Notes on "man" files:
---------------------
Files with the ".m" suffix are man document source. 

Files with the ".p" suffix are preformatted man documents that
are built on the distribution system for the purpose of installing
on systems that don't have troff (Cray, SGI, most SV environments).

# NCAR Command Language

<img src="http://www.ncl.ucar.edu/Images/NCLLogoWithoutText.jpg" width="150" align=right title="NCL Logo">

This is the source code for the NCAR Command Language (NCL).

NCL is a scripting language for the analysis and visualization of climate and weather data.

* Supports NetCDF, GRIB, HDF, HDF-EOS, and shapefile data formats
* Has hundreds of built-in computational routines
* Produces high-quality graphics

NCL is developed by the [Computational and Information Systems Lab](https://www2.cisl.ucar.edu) at the [National Center for Atmospheric Research](https://ncar.ucar.edu) (NCAR).

NCAR is sponsored by the [National Science Foundation](https://www.nsf.gov). Any opinions, findings and conclusions or recommendations expressed in this material do not necessarily reflect the views of the National Science Foundation.

# Important announcement on the future of NCL

NCAR has made the decision to adopt Python as the scripting language platform of choice for future development of analysis and visualization tools. Please read this [open letter to NCL users](https://www.ncl.ucar.edu/open_letter_to_ncl_users.shtml) to understand what kind of impact this will have on the future of NCL.

# Installation

The current version of NCL is [6.6.2](http://www.ncl.ucar.edu/current_release.shtml), which can be installed via [conda](http://www.ncl.ucar.edu/Download/conda.shtml).

```
conda create -n ncl_stable -c conda-forge ncl
source activate ncl_stable
```

# Documentation and support

Visit the [NCL website](http://www.ncl.ucar.edu) for documentation, examples, support, and installation.

* [NCL User Guide](http://www.ncl.ucar.edu/Document/Manuals/NCL_User_Guide/)
* [Extensive example suite](http://www.ncl.ucar.edu/Applications/)
* [Email list support](http://www.ncl.ucar.edu/Support/email_lists.shtml)
* [Detailed download and installation instructions](http://www.ncl.ucar.edu/Download/)

# NCL source code tree

The top level NCL source code tree contains the following directories and files:

| Directory                | Purpose |
| :--------------          | :------- |
| ```common/```            | Low-level library and fonts required by NCAR Graphics and NCL |
| ```config/```            | Configuration files for installation |
| ```external/```          | External libraries required by NCL |
| ```install/```           | Auxiliary files for installation |
| ```ncarg2d/```           | NCAR Graphics and GKS libraries and examples |
| ```ncarview/```          | NCGM-based applications and raster utilities |
| ```ngmath/```            | Interpolation libraries for 1D, 2D, and 3D data |
| ```ni/```                | NCL interpreter, HLU library, examples, color tables, GRIB2 code tables |
| **Files**                | **Purpose** |
| ```CODE_OF_CONDUCT.md``` | Code of Conduct for NCL user community |
| ```CONTRIBUTING.md```    | How to contribute to the NCL Project |
| ```Configure```          | Configuration script for installation |
| ```LICENSE```            | Apache 2.0 License |
| ```README.md```          | Information about NCL |
| ```version```            | version file |
| ```yMakefile```          | Top level makefile |

# Bug reports and feature requests

Use the GitHub [issue tracker](https://github.com/NCAR/ncl/issues) to submit a bug or request a feature.

# Citing NCL

Cite NCL using the following text:

<> The NCAR Command Language (Version 6.6.2) [Software]. (2019). Boulder, Colorado: UCAR/NCAR/CISL/TDD. http://dx.doi.org/10.5065/D6WD3XH5

Update the NCL version and year as appropriate.

----------------------------------------------------------------------
This is the top level directory for version 6.4.0 of the NCL and NCAR
Graphics source code. 

This source can be used to build NCL or just NCAR Graphics.  Note:
NCL depends on NCAR Graphics, so you will get both if you elect to
build NCL.

The documentation for NCL can be found at:

    http://www.ncl.ucar.edu/

While NCAR Graphics is part of the NCL source code tree, it has
its own documentation:

    http://www.ncarg.ucar.edu/
----------------------------------------------------------------------

Generally, we recommend that people install NCL and NCAR Graphics
using a precompiled binary. We provide precompiled binaries for
several flavors of LINUX, MacOS, and Windows/Cygwin. The NCL and NCAR
Graphics precompiled binaries are hosted on the Earth System Grid
website:

   http://www.earthsystemgrid.org

Any questions or problems with installing NCL and/or NCAR Graphics
from source code or precompiled binaries should be posted to
ncl-install@ucar.edu.  You need to subscribe first:

   http://mailman.ucar.edu/mailman/listinfo/ncl-install

Questions and bug reports on NCL should be posted to
ncl-talk@ucar.edu:

   http://mailman.ucar.edu/mailman/listinfo/ncl-talk

Questions and bug reports on NCARG Graphics should be posted to
ncarg-talk@ucar.edu:

   http://mailman.ucar.edu/mailman/listinfo/ncarg-talk

----------------------------------------------------------------------
You can find detailed instructions for building NCL and NCAR Graphics
from source code, or installing from precompiled binaries at:

  http://www.ncl.ucar.edu/Download/

Detailed instructions for building from source code are also found
in the "INSTALL.html" file in this directory.

----------------------------------------------------------------------

----------------------------------------------------------------------
This is the top level directory for version 6.3.0 of the NCL and NCAR
Graphics source code. 

This source can be used to build NCL or just NCAR Graphics.  Note:
NCL depends on NCAR Graphics, so you will get both if you elect to
build NCL.

The documentation for NCL can be found at:

    http://www.ncl.ucar.edu/

While NCAR Graphics is part of the NCL source code tree, it has
its own documentation:

    http://www.ncarg.ucar.edu/
----------------------------------------------------------------------

Generally, we recommend that people install NCL and NCAR Graphics
using a precompiled binary. We provide precompiled binaries for
several flavors of LINUX, MacOS, and Windows/Cygwin. The NCL and NCAR
Graphics precompiled binaries are hosted on the Earth System Grid
website:

   http://www.earthsystemgrid.org

Any questions or problems with installing NCL and/or NCAR Graphics
from source code or precompiled binaries should be posted to
ncl-install@ucar.edu.  You need to subscribe first:

   http://mailman.ucar.edu/mailman/listinfo/ncl-install

Questions and bug reports on NCL should be posted to
ncl-talk@ucar.edu:

   http://mailman.ucar.edu/mailman/listinfo/ncl-talk

Questions and bug reports on NCARG Graphics should be posted to
ncarg-talk@ucar.edu:

   http://mailman.ucar.edu/mailman/listinfo/ncarg-talk

----------------------------------------------------------------------
You can find detailed instructions for building NCL and NCAR Graphics
from source code, or installing from precompiled binaries at:

  http://www.ncl.ucar.edu/Download/

Detailed instructions for building from source code are also found
in the "INSTALL.html" file in this directory.

----------------------------------------------------------------------

#
#
#
ENVIRONMENT VARS

NCARG   is no longer useful - the distribution keeps track of its directory
    hierarchy dynamically - so directories can be moved around within
    the distribution without having to edit ymake files directly - You
    may need to edit the $TOP/config/Project file to update any MAKE
    symbols that are set to know where that part of the distribution
    lives.

YMAKE_DEV_FILE

This is a new environment variable you can set for ymake - It only effects
ymake if you are using ymake from the installed directory - It takes no
effect for a full build of the system.  You can set this variable to a
filename anywhere on the system. ymake will then include this file into
the Makefile it creates - directly before it includes the yMakefile.  This
file can override any of the MAKE symbols that are set in the Template,Arch,
Site, or Project files.  This is very useful if you only want to have part
of the distribution checked out at a time.  You can override the values
that have been assigned to NCARGLIB or any of the other libraries.  That
way if you are currently working on that library you can put the line

NCARGLIB = /path/to/work/dir/libncarg.a

in this file - and all the application directories that use ymake will use
this symbol to retrieve the ncarg library instead of using the installed
library..

Template sets up defaults for the following cpp variables - They can be
overridden in the "architecture" files or in the "Site" file.

cpp symbol  default         Make Symbol(s) set or description

NcargRoot   /usr/local
BinRoot     NcargRoot/bin       $(BINROOT) $(BINPATH)
LibRoot     NcargRoot/lib       $(LIBROOT) $(LIBPATH)
IncRoot     NcargRoot/include   $(INCROOT) $(INCPATH)
ManRoot     NcargRoot/man       $(MANROOT) $(MANPATH)
TmpRoot     /tmp            $(TMPROOT) $(TMPPATH)
XLibrary    -lX11           $(XLIB)
XextLibrary -lXext          $(EXTENSIONLIB)
XToolLibrary    -lXt            $(XTOOLLIB)
XMutilLibrary   -lXmu           $(XMULIB)
XawLibrary  -lXaw           $(XAWLIB)
XmotifLibrary   -lXm            $(XMOTIFLIB)

UseCatDirs  NO          formatted/unformatted manpages
MakeProgram make            $(MAKE)
CCompiler   cc          $(CC)
CLoader     CCompiler       $(CC_LD)
LibSearch   null            default libsearch path(set in Site file)
IncSearch   null            default incsearch path(set in Site file)
LibSearchUser   null            User lib search path(specific to arch)
IncSearchUser   null            User inc search path(specific to arch)
ExtraLibSearch  null            Extra lib search path(specific to arch)
ExtraIncSearch  null            Extra inc search path(specific to arch)
ExtraSysLibraries   null        Extra lib to link into EVERY executable
ExtraExportFlags    null        Extra export options for building NCL so
  that it can load shared objects.
CtoFLibraries   null            $(CTOFLIBS)
CtoFLibrariesUser   null            $(CTOFLIBSUSER)
StdDefines  null            default c-defines (specific to arch)
Cdynamic    null            $(CDYNAMIC)
Cstatic     null            $(CSTATIC)
COptimizeFlag   -O          These two options are selected based
CdebugFlag  -g          on the DEBUG cpp symbol to set $(COPT)
CcOptions   null            default cc-options (specific to arch)
MakeDepend  makedepend      $(MAKEDEPEND)
CppCommand  /lib/cpp        $(CPP)
FCppCommand $(CONFIGPATH)/fcpp $(CPP)   $(FCPP)
FCompiler   f77         $(F77)
FLoader     FCompiler       $(F77_LD)
FoptimizeFlag   -O          These two options are selected based
FDebugFlag  -g          on the DEBUG cpp symbol to set $(FOPT)
NgCallF  reg##_         how to call Fortran subroutines from C
FcOptions   null            default f77 options (specific to arch)
LdCommand   ld          $(LD)
LdRelCommand    LdCommand       $(LD_REL)
ArCommand   ar          $(AR) = ArCommand ArRegOpt
ArRegOpt    vru
ArQuickOpt  q           $(AR_QUICK) = ArCommand ArQuickOpt
ArSrcCommand    ar          $(AR_SRC_QUICK) = ArSrcCommand ArQuickOpt
RmCommand   rm -f           $(RM)
CatCommand  cat         $(CAT)
CopyCommand cp          $(CP)
MoveCommand mv -f           $(MV)
LinkCommand ln -s           $(LN)
TblCommand  tbl         $(TBL)
NroffCommand    nroff -man      $(NROFF)
ColCommand  col         $(COL)
DoesRanLib  YES         If YES $(RANLIB) = RanLib
                    If NO $(RANLIB) = touch -c
RanLib      ranlib          possibly $(RANLIB)
NoOptCommand    touch -c        $(NO_OPT)
LintCommand lint            $(LINT)
InstallCommand  $(TOP)/utils/install -c $(INSTALL)
                    If UseInstalled - default is install -c
InstallRm   $(RM)           $(INSTALL_RM)

Other Make Symbols set in Template:

symbol          value               description

SYSTEM_INCLUDE      dynamic         Name of arch file to include
TOP         dynamic         top dir relative to current dir
CURRENT_DIR     dynamic         current dir relative to top dir
BINPATH         $(BINROOT)      dir to install execs to
LIBPATH         $(LIBROOT)      dir to install libs in
INCPATH         $(INCROOT)/$(NCARGDIR)  dir to install inc to
HLUINCPATH      $(INCPATH)/$(HLUDIR)    dir to install hlu incs to
TMPPATH         $(TMPROOT)      tmp dir
MANPATH         $(MANROOT)      top of man tree
MANLPATH        $(MANPATH)/[catl|manl]  dir to install manl pages to
MAN1PATH        $(MANPATH)/[cat1|man1]  dir to install man1 pages to
MAN3PATH        $(MANPATH)/[cat3|man3]  dir to install man3 pages to
MAN5PATH        $(MANPATH)/[cat5|man5]  dir to install man5 pages to
MAN6PATH        $(MANPATH)/[cat6|man6]  dir to install man6 pages to
MAN8PATH        $(MANPATH)/[cat8|man8]  dir to install man8 pages to
LIBNCARGPATH        $(LIBPATH)/ncarg    dir to install ncarg stuff to
CONFIGPATH      $(LIBNCARGPATH)/config  dir to install config stuff to
DBPATH          $(LIBNCARGPATH)/database    database dir
FONTCAPPATH     $(LIBNCARGPATH)/fontcaps    fontcaps dir
GRAPHCAPPATH        $(LIBNCARGPATH)/graphcaps   graphcaps dir
DOCPATH         $(LIBNCARGPATH)/doc dir to install doc's to
EXAMPLESPATH        $(LIBNCARGPATH)/examples    examples dir
ROBJPATH        $(LIBNCARGPATH)/robj    dir to install robj's
TESTSPATH       $(LIBNCARGPATH)/tests   dir to install test's
TUTORIALPATH        $(LIBNCARGPATH)/tutorial    tutorial's dir
XAPPPATH        $(LIBNCARGPATH)/xapp    dir to install x app files to
LIBHLUPATH      $(LIBNCARGPATH)/hlu hlu dir
HLUEXPATH       $(LIBHLUPATH)/examples  hlu examples dir
HLUDOCPATH      $(LIBHLUPATH)/doc   hlu doc's
HLURESPATH      $(LIBHLUPATH)
MANL_SECTION        l
MAN1_SECTION        1
MAN3_SECTION        3
MAN5_SECTION        5
MAN6_SECTION        6
MAN8_SECTION        8
XMOTIFCLIENTLIBS    $(XMOTIFLIB) $(XTOOLLIB) $(XLIB)
XATHENACLIENTLIBS   $(XAWLIB) $(XTOOLLIB) $(EXTENSIONLIB) $(XLIB)
XMUATHENACLIENTLIBS $(XAWLIB) $(XMULIB) $(XTOOLLIB) $(EXTENSIONLIB) $(XLIB)
INSTALL_BIN     0755
INSTALL_MAN     0644
INSTALL_DOC     0644
INSTALL_APP     0644
INSTALL_LIB     0644
INSTALL_DB      0644
INSTALL_INC     0644
SHELL           /bin/sh
CALLCONV        $(CONFIGPATH)/callconv
MKDIRHIER       mkdir -p
COPT            dynamic     uses DEBUG to determine
FOPT            dynamic     uses DEBUG to determine

"Project" sets up defaults for the following cpp variables:

NcargVersion        3.2.x
BuildRasterHDF      YES
BuildRasterHPPCL    YES
BuildRasterNrif     YES
BuildRasterSun      YES
BuildRasterAVS      YES
BuildRasterSGI      YES
BuildRasterAbekas   YES
BuildRasterBinary   YES
BuildXlibDependentCode  YES
BuildSunViewctrans  NO
BuildPNG            NO
BuildGDAL           NO
HDFlib          -lmfhdf -ldf -ljpeg -lz
PNGlib          -lpng -lz
CAIROlib        -lcairo -lfontconfig -lpixman-1 -lfreetype -lpng -lz
GDALlib         -lgdal -lproj
HDFEOSlib       -lhdfeos -lGctp  
HDFEOS5lib      -lhe5_hdfeos
NetCDFlib       -lnetcdf
UdUnitslib      -ludunits
V5Dlib          -lv5d
XdrLibrary      null
ProjectDefines      -DNeedFuncProto     extra c defines for every c file
GksBufferSize       0

"Project" sets up the following Make Symbols:

symbol          value                   description
VERSION         NcargVersion
COMMONSRC       $(TOP)/common/src
NCARG2DSRC      $(TOP)/ncarg2d/src
NVIEWSRC        $(TOP)/ncarview/src
NVIEWBINSRC     $(NVIEWSRC)/bin
NVIEWLIBSRC     $(NVIEWSRC)/lib
NISRC           $(TOP)/ni/src
NIBINSRC        $(NISRC)/bin
NILIBSRC        $(NISRC)/lib
NCARGCLIBSRC        $(COMMONSRC)/libncarg_c
NCARGLIBSRC     $(NCARG2DSRC)/libncarg
NCARGGKSLIBSRC      $(NCARG2DSRC)/libncarg_gks
NCARGOPTLIBSRC      $(NCARG2DSRC)/liboptional
CGMLIBSRC       $(NVIEWLIBSRC)/libcgm
CTRANSLIBSRC        $(NVIEWLIBSRC)/libctrans
ICTRANSLIBSRC       $(NVIEWLIBSRC)/libictrans
NCARGRASLIBSRC      $(NVIEWLIBSRC)/libncarg_ras
HLULIBSRC       $(NILIBSRC)/hlu

THESE ARE VERY IMPORTANT!! They should be used instead of using the library
directly so dependencies can be determined. They will use the libraries
in the distribution if ymake is being used in the distribution - but if ymake
is being used from the installed space then they will use the installed versions
of these libraries.

NCARGCLIB       dynamic -lncarg_c
NCARGLIB        dynamic -lncarg
NCARGGKSLIB     dynamic -lncarg_gks
CGMLIB          dynamic -lcgm
NCARGRASLIB     dynamic -lncarg_ras
HLULIB          dynamic -lhlu
CTRANSLIB       dynamic libctrans.o
ICTRANSLIB      dynamic libictrans.o
ICTRANS_LIB     dynamic libictrans_.o

These variable should be used with the new FortranProgram and CProgram Rules:

DEPNCARGCLIB        dynamic
DEPNCARGLIB     dynamic
DEPNCARGGKSLIB      dynamic
DEPCGMLIB       dynamic
DEPNCARGRASLIB      dynamic
DEPHLULIB       dynamic
DEPCTRANSLIB        $(CTRANSLIB)
DEPICTRANSLIB       $(ICTRANSLIB)
DEPICTRANS_LIB      $(ICTRANS_LIB)

These are convenience symbols that include a number of the libs together.

NCARGLIBS       $(NCARGLIB) $(NCARGGKSLIB) $(NCARGCLIB)
HLULIBS         $(HLULIB)
DEPNCARGLIBS        $(DEPNCARGLIB) $(DEPNCARGGKSLIB) $(DEPNCARGCLIB)
DEPHLULIBS      $(DEPHLULIB)

GRAPHC          Determines if it should use installed version or not
FONTC           Determines if it should use installed version or not
NETCDFLIB       used in raster libs
NCDFLIBS        netcdf library
HDFLIB          hdf library
PNGLIB          png/zlib library
CAIROLIB        cairo library
XDRLIB          xdr library
HDFDEFINES      hdf defines - set in arch files
GKS_BUFFER_SIZE     GksBufferSize

*************************************************************************
*                                                                       *
* The following cpp symbols are to be used in the Site file.            *
*                                                                       *
*************************************************************************

symbol          description

BuildNCARGSourceLibrary if defined the Source Rules will create make targets
            to create source libraries. Otherwise the Source Rules
            will be null.

InstallManToLocal   if defined the man pages will all be installed to
            manl instead of being broken up into man[135].
            This may also be set in the arch files so you
            may need to check if it is defined before you
            try to define it in Site.

*************************************************************************
*                                                                       *
* The following cpp symbols are to be used in individual yMakefiles.    *
*                                                                       *
*************************************************************************

symbol          description

DEBUG           if defined COPT and FOPT will be set to CDebugFlag
            and FDebugFlag respectively. if not defined COPT and
            FOPT will be set to COptimizeFlag and FOptimizeFlag
            unless DisableOptimize is defined.

DisableOptimize     if defined COptimizeFlag and FOptimizeFlag will be
            defined as null.

COptimizeFlag       This is usually set in the "arch" file but can be
            overridden in a specific yMakefile to use a specific
            level of optimization.

FOptimizeFlag       "see COptimizeFlag above"

IHaveSubdirs        This directive tells ymake that you have set the
            make symbol SUBDIRS equal to the sub-dirs of this
            directory.  ymake will set up all the rules to
            manage those sub-directories.
*
* Additionally, the name of the architecture file will have a cpp symbol
* associated with it - so individual yMakefiles can tell which arch file
* was selected and can use preprocesser directives to conditionally do
* things.

arch file       cpp symbol defined

AIX370          AIX370Arch
AIX_RS6000      AIX_RS6000Arch
AlphaOSF1       AlphaOSF1Arch
Ardent          ArdentArch
Cray            CrayArch
DECRISC         DECRISCArch
HPUX_snake      HPUX_snakeArch
SGI_IRIX        SGI_IRIXArch
Sun3            Sun3Arch
Sun386i         Sun386iArch
Sun4            Sun4Arch
Sun4Solaris     Sun4SolarisArch
SystemV         SystemVArch

*************************************************************************
*                                                                       *
* The following make symbols are to be used in individual yMakefiles.   *
*                                                                       *
*************************************************************************

$(EXTRA_CDEFINES)   Used as part of CFLAGS to compile C programs - put in
            additional -D flags to compile.

$(EXTRA_FDEFINES)   Used to add -D flags to fortran compile - be careful
            since this isn't supported on all arch's.

$(EXTRA_DEFINES)    Used to add -D flags to both fortran and C compiles.
            Same warning applies to fortran compiles.

$(EXTRA_INCLUDES)   Used to add -I flags to C compiles.

$(EXTRA_CLDFLAGS)   Used to add additional LD flags for the linking of C
            programs.

$(EXTRA_FLDFLAGS)   Used to add additional LD flags for the linking of
            Fortran programs.

$(EXTRA_LDFLAGS)    Used to add additional LD flags for the linking of
            Fortran and C programs.

$(PROG_LIBS)        Used to specify the libraries that need to be linked
            into a program that are part of the distribution.
            Only make symbols should be used to set this make
            symbol. ex. PROG_LIBS = $(NCARGLIBS)

$(EXTRA_LIBS)       Used to specify the libraries that need to be linked
            into a program that are not part of the distribution,
            but that may not be installed on all systems - so they
            need to be linked into the executable statically for
            the arch's that support dynamic libs.

$(SYS_LIBS)     Used to specify the system libraries that need to be
            linked into a program.  These libraries include the
            libc.a and all other libraries that are sure to be
            installed on the target system.  These should be linked
            dynamically so our programs work no matter which version
            of the OS is being used on the target system.

$(SUBDIRS)      Used in conjunction with the IHaveSubdirs cpp symbol
            to manage sub-directories.

*************************************************************************
*                                                                       *
* The following make symbols are to be used in the developers override  *
* file.  $YMAKE_DEV_FILE                                                *
* (Also, the "Optimize" cpp symbols can be used in this file)           *
*************************************************************************

$(DEV_DEFINES)      Add some extra defines that will be included in
            compile lines.

$(DEV_INCLUDES)     Add extra -I paths - like $(EXTRA_INCLUDES) but
            meant to be used in multiple directories. (ie.
            Don't Use Relative Paths)

$(DEV_LIB_SEARCH)   Add extra -L paths - These will be the first -L
            paths in the link lines.

All of the NCAR Graphics Library symbols can be specified in this file.

*************************************************************************
* Rules creates the following cpp macros that should be used in ymake   *
* files.  PLEASE - Don't put Make targets in ymake files unless in is   *
* truly a unique directory!: It makes things very difficult to update   *
*************************************************************************

-------------------------------------------------------------------------
**************************** Install Rules ******************************
-------------------------------------------------------------------------

InstallTarget(names, mode, dest)
    names   - list of files in the current dir to be installed in dest dir.
    mode    - mode to use for installing names.
    dest    - directory to install names to.

    This rule will create the dest dir if it needs to.

InstallLibTarget(library)
    library - name of a library to install in the current dir.

    This rule uses InstallTarget to install the library and then runs
    ranlib on the library if it needs to.

InstallManPages(files,suffix,destdir,section)
    files   - list of man pages (without suffix) to install.
    suffix  - suffix of man page files.
    destdir - directory to install manpages to -should use $(MAN?PATH).
    section - section of manpages installing to -should use $(MAN?_SECTION).

    This rule is used to install man pages.  It uses the InstallTarget rule.

InstallManPageAliases(file,destdir,section,aliases)
    file    - name of manpage that is already installed.
    destdir - directory manpage is installed in.
    section - section of manpage.
    aliases - list of names that should also bring up the "file" manpage.

    This rule is used to create alias manpages - It creates links to the
    original file with the new names.  The "file" manpage must already
    be installed before the aliases can be created.

InstallXappFiles(appfiles)
    appfiles    - name of the x app defaults file to install.

    This rule looks for a file "appfiles.ad" in the current dir and installs
    it into $(XAPPPATH) - creating that dir if it needs to. It will issue
    a warning if there is already an app-defaults file installed there and
    will move that file to "file.bak" and print a warning message.

-------------------------------------------------------------------------
************************** Build exec rules *****************************
-------------------------------------------------------------------------

FortranProgram(program,objects,deplibs)
    program - name of program to create.
    objects - list of object files to link to create program.
    deplibs - dependent libraries - $(DEP*) make symbols.

    This rule creates a program by linking the listed objects with the
    libraries indicated by setting the $(PROG_LIBS), $(EXTRA_LIBS) and
    $(SYS_LIBS) make symbols. This rule also puts the install rule
    in - it installs program to $(BINPATH).

FortranTarget(program,objects)

    This rule is essentially identical to FortranProgram except that it
    doesn't keep track of the Dependent Libraries - so it doesn't re-link
    if the libraries are re-compiled.

FNotInstalledTarget(program,objects)

    This rule is essentially identical to FortranTarget except that it
    doesn't put the install rule in.  It is intended to be used to create
    programs that are only used within the distribution or are installed
    into a different dir than $(BINPATH).

CProgram(program,objects,deplibs)

    This rule is the same as FortranProgram except that it uses $(CC_LD)
    to link instead of $(F77_LD) as FortranProgram does.

CTarget(program,objects)

    This rule is the same as FortranTarget with the same exception as
    CProgram.

CNotInstalledTarget(program,objects)

    Same as FNotInstalledTarget with same exception as CProgram.

HLUExampleTarget(program,objects,sources)
    program - name of example program.
    objects - objects used to create program.
    sources - All sources needed to be installed into $(HLUEXPATH)

    This rule is used to create an HLU example program.  It installs all
    the sources as well as the program into $(HLUEXPATH).

-------------------------------------------------------------------------
************************** Build lib rules ******************************
-------------------------------------------------------------------------

RelocatableTarget(name,objects)
    name    - name of the object file to create.
    objects - objects to combine into name.

    This rule will link the objects into name using $(LD_REL) and then
    install that file into $(ROBJPATH).

LibraryTarget(library,objects)
    library - library to create.
    objects - objects to archive into library.

    This rule create library in the current directory and puts an install
    rule in to install library into $(LIBPATH) and runs ranlib if needed.

SourceLibraryTarget(name,library,sources)
    name    - name of library to create source library for.
    library - name of source library.
    sources - sources to archive into library.

    Same as Library target but for Source files - It only creates the
    rules if BuildNCARGSourceLibrary is defined.

PartialLibraryRoot(library,dirs)
    library - name of library to create in the current dir.
    dirs    - sub-dirs that contain all the object files for library.

    This rule is used to combine all the subdirs(utilities) into one
    library in the current directory. It takes care of the install
    target as well.

PartialLibraryTarget(library,objects)
    library - name of the library in the directory above.
    objects - objects to add into the library.

    This rule is used to manage an individual directory that creates
    a portion of the library(a single utility).

PartialSourceLibraryRoot(library,dirs)
    library - source library to create in the current dir.
    dirs    - sub-dirs that contain the source for library.

    This rule is analogous to the PartialLibraryRoot rule but for a source
    library.  It is a null rule unless BuildNCARGSourceLibrary is defined.

PartialSourceLibraryTarget(name,library,sources)
    name    - name of the utility that is being added to library
    library - name of the source library in the directory above.
    sources - sources to add to library.

    This rule is analogous to the PartialLibraryTarget but for a source
    library.  It is a null rule unless BuildNCARGSourceLibrary is defined.

-------------------------------------------------------------------------
************************* other useful rules ****************************
-------------------------------------------------------------------------

CleanFilesTarget(files)
    files   - files to clean

    This rules is used to clean the files on a clean target.

FormatManPages(manpages,mansuffix,catsuffix)
    manpages    - name of manpages to format.
    mansuffix   - suffix of manpages.
    catsuffix   - suffix to use for formatted manpages.

    This rule is used to format the manpages for a format target.  It uses
    manpages as the root filename and mansuffix for the suffix of each
    of those files.  catsuffix is the suffix to be used for the formatted
    manpages that are created.

DependTarget(srcs)
    srcs    - sources to find the dependencies for.

    This rule looks threw the C sources in srcs and follows all the
    #include line to find out which files each of those sources are
    dependent upon and appends that information to the Makefile.

BuildIncludes(srclist,dstsubdir,dstupdir)
    srclist     - include files that eventually need to be installed.
    dstsubdir   - subdir in the include directory.
    dstupdir    - include dir from dstsubdir.

    This rule is used to create an include sym-link tree inside the
    distribution.

These filter have not be tested thoroughly due to lack of vanilla metafiles and
interpreters. However, while testing the filters on Sun phigs' metafiles an
interesting anomaly was noted. The Sun phigs' CGM generator produces a 
metafile made up exclusively of "long data format" CGM elements. Instructions
that were meant to be contained in "short" elements were coded as longs. This
presents no problem for a "true" CGM interpreter such as Ctrans. However, I
suspect that the Sun phigs' interpreter expects all instructions in the "long"
format to ease translation. The filter for NCAR-format-to-vanilla will
translate "short" instructions to "short" instructions. Thus it is unlikely
that an NCAR CGM filtered to vanilla CGM could be interpreted by the Sun phigs'
interpreter. Other vendors of CGM translators and interpreters may take similar
short cuts.

ictrans has a functional interface defined in the file ictrans.c. For a
disk resident CGM ictrans may be invoked via the ICTrans() subroutine. A 
description of the parameters for this routine may be found in the file
ictrans.c. The third argument should be set to NULL for a disk resident
CGM. The process of invoking ictrans for a memory resident CGM is a bit more
complicated. The third argument to ICTrans is the *name* of a metafile 
resident in memory. Such a file can be created with the utilities in libcgm.
The file ictrans_mem.c contains an example of how memory files can be
created, written to, and closed. 

This README file explains what the various files are in this
directory, and which ones you might want to edit or copy in order to
build NCL and/or NCAR Graphics on your system.

If you see a file that needs correction, or if you want to add
a configuration file of your own, post a message to ncarg-talk
or ncl-talk:

  http://mailman.ucar.edu/mailman/listinfo/ncl-talk
  http://mailman.ucar.edu/mailman/listinfo/ncarg-talk

----------------------------------------------------------------------

AIX_RS6000 - This is the configuration file used for an
   AIX system. Edit this file if you need to change compilation
   options before building on an AIX system. It compiles in 64-bit
   mode by default.  Look at the AIX_RS6000.32 file for information
   on how to build in 32-bit format.

AIX_RS6000.64 - Similar to the AIX_RS6000 file; slightly different
   compile options.

AlphaOSF1 - This is the configuration file used for a Compaq/OSF
   system. We haven't build NCL or NCAR Graphics on one of these
   in awhile, so we can't guarantee that the file is up-to-date.

CYGWIN - This is the configuration file used to build on a
   Windows/Cygwin system.  Edit this file if you need to change
   compilation options before building on an Window/Cygwin system.

Cray - This is the configuration file used to build on a Cray. This
   file is old and was only ever tested for NCAR Graphics.

DECRISC - This is the configuration file used to build on a
   DECRISC system. This file is old and was only ever tested for NCAR
   Graphics.

Darwin - This is the configuration file used to build on a
   Mac PPC (not Intel) system.  Edit this file if you need to change
   compilation options before building on an MacOSX/non-Intel system.

Darwin.absoft - This is a sample configuration file for building
   on a Mac PPC system using the Absoft compilers. Use this
   file only as a reference; make the changes to the Darwin file.
   This file hasn't been used in awhile and may be out-of-date.

Darwin_Intel -  This is the configuration file used to build on a
   Mac Intel system, using the gcc/g95 compilers.  Edit this file if
   you need to change compilation options before building on an
   MacOSX/Intel system.

FreeBSD - This is the configuration file used to build on a
   FreeBSD system.

HPUX_snake - This is the configuration file used to build on an
   HP system. Edit this file if you need to change compilation
   options before building on an HP system.

LINUX - This is the configuration file used to build on a
   LINUX system (i386, i686, x86_64). Use the other Linux.xxx
   files as guidelines for making changes to this file, depending
   on what kind of compilers and options you want to use.
   Edit this file if you need to change compilation options before
   building on a LINUX system.

LINUX.32.PGI -  This is a sample configuration file used to build on a
   LINUX 32-bit system using the PGI compilers.  Use this file as a
   reference only;  make the changes to the LINUX file.

LINUX.64.GNU -  This is a sample configuration file used to build on a
   LINUX 64-bit system using the GNU compilers.  Use this file as a
   reference only; make the changes to the LINUX file.

LINUX.64.INTEL - This is a sample configuration file used to build on
   a LINUX 64-bit system using the Intel compilers.  Use this file as
   a reference only; make the changes to the LINUX file.

LINUX.64.PGI - This is a sample configuration file used to build on a
   LINUX 64-bit system using the PGI compilers.  Use this file as a
   reference only; make the changes to the LINUX file.

LINUX.GNU - This is a sample configuration file used to build on a
   LINUX system using the GNU compilers; this file should be very
   similar to the LINUX file.  Use this file as a reference only; make
   the changes to the LINUX file.

LINUX.IA64.INTEL - This is a sample configuration file used to build
  on an Itanium LINUX system using the Intel compilers; this file
  should be very similar to the LINUX file.  Use this file as a
  reference only; make the changes to the LINUX file.

LINUX.INTEL - This is a sample configuration file used to build on
  a LINUX system using the Intel compilers.  Use this file as
  reference only; make the changes to the LINUX file.

LINUX.PGI - This is a sample configuration file used to build on a
   LINUX system using the PGI compilers.  Use this file as a
   reference only; make the changes to the LINUX file.

LINUX.ppc32.GNU - This is a sample configuration file used to build on
  a 32-bit ppc LINUX system using the GNU compilers.  Use this file as
  a reference only; make the changes to the LINUX file.

LINUX.ppc32.GNU - This is a sample configuration file used to build on
  a 32-bit ppc LINUX system using the GNU compilers.  Use this file as
  a reference only; make the changes to the LINUX file.

LINUX.ppc64.xl - This is a sample configuration file used to build on
  a 64-bit ppc LINUX system using the XL compilers.  Use this file as
  a reference only; make the changes to the LINUX file.

LinuxLib - No need to modify this file.

Makefile.ini - No need to modify this file.

Project - You shouldn't need to modify this file.

README_YMAKE - A README file on some of the variables used
  in the ymake system. Not very useful except for people who
  really know this stuff.

Rules - No need to modify this file

SGILib - No need to modify this file

SGI_IRIX - This is the configuration file used for an SGI
   IRIX system. Edit this file if you need to change compilation
   options before building on an SGI system. It compiles in 64-bit
   mode by default.  Look at the SGI_IRIX.n32 file for information
   on how to build in n32-bit format.

SGI_IRIX.n32 - See SGI_IRIX above. Use this file only as a reference;
  edit the SGI_IRIX file instead.

Site - No need to modify this file

Site.local - This file gets created when you run ./Configure.

SolarisPC - This is the configuration file used for a little endian
  system running Solaris X86.  Edit this file if you need to change
   compilation options before building on a Solaris X86 system.
   For building on a Sun system, see the Sun4Solaris file.

Sun3 - This is an old configuration file that probably should never
  be needed. See Sun4Solaris instead.

Sun4 - This is also an old configuration file that probably should never
  be needed. See Sun4Solaris instead.

Sun4Solaris - This is the configuration file used for a Sun system
  running Solaris. Edit this file if you need to change
   compilation options before building on a Sun system.
   See SolarisPC for building on a Solaris X86 system.

SystemV - This is a generic configuration file to use as a reference
  only.

Template - No need to modify this file.

YDLINUX - This is the configuration file used for a system running
  Yellow Dog Linux. It hasn't been used in awhile, so it may be
  out-of-date.

callconv - This is an old file used at one time. I don't think it
  is used anymore.

fcpp - This is an old file used at one time. I don't think it
  is used anymore.

ldrel - I believe this file was only needed for Cray builds.

yMakefile - no need to modify this file.

ymake - The file that is executed to see if it recognizes
  your system. You may need to edit this file if your system
  isn't recognized by the NCL/NCARG build system.

ymake-filter.c - No need to modify this file.

ymake-install - No need to modify this file.

ymkmf - No need to modify this file. It is used to help
  generate the Makefiles in every directory.

----------------------------------------------------------------------

For Intel mac, to get rid of wchar_t error message, you need
-D__UNIXOS2__:

gcc -D__UNIXOS2__ -ansi  -O  -I../../../.././include -I/usr/X11R6/include -I/sw/include   -DBuildRasterHDF -DDARWIN -DBuildRasterHPPCL -DBuildRasterNrif -DBuildRasterSun    -DBuildRasterXWD  -DBuildRasterAVS -DBuildRasterSGI              -DBuildRasterAbekas  -DBuildRasterBinary -DBuildRasterYUV               -DNGTMPDIR='"tmp"' -Di386 -DApple -DSYSV -D_POSIX_SOURCE -D_XOPEN_SOURCE -DByteSwapped -DNeedFuncProto    -c -o xwd.o xwd.c


Sun
---
The 24-bit RGB RLE portion of the driver needs work.

Parallax
--------
Compiling parallax.c with the Sun "acc" compiler results in problems
with ioctl()'s and /usr/include/sys/ioccom.h, which is not
ANSI-compatible.

HDF
---
The new driver is built upon HDF3.2r3.  24-bit imagery needs to be
checked out thoroughly.

SGI
---
The SGI rasterfile driver supports compressed and uncompressed input,
and uncompressed output. The driver needs to be modified so that it
can deal with INDEXED color on output.

A60
---
There is currently a bug in the output of Abekas RGB images but support
for input and output of Abekas RGB images is provided. YUV images are
not yet supported. The driver needs to be modified so that it can
deal with INDEXED color on output.

build_external is the only file used here, to build the external
packages of NCL. It's a mess as it's just a giant c-shell
script that has blocks of builds for each external
package.

----------------------------------------------------------------------
cairo notes: There's a PNG bug with cairo 1.12.16 and earlier, so use
cairo-1.10.2 instead.

It's important to use the correct versions of pixman, fontconfig, and
freetype with cairo. I think freetype is especially important, and
maybe pixman too.

I usually check which version of cairo is the latest, see what the
date is on it, and then make sure I don't update later dates of
freetype and fontconfig. The cairo download site usually has pixman
included with it, so I tend to use this.

Rick suggests using the system fontconfig rather than a
specially-built one.
----------------------------------------------------------------------
NetCDF-4 notes: Unidata provides versions of HDF5 and zlib with its
NetCDF-4 source, so I recommend using this.
----------------------------------------------------------------------
HDFEOS notes: Both hdfeos and hdfeos5 source codes have issues
with the Gctp "cproj.c" file which defines "sign". This conflicts with
some other "sign" defintion. You may have to edit cproj.c and change
"sign" to "cproj_sign".
----------------------------------------------------------------------
g2clib notes: we found a bug with g2clib-1.4.0-patch on 12/17/13 
(see JIRA NCL-1868). Use 1.2.3-patch instead.
----------------------------------------------------------------------
See the "wget_commands" file in this directory for the wget commands
used to retrieve all this software:

Here are the versions I use for everything:

    cairo-1.10.2
    curl-7.33.0
    esmf-6.2.0
    expat-2.1.0
    freetype-2.5.0.1
    g2clib-1.2.3-patch
    gdal-1.10.1
    hdf-4.2.9
    hdf5-1.8.11
    hdfeos-2.18
    hdfeos5-1.14
    jasper-1.900.1
    jpeg-6b
    libpng-1.2.50
    netcdf-4.3.0
    pixman-0.30.0
    szip-2.1
    zlib-1.2.8
    proj-4.8.0
    
    netcdf-cxx-4.2 (for ESMF only)
    netcdf-fortran-4.2 (for ESMF only)

----------------------------------------------------------------------

See the README file in ../nfp on how to add a new built-in
function to NCL.

----------------------------------------------------------------------

If you have problems building with xlf because of an undefined "flush",
try "-qextname=flush" as an xlf option.

http://www.arsc.edu/support/news/HPCnews/HPCnews321.shtml

IBM has chosen to slightly altered the symbols of several Fortran
subroutines to avoid linking ambiguities between user and Fortran
libraries. If we look at the Fortran 90 library (xlf90_r.a) we see
there is a "flush" symbol however it is ".flush_" rather than ".flush"

  iceberg1 2% nm -e /usr/lib/libxlf90_r.a  | grep flush
  .flush_              T      220408
  flush_               D       46360          12

The xlf compiler flag "-qextname" instructs the compiler to add an
underscore to the end of externally defined symbols or the specified
symbols. Adding "-qextname=flush" to the compile flags we see that
linking now occurs successfully.

  iceberg1 72% make
         xlf90_r -qsuffix=f=f90 -qextname=flush myprogram.f90  -o
  myprogram
  ** myprogram   === End of Compilation 1 ===
  1501-510  Compilation successful for file myprogram.f90.

There are several other ways to do the same thing. As noted in HPC
Newsletter 288, the trailing underscore could be added to the flush
subroutine call. E.g.,

  call flush(10)


becomes

  call flush_(10)

This option isn't very graceful since it involves an unnecessary
change to the source code.

----------------------------------------------------------------------

To get the latest versions of the I1MACH and R1MACH routines:
------------------------------------------------------------
Send email to netlib@ornl.gov with the following request in the
subject header or text body:

  send i1mach from slatec/src

You'll promptly (depending on Internet traffic) receive e-mail from
netlib, containing the I1MACH source code.  Of course, you can do this
for D1MACH as well.

You can also access Netlib via the World Wide Web. 
The URL is:

    http://www.netlib.org/index.html

If you have trouble accessing netlib files, please 
send email to netlib_maintainers@netlib.org.

----------------------------------------------------------------------

6/10/2008: On bluefire, had to compile sdbm.c with -O1 and not -O3
           (-qstrict is okay).

----------------------------------------------------------------------

April 12, 2007: On an Intel Mac (using g95) and an i686 Linux system
(using gfortran 4.x), the dlamch.f file has to be compiled with -g, or
else you end up with svd_lapack going into an infinite loop.

To build NCL using the Intel "ifort" Fortran compiler, and GNU "gcc"
compilers on an Intel Mac:
  
  1. I used "-m32" with ifort, otherwise it defaults to trying to
     compile for an x86_64 system. (I have an older Mac.)

  2. The "CToFLibraries" needs to be:

         -lifcore -lsvml -limf -lirc

  3. In order to build NCL, I had to include "-bind_at_load" on the
     "CC_LD" line, otherwise I got a bunch of errors like:

      symbol _fdim used from dynamic library
     /usr/lib/system/libmathCommon.A.dylib(single module) not from earlier
     dynamic library libimf.dylib(fdim_stub.o)

  4. In order to run fontc, graphc, ncl, etc, I had to set:

        setenv DYLD_LIBRARY_PATH /opt/intel/fc/10.1.007/lib

     This should be done for you if you do something like:

        source /opt/intel/fc/10.1.007/bin/ifortvars.csh 
  
----------------------------------------------------------------------

To build an OPeNDAP version on reader (a PPC Mac):

I started from scratch, and downloaded the latest versions of libdap
(3.7.6) and libnc-dap (3.7.0). I went ahead and built both shared and
static libraries, which seems to be the default.

I just used the system libraries for curl, xml2, and ssl.

I couldn't build NCL using the shared versions of the nc-dap,
dapclient, and dap libraries. I get the same problem that we've had in
the past, and that is "cdf_routine_name" is undefined.

When I use static libraries, it works. However, the order that the files
are listed in the yMakefile seem to be wrong. I had to reorder them to
be  "-lnc-dap -ldapclient -ldap".

I get an ncl executable that looks like this with "otool -L":

reader[193] otool -l ncl
         /usr/lib/libcurl.3.dylib (compatibility version 4.0.0, current version\
 4.0.0)
         /sw/lib/libxml2.2.dylib (compatibility version 9.0.0, current version \
9.7.0)
         /usr/lib/libSystem.B.dylib (compatibility version 1.0.0, current versi\
on 88.1.8)
         /usr/lib/libssl.0.9.7.dylib (compatibility version 0.9.7, current vers\
ion 0.9.7)
         /usr/X11R6/lib/libXpm.4.dylib (compatibility version 4.11.0, current v\
ersion 4.11.0)
         /usr/X11R6/lib/libX11.6.dylib (compatibility version 6.2.0, current ve\
rsion 6.2.0)
         /usr/X11R6/lib/libXext.6.dylib (compatibility version 6.4.0, current v\
ersion 6.4.0)
         /usr/lib/libstdc++.6.dylib (compatibility version 7.0.0, current 
on 7.4.0)
         /usr/lib/libgcc_s.1.dylib (compatibility version 1.0.0, current versio\
n 1.0.0)


----------------------------------------------------------------------
Marker and dashline problem - See NCL-1473, NCL-1431, NCL-1164


1. There are weird problems with the 2-line script:

  wks = create "test" ncgmWorkstationClass defaultapp end create
  nmark = NhlNewMarker(wks, "+", 4, 0.0, 0.0, 1.0, 0.1, 0.)

on some systems (seems to be with Linux systems running gcc 4.1.2, so
far). It was producing the error message:

fatal:Execute: Error occurred at or near line 2 in file test.ncl

On wedge.rap.ucar.edu, compiling HLUFunctions.c *and* Memory.c with
optimization turned off makes it work.

---
Later, in version 6.0.0 of NCL, and on k7.rap.ucar.edu, I had to
compile just Execute.c and Machine.c with -g instead of -O. It's never
consistent!  Grrr. With V6.1.0-beta, I saw the problem again. It
appears that just compiling Machine.c with -g made it work.

This didn't work for harmon.cgd, however, even with all three
of these files compiled with -g. I even tried compiling all
of the HLU and NCL source code with -g and it didn't work.
I finally decided to revisit HLUFunctions.c to see if I
could rewrite it in a way that might change the behavior.
I did see a weird thing going on with the *index variable,
so I got rid of this and just indexed "indexes" directly.
---

2. For same system as above, I also had to turn off optimization for
"lib/hlu/Format.c" because it would cause the "tm04n.ncl" example to
not generate the correct graphic.

----------------------------------------------------------------------

----------------------------------------------------------------------
If having problems with the HLUs on the Cray, the first thing I try is
compiling Convert.c with optimization turned off.

If having trouble compiling Create.c on Cygwin because of an sa_handler
error message, try compiling without -ansi.

If having trouble compiling Workstation.c on an x86_64 Linux system using
the Intel (icc) compiler and getting an "internal" error message, try
using gcc to compile just this one file.

----------------------------------------------------------------------

If triangle.c and triangle.h are missing and you need these files,
get them from this website:

http://www.cs.cmu.edu/~quake/triangle.html

There should be a link to a ".zip file" which you can unzip with:

unzip triangle.zip

DO NOT UNZIP THIS FILE IN THIS DIRECTORY, because it may
overwrite your "Makefile". Instead, download it somewhere
temporary, and then copy over "triangle.c" and "triangle.h"
to this directory.

Adding a Fortran routine as an NCL built-in function
----------------------------------------------------

Assume the Fortran routine is in a file called "calc.f".  It must be a
Fortran 77 file.
 
The below instructions assume you already have NCARG/NCL source code
checked out and built.

   o  If there is an underscore in the Fortran routine name, then
      g77 may add an extra underscore at the end of the name.  This
      can cause load problems unless care is taken to account for this.

      Avoiding underscores in the Fortran routine names is advisable.

      Rename the routine to not contain underscores.

   o  The routine should be a double precision version.

      Instead of coding a double precision version 
      directly, it is less error prone to use 
      the NAG single-to-double-precision converter.  This
      is on windom: /usr/local/NAGWare-4.1/bin/nag_apt .

      The default execution of nag_apt is to take a single
      precision .f file and convert it to double precision.

      The original file is backed up to a .orig file and 
      the input file is overwritten with the double precision
      version.

         nag_apt -double calc.f

      If this command is successful, you will see something like
      this:

       [nag_apt Normal Termination]
       nag_apt: 'calc.f' backed up to 'calc.f.orig'

      If it isn't successful, then "calc.f" will be unchanged. You
      can look through the errors and usually it is pretty easy
      to tell what needs to be fixed. For example, "nag_apt" doesn't
      like "!" as a comment character, and will tell you this.

   o  Add the routine to the nfpfort directory:

        cp calc.f $NCARG/ni/src/lib/nfpfort/.
        cd $NCARG/ni/src/lib/nfpfort
        cvs add calc.f

      Add the file to the yMakefile as well. Check these both into
      CVS at this point, if you want:

        cvs ci yMakefile calc.f

   o  To make sure it compiles, type:

          cvs update 
          make me
          make

      This should update the "libnfpfort.a" library with the new
      Fortran routine.

      Eventually test compilations on all test machines.  This is not
      necessary if you are super confident about the source. You can
      see a list of test machines at

      https://www.ncl.ucar.edu/internal/ncl-dev/systems.shtml

      You can also test later, *after* you've added the NCL wrapper.

   o  Change to directory $NCARG/ni/src/lib/nfp

      Create the wrapper file that calls the Fortran. Generally,
      call this file "calcW.c". Or, if it's similar to an existing
      wrapper, you can add it to the end of the existing *W.c
      file.
 
        --> Be sure to prototype the Fortran function/subroutine.
            Make sure the you are prototyping the
            correct routine, in particular that you are
            referencing the double precision version in the
            cases where there double precision and single
            precision versions available.

        --> The "W" file may contain several functions or procedures
            and those names will have an "_W" after them.

   o  Add the prototype to wrapper.c in directory $NCARG/ni/src/lib/nfp.

   o  Add the registration to wrapper.c 

      *Make sure the routine is properly registered as either a
      function or procedure.*

      The registered NCL name will be the same as the "_W" name
      without the "_W".

   o  Add the "calcW.c" file name to the yMakefile (see how the other 
      files are done).

   o  In the nfp directory do:

        cvs update
        make me
        make

   o  If instead of your having added a new routine to the nfpfort
      directory, but rather have added a new Fortran routine to
      libncarg, be sure to write the C wrappers and prototype them
      in $NCARG/ncarg2d/src/libncarg/ncargC.h .

   o  Go to $NCARG/ni/src/ncl and do

        cvs update
        make me
        make

      to make ncl for testing purposes.

   o  Add analysis test scripts to:

        ncargtest/nclscripts

   o  Add plotting test scripts to:

        ncargtest/nclscripts/plotting

   o  After testing is complete,
         +  Check in the original Fortran source in
            directory $NCARG/ni/src/lib/nfpfort
         +  Add and check in the test scripts in
            directory ncargtest/nclscripts.
         +  Add the "W" wrapper in directory
            $NCARG/ni/src/lib/nfp and check in
            wrapper.c, yMakefile, and the wrapper.

   o  Add NCL routine documentation to:

        webdoc/ncl/Document/Functions/Built-in

      Determine the version number of the release where the new
      routine will appear.  Add a "newversion" tag to the source like:

         <newversion>
         4.3.1
         </newversion>

      This version tag should appear after the </summary> tag and
      before the <synopsis ...> tag.

      For details on the formatting of the .xml files, see:
 
        webdoc/ncl/Document/Functions/Built-in/README

      Add the new file names to the yMakefile
 
      To review the new documentation use

         webdoc/ncl/internal/about_website/updatetnclweb

      to create a .shtml file from the .xml and copy that 
      to the NCL test web site  http://test.www.ncl.ucar.edu/
      (note the "t" that distinguishes updatetnclweb from updatenclweb).

      You can then review the documentation at

  http://test.www.ncl.ucar.edu/Document/Functions/Built-in/new_routine.shtml

  
      where "new_routine" is the name of the NCL routine just added.

      When you are satisfied with the documentation, use
      updatenclweb to copy it to the live web site.

      CVS add and check in the new .xml files as well as the
      yMakefile.  Do not check in .shtml files.

   o  Update various function lists on the web, for example, those
      that you see in:

      http://www.ncl.ucar.edu/Document/Functions/index.shtml
      http://www.ncl.ucar.edu/Document/Functions/list_type.shtml
      http://www.ncl.ucar.edu/Document/Functions/list_alpha.shtml
      http://www.ncl.ucar.edu/Document/Functions/Built-in/index.shtml

      To do this, cd to webdoc/ncl/Document/Functions and run:

         ./update_lists

      This may take awhile and generate a lot of output. It will
      also try to run "cvs update" in several directories. For
      a list of available options, type "./update_lists -h".

      To only copy files to the test web machine, type:

         ./update_lists -t

      You don't need to CVS check-in anything here.

   o  Edit webdoc/ncl/future_release.xml to add the new stuff.
      CVS check-in this file.

   o  If you want to add an Applications example that shows usage of
      the new routine, see

        webdoc/ncl/Applications/README

This directory contains machine specific command/configurations. The env.*
files specify the incantations for various commands. The paths.*
files contain the default intallation directories for NCAR G modules.

======================================================================
This directory contains a few different styles of color maps that
end in ".rgb", ".gp", or ".ncmap".
======================================================================
Adding a new colormap to NCL.

 1. Decide what you are going to call this color table and create a
    file called "xxxx.rgb", where "xxxx" is the color table name. This
    will be the name used in the call to "gsn_define_colormap" or
    as the value for the "wkColorMap" resource. (The ".rgb" extension
    needs to be part of the name, but you drop this when referencing 
    the colormap in an NCL script).

    Add "xxxx.rgb" to the yMakefile in this directory.

    Type:

        svn add xxxx.rgb
        svn ci

    to check in the new color table.

 2. How to create a color table from scratch:

    At the the beginning of this file, *optionally* add the two lines:

ncolors=n
# r g b

    where n is the number of RGB triplets you have in the file (do
    not count the background/foreground colors).

    Immediately following these two lines, put the RGB triplets in this
    file with one RGB triplet per line.  Do not include the
    background/foreground colors!

    For example:

160 32 240
0   0  180

   Here's a sample color table with 8 colors (the "# r g b" is ignored):

ncolors=8
# r   g   b
160 32  240
0   0   180
60  100 230
120 155 242
176 224 230
46  139 87
100 225 0
210 255 47

   Once you add the above color table to NCL, it will actually have 10
   colors, as the foreground and background colors will be added.

 3. To quickly test this new color table, you can copy it
    to $NCARG_ROOT/lib/ncarg/colormaps, and then run the
    short script, replacing "xxxx" with the name you used above:

load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/gsn_code.ncl"
    
begin
  wks = gsn_open_wks("x11","test")
  gsn_define_colormap(wks,"xxxx")
  gsn_draw_colormap(wks)
end

     If you don't have permission to copy the file to
     $NCARG_ROOT/lib/ncarg/colormaps, then put it wherever
     you like, and setenv NCARG_COLORMAP_PATH to this directory.
     Then, run the above script.

 4. The colormaps directory at:

     http://www.ncl.ucar.edu/Document/Graphics/color_table_gallery.shtml

    will need to be updated. See the README file in
    webdoc/ncl/Document/Graphics for more information.

These are the NCL, Python, and KSH scripts that Karin Meier-Fleischer
of DKRZ developed for the NCL User Guide (NUG).

They should be copied to the web via:

  scp *.ncl *.ksh *.py webpub.ucar.edu:/web/ncl/Document/Manuals/NCL_User_Guide/Scripts/.

  http://www.ncl.ucar.edu/Document/Manuals/NCL_User_Guide/Scripts/

The smaller data files are part of the NCL distribution in 

   $NCARG/ni/src/examples/data/nug

The larger data files were copied straight to the web:

  http://www.ncl.ucar.edu/Document/Manuals/NCL_User_Guide/Data/

  webpub.ucar.edu:/web/ncl/Document/Manuals/NCL_User_Guide/Data/

----------------------------------------------------------------------
If on a Mac system you get the following error when compiling
w_display.c:

  In file included from commands.h:17,
                 from w_display.c:51:
  /usr/include/signal.h:71: error: 'NSIG' undeclared here (not in a
  function)
  make[5]: *** [w_display.o] Error 1

then try adding "-D_DARWIN_C_SOURCE" to the end of the STD_DEFINES
line in the Makefile.

This appears to be a Mac bug.

----------------------------------------------------------------------

This directory, impltest, contains implementation dependent code in 
file tlocal*.f.  The yMakefile contains the system dependencies. 
Currently, there is a tlocalcray.f, for the Cray, and a tlocal32.f
for other 32 bit machines.

If you have problems compiling tlocal32.f because of the following error:

tlocal32.f:242.31:

     +  MASK1(33) / z'ffffffff'/                                        
                              1
Error: Arithmetic overflow converting INTEGER(8) to INTEGER(4) at (1)
tlocal32.f:174.31:

     +  MASK0(32) / z'80000000'/                                        
                              1
Error: Arithmetic overflow converting INTEGER(8) to INTEGER(4) at (1)
make: *** [tlocal32.o] Error 1

then add "-fno-range-check" to your gfortran compile line.
You can do this using "FcOptions" in the configuration file
in $NCARG/config.

The filter created in this directory may be tested (at NCAR) as follows:

  pre2ncgm.prog < conrec.pre
  ctrans -d ... gmeta

or (after the script "pre2ncgm" has been created, which happens in a
different directory)

  pre2ncgm < conrec.pre > conrec.cgm
  ctrans -d ... conrec.cgm

VisAreaMap is a java-based tool to interactively display and query an
"AreaMap" data structure produced from the ncarg package "Areas". It
is intended only as a programmer's tool for debugging problems with
Areas that lead to the so-called ARSCAM/ARPRAM class of
errors. Typically VisAreaMap would be used in conjunction with a
debugger (i.e., gdb) to visualize events leading up to the error.  See
Jira ticket #32 for a document describing strategies for debugging
Areas problems.

Use of this program presumes the Java SDK is installed and in the path
on the target machine. To build VisAreaMap.jar simply type:

   make

To run the program:

   java -jar VisAreaMap.jar <...input area map file...>


The area-map input file is obtained by annotating modules in the Areas
package with a strategically placed bit of code to dump the area-map:

      open(unit=11, file="AreaMapPrePhase6") 
      do 99999 i=1,iam(1) 
          write(11,'(i8,1x,i8)') i, iam(i) 
99999 continue 
      close(11)

Where precisely this should be placed depends upon where the error
originates. To date, errors have arisen in either phases 5 or 6 of
both the source modules arscam.f and arpram.f. Once the location of
the error is determined, it is useful to insert the code to dump the
area-map at the beginning of the associated phase.

This filters created in this directory may be tested (at NCAR) as follows:

  ctrans -d ps.color ps.input.file > ps.output.file
  psblack < ps.output.file > ps.output.file.black
  pswhite < ps.output.file > ps.output.file.white
  ps.imagen ps.output.file
  ps.imagen ps.output.file.black
  ps.imagen ps.output.file.white
  rm ps.output.file*

It is questionable how valuable this test is, since these filters are only
intended for use with 3.00 and older metafiles.  It does verify that they
compile and execute.

The expected appearance of the plots is as follows:

  ps.output.file       - a zig-zag line, some plus signs arranged in a
			 zig-zag pattern, a nonagon, a rectangular
			 checkerboard, and the words "Example string,
			 centered in the center".
  ps.output.file.black - a rectangular checkerboard in white on black
  ps.output.file.white - a rectangular checkerboard in black on white

This directory contains fonts to support cairo drivers.

Vera.ttf - a Helvetica-like font
VeraBd.ttf - Vera bold
VeraIt.ttf - Vera Italic
VeraBI.ttf - Vera bold Italic
VeraMono.ttf - a Courier-like mono-spaced font
VeraMoBd.ttf - Vera mono bold
VeraMoIt.ttf - Vera mono Italic
VeraMoBI.ttf - Vera mono bold Italic
VeraSe.ttf - a times-like (Serif) font
VeraSeBd.ttf - Vera Serif bold
Aristarcoj2.ttf - Greek characters
cmex10.ttf - math symbols
cmsy10.ttf - some math, script


The site:

  http://www.freepremiumfonts.com/

has an amazing number of free fonts.

The Vera fonts are available with an open source license. See:

  http://www.bitstream.com/font_rendering/products/dev_fonts/vera.html

The I/O package in the files "wks.c" and "wks.h" uses buffered I/O.  There
is an environment variable that allows the user to override the system
default buffer size.  For example:

    setenv NCARG_GKS_BUFSIZE 64

This produces a 64K buffer - the number specifies 1024-byte blocks.

This directory contains functions fx(x,y) and fy(x,y) which are
used for coordinate transformations for most of the utility programs.
They used to be Fortran arithmetic statement functions and you just
grabbed the entire source code and hacked at them if you needed new
ones.  Now you link in your own fx() and fy() before editing the 
libncarg library.  (don middleton 88).

This directory, dashsupr, has implementation dependent constants in
dashbd.f and remove.f.  There are various versions of remove.f, all of which
have the variables NXSIZE and NYSIZE set to 10.  dashbd.f has ISKIP
set assuming these values.  If you change NXSIZE and NYSIZE in remove*.f,
you must also make proper changes in dashbd.f.
Thu Jun 2 09:54:38 MDT 1988 don middleton - ncar scd

C
C $Id: APPF.f,v 1.1 2001-10-09 00:18:33 haley Exp $
C
C****************************************************************
C                                                               *
C                       Copyright (C)  1995                     *
C       University Corporation for Atmospheric Research         *
C                       All Rights Reserved                     *
C                                                               *
C****************************************************************
C
C      File:            APP.f
C
C      Author:          Jeff W. Boote
C                       National Center for Atmospheric Research
C                       PO 3000, Boulder, Colorado
C
C      Date:            Mon Mar 13 23:23:17 MST 1995
C
C      Description:     
C
      subroutine nhlfisapp(id,istat)

        integer id,istat
        call nhlpfisapp(id,istat)
      end

      subroutine nhlfappgetdefaultparentid(id)
        integer id
        call nhlpfappgetdefaultparentid(id)
      end

C
C	$Id: dashdb.f,v 1.5 2008-07-27 00:23:02 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE DASHDB (IPAT)
C
C Software dashed line package
C
C PURPOSE                DASHLINE is a software dashed line package.
C                        Some hardware dashed line generators
C                        fail to produce pleasing results when
C                        drawing very short vector segments or
C                        vector segments of varying lengths.  This
C                        package does not have this problem.
C
C USAGE                  First,
C                             CALL DASHDB (IPAT)
C
C                        Then, call any of the following:
C                             CALL CURVED (X,Y,N)
C                             CALL FRSTD (X,Y)
C                             CALL VECTD (X,Y)
C                             CALL LINED (XA,YA,XB,YB)
C
C
C ARGUMENTS             DASHDB (IPAT)
C ON INPUT                IPAT is a 16-bit dash pattern.  By default
C                         each bit in the pattern represents 3 plotter
C                         address units (1=solid, 0=blank)
C
C ARGUMENTS TO           CURVED(X,Y,N)
C OTHER LINE-DRAWING       X and Y are arrays of world coordinate values
C ROUTINES                 of length N or greater.  Line segments obeying
C                          the specified dash pattern are drawn to
C                          connect the N points.
C
C                        FRSTD(X,Y)
C                          The current pen position is set to
C                          the world coordinate value (X,Y)
C
C                        VECTD(X,Y)
C                          A line segment is drawn between the
C                          world coordinate value (X,Y) and the
C                          most recent pen position.  (X,Y) then
C                          becomes the most recent pen position.
C
C                        LINED(XA,XB,YA,YB)
C                          A line is drawn between world coordinate
C                          values (XA,YA) and (XB,YB).
C
C ON OUTPUT                All arguments are unchanged for all routines.
C
C ENTRY POINTS             DASHDB, CURVED, FRSTD, VECTD, LINED,
C                          LASTD, CFVLD, DRAWPV, DASHBD, DASHBDX
C
C COMMON BLOCKS            INTPR, DSHD, DSHDA, DSHDD, DSHDC, DSHDB
C
C REQUIRED LIBRARY         The ERPRT77 package and the SPPS.
C ROUTINES
C
C REQUIRED GKS LEVEL       0A
C
C PRECISION                Single
C
C LANGUAGE                 FORTRAN
C
C HISTORY                  Written in 1969, standardized in November 1972.
C                          Made portable in September 1977 for use
C                          with all computer systems having at least
C                          a 16-bit word.
C                          Converted to FORTRAN77 and GKS in April 1984.
C
C ALGORITHM                The position in the dash pattern is
C                          remembered as points are processed.  The
C                          distance transversed in plotter address space
C                          is used to determine whether to draw segments,
C                          parts of segments, characters, or nothing.
C                          The plotter address space is 1024 X 1024.
C
C ACCURACY                 Plus or minus .5 plotter address units per call.
C                          There is no cumulative error.
C
C TIMING                   For solid or blank lines, there is almost no
C                          overhead.  Dashed lines take about 4 times as
C                          long as drawing solid lines.  (The line
C                          drawing software is so fast that the increase
C                          will not be noticed in most programs.)
C
C PORTABILITY              FORTRAN77
C
C INTERNAL PARAMETERS      NAME   DEFAULT  FUNCTION  DECLARED IN BLOCK DATA
C                          ----   -------  --------
C
C                          IPAU      3     Number of plotter addresses per
C                                          element in the dash pattern for
C                                          solid lines and gaps. The
C                                          pattern is repeated every
C                                          IPAU*16 plotter address units.
C
C                          ICLOSE    6     An internal or external call to
C                                          set the pen (pen-up) to a
C                                          specific position is executed
C                                          only if this position is
C                                          more than ICLOSE metacode
C                                          address units away from the
C                                          current pen position (distance=
C                                          difference in X-coordinates +
C                                          difference in Y-coordinates).
C
C
C
C
C
C
C
      COMMON/INTPR/IPAU,FPART,TENSN,NP,SMALL,L1,ADDLR,ADDTB,MLLINE,
     1    ICLOSE
C
C USER ENTRY POINT.
C DASHDB GIVES AN INTERNAL REPRESENTATION TO THE DASH PATTERN WHICH IS
C SPECIFIED IN ITS ARGUMENTS. THIS INTERNAL REPRESENTATION IS PASSED
C TO ROUTINE CFVLD IN THE COMMON-BLOCK DSHD.
C
C
C IN DSHD AN INTERNAL REPRESENTATION OF THE DASH PATTERN IS PASSED TO
C ROUTINE CFVLD.
      COMMON /DSHD/   ISL        ,L          ,IP(16)
C IFSTFL IS A FLAG TO CONTROL THAT FRSTD IS CALLED BEFORE VECTD IS
C CALLED.
      COMMON /DSHDA/  IFSTFL
C
C IFCFLG IS THE FIRST CALL FLAG FOR DASHDB. IT IS INITIALIZED IN
C DASHBDX.  MASK HAS TO BE SAVED FOR SUBSEQUENT CALLS TO DASHDB.
C
      COMMON /DSHDD/ IFCFLG, MASK
      SAVE
C
C Do a call forcing a BLOCKDATA to be loaded from a binary library.
C
      CALL DASHBD
C
C THE FOLLOWING CALL IS FOR LIBRARY STATISTICS GATHERING AT NCAR
C
      CALL Q8QST4 ('GRAPHX', 'DASHLINE', 'DASHDB', 'VERSION 01')
      IF (IFCFLG .EQ. 2) GOTO 10
C
C CHECK IF THE CONSTANTS IN THE BLOCKDATA DASHBDX ARE LOADED CORRECTLY.
C
      IF (ISL .EQ. 1) GOTO 6
      CALL SETER('DASHDB - BLOCKDATA DASHBDX APPARENTLY NOT LOADED CORRE
     -CTLY',1,2)
    6 CONTINUE
C
C INITIALIZATION
C
C MASK IS AN ALL SOLID PATTERN TO BE PASSED TO OPTN (65535=177777B).
C
      MASK=IOR(ISHIFT(32767,1),1)
C
      IFCFLG = 2
C
C L - NUMBER OF WORDS IN THE FINAL PATTERN, POINTER TO IP ARRAY.
C ISL - FLAG FOR ALL SOLID PATTERN (1) OR ALL GAP PATTERN (-1).
C IFSTFL - FLAG TO CONTROL THAT FRSTD IS CALLED IN CFVLD BEFORE VECTD IS
C          CALLED, WHENEVER DASHDB HAS BEEN CALLED.
C
   10 CONTINUE
      L = 0
      ISL = 0
      IFSTFL = 1
C
C     FOR EXAMPLE, IF IPAT IS 0010001100000000 (BINARY), THEN L=5 AND
C       IP(1) = -2*IPAU
C       IP(2) =  1*IPAU
C       IP(3) = -3*IPAU
C       IP(4) =  2*IPAU
C       IP(5) = -8*IPAU
C
      ICRT = IPAU*ISHIFT(1,15-10)
      IF (IPAT .NE. 0) GO TO 260
      ISL = -1
      RETURN
  260 IF (IPAT .NE. MASK) GOTO 270
      ISL = 1
      RETURN
  270 NMODE1 = IAND(ISHIFT(IPAT,-15),1)
      DO 290 I = 1,16
      IF (NMODE1 .NE. IAND(ISHIFT(IPAT,I-16),1)) GO TO 280
      NMODE1 = 1 - NMODE1
      L = L + 1
      IP(L) = 0
  280 IP(L) = IP(L) + ICRT*(1-2*NMODE1)
  290 CONTINUE
      RETURN
      END

      SUBROUTINE CLARFB( SIDE, TRANS, DIRECT, STOREV, M, N, K, V, LDV,
     $                   T, LDT, C, LDC, WORK, LDWORK )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER          DIRECT, SIDE, STOREV, TRANS
      INTEGER            K, LDC, LDT, LDV, LDWORK, M, N
*     ..
*     .. Array Arguments ..
      COMPLEX            C( LDC, * ), T( LDT, * ), V( LDV, * ),
     $                   WORK( LDWORK, * )
*     ..
*
*  Purpose
*  =======
*
*  CLARFB applies a complex block reflector H or its transpose H' to a
*  complex M-by-N matrix C, from either the left or the right.
*
*  Arguments
*  =========
*
*  SIDE    (input) CHARACTER*1
*          = 'L': apply H or H' from the Left
*          = 'R': apply H or H' from the Right
*
*  TRANS   (input) CHARACTER*1
*          = 'N': apply H (No transpose)
*          = 'C': apply H' (Conjugate transpose)
*
*  DIRECT  (input) CHARACTER*1
*          Indicates how H is formed from a product of elementary
*          reflectors
*          = 'F': H = H(1) H(2) . . . H(k) (Forward)
*          = 'B': H = H(k) . . . H(2) H(1) (Backward)
*
*  STOREV  (input) CHARACTER*1
*          Indicates how the vectors which define the elementary
*          reflectors are stored:
*          = 'C': Columnwise
*          = 'R': Rowwise
*
*  M       (input) INTEGER
*          The number of rows of the matrix C.
*
*  N       (input) INTEGER
*          The number of columns of the matrix C.
*
*  K       (input) INTEGER
*          The order of the matrix T (= the number of elementary
*          reflectors whose product defines the block reflector).
*
*  V       (input) COMPLEX array, dimension
*                                (LDV,K) if STOREV = 'C'
*                                (LDV,M) if STOREV = 'R' and SIDE = 'L'
*                                (LDV,N) if STOREV = 'R' and SIDE = 'R'
*          The matrix V. See further details.
*
*  LDV     (input) INTEGER
*          The leading dimension of the array V.
*          If STOREV = 'C' and SIDE = 'L', LDV >= max(1,M);
*          if STOREV = 'C' and SIDE = 'R', LDV >= max(1,N);
*          if STOREV = 'R', LDV >= K.
*
*  T       (input) COMPLEX array, dimension (LDT,K)
*          The triangular K-by-K matrix T in the representation of the
*          block reflector.
*
*  LDT     (input) INTEGER
*          The leading dimension of the array T. LDT >= K.
*
*  C       (input/output) COMPLEX array, dimension (LDC,N)
*          On entry, the M-by-N matrix C.
*          On exit, C is overwritten by H*C or H'*C or C*H or C*H'.
*
*  LDC     (input) INTEGER
*          The leading dimension of the array C. LDC >= max(1,M).
*
*  WORK    (workspace) COMPLEX array, dimension (LDWORK,K)
*
*  LDWORK  (input) INTEGER
*          The leading dimension of the array WORK.
*          If SIDE = 'L', LDWORK >= max(1,N);
*          if SIDE = 'R', LDWORK >= max(1,M).
*
*  =====================================================================
*
*     .. Parameters ..
      COMPLEX            ONE
      PARAMETER          ( ONE = ( 1.0E+0, 0.0E+0 ) )
*     ..
*     .. Local Scalars ..
      CHARACTER          TRANST
      INTEGER            I, J
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           CCOPY, CGEMM, CLACGV, CTRMM
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          CONJG
*     ..
*     .. Executable Statements ..
*
*     Quick return if possible
*
      IF( M.LE.0 .OR. N.LE.0 )
     $   RETURN
*
      IF( LSAME( TRANS, 'N' ) ) THEN
         TRANST = 'C'
      ELSE
         TRANST = 'N'
      END IF
*
      IF( LSAME( STOREV, 'C' ) ) THEN
*
         IF( LSAME( DIRECT, 'F' ) ) THEN
*
*           Let  V =  ( V1 )    (first K rows)
*                     ( V2 )
*           where  V1  is unit lower triangular.
*
            IF( LSAME( SIDE, 'L' ) ) THEN
*
*              Form  H * C  or  H' * C  where  C = ( C1 )
*                                                  ( C2 )
*
*              W := C' * V  =  (C1'*V1 + C2'*V2)  (stored in WORK)
*
*              W := C1'
*
               DO 10 J = 1, K
                  CALL CCOPY( N, C( J, 1 ), LDC, WORK( 1, J ), 1 )
                  CALL CLACGV( N, WORK( 1, J ), 1 )
   10          CONTINUE
*
*              W := W * V1
*
               CALL CTRMM( 'Right', 'Lower', 'No transpose', 'Unit', N,
     $                     K, ONE, V, LDV, WORK, LDWORK )
               IF( M.GT.K ) THEN
*
*                 W := W + C2'*V2
*
                  CALL CGEMM( 'Conjugate transpose', 'No transpose', N,
     $                        K, M-K, ONE, C( K+1, 1 ), LDC,
     $                        V( K+1, 1 ), LDV, ONE, WORK, LDWORK )
               END IF
*
*              W := W * T'  or  W * T
*
               CALL CTRMM( 'Right', 'Upper', TRANST, 'Non-unit', N, K,
     $                     ONE, T, LDT, WORK, LDWORK )
*
*              C := C - V * W'
*
               IF( M.GT.K ) THEN
*
*                 C2 := C2 - V2 * W'
*
                  CALL CGEMM( 'No transpose', 'Conjugate transpose',
     $                        M-K, N, K, -ONE, V( K+1, 1 ), LDV, WORK,
     $                        LDWORK, ONE, C( K+1, 1 ), LDC )
               END IF
*
*              W := W * V1'
*
               CALL CTRMM( 'Right', 'Lower', 'Conjugate transpose',
     $                     'Unit', N, K, ONE, V, LDV, WORK, LDWORK )
*
*              C1 := C1 - W'
*
               DO 30 J = 1, K
                  DO 20 I = 1, N
                     C( J, I ) = C( J, I ) - CONJG( WORK( I, J ) )
   20             CONTINUE
   30          CONTINUE
*
            ELSE IF( LSAME( SIDE, 'R' ) ) THEN
*
*              Form  C * H  or  C * H'  where  C = ( C1  C2 )
*
*              W := C * V  =  (C1*V1 + C2*V2)  (stored in WORK)
*
*              W := C1
*
               DO 40 J = 1, K
                  CALL CCOPY( M, C( 1, J ), 1, WORK( 1, J ), 1 )
   40          CONTINUE
*
*              W := W * V1
*
               CALL CTRMM( 'Right', 'Lower', 'No transpose', 'Unit', M,
     $                     K, ONE, V, LDV, WORK, LDWORK )
               IF( N.GT.K ) THEN
*
*                 W := W + C2 * V2
*
                  CALL CGEMM( 'No transpose', 'No transpose', M, K, N-K,
     $                        ONE, C( 1, K+1 ), LDC, V( K+1, 1 ), LDV,
     $                        ONE, WORK, LDWORK )
               END IF
*
*              W := W * T  or  W * T'
*
               CALL CTRMM( 'Right', 'Upper', TRANS, 'Non-unit', M, K,
     $                     ONE, T, LDT, WORK, LDWORK )
*
*              C := C - W * V'
*
               IF( N.GT.K ) THEN
*
*                 C2 := C2 - W * V2'
*
                  CALL CGEMM( 'No transpose', 'Conjugate transpose', M,
     $                        N-K, K, -ONE, WORK, LDWORK, V( K+1, 1 ),
     $                        LDV, ONE, C( 1, K+1 ), LDC )
               END IF
*
*              W := W * V1'
*
               CALL CTRMM( 'Right', 'Lower', 'Conjugate transpose',
     $                     'Unit', M, K, ONE, V, LDV, WORK, LDWORK )
*
*              C1 := C1 - W
*
               DO 60 J = 1, K
                  DO 50 I = 1, M
                     C( I, J ) = C( I, J ) - WORK( I, J )
   50             CONTINUE
   60          CONTINUE
            END IF
*
         ELSE
*
*           Let  V =  ( V1 )
*                     ( V2 )    (last K rows)
*           where  V2  is unit upper triangular.
*
            IF( LSAME( SIDE, 'L' ) ) THEN
*
*              Form  H * C  or  H' * C  where  C = ( C1 )
*                                                  ( C2 )
*
*              W := C' * V  =  (C1'*V1 + C2'*V2)  (stored in WORK)
*
*              W := C2'
*
               DO 70 J = 1, K
                  CALL CCOPY( N, C( M-K+J, 1 ), LDC, WORK( 1, J ), 1 )
                  CALL CLACGV( N, WORK( 1, J ), 1 )
   70          CONTINUE
*
*              W := W * V2
*
               CALL CTRMM( 'Right', 'Upper', 'No transpose', 'Unit', N,
     $                     K, ONE, V( M-K+1, 1 ), LDV, WORK, LDWORK )
               IF( M.GT.K ) THEN
*
*                 W := W + C1'*V1
*
                  CALL CGEMM( 'Conjugate transpose', 'No transpose', N,
     $                        K, M-K, ONE, C, LDC, V, LDV, ONE, WORK,
     $                        LDWORK )
               END IF
*
*              W := W * T'  or  W * T
*
               CALL CTRMM( 'Right', 'Lower', TRANST, 'Non-unit', N, K,
     $                     ONE, T, LDT, WORK, LDWORK )
*
*              C := C - V * W'
*
               IF( M.GT.K ) THEN
*
*                 C1 := C1 - V1 * W'
*
                  CALL CGEMM( 'No transpose', 'Conjugate transpose',
     $                        M-K, N, K, -ONE, V, LDV, WORK, LDWORK,
     $                        ONE, C, LDC )
               END IF
*
*              W := W * V2'
*
               CALL CTRMM( 'Right', 'Upper', 'Conjugate transpose',
     $                     'Unit', N, K, ONE, V( M-K+1, 1 ), LDV, WORK,
     $                     LDWORK )
*
*              C2 := C2 - W'
*
               DO 90 J = 1, K
                  DO 80 I = 1, N
                     C( M-K+J, I ) = C( M-K+J, I ) -
     $                               CONJG( WORK( I, J ) )
   80             CONTINUE
   90          CONTINUE
*
            ELSE IF( LSAME( SIDE, 'R' ) ) THEN
*
*              Form  C * H  or  C * H'  where  C = ( C1  C2 )
*
*              W := C * V  =  (C1*V1 + C2*V2)  (stored in WORK)
*
*              W := C2
*
               DO 100 J = 1, K
                  CALL CCOPY( M, C( 1, N-K+J ), 1, WORK( 1, J ), 1 )
  100          CONTINUE
*
*              W := W * V2
*
               CALL CTRMM( 'Right', 'Upper', 'No transpose', 'Unit', M,
     $                     K, ONE, V( N-K+1, 1 ), LDV, WORK, LDWORK )
               IF( N.GT.K ) THEN
*
*                 W := W + C1 * V1
*
                  CALL CGEMM( 'No transpose', 'No transpose', M, K, N-K,
     $                        ONE, C, LDC, V, LDV, ONE, WORK, LDWORK )
               END IF
*
*              W := W * T  or  W * T'
*
               CALL CTRMM( 'Right', 'Lower', TRANS, 'Non-unit', M, K,
     $                     ONE, T, LDT, WORK, LDWORK )
*
*              C := C - W * V'
*
               IF( N.GT.K ) THEN
*
*                 C1 := C1 - W * V1'
*
                  CALL CGEMM( 'No transpose', 'Conjugate transpose', M,
     $                        N-K, K, -ONE, WORK, LDWORK, V, LDV, ONE,
     $                        C, LDC )
               END IF
*
*              W := W * V2'
*
               CALL CTRMM( 'Right', 'Upper', 'Conjugate transpose',
     $                     'Unit', M, K, ONE, V( N-K+1, 1 ), LDV, WORK,
     $                     LDWORK )
*
*              C2 := C2 - W
*
               DO 120 J = 1, K
                  DO 110 I = 1, M
                     C( I, N-K+J ) = C( I, N-K+J ) - WORK( I, J )
  110             CONTINUE
  120          CONTINUE
            END IF
         END IF
*
      ELSE IF( LSAME( STOREV, 'R' ) ) THEN
*
         IF( LSAME( DIRECT, 'F' ) ) THEN
*
*           Let  V =  ( V1  V2 )    (V1: first K columns)
*           where  V1  is unit upper triangular.
*
            IF( LSAME( SIDE, 'L' ) ) THEN
*
*              Form  H * C  or  H' * C  where  C = ( C1 )
*                                                  ( C2 )
*
*              W := C' * V'  =  (C1'*V1' + C2'*V2') (stored in WORK)
*
*              W := C1'
*
               DO 130 J = 1, K
                  CALL CCOPY( N, C( J, 1 ), LDC, WORK( 1, J ), 1 )
                  CALL CLACGV( N, WORK( 1, J ), 1 )
  130          CONTINUE
*
*              W := W * V1'
*
               CALL CTRMM( 'Right', 'Upper', 'Conjugate transpose',
     $                     'Unit', N, K, ONE, V, LDV, WORK, LDWORK )
               IF( M.GT.K ) THEN
*
*                 W := W + C2'*V2'
*
                  CALL CGEMM( 'Conjugate transpose',
     $                        'Conjugate transpose', N, K, M-K, ONE,
     $                        C( K+1, 1 ), LDC, V( 1, K+1 ), LDV, ONE,
     $                        WORK, LDWORK )
               END IF
*
*              W := W * T'  or  W * T
*
               CALL CTRMM( 'Right', 'Upper', TRANST, 'Non-unit', N, K,
     $                     ONE, T, LDT, WORK, LDWORK )
*
*              C := C - V' * W'
*
               IF( M.GT.K ) THEN
*
*                 C2 := C2 - V2' * W'
*
                  CALL CGEMM( 'Conjugate transpose',
     $                        'Conjugate transpose', M-K, N, K, -ONE,
     $                        V( 1, K+1 ), LDV, WORK, LDWORK, ONE,
     $                        C( K+1, 1 ), LDC )
               END IF
*
*              W := W * V1
*
               CALL CTRMM( 'Right', 'Upper', 'No transpose', 'Unit', N,
     $                     K, ONE, V, LDV, WORK, LDWORK )
*
*              C1 := C1 - W'
*
               DO 150 J = 1, K
                  DO 140 I = 1, N
                     C( J, I ) = C( J, I ) - CONJG( WORK( I, J ) )
  140             CONTINUE
  150          CONTINUE
*
            ELSE IF( LSAME( SIDE, 'R' ) ) THEN
*
*              Form  C * H  or  C * H'  where  C = ( C1  C2 )
*
*              W := C * V'  =  (C1*V1' + C2*V2')  (stored in WORK)
*
*              W := C1
*
               DO 160 J = 1, K
                  CALL CCOPY( M, C( 1, J ), 1, WORK( 1, J ), 1 )
  160          CONTINUE
*
*              W := W * V1'
*
               CALL CTRMM( 'Right', 'Upper', 'Conjugate transpose',
     $                     'Unit', M, K, ONE, V, LDV, WORK, LDWORK )
               IF( N.GT.K ) THEN
*
*                 W := W + C2 * V2'
*
                  CALL CGEMM( 'No transpose', 'Conjugate transpose', M,
     $                        K, N-K, ONE, C( 1, K+1 ), LDC,
     $                        V( 1, K+1 ), LDV, ONE, WORK, LDWORK )
               END IF
*
*              W := W * T  or  W * T'
*
               CALL CTRMM( 'Right', 'Upper', TRANS, 'Non-unit', M, K,
     $                     ONE, T, LDT, WORK, LDWORK )
*
*              C := C - W * V
*
               IF( N.GT.K ) THEN
*
*                 C2 := C2 - W * V2
*
                  CALL CGEMM( 'No transpose', 'No transpose', M, N-K, K,
     $                        -ONE, WORK, LDWORK, V( 1, K+1 ), LDV, ONE,
     $                        C( 1, K+1 ), LDC )
               END IF
*
*              W := W * V1
*
               CALL CTRMM( 'Right', 'Upper', 'No transpose', 'Unit', M,
     $                     K, ONE, V, LDV, WORK, LDWORK )
*
*              C1 := C1 - W
*
               DO 180 J = 1, K
                  DO 170 I = 1, M
                     C( I, J ) = C( I, J ) - WORK( I, J )
  170             CONTINUE
  180          CONTINUE
*
            END IF
*
         ELSE
*
*           Let  V =  ( V1  V2 )    (V2: last K columns)
*           where  V2  is unit lower triangular.
*
            IF( LSAME( SIDE, 'L' ) ) THEN
*
*              Form  H * C  or  H' * C  where  C = ( C1 )
*                                                  ( C2 )
*
*              W := C' * V'  =  (C1'*V1' + C2'*V2') (stored in WORK)
*
*              W := C2'
*
               DO 190 J = 1, K
                  CALL CCOPY( N, C( M-K+J, 1 ), LDC, WORK( 1, J ), 1 )
                  CALL CLACGV( N, WORK( 1, J ), 1 )
  190          CONTINUE
*
*              W := W * V2'
*
               CALL CTRMM( 'Right', 'Lower', 'Conjugate transpose',
     $                     'Unit', N, K, ONE, V( 1, M-K+1 ), LDV, WORK,
     $                     LDWORK )
               IF( M.GT.K ) THEN
*
*                 W := W + C1'*V1'
*
                  CALL CGEMM( 'Conjugate transpose',
     $                        'Conjugate transpose', N, K, M-K, ONE, C,
     $                        LDC, V, LDV, ONE, WORK, LDWORK )
               END IF
*
*              W := W * T'  or  W * T
*
               CALL CTRMM( 'Right', 'Lower', TRANST, 'Non-unit', N, K,
     $                     ONE, T, LDT, WORK, LDWORK )
*
*              C := C - V' * W'
*
               IF( M.GT.K ) THEN
*
*                 C1 := C1 - V1' * W'
*
                  CALL CGEMM( 'Conjugate transpose',
     $                        'Conjugate transpose', M-K, N, K, -ONE, V,
     $                        LDV, WORK, LDWORK, ONE, C, LDC )
               END IF
*
*              W := W * V2
*
               CALL CTRMM( 'Right', 'Lower', 'No transpose', 'Unit', N,
     $                     K, ONE, V( 1, M-K+1 ), LDV, WORK, LDWORK )
*
*              C2 := C2 - W'
*
               DO 210 J = 1, K
                  DO 200 I = 1, N
                     C( M-K+J, I ) = C( M-K+J, I ) -
     $                               CONJG( WORK( I, J ) )
  200             CONTINUE
  210          CONTINUE
*
            ELSE IF( LSAME( SIDE, 'R' ) ) THEN
*
*              Form  C * H  or  C * H'  where  C = ( C1  C2 )
*
*              W := C * V'  =  (C1*V1' + C2*V2')  (stored in WORK)
*
*              W := C2
*
               DO 220 J = 1, K
                  CALL CCOPY( M, C( 1, N-K+J ), 1, WORK( 1, J ), 1 )
  220          CONTINUE
*
*              W := W * V2'
*
               CALL CTRMM( 'Right', 'Lower', 'Conjugate transpose',
     $                     'Unit', M, K, ONE, V( 1, N-K+1 ), LDV, WORK,
     $                     LDWORK )
               IF( N.GT.K ) THEN
*
*                 W := W + C1 * V1'
*
                  CALL CGEMM( 'No transpose', 'Conjugate transpose', M,
     $                        K, N-K, ONE, C, LDC, V, LDV, ONE, WORK,
     $                        LDWORK )
               END IF
*
*              W := W * T  or  W * T'
*
               CALL CTRMM( 'Right', 'Lower', TRANS, 'Non-unit', M, K,
     $                     ONE, T, LDT, WORK, LDWORK )
*
*              C := C - W * V
*
               IF( N.GT.K ) THEN
*
*                 C1 := C1 - W * V1
*
                  CALL CGEMM( 'No transpose', 'No transpose', M, N-K, K,
     $                        -ONE, WORK, LDWORK, V, LDV, ONE, C, LDC )
               END IF
*
*              W := W * V2
*
               CALL CTRMM( 'Right', 'Lower', 'No transpose', 'Unit', M,
     $                     K, ONE, V( 1, N-K+1 ), LDV, WORK, LDWORK )
*
*              C1 := C1 - W
*
               DO 240 J = 1, K
                  DO 230 I = 1, M
                     C( I, N-K+J ) = C( I, N-K+J ) - WORK( I, J )
  230             CONTINUE
  240          CONTINUE
*
            END IF
*
         END IF
      END IF
*
      RETURN
*
*     End of CLARFB
*
      END

C
C $Id: llmisc.f,v 1.1 2009-05-15 00:49:27 dbrown Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE EPRIN
C
C This routine just prints the current error message, if any.
C
C The common blocks SECOMI and SECOMC are used to hold shared variables
C of types INTEGER and CHARACTER, respectively, for the routine SETER
C and associated routines.  For descriptions of these variables and for
C default values of them, see the block data routine SEBLDAX.
C
        COMMON /SECOMI/ IERRU,IERRF,IRECF,LOMSG
        SAVE   /SECOMI/
C
        COMMON /SECOMC/ ERMSG
          CHARACTER*256 ERMSG
        SAVE   /SECOMC/
C
C Do it.
C
        IF (IERRF.NE.0) WRITE (IERRU,'('' ERROR '',I4,'' IN '',A)')
     +                                              IERRF,ERMSG(1:LOMSG)
C
C Done.
C
        RETURN
C
      END
C
C $Id: llmisc.f,v 1.1 2009-05-15 00:49:27 dbrown Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE SETER (MESSG,NERRF,IROPT)
C
        CHARACTER*(*) MESSG
C
C This routine is called when an error occurs.  The arguments specify
C an error message, an error number, and an option indicating whether
C the error is recoverable or fatal.  Exactly how the error is handled
C depends not only on the values of these arguments, but also on the
C values of internal variables specifying whether recovery mode is in
C effect and whether a previous error has occurred and not yet been
C recovered from and cleared.
C
C If no uncleared recoverable error has occurred and there are no
C errors in the arguments, then the following apply:
C
C   IROPT = 1, recovery mode active      -  just remember the error.
C   IROPT = 1, recovery mode not active  -  print and stop.
C   IROPT = 2                            -  print, dump, and stop.
C
C Input:
C
C   MESSG  - the error message (113 characters maximum).  The error
C            message should contain the name of the routine in which
C            the error occurred, followed by a blank, then a hyphen
C            (minus sign), then another blank, and then a short
C            description of the error.
C   NERRF  - the error number - must be non-zero.
C   IROPT  - the option - must have IROPT = 1 or 2.
C
C Error states:
C
C   1 - message length not positive.
C   2 - NERRF equal to 0.
C   3 - an unrecovered error followed by another error.
C   4 - bad value for IROPT (less than 1 or greater than 2).
C
C The common blocks SECOMI and SECOMC are used to hold shared variables
C of types INTEGER and CHARACTER, respectively, for the routine SETER
C and associated routines.  For descriptions of these variables and for
C default values of them, see the block data routine SEBLDAX.
C
        COMMON /SECOMI/ IERRU,IERRF,IRECF,LOMSG
        SAVE   /SECOMI/
C
        COMMON /SECOMC/ ERMSG
          CHARACTER*256 ERMSG
        SAVE   /SECOMC/
C
C Do a call forcing a BLOCKDATA to be loaded from a binary library.
C
        CALL SEBLDA
C
C The unit number for error messages is I1MACH(4).  Save that value,
C if it has not already been done.
C
        IF (IERRU.EQ.0) IERRU=I1MACH(4)
C
C Check for various error conditions.  The low-order bits of IERRC
C are used to keep track of which such errors have occurred.
C
        IERRC=0
C
C Check for a message of length zero or less.
C
        IF (LEN(MESSG).LE.0) THEN
          IERRC=IERRC+1
          WRITE (IERRU,1001)
        END IF
C
C Check for NERRF = 0.
C
        IF (NERRF.EQ.0) THEN
          IERRC=IERRC+2
          WRITE (IERRU,1002)
        END IF
C
C Check for a previous unrecovered error.
C
        IF (IERRF.NE.0) THEN
          IERRC=IERRC+4
          WRITE (IERRU,1003)
        END IF
C
C Check for an illegal value of the recovery flag.
C
        IF (IROPT.NE.1.AND.IROPT.NE.2) THEN
          IERRC=IERRC+8
          WRITE (IERRU,1004)
        END IF
C
C If one of the error conditions applies, print the appropriate
C information and quit.
C
        IF (IERRC.NE.0) THEN
          IF (MOD(IERRC/4,2).NE.0) THEN
            WRITE (IERRU,1005) IERRF,ERMSG(1:LOMSG)
          END IF
          IF (MOD(IERRC,2).EQ.0) THEN
            WRITE (IERRU,1006) NERRF,MESSG(1:ICLOEM(MESSG))
          END IF
          CALL FDUM
          STOP
        END IF
C
C Save the error message and error number.
C
        IERRF=NERRF
        ERMSG=MESSG
        LOMSG=ICLOEM(ERMSG)
C
C If recovery mode is activated and the error is recoverable, return
C to the caller for recovery action.
C
        IF (IRECF.EQ.1.AND.IROPT.EQ.1) RETURN
C
C Otherwise, print the error message.
C
        WRITE (IERRU,1007) IERRF,ERMSG(1:LOMSG)
C
C If the error is fatal, call the dump routine.
C
        IF (IROPT.EQ.2) CALL FDUM
C
C Quit.
C
        STOP
C
C Formats used above.
C
 1001 FORMAT (' ERROR    1 IN SETER - MESSAGE LENGTH IS NOT POSITIVE')
 1002 FORMAT (' ERROR    2 IN SETER - ILLEGAL VALUE FOR ERROR NUMBER')
 1003 FORMAT (' ERROR    3 IN SETER - AN UNCLEARED PRIOR ERROR EXISTS')
 1004 FORMAT (' ERROR    4 IN SETER - ILLEGAL VALUE FOR RECOVERY FLAG')
 1005 FORMAT (' ... MESSAGE FOR UNCLEARED PRIOR ERROR IS AS FOLLOWS:'/
     +        ' ... ERROR ',I4,' IN ',A)
 1006 FORMAT (' ... MESSAGE FOR CURRENT CALL TO SETER IS AS FOLLOWS:'/
     +        ' ... ERROR ',I4,' IN ',A)
 1007 FORMAT (' ERROR ',I4,' IN ',A)
C
      END
C
C $Id: llmisc.f,v 1.1 2009-05-15 00:49:27 dbrown Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      FUNCTION ICFELL (MESSG,NERRF)
C
        CHARACTER*(*) MESSG
C
C ICFELL (which stands for "I Check For Errors on Lower Level") is used
C to check for the occurrence of a recoverable error in a lower-level
C routine and (perhaps) to update the current error flag and message.
C
C The old value of the current error flag is returned as the value of
C the function ICFELL.  If that value is zero, nothing else has been
C done.  If the value of ICFELL is non-zero, the following actions have
C been taken:
C
C   If MESSG is blank, the current error message has not been changed.
C
C   If MESSG is non-blank and its length is 6 or less, it should be the
C   name of the routine referencing ICFELL; the current error message
C   has been altered by prepending first a slash and then the value of
C   MESSG.  (Note that, if an error occurs several levels deep, the
C   effect of using ICFELL at each level is, effectively, to generate
C   traceback information in the error message.)
C
C   If MESSG is non-blank and its length is 7 or greater, its value
C   has become the new value of the current error message and the
C   previous error message has been printed.  This is used at the
C   beginning of an NCAR Graphics routine to check for an outstanding
C   error that the user has not recovered from and to ensure that the
C   message for the outstanding error gets printed.
C
C   If the expression NERRF has the value zero, the current error
C   flag has not been changed.
C
C   If the expression NERRF has a non-zero value, the value of the
C   current error flag has been made equal to that value.
C
C An example:  Assume that the routine "A" calls the routine "B" and
C that "B" detects an error and calls SETER with error number "32" and
C error message "B - ERROR HAS OCCURRED".  If recovery mode is not in
C effect, SETER prints the error message and STOPs, but, if recovery
C mode is in effect, control returns from "SETER" to "B" and thence to
C "A".  At that point, the statement
C
C   IF (ICFELL('A',13).NE.0) RETURN
C
C detects the fact that an error has occurred in "B" and results in a
C return from "A" to whatever routine called it.  It also changes the
C current error message to read "A/B - ERROR HAS OCCURRED" and changes
C the error number from "32" to "13".
C
C Another example:  Assume that the NCAR Graphics routine "A" is called
C when recovery mode is set and that it detects an error, calls SETER,
C and RETURNs to the user.  If the user neglects to check the error
C state and calls the routine "B" next, the statement
C
C   IF (ICFELL('B - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C ensures that the error message from routine "A" will be printed, that
C it will be replaced by "B - UNCLEARED PRIOR ERROR", and that "B" will
C not attempt to execute.
C
C
C The common blocks SECOMI and SECOMC are used to hold shared variables
C of types INTEGER and CHARACTER, respectively, for the routine SETER
C and associated routines.  For descriptions of these variables and for
C default values of them, see the block data routine SEBLDAX.
C
        COMMON /SECOMI/ IERRU,IERRF,IRECF,LOMSG
        SAVE   /SECOMI/
C
        COMMON /SECOMC/ ERMSG
          CHARACTER*256 ERMSG
        SAVE   /SECOMC/
C
C Define a character temporary to use.
C
        CHARACTER*256 CTEMP
C
C Set the value of the function to the current value of the error flag.
C
        ICFELL=IERRF
C
C If the current error flag is non-zero, update its value and the value
C of the error message as directed by the values of the arguments of
C ICFELL.
C
        IF (IERRF.NE.0) THEN
C
          IF (MESSG.NE.' ') THEN
C
            LENMSG=ICLOEM(MESSG)
C
            IF (LENMSG.LE.6) THEN
              CTEMP=ERMSG
              ERMSG=MESSG(1:LENMSG)//'/'//CTEMP
            ELSE
              CALL EPRIN
              ERMSG=MESSG
            END IF
C
            LOMSG=ICLOEM(ERMSG)
C
          END IF
C
          IF (NERRF.NE.0) IERRF=NERRF
C
        END IF
C
C Done.
C
        RETURN
C
      END
C
C $Id: llmisc.f,v 1.1 2009-05-15 00:49:27 dbrown Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      FUNCTION ICLOEM (MESSG)
C
        CHARACTER*(*) MESSG
C
C ICLOEM(MESSG) is the index of the last non-blank character in MESSG.
C
        DO 101 I=LEN(MESSG),1,-1
         IF (MESSG(I:I).NE.' ') THEN
           ICLOEM=I
           RETURN
         END IF
  101   CONTINUE
C
        ICLOEM=1
C
        RETURN
C
      END
C
C $Id: llmisc.f,v 1.1 2009-05-15 00:49:27 dbrown Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE FDUM
C
C This routine is called when a fatal error occurs.  The default
C version does nothing.  A version may be supplied by the user to
C do something more useful.
C
        RETURN
C
      END
      INTEGER FUNCTION I1MACH(I)
      INTEGER I
C
C    I1MACH( 1) = THE STANDARD INPUT UNIT.
C    I1MACH( 2) = THE STANDARD OUTPUT UNIT.
C    I1MACH( 3) = THE STANDARD PUNCH UNIT.
C    I1MACH( 4) = THE STANDARD ERROR MESSAGE UNIT.
C    I1MACH( 5) = THE NUMBER OF BITS PER INTEGER STORAGE UNIT.
C    I1MACH( 6) = THE NUMBER OF CHARACTERS PER CHARACTER STORAGE UNIT.
C    INTEGERS HAVE FORM SIGN ( X(S-1)*A**(S-1) + ... + X(1)*A + X(0) )
C    I1MACH( 7) = A, THE BASE.
C    I1MACH( 8) = S, THE NUMBER OF BASE-A DIGITS.
C    I1MACH( 9) = A**S - 1, THE LARGEST MAGNITUDE.
C    FLOATS HAVE FORM  SIGN (B**E)*( (X(1)/B) + ... + (X(T)/B**T) )
C               WHERE  EMIN .LE. E .LE. EMAX.
C    I1MACH(10) = B, THE BASE.
C  SINGLE-PRECISION
C    I1MACH(11) = T, THE NUMBER OF BASE-B DIGITS.
C    I1MACH(12) = EMIN, THE SMALLEST EXPONENT E.
C    I1MACH(13) = EMAX, THE LARGEST EXPONENT E.
C  DOUBLE-PRECISION
C    I1MACH(14) = T, THE NUMBER OF BASE-B DIGITS.
C    I1MACH(15) = EMIN, THE SMALLEST EXPONENT E.
C    I1MACH(16) = EMAX, THE LARGEST EXPONENT E.
C
      INTEGER IMACH(16), OUTPUT, SC, SMALL(2)
      SAVE IMACH, SC
      REAL RMACH
      EQUIVALENCE (IMACH(4),OUTPUT), (RMACH,SMALL(1))
      INTEGER I3, J, K, T3E(3)
      DATA T3E(1) / 9777664 /
      DATA T3E(2) / 5323660 /
      DATA T3E(3) / 46980 /
C  THIS VERSION ADAPTS AUTOMATICALLY TO MOST CURRENT MACHINES,
C  INCLUDING AUTO-DOUBLE COMPILERS.
C  TO COMPILE ON OLDER MACHINES, ADD A C IN COLUMN 1
C  ON THE NEXT LINE
      DATA SC/0/
C  AND REMOVE THE C FROM COLUMN 1 IN ONE OF THE SECTIONS BELOW.
C  CONSTANTS FOR EVEN OLDER MACHINES CAN BE OBTAINED BY
C          mail netlib@research.bell-labs.com
C          send old1mach from blas
C  PLEASE SEND CORRECTIONS TO dmg OR ehg@bell-labs.com.
C
C     MACHINE CONSTANTS FOR THE HONEYWELL DPS 8/70 SERIES.
C
C      DATA IMACH( 1) /    5 /
C      DATA IMACH( 2) /    6 /
C      DATA IMACH( 3) /   43 /
C      DATA IMACH( 4) /    6 /
C      DATA IMACH( 5) /   36 /
C      DATA IMACH( 6) /    4 /
C      DATA IMACH( 7) /    2 /
C      DATA IMACH( 8) /   35 /
C      DATA IMACH( 9) / O377777777777 /
C      DATA IMACH(10) /    2 /
C      DATA IMACH(11) /   27 /
C      DATA IMACH(12) / -127 /
C      DATA IMACH(13) /  127 /
C      DATA IMACH(14) /   63 /
C      DATA IMACH(15) / -127 /
C      DATA IMACH(16) /  127 /, SC/987/
C
C     MACHINE CONSTANTS FOR PDP-11 FORTRANS SUPPORTING
C     32-BIT INTEGER ARITHMETIC.
C
C      DATA IMACH( 1) /    5 /
C      DATA IMACH( 2) /    6 /
C      DATA IMACH( 3) /    7 /
C      DATA IMACH( 4) /    6 /
C      DATA IMACH( 5) /   32 /
C      DATA IMACH( 6) /    4 /
C      DATA IMACH( 7) /    2 /
C      DATA IMACH( 8) /   31 /
C      DATA IMACH( 9) / 2147483647 /
C      DATA IMACH(10) /    2 /
C      DATA IMACH(11) /   24 /
C      DATA IMACH(12) / -127 /
C      DATA IMACH(13) /  127 /
C      DATA IMACH(14) /   56 /
C      DATA IMACH(15) / -127 /
C      DATA IMACH(16) /  127 /, SC/987/
C
C     MACHINE CONSTANTS FOR THE UNIVAC 1100 SERIES.
C
C     NOTE THAT THE PUNCH UNIT, I1MACH(3), HAS BEEN SET TO 7
C     WHICH IS APPROPRIATE FOR THE UNIVAC-FOR SYSTEM.
C     IF YOU HAVE THE UNIVAC-FTN SYSTEM, SET IT TO 1.
C
C      DATA IMACH( 1) /    5 /
C      DATA IMACH( 2) /    6 /
C      DATA IMACH( 3) /    7 /
C      DATA IMACH( 4) /    6 /
C      DATA IMACH( 5) /   36 /
C      DATA IMACH( 6) /    6 /
C      DATA IMACH( 7) /    2 /
C      DATA IMACH( 8) /   35 /
C      DATA IMACH( 9) / O377777777777 /
C      DATA IMACH(10) /    2 /
C      DATA IMACH(11) /   27 /
C      DATA IMACH(12) / -128 /
C      DATA IMACH(13) /  127 /
C      DATA IMACH(14) /   60 /
C      DATA IMACH(15) /-1024 /
C      DATA IMACH(16) / 1023 /, SC/987/
C
      IF (SC .NE. 987) THEN
*        *** CHECK FOR AUTODOUBLE ***
         SMALL(2) = 0
         RMACH = 1E13
         IF (SMALL(2) .NE. 0) THEN
*           *** AUTODOUBLED ***
            IF (      (SMALL(1) .EQ. 1117925532
     *           .AND. SMALL(2) .EQ. -448790528)
     *       .OR.     (SMALL(2) .EQ. 1117925532
     *           .AND. SMALL(1) .EQ. -448790528)) THEN
*               *** IEEE ***
               IMACH(10) = 2
               IMACH(14) = 53
               IMACH(15) = -1021
               IMACH(16) = 1024
            ELSE IF ( SMALL(1) .EQ. -2065213935
     *          .AND. SMALL(2) .EQ. 10752) THEN
*               *** VAX WITH D_FLOATING ***
               IMACH(10) = 2
               IMACH(14) = 56
               IMACH(15) = -127
               IMACH(16) = 127
            ELSE IF ( SMALL(1) .EQ. 1267827943
     *          .AND. SMALL(2) .EQ. 704643072) THEN
*               *** IBM MAINFRAME ***
               IMACH(10) = 16
               IMACH(14) = 14
               IMACH(15) = -64
               IMACH(16) = 63
            ELSE
               WRITE(*,9010)
               STOP 777
               END IF
            IMACH(11) = IMACH(14)
            IMACH(12) = IMACH(15)
            IMACH(13) = IMACH(16)
         ELSE
            RMACH = 1234567.
            IF (SMALL(1) .EQ. 1234613304) THEN
*               *** IEEE ***
               IMACH(10) = 2
               IMACH(11) = 24
               IMACH(12) = -125
               IMACH(13) = 128
               IMACH(14) = 53
               IMACH(15) = -1021
               IMACH(16) = 1024
               SC = 987
            ELSE IF (SMALL(1) .EQ. -1271379306) THEN
*               *** VAX ***
               IMACH(10) = 2
               IMACH(11) = 24
               IMACH(12) = -127
               IMACH(13) = 127
               IMACH(14) = 56
               IMACH(15) = -127
               IMACH(16) = 127
               SC = 987
            ELSE IF (SMALL(1) .EQ. 1175639687) THEN
*               *** IBM MAINFRAME ***
               IMACH(10) = 16
               IMACH(11) = 6
               IMACH(12) = -64
               IMACH(13) = 63
               IMACH(14) = 14
               IMACH(15) = -64
               IMACH(16) = 63
               SC = 987
            ELSE IF (SMALL(1) .EQ. 1251390520) THEN
*              *** CONVEX C-1 ***
               IMACH(10) = 2
               IMACH(11) = 24
               IMACH(12) = -128
               IMACH(13) = 127
               IMACH(14) = 53
               IMACH(15) = -1024
               IMACH(16) = 1023
            ELSE
               DO 10 I3 = 1, 3
                  J = SMALL(1) / 10000000
                  K = SMALL(1) - 10000000*J
                  IF (K .NE. T3E(I3)) GO TO 20
                  SMALL(1) = J
 10               CONTINUE
*              *** CRAY T3E ***
               IMACH( 1) = 5
               IMACH( 2) = 6
               IMACH( 3) = 0
C
C Note: the original version returns '6' for IMACH(4). But, we've
C been using '0' for years, so we hard-coded it to '0' here.
C
               IMACH( 4) = 0
               IMACH( 5) = 64
               IMACH( 6) = 8
               IMACH( 7) = 2
               IMACH( 8) = 63
               CALL I1MCR1(IMACH(9), K, 32767, 16777215, 16777215)
               IMACH(10) = 2
               IMACH(11) = 53
               IMACH(12) = -1021
               IMACH(13) = 1024
               IMACH(14) = 53
               IMACH(15) = -1021
               IMACH(16) = 1024
               GO TO 35
 20            CALL I1MCR1(J, K, 16405, 9876536, 0)
               IF (SMALL(1) .NE. J) THEN
                  WRITE(*,9020)
                  STOP 777
                  END IF
*              *** CRAY 1, XMP, 2, AND 3 ***
               IMACH(1) = 5
               IMACH(2) = 6
               IMACH(3) = 102
               IMACH(4) = 6
               IMACH(5) = 46
               IMACH(6) = 8
               IMACH(7) = 2
               IMACH(8) = 45
               CALL I1MCR1(IMACH(9), K, 0, 4194303, 16777215)
               IMACH(10) = 2
               IMACH(11) = 47
               IMACH(12) = -8188
               IMACH(13) = 8189
               IMACH(14) = 94
               IMACH(15) = -8141
               IMACH(16) = 8189
               GO TO 35
               END IF
            END IF
         IMACH( 1) = 5
         IMACH( 2) = 6
         IMACH( 3) = 7
         IMACH( 4) = 0
         IMACH( 5) = 32
         IMACH( 6) = 4
         IMACH( 7) = 2
         IMACH( 8) = 31
         IMACH( 9) = 2147483647
 35      SC = 987
         END IF
 9010 FORMAT(/' Adjust autodoubled I1MACH by uncommenting data'/
     * ' statements appropriate for your machine and setting'/
     * ' IMACH(I) = IMACH(I+3) for I = 11, 12, and 13.')
 9020 FORMAT(/' Adjust I1MACH by uncommenting data statements'/
     * ' appropriate for your machine.')
      IF (I .LT. 1  .OR.  I .GT. 16) GO TO 40
      I1MACH = IMACH(I)
      RETURN
 40   WRITE(*,*) 'I1MACH(I): I =',I,' is out of bounds.'
      STOP
* /* C source for I1MACH -- remove the * in column 1 */
* /* Note that some values may need changing. */
*#include <stdio.h>
*#include <float.h>
*#include <limits.h>
*#include <math.h>
*
*long i1mach_(long *i)
*{
*	switch(*i){
*	  case 1:  return 5;	/* standard input */
*	  case 2:  return 6;	/* standard output */
*	  case 3:  return 7;	/* standard punch */
*	  case 4:  return 0;	/* standard error */
*	  case 5:  return 32;	/* bits per integer */
*	  case 6:  return sizeof(int);
*	  case 7:  return 2;	/* base for integers */
*	  case 8:  return 31;	/* digits of integer base */
*	  case 9:  return LONG_MAX;
*	  case 10: return FLT_RADIX;
*	  case 11: return FLT_MANT_DIG;
*	  case 12: return FLT_MIN_EXP;
*	  case 13: return FLT_MAX_EXP;
*	  case 14: return DBL_MANT_DIG;
*	  case 15: return DBL_MIN_EXP;
*	  case 16: return DBL_MAX_EXP;
*	  }
*	fprintf(stderr, "invalid argument: i1mach(%ld)\n", *i);
*	exit(1);return 0; /* some compilers demand return values */
*}
      END
      SUBROUTINE I1MCR1(A, A1, B, C, D)
**** SPECIAL COMPUTATION FOR OLD CRAY MACHINES ****
      INTEGER A, A1, B, C, D
      A1 = 16777216*B + C
      A = 16777216*A1 + D
      END
C
C $Id: llmisc.f,v 1.1 2009-05-15 00:49:27 dbrown Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE SEBLDA
C
C Calling this do-nothing subroutine forces "ld" to load the following
C block data routine (but only if they are in the same ".f" file).
C
        RETURN
C
      END
CNOSPLIT
      BLOCKDATA SEBLDAX
C
C The common blocks SECOMI and SECOMC are used to hold shared variables
C of types INTEGER and CHARACTER, respectively, for the routine SETER
C and associated routines.  For descriptions of these variables and for
C default values of them, see the block data routine SEBLDAX.
C
        COMMON /SECOMI/ IERRU,IERRF,IRECF,LOMSG
        SAVE   /SECOMI/
C
        COMMON /SECOMC/ ERMSG
          CHARACTER*256 ERMSG
        SAVE   /SECOMC/
C
C IERRU is the logical unit for error messages.  Its default value is
C zero, which serves as a signal to SETER that the proper value should
C be gotten from I1MACH.
C
        DATA IERRU / 0 /
C
C IERRF is the error flag.  Initially, it is zero.  A non-zero value
C means that there is an uncleared prior error.
C
        DATA IERRF / 0 /
C
C IRECF is the recovery flag, which can have values of 1, which turns
C recovery mode on, or 2, which turns recovery mode off and causes all
C errors to be treated as fatal errors.  The latter is the default.
C
        DATA IRECF / 2 /
C
C LOMSG is the actual length of the error message in ERMSG.
C
        DATA LOMSG / 1 /
C
C ERMSG is the text of the current error message, only meaningful when
C IERRF is non-zero.
C
        DATA ERMSG / ' ' /
C
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C   FFTPACK 5.0
C   Copyright (C) 1995-2004, Scientific Computing Division,
C   University Corporation for Atmospheric Research
C   Licensed under the GNU General Public License (GPL)
C
C   Authors:  Paul N. Swarztrauber and Richard A. Valent
C
C   $Id: sinq1i.f,v 1.2 2006-11-21 01:10:19 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      SUBROUTINE DSINQ1I(N,WSAVE,LENSAV,IER)
      INTEGER N,LENSAV,IER
      DOUBLE PRECISION WSAVE(LENSAV)
C
      IER = 0
C
      IF (LENSAV.LT.2*N+INT(LOG(DBLE(N)))+4) THEN
          IER = 2
          CALL DXERFFT('SINQ1I',3)
          GO TO 300
      END IF
C
      CALL DCOSQ1I(N,WSAVE,LENSAV,IER1)
      IF (IER1.NE.0) THEN
          IER = 20
          CALL DXERFFT('SINQ1I',-5)
      END IF
  300 RETURN
      END

      SUBROUTINE DGGHRD( COMPQ, COMPZ, N, ILO, IHI, A, LDA, B, LDB, Q,
     $                   LDQ, Z, LDZ, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER          COMPQ, COMPZ
      INTEGER            IHI, ILO, INFO, LDA, LDB, LDQ, LDZ, N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), B( LDB, * ), Q( LDQ, * ),
     $                   Z( LDZ, * )
*     ..
*
*  Purpose
*  =======
*
*  DGGHRD reduces a pair of real matrices (A,B) to generalized upper
*  Hessenberg form using orthogonal transformations, where A is a
*  general matrix and B is upper triangular:  Q' * A * Z = H and
*  Q' * B * Z = T, where H is upper Hessenberg, T is upper triangular,
*  and Q and Z are orthogonal, and ' means transpose.
*
*  The orthogonal matrices Q and Z are determined as products of Givens
*  rotations.  They may either be formed explicitly, or they may be
*  postmultiplied into input matrices Q1 and Z1, so that
*
*       Q1 * A * Z1' = (Q1*Q) * H * (Z1*Z)'
*       Q1 * B * Z1' = (Q1*Q) * T * (Z1*Z)'
*
*  Arguments
*  =========
*
*  COMPQ   (input) CHARACTER*1
*          = 'N': do not compute Q;
*          = 'I': Q is initialized to the unit matrix, and the
*                 orthogonal matrix Q is returned;
*          = 'V': Q must contain an orthogonal matrix Q1 on entry,
*                 and the product Q1*Q is returned.
*
*  COMPZ   (input) CHARACTER*1
*          = 'N': do not compute Z;
*          = 'I': Z is initialized to the unit matrix, and the
*                 orthogonal matrix Z is returned;
*          = 'V': Z must contain an orthogonal matrix Z1 on entry,
*                 and the product Z1*Z is returned.
*
*  N       (input) INTEGER
*          The order of the matrices A and B.  N >= 0.
*
*  ILO     (input) INTEGER
*  IHI     (input) INTEGER
*          It is assumed that A is already upper triangular in rows and
*          columns 1:ILO-1 and IHI+1:N.  ILO and IHI are normally set
*          by a previous call to DGGBAL; otherwise they should be set
*          to 1 and N respectively.
*          1 <= ILO <= IHI <= N, if N > 0; ILO=1 and IHI=0, if N=0.
*
*  A       (input/output) DOUBLE PRECISION array, dimension (LDA, N)
*          On entry, the N-by-N general matrix to be reduced.
*          On exit, the upper triangle and the first subdiagonal of A
*          are overwritten with the upper Hessenberg matrix H, and the
*          rest is set to zero.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(1,N).
*
*  B       (input/output) DOUBLE PRECISION array, dimension (LDB, N)
*          On entry, the N-by-N upper triangular matrix B.
*          On exit, the upper triangular matrix T = Q' B Z.  The
*          elements below the diagonal are set to zero.
*
*  LDB     (input) INTEGER
*          The leading dimension of the array B.  LDB >= max(1,N).
*
*  Q       (input/output) DOUBLE PRECISION array, dimension (LDQ, N)
*          If COMPQ='N':  Q is not referenced.
*          If COMPQ='I':  on entry, Q need not be set, and on exit it
*                         contains the orthogonal matrix Q, where Q'
*                         is the product of the Givens transformations
*                         which are applied to A and B on the left.
*          If COMPQ='V':  on entry, Q must contain an orthogonal matrix
*                         Q1, and on exit this is overwritten by Q1*Q.
*
*  LDQ     (input) INTEGER
*          The leading dimension of the array Q.
*          LDQ >= N if COMPQ='V' or 'I'; LDQ >= 1 otherwise.
*
*  Z       (input/output) DOUBLE PRECISION array, dimension (LDZ, N)
*          If COMPZ='N':  Z is not referenced.
*          If COMPZ='I':  on entry, Z need not be set, and on exit it
*                         contains the orthogonal matrix Z, which is
*                         the product of the Givens transformations
*                         which are applied to A and B on the right.
*          If COMPZ='V':  on entry, Z must contain an orthogonal matrix
*                         Z1, and on exit this is overwritten by Z1*Z.
*
*  LDZ     (input) INTEGER
*          The leading dimension of the array Z.
*          LDZ >= N if COMPZ='V' or 'I'; LDZ >= 1 otherwise.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit.
*          < 0:  if INFO = -i, the i-th argument had an illegal value.
*
*  Further Details
*  ===============
*
*  This routine reduces A to Hessenberg and B to triangular form by
*  an unblocked reduction, as described in _Matrix_Computations_,
*  by Golub and Van Loan (Johns Hopkins Press.)
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ONE, ZERO
      PARAMETER          ( ONE = 1.0D+0, ZERO = 0.0D+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            ILQ, ILZ
      INTEGER            ICOMPQ, ICOMPZ, JCOL, JROW
      DOUBLE PRECISION   C, S, TEMP
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           DLARTG, DLASET, DROT, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX
*     ..
*     .. Executable Statements ..
*
*     Decode COMPQ
*
      IF( LSAME( COMPQ, 'N' ) ) THEN
         ILQ = .FALSE.
         ICOMPQ = 1
      ELSE IF( LSAME( COMPQ, 'V' ) ) THEN
         ILQ = .TRUE.
         ICOMPQ = 2
      ELSE IF( LSAME( COMPQ, 'I' ) ) THEN
         ILQ = .TRUE.
         ICOMPQ = 3
      ELSE
         ICOMPQ = 0
      END IF
*
*     Decode COMPZ
*
      IF( LSAME( COMPZ, 'N' ) ) THEN
         ILZ = .FALSE.
         ICOMPZ = 1
      ELSE IF( LSAME( COMPZ, 'V' ) ) THEN
         ILZ = .TRUE.
         ICOMPZ = 2
      ELSE IF( LSAME( COMPZ, 'I' ) ) THEN
         ILZ = .TRUE.
         ICOMPZ = 3
      ELSE
         ICOMPZ = 0
      END IF
*
*     Test the input parameters.
*
      INFO = 0
      IF( ICOMPQ.LE.0 ) THEN
         INFO = -1
      ELSE IF( ICOMPZ.LE.0 ) THEN
         INFO = -2
      ELSE IF( N.LT.0 ) THEN
         INFO = -3
      ELSE IF( ILO.LT.1 ) THEN
         INFO = -4
      ELSE IF( IHI.GT.N .OR. IHI.LT.ILO-1 ) THEN
         INFO = -5
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -7
      ELSE IF( LDB.LT.MAX( 1, N ) ) THEN
         INFO = -9
      ELSE IF( ( ILQ .AND. LDQ.LT.N ) .OR. LDQ.LT.1 ) THEN
         INFO = -11
      ELSE IF( ( ILZ .AND. LDZ.LT.N ) .OR. LDZ.LT.1 ) THEN
         INFO = -13
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DGGHRD', -INFO )
         RETURN
      END IF
*
*     Initialize Q and Z if desired.
*
      IF( ICOMPQ.EQ.3 )
     $   CALL DLASET( 'Full', N, N, ZERO, ONE, Q, LDQ )
      IF( ICOMPZ.EQ.3 )
     $   CALL DLASET( 'Full', N, N, ZERO, ONE, Z, LDZ )
*
*     Quick return if possible
*
      IF( N.LE.1 )
     $   RETURN
*
*     Zero out lower triangle of B
*
      DO 20 JCOL = 1, N - 1
         DO 10 JROW = JCOL + 1, N
            B( JROW, JCOL ) = ZERO
   10    CONTINUE
   20 CONTINUE
*
*     Reduce A and B
*
      DO 40 JCOL = ILO, IHI - 2
*
         DO 30 JROW = IHI, JCOL + 2, -1
*
*           Step 1: rotate rows JROW-1, JROW to kill A(JROW,JCOL)
*
            TEMP = A( JROW-1, JCOL )
            CALL DLARTG( TEMP, A( JROW, JCOL ), C, S,
     $                   A( JROW-1, JCOL ) )
            A( JROW, JCOL ) = ZERO
            CALL DROT( N-JCOL, A( JROW-1, JCOL+1 ), LDA,
     $                 A( JROW, JCOL+1 ), LDA, C, S )
            CALL DROT( N+2-JROW, B( JROW-1, JROW-1 ), LDB,
     $                 B( JROW, JROW-1 ), LDB, C, S )
            IF( ILQ )
     $         CALL DROT( N, Q( 1, JROW-1 ), 1, Q( 1, JROW ), 1, C, S )
*
*           Step 2: rotate columns JROW, JROW-1 to kill B(JROW,JROW-1)
*
            TEMP = B( JROW, JROW )
            CALL DLARTG( TEMP, B( JROW, JROW-1 ), C, S,
     $                   B( JROW, JROW ) )
            B( JROW, JROW-1 ) = ZERO
            CALL DROT( IHI, A( 1, JROW ), 1, A( 1, JROW-1 ), 1, C, S )
            CALL DROT( JROW-1, B( 1, JROW ), 1, B( 1, JROW-1 ), 1, C,
     $                 S )
            IF( ILZ )
     $         CALL DROT( N, Z( 1, JROW ), 1, Z( 1, JROW-1 ), 1, C, S )
   30    CONTINUE
   40 CONTINUE
*
      RETURN
*
*     End of DGGHRD
*
      END

        PROGRAM CPEX02
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
        PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Declare an array to hold the data to be contoured.
C
        DIMENSION ZDAT(33,33)
C
C Declare the required real and integer workspaces.
C
        DIMENSION RWRK(5000),IWRK(1000)
C
C Declare an array to hold an area map.
C
        DIMENSION IAMA(20000)
C
C Declare the arrays needed by ARSCAM for x/y coordinates.
C
        DIMENSION XCRA(1000),YCRA(1000)
C
C Declare the arrays needed by ARSCAM for area and group identifiers.
C
        DIMENSION IARA(10),IGRA(10)
C
C Declare an array to hold the GKS "aspect source flags".
C
        DIMENSION IASF(13)
C
C Declare the routine which will draw contour lines, avoiding labels.
C
        EXTERNAL DRAWCL
C
C Declare the routine which does the shading.
C
        EXTERNAL SHADER
C
C Dimension a character variable to hold plot labels.
C
        CHARACTER*11 LABL
C
C Initialize the values in the aspect-source-flag array.
C
        DATA IASF / 13*1 /
C
C Open GKS.
C
        CALL GOPKS (IERRF, ISZDM)
        CALL GOPWK (IWKID, LUNIT, IWTYPE)
        CALL GACWK (IWKID)
C
C Turn off the clipping indicator.
C
        CALL GSCLIP (0)
C
C Set all the GKS aspect source flags to "individual".
C
        CALL GSASF (IASF)
C
C Turn on the drawing of the grid edge ("contour line number -1") and
C thicken it somewhat.
C
        CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',-1)
        CALL CPSETI ('CLU - CONTOUR LEVEL USE FLAG',1)
        CALL CPSETR ('CLL - CONTOUR LEVEL LINE WIDTH',2.)
C
C Turn on the positioning of labels by the penalty scheme and provide a
C little more room for X and Y coordinates defining contour lines, so
C as not to have labels right next to each other on a contour line.
C
        CALL CPSETI ('LLP - LINE LABEL POSITIONING',3)
        CALL CPSETI ('RWC - REAL WORKSPACE FOR CONTOURS',200)
C
C Turn on the drawing of the high and low label boxes.
C
        CALL CPSETI ('HLB - HIGH/LOW LABEL BOX FLAG',1)
C
C Tell CONPACK to delete high/low labels which overlap the informational
C label or another high/low label, but to move those which overlap the
C edge inward a little.
C
        CALL CPSETI ('HLO - HIGH/LOW LABEL OVERLAP FLAG',11)
C
C Make all CONPACK-written characters a little bigger.
C
        CALL CPSETR ('CWM - CHARACTER WIDTH MULTIPLIER',1.25)
C
C Move the informational label into the lower left-hand corner and
C turn on the box around it, making the box thicker than normal.
C
        CALL CPSETR ('ILX - INFORMATIONAL LABEL X POSITION',.02)
        CALL CPSETR ('ILY - INFORMATIONAL LABEL Y POSITION',.02)
        CALL CPSETI ('ILP - INFORMATIONAL LABEL POSIIONING',-4)
        CALL CPSETI ('ILB - INFORMATIONAL LABEL BOX',1)
        CALL CPSETR ('ILL - INFORMATIONAL LABEL LINE WIDTH',2.)
C
C Change the text of the informational label.
C
        CALL CPSETC ('ILT - INFORMATIONAL LABEL TEXT',
     +               'CONTOUR FROM $CMN$ TO $CMX$ BY $CIU$ (X $SFU$)')
C
C Do four different plots, one in each quadrant.
C
        DO 102 IPLT=1,4
C
C Generate an array of test data.
C
          CALL GENDAT (ZDAT,33,33,33,20,20,.000025,.000075)
C
C Move the viewport to the proper quadrant.
C
          CALL CPSETR ('VPL - VIEWPORT LEFT EDGE',
     +                 .0250+.4875*REAL(MOD(IPLT-1,2)))
          CALL CPSETR ('VPR - VIEWPORT RIGHT EDGE',
     +                 .4875+.4875*REAL(MOD(IPLT-1,2)))
          CALL CPSETR ('VPB - VIEWPORT BOTTOM EDGE',
     +                 .0250+.4875*REAL((4-IPLT)/2))
          CALL CPSETR ('VPT - VIEWPORT TOP EDGE',
     +                 .4875+.4875*REAL((4-IPLT)/2))
C
C Specify how the scale factor is to be selected.
C
          CALL CPSETI ('SFS - SCALE FACTOR SELECTION',-IPLT)
C
C Initialize the drawing of the contour plot.
C
          CALL CPRECT (ZDAT,33,33,33,RWRK,5000,IWRK,1000)
C
C Force the selection of contour levels, so that associated quantities
C may be tweaked.
C
          CALL CPPKCL (ZDAT,RWRK,IWRK)
C
C Increase the line width for labelled levels and turn off the area
C identifiers for all levels.
C
          CALL CPGETI ('NCL - NUMBER OF CONTOUR LEVELS',NCLV)
C
          DO 101 ICLV=1,NCLV
            CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',ICLV)
            CALL CPGETI ('CLU - CONTOUR LEVEL USE FLAG',ICLU)
            IF (ICLU.EQ.3) THEN
              CALL CPSETI ('CLL - CONTOUR-LINE LINE WIDTH',2)
            END IF
            CALL CPSETI ('AIA - AREA IDENTIFIER ABOVE LEVEL',0)
            CALL CPSETI ('AIB - AREA IDENTIFIER BELOW LEVEL',0)
  101     CONTINUE
C
C Add two new levels for which no contour lines are to be drawn, but
C between which shading is to be done.
C
          NCLV=NCLV+2
          CALL CPSETI ('NCL - NUMBER OF CONTOUR LEVELS',NCLV)
C
          CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',NCLV-1)
          CALL CPSETR ('CLV - CONTOUR LEVEL VALUE',.000045)
          CALL CPSETI ('CLU - CONTOUR LEVEL USE FLAG',0)
          CALL CPSETI ('AIA - AREA IDENTIFIER ABOVE LEVEL',1)
          CALL CPSETI ('AIB - AREA IDENTIFIER BELOW LEVEL',2)
          CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',NCLV)
          CALL CPSETR ('CLV - CONTOUR LEVEL VALUE',.000055)
          CALL CPSETI ('CLU - CONTOUR LEVEL USE FLAG',0)
          CALL CPSETI ('AIA - AREA IDENTIFIER ABOVE LEVEL',3)
          CALL CPSETI ('AIB - AREA IDENTIFIER BELOW LEVEL',1)
C
C Draw the contour plot.
C
          CALL ARINAM (IAMA,20000)
          CALL CPLBAM (ZDAT,RWRK,IWRK,IAMA)
          CALL CPCLDM (ZDAT,RWRK,IWRK,IAMA,DRAWCL)
          CALL CPLBDR (ZDAT,RWRK,IWRK)
          CALL CPCLAM (ZDAT,RWRK,IWRK,IAMA)
          CALL ARSCAM (IAMA,XCRA,YCRA,1000,IARA,IGRA,10,SHADER)
C
C Compute and print statistics for the plot and label it.
C
          LABL='EXAMPLE 2-'//CHAR(ICHAR('0')+IPLT)
          CALL CAPSAP (LABL,IAMA,20000)
          CALL LABTOP (LABL,.017)
C
  102   CONTINUE
C
C Put a boundary line at the edge of the plotter frame.
C
        CALL BNDARY
C
C Advance the frame.
C
        CALL FRAME
C
C Close GKS.
C
        CALL GDAWK (IWKID)
        CALL GCLWK (IWKID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END


      SUBROUTINE DRAWCL (XCS,YCS,NCS,IAI,IAG,NAI)
C
C This version of DRAWCL draws the polyline defined by the points
C ((XCS(I),YCS(I)),I=1,NCS) if and only if none of the area identifiers
C for the area containing the polyline are negative.  The dash package
C routine CURVED is called to do the drawing.
C
        DIMENSION XCS(*),YCS(*),IAI(*),IAG(*)
C
C Turn on drawing.
C
        IDR=1
C
C If any area identifier is negative, turn off drawing.
C
        DO 101 I=1,NAI
          IF (IAI(I).LT.0) IDR=0
  101   CONTINUE
C
C If drawing is turned on, draw the polyline.
C
        IF (IDR.NE.0) CALL CURVED (XCS,YCS,NCS)
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE SHADER (XCS,YCS,NCS,IAI,IAG,NAI)
C
C This version of SHADER shades the polygon whose edge is defined by
C the points ((XCS(I),YCS(I)),I=1,NCS) if and only, relative to edge
C group 3, its area identifier is a 1.  The package SOFTFILL is used
C to do the shading.
C
        DIMENSION XCS(*),YCS(*),IAI(*),IAG(*)
C
C Define workspaces for the shading routine.
C
        DIMENSION DST(1100),IND(1200)
C
C Turn off shading.
C
        ISH=0
C
C If the area identifier for group 3 is a 1, turn on shading.
C
        DO 101 I=1,NAI
          IF (IAG(I).EQ.3.AND.IAI(I).EQ.1) ISH=1
  101   CONTINUE
C
C If shading is turned on, shade the area.  The last point of the
C edge is redundant and may be omitted.
C
        IF (ISH.NE.0) THEN
          CALL SFSETI ('ANGLE',45)
          CALL SFSETR ('SPACING',.006)
          CALL SFWRLD (XCS,YCS,NCS-1,DST,1100,IND,1200)
          CALL SFSETI ('ANGLE',135)
          CALL SFNORM (XCS,YCS,NCS-1,DST,1100,IND,1200)
        END IF
C
C Done.
C
        RETURN
C
      END

C
C $Id: dpdpws.f,v 1.3 2008-07-27 00:16:58 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE DPDPWS (DPCH,DSYM,DPAT)
C
        CHARACTER*(*) DPCH,DSYM,DPAT
C
C This routine is called with three character strings of the same
C length: the input string DPCH is a basic dash pattern, to be used
C with DASHPACK, containing some characters that are to be treated
C as symbol generators; the input string DSYM contains characters
C other than blanks or minus signs in the positions corresponding to
C characters of DPCH that are to be treated as symbol generators; and
C the output string DPAT is the appropriate character string to be
C input to DASHPACK by a call to DPSETC.
C
C For example, to get a dash pattern specifying alternate solid-line
C segments and filled circles, use this:
C
C   DPCH: '$0'  !  (The '$' means "solid"; the '0' selects a symbol.)
C   DSYM: ' #'  !  (Use any character but ' ' or '-' in lieu of '#'.)
C
C To get a dash pattern specifying a solid section, the characters
C "I=1", another solid section, and a hollow-circle symbol, use this:
C
C   DPCH: '$$$I|=|1$$$5'  !  (A final '5' selects the desired symbol.)
C   DSYM: '-----------+'  !  (A plus sign marks the symbol position.)
C
C (Note the use of break characters - '|' - in the character string to
C allow the string to be written bending with a curve being drawn.)
C
C By default, symbol-selection characters which may be used include
C the following:
C
C   0 => filled circle         5 => hollow circle
C   1 => filled square         6 => hollow square
C   2 => filled triangle       7 => hollow triangle
C   3 => filled diamond        8 => hollow diamond
C   4 => filled star           9 => hollow star
C
C See also the DASHPACK routine DPDSYM; it actually draws the symbols
C and may be replaced by a user to draw a different set.
C
        LPAT=LEN(DPAT)
C
        DO 101 I=1,LPAT
          IF (DSYM(I:I).EQ.' '.OR.DSYM(I:I).EQ.'-') THEN
            DPAT(I:I)=DPCH(I:I)
          ELSE
            DPAT(I:I)=CHAR(IOR(ICHAR(DPCH(I:I)),128))
          END IF
  101   CONTINUE
C
        RETURN
C
      END

C
C       $Id: shstore3.f,v 1.6 2008-07-27 03:10:14 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE SHSTORE3 (N,X,Y,Z,NR, LCELL,LNEXT,XYZMIN,
     +                    XYZDEL,IER)
      INTEGER N, NR, LCELL(NR,NR,NR), LNEXT(N), IER
      REAL    X(N), Y(N), Z(N), XYZMIN(3), XYZDEL(3)
C
C***********************************************************
C
C                                               ROBERT RENKA
C                                       UNIV. OF NORTH TEXAS
C                                             (817) 565-2767
C
C  Given a set of N arbitrarily distributed nodes in three-
C  space, this subroutine creates a data structure for a
C  cell-based method of solving closest-point problems.  The
C  smallest box containing the nodes is partitioned into an
C  NR by NR by NR uniform grid of cells, and nodes are as-
C  sociated with cells.  In particular, the data structure
C  stores the indices of the nodes contained in each cell.
C  For a uniform random distribution of nodes, the nearest
C  node to an arbitrary point can be determined in constant
C  expected time.
C
C  ON INPUT --
C
C    N = number of nodes.  N .GE. 2.
C
C    X,Y,Z = arrays of length N containing the Cartesian
C            coordinates of the nodes.
C
C    NR = number of rows, columns, and planes in the
C         grid.  The cell density (average number of
C         nodes per cell) is D = N/(NR**3).  A recommended
C         value, based on empirical evidence, is D = 3
C         -- NR = (N/3)**(1/3).  NR .GE. 1.
C
C  The above parameters are not altered by this routine.
C
C    LCELL = array of length .GE. NR**3.
C
C    LNEXT = array of length .GE. N.
C
C    XYZMIN,XYZDEL = arrays of length .GE. 3.
C
C  ON OUTPUT --
C
C    LCELL = NR by NR by NR cell array such that
C            LCELL(I,J,K) contains the index (for X, Y,
C            and Z) of the first node (node with smallest
C            index) in cell (I,J,K), or LCELL(I,J,K) = 0
C            If no nodes are contained in the cell.  The
C            corner of cell (I,J,K) which is farthest
C            from the box corner defined by XYZMIN has
C            coordinates (XMIN+I*DX,YMIN+J*DY,ZMIN+K*DZ),
C            where (XMIN,YMIN,ZMIN) are the elements of
C            XYZMIN.  LCELL is not defined if IER .NE. 0.
C
C    LNEXT = Array of next-node indices such that
C            LNEXT(L) contains the index of the next node
C            in the cell which contains node L, or
C            LNEXT(L) = L if L is the last node in the
C            cell for L = 1,...,N.  (The nodes contained
C            in a cell are ordered by their indices.)
C            If, for example, cell (I,J,K) contains nodes
C            2, 3, and 5 (and no others), then
C            LCELL(I,J,K) = 2, LNEXT(2) = 3, LNEXT(3) =
C            5, and LNEXT(5) = 5.  LNEXT is not defined
C            if IER .NE. 0.
C
C    XYZMIN = Array of length 3 containing the minimum
C             nodal coordinates XMIN, YMIN, and ZMIN (in
C             that order) unless IER = 1.  The opposite
C             corner of the box defined by the nodes is
C             (XMIN+NR*DX,YMIN+NR*DY,ZMIN+NR*DZ).
C
C    XYZDEL = Array of length 3 containing the dimensions
C             of the cells unless IER = 1.  XYZDEL(1) =
C             (XMAX-XMIN)/NR, XYZDEL(2) = (YMAX-YMIN)/NR,
C             AND XYZDEL(3) = (ZMAX-ZMIN)/NR, where XMIN,
C             XMAX, YMIN, YMAX, ZMIN, and ZMAX are the
C             extrema of X, Y, and Z.
C
C    IER = Error indicator --
C          IER = 0 if no errors were encountered.
C          IER = 1 if N .LT. 2 or NR .LT. 1.
C          IER = 2 if a component of XYZDEL is not positive.
C
C  MODULES REQUIRED BY SHSTORE3 -- NONE
C
C  INTRINSIC FUNCTIONS CALLED BY SHSTORE3 -- FLOAT, IFIX
C
C***********************************************************
C
      NN = N
      NNR = NR
      IF (NN .LT. 2  .OR.  NNR .LT. 1) GO TO 4
C
C  Compute the dimensions of the rectangle containing the nodes.
C
      XMN = X(1)
      XMX = XMN
      YMN = Y(1)
      YMX = YMN
      ZMN = Z(1)
      ZMX = ZMN
      DO 1 L = 2,NN
        IF (X(L) .LT. XMN) XMN = X(L)
        IF (X(L) .GT. XMX) XMX = X(L)
        IF (Y(L) .LT. YMN) YMN = Y(L)
        IF (Y(L) .GT. YMX) YMX = Y(L)
        IF (Z(L) .LT. ZMN) ZMN = Z(L)
        IF (Z(L) .GT. ZMX) ZMX = Z(L)
    1 CONTINUE
      XYZMIN(1) = XMN
      XYZMIN(2) = YMN
      XYZMIN(3) = ZMN
C
C  Compute cell dimensions and test for zero area.
C
      DELX = (XMX-XMN)/FLOAT(NNR)
      DELY = (YMX-YMN)/FLOAT(NNR)
      DELZ = (ZMX-ZMN)/FLOAT(NNR)
      XYZDEL(1) = DELX
      XYZDEL(2) = DELY
      XYZDEL(3) = DELZ
      IF (DELX .EQ. 0.  .OR.  DELY .EQ. 0.  .OR.
     +    DELZ .EQ. 0.) GO TO 5
C
C INITIALIZE LCELL.
C
      DO 7 K = 1,NNR
        DO 6 J = 1,NNR
          DO 2 I = 1,NNR
            LCELL(I,J,K) = 0
    2     CONTINUE
    6   CONTINUE
    7 CONTINUE
C
C  Loop on nodes, storing indices in LCELL and LNEXT.
C
      NP1 = NN + 1
      DO 3 LL = 1,NN
        LB = NP1 - LL
        I = IFIX((X(LB)-XMN)/DELX) + 1
        IF (I .GT. NNR) I = NNR
        J = IFIX((Y(LB)-YMN)/DELY) + 1
        IF (J .GT. NNR) J = NNR
        K = IFIX((Z(LB)-ZMN)/DELZ) + 1
        IF (K .GT. NNR) K = NNR
        L = LCELL(I,J,K)
        LNEXT(LB) = L
        IF (L .EQ. 0) LNEXT(LB) = LB
        LCELL(I,J,K) = LB
    3 CONTINUE
C
C  No errors encountered.
C
      IER = 0
      RETURN
C
C  Invalid input parameter.
C
    4 CONTINUE
      CALL SHERR (1,'SHSTORE3 - number of input data must be > 9',41)
      IER = 1
      RETURN
C
C  Nonpositive XYZDEL component.
C
    5 CONTINUE
      CALL SHERR (7,
     +            'SHSTORE3 - cell grid dimensions must be positive',
     +             48)
      IER = 7
      RETURN
      END

C
C	$Id: cappar.f,v 1.4 2008-07-27 12:23:43 haley Exp $
C                                                                      
C			     Copyright (C)  1997
C	     University Corporation for Atmospheric Research
C			     All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C

      SUBROUTINE CAPPAR (IOS, STATUS)
C
C  This subroutine calls  MTCHIT  to parse keywords and then
C  invokes the appropriate subroutines to process various
C  classes.
C
C  OUTPUT
C       IOS    -  The I/O status flag.  This flag is valid only
C                 if the output variable STATUS indicates an error.
C       STATUS -  The error status:  = 0 - All OK.
C                                    = 1 - END OF FILE
C                                    > 1 - Error as defined in the CAPERR
C                                          COMMON block.
C
      COMMON /CAPERR/ ALLOK, EOFFL, INTERR, MAXINT, PLBERR, PMBERR,
     1                FABERR, TXBERR, FLTERR, MAXFLT, NOTINT, SIZERR,
     2                UNDASC, DEVERR, DOCERR, TBLERR , STSZER, ENTERR,
     3                TABERR, TABSER, PRSFIL
      INTEGER ALLOK, EOFFL, INTERR, MAXINT, PLBERR, PMBERR,
     1        FABERR, TXBERR, FLTERR, MAXFLT, NOTINT, SIZERR, UNDASC,
     2        DEVERR, DOCERR, STSZER, ENTERR, TABERR, TABSER, TBLERR,
     3        PRSFIL
      COMMON /CAPIOB/ UNIT, IPTR, LSIZE, NFST, NFLG
      COMMON /CAPIO2/ LINE, GRNM
      INTEGER LNMAX
      PARAMETER (LNMAX=80)
      CHARACTER*80 LINE
      CHARACTER*80 GRNM
      INTEGER UNIT, IPTR, LSIZE, NFST, NFLG
      COMMON /CAPUSR/ UPRSTR, UPRSIZ
      INTEGER    UPRMAX
      PARAMETER (UPRMAX=80)
      INTEGER    UPRSTR(UPRMAX), UPRSIZ
      INTEGER    LENUSR
      PARAMETER (LENUSR=UPRMAX+1)
      COMMON /PARTB1/ PART1, KEYSEP, KEYTER, FRMCOM
      COMMON /PARTB2/ PART2, PART3, PART4, PART5, CTSTR, CTLOC
C
C  THE NUMBER OF WORDS IN THE SEARCH PATH MUST BE BIG ENOUGH TO HOLD
C       THE NUMBER OF BITS PER PATH TIMES THE NUMBER OF LEVELS
C
      INTEGER WHSIZE
      PARAMETER (WHSIZE=20)
C
      INTEGER PARTSZ, OTHSZ, NTABLE
      PARAMETER(PARTSZ=3000, OTHSZ=150, NTABLE=50)
      CHARACTER*1 KEYSEP,KEYTER
      CHARACTER*1 FRMCOM(2)
      INTEGER PART2(OTHSZ), PART3(OTHSZ), PART4(NTABLE), PART5(NTABLE*2)
      CHARACTER*1 PART1(PARTSZ)
      INTEGER CTSTR, CTLOC
      COMMON /CAPSPC/ DUMSPC,ENDDSP
      INTEGER     DUMSIZ,DUMSM1
      PARAMETER (DUMSIZ=327, DUMSM1=DUMSIZ-1)
      INTEGER     DUMSPC(DUMSM1),ENDDSP
C
      INTEGER IOS, STATUS
      INTEGER WHICH(WHSIZE), ROW
C
C  Get the first line of the file.
C
      CALL RDLINE(IOS, STATUS)
      IF (STATUS.NE.ALLOK) RETURN
C
C  Continue processing, look for the next keyword.
C
 1    CONTINUE
      CALL SKPBLK(IOS, STATUS)
      IF (STATUS.NE.ALLOK) RETURN
C
C  Locate the keyword segment and store the encoded path
C  in WHICH.
C
      CALL MTCHIT (WHICH, IOS, STATUS)
      IF (STATUS.NE.ALLOK) RETURN
C
C  If there was no match, get a new line.
C
      IF (WHICH(1) .EQ. 0) GO TO 1
C
C  Set ROW to the level one command flag.
C
      ROW = WHICH(1)
C
C  Branch to the proper class processor.
C
      GO TO (100,200,300,400,500,600,700,800,900),ROW
C
C  DEVICE class processing.
C
 100  CONTINUE
      CALL DEVCLS(WHICH, IOS, STATUS)
      GO TO 9000
C
C  LINE class processing.
C
 200  CONTINUE
      CALL LINCLS(WHICH, IOS, STATUS)
      GO TO 9000
C
C  USER Class processing, get the user prompt.
C
 300  CONTINUE
      CALL GTSTR(UPRSTR, UPRMAX, UPRSIZ, IOS, STATUS)
      GO TO 9000
C
C  BUNDLE class processing.
C
 400  CONTINUE
      CALL BNDCLS(WHICH, IOS, STATUS)
      GO TO 9000
C
C  TEXT class processing.
C
 500  CONTINUE
      CALL TXTCLS(WHICH, IOS, STATUS)
      GO TO 9000
C
C  MARKER class processing.
C
 600  CONTINUE
      CALL MARCLS(WHICH, IOS, STATUS)
      GO TO 9000
C
C  POLYGON class processing.
C
 700  CONTINUE
      CALL PLGCLS(WHICH, IOS, STATUS)
C
C  DASH class processing.
C
 800  CONTINUE
      CALL DASCLS(WHICH, IOS, STATUS)
      GO TO 9000
C
C  RASTER class processing.
C
 900  CONTINUE
      CALL RASCLS(WHICH, IOS, STATUS)
      GO TO 9000
C
C  Class processing over, check STATUS.
C
 9000 CONTINUE
      IF (STATUS .NE. ALLOK) RETURN
C
C  Go back and start the scan again.
C
      GO TO 1
C
      END

C
C	$Id: wmlabc.f,v 1.6 2008-07-27 00:17:36 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE WMLABC(X,Y,CITY,TEMPS) 
C
C  Plot the city name in CITY and the daily temperatures
C  in TEMPS in two lines, all centered at (X,Y).  The
C  text will be surrounded with a box in the background
C  color.
C
      include 'wmcomn.h'
C
      CHARACTER*(*) CITY,TEMPS
C
C  Save the current line and fill colors and set them to ICOLOR.
C
      CALL GQFAIS(IER,IFAISO)
      CALL GQFACI(IER,IFCLRO)
      CALL GQPLCI(IER,ILCLRO)
      CALL GSFACI(ICOLOR)
      CALL GSPLCI(ICOLOR)
      CALL GSFAIS(1)
C
C  Convert X and Y to NDC and work in NDC space.
C
      CALL WMW2NX(1,X,XNDC)
      CALL WMW2NY(1,Y,YNDC)
      CALL GQCNTN(IER,NTRO)
      CALL GSELNT(0)
C
      SIZEL = WSIZEC
C
C  Save Plotchar parameters.
C
      CALL PCGETI ('FN - font name',IFNO)
C
C  Draw the city label and daily hi/lows.
C
      GAP = .9*SIZEL
      CALL PCSETI ('FN - font name',22)
C
      CALL WMGETI ('RBS',IRBSO)
      CALL WMGETI ('RLS',IRLSO)
      CALL WMGETI ('ROS',IROSO)
C
      CALL WMSETI ('RBS',IBGCTY)
      CALL WMSETI ('RLS',-1)
      CALL WMSETI ('ROS',-1)
C
      CALL WMCHBG (XNDC,YNDC+0.5*(GAP+SIZEL),CITY,SIZEL)
      CALL WMCHBG (XNDC,YNDC-0.5*(GAP+SIZEL),TEMPS,0.9*SIZEL)
      CALL WMSETI ('RBS',IRBSO)
      CALL WMSETI ('RLS',IRLSO)
      CALL WMSETI ('ROS',IROSO)
C
C  Restore Plotchar parameters.
C
      CALL PCSETI ('FN',IFNO)
C
C  Restore GKS environment.
C
      CALL GSFAIS(IFAISO)
      CALL GSFACI(IFCLRO)
      CALL GSPLCI(ILCLRO)
      CALL GSELNT(NTRO)
C
      RETURN
      END

      SUBROUTINE ZLAQSP( UPLO, N, AP, S, SCOND, AMAX, EQUED )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     February 29, 1992
*
*     .. Scalar Arguments ..
      CHARACTER          EQUED, UPLO
      INTEGER            N
      DOUBLE PRECISION   AMAX, SCOND
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   S( * )
      COMPLEX*16         AP( * )
*     ..
*
*  Purpose
*  =======
*
*  ZLAQSP equilibrates a symmetric matrix A using the scaling factors
*  in the vector S.
*
*  Arguments
*  =========
*
*  UPLO    (input) CHARACTER*1
*          Specifies whether the upper or lower triangular part of the
*          symmetric matrix A is stored.
*          = 'U':  Upper triangular
*          = 'L':  Lower triangular
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  AP      (input/output) COMPLEX*16 array, dimension (N*(N+1)/2)
*          On entry, the upper or lower triangle of the symmetric matrix
*          A, packed columnwise in a linear array.  The j-th column of A
*          is stored in the array AP as follows:
*          if UPLO = 'U', AP(i + (j-1)*j/2) = A(i,j) for 1<=i<=j;
*          if UPLO = 'L', AP(i + (j-1)*(2n-j)/2) = A(i,j) for j<=i<=n.
*
*          On exit, the equilibrated matrix:  diag(S) * A * diag(S), in
*          the same storage format as A.
*
*  S       (input) DOUBLE PRECISION array, dimension (N)
*          The scale factors for A.
*
*  SCOND   (input) DOUBLE PRECISION
*          Ratio of the smallest S(i) to the largest S(i).
*
*  AMAX    (input) DOUBLE PRECISION
*          Absolute value of largest matrix entry.
*
*  EQUED   (output) CHARACTER*1
*          Specifies whether or not equilibration was done.
*          = 'N':  No equilibration.
*          = 'Y':  Equilibration was done, i.e., A has been replaced by
*                  diag(S) * A * diag(S).
*
*  Internal Parameters
*  ===================
*
*  THRESH is a threshold value used to decide if scaling should be done
*  based on the ratio of the scaling factors.  If SCOND < THRESH,
*  scaling is done.
*
*  LARGE and SMALL are threshold values used to decide if scaling should
*  be done based on the absolute size of the largest matrix element.
*  If AMAX > LARGE or AMAX < SMALL, scaling is done.
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ONE, THRESH
      PARAMETER          ( ONE = 1.0D+0, THRESH = 0.1D+0 )
*     ..
*     .. Local Scalars ..
      INTEGER            I, J, JC
      DOUBLE PRECISION   CJ, LARGE, SMALL
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      DOUBLE PRECISION   DLAMCH
      EXTERNAL           LSAME, DLAMCH
*     ..
*     .. Executable Statements ..
*
*     Quick return if possible
*
      IF( N.LE.0 ) THEN
         EQUED = 'N'
         RETURN
      END IF
*
*     Initialize LARGE and SMALL.
*
      SMALL = DLAMCH( 'Safe minimum' ) / DLAMCH( 'Precision' )
      LARGE = ONE / SMALL
*
      IF( SCOND.GE.THRESH .AND. AMAX.GE.SMALL .AND. AMAX.LE.LARGE ) THEN
*
*        No equilibration
*
         EQUED = 'N'
      ELSE
*
*        Replace A by diag(S) * A * diag(S).
*
         IF( LSAME( UPLO, 'U' ) ) THEN
*
*           Upper triangle of A is stored.
*
            JC = 1
            DO 20 J = 1, N
               CJ = S( J )
               DO 10 I = 1, J
                  AP( JC+I-1 ) = CJ*S( I )*AP( JC+I-1 )
   10          CONTINUE
               JC = JC + J
   20       CONTINUE
         ELSE
*
*           Lower triangle of A is stored.
*
            JC = 1
            DO 40 J = 1, N
               CJ = S( J )
               DO 30 I = J, N
                  AP( JC+I-J ) = CJ*S( I )*AP( JC+I-J )
   30          CONTINUE
               JC = JC + N - J + 1
   40       CONTINUE
         END IF
         EQUED = 'Y'
      END IF
*
      RETURN
*
*     End of ZLAQSP
*
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C   FFTPACK 5.0
C   Copyright (C) 1995-2004, Scientific Computing Division,
C   University Corporation for Atmospheric Research
C   Licensed under the GNU General Public License (GPL)
C
C   Authors:  Paul N. Swarztrauber and Richard A. Valent
C
C   $Id: mrfti1.f,v 1.2 2006-11-21 01:10:18 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      SUBROUTINE DMRFTI1(N,WA,FAC)
      DOUBLE PRECISION FI
      DOUBLE PRECISION WA(N),FAC(15)
      INTEGER NTRYH(4)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION TPI,ARGH,ARGLD,ARG
      DATA NTRYH(1),NTRYH(2),NTRYH(3),NTRYH(4)/4,2,3,5/
C
      NL = N
      NF = 0
      J = 0
  101 J = J + 1
      IF (J-4) 102,102,103
  102 NTRY = NTRYH(J)
      GO TO 104
  103 NTRY = NTRY + 2
  104 NQ = NL/NTRY
      NR = NL - NTRY*NQ
      IF (NR) 101,105,101
  105 NF = NF + 1
      FAC(NF+2) = NTRY
      NL = NQ
      IF (NTRY.NE.2) GO TO 107
      IF (NF.EQ.1) GO TO 107
      DO 106 I = 2,NF
          IB = NF - I + 2
          FAC(IB+2) = FAC(IB+1)
  106 CONTINUE
      FAC(3) = 2
  107 IF (NL.NE.1) GO TO 104
      FAC(1) = N
      FAC(2) = NF
C*PT*WARNING* Constant already double-precision
C*PT*WARNING* Constant already double-precision
      TPI = 8.D0*DATAN(1.D0)
      ARGH = TPI/DBLE(N)
      IS = 0
      NFM1 = NF - 1
      L1 = 1
      IF (NFM1.EQ.0) RETURN
      DO 110 K1 = 1,NFM1
          IP = FAC(K1+2)
          LD = 0
          L2 = L1*IP
          IDO = N/L2
          IPM = IP - 1
          DO 109 J = 1,IPM
              LD = LD + L1
              I = IS
              ARGLD = DBLE(LD)*ARGH
              FI = 0.D0
              DO 108 II = 3,IDO,2
                  I = I + 2
                  FI = FI + 1.D0
                  ARG = FI*ARGLD
                  WA(I-1) = DCOS(ARG)
                  WA(I) = DSIN(ARG)
  108         CONTINUE
              IS = IS + IDO
  109     CONTINUE
          L1 = L2
  110 CONTINUE
      RETURN
      END

c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by UCAR                 .
c  .                                                             .
c  .       University Corporation for Atmospheric Research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                         SPHEREPACK                          .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c
c
c ... file igradec.f
c
c     this file includes documentation and code for
c     subroutine igradec         i
c
c ... files which must be loaded with igradec.f
c
c     sphcom.f, hrfft.f, shsec.f,vhaec.f
c
c     subroutine igradec(nlat,nlon,isym,nt,sf,isf,jsf,br,bi,mdb,ndb,
c    +                   wshsec,lshsec,work,lwork,ierror)
c
c     let br,bi,cr,ci be the vector spherical harmonic coefficients
c     precomputed by vhaec for a vector field (v,w).  let (v',w') be
c     the irrotational component of (v,w) (i.e., (v',w') is generated
c     by assuming cr,ci are zero and synthesizing br,bi with vhsec).
c     then subroutine igradec computes a scalar field sf such that
c
c            gradient(sf) = (v',w').
c
c     i.e.,
c
C*PL*ERROR* Comment line too long
c            v'(i,j) = d(sf(i,j))/dtheta          (colatitudinal component of
c                                                 the gradient)
c     and
c
C*PL*ERROR* Comment line too long
c            w'(i,j) = 1/sint*d(sf(i,j))/dlambda  (east longitudinal component
c                                                 of the gradient)
c
c     at colatitude
c
c            theta(i) = (i-1)*pi/(nlat-1)
c
c     and longitude
c
c            lambda(j) = (j-1)*2*pi/nlon
c
C*PL*ERROR* Comment line too long
c     where sint = sin(theta(i)).  required associated legendre polynomials
C*PL*ERROR* Comment line too long
c     are recomputed rather than stored as they are in subroutine igrades. this
c     saves storage (compare lshsec and lshses in igrades) but increases
c     computational requirements.
c
c     note:  for an irrotational vector field (v,w), subroutine igradec
c     computes a scalar field whose gradient is (v,w).  in ay case,
c     subroutine igradec "inverts" the gradient subroutine gradec.
c
c
c     input parameters
c
c     nlat   the number of colatitudes on the full sphere including the
c            poles. for example, nlat = 37 for a five degree grid.
c            nlat determines the grid increment in colatitude as
c            pi/(nlat-1).  if nlat is odd the equator is located at
c            grid point i=(nlat+1)/2. if nlat is even the equator is
c            located half way between points i=nlat/2 and i=nlat/2+1.
c            nlat must be at least 3. note: on the half sphere, the
c            number of grid points in the colatitudinal direction is
c            nlat/2 if nlat is even or (nlat+1)/2 if nlat is odd.
c
c     nlon   the number of distinct londitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater than
c            3.  the efficiency of the computation is improved when nlon
c            is a product of small prime numbers.
c
c
c     isym   a parameter which determines whether the scalar field sf is
c            computed on the full or half sphere as follows:
c
c      = 0
c
c            the symmetries/antsymmetries described in isym=1,2 below
c            do not exist in (v,w) about the equator.  in this case sf
c            is neither symmetric nor antisymmetric about the equator.
c            sf is computed on the entire sphere.  i.e., in the array
c            sf(i,j) for i=1,...,nlat and  j=1,...,nlon
c
c      = 1
c
c            w is antisymmetric and v is symmetric about the equator.
c            in this case sf is antisymmetyric about the equator and
c            is computed for the northern hemisphere only.  i.e.,
c            if nlat is odd sf is computed in the array sf(i,j) for
c            i=1,...,(nlat+1)/2 and for j=1,...,nlon.  if nlat is even
c            sf is computed in the array sf(i,j) for i=1,...,nlat/2
c            and j=1,...,nlon.
c
c      = 2
c
c            w is symmetric and v is antisymmetric about the equator.
c            in this case sf is symmetyric about the equator and
c            is computed for the northern hemisphere only.  i.e.,
c            if nlat is odd sf is computed in the array sf(i,j) for
c            i=1,...,(nlat+1)/2 and for j=1,...,nlon.  if nlat is even
c            sf is computed in the array sf(i,j) for i=1,...,nlat/2
c            and j=1,...,nlon.
c
c
c     nt     nt is the number of scalar and vector fields.  some
c            computational efficiency is obtained for multiple fields.
C*PL*ERROR* Comment line too long
c            the arrays br,bi, and sf can be three dimensional corresponding
c            to an indexed multiple vector field (v,w).  in this case,
c            multiple scalar synthesis will be performed to compute each
C*PL*ERROR* Comment line too long
c            scalar field.  the third index for br,bi, and sf is the synthesis
c            index which assumes the values k = 1,...,nt.  for a single
c            synthesis set nt = 1.  the description of the remaining
C*PL*ERROR* Comment line too long
c            parameters is simplified by assuming that nt=1 or that br,bi,
c            and sf are two dimensional arrays.
c
c     isf    the first dimension of the array sf as it appears in
c            the program that calls igradec. if isym = 0 then isf
c            must be at least nlat.  if isym = 1 or 2 and nlat is
c            even then isf must be at least nlat/2. if isym = 1 or 2
c            and nlat is odd then isf must be at least (nlat+1)/2.
c
c     jsf    the second dimension of the array sf as it appears in
c            the program that calls igradec. jsf must be at least nlon.
c
c     br,bi  two or three dimensional arrays (see input parameter nt)
c            that contain vector spherical harmonic coefficients
c            of the vector field (v,w) as computed by subroutine vhaec.
c     ***    br,bi must be computed by vhaec prior to calling igradec.
c
C*PL*ERROR* Comment line too long
c     mdb    the first dimension of the arrays br and bi as it appears in
c            the program that calls igradec (and vhaec). mdb must be at
c            least min0(nlat,nlon/2) if nlon is even or at least
c            min0(nlat,(nlon+1)/2) if nlon is odd.
c
C*PL*ERROR* Comment line too long
c     ndb    the second dimension of the arrays br and bi as it appears in
c            the program that calls igradec (and vhaec). ndb must be at
c            least nlat.
c
c
c  wshsec    an array which must be initialized by subroutine shseci.
c            once initialized,
c            wshsec can be used repeatedly by igradec as long as nlon
c            and nlat remain unchanged.  wshsec must not be altered
c            between calls of igradec.
c
c
c  lshsec    the dimension of the array wshsec as it appears in the
c            program that calls igradec. define
c
c               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd.
c
c
c            then lshsec must be greater than or equal to
c
c               2*nlat*l2+3*((l1-2)*(nlat+nlat-l1-1))/2+nlon+15
c
c     work   a work array that does not have to be saved.
c
c     lwork  the dimension of the array work as it appears in the
c            program that calls igradec. define
c
c               l2 = nlat/2                    if nlat is even or
c               l2 = (nlat+1)/2                if nlat is odd
c               l1 = min0(nlat,(nlon+2)/2)     if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2)     if nlon is odd
c
c            if isym is zero then lwork must be at least
c
c               nlat*(nt*nlon+max0(3*l2,nlon)+2*nt*l1+1)
c
c            if isym is not zero then lwork must be at least
c
c               l2*(nt*nlon+max0(3*nlat,nlon))+nlat*(2*nt*l1+1)
c
c
c     **************************************************************
c
c     output parameters
c
c
C*PL*ERROR* Comment line too long
c     sf    a two or three dimensional array (see input parameter nt) that
c           contain a scalar field whose gradient is the irrotational
c           component of the vector field (v,w).  the vector spherical
c           harmonic coefficients br,bi were precomputed by subroutine
c           vhaec.  sf(i,j) is given at the gaussian colatitude theta(i)
c           and longitude lambda(j) = (j-1)*2*pi/nlon.  the index ranges
c           are defined at input parameter isym.
c
c
c  ierror   = 0  no errors
c           = 1  error in the specification of nlat
c           = 2  error in the specification of nlon
c           = 3  error in the specification of isym
c           = 4  error in the specification of nt
c           = 5  error in the specification of isf
c           = 6  error in the specification of jsf
c           = 7  error in the specification of mdb
c           = 8  error in the specification of ndb
c           = 9  error in the specification of lshsec
c           = 10 error in the specification of lwork
c
c **********************************************************************
c
      SUBROUTINE DIGRADEC(NLAT,NLON,ISYM,NT,SF,ISF,JSF,BR,BI,MDB,NDB,
     +                   WSHSEC,LSHSEC,WORK,LWORK,IERROR)
      DOUBLE PRECISION SF
      DOUBLE PRECISION BR
      DOUBLE PRECISION BI
      DOUBLE PRECISION WSHSEC
      DOUBLE PRECISION WORK
      DIMENSION SF(ISF,JSF,NT)
      DIMENSION BR(MDB,NDB,NT),BI(MDB,NDB,NT)
      DIMENSION WSHSEC(LSHSEC),WORK(LWORK)
c
c     check input parameters
c
      IERROR = 1
      IF (NLAT.LT.3) RETURN
      IERROR = 2
      IF (NLON.LT.4) RETURN
      IERROR = 3
      IF (ISYM.LT.0 .OR. ISYM.GT.2) RETURN
      IERROR = 4
      IF (NT.LT.0) RETURN
      IERROR = 5
      IMID = (NLAT+1)/2
      IF ((ISYM.EQ.0.AND.ISF.LT.NLAT) .OR.
     +    (ISYM.NE.0.AND.ISF.LT.IMID)) RETURN
      IERROR = 6
      IF (JSF.LT.NLON) RETURN
      IERROR = 7
      MMAX = MIN0(NLAT, (NLON+2)/2)
      IF (MDB.LT.MIN0(NLAT, (NLON+1)/2)) RETURN
      IERROR = 8
      IF (NDB.LT.NLAT) RETURN
      IERROR = 9
      IMID = (NLAT+1)/2
      LPIMN = (IMID*MMAX* (NLAT+NLAT-MMAX+1))/2
c
c     verify saved work space length
c
      L1 = MIN0(NLAT, (NLON+2)/2)
      L2 = (NLAT+1)/2
      LWKMIN = 2*NLAT*L2 + 3* ((L1-2)* (NLAT+NLAT-L1-1))/2 + NLON + 15
      IF (LSHSEC.LT.LWKMIN) RETURN
      IERROR = 10
c
c     set minimum and verify unsaved work space
c
      LS = NLAT
      IF (ISYM.GT.0) LS = IMID
      NLN = NT*LS*NLON
c
c     set first dimension for a,b (as requried by shsec)
c
      MAB = MIN0(NLAT,NLON/2+1)
      MN = MAB*NLAT*NT
c     lwkmin = nln+ls*nlon+2*mn+nlat
      IF (ISYM.EQ.0) THEN
          LWKMIN = NLAT* (NT*NLON+MAX0(3*L2,NLON)+2*NT*L1+1)
      ELSE
          LWKMIN = L2* (NT*NLON+MAX0(3*NLAT,NLON)) + NLAT* (2*NT*L1+1)
      END IF
      IF (LWORK.LT.LWKMIN) RETURN
      IERROR = 0
c
c     set work space pointers
c
      IA = 1
      IB = IA + MN
      IS = IB + MN
      IWK = IS + NLAT
      LIWK = LWORK - 2*MN - NLAT
      CALL DIGRDEC1(NLAT,NLON,ISYM,NT,SF,ISF,JSF,WORK(IA),WORK(IB),MAB,
     +             WORK(IS),MDB,NDB,BR,BI,WSHSEC,LSHSEC,WORK(IWK),LIWK,
     +             IERROR)
      RETURN
      END

      SUBROUTINE DIGRDEC1(NLAT,NLON,ISYM,NT,SF,ISF,JSF,A,B,MAB,SQNN,MDB,
     +                   NDB,BR,BI,WSHSEC,LSHSEC,WK,LWK,IERROR)
      DOUBLE PRECISION SF
      DOUBLE PRECISION A
      DOUBLE PRECISION B
      DOUBLE PRECISION SQNN
      DOUBLE PRECISION BR
      DOUBLE PRECISION BI
      DOUBLE PRECISION WSHSEC
      DOUBLE PRECISION WK
      DOUBLE PRECISION FN
      DIMENSION SF(ISF,JSF,NT)
      DIMENSION BR(MDB,NDB,NT),BI(MDB,NDB,NT),SQNN(NLAT)
      DIMENSION A(MAB,NLAT,NT),B(MAB,NLAT,NT)
      DIMENSION WSHSEC(LSHSEC),WK(LWK)
c
c     preset coefficient multiplyers in vector
c
      DO 1 N = 2,NLAT
          FN = DBLE(N-1)
          SQNN(N) = 1.0D0/SQRT(FN* (FN+1.D0))
    1 CONTINUE
c
c     set upper limit for vector m subscript
c
      MMAX = MIN0(NLAT, (NLON+1)/2)
c
c     compute multiple scalar field coefficients
c
      DO 2 K = 1,NT
c
c     preset to 0.0
c
          DO 3 N = 1,NLAT
              DO 4 M = 1,MAB
                  A(M,N,K) = 0.0D0
                  B(M,N,K) = 0.0D0
    4         CONTINUE
    3     CONTINUE
c
c     compute m=0 coefficients
c
          DO 5 N = 2,NLAT
              A(1,N,K) = BR(1,N,K)*SQNN(N)
              B(1,N,K) = BI(1,N,K)*SQNN(N)
    5     CONTINUE
c
c     compute m>0 coefficients
c
          DO 6 M = 2,MMAX
              DO 7 N = M,NLAT
                  A(M,N,K) = SQNN(N)*BR(M,N,K)
                  B(M,N,K) = SQNN(N)*BI(M,N,K)
    7         CONTINUE
    6     CONTINUE
    2 CONTINUE
c
c     scalar sythesize a,b into sf
c
      CALL DSHSEC(NLAT,NLON,ISYM,NT,SF,ISF,JSF,A,B,MAB,NLAT,WSHSEC,
     +           LSHSEC,WK,LWK,IERROR)
      RETURN
      END

c ----------------------------------------------------
      SUBROUTINE DSVDMTR(X,XT,MROW,MRX,NCX,IER)

      INTEGER MROW,MRX,NCX,IER
c
c x (mrx,ncx)
c xt(ncx,mrx)
c
      DOUBLE PRECISION X(MROW,NCX),XT(NCX,MRX)

      DO NC = 1,NCX
          DO MR = 1,MRX
              XT(NC,MR) = X(MR,NC)
          END DO
      END DO

      RETURN
      END
c ----------------------------------------------------
      SUBROUTINE DSVDINFO(SV,NSVMX,NSV,TOL,FNORM,IRANK,CONDN,PCVAR)

c
c input:  number of elements in sv
c
      INTEGER NSV,NSVMX
c
c input:  numerical tolerance
c
      DOUBLE PRECISION TOL
c
c input:  singular values
c
      DOUBLE PRECISION SV(NSVMX)

c
c         ! output: rank
c
      INTEGER IRANK
c
c output: Frobenius norm
c
      DOUBLE PRECISION FNORM
c
c condition number (stability)
c
      DOUBLE PRECISION CONDN
c
c output: pcvar
c
      DOUBLE PRECISION PCVAR(NSV)

      IRANK = 0
c
c Frobenius norm ?
c
      FNORM = 0.D0
      DO N = 1,NSVMX
          IF (ABS(SV(N)).GT.TOL) THEN
              IRANK = IRANK + 1
              FNORM = FNORM + SV(N)**2
          END IF
      END DO
c
c condition number
c assumes sv were in
c strict descending order
c
      CONDN = SV(1)/SV(IRANK)
      IF (FNORM.GT.0.D0) THEN
          DO N = 1,NSV
              PCVAR(N) = (SV(N)**2/FNORM)*100.D0
          END DO
      END IF

      RETURN
      END
c ----------------------------------------------------
      SUBROUTINE DSVDPAR(X,MROW,MRX,NCX,LABEL)

c print data from an array

      INTEGER MROW,MRX,NCX
      DOUBLE PRECISION X(MROW,NCX)
      CHARACTER*(*) LABEL

      LEN = INDEX(LABEL,'$') - 1

      IF(LEN.LE.0) THEN
         WRITE (*,*) 'svdpar: String must end in $'
      ELSE
         WRITE (*,FMT='(/,a)') LABEL(1:LEN)
         DO MR = 1,MRX
            WRITE (*,FMT='(i5,(12f8.4))') MR, (X(MR,NC),NC=1,NCX)
         END DO
      END IF

      RETURN
      END
c ----------------------------------------------------
      SUBROUTINE DSVDPVC(X,NPTS,LABEL)

c print data from a vector

      INTEGER NPTS
      DOUBLE PRECISION X(NPTS)
      CHARACTER*(*) LABEL

      LEN = INDEX(LABEL,'$') - 1
      WRITE (*,FMT='(/,a)') LABEL(1:LEN)

      DO N = 1,NPTS
          WRITE (*,FMT='(i5,f8.4)') N,X(N)
      END DO

      RETURN
      END

C
C	$Id: wmfpts.f,v 1.4 2008-07-27 00:17:36 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE WMFPTS(M,X,Y,N,XT,YT)
C
C  Filter out N points from the coordinates (X(I),Y(I),I=1,M) and
C  store them in (XT(I),YT(I),I=1,N).  It is assumed that M > N.
C
      DIMENSION X(M),Y(M),XT(N),YT(N)
C
      SCL = REAL(N-1)/REAL(M-1)
      OFF = REAL(M-N)/REAL(M-1)
C
      IX = 1
      XT(1) = X(1)
      YT(1) = Y(1)
      DO 100 I=2,M
        STMP = SCL*REAL(I)+OFF
        IT = MIN(INT(STMP),N)
        IF (IT .EQ. IX) GO TO 100
        IX = IT
        XT(IX) = X(I)
        YT(IX) = Y(I)
  100 CONTINUE
      XT(N) = X(M)
      YT(N) = Y(M)
C
      RETURN
      END

      SUBROUTINE GENDAT (DATA,IDIM,M,N,MLOW,MHGH,DLOW,DHGH)
C
C This is a routine to generate test data for two-dimensional graphics
C routines.  Given an array "DATA", dimensioned "IDIM x 1", it fills
C the sub-array ((DATA(I,J),I=1,M),J=1,N) with a two-dimensional field
C of data having approximately "MLOW" lows and "MHGH" highs, a minimum
C value of exactly "DLOW" and a maximum value of exactly "DHGH".
C
C "MLOW" and "MHGH" are each forced to be greater than or equal to 1
C and less than or equal to 25.
C
C The function used is a sum of exponentials.
C
        DIMENSION DATA(IDIM,1),CCNT(3,50)
C
        FOVM=9./REAL(M)
        FOVN=9./REAL(N)
C
        NLOW=MAX(1,MIN(25,MLOW))
        NHGH=MAX(1,MIN(25,MHGH))
        NCNT=NLOW+NHGH
C
        DO 101 K=1,NCNT
          CCNT(1,K)=1.+(REAL(M)-1.)*FRAN()
          CCNT(2,K)=1.+(REAL(N)-1.)*FRAN()
          IF (K.LE.NLOW) THEN
            CCNT(3,K)=-1.
          ELSE
            CCNT(3,K)=+1.
          END IF
  101   CONTINUE
C
        DMIN=+1.E36
        DMAX=-1.E36
        DO 104 J=1,N
          DO 103 I=1,M
            DATA(I,J)=.5*(DLOW+DHGH)
            DO 102 K=1,NCNT
              TEMP=-((FOVM*(REAL(I)-CCNT(1,K)))**2+
     +               (FOVN*(REAL(J)-CCNT(2,K)))**2)
              IF (TEMP.GE.-20.) DATA(I,J)=DATA(I,J)+
     +            .5*(DHGH-DLOW)*CCNT(3,K)*EXP(TEMP)
  102       CONTINUE
            DMIN=MIN(DMIN,DATA(I,J))
            DMAX=MAX(DMAX,DATA(I,J))
  103     CONTINUE
  104   CONTINUE
C
        DO 106 J=1,N
          DO 105 I=1,M
            DATA(I,J)=(DATA(I,J)-DMIN)/(DMAX-DMIN)*(DHGH-DLOW)+DLOW
c	    write(*,*) 'i,j,data: ', i,j,data(i,j)
  105     CONTINUE
  106   CONTINUE
C
        RETURN
C
      END
C
      FUNCTION FRAN ()
        DIMENSION RSEQ (100)
        SAVE ISEQ
        DATA RSEQ / .749,.973,.666,.804,.081,.483,.919,.903,.951,.960 ,
     +              .039,.269,.270,.756,.222,.478,.621,.063,.550,.798 ,
     +              .027,.569,.149,.697,.451,.738,.508,.041,.266,.249 ,
     +              .019,.191,.266,.625,.492,.940,.508,.406,.972,.311 ,
     +              .757,.378,.299,.536,.619,.844,.342,.295,.447,.499 ,
     +              .688,.193,.225,.520,.954,.749,.997,.693,.217,.273 ,
     +              .961,.948,.902,.104,.495,.257,.524,.100,.492,.347 ,
     +              .981,.019,.225,.806,.678,.710,.235,.600,.994,.758 ,
     +              .682,.373,.009,.469,.203,.730,.588,.603,.213,.495 ,
     +              .884,.032,.185,.127,.010,.180,.689,.354,.372,.429 /
        DATA ISEQ / 0 /
        ISEQ=MOD(ISEQ,100)+1
        FRAN=RSEQ(ISEQ)
        RETURN
      END
C
      SUBROUTINE LABTOP (LABL,SIZE)
C
        CHARACTER*(*) LABL
C
C Put a label just above the top of the plot.  The SET call is re-done
C to allow for the use of fractional coordinates, and the text extent
C capabilities of the package PLOTCHAR are used to determine the label
C position.
C
        CALL GETSET (XVPL,XVPR,YVPB,YVPT,XWDL,XWDR,YWDB,YWDT,LNLG)
        SZFS=SIZE*(XVPR-XVPL)
        CALL    SET (0.,1.,0.,1.,0.,1.,0.,1.,1)
        CALL PCGETI ('QU - QUALITY FLAG',IQUA)
        CALL PCSETI ('QU - QUALITY FLAG',0)
        CALL PCSETI ('TE - TEXT EXTENT COMPUTATION FLAG',1)
        CALL PLCHHQ (.5,.5,LABL,SZFS,360.,0.)
        CALL PCGETR ('DB - DISTANCE TO BOTTOM OF STRING',DBOS)
        CALL PLCHHQ (.5*(XVPL+XVPR),YVPT+SZFS+DBOS,LABL,SZFS,0.,0.)
        CALL PCSETI ('QU - QUALITY FLAG',IQUA)
        CALL    SET (XVPL,XVPR,YVPB,YVPT,XWDL,XWDR,YWDB,YWDT,LNLG)
C
C Done.
C
        RETURN
C
      END
C
      SUBROUTINE BNDARY
C
C Draw a line showing where the edge of the plotter frame is.
C
        CALL PLOTIF (0.,0.,0)
        CALL PLOTIF (1.,0.,1)
        CALL PLOTIF (1.,1.,1)
        CALL PLOTIF (0.,1.,1)
        CALL PLOTIF (0.,0.,1)
        CALL PLOTIF (0.,0.,2)
C
C Done.
C
        RETURN
C
      END
C
      SUBROUTINE DFCLRS(IWKID)
C
C Define a set of RGB color triples for colors 0 through 15.
C
      PARAMETER (NCLRS=16)
      DIMENSION RGBV(3,NCLRS)
C
C Define the RGB color triples needed below.
C
      DATA RGBV / 
     +     0.00 , 0.00 , 0.00 ,
     +     1.00 , 1.00 , 1.00 ,
     +     0.70 , 0.70 , 0.70 ,
     +     0.75 , 0.50 , 1.00 ,
     +     0.50 , 0.00 , 1.00 ,
     +     0.00 , 0.00 , 1.00 ,
     +     0.00 , 0.50 , 1.00 ,
     +     0.00 , 1.00 , 1.00 ,
     +     0.00 , 1.00 , 0.60 ,
     +     0.00 , 1.00 , 0.00 ,
     +     0.70 , 1.00 , 0.00 ,
     +     1.00 , 1.00 , 0.00 ,
     +     1.00 , 0.75 , 0.00 ,
     +     1.00 , 0.38 , 0.38 ,
     +     1.00 , 0.00 , 0.38 ,
     +     1.00 , 0.00 , 0.00 /
C
C Define 16 different color indices, for indices 0 through 15.  The
C color corresponding to index 0 is black and the color corresponding
C to index 1 is white.
C
      DO 101 I=1,NCLRS
         CALL GSCR (IWKID,I-1,RGBV(1,I),RGBV(2,I),RGBV(3,I))
 101  CONTINUE
C
C Done.
C
        RETURN
C
      END
C
      SUBROUTINE GENARA (A,B,ID,JD)
C
C     This subroutine generates a smooth array in output array B.
C     The array is dependent on the random number function RANDNO.
C     RANDNO can be replaced by a random number generator on a
C     given machine, or for consistency across machines, the
C     supplied function RANDNO may be used.  RANDNO reads its random
C     numbers from the file RANFDAT.
C
      DIMENSION A(ID,JD), B(ID,JD)
      PARAMETER (PI=3.14159 , TWOPI=2.*PI , EPS=PI/6.)
C
      NN=(ID+JD)/10
      AA=1.
      DI=ID-4
      DJ=JD-4
C
    2 DO 5 K=1,NN
      II=3.+DI*RANDNO()
      JJ=3.+DJ*RANDNO()
      DO 4 J=1,JD
      JE=ABS(J-JJ)
      DO 3 I=1,ID
      IE=ABS(I-II)
      EE=MAX(IE,JE)
      A(I,J)=A(I,J)+AA*(.8**EE)
    3 CONTINUE
    4 CONTINUE
    5 CONTINUE
C
      IF (AA.NE.1.) GO TO 6
      AA=-1.
      GO TO 2
C
    6 DO 8 J=1,JD
      JM1=MAX(1,J-1)
      JP1=MIN(JD,J+1)
      DO 7 I=1,ID
      IM1=MAX(1,I-1)
      IP1=MIN(ID,I+1)
      B(I,J)=(4.*A(I,J)+2.*(A(I,JM1)+A(IM1,J)+A(IP1,J)+A(I,JP1))
     1                 +A(IM1,JM1)+A(IP1,JM1)+A(IM1,JP1)+A(IP1,JP1))/16.
    7 CONTINUE
    8 CONTINUE
      RETURN
      END
C
      SUBROUTINE OPENR (IUNIT)
      CHARACTER*128 FILENM
      DATA FILENM / ' ' /
      SAVE IOPEN
      DATA IOPEN / 0 /
      IF (IOPEN.EQ.0) THEN
      CALL GNGPAT (FILENM,'database',ISTAT)
      IF (ISTAT .NE. -1) THEN
          DO 101 I=1,119
              IF (FILENM(I:I).EQ.CHAR(0)) THEN
                  FILENM(I:I+8)='/ranfdata'
                  GOTO 104
              ENDIF
 101      CONTINUE
         GO TO 105
      ELSE
          DO 102 I=2,128
              LENEM=I
              IF (FILENM(I:I).EQ.CHAR(0)) GO TO 103
 102      CONTINUE
 103      PRINT * , 'OPENR - ',FILENM(1:LENEM-1)
          STOP
      ENDIF
 104  OPEN (UNIT=IUNIT,FILE=FILENM,STATUS='OLD',FORM='FORMATTED',
     +                                                       ERR=105)
      IOPEN=1
      END IF
      RETURN
 105  WRITE (6,*) 'ERROR OPENING RANFDATA DATA FILE - FILE NAME: ',
     +             FILENM
      STOP
      END
C
      FUNCTION RANDNO()
C
C     This function is used to produce random numbers for the
C     GENARA calls.  The random numbers are read from file
C     RANFDAT, and in this way consistency is maintained across
C     machines (the results on one machine should be the same
C     as on another.)  If consistency is not required, the
C     function RANDNO can be replaced by a local random number
C     generator.  RANFDAT contains 2000 random numbers in
C     250 card-image lines in format 8F10.8 .
C
      SAVE ICNT,A
      DIMENSION A(2000)
      DATA ICNT/0/
C
      ICNT = ICNT+1
C
C     Read in random numbers if this is the first function call.
C
      IF (ICNT .EQ. 1) THEN
C Modification for UNIX Version.
	CALL OPENR(8)
C End of modification for UNIX Version.
        DO 3 I=1,250
        INDX = 8*(I-1)+1
        JNDX = INDX+7
        READ(8,501) (A(LL),LL=INDX,JNDX)
    3   CONTINUE
      END IF
C
      RANDNO = A(ICNT)
      RETURN
C
  500 FORMAT(' RANDNO--ERROR IN READ')
  501 FORMAT(8F10.8)
C
      END

      PROGRAM CMPLAB
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      REAL PLIM1(2), PLIM2(2), PLIM3(2), PLIM4(2)

      DATA PLIM1 /0.,0./
      DATA PLIM2 /0.,0./
      DATA PLIM3 /0.,0./
      DATA PLIM4 /0.,0./
C
C Open GKS, Turn Clipping off
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Invoke demo driver
C
      CALL TCMPLAB('SV',40.,-50.,0.,'PO','MA',0., 0.,0.,0.,10.)
C
C Advance the frame.
C
      CALL FRAME
C
C Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS

      STOP
      END

      SUBROUTINE TCMPLAB(PROJ, PLAT, PLON, ROTA, OUTLN,
     +     JLIM, PLIM1, PLIM2, PLIM3, PLIM4, GRD)
      
      EXTERNAL MASK
      
      PARAMETER (LMAP=150000,NWRK=1000,ISIZ=5)
      
      CHARACTER*2 PROJ, OUTLN, JLIM
      INTEGER MAP(LMAP), IAREA(ISIZ), IGRP(ISIZ)
      REAL XWRK(NWRK), YWRK(NWRK)
      REAL PLIM1(2), PLIM2(2), PLIM3(2), PLIM4(2)
C
C CMPLOT demonstrates MAPLOT drawing continental and political outlines
C
C Use solid lines for grid.
C
      CALL DASHDB(65535)
C
C Draw Continental, political outlines 
C
      CALL MAPSTC ('OU - OUTLINE DATASET SELECTOR',OUTLN)
C
C Set grid spacing
C
      CALL MAPSTR ('GR - GRID SPACING',GRD)
C 
C Set Label Size
C
      CALL MAPSTI ('LS - LABEL SIZE',20)
C
C Set up projection
C
      CALL MAPROJ (PROJ,PLAT,PLON,ROTA)
C
C If it's a satellite projection, choose a satellite distance
C
      IF (PROJ.EQ.'SV') CALL MAPSTR ('SA - SATELLITE DISTANCE',7.)
C
C Set limits of map
C
      CALL MAPSET (JLIM,PLIM1,PLIM2,PLIM3,PLIM4)
C
C Initialize Maps and Areas
C
      CALL MAPINT
      CALL ARINAM (MAP,LMAP)
      CALL MAPBLA (MAP)
C
C Draw Masked Grid Lines
C
      CALL MAPGRM (MAP, XWRK, YWRK, NWRK, IAREA, IGRP, ISIZ, MASK)
C
C Draw Continental Outlines, Labels and Elliptical Perimeter
C
      CALL MAPSTI('EL - ELLIPTICAL-PERIMETER SELECTOR',1)
      CALL MAPLBL
      CALL MAPLOT
C
C Done.
C
      RETURN
      END

      SUBROUTINE MASK(XC,YC,MCS,AREAID,GRPID,IDSIZE)

      INTEGER AREAID(IDSIZE),GRPID(IDSIZE),ID
      REAL XC(MCS),YC(MCS)
C
C Retrieve area id for geographical area
C
      DO 10, I=1,IDSIZE
         IF (GRPID(I).EQ.1) ID=AREAID(I)
 10   CONTINUE
C
C If the line is over water, and has 2 or more points draw it.
C
      IF ((MAPACI(ID).EQ.1).AND.(MCS.GE.2)) THEN
         CALL CURVED(XC,YC,MCS)
      ENDIF
C
C Otherwise, don't draw the line - mask it.
C
      RETURN
      END

C
C	$Id: dashbd.f,v 1.5 2008-07-27 00:23:02 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE DASHBD
C
C Calling this do-nothing subroutine forces "ld" to load the following
C block data routine (but only if they are in the same ".f" file).
C
        RETURN
C
      END
CNOSPLIT
      BLOCKDATA DASHBDX
C
C DASHBDX IS USED TO INITIALIZE VARIABLES IN NAMED COMMON.
C
      COMMON/INTPR/IPAU,FPART,TENSN,NP,SMALL,L1,ADDLR,ADDTB,MLLINE,
     1    ICLOSE
      COMMON /DSHD/   ISL        ,L          ,IP(16)
      COMMON /DSHDA/  IFSTFL
      COMMON /DSHDC/ IXSTOR,IYSTOR
      COMMON /DSHDD/ IFCFLG, MASK
      SAVE
C
C ISL IS A FLAG FOR AN ALL SOLID PATTERN (+1) OR AN ALL GAP PATTERN (-1)
C
      DATA ISL /1/
C
C
C IFSTFL IS A FLAG TO CONTROL THAT FRSTD IS CALLED BEFORE VECTD IS
C CALLED ANY TIME WHEN DASHDB HAS BEEN CALLED.
C
      DATA IFSTFL /1/
C
C  INTERNAL PARAMETERS
C
      DATA IPAU/3/
      DATA FPART/1./
      DATA TENSN/2.5/
      DATA NP/150/
      DATA SMALL/128./
      DATA L1/70/
      DATA ADDLR/2./
      DATA ADDTB/2./
      DATA MLLINE/384/
      DATA ICLOSE/6/
C
C IFCFLG IS THE FIRST CALL FLAG FOR DASHDB.
C
      DATA IFCFLG /1/
C
C IXSTOR AND IYSTOR CONTAIN THE CURRENT PEN POSITION. THEY ARE
C INITIALIZED TO AN IMPOSSIBLE POSITION
C
      DATA IXSTOR,IYSTOR /-9999,-9999/
C
C
C REVISION HISTORY--------
C
C APRIL 1984        CONVERTED TO FORTRAN77 AND GKS.
C
C DECEMBER 1979     ADDED STATISTICS CALL AND REVISION HISTORY
C                   DID NOT CHANGE CARD COUNT
C
C------------------------------------------------------------
      END

C
C $Id: line.f,v 1.9 2008-07-27 00:17:24 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE LINE (X1,Y1,X2,Y2)
C
C Draw a line connecting the point (X1,Y1) to the point (X2,Y2), in the
C user coordinate system.
C
      IF (ICFELL('LINE - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
      CALL PLOTIF (CUFX(X1),CUFY(Y1),0)
      IF (ICFELL('LINE',2).NE.0) RETURN
      CALL PLOTIF (CUFX(X2),CUFY(Y2),1)
      IF (ICFELL('LINE',3).NE.0) RETURN
      CALL PLOTIF (0.,0.,2)
      IF (ICFELL('LINE',4).NE.0) RETURN
      RETURN
      END

      SUBROUTINE PASSB(NAC,IDO,IP,L1,IDL1,CC,C1,C2,CH,CH2,WA)
      DOUBLE PRECISION CC
      DOUBLE PRECISION C1
      DOUBLE PRECISION C2
      DOUBLE PRECISION CH
      DOUBLE PRECISION CH2
      DOUBLE PRECISION WA
      DOUBLE PRECISION WAR
      DOUBLE PRECISION WAI
      DIMENSION CH(IDO,L1,IP),CC(IDO,IP,L1),C1(IDO,L1,IP),WA(*),
     +          C2(IDL1,IP),CH2(IDL1,IP)

      IDOT = IDO/2
      NT = IP*IDL1
      IPP2 = IP + 2
      IPPH = (IP+1)/2
      IDP = IP*IDO
C
      IF (IDO.LT.L1) GO TO 106
      DO 103 J = 2,IPPH
          JC = IPP2 - J
          DO 102 K = 1,L1
              DO 101 I = 1,IDO
                  CH(I,K,J) = CC(I,J,K) + CC(I,JC,K)
                  CH(I,K,JC) = CC(I,J,K) - CC(I,JC,K)
  101         CONTINUE
  102     CONTINUE
  103 CONTINUE
      DO 105 K = 1,L1
          DO 104 I = 1,IDO
              CH(I,K,1) = CC(I,1,K)
  104     CONTINUE
  105 CONTINUE
      GO TO 112
  106 DO 109 J = 2,IPPH
          JC = IPP2 - J
          DO 108 I = 1,IDO
              DO 107 K = 1,L1
                  CH(I,K,J) = CC(I,J,K) + CC(I,JC,K)
                  CH(I,K,JC) = CC(I,J,K) - CC(I,JC,K)
  107         CONTINUE
  108     CONTINUE
  109 CONTINUE
      DO 111 I = 1,IDO
          DO 110 K = 1,L1
              CH(I,K,1) = CC(I,1,K)
  110     CONTINUE
  111 CONTINUE
  112 IDL = 2 - IDO
      INC = 0
      DO 116 L = 2,IPPH
          LC = IPP2 - L
          IDL = IDL + IDO
          DO 113 IK = 1,IDL1
              C2(IK,L) = CH2(IK,1) + WA(IDL-1)*CH2(IK,2)
              C2(IK,LC) = WA(IDL)*CH2(IK,IP)
  113     CONTINUE
          IDLJ = IDL
          INC = INC + IDO
          DO 115 J = 3,IPPH
              JC = IPP2 - J
              IDLJ = IDLJ + INC
              IF (IDLJ.GT.IDP) IDLJ = IDLJ - IDP
              WAR = WA(IDLJ-1)
              WAI = WA(IDLJ)
              DO 114 IK = 1,IDL1
                  C2(IK,L) = C2(IK,L) + WAR*CH2(IK,J)
                  C2(IK,LC) = C2(IK,LC) + WAI*CH2(IK,JC)
  114         CONTINUE
  115     CONTINUE
  116 CONTINUE
      DO 118 J = 2,IPPH
          DO 117 IK = 1,IDL1
              CH2(IK,1) = CH2(IK,1) + CH2(IK,J)
  117     CONTINUE
  118 CONTINUE
      DO 120 J = 2,IPPH
          JC = IPP2 - J
          DO 119 IK = 2,IDL1,2
              CH2(IK-1,J) = C2(IK-1,J) - C2(IK,JC)
              CH2(IK-1,JC) = C2(IK-1,J) + C2(IK,JC)
              CH2(IK,J) = C2(IK,J) + C2(IK-1,JC)
              CH2(IK,JC) = C2(IK,J) - C2(IK-1,JC)
  119     CONTINUE
  120 CONTINUE
      NAC = 1
      IF (IDO.EQ.2) RETURN
      NAC = 0
      DO 121 IK = 1,IDL1
          C2(IK,1) = CH2(IK,1)
  121 CONTINUE
      DO 123 J = 2,IP
          DO 122 K = 1,L1
              C1(1,K,J) = CH(1,K,J)
              C1(2,K,J) = CH(2,K,J)
  122     CONTINUE
  123 CONTINUE
      IF (IDOT.GT.L1) GO TO 127
      IDIJ = 0
      DO 126 J = 2,IP
          IDIJ = IDIJ + 2
          DO 125 I = 4,IDO,2
              IDIJ = IDIJ + 2
              DO 124 K = 1,L1
                  C1(I-1,K,J) = WA(IDIJ-1)*CH(I-1,K,J) -
     +                          WA(IDIJ)*CH(I,K,J)
                  C1(I,K,J) = WA(IDIJ-1)*CH(I,K,J) +
     +                        WA(IDIJ)*CH(I-1,K,J)
  124         CONTINUE
  125     CONTINUE
  126 CONTINUE
      RETURN
  127 IDJ = 2 - IDO
      DO 130 J = 2,IP
          IDJ = IDJ + IDO
          DO 129 K = 1,L1
              IDIJ = IDJ
              DO 128 I = 4,IDO,2
                  IDIJ = IDIJ + 2
                  C1(I-1,K,J) = WA(IDIJ-1)*CH(I-1,K,J) -
     +                          WA(IDIJ)*CH(I,K,J)
                  C1(I,K,J) = WA(IDIJ-1)*CH(I,K,J) +
     +                        WA(IDIJ)*CH(I-1,K,J)
  128         CONTINUE
  129     CONTINUE
  130 CONTINUE
      RETURN
      END

C
C	$Id: gputpt.f,v 1.5 2009-08-30 05:54:47 fred Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GPUTPT(ICODE)
C
C  Put out coordinate points from segment copy.
C
      include 'trpars.h'
      include 'trinst.h'
      include 'trbufr.h'
      include 'gkscom.h'
      include '../bwi/g01io.h'
C
      LOGICAL CNTINO
C
      INTEGER CONVAL, NOPNS, TNOPNS, TMAX, NBYTS, IOS, STATUS
      PARAMETER (MAXTMP=600,MAXTMH=300)
      INTEGER ITEMPS(MAXTMP)
      REAL TEMPP(MAXTMH),TEMPQ(MAXTMH)
      CHARACTER*1 DNAME
C
C  Set up interface values.
C
      FCODE = ICODE
      CALL GZROI(0)
C
C  Set TMAX to maximum dimension of temporary space.
C
      TMAX = MAXTMP
C
C  Compute the operand length.
C
      NBYTS = MOPLEN/8
C
C  Save the file pointers.
C
      MRECNO = MRECNM
      METREO = METREC
      METBIO = METBIT
      MRECLO = MRECLN
      MOPRSO = MOPRST
      LENO   = LEN
      CNTINO = CNTINU
      IF (CNTINU) THEN
        DO 50 I=1,MNWRDS
          MBFSAV(I) = MBUFER(I)
   50   CONTINUE
      ENDIF
C
C  Determine the total number of points to be passed.
C
      NPTOT = LEN/(2*NBYTS)
   20 CONTINUE
      IF (CNTINU) THEN
        CALL GSKPOP(MOPLEN,LEN/2,IOS,STATUS)
C
C  Get the continue flag value.
C
        CALL GBYTES(MBUFER,CONVAL,METBIT,MCOLEN,0,1)
        METBIT = METBIT + MCOLEN
        IF (CONVAL .EQ. CONFLG) THEN
          CNTINU = .TRUE.
        ELSE
          CNTINU = .FALSE.
        END IF
C
C  Get the long operand 8 bit byte count field.
C
        CALL GBYTES(MBUFER,LEN,METBIT,MLOLEN,0,1)
        METBIT = METBIT + MLOLEN
        MOPRST = METBIT
        NPTOT = NPTOT+LEN/(2*NBYTS)
        GO TO 20
      ENDIF
C
C  Reposition the input file and record pointers.
C
      IF (METREC .GT. METREO) THEN
        IBK = METREC - METREO
        MRECNO = MRECNM
        MRECNM = METREC
        DO 30 J=1,IBK 
          CALL G01MIO(6, MCONID, DNAME, IDUM1, IDUM2, IER)
   30   CONTINUE
        METREC = MRECNM
        MRECNM = MRECNO
      ENDIF
C
      MRECNM = MRECNO
      METREC = METREO
      METBIT = METBIO
      MRECLN = MRECLO
      MOPRST = MOPRSO
      LEN = LENO
      CNTINU = CNTINO
      IF (CNTINU) THEN
        DO 60 I=1,MNWRDS 
          MBUFER(I) = MBFSAV(I)
   60   CONTINUE
      ENDIF
C
C  Jump here if instruction continued from end of routine.
C
    5 CONTINUE
C
C  Compute the number of operands in the buffer.
C
      NOPNS = LEN/NBYTS
C
C  Number of operands must be greater than one.
C
      IF (NOPNS .GT. 1) THEN
    6   CONTINUE
C
C  Move only enough operands for the ITEMPS array.
C
        TNOPNS = NOPNS
        IF (TNOPNS .GT. TMAX) THEN
          TNOPNS = TMAX
          NOPNS = NOPNS - TMAX
        ELSE
          NOPNS = 0
        END IF
C
C  Get the operands.
C
        CALL GOPDEC(ITEMPS,MOPLEN,TNOPNS,IOS,STATUS)
        IF (STATUS .NE. 0) RETURN
C
C  Separate the coordinates into P and Q arrays.
C
        NP = TNOPNS/2
        DO 40 I=1,NP
          PTMP = REAL(ITEMPS(2*I-1))/32767.
          QTMP = REAL(ITEMPS(2*I))/32767.
C
C  Transform the points using the current segment transformation CURTM.
C
          TEMPP(I) = CURTM(1,1)*PTMP+CURTM(1,2)*QTMP+CURTM(1,3)        
          TEMPQ(I) = CURTM(2,1)*PTMP+CURTM(2,2)*QTMP+CURTM(2,3)        
   40   CONTINUE
C
C  Put the points out.
C
        CALL GZPUTR(NPTOT,NP,TEMPP,TEMPQ,0,IER)
C
C  If there was not enough room in the operand buffer, then move
C  the next set of this partition into the buffer.
C
        IF (NOPNS .NE. 0) GO TO 6
      END IF
C
C  Get the next part of the instruction if a continue.
C
      IF (CNTINU) THEN
        CALL GNPART(IOS,STATUS)
        IF (STATUS.NE.0) RETURN
        GO TO 5
      END IF
C
      RETURN
      END

C NCLFORTSTART
      SUBROUTINE DWGTAREASUM2(T,WGT,MX,NY,TMSG,IFLAG,SUM)
      IMPLICIT NONE
      INTEGER MX,NY,IFLAG
      DOUBLE PRECISION T(MX,NY),WGT(MX,NY)
      DOUBLE PRECISION TMSG
      DOUBLE PRECISION SUM
C NCLEND

C NCL: sumX = wgt_AreaSum2(x,wgt,flag)

      INTEGER NL,ML,KMSG,KOK
      DOUBLE PRECISION SUMT

C compute the weighted area sum

C Nomenclature:
C INPUT:
C t      - 2D array
C wgt    - 2D array
C mx     - 1st [faster varying] dimension of "t" [eg, longitude]
C ny     - 2nd [slower varying] dimension of "t" [eg, latitude ]
C tmsg   - msg value
C iflag  - flag
C          =0 compute  sum ignoring msg values
C          =1 if any msg data is encountered return as msg
c OUTPUT:
C sum    - area weighted sum

      SUMT = 0.0D0
      SUM = TMSG
      KMSG = 0
      KOK = 0

      DO NL = 1,NY
          DO ML = 1,MX
              IF (T(ML,NL).NE.TMSG) THEN
                  KOK = KOK + 1
                  SUMT = SUMT + T(ML,NL)*WGT(ML,NL)
              ELSE
                  KMSG = KMSG + 1
              END IF
          END DO
c                                      return if user desired
          IF (IFLAG.EQ.1 .AND. KMSG.NE.0) RETURN
      END DO
c
      IF (KOK.GT.0) THEN
          SUM = SUMT
      END IF

      RETURN
      END

C
C	$Id: rgbhls.f,v 1.5 2008-07-27 00:16:54 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE RGBHLS ( R, G, B, H, L, S )
C
C_BEGIN PROLOGUE RGBHLS
C
C_PURPOSE
C    This subroutine converts a color specification given as
C    Red, Green, and Blue intensity values to a color specification
C    given as Hue, Lightness, and Saturation values.
C
C_DESCRIPTION
C    This subroutine converts color values given in the
C    Red, Green, Blue (RGB) color space to color values
C    in the Hue, Lightness, and Saturation (HLS) color space.
C    The input Red, Green, and Blue values are intensities
C    in the range [0.,1.]; the output value H is returned
C    as a floating point number in the range [0.,360.);
C    full blue in the input space (red and green values of 0.)
C    corresponds to a hue of 0. in the
C    output space; the output value L is returned as a
C    floating point number in the range [0.,100.];
C    the output value S is returned as a floating
C    point number in the range [0.,100.] .
C
C_ARGUMENTS
C
C R       (INPUT,SINGLE,VARIABLE)  A real variable in the range
C         [0.,1.] which represents the red intensity component
C         of the input point in RGB color space.
C
C G       (INPUT,SINGLE,VARIABLE)  A real variable in the range
C         [0.,1.] which represents the green intensity component
C         of the input point in RGB color space.
C
C B       (INPUT,SINGLE,VARIABLE)  A real variable in the range
C         [0.,1.] which represents the blue intensity component
C         of the input point in RGB color space.
C
C H       (OUTPUT,SINGLE,VARIABLE)  A real variable in the range
C         [0.,360.) which represents the hue of the input point
C         in HLS color space.  A value of (0.,0.,B) in the input
C         space will result in a hue of 0. in the output space.
C
C L       (OUTPUT,SINGLE,VARIABLE)  A real variable in the range
C         [0.,100.] which represents the lightness value of the
C         input point in HLS color space.  Lightness is a measure
C         of the quantity of light--a lightness of 0. is black,
C         and a lightness of 100. gives white.  The pure hues occur
C         at lightness value 50.  The lightness should be thought
C         of as a percentage.
C
C S       (OUTPUT,SINGLE,VARIABLE)  A real variable in the range
C         [0.,100.] which represents the saturation value of the
C         input point in HLS color space.  Saturation is a measure
C         of how much white light is mixed with the color.  Saturation
C         values of 0. represent greys (with a grey value equal to
C         the lightness value L).  Saturation values of 100. are fully
C         saturated colors.  The hue is undefined when S=0.  The
C         fully saturated pure hues occur when S=100. and L=50.
C         The saturation value should be thought of as a percentage.
C
C_I/O
C    (NONE)
C
C_ROUTINES CALLED
C    (NONE)
C
C_COMMON BLOCKS
C    (NONE)
C
C_MAXIMUM GKS LEVEL
C    (NONE)
C
C_LANGUAGE
C    FORTRAN
C
C_REVISION DATE
C    880511 (YYMMDD)
C
C_HISTORY
C    This subroutine was originally coded at NCAR by Roy Barnes
C    based on the algorithm presented in Foley and van Dam (see
C    REFERENCES below); it was prepared for the NCAR Graphics
C    package by Fred Clare.
C
C_REFERENCES
C    Foley, James D. and van Dam, Andries,"Fundamentals of Interactive
C    Computer Graphics",Addison-Wesley Publishing Company, 1982.
C
C    Smith, A.R.,"Color Gamut Transformation Pairs",SIGGRAPH '78
C    Proceedings, published as Computer Graphics, 12(3),August 1978,
C    pp.12-19.
C
C_LONG DESCRIPTION
C    The hues returned can be made to put 0 degrees at red instead
C    of blue by changing the offsets to the computation of H in the
C    code.  Hue 0. representing blue, and S and L values ranging
C    from 0. to 100. instead of 0. to 1. were chosen for compatability
C    with the Tektronix color model, and compatibility with the
C    NCAR FORTRAN CGM translator GRAPHCAPs.
C
C_EXAMPLES
C    Example 1 --  Pure red at full intensity to HLS
C          SUBROUTINE HLS1
C          REAL    H,L,S,EPS
C          PARAMETER (EPS=0.00001)
C          CALL RGBHLS(1.,0.,0.,H,L,S)
C          IF ( (ABS(H-120.) .GT. EPS) .OR. (ABS(L-50.) .GT. EPS) .OR.
C         *     (ABS(S-100.) .GT. EPS) ) THEN
C            IUN = I1MACH(4)
C            WRITE(IUN,10)
C          ENDIF
C          RETURN
C       10 FORMAT(' HLS1 returned incorrect values')
C          END
C
C_END PROLOGUE RGBHLS
C
      REAL R,G,B,H,L,S,MXINTS,MNINTS,MAXMIN,HSAV,BC,GC,RC,RMM
      SAVE HSAV
      DATA HSAV/0./
C
C  Check on input arguments.
C
C_FIRST EXECUTABLE STATEMENT RGBHLS
      IF (R.LT.0. .OR. R.GT.1.)
     *      CALL SETER(' RGBHLS - R out of range',1,1)
      IF (G.LT.0. .OR. G.GT.1.)
     *      CALL SETER(' RGBHLS - G out of range',1,1)
      IF (B.LT.0. .OR. B.GT.1.)
     *      CALL SETER(' RGBHLS - B out of range',1,1)
      MXINTS = MAX(R,G,B)
      MNINTS = MIN(R,G,B)
C
C  Compute lightness
C
      L = (MXINTS+MNINTS)*0.5
      IF (MXINTS .EQ. MNINTS) THEN
C
C  Achromatic case.  If the saturation is 0., then leave H
C  as it was in the previous call as per the suggestion of
C  A.V. Smith (see REFERENCES).
C
        S = 0.0
        H = HSAV
      ELSE
C
C  Chromatic case.
C
        MAXMIN = MXINTS-MNINTS
        IF (L .LE. 0.5) THEN
          S = MAXMIN/(MXINTS+MNINTS)
        ELSE
          S = MAXMIN/(2.0-MXINTS-MNINTS)
        ENDIF
        RMM = 1./MAXMIN
        RC = (MXINTS-R)*RMM
        GC = (MXINTS-G)*RMM
        BC = (MXINTS-B)*RMM
        IF (R .EQ. MXINTS) THEN
          H = 2.+BC-GC
        ELSE IF (G .EQ. MXINTS) THEN
          H = 4.+RC-BC
        ELSE IF (B .EQ. MXINTS) THEN
          H = 0.+GC-RC
        ENDIF
C
C  Convert H to degrees.
C
        H = H*60.
        IF (H .LT. 0.) H = H+360.
        HSAV = H
      ENDIF
C
C  Scale lightness and saturation values.
C
      L = L*100.
      S = S*100.
      L = MIN(100.,MAX(0.,L))
      S = MIN(100.,MAX(0.,S))
      RETURN
      END

C
C	$Id: wmdrrg.f,v 1.10 2008-07-27 00:17:36 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE WMDRRG(N,X,Y,ITYPE,NC,XC,YC)
C
C  This subroutine draws a closed region filled as per the
C  value of ITYPE.  Legal values for ITYPE are:
C
C    ITYPE = 'INDEXnnn' where "nnn" denotes a color index.
C          = 'T' for thunderstorms.
C          = 'SH' for showers.
C          = 'R' for rain.
C          = 'F' for flurries.
C          = 'SN' for snow.
C          = 'I' for ice.
C
C  If NC is greater than 2, then the region resulting from the
C  spline fit to (X(I),Y(I),I=1,N) will be clipped against the 
C  region in (XC(I),YC(I),I=1,NC) .
C
C  X,Y and XC,YC are world coordinate values.
C
      include 'wmcomn.h'
C
      DIMENSION X(N),Y(N),XC(NC),YC(NC)
      CHARACTER*(*) ITYPE
C
C  Define necessary arrays and functions for the clipping calls.
C
      COMMON /WMLGCM/IDRFLG
      EXTERNAL WMLGFA
C
      NPO = N
C
C  Check error status.
C
      IF (ICFELL('WMDRRG - Uncleared prior error',1) .NE. 0) RETURN
      IF (NPO .LE. 1) THEN
        CALL SETER (
     +       'WMDRRG - input region must have at least three points',       
     +       1, 1)
        RETURN
      ENDIF
      IF (NC.LT.1 .OR. NC.EQ.2) THEN
        CALL SETER (
     +    'WMDRRG - fifth argument must be either 1 or greater than 2',      
     +    1, 1)
        RETURN
      ENDIF
C
C  If the original region has more than NPTS points, filter out NPTS
C  points from it.  Otherwise, keep the original points.
C
      IF (NPO .GT. NPTS) THEN
        NPO = NPTS
        CALL WMFPTS(N,X,Y,NPTS,XO,YO)
      ELSE
        DO 100 I=1,N
          XO(I) = X(I)
          YO(I) = Y(I)
  100   CONTINUE
      ENDIF
C
C  Construct a spline curve having NPTS points in it that represents
C  the curve in (X,Y).  We use Alan Cline's spline package for this.
C
      IF (TNSION .EQ. -1.) THEN
        TNSION = 0.001
      ENDIF
C
C  S is a common variable of maximal dimension NPTS.
C
      CALL MSKRV1(NPO,XO,YO,SLOPE1,SLOPE2,XS,YS,TEMP,S,TNSION,4)
      DO 10 I=1,NPTS
        T = REAL(I-1)/REAL(NPTS-1)
        IF (I.EQ.1) THEN
          CALL MSKRV2(T,XOUT(I),YOUT(I),NPO,XO,YO,XS,YS,S,TNSION,1,
     +                SLOPEL)
        ELSE IF (I .EQ. NPTS) THEN
          CALL MSKRV2(T,XOUT(I),YOUT(I),NPO,XO,YO,XS,YS,S,TNSION,0,SLP)
        ELSE
          CALL MSKRV2(T,XOUT(I),YOUT(I),NPO,XO,YO,XS,YS,S,TNSION,1,
     +                SLOPER)
        ENDIF
   10 CONTINUE
C
C  Convert spline curve to NDC space.
C
      CALL WMW2NX(NPTS,XOUT,XS)
      CALL WMW2NY(NPTS,YOUT,YS)
      DO 20 I=1,NPTS
        XOUT(I) = XS(I)
        YOUT(I) = YS(I)
   20 CONTINUE
C
C  Convert clipping region to NDC.
C
      IF (NC .GT. 2) THEN
        CALL WMW2NX(NC,XC,RWORK(1))
        CALL WMW2NY(NC,YC,RWORK(NC+1))
      ENDIF
C
C  Save the current normalization transformation number, and select
C  transformation 0.
C
      CALL GQCNTN(IER,NTRO)
      CALL GSELNT(0)
      CALL GQPLCI(IER,IPLLRO)
      CALL GQFACI(IER,IFCLRO)
      CALL GQFAIS(IER,INSTYO)
      CALL GSFAIS(1)
C
C  Draw the region.
C
      IF (ITYPE(1:5).EQ.'INDEX' .OR. ITYPE(1:5).EQ.'index') THEN
C
C  Get the color index.
C
        ICLEN = LEN(ITYPE)
C
C  Find the first non-blank character starting from the right
C  of ITYPE and moving to the left.  Adjust ICLEN accordingly.
C
        DO 400 I=ICLEN,1,-1
          IF (ITYPE(I:I) .NE. ' ') THEN
            ICLEN = I
            GO TO 405
          ENDIF
  400   CONTINUE   
  405   CONTINUE
        IF (ICLEN .EQ. 6) THEN
           READ(ITYPE(6:ICLEN),'(I1)') NDX
        ELSE IF (ICLEN .EQ. 7) THEN
           READ(ITYPE(6:ICLEN),'(I2)') NDX
        ELSE IF (ICLEN .EQ. 8) THEN
           READ(ITYPE(6:ICLEN),'(I3)') NDX
        ELSE IF (ICLEN .EQ. 9) THEN
           READ(ITYPE(6:ICLEN),'(I4)') NDX
        ELSE IF (ICLEN .EQ. 10) THEN
           READ(ITYPE(6:ICLEN),'(I5)') NDX
        ELSE
          NDX = 1
        ENDIF
        CALL GSFACI(NDX)
        CALL GSPLCI(NDX)
C
C  Draw the region.
C 
        IF (NC .EQ. 1) THEN
C
C  No clipping to be done.
C
          CALL GFA(NPTS,XOUT,YOUT)
        ELSE
C
C  Clip against the input poygon, set the value for IDRFLG so that
C  no outline is drawn.
C
          IDRFLG = 0
          CALL PPINPO(RWORK(1),RWORK(NC+1),NC,XOUT,YOUT,NPTS,
     +                RWORK(2*NC+1),IWORK(2*NC+1),NWRK-2*NC,WMLGFA,IER)       
        ENDIF
      ELSE IF (ITYPE(1:1).EQ.'T' .OR. ITYPE(1:1).EQ.'t') THEN
C
C  Thunderstorms.
C
        CALL GSFACI(ICOLOR)
        CALL GSPLCI(ICOLOR)
        CALL WMRGWT(NPTS,XOUT,YOUT,37,102)
      ELSE IF (ITYPE(1:2).EQ.'SH' .OR. ITYPE(1:2).EQ.'sh' .OR.
     +         ITYPE(1:2).EQ.'Sh') THEN
C
C  Showers.
C
        CALL GSFACI(ICOLOR)
        CALL GSPLCI(ICOLOR)
        CALL WMRGWT(NPTS,XOUT,YOUT,37,101)
      ELSE IF (ITYPE(1:1).EQ.'R' .OR. ITYPE(1:1).EQ.'r') THEN
C
C  Rain.
C
        CALL GSFACI(ICOLOR)
        CALL GSPLCI(ICOLOR)
        CALL WMRGWT(NPTS,XOUT,YOUT,37,103)
      ELSE IF (ITYPE(1:1).EQ.'F' .OR. ITYPE(1:1).EQ.'f') THEN
C
C  Flurries.
C
        CALL GSFACI(ICOLOR)
        CALL GSPLCI(ICOLOR)
        CALL WMRGWT(NPTS,XOUT,YOUT,37,106)
      ELSE IF (ITYPE(1:2).EQ.'SN' .OR. ITYPE(1:2).EQ.'sn' .OR.
     +         ITYPE(1:2).EQ.'Sn') THEN
C
C  Snow.
C
        CALL GSFACI(ICOLOR)
        CALL GSPLCI(ICOLOR)
        CALL WMRGWT(NPTS,XOUT,YOUT,37,104)
      ELSE IF (ITYPE(1:1).EQ.'I' .OR. ITYPE(1:1).EQ.'i') THEN
C
C  Ice.
C
        CALL GSFACI(ICOLOR)
        CALL GSPLCI(ICOLOR)
        CALL WMRGWT(NPTS,XOUT,YOUT,37,105)
      ENDIF
C
C  Restore original settings.
C
      CALL GSELNT(NTRO)
      CALL GSFAIS(INSTYO)
      CALL GSFACI(IFCLRO)
      CALL GSPLCI(IPLLRO)
C
      RETURN
      END

C NCLFORTSTART
      SUBROUTINE DLCLPRS(P,TK,TDK,PLCL)
      IMPLICIT NONE

C NCL:  plcl = lclvl (p,tk,tdk)

c input
      DOUBLE PRECISION P,TK,TDK
c output
      DOUBLE PRECISION PLCL
c NCLEND

c     g.s. stipanuk     1973      	  original version.
c     reference stipanuk paper entitled:
c            "algorithms for generating a skew-t, log p
c          diagram and computing selected meteorological
c          quantities."
c          atmospheric sciences laboratory
c          u.s. army electronics command
c          white sands missile range, new mexico 88002
c          33 pages
c
c   this function returns the pressure plcl (mb/hPa) of the lifting
c   condensation level (lcl) for a parcel initially at temperature
c   tk (K) dew point tdk (K) and pressure p (mb/hPa). plcl is computed
c   by an iterative procedure described by eqs. 8-12 in stipanuk
c   (1973), pp.13-14.

      INTEGER I
      DOUBLE PRECISION TNOT,RCP,TC,TDC,ES,ES0,WS,PTK,X,PI
      DOUBLE PRECISION C1,C2,C3,C4,C5,C6,TDAC,TMRK,TMRC,Z

      DATA TNOT/273.15D0/
      DATA RCP/0.286D0/
      DATA ES0/6.1121D0/
      DATA C1/.0498646455D0/,C2/2.4082965D0/,C3/7.07475D0/
      DATA C4/38.9114D0/,C5/.0915D0/,C6/1.2035D0/

      TC = TK - TNOT
      TDC = TDK - TNOT

c   determine the mixing ratio line through td and p.
c
c   the "es" statement returns the saturation vapor pressure es (mb)
c   over liquid water given a temperature t (celsius). the formula
c   appears bolton, david, 1980: "the computation of equivalent
c   potential temperature," monthly weather review, vol. 108,
c   no. 7 (july), p. 1047, eq.(10). the quoted accuracy is 0.3%
c   or better for -35 < t < 35c.

      ES = ES0*EXP(17.67D0*TDC/ (TDC+243.5D0))

c   saturation mix ratio

      WS = 622.D0*ES/ (P-ES)

c   determine the dry adiabat through t and p (ie: potential
c   temperature)

      PTK = TK* ((1000.D0/P)**RCP)

c   iterate to locate pressure pi at the intersection of the two
c   curves. pi has been set to p for the initial guess.

c   tdac - temp [C] on a dry adiabat at p [mb/hPa] where the dry
c          adibat is given by the potential temperature.
c   tmrc - temperature on a mix ratio line [ws] at pressure p [hPa]

    3 PI = P
      DO I = 1,10
          TDAC = PTK* ((PI/1000.D0)**RCP) - TNOT

          Z = DLOG10(WS*PI/ (622.D0+WS))
          TMRK = 10.D0** (C1*Z+C2) - C3 +
     +           C4* ((10.D0** (C5*Z)-C6)**2.D0)
          TMRC = TMRK - TNOT

          X = .02D0* (TMRC-TDAC)
          IF (ABS(X).LT.0.01D0) GO TO 5
          PI = PI* (2.D0** (X))
      END DO

    5 PLCL = PI
      RETURN

c       entry alclm(t,td,p)
c   for entry alclm only, t is the mean potential temperature (celsius)
c   and td is the mean mixing ratio (g/kg) of the layer containing the
c   parcel.

c       aw = td
c       ao = t
c       go to 3
      END

C
C	$Id: gzckwk.f,v 1.5 2008-07-27 00:21:03 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GZCKWK(NUM,ENAM,WKID,WTYPE,IER)
C
C  This subroutine provides the checking for error numbers:
C     20 -- SPECIFIED WORKSTATION IDENTIFIER IS INVALID
C     22 -- SPECIFIED WORKSTATION TYPE IS INVALID
C     23 -- SPECIFIED WORKSTATION TYPE DOES NOT EXIST
C     24 -- SPECIFIED WORKSTATION IS OPEN
C     25 -- SPECIFIED WORKSTATION IS NOT OPEN
C     29 -- SPECIFIED WORKSTATION IS ACTIVE
C     30 -- SPECIFIED WORKSTATION IS NOT ACTIVE
C
C  INPUT:
C    NUM   -- Error number to check for.
C    ENAM  -- Index of name of calling program (this is non-zero
C             only for non-inquiry functions, in which case GERHND
C             is called).
C    WKID  -- Workstation identifier (where applicable).
C    WTYPE -- Workstation type (where applicable).
C
C  OUTPUT:
C    IER   -- 0 If no error and the error number if an error was found.        
C
      include 'gkscom.h'
C
      INTEGER ENAM,WKID,WTYPE
      IER = 0
      IF (NUM .EQ. 20) THEN
C
C  Check if WKID is valid.
C
        IF (WKID .LT. 0) THEN
          IER = NUM
          IF (ENAM .GE. 0) THEN
            ERS = 1
            CALL GERHND(NUM,ENAM,ERF)
            ERS = 0
            RETURN
          ENDIF
        ENDIF
      ELSE IF (NUM .EQ. 22) THEN
C
C  Check if WTYPE is valid.
C
        INDX = 0
  200   CONTINUE
        INDX = INDX+1
        IF (INDX .GT. WK) THEN
          IER = NUM
          IF (ENAM.GE.0) THEN
            ERS = 1
            CALL GERHND(NUM,ENAM,ERF)
            ERS = 0
            RETURN
          ENDIF
          GO TO   201
        ELSE
          IF (LSWK(INDX) .EQ. WTYPE) THEN
            GO TO   201
          ENDIF
        ENDIF
        GO TO   200
  201   CONTINUE
      ELSE IF (NUM .EQ. 23) THEN
C
C  Check if WTYPE exists.
C
        INDX = 0
  202   CONTINUE
        INDX = INDX+1
        IF (INDX .GT. WK) THEN
          IER = NUM
          IF (ENAM .GE. 0) THEN
            ERS = 1
            CALL GERHND(NUM,ENAM,ERF)
            ERS = 0
            RETURN
          ENDIF
          GO TO   203
        ELSE
          IF (LSWK(INDX) .EQ. WTYPE) THEN
            GO TO   203
          ENDIF
        ENDIF
        GO TO 202
  203   CONTINUE
      ELSE IF (NUM .EQ. 24) THEN
C
C  Check if the workstation is currently open.
C
        IF (NOPWK .GT. 0) THEN
          DO 204 I=1,NOPWK
            IF (SOPWK(I) .EQ. WKID) THEN
              IER = NUM
              IF (ENAM .GE. 0) THEN
                ERS = 1
                CALL GERHND(NUM,ENAM,ERF)
                ERS = 0
                RETURN
              ENDIF
            ENDIF
  204     CONTINUE
        ENDIF
      ELSE IF (NUM.EQ.25) THEN
C
C  Check if the specified workstation is open.
C
        INDX = 0
  205   CONTINUE
        INDX = INDX+1
        IF (INDX .GT. MOPWK) THEN
          IER = NUM
          IF (ENAM .GE. 0) THEN
            ERS = 1
            CALL GERHND(NUM,ENAM,ERF)
            ERS = 0
            RETURN
          ENDIF
          GO TO 206
        ELSE
          IF (SOPWK(INDX) .EQ. WKID) THEN
            GO TO 206
          ENDIF
        ENDIF
        GO TO 205
  206   CONTINUE
      ELSE IF (NUM.EQ.29) THEN
C
C  Check if the workstation is currently active.
C
        DO 207 I=1,MACWK
          IF (SACWK(I) .EQ. WKID) THEN
            IF (ENAM .GE. 0) THEN
              ERS = 1
              CALL GERHND(NUM,ENAM,ERF)
              ERS = 0
              RETURN
            ENDIF
          ENDIF
  207   CONTINUE
      ELSE IF (NUM .EQ. 30) THEN
C
C  Check if the workstation is not active.
C
        INDX = 1
  208   CONTINUE
        IF (SACWK(INDX) .EQ. WKID) GO TO 209
        INDX = INDX+1
        IF (INDX .GT. MACWK) THEN
          IER = NUM
          IF (ENAM .GE. 0) THEN
            ERS = 1
            CALL GERHND(NUM,ENAM,ERF)
            ERS = 0
            RETURN
          ENDIF
          GO TO   209
        ENDIF
        GO TO   208
  209   CONTINUE
      ENDIF
C
      RETURN
      END

      SUBROUTINE SSTEBZ( RANGE, ORDER, N, VL, VU, IL, IU, ABSTOL, D, E,
     $                   M, NSPLIT, W, IBLOCK, ISPLIT, WORK, IWORK,
     $                   INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          ORDER, RANGE
      INTEGER            IL, INFO, IU, M, N, NSPLIT
      REAL               ABSTOL, VL, VU
*     ..
*     .. Array Arguments ..
      INTEGER            IBLOCK( * ), ISPLIT( * ), IWORK( * )
      REAL               D( * ), E( * ), W( * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  SSTEBZ computes the eigenvalues of a symmetric tridiagonal
*  matrix T.  The user may ask for all eigenvalues, all eigenvalues
*  in the half-open interval (VL, VU], or the IL-th through IU-th
*  eigenvalues.
*
*  To avoid overflow, the matrix must be scaled so that its
*  largest element is no greater than overflow**(1/2) *
*  underflow**(1/4) in absolute value, and for greatest
*  accuracy, it should not be much smaller than that.
*
*  See W. Kahan "Accurate Eigenvalues of a Symmetric Tridiagonal
*  Matrix", Report CS41, Computer Science Dept., Stanford
*  University, July 21, 1966.
*
*  Arguments
*  =========
*
*  RANGE   (input) CHARACTER
*          = 'A': ("All")   all eigenvalues will be found.
*          = 'V': ("Value") all eigenvalues in the half-open interval
*                           (VL, VU] will be found.
*          = 'I': ("Index") the IL-th through IU-th eigenvalues (of the
*                           entire matrix) will be found.
*
*  ORDER   (input) CHARACTER
*          = 'B': ("By Block") the eigenvalues will be grouped by
*                              split-off block (see IBLOCK, ISPLIT) and
*                              ordered from smallest to largest within
*                              the block.
*          = 'E': ("Entire matrix")
*                              the eigenvalues for the entire matrix
*                              will be ordered from smallest to
*                              largest.
*
*  N       (input) INTEGER
*          The order of the tridiagonal matrix T.  N >= 0.
*
*  VL      (input) REAL
*  VU      (input) REAL
*          If RANGE='V', the lower and upper bounds of the interval to
*          be searched for eigenvalues.  Eigenvalues less than or equal
*          to VL, or greater than VU, will not be returned.  VL < VU.
*          Not referenced if RANGE = 'A' or 'I'.
*
*  IL      (input) INTEGER
*  IU      (input) INTEGER
*          If RANGE='I', the indices (in ascending order) of the
*          smallest and largest eigenvalues to be returned.
*          1 <= IL <= IU <= N, if N > 0; IL = 1 and IU = 0 if N = 0.
*          Not referenced if RANGE = 'A' or 'V'.
*
*  ABSTOL  (input) REAL
*          The absolute tolerance for the eigenvalues.  An eigenvalue
*          (or cluster) is considered to be located if it has been
*          determined to lie in an interval whose width is ABSTOL or
*          less.  If ABSTOL is less than or equal to zero, then ULP*|T|
*          will be used, where |T| means the 1-norm of T.
*
*          Eigenvalues will be computed most accurately when ABSTOL is
*          set to twice the underflow threshold 2*SLAMCH('S'), not zero.
*
*  D       (input) REAL array, dimension (N)
*          The n diagonal elements of the tridiagonal matrix T.
*
*  E       (input) REAL array, dimension (N-1)
*          The (n-1) off-diagonal elements of the tridiagonal matrix T.
*
*  M       (output) INTEGER
*          The actual number of eigenvalues found. 0 <= M <= N.
*          (See also the description of INFO=2,3.)
*
*  NSPLIT  (output) INTEGER
*          The number of diagonal blocks in the matrix T.
*          1 <= NSPLIT <= N.
*
*  W       (output) REAL array, dimension (N)
*          On exit, the first M elements of W will contain the
*          eigenvalues.  (SSTEBZ may use the remaining N-M elements as
*          workspace.)
*
*  IBLOCK  (output) INTEGER array, dimension (N)
*          At each row/column j where E(j) is zero or small, the
*          matrix T is considered to split into a block diagonal
*          matrix.  On exit, if INFO = 0, IBLOCK(i) specifies to which
*          block (from 1 to the number of blocks) the eigenvalue W(i)
*          belongs.  (SSTEBZ may use the remaining N-M elements as
*          workspace.)
*
*  ISPLIT  (output) INTEGER array, dimension (N)
*          The splitting points, at which T breaks up into submatrices.
*          The first submatrix consists of rows/columns 1 to ISPLIT(1),
*          the second of rows/columns ISPLIT(1)+1 through ISPLIT(2),
*          etc., and the NSPLIT-th consists of rows/columns
*          ISPLIT(NSPLIT-1)+1 through ISPLIT(NSPLIT)=N.
*          (Only the first NSPLIT elements will actually be used, but
*          since the user cannot know a priori what value NSPLIT will
*          have, N words must be reserved for ISPLIT.)
*
*  WORK    (workspace) REAL array, dimension (4*N)
*
*  IWORK   (workspace) INTEGER array, dimension (3*N)
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*          > 0:  some or all of the eigenvalues failed to converge or
*                were not computed:
*                =1 or 3: Bisection failed to converge for some
*                        eigenvalues; these eigenvalues are flagged by a
*                        negative block number.  The effect is that the
*                        eigenvalues may not be as accurate as the
*                        absolute and relative tolerances.  This is
*                        generally caused by unexpectedly inaccurate
*                        arithmetic.
*                =2 or 3: RANGE='I' only: Not all of the eigenvalues
*                        IL:IU were found.
*                        Effect: M < IU+1-IL
*                        Cause:  non-monotonic arithmetic, causing the
*                                Sturm sequence to be non-monotonic.
*                        Cure:   recalculate, using RANGE='A', and pick
*                                out eigenvalues IL:IU.  In some cases,
*                                increasing the PARAMETER "FUDGE" may
*                                make things work.
*                = 4:    RANGE='I', and the Gershgorin interval
*                        initially used was too small.  No eigenvalues
*                        were computed.
*                        Probable cause: your machine has sloppy
*                                        floating-point arithmetic.
*                        Cure: Increase the PARAMETER "FUDGE",
*                              recompile, and try again.
*
*  Internal Parameters
*  ===================
*
*  RELFAC  REAL, default = 2.0e0
*          The relative tolerance.  An interval (a,b] lies within
*          "relative tolerance" if  b-a < RELFAC*ulp*max(|a|,|b|),
*          where "ulp" is the machine precision (distance from 1 to
*          the next larger floating point number.)
*
*  FUDGE   REAL, default = 2
*          A "fudge factor" to widen the Gershgorin intervals.  Ideally,
*          a value of 1 should work, but on machines with sloppy
*          arithmetic, this needs to be larger.  The default for
*          publicly released versions should be large enough to handle
*          the worst machine around.  Note that this has no effect
*          on accuracy of the solution.
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ZERO, ONE, TWO, HALF
      PARAMETER          ( ZERO = 0.0E0, ONE = 1.0E0, TWO = 2.0E0,
     $                   HALF = 1.0E0 / TWO )
      REAL               FUDGE, RELFAC
      PARAMETER          ( FUDGE = 2.0E0, RELFAC = 2.0E0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            NCNVRG, TOOFEW
      INTEGER            IB, IBEGIN, IDISCL, IDISCU, IE, IEND, IINFO,
     $                   IM, IN, IOFF, IORDER, IOUT, IRANGE, ITMAX,
     $                   ITMP1, IW, IWOFF, J, JB, JDISC, JE, NB, NWL,
     $                   NWU
      REAL               ATOLI, BNORM, GL, GU, PIVMIN, RTOLI, SAFEMN,
     $                   TMP1, TMP2, TNORM, ULP, WKILL, WL, WLU, WU, WUL
*     ..
*     .. Local Arrays ..
      INTEGER            IDUMMA( 1 )
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            ILAENV
      REAL               SLAMCH
      EXTERNAL           LSAME, ILAENV, SLAMCH
*     ..
*     .. External Subroutines ..
      EXTERNAL           SLAEBZ, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, INT, LOG, MAX, MIN, SQRT
*     ..
*     .. Executable Statements ..
*
      INFO = 0
*
*     Decode RANGE
*
      IF( LSAME( RANGE, 'A' ) ) THEN
         IRANGE = 1
      ELSE IF( LSAME( RANGE, 'V' ) ) THEN
         IRANGE = 2
      ELSE IF( LSAME( RANGE, 'I' ) ) THEN
         IRANGE = 3
      ELSE
         IRANGE = 0
      END IF
*
*     Decode ORDER
*
      IF( LSAME( ORDER, 'B' ) ) THEN
         IORDER = 2
      ELSE IF( LSAME( ORDER, 'E' ) ) THEN
         IORDER = 1
      ELSE
         IORDER = 0
      END IF
*
*     Check for Errors
*
      IF( IRANGE.LE.0 ) THEN
         INFO = -1
      ELSE IF( IORDER.LE.0 ) THEN
         INFO = -2
      ELSE IF( N.LT.0 ) THEN
         INFO = -3
      ELSE IF( IRANGE.EQ.2 ) THEN
         IF( VL.GE.VU ) INFO = -5
      ELSE IF( IRANGE.EQ.3 .AND. ( IL.LT.1 .OR. IL.GT.MAX( 1, N ) ) )
     $          THEN
         INFO = -6
      ELSE IF( IRANGE.EQ.3 .AND. ( IU.LT.MIN( N, IL ) .OR. IU.GT.N ) )
     $          THEN
         INFO = -7
      END IF
*
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'SSTEBZ', -INFO )
         RETURN
      END IF
*
*     Initialize error flags
*
      INFO = 0
      NCNVRG = .FALSE.
      TOOFEW = .FALSE.
*
*     Quick return if possible
*
      M = 0
      IF( N.EQ.0 )
     $   RETURN
*
*     Simplifications:
*
      IF( IRANGE.EQ.3 .AND. IL.EQ.1 .AND. IU.EQ.N )
     $   IRANGE = 1
*
*     Get machine constants
*     NB is the minimum vector length for vector bisection, or 0
*     if only scalar is to be done.
*
      SAFEMN = SLAMCH( 'S' )
      ULP = SLAMCH( 'P' )
      RTOLI = ULP*RELFAC
      NB = ILAENV( 1, 'SSTEBZ', ' ', N, -1, -1, -1 )
      IF( NB.LE.1 )
     $   NB = 0
*
*     Special Case when N=1
*
      IF( N.EQ.1 ) THEN
         NSPLIT = 1
         ISPLIT( 1 ) = 1
         IF( IRANGE.EQ.2 .AND. ( VL.GE.D( 1 ) .OR. VU.LT.D( 1 ) ) ) THEN
            M = 0
         ELSE
            W( 1 ) = D( 1 )
            IBLOCK( 1 ) = 1
            M = 1
         END IF
         RETURN
      END IF
*
*     Compute Splitting Points
*
      NSPLIT = 1
      WORK( N ) = ZERO
      PIVMIN = ONE
*
CDIR$ NOVECTOR
      DO 10 J = 2, N
         TMP1 = E( J-1 )**2
         IF( ABS( D( J )*D( J-1 ) )*ULP**2+SAFEMN.GT.TMP1 ) THEN
            ISPLIT( NSPLIT ) = J - 1
            NSPLIT = NSPLIT + 1
            WORK( J-1 ) = ZERO
         ELSE
            WORK( J-1 ) = TMP1
            PIVMIN = MAX( PIVMIN, TMP1 )
         END IF
   10 CONTINUE
      ISPLIT( NSPLIT ) = N
      PIVMIN = PIVMIN*SAFEMN
*
*     Compute Interval and ATOLI
*
      IF( IRANGE.EQ.3 ) THEN
*
*        RANGE='I': Compute the interval containing eigenvalues
*                   IL through IU.
*
*        Compute Gershgorin interval for entire (split) matrix
*        and use it as the initial interval
*
         GU = D( 1 )
         GL = D( 1 )
         TMP1 = ZERO
*
         DO 20 J = 1, N - 1
            TMP2 = SQRT( WORK( J ) )
            GU = MAX( GU, D( J )+TMP1+TMP2 )
            GL = MIN( GL, D( J )-TMP1-TMP2 )
            TMP1 = TMP2
   20    CONTINUE
*
         GU = MAX( GU, D( N )+TMP1 )
         GL = MIN( GL, D( N )-TMP1 )
         TNORM = MAX( ABS( GL ), ABS( GU ) )
         GL = GL - FUDGE*TNORM*ULP*N - FUDGE*TWO*PIVMIN
         GU = GU + FUDGE*TNORM*ULP*N + FUDGE*PIVMIN
*
*        Compute Iteration parameters
*
         ITMAX = INT( ( LOG( TNORM+PIVMIN )-LOG( PIVMIN ) ) /
     $           LOG( TWO ) ) + 2
         IF( ABSTOL.LE.ZERO ) THEN
            ATOLI = ULP*TNORM
         ELSE
            ATOLI = ABSTOL
         END IF
*
         WORK( N+1 ) = GL
         WORK( N+2 ) = GL
         WORK( N+3 ) = GU
         WORK( N+4 ) = GU
         WORK( N+5 ) = GL
         WORK( N+6 ) = GU
         IWORK( 1 ) = -1
         IWORK( 2 ) = -1
         IWORK( 3 ) = N + 1
         IWORK( 4 ) = N + 1
         IWORK( 5 ) = IL - 1
         IWORK( 6 ) = IU
*
         CALL SLAEBZ( 3, ITMAX, N, 2, 2, NB, ATOLI, RTOLI, PIVMIN, D, E,
     $                WORK, IWORK( 5 ), WORK( N+1 ), WORK( N+5 ), IOUT,
     $                IWORK, W, IBLOCK, IINFO )
*
         IF( IWORK( 6 ).EQ.IU ) THEN
            WL = WORK( N+1 )
            WLU = WORK( N+3 )
            NWL = IWORK( 1 )
            WU = WORK( N+4 )
            WUL = WORK( N+2 )
            NWU = IWORK( 4 )
         ELSE
            WL = WORK( N+2 )
            WLU = WORK( N+4 )
            NWL = IWORK( 2 )
            WU = WORK( N+3 )
            WUL = WORK( N+1 )
            NWU = IWORK( 3 )
         END IF
*
         IF( NWL.LT.0 .OR. NWL.GE.N .OR. NWU.LT.1 .OR. NWU.GT.N ) THEN
            INFO = 4
            RETURN
         END IF
      ELSE
*
*        RANGE='A' or 'V' -- Set ATOLI
*
         TNORM = MAX( ABS( D( 1 ) )+ABS( E( 1 ) ),
     $           ABS( D( N ) )+ABS( E( N-1 ) ) )
*
         DO 30 J = 2, N - 1
            TNORM = MAX( TNORM, ABS( D( J ) )+ABS( E( J-1 ) )+
     $              ABS( E( J ) ) )
   30    CONTINUE
*
         IF( ABSTOL.LE.ZERO ) THEN
            ATOLI = ULP*TNORM
         ELSE
            ATOLI = ABSTOL
         END IF
*
         IF( IRANGE.EQ.2 ) THEN
            WL = VL
            WU = VU
         ELSE
            WL = ZERO
            WU = ZERO
         END IF
      END IF
*
*     Find Eigenvalues -- Loop Over Blocks and recompute NWL and NWU.
*     NWL accumulates the number of eigenvalues .le. WL,
*     NWU accumulates the number of eigenvalues .le. WU
*
      M = 0
      IEND = 0
      INFO = 0
      NWL = 0
      NWU = 0
*
      DO 70 JB = 1, NSPLIT
         IOFF = IEND
         IBEGIN = IOFF + 1
         IEND = ISPLIT( JB )
         IN = IEND - IOFF
*
         IF( IN.EQ.1 ) THEN
*
*           Special Case -- IN=1
*
            IF( IRANGE.EQ.1 .OR. WL.GE.D( IBEGIN )-PIVMIN )
     $         NWL = NWL + 1
            IF( IRANGE.EQ.1 .OR. WU.GE.D( IBEGIN )-PIVMIN )
     $         NWU = NWU + 1
            IF( IRANGE.EQ.1 .OR. ( WL.LT.D( IBEGIN )-PIVMIN .AND. WU.GE.
     $          D( IBEGIN )-PIVMIN ) ) THEN
               M = M + 1
               W( M ) = D( IBEGIN )
               IBLOCK( M ) = JB
            END IF
         ELSE
*
*           General Case -- IN > 1
*
*           Compute Gershgorin Interval
*           and use it as the initial interval
*
            GU = D( IBEGIN )
            GL = D( IBEGIN )
            TMP1 = ZERO
*
            DO 40 J = IBEGIN, IEND - 1
               TMP2 = ABS( E( J ) )
               GU = MAX( GU, D( J )+TMP1+TMP2 )
               GL = MIN( GL, D( J )-TMP1-TMP2 )
               TMP1 = TMP2
   40       CONTINUE
*
            GU = MAX( GU, D( IEND )+TMP1 )
            GL = MIN( GL, D( IEND )-TMP1 )
            BNORM = MAX( ABS( GL ), ABS( GU ) )
            GL = GL - FUDGE*BNORM*ULP*IN - FUDGE*PIVMIN
            GU = GU + FUDGE*BNORM*ULP*IN + FUDGE*PIVMIN
*
*           Compute ATOLI for the current submatrix
*
            IF( ABSTOL.LE.ZERO ) THEN
               ATOLI = ULP*MAX( ABS( GL ), ABS( GU ) )
            ELSE
               ATOLI = ABSTOL
            END IF
*
            IF( IRANGE.GT.1 ) THEN
               IF( GU.LT.WL ) THEN
                  NWL = NWL + IN
                  NWU = NWU + IN
                  GO TO 70
               END IF
               GL = MAX( GL, WL )
               GU = MIN( GU, WU )
               IF( GL.GE.GU )
     $            GO TO 70
            END IF
*
*           Set Up Initial Interval
*
            WORK( N+1 ) = GL
            WORK( N+IN+1 ) = GU
            CALL SLAEBZ( 1, 0, IN, IN, 1, NB, ATOLI, RTOLI, PIVMIN,
     $                   D( IBEGIN ), E( IBEGIN ), WORK( IBEGIN ),
     $                   IDUMMA, WORK( N+1 ), WORK( N+2*IN+1 ), IM,
     $                   IWORK, W( M+1 ), IBLOCK( M+1 ), IINFO )
*
            NWL = NWL + IWORK( 1 )
            NWU = NWU + IWORK( IN+1 )
            IWOFF = M - IWORK( 1 )
*
*           Compute Eigenvalues
*
            ITMAX = INT( ( LOG( GU-GL+PIVMIN )-LOG( PIVMIN ) ) /
     $              LOG( TWO ) ) + 2
            CALL SLAEBZ( 2, ITMAX, IN, IN, 1, NB, ATOLI, RTOLI, PIVMIN,
     $                   D( IBEGIN ), E( IBEGIN ), WORK( IBEGIN ),
     $                   IDUMMA, WORK( N+1 ), WORK( N+2*IN+1 ), IOUT,
     $                   IWORK, W( M+1 ), IBLOCK( M+1 ), IINFO )
*
*           Copy Eigenvalues Into W and IBLOCK
*           Use -JB for block number for unconverged eigenvalues.
*
            DO 60 J = 1, IOUT
               TMP1 = HALF*( WORK( J+N )+WORK( J+IN+N ) )
*
*              Flag non-convergence.
*
               IF( J.GT.IOUT-IINFO ) THEN
                  NCNVRG = .TRUE.
                  IB = -JB
               ELSE
                  IB = JB
               END IF
               DO 50 JE = IWORK( J ) + 1 + IWOFF,
     $                 IWORK( J+IN ) + IWOFF
                  W( JE ) = TMP1
                  IBLOCK( JE ) = IB
   50          CONTINUE
   60       CONTINUE
*
            M = M + IM
         END IF
   70 CONTINUE
*
*     If RANGE='I', then (WL,WU) contains eigenvalues NWL+1,...,NWU
*     If NWL+1 < IL or NWU > IU, discard extra eigenvalues.
*
      IF( IRANGE.EQ.3 ) THEN
         IM = 0
         IDISCL = IL - 1 - NWL
         IDISCU = NWU - IU
*
         IF( IDISCL.GT.0 .OR. IDISCU.GT.0 ) THEN
            DO 80 JE = 1, M
               IF( W( JE ).LE.WLU .AND. IDISCL.GT.0 ) THEN
                  IDISCL = IDISCL - 1
               ELSE IF( W( JE ).GE.WUL .AND. IDISCU.GT.0 ) THEN
                  IDISCU = IDISCU - 1
               ELSE
                  IM = IM + 1
                  W( IM ) = W( JE )
                  IBLOCK( IM ) = IBLOCK( JE )
               END IF
   80       CONTINUE
            M = IM
         END IF
         IF( IDISCL.GT.0 .OR. IDISCU.GT.0 ) THEN
*
*           Code to deal with effects of bad arithmetic:
*           Some low eigenvalues to be discarded are not in (WL,WLU],
*           or high eigenvalues to be discarded are not in (WUL,WU]
*           so just kill off the smallest IDISCL/largest IDISCU
*           eigenvalues, by simply finding the smallest/largest
*           eigenvalue(s).
*
*           (If N(w) is monotone non-decreasing, this should never
*               happen.)
*
            IF( IDISCL.GT.0 ) THEN
               WKILL = WU
               DO 100 JDISC = 1, IDISCL
                  IW = 0
                  DO 90 JE = 1, M
                     IF( IBLOCK( JE ).NE.0 .AND.
     $                   ( W( JE ).LT.WKILL .OR. IW.EQ.0 ) ) THEN
                        IW = JE
                        WKILL = W( JE )
                     END IF
   90             CONTINUE
                  IBLOCK( IW ) = 0
  100          CONTINUE
            END IF
            IF( IDISCU.GT.0 ) THEN
*
               WKILL = WL
               DO 120 JDISC = 1, IDISCU
                  IW = 0
                  DO 110 JE = 1, M
                     IF( IBLOCK( JE ).NE.0 .AND.
     $                   ( W( JE ).GT.WKILL .OR. IW.EQ.0 ) ) THEN
                        IW = JE
                        WKILL = W( JE )
                     END IF
  110             CONTINUE
                  IBLOCK( IW ) = 0
  120          CONTINUE
            END IF
            IM = 0
            DO 130 JE = 1, M
               IF( IBLOCK( JE ).NE.0 ) THEN
                  IM = IM + 1
                  W( IM ) = W( JE )
                  IBLOCK( IM ) = IBLOCK( JE )
               END IF
  130       CONTINUE
            M = IM
         END IF
         IF( IDISCL.LT.0 .OR. IDISCU.LT.0 ) THEN
            TOOFEW = .TRUE.
         END IF
      END IF
*
*     If ORDER='B', do nothing -- the eigenvalues are already sorted
*        by block.
*     If ORDER='E', sort the eigenvalues from smallest to largest
*
      IF( IORDER.EQ.1 .AND. NSPLIT.GT.1 ) THEN
         DO 150 JE = 1, M - 1
            IE = 0
            TMP1 = W( JE )
            DO 140 J = JE + 1, M
               IF( W( J ).LT.TMP1 ) THEN
                  IE = J
                  TMP1 = W( J )
               END IF
  140       CONTINUE
*
            IF( IE.NE.0 ) THEN
               ITMP1 = IBLOCK( IE )
               W( IE ) = W( JE )
               IBLOCK( IE ) = IBLOCK( JE )
               W( JE ) = TMP1
               IBLOCK( JE ) = ITMP1
            END IF
  150    CONTINUE
      END IF
*
      INFO = 0
      IF( NCNVRG )
     $   INFO = INFO + 1
      IF( TOOFEW )
     $   INFO = INFO + 2
      RETURN
*
*     End of SSTEBZ
*
      END

C
C $Id: curvi.f,v 1.5 2008-07-27 03:10:10 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
C NOTE: If you make any changes to this software, please remember to
C make the same changes to the corresponding double precision routine.
C
      function curvi (xl,xu,n,x,y,yp,sigma)
c
      integer n
      real xl,xu,x(n),y(n),yp(n),sigma
c
c                                 coded by alan kaylor cline
c                           from fitpack -- january 26, 1987
c                        a curve and surface fitting package
c                      a product of pleasant valley software
c                  8603 altus cove, austin, texas 78759, usa
c
c this function integrates a curve specified by a spline
c under tension between two given limits. the subroutine
c curv1 should be called earlier to determine necessary
c parameters.
c
c on input--
c
c   xl and xu contain the upper and lower limits of inte-
c   gration, respectively. (sl need not be less than or
c   equal to xu, curvi (xl,xu,...) .eq. -curvi (xu,xl,...) ).
c
c   n contains the number of points which were specified to
c   determine the curve.
c
c   x and y are arrays containing the abscissae and
c   ordinates, respectively, of the specified points.
c
c   yp is an array from subroutine curv1 containing
c   the values of the second derivatives at the nodes.
c
c and
c
c   sigma contains the tension factor (its sign is ignored).
c
c the parameters n, x, y, yp, and sigma should be input
c unaltered from the output of curv1.
c
c on output--
c
c   curvi contains the integral value.
c
c none of the input parameters are altered.
c
c this function references package modules intrvl and
c snhcsh.
c
c-----------------------------------------------------------
c
c denormalize tension factor
c
      sigmap = abs(sigma)*float(n-1)/(x(n)-x(1))
c
c determine actual upper and lower bounds
c
      xxl = xl
      xxu = xu
      ssign = 1.
      if (xl .lt. xu) go to 1
      xxl = xu
      xxu = xl
      ssign = -1.
      if (xl .gt. xu) go to 1
c
c return zero if xl .eq. xu
c
      curvi = 0.
      return
c
c search for proper intervals
c
    1 ilm1 = intrvl (xxl,x,n)
      il = ilm1+1
      ium1 = intrvl (xxu,x,n)
      iu = ium1+1
      if (il .eq. iu) go to 8
c
c integrate from xxl to x(il)
c
      sum = 0.
      if (xxl .eq. x(il)) go to 3
      del1 = xxl-x(ilm1)
      del2 = x(il)-xxl
      dels = x(il)-x(ilm1)
      t1 = (del1+dels)*del2/(2.*dels)
      t2 = del2*del2/(2.*dels)
      sum = t1*y(il)+t2*y(ilm1)
      if (sigma .eq. 0.) go to 2
      call snhcsh (dummy,c1,sigmap*del1,2)
      call snhcsh (dummy,c2,sigmap*del2,2)
      call snhcsh (ss,cs,sigmap*dels,3)
      sum = sum+((dels*dels*(cs-ss/2.)-del1*del1*(c1-ss/2.))
     *           *yp(il)+del2*del2*(c2-ss/2.)*yp(ilm1))/
     *          (sigmap*sigmap*dels*(1.+ss))
      go to 3
    2 sum = sum-t1*t1*dels*yp(il)/6.
     *         -t2*(del1*(del2+dels)+dels*dels)*yp(ilm1)/12.
c
c integrate over interior intervals
c
    3 if (iu-il .eq. 1) go to 6
      ilp1 = il+1
      do 5 i = ilp1,ium1
        dels = x(i)-x(i-1)
        sum = sum+(y(i)+y(i-1))*dels/2.
        if (sigma .eq. 0.) go to 4
        call snhcsh (ss,cs,sigmap*dels,3)
        sum = sum+(yp(i)+yp(i-1))*dels*(cs-ss/2.)/
     *            (sigmap*sigmap*(1.+ss))
        go to 5
    4   sum = sum-(yp(i)+yp(i-1))*dels*dels*dels/24.
    5   continue
c
c integrate from x(iu-1) to xxu
c
    6 if (xxu .eq. x(ium1)) go to 10
      del1 = xxu-x(ium1)
      del2 = x(iu)-xxu
      dels = x(iu)-x(ium1)
      t1 = del1*del1/(2.*dels)
      t2 = (del2+dels)*del1/(2.*dels)
      sum = sum+t1*y(iu)+t2*y(ium1)
      if (sigma .eq. 0.) go to 7
      call snhcsh (dummy,c1,sigmap*del1,2)
      call snhcsh (dummy,c2,sigmap*del2,2)
      call snhcsh (ss,cs,sigmap*dels,3)
      sum = sum+(yp(iu)*del1*del1*(c1-ss/2.)+yp(ium1)*
     *          (dels*dels*(cs-ss/2.)-del2*del2*(c2-ss/2.)))
     *         /(sigmap*sigmap*dels*(1.+ss))
      go to 10
    7 sum = sum-t1*(del2*(del1+dels)+dels*dels)*yp(iu)/12.
     *         -t2*t2*dels*yp(ium1)/6.
      go to 10
c
c integrate from xxl to xxu
c
    8 delu1 = xxu-x(ium1)
      delu2 = x(iu)-xxu
      dell1 = xxl-x(ium1)
      dell2 = x(iu)-xxl
      dels = x(iu)-x(ium1)
      deli = xxu-xxl
      t1 = (delu1+dell1)*deli/(2.*dels)
      t2 = (delu2+dell2)*deli/(2.*dels)
      sum = t1*y(iu)+t2*y(ium1)
      if (sigma .eq. 0.) go to 9
      call snhcsh (dummy,cu1,sigmap*delu1,2)
      call snhcsh (dummy,cu2,sigmap*delu2,2)
      call snhcsh (dummy,cl1,sigmap*dell1,2)
      call snhcsh (dummy,cl2,sigmap*dell2,2)
      call snhcsh (ss,dummy,sigmap*dels,-1)
      sum = sum+(yp(iu)*(delu1*delu1*(cu1-ss/2.)
     *            -dell1*dell1*(cl1-ss/2.))
     *          +yp(ium1)*(dell2*dell2*(cl2-ss/2.)
     *            -delu2*delu2*(cu2-ss/2.)))/
     *          (sigmap*sigmap*dels*(1.+ss))
      go to 10
    9 sum = sum-t1*(delu2*(dels+delu1)+dell2*(dels+dell1))*
     *             yp(iu)/12.
     *         -t2*(dell1*(dels+dell2)+delu1*(dels+delu2))*
     *             yp(ium1)/12.
c
c correct sign and return
c
   10 curvi = ssign*sum
      return
      end

C
C       $Id: chkcyc.f,v 1.5 2008-07-27 00:17:27 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CHKCYC  (U,V,IMAX,JPTSY,IER)
C
C CHECK FOR CYCLIC CONDITION
C
      DIMENSION       U(IMAX,JPTSY)          ,V(IMAX,JPTSY)
      COMMON /STR01/  IS         ,IEND      ,JS        ,JEND
     1             ,  IEND1      ,JEND1     ,I         ,J
     2             ,  X          ,Y         ,DELX      ,DELY
     3             ,  ICYC1      ,IMSG1     ,IGFL1
C
        SAVE
      DO  10 J=JS,JEND
      IF (U(IS,J).NE.U(IEND,J)) GO TO  20
      IF (V(IS,J).NE.V(IEND,J)) GO TO  20
   10 CONTINUE
C
C MUST BE CYCLIC
C
      RETURN
   20 CONTINUE
C
C MUST NOT BE CYCLIC
C . CHANGE THE PARAMETER AND SET IER = -1
C
      ICYC1 = 0
      IER = -1
      RETURN
C
C-----------------------------------------------------------------------
C REVISION HISTORY
C
C OCTOBER, 1979     FIRST ADDED TO ULIB
C
C OCTOBER, 1980     ADDED BUGS SECTION
C
C JUNE, 1984        REMOVED STATEMENT FUNCTIONS ANDF AND ORF,
C                   CONVERTED TO FORTRAN77 AND GKS.
C
C MAY, 1988         CHANGED CODE (IN SUBROUTINE DRWSTR) WHICH PROTECTS
C                   UX ELEMENTS FROM BECOMING ZERO.  THE ORIGINAL CODE
C                   CAUSED UNDERFLOW ON IBM MACHINES.  (DJK)
C
C MARCH, 1990       FIXED SAVING AND RESTORING OF SET CALL.
C-----------------------------------------------------------------------
C
      END

      SUBROUTINE SSYGST( ITYPE, UPLO, N, A, LDA, B, LDB, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER          UPLO
      INTEGER            INFO, ITYPE, LDA, LDB, N
*     ..
*     .. Array Arguments ..
      REAL               A( LDA, * ), B( LDB, * )
*     ..
*
*  Purpose
*  =======
*
*  SSYGST reduces a real symmetric-definite generalized eigenproblem
*  to standard form.
*
*  If ITYPE = 1, the problem is A*x = lambda*B*x,
*  and A is overwritten by inv(U**T)*A*inv(U) or inv(L)*A*inv(L**T)
*
*  If ITYPE = 2 or 3, the problem is A*B*x = lambda*x or
*  B*A*x = lambda*x, and A is overwritten by U*A*U**T or L**T*A*L.
*
*  B must have been previously factorized as U**T*U or L*L**T by SPOTRF.
*
*  Arguments
*  =========
*
*  ITYPE   (input) INTEGER
*          = 1: compute inv(U**T)*A*inv(U) or inv(L)*A*inv(L**T);
*          = 2 or 3: compute U*A*U**T or L**T*A*L.
*
*  UPLO    (input) CHARACTER
*          = 'U':  Upper triangle of A is stored and B is factored as
*                  U**T*U;
*          = 'L':  Lower triangle of A is stored and B is factored as
*                  L*L**T.
*
*  N       (input) INTEGER
*          The order of the matrices A and B.  N >= 0.
*
*  A       (input/output) REAL array, dimension (LDA,N)
*          On entry, the symmetric matrix A.  If UPLO = 'U', the leading
*          N-by-N upper triangular part of A contains the upper
*          triangular part of the matrix A, and the strictly lower
*          triangular part of A is not referenced.  If UPLO = 'L', the
*          leading N-by-N lower triangular part of A contains the lower
*          triangular part of the matrix A, and the strictly upper
*          triangular part of A is not referenced.
*
*          On exit, if INFO = 0, the transformed matrix, stored in the
*          same format as A.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(1,N).
*
*  B       (input) REAL array, dimension (LDB,N)
*          The triangular factor from the Cholesky factorization of B,
*          as returned by SPOTRF.
*
*  LDB     (input) INTEGER
*          The leading dimension of the array B.  LDB >= max(1,N).
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ONE, HALF
      PARAMETER          ( ONE = 1.0, HALF = 0.5 )
*     ..
*     .. Local Scalars ..
      LOGICAL            UPPER
      INTEGER            K, KB, NB
*     ..
*     .. External Subroutines ..
      EXTERNAL           SSYGS2, SSYMM, SSYR2K, STRMM, STRSM, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            ILAENV
      EXTERNAL           LSAME, ILAENV
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      UPPER = LSAME( UPLO, 'U' )
      IF( ITYPE.LT.1 .OR. ITYPE.GT.3 ) THEN
         INFO = -1
      ELSE IF( .NOT.UPPER .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = -2
      ELSE IF( N.LT.0 ) THEN
         INFO = -3
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -5
      ELSE IF( LDB.LT.MAX( 1, N ) ) THEN
         INFO = -7
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'SSYGST', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
*
*     Determine the block size for this environment.
*
      NB = ILAENV( 1, 'SSYGST', UPLO, N, -1, -1, -1 )
*
      IF( NB.LE.1 .OR. NB.GE.N ) THEN
*
*        Use unblocked code
*
         CALL SSYGS2( ITYPE, UPLO, N, A, LDA, B, LDB, INFO )
      ELSE
*
*        Use blocked code
*
         IF( ITYPE.EQ.1 ) THEN
            IF( UPPER ) THEN
*
*              Compute inv(U')*A*inv(U)
*
               DO 10 K = 1, N, NB
                  KB = MIN( N-K+1, NB )
*
*                 Update the upper triangle of A(k:n,k:n)
*
                  CALL SSYGS2( ITYPE, UPLO, KB, A( K, K ), LDA,
     $                         B( K, K ), LDB, INFO )
                  IF( K+KB.LE.N ) THEN
                     CALL STRSM( 'Left', UPLO, 'Transpose', 'Non-unit',
     $                           KB, N-K-KB+1, ONE, B( K, K ), LDB,
     $                           A( K, K+KB ), LDA )
                     CALL SSYMM( 'Left', UPLO, KB, N-K-KB+1, -HALF,
     $                           A( K, K ), LDA, B( K, K+KB ), LDB, ONE,
     $                           A( K, K+KB ), LDA )
                     CALL SSYR2K( UPLO, 'Transpose', N-K-KB+1, KB, -ONE,
     $                            A( K, K+KB ), LDA, B( K, K+KB ), LDB,
     $                            ONE, A( K+KB, K+KB ), LDA )
                     CALL SSYMM( 'Left', UPLO, KB, N-K-KB+1, -HALF,
     $                           A( K, K ), LDA, B( K, K+KB ), LDB, ONE,
     $                           A( K, K+KB ), LDA )
                     CALL STRSM( 'Right', UPLO, 'No transpose',
     $                           'Non-unit', KB, N-K-KB+1, ONE,
     $                           B( K+KB, K+KB ), LDB, A( K, K+KB ),
     $                           LDA )
                  END IF
   10          CONTINUE
            ELSE
*
*              Compute inv(L)*A*inv(L')
*
               DO 20 K = 1, N, NB
                  KB = MIN( N-K+1, NB )
*
*                 Update the lower triangle of A(k:n,k:n)
*
                  CALL SSYGS2( ITYPE, UPLO, KB, A( K, K ), LDA,
     $                         B( K, K ), LDB, INFO )
                  IF( K+KB.LE.N ) THEN
                     CALL STRSM( 'Right', UPLO, 'Transpose', 'Non-unit',
     $                           N-K-KB+1, KB, ONE, B( K, K ), LDB,
     $                           A( K+KB, K ), LDA )
                     CALL SSYMM( 'Right', UPLO, N-K-KB+1, KB, -HALF,
     $                           A( K, K ), LDA, B( K+KB, K ), LDB, ONE,
     $                           A( K+KB, K ), LDA )
                     CALL SSYR2K( UPLO, 'No transpose', N-K-KB+1, KB,
     $                            -ONE, A( K+KB, K ), LDA, B( K+KB, K ),
     $                            LDB, ONE, A( K+KB, K+KB ), LDA )
                     CALL SSYMM( 'Right', UPLO, N-K-KB+1, KB, -HALF,
     $                           A( K, K ), LDA, B( K+KB, K ), LDB, ONE,
     $                           A( K+KB, K ), LDA )
                     CALL STRSM( 'Left', UPLO, 'No transpose',
     $                           'Non-unit', N-K-KB+1, KB, ONE,
     $                           B( K+KB, K+KB ), LDB, A( K+KB, K ),
     $                           LDA )
                  END IF
   20          CONTINUE
            END IF
         ELSE
            IF( UPPER ) THEN
*
*              Compute U*A*U'
*
               DO 30 K = 1, N, NB
                  KB = MIN( N-K+1, NB )
*
*                 Update the upper triangle of A(1:k+kb-1,1:k+kb-1)
*
                  CALL STRMM( 'Left', UPLO, 'No transpose', 'Non-unit',
     $                        K-1, KB, ONE, B, LDB, A( 1, K ), LDA )
                  CALL SSYMM( 'Right', UPLO, K-1, KB, HALF, A( K, K ),
     $                        LDA, B( 1, K ), LDB, ONE, A( 1, K ), LDA )
                  CALL SSYR2K( UPLO, 'No transpose', K-1, KB, ONE,
     $                         A( 1, K ), LDA, B( 1, K ), LDB, ONE, A,
     $                         LDA )
                  CALL SSYMM( 'Right', UPLO, K-1, KB, HALF, A( K, K ),
     $                        LDA, B( 1, K ), LDB, ONE, A( 1, K ), LDA )
                  CALL STRMM( 'Right', UPLO, 'Transpose', 'Non-unit',
     $                        K-1, KB, ONE, B( K, K ), LDB, A( 1, K ),
     $                        LDA )
                  CALL SSYGS2( ITYPE, UPLO, KB, A( K, K ), LDA,
     $                         B( K, K ), LDB, INFO )
   30          CONTINUE
            ELSE
*
*              Compute L'*A*L
*
               DO 40 K = 1, N, NB
                  KB = MIN( N-K+1, NB )
*
*                 Update the lower triangle of A(1:k+kb-1,1:k+kb-1)
*
                  CALL STRMM( 'Right', UPLO, 'No transpose', 'Non-unit',
     $                        KB, K-1, ONE, B, LDB, A( K, 1 ), LDA )
                  CALL SSYMM( 'Left', UPLO, KB, K-1, HALF, A( K, K ),
     $                        LDA, B( K, 1 ), LDB, ONE, A( K, 1 ), LDA )
                  CALL SSYR2K( UPLO, 'Transpose', K-1, KB, ONE,
     $                         A( K, 1 ), LDA, B( K, 1 ), LDB, ONE, A,
     $                         LDA )
                  CALL SSYMM( 'Left', UPLO, KB, K-1, HALF, A( K, K ),
     $                        LDA, B( K, 1 ), LDB, ONE, A( K, 1 ), LDA )
                  CALL STRMM( 'Left', UPLO, 'Transpose', 'Non-unit', KB,
     $                        K-1, ONE, B( K, K ), LDB, A( K, 1 ), LDA )
                  CALL SSYGS2( ITYPE, UPLO, KB, A( K, K ), LDA,
     $                         B( K, K ), LDB, INFO )
   40          CONTINUE
            END IF
         END IF
      END IF
      RETURN
*
*     End of SSYGST
*
      END

C
C $Id: RLSET.f,v 1.6 1997-05-05 21:45:20 boote Exp $
C
C****************************************************************
C                                                               *
C                       Copyright (C)  1994                     *
C       University Corporation for Atmospheric Research         *
C                       All Rights Reserved                     *
C                                                               *
C****************************************************************
C
C      File:            RLSET.f
C
C      Author:          Jeff W. Boote
C                       National Center for Atmospheric Research
C                       PO 3000, Boulder, Colorado
C
C      Date:            Fri Mar 25 10:54:56 MST 1994
C
C      Description:     This file contains all the "set" subroutines for
C                       the Fortran RL interface to the hlu's.
C
      subroutine nhlfrlsetinteger(id,name,ival,ierr)
        integer id, ival,ierr
        character*(*) name
        call nhlpfrlsetinteger(id,name,len(name),ival,ierr)
      end
C
      subroutine nhlfrlsetfloat(id,name,fval,ierr)
        integer id,ierr
        real fval
        character*(*) name
        call nhlpfrlsetfloat(id,name,len(name),fval,ierr)
      end
C
      subroutine nhlfrlsetdouble(id,name,dval,ierr)
        integer id,ierr
        double precision dval
        character*(*) name
        call nhlpfrlsetdouble(id,name,len(name),dval,ierr)
      end
C
      subroutine nhlfrlsetstring(id,name,sval,ierr)
        integer id,ierr
        character*(*) name,sval
        call nhlpfrlsetstring(id,name,len(name),sval,len(sval),ierr)
      end
C
      subroutine nhlfrlsetmdintegerarray(id,name,iarr,inumdim,ilendim,
     % ierr)
        integer id,iarr(*),inumdim,ilendim,ierr
        character*(*) name
        call nhlpfrlsetmdintegerarray(id,name,len(name),iarr,inumdim,
     %  ilendim,ierr)
      end
C
      subroutine nhlfrlsetmdfloatarray(id,name,farr,inumdim,ilendim,
     %  ierr)
        integer id,inumdim,ilendim,ierr
        character*(*) name
        real farr(*)
        call nhlpfrlsetmdfloatarray(id,name,len(name),farr,inumdim,
     %  ilendim,ierr)
      end
C
      subroutine nhlfrlsetmddoublearray(id,name,darr,inumdim,ilendim,
     %  ierr)
        integer id,inumdim,ilendim,ierr
        character*(*) name
        double precision darr(*)
        call nhlpfrlsetmddoublearray(id,name,len(name),darr,inumdim,
     %  ilendim,ierr)
      end
C
      subroutine nhlfrlsetintegerarray(id,name,iarr,iarr_len,ierr)
        integer id,iarr_len,iarr(iarr_len),ierr
        character*(*) name
        call nhlpfrlsetintegerarray(id,name,len(name),iarr,iarr_len,
     % ierr)
      end
C
      subroutine nhlfrlsetfloatarray(id,name,farr,farr_len,ierr)
        integer id,farr_len,ierr
        character*(*) name
        real farr(farr_len)
        call nhlpfrlsetfloatarray(id,name,len(name),farr,farr_len,ierr)
      end
C
      subroutine nhlfrlsetdoublearray(id,name,darr,darr_len,ierr)
        integer id,darr_len,ierr
        character*(*) name
        double precision darr(darr_len)
        call nhlpfrlsetdoublearray(id,name,len(name),darr,darr_len,ierr)
      end
C
      subroutine nhlfrlsetstringarray(id,name,carr,carr_len,ierr)
        integer id,carr_len,ierr
        character*(*) name
        character*(*) carr(carr_len)
        call nhlpfrlsetstringarray(id,name,len(name),carr,carr_len,
     %  len(carr(1)),ierr)
      end

C
C $Id: errof.f,v 1.7 2008-07-27 00:17:29 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE ERROF
C
C This routine just turns off the error flag.
C
C The common blocks SECOMI and SECOMC are used to hold shared variables
C of types INTEGER and CHARACTER, respectively, for the routine SETER
C and associated routines.  For descriptions of these variables and for
C default values of them, see the block data routine SEBLDAX.
C
        COMMON /SECOMI/ IERRU,IERRF,IRECF,LOMSG
        SAVE   /SECOMI/
C
        COMMON /SECOMC/ ERMSG
          CHARACTER*256 ERMSG
        SAVE   /SECOMC/
C
C Do it.
C
        IERRF=0
C
C Done.
C
        RETURN
C
      END

      SUBROUTINE CHEEVR( JOBZ, RANGE, UPLO, N, A, LDA, VL, VU, IL, IU,
     $                   ABSTOL, M, W, Z, LDZ, ISUPPZ, WORK, LWORK,
     $                   RWORK, LRWORK, IWORK, LIWORK, INFO )
*
*  -- LAPACK driver routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     March 20, 2000
*
*     .. Scalar Arguments ..
      CHARACTER          JOBZ, RANGE, UPLO
      INTEGER            IL, INFO, IU, LDA, LDZ, LIWORK, LRWORK, LWORK,
     $                   M, N
      REAL               ABSTOL, VL, VU
*     ..
*     .. Array Arguments ..
      INTEGER            ISUPPZ( * ), IWORK( * )
      REAL               RWORK( * ), W( * )
      COMPLEX            A( LDA, * ), WORK( * ), Z( LDZ, * )
*     ..
*
*  Purpose
*  =======
*
*  CHEEVR computes selected eigenvalues and, optionally, eigenvectors
*  of a complex Hermitian matrix T.  Eigenvalues and eigenvectors can
*  be selected by specifying either a range of values or a range of
*  indices for the desired eigenvalues.
*
*  Whenever possible, CHEEVR calls CSTEGR to compute the
*  eigenspectrum using Relatively Robust Representations.  CSTEGR
*  computes eigenvalues by the dqds algorithm, while orthogonal
*  eigenvectors are computed from various "good" L D L^T representations
*  (also known as Relatively Robust Representations). Gram-Schmidt
*  orthogonalization is avoided as far as possible. More specifically,
*  the various steps of the algorithm are as follows. For the i-th
*  unreduced block of T,
*     (a) Compute T - sigma_i = L_i D_i L_i^T, such that L_i D_i L_i^T
*          is a relatively robust representation,
*     (b) Compute the eigenvalues, lambda_j, of L_i D_i L_i^T to high
*         relative accuracy by the dqds algorithm,
*     (c) If there is a cluster of close eigenvalues, "choose" sigma_i
*         close to the cluster, and go to step (a),
*     (d) Given the approximate eigenvalue lambda_j of L_i D_i L_i^T,
*         compute the corresponding eigenvector by forming a
*         rank-revealing twisted factorization.
*  The desired accuracy of the output can be specified by the input
*  parameter ABSTOL.
*
*  For more details, see "A new O(n^2) algorithm for the symmetric
*  tridiagonal eigenvalue/eigenvector problem", by Inderjit Dhillon,
*  Computer Science Division Technical Report No. UCB//CSD-97-971,
*  UC Berkeley, May 1997.
*
*
*  Note 1 : CHEEVR calls CSTEGR when the full spectrum is requested
*  on machines which conform to the ieee-754 floating point standard.
*  CHEEVR calls SSTEBZ and CSTEIN on non-ieee machines and
*  when partial spectrum requests are made.
*
*  Normal execution of CSTEGR may create NaNs and infinities and
*  hence may abort due to a floating point exception in environments
*  which do not handle NaNs and infinities in the ieee standard default
*  manner.
*
*  Arguments
*  =========
*
*  JOBZ    (input) CHARACTER*1
*          = 'N':  Compute eigenvalues only;
*          = 'V':  Compute eigenvalues and eigenvectors.
*
*  RANGE   (input) CHARACTER*1
*          = 'A': all eigenvalues will be found.
*          = 'V': all eigenvalues in the half-open interval (VL,VU]
*                 will be found.
*          = 'I': the IL-th through IU-th eigenvalues will be found.
********** For RANGE = 'V' or 'I' and IU - IL < N - 1, SSTEBZ and
********** CSTEIN are called
*
*  UPLO    (input) CHARACTER*1
*          = 'U':  Upper triangle of A is stored;
*          = 'L':  Lower triangle of A is stored.
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  A       (input/output) COMPLEX array, dimension (LDA, N)
*          On entry, the Hermitian matrix A.  If UPLO = 'U', the
*          leading N-by-N upper triangular part of A contains the
*          upper triangular part of the matrix A.  If UPLO = 'L',
*          the leading N-by-N lower triangular part of A contains
*          the lower triangular part of the matrix A.
*          On exit, the lower triangle (if UPLO='L') or the upper
*          triangle (if UPLO='U') of A, including the diagonal, is
*          destroyed.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(1,N).
*
*  VL      (input) REAL
*  VU      (input) REAL
*          If RANGE='V', the lower and upper bounds of the interval to
*          be searched for eigenvalues. VL < VU.
*          Not referenced if RANGE = 'A' or 'I'.
*
*  IL      (input) INTEGER
*  IU      (input) INTEGER
*          If RANGE='I', the indices (in ascending order) of the
*          smallest and largest eigenvalues to be returned.
*          1 <= IL <= IU <= N, if N > 0; IL = 1 and IU = 0 if N = 0.
*          Not referenced if RANGE = 'A' or 'V'.
*
*  ABSTOL  (input) REAL
*          The absolute error tolerance for the eigenvalues.
*          An approximate eigenvalue is accepted as converged
*          when it is determined to lie in an interval [a,b]
*          of width less than or equal to
*
*                  ABSTOL + EPS *   max( |a|,|b| ) ,
*
*          where EPS is the machine precision.  If ABSTOL is less than
*          or equal to zero, then  EPS*|T|  will be used in its place,
*          where |T| is the 1-norm of the tridiagonal matrix obtained
*          by reducing A to tridiagonal form.
*
*          See "Computing Small Singular Values of Bidiagonal Matrices
*          with Guaranteed High Relative Accuracy," by Demmel and
*          Kahan, LAPACK Working Note #3.
*
*          If high relative accuracy is important, set ABSTOL to
*          SLAMCH( 'Safe minimum' ).  Doing so will guarantee that
*          eigenvalues are computed to high relative accuracy when
*          possible in future releases.  The current code does not
*          make any guarantees about high relative accuracy, but
*          furutre releases will. See J. Barlow and J. Demmel,
*          "Computing Accurate Eigensystems of Scaled Diagonally
*          Dominant Matrices", LAPACK Working Note #7, for a discussion
*          of which matrices define their eigenvalues to high relative
*          accuracy.
*
*  M       (output) INTEGER
*          The total number of eigenvalues found.  0 <= M <= N.
*          If RANGE = 'A', M = N, and if RANGE = 'I', M = IU-IL+1.
*
*  W       (output) REAL array, dimension (N)
*          The first M elements contain the selected eigenvalues in
*          ascending order.
*
*  Z       (output) COMPLEX array, dimension (LDZ, max(1,M))
*          If JOBZ = 'V', then if INFO = 0, the first M columns of Z
*          contain the orthonormal eigenvectors of the matrix A
*          corresponding to the selected eigenvalues, with the i-th
*          column of Z holding the eigenvector associated with W(i).
*          If JOBZ = 'N', then Z is not referenced.
*          Note: the user must ensure that at least max(1,M) columns are
*          supplied in the array Z; if RANGE = 'V', the exact value of M
*          is not known in advance and an upper bound must be used.
*
*  LDZ     (input) INTEGER
*          The leading dimension of the array Z.  LDZ >= 1, and if
*          JOBZ = 'V', LDZ >= max(1,N).
*
*  ISUPPZ  (output) INTEGER ARRAY, dimension ( 2*max(1,M) )
*          The support of the eigenvectors in Z, i.e., the indices
*          indicating the nonzero elements in Z. The i-th eigenvector
*          is nonzero only in elements ISUPPZ( 2*i-1 ) through
*          ISUPPZ( 2*i ).
********** Implemented only for RANGE = 'A' or 'I' and IU - IL = N - 1
*
*  WORK    (workspace/output) COMPLEX array, dimension (LWORK)
*          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*
*  LWORK   (input) INTEGER
*          The length of the array WORK.  LWORK >= max(1,2*N).
*          For optimal efficiency, LWORK >= (NB+1)*N,
*          where NB is the max of the blocksize for CHETRD and for
*          CUNMTR as returned by ILAENV.
*
*          If LWORK = -1, then a workspace query is assumed; the routine
*          only calculates the optimal size of the WORK array, returns
*          this value as the first entry of the WORK array, and no error
*          message related to LWORK is issued by XERBLA.
*
*  RWORK   (workspace/output) REAL array, dimension (LRWORK)
*          On exit, if INFO = 0, RWORK(1) returns the optimal
*          (and minimal) LRWORK.
*
* LRWORK  (input) INTEGER
*         The length of the array RWORK.  LRWORK >= max(1,24*N).
*
*         If LRWORK = -1, then a workspace query is assumed; the routine
*         only calculates the optimal size of the RWORK array, returns
*         this value as the first entry of the RWORK array, and no error
*         message related to LRWORK is issued by XERBLA.
*
*  IWORK   (workspace/output) INTEGER array, dimension (LIWORK)
*          On exit, if INFO = 0, IWORK(1) returns the optimal
*          (and minimal) LIWORK.
*
* LIWORK  (input) INTEGER
*         The dimension of the array IWORK.  LIWORK >= max(1,10*N).
*
*         If LIWORK = -1, then a workspace query is assumed; the
*         routine only calculates the optimal size of the IWORK array,
*         returns this value as the first entry of the IWORK array, and
*         no error message related to LIWORK is issued by XERBLA.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*          > 0:  Internal error
*
*  Further Details
*  ===============
*
*  Based on contributions by
*     Inderjit Dhillon, IBM Almaden, USA
*     Osni Marques, LBNL/NERSC, USA
*     Ken Stanley, Computer Science Division, University of
*       California at Berkeley, USA
*
* =====================================================================
*
*     .. Parameters ..
      REAL               ZERO, ONE
      PARAMETER          ( ZERO = 0.0E+0, ONE = 1.0E+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            ALLEIG, INDEIG, LOWER, LQUERY, VALEIG, WANTZ
      CHARACTER          ORDER
      INTEGER            I, IEEEOK, IINFO, IMAX, INDIBL, INDIFL, INDISP,
     $                   INDIWO, INDRD, INDRDD, INDRE, INDREE, INDRWK,
     $                   INDTAU, INDWK, INDWKN, ISCALE, ITMP1, J, JJ,
     $                   LIWMIN, LLWORK, LLWRKN, LRWMIN, LWKOPT, LWMIN,
     $                   NB, NSPLIT
      REAL               ABSTLL, ANRM, BIGNUM, EPS, RMAX, RMIN, SAFMIN,
     $                   SIGMA, SMLNUM, TMP1, VLL, VUU
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            ILAENV
      REAL               CLANSY, SLAMCH
      EXTERNAL           LSAME, ILAENV, CLANSY, SLAMCH
*     ..
*     .. External Subroutines ..
      EXTERNAL           CHETRD, CSSCAL, CSTEGR, CSTEIN, CSWAP, CUNMTR,
     $                   SCOPY, SSCAL, SSTEBZ, SSTERF, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN, REAL, SQRT
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      IEEEOK = ILAENV( 10, 'CHEEVR', 'N', 1, 2, 3, 4 )
*
      LOWER = LSAME( UPLO, 'L' )
      WANTZ = LSAME( JOBZ, 'V' )
      ALLEIG = LSAME( RANGE, 'A' )
      VALEIG = LSAME( RANGE, 'V' )
      INDEIG = LSAME( RANGE, 'I' )
*
      LQUERY = ( ( LWORK.EQ.-1 ) .OR. ( LRWORK.EQ.-1 ) .OR.
     $         ( LIWORK.EQ.-1 ) )
*
      LRWMIN = MAX( 1, 24*N )
      LIWMIN = MAX( 1, 10*N )
      LWMIN = MAX( 1, 2*N )
*
      INFO = 0
      IF( .NOT.( WANTZ .OR. LSAME( JOBZ, 'N' ) ) ) THEN
         INFO = -1
      ELSE IF( .NOT.( ALLEIG .OR. VALEIG .OR. INDEIG ) ) THEN
         INFO = -2
      ELSE IF( .NOT.( LOWER .OR. LSAME( UPLO, 'U' ) ) ) THEN
         INFO = -3
      ELSE IF( N.LT.0 ) THEN
         INFO = -4
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -6
      ELSE
         IF( VALEIG ) THEN
            IF( N.GT.0 .AND. VU.LE.VL )
     $         INFO = -8
         ELSE IF( INDEIG ) THEN
            IF( IL.LT.1 .OR. IL.GT.MAX( 1, N ) ) THEN
               INFO = -9
            ELSE IF( IU.LT.MIN( N, IL ) .OR. IU.GT.N ) THEN
               INFO = -10
            END IF
         END IF
      END IF
      IF( INFO.EQ.0 ) THEN
         IF( LDZ.LT.1 .OR. ( WANTZ .AND. LDZ.LT.N ) ) THEN
            INFO = -15
         ELSE IF( LWORK.LT.LWMIN .AND. .NOT.LQUERY ) THEN
            INFO = -18
         ELSE IF( LRWORK.LT.LRWMIN .AND. .NOT.LQUERY ) THEN
            INFO = -20
         ELSE IF( LIWORK.LT.LIWMIN .AND. .NOT.LQUERY ) THEN
            INFO = -22
         END IF
      END IF
*
      IF( INFO.EQ.0 ) THEN
         NB = ILAENV( 1, 'CHETRD', UPLO, N, -1, -1, -1 )
         NB = MAX( NB, ILAENV( 1, 'CUNMTR', UPLO, N, -1, -1, -1 ) )
         LWKOPT = MAX( ( NB+1 )*N, LWMIN )
         WORK( 1 ) = LWKOPT
         RWORK( 1 ) = LRWMIN
         IWORK( 1 ) = LIWMIN
      END IF
*
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'CHEEVR', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         RETURN
      END IF
*
*     Quick return if possible
*
      M = 0
      IF( N.EQ.0 ) THEN
         WORK( 1 ) = 1
         RETURN
      END IF
*
      IF( N.EQ.1 ) THEN
         WORK( 1 ) = 7
         IF( ALLEIG .OR. INDEIG ) THEN
            M = 1
            W( 1 ) = REAL( A( 1, 1 ) )
         ELSE
            IF( VL.LT.REAL( A( 1, 1 ) ) .AND. VU.GE.REAL( A( 1, 1 ) ) )
     $           THEN
               M = 1
               W( 1 ) = REAL( A( 1, 1 ) )
            END IF
         END IF
         IF( WANTZ )
     $      Z( 1, 1 ) = ONE
         RETURN
      END IF
*
*     Get machine constants.
*
      SAFMIN = SLAMCH( 'Safe minimum' )
      EPS = SLAMCH( 'Precision' )
      SMLNUM = SAFMIN / EPS
      BIGNUM = ONE / SMLNUM
      RMIN = SQRT( SMLNUM )
      RMAX = MIN( SQRT( BIGNUM ), ONE / SQRT( SQRT( SAFMIN ) ) )
*
*     Scale matrix to allowable range, if necessary.
*
      ISCALE = 0
      ABSTLL = ABSTOL
      VLL = VL
      VUU = VU
      ANRM = CLANSY( 'M', UPLO, N, A, LDA, RWORK )
      IF( ANRM.GT.ZERO .AND. ANRM.LT.RMIN ) THEN
         ISCALE = 1
         SIGMA = RMIN / ANRM
      ELSE IF( ANRM.GT.RMAX ) THEN
         ISCALE = 1
         SIGMA = RMAX / ANRM
      END IF
      IF( ISCALE.EQ.1 ) THEN
         IF( LOWER ) THEN
            DO 10 J = 1, N
               CALL CSSCAL( N-J+1, SIGMA, A( J, J ), 1 )
   10       CONTINUE
         ELSE
            DO 20 J = 1, N
               CALL CSSCAL( J, SIGMA, A( 1, J ), 1 )
   20       CONTINUE
         END IF
         IF( ABSTOL.GT.0 )
     $      ABSTLL = ABSTOL*SIGMA
         IF( VALEIG ) THEN
            VLL = VL*SIGMA
            VUU = VU*SIGMA
         END IF
      END IF
*
*     Call CHETRD to reduce Hermitian matrix to tridiagonal form.
*
      INDTAU = 1
      INDWK = INDTAU + N
*
      INDRE = 1
      INDRD = INDRE + N
      INDREE = INDRD + N
      INDRDD = INDREE + N
      INDRWK = INDRDD + N
      LLWORK = LWORK - INDWK + 1
      CALL CHETRD( UPLO, N, A, LDA, RWORK( INDRD ), RWORK( INDRE ),
     $             WORK( INDTAU ), WORK( INDWK ), LLWORK, IINFO )
*
*     If all eigenvalues are desired
*     then call SSTERF or CSTEGR and CUNMTR.
*
      IF( ( ALLEIG .OR. ( INDEIG .AND. IL.EQ.1 .AND. IU.EQ.N ) ) .AND.
     $    IEEEOK.EQ.1 ) THEN
         IF( .NOT.WANTZ ) THEN
            CALL SCOPY( N, RWORK( INDRD ), 1, W, 1 )
            CALL SCOPY( N-1, RWORK( INDRE ), 1, RWORK( INDREE ), 1 )
            CALL SSTERF( N, W, RWORK( INDREE ), INFO )
         ELSE
            CALL SCOPY( N-1, RWORK( INDRE ), 1, RWORK( INDREE ), 1 )
            CALL SCOPY( N, RWORK( INDRD ), 1, RWORK( INDRDD ), 1 )
*
            CALL CSTEGR( JOBZ, 'A', N, RWORK( INDRDD ),
     $                   RWORK( INDREE ), VL, VU, IL, IU, ABSTOL, M, W,
     $                   Z, LDZ, ISUPPZ, RWORK( INDRWK ), LWORK, IWORK,
     $                   LIWORK, INFO )
*
*
*
*        Apply unitary matrix used in reduction to tridiagonal
*        form to eigenvectors returned by CSTEIN.
*
            IF( WANTZ .AND. INFO.EQ.0 ) THEN
               INDWKN = INDWK
               LLWRKN = LWORK - INDWKN + 1
               CALL CUNMTR( 'L', UPLO, 'N', N, M, A, LDA,
     $                      WORK( INDTAU ), Z, LDZ, WORK( INDWKN ),
     $                      LLWRKN, IINFO )
            END IF
         END IF
*
*
         IF( INFO.EQ.0 ) THEN
            M = N
            GO TO 30
         END IF
         INFO = 0
      END IF
*
*     Otherwise, call SSTEBZ and, if eigenvectors are desired, CSTEIN.
*     Also call SSTEBZ and CSTEIN if CSTEGR fails.
*
      IF( WANTZ ) THEN
         ORDER = 'B'
      ELSE
         ORDER = 'E'
      END IF
      INDIFL = 1
      INDIBL = INDIFL + N
      INDISP = INDIBL + N
      INDIWO = INDISP + N
      CALL SSTEBZ( RANGE, ORDER, N, VLL, VUU, IL, IU, ABSTLL,
     $             RWORK( INDRD ), RWORK( INDRE ), M, NSPLIT, W,
     $             IWORK( INDIBL ), IWORK( INDISP ), RWORK( INDRWK ),
     $             IWORK( INDIWO ), INFO )
*
      IF( WANTZ ) THEN
         CALL CSTEIN( N, RWORK( INDRD ), RWORK( INDRE ), M, W,
     $                IWORK( INDIBL ), IWORK( INDISP ), Z, LDZ,
     $                RWORK( INDRWK ), IWORK( INDIWO ), IWORK( INDIFL ),
     $                INFO )
*
*        Apply unitary matrix used in reduction to tridiagonal
*        form to eigenvectors returned by CSTEIN.
*
         INDWKN = INDWK
         LLWRKN = LWORK - INDWKN + 1
         CALL CUNMTR( 'L', UPLO, 'N', N, M, A, LDA, WORK( INDTAU ), Z,
     $                LDZ, WORK( INDWKN ), LLWRKN, IINFO )
      END IF
*
*     If matrix was scaled, then rescale eigenvalues appropriately.
*
   30 CONTINUE
      IF( ISCALE.EQ.1 ) THEN
         IF( INFO.EQ.0 ) THEN
            IMAX = M
         ELSE
            IMAX = INFO - 1
         END IF
         CALL SSCAL( IMAX, ONE / SIGMA, W, 1 )
      END IF
*
*     If eigenvalues are not in order, then sort them, along with
*     eigenvectors.
*
      IF( WANTZ ) THEN
         DO 50 J = 1, M - 1
            I = 0
            TMP1 = W( J )
            DO 40 JJ = J + 1, M
               IF( W( JJ ).LT.TMP1 ) THEN
                  I = JJ
                  TMP1 = W( JJ )
               END IF
   40       CONTINUE
*
            IF( I.NE.0 ) THEN
               ITMP1 = IWORK( INDIBL+I-1 )
               W( I ) = W( J )
               IWORK( INDIBL+I-1 ) = IWORK( INDIBL+J-1 )
               W( J ) = TMP1
               IWORK( INDIBL+J-1 ) = ITMP1
               CALL CSWAP( N, Z( 1, I ), 1, Z( 1, J ), 1 )
            END IF
   50    CONTINUE
      END IF
*
*     Set WORK(1) to optimal workspace size.
*
      WORK( 1 ) = LWKOPT
      RWORK( 1 ) = LRWMIN
      IWORK( 1 ) = LIWMIN
*
      RETURN
*
*     End of CHEEVR
*
      END

C
C $Id: mpsetd.f,v 1.8 2008-09-18 00:42:18 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MPSETD (WHCH,DVAL)
        CHARACTER*(*)    WHCH
        DOUBLE PRECISION DVAL
        IF (ICFELL('MPSETD - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
        CALL MDSETD (WHCH,DVAL)
        IF (ICFELL('MPSETD',2).NE.0) RETURN
        RETURN
      END

      SUBROUTINE DGENDAT(DATA,IDIM,M,N,MLOW,MHGH,DLOW,DHGH,ISEED)
      DOUBLE PRECISION DATA
      DOUBLE PRECISION DLOW
      DOUBLE PRECISION DHGH
      DOUBLE PRECISION CCNT
      DOUBLE PRECISION FOVM
      DOUBLE PRECISION FOVN
      DOUBLE PRECISION DFRAN
      DOUBLE PRECISION DMIN
      DOUBLE PRECISION DMAX
      DOUBLE PRECISION TEMP
C
C This is a routine to generate test data for two-dimensional graphics
C routines.  Given an array "DATA", dimensioned "IDIM x 1", it fills
C the sub-array ((DATA(I,J),I=1,M),J=1,N) with a two-dimensional field
C of data having approximately "MLOW" lows and "MHGH" highs, a minimum
C value of exactly "DLOW" and a maximum value of exactly "DHGH".
C
C "MLOW" and "MHGH" are each forced to be greater than or equal to 1
C and less than or equal to 25.
C
C "ISEED" is forced to be 0 if it is < 0 or > 100.
C
C The function used is a sum of exponentials.
C
      DIMENSION DATA(IDIM,1),CCNT(3,50)
C
      FOVM = 9.D0/DBLE(M)
      FOVN = 9.D0/DBLE(N)
C
C This is all being done inside NCL C wrapper, so redundant, but safe.
C
      IF(ISEED.LT.0.OR.ISEED.GT.100) THEN
        JSEED = 0
      ELSE
        JSEED = ISEED
      ENDIF
      NLOW = MAX0(1,MIN0(25,MLOW))
      NHGH = MAX0(1,MIN0(25,MHGH))
      NCNT = NLOW + NHGH
C
      DO 101 K = 1,NCNT
          CCNT(1,K) = 1.D0 + (DBLE(M)-1.D0)*DFRAN(JSEED)
          CCNT(2,K) = 1.D0 + (DBLE(N)-1.D0)*DFRAN(JSEED)
          IF (K.LE.NLOW) THEN
              CCNT(3,K) = -1.D0
          ELSE
              CCNT(3,K) = +1.D0
          END IF
  101 CONTINUE
C
      DMIN = +1.D36
      DMAX = -1.D36
      DO 104 J = 1,N
          DO 103 I = 1,M
              DATA(I,J) = .5D0* (DLOW+DHGH)
              DO 102 K = 1,NCNT
                  TEMP = - ((FOVM* (DBLE(I)-CCNT(1,K)))**2+
     +                   (FOVN* (DBLE(J)-CCNT(2,K)))**2)
                  IF (TEMP.GE.-20.D0) DATA(I,J) = DATA(I,J) +
     +                .5D0* (DHGH-DLOW)*CCNT(3,K)*EXP(TEMP)
  102         CONTINUE
              DMIN = DMIN1(DMIN,DATA(I,J))
              DMAX = DMAX1(DMAX,DATA(I,J))
  103     CONTINUE
  104 CONTINUE
C
      DO 106 J = 1,N
          DO 105 I = 1,M
              DATA(I,J) = (DATA(I,J)-DMIN)/ (DMAX-DMIN)* (DHGH-DLOW) +
     +                    DLOW
  105     CONTINUE
  106 CONTINUE
C
      RETURN
C
      END


      FUNCTION DFRAN(ISEQ)
      DOUBLE PRECISION DFRAN
      DOUBLE PRECISION RSEQ
 
      DIMENSION RSEQ(100)
C      SAVE ISEQ
      DATA RSEQ/.749D0,.973D0,.666D0,.804D0,.081D0,.483D0,.919D0,.903D0,
     +     .951D0,.960D0,.039D0,.269D0,.270D0,.756D0,.222D0,.478D0,
     +     .621D0,.063D0,.550D0,.798D0,.027D0,.569D0,.149D0,.697D0,
     +     .451D0,.738D0,.508D0,.041D0,.266D0,.249D0,.019D0,.191D0,
     +     .266D0,.625D0,.492D0,.940D0,.508D0,.406D0,.972D0,.311D0,
     +     .757D0,.378D0,.299D0,.536D0,.619D0,.844D0,.342D0,.295D0,
     +     .447D0,.499D0,.688D0,.193D0,.225D0,.520D0,.954D0,.749D0,
     +     .997D0,.693D0,.217D0,.273D0,.961D0,.948D0,.902D0,.104D0,
     +     .495D0,.257D0,.524D0,.100D0,.492D0,.347D0,.981D0,.019D0,
     +     .225D0,.806D0,.678D0,.710D0,.235D0,.600D0,.994D0,.758D0,
     +     .682D0,.373D0,.009D0,.469D0,.203D0,.730D0,.588D0,.603D0,
     +     .213D0,.495D0,.884D0,.032D0,.185D0,.127D0,.010D0,.180D0,
     +     .689D0,.354D0,.372D0,.429D0/
C      DATA ISEQ/0/

      ISEQ = MOD(ISEQ,100) + 1
      DFRAN = RSEQ(ISEQ)
      RETURN
      END

c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by UCAR                 .
c  .                                                             .
c  .       University Corporation for Atmospheric Research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                         SPHEREPACK                          .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c
c ... file shsgc.f
c
c     this file contains code and documentation for subroutines
c     shsgc and shsgci
c
c ... files which must be loaded with shsgc.f
c
c     sphcom.f, hrfft.f, gaqd.f
c
c     subroutine shsgc(nlat,nlon,isym,nt,g,idg,jdg,a,b,mdab,ndab,
c    +                 wshsgc,lshsgc,work,lwork,ierror)
c
c     subroutine shsgc performs the spherical harmonic synthesis
c     on the arrays a and b and stores the result in the array g.
c     the synthesis is performed on an equally spaced longitude grid
c     and a gaussian colatitude grid.  the associated legendre functions
c     are recomputed rather than stored as they are in subroutine
c     shsgs.  the synthesis is described below at output parameter
c     g.
c
c     input parameters
c
c     nlat   the number of points in the gaussian colatitude grid on the
c            full sphere. these lie in the interval (0,pi) and are compu
c            in radians in theta(1),...,theta(nlat) by subroutine gaqd.
c            if nlat is odd the equator will be included as the grid poi
c            theta((nlat+1)/2).  if nlat is even the equator will be
c            excluded as a grid point and will lie half way between
c            theta(nlat/2) and theta(nlat/2+1). nlat must be at least 3.
c            note: on the half sphere, the number of grid points in the
c            colatitudinal direction is nlat/2 if nlat is even or
c            (nlat+1)/2 if nlat is odd.
c
c     nlon   the number of distinct londitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater
c            than or equal to 4. the efficiency of the computation is
c            improved when nlon is a product of small prime numbers.
c
c     isym   = 0  no symmetries exist about the equator. the synthesis
c                 is performed on the entire sphere.  i.e. on the
c                 array g(i,j) for i=1,...,nlat and j=1,...,nlon.
c                 (see description of g below)
c
c            = 1  g is antisymmetric about the equator. the synthesis
c                 is performed on the northern hemisphere only.  i.e.
c                 if nlat is odd the synthesis is performed on the
c                 array g(i,j) for i=1,...,(nlat+1)/2 and j=1,...,nlon.
c                 if nlat is even the synthesis is performed on the
c                 array g(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
c
c
c            = 2  g is symmetric about the equator. the synthesis is
c                 performed on the northern hemisphere only.  i.e.
c                 if nlat is odd the synthesis is performed on the
c                 array g(i,j) for i=1,...,(nlat+1)/2 and j=1,...,nlon.
c                 if nlat is even the synthesis is performed on the
c                 array g(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
c
c     nt     the number of syntheses.  in the program that calls shsgc,
c            the arrays g,a and b can be three dimensional in which
c            case multiple synthesis will be performed.  the third
c            index is the synthesis index which assumes the values
c            k=1,...,nt.  for a single synthesis set nt=1. the
c            discription of the remaining parameters is simplified
c            by assuming that nt=1 or that the arrays g,a and b
c            have only two dimensions.
c
c     idg    the first dimension of the array g as it appears in the
c            program that calls shsgc. if isym equals zero then idg
c            must be at least nlat.  if isym is nonzero then idg must
c            be at least nlat/2 if nlat is even or at least (nlat+1)/2
c            if nlat is odd.
c
c     jdg    the second dimension of the array g as it appears in the
c            program that calls shsgc. jdg must be at least nlon.
c
c     mdab   the first dimension of the arrays a and b as it appears
c            in the program that calls shsgc. mdab must be at least
c            min0((nlon+2)/2,nlat) if nlon is even or at least
c            min0((nlon+1)/2,nlat) if nlon is odd
c
c     ndab   the second dimension of the arrays a and b as it appears
c            in the program that calls shsgc. ndab must be at least nlat
c
c     a,b    two or three dimensional arrays (see the input parameter
c            nt) that contain the coefficients in the spherical harmonic
c            expansion of g(i,j) given below at the definition of the
c            output parameter g.  a(m,n) and b(m,n) are defined for
c            indices m=1,...,mmax and n=m,...,nlat where mmax is the
c            maximum (plus one) longitudinal wave number given by
c            mmax = min0(nlat,(nlon+2)/2) if nlon is even or
c            mmax = min0(nlat,(nlon+1)/2) if nlon is odd.
c
c     wshsgc an array which must be initialized by subroutine shsgci.
c            once initialized, wshsgc can be used repeatedly by shsgc
c            as long as nlat and nlon remain unchanged.  wshsgc must
c            not be altered between calls of shsgc.
c
c     lshsgc the dimension of the array wshsgc as it appears in the
c            program that calls shsgc. define
c
c               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            then lshsgc must be at least
c
c               nlat*(2*l2+3*l1-2)+3*l1*(1-l1)/2+nlon+15
c
c     work   a work array that does not have to be saved.
c
c     lwork  the dimension of the array work as it appears in the
c            program that calls shsgc. define
c
c               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            if isym is zero then lwork must be at least
c
c                      nlat*(nlon*nt+max0(3*l2,nlon))
c
c            if isym is not zero then lwork must be at least
c
c                      l2*(nlon*nt+max0(3*nlat,nlon))
c
c     **************************************************************
c
c     output parameters
c
c     g      a two or three dimensional array (see input parameter nt)
c            that contains the discrete function which is synthesized.
c            g(i,j) contains the value of the function at the gaussian
c            colatitude point theta(i) and longitude point
c            phi(j) = (j-1)*2*pi/nlon. the index ranges are defined
c            above at the input parameter isym.  for isym=0, g(i,j)
c            is given by the the equations listed below.  symmetric
c            versions are used when isym is greater than zero.
c
c     the normalized associated legendre functions are given by
c
c     pbar(m,n,theta) = sqrt((2*n+1)*factorial(n-m)/(2*factorial(n+m)))
c                       *sin(theta)**m/(2**n*factorial(n)) times the
c                       (n+m)th derivative of (x**2-1)**n with respect
c                       to x=cos(theta)
c
c
c     define the maximum (plus one) longitudinal wave number
c     as   mmax = min0(nlat,(nlon+2)/2) if nlon is even or
c          mmax = min0(nlat,(nlon+1)/2) if nlon is odd.
c
c     then g(i,j) = the sum from n=0 to n=nlat-1 of
c
c                   .5*pbar(0,n,theta(i))*a(1,n+1)
c
c              plus the sum from m=1 to m=mmax-1 of
c
c                   the sum from n=m to n=nlat-1 of
c
c              pbar(m,n,theta(i))*(a(m+1,n+1)*cos(m*phi(j))
c                                    -b(m+1,n+1)*sin(m*phi(j)))
c
c     ierror = 0  no errors
c            = 1  error in the specification of nlat
c            = 2  error in the specification of nlon
c            = 3  error in the specification of isym
c            = 4  error in the specification of nt
c            = 5  error in the specification of idg
c            = 6  error in the specification of jdg
c            = 7  error in the specification of mdab
c            = 8  error in the specification of ndab
c            = 9  error in the specification of lwshig
c            = 10 error in the specification of lwork
c
c
c ****************************************************************
c
c     subroutine shsgci(nlat,nlon,wshsgc,lshsgc,dwork,ldwork,ierror)
c
c     subroutine shsgci initializes the array wshsgc which can then
c     be used repeatedly by subroutines shsgc. it precomputes
c     and stores in wshsgc quantities such as gaussian weights,
c     legendre polynomial coefficients, and fft trigonometric tables.
c
c     input parameters
c
c     nlat   the number of points in the gaussian colatitude grid on the
c            full sphere. these lie in the interval (0,pi) and are compu
c            in radians in theta(1),...,theta(nlat) by subroutine gaqd.
c            if nlat is odd the equator will be included as the grid poi
c            theta((nlat+1)/2).  if nlat is even the equator will be
c            excluded as a grid point and will lie half way between
c            theta(nlat/2) and theta(nlat/2+1). nlat must be at least 3.
c            note: on the half sphere, the number of grid points in the
c            colatitudinal direction is nlat/2 if nlat is even or
c            (nlat+1)/2 if nlat is odd.
c
c     nlon   the number of distinct londitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater
c            than or equal to 4. the efficiency of the computation is
c            improved when nlon is a product of small prime numbers.
c
c     wshsgc an array which must be initialized by subroutine shsgci.
c            once initialized, wshsgc can be used repeatedly by shsgc
c            as long as nlat and nlon remain unchanged.  wshsgc must
c            not be altered between calls of shsgc.
c
c     lshsgc the dimension of the array wshsgc as it appears in the
c            program that calls shsgc. define
c
c               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            then lshsgc must be at least
c
c                  nlat*(2*l2+3*l1-2)+3*l1*(1-l1)/2+nlon+15
c
C*PL*ERROR* Comment line too long
c     dwork  a double precision work array that does not have to be saved.
c
c     ldwork the dimension of the array dwork as it appears in the
c            program that calls shsgci. ldwork must be at least
c
c                 nlat*(nlat+4)
c
c     output parameter
c
c     wshsgc an array which must be initialized before calling shsgc.
c            once initialized, wshsgc can be used repeatedly by shsgc
c            as long as nlat and nlon remain unchanged.  wshsgc must not
c            altered between calls of shsgc.
c
c     ierror = 0  no errors
c            = 1  error in the specification of nlat
c            = 2  error in the specification of nlon
c            = 3  error in the specification of lshsgc
c            = 4  error in the specification of ldwork
c            = 5  failure in gaqd to compute gaussian points
c                 (due to failure in eigenvalue routine)
c
c
c ****************************************************************
      SUBROUTINE DSHSGC(NLAT,NLON,MODE,NT,G,IDG,JDG,A,B,MDAB,NDAB,
     +                  WSHSGC,LSHSGC,WORK,LWORK,IERROR)
      DOUBLE PRECISION G
      DOUBLE PRECISION A
      DOUBLE PRECISION B
      DOUBLE PRECISION WSHSGC
      DOUBLE PRECISION WORK
c     subroutine shsgc performs the spherical harmonic synthesis on
c     a gaussian grid using the coefficients in array(s) a,b and returns
c     the results in array(s) g.  the legendre polynomials are computed
c     as needed in this version.
c
      DIMENSION G(IDG,JDG,1),A(MDAB,NDAB,1),B(MDAB,NDAB,1),
     +          WSHSGC(LSHSGC),WORK(LWORK)
c     check input parameters
      IERROR = 1
      IF (NLAT.LT.3) RETURN
      IERROR = 2
      IF (NLON.LT.4) RETURN
      IERROR = 3
      IF (MODE.LT.0 .OR. MODE.GT.2) RETURN
      IERROR = 4
      IF (NT.LT.1) RETURN
c     set limit for m iin a(m,n),b(m,n) computation
      L = MIN0((NLON+2)/2,NLAT)
c     set gaussian point nearest equator pointer
      LATE = (NLAT+MOD(NLAT,2))/2
c     set number of grid points for analysis/synthesis
      LAT = NLAT
      IF (MODE.NE.0) LAT = LATE
      IERROR = 5
      IF (IDG.LT.LAT) RETURN
      IERROR = 6
      IF (JDG.LT.NLON) RETURN
      IERROR = 7
      IF (MDAB.LT.L) RETURN
      IERROR = 8
      IF (NDAB.LT.NLAT) RETURN
      L1 = L
      L2 = LATE
      IERROR = 9
c     check permanent work space length
      IF (LSHSGC.LT.NLAT* (2*L2+3*L1-2)+3*L1* (1-L1)/2+NLON+15) RETURN
      IERROR = 10
c     check temporary work space length
      IF (MODE.EQ.0) THEN
          IF (LWORK.LT.NLAT* (NLON*NT+MAX0(3*L2,NLON))) RETURN
      ELSE
c     mode.ne.0
          IF (LWORK.LT.L2* (NLON*NT+MAX0(3*NLAT,NLON))) RETURN
      END IF
      IERROR = 0
c     starting address  fft values
      IFFT = NLAT + 2*NLAT*LATE + 3* (L* (L-1)/2+ (NLAT-L)* (L-1)) + 1
c     set pointers for internal storage of g and legendre polys
      IPMN = LAT*NLON*NT + 1
      CALL DSHSGC1(NLAT,NLON,L,LAT,MODE,G,IDG,JDG,NT,A,B,MDAB,NDAB,
     +             WSHSGC,WSHSGC(IFFT),LATE,WORK(IPMN),WORK)
      RETURN
      END
      SUBROUTINE DSHSGC1(NLAT,NLON,L,LAT,MODE,GS,IDG,JDG,NT,A,B,MDAB,
     +                  NDAB,W,WFFT,LATE,PMN,G)
      DOUBLE PRECISION GS
      DOUBLE PRECISION A
      DOUBLE PRECISION B
      DOUBLE PRECISION W
      DOUBLE PRECISION WFFT
      DOUBLE PRECISION PMN
      DOUBLE PRECISION G
      DOUBLE PRECISION T1
      DOUBLE PRECISION T3
      DOUBLE PRECISION T2
      DOUBLE PRECISION T4
      DIMENSION GS(IDG,JDG,NT),A(MDAB,NDAB,NT),B(MDAB,NDAB,NT)
      DIMENSION W(1),PMN(NLAT,LATE,3),G(LAT,NLON,NT),WFFT(1)
c     reconstruct fourier coefficients in g on gaussian grid
c     using coefficients in a,b
c     set m+1 limit for b coefficient calculation
      LM1 = L
      IF (NLON.EQ.L+L-2) LM1 = L - 1
c     initialize to zero
      DO 100 K = 1,NT
          DO 100 J = 1,NLON
              DO 100 I = 1,LAT
                  G(I,J,K) = 0.0D0
  100 CONTINUE
      IF (MODE.EQ.0) THEN
c     set first column in g
          M = 0
c     compute pmn for all i and n=m,...,l-1
          CALL DLEGIN(MODE,L,NLAT,M,W,PMN,KM)
          DO 101 K = 1,NT
c     n even
              DO 102 NP1 = 1,NLAT,2
                  DO 102 I = 1,LATE
                      G(I,1,K) = G(I,1,K) + A(1,NP1,K)*PMN(NP1,I,KM)
  102         CONTINUE
c     n odd
              NL2 = NLAT/2
              DO 103 NP1 = 2,NLAT,2
                  DO 103 I = 1,NL2
                      IS = NLAT - I + 1
                      G(IS,1,K) = G(IS,1,K) + A(1,NP1,K)*PMN(NP1,I,KM)
  103         CONTINUE
c     restore m=0 coefficents (reverse implicit even/odd reduction)
              DO 112 I = 1,NL2
                  IS = NLAT - I + 1
                  T1 = G(I,1,K)
                  T3 = G(IS,1,K)
                  G(I,1,K) = T1 + T3
                  G(IS,1,K) = T1 - T3
  112         CONTINUE
  101     CONTINUE
c     sweep  columns of g for which b is available
          DO 104 MP1 = 2,LM1
              M = MP1 - 1
              MP2 = M + 2
c     compute pmn for all i and n=m,...,l-1
              CALL DLEGIN(MODE,L,NLAT,M,W,PMN,KM)
              DO 105 K = 1,NT
c     for n-m even store (g(i,p,k)+g(nlat-i+1,p,k))/2 in g(i,p,k) p=2*m,
c     for i=1,...,late
                  DO 106 NP1 = MP1,NLAT,2
                      DO 107 I = 1,LATE
                          G(I,2*M,K) = G(I,2*M,K) +
     +                                 A(MP1,NP1,K)*PMN(NP1,I,KM)
                          G(I,2*M+1,K) = G(I,2*M+1,K) +
     +                                   B(MP1,NP1,K)*PMN(NP1,I,KM)
  107                 CONTINUE
  106             CONTINUE
c     for n-m odd store g(i,p,k)-g(nlat-i+1,p,k) in g(nlat-i+1,p,k)
c     for i=1,...,nlat/2 (p=2*m,p=2*m+1)
                  DO 108 NP1 = MP2,NLAT,2
                      DO 109 I = 1,NL2
                          IS = NLAT - I + 1
                          G(IS,2*M,K) = G(IS,2*M,K) +
     +                                  A(MP1,NP1,K)*PMN(NP1,I,KM)
                          G(IS,2*M+1,K) = G(IS,2*M+1,K) +
     +                                    B(MP1,NP1,K)*PMN(NP1,I,KM)
  109                 CONTINUE
  108             CONTINUE
c     now set fourier coefficients using even-odd reduction above
                  DO 110 I = 1,NL2
                      IS = NLAT - I + 1
                      T1 = G(I,2*M,K)
                      T2 = G(I,2*M+1,K)
                      T3 = G(IS,2*M,K)
                      T4 = G(IS,2*M+1,K)
                      G(I,2*M,K) = T1 + T3
                      G(I,2*M+1,K) = T2 + T4
                      G(IS,2*M,K) = T1 - T3
                      G(IS,2*M+1,K) = T2 - T4
  110             CONTINUE
  105         CONTINUE
  104     CONTINUE
c     set last column (using a only)
          IF (NLON.EQ.L+L-2) THEN
              M = L - 1
              CALL DLEGIN(MODE,L,NLAT,M,W,PMN,KM)
              DO 111 K = 1,NT
c     n-m even
                  DO 131 NP1 = L,NLAT,2
                      DO 131 I = 1,LATE
                          G(I,NLON,K) = G(I,NLON,K) +
     +                                  2.0D0*A(L,NP1,K)*PMN(NP1,I,KM)
  131             CONTINUE
                  LP1 = L + 1
c     n-m odd
                  DO 132 NP1 = LP1,NLAT,2
                      DO 132 I = 1,NL2
                          IS = NLAT - I + 1
                          G(IS,NLON,K) = G(IS,NLON,K) +
     +                                   2.0D0*A(L,NP1,K)*PMN(NP1,I,KM)
  132             CONTINUE
                  DO 133 I = 1,NL2
                      IS = NLAT - I + 1
                      T1 = G(I,NLON,K)
                      T3 = G(IS,NLON,K)
                      G(I,NLON,K) = T1 + T3
                      G(IS,NLON,K) = T1 - T3
  133             CONTINUE
  111         CONTINUE
          END IF
      ELSE
c     half sphere (mode.ne.0)
c     set first column in g
          M = 0
          MEO = 1
          IF (MODE.EQ.1) MEO = 2
          MS = M + MEO
c     compute pmn for all i and n=m,...,l-1
          CALL DLEGIN(MODE,L,NLAT,M,W,PMN,KM)
          DO 113 K = 1,NT
              DO 113 NP1 = MS,NLAT,2
                  DO 113 I = 1,LATE
                      G(I,1,K) = G(I,1,K) + A(1,NP1,K)*PMN(NP1,I,KM)
  113     CONTINUE
c     sweep interior columns of g
          DO 114 MP1 = 2,LM1
              M = MP1 - 1
              MS = M + MEO
c     compute pmn for all i and n=m,...,l-1
              CALL DLEGIN(MODE,L,NLAT,M,W,PMN,KM)
              DO 115 K = 1,NT
                  DO 115 NP1 = MS,NLAT,2
                      DO 115 I = 1,LATE
                          G(I,2*M,K) = G(I,2*M,K) +
     +                                 A(MP1,NP1,K)*PMN(NP1,I,KM)
                          G(I,2*M+1,K) = G(I,2*M+1,K) +
     +                                   B(MP1,NP1,K)*PMN(NP1,I,KM)
  115         CONTINUE
  114     CONTINUE
          IF (NLON.EQ.L+L-2) THEN
c     set last column
              M = L - 1
              CALL DLEGIN(MODE,L,NLAT,M,W,PMN,KM)
              NS = L
              IF (MODE.EQ.1) NS = L + 1
              DO 116 K = 1,NT
                  DO 116 I = 1,LATE
                      DO 116 NP1 = NS,NLAT,2
                          G(I,NLON,K) = G(I,NLON,K) +
     +                                  2.0D0*A(L,NP1,K)*PMN(NP1,I,KM)
  116         CONTINUE
          END IF
      END IF
c     do inverse fourier transform
      DO 120 K = 1,NT
          CALL DHRFFTB(LAT,NLON,G(1,1,K),LAT,WFFT,PMN)
  120 CONTINUE
c     scale output in gs
      DO 122 K = 1,NT
          DO 122 J = 1,NLON
              DO 122 I = 1,LAT
                  GS(I,J,K) = 0.5D0*G(I,J,K)
  122 CONTINUE
      RETURN
      END
      SUBROUTINE DSHSGCI(NLAT,NLON,WSHSGC,LSHSGC,DWORK,LDWORK,IERROR)
      DOUBLE PRECISION WSHSGC
c     this subroutine must be called before calling shsgc with
c     fixed nlat,nlon. it precomputes quantites such as the gaussian
c     points and weights, m=0,m=1 legendre polynomials, recursion
c     recursion coefficients.
      DIMENSION WSHSGC(LSHSGC)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION DWORK(LDWORK)

      IERROR = 1
      IF (NLAT.LT.3) RETURN
      IERROR = 2
      IF (NLON.LT.4) RETURN
c     set triangular truncation limit for spherical harmonic basis
      L = MIN0((NLON+2)/2,NLAT)
c     set equator or nearest point (if excluded) pointer
      LATE = (NLAT+MOD(NLAT,2))/2
      L1 = L
      L2 = LATE
      IERROR = 3
c     check permanent work space length
      IF (LSHSGC.LT.NLAT* (2*L2+3*L1-2)+3*L1* (1-L1)/2+NLON+15) RETURN
      IERROR = 4
      IF (LDWORK.LT.NLAT* (NLAT+4)) RETURN
      IERROR = 0
c     set pointers
      I1 = 1
      I2 = I1 + NLAT
      I3 = I2 + NLAT*LATE
      I4 = I3 + NLAT*LATE
      I5 = I4 + L* (L-1)/2 + (NLAT-L)* (L-1)
      I6 = I5 + L* (L-1)/2 + (NLAT-L)* (L-1)
      I7 = I6 + L* (L-1)/2 + (NLAT-L)* (L-1)
c     set indices in temp work for double precision gaussian wts and pts
      IDTH = 1
      IDWTS = IDTH + NLAT
      IW = IDWTS + NLAT
      CALL DSHSGCI1(NLAT,NLON,L,LATE,WSHSGC(I1),WSHSGC(I2),WSHSGC(I3),
     +              WSHSGC(I4),WSHSGC(I5),WSHSGC(I6),WSHSGC(I7),
     +              DWORK(IDTH),DWORK(IDWTS),DWORK(IW),IERROR)
      IF (IERROR.NE.0) IERROR = 5
      RETURN
      END
      SUBROUTINE DSHSGCI1(NLAT,NLON,L,LATE,WTS,P0N,P1N,ABEL,BBEL,CBEL,
     +                    WFFT,DTHETA,DWTS,WORK,IER)
      DOUBLE PRECISION WTS
      DOUBLE PRECISION P0N
      DOUBLE PRECISION P1N
      DOUBLE PRECISION ABEL
      DOUBLE PRECISION BBEL
      DOUBLE PRECISION CBEL
      DOUBLE PRECISION WFFT
      DOUBLE PRECISION FN
      DOUBLE PRECISION FM
      DIMENSION WTS(NLAT),P0N(NLAT,LATE),P1N(NLAT,LATE),ABEL(1),BBEL(1),
     +          CBEL(1),WFFT(1),DTHETA(NLAT),DWTS(NLAT)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION PB,DTHETA,DWTS,WORK(*)
c     compute the nlat  gaussian points and weights, the
c     m=0,1 legendre polys for gaussian points and all n,
c     and the legendre recursion coefficients
c     define index function used in storing
c     arrays for recursion coefficients (functions of (m,n))
c     the index function indx(m,n) is defined so that
c     the pairs (m,n) map to [1,2,...,indx(l-1,l-1)] with no
c     "holes" as m varies from 2 to n and n varies from 2 to l-1.
c     (m=0,1 are set from p0n,p1n for all n)
c     define for 2.le.n.le.l-1
      INDX(M,N) = (N-1)* (N-2)/2 + M - 1
c     define index function for l.le.n.le.nlat
      IMNDX(M,N) = L* (L-1)/2 + (N-L-1)* (L-1) + M - 1
c     preset quantites for fourier transform
      CALL DHRFFTI(NLON,WFFT)
c     compute double precision gaussian points and weights
c     lw = 4*nlat*(nlat+1)+2
      LW = NLAT* (NLAT+2)
      CALL DGAQD(NLAT,DTHETA,DWTS,WORK,LW,IER)
      IF (IER.NE.0) RETURN
c     store gaussian weights single precision to save computation
c     in inner loops in analysis
      DO 100 I = 1,NLAT
          WTS(I) = DWTS(I)
  100 CONTINUE
c     initialize p0n,p1n using double precision dnlfk,dnlft
      DO 101 NP1 = 1,NLAT
          DO 101 I = 1,LATE
              P0N(NP1,I) = 0.0D0
              P1N(NP1,I) = 0.0D0
  101 CONTINUE
c     compute m=n=0 legendre polynomials for all theta(i)
      NP1 = 1
      N = 0
      M = 0
      CALL DDNLFK(M,N,WORK)
      DO 103 I = 1,LATE
          CALL DDNLFT(M,N,DTHETA(I),WORK,PB)
          P0N(1,I) = PB
  103 CONTINUE
c     compute p0n,p1n for all theta(i) when n.gt.0
      DO 104 NP1 = 2,NLAT
          N = NP1 - 1
          M = 0
          CALL DDNLFK(M,N,WORK)
          DO 105 I = 1,LATE
              CALL DDNLFT(M,N,DTHETA(I),WORK,PB)
              P0N(NP1,I) = PB
  105     CONTINUE
c     compute m=1 legendre polynomials for all n and theta(i)
          M = 1
          CALL DDNLFK(M,N,WORK)
          DO 106 I = 1,LATE
              CALL DDNLFT(M,N,DTHETA(I),WORK,PB)
              P1N(NP1,I) = PB
  106     CONTINUE
  104 CONTINUE
c     compute and store swarztrauber recursion coefficients
c     for 2.le.m.le.n and 2.le.n.le.nlat in abel,bbel,cbel
      DO 107 N = 2,NLAT
          FN = DBLE(N)
          MLIM = MIN0(N,L)
          DO 107 M = 2,MLIM
              FM = DBLE(M)
              IMN = INDX(M,N)
              IF (N.GE.L) IMN = IMNDX(M,N)
              ABEL(IMN) = SQRT(((2*FN+1)* (FM+FN-2)* (FM+FN-3))/
     +                    (((2*FN-3)* (FM+FN-1)* (FM+FN))))
              BBEL(IMN) = SQRT(((2*FN+1)* (FN-FM-1)* (FN-FM))/
     +                    (((2*FN-3)* (FM+FN-1)* (FM+FN))))
              CBEL(IMN) = SQRT(((FN-FM+1)* (FN-FM+2))/
     +                    (((FN+FM-1)* (FN+FM))))
  107 CONTINUE
      RETURN
      END

C
C	$Id: ncarbd.f,v 1.13 2008-07-27 00:23:04 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE NCARBD
C
C Call all of the do-nothing routines that, by virtue of being called,
C force the associated block data routines to be loaded.
C
        CALL AGDFLTX
        CALL ARBLDAX
        CALL BCBKDX
        CALL CONBDX
        CALL CONBDNX
        CALL CPBLDAX
        CALL CTBLDAX
        CALL DASHBDX
        CALL DPBLDAX
        CALL G01BKDX
        CALL GABLDTX
        CALL GFLSBDX
        CALL GKSBDX
        CALL GSEGDTX
        CALL GTPZBDX
        CALL GWIBKDX
        CALL HFINITX
        CALL HSTBKDX
        CALL IDBLDAX
        CALL ISBLDAX
        CALL LBBLDAX
        CALL MAPBDX
        CALL NGBLDAX
        CALL PCBDFFX
        CALL PCBLDAX
        CALL PWRXBDX
        CALL PWRYBDX
        CALL SEBLDAX
        CALL SFBLDAX
        CALL SLBLDAX
        CALL SRFABDX
        CALL STDATAX
        CALL TDBLDAX
        CALL THREBDX
        CALL UTILBDX
        CALL VELDATX
        CALL VTBLDAX
        CALL VVDATAX
        CALL WMBLDAX
C
      END

      SUBROUTINE ZLARZ( SIDE, M, N, L, V, INCV, TAU, C, LDC, WORK )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          SIDE
      INTEGER            INCV, L, LDC, M, N
      COMPLEX*16         TAU
*     ..
*     .. Array Arguments ..
      COMPLEX*16         C( LDC, * ), V( * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  ZLARZ applies a complex elementary reflector H to a complex
*  M-by-N matrix C, from either the left or the right. H is represented
*  in the form
*
*        H = I - tau * v * v'
*
*  where tau is a complex scalar and v is a complex vector.
*
*  If tau = 0, then H is taken to be the unit matrix.
*
*  To apply H' (the conjugate transpose of H), supply conjg(tau) instead
*  tau.
*
*  H is a product of k elementary reflectors as returned by ZTZRZF.
*
*  Arguments
*  =========
*
*  SIDE    (input) CHARACTER*1
*          = 'L': form  H * C
*          = 'R': form  C * H
*
*  M       (input) INTEGER
*          The number of rows of the matrix C.
*
*  N       (input) INTEGER
*          The number of columns of the matrix C.
*
*  L       (input) INTEGER
*          The number of entries of the vector V containing
*          the meaningful part of the Householder vectors.
*          If SIDE = 'L', M >= L >= 0, if SIDE = 'R', N >= L >= 0.
*
*  V       (input) COMPLEX*16 array, dimension (1+(L-1)*abs(INCV))
*          The vector v in the representation of H as returned by
*          ZTZRZF. V is not used if TAU = 0.
*
*  INCV    (input) INTEGER
*          The increment between elements of v. INCV <> 0.
*
*  TAU     (input) COMPLEX*16
*          The value tau in the representation of H.
*
*  C       (input/output) COMPLEX*16 array, dimension (LDC,N)
*          On entry, the M-by-N matrix C.
*          On exit, C is overwritten by the matrix H * C if SIDE = 'L',
*          or C * H if SIDE = 'R'.
*
*  LDC     (input) INTEGER
*          The leading dimension of the array C. LDC >= max(1,M).
*
*  WORK    (workspace) COMPLEX*16 array, dimension
*                         (N) if SIDE = 'L'
*                      or (M) if SIDE = 'R'
*
*  Further Details
*  ===============
*
*  Based on contributions by
*    A. Petitet, Computer Science Dept., Univ. of Tenn., Knoxville, USA
*
*  =====================================================================
*
*     .. Parameters ..
      COMPLEX*16         ONE, ZERO
      PARAMETER          ( ONE = ( 1.0D+0, 0.0D+0 ),
     $                   ZERO = ( 0.0D+0, 0.0D+0 ) )
*     ..
*     .. External Subroutines ..
      EXTERNAL           ZAXPY, ZCOPY, ZGEMV, ZGERC, ZGERU, ZLACGV
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. Executable Statements ..
*
      IF( LSAME( SIDE, 'L' ) ) THEN
*
*        Form  H * C
*
         IF( TAU.NE.ZERO ) THEN
*
*           w( 1:n ) = conjg( C( 1, 1:n ) )
*
            CALL ZCOPY( N, C, LDC, WORK, 1 )
            CALL ZLACGV( N, WORK, 1 )
*
*           w( 1:n ) = conjg( w( 1:n ) + C( m-l+1:m, 1:n )' * v( 1:l ) )
*
            CALL ZGEMV( 'Conjugate transpose', L, N, ONE, C( M-L+1, 1 ),
     $                  LDC, V, INCV, ONE, WORK, 1 )
            CALL ZLACGV( N, WORK, 1 )
*
*           C( 1, 1:n ) = C( 1, 1:n ) - tau * w( 1:n )
*
            CALL ZAXPY( N, -TAU, WORK, 1, C, LDC )
*
*           C( m-l+1:m, 1:n ) = C( m-l+1:m, 1:n ) - ...
*                               tau * v( 1:l ) * conjg( w( 1:n )' )
*
            CALL ZGERU( L, N, -TAU, V, INCV, WORK, 1, C( M-L+1, 1 ),
     $                  LDC )
         END IF
*
      ELSE
*
*        Form  C * H
*
         IF( TAU.NE.ZERO ) THEN
*
*           w( 1:m ) = C( 1:m, 1 )
*
            CALL ZCOPY( M, C, 1, WORK, 1 )
*
*           w( 1:m ) = w( 1:m ) + C( 1:m, n-l+1:n, 1:n ) * v( 1:l )
*
            CALL ZGEMV( 'No transpose', M, L, ONE, C( 1, N-L+1 ), LDC,
     $                  V, INCV, ONE, WORK, 1 )
*
*           C( 1:m, 1 ) = C( 1:m, 1 ) - tau * w( 1:m )
*
            CALL ZAXPY( M, -TAU, WORK, 1, C, 1 )
*
*           C( 1:m, n-l+1:n ) = C( 1:m, n-l+1:n ) - ...
*                               tau * w( 1:m ) * v( 1:l )'
*
            CALL ZGERC( M, L, -TAU, WORK, 1, V, INCV, C( 1, N-L+1 ),
     $                  LDC )
*
         END IF
*
      END IF
*
      RETURN
*
*     End of ZLARZ
*
      END

C
C	$Id: g01siq.f,v 1.5 2008-07-27 00:21:06 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
        SUBROUTINE G01SIQ
C
C       WORKSTATION STATE LIST (WSL) INQUIRY.
C             (OPCODE -200 THRU -299)
C
      include 'gksin.h'
      include 'g01wsl.h'
      include 'g01ins.h'
C
C
        INTEGER  INDX, IPTR, I, NCI
C
C
C        CODE -200 -201 -202
        GOTO  (200, 201, 202) -199-MCODES
C
C        CODE -226
        IF (MCODES .EQ. -226)  GOTO 226
C
C        CODE -256 -257
        GOTO  (256, 257) -255-MCODES
C
C        CODE -290 -291 -292 -293
        GOTO  ( 39,  39,  39,  39) -289-MCODES
C
C       FALL THROUGH MEANS UNDEFINED OPCODE.
C
        RERR = 320
        RETURN
C
C       ERROR 39, "SPECIFIED WORKSTATION IS NEITHER OF CATEGORY OUTPUT
C       NOR OF CATEGORY OUTIN".
C
39      CONTINUE
        RERR = 39
        RETURN
C
C       INQUIRE WORKSTATION DEFERRAL AND UPDATE STATE.
C
200     CONTINUE
        ID(2) = MDEFMO
        ID(3) = MREGMO
        ID(4) = MDEMPT
        ID(5) = MNFRAM
        RETURN
C
C       INQUIRE WORKSTATION STATE.
C
201     CONTINUE
        ID(2) = MSTATE
        RETURN
C
C       INQUIRE WORKSTATION TRANSFORMATION.
C
202     CONTINUE
        ID(2) = MTUS
        RX(1) = RWINDO(1)
        RX(2) = RWINDO(2)
        RX(3) = RWINDO(3)
        RX(4) = RWINDO(4)
        RX(5) = CWINDO(1)
        RX(6) = CWINDO(2)
        RX(7) = CWINDO(3)
        RX(8) = CWINDO(4)
        RY(1) = RWKVP(1)
        RY(2) = RWKVP(2)
        RY(3) = RWKVP(3)
        RY(4) = RWKVP(4)
        RY(5) = CWKVP(1)
        RY(6) = CWKVP(2)
        RY(7) = CWKVP(3)
        RY(8) = CWKVP(4)
        RETURN
C
C       INQUIRE WORKSTATION CONNECTION AND TYPE.
C
226     CONTINUE
        ID(2) = MCONID
        ID(3) = MWTYPE
        RETURN
C
C     INQUIRE COLOR REPRESENTATION.
C
256     CONTINUE
C
C       SEARCH FOR INDEX IN INDEX LIST.
C
        INDX = ID(2)
        IPTR = 0
        DO 2561 I=1,MOL
           IF (INDX.EQ.MCOLI(I))  THEN
              IPTR = I
              GOTO 2562
           END IF
2561    CONTINUE
2562    CONTINUE
        IF (IPTR.NE.0)  THEN
C
C          INDEX WAS FOUND, COPY COLOR COMPONENTS.
           RX(1) = SRED(IPTR)
           RX(2) = SGREEN(IPTR)
           RX(3) = SBLUE(IPTR)
        ELSE
C
           RERR = 94
        END IF
        RETURN
C
C       INQUIRE LIST ELEMENT OF COLOR INDICES.
C
257     CONTINUE
C
C       RETURN THE COUNT BEFORE CHECKING FOR THE ERROR CONDITION
C       (INDEX HAS NOT BEEN DEFINED).
C
        ID(3) = MOL
C
C       CHECK THAT INDEX IS DEFINED.
C
        NCI = ID(2)
        IF (NCI .GT. MOL)  THEN
C
C          UNDEFINED.
           RERR = 502
        ELSE
C
C          DEFINED.
           ID(4) = MCOLI(NCI)
        END IF
        RETURN
C
        END

C
C	$Id: gqtxci.f,v 1.5 2008-07-27 00:21:00 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GQTXCI(ERRIND,COLI)
C
C  INQUIRE TEXT COLOR INDEX
C
      include 'gkscom.h'
C
      INTEGER ERRIND,COLI
C
C  Check if GKS is in the proper state.
C
      CALL GZCKST(8,-1,ERRIND)
      IF (ERRIND .EQ. 0) THEN
        COLI = CTXCI
      ELSE
        COLI = -1
      ENDIF
C
      RETURN
      END

C
C	$Id: mmdef.f,v 1.5 2008-07-27 00:59:04 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MMDEF
C
C  SET THE REQUIRED DEFAULTS FOR THE MIMINAL METACODE TRANSLATOR
C
C  NOTE THAT XMDEF MUST BE CALLED PRIOR TO THE INVOCATION OF THIS ROUTINE
C
      COMMON /TRMTYP/ FOURBT, MULTBT, TWOBT, PTSFLG, CURCOL, IPWRIT,
     1                IFRAME, ISETOP, IRANG, IPTS, ICAS, IINT, IORNT,
     2                ISIZE, IFONT, IPAT, ISSIZ, ICENT, ICOLR,
     3                MCENT, MSIZE, MOR, OLDX, OLDY, MCASE, MINTEN,
     4                MFONT, MDASH, MSPOT, MCOLOR, MLIMIT, PTSYM,
     5                SAVX, SAVY
      INTEGER FOURBT, MULTBT, TWOBT, PTSFLG, CURCOL, IPWRIT,
     1                IFRAME, ISETOP, IRANG, IPTS, ICAS, IINT, IORNT,
     2                ISIZE, IFONT, IPAT, ISSIZ, ICENT, ICOLR,
     3                MCENT, MSIZE, MOR, OLDX, OLDY, MCASE, MINTEN,
     4                MFONT, MDASH, MSPOT, MCOLOR(3), MLIMIT(4), PTSYM,
     5                SAVX, SAVY
      COMMON /PGKSCOM/ CLPDAT, CLPFLG, POLIDX, LINTYP, LINWTH, LINCOL,
     1                LINRGB, MARIDX, MARSIZ, MARCOL, MARRGB, TXTIDX,
     2                INTSTL, PATIDX, FILCOL, FILRGB, MARTYP, HORIZ ,
     3                VERT  , PATH  , CHIGHT, XU    , YU    , XB    ,
     4                YB    , TXTCOL, FINDEX, CEXPN , CSPACE, CURIDX,
     5                CURIMP, CURINT, COLMOD, FILIDX, TXTRGB, PROPN ,
     6                FIRSTX, FIRSTY, LASTX , LASTY , TRATIO, CBV   ,
     7                CUV   , CHP   , CVP   , CCSPAC, CHHORZ, CDV   ,
     8                PMRSIZ, CLPX  , CLPY  , CLPP  , DEFREP, DEFLEN,
     9                VDCECR, TRANVN, TXTPRE, HATIDX, FILRPT, ASFSRF,
     A                ASFSDF, MAPMOD, VERSOK, PCBFST, CPGLEN, CLPNUL,
     B                MTDLEN
      INTEGER         CMPMAX, ASFMAX
      PARAMETER      (CMPMAX=256    , ASFMAX=18)
      LOGICAL         CLPFLG, PROPN , CHHORZ, DEFREP, CLPNUL, MAPMOD,
     1                VERSOK, PCBFST
      REAL            LINWTH, MARSIZ, CEXPN , CSPACE, TRATIO, CBV(2),
     1                CUV(2), CDV(2), CCSPAC
      INTEGER         CLPDAT(4)     , POLIDX, LINTYP, LINCOL, LINRGB(3),
     1                MARIDX, MARCOL, MARRGB(3)     , TXTIDX, INTSTL,
     2                PATIDX, FILCOL, FILRGB(3)     , MARTYP, HORIZ ,
     3                VERT  , PATH  , XU    , YU    , XB    , YB    ,
     4                TXTCOL, FINDEX, CURIMP(CMPMAX), CURINT(CMPMAX*3),
     5                CHIGHT, COLMOD, FILIDX, TXTRGB(3)     , CURIDX,
     6                FIRSTX, FIRSTY, LASTX , LASTY , CHP   , CVP   ,
     7                PMRSIZ, CLPX  , CLPY  , CLPP  , DEFLEN, TRANVN,
     8                TXTPRE, HATIDX, FILRPT(2)     , VDCECR(4)     ,
     9                ASFSRF(ASFMAX), ASFSDF(ASFMAX), CPGLEN, MTDLEN
      COMMON /GKSCHR/ MTDESC
      CHARACTER*80    MTDESC
      COMMON /TRTYPE/ METMIN, METEXT, METPRT, METHED, MIOPCL, MXOPCL,
     1                MIOPID, MXOPID, ASCDEC, ASCHEX, ASCOCT, BINARY,
     2                GAHNOR, GALEFT, GACENT, GARITE, GAVNOR, GATOP ,
     3                GACAP , GAHALF, GABASE, GABOTT, GRIGHT, GLEFT ,
     4                GUP   ,
     5                GDOWN , CINDEX, CDIRCT, PENUP , PENDN , FLAGVL,
     6                SEPRVL, ASCTEK, TYPRGB, TYPBGR,
     7                TYPHLS, TYPMON, SOLID , DASHED, INVSBL, SOLPAT,
     8                ASFIND, ASFBND, ASFLNT, ASFLNW, ASFLNC, ASFMRT,
     9                ASFMRS, ASFMRC, ASFFIS, ASFFHI, ASFFPI, ASFFCO,
     A                ASFFPT, ASFFPW, ASFFPC, ASFTFI, ASFTPR, ASFTCX,
     B                ASFTCS, ASFTCO, ASCFLT, PHOLLO, PSOLID, PPATTR,
     C                PHATCH, PEMPTY, HHORIZ, HVERTI, HPOSLP, HNESLP,
     D                HHOAVE, HPOANE
      INTEGER         METMIN, METEXT, METPRT, METHED, MIOPCL, MXOPCL,
     1                MIOPID, MXOPID, ASCDEC, ASCHEX, ASCOCT, BINARY,
     2                GAHNOR, GALEFT, GACENT, GARITE, GAVNOR, GATOP ,
     3                GACAP , GAHALF, GABASE, GABOTT, GRIGHT, GLEFT ,
     4                GUP   ,
     5                GDOWN , CINDEX, CDIRCT, PENUP , PENDN , FLAGVL,
     6                SEPRVL, ASCTEK, TYPRGB, TYPBGR,
     7                TYPHLS, TYPMON, SOLID , DASHED, INVSBL, SOLPAT,
     8                ASFIND, ASFBND, ASFLNT, ASFLNW, ASFLNC, ASFMRT,
     9                ASFMRS, ASFMRC, ASFFIS, ASFFHI, ASFFPI, ASFFCO,
     A                ASFFPT, ASFFPW, ASFFPC, ASFTFI, ASFTPR, ASFTCX,
     B                ASFTCS, ASFTCO, ASCFLT, PHOLLO, PSOLID, PPATTR,
     C                PHATCH, PEMPTY, HHORIZ, HVERTI, HPOSLP, HNESLP,
     D                HHOAVE, HPOANE
C
C  DEFAULT COLOR ATTRIBUTES TO FOREGROUND COLOR.
C
      CURCOL = 1
      CALL GSTXCI(CURCOL)
      CALL GSPLCI(CURCOL)
      CALL GSPMCI(CURCOL)
C
C  SET POINTS MODE OFF
C
      PTSFLG = 0
C
C  SET CHARACTER ORIENTATION TO 0 AND CENTERING TO LEFT
C
      MOR = 0
      MCENT = 0
C
C  SET THE DEFAULT DASH PATTERN TO SOLID
C
      MDASH = SOLID
      CALL PATSET(MDASH)
C
      RETURN
      END

C
C       $Id: vvectr.f,v 1.23 2008-07-27 00:17:35 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE VVECTR (U,V,P,IAM,VVUDMV,WRK)
C
C Argument dimensions
C
      DIMENSION U(IUD1,*), V(IVD1,*), P(IPD1,*)
C
      DIMENSION WRK(*),IAM(*)
C
      EXTERNAL VVUDMV
C
C Input parameters
C
C U,V    - 2-d arrays holding the component values of a vector field
C P      - A 2-d array containing a scalar data field. The contents
C          of this array may be used to color the vectors 
C IAM    - Area mask array
C VVUDMV - User modifiable masked vector drawing function
C WRK    - work array (currently unused)
C
C Output parameters:
C
C None
C
C PURPOSE                VVECTR draws a representation of a two-
C                        dimensional velocity field by drawing arrows
C                        from each data location.  The length of the
C                        arrow is proportional to the strength of the
C                        field at that location and the direction of
C                        the arrow indicates the direction of the flow
C                        at that location.
C
C ---------------------------------------------------------------------
C
C NOTE:
C Since implicit typing is used for all real and integer variables
C a consistent length convention has been adopted to help clarify the
C significance of the variables encountered in the code for this 
C utility. All local variable and subroutine parameter identifiers 
C are limited to 1,2,or 3 characters. Four character names identify  
C members of common blocks. Five and 6 character variable names 
C denote PARAMETER constants or subroutine or function names.
C
C Declare the VV common blocks.
C
C IPLVLS - Maximum number of color threshold level values
C IPAGMX - Maximum number of area groups allowed in the area map
C
      PARAMETER (IPLVLS = 256, IPAGMX = 64)
C
C Integer and real common block variables
C
C
      COMMON /VVCOM/
     +                IUD1       ,IVD1       ,IPD1       ,IXDM       ,
     +                IYDN       ,VLOM       ,VHIM       ,ISET       ,
     +                VRMG       ,VRLN       ,VFRC       ,IXIN       ,
     +                IYIN       ,ISVF       ,UUSV       ,UVSV       ,
     +                UPSV       ,IMSK       ,ICPM       ,UVPS       ,
     +                UVPL       ,UVPR       ,UVPB       ,UVPT       ,
     +                UWDL       ,UWDR       ,UWDB       ,UWDT       ,
     +                UXC1       ,UXCM       ,UYC1       ,UYCN       ,
     +                NLVL       ,IPAI       ,ICTV       ,WDLV       ,
     +                UVMN       ,UVMX       ,PMIN       ,PMAX       ,
     +                RVMN       ,RVMX       ,RDMN       ,RDMX       ,
     +                ISPC       ,RVMD       ,IPLR       ,IVST       ,
     +                IVPO       ,ILBL       ,IDPF       ,IMSG       ,
     +                ICLR(IPLVLS)           ,TVLU(IPLVLS)
C
C Arrow size/shape parameters
C
        COMMON / VVARO /
     +                HDSZ       ,HINF       ,HANG       ,IAST       ,
     +                HSIN       ,HCOS       ,FAMN       ,FAMX       ,
     +                UVMG       ,FAIR       ,FAWR       ,FAWF       ,
     +                FAXR       ,FAXF       ,FAYR       ,FAYF       ,
     +                AROX(8)    ,AROY(8)    ,FXSZ       ,FYSZ       ,
     +                FXRF       ,FXMN       ,FYRF       ,FYMN       ,
     +                FWRF       ,FWMN       ,FIRF       ,FIMN       ,
     +                AXMN       ,AXMX       ,AYMN       ,AYMX       ,
     +                IACM       ,IAFO       ,WBAD       ,WBTF       ,
     +                WBCF       ,WBDF       ,WBSC
C
C
C Text related parameters
C
        COMMON /VVTXP /
     +                FCWM    ,ICSZ    ,
     +                FMNS    ,FMNX    ,FMNY    ,IMNP    ,IMNC  ,
     +                FMXS    ,FMXX    ,FMXY    ,IMXP    ,IMXC  ,
     +                FZFS    ,FZFX    ,FZFY    ,IZFP    ,IZFC  ,
     +                FILS    ,FILX    ,FILY    ,IILP    ,IILC  ,
     +                FLBS    ,ILBC

C
C Character variable declartions
C
      CHARACTER*160 CSTR
      PARAMETER (IPCHSZ=36)
      CHARACTER*(IPCHSZ)  CMNT,CMXT,CZFT,CLBT,CILT
C
C Text string parameters
C
      COMMON /VVCHAR/ CSTR,CMNT,CMXT,CZFT,CLBT,CILT
C
      SAVE /VVCOM/, /VVARO/, /VVTXP/, /VVCHAR/
C
C The mapping common block: made available to user mapping routines
C
      COMMON /VVMAP/
     +                IMAP       ,
     +                XVPL       ,XVPR       ,YVPB       ,YVPT       ,
     +                WXMN       ,WXMX       ,WYMN       ,WYMX       ,
     +                XLOV       ,XHIV       ,YLOV       ,YHIV       ,
     +                SXDC       ,SYDC       ,NXCT       ,NYCT       ,
     +                RLEN       ,LNLG       ,INVX       ,INVY       ,
     +                ITRT       ,IWCT       ,FW2W       ,FH2H       ,
     +                DVMN       ,DVMX       ,RBIG       ,IBIG
C
      SAVE /VVMAP/
C
C Math constants
C
      PARAMETER (PDTOR  = 0.017453292519943,
     +           PRTOD  = 57.2957795130823,
     +           P1XPI  = 3.14159265358979,
     +           P2XPI  = 6.28318530717959,
     +           P1D2PI = 1.57079632679489,
     +           P5D2PI = 7.85398163397448) 
C
C --------------------------------------------------------------------
C
C Local variable dimensions
C
      PARAMETER (IPLBSZ=10)
      CHARACTER*(IPLBSZ)LBL
      REAL IAR(4)
C
C Local variables
C
C
C The following status and count variables are used to gather
C statistics that are not currently available to the user
C
C IST - Status flag returned from the mapping routine
C ISC - Count of vectors rejected by the mapping routine
C ICT - Count of vector actually plotted
C MXO - Count of vectors rejected because magnitude > maximum
C MNO - Count of vectors rejected because magnitude < minimum
C
C Variables relating to the vector magnitude label
C
C LBL - Character string to hold the vector magnitude label
C NC - Number of characters in the vector magnitude label
C IDP - Local decimal flag for the ENCD routine
C ASH - Scale factor for the vector magnitude label
C
C Zero-field processing and label
C
C IZF - Zero field flag, set TRUE if no vectors are plotted
C XF,YF - fractional length of Zero field string
C IB,IE - beginning and end characters of the string
C W,H   - width and height of the string in fractional coordinates
C XW,YW - position of the string in window coordinates
C
C Vector length adjustment
C
C RAT - Temporary ratio variable
C VA  - adjusted length of current vector
C RA  - ratio of adjusted length to current length
C SMN,SMX - saved value of DVMN and DVMX so they can be restored
C
C Other variables
C
C IOC - the old (saved) color
C IOW - the old (saved) linewidth
C IDA - Do area masking flag
C VMN - The minimum vector size actually plotted (in frac coords)
C VMX - The maximum vector size actually plotted (in frac coords)
C I,J - loop indices for traversing the vector arrays
C K   - loop index for traversing the threshold values
C UI,VI - local copies of the current vector values
C XB,XE,YB,XE - the beginning/ending points of the vector in 
C               the fractional system
C X,Y - mapping of the array indices to a coordinate system
C VLN - length of the current vector in fractional coordinates
C XGV,YGV - X and Y grid value, the scaled distance between each
C           array grid point
C VPL,VPR,VPB,VPT,WDL,WDR,WDB,WDT,ILG - Saved SET call values
C ICI - NGDOT state 'CT' 1 or 0
C IER,ICL,IAR - Clip query values
C 
C ---------------------------------------------------------------------
C
C Check for valid area map and area group overflow if masking is enabled
C
      IF (IMSK.GT.0) THEN
         IF (IAM(7).GT.IPAGMX) THEN
            CSTR(1:29)='VVECTR - TOO MANY AREA GROUPS'
            CALL SETER (CSTR(1:29),1,1)
            RETURN
         END IF
         IF (IAM(7).LE.0) THEN
            CSTR(1:25)='VVECTR - INVALID AREA MAP'
            CALL SETER (CSTR(1:29),2,1)
            RETURN
         END IF
      END IF
C
C Initialize local variables
C
      NC  = 0
      ICT = 0
      IVC = 0
      ISC = 0
      IZC = 0
      ITH = 0
      MXO = 0
      MNO = 0
      IDA = IMSK
      VMN = RBIG
      VMX = 0.0
      IZF = 1
      SMN=DVMN
      SMX=DVMX
C 
C Save the current color and linewidth, then set the vector
C linewidth. Color must be set on a per vector basis within the 
C main loop. Label text color is set here if a single color is
C specified for all labels. 
C
      CALL NGGETI('CT',ICI)
      CALL GQPLCI(IER,IOC)
      CALL GQTXCI(IER,IOT)
      CALL GQFAIS(IER,IOF)
      CALL GQFACI(IER,IOK)
      CALL GQLWSC(IER,ROW)
      CALL GSLWSC(WDLV)
      IF (ILBC .GE. 0) THEN
         CALL GSTXCI(ILBC)
      END IF
      IF (IAST.NE.0) THEN
         CALL GSFAIS(1)
      END IF
C
C If there are no drawable vectors skip the main loop
C
      IF (UVMX .LE. 0.0) THEN
         IZC=NXCT*NYCT
         DVMX=0.0
         DVMN=0.0
         VMN=0.0
         VMX=0.0
         VFR=0.0
         DRL=0.0
         IAV=0
         GOTO 9800
      END IF
C
C Initialize variables (both local and common block values) that 
C control the mapping between vector magnitude and the realized 
C vector length. 
C
      CALL VVILNS(DRL,VFR,IAV)
C
      IF (DVMX .GT. 2.0*(XVPR - XVPL)) THEN
         CSTR(1:36)='VVECTR - VECTOR NDC LENGTH TOO GREAT'
         CALL SETER (CSTR(1:36),3,1)
         RETURN
      END IF
C
C If using filled arrows initialize the fill arrow data
C For wind barbs initialize data, set up for calling NGDOTS, and
C set the fill color the same as the line color
C
      IF (IAST.EQ.1) THEN
         CALL VVINFA
      ELSE IF (IAST.GE.2) THEN
         CALL NGSETI('CT',1)
         CALL GSFACI(IOC)
         CALL VVINWB(1)
      END IF
C
C Set the scaling for the optional vector labels
C
      IDP = IDPF
      IF (UVMN.NE.0.0 .AND. (ABS(UVMN).LT.0.1 .OR. ABS(UVMN).GE.1.E5))
     +    IDP = 1
      IF (UVMX.NE.0.0 .AND. (ABS(UVMX).LT.0.1 .OR. ABS(UVMX).GE.1.E5))
     +    IDP = 1
      ASH = 1.0
      IF (IDP .NE. 0) ASH =
     +     10.**(3-INT(ALOG10(MAX(ABS(UVMN),ABS(UVMX)))-500.)-500)
C
C If thinning is in effect, set up the thinning arrays
C
      IV=IXDM*IYDN+1
      IF (RVMD.GT.0.0) THEN
         CALL VVTHIN(U,V,P,WRK(1),WRK(IV))
      END IF
C
C Calculate the grid interval represented by adjacent array
C elements along each axis
C
      XGV=(XHIV-XLOV)/REAL(MAX(1,IXDM-1))
      YGV=(YHIV-YLOV)/REAL(MAX(1,IYDN-1))
C
C Draw the vectors. Note the extra processing if there are special 
C values to consider or the independent scalar array is processed.
C
      DO 201 J=1,IYDN,IYIN
         DO 200 I=1,IXDM,IXIN
C
            UI = U(I,J)
            VI = V(I,J)
C
C If thinning remove thinned out vectors
C
            IF (RVMD.GT.0.0) THEN
               CALL VVTHND(I,J,WRK(1),IS)
               IF (IS.EQ.1) GO TO 194
            END IF
C
C Cull out special values
C
            IF (ISVF .GT. 0) THEN
               IF (UI .EQ. UUSV) THEN
                  IF (ISVF .EQ. 1 .OR. ISVF .EQ. 3) GO TO 199
                  IF (VI .EQ. UVSV .AND. ISVF .EQ. 4) GO TO 199
               ELSE IF (VI .EQ. UVSV) THEN
                  IF (ISVF .EQ. 2 .OR. ISVF .EQ. 3) GO TO 199
               END IF
            END IF
C
C Calculate the vector magnitude or if the polar flag is set
C compute the cartesian component values
C
            IF (IPLR .LE. 0) THEN
               UVMG = SQRT(UI*UI+VI*VI)
            ELSE
               UVMG = ABS(UI)
               IF (IPLR .EQ. 1) VI = PDTOR * VI
               UI = UVMG * COS(VI)
               VI = UVMG * SIN(VI)
            END IF
C
C Bypass vectors that fall outside the user-specified range.
C
            IF (VLOM .NE. 0.0 .AND. UVMG .LT. UVMN) GO TO 196
C
            IF (VHIM .NE. 0.0 .AND. UVMG .GT. UVMX) GO TO 197
C
C Eliminate zero vectors unless using wind barbs
C
            IF (UVMG .EQ. 0.0 .AND. IAST .LT. 2) GO TO 198
C
C If using a scalar array, check for special values in the array, 
C then determine the color to use for the vector
C
            IF (ABS(ICTV) .GE. 2) THEN
C
               IF (ISPC .EQ. 0 .AND. P(I,J) .EQ. UPSV) THEN
                  GO TO 199
               ELSE IF (ISPC .GT. 0 .AND. P(I,J) .EQ. UPSV) THEN
                  IF (IAST .EQ. 0) THEN
                     CALL GSPLCI(ISPC)
                  ELSE IF (IAST .EQ. 1) THEN
                     IF (IACM .EQ. -1 .OR. IACM .GE. 1) THEN
                        CALL GSPLCI(ISPC)
                     END IF
                     IF (IACM .EQ. 0 .OR. ABS(IACM) .GE. 2) THEN
                        CALL GSFACI(ISPC)
                     END IF
                  ELSE
                     CALL GSPLCI(ISPC)
                     CALL GSFACI(ISPC)
                  END IF
                  GO TO 129
               END IF
C
               DO 128 K=1,NLVL,1
                  IF (P(I,J).LE.TVLU(K) .OR. K.EQ.NLVL) THEN
                     IF (IAST .EQ. 0) THEN
                        CALL GSPLCI(ICLR(K))
                     ELSE IF (IAST .EQ. 1) THEN
                        IF (IACM .EQ. -1 .OR. IACM .GE. 1) THEN
                           CALL GSPLCI(ICLR(K))
                        END IF
                        IF (IACM .EQ. 0 .OR. ABS(IACM) .GE. 2) THEN
                           CALL GSFACI(ICLR(K))
                        END IF
                     ELSE
                        CALL GSPLCI(ICLR(K))
                        CALL GSFACI(ICLR(K))
                     END IF
                     IF (ILBC .EQ. -1) THEN
                        CALL GSTXCI(ICLR(K))
                     END IF
                     GO TO 129
                  END IF
 128           CONTINUE
C
 129           CONTINUE
C               
            ELSE IF (ICTV .NE. 0) THEN
C
C If coloring based on vector magnitude, figure out the color
C
               DO 130 K=1,NLVL,1
                  IF (UVMG.LE.TVLU(K) .OR. K.EQ.NLVL) THEN
                     IF (IAST .EQ. 0) THEN
                        CALL GSPLCI(ICLR(K))
                     ELSE IF (IAST .EQ. 1) THEN
                        IF (IACM .EQ. -1 .OR. IACM .GE. 1) THEN
                           CALL GSPLCI(ICLR(K))
                        END IF
                        IF (IACM .EQ. 0 .OR. ABS(IACM) .GE. 2) THEN
                           CALL GSFACI(ICLR(K))
                        END IF
                     ELSE
                        CALL GSPLCI(ICLR(K))
                        CALL GSFACI(ICLR(K))
                     END IF
                     IF (ILBC .EQ. -1) THEN
                        CALL GSTXCI(ICLR(K))
                     END IF
                     GO TO 131
                  END IF
 130           CONTINUE
C
 131           CONTINUE
C
            END IF
C
C Map the vector. If the compatiblity flag is set use the 
C compatibility subroutine.
C
            IF (ICPM .GT. 0) THEN
C
               CALL VVFCPM(I,J,UI,VI,UVMG,XB,YB,XE,YE,IST)
               IF (IST .NE. 0 .AND. IST .NE. -999) GO TO 195
C
            ELSE
C
               X=XLOV+REAL(I-1)*XGV
               Y=YLOV+REAL(J-1)*YGV
               CALL HLUVVMPXY(X,Y,UI,VI,UVMG,XB,YB,XE,YE,IST)
               IF (IST .NE. 0 .AND. IST .NE. -999) GO TO 195
C
            END IF
C
            IF (IAST .GE. 2 .AND. IST .EQ. -999) THEN
               VLN = DVMX
            ELSE
               VLN = SQRT((XE-XB)*(XE-XB)+(YE-YB)*(YE-YB))
               IF (VLN .EQ. 0.0) GO TO 198
C
C Adjust the vector length in proportion to the difference between
C the minimum and maximum display vector magnitudes
C
               IF (IAV.NE.0) THEN
                  VA = VFR+(DVMX - VFR)*(UVMG - UVMN) /(UVMX - UVMN)
                  RA = VA / VLN
                  XE = XB + RA *(XE-XB)
                  YE = YB + RA *(YE-YB)
                  VLN = VA
               END IF
            END IF
C
C Track the minimum/maximum displayed values
C
            IF (UVMG .LT. VMN) VMN=UVMG
            IF (UVMG .GT. VMX) VMX=UVMG
C
C Turn zero field flag off; encode the number if a label is to
C be drawn
C
            IZF = 0
            IF (ILBL .NE. 0) CALL ENCD(UVMG,ASH,LBL,NC,IDP)
C
C Draw the vector
C
            IF (IAST .EQ. 0) THEN
               CALL VVDRAW (XB,YB,XE,YE,VLN,LBL,NC,IAM,VVUDMV,IDA)
            ELSE IF (IAST .EQ. 1) THEN
               CALL VVDRFL (XB,YB,XE,YE,VLN,LBL,NC,IAM,VVUDMV,IDA)
            ELSE
               CALL VVDRWB (XB,YB,XE,YE,VLN,LBL,NC,IAM,VVUDMV,IDA)
            END IF
C
C Statistical data:
C
C Vectors plotted
C
            ICT=ICT + 1
            GOTO 200
C
 194        CONTINUE
C
C Vectors culled out by thinning algorithm
C
            ITH=ITH+1
            GO TO 200
C
 195        CONTINUE
C
C Vectors rejected by mapping routine
C
            ISC=ISC+1
            GO TO 200
C
 196        CONTINUE
C
C Vectors under minimum magnitude
C
            MNO=MNO+1
            GO TO 200
C
 197        CONTINUE
C
C Vectors over maximum magnitude
C
            MXO=MXO + 1
            GO TO 200
C
C Zero length vectors cannot be drawn even if UVMN is 0.0, but
C need to be treated as if they were drawn.
C
 198        CONTINUE
C
            IF (UVMG .LT. VMN) VMN=UVMG
            IZC=IZC + 1
            GO TO 200
C
C Special values
C
 199        CONTINUE
            IVC = IVC+1
C
 200     CONTINUE
 201  CONTINUE
C
C End of main loop.
C
 9800 CONTINUE
C
C Plot statistics
C
      IF (IVST .EQ. 1) THEN
         LUN=I1MACH(2)
         WRITE(LUN,*) 'VVECTR Statistics'
         WRITE(LUN,*) '                    Vectors plotted:',ICT
         WRITE(LUN,*) 'Vectors rejected by mapping routine:',ISC
         WRITE(LUN,*) '    Vectors under minimum magnitude:',MNO
         WRITE(LUN,*) '     Vectors over maximum magnitude:',MXO
         WRITE(LUN,*) '          Other zero length vectors:',IZC
         WRITE(LUN,*) '            Rejected special values:',IVC
         IF (RVMD.GT.0) THEN
            WRITE(LUN,*) '     Vectors below minimum distance:',ITH
         END IF
         WRITE(LUN,*) '   Minimum plotted vector magnitude:',VMN
         WRITE(LUN,*) '   Maximum plotted vector magnitude:',VMX
         IF (ABS(ICTV).GE.2) THEN
            WRITE(LUN,*) '               Minimum scalar value:',PMIN
            WRITE(LUN,*) '               Maximum scalar value:',PMAX
         END IF
         WRITE(LUN,*) ' '
      END IF
C
C Reset attributes
C
      CALL GSPLCI(IOC)
      CALL GSLWSC(ROW)
      CALL GSTXCI(IOT)
      CALL GSFACI(IOK)
      CALL GSFAIS(IOF)
      CALL NGSETI('CT', ICI)
C
C Set the read-only min/max vector sizes to reflect the vectors
C actually drawn
C
      IF (IAV.EQ.0) THEN
         RDMN=VMN*SXDC
      ELSE
         RDMN = VFR+(DVMX - VFR)*(VMN - UVMN) /(UVMX - UVMN)
      END IF
      RDMX=VMX*SXDC
      RVMX=VMX
      RVMN=VMN
C
C If vectors were drawn, write out the vector informational text if 
C called for, else conditionally write the zero field text.
C The size printed out depends on whether absolute or relative
C size mode is in effect.
C 
      IF (IZF .EQ. 0) THEN
C
         IF (CMXT(1:1) .NE. ' ') THEN
            IF (VRMG .GT. 0.0) THEN
               CALL VVARTX(CMXT,IMXP,FMXX,FMXY,FMXS,IMXC,VRMG,DRL)
            ELSE IF (VHIM .LT. 0.0) THEN
               CALL VVARTX(CMXT,IMXP,FMXX,FMXY,FMXS,IMXC,UVMX,DVMX)
            ELSE
               CALL VVARTX(CMXT,IMXP,FMXX,FMXY,FMXS,IMXC,VMX,RDMX)
            ENDIF
         END IF
         IF (CMNT(1:1) .NE. ' ') THEN
            IF (VLOM .LT. 0.0) THEN
               CALL VVARTX(CMNT,IMNP,FMNX,FMNY,FMNS,IMNC,UVMN,DVMN)
            ELSE
               CALL VVARTX(CMNT,IMNP,FMNX,FMNY,FMNS,IMNC,VMN,RDMN)
            END IF
         END IF
C
      ELSE
C
         IF (CZFT(1:1) .NE. ' ') THEN
C
C Turn clipping off and SET to an identity transform
C
            CALL GQCLIP(IER,ICL,IAR)
            CALL GSCLIP(0)
            CALL GETSET(VPL,VPR,VPB,VPT,WDL,WDR,WDB,WDT,ILG)
            CALL SET(0.0,1.0,0.0,1.0,0.0,1.0,0.0,1.0,1)
C
            XF = XVPL + FZFX * FW2W
            YF = YVPB + FZFY * FH2H
            CALL VVTXLN(CZFT,IPCHSZ,IB,IE)
            CALL VVTXIQ(CZFT(IB:IE),FZFS*FW2W,W,H)
            CALL VVTXPO(IZFP,XF,YF,W,H,XW,YW)
            IF (IZFC .GE. 0) THEN
               CALL GSTXCI(IZFC)
               CALL GSPLCI(IZFC)
            ELSE
               CALL  GSPLCI(IOT)
            END IF
C      
            CALL PLCHHQ(XW,YW,CZFT(IB:IE),FZFS*FW2W,0.0,0.0)
C
            CALL GSTXCI(IOT)
            CALL GSPLCI(IOC)
C
C Restore clipping and the set transformation.
C
            CALL NGSETI('CT',ICI)
            CALL GSCLIP(ICL)
            CALL SET(VPL,VPR,VPB,VPT,WDL,WDR,WDB,WDT,ILG)
C
         END IF
C
      END IF
C
C Restore DVMN and DVMX
C
      DVMN=SMN
      DVMX=SMX
C
C Done
C
      RETURN
      END
C
C -------------------------------------------------------------------
C
      SUBROUTINE VVFCPM(I,J,UI,VI,UVM,XB,YB,XE,YE,IST)
C
C This subroutine implements the compatibility mode for
C the FX,FY,MXY,MYF functions.
C
C Input parameters:
C  
C I,J   -- array indices specifying the current grid point
C UI,VI -- u,v vector component values at the current grid point
C UVM   -- magnitude of the vector
C
C Output parameters:
C
C XB,YB -- the begin position of the vector in fractional coords
C XE,YE -- the end position of the vector in fractional coords
C
C ---------------------------------------------------------------------
C
C NOTE:
C Since implicit typing is used for all real and integer variables
C a consistent length convention has been adopted to help clarify the
C significance of the variables encountered in the code for this 
C utility. All local variable and subroutine parameter identifiers 
C are limited to 1,2,or 3 characters. Four character names identify  
C members of common blocks. Five and 6 character variable names 
C denote PARAMETER constants or subroutine or function names.
C
C Declare the VV common blocks.
C
C IPLVLS - Maximum number of color threshold level values
C IPAGMX - Maximum number of area groups allowed in the area map
C
      PARAMETER (IPLVLS = 256, IPAGMX = 64)
C
C Integer and real common block variables
C
C
      COMMON /VVCOM/
     +                IUD1       ,IVD1       ,IPD1       ,IXDM       ,
     +                IYDN       ,VLOM       ,VHIM       ,ISET       ,
     +                VRMG       ,VRLN       ,VFRC       ,IXIN       ,
     +                IYIN       ,ISVF       ,UUSV       ,UVSV       ,
     +                UPSV       ,IMSK       ,ICPM       ,UVPS       ,
     +                UVPL       ,UVPR       ,UVPB       ,UVPT       ,
     +                UWDL       ,UWDR       ,UWDB       ,UWDT       ,
     +                UXC1       ,UXCM       ,UYC1       ,UYCN       ,
     +                NLVL       ,IPAI       ,ICTV       ,WDLV       ,
     +                UVMN       ,UVMX       ,PMIN       ,PMAX       ,
     +                RVMN       ,RVMX       ,RDMN       ,RDMX       ,
     +                ISPC       ,RVMD       ,IPLR       ,IVST       ,
     +                IVPO       ,ILBL       ,IDPF       ,IMSG       ,
     +                ICLR(IPLVLS)           ,TVLU(IPLVLS)
C
C Arrow size/shape parameters
C
        COMMON / VVARO /
     +                HDSZ       ,HINF       ,HANG       ,IAST       ,
     +                HSIN       ,HCOS       ,FAMN       ,FAMX       ,
     +                UVMG       ,FAIR       ,FAWR       ,FAWF       ,
     +                FAXR       ,FAXF       ,FAYR       ,FAYF       ,
     +                AROX(8)    ,AROY(8)    ,FXSZ       ,FYSZ       ,
     +                FXRF       ,FXMN       ,FYRF       ,FYMN       ,
     +                FWRF       ,FWMN       ,FIRF       ,FIMN       ,
     +                AXMN       ,AXMX       ,AYMN       ,AYMX       ,
     +                IACM       ,IAFO       ,WBAD       ,WBTF       ,
     +                WBCF       ,WBDF       ,WBSC
C
C
C Text related parameters
C
        COMMON /VVTXP /
     +                FCWM    ,ICSZ    ,
     +                FMNS    ,FMNX    ,FMNY    ,IMNP    ,IMNC  ,
     +                FMXS    ,FMXX    ,FMXY    ,IMXP    ,IMXC  ,
     +                FZFS    ,FZFX    ,FZFY    ,IZFP    ,IZFC  ,
     +                FILS    ,FILX    ,FILY    ,IILP    ,IILC  ,
     +                FLBS    ,ILBC

C
C Character variable declartions
C
      CHARACTER*160 CSTR
      PARAMETER (IPCHSZ=36)
      CHARACTER*(IPCHSZ)  CMNT,CMXT,CZFT,CLBT,CILT
C
C Text string parameters
C
      COMMON /VVCHAR/ CSTR,CMNT,CMXT,CZFT,CLBT,CILT
C
      SAVE /VVCOM/, /VVARO/, /VVTXP/, /VVCHAR/
C
C The mapping common block: made available to user mapping routines
C
      COMMON /VVMAP/
     +                IMAP       ,
     +                XVPL       ,XVPR       ,YVPB       ,YVPT       ,
     +                WXMN       ,WXMX       ,WYMN       ,WYMX       ,
     +                XLOV       ,XHIV       ,YLOV       ,YHIV       ,
     +                SXDC       ,SYDC       ,NXCT       ,NYCT       ,
     +                RLEN       ,LNLG       ,INVX       ,INVY       ,
     +                ITRT       ,IWCT       ,FW2W       ,FH2H       ,
     +                DVMN       ,DVMX       ,RBIG       ,IBIG
C
      SAVE /VVMAP/
C
C Math constants
C
      PARAMETER (PDTOR  = 0.017453292519943,
     +           PRTOD  = 57.2957795130823,
     +           P1XPI  = 3.14159265358979,
     +           P2XPI  = 6.28318530717959,
     +           P1D2PI = 1.57079632679489,
     +           P5D2PI = 7.85398163397448) 
C
C --------------------------------------------------------------------
C
      PARAMETER (PRCFAC=1E5)
C
C Internal functions which may be modified for data transformation -
C
C
C                        FX       Returns the X index as the
C                                 X-coordinate of the vector base.
C
C                        MXF      Returns the X-coordinate of the vector
C                                 head.
C
C                        FY       Returns the Y index as the
C                                 Y-coordinate of the vector base.
C
C                        MYF      REturns the Y-coordinate of the vector
C                                 head.
C
C                        SCALEX   Computes a scale factor used in the
C                                 determination of the length of the
C                                 vector to be drawn.
C
C                        SCALEY   Identical to SCALEX in the current
C                                 implementation
C
C     FX(XX,YY) = XX
C     FY(XX,YY) = YY
C     MXF(XX,YY,UU,VV,SFXX,SFYY,MXX,MYY) = MXX+INT(SFXX*UU)
C     MYF(XX,YY,UU,VV,SFXX,SFYY,MXX,MYY) = MYY+INT(SFYY*VV)
C
      SCALEX(MM,NN,IX,IY,UVM,XX1,XX2,YY1,YY2,XX3,XX4,YY3,YY4,
     1     LENN) = LENN/UVM
      SCALEY(MM,NN,IX,IY,UVM,XX1,XX2,YY1,YY2,XX3,XX4,YY3,YY4,
     1     LENN) = SCALEX(MM,NN,IX,IY,UVM,XX1,XX2,YY1,YY2,XX3,
     2     XX4,YY3,YY4,LENN)
C
C ---------------------------------------------------------------------
C
C Clear the status flag and reset the scale factors
C
      IST = 0
C
C Check for zero magnitude
C
      IF (INT(UVM*PRCFAC+0.5) .EQ. 0) THEN
         IZO = 1
      ELSE
         IZO = 0
      END IF
C
      ILN = KFMX(DVMX)
      SFX = SCALEX(IXDM,IYDN,IXIN,IYIN,UVMX,XVPL,XVPR,YVPB,YVPT,
     +     WXMN,WXMX,WYMN,WYMX,ILN)
      SFY = SCALEY(IXDM,IYDN,IXIN,IYIN,UVMX,XVPL,XVPR,YVPB,YVPT,
     +     WXMN,WXMX,WYMN,WYMX,ILN)
C
C Use the FX,FY functions to project the vector begin position and
C FL2INT to convert to the integer metacode system
C
      X=REAL(I)
      Y=REAL(J)
      TX=FX(X,Y)
      IF (TX .LT. WXMN .OR. TX .GT. WXMX) THEN
         IST = -1
         RETURN
      END IF
      TY=FY(X,Y)
      IF (TY .LT. WYMN .OR. TY .GT. WYMX) THEN
         IST = -1
         RETURN
      END IF
      CALL FL2INT(TX,TY,MX,MY)
C
C Return special status if zero magnitude
C
         IF (IZO .EQ. 1) THEN
            XB=CMFX(MX)
            YB=CMFY(MY)
            XE = XB
            YE = YB
            IST = -999
            RETURN
         END IF
C
C Use MYX,MYF to calculate the end of the vector in metacode
C coordinates.
C     
      LX = MXF(X,Y,UI,VI,SFX,SFY,MX,MY)
      LY = MYF(X,Y,UI,VI,SFX,SFY,MX,MY)
      IF(LX .GE. IBIG .OR. LY .GE. IBIG) THEN
         IST = -1
         RETURN
      END IF
C
C Convert to fractional coordinates
C
      XB=CMFX(MX)
      YB=CMFY(MY)
      XE=CMFX(LX)
      YE=CMFY(LY)
C
C Done
C
      RETURN
      END
C
C -------------------------------------------------------------------
C
      SUBROUTINE VVILNS(DRL,VFR,IAV)
C
C This subroutine initializes a number of variables that control the
C mapping between vector magnitude and the NDC length of the arrow.
C
C Output parameters:
C
C DRL - length of reference vector in NDC
C IAV - Adjust vector length flag (based on fractional length - VFR)
C VFR - Length in fractional coordinates of the adjusted minimum
C       vector
C
C ---------------------------------------------------------------------
C
C NOTE:
C Since implicit typing is used for all real and integer variables
C a consistent length convention has been adopted to help clarify the
C significance of the variables encountered in the code for this 
C utility. All local variable and subroutine parameter identifiers 
C are limited to 1,2,or 3 characters. Four character names identify  
C members of common blocks. Five and 6 character variable names 
C denote PARAMETER constants or subroutine or function names.
C
C Declare the VV common blocks.
C
C IPLVLS - Maximum number of color threshold level values
C IPAGMX - Maximum number of area groups allowed in the area map
C
      PARAMETER (IPLVLS = 256, IPAGMX = 64)
C
C Integer and real common block variables
C
C
      COMMON /VVCOM/
     +                IUD1       ,IVD1       ,IPD1       ,IXDM       ,
     +                IYDN       ,VLOM       ,VHIM       ,ISET       ,
     +                VRMG       ,VRLN       ,VFRC       ,IXIN       ,
     +                IYIN       ,ISVF       ,UUSV       ,UVSV       ,
     +                UPSV       ,IMSK       ,ICPM       ,UVPS       ,
     +                UVPL       ,UVPR       ,UVPB       ,UVPT       ,
     +                UWDL       ,UWDR       ,UWDB       ,UWDT       ,
     +                UXC1       ,UXCM       ,UYC1       ,UYCN       ,
     +                NLVL       ,IPAI       ,ICTV       ,WDLV       ,
     +                UVMN       ,UVMX       ,PMIN       ,PMAX       ,
     +                RVMN       ,RVMX       ,RDMN       ,RDMX       ,
     +                ISPC       ,RVMD       ,IPLR       ,IVST       ,
     +                IVPO       ,ILBL       ,IDPF       ,IMSG       ,
     +                ICLR(IPLVLS)           ,TVLU(IPLVLS)
C
C Arrow size/shape parameters
C
        COMMON / VVARO /
     +                HDSZ       ,HINF       ,HANG       ,IAST       ,
     +                HSIN       ,HCOS       ,FAMN       ,FAMX       ,
     +                UVMG       ,FAIR       ,FAWR       ,FAWF       ,
     +                FAXR       ,FAXF       ,FAYR       ,FAYF       ,
     +                AROX(8)    ,AROY(8)    ,FXSZ       ,FYSZ       ,
     +                FXRF       ,FXMN       ,FYRF       ,FYMN       ,
     +                FWRF       ,FWMN       ,FIRF       ,FIMN       ,
     +                AXMN       ,AXMX       ,AYMN       ,AYMX       ,
     +                IACM       ,IAFO       ,WBAD       ,WBTF       ,
     +                WBCF       ,WBDF       ,WBSC
C
C
C Text related parameters
C
        COMMON /VVTXP /
     +                FCWM    ,ICSZ    ,
     +                FMNS    ,FMNX    ,FMNY    ,IMNP    ,IMNC  ,
     +                FMXS    ,FMXX    ,FMXY    ,IMXP    ,IMXC  ,
     +                FZFS    ,FZFX    ,FZFY    ,IZFP    ,IZFC  ,
     +                FILS    ,FILX    ,FILY    ,IILP    ,IILC  ,
     +                FLBS    ,ILBC

C
C Character variable declartions
C
      CHARACTER*160 CSTR
      PARAMETER (IPCHSZ=36)
      CHARACTER*(IPCHSZ)  CMNT,CMXT,CZFT,CLBT,CILT
C
C Text string parameters
C
      COMMON /VVCHAR/ CSTR,CMNT,CMXT,CZFT,CLBT,CILT
C
      SAVE /VVCOM/, /VVARO/, /VVTXP/, /VVCHAR/
C
C The mapping common block: made available to user mapping routines
C
      COMMON /VVMAP/
     +                IMAP       ,
     +                XVPL       ,XVPR       ,YVPB       ,YVPT       ,
     +                WXMN       ,WXMX       ,WYMN       ,WYMX       ,
     +                XLOV       ,XHIV       ,YLOV       ,YHIV       ,
     +                SXDC       ,SYDC       ,NXCT       ,NYCT       ,
     +                RLEN       ,LNLG       ,INVX       ,INVY       ,
     +                ITRT       ,IWCT       ,FW2W       ,FH2H       ,
     +                DVMN       ,DVMX       ,RBIG       ,IBIG
C
      SAVE /VVMAP/
C
C Math constants
C
      PARAMETER (PDTOR  = 0.017453292519943,
     +           PRTOD  = 57.2957795130823,
     +           P1XPI  = 3.14159265358979,
     +           P2XPI  = 6.28318530717959,
     +           P1D2PI = 1.57079632679489,
     +           P5D2PI = 7.85398163397448) 
C
C --------------------------------------------------------------------
C         
C Determine the maximum vector magnitude to use. If VHIM is less than
C 0.0 then it becomes the size to use, unconditionally. Otherwise,
C It will be the minimum of the parameter VHIM (if not equal to 0.0) 
C and the maximum vector size encountered in the field, stored in UVMX.
C Do likewise with the minimum vector.
C Note that it is possible for the user to set the max or min
C such that no vectors qualify for plotting. A 'ZERO FIELD' condition
C results in this case. 
C
      DRL = DVMX
      VFR = DVMN
      IAV = 0
C
      IF (VHIM .GT. 0.0) THEN
         UVMX = MIN(VHIM, UVMX)
      ELSE IF (VHIM.LT.0.0) THEN
         UVMX = ABS(VHIM)
      END IF
C
      IF (VLOM .GT. 0.0) THEN
         UVMN = MAX(VLOM, UVMN)
      ELSE IF (VLOM.LT.0.0) THEN
         UVMN = ABS(VLOM)
      END IF
C
C Determine the length of the maximum, minimum and reference
C vector magnitudes in NDC. Once these values are calculated
C the maximum vector length only is used for scaling purposes
C in the VVMPXY routine. Its value is also calculated in user
C coordinates. This value may not be useful to VVMPXY if the 
C user coordinate system is not uniform.
C
C There are a number of ways these lengths may be determined,
C depending on whether the user has specified (1) a 
C reference magnitude, (2) a reference length, or (3) a fractional
C size for the minimum magnitude. 
C
C Note that for wind barbs the fractional size is forced to 1.0,
C which will cause all the glyphs to have the same basic length.
C 
      IF (IAST.GE.2) THEN
         VFL = 1.0
         RMG = UVMX
      ELSE
         VFL = MIN(1.0, VFRC)
         RMG = VRMG
      END IF
C
C If the field is uniform, special conditions apply
C
      IF (UVMX - UVMN .LE. 0.0) THEN
         IF (VRLN .GT. 0.0 .AND. RMG .GT. 0.0) THEN
            DRL=VRLN*FW2W
            DVMX=DRL*UVMX/RMG
         ELSE IF (RMG .GT. 0.0) THEN
            DRL=DVMX*RMG/UVMX
         ELSE IF (VRLN .GT. 0.0) THEN
            DVMX=VRLN*FW2W
            DRL=DVMX
         END IF
         VFR=DRL
         DVMN=VFR
C
C If no reference magnitude specified, the maximum magnitude
C is used as the reference magnitude
C
      ELSE IF (RMG .LE. 0.0) THEN
         IF (VRLN .GT. 0.0) THEN
            DVMX=VRLN*FW2W
         END IF
         DRL=DVMX
         IF (VFL .GT. 0.0) THEN
            IAV=1
            VFR=VFL*DVMX
            DVMN=VFR
         ELSE
            DVMN=DVMX*(UVMN/UVMX)
            VFR=DVMN
         END IF
C
C If the reference magnitude is less than the minimum magnitude,
C the fractional size is ignored if a reference length is also
C specified. Otherwise, the fractional size determines not the
C minimum magnitude length, but the reference magnitude length.
C
      ELSE IF (RMG .LE. UVMN) THEN
         IAV=1
         IF (VRLN .GT. 0.0) THEN
            DRL=VRLN*FW2W
            DVMX=DRL*UVMX/RMG
         ELSE IF (VFL .GT. 0.0) THEN
            DRL=DVMX*VFL
         ELSE
            DRL=DVMX*RMG/UVMX
         END IF
         DVMN=DRL*UVMN/RMG
         VFR=DVMN
C
C A reference magnitude is specified, as well as a fractional
C magnitude. The min magnitude length is the fractional size 
C times the reference length. If a reference length is specified, 
C it becomes the length of the reference magnitude.  The maximum
C magnitude is determined proportionally. If no reference length
C is specified, the reference length is set proportionally to
C the default size assigned to the maximum magnitude.
C
      ELSE IF (VFL .GT. 0.0) THEN
         IAV=1
         IF (VRLN .GT. 0.0) THEN
            DRL=VRLN*FW2W
            VFR=VFL*DRL
            DVMN=VFR
            DVMX=DVMN+(DRL-DVMN)*(UVMX-UVMN)/(RMG-UVMN)
         ELSE
            RAT=(RMG-UVMN)/(UVMX-UVMN)
            DRL=DVMX*RAT/(1.0-VFL+VFL*RAT)
            VFR=VFL*DRL
            DVMN=VFR
         END IF
C
C A reference magnitude is specified. If a reference length is 
C specified, it becomes the length of the reference magnitude.
C Otherwise the reference magnitude's length is proportional
C to the default length assigned to the maximum magnitude.
C The min magnitude length is then determined proportionally
C to both these values.
C
      ELSE
         IF (VRLN .GT. 0.0) THEN
            DRL=VRLN*FW2W
            DVMX=DRL*UVMX/RMG
            VFR=DRL*UVMN/RMG
            DVMN=VFR
         ELSE
            DRL=DVMX*RMG/UVMX
            VFR=DVMX*UVMN/UVMX
            DVMN=VFR
         END IF
      END IF
      RLEN=DVMX*(WXMX-WXMN)/FW2W
C
C Compute scale factors.
C
      SXDC=DVMX/UVMX
      SYDC=DVMX/UVMX
C
C Calculate the sine and cosine of the arrow head half angle
C
      HSIN = SIN(PDTOR*HANG)
      HCOS = COS(PDTOR*HANG)
C
C Done
C
      RETURN
      END

C NCLFORTSTART
      SUBROUTINE DWGTAREARMSE(T,Q,WGTY,WGTX,MX,NY,TMSG,QMSG,IFLAG,RMSE)
      IMPLICIT NONE
      INTEGER MX,NY,IFLAG
      DOUBLE PRECISION T(MX,NY),Q(MX,NY),WGTX(MX),WGTY(NY)
      DOUBLE PRECISION TMSG,QMSG
      DOUBLE PRECISION RMSE
C NCLEND

C NCL: rmseTQ = wgt_AreaRmse (t,q,wgty,wgtx,flag)

      INTEGER NL,ML,KMSG
      DOUBLE PRECISION SUMD,SUMW,WGTXY

C compute the weighted root-mean-square-difference [rmse]

C Nomenclature:
C INPUT:
C t      - 2D array
C q      - 2D array
C wgty   - 1D array of length "ny" [eg: cos(0.01745*lat) or gau_wgt(:)]
C wgtx   - 1D array of length "mx"
C mx     - 1st [faster varying] dimension of "t" [eg, longitude]
C ny     - 2nd [slower varying] dimension of "t" [eg, latitude ]
C tmsg   - msg value
C iflag  - flag
C          =0 compute  rmse ignoring msg values
C          =1 if any msg data is encountered return as msg
c OUTPUT:
C rmse   - root-mean-square-difference [weighted]

      SUMD = 0.0D0
      SUMW = 0.0D0
      KMSG = 0
      RMSE = TMSG

      DO NL = 1,NY
          DO ML = 1,MX
              IF (T(ML,NL).NE.TMSG .AND. Q(ML,NL).NE.QMSG) THEN
                  WGTXY = WGTX(ML)*WGTY(NL)
                  SUMD = SUMD + WGTXY* (T(ML,NL)-Q(ML,NL))**2
                  SUMW = SUMW + WGTXY
              ELSE
                  KMSG = KMSG + 1
              END IF
          END DO
c                                      return if user desired
          IF (IFLAG.EQ.1 .AND. KMSG.NE.0) RETURN
      END DO
c                          compute wgted differense
      IF (SUMW.NE.0.D0) THEN
          RMSE = SQRT(SUMD/SUMW)
      END IF

      RETURN
      END

C NCLFORTSTART
      subroutine patcor1 (mlon,nlat,ntim,x,y,xmsg,ymsg,w, r, ier)

c compute the anomaly correlation: 1-dimensional weight array 

c nomenclature:
c INPUT  
c .    mlon, nlat  - dimension sizes
c .    x,y         - arrays/grids 
c .    xmsg,ymsg   - missing codes [if none set to some value]
c .    w           - contains weights specified by user [eg: gaussian wgts]
c OUTPUT 
c .    r           - anomaly (pattern) correlation
c .    ier         - error code
c .                  =0  no errors
c .                  =1  x or y contains all msg values
c .                  =2  x or y contains all constant values
c
      implicit none
c                                               !  INPUT
      integer  mlon, nlat, ntim, ier
      double precision x(mlon,nlat,ntim), y(mlon,nlat,ntim)
     $               , w(nlat), xmsg, ymsg
c                                               !  OUTPUT
      double precision r(ntim)
C NCLEND
c                                               !  LOCAL
      integer ml, nl, nt
      double precision xave , yave , wsum
      double precision xycov, xanom2, yanom2

      ier    = 0

      do nt=1,ntim

c wgted area mean

         xave = 0.0d0
         yave = 0.0d0
         wsum = 0.0d0
         do nl=1,nlat
           do ml=1,mlon
              if (x(ml,nl,nt).ne.xmsg .and. y(ml,nl,nt).ne.ymsg) then 
                  xave = xave + w(nl)*x(ml,nl,nt)
                  yave = yave + w(nl)*y(ml,nl,nt)
                  wsum = wsum + w(nl)
              end if
           end do
         end do
   
c all missing?
   
         if (wsum.eq.0.0d0) then
             ier = 1
             r   = xmsg
             return
         end if
         
         xave = xave/wsum
         yave = yave/wsum
   
c covariance and anomalies
   
         xycov  = 0.0d0
         xanom2 = 0.0d0
         yanom2 = 0.0d0
         
         do nl=1,nlat
           do ml=1,mlon
              if (x(ml,nl,nt).ne.xmsg .and. y(ml,nl,nt).ne.ymsg) then 
                  xycov  = xycov  + w(nl)*(x(ml,nl,nt)-xave)
     &                                   *(y(ml,nl,nt)-yave)
                  xanom2 = xanom2 + w(nl)*(x(ml,nl,nt)-xave)**2
                  yanom2 = yanom2 + w(nl)*(y(ml,nl,nt)-yave)**2
              end if
           end do
         end do
   
         if (xanom2.gt.0.0d0 .and. yanom2.gt.0.0d0) then
             r(nt)   = xycov/(sqrt(xanom2)*sqrt(yanom2))
         else
             ier = 2
             r(nt)   = xmsg
         end if

      end do

      return
      end
c ======================================================
C NCLFORTSTART
      subroutine patcor2 (mlon,nlat,ntim,x,y,xmsg,ymsg,w, r, ier)

c compute the anomaly correlation: 2-dimensional weight array 

c nomenclature:
c INPUT  
c .    mlon, nlat  - dimension sizes
c .    x,y         - arrays/grids 
c .    xmsg,ymsg   - missing codes [if none set to some value]
c .    w           - contains weights specified by user [eg: POP area]
c OUTPUT 
c .    r           - anomaly (pattern) correlation
c .    ier         - error code
c .                  =0  no errors
c .                  =1  x or y contains all msg values
c .                  =2  x or y contains all constant values
c
      implicit none
c                                               !  INPUT
      integer  mlon, nlat, ntim, ier
      double precision x(mlon,nlat,ntim), y(mlon,nlat,ntim),w(mlon,nlat)
     $               , xmsg, ymsg
c                                               !  OUTPUT
      double precision r
C NCLEND
c                                               !  LOCAL
      integer ml, nl, nt
      double precision xave , yave , wsum
      double precision xycov, xanom2, yanom2

      ier    = 0

      do nt=1,ntim

c wgted area mean

         xave = 0.0d0
         yave = 0.0d0
         wsum = 0.0d0
         do nl=1,nlat
           do ml=1,mlon
              if (x(ml,nl,nt).ne.xmsg .and. y(ml,nl,nt).ne.ymsg) then 
                  xave = xave + w(ml,nl)*x(ml,nl,nt)
                  yave = yave + w(ml,nl)*y(ml,nl,nt)
                  wsum = wsum + w(ml,nl)
              end if
           end do
         end do

c all missing?

         if (wsum.eq.0.0d0) then
             ier = 1
             r   = xmsg
             return
         end if
         
         xave = xave/wsum
         yave = yave/wsum

c covariance and anomalies

         xycov  = 0.0d0
         xanom2 = 0.0d0
         yanom2 = 0.0d0
         
         do nl=1,nlat
           do ml=1,mlon
              if (x(ml,nl,nt).ne.xmsg .and. y(ml,nl,nt).ne.ymsg) then 
                  xycov  = xycov  +w(ml,nl)*(x(ml,nl,nt)-xave)
     $                                     *(y(ml,nl,nt)-yave)
                  xanom2 = xanom2 +w(ml,nl)*(x(ml,nl,nt)-xave)**2
                  yanom2 = yanom2 +w(ml,nl)*(y(ml,nl,nt)-yave)**2
              end if
           end do
         end do

         if (xanom2.gt.0.0d0 .and. yanom2.gt.0.0d0) then
             r   = xycov/(sqrt(xanom2)*sqrt(yanom2))
         else
             ier = 2
             r   = xmsg
         end if

      end do

      return
      end

C NCLFORTSTART
      SUBROUTINE Z2GEOUV(Z,MLON,NLAT,ZMSG,GLON,GLAT,UG,VG,IOPT)
      IMPLICIT NONE

c NCL: uv = z2geouv(z,lat,lon,iopt)           ; uv(2,...,nlat,mlon)
c                                               INPUT
      INTEGER MLON,NLAT,IOPT
      DOUBLE PRECISION Z(MLON,NLAT),ZMSG,GLAT(NLAT),GLON(MLON)
c                                               OUTPUT
      DOUBLE PRECISION UG(MLON,NLAT),VG(MLON,NLAT)
C NCLEND

c Given geopotential height (gpm): calculate geostrophic wind components

c INPUT
c .   z     - geopotential height (south to north order)
c .   mlon  - number of longitudes
c .   nlat  - number of latitudes
c .   zmsg  - missing value code
c .   glat  - latitudes  of grid points
c .   glon  - longitudes of grid points
c .   iopt  - option: iopt=0 z is not cyclic in longitude
c .                   iopt=1 z is cyclic in longitude
c OUTPUT
c .   ug,vg - geostrophic wind components

      INTEGER NL,ML

      IF (GLAT(2).GT.GLAT(1)) THEN
c                                         south to north
          CALL Z2GUV(Z,MLON,NLAT,ZMSG,GLON,GLAT,UG,VG,IOPT)
      ELSE
c                                         north to south [reorder]
          CALL ZUVNEW(Z,MLON,NLAT,ZMSG,GLON,GLAT,UG,VG,IOPT)
      END IF

      RETURN
      END
C -------
      SUBROUTINE ZUVNEW(Z,MLON,NLAT,ZMSG,GLON,GLAT,UG,VG,IOPT)
      IMPLICIT NONE
c
c data array need to be rearranged to go fron south to north
c
c                                               INPUT
      INTEGER MLON,NLAT,IOPT
      DOUBLE PRECISION Z(MLON,NLAT),ZMSG,GLAT(NLAT),GLON(MLON)
c                                               OUTPUT
      DOUBLE PRECISION UG(MLON,NLAT),VG(MLON,NLAT)

c local temporary arrays.
      DOUBLE PRECISION ZTMP(MLON,NLAT),GLATTMP(NLAT),UTMP(NLAT),
     +                 VTMP(NLAT)
      INTEGER NL,ML,NLAT1

c reorder [ S ==> N ]
      NLAT1 = NLAT + 1
      DO NL = 1,NLAT
          GLATTMP(NLAT1-NL) = GLAT(NL)
          DO ML = 1,MLON
              ZTMP(ML,NLAT1-NL) = Z(ML,NL)
          END DO
      END DO

      CALL Z2GUV(ZTMP,MLON,NLAT,ZMSG,GLON,GLATTMP,UG,VG,IOPT)

c put in original order

      DO ML = 1,MLON
          DO NL = 1,NLAT
              UTMP(NLAT1-NL) = UG(ML,NL)
              VTMP(NLAT1-NL) = VG(ML,NL)
          END DO
          DO NL = 1,NLAT
              UG(ML,NL) = UTMP(NL)
              VG(ML,NL) = VTMP(NL)
          END DO
      END DO

      RETURN
      END
C -------
      SUBROUTINE Z2GUV(Z,MLON,NLAT,ZMSG,GLON,GLAT,UG,VG,IOPT)
      IMPLICIT NONE
c                                               INPUT
      INTEGER MLON,NLAT,IOPT
      DOUBLE PRECISION Z(MLON,NLAT),ZMSG,GLAT(NLAT),GLON(MLON)
c                                               OUTPUT
      DOUBLE PRECISION UG(MLON,NLAT),VG(MLON,NLAT)

c Given geopotential height (gpm): calculate geostrophic components

c INPUT
c .   z     - geopotential height (south to north order)
c .   mlon  - number of longitudes
c .   nlat  - number of latitudes
c .   zmsg  - missing value code
c .   glat  - latitudes  of grid points
c .   glon  - longitudes of grid points
c .   iopt  - option: iopt=0 z is not cyclic in longitude
c .                   iopt=1 z is cyclic in longitude
c OUTPUT
c .   ug,vg - geostrophic wind components

      INTEGER NL,ML
      DOUBLE PRECISION ZZ(0:MLON+1,0:NLAT+1)
      DOUBLE PRECISION GF(0:NLAT+1),DX(0:NLAT+1),DY(0:NLAT+1)
      DOUBLE PRECISION GR,RAD,RE,RR,OMEGA,DLON,DLON2

c  calculate `constant' quantities

      GR = 9.80616D0
      RAD = 4.D0*ATAN(1.0D0)/180.D0
      RE = 6371220.D0
      RR = RE*RAD
      DLON = RR* (GLON(2)-GLON(1))
      DLON2 = 2.D0*DLON
      OMEGA = 7.292D-05

c  calculate the quantity [gravity/coriolis_force])
c .   dx and dy represent the distances over which finite diff apply
c .   Note: dy(1) and dy(nlat) are half width for
c .   one sided differences

c                       calculate the quantity [gravity/[cor force])
      DO NL = 1,NLAT
          IF (GLAT(NL).NE.0.D0) THEN
              GF(NL) = GR/ (2.D0*OMEGA*SIN(GLAT(NL)*RAD))
          ELSE
              GF(NL) = ZMSG
          END IF
          DX(NL) = DLON2*COS(GLAT(NL)*RAD)
      END DO
c                                     get around 'rounding' problem
      IF (GLAT(1).LT.-89.999D0) THEN
          DX(1) = 0.0D0
      END IF
      IF (GLAT(NLAT).GT.89.999D0) THEN
          DX(NLAT) = 0.0D0
      END IF
c                                     lat can have variable spacing
c                                     dy(1) and dy(nlat) are half size
c                                     for use in one-sided differences
      DY(1) = (GLAT(2)-GLAT(1))*RR
      DO NL = 2,NLAT - 1
          DY(NL) = (GLAT(NL+1)-GLAT(NL-1))*RR
      END DO
      DY(NLAT) = (GLAT(NLAT)-GLAT(NLAT-1))*RR

c set ug and vg to default values

      DO NL = 1,NLAT
          DO ML = 1,MLON
              UG(ML,NL) = ZMSG
              VG(ML,NL) = ZMSG
          END DO
      END DO

c use zz array to eliminate the need for special
c .   loops/statements to handle the east and west boundaries

c                                     fill zz 'middle'
      DO NL = 1,NLAT
          DO ML = 1,MLON
              ZZ(ML,NL) = Z(ML,NL)
          END DO
      END DO
c                                     bottom and top boundaries
      DO ML = 1,MLON
          ZZ(ML,0) = ZZ(ML,1)
          ZZ(ML,NLAT+1) = ZZ(ML,NLAT)
      END DO
c                                     left and right boundaries
      IF (IOPT.EQ.1) THEN
c                                     specify cyclic values
          DO NL = 1,NLAT
              ZZ(0,NL) = ZZ(MLON,NL)
              ZZ(MLON+1,NL) = ZZ(1,NL)
          END DO
      ELSE
c                                     duplicate adjacent points
          DO NL = 1,NLAT
              ZZ(0,NL) = ZZ(1,NL)
              ZZ(MLON+1,NL) = ZZ(MLON,NL)
          END DO
      END IF

c calculate the winds at all grid points of array zz
c .   ug calculated via a one-sided differences [crude approx]
c Note: a 'trick' is used
c .   (1) the top and bottom rows of zz are duplicates of adjacent rows
c .   (2) dy(1) and dy(nlat) are already set for one-sided differences
c .   (3) the combination will result in numerically correct results

      DO NL = 1,NLAT
          IF (.NOT. (GLAT(NL).EQ.0.0D0.OR.ABS(GLAT(NL)).GT.89.999D0))
     +        THEN
              DO ML = 1,MLON
                  IF (ZZ(ML,NL+1).NE.ZMSG .AND.
     +                ZZ(ML,NL-1).NE.ZMSG) THEN
                      UG(ML,NL) = -GF(NL)* (ZZ(ML,NL+1)-ZZ(ML,NL-1))/
     +                            DY(NL)
                  END IF
                  IF (ZZ(ML+1,NL).NE.ZMSG .AND.
     +                ZZ(ML-1,NL).NE.ZMSG) THEN
                      VG(ML,NL) = GF(NL)* (ZZ(ML+1,NL)-ZZ(ML-1,NL))/
     +                            DX(NL)
                  END IF
              END DO
          END IF
      END DO

c if not cyclic in lon then "adjust" the vg for the left/right columns
c .   Basically, they should be one sided differences BUT they were
c .   divided by 2*dx. The multiplication by 2 below undoes this.
c .   The reason for the "if" is to handle the case at the EQ

      IF (IOPT.NE.1) THEN
          DO NL = 1,NLAT
              IF (VG(1,NL).NE.ZMSG) VG(1,NL) = VG(1,NL)*2.0D0
              IF (VG(MLON,NL).NE.ZMSG) VG(MLON,NL) = VG(MLON,NL)*2.0D0
          END DO
      END IF

      RETURN
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C   FFTPACK 5.0
C   Copyright (C) 1995-2004, Scientific Computing Division,
C   University Corporation for Atmospheric Research
C   Licensed under the GNU General Public License (GPL)
C
C   Authors:  Paul N. Swarztrauber and Richard A. Valent
C
C   $Id: cost1i.f,v 1.2 2006-11-21 01:10:17 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      SUBROUTINE DCOST1I(N,WSAVE,LENSAV,IER)
      DOUBLE PRECISION PI
      DOUBLE PRECISION DT
      DOUBLE PRECISION FK
      INTEGER N,LENSAV,IER
      DOUBLE PRECISION WSAVE(LENSAV)
C
      IER = 0
C
      IF (LENSAV.LT.2*N+INT(LOG(DBLE(N)))+4) THEN
          IER = 2
          CALL DXERFFT('COST1I',3)
          GO TO 300
      END IF
C
      IF (N.LE.3) RETURN
      NM1 = N - 1
      NP1 = N + 1
      NS2 = N/2
      PI = 4.D0*ATAN(1.D0)
      DT = PI/DBLE(NM1)
      FK = 0.D0
      DO 101 K = 2,NS2
          KC = NP1 - K
          FK = FK + 1.D0
          WSAVE(K) = 2.D0*SIN(FK*DT)
          WSAVE(KC) = 2.D0*COS(FK*DT)
  101 CONTINUE
      LNSV = NM1 + INT(LOG(DBLE(NM1))) + 4
      CALL DRFFT1I(NM1,WSAVE(N+1),LNSV,IER1)
      IF (IER1.NE.0) THEN
          IER = 20
          CALL DXERFFT('COST1I',-5)
      END IF
  300 CONTINUE
      RETURN
      END

      PROGRAM TVELVC
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C OPEN GKS, OPEN WORKSTATION OF TYPE 1, ACTIVATE WORKSTATION
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C INVOKE DEMO DRIVER
C
      CALL TVELVC1 (IERR)
C
C DEACTIVATE AND CLOSE WORKSTATION, CLOSE GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END
C
      SUBROUTINE TVELVC1 (IERROR)
C
C PURPOSE                To provide a simple demonstration of VELVCT.
C
C USAGE                  CALL TVELVC1 (IERROR)
C
C ARGUMENTS
C
C ON OUTPUT              IERROR
C                          An integer variable
C                          = 0, if the test was successful,
C                          = 1, the test was not successful.
C
C I/O                    If the test is successful, the message
C
C               VELVCT TEST EXECUTED--SEE PLOTS TO CERTIFY
C
C                        is printed on unit 6.  In addition, 1
C                        frame is produced on the machine graphics
C                        device.  In order to determine if the test
C                        was successful, it is necessary to examine
C                        the plot.
C
C PRECISION              Single
C
C LANGUAGE               FORTRAN 77
C
C REQUIRED ROUTINES      VELVCT
C
C REQUIRED GKS LEVEL     0A
C
C ALGORITHM              This test program calls entries EZVEC and
C                        VELVCT.  Each call produces a plot of a
C                        vector field obtained from the function
C
C                          Z(X,Y) = X + Y + 1./((X-.1)**2+Y**2+.09)
C                                   -1./((X+.1)**2+Y**2+.09),
C
C                        by using the direction of the Z gradient
C                        vectors and the logarithm of the absolute
C                        value of the components.
C
C HISTORY                Originally written in November 1976.
C                        Converted to FORTRAN 77 and GKS in July 1984.
C
C
      DIMENSION       U(21,25)   ,V(21,25)
C
C Specify coordinates for a plot title.
C
        DATA IX/94/,IY/1000/
C
C Specify VELVCT arguments.
C
      DATA FLO/0./,HI/0./,NSET/0/,LENGTH/0/,ISPV/0/,SPV/0./
C
C Initialize the error parameter.
C
      IERROR = 1
C
C Specify velocity field functions U and V.
C
      M = 21
      N = 25
      DO  20 I=1,M
         X = .1*REAL(I-11)
         DO  10 J=1,N
            Y = .1*REAL(J-13)
            DZDX = 1.-2.*(X-.10)/((X-.10)**2+Y**2+.09)**2+
     1             2.*(X+.10)/((X+.10)**2+Y**2+.09)**2
            DZDY = 1.-2.*Y/((X-.10)**2+Y**2+.09)**2+
     1             2.*Y/((X+.10)**2+Y**2+.09)**2
            UVMAG = ALOG(SQRT(DZDX*DZDX+DZDY*DZDY))
            UVDIR = ATAN2(DZDY,DZDX)
            U(I,J) = UVMAG*COS(UVDIR)
            V(I,J) = UVMAG*SIN(UVDIR)
   10    CONTINUE
   20 CONTINUE
C
        CALL GQCNTN(IERR,ICN)
C
C Select normalization transformation 0.
C
        CALL GSELNT(0)
C
C Call PLCHLQ to write the plot title.
C
        X = CPUX(IX)
        Y = CPUY(IY)
      CALL PLCHLQ (X,Y,'DEMONSTRATION PLOT FOR ENTRY EZVEC OF VELVCT',
     1           16.,0.,-1.)
        CALL GSELNT(ICN)
C
C Call EZVEC for a default velocity field plot.
C
      CALL EZVEC (U,V,M,N)
C
C Call VELVCT to generate the user tuned velocity field plot.
C
      CALL VELVCT (U,M,V,M,M,N,FLO,HI,NSET,LENGTH,ISPV,SPV)
        CALL GQCNTN(IERR,ICN)
C
C Select normalization transformation 0.
C
        CALL GSELNT(0)
C
C Call PLCHLQ to write the plot title.
C
        X = CPUX(IX)
        Y = CPUY(IY)
      CALL PLCHLQ (X,Y,
     1           'DEMONSTRATION PLOT FOR ENTRY VELVCT OF VELVCT',16.,
     2           0.,-1.)
        CALL GSELNT(ICN)
      CALL FRAME
C
      IERROR = 0
      WRITE (6,1001)
      RETURN
C
 1001 FORMAT (' VELVCT TEST EXECUTED--SEE PLOTS TO CERTIFY')
C
      END

c ----------------------------------------------------------------------
      SUBROUTINE DSTAT2(X,NPTS,XMSG,XMEAN,XVAR,XSD,NPTUSED,IER)
      DOUBLE PRECISION X1
      DOUBLE PRECISION X2
      DOUBLE PRECISION XN
      DOUBLE PRECISION X3

c this routine will calculate estimates of the first two  moments
c .   of the vector x containing missing data.

c input arguments:
c .   x        - input vector
c .   npts     - length of x
c .   xmsg     - missing code: if there are no msg values
c .                            set xmsg to some value which will
c .                            not be encountered.

c output arguments:
c .   xmean    - mean of x (first moment)
c .   xvar     - sample variance
c .   xsd      - sqrt( xvar )
c .   nptused  - no. of points used to calculate the estimates
c .   ier      - if (ier.ne.0) an error has occurred

c note :
c .   uncalculated quantities are set to xmsg (nptused set to zero)

      INTEGER NPTS,NPTUSED,IER
      DOUBLE PRECISION X(1:NPTS),XMSG,XMEAN,XVAR,XSD

      XMEAN = XMSG
      XVAR = XMSG
      XSD = XMSG
      NPTUSED = 0

      IF (NPTS.LT.1) THEN
          IER = 1
          RETURN
      END IF

      IER = 0
      X1 = 0.D0
      X2 = 0.D0
      XN = 0.D0
      DO N = 1,NPTS
          IF (X(N).NE.XMSG) THEN
              XN = XN + 1.0D0
              X1 = X1 + X(N)
              X2 = X2 + X(N)*X(N)
          END IF
      END DO

      NPTUSED = XN

      IF ((XN-1.D0).GT.0.D0) THEN
          X3 = X1*X1/XN
c
c prevent possible roundoff
c
          XVAR = DMAX1((X2-X3)/ (XN-1.D0),0.D0)
          XSD = SQRT(XVAR)
          XMEAN = X1/XN
      ELSE IF ((XN-1.D0).EQ.0.D0) THEN
          XMEAN = X1
          XVAR = 0.0D0
          XSD = 0.0D0
      ELSE
c
c error code for all msg values
c
          IER = 2
      END IF

      RETURN
      END
c ----------------------------------------------------------------------
      SUBROUTINE DSTAT2T(X,NPTS,XMSG,XMEANT,XVART,XSDT,NPTUSED,WORK,
     +                  PTRIM,IER)
      DOUBLE PRECISION XMSG
      DOUBLE PRECISION XMEANT
      DOUBLE PRECISION XVART
      DOUBLE PRECISION XSDT
      DOUBLE PRECISION PTRIM

c this routine will calculate trimmed estimates of the first
c .   two moments of the vector x containing missing data.

c input arguments:
c .   x        - input vector
c .   npts     - length of x  (npts.ge.5 if pctrim.gt.0.)
c .   xmsg     - missing code: if there are no msg values
c .                            set xmsg to some value which will
c .                            not be encountered.
c .   work     - work vector of length npts
c .              upon return work contains x in ascending order
c .   ptrim    - portion of the series to be trimmed (0.<= pctrim <1.)
c .              if (pctrim.eq.0.) then
c .                  calculate whole series mean and st dev
c .              else
c .                  a minimum of two pts will be trimmed
c .                  a maximum of npts-2 will be trimmed
c .              endif
c .
c .              note: if u want to be very conservative and only
c .                    trim the min and max values then set
c .                    ptrim to some very small value (e.g. 1.e-36)
c .
c .              ex: npts=45, ptrim=0.50 then
c .                  0.5*45=22 pts will be trimmed (11 on each end)

c output arguments:
c .   xmeant   - mean of trimmed series x
c .   xvart    - sample trimmed variance
c .   xsdt     - sqrt( xvart ): st deviation of trimmed series
c .   nptused  - no. of points used to calculate the trimmed estimates
c .   ier      - if (ier.ne.0) an error has occurred

c note : uncalculated quantities are set to xmsg (nptused set to zero)

      DOUBLE PRECISION X(1:NPTS),WORK(1:NPTS)

      IER = 0
      XMEANT = XMSG
      XVART = XMSG
      XSDT = XMSG
      NPTUSED = 0

      IF (NPTS.LT.1) THEN
          IER = 1
          RETURN
      END IF

      IF (PTRIM.EQ.0.D0) THEN
          CALL DSTAT2(X,NPTS,XMSG,XMEANT,XVART,XSDT,NPTUSED,IER)
          RETURN
      ELSE IF (PTRIM.EQ.1.D0) THEN
c
c cannot trim whole series
c
          IER = 2
          RETURN
      END IF

c sort x into numerically ascending order
c .   first transfer the input array to the work array
c .   excluding missing pts

      MPTS = 0
      DO N = 1,NPTS
          IF (X(N).NE.XMSG) THEN
              MPTS = MPTS + 1
              WORK(MPTS) = X(N)
          END IF
      END DO

      IF (MPTS.LT.1) THEN
c
c series contains all msg values
c
          IER = 3
          RETURN
      ELSE IF (MPTS.LT.NPTS) THEN
c
c fill the rest of work with msg code
c
          DO M = MPTS + 1,NPTS
              WORK(M) = XMSG
          END DO
      END IF
c
c sort series in ascending order
c
      CALL DSORTU(WORK,MPTS)
c
c no. of values trimmed from one side
c
      MTRIM = MAX0(INT(DBLE(MPTS)*0.5D0*PTRIM),1)


      IF ((MPTS-2*MTRIM).GT.0) THEN
          CALL DSTAT2(WORK(MTRIM+1),MPTS-2*MTRIM,XMSG,XMEANT,XVART,XSDT,
     +               NPTUSED,IER)
      ELSE
c
c not enough trimmed values
c
          IER = 4
      END IF

      RETURN
      END
c ----------------------------------------------------------------------
      SUBROUTINE DSTAT4(X,NPTS,XMSG,XMEAN,XVAR,XSD,XSKEW,XKURT,NPTUSED,
     +                 IER)
      DOUBLE PRECISION XMSG
      DOUBLE PRECISION XMEAN
      DOUBLE PRECISION XVAR
      DOUBLE PRECISION XSD
      DOUBLE PRECISION XSKEW
      DOUBLE PRECISION XKURT
      DOUBLE PRECISION X1
      DOUBLE PRECISION X2
      DOUBLE PRECISION XN
      DOUBLE PRECISION X3
      DOUBLE PRECISION X4

c this routine will calculate estimates of the first four moments
c .   of the vector x containing missing data.

c input arguments:
c .   x        - input vector
c .   npts     - length of x
c .   xmsg     - missing code: if there are no msg values
c .                            set xmsg to some value which will
c .                            not be encountered.

c output arguments:
c .   xmean    - mean of x (first moment)
c .   xvar     - sample variance of x (second moment)
c .   xsd      - sqrt( xvar )
c .   xskew    - coef. of skewness (third moment)
c .              departure from symmetry. if skew>0 [skew<0] the
c .              distribution trails off to the right [left] .
c .   xkurt    - coef. of kurtosis (fourth moment)
c .              the normal distribution has a kurtosis of 3 . this
c .              value is subtracted from the calculated kurtosis.
c .              thus neg values are possible and the returned value
c .              is kurtosis relative to the normal distribution.
c .              if (kurt-3) > 0 [<0] it is usually more sharply peaked
c .              [flatter] than the normal distribution. (leptokurtic
c .              and platykurtic , respectively.) e.g. , a rectangular
c.               function has a kurtosis of 1.8 or 1.8-3 = -1.2 relative
c.               to the normal distribution.
c .   nptused  - no. of points used to calculate the estimates
c .   ier      - if (ier.ne.0) an error has occurred

c note :
c .   uncalculated quantities are set to xmsg (nptused set to zero)

      DOUBLE PRECISION X(1:NPTS)

      XMEAN = XMSG
      XVAR = XMSG
      XSD = XMSG
      XSKEW = XMSG
      XKURT = XMSG
      NPTUSED = 0


      IF (NPTS.LT.1) THEN
          IER = 1
          RETURN
      END IF

      IER = 0
      X1 = 0.D0
      X2 = 0.D0
      XN = 0.D0
      DO N = 1,NPTS
          IF (X(N).NE.XMSG) THEN
              XN = XN + 1.0D0
              X1 = X1 + X(N)
              X2 = X2 + X(N)*X(N)
          END IF
      END DO

      NPTUSED = XN

      IF ((XN-1.D0).GT.0.D0) THEN
          X3 = X1*X1/XN
c
c prevent possible roundoff
c
          XVAR = DMAX1((X2-X3)/ (XN-1.D0),0.D0)
          XSD = SQRT(XVAR)
          XMEAN = X1/XN

          IF (XVAR.GT.0.D0) THEN
              X1 = 0.D0
              X2 = 0.D0
              X3 = 0.D0
              X4 = 0.D0
              DO N = 1,NPTS
                  IF (X(N).NE.XMSG) THEN
                      X4 = X(N) - XMEAN
                      X1 = X4**3
                      X2 = X2 + X1
                      X3 = X3 + X1*X4
                  END IF
              END DO
              XSKEW = (X2/SQRT(XVAR)**3)/XN
              XKURT = (X3/ (XVAR*XVAR))/XN - 3.D0
          END IF
      ELSE IF ((XN-1.D0).EQ.0.D0) THEN
          XMEAN = X1
          XVAR = 0.0D0
          XSD = 0.0D0
      ELSE
c
c error code for all msg values
c
          IER = 2
          RETURN
      END IF

      RETURN
      END
c ----------------------------------------------------------------------
      SUBROUTINE DMEDMRNG(X,WORK,NPTS,XMSG,XMEDIAN,XMRANGE,XRANGE,
     +                   NPTUSED,IER)
      DOUBLE PRECISION XMSG
      DOUBLE PRECISION XMEDIAN
      DOUBLE PRECISION XMRANGE
      DOUBLE PRECISION XRANGE

c this routine will find the median, range and mid-range
c .   of the input  vector x containing missing data.

c arguments :
c .   x        - input vector (series)
c .   work     - work vector of length npts. upon output
c .              work(1) thru work(nptused) are in numerically ascending
c .              order. work(nptused+1) thru work(npts) will be filled
c .              the missing value code.
c .   npts     - length of x
c .   xmsg     - missing code: if no msg values set to some number
c .                            which will not be encountered.
c .   xmedian  - median value of vector x
c .   xmrange  - midrange
c .   xrange   - range of x
c .   nptused  - no. of points used in computing various quantities
c .   ier      - if (ier.ne.0) an error has occurred

c note :
c .   uncalculated quantities are set to xmsg (nptused set to zero)

      DOUBLE PRECISION X(1:NPTS),WORK(1:NPTS)

      XMEDIAN = XMSG
      XMRANGE = XMSG
      XRANGE = XMSG
      NPTUSED = 0

      IF (NPTS.LT.1) THEN
          IER = 1
          RETURN
      END IF
      IER = 0

c sort x into numerically ascending order
c .   first transfer the input array to the work array
c .   excluding missing pts

      MPTS = 0
      DO N = 1,NPTS
          IF (X(N).NE.XMSG) THEN
              MPTS = MPTS + 1
              WORK(MPTS) = X(N)
          END IF
      END DO

      IF (MPTS.LT.1) THEN
c
c series contains all msg values
c
          IER = 2
          RETURN
      END IF

      CALL DSORTU(WORK,MPTS)

      IF (MPTS.LT.NPTS) THEN
c
c fill the rest of work with msg code
c
          DO N = MPTS + 1,NPTS
              WORK(N) = XMSG
          END DO
      END IF

      XMRANGE = 0.5D0* (WORK(MPTS)+WORK(1))
      XRANGE = WORK(MPTS) - WORK(1)

      IF (DMOD(DBLE(MPTS),2.D0).EQ.0.D0) THEN
          XMEDIAN = 0.5D0* (WORK(MPTS/2)+WORK(MPTS/2+1))
      ELSE
          XMEDIAN = WORK((MPTS+1)/2)
      END IF

c
c for nomenclature compatibility
c
      NPTUSED = MPTS

      RETURN
      END
c ----------------------------------------------------------------------
      SUBROUTINE DESAUTO(X,NPTS,XMSG,XMEAN,XVAR,MXLAG,ACV,ACR,IER)
      DOUBLE PRECISION XMSG
      DOUBLE PRECISION XMEAN
      DOUBLE PRECISION XVAR
      DOUBLE PRECISION XSD
      DOUBLE PRECISION X1
      DOUBLE PRECISION XN

c this routine will estimate the autocovariances and autocorrelations
c .   for the input vector x with missing data. the normalizing factor
c .   in the denominator (xvar) is kept constant.

c arguments :
c .   x        - input vector
c .   npts     - length of vector x
c .   xmsg     - missing code: if no msg values set to some number
c .                            which will not be encountered.
c .   xmean    - mean of the input vector x
c .   xvar     - sample variance  of the input vector x
c .              note: if xmean and/or xvar = xmsg this routine will
c .                    calculate the quantities and return them
c .   mxlag    - max lag to be estimated  [0 <= mxlag <= npts ]
c .   acv      - sample autocovariances  [vector of length .ge.
c .                                      (mxlag+1) ]
c .   acr      - sample autocorrelations [vector of length .ge. 
c .                                       (mxlag+1) ]

c .              acv(0) = xvar (lag 0  )  : acr(0)   = 1.00 ( lag 0  )
c .              acv(1) =      (lag 1  )  : acr(1)   =      ( lag 1  )
c .                         .                              .
c .                         .                              .
c .              acv(mxlag) = (lag mxlag): acr(mxlag) = ( lag mxlag)

c .   ier      - if (ier.ne.0) an error has occurred

c note :  uncalculated quantities are set to xmsg

      DOUBLE PRECISION X(1:NPTS),ACV(0:MXLAG),ACR(0:MXLAG)

      IER = 0
      IF (NPTS.LT.2) IER = 1
      IF (MXLAG.LT.0 .OR. MXLAG.GT.NPTS) IER = 2
      IF (XVAR.LE.0.D0 .AND. XVAR.NE.XMSG) IER = 3

      DO LAG = 0,MAX0(0,MIN0(MXLAG,NPTS))
         ACV(LAG) = XMSG
         ACR(LAG) = XMSG
      END DO
      IF (IER.NE.0) RETURN


      IF (XMEAN.EQ.XMSG .OR. XVAR.EQ.XMSG) THEN
          CALL DSTAT2(X,NPTS,XMSG,XMEAN,XVAR,XSD,NPTUSED,JER)
          IF (JER.NE.0) THEN
              IER = -JER
          ELSE IF (XVAR.EQ.0.D0) THEN
              IER = -5
          END IF
      END IF
      IF (IER.NE.0) RETURN

      ACV(0) = XVAR
      ACR(0) = 1.00D0

c
c i hope somebody wants more than this
c
      IF (MXLAG.EQ.0) RETURN

      DO LAG = 1,MXLAG
          X1 = 0.D0
          XN = 0.D0
          DO N = 1,NPTS - LAG
              IF (X(N).NE.XMSG .AND. X(N+LAG).NE.XMSG) THEN
                  X1 = X1 + ((X(N+LAG)-XMEAN)* (X(N)-XMEAN))
                  XN = XN + 1.D0
              END IF
          END DO
          IF (XN.GE.2.D0) THEN
              ACV(LAG) = X1/ (XN-1.D0)
              ACR(LAG) = ACV(LAG)/XVAR
          ELSE
              ACV(LAG) = XMSG
              ACR(LAG) = XMSG
          END IF
      END DO

      RETURN
      END
c ----------------------------------------------------------------------
      SUBROUTINE DESCROS(X,Y,NPTS,XMSG,YMSG,XMEAN,YMEAN,XSD,YSD,MXLAG,
     +                  CCV,CCR,IER)
      DOUBLE PRECISION XMSG
      DOUBLE PRECISION YMSG
      DOUBLE PRECISION XMEAN
      DOUBLE PRECISION YMEAN
      DOUBLE PRECISION XSD
      DOUBLE PRECISION YSD
      DOUBLE PRECISION XVAR
      DOUBLE PRECISION YVAR
      DOUBLE PRECISION XSDYSD
      DOUBLE PRECISION XYN
      DOUBLE PRECISION XY1


c this routine will estimate the crosscovariances and crosscorrelations
c .   for the input series x and y. missing data is allowed.

c .   to get the (+) and (-) ccv and ccr two calls must be made. the
c .   first with the calling sequence above and the second with the
c .   x and y series reversed (also the other arguments) . note
c .   that  the second ccv(0) and ccr(0) are redundant.

c arguments :
c .   x,y      - input vectors with which the calculations are to take
c .              place.
c .   npts     - length of vectors x and y
c .   xmsg,ymsg- missing code: if no msg values set to some number
c .                            which will not be encountered.
c .              xmsg will be used to fill missing values
c .   xmean    - mean of the x vector (if xmean=xmsg: program will
c .              calculate)
c .   ymean    - mean of the y vector (if ymean=ymsg: program will
c .              calculate)
c .   xsd      - st. dev. of x vector (if xsd  =xmsg: program will
c .              calculate)
c .   ysd      - st. dev. of y vector (if ysd  =ymsg: program will
c .              calculate)
c .   mxlag    - max lag crosscovariance/correlation to be estimated
c .   ccv      - vector of length .ge. (mxlag+1) containing sample
c .              cross cov
c .   ccr      - vector of length .ge. (mxlag+1) containing sample
c .              cross cor

c .                ccv(0) = xyvar (lag 0  )  : ccr(0) =  ( lag 0   )
c .                ccv(1) =       (lag 1  )  : ccr(1) =  ( lag 1   )
c .                           .                               .
c .                           .                               .
c .                ccv(mxlag) =  (lag mxlag): ccr(mxlag) = ( lag mxlag)

c .   ier      - if (ier.ne.0) an error has occurred

c note : uncalculated quantities are set to xmsg

      DOUBLE PRECISION X(1:NPTS),Y(1:NPTS),CCV(0:MXLAG),CCR(0:MXLAG)

      IER = 0
      IF (NPTS.LT.2) IER = 1
      IF (MXLAG.LT.0 .OR. MXLAG.GT.NPTS) IER = 2
      IF ((XSD.NE.XMSG.AND.XSD.LE.0.D0) .OR.
     +    (YSD.NE.YMSG.AND.YSD.LE.0.D0)) IER = 3
      DO LAG = 0,MAX0(0,MIN0(MXLAG,NPTS))
          CCV(LAG) = XMSG
          CCR(LAG) = XMSG
      END DO
      IF (IER.NE.0) RETURN

      IF (XMEAN.EQ.XMSG .OR. XSD.EQ.XMSG) THEN
          CALL DSTAT2(X,NPTS,XMSG,XMEAN,XVAR,XSD,NPTUSED,JER)
          IF (JER.NE.0) THEN
              IER = -JER
          ELSE IF (XSD.EQ.0.D0) THEN
c
c x must be a series of constant values
c
              IER = -5
          ELSE IF (NPTUSED.EQ.0) THEN
c
c x must be a series of missing values
c
              IER = -6
          END IF
          IF (IER.NE.0) RETURN
      END IF

      IF (YMEAN.EQ.YMSG .OR. YSD.EQ.YMSG) THEN
          CALL DSTAT2(Y,NPTS,YMSG,YMEAN,YVAR,YSD,NPTUSED,JER)
          IF (JER.NE.0) THEN
              IER = - (JER+100)
          ELSE IF (YSD.EQ.0.D0) THEN
c
c y must be a series of constant values
c
              IER = -105
          ELSE IF (NPTUSED.EQ.0) THEN
c
c y must be a series of missing values
c
              IER = -106
          END IF
          IF (IER.NE.0) RETURN
      END IF

      XSDYSD = 1.D0/ (XSD*YSD)

      DO LAG = 0,MXLAG
          XYN = 0.D0
          XY1 = 0.D0
          DO N = 1,NPTS - LAG
              IF (X(N).NE.XMSG .AND. Y(N+LAG).NE.YMSG) THEN
                  XY1 = XY1 + ((Y(N+LAG)-YMEAN)* (X(N)-XMEAN))
                  XYN = XYN + 1.D0
              END IF
          END DO
          IF (XYN.GE.2.D0) THEN
              CCV(LAG) = XY1/ (XYN-1.D0)
              CCR(LAG) = CCV(LAG)*XSDYSD
          ELSE
              CCV(LAG) = XMSG
              CCR(LAG) = XMSG
          END IF
      END DO

      RETURN
      END
c ----------------------------------------------------------------------
      SUBROUTINE DRMVAVE(X,NPTS,XMSG,XMEAN,IER)
      DOUBLE PRECISION XMSG
      DOUBLE PRECISION XMEAN

c this routine will remove the mean of vector x from each pt.
c .   missing pts are excepted.

c arguments :
c .   x        - input vector
c .   npts     - length of x
c .   xmsg     - missing code: if there are no msg values
c .                            set xmsg to some value which will
c .                            not be encountered.
c .   xmean    - mean of the input vector (x)
c .   ier      - if (ier.ne.0) an error has occurred

      DOUBLE PRECISION X(1:NPTS)

      IF (NPTS.LT.1) THEN
          IER = 1
          RETURN
      ELSE
          IER = 0
      END IF

      DO N = 1,NPTS
          IF (X(N).NE.XMSG) X(N) = X(N) - XMEAN
      END DO

      RETURN
      END
c ----------------------------------------------------------
      SUBROUTINE DSTNDX(X,NPTS,XMSG,XMEAN,XSD,IER)
      DOUBLE PRECISION XMSG
      DOUBLE PRECISION XMEAN
      DOUBLE PRECISION XSD

c standardize the vector x

c arguments :
c .   x        - vector to be standardized
c .   npts     - length of vector x
c .   xmsg     - missing code: if there are no msg values
c .                            set xmsg to some value which will
c .                            not be encountered.
c .   xmean    - mean of the input vector
c .   xsd      - standard deviation of the series
c .   ier      - if (ier.ne.0) an error has ocurred

      DOUBLE PRECISION X(1:NPTS)

      IER = 0
      IF (NPTS.LT.1) THEN
          IER = 1
      ELSE IF (XSD.LE.0.D0) THEN
          IER = 2
      END IF
      IF (IER.NE.0) RETURN

      DO N = 1,NPTS
          IF (X(N).NE.XMSG) X(N) = (X(N)-XMEAN)/XSD
      END DO

      RETURN
      END
c ----------------------------------------------------------------------
      SUBROUTINE DNMDATA(X,NPTS,XMSG,IER)
      DOUBLE PRECISION XMSG
      DOUBLE PRECISION XMAX

c normalize the vector x by the absolute value of its largest element

c arguments :
c .   x        - series (vector) to be normalized
c .   npts     - length of x
c .   xmsg     - missing code: if there are no msg values
c .                            set xmsg to some value which will
c .                            not be encountered.
c .   ier      - if (ier.ne.0) an error has occurred

      DOUBLE PRECISION X(1:NPTS)

      IER = 0
      IF (NPTS.LT.1) THEN
          IER = 1
          RETURN
      END IF

c find the first non-missing pt

      DO N = 1,NPTS
          IF (X(N).NE.XMSG) THEN
              NSTRT = N
              GO TO 20
          END IF
      END DO

c
c must be all msg values
c
      IER = 1
      RETURN

   20 XMAX = ABS(X(NSTRT))
      DO N = NSTRT,NPTS
          IF (X(N).NE.XMSG) XMAX = DMAX1(ABS(X(N)),XMAX)
      END DO

      IF (XMAX.NE.0.D0) THEN
          DO N = NSTRT,NPTS
              IF (X(N).NE.XMSG) X(N) = X(N)/XMAX
          END DO
      ELSE
c
c must be all zeros
c
          IER = 2
      END IF

      RETURN
      END
c ----------------------------------------------------------------------
      SUBROUTINE DERRCHK(X,NPTS,XMEAN,XSD,XMSG,XBAND,LOCERR,NPTER,IER)
      DOUBLE PRECISION XMEAN
      DOUBLE PRECISION XSD
      DOUBLE PRECISION XMSG
      DOUBLE PRECISION XBAND
      DOUBLE PRECISION XWIDTH

c this routine will check a series of data for potential gross errors
c .   (i.e., wild points). the series will be scanned and the locations
c .   of possibly bad points are stored. this routine
c .   assumes that the series x is normally distributed.

c input arguments:
c .   x        - series (vector) to be checked
c .   npts     - length of x
c .   xmean    - series mean (... or median is the user chooses)
c .   xsd      - series standard deviation
c .   xmsg     - missing code: if there are no msg values
c .                            set xmsg to some value which will
c .                            not be encountered.
c .   xband    - standard deviation width to be allowed
c .              (e.g., xband=3.0; check values beyond 99%)

c output arguments:
c .   locerr   - integer vector which will contain the subscript
c .              location of potential gross errors. for example: if
c .              series x has two pts more than xband from xmean and
c .              these pts are located at x(17) and x(204) then
c .              locerr(1) = 17 and locerr(2) = 204.
c .   npter    - no. of pts in locerr. in the above example it would be
c .              two. if a value of zero is returned no gross errors
c .              have been detected.
c .   ier      - if (ier.ne.0) an error has occurred

      DOUBLE PRECISION X(1:NPTS)
      INTEGER LOCERR(1:NPTS)

      IER = 0
      IF (NPTS.LT.1) THEN
          IER = 1
      ELSE IF (XSD.EQ.0.D0) THEN
          IER = 2
      END IF
      IF (IER.NE.0) RETURN

      NN = 0
      NPTER = 0
      XWIDTH = XBAND*XSD
      DO N = 1,NPTS
          IF (X(N).NE.XMSG .AND. ABS(X(N)-XMEAN).GT.XWIDTH) THEN
c
c must be a potential gross error
c
              NPTER = NPTER + 1
              LOCERR(NPTER) = N
          END IF
      END DO

      RETURN
      END
c ----------------------------------------------------------------------
      SUBROUTINE DDOTPR(X,Y,NPTS,XMSG,YMSG,ANS,NPTUSED,IER)
      DOUBLE PRECISION X
      DOUBLE PRECISION Y
      DOUBLE PRECISION XMSG
      DOUBLE PRECISION YMSG
      DOUBLE PRECISION ANS

c compute the dot product for series containing msg values

c arguments :
c .   x,y       - input series
c .   npts      - length of x and y
c .   xmsg,ymsg - missing code: if there are no msg values
c .                             set xmsg,ymsg to some value which will
c .                             not be encountered.
c .   ans       - answer (dot product)
c .   nptused   - number of points used to compute the dot product
c .   ier       - if (ier.ne.0) an error has occurred

      DIMENSION X(1:NPTS),Y(1:NPTS)

      IER = 0
      IF (NPTS.LT.1) THEN
          IER = 1
          RETURN
      END IF

      ANS = 0.D0
      NPTUSED = 0
      DO N = 1,NPTS
          IF (X(N).NE.XMSG .AND. Y(N).NE.YMSG) THEN
              ANS = ANS + X(N)*Y(N)
              NPTUSED = NPTUSED + 1
          END IF
      END DO

      RETURN
      END
c ----------------------------------------------------------------------
      SUBROUTINE DVCVMNS(X,NROW,NCOL,NRT,NCS,XMSG,VCM,LVCM,IER)
      DOUBLE PRECISION XMSG
      DOUBLE PRECISION XN
      DOUBLE PRECISION XCA
      DOUBLE PRECISION XCB
      DOUBLE PRECISION XCACB

c this routine will calculate the variance-covariance matrix (vcm)
c .   of the array x containing missing data. obviously if x does
c .   contain missing data then vcm is only an approximation.

c note : conventional storage is utilized for vcm

c     x        - input data array  ( unchanged on output)
c     nrow,ncol- exact dimensions of x in calling routine
c     nrt,ncs  - dimension of sub-matrix which contains the data
c                (nrt@nrow : ncs@ncol)
c     xmsg     - missing data code (if none set to some no. not
c                encountered)
c     vcm      - var-cov matrix
c     lvcm     - not used in this routine
c     ier      - error code (if ier=-1 then vcm contains missing entry)

      DOUBLE PRECISION X(1:NROW,1:NCOL),VCM(1:NCOL,1:NCOL)

      IER = 0

c calculate the var-cov between columns (stations)

      DO NCA = 1,NCS
          DO NCB = NCA,NCS
              XN = 0.D0
              XCA = 0.D0
              XCB = 0.D0
              XCACB = 0.D0
              DO I = 1,NRT
                  IF (X(I,NCA).NE.XMSG .AND. X(I,NCB).NE.XMSG) THEN
                      XN = XN + 1.D0
                      XCA = XCA + X(I,NCA)
                      XCB = XCB + X(I,NCB)
                      XCACB = XCACB + X(I,NCA)*X(I,NCB)
                  END IF
c
c end "nrt"
c
              END DO
              IF (XN.GE.2.D0) THEN
                  VCM(NCA,NCB) = (XCACB- (XCA*XCB)/ (XN))/ (XN-1.D0)
                  VCM(NCB,NCA) = VCM(NCA,NCB)
              ELSE
                  IER = -1
                  VCM(NCA,NCB) = XMSG
                  VCM(NCB,NCA) = XMSG
              END IF
c
c end "nrt"
c
          END DO
c
c end "ncs"
c
      END DO

      RETURN
      END
c ----------------------------------------------------------------------
      SUBROUTINE DVCMSSM(X,NROW,NCOL,NRT,NCS,XMSG,VCM,LVCM,IER)
      DOUBLE PRECISION X
      DOUBLE PRECISION XMSG
      DOUBLE PRECISION VCM
      DOUBLE PRECISION XN
      DOUBLE PRECISION XCA
      DOUBLE PRECISION XCB
      DOUBLE PRECISION XCACB

c this routine will calculate the variance-couariance matrix (vcm)
c .   of the array x containing missing data. obviously if x does
c .   contain missing data then vcm is only an approximation.

c note : symmetric storage mode is utilized for vcm to save space.

c input:
c     x        - input data array  ( unchanged on output)
c     nrow,ncol- exact dimensions of x in calling routine
c     nrt,ncs  - dimension of sub-matrix which contains the data
c                (nrt <= nrow : ncs <= ncol)
c     xmsg     - missing data code (if none set to some no. not
c                encountered)
c output:
c     vcm      - var-cov matrix
c     lvcm     - length of vcm
c     ier      - error code (if ier=-1 then vcm contains missing entry)

      DIMENSION X(1:NROW,1:NCOL),VCM(*)

      IER = 0
      IF (NROW.LT.1 .OR. NCOL.LT.1) IER = IER + 1
      IF (NRT.LT.1 .OR. NCS.LT.1) IER = IER + 10
      IF (IER.NE.0) RETURN

      LVCM = NCS* (NCS+1)/2

c calculate the var-cov between columns (stations)

      NN = 0
      DO NCA = 1,NCS
          DO NCB = 1,NCA
              XN = 0.D0
              XCA = 0.D0
              XCB = 0.D0
              XCACB = 0.D0
              NN = NN + 1
              DO I = 1,NRT
                  IF (X(I,NCA).NE.XMSG .AND. X(I,NCB).NE.XMSG) THEN
                      XN = XN + 1.D0
                      XCA = XCA + X(I,NCA)
                      XCB = XCB + X(I,NCB)
                      XCACB = XCACB + (X(I,NCA))* (X(I,NCB))
                  END IF
              END DO
              IF (XN.GE.2.D0) THEN
                 VCM(NN) = (XCACB-(XCA*XCB)/XN)/ (XN-1.D0)
              ELSEIF (XN.EQ.1.) THEN
                 VCM(NN) = (XCACB-(XCA*XCB)/XN)
              ELSE
                 IER = -1
                 VCM(NN) = XMSG
              END IF
          END DO
      END DO

      RETURN
      END
c
c ----------------------------------------------------------------------
      SUBROUTINE DCORMNS(X,NROW,NCOL,NRT,NCS,XMSG,CRM,LCRM,IER)
      DOUBLE PRECISION XMSG
      DOUBLE PRECISION XN
      DOUBLE PRECISION XCA
      DOUBLE PRECISION XCB
      DOUBLE PRECISION XCA2
      DOUBLE PRECISION XCB2
      DOUBLE PRECISION XCACB
      DOUBLE PRECISION XVARA
      DOUBLE PRECISION XVARB

c this routine will calculate the correlation matrix   (crm)
c .   of the array x containing missing data. obviously if x does
c .   contain missing data then crm is only an approximation.

c note : conventional storage

c     x        - input data array  ( unchanged on output)
c     nrow,ncol- exact dimensions of x in calling routine
c     nrt,ncs  - dimension of sub-matrix which contains the data
c                (nrt@nrow : ncs@ncol)
c     xmsg     - missing data code (if none set to some no. not
c                encountered)
c     crm      - correlation matrix  [full]
c     lcrm     - dummy [not used in this routine]
c     ier      - error code (if ier=-1 then crm contains missing entry)

      DOUBLE PRECISION X(1:NROW,1:NCOL),CRM(1:NCOL,1:NCOL)

      IER = 0
      LCRM = NCS* (NCS+1)/2

c calculate the var-cov between columns (stations)
c .   then standardize

      DO NCA = 1,NCS
          DO NCB = 1,NCA
              XN = 0.D0
              XCA = 0.D0
              XCB = 0.D0
              XCA2 = 0.D0
              XCB2 = 0.D0
              XCACB = 0.D0
              DO I = 1,NRT
                  IF (X(I,NCA).NE.XMSG .AND. X(I,NCB).NE.XMSG) THEN
                      XN = XN + 1.D0
                      XCA = XCA + X(I,NCA)
                      XCB = XCB + X(I,NCB)
                      XCA2 = XCA2 + X(I,NCA)*X(I,NCA)
                      XCB2 = XCB2 + X(I,NCB)*X(I,NCB)
                      XCACB = XCACB + X(I,NCA)*X(I,NCB)
                  END IF
              END DO
              IF (XN.GE.2.D0) THEN
                  XVARA = (XCA2- ((XCA*XCA)/ (XN)))/ (XN-1.D0)
                  XVARB = (XCB2- ((XCB*XCB)/ (XN)))/ (XN-1.D0)
                  IF (XVARA.GT.0.D0 .AND. XVARB.GT.0.D0) THEN
                      CRM(NCB,NCA) = (XCACB- ((XCA*XCB)/ (XN)))/
     +                               (XN-1.D0)
                      CRM(NCB,NCA) = CRM(NCB,NCA)/
     +                               (SQRT(XVARA)*SQRT(XVARB))
                      CRM(NCA,NCB) = CRM(NCB,NCA)
                  ELSE
                      IER = -1
                      CRM(NCB,NCA) = XMSG
                      CRM(NCA,NCB) = XMSG
                  END IF
              ELSE
                  IER = -1
                  CRM(NCB,NCA) = XMSG
                  CRM(NCA,NCB) = XMSG
              END IF
          END DO
      END DO

      RETURN
      END
c ----------------------------------------------------------------------
      SUBROUTINE DCRMSSM(X,NROW,NCOL,NRT,NCS,XMSG,CRM,LCRM,IER)
      DOUBLE PRECISION XMSG
      DOUBLE PRECISION XN
      DOUBLE PRECISION XCA
      DOUBLE PRECISION XCB
      DOUBLE PRECISION XCA2
      DOUBLE PRECISION XCB2
      DOUBLE PRECISION XCACB
      DOUBLE PRECISION XVARA
      DOUBLE PRECISION XVARB

c this routine will calculate the correlation matrix   (crm)
c .   of the array x containing missing data. obviously if x does
c .   contain missing data then crm is only an approximation.

c note : symmetric storage mode is utilized for crm to save space.

c input:
c     x        - input data array  ( unchanged on output)
c     nrow,ncol- exact dimensions of x in calling routine
c     nrt,ncs  - dimension of sub-matrix which contains the data
c                (nrt <= nrow : ncs <= ncol)
c     xmsg     - missing data code (if none set to some no. not
c                encountered)
c output:
c     crm      - correlation matrix
c     lcrm     - length of crm
c     ier      - error code (if ier=-1 then crm contains missing entry)

      DOUBLE PRECISION X(1:NROW,1:NCOL),CRM(*)

      IER = 0
      IF (NROW.LT.1 .OR. NCOL.LT.1) IER = IER + 1
      IF (NRT.LT.1 .OR. NCS.LT.1) IER = IER + 10
      IF (IER.NE.0) RETURN

      LCRM = NCS* (NCS+1)/2

c calculate the var-cov between columns (stations)

      NN = 0
      DO NCA = 1,NCS
          DO NCB = 1,NCA
              XN = 0.D0
              XCA = 0.D0
              XCB = 0.D0
              XCA2 = 0.D0
              XCB2 = 0.D0
              XCACB = 0.D0
              NN = NN + 1
              DO I = 1,NRT
                  IF (X(I,NCA).NE.XMSG .AND. X(I,NCB).NE.XMSG) THEN
                      XN = XN + 1.D0
                      XCA = XCA + X(I,NCA)
                      XCB = XCB + X(I,NCB)
                      XCA2 = XCA2 + X(I,NCA)*X(I,NCA)
                      XCB2 = XCB2 + X(I,NCB)*X(I,NCB)
                      XCACB = XCACB + X(I,NCA)*X(I,NCB)
                  END IF
              END DO
              IF (XN.GE.2.D0) THEN
                 XVARA = (XCA2- ((XCA*XCA)/ (XN)))/ (XN-1.D0)
                 XVARB = (XCB2- ((XCB*XCB)/ (XN)))/ (XN-1.D0)
                 IF (XVARA.GT.0.D0 .AND. XVARB.GT.0.D0) THEN
                    CRM(NN) = (XCACB- ((XCA*XCB)/ (XN)))/ (XN-1.D0)
                    CRM(NN) = CRM(NN)/ (SQRT(XVARA)*SQRT(XVARB))
                 ELSE
                    IER = -1
                    CRM(NN) = XMSG
                 END IF
              ELSEIF (XN.EQ.1.D0) THEN
                 XVARA   =  ( XCA2-((XCA*XCA)/(XN)) )
                 XVARB   =  ( XCB2-((XCB*XCB)/(XN)) )
                 IF (XVARA.GT.0.D0 .AND. XVARB.GT.0.D0) THEN
                    CRM(NN) = ( XCACB-((XCA*XCB)/(XN)) )
                    CRM(NN) = CRM(NN)/(SQRT(XVARA)*SQRT(XVARB))
                 ELSE
                    IER     = -1
                    CRM(NN) = XMSG
                 ENDIF
              ELSE
                 IER = -1
                 CRM(NN) = XMSG
              END IF
          END DO
      END DO

      RETURN
      END

c ----------------------------------------------------------------------
      SUBROUTINE DCCORC(Y,X,NROW,NCOL,NRT,NCS,XMSG,CORC,IER)
      DOUBLE PRECISION XMSG
      DOUBLE PRECISION YMEAN
      DOUBLE PRECISION YVAR
      DOUBLE PRECISION YSD
      DOUBLE PRECISION XMEAN
      DOUBLE PRECISION XVAR
      DOUBLE PRECISION XSD
      DOUBLE PRECISION XN
      DOUBLE PRECISION XY
      DOUBLE PRECISION COVAR

c this routine will calculate the correlation coef between a
c .   vector (station) y and a matrix x containing observations from
c .   many different stations

c     y        - vector (station data) with which data matrix x is to
c                be correlated
c     x        - input data array  ( unchanged on output)
c     nrow,ncol- exact dimensions of x in calling routine
c     nrt,ncs  - dimension of sub-matrix which contains the data
c                (nrt@nrow : ncs@ncol)
c     xmsg     - missing data code (if none set to some no. not
c                encountered)
c     corc     - correlation coef. vector
c                corc(1) contain correlation coef between y and x(nrt,1)
c                corc(2) contain correlation coef between y and 
c                    x(nrt,2) etc.
c     ier      - error code (if ier=-1 then corc contains missing entry)

      DOUBLE PRECISION X(1:NROW,1:NCOL),Y(*),CORC(*)

c calculate the mean and var of y

      CALL DSTAT2(Y,NRT,XMSG,YMEAN,YVAR,YSD,NPTUSY,IER)
      IF (IER.NE.0) RETURN
      IF (YSD.EQ.0.D0) THEN
          DO NC = 1,NCS
              CORC(NC) = XMSG
          END DO
          IER = 201
          RETURN
      END IF

c calculate the cross correlation coef
c .   calculate the mean and variance of column nc in the data array

      DO NC = 1,NCS
          CORC(NC) = XMSG
          CALL DSTAT2(X(1,NC),NRT,XMSG,XMEAN,XVAR,XSD,NPTUSX,JER)
          IF (JER.NE.0) THEN
              IER = 205
              GO TO 40
          END IF
          IF (XSD.NE.0.D0) THEN
              XN = 0.D0
              XY = 0.D0
              DO N = 1,NRT
                  IF (Y(N).NE.XMSG .AND. X(N,NC).NE.XMSG) THEN
                      XN = XN + 1.D0
                      XY = XY + (Y(N)-YMEAN)* (X(N,NC)-XMEAN)
                  END IF
              END DO
              IF (XN.GT.2.D0) THEN
                  COVAR = XY/ (XN-1.D0)
                  CORC(NC) = COVAR/ (XSD*YSD)
              END IF
          END IF
   40     CONTINUE
      END DO

      RETURN
      END
c------------------------------------------------------------------
      SUBROUTINE DSSMIOX(X,NCS)

c output a symmetric storage mode matrix [x]

c note: format statement have to be changed

c .   x(1)
c .   x(2)  x(3)
c .   x(4)  x(5)  x(6)
c .   etc.

      DOUBLE PRECISION X(1:*)

      DATA IPR/6/

      NCEND = 0
      DO NC = 1,NCS
          NCSTRT = NCEND + 1
          NCEND = NCSTRT + NC - 1
          WRITE (IPR,FMT='(2x,i5,10(1x,f12.3),/, (7x,(10(1x,f12.3))))')
     +      NC, (X(N),N=NCSTRT,NCEND)
      END DO

      RETURN
      END
c ------------------------------------------------------------
      DOUBLE PRECISION FUNCTION DEPSMACH(IPR)

c
c =1 print else no print
c
      INTEGER IPR
      DOUBLE PRECISION EPS

      EPS = 1.0D0
    1 EPS = 0.5D0*EPS
      IF ((1.0D0+EPS).GT.1.0D0) GO TO 1
      DEPSMACH = 2.0D0*EPS
      IF (IPR.EQ.1) WRITE (*,FMT='(''DEPSMACH: eps='',e15.7)') DEPSMACH

      RETURN
      END

c ----------------------------------------------------------------------
      SUBROUTINE DSORTU(A,LA)

c sort type "real"

      INTEGER LA
      DOUBLE PRECISION A(LA)

      INTEGER IU(21),IL(21),I,M,J,K,IJ,L
      DOUBLE PRECISION T,TT,R

      M = 1
      I = 1
      J = LA
      R = .375D0
      IF (LA.LE.0) RETURN
   10 IF (I.EQ.J) GO TO 55
   15 IF (R.GT..5898437D0) GO TO 20
      R = R + 3.90625D-2
      GO TO 25
   20 R = R - .21875D0
   25 K = I
c                          select a central element of the
c                          array and save it in location t
      IJ = I + (J-I)*R
      T = A(IJ)
c                          if first element of array is greater
c                          than t, interchange with t
      IF (A(I).LE.T) GO TO 30
      A(IJ) = A(I)
      A(I) = T
      T = A(IJ)
   30 L = J
c                           if last element of array is less than
c                           t, interchange with t
      IF (A(J).GE.T) GO TO 40
      A(IJ) = A(J)
      A(J) = T
      T = A(IJ)
c                          if first element of array is greater
c                          than t, interchange with t
      IF (A(I).LE.T) GO TO 40
      A(IJ) = A(I)
      A(I) = T
      T = A(IJ)
      GO TO 40
   35 IF (A(L).EQ.A(K)) GO TO 40
      TT = A(L)
      A(L) = A(K)
      A(K) = TT
c                           find an element in the second half of
c                           the array which is smaller than t
   40 L = L - 1
      IF (A(L).GT.T) GO TO 40
c                           find an element in the first half of
c                           the array which is greater than t
   45 K = K + 1
      IF (A(K).LT.T) GO TO 45
c                           interchange these elements
      IF (K.LE.L) GO TO 35
c                           save upper and lower subscripts of
c                           the array yet to be sorted
      IF (L-I.LE.J-K) GO TO 50
      IL(M) = I
      IU(M) = L
      I = K
      M = M + 1
      GO TO 60
   50 IL(M) = K
      IU(M) = J
      J = L
      M = M + 1
      GO TO 60
c                           begin again on another portion of
c                           the unsorted array
   55 M = M - 1
      IF (M.EQ.0) RETURN
      I = IL(M)
      J = IU(M)
   60 IF (J-I.GE.11) GO TO 25
      IF (I.EQ.1) GO TO 10
      I = I - 1
   65 I = I + 1
      IF (I.EQ.J) GO TO 55
      T = A(I+1)
      IF (A(I).LE.T) GO TO 65
      K = I
   70 A(K+1) = A(K)
      K = K - 1
      IF (T.LT.A(K)) GO TO 70
      A(K+1) = T
      GO TO 65
      END
c ----------------------------------------------------------------------
      SUBROUTINE DISORTU(A,LA)

c sort type "integer"

      INTEGER LA
      INTEGER A(LA)

      INTEGER IU(21),IL(21),I,M,J,K,IJ,L
      INTEGER T,TT
      DOUBLE PRECISION R

      M = 1
      I = 1
      J = LA
      R = .375D0
      IF (LA.LE.0) RETURN
   10 IF (I.EQ.J) GO TO 55
   15 IF (R.GT..5898437D0) GO TO 20
      R = R + 3.90625D-2
      GO TO 25
   20 R = R - .21875D0
   25 K = I
c                                  select a central element of the
c                                  array and save it in location t
      IJ = I + (J-I)*R
      T = A(IJ)
c                                  if first element of array is greater
c                                  than t, interchange with t
      IF (A(I).LE.T) GO TO 30
      A(IJ) = A(I)
      A(I) = T
      T = A(IJ)
   30 L = J
c                                  if last element of array is less than
c                                  t, interchange with t
      IF (A(J).GE.T) GO TO 40
      A(IJ) = A(J)
      A(J) = T
      T = A(IJ)
c                                  if first element of array is greater
c                                  than t, interchange with t
      IF (A(I).LE.T) GO TO 40
      A(IJ) = A(I)
      A(I) = T
      T = A(IJ)
      GO TO 40
   35 IF (A(L).EQ.A(K)) GO TO 40
      TT = A(L)
      A(L) = A(K)
      A(K) = TT
c                                  find an element in the second half of
c                                  the array which is smaller than t
   40 L = L - 1
      IF (A(L).GT.T) GO TO 40
c                                  find an element in the first half of
c                                  the array which is greater than t
   45 K = K + 1
      IF (A(K).LT.T) GO TO 45
c                                  interchange these elements
      IF (K.LE.L) GO TO 35
c                                  save upper and lower subscripts of
c                                  the array yet to be sorted
      IF (L-I.LE.J-K) GO TO 50
      IL(M) = I
      IU(M) = L
      I = K
      M = M + 1
      GO TO 60
   50 IL(M) = K
      IU(M) = J
      J = L
      M = M + 1
      GO TO 60
c                                  begin again on another portion of
c                                  the unsorted array
   55 M = M - 1
      IF (M.EQ.0) RETURN
      I = IL(M)
      J = IU(M)
   60 IF (J-I.GE.11) GO TO 25
      IF (I.EQ.1) GO TO 10
      I = I - 1
   65 I = I + 1
      IF (I.EQ.J) GO TO 55
      T = A(I+1)
      IF (A(I).LE.T) GO TO 65
      K = I
   70 A(K+1) = A(K)
      K = K - 1
      IF (T.LT.A(K)) GO TO 70
      A(K+1) = T
      GO TO 65
      END

      SUBROUTINE COLLAPSEXY(X,Y,NPTS,XMSG,YMSG,XX,YY,MPTS)
      IMPLICIT NONE
      INTEGER NPTS,MPTS
      DOUBLE PRECISION X(NPTS),Y(NPTS)
      DOUBLE PRECISION XX(NPTS),YY(NPTS)
      DOUBLE PRECISION XMSG,YMSG

      INTEGER N

      MPTS = 0
      DO N = 1,NPTS
          IF (X(N).NE.XMSG .AND. Y(N).NE.YMSG) THEN
              MPTS = MPTS + 1
              XX(MPTS) = X(N)
              YY(MPTS) = Y(N)
c              PRINT *,'n, mpts, xx(mpts), yy(mpts)=',N,MPTS,XX(MPTS),
c     +          YY(MPTS)
          END IF
      END DO

      RETURN
      END

C
C	$Id: pcffgp.f,v 1.5 2008-07-27 00:17:19 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE PCFFGP(NUM,IOFF,PFLG,X,Y)
C
C  Get NUM packets from the fontcap starting at bit offset IOFF.
C  Store the packet(s) in the arrays PFLG, X, and Y.
C
      include 'pcffme.h'
      include 'pcffdx.h'
C
      INTEGER PFLG(*),X(*),Y(*)
C
      CALL GBYTES(IBFC,PFLG,IOFF,PKFLWD,XBITWD+YBITWD,NUM)
      CALL GBYTES(IBFC,X,IOFF+PKFLWD,XBITWD,YBITWD+PKFLWD,NUM)
      CALL GBYTES(IBFC,Y,IOFF+PKFLWD+XBITWD,YBITWD,PKFLWD+XBITWD,NUM)
C
      RETURN
      END

C
C $Id: rdpntz.f,v 1.7 2008-09-18 00:42:18 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      FUNCTION RDPNTZ (DVIN)
C
        DOUBLE PRECISION DVIN,DVAL,SVAL,TVAL
C
C "RDPNTZ" stands for "Round Double Precision Number Toward Zero".  The
C value of RDPNTZ is the real number having the largest absolute value
C which is less than or equal to the value of the double-precision
C argument DVIN.
C
        IF (DVIN.LT.0.D0) THEN
          DVAL=-DVIN
          DSGN=-1.
        ELSE
          DVAL=+DVIN
          DSGN=+1.
        END IF
C
        IF (DBLE(REAL(DVAL)).LE.DVAL) THEN
          RDPNTZ=SIGN(REAL(DVAL),DSGN)
        ELSE
          SVAL=.5D0
          TVAL=.25D0
          NTMS=0
  101     IF (DBLE(REAL(SVAL*DVAL)).LE.DVAL) THEN
            RDPNTZ=SIGN(REAL(SVAL*DVAL),DSGN)
            SVAL=SVAL+TVAL
            TVAL=TVAL/2.D0
            NTMS=NTMS+1
            IF (NTMS.LT.64) GO TO 101
          END IF
        END IF
C
C Done.
C
        RETURN
C
      END

C NCLFORTSTART
      SUBROUTINE DCOMPUTEPI(PI,PRESSURE,NX,NY,NZ)
      IMPLICIT NONE
      INTEGER NX,NY,NZ
      DOUBLE PRECISION PI(NX,NY,NZ)
      DOUBLE PRECISION PRESSURE(NX,NY,NZ)
C NCLEND

      INTEGER I,J,K
      DOUBLE PRECISION P1000MB,R_D,CP
      PARAMETER (P1000MB=100000.D0,R_D=287.D0,CP=7.D0*R_D/2.D0)

      DO K = 1,NZ
          DO J = 1,NY
              DO I = 1,NX
                  PI(I,J,K) = (PRESSURE(I,J,K)/P1000MB)** (R_D/CP)
              END DO
          END DO
      END DO

      END

C NCLFORTSTART
      SUBROUTINE DCOMPUTETK(TK,PRESSURE,THETA,NX)
      IMPLICIT NONE
      INTEGER NX
      DOUBLE PRECISION PI
      DOUBLE PRECISION PRESSURE(NX)
      DOUBLE PRECISION THETA(NX)
      DOUBLE PRECISION TK(NX)
C NCLEND

      INTEGER I
      DOUBLE PRECISION P1000MB,R_D,CP
      PARAMETER (P1000MB=100000.D0,R_D=287.D0,CP=7.D0*R_D/2.D0)

      DO I = 1,NX
         PI = (PRESSURE(I)/P1000MB)** (R_D/CP)
         TK(I) = PI*THETA(I)
      END DO

      END

C NCLFORTSTART
      SUBROUTINE DINTERP3DZ(V3D,V2D,Z,LOC,NX,NY,NZ,VMSG)
      IMPLICIT NONE
      INTEGER NX,NY,NZ
      DOUBLE PRECISION V3D(NX,NY,NZ),V2D(NX,NY)
      DOUBLE PRECISION Z(NX,NY,NZ)
      DOUBLE PRECISION LOC
      DOUBLE PRECISION VMSG
C NCLEND

      INTEGER I,J,KP,IP,IM
      LOGICAL INTERP
      DOUBLE PRECISION HEIGHT,W1,W2

      HEIGHT = LOC

c does vertical coordinate increase or decrease with increasing k?
c set offset appropriately

      IP = 0
      IM = 1
      IF (Z(1,1,1).GT.Z(1,1,NZ)) THEN
          IP = 1
          IM = 0
      END IF

      DO I = 1,NX
          DO J = 1,NY
C Initialize to missing.  Was initially hard-coded to -999999.
              V2D(I,J) = VMSG
              INTERP = .false.
              KP = NZ

              DO WHILE ((.NOT.INTERP) .AND. (KP.GE.2))

                  IF (((Z(I,J,KP-IM).LE.HEIGHT).AND. (Z(I,J,
     +                KP-IP).GT.HEIGHT))) THEN
                      W2 = (HEIGHT-Z(I,J,KP-IM))/
     +                     (Z(I,J,KP-IP)-Z(I,J,KP-IM))
                      W1 = 1.D0 - W2
                      V2D(I,J) = W1*V3D(I,J,KP-IM) + W2*V3D(I,J,KP-IP)
                      INTERP = .true.
                  END IF
                  KP = KP - 1

              END DO

          END DO
      END DO

      RETURN
      END

C NCLFORTSTART
      SUBROUTINE DZSTAG(ZNEW,NX,NY,NZ,Z,NXZ,NYZ,NZZ,TERRAIN)
      IMPLICIT NONE
      INTEGER NX,NY,NZ,NXZ,NYZ,NZZ
      DOUBLE PRECISION ZNEW(NX,NY,NZ),Z(NXZ,NYZ,NZZ)
      DOUBLE PRECISION TERRAIN(NXZ,NYZ)
C NCLEND

      INTEGER I,J,K,II,IM1,JJ,JM1

c check for u, v, or w (x,y,or z) staggering
c
c for x and y stag, avg z to x, y, point
c
      IF (NX.GT.NXZ) THEN

          DO K = 1,NZ
              DO J = 1,NY
                  DO I = 1,NX
                      II = MIN0(I,NXZ)
                      IM1 = MAX0(I-1,1)
                      ZNEW(I,J,K) = 0.5D0* (Z(II,J,K)+Z(IM1,J,K))
                  END DO
              END DO
          END DO

      ELSE IF (NY.GT.NYZ) THEN

          DO K = 1,NZ
              DO J = 1,NY
                  JJ = MIN0(J,NYZ)
                  JM1 = MAX0(J-1,1)
                  DO I = 1,NX
                      ZNEW(I,J,K) = 0.5D0* (Z(I,JJ,K)+Z(I,JM1,K))
                  END DO
              END DO
          END DO
c
c w (z) staggering
c
      ELSE IF (NZ.GT.NZZ) THEN

          DO J = 1,NY
              DO I = 1,NX
                  ZNEW(I,J,1) = TERRAIN(I,J)
              END DO
          END DO

          DO K = 2,NZ
              DO J = 1,NY
                  DO I = 1,NX
                      ZNEW(I,J,K) = ZNEW(I,J,K-1) +
     +                              2.D0* (Z(I,J,K-1)-ZNEW(I,J,K-1))
                  END DO
              END DO
          END DO

      END IF

      RETURN
      END

C NCLFORTSTART
      SUBROUTINE DINTERP2DXY(V3D,V2D,XY,NX,NY,NZ,NXY)
      IMPLICIT NONE
      INTEGER NX,NY,NZ,NXY
      DOUBLE PRECISION V3D(NX,NY,NZ),V2D(NXY,NZ)
      DOUBLE PRECISION XY(2,NXY)
C NCLEND

      INTEGER I,J,K,IJ
      DOUBLE PRECISION W11,W12,W21,W22,WX,WY

      DO IJ = 1,NXY

          I = MAX0(1,MIN0(NX-1,INT(XY(1,IJ)+1)))
          J = MAX0(1,MIN0(NY-1,INT(XY(2,IJ)+1)))
          WX = DBLE(I+1) - (XY(1,IJ)+1)
          WY = DBLE(J+1) - (XY(2,IJ)+1)
          W11 = WX*WY
          W21 = (1.D0-WX)*WY
          W12 = WX* (1.D0-WY)
          W22 = (1.D0-WX)* (1.D0-WY)
          DO K = 1,NZ
              V2D(IJ,K) = W11*V3D(I,J,K) + W21*V3D(I+1,J,K) +
     +                    W12*V3D(I,J+1,K) + W22*V3D(I+1,J+1,K)
          END DO
      END DO

      RETURN
      END

C NCLFORTSTART
      SUBROUTINE DINTERP1D(V_IN,V_OUT,Z_IN,Z_OUT,NZ_IN,NZ_OUT,VMSG)
      IMPLICIT NONE
      INTEGER NZ_IN,NZ_OUT
      DOUBLE PRECISION V_IN(NZ_IN),Z_IN(NZ_IN)
      DOUBLE PRECISION V_OUT(NZ_OUT),Z_OUT(NZ_OUT)
      DOUBLE PRECISION VMSG
C NCLEND

      INTEGER KP,K,IM,IP
      LOGICAL INTERP
      DOUBLE PRECISION HEIGHT,W1,W2

c does vertical coordinate increase of decrease with increasing k?
c set offset appropriately

      IP = 0
      IM = 1
      IF (Z_IN(1).GT.Z_IN(NZ_IN)) THEN
          IP = 1
          IM = 0
      END IF

      DO K = 1,NZ_OUT
          V_OUT(K) = VMSG

          INTERP = .false.
          KP = NZ_IN
          HEIGHT = Z_OUT(K)

          DO WHILE ((.NOT.INTERP) .AND. (KP.GE.2))

              IF (((Z_IN(KP-IM).LE.HEIGHT).AND.
     +            (Z_IN(KP-IP).GT.HEIGHT))) THEN
                  W2 = (HEIGHT-Z_IN(KP-IM))/ (Z_IN(KP-IP)-Z_IN(KP-IM))
                  W1 = 1.D0 - W2
                  V_OUT(K) = W1*V_IN(KP-IM) + W2*V_IN(KP-IP)
                  INTERP = .true.
              END IF
              KP = KP - 1

          END DO

      END DO

      RETURN
      END

c---------------------------------------------

c Bill,
c This routine assumes
c    index order is (i,j,k)
c    wrf staggering
C
c    units: pressure (Pa), temperature(K), height (m), mixing ratio
c     (kg kg{-1}) availability of 3d p, t, and qv; 2d terrain; 1d 
c half-level zeta string
c    output units of SLP are Pa, but you should divide that by 100 for the
c          weather weenies.
c    virtual effects are included
c

C NCLFORTSTART
      SUBROUTINE DCOMPUTESEAPRS(NX,NY,NZ,Z,T,P,Q,SEA_LEVEL_PRESSURE,
     +                          T_SEA_LEVEL,T_SURF,LEVEL)
      IMPLICIT NONE
c     Estimate sea level pressure.
      INTEGER NX,NY,NZ
      DOUBLE PRECISION Z(NX,NY,NZ)
      DOUBLE PRECISION T(NX,NY,NZ),P(NX,NY,NZ),Q(NX,NY,NZ)
c     The output is the 2d sea level pressure.
      DOUBLE PRECISION SEA_LEVEL_PRESSURE(NX,NY)
      INTEGER LEVEL(NX,NY)
      DOUBLE PRECISION T_SURF(NX,NY),T_SEA_LEVEL(NX,NY)
C NCLEND
c     Some required physical constants:

      DOUBLE PRECISION R,G,GAMMA
      PARAMETER (R=287.04D0,G=9.81D0,GAMMA=0.0065D0)

c     Specific constants for assumptions made in this routine:

      DOUBLE PRECISION TC,PCONST
      PARAMETER (TC=273.16D0+17.5D0,PCONST=10000)
      LOGICAL RIDICULOUS_MM5_TEST
      PARAMETER (RIDICULOUS_MM5_TEST=.TRUE.)
c      PARAMETER (ridiculous_mm5_test = .false.)

c     Local variables:

      INTEGER I,J,K
      INTEGER KLO,KHI


      DOUBLE PRECISION PLO,PHI,TLO,THI,ZLO,ZHI
      DOUBLE PRECISION P_AT_PCONST,T_AT_PCONST,Z_AT_PCONST
      DOUBLE PRECISION Z_HALF_LOWEST

      LOGICAL L1,L2,L3,FOUND

C
c  Find least zeta level that is PCONST Pa above the surface.  We
c  later use this level to extrapolate a surface pressure and 
c  temperature, which is supposed to reduce the effect of the diurnal
c  heating cycle in the pressure field.

      DO J = 1,NY
          DO I = 1,NX
              LEVEL(I,J) = -1

              K = 1
              FOUND = .false.
              DO WHILE ((.NOT.FOUND) .AND. (K.LE.NZ))
                  IF (P(I,J,K).LT.P(I,J,1)-PCONST) THEN
                      LEVEL(I,J) = K
                      FOUND = .true.
                  END IF
                  K = K + 1
              END DO

              IF (LEVEL(I,J).EQ.-1) THEN
                  PRINT '(A,I4,A)','Troubles finding level ',
     +              NINT(PCONST)/100,' above ground.'
                  PRINT '(A,I4,A,I4,A)','Problems first occur at (',I,
     +              ',',J,')'
                  PRINT '(A,F6.1,A)','Surface pressure = ',P(I,J,1)/100,
     +              ' hPa.'
                  STOP 'Error_in_finding_100_hPa_up'
              END IF


          END DO
      END DO

c     Get temperature PCONST Pa above surface.  Use this to extrapolate
c     the temperature at the surface and down to sea level.

      DO J = 1,NY
          DO I = 1,NX

              KLO = MAX(LEVEL(I,J)-1,1)
              KHI = MIN(KLO+1,NZ-1)

              IF (KLO.EQ.KHI) THEN
                  PRINT '(A)','Trapping levels are weird.'
                  PRINT '(A,I3,A,I3,A)','klo = ',KLO,', khi = ',KHI,
     +              ': and they should not be equal.'
                  STOP 'Error_trapping_levels'
              END IF

              PLO = P(I,J,KLO)
              PHI = P(I,J,KHI)
              TLO = T(I,J,KLO)* (1.D0+0.608D0*Q(I,J,KLO))
              THI = T(I,J,KHI)* (1.D0+0.608D0*Q(I,J,KHI))
c         zlo = zetahalf(klo)/ztop*(ztop-terrain(i,j))+terrain(i,j)
c         zhi = zetahalf(khi)/ztop*(ztop-terrain(i,j))+terrain(i,j)
              ZLO = Z(I,J,KLO)
              ZHI = Z(I,J,KHI)

              P_AT_PCONST = P(I,J,1) - PCONST
              T_AT_PCONST = THI - (THI-TLO)*LOG(P_AT_PCONST/PHI)*
     +                      LOG(PLO/PHI)
              Z_AT_PCONST = ZHI - (ZHI-ZLO)*LOG(P_AT_PCONST/PHI)*
     +                      LOG(PLO/PHI)

              T_SURF(I,J) = T_AT_PCONST* (P(I,J,1)/P_AT_PCONST)**
     +                      (GAMMA*R/G)
              T_SEA_LEVEL(I,J) = T_AT_PCONST + GAMMA*Z_AT_PCONST

          END DO
      END DO

C
c If we follow a traditional computation, there is a correction to the
c sea level temperature if both the surface and sea level 
c temperatures are *too* hot.

      IF (RIDICULOUS_MM5_TEST) THEN
          DO J = 1,NY
              DO I = 1,NX
                  L1 = T_SEA_LEVEL(I,J) .LT. TC
                  L2 = T_SURF(I,J) .LE. TC
                  L3 = .NOT. L1
                  IF (L2 .AND. L3) THEN
                      T_SEA_LEVEL(I,J) = TC
                  ELSE
                      T_SEA_LEVEL(I,J) = TC -
     +                                   0.005D0* (T_SURF(I,J)-TC)**2
                  END IF
              END DO
          END DO
      END IF

c     The grand finale: ta da!

      DO J = 1,NY
          DO I = 1,NX
c   z_half_lowest=zetahalf(1)/ztop*(ztop-terrain(i,j))+terrain(i,j)
              Z_HALF_LOWEST = Z(I,J,1)

C Convert to hPa in this step, by multiplying by 0.01. The original
C Fortran routine didn't do this, but the NCL script that called it
C did, so we moved it here.
              SEA_LEVEL_PRESSURE(I,J) = 0.01 * (P(I,J,1)*
     +                                  EXP((2.D0*G*Z_HALF_LOWEST)/
     +                                  (R* (T_SEA_LEVEL(I,J)+T_SURF(I,
     +                                  J)))))
          END DO
      END DO

c     print *,'sea pres input at weird location i=20,j=1,k=1'
c     print *,'t=',t(20,1,1),t(20,2,1),t(20,3,1)
c     print *,'z=',z(20,1,1),z(20,2,1),z(20,3,1)
c     print *,'p=',p(20,1,1),p(20,2,1),p(20,3,1)
c     print *,'slp=',sea_level_pressure(20,1),
c    *         sea_level_pressure(20,2),sea_level_pressure(20,3)

      END


c---------------------------------------------------

C
C Double precision version. If you make a change here, you
C must make the same change below to filter2d.
C
C NCLFORTSTART
      SUBROUTINE DFILTER2D(A,B,NX,NY,IT,MISSING)
      IMPLICIT NONE
c     Estimate sea level pressure.
      INTEGER NX,NY,IT
      DOUBLE PRECISION A(NX,NY),B(NX,NY),MISSING
C NCLEND

      DOUBLE PRECISION COEF
      PARAMETER (COEF=0.25D0)
      INTEGER I,J,ITER

      DO ITER = 1,IT
          DO J = 1,NY
              DO I = 1,NX
                  B(I,J) = A(I,J)
              END DO
          END DO
          DO J = 2,NY - 1
             DO I = 1,NX
                IF ( B(I,J-1).EQ.MISSING .OR. B(I,J).EQ.MISSING .OR.
     +               B(I,J+1).EQ.MISSING ) THEN
                   A(I,J) = A(I,J)
                ELSE
                   A(I,J) = A(I,J) + COEF* (B(I,J-1)-2*B(I,J)+B(I,J+1))
                END IF
             END DO
          END DO
          DO J = 1,NY
             DO I = 2,NX - 1
                IF ( B(I-1,J).EQ.MISSING .OR. B(I,J).EQ.MISSING .OR.
     +               B(I+1,J).EQ.MISSING ) THEN
                   A(I,J) = A(I,J)
                ELSE
                   A(I,J) = A(I,J) + COEF* (B(I-1,J)-2*B(I,J)+B(I+1,J))
                END IF
             END DO
          END DO
c        do j=1,ny
c        do i=1,nx
c          b(i,j) = a(i,j)
c        enddo
c        enddo
c        do j=2,ny-1
c        do i=1,nx
c          a(i,j) = a(i,j) - .99*coef*(b(i,j-1)-2*b(i,j)+b(i,j+1))
c        enddo
c        enddo
c        do j=1,ny
c        do i=2,nx-1
c          a(i,j) = a(i,j) - .99*coef*(b(i-1,j)-2*b(i,j)+b(i+1,j))
c        enddo
c        enddo
      END DO
      RETURN
      END

C
C Single precision version. If you make a change here, you
C must make the same change above to dfilter2d.
C
C NCLFORTSTART
      SUBROUTINE filter2d( a, b, nx , ny , it, missing)
      IMPLICIT NONE
c     Estimate sea level pressure.
      INTEGER nx , ny, it
      REAL    a(nx,ny),b(nx,ny), missing
C NCLEND

      REAL coef
      parameter( coef = 0.25)
      INTEGER i,j,iter

      do iter=1, it
        do j=1,ny
        do i=1,nx
          b(i,j) = a(i,j)
        enddo
        enddo
        do j=2,ny-1
        do i=1,nx
          if ( b(i,j-1).eq.missing .or. b(i,j).eq.missing .or.
     +         b(i,j+1).eq.missing ) then
             a(i,j) = a(i,j)
          else
             a(i,j) = a(i,j) + coef*(b(i,j-1)-2*b(i,j)+b(i,j+1))
          end if
        enddo
        enddo
        do j=1,ny
        do i=2,nx-1
           if ( b(i-1,j).eq.missing .or. b(i,j).eq.missing .or.
     +          b(i+1,j).eq.missing ) then
              a(i,j) = a(i,j)
           else
              a(i,j) = a(i,j) + coef*(b(i-1,j)-2*b(i,j)+b(i+1,j))
           end if
        enddo
        enddo
c        do j=1,ny
c        do i=1,nx
c          b(i,j) = a(i,j)
c        enddo
c        enddo
c        do j=2,ny-1
c        do i=1,nx
c          a(i,j) = a(i,j) - .99*coef*(b(i,j-1)-2*b(i,j)+b(i,j+1))
c        enddo
c        enddo
c        do j=1,ny
c        do i=2,nx-1
c          a(i,j) = a(i,j) - .99*coef*(b(i-1,j)-2*b(i,j)+b(i+1,j))
c        enddo
c        enddo
      enddo
      return
      end
c---------------------------------------------------------

C NCLFORTSTART
      SUBROUTINE DCOMPUTERH(QV,P,T,RH,NX)

      IMPLICIT NONE
      INTEGER NX
      DOUBLE PRECISION QV(NX),P(NX),T(NX),RH(NX)
C NCLEND
      DOUBLE PRECISION SVP1,SVP2,SVP3,SVPT0
      PARAMETER (SVP1=0.6112D0,SVP2=17.67D0,SVP3=29.65D0,SVPT0=273.15D0)
      INTEGER I
      DOUBLE PRECISION QVS,ES,PRESSURE,TEMPERATURE
      DOUBLE PRECISION EP_2,R_D,R_V
      PARAMETER (R_D=287.D0,R_V=461.6D0,EP_2=R_D/R_V)
      DOUBLE PRECISION EP_3
      PARAMETER (EP_3=0.622D0)

      DO I = 1,NX
         PRESSURE = P(I)
         TEMPERATURE = T(I)
c       es  = 1000.*svp1*
         ES = 10.D0*SVP1*EXP(SVP2* (TEMPERATURE-SVPT0)/
     +        (TEMPERATURE-SVP3))
c       qvs = ep_2*es/(pressure-es)
         QVS = EP_3*ES/ (0.01D0*PRESSURE- (1.D0-EP_3)*ES)
c        rh = 100*amax1(1., qv(i)/qvs)
c       rh(i) = 100.*qv(i)/qvs
         RH(I) = 100.D0*DMAX1(DMIN1(QV(I)/QVS,1.0D0),0.0D0)
      END DO

      RETURN
      END

c----------------------------------------------

C NCLFORTSTART
      SUBROUTINE DGETIJLATLONG(LAT_ARRAY,LONG_ARRAY,LAT,LONGITUDE,
     +                         II,JJ,NX,NY,IMSG)
      IMPLICIT NONE
      INTEGER NX,NY,II,JJ,IMSG
      DOUBLE PRECISION LAT_ARRAY(NX,NY),LONG_ARRAY(NX,NY)
      DOUBLE PRECISION LAT,LONGITUDE
C NCLEND
      DOUBLE PRECISION LONGD,LATD
      INTEGER I,J
      DOUBLE PRECISION IR,JR
      DOUBLE PRECISION DIST_MIN,DIST

C Init to missing. Was hard-coded to -999 initially.
      IR = IMSG
      JR = IMSG

      DIST_MIN = 1.D+20
      DO J = 1,NY
          DO I = 1,NX
              LATD = (LAT_ARRAY(I,J)-LAT)**2
              LONGD = (LONG_ARRAY(I,J)-LONGITUDE)**2
C             LONGD = DMIN1((LONG_ARRAY(I,J)-LONGITUDE)**2,
C    +                (LONG_ARRAY(I,J)+LONGITUDE)**2)
              DIST = SQRT(LATD+LONGD)
              IF (DIST_MIN.GT.DIST) THEN
                  DIST_MIN = DIST
                  IR = DBLE(I)
                  JR = DBLE(J)
              END IF
          END DO
      END DO
C
C The original version of this routine returned IR and JR. But, then
C the NCL script that called this routine was converting IR and JR
C to integer, so why not just return II and JJ?
C
C Also, I'm subtracing 1 here, because it will be returned to NCL
C script which has 0-based indexing.
C 
      IF(IR.ne.IMSG.and.JR.ne.IMSG) then
        II = NINT(IR)-1
        JJ = NINT(JR)-1
      ELSE
        II = IMSG
        JJ = IMSG
      END IF

c we will just return the nearest point at present

      RETURN
      END

C NCLFORTSTART
      SUBROUTINE DCOMPUTEUVMET(U,V,UVMET,LONGCA,LONGCB,FLONG,FLAT,
     +                         CEN_LONG,CONE,RPD,NX,NY,NXP1,NYP1,
     +                         ISTAG,IS_MSG_VAL,UMSG,VMSG,UVMETMSG)
      IMPLICIT NONE

C ISTAG should be 0 if the U,V grids are not staggered.
C That is, NY = NYP1 and NX = NXP1.

      INTEGER NX,NY,NXP1,NYP1,ISTAG
      LOGICAL IS_MSG_VAL
      DOUBLE PRECISION U(NXP1,NY),V(NX,NYP1)
      DOUBLE PRECISION UVMET(NX,NY,2)
      DOUBLE PRECISION FLONG(NX,NY),FLAT(NX,NY)
      DOUBLE PRECISION LONGCB(NX,NY),LONGCA(NX,NY)
      DOUBLE PRECISION CEN_LONG,CONE,RPD
      DOUBLE PRECISION UMSG,VMSG,UVMETMSG
C NCLEND

      INTEGER I,J
      DOUBLE PRECISION UK,VK


c      WRITE (6,FMT=*) ' in compute_uvmet ',NX,NY,NXP1,NYP1,ISTAG

      DO J = 1,NY
          DO I = 1,NX

              LONGCA(I,J) = FLONG(I,J) - CEN_LONG
              IF (LONGCA(I,J).GT.180.D0) THEN
                  LONGCA(I,J) = LONGCA(I,J) - 360.D0
              END IF
              IF (LONGCA(I,J).LT.-180.D0) THEN
                  LONGCA(I,J) = LONGCA(I,J) + 360.D0
              END IF
              IF (FLAT(I,J).LT.0.D0) THEN
                  LONGCB(I,J) = -LONGCA(I,J)*CONE*RPD
              ELSE
                  LONGCB(I,J) = LONGCA(I,J)*CONE*RPD
              END IF

              LONGCA(I,J) = COS(LONGCB(I,J))
              LONGCB(I,J) = SIN(LONGCB(I,J))

          END DO
      END DO

c      WRITE (6,FMT=*) ' computing velocities '

      DO J = 1,NY
         DO I = 1,NX
            IF (ISTAG.EQ.1) THEN
               IF (IS_MSG_VAL.AND.(U(I,J).EQ.UMSG.OR.
     +                             V(I,J).EQ.VMSG.OR.
     +                             U(I+1,J).EQ.UMSG.OR.
     +                             V(I,J+1).EQ.VMSG)) THEN
                  UVMET(I,J,1) = UVMETMSG
                  UVMET(I,J,2) = UVMETMSG
               ELSE
                  UK = 0.5D0* (U(I,J)+U(I+1,J))
                  VK = 0.5D0* (V(I,J)+V(I,J+1))
                  UVMET(I,J,1) = VK*LONGCB(I,J) + UK*LONGCA(I,J)
                  UVMET(I,J,2) = VK*LONGCA(I,J) - UK*LONGCB(I,J)
               END IF
            ELSE
               IF (IS_MSG_VAL.AND.(U(I,J).EQ.UMSG.OR.
     +                             V(I,J).EQ.VMSG)) THEN
                  UVMET(I,J,1) = UVMETMSG
                  UVMET(I,J,2) = UVMETMSG
               ELSE
                  UK = U(I,J)
                  VK = V(I,J)
                  UVMET(I,J,1) = VK*LONGCB(I,J) + UK*LONGCA(I,J)
                  UVMET(I,J,2) = VK*LONGCA(I,J) - UK*LONGCB(I,J)
               END IF
            END IF
         END DO
      END DO

      RETURN
      END

C NCLFORTSTART
C
C This was originally a routine that took 2D input arrays. Since
C the NCL C wrapper routine can handle multiple dimensions, it's
C not necessary to have anything bigger than 1D here.
C
      SUBROUTINE DCOMPUTETD(TD,PRESSURE,QV_IN,NX)
      IMPLICIT NONE
      INTEGER NX
      DOUBLE PRECISION PRESSURE(NX)
      DOUBLE PRECISION QV_IN(NX)
      DOUBLE PRECISION TD(NX)
C NCLEND
      DOUBLE PRECISION QV,TDC

      INTEGER I

      DO I = 1,NX
          QV = DMAX1(QV_IN(I),0.D0)
c vapor pressure
          TDC = QV*PRESSURE(I)/ (.622D0+QV)

c avoid problems near zero
          TDC = DMAX1(TDC,0.001D0)
          TD(I) = (243.5D0*LOG(TDC)-440.8D0)/ (19.48D0-LOG(TDC))
      END DO

      RETURN
      END

C NCLFORTSTART
      SUBROUTINE DCOMPUTEICLW(ICLW,PRESSURE,QC_IN,NX,NY,NZ)
      IMPLICIT NONE
      INTEGER NX,NY,NZ
      DOUBLE PRECISION PRESSURE(NX,NY,NZ)
      DOUBLE PRECISION QC_IN(NX,NY,NZ)
      DOUBLE PRECISION ICLW(NX,NY)
      DOUBLE PRECISION QCLW,DP,GG
C NCLEND

      INTEGER I,J,K

      GG = 1000.D0/9.8D0

      DO J = 1,NY
          DO I = 1,NX
              ICLW(I,J) = 0.D0
          END DO
      END DO

      DO J = 3,NY - 2
          DO I = 3,NX - 2
              DO K = 1,NZ
                  QCLW = DMAX1(QC_IN(I,J,K),0.D0)
                  IF (K.EQ.1) THEN
                      DP = (PRESSURE(I,J,K-1)-PRESSURE(I,J,K))
                  ELSE IF (K.EQ.NZ) THEN
                      DP = (PRESSURE(I,J,K)-PRESSURE(I,J,K+1))
                  ELSE
                      DP = (PRESSURE(I,J,K-1)-PRESSURE(I,J,K+1))/2.D0
                  END IF
                  ICLW(I,J) = ICLW(I,J) + QCLW*DP*GG
              END DO
          END DO
      END DO

      RETURN
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C   FFTPACK 5.0
C   Copyright (C) 1995-2004, Scientific Computing Division,
C   University Corporation for Atmospheric Research
C   Licensed under the GNU General Public License (GPL)
C
C   Authors:  Paul N. Swarztrauber and Richard A. Valent
C
C   $Id: cmfm1b.f,v 1.2 2006-11-21 01:10:16 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      SUBROUTINE DCMFM1B(LOT,JUMP,N,INC,C,CH,WA,FNF,FAC)
      DOUBLE PRECISION FNF
      DOUBLE COMPLEX C(*)
      DOUBLE PRECISION CH(*),WA(*),FAC(*)
C
C FFTPACK 5.0 auxiliary routine
C
      NF = FNF
      NA = 0
      L1 = 1
      IW = 1
      DO 125 K1 = 1,NF
          IP = FAC(K1)
          L2 = IP*L1
          IDO = N/L2
          LID = L1*IDO
          NBR = 1 + NA + 2*MIN(IP-2,4)
          GO TO (52,62,53,63,54,64,55,65,56,66) NBR
   52     CALL DCMF2KB(LOT,IDO,L1,NA,C,JUMP,INC,CH,1,LOT,WA(IW))
          GO TO 120
   62     CALL DCMF2KB(LOT,IDO,L1,NA,CH,1,LOT,C,JUMP,INC,WA(IW))
          GO TO 120
   53     CALL DCMF3KB(LOT,IDO,L1,NA,C,JUMP,INC,CH,1,LOT,WA(IW))
          GO TO 120
   63     CALL DCMF3KB(LOT,IDO,L1,NA,CH,1,LOT,C,JUMP,INC,WA(IW))
          GO TO 120
   54     CALL DCMF4KB(LOT,IDO,L1,NA,C,JUMP,INC,CH,1,LOT,WA(IW))
          GO TO 120
   64     CALL DCMF4KB(LOT,IDO,L1,NA,CH,1,LOT,C,JUMP,INC,WA(IW))
          GO TO 120
   55     CALL DCMF5KB(LOT,IDO,L1,NA,C,JUMP,INC,CH,1,LOT,WA(IW))
          GO TO 120
   65     CALL DCMF5KB(LOT,IDO,L1,NA,CH,1,LOT,C,JUMP,INC,WA(IW))
          GO TO 120
   56     CALL DCMFGKB(LOT,IDO,IP,L1,LID,NA,C,C,JUMP,INC,CH,CH,1,LOT,
     +                WA(IW))
          GO TO 120
   66     CALL DCMFGKB(LOT,IDO,IP,L1,LID,NA,CH,CH,1,LOT,C,C,JUMP,INC,
     +                WA(IW))
  120     L1 = L2
          IW = IW + (IP-1)* (IDO+IDO)
          IF (IP.LE.5) NA = 1 - NA
  125 CONTINUE
      RETURN
      END

C
C	$Id: giitm.f,v 1.5 2008-07-27 00:20:57 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GIITM (TYPE,LDR,DATREC)
C
C  INTERPRET ITEM
C
      INTEGER EIITM
      PARAMETER (EIITM=104)
C
      include 'gkscom.h'
C
      INTEGER TYPE,LDR
      CHARACTER*80 DATREC(LDR)
C
C  Check if GKS is in the proper state.
C
      CALL GZCKST(7,EIITM,IER)
      IF (IER .NE. 0) RETURN
C
C  Set function code and put out WKID.
C
      FCODE = 104
      CONT  = 0
      CALL GZROI(0)
      IL1 = 1
      IL2 = 1
      ID(1) = TYPE
      IF (LDR .GE. 1) THEN
        IF (LDR .EQ. 1) THEN
          CONT = 0
          STRL1 = 80
          STRL2 = 80
          STR(1:80) = DATREC(1)
          CALL GZTOWK
          IF (RERR.NE.0) THEN
            ERS = 1
            CALL GERHND(RERR,EIITM,ERF)
            ERS = 0
            RETURN
          ENDIF
        ELSE
C
C  Send over the data record 80 characters at a time.
C
          CONT = 1
          STRL1 = 80*LDR
          STRL2 = 80
          LDRM1 = LDR-1
          DO 200 I=1,LDRM1
            IF (I .GT. 1) IL2 = 0
            STR(1:80) = DATREC(I)
            CALL GZTOWK
            IF (RERR.NE.0) THEN
              ERS = 1
              CALL GERHND(RERR,EIITM,ERF)
              ERS = 0
              RETURN
            ENDIF
  200     CONTINUE
          CONT = 0
          STR(1:80) = DATREC(LDR)
          CALL GZTOWK
          IF (RERR.NE.0) THEN
            ERS = 1
            CALL GERHND(RERR,EIITM,ERF)
            ERS = 0
            RETURN
          ENDIF
        ENDIF
      ELSE
        CONT = 0
        CALL GZTOWK
        IF (RERR.NE.0) THEN
          ERS = 1
          CALL GERHND(RERR,EIITM,ERF)
          ERS = 0
          RETURN
        ENDIF
      ENDIF
      RETURN
      END

C
C $Id: pcfred.f,v 1.7 2008-07-27 00:17:19 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE PCFRED (IBNU,NFNT,IBUF,LBUF)
        CHARACTER*32 CTMP
        DIMENSION IBUF(LBUF)
        IF (NFNT.EQ.0) THEN
          CALL NGRDIN (IBNU,IBUF,LBUF,ISTA)
          IF (ISTA.NE.LBUF) THEN
            CALL SETER ('PCFRED - ERROR READING PWRITX DATABASE',2,1)
          END IF
        ELSE
          CALL PCBNRD (IBNU,LBUF,IBUF,IOST,ISTA)
          IF (ISTA.NE.0) THEN
            WRITE (CTMP,'(''PCFRED - ERROR READING FONT'',I5)') NFNT
            CALL SETER (CTMP,1,1)
            RETURN
          END IF
        END IF
        RETURN
      END

C
C $Id: isst3d.f,v 1.5 2008-07-27 00:17:16 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE ISST3D (EYE,ULO,UHI,VLO,VHI,WLO,WHI)
C
      DIMENSION       EYE(3)
C
C This routine determines how the picture will be scaled onto the
C plotter frame.
C
      COMMON /ISCOMN/ BIG,BIGD,DBPI,IDONE,IFILL,IFLIP,IONES,IHSS(1000),
     +                IREF,ISCA(16,256),ISCALE,ISCR(16,256),ISLBT,ISDR,
     +                LHSS,LX,NFPW,NINU,NINV,NINW,NX,NY,R0,RNX,RNY,
     +                SMALL,SVAL,TENSN,U,V,W,XMAX,XMIN,YMAX,YMIN,XVPL,
     +                XVPR,YVPB,YVPT
      SAVE   /ISCOMN/
C
      COMMON /PWRZ1I/ UUMIN,UUMAX,VVMIN,VVMAX,WWMIN,WWMAX,DELCRT,EYEU,
     +                EYEV,EYEW
      SAVE   /PWRZ1I/
C
      COMMON /TEMPRX/ RZERO
      SAVE   /TEMPRX/
C
C Arithmetic statement function for taking the average of two reals.
C
      AVE(A,B) = (A+B)*.5
C
C Arithmetic statement functions for scaling.
C
      SU(UTEMP) = UTEMP
      SV(VTEMP) = VTEMP
      SW(WTEMP) = WTEMP
C
C Constants for PWRZI.
C
      UUMIN = ULO
      UUMAX = UHI
      VVMIN = VLO
      VVMAX = VHI
      WWMIN = WLO
      WWMAX = WHI
      EYEU = EYE(1)
      EYEV = EYE(2)
      EYEW = EYE(3)
C
C Find corners in 2-space for 3-space box containing object.
C
      ISCALE = 0
      ATU = AVE(SU(UUMIN),SU(UUMAX))
      ATV = AVE(SV(VVMIN),SV(VVMAX))
      ATW = AVE(SW(WWMIN),SW(WWMAX))
      BIGD = 0.
      IF (RZERO .LE. 0.) GO TO  10
C
C Relative size feature is in use.  Generate eye position that makes box
C have maximum projected size.
C
      ALPHA = -(VVMIN-ATV)/(UUMIN-ATU)
      VVEYE = -RZERO/SQRT(1.+ALPHA*ALPHA)
      UUEYE = VVEYE*ALPHA
      VVEYE = VVEYE+ATV
      UUEYE = UUEYE+ATU
      WWEYE = ATW
      CALL ISTR32 (ATU,ATV,ATW,UUEYE,VVEYE,WWEYE,1)
      CALL ISTR32 (UUMIN,VVMIN,ATW,XMIN,DUMM,DUMM,2)
      CALL ISTR32 (UUMAX,VVMIN,WWMIN,DUMM,YMIN,DUMM,2)
      CALL ISTR32 (UUMAX,VVMAX,ATW,XMAX,DUMM,DUMM,2)
      CALL ISTR32 (UUMAX,VVMIN,WWMAX,DUMM,YMAX,DUMM,2)
      BIGD = SQRT((UUMAX-UUMIN)**2+(VVMAX-VVMIN)**2+(WWMAX-WWMIN)**2)*.5
      R0 = RZERO
      GO TO  20
   10 CALL ISTR32 (ATU,ATV,ATW,EYE(1),EYE(2),EYE(3),1)
      CALL ISTR32 (SU(UUMIN),SV(VVMIN),SW(WWMIN),X1,Y1,DUM,2)
      CALL ISTR32 (SU(UUMIN),SV(VVMIN),SW(WWMAX),X2,Y2,DUM,2)
      CALL ISTR32 (SU(UUMIN),SV(VVMAX),SW(WWMIN),X3,Y3,DUM,2)
      CALL ISTR32 (SU(UUMIN),SV(VVMAX),SW(WWMAX),X4,Y4,DUM,2)
      CALL ISTR32 (SU(UUMAX),SV(VVMIN),SW(WWMIN),X5,Y5,DUM,2)
      CALL ISTR32 (SU(UUMAX),SV(VVMIN),SW(WWMAX),X6,Y6,DUM,2)
      CALL ISTR32 (SU(UUMAX),SV(VVMAX),SW(WWMIN),X7,Y7,DUM,2)
      CALL ISTR32 (SU(UUMAX),SV(VVMAX),SW(WWMAX),X8,Y8,DUM,2)
      XMIN = MIN(X1,X2,X3,X4,X5,X6,X7,X8)
      XMAX = MAX(X1,X2,X3,X4,X5,X6,X7,X8)
      YMIN = MIN(Y1,Y2,Y3,Y4,Y5,Y6,Y7,Y8)
      YMAX = MAX(Y1,Y2,Y3,Y4,Y5,Y6,Y7,Y8)
C
C Add the right amount to keep the picture square.
C
   20 WIDTH = XMAX-XMIN
      HIGHT = YMAX-YMIN
      DIF = .5*(WIDTH-HIGHT)
      IF (DIF)  30, 50, 40
   30 XMIN = XMIN+DIF
      XMAX = XMAX-DIF
      GO TO  50
   40 YMIN = YMIN-DIF
      YMAX = YMAX+DIF
   50 ISCALE = 1
      CALL ISTR32 (ATU,ATV,ATW,EYE(1),EYE(2),EYE(3),1)
      RETURN
      END

C
C	$Id: gqtxf.f,v 1.5 2008-07-27 00:21:00 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GQTXF(WTYPE,N,ERRIND,NFPP,FONT,PREC,NCHH,MINCHH,
     +                 MAXCHH,NCHX,MINCHX,MAXCHX,NPTXI)
C
C  INQUIRE TEXT FACILITIES
C
      include 'gkscom.h'
C
      INTEGER WTYPE,N,ERRIND,NFPP,FONT,PREC,NCHH,NCHX,NPTXI
      REAL    MINCHH,MAXCHH,MINCHX,MAXCHX
C
C  Check if GKS is in the proper state.
C
      CALL GZCKST(8,-1,ERRIND)
      IF (ERRIND .NE. 0) GOTO 100
C
C  Check that the workstation type is valid.
C
      CALL GZCKWK(22,-1,IDUM,WTYPE,ERRIND)
      IF (ERRIND .NE. 0) GO TO 100
C
C  Check if the workstation category is OUTPUT or OUTIN.
C
      CALL GQWKCA(WTYPE,ERRIND,ICAT)
      IF (ICAT.NE.GOUTPT .AND. ICAT.NE.GOUTIN) THEN
        ERRIND = 39
        GO TO 100
      ENDIF
C
C  Invoke interface.
C
      FCODE = -124
      CONT  = 0
      CALL GZROI(0)
      IL1   = 2
      IL2   = 2
      ID(1) = WTYPE
      ID(2) = N
      IWK   = -1
      CALL GZIQWK(WTYPE,IWK)
      IF (RERR .NE. 0) THEN
        ERRIND = RERR
        GOTO 100
      ENDIF
      NFPP   = ID(3)
      FONT   = ID(4)
      PREC   = ID(5)
      NCHH   = ID(6)
      NCHX   = ID(7)
      NPTXI  = ID(8)
      MINCHH = RX(1)
      MAXCHH = RX(2)
      MINCHX = RX(3)
      MAXCHX = RX(4)
      RETURN
C
  100 CONTINUE
      NFPP   = -1
      FONT   = -1
      PREC   = -1
      NCHH   = -1
      NCHX   = -1
      NPTXI  = -1
      MINCHH = 1.E20
      MAXCHH = -1.E20
      MINCHX = 1.E20
      MAXCHX = -1.E20
      RETURN
      END

      SUBROUTINE DLOCALMN(X,NI,NJ,XMSG,LWRAP,XI,YJ,NINJ,LOCMIN,
     +     DELTA,NMIN,IER)
      DOUBLE PRECISION XVAL

C input
      INTEGER LWRAP,NI,NJ,NINJ
C input
      INTEGER XI(NINJ),YJ(NINJ)
C input
      DOUBLE PRECISION X(NI,NJ),XMSG,DELTA
C output
      INTEGER NMIN,IER
C output
      DOUBLE PRECISION LOCMIN(NINJ)
c***********************************************************************
c
c this routine looks at 9 points
c
c  where the grid is:
c
c      1-------------8---------------7
c      |             |               |
c      |             |               |
c      |             |               |
c      |             |               |
c      2-------------0---------------6
c      |             |               |
c      |             |               |
c      |             |               |
c      |             |               |
c      3-------------4---------------5
c
c   arguments :
c .
c .   x        - 2-d input/output array
c .   ni       - dimension size ["x-axis": eg longitude]
c .   nj       - dimension size ["y-axis": eg latitude ]
c .   xmsg     - value of missing points
c .   lwrap    - flag to include wraparound points
c .              if lwrap = 1 , if data are cyclic in x
c .              if lwrap = 0 , data are not cyclic
c .   xi       - x-axis coordinates [eg, longitudes]
c .              The fortran subscripts have been adjusted for NCL
c .   yj       - y-axis coordinates [eg, latitudes ]
c .              The fortran subscripts have been adjusted for NCL
c .   ninj     - max number of points  (ni*nj is overkill but safe)
c .   locmin   - 1D array dimensioned (ninj)
c .   delta    - surrounding points must be different from the
c .              central value to be considered a local minimum
c .              Normally: delta = 0.0
c .   nmin     - actual number of local minima detected
c .
c  notes:
c
c       1)  if a point or any of its neighbors is missing, check is
c           not implemented
c       2)  this routine does not check the edges, just the interior
c           except when "lwrap" is true.
c       3)  array has to have at least 3 points in each direction
c
c  usage:
c     program main
c     implicit none
c     integer lwrap, ni, nj, ninj
c     parameter (ni=128, nj=64, ninj=ni*nj)
c     real z(ni,nj), zmsg, locmin(ninj)
c     integer xi(ni), yj(nj)
c     integer ier, n, m, nmin
c
c     read () z
c     ier   = 0
c     zmsg  = -999.
c     lwrap = 1
c     delta = 0.0
c     call localmin (z,ni,nj,zmsg,lwrap,xi,yj
c    *               ,ninj,locmin,delta,nmin,ier)
c
c     if (nmin.gt.0) then
c         do n=1, nmin
c            write (*,"(2i4,f10.2)") xi(n),jy(n),locmin(n)
c         end do
c     else
c         write (*,"('sub localmin: no local min found)")
c     end if
c     end
c***********************************************************************

c determine if size of array is sufficient

      IER = 0
      IF (NI.LT.3 .OR. NJ.LT.3) THEN
          IER = 1
          WRITE (*,FMT='(/,'' sub localmn: error'',2i5)') NI,NJ
          RETURN
      END IF

c initialize to missing and zero

      NMIN = 0
      DO N = 1,NINJ
          LOCMIN(N) = XMSG
          XI(N) = -999
          YJ(N) = -999
      END DO

c are endpoints to be included?

      IF (LWRAP.EQ.1) THEN
          NIB = 1
          NIE = NI
      ELSE
          NIB = 2
          NIE = NI - 1
      END IF
      NJB = 2
      NJE = NJ - 1

c  main loop

      DO J = NJB,NJE
          DO I = NIB,NIE
              JM1 = J - 1
              JP1 = J + 1
              IM1 = I - 1
              IP1 = I + 1
              IF (IM1.LT.1) IM1 = NI
              IF (IP1.GT.NI) IP1 = 1

              IF (X(I,J).NE.XMSG .AND. X(IM1,JP1).NE.XMSG .AND.
     +            X(IM1,J).NE.XMSG .AND. X(IM1,JM1).NE.XMSG .AND.
     +            X(I,JM1).NE.XMSG .AND. X(IP1,JM1).NE.XMSG .AND.
     +            X(IP1,J).NE.XMSG .AND. X(IP1,JP1).NE.XMSG .AND.
     +            X(I,JP1).NE.XMSG) THEN

                  XVAL = X(I,J) + DELTA

                  IF (X(IM1,JP1).GT.XVAL .AND. X(IM1,J).GT.XVAL .AND.
     +                X(IM1,JM1).GT.XVAL .AND. X(I,JM1).GT.XVAL .AND.
     +                X(IP1,JM1).GT.XVAL .AND. X(IP1,J).GT.XVAL .AND.
     +                X(IP1,JP1).GT.XVAL .AND. X(I,JP1).GT.X(I,J)) THEN
                      NMIN = NMIN + 1
c                                  subtract 1 for NCL subscripts
                      XI(NMIN) = I - 1
                      YJ(NMIN) = J - 1
                      LOCMIN(NMIN) = X(I,J)
                  END IF
              END IF
          END DO
      END DO

      RETURN
      END
c ----------------------------------------------------------
      SUBROUTINE DLOCALMX(X,NI,NJ,XMSG,LWRAP,XI,YJ,NINJ,LOCMAX,
     +     DELTA,NMAX,IER)
      DOUBLE PRECISION XVAL

C input
      INTEGER LWRAP,NI,NJ,NINJ
C input
      INTEGER XI(NINJ),YJ(NINJ)
C input
      DOUBLE PRECISION X(NI,NJ),XMSG,DELTA
C output
      INTEGER NMAX,IER
C output
      DOUBLE PRECISION LOCMAX(NINJ)
c***********************************************************************
c  see documentation for localmn
c***********************************************************************

c determine if size of array is sufficient

      IER = 0
      IF (NI.LT.3 .OR. NJ.LT.3) THEN
          IER = 1
          WRITE (*,FMT='(/,'' sub localmx: error'',2i5)') NI,NJ
          RETURN
      END IF

c initialize to missing and zero

      NMAX = 0
      DO N = 1,NINJ
          LOCMAX(N) = XMSG
          XI(N) = -999
          YJ(N) = -999
      END DO


c are endpoints to be included?

      IF (LWRAP.EQ.1) THEN
          NIB = 1
          NIE = NI
      ELSE
          NIB = 2
          NIE = NI - 1
      END IF
      NJB = 2
      NJE = NJ - 1

c  main loop

      DO J = NJB,NJE
          DO I = NIB,NIE
              JM1 = J - 1
              JP1 = J + 1
              IM1 = I - 1
              IP1 = I + 1
              IF (IM1.LT.1) IM1 = NI
              IF (IP1.GT.NI) IP1 = 1

              IF (X(I,J).NE.XMSG .AND. X(IM1,JP1).NE.XMSG .AND.
     +            X(IM1,J).NE.XMSG .AND. X(IM1,JM1).NE.XMSG .AND.
     +            X(I,JM1).NE.XMSG .AND. X(IP1,JM1).NE.XMSG .AND.
     +            X(IP1,J).NE.XMSG .AND. X(IP1,JP1).NE.XMSG .AND.
     +            X(I,JP1).NE.XMSG) THEN

                  XVAL = X(I,J) - DELTA

                  IF (X(IM1,JP1).LT.XVAL .AND. X(IM1,J).LT.XVAL .AND.
     +                X(IM1,JM1).LT.XVAL .AND. X(I,JM1).LT.XVAL .AND.
     +                X(IP1,JM1).LT.XVAL .AND. X(IP1,J).LT.XVAL .AND.
     +                X(IP1,JP1).LT.XVAL .AND. X(I,JP1).LT.X(I,J)) THEN
                      NMAX = NMAX + 1
c                                  subtract 1 for NCL subscripts
                      XI(NMAX) = I - 1
                      YJ(NMAX) = J - 1
                      LOCMAX(NMAX) = X(I,J)
                  END IF
              END IF
          END DO
      END DO

      RETURN
      END

C
C	$Id: csserr.f,v 1.5 2008-07-27 03:10:07 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CSSERR (ISUB,IERR)                               
C
C SUBROUTINE CSSERR (ISUB,IERR)
C                                                                       
C PURPOSE        To print an error number and an error message.
C                                                                       
C USAGE          CALL CSSERR (ISUB,IERR)
C                                                                       
C ARGUMENTS                                                             
C ON INPUT       ISUB
C                  The subroutine producing the error.
C                IERR                                           
C                  The error number.
C                                                                       
C ARGUMENTS                                                             
C ON OUTPUT      None                                           
C                                                                       
C I/O            The message is writen to unit 6.             
C
C ******************************************************************    
C                                                                       
      CHARACTER *(*) ISUB
C
      IF (IERR .EQ. 1) THEN
        WRITE(6,100) ISUB
  100   FORMAT(A7,' - error 1, invalid number of input points (must be g
     +reater than 3).')
      ELSE IF (IERR .EQ. 2) THEN
        WRITE(6,110) ISUB
  110   FORMAT(A7,' - error 2, invalid dimension for latitudes in the ou
     +tput grid.')
      ELSE IF (IERR .EQ. 3) THEN
        WRITE(6,120) ISUB
  120   FORMAT(A7,' - error 3, invalid dimension for longitudes in the o
     +utput grid.')
      ELSE IF (IERR .EQ. 4) THEN
        WRITE(6,130) ISUB
  130   FORMAT(A7,' - error 4, first three nodes are collinear.')
      ELSE IF (IERR .EQ. 5) THEN
        WRITE(6,140) ISUB
  140   FORMAT(A7,' - error 5, extrapolation failed due to the uniform g
     +rid extending too far beyond the triangulation boundary.')
      ELSE IF (IERR .EQ. 6) THEN
        WRITE(6,150) ISUB
  150   FORMAT(A7,' - error 6, internal algorithm error - please report 
     +this.')
      ELSE IF (IERR .EQ. 7) THEN
        WRITE(6,160) ISUB
  160   FORMAT(A7,' - error 7, vertex of a triangle containing an interp
     +olation point is outside its valid range.')
      ELSE IF (IERR .EQ. 8) THEN
        WRITE(6,170) ISUB
  170   FORMAT(A7,' - error 8, the angular distance between an interpola
     +ted point and the nearest point of the triangulation is at least 9
     +0 degrees.')
      ELSE IF (IERR .EQ. 9) THEN
        WRITE(6,180) ISUB
  180   FORMAT(A7,' - error 9, not enough input points to calculate a gr
     +adient.')
      ELSE IF (IERR .EQ. 10) THEN
        WRITE(6,190) ISUB
  190   FORMAT(A7,' - error 10, insufficient space for the triangulation
     + (must be >= number of boundary nodes minus 2).')
      ELSE IF (IERR .EQ. 11) THEN
        WRITE(6,200) ISUB
  200   FORMAT(A7,' - error 11, degenerate triangle (two vertices lie on
     + same geodesic).')
      ELSE IF (IERR .EQ. 12) THEN
        WRITE(6,210) ISUB
  210   FORMAT(A7,' - error 12, duplicate input points.')
      ELSE IF (IERR .EQ. 13) THEN
        WRITE(6,220) ISUB
  220   FORMAT(A7,' - error 13, parameter TOL or NSG out of range.')
      ELSE IF (IERR .LT. 0) THEN
        NERR = -IERR
        WRITE(6,300) ISUB,IERR,NERR,NERR
  300   FORMAT(A7,' - error ',I5,', coordinates ',I5,' and M coincide fo
     +r some M  > ',I5,' >= 1 (coordinate numbering starting at 1).')
      ENDIF
C                                                                       
      RETURN                                                            
      END                                                               

C
C $Id: wtprin.f,v 1.4 2008-09-18 00:42:18 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE WTPRIN (UVAL,VVAL,DLAT,DLON,CSLT)
C
        DOUBLE PRECISION UVAL,VVAL,DLAT,DLON,CSLT
C
C The subroutine WTPRIN implements the inverse of the Winkel tripel
C projection, using an iterative algorithm due to Cengizhan Ipbuker,
C of the Istanbul Technical University, in Istanbul, Turkey, and Oztug
C Bildirici, of Selcuk University, in Konya, Turkey.  Their paper is
C called "A General Algorithm for the Inverse Transformation of Map
C Projections Using Jacobian Matrices", and it was published in the
C proceedings of the Third International Symposium on Mathematical and
C Computational Applications, September 4-6, 2002 (pp. 175-182).
C
C UVAL and VVAL are input values of U and V, in the projection plane.
C DLAT and DLON are output values of latitude and longitude, in radians.
C CSLT is the cosine of the standard parallel of the Winkel tripel, for
C which Winkel used ACOS(2/PI); in EZMAP, though, it is allowed to vary.
C
C The common block MAPCM0 contains mathematical constants.
C
        COMMON /MAPCM0/  COS1,DTOR,DTRH,OOPI,PI,PIOF,PIOT,RTDD,RTOD,
     +                   SROT,SIN1,TOPI,TSRT
        DOUBLE PRECISION COS1,DTOR,DTRH,OOPI,PI,PIOF,PIOT,RTDD,RTOD,
     +                   SROT,SIN1,TOPI,TSRT
        SAVE   /MAPCM0/
C
C Local variables.
C
        DOUBLE PRECISION CVAL,DLAP,DLOP,DNOM,DVAL,PULA,PULO,PVLA, PVLO,
     +                   TVAL,UDIF,VDIF
C
C First, we must check the point (UVAL,VVAL) to see if it lies in the
C region occupied by the projection of the globe.  IOOR will be set to
C 0 if so, and to 1 otherwise.  ("OOR" stands for "Out Of Range".)
C
        IOOR=0
C
C The first condition in the following block-if expresses the condition
C that the point (UVAL,VVAL) is outside the bounding rectangle of the
C area occupied by the projection of the globe.  If not, and if it is
C not in the central rectangle, we do a more complicated test to see if
C it is inside or outside one of the curved end pieces of the area.
C
        IF (ABS(UVAL)-PIOT*(CSLT+1.D0).GT.1.D-9.OR.
     +      ABS(VVAL)-PIOT.GT.1.D-9) THEN
          IOOR=1
        ELSE IF (ABS(UVAL).GT.PIOT*CSLT) THEN
          DLAT=ACOS(ABS(UVAL)/PIOT-CSLT)
          IF (ABS(VVAL)-(.5D0*DLAT+PIOF*SIN(DLAT)).GT.1.D-9) IOOR=1
        END IF
C
C If the input point is out of range, return the value "1.D12" to
C signal the fact.
C
        IF (IOOR.NE.0) THEN
          DLAT=1.D12
          DLON=1.D12
          RETURN
        END IF
C
C Ipbuker and Bildirici's algorithm makes use of partial derivatives
C of the forward projection functions, which are usually expressed
C using the SINC function, which is carefully defined so as not to
C cause problems when its argument is zero.  To facilitate the taking
C of partial derivatives, the SINC function was replaced by a more
C conventional expression, and it may be that which causes problems
C for the algorithm along the equator.  In any case, the following
C code takes care of the problem:
C
        IF (ABS(VVAL).LT.1.D-12) THEN
          DLAT=VVAL
          DLON=2.D0*UVAL/(CSLT+1.D0)
          RETURN
        END IF
C
C Set up the iteration loop.  DLAP and DLOP hold values of latitude and
C longitude from the previous iteration; they are given initial values
C that represent a guess at the proper values.
C
        DLAP=.999D0*VVAL
        DLOP=DLAP*(CSLT+COS(DLAP))
C
C NITR keeps track of the number of iterations performed, which is
C limited to 20.  (Actually, my tests indicate that a maximum of 7
C iterations suffice to give full double-precision accuracy.)
C
        NITR=1
C
C Iteration loop.  First, compute terms that occur frequently.
C
  101   TVAL=COS(DLAP)*COS(.5D0*DLOP)
C
        CVAL=1.D0-TVAL**2
        DVAL=ACOS(TVAL)
C
C To follow this code, refer to Ipbuker and Bildirici's paper.  UDIF
C and VDIF are functions of latitude and longitude expressing the
C difference between the projected values at a lat/lon position and
C the desired values.  Each of PULA, PULO, PVLA, and PVLO is a partial
C derivative of either U or V with respect to either latitude or
C longitude.
C
        TVAL=DVAL/SQRT(CVAL)
C
        UDIF=.5D0*(2.D0*TVAL*COS(DLAP)*SIN(.5D0*DLOP)+DLOP*CSLT)-UVAL
        VDIF=.5D0*(TVAL*SIN(DLAP)+DLAP)-VVAL
C
        TVAL=TVAL/CVAL
C
        PULA=SIN(DLOP)*SIN(2.D0*DLAP)/(4.D0*CVAL)-
     +       TVAL*SIN(DLAP)*SIN(.5D0*DLOP)
        PULO=.5D0*(COS(DLAP)**2*SIN(.5D0*DLOP)**2/CVAL+
     +           TVAL*COS(DLAP)*COS(.5D0*DLOP)*SIN(DLAP)**2+CSLT)
        PVLA=.5D0*(SIN(DLAP)**2*COS(.5D0*DLOP)/CVAL+
     +           TVAL*SIN(.5D0*DLOP)**2*COS(DLAP)+1.D0)
        PVLO=.125D0*(SIN(2.D0*DLAP)*SIN(.5D0*DLOP)/CVAL-
     +             TVAL*SIN(DLAP)*COS(DLAP)**2*SIN(DLOP))
C
        DNOM=PULA*PVLO-PVLA*PULO
C
C DLAT and DLON are improved values of latitude and longitude.
C
        DLAT=DLAP-(UDIF*PVLO-VDIF*PULO)/DNOM
        DLON=DLOP-(VDIF*PULA-UDIF*PVLA)/DNOM
C
C If the improved values are not sufficiently different from the
C previous values and fewer than 20 iterations have been performed,
C go back for another one.  Otherwise, just return DLAT and DLON.
C
        IF (ABS(DLAT-DLAP).GT.1.D-12.OR.ABS(DLON-DLOP).GT.1.D-12) THEN
          IF (NITR.LT.20) THEN
            DLAP=DLAT
            DLOP=DLON
            NITR=NITR+1
            GO TO 101
          END IF
        END IF
C
C Done.
C
        RETURN
C
      END

C
C	$Id: gqegdp.f,v 1.5 2008-07-27 00:20:59 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GQEGDP(WTYPE,N,ERRIND,NGDP,GDPL)
C
C  INQUIRE LIST element OF AVAILABLE GENERALIZED DRAWING PRIMITIVES.
C
      include 'gkscom.h'
C
      INTEGER WTYPE,N,ERRIND,NGDP,GDPL
C
C  Check if GKS is in the proper state.
C
      CALL GZCKST(8,-1,ERRIND)
      IF (ERRIND .NE. 0) GOTO 100
C
C  Check that the workstation type is valid.
C
      CALL GZCKWK(22,-1,IDUM,WTYPE,ERRIND)
      IF (ERRIND .NE. 0) GO TO 100
C
C  Check if the workstation category is OUTPUT or OUTIN.
C
      CALL GQWKCA(WTYPE,ERRIND,ICAT)
      IF (ICAT.NE.GOUTPT .AND. ICAT.NE.GOUTIN) THEN
        ERRIND = 39
        GO TO 100
      ENDIF
C
C  Check that requested element number is non-negative.
C
      IF (N .LT. 0) THEN
        ERRIND = 2002
        GO TO 100
      ENDIF
C
C  Currently no supported workstation type has any GDPs.
C
      NGDP = 0
      GDPL = 0
      RETURN
C
  100 CONTINUE
      NGDP = -1
      GDPL = -1
      RETURN
      END

C
C	$Id: gputps.f,v 1.7 2008-07-27 00:21:06 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GPUTPS (BUFFER, COUNT1, COUNT2, CONTIN, GKSERR)
C
C  Put a character string into the metafile buffer.  This subroutine
C  can be called successively to put out long strings--on the
C  first call the total count is put out and on subsequent calls
C  just the characters are put out.
C
C  INPUT
C    BUFFER -- The character string to move (must be type CHARACTER).
C    COUNT1 -- Total number of characters to be processed for the
C              entire sequence.
C    COUNT2 -- Number of characters to be processed this call.
C    CONTIN -- If 0, COUNT1 is put out prior to the string itself;
C              if 1, only the character string is put out.
C  OUTPUT
C    GKSERR -- Error status.
C
C  All data is type integer unless otherwise indicated.
C
      IMPLICIT INTEGER (A-Z)
      DIMENSION CHARS(256)
      CHARACTER*(*) BUFFER
C
      INTEGER  BITSPC
      INTEGER  GKASCI
C
      include 'g01prm.h'
      include 'g01ins.h'
      SAVE
C
C  Maximum number of characters allowed in the temporary buffer.
C
      DATA  MXCH/256/
C
C  CGM uses 8-bit ASCII.
C
      DATA  BITSPC/8/,  LSFLG/255/
C
C  First call processing, set up count (or flag/count).
C
      IF (CONTIN .EQ. 0)  THEN
C
C  The number of bytes for the  COUNT+STRING  depends on
C  whether the string is encoded in the long or short form.
C
        IF (COUNT1 .LE. 254)  THEN
          NBCCNT = 8
        ELSE
          NBCCNT = 16
          CALL GMFLOD (LSFLG, 8, 1, GKSERR)
          IF (GKSERR .NE. 0)  RETURN
        END IF
        CALL GMFLOD (COUNT1, NBCCNT, 1, GKSERR)
        IF (GKSERR .NE. 0)  RETURN
      END IF
C
      CTEMP = COUNT2
      IF (CTEMP .EQ. 0) RETURN
      STRT = 1
C
   10 CONTINUE
C
C  Determine the number of characters that will fit
C  in the current partition.
C
      WCBYT = 1 + (MCCBYT*8-1)/BITSPC
C
C  Compute and move the allowed number of characters.
C
      MOVIT = MIN(WCBYT,CTEMP,MXCH)
C
C  Move the character codes to the integer buffer.
C
      DO 20 II = 1,MOVIT
        NP = STRT + II - 1
C
C  Get the ASCII equivalent of the character code.
C
        CHARS(II) = GKASCI (ICHAR(BUFFER(NP:NP)))
   20 CONTINUE
C
      CALL GMFLOD (CHARS, BITSPC, MOVIT, GKSERR)
      IF (GKSERR .NE. 0) RETURN
C
C  Check if another partition has to be started.
C
      CTEMP = CTEMP - MOVIT
      MCCBYT = MCCBYT - (MOVIT*BITSPC)/8
      IF (CTEMP .NE. 0) THEN
C
C  Check if more room in partition.
C
        IF (MCCBYT .NE. 0) THEN
C
C  More room in the current partition.
C
          STRT = STRT + MOVIT
        ELSE
C
C  New partition required, so set up the instruction.
C
          STRT = STRT + MOVIT
C  Take the remainder of the bytes left in the current partition
C  (they must be used).
          TCBYT = MCNBYT + MCCBYT
          CALL GMPART (TCBYT, GKSERR)
          IF (GKSERR .NE. 0) RETURN
        END IF
C
C  Move more operands into new partition.
C
        GO TO 10
      END IF
C
      RETURN
      END

C NCLFORTSTART
      SUBROUTINE DMIXHUM1(P,TK,RH,ISWIT,QW)
      IMPLICIT NONE
C NCL: qw = mixhum_ptrh(p:numeric,tk:numeric,rh:numeric,iswit:integer)

c input
      INTEGER ISWIT
      DOUBLE PRECISION P,TK,RH
c output
      DOUBLE PRECISION QW
c NCLEND

c computes qw (specific humidity or mixing ratio) from p, t and rh

c definition of mixing ratio
c if,
c    es  - is the saturation mixing ratio
c    ep  - is the ratio of the molecular weights of water vapor to 
c          dry air
c    p   - is the atmospheric pressure
c    rh  - is the relative humidity (given as a percent)

c    q =   rh * ( (ep*es)/(p-es) )

c input-
c    p      - pressure (hPa or mb)
c    tk     - temperature (k)
c    rh     - rel hum in percent
c    iswit  - if iswit=1 qw will contain mix ratio
c                iswit=2 qw will contain spc humidity
c                if iswit is negative the units will be kg/kg else g/kg

c output-
c    qw     - mixing ratio or specific hum

c local
      DOUBLE PRECISION T0,EP,ONEMEP,ES0,A,B,EST,QST
      DATA T0,EP,ONEMEP,ES0,A,B/273.15D0,0.622D0,0.378D0,6.11D0,
     +     17.269D0,35.86D0/

      EST = ES0*EXP((A* (TK-T0))/ (TK-B))
      QST = (EP*EST)/ (P-ONEMEP*EST)
c                                    mix ratio
      QW = QST* (RH*.01D0)
c                                    ?specific hum?
      IF (ABS(ISWIT).EQ.2) THEN
          QW = QW/ (1.D0+QW)
      END IF

      IF (ISWIT.LT.0) THEN
          QW = QW*1000.D0
      END IF

      RETURN
      END

C
C	$Id: gmpart.f,v 1.5 2008-07-27 00:21:06 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GMPART(NBYTES,GKSERR)
C
C  This subroutine loads the next partition of an active element.
C
C  OUTPUT
C    GKSERR -- An error status flag.
C
C  All data is type integer unless otherwise indicated.
C
      IMPLICIT INTEGER (A-Z)
C
      include 'g01prm.h'
      include 'g01ins.h'
      include 'g01io.h'
C
C  Define the CGM data element partition size.  To make the arithmetic
C  come out right in other parts of the code, this should be a multiple
C  of 256.
C
      DATA PARSIZ/32256/
      DATA ALLOK/0/
C
C  Define the short format length, short format count, long format flag,
C  continue flag on, continue flag off, continue length, long format
C  length.
C
      DATA CONON,CONOFF,CFMLNG,LFMLNG /1,0,1,15/
C
      GKSERR = ALLOK
C
C  Set the current partition byte count and the remainder byte count.
C
      IF (NBYTES .GT. PARSIZ) THEN
        MCCBYT = PARSIZ
        MCNBYT = NBYTES - PARSIZ
      ELSE
        MCCBYT = NBYTES
        MCNBYT = 0
      END IF
C
C  Set the continue flag.
C
      IF (MCNBYT .NE. 0) THEN
C
C  There is another partition.
C
        CALL GMFLOD(CONON,CFMLNG,1,GKSERR)
      ELSE
C
C  Last partition.
C
        CALL GMFLOD(CONOFF,CFMLNG,1,GKSERR)
      END IF
C
      IF (GKSERR .NE. ALLOK) RETURN
C
C  Set the long format operand list size.
C
      CALL GMFLOD(MCCBYT,LFMLNG,1,GKSERR)
C
      RETURN
      END

      PROGRAM WMEX11
C
C  Example of station model data.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER (X1=0.22, X2=0.67)
      CHARACTER*5 IMDAT(10)
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
      CALL GSCR(IWKID,0,1.,1.,1.)
      CALL GSCR(IWKID,1,0.,0.,0.)
      CALL GSCR(IWKID,2,.4,0.,.4)
C
C  Symbolic station model
C
      CALL WMSETR('WBS',0.20)
      CALL GSLWSC(3.)
      CALL EXSTNM(X2,.73)
      CALL LINE(0.1,.5,0.9,.5)
      CALL PLOTIT(0,0,0)
      SIZ = 0.03
      CALL PCSETI('FN',26)
      CALL PCSETI('CC',2)
      CALL PLCHHQ(X1,.85,'SYMBOLIC',SIZ,0.,0.)
      CALL PLCHHQ(X1,.75,'STATION',SIZ,0.,0.)
      CALL PLCHHQ(X1,.65,'MODEL',SIZ,0.,0.)
      CALL PCSETI('CC',1)
C
C  Sample plotted report
C
      IMDAT(1) = '11212'
      IMDAT(2) = '83320'
      IMDAT(3) = '10011'
      IMDAT(4) = '20000'
      IMDAT(5) = '30000'
      IMDAT(6) = '40147'
      IMDAT(7) = '52028'
      IMDAT(8) = '60111'
      IMDAT(9) = '77060'
      IMDAT(10) = '86792'
      CALL WMSTNM(X2,.23,IMDAT)
      CALL PCSETI('FN',26)
      CALL PCSETI('CC',2)
      CALL PLCHHQ(X1,.35,'SAMPLE',SIZ,0.,0.)
      CALL PLCHHQ(X1,.25,'PLOTTED',SIZ,0.,0.)
      CALL PLCHHQ(X1,.15,'DATA',SIZ,0.,0.)
      CALL PCSETI('CC',1)
C
      CALL FRAME
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END
      SUBROUTINE EXSTNM(X,Y)
C
C  Convert X and Y to NDC and work in NDC space.
C
      CALL WMW2NX(1,X,XNDC)
      CALL WMW2NY(1,Y,YNDC)
C
C  Draw a wind barb at 320 degrees and cloud cover symbol.
C
      CALL WMSETI('WBF',1)
      CALL WMBARB(XNDC,YNDC,-5.,8.66)
      CALL WMGETR('WBC',WBC)
      CALL WMGETR('WBS',WBSHFT)
      CALL NGWSYM('N',0,XNDC,YNDC,WBC*WBSHFT,1,0)
C
      SIZ = 0.15*WBSHFT
      CALL PCSETI('FN',21)
      CALL PLCHHQ(XNDC,YNDC,'N',SIZ,0.,0.)
C
C  Direction
C
      CALL WMSETI('RBS',0)
      CALL WMSETR('RMG',.030*WBSHFT)
      CALL WMSETR('THT',0.8*SIZ)
      CALL WMLABT(XNDC-0.7*WBSHFT*0.5,YNDC+0.7*WBSHFT*0.866,'dd',0)
C
C  Wind speed
C
      CALL WMLABT(XNDC-0.92*WBSHFT*0.5,YNDC+0.7*WBSHFT*1.5,'ff',0)
C
C  High clouds (CH).
C
      CALL PLCHHQ(XNDC,YNDC+0.83*WBSHFT,'C:B1:H',SIZ,0.,0.)
C
C  Medium clouds (CM).
C
      CALL PLCHHQ(XNDC,YNDC+0.47*WBSHFT,'C:B1:M',SIZ,0.,0.)
C
C  Current temperature (TT).
C
      CALL PLCHHQ(XNDC-0.7*WBSHFT,YNDC+0.36*WBSHFT,'TT',SIZ,0.,0.)
C
C  Barometric pressure (ppp).
C
      CALL PLCHHQ(XNDC+0.55*WBSHFT,YNDC+0.36*WBSHFT,'ppp',SIZ,0.,0.)
C
C  Visibility (VV).
C
      CALL PLCHHQ(XNDC-.95*WBSHFT,YNDC,'VV',SIZ,0.,0.)
C
C  Present weather (ww).
C
      CALL PLCHHQ(XNDC-0.45*WBSHFT,YNDC,'ww',SIZ,0.,0.)
C
C  Pressure change (pp).
C
      CALL PLCHHQ(XNDC+0.5*WBSHFT,YNDC,'pp',SIZ,0.,0.)
C
C  Pressure tendency (a).
C
      CALL PLCHHQ(XNDC+WBSHFT,YNDC,'a',SIZ,0.,0.)
C
C  Temperature of dewpoint (TD).
C
      CALL PLCHHQ(XNDC-0.65*WBSHFT,YNDC-0.42*WBSHFT,'T:B1:d',SIZ,0.,0.)
C
C  Low clouds (CL).
C
      CALL PLCHHQ(XNDC-0.17*WBSHFT,YNDC-0.42*WBSHFT,'C:B1:L',SIZ,0.,0.)
C
C  Sky cover (NH).
C
      CALL PLCHHQ(XNDC+0.31*WBSHFT,YNDC-0.42*WBSHFT,'N:B1:h',SIZ,0.,0.)
C
C  Past weather (W).
C
      CALL PLCHHQ(XNDC+0.75*WBSHFT,YNDC-0.42*WBSHFT,'W',SIZ,0.,0.)
C
C  Cloud height (h).
C
      CALL PLCHHQ(XNDC-0.12*WBSHFT,YNDC-0.72*WBSHFT,'h',SIZ,0.,0.)
C
C  Precipitation in last 6 hours (RR).
C
      CALL PLCHHQ(XNDC+0.53*WBSHFT,YNDC-0.72*WBSHFT,'RR',SIZ,0.,0.)
C
      END

C
C $Id: tick43.f,v 1.6 2008-07-27 00:17:34 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE TICK43 (MAGU,MINU,MAGV,MINV,MAGW,MINW)
      SAVE
      COMMON /TCK31/  TMAGU      ,TMINU      ,TMAGV      ,TMINV      ,
     1                TMAGW      ,TMINW
      TMAGU = MAGU
      TMINU = MINU
      TMAGV = MAGV
      TMINV = MINV
      TMAGW = MAGW
      TMINW = MINW
      RETURN
      END

C
C $Id: phi2dp.f,v 1.5 2008-07-27 00:17:10 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      DOUBLE PRECISION FUNCTION PHI2DP (ECCENT,TS)
C
C FUNCTION TO COMPUTE LATITUDE ANGLE (PHI-2).
C
      IMPLICIT DOUBLE PRECISION (A-Z)
      INTEGER II,NIT
      COMMON /ERRMZ0/ IERR
        INTEGER IERR
      SAVE   /ERRMZ0/
      COMMON /PRINZ0/ IPEMSG,IPELUN,IPPARM,IPPLUN
        INTEGER IPEMSG,IPELUN,IPPARM,IPPLUN
      SAVE   /PRINZ0/
      DATA HALF,ONE,TWO /0.5D0,1.0D0,2.0D0/
      DATA TOL,NIT /1.0D-10,15/
      DATA HALFPI /1.5707963267948966D0/
C
      ECCNTH = HALF * ECCENT
      PHI = HALFPI - TWO * ATAN (TS)
      DO 020 II = 1,NIT
      SINPI = SIN (PHI)
      CON = ECCENT * SINPI
      DPHI = HALFPI - TWO * ATAN (TS * ((ONE - CON) /
     .       (ONE + CON)) ** ECCNTH) - PHI
      PHI = PHI + DPHI
      IF (ABS(DPHI) .GT. TOL) GO TO 020
      PHI2DP = PHI
      RETURN
  020 CONTINUE
C
      IF (IPEMSG .EQ. 0) WRITE (IPELUN,2000) NIT,ECCENT,TS
 2000 FORMAT (/' ERROR PHI2DP' /
     .         ' LATITUDE FAILED TO CONVERGE AFTER',I3,' ITERATIONS'/
     .         ' ECCENTRICITY =',E25.16,'   TS =',E25.16)
      IERR = 002
      RETURN
C
      END

C NCLFORTSTART
      subroutine xy2pdf90(nxy,x,y, xmsg,ymsg, nby, mbx, pdf
     *                   ,mbxp1,nbyp1,binxbnd, binybnd,ipcnt,ier)
      implicit none
      integer  nxy, nby, mbx, mbxp1,nbyp1, ipcnt,ier
      double precision x(nxy), y(nxy), xmsg, ymsg
     *                ,binxbnd(mbxp1), binybnd(nbyp1)
      double precision pdf(mbx,nby)
C NCLEND
      integer m, n, mb, nb, kxy, unit, msgflg
 
c Initialize; Count valid values 

      ier   = 0
      pdf   = 0.0
      kxy   = count(x.ne.xmsg .and. y.ne.ymsg)

c Valid data check

      if (kxy.eq.0) then
          ier = 1
          return
      end if

c Very large arrays can result in slow execution times. 
c .   To minimize unnecessary do loop checks, see if missing
c .   values are present.

      msgflg = 1
      if (kxy.eq.nxy) msgflg = 0

c binning

      if (msgflg.eq.1) then
          do nb=1,nby
            do mb=1,mbx
               pdf(mb,nb) = count(x.ne.xmsg .and. y.ne.ymsg .and.    
     *                            x.ge.binxbnd(mb)  .and.
     *                            x.lt.binxbnd(mb+1).and. 
     *                            y.ge.binybnd(nb)  .and.
     *                            y.lt.binybnd(nb+1))
            end do
          end do
      else
          do nb=1,nby
            do mb=1,mbx
               pdf(mb,nb) = count(x.ge.binxbnd(mb)  .and.
     *                            x.lt.binxbnd(mb+1).and. 
     *                            y.ge.binybnd(nb)  .and.
     *                            y.lt.binybnd(nb+1))
            end do
          end do
      end if

      unit = 1
      if (ipcnt.eq.1) then
          unit = 100
      end if

      pdf = unit*(pdf/kxy)

      return
      end

C
C	$Id: cshval.f,v 1.5 2008-07-27 03:10:07 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      DOUBLE PRECISION FUNCTION CSHVAL (B,H1,H2,HP1,HP2,SIGMA)
      DOUBLE PRECISION B, H1, H2, HP1, HP2, SIGMA
C
C***********************************************************
C
C                                              From SSRFPACK
C                                            Robert J. Renka
C                                  Dept. of Computer Science
C                                       Univ. of North Texas
C                                           renka@cs.unt.edu
C                                                   11/21/96
C
C   Given a line segment P1-P2 containing a point P, along
C with values and derivatives at the endpoints, this func-
C tion returns the value H(P), where H is the Hermite inter-
C polatory tension spline defined by the endpoint data.
C
C On input:
C
C       B = Local coordinate of P with respect to P1-P2:
C           P = B*P1 + (1-B)*P2, and thus B = d(P,P2)/
C           d(P1,P2), where d(P1,P2) is the distance between
C           P1 and P2.  B < 0 or B > 1 results in extrapola-
C           tion.
C
C       H1,H2 = Values interpolated at P1 and P2, respec-
C               tively.
C
C       HP1,HP2 = Products of d(P1,P2) with first order der-
C                 ivatives at P1 and P2, respectively.  HP1
C                 may, for example, be the scalar product of
C                 P2-P1 with a gradient at P1.
C
C       SIGMA = Nonnegative tension factor associated with
C               the spline.  SIGMA = 0 corresponds to a
C               cubic spline, and H approaches the linear
C               interpolant of H1 and H2 as SIGMA increases.
C
C Input parameters are not altered by this function.
C
C On output:
C
C       CSHVAL = Interpolated value H(P).
C
C SSRFPACK module required by CSHVAL:  CSSNHCSH
C
C Intrinsic functions called by CSHVAL:  ABS, EXP
C
C***********************************************************
C
      DOUBLE PRECISION B1, B2, CM, CM2, CMM, D1, D2, DUMMY,
     .                 E, E1, E2, EMS, S, SB1, SB2, SIG, SM,
     .                 SM2, TM, TM1, TM2, TS
      B1 = B
      B2 = 1. - B1
C
C Compute slope S and second differences D1 and D2 scaled
C   by the separation between P1 and P2.
C
      S = H2 - H1
      D1 = S - HP1
      D2 = HP2 - S
C
C Test the range of SIGMA.
C
      SIG = ABS(SIGMA)
      IF (SIG .LT. 1.D-9) THEN
C
C Hermite cubic interpolation:
C
        CSHVAL = H1 + B2*(HP1 + B2*(D1 + B1*(D1 - D2)))
      ELSEIF (SIG .LE. .5) THEN
C
C 0 < SIG .LE. .5.  Use approximations designed to avoid
C   cancellation error in the hyperbolic functions.
C
        SB2 = SIG*B2
        CALL CSSNHCSH (SIG, SM,CM,CMM)
        CALL CSSNHCSH (SB2, SM2,CM2,DUMMY)
        E = SIG*SM - CMM - CMM
        CSHVAL = H1 + B2*HP1 + ((CM*SM2-SM*CM2)*(D1+D2) + SIG*
     .                     (CM*CM2-(SM+SIG)*SM2)*D1)/(SIG*E)
      ELSE
C
C SIG > .5.  Use negative exponentials in order to avoid
C   overflow.  Note that EMS = EXP(-SIG).
C
        SB1 = SIG*B1
        SB2 = SIG - SB1
        E1 = EXP(-SB1)
        E2 = EXP(-SB2)
        EMS = E1*E2
        TM = 1. - EMS
        TS = TM*TM
        TM1 = 1. - E1
        TM2 = 1. - E2
        E = TM*(SIG*(1.+EMS) - TM - TM)
        CSHVAL = H1 + B2*S + (TM*TM1*TM2*(D1+D2) + SIG*
     .                      ((E2*TM1*TM1-B1*TS)*D1 +
     .                       (E1*TM2*TM2-B2*TS)*D2))/(SIG*E)
      ENDIF
      RETURN
      END

C
C $Id: mditve.f,v 1.9 2008-09-18 00:42:17 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MDITVE (RLTV,RLNV,PAPV,UCOV,VCOV,
     +                   RLTI,RLNI,PAPI,UCOI,VCOI,
     +                   RLTE,RLNE,PAPE,UCOE,VCOE)
C
        DOUBLE PRECISION RLTV,RLNV,PAPV,UCOV,VCOV,
     +                   RLTI,RLNI,PAPI,UCOI,VCOI,
     +                   RLTE,RLNE,PAPE,UCOE,VCOE
C
C The routine MDITVE (MaP, Interpolate To Visible Edge), given the
C latitude and longitude (RLTV and RLNV) of a point which is visible
C under the current projection, the value of P associated with that
C point (PAPV), and the U and V coordinates (UCOV and VCOV) of the
C point's projection, plus similar quantities (RLTI, RLNI, PAPI, UCOI,
C and VCOI) for a point which is either invisible under the current
C projection or is separated from it by a "crossover" boundary, returns
C similar quantities for an intermediate point at the very edge of the
C visible area or on the "crossover" boundary.
C
C Declare required common blocks.  See MAPBDX for descriptions of these
C common blocks and the variables in them.
C
        COMMON /MAPCM8/  P,Q,R
        DOUBLE PRECISION P,Q,R
        SAVE   /MAPCM8/
C
C Declare local variables, including a couple of one-dimensional arrays
C to use in a call to MDPGCI.  Mostly, this is to prevent compilers from
C giving us a warning message, but it also makes the code comply with
C the FORTRAN standard.
C
        DOUBLE PRECISION DLNH(1),DLTH(1),PAPA,PAPB,PAPH,RLNA,RLNB,RLNH,
     +                   RLTA,RLTB,RLTH,UCOA,UCOB,UCOH,VCOA,VCOB,VCOH
        INTEGER          ITMP
        EQUIVALENCE      (DLTH(1),RLTH),(DLNH(1),RLNH)
C
C Check for an uncleared prior error.
C
        IF (ICFELL('MDITVE - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
        RLTA=RLTV
        RLNA=RLNV
        PAPA=PAPV
        UCOA=UCOV
        VCOA=VCOV
        RLTB=RLTI
        RLNB=RLNI
        PAPB=PAPI
        UCOB=UCOI
        VCOB=VCOI
C
        ITMP=0
C
  101   CALL MDPGCI (RLTA,RLNA,RLTB,RLNB,1,DLTH,DLNH)
        IF (ABS(RLNH-RLNA).GT.180.D0) RLNH=RLNH+SIGN(360.D0,RLNA-RLNH)
        CALL MDPTRA (RLTH,RLNH,UCOH,VCOH)
        IF (ICFELL('MDITVE',2).NE.0) RETURN
        PAPH=P
        IF (UCOH.GE.1.D12) THEN
          IF (RLTH.EQ.RLTB.AND.RLNH.EQ.RLNB) GO TO 102
          RLTB=RLTH
          RLNB=RLNH
          PAPB=PAPH
          UCOB=UCOH
          VCOB=VCOH
        ELSE IF (UCOB.GE.1.D12) THEN
          IF (RLTH.EQ.RLTA.AND.RLNH.EQ.RLNA) GO TO 102
          RLTA=RLTH
          RLNA=RLNH
          PAPA=PAPH
          UCOA=UCOH
          VCOA=VCOH
        ELSE IF ((UCOH-UCOA)**2+(VCOH-VCOA)**2.LT.
     +           (UCOH-UCOB)**2+(VCOH-VCOB)**2) THEN
          IF (RLTH.EQ.RLTA.AND.RLNH.EQ.RLNA) GO TO 102
          RLTA=RLTH
          RLNA=RLNH
          PAPA=PAPH
          UCOA=UCOH
          VCOA=VCOH
        ELSE
          IF (RLTH.EQ.RLTB.AND.RLNH.EQ.RLNB) GO TO 102
          RLTB=RLTH
          RLNB=RLNH
          PAPB=PAPH
          UCOB=UCOH
          VCOB=VCOH
        END IF
C
        ITMP=ITMP+1
        IF (ITMP.LT.64) GO TO 101
C
  102   RLTE=RLTA
        RLNE=RLNA
        PAPE=PAPA
        UCOE=UCOA
        VCOE=VCOA
C
        RETURN
C
      END

C NCLFORTSTART
      SUBROUTINE DWGTAREAAVE(T,WGTY,WGTX,MX,NY,TMSG,IFLAG,AVE)
      IMPLICIT NONE
      INTEGER MX,NY,IFLAG
      DOUBLE PRECISION T(MX,NY),WGTX(MX),WGTY(NY)
      DOUBLE PRECISION TMSG
      DOUBLE PRECISION AVE
C NCLEND

C NCL: aveX = wgt_AreaAve (x,wgty,wgtx,flag)

      INTEGER NL,ML,KMSG
      DOUBLE PRECISION SUMT,SUMW,WGT

C compute the weighted area average

C Nomenclature:
C INPUT:
C t      - 2D array
C wgty   - 1D array of length "ny" [eg: cos(0.01745*lat) or gau_wgt(:)]
C wgtx   - 1D array of length "mx"
C mx     - 1st [faster varying] dimension of "t" [eg, longitude]
C ny     - 2nd [slower varying] dimension of "t" [eg, latitude ]
C tmsg   - msg value
C iflag  - flag
C          =0 compute  average ignoring msg values
C          =1 if any msg data is encountered return as msg
c OUTPUT:
C ave    - area average

      SUMT = 0.0D0
      SUMW = 0.0D0
      KMSG = 0
      AVE = TMSG

      DO NL = 1,NY
          DO ML = 1,MX
              IF (T(ML,NL).NE.TMSG) THEN
                  WGT = WGTX(ML)*WGTY(NL)
                  SUMT = SUMT + T(ML,NL)*WGT
                  SUMW = SUMW + WGT
              ELSE
                  KMSG = KMSG + 1
              END IF
          END DO
c                                      return if user desired
          IF (IFLAG.EQ.1 .AND. KMSG.NE.0) RETURN
      END DO
c                                      compute wgted average
      IF (SUMW.NE.0.D0) THEN
          AVE = SUMT/SUMW
      END IF

      RETURN
      END

C
C	$Id: wmvmap.f,v 1.3 2008-07-27 00:17:37 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE WMVECTMAP(X,Y,U,V)
C
C  This subroutine plots wind vectors over a map with the origin 
C  of the vector at lat/lon coordinate (X,Y).  U and V are the 
C  components of the wind vector.
C
      include 'wmcomn.h'
C
      PARAMETER (R2D=57.2957795131,D2R=0.0174532925)
C
C  Do a call forcing a BLOCKDATA to be loaded from a binary library.
C
      CALL WMBLDA
C
C  Adjust the vector direction depending on its location
C  on a map.
C
      CALL MAPTRN(X,Y,X0,Y0)
      ANGR = ATAN2(U,V)
      CALL MAPTRN(X+0.1*COS(ANGR),Y+0.1/COS(D2R*X)*SIN(ANGR),XA,YA)
      ANGTMP = ATAN2(YA-Y0,XA-X0)
      VLEN = SQRT(U*U+V*V)
      UTMP = VLEN*COS(ANGTMP)
      VTMP = VLEN*SIN(ANGTMP)
      CALL WMVECT(X0,Y0,UTMP,VTMP)
C
      RETURN
      END

      SUBROUTINE SGGEVX( BALANC, JOBVL, JOBVR, SENSE, N, A, LDA, B, LDB,
     $                   ALPHAR, ALPHAI, BETA, VL, LDVL, VR, LDVR, ILO,
     $                   IHI, LSCALE, RSCALE, ABNRM, BBNRM, RCONDE,
     $                   RCONDV, WORK, LWORK, IWORK, BWORK, INFO )
*
*  -- LAPACK driver routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          BALANC, JOBVL, JOBVR, SENSE
      INTEGER            IHI, ILO, INFO, LDA, LDB, LDVL, LDVR, LWORK, N
      REAL               ABNRM, BBNRM
*     ..
*     .. Array Arguments ..
      LOGICAL            BWORK( * )
      INTEGER            IWORK( * )
      REAL               A( LDA, * ), ALPHAI( * ), ALPHAR( * ),
     $                   B( LDB, * ), BETA( * ), LSCALE( * ),
     $                   RCONDE( * ), RCONDV( * ), RSCALE( * ),
     $                   VL( LDVL, * ), VR( LDVR, * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  SGGEVX computes for a pair of N-by-N real nonsymmetric matrices (A,B)
*  the generalized eigenvalues, and optionally, the left and/or right
*  generalized eigenvectors.
*
*  Optionally also, it computes a balancing transformation to improve
*  the conditioning of the eigenvalues and eigenvectors (ILO, IHI,
*  LSCALE, RSCALE, ABNRM, and BBNRM), reciprocal condition numbers for
*  the eigenvalues (RCONDE), and reciprocal condition numbers for the
*  right eigenvectors (RCONDV).
*
*  A generalized eigenvalue for a pair of matrices (A,B) is a scalar
*  lambda or a ratio alpha/beta = lambda, such that A - lambda*B is
*  singular. It is usually represented as the pair (alpha,beta), as
*  there is a reasonable interpretation for beta=0, and even for both
*  being zero.
*
*  The right eigenvector v(j) corresponding to the eigenvalue lambda(j)
*  of (A,B) satisfies
*
*                   A * v(j) = lambda(j) * B * v(j) .
*
*  The left eigenvector u(j) corresponding to the eigenvalue lambda(j)
*  of (A,B) satisfies
*
*                   u(j)**H * A  = lambda(j) * u(j)**H * B.
*
*  where u(j)**H is the conjugate-transpose of u(j).
*
*
*  Arguments
*  =========
*
*  BALANC  (input) CHARACTER*1
*          Specifies the balance option to be performed.
*          = 'N':  do not diagonally scale or permute;
*          = 'P':  permute only;
*          = 'S':  scale only;
*          = 'B':  both permute and scale.
*          Computed reciprocal condition numbers will be for the
*          matrices after permuting and/or balancing. Permuting does
*          not change condition numbers (in exact arithmetic), but
*          balancing does.
*
*  JOBVL   (input) CHARACTER*1
*          = 'N':  do not compute the left generalized eigenvectors;
*          = 'V':  compute the left generalized eigenvectors.
*
*  JOBVR   (input) CHARACTER*1
*          = 'N':  do not compute the right generalized eigenvectors;
*          = 'V':  compute the right generalized eigenvectors.
*
*  SENSE   (input) CHARACTER*1
*          Determines which reciprocal condition numbers are computed.
*          = 'N': none are computed;
*          = 'E': computed for eigenvalues only;
*          = 'V': computed for eigenvectors only;
*          = 'B': computed for eigenvalues and eigenvectors.
*
*  N       (input) INTEGER
*          The order of the matrices A, B, VL, and VR.  N >= 0.
*
*  A       (input/output) REAL array, dimension (LDA, N)
*          On entry, the matrix A in the pair (A,B).
*          On exit, A has been overwritten. If JOBVL='V' or JOBVR='V'
*          or both, then A contains the first part of the real Schur
*          form of the "balanced" versions of the input A and B.
*
*  LDA     (input) INTEGER
*          The leading dimension of A.  LDA >= max(1,N).
*
*  B       (input/output) REAL array, dimension (LDB, N)
*          On entry, the matrix B in the pair (A,B).
*          On exit, B has been overwritten. If JOBVL='V' or JOBVR='V'
*          or both, then B contains the second part of the real Schur
*          form of the "balanced" versions of the input A and B.
*
*  LDB     (input) INTEGER
*          The leading dimension of B.  LDB >= max(1,N).
*
*  ALPHAR  (output) REAL array, dimension (N)
*  ALPHAI  (output) REAL array, dimension (N)
*  BETA    (output) REAL array, dimension (N)
*          On exit, (ALPHAR(j) + ALPHAI(j)*i)/BETA(j), j=1,...,N, will
*          be the generalized eigenvalues.  If ALPHAI(j) is zero, then
*          the j-th eigenvalue is real; if positive, then the j-th and
*          (j+1)-st eigenvalues are a complex conjugate pair, with
*          ALPHAI(j+1) negative.
*
*          Note: the quotients ALPHAR(j)/BETA(j) and ALPHAI(j)/BETA(j)
*          may easily over- or underflow, and BETA(j) may even be zero.
*          Thus, the user should avoid naively computing the ratio
*          ALPHA/BETA. However, ALPHAR and ALPHAI will be always less
*          than and usually comparable with norm(A) in magnitude, and
*          BETA always less than and usually comparable with norm(B).
*
*  VL      (output) REAL array, dimension (LDVL,N)
*          If JOBVL = 'V', the left eigenvectors u(j) are stored one
*          after another in the columns of VL, in the same order as
*          their eigenvalues. If the j-th eigenvalue is real, then
*          u(j) = VL(:,j), the j-th column of VL. If the j-th and
*          (j+1)-th eigenvalues form a complex conjugate pair, then
*          u(j) = VL(:,j)+i*VL(:,j+1) and u(j+1) = VL(:,j)-i*VL(:,j+1).
*          Each eigenvector will be scaled so the largest component have
*          abs(real part) + abs(imag. part) = 1.
*          Not referenced if JOBVL = 'N'.
*
*  LDVL    (input) INTEGER
*          The leading dimension of the matrix VL. LDVL >= 1, and
*          if JOBVL = 'V', LDVL >= N.
*
*  VR      (output) REAL array, dimension (LDVR,N)
*          If JOBVR = 'V', the right eigenvectors v(j) are stored one
*          after another in the columns of VR, in the same order as
*          their eigenvalues. If the j-th eigenvalue is real, then
*          v(j) = VR(:,j), the j-th column of VR. If the j-th and
*          (j+1)-th eigenvalues form a complex conjugate pair, then
*          v(j) = VR(:,j)+i*VR(:,j+1) and v(j+1) = VR(:,j)-i*VR(:,j+1).
*          Each eigenvector will be scaled so the largest component have
*          abs(real part) + abs(imag. part) = 1.
*          Not referenced if JOBVR = 'N'.
*
*  LDVR    (input) INTEGER
*          The leading dimension of the matrix VR. LDVR >= 1, and
*          if JOBVR = 'V', LDVR >= N.
*
*  ILO,IHI (output) INTEGER
*          ILO and IHI are integer values such that on exit
*          A(i,j) = 0 and B(i,j) = 0 if i > j and
*          j = 1,...,ILO-1 or i = IHI+1,...,N.
*          If BALANC = 'N' or 'S', ILO = 1 and IHI = N.
*
*  LSCALE  (output) REAL array, dimension (N)
*          Details of the permutations and scaling factors applied
*          to the left side of A and B.  If PL(j) is the index of the
*          row interchanged with row j, and DL(j) is the scaling
*          factor applied to row j, then
*            LSCALE(j) = PL(j)  for j = 1,...,ILO-1
*                      = DL(j)  for j = ILO,...,IHI
*                      = PL(j)  for j = IHI+1,...,N.
*          The order in which the interchanges are made is N to IHI+1,
*          then 1 to ILO-1.
*
*  RSCALE  (output) REAL array, dimension (N)
*          Details of the permutations and scaling factors applied
*          to the right side of A and B.  If PR(j) is the index of the
*          column interchanged with column j, and DR(j) is the scaling
*          factor applied to column j, then
*            RSCALE(j) = PR(j)  for j = 1,...,ILO-1
*                      = DR(j)  for j = ILO,...,IHI
*                      = PR(j)  for j = IHI+1,...,N
*          The order in which the interchanges are made is N to IHI+1,
*          then 1 to ILO-1.
*
*  ABNRM   (output) REAL
*          The one-norm of the balanced matrix A.
*
*  BBNRM   (output) REAL
*          The one-norm of the balanced matrix B.
*
*  RCONDE  (output) REAL array, dimension (N)
*          If SENSE = 'E' or 'B', the reciprocal condition numbers of
*          the selected eigenvalues, stored in consecutive elements of
*          the array. For a complex conjugate pair of eigenvalues two
*          consecutive elements of RCONDE are set to the same value.
*          Thus RCONDE(j), RCONDV(j), and the j-th columns of VL and VR
*          all correspond to the same eigenpair (but not in general the
*          j-th eigenpair, unless all eigenpairs are selected).
*          If SENSE = 'V', RCONDE is not referenced.
*
*  RCONDV  (output) REAL array, dimension (N)
*          If SENSE = 'V' or 'B', the estimated reciprocal condition
*          numbers of the selected eigenvectors, stored in consecutive
*          elements of the array. For a complex eigenvector two
*          consecutive elements of RCONDV are set to the same value. If
*          the eigenvalues cannot be reordered to compute RCONDV(j),
*          RCONDV(j) is set to 0; this can only occur when the true
*          value would be very small anyway.
*          If SENSE = 'E', RCONDV is not referenced.
*
*  WORK    (workspace/output) REAL array, dimension (LWORK)
*          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*
*  LWORK   (input) INTEGER
*          The dimension of the array WORK. LWORK >= max(1,6*N).
*          If SENSE = 'E', LWORK >= 12*N.
*          If SENSE = 'V' or 'B', LWORK >= 2*N*N+12*N+16.
*
*          If LWORK = -1, then a workspace query is assumed; the routine
*          only calculates the optimal size of the WORK array, returns
*          this value as the first entry of the WORK array, and no error
*          message related to LWORK is issued by XERBLA.
*
*  IWORK   (workspace) INTEGER array, dimension (N+6)
*          If SENSE = 'E', IWORK is not referenced.
*
*  BWORK   (workspace) LOGICAL array, dimension (N)
*          If SENSE = 'N', BWORK is not referenced.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value.
*          = 1,...,N:
*                The QZ iteration failed.  No eigenvectors have been
*                calculated, but ALPHAR(j), ALPHAI(j), and BETA(j)
*                should be correct for j=INFO+1,...,N.
*          > N:  =N+1: other than QZ iteration failed in SHGEQZ.
*                =N+2: error return from STGEVC.
*
*  Further Details
*  ===============
*
*  Balancing a matrix pair (A,B) includes, first, permuting rows and
*  columns to isolate eigenvalues, second, applying diagonal similarity
*  transformation to the rows and columns to make the rows and columns
*  as close in norm as possible. The computed reciprocal condition
*  numbers correspond to the balanced matrix. Permuting rows and columns
*  will not change the condition numbers (in exact arithmetic) but
*  diagonal scaling will.  For further explanation of balancing, see
*  section 4.11.1.2 of LAPACK Users' Guide.
*
*  An approximate error bound on the chordal distance between the i-th
*  computed generalized eigenvalue w and the corresponding exact
*  eigenvalue lambda is
*
*       chord(w, lambda) <= EPS * norm(ABNRM, BBNRM) / RCONDE(I)
*
*  An approximate error bound for the angle between the i-th computed
*  eigenvector VL(i) or VR(i) is given by
*
*       EPS * norm(ABNRM, BBNRM) / DIF(i).
*
*  For further explanation of the reciprocal condition numbers RCONDE
*  and RCONDV, see section 4.11 of LAPACK User's Guide.
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ZERO, ONE
      PARAMETER          ( ZERO = 0.0E+0, ONE = 1.0E+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            ILASCL, ILBSCL, ILV, ILVL, ILVR, LQUERY, PAIR,
     $                   WANTSB, WANTSE, WANTSN, WANTSV
      CHARACTER          CHTEMP
      INTEGER            I, ICOLS, IERR, IJOBVL, IJOBVR, IN, IROWS,
     $                   ITAU, IWRK, IWRK1, J, JC, JR, M, MAXWRK,
     $                   MINWRK, MM
      REAL               ANRM, ANRMTO, BIGNUM, BNRM, BNRMTO, EPS,
     $                   SMLNUM, TEMP
*     ..
*     .. Local Arrays ..
      LOGICAL            LDUMMA( 1 )
*     ..
*     .. External Subroutines ..
      EXTERNAL           SGEQRF, SGGBAK, SGGBAL, SGGHRD, SHGEQZ, SLABAD,
     $                   SLACPY, SLASCL, SLASET, SORGQR, SORMQR, STGEVC,
     $                   STGSNA, XERBLA
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            ILAENV
      REAL               SLAMCH, SLANGE
      EXTERNAL           LSAME, ILAENV, SLAMCH, SLANGE
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, MAX, SQRT
*     ..
*     .. Executable Statements ..
*
*     Decode the input arguments
*
      IF( LSAME( JOBVL, 'N' ) ) THEN
         IJOBVL = 1
         ILVL = .FALSE.
      ELSE IF( LSAME( JOBVL, 'V' ) ) THEN
         IJOBVL = 2
         ILVL = .TRUE.
      ELSE
         IJOBVL = -1
         ILVL = .FALSE.
      END IF
*
      IF( LSAME( JOBVR, 'N' ) ) THEN
         IJOBVR = 1
         ILVR = .FALSE.
      ELSE IF( LSAME( JOBVR, 'V' ) ) THEN
         IJOBVR = 2
         ILVR = .TRUE.
      ELSE
         IJOBVR = -1
         ILVR = .FALSE.
      END IF
      ILV = ILVL .OR. ILVR
*
      WANTSN = LSAME( SENSE, 'N' )
      WANTSE = LSAME( SENSE, 'E' )
      WANTSV = LSAME( SENSE, 'V' )
      WANTSB = LSAME( SENSE, 'B' )
*
*     Test the input arguments
*
      INFO = 0
      LQUERY = ( LWORK.EQ.-1 )
      IF( .NOT.( LSAME( BALANC, 'N' ) .OR. LSAME( BALANC,
     $    'S' ) .OR. LSAME( BALANC, 'P' ) .OR. LSAME( BALANC, 'B' ) ) )
     $     THEN
         INFO = -1
      ELSE IF( IJOBVL.LE.0 ) THEN
         INFO = -2
      ELSE IF( IJOBVR.LE.0 ) THEN
         INFO = -3
      ELSE IF( .NOT.( WANTSN .OR. WANTSE .OR. WANTSB .OR. WANTSV ) )
     $          THEN
         INFO = -4
      ELSE IF( N.LT.0 ) THEN
         INFO = -5
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -7
      ELSE IF( LDB.LT.MAX( 1, N ) ) THEN
         INFO = -9
      ELSE IF( LDVL.LT.1 .OR. ( ILVL .AND. LDVL.LT.N ) ) THEN
         INFO = -14
      ELSE IF( LDVR.LT.1 .OR. ( ILVR .AND. LDVR.LT.N ) ) THEN
         INFO = -16
      END IF
*
*     Compute workspace
*      (Note: Comments in the code beginning "Workspace:" describe the
*       minimal amount of workspace needed at that point in the code,
*       as well as the preferred amount for good performance.
*       NB refers to the optimal block size for the immediately
*       following subroutine, as returned by ILAENV. The workspace is
*       computed assuming ILO = 1 and IHI = N, the worst case.)
*
      MINWRK = 1
      IF( INFO.EQ.0 .AND. ( LWORK.GE.1 .OR. LQUERY ) ) THEN
         MAXWRK = 5*N + N*ILAENV( 1, 'SGEQRF', ' ', N, 1, N, 0 )
         MINWRK = MAX( 1, 6*N )
         IF( WANTSE ) THEN
            MINWRK = MAX( 1, 12*N )
         ELSE IF( WANTSV .OR. WANTSB ) THEN
            MINWRK = 2*N*N + 12*N + 16
            MAXWRK = MAX( MAXWRK, 2*N*N+12*N+16 )
         END IF
         WORK( 1 ) = MAXWRK
      END IF
*
      IF( LWORK.LT.MINWRK .AND. .NOT.LQUERY ) THEN
         INFO = -26
      END IF
*
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'SGGEVX', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
*
*
*     Get machine constants
*
      EPS = SLAMCH( 'P' )
      SMLNUM = SLAMCH( 'S' )
      BIGNUM = ONE / SMLNUM
      CALL SLABAD( SMLNUM, BIGNUM )
      SMLNUM = SQRT( SMLNUM ) / EPS
      BIGNUM = ONE / SMLNUM
*
*     Scale A if max element outside range [SMLNUM,BIGNUM]
*
      ANRM = SLANGE( 'M', N, N, A, LDA, WORK )
      ILASCL = .FALSE.
      IF( ANRM.GT.ZERO .AND. ANRM.LT.SMLNUM ) THEN
         ANRMTO = SMLNUM
         ILASCL = .TRUE.
      ELSE IF( ANRM.GT.BIGNUM ) THEN
         ANRMTO = BIGNUM
         ILASCL = .TRUE.
      END IF
      IF( ILASCL )
     $   CALL SLASCL( 'G', 0, 0, ANRM, ANRMTO, N, N, A, LDA, IERR )
*
*     Scale B if max element outside range [SMLNUM,BIGNUM]
*
      BNRM = SLANGE( 'M', N, N, B, LDB, WORK )
      ILBSCL = .FALSE.
      IF( BNRM.GT.ZERO .AND. BNRM.LT.SMLNUM ) THEN
         BNRMTO = SMLNUM
         ILBSCL = .TRUE.
      ELSE IF( BNRM.GT.BIGNUM ) THEN
         BNRMTO = BIGNUM
         ILBSCL = .TRUE.
      END IF
      IF( ILBSCL )
     $   CALL SLASCL( 'G', 0, 0, BNRM, BNRMTO, N, N, B, LDB, IERR )
*
*     Permute and/or balance the matrix pair (A,B)
*     (Workspace: need 6*N)
*
      CALL SGGBAL( BALANC, N, A, LDA, B, LDB, ILO, IHI, LSCALE, RSCALE,
     $             WORK, IERR )
*
*     Compute ABNRM and BBNRM
*
      ABNRM = SLANGE( '1', N, N, A, LDA, WORK( 1 ) )
      IF( ILASCL ) THEN
         WORK( 1 ) = ABNRM
         CALL SLASCL( 'G', 0, 0, ANRMTO, ANRM, 1, 1, WORK( 1 ), 1,
     $                IERR )
         ABNRM = WORK( 1 )
      END IF
*
      BBNRM = SLANGE( '1', N, N, B, LDB, WORK( 1 ) )
      IF( ILBSCL ) THEN
         WORK( 1 ) = BBNRM
         CALL SLASCL( 'G', 0, 0, BNRMTO, BNRM, 1, 1, WORK( 1 ), 1,
     $                IERR )
         BBNRM = WORK( 1 )
      END IF
*
*     Reduce B to triangular form (QR decomposition of B)
*     (Workspace: need N, prefer N*NB )
*
      IROWS = IHI + 1 - ILO
      IF( ILV .OR. .NOT.WANTSN ) THEN
         ICOLS = N + 1 - ILO
      ELSE
         ICOLS = IROWS
      END IF
      ITAU = 1
      IWRK = ITAU + IROWS
      CALL SGEQRF( IROWS, ICOLS, B( ILO, ILO ), LDB, WORK( ITAU ),
     $             WORK( IWRK ), LWORK+1-IWRK, IERR )
*
*     Apply the orthogonal transformation to A
*     (Workspace: need N, prefer N*NB)
*
      CALL SORMQR( 'L', 'T', IROWS, ICOLS, IROWS, B( ILO, ILO ), LDB,
     $             WORK( ITAU ), A( ILO, ILO ), LDA, WORK( IWRK ),
     $             LWORK+1-IWRK, IERR )
*
*     Initialize VL and/or VR
*     (Workspace: need N, prefer N*NB)
*
      IF( ILVL ) THEN
         CALL SLASET( 'Full', N, N, ZERO, ONE, VL, LDVL )
         CALL SLACPY( 'L', IROWS-1, IROWS-1, B( ILO+1, ILO ), LDB,
     $                VL( ILO+1, ILO ), LDVL )
         CALL SORGQR( IROWS, IROWS, IROWS, VL( ILO, ILO ), LDVL,
     $                WORK( ITAU ), WORK( IWRK ), LWORK+1-IWRK, IERR )
      END IF
*
      IF( ILVR )
     $   CALL SLASET( 'Full', N, N, ZERO, ONE, VR, LDVR )
*
*     Reduce to generalized Hessenberg form
*     (Workspace: none needed)
*
      IF( ILV .OR. .NOT.WANTSN ) THEN
*
*        Eigenvectors requested -- work on whole matrix.
*
         CALL SGGHRD( JOBVL, JOBVR, N, ILO, IHI, A, LDA, B, LDB, VL,
     $                LDVL, VR, LDVR, IERR )
      ELSE
         CALL SGGHRD( 'N', 'N', IROWS, 1, IROWS, A( ILO, ILO ), LDA,
     $                B( ILO, ILO ), LDB, VL, LDVL, VR, LDVR, IERR )
      END IF
*
*     Perform QZ algorithm (Compute eigenvalues, and optionally, the
*     Schur forms and Schur vectors)
*     (Workspace: need N)
*
      IF( ILV .OR. .NOT.WANTSN ) THEN
         CHTEMP = 'S'
      ELSE
         CHTEMP = 'E'
      END IF
*
      CALL SHGEQZ( CHTEMP, JOBVL, JOBVR, N, ILO, IHI, A, LDA, B, LDB,
     $             ALPHAR, ALPHAI, BETA, VL, LDVL, VR, LDVR, WORK,
     $             LWORK, IERR )
      IF( IERR.NE.0 ) THEN
         IF( IERR.GT.0 .AND. IERR.LE.N ) THEN
            INFO = IERR
         ELSE IF( IERR.GT.N .AND. IERR.LE.2*N ) THEN
            INFO = IERR - N
         ELSE
            INFO = N + 1
         END IF
         GO TO 130
      END IF
*
*     Compute Eigenvectors and estimate condition numbers if desired
*     (Workspace: STGEVC: need 6*N
*                 STGSNA: need 2*N*(N+2)+16 if SENSE = 'V' or 'B',
*                         need N otherwise )
*
      IF( ILV .OR. .NOT.WANTSN ) THEN
         IF( ILV ) THEN
            IF( ILVL ) THEN
               IF( ILVR ) THEN
                  CHTEMP = 'B'
               ELSE
                  CHTEMP = 'L'
               END IF
            ELSE
               CHTEMP = 'R'
            END IF
*
            CALL STGEVC( CHTEMP, 'B', LDUMMA, N, A, LDA, B, LDB, VL,
     $                   LDVL, VR, LDVR, N, IN, WORK, IERR )
            IF( IERR.NE.0 ) THEN
               INFO = N + 2
               GO TO 130
            END IF
         END IF
*
         IF( .NOT.WANTSN ) THEN
*
*           compute eigenvectors (STGEVC) and estimate condition
*           numbers (STGSNA). Note that the definition of the condition
*           number is not invariant under transformation (u,v) to
*           (Q*u, Z*v), where (u,v) are eigenvectors of the generalized
*           Schur form (S,T), Q and Z are orthogonal matrices. In order
*           to avoid using extra 2*N*N workspace, we have to recalculate
*           eigenvectors and estimate one condition numbers at a time.
*
            PAIR = .FALSE.
            DO 20 I = 1, N
*
               IF( PAIR ) THEN
                  PAIR = .FALSE.
                  GO TO 20
               END IF
               MM = 1
               IF( I.LT.N ) THEN
                  IF( A( I+1, I ).NE.ZERO ) THEN
                     PAIR = .TRUE.
                     MM = 2
                  END IF
               END IF
*
               DO 10 J = 1, N
                  BWORK( J ) = .FALSE.
   10          CONTINUE
               IF( MM.EQ.1 ) THEN
                  BWORK( I ) = .TRUE.
               ELSE IF( MM.EQ.2 ) THEN
                  BWORK( I ) = .TRUE.
                  BWORK( I+1 ) = .TRUE.
               END IF
*
               IWRK = MM*N + 1
               IWRK1 = IWRK + MM*N
*
*              Compute a pair of left and right eigenvectors.
*              (compute workspace: need up to 4*N + 6*N)
*
               IF( WANTSE .OR. WANTSB ) THEN
                  CALL STGEVC( 'B', 'S', BWORK, N, A, LDA, B, LDB,
     $                         WORK( 1 ), N, WORK( IWRK ), N, MM, M,
     $                         WORK( IWRK1 ), IERR )
                  IF( IERR.NE.0 ) THEN
                     INFO = N + 2
                     GO TO 130
                  END IF
               END IF
*
               CALL STGSNA( SENSE, 'S', BWORK, N, A, LDA, B, LDB,
     $                      WORK( 1 ), N, WORK( IWRK ), N, RCONDE( I ),
     $                      RCONDV( I ), MM, M, WORK( IWRK1 ),
     $                      LWORK-IWRK1+1, IWORK, IERR )
*
   20       CONTINUE
         END IF
      END IF
*
*     Undo balancing on VL and VR and normalization
*     (Workspace: none needed)
*
      IF( ILVL ) THEN
         CALL SGGBAK( BALANC, 'L', N, ILO, IHI, LSCALE, RSCALE, N, VL,
     $                LDVL, IERR )
*
         DO 70 JC = 1, N
            IF( ALPHAI( JC ).LT.ZERO )
     $         GO TO 70
            TEMP = ZERO
            IF( ALPHAI( JC ).EQ.ZERO ) THEN
               DO 30 JR = 1, N
                  TEMP = MAX( TEMP, ABS( VL( JR, JC ) ) )
   30          CONTINUE
            ELSE
               DO 40 JR = 1, N
                  TEMP = MAX( TEMP, ABS( VL( JR, JC ) )+
     $                   ABS( VL( JR, JC+1 ) ) )
   40          CONTINUE
            END IF
            IF( TEMP.LT.SMLNUM )
     $         GO TO 70
            TEMP = ONE / TEMP
            IF( ALPHAI( JC ).EQ.ZERO ) THEN
               DO 50 JR = 1, N
                  VL( JR, JC ) = VL( JR, JC )*TEMP
   50          CONTINUE
            ELSE
               DO 60 JR = 1, N
                  VL( JR, JC ) = VL( JR, JC )*TEMP
                  VL( JR, JC+1 ) = VL( JR, JC+1 )*TEMP
   60          CONTINUE
            END IF
   70    CONTINUE
      END IF
      IF( ILVR ) THEN
         CALL SGGBAK( BALANC, 'R', N, ILO, IHI, LSCALE, RSCALE, N, VR,
     $                LDVR, IERR )
         DO 120 JC = 1, N
            IF( ALPHAI( JC ).LT.ZERO )
     $         GO TO 120
            TEMP = ZERO
            IF( ALPHAI( JC ).EQ.ZERO ) THEN
               DO 80 JR = 1, N
                  TEMP = MAX( TEMP, ABS( VR( JR, JC ) ) )
   80          CONTINUE
            ELSE
               DO 90 JR = 1, N
                  TEMP = MAX( TEMP, ABS( VR( JR, JC ) )+
     $                   ABS( VR( JR, JC+1 ) ) )
   90          CONTINUE
            END IF
            IF( TEMP.LT.SMLNUM )
     $         GO TO 120
            TEMP = ONE / TEMP
            IF( ALPHAI( JC ).EQ.ZERO ) THEN
               DO 100 JR = 1, N
                  VR( JR, JC ) = VR( JR, JC )*TEMP
  100          CONTINUE
            ELSE
               DO 110 JR = 1, N
                  VR( JR, JC ) = VR( JR, JC )*TEMP
                  VR( JR, JC+1 ) = VR( JR, JC+1 )*TEMP
  110          CONTINUE
            END IF
  120    CONTINUE
      END IF
*
*     Undo scaling if necessary
*
      IF( ILASCL ) THEN
         CALL SLASCL( 'G', 0, 0, ANRMTO, ANRM, N, 1, ALPHAR, N, IERR )
         CALL SLASCL( 'G', 0, 0, ANRMTO, ANRM, N, 1, ALPHAI, N, IERR )
      END IF
*
      IF( ILBSCL ) THEN
         CALL SLASCL( 'G', 0, 0, BNRMTO, BNRM, N, 1, BETA, N, IERR )
      END IF
*
  130 CONTINUE
      WORK( 1 ) = MAXWRK
*
      RETURN
*
*     End of SGGEVX
*
      END

C
C	$Id: cstrans.f,v 1.5 2008-07-27 03:10:08 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CSTRANS (N,RLAT,RLON, X,Y,Z)
      INTEGER N
      REAL RLAT(N), RLON(N), X(N), Y(N), Z(N)
C
C***********************************************************
C
C                                              From STRIPACK
C                                            Robert J. Renka
C                                  Dept. of Computer Science
C                                       Univ. of North Texas
C                                           renka@cs.unt.edu
C                                                   04/08/90
C
C   This subroutine transforms spherical coordinates into
C Cartesian coordinates on the unit sphere for input to
C Subroutine CSTRMESH.  Storage for X and Y may coincide with
C storage for RLAT and RLON if the latter need not be saved.
C
C
C On input:
C
C       N = Number of nodes (points on the unit sphere)
C           whose coordinates are to be transformed.
C
C       RLAT = Array of length N containing latitudinal
C              coordinates of the nodes in radians.
C
C       RLON = Array of length N containing longitudinal
C              coordinates of the nodes in radians.
C
C The above parameters are not altered by this routine.
C
C       X,Y,Z = Arrays of length at least N.
C
C On output:
C
C       X,Y,Z = Cartesian coordinates in the range -1 to 1.
C               X(I)**2 + Y(I)**2 + Z(I)**2 = 1 for I = 1
C               to N.
C
C Modules required by CSTRANS:  None
C
C Intrinsic functions called by CSTRANS:  COS, SIN
C
C***********************************************************
C
      INTEGER I, NN
      DOUBLE PRECISION COSPHI, PHI, THETA
C
C Local parameters:
C
C COSPHI = cos(PHI)
C I =      DO-loop index
C NN =     Local copy of N
C PHI =    Latitude
C THETA =  Longitude
C
      NN = N
      DO 1 I = 1,NN
        PHI = RLAT(I)
        THETA = RLON(I)
        COSPHI = COS(PHI)
        X(I) = COSPHI*COS(THETA)
        Y(I) = COSPHI*SIN(THETA)
        Z(I) = SIN(PHI)
    1   CONTINUE
      RETURN
      END

c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by UCAR                 .
c  .                                                             .
c  .       University Corporation for Atmospheric Research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                         SPHEREPACK                          .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c
c ... file shaec.f
c
c     this file contains code and documentation for subroutines
c     shaec and shaeci
c
c ... files which must be loaded with shaec.f
c
c     sphcom.f, hrfft.f
c
c     subroutine shaec(nlat,nlon,isym,nt,g,idg,jdg,a,b,mdab,ndab,
c    +                 wshaec,lshaec,work,lwork,ierror)
c
c     subroutine shaec performs the spherical harmonic analysis
c     on the array g and stores the result in the arrays a and b.
c     the analysis is performed on an equally spaced grid.  the
c     associated legendre functions are recomputed rather than stored
c     as they are in subroutine shaes.  the analysis is described
c     below at output parameters a,b.
c
c     input parameters
c
c     nlat   the number of colatitudes on the full sphere including the
c            poles. for example, nlat = 37 for a five degree grid.
c            nlat determines the grid increment in colatitude as
c            pi/(nlat-1).  if nlat is odd the equator is located at
c            grid point i=(nlat+1)/2. if nlat is even the equator is
c            located half way between points i=nlat/2 and i=nlat/2+1.
c            nlat must be at least 3. note: on the half sphere, the
c            number of grid points in the colatitudinal direction is
c            nlat/2 if nlat is even or (nlat+1)/2 if nlat is odd.
c
c     nlon   the number of distinct londitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater
c            than or equal to 4. the efficiency of the computation is
c            improved when nlon is a product of small prime numbers.
c
c     isym   = 0  no symmetries exist about the equator. the analysis
c                 is performed on the entire sphere.  i.e. on the
c                 array g(i,j) for i=1,...,nlat and j=1,...,nlon.
c                 (see description of g below)
c
c            = 1  g is antisymmetric about the equator. the analysis
c                 is performed on the northern hemisphere only.  i.e.
c                 if nlat is odd the analysis is performed on the
c                 array g(i,j) for i=1,...,(nlat+1)/2 and j=1,...,nlon.
c                 if nlat is even the analysis is performed on the
c                 array g(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
c
c
c            = 2  g is symmetric about the equator. the analysis is
c                 performed on the northern hemisphere only.  i.e.
c                 if nlat is odd the analysis is performed on the
c                 array g(i,j) for i=1,...,(nlat+1)/2 and j=1,...,nlon.
c                 if nlat is even the analysis is performed on the
c                 array g(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
c
c     nt     the number of analyses.  in the program that calls shaec,
c            the arrays g,a and b can be three dimensional in which
c            case multiple analyses will be performed.  the third
c            index is the analysis index which assumes the values
c            k=1,...,nt.  for a single analysis set nt=1. the
c            discription of the remaining parameters is simplified
c            by assuming that nt=1 or that the arrays g,a and b
c            have only two dimensions.
c
c     g      a two or three dimensional array (see input parameter
c            nt) that contains the discrete function to be analyzed.
c            g(i,j) contains the value of the function at the colatitude
c            point theta(i) = (i-1)*pi/(nlat-1) and longitude point
c            phi(j) = (j-1)*2*pi/nlon. the index ranges are defined
c            above at the input parameter isym.
c
c
c     idg    the first dimension of the array g as it appears in the
c            program that calls shaec.  if isym equals zero then idg
c            must be at least nlat.  if isym is nonzero then idg
c            must be at least nlat/2 if nlat is even or at least
c            (nlat+1)/2 if nlat is odd.
c
c     jdg    the second dimension of the array g as it appears in the
c            program that calls shaec.  jdg must be at least nlon.
c
c     mdab   the first dimension of the arrays a and b as it appears
c            in the program that calls shaec. mdab must be at least
c            min0(nlat,(nlon+2)/2) if nlon is even or at least
c            min0(nlat,(nlon+1)/2) if nlon is odd.
c
c     ndab   the second dimension of the arrays a and b as it appears
c            in the program that calls shaec. ndab must be at least nlat
c
c     wshaec an array which must be initialized by subroutine shaeci.
c            once initialized, wshaec can be used repeatedly by shaec
c            as long as nlon and nlat remain unchanged.  wshaec must
c            not be altered between calls of shaec.
c
c     lshaec the dimension of the array wshaec as it appears in the
c            program that calls shaec. define
c
c               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            then lshaec must be at least
c
c            2*nlat*l2+3*((l1-2)*(nlat+nlat-l1-1))/2+nlon+15
c
c
c     work   a work array that does not have to be saved.
c
c     lwork  the dimension of the array work as it appears in the
c            program that calls shaec. define
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            if isym is zero then lwork must be at least
c
c                    nlat*(nt*nlon+max0(3*l2,nlon))
c
c            if isym is not zero then lwork must be at least
c
c                    l2*(nt*nlon+max0(3*nlat,nlon))
c
c     **************************************************************
c
c     output parameters
c
c     a,b    both a,b are two or three dimensional arrays (see input
c            parameter nt) that contain the spherical harmonic
c            coefficients in the representation of g(i,j) given in the
c            discription of subroutine shsec. for isym=0, a(m,n) and
c            b(m,n) are given by the equations listed below. symmetric
c            versions are used when isym is greater than zero.
c
c
c
c     definitions
c
c     1. the normalized associated legendre functions
c
c     pbar(m,n,theta) = sqrt((2*n+1)*factorial(n-m)/(2*factorial(n+m)))
c                       *sin(theta)**m/(2**n*factorial(n)) times the
c                       (n+m)th derivative of (x**2-1)**n with respect
c                       to x=cos(theta)
c
c     2. the normalized z functions for m even
c
c     zbar(m,n,theta) = 2/(nlat-1) times the sum from k=0 to k=nlat-1 of
c                       the integral from tau = 0 to tau = pi of
c                       cos(k*theta)*cos(k*tau)*pbar(m,n,tau)*sin(tau)
c                       (first and last terms in this sum are divided
c                       by 2)
c
c     3. the normalized z functions for m odd
c
c     zbar(m,n,theta) = 2/(nlat-1) times the sum from k=0 to k=nlat-1 of
c                       of the integral from tau = 0 to tau = pi of
c                       sin(k*theta)*sin(k*tau)*pbar(m,n,tau)*sin(tau)
c
c     4. the fourier transform of g(i,j).
c
c     c(m,i)          = 2/nlon times the sum from j=1 to j=nlon
c                       of g(i,j)*cos((m-1)*(j-1)*2*pi/nlon)
c                       (the first and last terms in this sum
c                       are divided by 2)
c
c     s(m,i)          = 2/nlon times the sum from j=2 to j=nlon
c                       of g(i,j)*sin((m-1)*(j-1)*2*pi/nlon)
c
c     5. the maximum (plus one) longitudinal wave number
c
c            mmax = min0(nlat,(nlon+2)/2) if nlon is even or
c            mmax = min0(nlat,(nlon+1)/2) if nlon is odd.
c
c
c     then for m=0,...,mmax-1 and n=m,...,nlat-1 the arrays a,b
c     are given by
c
c     a(m+1,n+1)      = the sum from i=1 to i=nlat of
c                       c(m+1,i)*zbar(m,n,theta(i))
c                       (first and last terms in this sum are
c                       divided by 2)
c
c     b(m+1,n+1)      = the sum from i=1 to i=nlat of
c                       s(m+1,i)*zbar(m,n,theta(i))
c
c
c     ierror = 0  no errors
c            = 1  error in the specification of nlat
c            = 2  error in the specification of nlon
c            = 3  error in the specification of isym
c            = 4  error in the specification of nt
c            = 5  error in the specification of idg
c            = 6  error in the specification of jdg
c            = 7  error in the specification of mdab
c            = 8  error in the specification of ndab
c            = 9  error in the specification of lshaec
c            = 10 error in the specification of lwork
c
c
c ****************************************************************
c     subroutine shaeci(nlat,nlon,wshaec,lshaec,dwork,ldwork,ierror)
c
c     subroutine shaeci initializes the array wshaec which can then
c     be used repeatedly by subroutine shaec.
c
c     input parameters
c
c     nlat   the number of colatitudes on the full sphere including the
c            poles. for example, nlat = 37 for a five degree grid.
c            nlat determines the grid increment in colatitude as
c            pi/(nlat-1).  if nlat is odd the equator is located at
c            grid point i=(nlat+1)/2. if nlat is even the equator is
c            located half way between points i=nlat/2 and i=nlat/2+1.
c            nlat must be at least 3. note: on the half sphere, the
c            number of grid points in the colatitudinal direction is
c            nlat/2 if nlat is even or (nlat+1)/2 if nlat is odd.
c
c     nlon   the number of distinct londitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater
c            than or equal to 4. the efficiency of the computation is
c            improved when nlon is a product of small prime numbers.
c
c     lshaec the dimension of the array wshaec as it appears in the
c            program that calls shaeci. the array wshaec is an output
c            parameter which is described below. define
c
c               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            then lshaec must be at least
c
c            2*nlat*l2+3*((l1-2)*(nlat+nlat-l1-1))/2+nlon+15
c
C*PL*ERROR* Comment line too long
c     dwork  a double precision dwork array that does not have to be saved.
c
c     ldwork the dimension of the array dwork as it appears in the
c            program that calls shaeci.  ldwork  must be at least
c            nlat+1.
c
c
c     output parameters
c
c     wshaec an array which is initialized for use by subroutine shaec.
c            once initialized, wshaec can be used repeatedly by shaec
c            as long as nlon and nlat remain unchanged.  wshaec must
c            not be altered between calls of shaec.
c
c     ierror = 0  no errors
c            = 1  error in the specification of nlat
c            = 2  error in the specification of nlon
c            = 3  error in the specification of lshaec
c            = 4  error in the specification of ldwork
c
c
c *******************************************************************
      SUBROUTINE DSHAEC(NLAT,NLON,ISYM,NT,G,IDG,JDG,A,B,MDAB,NDAB,
     +                  WSHAEC,LSHAEC,WORK,LWORK,IERROR)
      DOUBLE PRECISION G
      DOUBLE PRECISION A
      DOUBLE PRECISION B
      DOUBLE PRECISION WSHAEC
      DOUBLE PRECISION WORK
      DIMENSION G(IDG,JDG,*),A(MDAB,NDAB,*),B(MDAB,NDAB,*),WSHAEC(*),
     +          WORK(*)

      IERROR = 1
      IF (NLAT.LT.3) RETURN
      IERROR = 2
      IF (NLON.LT.4) RETURN
      IERROR = 3
      IF (ISYM.LT.0 .OR. ISYM.GT.2) RETURN
      IERROR = 4
      IF (NT.LT.0) RETURN
      IERROR = 5
      IF ((ISYM.EQ.0.AND.IDG.LT.NLAT) .OR.
     +    (ISYM.NE.0.AND.IDG.LT. (NLAT+1)/2)) RETURN
      IERROR = 6
      IF (JDG.LT.NLON) RETURN
      IERROR = 7
      MMAX = MIN0(NLAT,NLON/2+1)
      IF (MDAB.LT.MMAX) RETURN
      IERROR = 8
      IF (NDAB.LT.NLAT) RETURN
      IERROR = 9
      IMID = (NLAT+1)/2
      LZZ1 = 2*NLAT*IMID
      LABC = 3* ((MMAX-2)* (NLAT+NLAT-MMAX-1))/2
      IF (LSHAEC.LT.LZZ1+LABC+NLON+15) RETURN
      IERROR = 10
      LS = NLAT
      IF (ISYM.GT.0) LS = IMID
      NLN = NT*LS*NLON
      IF (LWORK.LT.NLN+MAX0(LS*NLON,3*NLAT*IMID)) RETURN
      IERROR = 0
      IST = 0
      IF (ISYM.EQ.0) IST = IMID
      IW1 = LZZ1 + LABC + 1
      CALL DSHAEC1(NLAT,ISYM,NT,G,IDG,JDG,A,B,MDAB,NDAB,IMID,LS,NLON,
     +            WORK,WORK(IST+1),WORK(NLN+1),WORK(NLN+1),WSHAEC,
     +            WSHAEC(IW1))
      RETURN
      END
      SUBROUTINE DSHAEC1(NLAT,ISYM,NT,G,IDGS,JDGS,A,B,MDAB,NDAB,IMID,
     +                   IDG,JDG,GE,GO,WORK,ZB,WZFIN,WHRFFT)
      DOUBLE PRECISION G
      DOUBLE PRECISION A
      DOUBLE PRECISION B
      DOUBLE PRECISION GE
      DOUBLE PRECISION GO
      DOUBLE PRECISION WORK
      DOUBLE PRECISION ZB
      DOUBLE PRECISION WZFIN
      DOUBLE PRECISION WHRFFT
      DOUBLE PRECISION TSN
      DOUBLE PRECISION FSN
c
c     whrfft must have at least nlon+15 locations
c     wzfin must have 2*l*(nlat+1)/2 + ((l-3)*l+2)/2 locations
c     zb must have 3*l*(nlat+1)/2 locations
c     work must have ls*nlon locations
c
      DIMENSION G(IDGS,JDGS,1),A(MDAB,NDAB,1),B(MDAB,NDAB,1),
     +          GE(IDG,JDG,1),GO(IDG,JDG,1),ZB(IMID,NLAT,3),WZFIN(1),
     +          WHRFFT(1),WORK(1)

      LS = IDG
      NLON = JDG
      MMAX = MIN0(NLAT,NLON/2+1)
      MDO = MMAX
      IF (MDO+MDO-1.GT.NLON) MDO = MMAX - 1
      NLP1 = NLAT + 1
      TSN = 2.D0/NLON
      FSN = 4.D0/NLON
      MODL = MOD(NLAT,2)
      IMM1 = IMID
      IF (MODL.NE.0) IMM1 = IMID - 1
      IF (ISYM.NE.0) GO TO 15
      DO 5 K = 1,NT
          DO 5 I = 1,IMM1
              DO 5 J = 1,NLON
                  GE(I,J,K) = TSN* (G(I,J,K)+G(NLP1-I,J,K))
                  GO(I,J,K) = TSN* (G(I,J,K)-G(NLP1-I,J,K))
    5 CONTINUE
      GO TO 30
   15 DO 20 K = 1,NT
          DO 20 I = 1,IMM1
              DO 20 J = 1,NLON
                  GE(I,J,K) = FSN*G(I,J,K)
   20 CONTINUE
      IF (ISYM.EQ.1) GO TO 27
   30 IF (MODL.EQ.0) GO TO 27
      DO 25 K = 1,NT
          DO 25 J = 1,NLON
              GE(IMID,J,K) = TSN*G(IMID,J,K)
   25 CONTINUE
   27 DO 35 K = 1,NT
          CALL DHRFFTF(LS,NLON,GE(1,1,K),LS,WHRFFT,WORK)
          IF (MOD(NLON,2).NE.0) GO TO 35
          DO 36 I = 1,LS
              GE(I,NLON,K) = .5D0*GE(I,NLON,K)
   36     CONTINUE
   35 CONTINUE
      DO 40 K = 1,NT
          DO 40 MP1 = 1,MMAX
              DO 40 NP1 = MP1,NLAT
                  A(MP1,NP1,K) = 0.D0
                  B(MP1,NP1,K) = 0.D0
   40 CONTINUE
      IF (ISYM.EQ.1) GO TO 145
      CALL DZFIN(2,NLAT,NLON,0,ZB,I3,WZFIN)
      DO 110 K = 1,NT
          DO 110 I = 1,IMID
              DO 110 NP1 = 1,NLAT,2
                  A(1,NP1,K) = A(1,NP1,K) + ZB(I,NP1,I3)*GE(I,1,K)
  110 CONTINUE
      NDO = NLAT
      IF (MOD(NLAT,2).EQ.0) NDO = NLAT - 1
      DO 120 MP1 = 2,MDO
          M = MP1 - 1
          CALL DZFIN(2,NLAT,NLON,M,ZB,I3,WZFIN)
          DO 120 K = 1,NT
              DO 120 I = 1,IMID
                  DO 120 NP1 = MP1,NDO,2
                      A(MP1,NP1,K) = A(MP1,NP1,K) +
     +                               ZB(I,NP1,I3)*GE(I,2*MP1-2,K)
                      B(MP1,NP1,K) = B(MP1,NP1,K) +
     +                               ZB(I,NP1,I3)*GE(I,2*MP1-1,K)
  120 CONTINUE
      IF (MDO.EQ.MMAX .OR. MMAX.GT.NDO) GO TO 135
      CALL DZFIN(2,NLAT,NLON,MDO,ZB,I3,WZFIN)
      DO 130 K = 1,NT
          DO 130 I = 1,IMID
              DO 130 NP1 = MMAX,NDO,2
                  A(MMAX,NP1,K) = A(MMAX,NP1,K) +
     +                            ZB(I,NP1,I3)*GE(I,2*MMAX-2,K)
  130 CONTINUE
  135 IF (ISYM.EQ.2) RETURN
  145 CALL DZFIN(1,NLAT,NLON,0,ZB,I3,WZFIN)
      DO 150 K = 1,NT
          DO 150 I = 1,IMM1
              DO 150 NP1 = 2,NLAT,2
                  A(1,NP1,K) = A(1,NP1,K) + ZB(I,NP1,I3)*GO(I,1,K)
  150 CONTINUE
      NDO = NLAT
      IF (MOD(NLAT,2).NE.0) NDO = NLAT - 1
      DO 160 MP1 = 2,MDO
          M = MP1 - 1
          MP2 = MP1 + 1
          CALL DZFIN(1,NLAT,NLON,M,ZB,I3,WZFIN)
          DO 160 K = 1,NT
              DO 160 I = 1,IMM1
                  DO 160 NP1 = MP2,NDO,2
                      A(MP1,NP1,K) = A(MP1,NP1,K) +
     +                               ZB(I,NP1,I3)*GO(I,2*MP1-2,K)
                      B(MP1,NP1,K) = B(MP1,NP1,K) +
     +                               ZB(I,NP1,I3)*GO(I,2*MP1-1,K)
  160 CONTINUE
      MP2 = MMAX + 1
      IF (MDO.EQ.MMAX .OR. MP2.GT.NDO) RETURN
      CALL DZFIN(1,NLAT,NLON,MDO,ZB,I3,WZFIN)
      DO 170 K = 1,NT
          DO 170 I = 1,IMM1
              DO 170 NP1 = MP2,NDO,2
                  A(MMAX,NP1,K) = A(MMAX,NP1,K) +
     +                            ZB(I,NP1,I3)*GO(I,2*MMAX-2,K)
  170 CONTINUE
      RETURN
      END

      SUBROUTINE DSHAECI(NLAT,NLON,WSHAEC,LSHAEC,DWORK,LDWORK,IERROR)
      DOUBLE PRECISION WSHAEC
      DIMENSION WSHAEC(LSHAEC)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION DWORK(LDWORK)

      IERROR = 1
      IF (NLAT.LT.3) RETURN
      IERROR = 2
      IF (NLON.LT.4) RETURN
      IERROR = 3
      IMID = (NLAT+1)/2
      MMAX = MIN0(NLAT,NLON/2+1)
      LZZ1 = 2*NLAT*IMID
      LABC = 3* ((MMAX-2)* (NLAT+NLAT-MMAX-1))/2
      IF (LSHAEC.LT.LZZ1+LABC+NLON+15) RETURN
      IERROR = 4
      IF (LDWORK.LT.NLAT+1) RETURN
      IERROR = 0
      CALL DZFINIT(NLAT,NLON,WSHAEC,DWORK)
      IW1 = LZZ1 + LABC + 1
      CALL DHRFFTI(NLON,WSHAEC(IW1))
      RETURN
      END

      SUBROUTINE CGETRS( TRANS, N, NRHS, A, LDA, IPIV, B, LDB, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER          TRANS
      INTEGER            INFO, LDA, LDB, N, NRHS
*     ..
*     .. Array Arguments ..
      INTEGER            IPIV( * )
      COMPLEX            A( LDA, * ), B( LDB, * )
*     ..
*
*  Purpose
*  =======
*
*  CGETRS solves a system of linear equations
*     A * X = B,  A**T * X = B,  or  A**H * X = B
*  with a general N-by-N matrix A using the LU factorization computed
*  by CGETRF.
*
*  Arguments
*  =========
*
*  TRANS   (input) CHARACTER*1
*          Specifies the form of the system of equations:
*          = 'N':  A * X = B     (No transpose)
*          = 'T':  A**T * X = B  (Transpose)
*          = 'C':  A**H * X = B  (Conjugate transpose)
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  NRHS    (input) INTEGER
*          The number of right hand sides, i.e., the number of columns
*          of the matrix B.  NRHS >= 0.
*
*  A       (input) COMPLEX array, dimension (LDA,N)
*          The factors L and U from the factorization A = P*L*U
*          as computed by CGETRF.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(1,N).
*
*  IPIV    (input) INTEGER array, dimension (N)
*          The pivot indices from CGETRF; for 1<=i<=N, row i of the
*          matrix was interchanged with row IPIV(i).
*
*  B       (input/output) COMPLEX array, dimension (LDB,NRHS)
*          On entry, the right hand side matrix B.
*          On exit, the solution matrix X.
*
*  LDB     (input) INTEGER
*          The leading dimension of the array B.  LDB >= max(1,N).
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*
*  =====================================================================
*
*     .. Parameters ..
      COMPLEX            ONE
      PARAMETER          ( ONE = ( 1.0E+0, 0.0E+0 ) )
*     ..
*     .. Local Scalars ..
      LOGICAL            NOTRAN
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           CLASWP, CTRSM, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      NOTRAN = LSAME( TRANS, 'N' )
      IF( .NOT.NOTRAN .AND. .NOT.LSAME( TRANS, 'T' ) .AND. .NOT.
     $    LSAME( TRANS, 'C' ) ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( NRHS.LT.0 ) THEN
         INFO = -3
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -5
      ELSE IF( LDB.LT.MAX( 1, N ) ) THEN
         INFO = -8
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'CGETRS', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 .OR. NRHS.EQ.0 )
     $   RETURN
*
      IF( NOTRAN ) THEN
*
*        Solve A * X = B.
*
*        Apply row interchanges to the right hand sides.
*
         CALL CLASWP( NRHS, B, LDB, 1, N, IPIV, 1 )
*
*        Solve L*X = B, overwriting B with X.
*
         CALL CTRSM( 'Left', 'Lower', 'No transpose', 'Unit', N, NRHS,
     $               ONE, A, LDA, B, LDB )
*
*        Solve U*X = B, overwriting B with X.
*
         CALL CTRSM( 'Left', 'Upper', 'No transpose', 'Non-unit', N,
     $               NRHS, ONE, A, LDA, B, LDB )
      ELSE
*
*        Solve A**T * X = B  or A**H * X = B.
*
*        Solve U'*X = B, overwriting B with X.
*
         CALL CTRSM( 'Left', 'Upper', TRANS, 'Non-unit', N, NRHS, ONE,
     $               A, LDA, B, LDB )
*
*        Solve L'*X = B, overwriting B with X.
*
         CALL CTRSM( 'Left', 'Lower', TRANS, 'Unit', N, NRHS, ONE, A,
     $               LDA, B, LDB )
*
*        Apply row interchanges to the solution vectors.
*
         CALL CLASWP( NRHS, B, LDB, 1, N, IPIV, -1 )
      END IF
*
      RETURN
*
*     End of CGETRS
*
      END

      SUBROUTINE DPSIGMA(SIGMA,PSFC,MLON,NLAT,KLEV,PSIG)
      IMPLICIT NONE

c NCL: psig = pres_sigma (sigma,psfc)

c this routine interploates sigma to pressure coordinates.
c .   analogous to pres_hybrid_ccm

c     formula for the pressure of a sigma surface is;
c          psig(k,lat,lon) = sigma(k)*psfc(lat,lon)
c          psig(time,k,lat,lon) = sigma(k)*psfc(time,lat,lon)

c     input
c          sigma  - is the sigma coeficient
c          psfc   - is the surface pressure in pascals
c          mlon   - longitude dimension
c          nlat   - latitude  dimension
c          klev   - number of levels
c     output
c          psig   - pressure at sigma levels
c                                               INPUT
      INTEGER MLON,NLAT,KLEV
      DOUBLE PRECISION SIGMA(KLEV),PSFC(MLON,NLAT)
c                                               OUTPUT
      DOUBLE PRECISION PSIG(MLON,NLAT,KLEV)

      INTEGER KL,NL,ML

      DO KL = 1,KLEV
          DO NL = 1,NLAT
              DO ML = 1,MLON
                  PSIG(ML,NL,KL) = SIGMA(KL)*PSFC(ML,NL)
              END DO
          END DO
      END DO

      RETURN
      END

C
C $Id: llmap.f,v 1.1 2009-05-15 00:49:27 dbrown Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MAPBD
C
C Calling this do-nothing subroutine forces "ld" to load the following
C block data routine (but only if they are in the same ".f" file).
C
        RETURN
C
      END
CNOSPLIT
      BLOCKDATA MAPBDX
C
        PARAMETER (MNAI=6000)
C
C The common block MAPCM0 contains mathematical constants.
C
        COMMON /MAPCM0/  COS1,DTOR,DTRH,OOPI,PI,PIOT,RTDD,RTOD,SIN1,TOPI
        DOUBLE PRECISION COS1,DTOR,DTRH,OOPI,PI,PIOT,RTDD,RTOD,SIN1,TOPI
        SAVE   /MAPCM0/
C
C The common block MAPCM1 contains transformation constants.
C
        COMMON /MAPCM1/  COSO,COSR,PHOC,SINO,SINR,IPRJ,IROD
        DOUBLE PRECISION COSO,COSR,PHOC,SINO,SINR
        INTEGER          IPRJ,IROD
        SAVE   /MAPCM1/
C
C The common block MAPCM2 contains area-specification variables.
C
        COMMON /MAPCM2/  BLAM,BLOM,PEPS,SLAM,SLOM,UCEN,UMAX,UMIN,UOFF,
     +                   URNG,VCEN,VMAX,VMIN,VOFF,VRNG,ISSL
        DOUBLE PRECISION BLAM,BLOM,PEPS,SLAM,SLOM,UCEN,UMAX,UMIN,UOFF,
     +                   URNG,VCEN,VMAX,VMIN,VOFF,VRNG
        INTEGER          ISSL
        SAVE   /MAPCM2/
C
C The common block MAPCM3 contains parameters having to do with reading
C the data for outlines.
C
        COMMON /MAPCM3/  ITPN,NOUT,NPTS,IGID,IDLS,IDRS,BLAG,SLAG,BLOG,
     +                   SLOG,PNTS(200),IDOS(4)
        INTEGER          ITPN,NOUT,NPTS,IGID,IDLS,IDRS,IDOS
        REAL             BLAG,SLAG,BLOG,SLOG,PNTS
        SAVE   /MAPCM3/
C
C The common block MAPCM4 contains most of the input parameters.
C
        COMMON /MAPCM4/  GRDR,GRID,GRLA,GRLO,GRPO,OTOL,PHIA,PHIO,PLA1,
     +                   PLA2,PLA3,PLA4,PLB1,PLB2,PLB3,PLB4,PLTR,ROTA,
     +                   SRCH,XLOW,XROW,YBOW,YTOW,IDOT,IDSH,IDTL,ILCW,
     +                   ILTS,JPRJ,ELPF,INTF,LBLF,PRMF
        DOUBLE PRECISION GRDR,GRID,GRLA,GRLO,GRPO,OTOL,PHIA,PHIO,PLA1,
     +                   PLA2,PLA3,PLA4,PLB1,PLB2,PLB3,PLB4,PLTR,ROTA,
     +                   SRCH,XLOW,XROW,YBOW,YTOW
        INTEGER          IDOT,IDSH,IDTL,ILCW,ILTS,JPRJ
        LOGICAL          ELPF,INTF,LBLF,PRMF
        SAVE   /MAPCM4/
C
C The common block MAPCM5 contains various lists ("dictionaries") of
C two-character codes required by EZMAP for parameter-setting.
C
        COMMON /MAPCM5/  DDCT(5),DDCL(5),LDCT(6),LDCL(6),PDCT(12),
     +                   PDCL(12)
        CHARACTER*2      DDCT,DDCL,LDCT,LDCL,PDCT,PDCL
        SAVE   /MAPCM5/
C
C The common block MAPCM6 contains quantities needed by the routines
C MDPTRA and MDPTRI.
C
        COMMON /MAPCM6/  UCNM,UMNM,UMXM,URNM,VCNM,VMNM,VMXM,VRNM,ELPM
        DOUBLE PRECISION UCNM,UMNM,UMXM,URNM,VCNM,VMNM,VMXM,VRNM
        LOGICAL ELPM
        SAVE   /MAPCM6/
C
C The common block MAPCM7 contains parameters describing the portion of
C the plotter frame being used.
C
        COMMON /MAPCM7/  ULOW,UROW,VBOW,VTOW
        DOUBLE PRECISION ULOW,UROW,VBOW,VTOW
        SAVE   /MAPCM7/
C
C The common block MAPCM8 contains parameters set by MDPTRN and used by
C MAPIT in handling "cross-over" problems.
C
        COMMON /MAPCM8/  P,Q,R
        DOUBLE PRECISION P,Q,R
        SAVE   /MAPCM8/
C
C The common block MAPCMA contains values which are used to position
C dots along dotted outlines and to avoid drawing vectors which are
C too short.
C
        COMMON /MAPCMA/  DATL,DBTD,DDTS,DPLT,DPSQ,DSCA,DSSQ
        DOUBLE PRECISION DATL,DBTD,DDTS,DPLT,DPSQ,DSCA,DSSQ
        SAVE   /MAPCMA/
C
C The common block MAPCMC contains variables for MDPBLA.
C
        COMMON /MAPCMC/  IGI1,IGI2,NCRA,NOVS,XCRA(100),YCRA(100)
        INTEGER          IGI1,IGI2,NCRA,NOVS
        REAL             XCRA,YCRA
        SAVE   /MAPCMC/
C
C The common block MAPCMP contains the buffers in which the X and Y
C coordinates of points are collected for an eventual call to POINTS.
C
        COMMON /MAPCMP/  NPTB,XPTB(50),YPTB(50)
        INTEGER          NPTB
        REAL             XPTB,YPTB
        SAVE   /MAPCMP/
C
C The common block MAPCMQ contains quantities specifying the color
C indices to be used for various portions of the plot.
C
        COMMON /MAPCMQ/  ICIN(8)
        INTEGER          ICIN
        SAVE   /MAPCMQ/
C
C The common blocks MAPCMX and MAPCMY contain variables used by the new
C routines in EZMAPB (implementing access to the new dataset created in
C early 1998).  MAPCMX contains integer variables and MAPCMY contains
C character variables.
C
        COMMON /MAPCMX/  IATY(MNAI),ISCI(MNAI),IPAR(MNAI)
        INTEGER          IATY,ISCI,IPAR
        SAVE   /MAPCMX/
C
        COMMON /MAPCMY/  NAME(MNAI),FLNS
        CHARACTER*64     NAME,FLNS
        SAVE   /MAPCMY/
C
C The common block MAPRGD contains two arrays of color indices and
C a couple of point-interpolation values used by the routines that plot
C data from the RANGS/GSHHS dataset.
C
        COMMON /MAPRGD/  ICOL(5),ICSF(5),IDPF,LCRA,NILN,NILT,OLAT,OLON
        INTEGER          ICOL,ICSF,IDPF,LCRA,NILN,NILT
        REAL             OLAT,OLON
        SAVE   /MAPRGD/
C
C The common block MAPSAT contains parameters for the satellite-view
C projection.
C
        COMMON /MAPSAT/  ALFA,BETA,DCSA,DCSB,DSNA,DSNB,SALT,SSMO,SRSS
        DOUBLE PRECISION ALFA,BETA,DCSA,DCSB,DSNA,DSNB,SALT,SSMO,SRSS
        SAVE   /MAPSAT/
C
C Below are descriptions of the variables in each of the common blocks,
C together with data statements giving default values to those variables
C which need default variables.
C
C Variables in MAPCM0:
C
        DATA COS1 / .999847695156390D0 /  !  COSINE OF 1 DEGREE
        DATA DTOR / .017453292519943D0 /  !  DEGREES TO RADIANS
        DATA DTRH / .008726646259971D0 /  !  DEGREES TO RADIANS, HALVED
        DATA OOPI / .318309886183790D0 /  !  ONE OVER PI
        DATA PI   / 3.14159265358979D0 /  !  PI
        DATA PIOT / 1.57079632679489D0 /  !  PI OVER TWO
        DATA RTDD / 114.591559026165D0 /  !  RADIANS TO DEGREES, DOUBLED
        DATA RTOD / 57.2957795130823D0 /  !  RADIANS TO DEGREES
        DATA SIN1 / .017452406437283D0 /  !  SINE OF 1 DEGREE
        DATA TOPI / .636619772367581D0 /  !  TWO OVER PI
C
C Variables in MAPCM1:
C
C IPRJ is an integer between 0 and 14, specifying what projection is
C currently in use.  The values 11, 12, 13, and 14 specify fast-path
C versions of the values 7, 8, 9, and 10, respectively.  The meanings
C of the various possible values of IPRJ are as follows:
C
C     IPRJ    Projection Selected                    Type
C     ----    -----------------------------------    -----------
C       0     USGS transformations                   Various
C       1     Lambert Conformal                      Conical
C       2     Stereographic                          Azimuthal
C       3     Orthographic (or Satellite)            Azimuthal
C       4     Lambert Equal-Area                     Azimuthal
C       5     Gnomonic                               Azimuthal
C       6     Azimuthal Equidistant                  Azimuthal
C       7     Cylindrical Equidistant (arbitrary)    Cylindrical
C       8     Mercator (arbitrary)                   Cylindrical
C       9     Mollweide (arbitrary)                  Cylindrical
C      10     Robinson (arbitrary)                   Cylindrical
C      11     Cylindrical Equidistant (fast-path)    Cylindrical
C      12     Mercator (fast-path)                   Cylindrical
C      13     Mollweide (fast-path)                  Cylindrical
C      14     Robinson (fast-path)                   Cylindrical
C
C PHOC is just a copy of PHIO, from the common block MAPCM4.  IROD is
C a flag which, if non-zero, says that we have to use double precision
C at selected points.  SINO, COSO, SINR, and COSR are projection
C variables computed by MDPINT for use by MDPTRN.
C
      DATA IROD / 0 /
C
C Variables in MAPCM2:
C
C UMIN, UMAX, VMIN, and VMAX specify the limits of the rectangle to be
C drawn, in projection space.  UCEN, VCEN, URNG, and VRNG are computed
C by MDPINT for use when the map perimeter is made elliptical (by
C setting the flag ELPF).  BLAM, SLAM, BLOM, and SLOM are respectively
C the biggest latitude, the smallest latitude, the biggest longitude,
C and the smallest longitude on the map.  They are used in MDPGRD and
C in MDPLOT to make the drawing of grids and outlines more efficient.
C ISSL is a flag set by MDPINT to indicate the success (ISSL=1) or
C failure (ISSL=0) of the code setting BLAM, SLAM, BLOM, and SLOM;
C failure indicates that default values were used and that it is not
C safe to take the efficient paths in MDPGRD.  PEPS is set by MDPINT
C for use in MAPIT in testing for cross-over problems.  UMIN and UMAX
C are given default values to prevent code in MDSETI and MDSETR from
C blowing up when PLTR is set prior to the first call to MDPINT.
C (08/07/2001) UOFF and VOFF are being added to this common block to
C support the use of U/V coordinates from which an offset has been
C subtracted to avoid loss of resolution when zooming in on a small
C portion of a projection.
C
      DATA UMIN,UMAX / 0.D0,1.D0 /
C
C Variables in MAPCM3:
C
C ITPN is the unit number of the "tape" from which outline data is to
C be read.  NOUT is the number of the outline to be used; the values 0
C through 5 imply 'NO', 'CO', 'US', 'PS', and 'PO', respectively; thus,
C if NOUT is zero, no outlines are to be used, and, if it is non-zero,
C it is the number of the "file" to be read from unit ITPN.  NPTS, just
C after a read, is the number of elements read into PNTS; it is then
C divided by 2 to become the number of points defined by the group just
C read.  IGID is an identifier for the group, so that, for example, one
C can distinguish a group belonging to a international boundary from
C one belonging to a U.S. state boundary.  IDLS and IDRS are integers
C identifying the areas to the left and right of the edge defined by
C the group of points just read.  BLAG, SLAG, BLOG, and SLOG specify
C the biggest and smallest latitude and the biggest and smallest
C longitude of the points in the group, so that, in some cases at least,
C one can decide quickly not to bother with the group.  PNTS contains
C NPTS coordinate pairs, each consisting of a latitude and a longitude,
C in degrees.  IDOS is an array of area-identifier offsets; for a given
C EZMAP dataset with index NOUT, the area identifiers in the dataset
C are biased by the addition of IDOS(NOUT) in order to generate a
C unique value.
C
      DATA ITPN,NOUT / 1,1 /
C
      DATA IDOS / 0,222,439,1003 /
C
C Variables in MAPCM4:
C
C INTF is a flag whose value at any given time indicates whether the
C package EZMAP is in need of initialization (.TRUE.) or not (.FALSE.).
C JPRJ is an integer between 0 and 10 indicating the type of projection
C currently in use.  PHIA, PHIO, and ROTA are the pole latitude and
C longitude and the rotation angle specified by the last user call to
C MAPROJ.  ILTS is an integer between 1 and 6, specifying how the limits
C of the map are to be chosen.  PLA1-4 and PLB1-4 are the values given
C by the user for PLM1(1), PLM2(1), ..., PLM1(2), PLM2(2), ..., in the
C last call to MAPSET.  PLTR is the plotter resolution - effectively,
C the number of addressable points in the x direction.  GRID, if zero,
C turns off the drawing of the lat/lon grid; if non-zero, it specifies
C the desired default spacing between grid lines, in degrees.  IDSH is
C the desired dash pattern (16-bit binary) for grid lines.  IDOT is a
C flag selecting solid outlines (0) or dotted outlines (1).  LBLF is
C a logical flag indicating whether the international date line, the
C equator, the Greenwich meridian, and the poles are to be labelled or
C not.  PRMF is a logical flag indicating whether or not a perimeter
C is to be drawn.  ELPF is a logical flag indicating whether the map
C perimeter is to be rectangular (.FALSE.) or elliptical (.TRUE.).
C XLOW, XROW, YBOW, and YTOW are fractions between 0. and 1. specifying
C the position of area of the plotter frame in which the map is to be
C put; the map is centered in this area and made as large as possible.
C IDTL is a flag specifying that MAPIT should draw solid outlines (0)
C or dotted outlines (1).  GRDR and SRCH are measured in degrees and
C lie in the range from .001 to 10.  GRDR specifies the resolution with
C which the grid is to be drawn and SRCH the accuracy with which the
C latitude/longitude limits of the map are to be found.  ILCW is the
C character width for characters in the label, as required for use in a
C call to PWRIT.  GRLA and GRLO specify the desired spacings of latitude
C and longitude grid lines, respectively (in degrees); if either is less
C than or equal to zero, the value of GRID is used instead.  GRPO
C specifies the way in which the lat/lon grid is to be modified near
C the poles on projections which map the poles into single points; it
C has a value of the form 1000*GRP1+GRP2, where GRP1 is an integer
C between 0 and 90 and GRP2 is a positive real between 0 and 360.  If
C GRP1 is zero, all the latitude lines of the grid are drawn; if GRP1
C is non-zero, latitude lines at latitudes from GRP1 to 90, inclusive
C (South or North) are omitted.   If GRP2 is zero, no longitude lines
C are drawn near the poles; if GRP2 is non-zero, only longitude lines
C of the grid at multiples of GRP2 are drawn near the poles.  Examples:
C GRPO=0 says "draw all the latitude lines of the grid; omit longitude
C lines of the grid near the poles."  GRPO=1 says "draw entire grid."
C GRPO=75045 says "suppress latitude lines of the grid above 75N and
C below 75S; near the poles, draw longitude lines of the grid only at
C multiples of 45 degrees."  The default is GRPO=90, which says "draw
C all latitude lines of the grid; near the poles, omit longitude lines
C of the grid except those at multiples of 90 degrees".  OTOL is an
C "offset tolerance" (new in 08/08/2001): when the absolute value of the
C difference of the U values at the left and right edges of a map is
C less than OTOL times the absolute value of their sum, or the absolute
C value of the difference of the V values at the bottom and top edges of
C a map is less than OTOL times the absolute value of their sum, MDPINT
C will initialize the projection to use offset values of U and V, thus
C avoiding a loss of precision.
C
      DATA INTF,JPRJ,PHIA,PHIO,ROTA,ILTS,PLA1,PLA2,PLA3,PLA4,PLB1,PLB2 /
     1   .TRUE.,   7,0.D0,0.D0,0.D0,   1,0.D0,0.D0,0.D0,0.D0,0.D0,0.D0 /
C
      DATA PLB3,PLB4,    PLTR, GRID, IDSH,IDOT, LBLF , PRMF ,  ELPF  /
     1     0.D0,0.D0,32768.D0,10.D0,21845,   0,.TRUE.,.TRUE.,.FALSE. /
C
      DATA IDTL,  OTOL /
     1        0,.001D0 /
C
      DATA XLOW,XROW,YBOW,YTOW / .05D0,.95D0,.05D0,.95D0 /
C
      DATA GRDR,SRCH / 1.D0,1.D0 /
C
      DATA ILCW / 1 /
C
      DATA GRLA,GRLO,GRPO / 0.D0,0.D0,90.D0 /
C
C Variables in MAPCM5:
C
C DDCT is the dictionary of available datasets, LDCT the dictionary of
C map limit definition types, and PDCT the dictionary of map projection
C names.  DDCL, LDCL, and PDCL are lower-case equivalents.
C
      DATA DDCT
     +        / 'NO','CO','US','PS','PO' /
      DATA DDCL
     +        / 'no','co','us','ps','po' /
C
      DATA LDCT
     +        / 'MA','CO','PO','AN','LI','GR' /
      DATA LDCL
     +        / 'ma','co','po','an','li','gr' /
C
      DATA PDCT
     +   / 'UT','LC','ST','OR','LE','GN','AE','CE','ME','MO','RO','SV' /
      DATA PDCL
     +   / 'ut','lc','st','or','le','gn','ae','ce','me','mo','ro','sv' /
C
C Variables in MAPCM6:
C
C All of the variables in this common block are basically copies of
C variables in other common blocks (perhaps somewhat modified) for use
C by transformation routines.  ELPM is a copy of the logical variable
C ELPF, which indicates whether the map perimeter is to be rectangular
C or elliptical.  UMNM, UMXM, UMXM, and VMNM specify a rectangular
C perimeter just a little outside the one specified by UMIN, UMAX, VMIN,
C and VMAX.  UCNM, VCNM, URNM, and VRNM are just copies of the values
C UCEN, VCEN, URNG, and VRNG, respectively; they are used when the map
C perimeter is elliptical.  None of these parameters needs a default
C value.
C
C Variables in MAPCM7:
C
C ULOW, UROW, VBOW, and VTOW define the fraction of the plotter frame
C to be occupied by the map - they may be thought of as the first four
C arguments of the SET call or, in the GKS scheme, as the viewport.
C They are computed by MDPINT.  ULOW and UROW are given default values
C to prevent code in MDSETI and MDSETR from blowing up when PLTR is
C set prior to the first call to MDPINT.
C
      DATA ULOW,UROW / 0.D0,1.D0 /
C
C Variables in MAPCM8:
C
C P, Q, and R are set by MDPTRN each time it maps (RLAT,RLON) to (U,V).
C Q is always equal to V, but P is not always equal to U.  Instead, it
C is a value of U from an intermediate step in the projection process.
C For the Lambert conformal conic, P is the distance, in longitude, from
C the central meridian.  For the cylindrical projections, P is a value
C of U prior to multiplication by a function of V shrinking the map
C toward a vertical bisector.  They are all used by MAPIT, while drawing
C lines from point to point, to detect "cross-over" (a jump from one
C side of the map to the other, caused by the projection's having slit
C the globe along some half of a great circle and laid it open with the
C two sides of the slit at opposite ends of the map).
C
C Variables in MAPCMA:
C
C DPLT is the mimimum vector length; MAPIT requires two points to be at
C least DPLT plotter units apart before it will join them with a vector.
C DDTS is the desired distance in plotter units between dots in a dotted
C outline.  These values are relative to the "plotter resolution" PLTR;
C DPLT/PLTR is a fraction of the plotter frame.  DSCA is the ratio of
C the length of a vector, measured in plotter units, to the length of
C the same vector, measured in the u/v plane.  Thus, given a vector of
C length D in the u/v plane, D*DSCA is its length in plotter units.
C DPSQ and DSSQ are the squares of DPLT and DSCA, respectively.  DBTD
C is the distance, in the u/v plane, between two dots DDTS plotter
C units apart.  DPLT and DDTS have the values given below and are not
C reset by the code; DSCA, DPSQ, DSSQ, and DBTD are computed by MDPINT.
C DSCA is given a default value only to keep the routines MDSETI and
C MDSETR from blowing up when DDTS is set prior to any call to MDPINT.
C DATL is used by MAPIT and MDPVP to keep track of where the next point
C along a curve should go.
C
      DATA DPLT,DDTS,DSCA / 1.D0,96.D0,1.D0 /
C
C Variables in MAPCMC:
C
C IGI1 is the group identifier for the principal edge group - the one
C containing all the real map boundaries.  IGI2 is the group identifier
C for the dummy group that splits the map into vertical strips.  NOVS
C is the number of vertical strips to be used.  XCRA and YCRA hold X
C and Y coordinates for delivery to AREDAM.  NCRA is the number of
C coordinates in XCRA and YCRA.
C
      DATA IGI1,IGI2,NOVS,NCRA / 1,2,1,0 /
C
C Variables in MAPCMP:
C
C NPTB is the number of points whose coordinates have been collected in
C the arrays XPTB and YPTB for eventual output by a call to POINTS.
C
      DATA NPTB / 0 /
C
C Variables in MAPCMQ:
C
C The array ICIN specifies color indices to be used for the perimeter,
C for the grid, for labelling, for limbs, for the continental outlines,
C for the U.S. state outlines, and for international political outlines.
C See the routine MDPCHI.  The default values are all negative, to say
C that color should not be set.
C
      DATA ICIN / -1,-1,-1,-1,-1,-1,-1,-1 /
C
C Variables in MAPCMX and MAPCMY:
C
C For each I from 1 to MNAI, IATY(I), if non-zero, is the type of the
C area with area identifier I, ISCI(I) is a suggested color index for
C that area, IPAR(I) is the index of the parent area, and NAME(I) is
C the name of the area.  FLNS is the full name of the file from which
C the data in IATY, ISCI, IPAR, and NAME were read; it allows us to
C avoid re-reading the data when that isn't necessary.
C
      DATA (IATY(I),I=1,MNAI) / MNAI*0   /
      DATA (ISCI(I),I=1,MNAI) / MNAI*0   /
      DATA (IPAR(I),I=1,MNAI) / MNAI*0   /
      DATA (NAME(I),I=1,MNAI) / MNAI*' ' /
C
      DATA FLNS / ' ' /
C
C Variables in MAPRGD:
C
C The array ICOL contains five color indices to be used in drawing
C the outlines of polygons of the five different types defined by the
C RANGS/GSHHS data, and the array ICSF contains five color indices to
C be used in filling the polygons.  The routine MDRGSC may be called
C by the user to set these colors and the routine MDRGGC may be called
C to retrieve them.  The indices of each of these arrays are assigned
C to features as follows: 1 => ocean; 2 => land; 3 => lake; 4 =>
C island in lake; and 5 => pond on island.  NILN and NILT determine
C how many points are to be interpolated per degree of longitude or
C degree of latitude, respectively, along those parts of the filled
C polygons lying along the edges of 1-degree cells.  The object of this
C interpolation is to reduce the probability of having little gaps
C along the seams between adjacent cells.  (If it is not done and a
C projection is used that maps the 1-degree cells into patches whose
C edges are neither horizontal nor vertical, the gaps can be quite
C noticeable.)  OLAT and OLON are temporary variables in which some
C values are passed from MPRGSX to MPRGFA; they do not need to be
C initialized.  IDPF is a flag indicating how the RANGS/GSHHS data
C to be processed.  IDPF = 0 means that the data are to be used in
C are unedited form (MDRGSQ is called).  IDPF = 1 means that the data
C are to be edited and that polygon fills are to be done using direct
C calls to GFA, without using an area map (MDRGSX is called).  IDPF =
C 2 means that the data are to be edited and that fills are to be done
C using an area map (MDRGSX is called).
C
      DATA ICOL / 1 , 1 , 1 , 1 , 1 /
      DATA ICSF / 0 , 1 , 0 , 1 , 0 /
C
      DATA IDPF / 1 /
C
      DATA NILN,NILT / 50 , 50 /
C
C Variables in MAPSAT:
C
C The absolute value of SALT, if greater than 1, serves as a flag that
C a satellite-view projection is to be used in place of an orthographic
C projection; its value is the distance of the satellite from the center
C of the earth, in units of earth radii.  In this case, SSMO is the
C square of SALT minus 1 and SRSS is the square root of SSMO.  If ALFA
C is zero, the projection shows the view seen by a satellite looking
C straight at the center of the earth; call this the basic satellite
C view.  If ALFA is non-zero, it and BETA are angles, in degrees,
C determining where the line of sight of the projection is.  If E is
C at the center of the earth, S is at the satellite, and P is a point
C along the line of sight, then ALFA measures the angle ESP.  If O is
C the point at the origin of the basic satellite view and P is the
C projection of the line of sight, then BETA measures the angular
C distance from the positive u axis to the line OP, positive if
C measured counter-clockwise.  DSNA, DCSA, DSNB, and DCSB are sines
C and cosines of ALFA and BETA.  The sign of SALT says whether a normal
C projection (positive) or an extended projection (negative) is to be
C used.  The latter makes it easier to overlay CONREC output on one of
C these projections, by projecting points out of sight around the limb
C to point just outside the limb on the projected view.
C
      DATA SALT,ALFA,BETA / 0.D0,0.D0,0.D0 /
C
      DATA DSNA,DCSA,DSNB,DCSB / 0.D0,1.D0,0.D0,1.D0 /
C
      END
C
C $Id: llmap.f,v 1.1 2009-05-15 00:49:27 dbrown Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MAPPOS (ARG1,ARG2,ARG3,ARG4)
        REAL ARG1,ARG2,ARG3,ARG4
        IF (ICFELL('MAPPOS - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
        CALL MDPPOS (DBLE(ARG1),DBLE(ARG2),DBLE(ARG3),DBLE(ARG4))
        IF (ICFELL('MAPPOS',2).NE.0) RETURN
        RETURN
      END
C
C $Id: llmap.f,v 1.1 2009-05-15 00:49:27 dbrown Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MAPROJ (ARG1,ARG2,ARG3,ARG4)
        CHARACTER*(*) ARG1
        REAL          ARG2,ARG3,ARG4
        IF (ICFELL('MAPROJ - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
        CALL MDPROJ (ARG1,DBLE(ARG2),DBLE(ARG3),DBLE(ARG4))
        IF (ICFELL('MAPROJ',2).NE.0) RETURN
        RETURN
      END
C
C $Id: llmap.f,v 1.1 2009-05-15 00:49:27 dbrown Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MAPSET (ARG1,ARG2,ARG3,ARG4,ARG5)
        CHARACTER*(*) ARG1
        REAL          ARG2(2),ARG3(2),ARG4(2),ARG5(2)
        DOUBLE PRECISION DRG2(2),DRG3(2),DRG4(2),DRG5(2)
        DRG2(1)=DBLE(ARG2(1))
        DRG2(2)=DBLE(ARG2(2))
        DRG3(1)=DBLE(ARG3(1))
        DRG3(2)=DBLE(ARG3(2))
        DRG4(1)=DBLE(ARG4(1))
        DRG4(2)=DBLE(ARG4(2))
        DRG5(1)=DBLE(ARG5(1))
        DRG5(2)=DBLE(ARG5(2))
        CALL MDPSET (ARG1,DRG2,DRG3,DRG4,DRG5)
        IF (ICFELL('MAPSET',2).NE.0) RETURN
        RETURN
      END
C
C $Id: llmap.f,v 1.1 2009-05-15 00:49:27 dbrown Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MAPTRA (RLAT,RLON,UVAL,VVAL)
        REAL   RLAT,RLON,UVAL,VVAL
        DOUBLE PRECISION DUVL,DVVL
        IF (ICFELL('MAPTRA - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
        CALL MDPTRA (DBLE(RLAT),DBLE(RLON),DUVL,DVVL)
        IF (ICFELL('MAPTRA',2).NE.0) RETURN
        IF (DUVL.NE.1.D12) THEN
          UVAL=REAL(DUVL)
          VVAL=REAL(DVVL)
        ELSE
          UVAL=1.E12
          VVAL=1.E12
        END IF
        RETURN
      END
C
C $Id: llmap.f,v 1.1 2009-05-15 00:49:27 dbrown Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MAPTRI (UVAL,VVAL,RLAT,RLON)
        REAL   UVAL,VVAL,RLAT,RLON
        DOUBLE PRECISION DLAT,DLON
        IF (ICFELL('MAPTRI - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
        CALL MDPTRI (DBLE(UVAL),DBLE(VVAL),DLAT,DLON)
        IF (ICFELL('MAPTRI',2).NE.0) RETURN
        IF (DLAT.NE.1.D12) THEN
          RLAT=REAL(DLAT)
          RLON=REAL(DLON)
        ELSE
          RLAT=1.E12
          RLON=1.E12
        END IF
        RETURN
      END
C
C $Id: llmap.f,v 1.1 2009-05-15 00:49:27 dbrown Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MAPTRN (RLAT,RLON,UVAL,VVAL)
        REAL   RLAT,RLON,UVAL,VVAL
        DOUBLE PRECISION DUVL,DVVL
        IF (ICFELL('MAPTRN - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
        CALL MDPTRN (DBLE(RLAT),DBLE(RLON),DUVL,DVVL)
        IF (ICFELL('MAPTRN',2).NE.0) RETURN
        IF (DUVL.NE.1.D12) THEN
          UVAL=REAL(DUVL)
          VVAL=REAL(DVVL)
        ELSE
          UVAL=1.E12
          VVAL=1.E12
        END IF
        RETURN
      END
C
C $Id: llmap.f,v 1.1 2009-05-15 00:49:27 dbrown Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MDPCEM (IEM1,IEM2,IERR,IFLG)
C
        CHARACTER*(*) IEM1,IEM2
        INTEGER       IERR,IFLG
C
C MDPCEM is called to do a call to SETER when the error message to be
C printed is in two parts which need to be concatenated.  FORTRAN-77
C rules make it necessary to concatenate the two parts of the message
C into a local character variable.
C
        CHARACTER*100 IEMC
C
        IEMC=IEM1//IEM2
        CALL SETER (IEMC,IERR,IFLG)
C
        RETURN
C
      END
C
C $Id: llmap.f,v 1.1 2009-05-15 00:49:27 dbrown Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MDPIN1
C
C Declare required common blocks.  See MAPBDX for descriptions of these
C common blocks and the variables in them.
C
        COMMON /MAPCM0/  COS1,DTOR,DTRH,OOPI,PI,PIOT,RTDD,RTOD,SIN1,TOPI
        DOUBLE PRECISION COS1,DTOR,DTRH,OOPI,PI,PIOT,RTDD,RTOD,SIN1,TOPI
        SAVE   /MAPCM0/
C
        COMMON /MAPCM1/  COSO,COSR,PHOC,SINO,SINR,IPRJ,IROD
        DOUBLE PRECISION COSO,COSR,PHOC,SINO,SINR
        INTEGER          IPRJ,IROD
        SAVE   /MAPCM1/
C
        COMMON /MAPCM4/  GRDR,GRID,GRLA,GRLO,GRPO,OTOL,PHIA,PHIO,PLA1,
     +                   PLA2,PLA3,PLA4,PLB1,PLB2,PLB3,PLB4,PLTR,ROTA,
     +                   SRCH,XLOW,XROW,YBOW,YTOW,IDOT,IDSH,IDTL,ILCW,
     +                   ILTS,JPRJ,ELPF,INTF,LBLF,PRMF
        DOUBLE PRECISION GRDR,GRID,GRLA,GRLO,GRPO,OTOL,PHIA,PHIO,PLA1,
     +                   PLA2,PLA3,PLA4,PLB1,PLB2,PLB3,PLB4,PLTR,ROTA,
     +                   SRCH,XLOW,XROW,YBOW,YTOW
        INTEGER          IDOT,IDSH,IDTL,ILCW,ILTS,JPRJ
        LOGICAL          ELPF,INTF,LBLF,PRMF
        SAVE   /MAPCM4/
C
        COMMON /MAPSAT/  ALFA,BETA,DCSA,DCSB,DSNA,DSNB,SALT,SSMO,SRSS
        DOUBLE PRECISION ALFA,BETA,DCSA,DCSB,DSNA,DSNB,SALT,SSMO,SRSS
        SAVE   /MAPSAT/
C
C Set up alternate names for a couple of variables in common.
C
        DOUBLE PRECISION FLT1,FLT2
        EQUIVALENCE      (PHIA,FLT1),(ROTA,FLT2)
C
C Declare local variables.
C
        DOUBLE PRECISION CHI1,CHI2,COST,SINT,TMP1,TMP2
        REAL             TST1,TST2,TST3
C
C Do a call forcing a BLOCKDATA to be loaded from a binary library.
C
        CALL MAPBD
C
C Decide whether MAPTRN should use real or double-precision arithmetic.
C The subroutine call is necessary to fool some compilers into storing
C TST1, TST2, and TST3; otherwise, real precision may be used on
C machines on which double precision is necessary.  NOTE: As of 07/2001,
C double precision is being used everywhere except in the USGS routines,
C so the flag IROD is not as important as it was prior to that time.
C
        CALL MDPIN2 (TST1,TST2,TST3)
C
        IF (TST1.NE.TST2.AND.TST2.NE.TST3) THEN
          IROD=0
        ELSE
          IROD=1
        END IF
C
C IPRJ equals JPRJ until we find out if fast-path projections are to be
C used.  PHOC is just a copy of PHIO.
C
        IPRJ=JPRJ
        PHOC=PHIO
C
        IF (IPRJ.EQ.1) THEN
C
C Compute quantities required for the Lambert conformal conic.
C
          SINO=SIGN(1.D0,.5D0*(FLT1+FLT2))
          CHI1=(90.D0-SINO*FLT1)*DTOR
C
          IF (FLT1.EQ.FLT2) THEN
            COSO=COS(CHI1)
          ELSE
            CHI2=(90.D0-SINO*FLT2)*DTOR
            COSO=LOG(SIN(CHI1)/SIN(CHI2))/
     +           LOG(TAN(.5D0*CHI1)/TAN(.5D0*CHI2))
          END IF
C
        ELSE
C
C Compute quantities required for all the other projections.
C
          TMP1=ROTA*DTOR
          TMP2=PHIA*DTOR
          SINR=SIN(TMP1)
          COSR=COS(TMP1)
          SINO=SIN(TMP2)
          COSO=COS(TMP2)
C
C Compute constants required only by the cylindrical projections.
C
          IF (IPRJ.GE.7) THEN
C
C See if fast-path transformations can be used (PLAT=0, ROTA=0 or 180).
C
            IF (ABS(PHIA).GE..000001D0.OR.(ABS(ROTA).GE..000001D0.AND.
     +                                  ABS(ROTA).LE.179.999999D0)) THEN
C
C No.  Compute constants for the ordinary cylindrical projections.
C
              SINT=COSO*COSR
              COST=SQRT(1.D0-SINT**2)
              TMP1=SINR/COST
              TMP2=SINO/COST
              PHOC=PHIO-ATAN2(TMP1,-COSR*TMP2)*RTOD
              SINR=TMP1*COSO
              COSR=-TMP2
              SINO=SINT
              COSO=COST
C
            ELSE
C
C Yes.  The fast paths are implemented as three additional projections.
C
              IPRJ=IPRJ+4
C
            END IF
C
          END IF
C
        END IF
C
        RETURN
C
      END
C
C $Id: llmap.f,v 1.1 2009-05-15 00:49:27 dbrown Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MDPIN2 (TST1,TST2,TST3)
        REAL TST1,TST2,TST3
        TST1=1.
        TST2=TST1+1.E-10
        TST3=TST2+1.E-10
        RETURN
      END
C
C $Id: llmap.f,v 1.1 2009-05-15 00:49:27 dbrown Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MDPINT
C
C Declare required common blocks.  See MAPBDX for descriptions of these
C common blocks and the variables in them.
C
        COMMON /MAPCM0/  COS1,DTOR,DTRH,OOPI,PI,PIOT,RTDD,RTOD,SIN1,TOPI
        DOUBLE PRECISION COS1,DTOR,DTRH,OOPI,PI,PIOT,RTDD,RTOD,SIN1,TOPI
        SAVE   /MAPCM0/
C
        COMMON /MAPCM1/  COSO,COSR,PHOC,SINO,SINR,IPRJ,IROD
        DOUBLE PRECISION COSO,COSR,PHOC,SINO,SINR
        INTEGER          IPRJ,IROD
        SAVE   /MAPCM1/
C
        COMMON /MAPCM2/  BLAM,BLOM,PEPS,SLAM,SLOM,UCEN,UMAX,UMIN,UOFF,
     +                   URNG,VCEN,VMAX,VMIN,VOFF,VRNG,ISSL
        DOUBLE PRECISION BLAM,BLOM,PEPS,SLAM,SLOM,UCEN,UMAX,UMIN,UOFF,
     +                   URNG,VCEN,VMAX,VMIN,VOFF,VRNG
        INTEGER          ISSL
        SAVE   /MAPCM2/
C
        COMMON /MAPCM4/  GRDR,GRID,GRLA,GRLO,GRPO,OTOL,PHIA,PHIO,PLA1,
     +                   PLA2,PLA3,PLA4,PLB1,PLB2,PLB3,PLB4,PLTR,ROTA,
     +                   SRCH,XLOW,XROW,YBOW,YTOW,IDOT,IDSH,IDTL,ILCW,
     +                   ILTS,JPRJ,ELPF,INTF,LBLF,PRMF
        DOUBLE PRECISION GRDR,GRID,GRLA,GRLO,GRPO,OTOL,PHIA,PHIO,PLA1,
     +                   PLA2,PLA3,PLA4,PLB1,PLB2,PLB3,PLB4,PLTR,ROTA,
     +                   SRCH,XLOW,XROW,YBOW,YTOW
        INTEGER          IDOT,IDSH,IDTL,ILCW,ILTS,JPRJ
        LOGICAL          ELPF,INTF,LBLF,PRMF
        SAVE   /MAPCM4/
C
        COMMON /MAPCM6/  UCNM,UMNM,UMXM,URNM,VCNM,VMNM,VMXM,VRNM,ELPM
        DOUBLE PRECISION UCNM,UMNM,UMXM,URNM,VCNM,VMNM,VMXM,VRNM
        LOGICAL ELPM
        SAVE   /MAPCM6/
C
        COMMON /MAPCM7/  ULOW,UROW,VBOW,VTOW
        DOUBLE PRECISION ULOW,UROW,VBOW,VTOW
        SAVE   /MAPCM7/
C
        COMMON /MAPCMA/  DATL,DBTD,DDTS,DPLT,DPSQ,DSCA,DSSQ
        DOUBLE PRECISION DATL,DBTD,DDTS,DPLT,DPSQ,DSCA,DSSQ
        SAVE   /MAPCMA/
C
        COMMON /MAPSAT/  ALFA,BETA,DCSA,DCSB,DSNA,DSNB,SALT,SSMO,SRSS
        DOUBLE PRECISION ALFA,BETA,DCSA,DCSB,DSNA,DSNB,SALT,SSMO,SRSS
        SAVE   /MAPSAT/
C
        COMMON /USGSC1/  UTPA(15),UUMN,UUMX,UVMN,UVMX,IPRF
        DOUBLE PRECISION UTPA,UUMN,UUMX,UVMN,UVMX
        INTEGER          IPRF
        SAVE   /USGSC1/
C
C Set up alternate names for some of the variables in common.
C
        EQUIVALENCE      (PLA1,AUMN),(PLA2,AUMX),
     +                   (PLA3,AVMN),(PLA4,AVMX)
C
C Declare local variables.
C
        DOUBLE PRECISION A,AUMN,AUMX,AVMN,AVMX,B,C,CLAT,CLON,CUMA,CUMI,
     +                   CVMA,CVMI,D,DLAT,DLON,DU,DV,E,F,R,RESL,RLAT,
     +                   RLN1,RLN2,RLON,RLT1,RLT2,SASQ,SUMA,SUMI,SVMA,
     +                   SVMI,TEM1,TEM2,TEM3,TEM4,TEM5,TEM6,TEM7,TEM8,
     +                   U,V,XMAX,XMIN,XPOS,YMAX,YMIN,YPOS
        INTEGER          I,J,NLNS,NLTS
C
C Declare function types.
C
        DOUBLE PRECISION RBGDFE
C
C Define a necessary constant.
C
        DATA RESL / 10.D0 /
C
C Check for an uncleared prior error.
C
        IF (ICFELL('MDPINT - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C Check for an error in the projection specifier.
C
        IF (JPRJ.LT.0.OR.JPRJ.GE.11) GO TO 901
C
C Jump to a subroutine that is responsible for pre-computing constants
C required by MDPTRN.  The same subroutine may, on occasion, need to be
C called by MDPTRN itself.  (MDPTRN may not call MDPINT because MDPINT
C calls MDPTRN.)
C
        CALL MDPIN1
C
C Zero UOFF and VOFF to turn off the offset feature while we're setting
C up the projection.
C
        UOFF=0.D0
        VOFF=0.D0
C
C Set UMIN, UMAX, VMIN, and VMAX to correspond to the maximum useful
C area produced by the projection.
C
C Projection: US  LC  ST  OR  LE  GN  AE  CE  ME  MO  RO
C
        GO TO (100,101,102,101,102,102,103,104,103,105,106,
     +                                     104,103,105,106) , IPRJ+1
C
C USGS transformations.
C
  100   UMIN=UUMN  !  ???
        UMAX=UUMX  !  ???
        VMIN=UVMN  !  ???
        VMAX=UVMX  !  ???
C
        GO TO 107
C
C Lambert conformal conic and orthographic.  The quantity "R" which is
C used below is the largest acceptable ratio of the lengths of the major
C and minor axes of the elliptical limb of the satellite-view projection
C for which we will show the entire ellipse.  For larger values of the
C angle "alpha", we just use a "camera" with a 120-degree field of view;
C it is debatable whether there is any better course of action.
C
  101   IF (IPRJ.NE.3.OR.ABS(SALT).LE.1.D0.OR.ALFA.EQ.0.D0) THEN
          UMIN=-1.D0
          UMAX=+1.D0
          VMIN=-1.D0
          VMAX=+1.D0
        ELSE
          R=4.D0
          IF (ALFA.LT.RTOD*
     +        ACOS(SQRT((SALT*SALT+R*R-1.D0)/(R*R*SALT*SALT)))) THEN
            SASQ=SALT*SALT
            A=(1.D0-DSNA*DSNA*DCSB*DCSB)*SASQ-1.D0
            B=(1.D0-DSNA*DSNA*DSNB*DSNB)*SASQ-1.D0
            C=-2.D0*SASQ*DSNA*DSNA*DSNB*DCSB
            D= 2.D0*SASQ*SRSS*DSNA*DCSA*DCSB
            E= 2.D0*SASQ*SRSS*DSNA*DCSA*DSNB
            F=SSMO*(SSMO*DSNA*DSNA-DCSA*DCSA)
            TEM1=SQRT((2.D0*C*E-4.D0*B*D)**2-
     +                 4.D0*(C*C-4.D0*A*B)*(E*E-4.D0*B*F))
            TEM2=(4.D0*B*D-2.D0*C*E+TEM1)/(2.D0*(C*C-4.D0*A*B))
            TEM3=(4.D0*B*D-2.D0*C*E-TEM1)/(2.D0*(C*C-4.D0*A*B))
            UMIN=MIN(TEM2,TEM3)
            UMAX=MAX(TEM2,TEM3)
            TEM1=SQRT((2.D0*C*D-4.D0*A*E)**2-
     +                 4.D0*(C*C-4.D0*A*B)*(D*D-4.D0*A*F))
            TEM2=(4.D0*A*E-2.D0*C*D+TEM1)/(2.D0*(C*C-4.D0*A*B))
            TEM3=(4.D0*A*E-2.D0*C*D-TEM1)/(2.D0*(C*C-4.D0*A*B))
            VMIN=MIN(TEM2,TEM3)
            VMAX=MAX(TEM2,TEM3)
          ELSE
            UMIN=-SRSS*TAN(DTOR*60.D0)
            UMAX=+SRSS*TAN(DTOR*60.D0)
            VMIN=-SRSS*TAN(DTOR*60.D0)
            VMAX=+SRSS*TAN(DTOR*60.D0)
          END IF
        END IF
C
        GO TO 107
C
C Stereographic, Lambert equal area, and Gnomonic.
C
  102   UMIN=-2.D0
        UMAX=+2.D0
        VMIN=-2.D0
        VMAX=+2.D0
        GO TO 107
C
C Azimuthal equidistant and Mercator.
C
  103   UMIN=-PI
        UMAX=+PI
        VMIN=-PI
        VMAX=+PI
        GO TO 107
C
C Cylindrical equidistant.
C
  104   UMIN=-180.D0
        UMAX=+180.D0
        VMIN= -90.D0
        VMAX= +90.D0
        GO TO 107
C
C Mollweide.
C
  105   UMIN=-2.D0
        UMAX=+2.D0
        VMIN=-1.D0
        VMAX=+1.D0
        GO TO 107
C
C Robinson.
C
  106   UMIN=-1.0000D0
        UMAX=+1.0000D0
        VMIN= -.5072D0
        VMAX= +.5072D0
C
C Compute the quantity used by MAPIT in checking for crossover.  The
C USGS and conical projections are oddballs.
C
  107   IF (IPRJ.EQ.0) THEN
          IF (IPRF.EQ. 3.OR.IPRF.EQ. 4.OR.IPRF.EQ. 5.OR.IPRF.EQ. 7.OR.
     +        IPRF.EQ. 8.OR.IPRF.EQ.16.OR.IPRF.EQ.17.OR.IPRF.EQ.18.OR.
     +        IPRF.EQ.19.OR.IPRF.EQ.21) THEN
            PEPS=270.D0
          ELSE IF (IPRF.EQ.9) THEN
            PEPS=.75D0*(VMAX-VMIN)
          ELSE IF (IPRF.EQ.20) THEN
            PEPS=.75D0*(UMAX-UMIN)
          ELSE IF (IPRF.EQ.22) THEN
            PEPS=.25D0*(UMAX-UMIN)
          ELSE
            PEPS=.75D0*(UMAX-UMIN)
          END IF
        ELSE IF (IPRJ.EQ.1) THEN
          PEPS=270.D0
        ELSE
          PEPS=.75D0*(UMAX-UMIN)
        END IF
C
C Turn off the initialization-required flag; this is done here, rather
C than at the end, because, otherwise, each of the following calls to
C MDPTRN will result in an unnecessary call to MDPIN1.
C
        INTF=.FALSE.
C
C Jump to the appropriate limit-setting code.
C
        GO TO (600,200,300,400,500,550) , ILTS
C
C ILTS=2    Points (PL1,PL2) and (PL3,PL4) are on opposite corners
C ------    of the plot.
C
  200   E=0.D0
  201   CALL MDPTRN (PLA1,PLA2+E,TEM1,TEM3)
        IF (ICFELL('MDPINT',2).NE.0) GO TO 999
        CALL MDPTRN (PLA3,PLA4-E,TEM2,TEM4)
        IF (ICFELL('MDPINT',3).NE.0) GO TO 999
        IF (IPRJ.GE.7.AND.TEM1.GE.TEM2.AND.E.EQ.0.D0) THEN
          E=.000001D0
          GO TO 201
        END IF
        UMIN=MIN(TEM1,TEM2)
        UMAX=MAX(TEM1,TEM2)
        VMIN=MIN(TEM3,TEM4)
        VMAX=MAX(TEM3,TEM4)
        IF (UMAX.GE.1.D12) GO TO 904
        GO TO 600
C
C ILTS=3    Four edge points are given.
C ------
C
  300   E=0.D0
  301   CALL MDPTRN (PLA1,PLB1+E,TEM1,TEM5)
        IF (ICFELL('MDPINT',4).NE.0) GO TO 999
        CALL MDPTRN (PLA2,PLB2-E,TEM2,TEM6)
        IF (ICFELL('MDPINT',5).NE.0) GO TO 999
        IF (IPRJ.GE.7.AND.TEM1.GE.TEM2.AND.E.EQ.0.D0) THEN
          E=.000001D0
          GO TO 301
        END IF
        CALL MDPTRN (PLA3,PLB3,TEM3,TEM7)
        IF (ICFELL('MDPINT',6).NE.0) GO TO 999
        CALL MDPTRN (PLA4,PLB4,TEM4,TEM8)
        IF (ICFELL('MDPINT',7).NE.0) GO TO 999
        UMIN=MIN(TEM1,TEM2,TEM3,TEM4)
        UMAX=MAX(TEM1,TEM2,TEM3,TEM4)
        VMIN=MIN(TEM5,TEM6,TEM7,TEM8)
        VMAX=MAX(TEM5,TEM6,TEM7,TEM8)
        IF (UMAX.GE.1.D12) GO TO 904
        GO TO 600
C
C ILTS=4    Angular distances are given.
C ------
C
  400   CUMI=COS(AUMN*DTOR)
        SUMI=SIN(AUMN*DTOR)
        CUMA=COS(AUMX*DTOR)
        SUMA=SIN(AUMX*DTOR)
        CVMI=COS(AVMN*DTOR)
        SVMI=SIN(AVMN*DTOR)
        CVMA=COS(AVMX*DTOR)
        SVMA=SIN(AVMX*DTOR)
C
C Projection: US  LC  ST  OR  LE  GN  AE  CE  ME  MO  RO
C
        GO TO (410,904,401,402,403,404,405,406,407,408,409,
     +                                     406,407,408,409) , IPRJ+1
C
C USGS transformations.
C
  410   UMIN=UUMN  !  ???
        UMAX=UUMX  !  ???
        VMIN=UVMN  !  ???
        VMAX=UVMX  !  ???
C
        GO TO 600
C
C Stereographic.
C
  401   IF (SUMI.LT..000001D0) THEN
          IF (CUMI.GT.0.D0) UMIN=0.D0
        ELSE
          UMIN=-(1.D0-CUMI)/SUMI
        END IF
        IF (SUMA.LT..000001D0) THEN
          IF (CUMA.GT.0.D0) UMAX=0.D0
        ELSE
          UMAX=(1.D0-CUMA)/SUMA
        END IF
        IF (SVMI.LT..000001D0) THEN
          IF (CVMI.GT.0.D0) VMIN=0.D0
        ELSE
          VMIN=-(1.D0-CVMI)/SVMI
        END IF
        IF (SVMA.LT..000001D0) THEN
          IF (CVMA.GT.0.D0) VMAX=0.D0
        ELSE
          VMAX=(1.D0-CVMA)/SVMA
        END IF
        GO TO 600
C
C Orthographic or satellite-view.
C
  402   IF (ABS(SALT).LE.1.D0) THEN
          IF (MAX(AUMN,AUMX,AVMN,AVMX).GT.90.D0) GO TO 902
          UMIN=-SUMI
          UMAX=+SUMA
          VMIN=-SVMI
          VMAX=+SVMA
        ELSE
          IF (MAX(AUMN,AUMX,AVMN,AVMX).GE.90.D0) GO TO 902
          UMIN=-SRSS*SUMI/CUMI
          UMAX=+SRSS*SUMA/CUMA
          VMIN=-SRSS*SVMI/CVMI
          VMAX=+SRSS*SVMA/CVMA
        END IF
        GO TO 600
C
C Lambert equal area.
C
  403   IF (SUMI.LT..000001D0) THEN
          IF (CUMI.GT.0.D0) UMIN=0.D0
        ELSE
          UMIN=-2.D0/SQRT(1.D0+((1.D0+CUMI)/SUMI)**2)
        END IF
        IF (SUMA.LT..000001D0) THEN
          IF (CUMA.GT.0.D0) UMAX=0.D0
        ELSE
          UMAX=2.D0/SQRT(1.D0+((1.D0+CUMA)/SUMA)**2)
        END IF
        IF (SVMI.LT..000001D0) THEN
          IF (CVMI.GT.0.D0) VMIN=0.D0
        ELSE
          VMIN=-2.D0/SQRT(1.D0+((1.D0+CVMI)/SVMI)**2)
        END IF
        IF (SVMA.LT..000001D0) THEN
          IF (CVMA.GT.0.D0) VMAX=0.D0
        ELSE
          VMAX=2.D0/SQRT(1.D0+((1.D0+CVMA)/SVMA)**2)
        END IF
        GO TO 600
C
C Gnomonic.
C
  404   IF (MAX(AUMN,AUMX,AVMN,AVMX).GE.89.999999D0) GO TO 902
        UMIN=-SUMI/CUMI
        UMAX=+SUMA/CUMA
        VMIN=-SVMI/CVMI
        VMAX=+SVMA/CVMA
        GO TO 600
C
C Azimuthal equidistant.
C
  405   UMIN=-AUMN*DTOR
        UMAX=+AUMX*DTOR
        VMIN=-AVMN*DTOR
        VMAX=+AVMX*DTOR
        GO TO 600
C
C Cylindrical equidistant.
C
  406   UMIN=-AUMN
        UMAX=+AUMX
        VMIN=-AVMN
        VMAX=+AVMX
        GO TO 600
C
C Mercator.
C
  407   IF (MAX(AVMN,AVMX).GE.89.999999D0) GO TO 902
        UMIN=-AUMN*DTOR
        UMAX=+AUMX*DTOR
        VMIN=-LOG((1.D0+SVMI)/CVMI)
        VMAX=+LOG((1.D0+SVMA)/CVMA)
        GO TO 600
C
C Mollweide.
C
  408   UMIN=-AUMN/90.D0
        UMAX=+AUMX/90.D0
        VMIN=-SVMI
        VMAX=+SVMA
        GO TO 600
C
C Robinson.
C
  409   UMIN=-AUMN/180.D0
        UMAX=+AUMX/180.D0
        VMIN=-RBGDFE(MAX(-90.D0,MIN(+90.D0,AVMN)))
        VMAX=+RBGDFE(MAX(-90.D0,MIN(+90.D0,AVMX)))
        GO TO 600
C
C ILTS=5    Values in the u/v plane are given.
C ------
C
  500   UMIN=PLA1
        UMAX=PLA2
        VMIN=PLA3
        VMAX=PLA4
        GO TO 600
C
C ILTS=6    Ranges of latitudes and longitudes are given, defining a
C ------    region of interest, all of which is to be shown.
C
  550   RLT1=MAX(-90.D0,MIN(90.D0,PLA1))
        RLT2=MAX(-90.D0,MIN(90.D0,PLA3))
        IF (RLT1.GT.RLT2) THEN
          RLAT=RLT1
          RLT1=RLT2
          RLT2=RLAT
        END IF
        RLN1=MOD(PLA2+3600.D0,360.D0)
        RLN2=MOD(PLA4+3600.D0,360.D0)
        IF (RLN2.LE.RLN1) RLN2=RLN2+360.D0
        NLTS=MAX(5,INT((RLT2-RLT1)/GRDR))+2
        NLNS=MAX(5,INT((RLN2-RLN1)/GRDR))+2
        XMIN=+1.D12
        XMAX=-1.D12
        YMIN=+1.D12
        YMAX=-1.D12
        DO 552 J=1,NLTS
          RLAT=RLT1+DBLE(J-1)*(RLT2-RLT1)/DBLE(NLTS-1)
          DO 551 I=1,NLNS
            RLON=RLN1+DBLE(I-1)*(RLN2-RLN1)/DBLE(NLNS-1)
            CALL MDPTRN (RLAT,RLON,XPOS,YPOS)
            IF (XPOS.NE.1.D12) THEN
              XMIN=MIN(XMIN,XPOS)
              XMAX=MAX(XMAX,XPOS)
              YMIN=MIN(YMIN,YPOS)
              YMAX=MAX(YMAX,YPOS)
            END IF
  551     CONTINUE
  552   CONTINUE
        IF (XMIN.NE.1.D12) THEN
          UMIN=XMIN
          UMAX=XMAX
          VMIN=YMIN
          VMAX=YMAX
        END IF
        GO TO 600
C
C Compute the width and height of the plot.
C
  600   DU=UMAX-UMIN
        DV=VMAX-VMIN
C
C Error if map has zero area.
C
        IF (DU.LE.0.D0.OR.DV.LE.0.D0) GO TO 903
C
C Position the map on the plotter frame.
C
        IF (DU/DV.LT.(XROW-XLOW)/(YTOW-YBOW)) THEN
          ULOW=.5D0*(XLOW+XROW)-.5D0*(DU/DV)*(YTOW-YBOW)
          UROW=.5D0*(XLOW+XROW)+.5D0*(DU/DV)*(YTOW-YBOW)
          VBOW=YBOW
          VTOW=YTOW
        ELSE
          ULOW=XLOW
          UROW=XROW
          VBOW=.5D0*(YBOW+YTOW)-.5D0*(DV/DU)*(XROW-XLOW)
          VTOW=.5D0*(YBOW+YTOW)+.5D0*(DV/DU)*(XROW-XLOW)
        END IF
C
C Error if map has essentially zero area.
C
        IF (MIN(UROW-ULOW,VTOW-VBOW)*PLTR.LT.RESL) GO TO 903
C
C Compute the quantities used by MAPIT to see if points are far enough
C apart to draw the line between them and the quantities used by MDPVP
C to determine the number of dots to interpolate between two points.
C
        DSCA=(UROW-ULOW)*PLTR/DU
        DPSQ=DPLT*DPLT
        DSSQ=DSCA*DSCA
        DBTD=DDTS/DSCA
C
C Set parameters required if an elliptical perimeter is being used.
C
        UCEN=.5D0*(UMIN+UMAX)
        VCEN=.5D0*(VMIN+VMAX)
        URNG=.5D0*(UMAX-UMIN)
        VRNG=.5D0*(VMAX-VMIN)
C
C Now, compute the latitude/longitude limits which will be required by
C various other routines.
C
C At first, assume the whole globe will be projected.
C
        SLAM=-90.D0
        BLAM=+90.D0
        SLOM=PHOC-180.D0
        BLOM=PHOC+180.D0
C
C Jump if it's obvious that really is the case.
C
        IF (JPRJ.EQ.0) GO TO 701  !  ???
C
        IF (ILTS.EQ.1.AND.(JPRJ.EQ.4.OR.JPRJ.EQ.6.OR.JPRJ.EQ.7.OR.
     +                               JPRJ.EQ.9.OR.JPRJ.EQ.10)) GO TO 701
C
C Otherwise, the whole globe is not being projected.  The first thing
C to do is to find a point (CLAT,CLON) whose projection is known to be
C on the map.  First, try the pole of the projection.
C
        CLAT=PHIA
        CLON=PHOC
        CALL MDPTRN (CLAT,CLON,U,V)
        IF (ICFELL('MDPINT',8).NE.0) GO TO 999
        IF ((.NOT.ELPF.AND.U.GE.UMIN.AND.U.LE.UMAX.AND.V.GE.VMIN
     +                                            .AND.V.LE.VMAX).OR.
     +        (ELPF.AND.((U-UCEN)/URNG)**2+((V-VCEN)/VRNG)**2.LE.1.D0))
     +                                                         GO TO 611
C
C If that didn't work, try a point based on the limits specifier.
C
        IF (ILTS.EQ.2.OR.ILTS.EQ.6) THEN
          CLAT=.5D0*(PLA1+PLA3)
          CLON=.5D0*(PLA2+PLA4)
        ELSE IF (ILTS.EQ.3) THEN
          TEM1=MIN(PLA1,PLA2,PLA3,PLA4)
          TEM2=MAX(PLA1,PLA2,PLA3,PLA4)
          TEM3=MIN(PLB1,PLB2,PLB3,PLB4)
          TEM4=MAX(PLB1,PLB2,PLB3,PLB4)
          CLAT=.5D0*(TEM1+TEM2)
          CLON=.5D0*(TEM3+TEM4)
        ELSE
          GO TO 700
        END IF
        CALL MDPTRN (CLAT,CLON,U,V)
        IF (ICFELL('MDPINT',9).NE.0) GO TO 999
        IF ((.NOT.ELPF.AND.U.GE.UMIN.AND.U.LE.UMAX.AND.V.GE.VMIN
     +                                            .AND.V.LE.VMAX).OR.
     +        (ELPF.AND.((U-UCEN)/URNG)**2+((V-VCEN)/VRNG)**2.LE.1.D0))
     +                                                         GO TO 611
        GO TO 700
C
C Once we have the latitudes and longitudes of a point on the map, we
C find the minimum and maximum latitude and the minimum and maximum
C longitude by running a search point about on a fine lat/lon grid.
C
C Find the minimum latitude.
C
  611   RLAT=CLAT
        RLON=CLON
        DLON=SRCH
  612   RLAT=RLAT-SRCH
        IF (RLAT.LE.-90.D0) GO TO 621
  613   CALL MDPTRN (RLAT,RLON,U,V)
        IF (ICFELL('MDPINT',10).NE.0) GO TO 999
        IF ((.NOT.ELPF.AND.U.GE.UMIN.AND.U.LE.UMAX.AND.V.GE.VMIN
     +                                            .AND.V.LE.VMAX).OR.
     +    (ELPF.AND.((U-UCEN)/URNG)**2+((V-VCEN)/VRNG)**2.LE.1.D0)) THEN
          DLON=SRCH
          GO TO 612
        END IF
        RLON=RLON+DLON
        DLON=SIGN(ABS(DLON)+SRCH,-DLON)
        IF (RLON.GT.CLON-180.D0.AND.RLON.LT.CLON+180.D0) GO TO 613
        RLON=RLON+DLON
        DLON=SIGN(ABS(DLON)+SRCH,-DLON)
        IF (RLON.GT.CLON-180.D0.AND.RLON.LT.CLON+180.D0) GO TO 613
        SLAM=RLAT
C
C Find the maximum latitude.
C
  621   RLAT=CLAT
        RLON=CLON
        DLON=SRCH
  622   RLAT=RLAT+SRCH
        IF (RLAT.GT.90.D0) GO TO 631
  623   CALL MDPTRN (RLAT,RLON,U,V)
        IF (ICFELL('MDPINT',11).NE.0) GO TO 999
        IF ((.NOT.ELPF.AND.U.GE.UMIN.AND.U.LE.UMAX.AND.V.GE.VMIN
     +                                            .AND.V.LE.VMAX).OR.
     +    (ELPF.AND.((U-UCEN)/URNG)**2+((V-VCEN)/VRNG)**2.LE.1.D0)) THEN
          DLON=SRCH
          GO TO 622
        END IF
        RLON=RLON+DLON
        DLON=SIGN(ABS(DLON)+SRCH,-DLON)
        IF (RLON.GT.CLON-180.D0.AND.RLON.LT.CLON+180.D0) GO TO 623
        RLON=RLON+DLON
        DLON=SIGN(ABS(DLON)+SRCH,-DLON)
        IF (RLON.GT.CLON-180.D0.AND.RLON.LT.CLON+180.D0) GO TO 623
        BLAM=RLAT
C
C Find the minimum longitude.
C
  631   RLAT=CLAT
        RLON=CLON
        DLAT=SRCH
  632   RLON=RLON-SRCH
        IF (RLON.LE.CLON-360.D0) GO TO 651
  633   CALL MDPTRN (RLAT,RLON,U,V)
        IF (ICFELL('MDPINT',12).NE.0) GO TO 999
        IF ((.NOT.ELPF.AND.U.GE.UMIN.AND.U.LE.UMAX.AND.V.GE.VMIN
     +                                            .AND.V.LE.VMAX).OR.
     +    (ELPF.AND.((U-UCEN)/URNG)**2+((V-VCEN)/VRNG)**2.LE.1.D0)) THEN
          DLAT=SRCH
          GO TO 632
        END IF
        RLAT=RLAT+DLAT
        DLAT=SIGN(ABS(DLAT)+SRCH,-DLAT)
        IF (RLAT.GT.-90.D0.AND.RLAT.LT.90.D0) GO TO 633
        RLAT=RLAT+DLAT
        DLAT=SIGN(ABS(DLAT)+SRCH,-DLAT)
        IF (RLAT.GT.-90.D0.AND.RLAT.LT.90.D0) GO TO 633
        SLOM=RLON+(-SIGN(180.D0,RLON+180.D0)+SIGN(180.D0,180.D0-RLON))
C
C Find the maximum longitude.
C
  641   RLAT=CLAT
        RLON=CLON
        DLAT=SRCH
  642   RLON=RLON+SRCH
        IF (RLON.GE.CLON+360.D0) GO TO 651
  643   CALL MDPTRN (RLAT,RLON,U,V)
        IF (ICFELL('MDPINT',13).NE.0) GO TO 999
        IF ((.NOT.ELPF.AND.U.GE.UMIN.AND.U.LE.UMAX.AND.V.GE.VMIN
     +                                            .AND.V.LE.VMAX).OR.
     +           (ELPF.AND.((U-UCEN)/URNG)**2+
     +                      ((V-VCEN)/VRNG)**2.LE.1.D0)) THEN
          DLAT=SRCH
          GO TO 642
        END IF
        RLAT=RLAT+DLAT
        DLAT=SIGN(ABS(DLAT)+SRCH,-DLAT)
        IF (RLAT.GT.-90.D0.AND.RLAT.LT.90.D0) GO TO 643
        RLAT=RLAT+DLAT
        DLAT=SIGN(ABS(DLAT)+SRCH,-DLAT)
        IF (RLAT.GT.-90.D0.AND.RLAT.LT.90.D0) GO TO 643
        BLOM=RLON+(-SIGN(180.D0,RLON+180.D0)+SIGN(180.D0,180.D0-RLON))
        IF (BLOM.LE.SLOM) BLOM=BLOM+360.D0
        GO TO 701
C
  651   SLOM=PHOC-180.D0
        BLOM=PHOC+180.D0
        GO TO 701
C
C Control comes here if we didn't succeed in setting limits properly.
C
  700   ISSL=0
        GO TO 702
C
C Control comes here if we did succeed in setting limits properly.
C
  701   ISSL=1
C
C Set the offset values and reset the minimum and maximum values.
C
  702   IF (ABS(UMIN-UMAX).LT.OTOL*ABS(UMIN+UMAX).OR.
     +      ABS(VMIN-VMAX).LT.OTOL*ABS(VMIN+VMAX)) THEN
          UOFF=UMIN
          VOFF=VMIN
          UMIN=0.
          VMIN=0.
          UMAX=UMAX-UOFF
          VMAX=VMAX-VOFF
        END IF
C
C Do the required SET call, being careful to use real numbers which are
C within the ranges specified by the double-precision numbers involved.
C
c       CALL SET (RDPNUW(ULOW),RDPNDW(UROW),RDPNUW(VBOW),RDPNDW(VTOW),
c    +            RDPNUW(UMIN),RDPNDW(UMAX),RDPNUW(VMIN),RDPNDW(VMAX),1)
c       IF (ICFELL('MDPINT',14).NE.0) GO TO 999
C
C Set all the variables in the common block passed to MDPTRA.
C
        ELPM=ELPF
        UMNM=UMIN-.000001D0*(UMAX-UMIN)
        UMXM=UMAX+.000001D0*(UMAX-UMIN)
        VMNM=VMIN-.000001D0*(VMAX-VMIN)
        VMXM=VMAX+.000001D0*(VMAX-VMIN)
        UCNM=UCEN
        VCNM=VCEN
        URNM=URNG
        VRNM=VRNG
C
C Done.
C
        RETURN
C
C Error returns.
C
  901   CALL SETER ('MDPINT - ATTEMPT TO USE NON-EXISTENT PROJECTION',
     +                                                           15,1)
        GO TO 999
C
  902   CALL SETER ('MDPINT - ANGULAR LIMITS TOO GREAT',16,1)
        GO TO 999
C
  903   CALL SETER ('MDPINT - MAP HAS ZERO AREA',17,1)
        GO TO 999
C
  904   CALL SETER ('MDPINT - MAP LIMITS INAPPROPRIATE',18,1)
        GO TO 999
C
  999   INTF=.TRUE.
        RETURN
C
      END
C
C $Id: llmap.f,v 1.1 2009-05-15 00:49:27 dbrown Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MDPPOS (ARG1,ARG2,ARG3,ARG4)
C
        DOUBLE PRECISION ARG1,ARG2,ARG3,ARG4
C
C Declare required common blocks.  See MAPBDX for descriptions of these
C common blocks and the variables in them.
C
        COMMON /MAPCM4/  GRDR,GRID,GRLA,GRLO,GRPO,OTOL,PHIA,PHIO,PLA1,
     +                   PLA2,PLA3,PLA4,PLB1,PLB2,PLB3,PLB4,PLTR,ROTA,
     +                   SRCH,XLOW,XROW,YBOW,YTOW,IDOT,IDSH,IDTL,ILCW,
     +                   ILTS,JPRJ,ELPF,INTF,LBLF,PRMF
        DOUBLE PRECISION GRDR,GRID,GRLA,GRLO,GRPO,OTOL,PHIA,PHIO,PLA1,
     +                   PLA2,PLA3,PLA4,PLB1,PLB2,PLB3,PLB4,PLTR,ROTA,
     +                   SRCH,XLOW,XROW,YBOW,YTOW
        INTEGER          IDOT,IDSH,IDTL,ILCW,ILTS,JPRJ
        LOGICAL          ELPF,INTF,LBLF,PRMF
        SAVE   /MAPCM4/
C
C Check for an uncleared prior error.
C
        IF (ICFELL('MDPPOS - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C Check the arguments for errors.
C
        IF (ARG1.LT.0.D0.OR.ARG1.GE.ARG2.OR.ARG2.GT.1.D0) GO TO 901
        IF (ARG3.LT.0.D0.OR.ARG3.GE.ARG4.OR.ARG4.GT.1.D0) GO TO 901
C
C Transfer in the values.
C
        XLOW=ARG1
        XROW=ARG2
        YBOW=ARG3
        YTOW=ARG4
C
C Set the flag to indicate that initialization is now required.
C
        INTF=.TRUE.
C
C Done.
C
        RETURN
C
C Error exit.
C
  901   CALL SETER ('MDPPOS - ARGUMENTS ARE INCORRECT',2,1)
        RETURN
C
      END
C
C $Id: llmap.f,v 1.1 2009-05-15 00:49:27 dbrown Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MDPROJ (ARG1,ARG2,ARG3,ARG4)
C
        CHARACTER*(*)    ARG1
        DOUBLE PRECISION ARG2,ARG3,ARG4
C
C Declare required common blocks.  See MAPBDX for descriptions of these
C common blocks and the variables in them.
C
        COMMON /MAPCM4/  GRDR,GRID,GRLA,GRLO,GRPO,OTOL,PHIA,PHIO,PLA1,
     +                   PLA2,PLA3,PLA4,PLB1,PLB2,PLB3,PLB4,PLTR,ROTA,
     +                   SRCH,XLOW,XROW,YBOW,YTOW,IDOT,IDSH,IDTL,ILCW,
     +                   ILTS,JPRJ,ELPF,INTF,LBLF,PRMF
        DOUBLE PRECISION GRDR,GRID,GRLA,GRLO,GRPO,OTOL,PHIA,PHIO,PLA1,
     +                   PLA2,PLA3,PLA4,PLB1,PLB2,PLB3,PLB4,PLTR,ROTA,
     +                   SRCH,XLOW,XROW,YBOW,YTOW
        INTEGER          IDOT,IDSH,IDTL,ILCW,ILTS,JPRJ
        LOGICAL          ELPF,INTF,LBLF,PRMF
        SAVE   /MAPCM4/
C
        COMMON /MAPCM5/  DDCT(5),DDCL(5),LDCT(6),LDCL(6),PDCT(12),
     +                   PDCL(12)
        CHARACTER*2      DDCT,DDCL,LDCT,LDCL,PDCT,PDCL
        SAVE   /MAPCM5/
C
        COMMON /MAPSAT/  ALFA,BETA,DCSA,DCSB,DSNA,DSNB,SALT,SSMO,SRSS
        DOUBLE PRECISION ALFA,BETA,DCSA,DCSB,DSNA,DSNB,SALT,SSMO,SRSS
        SAVE   /MAPSAT/
C
C Declare local variables.
C
        INTEGER          I
C
C Check for an uncleared prior error.
C
        IF (ICFELL('MDPROJ - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C Transfer the parameters defining the projection.
C
        I=IDICTL(ARG1,PDCT,12)
        IF (I.EQ.0) I=IDICTL(ARG1,PDCL,12)
        IF (I.EQ.0) GO TO 901
C
        JPRJ=I-1
C
        IF (JPRJ.EQ.3) THEN
          CALL MDSETD ('SA',0.D0)
          IF (ICFELL('MDPROJ',2).NE.0) RETURN
        ELSE IF (JPRJ.EQ.11) THEN
          JPRJ=3
          IF (ABS(SALT).LE.1.D0) THEN
            CALL MDSETD ('SA',6.631D0)
            IF (ICFELL('MDPROJ',3).NE.0) RETURN
          END IF
        END IF
C
        PHIA=MAX(-90.D0,MIN(90.D0,ARG2))
        PHIO=ARG3+(-SIGN(180.D0,ARG3+180.D0)+SIGN(180.D0,180.D0-ARG3))
        ROTA=ARG4+(-SIGN(180.D0,ARG4+180.D0)+SIGN(180.D0,180.D0-ARG4))
C
C Set the flag to indicate that initialization is now required.
C
        INTF=.TRUE.
C
C Done.
C
        RETURN
C
C Error exit.
C
  901   CALL MDPCEM ('MDPROJ - UNKNOWN PROJECTION NAME ',ARG1,4,1)
        RETURN
C
      END
C
C $Id: llmap.f,v 1.1 2009-05-15 00:49:27 dbrown Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MDPSET (ARG1,ARG2,ARG3,ARG4,ARG5)
C
        CHARACTER*(*)    ARG1
        DOUBLE PRECISION ARG2(2),ARG3(2),ARG4(2),ARG5(2)
C
C Declare required common blocks.  See MAPBDX for descriptions of these
C common blocks and the variables in them.
C
        COMMON /MAPCM4/  GRDR,GRID,GRLA,GRLO,GRPO,OTOL,PHIA,PHIO,PLA1,
     +                   PLA2,PLA3,PLA4,PLB1,PLB2,PLB3,PLB4,PLTR,ROTA,
     +                   SRCH,XLOW,XROW,YBOW,YTOW,IDOT,IDSH,IDTL,ILCW,
     +                   ILTS,JPRJ,ELPF,INTF,LBLF,PRMF
        DOUBLE PRECISION GRDR,GRID,GRLA,GRLO,GRPO,OTOL,PHIA,PHIO,PLA1,
     +                   PLA2,PLA3,PLA4,PLB1,PLB2,PLB3,PLB4,PLTR,ROTA,
     +                   SRCH,XLOW,XROW,YBOW,YTOW
        INTEGER          IDOT,IDSH,IDTL,ILCW,ILTS,JPRJ
        LOGICAL          ELPF,INTF,LBLF,PRMF
        SAVE   /MAPCM4/
C
        COMMON /MAPCM5/  DDCT(5),DDCL(5),LDCT(6),LDCL(6),PDCT(12),
     +                   PDCL(12)
        CHARACTER*2      DDCT,DDCL,LDCT,LDCL,PDCT,PDCL
        SAVE   /MAPCM5/
C
C Declare local variables.
C
        INTEGER          I
C
C Check for an uncleared prior error.
C
        IF (ICFELL('MDPSET - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C Transfer the parameters defining the map limits.
C
        I=IDICTL(ARG1,LDCT,6)
        IF (I.EQ.0) I=IDICTL(ARG1,LDCL,6)
        IF (I.EQ.0) GO TO 901
        ILTS=I
C
        PLA1=ARG2(1)
        PLA2=ARG3(1)
        PLA3=ARG4(1)
        PLA4=ARG5(1)
C
        IF (I.EQ.3) THEN
          PLB1=ARG2(2)
          PLB2=ARG3(2)
          PLB3=ARG4(2)
          PLB4=ARG5(2)
        END IF
C
C Set the flag to indicate that initialization is now required.
C
        INTF=.TRUE.
C
C Done.
C
        RETURN
C
C Error exit.
C
  901   CALL MDPCEM ('MDPSET - UNKNOWN MAP AREA SPECIFIER ',ARG1,2,1)
        RETURN
C
      END
C
C $Id: llmap.f,v 1.1 2009-05-15 00:49:27 dbrown Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MDPTRI (UVAL,VVAL,RLAT,RLON)
C
        DOUBLE PRECISION UVAL,VVAL,RLAT,RLON
C
C Declare required common blocks.  See MAPBDX for descriptions of these
C common blocks and the variables in them.
C
        COMMON /MAPCM0/  COS1,DTOR,DTRH,OOPI,PI,PIOT,RTDD,RTOD,SIN1,TOPI
        DOUBLE PRECISION COS1,DTOR,DTRH,OOPI,PI,PIOT,RTDD,RTOD,SIN1,TOPI
        SAVE   /MAPCM0/
C
        COMMON /MAPCM1/  COSO,COSR,PHOC,SINO,SINR,IPRJ,IROD
        DOUBLE PRECISION COSO,COSR,PHOC,SINO,SINR
        INTEGER          IPRJ,IROD
        SAVE   /MAPCM1/
C
        COMMON /MAPCM2/  BLAM,BLOM,PEPS,SLAM,SLOM,UCEN,UMAX,UMIN,UOFF,
     +                   URNG,VCEN,VMAX,VMIN,VOFF,VRNG,ISSL
        DOUBLE PRECISION BLAM,BLOM,PEPS,SLAM,SLOM,UCEN,UMAX,UMIN,UOFF,
     +                   URNG,VCEN,VMAX,VMIN,VOFF,VRNG
        INTEGER          ISSL
        SAVE   /MAPCM2/
C
        COMMON /MAPCM4/  GRDR,GRID,GRLA,GRLO,GRPO,OTOL,PHIA,PHIO,PLA1,
     +                   PLA2,PLA3,PLA4,PLB1,PLB2,PLB3,PLB4,PLTR,ROTA,
     +                   SRCH,XLOW,XROW,YBOW,YTOW,IDOT,IDSH,IDTL,ILCW,
     +                   ILTS,JPRJ,ELPF,INTF,LBLF,PRMF
        DOUBLE PRECISION GRDR,GRID,GRLA,GRLO,GRPO,OTOL,PHIA,PHIO,PLA1,
     +                   PLA2,PLA3,PLA4,PLB1,PLB2,PLB3,PLB4,PLTR,ROTA,
     +                   SRCH,XLOW,XROW,YBOW,YTOW
        INTEGER          IDOT,IDSH,IDTL,ILCW,ILTS,JPRJ
        LOGICAL          ELPF,INTF,LBLF,PRMF
        SAVE   /MAPCM4/
C
        COMMON /MAPCM6/  UCNM,UMNM,UMXM,URNM,VCNM,VMNM,VMXM,VRNM,ELPM
        DOUBLE PRECISION UCNM,UMNM,UMXM,URNM,VCNM,VMNM,VMXM,VRNM
        LOGICAL ELPM
        SAVE   /MAPCM6/
C
        COMMON /MAPCM8/  P,Q,R
        DOUBLE PRECISION P,Q,R
        SAVE   /MAPCM8/
C
        COMMON /MAPSAT/  ALFA,BETA,DCSA,DCSB,DSNA,DSNB,SALT,SSMO,SRSS
        DOUBLE PRECISION ALFA,BETA,DCSA,DCSB,DSNA,DSNB,SALT,SSMO,SRSS
        SAVE   /MAPSAT/
C
C Declare local variables.
C
        DOUBLE PRECISION ANGA,ANGU,RCOSA,RCOSB,RCOSLA,RCOSPH,RCOSU,
     +                   RSINA,RSINB,RSINLA,RSINPH,RSINU,TMP1,TMP2,
     +                   UTMP,UTM1,UTM2,UTM3,VTMP,VTM1,VTM2,VTM3,VVTM
C
        REAL             SLAT,SLON
C
C Declare function types.
C
        DOUBLE PRECISION RBGLEN,RBIDFE
C
C Check for an uncleared prior error.
C
        IF (ICFELL('MDPTRI - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C If EZMAP needs initialization, do it.
C
        IF (INTF) THEN
          CALL MDPINT
          IF (ICFELL('MDPTRI',2).NE.0) RETURN
        END IF
C
C Check for a point outside the perimeter.  Return 1.D12's for such
C points.
C
        IF (ELPM) THEN
          IF (((UVAL-UCNM)/URNM)**2+
     +        ((VVAL-VCNM)/VRNM)**2.GT.1.000002D0) GO TO 301
        ELSE
          IF (UVAL.LT.UMNM.OR.UVAL.GT.UMXM.OR.
     +        VVAL.LT.VMNM.OR.VVAL.GT.VMXM) GO TO 301
        END IF
C
C The point is inside the perimeter.  Compute its actual coordinates.
C
        UTMP=UVAL+UOFF
        VTMP=VVAL+VOFF
C
C Jump to the proper piece of code, depending on the projection type.
C
C Projection: US  LC  ST  OR  LE  GN  AE  CE  ME  MO  RO
C
        GO TO (100,101,102,103,104,105,106,107,108,109,110,
     +                                     111,112,113,114) , IPRJ+1
C
C USGS transformations
C.
  100   RLAT=1.D12
        RLON=1.D12
        RETURN
C
c  100   IF (IROD.EQ.0) THEN
c          CALL MDUTIS (REAL(UTMP),REAL(VTMP),SLAT,SLON)
c          IF (SLAT.NE.1.E12) THEN
c            RLAT=DBLE(SLAT)
c            RLON=DBLE(SLON)
c          ELSE
c            RLAT=1.D12
c             RLON=1.D12
c          END IF
c        ELSE
c          CALL MDUTID (UTMP,VTMP,RLAT,RLON)
c        END IF
c        IF (RLAT.NE.1.D12) GO TO 201
c         RETURN
C     
C Lambert conformal conic.
C
  101   R=SQRT(UTMP*UTMP+VTMP*VTMP)
        IF (R.LT..000001D0) THEN
          RLAT=SINO*90.D0
          TMP1=0.D0
          TMP2=1.D0
        ELSE
          RLAT=SINO*(90.D0-RTDD*ATAN(R**(1.D0/COSO)))
          TMP1=UTMP/R
          TMP2=-SINO*VTMP/R
        END IF
        RLON=PHOC+RTOD*ATAN2(TMP1,TMP2)/COSO
        IF (ABS(RLON-PHOC).GT.180.D0) GO TO 301
        GO TO 201
C
C Stereographic.
C
  102   R=SQRT(UTMP*UTMP+VTMP*VTMP)
        IF (R.LT..000001D0) GO TO 198
        RSINB=(UTMP*COSR-VTMP*SINR)/R
        RCOSB=(UTMP*SINR+VTMP*COSR)/R
        RSINA=2.D0*R/(1.D0+R*R)
        RCOSA=(1.D0-R*R)/(1.D0+R*R)
        GO TO 199
C
C Orthographic or satellite-view (depending on the value of SALT).
C
  103   IF (ABS(SALT).LE.1.D0) THEN
          R=SQRT(UTMP*UTMP+VTMP*VTMP)
          IF (R.LT..000001D0) GO TO 198
          RSINB=(UTMP*COSR-VTMP*SINR)/R
          RCOSB=(UTMP*SINR+VTMP*COSR)/R
          IF (R.LE.1.D0) THEN
            RSINA=R
            RCOSA=SQRT(1.D0-RSINA*RSINA)
          ELSE
            IF (SALT.GE.0.D0.OR.R.GT.2.D0) GO TO 301
            RSINA=2.D0-R
            RCOSA=-SQRT(1.D0-RSINA*RSINA)
          END IF
          GO TO 199
        ELSE
          IF (ALFA.EQ.0.D0) THEN
            UTM1=UTMP
            VTM1=VTMP
          ELSE
            UTM3=UTMP*DCSB+VTMP*DSNB
            VTM3=VTMP*DCSB-UTMP*DSNB
            UTM2=SRSS*(SRSS*DSNA+UTM3*DCSA)/(SRSS*DCSA-UTM3*DSNA)
            IF ((SRSS*DCSA+UTM2*DSNA)/SRSS.LT..0001D0) GO TO 301
            VTM2=SRSS*VTM3/(SRSS*DCSA-UTM3*DSNA)
            UTM1=UTM2*DCSB-VTM2*DSNB
            VTM1=UTM2*DSNB+VTM2*DCSB
          END IF
          R=SQRT(UTM1*UTM1+VTM1*VTM1)
          IF (R.LT..000001D0) GO TO 198
          RSINB=(UTM1*COSR-VTM1*SINR)/R
          RCOSB=(UTM1*SINR+VTM1*COSR)/R
          IF (R.LE.1.D0) THEN
            RCOSA=(R*R*ABS(SALT)+SSMO*SQRT(1.D0-R*R))/(R*R+SSMO)
          ELSE
            IF (SALT.GE.0.D0.OR.R.GT.2.D0) GO TO 301
            R=2.D0-R
            RCOSA=(R*R*ABS(SALT)-SSMO*SQRT(1.D0-R*R))/(R*R+SSMO)
          END IF
          RCOSA=MAX(-1.D0,MIN(+1.D0,RCOSA))
          RSINA=SQRT(1.D0-RCOSA*RCOSA)
          GO TO 199
        END IF
C
C Lambert equal-area.
C
  104   R=SQRT(UTMP*UTMP+VTMP*VTMP)
        IF (R.LT..000001D0) GO TO 198
        IF (R.GT.2.D0) GO TO 301
        RSINB=(UTMP*COSR-VTMP*SINR)/R
        RCOSB=(UTMP*SINR+VTMP*COSR)/R
        RCOSA=MAX(-1.D0,MIN(+1.D0,1.D0-R*R/2.D0))
        RSINA=SQRT(1.D0-RCOSA*RCOSA)
        GO TO 199
C
C Gnomonic.
C
  105   R=SQRT(UTMP*UTMP+VTMP*VTMP)
        IF (R.LT..000001D0) GO TO 198
        RSINB=(UTMP*COSR-VTMP*SINR)/R
        RCOSB=(UTMP*SINR+VTMP*COSR)/R
        RCOSA=MAX(-1.D0,MIN(+1.D0,1.D0/SQRT(1.D0+R*R)))
        RSINA=SQRT(1.D0-RCOSA*RCOSA)
        GO TO 199
C
C Azimuthal equidistant.
C
  106   R=SQRT(UTMP*UTMP+VTMP*VTMP)
        IF (R.LT..000001D0) GO TO 198
        IF (R.GT.PI) GO TO 301
        RSINB=(UTMP*COSR-VTMP*SINR)/R
        RCOSB=(UTMP*SINR+VTMP*COSR)/R
        RCOSA=COS(R)
        RSINA=SQRT(1.D0-RCOSA*RCOSA)
        GO TO 199
C
C Cylindrical equidistant, arbitrary pole and orientation.
C
  107   IF (ABS(UTMP).GT.180.D0.OR.ABS(VTMP).GT.90.D0) GO TO 301
        ANGA=DTOR*(90.D0-VTMP)
        RSINA=SIN(ANGA)
        RCOSA=COS(ANGA)
        ANGU=DTOR*UTMP
        RSINU=SIN(ANGU)
        RCOSU=COS(ANGU)
        RSINB=RSINU*COSR+RCOSU*SINR
        RCOSB=RSINU*SINR-RCOSU*COSR
        GO TO 199
C
C Mercator, arbitrary pole and orientation.
C
  108   IF (ABS(UTMP).GT.PI) GO TO 301
        RSINA=SIN(PI-2.D0*ATAN(EXP(VTMP)))
        RCOSA=COS(PI-2.D0*ATAN(EXP(VTMP)))
        RSINU=SIN(UTMP)
        RCOSU=COS(UTMP)
        RSINB=RSINU*COSR+RCOSU*SINR
        RCOSB=RSINU*SINR-RCOSU*COSR
        GO TO 199
C
C Mollweide, arbitrary pole and orientation.
C
  109   IF (ABS(VTMP).GT.1.D0) GO TO 301
        RCOSA=VTMP
        RSINA=SQRT(1.D0-RCOSA*RCOSA)
        IF (RSINA.NE.0.D0) THEN
          IF (ABS(UTMP/RSINA).GT.2.D0) GO TO 301
          ANGU=PIOT*UTMP/RSINA
          RSINU=SIN(ANGU)
          RCOSU=COS(ANGU)
        ELSE
          IF (UTMP.NE.0.D0) GO TO 301
          RSINU=0.D0
          RCOSU=1.D0
        END IF
        RSINB=RSINU*COSR+RCOSU*SINR
        RCOSB=RSINU*SINR-RCOSU*COSR
        GO TO 199
C
C Robinson, arbitrary pole and orientation.
C
  110   IF (ABS(VTMP).GT..5072D0) GO TO 301
        VVTM=RBIDFE(VTMP)
        IF (ABS(UTMP).GT.RBGLEN(VVTM)) GO TO 301
        ANGA=PIOT-DTOR*VVTM
        RSINA=SIN(ANGA)
        RCOSA=COS(ANGA)
        ANGU=PI*UTMP/RBGLEN(VVTM)
        RSINU=SIN(ANGU)
        RCOSU=COS(ANGU)
        RSINB=RSINU*COSR+RCOSU*SINR
        RCOSB=RSINU*SINR-RCOSU*COSR
        GO TO 199
C
C Cylindrical equidistant, fast path.
C
  111   IF (ABS(UTMP).GT.180.D0.OR.ABS(VTMP).GT.90.D0) GO TO 301
        RLAT=VTMP
        RLON=PHOC+UTMP
        GO TO 200
C
C Mercator, fast path.
C
  112   IF (ABS(UTMP).GT.PI) GO TO 301
        RLAT=RTDD*ATAN(EXP(VTMP))-90.D0
        RLON=PHOC+RTOD*UTMP
        GO TO 200
C
C Mollweide, fast path.
C
  113   IF (ABS(VTMP).GT.1.D0) GO TO 301
        RLAT=ASIN(VTMP)*RTOD
        IF (1.D0-VTMP*VTMP.NE.0.D0) THEN
          RLON=PHOC+90.D0*UTMP/SQRT(1.D0-VTMP*VTMP)
          IF (ABS(RLON-PHOC).GT.180.D0) GO TO 301
        ELSE
          IF (UTMP.NE.0.D0) GO TO 301
          RLON=PHOC
        END IF
        GO TO 200
C
C Robinson, fast path.
C
  114   IF (ABS(VTMP).GT..5072D0) GO TO 301
        VVTM=RBIDFE(VTMP)
        IF (ABS(UTMP).GT.RBGLEN(VVTM)) GO TO 301
        RLAT=VVTM
        RLON=PHOC+180.D0*UTMP/RBGLEN(VVTM)
        GO TO 200
C
C The following code is common to all of the azimuthal projections when
C the "radius" R is within epsilon of zero.
C
  198   RSINB=0.D0
        RCOSB=1.D0
        RSINA=0.D0
        RCOSA=1.D0
C
C The following code is common to all of the azimuthal projections.
C
  199   RSINPH=RSINA*RSINB
        RCOSPH=RCOSA*COSO-RSINA*SINO*RCOSB
        RCOSLA=SQRT(RSINPH*RSINPH+RCOSPH*RCOSPH)
C
        IF (RCOSLA.NE.0.D0) THEN
          RSINPH=RSINPH/RCOSLA
          RCOSPH=RCOSPH/RCOSLA
        END IF
        IF (ABS(SINO).GT..000001D0) THEN
          RSINLA=(RCOSA-RCOSLA*RCOSPH*COSO)/SINO
        ELSE
          RSINLA=RSINA*RCOSB
        END IF
C
        IF (RSINLA.NE.0.D0.OR.RCOSLA.NE.0.D0) THEN
          RLAT=RTOD*ATAN2(RSINLA,RCOSLA)
        ELSE
          RLAT=0.D0
        END IF
        IF (RSINA*RSINB.NE.0.D0.OR.
     +      RCOSA*COSO-RSINA*SINO*RCOSB.NE.0.D0) THEN
          RLON=PHOC+RTOD*ATAN2(RSINA*RSINB,RCOSA*COSO-RSINA*SINO*RCOSB)
        ELSE
          RLON=0.D0
        END IF
C
        GO TO 201
C
C The following code is common to all the fast-path projections.  If the
C rotation angle is 180, negate the output values of RLAT and RLON.
C
  200   IF (ABS(ROTA).GT.179.999999D0) THEN
          RLAT=-RLAT
          RLON=-RLON
        END IF
C
        GO TO 201
C
C Done.
C
  201   IF (ABS(RLON).GT.180.D0) RLON=RLON-SIGN(360.D0,RLON)
C
        RETURN
C
C Inverse is not defined; return the values that signal that.
C
  301   RLAT=1.D12
        RLON=1.D12
C
        RETURN
C
      END
C
C $Id: llmap.f,v 1.1 2009-05-15 00:49:27 dbrown Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MDPTRN (RLAT,RLON,U,V)
C
        DOUBLE PRECISION RLAT,RLON,U,V
C
C Given the latitude, RLAT, and the longitude, RLON, of a point on the
C earth, this routine returns the U and V coordinates of the projection
C of that point on the map.
C
C Declare required common blocks.  See MAPBDX for descriptions of these
C common blocks and the variables in them.
C
        COMMON /MAPCM0/  COS1,DTOR,DTRH,OOPI,PI,PIOT,RTDD,RTOD,SIN1,TOPI
        DOUBLE PRECISION COS1,DTOR,DTRH,OOPI,PI,PIOT,RTDD,RTOD,SIN1,TOPI
        SAVE   /MAPCM0/
C
        COMMON /MAPCM1/  COSO,COSR,PHOC,SINO,SINR,IPRJ,IROD
        DOUBLE PRECISION COSO,COSR,PHOC,SINO,SINR
        INTEGER          IPRJ,IROD
        SAVE   /MAPCM1/
C
        COMMON /MAPCM2/  BLAM,BLOM,PEPS,SLAM,SLOM,UCEN,UMAX,UMIN,UOFF,
     +                   URNG,VCEN,VMAX,VMIN,VOFF,VRNG,ISSL
        DOUBLE PRECISION BLAM,BLOM,PEPS,SLAM,SLOM,UCEN,UMAX,UMIN,UOFF,
     +                   URNG,VCEN,VMAX,VMIN,VOFF,VRNG
        INTEGER          ISSL
        SAVE   /MAPCM2/
C
        COMMON /MAPCM4/  GRDR,GRID,GRLA,GRLO,GRPO,OTOL,PHIA,PHIO,PLA1,
     +                   PLA2,PLA3,PLA4,PLB1,PLB2,PLB3,PLB4,PLTR,ROTA,
     +                   SRCH,XLOW,XROW,YBOW,YTOW,IDOT,IDSH,IDTL,ILCW,
     +                   ILTS,JPRJ,ELPF,INTF,LBLF,PRMF
        DOUBLE PRECISION GRDR,GRID,GRLA,GRLO,GRPO,OTOL,PHIA,PHIO,PLA1,
     +                   PLA2,PLA3,PLA4,PLB1,PLB2,PLB3,PLB4,PLTR,ROTA,
     +                   SRCH,XLOW,XROW,YBOW,YTOW
        INTEGER          IDOT,IDSH,IDTL,ILCW,ILTS,JPRJ
        LOGICAL          ELPF,INTF,LBLF,PRMF
        SAVE   /MAPCM4/
C
        COMMON /MAPCM8/  P,Q,R
        DOUBLE PRECISION P,Q,R
        SAVE   /MAPCM8/
C
        COMMON /MAPSAT/  ALFA,BETA,DCSA,DCSB,DSNA,DSNB,SALT,SSMO,SRSS
        DOUBLE PRECISION ALFA,BETA,DCSA,DCSB,DSNA,DSNB,SALT,SSMO,SRSS
        SAVE   /MAPSAT/
C
        COMMON /USGSC1/  UTPA(15),UUMN,UUMX,UVMN,UVMX,IPRF
        DOUBLE PRECISION UTPA,UUMN,UUMX,UVMN,UVMX
        INTEGER          IPRF
        SAVE   /USGSC1/
C
C Declare local variables.
C
        DOUBLE PRECISION CHI,COSA,COSB,COSLA,COSPH,SINA,SINB,SINLA,
     +                   SINPH,TCOS,TEMP,TMP1,TMP2,UTM1,UTM2,UTM3,
     +                   VTM1,VTM2,VTM3
C
        REAL             USNG,VSNG
C
C Declare function types.
C
        DOUBLE PRECISION MDGDDP,RBGDFE,RBGLEN
C
C Check for an uncleared prior error.
C
        IF (ICFELL('MDPTRN - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C If EZMAP needs initialization, there's a problem: MDPTRN can't call
C MDPINT, because MDPINT calls MDPTRN; instead, it calls the internal
C routine MDPIN1 to initialize just the constants that it needs.
C
        IF (INTF) CALL MDPIN1
C
C Set up U and V for the fast paths.  U is a longitude, in degrees,
C between -180. and +180., inclusive, and V is a latitude, in degrees.
C
        TEMP=RLON-PHOC
        U=TEMP+(-SIGN(180.D0,TEMP+180.D0)+SIGN(180.D0,180.D0-TEMP))
        V=MAX(-90.D0,MIN(90.D0,RLAT))
C
C If a fast-path projection is in use and the rotation angle is 180,
C adjust U and V.
C
        IF (IPRJ.GE.11.AND.ABS(ROTA).GT.179.999999D0) THEN
          U=-U
          V=-V
        END IF
C
C Take fast paths for simple cylindrical projections.
C
        IF (IPRJ-11) 100,197,113
C
C No fast path.  Sort out the USGS transformations and the Lambert
C conformal conic from the rest.
C
  100   IF (IPRJ-1) 101,102,103
C
C USGS projections.
C
c  101   IF (IPRF.EQ.0) GO TO 901
  101   GO TO 901
C
c        IF (IROD.EQ.0) THEN
c          CALL MDUTFS (REAL(RLAT),REAL(RLON),USNG,VSNG)
c          IF (USNG.NE.1.E12) THEN
c            U=DBLE(USNG)
c            V=DBLE(VSNG)
c          ELSE
c            U=1.D12
c            V=1.D12
c          END IF
c        ELSE
c          CALL MDUTFD (RLAT,RLON,U,V)
c        END IF
cC
c        IF (IPRF.EQ. 3.OR.IPRF.EQ. 4.OR.IPRF.EQ. 5.OR.IPRF.EQ. 7.OR.
c     +      IPRF.EQ. 8.OR.IPRF.EQ.16.OR.IPRF.EQ.17.OR.IPRF.EQ.18.OR.
c     +      IPRF.EQ.19.OR.IPRF.EQ.21) THEN
c          TMP1=RLON-UTPA(5)
c          P=TMP1+(-SIGN(180.D0,TMP1+180.D0)+SIGN(180.D0,180.D0-TMP1))
c          IF ((IPRF.EQ.3.OR.IPRF.EQ.8).AND.ABS(RLAT).GT.89.999999D0)
c     +                                                         GO TO 200
c        ELSE IF (IPRF.EQ.9) THEN
c          P=V
c        ELSE IF (IPRF.EQ.11.OR.IPRF.EQ.12) THEN
c          IF (MDGDDP(RLAT,RLON,UTPA(6),UTPA(5)).GT.179.99D0) GO TO 200
c        ELSE IF (IPRF.EQ.20) THEN
c          P=U*SIN(DTOR*UTPA(4))+V*COS(DTOR*UTPA(4))
c        ELSE IF (IPRF.EQ.22) THEN
c          P=U*SIN(DTOR*UTPA(4))+V*COS(DTOR*UTPA(4))
c        END IF
cC
c        GO TO 199
C
C Lambert conformal conic.
C
  102   P=U
        CHI=90.D0-SINO*V
        IF (CHI.GT.179.999999D0) GO TO 200
        R=TAN(DTRH*CHI)**COSO
        U=U*COSO*DTOR
        V=-R*SINO*COS(U)
        U=R*SIN(U)
        GO TO 198
C
C Not Lambert conformal conic.  Calculate constants common to most of
C the other projections.
C
  103   TMP1=U*DTOR
        TMP2=V*DTOR
        SINPH=SIN(TMP1)
        SINLA=SIN(TMP2)
        COSPH=COS(TMP1)
        COSLA=COS(TMP2)
        TCOS=COSLA*COSPH
        COSA=MAX(-1.D0,MIN(+1.D0,SINLA*SINO+TCOS*COSO))
        SINA=SQRT(1.D0-COSA*COSA)
        IF (SINA.LT..000001D0) THEN
          SINA=0.D0
          IF (IPRJ.EQ.3.AND.ABS(SALT).GT.1.D0) THEN
            SINB=0.D0
            COSB=1.D0
            GO TO 105
          END IF
          IF (IPRJ.GE.7.OR.COSA.LT.0.D0) GO TO 200
          U=0.D0
          V=0.D0
          GO TO 197
        END IF
        SINB=COSLA*SINPH/SINA
        COSB=(SINLA*COSO-TCOS*SINO)/SINA
C
C Jump to code appropriate for the chosen projection.
C
C Projection: ST  OR  LE  GN  AE  CE  ME  MO  RO
C
        GO TO (104,105,106,107,108,109,110,111,112) , IPRJ-1
C
C Stereographic.
C
  104   IF (ABS(SINA).LT..000001D0) THEN
          R=SINA/2.D0
        ELSE
          R=(1.D0-COSA)/SINA
        END IF
        GO TO 196
C
C Orthographic or satellite-view, depending on the value of SALT.
C
  105   IF (ABS(SALT).LE.1.D0) THEN
          IF (COSA.GT.0.D0) THEN
            R=SINA
          ELSE
            IF (SALT.GE.0.D0) GO TO 200
            R=2.D0-SINA
          END IF
          GO TO 196
        ELSE
          IF (COSA.GT.1.D0/ABS(SALT)) THEN
            R=SRSS*SINA/(ABS(SALT)-COSA)
          ELSE
            IF (SALT.GE.0.D0) GO TO 200
            R=2.D0-SRSS*SINA/(ABS(SALT)-COSA)
          END IF
          IF (ALFA.EQ.0.D0) GO TO 196
          UTM1=R*(SINB*COSR+COSB*SINR)
          VTM1=R*(COSB*COSR-SINB*SINR)
          UTM2=UTM1*DCSB+VTM1*DSNB
          VTM2=VTM1*DCSB-UTM1*DSNB
          IF ((SRSS*DCSA+UTM2*DSNA)/SRSS.LT..0001D0) GO TO 200
          UTM3=SRSS*(UTM2*DCSA-SRSS*DSNA)/
     +                    (UTM2*DSNA+SRSS*DCSA)
          VTM3=SRSS*VTM2/(UTM2*DSNA+SRSS*DCSA)
          U=UTM3*DCSB-VTM3*DSNB
          V=VTM3*DCSB+UTM3*DSNB
          GO TO 197
        END IF
C
C Lambert equal area.
C
  106   IF (ABS(COSA+1.D0).LT..000001D0) GO TO 200
        R=(1.D0+COSA)/SINA
        R=2.D0/SQRT(1.D0+R*R)
        GO TO 196
C
C Gnomonic.
C
  107   IF (COSA.LE..000001D0) GO TO 200
        R=SINA/COSA
        GO TO 196
C
C Azimuthal equidistant.
C
  108   IF (ABS(COSA+1.D0).LT..000001D0) GO TO 200
        R=ACOS(COSA)
        GO TO 196
C
C Cylindrical equidistant, arbitrary pole and orientation.
C
  109   U=ATAN2(SINB*COSR+COSB*SINR,SINB*SINR-COSB*COSR)*RTOD
        V=90.D0-ACOS(COSA)*RTOD
        GO TO 197
C
C Mercator, arbitrary pole and orientation.
C
  110   U=ATAN2(SINB*COSR+COSB*SINR,SINB*SINR-COSB*COSR)
        V=LOG((1.D0+COSA)/SINA)
        GO TO 197
C
C Mollweide, arbitrary pole and orientation.
C
  111   P=ATAN2(SINB*COSR+COSB*SINR,SINB*SINR-COSB*COSR)*TOPI
        U=P*SINA
        V=COSA
        GO TO 198
C
C Robinson, arbitrary pole and orientation.
C
  112   P=ATAN2(SINB*COSR+COSB*SINR,SINB*SINR-COSB*COSR)*OOPI
        U=P*RBGLEN(90.D0-ACOS(COSA)*RTOD)
        V=RBGDFE(90.D0-ACOS(COSA)*RTOD)
        GO TO 198
C
C Fast-path cylindrical projections (with PLAT=0, ROTA=0 or 180).
C
  113   IF (IPRJ-13) 114,115,116
C
C Fast-path Mercator.
C
  114   IF (ABS(V).GT.89.999999D0) GO TO 200
        U=U*DTOR
        V=LOG(TAN((V+90.D0)*DTRH))
        GO TO 197
C
C Fast-path Mollweide.
C
  115   P=U/90.D0
        V=SIN(V*DTOR)
        U=P*SQRT(1.D0-V*V)
        GO TO 198
C
C Fast-path Robinson.
C
  116   P=U/180.D0
        U=P*RBGLEN(V)
        V=RBGDFE(V)
        GO TO 198
C
C Common terminal code for certain projections.
C
  196   U=R*(SINB*COSR+COSB*SINR)
        V=R*(COSB*COSR-SINB*SINR)
C
  197   P=U
C
  198   Q=V
C
C Normal exit.
C
  199   U=U-UOFF
        V=V-VOFF
C
        RETURN
C
C Projection of point is invisible or undefined.
C
  200   U=1.D12
        P=U
C
        RETURN
C
C Error exit.
C
  901   CALL SETER ('MDPTRN - USGS PROJECTION WAS NOT INITIALIZED',2,1)
        RETURN
C
      END
C
C $Id: llmap.f,v 1.1 2009-05-15 00:49:27 dbrown Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MDSETD (WHCH,DVAL)
C
        CHARACTER*(*)    WHCH
        DOUBLE PRECISION DVAL
C
C Declare required common blocks.  See MAPBDX for descriptions of these
C common blocks and the variables in them.
C
        COMMON /MAPCM0/  COS1,DTOR,DTRH,OOPI,PI,PIOT,RTDD,RTOD,SIN1,TOPI
        DOUBLE PRECISION COS1,DTOR,DTRH,OOPI,PI,PIOT,RTDD,RTOD,SIN1,TOPI
        SAVE   /MAPCM0/
C
        COMMON /MAPCM2/  BLAM,BLOM,PEPS,SLAM,SLOM,UCEN,UMAX,UMIN,UOFF,
     +                   URNG,VCEN,VMAX,VMIN,VOFF,VRNG,ISSL
        DOUBLE PRECISION BLAM,BLOM,PEPS,SLAM,SLOM,UCEN,UMAX,UMIN,UOFF,
     +                   URNG,VCEN,VMAX,VMIN,VOFF,VRNG
        INTEGER          ISSL
        SAVE   /MAPCM2/
C
        COMMON /MAPCM4/  GRDR,GRID,GRLA,GRLO,GRPO,OTOL,PHIA,PHIO,PLA1,
     +                   PLA2,PLA3,PLA4,PLB1,PLB2,PLB3,PLB4,PLTR,ROTA,
     +                   SRCH,XLOW,XROW,YBOW,YTOW,IDOT,IDSH,IDTL,ILCW,
     +                   ILTS,JPRJ,ELPF,INTF,LBLF,PRMF
        DOUBLE PRECISION GRDR,GRID,GRLA,GRLO,GRPO,OTOL,PHIA,PHIO,PLA1,
     +                   PLA2,PLA3,PLA4,PLB1,PLB2,PLB3,PLB4,PLTR,ROTA,
     +                   SRCH,XLOW,XROW,YBOW,YTOW
        INTEGER          IDOT,IDSH,IDTL,ILCW,ILTS,JPRJ
        LOGICAL          ELPF,INTF,LBLF,PRMF
        SAVE   /MAPCM4/
C
        COMMON /MAPCM7/  ULOW,UROW,VBOW,VTOW
        DOUBLE PRECISION ULOW,UROW,VBOW,VTOW
        SAVE   /MAPCM7/
C
        COMMON /MAPCMA/  DATL,DBTD,DDTS,DPLT,DPSQ,DSCA,DSSQ
        DOUBLE PRECISION DATL,DBTD,DDTS,DPLT,DPSQ,DSCA,DSSQ
        SAVE   /MAPCMA/
C
        COMMON /MAPSAT/  ALFA,BETA,DCSA,DCSB,DSNA,DSNB,SALT,SSMO,SRSS
        DOUBLE PRECISION ALFA,BETA,DCSA,DCSB,DSNA,DSNB,SALT,SSMO,SRSS
        SAVE   /MAPSAT/
C
        IF (ICFELL('MDSETD - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
        IF      (WHCH(1:2).EQ.'DD'.OR.WHCH(1:2).EQ.'dd') THEN
          DDTS=DVAL
          DBTD=DDTS/DSCA
        ELSE IF (WHCH(1:2).EQ.'GD'.OR.WHCH(1:2).EQ.'gd') THEN
          GRDR=MAX(.001D0,MIN(10.D0,DVAL))
        ELSE IF (WHCH(1:2).EQ.'GN'.OR.WHCH(1:2).EQ.'gn') THEN
          GRLO=DVAL
        ELSE IF (WHCH(1:2).EQ.'GP'.OR.WHCH(1:2).EQ.'gp') THEN
          GRPO=MAX(0.D0,MIN(90360.D0,DVAL))
        ELSE IF (WHCH(1:2).EQ.'GR'.OR.WHCH(1:2).EQ.'gr') THEN
          GRID=DVAL
        ELSE IF (WHCH(1:2).EQ.'GT'.OR.WHCH(1:2).EQ.'gt') THEN
          GRLA=DVAL
        ELSE IF (WHCH(1:2).EQ.'MV'.OR.WHCH(1:2).EQ.'mv') THEN
          DPLT=DVAL
          DPSQ=DPLT*DPLT
        ELSE IF (WHCH(1:2).EQ.'OT'.OR.WHCH(1:2).EQ.'ot') THEN
          OTOL=MAX(0.D0,DVAL)
        ELSE IF (WHCH(1:2).EQ.'RE'.OR.WHCH(1:2).EQ.'re') THEN
          PLTR=DVAL
          INTF=.TRUE.
        ELSE IF (WHCH(1:2).EQ.'SA'.OR.WHCH(1:2).EQ.'sa') THEN
          SALT=DVAL
          IF (ABS(SALT).GT.1.D0) THEN
            SSMO=SALT*SALT-1.D0
            SRSS=SQRT(SSMO)
          END IF
          INTF=.TRUE.
        ELSE IF (WHCH(1:2).EQ.'S1'.OR.WHCH(1:2).EQ.'s1') THEN
          ALFA=ABS(DVAL)
          DSNA=SIN(DTOR*ALFA)
          DCSA=COS(DTOR*ALFA)
          INTF=.TRUE.
        ELSE IF (WHCH(1:2).EQ.'S2'.OR.WHCH(1:2).EQ.'s2') THEN
          BETA=DVAL
          DSNB=SIN(DTOR*BETA)
          DCSB=COS(DTOR*BETA)
          INTF=.TRUE.
        ELSE IF (WHCH(1:2).EQ.'SR'.OR.WHCH(1:2).EQ.'sr') THEN
          SRCH=MAX(.001D0,MIN(10.D0,DVAL))
          INTF=.TRUE.
        ELSE
          GO TO 901
        END IF
C
C Done.
C
        RETURN
C
C Error exits.
C
  901   CALL MDPCEM ('MDSETD - UNKNOWN PARAMETER NAME ',WHCH,2,1)
        RETURN
C
      END
C
C $Id: llmap.f,v 1.1 2009-05-15 00:49:27 dbrown Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      DOUBLE PRECISION FUNCTION RBGDFE (RLAT)
C
        DOUBLE PRECISION RLAT
C
C The value of RBGDFE(RLAT) is the signed distance, from the equator,
C of the parallel at latitude RLAT; its magnitude is a fraction of the
C length of the equator.
C
C Declare local variables.
C
        DOUBLE PRECISION FLAT,PDFE(19)
C
        INTEGER          ILAT
C
C Define the contents of PDFE per the definition of the Robinson
C projection.
C
        DATA PDFE( 1) / 0.0000D0 /  !   0N
        DATA PDFE( 2) / 0.0620D0 /  !   5N
        DATA PDFE( 3) / 0.1240D0 /  !  10N
        DATA PDFE( 4) / 0.1860D0 /  !  15N
        DATA PDFE( 5) / 0.2480D0 /  !  20N
        DATA PDFE( 6) / 0.3100D0 /  !  25N
        DATA PDFE( 7) / 0.3720D0 /  !  30N
        DATA PDFE( 8) / 0.4340D0 /  !  35N
        DATA PDFE( 9) / 0.4958D0 /  !  40N
        DATA PDFE(10) / 0.5571D0 /  !  45N
        DATA PDFE(11) / 0.6176D0 /  !  50N
        DATA PDFE(12) / 0.6769D0 /  !  55N
        DATA PDFE(13) / 0.7346D0 /  !  60N
        DATA PDFE(14) / 0.7903D0 /  !  65N
        DATA PDFE(15) / 0.8435D0 /  !  70N
        DATA PDFE(16) / 0.8936D0 /  !  75N
        DATA PDFE(17) / 0.9394D0 /  !  80N
        DATA PDFE(18) / 0.9761D0 /  !  85N
        DATA PDFE(19) / 1.0000D0 /  !  90N
C
C Determine where the parallel of interest lies relative to the ones
C represented in the tables (between the ones associated with elements
C ILAT and ILAT+1 and a fractional distance FLAT from the former to the
C latter).
C
        ILAT=MAX(1,MIN(18,INT(1.D0+ABS(RLAT)/5.D0)))
C
        FLAT=1.D0+ABS(RLAT)/5.D0-DBLE(ILAT)
C
C Return the desired value.
C
        RBGDFE=.5072D0*SIGN((1.D0-FLAT)*PDFE(ILAT)+
     +                             FLAT*PDFE(ILAT+1),RLAT)
C
C Done.
C
        RETURN
C
      END
C
C $Id: llmap.f,v 1.1 2009-05-15 00:49:27 dbrown Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      DOUBLE PRECISION FUNCTION RBGLEN (RLAT)
C
        DOUBLE PRECISION RLAT
C
C The value of RBGLEN(RLAT) is the length of the parallel at latitude
C RLAT, stated as a fraction of the length of the equator.
C
C Declare local variables.
C
        DOUBLE PRECISION FLAT,PLEN(19)
C
        INTEGER          ILAT
C
C Define the contents of PLEN per the definition of the Robinson
C projection.
C
        DATA PLEN( 1) / 1.0000D0 /  !   0N
        DATA PLEN( 2) / 0.9986D0 /  !   5N
        DATA PLEN( 3) / 0.9954D0 /  !  10N
        DATA PLEN( 4) / 0.9900D0 /  !  15N
        DATA PLEN( 5) / 0.9822D0 /  !  20N
        DATA PLEN( 6) / 0.9730D0 /  !  25N
        DATA PLEN( 7) / 0.9600D0 /  !  30N
        DATA PLEN( 8) / 0.9427D0 /  !  35N
        DATA PLEN( 9) / 0.9216D0 /  !  40N
        DATA PLEN(10) / 0.8962D0 /  !  45N
        DATA PLEN(11) / 0.8679D0 /  !  50N
        DATA PLEN(12) / 0.8350D0 /  !  55N
        DATA PLEN(13) / 0.7986D0 /  !  60N
        DATA PLEN(14) / 0.7597D0 /  !  65N
        DATA PLEN(15) / 0.7186D0 /  !  70N
        DATA PLEN(16) / 0.6732D0 /  !  75N
        DATA PLEN(17) / 0.6213D0 /  !  80N
        DATA PLEN(18) / 0.5722D0 /  !  85N
        DATA PLEN(19) / 0.5322D0 /  !  90N
C
C Determine where the parallel of interest lies relative to the ones
C represented in the tables (between the ones associated with elements
C ILAT and ILAT+1 and a fractional distance FLAT from the former to the
C latter).
C
        ILAT=MAX(1,MIN(18,INT(1.D0+ABS(RLAT)/5.D0)))
C
        FLAT=1.D0+ABS(RLAT)/5.D0-DBLE(ILAT)
C
C Return the desired value.
C
        RBGLEN=(1.D0-FLAT)*PLEN(ILAT)+FLAT*PLEN(ILAT+1)
C
C Done.
C
        RETURN
C
      END
C
C $Id: llmap.f,v 1.1 2009-05-15 00:49:27 dbrown Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      DOUBLE PRECISION FUNCTION RBIDFE (QDFE)
C
        DOUBLE PRECISION QDFE
C
C The value of RBIDFE(QDFE) is the latitude for which the distance of
C the parallel of the Robinson projection from the equator is QDFE.
C
C Declare local variables.
C
        DOUBLE PRECISION PDFE(19),XDFE
C
        INTEGER          ITST,IBEG,IEND
C
C Define the contents of PLEN per the definition of the Robinson
C projection.
C
C
        DATA PDFE( 1) / 0.0000D0 /  !   0N
        DATA PDFE( 2) / 0.0620D0 /  !   5N
        DATA PDFE( 3) / 0.1240D0 /  !  10N
        DATA PDFE( 4) / 0.1860D0 /  !  15N
        DATA PDFE( 5) / 0.2480D0 /  !  20N
        DATA PDFE( 6) / 0.3100D0 /  !  25N
        DATA PDFE( 7) / 0.3720D0 /  !  30N
        DATA PDFE( 8) / 0.4340D0 /  !  35N
        DATA PDFE( 9) / 0.4958D0 /  !  40N
        DATA PDFE(10) / 0.5571D0 /  !  45N
        DATA PDFE(11) / 0.6176D0 /  !  50N
        DATA PDFE(12) / 0.6769D0 /  !  55N
        DATA PDFE(13) / 0.7346D0 /  !  60N
        DATA PDFE(14) / 0.7903D0 /  !  65N
        DATA PDFE(15) / 0.8435D0 /  !  70N
        DATA PDFE(16) / 0.8936D0 /  !  75N
        DATA PDFE(17) / 0.9394D0 /  !  80N
        DATA PDFE(18) / 0.9761D0 /  !  85N
        DATA PDFE(19) / 1.0000D0 /  !  90N
C
C XDFE is the magnitude of QDFE, limited to the range of values in the
C table.
C
        XDFE=MAX(0.D0,MIN(1.D0,ABS(QDFE)/.5072D0))
C
C Find the indices of the values in the table between which XDFE lies.
C
        IBEG=1
        IEND=19
C
  101   ITST=(IBEG+IEND)/2
C
        IF (PDFE(ITST).LE.XDFE) THEN
          IBEG=ITST
        ELSE
          IEND=ITST
        END IF
C
        IF (IEND-IBEG.GT.1) GO TO 101
C
C Now, just interpolate to find the desired latitude.
C
        RBIDFE=SIGN(5.D0*(DBLE(IBEG-1)+(      XDFE-PDFE(IBEG))/
     +                                 (PDFE(IEND)-PDFE(IBEG))),QDFE)
C
C Done.
C
        RETURN
C
      END
C
C $Id: llmap.f,v 1.1 2009-05-15 00:49:27 dbrown Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      INTEGER FUNCTION IDICTL (ISTR,IDCT,NDCT)
C
        CHARACTER*(*) ISTR
        CHARACTER*2   IDCT(NDCT)
        INTEGER       NDCT
C
C The value of this function is the index in the NDCT-element dictionary
C IDCT of the string ISTR.  Only the first two characters of ISTR and
C IDCT(I) are compared.  If ISTR is not found in the dictionary, the
C function value is zero.
C
C Declare local variables
C
        INTEGER       I
C
        DO 101 I=1,NDCT
          IF (ISTR(1:2).EQ.IDCT(I)) THEN
            IDICTL=I
            RETURN
          END IF
  101   CONTINUE
C
C Not found.  Return a zero.
C
        IDICTL=0
        RETURN
C
      END
C
C $Id: llmap.f,v 1.1 2009-05-15 00:49:27 dbrown Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MDPTRA (RLAT,RLON,UVAL,VVAL)
C
        DOUBLE PRECISION RLAT,RLON,UVAL,VVAL
C
C Declare required common blocks.  See MAPBDX for descriptions of these
C common blocks and the variables in them.
C
        COMMON /MAPCM4/  GRDR,GRID,GRLA,GRLO,GRPO,OTOL,PHIA,PHIO,PLA1,
     +                   PLA2,PLA3,PLA4,PLB1,PLB2,PLB3,PLB4,PLTR,ROTA,
     +                   SRCH,XLOW,XROW,YBOW,YTOW,IDOT,IDSH,IDTL,ILCW,
     +                   ILTS,JPRJ,ELPF,INTF,LBLF,PRMF
        DOUBLE PRECISION GRDR,GRID,GRLA,GRLO,GRPO,OTOL,PHIA,PHIO,PLA1,
     +                   PLA2,PLA3,PLA4,PLB1,PLB2,PLB3,PLB4,PLTR,ROTA,
     +                   SRCH,XLOW,XROW,YBOW,YTOW
        INTEGER          IDOT,IDSH,IDTL,ILCW,ILTS,JPRJ
        LOGICAL          ELPF,INTF,LBLF,PRMF
        SAVE   /MAPCM4/
C
        COMMON /MAPCM6/  UCNM,UMNM,UMXM,URNM,VCNM,VMNM,VMXM,VRNM,ELPM
        DOUBLE PRECISION UCNM,UMNM,UMXM,URNM,VCNM,VMNM,VMXM,VRNM
        LOGICAL ELPM
        SAVE   /MAPCM6/
C
C Check for an uncleared prior error.
C
        IF (ICFELL('MDPTRA - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C If EZMAP needs initialization, do it.
C
        IF (INTF) THEN
          CALL MDPINT
          IF (ICFELL('MDPTRA',2).NE.0) RETURN
        END IF
C
C The call to MDPTRA is simply passed on to MDPTRN, but the values
C returned are checked to see if the point lies outside the perimeter;
C if so, the value 1.D12 is substituted for UVAL.
C
        CALL MDPTRN (RLAT,RLON,UVAL,VVAL)
        IF (ICFELL('MDPTRA',3).NE.0) RETURN
C
        IF (ELPM) THEN
          IF (((UVAL-UCNM)/URNM)**2+
     +        ((VVAL-VCNM)/VRNM)**2.GT.1.000002D0) THEN
            UVAL=1.D12
            VVAL=1.D12
          END IF
        ELSE
          IF (UVAL.LT.UMNM.OR.UVAL.GT.UMXM.OR.
     +        VVAL.LT.VMNM.OR.VVAL.GT.VMXM) THEN
            UVAL=1.D12
            VVAL=1.D12
          END IF
        END IF
C
        RETURN
C
      END

      PROGRAM THSTMV
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)

      CALL HSTMV(IERR)
C
C Deactivate and close the workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      STOP
      END
      SUBROUTINE HSTMV (IERROR)
C
C PURPOSE                To provide a demonstration of the Histogram
C                        utility when special flagged values occur in
C                        the input data.
C
C USAGE                  CALL HSTMV (IERROR)
C
C ARGUMENTS
C
C ON OUTPUT              IERROR
C                          An error flag
C                          = 0, If the test is successful,
C                          = 1, otherwise.
C
C I/O                    If the test is successful, the message
C
C                          HISTGR TEST SUCCESSFUL  . . .  SEE PLOT
C                          TO VERIFY PERFORMANCE
C
C                        is written on unit 6.
C
C                        Verify success by examing the plot produced.
C
C PRECISION              Single
C
C REQUIRED LIBRARY       HISTGR
C FILES
C
C REQUIRED GKS LEVEL     0A
C
C LANGUAGE               FORTRAN 77
C
C HISTORY                Written by Bob Lackman, October 1993.
C
C ALGORITHM              THSTMV computes data and calls HISTGR
C                        with special values
C
C
C  Array DAT1 is filled with values to be used as input for HISTGR
C
      PARAMETER ( NDIM=320, NCLS=17, NWRK=374 )
C
C  NWRK = NDIM + 3*(NCLS+1)
C
      REAL  DAT1(NDIM,2), X, WORK(NWRK)
      REAL  CLASS(NCLS+1)
      REAL  ARRAY(2)
      CHARACTER*1 IFC
C
C Change the Plotchar special character code from a : to a @
C
      IFC(1:1) = '@'
      CALL PCSETC('FC',IFC)
C
C Change the print font to the high quality filled times roman.
C
      CALL PCSETC('FN','times-roman')
C
C     Plot 1:   IFLAG = 0, input values are sorted into 11 equal classes
C
      IFLAG = 0
      NCLASS = 11
      NPTS = 320
C
      DO 105 I=1,NPTS
        DO 105 J=1,2
          DAT1(I,J)=0.
  105 CONTINUE
C
      DO  110 I=1,NPTS
        X = REAL(I)
        DAT1(I,1) = 10. * ALOG10(0.1*X+1.)
  110 CONTINUE
C
C Put in some special values
C
	DAT1(7,1)  = -999.
	DAT1(44,1) = -999.
	DAT1(79,1) = -999.
C
	DO 111 L=200,320
	DAT1(L,1) = -999.
  111   CONTINUE
C
C  (First call HSTOPL('DEF=ON') to activate all default options.)
C
      CALL HSTOPL('DE=ON')
C
C  Then call HSTOPR to activate special value checking
C
      ARRAY(1) = -999.
      ARRAY(2) = 1.E-6
      CALL HSTOPR('MV=ON',ARRAY,2)
C
C  Call HSTOPL with NMV = ON, so normalization is by NPTS-MISS.
C
      CALL HSTOPL('NM=ON')
C
C  Call HSTOPL with PMV = ON, so NPTS and MISS are written on the plot.
C
      CALL HSTOPL('PM=ON')
C
C  Turn on the printing of the option list.
C
      CALL HSTOPL('LI=ON')
C
C  Print a main title.
C
      CALL HSTOPC('TIT=ON','Demonstration plot for Histogram.  Special v
     +alue = -999.',0,0)
      CALL HISTGR(DAT1, NDIM, NPTS, IFLAG, CLASS, NCLASS, WORK, NWRK)
C
C     Plot 2:   IFLAG = 1, input values are sorted into a defined set of
C               8 classes.
C
      IFLAG = 1
      NCLASS = 8
      CLASS(1) = -0.6
      DO 550 I = 1,NCLASS
        CLASS(I+1) = CLASS(I) + 0.20
550   CONTINUE
C
C  Create some input data.
C
      X = 0.
      DO 500 I = 1,NPTS
        DAT1(I,1) = SIN(X)
        X = X + .02
  500 CONTINUE
C
C Put in some special values
C
	DAT1(7,1)  = -999.
	DAT1(44,1) = -999.
	DAT1(79,1) = -999.
C
	DO 112 L=100,220
	DAT1(L,1) = -999.
  112   CONTINUE
C
C  (First call HSTOPL('DEF=ON') to activate all default options.)
C
      CALL HSTOPL('DE=ON')
C
C  Then call HSTOPR to activate special value checking
C
      ARRAY(1) = -999.
      ARRAY(2) = 1.E-6
      CALL HSTOPR('MV=ON',ARRAY,2)
C
C  Call HSTOPL with NMV = OFF so normalization is relative to NPTS.
C
      CALL HSTOPL('NM=OF')
C
C  Call HSTOPL with PMV = ON, so NPTS and MISS are written on the plot.
C
      CALL HSTOPL('PM=ON')
C
      CALL HSTOPC('TIT=ON','Demonstration plot for Histogram.  Normalize
     + to the original number of points.',0,0)
      CALL HISTGR(DAT1, NDIM, NPTS, IFLAG, CLASS, NCLASS, WORK, NWRK)
C
C     Plot 3:   IFLAG = 1, define the CLASS values so as to capture
C               the missing value counts.
C
      IFLAG = 1
      NCLASS = 7
C
C  Set the first class bin between -1000. and -0.6.  Missing values
C   of -999. will fall into this bin.
C
      CLASS(1) = -1000.
      CLASS(2) = -0.6
      DO 555 I = 2,NCLASS
	CLASS(I+1) = CLASS(I) + 0.30
555   CONTINUE
      NPTS = 320
C
      DO 106 I=1,NPTS
	DO 106 J=1,2
          DAT1(I,J)=0.
  106 CONTINUE
C
C  Define some data
C
      X = 0.
      DO 600 I = 1,NPTS
        DAT1(I,1) = SIN(X)
        X = X + .02
  600 CONTINUE
C
C Put in some special values
C
	DAT1(7,1)  = -999.
	DAT1(44,1) = -999.
	DAT1(79,1) = -999.
C
	DO 113 L=200,320
	DAT1(L,1) = -999.
  113   CONTINUE
C
C  (First call HSTOPL('DEF=ON') to activate all default options.)
C
      CALL HSTOPL('DE=ON')
C
C  Label the histogram bar endpoints
C
      CALL HSTOPL('MI=OF')
C
C  Convert the class label format to F7.1
C
      CALL HSTOPC('FOR=ON','(F7.1)',9,7)
C
C  To see the missing values in a histogram bar.  Choose CLASS
C    values so that the missing value indicator becomes a bar
C    and use MVA = OFF (default.)
C
      CALL HSTOPC('TIT=ON','Demo plot for special value in Histogram.
     + Title length has been increased to 96 characters.',0,0)
C
      CALL HISTGR(DAT1, NDIM, NPTS, IFLAG, CLASS, NCLASS, WORK, NWRK)
C
      IERROR = 0
      WRITE (6,1001)
C
      RETURN
C
 1001 FORMAT ('  HISTGR TEST SUCCESSFUL',24X,
     1        'SEE PLOT TO VERIFY PERFORMANCE')
      END

C
C $Id: gridl.f,v 1.7 2008-07-27 00:17:14 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GRIDL (MJRX,MNRX,MJRY,MNRY)
        IF (ICFELL('GRIDL - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
        CALL GRIDAL (MJRX,MNRX,MJRY,MNRY,1,1,0,0.,0.)
        IF (ICFELL('GRIDL',2).NE.0) RETURN
        RETURN
      END

      SUBROUTINE SGER  ( M, N, ALPHA, X, INCX, Y, INCY, A, LDA )
*     .. Scalar Arguments ..
      REAL               ALPHA
      INTEGER            INCX, INCY, LDA, M, N
*     .. Array Arguments ..
      REAL               A( LDA, * ), X( * ), Y( * )
*     ..
*
*  Purpose
*  =======
*
*  SGER   performs the rank 1 operation
*
*     A := alpha*x*y' + A,
*
*  where alpha is a scalar, x is an m element vector, y is an n element
*  vector and A is an m by n matrix.
*
*  Parameters
*  ==========
*
*  M      - INTEGER.
*           On entry, M specifies the number of rows of the matrix A.
*           M must be at least zero.
*           Unchanged on exit.
*
*  N      - INTEGER.
*           On entry, N specifies the number of columns of the matrix A.
*           N must be at least zero.
*           Unchanged on exit.
*
*  ALPHA  - REAL            .
*           On entry, ALPHA specifies the scalar alpha.
*           Unchanged on exit.
*
*  X      - REAL             array of dimension at least
*           ( 1 + ( m - 1 )*abs( INCX ) ).
*           Before entry, the incremented array X must contain the m
*           element vector x.
*           Unchanged on exit.
*
*  INCX   - INTEGER.
*           On entry, INCX specifies the increment for the elements of
*           X. INCX must not be zero.
*           Unchanged on exit.
*
*  Y      - REAL             array of dimension at least
*           ( 1 + ( n - 1 )*abs( INCY ) ).
*           Before entry, the incremented array Y must contain the n
*           element vector y.
*           Unchanged on exit.
*
*  INCY   - INTEGER.
*           On entry, INCY specifies the increment for the elements of
*           Y. INCY must not be zero.
*           Unchanged on exit.
*
*  A      - REAL             array of DIMENSION ( LDA, n ).
*           Before entry, the leading m by n part of the array A must
*           contain the matrix of coefficients. On exit, A is
*           overwritten by the updated matrix.
*
*  LDA    - INTEGER.
*           On entry, LDA specifies the first dimension of A as declared
*           in the calling (sub) program. LDA must be at least
*           max( 1, m ).
*           Unchanged on exit.
*
*
*  Level 2 Blas routine.
*
*  -- Written on 22-October-1986.
*     Jack Dongarra, Argonne National Lab.
*     Jeremy Du Croz, Nag Central Office.
*     Sven Hammarling, Nag Central Office.
*     Richard Hanson, Sandia National Labs.
*
*
*     .. Parameters ..
      REAL               ZERO
      PARAMETER        ( ZERO = 0.0E+0 )
*     .. Local Scalars ..
      REAL               TEMP
      INTEGER            I, INFO, IX, J, JY, KX
*     .. External Subroutines ..
      EXTERNAL           XERBLA
*     .. Intrinsic Functions ..
      INTRINSIC          MAX
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      IF     ( M.LT.0 )THEN
         INFO = 1
      ELSE IF( N.LT.0 )THEN
         INFO = 2
      ELSE IF( INCX.EQ.0 )THEN
         INFO = 5
      ELSE IF( INCY.EQ.0 )THEN
         INFO = 7
      ELSE IF( LDA.LT.MAX( 1, M ) )THEN
         INFO = 9
      END IF
      IF( INFO.NE.0 )THEN
         CALL XERBLA( 'SGER  ', INFO )
         RETURN
      END IF
*
*     Quick return if possible.
*
      IF( ( M.EQ.0 ).OR.( N.EQ.0 ).OR.( ALPHA.EQ.ZERO ) )
     $   RETURN
*
*     Start the operations. In this version the elements of A are
*     accessed sequentially with one pass through A.
*
      IF( INCY.GT.0 )THEN
         JY = 1
      ELSE
         JY = 1 - ( N - 1 )*INCY
      END IF
      IF( INCX.EQ.1 )THEN
         DO 20, J = 1, N
            IF( Y( JY ).NE.ZERO )THEN
               TEMP = ALPHA*Y( JY )
               DO 10, I = 1, M
                  A( I, J ) = A( I, J ) + X( I )*TEMP
   10          CONTINUE
            END IF
            JY = JY + INCY
   20    CONTINUE
      ELSE
         IF( INCX.GT.0 )THEN
            KX = 1
         ELSE
            KX = 1 - ( M - 1 )*INCX
         END IF
         DO 40, J = 1, N
            IF( Y( JY ).NE.ZERO )THEN
               TEMP = ALPHA*Y( JY )
               IX   = KX
               DO 30, I = 1, M
                  A( I, J ) = A( I, J ) + X( IX )*TEMP
                  IX        = IX        + INCX
   30          CONTINUE
            END IF
            JY = JY + INCY
   40    CONTINUE
      END IF
*
      RETURN
*
*     End of SGER  .
*
      END

C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE SUPRLS (I,ROWI,N,BI,A,NN,SOLN,ERR,IER)
      DIMENSION       ROWI(N)    ,A(NN)      ,SOLN(N)
      SAVE
C
      IER = 0
      IF (I .GT. 1) GO TO 101
C
C  Routine entered with I.LE.0 means complete the reduction and store
C  the solution in SOLN.
C
      IF (I .LE. 0) GO TO 125
C
C  Set up quantities on first call.
C
      IOLD = 0
      NP1 = N+1
C
C  Compute how many rows can be input now.
C
      L = NN/NP1
      ILAST = 0
      IL1 = 0
      K = 0
      K1 = 0
      ERRSUM = 0.
      NREQ = ((N+5)*N+2)/2
C
C  Error exit if insufficient scratch storage provided.
C
      IF (NN .GE. NREQ) GO TO 101
      IER = 32
      CALL CFAERR (IER,' SUPRLS - insufficient scratch storage provided. 
     + at least ((N+5)*N+2)/2 locations needed',88)
      RETURN
C
C  Store the row in the scratch storage.
C
  101 CONTINUE
C
C  Error exit if (I-IOLD).NE.1.
C
      IF ((I-IOLD) .EQ. 1) GO TO 102
      IER = 35
      CALL CFAERR (IER,' SUPRLS - values of I not in sequence',37)
      RETURN
C
  102 CONTINUE
      IOLD = I
      DO 103 J=1,N
         ILJ = ILAST+J
         A(ILJ) = ROWI(J)
  103 CONTINUE
      ILNP = ILAST+NP1
      A(ILNP) = BI
      ILAST = ILAST+NP1
      ISAV = I
      IF (I .LT. L) RETURN
  104 CONTINUE
      IF (K .EQ. 0) GO TO 115
      K1 = MIN0(K,N)
      IDIAG = -NP1
      IF (L-K .EQ. 1) GO TO 110
C
C  Apply householder transformations to zero out new rows.
C
      DO 109 J=1,K1
         IDIAG = IDIAG+(NP1-J+2)
         I1 = IL1+J
         I2 = I1+NP1*(L-K-1)
         S = A(IDIAG)*A(IDIAG)
         DO 105 II=I1,I2,NP1
            S = S+A(II)*A(II)
  105    CONTINUE
         IF (S .EQ. 0.) GO TO 109
         TEMP = A(IDIAG)
         A(IDIAG) = SQRT(S)
         IF (TEMP .GT. 0.) A(IDIAG) = -A(IDIAG)
         TEMP = TEMP-A(IDIAG)
         TEMP1 = 1./(TEMP*A(IDIAG))
         JP1 = J+1
         DO 108 J1=JP1,NP1
            JDEL = J1-J
            IDJ = IDIAG+JDEL
            S = TEMP*A(IDJ)
            DO 106 II=I1,I2,NP1
               IIJD = II+JDEL
               S = S+A(II)*A(IIJD)
  106       CONTINUE
            S = S*TEMP1
            A(IDJ) = A(IDJ)+S*TEMP
            DO 107 II=I1,I2,NP1
               IIJD = II+JDEL
               A(IIJD) = A(IIJD)+S*A(II)
  107       CONTINUE
  108    CONTINUE
  109 CONTINUE
      GO TO 113
C
C  Apply rotations to zero out the single new row.
C
  110 DO 112 J=1,K1
         IDIAG = IDIAG+(NP1-J+2)
         I1 = IL1+J
         IF (ABS(A(I1)) .LE. 1.E-18) THEN
           S = SQRT(A(IDIAG)*A(IDIAG))
         ELSE if (ABS(A(IDIAG)) .LT. 1.E-18) THEN
           S = SQRT(A(I1)*A(I1))
         ELSE
           S = SQRT(A(IDIAG)*A(IDIAG)+A(I1)*A(I1))
         ENDIF
         IF (S .EQ. 0.) GO TO 112
         TEMP = A(IDIAG)
         A(IDIAG) = S
         S = 1./S
         CN = TEMP*S
         SN = A(I1)*S
         JP1 = J+1
         DO 111 J1=JP1,NP1
            JDEL = J1-J
            IDJ = IDIAG+JDEL
            TEMP = A(IDJ)
            I1JD = I1+JDEL
            A(IDJ) = CN*TEMP+SN*A(I1JD)
            A(I1JD) = -SN*TEMP+CN*A(I1JD)
  111    CONTINUE
  112 CONTINUE
  113 IF (K .LT. N) GO TO 115
      LMKM1 = L-K
C
C  Accumulate residual sum of squares.
C
      DO 114 II=1,LMKM1
         ILNP = IL1+II*NP1
         ERRSUM = ERRSUM+A(ILNP)*A(ILNP)
  114 CONTINUE
      IF (I .LE. 0) GO TO 127
      K = L
      ILAST = IL1
C
C  Determine how many new rows may be input on next iteration.
C
      L = K+(NN-ILAST)/NP1
      RETURN
  115 K11 = K1+1
      K1 = MIN0(L,N)
      IF (L-K .EQ. 1) GO TO 122
      K1M1 = K1-1
      IF (L .GT. N) K1M1 = N
      I1 = IL1+K11-NP1-1
C
C  Perform householder transformations to reduce rows to upper 
C  triangular form.
C
      DO 120 J=K11,K1M1
         I1 = I1+(NP1+1)
         I2 = I1+(L-J)*NP1
         S = 0.
         DO 116 II=I1,I2,NP1
            S = S+A(II)*A(II)
  116    CONTINUE
         IF (S .EQ. 0.) GO TO 120
         TEMP = A(I1)
         A(I1) = SQRT(S)
         IF (TEMP .GT. 0.) A(I1) = -A(I1)
         TEMP = TEMP-A(I1)
         TEMP1 = 1./(TEMP*A(I1))
         JP1 = J+1
         I11 = I1+NP1
         DO 119 J1=JP1,NP1
            JDEL = J1-J
            I1JD = I1+JDEL
            S = TEMP*A(I1JD)
            DO 117 II=I11,I2,NP1
               IIJD = II+JDEL
               S = S+A(II)*A(IIJD)
  117       CONTINUE
            S = S*TEMP1
            I1JD = I1+JDEL
            A(I1JD) = A(I1JD)+S*TEMP
            DO 118 II=I11,I2,NP1
               IIJD = II+JDEL
               A(IIJD) = A(IIJD)+S*A(II)
  118       CONTINUE
  119    CONTINUE
  120 CONTINUE
      IF (L .LE. N) GO TO 122
      NP1MK = NP1-K
      LMK = L-K
C
C  Accumulate residual sum of squares.
C
      DO 121 II=NP1MK,LMK
         ILNP = IL1+II*NP1
         ERRSUM = ERRSUM+A(ILNP)*A(ILNP)
  121 CONTINUE
  122 IMOV = 0
      I1 = IL1+K11-NP1-1
C
C  Squeeze the unnecessary elements out of scratch storage to 
C  allow space for more rows.
C
      DO 124 II=K11,K1
         IMOV = IMOV+(II-1)
         I1 = I1+NP1+1
         I2 = I1+NP1-II
         DO 123 III=I1,I2
            IIIM = III-IMOV
            A(IIIM) = A(III)
  123    CONTINUE
  124 CONTINUE
      ILAST = I2-IMOV
      IL1 = ILAST
      IF (I .LE. 0) GO TO 127
      K = L
C
C  Determine how many new rows may be input on next iteration.
C
      L = K+(NN-ILAST)/NP1
      RETURN
C
C  Complete reduction and store solution in SOLN.
C
  125 L = ISAV
C
C  Error exit if L less than N.
C
      IF (L .GE. N) GO TO 126
      IER = 33
      CALL CFAERR (IER,' SUPRLS - array has too few rows.',33)
      RETURN
  126 CONTINUE
C
C  K.NE.ISAV means further reduction needed.
C
      IF (K .NE. ISAV) GO TO 104
  127 ILAST = (NP1*(NP1+1))/2-1
      IF (A(ILAST-1) .EQ. 0.) GO TO 130
C
C Solve triangular system into ROWI.
C
      SOLN(N) = A(ILAST)/A(ILAST-1)
      DO 129 II=2,N
         IIM1 = II-1
         ILAST = ILAST-II
         S = A(ILAST)
         DO 128 K=1,IIM1
            ILK = ILAST-K
            NPK = NP1-K
            S = S-A(ILK)*SOLN(NPK)
  128    CONTINUE
         ILII = ILAST-II
         IF (A(ILII) .EQ. 0.) GO TO 130
         NPII = NP1-II
         SOLN(NPII) = S/A(ILII)
  129 CONTINUE
C
C  Store residual norm.
C
      ERR = SQRT(ERRSUM)
      RETURN
C
C  Error return if system is singular.
C
  130 CONTINUE
      IER = 34
      CALL CFAERR (IER,' SUPRLS - system is singular.',29)
      RETURN
C
      END

C
C	$Id: sigplc.f,v 1.5 2008-07-27 00:16:54 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      REAL FUNCTION SIGPLC(M1,M2,HUE)
C
C_BEGIN PROLOGUE SIGPLC
C
C_SUBSIDIARY HLSRGB, HSVRGB
C
C_PURPOSE
C    To define a generic piecewise linear curve (as a function
C    of HUE) which can be used to calculate the R, G, B
C    values.
C
C_DESCRIPTION
C    This subroutine takes a minimum and maximum value and
C    defines a piecewise linear curve as a function of HUE.
C
C_ARGUMENTS
C
C M1      (INPUT,SINGLE,VARIABLE)  The minimum value.
C
C M2      (INPUT,SINGLE,VARIABLE)  The maximum value.
C
C HUE     (INPUT,SINGLE,VARIABLE)  Hue.
C
C_I/O
C    (NONE)
C
C_ROUTINES CALLED
C    (NONE)
C
C_COMMON BLOCKS
C    (NONE)
C
C_MAXIMUM GKS LEVEL
C    (NONE)
C
C_LANGUAGE
C    FORTRAN
C
C_REVISION DATE
C    880511 (YYMMDD)
C
C_HISTORY
C    This subroutine was originally coded at NCAR by Roy Barnes
C    using the algorithm presented in Foley and van Dam (see
C    REFERENCES); it was prepared for the NCAR Graphics
C    package by Fred Clare.
C
C_REFERENCES
C    Foley, James D. and van Dam, Andries,"Fundamentals of Interactive
C    Computer Graphics",Addison-Wesley Publishing Company, 1982.
C
C    Smith, A.R.,"Color Gamut Transformation Pairs",SIGGRAPH '78
C    Proceedings, published as Computer Graphics, 12(3),August 1978,
C    pp.12-19.
C
C_END PROLOGUE SIGPLC
C
      REAL M1,M2,HUE,H
C_FIRST EXECUTABLE STATEMENT SIGPLC
      H = HUE
      H = MOD(H,360.)
      IF (H .LT. 0.) H = H+360.
      IF (H .LT. 60.0) THEN
C
C  Linear curve from M1 to M2 if HUE is in [0.,60.)
C
          SIGPLC = M1 + (M2 - M1) * H / 60.0
      ELSE IF (H .LT. 180.0) THEN
C
C  Maximum value for HUE in [60.,180.)
C
          SIGPLC = M2
      ELSE IF (H .LT. 240.0) THEN
C
C  Linear curve from M2 to M1 for HUE in [180.,240.)
C
          SIGPLC = M1 + (M2 - M1) * (240.0 - H) / 60.0
      ELSE
C
C  Minimum value for HUE in [240.,360.)
C
          SIGPLC = M1
      ENDIF
C
C  Guarantee SIGPLC is in the range 0. to 1.
C
      SIGPLC = MIN(1.,MAX(0.,SIGPLC))
      RETURN
      END

C NCLFORTSTART
        subroutine spi3ncdc(ntim,pp,pmsg,nrun,spi3,probne,pcpacc,index,
     +                      y, x, temparr,maxyrs,maxyrsp1,ier)
        implicit none
c                                 INPUT
        integer ntim, nrun, ier, maxyrs, maxyrsp1
        double precision pp(ntim), pmsg
        double precision probne(ntim),pcpacc(ntim)
     +                 , y(ntim),x(maxyrs),temparr(maxyrsp1)
     +                 , index(ntim)
c                                 OUTPUT
        double precision spi3(ntim)
C NCLEND
c
c NCL:   spi3 = dim_spi3_n(p,nrun,opt,dims)   ; same as 'dim_spi_n' 
c
c                                 LOCAL
        integer  num(12),numpos(12), nt
        double precision pzero(12)
        double precision par1(12),par2(12),par3(12),
     +                   xmom1(12),xmom2(12),xmom3(12)

        do nt=1,ntim
           spi3(nt) = pmsg
        end do

        if (mod(ntim,12).ne.0) then
            ier = 1
            return
        end if

C This is being passed in by C calling routine
C       maxyrs = ntim/12     
       
        call  spipe3(nrun,pp,par1,par2,par3,pzero,spi3,probne
     1              ,pcpacc,xmom1,xmom2,xmom3,pmsg,num,numpos
     2              ,maxyrs,index,y,x,temparr)

        return
        end

C --------------  NCDC code --------------------------------------
c To avoid subroutine name conflicts:
C .        change 'subroutine sort' to 'subroutine sortncdc'

        SUBROUTINE SPIPE3(nrun,pp,par1,par2,par3,pzero,spi,probne,
     1  pcpacc,xmom1,xmom2,xmom3,amssng,num,numpos,maxyrs,index,y,
     2  x,temparr)
c    
c       INPUT:  pp                one dimensional array of input data
c                                 where input is monthly precip data 
c                                 beginning with a January value
c               nrun              length of moving totals
c               amssng            value for missing data
c               maxyrs            maximum possible number of years of
c                                 data
c
c       OUTPUT: par1,par2,par3    parameters (mean, s.d., skewness) of
c                                 Pearson Type III distribution used to
c                                 fit the input data > 0
c               xmom1,xmom2,xmom3 l-moments of the input data > 0
c               pzero             relative  frequency of input data = 0
c               spi               standardized precip index
c               probne            probability of observed data <= x
c               pcpacc            data accumulated over length nrun
c               num               number of non-missing observations
c               numpos            number of non-zero observations
c
c       This program used the program of John Kleist, Colorado State
c       Univ., that computed spi values from a 2 parameter ML gamma
c       probability distribution, as a basis for the moving totals, etc.
c       code.  I added the PE3 l-moment computations.  The subroutines
c       and functions in upper case came from Jon Hosking, IBM.
c               Ned Guttman
c               Nov. 1997
c
        double precision  pp(maxyrs*12),probne(maxyrs*12),amssng,
     1                    pcpacc(maxyrs*12),pzero(12),spi(maxyrs*12)
        integer           num(12),numpos(12)

        double precision par1(12),par2(12),par3(12),index(maxyrs*12),
     1    xmom1(12),xmom2(12),xmom3(12),xmom(3),para(3),
     2    y(maxyrs*12),x(maxyrs),temparr(maxyrs+1),
     3    cdfpe3,quastn
c
c
c       save par1,par2,par3 to 8 decimal places if you want to use
c       them later for any additional calculations...not keeping
c       enough decimal places leads to errors in probabilities!     
c
c
c       the first nrun-1 index values will be missing
c
        do 10 j=1,nrun-1   
          index(j)=amssng
          probne(j)=amssng
          pcpacc(j)=amssng
 10     continue 
c
c       sum nrun precip values; store them in appropriate index location
C
c       if any value is missing, set the sum to missing
c
        do 30 j=nrun,maxyrs*12
          index(j)=0.0
          do 20 i=0,nrun-1
            if(pp(j-i).ne.amssng)then
              index(j)=index(j)+pp(j-i)
              pcpacc(j)=index(j)
            else
              index(j)=amssng
              probne(j)=amssng
              pcpacc(j)=amssng
              goto 30
            endif
 20       continue
 30     continue
       
c
c       to maintain seasonality, do everything by month
c
        do 50 i=0,11
           n=0
           nz=0
           np=0
           if (nrun.le.12) then
             do 40 j=nrun+i,maxyrs*12,12
               if(index(j).ne.amssng) then
c
c          this routine calculates lmoments and parameters of the PE3
c          distribution for all input data.  if you want to compute the
c          parameters for a specific period of record, then the limits
c          of j must be set appropriately for temparr. it is recommended
c          that for both monitoring and historical perspective that
c          all data be used for computing the probabilities, and that
c          the historical time series be the "latest" and most complete
c          output.
c
c          n-count for all non-missing data, including zeroes
c
                 n=n+1
                 if(index(j).gt.0) then
c
c          n-count for all non-missing, non-zero data; temparr is for
c          non-zero, non-missing precipitation
c
                   np=np+1
                   temparr(np)=index(j)
                 else 
c
c          n-count for all non-missing, zero data
c
                   nz=nz+1
                 endif
               endif
 40          continue
        elseif (nrun.gt.12) then
          j=nrun+i 
c
c         step the sequence of data by the length of nrun to get
c         independent samples 
c
          if (nrun.gt.12.and.nrun.le.24) nstep=24
          if (nrun.gt.24.and.nrun.le.36) nstep=36
          if (nrun.gt.36.and.nrun.le.48) nstep=48
          if (nrun.gt.48.and.nrun.le.60) nstep=60
          if (nrun.gt.60.and.nrun.le.72) nstep=72
 41       if (j.gt.maxyrs*12) GOTO 42
c
c          this routine calculates lmoments and parameters of the PE3
c          distribution for all input data.  if you want to compute the
c          parameters for a specific period of record, then the limits
c          of j must be set appropriately for temparr
c
             if(index(j).ne.amssng) then
               n=n+1
               if(index(j).gt.0) then
                 np=np+1
                 temparr(np)=index(j)
               else 
                 nz=nz+1
               endif
               j=j+nstep
               goto 41
             else
c
c          look for next non-missing nrun>12 value
c
               j=j+12
               goto 41
             endif
           endif
 42     im=mod(nrun+i-1,12)+1
        pzero(im)=float(nz)/float(n)
        num(im)=n
        numpos(im)=np
c
c       order the data
c
        call sortncdc(temparr,x,np,maxyrs)
c   
c       fit l-moments for non-zero precip; if 2nd moment=0, routine
c       fails and all 3 moments set to zero (condition indicates all
c       data values are equal).  also, if not enough non-zero data
c       (less than 3), routine fails and all moments set to zero.
c
cR c c  call samlmr(x,np,xmom,3,-0.00D0,ODO,ifail) 
        call samlmr(x,np,xmom,3, 0.00D0,0d0,ifail) 
        xmom1(im)=xmom(1)
        xmom2(im)=xmom(2)
        xmom3(im)=xmom(3)
c       
c       compute parameters of Pearson type III (3-parameter gamma); the
c       three parameters are the mean, s.d., skewness of the NON-ZERO data.
c       The mean for all the data is (1-pzero)*par1 or (1-pzero)*xmom1
c       since par1=xmom1
c
        call pelpe3(xmom,para,ifail)
c
c       if ifail not = 0, then all 3 parameters are set to zero
c       if routine fails, output is sent to unit 6 by pelpe3 routine
c
        par1(im)=para(1)
        par2(im)=para(2)
        par3(im)=para(3)
 50     continue
c
c       compute the probability (cdfpe3), take into account the 
c       mixed distribution if pzero not equal to zero, truncate
c       the probability from .001 to .999, transform the probability to
c       spi (quastn). ifail=1 indicates invalid parameter 2 (negative).
c       if routines fail, output is sent to unit 6 by called routines.
c
        do 60 j=nrun,maxyrs*12
          im=mod(j-1,12)+1
          para(1)=par1(im)
          para(2)=par2(im)
          para(3)=par3(im)
c
c         set missing values to amssng
c
 61       if(index(j).eq.amssng) then
             probne(j)=amssng
             spi(j)=amssng
             goto 60
          endif
          if(index(j).ne.amssng) then
             index(j)=cdfpe3(index(j),para,ifail,amssng)
c
c         if cdf routine fails, set probne and spi = amssng
c
             if(ifail.ne.0) then
               index(j)=amssng
               goto 61
             endif
             y(j)=pzero(im)+(1-pzero(im))*index(j)
c
c            force the probabilities and therefore the spi to be bounded
c            by +/- 3.09
c
             if(y(j).gt..999)y(j)=.999
             if(y(j).lt..001)y(J)=.001
             probne(j)=y(j)
             index(j)=quastn(y(j))
             spi(j)=index(j)
          endif
 60    continue
       return
       end
c
c
      DOUBLE PRECISION FUNCTION CDFPE3(X,PARA,ifail,amssng)
C***********************************************************************
C*                                                                     *
C*  FORTRAN CODE WRITTEN FOR INCLUSION IN IBM RESEARCH REPORT RC20525, *
C*  'FORTRAN ROUTINES FOR USE WITH THE METHOD OF L-MOMENTS, VERSION 3' *
C*                                                                     *
C*  J. R. M. HOSKING                                                   *
C*  IBM RESEARCH DIVISION                                              *
C*  T. J. WATSON RESEARCH CENTER                                       *
C*  YORKTOWN HEIGHTS                                                   *
C*  NEW YORK 10598, U.S.A.                                             *
C*                                                                     *
C*  VERSION 3     AUGUST 1996                                          *
C*                                                                     *
C***********************************************************************
C
C  DISTRIBUTION FUNCTION OF THE PEARSON TYPE 3 DISTRIBUTION
C
C  OTHER ROUTINES USED: DERFLM,DLGAMALM,GAMINDLM
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DOUBLE PRECISION PARA(3)
      DATA ZERO/0D0/,HALF/0.5D0/,ONE/1D0/,TWO/2D0/,FOUR/4D0/
      DATA RTHALF/0.70710 67811 86547 524D0/
C
C         SMALL IS USED TO TEST WHETHER SKEWNESS IS EFFECTIVELY ZERO
C
      DATA SMALL/1D-6/
C
      ifail=0
      CDFPE3=ZERO
      IF(PARA(2).LE.ZERO)GOTO 1000
      GAMMA=PARA(3)
      IF(DABS(GAMMA).LE.SMALL)GOTO 10
      ALPHA=FOUR/(GAMMA*GAMMA)
      Z=TWO*(X-PARA(1))/(PARA(2)*GAMMA)+ALPHA
      IF(Z.GT.ZERO)CDFPE3=GAMINDLM(Z,ALPHA,DLGAMALM(ALPHA))
      IF(GAMMA.LT.ZERO)CDFPE3=ONE-CDFPE3
      RETURN
C
C         ZERO SKEWNESS
C
   10 Z=(X-PARA(1))/PARA(2)
      CDFPE3=HALF+HALF*DERFLM(Z*RTHALF)
      RETURN
C
1000  WRITE(6,7000)
      ifail=1
      cdfpe3=amssng
      RETURN
C
 7000 FORMAT(' *** ERROR *** ROUTINE CDFPE3 : PARAMETERS INVALID')
      END
c
c
      SUBROUTINE PELPE3(XMOM,PARA,ifail)
C***********************************************************************
C*                                                                     *
C*  FORTRAN CODE WRITTEN FOR INCLUSION IN IBM RESEARCH REPORT RC20525, *
C*  'FORTRAN ROUTINES FOR USE WITH THE METHOD OF L-MOMENTS, VERSION 3' *
C*                                                                     *
C*  J. R. M. HOSKING                                                   *
C*  IBM RESEARCH DIVISION                                              *
C*  T. J. WATSON RESEARCH CENTER                                       *
C*  YORKTOWN HEIGHTS                                                   *
C*  NEW YORK 10598, U.S.A.                                             *
C*                                                                     *
C*  VERSION 3     AUGUST 1996                                          *
C*                                                                     *
C***********************************************************************
C
C  PARAMETER ESTIMATION VIA L-MOMENTS FOR THE PEARSON TYPE 3 DISTRIBUTION
C
C  PARAMETERS OF ROUTINE:
C  XMOM   * INPUT* ARRAY OF LENGTH 3. CONTAINS THE L-MOMENTS LAMBDA-1,
C                  LAMBDA-2 AND TAU-3.
C  PARA   *OUTPUT* ARRAY OF LENGTH 3. ON EXIT, CONTAINS THE PARAMETERS
C                  IN THE ORDER MU, SIGMA, GAMMA (MEAN, S.D., SKEWNESS).
C
C  OTHER ROUTINES USED: DLGAMALM
C
C  METHOD: RATIONAL APPROXIMATION IS USED TO EXPRESS ALPHA, THE SHAPE
C  PARAMETER OF THE GAMMA DISTRIBUTION, AS A FUNCTION OF TAU-3.
C  RELATIVE ACCURACY OF THE APPROXIMATION IS BETTER THAN 3E-5.
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DOUBLE PRECISION XMOM(3),PARA(3)
      DATA ZERO/0D0/,THIRD/0.33333333D0/,HALF/0.5D0/,ONE/1D0/,TWO/2D0/
C
C         SMALL IS USED TO TEST WHETHER SKEWNESS IS EFFECTIVELY ZERO
C
      DATA SMALL/1D-6/
C
C         CONSTANTS USED IN MINIMAX APPROXIMATIONS
C
      DATA C1,C2,C3/ 0.2906D0,  0.1882D0,  0.0442D0/
      DATA D1,D2,D3/ 0.36067D0,-0.59567D0, 0.25361D0/
      DATA D4,D5,D6/-2.78861D0, 2.56096D0,-0.77045D0/
      DATA PI3,ROOTPI/9.4247780D0,1.7724539D0/
C
      ifail=0
      T3=DABS(XMOM(3))
      IF(XMOM(2).LE.ZERO.OR.T3.GE.ONE)GOTO 1000
      IF(T3.LE.SMALL)GOTO 100
      IF(T3.GE.THIRD)GOTO 10
      T=PI3*T3*T3
      ALPHA=(ONE+C1*T)/(T*(ONE+T*(C2+T*C3)))
      GOTO 20
   10 CONTINUE
      T=ONE-T3
      ALPHA=T*(D1+T*(D2+T*D3))/(ONE+T*(D4+T*(D5+T*D6)))
   20 CONTINUE
      RTALPH=DSQRT(ALPHA)
      BETA=ROOTPI*XMOM(2)*DEXP(DLGAMALM(ALPHA)-DLGAMALM(ALPHA+HALF))
      PARA(1)=XMOM(1)
      PARA(2)=BETA*RTALPH
      PARA(3)=TWO/RTALPH
      IF(XMOM(3).LT.ZERO)PARA(3)=-PARA(3)
      RETURN
C
C         ZERO SKEWNESS
C
  100 CONTINUE
      PARA(1)=XMOM(1)
      PARA(2)=XMOM(2)*ROOTPI
      PARA(3)=ZERO
      RETURN
C
c1000 WRITE(6,7000)
 1000 DO 1010 I=1,3
 1010 PARA(I)=ZERO
      ifail=1
      RETURN
C
C 7000 FORMAT(' *** ERROR *** ROUTINE PELPE3 : L-MOMENTS INVALID')
      END
c
c
c
      SUBROUTINE SAMLMR(X,N,XMOM,NMOM,A,B,ifail)
C***********************************************************************
C*                                                                     *
C*  FORTRAN CODE WRITTEN FOR INCLUSION IN IBM RESEARCH REPORT RC20525, *
C*  'FORTRAN ROUTINES FOR USE WITH THE METHOD OF L-MOMENTS, VERSION 3' *
C*                                                                     *
C*  J. R. M. HOSKING                                                   *
C*  IBM RESEARCH DIVISION                                              *
C*  T. J. WATSON RESEARCH CENTER                                       *
C*  YORKTOWN HEIGHTS                                                   *
C*  NEW YORK 10598, U.S.A.                                             *
C*                                                                     *
C*  VERSION 3     AUGUST 1996                                          *
C*                                                                     *
C***********************************************************************
C
C  SAMPLE L-MOMENTS OF A DATA ARRAY
C
C  PARAMETERS OF ROUTINE:
C  X      * INPUT* ARRAY OF LENGTH N. CONTAINS THE DATA, IN ASCENDING
C                  ORDER.
C  N      * INPUT* NUMBER OF DATA VALUES
C  XMOM   *OUTPUT* ARRAY OF LENGTH NMOM. ON EXIT, CONTAINS THE SAMPLE
C                  L-MOMENTS L-1, L-2, T-3, T-4, ... .
C  NMOM   * INPUT* NUMBER OF L-MOMENTS TO BE FOUND. AT MOST MAX(N,20).
C  A      * INPUT* ) PARAMETERS OF PLOTTING
C  B      * INPUT* ) POSITION (SEE BELOW)
C
C  FOR UNBIASED ESTIMATES (OF THE LAMBDA'S) SET A=B=ZERO. OTHERWISE,
C  PLOTTING-POSITION ESTIMATORS ARE USED, BASED ON THE PLOTTING POSITION
C  (J+A)/(N+B)  FOR THE J'TH SMALLEST OF N OBSERVATIONS. FOR EXAMPLE,
C  A=-0.35D0 AND B=0.0D0 YIELDS THE ESTIMATORS RECOMMENDED BY
C  HOSKING ET AL. (1985, TECHNOMETRICS) FOR THE GEV DISTRIBUTION.
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DOUBLE PRECISION X(N),XMOM(NMOM),SUM(20)
      DATA ZERO/0D0/,ONE/1D0/
      ifail=0
      IF(NMOM.GT.20.OR.NMOM.GT.N)GOTO 1000
      DO 10 J=1,NMOM
   10 SUM(J)=ZERO
      IF(A.EQ.ZERO.AND.B.EQ.ZERO)GOTO 50
      IF(A.LE.-ONE.OR.A.GE.B)GOTO 1010
C
C         PLOTTING-POSITION ESTIMATES OF PWM'S
C
      DO 30 I=1,N
      PPOS=(I+A)/(N+B)
      TERM=X(I)
      SUM(1)=SUM(1)+TERM
      DO 20 J=2,NMOM
      TERM=TERM*PPOS
   20 SUM(J)=SUM(J)+TERM
   30 CONTINUE
      DO 40 J=1,NMOM
   40 SUM(J)=SUM(J)/N
      GOTO 100
C
C         UNBIASED ESTIMATES OF PWM'S
C
   50 DO 70 I=1,N
      Z=I
      TERM=X(I)
      SUM(1)=SUM(1)+TERM
      DO 60 J=2,NMOM
      Z=Z-ONE
      TERM=TERM*Z
   60 SUM(J)=SUM(J)+TERM
   70 CONTINUE
      Y=N
      Z=N
      SUM(1)=SUM(1)/Z
      DO 80 J=2,NMOM
      Y=Y-ONE
      Z=Z*Y
   80 SUM(J)=SUM(J)/Z
C
C         L-MOMENTS
C
  100 K=NMOM
      P0=ONE
      IF(NMOM-NMOM/2*2.EQ.1)P0=-ONE
      DO 120 KK=2,NMOM
      AK=K
      P0=-P0
      P=P0
      TEMP=P*SUM(1)
      DO 110 I=1,K-1
      AI=I
      P=-P*(AK+AI-ONE)*(AK-AI)/(AI*AI)
  110 TEMP=TEMP+P*SUM(I+1)
      SUM(K)=TEMP
  120 K=K-1
      XMOM(1)=SUM(1)
      IF(NMOM.EQ.1)RETURN
      XMOM(2)=SUM(2)
      IF(SUM(2).EQ.ZERO)GOTO 1020
      IF(NMOM.EQ.2)RETURN
      DO 130 K=3,NMOM
  130 XMOM(K)=SUM(K)/SUM(2)
      RETURN
C
 1000 ifail=1
      do i=1,3
        xmom(i)=0
      enddo
      WRITE(6,7000)
      RETURN
 1010 WRITE(6,7010)
      RETURN
 1020 ifail=1
      do i=1,3
        xmom(i)=0
      enddo
      WRITE(6,7020)
      RETURN
C
 7000 FORMAT(' *** ERROR *** ROUTINE SAMLMR : PARAMETER NMOM INVALID')
 7010 FORMAT(' *** ERROR *** ROUTINE SAMLMR :',
     *  ' PLOTTING-POSITION PARAMETERS INVALID')
 7020 FORMAT(' *** ERROR *** ROUTINE SAMLMR : ALL DATA VALUES EQUAL')
      END
c
c
c
c RENAMED DERF to DERFLM to avoid name conflict.
      DOUBLE PRECISION FUNCTION DERFLM(X)
C***********************************************************************
C*                                                                     *
C*  FORTRAN CODE WRITTEN FOR INCLUSION IN IBM RESEARCH REPORT RC20525, *
C*  'FORTRAN ROUTINES FOR USE WITH THE METHOD OF L-MOMENTS, VERSION 3' *
C*                                                                     *
C*  J. R. M. HOSKING                                                   *
C*  IBM RESEARCH DIVISION                                              *
C*  T. J. WATSON RESEARCH CENTER                                       *
C*  YORKTOWN HEIGHTS                                                   *
C*  NEW YORK 10598, U.S.A.                                             *
C*                                                                     *
C*  VERSION 3     AUGUST 1996                                          *
C*                                                                     *
C***********************************************************************
C
C  ERROR FUNCTION
C
C  BASED ON ALGORITHM 5666, J.F.HART ET AL. (1968) 'COMPUTER
C  APPROXIMATIONS'
C
C  ACCURATE TO 15 DECIMAL PLACES
C
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
      DATA ZERO/0D0/,ONE/1D0/,TWO/2D0/,THREE/3D0/,FOUR/4D0/,P65/0.65D0/
C
C         COEFFICIENTS OF RATIONAL-FUNCTION APPROXIMATION
C
      DATA P0,P1,P2,P3,P4,P5,P6/
     *  0.22020 68679 12376 1D3,    0.22121 35961 69931 1D3,
     *  0.11207 92914 97870 9D3,    0.33912 86607 83830 0D2,
     *  0.63739 62203 53165 0D1,    0.70038 30644 43688 1D0,
     *  0.35262 49659 98910 9D-1/
      DATA Q0,Q1,Q2,Q3,Q4,Q5,Q6,Q7/
     *  0.44041 37358 24752 2D3,   0.79382 65125 19948 4D3,
     *  0.63733 36333 78831 1D3,   0.29656 42487 79673 7D3,
     *  0.86780 73220 29460 8D2,   0.16064 17757 92069 5D2,
     *  0.17556 67163 18264 2D1,   0.88388 34764 83184 4D-1/
C
C         C1 IS SQRT(2), C2 IS SQRT(2/PI)
C         BIG IS THE POINT AT WHICH DERFLM=1 TO MACHINE PRECISION
C
      DATA C1/1.4142 13562 37309 5D0/
      DATA C2/7.9788 45608 02865 4D-1/
      DATA BIG/6.25D0/,CRIT/5D0/
C
      DERFLM=ZERO
      IF(X.EQ.ZERO)RETURN
      XX=DABS(X)
      IF(XX.GT.BIG)GOTO 20
      EXPNTL=DEXP(-X*X)
      ZZ=DABS(X*C1)
      IF(XX.GT.CRIT)GOTO 10
      DERFLM=EXPNTL*((((((P6*ZZ+P5)*ZZ+P4)*ZZ+P3)*ZZ+P2)*ZZ+P1)
     * *ZZ+P0)/(((((((Q7*ZZ+Q6)*ZZ+Q5)*ZZ+Q4)*ZZ+Q3)*ZZ+Q2)*ZZ+Q1)
     * *ZZ+Q0)
      IF(X.GT.ZERO)DERFLM=ONE-TWO*DERFLM
      IF(X.LT.ZERO)DERFLM=TWO*DERFLM-ONE
      RETURN
C
   10 DERFLM=EXPNTL*C2/(ZZ+ONE/(ZZ+TWO/(ZZ+THREE/(ZZ+FOUR/(ZZ+P65)))))
      IF(X.GT.ZERO)DERFLM=ONE-DERFLM
      IF(X.LT.ZERO)DERFLM=DERFLM-ONE
      RETURN
C
   20 DERFLM=ONE
      IF(X.LT.ZERO)DERFLM=-ONE
      RETURN
      END
c
c
c
c RENAMED DLGAMA to DLGAMALM to avoid name conflict.
      DOUBLE PRECISION FUNCTION DLGAMALM(X)
C***********************************************************************
C*                                                                     *
C*  FORTRAN CODE WRITTEN FOR INCLUSION IN IBM RESEARCH REPORT RC20525, *
C*  'FORTRAN ROUTINES FOR USE WITH THE METHOD OF L-MOMENTS, VERSION 3' *
C*                                                                     *
C*  J. R. M. HOSKING                                                   *
C*  IBM RESEARCH DIVISION                                              *
C*  T. J. WATSON RESEARCH CENTER                                       *
C*  YORKTOWN HEIGHTS                                                   *
C*  NEW YORK 10598, U.S.A.                                             *
C*                                                                     *
C*  VERSION 3     AUGUST 1996                                          *
C*                                                                     *
C***********************************************************************
C
C  LOGARITHM OF GAMMA FUNCTION
C
C  BASED ON ALGORITHM ACM291, COMMUN. ASSOC. COMPUT. MACH. (1966)
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DATA SMALL,CRIT,BIG,TOOBIG/1D-7,13D0,1D9,2D36/
C
C         C0 IS 0.5*LOG(2*PI)
C         C1...C7 ARE THE COEFFTS OF THE ASYMPTOTIC EXPANSION OF DLGAMALM
C
      DATA C0,C1,C2,C3,C4,C5,C6,C7/
     *   0.91893 85332 04672 742D 0,  0.83333 33333 33333 333D-1,
     *  -0.27777 77777 77777 778D-2,  0.79365 07936 50793 651D-3,
     *  -0.59523 80952 38095 238D-3,  0.84175 08417 50841 751D-3,
     *  -0.19175 26917 52691 753D-2,  0.64102 56410 25641 026D-2/
C
C         S1 IS -(EULER'S CONSTANT), S2 IS PI**2/12
C
      DATA S1/-0.57721 56649 01532 861D 0/
      DATA S2/ 0.82246 70334 24113 218D 0/
C
      DATA ZERO/0D0/,HALF/0.5D0/,ONE/1D0/,TWO/2D0/
      DLGAMALM=ZERO
      IF(X.LE.ZERO)GOTO 1000
      IF(X.GT.TOOBIG)GOTO 1000
C
C         USE SMALL-X APPROXIMATION IF X IS NEAR 0, 1 OR 2
C
      IF(DABS(X-TWO).GT.SMALL)GOTO 10
      DLGAMALM=DLOG(X-ONE)
      XX=X-TWO
      GOTO 20
   10 IF(DABS(X-ONE).GT.SMALL)GOTO 30
      XX=X-ONE
   20 DLGAMALM=DLGAMALM+XX*(S1+XX*S2)
      RETURN
   30 IF(X.GT.SMALL)GOTO 40
      DLGAMALM=-DLOG(X)+S1*X
      RETURN
C
C         REDUCE TO DLGAMALM(X+N) WHERE X+N.GE.CRIT
C
   40 SUM1=ZERO
      Y=X
      IF(Y.GE.CRIT)GOTO 60
      Z=ONE
   50 Z=Z*Y
      Y=Y+ONE
      IF(Y.LT.CRIT)GOTO 50
      SUM1=SUM1-DLOG(Z)
C
C         USE ASYMPTOTIC EXPANSION IF Y.GE.CRIT
C
   60 SUM1=SUM1+(Y-HALF)*DLOG(Y)-Y+C0
      SUM2=ZERO
      IF(Y.GE.BIG)GOTO 70
      Z=ONE/(Y*Y)
      SUM2=((((((C7*Z+C6)*Z+C5)*Z+C4)*Z+C3)*Z+C2)*Z+C1)/Y
   70 DLGAMALM=SUM1+SUM2
      RETURN
C
 1000 WRITE(6,7000)X
      RETURN
C
 7000 FORMAT(' *** ERROR *** ROUTINE DLGAMALM :',
     *  ' ARGUMENT OUT OF RANGE :',D24.16)
      END
c
c
c
c RENAMED GAMIND to GAMINDLM to avoid name conflict.
      DOUBLE PRECISION FUNCTION GAMINDLM(X,ALPHA,G)
C***********************************************************************
C*                                                                     *
C*  FORTRAN CODE WRITTEN FOR INCLUSION IN IBM RESEARCH REPORT RC20525, *
C*  'FORTRAN ROUTINES FOR USE WITH THE METHOD OF L-MOMENTS, VERSION 3' *
C*                                                                     *
C*  J. R. M. HOSKING                                                   *
C*  IBM RESEARCH DIVISION                                              *
C*  T. J. WATSON RESEARCH CENTER                                       *
C*  YORKTOWN HEIGHTS                                                   *
C*  NEW YORK 10598, U.S.A.                                             *
C*                                                                     *
C*  VERSION 3     AUGUST 1996                                          *
C*                                                                     *
C***********************************************************************
C
C  THE INCOMPLETE GAMMA INTEGRAL
C
C  BASED ON ALGORITHM AS239, APPL. STATIST. (1988) VOL.37 NO.3
C
C  PARAMETERS OF ROUTINE:
C  X      * INPUT* ARGUMENT OF FUNCTION (UPPER LIMIT OF INTEGRATION)
C  ALPHA  * INPUT* SHAPE PARAMETER
C  G      * INPUT* LOG(GAMMA(ALPHA)). MUST BE SUPPLIED BY THE PROGRAM,
C                  E.G. AS DLGAMALM(ALPHA).
C
C  OTHER ROUTINES USED: DERFLM
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DATA ZERO/0D0/,HALF/0.5D0/,ONE/1D0/,TWO/2D0/,THREE/3D0/,X13/13D0/,
     *  X36/36D0/,X42/42D0/,X119/119D0/,X1620/1620D0/,X38880/38880D0/,
     *  RTHALF/0.70710 67811 86547 524D0/
C
C         EPS,MAXIT CONTROL THE TEST FOR CONVERGENCE OF THE SERIES AND
C           CONTINUED-FRACTION EXPANSIONS.
C         OFL IS A LARGE NUMBER, USED TO RESCALE THE CONTINUED FRACTION.
C         UFL IS SUCH THAT EXP(UFL) IS JUST .GT. ZERO.
C         AHILL CONTROLS THE SWITCH TO HILL'S APPROXIMATION.
C
      DATA EPS/1D-12/,MAXIT/100000/,OFL/1D30/,UFL/-180D0/,AHILL/1D4/
      GAMINDLM=ZERO
      IF(ALPHA.LE.ZERO)GOTO 1000
      IF(X.LT.ZERO)GOTO 1010
      IF(X.EQ.ZERO)RETURN
C
      IF(ALPHA.GT.AHILL)GOTO 100
      IF(X.GT.ONE.AND.X.GE.ALPHA)GOTO 50
C
C         SERIES EXPANSION
C
      SUM=ONE
      TERM=ONE
      A=ALPHA
      DO 10 IT=1,MAXIT
      A=A+ONE
      TERM=TERM*X/A
      SUM=SUM+TERM
      IF(TERM.LE.EPS)GOTO 20
   10 CONTINUE
      WRITE(6,7020)
   20 ARG=ALPHA*DLOG(X)-X-G+DLOG(SUM/ALPHA)
      GAMINDLM=ZERO
      IF(ARG.GE.UFL)GAMINDLM=DEXP(ARG)
      RETURN
C
C         CONTINUED-FRACTION EXPANSION
C
   50 CONTINUE
      A=ONE-ALPHA
      B=A+X+ONE
      TERM=ZERO
      PN1=ONE
      PN2=X
      PN3=X+ONE
      PN4=X*B
      RATIO=PN3/PN4
      DO 70 IT=1,MAXIT
      A=A+ONE
      B=B+TWO
      TERM=TERM+ONE
      AN=A*TERM
      PN5=B*PN3-AN*PN1
      PN6=B*PN4-AN*PN2
      IF(PN6.EQ.ZERO)GOTO 60
      RN=PN5/PN6
      DIFF=DABS(RATIO-RN)
      IF(DIFF.LE.EPS.AND.DIFF.LE.EPS*RN)GOTO 80
      RATIO=RN
   60 PN1=PN3
      PN2=PN4
      PN3=PN5
      PN4=PN6
      IF(DABS(PN5).LT.OFL)GOTO 70
      PN1=PN1/OFL
      PN2=PN2/OFL
      PN3=PN3/OFL
      PN4=PN4/OFL
   70 CONTINUE
      WRITE(6,7020)
   80 ARG=ALPHA*DLOG(X)-X-G+DLOG(RATIO)
      GAMINDLM=ONE
      IF(ARG.GE.UFL)GAMINDLM=ONE-DEXP(ARG)
      RETURN
C
C         ALPHA IS LARGE: USE HILL'S APPROXIMATION (N.L. JOHNSON AND
C         S. KOTZ, 1970, 'CONTINUOUS UNIVARIATE DISTRIBUTIONS 1', P.180)
C
C         THE 'DO 110' LOOP CALCULATES 2*(X-ALPHA-ALPHA*DLOG(X/ALPHA)),
C         USING POWER-SERIES EXPANSION TO AVOID ROUNDING ERROR
C
  100 CONTINUE
      R=ONE/DSQRT(ALPHA)
      Z=(X-ALPHA)*R
      TERM=Z*Z
      SUM=HALF*TERM
      DO 110 I=1,12
      TERM=-TERM*Z*R
      SUM=SUM+TERM/(I+TWO)
      IF(DABS(TERM).LT.EPS)GOTO 120
  110 CONTINUE
  120 WW=TWO*SUM
      W=DSQRT(WW)
      IF(X.LT.ALPHA)W=-W
      H1=ONE/THREE
      H2=-W/X36
      H3=(-WW+X13)/X1620
      H4=(X42*WW+X119)*W/X38880
      Z=(((H4*R+H3)*R+H2)*R+H1)*R+W
      GAMINDLM=HALF+HALF*DERFLM(Z*RTHALF)
      RETURN
C
 1000 WRITE(6,7000)ALPHA
      RETURN
 1010 WRITE(6,7010)X
      RETURN
C
 7000 FORMAT(' *** ERROR *** ROUTINE GAMINDLM :',
     *  ' SHAPE PARAMETER OUT OF RANGE :',D16.8)
 7010 FORMAT(' *** ERROR *** ROUTINE GAMINDLM :',
     *  ' ARGUMENT OF FUNCTION OUT OF RANGE :',D16.8)
 7020 FORMAT(' ** WARNING ** ROUTINE GAMINDLM :',
     *  ' ITERATION HAS NOT CONVERGED. RESULT MAY BE UNRELIABLE.')
      END
c
c
c
      DOUBLE PRECISION FUNCTION QUASTN(F)
C***********************************************************************
C*                                                                     *
C*  FORTRAN CODE WRITTEN FOR INCLUSION IN IBM RESEARCH REPORT RC20525, *
C*  'FORTRAN ROUTINES FOR USE WITH THE METHOD OF L-MOMENTS, VERSION 3' *
C*                                                                     *
C*  J. R. M. HOSKING                                                   *
C*  IBM RESEARCH DIVISION                                              *
C*  T. J. WATSON RESEARCH CENTER                                       *
C*  YORKTOWN HEIGHTS                                                   *
C*  NEW YORK 10598, U.S.A.                                             *
C*                                                                     *
C*  VERSION 3     AUGUST 1996                                          *
C*                                                                     *
C***********************************************************************
C
C  QUANTILE FUNCTION OF THE STANDARD NORMAL DISTRIBUTION
C
C  BASED ON ALGORITHM AS241, APPL. STATIST. (1988) VOL.37 NO.3
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DATA ZERO/0D0/,HALF/0.5D0/,ONE/1D0/
      DATA SPLIT1/0.425D0/,SPLIT2/5D0/,CONST1/0.180625D0/,CONST2/1.6D0/
C
C         COEFFICIENTS OF RATIONAL-FUNCTION APPROXIMATIONS
C
      DATA A0,A1,A2,A3,A4,A5,A6,A7,B1,B2,B3,B4,B5,B6,B7/
     *                                0.33871 32872 79636 661D  1,
     *  0.13314 16678 91784 377D  3,  0.19715 90950 30655 144D  4,
     *  0.13731 69376 55094 611D  5,  0.45921 95393 15498 715D  5,
     *  0.67265 77092 70087 009D  5,  0.33430 57558 35881 281D  5,
     *  0.25090 80928 73012 267D  4,  0.42313 33070 16009 113D  2,
     *  0.68718 70074 92057 908D  3,  0.53941 96021 42475 111D  4,
     *  0.21213 79430 15865 959D  5,  0.39307 89580 00927 106D  5,
     *  0.28729 08573 57219 427D  5,  0.52264 95278 85285 456D  4/
      DATA C0,C1,C2,C3,C4,C5,C6,C7,D1,D2,D3,D4,D5,D6,D7/
     *                                0.14234 37110 74968 358D  1,
     *  0.46303 37846 15654 530D  1,  0.57694 97221 46069 141D  1,
     *  0.36478 48324 76320 461D  1,  0.12704 58252 45236 838D  1,
     *  0.24178 07251 77450 612D  0,  0.22723 84498 92691 846D -1,
     *  0.77454 50142 78341 408D -3,  0.20531 91626 63775 882D  1,
     *  0.16763 84830 18380 385D  1,  0.68976 73349 85100 005D  0,
     *  0.14810 39764 27480 075D  0,  0.15198 66656 36164 572D -1,
     *  0.54759 38084 99534 495D -3,  0.10507 50071 64441 684D -8/
      DATA E0,E1,E2,E3,E4,E5,E6,E7,F1,F2,F3,F4,F5,F6,F7/
     *                                0.66579 04643 50110 378D  1,
     *  0.54637 84911 16411 437D  1,  0.17848 26539 91729 133D  1,
     *  0.29656 05718 28504 891D  0,  0.26532 18952 65761 230D -1,
     *  0.12426 60947 38807 844D -2,  0.27115 55568 74348 758D -4,
     *  0.20103 34399 29228 813D -6,  0.59983 22065 55887 938D  0,
     *  0.13692 98809 22735 805D  0,  0.14875 36129 08506 149D -1,
     *  0.78686 91311 45613 259D -3,  0.18463 18317 51005 468D -4,
     *  0.14215 11758 31644 589D -6,  0.20442 63103 38993 979D-14/
C
      Q=F-HALF
      IF(DABS(Q).GT.SPLIT1)GOTO 10
      R=CONST1-Q*Q
      QUASTN=Q*(((((((A7*R+A6)*R+A5)*R+A4)*R+A3)*R+A2)*R+A1)*R+A0)
     *        /(((((((B7*R+B6)*R+B5)*R+B4)*R+B3)*R+B2)*R+B1)*R+ONE)
      RETURN
   10 R=F
      IF(Q.GE.ZERO)R=ONE-F
      IF(R.LE.ZERO)GOTO 1000
      R=DSQRT(-DLOG(R))
      IF(R.GT.SPLIT2)GOTO 20
      R=R-CONST2
      QUASTN=(((((((C7*R+C6)*R+C5)*R+C4)*R+C3)*R+C2)*R+C1)*R+C0)
     *      /(((((((D7*R+D6)*R+D5)*R+D4)*R+D3)*R+D2)*R+D1)*R+ONE)
      GOTO 30
   20 R=R-SPLIT2
      QUASTN=(((((((E7*R+E6)*R+E5)*R+E4)*R+E3)*R+E2)*R+E1)*R+E0)
     *      /(((((((F7*R+F6)*R+F5)*R+F4)*R+F3)*R+F2)*R+F1)*R+ONE)
   30 IF(Q.LT.ZERO)QUASTN=-QUASTN
      RETURN
C
 1000 WRITE(6,7000)F
      QUASTN=ZERO
      RETURN
C
 7000 FORMAT(' *** ERROR *** ROUTINE QUASTN :',
     *  ' ARGUMENT OF FUNCTION INVALID')
      END
c
c
c
      SUBROUTINE SORTNCDC(temparr,X,N,maxyrs)
CCCC  SUBROUTINE SORT(temparr,X,N,maxyrs)
C***********************************************************************
C*                                                                     *
C*  FORTRAN CODE WRITTEN FOR INCLUSION IN IBM RESEARCH REPORT RC20525, *
C*  'FORTRAN ROUTINES FOR USE WITH THE METHOD OF L-MOMENTS, VERSION 3' *
C*                                                                     *
C*  J. R. M. HOSKING                                                   *
C*  IBM RESEARCH DIVISION                                              *
C*  T. J. WATSON RESEARCH CENTER                                       *
C*  YORKTOWN HEIGHTS                                                   *
C*  NEW YORK 10598, U.S.A.                                             *
C*                                                                     *
C*  VERSION 3     AUGUST 1996                                          *
C*                                                                     *
C***********************************************************************
C
C  SORTS THE ARRAY X INTO ASCENDING ORDER
C
C  PARAMETERS OF ROUTINE:
C  X      *IN/OUT* ARRAY OF LENGTH N. CONTAINS THE NUMBERS TO BE SORTED.
C                  ON EXIT, CONTAINS THE SORTED NUMBERS.
C  N      * INPUT* NUMBER OF ELEMENTS TO BE SORTED
C
C  METHOD USED IS SHELL SORT WITH SEQUENCE OF INCREMENTS AS IN
C  D.F.KNUTH (1969) 'THE ART OF COMPUTER PROGRAMMING', VOL.3, P.95
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DOUBLE PRECISION X(N),temparr(maxyrs+1)
      IF(N.LE.1)RETURN
      do i=1,n
        x(i)=temparr(i)
      enddo
      J=4
      DO 10 I=1,100
      J=3*J+1
      IF(J.GE.N)GOTO 20
   10 CONTINUE
   20 CONTINUE
      M=(J/3)
      DO 60 MM=1,100
      M=M/3
      IF(M.EQ.0)RETURN
      DO 50 I=M+1,N
      TEST=X(I)
      J=I
      DO 30 JJ=1,100
      J=J-M
      IF(J.LE.0)GOTO 40
      IF(TEST.GE.X(J))GOTO 40
   30 X(J+M)=X(J)
   40 CONTINUE
   50 X(J+M)=TEST
   60 CONTINUE
      END

C
C $Id: hstopc.f,v 1.6 2008-07-27 00:17:15 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
C *************************************************************
C
      SUBROUTINE HSTOPC (IOPT,STRING,NUMBER,ILCH)
C
C *************************************************************
C
C SET THE HISTOGRAM OPTIONS
C
C INPUT
C     IOPT-CHARACTER STRING OF OPTION VALUE
C     ARRAY-   CHARACTER INPUT DATA
C
C  SET COMMON DATA EQUAL TO INPUT DATA
C
C
C
      COMMON /HSTGC1/ HORZNT, PERCNT, MIDVAL, SHADE, MEDIAN, PERIM,
     -       HFRAME, LISTOP, WINDOW, COLORS, HSTFOR, TITLE, LABEL,
     -       FREQNC, HWIND(4), COLSHA, COLREC, COLAXI, COLMED, COLTEX,
     -       COLTIT, COLPER, DRAWL, SPACE, LABMAX, CHARL, HEIGHT,
     -       ORIENT, COLSH2, SETSPA, SETSP2, MVALU, SETMVA, SETEPS,
     -       NMVAL, PMVAL, PERTIT
      LOGICAL HORZNT, PERCNT, MIDVAL, SHADE, MEDIAN, PERIM, HFRAME,
     -        LISTOP, WINDOW, COLORS, HSTFOR, TITLE, LABEL, FREQNC,
     -        DRAWL, SPACE, CHARL, MVALU, NMVAL, PMVAL, PERTIT
      COMMON /HSTGC2/ STRFOR, STRTIT, STRLAB, STRFRE, STRPER, LABTEX
      CHARACTER*96  STRTIT
      CHARACTER*55  STRFOR, STRLAB, STRFRE, STRPER
      CHARACTER*(*)  STRING
      CHARACTER*15 LABTEX(30)
      CHARACTER*7  IOPT
      CHARACTER*2  TAG, OPT
      INTEGER  COLSHA, COLREC, COLAXI, COLMED, COLTEX
      INTEGER  COLTIT, COLPER, NUMBER, COLSH2, HEIGHT, ORIENT
C
      NERR = 0
C
C  DETERMINE THE OPTION DESIRED
C
      TAG = IOPT(1:2)
      IF (IOPT(3:3) .EQ. '=') THEN
          OPT = IOPT(4:5)
      ELSE
          OPT = IOPT(5:6)
      ENDIF
C
C  TITLE OPTION
C
      IF (TAG .EQ. 'TI') THEN
C
C  SWITCH ON GET TITLE AND COUNT FROM INPUT
C
          IF (OPT .EQ. 'ON') THEN
              TITLE = .TRUE.
              STRTIT = STRING
              RETURN
C
C  SWITCH OFF OPTION DEACTIVATED
C
          ELSEIF (OPT .EQ. 'OF') THEN
            TITLE = .FALSE.
            RETURN
          ELSE
                GOTO 120
          ENDIF
C
C  FORMAT FLAG
C
      ELSEIF (TAG .EQ. 'FO') THEN
C
C  SWITCH ON GET USER FORMAT
C
        IF (OPT .EQ. 'ON') THEN
            HSTFOR = .TRUE.
            STRFOR = STRING
	    LABMAX = NUMBER
            RETURN
C
C SWITCH OFF SET FORMAT TO DEFAULT
C
          ELSEIF (OPT .EQ. 'OF') THEN
            HSTFOR = .FALSE.
            STRFOR = '(G10.3)'
            RETURN
          ELSE
                GOTO 120
          ENDIF
C
C  LABEL FLAG
C
      ELSEIF (TAG .EQ. 'LA') THEN
C
C  SWITCH ON GET USER LABEL
C
        IF (OPT .EQ. 'ON') THEN
            LABEL = .TRUE.
            STRLAB = STRING
            RETURN
C
C SWITCH OFF
C
        ELSEIF (OPT .EQ. 'OF') THEN
            LABEL = .FALSE.
            RETURN
        ELSE
                GOTO 120
        ENDIF
C
C  FREQUENCY FLAG
C
      ELSEIF (TAG .EQ. 'FQ') THEN
C
C  SWITCH ON
C
          IF (OPT .EQ. 'ON') THEN
            FREQNC = .TRUE.
            STRFRE = STRING
            RETURN
C
C SWITCH OFF
C
          ELSEIF (OPT .EQ. 'OF') THEN
            FREQNC = .FALSE.
            RETURN
          ELSE
                GOTO 120
          ENDIF
C
C  PERCENT TITLE FLAG.
C
      ELSEIF (TAG .EQ. 'PT') THEN
C
C  SWITCH ON
C
          IF (OPT .EQ. 'ON') THEN
	    PERTIT = .TRUE.
	    STRPER = STRING
            RETURN
C
C SWITCH OFF
C
          ELSEIF (OPT .EQ. 'OF') THEN
	    PERTIT = .FALSE.
            RETURN
          ELSE
                GOTO 120
          ENDIF
C
C  CHARACTER FLAG
C
      ELSEIF (TAG .EQ. 'CH') THEN
C
C  SWITCH ON
C
          IF (OPT .EQ. 'ON') THEN
            CHARL = .TRUE.
            DO 100 I = 1,NUMBER
              J = I + (I-1)*(ILCH-1)
              K = J + ILCH-1
              LABTEX(I) = STRING(J:K)
  100       CONTINUE
            RETURN
C
C SWITCH OFF
C
          ELSEIF (OPT .EQ. 'OF') THEN
            CHARL = .FALSE.
            RETURN
          ELSE
                GOTO 120
          ENDIF
      ELSE
          GOTO 120
      ENDIF
C
C  ERROR UNDEFINED OPTION DETECTED
C
 120  NERR = NERR + 1
      CALL SETER (' HSTOPC -- UNDEFINED OPTION',NERR,IREC)
      RETURN
      END

C     
C      $Id: xy03f.f,v 1.17 2010-03-15 22:49:25 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C                Copyright (C)  1995                                   C
C        University Corporation for Atmospheric Research               C
C                All Rights Reserved                                   C
C                                                                      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C  File:       xy03f.f
C
C  Author:     Mary Haley
C          National Center for Atmospheric Research
C          PO 3000, Boulder, Colorado
C
C  Date:       Wed Feb  8 11:44:39 MST 1995
C
C  Description:    This program shows how to create an XyPlot object
C                  with some of the XyPlot line resources tweaked.  A
C                  resource file is used to changed the resources. 
C                  This program uses the same Y-axis dataset as the
C                  example "xy02", but this time values for the X
C                  axis are specified, changing the look of the plot.
C 
C                  The "CoordArrays" object is used to set up the data.
C
      external NhlFAppClass
      external NhlFCairoWindowWorkstationClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFXyPlotClass
      external NhlFCoordArraysClass
C
C Define the number of points in the curve.
C
      parameter(NPTS=500)
      parameter(PI100=.031415926535898)

      integer appid,xworkid,plotid,dataid
      integer rlist, i, len(2)
      real cmap(3,4)
      real xdra(NPTS), ydra(NPTS), theta
      CHARACTER*7  wks_type
C
C Define the workstation type
C
      wks_type = "x11"
C
C
C Initialize some data for the XyPlot object.
C
      do 10 i = 1,NPTS
         theta = PI100*real(i-1)
         xdra(i) = 500.+.9*real(i-1)*cos(theta)
         ydra(i) = 500.+.9*real(i-1)*sin(theta)
 10   continue
C
C Initialize the HLU library and set up resource template.
C
      call NhlFInitialize
      call NhlFRLCreate(rlist,'setrl')
C
C Modify the color map.  Color indices '1' and '2' are the background
C and foreground colors respectively.
C
      cmap(1,1) = 0.
      cmap(2,1) = 0.
      cmap(3,1) = 0.
      cmap(1,2) = 1.
      cmap(2,2) = 1.
      cmap(3,2) = 1.
      cmap(1,3) = 0.
      cmap(2,3) = .5
      cmap(3,3) = 1.
      cmap(1,4) = 0.
      cmap(2,4) = 1.
      cmap(3,4) = 0.
      len(1) = 3
      len(2) = 4
C
C Create Application object.  The Application object name is used to
C determine the name of the resource file, which is "xy03.res" in
C this case.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'appDefaultParent','True',ierr)
      call NhlFRLSetString(rlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'xy03',NhlFAppClass,0,rlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkMetaName','./xy03f.ncgm',ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',cmap,2,len,ierr)
         call NhlFCreate(xworkid,'xy03Work',
     +        NhlFNcgmWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X11 workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPause','True',ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',cmap,2,len,ierr)
         call NhlFCreate(xworkid,'xy03Work',
     +        NhlFCairoWindowWorkstationClass,
     +        0,rlist,ierr)
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PS workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPSFileName','./xy03f.ps',ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',cmap,2,len,ierr)
         call NhlFCreate(xworkid,'xy03Work',
     +        NhlFPSWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPDFFileName','./xy03f.pdf',ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',cmap,2,len,ierr)
         call NhlFCreate(xworkid,'xy03Work',
     +        NhlFPDFWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFileName','./xy03f',ierr)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',cmap,2,len,ierr)
         call NhlFCreate(xworkid,'xy03Work',
     +        NhlFcairoPSPDFWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFileName','./xy03f',ierr)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',cmap,2,len,ierr)
         call NhlFCreate(xworkid,'xy03Work',
     +        NhlFcairoImageWorkstationClass,0,rlist,ierr)
      endif
C
C Define the data object.  The id for this object will later be used
C as the value for the XyPlot data resource, 'xyCoordData'.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetFloatArray(rlist,'caXArray',xdra,NPTS,ierr)
      call NhlFRLSetFloatArray(rlist,'caYArray',ydra,NPTS,ierr)
      call NhlFCreate(dataid,'xyData',NhlFCoordArraysClass,
     +                0,rlist,ierr)
C
C Create the XyPlot object which is created as a child of the
C Xworkstation object.  The resources that are being changed are done
C in the "xy03.res" file.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetInteger(rlist,'xyCoordData',dataid,ierr)
      call NhlFCreate(plotid,'xyPlot',NhlFXyPlotClass,xworkid,
     +                rlist,ierr)
C
C Draw the plot.
C
      call NhlFDraw(plotid,ierr)
      call NhlFFrame(xworkid,ierr)
C
C NhlDestroy destroys the given id and all of its children
C so destroying "xworkid" will also destroy "plotid".
C
      call NhlFRLDestroy(rlist)
      call NhlFDestroy(xworkid,ierr)
      call NhlFDestroy(appid,ierr)
C
C Restores state.
C
      call NhlFClose
      stop
      end

C NCLFORTSTART
      SUBROUTINE DEXPTAPER(N0,R,S,NLAT,JER)
      IMPLICIT NONE
c                                input
      INTEGER R,NLAT,JER
      DOUBLE PRECISION N0
c                                output [ALLOCATE IN INTERFACE]
      DOUBLE PRECISION S(NLAT)
C NCLEND

c NCL: wgt = exp_taper (n0, r)

      INTEGER N
      DOUBLE PRECISION CON

      JER = 0
      IF (R.LE.0) THEN
          JER = 1
          PRINT *,'DEXPTAPER: r must be > 0:  r=',R
      END IF
      IF (N0.LE.0.D0) THEN
          JER = 10
          PRINT *,'DEXPTAPER: no must be > 0:  n0=',N0
      END IF
      IF (JER.NE.0) RETURN
c
c equation 9
c
      CON = N0* (N0+1.D0)
      DO N = 1,NLAT
          S(N) = EXP(- (N* (N+1)/CON)**R)
      END DO
c now wgt the coef by the wgts
c
      RETURN
      END

C NCLFORTSTART
      SUBROUTINE DEXPTAPERSH(MB,NB,AB,BB,N0,R,JER)
      IMPLICIT NONE
      INTEGER MB,NB,R,JER
      DOUBLE PRECISION AB(MB,NB),BB(MB,NB),N0
C NCLEND

c NCL: exp_tapersh (a,b, n0, r)
c      ab = exp_tapershC (ab, n0, r)

c     perform an exponential taper on the spherical harmonic coef

      INTEGER M,N,KER
      DOUBLE PRECISION S(2*NB)

      JER = 0
      IF ((N0+2).GT.NB) THEN
          JER = 8
          WRITE (*,FMT=
     +'(''SUB DEXPTAPERSH: N0 too large: ''
     +   ,''N0='',f8.0,3x,''iwave,nb='',2i5)') N0,R,NB
      ELSE IF (NB.NE.MB) THEN
          JER = 9
          WRITE (*,FMT=
     +'(''SUB DEXPTAPERSH: nb .ne. mb: ''
     +   ,''nb,mb='',2i5)') NB,MB
      END IF
      IF (JER.NE.0) RETURN
c equation 9
c
      CALL DEXPTAPER(N0,R,S,NB,KER)
c now wgt the coef by the wgts
c
      DO N = 1,NB
          DO M = 1,N
              AB(M,N) = AB(M,N)*S(N)
              BB(M,N) = BB(M,N)*S(N)
          END DO
      END DO

      RETURN
      END

C
C $Id: e4fnsp.f,v 1.5 2008-07-27 00:17:08 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      REAL FUNCTION E4FNSP (ECCENT)
C
C This function computes the constant E4.
C
      IMPLICIT REAL (A-Z)
      DATA ONE /1.0E0/
C
      CON = ONE + ECCENT
      COM = ONE - ECCENT
      E4FNSP = SQRT ((CON ** CON) * (COM ** COM))
C
      RETURN
      END

C
C $Id: agsetc.f,v 1.6 2008-07-27 00:14:35 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE AGSETC (TPID,CUSR)
C
      CHARACTER*(*) TPID,CUSR
C
      DIMENSION FURA(1)
C
C The routine AGSETC is used to set the values of individual AUTOGRAPH
C parameters which intrinsically represent character strings.  TPID is a
C parameter identifier.  CUSR is a character string.  The situation is
C complicated by the fact that the character string may be either a dash
C pattern, the name of a label, the line-end character, or the text of a
C line, all of which are treated differently.
C
C Define a local variable to hold the "line-end" character.
C
      CHARACTER*1 LEND
C
C See what kind of parameter is being set.
C
      CALL AGCTCS (TPID,ITCS)
C
C If the parameter is not intrinsically of type character, log an error.
C
      IF (ITCS.EQ.0) GO TO 901
C
C Find the length of the string, which may or may not actually be used.
C (On the Cray, at least, it may be zero if the wrong type of argument
C was used.)
C
      ILEN=LEN(CUSR)
C
C Retrieve the current (integer) value of the parameter.
C
      CALL AGGETI (TPID,ITMP)
C
C Check for a dash pattern.
C
      IF (ITCS.EQ.1) THEN
        CALL AGGETI ('DASH/LENG.',NCHR)
        IF (ILEN.GT.0.AND.ILEN.LT.NCHR) NCHR=ILEN
        CALL AGRPCH (CUSR,NCHR,ITMP)
C
C Check for a label name.
C
      ELSE IF (ITCS.EQ.2) THEN
        CALL AGSTCH (CUSR,MAX(1,ILEN),ITMP)
C
C Check for the line-end character.
C
      ELSE IF (ITCS.EQ.3) THEN
        CALL AGRPCH (CUSR,1,ITMP)
C
C Check for the text of a label.
C
      ELSE IF (ITCS.EQ.4) THEN
        CALL AGGETI ('LINE/MAXI.',NCHR)
        IF (ILEN.GT.0) NCHR=MIN(NCHR,ILEN)
        CALL AGGETC ('LINE/END .',LEND)
        DO 101 I=1,NCHR
          IF (CUSR(I:I).EQ.LEND) THEN
            NCHR=I-1
            GO TO 102
          END IF
  101   CONTINUE
C
  102   IF (NCHR.LE.0) THEN
          CALL AGRPCH (' ',1,ITMP)
        ELSE
          CALL AGRPCH (CUSR,NCHR,ITMP)
        END IF
C
      END IF
C
C Transfer the generated value to the list of AUTOGRAPH parameters.
C
      FURA(1)=REAL(ITMP)
      CALL AGSETP (TPID,FURA,1)
C
C Done.
C
      RETURN
C
C Error exit.
C
  901 CALL AGPPID (TPID)
      CALL SETER ('AGSETC - PARAMETER TO SET IS NOT INTRINSICALLY OF TYP
     +E CHARACTER',14,2)
C
      END

C NCLFORTSTART
      SUBROUTINE DWGTVOLRMSE(T,Q,WGTZ,WGTY,WGTX,MX,NY,KZ,TMSG,QMSG,
     +                       IFLAG,RMSE)
      IMPLICIT NONE
      INTEGER MX,NY,KZ,IFLAG
      DOUBLE PRECISION T(MX,NY,KZ),Q(MX,NY,KZ)
      DOUBLE PRECISION WGTX(MX),WGTY(NY),WGTZ(KZ)
      DOUBLE PRECISION TMSG,QMSG
      DOUBLE PRECISION RMSE
C NCLEND

C NCL: rmsqTQ = wgtVolRmse (T,Q,wgtz,wgty,wgtx,flag)
C compute the weighted root-mean-square-difference [rmse]
c .   This could have been programmed more efficiently.

      INTEGER NL,ML,KL,KMSG
      DOUBLE PRECISION SUMD,SUMW,WGTXY,SUMTQ,SUMWZ,VARTQ

C Nomenclature:
C INPUT:
C t      - 3D array
C q      - 3D array
C wgtz   - 1D array of length "kz"
C wgty   - 1D array of length "ny"
C wgtx   - 1D array of length "mx"
C mx     - 1st [fastest varying] dimension of "t" [eg, longitude]
C ny     - 2nd                   dimension of "t" [eg, latitude ]
C kz     - 3rd [slowest varying] dimension of "t" [eg, latitude ]
c tmsg   - msg value
c qmsg   - msg value
C iflag  - flag
C          =0 compute  rmse ignoring msg values
C          =1 if any msg data is encountered return as msg

C OUTPUT:
C rmse   - volume root-mean-square-difference [weighted]

      SUMD = 0.0D0
      SUMW = 0.0D0
      RMSE = TMSG
      KMSG = 0

      DO NL = 1,NY
          DO ML = 1,MX
              SUMTQ = 0
              SUMWZ = 0.0D0
c                                     sum wgted vertical differences
c                                     at each lat/lon point
              DO KL = 1,KZ
                  IF (T(ML,NL,KL).NE.TMSG .AND.
     +                Q(ML,NL,KL).NE.QMSG) THEN
                      SUMTQ = SUMTQ + WGTZ(KL)*
     +                        (T(ML,NL,KL)-Q(ML,NL,KL))**2
                      SUMWZ = SUMWZ + WGTZ(KL)
                  ELSE
                      KMSG = KMSG + 1
                  END IF
              END DO
c                                      return if user desired
              IF (IFLAG.EQ.1 .AND. KMSG.NE.0) RETURN
c                            wgt vertical mean square difference
c                            by areal wgts x/lon and y/lat
              IF (SUMWZ.GT.0.0D0) THEN
                  VARTQ = (SUMTQ/SUMWZ)
                  WGTXY = WGTX(ML)*WGTY(NL)
                  SUMD  = SUMD + WGTXY*VARTQ
                  SUMW = SUMW + WGTXY
              END IF

          END DO
      END DO
c                          compute wgted rmse
      IF (SUMW.GT.0.0D0) THEN
          RMSE = SQRT(SUMD/SUMW)
      END IF

      RETURN
      END

C NCLFORTSTART
      SUBROUTINE DWGTVOLRMSECCM(T,Q,DPT,DPQ,WGTY,WGTX,MX,NY,KZ,TMSG,
     +                         QMSG,IFLAG,RMSE)
      IMPLICIT NONE
      INTEGER MX,NY,KZ,IFLAG
      DOUBLE PRECISION T(MX,NY,KZ),Q(MX,NY,KZ)
      DOUBLE PRECISION WGTX(MX),WGTY(NY)
      DOUBLE PRECISION DPT(MX,NY,KZ),DPQ(MX,NY,KZ)
      DOUBLE PRECISION TMSG,QMSG
      DOUBLE PRECISION RMSE
C NCLEND

C NCL: rmsqTQ = wgtVolRmse_ccm (T,Q,dpT,dpQ,wgty,wgtx,flag)
C compute the weighted root-mean-square-difference [rmse]
c .   This could have been programmed more efficiently.

      INTEGER NL,ML,KL,KMSG
      DOUBLE PRECISION SUMD,SUMW,WGTXY,SUMTQ,SUMDP,WGTDP,VARTQ

C Nomenclature:
C INPUT:
C t      - 3D array
C q      - 3D array
C dpt    - 3D array same size as "t" and "q"
C dpq    - 3D array same size as "t" and "q"
C wgty   - 1D array of length "ny"
C wgtx   - 1D array of length "mx"
C mx     - 1st [faster varying] dimension of "t" [eg, longitude]
C ny     - 2nd [slower varying] dimension of "t" [eg, latitude ]
C kz     - 3rd [slower varying] dimension of "t" [eg, latitude ]
c tmsg   - msg value
c qmsg   - msg value
C iflag  - flag
C          =0 compute  rmse ignoring msg values
C          =1 if any msg data is encountered return as msg

C OUTPUT:
C rmse   - volume root-mean-square-difference [weighted]
C          Dave Williamson suggested the use of the mean "dp"

      SUMD = 0.0D0
      SUMW = 0.0D0
      RMSE = TMSG
      KMSG = 0

      DO NL = 1,NY
          DO ML = 1,MX
              SUMTQ = 0.0D0
              SUMDP = 0.0D0
c                                     sum wgted vertical differences
c                                     at each lat/lon point
              DO KL = 1,KZ
                  IF (T(ML,NL,KL).NE.TMSG .AND.
     +                Q(ML,NL,KL).NE.QMSG) THEN
                      WGTDP = 0.5D0* (DPT(ML,NL,KL)+DPQ(ML,NL,KL))
                      SUMTQ = SUMTQ + WGTDP*(T(ML,NL,KL)-Q(ML,NL,KL))**2
                      SUMDP = SUMDP + WGTDP
                  ELSE
                      KMSG = KMSG + 1
                  END IF
              END DO
c                                      return if user desired
              IF (IFLAG.EQ.1 .AND. KMSG.NE.0) RETURN
c                        wgt vertical mean square difference
c                        by areal wgts x/lon and y/lat
              IF (SUMDP.GT.0.0D0) THEN
                  VARTQ = SUMTQ/SUMDP
                  WGTXY = WGTX(ML)*WGTY(NL)
                  SUMD  = SUMD + WGTXY*VARTQ
                  SUMW  = SUMW + WGTXY
              END IF

          END DO
      END DO
c                          compute wgted rmse
      IF (SUMW.GT.0.0D0) THEN
          RMSE = SQRT(SUMD/SUMW)
      END IF

      RETURN
      END

      SUBROUTINE DLAQP2( M, N, OFFSET, A, LDA, JPVT, TAU, VN1, VN2,
     $                   WORK )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      INTEGER            LDA, M, N, OFFSET
*     ..
*     .. Array Arguments ..
      INTEGER            JPVT( * )
      DOUBLE PRECISION   A( LDA, * ), TAU( * ), VN1( * ), VN2( * ),
     $                   WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  DLAQP2 computes a QR factorization with column pivoting of
*  the block A(OFFSET+1:M,1:N).
*  The block A(1:OFFSET,1:N) is accordingly pivoted, but not factorized.
*
*  Arguments
*  =========
*
*  M       (input) INTEGER
*          The number of rows of the matrix A. M >= 0.
*
*  N       (input) INTEGER
*          The number of columns of the matrix A. N >= 0.
*
*  OFFSET  (input) INTEGER
*          The number of rows of the matrix A that must be pivoted
*          but no factorized. OFFSET >= 0.
*
*  A       (input/output) DOUBLE PRECISION array, dimension (LDA,N)
*          On entry, the M-by-N matrix A.
*          On exit, the upper triangle of block A(OFFSET+1:M,1:N) is
*          the triangular factor obtained; the elements in block
*          A(OFFSET+1:M,1:N) below the diagonal, together with the
*          array TAU, represent the orthogonal matrix Q as a product of
*          elementary reflectors. Block A(1:OFFSET,1:N) has been
*          accordingly pivoted, but no factorized.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A. LDA >= max(1,M).
*
*  JPVT    (input/output) INTEGER array, dimension (N)
*          On entry, if JPVT(i) .ne. 0, the i-th column of A is permuted
*          to the front of A*P (a leading column); if JPVT(i) = 0,
*          the i-th column of A is a free column.
*          On exit, if JPVT(i) = k, then the i-th column of A*P
*          was the k-th column of A.
*
*  TAU     (output) DOUBLE PRECISION array, dimension (min(M,N))
*          The scalar factors of the elementary reflectors.
*
*  VN1     (input/output) DOUBLE PRECISION array, dimension (N)
*          The vector with the partial column norms.
*
*  VN2     (input/output) DOUBLE PRECISION array, dimension (N)
*          The vector with the exact column norms.
*
*  WORK    (workspace) DOUBLE PRECISION array, dimension (N)
*
*  Further Details
*  ===============
*
*  Based on contributions by
*    G. Quintana-Orti, Depto. de Informatica, Universidad Jaime I, Spain
*    X. Sun, Computer Science Dept., Duke University, USA
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO, ONE
      PARAMETER          ( ZERO = 0.0D+0, ONE = 1.0D+0 )
*     ..
*     .. Local Scalars ..
      INTEGER            I, ITEMP, J, MN, OFFPI, PVT
      DOUBLE PRECISION   AII, TEMP, TEMP2
*     ..
*     .. External Subroutines ..
      EXTERNAL           DLARF, DLARFG, DSWAP
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, MAX, MIN, SQRT
*     ..
*     .. External Functions ..
      INTEGER            IDAMAX
      DOUBLE PRECISION   DNRM2
      EXTERNAL           IDAMAX, DNRM2
*     ..
*     .. Executable Statements ..
*
      MN = MIN( M-OFFSET, N )
*
*     Compute factorization.
*
      DO 20 I = 1, MN
*
         OFFPI = OFFSET + I
*
*        Determine ith pivot column and swap if necessary.
*
         PVT = ( I-1 ) + IDAMAX( N-I+1, VN1( I ), 1 )
*
         IF( PVT.NE.I ) THEN
            CALL DSWAP( M, A( 1, PVT ), 1, A( 1, I ), 1 )
            ITEMP = JPVT( PVT )
            JPVT( PVT ) = JPVT( I )
            JPVT( I ) = ITEMP
            VN1( PVT ) = VN1( I )
            VN2( PVT ) = VN2( I )
         END IF
*
*        Generate elementary reflector H(i).
*
         IF( OFFPI.LT.M ) THEN
            CALL DLARFG( M-OFFPI+1, A( OFFPI, I ), A( OFFPI+1, I ), 1,
     $                   TAU( I ) )
         ELSE
            CALL DLARFG( 1, A( M, I ), A( M, I ), 1, TAU( I ) )
         END IF
*
         IF( I.LT.N ) THEN
*
*           Apply H(i)' to A(offset+i:m,i+1:n) from the left.
*
            AII = A( OFFPI, I )
            A( OFFPI, I ) = ONE
            CALL DLARF( 'Left', M-OFFPI+1, N-I, A( OFFPI, I ), 1,
     $                  TAU( I ), A( OFFPI, I+1 ), LDA, WORK( 1 ) )
            A( OFFPI, I ) = AII
         END IF
*
*        Update partial column norms.
*
         DO 10 J = I + 1, N
            IF( VN1( J ).NE.ZERO ) THEN
               TEMP = ONE - ( ABS( A( OFFPI, J ) ) / VN1( J ) )**2
               TEMP = MAX( TEMP, ZERO )
               TEMP2 = ONE + 0.05D0*TEMP*( VN1( J ) / VN2( J ) )**2
               IF( TEMP2.EQ.ONE ) THEN
                  IF( OFFPI.LT.M ) THEN
                     VN1( J ) = DNRM2( M-OFFPI, A( OFFPI+1, J ), 1 )
                     VN2( J ) = VN1( J )
                  ELSE
                     VN1( J ) = ZERO
                     VN2( J ) = ZERO
                  END IF
               ELSE
                  VN1( J ) = VN1( J )*SQRT( TEMP )
               END IF
            END IF
   10    CONTINUE
*
   20 CONTINUE
*
      RETURN
*
*     End of DLAQP2
*
      END

      SUBROUTINE SGERFS( TRANS, N, NRHS, A, LDA, AF, LDAF, IPIV, B, LDB,
     $                   X, LDX, FERR, BERR, WORK, IWORK, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER          TRANS
      INTEGER            INFO, LDA, LDAF, LDB, LDX, N, NRHS
*     ..
*     .. Array Arguments ..
      INTEGER            IPIV( * ), IWORK( * )
      REAL               A( LDA, * ), AF( LDAF, * ), B( LDB, * ),
     $                   BERR( * ), FERR( * ), WORK( * ), X( LDX, * )
*     ..
*
*  Purpose
*  =======
*
*  SGERFS improves the computed solution to a system of linear
*  equations and provides error bounds and backward error estimates for
*  the solution.
*
*  Arguments
*  =========
*
*  TRANS   (input) CHARACTER*1
*          Specifies the form of the system of equations:
*          = 'N':  A * X = B     (No transpose)
*          = 'T':  A**T * X = B  (Transpose)
*          = 'C':  A**H * X = B  (Conjugate transpose = Transpose)
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  NRHS    (input) INTEGER
*          The number of right hand sides, i.e., the number of columns
*          of the matrices B and X.  NRHS >= 0.
*
*  A       (input) REAL array, dimension (LDA,N)
*          The original N-by-N matrix A.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(1,N).
*
*  AF      (input) REAL array, dimension (LDAF,N)
*          The factors L and U from the factorization A = P*L*U
*          as computed by SGETRF.
*
*  LDAF    (input) INTEGER
*          The leading dimension of the array AF.  LDAF >= max(1,N).
*
*  IPIV    (input) INTEGER array, dimension (N)
*          The pivot indices from SGETRF; for 1<=i<=N, row i of the
*          matrix was interchanged with row IPIV(i).
*
*  B       (input) REAL array, dimension (LDB,NRHS)
*          The right hand side matrix B.
*
*  LDB     (input) INTEGER
*          The leading dimension of the array B.  LDB >= max(1,N).
*
*  X       (input/output) REAL array, dimension (LDX,NRHS)
*          On entry, the solution matrix X, as computed by SGETRS.
*          On exit, the improved solution matrix X.
*
*  LDX     (input) INTEGER
*          The leading dimension of the array X.  LDX >= max(1,N).
*
*  FERR    (output) REAL array, dimension (NRHS)
*          The estimated forward error bound for each solution vector
*          X(j) (the j-th column of the solution matrix X).
*          If XTRUE is the true solution corresponding to X(j), FERR(j)
*          is an estimated upper bound for the magnitude of the largest
*          element in (X(j) - XTRUE) divided by the magnitude of the
*          largest element in X(j).  The estimate is as reliable as
*          the estimate for RCOND, and is almost always a slight
*          overestimate of the true error.
*
*  BERR    (output) REAL array, dimension (NRHS)
*          The componentwise relative backward error of each solution
*          vector X(j) (i.e., the smallest relative change in
*          any element of A or B that makes X(j) an exact solution).
*
*  WORK    (workspace) REAL array, dimension (3*N)
*
*  IWORK   (workspace) INTEGER array, dimension (N)
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*
*  Internal Parameters
*  ===================
*
*  ITMAX is the maximum number of steps of iterative refinement.
*
*  =====================================================================
*
*     .. Parameters ..
      INTEGER            ITMAX
      PARAMETER          ( ITMAX = 5 )
      REAL               ZERO
      PARAMETER          ( ZERO = 0.0E+0 )
      REAL               ONE
      PARAMETER          ( ONE = 1.0E+0 )
      REAL               TWO
      PARAMETER          ( TWO = 2.0E+0 )
      REAL               THREE
      PARAMETER          ( THREE = 3.0E+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            NOTRAN
      CHARACTER          TRANST
      INTEGER            COUNT, I, J, K, KASE, NZ
      REAL               EPS, LSTRES, S, SAFE1, SAFE2, SAFMIN, XK
*     ..
*     .. External Subroutines ..
      EXTERNAL           SAXPY, SCOPY, SGEMV, SGETRS, SLACON, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, MAX
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      REAL               SLAMCH
      EXTERNAL           LSAME, SLAMCH
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      NOTRAN = LSAME( TRANS, 'N' )
      IF( .NOT.NOTRAN .AND. .NOT.LSAME( TRANS, 'T' ) .AND. .NOT.
     $    LSAME( TRANS, 'C' ) ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( NRHS.LT.0 ) THEN
         INFO = -3
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -5
      ELSE IF( LDAF.LT.MAX( 1, N ) ) THEN
         INFO = -7
      ELSE IF( LDB.LT.MAX( 1, N ) ) THEN
         INFO = -10
      ELSE IF( LDX.LT.MAX( 1, N ) ) THEN
         INFO = -12
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'SGERFS', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 .OR. NRHS.EQ.0 ) THEN
         DO 10 J = 1, NRHS
            FERR( J ) = ZERO
            BERR( J ) = ZERO
   10    CONTINUE
         RETURN
      END IF
*
      IF( NOTRAN ) THEN
         TRANST = 'T'
      ELSE
         TRANST = 'N'
      END IF
*
*     NZ = maximum number of nonzero elements in each row of A, plus 1
*
      NZ = N + 1
      EPS = SLAMCH( 'Epsilon' )
      SAFMIN = SLAMCH( 'Safe minimum' )
      SAFE1 = NZ*SAFMIN
      SAFE2 = SAFE1 / EPS
*
*     Do for each right hand side
*
      DO 140 J = 1, NRHS
*
         COUNT = 1
         LSTRES = THREE
   20    CONTINUE
*
*        Loop until stopping criterion is satisfied.
*
*        Compute residual R = B - op(A) * X,
*        where op(A) = A, A**T, or A**H, depending on TRANS.
*
         CALL SCOPY( N, B( 1, J ), 1, WORK( N+1 ), 1 )
         CALL SGEMV( TRANS, N, N, -ONE, A, LDA, X( 1, J ), 1, ONE,
     $               WORK( N+1 ), 1 )
*
*        Compute componentwise relative backward error from formula
*
*        max(i) ( abs(R(i)) / ( abs(op(A))*abs(X) + abs(B) )(i) )
*
*        where abs(Z) is the componentwise absolute value of the matrix
*        or vector Z.  If the i-th component of the denominator is less
*        than SAFE2, then SAFE1 is added to the i-th components of the
*        numerator and denominator before dividing.
*
         DO 30 I = 1, N
            WORK( I ) = ABS( B( I, J ) )
   30    CONTINUE
*
*        Compute abs(op(A))*abs(X) + abs(B).
*
         IF( NOTRAN ) THEN
            DO 50 K = 1, N
               XK = ABS( X( K, J ) )
               DO 40 I = 1, N
                  WORK( I ) = WORK( I ) + ABS( A( I, K ) )*XK
   40          CONTINUE
   50       CONTINUE
         ELSE
            DO 70 K = 1, N
               S = ZERO
               DO 60 I = 1, N
                  S = S + ABS( A( I, K ) )*ABS( X( I, J ) )
   60          CONTINUE
               WORK( K ) = WORK( K ) + S
   70       CONTINUE
         END IF
         S = ZERO
         DO 80 I = 1, N
            IF( WORK( I ).GT.SAFE2 ) THEN
               S = MAX( S, ABS( WORK( N+I ) ) / WORK( I ) )
            ELSE
               S = MAX( S, ( ABS( WORK( N+I ) )+SAFE1 ) /
     $             ( WORK( I )+SAFE1 ) )
            END IF
   80    CONTINUE
         BERR( J ) = S
*
*        Test stopping criterion. Continue iterating if
*           1) The residual BERR(J) is larger than machine epsilon, and
*           2) BERR(J) decreased by at least a factor of 2 during the
*              last iteration, and
*           3) At most ITMAX iterations tried.
*
         IF( BERR( J ).GT.EPS .AND. TWO*BERR( J ).LE.LSTRES .AND.
     $       COUNT.LE.ITMAX ) THEN
*
*           Update solution and try again.
*
            CALL SGETRS( TRANS, N, 1, AF, LDAF, IPIV, WORK( N+1 ), N,
     $                   INFO )
            CALL SAXPY( N, ONE, WORK( N+1 ), 1, X( 1, J ), 1 )
            LSTRES = BERR( J )
            COUNT = COUNT + 1
            GO TO 20
         END IF
*
*        Bound error from formula
*
*        norm(X - XTRUE) / norm(X) .le. FERR =
*        norm( abs(inv(op(A)))*
*           ( abs(R) + NZ*EPS*( abs(op(A))*abs(X)+abs(B) ))) / norm(X)
*
*        where
*          norm(Z) is the magnitude of the largest component of Z
*          inv(op(A)) is the inverse of op(A)
*          abs(Z) is the componentwise absolute value of the matrix or
*             vector Z
*          NZ is the maximum number of nonzeros in any row of A, plus 1
*          EPS is machine epsilon
*
*        The i-th component of abs(R)+NZ*EPS*(abs(op(A))*abs(X)+abs(B))
*        is incremented by SAFE1 if the i-th component of
*        abs(op(A))*abs(X) + abs(B) is less than SAFE2.
*
*        Use SLACON to estimate the infinity-norm of the matrix
*           inv(op(A)) * diag(W),
*        where W = abs(R) + NZ*EPS*( abs(op(A))*abs(X)+abs(B) )))
*
         DO 90 I = 1, N
            IF( WORK( I ).GT.SAFE2 ) THEN
               WORK( I ) = ABS( WORK( N+I ) ) + NZ*EPS*WORK( I )
            ELSE
               WORK( I ) = ABS( WORK( N+I ) ) + NZ*EPS*WORK( I ) + SAFE1
            END IF
   90    CONTINUE
*
         KASE = 0
  100    CONTINUE
         CALL SLACON( N, WORK( 2*N+1 ), WORK( N+1 ), IWORK, FERR( J ),
     $                KASE )
         IF( KASE.NE.0 ) THEN
            IF( KASE.EQ.1 ) THEN
*
*              Multiply by diag(W)*inv(op(A)**T).
*
               CALL SGETRS( TRANST, N, 1, AF, LDAF, IPIV, WORK( N+1 ),
     $                      N, INFO )
               DO 110 I = 1, N
                  WORK( N+I ) = WORK( I )*WORK( N+I )
  110          CONTINUE
            ELSE
*
*              Multiply by inv(op(A))*diag(W).
*
               DO 120 I = 1, N
                  WORK( N+I ) = WORK( I )*WORK( N+I )
  120          CONTINUE
               CALL SGETRS( TRANS, N, 1, AF, LDAF, IPIV, WORK( N+1 ), N,
     $                      INFO )
            END IF
            GO TO 100
         END IF
*
*        Normalize error.
*
         LSTRES = ZERO
         DO 130 I = 1, N
            LSTRES = MAX( LSTRES, ABS( X( I, J ) ) )
  130    CONTINUE
         IF( LSTRES.NE.ZERO )
     $      FERR( J ) = FERR( J ) / LSTRES
*
  140 CONTINUE
*
      RETURN
*
*     End of SGERFS
*
      END

C
      PROGRAM STEX01
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Example illustrating polar coordinates using Streamlines
C
      PARAMETER (M=20, N=36)
      DIMENSION A(M,N),B(M,N)
      DIMENSION WRK(2*M*N)
C
C     Open GKS, open workstation, activate workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Define a GKS color table
C
      CALL DFCLRS(IWKID)
C
C Do the SET call, set the mapping mode and data coordinate boundaries
C appropriately for polar coordinate mapping
C
      CALL SET (0.05,0.95,0.05,0.95,-20.0,20.0,-20.0,20.0,1)
      CALL STSETI('MAP -- Mapping Mode', 2)
      CALL STSETI('SET -- Do Set Call', 0)
      CALL STSETR('XC1 -- Lower X Bound', 1.0)
      CALL STSETR('XCM -- Upper X Bound', 20.0)
      CALL STSETR('YC1 -- Lower Y Bound', 0.0)
      CALL STSETR('YCN -- Upper Y Bound', 360.0)
C     CALL STSETI('TRT -- Transform Type', 1)
C
C Set up a uniform field parallel to the radius
C
      DO 20 I = 1,M
         DO 10 J = 1,N
            A(I,J)=1.0
            B(I,J)=0.0
 10      CONTINUE
 20   CONTINUE
C
C Render the field using one color
C
      CALL GSPLCI(4)
      CALL STINIT(A,M,B,M,IDM,IDM,M,N,WRK,2*M*N)
      CALL STREAM(A,B,IDM,IDM,IDM,WRK)
C
C Set up a uniform field perpendicular to the radius
C
      DO 120 I = 1,M
         DO 110 J = 1,N
            A(I,J)=0.0
            B(I,J)=1.0
 110     CONTINUE
 120  CONTINUE
C
C Change the color and render the next field
C
      CALL GSPLCI(15)
      CALL STINIT(A,M,B,M,IDM,IDM,M,N,WRK,2*M*N)
      CALL STREAM(A,B,IDM,IDM,IDM,WRK)
      CALL FRAME
C
C     Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END
C
C ==============================================================
C
      SUBROUTINE DFCLRS(IWKID)
C
C Define a set of RGB color triples for colors 0 through 15.
C
      PARAMETER (NCLRS=16)
      DIMENSION RGBV(3,NCLRS)
C
C Define the RGB color triples needed below.
C
      DATA RGBV / 
     +     0.00 , 0.00 , 0.00 ,
     +     1.00 , 1.00 , 1.00 ,
     +     0.70 , 0.70 , 0.70 ,
     +     0.75 , 0.50 , 1.00 ,
     +     1.00 , 0.00 , 1.00 ,
     +     0.00 , 0.00 , 1.00 ,
     +     0.00 , 0.50 , 1.00 ,
     +     0.00 , 1.00 , 1.00 ,
     +     0.00 , 1.00 , 0.60 ,
     +     0.00 , 1.00 , 0.00 ,
     +     0.70 , 1.00 , 0.00 ,
     +     1.00 , 1.00 , 0.00 ,
     +     1.00 , 0.75 , 0.00 ,
     +     1.00 , 0.38 , 0.38 ,
     +     1.00 , 0.00 , 0.38 ,
     +     1.00 , 0.00 , 0.00 /
C
C Define 16 different color indices, for indices 0 through 15.  The
C color corresponding to index 0 is black and the color corresponding
C to index 1 is white.
C
      DO 101 I=1,NCLRS
         CALL GSCR (IWKID,I-1,RGBV(1,I),RGBV(2,I),RGBV(3,I))
 101  CONTINUE
C
C Done.
C
        RETURN
C
      END
C

C
C $Id: stitle.f,v 1.9 2008-07-27 00:17:27 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE STITLE (CRDS,NCDS,IYST,IYND,TMST,TMMV,TMND,MTST)
C
C The routine STITLE is given information defining a group of titles
C on a "scroll" that is 1023 units wide by 99,998 units high.  (X
C coordinates on the scroll run from 1 to 1024, while Y coordinates
C run from 1 to 99,999.)  Using this information, STITLE creates
C frames, for use in a movie, showing the titles scrolling by.
C
C Each element of the array CRDS defines the text of one title line and
C its desired X/Y position, color, centering, and character size.  The
C frames generated by STITLE show what lies within a viewport centered
C at (512,IYCN) on the scroll, where IYCN is equal to IYST for the first
C TMST seconds, changes linearly toward the value IYND over the next
C TMMV seconds, and then holds with IYCN equal to IYND for the last
C TMND seconds.
C
C The argument MTST may be set non-zero to request a set of test frames
C in place of the movie frames themselves.
C
C The behavior of STITLE is affected not only by the values of its
C arguments, but by the values of a number of "internal parameters":
C variables in common blocks of STITLE.  For example, there is an
C internal parameter, known by the name 'FIN', which specifies the
C number of seconds during which the titles "fade in" at the position
C IYCN = IYST, and another, known by the name 'FOU', which specifies
C the number of seconds during which the titles "fade out" at the
C position IYCN = IYND.
C
C See the STITLE programmer document for complete information.
C
        CHARACTER*(*) CRDS(NCDS)
C
C The common block SLCOMN holds all of the internal parameters of
C the package STITLE except for color-table parameters.
C
        COMMON /SLCOMN/ GPSZ,IBGC,IBGF,ICOP,IDOT,IFGC,IFGF,IJMP,IMAP,
     +                  INCU,IWLU,IWRK,IWWI,IXND,IXST,OORV,PCSZ,RNFS,
     +                  RVPB,RVPL,RVPR,RVPT,TFIN,TFOU,TGP1,TGP2,TGP3
        SAVE   /SLCOMN/
C
C The common block SLCLRS holds color-table parameters.
C
        COMMON /SLCLRS/ CRED(256),CGRN(256),CBLU(256),LOCI(256),NOCI
        SAVE   /SLCLRS/
C
C The common block PCSTCM is used to communicate the variables defining
C the STITLE viewport to PLOTCHAR so that titles can be clipped.
C
        COMMON /PCSTCM/ XVPL,XVPR,YVPB,YVPT
        SAVE   /PCSTCM/
C
C Declare a temporary variable in which to form complete output lines.
C
        CHARACTER*500 CTMP
C
C Declare a temporary variable in which to receive the GKS clipping
C rectangle.
C
        DIMENSION CRCT(4)
C
C Declare a couple of arrays in which to define the coordinates of the
C corners of the plotter frame for the GPM calls below.
C
        DIMENSION XCPF(4),YCPF(4)
C
C Define a character variable in which messages may be formed.
C
        CHARACTER*42 CMSG
C
C Declare the type of the function SLSTLN, which finds the length of
C a character string, not counting terminal blanks.
C
        INTEGER SLSTLN
C
C Define the corners of the plotter frame for the GPM calls below.
C
        DATA XCPF(1),XCPF(2),XCPF(3),XCPF(4) / 0. , 1. , 1. , 0. /
        DATA YCPF(1),YCPF(2),YCPF(3),YCPF(4) / 0. , 0. , 1. , 1. /
C
C Define an arithmetic statement function that, given an X or Y plotter
C coordinate as its integer argument, returns the equivalent fractional
C coordinate as its value.  This is done instead of calling CPFX and
C CPFY because it is more efficient and because it avoids problems due
C to a possible user call to the old routine SETI.
C
        FRCT(IARG)=(IARG-1)/1023.
C
C Do a call forcing a BLOCKDATA to be loaded from a binary library.
C
        CALL SLBLDA
C
C Check for an uncleared prior error.
C
        IF (ICFELL('STITLE - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C If the card buffer is empty, there's nothing to do, so quit.
C
        IF (NCDS.LE.0) RETURN
C
C Find out how long each "card image" is.
C
        LCRD=LEN(CRDS(1))
C
C ICNX is the X-coordinate of the center of the window, in the plotter
C coordinate system.
C
        ICNX=1+INT(.5*(RVPL+RVPR)*1023.)
C
C ICNY is the Y-coordinate of the center of the window, in the plotter
C coordinate system.
C
        ICNY=1+INT(.5*(RVPB+RVPT)*1023.)
C
C IHHW is half the height of the window, in the plotter coordinate
C system.
C
        IHHW=.5*(RVPT-RVPB)*1023.
C
C Compute the multiplicative constant required to make PLCHHQ give
C characters of a desired size.
C
        FPMC=(6./7.)*PCSZ/1023.
C
C Save the current GKS clipping indicator, and then set clipping off.
C (All necessary clipping is done by PLOTCHAR.)
C
        CALL GQCLIP (IERR,ISCI,CRCT)
        IF (IERR.NE.0) THEN
          CMSG(1:34)='STITLE - ERROR RETURN FROM GQCLIP:'
          WRITE (CMSG(35:42),'(I8)') IERR
          CALL SETER (CMSG(1:42),2,1)
          RETURN
        END IF
        CALL GSCLIP (0)
C
C Save the current normalization transformation number and reset to use
C normalization transformation 0.  This allows us to use X/Y coordinates
C in the fractional system (NDCs).
C
        CALL GQCNTN (IERR,ISNT)
        IF (IERR.NE.0) THEN
          CMSG(1:34)='STITLE - ERROR RETURN FROM GQCNTN:'
          WRITE (CMSG(35:42),'(I8)') IERR
          CALL SETER (CMSG(1:42),3,1)
          RETURN
        END IF
        CALL GSELNT (0)
C
C Save the current polyline, polymarker, and text color indices and set
C all of them to the default foreground color.
C
        CALL GQPLCI (IERR,ISPL)
        IF (IERR.NE.0) THEN
          CMSG(1:34)='STITLE - ERROR RETURN FROM GQPLCI:'
          WRITE (CMSG(35:42),'(I8)') IERR
          CALL SETER (CMSG(1:42),4,1)
          RETURN
        END IF
        CALL GSPLCI (IFGC)
C
        CALL GQPMCI (IERR,ISPM)
        IF (IERR.NE.0) THEN
          CMSG(1:34)='STITLE - ERROR RETURN FROM GQPMCI:'
          WRITE (CMSG(35:42),'(I8)') IERR
          CALL SETER (CMSG(1:42),5,1)
          RETURN
        END IF
        CALL GSPMCI (IFGC)
C
        CALL GQTXCI (IERR,ISTX)
        IF (IERR.NE.0) THEN
          CMSG(1:34)='STITLE - ERROR RETURN FROM GQTXCI:'
          WRITE (CMSG(35:42),'(I8)') IERR
          CALL SETER (CMSG(1:42),6,1)
          RETURN
        END IF
        CALL GSTXCI (IFGC)
C
C Open WISS for GFLASH.
C
        CALL GOPWK (IWWI,IWLU,3)
C
C Save the current value of the PLOTCHAR character-color parameter for
C later restoration.
C
        CALL PCGETI ('CC',ISCC)
        IF (ICFELL('STITLE',7).NE.0) RETURN
C
C Set all the parameters required to make PLOTCHAR do clipping (saving
C the original values for later restoration).
C
        IF (IMAP.GT.0) THEN
          CALL PCGETI ('MA',ISMA)
          IF (ICFELL('STITLE',8).NE.0) RETURN
          CALL PCSETI ('MA',IMAP)
          IF (ICFELL('STITLE',9).NE.0) RETURN
        END IF
C
        IF (OORV.NE.0.) THEN
          CALL PCGETR ('OR',RSOR)
          IF (ICFELL('STITLE',10).NE.0) RETURN
          CALL PCSETR ('OR',OORV)
          IF (ICFELL('STITLE',11).NE.0) RETURN
        END IF
C
        XVPL=RVPL
        XVPR=RVPR
        YVPB=RVPB
        YVPT=RVPT
C
C Make sure color indices IBGC and IFGC and all color indices mentioned
C in the card input are among those defined by the STITLE color table.
C (Requesting the RGB components forces them to be defined if they
C hadn't been already.)  These calls have the side effect of causing
C the common variable IWRK to be defined, as well.
C
        CALL SLGCLR (IBGC,BRED,BGRN,BBLU)
        IF (ICFELL('STITLE',12).NE.0) RETURN
C
        CALL SLGCLR (IFGC,FRED,FGRN,FBLU)
        IF (ICFELL('STITLE',13).NE.0) RETURN
C
        DO 101 I=1,NCDS
          READ (CRDS(I)(1:13),'(2I5,I3)') IXPS,IYPS,ICLR
          IF (IXPS.NE.-9999) THEN
            CALL SLGCLR (MAX(1,ICLR),FRED,FGRN,FBLU)
            IF (ICFELL('STITLE',14).NE.0) RETURN
          END IF
  101   CONTINUE
C
C Make sure all the colors defined by the STITLE color table are still
C defined as such for GKS.
C
        DO 102 IOCI=1,NOCI
          CALL SLGCLR (LOCI(IOCI),FRED,FGRN,FBLU)
          IF (ICFELL('STITLE',15).NE.0) RETURN
          CALL GSCR (IWRK,LOCI(IOCI),FRED,FGRN,FBLU)
  102   CONTINUE
C
C If it has been requested, dot the corners of an initial frame (for
C splicing purposes - useless now, I suppose).
C
        IF (IDOT.NE.0) THEN
          CALL GPM (4,XCPF,YCPF)
          IF (MTST.NE.0.OR.IDOT.GT.1) THEN
            CALL WTSTR (.5,.5,'ALIGNMENT FRAME',2,0,0)
            IF (ICFELL('STITLE',16).NE.0) RETURN
          END IF
          CALL SLFRME
          IF (ICFELL('STITLE',17).NE.0) RETURN
        END IF
C
C Fade-in at start.
C
        IF (TFIN.NE.0.) THEN
C
          NREP=MAX(1,INT(TFIN*RNFS+.5))
          IF (MTST.NE.0) NREP=1
C
          IF (IBGF.GE.0.AND.IBGF/1000.NE.999) THEN
            CALL SLGCLR (IBGF/1000,BFIR,BFIG,BFIB)
            IF (ICFELL('STITLE',18).NE.0) RETURN
          END IF
C
          IF (IFGF.GE.0.AND.IFGF/1000.NE.999) THEN
            CALL SLGCLR (IFGF/1000,FFIR,FFIG,FFIB)
            IF (ICFELL('STITLE',19).NE.0) RETURN
          END IF
C
          DO 107 IREP=1,NREP
C
            DO 103 IOCI=1,NOCI
              CALL SLGCLR (LOCI(IOCI),FRED,FGRN,FBLU)
              IF (ICFELL('STITLE',20).NE.0) RETURN
              IF      ((LOCI(IOCI).EQ.IBGC.AND.IBGF.EQ.-2).OR.
     +                 (LOCI(IOCI).NE.IBGC.AND.IFGF.EQ.-2)) THEN
                CALL RGBHSV (FRED,FGRN,FBLU,H,S,V)
                IF (ICFELL('STITLE',21).NE.0) RETURN
                CALL HSVRGB (H,S,REAL(IREP)*V/REAL(NREP),FRED,FGRN,FBLU)
                IF (ICFELL('STITLE',22).NE.0) RETURN
              ELSE IF (LOCI(IOCI).EQ.IBGC.AND.IBGF.GE.0.AND.
     +                                            IBGF/1000.NE.999) THEN
                FRED=(REAL(NREP-IREP)*BFIR+REAL(IREP)*FRED)/REAL(NREP)
                FGRN=(REAL(NREP-IREP)*BFIG+REAL(IREP)*FGRN)/REAL(NREP)
                FBLU=(REAL(NREP-IREP)*BFIB+REAL(IREP)*FBLU)/REAL(NREP)
              ELSE IF (LOCI(IOCI).NE.IBGC.AND.IFGF.GE.0.AND.
     +                                            IFGF/1000.NE.999) THEN
                FRED=(REAL(NREP-IREP)*FFIR+REAL(IREP)*FRED)/REAL(NREP)
                FGRN=(REAL(NREP-IREP)*FFIG+REAL(IREP)*FGRN)/REAL(NREP)
                FBLU=(REAL(NREP-IREP)*FFIB+REAL(IREP)*FBLU)/REAL(NREP)
              END IF
              CALL GSCR (IWRK,LOCI(IOCI),FRED,FGRN,FBLU)
  103       CONTINUE
C
            IF (IBGC.NE.0) THEN
              CALL SLBKGD
              IF (ICFELL('STITLE',23).NE.0) RETURN
            END IF
C
            CALL SLUBKG (-1)
            IF (ICFELL('STITLE',24).NE.0) RETURN
C
            DO 106 I=1,NCDS
              READ (CRDS(I)(1:20),'(2I5,I3,I2,F5.1)')
     +                                          IXPS,IYPS,ICLR,ICNT,SIZE
              IF (IXPS.EQ.-9999) GO TO 106
              NOCH=MIN(500,SLSTLN(CRDS(I)(21:LCRD)))
              CTMP=CRDS(I)(21:20+NOCH)
              DO 104 J=I+1,NCDS
                IF (CRDS(J)(1:5).NE.'-9999') GO TO 105
                NACH=MIN(500-NOCH,SLSTLN(CRDS(J)(21:LCRD)))
                IF (NACH.NE.0) THEN
                  CTMP(NOCH+1:NOCH+NACH)=CRDS(J)(21:20+NACH)
                  NOCH=NOCH+NACH
                END IF
  104         CONTINUE
  105         CALL PCSETI ('CC (CHARACTER COLOR)',MAX(1,ICLR))
              IF (ICFELL('STITLE',25).NE.0) RETURN
              CALL PLCHHQ (FRCT(IXPS-IXST+ICNX),FRCT(IYPS-IYST+ICNY),
     +                     CTMP(1:NOCH),FPMC*SIZE,0.,REAL(ICNT-1))
              IF (ICFELL('STITLE',26).NE.0) RETURN
  106       CONTINUE
C
            CALL SLUBKG (+1)
            IF (ICFELL('STITLE',27).NE.0) RETURN
C
            IF (MTST.NE.0) THEN
              CALL SLOWND
              IF (ICFELL('STITLE',28).NE.0) RETURN
              WRITE (CMSG(1:8),'(F8.2)') TFIN
              CMSG(9:24)=' SECS OF FADE IN'
              CALL SLPWRV (.98,.5,CMSG(1:24),.016)
              IF (ICFELL('STITLE',29).NE.0) RETURN
            END IF
C
            CALL SLFRME
            IF (ICFELL('STITLE',30).NE.0) RETURN
C
  107     CONTINUE
C
        END IF
C
C Stationary frames at start.
C
        IF (TMST.NE.0.) THEN
C
          CALL GFLAS1 (IWWI)
          IF (ICFELL('STITLE',31).NE.0) RETURN
C
          IF (IBGC.NE.0) THEN
            CALL SLBKGD
            IF (ICFELL('STITLE',32).NE.0) RETURN
          END IF
C
          CALL SLUBKG (-2)
          IF (ICFELL('STITLE',33).NE.0) RETURN
C
          DO 110 I=1,NCDS
            READ (CRDS(I)(1:20),'(2I5,I3,I2,F5.1)')
     +                                          IXPS,IYPS,ICLR,ICNT,SIZE
            IF (IXPS.EQ.-9999) GO TO 110
            NOCH=MIN(500,SLSTLN(CRDS(I)(21:LCRD)))
            CTMP=CRDS(I)(21:20+NOCH)
            DO 108 J=I+1,NCDS
              IF (CRDS(J)(1:5).NE.'-9999') GO TO 109
              NACH=MIN(500-NOCH,SLSTLN(CRDS(J)(21:LCRD)))
              IF (NACH.NE.0) THEN
                CTMP(NOCH+1:NOCH+NACH)=CRDS(J)(21:20+NACH)
                NOCH=NOCH+NACH
              END IF
  108       CONTINUE
  109       CALL PCSETI ('CC (CHARACTER COLOR)',MAX(1,ICLR))
            IF (ICFELL('STITLE',34).NE.0) RETURN
            CALL PLCHHQ (FRCT(IXPS-IXST+ICNX),FRCT(IYPS-IYST+ICNY),
     +                   CTMP(1:NOCH),FPMC*SIZE,0.,REAL(ICNT-1))
            IF (ICFELL('STITLE',35).NE.0) RETURN
  110     CONTINUE
C
          CALL SLUBKG (+2)
          IF (ICFELL('STITLE',36).NE.0) RETURN
C
          CALL GFLAS2
          IF (ICFELL('STITLE',37).NE.0) RETURN
C
          NREP=MAX(1,INT(TMST*RNFS+.5))
          IF (MTST.NE.0) NREP=1
C
          DO 111 I=1,NREP
            CALL GFLAS3 (IWWI)
            IF (ICFELL('STITLE',38).NE.0) RETURN
            IF (MTST.NE.0) THEN
              CALL SLOWND
              IF (ICFELL('STITLE',39).NE.0) RETURN
              WRITE (CMSG(1:8),'(F8.2)') TMST
              CMSG(9:22)=' SECS AT START'
              CALL SLPWRV (.98,.5,CMSG(1:22),.016)
              IF (ICFELL('STITLE',40).NE.0) RETURN
            END IF
            CALL SLFRME
            IF (ICFELL('STITLE',41).NE.0) RETURN
  111     CONTINUE
C
        END IF
C
C Moving portion.  Note the inclusion of a test to prevent PLCHHQ from
C being called if it is not possible that any portion of the line is
C visible in the viewport.
C
        IF (TMMV.NE.0.) THEN
C
          NDIF=INT(TMMV*RNFS+.5)
          IF (MTST.NE.0) NDIF=MAX(1,ABS(IYND-IYST)/IJMP)
C
          TPER=TMMV/REAL(NDIF)
C
          DIFX=REAL(IXND-IXST)/REAL(NDIF)
          DIFY=REAL(IYND-IYST)/REAL(NDIF)
C
          NDIF=NDIF+1
C
          TFRA=0.
C
          DO 115 K=1,NDIF
C
            LXPS=ICNX-IXST-INT(REAL(K-1)*DIFX)
            LYPS=ICNY-IYST-INT(REAL(K-1)*DIFY)
C
            IF (IBGC.NE.0) THEN
              CALL SLBKGD
              IF (ICFELL('STITLE',42).NE.0) RETURN
            END IF
C
            CALL SLUBKG (-3)
            IF (ICFELL('STITLE',43).NE.0) RETURN
C
            DO 114 I=1,NCDS
              READ (CRDS(I)(1:20),'(2I5,I3,I2,F5.1)')
     +                                          IXPS,IYPS,ICLR,ICNT,SIZE
              IF (IXPS.EQ.-9999) GO TO 114
              NOCH=MIN(500,SLSTLN(CRDS(I)(21:LCRD)))
              CTMP=CRDS(I)(21:20+NOCH)
              DO 112 J=I+1,NCDS
                IF (CRDS(J)(1:5).NE.'-9999') GO TO 113
                NACH=MIN(500-NOCH,SLSTLN(CRDS(J)(21:LCRD)))
                IF (NACH.NE.0) THEN
                  CTMP(NOCH+1:NOCH+NACH)=CRDS(J)(21:20+NACH)
                  NOCH=NOCH+NACH
                END IF
  112         CONTINUE
  113         MXPS=LXPS+IXPS
              MYPS=LYPS+IYPS
              IF (IMAP.NE.100.OR.OORV.NE.1.E12.OR.
     +            ABS(MYPS-ICNY).LT.IHHW+INT(SIZE*PCSZ)) THEN
                CALL PCSETI ('CC (CHARACTER COLOR)',MAX(1,ICLR))
                IF (ICFELL('STITLE',44).NE.0) RETURN
                CALL PLCHHQ (FRCT(MXPS),FRCT(MYPS),CTMP(1:NOCH),
     +                       FPMC*SIZE,0.,REAL(ICNT-1))
                IF (ICFELL('STITLE',45).NE.0) RETURN
              END IF
  114       CONTINUE
C
            CALL SLUBKG (+3)
            IF (ICFELL('STITLE',46).NE.0) RETURN
C
            IF (MTST.NE.0) THEN
              CALL SLOWND
              IF (ICFELL('STITLE',47).NE.0) RETURN
              WRITE (CMSG(1:8),'(F8.2)') TFRA
              CMSG(9:28)=' SECS INTO MOVE TIME'
              CALL SLPWRV (.98,.5,CMSG(1:28),.016)
              IF (ICFELL('STITLE',48).NE.0) RETURN
              TFRA=TFRA+TPER
            END IF
C
            CALL SLFRME
            IF (ICFELL('STITLE',49).NE.0) RETURN
C
  115     CONTINUE
C
        END IF
C
C Stationary frames at end.
C
        IF (TMND.NE.0.) THEN
C
          CALL GFLAS1 (IWWI)
          IF (ICFELL('STITLE',50).NE.0) RETURN
C
          IF (IBGC.NE.0) THEN
            CALL SLBKGD
            IF (ICFELL('STITLE',51).NE.0) RETURN
          END IF
C
          CALL SLUBKG (-4)
          IF (ICFELL('STITLE',52).NE.0) RETURN
C
          DO 118 I=1,NCDS
            READ (CRDS(I)(1:20),'(2I5,I3,I2,F5.1)')
     +                                          IXPS,IYPS,ICLR,ICNT,SIZE
            IF (IXPS.EQ.-9999) GO TO 118
            NOCH=MIN(500,SLSTLN(CRDS(I)(21:LCRD)))
            CTMP=CRDS(I)(21:20+NOCH)
            DO 116 J=I+1,NCDS
              IF (CRDS(J)(1:5).NE.'-9999') GO TO 117
              NACH=MIN(500-NOCH,SLSTLN(CRDS(J)(21:LCRD)))
              IF (NACH.NE.0) THEN
                CTMP(NOCH+1:NOCH+NACH)=CRDS(J)(21:20+NACH)
                NOCH=NOCH+NACH
              END IF
  116       CONTINUE
  117       CALL PCSETI ('CC (CHARACTER COLOR)',MAX(1,ICLR))
            IF (ICFELL('STITLE',53).NE.0) RETURN
            CALL PLCHHQ (FRCT(IXPS-IXND+ICNX),FRCT(IYPS-IYND+ICNY),
     +                   CTMP(1:NOCH),FPMC*SIZE,0.,REAL(ICNT-1))
            IF (ICFELL('STITLE',54).NE.0) RETURN
  118     CONTINUE
C
          CALL SLUBKG (+4)
          IF (ICFELL('STITLE',55).NE.0) RETURN
C
          CALL GFLAS2
          IF (ICFELL('STITLE',56).NE.0) RETURN
C
          NREP=MAX(1,INT(TMND*RNFS+.5))
          IF (MTST.NE.0) NREP=1
C
          DO 119 I=1,NREP
            CALL GFLAS3 (IWWI)
            IF (ICFELL('STITLE',57).NE.0) RETURN
            IF (MTST.NE.0) THEN
              CALL SLOWND
              IF (ICFELL('STITLE',58).NE.0) RETURN
              WRITE (CMSG(1:8),'(F8.2)') TMND
              CMSG(9:20)=' SECS AT END'
              CALL SLPWRV (.98,.5,CMSG(1:20),.016)
              IF (ICFELL('STITLE',59).NE.0) RETURN
            END IF
            CALL SLFRME
            IF (ICFELL('STITLE',60).NE.0) RETURN
  119     CONTINUE
C
        END IF
C
C Fade-out at end.  After the fade-out, colors are restored to maximum
C intensity again.
C
        IF (TFOU.NE.0.) THEN
C
          NREP=MAX(1,INT(TFOU*RNFS+.5))
          IF (MTST.NE.0) NREP=1
C
          IF (IBGF.GE.0.AND.MOD(IBGF,1000).NE.999) THEN
            CALL SLGCLR (MOD(IBGF,1000),BFOR,BFOG,BFOB)
            IF (ICFELL('STITLE',61).NE.0) RETURN
          END IF
C
          IF (IFGF.GE.0.AND.MOD(IFGF,1000).NE.999) THEN
            CALL SLGCLR (MOD(IFGF,1000),FFOR,FFOG,FFOB)
            IF (ICFELL('STITLE',62).NE.0) RETURN
          END IF
C
          DO 124 IREP=NREP,1,-1
C
            DO 120 IOCI=1,NOCI
              CALL SLGCLR (LOCI(IOCI),FRED,FGRN,FBLU)
              IF (ICFELL('STITLE',63).NE.0) RETURN
              IF      ((LOCI(IOCI).EQ.IBGC.AND.IBGF.EQ.-2).OR.
     +                 (LOCI(IOCI).NE.IBGC.AND.IFGF.EQ.-2)) THEN
                CALL RGBHSV (FRED,FGRN,FBLU,H,S,V)
                IF (ICFELL('STITLE',64).NE.0) RETURN
                CALL HSVRGB (H,S,REAL(IREP)*V/REAL(NREP),FRED,FGRN,FBLU)
                IF (ICFELL('STITLE',65).NE.0) RETURN
              ELSE IF (LOCI(IOCI).EQ.IBGC.AND.IBGF.GE.0.AND.
     +                                       MOD(IBGF,1000).NE.999) THEN
                FRED=(REAL(IREP)*FRED+REAL(NREP-IREP)*BFOR)/REAL(NREP)
                FGRN=(REAL(IREP)*FGRN+REAL(NREP-IREP)*BFOG)/REAL(NREP)
                FBLU=(REAL(IREP)*FBLU+REAL(NREP-IREP)*BFOB)/REAL(NREP)
              ELSE IF (LOCI(IOCI).NE.IBGC.AND.IFGF.GE.0.AND.
     +                                       MOD(IFGF,1000).NE.999) THEN
                FRED=(REAL(IREP)*FRED+REAL(NREP-IREP)*FFOR)/REAL(NREP)
                FGRN=(REAL(IREP)*FGRN+REAL(NREP-IREP)*FFOG)/REAL(NREP)
                FBLU=(REAL(IREP)*FBLU+REAL(NREP-IREP)*FFOB)/REAL(NREP)
              END IF
              CALL GSCR (IWRK,LOCI(IOCI),FRED,FGRN,FBLU)
  120       CONTINUE
C
            IF (IBGC.NE.0) THEN
              CALL SLBKGD
              IF (ICFELL('STITLE',66).NE.0) RETURN
            END IF
C
            CALL SLUBKG (-5)
            IF (ICFELL('STITLE',67).NE.0) RETURN
C
            DO 123 I=1,NCDS
              READ (CRDS(I)(1:20),'(2I5,I3,I2,F5.1)')
     +                                          IXPS,IYPS,ICLR,ICNT,SIZE
              IF (IXPS.EQ.-9999) GO TO 123
              NOCH=MIN(500,SLSTLN(CRDS(I)(21:LCRD)))
              CTMP=CRDS(I)(21:20+NOCH)
              DO 121 J=I+1,NCDS
                IF (CRDS(J)(1:5).NE.'-9999') GO TO 122
                NACH=MIN(500-NOCH,SLSTLN(CRDS(J)(21:LCRD)))
                IF (NACH.NE.0) THEN
                  CTMP(NOCH+1:NOCH+NACH)=CRDS(J)(21:20+NACH)
                  NOCH=NOCH+NACH
                END IF
  121         CONTINUE
  122         CALL PCSETI ('CC (CHARACTER COLOR)',MAX(1,ICLR))
              IF (ICFELL('STITLE',68).NE.0) RETURN
              CALL PLCHHQ (FRCT(IXPS-IXND+ICNX),FRCT(IYPS-IYND+ICNY),
     +                     CTMP(1:NOCH),FPMC*SIZE,0.,REAL(ICNT-1))
              IF (ICFELL('STITLE',69).NE.0) RETURN
  123       CONTINUE
C
            CALL SLUBKG (+5)
            IF (ICFELL('STITLE',70).NE.0) RETURN
C
            IF (MTST.NE.0) THEN
              CALL SLOWND
              IF (ICFELL('STITLE',71).NE.0) RETURN
              WRITE (CMSG(1:8),'(F8.2)') TFOU
              CMSG(9:25)=' SECS OF FADE OUT'
              CALL SLPWRV (.98,.5,CMSG(1:25),.016)
              IF (ICFELL('STITLE',72).NE.0) RETURN
            END IF
C
            CALL SLFRME
            IF (ICFELL('STITLE',73).NE.0) RETURN
C
  124     CONTINUE
C
          DO 125 IOCI=1,NOCI
            CALL SLGCLR (LOCI(IOCI),FRED,FGRN,FBLU)
            IF (ICFELL('STITLE',74).NE.0) RETURN
            CALL GSCR (IWRK,LOCI(IOCI),FRED,FGRN,FBLU)
  125     CONTINUE
C
        END IF
C
C If it has been requested, dot the corners of an initial frame (for
C splicing purposes - useless now, I suppose).
C
        IF (IDOT.NE.0) THEN
          CALL GPM (4,XCPF,YCPF)
          IF (MTST.NE.0.OR.IDOT.GT.1) THEN
            CALL WTSTR (.5,.5,'ALIGNMENT FRAME',2,0,0)
            IF (ICFELL('STITLE',75).NE.0) RETURN
          END IF
          CALL SLFRME
          IF (ICFELL('STITLE',76).NE.0) RETURN
        END IF
C
C Close WISS.
C
        CALL GCLWK (IWWI)
C
C Restore the values of internal parameters of PLOTCHAR that have been
C changed.
C
        CALL PCSETI ('CC',ISCC)
        IF (ICFELL('STITLE',77).NE.0) RETURN
C
        IF (IMAP.GT.0) THEN
          CALL PCSETI ('MA',ISMA)
          IF (ICFELL('STITLE',78).NE.0) RETURN
        END IF
C
        IF (OORV.NE.0.) THEN
          CALL PCSETR ('OR',RSOR)
          IF (ICFELL('STITLE',79).NE.0) RETURN
        END IF
C
C Restore original settings of the GKS clipping flag, the normalization
C transformation, and various color indices.
C
        CALL GSCLIP (ISCI)
        CALL GSELNT (ISNT)
        CALL GSPLCI (ISPL)
        CALL GSPMCI (ISPM)
        CALL GSTXCI (ISTX)
C
        RETURN
C
      END

C
C	$Id: csarcint.f,v 1.5 2008-07-27 03:10:05 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CSARCINT (P,P1,P2,F1,F2,G1,G2,SIGMA, F,G,GN)
      DOUBLE PRECISION P(3), P1(3), P2(3), F1, F2, G1(3),
     .                 G2(3), SIGMA, F, G(3), GN
C
C***********************************************************
C
C                                              From SSRFPACK
C                                            Robert J. Renka
C                                  Dept. of Computer Science
C                                       Univ. of North Texas
C                                           renka@cs.unt.edu
C                                                   11/21/96
C
C   Given 3 points P, P1, and P2 lying on a common geodesic
C of the unit sphere with P between P1 and P2, along with
C data values and gradients at P1 and P2, this subroutine
C computes an interpolated value F and a gradient vector G
C AT P.  F and the tangential component of G are taken to be
C the value and derivative (with respect to arc-length) of
C a Hermite interpolatory tension spline defined by the end-
C point values and tangential gradient components.  The nor-
C mal component of G is obtained by linear interpolation of
C the normal components of the gradients at P1 and P2.
C
C On input:
C
C       P = Cartesian coordinates of a point lying on the
C           arc defined by P1 and P2.  P(1)**2 + P(2)**2 +
C           P(3)**2 = 1.
C
C       P1,P2 = Coordinates of distinct points on the unit
C               sphere defining an arc with length less than
C               180 degrees.
C
C       F1,F2 = Data values associated with P1 and P2,
C               respectively.
C
C       G1,G2 = Gradient vectors associated with P1 and P2.
C               G1 and G2 are orthogonal to P1 and P2,
C               respectively.
C
C       SIGMA = Tension factor associated with P1-P2.
C
C The above parameters are not altered by this routine.
C
C       G = Array of length 3.
C
C On output:
C
C       F = Interpolated value at P.
C
C       G = Interpolated gradient at P.
C
C       GN = Normal component of G with the direction
C            P1 X P2 taken to be positive.  The extrapola-
C            tion procedure requires this component.
C
C   For each vector V, V(1), V(2), and V(3) contain X, Y,
C and Z components, respectively.
C
C SSRFPACK modules required by CSARCINT:  CSARCLEN, CSSNHCSH
C
C Intrinsic functions called by CSARCINT:  ABS, EXP, SQRT
C
C***********************************************************
C
      DOUBLE PRECISION CSARCLEN
      INTEGER I, LUN
      DOUBLE PRECISION A, AL, B1, B2, CM, CMM, CM2, DUMMY,
     .                 D1, D2, E, EMS, E1, E2, GT, S, SB1,
     .                 SB2, SIG, SINH, SINH2, SM, SM2, TAU1,
     .                 TAU2, TM, TM1, TM2, TP1, TP2, TS,
     .                 UN(3), UNORM
      DATA    LUN/6/
C
C Local parameters:
C
C A =         Angle in radians (arc-length) between P1 and
C               P2
C AL =        Arc-length between P1 and P
C B1,B2 =     Local coordinates of P with respect to P1-P2
C CM,CMM =    Coshm(SIG) and Coshmm(SIG) -- refer to CSSNHCSH
C CM2 =       Coshm(SB2)
C DUMMY =     Dummy parameter for CSSNHCSH
C D1,D2 =     Scaled second differences
C E =         CM**2 - SM*Sinh = SIG*SM - 2*CMM (scaled by
C               2*EMS if SIG > .5)
C EMS =       Exp(-SIG)
C E1,E2 =     Exp(-SB1), Exp(-SB2)
C GT =        Tangential component of G -- component in the
C               direction UN X P
C I =         DO-loop index
C LUN =       Logical unit for error messages
C S =         Slope:  (F2-F1)/A
C SB1,SB2 =   SIG*B1, SIG*B2
C SIG =       Abs(SIGMA)
C SINH =      Sinh(SIGMA)
C SINH2 =     Sinh(SB2)
C SM,SM2 =    Sinhm(SIG), Sinhm(SB2)
C TAU1,TAU2 = Tangential derivatives (components of G1,G2)
C               at P1 and P2
C TM =        1-EMS
C TM1,TM2 =   1-E1, 1-E2
C TP1,TP2 =   1+E1, 1+E2
C TS =        TM**2
C UN =        Unit normal to the plane of P, P1, and P2
C UNORM =     Euclidean norm of P1 X P2 -- used to normalize
C               UN
C
C
C Compute unit normal UN.
C
      UN(1) = P1(2)*P2(3) - P1(3)*P2(2)
      UN(2) = P1(3)*P2(1) - P1(1)*P2(3)
      UN(3) = P1(1)*P2(2) - P1(2)*P2(1)
      UNORM = SQRT(UN(1)*UN(1) + UN(2)*UN(2) + UN(3)*UN(3))
      IF (UNORM .EQ. 0.) GO TO 2
C
C Normalize UN.
C
      DO 1 I = 1,3
        UN(I) = UN(I)/UNORM
    1   CONTINUE
C
C Compute tangential derivatives at the endpoints:
C   TAU1 = (G1,UN X P1) = (G1,P2)/UNORM and
C   TAU2 = (G2,UN X P2) = -(G2,P1)/UNORM.
C
      TAU1 = (G1(1)*P2(1) + G1(2)*P2(2) + G1(3)*P2(3))/UNORM
      TAU2 =-(G2(1)*P1(1) + G2(2)*P1(2) + G2(3)*P1(3))/UNORM
C
C Compute arc-lengths A, AL.
C
      A = CSARCLEN(P1,P2)
      IF (A .EQ. 0.) GO TO 2
      AL = CSARCLEN(P1,P)
C
C Compute local coordinates, slope, and second differences.
C
      B2 = AL/A
      B1 = 1. - B2
      S = (F2-F1)/A
      D1 = S - TAU1
      D2 = TAU2 - S
C
C Test the range of SIGMA.
C
      SIG = ABS(SIGMA)
      IF (SIG .LT. 1.D-9) THEN
C
C Hermite cubic interpolation.
C
        F = F1 + AL*(TAU1 + B2*(D1 + B1*(D1 - D2)))
        GT = TAU1 + B2*(D1 + D2 + 3.*B1*(D1 - D2))
      ELSEIF (SIG .LE. .5) THEN
C
C 0 < SIG .LE. .5.  Use approximations designed to avoid
C   cancellation error in the hyperbolic functions.
C
        SB2 = SIG*B2
        CALL CSSNHCSH (SIG, SM,CM,CMM)
        CALL CSSNHCSH (SB2, SM2,CM2,DUMMY)
        SINH = SM + SIG
        SINH2 = SM2 + SB2
        E = SIG*SM - CMM - CMM
        F = F1 + AL*TAU1 + A*((CM*SM2-SM*CM2)*(D1+D2) + SIG*
     .                        (CM*CM2-SINH*SM2)*D1)/(SIG*E)
        GT = TAU1 + ((CM*CM2-SM*SINH2)*(D1+D2) + SIG*
     .               (CM*SINH2-SINH*CM2)*D1)/E
      ELSE
C
C SIG > .5.  Use negative exponentials in order to avoid
C   overflow.  Note that EMS = EXP(-SIG).
C
        SB1 = SIG*B1
        SB2 = SIG - SB1
        E1 = EXP(-SB1)
        E2 = EXP(-SB2)
        EMS = E1*E2
        TM = 1. - EMS
        TS = TM*TM
        TM1 = 1. - E1
        TM2 = 1. - E2
        E = TM*(SIG*(1.+EMS) - TM - TM)
        F = F1 + AL*S + A*(TM*TM1*TM2*(D1+D2) + SIG*
     .                     ((E2*TM1*TM1-B1*TS)*D1 +
     .                      (E1*TM2*TM2-B2*TS)*D2))/(SIG*E)
        TP1 = 1. + E1
        TP2 = 1. + E2
        GT = S + (TM1*(TM*TP2-SIG*E2*TP1)*D1 -
     .            TM2*(TM*TP1-SIG*E1*TP2)*D2)/E
      ENDIF
C
C Compute GN.
C
      GN = B1*(UN(1)*G1(1) + UN(2)*G1(2) + UN(3)*G1(3)) +
     .     B2*(UN(1)*G2(1) + UN(2)*G2(2) + UN(3)*G2(3))
C
C Compute G = GT*(UN X P) + GN*UN.
C
      G(1) = GT*(UN(2)*P(3) - UN(3)*P(2)) + GN*UN(1)
      G(2) = GT*(UN(3)*P(1) - UN(1)*P(3)) + GN*UN(2)
      G(3) = GT*(UN(1)*P(2) - UN(2)*P(1)) + GN*UN(3)
      RETURN
C
C P1 X P2 = 0.  Print an error message and terminate
C   processing.
C
    2 WRITE (LUN,100) (P1(I),I=1,3), (P2(I),I=1,3)
  100 FORMAT ('1','ERROR IN CSARCINT -- P1 = ',2(F9.6,',  '),
     .        F9.6/1X,19X,'P2 = ',2(F9.6,',  '),F9.6)
      STOP
      END

C BOGUS DRIVER
C     VCM = covcorm(x[*][*], iopt[2]:integer)
C           NCL:   x(nvar,ntim)

C NCLFORTSTART
c     subroutine BOGUS (ntim,nvar,x,xmsg,iopt,ier)
c     implicit none
c                                              ! input
c     integer ntim, nvar, iopt(2), ier
c     double precision x(ntim,nvar), xmsg, trace 
c                                              ! output
c     integer lvcm
c
c     lvcm = (nvar*(nvar+1))/2
c
c     if (iopt(1).eq.0) then
c                                              ; return sym storage mode
c         real, allocatable, dimension(:)   :: vcm
c         allocate (vcm1d(lvcm), stat=ier)
c         call dcovcormssm (ntim,nvar,x,xmsg,iopt(2)
c    +                     ,vcm1d,lvcm,trace,ier) 
c         return(vcm1d)
c     else
c                                              ; return as 2D
c         real, allocatable, dimension(:,:) :: vcm
c         allocate (vcm2d(nvar,nvar), stat=ier)
c         call dcovcorm (ntim,nvar,x,xmsg, iopt(2)
c    +                  ,vcm2d, lvcm,trace,ier)
c         return(vcm2d)
c     end if

c     return 
c     end

C NCLFORTSTART
      subroutine dcovcormssm (ntim,nvar,x,xmsg,iopt
     +                       ,vcm,lvcm,trace,ier)

c This is a driver routine to a suite of subroutines that
c     will calculate covariance or correlation matrices
c     x        - input data array  ( unchanged on output)
c     ntim,nvar- exact dimensions of x in calling routine
c     xmsg     - missing data code (if none set to some no. not encountered)
c     iopt     - 0 ==> covariance, 1 ==> correlation
c     vcm      - var-cov matrix
c     trace    - sum of diagonal elements
c                                              ! input
      integer ntim, nvar, iopt, lvcm, ier
      double precision x(ntim,nvar), xmsg, trace
c                                              ! output
      double precision vcm(lvcm)
C NCLEND

      ier   = 0
c
c iopt == 0 --> calculate variance-covariance matrix
c iopt == 1 --> calculate correlation matrix
c
      if (iopt.eq.0) then
          call dvcmssm (x,ntim,nvar,ntim,nvar,xmsg,vcm,lvcm,ier)
          nn    = 0
          trace = 0.0d0
          do nv=1,nvar
             nn    = nn + nv
             trace = trace + vcm(nn)
          end do
      else
          call dcrmssm (x,ntim,nvar,ntim,nvar,xmsg,vcm,lvcm,ier)
          trace = nvar
      end if

      return
      end


C NCLFORTSTART
      subroutine dcovcorm (ntim,nvar,x,xmsg, iopt, vcm, lvcm, trace,ier)
c
c This is a driver routine to a suite of subroutines that
c     will calculate covariance or correlation matrices

c     x        - input data array  ( unchanged on output)
c     ntim,nvar- exact dimensions of x in calling routine
c     xmsg     - missing data code (if none set to some no. not encountered)
c     iopt     - 0 ==> covariance, 1 ==> correlation
c     vcm      - var-cov matrix
c     lvcm     - not used
c                                              ! input
      integer ntim, nvar, iopt,lvcm, ier
      double precision x(ntim,nvar), xmsg, trace
c                                              ! output
      double precision vcm(nvar,nvar)
C NCLEND
      ier = 0
c
c iopt == 1 --> calculate variance-covariance matrix
c iopt == 0 --> calculate correlation matrix
c
      if (iopt.eq.0) then
          call dvcvmns (x,ntim,nvar,ntim,nvar,xmsg,vcm,lvcm,ier)
          trace = 0.0d0
          do nv=1,nvar
             trace = trace + vcm(nv,nv)
          end do
      else
          call dcormns (x,ntim,nvar,ntim,nvar,xmsg,vcm,lvcm,ier)
          trace = nvar
      end if

      return
      end

      SUBROUTINE CPBCON( UPLO, N, KD, AB, LDAB, ANORM, RCOND, WORK,
     $                   RWORK, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER          UPLO
      INTEGER            INFO, KD, LDAB, N
      REAL               ANORM, RCOND
*     ..
*     .. Array Arguments ..
      REAL               RWORK( * )
      COMPLEX            AB( LDAB, * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  CPBCON estimates the reciprocal of the condition number (in the
*  1-norm) of a complex Hermitian positive definite band matrix using
*  the Cholesky factorization A = U**H*U or A = L*L**H computed by
*  CPBTRF.
*
*  An estimate is obtained for norm(inv(A)), and the reciprocal of the
*  condition number is computed as RCOND = 1 / (ANORM * norm(inv(A))).
*
*  Arguments
*  =========
*
*  UPLO    (input) CHARACTER*1
*          = 'U':  Upper triangular factor stored in AB;
*          = 'L':  Lower triangular factor stored in AB.
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  KD      (input) INTEGER
*          The number of superdiagonals of the matrix A if UPLO = 'U',
*          or the number of sub-diagonals if UPLO = 'L'.  KD >= 0.
*
*  AB      (input) COMPLEX array, dimension (LDAB,N)
*          The triangular factor U or L from the Cholesky factorization
*          A = U**H*U or A = L*L**H of the band matrix A, stored in the
*          first KD+1 rows of the array.  The j-th column of U or L is
*          stored in the j-th column of the array AB as follows:
*          if UPLO ='U', AB(kd+1+i-j,j) = U(i,j) for max(1,j-kd)<=i<=j;
*          if UPLO ='L', AB(1+i-j,j)    = L(i,j) for j<=i<=min(n,j+kd).
*
*  LDAB    (input) INTEGER
*          The leading dimension of the array AB.  LDAB >= KD+1.
*
*  ANORM   (input) REAL
*          The 1-norm (or infinity-norm) of the Hermitian band matrix A.
*
*  RCOND   (output) REAL
*          The reciprocal of the condition number of the matrix A,
*          computed as RCOND = 1/(ANORM * AINVNM), where AINVNM is an
*          estimate of the 1-norm of inv(A) computed in this routine.
*
*  WORK    (workspace) COMPLEX array, dimension (2*N)
*
*  RWORK   (workspace) REAL array, dimension (N)
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ONE, ZERO
      PARAMETER          ( ONE = 1.0E+0, ZERO = 0.0E+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            UPPER
      CHARACTER          NORMIN
      INTEGER            IX, KASE
      REAL               AINVNM, SCALE, SCALEL, SCALEU, SMLNUM
      COMPLEX            ZDUM
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            ICAMAX
      REAL               SLAMCH
      EXTERNAL           LSAME, ICAMAX, SLAMCH
*     ..
*     .. External Subroutines ..
      EXTERNAL           CLACON, CLATBS, CSRSCL, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, AIMAG, REAL
*     ..
*     .. Statement Functions ..
      REAL               CABS1
*     ..
*     .. Statement Function definitions ..
      CABS1( ZDUM ) = ABS( REAL( ZDUM ) ) + ABS( AIMAG( ZDUM ) )
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      UPPER = LSAME( UPLO, 'U' )
      IF( .NOT.UPPER .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( KD.LT.0 ) THEN
         INFO = -3
      ELSE IF( LDAB.LT.KD+1 ) THEN
         INFO = -5
      ELSE IF( ANORM.LT.ZERO ) THEN
         INFO = -6
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'CPBCON', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      RCOND = ZERO
      IF( N.EQ.0 ) THEN
         RCOND = ONE
         RETURN
      ELSE IF( ANORM.EQ.ZERO ) THEN
         RETURN
      END IF
*
      SMLNUM = SLAMCH( 'Safe minimum' )
*
*     Estimate the 1-norm of the inverse.
*
      KASE = 0
      NORMIN = 'N'
   10 CONTINUE
      CALL CLACON( N, WORK( N+1 ), WORK, AINVNM, KASE )
      IF( KASE.NE.0 ) THEN
         IF( UPPER ) THEN
*
*           Multiply by inv(U').
*
            CALL CLATBS( 'Upper', 'Conjugate transpose', 'Non-unit',
     $                   NORMIN, N, KD, AB, LDAB, WORK, SCALEL, RWORK,
     $                   INFO )
            NORMIN = 'Y'
*
*           Multiply by inv(U).
*
            CALL CLATBS( 'Upper', 'No transpose', 'Non-unit', NORMIN, N,
     $                   KD, AB, LDAB, WORK, SCALEU, RWORK, INFO )
         ELSE
*
*           Multiply by inv(L).
*
            CALL CLATBS( 'Lower', 'No transpose', 'Non-unit', NORMIN, N,
     $                   KD, AB, LDAB, WORK, SCALEL, RWORK, INFO )
            NORMIN = 'Y'
*
*           Multiply by inv(L').
*
            CALL CLATBS( 'Lower', 'Conjugate transpose', 'Non-unit',
     $                   NORMIN, N, KD, AB, LDAB, WORK, SCALEU, RWORK,
     $                   INFO )
         END IF
*
*        Multiply by 1/SCALE if doing so will not cause overflow.
*
         SCALE = SCALEL*SCALEU
         IF( SCALE.NE.ONE ) THEN
            IX = ICAMAX( N, WORK, 1 )
            IF( SCALE.LT.CABS1( WORK( IX ) )*SMLNUM .OR. SCALE.EQ.ZERO )
     $         GO TO 20
            CALL CSRSCL( N, SCALE, WORK, 1 )
         END IF
         GO TO 10
      END IF
*
*     Compute the estimate of the reciprocal condition number.
*
      IF( AINVNM.NE.ZERO )
     $   RCOND = ( ONE / AINVNM ) / ANORM
*
   20 CONTINUE
*
      RETURN
*
*     End of CPBCON
*
      END

      PROGRAM TSRFAC
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C OPEN GKS, OPEN WORKSTATION OF TYPE 1, ACTIVATE WORKSTATION
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C INVOKE DEMO DRIVER
C
      CALL SRFAC(IERR)
C
C DEACTIVATE AND CLOSE WORKSTATION, CLOSE GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END
C
      SUBROUTINE SRFAC (IERROR)
C
C PURPOSE                To provide a simple demonstration of SRFACE.
C
C USAGE                  CALL SRFAC (IERROR)
C
C ARGUMENTS
C
C ON OUTPUT              IERROR
C                          An integer variable
C                          = 0, if the test was successful,
C                          = 1, the test was not successful.
C
C I/O                    If the test is successful, the message
C
C               SRFACE TEST EXECUTED--SEE PLOT TO CERTIFY
C
C                        is printed on unit 6.  In addition, 2
C                        frames are produced on the machine graphics
C                        device.  In order to determine if the test
C                        was successful, it is necessary to examine
C                        the plots.
C
C PRECISION              Single
C
C LANGUAGE               FORTRAN 77
C
C REQUIRED ROUTINES      SRFACE
C
C REQUIRED GKS LEVEL     0A
C
C ALGORITHM              The function
C
C                          Z(X,Y) = .25*(X + Y + 1./((X-.1)**2+Y**2+.09)
C                                   -1./((X+.1)**2+Y**2+.09)
C
C                        for X = -1. to +1. in increments of .1, and
C                            Y = -1.2 to +1.2 in increments of .1,
C                        is computed.  Then, entries EZSRFC and SURFACE
C                        are called to generate surface plots of Z.
C
C HISTORY                SURFACE was first written in April 1979 and
C                        converted to FORTRAN 77 and GKS in March 1984.
C
C XX contains the X-direction coordinate values for Z(X,Y);  YY contains
C the Y-direction coordinate values for Z(X,Y);  Z contains the function
C values;  S contains values for the line of sight for entry SRFACE;
C WORK is a work array;  ANGH contains the angle in degrees in the X-Y
C plane to the line of sight;  and ANGV contains the angle in degrees
C from the X-Y plane to the line of sight.
C
      REAL            XX(21)     ,YY(25)     ,Z(21,25)   ,S(6)       ,
     1                WORK(1096)
C
      DATA  S(1), S(2), S(3), S(4), S(5), S(6)/
     1      -8.0, -6.0,  3.0,  0.0,  0.0,  0.0/
C
      DATA  ANGH/45./, ANGV/15./
C
C Specify coordinates for plot titles.  The values CX and CY
C define the center of the title string in a 0. to 1. range.
C
      DATA CX/.5/, CY/.9/
C
C Initialize the error parameter.
C
      IERROR = 0
C
C Fill the XX and YY coordinate arrays as well as the Z function array.
C
      DO  20 I=1,21
         X = .1*REAL(I-11)
         XX(I) = X
         DO  10 J=1,25
            Y = .1*REAL(J-13)
            YY(J) = Y
            Z(I,J) = (X+Y+1./((X-.1)**2+Y**2+.09)-
     1                                      1./((X+.1)**2+Y**2+.09))*.25
   10    CONTINUE
   20 CONTINUE
C
C Select the normalization transformation 0.
C
      CALL GSELNT(0)
C
C
C     Frame 1 -- The EZSRFC entry.
C
C Add the plot title using GKS calls.
C
C Set the text alignment to center the string in horizontal and vertical
C
      CALL GSTXAL(2,3)
C
C Set the character height.
C
      CALL GSCHH(.016)
C
C Write the text.
C
      CALL GTX(CX,CY,'DEMONSTRATION PLOT FOR EZSRFC ENTRY OF SRFACE')
C
      CALL EZSRFC (Z,21,25,ANGH,ANGV,WORK)
C
C
C     Frame 2 -- The SRFACE entry.
C
C Add the plot title.
C
C Set the text alignment to center the string in horizontal and vertical
C
      CALL GSTXAL(2,3)
C
C Set the character height.
C
      CALL GSCHH(.016)
C
C Write the text.
C
      CALL GTX(CX,CY,'DEMONSTRATION PLOT FOR SRFACE ENTRY OF SRFACE')
C
      CALL SRFACE (XX,YY,Z,WORK,21,21,25,S,0.)
C
C This routine automatically generates frame advances.
C
      WRITE (6,1001)
C
      RETURN
C
 1001 FORMAT (' SRFACE TEST EXECUTED--SEE PLOT TO CERTIFY')
C
      END

      SUBROUTINE CUNMR3( SIDE, TRANS, M, N, K, L, A, LDA, TAU, C, LDC,
     $                   WORK, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          SIDE, TRANS
      INTEGER            INFO, K, L, LDA, LDC, M, N
*     ..
*     .. Array Arguments ..
      COMPLEX            A( LDA, * ), C( LDC, * ), TAU( * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  CUNMR3 overwrites the general complex m by n matrix C with
*
*        Q * C  if SIDE = 'L' and TRANS = 'N', or
*
*        Q'* C  if SIDE = 'L' and TRANS = 'C', or
*
*        C * Q  if SIDE = 'R' and TRANS = 'N', or
*
*        C * Q' if SIDE = 'R' and TRANS = 'C',
*
*  where Q is a complex unitary matrix defined as the product of k
*  elementary reflectors
*
*        Q = H(1) H(2) . . . H(k)
*
*  as returned by CTZRZF. Q is of order m if SIDE = 'L' and of order n
*  if SIDE = 'R'.
*
*  Arguments
*  =========
*
*  SIDE    (input) CHARACTER*1
*          = 'L': apply Q or Q' from the Left
*          = 'R': apply Q or Q' from the Right
*
*  TRANS   (input) CHARACTER*1
*          = 'N': apply Q  (No transpose)
*          = 'C': apply Q' (Conjugate transpose)
*
*  M       (input) INTEGER
*          The number of rows of the matrix C. M >= 0.
*
*  N       (input) INTEGER
*          The number of columns of the matrix C. N >= 0.
*
*  K       (input) INTEGER
*          The number of elementary reflectors whose product defines
*          the matrix Q.
*          If SIDE = 'L', M >= K >= 0;
*          if SIDE = 'R', N >= K >= 0.
*
*  L       (input) INTEGER
*          The number of columns of the matrix A containing
*          the meaningful part of the Householder reflectors.
*          If SIDE = 'L', M >= L >= 0, if SIDE = 'R', N >= L >= 0.
*
*  A       (input) COMPLEX array, dimension
*                               (LDA,M) if SIDE = 'L',
*                               (LDA,N) if SIDE = 'R'
*          The i-th row must contain the vector which defines the
*          elementary reflector H(i), for i = 1,2,...,k, as returned by
*          CTZRZF in the last k rows of its array argument A.
*          A is modified by the routine but restored on exit.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A. LDA >= max(1,K).
*
*  TAU     (input) COMPLEX array, dimension (K)
*          TAU(i) must contain the scalar factor of the elementary
*          reflector H(i), as returned by CTZRZF.
*
*  C       (input/output) COMPLEX array, dimension (LDC,N)
*          On entry, the m-by-n matrix C.
*          On exit, C is overwritten by Q*C or Q'*C or C*Q' or C*Q.
*
*  LDC     (input) INTEGER
*          The leading dimension of the array C. LDC >= max(1,M).
*
*  WORK    (workspace) COMPLEX array, dimension
*                                   (N) if SIDE = 'L',
*                                   (M) if SIDE = 'R'
*
*  INFO    (output) INTEGER
*          = 0: successful exit
*          < 0: if INFO = -i, the i-th argument had an illegal value
*
*  Further Details
*  ===============
*
*  Based on contributions by
*    A. Petitet, Computer Science Dept., Univ. of Tenn., Knoxville, USA
*
*  =====================================================================
*
*     .. Local Scalars ..
      LOGICAL            LEFT, NOTRAN
      INTEGER            I, I1, I2, I3, IC, JA, JC, MI, NI, NQ
      COMPLEX            TAUI
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           CLARZ, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          CONJG, MAX
*     ..
*     .. Executable Statements ..
*
*     Test the input arguments
*
      INFO = 0
      LEFT = LSAME( SIDE, 'L' )
      NOTRAN = LSAME( TRANS, 'N' )
*
*     NQ is the order of Q
*
      IF( LEFT ) THEN
         NQ = M
      ELSE
         NQ = N
      END IF
      IF( .NOT.LEFT .AND. .NOT.LSAME( SIDE, 'R' ) ) THEN
         INFO = -1
      ELSE IF( .NOT.NOTRAN .AND. .NOT.LSAME( TRANS, 'C' ) ) THEN
         INFO = -2
      ELSE IF( M.LT.0 ) THEN
         INFO = -3
      ELSE IF( N.LT.0 ) THEN
         INFO = -4
      ELSE IF( K.LT.0 .OR. K.GT.NQ ) THEN
         INFO = -5
      ELSE IF( L.LT.0 .OR. ( LEFT .AND. ( L.GT.M ) ) .OR.
     $         ( .NOT.LEFT .AND. ( L.GT.N ) ) ) THEN
         INFO = -6
      ELSE IF( LDA.LT.MAX( 1, K ) ) THEN
         INFO = -8
      ELSE IF( LDC.LT.MAX( 1, M ) ) THEN
         INFO = -11
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'CUNMR3', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( M.EQ.0 .OR. N.EQ.0 .OR. K.EQ.0 )
     $   RETURN
*
      IF( ( LEFT .AND. .NOT.NOTRAN .OR. .NOT.LEFT .AND. NOTRAN ) ) THEN
         I1 = 1
         I2 = K
         I3 = 1
      ELSE
         I1 = K
         I2 = 1
         I3 = -1
      END IF
*
      IF( LEFT ) THEN
         NI = N
         JA = M - L + 1
         JC = 1
      ELSE
         MI = M
         JA = N - L + 1
         IC = 1
      END IF
*
      DO 10 I = I1, I2, I3
         IF( LEFT ) THEN
*
*           H(i) or H(i)' is applied to C(i:m,1:n)
*
            MI = M - I + 1
            IC = I
         ELSE
*
*           H(i) or H(i)' is applied to C(1:m,i:n)
*
            NI = N - I + 1
            JC = I
         END IF
*
*        Apply H(i) or H(i)'
*
         IF( NOTRAN ) THEN
            TAUI = TAU( I )
         ELSE
            TAUI = CONJG( TAU( I ) )
         END IF
         CALL CLARZ( SIDE, MI, NI, L, A( I, JA ), LDA, TAUI,
     $               C( IC, JC ), LDC, WORK )
*
   10 CONTINUE
*
      RETURN
*
*     End of CUNMR3
*
      END

C
C	$Id: g01pat.f,v 1.8 2008-07-27 00:21:05 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE G01PAT
C
C  Process primitive attributes.
C
      include 'gksin.h'
      include 'g01ins.h'
      include 'g01adc.h'

	include 'g01rqa.h'
        include 'g01ast.h'
C
        REAL   UP, BASE, DMAX, FACTOR
        INTEGER ARGB2CI
C
        GOTO (210, 220, 230, 240, 250, 260, 270, 280,
     +        290, 300, 310, 320, 330, 340, 350, 360,
     +        370, 380, 390, 400, 410, 420, 430) MCODES-20
C
C  POLYLINE INDEX
C
  210 CONTINUE
      CALL GUPDVI (ID(1), IVPLIX, 1)
      RETURN
C
C  LINETYPE
C
  220 CONTINUE
      CALL GUPDVI (ID, IVLTYP, 1)
      RETURN
C
C  LINEWIDTH SCALE FACTOR
C
  230 CONTINUE
      CALL GUPDVR (RX, IVLWSC, 1)
      RETURN
C
C  POLYLINE COLOR INDEX
C
  240 CONTINUE
      CALL GUPDVI(argb2ci(ic(1)), IVPLCI, 1)
      RETURN
C
C  POLYMARKER INDEX
C
  250 CONTINUE
      CALL GUPDVI (ID, IVPMIX, 2)
      RETURN
C
C  MARKER TYPE
C
  260 CONTINUE
      CALL GUPDVI (ID, IVMTYP, 2)
      RETURN
C
C  MARKER SIZE SCALE FACTOR
C
  270 CONTINUE
      CALL GUPDVR (RX, IVMSZS, 2)
      RETURN
C
C  POLYMARKER COLOR INDEX
C
  280 CONTINUE
      CALL GUPDVI(argb2ci(ic(1)), IVPMCI, 2)
      RETURN
C
C  TEXT INDEX
C
  290 CONTINUE
      CALL GUPDVI (ID, IVTXIX, 3)
      RETURN
C
C  TEXT FONT AND PRECISION
C
  300 CONTINUE
C
C  Font.
C    Convert GKS font index to CGM pointer to font list.
C
      IFP = ABS(ID(1))
      CALL GUPDVI (IFP, IVTXFO, 3)
C
C  Precision.
C
      CALL GUPDVI (ID(2), IVTXPR, 3)
      RETURN
C
C  CHARACTER EXPANSION FACTOR
C
  310 CONTINUE
      CALL GUPDVR (RX, IVCHXP, 3)
      RETURN
C
C  CHARACTER SPACING
C
  320 CONTINUE
      CALL GUPDVR (RX, IVCHSP, 3)
      RETURN
C
C  TEXT COLOR INDEX
C
  330 CONTINUE
      CALL GUPDVI(argb2ci(ic(1)), IVTXCI, 3)
      RETURN
C
C  CHARACTER ORIENTATION VECTORS
C
  340 CONTINUE
C
C  Extract and process height.
C
      UP   = SQRT (RX(1)**2+RY(1)**2)
      BASE = SQRT (RX(2)**2+RY(2)**2)
      DMAX = MAX(UP,BASE)
      IF (DMAX .GT. 1.0)  THEN
C
C  A vector is longer than 1.0 NDC, scale down both vectors equally.
C
        FACTOR = 1.0/MAX(1.,DMAX)
        RX(1) = FACTOR*RX(1)
        RY(1) = FACTOR*RY(1)
        RX(2) = FACTOR*RX(2)
        RY(2) = FACTOR*RY(2)
      END IF
C
C  Fix height and process it.
C
      RTMP = 0.5+UP*REAL(MYSCAL)
      ID(1) = MAXYVD
      IF (RTMP .LT. REAL(MAXYVD)) ID(1) = INT(RTMP)
      CALL GUPDVI (ID, IVCHH, 3)
C
C  Convert NDC vectors to VDC and process.
C
      ID(1) = MIN (MAXYVD, INT (0.5 + MXSCAL*RX(1)))
      ID(2) = MIN (MAXYVD, INT (0.5 + MYSCAL*RY(1)))
      ID(3) = MIN (MAXYVD, INT (0.5 + MXSCAL*RX(2)))
      ID(4) = MIN (MAXYVD, INT (0.5 + MYSCAL*RY(2)))
      CALL GUPDVI (ID, IVCHOV, 3)
      RETURN
C
C  TEXT PATH
C
  350 CONTINUE
      CALL GUPDVI (ID, IVTXP, 3)
      RETURN
C
C  TEXT ALIGNMENT
C
  360 CONTINUE
      CALL GUPDVI (ID, IVTXAL, 3)
      RETURN
C
C  FILL AREA INDEX
C
  370 CONTINUE
      CALL GUPDVI (ID, IVFAIX, 4)
      RETURN
C
C  FILL AREA INTERIOR STYLE
C
  380 CONTINUE
      CALL GUPDVI (ID, IVFAIS, 4)
      RETURN
C
C  FILL AREA STYLE INDEX
C
  390 CONTINUE
      CALL GUPDVI (ID, IVFASI, 4)
      RETURN
C
C  FILL AREA COLOR INDEX
C
  400 CONTINUE
      CALL GUPDVI (argb2ci(ic(1)), IVFACI, 4)
      RETURN
C
C  PATTERN SIZE
C
  410 CONTINUE
C
C  Truncate DX,DY to limits of NDC unit square,
C  convert to VDC, store as height and width vectors.
C
      ID(4) = 0
      ID(3) = INT(REAL(MXSCAL)*(MAX(0.,MIN(1.0,RX(1)))))
      ID(2) = INT(REAL(MYSCAL)*(MAX(0.,MIN(1.0,RY(1)))))
      ID(1) = 0
      CALL GUPDVI (ID, IVPASZ, 4)
      RETURN
C
C  PATTERN REFERENCE POINT
C
  420 CONTINUE
C
C  Truncate X,Y to limits of NDC unit square and convert to VDC.
C
      ID(1) = INT(REAL(MXSCAL)*(MAX(0.,MIN(1.0,RX(1)))))
      ID(2) = INT(REAL(MYSCAL)*(MAX(0.,MIN(1.0,RX(2)))))
      CALL GUPDVI (ID, IVPARF, 4)
      RETURN
C
C  ASPECT SOURCE FLAGS
C
  430 CONTINUE
      CALL GUPASF
C
      RETURN
      END

C
C	$Id: gtdgts.f,v 1.4 2008-07-27 00:17:21 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
C============================================================
C                       GTDGTS
C============================================================
      SUBROUTINE GTDGTS(STRING,POS,MAXLEN,BASE,NUMBER)
C
C Routine to extract a number from a character string
C
C ON Entry:
C
C    STRING is a character string
C    POS    is the position to look for the first digit (POS <= MAXLEN)
C    MAXLEN is the length of STRING
C    BASE   is a string indicating the base of the number
C
C ON Exit :
C
C    NUMBER contains the integer (base 10) obtained from interpreting
C           the longest string of digits as a base BASE number, or 0
C           if no number was found.
C    POS    points to the character following the last digit (NUMBER <>
C           or UNCHANGED if NUMBER = 0
C ======================================================================
C
C INPUT arguments
C
      CHARACTER*(*) STRING
      CHARACTER*(*) BASE
      INTEGER       MAXLEN
C
C INPUT/OUTPUT arguments
C
      INTEGER       POS
C
C OUTPUT arguments
C
      INTEGER       NUMBER
C
C INTERNAL variables
C
      CHARACTER*1   MAXDIG, DIGIT
      INTEGER       IBASE,  IZERO, INDEX, MAX
C
C ======================================================================
C
C  Begin
C                Initialize the number and store the value of a
C                repeatedly needed function call.
      NUMBER = 0
      IZERO  = ICHAR ('0')
C
C                Find the integer representation of the base and the
C                character which is the greatest digit allowed in a
C                number of that base.
C
      IBASE  = 0
      DO 50 INDEX = 1, LEN(BASE)
          IBASE = IBASE*10 + ICHAR(BASE(INDEX:INDEX)) - IZERO
 50   CONTINUE
      MAX = IBASE - 1
      WRITE (MAXDIG, '(I1)') MAX
C
C                Examine each character, updating the value of the
C                number and the position of the first possible
C                non-digit,  until a non-digit is found.
C
      DO 100  INDEX = POS, MAXLEN
           DIGIT = STRING(INDEX:INDEX)
           IF ((DIGIT .GE. '0') .AND. (DIGIT .LE. MAXDIG)) THEN
                 NUMBER = NUMBER*IBASE + ICHAR(DIGIT) - IZERO
                 POS = POS + 1
           ELSE
                 GOTO 110
           ENDIF
 100  CONTINUE
 110  CONTINUE
C
      RETURN
      END

C
C	$Id: gwica.f,v 1.7 2008-07-27 00:21:07 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GWICA
C
C  Process GKS CELL ARRAY elements, put out CGM CELL ARRAY.
C
      include 'gksin.h'
      include 'gwiio.h'
      include 'gwiins.h'
      include 'gwiwsl.h'
      include 'gwienu.h'
      include 'gwiopc.h'
C
      INTEGER  DX, DY, KALL, NBYPCW, ROWLEN, ROWPAD, NBYTES
      INTEGER  NBYTE1, NBYTE2, GPAD, GDFCP, GNORUN
      INTEGER  ROWPOS, IDPOS, NCLOUT, NBPROW, IX
C
      SAVE
C
      DATA  KALL/0/,  NBYPCW/2/,  GPAD/0/,  GDFCP/0/,  GNORUN/1/
C
      KALL = KALL+1
      IF (KALL .EQ. 1) THEN
C
C  Treat the first case (set-up call, P,Q,DX,DY passed,
C  first color indices processed).
C
C  If the picture is empty, send the clip indicator and rectangle;
C  set the WSL entry "DISPLAY SURFACE EMPTY" to "NOT EMPTY".
C
        IF (MDEMPT .EQ. GEMPTY) CALL GWICLP(1)
        MDEMPT = GNEMPT
C
C  Transform P and Q corner points to VDC, generate the
C  R corner point, store all in WPXPY.
C
        WPXPY(1) = MXOFF+INT(REAL(MXSCAL)*RX(1))
        WPXPY(2) = MXOFF+INT(REAL(MYSCAL)*RY(1))
        WPXPY(3) = MYOFF+INT(REAL(MXSCAL)*RX(2))
        WPXPY(4) = MYOFF+INT(REAL(MYSCAL)*RY(2))
        WPXPY(5) = WPXPY(3)
        WPXPY(6) = WPXPY(2)
C
C  Save DX,DY for subsequent calls.
C
        DX = ID(1)
        DY = ID(2)
C
C  Compute the total byte length -- rows must all start on
C  CGM word boundaries, including the first row.
C
C  Byte count for P,Q,R points, DX,DY, local color precision,
C  run-length/packed flag, round to nearest CGM metafile word.
C
        NBYTE1 = 1 + (6*MVDCFW + 2*MINTFW + MINTFW + MEFW -1)/8
        NBYTE2 = NBYPCW*( 1 + (NBYTE1-1)/NBYPCW )
C
C  Number of bytes to hold a row of color indexes, round to
C  CGM word boundary, compute padding bytes per row (if any).
C
        NBPROW = 1 + (DX*MCIXFW-1)/8
        ROWLEN = NBYPCW*( 1 + (NBPROW-1)/NBYPCW )
        ROWPAD = ROWLEN - NBPROW
C
C  Total byte length of cell array element.
C
        NBYTES = NBYTE2 + DY*ROWLEN
C
C  Put out opcode (class and ID) and total length.
C
        CALL GWPTNI (CLCARY, IDCARY, NBYTES, RERR)
C
C  Put out P, Q, R points.
C
        CALL GWPTPR (WPXPY, MVDCFW, 6, RERR)
C
C  Put out DX and DY, local color precision, packed/run-length flg.
C
        CALL GWPTPR (ID, MINTFW, 2, RERR)
        CALL GWPTPR (GDFCP,  MINTFW, 1, RERR)
        CALL GWPTPR (GNORUN, MEFW, 1, RERR)
C
C  Pad to start of first row if necessary.
C
        IF (NBYTE1 .LT. NBYTE2)  THEN
           DO 10 IX=1, (NBYTE2-NBYTE1)
              CALL GWPTPR (GPAD, 8, 1, RERR)
 10        CONTINUE
        END IF
C
        IF (RERR .NE. 0) RETURN
C
C  Initialize pointer into current row.
C
        ROWPOS = 1
C
C  Begin processing of color index array.
C
C
C  Initialize pointer into current chunk of cell array.
C
        IDPOS  = 1
C
   25   CONTINUE
C
C  Number of cells to put out, to end of current row or
C  all cells remaining, whichever is less.
C
        NCLOUT = MIN (DX-ROWPOS+1, IC2-IDPOS+1)
        CALL GWPTPR (IC(IDPOS), MCIXFW, NCLOUT, RERR)
        IF (RERR .NE. 0)  RETURN
C
C  Update row position, pad to CGM word boundary if
C  just completed a row (next GPUTPR starts new row).
C
        ROWPOS = ROWPOS + NCLOUT
        IF (ROWPOS .GT. DX)  ROWPOS = 1
        IF (ROWPAD.GT.0 .AND. ROWPOS.EQ.1)  THEN
          DO 35 IX=1,ROWPAD
            CALL GWPTPR (GPAD, 8, 1, RERR)
   35     CONTINUE
        END IF
C
C  Update position in index array.
C
        IDPOS  = IDPOS  + NCLOUT
C
C  Go back to process next row (or partial row) if more
C  cells remain in this call.
C
        IF (IDPOS .LE. IC2)  GOTO 25
C
C  Processing of first call complete.
C
      END IF
C
C  Treat the continuation calls (the color index array).
C
      IF (KALL .GT. 1) THEN
C
C  Initialize pointer into current chunk of cell array.
C
        IDPOS  = 1
C
   20   CONTINUE
C
C  Number of cells to put out, to end of current row or
C  all cells remaining, whichever is less.
C
        NCLOUT = MIN (DX-ROWPOS+1, IC2-IDPOS+1)
        CALL GWPTPR (IC(IDPOS), MCIXFW, NCLOUT, RERR)
        IF (RERR .NE. 0)  RETURN
C
C  Update row position, pad to CGM word boundary if
C  just completed a row (next GPUTPR starts new row).
C
        ROWPOS = ROWPOS + NCLOUT
        IF (ROWPOS .GT. DX)  ROWPOS = 1
        IF (ROWPAD.GT.0 .AND. ROWPOS.EQ.1)  THEN
          DO 30 IX=1, ROWPAD
            CALL GWPTPR (GPAD, 8, 1, RERR)
   30     CONTINUE
        END IF
C
C  Update position in index array.
C
        IDPOS = IDPOS+NCLOUT
C
C  Go back to process next row (or partial row) if more
C  cells remain this call.
C
        IF (IDPOS .LE. IC2)  GOTO 20
C
      END IF
C
      IF (CONT .EQ. 0)  KALL = 0
C
      RETURN
C
      END

C
C	$Id: gqtxi.f,v 1.5 2008-07-27 00:21:00 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GQTXI(ERRIND,INDEX)
C
C  INQUIRE TEXT INDEX
C
      include 'gkscom.h'
C
      INTEGER ERRIND,INDEX
C
C  Check if GKS is in the proper state.
C
      CALL GZCKST(8,-1,ERRIND)
      IF (ERRIND .EQ. 0) THEN
        INDEX = CTXI
      ELSE
        INDEX = -1
      ENDIF
C
      RETURN
      END

      PROGRAM CTGEO3
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.  Use one
C of the following:
C
C       PARAMETER (IERF=6,LUNI=2,IWTY=1 ,IWID=1)  !  NCGM
C       PARAMETER (IERF=6,LUNI=2,IWTY=8 ,IWID=1)  !  X Windows
C       PARAMETER (IERF=6,LUNI=2,IWTY=20,IWID=1)  !  PostScript
C       PARAMETER (IERF=6,LUNI=2,IWTY=11,IWID=1)  !  PDF, Portrait
C       PARAMETER (IERF=6,LUNI=2,IWTY=12,IWID=1)  !  PDF, Landscape
C
        PARAMETER (IERF=6,LUNI=2,IWTYPE=1,IWTY=IWTYPE,IWID=1)
C
C The object of this program is to produce a set of plots illustrating
C the use of a geodesic mesh (which is inherently a triangular mesh) on
C the surface of the globe.  The data for the geodesic mesh were down-
C loaded from the Web site with the following URL:
C
C   http://kiwi.atmos.colostate.edu:16080/BUGS/projects/geodesic/
C
C (It seems that this URL no longer works; the scientists mentioned
C included David Randall and Ross Heikes.)
C
C The dataset is of interest for a couple of reasons:
C
C   The scientists who created it found a way of slightly altering the
C   mesh to make all its triangles have nearly the same surface area.
C   This is a difficult thing to do, and I would like to know how they
C   did it.
C
C   The dataset is presented in a somewhat different format; ingenuity
C   is required to extract the triangular mesh from it.  The vertices
C   of the geodesic mesh are given and each is accompanied by a list of
C   points forming a five- or six-sided polygonal patch around it.  In
C   order to connect adjacent vertices to form a triangular mesh, one
C   must first determine which vertices are adjacent.  This proves to
C   be a little tricky to do efficiently.  See the routine "GTGEO3",
C   which reads in the data and constructs the triangular mesh, for a
C   solution and for more information.
C
C Selected frames are drawn for each of four different viewpoints.  If
C (CLAT,CLON) is the approximate position of the "center point" of the
C mesh (which is defined somewhat arbitrarily for this mesh), the four
C viewpoints used will be as follows: (CLAT+45,CLON), (CLAT-45,CLON),
C (CLAT+45,CLON+180), and (CLAT-45,CLON+180).
C
C At each of the four viewpoints, up to four different frames may be
C drawn:
C
C   1) A frame showing the triangular mesh on the globe.  This frame
C      is drawn only if the parameter IMSH is non-zero.
C
C   2) A frame showing simple contours on the globe.  This frame is
C      drawn only if the parameter ICON is non-zero.
C
C   3) A frame showing color-filled contour bands on the globe, drawn
C      using filled areas.  This frame is drawn only if the parameter
C      ICOL is non-zero.
C
C   4) A frame showing color-filled contour bands on the globe, drawn
C      using a cell array.  This frame is drawn only if the parameter
C      ICAP is non-zero.
C
C Define the parameter that says whether or not the frame showing the
C triangular mesh is to be drawn (frame 1):
C
C       PARAMETER (IMSH=0)  !  triangular mesh not drawn
C       PARAMETER (IMSH=1)  !  triangular mesh drawn
C
        PARAMETER (IMSH=1)
C
C Define the parameter that says whether or not to draw simple contours
C (frame 2):
C
C       PARAMETER (ICON=0)  !  contours not drawn
C       PARAMETER (ICON=1)  !  contours drawn
C
        PARAMETER (ICON=1)
C
C Define the parameter that says whether or not to draw color-filled
C contours (frame 3):
C
C       PARAMETER (ICOL=0)  !  no color fill done
C       PARAMETER (ICOL=1)  !  color fill done
C
        PARAMETER (ICOL=1)
C
C Define the parameter that says whether or not to draw a cell array
C plot (frame 4):
C
C       PARAMETER (ICAP=0)  !  cell array plot not drawn
C       PARAMETER (ICAP=1)  !  cell array plot drawn
C
        PARAMETER (ICAP=1)
C
C To represent the triangular mesh, we use three singly-dimensioned
C arrays: RPNT holds points, IEDG holds edges, and ITRI holds triangles.
C The elements of each array form "nodes" having lengths as follows:
C
        PARAMETER (LOPN=5)
C
C The five elements of a point node are
C
C   1. the X coordinate of the point;
C   2. the Y coordinate of the point;
C   3. the Z coordinate of the point;
C   4. the field value at the point;
C   5. any additional value desired by the user.
C
        PARAMETER (LOEN=5)
C
C The five elements of an edge node are
C
C   1. the base index, in RPNT, of point 1 of the edge;
C   2. the base index, in RPNT, of point 2 of the edge;
C   3. the index, in ITRI, of the pointer to the edge in the triangle to
C      the left of the edge (-1 if there is no triangle to the left);
C   4. the index, in ITRI, of the pointer to the edge in the triangle to
C      the right of the edge (-1 if there is no triangle to the right);
C   5. a utility flag for use by algorithms that scan the structure.
C
C The "left" and "right" sides of an edge are defined as they would be
C by an observer standing on the globe at point 1 of the edge, looking
C toward point 2 of the edge.  It is possible, if there are "holes" in
C the mesh, that there will be no triangle to the left or to the right
C of an edge, but there must be a triangle on one side or the other.
C
        PARAMETER (LOTN=4)
C
C The four elements of a triangle node are
C
C   1. the base index, in IEDG, of edge 1 of the triangle;
C   2. the base index, in IEDG, of edge 2 of the triangle;
C   3. the base index, in IEDG, of edge 3 of the triangle;
C   4. a flag set non-zero to block use of the triangle, effectively
C      removing it from the mesh (not used for this mesh).
C
C The "base index" of a point node, an edge node, or a triangle node is
C always a multiple of the length of the node, to which can be added an
C offset to get the index of a particular element of the node.  For
C example, if I is the base index of a triangle of interest, ITRI(I+1)
C is its first element (the base index of its first edge).  Similarly,
C IEDG(ITRI(I+1)+2) is the base index of the second point of the first
C edge of the triangle with base index I, and RPNT(IEDG(ITRI(I+1)+2)+3)
C is the third (Z) coordinate of the second point of the first edge of
C the triangle with base index I.
C
C It is the pointers from the edge nodes back to the triangle nodes that
C allow CONPACKT to navigate the mesh, moving from triangle to triangle
C as it follows a contour line, but these pointers are tricky to define:
C if IPTE is the base index of an edge node and IEDG(IPTE+3) is zero or
C more, saying that there is a triangle to the left of the edge, then
C IEDG(IPTE+3) is the actual index of that element of the triangle node
C that points to the edge node; i.e., ITRI(IEDG(IPTE+3))=IPTE.  The base
C index of the triangle node defining that triangle is IPTT, where
C IPTT=LOTN*((IEDG(IPTE+3)-1)/LOTN), and the index of the pointer to
C the edge within the triangle node is IPTI=IEDG(IPTE+3)-IPTT, so that
C ITRI(IPTT+IPTI)=IPTE.  Similar comments apply to element 4 of an edge
C node, which points into the triangle node defining the triangle to the
C right of the edge.
C
C The maximum number of points, edges, and triangles (MNOP, MNOE, and
C MNOT) in a geodesic mesh can be computed directly from the parameter
C NDIV, which determines the order of the geodesic mesh.  For the grid
C we downloaded, the correct value is 16.
C
        PARAMETER (NDIV=16)
C
        PARAMETER (MNOP=10*NDIV*NDIV+2)
        PARAMETER (MNOE=30*NDIV*NDIV)
        PARAMETER (MNOT=20*NDIV*NDIV)
C
C Define the space reserved for the triangular mesh:
C
        PARAMETER (MPNT=MNOP*LOPN)
        PARAMETER (MEDG=MNOE*LOEN)
        PARAMETER (MTRI=MNOT*LOTN)
C
C Declare the arrays to hold point nodes, edge nodes, and triangle nodes
C defining the triangular mesh.
C
        DIMENSION RPNT(MPNT),IEDG(MEDG),ITRI(MTRI)
C
C Declare sort arrays to be used to keep track of where points and
C edges were put in the structure defining the triangular mesh.
C
        DIMENSION IPPP(2,MNOP),IPPE(2,MNOE)
C
C Declare real and integer workspaces needed by CONPACKT.
C
        PARAMETER (LRWK=10000,LIWK=1000)
C
        DIMENSION RWRK(LRWK),IWRK(LIWK)
C
C Declare the area map array needed to do solid fill.
C
        PARAMETER (LAMA=200000)
C
        DIMENSION IAMA(LAMA)
C
C Declare workspace arrays to be used in calls to ARSCAM.
C
        PARAMETER (NCRA=LAMA/10,NGPS=2)
C
        DIMENSION XCRA(NCRA),YCRA(NCRA),IAAI(NGPS),IAGI(NGPS)
C
C Declare arrays in which to generate a cell-array picture of the data
C on the triangular mesh.
C
C       PARAMETER (ICAM=1024,ICAN=1024)
        PARAMETER (ICAM= 512,ICAN= 512)
C
        DIMENSION ICRA(ICAM,ICAN)
C
C Declare external the routine that draws masked contour lines.
C
        EXTERNAL DRWMCL
C
C Declare external the routine that does color fill of contour bands.
C
        EXTERNAL DCFOCB
C
C Define a common block in which to keep track of the maximum space used
C in the arrays XCRA and YCRA.
C
        COMMON /COMONA/ MAXN
C
C Define the out-of-range flag.
C
        DATA OORV / 1.E12 /
C
C Define the tension on the splines to be used in smoothing contours.
C
C       DATA T2DS / 0.0 /  !  smoothing off
C       DATA T2DS / 2.5 /  !  smoothing on
C
        DATA T2DS / 0.0 /
C
C Define the distance between points on smoothed contour lines.
C
        DATA RSSL / .002 /
C
C Define the amount of real workspace to be used in drawing contours.
C
        DATA IRWC / 500 /
C
C Define the label-positioning flag.
C
C       DATA ILLP / 0 /  !  no labels
C       DATA ILLP / 1 /  !  dash-package writes labels
C       DATA ILLP / 2 /  !  regular scheme
C       DATA ILLP / 3 /  !  penalty scheme
C
        DATA ILLP / 2 /
C
C Define the high/low search radius.
C
        DATA HLSR / .075 /
C
C Define the high/low label overlap flag.
C
        DATA IHLO / 11 /
C
C Define the hachuring flag, hachure length, and hachure spacing.
C
C       DATA IHCF,HCHL,HCHS /  0 , +.004 , .010 /  !  off
C       DATA IHCF,HCHL,HCHS / +1 , -.004 , .020 /  !  on, all, uphill
C
        DATA IHCF,HCHL,HCHS /  0 , +.004 , .010 /
C
C Define a constant to convert from radians to degrees.
C
        DATA RTOD / 57.2957795130823 /
C
C Read data and generate the required triangular mesh.
C
        PRINT * , ' '
        PRINT * , 'READING TRIANGULAR MESH:'
C
        CALL GTGEO3 (RPNT,MPNT,NPNT,LOPN,
     +               IEDG,MEDG,NEDG,LOEN,
     +               ITRI,MTRI,NTRI,LOTN,
     +               IPPP,IPPE,CLAT,CLON)
C
C Print the number of points, edges, and triangles.
C
        PRINT * , '  NUMBER OF POINTS:    ',NPNT/LOPN
        PRINT * , '  NUMBER OF EDGES:     ',NEDG/LOEN
        PRINT * , '  NUMBER OF TRIANGLES: ',NTRI/LOTN
C
C Write the contents of the point list, the edge list, and the triangle
C list to "fort.11" in a readable form.
C
c       WRITE (11,'(''P'',I8,5F10.4)')
c    +        (I,RPNT(I+1),RPNT(I+2),RPNT(I+3),RPNT(I+4),RPNT(I+5),
c    +                                               I=0,NPNT-LOPN,LOPN)
c       WRITE (11,'(''E'',I8,5I10)')
c    +        (I,IEDG(I+1),IEDG(I+2),IEDG(I+3),IEDG(I+4),IEDG(I+5),
c    +                                               I=0,NEDG-LOEN,LOEN)
c       WRITE (11,'(''T'',I8,4I10)')
c    +        (I,ITRI(I+1),ITRI(I+2),ITRI(I+3),ITRI(I+4),
c    +                                               I=0,NTRI-LOTN,LOTN)
C
C Open GKS.
C
        PRINT * , 'OPENING AND INITIALIZING GKS'
C
        CALL GOPKS (IERF,0)
        CALL GOPWK (IWID,LUNI,IWTY)
        CALL GACWK (IWID)
C
C Turn off the clipping indicator.
C
        CALL GSCLIP (0)
C
C Define a basic set of colors (0 = white, background; 1 = black,
C foreground; 2 = yellow; 3 = magenta; 4 = red; 5 = cyan; 6 = green;
C 7 = blue; 8 = darker light gray; 9 = lighter light gray; 10 = dark
C yellow; 11 = dark gray; 12 = medium gray; 13 = light red, for
C geographic lines; 14 = light blue, for lat/lon lines).
C
        CALL GSCR   (IWID, 0,1.,1.,1.)
        CALL GSCR   (IWID, 1,0.,0.,0.)
        CALL GSCR   (IWID, 2,1.,1.,0.)
        CALL GSCR   (IWID, 3,1.,0.,1.)
        CALL GSCR   (IWID, 4,1.,0.,0.)
        CALL GSCR   (IWID, 5,0.,1.,1.)
        CALL GSCR   (IWID, 6,0.,1.,0.)
        CALL GSCR   (IWID, 7,0.,0.,1.)
        CALL GSCR   (IWID, 8,.5,.5,.5)
        CALL GSCR   (IWID, 9,.8,.8,.8)
        CALL GSCR   (IWID,10,.3,.3,0.)
        CALL GSCR   (IWID,11,.3,.3,.3)
        CALL GSCR   (IWID,12,.5,.5,.5)
        CALL GSCR   (IWID,13,.8,.5,.5)
        CALL GSCR   (IWID,14,.5,.5,.8)
C
C Define 100 colors, associated with color indices 151 through 250, to
C be used for color-filled contour bands and in cell arrays, ranging
C from blue to red.
C
        CALL DFCLRS (IWID,151,250,0.,0.,1.,1.,0.,0.)
C
C Set parameters in the utilities.
C
        PRINT * , 'SETTING PARAMETERS IN CONPACKT, EZMAP, AND PLOTCHAR'
C
C Set the mapping flag.
C
        CALL CTSETI ('MAP - MAPPING FLAG',1)
C
C Set the out-of-range flag value.
C
        CALL CTSETR ('ORV - OUT-OF-RANGE VALUE',OORV)
C
C Turn on the drawing of the mesh edge and set the area identifier for
C areas outside the mesh.
C
        CALL CTSETI ('PAI - PARAMETER ARRAY INDEX',-1)
        CALL CTSETI ('CLU - CONTOUR LEVEL USE FLAG',1)
        CALL CTSETI ('AIA - AREA IDENTIFIER FOR AREA',1001)
C
C Set the area identifier for areas in "out-of-range" areas.
C
C       CALL CTSETI ('PAI',-2)
C       CALL CTSETI ('AIA - AREA IDENTIFIER FOR AREA',1002)
C
C Set the 2D smoother flag.
C
        CALL CTSETR ('T2D - TENSION ON 2D SPLINES',T2DS)
C
C Set the distance between points on smoothed lines.
C
        CALL CTSETR ('SSL - SMOOTHED SEGMENT LENGTH',RSSL)
C
C Set the amount of real workspace to be used in drawing contours.
C
        CALL CTSETI ('RWC - REAL WORKSPACE FOR CONTOURS',IRWC)
C
C Set the label-positioning flag.
C
        CALL CTSETI ('LLP - LINE LABEL POSITIONING FLAG',ILLP)
C
C Set the high/low search radius.
C
        CALL CTSETR ('HLR - HIGH/LOW SEARCH RADIUS',HLSR)
C
C Set the high/low label overlap flag.
C
        CALL CTSETI ('HLO - HIGH/LOW LABEL OVERLAP FLAG',IHLO)
C
C Set the hachuring flag, hachure length, and hachure spacing.
C
        CALL CTSETI ('HCF - HACHURING FLAG',IHCF)
        CALL CTSETR ('HCL - HACHURE LENGTH',HCHL)
        CALL CTSETR ('HCS - HACHURE SPACING',HCHS)
C
C Set the cell array flag.
C
        CALL CTSETI ('CAF - CELL ARRAY FLAG',-1)
C
C Tell CONPACKT not to do its own call to SET, since EZMAP will have
C done it.
C
        CALL CTSETI ('SET - DO-SET-CALL FLAG', 0)
C
C Move the informational label up a little.
C
        CALL CTSETR ('ILY - INFORMATIONAL LABEL Y POSITION',-.005)
C
C Tell EZMAP not to draw the perimeter.
C
        CALL MPSETI ('PE',0)
C
C Tell EZMAP to use solid lat/lon lines.
C
        CALL MPSETI ('DA',65535)
C
C Tell PLOTCHAR to use one of the filled fonts and to outline each
C character.
C
        CALL PCSETI ('FN',25)
        CALL PCSETI ('OF',1)
C
C Tell PLOTCHAR to expect a character other than a colon as the
C function-control signal character.
C
        CALL PCSETC ('FC','|')
C
C Loop through four different viewing angles.
C
        DO 104 IDIR=1,4
C
          PRINT * , ' '
          PRINT * , 'VIEW FROM DIRECTION NUMBER: ',IDIR
C
C Tell EZMAP what projection to use and what its limits are.
C
          IF      (IDIR.EQ.1) THEN
            CALL MAPROJ ('OR',CLAT+45.,CLON,      0.)
          ELSE IF (IDIR.EQ.2) THEN
            CALL MAPROJ ('OR',CLAT-45.,CLON,      0.)
          ELSE IF (IDIR.EQ.3) THEN
            CALL MAPROJ ('OR',CLAT+45.,CLON+180., 0.)
          ELSE IF (IDIR.EQ.4) THEN
            CALL MAPROJ ('OR',CLAT-45.,CLON+180., 0.)
          END IF
C
          CALL MAPSET ('MA',0.,0.,0.,0.)
C
C Initialize EZMAP.
C
          CALL MAPINT
C
C If the triangular mesh is to be drawn, do it.
C
          IF (IMSH.NE.0) THEN
C
            PRINT * , 'DRAWING TRIANGULAR MESH'
C
            DO 101 IPTE=0,NEDG-LOEN,LOEN
C
              IFLL=0
C
              IF (IEDG(IPTE+3).GE.0) THEN
                IF (ITRI(LOTN*((IEDG(IPTE+3)-1)/LOTN)+4).EQ.0) IFLL=1
              END IF
C
              IFLR=0
C
              IF (IEDG(IPTE+4).GE.0) THEN
                IF (ITRI(LOTN*((IEDG(IPTE+4)-1)/LOTN)+4).EQ.0) IFLR=1
              END IF
C
              IF (IFLL.NE.0.OR.IFLR.NE.0) THEN
                CALL PLOTIT (0,0,2)
                CALL GSPLCI (8)
              ELSE
                CALL PLOTIT (0,0,2)
                CALL GSPLCI (9)
              END IF
C
              ALAT=RTOD*ASIN(RPNT(IEDG(IPTE+1)+3))
C
              IF (RPNT(IEDG(IPTE+1)+1).EQ.0..AND.
     +            RPNT(IEDG(IPTE+1)+2).EQ.0.) THEN
                ALON=0.
              ELSE
                ALON=RTOD*ATAN2(RPNT(IEDG(IPTE+1)+2),
     +                          RPNT(IEDG(IPTE+1)+1))
              END IF
C
              BLAT=RTOD*ASIN(RPNT(IEDG(IPTE+2)+3))
C
              IF (RPNT(IEDG(IPTE+2)+1).EQ.0..AND.
     +            RPNT(IEDG(IPTE+2)+2).EQ.0.) THEN
                BLON=0.
              ELSE
                BLON=RTOD*ATAN2(RPNT(IEDG(IPTE+2)+2),
     +                          RPNT(IEDG(IPTE+2)+1))
              END IF
C
              CALL DRSGCR (ALAT,ALON,BLAT,BLON)
C
  101       CONTINUE
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (13)
            CALL MAPGRD
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (14)
            CALL MAPLOT
C
C Draw the edges and vertices of the generating icosahedron.
C
            CALL DRGEAV
C
C Label the first frame.
C
            CALL PLCHHQ (CFUX(.03),CFUY(.946),'GEODESIC',.024,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.906),'(USER-DEFINED)',
     +                                                      .016,0.,-1.)
C
            IF (     IDIR.EQ.1) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 1',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.2) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 2',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.3) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 3',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.4) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 4',
     +                                                      .012,0.,-1.)
            END IF
C
            CALL PLCHHQ (CFUX(.97),CFUY(.950),'DERIVED TRIANGULAR MESH',
     +.012,0.,1.)
C
            CALL PLCHHQ (CFUX(.97),CFUY(.928),
     +                   'This mesh was created by subdividing',
     +                                                       .010,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.908),
     +                   'the faces of an icosahedron into',
     +                                                       .010,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.888),
     +                   'N x N equilateral triangles',
     +                                                       .010,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.868),
     +                   'and projecting those',
     +                                                       .010,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.848),
     +                   'onto the surface',
     +                                                       .010,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.828),
     +                   'of the globe',
     +                                                       .010,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.808),
     +                   '(shown for',
     +                                                       .010,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.788),
     +                   'N=16).',
     +                                                       .010,0.,1.)
C
            CALL PLCHHQ (CFUX(.97),CFUY(.183),
     +                   'Mesh was',
     +                                                       .010,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.163),
     +                   'then modified',
     +                                                       .010,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.143),
     +                   'in such a way as',
     +                                                       .010,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.123),
     +                   'to make all triangles',
     +                                                       .010,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.103),
     +                   'have nearly the same area.',
     +                                                       .010,0.,1.)
C
            CALL PLCHHQ (CFUX(.97),CFUY(.073),
     +                   'Projections of the edges and',
     +                                                       .010,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.053),
     +                   'vertices of the original icosahedron',
     +                                                       .010,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.033),
     +                   'are drawn using bold black lines and dots.',
     +                                                       .010,0.,1.)
C
            CALL PLCHHQ (CFUX(.03),CFUY(.084),'Mesh is gray.',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.060),'Shorelines are blue.',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.036),'Parallels/meridians are r
     +ed.',.012,0.,-1.)
C
C Advance the frame.
C
            CALL FRAME
C
          END IF
C
C If a frame showing simple contours is to be drawn, do it next (adding
C an overlay of lat/lon lines and continental outlines in light gray).
C
          IF (ICON.NE.0) THEN
C
            PRINT * , 'DRAWING PLOT SHOWING SIMPLE CONTOURS'
C
C Initialize CONPACKT.
C
            PRINT * , 'CALLING CTMESH'
C
            CALL CTMESH (RPNT,NPNT,LOPN,
     +                   IEDG,NEDG,LOEN,
     +                   ITRI,NTRI,LOTN,
     +                   RWRK,LRWK,
     +                   IWRK,LIWK)
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (1)
C
C Proceed as implied by the setting of the label-positioning flag.
C
            IF (ABS(ILLP).EQ.1) THEN
C
C Draw the contour lines with labels generated by the dash package.
C
              PRINT * , 'CALLING CTCLDR'
              CALL CTCLDR (RPNT,IEDG,ITRI,RWRK,IWRK)
C
C Add the informational and high/low labels.
C
              PRINT * , 'CALLING CTLBDR'
              CALL CTLBDR (RPNT,IEDG,ITRI,RWRK,IWRK)
C
            ELSE IF (ABS(ILLP).GT.1) THEN
C
C Create an area map for masking of labels.
C
              MAXN=0
C
              PRINT * , 'CALLING ARINAM'
              CALL ARINAM (IAMA,LAMA)
C
              PRINT * , 'CALLING CTLBAM'
              CALL CTLBAM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA)
C
C Draw the contour lines masked by the area map.
C
              PRINT * , 'CALLING CTCLDM'
              CALL CTCLDM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA,DRWMCL)
C
              PRINT * , 'AREA MAP SPACE REQUIRED:         ',
     +                                         IAMA(1)-IAMA(6)+IAMA(5)+1
C
              PRINT * , 'NUMBER OF POINTS IN LONGEST LINE:',MAXN
C
C Draw all the labels.
C
              PRINT * , 'CALLING CTLBDR'
              CALL CTLBDR (RPNT,IEDG,ITRI,RWRK,IWRK)
C
            END IF
C
            CALL CTGETI ('IWU - INTEGER WORKSPACE USED',IIWU)
            PRINT * , 'INTEGER WORKSPACE REQUIRED:      ',IIWU
C
            CALL CTGETI ('RWU -    REAL WORKSPACE USED',IRWU)
            PRINT * , 'REAL WORKSPACE REQUIRED:         ',IRWU
C
C Add lat/lon lines and continental outlines.
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (13)
            CALL MAPGRD
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (14)
            CALL MAPLOT
C
C Label the second frame.
C
            CALL PLCHHQ (CFUX(.03),CFUY(.946),'GEODESIC',.024,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.906),'(USER-DEFINED)',
     +                                                      .016,0.,-1.)
C
            IF (     IDIR.EQ.1) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 1',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.2) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 2',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.3) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 3',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.4) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 4',
     +                                                      .012,0.,-1.)
            END IF
C
            CALL PLCHHQ (CFUX(.97),CFUY(.950),'SIMPLE CONTOURS ON',
     +                                                       .012,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.926),'TRIANGULAR MESH',
     +                                                       .012,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.904),'Dummy data are used.',
     +                                                       .010,0.,1.)
C
            CALL PLCHHQ (CFUX(.03),CFUY(.060),'Shorelines are blue.',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.036),'Parallels/meridians are r
     +ed.',.012,0.,-1.)
C
C Advance the frame.
C
            CALL FRAME
C
          END IF
C
C If a frame showing color-filled contours is to be drawn, do it next.
C
          IF (ICOL.NE.0) THEN
C
            PRINT * , 'DRAWING PLOT SHOWING COLOR-FILLED CONTOURS'
C
            PRINT * , 'CALLING CTMESH'
C
            CALL CTMESH (RPNT,NPNT,LOPN,
     +                   IEDG,NEDG,LOEN,
     +                   ITRI,NTRI,LOTN,
     +                   RWRK,LRWK,
     +                   IWRK,LIWK)
C
            MAXN=0
C
            PRINT * , 'CALLING CTPKCL'
            CALL CTPKCL (RPNT,IEDG,ITRI,RWRK,IWRK)
C
            PRINT * , 'CALLING ARINAM'
            CALL ARINAM (IAMA,LAMA)
C
            PRINT * , 'CALLING CTCLAM'
            CALL CTCLAM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA)
C
C           PRINT * , 'CALLING CTLBAM'
C           CALL CTLBAM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA)
C
            PRINT * , 'CALLING ARSCAM'
            CALL ARSCAM (IAMA,XCRA,YCRA,NCRA,IAAI,IAGI,NGPS,DCFOCB)
C
            PRINT * , 'SPACE REQUIRED IN AREA MAP:      ',
     +                                         IAMA(1)-IAMA(6)+IAMA(5)+1
C
            PRINT * , 'NUMBER OF POINTS IN LARGEST AREA:',MAXN
C
            CALL CTGETI ('IWU - INTEGER WORKSPACE USED',IIWU)
            PRINT * , 'INTEGER WORKSPACE REQUIRED:      ',IIWU
C
            CALL CTGETI ('RWU -    REAL WORKSPACE USED',IRWU)
            PRINT * , 'REAL WORKSPACE REQUIRED:         ',IRWU
C
            CALL GSFACI (1)
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (13)
            CALL MAPGRD
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (14)
            CALL MAPLOT
C
C Label the third frame.
C
            CALL PLCHHQ (CFUX(.03),CFUY(.946),'GEODESIC',.024,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.906),'(USER-DEFINED)',
     +                                                      .016,0.,-1.)
C
            IF (     IDIR.EQ.1) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 1',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.2) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 2',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.3) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 3',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.4) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 4',
     +                                                      .012,0.,-1.)
            END IF
C
            CALL PLCHHQ (CFUX(.97),CFUY(.950),'COLORED CONTOUR BANDS ON'
     +,.012,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.926),'TRIANGULAR MESH',
     +                                                       .012,0.,1.)
C
            CALL PLCHHQ (CFUX(.97),CFUY(.904),'Dummy data are used.',
     +                                                       .010,0.,1.)
C
            CALL PLCHHQ (CFUX(.03),CFUY(.132),'Off-mesh',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.108),'areas of the',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.084),'globe are yellow.',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.060),'Shorelines are blue.',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.036),'Parallels/meridians are r
     +ed.',.012,0.,-1.)
C
C Advance the frame.
C
            CALL FRAME
C
          END IF
C
C If the flag for it is set, do a cell array plot.
C
          IF (ICAP.NE.0) THEN
C
            PRINT * , 'DRAWING CELL-ARRAY PLOT OF DATA VALUES'
C
            PRINT * , 'CALLING CTMESH'
C
            CALL CTMESH (RPNT,NPNT,LOPN,
     +                   IEDG,NEDG,LOEN,
     +                   ITRI,NTRI,LOTN,
     +                   RWRK,LRWK,
     +                   IWRK,LIWK)
C
            CALL GETSET (XVPL,XVPR,YVPB,YVPT,XWDL,XWDR,YWDB,YWDT,LNLG)
C
            PRINT * , 'CALLING CTCICA'
            CALL CTCICA (RPNT,IEDG,ITRI,RWRK,IWRK,ICRA,ICAM,ICAM,ICAN,
     +                                            XVPL,YVPB,XVPR,YVPT)
C
            PRINT * , 'CALLING GCA'
            CALL GCA (XWDL,YWDB,XWDR,YWDT,ICAM,ICAN,1,1,ICAM,ICAN,ICRA)
C
            CALL CTGETI ('IWU - INTEGER WORKSPACE USED',IIWU)
            PRINT * , 'INTEGER WORKSPACE REQUIRED:      ',IIWU
C
            CALL CTGETI ('RWU -    REAL WORKSPACE USED',IRWU)
            PRINT * , 'REAL WORKSPACE REQUIRED:         ',IRWU
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (13)
            CALL MAPGRD
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (14)
            CALL MAPLOT
C
C Label the fourth frame.
C
            CALL PLCHHQ (CFUX(.03),CFUY(.946),'GEODESIC',.024,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.906),'(USER-DEFINED)',
     +                                                      .016,0.,-1.)
C
            IF (     IDIR.EQ.1) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 1',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.2) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 2',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.3) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 3',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.4) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 4',
     +                                                      .012,0.,-1.)
            END IF
C
            CALL PLCHHQ (CFUX(.97),CFUY(.950),'CELL ARRAY DERIVED FROM',
     +.012,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.926),'TRIANGULAR MESH',
     +                                                       .012,0.,1.)
C
            CALL PLCHHQ (CFUX(.97),CFUY(.904),'Dummy data are used.',
     +                                                       .010,0.,1.)
C
            CALL PLCHHQ (CFUX(.03),CFUY(.132),'Off-mesh',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.108),'areas of the',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.084),'globe are yellow.',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.060),'Shorelines are blue.',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.036),'Parallels/meridians are r
     +ed.',.012,0.,-1.)
C
C Advance the frame.
C
            CALL FRAME
C
          END IF
C
  104   CONTINUE
C
C Close GKS.
C
        CALL GDAWK (IWID)
        CALL GCLWK (IWID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END


      SUBROUTINE DFCLRS (IWID,IOFC,IOLC,REDF,GRNF,BLUF,REDL,GRNL,BLUL)
C
C This routine defines color indices IOFC through IOLC on workstation
C IWID by interpolating values from REDF/GRNF/BLUF to REDL/GRNL/BLUL.
C
        DO 101 I=IOFC,IOLC
          P=REAL(IOLC-I)/REAL(IOLC-IOFC)
          Q=REAL(I-IOFC)/REAL(IOLC-IOFC)
          CALL GSCR (IWID,I,P*REDF+Q*REDL,P*GRNF+Q*GRNL,P*BLUF+Q*BLUL)
  101   CONTINUE
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE GTGEO3 (RPNT,MPNT,NPNT,LOPN,
     +                   IEDG,MEDG,NEDG,LOEN,
     +                   ITRI,MTRI,NTRI,LOTN,
     +                   IPPP,IPPE,PLAT,PLON)
C
        DIMENSION RPNT(MPNT),IEDG(MEDG),ITRI(MTRI),IPPP(2,*),IPPE(2,*)
C
C Construct a triangular mesh representing a geodesic sphere from data
C downloaded from a user site.
C
C Include definitions that "NetCDF" needs (now commented out, because
C the data are being read from an ASCII file, instead).
C
C       include 'netcdf.inc'
C
C GTGEO3 calls a routine (CTTMTL) that allows one to easily create an
C arbitrary triangular mesh.  The "tree-sorts" used by the method are
C very inefficient for objects that are partially ordered, so, as the
C triangles of the mesh are generated, they are stored in a triangle
C buffer from which they can be dumped in random order by calls to the
C routine CTTMTL.  The following declarations create an array to use
C as the buffer for the triangles.  Up to a point, making this buffer
C larger will result in more randomization of the triangles and speed
C up the process.  MBUF is the number of triangles that will fit in the
C buffer at once, and KBUF is the number of those to be dumped whenever
C the buffer is found to be full.  Because the call and loop set-up
C time for CTTMTL are non-trivial, it's better to dump a significant
C number of triangles while you're there, but I'm not sure what value
C might work best.  Use MBUF > KBUF > 1 and play with the values a bit
C to see what causes improvement.  (I tend to use numbers that are
C relatively prime, but I'm not sure if that makes any difference.)
C
        PARAMETER (MBUF=5021,KBUF=173)
C
        DIMENSION TBUF(12,MBUF)
C
C Declare arrays into which to read the user's geodesic data.  VLAT
C and VLON hold the latitudes and longitudes of the 2562 vertices of
C the mesh, IOLF is an array of ocean/land flags, and ZDAT is an
C array of data (land elevations, in meters?).
C
        DIMENSION VLAT(2562),VLON(2562),IOLF(2562),ZDAT(2562)
C
C CLAT and CLON hold the latitudes and longitudes of the six (for some
C vertices, only five) corner points of a polygonal cell centered at the
C vertex.
C
        DIMENSION CLAT(6,2562),CLON(6,2562)
C
C In XCOV, YCOV, and ZCOV, we compute the Cartesian coordinates of the
C vertices and in IADJ we put the indices of adjacent polygonal patches.
C (The triangular mesh consists of the lines joining the vertices at the
C centers of adjacent patches.)  IWRK is an index array allowing us to
C order the vertices in such a way as to permit efficient searching for
C adjacent polygonal patches.
C
        DIMENSION XCOV(2562),YCOV(2562),ZCOV(2562)
        DIMENSION IADJ(2562,6)
        DIMENSION IWRK(2562)
C
C Dimension a variable needed for timing below.
C
C       DIMENSION TIME(2)
C
C Define needed conversion constants.
C
        DATA DTOR / .017453292519943 /
        DATA RTOD / 57.2957795130823 /
C
C The data for this example were originally read from a user's "NetCDF"
C file.  The code used for the purpose follows, but has been commented
C out, as the data are now read from an ASCII file.  This gets around
C certain procedural problems in running the example from "ncargex".
C
C Open the "NetCDF" file containing the geodesic data and read it.
C
C       ISTA=NF_OPEN('C02562.orog.nc',0,NCID)
C
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'ERROR RETURN FROM NF_OPEN: ',ISTA
C         STOP
C       END IF
C
C Read the array of latitudes of point nodes.
C
C       ISTA=NF_INQ_VARID(NCID,'grid_center_lat',IVID)
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'ERROR RETURN FROM NF_INQ_VARID: ',ISTA
C         STOP
C       END IF
C       ISTA=NF_GET_VAR_REAL(NCID,IVID,VLAT)
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'ERROR RETURN FROM NF_GET_VAR_REAL: ',ISTA
C         STOP
C       END IF
C
C Read the array of longitudes of point nodes.
C
C       ISTA=NF_INQ_VARID(NCID,'grid_center_lon',IVID)
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'ERROR RETURN FROM NF_INQ_VARID: ',ISTA
C         STOP
C       END IF
C       ISTA=NF_GET_VAR_REAL(NCID,IVID,VLON)
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'ERROR RETURN FROM NF_GET_VAR_REAL: ',ISTA
C         STOP
C       END IF
C
C Read the grid mask (ocean/land flag?) array.
C
C       ISTA=NF_INQ_VARID(NCID,'grid_imask',IVID)
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'ERROR RETURN FROM NF_INQ_VARID: ',ISTA
C         STOP
C       END IF
C       ISTA=NF_GET_VAR_INT(NCID,IVID,IOLF)
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'ERROR RETURN FROM NF_GET_VAR_REAL: ',ISTA
C         STOP
C       END IF
C
C Read an array of data at the point nodes.
C
C       ISTA=NF_INQ_VARID(NCID,'zs',IVID)
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'ERROR RETURN FROM NF_INQ_VARID: ',ISTA
C         STOP
C       END IF
C       ISTA=NF_GET_VAR_REAL(NCID,IVID,ZDAT)
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'ERROR RETURN FROM NF_GET_VAR_REAL: ',ISTA
C         STOP
C       END IF
C
C Read the array of latitudes of corner points.
C
C       ISTA=NF_INQ_VARID(NCID,'grid_corner_lat',IVID)
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'ERROR RETURN FROM NF_INQ_VARID: ',ISTA
C         STOP
C       END IF
C       ISTA=NF_GET_VAR_REAL(NCID,IVID,CLAT)
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'ERROR RETURN FROM NF_GET_VAR_REAL: ',ISTA
C         STOP
C       END IF
C
C Read the array of longitudes of corner points.
C
C       ISTA=NF_INQ_VARID(NCID,'grid_corner_lon',IVID)
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'ERROR RETURN FROM NF_INQ_VARID: ',ISTA
C         STOP
C       END IF
C       ISTA=NF_GET_VAR_REAL(NCID,IVID,CLON)
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'ERROR RETURN FROM NF_GET_VAR_REAL: ',ISTA
C         STOP
C       END IF
C
C Close the "NetCDF" file.
C
C       ISTA=NF_CLOSE(NCID)
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'ERROR RETURN FROM NF_CLOSE: ',ISTA
C         STOP
C       END IF
C
C Write the data to unit 11.  (These statements are commented out; they
C were used to create a "fort.11" which was then renamed "ctgeo3.dat".)
C
C       WRITE (11,'(5E16.8)') VLAT
C       WRITE (11,'(5E16.8)') VLON
C       WRITE (11,'(5E16.8)') ZDAT
C       WRITE (11,'(5E16.8)') CLAT
C       WRITE (11,'(5E16.8)') CLON
C       WRITE (11,'(  10I8)') IOLF
C
C Read the required data from the ASCII file "ctgeo3.dat".
C
        OPEN (11,FILE='ctgeo3.dat',STATUS='OLD',FORM='FORMATTED')
C
        READ (11,'(5E16.8)') VLAT
        READ (11,'(5E16.8)') VLON
        READ (11,'(5E16.8)') ZDAT
        READ (11,'(5E16.8)') CLAT
        READ (11,'(5E16.8)') CLON
        READ (11,'(  10I8)') IOLF
C
        CLOSE (11)
C
C Convert the latitudes and longitudes of the mesh points to degrees,
C compute equivalent X, Y, and Z coordinates on the unit sphere, and
C identify those polygonal patches having five vertices instead of six,
C replacing the latitude for any duplicate by the value 99.
C
        DO 104 I=1,2562
          VLAT(I)=RTOD*VLAT(I)
          VLON(I)=RTOD*VLON(I)
          XCOV(I)=COS(DTOR*VLAT(I))*COS(DTOR*VLON(I))
          YCOV(I)=COS(DTOR*VLAT(I))*SIN(DTOR*VLON(I))
          ZCOV(I)=SIN(DTOR*VLAT(I))
          DO 101 J=1,6
            CLAT(J,I)=RTOD*CLAT(J,I)
            CLON(J,I)=RTOD*CLON(J,I)
  101     CONTINUE
          DO 103 J=1,6
            JM1=MOD(J+4,6)+1
            IF (CLAT(J,I).EQ.CLAT(JM1,I).AND.
     +          CLON(J,I).EQ.CLON(JM1,I)) THEN
              DO 102 K=J,5
                CLAT(K,I)=CLAT(K+1,I)
                CLON(K,I)=CLON(K+1,I)
  102         CONTINUE
              CLAT(6,I)=99.
              GO TO 104
            END IF
  103     CONTINUE
  104   CONTINUE
C
C Print initial timing (commented out to avoid compiler problems on some
C machines).
C
C       PRINT * , ' '
C       PRINT * , 'BEFORE CREATING ADJACENCY INDEX ARRAY:'
C       IF (DTIME(TIME).GE.0.) THEN
C         PRINT * , '  USER TIME:  ',TIME(1)
C         PRINT * , '  SYSTEM TIME:',TIME(2)
C       ELSE
C         PRINT * , '  GTGEO3 - STOP - ERROR IN DTIME'
C       END IF
C
C Set up the adjacency index array (time-consuming brute-force method).
C This code is commented out, but I have left it here because it's a bit
C easier to read than the code that replaced it.  The idea is to examine
C each side of each of the 2562 five- or six-sided polygonal patches
C (having a center defined by VLAT(I) and VLON(I) and corners defined
C by the contents of CLAT(J,I) and CLON(J,I) for J from 1 to NOJS) and
C find a matching side in one of the other polygonal patches.  We take
C advantage of the fact that the corners are given in counterclockwise
C order.  We define the contents of an "adjacency array" so that, once
C we are done, we have the indices of the five or six neighbors of each
C of the polygonal patches.  Given this adjacency array, the triangles
C of the triangular mesh can be formed (by just connecting the center
C points of neighboring patches).
C
C       DO 108 I=1,2562
C         IF (CLAT(6,I).EQ.99.) THEN
C           IADJ(I,6)=-1
C           NOJS=5
C         ELSE
C           NOJS=6
C         END IF
C         DO 107 J=1,NOJS
C           JM1=MOD(J+NOJS-2,NOJS)+1
C           DO 106 K=1,2562
C             IF (K.NE.I) THEN
C               IF (CLAT(6,K).EQ.99.) THEN
C                 NOLS=5
C               ELSE
C                 NOLS=6
C               END IF
C               DO 105 L=1,NOLS
C                 LP1=MOD(L,NOLS)+1
C                 IF (CLAT(J  ,I).EQ.CLAT(L  ,K).AND.
C    +                CLON(J  ,I).EQ.CLON(L  ,K).AND.
C    +                CLAT(JM1,I).EQ.CLAT(LP1,K).AND.
C    +                CLON(JM1,I).EQ.CLON(LP1,K)) THEN
C                   IADJ(I,J)=K
C                   GO TO 107
C                 END IF
C 105           CONTINUE
C             END IF
C 106       CONTINUE
C 107     CONTINUE
C 108   CONTINUE
C
C Set up the adjacency index array (better method).  This is just like
C the brute-force method commented out above, but is about an order of
C magnitude faster because we order the vertices of the center points
C of the polygonal patches by latitude, making it possible to look for
C matching edges in nearby polygonal patches first.  (If we're trying
C to find a match for a side of the Ith polygonal patch (sorted order),
C we look at polygonal patches for IC = I+1, I-1, I+2, I-2, and so on,
C until we find the one we want.  If IC becomes less than 1 or greater
C than 2562, we just finish out the rest of the list by stepping through
C the remaining elements on the opposite end of it; IM implements the
C logic to manage this.
C
        CALL CTSORT (VLAT,2562,IWRK)
C
        DO 108 I=1,2562
          IF (CLAT(6,IWRK(I)).EQ.99.) THEN
            IADJ(IWRK(I),6)=-1
            NOJS=5
          ELSE
            NOJS=6
          END IF
          DO 107 J=1,NOJS
            JM1=MOD(J+NOJS-2,NOJS)+1
            IC=I
            IM=0
            DO 106 K=1,2561
              IF (IM.EQ.0) THEN
                IF (MOD(K,2).EQ.0) THEN
                  IC=IC-K
                  IF (IC.LT.1) THEN
                    IC=IC+K+1
                    IM=+1
                  END IF
                ELSE
                  IC=IC+K
                  IF (IC.GT.2562) THEN
                    IC=IC-K-1
                    IM=-1
                  END IF
                END IF
              ELSE
                IC=IC+IM
              END IF
              IF (CLAT(6,IWRK(IC)).EQ.99.) THEN
                NOLS=5
              ELSE
                NOLS=6
              END IF
              DO 105 L=1,NOLS
                LP1=MOD(L,NOLS)+1
                IF (CLAT(J  ,IWRK(I)).EQ.CLAT(L  ,IWRK(IC)).AND.
     +              CLON(J  ,IWRK(I)).EQ.CLON(L  ,IWRK(IC)).AND.
     +              CLAT(JM1,IWRK(I)).EQ.CLAT(LP1,IWRK(IC)).AND.
     +              CLON(JM1,IWRK(I)).EQ.CLON(LP1,IWRK(IC))) THEN
                  IADJ(IWRK(I),J)=IWRK(IC)
                  GO TO 107
                END IF
  105         CONTINUE
  106       CONTINUE
  107     CONTINUE
  108   CONTINUE
C
C Print final timing (commented out to avoid compiler problems on some
C machines).
C
C       PRINT * , ' '
C       PRINT * , 'AFTER CREATING ADJACENCY INDEX ARRAY:'
C       IF (DTIME(TIME).GE.0.) THEN
C         PRINT * , '  USER TIME:  ',TIME(1)
C         PRINT * , '  SYSTEM TIME:',TIME(2)
C       ELSE
C         PRINT * , '  GTGEO3 - STOP - ERROR IN DTIME'
C       END IF
C
C Build structures forming the triangular mesh.  First, initialize the
C variables used to keep track of items in the sort arrays for points
C and edges, in the triangle buffer, and in the triangle list.
C
        MPPP=MPNT/LOPN
        NPPP=0
C
        MPPE=MEDG/LOEN
        NPPE=0
C
        NBUF=0
C
        NTRI=0
C
C Loop through the vertices of the geodesic grid.
C
        DO 110 I=1,2562
C
C Set the index of vertex 1 of the triangle.
C
          IOV1=I
C
C Determine how many vertices are connected to vertex IOV1.
C
          IF (IADJ(I,6).LT.0) THEN
            NOJS=5
          ELSE
            NOJS=6
          END IF
C
C Examine all of the 5 or 6 triangles meeting at vertex IOV1, taking
C advantage of the fact that the vertices are given in counterclockwise
C order.
C
          DO 109 J=1,NOJS
C
            JP1=MOD(J,NOJS)+1
C
C Set the indices of vertices 2 and 3 of the triangle.
C
            IOV2=IADJ(I,J)
            IOV3=IADJ(I,JP1)
C
C Process a triangle only if the index of the 1st vertex is less than
C the indices of the other two vertices.  This will ensure that each
C triangle is processed only once, even though we see it three times.
C
            IF (IOV1.LT.IOV2.AND.IOV1.LT.IOV3) THEN
C
C If the triangle buffer is full, dump a few randomly-chosen triangles
C from it to make room for the new one.
C
              IF (NBUF.EQ.MBUF) THEN
                CALL CTTMTL (KBUF,TBUF,MBUF,NBUF,
     +                       IPPP,MPPP,NPPP,
     +                       IPPE,MPPE,NPPE,
     +                       RPNT,MPNT,NPNT,LOPN,
     +                       IEDG,MEDG,NEDG,LOEN,
     +                       ITRI,MTRI,NTRI,LOTN)
              END IF
C
C Put the new triangle in the triangle buffer.
C
              NBUF=NBUF+1

              TBUF( 1,NBUF)=XCOV(IOV1)
              TBUF( 2,NBUF)=YCOV(IOV1)
              TBUF( 3,NBUF)=ZCOV(IOV1)
              TBUF( 4,NBUF)=ZDAT(IOV1)
C
              TBUF( 5,NBUF)=XCOV(IOV2)
              TBUF( 6,NBUF)=YCOV(IOV2)
              TBUF( 7,NBUF)=ZCOV(IOV2)
              TBUF( 8,NBUF)=ZDAT(IOV2)
C
              TBUF( 9,NBUF)=XCOV(IOV3)
              TBUF(10,NBUF)=YCOV(IOV3)
              TBUF(11,NBUF)=ZCOV(IOV3)
              TBUF(12,NBUF)=ZDAT(IOV3)
C
            END IF
C
  109     CONTINUE
C
  110   CONTINUE
C
C Output all triangles remaining in the buffer.
C
        IF (NBUF.NE.0) THEN
          CALL CTTMTL (NBUF,TBUF,MBUF,NBUF,
     +                 IPPP,MPPP,NPPP,
     +                 IPPE,MPPE,NPPE,
     +                 RPNT,MPNT,NPNT,LOPN,
     +                 IEDG,MEDG,NEDG,LOEN,
     +                 ITRI,MTRI,NTRI,LOTN)
        END IF
C
C Set the pointers that tell the caller how many points and edges were
C created.
C
        NPNT=NPPP*LOPN
        NEDG=NPPE*LOEN
C
C Initialize the dummy-data generator and get data values for all the
C points of the mesh.
C
        CALL TDGDIN (-1.,1.,-1.,1.,-1.,1.,21,21)
C
        DO 111 I=0,NPNT-LOPN,LOPN
          RPNT(I+4)=TDGDVA(RPNT(I+1),RPNT(I+2),RPNT(I+3))
  111   CONTINUE
C
C Return the latitude and longitude of the approximate center point of
C the mesh on the globe (arbitrary for this mesh).
C
        PLAT=0.
        PLON=0.
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE DRWMCL (XCRA,YCRA,NCRA,IAAI,IAGI,NGPS)
C
        DIMENSION XCRA(*),YCRA(*),IAAI(*),IAGI(*)
C
C This routine draws the curve defined by the points (XCRA(I),YCRA(I)),
C for I = 1 to NCRA, if and only if none of the area identifiers for the
C area containing the polyline are negative.  It calls either CURVE or
C CURVED to do the drawing, depending on the value of the internal
C parameter 'DPU'.
C
C It keeps track of the maximum value used for NCRA in a common block.
C
        COMMON /COMONA/ MAXN
C
        MAXN=MAX(MAXN,NCRA)
C
C Retrieve the value of the internal parameter 'DPU'.
C
        CALL CTGETI ('DPU - DASH PACKAGE USED',IDUF)
C
C Turn on drawing.
C
        IDRW=1
C
C If any area identifier is negative, turn off drawing.
C
        DO 101 I=1,NGPS
          IF (IAAI(I).LT.0) IDRW=0
  101   CONTINUE
C
C If drawing is turned on, draw the polyline.
C
        IF (IDRW.NE.0) THEN
          IF (IDUF.EQ.0) THEN
            CALL CURVE  (XCRA,YCRA,NCRA)
          ELSE IF (IDUF.LT.0) THEN
            CALL DPCURV (XCRA,YCRA,NCRA)
          ELSE
            CALL CURVED (XCRA,YCRA,NCRA)
          END IF
        END IF
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE DCFOCB (XCRA,YCRA,NCRA,IAAI,IAGI,NGPS)
C
C This routine fills the area defined by the points (XCRA(I),YCRA(I)),
C for I = 1 to NCRA, if and only if none of the area identifiers for
C the area are negative.  The color used is determined from the area
C identifier of the area relative to group 3; it is assumed that 100
C colors are defined having color indices 151 through 250.
C
        DIMENSION XCRA(*),YCRA(*),IAAI(*),IAGI(*)
C
C It keeps track of the maximum value used for NCRA in a common block.
C
        COMMON /COMONA/ MAXN
C
        MAXN=MAX(MAXN,NCRA)
C
C Retrieve the number of contour levels being used.
C
        CALL CTGETI ('NCL - NUMBER OF CONTOUR LEVELS',NOCL)
C
C If the number of contour levels is non-zero and the area has more
C than two points, fill it.
C
        IF (NOCL.NE.0.AND.NCRA.GT.2) THEN
C
          IAI3=-1
C
          DO 101 I=1,NGPS
            IF (IAGI(I).EQ.3) IAI3=IAAI(I)
  101     CONTINUE
C
          IF (IAI3.GE.1.AND.IAI3.LE.NOCL+1) THEN
            CALL GSFACI (151+INT(((REAL(IAI3)-.5)/REAL(NOCL+1))*100.))
            CALL GFA    (NCRA,XCRA,YCRA)
          ELSE IF (IAI3.EQ.1001) THEN
            CALL GSFACI (2)
            CALL GFA    (NCRA,XCRA,YCRA)
          ELSE IF (IAI3.EQ.1002) THEN
            CALL GSFACI (3)
            CALL GFA    (NCRA,XCRA,YCRA)
          END IF
C
        END IF
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE DRSGCR (ALAT,ALON,BLAT,BLON)
C
C (DRSGCR = DRaw Shortest Great Circle Route)
C
C This routine draws the shortest great circle route joining two points
C on the globe.  Note that MPTS = INT(180./SIZE) + 1.
C
        PARAMETER (MPTS=181,SIZE=1.)
C
        DIMENSION QLAT(MPTS),QLON(MPTS)
C
        NPTS=MAX(1,MIN(MPTS,INT(ADSGCR(ALAT,ALON,BLAT,BLON)/SIZE)))
C
        CALL MAPGCI (ALAT,ALON,BLAT,BLON,NPTS,QLAT,QLON)
C
        CALL MAPIT (ALAT,ALON,0)
C
        DO 101 I=1,NPTS
          CALL MAPIT (QLAT(I),QLON(I),1)
  101   CONTINUE
C
        CALL MAPIT (BLAT,BLON,2)
C
        CALL MAPIQ
C
        RETURN
C
      END


      FUNCTION ADSGCR (ALAT,ALON,BLAT,BLON)
C
C (ADSGCR = Angle in Degrees along Shortest Great Circle Route)
C
C This function returns the shortest great circle distance, in degrees,
C between two points, A and B, on the surface of the globe.
C
        DATA DTOR / .017453292519943 /
        DATA RTOD / 57.2957795130823 /
C
        XCOA=COS(DTOR*ALAT)*COS(DTOR*ALON)
        YCOA=COS(DTOR*ALAT)*SIN(DTOR*ALON)
        ZCOA=SIN(DTOR*ALAT)
C
        XCOB=COS(DTOR*BLAT)*COS(DTOR*BLON)
        YCOB=COS(DTOR*BLAT)*SIN(DTOR*BLON)
        ZCOB=SIN(DTOR*BLAT)
C
        ADSGCR=2.*RTOD*ASIN(SQRT((XCOA-XCOB)**2+
     +                           (YCOA-YCOB)**2+
     +                           (ZCOA-ZCOB)**2)/2.)
C
        RETURN
C
      END


      SUBROUTINE TDGDIN (XMIN,XMAX,YMIN,YMAX,ZMIN,ZMAX,MLOW,MHGH)
C
C This is a routine to generate test data for three-dimensional graphics
C routines.  The function used is a sum of exponentials.
C
C "MLOW" and "MHGH" are each forced to be greater than or equal to 1 and
C less than or equal to 25.
C
        COMMON /TDGDCO/ XRNG,YRNG,ZRNG,NCNT,CCNT(4,50)
        SAVE   /TDGDCO/
C
        XRNG=XMAX-XMIN
        YRNG=YMAX-YMIN
        ZRNG=ZMAX-ZMIN
C
        NLOW=MAX(1,MIN(25,MLOW))
        NHGH=MAX(1,MIN(25,MHGH))
        NCNT=NLOW+NHGH
C
        DO 101 ICNT=1,NCNT
          CCNT(1,ICNT)=XMIN+XRNG*FRAN()
          CCNT(2,ICNT)=YMIN+YRNG*FRAN()
          CCNT(3,ICNT)=ZMIN+ZRNG*FRAN()
          IF (ICNT.LE.NLOW) THEN
            CCNT(4,ICNT)=-1.
          ELSE
            CCNT(4,ICNT)=+1.
          END IF
  101   CONTINUE
C
        RETURN
C
      END


      FUNCTION TDGDVA (XPOS,YPOS,ZPOS)
C
        COMMON /TDGDCO/ XRNG,YRNG,ZRNG,NCNT,CCNT(4,50)
        SAVE   /TDGDCO/
C
        TDGDVA=0.
C
        DO 101 ICNT=1,NCNT
          TEMP=-50.*(((XPOS-CCNT(1,ICNT))/XRNG)**2+
     +               ((YPOS-CCNT(2,ICNT))/YRNG)**2+
     +               ((ZPOS-CCNT(3,ICNT))/YRNG)**2)
          IF (TEMP.GE.-20.) TDGDVA=TDGDVA+CCNT(4,ICNT)*EXP(TEMP)
  101   CONTINUE
C
C Done.
C
        RETURN
C
      END


      FUNCTION FRAN ()
C
C Pseudo-random-number generator.
C
        DOUBLE PRECISION X
        SAVE X
C
        DATA X / 2.718281828459045D0 /
C
        X=MOD(9821.D0*X+.211327D0,1.D0)
        FRAN=REAL(X)
C
        RETURN
C
      END


      SUBROUTINE DRGEAV
C
C Draw the edges and vertices of the icosahedron used to generate a
C geodesic grid.
C
C Declare arrays to hold information describing an icosahedron.
C
        DIMENSION JEDG(2,30),XCVI(12),YCVI(12),ZCVI(12)
C
C Declare arrays to hold the latitudes and longitudes of the vertices
C (to be computed).
C
        DIMENSION RLAT(12),RLON(12)
C
C Define the thirty edges of the icosahedron (pointers to vertices).
C
        DATA JEDG(1, 1),JEDG(2, 1) /  1, 3 /
        DATA JEDG(1, 2),JEDG(2, 2) /  1, 5 /
        DATA JEDG(1, 3),JEDG(2, 3) /  1, 7 /
        DATA JEDG(1, 4),JEDG(2, 4) /  1, 9 /
        DATA JEDG(1, 5),JEDG(2, 5) /  1,11 /
        DATA JEDG(1, 6),JEDG(2, 6) /  2, 4 /
        DATA JEDG(1, 7),JEDG(2, 7) /  2, 6 /
        DATA JEDG(1, 8),JEDG(2, 8) /  2, 8 /
        DATA JEDG(1, 9),JEDG(2, 9) /  2,10 /
        DATA JEDG(1,10),JEDG(2,10) /  2,12 /
        DATA JEDG(1,11),JEDG(2,11) /  3, 5 /
        DATA JEDG(1,12),JEDG(2,12) /  3, 8 /
        DATA JEDG(1,13),JEDG(2,13) /  3,10 /
        DATA JEDG(1,14),JEDG(2,14) /  3,11 /
        DATA JEDG(1,15),JEDG(2,15) /  4, 6 /
        DATA JEDG(1,16),JEDG(2,16) /  4, 7 /
        DATA JEDG(1,17),JEDG(2,17) /  4, 9 /
        DATA JEDG(1,18),JEDG(2,18) /  4,12 /
        DATA JEDG(1,19),JEDG(2,19) /  5, 7 /
        DATA JEDG(1,20),JEDG(2,20) /  5,10 /
        DATA JEDG(1,21),JEDG(2,21) /  5,12 /
        DATA JEDG(1,22),JEDG(2,22) /  6, 8 /
        DATA JEDG(1,23),JEDG(2,23) /  6, 9 /
        DATA JEDG(1,24),JEDG(2,24) /  6,11 /
        DATA JEDG(1,25),JEDG(2,25) /  7, 9 /
        DATA JEDG(1,26),JEDG(2,26) /  7,12 /
        DATA JEDG(1,27),JEDG(2,27) /  8,10 /
        DATA JEDG(1,28),JEDG(2,28) /  8,11 /
        DATA JEDG(1,29),JEDG(2,29) /  9,11 /
        DATA JEDG(1,30),JEDG(2,30) / 10,12 /
C
C Define the 12 vertices of the icosahedron (note radius less than one).
C
        DATA XCVI / .0000000000000 ,  .0000000000000 , -.8506508083520 ,
     +              .8506508083520 , -.2628655560596 ,  .2628655560596 ,
     +              .6881909602356 , -.6881909602356 ,  .6881909602356 ,
     +             -.6881909602356 , -.2628655560595 ,  .2628655560596 /
        DATA YCVI / .0000000000000 ,  .0000000000000 ,  .0000000000000 ,
     +              .0000000000000 , -.8090169943749 ,  .8090169943749 ,
     +             -.5000000000000 ,  .5000000000000 ,  .5000000000000 ,
     +             -.5000000000000 ,  .8090169943749 , -.8090169943749 /
        DATA ZCVI / .9510565162952 , -.9510565162951 ,  .4253254041760 ,
     +             -.4253254041760 ,  .4253254041760 , -.4253254041760 ,
     +              .4253254041760 , -.4253254041760 ,  .4253254041760 ,
     +             -.4253254041760 ,  .4253254041760 , -.4253254041760 /
C
C Define a constant to convert from radians to degrees.
C
        DATA RTOD / 57.2957795130823 /
C
C Enlarge the icosahedron to have a radius of one and compute lat/lon
C coordinates of the points.
C
        DO 101 I=1,12
          DNOM=SQRT(XCVI(I)**2+YCVI(I)**2+ZCVI(I)**2)
          XCVI(I)=XCVI(I)/DNOM
          YCVI(I)=YCVI(I)/DNOM
          ZCVI(I)=ZCVI(I)/DNOM
          RLAT(I)=RTOD*ASIN(ZCVI(I))
          IF (XCVI(I).EQ.0..AND.YCVI(I).EQ.0.) THEN
            RLON(I)=0.
          ELSE
            RLON(I)=RTOD*ATAN2(YCVI(I),XCVI(I))
          END IF
  101   CONTINUE
C
C Draw the edges of the icosahedron, projected outwards onto the surface
C of the sphere.
C
        CALL PLOTIF (0.,0.,2)
        CALL GSLWSC (2.)
        CALL GSPLCI (1)
        CALL GSFACI (1)
C
        DO 102 I=1,30
          CALL DRSGCR (RLAT(JEDG(1,I)),RLON(JEDG(1,I)),
     +                 RLAT(JEDG(2,I)),RLON(JEDG(2,I)))
  102   CONTINUE
C
        CALL PLOTIF (0.,0.,2)
        CALL GSLWSC (1.)
C
C Mark the vertices of the icosahedron.
C
        DO 103 I=1,12
          CALL MAPTRA (RLAT(I),RLON(I),XVAL,YVAL)
          IF (XVAL.NE.1.E12.AND.YVAL.NE.1.E12) THEN
            CALL ELLIPS (CUFX(XVAL),CUFY(YVAL),.0075,.0075,0.,4.)
          END IF
  103   CONTINUE
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE ELLIPS (XCFR,YCFR,RADA,RADB,ROTD,DSTP)
C
C This routine fills an ellipse.  The arguments are as follows:
C
C   XCFR and YCFR are the coordinates of the center of the ellipse, in
C   the fractional coordinate system.
C
C   RADA is the length of the semimajor axis of the ellipse (i.e., the
C   distance from the center of the ellipse to one of the two points on
C   the ellipse which are furthest from the center).  This is a distance
C   in the fractional coordinate system.
C
C   RADB is the length of the semiminor axis of the ellipse (i.e., the
C   distance from the center of the ellipse to one of the two points on
C   the ellipse which are nearest to the center).  This is a distance in
C   the fractional coordinate system.
C
C   ROTD is a rotation angle, in degrees.  If ROTD is 0, the major axis
C   of the ellipse is horizontal.  If ROTD is 90, the major axis is
C   vertical.
C
C   DSTP is the step size, in degrees, between any two consecutive
C   points used to draw the ellipse.  The actual value used will be
C   limited to the range from .1 degrees (3600 points used to draw
C   the ellipse) to 90 degrees (4 points used to draw the ellipse).
C
C Declare work arrays to hold the coordinates.
C
        DIMENSION XCRA(3601),YCRA(3601)
C
C DTOR is pi over 180, used to convert an angle from degrees to radians.
C
        DATA DTOR / .017453292519943 /
C
C Get the rotation angle in radians.
C
        ROTR=DTOR*ROTD
C
C Compute the number of steps to be used to draw the ellipse and the
C actual number of degrees for each step.
C
        NSTP=MAX(4,MIN(3600,INT(360./MAX(.1,MIN(90.,DSTP)))))
        RSTP=360./NSTP
C
C Compute coordinates for the ellipse (just some trigonometry).
C
        DO 101 ISTP=0,NSTP
          ANGL=DTOR*REAL(ISTP)*RSTP
          XTMP=RADA*COS(ANGL)
          YTMP=RADB*SIN(ANGL)
          XCRA(ISTP+1)=CFUX(XCFR+XTMP*COS(ROTR)-YTMP*SIN(ROTR))
          YCRA(ISTP+1)=CFUY(YCFR+XTMP*SIN(ROTR)+YTMP*COS(ROTR))
  101   CONTINUE
C
C Fill it.
C
        CALL GFA (NSTP+1,XCRA,YCRA)
C
C Draw it.
C
        CALL GPL (NSTP+1,XCRA,YCRA)
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE SORTEM (RWRK,NRWK,IORD,IWRK)
C
        DIMENSION RWRK(NRWK),IWRK(NRWK)
C
C Given an array of NRWK reals in an array RWRK and an order flag
C IORD, this routine returns a permutation vector IWRK such that, for
C every I and J such that 1.LE.I.LE.J.LE.NRWK, if IORD is zero, then
C RWRK(IWRK(I)).LE.RWRK(IWRK(J)), else RWRK(IWRK(I)).GE.RWRK(IWRK(J)).
C
        DO 101 I=1,NRWK
          IWRK(I)=I
  101   CONTINUE
C                                                                       
        K=0
C
  102   IF (3*K+1.LT.NRWK) THEN
          K=3*K+1
          GO TO 102
        END IF
C                                                                       
        IF (IORD.EQ.0) THEN
C
  103     IF (K.GT.0) THEN
C
            DO 105 I=1,NRWK-K
C
              J=I
C
  104         IF (RWRK(IWRK(J)).LE.RWRK(IWRK(J+K))) GO TO 105
              ITMP=IWRK(J)
              IWRK(J)=IWRK(J+K)
              IWRK(J+K)=ITMP
              J=J-K
              IF (J.LT.1) GO TO 105
              GO TO 104
C
  105       CONTINUE
C
            K=(K-1)/3
C
            GO TO 103
C
          END IF
C
        ELSE
C
  106     IF (K.GT.0) THEN
C
            DO 108 I=1,NRWK-K
C
              J=I
C
  107         IF (RWRK(IWRK(J)).GE.RWRK(IWRK(J+K))) GO TO 108
              ITMP=IWRK(J)
              IWRK(J)=IWRK(J+K)
              IWRK(J+K)=ITMP
              J=J-K
              IF (J.LT.1) GO TO 108
              GO TO 107
C
  108       CONTINUE
C
            K=(K-1)/3
C
            GO TO 106
C
          END IF
C
        END IF
C
C Done.
C
        RETURN
C
      END                                                               


      SUBROUTINE CTSCAE (ICRA,ICA1,ICAM,ICAN,XCPF,YCPF,XCQF,YCQF,
     +                                       IND1,IND2,ICAF,IAID)
        DIMENSION ICRA(ICA1,*)
C
C This routine is called by CTCICA when the internal parameter 'CAF' is
C given a negative value.  Each call is intended to create a particular
C element in the user's cell array.  The arguments are as follows:
C
C ICRA is the user's cell array.
C
C ICA1 is the first dimension of the FORTRAN array ICRA.
C
C ICAM and ICAN are the first and second dimensions of the cell array
C stored in ICRA.
C
C (XCPF,YCPF) is the point at that corner of the rectangular area
C into which the cell array maps that corresponds to the cell (1,1).
C The coordinates are given in the fractional coordinate system (unlike
C what is required in a call to GCA, in which the coordinates of the
C point P are in the world coordinate system).
C
C (XCQF,YCQF) is the point at that corner of the rectangular area into
C which the cell array maps that corresponds to the cell (ICAM,ICAN).
C The coordinates are given in the fractional coordinate system (unlike
C what is required in a call to GCA, in which the coordinates of the
C point Q are in the world coordinate system).
C
C IND1 is the 1st index of the cell that is to be updated.
C
C IND2 is the 2nd index of the cell that is to be updated.
C
C ICAF is the current value of the internal parameter 'CAF'.  This
C value will always be an integer which is less than zero (because
C when 'CAF' is zero or greater, this routine is not called).
C
C IAID is the area identifier associated with the cell.  It will have
C been given one of the values from the internal parameter array 'AIA'
C (the one for 'PAI' = -2 if the cell lies in an out-of-range area, the
C one for 'PAI' = -1 if the cell lies off the data grid, or the one for
C some value of 'PAI' between 1 and 'NCL' if the cell lies on the data
C grid).  The value zero may occur if the cell falls in an out-of-range
C area and the value of 'AIA' for 'PAI' = -2 is 0 or if the cell lies
C off the data grid and the value of 'AIA' for 'PAI' = -1 is 0, or if
C the cell falls on the data grid, but no contour level below the cell
C has a non-zero 'AIA' and no contour level above the cell has a
C non-zero 'AIB'.  Note that, if the values of 'AIA' for 'PAI' = -1
C and -2 are given non-zero values, IAID can only be given a zero
C value in one way.
C
C The default behavior of CTSCAE is as follows:  If the area identifier
C is non-negative, it is treated as a color index, to be stored in the
C appropriate cell in the cell array; but if the area identifier is
C negative, a zero is stored for the color index.  The user may supply
C a version of CTSCAE that does something different; it may simply map
C the area identifiers into color indices or it may somehow modify the
C existing cell array element to incorporate the information provided
C by the area identifier.
C
C       ICRA(IND1,IND2)=MAX(0,IAID)
C
C What follows is not the default behavior; instead, it is the behavior
C expected by many of the example programs for CONPACKT.
C
        CALL CTGETI ('NCL - NUMBER OF CONTOUR LEVELS',NOCL)
C
        IF (IAID.GE.1.AND.IAID.LE.NOCL+1) THEN
          ICRA(IND1,IND2)=151+INT(((REAL(IAID)-.5)/REAL(NOCL+1))*100.)
        ELSE IF (IAID.EQ.1001) THEN
          ICRA(IND1,IND2)=2
        ELSE IF (IAID.EQ.1002) THEN
          ICRA(IND1,IND2)=3
        END IF
C
        RETURN
C
      END

C
C     $Id: isamax.f,v 1.1 1994-08-11 23:17:28 boote Exp $
C



      INTEGER FUNCTION ISAMAX(N,SX,INCX)
C
C     FINDS THE INDEX OF ELEMENT HAVING MAX. ABSOLUTE VALUE.
C     JACK DONGARRA, LINPACK, 3/11/78.
C
      REAL SX(1),SMAX
      INTEGER I,INCX,IX,N
C
      ISAMAX = 0
      IF( N .LT. 1 ) RETURN
      ISAMAX = 1
      IF(N.EQ.1)RETURN
      IF(INCX.EQ.1)GO TO 20
C
C        CODE FOR INCREMENT NOT EQUAL TO 1
C
      IX = 1
      SMAX = ABS(SX(1))
      IX = IX + INCX
      DO 10 I = 2,N
         IF(ABS(SX(IX)).LE.SMAX) GO TO 5
         ISAMAX = I
         SMAX = ABS(SX(IX))
    5    IX = IX + INCX
   10 CONTINUE
      RETURN
C
C        CODE FOR INCREMENT EQUAL TO 1
C
   20 SMAX = ABS(SX(1))
      DO 30 I = 2,N
         IF(ABS(SX(I)).LE.SMAX) GO TO 30
         ISAMAX = I
         SMAX = ABS(SX(I))
   30 CONTINUE
      RETURN
      END

C
C $Id: mdglty.f,v 1.2 2008-07-27 00:17:06 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MDGLTY (IARG)
C
        INTEGER IARG
C
C This routine may be called by a user from the line-processing routine
C specified as the final argument in a call to MDLNDM in order to obtain
C the type of the line being processed.
C
        COMMON /MAPCMZ/  NNMS,ILTY,IAIL,IAIR,BLAG,SLAG,BLOG,SLOG,
     +                   PNTS(200)
        INTEGER          NNMS,ILTY,IAIL,IAIR
        REAL             BLAG,SLAG,BLOG,SLOG,PNTS
        SAVE   /MAPCMZ/
C
        IARG=ILTY
C
        RETURN
C
      END

C NCLFORTSTART
c tst subroutine arealinint2dx (mxi,nyi,ngrd,xi,yi,zi,wxi,wyi,zimsg
c tst+                         ,mcyc,ncyc,mxo,nyo,xo,yo,zo,critpc
c tst+                         ,debug,ier)
c tst implicit none
c                                               ! INPUT
c tst integer          mxi, nyi, ngrd, mxo, nyo,
c tst+                 mcyc, ncyc, debug, ier  
c tst double precision zi(mxi,nyi,ngrd), xi(mxi), yi(nyi)
c tst double precision wxi(mxi), wyi(nyi), zimsg, critpc
c tst double precision xo(mxo) , yo(nyo)
c                                               ! OUTPUT
c tst double precision zo(mxo,nyo,ngrd)
C NCLEND
c                                               ! LOCAL
c MH: The interface should allocate.
c tst double precision xilft(mxi), xirgt(mxi), dxi(mxi)
c tst double precision yibot(nyi), yitop(nyi), dyi(nyi)
c tst double precision xolft(mxo), xorgt(mxo)
c tst double precision fracx(mxi,mxo), fracy(nyi,nyo)  
c tst double precision ziwrk(mxi,nyi), zowrk(mxo,nyo)
c tst double precision yiwrk(nyi), yowrk(nyo)
c tst integer          indx(2,mxo), indy(2,nyo)

c                  ! interface sets the following
c tst ier    = 0
c tst ncyc   = 0
c tst debug  = 0
c tst critpc = 100 ! this may change via attribi]ute

c tst do n=1,mxi
c tst    wxi(n) = 1.0d0   ! always
c tst end do

c tst                  ( if wyi is a scalar)
c tst do n=1,nyi
c tst    wyi(n) = 1.0d0
c tst end do

c tst call arealinint2da (mxi,nyi,ngrd,xi,yi,zi,wxi,wyi,zimsg
c tst+                   ,mcyc,ncyc,mxo,nyo,xo,yo,zo,critpc,debug,ier
c tst+                   ,xilft,xirgt, yibot, yitop, dyi
c tst+                   ,xolft, xorgt, yiwrk, yowrk
c tst+                   ,fracx, fracy, ziwrk, zowrk, indx, indy)

c tst return
c tst end

C NCLFORTSTART
      subroutine arealinint2da(mxi,nyi,ngrd,xi,yi,zi,wxi,wyi,zimsg
     +                        ,mcyc,ncyc,mxo,nyo,xo,yo,zo,critpc,debug
     +                        ,ier
     +                        ,xilft,xirgt, yibot, yitop, dyi
     +                        ,xolft, xorgt, yiwrk, yowrk
     +                        ,fracx, fracy, ziwrk, zowrk, indx, indy)
      implicit none
c                                               ! INPUT
      integer          mxi, nyi, ngrd, mxo, nyo,
     +                 mcyc, ncyc, debug, ier  
      double precision zi(mxi,nyi,ngrd), xi(mxi), yi(nyi)
      double precision wxi(mxi), wyi(nyi), zimsg, critpc
      double precision xo(mxo) , yo(nyo)

      double precision xilft(mxi), xirgt(mxi), dxi(mxi)
      double precision yibot(nyi), yitop(nyi), dyi(nyi)
      double precision xolft(mxo), xorgt(mxo)
      double precision fracx(mxi,mxo), fracy(nyi,nyo)  
      double precision ziwrk(mxi,nyi), zowrk(mxo,nyo)
      double precision yiwrk(nyi), yowrk(nyo)
      integer          indx(2,mxo), indy(2,nyo)
c                                               ! OUTPUT
      double precision zo(mxo,nyo,ngrd)
C NCLEND
c                                               ! LOCAL
      integer          ni, mi, ng, no, mo, kmsg, kbox,
     +                 nn, mm, niStrt, niLast, miStrt, miLast,
     +                 monoxi, monoyi, monoxo, monoyo, 
     +                 ierx, iery
      double precision sz, sw, dwf, boxpc

c The rather cumbersome code below allows users to input
c to input arrays in which the yi/yo coordinates can be 
c in arbitrary mono order: (a) Both mono {in/de}creasing,
c (b) one mono {in/de}creasing and the other {de/in}creasing.
  
      ier = 0

c just in case of early termination: initializing returned zo to msg

      do ng=1,ngrd
        do no=1,nyo
          do mo=1,mxo
             zo(mo,no,ng) = zimsg
          end do
        end do
      end do

c check to see if yi is monotonically increasing or decreasing

      monoyi = 1
      if ((yi(2)-yi(1)).lt.0.0d0) monoyi = -1
      monoyo = 1
      if ((yo(2)-yo(1)).lt.0.0d0) monoyo = -1
      
      monoxi = 1
      if ((xi(2)-xi(1)).lt.0.0d0) then
          monoxi = -1
          ier    = -2
c          print *, "code does not handle monotonically decreasing xi"
          return
      end if

      monoxo = 1
      if ((xo(2)-xo(1)).lt.0.0d0) then
          monoxo = -1
          ier    = -2
c          print *, "code does not handle monotonically decreasing xo"
          return
      end if


c define area cells: take advantage of the fact that this is
c .   regular rectilinear grid. The grid spacing may be unequal.   
c If the 'y' direction is mono decreasing then reorder

      call areacells (mxi, mxo, xi, xo, mcyc
     +               ,xilft, xirgt, dxi, fracx, indx, debug) 

c                       ! reorder or not ?               
      if (monoyi.gt.0) then
c                       ! no reorder necessary
          do ni=1,nyi
             yiwrk(ni) = yi(ni)
          end do
      else
c                       ! reorder the 'yi' to mono increasing
          do ni=1,nyi
             yiwrk(ni) = yi(nyi-ni+1)
          end do
      end if

      if (monoyo.gt.0) then
          do no=1,nyo
             yowrk(no) = yo(no)
          end do  
      else
          do no=1,nyo
             yowrk(no) = yo(nyo-no+1)
          end do
      end if
c                       ! yiwrk and yowrk are both mono increasing
      call areacells (nyi, nyo, yiwrk, yowrk, ncyc
     +               ,yibot, yitop, dyi, fracy, indy, debug) 

      if (debug.eq.1) then
          do mo=1,mxo
             print *,"indx: ",mo,indx(1,mo),indx(2,mo) 
          end do
          do no=1,nyo
             print *,"indy: ",no,indy(1,no),indy(2,no) 
          end do
      end if

c check to make sure that the output grid is lower resolution
c .   conchkres requires monotonic input
c .   Return if either the 'xo' or 'yo' is higher
c .   resolution than the input grid.

      call conchkres (xi,mxi,xo,mxo,ierx) 
      call conchkres (yiwrk,nyi,yowrk,nyo,iery) 
      if (ierx.ne.0 .or. iery.ne.0) then
          ier = -5
          return
      end if

c for each grid and  for each output point (mo,no,ng) 
c .   reverse the order if input was decreasing in 'y'

      do ng=1,ngrd
c                      ! separate sections/loops for efficiency
         if (monoyi.gt.0) then
c                      ! no reorddr necessary
             do ni=1,nyi
               do mi=1,mxi
                  ziwrk(mi,ni) = zi(mi,ni,ng)
               end do
             end do
         else
c                      ! reorder the 'yi' indices [ note:  nn ]  
             do ni=1,nyi
                nn = nyi-ni+1
               do mi=1,mxi
                  ziwrk(mi,ni) = zi(mi,nn,ng)
               end do
             end do
         end if
c                      ! initialize interpolated grid
         do no=1,nyo
           do mo=1,mxo
              zowrk(mo,no) = zimsg    
           end do
         end do
c                      ! loop over each output point
        do no=1,nyo
          do mo=1,mxo

c extract the input indices that affect the output grid values. 
c .   indx/indy are the 'pointers' to the sub-area of the 
c .   output grid.

             miStrt = indx(1,mo)
             miLast = indx(2,mo)
             niStrt = indy(1,no)
             niLast = indy(2,no)

             if (niStrt.gt.0 .and. miStrt.gt.0) then

c compute the weighted sum value for the output grid point
  
                 kbox = 0
                 kmsg = 0
                 sz   = 0.0d0
                 sw   = 0.0d0

                 do nn=niStrt,niLast
                   do mm=miStrt,miLast
                      kbox = kbox+1
c c c                 if (zi(mm,nn,ng).ne.zimsg) then
                      if (ziwrk(mm,nn).ne.zimsg) then
                          dwf= wxi(mm)*wyi(nn)*fracx(mm,mo)*fracy(nn,no) 
c c c                     sz = sz + zi(mm,nn,ng)*dwf
                          sz = sz + ziwrk(mm,nn)*dwf
                          sw = sw + dwf
                      else
                          kmsg = kmsg+1
c critpc=100.0 means all values must be present. Skip out at 1st msg value
                          if (critpc.eq.100d0) go to 10
                      end if
                   end do
                 end do
c boxpc: percent 'good' values 
                 boxpc = 100.0d0*(dble(kbox-kmsg)/dble(kbox))

c compute the weighted area value for the output grid point
c .   only if there were no msg pts.

                 if (sw.gt.0.0d0 .and. boxpc.ge.critpc ) then
c c c                zo(mo,no,ng) = sz/sw
                     zowrk(mo,no) = sz/sw
                     if (debug.eq.1 .and. ng.eq.1) then
                         print *, mo,no,zowrk(mo,no)," : ",boxpc
                     end if
                 end if
10               continue

             end if     ! if (zi(mi,ni,ng).ne.zimsg )

          end do        ! end: do mo=1,mxo
        end do          ! end: do no=1,nxo

c                       ! place in return grid: separate for efficiency      
        if (monoyo.gt.0) then
c                       ! no reorder necessary
            do no=1,nyo
              do mo=1,mxo
                 zo(mo,no,ng) = zowrk(mo,no)    
              end do
            end do
        else
c                       ! reorder the 'y'  [ note:  nn ]                
            do no=1,nyo
               nn = nyo-no+1
              do mo=1,mxo
                 zo(mo,no,ng) = zowrk(mo,nn)    
              end do
	    end do
        end if

      end do            ! end: do ng=1,ngrd

      return
      end

      subroutine areacells (nxi, nxo, xi, xo, icyc
     +                     ,xilft, xirgt, dxi, fracx, indx, debug) 
 
c This was originally written for "x" but it works for
c .   *any* mononotonically increasing 1d array
c .   lft<==>bot , rgt<==>top , dx<==>dy , fracx<==>fracy , indx<==>indy
c .   nxi<==>nyi , nxo<==>nyo

      implicit          none
      integer           nxi, nxo, icyc, debug
      double precision  xi(nxi), xilft(nxi), xirgt(nxi), dxi(nxi)
      double precision  xo(nxo), xolft(nxo), xorgt(nxo)

      integer           indx(2,nxo)
      double precision  fracx(nxi,nxo)

      integer ni, no

c left and right cell boundaries for input and output 

      do ni=2,nxi-1
         xilft(ni) = 0.5d0*(xi(ni-1)+xi(ni))
         xirgt(ni) = 0.5d0*(xi(ni+1)+xi(ni))
      end do

      do no=2,nxo-1
         xolft(no) = 0.5d0*(xo(no-1)+xo(no))
         xorgt(no) = 0.5d0*(xo(no+1)+xo(no))
      end do
c                                 left/right boundaries
      xirgt(1)   =  0.5d0*(xi(2)  +xi(1))
      xorgt(1)   =  0.5d0*(xo(2)  +xo(1))
      xilft(nxi) =  0.5d0*(xi(nxi)+xi(nxi-1))
      xolft(nxo) =  0.5d0*(xo(nxo)+xo(nxo-1))

c non-periodic [icyc=0] or periodic [icyc=1]  left/right boundaries

      if (icyc.eq.0) then
c                                 half width ends
          xilft(1)   = xi(1)
          xolft(1)   = xo(1)
          xirgt(nxi) = xi(nxi)
          xorgt(nxo) = xo(nxo)
      else
c                                      full width ends
          xilft(1)   = xi(1)   - 0.5d0*(xi(2)-xi(1))
          xolft(1)   = xo(1)   - 0.5d0*(xo(2)-xo(1))
          xirgt(nxi) = xi(nxi) + 0.5d0*(xi(nxi)-xi(nxi-1))
          xorgt(nxo) = xo(nxo) + 0.5d0*(xo(nxo)-xo(nxo-1))
      end if
c                                nominal (full width) dx
      do ni=1,nxi
         dxi(ni) = xirgt(ni)-xilft(ni)
      end do

c for each output point: 
c .   find portion of xi cell boundaries 
c .   within each output [xo] cell boundary
c
      do no=1,nxo
         indx(1,no) = 0     
         indx(2,no) = 0     

c Find all xi points between the xo cell coundaries 
c NCL would use the "ind" function for the "i-1,nxi" loop
c .   isave = ind(xi.ge.xolft(n) .and. xi.le.xorgt(n))
c f90 could use the "where" construct

         do ni=1,nxi
            fracx(ni,no)  = 0.0d0

c skip if outside cell boundaries: xi < xolft   xi > xorgt
c .         xi < xolft   go to next iteration
c .         xi > xorgt   go to next output point

            if (xi(ni).lt. xolft(no)) go to 10       
            if (xi(ni).gt. xorgt(no)) go to 20   

c xi must be within xo cell boundaries:  xolft <= xi  <= xorgt      

            if (xilft(ni).ge.xolft(no) .and. xirgt(ni).le.xorgt(no))then

c xi cell boundaries totally  within xo cell boundaries
c               xolft     [xilft    xi     xirgt]     xorgt 
c                         [-------  dx  --------]     xorgt 

                fracx(ni,no) = 1.0d0

            elseif(xilft(ni).lt.xolft(no) .and. 
     +             xirgt(ni).ge.xolft(no) .and. 
     +             xi(ni).ge.xolft(no)  ) then

c                                       xolft     xi        xorgt 
c left cell boundary overlap:    xilft              xirgt      
c                                       [---- dx------]

                fracx(ni,no) = (xirgt(ni)-xolft(no))/dxi(ni)

            elseif(xirgt(ni).gt.xorgt(no) .and. 
     +             xilft(ni).lt.xorgt(no) .and.  
     +             xi(ni).le.xorgt(no)   ) then
 
c                                      xolft       xi      xorgt 
c right cell boundary overlap:              xilft               xirgt
c                                             [------ dx -------]

                fracx(ni,no) = (xorgt(no)-xilft(ni))/dxi(ni)
            end if

c for efficiency when computing the values, 
c .    save the 'start' and 'end' subscripts

            if (indx(1,no).eq.0) indx(1,no) = ni
            indx(2,no) = ni

   10       continue               ! if (xi(ni).lt. xolft(no)) go to 10       
            end do                 ! end "ni"

   20    continue                  ! if (xi(ni).gt. xorgt(no)) go to 20   
         end do                    ! end "no"

      return
      end


      subroutine conchkres (zi,nzi,zo,nzo,ier)
      implicit none
      integer  nzi, nzo, ier
      double precision zi(nzi), zo(nzo)

      integer  n
      double precision dzimin, dzomin

      ier = 0

      dzimin = 1d20 
      do n=2,nzi
         if (abs(zi(n)-zi(n-1)) .lt. dzimin) dzimin = abs(zi(n)-zi(n-1))
      end do

      dzomin = 1d20 
      do n=2,nzo
         if (abs(zo(n)-zo(n-1)) .lt. dzomin) dzomin = abs(zo(n)-zo(n-1))
      end do

      if (dzomin.lt.dzimin) ier = 5

      return
      end

      PROGRAM CCPPC1
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER (LRWK=3500,LIWK=4000,LMAP=75000)
      PARAMETER (MREG=50,NREG=50)
      REAL X(MREG),Y(NREG),ZREG(MREG,NREG), RWRK(LRWK)
      INTEGER IWRK(LIWK), MAP(LMAP)

      EXTERNAL CPDRPL

      CALL GETDAT (X, Y, ZREG, MREG, NREG, RWRK, IWRK, LRWK, LIWK)
C
C Open GKS
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Initialize Areas
C
      CALL ARINAM(MAP,LMAP)
C
C Choose which labelling scheme will be used.
C
      CALL CPSETI('LLP - LINE LABEL POSITIONING FLAG',3)
C
C Set the gradient parameter to label steep slopes
C
      CALL CPSETR('PC1 - PENALTY SCHEME CONSTANT 1',3.0)
C
C Initialize Conpack
C
      CALL CPRECT(ZREG, MREG, MREG, NREG, RWRK, LRWK, IWRK, LIWK)
C
C Force Conpack to chose contour levels
C
      CALL CPPKCL(ZREG, RWRK, IWRK)
C
C Modify Conpack chosen parameters
C
      CALL CPGETI('NCL - NUMBER OF CONTOUR LEVELS',NCONS)
      DO 12, I=1,NCONS
         CALL CPSETI('PAI - PARAMETER ARRAY INDEX',I)
C
C Force every line to be labeled.
C
         CALL CPSETI('CLU - CONTOUR LEVEL USE FLAG',3)
 12   CONTINUE
C
C Add contours to area map
C
      CALL CPCLAM(ZREG, RWRK, IWRK, MAP)
C
C Add labels to area map
C
      CALL CPLBAM(ZREG, RWRK, IWRK, MAP)
C
C Draw Perimeter
C
      CALL CPBACK(ZREG, RWRK, IWRK)
C
C Draw Labels
C
      CALL CPLBDR(ZREG,RWRK,IWRK)
C
C Draw Contours
C
      CALL CPCLDM(ZREG,RWRK,IWRK,MAP,CPDRPL)
C
C Close frame and close GKS
C
      CALL FRAME
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS

      STOP
      END

      SUBROUTINE GETDAT (X,Y,Z,M,N,RWRK,IWRK,LRWK,LIWK)

      PARAMETER (NRAN=30)

      REAL XRAN(NRAN), YRAN(NRAN), ZRAN(NRAN)
      REAL X(M), Y(N), Z(M,N), RWRK(LRWK)
      REAL XDELTA(50)
      INTEGER IWRK(LIWK)

      DATA XRAN /12., 60., 14., 33.,  8., 12., 43., 57., 22., 15.,
     +         19., 12., 64., 19., 15., 55., 31., 32., 33., 29.,
     +         18.,  1., 18., 42., 56.,  9.,  6., 12., 44., 19./
      DATA YRAN / 1.,  2.,  3., 53.,  7., 11., 13., 17., 19., 49.,
     +          1., 31., 37.,  5.,  7., 47., 61., 17.,  5., 23.,
     +         29.,  3.,  5., 41., 43.,  9., 13., 59.,  1., 67./
      DATA ZRAN /1.0, 1.5, 1.7, 1.4, 1.9, 1.0, 1.5, 1.2, 1.8, 1.4,
     +         1.8, 1.7, 1.9, 1.5, 1.2, 1.1, 1.3, 1.7, 1.2, 1.6,
     +         1.9, 1.0, 1.6, 1.3, 1.4, 1.8, 1.7, 1.5, 1.1, 1.0/
      DATA XDELTA/.00,.02,.04,.06,.08,.10,.12,.14,.16,.18,.20,
     +            .22,.24,.26,.28,.30,.32,.34,.36,.38,.40,.42,
     +            .44,.46,.48,.50,.52,.54,.56,.58,.60,.62,.64,
     +            .66,.68,.70,.72,.74,.76,.78,.80,.82,.84,.86,
     +            .88,.90,.92,.94,.96,.98/
C
C  Set the min and max data values.
C
      XMIN = 0.0
      XMAX = 65.0
      YMIN =  0.0
      YMAX = 68.0
C
C Choose the X and Y coordinates for interpolation points on the 
C regular grid.
C
      DO 101 I=1,M
         X(I)=XMIN + (XMAX - XMIN)*XDELTA(I)
 101  CONTINUE
C
      DO 102 I=1,N
         Y(I)=YMIN + (YMAX - YMIN)*XDELTA(I)
 102  CONTINUE
C
C Interpolate data onto a regular grid
C
      CALL IDSFFT (1,NRAN,XRAN,YRAN,ZRAN,M,N,M,X,Y,Z,IWRK,RWRK)
      
      RETURN
      END

c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by UCAR                 .
c  .                                                             .
c  .       University Corporation for Atmospheric Research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                         SPHEREPACK                          .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c
c
c ... file gradges.f
c
c     this file includes documentation and code for
c     subroutine grades         i
c
c ... files which must be loaded with gradges.f
c
c     sphcom.f, hrfft.f, shaes.f,vhses.f
c
c     subroutine grades(nlat,nlon,isym,nt,v,w,idvw,jdvw,a,b,mdab,ndab,
c    +                  wvhses,lvhses,work,lwork,ierror)
c
C*PL*ERROR* Comment line too long
c     given the scalar spherical harmonic coefficients a and b, precomputed
C*PL*ERROR* Comment line too long
c     by subroutine shaes for a scalar field sf, subroutine grades computes
c     an irrotational vector field (v,w) such that
c
c           gradient(sf) = (v,w).
c
c     v is the colatitudinal and w is the east longitudinal component
c     of the gradient.  i.e.,
c
c            v(i,j) = d(sf(i,j))/dtheta
c
c     and
c
c            w(i,j) = 1/sint*d(sf(i,j))/dlambda
c
c     at colatitude
c
c            theta(i) = (i-1)*pi/(nlat-1)
c
c     and longitude
c
c            lambda(j) = (j-1)*2*pi/nlon.
c
C*PL*ERROR* Comment line too long
c     where sint = sin(theta(i)).  required associated legendre polynomials
c     are stored rather than recomputed as they are in subroutine gradec
c
c
c     input parameters
c
c
c     nlat   the number of colatitudes on the full sphere including the
c            poles. for example, nlat = 37 for a five degree grid.
c            nlat determines the grid increment in colatitude as
c            pi/(nlat-1).  if nlat is odd the equator is located at
c            grid point i=(nlat+1)/2. if nlat is even the equator is
c            located half way between points i=nlat/2 and i=nlat/2+1.
c            nlat must be at least 3. note: on the half sphere, the
c            number of grid points in the colatitudinal direction is
c            nlat/2 if nlat is even or (nlat+1)/2 if nlat is odd.
c
c     nlon   the number of distinct londitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater than
c            3.  the efficiency of the computation is improved when nlon
c            is a product of small prime numbers.
c
c
c     isym   this has the same value as the isym that was input to
c            subroutine shaes to compute the arrays a and b from the
c            scalar field sf.  isym determines whether (v,w) are
c            computed on the full or half sphere as follows:
c
c      = 0
c
c           sf is not symmetric about the equator. in this case
c           the vector field (v,w) is computed on the entire sphere.
c           i.e., in the arrays  v(i,j),w(i,j) for i=1,...,nlat and
c           j=1,...,nlon.
c
c      = 1
c
c           sf is antisymmetric about the equator. in this case w is
c           antisymmetric and v is symmetric about the equator. w
c           and v are computed on the northern hemisphere only.  i.e.,
c           if nlat is odd they are computed for i=1,...,(nlat+1)/2
c           and j=1,...,nlon.  if nlat is even they are computed for
c           i=1,...,nlat/2 and j=1,...,nlon.
c
c      = 2
c
c           sf is symmetric about the equator. in this case w is
c           symmetric and v is antisymmetric about the equator. w
c           and v are computed on the northern hemisphere only.  i.e.,
c           if nlat is odd they are computed for i=1,...,(nlat+1)/2
c           and j=1,...,nlon.  if nlat is even they are computed for
c           i=1,...,nlat/2 and j=1,...,nlon.
c
c
c     nt     nt is the number of scalar and vector fields.  some
c            computational efficiency is obtained for multiple fields.
C*PL*ERROR* Comment line too long
c            the arrays a,b,v, and w can be three dimensional corresponding
c            to an indexed multiple array sf.  in this case, multiple
c            vector synthesis will be performed to compute each vector
c            field.  the third index for a,b,v, and w is the synthesis
c            index which assumes the values k = 1,...,nt.  for a single
c            synthesis set nt = 1.  the description of the remaining
C*PL*ERROR* Comment line too long
c            parameters is simplified by assuming that nt=1 or that a,b,v,
c            and w are two dimensional arrays.
c
c     idvw   the first dimension of the arrays v,w as it appears in
c            the program that calls grades. if isym = 0 then idvw
c            must be at least nlat.  if isym = 1 or 2 and nlat is
c            even then idvw must be at least nlat/2. if isym = 1 or 2
c            and nlat is odd then idvw must be at least (nlat+1)/2.
c
c     jdvw   the second dimension of the arrays v,w as it appears in
c            the program that calls grades. jdvw must be at least nlon.
c
c     a,b    two or three dimensional arrays (see input parameter nt)
c            that contain scalar spherical harmonic coefficients
C*PL*ERROR* Comment line too long
c            of the scalar field array sf as computed by subroutine shaes.
c     ***    a,b must be computed by shaes prior to calling grades.
c
c     mdab   the first dimension of the arrays a and b as it appears in
c            the program that calls grades (and shaes). mdab must be at
c            least min0(nlat,(nlon+2)/2) if nlon is even or at least
c            min0(nlat,(nlon+1)/2) if nlon is odd.
c
c     ndab   the second dimension of the arrays a and b as it appears in
c            the program that calls grades (and shaes). ndab must be at
c            least nlat.
c
c
c   wvhses   an array which must be initialized by subroutine gradesi
c            (or equivalently by subroutine vhsesi).  once initialized,
c            wsav can be used repeatedly by grades as long as nlon
c            and nlat remain unchanged.  wvhses must not be altered
c            between calls of grades.
c
c
c  lvhses    the dimension of the array wvhses as it appears in the
c            program that calls grades. define
c
c               l1 = min0(nlat,nlon/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd.
c
c            then lvhses must be greater than or equal to
c
c               (l1*l2*(nlat+nlat-l1+1))/2+nlon+15
c
c     work   a work array that does not have to be saved.
c
c     lwork  the dimension of the array work as it appears in the
c            program that calls grades. define
c
c               l1 = min0(nlat,nlon/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2                  if nlat is even or
c               l2 = (nlat+1)/2              if nlat is odd
c
c            if isym = 0, lwork must be greater than or equal to
c
c               nlat*((2*nt+1)*nlon+2*l1*nt+1).
c
c            if isym = 1 or 2, lwork must be greater than or equal to
c
c               (2*nt+1)*l2*nlon+nlat*(2*l1*nt+1).
c
c
c     **************************************************************
c
c     output parameters
c
c
C*PL*ERROR* Comment line too long
c     v,w   two or three dimensional arrays (see input parameter nt) that
C*PL*ERROR* Comment line too long
c           contain an irrotational vector field such that the gradient of
c           the scalar field sf is (v,w).  w(i,j) is the east longitude
C*PL*ERROR* Comment line too long
c           component and v(i,j) is the colatitudinal component of velocity
c           at colatitude theta(i) = (i-1)*pi/(nlat-1) and longitude
C*PL*ERROR* Comment line too long
c           lambda(j) = (j-1)*2*pi/nlon. the indices for v and w are defined
C*PL*ERROR* Comment line too long
c           at the input parameter isym.  the vorticity of (v,w) is zero.
c           note that any nonzero vector field on the sphere will be
c           multiple valued at the poles [reference swarztrauber].
c
c
c  ierror   = 0  no errors
c           = 1  error in the specification of nlat
c           = 2  error in the specification of nlon
c           = 3  error in the specification of isym
c           = 4  error in the specification of nt
c           = 5  error in the specification of idvw
c           = 6  error in the specification of jdvw
c           = 7  error in the specification of mdab
c           = 8  error in the specification of ndab
c           = 9  error in the specification of lvhses
c           = 10 error in the specification of lwork
c **********************************************************************
c
c
      SUBROUTINE DGRADES(NLAT,NLON,ISYM,NT,V,W,IDVW,JDVW,A,B,MDAB,NDAB,
     +                  WVHSES,LVHSES,WORK,LWORK,IERROR)
      DOUBLE PRECISION V
      DOUBLE PRECISION W
      DOUBLE PRECISION A
      DOUBLE PRECISION B
      DOUBLE PRECISION WVHSES
      DOUBLE PRECISION WORK
      DIMENSION V(IDVW,JDVW,NT),W(IDVW,JDVW,NT)
      DIMENSION A(MDAB,NDAB,NT),B(MDAB,NDAB,NT)
      DIMENSION WVHSES(LVHSES),WORK(LWORK)
c
c     check input parameters
c
      IERROR = 1
      IF (NLAT.LT.3) RETURN
      IERROR = 2
      IF (NLON.LT.4) RETURN
      IERROR = 3
      IF (ISYM.LT.0 .OR. ISYM.GT.2) RETURN
      IERROR = 4
      IF (NT.LT.0) RETURN
      IERROR = 5
      IMID = (NLAT+1)/2
      IF ((ISYM.EQ.0.AND.IDVW.LT.NLAT) .OR.
     +    (ISYM.NE.0.AND.IDVW.LT.IMID)) RETURN
      IERROR = 6
      IF (JDVW.LT.NLON) RETURN
      IERROR = 7
      MMAX = MIN0(NLAT, (NLON+1)/2)
      IF (MDAB.LT.MIN0(NLAT, (NLON+2)/2)) RETURN
      IERROR = 8
      IF (NDAB.LT.NLAT) RETURN
      IERROR = 9
c
c     verify minimum saved work space length
c
      IDZ = (MMAX* (NLAT+NLAT-MMAX+1))/2
      LZIMN = IDZ*IMID
      LGDMIN = LZIMN + LZIMN + NLON + 15
      IF (LVHSES.LT.LGDMIN) RETURN
      IERROR = 10
c
c     verify minimum unsaved work space length
c
      MN = MMAX*NLAT*NT
      IDV = NLAT
      IF (ISYM.NE.0) IDV = IMID
      LNL = NT*IDV*NLON
      LWKMIN = LNL + LNL + IDV*NLON + 2*MN + NLAT
      IF (LWORK.LT.LWKMIN) RETURN
      IERROR = 0
c
c     set work space pointers
c
      IBR = 1
      IBI = IBR + MN
      IS = IBI + MN
      IWK = IS + NLAT
      LIWK = LWORK - 2*MN - NLAT
      CALL DGRADES1(NLAT,NLON,ISYM,NT,V,W,IDVW,JDVW,WORK(IBR),WORK(IBI),
     +             MMAX,WORK(IS),MDAB,NDAB,A,B,WVHSES,LVHSES,WORK(IWK),
     +             LIWK,IERROR)
      RETURN
      END

      SUBROUTINE DGRADES1(NLAT,NLON,ISYM,NT,V,W,IDVW,JDVW,BR,BI,MMAX,
     +                   SQNN,MDAB,NDAB,A,B,WVHSES,LVHSES,WK,LWK,IERROR)
      DOUBLE PRECISION V
      DOUBLE PRECISION W
      DOUBLE PRECISION BR
      DOUBLE PRECISION BI
      DOUBLE PRECISION SQNN
      DOUBLE PRECISION A
      DOUBLE PRECISION B
      DOUBLE PRECISION WVHSES
      DOUBLE PRECISION WK
      DOUBLE PRECISION FN
      DOUBLE PRECISION CR
      DOUBLE PRECISION CI
      DIMENSION V(IDVW,JDVW,NT),W(IDVW,JDVW,NT)
      DIMENSION BR(MMAX,NLAT,NT),BI(MMAX,NLAT,NT),SQNN(NLAT)
      DIMENSION A(MDAB,NDAB,NT),B(MDAB,NDAB,NT)
      DIMENSION WVHSES(LVHSES),WK(LWK)
c
c     preset coefficient multiplyers in vector
c
      DO 1 N = 2,NLAT
          FN = DBLE(N-1)
          SQNN(N) = SQRT(FN* (FN+1.D0))
    1 CONTINUE
c
c     compute multiple vector fields coefficients
c
      DO 2 K = 1,NT
c
c     preset br,bi to 0.0
c
          DO 3 N = 1,NLAT
              DO 4 M = 1,MMAX
                  BR(M,N,K) = 0.0D0
                  BI(M,N,K) = 0.0D0
    4         CONTINUE
    3     CONTINUE
c
c     compute m=0 coefficients
c
          DO 5 N = 2,NLAT
              BR(1,N,K) = SQNN(N)*A(1,N,K)
              BI(1,N,K) = SQNN(N)*B(1,N,K)
    5     CONTINUE
c
c     compute m>0 coefficients
c
          DO 6 M = 2,MMAX
              DO 7 N = M,NLAT
                  BR(M,N,K) = SQNN(N)*A(M,N,K)
                  BI(M,N,K) = SQNN(N)*B(M,N,K)
    7         CONTINUE
    6     CONTINUE
    2 CONTINUE
c
c     set ityp for irrotational vector synthesis to compute gradient
c
      IF (ISYM.EQ.0) THEN
          ITYP = 1
      ELSE IF (ISYM.EQ.1) THEN
          ITYP = 4
      ELSE IF (ISYM.EQ.2) THEN
          ITYP = 7
      END IF
c
c     vector sythesize br,bi into (v,w) (cr,ci are dummy variables)
c
      CALL DVHSES(NLAT,NLON,ITYP,NT,V,W,IDVW,JDVW,BR,BI,CR,CI,MMAX,NLAT,
     +           WVHSES,LVHSES,WK,LWK,IERROR)
      RETURN
      END

C
C $Id: seter.f,v 1.8 2008-07-27 00:17:31 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE SETER (MESSG,NERRF,IROPT)
C
        CHARACTER*(*) MESSG
C
C This routine is called when an error occurs.  The arguments specify
C an error message, an error number, and an option indicating whether
C the error is recoverable or fatal.  Exactly how the error is handled
C depends not only on the values of these arguments, but also on the
C values of internal variables specifying whether recovery mode is in
C effect and whether a previous error has occurred and not yet been
C recovered from and cleared.
C
C If no uncleared recoverable error has occurred and there are no
C errors in the arguments, then the following apply:
C
C   IROPT = 1, recovery mode active      -  just remember the error.
C   IROPT = 1, recovery mode not active  -  print and stop.
C   IROPT = 2                            -  print, dump, and stop.
C
C Input:
C
C   MESSG  - the error message (113 characters maximum).  The error
C            message should contain the name of the routine in which
C            the error occurred, followed by a blank, then a hyphen
C            (minus sign), then another blank, and then a short
C            description of the error.
C   NERRF  - the error number - must be non-zero.
C   IROPT  - the option - must have IROPT = 1 or 2.
C
C Error states:
C
C   1 - message length not positive.
C   2 - NERRF equal to 0.
C   3 - an unrecovered error followed by another error.
C   4 - bad value for IROPT (less than 1 or greater than 2).
C
C The common blocks SECOMI and SECOMC are used to hold shared variables
C of types INTEGER and CHARACTER, respectively, for the routine SETER
C and associated routines.  For descriptions of these variables and for
C default values of them, see the block data routine SEBLDA.
C
        COMMON /SECOMI/ IERRU,IERRF,IRECF,LOMSG
        SAVE   /SECOMI/
C
        COMMON /SECOMC/ ERMSG
          CHARACTER*256 ERMSG
        SAVE   /SECOMC/
C
C Do a call forcing a BLOCKDATA to be loaded from a binary library.
C
        CALL SEBLDA
C
C The unit number for error messages is I1MACH(4).  Save that value,
C if it has not already been done.
C
        IF (IERRU.EQ.0) IERRU=I1MACH(4)
C
C Check for various error conditions.  The low-order bits of IERRC
C are used to keep track of which such errors have occurred.
C
        IERRC=0
C
C Check for a message of length zero or less.
C
        IF (LEN(MESSG).LE.0) THEN
          IERRC=IERRC+1
          WRITE (IERRU,1001)
        END IF
C
C Check for NERRF = 0.
C
        IF (NERRF.EQ.0) THEN
          IERRC=IERRC+2
          WRITE (IERRU,1002)
        END IF
C
C Check for a previous unrecovered error.
C
        IF (IERRF.NE.0) THEN
          IERRC=IERRC+4
          WRITE (IERRU,1003)
        END IF
C
C Check for an illegal value of the recovery flag.
C
        IF (IROPT.NE.1.AND.IROPT.NE.2) THEN
          IERRC=IERRC+8
          WRITE (IERRU,1004)
        END IF
C
C If one of the error conditions applies, print the appropriate
C information and quit.
C
        IF (IERRC.NE.0) THEN
          IF (MOD(IERRC/4,2).NE.0) THEN
            WRITE (IERRU,1005) IERRF,ERMSG(1:LOMSG)
          END IF
          IF (MOD(IERRC,2).EQ.0) THEN
            WRITE (IERRU,1006) NERRF,MESSG(1:ICLOEM(MESSG))
          END IF
          CALL FDUM
          STOP
        END IF
C
C Save the error message and error number.
C
        IERRF=NERRF
        ERMSG=MESSG
        LOMSG=ICLOEM(ERMSG)
C
C If recovery mode is activated and the error is recoverable, return
C to the caller for recovery action.
C
        IF (IRECF.EQ.1.AND.IROPT.EQ.1) RETURN
C
C Otherwise, print the error message.
C
        WRITE (IERRU,1007) IERRF,ERMSG(1:LOMSG)
C
C If the error is fatal, call the dump routine.
C
        IF (IROPT.EQ.2) CALL FDUM
C
C Quit.
C
        STOP
C
C Formats used above.
C
 1001 FORMAT (' ERROR    1 IN SETER - MESSAGE LENGTH IS NOT POSITIVE')
 1002 FORMAT (' ERROR    2 IN SETER - ILLEGAL VALUE FOR ERROR NUMBER')
 1003 FORMAT (' ERROR    3 IN SETER - AN UNCLEARED PRIOR ERROR EXISTS')
 1004 FORMAT (' ERROR    4 IN SETER - ILLEGAL VALUE FOR RECOVERY FLAG')
 1005 FORMAT (' ... MESSAGE FOR UNCLEARED PRIOR ERROR IS AS FOLLOWS:'/
     +        ' ... ERROR ',I4,' IN ',A)
 1006 FORMAT (' ... MESSAGE FOR CURRENT CALL TO SETER IS AS FOLLOWS:'/
     +        ' ... ERROR ',I4,' IN ',A)
 1007 FORMAT (' ERROR ',I4,' IN ',A)
C
      END

C
C $Id: fl2int.f,v 1.7 2008-07-27 00:17:24 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE FL2INT (PX,PY,IX,IY)
C
C Given the user coordinates PX and PY of a point, FL2INT returns the
C metacode coordinates IX and IY of that point.
C
C Declare the common block containing the user state variables LL, MI,
C MX, and MY.
C
      COMMON /IUTLCM/ LL,MI,MX,MY,IU(96)
      SAVE /IUTLCM/
C
C Declare arrays in which to retrieve the variables defining the current
C window and viewport.
C
      DIMENSION WD(4),VP(4)
C
C Get the variables defining the current window and viewport.
C
      CALL GQCNTN (IE,NT)
      IF (IE.NE.0) THEN
        CALL SETER ('FL2INT - ERROR EXIT FROM GQCNTN',1,1)
        RETURN
      END IF
      CALL GQNT (NT,IE,WD,VP)
      IF (IE.NE.0) THEN
        CALL SETER ('FL2INT - ERROR EXIT FROM GQNT',2,1)
        RETURN
      END IF
C
C Compute IX.
C
      I=1
      IF (MI.GE.3) I=2
      IF (LL.LE.2) THEN
        IX=INT(((PX-WD(I))/(WD(3-I)-WD(I))*(VP(2)-VP(1))+VP(1))*32767.)
      ELSE
        IX=INT(((ALOG10(PX)-WD(I))/(WD(3-I)-WD(I))*
     +                             (VP(2)-VP(1))+VP(1))*32767.)
      ENDIF
C
C Compute IY.
C
      I=3
      IF (MI.EQ.2.OR.MI.GE.4) I=4
      IF (LL.LE.1.OR.LL.EQ.3) THEN
        IY=INT(((PY-WD(I))/(WD(7-I)-WD(I))*(VP(4)-VP(3))+VP(3))*32767.)
      ELSE
        IY=INT(((ALOG10(PY)-WD(I))/(WD(7-I)-WD(I))*
     +                             (VP(4)-VP(3))+VP(3))*32767.)
      ENDIF
C
C Done.
C
      RETURN
C
      END

C
C	$Id: g01snp.f,v 1.10 2008-07-27 00:21:06 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE G01SNP (ERROR)
C
C  Start new picture.
C
      INTEGER ERROR
      INTEGER  G01PBL, HOLD(3), NBYTES, ITMP(4)
C
      include 'g01prm.h'
      include 'g01io.h'
      include 'g01opc.h'
      include 'g01ins.h'
      include 'g01wsl.h'
      include 'gksenu.h'
C
C  Set 'NEW FRAME' flag.
C
      MNFFLG = GYES
C
C  Put out 'BEGIN PICTURE' element using the picture name in MPNAME.
C
      CALL GPUTNI (CLBEGP, IDBEGP, G01PBL(60,0), ERROR)
      CALL GPUTPS (MPNAME(1:60), 60, 60, 0, ERROR)
C
C  Reset picture name to blank.
C
      MPNAME = ' '
      IF (ERROR.NE.0)  GO TO 77
C
C  Put out the PICTURE DESCRIPTOR.
C
C  Put out background color, conditionally depending upon
C  whether it has been explicitly changed.
C
      IF (MBCCHG .EQ. GYES)  THEN
         NBYTES = 1 + (3*MDCCFW-1)/8
         CALL GPUTNI (CLBKGC, IDBKGC, NBYTES, ERROR)
         HOLD(1) = SRED(1)*MDCCRG
         HOLD(2) = SGREEN(1)*MDCCRG
         HOLD(3) = SBLUE(1)*MDCCRG
         CALL GPUTPR (HOLD, MDCCFW, 3, ERROR)
         IF (ERROR.NE.0)  GOTO 77
      ENDIF
C
C  Put out 'BEGIN PICTURE BODY' element.
C
      CALL GPUTNI (CLBGPB, IDBGPB, 0, ERROR)
      IF (ERROR.NE.0)  GO TO 77
C
 77   CONTINUE
C
C  Put out the clipping indicator and rectangle.
C
       CALL G01CLP(1)
C
C  Send the color table.
C
      NBYTES = 1 + (3*MDCCFW + MCIXFW - 1)/8
      DO 10 I=1,MOL
C
C  Put out opcode (CLASS and ID) and length.
C
        CALL GPUTNI (CLCTBL, IDCTBL, NBYTES, ERROR)
        IF (ERROR.NE.0)  GO TO 77
C
C  Put out parameter index (DATA, PRECIS, COUNT)
C
        CALL GPUTPR (MCOLI(I), MCIXFW, 1, ERROR)
        IF (ERROR.NE.0)  GO TO 77
C
C  Put out the color components.
C
        ITMP(1) = SRED(I)*REAL(MDCCRG)
        ITMP(2) = SGREEN(I)*REAL(MDCCRG)
        ITMP(3) = SBLUE(I)*REAL(MDCCRG)
        CALL GPUTPR (ITMP, MDCCFW, 3, ERROR)
   10 CONTINUE
C
C  Set the flag indicating that the new picture information
C  has been put out.  This is to inform G01CLP to issue its
C  clipping information if G01SNP has been called.
C
      NPFLG = 1
C
      RETURN
      END

C
C $Id: HLUF.f,v 1.1 2002-02-22 18:12:38 haley Exp $
C
C****************************************************************
C                                                               *
C                       Copyright (C)  1994                     *
C       University Corporation for Atmospheric Research         *
C                       All Rights Reserved                     *
C                                                               *
C****************************************************************
C
C      File:            HLU.f
C
C      Author:          Jeff W. Boote
C                       National Center for Atmospheric Research
C                       PO 3000, Boulder, Colorado
C
C      Date:            Fri Mar 25 10:56:58 MST 1994
C
C      Description:     This file contains all the "general" hlu
C                       subroutines to support the fortran interface
C                       to the hlu library.
C
C
C       In Open.c
C
      subroutine nhlfopen
        call nhlpfopen
      end
C
      subroutine nhlfinitialize
        call nhlpfinitialize
      end
C
C       In Close.c
C
      subroutine nhlfclose
      call nhlpfclose
      end
C
C       In Create.c
C
      subroutine nhlfcreate (id_obj,name,cfunc,id_parent,id_rl,err_ret)
        integer id_obj,id_parent,id_rl,err_ret
        character*(*) name
        external cfunc
        call nhlpfcreate(id_obj,name,cfunc,id_parent,id_rl,len(name),
     %                                                  err_ret)
      end
C
C       SetValues.c
C
      subroutine nhlfsetvalues (id_obj,id_rl,err_ret)
        integer id_obj, id_rl, err_ret
        call nhlpfsetvalues(id_obj,id_rl,err_ret)
      end
C
C       GetValues.c
C
      subroutine nhlfgetvalues (id_obj,id_rl,err_ret)
        integer id_obj, id_rl, err_ret
        call nhlpfgetvalues(id_obj,id_rl,err_ret)
      end
C
C       Draw.c
C
      subroutine nhlfdraw (id_obj,err_ret)
        integer id_obj,err_ret
        call nhlpfdraw(id_obj,err_ret)
      end
C
C       Destroy.c
C
      subroutine nhlfdestroy (id_obj,err_ret)
        integer id_obj,err_ret
        call nhlpfdestroy(id_obj,err_ret)
      end
C
C       hlu.c
C
      subroutine nhlfname(id_obj,name_ret,ierr)
        integer id_obj,ierr
        character*(*) name_ret
        call nhlpfname(id_obj,name_ret,len(name_ret),ierr)
      end
C
C       hlu.c
C
      subroutine nhlfclassname(id_obj,name_ret,ierr)
        integer id_obj,ierr
        character*(*) name_ret
        call nhlpfclassname(id_obj,name_ret,len(name_ret),ierr)
      end
C
C       Reparent.c
C
      subroutine nhlfchangeworkstation(id_plot,id_work,ierr)
        call nhlfpchangeworkstation(id_plot,id_work,ierr)
      end

      subroutine srotg(sa,sb,c,s)
c
c     construct givens plane rotation.
c     jack dongarra, linpack, 3/11/78.
c
      real sa,sb,c,s,roe,scale,r,z
c
      roe = sb
      if( abs(sa) .gt. abs(sb) ) roe = sa
      scale = abs(sa) + abs(sb)
      if( scale .ne. 0.0 ) go to 10
         c = 1.0
         s = 0.0
         r = 0.0
         z = 0.0
         go to 20
   10 r = scale*sqrt((sa/scale)**2 + (sb/scale)**2)
      r = sign(1.0,roe)*r
      c = sa/r
      s = sb/r
      z = 1.0
      if( abs(sa) .gt. abs(sb) ) z = s
      if( abs(sb) .ge. abs(sa) .and. c .ne. 0.0 ) z = 1.0/c
   20 sa = r
      sb = z
      return
      end

C
C $Id: RLGEN.f,v 1.3 1997-05-05 21:45:19 boote Exp $
C
C************************************************************************
C                                                                       *
C                            Copyright (C)  1994                        *
C                 University Corporation for Atmospheric Research       *
C                            All Rights Reserved                        *
C                                                                       *
C************************************************************************
C
C      File:            RLGEN.f
C
C      Author:          Jeff W. Boote
C                       National Center for Atmospheric Research
C                       PO 3000, Boulder, Colorado
C
C      Date:            Thu Mar 24 15:58:56 MST 1994
C
C      Description:     This file contains the "generic" list functions
C                       needed for the Fortran programmer to manage
C                       ResLists.
C
C
C       Fortran.c
C
      subroutine nhlfrlcreate (listid,ltype)
        integer listid
        character*(*) ltype
        call nhlpfrlcreate(listid,ltype,len(ltype))
      end
      subroutine nhlfrldestroy (id)
        call nhlpfrldestroy (id)
      end
      subroutine nhlfrlclear (id)
        call nhlpfrlclear (id)
      end
      subroutine nhlfrlunset (id,name)
        character*(*) name
        call nhlpfrlunset (id,name,len(name))
      end
      subroutine nhlfrlisset (id,name,ival)
        character*(*) name
        call nhlpfrlisset (id,name,len(name),ival)
      end

C
C	$Id: condet.f,v 1.4 2008-07-27 00:16:56 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CONDET (NDP,XD,YD,NCP,IPC)
C
C******************************************************************
C*                                                                *
C*   THIS FILE IS A PACKAGE OF SUPPORT ROUTINES FOR THE ULIB      *
C*   FILES CONRAN , CONRAQ AND CONRAS.  SEE THOSE FILES FOR AN    *
C*   EXPLAINATION OF THE ENTRY POINTS.                            *
C*                                                                *
C******************************************************************
C
C THIS SUBROUTINE SELECTS SEVERAL DATA POINTS THAT ARE CLOSEST
C TO EACH OF THE DATA POINT.
C THE INPUT PARAMETERS ARE
C     NDP = NUMBER OF DATA POINTS,
C     XD,YD = ARRAYS CONTAINING THE X AND Y COORDINATES
C             OF DATA POINTS,
C     NCP = NUMBER OF DATA POINTS CLOSEST TO EACH DATA
C           POINTS.
C THE OUTPUT PARAMETER IS
C     IPC = INTEGER ARRAY OF DIMENSION NCP*NDP, WHERE THE
C           POINT NUMBERS OF NCP DATA POINTS CLOSEST TO
C           EACH OF THE NDP DATA POINTS ARE TO BE STORED.
C THIS SUBROUTINE ARBITRARILY SETS A RESTRICTION THAT NCP MUST
C NOT EXCEED 25 WITHOUT MODIFICATION TO THE ARRAYS DSQ0 AND IPC0.
C DECLARATION STATEMENTS
C
      COMMON /CONRA3/ IREC
      DIMENSION       XD(NDP)    ,YD(NDP)    ,IPC(1)
      DIMENSION       DSQ0(25)   ,IPC0(25)
C
        SAVE
C
C STATEMENT FUNCTION
C
      DSQF(U1,V1,U2,V2) = (U2-U1)**2+(V2-V1)**2
C
C CALCULATION
C
      DO  220 IP1=1,NDP
C
C - SELECTS NCP POINTS.
C
         X1 = XD(IP1)
         Y1 = YD(IP1)
         J1 = 0
         DSQMX = 0.0
         DO  110 IP2=1,NDP
            IF (IP2 .EQ. IP1) GO TO  110
            DSQI = DSQF(X1,Y1,XD(IP2),YD(IP2))
            J1 = J1+1
            DSQ0(J1) = DSQI
            IPC0(J1) = IP2
            IF (DSQI .LE. DSQMX) GO TO  100
            DSQMX = DSQI
            JMX = J1
  100       IF (J1 .GE. NCP) GO TO  120
  110    CONTINUE
  120    IP2MN = IP2+1
         IF (IP2MN .GT. NDP) GO TO  150
         DO  140 IP2=IP2MN,NDP
            IF (IP2 .EQ. IP1) GO TO  140
            DSQI = DSQF(X1,Y1,XD(IP2),YD(IP2))
            IF (DSQI .GE. DSQMX) GO TO  140
            DSQ0(JMX) = DSQI
            IPC0(JMX) = IP2
            DSQMX = 0.0
            DO  130 J1=1,NCP
               IF (DSQ0(J1) .LE. DSQMX) GO TO  130
               DSQMX = DSQ0(J1)
               JMX = J1
  130       CONTINUE
  140    CONTINUE
C
C - CHECKS IF ALL THE NCP+1 POINTS ARE COLLINEAR.
C
  150    IP2 = IPC0(1)
         DX12 = XD(IP2)-X1
         DY12 = YD(IP2)-Y1
         DO  160 J3=2,NCP
            IP3 = IPC0(J3)
            DX13 = XD(IP3)-X1
            DY13 = YD(IP3)-Y1
            IF ((DY13*DX12-DX13*DY12) .NE. 0.0) GO TO  200
  160    CONTINUE
C
C - SEARCHES FOR THE CLOSEST NONCOLLINEAR POINT.
C
         NCLPT = 0
         DO  190 IP3=1,NDP
            IF (IP3 .EQ. IP1) GO TO  190
            DO  170 J4=1,NCP
               IF (IP3 .EQ. IPC0(J4)) GO TO  190
  170       CONTINUE
            DX13 = XD(IP3)-X1
            DY13 = YD(IP3)-Y1
            IF ((DY13*DX12-DX13*DY12) .EQ. 0.0) GO TO  190
            DSQI = DSQF(X1,Y1,XD(IP3),YD(IP3))
            IF (NCLPT .EQ. 0) GO TO  180
            IF (DSQI .GE. DSQMN) GO TO  190
  180       NCLPT = 1
            DSQMN = DSQI
            IP3MN = IP3
  190    CONTINUE
         DSQMX = DSQMN
         IPC0(JMX) = IP3MN
C
C - REPLACES THE LOCAL ARRAY FOR THE OUTPUT ARRAY.
C
  200    J1 = (IP1-1)*NCP
         DO  210 J2=1,NCP
            J1 = J1+1
            IPC(J1) = IPC0(J2)
  210    CONTINUE
  220 CONTINUE
      RETURN
      END

C
C $Id: kfpx.f,v 1.7 2008-07-27 00:17:24 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      FUNCTION KFPX (RX)
C
C Given an X coordinate RX in the fractional system, KFPX(RX) is an X
C coordinate in the plotter system.
C
      COMMON /IUTLCM/ LL,MI,MX,MY,IU(96)
      SAVE /IUTLCM/
      KFPX=1+INT(RX*(2.**MX-1.))
      RETURN
      END

c ----------------------------------------------------------------------
      subroutine stat2 (x,npts,xmsg,xmean,xvar,xsd,nptused,ier)
 
c this routine will calculate estimates of the first two  moments
c .   of the vector x containing missing data.
 
c input arguments:
c .   x        - input vector
c .   npts     - length of x
c .   xmsg     - missing code: if there are no msg values
c .                            set xmsg to some value which will
c .                            not be encountered.
 
c output arguments:
c .   xmean    - mean of x (first moment)
c .   xvar     - sample variance
c .   xsd      - sqrt( xvar )
c .   nptused  - no. of points used to calculate the estimates
c .   ier      - if (ier.ne.0) an error has occurred
 
c note :
c .   uncalculated quantities are set to xmsg (nptused set to zero)
 
      integer npts  , nptused, ier
      real x(1:npts), xmsg, xmean, xvar, xsd
      double precision x1, x2, x3, temp
 
      xmean   = xmsg
      xvar    = xmsg
      xsd     = xmsg
      nptused = 0
 
      if (npts.lt.1) then
         ier = 1
         return
      endif
 
      ier = 0
      x1  = 0.d0
      x2  = 0.d0
      xn  = 0.
      do n=1,npts
         if (x(n).ne.xmsg) then
             xn = xn + 1.0
             x1 = x1 + dble(x(n))
             x2 = x2 + dprod( x(n),x(n) )  
         endif
      enddo
 
      nptused = xn
 
      if ((xn-1.).gt.0.) then
         x3    = x1*x1/dble(xn)
         temp  = (x2-x3)/dble(xn-1.)
         xvar  = sngl(dmax1( temp  , 0.d0 )) ! prevent possible roundoff
         xsd   = sqrt( xvar )
         xmean = sngl(x1/dble(xn))
      elseif ((xn-1.).eq.0.) then
         xmean = sngl(x1)
         xvar  = 0.0
         xsd   = 0.0
      else
         ier = 2    ! error code for all msg values
      endif
 
      return
      end
c ----------------------------------------------------------------------
      subroutine stat2t (x,npts,xmsg,xmeant,xvart,xsdt,nptused
     1                  ,work,ptrim,ier)
 
c this routine will calculate trimmed estimates of the first
c .   two moments of the vector x containing missing data.
 
c input arguments:
c .   x        - input vector
c .   npts     - length of x  (npts.ge.5 if pctrim.gt.0.)
c .   xmsg     - missing code: if there are no msg values
c .                            set xmsg to some value which will
c .                            not be encountered.
c .   work     - work vector of length npts
c .              upon return work contains x in ascending order
c .   ptrim    - portion of the series to be trimmed (0.<= pctrim <1.)
c .              if (pctrim.eq.0.) then
c .                  calculate whole series mean and st dev
c .              else
c .                  a minimum of two pts will be trimmed
c .                  a maximum of npts-2 will be trimmed
c .              endif
c .
c .              note: if u want to be very conservative and only
c .                    trim the min and max values then set
c .                    ptrim to some very small value (e.g. 1.e-36)
c .
c .              ex: npts=45, ptrim=0.50 then
c .                  0.5*45=22 pts will be trimmed (11 on each end)
 
c output arguments:
c .   xmeant   - mean of trimmed series x
c .   xvart    - sample trimmed variance
c .   xsdt     - sqrt( xvart ): st deviation of trimmed series
c .   nptused  - no. of points used to calculate the trimmed estimates
c .   ier      - if (ier.ne.0) an error has occurred
 
c note : uncalculated quantities are set to xmsg (nptused set to zero)
 
      real x(1:npts)  , work(1:npts)
 
      ier     = 0
      xmeant  = xmsg
      xvart   = xmsg
      xsdt    = xmsg
      nptused = 0
 
      if (npts.lt.1) then
         ier = 1
         return
      endif
 
      if (ptrim.eq.0.) then
          call stat2 (x,npts,xmsg,xmeant,xvart,xsdt,nptused,ier)
          return
      elseif (ptrim.eq.1.) then
          ier = 2     ! cannot trim whole series
          return
      endif
 
c sort x into numerically ascending order
c .   first transfer the input array to the work array
c .   excluding missing pts
 
      mpts = 0
      do n=1,npts
         if (x(n).ne.xmsg) then
             mpts       = mpts+1
             work(mpts) = x(n)
         endif
      enddo
 
      if (mpts.lt.1) then
          ier = 3                   ! series contains all msg values
          return
      elseif (mpts.lt.npts) then
          do m=mpts+1,npts          ! fill the rest of work with msg code
             work(m) = xmsg
          enddo
      endif
 
      call sortu(work,mpts)         ! sort series in ascending order
 
      mtrim = max0( int( float(mpts)*0.5*ptrim ), 1)   ! no. of values trimmed
                                                       ! from one side
 
      if ((mpts-2*mtrim).gt.0) then
          call stat2 (work(mtrim+1),mpts-2*mtrim,xmsg,xmeant
     1               ,xvart,xsdt,nptused,ier)
      else
          ier = 4                   ! not enough trimmed values
      endif
 
      return
      end
c ----------------------------------------------------------------------
      subroutine stat4 (x,npts,xmsg,xmean,xvar,xsd,xskew,xkurt
     1                 ,nptused,ier)
 
c this routine will calculate estimates of the first four moments
c .   of the vector x containing missing data.
 
c input arguments:
c .   x        - input vector
c .   npts     - length of x
c .   xmsg     - missing code: if there are no msg values
c .                            set xmsg to some value which will
c .                            not be encountered.
 
c output arguments:
c .   xmean    - mean of x (first moment)
c .   xvar     - sample variance of x (second moment)
c .   xsd      - sqrt( xvar )
c .   xskew    - coef. of skewness (third moment)
c .              departure from symmetry. if skew>0 [skew<0] the
c .              distribution trails off to the right [left] .
c .   xkurt    - coef. of kurtosis (fourth moment)
c .              the normal distribution has a kurtosis of 3 . this
c .              value is subtracted from the calculated kurtosis.
c .              thus neg values are possible and the returned value
c .              is kurtosis relative to the normal distribution.
c .              if (kurt-3) > 0 [<0] it is usually more sharply peaked
c .              [flatter] than the normal distribution. (leptokurtic and
c .              platykurtic , respectively.) e.g. , a rectangular function has
c .              a kurtosis of 1.8 or 1.8-3 = -1.2 relative to the normal
c .              distribution.
c .   nptused  - no. of points used to calculate the estimates
c .   ier      - if (ier.ne.0) an error has occurred
 
c note :
c .   uncalculated quantities are set to xmsg (nptused set to zero)
 
      real x(1:npts)
      double precision x1, x2, x3, x4, dxvar
 
      xmean = xmsg
      xvar  = xmsg
      xsd   = xmsg
      xskew = xmsg
      xkurt = xmsg
      nptused = 0
 
 
      if (npts.lt.1) then
         ier = 1
         return
      endif
 
      ier = 0
      x1  = 0.d0
      x2  = 0.d0
      xn  = 0.
      do n=1,npts
         if (x(n).ne.xmsg) then
             xn = xn + 1.0
             x1 = x1 + dble(x(n))
             x2 = x2 + dprod( x(n),x(n) )
         endif
      enddo
 
      nptused = xn
 
      if ((xn-1.).gt.0.) then
         x3    = x1*x1/dble(xn)
         dxvar = dmax1( (x2-x3)/dble(xn-1.) , 0.d0 ) !prevent possible roundoff
         xvar  = sngl( dxvar )
         xsd   = sqrt( xvar )
         xmean = sngl(x1/dble(xn))
 
         if (dxvar.gt.0.d0) then
             x1 = 0.d0
             x2 = 0.d0
             x3 = 0.d0
             x4 = 0.d0
             do n=1,npts
                if (x(n).ne.xmsg) then
                    x4 = dble(x(n)-xmean)
                    x1 = x4**3
                    x2 = x2 + x1
                    x3 = x3 + x1*x4
                endif
             enddo
             xskew = sngl( (x2/dsqrt(dxvar)**3)/dble(xn))
             xkurt = sngl( (x3/(dxvar*dxvar))/dble(xn)) - 3.
         endif
      elseif ((xn-1.).eq.0.) then
         xmean = sngl(x1)
         xvar  = 0.0
         xsd   = 0.0
      else
         ier = 2    ! error code for all msg values
         return
      endif
 
      return
      end
c ----------------------------------------------------------------------
      subroutine medmrng (x,work,npts,xmsg,xmedian,xmrange
     1                   ,xrange,nptused,ier)
 
c this routine will find the median, range and mid-range
c .   of the input  vector x containing missing data.
 
c arguments :
c .   x        - input vector (series)
c .   work     - work vector of length npts. upon output
c .              work(1) thru work(nptused) are in numerically ascending
c .              order. work(nptused+1) thru work(npts) will be filled
c .              the missing value code.
c .   npts     - length of x
c .   xmsg     - missing code: if no msg values set to some number
c .                            which will not be encountered.
c .   xmedian  - median value of vector x
c .   xmrange  - midrange
c .   xrange   - range of x
c .   nptused  - no. of points used in computing various quantities
c .   ier      - if (ier.ne.0) an error has occurred
 
c note :
c .   uncalculated quantities are set to xmsg (nptused set to zero)
 
      real x(1:npts) , work(1:npts)
 
      xmedian = xmsg
      xmrange = xmsg
      xrange  = xmsg
      nptused = 0
 
      if (npts.lt.1) then
         ier = 1
         return
      endif
      ier     = 0
 
c sort x into numerically ascending order
c .   first transfer the input array to the work array
c .   excluding missing pts
 
      mpts = 0
      do n=1,npts
         if (x(n).ne.xmsg) then
             mpts       = mpts+1
             work(mpts) = x(n)
         endif
      enddo
 
      if (mpts.lt.1) then
          ier = 2                     ! series contains all msg values
          return
      endif
 
      call sortu(work,mpts)
 
      if (mpts.lt.npts) then
          do n=mpts+1,npts            ! fill the rest of work with msg code
             work(n) = xmsg
          enddo
      endif
 
      xmrange = 0.5*( work(mpts)+work(1) )
      xrange  =       work(mpts)-work(1)
 
      if (amod(float(mpts),2.).eq.0.) then
          xmedian = 0.5*(work(mpts/2)+work(mpts/2+1) )
      else
          xmedian  = work((mpts+1)/2)
      endif
 
      nptused = mpts          ! for nomenclature compatibility
 
      return
      end
c ----------------------------------------------------------------------
      subroutine esauto (x,npts,xmsg,xmean,xvar,mxlag,acv,acr,ier)
 
c this routine will estimate the autocovariances and autocorrelations
c .   for the input vector x with missing data. the normalizing factor
c .   in the denominator (xvar) is kept constant.
 
c arguments :
c .   x        - input vector
c .   npts     - length of vector x
c .   xmsg     - missing code: if no msg values set to some number
c .                            which will not be encountered.
c .   xmean    - mean of the input vector x
c .   xvar     - sample variance  of the input vector x
c .              note: if xmean and/or xvar = xmsg this routine will
c .                    calculate the quantities and return them
c .   mxlag    - max lag to be estimated  [0 <= mxlag <= npts ]
c .   acv      - sample autocovariances  [vector of length .ge. (mxlag+1) ]
c .   acr      - sample autocorrelations [vector of length .ge. (mxlag+1) ]
 
c .              acv(0)     = xvar (lag 0  )  : acr(0)       = 1.00 ( lag 0  )
c .              acv(1)     =      (lag 1  )  : acr(1)       =      ( lag 1  )
c .                         .                              .
c .                         .                              .
c .              acv(mxlag) =      (lag mxlag): acr(mxlag) =      ( lag mxlag)
 
c .   ier      - if (ier.ne.0) an error has occurred
 
c note :  uncalculated quantities are set to xmsg
 
      real x(1:npts) , acv(0:mxlag) , acr(0:mxlag)
      double precision x1
 
      ier = 0
      if (npts.lt.2) ier = 1
      if (mxlag.lt.0 .or. mxlag.gt.npts) ier = 2
      if (xvar .le.0. .and. xvar .ne.xmsg)    ier = 3
      if (ier.ne.0) then
          do lag=0,max0 (0, min0(mxlag,npts) )
             acv(lag) = xmsg
             acr(lag) = xmsg
          enddo
          return
      endif
 
      if (xmean.eq.xmsg .or. xvar.eq.xmsg) then
         call stat2 (x,npts,xmsg,xmean,xvar,xsd,nptused,jer)
         if (jer.ne.0) then
             ier = -jer
             return
         elseif (xvar.eq.0.) then
             ier = -5
             return
         endif
      endif
 
      acv(0) = xvar
      acr(0) = 1.00
 
      if (mxlag.eq.0) return       ! i hope somebody wants more than this
 
      do lag=1,mxlag
         x1 = 0.d0
         xn = 0.
       do n=1,npts-lag
          if (x(n).ne.xmsg .and. x(n+lag).ne.xmsg) then
              x1 = x1 + dprod( (x(n+lag)-xmean) , (x(n)-xmean) )
              xn = xn + 1.
          endif
       enddo
         if (xn.ge.2.) then
             acv(lag) = sngl(x1/dble(xn-1.))
             acr(lag) = acv(lag)/xvar
         else
             acv(lag) = xmsg
             acr(lag) = xmsg
         endif
      enddo
 
      return
      end
c ----------------------------------------------------------------------
      subroutine escros (x,y,npts,xmsg,ymsg,xmean,ymean,xsd,ysd
     1                  ,mxlag,ccv,ccr,ier)
 
 
c this routine will estimate the crosscovariances and crosscorrelations
c .   for the input series x and y. missing data is allowed.
 
c .   to get the (+) and (-) ccv and ccr two calls must be made. the
c .   first with the calling sequence above and the second with the
c .   x and y series reversed (also the other arguments) . note
c .   that  the second ccv(0) and ccr(0) are redundant.
 
c arguments :
c .   x,y      - input vectors with which the calculations are to take place.
c .   npts     - length of vectors x and y
c .   xmsg,ymsg- missing code: if no msg values set to some number
c .                            which will not be encountered.
c .              xmsg will be used to fill missing values
c .   xmean    - mean of the x vector (if xmean=xmsg: program will calculate)
c .   ymean    - mean of the y vector (if ymean=ymsg: program will calculate)
c .   xsd      - st. dev. of x vector (if xsd  =xmsg: program will calculate)
c .   ysd      - st. dev. of y vector (if ysd  =ymsg: program will calculate)
c .   mxlag    - max lag crosscovariance/correlation to be estimated
c .   ccv      - vector of length .ge. (mxlag+1) containing sample cross cov
c .   ccr      - vector of length .ge. (mxlag+1) containing sample cross cor
 
c .                ccv(0)     = xyvar (lag 0  )  : ccr(0)     =  ( lag 0   )
c .                ccv(1)     =       (lag 1  )  : ccr(1)     =  ( lag 1   )
c .                           .                               .
c .                           .                               .
c .                ccv(mxlag) =       (lag mxlag): ccr(mxlag) =  ( lag mxlag)
 
c .   ier      - if (ier.ne.0) an error has occurred
 
c note : uncalculated quantities are set to xmsg
 
      real x(1:npts) , y(1:npts) , ccv(0:mxlag) , ccr(0:mxlag)
      double precision xy1
 
      ier = 0
      if (npts.lt.2) ier = 1
      if (mxlag.lt.0 .or. mxlag.gt.npts) ier = 2
      if ((xsd.ne.xmsg .and. xsd.le.0.) .or.
     *    (ysd.ne.ymsg .and. ysd.le.0.)) ier = 3
      do lag=0,max0( 0, min0(mxlag,npts) )
         ccv(lag) = xmsg
         ccr(lag) = xmsg
      enddo
      if (ier.ne.0) return
 
      if (xmean.eq.xmsg .or. xsd.eq.xmsg) then
         call stat2 (x,npts,xmsg,xmean,xvar,xsd,nptused,jer)
         if (jer.ne.0) then
             ier = -jer
         elseif (xsd.eq.0.) then
             ier = -5              ! x must be a series of constant values
         elseif (nptused.eq.0) then
             ier = -6              ! x must be a series of missing values
         endif
         if (ier.ne.0) return
      endif
 
      if (ymean.eq.ymsg .or. ysd.eq.ymsg) then
         call stat2 (y,npts,ymsg,ymean,yvar,ysd,nptused,jer)
         if (jer.ne.0) then
             ier = -(jer+100)
         elseif (ysd.eq.0.) then
             ier = -105            ! y must be a series of constant values
         elseif (nptused.eq.0) then
             ier = -106            ! y must be a series of missing values
         endif
         if (ier.ne.0) return
      endif
 
      xsdysd = sngl(1.d0/dprod(xsd,ysd))
 
      do lag=0,mxlag
         xyn = 0.
         xy1 = 0.d0
       do n=1,npts-lag
          if (x(n).ne.xmsg .and. y(n+lag).ne.ymsg) then
              xy1 = xy1 + dprod((y(n+lag)-ymean),(x(n)-xmean))
              xyn = xyn + 1.
          endif
       enddo
         if (xyn.ge.2.) then
             ccv(lag) = sngl(xy1/dble(xyn-1.))
             ccr(lag) = ccv(lag)*xsdysd
         else
             ccv(lag) = xmsg
             ccr(lag) = xmsg
         endif
      enddo
 
      return
      end
c ----------------------------------------------------------------------
      subroutine rmvave  (x,npts,xmsg,xmean,ier)
 
c this routine will remove the mean of vector x from each pt.
c .   missing pts are excepted.
 
c arguments :
c .   x        - input vector
c .   npts     - length of x
c .   xmsg     - missing code: if there are no msg values
c .                            set xmsg to some value which will
c .                            not be encountered.
c .   xmean    - mean of the input vector (x)
c .   ier      - if (ier.ne.0) an error has occurred
 
      real x(1:npts)
 
      if (npts.lt.1) then
          ier = 1
          return
      else
          ier = 0
      endif
 
      do n=1,npts
         if (x(n).ne.xmsg) x(n) = x(n) - xmean
      enddo
 
      return
      end
c ----------------------------------------------------------
      subroutine stndx (x,npts,xmsg,xmean,xsd,ier)
 
c standardize the vector x
 
c arguments :
c .   x        - vector to be standardized
c .   npts     - length of vector x
c .   xmsg     - missing code: if there are no msg values
c .                            set xmsg to some value which will
c .                            not be encountered.
c .   xmean    - mean of the input vector
c .   xsd      - standard deviation of the series
c .   ier      - if (ier.ne.0) an error has ocurred
 
      real x(1:npts)
 
      ier = 0
      if (npts.lt.1) then
          ier = 1
      elseif (xsd.le.0.) then
          ier = 2
      endif
      if (ier.ne.0) return
 
      do n=1,npts
         if (x(n).ne.xmsg) x(n) = (x(n)-xmean)/xsd
      enddo
 
      return
      end
c ----------------------------------------------------------------------
      subroutine nmdata (x,npts,xmsg,ier)
 
c normalize the vector x by the absolute value of its largest element
 
c arguments :
c .   x        - series (vector) to be normalized
c .   npts     - length of x
c .   xmsg     - missing code: if there are no msg values
c .                            set xmsg to some value which will
c .                            not be encountered.
c .   ier      - if (ier.ne.0) an error has occurred
 
      real x(1:npts)
 
      ier = 0
      if (npts.lt.1) then
          ier = 1
          return
      endif
 
c find the first non-missing pt
 
      do n=1,npts
      if (x(n).ne.xmsg) then
          nstrt = n
          go to 20
      endif
      enddo
 
      ier = 1      ! must be all msg values
      return
 
   20 xmax = abs( x(nstrt) )
      do n=nstrt,npts
         if (x(n).ne.xmsg) xmax = amax1( abs(x(n)) , xmax )
      enddo
 
      if (xmax.ne.0.) then
          do n=nstrt,npts
             if (x(n).ne.xmsg) x(n) = x(n)/xmax
          enddo
      else
          ier = 2 ! must be all zeros
      endif
 
      return
      end
c ----------------------------------------------------------------------
      subroutine errchk (x,npts,xmean,xsd,xmsg,xband,locerr,npter,ier)
 
c this routine will check a series of data for potential gross errors
c .   (i.e., wild points). the series will be scanned and the locations
c .   of possibly bad points are stored. this routine
c .   assumes that the series x is normally distributed.
 
c input arguments:
c .   x        - series (vector) to be checked
c .   npts     - length of x
c .   xmean    - series mean (... or median is the user chooses)
c .   xsd      - series standard deviation
c .   xmsg     - missing code: if there are no msg values
c .                            set xmsg to some value which will
c .                            not be encountered.
c .   xband    - standard deviation width to be allowed
c .              (e.g., xband=3.0; check values beyond 99%)
 
c output arguments:
c .   locerr   - integer vector which will contain the subscript location of
c .              potential gross errors. for example: if series x has
c .              two pts more than xband from xmean and these pts are
c .              located at x(17) and x(204) then locerr(1) = 17 and
c .              locerr(2) = 204.
c .   npter    - no. of pts in locerr. in the above example it would be
c .              two. if a value of zero is returned no gross errors
c .              have been detected.
c .   ier      - if (ier.ne.0) an error has occurred
 
      real    x(1:npts)
      integer locerr(1:npts)
 
      ier = 0
      if (npts.lt.1) then
          ier = 1
      elseif (xsd.eq.0.) then
          ier = 2
      endif
      if (ier.ne.0) return
 
      nn     = 0
      npter  = 0
      xwidth = xband*xsd
      do n=1,npts
         if (x(n).ne.xmsg .and. abs(x(n)-xmean).gt.xwidth) then
             npter         = npter+1   ! must be a potential gross error
             locerr(npter) = n
         endif
      enddo
 
      return
      end
c ----------------------------------------------------------------------
      subroutine dotpr (x,y,npts,xmsg,ymsg,ans,nptused,ier)
 
c compute the dot product for series containing msg values
 
c arguments :
c .   x,y       - input series
c .   npts      - length of x and y
c .   xmsg,ymsg - missing code: if there are no msg values
c .                             set xmsg,ymsg to some value which will
c .                             not be encountered.
c .   ans       - answer (dot product)
c .   nptused   - number of points used to compute the dot product
c .   ier       - if (ier.ne.0) an error has occurred
 
      dimension x(1:npts) , y(1:npts)
      double precision temp
 
      ier = 0
      if (npts.lt.1) then
          ier = 1
          return
      endif
 
      temp    = 0.d0
      nptused = 0
      do n=1,npts
         if (x(n).ne.xmsg .and. y(n).ne.ymsg ) then
             temp    = temp + dprod( x(n),y(n) )
             nptused = nptused + 1
         endif
      enddo

      ans = sngl(temp)
 
      return
      end
c ----------------------------------------------------------------------
      subroutine vcvmns (x,nrow,ncol,nrt,ncs,xmsg,vcm,lvcm,ier)
 
c this routine will calculate the variance-covariance matrix (vcm)
c .   of the array x containing missing data. obviously if x does contain
c .   missing data then vcm is only an approximation.
 
c note : conventional storage is utilized for vcm
 
c     x        - input data array  ( unchanged on output)
c     nrow,ncol- exact dimensions of x in calling routine
c     nrt,ncs  - dimension of sub-matrix which contains the data
c                (nrt@nrow : ncs@ncol)
c     xmsg     - missing data code (if none set to some no. not encountered)
c     vcm      - var-cov matrix
c     lvcm     - not used in this routine
c     ier      - error code (if ier=-1 then vcm contains missing entry)
 
      real x(1:nrow,1:ncol) , vcm(1:ncol,1:ncol)
      double precision xca, xcb, xcacb   
 
      ier=0
 
c calculate the var-cov between columns (stations)
 
      do nca=1,ncs
       do ncb=nca,ncs
          xn    = 0.
          xca   = 0.
          xcb   = 0.
          xcacb = 0.
        do i=1,nrt
           if (x(i,nca).ne.xmsg .and. x(i,ncb).ne.xmsg) then
               xn    = xn  + 1.
               xca   = xca + dble(x(i,nca))
               xcb   = xcb + dble(x(i,ncb))
               xcacb = xcacb + dprod( x(i,nca),x(i,ncb) )
           endif
        enddo    ! end "nrt"
          if (xn.ge.2.) then
              vcm(nca,ncb)= sngl((xcacb-(xca*xcb)/dble(xn))/dble(xn-1.))
              vcm(ncb,nca)= vcm(nca,ncb)
          else
              ier = -1
              vcm(nca,ncb) = xmsg
              vcm(ncb,nca) = xmsg
          endif
       enddo     ! end "ncs"
      enddo      ! end "ncs"
 
      return
      end
c ----------------------------------------------------------------------
      subroutine vcmssm (x,nrow,ncol,nrt,ncs,xmsg,vcm,lvcm,ier)
 
c this routine will calculate the variance-couariance matrix (vcm)
c .   of the array x containing missing data. obviously if x does contain
c .   missing data then vcm is only an approximation.
 
c note : symmetric storage mode is utilized for vcm to save space.
 
c input:
c     x        - input data array  ( unchanged on output)
c     nrow,ncol- exact dimensions of x in calling routine
c     nrt,ncs  - dimension of sub-matrix which contains the data
c                (nrt <= nrow : ncs <= ncol)
c     xmsg     - missing data code (if none set to some no. not encountered)
c output:
c     vcm      - var-cov matrix
c     lvcm     - length of vcm
c     ier      - error code (if ier=-1 then vcm contains missing entry)
 
      dimension x(1:nrow,1:ncol) , vcm(*)
      double precision xca, xcb, xcacb   
 
      ier  = 0
      if (nrow.lt.1 .or. ncol.lt.1) ier = ier+1
      if (nrt .lt.1 .or. ncs .lt.1) ier = ier+10
      if (ier.ne.0) return
 
      lvcm = ncs*(ncs+1)/2
 
c calculate the var-cov between columns (stations)
 
      nn = 0
      do nca=1,ncs
       do ncb=1,nca
          xn    = 0.
          xca   = 0.d0
          xcb   = 0.d0
          xcacb = 0.d0
          nn    = nn + 1
        do i=1,nrt
           if (x(i,nca).ne.xmsg .and. x(i,ncb).ne.xmsg) then
               xn    = xn + 1.
               xca   = xca + dble(x(i,nca))
               xcb   = xcb + dble(x(i,ncb))
               xcacb = xcacb + dprod( x(i,nca) , x(i,ncb) )
           endif
        enddo
          if (xn.ge.2.) then
              vcm(nn) = sngl( (xcacb-(xca*xcb)/dble(xn) )/dble(xn-1.)) 
          elseif (xn.eq.1.) THEN
             vcm(nn) = ( xcacb-(xca*xcb)/xn )
          else
              ier     = -1
              vcm(nn) = xmsg
          endif
       enddo
      enddo
 
      return
      end
c
c ----------------------------------------------------------------------
      subroutine cormns (x,nrow,ncol,nrt,ncs,xmsg,crm,lcrm,ier)
 
c this routine will calculate the correlation matrix   (crm)
c .   of the array x containing missing data. obviously if x does contain
c .   missing data then crm is only an approximation.
 
c note : conventional storage
 
c     x        - input data array  ( unchanged on output)
c     nrow,ncol- exact dimensions of x in calling routine
c     nrt,ncs  - dimension of sub-matrix which contains the data
c                (nrt@nrow : ncs@ncol)
c     xmsg     - missing data code (if none set to some no. not encountered)
c     crm      - correlation matrix  [full]
c     lcrm     - dummy [not used in this routine]
c     ier      - error code (if ier=-1 then crm contains missing entry)
 
      real x(1:nrow,1:ncol) , crm(1:ncol,1:ncol)
      double precision xca, xcb, xca2, xcb2, xcacb, xvara, xvarb, temp 
 
      ier  = 0
      lcrm = ncs*(ncs+1)/2
 
c calculate the var-cov between columns (stations)
c .   then standardize
 
      do nca=1,ncs
       do ncb=1,nca
          xn    = 0.
          xca   = 0.d0
          xcb   = 0.d0
          xca2  = 0.d0
          xcb2  = 0.d0
          xcacb = 0.d0
        do i=1,nrt
           if (x(i,nca).ne.xmsg .and. x(i,ncb).ne.xmsg) then
               xn    = xn + 1.
               xca   = xca + dble(x(i,nca))
               xcb   = xcb + dble(x(i,ncb))
               xca2  = xca2 + dprod(x(i,nca),x(i,nca))
               xcb2  = xcb2 + dprod(x(i,ncb),x(i,ncb))
              xcacb = xcacb + dprod(x(i,nca),x(i,ncb))
          endif
        enddo    
          if (xn.ge.2.) then
              xvara   =  ( xca2-((xca*xca)/dble(xn)) )/dble(xn-1.)
              xvarb   =  ( xcb2-((xcb*xcb)/dble(xn)) )/dble(xn-1.)
              if (xvara.gt.0. .and. xvarb.gt.0.) then
                  temp  = (xcacb-((xca*xcb)/dble(xn)))/dble(xn-1.)
                  crm(ncb,nca) = sngl(temp/(dsqrt(xvara)*dsqrt(xvarb)))
                  crm(nca,ncb) = crm(ncb,nca) ! symmetric 
              else
                  ier     = -1
                  crm(ncb,nca) = xmsg
                  crm(nca,ncb) = xmsg
              endif
          else
              ier     = -1
              crm(ncb,nca) = xmsg
              crm(nca,ncb) = xmsg
          endif
       enddo
      enddo
 
      return
      end
c ----------------------------------------------------------------------
      subroutine crmssm (x,nrow,ncol,nrt,ncs,xmsg,crm,lcrm,ier)
 
c this routine will calculate the correlation matrix   (crm)
c .   of the array x containing missing data. obviously if x does contain
c .   missing data then crm is only an approximation.
 
c note : symmetric storage mode is utilized for crm to save space.
 
c input:
c     x        - input data array  ( unchanged on output)
c     nrow,ncol- exact dimensions of x in calling routine
c     nrt,ncs  - dimension of sub-matrix which contains the data
c                (nrt <= nrow : ncs <= ncol)
c     xmsg     - missing data code (if none set to some no. not encountered)
c output:
c     crm      - correlation matrix
c     lcrm     - length of crm
c     ier      - error code (if ier=-1 then crm contains missing entry)
 
      real x(1:nrow,1:ncol) , crm(*)
      double precision xca, xcb, xca2, xcb2, xcacb, xvara, xvarb, temp 
 
      ier  = 0
      if (nrow.lt.1 .or. ncol.lt.1) ier = ier+1
      if (nrt .lt.1 .or. ncs .lt.1) ier = ier+10
      if (ier.ne.0) return
 
      lcrm = ncs*(ncs+1)/2
 
c calculate the var-cov between columns (stations)
 
      nn   = 0
      do nca=1,ncs
       do ncb=1,nca
          xn    = 0.
          xca   = 0.d0
          xcb   = 0.d0
          xca2  = 0.d0
          xcb2  = 0.d0
          xcacb = 0.d0
          nn    = nn + 1
        do i=1,nrt
           if (x(i,nca).ne.xmsg .and. x(i,ncb).ne.xmsg) then
               xn    = xn + 1.
               xca   = xca   + dble(x(i,nca))
               xcb   = xcb   + dble(x(i,ncb))
               xca2  = xca2  + dprod(x(i,nca),x(i,nca))
               xcb2  = xcb2  + dprod(x(i,ncb),x(i,ncb))
               xcacb = xcacb + dprod(x(i,nca),x(i,ncb))
           endif
        enddo
          if (xn.ge.2.) then
              xvara   =  ( xca2-((xca*xca)/dble(xn)) )/dble(xn-1.)
              xvarb   =  ( xcb2-((xcb*xcb)/dble(xn)) )/dble(xn-1.)
              if (xvara.gt.0.d0 .and. xvarb.gt.0.d0) then
                  temp    = ( xcacb-((xca*xcb)/dble(xn)) )/dble(xn-1.)
                  crm(nn) = sngl( temp/(dsqrt(xvara)*dsqrt(xvarb)) )
              else
                  ier     = -1
                  crm(nn) = xmsg
              endif
           elseif (xn.eq.1.) then
              xvara   =  ( xca2-((xca*xca)/(xn)) )
              xvarb   =  ( xcb2-((xcb*xcb)/(xn)) )
              if (xvara.gt.0. .and. xvarb.gt.0.) then
                  crm(nn) = ( xcacb-((xca*xcb)/(xn)) )
                  crm(nn) = crm(nn)/(sqrt(xvara)*sqrt(xvarb))
              else
                  ier     = -1
                  crm(nn) = xmsg
              endif
          else
              ier     = -1
              crm(nn) = xmsg
          endif
       enddo
      enddo
 
      return
      end

c ----------------------------------------------------------------------
      subroutine ccorc (y,x,nrow,ncol,nrt,ncs,xmsg,corc,ier)
 
c this routine will calculate the correlation coef between a
c .   vector (station) y and a matrix x containing observations from
c .   many different stations
 
c     y        - vector (station data) with which data matrix x is to
c                be correlated
c     x        - input data array  ( unchanged on output)
c     nrow,ncol- exact dimensions of x in calling routine
c     nrt,ncs  - dimension of sub-matrix which contains the data
c                (nrt@nrow : ncs@ncol)
c     xmsg     - missing data code (if none set to some no. not encountered)
c     corc     - correlation coef. vector
c                corc(1) contain correlation coef between y and x(nrt,1)
c                corc(2) contain correlation coef between y and x(nrt,2) etc.
c     ier      - error code (if ier=-1 then corc contains missing entry)
 
      real x(1:nrow,1:ncol) , y(*) , corc(*)
      double precision xy, temp
 
c calculate the mean and var of y
 
      call stat2 (y,nrt,xmsg,ymean,yvar,ysd,nptusy,ier)
      if (ier.ne.0) return
      if (ysd .eq.0.) then
          do nc=1,ncs
             corc(nc) = xmsg
          enddo
          ier = 201
          return
      endif
 
c calculate the cross correlation coef
c .   calculate the mean and variance of column nc in the data array
 
      do nc=1,ncs
         corc(nc) = xmsg
         call stat2 (x(1,nc),nrt,xmsg,xmean,xvar,xsd,nptusx,jer)
         if (jer.ne.0) then
             ier = 205
             go to 40
         endif
         if (xsd.ne.0.) then
             xn = 0.
             xy = 0.d0
             do n=1,nrt
                if (y(n).ne.xmsg .and. x(n,nc).ne.xmsg) then
                    xn = xn + 1.
                    xy = xy + dprod( (y(n)-ymean),(x(n,nc)-xmean) ) 
               endif
             enddo
             if (xn.gt.2.) then
                 temp     = xy/dble(xn-1.)
                 corc(nc) = sngl(temp/dprod(xsd,ysd))
             endif
         endif
   40    continue
      enddo
 
      return
      end
c ------------------------------------------------------------------------------
      subroutine ssmiox (x,ncs)
 
c output a symmetric storage mode matrix [x]
 
c note: format statement have to be changed
 
c .   x(1)
c .   x(2)  x(3)
c .   x(4)  x(5)  x(6)
c .   etc.
 
      real x(1:*)
 
      data ipr/6/
 
      ncend=0
      do nc=1,ncs
         ncstrt = ncend+1
         ncend  = ncstrt+nc-1
         write(ipr,'(2x,i5,10(1x,f12.3),/, (7x,(10(1x,f12.3))))')
     *               nc,(x(n),n=ncstrt,ncend)
      enddo
 
      return
      end
c ------------------------------------------------------------
      real function epsmach (ipr)

      integer ipr    ! =1 print else no print
      real    eps

      eps = 1.0
    1 eps = 0.5*eps
      if ((1.0+eps) .gt. 1.0) go to 1
      epsmach = 2.0*eps
      if (ipr.eq.1) write (*,"('EPSMACH: eps=',e15.7)") epsmach

      return
      end

c ----------------------------------------------------------------------
      subroutine sortu  (a,la)                                          0340

c sort type "real"
 
      integer            la                                             0360
      real               a(la)                                          0370
 
      integer            iu(21),il(21),i,m,j,k,ij,l                     0390
      real               t,tt,r                                         0400
 
      m=1                                                               0420
      i=1                                                               0430
      j=la                                                              0440
      r=.375                                                            0450
      if (la.le.0) return                                               0460
   10 if (i .eq. j) go to 55                                            0470
   15 if (r .gt. .5898437) go to 20                                     0480
      r=r+3.90625e-2                                                    0490
      go to 25                                                          0500
   20 r=r-.21875                                                        0510
   25 k=i                                                               0520
c                                  select a central element of the      0530
c                                  array and save it in location t      0540
      ij=i+(j-i)*r                                                      0550
      t=a(ij)                                                           0560
c                                  if first element of array is greater 0570
c                                  than t, interchange with t           0580
      if (a(i) .le. t) go to 30                                         0590
      a(ij)=a(i)                                                        0600
      a(i)=t                                                            0610
      t=a(ij)                                                           0620
   30 l=j                                                               0630
c                                  if last element of array is less than0640
c                                  t, interchange with t                0650
      if (a(j) .ge. t) go to 40                                         0660
      a(ij)=a(j)                                                        0670
      a(j)=t                                                            0680
      t=a(ij)                                                           0690
c                                  if first element of array is greater 0700
c                                  than t, interchange with t           0710
      if (a(i) .le. t) go to 40                                         0720
      a(ij)=a(i)                                                        0730
      a(i)=t                                                            0740
      t=a(ij)                                                           0750
      go to 40                                                          0760
   35 if(a(l).eq.a(k)) go to 40                                         0770
      tt=a(l)                                                           0780
      a(l)=a(k)                                                         0790
      a(k)=tt                                                           0800
c                                  find an element in the second half of0810
c                                  the array which is smaller than t    0820
   40 l=l-1                                                             0830
      if (a(l) .gt. t) go to 40                                         0840
c                                  find an element in the first half of 0850
c                                  the array which is greater than t    0860
   45 k=k+1                                                             0870
      if (a(k) .lt. t) go to 45                                         0880
c                                  interchange these elements           0890
      if (k .le. l) go to 35                                            0900
c                                  save upper and lower subscripts of   0910
c                                  the array yet to be sorted           0920
      if (l-i .le. j-k) go to 50                                        0930
      il(m)=i                                                           0940
      iu(m)=l                                                           0950
      i=k                                                               0960
      m=m+1                                                             0970
      go to 60                                                          0980
   50 il(m)=k                                                           0990
      iu(m)=j                                                           1000
      j=l                                                               1010
      m=m+1                                                             1020
      go to 60                                                          1030
c                                  begin again on another portion of    1040
c                                  the unsorted array                   1050
   55 m=m-1                                                             1060
      if (m .eq. 0) return                                              1070
      i=il(m)                                                           1080
      j=iu(m)                                                           1090
   60 if (j-i .ge. 11) go to 25                                         1100
      if (i .eq. 1) go to 10                                            1110
      i=i-1                                                             1120
   65 i=i+1                                                             1130
      if (i .eq. j) go to 55                                            1140
      t=a(i+1)                                                          1150
      if (a(i) .le. t) go to 65                                         1160
      k=i                                                               1170
   70 a(k+1)=a(k)                                                       1180
      k=k-1                                                             1190
      if (t .lt. a(k)) go to 70                                         1200
      a(k+1)=t                                                          1210
      go to 65                                                          1220
      end                                                               1230
c ----------------------------------------------------------------------
      subroutine isortu  (a,la)
 
c sort type "integer"
 
      integer            la
      integer            a(la)
 
      integer            iu(21),il(21),i,m,j,k,ij,l
      integer            t,tt
      real               r
 
      m=1
      i=1
      j=la
      r=.375
      if (la.le.0) return
   10 if (i .eq. j) go to 55
   15 if (r .gt. .5898437) go to 20
      r=r+3.90625e-2
      go to 25
   20 r=r-.21875
   25 k=i
c                                  select a central element of the
c                                  array and save it in location t
      ij=i+(j-i)*r
      t=a(ij)
c                                  if first element of array is greater
c                                  than t, interchange with t
      if (a(i) .le. t) go to 30
      a(ij)=a(i)
      a(i)=t
      t=a(ij)
   30 l=j
c                                  if last element of array is less than
c                                  t, interchange with t
      if (a(j) .ge. t) go to 40
      a(ij)=a(j)
      a(j)=t
      t=a(ij)
c                                  if first element of array is greater
c                                  than t, interchange with t
      if (a(i) .le. t) go to 40
      a(ij)=a(i)
      a(i)=t
      t=a(ij)
      go to 40
   35 if(a(l).eq.a(k)) go to 40
      tt=a(l)
      a(l)=a(k)
      a(k)=tt
c                                  find an element in the second half of
c                                  the array which is smaller than t
   40 l=l-1
      if (a(l) .gt. t) go to 40
c                                  find an element in the first half of
c                                  the array which is greater than t
   45 k=k+1
      if (a(k) .lt. t) go to 45
c                                  interchange these elements
      if (k .le. l) go to 35
c                                  save upper and lower subscripts of
c                                  the array yet to be sorted
      if (l-i .le. j-k) go to 50
      il(m)=i
      iu(m)=l
      i=k
      m=m+1
      go to 60
   50 il(m)=k
      iu(m)=j
      j=l
      m=m+1
      go to 60
c                                  begin again on another portion of
c                                  the unsorted array
   55 m=m-1
      if (m .eq. 0) return
      i=il(m)
      j=iu(m)
   60 if (j-i .ge. 11) go to 25
      if (i .eq. 1) go to 10
      i=i-1
   65 i=i+1
      if (i .eq. j) go to 55
      t=a(i+1)
      if (a(i) .le. t) go to 65
      k=i
   70 a(k+1)=a(k)
      k=k-1
      if (t .lt. a(k)) go to 70
      a(k+1)=t
      go to 65
      end

C
C     $Id: cn12f.f,v 1.5 2010-03-15 22:49:23 haley Exp $
C
C***********************************************************************
C                                                                      *
C                            Copyright (C)  1995                       *
C                 University Corporation for Atmospheric Research      *
C                            All Rights Reserved                       *
C                                                                      *
C***********************************************************************
C
C      File:            cn12f.f
C
C      Author:          Mary Haley
C                       National Center for Atmospheric Research
C                       PO 3000, Boulder, Colorado
C
C      Date:            Mon Oct 16 11:02:58 MDT 1995
C
C   Description:  This example emulates LLU example "cpex08".  It
C                 draws a filled map with filled contours appearing in
C                 Africa. In order to mask Africa from the map fill, we
C                 use the mpMaskAreaSpecifiers resource and mask all of
C                 the countries in Africa.
C
      external NhlFAppClass
      external NhlFCairoWindowWorkstationClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external nhlfscalarfieldclass
      external nhlfcontourplotclass
      external nhlfmapplotclass

      integer appid,wid,dataid,conid,mapid
      integer rlist

      parameter(M = 40, N = 40)
      real z(M,N)
      integer len_dims(2)

      character*7  wks_type
C
C Areas we want to fill.
C
      character*5 fillspcs(2)
      data fillspcs/'water','land'/
C
C Areas we want to mask (countries of Africa).
C
      character*30 maskspcs(50)
      data maskspcs/'algeria','angola','angola-exclave-called-cabinda',
     +     'benin','botswana','burundi','cameroon',
     +     'central-african-republic','chad','congo','djibouti','egypt',
     +     'equatorial-guinea','ethiopia','gabon','gambia','ghana',
     +     'guinea','guinea-bissau','ivory-coast','kenya','lesotho',
     +     'liberia','libya','madagascar','malawi','mali','mauritania',
     +     'mauritius','morocco','mozambique','namibia','niger',
     +     'nigeria','rwanda','senegal','sierra-leone','somalia',
     +     'south-africa','sudan','swaziland','tanzania','togo',
     +     'tunisia','uganda','upper-volta','western-sahara','zaire',
     +     'zambia','zimbabwe'/
C
C Define the workstation type
C
      wks_type = "x11"

      call NhlFInitialize
C
C Create an application object.
C
      call NhlFRLCreate(rlist,'SETRL')
      call NhlFRLClear(rlist)
      call NhlFRLSetstring(rlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'cn12',NhlFAppClass,0,rlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkMetaName','./cn12f.ncgm',ierr)
         call NhlFCreate(wid,'cn12Work',NhlFNcgmWorkstationClass,
     1     0,rlist,ierr) 
      else  if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPause','True',ierr)
         call NhlFCreate(wid,'cn12Work',
     +        NhlFCairoWindowWorkstationClass,
     1        0,rlist,ierr) 
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PostScript workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPSFileName','./cn12f.ps',ierr)
         call NhlFCreate(wid,'cn12Work',NhlFPSWorkstationClass,
     1     0,rlist,ierr) 
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPDFFileName','./cn12f.pdf',ierr)
         call NhlFCreate(wid,'cn12Work',NhlFPDFWorkstationClass,
     1     0,rlist,ierr) 
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF object.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkFileName','./cn12f',ierr)
         call NhlFRLSetstring(rlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(wid,'cn12Work',NhlFCairoPSPDFWorkstationClass,
     1     0,rlist,ierr) 
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG object.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkFileName','./cn12f',ierr)
         call NhlFRLSetstring(rlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(wid,'cn12Work',NhlFCairoImageWorkstationClass,
     1     0,rlist,ierr) 
      endif
C
C Call the routine 'gendat' to create an array of contour data.
C Create a ScalarField data object and hand it the data created by
C 'gendat'.
C
      call NhlFRLClear(rlist)
      len_dims(1) = N
      len_dims(2) = M
      call gendat(z,M,M,N,15,15,-10.,110.)
      call NhlFRLSetmdfloatarray(rlist,'sfDataArray',z,2,len_dims,ierr)
      call NhlFRLSetFloat(rlist,'sfXCStartV',-18.,ierr)
      call NhlFRLSetFloat(rlist,'sfXCEndV',52.,ierr)
      call NhlFRLSetFloat(rlist,'sfYCStartV',-35.,ierr)
      call NhlFRLSetFloat(rlist,'sfYCEndV',38.,ierr)
      call NhlFCreate(dataid,'DataPlot',nhlfscalarfieldclass,appid,
     1                rlist,ierr)
C
C Create a ContourPlot object using the above data field, and make sure
C the LabelBar is displayed.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetInteger(rlist,'cnScalarFieldData',dataid,ierr)
      call NhlFCreate(conid,'con1',nhlfcontourplotclass,wid,rlist,ierr)
C
C Create a map object, specifying the areas we want filled and masked.
C     
      call NhlFRLClear(rlist)
      call NhlFRLSetFloat(rlist,'vpXF',0.1,ierr)
      call NhlFRLSetStringArray(rlist,'mpMaskAreaSpecifiers',maskspcs,
     +     50,ierr)
      call NhlFRLSetStringArray(rlist,'mpFillAreaSpecifiers',fillspcs,2,
     +     ierr)
      call NhlFRLSetString(rlist,'pmLabelBarDisplayMode','always',ierr)
      call NhlFCreate(mapid,'map',nhlfmapplotclass,wid,rlist,ierr)

      call NhlFAddOverlay(mapid,conid,-1,ierr)
      call NhlFDraw(mapid,ierr)
      call NhlFFrame(wid,ierr)
C
C Destroy the workstation object and exit.
C
      call NhlFDestroy(wid,ierr)

      call NhlFClose
      stop
      end

      subroutine gendat (data,idim,m,n,mlow,mhgh,dlow,dhgh)
C
C This is a routine to generate test data for two-dimensional graphics
C routines.  Given an array 'DATA', dimensioned 'IDIM x 1', it fills
C the sub-array ((DATA(I,J),I=1,M),J=1,N) with a two-dimensional field
C of data having approximately 'MLOW' lows and 'MHGH' highs, a minimum
C value of exactly 'DLOW' and a maximum value of exactly 'DHGH'.
C
C 'MLOW' and 'MHGH' are each forced to be greater than or equal to 1
C and less than or equal to 25.
C
C The function used is a sum of exponentials.
C
        dimension data(idim,1),ccnt(3,50)

        fovm=9./float(m)
        fovn=9./float(n)

        nlow=max0(1,min0(25,mlow))
        nhgh=max0(1,min0(25,mhgh))
        ncnt=nlow+nhgh

        do 101 k=1,ncnt
          ccnt(1,k)=1.+(float(m)-1.)*fran()
          ccnt(2,k)=1.+(float(n)-1.)*fran()
          if (k.le.nlow) then
            ccnt(3,k)=-1.
          else
            ccnt(3,k)=+1.
          end if
  101   continue

        dmin=+1.e36
        dmax=-1.e36
        do 104 j=1,n
          do 103 i=1,m
            data(i,j)=.5*(dlow+dhgh)
            do 102 k=1,ncnt
              temp=-((fovm*(float(i)-ccnt(1,k)))**2+
     +               (fovn*(float(j)-ccnt(2,k)))**2)
              if (temp.ge.-20.) data(i,j)=data(i,j)+
     +            .5*(dhgh-dlow)*ccnt(3,k)*exp(temp)
  102       continue
            dmin=amin1(dmin,data(i,j))
            dmax=amax1(dmax,data(i,j))
  103     continue
  104   continue

        do 106 j=1,n
          do 105 i=1,m
            data(i,j)=(data(i,j)-dmin)/(dmax-dmin)*(dhgh-dlow)+dlow
  105     continue
  106   continue

        return

      end

      function fran ()
        dimension rseq (100)
        save iseq
        data rseq / .749,.973,.666,.804,.081,.483,.919,.903,.951,.960 ,
     +              .039,.269,.270,.756,.222,.478,.621,.063,.550,.798 ,
     +              .027,.569,.149,.697,.451,.738,.508,.041,.266,.249 ,
     +              .019,.191,.266,.625,.492,.940,.508,.406,.972,.311 ,
     +              .757,.378,.299,.536,.619,.844,.342,.295,.447,.499 ,
     +              .688,.193,.225,.520,.954,.749,.997,.693,.217,.273 ,
     +              .961,.948,.902,.104,.495,.257,.524,.100,.492,.347 ,
     +              .981,.019,.225,.806,.678,.710,.235,.600,.994,.758 ,
     +              .682,.373,.009,.469,.203,.730,.588,.603,.213,.495 ,
     +              .884,.032,.185,.127,.010,.180,.689,.354,.372,.429 /
        data iseq / 0 /
        iseq=mod(iseq,100)+1
        fran=rseq(iseq)
        return
      end

      subroutine bndary
C
C Draw a line showing where the edge of the plotter frame is.
C
        call plotif (0.,0.,0)
        call plotif (1.,0.,1)
        call plotif (1.,1.,1)
        call plotif (0.,1.,1)
        call plotif (0.,0.,1)
        call plotif (0.,0.,2)
C
C Done.
C
        return
C
      end

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C   FFTPACK 5.0
C   Copyright (C) 1995-2004, Scientific Computing Division,
C   University Corporation for Atmospheric Research
C   Licensed under the GNU General Public License (GPL)
C
C   Authors:  Paul N. Swarztrauber and Richard A. Valent
C
C   $Id: msntf1.f,v 1.2 2006-11-21 01:10:18 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      SUBROUTINE DMSNTF1(LOT,JUMP,N,INC,X,WSAVE,DSUM,XH,WORK,IER)
      DOUBLE PRECISION WORK
      DOUBLE PRECISION SSQRT3
      DOUBLE PRECISION XHOLD
      DOUBLE PRECISION T1
      DOUBLE PRECISION T2
      DOUBLE PRECISION SFNP1
      DOUBLE PRECISION X(INC,*),WSAVE(*),XH(LOT,*)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION DSUM(*)

      IER = 0
      LJ = (LOT-1)*JUMP + 1
      IF (N-2) 101,102,103
  102 SSQRT3 = 1.D0/SQRT(3.D0)
      DO 112 M = 1,LJ,JUMP
          XHOLD = SSQRT3* (X(M,1)+X(M,2))
          X(M,2) = SSQRT3* (X(M,1)-X(M,2))
          X(M,1) = XHOLD
  112 CONTINUE
  101 GO TO 200
  103 NP1 = N + 1
      NS2 = N/2
      DO 104 K = 1,NS2
          KC = NP1 - K
          M1 = 0
          DO 114 M = 1,LJ,JUMP
              M1 = M1 + 1
              T1 = X(M,K) - X(M,KC)
              T2 = WSAVE(K)* (X(M,K)+X(M,KC))
              XH(M1,K+1) = T1 + T2
              XH(M1,KC+1) = T2 - T1
  114     CONTINUE
  104 CONTINUE
      MODN = MOD(N,2)
      IF (MODN.EQ.0) GO TO 124
      M1 = 0
      DO 123 M = 1,LJ,JUMP
          M1 = M1 + 1
          XH(M1,NS2+2) = 4.D0*X(M,NS2+1)
  123 CONTINUE
  124 DO 127 M = 1,LOT
          XH(M,1) = 0.D0
  127 CONTINUE
      LNXH = LOT - 1 + LOT* (NP1-1) + 1
      LNSV = NP1 + INT(LOG(DBLE(NP1))) + 4
      LNWK = LOT*NP1
C
      CALL DRFFTMF(LOT,1,NP1,LOT,XH,LNXH,WSAVE(NS2+1),LNSV,WORK,LNWK,
     +            IER1)
      IF (IER1.NE.0) THEN
          IER = 20
          CALL DXERFFT('MSNTF1',-5)
          GO TO 200
      END IF
C
      IF (MOD(NP1,2).NE.0) GO TO 30
      DO 20 M = 1,LOT
          XH(M,NP1) = XH(M,NP1) + XH(M,NP1)
   20 CONTINUE
   30 SFNP1 = 1.D0/DBLE(NP1)
      M1 = 0
      DO 125 M = 1,LJ,JUMP
          M1 = M1 + 1
          X(M,1) = .5D0*XH(M1,1)
          DSUM(M1) = X(M,1)
  125 CONTINUE
      DO 105 I = 3,N,2
          M1 = 0
          DO 115 M = 1,LJ,JUMP
              M1 = M1 + 1
              X(M,I-1) = .5D0*XH(M1,I)
              DSUM(M1) = DSUM(M1) + .5D0*XH(M1,I-1)
              X(M,I) = DSUM(M1)
  115     CONTINUE
  105 CONTINUE
      IF (MODN.NE.0) GO TO 200
      M1 = 0
      DO 116 M = 1,LJ,JUMP
          M1 = M1 + 1
          X(M,N) = .5D0*XH(M1,N+1)
  116 CONTINUE
  200 CONTINUE
      RETURN
      END

c -----------------------------------------------------
C NCLFORTSTART
      SUBROUTINE DRHOMBTRUNC(M,N,AR,AI,R)

C NCL:  ab = rhomb_trunC(ab,R) or procedure:   rhomb_trunc (Ar,Ai,R)

c original code was f90 from Dave Stepaniack
c /home/dataproc/davestep/SPHERE/SUBR_RHOMBOIDAL.f90

C*PL*ERROR* Comment line too long
c Produces rhomboidal truncation R of an MxN array A of spectral coefficients
c (with the restriction that  1 < R < N).

c Example; A is 18x20:
c (Let m represent zonal wavenumber, and n total wavenumber.)

C*PL*ERROR* Comment line too long
c m, n->                                                                         N
c |
c v
C*PL*ERROR* Comment line too long
c   7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7
C*PL*ERROR* Comment line too long
c   7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7
C*PL*ERROR* Comment line too long
c   7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7
C*PL*ERROR* Comment line too long
c   7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7
C*PL*ERROR* Comment line too long
c   7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7
C*PL*ERROR* Comment line too long
c   7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7
C*PL*ERROR* Comment line too long
c   7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7
C*PL*ERROR* Comment line too long
c   7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7
C*PL*ERROR* Comment line too long
c   7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7
C*PL*ERROR* Comment line too long
c   7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7
C*PL*ERROR* Comment line too long
c   7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7
C*PL*ERROR* Comment line too long
c   7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7
C*PL*ERROR* Comment line too long
c   7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7
C*PL*ERROR* Comment line too long
c   7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7
C*PL*ERROR* Comment line too long
c   7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7
C*PL*ERROR* Comment line too long
c   7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7
C*PL*ERROR* Comment line too long
c   7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7
C*PL*ERROR* Comment line too long
c M 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7

c Example; A truncated at R9:

c    1   2   3   4   5   6   7   8   9

C*PL*ERROR* Comment line too long
c   7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0
C*PL*ERROR* Comment line too long
c   0.0 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0
C*PL*ERROR* Comment line too long
c   0.0 0.0 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0
C*PL*ERROR* Comment line too long
c   0.0 0.0 0.0 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0
C*PL*ERROR* Comment line too long
c   0.0 0.0 0.0 0.0 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 0.0 0.0 0.0 0.0 0.0 0.0 0.0
C*PL*ERROR* Comment line too long
c   0.0 0.0 0.0 0.0 0.0 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 0.0 0.0 0.0 0.0 0.0 0.0
C*PL*ERROR* Comment line too long
c   0.0 0.0 0.0 0.0 0.0 0.0 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 0.0 0.0 0.0 0.0 0.0
C*PL*ERROR* Comment line too long
c   0.0 0.0 0.0 0.0 0.0 0.0 0.0 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 0.0 0.0 0.0 0.0
C*PL*ERROR* Comment line too long
c   0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 0.0 0.0 0.0
C*PL*ERROR* Comment line too long
c   0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 0.0 0.0
C*PL*ERROR* Comment line too long
c   0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 0.0
C*PL*ERROR* Comment line too long
c   0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7 7.7
C*PL*ERROR* Comment line too long
c   0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0
C*PL*ERROR* Comment line too long
c   0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0
C*PL*ERROR* Comment line too long
c   0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0
C*PL*ERROR* Comment line too long
c   0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0
C*PL*ERROR* Comment line too long
c   0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0
C*PL*ERROR* Comment line too long
c   0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0

      IMPLICIT NONE

C Extent of zonal wave  number dimension.
      INTEGER M
C Extent of total wave  number dimension.
      INTEGER N
C Rhomboidal truncation parameter. R is the
      INTEGER R
C constant number of total wave numbers to keep.

C Spectral coefficients (real).
      DOUBLE PRECISION AR(M,N)
C Spectral coefficients (real).
      DOUBLE PRECISION AI(M,N)
C NCLEND

C DO loop control variable for zonal wavenumber index.
      INTEGER IM
C Total wavenumber place holder.
      INTEGER JN
C Zonal wavenumber place holder.
      INTEGER KM

C local loop variables
      INTEGER I,J

C Check immediately to determine if R is an element of [1,N]:


C djs
      IF (R.EQ.0) THEN
          WRITE (*,FMT='(''SUB RHOMBOIDAL: R=0 no action taken'')')
          RETURN
      END IF

      IF (.NOT. ((1.LT.R).AND. (R.LT.N))) THEN
c c c IF ( .NOT. ( ( 1 < R )    .AND. ( R < N ) ) ) THEN

          WRITE (*,FMT='(A25,I3,A7,I2)')
     +'R outside of OPEN set (1,
     +',N,'); R = ',R
          WRITE (*,FMT='(A43)')
     +      'Execution stopped in SUBROUTINE DRHOMBOIDAL.'
          RETURN

      END IF

C Now zero out A according to rhomboidal truncation:


      IF (M.GE.N) THEN
c c c IF ( M >= N ) THEN

C Case M greater than or equal to N.


C Loop over zonal wavenumber (i.e. rows).
          DO IM = 1,N - R

              JN = IM

C Zero out above diagonal band of width R.
c c c     A( im, jn+R:N ) = 0.0
              DO J = JN + R,N
                  AR(IM,J) = 0.0D0
                  AI(IM,J) = 0.0D0
              END DO

              KM = IM + 1

C Zero out below diagonal band of width R.
c c c     A( km, 1:jn ) = 0.0
              DO J = 1,JN
                  AR(KM,J) = 0.0D0
                  AI(KM,J) = 0.0D0
              END DO

          END DO

      ELSE IF (M.LT.N) THEN
c c c ELSE IF ( M < N ) THEN

C Case M less than N.


          IM = 0

c c c   DO
          DO WHILE (((IM+R-1).GE.N) .OR. (IM.GT. (M-1)))

              IM = IM + 1
C Loop over zonal wavenumber (i.e. rows).


c c c     IF ( ( (im + R - 1) >= N ) .OR. ( im > (M - 1) ) ) EXIT

              JN = IM

C Zero out above diagonal band of width R.
c c c     A( im, jn+R:N ) = 0.0
              DO J = JN + R,N
                  AR(IM,J) = 0.0D0
                  AI(IM,J) = 0.0D0
              END DO


              KM = IM + 1

C Zero out below diagonal band of width R.
c c c     A( km, 1:jn ) = 0.0
              DO J = 1,JN
                  AR(KM,J) = 0.0D0
                  AI(KM,J) = 0.0D0
              END DO

          END DO

          IF ((JN+R+1).LE.N) THEN
c c c   IF ( (jn+R+1) <= N ) THEN

C Zero out last row ABOVE diagonal.
c c c     A( km, jn+R+1:N ) = 0.0
              DO J = JN + R + 1,N
                  AR(KM,J) = 0.0D0
                  AI(KM,J) = 0.0D0
              END DO

          END IF

      END IF

      IF ((KM+1).LE.M) THEN
c c c IF ( (km + 1) <= M ) THEN
C Zero out any remaining rows (if any).
c c c   A(km+1:M,:) = 0.
          DO I = KM + 1,M
              DO J = 1,N
                  AR(I,J) = 0.0D0
                  AI(I,J) = 0.0D0
              END DO
          END DO
      END IF

      RETURN
      END
c     END SUBROUTINE DRHOMBOIDAL

      SUBROUTINE DTRITRUNC(NLAT2,T,NLAT,A,B)

      IMPLICIT NONE
      INTEGER NLAT,T,NLAT2
      DOUBLE PRECISION A(NLAT,NLAT2),B(NLAT,NLAT2)

      CALL DTRUNC(NLAT2,T,NLAT,A,B)

      RETURN
      END
c ---------------- original interface
      SUBROUTINE DTRUNC(NM,MS,ID,A,B)
      IMPLICIT NONE

      INTEGER NM,MS,ID
      DOUBLE PRECISION A(ID,NM),B(ID,NM)

c c c dimension a(id,1), b(id,1)    .... old fortran

C     Triangular truncation:
C     "Truncates spectral coefficients so that aliasing does not
C     occur when computing the spectral representation of the product
C     terms."
C     Taken from page 54 of Adams, John C., and Paul N. Swarztrauber,
C     1997: Spherepack 2.0: A model development facility. NCAR Technical
C     Note NCAR/TN-436-STR, 62 pp.

c     D Shea made some cosmetic changes

      INTEGER MP,N,M

      MP = MS + 2
      DO N = MP,NM
          DO M = 1,N
              A(M,N) = 0.D0
              B(M,N) = 0.D0
          END DO
      END DO

      RETURN
      END

C
C $Id: line3.f,v 1.6 2008-07-27 00:17:33 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE LINE3 (UA,VA,WA,UB,VB,WB)
      CALL TRN32T (UA,VA,WA,XA,YA,XDUM,2)
      CALL TRN32T (UB,VB,WB,XB,YB,XDUM,2)
      IIX = 32*INT(XB)
      IIY = 32*INT(YB)
      CALL PLOTIT (32*INT(XA),32*INT(YA),0)
      CALL PLOTIT (IIX,IIY,1)
C
C FLUSH PLOTIT BUFFER
C
      CALL PLOTIT (0,0,0)
      RETURN
      END

      SUBROUTINE DSMTH9(X,WRK,NI,NJ,P,Q,XMSG,LWRAP,IER)
      DOUBLE PRECISION PO4
      DOUBLE PRECISION QO4
      DOUBLE PRECISION TERM1
      DOUBLE PRECISION TERM2

      LOGICAL LWRAP
      INTEGER NI,NJ,IER
      DOUBLE PRECISION X(NI,NJ),WRK(NI,NJ),P,Q,XMSG
c***********************************************************************
c modified j. olson routine
c***********************************************************************
c
c this routine does 9-point smoothing using the equation:
c
c   f0 = f0 + (p/4)*(f2+f4+f6+f8-4*f0) + (q/4)*(f1+f3+f5+f7-4*f0)
c
c  where the grid is:
c
c      1-------------8---------------7
c      |             |               |
c      |             |               |
c      |             |               |
c      |             |               |
c      2-------------0---------------6
c      |             |               |
c      |             |               |
c      |             |               |
c      |             |               |
c      3-------------4---------------5
c
c   arguments :
c .
c .   x        - 2-d input/output array
c .   wrk      - 2-d work array
c .   ni       - dimension
c .   nj       - dimension
c .   p        - first  weight (suggested value of  0.50)
c .   q        - second weight (suggested value of  0.25)
c .   xmsg     - value of missing points
c .   lwrap    - logical flag to include wraparound points in smoothing
c .              if lwrap = .true. , smooth left and right endpoints
c .              if lwrap = .false., no smoothing
c .
c  notes:
c
c       1)  if a point or any of its neighbors is missing, the point is
c           not smoothed
c       2)  this routine does not smooth the edges, just the interior
C*PL*ERROR* Comment line too long
c           with the exception that the left and right edges are smoothed
c           when "lwrap" is true.
c       3)  array has to have at least 3 points in each direction
c       4)  smoothed results are returned via the original input array
c
c***********************************************************************

c determine if size of array is sufficient

      IER = 0
      IF (NI.LT.3 .OR. NJ.LT.3) THEN
          IER = 1
          WRITE (*,FMT='(/,'' sub smth9: error'',2i5)') NI,NJ
          RETURN
      END IF

      PO4 = P/4.D0
      QO4 = Q/4.D0

c set the wrk array to msg

      DO I = 1,NI
          DO J = 1,NJ
              WRK(I,J) = XMSG
          END DO
      END DO

c are endpoints to be smoothed?

      IF (LWRAP) THEN
          NIB = 1
          NIE = NI
      ELSE
          NIB = 2
          NIE = NI - 1
      END IF
      NJB = 2
      NJE = NJ - 1

c  smooth

      DO J = NJB,NJE
          DO I = NIB,NIE
              JM1 = J - 1
              JP1 = J + 1
              IM1 = I - 1
              IP1 = I + 1
              IF (IM1.LT.1) IM1 = NI
              IF (IP1.GT.NI) IP1 = 1

              IF (X(I,J).EQ.XMSG .OR. X(IM1,JP1).EQ.XMSG .OR.
     +            X(IM1,J).EQ.XMSG .OR. X(IM1,JM1).EQ.XMSG .OR.
     +            X(I,JM1).EQ.XMSG .OR. X(IP1,JM1).EQ.XMSG .OR.
     +            X(IP1,J).EQ.XMSG .OR. X(IP1,JP1).EQ.XMSG .OR.
     +            X(I,JP1).EQ.XMSG) THEN
C original (unsmoothed) value
                  WRK(I,J) = X(I,J)
              ELSE
                  TERM1 = PO4* (X(IM1,J)+X(I,JM1)+X(IP1,J)+X(I,JP1)-
     +                    4.D0*X(I,J))
                  TERM2 = QO4* (X(IM1,JP1)+X(IM1,JM1)+X(IP1,JM1)+
     +                    X(IP1,JP1)-4.D0*X(I,J))
                  WRK(I,J) = X(I,J) + TERM1 + TERM2
              END IF
          END DO
      END DO

c transfer back to original array

      DO J = NJB,NJE
          DO I = NIB,NIE
              X(I,J) = WRK(I,J)
          END DO
      END DO

      RETURN
      END

C NCLFORTSTART
        subroutine wetbulbprofs(npts,t,td,p,twb,tmsg,tdmsg,pmsg,ier)
        implicit none
c                                      INPUT
        integer ier, npts
        double precision t(npts) 
        double precision td(npts) 
        double precision p(npts) 
        double precision tmsg, tdmsg, pmsg
c                                      OUTPUT
        double precision twb(npts) 
c NCLEND
c                                      LOCAL
        integer n
        external twbprofs
        double precision twbprofs

c       g.s. stipanuk     1973            original version.
c       reference stipanuk paper entitled:
c            "algorithms for generating a skew-t, log p
c            diagram and computing selected meteorological quantities."
c            atmospheric sciences laboratory
c            u.s. army electronics command
c            white sands missile range, new mexico 88002 : 33 pages
c       baker, schlatter  17-may-1982   

c PROFS: Program for Regional Observing and Forecasting Services (NOAA)

        do n=1,npts
           if (t(n).ne.tmsg.and.td(n).ne.tdmsg.and.p(n).ne.pmsg) then
               twb(n) = twbprofs(t(n),td(n),p(n))
           else
               twb(n) = tmsg
           end if
        end do

c Note: ier isn't used for anything yet, so set to 0 here.
        ier = 0
        return
        end
c---
        double precision function twbprofs(t,td,p)
        implicit none
c                                      INPUT
        double precision t 
        double precision td 
        double precision p 
c                                      LOCAL 
        integer i
        double precision aw, ao, pi, x, ti, aos, eps

        external          wxprofs, oxprofs, tmrprofs, tmaprofs, tdaprofs
     +                 ,  osprofs, tsaprofs
        double precision  wxprofs, oxprofs , tmrprofs, tmaprofs,tdaprofs
     +                 ,  osprofs, tsaprofs

c   this function returns the wet-bulb temperature tw (celsius)
c   given the temperature t (celsius), dew point td (celsius)
c   and pressure p (mb).  see p.13 in stipanuk (1973), referenced
c   above, for a description of the technique.
c
c   determine the mixing ratio line thru td and p.

        aw = wxprofs(td,p)
c
c   determine the dry adiabat thru t and p.

        ao = oxprofs(t,p)     

c   iterate to locate pressure pi at the intersection of the two
c   curves .  pi has been set to p for the initial guess.

        eps = 0.01d0
        pi  = p
        do i= 1,10
           x= 0.02d0*(tmrprofs(aw,pi)-tdaprofs(ao,pi))
           if (abs(x).lt.eps) exit    
           pi= pi*(2**(x))
        end do

c   find the temperature on the dry adiabat ao at pressure pi.

        ti = tdaprofs(ao,pi)

c   the intersection has been located...now, find a saturation
c   adiabat thru this point. function os returns the equivalent
c   potential temperature (c) of a parcel saturated at temperature
c   ti and pressure pi.

        aos = osprofs(ti,pi)

c   function tsa returns the wet-bulb temperature (c) of a parcel at
c   pressure p whose equivalent potential temperature is aos.

        twbprofs = tsaprofs(aos,p)

        return
        end
c ---------------------------------------------------------------------

        double precision function oxprofs(t,p)
        implicit none
c                                      INPUT
        double precision t, p
c                                      LOCAL
        double precision  tk 

c   this function returns potential temperature (celsius) given
c   temperature t (celsius) and pressure p (mb) by solving the poisson
c   equation.

        tk = t  + 273.15d0
        oxprofs = tk*((1000d0/p)**0.286) - 273.15d0

        return
        end
c ---------------------------------------------------------------------

        double precision function wxprofs(t,p)
        implicit none
c                                      INPUT
        double precision t, p
c                                      LOCAL
        double precision x

        external esatprofs
        double precision esatprofs

c  this function returns the mixing ratio (grams of water vapor per
c  kilogram of dry air) given the dew point (celsius) and pressure
c  (millibars). if the temperture  is input instead of the
c  dew point, then saturation mixing ratio (same units) is returned.
c  the formula is found in most meteorological texts.

        x       = esatprofs(t)
        wxprofs = 622d0*x/(p-x)

        return
        end
c ---------------------------------------------------------------------

        double precision function esatprofs(t)
        implicit none
c                                      INPUT
        double precision t

c   this function returns the saturation vapor pressure over
c   water (mb) given the temperature (celsius).
c   the algorithm is due to nordquist, w.s.,1973: "numerical approxima-
c   tions of selected meteorlolgical parameters for cloud physics prob-
c   lems," ecom-5475, atmospheric sciences laboratory, u.s. army
c   electronics command, white sands missile range, new mexico 88002.

c                                      LOCAL
        double precision tk, p1, p2, c1

        tk = t+273.15d0
        p1 = 11.344d0-0.0303998d0*tk
        p2 = 3.49149d0-1302.8844d0/tk
        c1 = 23.832241d0-5.02808d0*log10(tk)

        esatprofs = 10.**(c1-1.3816d-7*10.**p1
     +                      +8.1328d-3*10.**p2-2949.076d0/tk)

        return
        end
c ---------------------------------------------------------------------
        double precision function tsaprofs(os,p)
        implicit none
c                                      INPUT
        double precision os, p

c   this function returns the temperature tsa (celsius) on a saturation
c   adiabat at pressure p (millibars). os is the equivalent potential
c   temperature of the parcel (celsius). sign(a,b) replaces the
c   algebraic sign of a with that of b.
c   b is an empirical constant approximately equal to 0.001 of the 
c   latent heat of vaporization for water divided by the specific heat
c   at constant pressure for dry air.
c                                      LOCAL
        integer i
        double precision a, b, d, tq, tqk, x, eps 
        data b/2.6518986d0/
       
        external wxprofs
        double precision wxprofs

        a  = os+273.15d0

c   tq is the first guess for tsa.

        tq = 253.15d0

c   d is an initial value used in the iteration below.

        d = 120d0

c   iterate to obtain sufficient accuracy....see table 1, p.8
c   of stipanuk (1973) for equation used in iteration.

        eps = 1d-1
        do 1 i= 1,12
           tqk = tq-273.15d0
           d   = d/2d0
           x   = a*exp(-b*wxprofs(tqk,p)/tq)-tq*((1000d0/p)**.286)
           if (abs(x).lt.eps) go to 2
           tq  = tq+sign(d,x)
 1      continue

 2      tsaprofs= tq-273.15d0

        return
        end
c -------------------------------------------------------------------

        double precision function tdaprofs(o,p)
        implicit none
c                                      INPUT
        double precision o, p
c                                      LOCAL
        double precision ok, tdak
 
c   this function returns the temperature tda (celsius) on a dry adiabat
c   at pressure p (millibars). the dry adiabat is given by
c   potential temperature o (celsius). the computation is based on
c   poisson's equation.
 
        ok       = o+273.15d0
        tdak     = ok*((p*0.001d0)**0.286)
        tdaprofs = tdak-273.15d0

        return
        end

c -------------------------------------------------------------------

        double precision function osprofs(t,p)
        implicit none
c                                      INPUT
        double precision t, p

c   this function returns the equivalent potential temperature os
c   (celsius) for a parcel of air saturated at temperature t (celsius)
c   and pressure p (millibars).

c                                      LOCAL
c   b is an empirical constant approximately equal to the latent heat
c   of vaporization for water divided by the specific heat at constant
c   pressure for dry air.

        double precision b, tk, osk
        data b/2.6518986d0/

        external wxprofs
        double precision wxprofs

        tk      = t+273.15d0
        osk     = tk*((1000d0/p)**.286)*(exp(b*wxprofs(t,p)/tk))
        osprofs = osk-273.15d0

        return
        end
c ---------------------------------------------------------------------
 
        double precision function tmrprofs(w,p)
        implicit none
c                                      INPUT
        double precision w, p
c                                      LOCAL
        double precision c1, c2, c3, c4, c5, c6, x, tmrk
 
c   this function returns the temperature (celsius) on a mixing
c   ratio line w (g/kg) at pressure p (mb). the formula is given in
c   table 1 on page 7 of stipanuk (1973).
c
c   initialize constants
 
        data c1/.0498646455/,c2/2.4082965/,c3/7.07475/
        data c4/38.9114/,c5/.0915/,c6/1.2035/
 
        x    = log10(w*p/(622d0+w))
        tmrk = 10.**(c1*x+c2)-c3+c4*((10.**(c5*x)-c6)**2.)
        tmrprofs = tmrk-273.15d0

        return
        end

c --------------------------------------------------------------
C input
      SUBROUTINE DINDX77(X,Y,NMOS,NYRS,XMSG,IPRNT,WORK,LWORK,ZI,ZNI,IER)

c routine to call indx77x which actually does the calculations
c .   this is just a short calling list
c NOTE: indx77x can also be called directly
c .   DSJ: this is a variant of index routines

C number of "months" (eg: 12, 4, 1)
C number of years of data
C print flag (=0 mean do not print)
C length of work (>= 2*nmos*nyrs + 4*nmos + nyrs)
C error code
      INTEGER NMOS,NYRS,IPRNT,LWORK,IER

C monthly data from station/grid pt 1
C monthly data from station/grid pt 2
C missing code (if any)
C index
C noise index
C work array that will be partitioned
      DOUBLE PRECISION X(NMOS,NYRS),Y(NMOS,NYRS),XMSG,ZI(NMOS,NYRS),
     +                 ZNI(NMOS,NYRS),WORK(LWORK)

C local

C overall st dev of x anomalies
C overall st dev of y anomalies
      DOUBLE PRECISION XASTD,YASTD


      IER = 0
      IF (NMOS.LE.0 .OR. NYRS.LE.0) IER = IER + 1
      IF (LWORK.LT. (2*NMOS*NYRS+4*NMOS+NYRS)) IER = 19

c Check if either input arrays contains all missing values.
      IXMISS = 1
      IYMISS = 1
      DO NYR = 1,NYRS
          DO NMO = 1,NMOS
              IF (X(NMO,NYR).NE.XMSG) THEN
                  IXMISS = 0
              END IF
              IF (Y(NMO,NYR).NE.XMSG) THEN
                  IYMISS = 0
              END IF
          END DO
      END DO
      IF (IXMISS.EQ.1 .OR. IYMISS.EQ.1) THEN
          IER = 2
          RETURN
      END IF

      IF (IER.NE.0) THEN
          DO NYR = 1,NYRS
              DO NMO = 1,NMOS
                  ZI(NMO,NYR) = XMSG
                  ZNI(NMO,NYR) = XMSG
              END DO
          END DO

          RETURN
      END IF

C set up pointers (addresses in work array)

C beginning of "xa"   (see indx77x)
      I1 = 1
C beginning of "ya"   (see indx77x)
      I2 = I1 + NMOS*NYRS
C beginning of "xave" (see indx77x)
      I3 = I2 + NMOS*NYRS
C beginning of "yave" (see indx77x)
      I4 = I3 + NMOS
C beginning of "xstd" (see indx77x)
      I5 = I4 + NMOS
C beginning of "ystd" (see indx77x)
      I6 = I5 + NMOS
C beginning of "wyrs" (see indx77x)
      I7 = I6 + NMOS

C input
C input
C input
C output
      CALL DINDX77X(X,Y,NMOS,NYRS,XMSG,IPRNT,WORK(I1),WORK(I2),WORK(I3),
     +              WORK(I4),WORK(I5),WORK(I6),WORK(I7),XASTD,YASTD,ZI,
     +              ZNI,IER)

      RETURN
      END
c -----------------------------------------------------------
C input
C input/output
C output
      SUBROUTINE DINDX77X(X,Y,NMOS,NYRS,XMSG,IPRNT,XA,YA,XAVE,YAVE,XSTD,
     +                    YSTD,WYRS,XASTD,YASTD,ZI,ZNI,IER)
      DOUBLE PRECISION XVAR
      DOUBLE PRECISION YVAR
      DOUBLE PRECISION XABAR
      DOUBLE PRECISION XAVAR
      DOUBLE PRECISION YABAR
      DOUBLE PRECISION YAVAR

c This is the most commonly used routine.

c given two series of year-month values (eg: slp) calculate
c .  an "index" (eg: Southern Oscillation Index)
c .  the way Kevin Trenberth suggests doing it.
c .  This means using the overall anomaly standard deviation
c .  to normalize the anomalies.

c index is computed as zi = x/sigma(x) - y/sigma(y) (normalized stuff)

c Trenberth (1984), "Signal versus Noise in the Southern Oscillation"
c .  Monthly Weather Review 112:326-332

c code written for clarity

C number of "months" (eg: 12, 4, 1)
C number of years of data
C print flag (=0 means do not print)
C error code
      INTEGER NMOS,NYRS,IPRNT,IER

C monthly data from station/grid pt 1
C monthly data from station/grid pt 2
C missing code (if any)
C index
C noise index
      DOUBLE PRECISION X(NMOS,NYRS),Y(NMOS,NYRS),XMSG,ZI(NMOS,NYRS),
     +                 ZNI(NMOS,NYRS)

C upon exit the following will contain

C monthly anomalies from average
C monthly averages
C monthly st dev (interannual variability)
C work array
C overall st dev of xa anomalies
C overall st dev of ya anomalies
      DOUBLE PRECISION XA(NMOS,NYRS),YA(NMOS,NYRS),XAVE(NMOS),
     +                 YAVE(NMOS),XSTD(NMOS),YSTD(NMOS),WYRS(NYRS),
     +                 XASTD,YASTD

      IER = 0
      IF (NMOS.LE.0 .OR. NYRS.LE.0) IER = IER + 1
      IF (IER.NE.0) RETURN

c initilize index to msg values

      DO NYR = 1,NYRS
          DO NMO = 1,NMOS
              ZI(NMO,NYR) = XMSG
              ZNI(NMO,NYR) = XMSG
          END DO
      END DO

c calculate each months long-term mean and standard deviation
c .   (long-term <==> climatological)

      DO NMO = 1,NMOS
          DO NYR = 1,NYRS
              WYRS(NYR) = X(NMO,NYR)
          END DO
          CALL DSTAT2(WYRS,NYRS,XMSG,XAVE(NMO),XVAR,XSTD(NMO),KNTX,IER)

          DO NYR = 1,NYRS
              WYRS(NYR) = Y(NMO,NYR)
          END DO
          CALL DSTAT2(WYRS,NYRS,XMSG,YAVE(NMO),YVAR,YSTD(NMO),KNTY,IER)
      END DO

c calculate anomalies from climatogical mean

      DO NYR = 1,NYRS
          DO NMO = 1,NMOS
              IF (X(NMO,NYR).NE.XMSG .AND. XAVE(NMO).NE.XMSG) THEN
                  XA(NMO,NYR) = X(NMO,NYR) - XAVE(NMO)
              ELSE
                  XA(NMO,NYR) = XMSG
              END IF
              IF (Y(NMO,NYR).NE.XMSG .AND. YAVE(NMO).NE.XMSG) THEN
                  YA(NMO,NYR) = Y(NMO,NYR) - YAVE(NMO)
              ELSE
                  YA(NMO,NYR) = XMSG
              END IF
          END DO
      END DO

c calculate the overall standard deviation of the anomalies
c .   (ie: use anomalies from all year-months together)

      CALL DSTAT2(XA,NMOS*NYRS,XMSG,XABAR,XAVAR,XASTD,KNTXA,IER)
      CALL DSTAT2(YA,NMOS*NYRS,XMSG,YABAR,YAVAR,YASTD,KNTYA,IER)

c calculate each index

      IF (XASTD.NE.XMSG .AND. XASTD.GT.0.0D0 .AND. YASTD.NE.XMSG .AND.
     +    YASTD.GT.0.0D0) THEN
          DO NYR = 1,NYRS
              DO NMO = 1,NMOS
                  IF (XA(NMO,NYR).NE.XMSG .AND.
     +                YA(NMO,NYR).NE.XMSG) THEN
                      ZI(NMO,NYR) = XA(NMO,NYR)/XASTD -
     +                              YA(NMO,NYR)/YASTD
                      ZNI(NMO,NYR) = XA(NMO,NYR)/XASTD +
     +                               YA(NMO,NYR)/YASTD
                  END IF
              END DO
          END DO
      ELSE
          IER = IER + 10
      END IF

      IF (IPRNT.NE.0) THEN
          DO NYR = 1,NYRS
              WRITE (*,FMT='('' SINDEX: '',i4,12(1x,f7.1))') NYR,
     +          (ZI(NMO,NYR),NMO=1,NMOS)
          END DO
          IF (IPRNT.LT.0) THEN
              DO NYR = 1,NYRS
                  WRITE (*,FMT='('' NINDEX: '',i4,12(1x,f7.1))') NYR,
     +              (ZNI(NMO,NYR),NMO=1,NMOS)
              END DO
          END IF
      END IF

      RETURN
      END

      SUBROUTINE SSYMM ( SIDE, UPLO, M, N, ALPHA, A, LDA, B, LDB,
     $                   BETA, C, LDC )
*     .. Scalar Arguments ..
      CHARACTER*1        SIDE, UPLO
      INTEGER            M, N, LDA, LDB, LDC
      REAL               ALPHA, BETA
*     .. Array Arguments ..
      REAL               A( LDA, * ), B( LDB, * ), C( LDC, * )
*     ..
*
*  Purpose
*  =======
*
*  SSYMM  performs one of the matrix-matrix operations
*
*     C := alpha*A*B + beta*C,
*
*  or
*
*     C := alpha*B*A + beta*C,
*
*  where alpha and beta are scalars,  A is a symmetric matrix and  B and
*  C are  m by n matrices.
*
*  Parameters
*  ==========
*
*  SIDE   - CHARACTER*1.
*           On entry,  SIDE  specifies whether  the  symmetric matrix  A
*           appears on the  left or right  in the  operation as follows:
*
*              SIDE = 'L' or 'l'   C := alpha*A*B + beta*C,
*
*              SIDE = 'R' or 'r'   C := alpha*B*A + beta*C,
*
*           Unchanged on exit.
*
*  UPLO   - CHARACTER*1.
*           On  entry,   UPLO  specifies  whether  the  upper  or  lower
*           triangular  part  of  the  symmetric  matrix   A  is  to  be
*           referenced as follows:
*
*              UPLO = 'U' or 'u'   Only the upper triangular part of the
*                                  symmetric matrix is to be referenced.
*
*              UPLO = 'L' or 'l'   Only the lower triangular part of the
*                                  symmetric matrix is to be referenced.
*
*           Unchanged on exit.
*
*  M      - INTEGER.
*           On entry,  M  specifies the number of rows of the matrix  C.
*           M  must be at least zero.
*           Unchanged on exit.
*
*  N      - INTEGER.
*           On entry, N specifies the number of columns of the matrix C.
*           N  must be at least zero.
*           Unchanged on exit.
*
*  ALPHA  - REAL            .
*           On entry, ALPHA specifies the scalar alpha.
*           Unchanged on exit.
*
*  A      - REAL             array of DIMENSION ( LDA, ka ), where ka is
*           m  when  SIDE = 'L' or 'l'  and is  n otherwise.
*           Before entry  with  SIDE = 'L' or 'l',  the  m by m  part of
*           the array  A  must contain the  symmetric matrix,  such that
*           when  UPLO = 'U' or 'u', the leading m by m upper triangular
*           part of the array  A  must contain the upper triangular part
*           of the  symmetric matrix and the  strictly  lower triangular
*           part of  A  is not referenced,  and when  UPLO = 'L' or 'l',
*           the leading  m by m  lower triangular part  of the  array  A
*           must  contain  the  lower triangular part  of the  symmetric
*           matrix and the  strictly upper triangular part of  A  is not
*           referenced.
*           Before entry  with  SIDE = 'R' or 'r',  the  n by n  part of
*           the array  A  must contain the  symmetric matrix,  such that
*           when  UPLO = 'U' or 'u', the leading n by n upper triangular
*           part of the array  A  must contain the upper triangular part
*           of the  symmetric matrix and the  strictly  lower triangular
*           part of  A  is not referenced,  and when  UPLO = 'L' or 'l',
*           the leading  n by n  lower triangular part  of the  array  A
*           must  contain  the  lower triangular part  of the  symmetric
*           matrix and the  strictly upper triangular part of  A  is not
*           referenced.
*           Unchanged on exit.
*
*  LDA    - INTEGER.
*           On entry, LDA specifies the first dimension of A as declared
*           in the calling (sub) program.  When  SIDE = 'L' or 'l'  then
*           LDA must be at least  max( 1, m ), otherwise  LDA must be at
*           least  max( 1, n ).
*           Unchanged on exit.
*
*  B      - REAL             array of DIMENSION ( LDB, n ).
*           Before entry, the leading  m by n part of the array  B  must
*           contain the matrix B.
*           Unchanged on exit.
*
*  LDB    - INTEGER.
*           On entry, LDB specifies the first dimension of B as declared
*           in  the  calling  (sub)  program.   LDB  must  be  at  least
*           max( 1, m ).
*           Unchanged on exit.
*
*  BETA   - REAL            .
*           On entry,  BETA  specifies the scalar  beta.  When  BETA  is
*           supplied as zero then C need not be set on input.
*           Unchanged on exit.
*
*  C      - REAL             array of DIMENSION ( LDC, n ).
*           Before entry, the leading  m by n  part of the array  C must
*           contain the matrix  C,  except when  beta  is zero, in which
*           case C need not be set on entry.
*           On exit, the array  C  is overwritten by the  m by n updated
*           matrix.
*
*  LDC    - INTEGER.
*           On entry, LDC specifies the first dimension of C as declared
*           in  the  calling  (sub)  program.   LDC  must  be  at  least
*           max( 1, m ).
*           Unchanged on exit.
*
*
*  Level 3 Blas routine.
*
*  -- Written on 8-February-1989.
*     Jack Dongarra, Argonne National Laboratory.
*     Iain Duff, AERE Harwell.
*     Jeremy Du Croz, Numerical Algorithms Group Ltd.
*     Sven Hammarling, Numerical Algorithms Group Ltd.
*
*
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     .. External Subroutines ..
      EXTERNAL           XERBLA
*     .. Intrinsic Functions ..
      INTRINSIC          MAX
*     .. Local Scalars ..
      LOGICAL            UPPER
      INTEGER            I, INFO, J, K, NROWA
      REAL               TEMP1, TEMP2
*     .. Parameters ..
      REAL               ONE         , ZERO
      PARAMETER        ( ONE = 1.0E+0, ZERO = 0.0E+0 )
*     ..
*     .. Executable Statements ..
*
*     Set NROWA as the number of rows of A.
*
      IF( LSAME( SIDE, 'L' ) )THEN
         NROWA = M
      ELSE
         NROWA = N
      END IF
      UPPER = LSAME( UPLO, 'U' )
*
*     Test the input parameters.
*
      INFO = 0
      IF(      ( .NOT.LSAME( SIDE, 'L' ) ).AND.
     $         ( .NOT.LSAME( SIDE, 'R' ) )      )THEN
         INFO = 1
      ELSE IF( ( .NOT.UPPER              ).AND.
     $         ( .NOT.LSAME( UPLO, 'L' ) )      )THEN
         INFO = 2
      ELSE IF( M  .LT.0               )THEN
         INFO = 3
      ELSE IF( N  .LT.0               )THEN
         INFO = 4
      ELSE IF( LDA.LT.MAX( 1, NROWA ) )THEN
         INFO = 7
      ELSE IF( LDB.LT.MAX( 1, M     ) )THEN
         INFO = 9
      ELSE IF( LDC.LT.MAX( 1, M     ) )THEN
         INFO = 12
      END IF
      IF( INFO.NE.0 )THEN
         CALL XERBLA( 'SSYMM ', INFO )
         RETURN
      END IF
*
*     Quick return if possible.
*
      IF( ( M.EQ.0 ).OR.( N.EQ.0 ).OR.
     $    ( ( ALPHA.EQ.ZERO ).AND.( BETA.EQ.ONE ) ) )
     $   RETURN
*
*     And when  alpha.eq.zero.
*
      IF( ALPHA.EQ.ZERO )THEN
         IF( BETA.EQ.ZERO )THEN
            DO 20, J = 1, N
               DO 10, I = 1, M
                  C( I, J ) = ZERO
   10          CONTINUE
   20       CONTINUE
         ELSE
            DO 40, J = 1, N
               DO 30, I = 1, M
                  C( I, J ) = BETA*C( I, J )
   30          CONTINUE
   40       CONTINUE
         END IF
         RETURN
      END IF
*
*     Start the operations.
*
      IF( LSAME( SIDE, 'L' ) )THEN
*
*        Form  C := alpha*A*B + beta*C.
*
         IF( UPPER )THEN
            DO 70, J = 1, N
               DO 60, I = 1, M
                  TEMP1 = ALPHA*B( I, J )
                  TEMP2 = ZERO
                  DO 50, K = 1, I - 1
                     C( K, J ) = C( K, J ) + TEMP1    *A( K, I )
                     TEMP2     = TEMP2     + B( K, J )*A( K, I )
   50             CONTINUE
                  IF( BETA.EQ.ZERO )THEN
                     C( I, J ) = TEMP1*A( I, I ) + ALPHA*TEMP2
                  ELSE
                     C( I, J ) = BETA *C( I, J ) +
     $                           TEMP1*A( I, I ) + ALPHA*TEMP2
                  END IF
   60          CONTINUE
   70       CONTINUE
         ELSE
            DO 100, J = 1, N
               DO 90, I = M, 1, -1
                  TEMP1 = ALPHA*B( I, J )
                  TEMP2 = ZERO
                  DO 80, K = I + 1, M
                     C( K, J ) = C( K, J ) + TEMP1    *A( K, I )
                     TEMP2     = TEMP2     + B( K, J )*A( K, I )
   80             CONTINUE
                  IF( BETA.EQ.ZERO )THEN
                     C( I, J ) = TEMP1*A( I, I ) + ALPHA*TEMP2
                  ELSE
                     C( I, J ) = BETA *C( I, J ) +
     $                           TEMP1*A( I, I ) + ALPHA*TEMP2
                  END IF
   90          CONTINUE
  100       CONTINUE
         END IF
      ELSE
*
*        Form  C := alpha*B*A + beta*C.
*
         DO 170, J = 1, N
            TEMP1 = ALPHA*A( J, J )
            IF( BETA.EQ.ZERO )THEN
               DO 110, I = 1, M
                  C( I, J ) = TEMP1*B( I, J )
  110          CONTINUE
            ELSE
               DO 120, I = 1, M
                  C( I, J ) = BETA*C( I, J ) + TEMP1*B( I, J )
  120          CONTINUE
            END IF
            DO 140, K = 1, J - 1
               IF( UPPER )THEN
                  TEMP1 = ALPHA*A( K, J )
               ELSE
                  TEMP1 = ALPHA*A( J, K )
               END IF
               DO 130, I = 1, M
                  C( I, J ) = C( I, J ) + TEMP1*B( I, K )
  130          CONTINUE
  140       CONTINUE
            DO 160, K = J + 1, N
               IF( UPPER )THEN
                  TEMP1 = ALPHA*A( J, K )
               ELSE
                  TEMP1 = ALPHA*A( K, J )
               END IF
               DO 150, I = 1, M
                  C( I, J ) = C( I, J ) + TEMP1*B( I, K )
  150          CONTINUE
  160       CONTINUE
  170    CONTINUE
      END IF
*
      RETURN
*
*     End of SSYMM .
*
      END

c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by UCAR                 .
c  .                                                             .
c  .       University Corporation for Atmospheric Research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                         SPHEREPACK                          .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c
c
c ... file vrtgc.f
c
c     this file includes documentation and code for
c     subroutine divec          i
c
c ... files which must be loaded with vrtgc.f
c
c     sphcom.f, hrfft.f, vhagc.f, shsgc.f, gaqd.f
c
c     subroutine vrtgc(nlat,nlon,isym,nt,vort,ivrt,jvrt,cr,ci,mdc,ndc,
c    +                 wshsgc,lshsgc,work,lwork,ierror)
c
C*PL*ERROR* Comment line too long
c     given the vector spherical harmonic coefficients cr and ci, precomputed
c     by subroutine vhagc for a vector field (v,w), subroutine vrtgc
c     computes the vorticity of the vector field in the scalar array
c     vort.  vort(i,j) is the vorticity at the gaussian colatitude
c     theta(i) (see nlat as input parameter) and longitude
c     lambda(j) = (j-1)*2*pi/nlon on the sphere.  i.e.,
c
c            vort(i,j) =  [-dv/dlambda + d(sint*w)/dtheta]/sint
c
c     where sint = sin(theta(i)).  w is the east longitudinal and v
c     is the colatitudinal component of the vector field from which
c     cr,ci were precomputed.  required associated legendre polynomials
c     are recomputed rather than stored as they are in subroutine vrtgs.
c
c
c     input parameters
c
c     nlat   the number of points in the gaussian colatitude grid on the
C*PL*ERROR* Comment line too long
c            full sphere. these lie in the interval (0,pi) and are computed
C*PL*ERROR* Comment line too long
c            in radians in theta(1) <...< theta(nlat) by subroutine gaqd.
C*PL*ERROR* Comment line too long
c            if nlat is odd the equator will be included as the grid point
c            theta((nlat+1)/2).  if nlat is even the equator will be
c            excluded as a grid point and will lie half way between
c            theta(nlat/2) and theta(nlat/2+1). nlat must be at least 3.
c            note: on the half sphere, the number of grid points in the
c            colatitudinal direction is nlat/2 if nlat is even or
c            (nlat+1)/2 if nlat is odd.
c
c     nlon   the number of distinct londitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater
c            than 3. the axisymmetric case corresponds to nlon=1.
c            the efficiency of the computation is improved when nlon
c            is a product of small prime numbers.
c
c
c     isym   a parameter which determines whether the vorticity is
c            computed on the full or half sphere as follows:
c
c      = 0
c            the symmetries/antsymmetries described in isym=1,2 below
c            do not exist in (v,w) about the equator.  in this case the
c            vorticity is neither symmetric nor antisymmetric about
c            the equator.  the vorticity is computed on the entire
c            sphere.  i.e., in the array vort(i,j) for i=1,...,nlat and
c            j=1,...,nlon.
c
c      = 1
c            w is antisymmetric and v is symmetric about the equator.
c            in this case the vorticity is symmetyric about the
c            equator and is computed for the northern hemisphere
c            only.  i.e., if nlat is odd the vorticity is computed
c            in the array vort(i,j) for i=1,...,(nlat+1)/2 and for
c            j=1,...,nlon.  if nlat is even the vorticity is computed
c            in the array vort(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
c
c      = 2
c            w is symmetric and v is antisymmetric about the equator
c            in this case the vorticity is antisymmetric about the
c            equator and is computed for the northern hemisphere
c            only.  i.e., if nlat is odd the vorticity is computed
c            in the array vort(i,j) for i=1,...,(nlat+1)/2 and for
c            j=1,...,nlon.  if nlat is even the vorticity is computed
c            in the array vort(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
c
c
c      nt    nt is the number of scalar and vector fields.  some
c            computational efficiency is obtained for multiple fields.
c            in the program that calls vrtgc, the arrays cr,ci, and vort
C*PL*ERROR* Comment line too long
c            can be three dimensional corresponding to an indexed multiple
c            vector field.  in this case multiple scalar synthesis will
c            be performed to compute the vorticity for each field.  the
c            third index is the synthesis index which assumes the values
c            k=1,...,nt.  for a single synthesis set nt = 1.  the
c            description of the remaining parameters is simplified by
C*PL*ERROR* Comment line too long
c            assuming that nt=1 or that all the arrays are two dimensional.
c
c     ivrt   the first dimension of the array vort as it appears in
c            the program that calls vrtgc. if isym = 0 then ivrt
c            must be at least nlat.  if isym = 1 or 2 and nlat is
c            even then ivrt must be at least nlat/2. if isym = 1 or 2
c            and nlat is odd then ivrt must be at least (nlat+1)/2.
c
c     jvrt   the second dimension of the array vort as it appears in
c            the program that calls vrtgc. jvrt must be at least nlon.
c
c    cr,ci   two or three dimensional arrays (see input parameter nt)
c            that contain vector spherical harmonic coefficients
c            of the vector field (v,w) as computed by subroutine vhagc.
c     ***    cr and ci must be computed by vhagc prior to calling
c            vrtgc.
c
c      mdc   the first dimension of the arrays cr and ci as it
c            appears in the program that calls vrtgc. mdc must be at
c            least min0(nlat,nlon/2) if nlon is even or at least
c            min0(nlat,(nlon+1)/2) if nlon is odd.
c
c      ndc   the second dimension of the arrays cr and ci as it
c            appears in the program that calls vrtgc. ndc must be at
c            least nlat.
c
c   wshsgc   an array which must be initialized by subroutine shsgci.
c            once initialized,
c            wshsgc can be used repeatedly by vrtgc as long as nlon
c            and nlat remain unchanged.  wshsgc must not be altered
c            between calls of vrtgc
c
c   lshsgc   the dimension of the array wshsgc   as it appears in the
c            program that calls vrtgc. define
c
c               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            then lshsgc must be at least
c
c               nlat*(2*l2+3*l1-2)+3*l1*(1-l1)/2+nlon+15
c
c
c     work   a work array that does not have to be saved.
c
c    lwork   the dimension of the array work as it appears in the
c            program that calls vrtgc. define
c
c               l1 = min0(nlat,nlon/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd.
c
c            if isym is zero then lwork must be at least
c
c               nlat*(nlon*nt+max0(3*l2,nlon) + 2*nt*l1+1)
c
c            if isym is not zero then lwork must be at least
c
c               l2*(nlon*nt+max0(3*nlat,nlon)) + nlat*(2*nt*l1+1)
c
c
c     **************************************************************
c
c     output parameters
c
c
c     vort   a two or three dimensional array (see input parameter nt)
c            that contains the vorticity of the vector field (v,w)
C*PL*ERROR* Comment line too long
c            whose coefficients cr,ci where computed by subroutine vhagc.
c            vort(i,j) is the vorticity at the gaussian colatitude point
c            theta(i) and longitude point lambda(j) = (j-1)*2*pi/nlon.
c            the index ranges are defined above at the input parameter
c            isym.
c
c
c   ierror   an error parameter which indicates fatal errors with input
c            parameters when returned positive.
c          = 0  no errors
c          = 1  error in the specification of nlat
c          = 2  error in the specification of nlon
c          = 3  error in the specification of isym
c          = 4  error in the specification of nt
c          = 5  error in the specification of ivrt
c          = 6  error in the specification of jvrt
c          = 7  error in the specification of mdc
c          = 8  error in the specification of ndc
c          = 9  error in the specification of lshsgc
c          = 10 error in the specification of lwork
c **********************************************************************
c
c
      SUBROUTINE DVRTGC(NLAT,NLON,ISYM,NT,VORT,IVRT,JVRT,CR,CI,MDC,NDC,
     +                 WSHSGC,LSHSGC,WORK,LWORK,IERROR)
      DOUBLE PRECISION VORT
      DOUBLE PRECISION CR
      DOUBLE PRECISION CI
      DOUBLE PRECISION WSHSGC
      DOUBLE PRECISION WORK

      DIMENSION VORT(IVRT,JVRT,NT),CR(MDC,NDC,NT),CI(MDC,NDC,NT)
      DIMENSION WSHSGC(LSHSGC),WORK(LWORK)
c
c     check input parameters
c
      IERROR = 1
      IF (NLAT.LT.3) RETURN
      IERROR = 2
      IF (NLON.LT.4) RETURN
      IERROR = 3
      IF (ISYM.LT.0 .OR. ISYM.GT.2) RETURN
      IERROR = 4
      IF (NT.LT.0) RETURN
      IERROR = 5
      IMID = (NLAT+1)/2
      IF ((ISYM.EQ.0.AND.IVRT.LT.NLAT) .OR.
     +    (ISYM.GT.0.AND.IVRT.LT.IMID)) RETURN
      IERROR = 6
      IF (JVRT.LT.NLON) RETURN
      IERROR = 7
      IF (MDC.LT.MIN0(NLAT, (NLON+1)/2)) RETURN
      MMAX = MIN0(NLAT, (NLON+2)/2)
      IERROR = 8
      IF (NDC.LT.NLAT) RETURN
      IERROR = 9
      IMID = (NLAT+1)/2
      LPIMN = (IMID*MMAX* (NLAT+NLAT-MMAX+1))/2
      L1 = MIN0(NLAT, (NLON+2)/2)
      L2 = (NLAT+1)/2
      LWMIN = NLAT* (2*L2+3*L1-2) + 3*L1* (1-L1)/2 + NLON + 15
      IF (LSHSGC.LT.LWMIN) RETURN
      IERROR = 10
c
c     verify unsaved work space (add to what shses requires, file f3)
c
c
c     set first dimension for a,b (as requried by shses)
c
      MAB = MIN0(NLAT,NLON/2+1)
      MN = MAB*NLAT*NT
      LS = NLAT
      IF (ISYM.GT.0) LS = IMID
      NLN = NT*LS*NLON
c     if(lwork.lt. nln+ls*nlon+2*mn+nlat) return
      L1 = MIN0(NLAT, (NLON+2)/2)
      L2 = (NLAT+1)/2
      IF (ISYM.EQ.0) THEN
          LWKMIN = NLAT* (NT*NLON+MAX0(3*L2,NLON)+2*NT*L1+1)
      ELSE
          LWKMIN = L2* (NT*NLON+MAX0(3*NLAT,NLON)) + NLAT* (2*NT*L1+1)
      END IF
      IF (LWORK.LT.LWKMIN) RETURN
      IERROR = 0
c
c     set work space pointers
c
      IA = 1
      IB = IA + MN
      IS = IB + MN
      IWK = IS + NLAT
      LWK = LWORK - 2*MN - NLAT
      CALL DVRTGC1(NLAT,NLON,ISYM,NT,VORT,IVRT,JVRT,CR,CI,MDC,NDC,
     +            WORK(IA),WORK(IB),MAB,WORK(IS),WSHSGC,LSHSGC,
     +            WORK(IWK),LWK,IERROR)
      RETURN
      END

      SUBROUTINE DVRTGC1(NLAT,NLON,ISYM,NT,VORT,IVRT,JVRT,CR,CI,MDC,NDC,
     +                  A,B,MAB,SQNN,WSAV,LWSAV,WK,LWK,IERROR)
      DOUBLE PRECISION VORT
      DOUBLE PRECISION CR
      DOUBLE PRECISION CI
      DOUBLE PRECISION A
      DOUBLE PRECISION B
      DOUBLE PRECISION SQNN
      DOUBLE PRECISION WSAV
      DOUBLE PRECISION WK
      DOUBLE PRECISION FN
      DIMENSION VORT(IVRT,JVRT,NT),CR(MDC,NDC,NT),CI(MDC,NDC,NT)
      DIMENSION A(MAB,NLAT,NT),B(MAB,NLAT,NT),SQNN(NLAT)
      DIMENSION WSAV(LWSAV),WK(LWK)
c
c     set coefficient multiplyers
c
      DO 1 N = 2,NLAT
          FN = DBLE(N-1)
          SQNN(N) = SQRT(FN* (FN+1.D0))
    1 CONTINUE
c
c     compute divergence scalar coefficients for each vector field
c
      DO 2 K = 1,NT
          DO 3 N = 1,NLAT
              DO 4 M = 1,MAB
                  A(M,N,K) = 0.0D0
                  B(M,N,K) = 0.0D0
    4         CONTINUE
    3     CONTINUE
c
c     compute m=0 coefficients
c
          DO 5 N = 2,NLAT
              A(1,N,K) = SQNN(N)*CR(1,N,K)
              B(1,N,K) = SQNN(N)*CI(1,N,K)
    5     CONTINUE
c
c     compute m>0 coefficients
c
          MMAX = MIN0(NLAT, (NLON+1)/2)
          DO 6 M = 2,MMAX
              DO 7 N = M,NLAT
                  A(M,N,K) = SQNN(N)*CR(M,N,K)
                  B(M,N,K) = SQNN(N)*CI(M,N,K)
    7         CONTINUE
    6     CONTINUE
    2 CONTINUE
c
c     synthesize a,b into vort
c
      CALL DSHSGC(NLAT,NLON,ISYM,NT,VORT,IVRT,JVRT,A,B,MAB,NLAT,WSAV,
     +           LWSAV,WK,LWK,IERROR)
      RETURN
      END

      SUBROUTINE SSYTRI( UPLO, N, A, LDA, IPIV, WORK, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     March 31, 1993 
*
*     .. Scalar Arguments ..
      CHARACTER          UPLO
      INTEGER            INFO, LDA, N
*     ..
*     .. Array Arguments ..
      INTEGER            IPIV( * )
      REAL               A( LDA, * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  SSYTRI computes the inverse of a real symmetric indefinite matrix
*  A using the factorization A = U*D*U**T or A = L*D*L**T computed by
*  SSYTRF.
*
*  Arguments
*  =========
*
*  UPLO    (input) CHARACTER*1
*          Specifies whether the details of the factorization are stored
*          as an upper or lower triangular matrix.
*          = 'U':  Upper triangular, form is A = U*D*U**T;
*          = 'L':  Lower triangular, form is A = L*D*L**T.
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  A       (input/output) REAL array, dimension (LDA,N)
*          On entry, the block diagonal matrix D and the multipliers
*          used to obtain the factor U or L as computed by SSYTRF.
*
*          On exit, if INFO = 0, the (symmetric) inverse of the original
*          matrix.  If UPLO = 'U', the upper triangular part of the
*          inverse is formed and the part of A below the diagonal is not
*          referenced; if UPLO = 'L' the lower triangular part of the
*          inverse is formed and the part of A above the diagonal is
*          not referenced.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(1,N).
*
*  IPIV    (input) INTEGER array, dimension (N)
*          Details of the interchanges and the block structure of D
*          as determined by SSYTRF.
*
*  WORK    (workspace) REAL array, dimension (N)
*
*  INFO    (output) INTEGER
*          = 0: successful exit
*          < 0: if INFO = -i, the i-th argument had an illegal value
*          > 0: if INFO = i, D(i,i) = 0; the matrix is singular and its
*               inverse could not be computed.
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ONE, ZERO
      PARAMETER          ( ONE = 1.0E+0, ZERO = 0.0E+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            UPPER
      INTEGER            K, KP, KSTEP
      REAL               AK, AKKP1, AKP1, D, T, TEMP
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      REAL               SDOT
      EXTERNAL           LSAME, SDOT
*     ..
*     .. External Subroutines ..
      EXTERNAL           SCOPY, SSWAP, SSYMV, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, MAX
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      UPPER = LSAME( UPLO, 'U' )
      IF( .NOT.UPPER .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -4
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'SSYTRI', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
*
*     Check that the diagonal matrix D is nonsingular.
*
      IF( UPPER ) THEN
*
*        Upper triangular storage: examine D from bottom to top
*
         DO 10 INFO = N, 1, -1
            IF( IPIV( INFO ).GT.0 .AND. A( INFO, INFO ).EQ.ZERO )
     $         RETURN
   10    CONTINUE
      ELSE
*
*        Lower triangular storage: examine D from top to bottom.
*
         DO 20 INFO = 1, N
            IF( IPIV( INFO ).GT.0 .AND. A( INFO, INFO ).EQ.ZERO )
     $         RETURN
   20    CONTINUE
      END IF
      INFO = 0
*
      IF( UPPER ) THEN
*
*        Compute inv(A) from the factorization A = U*D*U'.
*
*        K is the main loop index, increasing from 1 to N in steps of
*        1 or 2, depending on the size of the diagonal blocks.
*
         K = 1
   30    CONTINUE
*
*        If K > N, exit from loop.
*
         IF( K.GT.N )
     $      GO TO 40
*
         IF( IPIV( K ).GT.0 ) THEN
*
*           1 x 1 diagonal block
*
*           Invert the diagonal block.
*
            A( K, K ) = ONE / A( K, K )
*
*           Compute column K of the inverse.
*
            IF( K.GT.1 ) THEN
               CALL SCOPY( K-1, A( 1, K ), 1, WORK, 1 )
               CALL SSYMV( UPLO, K-1, -ONE, A, LDA, WORK, 1, ZERO,
     $                     A( 1, K ), 1 )
               A( K, K ) = A( K, K ) - SDOT( K-1, WORK, 1, A( 1, K ),
     $                     1 )
            END IF
            KSTEP = 1
         ELSE
*
*           2 x 2 diagonal block
*
*           Invert the diagonal block.
*
            T = ABS( A( K, K+1 ) )
            AK = A( K, K ) / T
            AKP1 = A( K+1, K+1 ) / T
            AKKP1 = A( K, K+1 ) / T
            D = T*( AK*AKP1-ONE )
            A( K, K ) = AKP1 / D
            A( K+1, K+1 ) = AK / D
            A( K, K+1 ) = -AKKP1 / D
*
*           Compute columns K and K+1 of the inverse.
*
            IF( K.GT.1 ) THEN
               CALL SCOPY( K-1, A( 1, K ), 1, WORK, 1 )
               CALL SSYMV( UPLO, K-1, -ONE, A, LDA, WORK, 1, ZERO,
     $                     A( 1, K ), 1 )
               A( K, K ) = A( K, K ) - SDOT( K-1, WORK, 1, A( 1, K ),
     $                     1 )
               A( K, K+1 ) = A( K, K+1 ) -
     $                       SDOT( K-1, A( 1, K ), 1, A( 1, K+1 ), 1 )
               CALL SCOPY( K-1, A( 1, K+1 ), 1, WORK, 1 )
               CALL SSYMV( UPLO, K-1, -ONE, A, LDA, WORK, 1, ZERO,
     $                     A( 1, K+1 ), 1 )
               A( K+1, K+1 ) = A( K+1, K+1 ) -
     $                         SDOT( K-1, WORK, 1, A( 1, K+1 ), 1 )
            END IF
            KSTEP = 2
         END IF
*
         KP = ABS( IPIV( K ) )
         IF( KP.NE.K ) THEN
*
*           Interchange rows and columns K and KP in the leading
*           submatrix A(1:k+1,1:k+1)
*
            CALL SSWAP( KP-1, A( 1, K ), 1, A( 1, KP ), 1 )
            CALL SSWAP( K-KP-1, A( KP+1, K ), 1, A( KP, KP+1 ), LDA )
            TEMP = A( K, K )
            A( K, K ) = A( KP, KP )
            A( KP, KP ) = TEMP
            IF( KSTEP.EQ.2 ) THEN
               TEMP = A( K, K+1 )
               A( K, K+1 ) = A( KP, K+1 )
               A( KP, K+1 ) = TEMP
            END IF
         END IF
*
         K = K + KSTEP
         GO TO 30
   40    CONTINUE
*
      ELSE
*
*        Compute inv(A) from the factorization A = L*D*L'.
*
*        K is the main loop index, increasing from 1 to N in steps of
*        1 or 2, depending on the size of the diagonal blocks.
*
         K = N
   50    CONTINUE
*
*        If K < 1, exit from loop.
*
         IF( K.LT.1 )
     $      GO TO 60
*
         IF( IPIV( K ).GT.0 ) THEN
*
*           1 x 1 diagonal block
*
*           Invert the diagonal block.
*
            A( K, K ) = ONE / A( K, K )
*
*           Compute column K of the inverse.
*
            IF( K.LT.N ) THEN
               CALL SCOPY( N-K, A( K+1, K ), 1, WORK, 1 )
               CALL SSYMV( UPLO, N-K, -ONE, A( K+1, K+1 ), LDA, WORK, 1,
     $                     ZERO, A( K+1, K ), 1 )
               A( K, K ) = A( K, K ) - SDOT( N-K, WORK, 1, A( K+1, K ),
     $                     1 )
            END IF
            KSTEP = 1
         ELSE
*
*           2 x 2 diagonal block
*
*           Invert the diagonal block.
*
            T = ABS( A( K, K-1 ) )
            AK = A( K-1, K-1 ) / T
            AKP1 = A( K, K ) / T
            AKKP1 = A( K, K-1 ) / T
            D = T*( AK*AKP1-ONE )
            A( K-1, K-1 ) = AKP1 / D
            A( K, K ) = AK / D
            A( K, K-1 ) = -AKKP1 / D
*
*           Compute columns K-1 and K of the inverse.
*
            IF( K.LT.N ) THEN
               CALL SCOPY( N-K, A( K+1, K ), 1, WORK, 1 )
               CALL SSYMV( UPLO, N-K, -ONE, A( K+1, K+1 ), LDA, WORK, 1,
     $                     ZERO, A( K+1, K ), 1 )
               A( K, K ) = A( K, K ) - SDOT( N-K, WORK, 1, A( K+1, K ),
     $                     1 )
               A( K, K-1 ) = A( K, K-1 ) -
     $                       SDOT( N-K, A( K+1, K ), 1, A( K+1, K-1 ),
     $                       1 )
               CALL SCOPY( N-K, A( K+1, K-1 ), 1, WORK, 1 )
               CALL SSYMV( UPLO, N-K, -ONE, A( K+1, K+1 ), LDA, WORK, 1,
     $                     ZERO, A( K+1, K-1 ), 1 )
               A( K-1, K-1 ) = A( K-1, K-1 ) -
     $                         SDOT( N-K, WORK, 1, A( K+1, K-1 ), 1 )
            END IF
            KSTEP = 2
         END IF
*
         KP = ABS( IPIV( K ) )
         IF( KP.NE.K ) THEN
*
*           Interchange rows and columns K and KP in the trailing
*           submatrix A(k-1:n,k-1:n)
*
            IF( KP.LT.N )
     $         CALL SSWAP( N-KP, A( KP+1, K ), 1, A( KP+1, KP ), 1 )
            CALL SSWAP( KP-K-1, A( K+1, K ), 1, A( KP, K+1 ), LDA )
            TEMP = A( K, K )
            A( K, K ) = A( KP, KP )
            A( KP, KP ) = TEMP
            IF( KSTEP.EQ.2 ) THEN
               TEMP = A( K, K-1 )
               A( K, K-1 ) = A( KP, K-1 )
               A( KP, K-1 ) = TEMP
            END IF
         END IF
*
         K = K - KSTEP
         GO TO 50
   60    CONTINUE
      END IF
*
      RETURN
*
*     End of SSYTRI
*
      END

      SUBROUTINE DLASD4( N, I, D, Z, DELTA, RHO, SIGMA, WORK, INFO )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Oak Ridge National Lab, Argonne National Lab,
*     Courant Institute, NAG Ltd., and Rice University
*     October 31, 1999
*
*     .. Scalar Arguments ..
      INTEGER            I, INFO, N
      DOUBLE PRECISION   RHO, SIGMA
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   D( * ), DELTA( * ), WORK( * ), Z( * )
*     ..
*
*  Purpose
*  =======
*
*  This subroutine computes the square root of the I-th updated
*  eigenvalue of a positive symmetric rank-one modification to
*  a positive diagonal matrix whose entries are given as the squares
*  of the corresponding entries in the array d, and that
*
*         0 <= D(i) < D(j)  for  i < j
*
*  and that RHO > 0. This is arranged by the calling routine, and is
*  no loss in generality.  The rank-one modified system is thus
*
*         diag( D ) * diag( D ) +  RHO *  Z * Z_transpose.
*
*  where we assume the Euclidean norm of Z is 1.
*
*  The method consists of approximating the rational functions in the
*  secular equation by simpler interpolating rational functions.
*
*  Arguments
*  =========
*
*  N      (input) INTEGER
*         The length of all arrays.
*
*  I      (input) INTEGER
*         The index of the eigenvalue to be computed.  1 <= I <= N.
*
*  D      (input) DOUBLE PRECISION array, dimension ( N )
*         The original eigenvalues.  It is assumed that they are in
*         order, 0 <= D(I) < D(J)  for I < J.
*
*  Z      (input) DOUBLE PRECISION array, dimension ( N )
*         The components of the updating vector.
*
*  DELTA  (output) DOUBLE PRECISION array, dimension ( N )
*         If N .ne. 1, DELTA contains (D(j) - sigma_I) in its  j-th
*         component.  If N = 1, then DELTA(1) = 1.  The vector DELTA
*         contains the information necessary to construct the
*         (singular) eigenvectors.
*
*  RHO    (input) DOUBLE PRECISION
*         The scalar in the symmetric updating formula.
*
*  SIGMA  (output) DOUBLE PRECISION
*         The computed lambda_I, the I-th updated eigenvalue.
*
*  WORK   (workspace) DOUBLE PRECISION array, dimension ( N )
*         If N .ne. 1, WORK contains (D(j) + sigma_I) in its  j-th
*         component.  If N = 1, then WORK( 1 ) = 1.
*
*  INFO   (output) INTEGER
*         = 0:  successful exit
*         > 0:  if INFO = 1, the updating process failed.
*
*  Internal Parameters
*  ===================
*
*  Logical variable ORGATI (origin-at-i?) is used for distinguishing
*  whether D(i) or D(i+1) is treated as the origin.
*
*            ORGATI = .true.    origin at i
*            ORGATI = .false.   origin at i+1
*
*  Logical variable SWTCH3 (switch-for-3-poles?) is for noting
*  if we are working with THREE poles!
*
*  MAXIT is the maximum number of iterations allowed for each
*  eigenvalue.
*
*  Further Details
*  ===============
*
*  Based on contributions by
*     Ren-Cang Li, Computer Science Division, University of California
*     at Berkeley, USA
*
*  =====================================================================
*
*     .. Parameters ..
      INTEGER            MAXIT
      PARAMETER          ( MAXIT = 20 )
      DOUBLE PRECISION   ZERO, ONE, TWO, THREE, FOUR, EIGHT, TEN
      PARAMETER          ( ZERO = 0.0D+0, ONE = 1.0D+0, TWO = 2.0D+0,
     $                   THREE = 3.0D+0, FOUR = 4.0D+0, EIGHT = 8.0D+0,
     $                   TEN = 10.0D+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            ORGATI, SWTCH, SWTCH3
      INTEGER            II, IIM1, IIP1, IP1, ITER, J, NITER
      DOUBLE PRECISION   A, B, C, DELSQ, DELSQ2, DPHI, DPSI, DTIIM,
     $                   DTIIP, DTIPSQ, DTISQ, DTNSQ, DTNSQ1, DW, EPS,
     $                   ERRETM, ETA, PHI, PREW, PSI, RHOINV, SG2LB,
     $                   SG2UB, TAU, TEMP, TEMP1, TEMP2, W
*     ..
*     .. Local Arrays ..
      DOUBLE PRECISION   DD( 3 ), ZZ( 3 )
*     ..
*     .. External Subroutines ..
      EXTERNAL           DLAED6, DLASD5
*     ..
*     .. External Functions ..
      DOUBLE PRECISION   DLAMCH
      EXTERNAL           DLAMCH
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, MAX, MIN, SQRT
*     ..
*     .. Executable Statements ..
*
*     Since this routine is called in an inner loop, we do no argument
*     checking.
*
*     Quick return for N=1 and 2.
*
      INFO = 0
      IF( N.EQ.1 ) THEN
*
*        Presumably, I=1 upon entry
*
         SIGMA = SQRT( D( 1 )*D( 1 )+RHO*Z( 1 )*Z( 1 ) )
         DELTA( 1 ) = ONE
         WORK( 1 ) = ONE
         RETURN
      END IF
      IF( N.EQ.2 ) THEN
         CALL DLASD5( I, D, Z, DELTA, RHO, SIGMA, WORK )
         RETURN
      END IF
*
*     Compute machine epsilon
*
      EPS = DLAMCH( 'Epsilon' )
      RHOINV = ONE / RHO
*
*     The case I = N
*
      IF( I.EQ.N ) THEN
*
*        Initialize some basic variables
*
         II = N - 1
         NITER = 1
*
*        Calculate initial guess
*
         TEMP = RHO / TWO
*
*        If ||Z||_2 is not one, then TEMP should be set to
*        RHO * ||Z||_2^2 / TWO
*
         TEMP1 = TEMP / ( D( N )+SQRT( D( N )*D( N )+TEMP ) )
         DO 10 J = 1, N
            WORK( J ) = D( J ) + D( N ) + TEMP1
            DELTA( J ) = ( D( J )-D( N ) ) - TEMP1
   10    CONTINUE
*
         PSI = ZERO
         DO 20 J = 1, N - 2
            PSI = PSI + Z( J )*Z( J ) / ( DELTA( J )*WORK( J ) )
   20    CONTINUE
*
         C = RHOINV + PSI
         W = C + Z( II )*Z( II ) / ( DELTA( II )*WORK( II ) ) +
     $       Z( N )*Z( N ) / ( DELTA( N )*WORK( N ) )
*
         IF( W.LE.ZERO ) THEN
            TEMP1 = SQRT( D( N )*D( N )+RHO )
            TEMP = Z( N-1 )*Z( N-1 ) / ( ( D( N-1 )+TEMP1 )*
     $             ( D( N )-D( N-1 )+RHO / ( D( N )+TEMP1 ) ) ) +
     $             Z( N )*Z( N ) / RHO
*
*           The following TAU is to approximate
*           SIGMA_n^2 - D( N )*D( N )
*
            IF( C.LE.TEMP ) THEN
               TAU = RHO
            ELSE
               DELSQ = ( D( N )-D( N-1 ) )*( D( N )+D( N-1 ) )
               A = -C*DELSQ + Z( N-1 )*Z( N-1 ) + Z( N )*Z( N )
               B = Z( N )*Z( N )*DELSQ
               IF( A.LT.ZERO ) THEN
                  TAU = TWO*B / ( SQRT( A*A+FOUR*B*C )-A )
               ELSE
                  TAU = ( A+SQRT( A*A+FOUR*B*C ) ) / ( TWO*C )
               END IF
            END IF
*
*           It can be proved that
*               D(N)^2+RHO/2 <= SIGMA_n^2 < D(N)^2+TAU <= D(N)^2+RHO
*
         ELSE
            DELSQ = ( D( N )-D( N-1 ) )*( D( N )+D( N-1 ) )
            A = -C*DELSQ + Z( N-1 )*Z( N-1 ) + Z( N )*Z( N )
            B = Z( N )*Z( N )*DELSQ
*
*           The following TAU is to approximate
*           SIGMA_n^2 - D( N )*D( N )
*
            IF( A.LT.ZERO ) THEN
               TAU = TWO*B / ( SQRT( A*A+FOUR*B*C )-A )
            ELSE
               TAU = ( A+SQRT( A*A+FOUR*B*C ) ) / ( TWO*C )
            END IF
*
*           It can be proved that
*           D(N)^2 < D(N)^2+TAU < SIGMA(N)^2 < D(N)^2+RHO/2
*
         END IF
*
*        The following ETA is to approximate SIGMA_n - D( N )
*
         ETA = TAU / ( D( N )+SQRT( D( N )*D( N )+TAU ) )
*
         SIGMA = D( N ) + ETA
         DO 30 J = 1, N
            DELTA( J ) = ( D( J )-D( I ) ) - ETA
            WORK( J ) = D( J ) + D( I ) + ETA
   30    CONTINUE
*
*        Evaluate PSI and the derivative DPSI
*
         DPSI = ZERO
         PSI = ZERO
         ERRETM = ZERO
         DO 40 J = 1, II
            TEMP = Z( J ) / ( DELTA( J )*WORK( J ) )
            PSI = PSI + Z( J )*TEMP
            DPSI = DPSI + TEMP*TEMP
            ERRETM = ERRETM + PSI
   40    CONTINUE
         ERRETM = ABS( ERRETM )
*
*        Evaluate PHI and the derivative DPHI
*
         TEMP = Z( N ) / ( DELTA( N )*WORK( N ) )
         PHI = Z( N )*TEMP
         DPHI = TEMP*TEMP
         ERRETM = EIGHT*( -PHI-PSI ) + ERRETM - PHI + RHOINV +
     $            ABS( TAU )*( DPSI+DPHI )
*
         W = RHOINV + PHI + PSI
*
*        Test for convergence
*
         IF( ABS( W ).LE.EPS*ERRETM ) THEN
            GO TO 240
         END IF
*
*        Calculate the new step
*
         NITER = NITER + 1
         DTNSQ1 = WORK( N-1 )*DELTA( N-1 )
         DTNSQ = WORK( N )*DELTA( N )
         C = W - DTNSQ1*DPSI - DTNSQ*DPHI
         A = ( DTNSQ+DTNSQ1 )*W - DTNSQ*DTNSQ1*( DPSI+DPHI )
         B = DTNSQ*DTNSQ1*W
         IF( C.LT.ZERO )
     $      C = ABS( C )
         IF( C.EQ.ZERO ) THEN
            ETA = RHO - SIGMA*SIGMA
         ELSE IF( A.GE.ZERO ) THEN
            ETA = ( A+SQRT( ABS( A*A-FOUR*B*C ) ) ) / ( TWO*C )
         ELSE
            ETA = TWO*B / ( A-SQRT( ABS( A*A-FOUR*B*C ) ) )
         END IF
*
*        Note, eta should be positive if w is negative, and
*        eta should be negative otherwise. However,
*        if for some reason caused by roundoff, eta*w > 0,
*        we simply use one Newton step instead. This way
*        will guarantee eta*w < 0.
*
         IF( W*ETA.GT.ZERO )
     $      ETA = -W / ( DPSI+DPHI )
         TEMP = ETA - DTNSQ
         IF( TEMP.GT.RHO )
     $      ETA = RHO + DTNSQ
*
         TAU = TAU + ETA
         ETA = ETA / ( SIGMA+SQRT( ETA+SIGMA*SIGMA ) )
         DO 50 J = 1, N
            DELTA( J ) = DELTA( J ) - ETA
            WORK( J ) = WORK( J ) + ETA
   50    CONTINUE
*
         SIGMA = SIGMA + ETA
*
*        Evaluate PSI and the derivative DPSI
*
         DPSI = ZERO
         PSI = ZERO
         ERRETM = ZERO
         DO 60 J = 1, II
            TEMP = Z( J ) / ( WORK( J )*DELTA( J ) )
            PSI = PSI + Z( J )*TEMP
            DPSI = DPSI + TEMP*TEMP
            ERRETM = ERRETM + PSI
   60    CONTINUE
         ERRETM = ABS( ERRETM )
*
*        Evaluate PHI and the derivative DPHI
*
         TEMP = Z( N ) / ( WORK( N )*DELTA( N ) )
         PHI = Z( N )*TEMP
         DPHI = TEMP*TEMP
         ERRETM = EIGHT*( -PHI-PSI ) + ERRETM - PHI + RHOINV +
     $            ABS( TAU )*( DPSI+DPHI )
*
         W = RHOINV + PHI + PSI
*
*        Main loop to update the values of the array   DELTA
*
         ITER = NITER + 1
*
         DO 90 NITER = ITER, MAXIT
*
*           Test for convergence
*
            IF( ABS( W ).LE.EPS*ERRETM ) THEN
               GO TO 240
            END IF
*
*           Calculate the new step
*
            DTNSQ1 = WORK( N-1 )*DELTA( N-1 )
            DTNSQ = WORK( N )*DELTA( N )
            C = W - DTNSQ1*DPSI - DTNSQ*DPHI
            A = ( DTNSQ+DTNSQ1 )*W - DTNSQ1*DTNSQ*( DPSI+DPHI )
            B = DTNSQ1*DTNSQ*W
            IF( A.GE.ZERO ) THEN
               ETA = ( A+SQRT( ABS( A*A-FOUR*B*C ) ) ) / ( TWO*C )
            ELSE
               ETA = TWO*B / ( A-SQRT( ABS( A*A-FOUR*B*C ) ) )
            END IF
*
*           Note, eta should be positive if w is negative, and
*           eta should be negative otherwise. However,
*           if for some reason caused by roundoff, eta*w > 0,
*           we simply use one Newton step instead. This way
*           will guarantee eta*w < 0.
*
            IF( W*ETA.GT.ZERO )
     $         ETA = -W / ( DPSI+DPHI )
            TEMP = ETA - DTNSQ
            IF( TEMP.LE.ZERO )
     $         ETA = ETA / TWO
*
            TAU = TAU + ETA
            ETA = ETA / ( SIGMA+SQRT( ETA+SIGMA*SIGMA ) )
            DO 70 J = 1, N
               DELTA( J ) = DELTA( J ) - ETA
               WORK( J ) = WORK( J ) + ETA
   70       CONTINUE
*
            SIGMA = SIGMA + ETA
*
*           Evaluate PSI and the derivative DPSI
*
            DPSI = ZERO
            PSI = ZERO
            ERRETM = ZERO
            DO 80 J = 1, II
               TEMP = Z( J ) / ( WORK( J )*DELTA( J ) )
               PSI = PSI + Z( J )*TEMP
               DPSI = DPSI + TEMP*TEMP
               ERRETM = ERRETM + PSI
   80       CONTINUE
            ERRETM = ABS( ERRETM )
*
*           Evaluate PHI and the derivative DPHI
*
            TEMP = Z( N ) / ( WORK( N )*DELTA( N ) )
            PHI = Z( N )*TEMP
            DPHI = TEMP*TEMP
            ERRETM = EIGHT*( -PHI-PSI ) + ERRETM - PHI + RHOINV +
     $               ABS( TAU )*( DPSI+DPHI )
*
            W = RHOINV + PHI + PSI
   90    CONTINUE
*
*        Return with INFO = 1, NITER = MAXIT and not converged
*
         INFO = 1
         GO TO 240
*
*        End for the case I = N
*
      ELSE
*
*        The case for I < N
*
         NITER = 1
         IP1 = I + 1
*
*        Calculate initial guess
*
         DELSQ = ( D( IP1 )-D( I ) )*( D( IP1 )+D( I ) )
         DELSQ2 = DELSQ / TWO
         TEMP = DELSQ2 / ( D( I )+SQRT( D( I )*D( I )+DELSQ2 ) )
         DO 100 J = 1, N
            WORK( J ) = D( J ) + D( I ) + TEMP
            DELTA( J ) = ( D( J )-D( I ) ) - TEMP
  100    CONTINUE
*
         PSI = ZERO
         DO 110 J = 1, I - 1
            PSI = PSI + Z( J )*Z( J ) / ( WORK( J )*DELTA( J ) )
  110    CONTINUE
*
         PHI = ZERO
         DO 120 J = N, I + 2, -1
            PHI = PHI + Z( J )*Z( J ) / ( WORK( J )*DELTA( J ) )
  120    CONTINUE
         C = RHOINV + PSI + PHI
         W = C + Z( I )*Z( I ) / ( WORK( I )*DELTA( I ) ) +
     $       Z( IP1 )*Z( IP1 ) / ( WORK( IP1 )*DELTA( IP1 ) )
*
         IF( W.GT.ZERO ) THEN
*
*           d(i)^2 < the ith sigma^2 < (d(i)^2+d(i+1)^2)/2
*
*           We choose d(i) as origin.
*
            ORGATI = .TRUE.
            SG2LB = ZERO
            SG2UB = DELSQ2
            A = C*DELSQ + Z( I )*Z( I ) + Z( IP1 )*Z( IP1 )
            B = Z( I )*Z( I )*DELSQ
            IF( A.GT.ZERO ) THEN
               TAU = TWO*B / ( A+SQRT( ABS( A*A-FOUR*B*C ) ) )
            ELSE
               TAU = ( A-SQRT( ABS( A*A-FOUR*B*C ) ) ) / ( TWO*C )
            END IF
*
*           TAU now is an estimation of SIGMA^2 - D( I )^2. The
*           following, however, is the corresponding estimation of
*           SIGMA - D( I ).
*
            ETA = TAU / ( D( I )+SQRT( D( I )*D( I )+TAU ) )
         ELSE
*
*           (d(i)^2+d(i+1)^2)/2 <= the ith sigma^2 < d(i+1)^2/2
*
*           We choose d(i+1) as origin.
*
            ORGATI = .FALSE.
            SG2LB = -DELSQ2
            SG2UB = ZERO
            A = C*DELSQ - Z( I )*Z( I ) - Z( IP1 )*Z( IP1 )
            B = Z( IP1 )*Z( IP1 )*DELSQ
            IF( A.LT.ZERO ) THEN
               TAU = TWO*B / ( A-SQRT( ABS( A*A+FOUR*B*C ) ) )
            ELSE
               TAU = -( A+SQRT( ABS( A*A+FOUR*B*C ) ) ) / ( TWO*C )
            END IF
*
*           TAU now is an estimation of SIGMA^2 - D( IP1 )^2. The
*           following, however, is the corresponding estimation of
*           SIGMA - D( IP1 ).
*
            ETA = TAU / ( D( IP1 )+SQRT( ABS( D( IP1 )*D( IP1 )+
     $            TAU ) ) )
         END IF
*
         IF( ORGATI ) THEN
            II = I
            SIGMA = D( I ) + ETA
            DO 130 J = 1, N
               WORK( J ) = D( J ) + D( I ) + ETA
               DELTA( J ) = ( D( J )-D( I ) ) - ETA
  130       CONTINUE
         ELSE
            II = I + 1
            SIGMA = D( IP1 ) + ETA
            DO 140 J = 1, N
               WORK( J ) = D( J ) + D( IP1 ) + ETA
               DELTA( J ) = ( D( J )-D( IP1 ) ) - ETA
  140       CONTINUE
         END IF
         IIM1 = II - 1
         IIP1 = II + 1
*
*        Evaluate PSI and the derivative DPSI
*
         DPSI = ZERO
         PSI = ZERO
         ERRETM = ZERO
         DO 150 J = 1, IIM1
            TEMP = Z( J ) / ( WORK( J )*DELTA( J ) )
            PSI = PSI + Z( J )*TEMP
            DPSI = DPSI + TEMP*TEMP
            ERRETM = ERRETM + PSI
  150    CONTINUE
         ERRETM = ABS( ERRETM )
*
*        Evaluate PHI and the derivative DPHI
*
         DPHI = ZERO
         PHI = ZERO
         DO 160 J = N, IIP1, -1
            TEMP = Z( J ) / ( WORK( J )*DELTA( J ) )
            PHI = PHI + Z( J )*TEMP
            DPHI = DPHI + TEMP*TEMP
            ERRETM = ERRETM + PHI
  160    CONTINUE
*
         W = RHOINV + PHI + PSI
*
*        W is the value of the secular function with
*        its ii-th element removed.
*
         SWTCH3 = .FALSE.
         IF( ORGATI ) THEN
            IF( W.LT.ZERO )
     $         SWTCH3 = .TRUE.
         ELSE
            IF( W.GT.ZERO )
     $         SWTCH3 = .TRUE.
         END IF
         IF( II.EQ.1 .OR. II.EQ.N )
     $      SWTCH3 = .FALSE.
*
         TEMP = Z( II ) / ( WORK( II )*DELTA( II ) )
         DW = DPSI + DPHI + TEMP*TEMP
         TEMP = Z( II )*TEMP
         W = W + TEMP
         ERRETM = EIGHT*( PHI-PSI ) + ERRETM + TWO*RHOINV +
     $            THREE*ABS( TEMP ) + ABS( TAU )*DW
*
*        Test for convergence
*
         IF( ABS( W ).LE.EPS*ERRETM ) THEN
            GO TO 240
         END IF
*
         IF( W.LE.ZERO ) THEN
            SG2LB = MAX( SG2LB, TAU )
         ELSE
            SG2UB = MIN( SG2UB, TAU )
         END IF
*
*        Calculate the new step
*
         NITER = NITER + 1
         IF( .NOT.SWTCH3 ) THEN
            DTIPSQ = WORK( IP1 )*DELTA( IP1 )
            DTISQ = WORK( I )*DELTA( I )
            IF( ORGATI ) THEN
               C = W - DTIPSQ*DW + DELSQ*( Z( I ) / DTISQ )**2
            ELSE
               C = W - DTISQ*DW - DELSQ*( Z( IP1 ) / DTIPSQ )**2
            END IF
            A = ( DTIPSQ+DTISQ )*W - DTIPSQ*DTISQ*DW
            B = DTIPSQ*DTISQ*W
            IF( C.EQ.ZERO ) THEN
               IF( A.EQ.ZERO ) THEN
                  IF( ORGATI ) THEN
                     A = Z( I )*Z( I ) + DTIPSQ*DTIPSQ*( DPSI+DPHI )
                  ELSE
                     A = Z( IP1 )*Z( IP1 ) + DTISQ*DTISQ*( DPSI+DPHI )
                  END IF
               END IF
               ETA = B / A
            ELSE IF( A.LE.ZERO ) THEN
               ETA = ( A-SQRT( ABS( A*A-FOUR*B*C ) ) ) / ( TWO*C )
            ELSE
               ETA = TWO*B / ( A+SQRT( ABS( A*A-FOUR*B*C ) ) )
            END IF
         ELSE
*
*           Interpolation using THREE most relevant poles
*
            DTIIM = WORK( IIM1 )*DELTA( IIM1 )
            DTIIP = WORK( IIP1 )*DELTA( IIP1 )
            TEMP = RHOINV + PSI + PHI
            IF( ORGATI ) THEN
               TEMP1 = Z( IIM1 ) / DTIIM
               TEMP1 = TEMP1*TEMP1
               C = ( TEMP - DTIIP*( DPSI+DPHI ) ) -
     $             ( D( IIM1 )-D( IIP1 ) )*( D( IIM1 )+D( IIP1 ) )*TEMP1
               ZZ( 1 ) = Z( IIM1 )*Z( IIM1 )
               IF( DPSI.LT.TEMP1 ) THEN
                  ZZ( 3 ) = DTIIP*DTIIP*DPHI
               ELSE
                  ZZ( 3 ) = DTIIP*DTIIP*( ( DPSI-TEMP1 )+DPHI )
               END IF
            ELSE
               TEMP1 = Z( IIP1 ) / DTIIP
               TEMP1 = TEMP1*TEMP1
               C = ( TEMP - DTIIM*( DPSI+DPHI ) ) -
     $             ( D( IIP1 )-D( IIM1 ) )*( D( IIM1 )+D( IIP1 ) )*TEMP1
               IF( DPHI.LT.TEMP1 ) THEN
                  ZZ( 1 ) = DTIIM*DTIIM*DPSI
               ELSE
                  ZZ( 1 ) = DTIIM*DTIIM*( DPSI+( DPHI-TEMP1 ) )
               END IF
               ZZ( 3 ) = Z( IIP1 )*Z( IIP1 )
            END IF
            ZZ( 2 ) = Z( II )*Z( II )
            DD( 1 ) = DTIIM
            DD( 2 ) = DELTA( II )*WORK( II )
            DD( 3 ) = DTIIP
            CALL DLAED6( NITER, ORGATI, C, DD, ZZ, W, ETA, INFO )
            IF( INFO.NE.0 )
     $         GO TO 240
         END IF
*
*        Note, eta should be positive if w is negative, and
*        eta should be negative otherwise. However,
*        if for some reason caused by roundoff, eta*w > 0,
*        we simply use one Newton step instead. This way
*        will guarantee eta*w < 0.
*
         IF( W*ETA.GE.ZERO )
     $      ETA = -W / DW
         IF( ORGATI ) THEN
            TEMP1 = WORK( I )*DELTA( I )
            TEMP = ETA - TEMP1
         ELSE
            TEMP1 = WORK( IP1 )*DELTA( IP1 )
            TEMP = ETA - TEMP1
         END IF
         IF( TEMP.GT.SG2UB .OR. TEMP.LT.SG2LB ) THEN
            IF( W.LT.ZERO ) THEN
               ETA = ( SG2UB-TAU ) / TWO
            ELSE
               ETA = ( SG2LB-TAU ) / TWO
            END IF
         END IF
*
         TAU = TAU + ETA
         ETA = ETA / ( SIGMA+SQRT( SIGMA*SIGMA+ETA ) )
*
         PREW = W
*
         SIGMA = SIGMA + ETA
         DO 170 J = 1, N
            WORK( J ) = WORK( J ) + ETA
            DELTA( J ) = DELTA( J ) - ETA
  170    CONTINUE
*
*        Evaluate PSI and the derivative DPSI
*
         DPSI = ZERO
         PSI = ZERO
         ERRETM = ZERO
         DO 180 J = 1, IIM1
            TEMP = Z( J ) / ( WORK( J )*DELTA( J ) )
            PSI = PSI + Z( J )*TEMP
            DPSI = DPSI + TEMP*TEMP
            ERRETM = ERRETM + PSI
  180    CONTINUE
         ERRETM = ABS( ERRETM )
*
*        Evaluate PHI and the derivative DPHI
*
         DPHI = ZERO
         PHI = ZERO
         DO 190 J = N, IIP1, -1
            TEMP = Z( J ) / ( WORK( J )*DELTA( J ) )
            PHI = PHI + Z( J )*TEMP
            DPHI = DPHI + TEMP*TEMP
            ERRETM = ERRETM + PHI
  190    CONTINUE
*
         TEMP = Z( II ) / ( WORK( II )*DELTA( II ) )
         DW = DPSI + DPHI + TEMP*TEMP
         TEMP = Z( II )*TEMP
         W = RHOINV + PHI + PSI + TEMP
         ERRETM = EIGHT*( PHI-PSI ) + ERRETM + TWO*RHOINV +
     $            THREE*ABS( TEMP ) + ABS( TAU )*DW
*
         IF( W.LE.ZERO ) THEN
            SG2LB = MAX( SG2LB, TAU )
         ELSE
            SG2UB = MIN( SG2UB, TAU )
         END IF
*
         SWTCH = .FALSE.
         IF( ORGATI ) THEN
            IF( -W.GT.ABS( PREW ) / TEN )
     $         SWTCH = .TRUE.
         ELSE
            IF( W.GT.ABS( PREW ) / TEN )
     $         SWTCH = .TRUE.
         END IF
*
*        Main loop to update the values of the array   DELTA and WORK
*
         ITER = NITER + 1
*
         DO 230 NITER = ITER, MAXIT
*
*           Test for convergence
*
            IF( ABS( W ).LE.EPS*ERRETM ) THEN
               GO TO 240
            END IF
*
*           Calculate the new step
*
            IF( .NOT.SWTCH3 ) THEN
               DTIPSQ = WORK( IP1 )*DELTA( IP1 )
               DTISQ = WORK( I )*DELTA( I )
               IF( .NOT.SWTCH ) THEN
                  IF( ORGATI ) THEN
                     C = W - DTIPSQ*DW + DELSQ*( Z( I ) / DTISQ )**2
                  ELSE
                     C = W - DTISQ*DW - DELSQ*( Z( IP1 ) / DTIPSQ )**2
                  END IF
               ELSE
                  TEMP = Z( II ) / ( WORK( II )*DELTA( II ) )
                  IF( ORGATI ) THEN
                     DPSI = DPSI + TEMP*TEMP
                  ELSE
                     DPHI = DPHI + TEMP*TEMP
                  END IF
                  C = W - DTISQ*DPSI - DTIPSQ*DPHI
               END IF
               A = ( DTIPSQ+DTISQ )*W - DTIPSQ*DTISQ*DW
               B = DTIPSQ*DTISQ*W
               IF( C.EQ.ZERO ) THEN
                  IF( A.EQ.ZERO ) THEN
                     IF( .NOT.SWTCH ) THEN
                        IF( ORGATI ) THEN
                           A = Z( I )*Z( I ) + DTIPSQ*DTIPSQ*
     $                         ( DPSI+DPHI )
                        ELSE
                           A = Z( IP1 )*Z( IP1 ) +
     $                         DTISQ*DTISQ*( DPSI+DPHI )
                        END IF
                     ELSE
                        A = DTISQ*DTISQ*DPSI + DTIPSQ*DTIPSQ*DPHI
                     END IF
                  END IF
                  ETA = B / A
               ELSE IF( A.LE.ZERO ) THEN
                  ETA = ( A-SQRT( ABS( A*A-FOUR*B*C ) ) ) / ( TWO*C )
               ELSE
                  ETA = TWO*B / ( A+SQRT( ABS( A*A-FOUR*B*C ) ) )
               END IF
            ELSE
*
*              Interpolation using THREE most relevant poles
*
               DTIIM = WORK( IIM1 )*DELTA( IIM1 )
               DTIIP = WORK( IIP1 )*DELTA( IIP1 )
               TEMP = RHOINV + PSI + PHI
               IF( SWTCH ) THEN
                  C = TEMP - DTIIM*DPSI - DTIIP*DPHI
                  ZZ( 1 ) = DTIIM*DTIIM*DPSI
                  ZZ( 3 ) = DTIIP*DTIIP*DPHI
               ELSE
                  IF( ORGATI ) THEN
                     TEMP1 = Z( IIM1 ) / DTIIM
                     TEMP1 = TEMP1*TEMP1
                     TEMP2 = ( D( IIM1 )-D( IIP1 ) )*
     $                       ( D( IIM1 )+D( IIP1 ) )*TEMP1
                     C = TEMP - DTIIP*( DPSI+DPHI ) - TEMP2
                     ZZ( 1 ) = Z( IIM1 )*Z( IIM1 )
                     IF( DPSI.LT.TEMP1 ) THEN
                        ZZ( 3 ) = DTIIP*DTIIP*DPHI
                     ELSE
                        ZZ( 3 ) = DTIIP*DTIIP*( ( DPSI-TEMP1 )+DPHI )
                     END IF
                  ELSE
                     TEMP1 = Z( IIP1 ) / DTIIP
                     TEMP1 = TEMP1*TEMP1
                     TEMP2 = ( D( IIP1 )-D( IIM1 ) )*
     $                       ( D( IIM1 )+D( IIP1 ) )*TEMP1
                     C = TEMP - DTIIM*( DPSI+DPHI ) - TEMP2
                     IF( DPHI.LT.TEMP1 ) THEN
                        ZZ( 1 ) = DTIIM*DTIIM*DPSI
                     ELSE
                        ZZ( 1 ) = DTIIM*DTIIM*( DPSI+( DPHI-TEMP1 ) )
                     END IF
                     ZZ( 3 ) = Z( IIP1 )*Z( IIP1 )
                  END IF
               END IF
               DD( 1 ) = DTIIM
               DD( 2 ) = DELTA( II )*WORK( II )
               DD( 3 ) = DTIIP
               CALL DLAED6( NITER, ORGATI, C, DD, ZZ, W, ETA, INFO )
               IF( INFO.NE.0 )
     $            GO TO 240
            END IF
*
*           Note, eta should be positive if w is negative, and
*           eta should be negative otherwise. However,
*           if for some reason caused by roundoff, eta*w > 0,
*           we simply use one Newton step instead. This way
*           will guarantee eta*w < 0.
*
            IF( W*ETA.GE.ZERO )
     $         ETA = -W / DW
            IF( ORGATI ) THEN
               TEMP1 = WORK( I )*DELTA( I )
               TEMP = ETA - TEMP1
            ELSE
               TEMP1 = WORK( IP1 )*DELTA( IP1 )
               TEMP = ETA - TEMP1
            END IF
            IF( TEMP.GT.SG2UB .OR. TEMP.LT.SG2LB ) THEN
               IF( W.LT.ZERO ) THEN
                  ETA = ( SG2UB-TAU ) / TWO
               ELSE
                  ETA = ( SG2LB-TAU ) / TWO
               END IF
            END IF
*
            TAU = TAU + ETA
            ETA = ETA / ( SIGMA+SQRT( SIGMA*SIGMA+ETA ) )
*
            SIGMA = SIGMA + ETA
            DO 200 J = 1, N
               WORK( J ) = WORK( J ) + ETA
               DELTA( J ) = DELTA( J ) - ETA
  200       CONTINUE
*
            PREW = W
*
*           Evaluate PSI and the derivative DPSI
*
            DPSI = ZERO
            PSI = ZERO
            ERRETM = ZERO
            DO 210 J = 1, IIM1
               TEMP = Z( J ) / ( WORK( J )*DELTA( J ) )
               PSI = PSI + Z( J )*TEMP
               DPSI = DPSI + TEMP*TEMP
               ERRETM = ERRETM + PSI
  210       CONTINUE
            ERRETM = ABS( ERRETM )
*
*           Evaluate PHI and the derivative DPHI
*
            DPHI = ZERO
            PHI = ZERO
            DO 220 J = N, IIP1, -1
               TEMP = Z( J ) / ( WORK( J )*DELTA( J ) )
               PHI = PHI + Z( J )*TEMP
               DPHI = DPHI + TEMP*TEMP
               ERRETM = ERRETM + PHI
  220       CONTINUE
*
            TEMP = Z( II ) / ( WORK( II )*DELTA( II ) )
            DW = DPSI + DPHI + TEMP*TEMP
            TEMP = Z( II )*TEMP
            W = RHOINV + PHI + PSI + TEMP
            ERRETM = EIGHT*( PHI-PSI ) + ERRETM + TWO*RHOINV +
     $               THREE*ABS( TEMP ) + ABS( TAU )*DW
            IF( W*PREW.GT.ZERO .AND. ABS( W ).GT.ABS( PREW ) / TEN )
     $         SWTCH = .NOT.SWTCH
*
            IF( W.LE.ZERO ) THEN
               SG2LB = MAX( SG2LB, TAU )
            ELSE
               SG2UB = MIN( SG2UB, TAU )
            END IF
*
  230    CONTINUE
*
*        Return with INFO = 1, NITER = MAXIT and not converged
*
         INFO = 1
*
      END IF
*
  240 CONTINUE
      RETURN
*
*     End of DLASD4
*
      END

C
C $Id: frst3.f,v 1.6 2008-07-27 00:17:33 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE FRST3 (U,V,W)
      XDUM = 5.
      CALL TRN32T (U,V,W,X,Y,XDUM,2)
      CALL PLOTIT  (32*INT(X),32*INT(Y),0)
      RETURN
      END

C
C	$Id: bound.f,v 1.4 2008-07-27 00:17:14 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE BOUND (Z,MX,NNX,NNY,SSP)
      DIMENSION       Z(MX,NNY)   ,PX(2)   ,PY(2)
C
C BOUND DRAWS A POLYGONAL BOUNDRY AROUND ANY SPECIAL-VALUE AREAS IN Z.
C
      SAVE
      NX = NNX
      NY = NNY
C
C VERTICAL LINES
C
      SP = SSP
      DO 103 IP1=3,NX
         I = IP1-1
         PX(1) = I
         PX(2) = I
         IM1 = I-1
         DO 102 JP1=2,NY
            PY(2) = JP1
            J = JP1-1
            PY(1) = J
            KLEFT = 0
            IF (Z(IM1,J).EQ.SP .OR. Z(IM1,JP1).EQ.SP) KLEFT = 1
            KCENT = 0
            IF (Z(I,J).EQ.SP .OR. Z(I,JP1).EQ.SP) KCENT = 1
            KRIGT = 0
            IF (Z(IP1,J).EQ.SP .OR. Z(IP1,JP1).EQ.SP) KRIGT = 1
            JUMP = KLEFT*4+KCENT*2+KRIGT+1
            GO TO (102,101,102,102,101,102,102,102,102),JUMP
  101       CALL GPL (2,PX,PY)
  102    CONTINUE
  103 CONTINUE
C
C HORIZONTAL
C
      DO 106 JP1=3,NY
         J = JP1-1
         PY(1) = J
         PY(2) = J
         JM1 = J-1
         DO 105 IP1=2,NX
            PX(2) = IP1
            I = IP1-1
            PX(1) = I
            KLOWR = 0
            IF (Z(I,JM1).EQ.SP .OR. Z(IP1,JM1).EQ.SP) KLOWR = 1
            KCENT = 0
            IF (Z(I,J).EQ.SP .OR. Z(IP1,J).EQ.SP) KCENT = 1
            KUPER = 0
            IF (Z(I,JP1).EQ.SP .OR. Z(IP1,JP1).EQ.SP) KUPER = 1
            JUMP = KLOWR*4+KCENT*2+KUPER+1
            GO TO (105,104,105,105,104,105,105,105,105),JUMP
  104       CALL GPL (2,PX,PY)
  105    CONTINUE
  106 CONTINUE
      RETURN
      END

      SUBROUTINE CTREVC( SIDE, HOWMNY, SELECT, N, T, LDT, VL, LDVL, VR,
     $                   LDVR, MM, M, WORK, RWORK, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          HOWMNY, SIDE
      INTEGER            INFO, LDT, LDVL, LDVR, M, MM, N
*     ..
*     .. Array Arguments ..
      LOGICAL            SELECT( * )
      REAL               RWORK( * )
      COMPLEX            T( LDT, * ), VL( LDVL, * ), VR( LDVR, * ),
     $                   WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  CTREVC computes some or all of the right and/or left eigenvectors of
*  a complex upper triangular matrix T.
*
*  The right eigenvector x and the left eigenvector y of T corresponding
*  to an eigenvalue w are defined by:
*
*               T*x = w*x,     y'*T = w*y'
*
*  where y' denotes the conjugate transpose of the vector y.
*
*  If all eigenvectors are requested, the routine may either return the
*  matrices X and/or Y of right or left eigenvectors of T, or the
*  products Q*X and/or Q*Y, where Q is an input unitary
*  matrix. If T was obtained from the Schur factorization of an
*  original matrix A = Q*T*Q', then Q*X and Q*Y are the matrices of
*  right or left eigenvectors of A.
*
*  Arguments
*  =========
*
*  SIDE    (input) CHARACTER*1
*          = 'R':  compute right eigenvectors only;
*          = 'L':  compute left eigenvectors only;
*          = 'B':  compute both right and left eigenvectors.
*
*  HOWMNY  (input) CHARACTER*1
*          = 'A':  compute all right and/or left eigenvectors;
*          = 'B':  compute all right and/or left eigenvectors,
*                  and backtransform them using the input matrices
*                  supplied in VR and/or VL;
*          = 'S':  compute selected right and/or left eigenvectors,
*                  specified by the logical array SELECT.
*
*  SELECT  (input) LOGICAL array, dimension (N)
*          If HOWMNY = 'S', SELECT specifies the eigenvectors to be
*          computed.
*          If HOWMNY = 'A' or 'B', SELECT is not referenced.
*          To select the eigenvector corresponding to the j-th
*          eigenvalue, SELECT(j) must be set to .TRUE..
*
*  N       (input) INTEGER
*          The order of the matrix T. N >= 0.
*
*  T       (input/output) COMPLEX array, dimension (LDT,N)
*          The upper triangular matrix T.  T is modified, but restored
*          on exit.
*
*  LDT     (input) INTEGER
*          The leading dimension of the array T. LDT >= max(1,N).
*
*  VL      (input/output) COMPLEX array, dimension (LDVL,MM)
*          On entry, if SIDE = 'L' or 'B' and HOWMNY = 'B', VL must
*          contain an N-by-N matrix Q (usually the unitary matrix Q of
*          Schur vectors returned by CHSEQR).
*          On exit, if SIDE = 'L' or 'B', VL contains:
*          if HOWMNY = 'A', the matrix Y of left eigenvectors of T;
*                           VL is lower triangular. The i-th column
*                           VL(i) of VL is the eigenvector corresponding
*                           to T(i,i).
*          if HOWMNY = 'B', the matrix Q*Y;
*          if HOWMNY = 'S', the left eigenvectors of T specified by
*                           SELECT, stored consecutively in the columns
*                           of VL, in the same order as their
*                           eigenvalues.
*          If SIDE = 'R', VL is not referenced.
*
*  LDVL    (input) INTEGER
*          The leading dimension of the array VL.  LDVL >= max(1,N) if
*          SIDE = 'L' or 'B'; LDVL >= 1 otherwise.
*
*  VR      (input/output) COMPLEX array, dimension (LDVR,MM)
*          On entry, if SIDE = 'R' or 'B' and HOWMNY = 'B', VR must
*          contain an N-by-N matrix Q (usually the unitary matrix Q of
*          Schur vectors returned by CHSEQR).
*          On exit, if SIDE = 'R' or 'B', VR contains:
*          if HOWMNY = 'A', the matrix X of right eigenvectors of T;
*                           VR is upper triangular. The i-th column
*                           VR(i) of VR is the eigenvector corresponding
*                           to T(i,i).
*          if HOWMNY = 'B', the matrix Q*X;
*          if HOWMNY = 'S', the right eigenvectors of T specified by
*                           SELECT, stored consecutively in the columns
*                           of VR, in the same order as their
*                           eigenvalues.
*          If SIDE = 'L', VR is not referenced.
*
*  LDVR    (input) INTEGER
*          The leading dimension of the array VR.  LDVR >= max(1,N) if
*           SIDE = 'R' or 'B'; LDVR >= 1 otherwise.
*
*  MM      (input) INTEGER
*          The number of columns in the arrays VL and/or VR. MM >= M.
*
*  M       (output) INTEGER
*          The number of columns in the arrays VL and/or VR actually
*          used to store the eigenvectors.  If HOWMNY = 'A' or 'B', M
*          is set to N.  Each selected eigenvector occupies one
*          column.
*
*  WORK    (workspace) COMPLEX array, dimension (2*N)
*
*  RWORK   (workspace) REAL array, dimension (N)
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*
*  Further Details
*  ===============
*
*  The algorithm used in this program is basically backward (forward)
*  substitution, with scaling to make the the code robust against
*  possible overflow.
*
*  Each eigenvector is normalized so that the element of largest
*  magnitude has magnitude 1; here the magnitude of a complex number
*  (x,y) is taken to be |x| + |y|.
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ZERO, ONE
      PARAMETER          ( ZERO = 0.0E+0, ONE = 1.0E+0 )
      COMPLEX            CMZERO, CMONE
      PARAMETER          ( CMZERO = ( 0.0E+0, 0.0E+0 ),
     $                   CMONE = ( 1.0E+0, 0.0E+0 ) )
*     ..
*     .. Local Scalars ..
      LOGICAL            ALLV, BOTHV, LEFTV, OVER, RIGHTV, SOMEV
      INTEGER            I, II, IS, J, K, KI
      REAL               OVFL, REMAX, SCALE, SMIN, SMLNUM, ULP, UNFL
      COMPLEX            CDUM
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            ICAMAX
      REAL               SCASUM, SLAMCH
      EXTERNAL           LSAME, ICAMAX, SCASUM, SLAMCH
*     ..
*     .. External Subroutines ..
      EXTERNAL           CCOPY, CGEMV, CLATRS, CSSCAL, SLABAD, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, AIMAG, CMPLX, CONJG, MAX, REAL
*     ..
*     .. Statement Functions ..
      REAL               CABS1
*     ..
*     .. Statement Function definitions ..
      CABS1( CDUM ) = ABS( REAL( CDUM ) ) + ABS( AIMAG( CDUM ) )
*     ..
*     .. Executable Statements ..
*
*     Decode and test the input parameters
*
      BOTHV = LSAME( SIDE, 'B' )
      RIGHTV = LSAME( SIDE, 'R' ) .OR. BOTHV
      LEFTV = LSAME( SIDE, 'L' ) .OR. BOTHV
*
      ALLV = LSAME( HOWMNY, 'A' )
      OVER = LSAME( HOWMNY, 'B' )
      SOMEV = LSAME( HOWMNY, 'S' )
*
*     Set M to the number of columns required to store the selected
*     eigenvectors.
*
      IF( SOMEV ) THEN
         M = 0
         DO 10 J = 1, N
            IF( SELECT( J ) )
     $         M = M + 1
   10    CONTINUE
      ELSE
         M = N
      END IF
*
      INFO = 0
      IF( .NOT.RIGHTV .AND. .NOT.LEFTV ) THEN
         INFO = -1
      ELSE IF( .NOT.ALLV .AND. .NOT.OVER .AND. .NOT.SOMEV ) THEN
         INFO = -2
      ELSE IF( N.LT.0 ) THEN
         INFO = -4
      ELSE IF( LDT.LT.MAX( 1, N ) ) THEN
         INFO = -6
      ELSE IF( LDVL.LT.1 .OR. ( LEFTV .AND. LDVL.LT.N ) ) THEN
         INFO = -8
      ELSE IF( LDVR.LT.1 .OR. ( RIGHTV .AND. LDVR.LT.N ) ) THEN
         INFO = -10
      ELSE IF( MM.LT.M ) THEN
         INFO = -11
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'CTREVC', -INFO )
         RETURN
      END IF
*
*     Quick return if possible.
*
      IF( N.EQ.0 )
     $   RETURN
*
*     Set the constants to control overflow.
*
      UNFL = SLAMCH( 'Safe minimum' )
      OVFL = ONE / UNFL
      CALL SLABAD( UNFL, OVFL )
      ULP = SLAMCH( 'Precision' )
      SMLNUM = UNFL*( N / ULP )
*
*     Store the diagonal elements of T in working array WORK.
*
      DO 20 I = 1, N
         WORK( I+N ) = T( I, I )
   20 CONTINUE
*
*     Compute 1-norm of each column of strictly upper triangular
*     part of T to control overflow in triangular solver.
*
      RWORK( 1 ) = ZERO
      DO 30 J = 2, N
         RWORK( J ) = SCASUM( J-1, T( 1, J ), 1 )
   30 CONTINUE
*
      IF( RIGHTV ) THEN
*
*        Compute right eigenvectors.
*
         IS = M
         DO 80 KI = N, 1, -1
*
            IF( SOMEV ) THEN
               IF( .NOT.SELECT( KI ) )
     $            GO TO 80
            END IF
            SMIN = MAX( ULP*( CABS1( T( KI, KI ) ) ), SMLNUM )
*
            WORK( 1 ) = CMONE
*
*           Form right-hand side.
*
            DO 40 K = 1, KI - 1
               WORK( K ) = -T( K, KI )
   40       CONTINUE
*
*           Solve the triangular system:
*              (T(1:KI-1,1:KI-1) - T(KI,KI))*X = SCALE*WORK.
*
            DO 50 K = 1, KI - 1
               T( K, K ) = T( K, K ) - T( KI, KI )
               IF( CABS1( T( K, K ) ).LT.SMIN )
     $            T( K, K ) = SMIN
   50       CONTINUE
*
            IF( KI.GT.1 ) THEN
               CALL CLATRS( 'Upper', 'No transpose', 'Non-unit', 'Y',
     $                      KI-1, T, LDT, WORK( 1 ), SCALE, RWORK,
     $                      INFO )
               WORK( KI ) = SCALE
            END IF
*
*           Copy the vector x or Q*x to VR and normalize.
*
            IF( .NOT.OVER ) THEN
               CALL CCOPY( KI, WORK( 1 ), 1, VR( 1, IS ), 1 )
*
               II = ICAMAX( KI, VR( 1, IS ), 1 )
               REMAX = ONE / CABS1( VR( II, IS ) )
               CALL CSSCAL( KI, REMAX, VR( 1, IS ), 1 )
*
               DO 60 K = KI + 1, N
                  VR( K, IS ) = CMZERO
   60          CONTINUE
            ELSE
               IF( KI.GT.1 )
     $            CALL CGEMV( 'N', N, KI-1, CMONE, VR, LDVR, WORK( 1 ),
     $                        1, CMPLX( SCALE ), VR( 1, KI ), 1 )
*
               II = ICAMAX( N, VR( 1, KI ), 1 )
               REMAX = ONE / CABS1( VR( II, KI ) )
               CALL CSSCAL( N, REMAX, VR( 1, KI ), 1 )
            END IF
*
*           Set back the original diagonal elements of T.
*
            DO 70 K = 1, KI - 1
               T( K, K ) = WORK( K+N )
   70       CONTINUE
*
            IS = IS - 1
   80    CONTINUE
      END IF
*
      IF( LEFTV ) THEN
*
*        Compute left eigenvectors.
*
         IS = 1
         DO 130 KI = 1, N
*
            IF( SOMEV ) THEN
               IF( .NOT.SELECT( KI ) )
     $            GO TO 130
            END IF
            SMIN = MAX( ULP*( CABS1( T( KI, KI ) ) ), SMLNUM )
*
            WORK( N ) = CMONE
*
*           Form right-hand side.
*
            DO 90 K = KI + 1, N
               WORK( K ) = -CONJG( T( KI, K ) )
   90       CONTINUE
*
*           Solve the triangular system:
*              (T(KI+1:N,KI+1:N) - T(KI,KI))'*X = SCALE*WORK.
*
            DO 100 K = KI + 1, N
               T( K, K ) = T( K, K ) - T( KI, KI )
               IF( CABS1( T( K, K ) ).LT.SMIN )
     $            T( K, K ) = SMIN
  100       CONTINUE
*
            IF( KI.LT.N ) THEN
               CALL CLATRS( 'Upper', 'Conjugate transpose', 'Non-unit',
     $                      'Y', N-KI, T( KI+1, KI+1 ), LDT,
     $                      WORK( KI+1 ), SCALE, RWORK, INFO )
               WORK( KI ) = SCALE
            END IF
*
*           Copy the vector x or Q*x to VL and normalize.
*
            IF( .NOT.OVER ) THEN
               CALL CCOPY( N-KI+1, WORK( KI ), 1, VL( KI, IS ), 1 )
*
               II = ICAMAX( N-KI+1, VL( KI, IS ), 1 ) + KI - 1
               REMAX = ONE / CABS1( VL( II, IS ) )
               CALL CSSCAL( N-KI+1, REMAX, VL( KI, IS ), 1 )
*
               DO 110 K = 1, KI - 1
                  VL( K, IS ) = CMZERO
  110          CONTINUE
            ELSE
               IF( KI.LT.N )
     $            CALL CGEMV( 'N', N, N-KI, CMONE, VL( 1, KI+1 ), LDVL,
     $                        WORK( KI+1 ), 1, CMPLX( SCALE ),
     $                        VL( 1, KI ), 1 )
*
               II = ICAMAX( N, VL( 1, KI ), 1 )
               REMAX = ONE / CABS1( VL( II, KI ) )
               CALL CSSCAL( N, REMAX, VL( 1, KI ), 1 )
            END IF
*
*           Set back the original diagonal elements of T.
*
            DO 120 K = KI + 1, N
               T( K, K ) = WORK( K+N )
  120       CONTINUE
*
            IS = IS + 1
  130    CONTINUE
      END IF
*
      RETURN
*
*     End of CTREVC
*
      END

C
C	$Id: gwpdva.f,v 1.5 2008-07-27 00:21:08 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GWPDVA
C
C  Update all attribute deferral variables.
C
      include 'gksin.h'
      include 'gwiarq.h'
      include 'gwiast.h'
      include 'gwiadc.h'
C
      INTEGER  IPRIM, I, IOFF, JOFF, J
C
      SAVE
C
C  Copy default attribute context to "SET" context.
C
      CALL GWID2S
C
C  Go through the attribute structures GWIARQ and GWIAST to
C  reset the attribute context variables.
C
C  Polyline attributes.
C
      IPRIM = 1
      AGPEND(IPRIM) = .FALSE.
      DO 100 I=IVPLIX,IVPLCI
        IOFF = ABS(IP2AEA(I))
C
C  Is the requested value different from the sent?
C  The following code reflects the fact that all attribute
C  variables for polyline are stored contiguously.
C
        IF (IP2AEA(I) .GT. 0) THEN
          VALCHG(I) = MSAEQV(IOFF).NE.MRAEQV(IOFF)
        ELSE
          VALCHG(I) = ASAEQV(IOFF).NE.ARAEQV(IOFF)
        ENDIF
C
C  Update aggregate change parameter.
C
        AGPEND(IPRIM) = AGPEND(IPRIM) .OR. VALCHG(I)
  100 CONTINUE
C
C  Polymarker attributes.
C
      IPRIM = 2
      AGPEND(IPRIM) = .FALSE.
      DO 140 I=IVPMIX,IVPMCI
C
        IOFF = ABS(IP2AEA(I))
C
C  Is the requested value different from the sent?
C  The following code reflects the fact that all attribute
C  variables for polymarker are stored contiguously.
C
        IF (IP2AEA(I) .GT. 0) THEN
          VALCHG(I) = MSAEQV(IOFF).NE.MRAEQV(IOFF)
        ELSE
          VALCHG(I) = ASAEQV(IOFF).NE.ARAEQV(IOFF)
        ENDIF
C
C  Update aggregate change parameter.
C
        AGPEND(IPRIM) = AGPEND(IPRIM) .OR. VALCHG(I)
C
  140 CONTINUE
C
C  Text attributes.
C
      IPRIM = 3
      AGPEND(IPRIM) = .FALSE.
      DO 150 I=IVTXIX,IVTXCI
C
        IOFF = ABS(IP2AEA(I))
        JOFF = IOFF + IL2AEA(I) - 1
C
C  Is the requested value different from the sent?
C
        IF (IP2AEA(I) .GT. 0) THEN
          VALCHG(I) = MSAEQV(IOFF).NE.MRAEQV(IOFF)
          DO 110 J=IOFF+1,JOFF
            VALCHG(I) = VALCHG(I) .OR. MSAEQV(J).NE.MRAEQV(J)
  110     CONTINUE
        ELSE
          VALCHG(I) = ASAEQV(IOFF).NE.ARAEQV(IOFF)
          DO 120 J=IOFF+1,JOFF
            VALCHG(I) = VALCHG(I) .OR. ASAEQV(J).NE.ARAEQV(J)
  120     CONTINUE
        ENDIF
C
C  Update aggregate change parameter.
C
        AGPEND(IPRIM) = AGPEND(IPRIM) .OR. VALCHG(I)
C
  150 CONTINUE
C
C  Fill area attributes.
C
      IPRIM = 4
      AGPEND(IPRIM) = .FALSE.
      DO 160 I=IVFAIX,IVFACI
C
        IOFF = ABS(IP2AEA(I))
        JOFF = IOFF + IL2AEA(I) - 1
C
C  Is the requested value different from the sent?
C
        IF (IP2AEA(I) .GT. 0) THEN
          VALCHG(I) = MSAEQV(IOFF).NE.MRAEQV(IOFF)
          DO 170 J=IOFF+1,JOFF
            VALCHG(I) = VALCHG(I) .OR. MSAEQV(J).NE.MRAEQV(J)
  170     CONTINUE
        ELSE
          VALCHG(I) = ASAEQV(IOFF).NE.ARAEQV(IOFF)
          DO 180 J=IOFF+1,JOFF
            VALCHG(I) = VALCHG(I) .OR. ASAEQV(J).NE.ARAEQV(J)
  180     CONTINUE
        ENDIF
C
C  Update aggregate change parameter.
C
        AGPEND(IPRIM) = AGPEND(IPRIM) .OR. VALCHG(I)
  160 CONTINUE
C
C  Update aspect source flag context.
C
      DO 190 I=1,13
        ID(I) = MRASF(I)
  190 CONTINUE
      CALL GWPASF
C
      RETURN
      END

c ---------------------------------------------------------------
      SUBROUTINE DHYDRO(P,TKV,ZSFC,NLVL,ZH,IER)
      IMPLICIT NONE

c NCL: zh = hydro (p,tkv,zsfc)

c use the hydrostatic eqn to get geopotential height
c .   it is assumed that p(1) and tkv(1) contain the
c .   surface quantities corresponding to zsfc.

c .   missing data not allowed
C input

C no. levels; error code
      INTEGER NLVL,IER
C pres (Pa)
C temp (K) at each "p"
C sfc geopotential height (gpm)
      DOUBLE PRECISION P(NLVL),TKV(NLVL),ZSFC
C output

C calculated geopotential (gpm)
      DOUBLE PRECISION ZH(NLVL)
C local

      INTEGER NL
      DOUBLE PRECISION G,RDAIR,RDAG,TVBAR

c     --------
      IER = 0
      IF (NLVL.LT.1) THEN
C unrealistic nlvl value
          IER = -1
          RETURN
      END IF

C gravity at 45 deg lat used by the WMO
      G = 9.80665D0
C gas const dry air (j/{kg-k})
      RDAIR = 287.04D0
      RDAG = RDAIR/G

c calculate geopotential height if initial z available [hydrostatic eq]

      ZH(1) = ZSFC
      DO NL = 2,NLVL
C same as [ln(p(nl)+ln(p(nl-1)]
          TVBAR = (TKV(NL)*DLOG(P(NL))+TKV(NL-1)*DLOG(P(NL-1)))/
     +            DLOG(P(NL)*P(NL-1))
          ZH(NL) = ZH(NL-1) + RDAG*TVBAR*DLOG(P(NL-1)/P(NL))
      END DO

      RETURN
      END

C NCLFORTSTART                                                        
      subroutine wrfcttcalc(prs,tk,qci,qcw,qvp,ght,ter,ctt,
     &                      haveqci,nz,ns,ew)

      implicit none
      integer nz,ns,ew,haveqci 
      double precision    ght(ew,ns,nz)
      double precision    prs(ew,ns,nz),tk(ew,ns,nz)
      double precision    qci(ew,ns,nz),qcw(ew,ns,nz)
      double precision    qvp(ew,ns,nz)
      double precision    ctt(ew,ns),ter(ew,ns)
c      double precision    znfac(nz)
C NCLEND
c
c
      integer i,j,k,mjx,miy,mkzh,ripk,wrfout
      double precision    vt,rgas,grav,opdepthu,opdepthd,dp
      double precision    ratmix,eps,arg1,arg2,agl_hgt,ussalr
      double precision    abscoefi,abscoef,fac,prsctt,celkel
c      double precision    ght(ew,ns,nz),stuff(ew,ns)
      double precision    pf(ns,ew,nz),p1,p2
c
c
       mjx      =   ew 
       miy      =   ns 
       mkzh     =   nz 
       eps      = 0.622d0
       ussalr   = .0065d0      ! deg C per m
       rgas     = 287.04d0     !J/K/kg
       grav     = 9.81d0
       abscoefi = .272d0  ! cloud ice absorption coefficient in m^2/g
       abscoef  =.145d0   ! cloud water absorption coefficient in m^2/g
       celkel   = 273.15d0 
       wrfout = 1


cCalculate the surface pressure 
       do j=1,ew
       do i=1,ns
           ratmix     = .001d0*qvp(j,i,1)
           arg1       = eps + ratmix
           arg2       = eps*(1.+ratmix)
           vt         =  tk(j,i,1) * arg1/arg2 !Virtual temperature
           agl_hgt    = ght(j,i,nz) - ter(j,i)
           arg1       = -grav/(rgas*ussalr)
           pf(i,j,nz) = prs(j,i,1)*
     &                        (vt/(vt+ussalr*(agl_hgt)))**(arg1)
       enddo
       enddo


c
       do j=1,ew
       do i=1,ns
          do k=1,nz-1
            ripk = nz-k+1
            pf(i,j,k)=.5d0*(prs(j,i,ripk)+prs(j,i,ripk-1))
          enddo
      enddo
      enddo

      do 190 j=1,ew
      do 190 i=1,ns
         opdepthd=0.d0
         k=1

c
c      Integrate downward from model top, calculating path at full
c      model vertical levels.
c
   20    opdepthu=opdepthd
         k=k+1
         ripk = nz-k+1

         if (k.eq.1) then
            dp=200.d0*(pf(i,j,1)-prs(j,i,nz))  ! should be in Pa
         else
            dp=100.d0*(pf(i,j,k)-pf(i,j,k-1))  ! should be in Pa
         endif 
         if (haveqci .eq. 0) then
            if (tk(i,j,k).lt.celkel) then
c             Note: abscoefi is m**2/g, qcw is g/kg,
c                   so no convrsion needed
               opdepthd=opdepthu+abscoefi*qcw(j,i,ripk)*dp/grav
            else
               opdepthd=opdepthu+abscoef*qcw(j,i,ripk)*dp/grav
            endif
         else
            opdepthd=opdepthd+(abscoef*qcw(j,i,ripk)+
     &                         abscoefi*qci(j,i,ripk))*dp/grav
         endif
         
          if (opdepthd.lt.1..and.k.lt.nz) then
            goto 20
         elseif (opdepthd.lt.1..and.k.eq.nz) then
            prsctt=prs(j,i,1)
         else
            fac=(1.-opdepthu)/(opdepthd-opdepthu)
            prsctt=pf(i,j,k-1)+fac*(pf(i,j,k)-pf(i,j,k-1))
            prsctt=min(prs(j,i,1),max(prs(j,i,nz),prsctt))
         endif

         do 30 k=2,nz
            ripk = nz-k+1
            p1   = prs(j,i,ripk+1)
            p2   = prs(j,i,ripk)
            if (prsctt .ge. p1 .and. prsctt .le .p2) then
               fac=(prsctt-p1)/(p2-p1)
               arg1 = fac*(tk(j,i,ripk)-tk(j,i,ripk+1))-celkel
               ctt(j,i) = tk(j,i,ripk+1)+ arg1
               goto 40
            endif
   30    continue 
   40    continue
 190  continue
      return
      end

C
C	$Id: stline.f,v 1.4 2008-07-27 00:23:02 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE STLINE (Z,LL,MM,NN,CONV)
      SAVE
      DIMENSION       Z(LL,NN)
C
C THIS ROUTINE FINDS THE BEGINNINGS OF ALL CONTOUR LINES AT LEVEL CONV.
C FIRST THE EDGES ARE SEARCHED FOR LINES INTERSECTING THE EDGE (OPEN
C LINES) THEN THE INTERIOR IS SEARCHED FOR LINES WHICH DO NOT INTERSECT
C THE EDGE (CLOSED LINES).  BEGINNINGS ARE STORED IN IR TO PREVENT RE-
C TRACING OF LINES.  IF IR IS FILLED, THE SEARCH IS STOPPED FOR THIS
C CONV.
C
      COMMON /CONRE2/ IX         ,IY         ,IDX        ,IDY        ,
     1                IS         ,ISS        ,NP         ,CV         ,
     2                INX(8)     ,INY(8)     ,IR(2000)   ,NR
      COMMON /CONRE3/ IXBITS     ,IYBITS
C
      IXYPAK(IXX,IYY) = ISHIFT(IXX,IYBITS)+IYY
C
      L = LL
      M = MM
      N = NN
      CV = CONV
      NP = 0
      ISS = 0
      DO 102 IP1=2,M
         I = IP1-1
         IF (Z(I,1).GE.CV .OR. Z(IP1,1).LT.CV) GO TO 101
         IX = IP1
         IY = 1
         IDX = -1
         IDY = 0
         IS = 1
         CALL CRDRLN (Z,L,M,N)
  101    IF (Z(IP1,N).GE.CV .OR. Z(I,N).LT.CV) GO TO 102
         IX = I
         IY = N
         IDX = 1
         IDY = 0
         IS = 5
         CALL CRDRLN (Z,L,M,N)
  102 CONTINUE
      DO 104 JP1=2,N
         J = JP1-1
         IF (Z(M,J).GE.CV .OR. Z(M,JP1).LT.CV) GO TO 103
         IX = M
         IY = JP1
         IDX = 0
         IDY = -1
         IS = 7
         CALL CRDRLN (Z,L,M,N)
  103    IF (Z(1,JP1).GE.CV .OR. Z(1,J).LT.CV) GO TO 104
         IX = 1
         IY = J
         IDX = 0
         IDY = 1
         IS = 3
         CALL CRDRLN (Z,L,M,N)
  104 CONTINUE
      ISS = 1
      DO 108 JP1=3,N
         J = JP1-1
         DO 107 IP1=2,M
            I = IP1-1
            IF (Z(I,J).GE.CV .OR. Z(IP1,J).LT.CV) GO TO 107
            IXY = IXYPAK(IP1,J)
            IF (NP .EQ. 0) GO TO 106
            DO 105 K=1,NP
               IF (IR(K) .EQ. IXY) GO TO 107
  105       CONTINUE
  106       NP = NP+1
            IF (NP .GT. NR) THEN
C
C THIS PRINTS AN ERROR MESSAGE IF THE LOCAL ARRAY IR IN SUBROUTINE
C STLINE HAS AN OVERFLOW
C THIS MESSAGE IS WRITTEN BOTH ON THE FRAME AND ON THE STANDARD ERROR
C UNIT
C
      IUNIT = I1MACH(4)
      WRITE(IUNIT,1000)
 1000 FORMAT(
     1' WARNING FROM ROUTINE STLINE IN CONREC--WORK ARRAY OVERFLOW')
      CALL GETSET(VXA,VXB,VYA,VYB,XA,XB,YA,YB,LTYPE)
      X = (VXB + VXA) / 2.
      Y = (VYB + VYA) / 2.
      CALL PWRIT(CFUX(X),CFUY(Y),
     1'**WARNING--PICTURE INCOMPLETE**',
     2 31,3,0,0)
      Y = Y - .05
      CALL PWRIT(CFUX(X),CFUY(Y),
     1'WORK ARRAY OVERFLOW IN STLINE',
     2 29,3,0,0)
        RETURN
        ENDIF
            IR(NP) = IXY
            IX = IP1
            IY = J
            IDX = -1
            IDY = 0
            IS = 1
            CALL CRDRLN (Z,L,M,N)
  107    CONTINUE
  108 CONTINUE
      RETURN
      END

      PROGRAM TESTIT
C
C This program constructs a simple triangular mesh, including dummy flow
C data, and then traces curly vectors on it.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID, to be used in calls to GKS routines.  Use one
C of the following:
C
C       PARAMETER (IERF=6,LUNI=2,IWTY=1 ,IWID=1)  !  NCGM
C       PARAMETER (IERF=6,LUNI=2,IWTY=8 ,IWID=1)  !  X Windows
C       PARAMETER (IERF=6,LUNI=2,IWTY=20,IWID=1)  !  PostScript
C       PARAMETER (IERF=6,LUNI=2,IWTY=11,IWID=1)  !  PDF, Portrait
C       PARAMETER (IERF=6,LUNI=2,IWTY=12,IWID=1)  !  PDF, Landscape
C
        PARAMETER (IERF=6,LUNI=2,IWTYPE=1,IWTY=IWTYPE,IWID=1)
C
C Define a parameter saying how many pieces each edge of an icosahedron
C is to be broken into in forming the geodesic mesh.
C
C       PARAMETER (NDIV=3)
C       PARAMETER (NDIV=7)
C       PARAMETER (NDIV=15)
C       PARAMETER (NDIV=25)
        PARAMETER (NDIV=30)
C       PARAMETER (NDIV=45)
C       PARAMETER (NDIV=60)
C       PARAMETER (NDIV=80)
C       PARAMETER (NDIV=100)
C
C To represent the triangular mesh, we use three singly-dimensioned
C arrays: RPNT holds points, IEDG holds edges, and ITRI holds triangles.
C The elements of each array form "nodes" having lengths as follows:
C
        PARAMETER (LOPN=8)  !  length of a point node
C
C The eight elements of a point node are
C
C   1) the X coordinate of the point;
C   2) the Y coordinate of the point;
C   3) the Z coordinate of the point;
C   4) the X component of the flow field at the point;
C   5) the Y component of the flow field at the point;
C   6) the Z component of the flow field at the point;
C   7) the latitude of the point;
C   8) the longitude of the point.
C
C Latitude and longitude are not necessary; I'm using them for testing
C purposes.
C
        PARAMETER (LOEN=4)  !  length of an edge node
C
C The five elements of an edge node are
C
C   1) the base index, in RPNT, of point 1 of the edge;
C   2) the base index, in RPNT, of point 2 of the edge;
C   3) the index, in ITRI, of the pointer to the edge in the triangle
C      to the left of the edge (-1 if there is no triangle there);
C   4) the index, in ITRI, of the pointer to the edge in the triangle
C      to the right of the edge (-1 if there is no triangle there);
C   5) a utility flag for use by algorithms that scan the structure.
C
C The "left" and "right" sides of an edge are defined as they would be
C by an observer standing on the globe at point 1 of the edge, looking
C toward point 2 of the edge.  It is possible, if there are "holes" in
C the mesh, that there will be no triangle to the left or to the right
C of an edge, but there must be a triangle on at least one side of it.
C
        PARAMETER (LOTN=5)  !  length of a triangle node
C
C The five elements of a triangle node are
C
C   1) the base index, in IEDG, of edge 1 of the triangle;
C   2) the base index, in IEDG, of edge 2 of the triangle;
C   3) the base index, in IEDG, of edge 3 of the triangle;
C   4) a flag set non-zero to block use of the triangle, effectively
C      removing it from the mesh (different bits of this flag may be
C      used for different purposes, particularly when a 3D view is
C      being drawn);
C   5) a flag used by the streamline-drawing process.
C
C The "base index" of a point node, an edge node, or a triangle node is
C always a multiple of the length of the node, to which can be added an
C offset to get the index of a particular element of the node.  For
C example, if I is the base index of a triangle of interest, ITRI(I+1)
C is its first element (the base index of its first edge).  Similarly,
C IEDG(ITRI(I+1)+2) is the base index of the second point of the first
C edge of the triangle with base index I, and RPNT(IEDG(ITRI(I+1)+2)+3)
C is the third (Z) coordinate of the second point of the first edge of
C the triangle with base index I.
C
C It is the pointers from the edge nodes back to the triangle nodes that
C allow one to navigate the mesh, moving from triangle to triangle to
C follow a contour or a streamline; the pointers are tricky to define:
C if IPTE is the base index of an edge node and IEDG(IPTE+3) is zero or
C more, saying that there is a triangle to the left of the edge, then
C IEDG(IPTE+3) is the actual index of that element of the triangle node
C that points to the edge node; i.e., ITRI(IEDG(IPTE+3))=IPTE.  The base
C index of the triangle node defining that triangle is IPTT, where
C IPTT=LOTN*((IEDG(IPTE+3)-1)/LOTN), and the index of the pointer to
C the edge within the triangle node is IPTI=IEDG(IPTE+3)-IPTT, so that
C ITRI(IPTT+IPTI)=IPTE.  Similar comments apply to element 4 of an edge
C node, which points into the triangle node defining the triangle to the
C right of the edge.
C
C The maximum number of points, edges, and triangles in a geodesic mesh
C may be computed from the parameter NDIV, which determines the order of
C the geodesic mesh:
C
        PARAMETER (MNOP=10*NDIV*NDIV+2)  !  maximum number of points
        PARAMETER (MNOE=30*NDIV*NDIV)    !  maximum number of edges
        PARAMETER (MNOT=20*NDIV*NDIV)    !  maximum number of triangles
C
C Once we know how many points, edges, and triangles we're going to use
C (at most), we can set parameters defining the space reserved for the
C triangular mesh:
C
        PARAMETER (MPNT=MNOP*LOPN)  !  space for points
        PARAMETER (MEDG=MNOE*LOEN)  !  space for edges
        PARAMETER (MTRI=MNOT*LOTN)  !  space for triangles
C
C Declare the arrays to hold the point nodes, edge nodes, and triangle
C nodes defining the triangular mesh.
C
        DIMENSION RPNT(MPNT),IEDG(MEDG),ITRI(MTRI)
C
C Declare real and integer workspaces needed by VASPACKT.
C
        PARAMETER (LRWK=MTRI,LIWK=MTRI)
C
        DIMENSION RWRK(LRWK),IWRK(LIWK)
C
C Declare variables to hold labels.
C
        CHARACTER*64 UNLB,VNLB,WNLB,UILB,VILB,WILB
C 
C Declare a variable to hold an area map for masking purposes.
C 
        PARAMETER (LAMA=10000)
C       
        DIMENSION IAMA(LAMA)
C 
C Declare some arrays to be used in defining a masked-out area.
C   
        DIMENSION XMSK(5),YMSK(5)
C
C Declare the routine that will do the masked drawing of vectors.
C
        EXTERNAL VTDRPL
C
C Set the desired minimum and maximum values of U, V, and W.
C
        DATA UMIN,VMIN,WMIN,UMAX,VMAX,WMAX / -1.,-1.,-1.,+1.,+1.,+1. /
C
C Set the desired values of parameters determining the eye position.
C ANG1 is a bearing angle, ANG2 is an elevation angle, and RMUL is a
C multiplier of the length of the diagonal of the data box, specifying
C the distance from the center of the box to the eye.
C
C       DATA ANG1,ANG2,RMUL / 115., 25.,1.5 /
C       DATA ANG1,ANG2,RMUL / 210., 30.,1.5 /
C       DATA ANG1,ANG2,RMUL / 280.,-45.,1.5 /
C       DATA ANG1,ANG2,RMUL / 130., 45.,1.5 /
        DATA ANG1,ANG2,RMUL / 210.,-45.,1.5 /
C       DATA ANG1,ANG2,RMUL / 300.,-45.,1.5 /
C       DATA ANG1,ANG2,RMUL / 210., 80.,1.5 /
C       DATA ANG1,ANG2,RMUL / 300.,  5.,1.5 /
C       DATA ANG1,ANG2,RMUL /  30.,  5.,1.5 /
C
C ISTE is a flag that says whether to do a simple image (ISTE=0),
C a one-frame stereo image (ISTE=-1), or a two-frame stereo image
C (ISTE=+1).
C
        DATA ISTE / -1 /
C
C ASTE is the desired angle (in degrees) between the lines of sight for
C a pair of stereo views.
C
        DATA ASTE / 4. /
C
C WOSW is the width of the stereo windows to be used in one-frame stereo
C images; the width is stated as a fraction of the width of the plotter
C frame.  (The windows are centered vertically; horizontally, they are
C placed as far apart as possible in the plotter frame.)  The value used
C must be positive and non-zero; it may be slightly greater than .5, if
C it is desired that the stereo windows should overlap slightly.
C
        DATA WOSW / .5 /
C
C Define the conversion constant from degrees to radians.
C
        DATA DTOR / .017453292519943 /
C
C Define labels for the edges of the box.
C
        DATA UNLB / ' -1 -.8 -.6 -.4 -.2 0 .2 .4 .6 .8 1 ' /
        DATA VNLB / ' -1 -.8 -.6 -.4 -.2 0 .2 .4 .6 .8 1 ' /
        DATA WNLB / ' -1 -.8 -.6 -.4 -.2 0 .2 .4 .6 .8 1 ' /
C
        DATA UILB / 'U Coordinate Values' /
        DATA VILB / 'V Coordinate Values' /
        DATA WILB / 'W Coordinate Values' /
C
C Define the desired value of the parameter 'CTV', which says whether
C or not streamlines are to be colored and, if so, how:
C
C   ICTV = 0 => no coloring
C   ICTV < 0 => colored, user defines color threshold values used
C   ICTV > 0 => colored, VTMESH defines color threshold values used
C
C If ABS(ICTV) is between 1 and LOPN, inclusive, then colors will be
C determined from elements having index ABS(ICTV) in the point nodes:
C otherwise, colors will be determined from the vector magnitudes at
C the points.
C
C       DATA ICTV / -100 /  !  vector magnitudes     !  user values  !
C       DATA ICTV /   -8 /  !  longitude             !  user values  !
C       DATA ICTV /   -7 /  !  latitude              !  user values  !
C       DATA ICTV /   -6 /  !  W velocity component  !  user values  !
C       DATA ICTV /   -5 /  !  V velocity component  !  user values  !
C       DATA ICTV /   -4 /  !  U velocity component  !  user values  !
C       DATA ICTV /   -3 /  !  W coordinate          !  user values  !
C       DATA ICTV /   -2 /  !  V coordinate          !  user values  !
C       DATA ICTV /   -1 /  !  U coordinate          !  user values  !
C       DATA ICTV /    0 /  !  uncolored
C       DATA ICTV /   +1 /  !  U coordinate          !  auto values  !
C       DATA ICTV /   +2 /  !  V coordinate          !  auto values  !
C       DATA ICTV /   +3 /  !  W coordinate          !  auto values  !
C       DATA ICTV /   +4 /  !  U velocity component  !  auto values  !
C       DATA ICTV /   +5 /  !  V velocity component  !  auto values  !
C       DATA ICTV /   +6 /  !  W velocity component  !  auto values  !
C       DATA ICTV /   +7 /  !  latitude              !  auto values  !
C       DATA ICTV /   +8 /  !  longitude             !  auto values  !
        DATA ICTV / +100 /  !  vector magnitudes     !  auto values  !
C
C Define the desired value of the parameter 'NLV', which is the number
C of colors to be used.
C
C       DATA NCLR /   1 /
        DATA NCLR / 100 /
C
C Define the parameter that tells VASPACKT how to interpret size
C parameters.
C
        DATA IISP / 0 /
C       DATA IISP / 1 /
C
C Define the segment length for drawing streamlines.
C
        DATA SLPS / .001 /
C       DATA SLPS / .002 /
C       DATA SLPS / .005 /
C       DATA SLPS / .010 /
C       DATA SLPS / .020 /
C
C Define the termination test parameters for curly vectors.
C
C       DATA TTSP,TTLL / .012 , .024 /
C       DATA TTSP,TTLL / .006 , .012 /
C       DATA TTSP,TTLL / .012 , .024 /
C       DATA TTSP,TTLL / .009 , .018 /
        DATA TTSP,TTLL / .020 , .020 /
C
C Define the values of VASPACKT's arrowhead parameters.
C
        DATA AHSP,AHAW,AHLN / .24 , 30. , .03 /
C
C Define the values of parameters used to map vector magnitudes into
C vector lengths.
C
        DATA VFRA,VRLN,VRMG / .25 , .20 , 0. /
C
C Define the value of the debug flag and a trio of required color
C indices for VASPACKT.
C
        DATA IDBG,ICSG,ICTG,ICTT / 0 , 7 , 10 , 8 /
C
C Define the desired value of VASPACKT's point interpolation threshold.
C
C       DATA PITH /  0. /  !  point interpolation off
        DATA PITH / .01 /
C
C Define a parameter that says whether or not masking is to be tested.
C
        DATA IMSK / 0 /
C
C Define the coordinates of the area to be masked out.
C
        DATA XMSK / .3 , .7 , .7 , .3 , .3 /
        DATA YMSK / .3 , .3 , .7 , .7 , .3 /
C
C Define the value of 'VVM', which depends on the range of the data.
C
        DATA VVMM / .001 /
C
C Create data and generate the required triangular mesh.
C
        PRINT * , ' '
        PRINT * , 'CREATING TRIANGULAR MESH:'
C
        CALL GTGEO1 (RPNT,MPNT,NPNT,LOPN,  !  point list
     +               IEDG,MEDG,NEDG,LOEN,  !  edge list
     +               ITRI,MTRI,NTRI,LOTN,  !  triangle list
     +               NDIV)
C
C Print the number of points, edges, and triangles.
C
        PRINT * , '  NUMBER OF POINTS:    ',NPNT/LOPN
        PRINT * , '  NUMBER OF EDGES:     ',NEDG/LOEN
        PRINT * , '  NUMBER OF TRIANGLES: ',NTRI/LOTN
C
C Modify the dummy velocity-vector data generated by GTGEO1 to make it
C smoother.  Basically, each velocity vector points a little north of
C due east, with some smooth variation based on the original data.
C
        DO 101 I=0,NPNT-LOPN,LOPN
          DNOM=SQRT(RPNT(I+1)**2+RPNT(I+2)**2+RPNT(I+3)**2)
          RPNT(I+1)=RPNT(I+1)/DNOM
          RPNT(I+2)=RPNT(I+2)/DNOM
          RPNT(I+3)=RPNT(I+3)/DNOM
          CALL XYZLLP (RPNT(I+1),RPNT(I+2),RPNT(I+3),RLAT,RLON)
          CALL LLPXYZ (MAX(-90.,MIN(+90.,RLAT+.25)),RLON+2.,
     +                                                   RVOX,RVOY,RVOZ)
          RVOX=RVOX+RPNT(I+4)/15.
          RVOY=RVOY+RPNT(I+5)/15.
          RVOZ=RVOZ+RPNT(I+6)/15.
          DNOM=SQRT(RVOX**2+RVOY**2+RVOZ**2)
          RPNT(I+4)=RVOX/DNOM-RPNT(I+1)
          RPNT(I+5)=RVOY/DNOM-RPNT(I+2)
          RPNT(I+6)=RVOZ/DNOM-RPNT(I+3)
          RPNT(I+7)=RLAT
          RPNT(I+8)=RLON
  101   CONTINUE
C
C Open GKS.
C
        CALL GOPKS (IERF,0)
        CALL GOPWK (IWID,LUNI,IWTY)
        CALL GACWK (IWID)
C
C Turn clipping off.
C
        CALL GSCLIP (0)
C
C Define some colors to use.
C
        CALL GSCR   (IWID, 0,1.,1.,1.)  !  white (background)
        CALL GSCR   (IWID, 1,0.,0.,0.)  !  black (foreground)
        CALL GSCR   (IWID, 2,.8,.8,.8)  !  gray (mesh lines)
        CALL GSCR   (IWID, 3,1.,0.,0.)  !  red
        CALL GSCR   (IWID, 4,0.,1.,0.)  !  green
        CALL GSCR   (IWID, 5,0.,0.,1.)  !  blue
        CALL GSCR   (IWID, 6,1.,1.,0.)  !  yellow
        CALL GSCR   (IWID, 7,1.,.7,1.)  !  magenta
        CALL GSCR   (IWID, 8,.7,1.,1.)  !  cyan
        CALL GSCR   (IWID, 9,.6,.3,.3)  !  reddish-gray (streamlines)
        CALL GSCR   (IWID,10,.3,.6,.3)  !  greenish-gray (subtriangles)
C       
C Define 100 colors, associated with color indices 151 through 250, to
C be used for color-coding along streamlines, ranging from one color to
C another.
C
        CALL DFCRGB (IWID,151,150+NCLR,0.,0.,1.,1.,0.,0.,0.)
C
C Initialize the area map as directed.
C
        IF (IMSK.EQ.0) THEN
          IAMA(1)=0
        ELSE
          CALL SET    (0.,1.,0.,1.,0.,1.,0.,1.,1)
          PRINT * , 'CALLING ARINAM'
          CALL ARINAM (IAMA,LAMA)
          PRINT * , 'CALLING AREDAM'
          CALL AREDAM (IAMA,XMSK,YMSK,5,1,-1,0)
        END IF
C
C Select font number 25, turn on the outlining of filled fonts, set the
C line width to 1, and set the outline color to the foreground color.
C
        CALL PCSETI ('FN - FONT NUMBER',25)
        CALL PCSETI ('OF - OUTLINE FLAG',1)
        CALL PCSETR ('OL - OUTLINE LINE WIDTH',1.)
        CALL PCSETI ('OC - OUTLINE LINE COLOR',1)
C
C Specify the field of view to be used.
C
        CALL TDSETI ('FOV',40)
C
C Make TDPACK characters a bit bigger.
C
        CALL TDSETR ('CS1',1.25)
C
C Tell VASPACKT what the minimum velocity vector magnitude is to be.
C
        CALL VTSETR ('VVM - VELOCITY VECTOR MINIMUM MAGNITUDE',VVMM)
C
C Set VASPACKT's size-interpretation parameter.
C
        CALL VTSETI ('ISP',IISP)
C
C Set VASPACKT's streamline segment length.
C
        CALL VTSETR ('SLP',SLPS)
C
C Set VASPACKT's termination test parameters.
C
        CALL VTSETR ('TTS',TTSP)
        CALL VTSETR ('TTL',TTLL)
C
C Set VASPACKT's arrowhead parameters.
C
        CALL VTSETR ('AHS',AHSP)
        CALL VTSETR ('AHA',AHAW)
        CALL VTSETR ('AHL',AHLN)
C
C Set VASPACKT's vector-magnitude mapping parameters.
C
        CALL VTSETR ('VFR',VFRA)
        CALL VTSETR ('VRL',VRLN)
        CALL VTSETR ('VRM',VRMG)
C
C Set VASPACKT's debug flag and a trio of color indices.
C
        CALL VTSETI ('DBG',IDBG)
        CALL VTSETI ('SGC',ICSG)
        CALL VTSETI ('STC',ICTG)
        CALL VTSETI ('TTC',ICTT)
C
C Set VASPACKT's point interpolation threshold value.
C
        CALL VTSETR ('PIT',PITH)
C
C Set VASPACKT parameters having to do with coloring of streamlines.
C
        CALL VTSETI ('CTV - COLOR THRESHOLD VALUE CONTROL',ICTV)
C
C Initialize coloring of the streamlines.
C
        IF (ICTV.NE.0.AND.NCLR.NE.0) THEN
C
          IF (ICTV.LT.0) THEN
C
            DO 102 I=0,NPNT-LOPN,LOPN
              IF (ABS(ICTV).LE.LOPN) THEN
                TMAG=RPNT(I+ABS(ICTV))
              ELSE
                TMAG=SQRT(RPNT(I+4)**2+RPNT(I+5)**2+RPNT(I+6)**2)
              END IF
              IF (I.EQ.0) THEN
                TMIN=TMAG
                TMAX=TMAG
              ELSE
                TMIN=MIN(TMIN,TMAG)
                TMAX=MAX(TMAX,TMAG)
              END IF
  102       CONTINUE
C
          END IF
C
          CALL VTSETI ('NLV - NUMBER OF COLOR LEVELS',NCLR)
C
          DO 103 I=1,NCLR
            CALL VTSETI ('PAI - PARAMETER ARRRAY INDEX',I)
            CALL VTSETI ('CLR - GKS COLOR INDEX',150+I)
            IF (ICTV.LT.0) THEN
              CALL VTSETR ('TVL',
     +                     TMIN+(TMAX-TMIN)*(REAL(I)/REAL(NCLR+1))**2)
            END IF
  103     CONTINUE
C
        END IF
C
C Tell VASPACKT to use the TDPACK mapping (implies the use of a special
C version of VTMXYZ).
C
        CALL VTSETI ('MAP - MAPPING FLAG',2)
C
C Tell VASPACKT not to do its own call to SET, since TDPACK will have
C done it.
C
        CALL VTSETI ('SET - DO-SET-CALL FLAG', 0)
C
C Find the midpoint of the data box (to be used as the point looked at).
C
        UMID=.5*(UMIN+UMAX)
        VMID=.5*(VMIN+VMAX)
        WMID=.5*(WMIN+WMAX)
C
C Determine the distance (RDST) from which the data box will be viewed
C and, given that, the eye position.
C
        RDST=RMUL*SQRT((UMAX-UMIN)**2+(VMAX-VMIN)**2+(WMAX-WMIN)**2)
C
        UEYE=UMID+RDST*COS(DTOR*ANG1)*COS(DTOR*ANG2)
        VEYE=VMID+RDST*SIN(DTOR*ANG1)*COS(DTOR*ANG2)
        WEYE=WMID+RDST*SIN(DTOR*ANG2)
C
C SET THE TRIANGLE BLOCKING FLAGS FOR THE VIEWS TO BE DRAWN.
C --- --- -------- -------- ----- --- --- ----- -- -- ------
C
C Initialize the stereo offset argument to do either a single view or
C a left-eye view (whichever is selected by the value of ISTE).
C
        IF (ISTE.EQ.0) THEN
          OTEP=0.                       !  (single view)
        ELSE
          OTEP=-RDST*TAN(DTOR*ASTE/2.)  !  (left-eye view)
        END IF
C
C Initialize TDPACK.
C
  104   CALL TDINIT (UEYE,VEYE,WEYE,UMID,VMID,WMID,
     +                              UMID,VMID,WMID+RDST,OTEP)
C
C If stereo views are being done, do the requested thing, either by
C redoing the SET call to put them side by side on the same frame,
C or by calling FRAME to put them on separate frames.
C
        IF (OTEP.NE.0.) THEN
          IF (ISTE.LT.0) THEN
            CALL GETSET (XVPL,XVPR,YVPB,YVPT,XWDL,XWDR,YWDB,YWDT,LNLG)
            IF (OTEP.LT.0.) THEN
              CALL SET  (1.-WOSW,1.,.5-.5*WOSW,.5+.5*WOSW,
     +                           XWDL,XWDR,YWDB,YWDT,LNLG)
            ELSE
              CALL SET  (  0., WOSW,.5-.5*WOSW,.5+.5*WOSW,
     +                           XWDL,XWDR,YWDB,YWDT,LNLG)
            END IF
          END IF
        END IF
C
C Initialize VASPACKT.
C
        CALL VTMESH (RPNT,NPNT,LOPN,  !  point list
     +               IEDG,NEDG,LOEN,  !  edge list
     +               ITRI,NTRI,LOTN,  !  triangle list
     +               RWRK,LRWK,       !  real workspace
     +               IWRK,LIWK)       !  integer workspace
C
C Retrieve and print the average edge length.
C
        CALL VTGETR ('AEL',AVEL)
        PRINT * , '  AVERAGE LENGTH OF EDGES: ',AVEL
C
C VTTDBF is called to set blocking flag bits for triangles according to
C various criteria.  Its next-to-last argument may take on the following
C values:
C
C   0 => just clear the blocking flags for all triangles.
C   1 => set blocking flags for triangles that are nearly edge-on to
C        the line of sight or that are seen from the "wrong" side (so
C        that they appear to be defined by points given in clockwise
C        order, rather than in counter-clockwise order).
C   2 => set blocking flags for triangles that are hidden by other
C        triangles of the mesh.
C   3 => do both 1 and 2.
C
C Its final argument is a tolerance value, in degrees, defining what
C it means for a triangle to be nearly edge-on to the line of sight.
C Using the value zero turns off the setting of nearly-edge-on bits.
C
C The bits used in the blocking flags are as follows.  Assume that the
C seven rightmost (lowest-order) bits of the blocking flags are numbered
C as follows:
C
C   . . . B6 B5 B4 B3 B2 B1 B0
C
C Bit B0 of the blocking flag for a triangle is untouched by a call to
C VTTDBF; a user may set it to block the triangle.
C
C Bits B3, B2, and B1 are used for the view from the right eye (when
C stereo views are being drawn) or the only eye (when a simple view is
C being drawn).  If B3 is set, it indicates that the triangle is hidden
C by another triangle of the mesh; if B2 is set, it indicates that the
C triangle is nearly edge-on to the line of sight; if B1 is set, it
C indicates that the triangle is seen from the wrong side.
C
C Bits B6, B5, and B4 are defined similarly, but apply to the view from
C the left eye, rather than the right eye (when stereo views are being
C drawn).
C
        CALL VTTDBF (RPNT,IEDG,ITRI,RWRK,IWRK,1,2.)
C
C If a left-eye view has just been done, loop back for a right-eye view.
C
        IF (OTEP.LT.0.) THEN
          OTEP=-OTEP
          GO TO 104
        END IF
C
C Once bits B6, B5, B4, B3, B2, B1, and B0 are set in all the triangle
C blocking flags, one may use them to determine what is drawn in a
C particular view.  This is done by calling the routine VTTDBM, which
C has eight integer arguments.  The first four arguments are used to
C toggle bit values from the triangle's blocking flag, while the final
C four arguments are used to determine which of those bit values are
C considered to be meaningful.  For example, using the values "0, 0,
C 0, 0, 1, 1, 0, 1" says that none of the four values is to be toggled
C and that all will be allowed to block the triangle except the third;
C the net effect is to block triangles that are hidden, nearly edge-on,
C or blocked by the user, but none that are viewed from the wrong side.
C The four bits used from the blocking flag of each triangle are either
C bits B3, B2, B1, and B0, if the right (or only) eye is in use or bits
C B6, B5, B4, and B0, if the left eye is in use.
C
C Set masks for 3-D| t t t t u u u u | toggle/use
C triangle blocking| h e w u h e w u | hidden/edge-on/wrongside/user
C
C       CALL VTTDBM (0,0,0,0,1,1,0,1)
C
C DRAW THE TRIANGULAR MESH WITH STREAMLINES ON IT.
C ---- --- ---------- ---- ---- ----------- -- ---
C
C Initialize the stereo offset argument to do either a single view or
C a left-eye view (whichever is selected by the value of ISTE).
C
        IF (ISTE.EQ.0) THEN
          OTEP=0.                       !  (single view)
        ELSE
          OTEP=-RDST*TAN(DTOR*ASTE/2.)  !  (left-eye view)
        END IF
C
C Initialize TDPACK.
C
  105   CALL TDINIT (UEYE,VEYE,WEYE,UMID,VMID,WMID,
     +                              UMID,VMID,WMID+RDST,OTEP)
C
C If stereo views are being done, do the requested thing, either by
C redoing the SET call to put them side by side on the same frame,
C or by calling FRAME to put them on separate frames.
C
        IF (OTEP.NE.0.) THEN
          IF (ISTE.LT.0) THEN
            CALL GETSET (XVPL,XVPR,YVPB,YVPT,XWDL,XWDR,YWDB,YWDT,LNLG)
            IF (OTEP.LT.0.) THEN
              CALL SET  (1.-WOSW,1.,.5-.5*WOSW,.5+.5*WOSW,
     +                           XWDL,XWDR,YWDB,YWDT,LNLG)
            ELSE
              CALL SET  (  0., WOSW,.5-.5*WOSW,.5+.5*WOSW,
     +                           XWDL,XWDR,YWDB,YWDT,LNLG)
            END IF
          ELSE
            IF (OTEP.GT.0.) CALL FRAME
          END IF
        END IF
C
C Call VTTDBM, as described above.  We don't bother checking for hidden
C triangles, because, for a geodesic mesh, we know that all triangles
C that are hidden are viewed from the wrong side and it's easier to do
C that check.
C
C Set masks for 3-D| t t t t u u u u | toggle/use
C triangle blocking| h e w u h e w u | hidden/edge-on/wrong-side/user
C
        CALL VTTDBM (0,0,0,0,0,1,1,1)
C
C Draw labels for the axes.
C
        CALL TDLBLS (UMIN,VMIN,WMIN,UMAX,VMAX,WMAX,
     +               UNLB,VNLB,WNLB,UILB,VILB,WILB,1)
C
C Draw the sides of the box that could be hidden.
C
        CALL TDGRDS (UMIN,VMIN,WMIN,UMAX,VMAX,WMAX,
     +               .1*(UMAX-UMIN),.1*(VMAX-VMIN),.1*(WMAX-WMIN),
     +                                                       12,1)
C
C Color the visible triangles of the mesh in yellow.
C
        CALL GSFACI (6)
C
        CALL VTTDFM (RPNT,IEDG,ITRI,RWRK,IWRK)
C
        CALL GSFACI (1)
C
C Draw the triangular mesh in a light gray.
C
        CALL PLOTIT (0,0,2)
        CALL GSPLCI (2)
        CALL GSLWSC (1.)
C
        CALL VTTDDM (RPNT,IEDG,ITRI,RWRK,IWRK,0)
C
        CALL PLOTIT (0,0,2)
        CALL GSPLCI (1)
        CALL GSLWSC (1.)
C
C Draw the curly vectors, either in a reddish-gray or in varying
C colors, depending on the value of ICTV, above.
C
        CALL PLOTIF (0.,0.,2)
        CALL GSPLCI (9)
C
        CALL VTCVDM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA,VTDRPL)
C
        CALL PLOTIF (0.,0.,2)
        CALL GSPLCI (1)
C
C Draw the sides of the box that could not be hidden.
C
        CALL TDGRDS (UMIN,VMIN,WMIN,UMAX,VMAX,WMAX,
     +               .1*(UMAX-UMIN),.1*(VMAX-VMIN),.1*(WMAX-WMIN),
     +                                                       12,0)
C
C If a left-eye view has just been done, loop back for a right-eye view.
C
        IF (OTEP.LT.0.) THEN
          OTEP=-OTEP
          GO TO 105
        END IF
C
C Advance the frame.
C
        CALL FRAME
C
C Draw another frame or two using EZMAP.
C
        DO 107 IFRA=1,2
C
          DO 106 I=0,NTRI-LOTN,LOTN
            ITRI(I+4)=0
  106     CONTINUE
C
          IF (IFRA.EQ.1) THEN
            CALL MAPROJ ('CE',40.,-105.,0.)
          ELSE IF (IFRA.EQ.2) THEN
            CALL MAPROJ ('LE',40.,-105.,0.)
C           CALL MAPROJ ('AE',40.,-105.,0.)
C           CALL MAPROJ ('ME',40.,-105.,0.)
C           CALL MAPROJ ('MO',40.,-105.,0.)
C           CALL MAPROJ ('RO',40.,-105.,0.)
C           CALL MAPROJ ('OR',40.,-105.,0.)
C           CALL MAPROJ ('SV',40.,-105.,0.)
C           CALL MAPROJ ('LC',40.,-105.,60.)
C           CALL MAPROJ ('ST',40.,-105.,60.)
C           CALL MAPROJ ('GN',40.,-105.,60.)
          END IF
C
          CALL MAPDRW
C
          CALL VTSETI ('MAP - MAPPING FLAG',1)
          CALL VTSETR ('ORV - OUT-OF-RANGE FLAG',1.E12)
C
          CALL VTMESH (RPNT,NPNT,LOPN,  !  point list
     +                 IEDG,NEDG,LOEN,  !  edge list
     +                 ITRI,NTRI,LOTN,  !  triangle list
     +                 RWRK,LRWK,       !  real workspace
     +                 IWRK,LIWK)       !  integer workspace
C
          CALL PLOTIF (0.,0.,2)
          CALL GSPLCI (9)
C
          CALL VTCVDM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA,VTDRPL)
C
          CALL PLOTIF (0.,0.,2)
          CALL GSPLCI (1)
C
          CALL FRAME
C
  107   CONTINUE
C
C Close GKS.
C
        CALL GDAWK (IWID)
        CALL GCLWK (IWID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END


      SUBROUTINE GTGEO1 (RPNT,MPNT,NPNT,LOPN,
     +                   IEDG,MEDG,NEDG,LOEN,
     +                   ITRI,MTRI,NTRI,LOTN,
     +                   NDIV)
C
        DIMENSION RPNT(MPNT),IEDG(MEDG),ITRI(MTRI)
C
C Construct a triangular mesh representing a geodesic sphere as an
C exercise to demonstrate its feasibility and to see how the timing
C varies as a function of the resolution of the mesh.
C
C Declare arrays to hold information describing an icosahedron.
C
        DIMENSION JFCE(3,20),JEDG(2,30),XCVI(12),YCVI(12),ZCVI(12)
C
C Define the twenty faces of an icosahedron (pointers to edges).
C
        DATA JFCE(1, 1),JFCE(2, 1),JFCE(3, 1) /  1,11, 2 /
        DATA JFCE(1, 2),JFCE(2, 2),JFCE(3, 2) /  2,19, 3 /
        DATA JFCE(1, 3),JFCE(2, 3),JFCE(3, 3) /  3,25, 4 /
        DATA JFCE(1, 4),JFCE(2, 4),JFCE(3, 4) /  4,29, 5 /
        DATA JFCE(1, 5),JFCE(2, 5),JFCE(3, 5) /  1, 5,14 /
        DATA JFCE(1, 6),JFCE(2, 6),JFCE(3, 6) / 12,14,28 /
        DATA JFCE(1, 7),JFCE(2, 7),JFCE(3, 7) / 12,27,13 /
        DATA JFCE(1, 8),JFCE(2, 8),JFCE(3, 8) / 11,13,20 /
        DATA JFCE(1, 9),JFCE(2, 9),JFCE(3, 9) / 20,30,21 /
        DATA JFCE(1,10),JFCE(2,10),JFCE(3,10) / 19,21,26 /
        DATA JFCE(1,11),JFCE(2,11),JFCE(3,11) / 16,26,18 /
        DATA JFCE(1,12),JFCE(2,12),JFCE(3,12) / 16,17,25 /
        DATA JFCE(1,13),JFCE(2,13),JFCE(3,13) / 15,23,17 /
        DATA JFCE(1,14),JFCE(2,14),JFCE(3,14) / 23,24,29 /
        DATA JFCE(1,15),JFCE(2,15),JFCE(3,15) / 22,28,24 /
        DATA JFCE(1,16),JFCE(2,16),JFCE(3,16) /  7, 8,22 /
        DATA JFCE(1,17),JFCE(2,17),JFCE(3,17) /  6, 7,15 /
        DATA JFCE(1,18),JFCE(2,18),JFCE(3,18) /  6,18,10 /
        DATA JFCE(1,19),JFCE(2,19),JFCE(3,19) /  9,10,30 /
        DATA JFCE(1,20),JFCE(2,20),JFCE(3,20) /  8, 9,27 /
C
C Define the thirty edges of the icosahedron (pointers to vertices).
C
        DATA JEDG(1, 1),JEDG(2, 1) /  1, 3 /
        DATA JEDG(1, 2),JEDG(2, 2) /  1, 5 /
        DATA JEDG(1, 3),JEDG(2, 3) /  1, 7 /
        DATA JEDG(1, 4),JEDG(2, 4) /  1, 9 /
        DATA JEDG(1, 5),JEDG(2, 5) /  1,11 /
        DATA JEDG(1, 6),JEDG(2, 6) /  2, 4 /
        DATA JEDG(1, 7),JEDG(2, 7) /  2, 6 /
        DATA JEDG(1, 8),JEDG(2, 8) /  2, 8 /
        DATA JEDG(1, 9),JEDG(2, 9) /  2,10 /
        DATA JEDG(1,10),JEDG(2,10) /  2,12 /
        DATA JEDG(1,11),JEDG(2,11) /  3, 5 /
        DATA JEDG(1,12),JEDG(2,12) /  3, 8 /
        DATA JEDG(1,13),JEDG(2,13) /  3,10 /
        DATA JEDG(1,14),JEDG(2,14) /  3,11 /
        DATA JEDG(1,15),JEDG(2,15) /  4, 6 /
        DATA JEDG(1,16),JEDG(2,16) /  4, 7 /
        DATA JEDG(1,17),JEDG(2,17) /  4, 9 /
        DATA JEDG(1,18),JEDG(2,18) /  4,12 /
        DATA JEDG(1,19),JEDG(2,19) /  5, 7 /
        DATA JEDG(1,20),JEDG(2,20) /  5,10 /
        DATA JEDG(1,21),JEDG(2,21) /  5,12 /
        DATA JEDG(1,22),JEDG(2,22) /  6, 8 /
        DATA JEDG(1,23),JEDG(2,23) /  6, 9 /
        DATA JEDG(1,24),JEDG(2,24) /  6,11 /
        DATA JEDG(1,25),JEDG(2,25) /  7, 9 /
        DATA JEDG(1,26),JEDG(2,26) /  7,12 /
        DATA JEDG(1,27),JEDG(2,27) /  8,10 /
        DATA JEDG(1,28),JEDG(2,28) /  8,11 /
        DATA JEDG(1,29),JEDG(2,29) /  9,11 /
        DATA JEDG(1,30),JEDG(2,30) / 10,12 /
C
C Define the 12 vertices of the icosahedron (note radius less than one).
C
        DATA XCVI / .0000000000000 ,  .0000000000000 , -.8506508083520 ,
     +              .8506508083520 , -.2628655560596 ,  .2628655560596 ,
     +              .6881909602356 , -.6881909602356 ,  .6881909602356 ,
     +             -.6881909602356 , -.2628655560595 ,  .2628655560596 /
        DATA YCVI / .0000000000000 ,  .0000000000000 ,  .0000000000000 ,
     +              .0000000000000 , -.8090169943749 ,  .8090169943749 ,
     +             -.5000000000000 ,  .5000000000000 ,  .5000000000000 ,
     +             -.5000000000000 ,  .8090169943749 , -.8090169943749 /
        DATA ZCVI / .9510565162952 , -.9510565162951 ,  .4253254041760 ,
     +             -.4253254041760 ,  .4253254041760 , -.4253254041760 ,
     +              .4253254041760 , -.4253254041760 ,  .4253254041760 ,
     +             -.4253254041760 ,  .4253254041760 , -.4253254041760 /
C
C Check array sizes to see if we have enough space.
C
        IF ((10*NDIV*NDIV+2)*LOPN.GT.MPNT) THEN
          PRINT * , ' '
          PRINT * , 'GTGEO1 - STOP - POINT ARRAY TOO SMALL'
          STOP
        END IF
C
        IF (30*NDIV*NDIV*LOEN.GT.MEDG) THEN
          PRINT * , ' '
          PRINT * , 'GTGEO1 - STOP - EDGE ARRAY TOO SMALL'
          STOP
        END IF
C
        IF (20*NDIV*NDIV*LOTN.GT.MTRI) THEN
          PRINT * , ' '
          PRINT * , 'GTGEO1 - STOP - TRIANGLE ARRAY TOO SMALL'
          STOP
        END IF
C
C Initialize the number of points, edges, and triangles.
C
        NPNT=0
        NEDG=0
        NTRI=0
C
C Put the twelve vertices of the icosahedron in the point list; modify
C each to lie on the surface of a sphere of radius 1.
C
        DO 101 I=1,12
          RPNT(NPNT+1)=XCVI(I)
          RPNT(NPNT+2)=YCVI(I)
          RPNT(NPNT+3)=ZCVI(I)
          NPNT=NPNT+LOPN
  101   CONTINUE
C
C On each edge of the icosahedron, interpolate NDIV-1 points and put
C them in the point list.
C
        DO 103 I=1,30
          IPPA=(JEDG(1,I)-1)*LOPN
          IPPB=(JEDG(2,I)-1)*LOPN
          DO 102 J=1,NDIV-1
            RPNT(NPNT+1)=(REAL(NDIV-J)*RPNT(IPPA+1)+
     +                    REAL(     J)*RPNT(IPPB+1))/REAL(NDIV)
            RPNT(NPNT+2)=(REAL(NDIV-J)*RPNT(IPPA+2)+
     +                    REAL(     J)*RPNT(IPPB+2))/REAL(NDIV)
            RPNT(NPNT+3)=(REAL(NDIV-J)*RPNT(IPPA+3)+
     +                    REAL(     J)*RPNT(IPPB+3))/REAL(NDIV)
            NPNT=NPNT+LOPN
  102     CONTINUE
  103   CONTINUE
C
C On each edge of the icosahedron, generate NDIV pieces of the edge and
C put them in the edge list.
C
        DO 105 I=1,30
          IPP2=(JEDG(1,I)-1)*LOPN
          DO 104 J=1,NDIV
            IPP1=IPP2
            IF (J.LT.NDIV) THEN
              IPP2=(12+(I-1)*(NDIV-1)+J-1)*LOPN
            ELSE
              IPP2=(JEDG(2,I)-1)*LOPN
            END IF
            IEDG(NEDG+1)=IPP1
            IEDG(NEDG+2)=IPP2
            IEDG(NEDG+3)=0
            IEDG(NEDG+4)=-1
            NEDG=NEDG+LOEN
  104     CONTINUE
  105   CONTINUE
C
C On each face of the icosahedron, generate (NDIV-2)*(NDIV-1)/2 interior
C points and put them in the point list (completing it).  Also generate
C 3*(NDIV-1)*NDIV/2 interior edges and put them in the edge list (which
C completes it).  Also generate NDIV*NDIV triangles and put them in the
C triangle list (completing it).
C
        DO 110 I=1,20
          IF (JEDG(1,JFCE(1,I)).EQ.JEDG(1,JFCE(2,I)).OR.
     +        JEDG(1,JFCE(1,I)).EQ.JEDG(2,JFCE(2,I))) THEN
            IPPA=(12+(JFCE(1,I)-1)*(NDIV-1)-1)*LOPN
            IIPA=LOPN
            IPEA=((JFCE(1,I)-1)*NDIV-1)*LOEN
            IIEA=LOEN
          ELSE
            IPPA=(12+(JFCE(1,I)-1)*(NDIV-1)+NDIV-1)*LOPN
            IIPA=-LOPN
            IPEA=((JFCE(1,I)-1)*NDIV+NDIV)*LOEN
            IIEA=-LOEN
          END IF
          IF (JEDG(1,JFCE(3,I)).EQ.JEDG(1,JFCE(2,I)).OR.
     +        JEDG(1,JFCE(3,I)).EQ.JEDG(2,JFCE(2,I))) THEN
            IPPB=(12+(JFCE(3,I)-1)*(NDIV-1)-1)*LOPN
            IIPB=LOPN
            IPEB=((JFCE(3,I)-1)*NDIV-1)*LOEN
            IIEB=LOEN
          ELSE
            IPPB=(12+(JFCE(3,I)-1)*(NDIV-1)+NDIV-1)*LOPN
            IIPB=-LOPN
            IPEB=((JFCE(3,I)-1)*NDIV+NDIV)*LOEN
            IIEB=-LOEN
          END IF
          IF (JEDG(1,JFCE(2,I)).EQ.JEDG(1,JFCE(1,I)).OR.
     +        JEDG(1,JFCE(2,I)).EQ.JEDG(2,JFCE(1,I))) THEN
            IPEC=((JFCE(2,I)-1)*NDIV)*LOEN
            IIEC=LOEN
          ELSE
            IPEC=((JFCE(2,I)-1)*NDIV+NDIV-1)*LOEN
            IIEC=-LOEN
          END IF
          DO 109 J=1,NDIV
            IPPA=IPPA+IIPA
            IPPB=IPPB+IIPB
            IPEA=IPEA+IIEA
            IPEB=IPEB+IIEB
            DO 106 K=1,NDIV-J-1
              RPNT(NPNT+1)=(REAL(NDIV-J-K)*RPNT(IPPA+1)+
     +                      REAL(       K)*RPNT(IPPB+1))/REAL(NDIV-J)
              RPNT(NPNT+2)=(REAL(NDIV-J-K)*RPNT(IPPA+2)+
     +                      REAL(       K)*RPNT(IPPB+2))/REAL(NDIV-J)
              RPNT(NPNT+3)=(REAL(NDIV-J-K)*RPNT(IPPA+3)+
     +                      REAL(       K)*RPNT(IPPB+3))/REAL(NDIV-J)
              NPNT=NPNT+LOPN
  106       CONTINUE
            IPED=NEDG
            IIED=LOEN
            IPP2=IPPA
            DO 107 K=1,NDIV-J
              IPP1=IPP2
              IF (K.LT.NDIV-J) THEN
                IPP2=NPNT-(NDIV-J-K)*LOPN
              ELSE
                IPP2=IPPB
              END IF
              IEDG(NEDG+1)=IPP1
              IEDG(NEDG+2)=IPP2
              IEDG(NEDG+3)=-1
              IEDG(NEDG+4)=-1
              NEDG=NEDG+LOEN
  107       CONTINUE
            IPEF=IPEA
            DO 108 K=0,2*(NDIV-J)
              IF (MOD(K,2).EQ.0) THEN
                IF (K.LT.(NDIV-J)*2) THEN
                  IPEG=NEDG
                  IF (IIEC.GT.0) THEN
                    IEDG(NEDG+1)=IEDG(IPEC+(K/2)*IIEC+2)
                  ELSE
                    IEDG(NEDG+1)=IEDG(IPEC+(K/2)*IIEC+1)
                  END IF
                  IF (IIED.GT.0) THEN
                    IEDG(NEDG+2)=IEDG(IPED+(K/2)*IIED+1)
                  ELSE
                    IEDG(NEDG+2)=IEDG(IPED+(K/2)*IIED+2)
                  END IF
                  IEDG(NEDG+3)=-1
                  IEDG(NEDG+4)=-1
                  NEDG=NEDG+LOEN
                ELSE
                  IPEG=IPEB
                END IF
                ITRI(NTRI+1)=IPEF
                ITRI(NTRI+2)=IPEC+(K/2)*IIEC
                ITRI(NTRI+3)=IPEG
                ITRI(NTRI+4)=0
                NTRI=NTRI+LOTN
                CALL STPIEN (ITRI,NTRI-LOTN,IEDG)
              ELSE
                IPEG=NEDG
                IF (IIEC.GT.0) THEN
                  IEDG(NEDG+1)=IEDG(IPEC+(K/2)*IIEC+2)
                ELSE
                  IEDG(NEDG+1)=IEDG(IPEC+(K/2)*IIEC+1)
                END IF
                IF (IIED.GT.0) THEN
                  IEDG(NEDG+2)=IEDG(IPED+(K/2)*IIED+2)
                ELSE
                  IEDG(NEDG+2)=IEDG(IPED+(K/2)*IIED+1)
                END IF
                IEDG(NEDG+3)=-1
                IEDG(NEDG+4)=-1
                NEDG=NEDG+LOEN
                ITRI(NTRI+1)=IPEF
                ITRI(NTRI+2)=IPEG
                ITRI(NTRI+3)=IPED+(K/2)*IIEC
                ITRI(NTRI+4)=0
                NTRI=NTRI+LOTN
                CALL STPIEN (ITRI,NTRI-LOTN,IEDG)
              END IF
              IPEF=IPEG
  108       CONTINUE
            IPEC=IPED
            IIEC=IIED
  109     CONTINUE
  110   CONTINUE
C
C Blow the elaborated icosahedron up into a sphere, supply dummy data
C at each of its vertices and clear the "additional info" slots in the
C point nodes.
C
        DO 111 I=0,NPNT-LOPN,LOPN
          DNOM=SQRT(RPNT(I+1)**2+RPNT(I+2)**2+RPNT(I+3)**2)
          RPNT(I+1)=.9*RPNT(I+1)/DNOM
          RPNT(I+2)=.9*RPNT(I+2)/DNOM
          RPNT(I+3)=.9*RPNT(I+3)/DNOM
  111   CONTINUE
C
C Initialize the dummy-data generator and generate X flow components.
C
        CALL TDGDIN (-1.,1.,-1.,1.,-1.,1.,21,21)
C
        DO 112 I=0,NPNT-LOPN,LOPN
          RPNT(I+4)=TDGDVA(RPNT(I+1),RPNT(I+2),RPNT(I+3))
  112   CONTINUE
C
C Initialize the dummy-data generator and generate Y flow components.
C
        CALL TDGDIN (-1.,1.,-1.,1.,-1.,1.,21,21)
C
        DO 113 I=0,NPNT-LOPN,LOPN
          RPNT(I+5)=TDGDVA(RPNT(I+1),RPNT(I+2),RPNT(I+3))
  113   CONTINUE
C
C Initialize the dummy-data generator and generate Z flow components.
C
        CALL TDGDIN (-1.,1.,-1.,1.,-1.,1.,21,21)
C
        DO 114 I=0,NPNT-LOPN,LOPN
          RPNT(I+6)=TDGDVA(RPNT(I+1),RPNT(I+2),RPNT(I+3))
  114   CONTINUE
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE STPIEN (ITRI,NTRI,IEDG)
C
        DIMENSION ITRI(*),IEDG(*)
C
C This subroutine sets the triangle pointers in the edge nodes pointed
C to by a triangle node just defined.
C
        IF (IEDG(ITRI(NTRI+1)+2).EQ.IEDG(ITRI(NTRI+2)+1).OR.
     +      IEDG(ITRI(NTRI+1)+2).EQ.IEDG(ITRI(NTRI+2)+2)) THEN
          IEDG(ITRI(NTRI+1)+3)=NTRI+1
        ELSE
          IEDG(ITRI(NTRI+1)+4)=NTRI+1
        END IF
C
        IF (IEDG(ITRI(NTRI+2)+2).EQ.IEDG(ITRI(NTRI+3)+1).OR.
     +      IEDG(ITRI(NTRI+2)+2).EQ.IEDG(ITRI(NTRI+3)+2)) THEN
          IEDG(ITRI(NTRI+2)+3)=NTRI+2
        ELSE
          IEDG(ITRI(NTRI+2)+4)=NTRI+2
        END IF
C
        IF (IEDG(ITRI(NTRI+3)+2).EQ.IEDG(ITRI(NTRI+1)+1).OR.
     +      IEDG(ITRI(NTRI+3)+2).EQ.IEDG(ITRI(NTRI+1)+2)) THEN
          IEDG(ITRI(NTRI+3)+3)=NTRI+3
        ELSE
          IEDG(ITRI(NTRI+3)+4)=NTRI+3
        END IF
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE TDGDIN (XMIN,XMAX,YMIN,YMAX,ZMIN,ZMAX,MLOW,MHGH)
C
C This is a routine to generate test data for three-dimensional graphics
C routines.  The function used is a sum of exponentials.
C
C "MLOW" and "MHGH" are each forced to be greater than or equal to 1 and
C less than or equal to 25.
C
        COMMON /TDGDCO/ XRNG,YRNG,ZRNG,NCNT,CCNT(4,50)
        SAVE   /TDGDCO/
C
        XRNG=XMAX-XMIN
        YRNG=YMAX-YMIN
        ZRNG=ZMAX-ZMIN
C
        NLOW=MAX(1,MIN(25,MLOW))
        NHGH=MAX(1,MIN(25,MHGH))
        NCNT=NLOW+NHGH
C
        DO 101 ICNT=1,NCNT
C         CCNT(1,ICNT)=XMIN+XRNG*FRAN()
C         CCNT(2,ICNT)=YMIN+YRNG*FRAN()
C         CCNT(3,ICNT)=ZMIN+ZRNG*FRAN()
          CCNT(1,ICNT)=XMIN+XRNG*GRAN()
          CCNT(2,ICNT)=YMIN+YRNG*GRAN()
          CCNT(3,ICNT)=ZMIN+ZRNG*GRAN()
          IF (ICNT.LE.NLOW) THEN
            CCNT(4,ICNT)=-1.
          ELSE
            CCNT(4,ICNT)=+1.
          END IF
  101   CONTINUE
C
        RETURN
C
      END


      FUNCTION TDGDVA (XPOS,YPOS,ZPOS)
C
        COMMON /TDGDCO/ XRNG,YRNG,ZRNG,NCNT,CCNT(4,50)
        SAVE   /TDGDCO/
C
        TDGDVA=0.
C
        DO 101 ICNT=1,NCNT
          TEMP=-50.*(((XPOS-CCNT(1,ICNT))/XRNG)**2+
     +               ((YPOS-CCNT(2,ICNT))/YRNG)**2+
     +               ((ZPOS-CCNT(3,ICNT))/YRNG)**2)
          IF (TEMP.GE.-20.) TDGDVA=TDGDVA+CCNT(4,ICNT)*EXP(TEMP)
  101   CONTINUE
C
C Done.
C
        RETURN
C
      END


      FUNCTION FRAN ()
C
C Pseudo-random-number generator.
C
        DOUBLE PRECISION X
        SAVE X
C
        DATA X / 2.718281828459045D0 /
C
        X=MOD(9821.D0*X+.211327D0,1.D0)
        FRAN=REAL(X)
C
        RETURN
C
      END


      FUNCTION GRAN ()
C
C This function generates a sequence of "random" numbers.  Obviously,
C it repeats after the 100th such number.  This is not very important,
C because of the way in which these numbers are being used.
C
      DIMENSION RSEQ (100)
      SAVE ISEQ
      DATA RSEQ / .749,.973,.666,.804,.081,.483,.919,.903,.951,.960 ,
     +            .039,.269,.270,.756,.222,.478,.621,.063,.550,.798 ,
     +            .027,.569,.149,.697,.451,.738,.508,.041,.266,.249 ,
     +            .019,.191,.266,.625,.492,.940,.508,.406,.972,.311 ,
     +            .757,.378,.299,.536,.619,.844,.342,.295,.447,.499 ,
     +            .688,.193,.225,.520,.954,.749,.997,.693,.217,.273 ,
     +            .961,.948,.902,.104,.495,.257,.524,.100,.492,.347 ,
     +            .981,.019,.225,.806,.678,.710,.235,.600,.994,.758 ,
     +            .682,.373,.009,.469,.203,.730,.588,.603,.213,.495 ,
     +            .884,.032,.185,.127,.010,.180,.689,.354,.372,.429 /
      DATA ISEQ / 0 /
      ISEQ=MOD(ISEQ,100)+1
      GRAN=RSEQ(ISEQ)
      RETURN
      END


      SUBROUTINE LLPXYZ (RLAT,RLON,RVOX,RVOY,RVOZ)
C
C (LLPXYZ = Lat/Lon Position to XYZ coordinates)
C
C Given the latitude and longitude of a point on the globe, return its
C X, Y, and Z coordinates.
C
        DATA DTOR / .017453292519943 /
C
        RVOX=COS(DTOR*RLAT)*COS(DTOR*RLON)
        RVOY=COS(DTOR*RLAT)*SIN(DTOR*RLON)
        RVOZ=SIN(DTOR*RLAT)
C
        RETURN
C
      END


      SUBROUTINE XYZLLP (RVOX,RVOY,RVOZ,RLAT,RLON)
C
C (XYZLLP = XYZ coordinates to Lat/Lon Position)
C
C Given the X, Y, and Z coordinates of a point on the globe, return its
C latitude and longitude.
C
        DATA RTOD / 57.2957795130823 /
C
        RLAT=RTOD*ASIN(RVOZ)
C
        IF (RVOX.NE.0..OR.RVOY.NE.0.) THEN
          RLON=RTOD*ATAN2(RVOY,RVOX)
        ELSE
          RLON=0.
        END IF
C
        RETURN
C
      END


C THE FOLLOWING ROUTINES SHOULD BECOME A PART OF TDPACK.


      SUBROUTINE TDAROW (UCP1,VCP1,WCP1,UCP2,VCP2,WCP2,ARHL,ARHW)
C
        DIMENSION UCRV(2),VCRV(2),WCRV(2)
C
C Draw the projection of an arrow from the point (UCP1,VCP1,WCP1) to the
C point (UCP2,VCP2,WCP2).  ARHL and ARHW define the length and width of
C the arrowhead.
C
C First, define a two-point "curve".
C
        UCRV(1)=UCP1
        VCRV(1)=VCP1
        WCRV(1)=WCP1
C
        UCRV(2)=UCP2
        VCRV(2)=VCP2
        WCRV(2)=WCP2
C
C Use a TDPACK routine to draw the projection of the "curve" with a
C cone-shaped arrowhead on the end of it.
C
        CALL TDCURV (UCRV,VCRV,WCRV,2,1,AHLN,AHWD)
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE TDCURV (UCRV,VCRV,WCRV,NCRV,IARH,ARHL,ARHW)
C
        DIMENSION UCRV(NCRV),VCRV(NCRV),WCRV(NCRV)
C
C Draw the projection of a curve in 3-space, as defined by the points
C (UCRV(I),VCRV(I),WCRV(I)), for I from 1 to NCRV.
C
C In addition, if IARH is non-zero, draw the projection of one of the
C following objects at one end of the curve (at the beginning of it if
C IARH is negative, at the end of it if IARH is positive).  If IARH has
C absolute value 1, what is used is a simple arrowhead, of length ARHL
C and width ARHW, lying in a plane that is perpendicular to both the
C unit vector having components UDCP, VDCP, and WDCP, as defined in the
C common block TDPOAH, and to the terminal segment of the curve; if
C IARH has absolute value 2 or greater, what is drawn is a cone-shaped
C arrowhead, of length ARHL and width ARHW; the magnitude of IARH is
C of the form NPAC+1000*NPCT, where NPAC is the number of points to be
C used to draw the circular base of the cone and NPCT is the number of
C points on the base to be connected to the tip.  NPAC is forced to be
C 32 or greater and NPCT is forced to be NPAC/4 or greater; therefore,
C if you use IARH=2, you'll get NPAC=32 and NPCT=8.
C
C UDCP, VDCP, and WDCP are the direction cosines for the normal to the
C plane in which an arrowhead is to be drawn when ABS(IARH) = 1.
C
        COMMON /TDPOAH/ UDCP,VDCP,WDCP
        SAVE   /TDPOAH/
C
C Check for an uncleared prior error.
C
        IF (ICFELL('TDCURV - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C Project the points of the curve, convert to the fractional coordinate
C system, and draw the curve using calls to the SPPS routine PLOTIF.
C
        DO 101 I=1,NCRV
          CALL TDPRPT (UCRV(I),VCRV(I),WCRV(I),XPOS,YPOS)
          CALL PLOTIF (CUFX(XPOS),CUFY(YPOS),MIN(I-1,1))
  101   CONTINUE
C
C Flush the point-draw buffers.
C
        CALL PLOTIF (0.,0.,2)
C
C If an arrowhead is to be drawn at the end of the curve, do that.
C
        IF (IARH.NE.0.AND.NCRV.GE.2) THEN
          IF (IARH.LT.0) THEN
            UEND=UCRV(1)
            VEND=VCRV(1)
            WEND=WCRV(1)
            UBEG=UCRV(2)
            VBEG=VCRV(2)
            WBEG=WCRV(2)
          ELSE
            UEND=UCRV(NCRV)
            VEND=VCRV(NCRV)
            WEND=WCRV(NCRV)
            UBEG=UCRV(NCRV-1)
            VBEG=VCRV(NCRV-1)
            WBEG=WCRV(NCRV-1)
          END IF
          DNOM=SQRT((UEND-UBEG)**2+(VEND-VBEG)**2+(WEND-WBEG)**2)
          IF (DNOM.NE.0.) THEN
            UDCC=(UEND-UBEG)/DNOM
            VDCC=(VEND-VBEG)/DNOM
            WDCC=(WEND-WBEG)/DNOM
            UACC=UEND-ARHL*UDCC
            VACC=VEND-ARHL*VDCC
            WACC=WEND-ARHL*WDCC
            IF (ABS(IARH).EQ.1) THEN
              CALL TDPRPT (UEND,VEND,WEND,XEND,YEND)
              UDC3=VDCC*WDCP-WDCC*VDCP
              VDC3=WDCC*UDCP-UDCC*WDCP
              WDC3=UDCC*VDCP-VDCC*UDCP
              CALL TDPRPT (UACC-(ARHW/2.)*UDC3,
     +                     VACC-(ARHW/2.)*VDC3,
     +                     WACC-(ARHW/2.)*WDC3,XPOS,YPOS)
              CALL PLOTIF (CUFX(XPOS),CUFY(YPOS),0)
              CALL PLOTIF (CUFX(XEND),CUFY(YEND),1)
              CALL TDPRPT (UACC+(ARHW/2.)*UDC3,
     +                     VACC+(ARHW/2.)*VDC3,
     +                     WACC+(ARHW/2.)*WDC3,XPOS,YPOS)
              CALL PLOTIF (CUFX(XPOS),CUFY(YPOS),1)
            ELSE
              NPAC=MAX(32,MOD(ABS(IARH),1000))
              NPCT=MAX(NPAC/4,ABS(IARH)/1000)
              CALL TDCONE (UACC,VACC,WACC,UDCC,VDCC,WDCC,ARHW/2.,NPAC,
     +                                              NPCT,UEND,VEND,WEND)
            END IF
          END IF
        END IF
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE TDCUDP (UCRV,VCRV,WCRV,NCRV,IARH,ARHL,ARHW)
C
        DIMENSION UCRV(NCRV),VCRV(NCRV),WCRV(NCRV)
C
C Draw the projection of a curve in 3-space, as defined by the points
C (UCRV(I),VCRV(I),WCRV(I)), for I from 1 to NCRV.  This routine is just
C like TDCURV, except that it calls the DASHPACK routine DPDRAW instead
C of the SPPS routine PLOTIF and can therefore be made to draw a dashed
C line.
C
C In addition, if IARH is non-zero, draw the projection of one of the
C following objects at one end of the curve (at the beginning of it if
C IARH is negative, at the end of it if IARH is positive).  If IARH has
C absolute value 1, what is used is a simple arrowhead, of length ARHL
C and width ARHW, lying in a plane that is perpendicular to both the
C unit vector having components UDCP, VDCP, and WDCP, as defined in the
C common block TDPOAH, and to the terminal segment of the curve; if
C IARH has absolute value 2 or greater, what is drawn is a cone-shaped
C arrowhead, of length ARHL and width ARHW; the magnitude of IARH is
C of the form NPAC+1000*NPCT, where NPAC is the number of points to be
C used to draw the circular base of the cone and NPCT is the number of
C points on the base to be connected to the tip.  NPAC is forced to be
C 32 or greater and NPCT is forced to be NPAC/4 or greater; therefore,
C if you use IARH=2, you'll get NPAC=32 and NPCT=8.
C
C UDCP, VDCP, and WDCP are the direction cosines for the normal to the
C plane in which an arrowhead is to be drawn when ABS(IARH) = 1.
C
        COMMON /TDPOAH/ UDCP,VDCP,WDCP
        SAVE   /TDPOAH/
C
C Check for an uncleared prior error.
C
        IF (ICFELL('TDCUDP - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C Project the points of the curve, convert to the fractional coordinate
C system, and draw the curve using calls to the DASHPACK routine DPDRAW.
C
        DO 101 I=1,NCRV
          CALL TDPRPT (UCRV(I),VCRV(I),WCRV(I),XPOS,YPOS)
          CALL DPDRAW (CUFX(XPOS),CUFY(YPOS),MIN(I-1,1))
  101   CONTINUE
C
C Flush the point-draw buffers.
C
        CALL DPDRAW (0.,0.,2)
C
C If an arrowhead is to be drawn at the end of the curve, do that.
C
        IF (IARH.NE.0.AND.NCRV.GE.2) THEN
          IF (IARH.LT.0) THEN
            UEND=UCRV(1)
            VEND=VCRV(1)
            WEND=WCRV(1)
            UBEG=UCRV(2)
            VBEG=VCRV(2)
            WBEG=WCRV(2)
          ELSE
            UEND=UCRV(NCRV)
            VEND=VCRV(NCRV)
            WEND=WCRV(NCRV)
            UBEG=UCRV(NCRV-1)
            VBEG=VCRV(NCRV-1)
            WBEG=WCRV(NCRV-1)
          END IF
          DNOM=SQRT((UEND-UBEG)**2+(VEND-VBEG)**2+(WEND-WBEG)**2)
          IF (DNOM.NE.0.) THEN
            UDCC=(UEND-UBEG)/DNOM
            VDCC=(VEND-VBEG)/DNOM
            WDCC=(WEND-WBEG)/DNOM
            UACC=UEND-ARHL*UDCC
            VACC=VEND-ARHL*VDCC
            WACC=WEND-ARHL*WDCC
            IF (ABS(IARH).EQ.1) THEN
              CALL TDPRPT (UEND,VEND,WEND,XEND,YEND)
              UDC3=VDCC*WDCP-WDCC*VDCP
              VDC3=WDCC*UDCP-UDCC*WDCP
              WDC3=UDCC*VDCP-VDCC*UDCP
              CALL TDPRPT (UACC-(ARHW/2.)*UDC3,
     +                     VACC-(ARHW/2.)*VDC3,
     +                     WACC-(ARHW/2.)*WDC3,XPOS,YPOS)
              CALL DPDRAW (CUFX(XPOS),CUFY(YPOS),0)
              CALL DPDRAW (CUFX(XEND),CUFY(YEND),1)
              CALL TDPRPT (UACC+(ARHW/2.)*UDC3,
     +                     VACC+(ARHW/2.)*VDC3,
     +                     WACC+(ARHW/2.)*WDC3,XPOS,YPOS)
              CALL DPDRAW (CUFX(XPOS),CUFY(YPOS),1)
            ELSE
              NPAC=MAX(32,MOD(ABS(IARH),1000))
              NPCT=MAX(NPAC/4,ABS(IARH)/1000)
              CALL TDCONE (UACC,VACC,WACC,UDCC,VDCC,WDCC,ARHW/2.,NPAC,
     +                                              NPCT,UEND,VEND,WEND)
            END IF
          END IF
        END IF
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE TDCONE (UACC,VACC,WACC,UDCS,VDCS,WDCS,RADI,NPAC,
     +                                       NPCT,UTIP,VTIP,WTIP)
C
C Draw the projection of a cone in 3-space.  The circular base of the
C cone is centered at the point (UACC,VACC,WACC), is perpendicular to
C the vector with direction cosines UDCS, VDCS, and WDCS, has a radius
C of RADI, and is drawn using NPAC equispaced points along the circle;
C NPCT points equispaced along the circle are connected to the tip,
C which is at (UTIP,VTIP,WTIP).
C
C (This routine is included here because it has a fix that might not
C have made it into the official NCAR Graphics installed on my system.)
C
        DATA DTOR / .017453292519943 /
        DATA RTOD / 57.2957795130823 /
C
C Below, the method used to construct the cone and to put it in the
C desired position is described in terms of the angles RLAT and RLON.
C We can compute the required functions of RLAT and RLON directly from
C the direction cosines that we are given, so we never actually need to
C compute RLAT and RLON themselves.  Still, it may be helpful to see
C how they would be computed:
C
C       RLAT=RTOD*ASIN(WDCS)
C
C       IF (UDCS.NE.0.OR.VDCS.NE.0.) THEN
C         RLON=RTOD*ATAN2(VDCS,UDCS)
C       ELSE
C         RLON=0.
C       END IF
C
C Draw the circular base of the arrowhead.  Essentially, we form the
C circle in the UV plane, perform two rotations (one about the V axis,
C by the angle 90-RLAT, and one about the W axis, by the angle RLON),
C and then translate the circle to its desired final position.  The
C rotations involve sines and cosines of 90-RLAT and of RLON; the code
C is simplified by computing these from the direction cosines.
C
        DNOM=SQRT(UDCS*UDCS+VDCS*VDCS)
C
        DO 101 I=0,NPAC
          UCR1=RADI*COS(DTOR*REAL(I)*(360./REAL(NPAC)))
          UCR2=UCR1*WDCS
          VCR2=RADI*SIN(DTOR*REAL(I)*(360./REAL(NPAC)))
          IF (DNOM.EQ.0.) THEN
            UCR3=UCR2
            VCR3=VCR2
          ELSE
            UCR3=(UCR2*UDCS-VCR2*VDCS)/DNOM
            VCR3=(VCR2*UDCS+UCR2*VDCS)/DNOM
          END IF
          WCR3=-UCR1*SQRT(1.-WDCS*WDCS)
          CALL TDPRPT (UACC+UCR3,VACC+VCR3,WACC+WCR3,XPOS,YPOS)
          CALL PLOTIF (CUFX(XPOS),CUFY(YPOS),MIN(I,1))
  101   CONTINUE
C
C Connect some points along the base of the circle to the tip, using
C very similar code.
C
        CALL TDPRPT (UTIP,VTIP,WTIP,XTIP,YTIP)
C
        XTIP=CUFX(XTIP)
        YTIP=CUFY(YTIP)
C
        DO 102 I=0,NPCT
          CALL PLOTIF (XTIP,YTIP,0)
          UCR1=RADI*COS(DTOR*REAL(I)*(360./REAL(NPCT)))
          UCR2=UCR1*WDCS
          VCR2=RADI*SIN(DTOR*REAL(I)*(360./REAL(NPCT)))
          IF (DNOM.EQ.0.) THEN
            UCR3=UCR2
            VCR3=VCR2
          ELSE
            UCR3=(UCR2*UDCS-VCR2*VDCS)/DNOM
            VCR3=(VCR2*UDCS+UCR2*VDCS)/DNOM
          END IF
          WCR3=-UCR1*SQRT(1.-WDCS*WDCS)
          CALL TDPRPT (UACC+UCR3,VACC+VCR3,WACC+WCR3,XPOS,YPOS)
          CALL PLOTIF (CUFX(XPOS),CUFY(YPOS),1)
  102   CONTINUE
C
C Flush the point-draw buffers.
C
        CALL PLOTIF (0.,0.,2)
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE DFCRGB (IWID,IOFC,IOLC,BRED,BGRN,BBLU,ERED,EGRN,EBLU,
     +                                                           AMUL)
C
C This routine defines color indices IOFC through IOLC on workstation
C IWID by interpolating values from BRED/BGRN/BBLU to ERED/EGRN/EBLU.
C
C BRED, BGRN, BBLE, ERED, EGRN, and EBLU are all reals between 0 and 1.
C
C AMUL should be a real between zero and one: zero gives interpolated
C values along a straight line in the RGB color cube; larger values
C give interpolated values along a curved line that bends toward the
C black corner of the cube.  On some of the newer color laser jet
C printers, using a non-zero value of AMUL gives colors closer to what
C one sees on one's monitor; for example, if the colors range from pure
C blue to pure red, using AMUL=.6 works pretty well.
C
        DO 101 I=IOFC,IOLC
          P=REAL(IOLC-I)/REAL(IOLC-IOFC)
          Q=REAL(I-IOFC)/REAL(IOLC-IOFC)
          RRED=P*BRED+Q*ERED
          RGRN=P*BGRN+Q*EGRN
          RBLU=P*BBLU+Q*EBLU
          DMIN=SQRT(MIN((RRED-0.)**2+(RGRN-0.)**2+(RBLU-0.)**2,
     +                  (RRED-0.)**2+(RGRN-0.)**2+(RBLU-1.)**2,
     +                  (RRED-0.)**2+(RGRN-1.)**2+(RBLU-0.)**2,
     +                  (RRED-0.)**2+(RGRN-1.)**2+(RBLU-1.)**2,
     +                  (RRED-1.)**2+(RGRN-0.)**2+(RBLU-0.)**2,
     +                  (RRED-1.)**2+(RGRN-0.)**2+(RBLU-1.)**2,
     +                  (RRED-1.)**2+(RGRN-1.)**2+(RBLU-0.)**2,
     +                  (RRED-1.)**2+(RGRN-1.)**2+(RBLU-1.)**2))
          DNOM=1.-(2.*DMIN/SQRT(3.))*MAX(0.,MIN(1.,AMUL))
          RRED=RRED*DNOM
          RGRN=RGRN*DNOM
          RBLU=RBLU*DNOM
          CALL GSCR (IWID,I,RRED,RGRN,RBLU)
  101   CONTINUE
C
C Done.
C
        RETURN
C
      END

C
C	$Id: conbdn.f,v 1.5 2008-07-27 00:16:56 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CONBDN
C
C Calling this do-nothing subroutine forces "ld" to load the following
C block data routine (but only if they are in the same ".f" file).
C
        RETURN
C
      END
CNOSPLIT
      BLOCKDATA CONBDNX
C
C
C
C COMMON DATA
C
C NOTE THE COMMON BLOCKS LISTED INCLUDE ALL THE COMMON USED BY
C      THE ENTIRE CONRAN FAMILY, NOT ALL MEMBERS WILL USE ALL
C      THE COMMON DATA.
C
C   CONRA1
C       CL-ARRAY OF CONTOUR LEVELS
C       NCL-NUMBER OF CONTOUR LEVELS
C       OLDZ-Z VALUE OF LEFT NEIGHBOR TO CURRENT LOCATION
C       PV-ARRAY OF PREVIOUS ROW VALUES
C       HI-LARGEST CONTOUR PLOTTED
C       FLO-LOWEST CONTOUR PLOTTED
C       FINC-INCREMENT LEVEL BETWEEN EQUALLY SPACED CONTOURS
C   CONRA2
C       REPEAT-FLAG TO TRIANGULATE AND DRAW OR JUST DRAW
C       EXTRAP-PLOT DATA OUTSIDE OF CONVEX DATA HULL
C       PER-PUT PERIMETER ARROUND PLOT
C       MESS-FLAG TO INDICATE MESSAGE OUTPUT
C       ISCALE-SCALING SWITCH
C       LOOK-PLOT TRIANGLES FLAG
C       PLDVLS-PLOT THE DATA VALUES FLAG
C       GRD-PLOT GRID FLAG
C       CON-USER SET OR PROGRAM SET CONTOURS FLAG
C       CINC-USER OR PROGRAM SET INCREMENT FLAG
C       CHILO-USER OR PROGRAM SET HI LOW CONTOURS
C       LABON-FLAG TO CONTROL LABELING OF CONTOURS
C       PMIMX-FLAG TO CONTROL THE PLOTTING OF MIN"S
C             AND MAX"S
C       SCALE-THE SCALE FACTOR FOR CONTOUR LINE VALUES
C             AND MIN , MAX PLOTTED VALUES
C       FRADV-ADVANCE FRAME BEFORE PLOTTING TRIANGUALTION
C       EXTRI-ONLY PLOT TRIANGULATION
C       BPSIZ-BREAKPOINT SIZE FOR DASHPATTERNS
C       LISTOP-LIST OPTIONS ON UNIT6 FLAG
C   CONRA3
C       IREC-PORT RECOVERABLE ERROR FLAG
C   CONRA4
C       NCP-NUMBER OF DATA POINTS USED AT EACH POINT FOR
C           POLYNOMIAL CONSTRUCTION.
C       NCPSZ-MAX SIZE ALLOWED FOR NCP
C   CONRA5
C       NIT-FLAG TO INDICATE STATUS OF SEARCH DATA BASE
C       ITIPV-LAST TRIANGLE INTERPOLATION OCCURRED IN
C  CONRA6
C       XST-X COORDINATE START POINT FOR CONTOURING
C       YST-Y COORDINATE START POINT FOR CONTOURING
C       XED-X COORDINATE END POINT FOR CONTOURING
C       YED-Y COORDINATE END POINT FOR CONTOURING
C       STPSZ-STEP SIZE FOR X,Y CHANGE WHEN CONTOURING
C       IGRAD-NUMBER OF GRADUATIONS FOR CONTOURING(STEP SIZE)
C       IG-RESET VALUE FOR IGRAD
C       XRG-X RANGE OF COORDINATES
C       YRG-Y RANGE OF COORDINATES
C       BORD-PERCENT OF FRAME USED FOR CONTOUR PLOT
C       PXST-X PLOTTER START ADDRESS FOR CONTOURS
C       PYST-Y PLOTTER START ADDRESS FOR CONTOURS
C       PXED-X PLOTTER END ADDRESS FOR CONTOURS
C       PYED-Y PLOTTER END ADDRESS FOR CONTOURS
C       ITICK-NUMBER OF TICK MARKS FOR GRIDS AND PERIMETERS
C CONR18
C       TITLE-SWITCH TO INDICATE IF TITLE OPTION ON OR OFF
C       ISTRNG-CHARACTER STRING OF TITLE
C       ICNT-CHARACTER COUNT OF ISTRNG
C       ITLSIZ-SIZE OF TITLE IN PWRIT UNITS
C CONR19
C       IHIGH-DEFAULT COLOR (INTENSITY) INDEX SETTING
C       INMAJ-CONTOUR LEVEL COLOR (INTENSITY) INDEX FOR MAJOR LINES
C       INMIN-CONTOUR LEVEL COLOR (INTENSITY) INDEX FOR MINOR LINES
C       INLAB-TITLE AND MESSAGE COLOR (INTENSITY) INDEX
C       INDAT-DATA VALUE COLOR (INTENSITY) INDEX
C       FORM-THE FORMAT FOR PLOTTING THE DATA VALUES
C       LEN-THE NUMBER OF CHARACTERS IN THE FORMAT
C       IFMT-SIZE OF THE FORMAT FIELD
C       LEND-DEFAULT FORMAT LENGTH
C       IFMTD-DEFAULT FORMAT FIELD SIZE
C       ISIZEP-SIZE OF THE PLOTTED DATA VALUES
C  CONRA9
C       X-ARRAY OF X COORDINATES OF CONTOURS DRAWN AT CURRENT CONTOUR
C          LEVEL
C       Y-ARRAY OF Y COORDINATES OF CONTOURS DRAWN AT CURRENT CONTOUR
C          LEVEL
C       NP-COUNT IN X AND Y
C       MXXY-SIZE OF X AND Y
C       TR-TOP RIGHT CORNER VALUE OF CURRENT CELL
C       BR-BOTTOM RIGHT CORNER VALUE OF CURRENT CELL
C       TL-TOP LEFT CORNER VALUE OF CURRENT CELL
C       BL-BOTTOM LEFT CORNER VALUE OF CURRENT CELL
C       CONV-CURRENT CONTOUR VALUE
C       XN-X POSITION WHERE CONTOUR IS BEING DRAWN
C       YN-Y POSITION WHERE CONTOUR IS BEING DRAWN
C       ITLL-TRIANGLE WHERE TOP LEFT CORNER OF CURRENT CELL LIES
C       IBLL-TRIANGLE OF BOTTOM LEFT CORNER
C       ITRL-TRIANGLE OF TOP RIGHT CORNER
C       IBRL-TRIANGLE OF BOTTOM LEFT CORNER
C       XC-X COORDINATE OF CURRENT CELL
C       YC-Y CORRDINATE OF CURRENT CELL
C       ITLOC-IN CONJUNCTION WITH PV STORES THE TRIANGLE WHERE PV
C             VALUE CAME FROM
C CONR10
C       NT-NUMBER OF TRIANGLES GENERATED
C       NL-NUMBER OF LINE SEGMENTS
C       NTNL-NT+NL
C       JWIPT-POINTER INTO IWK WHERE WHERE TRIANGLE POINT NUMBERS
C             ARE STORED
C       JWIWL-IN IWK THE LOCATION OF A SCRATCH SPACE
C       JWIWP-IN IWK THE LOCATION OF A SCRATCH SPACE
C       JWIPL-IN IWK THE LOCATION OF END POINTS FOR BORDER LINE
C             SEGMENTS
C       IPR-IN WK THE LOCATION OF THE PARTIAL DERIVITIVES AT EACH
C           DATA POINT
C       ITPV-THE TRIANGLE WHERE THE PREVIOUS VALUE CAME FROM
C CONR20
C       NREP-NUMBER OF REPETITIONS OF DASH PATTERN BEFORE A LABEL
C       NCRT-NUMBER OF CRT UNITS FOR A DASH MARK OR BLANK
C       ISIZEL-SIZE OF CONTOUR LINE LABELS
C       NDASH-ARRAY CONTAINING THE NEGATIVE VALUED CONTOUR DASH
C             PATTERN
C       MINGAP-NUMBER OF UNLABELED LINES BETWEEN EACH LABELED ONE
C       IDASH-POSITIVE VALUED CONTOUR DASH PATTERN
C       ISIZEM-SIZE OF PLOTTED MINIMUMS AND MAXIMUMS
C       EDASH-EQUAL VALUED CONTOUR DASH PATTERN
C       TENS-DEFAULT TENSION SETTING FOR SMOOTHING
C CONR12
C       IXMAX,IYMAX-MAXINUM X AND Y COORDINATES RELATIVE TO THE
C                 SCRATCH ARRAY, SCRARR
C       XMAX,YMAX-MAXIMUM X AND Y COORDINATES RELATIVE TO USERS
C                 COORDINATE SPACE
C CONR13
C       XVS-ARRAY OF THE X COORD FOR SHIELDING
C       YVS-ARRAY OF THE Y COORD FOR SHIELDING
C       ICOUNT-COUNT OF THE SHIELD ELEMENTS
C       SPVAL-SPECIAL VALUE USED TO HALT CONTOURING AT THE SHIELD
C               BOUNDRY
C       SHIELD-LOGICAL FLAG TO SIGNAL STATUS OF SHIELDING
C       SLDPLT-LOGICAL FLAG TO INDICTE STATUS OF SHIEDL PLOTTING
C CONR14
C       LINEAR-C1 LINAER INTERPOLATIN FLAG
C
C
      COMMON /CONRA1/ CL(30)     ,NCL        ,OLDZ       ,PV(210)    ,
     1                FINC       ,HI         ,FLO
      COMMON /CONRA2/ REPEAT     ,EXTRAP     ,PER        ,MESS       ,
     1                ISCALE     ,LOOK       ,PLDVLS     ,GRD        ,
     2                CINC       ,CHILO      ,CON        ,LABON      ,
     3                PMIMX      ,SCALE      ,FRADV      ,EXTRI      ,
     4                BPSIZ      ,LISTOP
      COMMON /CONRA3/ IREC
      COMMON /CONRA4/ NCP        ,NCPSZ
      COMMON /CONRA5/ NIT        ,ITIPV
      COMMON /CONRA6/ XST        ,YST        ,XED        ,YED        ,
     1                STPSZ      ,IGRAD      ,IG         ,XRG        ,
     2                YRG        ,BORD       ,PXST       ,PYST       ,
     3                PXED       ,PYED       ,ITICK
      COMMON /CONR18/ TITLE      ,ICNT   ,ITLSIZ
      COMMON /CONR19/ IHIGH      ,INMAJ      ,INLAB      ,INDAT      ,
     1              LEN      ,IFMT       ,LEND       ,
     2                IFMTD      ,ISIZEP     ,INMIN
      COMMON /CONRA9/ ICOORD(500),NP         ,MXXY       ,TR         ,
     1                BR         ,TL         ,BL         ,CONV       ,
     2                XN         ,YN         ,ITLL       ,IBLL       ,
     3                ITRL       ,IBRL       ,XC         ,YC         ,
     4                ITLOC(210) ,JX         ,JY         ,ILOC       ,
     5                ISHFCT     ,XO         ,YO         ,IOC        ,NC
      COMMON /CONR10/ NT         ,NL         ,NTNL       ,JWIPT      ,
     1                JWIWL      ,JWIWP      ,JWIPL      ,IPR        ,
     2                ITPV
      COMMON /CONR20/ NREP       ,NCRT       ,ISIZEL     ,
     1                MINGAP     ,ISIZEM         ,
     2                TENS
      COMMON /CONR12/ IXMAX      ,IYMAX      ,XMAX       ,YMAX
      LOGICAL         REPEAT     ,EXTRAP     ,PER        ,MESS       ,
     1                LOOK       ,PLDVLS     ,GRD        ,LABON      ,
     2                PMIMX      ,FRADV      ,EXTRI      ,CINC       ,
     3                TITLE      ,LISTOP     ,CHILO      ,CON
      COMMON /CONR13/XVS(50),YVS(50),ICOUNT,SPVAL,SHIELD,
     1               SLDPLT
      LOGICAL SHIELD,SLDPLT
      COMMON /CONR14/LINEAR
      LOGICAL LINEAR
      COMMON /CONR15/ ISTRNG
        CHARACTER*64 ISTRNG
        COMMON /CONR16/ FORM
        CHARACTER*10 FORM
        COMMON /CONR17/ NDASH, IDASH, EDASH
        CHARACTER*10 NDASH, IDASH, EDASH
        COMMON /RANINT/ IRANMJ, IRANMN, IRANTX
        COMMON /RAQINT/ IRAQMJ, IRAQMN, IRAQTX
        COMMON /RASINT/ IRASMJ, IRASMN, IRASTX
        SAVE
C
C
C
C
        DATA ICOUNT,SHIELD,SLDPLT,LINEAR/0,.FALSE.,.FALSE.,.FALSE./
        DATA REPEAT,EXTRAP,PER/.FALSE.,.FALSE.,.TRUE./
        DATA FRADV,EXTRI,BPSIZ/.TRUE.,.FALSE.,0.0/
        DATA TITLE,MESS,LOOK/.FALSE.,.TRUE.,.FALSE./
        DATA PLDVLS,GRD/.FALSE.,.FALSE./
        DATA CON,CINC,CHILO/.FALSE.,.FALSE.,.FALSE./
        DATA SCALE,PMIMX/1.,.FALSE./
        DATA ISIZEP,ISIZEM,TENS/8,15,2.5/
        DATA INMAJ,INMIN,INLAB,INDAT/1, 1, 1, 1/
        DATA IRANMJ, IRANMN, IRANTX /1, 1, 1/
        DATA IRASMJ, IRASMN, IRASTX /1, 1, 1/
        DATA IRAQMJ, IRAQMN, IRAQTX /1, 1, 1/
        DATA LABON/.TRUE./,LISTOP/.FALSE./
        DATA BORD,ITICK/.9,10/
        DATA ISCALE,ITLSIZ/0,16/
        DATA ITIPV,NIT,NCL/0,0,0/
        DATA NCPSZ/25/
        DATA IHIGH/255/
        DATA NCP /4/
        DATA IREC /1/
        DATA LEN,IFMT,LEND,IFMTD/0,0,7,10/
        DATA IGRAD,IG/40,40/
        DATA NREP,NCRT,ISIZEL,MXXY,MINGAP/6,3,9,500,3/
        DATA IDASH(1:1)/' '/
        DATA NDASH(1:1)/' '/
        DATA EDASH(1:1)/' '/
        DATA ISHFCT/9/
      END

C
C	$Id: lastd.f,v 1.4 2008-07-27 00:16:58 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE LASTD
C USER ENTRY POINT. SEE DOCUMENTATION FOR PURPOSE.
      DATA IDUMMY /0/
      CALL CFVLD (3,IDUMMY,IDUMMY)
C
C     FLUSH PLOTIT BUFFER
C
      CALL PLOTIT(0,0,0)
      RETURN
      END

      SUBROUTINE DGGRQF( M, P, N, A, LDA, TAUA, B, LDB, TAUB, WORK,
     $                   LWORK, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      INTEGER            INFO, LDA, LDB, LWORK, M, N, P
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), B( LDB, * ), TAUA( * ), TAUB( * ),
     $                   WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  DGGRQF computes a generalized RQ factorization of an M-by-N matrix A
*  and a P-by-N matrix B:
*
*              A = R*Q,        B = Z*T*Q,
*
*  where Q is an N-by-N orthogonal matrix, Z is a P-by-P orthogonal
*  matrix, and R and T assume one of the forms:
*
*  if M <= N,  R = ( 0  R12 ) M,   or if M > N,  R = ( R11 ) M-N,
*                   N-M  M                           ( R21 ) N
*                                                       N
*
*  where R12 or R21 is upper triangular, and
*
*  if P >= N,  T = ( T11 ) N  ,   or if P < N,  T = ( T11  T12 ) P,
*                  (  0  ) P-N                         P   N-P
*                     N
*
*  where T11 is upper triangular.
*
*  In particular, if B is square and nonsingular, the GRQ factorization
*  of A and B implicitly gives the RQ factorization of A*inv(B):
*
*               A*inv(B) = (R*inv(T))*Z'
*
*  where inv(B) denotes the inverse of the matrix B, and Z' denotes the
*  transpose of the matrix Z.
*
*  Arguments
*  =========
*
*  M       (input) INTEGER
*          The number of rows of the matrix A.  M >= 0.
*
*  P       (input) INTEGER
*          The number of rows of the matrix B.  P >= 0.
*
*  N       (input) INTEGER
*          The number of columns of the matrices A and B. N >= 0.
*
*  A       (input/output) DOUBLE PRECISION array, dimension (LDA,N)
*          On entry, the M-by-N matrix A.
*          On exit, if M <= N, the upper triangle of the subarray
*          A(1:M,N-M+1:N) contains the M-by-M upper triangular matrix R;
*          if M > N, the elements on and above the (M-N)-th subdiagonal
*          contain the M-by-N upper trapezoidal matrix R; the remaining
*          elements, with the array TAUA, represent the orthogonal
*          matrix Q as a product of elementary reflectors (see Further
*          Details).
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A. LDA >= max(1,M).
*
*  TAUA    (output) DOUBLE PRECISION array, dimension (min(M,N))
*          The scalar factors of the elementary reflectors which
*          represent the orthogonal matrix Q (see Further Details).
*
*  B       (input/output) DOUBLE PRECISION array, dimension (LDB,N)
*          On entry, the P-by-N matrix B.
*          On exit, the elements on and above the diagonal of the array
*          contain the min(P,N)-by-N upper trapezoidal matrix T (T is
*          upper triangular if P >= N); the elements below the diagonal,
*          with the array TAUB, represent the orthogonal matrix Z as a
*          product of elementary reflectors (see Further Details).
*
*  LDB     (input) INTEGER
*          The leading dimension of the array B. LDB >= max(1,P).
*
*  TAUB    (output) DOUBLE PRECISION array, dimension (min(P,N))
*          The scalar factors of the elementary reflectors which
*          represent the orthogonal matrix Z (see Further Details).
*
*  WORK    (workspace/output) DOUBLE PRECISION array, dimension (LWORK)
*          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*
*  LWORK   (input) INTEGER
*          The dimension of the array WORK. LWORK >= max(1,N,M,P).
*          For optimum performance LWORK >= max(N,M,P)*max(NB1,NB2,NB3),
*          where NB1 is the optimal blocksize for the RQ factorization
*          of an M-by-N matrix, NB2 is the optimal blocksize for the
*          QR factorization of a P-by-N matrix, and NB3 is the optimal
*          blocksize for a call of DORMRQ.
*
*          If LWORK = -1, then a workspace query is assumed; the routine
*          only calculates the optimal size of the WORK array, returns
*          this value as the first entry of the WORK array, and no error
*          message related to LWORK is issued by XERBLA.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INF0= -i, the i-th argument had an illegal value.
*
*  Further Details
*  ===============
*
*  The matrix Q is represented as a product of elementary reflectors
*
*     Q = H(1) H(2) . . . H(k), where k = min(m,n).
*
*  Each H(i) has the form
*
*     H(i) = I - taua * v * v'
*
*  where taua is a real scalar, and v is a real vector with
*  v(n-k+i+1:n) = 0 and v(n-k+i) = 1; v(1:n-k+i-1) is stored on exit in
*  A(m-k+i,1:n-k+i-1), and taua in TAUA(i).
*  To form Q explicitly, use LAPACK subroutine DORGRQ.
*  To use Q to update another matrix, use LAPACK subroutine DORMRQ.
*
*  The matrix Z is represented as a product of elementary reflectors
*
*     Z = H(1) H(2) . . . H(k), where k = min(p,n).
*
*  Each H(i) has the form
*
*     H(i) = I - taub * v * v'
*
*  where taub is a real scalar, and v is a real vector with
*  v(1:i-1) = 0 and v(i) = 1; v(i+1:p) is stored on exit in B(i+1:p,i),
*  and taub in TAUB(i).
*  To form Z explicitly, use LAPACK subroutine DORGQR.
*  To use Z to update another matrix, use LAPACK subroutine DORMQR.
*
*  =====================================================================
*
*     .. Local Scalars ..
      LOGICAL            LQUERY
      INTEGER            LOPT, LWKOPT, NB, NB1, NB2, NB3
*     ..
*     .. External Subroutines ..
      EXTERNAL           DGEQRF, DGERQF, DORMRQ, XERBLA
*     ..
*     .. External Functions ..
      INTEGER            ILAENV
      EXTERNAL           ILAENV
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          INT, MAX, MIN
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters
*
      INFO = 0
      NB1 = ILAENV( 1, 'DGERQF', ' ', M, N, -1, -1 )
      NB2 = ILAENV( 1, 'DGEQRF', ' ', P, N, -1, -1 )
      NB3 = ILAENV( 1, 'DORMRQ', ' ', M, N, P, -1 )
      NB = MAX( NB1, NB2, NB3 )
      LWKOPT = MAX( N, M, P )*NB
      WORK( 1 ) = LWKOPT
      LQUERY = ( LWORK.EQ.-1 )
      IF( M.LT.0 ) THEN
         INFO = -1
      ELSE IF( P.LT.0 ) THEN
         INFO = -2
      ELSE IF( N.LT.0 ) THEN
         INFO = -3
      ELSE IF( LDA.LT.MAX( 1, M ) ) THEN
         INFO = -5
      ELSE IF( LDB.LT.MAX( 1, P ) ) THEN
         INFO = -8
      ELSE IF( LWORK.LT.MAX( 1, M, P, N ) .AND. .NOT.LQUERY ) THEN
         INFO = -11
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DGGRQF', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         RETURN
      END IF
*
*     RQ factorization of M-by-N matrix A: A = R*Q
*
      CALL DGERQF( M, N, A, LDA, TAUA, WORK, LWORK, INFO )
      LOPT = WORK( 1 )
*
*     Update B := B*Q'
*
      CALL DORMRQ( 'Right', 'Transpose', P, N, MIN( M, N ),
     $             A( MAX( 1, M-N+1 ), 1 ), LDA, TAUA, B, LDB, WORK,
     $             LWORK, INFO )
      LOPT = MAX( LOPT, INT( WORK( 1 ) ) )
*
*     QR factorization of P-by-N matrix B: B = Z*T
*
      CALL DGEQRF( P, N, B, LDB, TAUB, WORK, LWORK, INFO )
      WORK( 1 ) = MAX( LOPT, INT( WORK( 1 ) ) )
*
      RETURN
*
*     End of DGGRQF
*
      END

C NCLFORTSTART
      SUBROUTINE TRIPLE2GRID1(KZ,XI,YI,ZI,ZMSG,MX,NY,GX,GY,GRID,
     +                        DOMAIN,LOOP,METHOD,DISTMX,MX2,NY2,
     +                        X,Y,Z,GBIGX,GBIGY,GBIGXY,IER)
      IMPLICIT NONE

c NCL:  grid = triple2grid(xi,yi,zi,gx,gy,option)

      INTEGER MX,NY,KZ,IER,MX2,NY2, LOOP,METHOD
      DOUBLE PRECISION GRID(MX,NY),GX(MX),GY(NY),DISTMX,DOMAIN
      DOUBLE PRECISION XI(KZ),YI(KZ),ZI(KZ),ZMSG
      DOUBLE PRECISION X(KZ),Y(KZ),Z(KZ)

C C C WRAPIT can not handle semantics like:  0:MX2-1 
C C C DOUBLE PRECISION GXBIG(0:MX2-1),GYBIG(0:NY2-1)
C C C DOUBLE PRECISION GBIG(0:MX2-1,0:NY2-1)
      DOUBLE PRECISION GBIGX(MX2),GBIGY(NY2)
      DOUBLE PRECISION GBIGXY(MX2,NY2)
C NCLEND
      INTEGER M,N,K,KOUT,KPTS, MFLAG,NFLAG
      DOUBLE PRECISION DD,DDEPS,DDCRIT

c c c real     t0, t1, t2, second
      logical  debug

      IER   = 0
      DDEPS = 1D-3
      IF (DISTMX.LE.0.0D0) THEN
          DDCRIT = 1D20
      ELSE
          DDCRIT = DISTMX
      END IF
          
      debug = .false.
c c c t0    = second()
c                     strip out missing data (kpts)
c                     count the number of pts outside the grid (KOUT)
      KPTS = 0
      KOUT = 0
      DO K = 1,KZ
          IF (ZI(K).NE.ZMSG) THEN
              KPTS = KPTS + 1
              X(KPTS) = XI(K)
              Y(KPTS) = YI(K)
              Z(KPTS) = ZI(K)
              IF (XI(K).LT.GX(1) .OR. XI(K).GT.GX(MX) .OR.
     +            YI(K).LT.GY(1) .OR. YI(K).GT.GY(NY)) KOUT = KOUT + 1
          END IF
      END DO

c c c if (debug) then
c c c     print *, "STRIP MSG: kout=",kout,":  telapse=", (second()-t0)
c c c end if
c                     return if no valid pts
      IF (KPTS.EQ.0) THEN
          DO N = 1,NY
              DO M = 1,MX
                  GRID(M,N) = ZMSG
              END DO
          END DO
          RETURN
      END IF

c To facilitate faster subscripting, check to see if the grid is equally spaced
c                    equally spaced in x ???
      MFLAG = 1
      DD    = ABS( GX(2)-GX(1) )
      DO M=2,MX-1
         IF (DD.LT.(GX(M+1)-GX(M))-DDEPS   .OR.
     +       DD.GT.(GX(M+1)-GX(M))+DDEPS ) THEN
             MFLAG = 0
             GO TO 10 
         END IF
      END DO

c                    equally spaced in y ???
   10 NFLAG = 1
      DD    = ABS( GY(2)-GY(1) )
      DO N=2,NY-1
         IF (DD.LT.(GY(N+1)-GY(N))-DDEPS   .OR.
     +       DD.GT.(GY(N+1)-GY(N))+DDEPS ) THEN
             NFLAG = 0
             GO TO 20 
         END IF
      END DO
   20 CONTINUE

C  MH Note: 02/01/2017
C
C  There's a serious bug in TRIP2GRD3 that sometimes causes the return 
C  values to be all missing or just flat out wrong. This bug is 
C  elusive; it appears to change in behavior if you run this code
C  in debug mode, or even on different systems (Mac versus Linux).
C  Since TRIP2GRD2 seems to be working for now and is faster, we
C  will have the NCL C driver code set LOOP=0 no matter what.
C
      IF (KOUT.EQ.0) THEN
          IF (LOOP.EQ.0) THEN
              CALL TRIP2GRD2(KPTS,X,Y,Z,ZMSG,MX,NY,GX,GY,GRID
     +                      ,MFLAG,NFLAG,METHOD,DDCRIT,IER)
          ELSE
              CALL TRIP2GRD3(KPTS,X,Y,Z,ZMSG,MX,NY,GX,GY,GRID
     +                      ,MFLAG,NFLAG,METHOD,DDCRIT,IER)
          END IF
      ELSE
c          create an oversized (big) grid
c          allows outliers to influence grid
          DO N = 1,NY
             GBIGY(N+1) = GY(N)
          END DO

          DO M = 1,MX
             GBIGX(M+1) = GX(M)
          END DO
c          domain is arbitrary
          GBIGY(1)   = GY(1)  - DOMAIN*(GY(2)-GY(1))
          GBIGY(NY2) = GY(NY) + DOMAIN*(GY(NY)-GY(NY-1))
          GBIGX(1)   = GX(1)  - DOMAIN*(GX(2)-GX(1))
          GBIGX(MX2) = GX(MX) + DOMAIN*(GX(MX)-GX(MX-1))

C  See MH note above about TRIP2GRD3 and LOOP.
          IF (LOOP.EQ.0) THEN
              CALL TRIP2GRD2(KPTS,X,Y,Z,ZMSG,MX2,NY2,GBIGX,GBIGY
     +                      ,GBIGXY,MFLAG,NFLAG,METHOD,DDCRIT,IER)
          ELSE
              CALL TRIP2GRD3(KPTS,X,Y,Z,ZMSG,MX2,NY2,GBIGX,GBIGY
     +                      ,GBIGXY,MFLAG,NFLAG,METHOD,DDCRIT,IER)
          END IF
c           store interior of gbig in return array
          DO N = 1,NY
            DO M = 1,MX
               GRID(M,N) = GBIGXY(M+1,N+1)
            END DO
          END DO
      END IF

c c c if (debug) then
c c c     print *, "TOTAL TIME    :  telapse=", (second()-t0)
c c c end if

      RETURN
      END
C ------------
      SUBROUTINE TRIP2GRD2(KZ,X,Y,Z,ZMSG,MX,NY,GXOUT,GYOUT,GOUT
     +                     ,MFLAG,NFLAG,METHOD,DDCRIT,IER)

c This sub assigns each "Z" to a grid point.
c It is possible that the number of grid points having values assigned
c .   will be less than the number KZ due to over writing the same grid pt.

      IMPLICIT NONE
      INTEGER MX,NY,KZ,IER, MFLAG,NFLAG,METHOD
      DOUBLE PRECISION GXOUT(MX),GYOUT(NY),GOUT(MX,NY)
      DOUBLE PRECISION X(KZ),Y(KZ),Z(KZ),ZMSG,DDCRIT
c                          local
      INTEGER M,N,K,MM,NN,KSUM,KPTS
      DOUBLE PRECISION DOUT(MX,NY)
      DOUBLE PRECISION DD,XX,YY,SLPY,SLPX,DX,DY,ATMP,YLAT,RE,RAD 

c c c real     t0, t1, t2, second
      logical  debug

      IER   = 0
      debug = .false.
c c c t0    = second()

      RE   = 6371.2200D0 
      RAD  = 4.D0*ATAN(1.0D0)/180.D0

c                     strip out missing data (kpts)
c                     count the number of pts outside the grid (kout)
      IER  = 0
      KPTS = KZ
      DX   = ABS( GXOUT(3)-GXOUT(2) )
      DY   = ABS( GYOUT(3)-GYOUT(2) )

c                          initialize
      DO N = 1,NY
        DO M = 1,MX
           DOUT(M,N) = 1D20
           GOUT(M,N) = ZMSG
        END DO
      END DO

c                     EXACT MATCHES ONLY 
c c c t1  = second()
      KSUM = 0
      DO K = 1,KPTS
        DO N=1,NY
           IF (Y(K).EQ.GYOUT(N)) THEN
               DO M=1,MX
                  IF (X(K).EQ.GXOUT(M)) THEN
                      GOUT(M,N) = Z(K)
                      DOUT(M,N) = 0.0D0
                      KSUM = KSUM + 1
                      GO TO 10
                   END IF
                END DO
            END IF
        END DO
   10   CONTINUE
      END DO

c  Did all kpts input get assigned to the gout?
c  ier = -1 is not really an error; it is just informational
c           meaning that no 'nearest neighbor' stuff was used.

      IF (KSUM.EQ.KPTS) THEN
          IER = -1
          RETURN
      END IF
c                     LOOP OVER THE X/Y/Z POINTS
c                     ASSIGN TO NEARBY GRID POINT
      KSUM = 0
      DO K = 1,KPTS
c                     determine subscripts to nearest grid pt
         NN = -1
         IF (NFLAG.EQ.1) THEN
             NN = INT(((Y(K)-GYOUT(1))/DY))+2  
         ELSE
             DO N=1,NY-1
                IF (Y(K).GE.GYOUT(N) .AND. Y(K).LT.GYOUT(N+1) ) THEN   
                    DY   = Y(K)-GYOUT(N)
                    SLPY = DY/(GYOUT(N+1)-GYOUT(N))
                    YY   = N + SLPY
                    NN   = NINT(YY)
                    GO TO 20
                END IF
             END DO
         END IF

   20    MM = -1
         IF (MFLAG.EQ.1) THEN
             MM = INT(((X(K)-GXOUT(1))/DX))+2
         ELSE
             DO M=1,MX-1
                IF (X(K).GE.GXOUT(M) .AND. X(K).LT.GXOUT(M+1) ) THEN   
                    DX   = X(K)-GXOUT(M)
                    SLPX = DX/(GXOUT(M+1)-GXOUT(M))
                    XX   = M + SLPX
                    MM   = NINT(XX)
                    GO TO 30
                END IF
             END DO
         END IF

  30     IF (MM.GE.1 .AND. MM.LE.MX .AND.
     +       NN.GE.1 .AND. NN.LE.NY) THEN

c                                     mm,nn =>  nearest grid pt
             IF (METHOD.EQ.0) THEN
                 DD = SQRT( SLPX**2 + SLPY**2 )
             ELSE
                 YLAT = Y(K)*RAD
                 ATMP = SIN(YLAT)*SIN(GXOUT(MM)*RAD)
     +                       + COS(YLAT)*COS(GYOUT(NN)*RAD)*
     +                         COS((X(K)-GXOUT(MM))*RAD)
                 ATMP  = MIN(1.D0,MAX(-1.D0,ATMP))
                 DD    = ACOS(ATMP)*RE
             END IF

             IF (DD.LT.DOUT(MM,NN) .AND. DD.LT.DDCRIT) THEN
                 KSUM = KSUM + 1
                 GOUT(MM,NN) = Z(K)
                 DOUT(MM,NN) = DD
             END IF
         END IF
   
      END DO

c     if (debug) then
c c c     print *, "gout interior :  kpts=",kpts,":  ksum=",ksum
c c c+                                 ,": telapse=", (second()-t1)
c     end if

      RETURN
      END
C ------------
      SUBROUTINE TRIP2GRD3(KZ,X,Y,Z,ZMSG,MX,NY,GXOUT,GYOUT,GOUT
     +                    ,MFLAG,NFLAG,METHOD,DDCRIT,IER)

      IMPLICIT NONE
      INTEGER MX,NY,KZ,IER, MFLAG,NFLAG,METHOD
      DOUBLE PRECISION GXOUT(MX),GYOUT(NY),GOUT(MX,NY)
      DOUBLE PRECISION X(KZ),Y(KZ),Z(KZ),ZMSG, DDCRIT
c                          local
      INTEGER M,N,K,KSUM,KPTS
      DOUBLE PRECISION DOUT(MX,NY), DIST(KZ)
     +                ,RE,RAD,RLAT,ATMP 

c c c real     t0, t1, t2, second
      logical  debug

      debug = .true.
c c c t0    = second()

      IER = 0
      KPTS = KZ
c                          initialize
      DO N = 1,NY
          DO M = 1,MX
              DOUT(M,N) = 1.D20
              GOUT(M,N) = ZMSG
          END DO
      END DO
c                     EXACT MATCHES ONLY 
c c c t1  = second()
      KSUM = 0
      DO K = 1,KPTS
         DO N=1,NY
            IF (Y(K).EQ.GYOUT(N)) THEN
                DO M=1,MX
                   IF (X(K).EQ.GXOUT(M)) THEN
                      GOUT(M,N) = Z(K)
                      DOUT(M,N) = 0.0D0
                      KSUM = KSUM + 1
                      GO TO 10
                   END IF
                END DO
            END IF
         END DO
   10    CONTINUE
      END DO

c c c if (debug) then
c c c     print *, "EXACT MATCH: ksum=",ksum,":  telapse=",(second()-t1)
c c c end if

c  Did all kpts input get assigned to the gout?
c  ier = -1 is not really an error; it is just informational
c           meaning that no 'nearest neighbor' stuuf was used.

      IF (KSUM.EQ.KPTS) THEN
          IER = -11
          RETURN
      END IF

c c c t1  = second()

      RE   = 6371.2200D0 
      RAD  = 4.D0*ATAN(1.0D0)/180.D0
C                                        LOOP OVER EACH GRID POINT
      DO N = 1,NY
         DO M = 1,MX
            IF (DOUT(M,N).NE.0.D0) then
C                                        LOOP OVER EACH OBSERVATION
C                                        DISTANCE TO CURRENT GRID PT
                IF (METHOD.EQ.0) THEN
                    DO K = 1,KPTS
                       DIST(K) = SQRT( (X(K)-GXOUT(M))**2 
     +                               + (Y(K)-GYOUT(N))**2)
                    END DO
                ELSE
                    RLAT = GYOUT(N)*RAD
                    DO K = 1,KPTS
C
C The ATMP variable is necessary to make sure the
C value passed to ACOS is between -1 and 1.
C (Otherwise, you might get "NaN".)
C
                        ATMP = SIN(RLAT)*SIN(Y(K)*RAD)
     +                       + COS(RLAT)*COS(Y(K)*RAD)*
     +                         COS((X(K)-GXOUT(M))*RAD)
                        ATMP  = MIN(1.D0,MAX(-1.D0,ATMP))
                        DIST(K) = ACOS(ATMP)*RE
                    END DO
                END IF
c                              assign z(k) to nearest grid point
                DO K = 1,KPTS
                   IF (Z(K).NE.ZMSG) THEN
                       IF (DIST(K).LT.DOUT(M,N) .AND. 
     +                     DIST(K) .LT.DDCRIT)   THEN
                           DOUT(M,N) = DIST(K)
                           GOUT(M,N) = Z(K)
                       END IF
                   END IF
                END DO

            END IF

         END DO
      END DO

      RETURN
      END

c ------------------
C TRIP2GRID4 ... not used ....keep for historical reasons
c ------------------
cc    SUBROUTINE TRIP2GRD4(KZ,X,Y,Z,ZMSG,MX,NY,GXOUT,GYOUT,GOUT,STRICT,
cc   +                    ,METHOD,IER)

cc    IMPLICIT NONE
cc    INTEGER MX,NY,KZ,IER, METHOD
cc    DOUBLE PRECISION GXOUT(MX),GYOUT(NY),GOUT(MX,NY)
cc    DOUBLE PRECISION X(KZ),Y(KZ),Z(KZ),ZMSG
cc    LOGICAL STRICT
c                          local
cc    INTEGER M,N,K,MM,NN,KSUM,KPTS
cc    DOUBLE PRECISION DOUT(MX,NY),DD,XX,YY,SLPY,SLPX

cc    real     t0, t1, t2, second
cc    logical  debug

cc    debug = .true.
cc    t0    = second()

cc    IER = 0
cc    KPTS = KZ
c                          initialize
cc    DO N = 1,NY
cc        DO M = 1,MX
cc            DOUT(M,N) = 1.D20
cc            GOUT(M,N) = ZMSG
cc        END DO
cc    END DO
c                     EXACT MATCHES ONLY 
cc    t1  = second()
cc    KSUM = 0
cc    DO K = 1,KPTS
cc       DO N=1,NY
cc          IF (Y(K).EQ.GYOUT(N)) THEN
cc              DO M=1,MX
cc                 IF (X(K).EQ.GXOUT(M)) THEN
cc                    GOUT(M,N) = Z(K)
cc                    DOUT(M,N) = 0.0D0
cc                    KSUM = KSUM + 1
cc                    GO TO 10
cc                 END IF
cc              END DO
cc          END IF
cc       END DO
cc 10    CONTINUE
cc    END DO

cc    if (debug) then
cc        print *, "EXACT MATCH: ksum=",ksum,":  telapse=",(second()-t1)
cc    end if

c  Did all kpts input get assigned to the gout?
c  ier = -1 is not really an error; it is just informational
c           meaning that no 'nearest neighbor' stuuf was used.

cc    IF (KSUM.EQ.KPTS) THEN
cc        IER = -1
cc        RETURN
cc    END IF

cc    t1  = second()
c                     LOOP OVER POINTS
cc    KSUM = 0
cc    DO N = 1,NY
cc        DO M = 1,MX
cc        IF (DOUT(M,N).NE.0.0) THEN

cc            DO K = 1,KPTS
cc                IF ((X(K).GE.GXOUT(M).AND.X(K).LT.GXOUT(M+1)) .AND.
cc   +                (Y(K).GE.GYOUT(N).AND.Y(K).LT.GYOUT(N+1))) THEN

cc                    SLPX = (X(K)-GXOUT(M))/ (GXOUT(M+1)-GXOUT(M))
cc                    SLPY = (Y(K)-GYOUT(N))/ (GYOUT(N+1)-GYOUT(N))
cc                    XX = M + SLPX
cc                    YY = N + SLPY
cc                    IF (STRICT) THEN
c                                     mm,nn =>  nearest grid pt
cc                        MM = NINT(XX)
cc                        NN = NINT(YY)
cc                        DD = SQRT(X-MM)**2 + (YY-NN)**2)
cc                        IF (DD.LT.DOUT(MM,NN)) THEN
cc                            KSUM = KSUM + 1
cc                            GOUT(MM,NN) = Z(K)
cc                            DOUT(MM,NN) = DD
cc                        END IF
cc                    ELSE
c                                    allow value to influence nearby pts
cc                        DO NN = N,N + 1
cc                            DO MM = M,M + 1
cc                                DD = (XX-MM)**2 + (YY-NN)**2
cc                                IF (DD.LT.DOUT(MM,NN)) THEN
cc                                    KSUM = KSUM + 1
cc                                    GOUT(MM,NN) = Z(K)
cc                                    DOUT(MM,NN) = DD
cc                                END IF
cc                            END DO
cc                        END DO
cc                    END IF

cc                END IF
cc            END DO

c c c     end if
cc        END DO
cc    END DO

cc    if (debug) then
cc        print *, "gout interior :  kpts=",kpts,":  ksum=",ksum
cc   +                                 ,": telapse=", (second()-t1)
cc    end if

cc    RETURN
cc    END

C
C     $Id: sscal.f,v 1.1 1994-08-11 23:17:35 boote Exp $
C



      SUBROUTINE  SSCAL(N,SA,SX,INCX)
C
C     SCALES A VECTOR BY A CONSTANT.
C     USES UNROLLED LOOPS FOR INCREMENT EQUAL TO 1.
C     JACK DONGARRA, LINPACK, 3/11/78.
C
      REAL SA,SX(1)
      INTEGER I,INCX,M,MP1,N,NINCX
C
      IF(N.LE.0)RETURN
      IF(INCX.EQ.1)GO TO 20
C
C        CODE FOR INCREMENT NOT EQUAL TO 1
C
      NINCX = N*INCX
      DO 10 I = 1,NINCX,INCX
        SX(I) = SA*SX(I)
   10 CONTINUE
      RETURN
C
C        CODE FOR INCREMENT EQUAL TO 1
C
C
C        CLEAN-UP LOOP
C
   20 M = MOD(N,5)
      IF( M .EQ. 0 ) GO TO 40
      DO 30 I = 1,M
        SX(I) = SA*SX(I)
   30 CONTINUE
      IF( N .LT. 5 ) RETURN
   40 MP1 = M + 1
      DO 50 I = MP1,N,5
        SX(I) = SA*SX(I)
        SX(I + 1) = SA*SX(I + 1)
        SX(I + 2) = SA*SX(I + 2)
        SX(I + 3) = SA*SX(I + 3)
        SX(I + 4) = SA*SX(I + 4)
   50 CONTINUE
      RETURN
      END

C NCLFORTSTART
      SUBROUTINE DTAPER(X,N,P,XT,IOPT)
      IMPLICIT NONE
C NCL: xTaper = taper(x,p,iopt)

c this subroutine applies split-cosine-bell tapering to the series x.
c .   the series will be tapered to the mean of x.
c .   See Bloomfield's "Intro to Fourier .."
c .   This is used prior performing an fft on non-cyclic data

c arguments:
c .   x   series to be tapered (tapering done in place)
c .       **missing data not allowed**
c .   n   series length
c .   p   the proportion of the time series to be tapered
c .       [p=0.10 means 10 %]
c .   xt  tapered series
c .   iopt  iopt=0 taper to series mean
c .   iopt  iopt=1 means *force* taper to 0.0
C                                            INPUT
      INTEGER N,IOPT
      DOUBLE PRECISION X(N),P
C                                            OUTPUT
      DOUBLE PRECISION XT(N)
C NCLEND
      INTEGER I,M,kopt
      DOUBLE PRECISION WEIGHT,PI,PIM,XAV
      DATA PI/3.141592653589D0/

      kopt = iopt

c pathological case: all values constant  
c force taper to xav=0.0

      do i=2,n
         if (x(i).ne.x(1)) then
             go to 10
         end if
      end do
      kopt = 1
   10 continue
  
      XAV = 0.0D0
      if (kopt.ne.1) then
          DO I = 1,N
             XT(I) = X(I)
             XAV = XAV + X(I)
         END DO
         XAV = XAV/N
      end if

      M = MAX0(1,INT(P*DBLE(N)+0.5D0)/2)
      PIM = PI/DBLE(M)

      DO I = 1,M
          WEIGHT = 0.5D0 - 0.5D0*COS(PIM* (DBLE(I)-0.5D0))
          XT(I) = (X(I)-XAV)*WEIGHT + XAV
          XT(N+1-I) = (X(N+1-I)-XAV)*WEIGHT + XAV
      END DO

c .   cft correction factor for taper (not used , for info only)
c c c cft = 0.5*(128.-93.*p)/(8.-5.*p)**2

      RETURN
      END

      SUBROUTINE DLAGTM( TRANS, N, NRHS, ALPHA, DL, D, DU, X, LDX, BETA,
     $                   B, LDB )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     October 31, 1992
*
*     .. Scalar Arguments ..
      CHARACTER          TRANS
      INTEGER            LDB, LDX, N, NRHS
      DOUBLE PRECISION   ALPHA, BETA
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   B( LDB, * ), D( * ), DL( * ), DU( * ),
     $                   X( LDX, * )
*     ..
*
*  Purpose
*  =======
*
*  DLAGTM performs a matrix-vector product of the form
*
*     B := alpha * A * X + beta * B
*
*  where A is a tridiagonal matrix of order N, B and X are N by NRHS
*  matrices, and alpha and beta are real scalars, each of which may be
*  0., 1., or -1.
*
*  Arguments
*  =========
*
*  TRANS   (input) CHARACTER
*          Specifies the operation applied to A.
*          = 'N':  No transpose, B := alpha * A * X + beta * B
*          = 'T':  Transpose,    B := alpha * A'* X + beta * B
*          = 'C':  Conjugate transpose = Transpose
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  NRHS    (input) INTEGER
*          The number of right hand sides, i.e., the number of columns
*          of the matrices X and B.
*
*  ALPHA   (input) DOUBLE PRECISION
*          The scalar alpha.  ALPHA must be 0., 1., or -1.; otherwise,
*          it is assumed to be 0.
*
*  DL      (input) DOUBLE PRECISION array, dimension (N-1)
*          The (n-1) sub-diagonal elements of T.
*
*  D       (input) DOUBLE PRECISION array, dimension (N)
*          The diagonal elements of T.
*
*  DU      (input) DOUBLE PRECISION array, dimension (N-1)
*          The (n-1) super-diagonal elements of T.
*
*  X       (input) DOUBLE PRECISION array, dimension (LDX,NRHS)
*          The N by NRHS matrix X.
*  LDX     (input) INTEGER
*          The leading dimension of the array X.  LDX >= max(N,1).
*
*  BETA    (input) DOUBLE PRECISION
*          The scalar beta.  BETA must be 0., 1., or -1.; otherwise,
*          it is assumed to be 1.
*
*  B       (input/output) DOUBLE PRECISION array, dimension (LDB,NRHS)
*          On entry, the N by NRHS matrix B.
*          On exit, B is overwritten by the matrix expression
*          B := alpha * A * X + beta * B.
*
*  LDB     (input) INTEGER
*          The leading dimension of the array B.  LDB >= max(N,1).
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ONE, ZERO
      PARAMETER          ( ONE = 1.0D+0, ZERO = 0.0D+0 )
*     ..
*     .. Local Scalars ..
      INTEGER            I, J
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. Executable Statements ..
*
      IF( N.EQ.0 )
     $   RETURN
*
*     Multiply B by BETA if BETA.NE.1.
*
      IF( BETA.EQ.ZERO ) THEN
         DO 20 J = 1, NRHS
            DO 10 I = 1, N
               B( I, J ) = ZERO
   10       CONTINUE
   20    CONTINUE
      ELSE IF( BETA.EQ.-ONE ) THEN
         DO 40 J = 1, NRHS
            DO 30 I = 1, N
               B( I, J ) = -B( I, J )
   30       CONTINUE
   40    CONTINUE
      END IF
*
      IF( ALPHA.EQ.ONE ) THEN
         IF( LSAME( TRANS, 'N' ) ) THEN
*
*           Compute B := B + A*X
*
            DO 60 J = 1, NRHS
               IF( N.EQ.1 ) THEN
                  B( 1, J ) = B( 1, J ) + D( 1 )*X( 1, J )
               ELSE
                  B( 1, J ) = B( 1, J ) + D( 1 )*X( 1, J ) +
     $                        DU( 1 )*X( 2, J )
                  B( N, J ) = B( N, J ) + DL( N-1 )*X( N-1, J ) +
     $                        D( N )*X( N, J )
                  DO 50 I = 2, N - 1
                     B( I, J ) = B( I, J ) + DL( I-1 )*X( I-1, J ) +
     $                           D( I )*X( I, J ) + DU( I )*X( I+1, J )
   50             CONTINUE
               END IF
   60       CONTINUE
         ELSE
*
*           Compute B := B + A'*X
*
            DO 80 J = 1, NRHS
               IF( N.EQ.1 ) THEN
                  B( 1, J ) = B( 1, J ) + D( 1 )*X( 1, J )
               ELSE
                  B( 1, J ) = B( 1, J ) + D( 1 )*X( 1, J ) +
     $                        DL( 1 )*X( 2, J )
                  B( N, J ) = B( N, J ) + DU( N-1 )*X( N-1, J ) +
     $                        D( N )*X( N, J )
                  DO 70 I = 2, N - 1
                     B( I, J ) = B( I, J ) + DU( I-1 )*X( I-1, J ) +
     $                           D( I )*X( I, J ) + DL( I )*X( I+1, J )
   70             CONTINUE
               END IF
   80       CONTINUE
         END IF
      ELSE IF( ALPHA.EQ.-ONE ) THEN
         IF( LSAME( TRANS, 'N' ) ) THEN
*
*           Compute B := B - A*X
*
            DO 100 J = 1, NRHS
               IF( N.EQ.1 ) THEN
                  B( 1, J ) = B( 1, J ) - D( 1 )*X( 1, J )
               ELSE
                  B( 1, J ) = B( 1, J ) - D( 1 )*X( 1, J ) -
     $                        DU( 1 )*X( 2, J )
                  B( N, J ) = B( N, J ) - DL( N-1 )*X( N-1, J ) -
     $                        D( N )*X( N, J )
                  DO 90 I = 2, N - 1
                     B( I, J ) = B( I, J ) - DL( I-1 )*X( I-1, J ) -
     $                           D( I )*X( I, J ) - DU( I )*X( I+1, J )
   90             CONTINUE
               END IF
  100       CONTINUE
         ELSE
*
*           Compute B := B - A'*X
*
            DO 120 J = 1, NRHS
               IF( N.EQ.1 ) THEN
                  B( 1, J ) = B( 1, J ) - D( 1 )*X( 1, J )
               ELSE
                  B( 1, J ) = B( 1, J ) - D( 1 )*X( 1, J ) -
     $                        DL( 1 )*X( 2, J )
                  B( N, J ) = B( N, J ) - DU( N-1 )*X( N-1, J ) -
     $                        D( N )*X( N, J )
                  DO 110 I = 2, N - 1
                     B( I, J ) = B( I, J ) - DU( I-1 )*X( I-1, J ) -
     $                           D( I )*X( I, J ) - DL( I )*X( I+1, J )
  110             CONTINUE
               END IF
  120       CONTINUE
         END IF
      END IF
      RETURN
*
*     End of DLAGTM
*
      END

C
C $Id: pakcsp.f,v 1.5 2008-07-27 00:17:09 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      REAL FUNCTION PAKCSP (PAK)
C
C FUNCTION TO CONVERT 2 DIGIT PACKED DMS TO 3 DIGIT PACKED DMS ANGLE.
C
C SGNA : SIGN OF ANGLE
C DEGS : DEGREES PORTION OF ANGLE
C MINS : MINUTES PORTION OF ANGLE
C SECS : SECONDS PORTION OF ANGLE
C
      IMPLICIT REAL (A-Z)
      INTEGER DEGS,MINS
      CHARACTER*1 SGNA,IBLANK,NEG
      DATA ZERO,CON1,CON2 /0.0E0,10000.0E0,100.0E0/
      DATA CON3,CON4 /1000000.0E0,1000.0E0/
      DATA TOL /1.0E-3/
      DATA IBLANK,NEG /' ','-'/
C
      SGNA = IBLANK
      IF (PAK .LT. ZERO) SGNA = NEG
      CON = ABS (PAK)
      DEGS = INT ((CON / CON1) + TOL)
      CON = MOD ( CON , CON1)
      MINS = INT ((CON / CON2) + TOL)
      SECS = MOD (CON , CON2)
C
      CON = DEGS * CON3 + MINS * CON4 + SECS
      IF (SGNA .EQ. NEG) CON = - CON
      PAKCSP = CON
      RETURN
C
      END

      SUBROUTINE DCFINDIF(Q,R,NPTS,QMSG,RMSG,ICYC,IEND,QQ,RR,NPTS1,
     +                    DQDR,IER)

c perform a centered finite difference:
c .   dq/dr ==> partial(q)/partial(r) ==>
c .             dqdr(n) = (q(n+1)-q(n-1))/(r(n+1)-r(n-1))

c NCL: dqdr = center_finite_diff (q,r,rCyclic,opt)
c .           rCyclic = True/False
c .           opt     = unused
c .           wrapper: if rCyclic=True   set iend=0
c .           wrapper: if rCyclic=False  set iend=1

c Nomenclature:
c .   q     - input vector [variable to be differenced]
c .   r     - input vector [spatial or temporal coordinates]
c .   npts  - number of points
c .   qmsg  - msg value for q
c .   rmsg  - msg value for r [currently not used]
c .   icyc  - =1 if data are cyclic in the "r" coordinate
c .   iend  - only used if data are not cyclic in the "r" coordinate
c .           =1 if the end points of are to be approximated
c .              via a one-sided difference scheme
c .           =0 if the end points of are to be returned as rmsg
c .   dqdr  - result
c .   ier   - error code

      IMPLICIT NONE
c                                     input arguments
      INTEGER NPTS,NPTS1,ICYC,IEND
      DOUBLE PRECISION Q(NPTS),R(NPTS),QMSG,RMSG
c                                     output
      INTEGER IER
      DOUBLE PRECISION DQDR(NPTS)
      DOUBLE PRECISION QQ(0:NPTS1),RR(0:NPTS1)
      INTEGER N,NSTRT,NLAST

      IER = 0
c                                    not enough points
      IF (NPTS.LE.2) THEN
          IER = 1
      END IF
c                                    conflicting options
      IF (ICYC.EQ.1 .AND. IEND.NE.0) THEN
          IER = 2
      END IF
      IF (IER.NE.0) RETURN
c                                    initialize
      DO N = 1,NPTS
          DQDR(N) = QMSG
          QQ(N) = Q(N)
          RR(N) = R(N)
      END DO
c                                    add points if cyclic
      NSTRT = 2
      NLAST = NPTS - 1
      IF (ICYC.EQ.1) THEN
          NSTRT = 1
          NLAST = NPTS
          QQ(0) = QQ(NPTS)
          RR(0) = RR(1) - (RR(2)-RR(1))
          QQ(NPTS+1) = QQ(1)
          RR(NPTS+1) = RR(NPTS) + (RR(NPTS)-RR(NPTS-1))
      END IF
c                                    centered finite differences
      DO N = NSTRT,NLAST
          IF (QQ(N-1).NE.QMSG .AND. QQ(N+1).NE.QMSG) THEN
              DQDR(N) = (QQ(N+1)-QQ(N-1))/ (RR(N+1)-RR(N-1))
          END IF
      END DO
c                                    if not cyclic
c                                    how to treat end-points
c                                    3 Mar 2006 [added qmsg checks]
      IF (ICYC.NE.1 .AND. IEND.EQ.1) THEN
         IF (QQ(1).NE.QMSG .AND. QQ(2).NE.QMSG) THEN
             DQDR(1) = (QQ(2)-QQ(1))/ (RR(2)-RR(1))
         END IF
         IF (QQ(NPTS).NE.QMSG .AND. QQ(NPTS-1).NE.QMSG) THEN
             DQDR(NPTS) = (QQ(NPTS)-QQ(NPTS-1))/ (RR(NPTS)-RR(NPTS-1))
         END IF
      END IF

      RETURN
      END

C
C	$Id: cslstptr.f,v 1.5 2008-07-27 03:10:07 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      INTEGER FUNCTION CSLSTPTR (LPL,NB,LIST,LPTR)
      INTEGER LPL, NB, LIST(*), LPTR(*)
C
C***********************************************************
C
C                                              From STRIPACK
C                                            Robert J. Renka
C                                  Dept. of Computer Science
C                                       Univ. of North Texas
C                                           renka@cs.unt.edu
C                                                   07/15/96
C
C   This function returns the index (LIST pointer) of NB in
C the adjacency list for N0, where LPL = LEND(N0).
C
C   This function is identical to the similarly named
C function in TRIPACK.
C
C
C On input:
C
C       LPL = LEND(N0)
C
C       NB = Index of the node whose pointer is to be re-
C            turned.  NB must be connected to N0.
C
C       LIST,LPTR = Data structure defining the triangula-
C                   tion.  Refer to Subroutine CSTRMESH.
C
C Input parameters are not altered by this function.
C
C On output:
C
C       CSLSTPTR = Pointer such that LIST(CSLSTPTR) = NB or
C                LIST(CSLSTPTR) = -NB, unless NB is not a
C                neighbor of N0, in which case CSLSTPTR = LPL.
C
C Modules required by CSLSTPTR:  None
C
C***********************************************************
C
      INTEGER LP, ND
C
C Local parameters:
C
C LP = LIST pointer
C ND = Nodal index
C
      LP = LPTR(LPL)
    1 ND = LIST(LP)
        IF (ND .EQ. NB) GO TO 2
        LP = LPTR(LP)
        IF (LP .NE. LPL) GO TO 1
C
    2 CSLSTPTR = LP
      RETURN
      END

      SUBROUTINE CGGQRF( N, M, P, A, LDA, TAUA, B, LDB, TAUB, WORK,
     $                   LWORK, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      INTEGER            INFO, LDA, LDB, LWORK, M, N, P
*     ..
*     .. Array Arguments ..
      COMPLEX            A( LDA, * ), B( LDB, * ), TAUA( * ), TAUB( * ),
     $                   WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  CGGQRF computes a generalized QR factorization of an N-by-M matrix A
*  and an N-by-P matrix B:
*
*              A = Q*R,        B = Q*T*Z,
*
*  where Q is an N-by-N unitary matrix, Z is a P-by-P unitary matrix,
*  and R and T assume one of the forms:
*
*  if N >= M,  R = ( R11 ) M  ,   or if N < M,  R = ( R11  R12 ) N,
*                  (  0  ) N-M                         N   M-N
*                     M
*
*  where R11 is upper triangular, and
*
*  if N <= P,  T = ( 0  T12 ) N,   or if N > P,  T = ( T11 ) N-P,
*                   P-N  N                           ( T21 ) P
*                                                       P
*
*  where T12 or T21 is upper triangular.
*
*  In particular, if B is square and nonsingular, the GQR factorization
*  of A and B implicitly gives the QR factorization of inv(B)*A:
*
*               inv(B)*A = Z'*(inv(T)*R)
*
*  where inv(B) denotes the inverse of the matrix B, and Z' denotes the
*  conjugate transpose of matrix Z.
*
*  Arguments
*  =========
*
*  N       (input) INTEGER
*          The number of rows of the matrices A and B. N >= 0.
*
*  M       (input) INTEGER
*          The number of columns of the matrix A.  M >= 0.
*
*  P       (input) INTEGER
*          The number of columns of the matrix B.  P >= 0.
*
*  A       (input/output) COMPLEX array, dimension (LDA,M)
*          On entry, the N-by-M matrix A.
*          On exit, the elements on and above the diagonal of the array
*          contain the min(N,M)-by-M upper trapezoidal matrix R (R is
*          upper triangular if N >= M); the elements below the diagonal,
*          with the array TAUA, represent the unitary matrix Q as a
*          product of min(N,M) elementary reflectors (see Further
*          Details).
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A. LDA >= max(1,N).
*
*  TAUA    (output) COMPLEX array, dimension (min(N,M))
*          The scalar factors of the elementary reflectors which
*          represent the unitary matrix Q (see Further Details).
*
*  B       (input/output) COMPLEX array, dimension (LDB,P)
*          On entry, the N-by-P matrix B.
*          On exit, if N <= P, the upper triangle of the subarray
*          B(1:N,P-N+1:P) contains the N-by-N upper triangular matrix T;
*          if N > P, the elements on and above the (N-P)-th subdiagonal
*          contain the N-by-P upper trapezoidal matrix T; the remaining
*          elements, with the array TAUB, represent the unitary
*          matrix Z as a product of elementary reflectors (see Further
*          Details).
*
*  LDB     (input) INTEGER
*          The leading dimension of the array B. LDB >= max(1,N).
*
*  TAUB    (output) COMPLEX array, dimension (min(N,P))
*          The scalar factors of the elementary reflectors which
*          represent the unitary matrix Z (see Further Details).
*
*  WORK    (workspace/output) COMPLEX array, dimension (LWORK)
*          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*
*  LWORK   (input) INTEGER
*          The dimension of the array WORK. LWORK >= max(1,N,M,P).
*          For optimum performance LWORK >= max(N,M,P)*max(NB1,NB2,NB3),
*          where NB1 is the optimal blocksize for the QR factorization
*          of an N-by-M matrix, NB2 is the optimal blocksize for the
*          RQ factorization of an N-by-P matrix, and NB3 is the optimal
*          blocksize for a call of CUNMQR.
*
*          If LWORK = -1, then a workspace query is assumed; the routine
*          only calculates the optimal size of the WORK array, returns
*          this value as the first entry of the WORK array, and no error
*          message related to LWORK is issued by XERBLA.
*
*  INFO    (output) INTEGER
*           = 0:  successful exit
*           < 0:  if INFO = -i, the i-th argument had an illegal value.
*
*  Further Details
*  ===============
*
*  The matrix Q is represented as a product of elementary reflectors
*
*     Q = H(1) H(2) . . . H(k), where k = min(n,m).
*
*  Each H(i) has the form
*
*     H(i) = I - taua * v * v'
*
*  where taua is a complex scalar, and v is a complex vector with
*  v(1:i-1) = 0 and v(i) = 1; v(i+1:n) is stored on exit in A(i+1:n,i),
*  and taua in TAUA(i).
*  To form Q explicitly, use LAPACK subroutine CUNGQR.
*  To use Q to update another matrix, use LAPACK subroutine CUNMQR.
*
*  The matrix Z is represented as a product of elementary reflectors
*
*     Z = H(1) H(2) . . . H(k), where k = min(n,p).
*
*  Each H(i) has the form
*
*     H(i) = I - taub * v * v'
*
*  where taub is a complex scalar, and v is a complex vector with
*  v(p-k+i+1:p) = 0 and v(p-k+i) = 1; v(1:p-k+i-1) is stored on exit in
*  B(n-k+i,1:p-k+i-1), and taub in TAUB(i).
*  To form Z explicitly, use LAPACK subroutine CUNGRQ.
*  To use Z to update another matrix, use LAPACK subroutine CUNMRQ.
*
*  =====================================================================
*
*     .. Local Scalars ..
      LOGICAL            LQUERY
      INTEGER            LOPT, LWKOPT, NB, NB1, NB2, NB3
*     ..
*     .. External Subroutines ..
      EXTERNAL           CGEQRF, CGERQF, CUNMQR, XERBLA
*     ..
*     .. External Functions ..
      INTEGER            ILAENV 
      EXTERNAL           ILAENV
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          INT, MAX, MIN
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters
*
      INFO = 0
      NB1 = ILAENV( 1, 'CGEQRF', ' ', N, M, -1, -1 )
      NB2 = ILAENV( 1, 'CGERQF', ' ', N, P, -1, -1 )
      NB3 = ILAENV( 1, 'CUNMQR', ' ', N, M, P, -1 )
      NB = MAX( NB1, NB2, NB3 )
      LWKOPT = MAX( N, M, P)*NB
      WORK( 1 ) = LWKOPT
      LQUERY = ( LWORK.EQ.-1 )
      IF( N.LT.0 ) THEN
         INFO = -1
      ELSE IF( M.LT.0 ) THEN
         INFO = -2
      ELSE IF( P.LT.0 ) THEN
         INFO = -3
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -5
      ELSE IF( LDB.LT.MAX( 1, N ) ) THEN
         INFO = -8
      ELSE IF( LWORK.LT.MAX( 1, N, M, P ) .AND. .NOT.LQUERY ) THEN
         INFO = -11
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'CGGQRF', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         RETURN
      END IF
*
*     QR factorization of N-by-M matrix A: A = Q*R
*
      CALL CGEQRF( N, M, A, LDA, TAUA, WORK, LWORK, INFO )
      LOPT = WORK( 1 )
*
*     Update B := Q'*B.
*
      CALL CUNMQR( 'Left', 'Conjugate Transpose', N, P, MIN( N, M ), A,
     $             LDA, TAUA, B, LDB, WORK, LWORK, INFO )
      LOPT = MAX( LOPT, INT( WORK( 1 ) ) )
*
*     RQ factorization of N-by-P matrix B: B = T*Z.
*
      CALL CGERQF( N, P, B, LDB, TAUB, WORK, LWORK, INFO )
      WORK( 1 ) = MAX( LOPT, INT( WORK( 1 ) ) )
*
      RETURN
*
*     End of CGGQRF
*
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C   FFTPACK 5.0
C   Copyright (C) 1995-2004, Scientific Computing Division,
C   University Corporation for Atmospheric Research
C   Licensed under the GNU General Public License (GPL)
C
C   Authors:  Paul N. Swarztrauber and Richard A. Valent
C
C   $Id: c1f4kf.f,v 1.2 2006-11-21 01:10:15 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      SUBROUTINE DC1F4KF(IDO,L1,NA,CC,IN1,CH,IN2,WA)
      DOUBLE PRECISION SN
      DOUBLE PRECISION TI1
      DOUBLE PRECISION TI2
      DOUBLE PRECISION TR4
      DOUBLE PRECISION TI3
      DOUBLE PRECISION TR1
      DOUBLE PRECISION TR2
      DOUBLE PRECISION TI4
      DOUBLE PRECISION TR3
      DOUBLE PRECISION CR3
      DOUBLE PRECISION CI3
      DOUBLE PRECISION CR2
      DOUBLE PRECISION CR4
      DOUBLE PRECISION CI2
      DOUBLE PRECISION CI4
      DOUBLE PRECISION CC(IN1,L1,IDO,4),CH(IN2,L1,4,IDO),WA(IDO,3,2)
C
C FFTPACK 5.0 auxiliary routine
C
      IF (IDO.GT.1) GO TO 102
      SN = 1.D0/DBLE(4*L1)
      IF (NA.EQ.1) GO TO 106
      DO 101 K = 1,L1
          TI1 = CC(2,K,1,1) - CC(2,K,1,3)
          TI2 = CC(2,K,1,1) + CC(2,K,1,3)
          TR4 = CC(2,K,1,2) - CC(2,K,1,4)
          TI3 = CC(2,K,1,2) + CC(2,K,1,4)
          TR1 = CC(1,K,1,1) - CC(1,K,1,3)
          TR2 = CC(1,K,1,1) + CC(1,K,1,3)
          TI4 = CC(1,K,1,4) - CC(1,K,1,2)
          TR3 = CC(1,K,1,2) + CC(1,K,1,4)
          CC(1,K,1,1) = SN* (TR2+TR3)
          CC(1,K,1,3) = SN* (TR2-TR3)
          CC(2,K,1,1) = SN* (TI2+TI3)
          CC(2,K,1,3) = SN* (TI2-TI3)
          CC(1,K,1,2) = SN* (TR1+TR4)
          CC(1,K,1,4) = SN* (TR1-TR4)
          CC(2,K,1,2) = SN* (TI1+TI4)
          CC(2,K,1,4) = SN* (TI1-TI4)
  101 CONTINUE
      RETURN
  106 DO 107 K = 1,L1
          TI1 = CC(2,K,1,1) - CC(2,K,1,3)
          TI2 = CC(2,K,1,1) + CC(2,K,1,3)
          TR4 = CC(2,K,1,2) - CC(2,K,1,4)
          TI3 = CC(2,K,1,2) + CC(2,K,1,4)
          TR1 = CC(1,K,1,1) - CC(1,K,1,3)
          TR2 = CC(1,K,1,1) + CC(1,K,1,3)
          TI4 = CC(1,K,1,4) - CC(1,K,1,2)
          TR3 = CC(1,K,1,2) + CC(1,K,1,4)
          CH(1,K,1,1) = SN* (TR2+TR3)
          CH(1,K,3,1) = SN* (TR2-TR3)
          CH(2,K,1,1) = SN* (TI2+TI3)
          CH(2,K,3,1) = SN* (TI2-TI3)
          CH(1,K,2,1) = SN* (TR1+TR4)
          CH(1,K,4,1) = SN* (TR1-TR4)
          CH(2,K,2,1) = SN* (TI1+TI4)
          CH(2,K,4,1) = SN* (TI1-TI4)
  107 CONTINUE
      RETURN
  102 DO 103 K = 1,L1
          TI1 = CC(2,K,1,1) - CC(2,K,1,3)
          TI2 = CC(2,K,1,1) + CC(2,K,1,3)
          TR4 = CC(2,K,1,2) - CC(2,K,1,4)
          TI3 = CC(2,K,1,2) + CC(2,K,1,4)
          TR1 = CC(1,K,1,1) - CC(1,K,1,3)
          TR2 = CC(1,K,1,1) + CC(1,K,1,3)
          TI4 = CC(1,K,1,4) - CC(1,K,1,2)
          TR3 = CC(1,K,1,2) + CC(1,K,1,4)
          CH(1,K,1,1) = TR2 + TR3
          CH(1,K,3,1) = TR2 - TR3
          CH(2,K,1,1) = TI2 + TI3
          CH(2,K,3,1) = TI2 - TI3
          CH(1,K,2,1) = TR1 + TR4
          CH(1,K,4,1) = TR1 - TR4
          CH(2,K,2,1) = TI1 + TI4
          CH(2,K,4,1) = TI1 - TI4
  103 CONTINUE
      DO 105 I = 2,IDO
          DO 104 K = 1,L1
              TI1 = CC(2,K,I,1) - CC(2,K,I,3)
              TI2 = CC(2,K,I,1) + CC(2,K,I,3)
              TI3 = CC(2,K,I,2) + CC(2,K,I,4)
              TR4 = CC(2,K,I,2) - CC(2,K,I,4)
              TR1 = CC(1,K,I,1) - CC(1,K,I,3)
              TR2 = CC(1,K,I,1) + CC(1,K,I,3)
              TI4 = CC(1,K,I,4) - CC(1,K,I,2)
              TR3 = CC(1,K,I,2) + CC(1,K,I,4)
              CH(1,K,1,I) = TR2 + TR3
              CR3 = TR2 - TR3
              CH(2,K,1,I) = TI2 + TI3
              CI3 = TI2 - TI3
              CR2 = TR1 + TR4
              CR4 = TR1 - TR4
              CI2 = TI1 + TI4
              CI4 = TI1 - TI4
              CH(1,K,2,I) = WA(I,1,1)*CR2 + WA(I,1,2)*CI2
              CH(2,K,2,I) = WA(I,1,1)*CI2 - WA(I,1,2)*CR2
              CH(1,K,3,I) = WA(I,2,1)*CR3 + WA(I,2,2)*CI3
              CH(2,K,3,I) = WA(I,2,1)*CI3 - WA(I,2,2)*CR3
              CH(1,K,4,I) = WA(I,3,1)*CR4 + WA(I,3,2)*CI4
              CH(2,K,4,I) = WA(I,3,1)*CI4 - WA(I,3,2)*CR4
  104     CONTINUE
  105 CONTINUE
      RETURN
      END

C
C     $Id: 
C
C     interface to dashchar package. set the gap character to an
C     underscore.
      SUBROUTINE SETDASHCHAR()
C
      COMMON /BLGASO/ IBLK,IGAP,ISOL
      CHARACTER*1     IBLK,IGAP,ISOL
C
      IGAP = '_'
C
      RETURN
C
      END
C
      SUBROUTINE RESETDASHCHAR()
C
      COMMON /BLGASO/ IBLK,IGAP,ISOL
      CHARACTER*1     IBLK,IGAP,ISOL
C
      IGAP = ''''
C
      RETURN
      END

C
C $Id: perim3.f,v 1.7 2008-07-27 00:17:34 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE PERIM3 (MAGR1,MINI1,MAGR2,MINI2,IWHICH,VAR)
      SAVE
      COMMON /PWRZ1T/ UUMIN      ,UUMAX      ,VVMIN      ,VVMAX      ,
     1                WWMIN      ,WWMAX      ,DELCRT     ,EYEU       ,
     2                EYEV       ,EYEW
      COMMON /PRM31/  Q          ,L
      COMMON /TCK31/  TMAGU      ,TMINU      ,TMAGV      ,TMINV      ,
     1                TMAGW      ,TMINW
C
C THRINT COMMON BLOCK IS USED FOR SETTING COLOR INTENSITY
C
      COMMON /THRINT/ ITHRMJ     ,ITHRMN     ,ITHRTX
      DIMENSION       LASF(13)
C
      TICK(T) = MAX(UUMAX-UUMIN,VVMAX-VVMIN,WWMAX-WWMIN)*T/1024.
C
C INQUIRE LINE COLOR INDEX AND SET ASF TO INDIVIDUAL
C
      CALL GQPLCI (IERR, IPLCI)
      CALL GQASF (IERR, LASF)
      LSV3  = LASF(3)
      LASF(3) = 1
      CALL GSASF (LASF)
C
      MGR1 = MAGR1
      MN1 = MINI1-1
      MGR2 = MAGR2
      MN2 = MINI2-1
      MN1P1 = MAX(MN1+1,1)
      MN2P1 = MAX(MN2+1,1)
      L = MIN(3,MAX(1,IWHICH))
      Q = VAR
C
C PICK BOUNDS
C
      GO TO ( 10, 30, 40),L
   10 XMIN = VVMIN
      XMAX = VVMAX
      DELYL = TICK(TMAGV)
      DELYS = TICK(TMINV)
   20 YMIN = WWMIN
      YMAX = WWMAX
      DELXL = TICK(TMAGW)
      DELXS = TICK(TMINW)
      GO TO  50
   30 XMIN = UUMIN
      XMAX = UUMAX
      DELYL = TICK(TMAGU)
      DELYS = TICK(TMINU)
      GO TO  20
   40 XMIN = UUMIN
      XMAX = UUMAX
      DELYL = TICK(TMAGU)
      DELYS = TICK(TMINU)
      YMIN = VVMIN
      YMAX = VVMAX
      DELXL = TICK(TMAGV)
      DELXS = TICK(TMINV)
C
C PERIM
C
   50 CALL LINE3W (XMIN,YMIN,XMAX,YMIN)
      CALL LINE3W (XMAX,YMIN,XMAX,YMAX)
      CALL LINE3W (XMAX,YMAX,XMIN,YMAX)
      CALL LINE3W (XMIN,YMAX,XMIN,YMIN)
      IF (MGR1 .LT. 1) GO TO  90
      DX = (XMAX-XMIN)/REAL(MAX(MGR1*(MN1P1),1))
      DO  80 I=1,MGR1
C
C MINORS
C
         IF (MN1 .LE. 0) GO TO  70
C
         CALL GSPLCI (ITHRMN)
C
         DO  60 J=1,MN1
            X = XMIN+REAL(MN1P1*(I-1)+J)*DX
            CALL LINE3W (X,YMIN,X,YMIN+DELYS)
            CALL LINE3W (X,YMAX,X,YMAX-DELYS)
   60    CONTINUE
   70    IF (I .GE. MGR1) GO TO  90
C
         CALL GSPLCI (ITHRMJ)
C
         X = XMIN+REAL(MN1P1*I)*DX
C
C MAJORS
C
         CALL LINE3W (X,YMIN,X,YMIN+DELYL)
         CALL LINE3W (X,YMAX,X,YMAX-DELYL)
   80 CONTINUE
   90 IF (MGR2 .LT. 1) GO TO 130
      DY = (YMAX-YMIN)/REAL(MAX(MGR2*(MN2P1),1))
      DO 120 J=1,MGR2
         IF (MN2 .LE. 0) GO TO 110
C
         CALL GSPLCI (ITHRMN)
C
         DO 100 I=1,MN2
            Y = YMIN+REAL(MN2P1*(J-1)+I)*DY
            CALL LINE3W (XMIN,Y,XMIN+DELXS,Y)
            CALL LINE3W (XMAX,Y,XMAX-DELXS,Y)
  100    CONTINUE
  110    IF (J .GE. MGR2) GO TO 130
C
         CALL GSPLCI (ITHRMJ)
C
         Y = YMIN+REAL(MN2P1*J)*DY
         CALL LINE3W (XMIN,Y,XMIN+DELXL,Y)
         CALL LINE3W (XMAX,Y,XMAX-DELXL,Y)
  120 CONTINUE
C
C RESTORE ASF AND COLOR INDEX TO ORIGINAL
C
  130 LASF(3) = LSV3
      CALL GSASF (LASF)
      CALL GSPLCI (IPLCI)
      RETURN
      END

C
C $Id: adjldp.f,v 1.5 2008-07-27 00:17:08 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      DOUBLE PRECISION FUNCTION ADJLDP (LON)
C
C This function adjusts a longitude angle modulo 180 degrees.
C
      IMPLICIT DOUBLE PRECISION (A-Z)
      DATA TWO,PI /2.0D0,3.14159265358979323846D0/
C
   20 ADJLDP = LON
      IF (ABS(LON) .LE. PI) RETURN
      TWOPI = TWO * PI
      LON = LON - SIGN (TWOPI,LON)
      GO TO 20
C
      END

C
C $Id: idpdrv.f,v 1.5 2008-07-27 00:17:30 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE IDPDRV (NDP,XD,YD,ZD,NT,IPT,PD,WK)
C
C This subroutine estimates partial derivatives of the first and
C second order at the data points.
C
C The input arguments are as follows:
C
C   NDP       number of data points.
C
C   XD,YD,ZD  arrays of dimension NDP containing the X,
C             Y, and Z coordinates of the data points.
C
C   NT        number of triangles.
C
C   IPT       integer array of dimension 3*NT containing the
C             point numbers of the vertices of the triangles.
C
C The output argument is as follows:
C
C   PD        array of dimension 5*NDP, where the estimated
C             ZX, ZY, ZXX, ZXY, and ZYY values at the Ith
C             data point are to be stored as the (5*I-4)th,
C             (5*I-3)rd, (5*I-2)nd, (5*I-1)st, and (5*I)th
C             elements, respectively, where I = 1, 2, ...,
C             NDP.
C
C The other argument is as follows:
C
C   WK        array of dimension NDP used internally as a
C             work area.
C
C Declaration statements.
C
      DIMENSION XD(NDP),YD(NDP),ZD(NDP),IPT(3*NT),PD(5*NDP),WK(NDP)
      DIMENSION IPTI(3),XV(3),YV(3),ZV(3),ZXV(3),ZYV(3),W1(3),W2(3)
C
      DATA EPSLN / 1.E-6 /
C
C Clear the PD array.
C
      JPDMX=5*NDP
C
      DO 101 JPD=1,JPDMX
        PD(JPD)=0.0
  101 CONTINUE
C
      DO 102 IDP=1,NDP
        WK(IDP)=0.0
  102 CONTINUE
C
C Estimate ZX and ZY.
C
      DO 105 IT=1,NT
        JPT0=3*(IT-1)
        DO 103 IV=1,3
          JPT=JPT0+IV
          IDP=IPT(JPT)
          IPTI(IV)=IDP
          XV(IV)=XD(IDP)
          YV(IV)=YD(IDP)
          ZV(IV)=ZD(IDP)
  103   CONTINUE
        DX1=XV(2)-XV(1)
        DY1=YV(2)-YV(1)
        DZ1=ZV(2)-ZV(1)
        DX2=XV(3)-XV(1)
        DY2=YV(3)-YV(1)
        DZ2=ZV(3)-ZV(1)
        VPX=DY1*DZ2-DZ1*DY2
        VPY=DZ1*DX2-DX1*DZ2
        VPZ=DX1*DY2-DY1*DX2
        VPZMN=ABS(DX1*DX2+DY1*DY2)*EPSLN
        IF (ABS(VPZ).LE.VPZMN) GO TO 105
        D12=SQRT((XV(2)-XV(1))**2+(YV(2)-YV(1))**2)
        D23=SQRT((XV(3)-XV(2))**2+(YV(3)-YV(2))**2)
        D31=SQRT((XV(1)-XV(3))**2+(YV(1)-YV(3))**2)
        W1(1)=1.0/(D31*D12)
        W1(2)=1.0/(D12*D23)
        W1(3)=1.0/(D23*D31)
        W2(1)=VPZ*W1(1)
        W2(2)=VPZ*W1(2)
        W2(3)=VPZ*W1(3)
        DO 104 IV=1,3
          IDP=IPTI(IV)
          JPD0=5*(IDP-1)
          WI=(W1(IV)**2)*W2(IV)
          PD(JPD0+1)=PD(JPD0+1)+VPX*WI
          PD(JPD0+2)=PD(JPD0+2)+VPY*WI
          WK(IDP)=WK(IDP)+VPZ*WI
  104   CONTINUE
  105 CONTINUE
      DO 106 IDP=1,NDP
        IF (WK(IDP).NE.0.) THEN
          JPD0=5*(IDP-1)
          PD(JPD0+1)=-PD(JPD0+1)/WK(IDP)
          PD(JPD0+2)=-PD(JPD0+2)/WK(IDP)
        END IF
  106 CONTINUE
C
C Estimate ZXX, ZXY, and ZYY.
C
      DO 109 IT=1,NT
        JPT0=3*(IT-1)
        DO 107 IV=1,3
          JPT=JPT0+IV
          IDP=IPT(JPT)
          IPTI(IV)=IDP
          XV(IV)=XD(IDP)
          YV(IV)=YD(IDP)
          JPD0=5*(IDP-1)
          ZXV(IV)=PD(JPD0+1)
          ZYV(IV)=PD(JPD0+2)
  107   CONTINUE
        DX1=XV(2)-XV(1)
        DY1=YV(2)-YV(1)
        DZX1=ZXV(2)-ZXV(1)
        DZY1=ZYV(2)-ZYV(1)
        DX2=XV(3)-XV(1)
        DY2=YV(3)-YV(1)
        DZX2=ZXV(3)-ZXV(1)
        DZY2=ZYV(3)-ZYV(1)
        VPXX=DY1*DZX2-DZX1*DY2
        VPXY=DZX1*DX2-DX1*DZX2
        VPYX=DY1*DZY2-DZY1*DY2
        VPYY=DZY1*DX2-DX1*DZY2
        VPZ=DX1*DY2-DY1*DX2
        VPZMN=ABS(DX1*DX2+DY1*DY2)*EPSLN
        IF (ABS(VPZ).LE.VPZMN) GO TO 109
        D12=SQRT((XV(2)-XV(1))**2+(YV(2)-YV(1))**2)
        D23=SQRT((XV(3)-XV(2))**2+(YV(3)-YV(2))**2)
        D31=SQRT((XV(1)-XV(3))**2+(YV(1)-YV(3))**2)
        W1(1)=1.0/(D31*D12)
        W1(2)=1.0/(D12*D23)
        W1(3)=1.0/(D23*D31)
        W2(1)=VPZ*W1(1)
        W2(2)=VPZ*W1(2)
        W2(3)=VPZ*W1(3)
        DO 108 IV=1,3
          IDP=IPTI(IV)
          JPD0=5*(IDP-1)
          WI=(W1(IV)**2)*W2(IV)
          PD(JPD0+3)=PD(JPD0+3)+VPXX*WI
          PD(JPD0+4)=PD(JPD0+4)+(VPXY+VPYX)*WI
          PD(JPD0+5)=PD(JPD0+5)+VPYY*WI
  108   CONTINUE
  109 CONTINUE
      DO 110 IDP=1,NDP
        JPD0=5*(IDP-1)
        IF (WK(IDP).NE.0.) THEN
          PD(JPD0+3)=-PD(JPD0+3)/WK(IDP)
          PD(JPD0+4)=-PD(JPD0+4)/(2.0*WK(IDP))
          PD(JPD0+5)=-PD(JPD0+5)/WK(IDP)
        END IF
  110 CONTINUE
C
      RETURN
C
      END

C NCLFORTSTART
      SUBROUTINE BINDATASUM3(MLON,NLAT,GBIN,GKNT,GLON,GLAT,NZ,ZLON,ZLAT,
     +                       Z,ZMSG)
      IMPLICIT NONE
      INTEGER NLAT,MLON,NZ
      DOUBLE PRECISION GLON(MLON),GLAT(NLAT)
      DOUBLE PRECISION ZLON(NZ),ZLAT(NZ),Z(NZ),ZMSG

      DOUBLE PRECISION GBIN(MLON,NLAT)
      INTEGER GKNT(MLON,NLAT)
C NCLEND

C
C NCL: bin_sum_util(gbin[*][*]:numeric,gknt[*][*]:integer,glat[*]:numeric
C                  ,glon[*]:numeric,zlon[*]:numeric,zlat[*]:numeric
C                  ,z[*]:numeric)

      INTEGER K,NL,ML,IFLAG
      DOUBLE PRECISION DLAT,DLON
      DOUBLE PRECISION GLATBND1,GLATBND2
      DOUBLE PRECISION GLONBND1,GLONBND2

      DLON = GLON(2)-GLON(1)
      IF (DLON.LE.0.0D0) THEN
          PRINT *, "BINDATASUM3: longitudes must be monotonically"
          PRINT *, " increasing: FATAL ERROR"
          STOP
      END IF

      DLAT = GLAT(2)-GLAT(1)
      IF (DLAT.GT.0.0D0) THEN
          IFLAG = 1
      ELSEIF (DLAT.LT.0.0D0) THEN
          IFLAG = -1
      END IF
      DLAT = ABS(DLAT)

      GLATBND1 = MIN(GLAT(1),GLAT(NLAT)) - DLAT/2
      GLATBND2 = MAX(GLAT(1),GLAT(NLAT)) + DLAT/2
      GLONBND1 = GLON(1)    - DLON/2
      GLONBND2 = GLON(MLON) + DLON/2

      DO K = 1,NZ
          IF (Z(K).NE.ZMSG .AND.
     +       (ZLAT(K).GE.GLATBND1 .AND. ZLAT(K).LE.GLATBND2)  .AND.
     +       (ZLON(K).GE.GLONBND1 .AND. ZLON(K).LE.GLONBND2)) THEN
              ML = ABS((ZLON(K)-GLONBND1)/DLON) + 1
              NL = ABS((ZLAT(K)-GLATBND1)/DLAT) + 1
              IF (IFLAG.EQ.-1) NL = NLAT-NL+1

c c c         IF (ML.GE.1 .AND. ML.LE.MLON .AND. NL.GE.1 .AND.
c c c             NL.LE.NLAT) THEN
                  GBIN(ML,NL) = GBIN(ML,NL) + Z(K)
                  GKNT(ML,NL) = GKNT(ML,NL) + 1
c c c         END IF

          END IF
      END DO

      RETURN
      END

C NCLFORTSTART
      subroutine mocloops(nyaux,mlon,nlat,kdep,nrx,tlat,lat_aux_grid
     +                   ,rmlak,work1,work2,work3,wmsg,tmp1,tmp2,tmp3)
      implicit none
      integer  nyaux,mlon,nlat,kdep,nrx

      double precision     work1(mlon,nlat,kdep), work2(mlon,nlat,kdep)
     +                    ,work3(mlon,nlat,kdep), wmsg
      double precision     tmp1(nyaux,kdep,2)   , tmp2(nyaux,kdep,2)
     +                    ,tmp3(nyaux,kdep,2)  
      double precision     lat_aux_grid(nyaux)  , tlat(mlon,nlat)
      
      integer  rmlak(mlon,nlat,2)
C NCLEND
      integer  ny, kd, nl, ml, nr 
c c c logical  section(mlon,nlat,kdep)

c initilize 
      do nr=1,nrx
        do kd=1,kdep
          do ny=1,nyaux
             tmp1(ny,kd,nr) = 0.0d0 
             tmp2(ny,kd,nr) = 0.0d0 
             tmp3(ny,kd,nr) = 0.0d0 
          end do
        end do
      end do

c globe [note: rmlak(:,:,1)]

      do ny=2,nyaux

        do nl=1,nlat
          do ml=1,mlon
             if (tlat(ml,nl).ge.lat_aux_grid(ny-1) .and.
     +           tlat(ml,nl).lt.lat_aux_grid(ny)   .and.
     +           rmlak(ml,nl,1).eq.1) then

                 do kd=1,kdep
                    if (work1(ml,nl,kd).ne.wmsg)  then          
                        tmp1(ny,kd,1) = tmp1(ny,kd,1) + work1(ml,nl,kd)
                        tmp2(ny,kd,1) = tmp2(ny,kd,1) + work2(ml,nl,kd)
                        tmp3(ny,kd,1) = tmp3(ny,kd,1) + work3(ml,nl,kd)
                    end if
                 end do

             end if
          end do
        end do

      end do

c atlantic [note: rmlak(:,:,2)]

      do ny=2,nyaux

        do nl=1,nlat
          do ml=1,mlon
             if (tlat(ml,nl).ge.lat_aux_grid(ny-1) .and.
     +           tlat(ml,nl).lt.lat_aux_grid(ny)   .and.
     +           rmlak(ml,nl,2).eq.1) then

                 do kd=1,kdep
                    if (work1(ml,nl,kd).ne.wmsg)  then          
                        tmp1(ny,kd,2) = tmp1(ny,kd,2) + work1(ml,nl,kd)
                        tmp2(ny,kd,2) = tmp2(ny,kd,2) + work2(ml,nl,kd)
                        tmp3(ny,kd,2) = tmp3(ny,kd,2) + work3(ml,nl,kd)
                    end if
                 end do

             end if
          end do
        end do

      end do

      return
      end

c subroutine lfp (init,n,m,l,cp,pb,w)
c
c dimension of           cp((n/2)+1), pb(l), w(5*l+41)
c arguments
c
c purpose                routine lfp uses coefficients computed by
c                        routine alfk to calculate the single precision
c                        normalized associated legendre function pbar(n,
c                        m,theta) at colatitudes theta=(i-1)*pi/(l-1),
c                        i=1,...,l. subroutine lfp evaluates pbar
c                        using one of the following trigonometric
c                        expansions
c
c                        1) for n even and m even, pbar(m,n,theta) =
c                           .5*cp(1) plus the sum from k=1 to k=n/2
c                           of cp(k)*cos(2*k*th)
c
c                        2) for n even and m odd, pbar(m,n,theta) =
c                           the sum from k=1 to k=n/2 of
c                           cp(k)*sin(2*k*th)
c
c                        3) for n odd and m even, pbar(m,n,theta) =
c                           the sum from k=1 to k=(n+1)/2 of
c                           cp(k)*cos((2*k-1)*th)
c
c                        4) for n odd and m odd,  pbar(m,n,theta) =
c                           the sum from k=1 to k=(n+1)/2 of
c                           cp(k)*sin((2*k-1)*th)
c
c
c usage                  call lfp(init,n,m,l,cp,pb,w)
c
c arguments
c
c on input               init
c                          = 0 initialization only
c                          = 1 compute pbar(n,m,theta)
c
c                          lfp call with init = 0 initializes array w;
c                          no values of pbar(n,m,theta) are computed.
c                          init=0 should be used on the first call, or
c                          if l or w values differ from those in the
c                          previous call.
c
c                        n
c                          nonnegative integer, less than l, specifying
c                          the degree of pbar(n,m,theta)
c
c                        m
c                          is the order of pbar(n,m,theta). m can be
c                          any integer however pbar(n,m,theta) = 0
c                          if abs(m) is greater than n and
c                          pbar(n,m,theta) = (-1)**m*pbar(n,-m,theta)
c                          for negative m.
c
c                        l
c                          number of colatitudes theta=(i-1)*pi/(l-1)
c                          for i=1,...,l where l is greater than 1.
c                          l must be an odd integer.
c
c                        cp
c                          single precision array of length (n/2)+1
c                          containing coefficients computed by routine
c                          alfk
c
c                        w
c                          a single precision work array with at
c                          least 5*l+41 locations
c
c on output              pb
c                          single precision array of length l containing
c                          pbar(n,m,theta), theta=(i-1)*pi/(l-1) for i=1
c                          ,...,l.
c
c                        w
c                          a single precision array containing values
c                          which must not be destroyed if the next call
c                          will have the same value of input parameter n
c
c special conditions     calls to routine lfp must be preceded by an
c                        appropriate call to routine alfk.
c
c precision              single
c
c algorithm              the trigonometric series formula used by
c                        routine lfp to calculate pbar(n,m,theta) for
c                        theta=(i-1)*pi/(l-1), i=1,...,n, depends on
c                        m and n as follows:
c
c                           1) for n even and m even, the formula is
c                              .5*cp(1) plus the sum from k=1 to k=n/2
c                              of cp(k)*cos(2*k*theta)
c                           2) for n even and m odd. the formula is
c                              the sum from k=1 to k=n/2 of
c                              cp(k)*sin(2*k*theta)
c                           3) for n odd and m even, the formula is
c                              the sum from k=1 to k=(n+1)/2 of
c                              cp(k)*cos((2*k-1)*theta)
c                           4) for n odd and m odd, the formula is
c                              the sum from k=1 to k=(n+1)/2 of
c                              cp(k)*sin((2*k-1)*theta)
c
c accuracy               comparison between routines lfp and double
c                        precision dlfp on the cray1 indicates greater
c                        accuracy for smaller values of input parameter
c                        n.  agreement to 12 places was obtained for
c                        n=10 and to 11 places for n=100.
c
c timing                 time per call to routine lfp is dependent on
c                        the input parameters l and n.
c
      SUBROUTINE DLFP(INIT,N,M,L,CP,PB,W)
      DOUBLE PRECISION CP
      DOUBLE PRECISION PB
      DOUBLE PRECISION W
      DIMENSION CP(1),PB(1),W(1)
c
      DO 10 I = 1,L
          PB(I) = 0.D0
   10 CONTINUE
      MA = IABS(M)
      IF (MA.GT.N) RETURN
      IW1 = L + L + 12
      IW2 = IW1 + 3* (L+1)/2 + 15
      CALL DLFP1(INIT,N,MA,L,CP,PB,W,W(IW1),W(IW2))
      RETURN
      END
      SUBROUTINE DLFP1(INIT,N,M,L,CP,P,WSAVE1,WSAVE2,WSAVE3)
      DOUBLE PRECISION CP
      DOUBLE PRECISION P
      DOUBLE PRECISION WSAVE1
      DOUBLE PRECISION WSAVE2
      DOUBLE PRECISION WSAVE3
      DOUBLE PRECISION SSQRT2
      DOUBLE PRECISION PI
      DOUBLE PRECISION DT
      DIMENSION CP(1),P(1),WSAVE1(1),WSAVE2(1),WSAVE3(1)
      SAVE LC,LQ,LS

      IF (INIT.NE.0) GO TO 41
      LC = (L+1)/2
      LS = LC - 2
      LQ = LC - 1
      CALL SINTI(LS,WSAVE1)
      CALL COSTI(LC,WSAVE2)
      CALL COSQI(LQ,WSAVE3)
      RETURN
   41 IF (N) 10,10,40
   10 IF (M) 20,20,40
   20 SSQRT2 = 1.D0/SQRT(2.D0)
      DO 30 I = 1,L
          P(I) = SSQRT2
   30 CONTINUE
      RETURN
   40 LS2 = (L+1)/2
      LM1 = L - 1
      NP1 = N + 1
      PI = 4.D0*ATAN(1.D0)
      DT = PI/LM1
      NMOD = MOD(N,2)
      MMOD = MOD(M,2)
      IF (NMOD) 50,50,120
   50 IF (MMOD) 60,60,90
   60 KDP = N/2 + 1
      DO 70 I = 1,KDP
          P(I) = .5D0*CP(I)
   70 CONTINUE
      P(LC) = P(LC) + P(LC)
      CALL COST(LC,P,WSAVE2)
      DO 80 I = 1,LC
          LMI = L - I
          P(LMI+1) = P(I)
   80 CONTINUE
      GO TO 190
   90 KDP = N/2
      DO 100 I = 1,KDP
          P(I+1) = .5D0*CP(I)
  100 CONTINUE
      P(LS+2) = 0.D0
      CALL SINT(LS,P(2),WSAVE1)
      DO 110 I = 1,LS
          LMI = L - I
          P(LMI) = -P(I+1)
  110 CONTINUE
      P(L) = 0.D0
      GO TO 190
  120 KDP = (N+1)/2
      IF (MMOD) 140,140,160
  140 DO 130 I = 1,KDP
          P(I) = .25D0*CP(I)
  130 CONTINUE
      CALL COSQB(LQ,P,WSAVE3)
      DO 150 I = 1,LQ
          LMI = L - I
          P(LMI+1) = -P(I)
  150 CONTINUE
      GO TO 190
  160 DO 180 I = 1,KDP
          P(I+1) = .25D0*CP(I)
  180 CONTINUE
      CALL SINQB(LQ,P(2),WSAVE3)
      DO 170 I = 1,LQ
          LMI = L - I
          P(LMI) = P(I+1)
  170 CONTINUE
      P(L) = 0.D0
  190 RETURN
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C   FFTPACK 5.0
C   Copyright (C) 1995-2004, Scientific Computing Division,
C   University Corporation for Atmospheric Research
C   Licensed under the GNU General Public License (GPL)
C
C   Authors:  Paul N. Swarztrauber and Richard A. Valent
C
C   $Id: costf1.f,v 1.2 2006-11-21 01:10:17 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      SUBROUTINE DCOSTF1(N,INC,X,WSAVE,WORK,IER)
      DOUBLE PRECISION WORK
      DOUBLE PRECISION X1H
      DOUBLE PRECISION X1P3
      DOUBLE PRECISION TX2
      DOUBLE PRECISION T1
      DOUBLE PRECISION T2
      DOUBLE PRECISION SNM1
      DOUBLE PRECISION XI
      DOUBLE PRECISION X(INC,*),WSAVE(*)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION DSUM

      IER = 0
      NM1 = N - 1
      NP1 = N + 1
      NS2 = N/2
      IF (N-2) 200,101,102
  101 X1H = X(1,1) + X(1,2)
      X(1,2) = .5D0* (X(1,1)-X(1,2))
      X(1,1) = .5D0*X1H
      GO TO 200
  102 IF (N.GT.3) GO TO 103
      X1P3 = X(1,1) + X(1,3)
      TX2 = X(1,2) + X(1,2)
      X(1,2) = .5D0* (X(1,1)-X(1,3))
      X(1,1) = .25D0* (X1P3+TX2)
      X(1,3) = .25D0* (X1P3-TX2)
      GO TO 200
  103 DSUM = X(1,1) - X(1,N)
      X(1,1) = X(1,1) + X(1,N)
      DO 104 K = 2,NS2
          KC = NP1 - K
          T1 = X(1,K) + X(1,KC)
          T2 = X(1,K) - X(1,KC)
          DSUM = DSUM + WSAVE(KC)*T2
          T2 = WSAVE(K)*T2
          X(1,K) = T1 - T2
          X(1,KC) = T1 + T2
  104 CONTINUE
      MODN = MOD(N,2)
      IF (MODN.EQ.0) GO TO 124
      X(1,NS2+1) = X(1,NS2+1) + X(1,NS2+1)
  124 LENX = INC* (NM1-1) + 1
      LNSV = NM1 + INT(LOG(DBLE(NM1))) + 4
      LNWK = NM1
C
      CALL DRFFT1F(NM1,INC,X,LENX,WSAVE(N+1),LNSV,WORK,LNWK,IER1)
      IF (IER1.NE.0) THEN
          IER = 20
          CALL DXERFFT('COSTF1',-5)
          GO TO 200
      END IF
C
      SNM1 = 1.D0/DBLE(NM1)
      DSUM = SNM1*DSUM
      IF (MOD(NM1,2).NE.0) GO TO 30
      X(1,NM1) = X(1,NM1) + X(1,NM1)
   30 DO 105 I = 3,N,2
          XI = .5D0*X(1,I)
          X(1,I) = .5D0*X(1,I-1)
          X(1,I-1) = DSUM
          DSUM = DSUM + XI
  105 CONTINUE
      IF (MODN.NE.0) GO TO 117
      X(1,N) = DSUM
  117 X(1,1) = .5D0*X(1,1)
      X(1,N) = .5D0*X(1,N)
  200 RETURN
      END

C
C $Id: dpblda.f,v 1.8 2008-07-27 00:16:58 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE DPBLDA
C
C Calling this do-nothing subroutine forces "ld" to load the following
C block data routine (but only if they are in the same ".f" file).
C
        RETURN
C
      END
CNOSPLIT
      BLOCKDATA DPBLDAX
C
C This is the BLOCK DATA routine for DASHPACK; it provides initial
C values for all the common variables that control the behavior of
C the package.
C
C Declare the character common block.
C
        COMMON /DPCMCH/ CHDP,CHRB,CHRG,CHRS
          CHARACTER*256 CHDP
          CHARACTER*1 CHRB,CHRG,CHRS
        SAVE   /DPCMCH/
C
C Declare the real/integer common block.
C
        COMMON /DPCMRI/ ANGF,DBPI,EPSI,IDPI,IDPS,ILTL,INDP,IPCF,ISBF,
     +                  ISCF,LCDP,RLS1,RLS2,RMFS,TENS,WCHR,WGAP,WSLD
        SAVE   /DPCMRI/
C
C ANGF is the internal parameter 'SAF' (for "String Angle Flag").  When
C 'SAF' has the value zero, strings are written along a curve in the
C direction in which the curve is being drawn.  If 'SAF' is negative,
C all angles are written in the direction ABS('SAF') degrees, but this
C is done only if 'LTL' is non-zero; otherwise, the code behaves as if
C 'SAF' were zero.  When 'SAF' is greater than zero, strings are written
C along the curve, but the angle is adjusted by adding multiples of 180
C degrees so that the resulting angle lies in the range from ANGF-90 to
C ANGF+90 degrees.  (Generally, when ANGF is different from zero, it is
C either -360 or +360, which ensures that labels are as nearly upright
C as possible on the frame).  Note that, if embedded character strings
C in the dash pattern are broken (either because there are "breakpoint"
C characters in the strings or because 'SCF' is non-zero), using 'SAF'
C non-zero could give undesirable results: some characters in such a
C string might be rotated and others might not be.  Therefore, in such
C cases, a non-zero value of 'SAF' is treated as zero.
C
        DATA ANGF / 360. /
C
C CHDP is the internal parameter 'DPT' (for "Dash PaTtern"), defining
C the character dash pattern.  It is accessed by DPGETC/DPSETC.  (When
C 'DPT' is accessed by DPGETI/DPSETI, the internal variable INDP is
C meant.)  When 'DPS' is greater than or equal to zero, it says that
C CHDP specifies the dash pattern.  CHDP may contain occurrences of the
C character 'CRS' to specify a solid part of the line and the character
C 'CRG' to specify a gap.  Other characters form strings that are to be
C written along the line; within such strings, the character 'CRB' may
C be used to specify places where the string may be broken (which has
C the effect of making the characters follow the curve instead of being
C written in a straight line).
C
        DATA CHDP / '$$$$$$$$$$$$$$$$' /
C
C CHRB is the internal parameter 'CRB' (for "Character Representing
C Break") - the character that, when used in a character dash pattern,
C represents a "breakpoint" - a position at which an embedded string
C of characters may be broken.  Example: if 'DPT' has the value
C
C   '$_$_$_1|3|.|6|2|:L1:4|1|0:S:14:N:_',
C
C and other internal parameters have their default values, the dollar
C signs represent solid parts of the line and the underscores represent
C gaps; the rest of the characters form a string to be written along
C the line.  Each of the substrings '1', '3', '.', '6', '2', ':L1:4'
C (which represents the "times" sign), '1', and '0:S:14:N:' (which
C represents "zero to the power 14") will be written using a separate
C call to PLCHHQ.  The effect of this will be to make the whole label
C follow the bends of the curve, while ensuring that each call to
C PLCHHQ contains the appropriate "function codes" to make the call
C write the desired characters.
C
        DATA CHRB / '|' /
C
C CHRG is the internal parameter 'CRG' (for "Character Representing
C Gap") - the character that, when used in a character dash pattern,
C represents a gap in the line.
C
        DATA CHRG / '_' /
C
C CHRS is the internal parameter 'CRS' (for "Character Representing
C Solid")  - the character that, when used in a character dash pattern,
C represents a solid part of the line.
C
        DATA CHRS / '$' /
C
C DBPI is the internal parameter 'SSL' (for "Smoothed Segment Length"),
C which defines the distance between points interpolated along smooth
C curves.  It is given as a fraction of the distance across the plotter
C frame.
C
        DATA DBPI / .01 /
C
C EPSI is the internal parameter 'EPS' (for "EPSilon"), which specifies
C how far apart two points have to be to be considered distinct.  It is
C given as a fraction of the distance across the plotter frame.
C
        DATA EPSI / .000001 /
C
C IDPI is a flag that says whether or not quantities derived from the
C dash pattern have been computed or not.  It is initially zero and is
C set back to zero whenever anything that would affect the dash pattern
C changes.
C
        DATA IDPI / 0 /
C
C IDPS is the internal parameter 'DPS' (for "Dash Pattern Selector") -
C a dash pattern selector switch.  When IDPS is negative and equal to
C "-n", it says to use the "n" low-order bits of the current integer
C dash pattern.  When IDPS is zero, it says to use all the characters
C of the current character dash pattern.  When IDPS is positive and
C equal to "+n", it says to use the first "n" characters of the current
C character dash pattern.
C
        DATA IDPS / 0 /
C
C ILTL is the internal parameter 'LTL' (for "Lines Through Labels"),
C which may be set non-zero to cause curve lines to be drawn through
C the strings that serve as line labels.  By default, 'LTL' is zero,
C in which case each such string is written within its own gap in
C the line.
C
        DATA ILTL / 0 /
C
C INDP is the internal parameter 'DPT' (for "Dash PaTtern"), defining
C the integer dash pattern.  It is accessed by DPGETI/DPSETI.  (When
C 'DPT' is accessed by DPGETC/DPSETC, the internal variable CHDP is
C meant.)  When 'DPS' is less than zero, it says how many low-order
C bits of INDP are to be used.  Each zero bit represents a gap and each
C one bit represents a solid part of the line.
C
        DATA INDP / 65535 /
C
C IPCF is the internal parameter 'PCF' (for "PlotChar Flag"), which
C says which PLOTCHAR routine is to be called to write out character
C strings.  The value 0 says to call PLCHHQ, the value 1 says to call
C PLCHMQ, and the value 2 says to call PLCHLQ.
C
        DATA IPCF / 0 /
C
C ISBF is the internal parameter 'SBF' (for "String Buffering Flag");
C when set non-zero, it turns on a buffering mechanism for character
C strings to be written as part of a dash pattern.  Turning buffering
C on ensures that, if the end of a curve occurs anywhere within a
C contiguous group of strings, none of those strings is written;
C instead, that part of the curve is drawn using only the gap and
C solid elements of the dash pattern.  If buffering is turned off,
C there may be gaps at the ends of curves; if, in addition, 'SCF'
C is non-zero or breakpoints are specified in the embedded character
C strings, the result may be to write only part of a character string
C at the end of a curve.
C
        DATA ISBF / 1 /
C
C ISCF is the internal parameter 'SCF' (for "Single-Character Flag");
C when set non-zero, it says that character strings embedded in dash
C patterns are to be broken into single characters, each of which is
C written separately.  This has the effect of making the characters
C appear to follow the curve being drawn.  (Note, however, that it is
C not appropriate for 'SCF' to be non-zero when PLCHHQ is being used
C and an embedded character string contains function codes that are
C meaningful to that routine; in that case, one should leave 'SCF' = 0
C and use the "break character" 'CRB' to tell DASHPACK where to break
C the string.)
C
        DATA ISCF / 0 /
C
C LCDP is the internal parameter 'DPL' (for "Dash Pattern Length").
C Its value is set whenever a call to DPSETC sets 'DPT' - to the length
C of the character string that the call sets 'DPT' to - but 'DPL' may
C also be set independently by a subsequent call to DPSETI, specifying
C the use of fewer characters of the string previously given.
C
        DATA LCDP / 16 /
C
C RLS1 and RLS2 are the internal parameters 'LS1' and 'LS2' (for "Label
C Spacing 1 and 2").  The first of these specifies the widths of extra
C gaps to be placed before and after a label.  The second specifies the
C amount of additional gap space that will be provided for each label
C substring written by a single call to PLCHHQ/MQ/LQ (in addition to
C the length of the string itself).  Both are stated as multipliers of
C the current character width.
C
        DATA RLS1,RLS2 / .5 , 0. /
C
C RMFS is the internal parameter 'MFS' (for "Multiplier for First
C Solid").  If the first element of a dash pattern specifies a solid
C chunk of line, its length is multiplied by the current value of RMFS.
C This can be used to help ensure that labels along adjacent, nearly
C identical, curves (as, for example, when drawing contour lines) do
C not overlap each other.  (This feature of the old dash package is
C duplicated here for what use it may have in the new one.)
C
        DATA RMFS / 1. /
C
C TENS is the internal parameter 'TCS' (for "Tension on Cubic Splines");
C if it is set non-negative, it turns on smoothing of the lines drawn;
C the value zero says to use cubic splines; values greater than zero
C say to use splines under tension and specify what tension to use.
C Values greater than about 15 should be avoided, as they can cause
C overflows in the smoothing routines.  Note that DPSMTH always smooths;
C it treats a negative value of TENS as zero and uses cubic splines.
C
        DATA TENS / -1. /
C
C WCHR is the internal parameter 'WOC' (for "Width Of Character"), which
C specifies the width of the characters to be used in writing character
C strings, given as a fraction of the width of the plotter frame.
C
        DATA WCHR / .01 /
C
C WGAP is the internal parameter 'WOG' (for "Width of Gap"), which
C specifies the width of a gap in a dashed line, given as a fraction
C of the width of the plotter frame.
C
        DATA WGAP / .005 /
C
C WSLD is the internal parameter 'WOS' (for "Width of Solid"), which
C specifies the width of a solid in a dashed line, given as a fraction
C of the width of the plotter frame.
C
        DATA WSLD / .005 /
C
      END

      SUBROUTINE ZLACGV( N, X, INCX )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     October 31, 1992
*
*     .. Scalar Arguments ..
      INTEGER            INCX, N
*     ..
*     .. Array Arguments ..
      COMPLEX*16         X( * )
*     ..
*
*  Purpose
*  =======
*
*  ZLACGV conjugates a complex vector of length N.
*
*  Arguments
*  =========
*
*  N       (input) INTEGER
*          The length of the vector X.  N >= 0.
*
*  X       (input/output) COMPLEX*16 array, dimension
*                         (1+(N-1)*abs(INCX))
*          On entry, the vector of length N to be conjugated.
*          On exit, X is overwritten with conjg(X).
*
*  INCX    (input) INTEGER
*          The spacing between successive elements of X.
*
* =====================================================================
*
*     .. Local Scalars ..
      INTEGER            I, IOFF
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          DCONJG
*     ..
*     .. Executable Statements ..
*
      IF( INCX.EQ.1 ) THEN
         DO 10 I = 1, N
            X( I ) = DCONJG( X( I ) )
   10    CONTINUE
      ELSE
         IOFF = 1
         IF( INCX.LT.0 )
     $      IOFF = 1 - ( N-1 )*INCX
         DO 20 I = 1, N
            X( IOFF ) = DCONJG( X( IOFF ) )
            IOFF = IOFF + INCX
   20    CONTINUE
      END IF
      RETURN
*
*     End of ZLACGV
*
      END

C
C $Id: frstpt.f,v 1.7 2008-07-27 00:17:24 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE FRSTPT (PX,PY)
C
C Given the user coordinates PX and PY of a point, FRSTPT generates a
C pen-up move to that point.
C
      IF (ICFELL('FRSTPT - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
      CALL PLOTIF (CUFX(PX),CUFY(PY),0)
      IF (ICFELL('FRSTPT',2).NE.0) RETURN
C
C Done.
C
      RETURN
C
      END

c orig code [ sp2_util.orig ]: John Adams
c .          check arguments to make sure calls are correct
c
      SUBROUTINE DGEOMATV(NLON,NLAT,U,V,WORK)
c
c pay special attention to subscript order
c .   nlon is first   [ u(nlon,nlat),v(nlon,nlat) ]
c
c     when invoked, this subroutine converts the nlon by nlat
c     geophysical vector field (u,v) to nlat by nlon mathematical
c     coordinates.  work is an UNSAVED work space of length at
c     least nlon*nlat
c
      IMPLICIT NONE
      INTEGER NLON,NLAT,I,J
      DOUBLE PRECISION U(NLON,NLAT),V(NLON,NLAT),WORK(*)
c
c     negate v
c
      DO J = 1,NLON
          DO I = 1,NLAT
              V(J,I) = -V(J,I)
          END DO
      END DO
c
c     traspose u,v
c
      CALL DTPLATX(NLON,NLAT,U,WORK)
      CALL DTPLATX(NLON,NLAT,V,WORK)
c
c     reverse (co)latitude subscript order
c
      CALL DCLATX(NLAT,NLON,U)
      CALL DCLATX(NLAT,NLON,V)

      RETURN
      END
c ---------------------------------------------------------
      SUBROUTINE DMATGEOV(NLAT,NLON,U,V,WORK)
c
c pay special attention to subscript order
c .   nlat is first dim  [ u(nlat,nlon), v(nlat,nlon) ]
c
c     when invoked, this subroutine converts the nlat by nlon
c     vector u & v, given in mathematical spherical coordinates, to
c     nlon by nlat vector field given in geophysical spherical
c     coordinates.  work is an UNSAVED work space of length at least
c     nlon*nlat
c
      IMPLICIT NONE
      INTEGER NLON,NLAT,I,J
      DOUBLE PRECISION U(NLAT,NLON),V(NLAT,NLON),WORK(*)
c
c     negate v
c
      DO J = 1,NLON
          DO I = 1,NLAT
              V(I,J) = -V(I,J)
          END DO
      END DO
c
c     reverse (co)latitude subscript order
c
      CALL DCLATX(NLAT,NLON,U)
      CALL DCLATX(NLAT,NLON,V)
c
c     transpose array
c
      CALL DTPLATX(NLAT,NLON,U,WORK)
      CALL DTPLATX(NLAT,NLON,V,WORK)

      RETURN
      END
c -------------------------------------------------------
      SUBROUTINE DGEOMAT(NLON,NLAT,S,WORK)
c
c pay special attention to subscript order
c .   nlon is first dim  [ s(nlon,nlat) ]
c
c     when invoked, this subroutine converts the nlon by nlat
c     scalar s, given in geophysical spherical coordinates, to
c     a nlat by nlon array given in mathematical spherical
c     coordinates.  work is an UNSAVED work space of length at
c     least nlon*nlat
c
      IMPLICIT NONE
      INTEGER NLON,NLAT
      DOUBLE PRECISION S(*),WORK(*)
c
c     traspose array
c
      CALL DTPLATX(NLON,NLAT,S,WORK)
c
c     reverse (co)latitude subscript order
c
      CALL DCLATX(NLAT,NLON,S)
      RETURN
      END
c -------------------------------------------------------------
      SUBROUTINE DMATGEO(NLAT,NLON,S,WORK)
c
c pay special attention to subscript order
c .   nlat is first dim  [ s(nlat,nlon) ]
c
c     when invoked, this subroutine converts the nlat by nlon
c     array s, given in mathematical spherical coordinates, to
c     a nlon by nlat array given in geophysical spherical
c     coordinates.  work is an UNSAVED work space of length at least
c     nlon*nlat
c
      IMPLICIT NONE
      INTEGER NLON,NLAT
      DOUBLE PRECISION S(*),WORK(*)
c
c     reverse (co)latitude subscript order
c
      CALL DCLATX(NLAT,NLON,S)
c
c     transpose array
c
      CALL DTPLATX(NLAT,NLON,S,WORK)
      RETURN
      END
c -------------------------------------------------------------
      SUBROUTINE DTPLATX(N,M,DATA,WORK)
c
c     transpose the n by m array data to a m by n array data
c     work must be at least n*m words long
c
      IMPLICIT NONE
      INTEGER N,M,I,J,IJ,JI
      DOUBLE PRECISION DATA(*),WORK(*)

      DO J = 1,M
          DO I = 1,N
              IJ = (J-1)*N + I
              WORK(IJ) = DATA(IJ)
          END DO
      END DO

      DO I = 1,N
          DO J = 1,M
              JI = (I-1)*M + J
              IJ = (J-1)*N + I
              DATA(JI) = WORK(IJ)
          END DO
      END DO

      RETURN
      END
c ----------------------------------------------------
      SUBROUTINE DCLATX(NLAT,NLON,DATA)
c
c     reverse order of latitude (colatitude) grids
c
      IMPLICIT NONE
      INTEGER NLAT,NLON,NLAT2,I,IB,J
      DOUBLE PRECISION DATA(NLAT,NLON),TEMP

      NLAT2 = NLAT/2
      DO I = 1,NLAT2
          IB = NLAT - I + 1
          DO J = 1,NLON
              TEMP = DATA(I,J)
              DATA(I,J) = DATA(IB,J)
              DATA(IB,J) = TEMP
          END DO
      END DO

      RETURN
      END
c ------------------------------------
      SUBROUTINE DCHKERR(STRING1,STRING2,IER,JER,KER,MER)
      IMPLICIT NONE

      INTEGER IER,JER,KER,MER
      CHARACTER*(*) STRING1,STRING2

      RETURN

      IF (IER.NE.0 .OR. JER.NE.0 .OR. KER.NE.0 .OR. MER.NE.0) THEN
          WRITE (*,FMT=
     +'('' ERROR: '',a,'' : '',a
     + ,'' : ier,jer,ker,mer='',4i3)') STRING1,STRING2,IER,JER,KER,MER
          STOP
      END IF
      END
c ---------------------------------------------------------
      SUBROUTINE DTRCTPR(NLAT,MWAVE,MDAB,NDAB,NT,A,B,IER)
      IMPLICIT NONE

c truncate spectral coefficients
c .   (possibly) taper the spectral coef

      INTEGER NLAT,MWAVE,MDAB,NDAB,NT,IER
      DOUBLE PRECISION A(MDAB,NDAB,NT),B(MDAB,NDAB,NT)

      DOUBLE PRECISION CON
      INTEGER NTWGT,M,N,IWAVE,JP,JW,J,K,MW2
      PARAMETER (NTWGT=500)
      DOUBLE PRECISION TWGT(NTWGT)

      IER = 0
      IF (MWAVE.EQ.0) RETURN

      MW2 = IABS(MWAVE) + 2

      DO K = 1,NT
          DO N = MW2,NLAT
              DO M = 1,N
                  A(M,N,K) = 0.0D0
                  B(M,N,K) = 0.0D0
              END DO
          END DO
      END DO

      IF (MWAVE.GT.0) RETURN

      IWAVE = IABS(MWAVE)
C perform exponential tapering

C exponent; determines fall-off rate
      JP = MAX0(IWAVE/10,1)
C coef which has wgt=exp(-1)
      JW = JP*10

      IF ((IWAVE+1).GT.NTWGT) THEN
          WRITE (*,FMT='(''taprwv: ntwgt exceeded='',2i5)') NTWGT,
     +      (IWAVE+1)
          RETURN
      END IF

      CON = 1.D0/DBLE(JW* (JW+1))
      DO J = 0,IWAVE
          TWGT(J+1) = EXP(- (DBLE(J* (J+1))*CON)**JP)
c c c    write (*,'(''taprwv: j, twgt(j)='',2i5,1x,f15.7)')
c c c*                        j, (j+1),twgt(j+1)
      END DO
C now wgt the coef by the wgts

      DO K = 1,NT
C traverse the diagonal
          DO N = IWAVE + 1,1,-1
              DO M = 1,N
                  A(M,N,K) = A(M,N,K)*TWGT(N)
                  B(M,N,K) = B(M,N,K)*TWGT(N)
              END DO
          END DO
      END DO

      RETURN
      END
c ----------------------------------------------------
      SUBROUTINE DGEOSCL(MLON,NLAT,NT,X,SCALE,NER)
      IMPLICIT NONE
      INTEGER MLON,NLAT,NT,NER
      DOUBLE PRECISION X(MLON,NLAT,NT),SCALE

      INTEGER N,ML,NL

c scale an array

      NER = 0
      IF (SCALE.EQ.1.0D0) RETURN

      DO N = 1,NT
          DO NL = 1,NLAT
              DO ML = 1,MLON
                  X(ML,NL,N) = X(ML,NL,N)*SCALE
              END DO
          END DO
      END DO

      RETURN
      END

C
C $Id: mdlocd.f,v 1.6 2008-09-18 00:42:17 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MDLOCD (RLON,CHRS,NCHR,NOFD)
C
C This routine, given a longitude RLON and a character buffer CHRS,
C returns CHRS and NCHR such that CHRS(1:NCHR), when written by PLCHHQ,
C will yield a representation of RLON in degrees and possibly fractions
C of a degree east or west of the prime meridian at Greenwich.
C
        DOUBLE PRECISION RLON
        CHARACTER*(*)    CHRS
        INTEGER          NCHR,NOFD
C
C Declare local variables.
C
        DOUBLE PRECISION ALON
        INTEGER          I,ILON
C
C Compute the equivalent value of the longitude in the range -180 to
C +180 degrees.
C
        ALON=MOD(MOD(RLON,360.D0)+360.D0,360.D0)
        IF (ALON.GE.180.D0) ALON=ALON-360.D0
C
C Compute the absolute value of the longitude in units of 10**(-5)
C degrees, limiting it to the range [0,18000000].
C
        ILON=MIN(18000000,INT(100000.D0*ABS(ALON)+.5D0))
C
C If the value is zero, return a string that will make PLCHHQ write a
C 0 followed by a degree sign.
C
        IF (ILON.EQ.0) THEN
          NCHR=7
          CHRS='0:F34:0'
          RETURN
        END IF
C
C Otherwise, put blanks in the buffer and zero the current character
C count.
C
        CHRS=' '
        NCHR=0
C
C Put the number of degrees in the buffer.
C
        CALL MDINCH (ILON/100000,CHRS,NCHR)
C
C If there is to be a fractional part, put it in the buffer.
C
        IF (NOFD.NE.0) THEN
          NCHR=NCHR+1
          CHRS(NCHR:NCHR)='.'
          DO 101 I=1,NOFD
            CALL MDINCH (MOD(ILON/10**(5-I),10),CHRS,NCHR)
  101     CONTINUE
        END IF
C
C Add the code for a degree sign to the buffer.
C
        NCHR=NCHR+9
        CHRS(NCHR-8:NCHR)=':F34:0:F:'
C
C Finally, put either a "W" or an "E" in the buffer.
C
        NCHR=NCHR+1
C
        IF (ALON.LT.0.) THEN
          CHRS(NCHR:NCHR)='W'
        ELSE
          CHRS(NCHR:NCHR)='E'
        END IF
C
C Done.
C
        RETURN
C
      END

      SUBROUTINE ZLAGTM( TRANS, N, NRHS, ALPHA, DL, D, DU, X, LDX, BETA,
     $                   B, LDB )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     October 31, 1992
*
*     .. Scalar Arguments ..
      CHARACTER          TRANS
      INTEGER            LDB, LDX, N, NRHS
      DOUBLE PRECISION   ALPHA, BETA
*     ..
*     .. Array Arguments ..
      COMPLEX*16         B( LDB, * ), D( * ), DL( * ), DU( * ),
     $                   X( LDX, * )
*     ..
*
*  Purpose
*  =======
*
*  ZLAGTM performs a matrix-vector product of the form
*
*     B := alpha * A * X + beta * B
*
*  where A is a tridiagonal matrix of order N, B and X are N by NRHS
*  matrices, and alpha and beta are real scalars, each of which may be
*  0., 1., or -1.
*
*  Arguments
*  =========
*
*  TRANS   (input) CHARACTER
*          Specifies the operation applied to A.
*          = 'N':  No transpose, B := alpha * A * X + beta * B
*          = 'T':  Transpose,    B := alpha * A**T * X + beta * B
*          = 'C':  Conjugate transpose, B := alpha * A**H * X + beta * B
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  NRHS    (input) INTEGER
*          The number of right hand sides, i.e., the number of columns
*          of the matrices X and B.
*
*  ALPHA   (input) DOUBLE PRECISION
*          The scalar alpha.  ALPHA must be 0., 1., or -1.; otherwise,
*          it is assumed to be 0.
*
*  DL      (input) COMPLEX*16 array, dimension (N-1)
*          The (n-1) sub-diagonal elements of T.
*
*  D       (input) COMPLEX*16 array, dimension (N)
*          The diagonal elements of T.
*
*  DU      (input) COMPLEX*16 array, dimension (N-1)
*          The (n-1) super-diagonal elements of T.
*
*  X       (input) COMPLEX*16 array, dimension (LDX,NRHS)
*          The N by NRHS matrix X.
*  LDX     (input) INTEGER
*          The leading dimension of the array X.  LDX >= max(N,1).
*
*  BETA    (input) DOUBLE PRECISION
*          The scalar beta.  BETA must be 0., 1., or -1.; otherwise,
*          it is assumed to be 1.
*
*  B       (input/output) COMPLEX*16 array, dimension (LDB,NRHS)
*          On entry, the N by NRHS matrix B.
*          On exit, B is overwritten by the matrix expression
*          B := alpha * A * X + beta * B.
*
*  LDB     (input) INTEGER
*          The leading dimension of the array B.  LDB >= max(N,1).
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ONE, ZERO
      PARAMETER          ( ONE = 1.0D+0, ZERO = 0.0D+0 )
*     ..
*     .. Local Scalars ..
      INTEGER            I, J
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          DCONJG
*     ..
*     .. Executable Statements ..
*
      IF( N.EQ.0 )
     $   RETURN
*
*     Multiply B by BETA if BETA.NE.1.
*
      IF( BETA.EQ.ZERO ) THEN
         DO 20 J = 1, NRHS
            DO 10 I = 1, N
               B( I, J ) = ZERO
   10       CONTINUE
   20    CONTINUE
      ELSE IF( BETA.EQ.-ONE ) THEN
         DO 40 J = 1, NRHS
            DO 30 I = 1, N
               B( I, J ) = -B( I, J )
   30       CONTINUE
   40    CONTINUE
      END IF
*
      IF( ALPHA.EQ.ONE ) THEN
         IF( LSAME( TRANS, 'N' ) ) THEN
*
*           Compute B := B + A*X
*
            DO 60 J = 1, NRHS
               IF( N.EQ.1 ) THEN
                  B( 1, J ) = B( 1, J ) + D( 1 )*X( 1, J )
               ELSE
                  B( 1, J ) = B( 1, J ) + D( 1 )*X( 1, J ) +
     $                        DU( 1 )*X( 2, J )
                  B( N, J ) = B( N, J ) + DL( N-1 )*X( N-1, J ) +
     $                        D( N )*X( N, J )
                  DO 50 I = 2, N - 1
                     B( I, J ) = B( I, J ) + DL( I-1 )*X( I-1, J ) +
     $                           D( I )*X( I, J ) + DU( I )*X( I+1, J )
   50             CONTINUE
               END IF
   60       CONTINUE
         ELSE IF( LSAME( TRANS, 'T' ) ) THEN
*
*           Compute B := B + A**T * X
*
            DO 80 J = 1, NRHS
               IF( N.EQ.1 ) THEN
                  B( 1, J ) = B( 1, J ) + D( 1 )*X( 1, J )
               ELSE
                  B( 1, J ) = B( 1, J ) + D( 1 )*X( 1, J ) +
     $                        DL( 1 )*X( 2, J )
                  B( N, J ) = B( N, J ) + DU( N-1 )*X( N-1, J ) +
     $                        D( N )*X( N, J )
                  DO 70 I = 2, N - 1
                     B( I, J ) = B( I, J ) + DU( I-1 )*X( I-1, J ) +
     $                           D( I )*X( I, J ) + DL( I )*X( I+1, J )
   70             CONTINUE
               END IF
   80       CONTINUE
         ELSE IF( LSAME( TRANS, 'C' ) ) THEN
*
*           Compute B := B + A**H * X
*
            DO 100 J = 1, NRHS
               IF( N.EQ.1 ) THEN
                  B( 1, J ) = B( 1, J ) + DCONJG( D( 1 ) )*X( 1, J )
               ELSE
                  B( 1, J ) = B( 1, J ) + DCONJG( D( 1 ) )*X( 1, J ) +
     $                        DCONJG( DL( 1 ) )*X( 2, J )
                  B( N, J ) = B( N, J ) + DCONJG( DU( N-1 ) )*
     $                        X( N-1, J ) + DCONJG( D( N ) )*X( N, J )
                  DO 90 I = 2, N - 1
                     B( I, J ) = B( I, J ) + DCONJG( DU( I-1 ) )*
     $                           X( I-1, J ) + DCONJG( D( I ) )*
     $                           X( I, J ) + DCONJG( DL( I ) )*
     $                           X( I+1, J )
   90             CONTINUE
               END IF
  100       CONTINUE
         END IF
      ELSE IF( ALPHA.EQ.-ONE ) THEN
         IF( LSAME( TRANS, 'N' ) ) THEN
*
*           Compute B := B - A*X
*
            DO 120 J = 1, NRHS
               IF( N.EQ.1 ) THEN
                  B( 1, J ) = B( 1, J ) - D( 1 )*X( 1, J )
               ELSE
                  B( 1, J ) = B( 1, J ) - D( 1 )*X( 1, J ) -
     $                        DU( 1 )*X( 2, J )
                  B( N, J ) = B( N, J ) - DL( N-1 )*X( N-1, J ) -
     $                        D( N )*X( N, J )
                  DO 110 I = 2, N - 1
                     B( I, J ) = B( I, J ) - DL( I-1 )*X( I-1, J ) -
     $                           D( I )*X( I, J ) - DU( I )*X( I+1, J )
  110             CONTINUE
               END IF
  120       CONTINUE
         ELSE IF( LSAME( TRANS, 'T' ) ) THEN
*
*           Compute B := B - A'*X
*
            DO 140 J = 1, NRHS
               IF( N.EQ.1 ) THEN
                  B( 1, J ) = B( 1, J ) - D( 1 )*X( 1, J )
               ELSE
                  B( 1, J ) = B( 1, J ) - D( 1 )*X( 1, J ) -
     $                        DL( 1 )*X( 2, J )
                  B( N, J ) = B( N, J ) - DU( N-1 )*X( N-1, J ) -
     $                        D( N )*X( N, J )
                  DO 130 I = 2, N - 1
                     B( I, J ) = B( I, J ) - DU( I-1 )*X( I-1, J ) -
     $                           D( I )*X( I, J ) - DL( I )*X( I+1, J )
  130             CONTINUE
               END IF
  140       CONTINUE
         ELSE IF( LSAME( TRANS, 'C' ) ) THEN
*
*           Compute B := B - A'*X
*
            DO 160 J = 1, NRHS
               IF( N.EQ.1 ) THEN
                  B( 1, J ) = B( 1, J ) - DCONJG( D( 1 ) )*X( 1, J )
               ELSE
                  B( 1, J ) = B( 1, J ) - DCONJG( D( 1 ) )*X( 1, J ) -
     $                        DCONJG( DL( 1 ) )*X( 2, J )
                  B( N, J ) = B( N, J ) - DCONJG( DU( N-1 ) )*
     $                        X( N-1, J ) - DCONJG( D( N ) )*X( N, J )
                  DO 150 I = 2, N - 1
                     B( I, J ) = B( I, J ) - DCONJG( DU( I-1 ) )*
     $                           X( I-1, J ) - DCONJG( D( I ) )*
     $                           X( I, J ) - DCONJG( DL( I ) )*
     $                           X( I+1, J )
  150             CONTINUE
               END IF
  160       CONTINUE
         END IF
      END IF
      RETURN
*
*     End of ZLAGTM
*
      END

C
C $Id: isosrf.f,v 1.8 2008-07-27 00:17:16 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE ISOSRF (T,LU,MU,LV,MV,MW,EYE,MUVWP2,SLAB,TISO,IFLAG)
C
      DIMENSION T(LU,LV,MW),EYE(3),SLAB(MUVWP2,MUVWP2)
C
      COMMON /ISCOMN/ BIG,BIGD,DBPI,IDONE,IFILL,IFLIP,IONES,IHSS(1000),
     +                IREF,ISCA(16,256),ISCALE,ISCR(16,256),ISLBT,ISDR,
     +                LHSS,LX,NFPW,NINU,NINV,NINW,NX,NY,R0,RNX,RNY,
     +                SMALL,SVAL,TENSN,U,V,W,XMAX,XMIN,YMAX,YMIN,XVPL,
     +                XVPR,YVPB,YVPT
      SAVE   /ISCOMN/
C
C Arithmetic statement function for taking an average of two reals.
C
      AVE(A,B) = (A+B)*.5
C
C Arithmetic statement functions for scaling.
C
      SU(UTEMP) = UTEMP
      SV(VTEMP) = VTEMP
      SW(WTEMP) = WTEMP
C
C Do a call forcing a BLOCKDATA to be loaded from a binary library.
C
      CALL ISBLDA
C
C  Initialize machine constants.
C
      IF (IDONE.EQ.0) THEN
        CALL ISINIT
        IDONE=1
      END IF
C
C In 3-space, we use variables U, V, W, IU, IV, IW, etc.  In 2-space,
C we use X, Y, IX, IY, etc.  Initialize.
C
      NU = MU
      NUP2 = NU+2
      NV = MV
      NVP2 = NV+2
      NW = MW
      NWP2 = NW+2
      FNU = NU
      FNV = NV
      FNW = NW
      SU1 = SU(1.)
      SV1 = SV(1.)
      SW1 = SW(1.)
      SUNU = SU(FNU)
      SVNV = SV(FNV)
      SWNW = SW(FNW)
      AVEU = AVE(SU1,SUNU)
      AVEV = AVE(SV1,SVNV)
      AVEW = AVE(SW1,SWNW)
      EYEU = EYE(1)
      EYEV = EYE(2)
      EYEW = EYE(3)
      NUVWP2 = MUVWP2
      TVAL = TISO
      NFLAG = ABS(IFLAG)
      IF (NFLAG.EQ.0 .OR. NFLAG.GE.8) NFLAG = 7
C
C Set up scaling.
C
      CALL ISST3D (EYE,1.,FNU,1.,FNV,1.,FNW)
C
C Bound lower and left edge of slab.
C
      EDGE = -SIGN(BIG,REAL(IFLAG))
C
      DO  40 IUVW=1,NUVWP2
        SLAB(IUVW,1) = EDGE
        SLAB(1,IUVW) = EDGE
   40 CONTINUE
C
C Slices perpendicular to the U axis (V/W slices):
C
      IF (NFLAG .LT. 4) GO TO 100
      CALL ISZERO
C
      ISLBT = -1
C
C Determine whether the viewing direction turns the contours over.
C
      IF (EYEU.LT.AVEU) THEN
        IFLIP=1
      ELSE
        IFLIP=2
      END IF
C
      IF (IFLAG.LT.0) IFLIP=3-IFLIP
C
C Bound upper and right edge of slab.
C
      DO  50 IV=2,NVP2
        SLAB(IV,NWP2) = EDGE
   50 CONTINUE
      DO  60 IW=2,NWP2
        SLAB(NVP2,IW) = EDGE
   60 CONTINUE
C
C Go through 3D array in the U direction.  IUEW stands for "IU, Either
C Way".  Pick IU based on the relative values of AVEU and EYEU.
C
      DO  90 IUEW=1,NU
        IU = IUEW
        IF (EYEU .GT. AVEU) IU = NU+1-IUEW
        U = IU
C
C Load this slice of T into SLAB.
C
        IF (SVAL.EQ.0.) THEN
          DO  71 IV=1,NV
            DO  70 IW=1,NW
              SLAB(IV+1,IW+1) = T(IU,IV,IW)
   70       CONTINUE
   71     CONTINUE
        ELSE
          DO  73 IV=1,NV
            DO  72 IW=1,NW
              IF (T(IU,IV,IW).NE.SVAL) THEN
                SLAB(IV+1,IW+1) = T(IU,IV,IW)
              ELSE
                SLAB(IV+1,IW+1) = EDGE
              END IF
   72       CONTINUE
   73     CONTINUE
        END IF
C
C Contour this slab.
C
        CALL ISTRCL (SLAB,NUVWP2,NVP2,NWP2,TVAL)
C
C Construct the visibility array.
C
        CALL ISFILL
C
C If interpolation is turned on, fill in intermediate slabs.
C
        IF (NINU.NE.0.AND.IUEW.NE.NU) THEN
          IF (NINU.LT.0) ISDR=1
          IQ=IU+1
          IF (EYEU.GT.AVEU) IQ=IU-1
          DO  85 IINU=1,ABS(NINU)
            Q=REAL(IINU)/REAL(ABS(NINU)+1)
            P=1.-Q
            U=P*REAL(IU)+Q*REAL(IQ)
            IF (SVAL.EQ.0.) THEN
              DO  82 IV=1,NV
                DO  81 IW=1,NW
                  SLAB(IV+1,IW+1)=P*T(IU,IV,IW)+Q*T(IQ,IV,IW)
   81           CONTINUE
   82         CONTINUE
            ELSE
              DO  84 IV=1,NV
                DO  83 IW=1,NW
                  IF (T(IU,IV,IW).NE.SVAL.AND.T(IQ,IV,IW).NE.SVAL) THEN
                    SLAB(IV+1,IW+1)=P*T(IU,IV,IW)+Q*T(IQ,IV,IW)
                  ELSE
                    SLAB(IV+1,IW+1)=EDGE
                  END IF
   83           CONTINUE
   84         CONTINUE
            END IF
            CALL ISTRCL (SLAB,NUVWP2,NVP2,NWP2,TVAL)
            CALL ISFILL
   85     CONTINUE
          ISDR=0
        END IF
C
   90 CONTINUE
C
C Slices perpendicular to the V axis (U/W slices):
C
  100 IF (MOD(NFLAG/2,2) .EQ. 0) GO TO 160
      CALL ISZERO
C
      ISLBT = 0
C
C Determine whether the viewing direction turns the contours over.
C
      IF (EYEV.GT.AVEV) THEN
        IFLIP=1
      ELSE
        IFLIP=2
      END IF
C
      IF (IFLAG.LT.0) IFLIP=3-IFLIP
C
C Bound upper and right edge of slab.
C
      DO 110 IU=2,NUP2
        SLAB(IU,NWP2) = EDGE
  110 CONTINUE
      DO 120 IW=2,NWP2
        SLAB(NUP2,IW) = EDGE
  120 CONTINUE
C
C Go through 3D array in the V direction.  IVEW stands for "IV, Either
C Way".  Pick IV based on the relative values of AVEV and EYEV.
C
      DO 150 IVEW=1,NV
        IV = IVEW
        IF (EYEV .GT. AVEV) IV = NV+1-IVEW
        V = IV
C
C Load this slice of T into SLAB.
C
        IF (SVAL.EQ.0.) THEN
          DO 131 IU=1,NU
            DO 130 IW=1,NW
              SLAB(IU+1,IW+1) = T(IU,IV,IW)
  130       CONTINUE
  131     CONTINUE
        ELSE
          DO 133 IU=1,NU
            DO 132 IW=1,NW
              IF (T(IU,IV,IW).NE.SVAL) THEN
                SLAB(IU+1,IW+1) = T(IU,IV,IW)
              ELSE
                SLAB(IU+1,IW+1) = EDGE
              END IF
  132       CONTINUE
  133     CONTINUE
        END IF
C
C Contour this slab.
C
        CALL ISTRCL (SLAB,NUVWP2,NUP2,NWP2,TVAL)
C
C Construct the visibility array.
C
        CALL ISFILL
C
C If interpolation is turned on, fill in intermediate slabs.
C
        IF (NINV.NE.0.AND.IVEW.NE.NV) THEN
          IF (NINV.LT.0) ISDR=1
          IQ=IV+1
          IF (EYEV.GT.AVEV) IQ=IV-1
          DO 145 IINV=1,ABS(NINV)
            Q=REAL(IINV)/REAL(ABS(NINV)+1)
            P=1.-Q
            V=P*REAL(IV)+Q*REAL(IQ)
            IF (SVAL.EQ.0.) THEN
              DO 142 IU=1,NU
                DO 141 IW=1,NW
                  SLAB(IU+1,IW+1)=P*T(IU,IV,IW)+Q*T(IU,IQ,IW)
  141           CONTINUE
  142         CONTINUE
            ELSE
              DO 144 IU=1,NU
                DO 143 IW=1,NW
                  IF (T(IU,IV,IW).NE.SVAL.AND.T(IU,IQ,IW).NE.SVAL) THEN
                    SLAB(IU+1,IW+1)=P*T(IU,IV,IW)+Q*T(IU,IQ,IW)
                  ELSE
                    SLAB(IU+1,IW+1)=EDGE
                  END IF
  143           CONTINUE
  144         CONTINUE
            END IF
            CALL ISTRCL (SLAB,NUVWP2,NUP2,NWP2,TVAL)
            CALL ISFILL
  145     CONTINUE
          ISDR=0
        END IF
C
  150 CONTINUE
C
C Slices perpendicular to the W axis (U/V slices):
C
  160 IF (MOD(NFLAG,2) .EQ. 0) GO TO 220
      CALL ISZERO
C
      ISLBT = 1
C
C Determine whether the viewing direction turns the contours over.
C
      IF (EYEW.LT.AVEW) THEN
        IFLIP=1
      ELSE
        IFLIP=2
      END IF
C
      IF (IFLAG.LT.0) IFLIP=3-IFLIP
C
C Bound upper and right edge of slab.
C
      DO 170 IU=2,NUP2
        SLAB(IU,NVP2) = EDGE
  170 CONTINUE
      DO 180 IV=2,NVP2
        SLAB(NUP2,IV) = EDGE
  180 CONTINUE
C
C Go through 3D array in the W direction.  IWEW stands for "IW, Either
C Way".  Pick IW based on the relative values of AVEW and EYEW.
C
      DO 210 IWEW=1,NW
        IW = IWEW
        IF (EYEW .GT. AVEW) IW = NW+1-IWEW
        W = IW
C
C Load this slice of T into SLAB.
C
        IF (SVAL.EQ.0.) THEN
          DO 191 IU=1,NU
            DO 190 IV=1,NV
              SLAB(IU+1,IV+1) = T(IU,IV,IW)
  190       CONTINUE
  191     CONTINUE
        ELSE
          DO 193 IU=1,NU
            DO 192 IV=1,NV
              IF (T(IU,IV,IW).NE.SVAL) THEN
                SLAB(IU+1,IV+1) = T(IU,IV,IW)
              ELSE
                SLAB(IU+1,IV+1) = EDGE
              END IF
  192       CONTINUE
  193     CONTINUE
        END IF
C
C Contour this slab.
C
        CALL ISTRCL (SLAB,NUVWP2,NUP2,NVP2,TVAL)
C
C Construct the visibility array.
C
        CALL ISFILL
C
C If interpolation is turned on, fill in intermediate slabs.
C
        IF (NINW.NE.0.AND.IWEW.NE.NW) THEN
          IF (NINW.LT.0) ISDR=1
          IQ=IW+1
          IF (EYEW.GT.AVEW) IQ=IW-1
          DO 205 IINW=1,ABS(NINW)
            Q=REAL(IINW)/REAL(ABS(NINW)+1)
            P=1.-Q
            W=P*REAL(IW)+Q*REAL(IQ)
            IF (SVAL.EQ.0.) THEN
              DO 202 IU=1,NU
                DO 201 IV=1,NV
                  SLAB(IU+1,IV+1)=P*T(IU,IV,IW)+Q*T(IU,IV,IQ)
  201           CONTINUE
  202         CONTINUE
            ELSE
              DO 204 IU=1,NU
                DO 203 IV=1,NV
                  IF (T(IU,IV,IW).NE.SVAL.AND.T(IU,IV,IQ).NE.SVAL) THEN
                    SLAB(IU+1,IV+1)=P*T(IU,IV,IW)+Q*T(IU,IV,IQ)
                  ELSE
                    SLAB(IU+1,IV+1)=EDGE
                  END IF
  203           CONTINUE
  204         CONTINUE
            END IF
            CALL ISTRCL (SLAB,NUVWP2,NUP2,NVP2,TVAL)
            CALL ISFILL
  205     CONTINUE
          ISDR=0
        END IF
C
  210 CONTINUE
C
C Draw reference-plane edges and the W axis.
C
  220 IF (IREF .EQ. 0) RETURN
      CALL ISTR32 (SU1,SV1,SW1,XT,YT,DUM,2)
      IF (EYEV .LT. SV1) GO TO 240
      CALL ISPLTF (XT,YT,1)
      DO 230 IX=1,NX
        RU=1.+REAL(NU-1)*(REAL(IX)/REAL(NX))
        CALL ISTR32 (SU(RU),SV1,SW1,XT,YT,DUM,2)
        CALL ISPLTF (XT,YT,2)
  230 CONTINUE
      GO TO 250
  240 CALL PLOTIF (XVPL+(XVPR-XVPL)*XT,YVPB+(YVPT-YVPB)*YT,0)
      CALL ISTR32 (SUNU,SV1,SW1,XT,YT,DUM,2)
      CALL PLOTIF (XVPL+(XVPR-XVPL)*XT,YVPB+(YVPT-YVPB)*YT,1)
  250 IF (EYEU .GT. SUNU) GO TO 270
      CALL ISPLTF (XT,YT,1)
      DO 260 IX=1,NX
        RV=1.+REAL(NV-1)*(REAL(IX)/REAL(NX))
        CALL ISTR32 (SUNU,SV(RV),SW1,XT,YT,DUM,2)
        CALL ISPLTF (XT,YT,2)
  260 CONTINUE
      GO TO 280
  270 CALL PLOTIF (XVPL+(XVPR-XVPL)*XT,YVPB+(YVPT-YVPB)*YT,0)
      CALL ISTR32 (SUNU,SVNV,SW1,XT,YT,DUM,2)
      CALL PLOTIF (XVPL+(XVPR-XVPL)*XT,YVPB+(YVPT-YVPB)*YT,1)
  280 IF (EYEV .GT. SVNV) GO TO 300
      CALL ISPLTF (XT,YT,1)
      DO 290 IX=1,NX
        RU=1.+REAL(NU-1)*(REAL(NX-IX)/REAL(NX))
        CALL ISTR32 (SU(RU),SVNV,SW1,XT,YT,DUM,2)
        CALL ISPLTF (XT,YT,2)
  290 CONTINUE
      GO TO 310
  300 CALL PLOTIF (XVPL+(XVPR-XVPL)*XT,YVPB+(YVPT-YVPB)*YT,0)
      CALL ISTR32 (SU1,SVNV,SW1,XT,YT,DUM,2)
      CALL PLOTIF (XVPL+(XVPR-XVPL)*XT,YVPB+(YVPT-YVPB)*YT,1)
  310 IF (EYEU .LT. SU1) GO TO 330
      CALL ISPLTF (XT,YT,1)
      DO 320 IX=1,NX
        RV=1.+REAL(NV-1)*(REAL(NX-IX)/REAL(NX))
        CALL ISTR32 (SU1,SV(RV),SW1,XT,YT,DUM,2)
        CALL ISPLTF (XT,YT,2)
  320 CONTINUE
      GO TO 340
  330 CALL PLOTIF (XVPL+(XVPR-XVPL)*XT,YVPB+(YVPT-YVPB)*YT,0)
      CALL ISTR32 (SU1,SV1,SW1,XT,YT,DUM,2)
      CALL PLOTIF (XVPL+(XVPR-XVPL)*XT,YVPB+(YVPT-YVPB)*YT,1)
  340 IF (EYEU.LE.SU1 .OR. EYEV.LE.SV1) GO TO 360
      CALL ISPLTF (XT,YT,1)
      DO 350 IX=1,NX
        RW=1.+REAL(NW-1)*(REAL(IX)/REAL(NX))
        CALL ISTR32 (SU1,SV1,SW(RW),XT,YT,DUM,2)
        CALL ISPLTF (XT,YT,2)
  350 CONTINUE
      RETURN
  360 CALL PLOTIF (XVPL+(XVPR-XVPL)*XT,YVPB+(YVPT-YVPB)*YT,0)
      CALL ISTR32 (SU1,SV1,SWNW,XT,YT,DUM,2)
      CALL PLOTIF (XVPL+(XVPR-XVPL)*XT,YVPB+(YVPT-YVPB)*YT,1)
      RETURN
      END

C
C $Id: getusv.f,v 1.7 2008-07-27 00:17:24 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GETUSV (VN,IV)
      CHARACTER*(*) VN
C
C This subroutine retrieves the current values of the utility state
C variables.  VN is the character name of the variable and IV is
C its value.
C
C The labelled common block IUTLCM contains all of the utility state
C variables.
C
      COMMON /IUTLCM/IU(100)
      SAVE /IUTLCM/
C
C Check for an uncleared prior error.
C
      IF (ICFELL('GETUSV - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C Check for the linear-log scaling variable.
C
      IF (VN(1:2).EQ.'LS') THEN
        IV=IU(1)
C
C Check for the variable specifying the mirror-imaging of the axes.
C
      ELSE IF (VN(1:2).EQ.'MI') THEN
        IV=IU(2)
C
C Check for the variable specifying the resolution of the plotter in x.
C
      ELSE IF (VN(1:2).EQ.'XF') THEN
        IV=IU(3)
C
C Check for the variable specifying the resolution of the plotter in x.
C
      ELSE IF (VN(1:2).EQ.'YF') THEN
        IV=IU(4)
C
C Check for the variable specifying the size of the pen-move buffer.
C
      ELSE IF (VN(1:2).EQ.'PB') THEN
        IV=IU(5)
C
C Check for the variable specifying the metacode unit.
C
      ELSE IF (VN(1:2).EQ.'MU') THEN
        IV=ABS(IU(6))
C
C Check for one of the variables specifying color and intensity.
C
      ELSE IF (VN(1:2).EQ.'IR') THEN
        IV=IU(7)
C
      ELSE IF (VN(1:2).EQ.'IG') THEN
        IV=IU(8)
C
      ELSE IF (VN(1:2).EQ.'IB') THEN
        IV=IU(9)
C
      ELSE IF (VN(1:2).EQ.'IN') THEN
        IV=IU(10)
C
C Check for the variable specifying the current color index.
C
      ELSE IF (VN(1:2).EQ.'II') THEN
        IV=IU(11)
C
C Check for the variable specifying the maximum color index.
C
      ELSE IF (VN(1:2).EQ.'IM') THEN
        IV=IU(12)
C
C Check for the variable specifying the line width scale factor.
C
      ELSE IF (VN(1:2).EQ.'LW') THEN
        IV=IU(13)
C
C Check for the variable specifying the marker size scale factor.
C
      ELSE IF (VN(1:2).EQ.'MS') THEN
        IV=IU(14)
C
C Otherwise, the variable name is unknown.
C
      ELSE
        CALL SETER ('GETUSV - UNKNOWN VARIABLE NAME IN CALL',2,1)
C
      ENDIF
C
      RETURN
C
      END

C NCLORTSTART
      subroutine dacumrun(p,np,pmsg,nrun,pac,nmsg,iopt)
      implicit none
c                               INPUT
      integer np, nrun, iopt
      double precision p(np), pmsg
c                               OUTPUT
      integer nmsg
      double precision pac(np)
C NCLEND
c                               LOCAL
      integer n, m

c 1st (nrun-1) are msg

      do n=1,nrun-1
         pac(n) = pmsg
      end do

c Sum nrun 'p' values and store them in appropriate 'pac' location
c .   If any run encounters a msg value:
c .   iopt=0: (a) count; set 'pac=pmsg'; (c) terminate current run
c .   iopt=1: (a) count total # missing values; (b) continue w run

      nmsg = 0

      do n=nrun,np
         pac(n) = 0.0d0
        do m=0,nrun-1
           if (p(n-m).ne.pmsg) then
               pac(n) = pac(n) + p(n-m)
           else
               nmsg   = nmsg + 1
               if (iopt.eq.0) then
                   pac(n) = pmsg
                   go to 10
               end if
           end if
        end do
   10    continue
      end do

      return
      end

C
C $Id: mapstr.f,v 1.20 2008-09-18 00:42:16 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MAPSTR (WHCH,RVAL)
        CHARACTER*(*) WHCH
        REAL          RVAL
        IF (ICFELL('MAPSTR - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
        CALL MDSETR (WHCH,RVAL)
        IF (ICFELL('MAPSTR',2).NE.0) RETURN
        RETURN
      END

C
C	$Id: wmvect.f,v 1.3 2008-07-27 00:17:37 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE WMVECT(X,Y,U,V)
C
C  This subroutine plots wind vectors with the origin of the vector at
C  (X,Y).  U and V are the components of the wind vector.
C
      include 'wmcomn.h'
C
      PARAMETER (R2D=57.2957795131)
C
C  Do a call forcing a BLOCKDATA to be loaded from a binary library.
C
      CALL WMBLDA
C
C  Save the current line and fill colors and set them to ICOLOR.
C
      CALL GQPLCI(IER,ILCLRO)
      CALL GQLWSC(IER,RLNWTH)
C
      CALL GSPLCI(VCCOLR)
      CALL GSLWSC(VCLWID)
C
      SPEED  = SQRT(U*U+V*V)
      CALL WMGETR('VRS',VRS)
      CALL WMGETR('VRN',VRN)
C
      UP =  U
      VP =  V
      COSANG = UP/SPEED
      SINANG = VP/SPEED
      IF (VP .GE. 0.) THEN
        ALPHA = ACOS(UP/SPEED)*R2D
      ELSE
        ALPHA = -ACOS(UP/SPEED)*R2D
      ENDIF
      CALL WMSETR('VCD',ALPHA)
      CALL WMSETR('VCS',SPEED)
C
C  Draw the vector.
C
      CALL WMLABS(X,Y,'Vector')
C
C  Restore the original environment.
C
      CALL GSPLCI(ILCLRO)
C     CALL GSELNT(NTRO)
      CALL GSLWSC(RLNWTH)
      CALL PCSETI ('FN',IFNO)
C
      RETURN
      END

C
C	$Id: csnearnd.f,v 1.5 2008-07-27 03:10:07 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      INTEGER FUNCTION CSNEARND (P,IST,N,X,Y,Z,LIST,LPTR,
     .                         LEND, AL)
      INTEGER IST, N, LIST(*), LPTR(*), LEND(N)
      DOUBLE PRECISION P(3), X(N), Y(N), Z(N), AL
C
C***********************************************************
C
C                                              From STRIPACK
C                                            Robert J. Renka
C                                  Dept. of Computer Science
C                                       Univ. of North Texas
C                                           renka@cs.unt.edu
C                                                   07/28/98
C
C   Given a point P on the surface of the unit sphere and a
C Delaunay triangulation created by Subroutine CSTRMESH, this
C function returns the index of the nearest triangulation
C node to P.
C
C   The algorithm consists of implicitly adding P to the
C triangulation, finding the nearest neighbor to P, and
C implicitly deleting P from the triangulation.  Thus, it
C is based on the fact that, if P is a node in a Delaunay
C triangulation, the nearest node to P is a neighbor of P.
C
C
C On input:
C
C       P = Array of length 3 containing the Cartesian coor-
C           dinates of the point P to be located relative to
C           the triangulation.  It is assumed without a test
C           that P(1)**2 + P(2)**2 + P(3)**2 = 1.
C
C       IST = Index of a node at which CSTRFIND begins the
C             search.  Search time depends on the proximity
C             of this node to P.
C
C       N = Number of nodes in the triangulation.  N .GE. 3.
C
C       X,Y,Z = Arrays of length N containing the Cartesian
C               coordinates of the nodes.
C
C       LIST,LPTR,LEND = Data structure defining the trian-
C                        gulation.  Refer to CSTRMESH.
C
C Input parameters are not altered by this function.
C
C On output:
C
C       CSNEARND = Nodal index of the nearest node to P, or 0
C                if N < 3 or the triangulation data struc-
C                ture is invalid.
C
C       AL = Arc length (angular distance in radians) be-
C            tween P and CSNEARND unless CSNEARND = 0.
C
C       Note that the number of candidates for CSNEARND
C       (neighbors of P) is limited to LMAX defined in
C       the PARAMETER statement below.
C
C Modules required by CSNEARND:  CSJRAND, CSLSTPTR, CSTRFIND, CSSTORE
C
C Intrinsic functions called by CSNEARND:  ABS, ACOS
C
C***********************************************************
C
      INTEGER   CSLSTPTR
      INTEGER   LMAX
      PARAMETER (LMAX=25)
      INTEGER   I1, I2, I3, L, LISTP(LMAX), LP, LP1, LP2,
     .          LPL, LPTRP(LMAX), N1, N2, N3, NN, NR, NST
      DOUBLE PRECISION B1, B2, B3, DS1, DSR, DX1, DX2, DX3,
     .                 DY1, DY2, DY3, DZ1, DZ2, DZ3
C
C Local parameters:
C
C B1,B2,B3 =  Unnormalized barycentric coordinates returned
C               by CSTRFIND
C DS1 =       (Negative cosine of the) distance from P to N1
C DSR =       (Negative cosine of the) distance from P to NR
C DX1,..DZ3 = Components of vectors used by the swap test
C I1,I2,I3 =  Nodal indexes of a triangle containing P, or
C               the rightmost (I1) and leftmost (I2) visible
C               boundary nodes as viewed from P
C L =         Length of LISTP/LPTRP and number of neighbors
C               of P
C LMAX =      Maximum value of L
C LISTP =     Indexes of the neighbors of P
C LPTRP =     Array of pointers in 1-1 correspondence with
C               LISTP elements
C LP =        LIST pointer to a neighbor of N1 and LISTP
C               pointer
C LP1,LP2 =   LISTP indexes (pointers)
C LPL =       Pointer to the last neighbor of N1
C N1 =        Index of a node visible from P
C N2 =        Index of an endpoint of an arc opposite P
C N3 =        Index of the node opposite N1->N2
C NN =        Local copy of N
C NR =        Index of a candidate for the nearest node to P
C NST =       Index of the node at which CSTRFIND begins the
C               search
C
C
C Store local parameters and test for N invalid.
C
      NN = N
      IF (NN .LT. 3) GO TO 6
      NST = IST
      IF (NST .LT. 1  .OR.  NST .GT. NN) NST = 1
C
C Find a triangle (I1,I2,I3) containing P, or the rightmost
C   (I1) and leftmost (I2) visible boundary nodes as viewed
C   from P.
C
      CALL CSTRFIND (NST,P,N,X,Y,Z,LIST,LPTR,LEND, B1,B2,B3,
     .             I1,I2,I3)
C
C Test for collinear nodes.
C
      IF (I1 .EQ. 0) GO TO 6
C
C Store the linked list of 'neighbors' of P in LISTP and
C   LPTRP.  I1 is the first neighbor, and 0 is stored as
C   the last neighbor if P is not contained in a triangle.
C   L is the length of LISTP and LPTRP, and is limited to
C   LMAX.
C
      IF (I3 .NE. 0) THEN
        LISTP(1) = I1
        LPTRP(1) = 2
        LISTP(2) = I2
        LPTRP(2) = 3
        LISTP(3) = I3
        LPTRP(3) = 1
        L = 3
      ELSE
        N1 = I1
        L = 1
        LP1 = 2
        LISTP(L) = N1
        LPTRP(L) = LP1
C
C   Loop on the ordered sequence of visible boundary nodes
C     N1 from I1 to I2.
C
    1   LPL = LEND(N1)
          N1 = -LIST(LPL)
          L = LP1
          LP1 = L+1
          LISTP(L) = N1
          LPTRP(L) = LP1
          IF (N1 .NE. I2  .AND.  LP1 .LT. LMAX) GO TO 1
        L = LP1
        LISTP(L) = 0
        LPTRP(L) = 1
      ENDIF
C
C Initialize variables for a loop on arcs N1-N2 opposite P
C   in which new 'neighbors' are 'swapped' in.  N1 follows
C   N2 as a neighbor of P, and LP1 and LP2 are the LISTP
C   indexes of N1 and N2.
C
      LP2 = 1
      N2 = I1
      LP1 = LPTRP(1)
      N1 = LISTP(LP1)
C
C Begin loop:  find the node N3 opposite N1->N2.
C
    2 LP = CSLSTPTR(LEND(N1),N2,LIST,LPTR)
        IF (LIST(LP) .LT. 0) GO TO 3
        LP = LPTR(LP)
        N3 = ABS(LIST(LP))
C
C Swap test:  Exit the loop if L = LMAX.
C
        IF (L .EQ. LMAX) GO TO 4
        DX1 = X(N1) - P(1)
        DY1 = Y(N1) - P(2)
        DZ1 = Z(N1) - P(3)
C
        DX2 = X(N2) - P(1)
        DY2 = Y(N2) - P(2)
        DZ2 = Z(N2) - P(3)
C
        DX3 = X(N3) - P(1)
        DY3 = Y(N3) - P(2)
        DZ3 = Z(N3) - P(3)
        IF ( DX3*(DY2*DZ1 - DY1*DZ2) -
     .       DY3*(DX2*DZ1 - DX1*DZ2) +
     .       DZ3*(DX2*DY1 - DX1*DY2) .LE. 0.D0 ) GO TO 3
C
C Swap:  Insert N3 following N2 in the adjacency list for P.
C        The two new arcs opposite P must be tested.
C
        L = L+1
        LPTRP(LP2) = L
        LISTP(L) = N3
        LPTRP(L) = LP1
        LP1 = L
        N1 = N3
        GO TO 2
C
C No swap:  Advance to the next arc and test for termination
C           on N1 = I1 (LP1 = 1) or N1 followed by 0.
C
    3   IF (LP1 .EQ. 1) GO TO 4
        LP2 = LP1
        N2 = N1
        LP1 = LPTRP(LP1)
        N1 = LISTP(LP1)
        IF (N1 .EQ. 0) GO TO 4
        GO TO 2
C
C Set NR and DSR to the index of the nearest node to P and
C   an increasing function (negative cosine) of its distance
C   from P, respectively.
C
    4 NR = I1
      DSR = -(X(NR)*P(1) + Y(NR)*P(2) + Z(NR)*P(3))
      DO 5 LP = 2,L
        N1 = LISTP(LP)
        IF (N1 .EQ. 0) GO TO 5
        DS1 = -(X(N1)*P(1) + Y(N1)*P(2) + Z(N1)*P(3))
        IF (DS1 .LT. DSR) THEN
          NR = N1
          DSR = DS1
        ENDIF
    5   CONTINUE
      DSR = -DSR
      IF (DSR .GT. 1.0D0) DSR = 1.0D0
      AL = ACOS(DSR)
      CSNEARND = NR
      RETURN
C
C Invalid input.
C
    6 CSNEARND = 0
      RETURN
      END

      SUBROUTINE BNDARY
C
C Routine to draw the plotter-frame edge.
C
      CALL PLOTIT (    0,    0,0)
      CALL PLOTIT (32767,    0,1)
      CALL PLOTIT (32767,32767,1)
      CALL PLOTIT (    0,32767,1)
      CALL PLOTIT (    0,    0,1)
      RETURN
      END

      SUBROUTINE SLANV2( A, B, C, D, RT1R, RT1I, RT2R, RT2I, CS, SN )
*
*  -- LAPACK driver routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      REAL               A, B, C, CS, D, RT1I, RT1R, RT2I, RT2R, SN
*     ..
*
*  Purpose
*  =======
*
*  SLANV2 computes the Schur factorization of a real 2-by-2 nonsymmetric
*  matrix in standard form:
*
*       [ A  B ] = [ CS -SN ] [ AA  BB ] [ CS  SN ]
*       [ C  D ]   [ SN  CS ] [ CC  DD ] [-SN  CS ]
*
*  where either
*  1) CC = 0 so that AA and DD are real eigenvalues of the matrix, or
*  2) AA = DD and BB*CC < 0, so that AA + or - sqrt(BB*CC) are complex
*  conjugate eigenvalues.
*
*  Arguments
*  =========
*
*  A       (input/output) REAL            
*  B       (input/output) REAL            
*  C       (input/output) REAL            
*  D       (input/output) REAL            
*          On entry, the elements of the input matrix.
*          On exit, they are overwritten by the elements of the
*          standardised Schur form.
*
*  RT1R    (output) REAL 
*  RT1I    (output) REAL            
*  RT2R    (output) REAL            
*  RT2I    (output) REAL            
*          The real and imaginary parts of the eigenvalues. If the
*          eigenvalues are a complex conjugate pair, RT1I > 0.
*
*  CS      (output) REAL            
*  SN      (output) REAL            
*          Parameters of the rotation matrix.
*
*  Further Details
*  ===============
*
*  Modified by V. Sima, Research Institute for Informatics, Bucharest,
*  Romania, to reduce the risk of cancellation errors,
*  when computing real eigenvalues, and to ensure, if possible, that
*  abs(RT1R) >= abs(RT2R).
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ZERO, HALF, ONE
      PARAMETER          ( ZERO = 0.0E+0, HALF = 0.5E+0, ONE = 1.0E+0 )
      REAL               MULTPL
      PARAMETER          ( MULTPL = 4.0E+0 )
*     ..
*     .. Local Scalars ..
      REAL               AA, BB, BCMAX, BCMIS, CC, CS1, DD, EPS, P, SAB, 
     $                   SAC, SCALE, SIGMA, SN1, TAU, TEMP, Z
*     ..
*     .. External Functions ..
      REAL               SLAMCH, SLAPY2
      EXTERNAL           SLAMCH, SLAPY2
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, MAX, MIN, SIGN, SQRT
*     ..
*     .. Executable Statements ..
*
      EPS = SLAMCH( 'P' )
      IF( C.EQ.ZERO ) THEN
         CS = ONE
         SN = ZERO
         GO TO 10
*
      ELSE IF( B.EQ.ZERO ) THEN
*
*        Swap rows and columns
*
         CS = ZERO
         SN = ONE
         TEMP = D
         D = A
         A = TEMP
         B = -C
         C = ZERO
         GO TO 10
      ELSE IF( (A-D).EQ.ZERO .AND. SIGN( ONE, B ).NE.
     $   SIGN( ONE, C ) ) THEN
         CS = ONE
         SN = ZERO
         GO TO 10
      ELSE
*
         TEMP = A - D
         P = HALF*TEMP
         BCMAX = MAX( ABS( B ), ABS( C ) )
         BCMIS = MIN( ABS( B ), ABS( C ) )*SIGN( ONE, B )*SIGN( ONE, C )
         SCALE = MAX( ABS( P ), BCMAX )
         Z = ( P / SCALE )*P + ( BCMAX / SCALE )*BCMIS
*
*        If Z is of the order of the machine accuracy, postpone the
*        decision on the nature of eigenvalues
*
         IF( Z.GE.MULTPL*EPS ) THEN
*
*           Real eigenvalues. Compute A and D.
*
            Z = P + SIGN( SQRT( SCALE )*SQRT( Z ), P )
            A = D + Z
            D = D - ( BCMAX / Z )*BCMIS
*
*           Compute B and the rotation matrix
*
            TAU = SLAPY2( C, Z )
            CS = Z / TAU
            SN = C / TAU
            B = B - C
            C = ZERO
         ELSE
*
*           Complex eigenvalues, or real (almost) equal eigenvalues.
*           Make diagonal elements equal.
*
            SIGMA = B + C
            TAU = SLAPY2( SIGMA, TEMP )
            CS = SQRT( HALF*( ONE+ABS( SIGMA ) / TAU ) )
            SN = -( P / ( TAU*CS ) )*SIGN( ONE, SIGMA )
*
*           Compute [ AA  BB ] = [ A  B ] [ CS -SN ]
*                   [ CC  DD ]   [ C  D ] [ SN  CS ]
*
            AA = A*CS + B*SN
            BB = -A*SN + B*CS
            CC = C*CS + D*SN
            DD = -C*SN + D*CS
*
*           Compute [ A  B ] = [ CS  SN ] [ AA  BB ]
*                   [ C  D ]   [-SN  CS ] [ CC  DD ]
*
            A = AA*CS + CC*SN
            B = BB*CS + DD*SN
            C = -AA*SN + CC*CS
            D = -BB*SN + DD*CS
*
            TEMP = HALF*( A+D )
            A = TEMP
            D = TEMP
*
            IF( C.NE.ZERO ) THEN
               IF( B.NE.ZERO ) THEN
                  IF( SIGN( ONE, B ).EQ.SIGN( ONE, C ) ) THEN
*
*                    Real eigenvalues: reduce to upper triangular form
*
                     SAB = SQRT( ABS( B ) )
                     SAC = SQRT( ABS( C ) )
                     P = SIGN( SAB*SAC, C )
                     TAU = ONE / SQRT( ABS( B+C ) )
                     A = TEMP + P
                     D = TEMP - P
                     B = B - C
                     C = ZERO
                     CS1 = SAB*TAU
                     SN1 = SAC*TAU
                     TEMP = CS*CS1 - SN*SN1
                     SN = CS*SN1 + SN*CS1
                     CS = TEMP
                  END IF
               ELSE
                  B = -C
                  C = ZERO
                  TEMP = CS
                  CS = -SN
                  SN = TEMP
               END IF
            END IF
         END IF
*
      END IF
*
   10 CONTINUE
*
*     Store eigenvalues in (RT1R,RT1I) and (RT2R,RT2I).
*
      RT1R = A
      RT2R = D
      IF( C.EQ.ZERO ) THEN
         RT1I = ZERO
         RT2I = ZERO
      ELSE
         RT1I = SQRT( ABS( B ) )*SQRT( ABS( C ) )
         RT2I = -RT1I
      END IF
      RETURN
*
*     End of SLANV2
*
      END

C NCLFORTSTART
      SUBROUTINE DSIMPEQ (NUM,DX,Y,ANS)
      IMPLICIT NONE
      INTEGER  NUM
      DOUBLE PRECISION DX,Y(NUM),ANS
C NCLEND
C
C THE NSSL "simpsn.f" DOES NOT WORK. THIS IS NOW JUST A FRONT-END
C DRIVER THAT ALLOWS THE SAME INTERFACE TO BE USED BUT IT INVOKES
C THE *SLIGHTLY* LESS ACCURATE "simpne.f" TO PERFORM THE INTEGRATION.
C
C SOURCE                 NCAR's NSSL [simpsn.f]
C ARGUMENTS
C
C ON INPUT               DX
C                          A SINGLE VARIABLE SPECIFYING THE INCREMENT
C                          FOR THE EQUALLY SPACED ABSCISSAS.
C
C                        Y
C                          VECTOR OF ORDINATES.
C
C                        NUM
C                          LENGTH OF VECTOR Y (SHOULD BE .GT. 2).
C
C ON OUTPUT              ANS
C                          ANSWER [set to -9999. if error]
C
C ALGORITHM              SIMPSON'S RULE AND LAGRANGIAN INTERPOLATION
C
C ACCURACY               FOR EQUALLY SPACED ABSCISSAE THE ERROR IS
C                        PROPORTIONAL TO  H**4 TIMES THE FOURTH
C                        DERIVATIVE OF F  AT C, WHERE C IS SOME
C                        POINT WITHIN THE LIMITS OF INTEGRATION.
C                        FOR UNEQUALLY SPACED ABSCISSAE THE ERROR
C                        IS PROPORTIONAL TO THE FOURTH DERIVATIVE
C                        OF F AT X TIMES THE FOURTH POWER OF THE
C                        MAXIMUM DISTANCE BETWEEN ADJACENT ABSCISSAE.
C **********************************************************************

C LOCAL
      DOUBLE PRECISION X(NUM)
      INTEGER I

C CREATE A 1D EQUALLY SPACED ARRAY
      DO I=1,NUM
         X(I) = DBLE(I-1)*DX
      END DO

C INVOKE THE SIMPSON RULE FOR UNEQUALLY SPACED DATA
      CALL DSIMPNE2(NUM,X,Y,ANS)

      RETURN
      END
C ========================================================
C NCLFORTSTART
      SUBROUTINE DSIMPNE(NUM,X,Y,YMSG,ANS)
      IMPLICIT NONE
      INTEGER  NUM
      DOUBLE PRECISION X(NUM), Y(NUM), ANS, YMSG
C NCLEND
      INTEGER N,NUSE
      DOUBLE PRECISION XX(NUM), YY(NUM)

C STRIP MSG VALUES
      NUSE = 0
      DO N=1,NUM
         IF (Y(N).NE.YMSG) THEN
             NUSE = NUSE + 1
             XX(NUSE) = X(N)
             YY(NUSE) = Y(N)
         END IF
      END DO

      CALL DSIMPNE2(NUSE,XX,YY,ANS)

      RETURN
      END
C ---------------------------------------------------------
      SUBROUTINE DSIMPNE2(NUM,X,Y,ANS)
      IMPLICIT NONE
      INTEGER  NUM
      DOUBLE PRECISION X(NUM), Y(NUM), ANS
C
C SOURCE                 NCAR's NSSL [simpne.f]
C
C DIMENSION OF           X(NUM),Y(NUM)
C ARGUMENTS
C
C PURPOSE                TO INTEGRATE OVER A GIVEN SET OF ORDINATES
C                        BY ANALYTICALLY INTEGRATING A 3-POINT
C                        LAGRANGIAN INTERPOLATION POLYNOMIAL
C                        FITTING THE ORDINATES.
C
C ARGUMENTS
C
C ON INPUT               X
C                          THIS IS A VECTOR OF LENGTH NUM SPECIFYING
C                          THE UNEQUALLY SPACED ABSCISSAS.
C
C                        Y
C                          VECTOR OF ORDINATES.
C
C                        NUM
C                          LENGTH OF VECTOR Y (SHOULD BE .GT. 2).
C
C **********************************************************************
      DOUBLE PRECISION DEL(3),PI(3),G(3),THIRD,HALF,TWO3R
      DOUBLE PRECISION X1,X2,X3,E,F,FEINTS,DELPRD,SUMT
      INTEGER IER,N,I

      IF (NUM.LE.2) THEN
          IER = 32
          ANS = -9999.D0
          RETURN
      END IF

      IER = 0
      N   = 1
      ANS = 0.D0

      THIRD = 1.D0/3.D0
      HALF  = 1.D0/2.D0
      TWO3R = 2.D0/3.D0

  105 CONTINUE
      X1 = X(N)
      X2 = X(N+1)
      X3 = X(N+2)
      E  = X3*X3 - X1*X1
      F  = X3*X3*X3 - X1*X1*X1
      FEINTS = X3 - X1
      DEL(1) = X3 - X2
      DEL(2) = -FEINTS
      DEL(3) = X2 - X1
      G(1)   = X2 + X3
      G(2)   = X1 + X3
      G(3)   = X1 + X2
      PI(1)  = X2*X3
      PI(2)  = X1*X3
      PI(3)  = X1*X2
      DELPRD = DEL(1)*DEL(2)*DEL(3)

      SUMT = 0.D0
      DO I = 1,3
          SUMT = SUMT + Y(N-1+I)*DEL(I)*
     +           (THIRD*F-G(I)*HALF*E+PI(I)*FEINTS)
      END DO
      ANS = ANS - SUMT/DELPRD

      N = N + 2
      IF (NUM.GT. (N+1)) GO TO 105

      IF (MOD(NUM,2).NE.0) RETURN

      N  = NUM - 2
      X3 = X(NUM)
      X2 = X(NUM-1)
      X1 = X(NUM-2)
      E  = X3*X3 - X2*X2
      F  = X3*X3*X3 - X2*X2*X2
      FEINTS = X3 - X2
      DEL(1) = FEINTS
      DEL(2) = X1 - X3
      DEL(3) = X2 - X1
      G(1)   = X2 + X3
      G(2)   = X1 + X3
      G(3)   = X1 + X2
      PI(1)  = X2*X3
      PI(2)  = X1*X3
      PI(3)  = X1*X2
      DELPRD = DEL(1)*DEL(2)*DEL(3)

  107 SUMT = 0.D0
      DO I = 1,3
          SUMT = SUMT + Y(N-1+I)*DEL(I)*
     +           (THIRD*F-G(I)*HALF*E+PI(I)*FEINTS)
      END DO

      ANS = ANS - SUMT/DELPRD
      RETURN
      END

C
C $Id: mdpiqd.f,v 1.9 2008-09-18 00:42:17 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MDPIQD
C
C Declare required common blocks.  See MAPBDX for descriptions of these
C common blocks and the variables in them.
C
        COMMON /MAPCMP/  NPTB,XPTB(50),YPTB(50)
        INTEGER          NPTB
        REAL             XPTB,YPTB
        SAVE   /MAPCMP/
C
C Check for an uncleared prior error.
C
        IF (ICFELL('MDPIQD - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C Flush the points buffer.
C
        IF (NPTB.GT.0) THEN
          CALL POINTS (XPTB,YPTB,NPTB,0,0)
          IF (ICFELL('MDPIQD',2).NE.0) RETURN
          NPTB=0
        END IF
C
C Flush the buffer in DASHPACK.
C
        CALL DPLAST
        IF (ICFELL('MDPIQD',3).NE.0) RETURN
C
C Done.
C
        RETURN
C
      END

      PROGRAM ELBLBA
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
        PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Declare an array to hold the GKS "aspect source flags".
C
        DIMENSION IASF(13)
C
C Declare the arrays to hold the list of indices and the lists of labels
C required by the label-bar routine.
C
        DIMENSION LND1(20),LND2(16),LND3(16)
C
        CHARACTER*12 LLB1(20)
        CHARACTER*10 LLB2(17)
        CHARACTER*1  LLB3(16)
C
C Initialize the values in the aspect-source-flag array.
C
        DATA IASF / 13*1 /
C
C Define the list of indices required by the label-bar routine.
C
        DATA LND1 / 1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20 /
        DATA LND2 / 0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15 /
        DATA LND3 / 12,13,14,15,8,9,10,11,4,5,6,7,0,1,2,3 /
C
C Define labels for various bars.
C
        DATA LLB1 /   '0 to 5:H2Q', '5 to 10:H1Q','10 to 15:H1Q',
     +              '15 to 20:H1Q','20 to 25:H1Q','25 to 30:H1Q',
     +              '30 to 35:H1Q','35 to 40:H1Q','40 to 45:H1Q',
     +              '45 to 50:H1Q','50 to 55:H1Q','55 to 60:H1Q',
     +              '60 to 65:H1Q','65 to 70:H1Q','70 to 75:H1Q',
     +              '75 to 80:H1Q','80 to 85:H1Q','85 to 90:H1Q',
     +              '90 to 95:H1Q','95 to 100'   /
C
        DATA LLB2 / '-2000 feet',' Sea level',' 2000 feet',
     +              ' 4000 feet',' 6000 feet',' 8000 feet',
     +              '10000 feet','12000 feet','14000 feet',
     +              '16000 feet','18000 feet','20000 feet',
     +              '22000 feet','24000 feet','26000 feet',
     +              '28000 feet','30000 feet'/
C
        DATA LLB3 / 'M','N','O','P','I','J','K','L','E','F','G','H',
     +              'A','B','C','D'/
C
C Open GKS.
C
        CALL GOPKS (IERRF, ISZDM)
        CALL GOPWK (IWKID, LUNIT, IWTYPE)
        CALL GACWK (IWKID)
C
C Turn off the clipping indicator.
C
        CALL GSCLIP (0)
C
C Set all the GKS aspect source flags to "individual".
C
        CALL GSASF (IASF)
C
C Force solid fill.
C
        CALL GSFAIS (1)
C
C Define color indices.
C
        CALL DFCLRS(IWKID)
C
C Force PLOTCHAR to use constant spacing of characters.
C
        CALL PCSETR ('CS - CONSTANT SPACING',1.25)
C
C Set some parameter values.
C
        CALL LBSETR ('WBL - WIDTH OF BOX LINES',4.)
        CALL LBSETR ('WFL - WIDTH OF FILL LINES',2.)
        CALL LBSETR ('WLB - WIDTH OF LABEL LINES',2.)
C
C Put the first label bar vertically along the left edge of the plotter
C frame.  Use patterns.
C
        CALL SFSETI ('ANGLE OF FILL LINES',15)
        CALL SFSETI ('TYPE OF FILL',-4)
        CALL LBLBAR (1,.05,.30,.05,.95,20,.3333,1.,LND1,0,LLB1,20,2)
C
C Put the second label bar vertically along the right edge.  Use solid
C color fill.
C
        CALL SFSETI ('TYPE OF FILL',0)
        CALL LBLBAR (1,.70,.95,.05,.95,16,.3333,1.,LND2,0,LLB2,17,1)
C
C The remaining label bars are arranged horizontally in such a way as
C to form a rectangular key for color indices 1 through 12.  The
C default version of LBFILL is used.
C
        CALL LBLBAR (0,.35,.65,.05,.20,4,.5,.5,LND3( 1),1,LLB3( 1),4,1)
        CALL LBLBAR (0,.35,.65,.20,.35,4,.5,.5,LND3( 5),1,LLB3( 5),4,1)
        CALL LBLBAR (0,.35,.65,.35,.50,4,.5,.5,LND3( 9),1,LLB3( 9),4,1)
        CALL LBLBAR (0,.35,.65,.50,.65,4,.5,.5,LND3(13),1,LLB3(13),4,1)
C
C Put a title on the plot.  We must first call SET to define the ranges
C of the X and Y coordinates to be used.  The constant spacing feature
C is turned off so that the title will look normal.
C
        CALL SET (0.,1.,0.,1.,0.,1.,0.,1.,1)
        CALL PCSETR ('CS - CONSTANT SPACING',0.)
        CALL PLCHHQ (.5,.90,'THREE',.025,0.,0.)
        CALL PLCHHQ (.5,.85,'LABELBAR',.025,0.,0.)
        CALL PLCHHQ (.5,.80,'EXAMPLES',.025,0.,0.)
C
C Advance the frame.
C
        CALL FRAME
C
C Close GKS.
C
        CALL GDAWK (IWKID)
        CALL GCLWK (IWKID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END
      SUBROUTINE DFCLRS(IWKID)
C
C Define a set of RGB color triples for colors 1 through 15.
C
        DIMENSION RGBV(3,15)
C
C Define the RGB color triples needed below.
C
        DATA RGBV / 1.00 , 1.00 , 1.00 ,
     +              0.70 , 0.70 , 0.70 ,
     +              0.75 , 0.50 , 1.00 ,
     +              0.50 , 0.00 , 1.00 ,
     +              0.00 , 0.00 , 1.00 ,
     +              0.00 , 0.50 , 1.00 ,
     +              0.00 , 1.00 , 1.00 ,
     +              0.00 , 1.00 , 0.60 ,
     +              0.00 , 1.00 , 0.00 ,
     +              0.70 , 1.00 , 0.00 ,
     +              1.00 , 1.00 , 0.00 ,
     +              1.00 , 0.75 , 0.00 ,
     +              1.00 , 0.38 , 0.38 ,
     +              1.00 , 0.00 , 0.38 ,
     +              1.00 , 0.00 , 0.00 /
C
C Define 16 different color indices, for indices 0 through 15.  The
C color corresponding to index 0 is black and the color corresponding
C to index 1 is white.
C
        CALL GSCR (IWKID,0,0.,0.,0.)
C
        DO 101 I=1,15
          CALL GSCR (IWKID,I,RGBV(1,I),RGBV(2,I),RGBV(3,I))
  101   CONTINUE
C
C Done.
C
        RETURN
C
      END

      SUBROUTINE ZGELSS( M, N, NRHS, A, LDA, B, LDB, S, RCOND, RANK,
     $                   WORK, LWORK, RWORK, INFO )
*
*  -- LAPACK driver routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     October 31, 1999
*
*     .. Scalar Arguments ..
      INTEGER            INFO, LDA, LDB, LWORK, M, N, NRHS, RANK
      DOUBLE PRECISION   RCOND
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   RWORK( * ), S( * )
      COMPLEX*16         A( LDA, * ), B( LDB, * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  ZGELSS computes the minimum norm solution to a complex linear
*  least squares problem:
*
*  Minimize 2-norm(| b - A*x |).
*
*  using the singular value decomposition (SVD) of A. A is an M-by-N
*  matrix which may be rank-deficient.
*
*  Several right hand side vectors b and solution vectors x can be
*  handled in a single call; they are stored as the columns of the
*  M-by-NRHS right hand side matrix B and the N-by-NRHS solution matrix
*  X.
*
*  The effective rank of A is determined by treating as zero those
*  singular values which are less than RCOND times the largest singular
*  value.
*
*  Arguments
*  =========
*
*  M       (input) INTEGER
*          The number of rows of the matrix A. M >= 0.
*
*  N       (input) INTEGER
*          The number of columns of the matrix A. N >= 0.
*
*  NRHS    (input) INTEGER
*          The number of right hand sides, i.e., the number of columns
*          of the matrices B and X. NRHS >= 0.
*
*  A       (input/output) COMPLEX*16 array, dimension (LDA,N)
*          On entry, the M-by-N matrix A.
*          On exit, the first min(m,n) rows of A are overwritten with
*          its right singular vectors, stored rowwise.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A. LDA >= max(1,M).
*
*  B       (input/output) COMPLEX*16 array, dimension (LDB,NRHS)
*          On entry, the M-by-NRHS right hand side matrix B.
*          On exit, B is overwritten by the N-by-NRHS solution matrix X.
*          If m >= n and RANK = n, the residual sum-of-squares for
*          the solution in the i-th column is given by the sum of
*          squares of elements n+1:m in that column.
*
*  LDB     (input) INTEGER
*          The leading dimension of the array B.  LDB >= max(1,M,N).
*
*  S       (output) DOUBLE PRECISION array, dimension (min(M,N))
*          The singular values of A in decreasing order.
*          The condition number of A in the 2-norm = S(1)/S(min(m,n)).
*
*  RCOND   (input) DOUBLE PRECISION
*          RCOND is used to determine the effective rank of A.
*          Singular values S(i) <= RCOND*S(1) are treated as zero.
*          If RCOND < 0, machine precision is used instead.
*
*  RANK    (output) INTEGER
*          The effective rank of A, i.e., the number of singular values
*          which are greater than RCOND*S(1).
*
*  WORK    (workspace/output) COMPLEX*16 array, dimension (LWORK)
*          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*
*  LWORK   (input) INTEGER
*          The dimension of the array WORK. LWORK >= 1, and also:
*          LWORK >=  2*min(M,N) + max(M,N,NRHS)
*          For good performance, LWORK should generally be larger.
*
*          If LWORK = -1, then a workspace query is assumed; the routine
*          only calculates the optimal size of the WORK array, returns
*          this value as the first entry of the WORK array, and no error
*          message related to LWORK is issued by XERBLA.
*
*  RWORK   (workspace) DOUBLE PRECISION array, dimension (5*min(M,N))
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value.
*          > 0:  the algorithm for computing the SVD failed to converge;
*                if INFO = i, i off-diagonal elements of an intermediate
*                bidiagonal form did not converge to zero.
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO, ONE
      PARAMETER          ( ZERO = 0.0D+0, ONE = 1.0D+0 )
      COMPLEX*16         CZERO, CONE
      PARAMETER          ( CZERO = ( 0.0D+0, 0.0D+0 ),
     $                   CONE = ( 1.0D+0, 0.0D+0 ) )
*     ..
*     .. Local Scalars ..
      LOGICAL            LQUERY
      INTEGER            BL, CHUNK, I, IASCL, IBSCL, IE, IL, IRWORK,
     $                   ITAU, ITAUP, ITAUQ, IWORK, LDWORK, MAXMN,
     $                   MAXWRK, MINMN, MINWRK, MM, MNTHR
      DOUBLE PRECISION   ANRM, BIGNUM, BNRM, EPS, SFMIN, SMLNUM, THR
*     ..
*     .. Local Arrays ..
      COMPLEX*16         VDUM( 1 )
*     ..
*     .. External Subroutines ..
      EXTERNAL           DLABAD, DLASCL, DLASET, XERBLA, ZBDSQR, ZCOPY,
     $                   ZDRSCL, ZGEBRD, ZGELQF, ZGEMM, ZGEMV, ZGEQRF,
     $                   ZLACPY, ZLASCL, ZLASET, ZUNGBR, ZUNMBR, ZUNMLQ,
     $                   ZUNMQR
*     ..
*     .. External Functions ..
      INTEGER            ILAENV
      DOUBLE PRECISION   DLAMCH, ZLANGE
      EXTERNAL           ILAENV, DLAMCH, ZLANGE
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN
*     ..
*     .. Executable Statements ..
*
*     Test the input arguments
*
      INFO = 0
      MINMN = MIN( M, N )
      MAXMN = MAX( M, N )
      MNTHR = ILAENV( 6, 'ZGELSS', ' ', M, N, NRHS, -1 )
      LQUERY = ( LWORK.EQ.-1 )
      IF( M.LT.0 ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( NRHS.LT.0 ) THEN
         INFO = -3
      ELSE IF( LDA.LT.MAX( 1, M ) ) THEN
         INFO = -5
      ELSE IF( LDB.LT.MAX( 1, MAXMN ) ) THEN
         INFO = -7
      END IF
*
*     Compute workspace
*      (Note: Comments in the code beginning "Workspace:" describe the
*       minimal amount of workspace needed at that point in the code,
*       as well as the preferred amount for good performance.
*       CWorkspace refers to complex workspace, and RWorkspace refers
*       to real workspace. NB refers to the optimal block size for the
*       immediately following subroutine, as returned by ILAENV.)
*
      MINWRK = 1
      IF( INFO.EQ.0 .AND. ( LWORK.GE.1 .OR. LQUERY ) ) THEN
         MAXWRK = 0
         MM = M
         IF( M.GE.N .AND. M.GE.MNTHR ) THEN
*
*           Path 1a - overdetermined, with many more rows than columns
*
*           Space needed for ZBDSQR is BDSPAC = 5*N
*
            MM = N
            MAXWRK = MAX( MAXWRK, N+N*ILAENV( 1, 'ZGEQRF', ' ', M, N,
     $               -1, -1 ) )
            MAXWRK = MAX( MAXWRK, N+NRHS*
     $               ILAENV( 1, 'ZUNMQR', 'LC', M, NRHS, N, -1 ) )
         END IF
         IF( M.GE.N ) THEN
*
*           Path 1 - overdetermined or exactly determined
*
*           Space needed for ZBDSQR is BDSPC = 7*N+12
*
            MAXWRK = MAX( MAXWRK, 2*N+( MM+N )*
     $               ILAENV( 1, 'ZGEBRD', ' ', MM, N, -1, -1 ) )
            MAXWRK = MAX( MAXWRK, 2*N+NRHS*
     $               ILAENV( 1, 'ZUNMBR', 'QLC', MM, NRHS, N, -1 ) )
            MAXWRK = MAX( MAXWRK, 2*N+( N-1 )*
     $               ILAENV( 1, 'ZUNGBR', 'P', N, N, N, -1 ) )
            MAXWRK = MAX( MAXWRK, N*NRHS )
            MINWRK = 2*N + MAX( NRHS, M )
         END IF
         IF( N.GT.M ) THEN
            MINWRK = 2*M + MAX( NRHS, N )
            IF( N.GE.MNTHR ) THEN
*
*              Path 2a - underdetermined, with many more columns
*              than rows
*
*              Space needed for ZBDSQR is BDSPAC = 5*M
*
               MAXWRK = M + M*ILAENV( 1, 'ZGELQF', ' ', M, N, -1, -1 )
               MAXWRK = MAX( MAXWRK, 3*M+M*M+2*M*
     $                  ILAENV( 1, 'ZGEBRD', ' ', M, M, -1, -1 ) )
               MAXWRK = MAX( MAXWRK, 3*M+M*M+NRHS*
     $                  ILAENV( 1, 'ZUNMBR', 'QLC', M, NRHS, M, -1 ) )
               MAXWRK = MAX( MAXWRK, 3*M+M*M+( M-1 )*
     $                  ILAENV( 1, 'ZUNGBR', 'P', M, M, M, -1 ) )
               IF( NRHS.GT.1 ) THEN
                  MAXWRK = MAX( MAXWRK, M*M+M+M*NRHS )
               ELSE
                  MAXWRK = MAX( MAXWRK, M*M+2*M )
               END IF
               MAXWRK = MAX( MAXWRK, M+NRHS*
     $                  ILAENV( 1, 'ZUNMLQ', 'LC', N, NRHS, M, -1 ) )
            ELSE
*
*              Path 2 - underdetermined
*
*              Space needed for ZBDSQR is BDSPAC = 5*M
*
               MAXWRK = 2*M + ( N+M )*ILAENV( 1, 'ZGEBRD', ' ', M, N,
     $                  -1, -1 )
               MAXWRK = MAX( MAXWRK, 2*M+NRHS*
     $                  ILAENV( 1, 'ZUNMBR', 'QLC', M, NRHS, M, -1 ) )
               MAXWRK = MAX( MAXWRK, 2*M+M*
     $                  ILAENV( 1, 'ZUNGBR', 'P', M, N, M, -1 ) )
               MAXWRK = MAX( MAXWRK, N*NRHS )
            END IF
         END IF
         MINWRK = MAX( MINWRK, 1 )
         MAXWRK = MAX( MINWRK, MAXWRK )
         WORK( 1 ) = MAXWRK
      END IF
*
      IF( LWORK.LT.MINWRK .AND. .NOT.LQUERY )
     $   INFO = -12
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'ZGELSS', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( M.EQ.0 .OR. N.EQ.0 ) THEN
         RANK = 0
         RETURN
      END IF
*
*     Get machine parameters
*
      EPS = DLAMCH( 'P' )
      SFMIN = DLAMCH( 'S' )
      SMLNUM = SFMIN / EPS
      BIGNUM = ONE / SMLNUM
      CALL DLABAD( SMLNUM, BIGNUM )
*
*     Scale A if max element outside range [SMLNUM,BIGNUM]
*
      ANRM = ZLANGE( 'M', M, N, A, LDA, RWORK )
      IASCL = 0
      IF( ANRM.GT.ZERO .AND. ANRM.LT.SMLNUM ) THEN
*
*        Scale matrix norm up to SMLNUM
*
         CALL ZLASCL( 'G', 0, 0, ANRM, SMLNUM, M, N, A, LDA, INFO )
         IASCL = 1
      ELSE IF( ANRM.GT.BIGNUM ) THEN
*
*        Scale matrix norm down to BIGNUM
*
         CALL ZLASCL( 'G', 0, 0, ANRM, BIGNUM, M, N, A, LDA, INFO )
         IASCL = 2
      ELSE IF( ANRM.EQ.ZERO ) THEN
*
*        Matrix all zero. Return zero solution.
*
         CALL ZLASET( 'F', MAX( M, N ), NRHS, CZERO, CZERO, B, LDB )
         CALL DLASET( 'F', MINMN, 1, ZERO, ZERO, S, MINMN )
         RANK = 0
         GO TO 70
      END IF
*
*     Scale B if max element outside range [SMLNUM,BIGNUM]
*
      BNRM = ZLANGE( 'M', M, NRHS, B, LDB, RWORK )
      IBSCL = 0
      IF( BNRM.GT.ZERO .AND. BNRM.LT.SMLNUM ) THEN
*
*        Scale matrix norm up to SMLNUM
*
         CALL ZLASCL( 'G', 0, 0, BNRM, SMLNUM, M, NRHS, B, LDB, INFO )
         IBSCL = 1
      ELSE IF( BNRM.GT.BIGNUM ) THEN
*
*        Scale matrix norm down to BIGNUM
*
         CALL ZLASCL( 'G', 0, 0, BNRM, BIGNUM, M, NRHS, B, LDB, INFO )
         IBSCL = 2
      END IF
*
*     Overdetermined case
*
      IF( M.GE.N ) THEN
*
*        Path 1 - overdetermined or exactly determined
*
         MM = M
         IF( M.GE.MNTHR ) THEN
*
*           Path 1a - overdetermined, with many more rows than columns
*
            MM = N
            ITAU = 1
            IWORK = ITAU + N
*
*           Compute A=Q*R
*           (CWorkspace: need 2*N, prefer N+N*NB)
*           (RWorkspace: none)
*
            CALL ZGEQRF( M, N, A, LDA, WORK( ITAU ), WORK( IWORK ),
     $                   LWORK-IWORK+1, INFO )
*
*           Multiply B by transpose(Q)
*           (CWorkspace: need N+NRHS, prefer N+NRHS*NB)
*           (RWorkspace: none)
*
            CALL ZUNMQR( 'L', 'C', M, NRHS, N, A, LDA, WORK( ITAU ), B,
     $                   LDB, WORK( IWORK ), LWORK-IWORK+1, INFO )
*
*           Zero out below R
*
            IF( N.GT.1 )
     $         CALL ZLASET( 'L', N-1, N-1, CZERO, CZERO, A( 2, 1 ),
     $                      LDA )
         END IF
*
         IE = 1
         ITAUQ = 1
         ITAUP = ITAUQ + N
         IWORK = ITAUP + N
*
*        Bidiagonalize R in A
*        (CWorkspace: need 2*N+MM, prefer 2*N+(MM+N)*NB)
*        (RWorkspace: need N)
*
         CALL ZGEBRD( MM, N, A, LDA, S, RWORK( IE ), WORK( ITAUQ ),
     $                WORK( ITAUP ), WORK( IWORK ), LWORK-IWORK+1,
     $                INFO )
*
*        Multiply B by transpose of left bidiagonalizing vectors of R
*        (CWorkspace: need 2*N+NRHS, prefer 2*N+NRHS*NB)
*        (RWorkspace: none)
*
         CALL ZUNMBR( 'Q', 'L', 'C', MM, NRHS, N, A, LDA, WORK( ITAUQ ),
     $                B, LDB, WORK( IWORK ), LWORK-IWORK+1, INFO )
*
*        Generate right bidiagonalizing vectors of R in A
*        (CWorkspace: need 3*N-1, prefer 2*N+(N-1)*NB)
*        (RWorkspace: none)
*
         CALL ZUNGBR( 'P', N, N, N, A, LDA, WORK( ITAUP ),
     $                WORK( IWORK ), LWORK-IWORK+1, INFO )
         IRWORK = IE + N
*
*        Perform bidiagonal QR iteration
*          multiply B by transpose of left singular vectors
*          compute right singular vectors in A
*        (CWorkspace: none)
*        (RWorkspace: need BDSPAC)
*
         CALL ZBDSQR( 'U', N, N, 0, NRHS, S, RWORK( IE ), A, LDA, VDUM,
     $                1, B, LDB, RWORK( IRWORK ), INFO )
         IF( INFO.NE.0 )
     $      GO TO 70
*
*        Multiply B by reciprocals of singular values
*
         THR = MAX( RCOND*S( 1 ), SFMIN )
         IF( RCOND.LT.ZERO )
     $      THR = MAX( EPS*S( 1 ), SFMIN )
         RANK = 0
         DO 10 I = 1, N
            IF( S( I ).GT.THR ) THEN
               CALL ZDRSCL( NRHS, S( I ), B( I, 1 ), LDB )
               RANK = RANK + 1
            ELSE
               CALL ZLASET( 'F', 1, NRHS, CZERO, CZERO, B( I, 1 ), LDB )
            END IF
   10    CONTINUE
*
*        Multiply B by right singular vectors
*        (CWorkspace: need N, prefer N*NRHS)
*        (RWorkspace: none)
*
         IF( LWORK.GE.LDB*NRHS .AND. NRHS.GT.1 ) THEN
            CALL ZGEMM( 'C', 'N', N, NRHS, N, CONE, A, LDA, B, LDB,
     $                  CZERO, WORK, LDB )
            CALL ZLACPY( 'G', N, NRHS, WORK, LDB, B, LDB )
         ELSE IF( NRHS.GT.1 ) THEN
            CHUNK = LWORK / N
            DO 20 I = 1, NRHS, CHUNK
               BL = MIN( NRHS-I+1, CHUNK )
               CALL ZGEMM( 'C', 'N', N, BL, N, CONE, A, LDA, B( 1, I ),
     $                     LDB, CZERO, WORK, N )
               CALL ZLACPY( 'G', N, BL, WORK, N, B( 1, I ), LDB )
   20       CONTINUE
         ELSE
            CALL ZGEMV( 'C', N, N, CONE, A, LDA, B, 1, CZERO, WORK, 1 )
            CALL ZCOPY( N, WORK, 1, B, 1 )
         END IF
*
      ELSE IF( N.GE.MNTHR .AND. LWORK.GE.3*M+M*M+MAX( M, NRHS, N-2*M ) )
     $          THEN
*
*        Underdetermined case, M much less than N
*
*        Path 2a - underdetermined, with many more columns than rows
*        and sufficient workspace for an efficient algorithm
*
         LDWORK = M
         IF( LWORK.GE.3*M+M*LDA+MAX( M, NRHS, N-2*M ) )
     $      LDWORK = LDA
         ITAU = 1
         IWORK = M + 1
*
*        Compute A=L*Q
*        (CWorkspace: need 2*M, prefer M+M*NB)
*        (RWorkspace: none)
*
         CALL ZGELQF( M, N, A, LDA, WORK( ITAU ), WORK( IWORK ),
     $                LWORK-IWORK+1, INFO )
         IL = IWORK
*
*        Copy L to WORK(IL), zeroing out above it
*
         CALL ZLACPY( 'L', M, M, A, LDA, WORK( IL ), LDWORK )
         CALL ZLASET( 'U', M-1, M-1, CZERO, CZERO, WORK( IL+LDWORK ),
     $                LDWORK )
         IE = 1
         ITAUQ = IL + LDWORK*M
         ITAUP = ITAUQ + M
         IWORK = ITAUP + M
*
*        Bidiagonalize L in WORK(IL)
*        (CWorkspace: need M*M+4*M, prefer M*M+3*M+2*M*NB)
*        (RWorkspace: need M)
*
         CALL ZGEBRD( M, M, WORK( IL ), LDWORK, S, RWORK( IE ),
     $                WORK( ITAUQ ), WORK( ITAUP ), WORK( IWORK ),
     $                LWORK-IWORK+1, INFO )
*
*        Multiply B by transpose of left bidiagonalizing vectors of L
*        (CWorkspace: need M*M+3*M+NRHS, prefer M*M+3*M+NRHS*NB)
*        (RWorkspace: none)
*
         CALL ZUNMBR( 'Q', 'L', 'C', M, NRHS, M, WORK( IL ), LDWORK,
     $                WORK( ITAUQ ), B, LDB, WORK( IWORK ),
     $                LWORK-IWORK+1, INFO )
*
*        Generate right bidiagonalizing vectors of R in WORK(IL)
*        (CWorkspace: need M*M+4*M-1, prefer M*M+3*M+(M-1)*NB)
*        (RWorkspace: none)
*
         CALL ZUNGBR( 'P', M, M, M, WORK( IL ), LDWORK, WORK( ITAUP ),
     $                WORK( IWORK ), LWORK-IWORK+1, INFO )
         IRWORK = IE + M
*
*        Perform bidiagonal QR iteration, computing right singular
*        vectors of L in WORK(IL) and multiplying B by transpose of
*        left singular vectors
*        (CWorkspace: need M*M)
*        (RWorkspace: need BDSPAC)
*
         CALL ZBDSQR( 'U', M, M, 0, NRHS, S, RWORK( IE ), WORK( IL ),
     $                LDWORK, A, LDA, B, LDB, RWORK( IRWORK ), INFO )
         IF( INFO.NE.0 )
     $      GO TO 70
*
*        Multiply B by reciprocals of singular values
*
         THR = MAX( RCOND*S( 1 ), SFMIN )
         IF( RCOND.LT.ZERO )
     $      THR = MAX( EPS*S( 1 ), SFMIN )
         RANK = 0
         DO 30 I = 1, M
            IF( S( I ).GT.THR ) THEN
               CALL ZDRSCL( NRHS, S( I ), B( I, 1 ), LDB )
               RANK = RANK + 1
            ELSE
               CALL ZLASET( 'F', 1, NRHS, CZERO, CZERO, B( I, 1 ), LDB )
            END IF
   30    CONTINUE
         IWORK = IL + M*LDWORK
*
*        Multiply B by right singular vectors of L in WORK(IL)
*        (CWorkspace: need M*M+2*M, prefer M*M+M+M*NRHS)
*        (RWorkspace: none)
*
         IF( LWORK.GE.LDB*NRHS+IWORK-1 .AND. NRHS.GT.1 ) THEN
            CALL ZGEMM( 'C', 'N', M, NRHS, M, CONE, WORK( IL ), LDWORK,
     $                  B, LDB, CZERO, WORK( IWORK ), LDB )
            CALL ZLACPY( 'G', M, NRHS, WORK( IWORK ), LDB, B, LDB )
         ELSE IF( NRHS.GT.1 ) THEN
            CHUNK = ( LWORK-IWORK+1 ) / M
            DO 40 I = 1, NRHS, CHUNK
               BL = MIN( NRHS-I+1, CHUNK )
               CALL ZGEMM( 'C', 'N', M, BL, M, CONE, WORK( IL ), LDWORK,
     $                     B( 1, I ), LDB, CZERO, WORK( IWORK ), N )
               CALL ZLACPY( 'G', M, BL, WORK( IWORK ), N, B( 1, I ),
     $                      LDB )
   40       CONTINUE
         ELSE
            CALL ZGEMV( 'C', M, M, CONE, WORK( IL ), LDWORK, B( 1, 1 ),
     $                  1, CZERO, WORK( IWORK ), 1 )
            CALL ZCOPY( M, WORK( IWORK ), 1, B( 1, 1 ), 1 )
         END IF
*
*        Zero out below first M rows of B
*
         CALL ZLASET( 'F', N-M, NRHS, CZERO, CZERO, B( M+1, 1 ), LDB )
         IWORK = ITAU + M
*
*        Multiply transpose(Q) by B
*        (CWorkspace: need M+NRHS, prefer M+NHRS*NB)
*        (RWorkspace: none)
*
         CALL ZUNMLQ( 'L', 'C', N, NRHS, M, A, LDA, WORK( ITAU ), B,
     $                LDB, WORK( IWORK ), LWORK-IWORK+1, INFO )
*
      ELSE
*
*        Path 2 - remaining underdetermined cases
*
         IE = 1
         ITAUQ = 1
         ITAUP = ITAUQ + M
         IWORK = ITAUP + M
*
*        Bidiagonalize A
*        (CWorkspace: need 3*M, prefer 2*M+(M+N)*NB)
*        (RWorkspace: need N)
*
         CALL ZGEBRD( M, N, A, LDA, S, RWORK( IE ), WORK( ITAUQ ),
     $                WORK( ITAUP ), WORK( IWORK ), LWORK-IWORK+1,
     $                INFO )
*
*        Multiply B by transpose of left bidiagonalizing vectors
*        (CWorkspace: need 2*M+NRHS, prefer 2*M+NRHS*NB)
*        (RWorkspace: none)
*
         CALL ZUNMBR( 'Q', 'L', 'C', M, NRHS, N, A, LDA, WORK( ITAUQ ),
     $                B, LDB, WORK( IWORK ), LWORK-IWORK+1, INFO )
*
*        Generate right bidiagonalizing vectors in A
*        (CWorkspace: need 3*M, prefer 2*M+M*NB)
*        (RWorkspace: none)
*
         CALL ZUNGBR( 'P', M, N, M, A, LDA, WORK( ITAUP ),
     $                WORK( IWORK ), LWORK-IWORK+1, INFO )
         IRWORK = IE + M
*
*        Perform bidiagonal QR iteration,
*           computing right singular vectors of A in A and
*           multiplying B by transpose of left singular vectors
*        (CWorkspace: none)
*        (RWorkspace: need BDSPAC)
*
         CALL ZBDSQR( 'L', M, N, 0, NRHS, S, RWORK( IE ), A, LDA, VDUM,
     $                1, B, LDB, RWORK( IRWORK ), INFO )
         IF( INFO.NE.0 )
     $      GO TO 70
*
*        Multiply B by reciprocals of singular values
*
         THR = MAX( RCOND*S( 1 ), SFMIN )
         IF( RCOND.LT.ZERO )
     $      THR = MAX( EPS*S( 1 ), SFMIN )
         RANK = 0
         DO 50 I = 1, M
            IF( S( I ).GT.THR ) THEN
               CALL ZDRSCL( NRHS, S( I ), B( I, 1 ), LDB )
               RANK = RANK + 1
            ELSE
               CALL ZLASET( 'F', 1, NRHS, CZERO, CZERO, B( I, 1 ), LDB )
            END IF
   50    CONTINUE
*
*        Multiply B by right singular vectors of A
*        (CWorkspace: need N, prefer N*NRHS)
*        (RWorkspace: none)
*
         IF( LWORK.GE.LDB*NRHS .AND. NRHS.GT.1 ) THEN
            CALL ZGEMM( 'C', 'N', N, NRHS, M, CONE, A, LDA, B, LDB,
     $                  CZERO, WORK, LDB )
            CALL ZLACPY( 'G', N, NRHS, WORK, LDB, B, LDB )
         ELSE IF( NRHS.GT.1 ) THEN
            CHUNK = LWORK / N
            DO 60 I = 1, NRHS, CHUNK
               BL = MIN( NRHS-I+1, CHUNK )
               CALL ZGEMM( 'C', 'N', N, BL, M, CONE, A, LDA, B( 1, I ),
     $                     LDB, CZERO, WORK, N )
               CALL ZLACPY( 'F', N, BL, WORK, N, B( 1, I ), LDB )
   60       CONTINUE
         ELSE
            CALL ZGEMV( 'C', M, N, CONE, A, LDA, B, 1, CZERO, WORK, 1 )
            CALL ZCOPY( N, WORK, 1, B, 1 )
         END IF
      END IF
*
*     Undo scaling
*
      IF( IASCL.EQ.1 ) THEN
         CALL ZLASCL( 'G', 0, 0, ANRM, SMLNUM, N, NRHS, B, LDB, INFO )
         CALL DLASCL( 'G', 0, 0, SMLNUM, ANRM, MINMN, 1, S, MINMN,
     $                INFO )
      ELSE IF( IASCL.EQ.2 ) THEN
         CALL ZLASCL( 'G', 0, 0, ANRM, BIGNUM, N, NRHS, B, LDB, INFO )
         CALL DLASCL( 'G', 0, 0, BIGNUM, ANRM, MINMN, 1, S, MINMN,
     $                INFO )
      END IF
      IF( IBSCL.EQ.1 ) THEN
         CALL ZLASCL( 'G', 0, 0, SMLNUM, BNRM, N, NRHS, B, LDB, INFO )
      ELSE IF( IBSCL.EQ.2 ) THEN
         CALL ZLASCL( 'G', 0, 0, BIGNUM, BNRM, N, NRHS, B, LDB, INFO )
      END IF
   70 CONTINUE
      WORK( 1 ) = MAXWRK
      RETURN
*
*     End of ZGELSS
*
      END

C
C $Id: mpipan.f,v 1.8 2008-07-27 00:17:07 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      INTEGER FUNCTION MPIPAN (IAIN,ANME)
        INTEGER       IAIN
        CHARACTER*(*) ANME
        MPIPAN=MDIPAN(IAIN,ANME)
        RETURN
      END

C
C	$Id: giargs.f,v 1.5 2008-07-27 00:21:06 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GIARGS(UNIT, ARGS, STATUS)
C
C  This subroutine is in the generic package simply as a stub in order
C  to support a real routine of this name as part of the UNIX package.
C
      INTEGER UNIT, STATUS
      CHARACTER*(*) ARGS
      STATUS = 1
      RETURN
      END

C
C $Id: DATACOMMF.f,v 1.1 2001-10-09 00:18:34 haley Exp $
C
C****************************************************************
C                                                               *
C                       Copyright (C)  1994                     *
C       University Corporation for Atmospheric Research         *
C                       All Rights Reserved                     *
C                                                               *
C****************************************************************
C
C      File:            DATACOMM.f
C
C      Author:          Jeff W. Boote
C                       National Center for Atmospheric Research
C                       PO 3000, Boulder, Colorado
C
C      Date:            Fri Apr 15 16:51:43 MDT 1994
C
C      Description:     
C
      subroutine nhlfupdatedata(id_obj,ierr)
        call nhlfpupdatedata(id_obj,ierr)
      end
      subroutine nhlfadddata(id_plot,res_name,id_data,ierr)
        character*(*) res_name
        integer id_plot,id_data,ierr
        call nhlfpadddata(id_plot,res_name,len(res_name),id_data,ierr)
      end
      subroutine nhlfremovedata(id_plot,res_name,id_data,ierr)
        character*(*) res_name
        integer id_plot,id_data,ierr
        call nhlfpremovedata(id_plot,res_name,len(res_name),
     +                       id_data,ierr)
      end
      subroutine nhlfisdatacomm(id,istat)

        integer id,istat
        call nhlpfisdatacomm(id,istat)
      end
      subroutine nhlfisdataspec(id,istat)

        integer id,istat
        call nhlpfisdataspec(id,istat)
      end

C
C	$Id: fdvdld.f,v 1.6 2008-07-27 00:23:03 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE FDVDLD (IENTRY,IIX,IIY)
C
C Software dashed line package with character capability and smoothing
C
C PURPOSE                DASHSMTH is a software dashed line package with
C                        smoothing capabilities.  DASHSMTH is DASHCHAR
C                        with smoothing features added.
C
C USAGE                  First, either
C                             CALL DASHDB (IPAT)
C                        where IPAT is a 16-bit dash pattern as
C                        described in the subroutine DASHDB (see
C                        DASHLINE documentation), or
C                             CALL DASHDC (IPAT,JCRT,JSIZE)
C                        as described below.
C
C                        Then, call any of the following:
C                             CALL CURVED (X,Y,N)
C                             CALL FRSTD (X,Y)
C                             CALL VECTD (X,Y)
C                             CALL LASTD
C
C                        LASTD is called only after the last
C                        point of a line has been processed in VECTD.
C
C                        The following may also be called, but no
C                        smoothing will result:
C                             CALL LINED (XA,YA,XB,YB)
C
C
C ARGUMENTS              IPAT
C ON INPUT                 A character string of arbitrary length
C TO DASHDC                (60 characters seems to be a practical
C                          limit) which specifies the dash pattern
C                          to be used.  A dollar sign in IPAT
C                          indicates solid; an apostrophe indicates
C                          a gap; blanks are ignored.  Any character
C                          in IPAT which is not a dollar sign,
C                          apostrophe, or blank is considered to be
C                          part of a line label.  Each line label
C                          can be at most 15 characters in length.
C                          Sufficient white space is reserved in the
C                          dashed line for writing line labels.
C
C                        JCRT
C                          The length in plotter address units per
C                          $ or apostrophe.
C
C                        JSIZE
C                          Is the size of the plotted characters:
C                          . If between 0 and 3 , it is 1., 1.5, 2.
C                            and 3. times an 8 plotter address unit
C                            width.
C                          . If greater than 3, it is the character
C                            width in plotter address units.
C
C
C ARGUMENTS TO           CURVED(X,Y,N)
C OTHER LINE-DRAWING       X and Y are arrays of world coordinate values
C ROUTINES                 of length N or greater.  Line segments obeying
C                          the specified dash pattern are drawn to
C                          connect the N points.
C
C                        FRSTD(X,Y)
C                          The current pen position is set to
C                          the world coordinate value (X,Y)
C
C                        VECTD(X,Y)
C                          A line segment is drawn between the
C                          world coordinate value (X,Y) and the
C                          most recent pen position.  (X,Y) then
C                          becomes the most recent pen position.
C
C                        LINED(XA,XB,YA,YB)
C                          A line is drawn between world coordinate
C                          values (XA,YA) and (XB,YB).
C
C                        LASTD
C                          When using FRSTD and VECTD, LASTD must be
C                          called (no arguments needed).  LASTD sets up
C                          the calls to the smoothing routines MSKRV1
C                          and MSKRV2.
C
C ON OUTPUT                All arguments are unchanged for all routines.
C
C
C NOTE                     When switching from the regular plotting
C                          routines to a dashed line package the first
C                          call should not be to VECTD.
C
C ENTRY POINTS             DASHDB, DASHDC, CURVED, FRSTD, VECTD, LINED,
C                          RESET, LASTD, CFVLD, FDVDLD, DRAWPV, DASHBD,
C                          DASHBDX
C
C COMMON BLOCKS            INTPR, DASHD1, DASHD2, DDFLAG, DCFLAG, DSAVE1,
C                          DSAVE6, DSAVE3, DSAVE5, CFFLAG, SMFLAG, DFFLAG,
C                          FDFLAG
C
C REQUIRED LIBRARY         The ERPRT77 package and the SPPS.
C ROUTINES
C
C REQUIRED GKS LEVEL       0A
C
C I/O                      Plots solid or dashed lines, possibly with
C                          characters at intervals in the line.
C                          The lines may also be smoothed.
C
C PRECISION                Single
C
C LANGUAGE                 FORTRAN
C
C HISTORY                  Written in October 1973.
C                          Made portable in September 1977 for use
C                          with all machines which
C                          support plotters with up to 15 bit resolution.
C                          Converted to FORTRAN77 and GKS in June, 1984.
C
C ALGORITHM                Points for each line
C                          segment are processed and passed to the
C                          routines, MSKRV1 and MSKRV2, which compute
C                          splines under tension passing through these
C                          points.  New points are generated between the
C                          given points, resulting in smooth lines.
C
C ACCURACY                 Plus or minus .5 plotter address units per call.
C                          There is no cumulative error.
C
C TIMING                   About three times as long as DASHCHAR.
C
C
C
C
C
C
C
C
C***********************************************************************
C
C FDVDLD RECEIVES IN ITS ARGUMENTS THE POINTS TO BE PROCESSED FOR A
C LINE SEGMENT. IT PASSES THESE POINTS TO THE ROUTINES MSKRV1 AND MSKRV2
C WHICH COMPUTE SPLINES UNDER TENSION PASSING THROUGH THESE POINTS.
C FDVDLD THEN CALLS CFVLD TO CONNECT THE POINTS GENERATED IN MSKRV2.
C
      DIMENSION       XP(70),  YP(70),  TEMP(70),  SLEN(70)
C
C THE VARIABLES IN DSAVE5 HAVE TO BE SAVED FOR THE NEXT CALL TO FDVDLD.
C
      COMMON /DSAVE5/ XSAVE(70), YSAVE(70), XSVN, YSVN, XSV1, YSV1,
     1                SLP1, SLPN, SSLP1, SSLPN, N, NSEG
C
C IOFFS IS AN INTERNAL PARAMETER. IT IS INITIALIZED IN DASHBDX AND
C REFERENCED IN FDVDLD AND DRAWPV.
C
      COMMON /SMFLAG/ IOFFS
C
C IFSTF2 IS A FLAG TO CONTROL THAT FRSTD IS CALLED BEFORE VECTD IS
C CALLED.
C
      COMMON /DFFLAG/ IFSTF2
C
C IFLAG CONTROLS IF LASTD CAN BE CALLED DIRECTLY OR IF IT WAS JUST
C CALLED FROM BY VECTD SO THAT THIS CALL CAN BE IGNORED.
C
      COMMON /FDFLAG/ IFLAG
C
C NOTE THAT THIS IFSTF2 FLAG CANNOT BE IDENTICAL TO THE IFSTFL FLAG
C IN THE ROUTINE CFVLD, BECAUSE A CALL TO THE FRSTD ENTRY OF FDVDLD DOES
C NOT ELIMINATE THE NECESSITY OF A CALL TO THE FRSTD ENTRY OF CFVLD,
C AND REVERSE.
C
      COMMON/INTPR/IPAU,FPART,TENSN,NP,SMALL,L1,ADDLR,ADDTB,MLLINE,
     1    ICLOSE
      SAVE
C
C
C OTHER CONSTANTS.
C
      DATA PI /3.14159265358/
      DATA IDUMMY /0/
C
C
      GO TO (10,15,35),IENTRY
C
C *************************************
C
C ENTRY  FRSTD (XX,YY)
C
   10 DEG = 180./PI
C
      MX = IIX
      MY = IIY
      IFSTF2 = 0
      SSLP1 = 0.0
      SSLPN = 0.0
      XSVN = 0.0
      YSVN = 0.0
      IF (IOFFS .GE. 1) CALL CFVLD (1,MX,MY)
      IF (IOFFS .GE. 1) RETURN
C
C INITIALIZE THE POINT AND SEGMENT COUNTER
C N COUNTS THE NUMBER OF POINTS/SEGMENT
C
      N = 0
C
C NSEG = 0       FIRST SEGMENT
C NSEG = 1       MORE THAN ONE SEGMENT
C
      NSEG = 0
C
C SAVE THE X,Y COORDINATES OF THE FIRST POINT
C XSV1           CONTAINS THE X COORDINATE OF THE FIRST POINT
C                OF A LINE
C YSV1           CONTAINS THE Y COORDINATE OF THE FIRST POINT
C                OF A LINE
C
      XSV1 = MX
      YSV1 = MY
      GO TO 30
C
C *************************************
C
C     ENTRY VECTD (XX,YY)
C
   15 CONTINUE
C
C TEST FOR PREVIOUS FRSTD CALL
C
      IF (IFSTF2 .EQ. 0) GO TO 20
C
C INFORM USER - NO PREVIOUS CALL TO FRSTD. TREAT CALL AS FRSTD CALL.
C
      CALL SETER(' FDVDLD- VECTD CALL OCCURS BEFORE A CALL TO FRSTD.',
     -            1,1)
      GO TO 10
   20 MX = IIX
      MY = IIY
C
C VECTD          SAVES THE X,Y COORDINATES OF THE ACCEPTED
C                POINTS ON A LINE SEGMENT
C
      IF (IOFFS .GE. 1) CALL CFVLD (2,MX,MY)
      IF (IOFFS .GE. 1) RETURN
C
C IF THE NEW POINT IS TOO CLOSE TO THE PREVIOUS POINT, IGNORE IT
C
      IF (ABS(REAL(INT(XSVN)-MX))+ABS(REAL(INT(YSVN)-MY)) .LT.
     1    SMALL) RETURN
      IFLAG = 0
   30 N = N+1
C
C SAVE THE X,Y COORDINATES OF EACH POINT OF THE SEGMENT
C XSAVE          THE ARRAY OF X COORDINATES OF LINE SEGMENT
C YSAVE          THE ARRAY OF Y COORDINATES OF LINE SEGMENT
C
      XSAVE(N) = MX
      YSAVE(N) = MY
      XSVN = XSAVE(N)
      YSVN = YSAVE(N)
      IF (N .GE. L1-1) GO TO 40
      RETURN
C
C *************************************
C
C     ENTRY LASTD
C
   35 CONTINUE
      IF (IFSTF2 .NE. 0) RETURN
      IFSTF2 = 1
C
C LASTD          CHECKS FOR PERIODIC LINES AND SETS UP
C                  THE CALLS TO MSKRV1 AND MSKRV2
C
      IF (IOFFS .GE. 1) CALL CFVLD (3,IDUMMY,IDUMMY)
      IF (IOFFS .GE. 1) RETURN
C
C IFLAG = 0      OK TO CALL LASTD DIRECTLY
C IFLAG = 1      LASTD WAS JUST CALLED FROM BY VECTD
C                IGNORE CALL TO LASTD
C
      IF (IFLAG .EQ. 1) RETURN
C
C COMPARE THE LAST POINT OF SEGMENT WITH FIRST POINT OF LINE
C
   40 IFLAG = 1
C
C IPRD = 0       PERIODIC LINE
C IPRD = 1       NON-PERIODIC LINE
C
      IPRD = 1
      IF (ABS(XSV1-XSVN)+ABS(YSV1-YSVN) .LT. SMALL) IPRD = 0
C
C TAKE CARE OF THE CASE OF ONLY TWO DISTINCT P0INTS ON A LINE
C
      IF (NSEG .GE. 1) GO TO 60
      IF (N-2) 150,140,50
   50 IF (N .GE. 4) GO TO 60
C
      IF (IPRD .NE. 0) GO TO 60
      DX = XSAVE(2)-XSAVE(1)
      DY = YSAVE(2)-YSAVE(1)
      SLOPE = ATAN2(DY,DX)*DEG+90.
      IF (SLOPE .GE. 360.) SLOPE = SLOPE-360.
      IF (SLOPE .LE. 0.) SLOPE = SLOPE+360.
      SLP1 = SLOPE
      SLPN = SLOPE
      ISLPSW = 0
      SIGMA = TENSN
      GO TO 100
   60 SIGMA = TENSN
      IF (IPRD .GE. 1) GO TO 80
      IF (NSEG .GE. 1) GO TO 70
C
C SET UP FLAGS FOR A  1  SEGMENT, PERIODIC LINE
C
      ISLPSW = 4
      XSAVE(N) = XSV1
      YSAVE(N) = YSV1
      GO TO 100
C
C SET UP FLAGS FOR AN N-SEGMENT, PERIODIC LINE
C
   70 SLP1 = SSLPN
      SLPN = SSLP1
      ISLPSW = 0
      GO TO 100
   80 IF (NSEG .GE. 1) GO TO 90
C
C SET UP FLAGS FOR THE 1ST SEGMENT OF A NON-PERIODIC LINE
C
      ISLPSW = 3
      GO TO 100
C
C SET UP FLAGS FOR THE NTH SEGMENT OF A NON-PERIODIC LINE
C
   90 SLP1 = SSLPN
      ISLPSW = 1
C
C CALL THE SMOOTHING ROUTINES
C
  100 CALL MSKRV1 (N,XSAVE,YSAVE,SLP1,SLPN,XP,YP,TEMP,SLEN,SIGMA,ISLPSW)
C
C DETERMINE THE NUMBER OF POINTS TO INTERPOLATE FOR EACH SEGMENT
C
      IF (NSEG.GE.1 .AND. N.LT.L1-1) GO TO 110
      NPRIME = REAL(NP)-(SLEN(N)*REAL(NP)*.5)/32767.
      IF (SLEN(N) .GE. 32767.) NPRIME = .5*REAL(NP)
      NPL = MAX(REAL(NPRIME)*SLEN(N)/32767.,2.5)
  110 DT = 1./REAL(NPL)
      IX = INT (XSAVE(1))
      IY = INT (YSAVE(1))
      IF (NSEG .LE. 0) GO TO 112
      CALL DRAWPV (IX,IY,0)
      GO TO 114
  112 CONTINUE
      CALL CFVLD (1,IX,IY)
  114 CONTINUE
      T = 0.0
      NSLPSW = 1
      IF (NSEG .GE. 1) NSLPSW = 0
      NSEG = 1
      CALL MSKRV2 (T,XS,YS,N,XSAVE,YSAVE,XP,YP,SLEN,SIGMA,NSLPSW,SLP)
C
C SAVE SLOPE AT THE FIRST POINT OF THE LINE
C
      IF (NSLPSW .GE. 1) SSLP1 = SLP
      NSLPSW = 0
      DO 120 I=1,NPL
         T = T+DT
         IF (I .EQ. NPL) NSLPSW = 1
         CALL MSKRV2 (T,XS,YS,N,XSAVE,YSAVE,XP,YP,SLEN,SIGMA,NSLPSW,SLP)
C
C SAVE THE LAST SLOPE OF THIS LINE SEGMENT
C
         IF (NSLPSW .GE. 1) SSLPN = SLP
C
C DRAW EACH PART OF THE LINE SEGMENT
C
         IX = INT(XS)
         IY = INT (YS)
         CALL CFVLD (2,IX,IY)
  120 CONTINUE
      IF (IPRD .NE. 0) GO TO 130
C
C CONNECT THE LAST POINT WITH THE FIRST POINT OF A PERIODIC LINE
C
      IX = INT (XSV1)
      IY = INT (YSV1)
      CALL CFVLD (2,IX,IY)
C
C BEGIN THE NEXT LINE SEGMENT WITH THE LAST POINT OF THIS SEGMENT
C
  130 XSAVE(1) = XS
      YSAVE(1) = YS
      N = 1
      IF (IFSTF2 .EQ. 1) CALL CFVLD (3,IDUMMY,IDUMMY)
      GO TO 150
C
C FOR THE CASE WHEN THERE ARE ONLY 2 DISTINCT POINTS ON A LINE.
C
  140 IX = INT (XSAVE(1))
      IY = INT (YSAVE(1))
      CALL CFVLD (1,IX,IY)
      IX = INT (XSAVE(N))
      IY = INT (YSAVE(N))
      CALL CFVLD (2,IX,IY)
      IF (IFSTF2 .EQ. 1) CALL CFVLD (3,IDUMMY,IDUMMY)
C
  150 CONTINUE
      RETURN
      END

C
C $Id: slseti.f,v 1.6.8.1 2010-03-17 20:51:57 brownrig Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE SLSETI (PNAM,IVAL)
C
C Set the integer value of the STITLE parameter named PNAM from IVAL.
C
        CHARACTER*(*) PNAM
        INTEGER IVAL
C
C The common block SLCOMN holds all of the internal parameters of
C the package STITLE except for color-table parameters.
C
        COMMON /SLCOMN/ GPSZ,IBGC,IBGF,ICOP,IDOT,IFGC,IFGF,IJMP,IMAP,
     +                  INCU,IWLU,IWRK,IWWI,IXND,IXST,OORV,PCSZ,RNFS,
     +                  RVPB,RVPL,RVPR,RVPT,TFIN,TFOU,TGP1,TGP2,TGP3
        SAVE   /SLCOMN/
C
C Define a temporary variable in which to put the first three characters
C of PNAM.
C
        CHARACTER*3 CTMP
C
C Define a character variable in which messages may be formed.
C
        CHARACTER*29 CMSG
C
C RLB 3/2010: Previously the integer parameter was converted to a float
C   and the work was delegated off to SLSETR. This provided a sort
C   of "automatic type conversion", allowing the user to set a real
C   parameter using either slseti() or slsetr(), as in:
C        CALL SLSETI ('xxx',-9999)
C     or
C        CALL SLSETR ('xxx',-9999.0)
C
C   Color-indices are now either encoded RGBa values, or indices as
C   before. RGBa values are typically large integer values, beyond the
C   precision of floats, and thus this delegation scheme no longer
C   works correctly. The code has been refactored such that the integer
C   cases are now handled directly herein. If no action is found for
C   the PNAM, then we delegate over to SLSETR.
C --------------------------------------------------------------------
C
C Do a call forcing a BLOCKDATA to be loaded from a binary library.
C
        CALL SLBLDA
C
C Check for an uncleared prior error.
C
        IF (ICFELL('SLSETI - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C Extract the first three characters of the parameter name.
C
        CTMP=PNAM
C
C If the parameter name has less than three characters, log an error.
C
        IF (LEN(PNAM).LT.3) GO TO 901
C
C See what the parameter name is ...
C
C ... the flag controlling the output of the alignment frames, ...
C
        IF      (CTMP.EQ.'ALN'.OR.CTMP.EQ.'aln') THEN
C
          IDOT=MAX(0,MIN(2,IVAL))
C
C ... the default background color index ...
C
        ELSE IF (CTMP.EQ.'BGC'.OR.CTMP.EQ.'bgc') THEN
C
          IBGC=MAX(0,IVAL)
C
C ... the background color fade flag ...
C
        ELSE IF (CTMP.EQ.'BGF'.OR.CTMP.EQ.'bgf') THEN
C
          IBGF=MAX(-2,MIN(999999,IVAL))
C
C ... the default foreground color index ...
C
        ELSE IF (CTMP.EQ.'FGC'.OR.CTMP.EQ.'fgc') THEN
C
          IFGC=MAX(1,IVAL)
C
C ... the foreground color fade flag ...
C
        ELSE IF (CTMP.EQ.'FGF'.OR.CTMP.EQ.'fgf') THEN
C
          IFGF=MAX(-2,MIN(999999,IVAL))
C
C ... the centering parameter, ...
C
        ELSE IF (CTMP.EQ.'ICO'.OR.CTMP.EQ.'ico') THEN
C
          ICOP=MAX(0,MIN(2,IVAL))
C
C ... the FORTRAN logical unit number for "card" input, ...
C
        ELSE IF (CTMP.EQ.'ICU'.OR.CTMP.EQ.'icu') THEN
C
          INCU=MAX(0,IVAL)
C
C ... the interline spacing for practice runs, ...
C
        ELSE IF (CTMP.EQ.'INC'.OR.CTMP.EQ.'inc') THEN
C
          IJMP=MAX(1,IVAL)
C
C ... the FORTRAN logical unit number for WISS, ...
C
        ELSE IF (CTMP.EQ.'LOG'.OR.CTMP.EQ.'log') THEN
C
          IWLU=MAX(0,IVAL)
C
C ... the PLOTCHAR mapping flag, ...
C
        ELSE IF (CTMP.EQ.'MAP'.OR.CTMP.EQ.'map') THEN
C
          IMAP=MAX(0,IVAL)
C
C ... the horizontal scroll end coordinate, ...
C
        ELSE IF (CTMP.EQ.'NXE'.OR.CTMP.EQ.'nxe') THEN
C
          IXND=MAX(0,MIN(1023,IVAL))
C
C ... the horizontal scroll start coordinate, ...
C
        ELSE IF (CTMP.EQ.'NXS'.OR.CTMP.EQ.'nxs') THEN
C
          IXST=MAX(0,MIN(1023,IVAL))
C
C ... or the workstation identifier for WISS.
C
        ELSE IF (CTMP.EQ.'WID'.OR.CTMP.EQ.'wid') THEN
C
          IWWI=MAX(0,IVAL)
C
        ELSE
C         Pass SLSETR the real equivalent of the integral value and
C         let it do the work.
          CALL SLSETR (PNAM,REAL(IVAL))
          IF (ICFELL('SLSETI',2).NE.0) RETURN
        END IF
C
C Normal exit.
C
        RETURN
C
C Error exit.
C
  901   CMSG(1:29)='SLSETI - INVALID KEYWORD: '//CTMP
        CALL SETER (CMSG(1:29),8,1)
        RETURN
      END

C
C $Id: agctcs.f,v 1.6 2008-07-27 00:14:33 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE AGCTCS (TPID,ITCS)
C
      CHARACTER*(*) TPID
C
C The routine AGCTCS is called by the routines AGGETC and AGSETC to
C check what type of character-string parameter is implied by the
C parameter identifier TPID and return an appropriate value of ITCS, as
C follows:
C
C -- ITCS = 0 implies that the parameter is not intrinsically of type
C    character and that AGGETC/AGSETC should not have been called in
C    the way that it was.
C
C -- ITCS = 1 implies a dash-pattern parameter.
C
C -- ITCS = 2 implies a label name.
C
C -- ITCS = 3 implies the line-end character.
C
C -- ITCS = 4 implies the text of some line of some label.
C
C Find out where in the parameter list the requested parameter lies.
C
      CALL AGSCAN (TPID,LOPA,NIPA,IIPA)
C
C See if it's a dash pattern.
C
      CALL AGSCAN ('DASH/PATT.',LODP,NIDP,IIDP)
      IF (LOPA.GE.LODP.AND.LOPA.LE.LODP+NIDP-1) THEN
        ITCS=1
        RETURN
      END IF
C
C See if it's a label name.
C
      CALL AGSCAN ('LABE/NAME.',LOLN,NILN,IILN)
      IF (LOPA.EQ.LOLN) THEN
        ITCS=2
        RETURN
      END IF
C
C See if it's the line-end character.
C
      CALL AGSCAN ('LINE/END .',LOLE,NILE,IILE)
      IF (LOPA.EQ.LOLE) THEN
        ITCS=3
        RETURN
      END IF
C
C See if it's the text of some label line.
C
      CALL AGSCAN ('LINE/BUFF/CONT.',LOLB,NILB,IILB)
      IF (LOPA.GE.LOLB.AND.LOPA.LE.LOLB+NILB-1.AND.
     +                                       MOD(LOPA-LOLB,6).EQ.3) THEN
        ITCS=4
        RETURN
      END IF
C
C Error - type not recognizable.
C
      ITCS=0
      RETURN
C
      END

C
C	$Id: cssetup.f,v 1.5 2008-07-27 03:10:08 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CSSETUP (XI,YI,WI,WK,S1,S2,WT, ROW)
      DOUBLE PRECISION XI, YI, WI, WK, S1, S2, WT, ROW(6)
C
C***********************************************************
C
C                                              From SSRFPACK
C                                            Robert J. Renka
C                                  Dept. of Computer Science
C                                       Univ. of North Texas
C                                           renka@cs.unt.edu
C                                                   05/09/92
C
C   This subroutine sets up the I-th row of an augmented
C regression matrix for a weighted least squares fit of a
C quadratic function Q(X,Y) to a set of data values Wi,
C where Q(0,0) = Wk.  The first 3 columns (quadratic terms)
C are scaled by 1/S2 and the fourth and fifth columns (lin-
C ear terms) are scaled by 1/S1.
C
C On input:
C
C       XI,YI = Coordinates of node I.
C
C       WI = Data value at node I.
C
C       WK = Data value interpolated by Q at the origin.
C
C       S1,S2 = Inverse scale factors.
C
C       WT = Weight factor corresponding to the I-th
C            equation.
C
C       ROW = Array of length 6.
C
C Input parameters are not altered by this routine.
C
C On output:
C
C       ROW = Array containing a row of the augmented re-
C             gression matrix.
C
C Modules required by CSSETUP:  None
C
C***********************************************************
C
      DOUBLE PRECISION W1, W2
C
C Local parameters:
C
C W1 = Weighted scale factor for the linear terms
C W2 = Weighted scale factor for the quadratic terms
C
      W1 = WT/S1
      W2 = WT/S2
      ROW(1) = XI*XI*W2
      ROW(2) = XI*YI*W2
      ROW(3) = YI*YI*W2
      ROW(4) = XI*W1
      ROW(5) = YI*W1
      ROW(6) = (WI-WK)*WT
      RETURN
      END

C
C	$Id: dashdc.f,v 1.7 2008-07-27 00:23:03 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE DASHDC (IPAT,JCRT,JSIZE)
C
C
C
C
C
C
      COMMON/INTPR/IPAU,FPART,TENSN,NP,SMALL,L1,ADDLR,ADDTB,MLLINE,
     1    ICLOSE
C
C USER ENTRY POINT.
C DASHDC GIVES AN INTERNAL REPRESENTATION TO THE DASH PATTERN WHICH IS
C SPECIFIED IN ITS ARGUMENTS. THIS INTERNAL REPRESENTATION IS PASSED
C TO ROUTINE CFVLD IN THE COMMON-BLOCK DASHD1.
C
      CHARACTER*(*) IPAT
      CHARACTER*1   ICR
      CHARACTER*16  IPC(100)
C
C DASHD1 AND DASHD2 ARE USED
C FOR COMMUNICATION BETWEEN THE ROUTINES DASHDB, DASHDC AND CFVLD.
C ISL, MNCSTR AND IGP ARE INITIALIZED IN DASHBDX.
C
      COMMON /DASHD1/  ISL,  L,  ISIZE,  IP(100),  NWDSM1,  IPFLAG(100)
     1                 ,MNCSTR, IGP
      COMMON /DASHD2/  IPC
C
C IFCFLG IS THE FIRST CALL FLAG FOR DASHDB AND DASHDC.
C IT IS INITIALIZED IN DASHBDX.
C
      COMMON /DDFLAG/ IFCFLG
C
C IFSTFL CONTROLS THAT FRSTD IS CALLED BEFORE VECTD IS CALLED (IN CFVLD)
C WHENEVER DASHDB OR DASHDC HAVE BEEN CALLED.
C IT IS INITIALIZED IN DASHBDX AND REFERENCED IN CFVLD.
C
      COMMON /DCFLAG/ IFSTFL
C
C IFSTF2 CONTROLS THAT THE FRSTD ENTRY IS CALLED IN FDVDLD BEFORE THE
C VECTD ENTRY IS CALLED WHENEVER DASHDB OR DASHDC HAVE BEEN CALLED.
C IT IS INITIALIZED IN DASHBDX AND REFERENCED IN FDVDLD.
C
      COMMON /DFFLAG/ IFSTF2
C
C LOCAL VARIABLES TO DASHDB AND DASHDC ARE SAVED IN DSAVE6
C FOR THE NEXT CALL
C
      COMMON /DSAVE6/ MASK, NCHRWD, NBWD, MNCST1
C
C Make definitions of a blank, a gap, and a solid externally visible.
C
      COMMON /BLGASO/ IBLK,IGAP,ISOL
      CHARACTER*1     IBLK,IGAP,ISOL
C
C SAVE ALL VARIABLES
C
      SAVE
C
C NPD IS THE NUMBER OF WORDS IN IP
C
      DATA NPD/100/
C
C Do a call forcing a BLOCKDATA to be loaded from a binary library.
C
      CALL DASHBD
C
C THE FOLLOWING CALL IS FOR LIBRARY STATISTICS GATHERING AT NCAR
C
      CALL Q8QST4 ('GRAPHX', 'DASHSMTH', 'DASHDC', 'VERSION  1')
C
C     NC IS THE NUMBER OF CHARACTERS IN IPAT
C
      NC = LEN(IPAT)
      IF (IFCFLG .EQ. 2) GOTO 10
C
C CHECK IF THE CONSTANTS IN THE BLOCKDATA DASHBDX ARE LOADED CORRECTLY
C
      IF (MNCSTR .EQ. 15) GOTO 6
      CALL SETER('DASHDC -- BLOCKDATA DASHBDX APPARENTLY NOT LOADED CORR
     1ECTLY',1,2)
    6 CONTINUE
C
C INITIALIZATION
C
      MNCST1 = MNCSTR + 1
C
C MASK IS AN ALL SOLID PATTERN TO BE PASSED TO OPTN (65535=177777B).
C
      MASK=IOR(ISHIFT(32767,1),1)
C
C
      IFCFLG = 2
C
C NCHRTS - NUMBER OF CHARS IN THIS HOLLERITH STRING.
C L      - NUMBER OF WORDS IN THE FINAL PATTERN, POINTER TO IP ARRAY.
C ISL    - FLAG FOR ALL SOLID PATTERN (1) OR ALL GAP PATTERN (-1).
C IFSTFL - FLAG TO CONTROL THAT FRSTD IS CALLED IN CFVLD BEFORE VECTD IS
C          CALLED, WHENEVER DASHDB OR DASHDC HAVE BEEN CALLED.
C IFSTF2 - FLAG TO CONTROL THAT FRSTD IS CALLED IN FDVDLD BEFORE VECTD
C          IS CALLED, WHENEVER DASHDB OR DASHDC HAVE BEEN CALLED.
C
   10 CONTINUE
      NCHRTS = 0
      L = 0
      ISL = 0
      IFSTFL = 1
      IFSTF2 = 1
C
C RETRIEVE THE RESOLUTION AS SET BY THE USER.
C
      CALL GETUSV('XF',LXSAVE)
      CALL GETUSV('YF',LYSAVE)
C
C IADJUS - TO ADJUST NUMBERS TO THE GIVEN RESOLUTION.
C
      IADJUS = ISHIFT(1,15-LXSAVE)
      ICRT = JCRT*IADJUS
      ISIZE = JSIZE
      CHARW = REAL(ISIZE*IADJUS)
      IF (ISIZE .GT. 3) GO TO 30
      CHARW = 256. + REAL(ISIZE)*128.
      IF (ISIZE .EQ. 3) CHARW = 768.
C
   30 CONTINUE
      IF (ICRT .LT. 1) GO TO 230
      MODE = 2
C
C START MAIN LOOP
C
C THIS LOOP GENERATES THE IP ARRAY (NEEDED BY CURVED,VECTD,ETC.) FROM
C THE CHARACTER STRING IN IPAT.  EACH ITERATION OF THE LOOP PROCESSES
C ONE CHAR OF IPAT.  A SOLID OR GAP IS CONSIDERED TO BE A TYPE 1 ENTRY,
C AND A LABEL CHARACTER IS CONSIDERED TO BE A TYPE 2 ENTRY.
C
C IN THE CODE, L IS THE NUMBER OF CHANGES IN THE LINESTYLE (FROM GAP
C TO SOLID, SOLID TO CHARACTER, ETC.)  THE IP AND IPFLAG ARRAYS DESCRIBE
C THE LINE TO BE DRAWN, AND THESE ARRAYS ARE INDEXED FROM 1 TO L.  THE
C RELATIONSHIP BETWEEN IP AND IPFLAG IS:
C
C      IPFLAG(N)    IP(N)
C      ---------    -----
C          1        LENGTH (IN PLOTTER ADDRESS UNITS) OF SOLID LINE TO
C                   BE DRAWN.
C          0        NUMBER OF CHARACTERS TO BE PLOTTED.
C         -1        LENGTH (IN PLOTTER ADDRESS UNITS) OF GAP.
C
C THE 160 LOOP HANDLES 5 CASES:
C
C    1.)  CONTINUE TYPE 2 ENTRY (60-80)
C    2.)  START TYPE 2 ENTRY (80-90)
C    3.)  END TYPE 2 ENTRY AND START TYPE 1 ENTRY (90-160)
C    4.)  START TYPE 1 ENTRY, OR SWITCH TYPE 1 ENTRY FROM SOLID TO
C         GAP OR FROM GAP TO SOLID (140-160)
C    5.)  CONTINUE TYPE 1 ENTRY (150-160)
C
      DO 160 J=1,NC
C
C GET NEXT CHAR INTO ICR, RIGHT JUSTIFIED ZERO FILLED.
C
            ICR = IPAT(J:J)
C
C MODE SPECIFIES WHAT THE LAST CHARACTER PROCESSED WAS:
C
C    LAST ICR WAS $ (SOLID),      MODE IS 8
C    LAST ICR WAS ' (GAP),        MODE IS 2
C    LAST ICR WAS HOLLERITH CHAR, MODE IS 5
C
C NMODE SPECIFIES WHAT THE CURRENT CHARACTER TO BE PROCESSED IS:
C
C      ICR     NMODE
C      ---     -----
C       $        1
C       CHAR     0
C       '       -1
C
            NMODE = 0
            IF (ICR .EQ. IBLK) GO TO 160
            IF (ICR .EQ. IGAP) NMODE = -1
            IF (ICR .EQ. ISOL) NMODE = 1
            IF (L.EQ.0 .AND. NMODE.EQ.-1) MODE = 8
C
C NGO DETERMINES WHERE TO BRANCH BASED ON CASE TO BE PROCESSED.
C COMPUTE MODE FOR NEXT ITERATION.
C
            NGO = NMODE+MODE
            MODE = NMODE*3+5
            GO TO (150,80,140,90,60,90,140,80,150),NGO
C
C CHAR TO CHAR
C
C CASE 1) - CONTINUE TYPE 2 ENTRY.
C
   60      IF (NCHRTS .EQ. MNCSTR) GO TO 160
           NCHRTS = NCHRTS + 1
           IP(L) = NCHRTS
           IPC(L)(NCHRTS:NCHRTS) = ICR
           GO TO 160
C
C BLANK OR SOLID TO CHAR
C
C CASE 2) - START STRING ENTRY.  LGBSTR POINTS TO THE GAP WHICH
C           WILL CONTAIN THE STRING.
C
   80      LGBSTR = MIN(L+1,NPD)
           L = MIN(LGBSTR+1,NPD)
           IPFLAG(L) = 0
           NCHRTS    = 1
           IP(L)     = 1
           IPC(L)(NCHRTS:NCHRTS) = ICR
           GO TO 160
C
C CHAR TO SOLID OR GAP
C
C CASE 3) - END STRING ENTRY.  ICR IS A $ OR '.
C
   90      CONTINUE
           IP(LGBSTR) = CHARW*(REAL(NCHRTS) + .5)
           IPFLAG(LGBSTR) = -1
           IF (IGP .EQ. 0) IPFLAG(LGBSTR) = 1
C
C BLANK TO SOLID OR SOLID TO BLANK
C
C CASE 4) - START TYPE 1 ENTRY.
C
  140       L = MIN(L+1,NPD)
            IP(L) = 0
C
C ADD TO A BLANK OR SOLID LINE
C
C CASE 5) - CONTINUE TYPE 1 ENTRY.  ICR IS A $ OR '.
C ADD ICRT UNITS TO THE PLOTTER ADDRESS UNITS IN IP(L).
C NMODE INDICATES IF IT IS A GAP OR A SOLID.
C
  150       IP(L) = IP(L) + ICRT
            IPFLAG(L) = NMODE
  160    CONTINUE
C
C IF LAST ICR PROCESSED WAS A LABEL CHARACTER, MUST END STRING
C ENTRY.
C
      IF (NGO.NE.2 .AND. NGO.NE.5 .AND. NGO.NE.8) GO TO 220
      IP(LGBSTR) = CHARW*(REAL(NCHRTS)+.5)
      IPFLAG(LGBSTR) = -1
      IF (IGP .EQ. 0) IPFLAG(LGBSTR) = 1
C
C IF IP ARRAY HAS ONLY ONE TYPE 1 ENTRY, SET ISL FLAG.
C
  220 IF (L .GT. 1) RETURN
      IBIG = ISHIFT(1,MAX(LXSAVE,LYSAVE))
      IF (IP(L) .GE. IBIG) GO TO 230
      IF (IPFLAG(L)) 240,240,230
  230 ISL = 1
      RETURN
  240 ISL = -1
      RETURN
      END

C PACKAGE SPLPAK         Documentation for user entries follows
C                        the general package information.
C
C LATEST REVISION        August, 1998
C
C PURPOSE                This package contains routines for fitting
C                        (least squares) a multidimensional cubic spline
C                        to arbitrarily located data.  It also contains
C                        routines for evaluating this spline (or its
C                        partial derivatives) at any point.
C
C                        Coefficient calculation is performed in
C                        subroutines SPLCC or SPLCW and evaluation is
C                        performed by functions SPLFE or SPLDE.
C
C USAGE                  Package SPLPAK contains four user entries --
C                        SPLCC, SPLCW, SPLFE, AND SPLDE.
C
C                        The user first calls SPLCC by
C
C                          CALL SPLCC (NDIM,XDATA,L1XDAT,YDATA,NDATA,
C                                      XMIN,XMAX,NODES,XTRAP,COEF,NCF,
C                                      WORK,NWRK,IERROR)
C
C                        or SPLCW by
C
C                          CALL SPLCW (NDIM,XDATA,L1XDATA,YDATA,WDATA,
C                                      NDATA,XMIN,XMAX,NODES,XTRAP,
C                                      COEF,NCF,WORK,NWRK,IERROR)
C
C                        The parameter NDATA in the call to SPLCW
C                        enables the user to weight some of the data
C                        points more heavily than others.  Both
C                        routines return a set of coefficients in the
C                        array COEF.  These coefficients are
C                        subsequently used in the computation of
C                        function values and partial derivatives.
C                        To compute values on the spline approximation
C                        the user then calls SPLFE or SPLDE any
C                        number of times in any order provided that
C                        the values of the inputs, NDIM, COEF, XMIN,
C                        XMAX, and NODES, are preserved between calls.
C
C                        SPLFE and SPLDE are called in the following way:
C
C                          F = SPLFE (NDIM,X,COEF,XMIN,XMAX,NODES,
C                                     IERROR)
C
C                        or
C
C                          F = SPLDE (NDIM,X,NDERIV,COEF,XMIN,XMAX,
C                                     NODES,IERROR)
C
C                        The routine SPLFE returns an interpolated
C                        value at the point defined by the array X.
C                        SPLDE affords the user the additional
C                        capability of calculating an interpolated
C                        value for one of several partial derivatives
C                        specified by the array NDERIV.
C
C I/O                    None, except for error messages printed by
C                        calls to CFSARR, if an error is detected.
C
C PRECISION              Single
C
C REQUIRED LIBRARY       SUPRLS, CFAERR
C FILES
C
C LANGUAGE               FORTRAN
C
C HISTORY                Developed in 1972-73 by NCAR's
C                        Scientific Computing Division.
C
C                        Cleaned up and added to the Ngmath library in
C                        1998.
C
C PORTABILITY            FORTRAN 77
C
C***********************************************************************
C
C SUBROUTINE SPLCC (NDIM,XDATA,L1XDAT,YDATA,NDATA,XMIN,XMAX,NODES,
C                   XTRAP,COEF,NCF,WORK,NWRK,IERROR)
C
C DIMENSION OF           XDATA(NDATA,L1XDAT),YDATA(NDATA),XMIN(NDIM),
C ARGUMENTS              XMAX(NDIM),NODES(NDIM),COEF(NCF),WORK(NWRK)
C
C PURPOSE                N-dimensional cubic spline coefficient
C                        calculation by least squares.
C
C USAGE                  The usage and arguments of this routine are
C                        identical to those for SPLCW except for the
C                        omission of the array of weights, WDATA.  See
C                        entry SPLCW description immediately below for a
C                        complete description.
C
C                        CALL SPLCC (NDIM,XDATA,L1XDAT,YDATA,NDATA,XMIN,
C                                    XMAX,NODES,XTRAP,COEF,NCF,WORK,
C                                    NWRK,IERROR)
C
C***********************************************************************
C
C SUBROUTINE SPLCW (NDIM,XDATA,L1XDAT,YDATA,WDATA,NDATA,XMIN,XMAX,
C                   NODES,XTRAP,COEF,NCF,WORK,NWRK,IERROR)
C
C
C DIMENSION OF           XDATA(L1XDAT,NDATA),YDATA(NDATA),WDATA(NDATA),
C ARGUMENTS              XMIN(NDIM),XMAX(NDIM),NODES(NDIM),COEF(NCF),
C                        WORK(NWRK)
C
C PURPOSE                N-dimensional cubic spline coefficient
C                        calculation by weighted least squares on
C                        arbitrarily located data.
C
C                        A grid of evenly spaced nodes in NDIM space is
C                        defined by the arguments XMIN, XMAX and NODES.
C                        A linear basis for the class of natural splines
C                        on these nodes is formed, and a set of
C                        corresponding coefficients is computed in the
C                        array COEF.  These coefficients are chosen to
C                        minimize the weighted sum of squared errors
C                        between the spline and the arbitrarily located
C                        data values described by the arguments XDATA,
C                        YDATA and NDATA.  The smoothness of the spline
C                        in data sparse areas is controlled by the
C                        argument XTRAP.
C
C NOTE                   In order to understand the arguments of this
C                        routine, one should realize that the node grid
C                        need not bear any particular relation to the
C                        data points.  In the theory of exact-fit
C                        interpolatory splines, the nodes would in fact
C                        be data locations, but in this case they serve
C                        only to define the class of splines from which
C                        the approximating function is chosen.  This
C                        node grid is a rectangular arrangement of
C                        points in NDIM space, with the restriction that
C                        along any coordinate direction the nodes are
C                        equally spaced.  The class of natural splines
C                        on this grid of nodes (NDIM-cubic splines whose
C                        2nd derivatives normal to the boundaries are 0)
C                        has as many degrees of freedom as the grid has
C                        nodes.  Thus the smoothness or flexibility of
C                        the splines is determined by the choice of the
C                        node grid.
C
C USAGE                  CALL SPLCW (NDIM,XDATA,L1XDAT,YDATA,WDATA,
C                                    NDATA,XMIN,XMAX,NODES,XTRAP,COEF,
C                                    NCF,WORK,NWRK,IERROR)
C
C                        The spline (or its derivatives) may then be
C                        evaluated by using function SPLFE (or SPLDE).
C
C ARGUMENTS
C
C ON INPUT               NDIM
C                          The dimensionality of the problem.  The
C                          spline is a function of NDIM variables or
C                          coordinates and thus a point in the
C                          independent variable space is an NDIM vector.
C                          NDIM must be in the range 1 .LE. NDIM .LE. 4.
C
C                        XDATA
C                          A collection of locations for the data
C                          values, i.e., points from the independent
C                          variable space.  This collection is a
C                          2-dimensional array whose 1st dimension
C                          indexes the NDIM coordinates of a given point
C                          and whose 2nd dimension labels the data
C                          point.  For example, the data point with
C                          label IDATA is located at the point
C                          (XDATA(1,IDATA),...,XDATA(NDIM,IDATA)) where
C                          the elements of this vector are the values of
C                          the NDIM coordinates.  The location, number
C                          and ordering of the data points is arbitrary.
C                          The dimension of XDATA is assumed to be 
C                          XDATA(L1XDAT,NDATA).
C
C                        L1XDAT
C                          The length of the 1st dimension of XDATA in
C                          the calling program.  L1XDAT must be .GE.
C                          NDIM.
C
C                               NOTE:  For 1-dimensional problems L1XDAT
C                                      is usually 1.
C
C                        YDATA
C                          A collection of data values corresponding to
C                          the points in XDATA.  YDATA(IDATA) is the
C                          data value associated with the point
C                          (XDATA(1,IDATA),...,XDATA(NDIM,IDATA)) in the
C                          independent variable space.  The spline whose
C                          coefficients are computed by this routine
C                          approximates these data values in the least
C                          squares sense.  The dimension is assumed to be
C                          YDATA(NDATA).
C
C                        WDATA
C                          A collection of weights.  WDATA(IDATA) is a
C                          weight associated with the data point
C                          labelled IDATA.  It should be non-negative,
C                          but may be of any magnitude.  The weights
C                          have the effect of forcing greater or lesser
C                          accuracy at a given point as follows: this
C                          routine chooses coefficients to minimize the
C                          sum over all data points of the quantity
C
C                            (WDATA(IDATA)*(YDATA(IDATA) - spline value 
C                            at XDATA(IDATA)))**2.  
C
C                          Thus, if the reliability
C                          of a data point is known to be low, the
C                          corresponding weight may be made small
C                          (relative to the other weights) so that the
C                          sum over all data points is affected less by
C                          discrepencies at the unreliable point.  Data
C                          points with zero weight are completely
C                          ignored.
C
C                               NOTE:  If WDATA(1) is .LT. 0, the other
C                                      elements of WDATA are not
C                                      referenced, and all weights are
C                                      assumed to be unity.
C
C                          The dimension is assumed to be WDATA(NDATA)
C                          unless WDATA(1) .LT. 0., in which case the
C                          dimension is assumed to be 1.
C
C                        NDATA
C                          The number of data points mentioned in the
C                          above arguments.
C
C                        XMIN
C                          A vector describing the lower extreme corner
C                          of the node grid.  A set of evenly spaced
C                          nodes is formed along each coordinate axis
C                          and XMIN(IDIM) is the location of the first
C                          node along the IDIM axis.  The dimension is 
C                          assumed to be XMIN(NDIM).
C
C                        XMAX
C                          A vector describing the upper extreme corner
C                          of the node grid.  A set of evenly spaced
C                          nodes is formed along each coordinate axis
C                          and XMAX(IDIM) is the location of the last
C                          node along the IDIM axis.  The dimension is 
C                          assumed to be XMAX(NDIM).
C
C                        NODES
C                          A vector of integers describing the number of
C                          nodes along each axis.  NODES(IDIM) is the
C                          number of nodes (counting endpoints) along
C                          the IDIM axis and determines the flexibility
C                          of the spline in that coordinate direction.
C                          NODES(IDIM) must be .GE. 4, but may be as
C                          large as the arrays COEF and WORK allow.
C                          The dimension is assumed to be NODES(NDIM).
C
C                          NOTE:  The node grid is completely defined by
C                                 the arguments XMIN, XMAX and NODES.
C                                 The spacing of this grid in the IDIM
C                                 coordinate direction is:
C
C                                   DX(IDIM) = (XMAX(IDIM)-XMIN(IDIM)) /
C                                              (NODES(IDIM)-1).
C
C                                 A node in this grid may be indexed by
C                                 an NDIM vector of integers
C                                 (IN(1),...,IN(NDIM)) where
C                                 1 .LE. IN(IDIM) .LE. NODES(IDIM).
C                                 The location of such a node may be
C                                 represented by an NDIM vector
C                                 (X(1),...,X(NDIM)) where
C                                 X(IDIM) = XMIN(IDIM) + (IN(IDIM)-1) *
C                                                         DX(IDIM).
C
C                        XTRAP
C                          A parameter to control extrapolation to data
C                          sparse areas.  The region described by XMIN
C                          and XMAX is divided into rectangles, the
C                          number of which is determined by NODES, and
C                          any rectangle containing a disproportionately
C                          small number of data points is considered to
C                          be data sparse (rectangle is used here to
C                          mean NDIM-dimensional rectangle).  If XTRAP
C                          is nonzero the least squares problem is
C                          augmented with derivative constraints in the
C                          data sparse areas to prevent the matrix from
C                          becoming poorly conditioned.  XTRAP serves as
C                          a weight for these constraints, and thus may
C                          be used to control smoothness in data sparse
C                          areas.  Experience indicates that unity is a 
C                          good first guess for this parameter.
C
C                               NOTE:  If XTRAP is zero, substantial
C                                      portions of the routine will be
C                                      skipped, but a singular matrix
C                                      can result if large portions of
C                                      the region are without data.
C
C                        NCF
C                          The length of the array COEF in the calling
C                          program.  If NCF is .LT.
C                          NODES(1)*...*NODES(NDIM), a fatal error is
C                          diagnosed.
C
C                        WORK
C                          A workspace array for solving the least
C                          squares matrix generated by this routine.
C                          Its required size is a function of the total
C                          number of nodes in the node grid.  This
C                          total, NCOL = NODES(1)*...*NODES(NDIM), is
C                          also the number of columns in the least
C                          squares matrix.  The length of the array WORK
C                          must equal or exceed NCOL*(NCOL+1).
C
C                        NWRK
C                          The length of the array WORK in the calling
C                          program.  If
C                          NCOL = NODES(1)*...*NODES(NDIM) is the total
C                          number of nodes, then a fatal error is
C                          diagnosed if NWRK is less than
C                          NCOL*(NCOL+1).
C
C ON OUTPUT              COEF
C                          The array of coefficients computed by this
C                          routine.  Each coefficient corresponds to a
C                          particular basis function which in turn
C                          corresponds to a node in the node grid.  This
C                          correspondence between the node grid and the
C                          array COEF is as if COEF were an
C                          NDIM-dimensional Fortran array with
C                          dimensions NODES(1),...,NODES(NDIM), i.e., to
C                          store the array linearly, the leftmost
C                          indices are incremented most frequently.
C                          Hence the length of the COEF array must equal
C                          or exceed the total number of nodes, which is
C                          NODES(1)*...*NODES(NDIM).  The computed array
C                          COEF may be used with function SPLFE
C                          (or SPLDE) to evaluate the spline (or its
C                          derivatives) at an arbitrary point in NDIM
C                          space.  The dimension is assumed to be COEF(NCF).
C
C                        WORK
C                          The workspace containing intermediate
C                          calculations.  It need not be saved.
C
C                        IERROR
C                          An error flag with the following meanings:
C                              0  No error.
C                            101  NDIM is .LT. 1 or is .GT. 4.
C                            102  NODES(IDIM) is .LT. 4 fOR some IDIM.
C                            103  XMIN(IDIM) = XMAX(IDIM) for some IDIM.
C                            104  NCF (size of COEF) is
C                                 .LT. NODES(1)*...*NODES(NDIM).
C                            105  NDATA is .LT. 1.
C                            106  NWRK (size of WORK) is too small.
C                            107  SUPRLS failure (usually insufficient
C                                 data) -- ordinarily occurs only if
C                                 XTRAP is zero or WDATA contains all
C                                 zeros.
C
C ALGORITHM              An overdetermined system of linear equations
C                        is formed -- one equation for each data point
C                        plus equations for derivative constraints.
C                        This system is solved using subroutine SUPRLS.
C
C ACCURACY               If there is exactly one data point in the
C                        near vicinity of each node and no extra data,
C                        the resulting spline will agree with the
C                        data values to machine accuracy.  However, if
C                        the problem is overdetermined or the sparse
C                        data option is utilized, the accuracy is hard
C                        to predict.  Basically, smooth functions
C                        require fewer nodes than rough ones for the
C                        same accuracy.
C
C TIMING                 The execution time is roughly proportional
C                        to NDATA*NCOF**2 where NCOF = NODES(1)*...*
C                        NODES(NDIM).
C
C***********************************************************************
C
      SUBROUTINE SPLCC (NDIM,XDATA,L1XDAT,YDATA,NDATA,XMIN,XMAX,NODES,
     1                  XTRAP,COEF,NCF,WORK,NWRK,IERROR)
      DIMENSION       XDATA(L1XDAT,NDATA)    ,YDATA(NDATA)           ,
     1                XMIN(NDIM) ,XMAX(NDIM) ,NODES(NDIM),COEF(NCF)  ,
     2                WORK(NWRK)
      DIMENSION       W(1)
      SAVE
C
      W(1) = -1.
      CALL SPLCW (NDIM,XDATA,L1XDAT,YDATA,W,NDATA,XMIN,XMAX,NODES,
     +            XTRAP,COEF,NCF,WORK,NWRK,IERROR)
C
      RETURN
      END

      SUBROUTINE ZLARF( SIDE, M, N, V, INCV, TAU, C, LDC, WORK )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER          SIDE
      INTEGER            INCV, LDC, M, N
      COMPLEX*16         TAU
*     ..
*     .. Array Arguments ..
      COMPLEX*16         C( LDC, * ), V( * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  ZLARF applies a complex elementary reflector H to a complex M-by-N
*  matrix C, from either the left or the right. H is represented in the
*  form
*
*        H = I - tau * v * v'
*
*  where tau is a complex scalar and v is a complex vector.
*
*  If tau = 0, then H is taken to be the unit matrix.
*
*  To apply H' (the conjugate transpose of H), supply conjg(tau) instead
*  tau.
*
*  Arguments
*  =========
*
*  SIDE    (input) CHARACTER*1
*          = 'L': form  H * C
*          = 'R': form  C * H
*
*  M       (input) INTEGER
*          The number of rows of the matrix C.
*
*  N       (input) INTEGER
*          The number of columns of the matrix C.
*
*  V       (input) COMPLEX*16 array, dimension
*                     (1 + (M-1)*abs(INCV)) if SIDE = 'L'
*                  or (1 + (N-1)*abs(INCV)) if SIDE = 'R'
*          The vector v in the representation of H. V is not used if
*          TAU = 0.
*
*  INCV    (input) INTEGER
*          The increment between elements of v. INCV <> 0.
*
*  TAU     (input) COMPLEX*16
*          The value tau in the representation of H.
*
*  C       (input/output) COMPLEX*16 array, dimension (LDC,N)
*          On entry, the M-by-N matrix C.
*          On exit, C is overwritten by the matrix H * C if SIDE = 'L',
*          or C * H if SIDE = 'R'.
*
*  LDC     (input) INTEGER
*          The leading dimension of the array C. LDC >= max(1,M).
*
*  WORK    (workspace) COMPLEX*16 array, dimension
*                         (N) if SIDE = 'L'
*                      or (M) if SIDE = 'R'
*
*  =====================================================================
*
*     .. Parameters ..
      COMPLEX*16         ONE, ZERO
      PARAMETER          ( ONE = ( 1.0D+0, 0.0D+0 ),
     $                   ZERO = ( 0.0D+0, 0.0D+0 ) )
*     ..
*     .. External Subroutines ..
      EXTERNAL           ZGEMV, ZGERC
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. Executable Statements ..
*
      IF( LSAME( SIDE, 'L' ) ) THEN
*
*        Form  H * C
*
         IF( TAU.NE.ZERO ) THEN
*
*           w := C' * v
*
            CALL ZGEMV( 'Conjugate transpose', M, N, ONE, C, LDC, V,
     $                  INCV, ZERO, WORK, 1 )
*
*           C := C - v * w'
*
            CALL ZGERC( M, N, -TAU, V, INCV, WORK, 1, C, LDC )
         END IF
      ELSE
*
*        Form  C * H
*
         IF( TAU.NE.ZERO ) THEN
*
*           w := C * v
*
            CALL ZGEMV( 'No transpose', M, N, ONE, C, LDC, V, INCV,
     $                  ZERO, WORK, 1 )
*
*           C := C - w * v'
*
            CALL ZGERC( M, N, -TAU, WORK, 1, V, INCV, C, LDC )
         END IF
      END IF
      RETURN
*
*     End of ZLARF
*
      END

      SUBROUTINE CGEGS( JOBVSL, JOBVSR, N, A, LDA, B, LDB, ALPHA, BETA,
     $                  VSL, LDVSL, VSR, LDVSR, WORK, LWORK, RWORK,
     $                  INFO )
*
*  -- LAPACK driver routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          JOBVSL, JOBVSR
      INTEGER            INFO, LDA, LDB, LDVSL, LDVSR, LWORK, N
*     ..
*     .. Array Arguments ..
      REAL               RWORK( * )
      COMPLEX            A( LDA, * ), ALPHA( * ), B( LDB, * ),
     $                   BETA( * ), VSL( LDVSL, * ), VSR( LDVSR, * ),
     $                   WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  This routine is deprecated and has been replaced by routine CGGES.
*
*  CGEGS computes for a pair of N-by-N complex nonsymmetric matrices A,
*  B:  the generalized eigenvalues (alpha, beta), the complex Schur
*  form (A, B), and optionally left and/or right Schur vectors
*  (VSL and VSR).
*
*  (If only the generalized eigenvalues are needed, use the driver CGEGV
*  instead.)
*
*  A generalized eigenvalue for a pair of matrices (A,B) is, roughly
*  speaking, a scalar w or a ratio  alpha/beta = w, such that  A - w*B
*  is singular.  It is usually represented as the pair (alpha,beta),
*  as there is a reasonable interpretation for beta=0, and even for
*  both being zero.  A good beginning reference is the book, "Matrix
*  Computations", by G. Golub & C. van Loan (Johns Hopkins U. Press)
*
*  The (generalized) Schur form of a pair of matrices is the result of
*  multiplying both matrices on the left by one unitary matrix and
*  both on the right by another unitary matrix, these two unitary
*  matrices being chosen so as to bring the pair of matrices into
*  upper triangular form with the diagonal elements of B being
*  non-negative real numbers (this is also called complex Schur form.)
*
*  The left and right Schur vectors are the columns of VSL and VSR,
*  respectively, where VSL and VSR are the unitary matrices
*  which reduce A and B to Schur form:
*
*  Schur form of (A,B) = ( (VSL)**H A (VSR), (VSL)**H B (VSR) )
*
*  Arguments
*  =========
*
*  JOBVSL   (input) CHARACTER*1
*          = 'N':  do not compute the left Schur vectors;
*          = 'V':  compute the left Schur vectors.
*
*  JOBVSR   (input) CHARACTER*1
*          = 'N':  do not compute the right Schur vectors;
*          = 'V':  compute the right Schur vectors.
*
*  N       (input) INTEGER
*          The order of the matrices A, B, VSL, and VSR.  N >= 0.
*
*  A       (input/output) COMPLEX array, dimension (LDA, N)
*          On entry, the first of the pair of matrices whose generalized
*          eigenvalues and (optionally) Schur vectors are to be
*          computed.
*          On exit, the generalized Schur form of A.
*
*  LDA     (input) INTEGER
*          The leading dimension of A.  LDA >= max(1,N).
*
*  B       (input/output) COMPLEX array, dimension (LDB, N)
*          On entry, the second of the pair of matrices whose
*          generalized eigenvalues and (optionally) Schur vectors are
*          to be computed.
*          On exit, the generalized Schur form of B.
*
*  LDB     (input) INTEGER
*          The leading dimension of B.  LDB >= max(1,N).
*
*  ALPHA   (output) COMPLEX array, dimension (N)
*  BETA    (output) COMPLEX array, dimension (N)
*          On exit,  ALPHA(j)/BETA(j), j=1,...,N, will be the
*          generalized eigenvalues.  ALPHA(j), j=1,...,N  and  BETA(j),
*          j=1,...,N  are the diagonals of the complex Schur form (A,B)
*          output by CGEGS.  The  BETA(j) will be non-negative real.
*
*          Note: the quotients ALPHA(j)/BETA(j) may easily over- or
*          underflow, and BETA(j) may even be zero.  Thus, the user
*          should avoid naively computing the ratio alpha/beta.
*          However, ALPHA will be always less than and usually
*          comparable with norm(A) in magnitude, and BETA always less
*          than and usually comparable with norm(B).
*
*  VSL     (output) COMPLEX array, dimension (LDVSL,N)
*          If JOBVSL = 'V', VSL will contain the left Schur vectors.
*          (See "Purpose", above.)
*          Not referenced if JOBVSL = 'N'.
*
*  LDVSL   (input) INTEGER
*          The leading dimension of the matrix VSL. LDVSL >= 1, and
*          if JOBVSL = 'V', LDVSL >= N.
*
*  VSR     (output) COMPLEX array, dimension (LDVSR,N)
*          If JOBVSR = 'V', VSR will contain the right Schur vectors.
*          (See "Purpose", above.)
*          Not referenced if JOBVSR = 'N'.
*
*  LDVSR   (input) INTEGER
*          The leading dimension of the matrix VSR. LDVSR >= 1, and
*          if JOBVSR = 'V', LDVSR >= N.
*
*  WORK    (workspace/output) COMPLEX array, dimension (LWORK)
*          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*
*  LWORK   (input) INTEGER
*          The dimension of the array WORK.  LWORK >= max(1,2*N).
*          For good performance, LWORK must generally be larger.
*          To compute the optimal value of LWORK, call ILAENV to get
*          blocksizes (for CGEQRF, CUNMQR, and CUNGQR.)  Then compute:
*          NB  -- MAX of the blocksizes for CGEQRF, CUNMQR, and CUNGQR;
*          the optimal LWORK is N*(NB+1).
*
*          If LWORK = -1, then a workspace query is assumed; the routine
*          only calculates the optimal size of the WORK array, returns
*          this value as the first entry of the WORK array, and no error
*          message related to LWORK is issued by XERBLA.
*
*  RWORK   (workspace) REAL array, dimension (3*N)
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value.
*          =1,...,N:
*                The QZ iteration failed.  (A,B) are not in Schur
*                form, but ALPHA(j) and BETA(j) should be correct for
*                j=INFO+1,...,N.
*          > N:  errors that usually indicate LAPACK problems:
*                =N+1: error return from CGGBAL
*                =N+2: error return from CGEQRF
*                =N+3: error return from CUNMQR
*                =N+4: error return from CUNGQR
*                =N+5: error return from CGGHRD
*                =N+6: error return from CHGEQZ (other than failed
*                                               iteration)
*                =N+7: error return from CGGBAK (computing VSL)
*                =N+8: error return from CGGBAK (computing VSR)
*                =N+9: error return from CLASCL (various places)
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ZERO, ONE
      PARAMETER          ( ZERO = 0.0E0, ONE = 1.0E0 )
      COMPLEX            CZERO, CONE
      PARAMETER          ( CZERO = ( 0.0E0, 0.0E0 ),
     $                   CONE = ( 1.0E0, 0.0E0 ) )
*     ..
*     .. Local Scalars ..
      LOGICAL            ILASCL, ILBSCL, ILVSL, ILVSR, LQUERY
      INTEGER            ICOLS, IHI, IINFO, IJOBVL, IJOBVR, ILEFT,
     $                   ILO, IRIGHT, IROWS, IRWORK, ITAU, IWORK,
     $                   LOPT, LWKMIN, LWKOPT, NB, NB1, NB2, NB3
      REAL               ANRM, ANRMTO, BIGNUM, BNRM, BNRMTO, EPS,
     $                   SAFMIN, SMLNUM
*     ..
*     .. External Subroutines ..
      EXTERNAL           CGEQRF, CGGBAK, CGGBAL, CGGHRD, CHGEQZ, CLACPY,
     $                   CLASCL, CLASET, CUNGQR, CUNMQR, XERBLA
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            ILAENV
      REAL               CLANGE, SLAMCH
      EXTERNAL           ILAENV, LSAME, CLANGE, SLAMCH
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          INT, MAX
*     ..
*     .. Executable Statements ..
*
*     Decode the input arguments
*
      IF( LSAME( JOBVSL, 'N' ) ) THEN
         IJOBVL = 1
         ILVSL = .FALSE.
      ELSE IF( LSAME( JOBVSL, 'V' ) ) THEN
         IJOBVL = 2
         ILVSL = .TRUE.
      ELSE
         IJOBVL = -1
         ILVSL = .FALSE.
      END IF
*
      IF( LSAME( JOBVSR, 'N' ) ) THEN
         IJOBVR = 1
         ILVSR = .FALSE.
      ELSE IF( LSAME( JOBVSR, 'V' ) ) THEN
         IJOBVR = 2
         ILVSR = .TRUE.
      ELSE
         IJOBVR = -1
         ILVSR = .FALSE.
      END IF
*
*     Test the input arguments
*
      LWKMIN = MAX( 2*N, 1 )
      LWKOPT = LWKMIN
      WORK( 1 ) = LWKOPT
      LQUERY = ( LWORK.EQ.-1 )
      INFO = 0
      IF( IJOBVL.LE.0 ) THEN
         INFO = -1
      ELSE IF( IJOBVR.LE.0 ) THEN
         INFO = -2
      ELSE IF( N.LT.0 ) THEN
         INFO = -3
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -5
      ELSE IF( LDB.LT.MAX( 1, N ) ) THEN
         INFO = -7
      ELSE IF( LDVSL.LT.1 .OR. ( ILVSL .AND. LDVSL.LT.N ) ) THEN
         INFO = -11
      ELSE IF( LDVSR.LT.1 .OR. ( ILVSR .AND. LDVSR.LT.N ) ) THEN
         INFO = -13
      ELSE IF( LWORK.LT.LWKMIN .AND. .NOT.LQUERY ) THEN
         INFO = -15
      END IF
*
      IF( INFO.EQ.0 ) THEN
         NB1 = ILAENV( 1, 'CGEQRF', ' ', N, N, -1, -1 )
         NB2 = ILAENV( 1, 'CUNMQR', ' ', N, N, N, -1 )
         NB3 = ILAENV( 1, 'CUNGQR', ' ', N, N, N, -1 )
         NB = MAX( NB1, NB2, NB3 )
         LOPT = N*(NB+1)
         WORK( 1 ) = LOPT
      END IF
*
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'CGEGS ', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
*
*     Get machine constants
*
      EPS = SLAMCH( 'E' )*SLAMCH( 'B' )
      SAFMIN = SLAMCH( 'S' )
      SMLNUM = N*SAFMIN / EPS
      BIGNUM = ONE / SMLNUM
*
*     Scale A if max element outside range [SMLNUM,BIGNUM]
*
      ANRM = CLANGE( 'M', N, N, A, LDA, RWORK )
      ILASCL = .FALSE.
      IF( ANRM.GT.ZERO .AND. ANRM.LT.SMLNUM ) THEN
         ANRMTO = SMLNUM
         ILASCL = .TRUE.
      ELSE IF( ANRM.GT.BIGNUM ) THEN
         ANRMTO = BIGNUM
         ILASCL = .TRUE.
      END IF
*
      IF( ILASCL ) THEN
         CALL CLASCL( 'G', -1, -1, ANRM, ANRMTO, N, N, A, LDA, IINFO )
         IF( IINFO.NE.0 ) THEN
            INFO = N + 9
            RETURN
         END IF
      END IF
*
*     Scale B if max element outside range [SMLNUM,BIGNUM]
*
      BNRM = CLANGE( 'M', N, N, B, LDB, RWORK )
      ILBSCL = .FALSE.
      IF( BNRM.GT.ZERO .AND. BNRM.LT.SMLNUM ) THEN
         BNRMTO = SMLNUM
         ILBSCL = .TRUE.
      ELSE IF( BNRM.GT.BIGNUM ) THEN
         BNRMTO = BIGNUM
         ILBSCL = .TRUE.
      END IF
*
      IF( ILBSCL ) THEN
         CALL CLASCL( 'G', -1, -1, BNRM, BNRMTO, N, N, B, LDB, IINFO )
         IF( IINFO.NE.0 ) THEN
            INFO = N + 9
            RETURN
         END IF
      END IF
*
*     Permute the matrix to make it more nearly triangular
*
      ILEFT = 1
      IRIGHT = N + 1
      IRWORK = IRIGHT + N
      IWORK = 1
      CALL CGGBAL( 'P', N, A, LDA, B, LDB, ILO, IHI, RWORK( ILEFT ),
     $             RWORK( IRIGHT ), RWORK( IRWORK ), IINFO )
      IF( IINFO.NE.0 ) THEN
         INFO = N + 1
         GO TO 10
      END IF
*
*     Reduce B to triangular form, and initialize VSL and/or VSR
*
      IROWS = IHI + 1 - ILO
      ICOLS = N + 1 - ILO
      ITAU = IWORK
      IWORK = ITAU + IROWS
      CALL CGEQRF( IROWS, ICOLS, B( ILO, ILO ), LDB, WORK( ITAU ),
     $             WORK( IWORK ), LWORK+1-IWORK, IINFO )
      IF( IINFO.GE.0 )
     $   LWKOPT = MAX( LWKOPT, INT( WORK( IWORK ) )+IWORK-1 )
      IF( IINFO.NE.0 ) THEN
         INFO = N + 2
         GO TO 10
      END IF
*
      CALL CUNMQR( 'L', 'C', IROWS, ICOLS, IROWS, B( ILO, ILO ), LDB,
     $             WORK( ITAU ), A( ILO, ILO ), LDA, WORK( IWORK ),
     $             LWORK+1-IWORK, IINFO )
      IF( IINFO.GE.0 )
     $   LWKOPT = MAX( LWKOPT, INT( WORK( IWORK ) )+IWORK-1 )
      IF( IINFO.NE.0 ) THEN
         INFO = N + 3
         GO TO 10
      END IF
*
      IF( ILVSL ) THEN
         CALL CLASET( 'Full', N, N, CZERO, CONE, VSL, LDVSL )
         CALL CLACPY( 'L', IROWS-1, IROWS-1, B( ILO+1, ILO ), LDB,
     $                VSL( ILO+1, ILO ), LDVSL )
         CALL CUNGQR( IROWS, IROWS, IROWS, VSL( ILO, ILO ), LDVSL,
     $                WORK( ITAU ), WORK( IWORK ), LWORK+1-IWORK,
     $                IINFO )
         IF( IINFO.GE.0 )
     $      LWKOPT = MAX( LWKOPT, INT( WORK( IWORK ) )+IWORK-1 )
         IF( IINFO.NE.0 ) THEN
            INFO = N + 4
            GO TO 10
         END IF
      END IF
*
      IF( ILVSR )
     $   CALL CLASET( 'Full', N, N, CZERO, CONE, VSR, LDVSR )
*
*     Reduce to generalized Hessenberg form
*
      CALL CGGHRD( JOBVSL, JOBVSR, N, ILO, IHI, A, LDA, B, LDB, VSL,
     $             LDVSL, VSR, LDVSR, IINFO )
      IF( IINFO.NE.0 ) THEN
         INFO = N + 5
         GO TO 10
      END IF
*
*     Perform QZ algorithm, computing Schur vectors if desired
*
      IWORK = ITAU
      CALL CHGEQZ( 'S', JOBVSL, JOBVSR, N, ILO, IHI, A, LDA, B, LDB,
     $             ALPHA, BETA, VSL, LDVSL, VSR, LDVSR, WORK( IWORK ),
     $             LWORK+1-IWORK, RWORK( IRWORK ), IINFO )
      IF( IINFO.GE.0 )
     $   LWKOPT = MAX( LWKOPT, INT( WORK( IWORK ) )+IWORK-1 )
      IF( IINFO.NE.0 ) THEN
         IF( IINFO.GT.0 .AND. IINFO.LE.N ) THEN
            INFO = IINFO
         ELSE IF( IINFO.GT.N .AND. IINFO.LE.2*N ) THEN
            INFO = IINFO - N
         ELSE
            INFO = N + 6
         END IF
         GO TO 10
      END IF
*
*     Apply permutation to VSL and VSR
*
      IF( ILVSL ) THEN
         CALL CGGBAK( 'P', 'L', N, ILO, IHI, RWORK( ILEFT ),
     $                RWORK( IRIGHT ), N, VSL, LDVSL, IINFO )
         IF( IINFO.NE.0 ) THEN
            INFO = N + 7
            GO TO 10
         END IF
      END IF
      IF( ILVSR ) THEN
         CALL CGGBAK( 'P', 'R', N, ILO, IHI, RWORK( ILEFT ),
     $                RWORK( IRIGHT ), N, VSR, LDVSR, IINFO )
         IF( IINFO.NE.0 ) THEN
            INFO = N + 8
            GO TO 10
         END IF
      END IF
*
*     Undo scaling
*
      IF( ILASCL ) THEN
         CALL CLASCL( 'U', -1, -1, ANRMTO, ANRM, N, N, A, LDA, IINFO )
         IF( IINFO.NE.0 ) THEN
            INFO = N + 9
            RETURN
         END IF
         CALL CLASCL( 'G', -1, -1, ANRMTO, ANRM, N, 1, ALPHA, N, IINFO )
         IF( IINFO.NE.0 ) THEN
            INFO = N + 9
            RETURN
         END IF
      END IF
*
      IF( ILBSCL ) THEN
         CALL CLASCL( 'U', -1, -1, BNRMTO, BNRM, N, N, B, LDB, IINFO )
         IF( IINFO.NE.0 ) THEN
            INFO = N + 9
            RETURN
         END IF
         CALL CLASCL( 'G', -1, -1, BNRMTO, BNRM, N, 1, BETA, N, IINFO )
         IF( IINFO.NE.0 ) THEN
            INFO = N + 9
            RETURN
         END IF
      END IF
*
   10 CONTINUE
      WORK( 1 ) = LWKOPT
*
      RETURN
*
*     End of CGEGS
*
      END

C NCLFORTSTART
      SUBROUTINE DH2SDRV(DATI,DATO,HYA,HYB,P0,SIGI,SIGO,INTYP,PSFC,NLVI,
     +                   NLVO)
      IMPLICIT NONE


      INTEGER INTYP,NLVI,NLVO
      DOUBLE PRECISION DATI(NLVI),DATO(NLVO),P0,PSFC,HYA(NLVO),
     +                 HYB(NLVO),SIGI(NLVI),SIGO(NLVO)
C NCLEND

c NCL:  xHybrid = sigma2hybrid(xSigma,sigma,hya,hyb,P0,psfc,intyp)

C*PL*ERROR* Comment line too long
c          sigo must be created in the interface. Need only be done once.
c          It is the same size as hya/hyb.

C         ----- ORIGINAL FUNCTION DOCUMENTATION --------------
C****     THIS ROUTINE INTERPLOATES DATA TO MODEL HYBRID
C****     COORDINATES FROM SIGMA COORDINATES USING SIGMA SURFACES.
C****     THE TYPE OF INTERPOLATION IS CURRENTLY A VARIANT OF
C****     TRANSFORMED SIGMA COORDINATES WITH THE  INTERPOLATION TYPE
C****     SPECIFIED BY INTYP.  ALL HYBRID COORDINATE VALUES ARE
C****     TRANSFORMED TO SIGMA VALUES. WHERE THE
C****     FORMULA FOR THE PRESSURE OF A HYBRID SURFACE IS;
C****          P(K) = HBCOFA(LEVH,K)*P0 + HBCOFB(LEVH,K)*PSFC
C****     THE RELATIONSHIP OF PRESSURE AND SIGMA IS;
C****          SIG(K) = P(K)/PSFC
C****     HENCE,
C****          SIG(K) = HBCOFA(K)*P0/PSFC + HBCOFB(K)
C****     WHERE,
C****          HBCOFA - IS THE "A" OR PRESSURE HYBRID COEF
C****          LEVH   - IS THE LAYER SURFACE (INTERFACE=1 MIDPOINT=2)
C****          P0     - IS THE BASE PRESSURE (PA)
C****          K      - THE LEVEL INDEX (RUNNING FROM TOP TO BOTTOM)
C****          HBCOFB - IS THE "B" OR SIGMA COEFICIENT
C****          P(K)   - IS THE PRESSURE OF A HYBRID SURFACE (PA).
C****          PSFC   - IS THE SURFACE PRESSURE IN PASCALS

C****                   (MB = .01*PASCALS   : PA = 100*MB/hPA)

C****        SIGI    - 1 DIMENSIONAL ARRAY CONTAINING MODEL SIGMA
C****                  SURFACES.  ARRAY IS NLVI.
C****                  AS WITH THE HYBRID COEFFICIENTS THEY ARE
C****                  ORDERED FROM TOP TO BOTTOM.


      INTEGER N

c convert hybrid to sigma. P0 and psfc are in the same units.

      DO N = 1,NLVO
          SIGO(N) = (HYA(N)*P0)/PSFC + HYB(N)
      END DO

      CALL DS2HBD(DATI,DATO,INTYP,SIGI,SIGO,NLVI,NLVO)

      RETURN
      END
c ------------
      SUBROUTINE DS2HBD(FKR,FKM,INTYP,SIGLEVI,SIGLEVO,NLI,NLO)
      IMPLICIT NONE
C
C****     THIS ROUTINE INTERP. A VERTICAL COLUMN OF SIGMA
C****     COORDINATE DATA TO HYBRID COORDINATES.
C
C****     ON INPUT-
C****        FKR     - INPUT DATA ON SIGMA COORDINATES
C****        FKM     - OUTPUT DATA  ON HYBRID COORD.
C****        INTYP   - TYPE OF INTERP. TO BE PERFORMED (1 - LINEAR,
C****                   2 - LOG ,3 - LOG-LOG
C****        SIGLEVI - 2 DIMENSIONAL ARRAY CONTAINING MODEL SIGMA
C****                  SURFACES.  ARRAY IS 2*NLVIP1.  THE 1ST INDEX
C****                  TAKES ON THE VALUE OF EITHER
C****                    1 - FOR LEVEL INTERFACES (OR 1/2 LEVELS) OR;
C****                    2 - FOR LEVEL MIDPOINTS  (OR FULL LEVELS WHERE
C****                        VIRTUALLY ALL VARIABLES ARE LOCATED)
C****                   AS WITH THE HYBRID COEFFICIENTS THEY ARE
C****                   ORDERED FROM TOP TO BOTTOM.
C****        SIGLEVO - ARRAY SPACE TO HOLD OUTPUT PRESURE SURFACES
C****                  FOR EITHER A 1/2 OF FULL LEVELS.  CURRENTLY
C****                  ALL VARIABLES ARE ON FULL LEVELS.
C****        NLI     - NO. OF PRESS SFCS.
C****        NLIP1   - NLI + 1
C****        NLO     - NO. OF MODEL HYBRID LEVELS.
C****
C****     ON OUTPUT-
C****        FKM - OUTPUT DATA ON MODEL HYBRID COORDINATES
C
C     INTEGER INTYP, NLI, NLIP1, NLO, IPHLV
C     REAL    FKR(NLI),FKM(NLO),SIGLEVO(NLO),SIGLEVI(NLIP1)  ! original
      INTEGER INTYP,NLI,NLO
      DOUBLE PRECISION FKR(NLI),FKM(NLO),SIGLEVO(NLO),SIGLEVI(NLI)

      INTEGER K,KP,IPRINT
      DOUBLE PRECISION A2LN,A1
C
C****     STATEMENT FCN. FOR DOUBLE ALOG. INTERP ON PRESSURE SURFACES
C****     PRESUMES PRESSURE IS IN MB
C
C     A2LN(A1)=ALOG(ALOG(A1+2.72))
C
C****     STATEMENT FCN. FOR DOUBLE ALOG. INTERP ON SIGMA SURFACES.
C****     SETS UP ROUGH UPPER BPOUND SIMILAR TO STATEMENT FCN FOR
C****     PRESSURE. I.E.    FIXED VALUE LN(LN(P) = LN(LN(FIXED VAL)
C****     AT .001 SIGMA OR ABOUT 1 MB
C
      A2LN(A1) = DLOG(DLOG(A1+1.001D0))
C
C****     BRACKET LEVEL TO BE INTERP. UNLESS MODEL IS AT EXTREMA OF REAL
C****     DATA LEVELS
C
      DO 60 K = 1,NLO
C
C****     IF BRANCH FOR MODEL TOP
C
          IF (SIGLEVO(K).LE.SIGLEVI(2)) THEN
              KP = 1
              GO TO 20
C
C****     IF BRANCH FOR MODEL BOTTOM
C
          ELSE IF (SIGLEVO(K).GE.SIGLEVI(NLI-1)) THEN
              KP = NLI - 1
              GO TO 20
C
C****     IF BRANCH FOR MODEL INTERIOR
C
          ELSE
              KP = 1
   10         CONTINUE
              KP = KP + 1
              IF (SIGLEVO(K).LE.SIGLEVI(KP+1)) GO TO 20
              GO TO 10
          END IF
   20     CONTINUE
C
C****     LINEAR INTERP.
C
          IF (INTYP.EQ.1) THEN
              FKM(K) = FKR(KP) + (FKR(KP+1)-FKR(KP))*
     +                 (SIGLEVO(K)-SIGLEVI(KP))/
     +                 (SIGLEVI(KP+1)-SIGLEVI(KP))
C
C****     LOG INTERPOLATION.
C
          ELSE IF (INTYP.EQ.2) THEN
              FKM(K) = FKR(KP) + (FKR(KP+1)-FKR(KP))*
     +                 DLOG(SIGLEVO(K)/SIGLEVI(KP))/
     +                 DLOG(SIGLEVI(KP+1)/SIGLEVI(KP))
C
C****     FOR LOG LOG INTERP. NOTE A2LN IS A STATEMENT FCN.
C
          ELSE IF (INTYP.EQ.3) THEN
              FKM(K) = FKR(KP) + (FKR(KP+1)-FKR(KP))*
     +                 (A2LN(SIGLEVO(K))-A2LN(SIGLEVI(KP)))/
     +                 (A2LN(SIGLEVI(KP+1))-A2LN(SIGLEVI(KP)))
          END IF
   60 CONTINUE
      RETURN
      END

C
C	$Id: drawpv.f,v 1.5 2008-07-27 00:23:02 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE DRAWPV (IX,IY,IND)
C
C DRAWPV INTERCEPTS THE CALL TO PLOTIT TO CHECK IF THE PEN HAS TO BE
C MOVED OR IF IT IS ALREADY CLOSE ENOUGH TO THE WANTED POSITION.
C IF IND=2 NEVER MOVE PEN, JUST UPDATE VARIABLES IXSTOR AND IYSTOR.
C
C IN IXSTOR AND IYSTOR THE CURRENT POSITION OF THE PEN IS SAVED.
C
      COMMON /DSHDC/ IXSTOR,IYSTOR
C
      COMMON/INTPR/IPAU,FPART,TENSN,NP,SMALL,L1,ADDLR,ADDTB,MLLINE,
     1    ICLOSE
      SAVE
      IIND = IND + 1
      GOTO (100,90,105), IIND
C
   90 CONTINUE
C
C DRAW LINE AND SAVE POSITION OF PEN.
C
      IXSTOR = IX
      IYSTOR = IY
      CALL PLOTIT (IXSTOR,IYSTOR,1)
      GOTO 110
C
  100 CONTINUE
C
C CHECK IF PEN IS ALREADY CLOSE ENOUGH TO THE WANTED POSITION.
C
      IF ((ABS(IXSTOR-IX)+ABS(IYSTOR-IY)) .LE. ICLOSE) GO TO 110
C
      IXSTOR = IX
      IYSTOR = IY
      CALL PLOTIT (IXSTOR,IYSTOR,0)
      GOTO 110
C
  105 CONTINUE
C
C DO NOT MOVE PEN. JUST UPDATE VARIABLES IXSTOR AND IYSTOR.
C
      IXSTOR = IX
      IYSTOR = IY
C
  110 CONTINUE
C
      RETURN
      END

C
C $Id: basic05f.f,v 1.14 2010-03-15 22:49:23 haley Exp $
C
C***********************************************************************
C                                                                      *
C                            Copyright (C)  1995                       *
C                 University Corporation for Atmospheric Research      *
C                            All Rights Reserved                       *
C                                                                      *
C***********************************************************************
C
C      File:            basic05f.f
C
C      Author:          Tim Scheitlin (converted by Ed Stautler)
C                       National Center for Atmospheric Research
C                       PO 3000, Boulder, Colorado
C
C      Date:            Mon Mar 20 10:43:42 MST 1995
C
C      Description:     This example demonstrates how to read, display, and
C                       manipulate colormaps.
C
C             The NG 4.x HLU software supports several different predefined
C             colormaps of various sizes.  This example demonstrates how to
C             display each of those colormaps using the labelbar utility.
C             This example also shows how to change entries in a colormap
C             and create a completely new colormap.
C
      external NhlFAppClass
      external NhlFCairoWindowWorkstationClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFLabelBarClass
      external NhlFTextItemClass

      integer i, ierr
      integer num_dims,len_dims(2)
      integer appid,wks,lbar,rlist,glist,text
      character*7  wks_type
      character*3 colorindices(255)

      real cmap(3,8)
      real newcmap(3,100)

C
C Define the workstation type
C
      wks_type = "x11"

C Initialize libraries and create a resource list.

      call NhlFInitialize
      call NhlFRLCreate(rlist,'SETRL')

      call NhlFRLClear(rlist)
      call NhlFCreate(appid,'appid',NhlFAppClass,0,rlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
        call NhlFRLClear(rlist)

        call NhlFRLSetstring(rlist,'wkMetaName','./basic05f.ncgm',ierr)

        call NhlFCreate(wks,'wks',
     1        NhlFNcgmWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C Create an XWorkstation object that uses the default colormap.

        call NhlFRLClear(rlist)

        call NhlFRLSetString(rlist,'wkPause','True',ierr)

C Set color mode to private so that there is no contention for colors
C        call NhlFRLSetString(rlist,'wkXColorMode','private',ierr)

        call NhlFCreate(wks,'wks',
     +     NhlFCairoWindowWorkstationClass,0,
     1     rlist,ierr)

      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PostScript workstation.
C
        call NhlFRLClear(rlist)

        call NhlFRLSetstring(rlist,'wkPSFileName','./basic05f.ps',ierr)

        call NhlFCreate(wks,'wks',
     1        NhlFPSWorkstationClass,0,rlist,ierr)

      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
        call NhlFRLClear(rlist)

        call NhlFRLSetstring(rlist,'wkPDFFileName','./basic05f.pdf',
     1        ierr)

        call NhlFCreate(wks,'wks',
     1        NhlFPDFWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     1         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF object.
C
        call NhlFRLClear(rlist)

        call NhlFRLSetstring(rlist,'wkFileName','./basic05f',
     1        ierr)
        call NhlFRLSetstring(rlist,'wkFormat',wks_type,
     1        ierr)

        call NhlFCreate(wks,'wks',
     1        NhlFCairoPSPDFWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG object.
C
        call NhlFRLClear(rlist)

        call NhlFRLSetstring(rlist,'wkFileName','./basic05f',
     1        ierr)
        call NhlFRLSetstring(rlist,'wkFormat',wks_type,
     1        ierr)

        call NhlFCreate(wks,'wks',
     1        NhlFCairoImageWorkstationClass,0,rlist,ierr)
      endif

C Initialize labels for the colormap entries

      do 100 i=1,255
           write (colorindices(i),111) i
 111       format (I3)
 100  continue

C Create a labelbar object. 

      call NhlFRLClear(rlist)

C Assign the labels
      call NhlFRLSetStringArray(rlist,'lbLabelStrings',
     1      colorindices,232,ierr)

C Label every 5th entry 
      call NhlFRLSetInteger(rlist,'lbLabelStride',5,ierr)

C Single pattern used for fill
      call NhlFRLSetString(rlist,'lbMonoFillPattern','True',ierr)

C Set fill pattern to solid
      call NhlFRLSetString(rlist,'lbFillPattern','SolidFill',ierr)

C No lines between colors
      call NhlFRLSetString(rlist,'lbBoxLinesOn','False',ierr)

C Display 255 entries
      call NhlFRLSetInteger(rlist,'lbBoxCount',255,ierr)

C Turn off labelbar perimeter
      call NhlFRLSetString(rlist,'lbPerimOn','False',ierr)

C Plot title
      call NhlFRLSetString(rlist,'lbTitleString',
     1      '(New) Default Colormap',ierr)

C Title font
      call NhlFRLSetString(rlist,'lbTitleFont','Helvetica-bold',ierr)

C Label font
      call NhlFRLSetString(rlist,'lbLabelFont','Helvetica',ierr)

C Set viewport to max size
      call NhlFRLSetFloat(rlist,'vpXF',0.0,ierr)
      call NhlFRLSetFloat(rlist,'vpYF',1.0,ierr)
      call NhlFRLSetFloat(rlist,'vpHeightF',1.0,ierr)
      call NhlFRLSetFloat(rlist,'vpWidthF',1.0,ierr)

      call NhlFCreate(lbar,'lbar',NhlFLabelBarClass,wks,
     1      rlist,ierr)

C Create a text label
      call NhlFRLClear(rlist)

C Set the font
      call NhlFRLSetString(rlist,'txFont','Helvetica-bold',ierr)

C Set position and height
      call NhlFRLSetFloat(rlist,'txPosXF',.5,ierr)
      call NhlFRLSetFloat(rlist,'txPosYF',.03,ierr)
      call NhlFRLSetFloat(rlist,'txFontHeightF',.035,ierr)

C Set the function code to the "*" character so that the 
C default function code character, the colon, can be used
C in the "txString" resource.
      call NhlFRLSetString(rlist,'txFuncCode','*',ierr)

C Set the text value
      call NhlFRLSetString(rlist,'txString','Note: Entry 0 is the backgr
     $ound color',ierr)

      call NhlFCreate(text,'text',NhlFtextItemClass,wks,
     1      rlist,ierr)


C Draw and frame the labelbar
      call NhlFDraw(lbar,ierr)
      call NhlFDraw(text,ierr)
      call NhlFFrame(wks,ierr)

C Change the colormap to the old default colormap
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'wkColorMap','default',ierr)
      call NhlFSetValues(wks,rlist,ierr)

      call NhlFRLClear(rlist)
      call NhlFRLSetInteger(rlist,'lbBoxCount',31,ierr)
      call NhlFRLSetString(rlist,'lbTitleString',
     1      '(Old) Default Colormap',ierr)
      call NhlFSetValues(lbar,rlist,ierr)

C Draw and frame the labelbar
      call NhlFDraw(lbar,ierr)
      call NhlFDraw(text,ierr)
      call NhlFFrame(wks,ierr)

C Change the colormap to one of the predefined colormaps
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'wkColorMap','cyclic',ierr)
      call NhlFSetValues(wks,rlist,ierr)

C Change the labelbar title, annotation, and number of entries.
      call NhlFRLClear(rlist)

C Labelbar title 
      call NhlFRLSetString(rlist,'lbTitleString','Cyclic Colormap',ierr)

C Label every entry
      call NhlFRLSetInteger(rlist,'lbLabelStride',1,ierr)

C Number of entries to display
      call NhlFRLSetInteger(rlist,'lbBoxCount',7,ierr)

      call NhlFSetValues(lbar,rlist,ierr)

C Draw and frame the labelbar
      call NhlFDraw(lbar,ierr)
      call NhlFDraw(text,ierr)
      call NhlFFrame(wks,ierr)

C Change the colormap to one of the predefined colormaps
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'wkColorMap','gscyclic',ierr)
      call NhlFSetValues(wks,rlist,ierr)

C Change the labelbar title, annotation, and number of entries.
      call NhlFRLClear(rlist)

C Labelbar title 
      call NhlFRLSetString(rlist,'lbTitleString','Gscyclic Colormap',
     $     ierr)

C Label every entry
      call NhlFRLSetInteger(rlist,'lbLabelStride',1,ierr)

C Number of entries to display
      call NhlFRLSetInteger(rlist,'lbBoxCount',7,ierr)

      call NhlFSetValues(lbar,rlist,ierr)

C Draw and frame the labelbar
      call NhlFDraw(lbar,ierr)
      call NhlFDraw(text,ierr)
      call NhlFFrame(wks,ierr)

C Change the colormap to one of the predefined colormaps
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'wkColorMap','gsltod',ierr)
      call NhlFSetValues(wks,rlist,ierr)

C Change the labelbar title, annotation, and number of entries.
      call NhlFRLClear(rlist)

C Labelbar title 
      call NhlFRLSetString(rlist,'lbTitleString','Gsltod Colormap',
     $     ierr)

C Label every other entry
      call NhlFRLSetInteger(rlist,'lbLabelStride',2,ierr)

C Number of entries to display
      call NhlFRLSetInteger(rlist,'lbBoxCount',32,ierr)

      call NhlFSetValues(lbar,rlist,ierr)

C Draw and frame the labelbar
      call NhlFDraw(lbar,ierr)
      call NhlFDraw(text,ierr)
      call NhlFFrame(wks,ierr)

C Change the colormap to one of the predefined colormaps
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'wkColorMap','gsdtol',ierr)
      call NhlFSetValues(wks,rlist,ierr)

C Change the labelbar title, annotation, and number of entries.
      call NhlFRLClear(rlist)

C Labelbar title 
      call NhlFRLSetString(rlist,'lbTitleString','Gsdtol Colormap',
     $     ierr)

C Label every other entry
      call NhlFRLSetInteger(rlist,'lbLabelStride',2,ierr)

C Number of entries to display
      call NhlFRLSetInteger(rlist,'lbBoxCount',32,ierr)

      call NhlFSetValues(lbar,rlist,ierr)

C Draw and frame the labelbar
      call NhlFDraw(lbar,ierr)
      call NhlFDraw(text,ierr)
      call NhlFFrame(wks,ierr)

C Change the colormap to one of the predefined colormaps
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'wkColorMap','uniform',ierr)
      call NhlFSetValues(wks,rlist,ierr)

C Change the labelbar title, annotation, and number of entries.
      call NhlFRLClear(rlist)

C Labelbar title 
      call NhlFRLSetString(rlist,'lbTitleString','Uniform Colormap',
     $     ierr)

C Label every 10th entry
      call NhlFRLSetInteger(rlist,'lbLabelStride',10,ierr)

C Number of entries to display
      call NhlFRLSetInteger(rlist,'lbBoxCount',112,ierr)

      call NhlFSetValues(lbar,rlist,ierr)

C Draw and frame the labelbar
      call NhlFDraw(lbar,ierr)
      call NhlFDraw(text,ierr)
      call NhlFFrame(wks,ierr)


C Change the colormap to one of the predefined colormaps
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'wkColorMap','temp1',ierr)
      call NhlFSetValues(wks,rlist,ierr)

C Change the labelbar title, annotation, and number of entries.
      call NhlFRLClear(rlist)

C Labelbar title 
      call NhlFRLSetString(rlist,'lbTitleString','Temp1 Colormap',
     $     ierr)

C Label every 5th entry
      call NhlFRLSetInteger(rlist,'lbLabelStride',5,ierr)

C Number of entries to display
      call NhlFRLSetInteger(rlist,'lbBoxCount',62,ierr)

      call NhlFSetValues(lbar,rlist,ierr)

C Draw and frame the labelbar
      call NhlFDraw(lbar,ierr)
      call NhlFDraw(text,ierr)
      call NhlFFrame(wks,ierr)


C Change the colormap to one of the predefined colormaps
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'wkColorMap','psgcap',ierr)
      call NhlFSetValues(wks,rlist,ierr)

C Change the labelbar title, annotation, and number of entries.
      call NhlFRLClear(rlist)

C Labelbar title 
      call NhlFRLSetString(rlist,'lbTitleString','Psgcap Colormap',
     $     ierr)

C Label every 15th entry
      call NhlFRLSetInteger(rlist,'lbLabelStride',15,ierr)

C Number of entries to display
      call NhlFRLSetInteger(rlist,'lbBoxCount',230,ierr)

      call NhlFSetValues(lbar,rlist,ierr)

C Draw and frame the labelbar
      call NhlFDraw(lbar,ierr)
      call NhlFDraw(text,ierr)
      call NhlFFrame(wks,ierr)


C Change the colormap to one of the predefined colormaps
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'wkColorMap','example',ierr)
      call NhlFSetValues(wks,rlist,ierr)

C Change the labelbar title, annotation, and number of entries.
      call NhlFRLClear(rlist)

C Labelbar title 
      call NhlFRLSetString(rlist,'lbTitleString','Example Colormap',
     $     ierr)

C Label every 15th entry
      call NhlFRLSetInteger(rlist,'lbLabelStride',10,ierr)

C Number of entries to display
      call NhlFRLSetInteger(rlist,'lbBoxCount',114,ierr)

      call NhlFSetValues(lbar,rlist,ierr)

C Draw and frame the labelbar
      call NhlFDraw(lbar,ierr)
      call NhlFDraw(text,ierr)
      call NhlFFrame(wks,ierr)


C  This next example changes three entries in the colormap.  Changing the
C  first entry (colormap index 0) in the colormap, sets the background
C  color for a plot. The second entry (color index 1) sets the foreground
C  color for a plot.
C 
C  The colormap is stored in a 3xN variable where N is the length of
C  the colormap.  Each entry in the color map consists of a vector
C  of 3 normalized red-green-blue color values.

C Assign gray scale colormap
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'wkColorMap','gscyclic',ierr)
      call NhlFSetValues(wks,rlist,ierr)

      num_dims = 2
      len_dims(1) = 3
      len_dims(2) = 8

      call NhlFRLCreate(glist,'GETRL')
      call NhlFRLClear(glist)
      call NhlFRLGetMDFloatArray(glist,'wkColorMap',cmap,num_dims,
     1      len_dims,ierr)
      call NhlFGetValues(wks,glist,ierr)

C  Change the first entry in the colormap array to blue, the
C  second to green, and the fourth to red.


C Background color
      cmap(1,1) = 0.0
      cmap(2,1) = 0.0
      cmap(3,1) = 1.0

C Foreground color 
      cmap(1,2) = 0.0
      cmap(2,2) = 1.0
      cmap(3,2) = 0.0

C Colormap entry 3
      cmap(1,4) = 1.0
      cmap(2,4) = 0.0
      cmap(3,4) = 0.0

C Assign the new color map to the workstation object.
      num_dims=2
      len_dims(1)=3
      len_dims(2)=8
      call NhlFRLClear(rlist)
      call NhlFRLSetMDFloatArray(rlist,'wkColorMap',cmap,
     1      num_dims,len_dims,ierr) 
      call NhlFSetValues(wks,rlist,ierr)

C Add a different title.
      call NhlFRLClear(rlist)

C Set the title
      call NhlFRLSetString(rlist,'lbTitleString',
     1      'Changing colormap entries',ierr)

C Label every entry
      call NhlFRLSetInteger(rlist,'lbLabelStride',1,ierr)

C Number of entries to display
      call NhlFRLSetInteger(rlist,'lbBoxCount',7,ierr)

      call NhlFSetValues(lbar,rlist,ierr)

C Change the textual annotation at bottom of frame
      call NhlFRLClear(rlist)

C Set the title for the labelbar 
      call NhlFRLSetString(rlist,'txString','Entry 0 (background) set to
     $ Blue',ierr)

      call NhlFSetValues(text,rlist,ierr)

C Draw and frame the labelbar.
      call NhlFDraw(lbar,ierr)
      call NhlFDraw(text,ierr)
      call NhlFFrame(wks,ierr)

C This example demonstrates how to create and assign a new colormap.
C
C First we will initialize a new array with RGB entries.  For this
C example we are choosing an arbitrary colormap size of 100.
C 
C Assign new RGB values to each entry of the colormap.
C The first entry (background color) is black.  The rest of
C the colormap is a smooth table that ranges from red to blue.


      newcmap(1,1) = 0.
      newcmap(2,1) = 0.
      newcmap(3,1) = 0.
      do 10, i=2,100
         newcmap(1,i) = 1.-(i/100.)
         newcmap(2,i) = i/100.
         newcmap(3,i) = i/100.
 10   continue

C Assign the new color map to the workstation object.
      call NhlFRLClear(rlist)
      num_dims=2
      len_dims(1)=3
      len_dims(2)=100
      call NhlFRLSetMDFloatArray(rlist,'wkColorMap',newcmap,
     1      num_dims,len_dims,ierr)
      call NhlFSetValues(wks,rlist,ierr)

C Assign a new title.
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'lbTitleString','New colormap',ierr)

C Label every 10th entry
      call NhlFRLSetInteger(rlist,'lbLabelStride',10,ierr)

C Number of entries to display
      call NhlFRLSetInteger(rlist,'lbBoxCount',99,ierr)
      call NhlFSetValues(lbar,rlist,ierr)

C Draw and frame the labelbar
      call NhlFDraw(lbar,ierr)
      call NhlFFrame(wks,ierr)

C Cleanup
      call NhlFDestroy(lbar,ierr)
      call NhlFDestroy(text,ierr)
      call NhlFDestroy(wks,ierr)
      call NhlFClose

      stop
      end

c
c interfaces for various Cumalative Distribution Functions
c based upon: www/stat.unipg.it/stat/dcdflib
c

c ================================================================
c NCLFORTSTART
      SUBROUTINE DCDFBINP(N,S,XN,PR,P,IER)
c NCL: p = cdfbin_p(s,xn,pr)
      IMPLICIT NONE
c input
      INTEGER N
      DOUBLE PRECISION S(N),XN(N),PR(N)
c output
      INTEGER IER
      DOUBLE PRECISION P(N)
c NCLEND
c local
      INTEGER WHICH, I
      DOUBLE PRECISION Q,OMPR,BOUND

C iwhich = 1 : Calculate P and Q from S, XN, PR
c              Q, OMPR not returned

      WHICH = 1

      DO I=1,N
         Q    = 1.D0 - P(I)
         OMPR = 1.D0 - PR(I)
         CALL CDFBIN(WHICH,P(I),Q,S(I),XN(I),PR(I),OMPR,IER,BOUND)
         IF (IER.NE.0) CALL CDFBERR('CDFBIN_P',IER)
      END DO

      RETURN
      END
c ------------
c NCLFORTSTART
      SUBROUTINE DCDFBINS(N,P,XN,PR,S,IER)
c NCL: s = cdfbin_s(p,xn,pr)
      IMPLICIT NONE
c input
      INTEGER N
      DOUBLE PRECISION P(N),XN(N),PR(N)
c output
      INTEGER IER
      DOUBLE PRECISION S(N)
c NCLEND
c local
      INTEGER WHICH, I
      DOUBLE PRECISION Q,OMPR,BOUND

C iwhich = 2 : Calculate S from P,Q,XN,PR and OMPR

      WHICH = 2
      DO I=1,N
         Q    = 1.0D0 - P(I)
         OMPR = 1.0D0 - PR(I)
         CALL CDFBIN(WHICH,P(I),Q,S(I),XN(I),PR(I),OMPR,IER,BOUND)
         IF (IER.NE.0) CALL CDFBERR('CDFBIN_X',IER)
      END DO

      RETURN
      END
c ------------
c NCLFORTSTART
      SUBROUTINE DCDFBINXN(N,P,S,PR,XN,IER)
c NCL: n = cdfbin_xn(p,s,pr)
      IMPLICIT NONE
c input
      INTEGER N
      DOUBLE PRECISION P(N),S(N),PR(N)
c output
      INTEGER IER
      DOUBLE PRECISION XN(N)
c NCLEND
c local
      INTEGER WHICH, I
      DOUBLE PRECISION Q,OMPR,BOUND

C iwhich = 3 : Calculate XN from P,Q,S,PR and OMPR

      WHICH = 3
      DO I=1,N
         OMPR = 1.0D0 - PR(I)
         Q    = 1.0D0 - P(I)
         CALL CDFBIN(WHICH,P(I),Q,S(I),XN(I),PR(I),OMPR,IER,BOUND)
         IF (IER.NE.0) CALL CDFBERR('CDFBIN_XN',IER)
      END DO

      RETURN
      END
c ------------
c NCLFORTSTART
      SUBROUTINE DCDFBINPR(N,P,S,XN,PR,IER)
c NCL: pr = cdfbin_pr(p,s,xn)
      IMPLICIT NONE
c input
      INTEGER N
      DOUBLE PRECISION P(N),S(N),XN(N)
c output
      INTEGER IER
      DOUBLE PRECISION PR(N)
c NCLEND
c local
      INTEGER WHICH, I
      DOUBLE PRECISION Q,OMPR,BOUND

C iwhich = 4 : Calculate PR and OMPR from P,Q,S and XN
c              OMPR not returned
      WHICH = 4
      DO I=1,N
         Q    = 1.0D0 - P(I)
         OMPR = 1.0D0 - PR(I)
         CALL CDFBIN(WHICH,P(I),Q,S(I),XN(I),PR(I),OMPR,IER,BOUND)
         IF (IER.NE.0) CALL CDFBERR('CDFBIN_PR',IER)
      END DO

      RETURN
      END

c ------------
      SUBROUTINE CDFBERR(NAME,IER)
c error messages for cdfbin_{p,x,n,pr} functions
      IMPLICIT NONE
      CHARACTER*(*) NAME
      INTEGER IER

      IF (IER.NE.0) THEN
          IF (IER.EQ.1) PRINT *,NAME,': lower bound error'
          IF (IER.EQ.2) PRINT *,NAME,': upper bound error'
          IF (IER.EQ.3) PRINT *,NAME,': P+Q .ne. 1'
          IF (IER.EQ.4) PRINT *,NAME,': PR + OMPR .ne. 1'
      END IF
      RETURN
      END

c ================================================================
c NCLFORTSTART
      SUBROUTINE DCDFGAMP(N,X,SHAPE,SCALE,P,IER)
c NCL: p = cdfgam_p(x,shape,scale)
      IMPLICIT NONE
c input
      INTEGER N
      DOUBLE PRECISION X(N),SHAPE(N),SCALE(N)
c output
      INTEGER IER
      DOUBLE PRECISION P(N)
c NCLEND
c local
      INTEGER WHICH, I
      DOUBLE PRECISION Q,BOUND

C iwhich = 1 : Calculate P and Q from X,SHAPE and SCALE
c              Q not returned
      WHICH = 1
      BOUND = -999.D0
      DO I=1,N
         CALL CDFGAM(WHICH,P(I),Q,X(I),SHAPE(I),SCALE(I),IER,BOUND)
         IF (IER.NE.0) CALL CDFGERR('CDFGAM_P',IER)
      END DO

      RETURN
      END

c ------------
c NCLFORTSTART
      SUBROUTINE DCDFGAMX(N,P,SHAPE,SCALE,X,IER)
c NCL: x = cdfgam_x(p,shape,scale)
      IMPLICIT NONE
c input
      INTEGER N
      DOUBLE PRECISION P(N),SHAPE(N),SCALE(N)
c output
      INTEGER IER
      DOUBLE PRECISION X(N)
C NCLEND
c local
      INTEGER WHICH, I
      DOUBLE PRECISION Q,BOUND

C iwhich = 2 : Calculate X from P,Q,SHAPE and SCALE

      WHICH = 2
      BOUND = -999.D0

      DO I=1,N
         Q = 1.0D0 - P(I)
         CALL CDFGAM(WHICH,P(I),Q,X(I),SHAPE(I),SCALE(I),IER,BOUND)
         IF (IER.NE.0) CALL CDFGERR('CDFGAM_X',IER)
      END DO

      RETURN
      END

c ------------
      SUBROUTINE CDFGERR(NAME,IER)
c error messages for cdfgam_{p,x} functions
      IMPLICIT NONE
      CHARACTER*(*) NAME
      INTEGER IER

      IF (IER.NE.0) THEN
          IF (IER.EQ.1) PRINT *,NAME,': lower bound error'
          IF (IER.EQ.2) PRINT *,NAME,': upper bound error'
          IF (IER.EQ.3) PRINT *,NAME,': P+Q .ne. 1'
          IF (IER.EQ.10)PRINT *,NAME,': gamma/inverse gamma err'
          IF (IER.LT.0) PRINT *,NAME,': illegal input'
      END IF

      RETURN
      END

c ================================================================
c NCLFORTSTART
      SUBROUTINE DCDFNORP(N,X,MEAN,SD,P,IER)
c NCL: p = cdfnor_p(x,mean,sd)
      IMPLICIT NONE
c input
      INTEGER N
      DOUBLE PRECISION X(N),MEAN(N),SD(N)
c output
      INTEGER IER
      DOUBLE PRECISION P(N)
c NCLEND
c local
      INTEGER WHICH, I
      DOUBLE PRECISION Q,BOUND

C iwhich = 1 : Calculate P and Q from X,MEAN and SD
c              Q not returned

      WHICH = 1
      DO I=1,N
         CALL CDFNOR(WHICH,P(I),Q,X(I),MEAN(I),SD(I),IER,BOUND)
         IF (IER.NE.0) CALL CDFNERR('CDFNOR_P',IER)
      END DO

      RETURN
      END

c ------------
c NCLFORTSTART
      SUBROUTINE DCDFNORX(N,P,MEAN,SD,X,IER)
c NCL: x = cdfnor_x(p,mean,sd)
      IMPLICIT NONE
c input
      INTEGER N
      DOUBLE PRECISION P(N),MEAN(N),SD(N)
c output
      INTEGER IER
      DOUBLE PRECISION X(N)
c NCLEND
c local
      INTEGER WHICH, I
      DOUBLE PRECISION Q,BOUND

C iwhich = 2 : Calculate X from P,Q,MEAN and SD
      WHICH = 2
      DO I=1,N
         Q = 1.0D0 - P(I)
         CALL CDFNOR(WHICH,P(I),Q,X(I),MEAN(I),SD(I),IER,BOUND)
         IF (IER.NE.0) CALL CDFNERR('CDFNOR_X',IER)
      END DO

      RETURN
      END
c ------------
      SUBROUTINE CDFNERR(NAME,IER)
c error messages for cdfnor_{p,x} functions
      IMPLICIT NONE
      CHARACTER*(*) NAME
      INTEGER IER

      IF (IER.NE.0) THEN
          IF (IER.EQ.1) PRINT *,NAME,': lower bound error'
          IF (IER.EQ.2) PRINT *,NAME,': upper bound error'
          IF (IER.EQ.3) PRINT *,NAME,': P+Q .ne. 1'
      END IF

      RETURN
      END
c ------------
c NCLFORTSTART
      SUBROUTINE DCDFCHIP(N,X,DF,P,IER)
c NCL: p = cdfchi_p(x,df)
      IMPLICIT NONE
c input
      INTEGER N
      DOUBLE PRECISION X(N),DF(N)
c output
      INTEGER IER
      DOUBLE PRECISION P(N)
c NCLEND
c local
      INTEGER WHICH, I
      DOUBLE PRECISION Q,BOUND

C iwhich = 1 : Calculate P and Q from X and DF
c              Q not returned
      WHICH = 1
      BOUND = -999.D0
      DO I=1,N
         CALL CDFCHI(WHICH,P(I),Q,X(I),DF(I),IER,BOUND)
         IF (IER.NE.0) CALL CDFGERR('CDFCHI_P',IER)
      END DO

      RETURN
      END

C
C $Id: mpname.f,v 1.8 2008-07-27 00:17:08 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      CHARACTER*64 FUNCTION MPNAME (IAIN)
        INTEGER      IAIN
        CHARACTER*64 MDNAME
        MPNAME=MDNAME(IAIN)
        RETURN
      END

C
C $Id: pcwrda.f,v 1.4 2008-07-27 01:04:31 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C

      PROGRAM PCWRDA
C
C Because of the difficulty of porting a binary file, the database for
C the PWRITX database is supplied in the distribution in the form of
C four ASCII card-image files named "pwritxc1", "pwritxc2", "pwritxd1",
C and "pwritxd2".  This program reads those files and writes a single
C binary file to be used by PLOTCHAR.
C
C After PCWRDA has created the desired binary file, it calls two short
C test routines to see whether it can be accessed correctly.  Messages
C are printed indicating the success or failure of these test routines.
C
C PCWRDA uses the support routines ISHIFT, IAND, and IOR, which are
C required locally-implemented support routines for NCAR's GKS package.
C
C COMMON block declarations.
C
      COMMON /PCCMN1/ INDA(789),INDL,IDDA(8625),IDDL
      COMMON /PCCMN2/ NBPW,NPPW
      COMMON /PCCMN3/ RDGU(7000)
C
C Declare a variable in which to put the name of the output file.
C
      CHARACTER*13 FLNM
C
C Define the number of "cards" in the files "pwritxc1" and "pwritxd1".
C
      DATA INC1 / 49 /
C
C Define the number of "cards" in the files "pwritxc2" and "pwritxd2".
C
      DATA INC2 / 575 /
C
C Define the numbers of the units from which the files "pwritxc1",
C "pwritxc2", "pwritxd1", and "pwritxd2", respectively, can be read.
C
      DATA IUN1,IUN2,IUN3,IUN4 / 1,2,3,4 /
C
C Log on.
C
      PRINT * , 'Program "WritePlotcharData" executing.'
C
C Open all required files.
C
      OPEN (UNIT=IUN1,STATUS='OLD',FILE='pwritxc1',ERR=901)
      OPEN (UNIT=IUN2,STATUS='OLD',FILE='pwritxc2',ERR=902)
      OPEN (UNIT=IUN3,STATUS='OLD',FILE='pwritxd1',ERR=903)
      OPEN (UNIT=IUN4,STATUS='OLD',FILE='pwritxd2',ERR=904)
C
      FLNM='PlotcharData'//CHAR(0)
      CALL NGOFWO (FLNM,IOUT,ISTA)
C
      IF (ISTA.NE.0) THEN
        PRINT * , 'Error opening file "PlotcharData" for output.'
        STOP
      END IF
C
C Find the number of bits per word.
C
      NBPW=I1MACH(5)
C
C Find the number of 15-bit parcels per word.
C
      NPPW=NBPW/15
C
C Calculate the length of arrays INDA and IDDA required on this
C machine.
C
      INDL=(INC1*16-1)/NPPW+1
      IDDL=(INC2*16*15-1)/NBPW+1
C
C Write two binary records representing the complex character set.
C
      CALL PCWB15 (IUN1,IOUT,INC1,INDA,INDL)
C
      CALL PCWBIN (IUN2,IOUT,INC2,IDDA,IDDL)
C
C Write two binary records representing the duplex character set.
C
      CALL PCWB15 (IUN3,IOUT,INC1,INDA,INDL)
C
      CALL PCWBIN (IUN4,IOUT,INC2,IDDA,IDDL)
C
C Close the output file.
C
      CALL NGCLFI (IOUT)
C
C Log what's happened so far.
C
      PRINT * , 'File "PlotcharData" created.'
C
C Reopen the new file for input.
C
      CALL NGOFRO (FLNM,IOUT,ISTA)
C
      IF (ISTA.NE.0) THEN
        PRINT * , 'Error opening file "PlotcharData" for input.'
        STOP
      END IF
C
C Read the two records of the complex character set.
C
      CALL NGRDIN (IOUT,INDA,INDL,ISTA)
C
      IF (ISTA.NE.INDL) THEN
        PRINT * , 'Error reading file "PlotcharData".'
        STOP
      END IF
C
      CALL NGRDIN (IOUT,IDDA,IDDL,ISTA)
C
      IF (ISTA.NE.IDDL) THEN
        PRINT * , 'Error reading file "PlotcharData".'
        STOP
      END IF
C
C Test accessing of complex character set.
C
      CALL PCCCHK (IERR)
C
C Print test results.
C
      PRINT * , 'Testing complex character set.'
C
      IF (IERR.EQ.0) THEN
        PRINT * , 'Test successful.'
      ELSE IF (IERR.EQ.1) THEN
        PRINT * , 'Test successful for 12-bit but not for 6-bit units.'
      ELSE IF (IERR.EQ.2) THEN
        PRINT * , 'Test successful for 6-bit but not for 12-bit units.'
      ELSE
        PRINT * , 'Test not successful.'
      END IF
C
C Read the two records of the duplex character set.
C
      CALL NGRDIN (IOUT,INDA,INDL,ISTA)
C
      IF (ISTA.NE.INDL) THEN
        PRINT * , 'Error reading file "PlotcharData".'
        STOP
      END IF
C
      CALL NGRDIN (IOUT,IDDA,IDDL,ISTA)
C
      IF (ISTA.NE.IDDL) THEN
        PRINT * , 'Error reading file "PlotcharData".'
        STOP
      END IF
C
C Test accessing of duplex character set.
C
      CALL PCDCHK(IERR)
C
C Print test results.
C
      PRINT * , 'Testing duplex character set.'
C
      IF (IERR.EQ.0) THEN
        PRINT * , 'Test successful.'
      ELSE IF (IERR.EQ.1) THEN
        PRINT * , 'Test successful for 12-bit but not for 6-bit units.'
      ELSE IF (IERR.EQ.2) THEN
        PRINT * , 'Test successful for 6-bit but not for 12-bit units.'
      ELSE
        PRINT * , 'Test not successful.'
      END IF
C
C Done.
C
      STOP
C
C Error exits.
C
  901 PRINT * , 'Error opening file "pwritxc1" for input.'
      STOP
C
  902 PRINT * , 'Error opening file "pwritxc2" for input.'
      STOP
C
  903 PRINT * , 'Error opening file "pwritxd1" for input.'
      STOP
C
  904 PRINT * , 'Error opening file "pwritxd2" for input.'
      STOP
C
      END

! For NCL graphics:
! WRAPIT -m64 calc_uh90.stub calc_uh.f90
! This should create a shared library named "calc_uh90.so".

!##################################################################
!##################################################################
!######                                                      ######
!######                  SUBROUTINE CALC_UH                  ######
!######                                                      ######
!######                     Developed by                     ######
!######     Center for Analysis and Prediction of Storms     ######
!######                University of Oklahoma                ######
!######                                                      ######
!##################################################################
!##################################################################
!
!  Calculates updraft helicity (UH) to detect rotating updrafts.
!  Formula follows Kain et al, 2008, Wea. and Forecasting, 931-952,
!  but this version has controls for the limits of integration
!  uhminhgt to uhmxhgt, in m AGL.  Kain et al used 2000 to 5000 m.
!  Units of UH are m^2/s^2.
!
!  Note here that us and vs are at ARPS scalar points.
!  w is at w-point (scalar pt in horiz, staggered vertical)
!
!  Keith Brewster, CAPS/Univ. of Oklahoma
!  March, 2010
!
!   uh = wrf_updraft_helicity(zp,us,vs,w, 
SUBROUTINE dcalcuh(nx,ny,nz,nzp1,zp,mapfct,dx,dy,uhmnhgt,uhmxhgt,        &
                   us,vs,w,uh,tem1,tem2)
  IMPLICIT NONE
  INTEGER, INTENT(IN) :: nx,ny,nz,nzp1
  DOUBLE PRECISION, INTENT(IN)  :: zp(nx,ny,nzp1)
  DOUBLE PRECISION, INTENT(IN)  :: mapfct(nx,ny)
  DOUBLE PRECISION, INTENT(IN)  :: dx,dy
  DOUBLE PRECISION, INTENT(IN)  :: uhmnhgt,uhmxhgt
  DOUBLE PRECISION, INTENT(IN)  :: us(nx,ny,nz)
  DOUBLE PRECISION, INTENT(IN)  :: vs(nx,ny,nz)
  DOUBLE PRECISION, INTENT(IN)  :: w(nx,ny,nzp1)
  DOUBLE PRECISION, INTENT(OUT) :: uh(nx,ny)
  DOUBLE PRECISION, INTENT(OUT) :: tem1(nx,ny,nz)
  DOUBLE PRECISION, INTENT(OUT) :: tem2(nx,ny,nz)
!
! Misc local variables
!
  INTEGER :: i,j,k,kbot,ktop
  DOUBLE PRECISION    :: twodx,twody,wgtlw,sum,wmean,wsum,wavg
  DOUBLE PRECISION    :: helbot,heltop,wbot,wtop
  DOUBLE PRECISION    :: zbot,ztop
!
! Initialize arrays
!
  uh=0.0
  tem1=0.0
!
! Calculate vertical component of helicity at scalar points
!   us: u at scalar points
!   vs: v at scalar points
!
  twodx=2.0*dx
  twody=2.0*dy
  DO k=2,nz-2
    DO j=2,ny-1
      DO i=2,nx-1
        wavg=0.5*(w(i,j,k)+w(i,j,k+1))
        tem1(i,j,k)=wavg *                                      &
            ((vs(i+1,j,k)-vs(i-1,j,k))/(twodx*mapfct(i,j))  -   &
             (us(i,j+1,k)-us(i,j-1,k))/(twody*mapfct(i,j)))
        tem2(i,j,k)=0.5*(zp(i,j,k)+zp(i,j,k+1))
      END DO
    END DO
  END DO
!
! Integrate over depth uhminhgt to uhmxhgt AGL
!
!  WRITE(6,'(a,f12.1,a,f12.1,a)') &
!        'Calculating UH from ',uhmnhgt,' to ',uhmxhgt,' m AGL'
  DO j=2,ny-2
    DO i=2,nx-2
      zbot=zp(i,j,2)+uhmnhgt
      ztop=zp(i,j,2)+uhmxhgt
!
! Find wbar, weighted-mean vertical velocity in column
! Find w at uhmnhgt AGL (bottom)
!
      DO k=2,nz-3
        IF(zp(i,j,k) > zbot) EXIT
      END DO
      kbot=k
      wgtlw=(zp(i,j,kbot)-zbot)/(zp(i,j,kbot)-zp(i,j,kbot-1))
      wbot=(wgtlw*w(i,j,kbot-1))+((1.-wgtlw)*w(i,j,kbot))
!
! Find w at uhmxhgt AGL (top)
!
      DO k=2,nz-3
        IF(zp(i,j,k) > ztop) EXIT
      END DO
      ktop=k
      wgtlw=(zp(i,j,ktop)-ztop)/(zp(i,j,ktop)-zp(i,j,ktop-1))
      wtop=(wgtlw*w(i,j,ktop-1))+((1.-wgtlw)*w(i,j,ktop))
!
! First part, uhmnhgt to kbot
!
      wsum=0.5*(w(i,j,kbot)+wbot)*(zp(i,j,kbot)-zbot)
!
! Integrate up through column
!
      DO k=(kbot+1),(ktop-1)
        wsum=wsum+0.5*(w(i,j,k)+w(i,j,k-1))*(zp(i,j,k)-zp(i,j,k-1))
      END DO
!
! Last part, ktop-1 to uhmxhgt
!
      wsum=wsum+0.5*(wtop+w(i,j,ktop-1))*(ztop-zp(i,j,ktop-1))
      wmean=wsum/(uhmxhgt-uhmnhgt)

      IF(wmean > 0.) THEN    ! column updraft, not downdraft
!
! Find helicity at uhmnhgt AGL (bottom)
!
        DO k=2,nz-3
          IF(tem2(i,j,k) > zbot) EXIT
        END DO
        kbot=k
        wgtlw=(tem2(i,j,kbot)-zbot)/(tem2(i,j,kbot)-tem2(i,j,kbot-1))
        helbot=(wgtlw*tem1(i,j,kbot-1))+((1.-wgtlw)*tem1(i,j,kbot))
!
! Find helicity at uhmxhgt AGL (top)
!
        DO k=2,nz-3
          IF(tem2(i,j,k) > ztop) EXIT
        END DO
        ktop=k
        wgtlw=(tem2(i,j,ktop)-ztop)/(tem2(i,j,ktop)-tem2(i,j,ktop-1))
        heltop=(wgtlw*tem1(i,j,ktop-1))+((1.-wgtlw)*tem1(i,j,ktop))
!
! First part, uhmnhgt to kbot
!
        sum=0.5*(tem1(i,j,kbot)+helbot)*(tem2(i,j,kbot)-zbot)
!
! Integrate up through column
!
        DO k=(kbot+1),(ktop-1)
          sum=sum+0.5*(tem1(i,j,k)+tem1(i,j,k-1))*(tem2(i,j,k)-tem2(i,j,k-1))
        END DO
!
! Last part, ktop-1 to uhmxhgt
!
        uh(i,j)=sum+0.5*(heltop+tem1(i,j,ktop-1))*(ztop-tem2(i,j,ktop-1))
      END IF
    END DO
  END DO

  uh = uh * 1000.   ! Scale according to Kain et al. (2008)

  RETURN
END SUBROUTINE dcalcuh

C
C	$Id: sftbkd.f,v 1.5 2008-07-27 12:23:42 haley Exp $
C
C                                                                      
C			     Copyright (C)  1997
C	     University Corporation for Atmospheric Research
C			     All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE SFTBKD
C
C Calling this do-nothing subroutine forces "ld" to load the following
C block data routine (but only if they are in the same ".f" file).
C
        RETURN
C
      END
CNOSPLIT
      BLOCKDATA SFTBKDX
C
C  COMMON data definitions for fontcap parser for stroked fonts.
C
      include 'capfnt.h'
      include 'fnttab.h'
      include 'fnterr.h'
C
C  Type the local variables.
C
      INTEGER II
C
C  Define the locations of the individual tables in the PART1 array.
C
      INTEGER PT01,PT02,PT03,PT04,PT05,
     1        PTEND
      PARAMETER (PT01=1)
      PARAMETER (PT02=PT01+PD011*PD012)
      PARAMETER (PT03=PT02+PD021*PD022)
      PARAMETER (PT04=PT03+PD031*PD032)
      PARAMETER (PT05=PT04+PD041*PD042)
      PARAMETER (PTEND=PT05+PD051*PD052)
C
C  Define table row starts.
C
      INTEGER RS02, RS03, RS04, RS05
      PARAMETER (RS02 = PD011+1)
      PARAMETER (RS03 = RS02 + PD021)
      PARAMETER (RS04 = RS03 + PD031)
      PARAMETER (RS05 = RS04 + PD041)
C
      DATA FNTRHT, FNTTOP, FNTCAP, FNTHLF, FNTBAS, FNTBOT, FNTTYP
     1    /     0,      0,      0,      0,      0,      0,     -1/
      DATA CORXST, CORXLN, CORYST, CORYLN, CORPST, CORPLN/ 6*0/
      DATA PBEGST, PBEGLN, PENDST, PENDLN/ 4*0/
      DATA CPNLST/ 0/
C
C  Define the major classes.
C
      DATA (PART1(II),II=PT01,(PT02-1))/
     1     'C','H','A','R','A','C','T','E','R',' '
     2    ,'C','O','O','R','D',5*' '
     3    ,'P','A','I','N','T',5*' '
     4    ,'C','H','A','R',6*' '
     5    ,'F','O','N','T',6*' '
     Z    /
C
C  Define the subclasses of class CHARACTER.
C
      DATA (PART1(II),II=PT02,(PT03-1))/
     1     'S','T','A','R','T',' '
     2    ,'E','N','D',3*' '
     3    ,'W','I','D','T','H',' '
     Z    /
C
C  Define the subclasses of class COORD.
C
      DATA (PART1(II),II=PT03,(PT04-1))/
     1     'X','_','S','T','A','R','T',3*' '
     2    ,'X','_','L','E','N',5*' '
     3    ,'Y','_','S','T','A','R','T',3*' '
     4    ,'Y','_','L','E','N',5*' '
     5    ,'P','E','N','_','S','T','A','R','T',' '
     6    ,'P','E','N','_','L','E','N',3*' '
     Z    /
C
C  Define the subclasses of class PAINT.
C
      DATA (PART1(II),II=PT04,(PT05-1))/
     1     'B','E','G','I','N','_','S','T','A','R','T',' '
     2    ,'B','E','G','I','N','_','L','E','N',' ',' ',' '
     3    ,'E','N','D','_','S','T','A','R','T',' ',' ',' '
     4    ,'E','N','D','_','L','E','N',' ',' ',' ',' ',' '
     Z    /
C
C  Define the subclasses of class FONT.
C
      DATA (PART1(II),II=PT05,(PTEND-1))/
     1     'R','I','G','H','T',' '
     2    ,'T','O','P',3*' '
     3    ,'C','A','P',3*' '
     4    ,'H','A','L','F',' ',' '
     5    ,'B','A','S','E',' ',' '
     6    ,'B','O','T','T','O','M'
     7    ,'T','Y','P','E',' ',' '
     Z    /
C
C  Define parser tables 2 - 5.
C
      DATA PART2/
     1          RS02, RS03, RS04, 0, RS05, 3*0, 6*0, 4*0, 7*0
     Z         /
      DATA PART3/
     1          PD011*1, PD021*2, PD031*3, PD041*4, PD051*5
     Z         /
      DATA PART4/
     1         PT01,PT02,PT03,PT04,PT05
     2        /
      DATA PART5/
     1         PD011,PD012,PD021,PD022,PD031,PD032,PD041,PD042,
     2         PD051,PD052
     Z        /
C
C  Define the keyword separator character and the keyword terminator
C  character.
C 
      DATA KEYSEP/'_'/, KEYTER/' '/
C
C  Define the initial two-character sequence to be interpreted
C  as beginning comment lines.
C
      DATA FRMCOM /'/','*'/
C
C Initialize buffer pointer.
C
      DATA IPTR/1/
C
C  Error flags in COMMON FNTERR.
C
      DATA ALLOK, EOFFL, INTERR, MAXINT
     1     /0, 1, 2, 3/
C
C  Number of bits used to store the integer flags used to specify
C  major class and subclass.
C
      DATA PTHBTS /4/
      END

c -------------------------------------------------------------
C NCLFORTSTART
      SUBROUTINE QDTRNDMSG(Y,NPTS,YMSG,IOPT,IER,C)
      IMPLICIT NONE
      INTEGER NPTS, IOPT, IER
      DOUBLE PRECISION Y(NPTS)
      DOUBLE PRECISION YMSG, C(3)
C NCLEND
c                                      local
      INTEGER I
      DOUBLE PRECISION FN , SUMX , SUMY , SUMX2 , SUMX3 , SUMX4
     +               , SUMXY , SUMX2Y , XS , D , YAVE 

      IER = 0

      IF (NPTS.LT.2) IER = 1
      IF (IER.NE.0) RETURN

      FN   = 0.0D0
      SUMY = 0.0D0
      DO I = 1,NPTS
         IF (Y(I).NE.YMSG) THEN
             FN   = FN + 1.0D0
             SUMY = SUMY + Y(I)
         END IF
      END DO

      IF (FN.GT.0.0D0) THEN
          YAVE = SUMY/FN
      ELSE
          IER  = 1
          YAVE = YMSG
       END IF

      IF (FN.EQ.1.0D0) THEN
          IER = 5
      END IF

      IF (IER.NE.0) THEN
          RETURN
      END IF
c                                 remove mean
      DO I = 1,NPTS
         IF (Y(I).NE.YMSG) THEN
             Y(I)   = Y(I) - YAVE
         END IF
      END DO
c     
C QUADRATIC DETRENDING
C
      FN    = 0.0D0
      SUMX  = 0.0D0
      SUMY  = 0.0D0
      SUMX2 = 0.0D0
      SUMX3 = 0.0D0
      SUMX4 = 0.0D0
      SUMXY = 0.0D0
      SUMX2Y= 0.0D0
      DO I = 1,NPTS
         IF (Y(I).NE.YMSG) THEN
             FN    = FN + 1.0D0
             XS    = DBLE(I)
             SUMX  = SUMX  + XS
             SUMY  = SUMY  + Y(I)
             SUMX2 = SUMX2 + XS**2
             SUMX3 = SUMX3 + XS**3
             SUMX4 = SUMX4 + XS**4
             SUMXY = SUMXY + XS*Y(I)
             SUMX2Y= SUMX2Y+ XS**2*Y(I)
         END IF
      END DO
      D    = FN* (SUMX2*SUMX4-SUMX3**2) +
     +            SUMX* (SUMX3*SUMX2-SUMX*SUMX4) +
     +            SUMX2* (SUMX*SUMX3-SUMX2**2)
      C(1) = (SUMX2*SUMX4-SUMX3**2)*SUMY +
     +       (SUMX3*SUMX2-SUMX*SUMX4)*SUMXY +
     +       (SUMX*SUMX3-SUMX2**2)*SUMX2Y
      C(2) = (SUMX3*SUMX2-SUMX*SUMX4)*SUMY +
     +       (FN*SUMX4-SUMX2**2)*SUMXY +
     +       (SUMX*SUMX2-FN*SUMX3)*SUMX2Y
      C(3) = (SUMX*SUMX3-SUMX2**2)*SUMY +
     +       (SUMX*SUMX2-FN*SUMX3)*SUMXY + (FN*SUMX2-SUMX**2)*SUMX2Y
      C(1) = C(1)/D
      C(2) = C(2)/D
      C(3) = C(3)/D

      DO I = 1,NPTS
         IF (Y(I).NE.YMSG) THEN
             Y(I) = Y(I) - (C(1)+C(2)*DBLE(I)+C(3)*DBLE(I)**2)
         END IF
      END DO

C JAN 14, 2013: IOPT=1 [True] matches 'dtrend_msg'
C IOPT=1 means True in NCL
      IF (IOPT.EQ.1) RETURN

C Add the mean back in
C C C IF (IOPT.NE.0) THEN 
          DO I = 1,NPTS
             IF (Y(I).NE.YMSG) THEN
                 Y(I)   = Y(I) + YAVE
             END IF
          END DO
C C C END IF
c     
      RETURN
      END

C NCLFORTSTART
      SUBROUTINE DPOTMP(PRESS,TEMP,S,RP,POTEMP)
      IMPLICIT NONE
C
C     TITLE:
C     *****
C
C       POTMP  -- CALCULATE POTENTIAL TEMPERATURE FOR AN ARBITRARY
C                 REFERENCE PRESSURE
C
C     PURPOSE:
C     *******
C
C       TO CALCULATE POTENTIAL TEMPERATURE
C
C       REF: N.P. FOFONOFF
C            DEEP SEA RESEARCH
C            IN PRESS NOV 1976
C
C     PARAMETERS:
C     **********
C
C       PRESS  -> PRESSURE IN DECIBARS
C       TEMP   -> TEMPERATURE IN CELSIUS DEGREES
C       S      -> SALINITY PSS 78
C       RP     -> REFERENCE PRESSURE IN DECIBARS
C                 (0.0 FOR THE QUANTITY THETA)
C       POTEMP <- POTENTIAL TEMPERATURE (DEG C)
C
      DOUBLE PRECISION PRESS,TEMP,S,RP,POTEMP
C NCLEND
C
C     VARIABLES:
C     *********
C
         INTEGER I,J,N
         DOUBLE PRECISION DP,P,Q,R1,R2,R3,R4,R5,S1,T,X
C
C     CODE:
C     ****
C
      S1 = S-35.0D0
      P  = PRESS
      T  = TEMP
C
      DP = RP - P
C C C N  = IFIX(ABS(DP)/1000.0D0) + 1     ! original; IFIX does not allow dble
      N  = IDINT (ABS(DP)/1000.0D0) + 1
      DP = DP/N
C
      DO 10 I=1,N
         DO 20 J=1,4
C
            R1 = ((-2.1687D-16*T+1.8676D-14)*T-4.6206D-13)*P
            R2 = (2.7759D-12*T-1.1351D-10)*S1
            R3 = ((-5.4481D-14*T+8.733D-12)*T-6.7795D-10)*T
            R4 = (R1+(R2+R3+1.8741D-8))*P+(-4.2393D-8*T+1.8932D-6)*S1
            R5 = R4+((6.6228D-10*T-6.836D-8)*T+8.5258D-6)*T+3.5803D-5
C
            X  = DP*R5
C
            GO TO (100,200,300,400),J
C
  100       CONTINUE
            T = T+0.5D0*X
            Q = X
            P = P + 0.5D0*DP
            GO TO 20
C
  200       CONTINUE
            T = T + .29298322D0*(X-Q)
            Q = 0.58578644D0*X + 0.121320344D0*Q
            GO TO 20
C
  300       CONTINUE
            T = T + 1.707106781D0*(X-Q)
            Q = 3.414213562D0*X - 4.121320344D0*Q
            P = P + 0.5D0*DP
            GO TO 20
C
  400       CONTINUE
            T = T + (X-2.0D0*Q)/6.0D0
  20      CONTINUE
  10    CONTINUE
C
        POTEMP = T
        RETURN
C
C       END POTMP
C
        END
c ------------
C NCLFORTSTART
        subroutine dpth2pres(nd, depth, has_msg_depth, depth_msg, 
     +             pressure)
        implicit none
c  DESCRIPTION:
c  This function computes pressure in bars from depth in meters
c  using a mean density derived from depth-dependent global 
c  average temperatures and salinities from Levitus 1994, and 
c  integrating using hydrostatic balance.
c 
c  References:
c 
c  Levitus, S., R. Burgett, and T.P. Boyer, World Ocean Atlas 
c  Volume 3: Salinity, NOAA Atlas NESDIS 3, US Dept. of ! Commerce, 1994.
c 
c  Levitus, S. and T.P. Boyer, World Ocean Atlas 1994, ! Volume 4:
c  Temperature, NOAA Atlas NESDIS 4, US Dept. of ! Commerce, 1994.
c 
c  Dukowicz, J. K., 2000: Reduction of Pressure and Pressure
c  Gradient Errors in Ocean Simulations, J. Phys. Oceanogr.,
c  submitted.

c  INPUT PARAMETERS:
c  nd     - size of 
c  depth  - depth in meters. No units check is made

      integer  nd, has_msg_depth
      double precision depth(nd), depth_msg

c  OUTPUT PARAMETERS:
c  pressure - pressure in bars 

      double precision pressure(nd)
C NCLEND

c  LOCAL PARAMETERS:
      integer n
      double precision c1
      data c1 /1.0d0/
c -----------------------------------------------------------------------
c  convert depth in meters to pressure in bars
c -----------------------------------------------------------------------

      if (has_msg_depth.eq.1) then
         do n=1,nd
            if(depth(n).eq.depth_msg) then
               pressure(n) = depth_msg
            else
               pressure(n) = 0.059808d0*(exp(-0.025d0*depth(n)) - c1) +
     &                       0.100766d0*depth(n)+2.28405d-7*depth(n)**2
            end if
         end do
      else
         do n=1,nd
            pressure(n) = 0.059808d0*(exp(-0.025d0*depth(n)) - c1) +
     &                    0.100766d0*depth(n)+2.28405d-7*depth(n)**2
         end do
      end if

      return
      end

      SUBROUTINE DGEMM ( TRANSA, TRANSB, M, N, K, ALPHA, A, LDA, B, LDB,
     $                   BETA, C, LDC )
*     .. Scalar Arguments ..
      CHARACTER*1        TRANSA, TRANSB
      INTEGER            M, N, K, LDA, LDB, LDC
      DOUBLE PRECISION   ALPHA, BETA
*     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), B( LDB, * ), C( LDC, * )
*     ..
*
*  Purpose
*  =======
*
*  DGEMM  performs one of the matrix-matrix operations
*
*     C := alpha*op( A )*op( B ) + beta*C,
*
*  where  op( X ) is one of
*
*     op( X ) = X   or   op( X ) = X',
*
*  alpha and beta are scalars, and A, B and C are matrices, with op( A )
*  an m by k matrix,  op( B )  a  k by n matrix and  C an m by n matrix.
*
*  Parameters
*  ==========
*
*  TRANSA - CHARACTER*1.
*           On entry, TRANSA specifies the form of op( A ) to be used in
*           the matrix multiplication as follows:
*
*              TRANSA = 'N' or 'n',  op( A ) = A.
*
*              TRANSA = 'T' or 't',  op( A ) = A'.
*
*              TRANSA = 'C' or 'c',  op( A ) = A'.
*
*           Unchanged on exit.
*
*  TRANSB - CHARACTER*1.
*           On entry, TRANSB specifies the form of op( B ) to be used in
*           the matrix multiplication as follows:
*
*              TRANSB = 'N' or 'n',  op( B ) = B.
*
*              TRANSB = 'T' or 't',  op( B ) = B'.
*
*              TRANSB = 'C' or 'c',  op( B ) = B'.
*
*           Unchanged on exit.
*
*  M      - INTEGER.
*           On entry,  M  specifies  the number  of rows  of the  matrix
*           op( A )  and of the  matrix  C.  M  must  be at least  zero.
*           Unchanged on exit.
*
*  N      - INTEGER.
*           On entry,  N  specifies the number  of columns of the matrix
*           op( B ) and the number of columns of the matrix C. N must be
*           at least zero.
*           Unchanged on exit.
*
*  K      - INTEGER.
*           On entry,  K  specifies  the number of columns of the matrix
*           op( A ) and the number of rows of the matrix op( B ). K must
*           be at least  zero.
*           Unchanged on exit.
*
*  ALPHA  - DOUBLE PRECISION.
*           On entry, ALPHA specifies the scalar alpha.
*           Unchanged on exit.
*
*  A      - DOUBLE PRECISION array of DIMENSION ( LDA, ka ), where ka is
*           k  when  TRANSA = 'N' or 'n',  and is  m  otherwise.
*           Before entry with  TRANSA = 'N' or 'n',  the leading  m by k
*           part of the array  A  must contain the matrix  A,  otherwise
*           the leading  k by m  part of the array  A  must contain  the
*           matrix A.
*           Unchanged on exit.
*
*  LDA    - INTEGER.
*           On entry, LDA specifies the first dimension of A as declared
*           in the calling (sub) program. When  TRANSA = 'N' or 'n' then
*           LDA must be at least  max( 1, m ), otherwise  LDA must be at
*           least  max( 1, k ).
*           Unchanged on exit.
*
*  B      - DOUBLE PRECISION array of DIMENSION ( LDB, kb ), where kb is
*           n  when  TRANSB = 'N' or 'n',  and is  k  otherwise.
*           Before entry with  TRANSB = 'N' or 'n',  the leading  k by n
*           part of the array  B  must contain the matrix  B,  otherwise
*           the leading  n by k  part of the array  B  must contain  the
*           matrix B.
*           Unchanged on exit.
*
*  LDB    - INTEGER.
*           On entry, LDB specifies the first dimension of B as declared
*           in the calling (sub) program. When  TRANSB = 'N' or 'n' then
*           LDB must be at least  max( 1, k ), otherwise  LDB must be at
*           least  max( 1, n ).
*           Unchanged on exit.
*
*  BETA   - DOUBLE PRECISION.
*           On entry,  BETA  specifies the scalar  beta.  When  BETA  is
*           supplied as zero then C need not be set on input.
*           Unchanged on exit.
*
*  C      - DOUBLE PRECISION array of DIMENSION ( LDC, n ).
*           Before entry, the leading  m by n  part of the array  C must
*           contain the matrix  C,  except when  beta  is zero, in which
*           case C need not be set on entry.
*           On exit, the array  C  is overwritten by the  m by n  matrix
*           ( alpha*op( A )*op( B ) + beta*C ).
*
*  LDC    - INTEGER.
*           On entry, LDC specifies the first dimension of C as declared
*           in  the  calling  (sub)  program.   LDC  must  be  at  least
*           max( 1, m ).
*           Unchanged on exit.
*
*
*  Level 3 Blas routine.
*
*  -- Written on 8-February-1989.
*     Jack Dongarra, Argonne National Laboratory.
*     Iain Duff, AERE Harwell.
*     Jeremy Du Croz, Numerical Algorithms Group Ltd.
*     Sven Hammarling, Numerical Algorithms Group Ltd.
*
*
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     .. External Subroutines ..
      EXTERNAL           XERBLA
*     .. Intrinsic Functions ..
      INTRINSIC          MAX
*     .. Local Scalars ..
      LOGICAL            NOTA, NOTB
      INTEGER            I, INFO, J, L, NCOLA, NROWA, NROWB
      DOUBLE PRECISION   TEMP
*     .. Parameters ..
      DOUBLE PRECISION   ONE         , ZERO
      PARAMETER        ( ONE = 1.0D+0, ZERO = 0.0D+0 )
*     ..
*     .. Executable Statements ..
*
*     Set  NOTA  and  NOTB  as  true if  A  and  B  respectively are not
*     transposed and set  NROWA, NCOLA and  NROWB  as the number of rows
*     and  columns of  A  and the  number of  rows  of  B  respectively.
*
      NOTA  = LSAME( TRANSA, 'N' )
      NOTB  = LSAME( TRANSB, 'N' )
      IF( NOTA )THEN
         NROWA = M
         NCOLA = K
      ELSE
         NROWA = K
         NCOLA = M
      END IF
      IF( NOTB )THEN
         NROWB = K
      ELSE
         NROWB = N
      END IF
*
*     Test the input parameters.
*
      INFO = 0
      IF(      ( .NOT.NOTA                 ).AND.
     $         ( .NOT.LSAME( TRANSA, 'C' ) ).AND.
     $         ( .NOT.LSAME( TRANSA, 'T' ) )      )THEN
         INFO = 1
      ELSE IF( ( .NOT.NOTB                 ).AND.
     $         ( .NOT.LSAME( TRANSB, 'C' ) ).AND.
     $         ( .NOT.LSAME( TRANSB, 'T' ) )      )THEN
         INFO = 2
      ELSE IF( M  .LT.0               )THEN
         INFO = 3
      ELSE IF( N  .LT.0               )THEN
         INFO = 4
      ELSE IF( K  .LT.0               )THEN
         INFO = 5
      ELSE IF( LDA.LT.MAX( 1, NROWA ) )THEN
         INFO = 8
      ELSE IF( LDB.LT.MAX( 1, NROWB ) )THEN
         INFO = 10
      ELSE IF( LDC.LT.MAX( 1, M     ) )THEN
         INFO = 13
      END IF
      IF( INFO.NE.0 )THEN
         CALL XERBLA( 'DGEMM ', INFO )
         RETURN
      END IF
*
*     Quick return if possible.
*
      IF( ( M.EQ.0 ).OR.( N.EQ.0 ).OR.
     $    ( ( ( ALPHA.EQ.ZERO ).OR.( K.EQ.0 ) ).AND.( BETA.EQ.ONE ) ) )
     $   RETURN
*
*     And if  alpha.eq.zero.
*
      IF( ALPHA.EQ.ZERO )THEN
         IF( BETA.EQ.ZERO )THEN
            DO 20, J = 1, N
               DO 10, I = 1, M
                  C( I, J ) = ZERO
   10          CONTINUE
   20       CONTINUE
         ELSE
            DO 40, J = 1, N
               DO 30, I = 1, M
                  C( I, J ) = BETA*C( I, J )
   30          CONTINUE
   40       CONTINUE
         END IF
         RETURN
      END IF
*
*     Start the operations.
*
      IF( NOTB )THEN
         IF( NOTA )THEN
*
*           Form  C := alpha*A*B + beta*C.
*
            DO 90, J = 1, N
               IF( BETA.EQ.ZERO )THEN
                  DO 50, I = 1, M
                     C( I, J ) = ZERO
   50             CONTINUE
               ELSE IF( BETA.NE.ONE )THEN
                  DO 60, I = 1, M
                     C( I, J ) = BETA*C( I, J )
   60             CONTINUE
               END IF
               DO 80, L = 1, K
                  IF( B( L, J ).NE.ZERO )THEN
                     TEMP = ALPHA*B( L, J )
                     DO 70, I = 1, M
                        C( I, J ) = C( I, J ) + TEMP*A( I, L )
   70                CONTINUE
                  END IF
   80          CONTINUE
   90       CONTINUE
         ELSE
*
*           Form  C := alpha*A'*B + beta*C
*
            DO 120, J = 1, N
               DO 110, I = 1, M
                  TEMP = ZERO
                  DO 100, L = 1, K
                     TEMP = TEMP + A( L, I )*B( L, J )
  100             CONTINUE
                  IF( BETA.EQ.ZERO )THEN
                     C( I, J ) = ALPHA*TEMP
                  ELSE
                     C( I, J ) = ALPHA*TEMP + BETA*C( I, J )
                  END IF
  110          CONTINUE
  120       CONTINUE
         END IF
      ELSE
         IF( NOTA )THEN
*
*           Form  C := alpha*A*B' + beta*C
*
            DO 170, J = 1, N
               IF( BETA.EQ.ZERO )THEN
                  DO 130, I = 1, M
                     C( I, J ) = ZERO
  130             CONTINUE
               ELSE IF( BETA.NE.ONE )THEN
                  DO 140, I = 1, M
                     C( I, J ) = BETA*C( I, J )
  140             CONTINUE
               END IF
               DO 160, L = 1, K
                  IF( B( J, L ).NE.ZERO )THEN
                     TEMP = ALPHA*B( J, L )
                     DO 150, I = 1, M
                        C( I, J ) = C( I, J ) + TEMP*A( I, L )
  150                CONTINUE
                  END IF
  160          CONTINUE
  170       CONTINUE
         ELSE
*
*           Form  C := alpha*A'*B' + beta*C
*
            DO 200, J = 1, N
               DO 190, I = 1, M
                  TEMP = ZERO
                  DO 180, L = 1, K
                     TEMP = TEMP + A( L, I )*B( J, L )
  180             CONTINUE
                  IF( BETA.EQ.ZERO )THEN
                     C( I, J ) = ALPHA*TEMP
                  ELSE
                     C( I, J ) = ALPHA*TEMP + BETA*C( I, J )
                  END IF
  190          CONTINUE
  200       CONTINUE
         END IF
      END IF
*
      RETURN
*
*     End of DGEMM .
*
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C
C NIO/NCL 
C Modified for the NIO library by David I. Brown
C Allocation is eliminated. All allocation is performed by the calling 
C function and allocated space passed in via arguments.
C Removed dependence on grprs.h -- errors printed to standard out (for now)
C Lines removed are left in the code but commented out.
C Added lines are bracketed with 
C NIO/NCL
C NIO/NCL END
C
C#ifndef USE_NO_POINTERS
C      SUBROUTINE QU2REG3(PFIELD,KPOINT,KLAT,KLON,KCODE,PMSVAL,KRET,
C     X                   OMISNG,OPERIO,OVEGGY)
      SUBROUTINE QU2REG3(PFIELD,KPOINT,KLAT,KLON,KCODE,PMSVAL,KRET,
     X                   OMISNG,OPERIO,OVEGGY,JPMAX,ZTEMP,ZLINE,ZWORK)
C
C---->
C**** QU2REG3 - Convert quasi-regular grid data to regular.
C
C     Purpose.
C     --------
C
C     Convert quasi-regular grid data to regular,
C     using either a linear or cubic interpolation.
C
C
C**   Interface.
C     ----------
C
C     CALL QU2REG3(PFIELD,KPOINT,KLAT,KLON,KCODE,PMSVAL,OMISNG,OPERIO,
C    X            OVEGGY)
C
C
C     Input Parameters.
C     -----------------
C
C     PFIELD     - Array containing quasi-regular grid
C                  data.
C
C     KPOINT     - Array containing list of the number of
C                  points on each latitude (or longitude) of
C                  the quasi-regular grid.
C
C     KLAT       - Number of latitude lines
C
C     KLON       - Number of longitude lines
C
C     KCODE      - Interpolation required.
C                  1 , linear - data quasi-regular on
C                               latitude lines.
C                  3 , cubic -  data quasi-regular on
C                               latitude lines.
C                  11, linear - data quasi-regular on
C                               longitude lines.
C                  13, cubic -  data quasi-regular on
C                               longitude lines.
C
C     PMSVAL     - Value used for missing data indicator.
C
C     OMISNG     - True if missing values are present in field.
C
C     OPERIO     - True if input field is periodic.
C
C     OVEGGY     - True if 'nearest neighbour' processing must be used
C                  for interpolation
C
C
C     Output Parameters.
C     ------------------
C
C     KRET       - return code
C                  0 = OK
C                  non-zero indicates fatal error
C
C
C     Output Parameters.
C     ------------------
C
C     PFIELD     - Array containing regular grid data.
C
C
C     Method.
C     -------
C
C     Data is interpolated and expanded into a temporary array,
C     which is then copied back into the user's array.
C     Returns an error code if an invalid interpolation is requested
C     or field size exceeds array dimensions.
C
C
C     Externals.
C     ----------
C
C     ROWINA3
C
C
C     Reference.
C     ----------
C
C     WMO Manual on Codes for GRIB code specifications of
C     quasi-regular grids.
C
C
C     Comments.
C     ---------
C
C     This routine is an adaptation of QU2REG to allow missing data
C     values, and hence bit mapped fields.
C
C
C     Author.
C     -------
C
C     J.D.Chambers     ECMWF      22.07.94
C
C
C     Modifications.
C     --------------
C
C     J.D.Chambers     ECMWF      13.09.94
C     Add return code KRET and remove calls to ABORT.
C
C     J.D.Chambers     ECMWF        Feb 1997
C     Allow for 64-bit pointers
C
C     J. Clochard, Meteo France, for ECMWF - January 1998.
C     Addition of OMISNG and OPERIO arguments.
C     Fix message for longitude number out of bounds, and routine
C     name in title and formats.
C
C
C----<
C     -----------------------------------------------------------------
C*    Section 0. Definition of variables. Data statements.
C     -----------------------------------------------------------------
C
      IMPLICIT NONE
C
C#include "grprs.h"
C
C     Parameters
C
      INTEGER JPBYTES, JPMAX
C#ifdef REAL_8
C      PARAMETER (JPBYTES = 8)
C#else
      PARAMETER (JPBYTES = 4)
C#endif
C      PARAMETER (JPMAX=3000)
C     Maximum number of latitudes (or longitudes), for which arrays
C     are dimensioned.
C
C     Subroutine arguments
C
      REAL PFIELD, PMSVAL
      DIMENSION PFIELD(*)
      INTEGER KPOINT, KLAT, KLON, KCODE, KRET
      DIMENSION KPOINT(*)
      REAL ZLINE, ZWORK, ZTEMP
      DIMENSION ZLINE(JPMAX*2)
      DIMENSION ZWORK(0:JPMAX*2+2,3)
      DIMENSION ZTEMP(JPMAX*JPMAX*2)
C
      LOGICAL OMISNG, OPERIO, OVEGGY
C
C     Local variables.
C
      INTEGER ICODE, ILII, ILIO, IQUANO, IREGNO
      INTEGER J210, J220, J225, J230, J240
C
C      REAL ZLINE, ZWORK
C
C#ifndef _CRAYFTN
C#ifdef POINTER_64
C      INTEGER*8 IZTEMP
C#endif
C#endif
C      REAL ZTEMP
C      DIMENSION ZTEMP(1)
C      POINTER ( IZTEMP, ZTEMP )
C      INTEGER ISIZE
C      SAVE ISIZE, IZTEMP
C
C     Externals
C
C#ifdef POINTER_64
C      INTEGER*8 JMALLOC
C#else
C      INTEGER JMALLOC
C#endif
C      EXTERNAL JMALLOC
C
C      DATA ISIZE/0/
C
C     ------------------------------------------------------------------
C*    Section 1. Set initial values.
C     ------------------------------------------------------------------
C
  100 CONTINUE
C
      KRET = 0
C
C     Check input parameters.
C
      IF (KCODE.NE.1.AND.KCODE.NE.3.AND.KCODE.NE.11.AND.KCODE.NE.13)
     X  THEN
C        WRITE(GRPRSM,9001) KCODE
        WRITE(*,9001) KCODE
        KRET = 1
        GOTO 900
      ELSEIF (KLAT.GT.JPMAX) THEN
C        WRITE(GRPRSM,9002) KLAT , JPMAX
        WRITE(*,9002) KLAT , JPMAX
        KRET = 2
        GOTO 900
      ELSEIF (KLON.GT.JPMAX*2) THEN
C        WRITE(GRPRSM,9003) KLON , JPMAX*2
        WRITE(*,9003) KLON , JPMAX*2
        KRET = 3
        GOTO 900
      ENDIF
C
C     Set array indices to 0.
C
      ILII  = 0
      ILIO  = 0
C
C     Establish values of loop parameters.
C
      IF (KCODE.GT.10) THEN
C
C       Quasi-regular along longitude lines.
C
        IQUANO = KLON
        IREGNO = KLAT
        ICODE  = KCODE - 10
      ELSE
C
C       Quasi-regular along latitude lines.
C
        IQUANO = KLAT
        IREGNO = KLON
        ICODE  = KCODE
      ENDIF
C
C     Allocate memory (first time only)
C      IF( ISIZE.EQ.0 ) THEN
C        ISIZE = (JPMAX*JPMAX*2)*JPBYTES
C        IZTEMP = JMALLOC(ISIZE)
C#ifdef hpR64
C        IZTEMP = IZTEMP/(1024*1024*1024*4)
C#endif
C        IF( IZTEMP.EQ.0 ) THEN
C          WRITE(GRPRSM,*) 'QU2REG3: Memory allocation failed.'
C          WRITE(GRPRSM,*) 'QU2REG3: Number of bytes required = ', ISIZE
C          KRET = 5
C          GOTO 900
C        ENDIF
C      ENDIF
C
C     ------------------------------------------------------------------
C*    Section 2. Interpolate field from quasi to regular grid.
C     ------------------------------------------------------------------
C
  200 CONTINUE
C
      DO 230 J230=1,IQUANO
C
        IF (IREGNO.NE.KPOINT(J230)) THEN
C
C         Line contains less values than required,so
C         extract quasi-regular grid values for a line
C
          DO 210 J210=1,KPOINT(J230)
            ILII        = ILII+1
            ZLINE(J210) = PFIELD(ILII)
  210     CONTINUE
C
C         and interpolate this line.
C
          CALL ROWINA3( ZLINE, IREGNO, KPOINT(J230), ZWORK, ICODE,
     X                  PMSVAL, KRET, OMISNG, OPERIO , OVEGGY)
          IF ( KRET .NE. 0 ) GOTO 900
C
C         Add regular grid values for this line to the temporary array.
C
          DO 220 J220=1,IREGNO
            ILIO        = ILIO+1
            ZTEMP(ILIO) = ZLINE(J220)
  220     CONTINUE
C
        ELSE
C
C         Line contains the required number of values, so add
C         this line to the temporary array.
C
          DO 225 J225=1,IREGNO
            ILIO        = ILIO+1
            ILII        = ILII+1
            ZTEMP(ILIO) = PFIELD(ILII)
  225     CONTINUE
C
        ENDIF
C
  230 CONTINUE
C
C     Copy temporary array to user array.
C
      DO 240 J240=1,KLON*KLAT
        PFIELD(J240) = ZTEMP(J240)
  240 CONTINUE
C
C     ------------------------------------------------------------------
C*    Section 9. Return to calling routine. Format statements.
C     ------------------------------------------------------------------
C
  900 CONTINUE
C
      RETURN
C
 9001 FORMAT (1H ,'QU2REG3 : Invalid interpolation type code = ',I3)
C
 9002 FORMAT (1H ,'QU2REG3 : Number of latitudes is ',I4,', maximum ',
     C                      'allowed is ',I4,'.')
C
 9003 FORMAT (1H ,'QU2REG3 : Number of longitudes is ',I4,', maximum ',
     C                      'allowed is ',I4,'.')
C
      END
C#endif

      SUBROUTINE CHBTRD( VECT, UPLO, N, KD, AB, LDAB, D, E, Q, LDQ,
     $                   WORK, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          UPLO, VECT
      INTEGER            INFO, KD, LDAB, LDQ, N
*     ..
*     .. Array Arguments ..
      REAL               D( * ), E( * )
      COMPLEX            AB( LDAB, * ), Q( LDQ, * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  CHBTRD reduces a complex Hermitian band matrix A to real symmetric
*  tridiagonal form T by a unitary similarity transformation:
*  Q**H * A * Q = T.
*
*  Arguments
*  =========
*
*  VECT    (input) CHARACTER*1
*          = 'N':  do not form Q;
*          = 'V':  form Q;
*          = 'U':  update a matrix X, by forming X*Q.
*
*  UPLO    (input) CHARACTER*1
*          = 'U':  Upper triangle of A is stored;
*          = 'L':  Lower triangle of A is stored.
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  KD      (input) INTEGER
*          The number of superdiagonals of the matrix A if UPLO = 'U',
*          or the number of subdiagonals if UPLO = 'L'.  KD >= 0.
*
*  AB      (input/output) COMPLEX array, dimension (LDAB,N)
*          On entry, the upper or lower triangle of the Hermitian band
*          matrix A, stored in the first KD+1 rows of the array.  The
*          j-th column of A is stored in the j-th column of the array AB
*          as follows:
*          if UPLO = 'U', AB(kd+1+i-j,j) = A(i,j) for max(1,j-kd)<=i<=j;
*          if UPLO = 'L', AB(1+i-j,j)    = A(i,j) for j<=i<=min(n,j+kd).
*          On exit, the diagonal elements of AB are overwritten by the
*          diagonal elements of the tridiagonal matrix T; if KD > 0, the
*          elements on the first superdiagonal (if UPLO = 'U') or the
*          first subdiagonal (if UPLO = 'L') are overwritten by the
*          off-diagonal elements of T; the rest of AB is overwritten by
*          values generated during the reduction.
*
*  LDAB    (input) INTEGER
*          The leading dimension of the array AB.  LDAB >= KD+1.
*
*  D       (output) REAL array, dimension (N)
*          The diagonal elements of the tridiagonal matrix T.
*
*  E       (output) REAL array, dimension (N-1)
*          The off-diagonal elements of the tridiagonal matrix T:
*          E(i) = T(i,i+1) if UPLO = 'U'; E(i) = T(i+1,i) if UPLO = 'L'.
*
*  Q       (input/output) COMPLEX array, dimension (LDQ,N)
*          On entry, if VECT = 'U', then Q must contain an N-by-N
*          matrix X; if VECT = 'N' or 'V', then Q need not be set.
*
*          On exit:
*          if VECT = 'V', Q contains the N-by-N unitary matrix Q;
*          if VECT = 'U', Q contains the product X*Q;
*          if VECT = 'N', the array Q is not referenced.
*
*  LDQ     (input) INTEGER
*          The leading dimension of the array Q.
*          LDQ >= 1, and LDQ >= N if VECT = 'V' or 'U'.
*
*  WORK    (workspace) COMPLEX array, dimension (N)
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*
*  Further Details
*  ===============
*
*  Modified by Linda Kaufman, Bell Labs.
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ZERO
      PARAMETER          ( ZERO = 0.0E+0 )
      COMPLEX            CZERO, CONE
      PARAMETER          ( CZERO = ( 0.0E+0, 0.0E+0 ),
     $                   CONE = ( 1.0E+0, 0.0E+0 ) )
*     ..
*     .. Local Scalars ..
      LOGICAL            INITQ, UPPER, WANTQ
      INTEGER            I, I2, IBL, INCA, INCX, IQAEND, IQB, IQEND, J,
     $                   J1, J1END, J1INC, J2, JEND, JIN, JINC, K, KD1,
     $                   KDM1, KDN, L, LAST, LEND, NQ, NR, NRT
      REAL               ABST
      COMPLEX            T, TEMP
*     ..
*     .. External Subroutines ..
      EXTERNAL           CLACGV, CLAR2V, CLARGV, CLARTG, CLARTV, CLASET,
     $                   CROT, CSCAL, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, CONJG, MAX, MIN, REAL
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters
*
      INITQ = LSAME( VECT, 'V' )
      WANTQ = INITQ .OR. LSAME( VECT, 'U' )
      UPPER = LSAME( UPLO, 'U' )
      KD1 = KD + 1
      KDM1 = KD - 1
      INCX = LDAB - 1
      IQEND = 1
*
      INFO = 0
      IF( .NOT.WANTQ .AND. .NOT.LSAME( VECT, 'N' ) ) THEN
         INFO = -1
      ELSE IF( .NOT.UPPER .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = -2
      ELSE IF( N.LT.0 ) THEN
         INFO = -3
      ELSE IF( KD.LT.0 ) THEN
         INFO = -4
      ELSE IF( LDAB.LT.KD1 ) THEN
         INFO = -6
      ELSE IF( LDQ.LT.MAX( 1, N ) .AND. WANTQ ) THEN
         INFO = -10
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'CHBTRD', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
*
*     Initialize Q to the unit matrix, if needed
*
      IF( INITQ )
     $   CALL CLASET( 'Full', N, N, CZERO, CONE, Q, LDQ )
*
*     Wherever possible, plane rotations are generated and applied in
*     vector operations of length NR over the index set J1:J2:KD1.
*
*     The real cosines and complex sines of the plane rotations are
*     stored in the arrays D and WORK.
*
      INCA = KD1*LDAB
      KDN = MIN( N-1, KD )
      IF( UPPER ) THEN
*
         IF( KD.GT.1 ) THEN
*
*           Reduce to complex Hermitian tridiagonal form, working with
*           the upper triangle
*
            NR = 0
            J1 = KDN + 2
            J2 = 1
*
            AB( KD1, 1 ) = REAL( AB( KD1, 1 ) )
            DO 90 I = 1, N - 2
*
*              Reduce i-th row of matrix to tridiagonal form
*
               DO 80 K = KDN + 1, 2, -1
                  J1 = J1 + KDN
                  J2 = J2 + KDN
*
                  IF( NR.GT.0 ) THEN
*
*                    generate plane rotations to annihilate nonzero
*                    elements which have been created outside the band
*
                     CALL CLARGV( NR, AB( 1, J1-1 ), INCA, WORK( J1 ),
     $                            KD1, D( J1 ), KD1 )
*
*                    apply rotations from the right
*
*
*                    Dependent on the the number of diagonals either
*                    CLARTV or CROT is used
*
                     IF( NR.GE.2*KD-1 ) THEN
                        DO 10 L = 1, KD - 1
                           CALL CLARTV( NR, AB( L+1, J1-1 ), INCA,
     $                                  AB( L, J1 ), INCA, D( J1 ),
     $                                  WORK( J1 ), KD1 )
   10                   CONTINUE
*
                     ELSE
                        JEND = J1 + ( NR-1 )*KD1
                        DO 20 JINC = J1, JEND, KD1
                           CALL CROT( KDM1, AB( 2, JINC-1 ), 1,
     $                                AB( 1, JINC ), 1, D( JINC ),
     $                                WORK( JINC ) )
   20                   CONTINUE
                     END IF
                  END IF
*
*
                  IF( K.GT.2 ) THEN
                     IF( K.LE.N-I+1 ) THEN
*
*                       generate plane rotation to annihilate a(i,i+k-1)
*                       within the band
*
                        CALL CLARTG( AB( KD-K+3, I+K-2 ),
     $                               AB( KD-K+2, I+K-1 ), D( I+K-1 ),
     $                               WORK( I+K-1 ), TEMP )
                        AB( KD-K+3, I+K-2 ) = TEMP
*
*                       apply rotation from the right
*
                        CALL CROT( K-3, AB( KD-K+4, I+K-2 ), 1,
     $                             AB( KD-K+3, I+K-1 ), 1, D( I+K-1 ),
     $                             WORK( I+K-1 ) )
                     END IF
                     NR = NR + 1
                     J1 = J1 - KDN - 1
                  END IF
*
*                 apply plane rotations from both sides to diagonal
*                 blocks
*
                  IF( NR.GT.0 )
     $               CALL CLAR2V( NR, AB( KD1, J1-1 ), AB( KD1, J1 ),
     $                            AB( KD, J1 ), INCA, D( J1 ),
     $                            WORK( J1 ), KD1 )
*
*                 apply plane rotations from the left
*
                  CALL CLACGV( NR, WORK( J1 ), KD1 )
                  IF( NR.GT.0 ) THEN
                     IF( 2*KD-1.LT.NR ) THEN
*
*                    Dependent on the the number of diagonals either
*                    CLARTV or CROT is used
*
                        DO 30 L = 1, KD - 1
                           IF( J2+L.GT.N ) THEN
                              NRT = NR - 1
                           ELSE
                              NRT = NR
                           END IF
                           IF( NRT.GT.0 )
     $                        CALL CLARTV( NRT, AB( KD-L, J1+L ), INCA,
     $                                     AB( KD-L+1, J1+L ), INCA,
     $                                     D( J1 ), WORK( J1 ), KD1 )
   30                   CONTINUE
                     ELSE
                        J1END = J1 + KD1*( NR-2 )
                        IF( J1END.GE.J1 ) THEN
                           DO 40 JIN = J1, J1END, KD1
                              CALL CROT( KD-1, AB( KD-1, JIN+1 ), INCX,
     $                                   AB( KD, JIN+1 ), INCX,
     $                                   D( JIN ), WORK( JIN ) )
   40                      CONTINUE
                        END IF
                        LEND = MIN( KDM1, N-J2 )
                        LAST = J1END + KD1
                        IF( LEND.GT.0 )
     $                     CALL CROT( LEND, AB( KD-1, LAST+1 ), INCX,
     $                                AB( KD, LAST+1 ), INCX, D( LAST ),
     $                                WORK( LAST ) )
                     END IF
                  END IF
*
                  IF( WANTQ ) THEN
*
*                    accumulate product of plane rotations in Q
*
                     IF( INITQ ) THEN
*
*                 take advantage of the fact that Q was
*                 initially the Identity matrix
*
                        IQEND = MAX( IQEND, J2 )
                        I2 = MAX( 0, K-3 )
                        IQAEND = 1 + I*KD
                        IF( K.EQ.2 )
     $                     IQAEND = IQAEND + KD
                        IQAEND = MIN( IQAEND, IQEND )
                        DO 50 J = J1, J2, KD1
                           IBL = I - I2 / KDM1
                           I2 = I2 + 1
                           IQB = MAX( 1, J-IBL )
                           NQ = 1 + IQAEND - IQB
                           IQAEND = MIN( IQAEND+KD, IQEND )
                           CALL CROT( NQ, Q( IQB, J-1 ), 1, Q( IQB, J ),
     $                                1, D( J ), CONJG( WORK( J ) ) )
   50                   CONTINUE
                     ELSE
*
                        DO 60 J = J1, J2, KD1
                           CALL CROT( N, Q( 1, J-1 ), 1, Q( 1, J ), 1,
     $                                D( J ), CONJG( WORK( J ) ) )
   60                   CONTINUE
                     END IF
*
                  END IF
*
                  IF( J2+KDN.GT.N ) THEN
*
*                    adjust J2 to keep within the bounds of the matrix
*
                     NR = NR - 1
                     J2 = J2 - KDN - 1
                  END IF
*
                  DO 70 J = J1, J2, KD1
*
*                    create nonzero element a(j-1,j+kd) outside the band
*                    and store it in WORK
*
                     WORK( J+KD ) = WORK( J )*AB( 1, J+KD )
                     AB( 1, J+KD ) = D( J )*AB( 1, J+KD )
   70             CONTINUE
   80          CONTINUE
   90       CONTINUE
         END IF
*
         IF( KD.GT.0 ) THEN
*
*           make off-diagonal elements real and copy them to E
*
            DO 100 I = 1, N - 1
               T = AB( KD, I+1 )
               ABST = ABS( T )
               AB( KD, I+1 ) = ABST
               E( I ) = ABST
               IF( ABST.NE.ZERO ) THEN
                  T = T / ABST
               ELSE
                  T = CONE
               END IF
               IF( I.LT.N-1 )
     $            AB( KD, I+2 ) = AB( KD, I+2 )*T
               IF( WANTQ ) THEN
                  CALL CSCAL( N, CONJG( T ), Q( 1, I+1 ), 1 )
               END IF
  100       CONTINUE
         ELSE
*
*           set E to zero if original matrix was diagonal
*
            DO 110 I = 1, N - 1
               E( I ) = ZERO
  110       CONTINUE
         END IF
*
*        copy diagonal elements to D
*
         DO 120 I = 1, N
            D( I ) = AB( KD1, I )
  120    CONTINUE
*
      ELSE
*
         IF( KD.GT.1 ) THEN
*
*           Reduce to complex Hermitian tridiagonal form, working with
*           the lower triangle
*
            NR = 0
            J1 = KDN + 2
            J2 = 1
*
            AB( 1, 1 ) = REAL( AB( 1, 1 ) )
            DO 210 I = 1, N - 2
*
*              Reduce i-th column of matrix to tridiagonal form
*
               DO 200 K = KDN + 1, 2, -1
                  J1 = J1 + KDN
                  J2 = J2 + KDN
*
                  IF( NR.GT.0 ) THEN
*
*                    generate plane rotations to annihilate nonzero
*                    elements which have been created outside the band
*
                     CALL CLARGV( NR, AB( KD1, J1-KD1 ), INCA,
     $                            WORK( J1 ), KD1, D( J1 ), KD1 )
*
*                    apply plane rotations from one side
*
*
*                    Dependent on the the number of diagonals either
*                    CLARTV or CROT is used
*
                     IF( NR.GT.2*KD-1 ) THEN
                        DO 130 L = 1, KD - 1
                           CALL CLARTV( NR, AB( KD1-L, J1-KD1+L ), INCA,
     $                                  AB( KD1-L+1, J1-KD1+L ), INCA,
     $                                  D( J1 ), WORK( J1 ), KD1 )
  130                   CONTINUE
                     ELSE
                        JEND = J1 + KD1*( NR-1 )
                        DO 140 JINC = J1, JEND, KD1
                           CALL CROT( KDM1, AB( KD, JINC-KD ), INCX,
     $                                AB( KD1, JINC-KD ), INCX,
     $                                D( JINC ), WORK( JINC ) )
  140                   CONTINUE
                     END IF
*
                  END IF
*
                  IF( K.GT.2 ) THEN
                     IF( K.LE.N-I+1 ) THEN
*
*                       generate plane rotation to annihilate a(i+k-1,i)
*                       within the band
*
                        CALL CLARTG( AB( K-1, I ), AB( K, I ),
     $                               D( I+K-1 ), WORK( I+K-1 ), TEMP )
                        AB( K-1, I ) = TEMP
*
*                       apply rotation from the left
*
                        CALL CROT( K-3, AB( K-2, I+1 ), LDAB-1,
     $                             AB( K-1, I+1 ), LDAB-1, D( I+K-1 ),
     $                             WORK( I+K-1 ) )
                     END IF
                     NR = NR + 1
                     J1 = J1 - KDN - 1
                  END IF
*
*                 apply plane rotations from both sides to diagonal
*                 blocks
*
                  IF( NR.GT.0 )
     $               CALL CLAR2V( NR, AB( 1, J1-1 ), AB( 1, J1 ),
     $                            AB( 2, J1-1 ), INCA, D( J1 ),
     $                            WORK( J1 ), KD1 )
*
*                 apply plane rotations from the right
*
*
*                    Dependent on the the number of diagonals either
*                    CLARTV or CROT is used
*
                  CALL CLACGV( NR, WORK( J1 ), KD1 )
                  IF( NR.GT.0 ) THEN
                     IF( NR.GT.2*KD-1 ) THEN
                        DO 150 L = 1, KD - 1
                           IF( J2+L.GT.N ) THEN
                              NRT = NR - 1
                           ELSE
                              NRT = NR
                           END IF
                           IF( NRT.GT.0 )
     $                        CALL CLARTV( NRT, AB( L+2, J1-1 ), INCA,
     $                                     AB( L+1, J1 ), INCA, D( J1 ),
     $                                     WORK( J1 ), KD1 )
  150                   CONTINUE
                     ELSE
                        J1END = J1 + KD1*( NR-2 )
                        IF( J1END.GE.J1 ) THEN
                           DO 160 J1INC = J1, J1END, KD1
                              CALL CROT( KDM1, AB( 3, J1INC-1 ), 1,
     $                                   AB( 2, J1INC ), 1, D( J1INC ),
     $                                   WORK( J1INC ) )
  160                      CONTINUE
                        END IF
                        LEND = MIN( KDM1, N-J2 )
                        LAST = J1END + KD1
                        IF( LEND.GT.0 )
     $                     CALL CROT( LEND, AB( 3, LAST-1 ), 1,
     $                                AB( 2, LAST ), 1, D( LAST ),
     $                                WORK( LAST ) )
                     END IF
                  END IF
*
*
*
                  IF( WANTQ ) THEN
*
*                    accumulate product of plane rotations in Q
*
                     IF( INITQ ) THEN
*
*                 take advantage of the fact that Q was
*                 initially the Identity matrix
*
                        IQEND = MAX( IQEND, J2 )
                        I2 = MAX( 0, K-3 )
                        IQAEND = 1 + I*KD
                        IF( K.EQ.2 )
     $                     IQAEND = IQAEND + KD
                        IQAEND = MIN( IQAEND, IQEND )
                        DO 170 J = J1, J2, KD1
                           IBL = I - I2 / KDM1
                           I2 = I2 + 1
                           IQB = MAX( 1, J-IBL )
                           NQ = 1 + IQAEND - IQB
                           IQAEND = MIN( IQAEND+KD, IQEND )
                           CALL CROT( NQ, Q( IQB, J-1 ), 1, Q( IQB, J ),
     $                                1, D( J ), WORK( J ) )
  170                   CONTINUE
                     ELSE
*
                        DO 180 J = J1, J2, KD1
                           CALL CROT( N, Q( 1, J-1 ), 1, Q( 1, J ), 1,
     $                                D( J ), WORK( J ) )
  180                   CONTINUE
                     END IF
                  END IF
*
                  IF( J2+KDN.GT.N ) THEN
*
*                    adjust J2 to keep within the bounds of the matrix
*
                     NR = NR - 1
                     J2 = J2 - KDN - 1
                  END IF
*
                  DO 190 J = J1, J2, KD1
*
*                    create nonzero element a(j+kd,j-1) outside the
*                    band and store it in WORK
*
                     WORK( J+KD ) = WORK( J )*AB( KD1, J )
                     AB( KD1, J ) = D( J )*AB( KD1, J )
  190             CONTINUE
  200          CONTINUE
  210       CONTINUE
         END IF
*
         IF( KD.GT.0 ) THEN
*
*           make off-diagonal elements real and copy them to E
*
            DO 220 I = 1, N - 1
               T = AB( 2, I )
               ABST = ABS( T )
               AB( 2, I ) = ABST
               E( I ) = ABST
               IF( ABST.NE.ZERO ) THEN
                  T = T / ABST
               ELSE
                  T = CONE
               END IF
               IF( I.LT.N-1 )
     $            AB( 2, I+1 ) = AB( 2, I+1 )*T
               IF( WANTQ ) THEN
                  CALL CSCAL( N, T, Q( 1, I+1 ), 1 )
               END IF
  220       CONTINUE
         ELSE
*
*           set E to zero if original matrix was diagonal
*
            DO 230 I = 1, N - 1
               E( I ) = ZERO
  230       CONTINUE
         END IF
*
*        copy diagonal elements to D
*
         DO 240 I = 1, N
            D( I ) = AB( 1, I )
  240    CONTINUE
      END IF
*
      RETURN
*
*     End of CHBTRD
*
      END

C
C       $Id: shgivens.f,v 1.4 2008-07-27 03:10:13 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE SHGIVENS ( A,B, C,S)
      REAL A, B, C, S
C
C***********************************************************
C
C                                               ROBERT RENKA
C                                       UNIV. OF NORTH TEXAS
C                                             (817) 565-2767
C
C  This routine constructs the Givens plane rotation --
C
C      ( C  S)
C  G = (     ) where C*C + S*S = 1 -- which zeros the second
C      (-S  C)
C
C  entry of the 2-vector (A B)-transpose.  A call to SHGIVENS
C  is normally followed by a call to SHROT which applieS
C  the transformation to a 2 by N matrix.  This routine was
C  taken from LINPACK.
C
C  ON INPUT --
C
C    A,B = Components of the 2-vector to be rotated.
C
C  ON OUTPUT --
C
C    A = value overwritten by R = +/-SQRT(A*A + B*B)
C
C    B = value overwritten by a value Z which allows C
C        and S to be recovered as follows --
C
C          C = SQRT(1-Z*Z), S=Z     if ABS(Z) .LE. 1.
C          C = 1/Z, S = SQRT(1-C*C) if ABS(Z) .GT. 1.
C
C    C = +/-(A/R)
C
C    S = +/-(B/R)
C
C  MODULES REQUIRED BY SHGIVENS -- NONE
C
C  INTRINSIC FUNCTIONS CALLED BY SHGIVENS - ABS, SQRT
C
C***********************************************************
C
      REAL AA, BB, R, U, V
C
C  Local parameters --
C
C  AA,BB = local copies of A and B
C  R =     C*A + S*B = +/-SQRT(A*A+B*B)
C  U,V =   variables used to scale A and B for computing R
C
      AA = A
      BB = B
      IF (ABS(AA) .LE. ABS(BB)) GO TO 1
C
C  ABS(A) .GT. ABS(B)
C
      U = AA + AA
      V = BB/U
      IF (ABS(V) .LT. 1.E-25) V = 0.
      R = SQRT(.25 + V*V) * U
      C = AA/R
      S = V * (C + C)
C
C  Note that R has the sign of A, C .GT. 0, and S has
C  SIGN(A)*SIGN(B).
C
      B = S
      A = R
      RETURN
C
C  ABS(A) .LE. ABS(B)
C
    1 IF (BB .EQ. 0.) GO TO 2
      U = BB + BB
      V = AA/U
C
C  Store R in A.
C
      IF (ABS(V) .LT. 1.E-25) V = 0.
      A = SQRT(.25 + V*V) * U
      S = BB/A
      C = V * (S + S)
C
C  Note that R has the sign of B, S .GT. 0, and C has
C  SIGN(A)*SIGN(B).
C
      B = 1.
      IF (C .NE. 0.) B = 1./C
      RETURN
C
C  A = B = 0.
C
    2 C = 1.
      S = 0.
      RETURN
      END

c =======fftpack.f subset==============================================
c     subroutine ezfftf(n,r,azero,a,b,wsave)
c
c     subroutine ezfftf computes the fourier coefficients of a real
c     perodic sequence (fourier analysis). the transform is defined
c     below at output parameters azero,a and b. ezfftf is a simplified
c     but slower version of rfftf.
c
c     input parameters
c
c     n       the length of the array r to be transformed.  the method
c             is must efficient when n is the product of small primes.
c
c     r       a real array of length n which contains the sequence
c             to be transformed. r is not destroyed.
c
c
c     wsave   a work array which must be dimensioned at least 3*n+15.
c             in the program that calls ezfftf. the wsave array must be
c             initialized by calling subroutine ezffti(n,wsave) and a
c             different wsave array must be used for each different
c             value of n. this initialization does not have to be
c             repeated so long as n remains unchanged thus subsequent
c             transforms can be obtained faster than the first.
c             the same wsave array can be used by ezfftf and ezfftb.
c
c     output parameters
c
c     azero   the sum from i=1 to i=n of r(i)/n
c
c     a,b     for n even b(n/2)=0. and a(n/2) is the sum from i=1 to
c             i=n of (-1)**(i-1)*r(i)/n
c
c             for n even define kmax=n/2-1
c             for n odd  define kmax=(n-1)/2
c
c             then for  k=1,...,kmax
c
c                  a(k) equals the sum from i=1 to i=n of
c
c                       2./n*r(i)*cos(k*(i-1)*2*pi/n)
c
c                  b(k) equals the sum from i=1 to i=n of
c
c                       2./n*r(i)*sin(k*(i-1)*2*pi/n)
c
c
      SUBROUTINE DEZFFTF(N,R,AZERO,A,B,WSAVE)
      DOUBLE PRECISION R
      DOUBLE PRECISION AZERO
      DOUBLE PRECISION A
      DOUBLE PRECISION B
      DOUBLE PRECISION WSAVE
      DOUBLE PRECISION CF
      DOUBLE PRECISION CFM
      DIMENSION R(*),A(*),B(*),WSAVE(*)
c
      IF (N-2.LE.0) THEN
          IF (N-2.NE.0) THEN
              AZERO = R(1)
              RETURN
          END IF
          AZERO = .5D0* (R(1)+R(2))
          A(1) = .5D0* (R(1)-R(2))
          RETURN
      END IF
      DO I = 1,N
          WSAVE(I) = R(I)
      END DO
      CALL DRFFTF(N,WSAVE,WSAVE(N+1))
      CF = 2.D0/DBLE(N)
      CFM = -CF
      AZERO = .5D0*CF*WSAVE(1)
      NS2 = (N+1)/2
      NS2M = NS2 - 1
      DO I = 1,NS2M
          A(I) = CF*WSAVE(2*I)
          B(I) = CFM*WSAVE(2*I+1)
      END DO
C      B(NS2) = 0.D0
      IF (MOD(N,2).EQ.1) RETURN
      A(NS2) = .5D0*CF*WSAVE(N)
      B(NS2) = 0.D0
      RETURN
      END
c
c =====================================================================
c     subroutine rfftf(n,r,wsave)
c
c     subroutine rfftf computes the fourier coefficients of a real
c     perodic sequence (fourier analysis). the transform is defined
c     below at output parameter r.
c
c     input parameters
c
c     n       the length of the array r to be transformed.  the method
c             is most efficient when n is a product of small primes.
c             n may change so long as different work arrays are provided
c
c     r       a real array of length n which contains the sequence
c             to be transformed
c
c     wsave   a work array which must be dimensioned at least 2*n+15.
c             in the program that calls rfftf. the wsave array must be
c             initialized by calling subroutine rffti(n,wsave) and a
c             different wsave array must be used for each different
c             value of n. this initialization does not have to be
c             repeated so long as n remains unchanged thus subsequent
c             transforms can be obtained faster than the first.
c             the same wsave array can be used by rfftf and rfftb.
c
c
c     output parameters
c
c     r       r(1) = the sum from i=1 to i=n of r(i)
c
c             if n is even set l =n/2   , if n is odd set l = (n+1)/2
c
c               then for k = 2,...,l
c
c                  r(2*k-2) = the sum from i = 1 to i = n of
c
c                       r(i)*cos((k-1)*(i-1)*2*pi/n)
c
c                  r(2*k-1) = the sum from i = 1 to i = n of
c
c                      -r(i)*sin((k-1)*(i-1)*2*pi/n)
c
c             if n is even
c
c                  r(n) = the sum from i = 1 to i = n of
c
c                       (-1)**(i-1)*r(i)
c
c      *****  note
c                  this transform is unnormalized since a call of rfftf
c                  followed by a call of rfftb will multiply the input
c                  sequence by n.
c
c     wsave   contains results which must not be destroyed between
c             calls of rfftf or rfftb.
c
      SUBROUTINE DRFFTF(N,R,WSAVE)
      DOUBLE PRECISION R
      DOUBLE PRECISION WSAVE
      DIMENSION R(*),WSAVE(*)
c
      IF (N.EQ.1) RETURN
      CALL DRFFTF1OLD(N,R,WSAVE,WSAVE(N+1),WSAVE(2*N+1))
      RETURN
      END
c
      SUBROUTINE DRFFTF1OLD(N,C,CH,WA,IFAC)
      DOUBLE PRECISION C
      DOUBLE PRECISION CH
      DOUBLE PRECISION WA
      DIMENSION CH(*),C(*),WA(*),IFAC(*)

      NF = IFAC(2)
      DO K1 = 1,NF
          KH = NF - K1
       END DO
      NA = 1
      L2 = N
      IW = N
      DO K1 = 1,NF
          KH = NF - K1
          IP = IFAC(KH+3)
          L1 = L2/IP
          IDO = N/L2
          IDL1 = IDO*L1
          IW = IW - (IP-1)*IDO
          NA = 1 - NA
          IF (IP.EQ.4) THEN
              IX2 = IW + IDO
              IX3 = IX2 + IDO
              IF (NA.EQ.0) THEN
                  CALL DRADF4(IDO,L1,C,CH,WA(IW),WA(IX2),WA(IX3))
                  GO TO 110
              END IF
              CALL DRADF4(IDO,L1,CH,C,WA(IW),WA(IX2),WA(IX3))
              GO TO 110
          END IF
          IF (IP.EQ.2) THEN
              IF (NA.EQ.0) THEN
                  CALL DRADF2(IDO,L1,C,CH,WA(IW))
                  GO TO 110
              END IF
              CALL DRADF2(IDO,L1,CH,C,WA(IW))
              GO TO 110
          END IF
  104     CONTINUE
          IF (IP.EQ.3) THEN
              IX2 = IW + IDO
              IF (NA.EQ.0) THEN
                  CALL DRADF3(IDO,L1,C,CH,WA(IW),WA(IX2))
                  GO TO 110
              END IF
              CALL DRADF3(IDO,L1,CH,C,WA(IW),WA(IX2))
              GO TO 110
          END IF
  106     CONTINUE
          IF (IP.EQ.5) THEN
              IX2 = IW + IDO
              IX3 = IX2 + IDO
              IX4 = IX3 + IDO
              IF (NA.EQ.0) THEN
                  CALL DRADF5(IDO,L1,C,CH,WA(IW),WA(IX2),WA(IX3),
     +                WA(IX4))
                  GO TO 110
              END IF
              CALL DRADF5(IDO,L1,CH,C,WA(IW),WA(IX2),WA(IX3),WA(IX4))
              GO TO 110
          END IF
  108     CONTINUE
          IF (IDO.EQ.1) NA = 1 - NA
          IF (NA.EQ.0) THEN
              CALL DRADFG(IDO,IP,L1,IDL1,C,C,C,CH,CH,WA(IW))
              NA = 1
          ELSE
              CALL DRADFG(IDO,IP,L1,IDL1,CH,CH,CH,C,C,WA(IW))
              NA = 0
          END IF
  110     CONTINUE
          L2 = L1
      END DO
      IF (NA.EQ.1) RETURN
      DO I = 1,N
          C(I) = CH(I)
      END DO
      RETURN
      END
c ==============================================================
c     subroutine ezfftb(n,r,azero,a,b,wsave)
c
c     subroutine ezfftb computes a real perodic sequence from its
c     fourier coefficients (fourier synthesis). the transform is
c     defined below at output parameter r. ezfftb is a simplified
c     but slower version of rfftb.
c
c     input parameters
c
c     n       the length of the output array r.  the method is most
c             efficient when n is the product of small primes.
c
c     azero   the constant fourier coefficient
c
c     a,b     arrays which contain the remaining fourier coefficients
c             these arrays are not destroyed.
c
c             the length of these arrays depends on whether n is even or
c             odd.
c
c             if n is even n/2    locations are required
c             if n is odd (n-1)/2 locations are required
c
c     wsave   a work array which must be dimensioned at least 3*n+15.
c             in the program that calls ezfftb. the wsave array must be
c             initialized by calling subroutine ezffti(n,wsave) and a
c             different wsave array must be used for each different
c             value of n. this initialization does not have to be
c             repeated so long as n remains unchanged thus subsequent
c             transforms can be obtained faster than the first.
c             the same wsave array can be used by ezfftf and ezfftb.
c
c
c     output parameters
c
c     r       if n is even define kmax=n/2
c             if n is odd  define kmax=(n-1)/2
c
c             then for i=1,...,n
c
c                  r(i)=azero plus the sum from k=1 to k=kmax of
c
c                  a(k)*cos(k*(i-1)*2*pi/n)+b(k)*sin(k*(i-1)*2*pi/n)
c
c     ********************* complex notation **************************
c
c             for j=1,...,n
c
c             r(j) equals the sum from k=-kmax to k=kmax of
c
c                  c(k)*exp(i*k*(j-1)*2*pi/n)
c
c             where
c
c                  c(k) = .5*cmplx(a(k),-b(k))   for k=1,...,kmax
c
c                  c(-k) = conjg(c(k))
c
c                  c(0) = azero
c
c                       and i=sqrt(-1)
c
c     *************** amplitude - phase notation ***********************
c
c             for i=1,...,n
c
c             r(i) equals azero plus the sum from k=1 to k=kmax of
c
c                  alpha(k)*cos(k*(i-1)*2*pi/n+beta(k))
c
c             where
c
c                  alpha(k) = sqrt(a(k)*a(k)+b(k)*b(k))
c
c                  cos(beta(k))=a(k)/alpha(k)
c
c                  sin(beta(k))=-b(k)/alpha(k)
c
      SUBROUTINE DEZFFTB(N,R,AZERO,A,B,WSAVE)
      DOUBLE PRECISION R
      DOUBLE PRECISION AZERO
      DOUBLE PRECISION A
      DOUBLE PRECISION B
      DOUBLE PRECISION WSAVE
      DIMENSION R(*),A(*),B(*),WSAVE(*)
c
      IF (N-2.LE.0) THEN
          IF (N-2.NE.0) THEN
              R(1) = AZERO
              RETURN
          END IF
          R(1) = AZERO + A(1)
          R(2) = AZERO - A(1)
          RETURN
      END IF
      NS2 = (N-1)/2
      DO I = 1,NS2
          R(2*I) = .5D0*A(I)
          R(2*I+1) = -.5D0*B(I)
      END DO
      R(1) = AZERO
      IF (MOD(N,2).EQ.0) R(N) = A(NS2+1)
      CALL DRFFTB(N,R,WSAVE(N+1))
      RETURN
      END
c
c =====================================================================
c     subroutine rfftb(n,r,wsave)
c
c     subroutine rfftb computes the real perodic sequence from its
c     fourier coefficients (fourier synthesis). the transform is defined
c     below at output parameter r.
c
c     input parameters
c
c     n       the length of the array r to be transformed.  the method
c             is most efficient when n is a product of small primes.
c             n may change so long as different work arrays are provided
c
c     r       a real array of length n which contains the sequence
c             to be transformed
c
c     wsave   a work array which must be dimensioned at least 2*n+15.
c             in the program that calls rfftb. the wsave array must be
c             initialized by calling subroutine rffti(n,wsave) and a
c             different wsave array must be used for each different
c             value of n. this initialization does not have to be
c             repeated so long as n remains unchanged thus subsequent
c             transforms can be obtained faster than the first.
c             the same wsave array can be used by rfftf and rfftb.
c
c
c     output parameters
c
c     r       for n even and for i = 1,...,n
c
c                  r(i) = r(1)+(-1)**(i-1)*r(n)
c
c                       plus the sum from k=2 to k=n/2 of
c
c                        2.*r(2*k-2)*cos((k-1)*(i-1)*2*pi/n)
c
c                       -2.*r(2*k-1)*sin((k-1)*(i-1)*2*pi/n)
c
c             for n odd and for i = 1,...,n
c
c                  r(i) = r(1) plus the sum from k=2 to k=(n+1)/2 of
c
c                       2.*r(2*k-2)*cos((k-1)*(i-1)*2*pi/n)
c
c                      -2.*r(2*k-1)*sin((k-1)*(i-1)*2*pi/n)
c
c      *****  note
c                  this transform is unnormalized since a call of rfftf
c                  followed by a call of rfftb will multiply the input
c                  sequence by n.
c
c     wsave   contains results which must not be destroyed between
c             calls of rfftb or rfftf.
c
c
      SUBROUTINE DRFFTB(N,R,WSAVE)
      DOUBLE PRECISION R
      DOUBLE PRECISION WSAVE
      DIMENSION R(*),WSAVE(*)
c
      IF (N.EQ.1) RETURN
      CALL DRFFTB1OLD(N,R,WSAVE,WSAVE(N+1),WSAVE(2*N+1))
      RETURN
      END
c
c =====================================================================
      SUBROUTINE DRFFTB1OLD(N,C,CH,WA,IFAC)
      DOUBLE PRECISION C
      DOUBLE PRECISION CH
      DOUBLE PRECISION WA
      DIMENSION CH(*),C(*),WA(*),IFAC(*)

      NF = IFAC(2)
      NA = 0
      L1 = 1
      IW = 1
      DO K1 = 1,NF
          IP = IFAC(K1+2)
          L2 = IP*L1
          IDO = N/L2
          IDL1 = IDO*L1
          IF (IP.EQ.4) THEN
              IX2 = IW + IDO
              IX3 = IX2 + IDO
              IF (NA.EQ.0) THEN
                  CALL DRADB4(IDO,L1,C,CH,WA(IW),WA(IX2),WA(IX3))
              ELSE
                  CALL DRADB4(IDO,L1,CH,C,WA(IW),WA(IX2),WA(IX3))
              END IF
              NA = 1 - NA
          ELSE
              IF (IP.EQ.2) THEN
                  IF (NA.EQ.0) THEN
                      CALL DRADB2(IDO,L1,C,CH,WA(IW))
                  ELSE
                      CALL DRADB2(IDO,L1,CH,C,WA(IW))
                  END IF
                  NA = 1 - NA
              ELSE
                  IF (IP.EQ.3) THEN
                      IX2 = IW + IDO
                      IF (NA.EQ.0) THEN
                          CALL DRADB3(IDO,L1,C,CH,WA(IW),WA(IX2))
                      ELSE
                          CALL DRADB3(IDO,L1,CH,C,WA(IW),WA(IX2))
                      END IF
                      NA = 1 - NA
                  ELSE
                      IF (IP.EQ.5) THEN
                          IX2 = IW + IDO
                          IX3 = IX2 + IDO
                          IX4 = IX3 + IDO
                          IF (NA.EQ.0) THEN
                              CALL DRADB5(IDO,L1,C,CH,WA(IW),WA(IX2),
     +                                   WA(IX3),WA(IX4))
                          ELSE
                              CALL DRADB5(IDO,L1,CH,C,WA(IW),WA(IX2),
     +                                   WA(IX3),WA(IX4))
                          END IF
                          NA = 1 - NA
                      ELSE
                          IF (NA.EQ.0) THEN
                              CALL DRADBG(IDO,IP,L1,IDL1,C,C,C,CH,CH,
     +                                   WA(IW))
                          ELSE
                              CALL DRADBG(IDO,IP,L1,IDL1,CH,CH,CH,C,C,
     +                                   WA(IW))
                          END IF
                          IF (IDO.EQ.1) NA = 1 - NA
                      END IF
                  END IF
              END IF
          END IF
          L1 = L2
          IW = IW + (IP-1)*IDO
      END DO
      IF (NA.EQ.0) RETURN
      DO I = 1,N
          C(I) = CH(I)
      END DO
      RETURN
      END
c ==============================================================
c     subroutine ezffti(n,wsave)
c
c     subroutine ezffti initializes the array wsave which is used in
c     both ezfftf and ezfftb. the prime factorization of n together with
c     a tabulation of the trigonometric functions are computed and
c     stored in wsave.
c
c     input parameter
c
c     n       the length of the sequence to be transformed.
c
c     output parameter
c
c     wsave   a work array which must be dimensioned at least 3*n+15.
c             the same work array can be used for both ezfftf and ezfftb
c             as long as n remains unchanged. different wsave arrays
c             are required for different values of n.
c
      SUBROUTINE DEZFFTI(N,WSAVE)
      DOUBLE PRECISION WSAVE
      DIMENSION WSAVE(*)
c
      IF (N.EQ.1) RETURN
      CALL DEZFFT1(N,WSAVE(2*N+1),WSAVE(3*N+1))
      RETURN
      END
c
      SUBROUTINE DEZFFT1(N,WA,IFAC)
      DOUBLE PRECISION WA
      DOUBLE PRECISION TPI
      DOUBLE PRECISION ARGH
      DOUBLE PRECISION ARG1
      DOUBLE PRECISION CH1
      DOUBLE PRECISION SH1
      DOUBLE PRECISION DCH1
      DOUBLE PRECISION DSH1
      DOUBLE PRECISION CH1H
      DIMENSION WA(*),IFAC(*),NTRYH(4)
      DATA NTRYH(1),NTRYH(2),NTRYH(3),NTRYH(4)/4,2,3,5/

      TPI = 8.0D0*ATAN(1.0D0)
      NL = N
      NF = 0
      J = 0
  101 CONTINUE
      J = J + 1
      IF (J-4.LE.0) THEN
          NTRY = NTRYH(J)
      ELSE
          NTRY = NTRY + 2
      END IF
  104 CONTINUE
      NQ = NL/NTRY
      NR = NL - NTRY*NQ
      IF (NR.NE.0) GO TO 101
      NF = NF + 1
      IFAC(NF+2) = NTRY
      NL = NQ
      IF (NTRY.EQ.2) THEN
          IF (NF.NE.1) THEN
              DO I = 2,NF
                  IB = NF - I + 2
                  IFAC(IB+2) = IFAC(IB+1)
              END DO
              IFAC(3) = 2
          END IF
      END IF
      IF (NL.NE.1) GO TO 104
      IFAC(1) = N
      IFAC(2) = NF
      ARGH = TPI/DBLE(N)
      IS = 0
      NFM1 = NF - 1
      L1 = 1
      IF (NFM1.EQ.0) RETURN
      DO K1 = 1,NFM1
          IP = IFAC(K1+2)
          L2 = L1*IP
          IDO = N/L2
          IPM = IP - 1
          ARG1 = DBLE(L1)*ARGH
          CH1 = 1.D0
          SH1 = 0.D0
          DCH1 = COS(ARG1)
          DSH1 = SIN(ARG1)
          DO J = 1,IPM
              CH1H = DCH1*CH1 - DSH1*SH1
              SH1 = DCH1*SH1 + DSH1*CH1
              CH1 = CH1H
              I = IS + 2
              WA(I-1) = CH1
              WA(I) = SH1
              IF (IDO.GE.5) THEN
                  DO II = 5,IDO,2
                      I = I + 2
                      WA(I-1) = CH1*WA(I-3) - SH1*WA(I-2)
                      WA(I) = CH1*WA(I-2) + SH1*WA(I-3)
                  END DO
              END IF
              IS = IS + IDO
          END DO
          L1 = L2
      END DO
      RETURN
      END
c ==========================================================
c     subroutine rffti(n,wsave)
c
c     subroutine rffti initializes the array wsave which is used in
c     both rfftf and rfftb. the prime factorization of n together with
c     a tabulation of the trigonometric functions are computed and
c     stored in wsave.
c
c     input parameter
c
c     n       the length of the sequence to be transformed.
c
c     output parameter
c
c     wsave   a work array which must be dimensioned at least 2*n+15.
c             the same work array can be used for both rfftf and rfftb
c             as long as n remains unchanged. different wsave arrays
c             are required for different values of n. the contents of
c             wsave must not be changed between calls of rfftf or rfftb.
c
      SUBROUTINE DRFFTI(N,WSAVE)
      DOUBLE PRECISION WSAVE
      DIMENSION WSAVE(*)
c
      IF (N.EQ.1) RETURN
      CALL DRFFTI1OLD(N,WSAVE(N+1),WSAVE(2*N+1))
      RETURN
      END
c
c ==========================================================
c      real function pimach (dum)
c     pi=3.1415926535897932384626433832795028841971693993751058209749446
c
c      pimach = 4.*atan(1.0)
c      return
c      end
c
      SUBROUTINE DRFFTI1OLD(N,WA,IFAC)
      DOUBLE PRECISION WA
      DOUBLE PRECISION TPI
      DOUBLE PRECISION DPIMACH
      DOUBLE PRECISION DUM
      DOUBLE PRECISION ARGH
      DOUBLE PRECISION ARGLD
      DOUBLE PRECISION FI
      DOUBLE PRECISION ARG
      DIMENSION WA(*),IFAC(*),NTRYH(4)
      DATA NTRYH(1),NTRYH(2),NTRYH(3),NTRYH(4)/4,2,3,5/

      NL = N
      NF = 0
      J = 0
  101 CONTINUE
      J = J + 1
      IF (J-4.LE.0) THEN
          NTRY = NTRYH(J)
      ELSE
          NTRY = NTRY + 2
      END IF
  104 CONTINUE
      NQ = NL/NTRY
      NR = NL - NTRY*NQ
      IF (NR.NE.0) GO TO 101
      NF = NF + 1
      IFAC(NF+2) = NTRY
      NL = NQ
      IF (NTRY.EQ.2) THEN
          IF (NF.NE.1) THEN
              DO I = 2,NF
                  IB = NF - I + 2
                  IFAC(IB+2) = IFAC(IB+1)
              END DO
              IFAC(3) = 2
          END IF
      END IF
      IF (NL.NE.1) GO TO 104
      IFAC(1) = N
      IFAC(2) = NF
      TPI = 2.0D0*DPIMACH(DUM)
      ARGH = TPI/DBLE(N)
      IS = 0
      NFM1 = NF - 1
      L1 = 1
      IF (NFM1.EQ.0) RETURN
      DO K1 = 1,NFM1
          IP = IFAC(K1+2)
          LD = 0
          L2 = L1*IP
          IDO = N/L2
          IPM = IP - 1
          DO J = 1,IPM
              LD = LD + L1
              I = IS
              ARGLD = DBLE(LD)*ARGH
              FI = 0.D0
              DO II = 3,IDO,2
                  I = I + 2
                  FI = FI + 1.D0
                  ARG = FI*ARGLD
                  WA(I-1) = COS(ARG)
                  WA(I) = SIN(ARG)
              END DO
              IS = IS + IDO
          END DO
          L1 = L2
      END DO
      RETURN
      END
c
      SUBROUTINE DRADF2(IDO,L1,CC,CH,WA1)
      DOUBLE PRECISION CC
      DOUBLE PRECISION CH
      DOUBLE PRECISION WA1
      DOUBLE PRECISION TR2
      DOUBLE PRECISION TI2
      DIMENSION CH(IDO,2,L1),CC(IDO,L1,2),WA1(*)

      DO K = 1,L1
          CH(1,1,K) = CC(1,K,1) + CC(1,K,2)
          CH(IDO,2,K) = CC(1,K,1) - CC(1,K,2)
      END DO
      IF (IDO-2.GE.0) THEN
          IF (IDO-2.NE.0) THEN
              IDP2 = IDO + 2
              DO K = 1,L1
                  DO I = 3,IDO,2
                      IC = IDP2 - I
                      TR2 = WA1(I-2)*CC(I-1,K,2) + WA1(I-1)*CC(I,K,2)
                      TI2 = WA1(I-2)*CC(I,K,2) - WA1(I-1)*CC(I-1,K,2)
                      CH(I,1,K) = CC(I,K,1) + TI2
                      CH(IC,2,K) = TI2 - CC(I,K,1)
                      CH(I-1,1,K) = CC(I-1,K,1) + TR2
                      CH(IC-1,2,K) = CC(I-1,K,1) - TR2
                  END DO
              END DO
              IF (MOD(IDO,2).EQ.1) RETURN
          END IF
          DO K = 1,L1
              CH(1,2,K) = -CC(IDO,K,2)
              CH(IDO,1,K) = CC(IDO,K,1)
          END DO
      END IF
      RETURN
      END
c
      SUBROUTINE DRADF3(IDO,L1,CC,CH,WA1,WA2)
      DOUBLE PRECISION CC
      DOUBLE PRECISION CH
      DOUBLE PRECISION WA1
      DOUBLE PRECISION WA2
      DOUBLE PRECISION TAUR
      DOUBLE PRECISION TAUI
      DOUBLE PRECISION CR2
      DOUBLE PRECISION DR2
      DOUBLE PRECISION DI2
      DOUBLE PRECISION DR3
      DOUBLE PRECISION DI3
      DOUBLE PRECISION CI2
      DOUBLE PRECISION TR2
      DOUBLE PRECISION TI2
      DOUBLE PRECISION TR3
      DOUBLE PRECISION TI3
      DIMENSION CH(IDO,3,L1),CC(IDO,L1,3),WA1(*),WA2(*)
      DATA TAUR,TAUI/-.5D0,.866025403784439D0/

      DO K = 1,L1
          CR2 = CC(1,K,2) + CC(1,K,3)
          CH(1,1,K) = CC(1,K,1) + CR2
          CH(1,3,K) = TAUI* (CC(1,K,3)-CC(1,K,2))
          CH(IDO,2,K) = CC(1,K,1) + TAUR*CR2
      END DO
      IF (IDO.EQ.1) RETURN
      IDP2 = IDO + 2
      DO K = 1,L1
          DO I = 3,IDO,2
              IC = IDP2 - I
              DR2 = WA1(I-2)*CC(I-1,K,2) + WA1(I-1)*CC(I,K,2)
              DI2 = WA1(I-2)*CC(I,K,2) - WA1(I-1)*CC(I-1,K,2)
              DR3 = WA2(I-2)*CC(I-1,K,3) + WA2(I-1)*CC(I,K,3)
              DI3 = WA2(I-2)*CC(I,K,3) - WA2(I-1)*CC(I-1,K,3)
              CR2 = DR2 + DR3
              CI2 = DI2 + DI3
              CH(I-1,1,K) = CC(I-1,K,1) + CR2
              CH(I,1,K) = CC(I,K,1) + CI2
              TR2 = CC(I-1,K,1) + TAUR*CR2
              TI2 = CC(I,K,1) + TAUR*CI2
              TR3 = TAUI* (DI2-DI3)
              TI3 = TAUI* (DR3-DR2)
              CH(I-1,3,K) = TR2 + TR3
              CH(IC-1,2,K) = TR2 - TR3
              CH(I,3,K) = TI2 + TI3
              CH(IC,2,K) = TI3 - TI2
          END DO
      END DO
      RETURN
      END
c
      SUBROUTINE DRADF4(IDO,L1,CC,CH,WA1,WA2,WA3)
      DOUBLE PRECISION CC
      DOUBLE PRECISION CH
      DOUBLE PRECISION WA1
      DOUBLE PRECISION WA2
      DOUBLE PRECISION WA3
      DOUBLE PRECISION HSQT2
      DOUBLE PRECISION TR1
      DOUBLE PRECISION TR2
      DOUBLE PRECISION CR2
      DOUBLE PRECISION CI2
      DOUBLE PRECISION CR3
      DOUBLE PRECISION CI3
      DOUBLE PRECISION CR4
      DOUBLE PRECISION CI4
      DOUBLE PRECISION TR4
      DOUBLE PRECISION TI1
      DOUBLE PRECISION TI4
      DOUBLE PRECISION TI2
      DOUBLE PRECISION TI3
      DOUBLE PRECISION TR3
      DIMENSION CC(IDO,L1,4),CH(IDO,4,L1),WA1(*),WA2(*),WA3(*)
      DATA HSQT2/.7071067811865475D0/

      DO K = 1,L1
          TR1 = CC(1,K,2) + CC(1,K,4)
          TR2 = CC(1,K,1) + CC(1,K,3)
          CH(1,1,K) = TR1 + TR2
          CH(IDO,4,K) = TR2 - TR1
          CH(IDO,2,K) = CC(1,K,1) - CC(1,K,3)
          CH(1,3,K) = CC(1,K,4) - CC(1,K,2)
      END DO
      IF (IDO-2.GE.0) THEN
          IF (IDO-2.NE.0) THEN
              IDP2 = IDO + 2
              DO K = 1,L1
                  DO I = 3,IDO,2
                      IC = IDP2 - I
                      CR2 = WA1(I-2)*CC(I-1,K,2) + WA1(I-1)*CC(I,K,2)
                      CI2 = WA1(I-2)*CC(I,K,2) - WA1(I-1)*CC(I-1,K,2)
                      CR3 = WA2(I-2)*CC(I-1,K,3) + WA2(I-1)*CC(I,K,3)
                      CI3 = WA2(I-2)*CC(I,K,3) - WA2(I-1)*CC(I-1,K,3)
                      CR4 = WA3(I-2)*CC(I-1,K,4) + WA3(I-1)*CC(I,K,4)
                      CI4 = WA3(I-2)*CC(I,K,4) - WA3(I-1)*CC(I-1,K,4)
                      TR1 = CR2 + CR4
                      TR4 = CR4 - CR2
                      TI1 = CI2 + CI4
                      TI4 = CI2 - CI4
                      TI2 = CC(I,K,1) + CI3
                      TI3 = CC(I,K,1) - CI3
                      TR2 = CC(I-1,K,1) + CR3
                      TR3 = CC(I-1,K,1) - CR3
                      CH(I-1,1,K) = TR1 + TR2
                      CH(IC-1,4,K) = TR2 - TR1
                      CH(I,1,K) = TI1 + TI2
                      CH(IC,4,K) = TI1 - TI2
                      CH(I-1,3,K) = TI4 + TR3
                      CH(IC-1,2,K) = TR3 - TI4
                      CH(I,3,K) = TR4 + TI3
                      CH(IC,2,K) = TR4 - TI3
                  END DO
              END DO
              IF (MOD(IDO,2).EQ.1) RETURN
          END IF
          DO K = 1,L1
              TI1 = -HSQT2* (CC(IDO,K,2)+CC(IDO,K,4))
              TR1 = HSQT2* (CC(IDO,K,2)-CC(IDO,K,4))
              CH(IDO,1,K) = TR1 + CC(IDO,K,1)
              CH(IDO,3,K) = CC(IDO,K,1) - TR1
              CH(1,2,K) = TI1 - CC(IDO,K,3)
              CH(1,4,K) = TI1 + CC(IDO,K,3)
          END DO
      END IF
      RETURN
      END
c
      SUBROUTINE DRADF5(IDO,L1,CC,CH,WA1,WA2,WA3,WA4)
      DOUBLE PRECISION CC
      DOUBLE PRECISION CH
      DOUBLE PRECISION WA1
      DOUBLE PRECISION WA2
      DOUBLE PRECISION WA3
      DOUBLE PRECISION WA4
      DOUBLE PRECISION TR11
      DOUBLE PRECISION TI11
      DOUBLE PRECISION TR12
      DOUBLE PRECISION TI12
      DOUBLE PRECISION CR2
      DOUBLE PRECISION CI5
      DOUBLE PRECISION CR3
      DOUBLE PRECISION CI4
      DOUBLE PRECISION DR2
      DOUBLE PRECISION DI2
      DOUBLE PRECISION DR3
      DOUBLE PRECISION DI3
      DOUBLE PRECISION DR4
      DOUBLE PRECISION DI4
      DOUBLE PRECISION DR5
      DOUBLE PRECISION DI5
      DOUBLE PRECISION CR5
      DOUBLE PRECISION CI2
      DOUBLE PRECISION CR4
      DOUBLE PRECISION CI3
      DOUBLE PRECISION TR2
      DOUBLE PRECISION TI2
      DOUBLE PRECISION TR3
      DOUBLE PRECISION TI3
      DOUBLE PRECISION TR5
      DOUBLE PRECISION TI5
      DOUBLE PRECISION TR4
      DOUBLE PRECISION TI4
      DIMENSION CC(IDO,L1,5),CH(IDO,5,L1),WA1(*),WA2(*),WA3(*),WA4(*)
      DATA TR11,TI11,TR12,TI12/.309016994374947D0,.951056516295154D0,
     +     -.809016994374947D0,.587785252292473D0/

      DO K = 1,L1
          CR2 = CC(1,K,5) + CC(1,K,2)
          CI5 = CC(1,K,5) - CC(1,K,2)
          CR3 = CC(1,K,4) + CC(1,K,3)
          CI4 = CC(1,K,4) - CC(1,K,3)
          CH(1,1,K) = CC(1,K,1) + CR2 + CR3
          CH(IDO,2,K) = CC(1,K,1) + TR11*CR2 + TR12*CR3
          CH(1,3,K) = TI11*CI5 + TI12*CI4
          CH(IDO,4,K) = CC(1,K,1) + TR12*CR2 + TR11*CR3
          CH(1,5,K) = TI12*CI5 - TI11*CI4
      END DO
      IF (IDO.EQ.1) RETURN
      IDP2 = IDO + 2
      DO K = 1,L1
          DO I = 3,IDO,2
              IC = IDP2 - I
              DR2 = WA1(I-2)*CC(I-1,K,2) + WA1(I-1)*CC(I,K,2)
              DI2 = WA1(I-2)*CC(I,K,2) - WA1(I-1)*CC(I-1,K,2)
              DR3 = WA2(I-2)*CC(I-1,K,3) + WA2(I-1)*CC(I,K,3)
              DI3 = WA2(I-2)*CC(I,K,3) - WA2(I-1)*CC(I-1,K,3)
              DR4 = WA3(I-2)*CC(I-1,K,4) + WA3(I-1)*CC(I,K,4)
              DI4 = WA3(I-2)*CC(I,K,4) - WA3(I-1)*CC(I-1,K,4)
              DR5 = WA4(I-2)*CC(I-1,K,5) + WA4(I-1)*CC(I,K,5)
              DI5 = WA4(I-2)*CC(I,K,5) - WA4(I-1)*CC(I-1,K,5)
              CR2 = DR2 + DR5
              CI5 = DR5 - DR2
              CR5 = DI2 - DI5
              CI2 = DI2 + DI5
              CR3 = DR3 + DR4
              CI4 = DR4 - DR3
              CR4 = DI3 - DI4
              CI3 = DI3 + DI4
              CH(I-1,1,K) = CC(I-1,K,1) + CR2 + CR3
              CH(I,1,K) = CC(I,K,1) + CI2 + CI3
              TR2 = CC(I-1,K,1) + TR11*CR2 + TR12*CR3
              TI2 = CC(I,K,1) + TR11*CI2 + TR12*CI3
              TR3 = CC(I-1,K,1) + TR12*CR2 + TR11*CR3
              TI3 = CC(I,K,1) + TR12*CI2 + TR11*CI3
              TR5 = TI11*CR5 + TI12*CR4
              TI5 = TI11*CI5 + TI12*CI4
              TR4 = TI12*CR5 - TI11*CR4
              TI4 = TI12*CI5 - TI11*CI4
              CH(I-1,3,K) = TR2 + TR5
              CH(IC-1,2,K) = TR2 - TR5
              CH(I,3,K) = TI2 + TI5
              CH(IC,2,K) = TI5 - TI2
              CH(I-1,5,K) = TR3 + TR4
              CH(IC-1,4,K) = TR3 - TR4
              CH(I,5,K) = TI3 + TI4
              CH(IC,4,K) = TI4 - TI3
          END DO
      END DO
      RETURN
      END
c
      SUBROUTINE DRADFG(IDO,IP,L1,IDL1,CC,C1,C2,CH,CH2,WA)
      DOUBLE PRECISION CC
      DOUBLE PRECISION C1
      DOUBLE PRECISION C2
      DOUBLE PRECISION CH
      DOUBLE PRECISION CH2
      DOUBLE PRECISION WA
      DOUBLE PRECISION TPI
      DOUBLE PRECISION DPIMACH
      DOUBLE PRECISION DUM
      DOUBLE PRECISION ARG
      DOUBLE PRECISION DCP
      DOUBLE PRECISION DSP
      DOUBLE PRECISION AR1
      DOUBLE PRECISION AI1
      DOUBLE PRECISION AR1H
      DOUBLE PRECISION DC2
      DOUBLE PRECISION DS2
      DOUBLE PRECISION AR2
      DOUBLE PRECISION AI2
      DOUBLE PRECISION AR2H
      DIMENSION CH(IDO,L1,IP),CC(IDO,IP,L1),C1(IDO,L1,IP),C2(IDL1,IP),
     +          CH2(IDL1,IP),WA(*)

      TPI = 2.0D0*DPIMACH(DUM)
      ARG = TPI/DBLE(IP)
      DCP = COS(ARG)
      DSP = SIN(ARG)
      IPPH = (IP+1)/2
      IPP2 = IP + 2
      IDP2 = IDO + 2
      NBD = (IDO-1)/2
      IF (IDO.NE.1) THEN
          DO IK = 1,IDL1
              CH2(IK,1) = C2(IK,1)
          END DO
          DO J = 2,IP
              DO K = 1,L1
                  CH(1,K,J) = C1(1,K,J)
              END DO
          END DO
          IF (NBD.LE.L1) THEN
              IS = -IDO
              DO J = 2,IP
                  IS = IS + IDO
                  IDIJ = IS
                  DO I = 3,IDO,2
                      IDIJ = IDIJ + 2
                      DO K = 1,L1
                          CH(I-1,K,J) = WA(IDIJ-1)*C1(I-1,K,J) +
     +                                  WA(IDIJ)*C1(I,K,J)
                          CH(I,K,J) = WA(IDIJ-1)*C1(I,K,J) -
     +                                WA(IDIJ)*C1(I-1,K,J)
                      END DO
                  END DO
              END DO
          ELSE
              IS = -IDO
              DO J = 2,IP
                  IS = IS + IDO
                  DO K = 1,L1
                      IDIJ = IS
                      DO I = 3,IDO,2
                          IDIJ = IDIJ + 2
                          CH(I-1,K,J) = WA(IDIJ-1)*C1(I-1,K,J) +
     +                                  WA(IDIJ)*C1(I,K,J)
                          CH(I,K,J) = WA(IDIJ-1)*C1(I,K,J) -
     +                                WA(IDIJ)*C1(I-1,K,J)
                      END DO
                  END DO
              END DO
          END IF
          IF (NBD.GE.L1) THEN
              DO J = 2,IPPH
                  JC = IPP2 - J
                  DO K = 1,L1
                      DO I = 3,IDO,2
                          C1(I-1,K,J) = CH(I-1,K,J) + CH(I-1,K,JC)
                          C1(I-1,K,JC) = CH(I,K,J) - CH(I,K,JC)
                          C1(I,K,J) = CH(I,K,J) + CH(I,K,JC)
                          C1(I,K,JC) = CH(I-1,K,JC) - CH(I-1,K,J)
                      END DO
                  END DO
              END DO
              GO TO 121
          END IF
          DO J = 2,IPPH
              JC = IPP2 - J
              DO I = 3,IDO,2
                  DO K = 1,L1
                      C1(I-1,K,J) = CH(I-1,K,J) + CH(I-1,K,JC)
                      C1(I-1,K,JC) = CH(I,K,J) - CH(I,K,JC)
                      C1(I,K,J) = CH(I,K,J) + CH(I,K,JC)
                      C1(I,K,JC) = CH(I-1,K,JC) - CH(I-1,K,J)
                  END DO
              END DO
          END DO
          GO TO 121
      END IF
      DO IK = 1,IDL1
          C2(IK,1) = CH2(IK,1)
      END DO
  121 CONTINUE
      DO J = 2,IPPH
          JC = IPP2 - J
          DO K = 1,L1
              C1(1,K,J) = CH(1,K,J) + CH(1,K,JC)
              C1(1,K,JC) = CH(1,K,JC) - CH(1,K,J)
          END DO
      END DO
c
      AR1 = 1.D0
      AI1 = 0.D0
      DO L = 2,IPPH
          LC = IPP2 - L
          AR1H = DCP*AR1 - DSP*AI1
          AI1 = DCP*AI1 + DSP*AR1
          AR1 = AR1H
          DO IK = 1,IDL1
              CH2(IK,L) = C2(IK,1) + AR1*C2(IK,2)
              CH2(IK,LC) = AI1*C2(IK,IP)
          END DO
          DC2 = AR1
          DS2 = AI1
          AR2 = AR1
          AI2 = AI1
          DO J = 3,IPPH
              JC = IPP2 - J
              AR2H = DC2*AR2 - DS2*AI2
              AI2 = DC2*AI2 + DS2*AR2
              AR2 = AR2H
              DO IK = 1,IDL1
                  CH2(IK,L) = CH2(IK,L) + AR2*C2(IK,J)
                  CH2(IK,LC) = CH2(IK,LC) + AI2*C2(IK,JC)
              END DO
          END DO
      END DO
      DO J = 2,IPPH
          DO IK = 1,IDL1
              CH2(IK,1) = CH2(IK,1) + C2(IK,J)
          END DO
      END DO
c
      IF (IDO.GE.L1) THEN
          DO K = 1,L1
              DO I = 1,IDO
                  CC(I,1,K) = CH(I,K,1)
              END DO
          END DO
      ELSE
          DO I = 1,IDO
              DO K = 1,L1
                  CC(I,1,K) = CH(I,K,1)
              END DO
          END DO
      END IF
      DO J = 2,IPPH
          JC = IPP2 - J
          J2 = J + J
          DO K = 1,L1
              CC(IDO,J2-2,K) = CH(1,K,J)
              CC(1,J2-1,K) = CH(1,K,JC)
          END DO
      END DO
      IF (IDO.EQ.1) RETURN
      IF (NBD.GE.L1) THEN
          DO J = 2,IPPH
              JC = IPP2 - J
              J2 = J + J
              DO K = 1,L1
                  DO I = 3,IDO,2
                      IC = IDP2 - I
                      CC(I-1,J2-1,K) = CH(I-1,K,J) + CH(I-1,K,JC)
                      CC(IC-1,J2-2,K) = CH(I-1,K,J) - CH(I-1,K,JC)
                      CC(I,J2-1,K) = CH(I,K,J) + CH(I,K,JC)
                      CC(IC,J2-2,K) = CH(I,K,JC) - CH(I,K,J)
                  END DO
              END DO
          END DO
          RETURN
      END IF
      DO J = 2,IPPH
          JC = IPP2 - J
          J2 = J + J
          DO I = 3,IDO,2
              IC = IDP2 - I
              DO K = 1,L1
                  CC(I-1,J2-1,K) = CH(I-1,K,J) + CH(I-1,K,JC)
                  CC(IC-1,J2-2,K) = CH(I-1,K,J) - CH(I-1,K,JC)
                  CC(I,J2-1,K) = CH(I,K,J) + CH(I,K,JC)
                  CC(IC,J2-2,K) = CH(I,K,JC) - CH(I,K,J)
              END DO
          END DO
      END DO
      RETURN
      END
c
      SUBROUTINE DRADB2(IDO,L1,CC,CH,WA1)
      DOUBLE PRECISION CC
      DOUBLE PRECISION CH
      DOUBLE PRECISION WA1
      DOUBLE PRECISION TR2
      DOUBLE PRECISION TI2
      DIMENSION CC(IDO,2,L1),CH(IDO,L1,2),WA1(*)

      DO K = 1,L1
          CH(1,K,1) = CC(1,1,K) + CC(IDO,2,K)
          CH(1,K,2) = CC(1,1,K) - CC(IDO,2,K)
      END DO
      IF (IDO-2.GE.0) THEN
          IF (IDO-2.NE.0) THEN
              IDP2 = IDO + 2
              DO K = 1,L1
                  DO I = 3,IDO,2
                      IC = IDP2 - I
                      CH(I-1,K,1) = CC(I-1,1,K) + CC(IC-1,2,K)
                      TR2 = CC(I-1,1,K) - CC(IC-1,2,K)
                      CH(I,K,1) = CC(I,1,K) - CC(IC,2,K)
                      TI2 = CC(I,1,K) + CC(IC,2,K)
                      CH(I-1,K,2) = WA1(I-2)*TR2 - WA1(I-1)*TI2
                      CH(I,K,2) = WA1(I-2)*TI2 + WA1(I-1)*TR2
                  END DO
              END DO
              IF (MOD(IDO,2).EQ.1) RETURN
          END IF
          DO K = 1,L1
              CH(IDO,K,1) = CC(IDO,1,K) + CC(IDO,1,K)
              CH(IDO,K,2) = - (CC(1,2,K)+CC(1,2,K))
          END DO
      END IF
      RETURN
      END
c
      SUBROUTINE DRADB3(IDO,L1,CC,CH,WA1,WA2)
      DOUBLE PRECISION CC
      DOUBLE PRECISION CH
      DOUBLE PRECISION WA1
      DOUBLE PRECISION WA2
      DOUBLE PRECISION TAUR
      DOUBLE PRECISION TAUI
      DOUBLE PRECISION TR2
      DOUBLE PRECISION CR2
      DOUBLE PRECISION CI3
      DOUBLE PRECISION TI2
      DOUBLE PRECISION CI2
      DOUBLE PRECISION CR3
      DOUBLE PRECISION DR2
      DOUBLE PRECISION DR3
      DOUBLE PRECISION DI2
      DOUBLE PRECISION DI3
      DIMENSION CC(IDO,3,L1),CH(IDO,L1,3),WA1(*),WA2(*)
      DATA TAUR,TAUI/-.5D0,.866025403784439D0/

      DO K = 1,L1
          TR2 = CC(IDO,2,K) + CC(IDO,2,K)
          CR2 = CC(1,1,K) + TAUR*TR2
          CH(1,K,1) = CC(1,1,K) + TR2
          CI3 = TAUI* (CC(1,3,K)+CC(1,3,K))
          CH(1,K,2) = CR2 - CI3
          CH(1,K,3) = CR2 + CI3
      END DO
      IF (IDO.EQ.1) RETURN
      IDP2 = IDO + 2
      DO K = 1,L1
          DO I = 3,IDO,2
              IC = IDP2 - I
              TR2 = CC(I-1,3,K) + CC(IC-1,2,K)
              CR2 = CC(I-1,1,K) + TAUR*TR2
              CH(I-1,K,1) = CC(I-1,1,K) + TR2
              TI2 = CC(I,3,K) - CC(IC,2,K)
              CI2 = CC(I,1,K) + TAUR*TI2
              CH(I,K,1) = CC(I,1,K) + TI2
              CR3 = TAUI* (CC(I-1,3,K)-CC(IC-1,2,K))
              CI3 = TAUI* (CC(I,3,K)+CC(IC,2,K))
              DR2 = CR2 - CI3
              DR3 = CR2 + CI3
              DI2 = CI2 + CR3
              DI3 = CI2 - CR3
              CH(I-1,K,2) = WA1(I-2)*DR2 - WA1(I-1)*DI2
              CH(I,K,2) = WA1(I-2)*DI2 + WA1(I-1)*DR2
              CH(I-1,K,3) = WA2(I-2)*DR3 - WA2(I-1)*DI3
              CH(I,K,3) = WA2(I-2)*DI3 + WA2(I-1)*DR3
          END DO
      END DO
      RETURN
      END
c
      SUBROUTINE DRADB4(IDO,L1,CC,CH,WA1,WA2,WA3)
      DOUBLE PRECISION CC
      DOUBLE PRECISION CH
      DOUBLE PRECISION WA1
      DOUBLE PRECISION WA2
      DOUBLE PRECISION WA3
      DOUBLE PRECISION SQRT2
      DOUBLE PRECISION TR1
      DOUBLE PRECISION TR2
      DOUBLE PRECISION TR3
      DOUBLE PRECISION TR4
      DOUBLE PRECISION TI1
      DOUBLE PRECISION TI2
      DOUBLE PRECISION TI3
      DOUBLE PRECISION TI4
      DOUBLE PRECISION CR3
      DOUBLE PRECISION CI3
      DOUBLE PRECISION CR2
      DOUBLE PRECISION CR4
      DOUBLE PRECISION CI2
      DOUBLE PRECISION CI4
      DIMENSION CC(IDO,4,L1),CH(IDO,L1,4),WA1(*),WA2(*),WA3(*)
      DATA SQRT2/1.414213562373095D0/

      DO K = 1,L1
          TR1 = CC(1,1,K) - CC(IDO,4,K)
          TR2 = CC(1,1,K) + CC(IDO,4,K)
          TR3 = CC(IDO,2,K) + CC(IDO,2,K)
          TR4 = CC(1,3,K) + CC(1,3,K)
          CH(1,K,1) = TR2 + TR3
          CH(1,K,2) = TR1 - TR4
          CH(1,K,3) = TR2 - TR3
          CH(1,K,4) = TR1 + TR4
      END DO
      IF (IDO-2.GE.0) THEN
          IF (IDO-2.NE.0) THEN
              IDP2 = IDO + 2
              DO K = 1,L1
                  DO I = 3,IDO,2
                      IC = IDP2 - I
                      TI1 = CC(I,1,K) + CC(IC,4,K)
                      TI2 = CC(I,1,K) - CC(IC,4,K)
                      TI3 = CC(I,3,K) - CC(IC,2,K)
                      TR4 = CC(I,3,K) + CC(IC,2,K)
                      TR1 = CC(I-1,1,K) - CC(IC-1,4,K)
                      TR2 = CC(I-1,1,K) + CC(IC-1,4,K)
                      TI4 = CC(I-1,3,K) - CC(IC-1,2,K)
                      TR3 = CC(I-1,3,K) + CC(IC-1,2,K)
                      CH(I-1,K,1) = TR2 + TR3
                      CR3 = TR2 - TR3
                      CH(I,K,1) = TI2 + TI3
                      CI3 = TI2 - TI3
                      CR2 = TR1 - TR4
                      CR4 = TR1 + TR4
                      CI2 = TI1 + TI4
                      CI4 = TI1 - TI4
                      CH(I-1,K,2) = WA1(I-2)*CR2 - WA1(I-1)*CI2
                      CH(I,K,2) = WA1(I-2)*CI2 + WA1(I-1)*CR2
                      CH(I-1,K,3) = WA2(I-2)*CR3 - WA2(I-1)*CI3
                      CH(I,K,3) = WA2(I-2)*CI3 + WA2(I-1)*CR3
                      CH(I-1,K,4) = WA3(I-2)*CR4 - WA3(I-1)*CI4
                      CH(I,K,4) = WA3(I-2)*CI4 + WA3(I-1)*CR4
                  END DO
              END DO
              IF (MOD(IDO,2).EQ.1) RETURN
          END IF
          DO K = 1,L1
              TI1 = CC(1,2,K) + CC(1,4,K)
              TI2 = CC(1,4,K) - CC(1,2,K)
              TR1 = CC(IDO,1,K) - CC(IDO,3,K)
              TR2 = CC(IDO,1,K) + CC(IDO,3,K)
              CH(IDO,K,1) = TR2 + TR2
              CH(IDO,K,2) = SQRT2* (TR1-TI1)
              CH(IDO,K,3) = TI2 + TI2
              CH(IDO,K,4) = -SQRT2* (TR1+TI1)
          END DO
      END IF
      RETURN
      END
c
      SUBROUTINE DRADB5(IDO,L1,CC,CH,WA1,WA2,WA3,WA4)
      DOUBLE PRECISION CC
      DOUBLE PRECISION CH
      DOUBLE PRECISION WA1
      DOUBLE PRECISION WA2
      DOUBLE PRECISION WA3
      DOUBLE PRECISION WA4
      DOUBLE PRECISION TR11
      DOUBLE PRECISION TI11
      DOUBLE PRECISION TR12
      DOUBLE PRECISION TI12
      DOUBLE PRECISION TI5
      DOUBLE PRECISION TI4
      DOUBLE PRECISION TR2
      DOUBLE PRECISION TR3
      DOUBLE PRECISION CR2
      DOUBLE PRECISION CR3
      DOUBLE PRECISION CI5
      DOUBLE PRECISION CI4
      DOUBLE PRECISION TI2
      DOUBLE PRECISION TI3
      DOUBLE PRECISION TR5
      DOUBLE PRECISION TR4
      DOUBLE PRECISION CI2
      DOUBLE PRECISION CI3
      DOUBLE PRECISION CR5
      DOUBLE PRECISION CR4
      DOUBLE PRECISION DR3
      DOUBLE PRECISION DR4
      DOUBLE PRECISION DI3
      DOUBLE PRECISION DI4
      DOUBLE PRECISION DR5
      DOUBLE PRECISION DR2
      DOUBLE PRECISION DI5
      DOUBLE PRECISION DI2
      DIMENSION CC(IDO,5,L1),CH(IDO,L1,5),WA1(*),WA2(*),WA3(*),WA4(*)
      DATA TR11,TI11,TR12,TI12/.309016994374947D0,.951056516295154D0,
     +     -.809016994374947D0,.587785252292473D0/

      DO K = 1,L1
          TI5 = CC(1,3,K) + CC(1,3,K)
          TI4 = CC(1,5,K) + CC(1,5,K)
          TR2 = CC(IDO,2,K) + CC(IDO,2,K)
          TR3 = CC(IDO,4,K) + CC(IDO,4,K)
          CH(1,K,1) = CC(1,1,K) + TR2 + TR3
          CR2 = CC(1,1,K) + TR11*TR2 + TR12*TR3
          CR3 = CC(1,1,K) + TR12*TR2 + TR11*TR3
          CI5 = TI11*TI5 + TI12*TI4
          CI4 = TI12*TI5 - TI11*TI4
          CH(1,K,2) = CR2 - CI5
          CH(1,K,3) = CR3 - CI4
          CH(1,K,4) = CR3 + CI4
          CH(1,K,5) = CR2 + CI5
      END DO
      IF (IDO.EQ.1) RETURN
      IDP2 = IDO + 2
      DO K = 1,L1
          DO I = 3,IDO,2
              IC = IDP2 - I
              TI5 = CC(I,3,K) + CC(IC,2,K)
              TI2 = CC(I,3,K) - CC(IC,2,K)
              TI4 = CC(I,5,K) + CC(IC,4,K)
              TI3 = CC(I,5,K) - CC(IC,4,K)
              TR5 = CC(I-1,3,K) - CC(IC-1,2,K)
              TR2 = CC(I-1,3,K) + CC(IC-1,2,K)
              TR4 = CC(I-1,5,K) - CC(IC-1,4,K)
              TR3 = CC(I-1,5,K) + CC(IC-1,4,K)
              CH(I-1,K,1) = CC(I-1,1,K) + TR2 + TR3
              CH(I,K,1) = CC(I,1,K) + TI2 + TI3
              CR2 = CC(I-1,1,K) + TR11*TR2 + TR12*TR3
              CI2 = CC(I,1,K) + TR11*TI2 + TR12*TI3
              CR3 = CC(I-1,1,K) + TR12*TR2 + TR11*TR3
              CI3 = CC(I,1,K) + TR12*TI2 + TR11*TI3
              CR5 = TI11*TR5 + TI12*TR4
              CI5 = TI11*TI5 + TI12*TI4
              CR4 = TI12*TR5 - TI11*TR4
              CI4 = TI12*TI5 - TI11*TI4
              DR3 = CR3 - CI4
              DR4 = CR3 + CI4
              DI3 = CI3 + CR4
              DI4 = CI3 - CR4
              DR5 = CR2 + CI5
              DR2 = CR2 - CI5
              DI5 = CI2 - CR5
              DI2 = CI2 + CR5
              CH(I-1,K,2) = WA1(I-2)*DR2 - WA1(I-1)*DI2
              CH(I,K,2) = WA1(I-2)*DI2 + WA1(I-1)*DR2
              CH(I-1,K,3) = WA2(I-2)*DR3 - WA2(I-1)*DI3
              CH(I,K,3) = WA2(I-2)*DI3 + WA2(I-1)*DR3
              CH(I-1,K,4) = WA3(I-2)*DR4 - WA3(I-1)*DI4
              CH(I,K,4) = WA3(I-2)*DI4 + WA3(I-1)*DR4
              CH(I-1,K,5) = WA4(I-2)*DR5 - WA4(I-1)*DI5
              CH(I,K,5) = WA4(I-2)*DI5 + WA4(I-1)*DR5
          END DO
      END DO
      RETURN
      END
c
      SUBROUTINE DRADBG(IDO,IP,L1,IDL1,CC,C1,C2,CH,CH2,WA)
      DOUBLE PRECISION CC
      DOUBLE PRECISION C1
      DOUBLE PRECISION C2
      DOUBLE PRECISION CH
      DOUBLE PRECISION CH2
      DOUBLE PRECISION WA
      DOUBLE PRECISION TPI
      DOUBLE PRECISION DPIMACH
      DOUBLE PRECISION DUM
      DOUBLE PRECISION ARG
      DOUBLE PRECISION DCP
      DOUBLE PRECISION DSP
      DOUBLE PRECISION AR1
      DOUBLE PRECISION AI1
      DOUBLE PRECISION AR1H
      DOUBLE PRECISION DC2
      DOUBLE PRECISION DS2
      DOUBLE PRECISION AR2
      DOUBLE PRECISION AI2
      DOUBLE PRECISION AR2H
      DIMENSION CH(IDO,L1,IP),CC(IDO,IP,L1),C1(IDO,L1,IP),C2(IDL1,IP),
     +          CH2(IDL1,IP),WA(*)

      TPI = 2.0D0*DPIMACH(DUM)
      ARG = TPI/DBLE(IP)
      DCP = COS(ARG)
      DSP = SIN(ARG)
      IDP2 = IDO + 2
      NBD = (IDO-1)/2
      IPP2 = IP + 2
      IPPH = (IP+1)/2
      IF (IDO.GE.L1) THEN
          DO K = 1,L1
              DO I = 1,IDO
                  CH(I,K,1) = CC(I,1,K)
              END DO
          END DO
      ELSE
          DO I = 1,IDO
              DO K = 1,L1
                  CH(I,K,1) = CC(I,1,K)
              END DO
          END DO
      END IF
      DO J = 2,IPPH
          JC = IPP2 - J
          J2 = J + J
          DO K = 1,L1
              CH(1,K,J) = CC(IDO,J2-2,K) + CC(IDO,J2-2,K)
              CH(1,K,JC) = CC(1,J2-1,K) + CC(1,J2-1,K)
          END DO
      END DO
      IF (IDO.NE.1) THEN
          IF (NBD.GE.L1) THEN
              DO J = 2,IPPH
                  JC = IPP2 - J
                  DO K = 1,L1
                      DO I = 3,IDO,2
                          IC = IDP2 - I
                          CH(I-1,K,J) = CC(I-1,2*J-1,K) +
     +                                  CC(IC-1,2*J-2,K)
                          CH(I-1,K,JC) = CC(I-1,2*J-1,K) -
     +                                   CC(IC-1,2*J-2,K)
                          CH(I,K,J) = CC(I,2*J-1,K) - CC(IC,2*J-2,K)
                          CH(I,K,JC) = CC(I,2*J-1,K) + CC(IC,2*J-2,K)
                      END DO
                  END DO
              END DO
          ELSE
              DO J = 2,IPPH
                  JC = IPP2 - J
                  DO I = 3,IDO,2
                      IC = IDP2 - I
                      DO K = 1,L1
                          CH(I-1,K,J) = CC(I-1,2*J-1,K) +
     +                                  CC(IC-1,2*J-2,K)
                          CH(I-1,K,JC) = CC(I-1,2*J-1,K) -
     +                                   CC(IC-1,2*J-2,K)
                          CH(I,K,J) = CC(I,2*J-1,K) - CC(IC,2*J-2,K)
                          CH(I,K,JC) = CC(I,2*J-1,K) + CC(IC,2*J-2,K)
                      END DO
                  END DO
              END DO
          END IF
      END IF
      AR1 = 1.D0
      AI1 = 0.D0
      DO L = 2,IPPH
          LC = IPP2 - L
          AR1H = DCP*AR1 - DSP*AI1
          AI1 = DCP*AI1 + DSP*AR1
          AR1 = AR1H
          DO IK = 1,IDL1
              C2(IK,L) = CH2(IK,1) + AR1*CH2(IK,2)
              C2(IK,LC) = AI1*CH2(IK,IP)
          END DO
          DC2 = AR1
          DS2 = AI1
          AR2 = AR1
          AI2 = AI1
          DO J = 3,IPPH
              JC = IPP2 - J
              AR2H = DC2*AR2 - DS2*AI2
              AI2 = DC2*AI2 + DS2*AR2
              AR2 = AR2H
              DO IK = 1,IDL1
                  C2(IK,L) = C2(IK,L) + AR2*CH2(IK,J)
                  C2(IK,LC) = C2(IK,LC) + AI2*CH2(IK,JC)
              END DO
          END DO
      END DO
      DO J = 2,IPPH
          DO IK = 1,IDL1
              CH2(IK,1) = CH2(IK,1) + CH2(IK,J)
          END DO
      END DO
      DO J = 2,IPPH
          JC = IPP2 - J
          DO K = 1,L1
              CH(1,K,J) = C1(1,K,J) - C1(1,K,JC)
              CH(1,K,JC) = C1(1,K,J) + C1(1,K,JC)
          END DO
      END DO
      IF (IDO.NE.1) THEN
          IF (NBD.GE.L1) THEN
              DO J = 2,IPPH
                  JC = IPP2 - J
                  DO K = 1,L1
                      DO I = 3,IDO,2
                          CH(I-1,K,J) = C1(I-1,K,J) - C1(I,K,JC)
                          CH(I-1,K,JC) = C1(I-1,K,J) + C1(I,K,JC)
                          CH(I,K,J) = C1(I,K,J) + C1(I-1,K,JC)
                          CH(I,K,JC) = C1(I,K,J) - C1(I-1,K,JC)
                      END DO
                  END DO
              END DO
          ELSE
              DO J = 2,IPPH
                  JC = IPP2 - J
                  DO I = 3,IDO,2
                      DO K = 1,L1
                          CH(I-1,K,J) = C1(I-1,K,J) - C1(I,K,JC)
                          CH(I-1,K,JC) = C1(I-1,K,J) + C1(I,K,JC)
                          CH(I,K,J) = C1(I,K,J) + C1(I-1,K,JC)
                          CH(I,K,JC) = C1(I,K,J) - C1(I-1,K,JC)
                      END DO
                  END DO
              END DO
          END IF
      END IF
      IF (IDO.EQ.1) RETURN
      DO IK = 1,IDL1
          C2(IK,1) = CH2(IK,1)
      END DO
      DO J = 2,IP
          DO K = 1,L1
              C1(1,K,J) = CH(1,K,J)
          END DO
      END DO
      IF (NBD.LE.L1) THEN
          IS = -IDO
          DO J = 2,IP
              IS = IS + IDO
              IDIJ = IS
              DO I = 3,IDO,2
                  IDIJ = IDIJ + 2
                  DO K = 1,L1
                      C1(I-1,K,J) = WA(IDIJ-1)*CH(I-1,K,J) -
     +                              WA(IDIJ)*CH(I,K,J)
                      C1(I,K,J) = WA(IDIJ-1)*CH(I,K,J) +
     +                            WA(IDIJ)*CH(I-1,K,J)
                  END DO
              END DO
          END DO
      ELSE
          IS = -IDO
          DO J = 2,IP
              IS = IS + IDO
              DO K = 1,L1
                  IDIJ = IS
                  DO I = 3,IDO,2
                      IDIJ = IDIJ + 2
                      C1(I-1,K,J) = WA(IDIJ-1)*CH(I-1,K,J) -
     +                              WA(IDIJ)*CH(I,K,J)
                      C1(I,K,J) = WA(IDIJ-1)*CH(I,K,J) +
     +                            WA(IDIJ)*CH(I-1,K,J)
                  END DO
              END DO
          END DO
      END IF
      RETURN
      END

      SUBROUTINE CPTTRF( N, D, E, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      INTEGER            INFO, N
*     ..
*     .. Array Arguments ..
      REAL               D( * )
      COMPLEX            E( * )
*     ..
*
*  Purpose
*  =======
*
*  CPTTRF computes the L*D*L' factorization of a complex Hermitian
*  positive definite tridiagonal matrix A.  The factorization may also
*  be regarded as having the form A = U'*D*U.
*
*  Arguments
*  =========
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  D       (input/output) REAL array, dimension (N)
*          On entry, the n diagonal elements of the tridiagonal matrix
*          A.  On exit, the n diagonal elements of the diagonal matrix
*          D from the L*D*L' factorization of A.
*
*  E       (input/output) COMPLEX array, dimension (N-1)
*          On entry, the (n-1) subdiagonal elements of the tridiagonal
*          matrix A.  On exit, the (n-1) subdiagonal elements of the
*          unit bidiagonal factor L from the L*D*L' factorization of A.
*          E can also be regarded as the superdiagonal of the unit
*          bidiagonal factor U from the U'*D*U factorization of A.
*
*  INFO    (output) INTEGER
*          = 0: successful exit
*          < 0: if INFO = -k, the k-th argument had an illegal value
*          > 0: if INFO = k, the leading minor of order k is not
*               positive definite; if k < N, the factorization could not
*               be completed, while if k = N, the factorization was
*               completed, but D(N) = 0.
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ZERO
      PARAMETER          ( ZERO = 0.0E+0 )
*     ..
*     .. Local Scalars ..
      INTEGER            I, I4
      REAL               EII, EIR, F, G
*     ..
*     .. External Subroutines ..
      EXTERNAL           XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          AIMAG, CMPLX, REAL
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      IF( N.LT.0 ) THEN
         INFO = -1
         CALL XERBLA( 'CPTTRF', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
*
*     Compute the L*D*L' (or U'*D*U) factorization of A.
*
      I4 = MOD( N-1, 4 )
      DO 10 I = 1, I4
         IF( D( I ).LE.ZERO ) THEN
            INFO = I
            GO TO 20
         END IF
         EIR = REAL( E( I ) )
         EII = AIMAG( E( I ) )
         F = EIR / D( I )
         G = EII / D( I )
         E( I ) = CMPLX( F, G )
         D( I+1 ) = D( I+1 ) - F*EIR - G*EII
   10 CONTINUE
*
      DO 110 I = I4+1, N - 4, 4
*
*        Drop out of the loop if d(i) <= 0: the matrix is not positive
*        definite.
*
         IF( D( I ).LE.ZERO ) THEN
            INFO = I
            GO TO 20
         END IF
*
*        Solve for e(i) and d(i+1).
*
         EIR = REAL( E( I ) )
         EII = AIMAG( E( I ) )
         F = EIR / D( I )
         G = EII / D( I )
         E( I ) = CMPLX( F, G )
         D( I+1 ) = D( I+1 ) - F*EIR - G*EII
*
         IF( D( I+1 ).LE.ZERO ) THEN
            INFO = I+1
            GO TO 20
         END IF
*
*        Solve for e(i+1) and d(i+2).
*
         EIR = REAL( E( I+1 ) )
         EII = AIMAG( E( I+1 ) )
         F = EIR / D( I+1 )
         G = EII / D( I+1 )
         E( I+1 ) = CMPLX( F, G )
         D( I+2 ) = D( I+2 ) - F*EIR - G*EII
*
         IF( D( I+2 ).LE.ZERO ) THEN
            INFO = I+2
            GO TO 20
         END IF
*
*        Solve for e(i+2) and d(i+3).
*
         EIR = REAL( E( I+2 ) )
         EII = AIMAG( E( I+2 ) )
         F = EIR / D( I+2 )
         G = EII / D( I+2 )
         E( I+2 ) = CMPLX( F, G )
         D( I+3 ) = D( I+3 ) - F*EIR - G*EII
*
         IF( D( I+3 ).LE.ZERO ) THEN
            INFO = I+3
            GO TO 20
         END IF
*
*        Solve for e(i+3) and d(i+4).
*
         EIR = REAL( E( I+3 ) )
         EII = AIMAG( E( I+3 ) )
         F = EIR / D( I+3 )
         G = EII / D( I+3 )
         E( I+3 ) = CMPLX( F, G )
         D( I+4 ) = D( I+4 ) - F*EIR - G*EII
  110 CONTINUE
*
*     Check d(n) for positive definiteness.
*
      IF( D( N ).LE.ZERO )
     $   INFO = N
*
   20 CONTINUE
      RETURN
*
*     End of CPTTRF
*
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C   FFTPACK 5.0
C   Copyright (C) 1995-2004, Scientific Computing Division,
C   University Corporation for Atmospheric Research
C   Licensed under the GNU General Public License (GPL)
C
C   Authors:  Paul N. Swarztrauber and Richard A. Valent
C
C   $Id: cfftmb.f,v 1.2 2006-11-21 01:10:16 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      SUBROUTINE DCFFTMB(LOT,JUMP,N,INC,C,LENC,WSAVE,LENSAV,WORK,
     +                   LENWRK,IER)
      INTEGER LOT,JUMP,N,INC,LENC,LENSAV,LENWRK,IER
      DOUBLE COMPLEX C(LENC)
      DOUBLE PRECISION WSAVE(LENSAV),WORK(LENWRK)
      LOGICAL DXERCON
C
      IER = 0
C
      IF (LENC.LT. (LOT-1)*JUMP+INC* (N-1)+1) THEN
          IER = 1
          CALL DXERFFT('CFFTMB ',6)
      ELSE IF (LENSAV.LT.2*N+INT(LOG(DBLE(N)))+4) THEN
          IER = 2
          CALL DXERFFT('CFFTMB ',8)
      ELSE IF (LENWRK.LT.2*LOT*N) THEN
          IER = 3
          CALL DXERFFT('CFFTMB ',10)
      ELSE IF (.NOT.DXERCON(INC,JUMP,N,LOT)) THEN
          IER = 4
          CALL DXERFFT('CFFTMB ',-1)
      END IF
C
      IF (N.EQ.1) RETURN
C
      IW1 = N + N + 1
      CALL DCMFM1B(LOT,JUMP,N,INC,C,WORK,WSAVE,WSAVE(IW1),WSAVE(IW1+1))
      RETURN
      END

c***********************************************************************
c Determine the latitudes and weights used by the Lin-Rood Model
c based on an email from "Shian-Jiann Lin" lin@dao.gsfc.nasa.gov
c His code was "dumbed down" to f77 for the gnu77 compiler.
c***********************************************************************
C NCLFORTSTART
C NCL:  lw = linrood_latwt(nlat) 
      subroutine   linrood(lat,weight,nlat)
      implicit     none
c                             INPUT
      integer      nlat
c                             OUTPUT [return like NCL 'gaus']
      double precision weight(nlat), lat(nlat)
C NCLEND
      integer          nl
      double precision dlat
c                             Calculate latitudes
      dlat   = 180.d0/(nlat-1.d0)
      lat(1) = -90.d0
      do nl=2,nlat-1
         lat(nl) = lat(nl-1) + dlat
      end do
      lat(nlat)  = 90.d0
c                             Calculate weights 
      call linroodwt (weight,nlat)

      return
      end
c ------------------------------------------------------
C NCLFORTSTART
C NCL:  lw = linroodwt(nlat) 
      subroutine linroodwt (weight,nlat)
      implicit none
      integer nlat
      double precision weight(nlat)  
C NCLEND
c                                LOCAL [AUTOMATIC ARRAYS]
      real             dp, dl
      double precision sine(nlat),cosp(nlat),sinp(nlat),cose(nlat)
      integer          nl

      call setrig (nlat, dp, dl, cosp, cose, sinp, sine)
c                             Compute gw to be used in physpkg
      do nl=2,nlat-1
         weight(nl) = sine(nl+1) - sine(nl)
      end do

      weight(   1) =  1. + sine(2)
      weight(nlat) =  1. - sine(nlat)

      return
      end
c -----------------------------------------
c c c subroutine setrig(im, jm, dp, dl, cosp, cose, sinp, sine)
      subroutine setrig(jm, dp, dl, cosp, cose, sinp, sine)
      implicit none
c                               INPUT
      integer jm
c                               OUTPUT
      double precision sine(jm),cosp(jm),sinp(jm),cose(jm)
c                               LOCAL
      real    dl, dp
      integer j, jm1
      double precision pi, ph5   

      jm1 = jm - 1
      pi  = 4.0d0 * atan(1.d0)
c c c dl  = (pi+pi)/dble(im)    ! not used: drop "im"
      dp  = pi/dble(jm1)

      do j=2,jm
         ph5     = -0.5d0*pi + (dble(j-1)-0.5d0)*(pi/dble(jm1))
         sine(j) = sin(ph5)
      enddo

      cosp( 1) =  0.d0
      cosp(jm) =  0.d0

      do j=2,jm1
         cosp(j) = (sine(j+1)-sine(j)) / dp
      enddo

c Define cosine at edges..

      do j=2,jm
         cose(j) = 0.5d0 * (cosp(j-1) + cosp(j))
      enddo

      cose(1)  = cose(2)

      sinp( 1) = -1.d0
      sinp(jm) =  1.d0

      do j=2,jm1
         sinp(j) = 0.5d0 * (sine(j) + sine(j+1))
      enddo

      return
      end

c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by UCAR                 .
c  .                                                             .
c  .       University Corporation for Atmospheric Research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                         SPHEREPACK                          .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c
c
c ... file gradec.f
c
c     this file includes documentation and code for
c     subroutine gradec         i
c
c ... files which must be loaded with gradec.f
c
c     sphcom.f, hrfft.f, shaec.f,vhsec.f
c
c     subroutine gradec(nlat,nlon,isym,nt,v,w,idvw,jdvw,a,b,mdab,ndab,
c    +                  wvhsec,lvhsec,work,lwork,ierror)
c
C*PL*ERROR* Comment line too long
c     given the scalar spherical harmonic coefficients a and b, precomputed
C*PL*ERROR* Comment line too long
c     by subroutine shaec for a scalar field sf, subroutine gradec computes
c     an irrotational vector field (v,w) such that
c
c           gradient(sf) = (v,w).
c
c     v is the colatitudinal and w is the east longitudinal component
c     of the gradient.  i.e.,
c
c            v(i,j) = d(sf(i,j))/dtheta
c
c     and
c
c            w(i,j) = 1/sint*d(sf(i,j))/dlambda
c
c     at colatitude
c
c            theta(i) = (i-1)*pi/(nlat-1)
c
c     and longitude
c
c            lambda(j) = (j-1)*2*pi/nlon.
c
C*PL*ERROR* Comment line too long
c     where sint = sin(theta(i)).  required associated legendre polynomials
C*PL*ERROR* Comment line too long
c     are recomputed rather than stored as they are in subroutine grades. this
C*PL*ERROR* Comment line too long
c     saves storage (compare wvhsec here and wvhses in grades) but increases
c     computational requirements.
c
c
c     input parameters
c
c
c     nlat   the number of colatitudes on the full sphere including the
c            poles. for example, nlat = 37 for a five degree grid.
c            nlat determines the grid increment in colatitude as
c            pi/(nlat-1).  if nlat is odd the equator is located at
c            grid point i=(nlat+1)/2. if nlat is even the equator is
c            located half way between points i=nlat/2 and i=nlat/2+1.
c            nlat must be at least 3. note: on the half sphere, the
c            number of grid points in the colatitudinal direction is
c            nlat/2 if nlat is even or (nlat+1)/2 if nlat is odd.
c
c     nlon   the number of distinct londitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater than
c            3.  the efficiency of the computation is improved when nlon
c            is a product of small prime numbers.
c
c
c     isym   this has the same value as the isym that was input to
c            subroutine shaec to compute the arrays a and b from the
c            scalar field sf.  isym determines whether (v,w) are
c            computed on the full or half sphere as follows:
c
c      = 0
c
c           sf is not symmetric about the equator. in this case
c           the vector field (v,w) is computed on the entire sphere.
c           i.e., in the arrays  v(i,j),w(i,j) for i=1,...,nlat and
c           j=1,...,nlon.
c
c      = 1
c
c           sf is antisymmetric about the equator. in this case w is
c           antisymmetric and v is symmetric about the equator. w
c           and v are computed on the northern hemisphere only.  i.e.,
c           if nlat is odd they are computed for i=1,...,(nlat+1)/2
c           and j=1,...,nlon.  if nlat is even they are computed for
c           i=1,...,nlat/2 and j=1,...,nlon.
c
c      = 2
c
c           sf is symmetric about the equator. in this case w is
c           symmetric and v is antisymmetric about the equator. w
c           and v are computed on the northern hemisphere only.  i.e.,
c           if nlat is odd they are computed for i=1,...,(nlat+1)/2
c           and j=1,...,nlon.  if nlat is even they are computed for
c           i=1,...,nlat/2 and j=1,...,nlon.
c
c
c     nt     nt is the number of scalar and vector fields.  some
c            computational efficiency is obtained for multiple fields.
C*PL*ERROR* Comment line too long
c            the arrays a,b,v, and w can be three dimensional corresponding
c            to an indexed multiple array sf.  in this case, multiple
c            vector synthesis will be performed to compute each vector
c            field.  the third index for a,b,v, and w is the synthesis
c            index which assumes the values k = 1,...,nt.  for a single
c            synthesis set nt = 1.  the description of the remaining
C*PL*ERROR* Comment line too long
c            parameters is simplified by assuming that nt=1 or that a,b,v,
c            and w are two dimensional arrays.
c
c     idvw   the first dimension of the arrays v,w as it appears in
c            the program that calls gradec. if isym = 0 then idvw
c            must be at least nlat.  if isym = 1 or 2 and nlat is
c            even then idvw must be at least nlat/2. if isym = 1 or 2
c            and nlat is odd then idvw must be at least (nlat+1)/2.
c
c     jdvw   the second dimension of the arrays v,w as it appears in
c            the program that calls gradec. jdvw must be at least nlon.
c
c     a,b    two or three dimensional arrays (see input parameter nt)
c            that contain scalar spherical harmonic coefficients
C*PL*ERROR* Comment line too long
c            of the scalar field array sf as computed by subroutine shaec.
c     ***    a,b must be computed by shaec prior to calling gradec.
c
c     mdab   the first dimension of the arrays a and b as it appears in
c            the program that calls gradec (and shaec). mdab must be at
c            least min0(nlat,(nlon+2)/2) if nlon is even or at least
c            min0(nlat,(nlon+1)/2) if nlon is odd.
c
c     ndab   the second dimension of the arrays a and b as it appears in
c            the program that calls gradec (and shaec). ndab must be at
c            least nlat.
c
c
c     wvhsec an array which must be initialized by subroutine vhseci.
c            once initialized,
c            wvhsec can be used repeatedly by gradec as long as nlon
c            and nlat remain unchanged.  wvhsec must not be altered
c            between calls of gradec.
c
c
c     lvhsec the dimension of the array wvhsec as it appears in the
c            program that calls gradec. define
c
c               l1 = min0(nlat,nlon/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd.
c
c            then lvhsec must be greater than or equal to
c
c               4*nlat*l2+3*max0(l1-2,0)*(nlat+nlat-l1-1)+nlon+15
c
c
c     work   a work array that does not have to be saved.
c
c     lwork  the dimension of the array work as it appears in the
c            program that calls gradec. define
c
c               l1 = min0(nlat,nlon/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2                  if nlat is even or
c               l2 = (nlat+1)/2              if nlat is odd
c
c
c            if isym = 0 then lwork must be at least
c
c                nlat*(2*nt*nlon+max0(6*l2,nlon)) + nlat*(2*l1*nt+1)
c
c            if isym = 1 or 2 then lwork must be at least
c
c                l2*(2*nt*nlon+max0(6*nlat,nlon)) + nlat*(2*l1*nt+1)
c
c
c     **************************************************************
c
c     output parameters
c
c
C*PL*ERROR* Comment line too long
c     v,w   two or three dimensional arrays (see input parameter nt) that
C*PL*ERROR* Comment line too long
c           contain an irrotational vector field such that the gradient of
c           the scalar field sf is (v,w).  w(i,j) is the east longitude
C*PL*ERROR* Comment line too long
c           component and v(i,j) is the colatitudinal component of velocity
c           at colatitude theta(i) = (i-1)*pi/(nlat-1) and longitude
C*PL*ERROR* Comment line too long
c           lambda(j) = (j-1)*2*pi/nlon. the indices for v and w are defined
C*PL*ERROR* Comment line too long
c           at the input parameter isym.  the vorticity of (v,w) is zero.
c           note that any nonzero vector field on the sphere will be
c           multiple valued at the poles [reference swarztrauber].
c
c
c  ierror   = 0  no errors
c           = 1  error in the specification of nlat
c           = 2  error in the specification of nlon
c           = 3  error in the specification of isym
c           = 4  error in the specification of nt
c           = 5  error in the specification of idvw
c           = 6  error in the specification of jdvw
c           = 7  error in the specification of mdab
c           = 8  error in the specification of ndab
c           = 9  error in the specification of lvhsec
c           = 10 error in the specification of lwork
c **********************************************************************
c
c
      SUBROUTINE DGRADEC(NLAT,NLON,ISYM,NT,V,W,IDVW,JDVW,A,B,MDAB,NDAB,
     +                  WVHSEC,LVHSEC,WORK,LWORK,IERROR)
      DOUBLE PRECISION V
      DOUBLE PRECISION W
      DOUBLE PRECISION A
      DOUBLE PRECISION B
      DOUBLE PRECISION WVHSEC
      DOUBLE PRECISION WORK
      DIMENSION V(IDVW,JDVW,NT),W(IDVW,JDVW,NT)
      DIMENSION A(MDAB,NDAB,NT),B(MDAB,NDAB,NT)
      DIMENSION WVHSEC(LVHSEC),WORK(LWORK)
c
c     check input parameters
c
      IERROR = 1
      IF (NLAT.LT.3) RETURN
      IERROR = 2
      IF (NLON.LT.4) RETURN
      IERROR = 3
      IF (ISYM.LT.0 .OR. ISYM.GT.2) RETURN
      IERROR = 4
      IF (NT.LT.0) RETURN
      IERROR = 5
      IMID = (NLAT+1)/2
      IF ((ISYM.EQ.0.AND.IDVW.LT.NLAT) .OR.
     +    (ISYM.NE.0.AND.IDVW.LT.IMID)) RETURN
      IERROR = 6
      IF (JDVW.LT.NLON) RETURN
      IERROR = 7
      MMAX = MIN0(NLAT, (NLON+1)/2)
      IF (MDAB.LT.MIN0(NLAT, (NLON+2)/2)) RETURN
      IERROR = 8
      IF (NDAB.LT.NLAT) RETURN
      IERROR = 9
c
c     verify minimum saved work space length
c
      IDZ = (MMAX* (NLAT+NLAT-MMAX+1))/2
      LZIMN = IDZ*IMID
      L1 = MIN0(NLAT, (NLON+1)/2)
      L2 = (NLAT+1)/2
      LWMIN = 4*NLAT*L2 + 3*MAX0(L1-2,0)* (NLAT+NLAT-L1-1) + NLON + 15
      IF (LVHSEC.LT.LWMIN) RETURN
      IERROR = 10
c
c     verify minimum unsaved work space length
c
      MN = MMAX*NLAT*NT
      IF (ISYM.EQ.0) THEN
          LWKMIN = NLAT* (2*NT*NLON+MAX0(6*L2,NLON)) + NLAT* (2*L1*NT+1)
      ELSE
          LWKMIN = L2* (2*NT*NLON+MAX0(6*NLAT,NLON)) + NLAT* (2*L1*NT+1)
      END IF
      IF (LWORK.LT.LWKMIN) RETURN

      IERROR = 0
c
c     set work space pointers
c
      IBR = 1
      IBI = IBR + MN
      IS = IBI + MN
      IWK = IS + NLAT
      LIWK = LWORK - 2*MN - NLAT
      CALL DGRADEC1(NLAT,NLON,ISYM,NT,V,W,IDVW,JDVW,WORK(IBR),WORK(IBI),
     +             MMAX,WORK(IS),MDAB,NDAB,A,B,WVHSEC,LVHSEC,WORK(IWK),
     +             LIWK,IERROR)
      RETURN
      END

      SUBROUTINE DGRADEC1(NLAT,NLON,ISYM,NT,V,W,IDVW,JDVW,BR,BI,MMAX,
     +                   SQNN,MDAB,NDAB,A,B,WVHSEC,LVHSEC,WK,LWK,IERROR)
      DOUBLE PRECISION V
      DOUBLE PRECISION W
      DOUBLE PRECISION BR
      DOUBLE PRECISION BI
      DOUBLE PRECISION SQNN
      DOUBLE PRECISION A
      DOUBLE PRECISION B
      DOUBLE PRECISION WVHSEC
      DOUBLE PRECISION WK
      DOUBLE PRECISION FN
      DOUBLE PRECISION CR
      DOUBLE PRECISION CI
      DIMENSION V(IDVW,JDVW,NT),W(IDVW,JDVW,NT)
      DIMENSION BR(MMAX,NLAT,NT),BI(MMAX,NLAT,NT),SQNN(NLAT)
      DIMENSION A(MDAB,NDAB,NT),B(MDAB,NDAB,NT)
      DIMENSION WVHSEC(LVHSEC),WK(LWK)
c
c     preset coefficient multiplyers in vector
c
      DO 1 N = 2,NLAT
          FN = DBLE(N-1)
          SQNN(N) = SQRT(FN* (FN+1.D0))
    1 CONTINUE
c
c     compute multiple vector fields coefficients
c
      DO 2 K = 1,NT
c
c     preset br,bi to 0.0
c
          DO 3 N = 1,NLAT
              DO 4 M = 1,MMAX
                  BR(M,N,K) = 0.0D0
                  BI(M,N,K) = 0.0D0
    4         CONTINUE
    3     CONTINUE
c
c     compute m=0 coefficients
c
          DO 5 N = 2,NLAT
              BR(1,N,K) = SQNN(N)*A(1,N,K)
              BI(1,N,K) = SQNN(N)*B(1,N,K)
    5     CONTINUE
c
c     compute m>0 coefficients
c
          DO 6 M = 2,MMAX
              DO 7 N = M,NLAT
                  BR(M,N,K) = SQNN(N)*A(M,N,K)
                  BI(M,N,K) = SQNN(N)*B(M,N,K)
    7         CONTINUE
    6     CONTINUE
    2 CONTINUE
c
c     set ityp for irrotational vector synthesis to compute gradient
c
      IF (ISYM.EQ.0) THEN
          ITYP = 1
      ELSE IF (ISYM.EQ.1) THEN
          ITYP = 4
      ELSE IF (ISYM.EQ.2) THEN
          ITYP = 7
      END IF
c
c     vector sythesize br,bi into (v,w) (cr,ci are dummy variables)
c
      CALL DVHSEC(NLAT,NLON,ITYP,NT,V,W,IDVW,JDVW,BR,BI,CR,CI,MMAX,NLAT,
     +           WVHSEC,LVHSEC,WK,LWK,IERROR)
      RETURN
      END

C
C $Id: msfnsp.f,v 1.5 2008-07-27 00:17:09 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      REAL FUNCTION MSFNSP (ECCENT,SINPHI,COSPHI)
C
C This function computes the constant "small m".
C
      IMPLICIT REAL (A-Z)
      DATA ONE /1.0E0/
C
      CON = ECCENT * SINPHI
      MSFNSP = COSPHI / SQRT (ONE - CON * CON)
C
      RETURN
      END

      SUBROUTINE DGEEQU( M, N, A, LDA, R, C, ROWCND, COLCND, AMAX,
     $                   INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     March 31, 1993
*
*     .. Scalar Arguments ..
      INTEGER            INFO, LDA, M, N
      DOUBLE PRECISION   AMAX, COLCND, ROWCND
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), C( * ), R( * )
*     ..
*
*  Purpose
*  =======
*
*  DGEEQU computes row and column scalings intended to equilibrate an
*  M-by-N matrix A and reduce its condition number.  R returns the row
*  scale factors and C the column scale factors, chosen to try to make
*  the largest element in each row and column of the matrix B with
*  elements B(i,j)=R(i)*A(i,j)*C(j) have absolute value 1.
*
*  R(i) and C(j) are restricted to be between SMLNUM = smallest safe
*  number and BIGNUM = largest safe number.  Use of these scaling
*  factors is not guaranteed to reduce the condition number of A but
*  works well in practice.
*
*  Arguments
*  =========
*
*  M       (input) INTEGER
*          The number of rows of the matrix A.  M >= 0.
*
*  N       (input) INTEGER
*          The number of columns of the matrix A.  N >= 0.
*
*  A       (input) DOUBLE PRECISION array, dimension (LDA,N)
*          The M-by-N matrix whose equilibration factors are
*          to be computed.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(1,M).
*
*  R       (output) DOUBLE PRECISION array, dimension (M)
*          If INFO = 0 or INFO > M, R contains the row scale factors
*          for A.
*
*  C       (output) DOUBLE PRECISION array, dimension (N)
*          If INFO = 0,  C contains the column scale factors for A.
*
*  ROWCND  (output) DOUBLE PRECISION
*          If INFO = 0 or INFO > M, ROWCND contains the ratio of the
*          smallest R(i) to the largest R(i).  If ROWCND >= 0.1 and
*          AMAX is neither too large nor too small, it is not worth
*          scaling by R.
*
*  COLCND  (output) DOUBLE PRECISION
*          If INFO = 0, COLCND contains the ratio of the smallest
*          C(i) to the largest C(i).  If COLCND >= 0.1, it is not
*          worth scaling by C.
*
*  AMAX    (output) DOUBLE PRECISION
*          Absolute value of largest matrix element.  If AMAX is very
*          close to overflow or very close to underflow, the matrix
*          should be scaled.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*          > 0:  if INFO = i,  and i is
*                <= M:  the i-th row of A is exactly zero
*                >  M:  the (i-M)-th column of A is exactly zero
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ONE, ZERO
      PARAMETER          ( ONE = 1.0D+0, ZERO = 0.0D+0 )
*     ..
*     .. Local Scalars ..
      INTEGER            I, J
      DOUBLE PRECISION   BIGNUM, RCMAX, RCMIN, SMLNUM
*     ..
*     .. External Functions ..
      DOUBLE PRECISION   DLAMCH
      EXTERNAL           DLAMCH
*     ..
*     .. External Subroutines ..
      EXTERNAL           XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, MAX, MIN
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      IF( M.LT.0 ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( LDA.LT.MAX( 1, M ) ) THEN
         INFO = -4
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DGEEQU', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( M.EQ.0 .OR. N.EQ.0 ) THEN
         ROWCND = ONE
         COLCND = ONE
         AMAX = ZERO
         RETURN
      END IF
*
*     Get machine constants.
*
      SMLNUM = DLAMCH( 'S' )
      BIGNUM = ONE / SMLNUM
*
*     Compute row scale factors.
*
      DO 10 I = 1, M
         R( I ) = ZERO
   10 CONTINUE
*
*     Find the maximum element in each row.
*
      DO 30 J = 1, N
         DO 20 I = 1, M
            R( I ) = MAX( R( I ), ABS( A( I, J ) ) )
   20    CONTINUE
   30 CONTINUE
*
*     Find the maximum and minimum scale factors.
*
      RCMIN = BIGNUM
      RCMAX = ZERO
      DO 40 I = 1, M
         RCMAX = MAX( RCMAX, R( I ) )
         RCMIN = MIN( RCMIN, R( I ) )
   40 CONTINUE
      AMAX = RCMAX
*
      IF( RCMIN.EQ.ZERO ) THEN
*
*        Find the first zero scale factor and return an error code.
*
         DO 50 I = 1, M
            IF( R( I ).EQ.ZERO ) THEN
               INFO = I
               RETURN
            END IF
   50    CONTINUE
      ELSE
*
*        Invert the scale factors.
*
         DO 60 I = 1, M
            R( I ) = ONE / MIN( MAX( R( I ), SMLNUM ), BIGNUM )
   60    CONTINUE
*
*        Compute ROWCND = min(R(I)) / max(R(I))
*
         ROWCND = MAX( RCMIN, SMLNUM ) / MIN( RCMAX, BIGNUM )
      END IF
*
*     Compute column scale factors
*
      DO 70 J = 1, N
         C( J ) = ZERO
   70 CONTINUE
*
*     Find the maximum element in each column,
*     assuming the row scaling computed above.
*
      DO 90 J = 1, N
         DO 80 I = 1, M
            C( J ) = MAX( C( J ), ABS( A( I, J ) )*R( I ) )
   80    CONTINUE
   90 CONTINUE
*
*     Find the maximum and minimum scale factors.
*
      RCMIN = BIGNUM
      RCMAX = ZERO
      DO 100 J = 1, N
         RCMIN = MIN( RCMIN, C( J ) )
         RCMAX = MAX( RCMAX, C( J ) )
  100 CONTINUE
*
      IF( RCMIN.EQ.ZERO ) THEN
*
*        Find the first zero scale factor and return an error code.
*
         DO 110 J = 1, N
            IF( C( J ).EQ.ZERO ) THEN
               INFO = M + J
               RETURN
            END IF
  110    CONTINUE
      ELSE
*
*        Invert the scale factors.
*
         DO 120 J = 1, N
            C( J ) = ONE / MIN( MAX( C( J ), SMLNUM ), BIGNUM )
  120    CONTINUE
*
*        Compute COLCND = min(C(J)) / max(C(J))
*
         COLCND = MAX( RCMIN, SMLNUM ) / MIN( RCMAX, BIGNUM )
      END IF
*
      RETURN
*
*     End of DGEEQU
*
      END

C
C $Id: gagetc.f,v 1.6 2008-07-27 00:17:13 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GAGETC (PNAM,CVAL)
C
        CHARACTER*(*) PNAM,CVAL
C
C The subroutine GAGETC may be used to get GRIDAL parameters which have
C values of type CHARACTER.
C
C Declare the common block containing character parameters.
C
        COMMON /GACHAR/ FNLX,FNLY
        CHARACTER*10    FNLX,FNLY
        SAVE   /GACHAR/
C
C Check for an uncleared prior error.
C
        IF (ICFELL('GAGETC - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C Get the parameter value desired.
C
        IF      (PNAM(1:3).EQ.'XLF'.OR.PNAM(1:3).EQ.'xlf') THEN
          CVAL=FNLX
        ELSE IF (PNAM(1:3).EQ.'YLF'.OR.PNAM(1:3).EQ.'ylf') THEN
          CVAL=FNLY
        ELSE
          CALL SETER ('GAGETC - UNRECOGNIZED PARAMETER NAME',2,1)
        END IF
C
C Done.
C
        RETURN
C
      END

      PROGRAM TTHREE
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C OPEN GKS, OPEN WORKSTATION OF TYPE 1, ACTIVATE WORKSTATION
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C INVOKE DEMO DRIVER
C
      CALL THREE(IERR)
C
C DEACTIVATE AND CLOSE WORKSTATION, CLOSE GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END
C
      SUBROUTINE THREE (IERROR)
C
C PURPOSE                To provide a simple demonstration of THREED.
C
C USAGE                  CALL THREE (IERROR)
C
C ARGUMENTS
C
C ON OUTPUT              IERROR
C                          An integer variable
C                          = 0, if the test was successful,
C                          = 1, the test was not successful.
C
C I/O                    If the test is successful, the message
C
C               THREED TEST EXECUTED--SEE PLOT TO CERTIFY
C
C                        is printed on unit 6.  In addition, 1
C                        frame is produced on the machine graphics
C                        device.  In order to determine if the test
C                        was successful, it is necessary to examine
C                        the plot.
C
C PRECISION              Single
C
C LANGUAGE               FORTRAN 77
C
C REQUIRED ROUTINES      THREED
C
C REQUIRED GKS LEVEL     0A
C
C ALGORITHM              Routine TTHREE calls SET3 to establish a
C                        mapping between the plotter addresses and
C                        the user's volume, and to indicate the
C                        coordinates of the eye position from which
C                        the lines to be drawn are viewed.  Next,
C                        the volume perimeters and associated tick
C                        marks are drawn by calls to PERIM3.  The
C                        selected latitude and longitude lines of
C                        a sphere are then drawn.
C
C HISTORY                THREED was originally written in November
C                        1976 and converted to FORTRAN 77 and GKS
C                        in July 1984.
C
      REAL EYE(3),X(31),Y(31),Z(31)
C
C Specify the arguments to be used by routine SET3 on a plot
C grid in the address range of 0. to 1.  In each coordinate direction,
C the values  RXA, RXB, RYA, and RYB define the portion of the address
C space to be used in making the plot.  UC, UD, VC, VD, WC, and WD
C define a volume in user coordinates which is to be mapped onto the
C portion of the viewing surface as specified by RXA, RXB, RYA, and RYB.
C
      DATA RXA/0.097656/, RXB/0.90236/, RYA/0.097656/, RYB/0.90236/
      DATA UC/-1./, UD/1./, VC/-1./, VD/1./, WC/-1./, WD/1./
      DATA EYE(1),EYE(2),EYE(3)/10.,6.,3./
      DATA TX/0.4374/, TY/0.9570/
      DATA PI/3.1415926535898/
C
C Select normalization transformation 0.
C
      CALL GSELNT (0)
C
C Call SET3 to establish a mapping between the plotter addresses
C and the user's volume, and to indicate the coordinates of the
C eye position from which the lines to be drawn are viewed.
C
      CALL SET3(RXA,RXB,RYA,RYB,UC,UD,VC,VD,WC,WD,EYE)
C
C Call PERIM3 to draw perimeter lines and tick marks.
C
      CALL PERIM3(2,5,1,10,1,-1.)
      CALL PERIM3(4,2,1,1,2,-1.)
      CALL PERIM3(2,10,4,5,3,-1.)
C
C Define and draw latitudinal lines on the sphere of radius one
C having its center at (0.,0.,0.)
C
      DO 10 J=1,18
      THETA = REAL(J)*PI/9.
      CT = COS(THETA)
      ST = SIN(THETA)
      DO 20 K=1,31
      PHI = REAL(K-16)*PI/30.
      Z(K) = SIN(PHI)
      CP = COS(PHI)
      X(K) = CT*CP
      Y(K) = ST*CP
   20 CONTINUE
      CALL CURVE3(X,Y,Z,31)
   10 CONTINUE
C
C Define and draw longitudinal lines on the sphere of radius one
C having its center at (0.,0.,0.)
C
      DO 30 K=1,5
      PHI = REAL(K-3)*PI/6.
      SP = SIN(PHI)
      CP = COS(PHI)
      DO 40 J=1,31
      TUETA = REAL(J-1)*PI/15.
      X(J) = COS(TUETA)*CP
      Y(J) = SIN(TUETA)*CP
      Z(J) = SP
   40 CONTINUE
      CALL CURVE3(X,Y,Z,31)
   30 CONTINUE
C
C Add a plot title.
C
      CALL PLCHLQ(TX,TY,'DEMONSTRATION PLOT FOR ROUTINE THREED',
     +             16.,0.,0.)
C
C Advance the frame.
C
      CALL FRAME
C
      IERROR = 0
      WRITE(6,1001)
      RETURN
C
 1001 FORMAT (' THREED TEST EXECUTED--SEE PLOT TO CERTIFY')
      END

C
C $Id: agchnl.f,v 1.6 2008-07-27 00:14:33 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE AGCHNL (IAXS,VILS,CHRM,MCIM,NCIM,IPXM,CHRE,MCIE,NCIE)
C
      CHARACTER*(*) CHRM,CHRE
C
C The routine AGCHNL is called by AGAXIS just after it has set up the
C character strings comprising a numeric label along an axis.  The
C default version does nothing.  A user may supply his own version to
C change the numeric labels.  For each numeric label, this routine is
C called twice by AGAXIS - once to determine how much space will be
C required when the label is actually drawn and once just before it
C is actually drawn.  The arguments are as follows:
C
C - IAXS is the number of the axis being drawn.  Its value is 1, 2, 3,
C   or 4, implying the left, right, bottom, or top axes, respectively.
C   The value of IAXS must not be altered.
C
C - VILS is the value to be represented by the numeric label, in the
C   label system for the axis.  The value of VILS must not be altered.
C
C - CHRM, on entry, is a character string containing the mantissa of the
C   numeric label, as it will appear if AGCHNL makes no changes.  If the
C   numeric label includes a "times" symbol, it will be represented by
C   a blank in CHRM.  (See IPXM, below.)  CHRM may be modified.
C
C - MCIM is the length of CHRM - the maximum number of characters that
C   it will hold.  The value of MCIM must not be altered.
C
C - NCIM, on entry, is the number of meaningful characters in CHRM.  If
C   CHRM is changed, NCIM should be changed accordingly.
C
C - IPXM, on entry, is zero if there is no "times" symbol in CHRM; if it
C   is non-zero, it is the index of the appropriate character position
C   in CHRM.  If AGCHNL changes the position of the "times" symbol in
C   CHRM, removes it, or adds it, the value of IPXM must be changed.
C
C - CHRE, on entry, is a character string containing the exponent of the
C   numeric label, as it will appear if AGCHNL makes no changes.  CHRE
C   may be modified.
C
C - MCIE is the length of CHRE - the maximum number of characters that
C   it will hold.  The value of MCIE must not be altered.
C
C - NCIE, on entry, is the number of meaningful characters in CHRE.  If
C   CHRE is changed, NCIE should be changed accordingly.
C
C Done.
C
      RETURN
C
      END

C
C	$Id: gwiiac.f,v 1.5 2008-07-27 00:21:07 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
        SUBROUTINE GWIIAC
C
C  Initialize attribute context.
C
      include 'gwiarq.h'
      include 'gwiast.h'
      include 'gwiadf.h'
      include 'gwiadc.h'
C
      INTEGER  IX
C
C  Compute the length of each attribute, based on pointers.
C
      DO 5 IX=1,25
        IL2AEA(IX) = ABS(IP2AEA(IX+1)) - ABS(IP2AEA(IX))
    5 CONTINUE
C
C  Copy the default attribute context to "SET" context.
C
      CALL GWID2S
C
C  Copy the default attribute context to "REQUESTED" context.
C
      CALL GWID2R
C
C  Initialize attribute deferral scheme.
C
C
C  Logical change variable for each primitive.
C
      DO 10 IX=1,4
        AGPEND(IX) = .FALSE.
   10 CONTINUE
C
C  Value change variables for each attribute.
C
      DO 20 IX=1,24
        VALCHG(IX) = .FALSE.
   20 CONTINUE
C
C  Aggregate ASF value change variable.
C
      ANYASF = .FALSE.
C
C  Value change variables for each ASF.
C
      DO 30 IX=1,13
        ASFCHG(IX) = .FALSE.
   30 CONTINUE
C
      RETURN
      END

C
C      $Id: vc01f.f,v 1.4 2010-03-15 22:49:25 haley Exp $
C
C***********************************************************************
C                                                                      *
C                Copyright (C)  1996                                   *
C        University Corporation for Atmospheric Research               *
C                All Rights Reserved                                   *
C                                                                      *
C***********************************************************************
C
C   File:       vc01f.f
C 
C   Author:     David Brown
C               National Center for Atmospheric Research
C               PO 3000, Boulder, Colorado
C 
C
C  Date:       Wed Apr  3 17:00:55 MST 1996
C
C  Description:  Basic VectorPlot example
C
      external NhlFAppClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFCairoWindowWorkstationClass
      external NhlFVectorFieldClass
      external NhlFVectorPlotClass

      parameter(M=30,N=25)
      parameter(PI=3.14159)

      character*7  wks_type
      integer appid,wid,vcid,vfid
      integer rlist
      integer len_dims(2)
      real U(M,N),V(M,N)
      real igrid, jgrid
      integer i,j

C
C Generate vector data arrays
C
      igrid = 2.0 * PI / real(M)
      jgrid = 2.0 * PI / real(N)
      do 20 j = 1,N
         do 10 i=1,M
            U(i,j) = 10.0 * cos(jgrid * real(j-1))
            V(i,j) = 10.0 * cos(igrid * real(i-1))
 10      continue
 20   continue
C
C Initialize the high level utility library
C
      call NhlFInitialize
C
C Create an application context. Set the app dir to the current
C directory so the application looks for a resource file in the working
C directory. 
C
      call NhlFRLCreate(rlist,'SETRL')
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'vc01',NhlFappClass,0,rlist,ierr)

      wks_type = "x11"

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkMetaName','./vc01f.ncgm',ierr)
         call NhlFCreate(wid,'vc01Work',NhlFNcgmWorkstationClass,
     1     0,rlist,ierr)
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPause','True',ierr)
         call NhlFCreate(wid,'vc01Work',
     +        NhlFCairoWindowWorkstationClass,
     1        0,rlist,ierr) 
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PostScript workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPSFileName','./vc01f.ps',ierr)
         call NhlFCreate(wid,'vc01Work',NhlFPSWorkstationClass,
     1        0,rlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPDFFileName','./vc01f.pdf',ierr)
         call NhlFCreate(wid,'vc01Work',NhlFPDFWorkstationClass,
     1        0,rlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF object.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetstring(rlist,'wkFileName','./vc01f',ierr)
         call NhlFCreate(wid,'vc01Work',
     1        NhlFCairoPSPDFWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG object.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetstring(rlist,'wkFileName','./vc01f',ierr)
         call NhlFCreate(wid,'vc01Work',
     1        NhlFCairoImageWorkstationClass,0,rlist,ierr)
      endif
C
C Create a VectorField object then use its id as the value of
C the 'vcVectorFieldData' resource when creating the VectorPlot object.
C
      len_dims(1) = M
      len_dims(2) = N
      call NhlFRLClear(rlist)
      call NhlFRLSetMDFloatArray(rlist,'vfUDataArray',U,2,len_dims,ierr)
      call NhlFRLSetMDFloatArray(rlist,'vfVDataArray',V,2,len_dims,ierr)
      call NhlFCreate(vfid,'vectorfield',NhlFVectorFieldClass,appid,
     1     rlist,ierr)
      
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'tiMainString',
     1     'Basic VectorPlot Example',ierr)
      call NhlFRLSetInteger(rlist,'vcVectorFieldData',vfid,ierr)
      call NhlFCreate(vcid,'vector',NhlFVectorPlotClass,wid,rlist,ierr)

      call NhlFDraw(vcid,ierr)
      call NhlFFrame(wid,ierr)
C
C Destroy the objects created, close the HLU library and exit.
C
      call NhlFDestroy(appid,ierr)
      call NhlFClose

      stop
      end

c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by UCAR                 .
c  .                                                             .
c  .       University Corporation for Atmospheric Research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                         SPHEREPACK                       .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c
c
c
c ... file slapes.f
c
c     this file includes documentation and code for
c     subroutine slapes          i
c
c ... files which must be loaded with slapec.f
c
c     sphcom.f, hrfft.f, shaes.f, shses.f
c
c
c
c     subroutine slapes(nlat,nlon,isym,nt,slap,ids,jds,a,b,mdab,ndab,
c    +                  wshses,lshses,work,lwork,ierror)
c
c
C*PL*ERROR* Comment line too long
c     given the scalar spherical harmonic coefficients a and b, precomputed
C*PL*ERROR* Comment line too long
c     by subroutine shaes for a scalar field sf, subroutine slapes computes
c     the laplacian of sf in the scalar array slap.  slap(i,j) is the
c     laplacian of sf at the colatitude
c
c         theta(i) = (i-1)*pi/(nlat-1)
c
c     and east longitude
c
c         lambda(j) = (j-1)*2*pi/nlon
c
c     on the sphere.  i.e.
c
c         slap(i,j) =
c
c                  2                2
C*PL*ERROR* Comment line too long
c         [1/sint*d (sf(i,j)/dlambda + d(sint*d(sf(i,j))/dtheta)/dtheta]/sint
c
c
c     where sint = sin(theta(i)).  the scalar laplacian in slap has the
C*PL*ERROR* Comment line too long
c     same symmetry or absence of symmetry about the equator as the scalar
c     field sf.  the input parameters isym,nt,mdab,ndab must have the
C*PL*ERROR* Comment line too long
c     same values used by shaes to compute a and b for sf. the associated
c     legendre functions are stored rather than recomputed as they are
c     in subroutine slapec.

c
c     input parameters
c
c     nlat   the number of colatitudes on the full sphere including the
c            poles. for example, nlat = 37 for a five degree grid.
c            nlat determines the grid increment in colatitude as
c            pi/(nlat-1).  if nlat is odd the equator is located at
c            grid point i=(nlat+1)/2. if nlat is even the equator is
c            located half way between points i=nlat/2 and i=nlat/2+1.
c            nlat must be at least 3. note: on the half sphere, the
c            number of grid points in the colatitudinal direction is
c            nlat/2 if nlat is even or (nlat+1)/2 if nlat is odd.
c
c     nlon   the number of distinct longitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater
c            than zero. the axisymmetric case corresponds to nlon=1.
c            the efficiency of the computation is improved when nlon
c            is a product of small prime numbers.
c
C*PL*ERROR* Comment line too long
c     isym   this parameter should have the same value input to subroutine
C*PL*ERROR* Comment line too long
c            shaes to compute the coefficients a and b for the scalar field
c            sf.  isym is set as follows:
c
c            = 0  no symmetries exist in sf about the equator. scalar
C*PL*ERROR* Comment line too long
c                 synthesis is used to compute slap on the entire sphere.
c                 i.e., in the array slap(i,j) for i=1,...,nlat and
c                 j=1,...,nlon.
c
c           = 1  sf and slap are antisymmetric about the equator. the
c                synthesis used to compute slap is performed on the
c                northern hemisphere only.  if nlat is odd, slap(i,j) is
c                computed for i=1,...,(nlat+1)/2 and j=1,...,nlon.  if
c                nlat is even, slap(i,j) is computed for i=1,...,nlat/2
c                and j=1,...,nlon.
c
c
c           = 2  sf and slap are symmetric about the equator. the
c                synthesis used to compute slap is performed on the
c                northern hemisphere only.  if nlat is odd, slap(i,j) is
c                computed for i=1,...,(nlat+1)/2 and j=1,...,nlon.  if
c                nlat is even, slap(i,j) is computed for i=1,...,nlat/2
c                and j=1,...,nlon.
c
c
c     nt     the number of analyses.  in the program that calls slapes
c            the arrays slap,a, and b can be three dimensional in which
c            case multiple synthesis will be performed.  the third index
c            is the synthesis index which assumes the values k=1,...,nt.
c            for a single analysis set nt=1. the description of the
c            remaining parameters is simplified by assuming that nt=1
c            or that all the arrays are two dimensional.
c
c   ids      the first dimension of the array slap as it appears in the
c            program that calls slapes.  if isym = 0 then ids must be at
c            least nlat.  if isym > 0 and nlat is even then ids must be
c            at least nlat/2. if isym > 0 and nlat is odd then ids must
c            be at least (nlat+1)/2.
c
c   jds      the second dimension of the array slap as it appears in the
c            program that calls slapes. jds must be at least nlon.
c
c
c   a,b      two or three dimensional arrays (see input parameter nt)
c            that contain scalar spherical harmonic coefficients
c            of the scalar field sf as computed by subroutine shaes.
c     ***    a,b must be computed by shaes prior to calling slapes.
c
c
c    mdab    the first dimension of the arrays a and b as it appears
c            in the program that calls slapes.  mdab must be at
c            least min0(nlat,(nlon+2)/2) if nlon is even or at least
c            min0(nlat,(nlon+1)/2) if nlon is odd.
c
c    ndab    the second dimension of the arrays a and b as it appears
c            in the program that calls slapes. ndbc must be at least
c            least nlat.
c
c            mdab,ndab should have the same values input to shaes to
c            compute the coefficients a and b.
c
c
c    wshses  an array which must be initialized by subroutine shsesi
c            before calling slapes.  once initialized, wshses
c            can be used repeatedly by slapes as long as nlat and nlon
c            remain unchanged.  wshses must not be altered between calls
c            of slapes.
c
c    lshses  the dimension of the array wshses as it appears in the
c            program that calls slapes.  let
c
c               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            then lshses must be greater than or equal to
c
c               (l1*l2*(nlat+nlat-l1+1))/2+nlon+15.
c
c
c     work   a work array that does not have to be saved.
c
c
c     lwork  the dimension of the array work as it appears in the
c            program that calls slapes. define
c
c               l2 = nlat/2                    if nlat is even or
c               l2 = (nlat+1)/2                if nlat is odd
c               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            if isym is zero then lwork must be at least
c
c               (nt+1)*nlat*nlon + nlat*(2*nt*l1+1)
c
c            if isym is nonzero lwork must be at least
c
c               (nt+1)*l2*nlon + nlat*(2*nt*l1+1)
c
c     **************************************************************
c
c     output parameters
c
c
C*PL*ERROR* Comment line too long
c    slap    a two or three dimensional arrays (see input parameter nt) that
C*PL*ERROR* Comment line too long
c            contain the scalar laplacian of the scalar field sf.  slap(i,j)
c            is the scalar laplacian at the colatitude
c
c                 theta(i) = (i-1)*pi/(nlat-1)
c
c            and longitude
c
c                 lambda(j) = (j-1)*2*pi/nlon
c
c            for i=1,...,nlat and j=1,...,nlon.
c
c
C*PL*ERROR* Comment line too long
c  ierror    a parameter which flags errors in input parameters as follows:
c
c            = 0  no errors detected
c
c            = 1  error in the specification of nlat
c
c            = 2  error in the specification of nlon
c
c            = 3  error in the specification of ityp
c
c            = 4  error in the specification of nt
c
c            = 5  error in the specification of ids
c
c            = 6  error in the specification of jds
c
c            = 7  error in the specification of mdbc
c
c            = 8  error in the specification of ndbc
c
c            = 9  error in the specification of lshses
c
c            = 10 error in the specification of lwork
c
c
c **********************************************************************
c
c     end of documentation for slapes
c
c **********************************************************************
c
      SUBROUTINE DSLAPES(NLAT,NLON,ISYM,NT,SLAP,IDS,JDS,A,B,MDAB,NDAB,
     +                  WSHSES,LSHSES,WORK,LWORK,IERROR)
      DOUBLE PRECISION SLAP
      DOUBLE PRECISION A
      DOUBLE PRECISION B
      DOUBLE PRECISION WSHSES
      DOUBLE PRECISION WORK
      DIMENSION SLAP(IDS,JDS,NT),A(MDAB,NDAB,NT),B(MDAB,NDAB,NT)
      DIMENSION WSHSES(LSHSES),WORK(LWORK)
c
c     check input parameters
c
      IERROR = 1
      IF (NLAT.LT.3) RETURN
      IERROR = 2
      IF (NLON.LT.4) RETURN
      IERROR = 3
      IF (ISYM.LT.0 .OR. ISYM.GT.2) RETURN
      IERROR = 4
      IF (NT.LT.0) RETURN
      IERROR = 5
      IMID = (NLAT+1)/2
      IF ((ISYM.EQ.0.AND.IDS.LT.NLAT) .OR.
     +    (ISYM.GT.0.AND.IDS.LT.IMID)) RETURN
      IERROR = 6
      IF (JDS.LT.NLON) RETURN
      IERROR = 7
      MMAX = MIN0(NLAT,NLON/2+1)
      IF (MDAB.LT.MMAX) RETURN
      IERROR = 8
      IF (NDAB.LT.NLAT) RETURN
      IERROR = 9
      IMID = (NLAT+1)/2
      LPIMN = (IMID*MMAX* (NLAT+NLAT-MMAX+1))/2
      IF (LSHSES.LT.LPIMN+NLON+15) RETURN
      IERROR = 10
c
c     set and verify unsaved work space length
c
      LS = NLAT
      IF (ISYM.GT.0) LS = IMID
      NLN = NT*LS*NLON
      MN = MMAX*NLAT*NT
c     lwkmin = nln+ls*nlon+2*mn+nlat
c     if (lwork .lt. lwkmin) return
      L2 = (NLAT+1)/2
      L1 = MIN0(NLAT,NLON/2+1)
      IF (ISYM.EQ.0) THEN
          LWKMIN = (NT+1)*NLAT*NLON + NLAT* (2*NT*L1+1)
      ELSE
          LWKMIN = (NT+1)*L2*NLON + NLAT* (2*NT*L1+1)
      END IF
      IF (LWORK.LT.LWKMIN) RETURN
      IERROR = 0
c
c     set work space pointers
c
      IA = 1
      IB = IA + MN
      IFN = IB + MN
      IWK = IFN + NLAT
      LWK = LWORK - 2*MN - NLAT
      CALL DSLAPES1(NLAT,NLON,ISYM,NT,SLAP,IDS,JDS,A,B,MDAB,NDAB,
     +             WORK(IA),WORK(IB),MMAX,WORK(IFN),WSHSES,LSHSES,
     +             WORK(IWK),LWK,IERROR)
      RETURN
      END

      SUBROUTINE DSLAPES1(NLAT,NLON,ISYM,NT,SLAP,IDS,JDS,A,B,MDAB,NDAB,
     +                   ALAP,BLAP,MMAX,FNN,WSAVE,LSAVE,WK,LWK,IERROR)
      DOUBLE PRECISION SLAP
      DOUBLE PRECISION A
      DOUBLE PRECISION B
      DOUBLE PRECISION ALAP
      DOUBLE PRECISION BLAP
      DOUBLE PRECISION FNN
      DOUBLE PRECISION WSAVE
      DOUBLE PRECISION WK
      DOUBLE PRECISION FN
      DIMENSION SLAP(IDS,JDS,NT),A(MDAB,NDAB,NT),B(MDAB,NDAB,NT)
      DIMENSION ALAP(MMAX,NLAT,NT),BLAP(MMAX,NLAT,NT),FNN(NLAT)
      DIMENSION WSAVE(LSAVE),WK(LWK)
c
c     set coefficient multiplyers
c
      DO 1 N = 2,NLAT
          FN = DBLE(N-1)
          FNN(N) = FN* (FN+1.D0)
    1 CONTINUE
c
c     compute scalar laplacian coefficients for each vector field
c
      DO 2 K = 1,NT
          DO 3 N = 1,NLAT
              DO 4 M = 1,MMAX
                  ALAP(M,N,K) = 0.0D0
                  BLAP(M,N,K) = 0.0D0
    4         CONTINUE
    3     CONTINUE
c
c     compute m=0 coefficients
c
          DO 5 N = 2,NLAT
              ALAP(1,N,K) = -FNN(N)*A(1,N,K)
              BLAP(1,N,K) = -FNN(N)*B(1,N,K)
    5     CONTINUE
c
c     compute m>0 coefficients
c
          DO 6 M = 2,MMAX
              DO 7 N = M,NLAT
                  ALAP(M,N,K) = -FNN(N)*A(M,N,K)
                  BLAP(M,N,K) = -FNN(N)*B(M,N,K)
    7         CONTINUE
    6     CONTINUE
    2 CONTINUE
c
c     synthesize alap,blap into slap
c
      CALL DSHSES(NLAT,NLON,ISYM,NT,SLAP,IDS,JDS,ALAP,BLAP,MMAX,NLAT,
     +           WSAVE,LSAVE,WK,LWK,IERROR)
      RETURN
      END

c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by UCAR                 .
c  .                                                             .
c  .       University Corporation for Atmospheric Research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                         SPHEREPACK                          .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c
c
c ... file vhses.f
c
c     this file contains code and documentation for subroutines
c     vhses and vhsesi
c
c ... files which must be loaded with vhses.f
c
c     sphcom.f, hrfft.f
c
c
c     subroutine vhses(nlat,nlon,ityp,nt,v,w,idvw,jdvw,br,bi,cr,ci,
c    +                 mdab,ndab,wvhses,lvhses,work,lwork,ierror)
c
c     subroutine vhses performs the vector spherical harmonic synthesis
c     of the arrays br, bi, cr, and ci and stores the result in the
c     arrays v and w. v(i,j) and w(i,j) are the colatitudinal
c     (measured from the north pole) and east longitudinal components
c     respectively, located at colatitude theta(i) = (i-1)*pi/(nlat-1)
c     and longitude phi(j) = (j-1)*2*pi/nlon. the spectral
c     representation of (v,w) is given below at output parameters v,w.
c
c     input parameters
c
c     nlat   the number of colatitudes on the full sphere including the
c            poles. for example, nlat = 37 for a five degree grid.
c            nlat determines the grid increment in colatitude as
c            pi/(nlat-1).  if nlat is odd the equator is located at
c            grid point i=(nlat+1)/2. if nlat is even the equator is
c            located half way between points i=nlat/2 and i=nlat/2+1.
c            nlat must be at least 3. note: on the half sphere, the
c            number of grid points in the colatitudinal direction is
c            nlat/2 if nlat is even or (nlat+1)/2 if nlat is odd.
c
c     nlon   the number of distinct londitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater
c            than zero. the axisymmetric case corresponds to nlon=1.
c            the efficiency of the computation is improved when nlon
c            is a product of small prime numbers.
c
c     ityp   = 0  no symmetries exist about the equator. the synthesis
c                 is performed on the entire sphere.  i.e. on the
c                 arrays v(i,j),w(i,j) for i=1,...,nlat and
c                 j=1,...,nlon.
c
c            = 1  no symmetries exist about the equator. the synthesis
c                 is performed on the entire sphere.  i.e. on the
c                 arrays v(i,j),w(i,j) for i=1,...,nlat and
c                 j=1,...,nlon. the curl of (v,w) is zero. that is,
c                 (d/dtheta (sin(theta) w) - dv/dphi)/sin(theta) = 0.
c                 the coefficients cr and ci are zero.
c
c            = 2  no symmetries exist about the equator. the synthesis
c                 is performed on the entire sphere.  i.e. on the
c                 arrays v(i,j),w(i,j) for i=1,...,nlat and
c                 j=1,...,nlon. the divergence of (v,w) is zero. i.e.,
c                 (d/dtheta (sin(theta) v) + dw/dphi)/sin(theta) = 0.
c                 the coefficients br and bi are zero.
c
c            = 3  v is symmetric and w is antisymmetric about the
c                 equator. the synthesis is performed on the northern
c                 hemisphere only.  i.e., if nlat is odd the synthesis
c                 is performed on the arrays v(i,j),w(i,j) for
c                 i=1,...,(nlat+1)/2 and j=1,...,nlon. if nlat is
c                 even the synthesis is performed on the the arrays
c                 v(i,j),w(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
c
c            = 4  v is symmetric and w is antisymmetric about the
c                 equator. the synthesis is performed on the northern
c                 hemisphere only.  i.e., if nlat is odd the synthesis
c                 is performed on the arrays v(i,j),w(i,j) for
c                 i=1,...,(nlat+1)/2 and j=1,...,nlon. if nlat is
c                 even the synthesis is performed on the the arrays
c                 v(i,j),w(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
c                 the curl of (v,w) is zero. that is,
c                 (d/dtheta (sin(theta) w) - dv/dphi)/sin(theta) = 0.
c                 the coefficients cr and ci are zero.
c
c            = 5  v is symmetric and w is antisymmetric about the
c                 equator. the synthesis is performed on the northern
c                 hemisphere only.  i.e., if nlat is odd the synthesis
c                 is performed on the arrays v(i,j),w(i,j) for
c                 i=1,...,(nlat+1)/2 and j=1,...,nlon. if nlat is
c                 even the synthesis is performed on the the arrays
c                 v(i,j),w(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
c                 the divergence of (v,w) is zero. i.e.,
c                 (d/dtheta (sin(theta) v) + dw/dphi)/sin(theta) = 0.
c                 the coefficients br and bi are zero.
c
c            = 6  v is antisymmetric and w is symmetric about the
c                 equator. the synthesis is performed on the northern
c                 hemisphere only.  i.e., if nlat is odd the synthesis
c                 is performed on the arrays v(i,j),w(i,j) for
c                 i=1,...,(nlat+1)/2 and j=1,...,nlon. if nlat is
c                 even the synthesis is performed on the the arrays
c                 v(i,j),w(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
c
c            = 7  v is antisymmetric and w is symmetric about the
c                 equator. the synthesis is performed on the northern
c                 hemisphere only.  i.e., if nlat is odd the synthesis
c                 is performed on the arrays v(i,j),w(i,j) for
c                 i=1,...,(nlat+1)/2 and j=1,...,nlon. if nlat is
c                 even the synthesis is performed on the the arrays
c                 v(i,j),w(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
c                 the curl of (v,w) is zero. that is,
c                 (d/dtheta (sin(theta) w) - dv/dphi)/sin(theta) = 0.
c                 the coefficients cr and ci are zero.
c
c            = 8  v is antisymmetric and w is symmetric about the
c                 equator. the synthesis is performed on the northern
c                 hemisphere only.  i.e., if nlat is odd the synthesis
c                 is performed on the arrays v(i,j),w(i,j) for
c                 i=1,...,(nlat+1)/2 and j=1,...,nlon. if nlat is
c                 even the synthesis is performed on the the arrays
c                 v(i,j),w(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
c                 the divergence of (v,w) is zero. i.e.,
c                 (d/dtheta (sin(theta) v) + dw/dphi)/sin(theta) = 0.
c                 the coefficients br and bi are zero.
c
c
c     nt     the number of syntheses.  in the program that calls vhses,
c            the arrays v,w,br,bi,cr, and ci can be three dimensional
c            in which case multiple syntheses will be performed.
c            the third index is the synthesis index which assumes the
c            values k=1,...,nt.  for a single synthesis set nt=1. the
c            discription of the remaining parameters is simplified
c            by assuming that nt=1 or that all the arrays are two
c            dimensional.
c
c     idvw   the first dimension of the arrays v,w as it appears in
c            the program that calls vhaes. if ityp .le. 2 then idvw
c            must be at least nlat.  if ityp .gt. 2 and nlat is
c            even then idvw must be at least nlat/2. if ityp .gt. 2
c            and nlat is odd then idvw must be at least (nlat+1)/2.
c
c     jdvw   the second dimension of the arrays v,w as it appears in
c            the program that calls vhses. jdvw must be at least nlon.
c
c     br,bi  two or three dimensional arrays (see input parameter nt)
c     cr,ci  that contain the vector spherical harmonic coefficients
c            in the spectral representation of v(i,j) and w(i,j) given
c            below at the discription of output parameters v and w.
c
c     mdab   the first dimension of the arrays br,bi,cr, and ci as it
c            appears in the program that calls vhses. mdab must be at
c            least min0(nlat,nlon/2) if nlon is even or at least
c            min0(nlat,(nlon+1)/2) if nlon is odd.
c
c     ndab   the second dimension of the arrays br,bi,cr, and ci as it
c            appears in the program that calls vhses. ndab must be at
c            least nlat.
c
c     wvhses an array which must be initialized by subroutine vhsesi.
c            once initialized, wvhses can be used repeatedly by vhses
c            as long as nlon and nlat remain unchanged.  wvhses must
c            not be altered between calls of vhses.
c
c     lvhses the dimension of the array wvhses as it appears in the
c            program that calls vhses. define
c
c               l1 = min0(nlat,nlon/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            then lvhses must be at least
c
c                 l1*l2*(nlat+nlat-l1+1)+nlon+15
c
c
c     work   a work array that does not have to be saved.
c
c     lwork  the dimension of the array work as it appears in the
c            program that calls vhses. define
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            if ityp .le. 2 then lwork must be at least
c
c                       (2*nt+1)*nlat*nlon
c
c            if ityp .gt. 2 then lwork must be at least
c
c                        (2*nt+1)*l2*nlon
c
c     **************************************************************
c
c     output parameters
c
c     v,w    two or three dimensional arrays (see input parameter nt)
c            in which the synthesis is stored. v is the colatitudinal
c            component and w is the east longitudinal component.
c            v(i,j),w(i,j) contain the components at colatitude
c            theta(i) = (i-1)*pi/(nlat-1) and longitude phi(j) =
c            (j-1)*2*pi/nlon. the index ranges are defined above at
c            the input parameter ityp. v and w are computed from the
c            formulas given below
c
c
c     define
c
c     1.  theta is colatitude and phi is east longitude
c
c     2.  the normalized associated legendre funnctions
c
c         pbar(m,n,theta) = sqrt((2*n+1)*factorial(n-m)
c                        /(2*factorial(n+m)))*sin(theta)**m/(2**n*
c                        factorial(n)) times the (n+m)th derivative
c                        of (x**2-1)**n with respect to x=cos(theta)
c
c     3.  vbar(m,n,theta) = the derivative of pbar(m,n,theta) with
c                           respect to theta divided by the square
c                           root of n(n+1).
c
c         vbar(m,n,theta) is more easily computed in the form
c
c         vbar(m,n,theta) = (sqrt((n+m)*(n-m+1))*pbar(m-1,n,theta)
c         -sqrt((n-m)*(n+m+1))*pbar(m+1,n,theta))/(2*sqrt(n*(n+1)))
c
c     4.  wbar(m,n,theta) = m/(sin(theta))*pbar(m,n,theta) divided
c                           by the square root of n(n+1).
c
c         wbar(m,n,theta) is more easily computed in the form
c
c         wbar(m,n,theta) = sqrt((2n+1)/(2n-1))*(sqrt((n+m)*(n+m-1))
c         *pbar(m-1,n-1,theta)+sqrt((n-m)*(n-m-1))*pbar(m+1,n-1,theta))
c         /(2*sqrt(n*(n+1)))
c
c
c    the colatitudnal dependence of the normalized surface vector
c                spherical harmonics are defined by
c
c     5.    bbar(m,n,theta) = (vbar(m,n,theta),i*wbar(m,n,theta))
c
c     6.    cbar(m,n,theta) = (i*wbar(m,n,theta),-vbar(m,n,theta))
c
c
c    the coordinate to index mappings
c
c     7.   theta(i) = (i-1)*pi/(nlat-1) and phi(j) = (j-1)*2*pi/nlon
c
c
c     the maximum (plus one) longitudinal wave number
c
c     8.     mmax = min0(nlat,nlon/2) if nlon is even or
c            mmax = min0(nlat,(nlon+1)/2) if nlon is odd.
c
c    if we further define the output vector as
c
c     9.    h(i,j) = (v(i,j),w(i,j))
c
c    and the complex coefficients
c
c     10.   b(m,n) = cmplx(br(m+1,n+1),bi(m+1,n+1))
c
c     11.   c(m,n) = cmplx(cr(m+1,n+1),ci(m+1,n+1))
c
c
c    then for i=1,...,nlat and  j=1,...,nlon
c
c        the expansion for real h(i,j) takes the form
c
c     h(i,j) = the sum from n=1 to n=nlat-1 of the real part of
c
c         .5*(b(0,n)*bbar(0,n,theta(i))+c(0,n)*cbar(0,n,theta(i)))
c
c     plus the sum from m=1 to m=mmax-1 of the sum from n=m to
c     n=nlat-1 of the real part of
c
c              b(m,n)*bbar(m,n,theta(i))*exp(i*m*phi(j))
c             +c(m,n)*cbar(m,n,theta(i))*exp(i*m*phi(j))
c
c   *************************************************************
c
c   in terms of real variables this expansion takes the form
c
c             for i=1,...,nlat and  j=1,...,nlon
c
c     v(i,j) = the sum from n=1 to n=nlat-1 of
c
c               .5*br(1,n+1)*vbar(0,n,theta(i))
c
c     plus the sum from m=1 to m=mmax-1 of the sum from n=m to
c     n=nlat-1 of the real part of
c
c       (br(m+1,n+1)*vbar(m,n,theta(i))-ci(m+1,n+1)*wbar(m,n,theta(i)))
c                                          *cos(m*phi(j))
c      -(bi(m+1,n+1)*vbar(m,n,theta(i))+cr(m+1,n+1)*wbar(m,n,theta(i)))
c                                          *sin(m*phi(j))
c
c    and for i=1,...,nlat and  j=1,...,nlon
c
c     w(i,j) = the sum from n=1 to n=nlat-1 of
c
c              -.5*cr(1,n+1)*vbar(0,n,theta(i))
c
c     plus the sum from m=1 to m=mmax-1 of the sum from n=m to
c     n=nlat-1 of the real part of
c
c      -(cr(m+1,n+1)*vbar(m,n,theta(i))+bi(m+1,n+1)*wbar(m,n,theta(i)))
c                                          *cos(m*phi(j))
c      +(ci(m+1,n+1)*vbar(m,n,theta(i))-br(m+1,n+1)*wbar(m,n,theta(i)))
c                                          *sin(m*phi(j))
c
c
c      br(m+1,nlat),bi(m+1,nlat),cr(m+1,nlat), and ci(m+1,nlat) are
c      assumed zero for m even.
c
c
c     ierror = 0  no errors
c            = 1  error in the specification of nlat
c            = 2  error in the specification of nlon
c            = 3  error in the specification of ityp
c            = 4  error in the specification of nt
c            = 5  error in the specification of idvw
c            = 6  error in the specification of jdvw
c            = 7  error in the specification of mdab
c            = 8  error in the specification of ndab
c            = 9  error in the specification of lvhses
c            = 10 error in the specification of lwork
c
c ************************************************************
c
c     subroutine vhsesi(nlat,nlon,wvhses,lvhses,work,lwork,dwork,
c    +                  ldwork,ierror)
c
c     subroutine vhsesi initializes the array wvhses which can then be
c     used repeatedly by subroutine vhses until nlat or nlon is changed.
c
c     input parameters
c
c     nlat   the number of colatitudes on the full sphere including the
c            poles. for example, nlat = 37 for a five degree grid.
c            nlat determines the grid increment in colatitude as
c            pi/(nlat-1).  if nlat is odd the equator is located at
c            grid point i=(nlat+1)/2. if nlat is even the equator is
c            located half way between points i=nlat/2 and i=nlat/2+1.
c            nlat must be at least 3. note: on the half sphere, the
c            number of grid points in the colatitudinal direction is
c            nlat/2 if nlat is even or (nlat+1)/2 if nlat is odd.
c
c     nlon   the number of distinct londitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater
c            than zero. the axisymmetric case corresponds to nlon=1.
c            the efficiency of the computation is improved when nlon
c            is a product of small prime numbers.
c
c     lvhses the dimension of the array wvhses as it appears in the
c            program that calls vhses. define
c
c               l1 = min0(nlat,nlon/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            then lvhses must be at least
c
c                  l1*l2*(nlat+nlat-l1+1)+nlon+15
c
c
c     work   a work array that does not have to be saved.
c
c     lwork  the dimension of the array work as it appears in the
c            program that calls vhses. lwork must be at least
c
c              3*(max0(l1-2,0)*(nlat+nlat-l1-1))/2+5*l2*nlat
c
c     dwork  an unsaved double precision work space
c
c     ldwork the length of the array dwork as it appears in the
c            program that calls vhsesi.  ldwork must be at least
c            2*(nlat+1)
c
c
c     **************************************************************
c
c     output parameters
c
c     wvhses an array which is initialized for use by subroutine vhses.
c            once initialized, wvhses can be used repeatedly by vhses
c            as long as nlat or nlon remain unchanged.  wvhses must not
c            be altered between calls of vhses.
c
c
c     ierror = 0  no errors
c            = 1  error in the specification of nlat
c            = 2  error in the specification of nlon
c            = 3  error in the specification of lvhses
c            = 4  error in the specification of lwork
c            = 5  error in the specification of ldwork
c
c *****************************************
      SUBROUTINE DVHSES(NLAT,NLON,ITYP,NT,V,W,IDVW,JDVW,BR,BI,CR,CI,
     +                 MDAB,NDAB,WVHSES,LVHSES,WORK,LWORK,IERROR)
      DOUBLE PRECISION V
      DOUBLE PRECISION W
      DOUBLE PRECISION BR
      DOUBLE PRECISION BI
      DOUBLE PRECISION CR
      DOUBLE PRECISION CI
      DOUBLE PRECISION WVHSES
      DOUBLE PRECISION WORK
      DIMENSION V(IDVW,JDVW,1),W(IDVW,JDVW,1),BR(MDAB,NDAB,1),
     +          BI(MDAB,NDAB,1),CR(MDAB,NDAB,1),CI(MDAB,NDAB,1),WORK(1),
     +          WVHSES(1)

      IERROR = 1
      IF (NLAT.LT.3) RETURN
      IERROR = 2
      IF (NLON.LT.1) RETURN
      IERROR = 3
      IF (ITYP.LT.0 .OR. ITYP.GT.8) RETURN
      IERROR = 4
      IF (NT.LT.0) RETURN
      IERROR = 5
      IMID = (NLAT+1)/2
      IF ((ITYP.LE.2.AND.IDVW.LT.NLAT) .OR.
     +    (ITYP.GT.2.AND.IDVW.LT.IMID)) RETURN
      IERROR = 6
      IF (JDVW.LT.NLON) RETURN
      IERROR = 7
      MMAX = MIN0(NLAT, (NLON+1)/2)
      IF (MDAB.LT.MMAX) RETURN
      IERROR = 8
      IF (NDAB.LT.NLAT) RETURN
      IERROR = 9
      IDZ = (MMAX* (NLAT+NLAT-MMAX+1))/2
      LZIMN = IDZ*IMID
      IF (LVHSES.LT.LZIMN+LZIMN+NLON+15) RETURN
      IERROR = 10
      IDV = NLAT
      IF (ITYP.GT.2) IDV = IMID
      LNL = NT*IDV*NLON
      IF (LWORK.LT.LNL+LNL+IDV*NLON) RETURN
      IERROR = 0
      IST = 0
      IF (ITYP.LE.2) IST = IMID
      IW1 = IST + 1
      IW2 = LNL + 1
      IW3 = IW2 + IST
      IW4 = IW2 + LNL
      JW1 = LZIMN + 1
      JW2 = JW1 + LZIMN
      CALL DVHSES1(NLAT,NLON,ITYP,NT,IMID,IDVW,JDVW,V,W,MDAB,NDAB,BR,
     +             BI,CR,CI,IDV,WORK,WORK(IW1),WORK(IW2),WORK(IW3),
     +             WORK(IW4),IDZ,WVHSES,WVHSES(JW1),WVHSES(JW2))
      RETURN
      END

      SUBROUTINE DVHSES1(NLAT,NLON,ITYP,NT,IMID,IDVW,JDVW,V,W,MDAB,NDAB,
     +                  BR,BI,CR,CI,IDV,VE,VO,WE,WO,WORK,IDZ,VB,WB,
     +                  WRFFT)
      DOUBLE PRECISION V
      DOUBLE PRECISION W
      DOUBLE PRECISION BR
      DOUBLE PRECISION BI
      DOUBLE PRECISION CR
      DOUBLE PRECISION CI
      DOUBLE PRECISION VE
      DOUBLE PRECISION VO
      DOUBLE PRECISION WE
      DOUBLE PRECISION WO
      DOUBLE PRECISION WORK
      DOUBLE PRECISION VB
      DOUBLE PRECISION WB
      DOUBLE PRECISION WRFFT
      DIMENSION V(IDVW,JDVW,1),W(IDVW,JDVW,1),BR(MDAB,NDAB,1),
     +          BI(MDAB,NDAB,1),CR(MDAB,NDAB,1),CI(MDAB,NDAB,1),
     +          VE(IDV,NLON,1),VO(IDV,NLON,1),WE(IDV,NLON,1),
     +          WO(IDV,NLON,1),WORK(1),WRFFT(1),VB(IMID,1),WB(IMID,1)

      NLP1 = NLAT + 1
      MLAT = MOD(NLAT,2)
      MLON = MOD(NLON,2)
      MMAX = MIN0(NLAT, (NLON+1)/2)
      IMM1 = IMID
      IF (MLAT.NE.0) IMM1 = IMID - 1
      DO 10 K = 1,NT
          DO 10 J = 1,NLON
              DO 10 I = 1,IDV
                  VE(I,J,K) = 0.D0
                  WE(I,J,K) = 0.D0
   10 CONTINUE
      NDO1 = NLAT
      NDO2 = NLAT
      IF (MLAT.NE.0) NDO1 = NLAT - 1
      IF (MLAT.EQ.0) NDO2 = NLAT - 1
   18 ITYPP = ITYP + 1
      GO TO (1,100,200,300,400,500,600,700,800) ITYPP
c
c     case ityp=0   no symmetries
c
c     case m = 0
c
    1 DO 15 K = 1,NT
          DO 15 NP1 = 2,NDO2,2
              DO 15 I = 1,IMID
                  VE(I,1,K) = VE(I,1,K) + BR(1,NP1,K)*VB(I,NP1)
                  WE(I,1,K) = WE(I,1,K) - CR(1,NP1,K)*VB(I,NP1)
   15 CONTINUE
      DO 16 K = 1,NT
          DO 16 NP1 = 3,NDO1,2
              DO 16 I = 1,IMM1
                  VO(I,1,K) = VO(I,1,K) + BR(1,NP1,K)*VB(I,NP1)
                  WO(I,1,K) = WO(I,1,K) - CR(1,NP1,K)*VB(I,NP1)
   16 CONTINUE
c
c     case m = 1 through nlat-1
c
      IF (MMAX.LT.2) GO TO 950
      DO 30 MP1 = 2,MMAX
          M = MP1 - 1
          MB = M* (NLAT-1) - (M* (M-1))/2
          MP2 = MP1 + 1
          IF (MP1.GT.NDO1) GO TO 26
          DO 25 K = 1,NT
              DO 24 NP1 = MP1,NDO1,2
                  MN = MB + NP1
                  DO 23 I = 1,IMM1
                      VO(I,2*MP1-2,K) = VO(I,2*MP1-2,K) +
     +                                  BR(MP1,NP1,K)*VB(I,MN)
                      VE(I,2*MP1-2,K) = VE(I,2*MP1-2,K) -
     +                                  CI(MP1,NP1,K)*WB(I,MN)
                      VO(I,2*MP1-1,K) = VO(I,2*MP1-1,K) +
     +                                  BI(MP1,NP1,K)*VB(I,MN)
                      VE(I,2*MP1-1,K) = VE(I,2*MP1-1,K) +
     +                                  CR(MP1,NP1,K)*WB(I,MN)
                      WO(I,2*MP1-2,K) = WO(I,2*MP1-2,K) -
     +                                  CR(MP1,NP1,K)*VB(I,MN)
                      WE(I,2*MP1-2,K) = WE(I,2*MP1-2,K) -
     +                                  BI(MP1,NP1,K)*WB(I,MN)
                      WO(I,2*MP1-1,K) = WO(I,2*MP1-1,K) -
     +                                  CI(MP1,NP1,K)*VB(I,MN)
                      WE(I,2*MP1-1,K) = WE(I,2*MP1-1,K) +
     +                                  BR(MP1,NP1,K)*WB(I,MN)
   23             CONTINUE
                  IF (MLAT.EQ.0) GO TO 24
                  VE(IMID,2*MP1-2,K) = VE(IMID,2*MP1-2,K) -
     +                                 CI(MP1,NP1,K)*WB(IMID,MN)
                  VE(IMID,2*MP1-1,K) = VE(IMID,2*MP1-1,K) +
     +                                 CR(MP1,NP1,K)*WB(IMID,MN)
                  WE(IMID,2*MP1-2,K) = WE(IMID,2*MP1-2,K) -
     +                                 BI(MP1,NP1,K)*WB(IMID,MN)
                  WE(IMID,2*MP1-1,K) = WE(IMID,2*MP1-1,K) +
     +                                 BR(MP1,NP1,K)*WB(IMID,MN)
   24         CONTINUE
   25     CONTINUE
   26     IF (MP2.GT.NDO2) GO TO 30
          DO 29 K = 1,NT
              DO 28 NP1 = MP2,NDO2,2
                  MN = MB + NP1
                  DO 27 I = 1,IMM1
                      VE(I,2*MP1-2,K) = VE(I,2*MP1-2,K) +
     +                                  BR(MP1,NP1,K)*VB(I,MN)
                      VO(I,2*MP1-2,K) = VO(I,2*MP1-2,K) -
     +                                  CI(MP1,NP1,K)*WB(I,MN)
                      VE(I,2*MP1-1,K) = VE(I,2*MP1-1,K) +
     +                                  BI(MP1,NP1,K)*VB(I,MN)
                      VO(I,2*MP1-1,K) = VO(I,2*MP1-1,K) +
     +                                  CR(MP1,NP1,K)*WB(I,MN)
                      WE(I,2*MP1-2,K) = WE(I,2*MP1-2,K) -
     +                                  CR(MP1,NP1,K)*VB(I,MN)
                      WO(I,2*MP1-2,K) = WO(I,2*MP1-2,K) -
     +                                  BI(MP1,NP1,K)*WB(I,MN)
                      WE(I,2*MP1-1,K) = WE(I,2*MP1-1,K) -
     +                                  CI(MP1,NP1,K)*VB(I,MN)
                      WO(I,2*MP1-1,K) = WO(I,2*MP1-1,K) +
     +                                  BR(MP1,NP1,K)*WB(I,MN)
   27             CONTINUE
                  IF (MLAT.EQ.0) GO TO 28
                  VE(IMID,2*MP1-2,K) = VE(IMID,2*MP1-2,K) +
     +                                 BR(MP1,NP1,K)*VB(IMID,MN)
                  VE(IMID,2*MP1-1,K) = VE(IMID,2*MP1-1,K) +
     +                                 BI(MP1,NP1,K)*VB(IMID,MN)
                  WE(IMID,2*MP1-2,K) = WE(IMID,2*MP1-2,K) -
     +                                 CR(MP1,NP1,K)*VB(IMID,MN)
                  WE(IMID,2*MP1-1,K) = WE(IMID,2*MP1-1,K) -
     +                                 CI(MP1,NP1,K)*VB(IMID,MN)
   28         CONTINUE
   29     CONTINUE
   30 CONTINUE
      GO TO 950
c
c     case ityp=1   no symmetries,  cr and ci equal zero
c
c     case m = 0
c
  100 CONTINUE
      DO 115 K = 1,NT
          DO 115 NP1 = 2,NDO2,2
              DO 115 I = 1,IMID
                  VE(I,1,K) = VE(I,1,K) + BR(1,NP1,K)*VB(I,NP1)
  115 CONTINUE
      DO 116 K = 1,NT
          DO 116 NP1 = 3,NDO1,2
              DO 116 I = 1,IMM1
                  VO(I,1,K) = VO(I,1,K) + BR(1,NP1,K)*VB(I,NP1)
  116 CONTINUE
c
c     case m = 1 through nlat-1
c
      IF (MMAX.LT.2) GO TO 950
      DO 130 MP1 = 2,MMAX
          M = MP1 - 1
          MB = M* (NLAT-1) - (M* (M-1))/2
          MP2 = MP1 + 1
          IF (MP1.GT.NDO1) GO TO 126
          DO 125 K = 1,NT
              DO 124 NP1 = MP1,NDO1,2
                  MN = MB + NP1
                  DO 123 I = 1,IMM1
                      VO(I,2*MP1-2,K) = VO(I,2*MP1-2,K) +
     +                                  BR(MP1,NP1,K)*VB(I,MN)
                      VO(I,2*MP1-1,K) = VO(I,2*MP1-1,K) +
     +                                  BI(MP1,NP1,K)*VB(I,MN)
                      WE(I,2*MP1-2,K) = WE(I,2*MP1-2,K) -
     +                                  BI(MP1,NP1,K)*WB(I,MN)
                      WE(I,2*MP1-1,K) = WE(I,2*MP1-1,K) +
     +                                  BR(MP1,NP1,K)*WB(I,MN)
  123             CONTINUE
                  IF (MLAT.EQ.0) GO TO 124
                  WE(IMID,2*MP1-2,K) = WE(IMID,2*MP1-2,K) -
     +                                 BI(MP1,NP1,K)*WB(IMID,MN)
                  WE(IMID,2*MP1-1,K) = WE(IMID,2*MP1-1,K) +
     +                                 BR(MP1,NP1,K)*WB(IMID,MN)
  124         CONTINUE
  125     CONTINUE
  126     IF (MP2.GT.NDO2) GO TO 130
          DO 129 K = 1,NT
              DO 128 NP1 = MP2,NDO2,2
                  MN = MB + NP1
                  DO 127 I = 1,IMM1
                      VE(I,2*MP1-2,K) = VE(I,2*MP1-2,K) +
     +                                  BR(MP1,NP1,K)*VB(I,MN)
                      VE(I,2*MP1-1,K) = VE(I,2*MP1-1,K) +
     +                                  BI(MP1,NP1,K)*VB(I,MN)
                      WO(I,2*MP1-2,K) = WO(I,2*MP1-2,K) -
     +                                  BI(MP1,NP1,K)*WB(I,MN)
                      WO(I,2*MP1-1,K) = WO(I,2*MP1-1,K) +
     +                                  BR(MP1,NP1,K)*WB(I,MN)
  127             CONTINUE
                  IF (MLAT.EQ.0) GO TO 128
                  VE(IMID,2*MP1-2,K) = VE(IMID,2*MP1-2,K) +
     +                                 BR(MP1,NP1,K)*VB(IMID,MN)
                  VE(IMID,2*MP1-1,K) = VE(IMID,2*MP1-1,K) +
     +                                 BI(MP1,NP1,K)*VB(IMID,MN)
  128         CONTINUE
  129     CONTINUE
  130 CONTINUE
      GO TO 950
c
c     case ityp=2   no symmetries,  br and bi are equal to zero
c
c     case m = 0
c
  200 DO 215 K = 1,NT
          DO 215 NP1 = 2,NDO2,2
              DO 215 I = 1,IMID
                  WE(I,1,K) = WE(I,1,K) - CR(1,NP1,K)*VB(I,NP1)
  215 CONTINUE
      DO 216 K = 1,NT
          DO 216 NP1 = 3,NDO1,2
              DO 216 I = 1,IMM1
                  WO(I,1,K) = WO(I,1,K) - CR(1,NP1,K)*VB(I,NP1)
  216 CONTINUE
c
c     case m = 1 through nlat-1
c
      IF (MMAX.LT.2) GO TO 950
      DO 230 MP1 = 2,MMAX
          M = MP1 - 1
          MB = M* (NLAT-1) - (M* (M-1))/2
          MP2 = MP1 + 1
          IF (MP1.GT.NDO1) GO TO 226
          DO 225 K = 1,NT
              DO 224 NP1 = MP1,NDO1,2
                  MN = MB + NP1
                  DO 223 I = 1,IMM1
                      VE(I,2*MP1-2,K) = VE(I,2*MP1-2,K) -
     +                                  CI(MP1,NP1,K)*WB(I,MN)
                      VE(I,2*MP1-1,K) = VE(I,2*MP1-1,K) +
     +                                  CR(MP1,NP1,K)*WB(I,MN)
                      WO(I,2*MP1-2,K) = WO(I,2*MP1-2,K) -
     +                                  CR(MP1,NP1,K)*VB(I,MN)
                      WO(I,2*MP1-1,K) = WO(I,2*MP1-1,K) -
     +                                  CI(MP1,NP1,K)*VB(I,MN)
  223             CONTINUE
                  IF (MLAT.EQ.0) GO TO 224
                  VE(IMID,2*MP1-2,K) = VE(IMID,2*MP1-2,K) -
     +                                 CI(MP1,NP1,K)*WB(IMID,MN)
                  VE(IMID,2*MP1-1,K) = VE(IMID,2*MP1-1,K) +
     +                                 CR(MP1,NP1,K)*WB(IMID,MN)
  224         CONTINUE
  225     CONTINUE
  226     IF (MP2.GT.NDO2) GO TO 230
          DO 229 K = 1,NT
              DO 228 NP1 = MP2,NDO2,2
                  MN = MB + NP1
                  DO 227 I = 1,IMM1
                      VO(I,2*MP1-2,K) = VO(I,2*MP1-2,K) -
     +                                  CI(MP1,NP1,K)*WB(I,MN)
                      VO(I,2*MP1-1,K) = VO(I,2*MP1-1,K) +
     +                                  CR(MP1,NP1,K)*WB(I,MN)
                      WE(I,2*MP1-2,K) = WE(I,2*MP1-2,K) -
     +                                  CR(MP1,NP1,K)*VB(I,MN)
                      WE(I,2*MP1-1,K) = WE(I,2*MP1-1,K) -
     +                                  CI(MP1,NP1,K)*VB(I,MN)
  227             CONTINUE
                  IF (MLAT.EQ.0) GO TO 228
                  WE(IMID,2*MP1-2,K) = WE(IMID,2*MP1-2,K) -
     +                                 CR(MP1,NP1,K)*VB(IMID,MN)
                  WE(IMID,2*MP1-1,K) = WE(IMID,2*MP1-1,K) -
     +                                 CI(MP1,NP1,K)*VB(IMID,MN)
  228         CONTINUE
  229     CONTINUE
  230 CONTINUE
      GO TO 950
c
c     case ityp=3   v even,  w odd
c
c     case m = 0
c
  300 DO 315 K = 1,NT
          DO 315 NP1 = 2,NDO2,2
              DO 315 I = 1,IMID
                  VE(I,1,K) = VE(I,1,K) + BR(1,NP1,K)*VB(I,NP1)
  315 CONTINUE
      DO 316 K = 1,NT
          DO 316 NP1 = 3,NDO1,2
              DO 316 I = 1,IMM1
                  WO(I,1,K) = WO(I,1,K) - CR(1,NP1,K)*VB(I,NP1)
  316 CONTINUE
c
c     case m = 1 through nlat-1
c
      IF (MMAX.LT.2) GO TO 950
      DO 330 MP1 = 2,MMAX
          M = MP1 - 1
          MB = M* (NLAT-1) - (M* (M-1))/2
          MP2 = MP1 + 1
          IF (MP1.GT.NDO1) GO TO 326
          DO 325 K = 1,NT
              DO 324 NP1 = MP1,NDO1,2
                  MN = MB + NP1
                  DO 323 I = 1,IMM1
                      VE(I,2*MP1-2,K) = VE(I,2*MP1-2,K) -
     +                                  CI(MP1,NP1,K)*WB(I,MN)
                      VE(I,2*MP1-1,K) = VE(I,2*MP1-1,K) +
     +                                  CR(MP1,NP1,K)*WB(I,MN)
                      WO(I,2*MP1-2,K) = WO(I,2*MP1-2,K) -
     +                                  CR(MP1,NP1,K)*VB(I,MN)
                      WO(I,2*MP1-1,K) = WO(I,2*MP1-1,K) -
     +                                  CI(MP1,NP1,K)*VB(I,MN)
  323             CONTINUE
                  IF (MLAT.EQ.0) GO TO 324
                  VE(IMID,2*MP1-2,K) = VE(IMID,2*MP1-2,K) -
     +                                 CI(MP1,NP1,K)*WB(IMID,MN)
                  VE(IMID,2*MP1-1,K) = VE(IMID,2*MP1-1,K) +
     +                                 CR(MP1,NP1,K)*WB(IMID,MN)
  324         CONTINUE
  325     CONTINUE
  326     IF (MP2.GT.NDO2) GO TO 330
          DO 329 K = 1,NT
              DO 328 NP1 = MP2,NDO2,2
                  MN = MB + NP1
                  DO 327 I = 1,IMM1
                      VE(I,2*MP1-2,K) = VE(I,2*MP1-2,K) +
     +                                  BR(MP1,NP1,K)*VB(I,MN)
                      VE(I,2*MP1-1,K) = VE(I,2*MP1-1,K) +
     +                                  BI(MP1,NP1,K)*VB(I,MN)
                      WO(I,2*MP1-2,K) = WO(I,2*MP1-2,K) -
     +                                  BI(MP1,NP1,K)*WB(I,MN)
                      WO(I,2*MP1-1,K) = WO(I,2*MP1-1,K) +
     +                                  BR(MP1,NP1,K)*WB(I,MN)
  327             CONTINUE
                  IF (MLAT.EQ.0) GO TO 328
                  VE(IMID,2*MP1-2,K) = VE(IMID,2*MP1-2,K) +
     +                                 BR(MP1,NP1,K)*VB(IMID,MN)
                  VE(IMID,2*MP1-1,K) = VE(IMID,2*MP1-1,K) +
     +                                 BI(MP1,NP1,K)*VB(IMID,MN)
  328         CONTINUE
  329     CONTINUE
  330 CONTINUE
      GO TO 950
c
c     case ityp=4   v even,  w odd, and both cr and ci equal zero
c
c     case m = 0
c
  400 DO 415 K = 1,NT
          DO 415 NP1 = 2,NDO2,2
              DO 415 I = 1,IMID
                  VE(I,1,K) = VE(I,1,K) + BR(1,NP1,K)*VB(I,NP1)
  415 CONTINUE
c
c     case m = 1 through nlat-1
c
      IF (MMAX.LT.2) GO TO 950
      DO 430 MP1 = 2,MMAX
          M = MP1 - 1
          MB = M* (NLAT-1) - (M* (M-1))/2
          MP2 = MP1 + 1
          IF (MP2.GT.NDO2) GO TO 430
          DO 429 K = 1,NT
              DO 428 NP1 = MP2,NDO2,2
                  MN = MB + NP1
                  DO 427 I = 1,IMM1
                      VE(I,2*MP1-2,K) = VE(I,2*MP1-2,K) +
     +                                  BR(MP1,NP1,K)*VB(I,MN)
                      VE(I,2*MP1-1,K) = VE(I,2*MP1-1,K) +
     +                                  BI(MP1,NP1,K)*VB(I,MN)
                      WO(I,2*MP1-2,K) = WO(I,2*MP1-2,K) -
     +                                  BI(MP1,NP1,K)*WB(I,MN)
                      WO(I,2*MP1-1,K) = WO(I,2*MP1-1,K) +
     +                                  BR(MP1,NP1,K)*WB(I,MN)
  427             CONTINUE
                  IF (MLAT.EQ.0) GO TO 428
                  VE(IMID,2*MP1-2,K) = VE(IMID,2*MP1-2,K) +
     +                                 BR(MP1,NP1,K)*VB(IMID,MN)
                  VE(IMID,2*MP1-1,K) = VE(IMID,2*MP1-1,K) +
     +                                 BI(MP1,NP1,K)*VB(IMID,MN)
  428         CONTINUE
  429     CONTINUE
  430 CONTINUE
      GO TO 950
c
c     case ityp=5   v even,  w odd,     br and bi equal zero
c
c     case m = 0
c
  500 DO 516 K = 1,NT
          DO 516 NP1 = 3,NDO1,2
              DO 516 I = 1,IMM1
                  WO(I,1,K) = WO(I,1,K) - CR(1,NP1,K)*VB(I,NP1)
  516 CONTINUE
c
c     case m = 1 through nlat-1
c
      IF (MMAX.LT.2) GO TO 950
      DO 530 MP1 = 2,MMAX
          M = MP1 - 1
          MB = M* (NLAT-1) - (M* (M-1))/2
          MP2 = MP1 + 1
          IF (MP1.GT.NDO1) GO TO 530
          DO 525 K = 1,NT
              DO 524 NP1 = MP1,NDO1,2
                  MN = MB + NP1
                  DO 523 I = 1,IMM1
                      VE(I,2*MP1-2,K) = VE(I,2*MP1-2,K) -
     +                                  CI(MP1,NP1,K)*WB(I,MN)
                      VE(I,2*MP1-1,K) = VE(I,2*MP1-1,K) +
     +                                  CR(MP1,NP1,K)*WB(I,MN)
                      WO(I,2*MP1-2,K) = WO(I,2*MP1-2,K) -
     +                                  CR(MP1,NP1,K)*VB(I,MN)
                      WO(I,2*MP1-1,K) = WO(I,2*MP1-1,K) -
     +                                  CI(MP1,NP1,K)*VB(I,MN)
  523             CONTINUE
                  IF (MLAT.EQ.0) GO TO 524
                  VE(IMID,2*MP1-2,K) = VE(IMID,2*MP1-2,K) -
     +                                 CI(MP1,NP1,K)*WB(IMID,MN)
                  VE(IMID,2*MP1-1,K) = VE(IMID,2*MP1-1,K) +
     +                                 CR(MP1,NP1,K)*WB(IMID,MN)
  524         CONTINUE
  525     CONTINUE
  530 CONTINUE
      GO TO 950
c
c     case ityp=6   v odd  ,  w even
c
c     case m = 0
c
  600 DO 615 K = 1,NT
          DO 615 NP1 = 2,NDO2,2
              DO 615 I = 1,IMID
                  WE(I,1,K) = WE(I,1,K) - CR(1,NP1,K)*VB(I,NP1)
  615 CONTINUE
      DO 616 K = 1,NT
          DO 616 NP1 = 3,NDO1,2
              DO 616 I = 1,IMM1
                  VO(I,1,K) = VO(I,1,K) + BR(1,NP1,K)*VB(I,NP1)
  616 CONTINUE
c
c     case m = 1 through nlat-1
c
      IF (MMAX.LT.2) GO TO 950
      DO 630 MP1 = 2,MMAX
          M = MP1 - 1
          MB = M* (NLAT-1) - (M* (M-1))/2
          MP2 = MP1 + 1
          IF (MP1.GT.NDO1) GO TO 626
          DO 625 K = 1,NT
              DO 624 NP1 = MP1,NDO1,2
                  MN = MB + NP1
                  DO 623 I = 1,IMM1
                      VO(I,2*MP1-2,K) = VO(I,2*MP1-2,K) +
     +                                  BR(MP1,NP1,K)*VB(I,MN)
                      VO(I,2*MP1-1,K) = VO(I,2*MP1-1,K) +
     +                                  BI(MP1,NP1,K)*VB(I,MN)
                      WE(I,2*MP1-2,K) = WE(I,2*MP1-2,K) -
     +                                  BI(MP1,NP1,K)*WB(I,MN)
                      WE(I,2*MP1-1,K) = WE(I,2*MP1-1,K) +
     +                                  BR(MP1,NP1,K)*WB(I,MN)
  623             CONTINUE
                  IF (MLAT.EQ.0) GO TO 624
                  WE(IMID,2*MP1-2,K) = WE(IMID,2*MP1-2,K) -
     +                                 BI(MP1,NP1,K)*WB(IMID,MN)
                  WE(IMID,2*MP1-1,K) = WE(IMID,2*MP1-1,K) +
     +                                 BR(MP1,NP1,K)*WB(IMID,MN)
  624         CONTINUE
  625     CONTINUE
  626     IF (MP2.GT.NDO2) GO TO 630
          DO 629 K = 1,NT
              DO 628 NP1 = MP2,NDO2,2
                  MN = MB + NP1
                  DO 627 I = 1,IMM1
                      VO(I,2*MP1-2,K) = VO(I,2*MP1-2,K) -
     +                                  CI(MP1,NP1,K)*WB(I,MN)
                      VO(I,2*MP1-1,K) = VO(I,2*MP1-1,K) +
     +                                  CR(MP1,NP1,K)*WB(I,MN)
                      WE(I,2*MP1-2,K) = WE(I,2*MP1-2,K) -
     +                                  CR(MP1,NP1,K)*VB(I,MN)
                      WE(I,2*MP1-1,K) = WE(I,2*MP1-1,K) -
     +                                  CI(MP1,NP1,K)*VB(I,MN)
  627             CONTINUE
                  IF (MLAT.EQ.0) GO TO 628
                  WE(IMID,2*MP1-2,K) = WE(IMID,2*MP1-2,K) -
     +                                 CR(MP1,NP1,K)*VB(IMID,MN)
                  WE(IMID,2*MP1-1,K) = WE(IMID,2*MP1-1,K) -
     +                                 CI(MP1,NP1,K)*VB(IMID,MN)
  628         CONTINUE
  629     CONTINUE
  630 CONTINUE
      GO TO 950
c
c     case ityp=7   v odd, w even   cr and ci equal zero
c
c     case m = 0
c
  700 DO 716 K = 1,NT
          DO 716 NP1 = 3,NDO1,2
              DO 716 I = 1,IMM1
                  VO(I,1,K) = VO(I,1,K) + BR(1,NP1,K)*VB(I,NP1)
  716 CONTINUE
c
c     case m = 1 through nlat-1
c
      IF (MMAX.LT.2) GO TO 950
      DO 730 MP1 = 2,MMAX
          M = MP1 - 1
          MB = M* (NLAT-1) - (M* (M-1))/2
          MP2 = MP1 + 1
          IF (MP1.GT.NDO1) GO TO 730
          DO 725 K = 1,NT
              DO 724 NP1 = MP1,NDO1,2
                  MN = MB + NP1
                  DO 723 I = 1,IMM1
                      VO(I,2*MP1-2,K) = VO(I,2*MP1-2,K) +
     +                                  BR(MP1,NP1,K)*VB(I,MN)
                      VO(I,2*MP1-1,K) = VO(I,2*MP1-1,K) +
     +                                  BI(MP1,NP1,K)*VB(I,MN)
                      WE(I,2*MP1-2,K) = WE(I,2*MP1-2,K) -
     +                                  BI(MP1,NP1,K)*WB(I,MN)
                      WE(I,2*MP1-1,K) = WE(I,2*MP1-1,K) +
     +                                  BR(MP1,NP1,K)*WB(I,MN)
  723             CONTINUE
                  IF (MLAT.EQ.0) GO TO 724
                  WE(IMID,2*MP1-2,K) = WE(IMID,2*MP1-2,K) -
     +                                 BI(MP1,NP1,K)*WB(IMID,MN)
                  WE(IMID,2*MP1-1,K) = WE(IMID,2*MP1-1,K) +
     +                                 BR(MP1,NP1,K)*WB(IMID,MN)
  724         CONTINUE
  725     CONTINUE
  730 CONTINUE
      GO TO 950
c
c     case ityp=8   v odd,  w even   br and bi equal zero
c
c     case m = 0
c
  800 DO 815 K = 1,NT
          DO 815 NP1 = 2,NDO2,2
              DO 815 I = 1,IMID
                  WE(I,1,K) = WE(I,1,K) - CR(1,NP1,K)*VB(I,NP1)
  815 CONTINUE
c
c     case m = 1 through nlat-1
c
      IF (MMAX.LT.2) GO TO 950
      DO 830 MP1 = 2,MMAX
          M = MP1 - 1
          MB = M* (NLAT-1) - (M* (M-1))/2
          MP2 = MP1 + 1
          IF (MP2.GT.NDO2) GO TO 830
          DO 829 K = 1,NT
              DO 828 NP1 = MP2,NDO2,2
                  MN = MB + NP1
                  DO 827 I = 1,IMM1
                      VO(I,2*MP1-2,K) = VO(I,2*MP1-2,K) -
     +                                  CI(MP1,NP1,K)*WB(I,MN)
                      VO(I,2*MP1-1,K) = VO(I,2*MP1-1,K) +
     +                                  CR(MP1,NP1,K)*WB(I,MN)
                      WE(I,2*MP1-2,K) = WE(I,2*MP1-2,K) -
     +                                  CR(MP1,NP1,K)*VB(I,MN)
                      WE(I,2*MP1-1,K) = WE(I,2*MP1-1,K) -
     +                                  CI(MP1,NP1,K)*VB(I,MN)
  827             CONTINUE
                  IF (MLAT.EQ.0) GO TO 828
                  WE(IMID,2*MP1-2,K) = WE(IMID,2*MP1-2,K) -
     +                                 CR(MP1,NP1,K)*VB(IMID,MN)
                  WE(IMID,2*MP1-1,K) = WE(IMID,2*MP1-1,K) -
     +                                 CI(MP1,NP1,K)*VB(IMID,MN)
  828         CONTINUE
  829     CONTINUE
  830 CONTINUE
  950 DO 14 K = 1,NT
          CALL DHRFFTB(IDV,NLON,VE(1,1,K),IDV,WRFFT,WORK)
          CALL DHRFFTB(IDV,NLON,WE(1,1,K),IDV,WRFFT,WORK)
   14 CONTINUE
      IF (ITYP.GT.2) GO TO 12
      DO 60 K = 1,NT
          DO 60 J = 1,NLON
              DO 60 I = 1,IMM1
                  V(I,J,K) = .5D0* (VE(I,J,K)+VO(I,J,K))
                  W(I,J,K) = .5D0* (WE(I,J,K)+WO(I,J,K))
                  V(NLP1-I,J,K) = .5D0* (VE(I,J,K)-VO(I,J,K))
                  W(NLP1-I,J,K) = .5D0* (WE(I,J,K)-WO(I,J,K))
   60 CONTINUE
      GO TO 13
   12 DO 11 K = 1,NT
          DO 11 J = 1,NLON
              DO 11 I = 1,IMM1
                  V(I,J,K) = .5D0*VE(I,J,K)
                  W(I,J,K) = .5D0*WE(I,J,K)
   11 CONTINUE
   13 IF (MLAT.EQ.0) RETURN
      DO 65 K = 1,NT
          DO 65 J = 1,NLON
              V(IMID,J,K) = .5D0*VE(IMID,J,K)
              W(IMID,J,K) = .5D0*WE(IMID,J,K)
   65 CONTINUE
      RETURN
      END

      SUBROUTINE DVHSESI(NLAT,NLON,WVHSES,LVHSES,WORK,LWORK,DWORK,
     +                   LDWORK,IERROR)
      DOUBLE PRECISION WVHSES
      DOUBLE PRECISION WORK
      DIMENSION WVHSES(LVHSES),WORK(LWORK)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION DWORK(LDWORK)

      IERROR = 1
      IF (NLAT.LT.3) RETURN
      IERROR = 2
      IF (NLON.LT.1) RETURN
      IERROR = 3
      MMAX = MIN0(NLAT, (NLON+1)/2)
      IMID = (NLAT+1)/2
      LZIMN = (IMID*MMAX* (NLAT+NLAT-MMAX+1))/2
      IF (LVHSES.LT.LZIMN+LZIMN+NLON+15) RETURN
      IERROR = 4
      LABC = 3* (MAX0(MMAX-2,0)* (NLAT+NLAT-MMAX-1))/2
      IF (LWORK.LT.5*NLAT*IMID+LABC) RETURN
      IERROR = 5
      IF (LDWORK.LT.2* (NLAT+1)) RETURN
      IERROR = 0
      IW1 = 3*NLAT*IMID + 1
      IDZ = (MMAX* (NLAT+NLAT-MMAX+1))/2
      CALL DVES1(NLAT,NLON,IMID,WVHSES,WVHSES(LZIMN+1),IDZ,WORK,
     +          WORK(IW1),DWORK)
      CALL DHRFFTI(NLON,WVHSES(2*LZIMN+1))
      RETURN
      END
      SUBROUTINE DVES1(NLAT,NLON,IMID,VB,WB,IDZ,VIN,WZVIN,DWORK)
      DOUBLE PRECISION VB
      DOUBLE PRECISION WB
      DOUBLE PRECISION VIN
      DOUBLE PRECISION WZVIN
      DIMENSION VB(IMID,*),WB(IMID,*),VIN(IMID,NLAT,3),WZVIN(*)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION DWORK(*)

      MMAX = MIN0(NLAT, (NLON+1)/2)
      CALL DVBINIT(NLAT,NLON,WZVIN,DWORK)
      DO 33 MP1 = 1,MMAX
          M = MP1 - 1
          CALL DVBIN(0,NLAT,NLON,M,VIN,I3,WZVIN)
          DO 33 NP1 = MP1,NLAT
              MN = M* (NLAT-1) - (M* (M-1))/2 + NP1
              DO 33 I = 1,IMID
                  VB(I,MN) = VIN(I,NP1,I3)
   33 CONTINUE
      CALL DWBINIT(NLAT,NLON,WZVIN,DWORK)
      DO 34 MP1 = 1,MMAX
          M = MP1 - 1
          CALL DWBIN(0,NLAT,NLON,M,VIN,I3,WZVIN)
          DO 34 NP1 = MP1,NLAT
              MN = M* (NLAT-1) - (M* (M-1))/2 + NP1
              DO 34 I = 1,IMID
                  WB(I,MN) = VIN(I,NP1,I3)
   34 CONTINUE
      RETURN
      END

      SUBROUTINE CLASSQ( N, X, INCX, SCALE, SUMSQ )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      INTEGER            INCX, N
      REAL               SCALE, SUMSQ
*     ..
*     .. Array Arguments ..
      COMPLEX            X( * )
*     ..
*
*  Purpose
*  =======
*
*  CLASSQ returns the values scl and ssq such that
*
*     ( scl**2 )*ssq = x( 1 )**2 +...+ x( n )**2 + ( scale**2 )*sumsq,
*
*  where x( i ) = abs( X( 1 + ( i - 1 )*INCX ) ). The value of sumsq is
*  assumed to be at least unity and the value of ssq will then satisfy
*
*     1.0 .le. ssq .le. ( sumsq + 2*n ).
*
*  scale is assumed to be non-negative and scl returns the value
*
*     scl = max( scale, abs( real( x( i ) ) ), abs( aimag( x( i ) ) ) ),
*            i
*
*  scale and sumsq must be supplied in SCALE and SUMSQ respectively.
*  SCALE and SUMSQ are overwritten by scl and ssq respectively.
*
*  The routine makes only one pass through the vector X.
*
*  Arguments
*  =========
*
*  N       (input) INTEGER
*          The number of elements to be used from the vector X.
*
*  X       (input) COMPLEX array, dimension (N)
*          The vector x as described above.
*             x( i )  = X( 1 + ( i - 1 )*INCX ), 1 <= i <= n.
*
*  INCX    (input) INTEGER
*          The increment between successive values of the vector X.
*          INCX > 0.
*
*  SCALE   (input/output) REAL
*          On entry, the value  scale  in the equation above.
*          On exit, SCALE is overwritten with the value  scl .
*
*  SUMSQ   (input/output) REAL
*          On entry, the value  sumsq  in the equation above.
*          On exit, SUMSQ is overwritten with the value  ssq .
*
* =====================================================================
*
*     .. Parameters ..
      REAL               ZERO
      PARAMETER          ( ZERO = 0.0E+0 )
*     ..
*     .. Local Scalars ..
      INTEGER            IX
      REAL               TEMP1
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, AIMAG, REAL
*     ..
*     .. Executable Statements ..
*
      IF( N.GT.0 ) THEN
         DO 10 IX = 1, 1 + ( N-1 )*INCX, INCX
            IF( REAL( X( IX ) ).NE.ZERO ) THEN
               TEMP1 = ABS( REAL( X( IX ) ) )
               IF( SCALE.LT.TEMP1 ) THEN
                  SUMSQ = 1 + SUMSQ*( SCALE / TEMP1 )**2
                  SCALE = TEMP1
               ELSE
                  SUMSQ = SUMSQ + ( TEMP1 / SCALE )**2
               END IF
            END IF
            IF( AIMAG( X( IX ) ).NE.ZERO ) THEN
               TEMP1 = ABS( AIMAG( X( IX ) ) )
               IF( SCALE.LT.TEMP1 ) THEN
                  SUMSQ = 1 + SUMSQ*( SCALE / TEMP1 )**2
                  SCALE = TEMP1
               ELSE
                  SUMSQ = SUMSQ + ( TEMP1 / SCALE )**2
               END IF
            END IF
   10    CONTINUE
      END IF
*
      RETURN
*
*     End of CLASSQ
*
      END

        PROGRAM SFEX02
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
        PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Declare required dimensioned arrays.
C
        DIMENSION XCS(101),YCS(101),XRA(100),YRA(100),DST(102),IND(104)
C
C Declare an array to hold the GKS "aspect source flags".
C
        DIMENSION IAS(13)
C
C Define a character variable for use in labelling the plot.
C
        CHARACTER*2 LBL
C
C Initialize the values in the aspect-source-flag array.
C
        DATA IAS / 13*1 /
C
C Open GKS.
C
        CALL GOPKS (IERRF, ISZDM)
        CALL GOPWK (IWKID, LUNIT, IWTYPE)
        CALL GACWK (IWKID)
C
C Turn off the clipping indicator.
C
        CALL GSCLIP (0)
C
C Set all the GKS aspect source flags to "individual".
C
        CALL GSASF (IAS)
C
C Force solid fill.
C
        CALL GSFAIS (1)
C
C Define color indices.
C
        CALL DFCLRS(IWKID)
C
C Define the window and viewport to make it easy to do seven rows
C containing sixteen ovals apiece.
C
        CALL SET (0.,1.,0.,1.,-1.,16.5,-.5,7.5,1)
C
C For each of the possible values of the internal parameter 'TY', fill
C a set of circles, one for each of sixteen values of ICI (0-15).
C
        DO 103 ITY=-4,2
C
          YCN=REAL(3-ITY)
C
          WRITE (LBL,'(I2)') ITY
          CALL PLCHHQ (CFUX(CUFX(.5)-.006),YCN,LBL,.012,0.,1.)
C
          CALL SFSETI ('TYPE OF FILL',ITY)
C
          DO 102 ICI=0,15
C
            XCN=REAL(ICI+1)
C
            DO 101 L=1,101
              XCS(L)=XCN+.48*SIN(.062831853071796*REAL(L))
              YCS(L)=YCN+.48*COS(.062831853071796*REAL(L))
              IF (L.LT.101) THEN
                XRA(L)=XCS(L)
                YRA(L)=YCS(L)
              END IF
  101       CONTINUE
C
            CALL SFSGFA (XRA,YRA,100,DST,102,IND,104,ICI)
C
            CALL CURVE (XCS,YCS,101)
C
  102     CONTINUE
C
  103   CONTINUE
C
C Finish the labelling.
C
        CALL PLCHHQ (CFUX(CUFX(.5)-.060),4.,'"TYPE OF FILL"',
     +                                                      .012,90.,0.)
C
        DO 104 ICI=0,15
          XCN=REAL(ICI+1)
          IF (ICI.LT.10) THEN
            WRITE (LBL,'(I1)') ICI
            CALL PLCHHQ (XCN,CFUY(CUFY(.5)-.024),LBL(1:1),.012,0.,0.)
          ELSE
            WRITE (LBL,'(I2)') ICI
            CALL PLCHHQ (XCN,CFUY(CUFY(.5)-.024),LBL(1:2),.012,0.,0.)
          END IF
  104   CONTINUE
C
        CALL PLCHHQ (8.5,CFUY(CUFY(.5)-.060),'"COLOR INDEX"',.012,0.,0.)
C
C Advance the frame.
C
      CALL FRAME
C
C Close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
C Done.
C
      STOP
C
      END
      SUBROUTINE DFCLRS(IWKID)
C
C Define a set of RGB color triples for colors 1 through 15.
C
        DIMENSION RGBV(3,15)
C
C Define the RGB color triples needed below.
C
        DATA RGBV / 1.00 , 1.00 , 1.00 ,
     +              0.70 , 0.70 , 0.70 ,
     +              0.75 , 0.50 , 1.00 ,
     +              0.50 , 0.00 , 1.00 ,
     +              0.00 , 0.00 , 1.00 ,
     +              0.00 , 0.50 , 1.00 ,
     +              0.00 , 1.00 , 1.00 ,
     +              0.00 , 1.00 , 0.60 ,
     +              0.00 , 1.00 , 0.00 ,
     +              0.70 , 1.00 , 0.00 ,
     +              1.00 , 1.00 , 0.00 ,
     +              1.00 , 0.75 , 0.00 ,
     +              1.00 , 0.38 , 0.38 ,
     +              1.00 , 0.00 , 0.38 ,
     +              1.00 , 0.00 , 0.00 /
C
C Define 16 different color indices, for indices 0 through 15.  The
C color corresponding to index 0 is black and the color corresponding
C to index 1 is white.
C
        CALL GSCR (IWKID,0,0.,0.,0.)
C
        DO 101 I=1,15
          CALL GSCR (IWKID,I,RGBV(1,I),RGBV(2,I),RGBV(3,I))
  101   CONTINUE
C
C Done.
C
        RETURN
C
      END

C
C $Id: curve.f,v 1.7 2008-07-27 00:17:24 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CURVE (PX,PY,NP)
C
      DIMENSION PX(NP),PY(NP)
C
C CURVE draws the curve defined by the points (PX(I),PY(I)), for I = 1
C to NP.  All coordinates are stated in the user coordinate system.
C
C Define arrays to hold converted point coordinates when it becomes
C necessary to draw the curve piecewise.
C
      DIMENSION QX(10),QY(10)
C
C Check for an uncleared prior error.
C
      IF (ICFELL('CURVE - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C If NP is less than or equal to zero, there's nothing to do.
C
      IF (NP.LE.0) RETURN
C
C If NP is exactly equal to 1, just draw a point.
C
      IF (NP.EQ.1) THEN
        CALL POINT (PX(1),PY(1))
        IF (ICFELL('CURVE',2).NE.0) RETURN
C
C Otherwise, draw the curve.
C
      ELSE
C
C Flush the pen-move buffer.
C
        CALL PLOTIF (0.,0.,2)
        IF (ICFELL('CURVE',3).NE.0) RETURN
C
C Save the current SET parameters.
C
        CALL GETSET (F1,F2,F3,F4,F5,F6,F7,F8,LL)
        IF (ICFELL('CURVE',4).NE.0) RETURN
C
C If the mapping defined by the last SET call was non-reversed and
C linear in both x and y, a single polyline will suffice.
C
        IF (F5.LT.F6.AND.F7.LT.F8.AND.LL.EQ.1) THEN
          CALL GPL (NP,PX,PY)
C
C Otherwise, piece the line together out of smaller chunks, converting
C the coordinates for each chunk as directed by the last SET call.
C
        ELSE
          DO 102 IP=1,NP,9
            NQ=MIN(10,NP-IP+1)
            IF (NQ.GE.2) THEN
              DO 101 IQ=1,NQ
                QX(IQ)=CUFX(PX(IP+IQ-1))
                QY(IQ)=CUFY(PY(IP+IQ-1))
  101         CONTINUE
              CALL SET (F1,F2,F3,F4,F1,F2,F3,F4,1)
              IF (ICFELL('CURVE',5).NE.0) RETURN
              CALL GPL (NQ,QX,QY)
              CALL SET (F1,F2,F3,F4,F5,F6,F7,F8,LL)
              IF (ICFELL('CURVE',6).NE.0) RETURN
            END IF
  102     CONTINUE
        END IF
C
C Update the pen position.
C
        CALL FRSTPT (PX(NP),PY(NP))
        IF (ICFELL('CURVE',7).NE.0) RETURN
C
      END IF
C
C Done.
C
      RETURN
C
      END

C
C     $Id: sdot.f,v 1.1 1994-08-11 23:17:31 boote Exp $
C
      REAL FUNCTION SDOT(N,SX,INCX,SY,INCY)
C
C     FORMS THE DOT PRODUCT OF TWO VECTORS.
C     USES UNROLLED LOOPS FOR INCREMENTS EQUAL TO ONE.
C     JACK DONGARRA, LINPACK, 3/11/78.
C
      REAL SX(1),SY(1),STEMP
      INTEGER I,INCX,INCY,IX,IY,M,MP1,N
C
      STEMP = 0.0E0
      SDOT = 0.0E0
      IF(N.LE.0)RETURN
      IF(INCX.EQ.1.AND.INCY.EQ.1)GO TO 20
C
C        CODE FOR UNEQUAL INCREMENTS OR EQUAL INCREMENTS
C          NOT EQUAL TO 1
C
      IX = 1
      IY = 1
      IF(INCX.LT.0)IX = (-N+1)*INCX + 1
      IF(INCY.LT.0)IY = (-N+1)*INCY + 1
      DO 10 I = 1,N
        STEMP = STEMP + SX(IX)*SY(IY)
        IX = IX + INCX
        IY = IY + INCY
   10 CONTINUE
      SDOT = STEMP
      RETURN
C
C        CODE FOR BOTH INCREMENTS EQUAL TO 1
C
C
C        CLEAN-UP LOOP
C
   20 M = MOD(N,5)
      IF( M .EQ. 0 ) GO TO 40
      DO 30 I = 1,M
        STEMP = STEMP + SX(I)*SY(I)
   30 CONTINUE
      IF( N .LT. 5 ) GO TO 60
   40 MP1 = M + 1
      DO 50 I = MP1,N,5
        STEMP = STEMP + SX(I)*SY(I) + SX(I + 1)*SY(I + 1) +
     *   SX(I + 2)*SY(I + 2) + SX(I + 3)*SY(I + 3) + SX(I + 4)*SY(I + 4)
   50 CONTINUE
   60 SDOT = STEMP
      RETURN
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C   FFTPACK 5.0
C   Copyright (C) 1995-2004, Scientific Computing Division,
C   University Corporation for Atmospheric Research
C   Licensed under the GNU General Public License (GPL)
C
C   Authors:  Paul N. Swarztrauber and Richard A. Valent
C
C   $Id: cmfgkf.f,v 1.2 2006-11-21 01:10:16 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      SUBROUTINE DCMFGKF(LOT,IDO,IP,L1,LID,NA,CC,CC1,IM1,IN1,CH,CH1,
     +                   IM2,IN2,WA)
      DOUBLE PRECISION WAR
      DOUBLE PRECISION WAI
      DOUBLE PRECISION SN
      DOUBLE PRECISION CHOLD1
      DOUBLE PRECISION CHOLD2
      DOUBLE PRECISION CH(2,IN2,L1,IDO,IP),CC(2,IN1,L1,IP,IDO),
     +                 CC1(2,IN1,LID,IP),CH1(2,IN2,LID,IP),
     +                 WA(IDO,IP-1,2)
C
C FFTPACK 5.0 auxiliary routine
C
      M1D = (LOT-1)*IM1 + 1
      M2S = 1 - IM2
      IPP2 = IP + 2
      IPPH = (IP+1)/2
      DO 110 KI = 1,LID
          M2 = M2S
          DO 110 M1 = 1,M1D,IM1
              M2 = M2 + IM2
              CH1(1,M2,KI,1) = CC1(1,M1,KI,1)
              CH1(2,M2,KI,1) = CC1(2,M1,KI,1)
  110 CONTINUE
      DO 111 J = 2,IPPH
          JC = IPP2 - J
          DO 112 KI = 1,LID
              M2 = M2S
              DO 112 M1 = 1,M1D,IM1
                  M2 = M2 + IM2
                  CH1(1,M2,KI,J) = CC1(1,M1,KI,J) + CC1(1,M1,KI,JC)
                  CH1(1,M2,KI,JC) = CC1(1,M1,KI,J) - CC1(1,M1,KI,JC)
                  CH1(2,M2,KI,J) = CC1(2,M1,KI,J) + CC1(2,M1,KI,JC)
                  CH1(2,M2,KI,JC) = CC1(2,M1,KI,J) - CC1(2,M1,KI,JC)
  112     CONTINUE
  111 CONTINUE
      DO 118 J = 2,IPPH
          DO 117 KI = 1,LID
              M2 = M2S
              DO 117 M1 = 1,M1D,IM1
                  M2 = M2 + IM2
                  CC1(1,M1,KI,1) = CC1(1,M1,KI,1) + CH1(1,M2,KI,J)
                  CC1(2,M1,KI,1) = CC1(2,M1,KI,1) + CH1(2,M2,KI,J)
  117     CONTINUE
  118 CONTINUE
      DO 116 L = 2,IPPH
          LC = IPP2 - L
          DO 113 KI = 1,LID
              M2 = M2S
              DO 113 M1 = 1,M1D,IM1
                  M2 = M2 + IM2
                  CC1(1,M1,KI,L) = CH1(1,M2,KI,1) +
     +                             WA(1,L-1,1)*CH1(1,M2,KI,2)
                  CC1(1,M1,KI,LC) = -WA(1,L-1,2)*CH1(1,M2,KI,IP)
                  CC1(2,M1,KI,L) = CH1(2,M2,KI,1) +
     +                             WA(1,L-1,1)*CH1(2,M2,KI,2)
                  CC1(2,M1,KI,LC) = -WA(1,L-1,2)*CH1(2,M2,KI,IP)
  113     CONTINUE
          DO 115 J = 3,IPPH
              JC = IPP2 - J
              IDLJ = MOD((L-1)* (J-1),IP)
              WAR = WA(1,IDLJ,1)
              WAI = -WA(1,IDLJ,2)
              DO 114 KI = 1,LID
                  M2 = M2S
                  DO 114 M1 = 1,M1D,IM1
                      M2 = M2 + IM2
                      CC1(1,M1,KI,L) = CC1(1,M1,KI,L) +
     +                                 WAR*CH1(1,M2,KI,J)
                      CC1(1,M1,KI,LC) = CC1(1,M1,KI,LC) +
     +                                  WAI*CH1(1,M2,KI,JC)
                      CC1(2,M1,KI,L) = CC1(2,M1,KI,L) +
     +                                 WAR*CH1(2,M2,KI,J)
                      CC1(2,M1,KI,LC) = CC1(2,M1,KI,LC) +
     +                                  WAI*CH1(2,M2,KI,JC)
  114         CONTINUE
  115     CONTINUE
  116 CONTINUE
      IF (IDO.GT.1) GO TO 136
      SN = 1.D0/DBLE(IP*L1)
      IF (NA.EQ.1) GO TO 146
      DO 149 KI = 1,LID
          M2 = M2S
          DO 149 M1 = 1,M1D,IM1
              M2 = M2 + IM2
              CC1(1,M1,KI,1) = SN*CC1(1,M1,KI,1)
              CC1(2,M1,KI,1) = SN*CC1(2,M1,KI,1)
  149 CONTINUE
      DO 120 J = 2,IPPH
          JC = IPP2 - J
          DO 119 KI = 1,LID
              DO 119 M1 = 1,M1D,IM1
                  CHOLD1 = SN* (CC1(1,M1,KI,J)-CC1(2,M1,KI,JC))
                  CHOLD2 = SN* (CC1(1,M1,KI,J)+CC1(2,M1,KI,JC))
                  CC1(1,M1,KI,J) = CHOLD1
                  CC1(2,M1,KI,JC) = SN* (CC1(2,M1,KI,J)-CC1(1,M1,KI,JC))
                  CC1(2,M1,KI,J) = SN* (CC1(2,M1,KI,J)+CC1(1,M1,KI,JC))
                  CC1(1,M1,KI,JC) = CHOLD2
  119     CONTINUE
  120 CONTINUE
      RETURN
  146 DO 147 KI = 1,LID
          M2 = M2S
          DO 147 M1 = 1,M1D,IM1
              M2 = M2 + IM2
              CH1(1,M2,KI,1) = SN*CC1(1,M1,KI,1)
              CH1(2,M2,KI,1) = SN*CC1(2,M1,KI,1)
  147 CONTINUE
      DO 145 J = 2,IPPH
          JC = IPP2 - J
          DO 144 KI = 1,LID
              M2 = M2S
              DO 144 M1 = 1,M1D,IM1
                  M2 = M2 + IM2
                  CH1(1,M2,KI,J) = SN* (CC1(1,M1,KI,J)-CC1(2,M1,KI,JC))
                  CH1(2,M2,KI,J) = SN* (CC1(2,M1,KI,J)+CC1(1,M1,KI,JC))
                  CH1(1,M2,KI,JC) = SN* (CC1(1,M1,KI,J)+CC1(2,M1,KI,JC))
                  CH1(2,M2,KI,JC) = SN* (CC1(2,M1,KI,J)-CC1(1,M1,KI,JC))
  144     CONTINUE
  145 CONTINUE
      RETURN
  136 DO 137 KI = 1,LID
          M2 = M2S
          DO 137 M1 = 1,M1D,IM1
              M2 = M2 + IM2
              CH1(1,M2,KI,1) = CC1(1,M1,KI,1)
              CH1(2,M2,KI,1) = CC1(2,M1,KI,1)
  137 CONTINUE
      DO 135 J = 2,IPPH
          JC = IPP2 - J
          DO 134 KI = 1,LID
              M2 = M2S
              DO 134 M1 = 1,M1D,IM1
                  M2 = M2 + IM2
                  CH1(1,M2,KI,J) = CC1(1,M1,KI,J) - CC1(2,M1,KI,JC)
                  CH1(2,M2,KI,J) = CC1(2,M1,KI,J) + CC1(1,M1,KI,JC)
                  CH1(1,M2,KI,JC) = CC1(1,M1,KI,J) + CC1(2,M1,KI,JC)
                  CH1(2,M2,KI,JC) = CC1(2,M1,KI,J) - CC1(1,M1,KI,JC)
  134     CONTINUE
  135 CONTINUE
      DO 131 I = 1,IDO
          DO 130 K = 1,L1
              M2 = M2S
              DO 130 M1 = 1,M1D,IM1
                  M2 = M2 + IM2
                  CC(1,M1,K,1,I) = CH(1,M2,K,I,1)
                  CC(2,M1,K,1,I) = CH(2,M2,K,I,1)
  130     CONTINUE
  131 CONTINUE
      DO 123 J = 2,IP
          DO 122 K = 1,L1
              M2 = M2S
              DO 122 M1 = 1,M1D,IM1
                  M2 = M2 + IM2
                  CC(1,M1,K,J,1) = CH(1,M2,K,1,J)
                  CC(2,M1,K,J,1) = CH(2,M2,K,1,J)
  122     CONTINUE
  123 CONTINUE
      DO 126 J = 2,IP
          DO 125 I = 2,IDO
              DO 124 K = 1,L1
                  M2 = M2S
                  DO 124 M1 = 1,M1D,IM1
                      M2 = M2 + IM2
                      CC(1,M1,K,J,I) = WA(I,J-1,1)*CH(1,M2,K,I,J) +
     +                                 WA(I,J-1,2)*CH(2,M2,K,I,J)
                      CC(2,M1,K,J,I) = WA(I,J-1,1)*CH(2,M2,K,I,J) -
     +                                 WA(I,J-1,2)*CH(1,M2,K,I,J)
  124         CONTINUE
  125     CONTINUE
  126 CONTINUE
      RETURN
      END

C
C
C       $Id: terp1.f,v 1.1 1994-08-11 23:17:36 boote Exp $
C
C PACKAGE CUBSPL         NOTE--DOCUMENTATION FOR INDIVIDUAL ROUTINES
C                              FOLLOWS THE GENERAL PACKAGE INFORMATION
C
C LATEST REVISION        JANUARY 1985
C
C PURPOSE                TO PERFORM ONE AND TWO-DIMENSIONAL CUBIC SPLINE
C                        INTERPOLATION WITH CHOICE OF BOUNDARY
C                        CONDITIONS.  THE FUNCTION AND SELECTED
C                        DERIVATIVES MAY BE EVALUATED AT ANY POINT WHERE
C                        INTERPOLATION IS REQUIRED.  IN THE
C                        TWO-DIMENSIONAL CASE, THE GIVEN DATA POINTS
C                        MUST BE ON A RECTANGULAR GRID, WHICH NEED NOT
C                        BE EQUALLY SPACED.  THE PACKAGE CUBSPL CONTAINS
C                        SEVEN ROUTINES.
C
C                        SUBROUTINE COEFF1
C                          COMPUTES THE COEFFICIENTS FOR ONE-DIMENSIONAL
C                          CUBIC SPLINE INTERPOLATION USING ONE OF
C                          THE FOLLOWING BOUNDARY CONDITIONS AT
C                          EACH END OF THE RANGE.
C                            . SECOND DERIVATIVE GIVEN AT BOUNDARY.
C                            . FIRST DERIVATIVE GIVEN AT BOUNDARY.
C                            . PERIODIC BOUNDARY CONDITION.
C                            . FIRST DERIVATIVE DETERMINED BY FITTING A
C                              CUBIC TO THE FOUR POINTS NEAREST TO THE
C                              BOUNDARY.
C
C                        SUBROUTINE TERP1
C                          USING THE COEFFICIENTS COMPUTED BY COEFF1,
C                          THIS ROUTINE EVALUATES THE FUNCTION AND/OR
C                          FIRST AND SECOND DERIVATIVES AT ANY POINT
C                          WHERE INTERPOLATION IS REQUIRED.
C
C                        SUBROUTINE COEFF2
C                          COMPUTES THE COEFFICIENTS FOR TWO-DIMENSIONAL
C                          BICUBIC SPLINE INTERPOLATION WITH THE SAME
C                          CHOICE OF BOUNDARY CONDITIONS AS FOR COEFF1.
C
C                        FUNCTION TERP2
C                          USING THE COEFFICIENTS PRODUCED BY COEFF2,
C                          THIS SUBROUTINE EVALUATES THE FUNCTION OR A
C                          SELECTED DERIVATIVE AT ANY POINT WHERE
C                          TWO-DIMENSIONAL INTERPOLATION IS REQUIRED.
C
C                        SUBROUTINE TRIP
C                          A SIMPLE PERIODIC, TRIDIAGONAL LINEAR
C                          EQUATION SOLVER USED BY COEFF1.
C
C                        SUBROUTINE SEARCH
C                          PERFORMS A BINARY SEARCH IN A ONE-DIMENSIONAL
C                          FLOATING POINT TABLE ARRANGED IN ASCENDING
C                          ORDER.  THIS ROUTINE IS CALLED BY TERP1 AND
C                          TERP2.
C
C                        SUBROUTINE INTERP
C                          GIVEN COEFFICIENTS PROVIDED BY COEFF1 AND THE
C                          POSITION OF THE INTERPOLATION POINT IN THE
C                          INDEPENDENT VARIABLE TABLE, THIS ROUTINE
C                          PERFORMS ONE-DIMENSIONAL INTERPOLATION FOR
C                          THE FUNCTION VALUE, FIRST AND SECOND
C                          DERIVATIVE, AS DESIRED.  THIS ROUTINE IS
C                          CALLED BY TERP1 AND TERP2.
C
C USAGE                  FOR ONE-DIMENSIONAL CUBIC SPLINE INTERPOLATION,
C                        THE USER FIRST CALLS COEFF1 BY
C
C                          CALL COEFF1 (N,X,F,W,IOP,INT,WK)
C
C                        THIS SUBROUTINE RETURNS THE COEFFICIENTS
C                        NEEDED FOR THE SUBSEQUENT INTERPOLATION
C                        IN THE ARRAY W.  THE USER THEN CALLS
C                        SUBROUTINE TERP1 BY
C
C                          CALL TERP1 (N,X,F,W,Y,INT,TAB,ITAB)
C
C                        IN ORDER TO COMPUTE THE VALUE OF THE
C                        FUNCTION AND/OR ITS DERIVATIVES.  THE USER
C                        SPECIFIES Y, THE VALUE OF THE INDEPENDENT
C                        VARIABLE WHERE THE INTERPOLATION IS TO BE
C                        PERFORMED.  THE INTERPOLATED VALUES ARE
C                        RETURNED IN TAB.  THE PARAMETERS
C                        N,X,F,W, AND INT MUST NOT BE CHANGED
C                        BETWEEN THE SUBROUTINE CALLS.
C
C                        FOR TWO-DIMENSIONAL CUBIC SPLINE INTERPOLATION
C                        THE USER FIRST CALLS COEFF2 BY
C
C                          CALL COEFF2 (NX,X,NY,Y,F,FXX,FYY,FXXYY,
C                                       IDM,IBD,WK)
C
C                        THIS SUBROUTINE RETURNS THE COEFFICIENTS
C                        NEEDED FOR THE SUBSEQUENT INTERPOLATION IN
C                        THE ARRAYS FXX, FYY, FXXYY.  THE USER THEN
C                        CALLS THE ROUTINE TERP2 BY
C
C                          R = TERP2 (XB,YB,NX,X,NY,Y,F,FXX,FYY,FXXYY,
C                                     IDM,IXD,IYD)
C
C                        IN ORDER TO PERFORM THE INTERPOLATION AT THE
C                        POINT SPECIFIED BY THE VALUES OF XB AND YB.
C                        DEPENDING ON THE VALUES INPUT IN IXD AND IYD,
C                        THE ROUTINE RETURNS AN INTERPOLATED VALUE
C                        FOR THE FUNCTION OR ONE OF ITS PARTIAL
C                        DERIVATIVES.  THE PARAMETERS NX,X,NY,Y,F,FXX,
C                        FYY,FXXYY, AND IDM MUST NOT BE CHANGED
C                        BETWEEN THE CALLS TO COEFF2 AND TERP2.
C
C SPECIAL CONDITIONS     TABLES OF INDEPENDENT VARIABLES MUST BE
C                        ARRANGED IN ASCENDING ORDER.  FOR
C                        TWO-DIMENSIONAL INTERPOLATION, THE DATA POINTS
C                        MUST LIE ON A RECTANGULAR MESH.
C
C I/O                    NONE
C
C PRECISION              SINGLE
C
C REQUIRED LIBRARY       NONE
C FILES
C
C LANGUAGE               FORTRAN
C
C HISTORY                THIS PACKAGE IS BASED ON THE ROUTINES
C                            LA E 102A, SPL1D1
C                            LA E 103A, SPL1D2
C                            LA E 104A, SPL2D1
C                            LA E 105A, SPL2D2
C                        OF THE LOS ALAMOS CUBIC SPLINE PACKAGE WRITTEN
C                        BY THOMAS J. JORDAN AND BERTHA FAGAN, 1968.
C                        THE ROUTINES HAVE BEEN STREAMLINED AND
C                        STANDARDIZED.  THE ALGORITHM FOR
C                        TWO-DIMENSIONAL INTERPOLATION IS CONSIDERABLY
C                        MODIFIED.
C
C ALGORITHM              FOR ONE-DIMENSIONAL INTERPOLATION, THE CUBIC
C                        SPLINE IS EXPRESSED IN TERMS OF THE FUNCTION
C                        VALUES AND SECOND DERIVATIVES AT THE DATA
C                        POINTS.  THE SECOND DERIVATIVES ARE
C                        DETERMINED FROM A TRIDIAGONAL LINEAR SYSTEM
C                        WHICH DESCRIBES THE CONTINUITY OF THE FIRST
C                        DERIVATIVE AND INCORPORATES THE GIVEN
C                        BOUNDARY CONDITIONS.  COEFF1  SETS UP THIS
C                        SYSTEM AND CALLS SUBROUTINE TRIP TO SOLVE IT.
C
C                        THE CUBIC SEGMENT BETWEEN TWO ADJACENT
C                        TABULAR POINTS IS CONSTRUCTED FROM THE
C                        FUNCTION VALUES AND SECOND DERIVATIVES AT
C                        THESE POINTS.  THESE PROVIDE THE FOUR
C                        CONSTANTS NEEDED TO DEFINE THE CUBIC
C                        UNIQUELY.  FROM THIS CUBIC, VALUES OF THE
C                        FUNCTION AND ITS FIRST AND SECOND
C                        DERIVATIVES ARE READILY DETERMINED AT ANY
C                        INTERMEDIATE POINT.  ONE-DIMENSIONAL
C                        INTERPOLATION IS PERFORMED BY THE ROUTINE
C                        TERP1.  FOR TWO-DIMENSIONAL INTERPOLATION,
C                        THE BICUBIC SPLINE IS DESCRIBED IN TERMS OF
C                        VALUES OF F,FXX,FYY, AND FXXYY  AT EACH
C                        POINT ON THE GIVEN TWO-DIMENSIONAL
C                        RECTANGULAR GRID OF DATA POINTS.  HERE F
C                        IS THE FUNCTION VALUE,
C
C                          FXX = (D/DX)**2*F
C
C                        AND SO ON.  THE COEFFICIENTS ARE DETERMINED
C                        BY COEFF2, WHICH USES SUCCESSIVE
C                        APPLICATIONS OF COEFF1.
C
C                        1.  THE ARRAY FXX IS DETERMINED BY APPLYING
C                            COEFF1 TO F ALONG EACH LINE IN THE
C                            X-DIRECTION.
C
C                        2.  THE ARRAY FYY IS DETERMINED BY APPLYING
C                            COEFF1 TO F ALONG EACH LINE IN THE
C                            Y-DIRECTION.
C
C                        3.  FXXYY IS DETERMINED ON THE CONSTANT Y
C                            BOUNDARIES BY APPLYING COEFF1 TO FYY
C                            ALONG THESE BOUNDARIES.
C
C                        4.  THE REMAINDER OF THE ARRAY FXXYY IS
C                            DETERMINED BY APPLYING COEFF1 TO FXX
C                            ALONG EACH LINE IN THE Y-DIRECTION.
C
C                        THE BICUBIC WITHIN ANY RECTANGULAR ELEMENT
C                        OF THE GRID IS CONSTRUCTED FROM THE VALUES
C                        OF F,FXX,FYY,FXXYY AT THE FOUR CORNERS.
C                        THESE PROVIDE THE 16 CONSTANTS NECESSARY
C                        TO DEFINE THE BICUBIC UNIQUELY.  TO FIND
C                        THE VALUE OF F CORRESPONDING TO A POINT
C                        (XB,YB) WITHIN THE ELEMENTARY RECTANGLE,
C                        (X(I),Y(J)),(X(I+1),Y(J)),(X(I),Y(J+1)),
C                        (X(I+1),Y(J+1)), FIVE ONE DIMENSIONAL
C                        INTERPOLATIONS ARE PERFORMED.
C
C                        1.  F AT (XB,Y(J)) AND (XB,Y(J+1)) ARE
C                            FOUND BY INTERPOLATING F IN THE
C                            X-DIRECTION USING FXX. (TWO INTERPOLATIONS)
C
C                        2.  FYY AT (XB,Y(J)) AND (XB,Y(J+1)) ARE
C                            FOUND BY INTERPOLATING FYY IN THE
C                            X-DIRECTION USING FXXYY. (TWO
C                            INTERPOLATIONS.)
C
C                        3.  FINALLY F AT (XB,YB) IS FOUND BY
C                        INTERPOLATING BETWEEN F(XB,Y(J)) AND
C                        F(XB,Y(J+1)) IN THE Y-DIRECTION USING
C                        VALUES OF FYY(XB,Y(J)) AND FYY(XB,Y(J+1))
C                        OBTAINED ABOVE. (ONE INTERPOLATION).
C
C                        TWO-DIMENSIONAL INTERPOLATION IS PERFORMED
C                        IN TERP2.
C
C REFERENCES             FOR GREATER DETAIL, SEE J.L.WALSH,
C                        J.H.AHLBERG, E.N.NILSEN, BEST APPROXIMATION
C                        PROPERTIES OF THE SPLINE FIT, JOURNAL OF
C                        MATHEMATICS AND MECHANICS, VOL.II(1962),
C                        225-234.
C
C                        T.L. JORDAN, SMOOTHING AND MULTIVARIABLE
C                        INTERPOLATION WITH SPLINES, LOS ALAMOS
C                        REPORT, LA-3137, 1965.
C
C ACCURACY               NEAR MACHINE ACCURACY WAS OBTAINED WHEN
C                        INTERPOLATING A CUBIC IN ONE DIMENSION
C                        OR A BICUBIC IN TWO DIMENSIONS.
C
C PORTABILITY            FULLY PORTABLE WITH RESPECT TO FORTRAN 66.
C***********************************************************************
C
C SUBROUTINE COEFF1 (N,X,F,W,IOP,INT,WK)
C
C DIMENSION OF           X(N),F(INT*(N-1)+1),W(INT*(N-1)+1),IOP(2),
C ARGUMENTS              WK(3*N+1)
C
C PURPOSE                SUBROUTINE COEFF1 COMPUTES THE COEFFICIENTS
C                        FOR ONE-DIMENSIONAL CUBIC SPLINE
C                        INTERPOLATION USING ONE OF THE FOLLOWING
C                        BOUNDARY CONDITIONS AT EACH END OF THE
C                        RANGE
C
C                        .  SECOND DERIVATIVES GIVEN AT BOUNDARY
C                        .  FIRST DERIVATIVE GIVEN AT BOUNDARY
C                        .  PERIODIC BOUNDARY CONDITIONS
C                        .  FIRST DERIVATIVE CALCULATED BY FITTING A
C                           CUBIC TO THE FOUR POINTS NEAREST TO THE
C                           BOUNDARY
C
C                        NOTE THAT TERP1 MUST BE CALLED TO PERFORM
C                        THE INTERPOLATION.
C
C USAGE                  CALL COEFF1 (N,X,F,W,IOP,INT,WK)
C
C ARGUMENTS
C
C ON INPUT               N
C                          THE NUMBER OF DATA POINTS.  N MUST BE AT
C                          LEAST 4.
C
C                        X
C                          TABLE OF N INDEPENDENT VARIABLE VALUES IN
C                          ASCENDING ORDER.  DIMENSION OF X IN CALLING
C                          PROGRAM MUST BE AT LEAST N.
C
C                        F
C                          TABLE OF N CORRESPONDING DEPENDENT VARIABLE
C                          VALUES.  THE VALUES ARE SEPARATED BY INTERVAL
C                          INT.  THIS IS USUALLY UNITY FOR
C                          ONE-DIMENSIONAL INTERPOLATION.  OTHER VALUES
C                          ARE USEFUL WHEN COEFF1 IS INCORPORATED IN A
C                          TWO-DIMENSIONAL INTERPOLATION SCHEME (SEE
C                          COEFF2).  DIMENSION OF F IN THE CALLING
C                          PROGRAM MUST BE AT LEAST (INT*(N-1)+1).
C
C                        IOP
C                          TWO ELEMENT INTEGER ARRAY DEFINING BOUNDARY
C                          CONDITIONS AT X(1) AND X(N) ACCORDING TO THE
C                          FOLLOWING CODE.
C
C                          FOR IOP(1)
C                          = 1  SECOND DERIVATIVE GIVEN AT X(1).  PLACE
C                               VALUE OF SECOND DERIVATIVE IN W(1)
C                               BEFORE CALL TO COEFF1.
C                          = 2  FIRST DERIVATIVE GIVEN AT X(1).  PLACE
C                               VALUE OF FIRST DERIVATIVE IN W(1) BEFORE
C                               CALL.
C                          = 3  PERIODIC BOUNDARY CONDITION.  X(1) AND
C                               X(N) ARE EQUIVALENT POINTS.  F(1) AND
C                               F(INT*(N-1)+1) ARE EQUAL.
C                          = 4  THE FIRST DERIVATIVE AT X(1) IS
C                               CALCULATED BY FITTING A CUBIC TO POINTS
C                               X(1) THROUGH X(4).
C                          SIMILARLY, IOP(2) DEFINES THE BOUNDARY
C                          CONDITION AT X(N).  WHEN IOP(2) = 1 (OR 2),
C                          THE VALUE OF THE SECOND (OR FIRST) DERIVATIVE
C                          MUST BE PLACED IN W(INT*(N-1)+1).  NOTE THAT
C                          IF IOP(1) = 3, CONSISTENCY DEMANDS THAT
C                          IOP(2) = 3 ALSO.
C
C                        INT
C                          SPACING IN F AND W TABLES.  FOR
C                          ONE-DIMENSIONAL INTERPOLATION THIS WILL
C                          USUALLY BE UNITY.
C
C                        WK
C                          WORK AREA OF DIMENSION AT LEAST (3*N+1).
C
C ON OUTPUT              W
C                          TABLE OF SECOND DERIVATIVES CORRESPONDING TO
C                          GIVEN X AND F VALUES.  THE SEPARATION OF
C                          TABULAR ENTRIES IS INT (SEE ABOVE).
C                          DIMENSION OF W IN THE CALLING PROGRAM MUST BE
C                          AT LEAST (INT*(N-1)+1).
C
C                          THE ARRAYS X, F, W ARE USED AS INPUT FOR THE
C                          ROUTINE TERP1, WHICH PERFORMS INTERPOLATION
C                          AT A GIVEN VALUE OF THE INDEPENDENT VARIABLE.
C
C TIMING                 THE TIMING IS LINEARLY PROPORTIONAL TO N, THE
C                        NUMBER OF DATA POINTS.
C***********************************************************************
C
C     SUBROUTINE TERP1 (N,X,F,W,Y,INT,TAB,ITAB)
C
C
C DIMENSION OF           X(N),F(INT*(N-1)+1),W(INT*(N-1)+1),TAB(3),
C ARGUMENTS              ITAB(3)
C
C PURPOSE                USING THE COEFFICIENTS COMPUTED BY COEFF1,
C                        THIS ROUTINE EVALUATES THE FUNCTION AND/OR
C                        FIRST AND SECOND DERIVATIVES AT ANY POINT.
C
C USAGE                  CALL TERP1 (N,X,F,W,Y,INT,TAB,ITAB)
C
C ARGUMENTS
C
C ON INPUT               N
C                          THE NUMBER OF DATA POINTS.  N MUST BE AT
C                          LEAST 4.
C
C                        X
C                          TABLE OF N INDEPENDENT VARIABLE VALUES IN
C                          ASCENDING ORDER.  DIMENSION OF X IN THE
C                          CALLING PROGRAM MUST BE AT LEAST N.
C
C                        F
C                          TABLE OF N CORRESPONDING DEPENDENT VARIABLE
C                          VALUES SEPARATED BY INTERVAL INT, USUALLY
C                          UNITY FOR ONE-DIMENSIONAL INTERPOLATION.
C                          DIMENSION OF F IN THE CALLING PROGRAM MUST BE
C                          AT LEAST (INT*(N-1)+1).
C
C                        W
C                          TABLE OF SECOND DERIVATIVES COMPUTED BY
C                          COEFF1.  THE SEPARATION OF TABULAR ENTRIES IS
C                          INT.  DIMENSION OF W IN THE CALLING PROGRAM
C                          MUST BE AT LEAST (INT*(N-1)+1).
C
C                        Y
C                          VALUE OF THE INDEPENDENT VARIABLE AT WHICH
C                          INTERPOLATION IS REQUIRED.  IF Y LIES OUTSIDE
C                          THE RANGE OF THE TABLE, EXTRAPOLATION TAKES
C                          PLACE.
C
C                        INT
C                          SPACING OF TABULAR ENTRIES IN F AND W ARRAYS.
C                          THIS IS USUALLY UNITY FOR ONE-DIMENSIONAL
C                          INTERPOLATION.
C
C                        ITAB
C                          THREE ELEMENT INTEGER ARRAY DEFINING
C                          INTERPOLATION TO BE PERFORMED AT Y.
C                            IF ITAB(1) = 1, THE FUNCTION VALUE IS
C                                            RETURNED IN TAB(1).
C                            IF ITAB(2) = 1, THE FIRST DERIVATIVE IS
C                                            RETURNED IN TAB(2).
C                            IF ITAB(3) = 1, THE SECOND DERIVATIVE IS
C                                            RETURNED IN TAB(3).
C                          IF ITAB(I) = 0 FOR I = 1, 2 OR 3, THE
C                          CORRESPONDING FUNCTION VALUE OR DERIVATIVE IS
C                          NOT COMPUTED AND TAB(I) IS NOT REFERENCED.
C
C ON OUTPUT              TAB
C                          THREE ELEMENT ARRAY IN WHICH INTERPOLATED
C                          FUNCTION VALUE, FIRST AND SECOND DERIVATIVES
C                          ARE RETURNED AS DICTATED BY ITAB (SEE ABOVE).
C
C TIMING                 THIS PROCEDURE IS FAST.  THE MAXIMUM TIME FOR
C                        THE BINARY SEARCH IS PROPORTIONAL TO ALOG(N).
C                        THE TIME FOR FUNCTION AND DERIVATIVE EVALUATION
C                        IS INDEPENDENT OF N.
C***********************************************************************
C
C     SUBROUTINE COEFF2 (NX,X,NY,Y,F,FXX,FYY,FXXYY,IDM,IBD,WK)
C
C
C DIMENSION OF           X(NX),Y(NY),F(IDM,NY),FXX(IDM,NY),FYY(IDM,NY),
C ARGUMENTS              FXXYY(IDM,NY),IBD(4),WK(3*MAX0(NX,NY)+1)
C                        (IDM MUST BE .GE. NX)
C
C PURPOSE                SUBROUTINE COEFF2 COMPUTES THE COEFFICIENTS
C                        FOR TWO-DIMENSIONAL BICUBIC SPLINE
C                        INTERPOLATION WITH THE SAME CHOICE OF
C                        BOUNDARY CONDITIONS AS FOR COEFF1.  TERP2
C                        IS CALLED TO PERFORM INTERPOLATION.
C
C USAGE                  CALL COEFF2 (NX,X,NY,Y,F,FXX,FYY,FXXYY,IDM,IBD,
C                                     WK)
C
C ARGUMENTS
C
C ON INPUT               NX
C                          NUMBER OF GRID POINTS IN THE X-DIRECTION.  NX
C                          MUST BE AT LEAST 4.
C
C                        X
C                          TABLE OF NX VALUES OF THE FIRST INDEPENDENT
C                          VARIABLE ARRANGED IN ASCENDING ORDER.
C                          DIMENSION OF X IN THE CALLING PROGRAM MUST BE
C                          AT LEAST NX.
C
C                        NY
C                          NUMBER OF GRID POINTS IN THE Y-DIRECTION.  NY
C                          MUST BE AT LEAST 4.
C
C                        Y
C                          TABLE OF NY VALUES OF THE SECOND INDEPENDENT
C                          VARIABLE ARRANGED IN ASCENDING ORDER.
C                          DIMENSION OF Y IN THE CALLING PROGRAM MUST BE
C                          AT LEAST NY.
C
C                        F
C                          TWO DIMENSIONAL ARRAY OF FUNCTION VALUES AT
C                          THE GRID POINTS DEFINED BY THE ARRAYS X AND
C                          Y.  DIMENSION OF F IN THE CALLING PROGRAM IS
C                          (IDM, NYY) WHERE
C                              IDM .GE. NX
C                              NYY .GE. NY
C
C                        IDM
C                          FIRST DIMENSION IN THE CALLING PROGRAM OF
C                          ARRAYS F, FXX, FYY, FXXYY.  IDM MUST BE AT
C                          LEAST NX.
C
C                        IBD
C                          FOUR ELEMENT INTEGER ARRAY DEFINING BOUNDARY
C                          CONDITIONS ACCORDING TO THE FOLLOWING CODE.
C                          FOR IBD(1)
C                          = 1  THE SECOND DERIVATIVE OF F WITH RESPECT
C                               TO X IS GIVEN AT (X(1),Y(J)) FOR
C                               J = 1,NY,1.  VALUES OF THIS SECOND
C                               DERIVATIVE MUST BE PLACED IN FXX(1,J)
C                               FOR J = 1,NY,1, BEFORE CALLING COEFF2.
C                          = 2  THE FIRST DERIVATIVE OF F WITH RESPECT
C                               TO X IS GIVEN AT (X(1),Y(J)) FOR
C                               J = 1,NY,1.  VALUES OF THE DERIVATIVE
C                               MUST BE PLACED IN FXX(1,J) FOR
C                               J = 1,NY,1 BEFORE CALLING COEFF2.
C                          = 3  PERIODIC BOUNDARY CONDITION IN THE
C                               X-DIRECTION.  (X(1),Y(J)) AND
C                               AND (X(NX),Y(J)) ARE EQUIVALENT POINTS
C                               FOR J = 1,NY,1.  F(1,J) AND F(NX,J) ARE
C                               EQUAL.
C                          = 4  THE FIRST DERIVATIVE OF F WITH RESPECT
C                               TO X AT (X(1),Y(J)) IS COMPUTED BY
C                               FITTING A CUBIC TO F(1,J) THROUGH F(4,J)
C                               FOR J = 1,NY,1.
C
C                          SIMILARLY, IBD(2) DEFINES THE BOUNDARY
C                          CONDITION AT (X(NX),Y(J)) FOR J = 1,NY,1.
C                          WHEN IBD(2) = 1 (OR 2) THE VALUES OF THE
C                          SECOND (OR FIRST) DERIVATIVE OF F WITH
C                          RESPECT TO X ARE PLACED IN FXX(NX,J) FOR
C                          J = 1,NY,1.
C                            NOTE THAT IF IBD(1) = 3, CONSISTENCY
C                            REQUIRES THAT IBD(2) = 3 ALSO.
C                          FOR IBD(3)
C                          = 1  THE SECOND DERIVATIVE OF F WITH RESPECT
C                               TO Y IS GIVEN AT (X(I),Y(1)).  PLACE
C                               VALUES OF THE DERIVATIVE IN FYY(I,1) FOR
C                               I = 1,NX,1 BEFORE CALLING COEFF2.
C                          = 2  THE FIRST DERIVATIVE OF F WITH RESPECT
C                               TO Y IS GIVEN AT (X(I),Y(1)).  VALUES OF
C                               THIS DERIVATIVE MUST BE PLACED IN
C                               FYY(I,1) FOR I = 1,NX,1 BEFORE CALLING
C                               COEFF2.
C                          = 3  PERIODIC BOUNDARY CONDITION IN THE
C                               Y-DIRECTION.  (X(I),Y(1)) AND
C                               (X(I),Y(NY)) ARE EQUIVALENT POINTS.
C                               F(I,1) AND F(I,NY) ARE EQUAL.
C                          = 4  THE FIRST DERIVATIVE OF F WITH RESPECT
C                               TO Y AT (X(I),Y(1)) IS COMPUTED BY
C                               FITTING A CUBIC TO F(I,1) THROUGH F(I,4)
C                               FOR I = 1,NX,1.
C
C                          SIMILARY, IBD(4) DEFINES THE BOUNDARY
C                          CONDITION AT (X(I),Y(NY)) FOR I = 1,NX,1 AND
C                          GIVEN DERIVATIVE VALUES ARE PLACED IN
C                          FYY(I,NY).
C                            NOTE THAT CONSISTENCY DEMANDS THAT IF
C                            IBD(3) = 3, THEN IBD(4) = 3 ALSO.
C
C                        WK
C                          WORK AREA OF DIMENSION AT LEAST
C                          (3*MAX0(NX,NY)+1)
C
C ON OUTPUT              FXX
C                          ARRAY OF SECOND DERIVATIVES OF F WITH RESPECT
C                          TO X COMPUTED BY COEFF2.  FXX(I,J) IS
C                          DERIVATIVE AT (X(I),Y(J)).  AS FOR F,
C                          DIMENSION OF FXX IN THE CALLING PROGRAM IS
C                          (IDM,NYY).
C
C                        FYY
C                          ARRAY OF SECOND DERIVATIVES OF F WITH RESPECT
C                          TO Y COMPUTED BY COEFF2.  DIMENSION OF FYY IN
C                          THE CALLING PROGRAM IS (IDM,NYY).
C
C                        FXXYY
C                          ARRAY OF FOURTH DERIVATIVES
C                          (D/DX)**2*(D/DY)**2*F, COMPUTED BY COEFF2.
C                          DIMENSION OF FXXYY IN THE CALLING PROGRAM IS
C                          (IDM,NYY).
C
C                        THE ARRAYS X, Y, F, FXX, FYY, FXXYY ARE USED AS
C                        INPUT FOR THE ROUTINE TERP2 WHICH PERFORMS
C                        INTERPOLATION AT REQUIRED VALUES OF THE TWO
C                        INDEPENDENT VARIABLES.
C
C TIMING                 THE TIMING IS PROPORTIONAL TO NX*NY.
C***********************************************************************
C
C     FUNCTION TERP2 (XB,YB,NX,X,NY,Y,F,FXX,FYY,FXXYY,IDM,IXD,IYD)
C
C
C DIMENSION OF           X(NX),Y(NY),F(IDM,NY),FXX(IDM,NY),FYY(IDM,NY),
C ARGUMENTS              FXXYY(IDM,NY))
C                        (IDM MUST BE .GE. NX)
C
C PURPOSE                USING THE COEFFICIENTS PRODUCED BY COEFF2,
C                        THIS ROUTINE EVALUATES THE FUNCTION ON A
C                        SELECTED DERIVATIVE OF ANY POINT WHERE
C                        TWO-DIMENSIONAL INTERPOLATION IS REQUIRED.
C
C USAGE                  R = TERP2 (XB,YB,NX,X,NY,Y,F,FXX,FYY,FXXYY,IDM,
C                                   IXD,IYD)
C
C ARGUMENTS
C
C ON INPUT               XB, YB
C                          VALUES OF THE INDEPENDENT VARIABLES, X AND Y,
C                          AT WHICH INTERPOLATION IS REQUIRED.
C
C                        NX
C                          NUMBER OF GRID POINTS IN THE X-DIRECTION.  NX
C                          MUST BE AT LEAST 4.
C
C                        X
C                          TABLE OF NX VALUES OF THE INDEPENDENT
C                          VARIABLE, X, ARRANGED IN ASCENDING ORDER.
C                          DIMENSION OF X IN THE CALLING PROGRAM MUST BE
C                          AT LEAST NX.
C
C                        NY
C                          NUMBER OF GRID POINTS IN THE Y-DIRECTION.  NY
C                          MUST BE AT LEAST 4.
C
C                        Y
C                          TABLE OF NY VALUES OF THE INDEPENDENT
C                          VARIABLE, Y, ARRANGED IN ASCENDING ORDER.
C                          DIMENSION OF Y IN THE CALLING PROGRAM MUST BE
C                          AT LEAST NY.
C
C                        F
C                          TWO-DIMENSIONAL ARRAY OF FUNCTION VALUES AT
C                          GRID POINTS DEFINED BY THE ARRAYS X AND Y.
C                          DIMENSION OF F IN THE CALLING PROGRAM IS
C                          (IDM,NYY), WHERE
C                              IDM .GE. NX
C                              NYY .GE. NY
C
C                        FXX
C                          ARRAY OF SECOND DERIVATIVES OF F WITH RESPECT
C                          TO X COMPUTED BY COEFF2.  DIMENSION OF FXX IN
C                          THE CALLING PROGRAM IS (IDM,NYY).  SEE UNDER
C                          F ABOVE.
C
C                        FYY
C                          ARRAY OF SECOND DERIVATIVES OF F WITH RESPECT
C                          TO Y COMPUTED BY COEFF2.  DIMENSION OF FYY IN
C                          THE CALLING PROGRAM IS (IDM,NYY).
C
C                        FXXYY
C                          ARRAY OF FOURTH DERIVATIVES,
C                          (D/DX)**2*(D/DY)**2*F, COMPUTED BY COEFF2.
C                          DIMENSION OF FXXYY IN THE CALLING PROGRAM IS
C                          (IDM,NYY).
C
C                        IDM
C                          FIRST DIMENSION IN THE CALLING PROGRAM OF
C                          ARRAYS F, FXX, FYY AND FXXYY,
C                              IDM .GE. NX
C
C                        IXD, IYD
C                          DEFINE DERIVATIVE TO BE RETURNED BY THE
C                          FUNCTION TERP2.  IXD, IYD MAY EACH TAKE THE
C                          THE VALUES 0, 1, 2.  THE DERIVATIVE RETURNED
C                          IS (D/DX)**IXD*(D/DY)**IYD*F.
C                            NOTE THAT IF IXD = IYD = 0, THE FUNCTION
C                            VALUE ITSELF IS RETURNED.
C
C TIMING                 THIS PROCEDURE IS FAST.  THE MAXIMUM
C                        TIME FOR THE BINARY SEARCH IS PROPORTIONAL TO
C                        ALOG(NX*NY).  THE TIME FOR FUNCTION EVALUATION
C                        IS INDEPENDENT OF N.
C***********************************************************************
      SUBROUTINE TERP1 (N,X,F,W,Y,INT,TAB,ITAB)
C
      DIMENSION       X(1)       ,F(1)       ,W(1)       ,TAB(3)     ,
     1                ITAB(3)
      SAVE
C
C PERFORM SEARCH
C
      CALL SEARCH (Y,X,N,I)
C
C CARRY OUT INTERPOLATION (OR EXTRAPOLATION)
C
      CALL INTERP (N,X,F,W,Y,I,INT,TAB,ITAB)
      RETURN
      END

C NCLFORTSTART
       subroutine detcalc(a,n,det)
       implicit none
c                        input
       integer n
       double precision a(n,n)
c                        output
       double precision det
C NCLEND
c                        local (dynamic)
       integer indx(n)

       call dtrm(a,n,det,indx)

       return
       end
c=======================================================================

c Updated 10/24/2001.
c
ccccccccccccccccccccccccc     Program 4.2     cccccccccccccccccccccccccc
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c                                                                      c
c Please Note:                                                         c
c                                                                      c
c (1) This computer program is part of the book, "An Introduction to   c
c     Computational Physics," written by Tao Pang and published and    c
c     copyrighted by Cambridge University Press in 1997.               c
c                                                                      c
c (2) No warranties, express or implied, are made for this program.    c
c                                                                      c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
      SUBROUTINE DTRM(A,N,D,INDX)
      IMPLICIT NONE
C
C Subroutine for evaluating the determinant of a matrix using 
C the partial-pivoting Gaussian elimination scheme.
C
      INTEGER N
      DOUBLE PRECISION A(N,N), D
      INTEGER INDX(N)
C
      INTEGER I, J, MSGN

      CALL ELGS(A,N,INDX)
C
      D    = 1.0D0
      DO I = 1,N
         D = D*A(INDX(I),I)
      END DO   
C
      MSGN = 1
      DO I=1,N
        DO WHILE (I.NE.INDX(I))
           MSGN = -MSGN
           J = INDX(I)
           INDX(I) = INDX(J)
           INDX(J) = J
        END DO
      END DO
      D = MSGN*D
C
      RETURN
      END
C ---
      SUBROUTINE ELGS(A,N,INDX)
      IMPLICIT NONE
      INTEGER N
      DOUBLE PRECISION A(N,N),C(N)
      INTEGER INDX(N)
C
C Subroutine to perform the partial-pivoting Gaussian elimination.
C A(N,N) is the original matrix in the input and transformed
C matrix plus the pivoting element ratios below the diagonal in
C the output.  INDX(N) records the pivoting order.

      INTEGER I, J, K, ITMP
      DOUBLE PRECISION C1, PI1, PI, PJ
C
C Initialize the index
C
      DO I=1,N
        INDX(I) = I
      END DO
C
C Find the rescaling factors, one from each row
C
        DO I=1,N
          C1= 0.0D0
          DO J=1,N
             C1 = AMAX1(C1,ABS(A(I,J)))
          END DO
          C(I) = C1
        END DO
C
C Search the pivoting (largest) element from each column
C
      DO J=1,N-1
         PI1 = 0.0D0
        DO I=J,N
           PI = ABS(A(INDX(I),J))/C(INDX(I))
          IF (PI.GT.PI1) THEN
              PI1 = PI
              K   = I
          ELSE
          ENDIF
        END DO
C
C Interchange the rows via INDX(N) to record pivoting order
C
        ITMP    = INDX(J)
        INDX(J) = INDX(K)
        INDX(K) = ITMP
        DO I=J+1,N
          PJ  = A(INDX(I),J)/A(INDX(J),J)
C
C Record pivoting ratios below the diagonal
C
          A(INDX(I),J) = PJ
C
C Modify other elements accordingly
C
          DO K=J+1,N
            A(INDX(I),K) = A(INDX(I),K)-PJ*A(INDX(J),K)
          END DO
        END DO
      END DO
C
      RETURN
      END

C
C $Id: mdpfst.f,v 1.8 2008-09-18 00:42:17 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MDPFST (XLAT,XLON)
        DOUBLE PRECISION XLAT,XLON
        IF (ICFELL('MDPFST - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
        CALL MDPIT (XLAT,XLON,0)
        IF (ICFELL('MDPFST',2).NE.0) RETURN
        RETURN
      END

C
C	$Id: pwrygt.f,v 1.4 2008-07-27 00:17:22 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE PWRYGT (KCHAR,JCHAR,INDEX,NSIZE,IPOINT)
C
C THIS ROUTINE FINDS WHERE KCHAR IS IN JCHAR AND RETURNS THE CORRES-
C PONDING INDEX IN IPOINT.  BINARY HALVING IS USED.
C
      SAVE
      CHARACTER*1     JCHAR(NSIZE)   ,KCHAR
      DIMENSION       INDEX(NSIZE)
C
C IT IS ASSUMED THAT JCHAR IS LESS THAT 2**9 IN LENGTH, SO IF KCHAR IS
C NOT FOUND IN 10 STEPS, THE SEARCH IS STOPPED.
C
      KOUNT = 0
      IBOT = 1
      ITOP = NSIZE
      I = ITOP
      GO TO 102
  101 I = (IBOT+ITOP)/2
      KOUNT = KOUNT+1
      IF (KOUNT .GT. 10) GO TO 106
  102 IF (ICHAR(JCHAR(I))-ICHAR(KCHAR)) 103,105,104
  103 IBOT = I
      GO TO 101
  104 ITOP = I
      GO TO 101
  105 IPOINT = INDEX(I)
      RETURN
C
C IPOINT=-1 MEANS THAT KCHAR WAS NOT IN THE TABLE.
C
  106 IPOINT = -1
      RETURN
      END

C NCLFORTSTART
      SUBROUTINE KRONSQM (n,n2,A,B,C)
        IMPLICIT NONE
c                                                ! input
        INTEGER              n, n2 
        DOUBLE PRECISION     A(n,n), B(n,n)
c                                                ! output
        DOUBLE PRECISION     C(n2,n2)
C NCLEND
c computes the Kronecker product of square matrices A and B (dim=d), 
c puts into C (dim=n^2)
        INTEGER              i, j, k, l, row, col
      
        DO i=1,n
          DO k=1,n
            row=n*(i-1)+k
            DO j=1,n
              DO l=1,n
                col=n*(j-1)+l
                C(row,col)=A(i,j)*B(k,l)
              END DO
            END DO
          END DO
        END DO
      
        RETURN
      END 

C
C	$Id: gstxal.f,v 1.5 2008-07-27 00:21:02 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GSTXAL (TXALH,TXALV)
C
C  SET TEXT ALIGNMENT
C
      INTEGER ESTXAL
      PARAMETER (ESTXAL=34)
C
      include 'gkscom.h'
C
      INTEGER TXALH,TXALV
C
C  Check if GKS is in the proper state.
C
      CALL GZCKST(8,ESTXAL,IER)
      IF (IER .NE. 0) RETURN
C
C  Check that the arguments are valid.
C
      IF (TXALH.LT.0 .OR. TXALH.GT.3 .OR. TXALV.LT.0 .OR.
     +    TXALV.GT.5) THEN
        ERS = 1
        CALL GERHND(2000,ESTXAL,ERF)
        ERS = 0
        RETURN
      ENDIF
C
C  Set the current text alignment variables in the GKS state list.
C
      CTXAL(1) = TXALH
      CTXAL(2) = TXALV
C
C  Invoke the workstation interface.
C
      FCODE = 36
      CONT  = 0
      CALL GZROI(0)
      IL1   = 2
      IL2   = 2
      ID(1) = TXALH
      ID(2) = TXALV
      CALL GZTOWK
      IF (RERR .NE. 0) THEN
        ERS = 1
        CALL GERHND(RERR,ESTXAL,ERF)
        ERS = 0
      ENDIF
C
      RETURN
      END

C
C $Id: ezisos.f,v 1.5 2008-07-27 00:17:15 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE EZISOS (T,MU,MV,MW,EYE,SLAB,TISO)
C
C Arguments are as described in ISOSRF.
C
      DIMENSION T(MU,MV,MW),EYE(3)
C
      DATA ANG,PI / .35 , 3.14159265358979 /
C
C Pick types of lines to draw.
C
      NU = MU
      NV = MV
      NW = MW
      TVAL = TISO
      MAXN = MAX(NU,NV,NW)+2
      ATU = NU/2
      ATV = NV/2
      ATW = NW/2
      EYEU = EYE(1)
      EYEV = EYE(2)
      EYEW = EYE(3)
      RU = EYEU-ATU
      RV = EYEV-ATV
      RW = EYEW-ATW
      RU2 = RU*RU
      RV2 = RV*RV
      RW2 = RW*RW
      DU = SQRT(RV2+RW2)
      DV = SQRT(RU2+RW2)
      DW = SQRT(RU2+RV2)
      DR = 1./SQRT(RU2+RV2+RW2)
C
C Compute the arc cosine.
C
      TU = DU*DR
      ANGU = ATAN(ABS(SQRT(1.-TU*TU)/TU))
      IF (TU .LE. 0.) ANGU = PI-ANGU
      TV = DV*DR
      ANGV = ATAN(ABS(SQRT(1.-TV*TV)/TV))
      IF (TV .LE. 0.) ANGV = PI-ANGV
      TW = DW*DR
      ANGW = ATAN(ABS(SQRT(1.-TW*TW)/TW))
      IF (TW .LE. 0.) ANGW = PI-ANGW
C
C Breakpoint is about 20 degrees or about .35 radians.
C
      IFLAG = 0
      IF (ANGU .GT. ANG) IFLAG = IFLAG+4
      IF (ANGV .GT. ANG) IFLAG = IFLAG+2
      IF (ANGW .GT. ANG) IFLAG = IFLAG+1
C
C Find sign of IFLAG.
C
      ICNT = 0
      IF (ABS(RU) .LE. ATU) GO TO  30
      IU = 1
      IF (EYEU .GT. ATU) IU = NU
      DO  20 IW=1,NW
         DO  10 IV=1,NV
            IF (T(IU,IV,IW) .GT. TVAL) ICNT = ICNT-2
            ICNT = ICNT+1
   10    CONTINUE
   20 CONTINUE
   30 IF (ABS(RV) .LE. ATV) GO TO  60
      IV = 1
      IF (EYEV .GT. ATV) IV = NV
      DO  50 IW=1,NW
         DO  40 IU=1,NU
            IF (T(IU,IV,IW) .GT. TVAL) ICNT = ICNT-2
            ICNT = ICNT+1
   40    CONTINUE
   50 CONTINUE
   60 IF (ABS(RW) .LE. ATW) GO TO  90
      IW = 1
      IF (EYEW .GT. ATW) IW = NW
      DO  80 IV=1,NV
         DO  70 IU=1,NU
            IF (T(IU,IV,IW) .GT. TVAL) ICNT = ICNT-2
            ICNT = ICNT+1
   70    CONTINUE
   80 CONTINUE
   90 IFLAG = SIGN(IFLAG,ICNT)
      CALL ISOSRF (T,NU,NU,NV,NV,NW,EYE,MAXN,SLAB,TVAL,IFLAG)
      CALL FRAME
      RETURN
      END

      SUBROUTINE CLAHQR( WANTT, WANTZ, N, ILO, IHI, H, LDH, W, ILOZ,
     $                   IHIZ, Z, LDZ, INFO )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      LOGICAL            WANTT, WANTZ
      INTEGER            IHI, IHIZ, ILO, ILOZ, INFO, LDH, LDZ, N
*     ..
*     .. Array Arguments ..
      COMPLEX            H( LDH, * ), W( * ), Z( LDZ, * )
*     ..
*
*  Purpose
*  =======
*
*  CLAHQR is an auxiliary routine called by CHSEQR to update the
*  eigenvalues and Schur decomposition already computed by CHSEQR, by
*  dealing with the Hessenberg submatrix in rows and columns ILO to IHI.
*
*  Arguments
*  =========
*
*  WANTT   (input) LOGICAL
*          = .TRUE. : the full Schur form T is required;
*          = .FALSE.: only eigenvalues are required.
*
*  WANTZ   (input) LOGICAL
*          = .TRUE. : the matrix of Schur vectors Z is required;
*          = .FALSE.: Schur vectors are not required.
*
*  N       (input) INTEGER
*          The order of the matrix H.  N >= 0.
*
*  ILO     (input) INTEGER
*  IHI     (input) INTEGER
*          It is assumed that H is already upper triangular in rows and
*          columns IHI+1:N, and that H(ILO,ILO-1) = 0 (unless ILO = 1).
*          CLAHQR works primarily with the Hessenberg submatrix in rows
*          and columns ILO to IHI, but applies transformations to all of
*          H if WANTT is .TRUE..
*          1 <= ILO <= max(1,IHI); IHI <= N.
*
*  H       (input/output) COMPLEX array, dimension (LDH,N)
*          On entry, the upper Hessenberg matrix H.
*          On exit, if WANTT is .TRUE., H is upper triangular in rows
*          and columns ILO:IHI, with any 2-by-2 diagonal blocks in
*          standard form. If WANTT is .FALSE., the contents of H are
*          unspecified on exit.
*
*  LDH     (input) INTEGER
*          The leading dimension of the array H. LDH >= max(1,N).
*
*  W       (output) COMPLEX array, dimension (N)
*          The computed eigenvalues ILO to IHI are stored in the
*          corresponding elements of W. If WANTT is .TRUE., the
*          eigenvalues are stored in the same order as on the diagonal
*          of the Schur form returned in H, with W(i) = H(i,i).
*
*  ILOZ    (input) INTEGER
*  IHIZ    (input) INTEGER
*          Specify the rows of Z to which transformations must be
*          applied if WANTZ is .TRUE..
*          1 <= ILOZ <= ILO; IHI <= IHIZ <= N.
*
*  Z       (input/output) COMPLEX array, dimension (LDZ,N)
*          If WANTZ is .TRUE., on entry Z must contain the current
*          matrix Z of transformations accumulated by CHSEQR, and on
*          exit Z has been updated; transformations are applied only to
*          the submatrix Z(ILOZ:IHIZ,ILO:IHI).
*          If WANTZ is .FALSE., Z is not referenced.
*
*  LDZ     (input) INTEGER
*          The leading dimension of the array Z. LDZ >= max(1,N).
*
*  INFO    (output) INTEGER
*          = 0: successful exit
*          > 0: if INFO = i, CLAHQR failed to compute all the
*               eigenvalues ILO to IHI in a total of 30*(IHI-ILO+1)
*               iterations; elements i+1:ihi of W contain those
*               eigenvalues which have been successfully computed.
*
*  =====================================================================
*
*     .. Parameters ..
      COMPLEX            ZERO, ONE
      PARAMETER          ( ZERO = ( 0.0E+0, 0.0E+0 ),
     $                   ONE = ( 1.0E+0, 0.0E+0 ) )
      REAL               RZERO, HALF
      PARAMETER          ( RZERO = 0.0E+0, HALF = 0.5E+0 )
      REAL               DAT1
      PARAMETER          ( DAT1 = 0.75E+0 )
*     ..
*     .. Local Scalars ..
      INTEGER            I, I1, I2, ITN, ITS, J, K, L, M, NH, NZ
      REAL               H10, H21, RTEMP, S, SMLNUM, T2, TST1, ULP
      COMPLEX            CDUM, H11, H11S, H22, SUM, T, T1, TEMP, U, V2,
     $                   X, Y
*     ..
*     .. Local Arrays ..
      REAL               RWORK( 1 )
      COMPLEX            V( 2 )
*     ..
*     .. External Functions ..
      REAL               CLANHS, SLAMCH
      COMPLEX            CLADIV
      EXTERNAL           CLANHS, SLAMCH, CLADIV
*     ..
*     .. External Subroutines ..
      EXTERNAL           CCOPY, CLARFG, CSCAL
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, AIMAG, CONJG, MAX, MIN, REAL, SQRT
*     ..
*     .. Statement Functions ..
      REAL               CABS1
*     ..
*     .. Statement Function definitions ..
      CABS1( CDUM ) = ABS( REAL( CDUM ) ) + ABS( AIMAG( CDUM ) )
*     ..
*     .. Executable Statements ..
*
      INFO = 0
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
      IF( ILO.EQ.IHI ) THEN
         W( ILO ) = H( ILO, ILO )
         RETURN
      END IF
*
      NH = IHI - ILO + 1
      NZ = IHIZ - ILOZ + 1
*
*     Set machine-dependent constants for the stopping criterion.
*     If norm(H) <= sqrt(OVFL), overflow should not occur.
*
      ULP = SLAMCH( 'Precision' )
      SMLNUM = SLAMCH( 'Safe minimum' ) / ULP
*
*     I1 and I2 are the indices of the first row and last column of H
*     to which transformations must be applied. If eigenvalues only are
*     being computed, I1 and I2 are set inside the main loop.
*
      IF( WANTT ) THEN
         I1 = 1
         I2 = N
      END IF
*
*     ITN is the total number of QR iterations allowed.
*
      ITN = 30*NH
*
*     The main loop begins here. I is the loop index and decreases from
*     IHI to ILO in steps of 1. Each iteration of the loop works
*     with the active submatrix in rows and columns L to I.
*     Eigenvalues I+1 to IHI have already converged. Either L = ILO, or
*     H(L,L-1) is negligible so that the matrix splits.
*
      I = IHI
   10 CONTINUE
      IF( I.LT.ILO )
     $   GO TO 130
*
*     Perform QR iterations on rows and columns ILO to I until a
*     submatrix of order 1 splits off at the bottom because a
*     subdiagonal element has become negligible.
*
      L = ILO
      DO 110 ITS = 0, ITN
*
*        Look for a single small subdiagonal element.
*
         DO 20 K = I, L + 1, -1
            TST1 = CABS1( H( K-1, K-1 ) ) + CABS1( H( K, K ) )
            IF( TST1.EQ.RZERO )
     $         TST1 = CLANHS( '1', I-L+1, H( L, L ), LDH, RWORK )
            IF( ABS( REAL( H( K, K-1 ) ) ).LE.MAX( ULP*TST1, SMLNUM ) )
     $         GO TO 30
   20    CONTINUE
   30    CONTINUE
         L = K
         IF( L.GT.ILO ) THEN
*
*           H(L,L-1) is negligible
*
            H( L, L-1 ) = ZERO
         END IF
*
*        Exit from loop if a submatrix of order 1 has split off.
*
         IF( L.GE.I )
     $      GO TO 120
*
*        Now the active submatrix is in rows and columns L to I. If
*        eigenvalues only are being computed, only the active submatrix
*        need be transformed.
*
         IF( .NOT.WANTT ) THEN
            I1 = L
            I2 = I
         END IF
*
         IF( ITS.EQ.10 .OR. ITS.EQ.20 ) THEN
*
*           Exceptional shift.
*
            S = DAT1*ABS( REAL( H( I, I-1 ) ) )
            T = S + H( I, I ) 
         ELSE
*
*           Wilkinson's shift.
*
            T = H( I, I )
            U = H( I-1, I )*REAL( H( I, I-1 ) )
            IF( U.NE.ZERO ) THEN
               X = HALF*( H( I-1, I-1 )-T )
               Y = SQRT( X*X+U )
               IF( REAL( X )*REAL( Y )+AIMAG( X )*AIMAG( Y ).LT.RZERO )
     $            Y = -Y
               T = T - CLADIV( U, ( X+Y ) )
            END IF
         END IF
*
*        Look for two consecutive small subdiagonal elements.
*
         DO 40 M = I - 1, L + 1, -1
*
*           Determine the effect of starting the single-shift QR
*           iteration at row M, and see if this would make H(M,M-1)
*           negligible.
*
            H11 = H( M, M )
            H22 = H( M+1, M+1 )
            H11S = H11 - T
            H21 = H( M+1, M )
            S = CABS1( H11S ) + ABS( H21 )
            H11S = H11S / S
            H21 = H21 / S
            V( 1 ) = H11S
            V( 2 ) = H21
            H10 = H( M, M-1 )
            TST1 = CABS1( H11S )*( CABS1( H11 )+CABS1( H22 ) )
            IF( ABS( H10*H21 ).LE.ULP*TST1 )
     $         GO TO 50
   40    CONTINUE
         H11 = H( L, L )
         H22 = H( L+1, L+1 )
         H11S = H11 - T
         H21 = H( L+1, L )
         S = CABS1( H11S ) + ABS( H21 )
         H11S = H11S / S
         H21 = H21 / S
         V( 1 ) = H11S
         V( 2 ) = H21
   50    CONTINUE
*
*        Single-shift QR step
*
         DO 100 K = M, I - 1
*
*           The first iteration of this loop determines a reflection G
*           from the vector V and applies it from left and right to H,
*           thus creating a nonzero bulge below the subdiagonal.
*
*           Each subsequent iteration determines a reflection G to
*           restore the Hessenberg form in the (K-1)th column, and thus
*           chases the bulge one step toward the bottom of the active
*           submatrix.
*
*           V(2) is always real before the call to CLARFG, and hence
*           after the call T2 ( = T1*V(2) ) is also real.
*
            IF( K.GT.M )
     $         CALL CCOPY( 2, H( K, K-1 ), 1, V, 1 )
            CALL CLARFG( 2, V( 1 ), V( 2 ), 1, T1 )
            IF( K.GT.M ) THEN
               H( K, K-1 ) = V( 1 )
               H( K+1, K-1 ) = ZERO
            END IF
            V2 = V( 2 )
            T2 = REAL( T1*V2 )
*
*           Apply G from the left to transform the rows of the matrix
*           in columns K to I2.
*
            DO 60 J = K, I2
               SUM = CONJG( T1 )*H( K, J ) + T2*H( K+1, J )
               H( K, J ) = H( K, J ) - SUM
               H( K+1, J ) = H( K+1, J ) - SUM*V2
   60       CONTINUE
*
*           Apply G from the right to transform the columns of the
*           matrix in rows I1 to min(K+2,I).
*
            DO 70 J = I1, MIN( K+2, I )
               SUM = T1*H( J, K ) + T2*H( J, K+1 )
               H( J, K ) = H( J, K ) - SUM
               H( J, K+1 ) = H( J, K+1 ) - SUM*CONJG( V2 )
   70       CONTINUE
*
            IF( WANTZ ) THEN
*
*              Accumulate transformations in the matrix Z
*
               DO 80 J = ILOZ, IHIZ
                  SUM = T1*Z( J, K ) + T2*Z( J, K+1 )
                  Z( J, K ) = Z( J, K ) - SUM
                  Z( J, K+1 ) = Z( J, K+1 ) - SUM*CONJG( V2 )
   80          CONTINUE
            END IF
*
            IF( K.EQ.M .AND. M.GT.L ) THEN
*
*              If the QR step was started at row M > L because two
*              consecutive small subdiagonals were found, then extra
*              scaling must be performed to ensure that H(M,M-1) remains
*              real.
*
               TEMP = ONE - T1
               TEMP = TEMP / ABS( TEMP )
               H( M+1, M ) = H( M+1, M )*CONJG( TEMP )
               IF( M+2.LE.I )
     $            H( M+2, M+1 ) = H( M+2, M+1 )*TEMP
               DO 90 J = M, I
                  IF( J.NE.M+1 ) THEN
                     IF( I2.GT.J )
     $                  CALL CSCAL( I2-J, TEMP, H( J, J+1 ), LDH )
                     CALL CSCAL( J-I1, CONJG( TEMP ), H( I1, J ), 1 )
                     IF( WANTZ ) THEN
                        CALL CSCAL( NZ, CONJG( TEMP ), Z( ILOZ, J ), 1 )
                     END IF
                  END IF
   90          CONTINUE
            END IF
  100    CONTINUE
*
*        Ensure that H(I,I-1) is real.
*
         TEMP = H( I, I-1 )
         IF( AIMAG( TEMP ).NE.RZERO ) THEN
            RTEMP = ABS( TEMP )
            H( I, I-1 ) = RTEMP
            TEMP = TEMP / RTEMP
            IF( I2.GT.I )
     $         CALL CSCAL( I2-I, CONJG( TEMP ), H( I, I+1 ), LDH )
            CALL CSCAL( I-I1, TEMP, H( I1, I ), 1 )
            IF( WANTZ ) THEN
               CALL CSCAL( NZ, TEMP, Z( ILOZ, I ), 1 )
            END IF
         END IF
*
  110 CONTINUE
*
*     Failure to converge in remaining number of iterations
*
      INFO = I
      RETURN
*
  120 CONTINUE
*
*     H(I,I-1) is negligible: one eigenvalue has converged.
*
      W( I ) = H( I, I )
*
*     Decrement number of remaining iterations, and return to start of
*     the main loop with new value of I.
*
      ITN = ITN - ITS
      I = L - 1
      GO TO 10
*
  130 CONTINUE
      RETURN
*
*     End of CLAHQR
*
      END

C
C $Id: pchiqu.f,v 1.8 2008-07-27 00:17:19 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE PCHIQU (XPOS,YPOS,CHRS,SIZE,ANGD,CNTR)
C
C This routine provides an alternate entry point for the high-quality
C character-drawing routine; the name has the standard prefix "PC".
C
        CHARACTER CHRS*(*)
C
C Check for an uncleared prior error.
C
        IF (ICFELL('PCHIQU - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
        CALL PLCHHQ (XPOS,YPOS,CHRS,SIZE,ANGD,CNTR)
        IF (ICFELL('PCHIQU',2).NE.0) RETURN
C
        RETURN
C
      END

C
C $Id: pcexcd.f,v 1.4 2008-07-27 01:04:31 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C

      SUBROUTINE PCEXCD (IPNT,IPSS,NDGU)
C
C The subroutine PCEXCD extracts a specified character digitization
C from the PWRITX database.  Its arguments are as follows:
C
C   IPNT is an input variable.  It is given a positive integral value
C   and identifies a particular character digitization by specifying a
C   particular 15-bit pointer in the COMMON array INDA.
C
C   IPSS is an input variable. It specifies how much of the digitization
C   is required by the caller.  If IPSS is 1, the length of a character
C   string is being determined, and only the first two units of the
C   digitization are needed.  If IPSS is 2, the character string is
C   actually being drawn, and all units are needed.
C
C   NDGU is an output variable.  It is set to zero if IPNT specifies an
C   illegal digitization; otherwise, its value specifies how many units
C   have been returned in the COMMON array RDGU.
C
C Each word of the COMMON array INDA contains as many 15-bit pointers
C as will fit, packed together at the upper end of the word; any unused
C bits in the word are at the right end.  Each of the 15-bit pointers
C consists of a single bit which is zero if the digitization uses 6-bit
C units and 1 if it uses 12-bit units, followed by a 14-bit pointer
C into the COMMON array IDDA.
C
C The COMMON array IDDA contains character digitizations, each of which
C consists of a string of 6-bit or 12-bit quantities.  The digitization
C "n" starts at bit number 60*(n-1)+1 and continues until two zeroed
C units in a row are found.  The 6-bit or 12-bit units are stored as
C a bit stream and may cross one or more word boundaries.
C
C Each 6-bit or 12-bit unit of a digitization is transformed before
C being put into RDGU.  From each non-zero 6-bit unit, 32 is subtracted.
C From each non-zero 12-bit unit, 2048 is subtracted.  Each zeroed unit
C is replaced by the value -2048.
C
C COMMON block declarations.
C
      COMMON /PCCMN1/ INDA(789),INDL,IDDA(8625),IDDL
      COMMON /PCCMN2/ NBPW,NPPW
      COMMON /PCCMN3/ RDGU(7000)
C
C MXUN specifies the maximum number of units to be retrieved for a
C given value of IPSS.
C
      DIMENSION MXUN(2)
C
      DATA MXUN / 2,7000 /
C
C Zero the count of digitization units returned.
C
      NDGU=0
C
C If the given pointer is invalid, return.
C
      IF (IPNT.LE.0.OR.IPNT.GT.768) RETURN
C
C Retrieve the proper pointer from the array INDA.
C
      INDI=(IPNT-1)/NPPW+1
      IPIW=IPNT-(INDI-1)*NPPW
      IDGP=IAND(ISHIFT(INDA(INDI),IPIW*15-NBPW),32767)
C
C Separate the 6-bit/12-bit mode indicator from the pointer.
C
      IMDE=IAND(ISHIFT(IDGP,-14),1)
      IDGP=IAND(IDGP,16383)
C
C If there is no digitization for the specified pointer, return.
C
      IF (IDGP.EQ.0) RETURN
C
C Initialize the digitization-unit retrieval loop.  IDDI is the index
C of the word in IDDA containing the first bit of the next unit and
C IFBT is the index of that bit within the word, with zero indicating
C the leftmost bit.
C
      IFBT=(IDGP-1)*60
C
      IDDI=IFBT/NBPW+1
      IFBT=MOD(IFBT,NBPW)
C
C NBPU is the number of bits per digitization unit, MASK is a mask of
C NBPU right-justified one bits, and IOFF is the offset to be subtracted
C from the digitization unit.
C
      IF (IMDE.EQ.0) THEN
        NBPU=6
        MASK=63
        IOFF=32
      ELSE
        NBPU=12
        MASK=4095
        IOFF=2048
      END IF
C
C Extract the digitization.  NRGT is the number of bits in the "right
C end" of a word, starting with the first bit of a unit.
C
      DO 101 I=1,MXUN(IPSS)
        NDGU=NDGU+1
        NRGT=NBPW-IFBT
        IDGU=IAND(ISHIFT(IDDA(IDDI),NBPU-NRGT),MASK)
        IF (NRGT.LT.NBPU)
     +    IDGU=IOR(ISHIFT(ISHIFT(IDGU,NRGT-NBPU),NBPU-NRGT),
     +          ISHIFT(IAND(ISHIFT(IDDA(IDDI+1),NBPU-NBPW),MASK),-NRGT))
        IF (IDGU.EQ.0) THEN
          RDGU(I)=-2048.
        ELSE
          RDGU(I)=REAL(IDGU-IOFF)
        END IF
        IF (I.NE.1) THEN
          IF (RDGU(I).EQ.-2048..AND.RDGU(I-1).EQ.-2048.) GO TO 102
        END IF
        IFBT=IFBT+NBPU
        IF (IFBT.GE.NBPW) THEN
          IDDI=IDDI+1
          IFBT=IFBT-NBPW
        END IF
  101 CONTINUE
C
C Compensate for the fact that the Y coordinates are off by a little.
C (This error dates from the days of PWRITX.)
C
  102 DO 103 I=4,NDGU,2
        IF (RDGU(I-1).NE.-2048.) THEN
          RDGU(I)=RDGU(I)-1.5
        ELSE
          RDGU(I)=0.
        END IF
  103 CONTINUE
C
C Done.
C
      RETURN
C
      END

      SUBROUTINE CFFTF1(N,C,CH,WA,IFAC)
      DOUBLE PRECISION C
      DOUBLE PRECISION CH
      DOUBLE PRECISION WA
      DIMENSION CH(*),C(*),WA(*),IFAC(*)

      NF = IFAC(2)
      NA = 0
      L1 = 1
      IW = 1
      DO 116 K1 = 1,NF
          IP = IFAC(K1+2)
          L2 = IP*L1
          IDO = N/L2
          IDOT = IDO + IDO
          IDL1 = IDOT*L1
          IF (IP.NE.4) GO TO 103
          IX2 = IW + IDOT
          IX3 = IX2 + IDOT
          IF (NA.NE.0) GO TO 101
          CALL PASSF4(IDOT,L1,C,CH,WA(IW),WA(IX2),WA(IX3))
          GO TO 102
  101     CALL PASSF4(IDOT,L1,CH,C,WA(IW),WA(IX2),WA(IX3))
  102     NA = 1 - NA
          GO TO 115
  103     IF (IP.NE.2) GO TO 106
          IF (NA.NE.0) GO TO 104
          CALL PASSF2(IDOT,L1,C,CH,WA(IW))
          GO TO 105
  104     CALL PASSF2(IDOT,L1,CH,C,WA(IW))
  105     NA = 1 - NA
          GO TO 115
  106     IF (IP.NE.3) GO TO 109
          IX2 = IW + IDOT
          IF (NA.NE.0) GO TO 107
          CALL PASSF3(IDOT,L1,C,CH,WA(IW),WA(IX2))
          GO TO 108
  107     CALL PASSF3(IDOT,L1,CH,C,WA(IW),WA(IX2))
  108     NA = 1 - NA
          GO TO 115
  109     IF (IP.NE.5) GO TO 112
          IX2 = IW + IDOT
          IX3 = IX2 + IDOT
          IX4 = IX3 + IDOT
          IF (NA.NE.0) GO TO 110
          CALL PASSF5(IDOT,L1,C,CH,WA(IW),WA(IX2),WA(IX3),WA(IX4))
          GO TO 111
  110     CALL PASSF5(IDOT,L1,CH,C,WA(IW),WA(IX2),WA(IX3),WA(IX4))
  111     NA = 1 - NA
          GO TO 115
  112     IF (NA.NE.0) GO TO 113
          CALL PASSF(NAC,IDOT,IP,L1,IDL1,C,C,C,CH,CH,WA(IW))
          GO TO 114
  113     CALL PASSF(NAC,IDOT,IP,L1,IDL1,CH,CH,CH,C,C,WA(IW))
  114     IF (NAC.NE.0) NA = 1 - NA
  115     L1 = L2
          IW = IW + (IP-1)*IDOT
  116 CONTINUE
      IF (NA.EQ.0) RETURN
      N2 = N + N
      DO 117 I = 1,N2
          C(I) = CH(I)
  117 CONTINUE
      RETURN
      END

      PROGRAM EXAMPLE
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
      REAL Y(21)
C
C OPEN GKS, OPEN WORKSTATION OF TYPE 1, ACTIVATE WORKSTATION
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Fill Y array for entry EZY of AUTOGRAPH.
C
      DO  10 I=1,21
         Y(I) = EXP(-.1*REAL(I))*COS(REAL(I)*.5)
   10 CONTINUE
C
      CALL EZY (Y(1),21,'DEMONSTRATING EZY ENTRY OF AUTOGRAPH$')
C
C     DEACTIVATE AND CLOSE WORKSTATION, CLOSE GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      END

C
C $Id: wmgtso.f,v 1.8 2008-07-27 00:17:36 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE WMGTSO(X1,Y1,X2,Y2,NOUT,XIN,YIN,IFLG)
C
C  Returns the symbol outlines:
C
C  Returns points along the Bezier curve for a warm front symbol.  
C  This is an arch beginning at (X2,Y2) and traversing to (X1,Y1).
C  NOUT must be greater than 2.
C
C  Returns points of a triangle for cold front symbols.
C
C  If IFLG has absolute value "1", then warm front symbols are 
C  returned; if IFLG has absolute value "2", then cold front symbols 
C  are returned.  The algebraic sign of IFLG determines which side
C  the symbol points to (the two possibilities are mirror-imaged
C  about the line connecting the points (X1,Y1) and (X2,Y2).
C  
      PARAMETER (NDIM=7)
C
      include 'wmcomn.h'
C
      DIMENSION XIN(NOUT),YIN(NOUT)
      DIMENSION WSBZCX(NDIM),WSBZCY(NDIM)
      DIMENSION WSXTMP(NDIM),WSYTMP(NDIM),WXTRAN(NDIM),WYTRAN(NDIM)
C
C  X and Y Bezier control points for the warm front symbol.
C
      DATA WSBZCX/ 1.00000,  0.94737,  0.36842,  0.00000,
     +            -0.36842, -0.94737, -1.00000           /
      DATA WSBZCY/ 0.00000, -1.05263, -1.42100, -1.42100,
     +            -1.42100, -1.05263,  0.00000           /
C
C  Scale the control points, and flip depending of the direction
C  the symbols are to be drawn in.
C
      D  = SQRT((Y2-Y1)**2+(X2-X1)**2)
      SS = 0.5*D
      DO 10 I=1,NDIM
        WXTRAN(I) = SS*WSBZCX(I)
        WYTRAN(I) = SS*SIGN(1,IFLG)*WSBZCY(I)
   10 CONTINUE
C
C  Make the cold front symbols a little larger.
C
      IF (ABS(IFLG) .EQ. 1) THEN
        WYTRAN(4) = 1.1*WYTRAN(4)
      ENDIF
C
C  Rotate the control points.
C
      COSANG = (X2-X1)/D
      SINANG = (Y2-Y1)/D
      DO 20 I=1,NDIM
        WSXTMP(I) = WXTRAN(I)*COSANG-WYTRAN(I)*SINANG
        WSYTMP(I) = WXTRAN(I)*SINANG+WYTRAN(I)*COSANG
   20 CONTINUE
      DO 30 I=1,NDIM
        WXTRAN(I) = WSXTMP(I)
        WYTRAN(I) = WSYTMP(I)
   30 CONTINUE
C
C  Translate the control points.
C
      XM = 0.5*(X1+X2)
      YM = 0.5*(Y1+Y2)
      DO 40 I=1,NDIM
        WXTRAN(I) = XM+WXTRAN(I)
        WYTRAN(I) = YM+WYTRAN(I)
   40 CONTINUE
C
      IF (ABS(IFLG).EQ.1 .OR. ABS(IFLG).EQ.3) THEN
C
C  Return cold front symbol.
C
        XIN(1) =  WXTRAN(1)
        YIN(1) =  WYTRAN(1)
        XIN(2) =  WXTRAN(4)
        YIN(2) =  WYTRAN(4)
        XIN(3) =  WXTRAN(7)
        YIN(3) =  WYTRAN(7)
      ELSE
C
C  Calculate the points along the Bezier curve for a warm front symbol.
C
        NHALF = NOUT/2
        CALL BCFCRV(WXTRAN(1),WYTRAN(1),NHALF+1,XIN(1),YIN(1))
        IF (MOD(NOUT,2) .EQ. 0) THEN
          CALL BCFCRV(WXTRAN(4),WYTRAN(4),NHALF,
     +                XIN(NHALF+1),YIN(NHALF+1))       
        ELSE
          CALL BCFCRV(WXTRAN(4),WYTRAN(4),NHALF+1,
     +                XIN(NHALF+1),YIN(NHALF+1))
        ENDIF
      ENDIF
C
      RETURN
      END

program read_redn80_uv

implicit none

integer, parameter                     :: nlats = 160
integer, parameter                     :: ngpts = 35718
integer, dimension(nlats)              :: ngpts_perlats
!integer, dimension(nlats)              :: lats
real(8), dimension(nlats)              :: lats
real(8), dimension(ngpts)              :: u, un
real(8), dimension(ngpts)              :: v, vn
integer                                :: gp
integer                                :: jlat
integer                                :: klon, nlons, ierror
real(8), dimension(:,:), allocatable :: ur, vr, br, bi, cr, ci
real(8), dimension(:), allocatable :: wvhagc, work
real(8)  :: ue, ve, uet, vet
integer :: iue,ive,ulat,ulon,vlat,vlon,mdab,ndab,l1,l2,lvhagc, &
           lwork, i

ngpts_perlats = (/18,25,36,40,45,54,60,64,72,72,80,90,96,100,108,              &
                   120,120,128,135,144,144,150,160,160,180,180,180,192,192,200, &
                   200,216,216,216,225,225,240,240,240,256,256,256,256,288,288, &
                   288,288,288,288,288,288,288,300,300,300,300,320,320,320,320, &
                   320,320,320,320,320,320,320,320,320,320,320,320,320,320,320, &
                   320,320,320,320,320,320,320,320,320,320,320,320,320,320,320, &
                   320,320,320,320,320,320,320,320,320,320,320,320,320,320,300, &
                   300,300,300,288,288,288,288,288,288,288,288,288,256,256,256, &
                   256,240,240,240,225,225,216,216,216,200,200,192,192,180,180, &
                   180,160,160,150,144,144,135,128,120,120,108,100,96,90,80,    &
                   72,72,64,60,54,45,40,36,25,18/)

lats = (/ 89.1416,  88.0294,  86.9108,  85.7906,  84.6699,  83.5489,  &
            82.4278,  81.3066,  80.1853,  79.0640,  77.9426,  76.8212,  &
            75.6998,  74.5784,  73.4570,  72.3356,  71.2141,  70.0927,  &
            68.9712,  67.8498,  66.7283,  65.6069,  64.4854,  63.3639,  &
            62.2425,  61.1210,  59.9995,  58.8780,  57.7566,  56.6351,  &
            55.5136,  54.3921,  53.2707,  52.1492,  51.0277,  49.9062,  &
            48.7847,  47.6632,  46.5418,  45.4203,  44.2988,  43.1773,  &
            42.0558,  40.9343,  39.8129,  38.6914,  37.5699,  36.4484,  &
            35.3269,  34.2054,  33.0839,  31.9624,  30.8410,  29.7195,  &
            28.5980,  27.4765,  26.3550,  25.2335,  24.1120,  22.9905,  &
            21.8690,  20.7476,  19.6261,  18.5046,  17.3831,  16.2616,  &
            15.1401,  14.0186,  12.8971,  11.7756,  10.6542,   9.5327,  &
            8.4112,   7.2897,   6.1682,   5.0467,   3.9252,   2.8037,   &
            1.6822,   0.5607,                                           &
            -0.5607, -1.6822,                                           &
            -2.8037, -3.9252, -5.0467, -6.1682, -7.2897, -8.4112,       & 
            -9.5327, -10.6542, -11.7756, -12.8971, -14.0186, -15.1401,  &
            -16.2616, -17.3831, -18.5046, -19.6261, -20.7476, -21.8690, &
            -22.9905, -24.1120, -25.2335, -26.3550, -27.4765, -28.5980, &
            -29.7195, -30.8410, -31.9624, -33.0839, -34.2054, -35.3269, &
            -36.4484, -37.5699, -38.6914, -39.8129, -40.9343, -42.0558, &
            -43.1773, -44.2988, -45.4203, -46.5418, -47.6632, -48.7847, &
            -49.9062, -51.0277, -52.1492, -53.2707, -54.3921, -55.5136, &
            -56.6351, -57.7566, -58.8780, -59.9995, -61.1210, -62.2425, &
            -63.3639, -64.4854, -65.6069, -66.7283, -67.8498, -68.9712, &
            -70.0927, -71.2141, -72.3356, -73.4570, -74.5784, -75.6998, &
            -76.8212, -77.9426, -79.0640, -80.1853, -81.3066, -82.4278, &
            -83.5489, -84.6699, -85.7906, -86.9108, -88.0294, -89.1416 /)

open(unit=10,file='UV_redn80_500mb_19570900.asc',access='sequential',form='formatted')

! Read in u:
gp = 0
do jlat = 1, nlats
  do klon = 1, ngpts_perlats(jlat)
    gp = gp + 1
    read(10,'(f10.5)') u(gp)
  end do
end do

! Read in v:
gp = 0
do jlat = 1, nlats
  do klon = 1, ngpts_perlats(jlat)
    gp = gp + 1
    read(10,'(f10.5)') v(gp)
  end do
end do

close(10)

nlons = 0
do jlat = 1, nlats
  nlons = max( nlons, ngpts_perlats(jlat))
end do
allocate( ur(nlats, nlons), vr(nlats,nlons) )

!-- Use Rich's routine to convert reduced to regular 
call red2reg(ngpts,u,nlats,ngpts_perlats,nlons,ur,ierror)
call red2reg(ngpts,v,nlats,ngpts_perlats,nlons,vr,ierror)

!-- Use Rich's routine to convert regular to reduced 
call reg2red(nlats,ngpts_perlats,nlons,ur,ngpts,un,ierror)
call reg2red(nlats,ngpts_perlats,nlons,vr,ngpts,vn,ierror)

!-- Compare the difference in this roundtrip and print
call find_diff(nlats,ngpts,ngpts_perlats,u,un,v,vn, &
     ue,ve,iue,ive,ulat,ulon,vlat,vlon)
print *,'Error after going from reduced to regular and '
print *,'back to reduced grid using routines written by Rich'
print *,'applied on data provided by Dave'
print *,'Max rel error in u ',ue,' for the value ',u(iue),' at (lat,lon)',ulat,ulon
print *,'Max rel error in v ',ve,' for the value ',v(ive),' at (lat,lon)',vlat,vlon

!-- Now let us analyse and sythensize this regular grid to
!-- make sure there is no gotchas somewhere else.
if ( mod(nlons,2) .eq. 0 ) then
  mdab = min(nlats,nlons/2)
  l1 = min(nlats,nlons/2)
else
  mdab = min(nlats,(nlons+1)/2)
  l1 = min(nlats,(nlons+1)/2)
endif

if ( mod(nlats,2) .eq. 0 ) then
  l2 = nlats/2
else
  l2 = (nlats+1)/2
endif

ndab = nlats

allocate(br(mdab,ndab),bi(mdab,ndab),cr(mdab,ndab),ci(mdab,ndab))

lvhagc = 4*nlats*l2+3*max(l1-2,0)*(2*nlats-l1-1)+nlons+l2+15
lwork = max(2*nlats*(2*nlons+3*l2), nlats*(2*nlons+max(6*l2,nlons)))
allocate( wvhagc(lvhagc), work(lwork) )

!-- Analyse
call vhagci(nlats,nlons,wvhagc,lvhagc,work,lwork,ierror)
call vhagc(nlats,nlons,0,1,ur,vr,nlats,nlons,br,bi,cr,ci, &
                 mdab,ndab,wvhagc,lvhagc,work,lwork,ierror)

!-- Synthesize to regular
call vhsgci(nlats,nlons,wvhagc,lvhagc,work,lwork,ierror)
call vhsgc(nlats,nlons,0,1,ur,vr,nlats,nlons,br,bi,cr,ci, &
                 mdab,ndab,wvhagc,lvhagc,work,lwork,ierror)

!-- Once again use Rich's routine to convert regular to reduced 
call reg2red(nlats,ngpts_perlats,nlons,ur,ngpts,un,ierror)
call reg2red(nlats,ngpts_perlats,nlons,vr,ngpts,vn,ierror)

!-- Compare the difference in this roundtrip and print
call find_diff(nlats,ngpts,ngpts_perlats,u,un,v,vn, &
     ue,ve,iue,ive,ulat,ulon,vlat,vlon)
print *,'Error after going from reduced to regular and '
print *,'analysis and followed by a synthesis and then'
print *,'back to reduced grid using routines written by Rich'
print *,'applied on data provided by Dave'
print *,'Max rel error in u ',ue,' for the value ',u(iue),' at (lat,lon)',ulat,ulon
print *,'Max rel error in v ',ve,' for the value ',v(ive),' at (lat,lon)',vlat,vlon

end program read_redn80_uv



subroutine red2reg(nred,red,nlat,jlon,nlon,reg,ierror)
implicit none
 
integer, intent(in) :: nred
integer, intent(in) :: nlat
integer, intent(in) :: nlon

real(kind=8), intent(in)  :: red(nred)
integer, intent(in)       :: jlon(nlat)
real(kind=8), intent(out) :: reg(nlat,nlon)
integer, intent(out)      :: ierror

! Local Variables
      
real(kind=8), dimension(:,:), allocatable :: atmp
real(kind=8), dimension(:), allocatable   :: work
real(kind=8), dimension(:), allocatable   :: wsave

integer :: jlat
integer :: jptr

! ==========================================
! Error tests go here
! ==========================================
      
ierror=0
      
! ==========================================
! Forward FFT (real-> complex) the reduced 
! grid data_values and store in the 
! regular grid array
! ==========================================

reg(:,:) = 0.0_8
jptr=1
do jlat=1,nlat

   ! recompute FFT work arrays only when longitude changes
   
   if (jlat==1) then
      allocate(wsave(2*jlon(jlat)+15))
      allocate(work(jlon(jlat)))
      allocate(atmp(1,jlon(jlat)))
            
      call hrffti(jlon(jlat),wsave)
   else if (jlon(jlat) .ne. jlon(jlat-1)) then

      deallocate(wsave)
      deallocate(work)
      deallocate(atmp)

      allocate(wsave(2*jlon(jlat)+15))
      allocate(work(jlon(jlat)))
      allocate(atmp(1,jlon(jlat)))

      call hrffti(jlon(jlat),wsave)
   end if
   atmp(1,1:jlon(jlat)) = red(jptr:jlon(jlat)+jptr-1)
   call hrfftf(1,jlon(jlat),atmp,1,wsave,work)
   reg(jlat,1:jlon(jlat)) = atmp(1,1:jlon(jlat))/jlon(jlat) ! rescale wave numbers
   jptr=jptr+jlon(jlat)
end do
      
deallocate(wsave)
deallocate(work)
deallocate(atmp)

! =============================
! Inverse FFT (complex to real)
! =============================
              
allocate(wsave(2*nlon+15))
allocate(work(nlat*nlon))

call hrffti(nlon,wsave)
call hrfftb(nlat,nlon,reg,nlat,wsave,work)
      
deallocate(wsave)
deallocate(work)

end subroutine red2reg


subroutine reg2red(nlat,jlon,nlon,reg,nred,red,ierror)
implicit none

integer, intent(in) :: nlat
integer, intent(in) :: nlon
integer, intent(in) :: nred
      
integer, intent(in)                 :: jlon(nlat)
real(kind=8), intent(in)   ::   reg(nlat,nlon)
real(kind=8), intent(out)  :: red(nred)

integer, intent(out)                :: ierror

! Local Variables
      
real(kind=8), dimension(:,:), allocatable :: atmp, reg1
real(kind=8), dimension(:), allocatable :: work
real(kind=8), dimension(:), allocatable :: wsave

integer :: jlat, i
integer :: jptr
      
allocate(reg1(nlat,nlon))
reg1 = reg
! ===================================================
! Error tests go here.
! ===================================================
      
ierror=0
      
! ===================================================
! Forward FFT (complex to real) the regular grid data
! ===================================================
              
allocate(wsave(2*nlon+15))
allocate(work(nlat*nlon))

call hrffti(nlon,wsave)
call hrfftf(nlat,nlon,reg1,nlat,wsave,work)
      
deallocate(wsave)
deallocate(work)
      
! ==========================================
! Forward FFT (real-> complex) the reduced 
! grid data_values and store in the 
! regular grid array
! ==========================================

red(:) = 0.0_8
jptr=1
do jlat=1,nlat

   ! recompute FFT work arrays only when longitude changes
   
   if (jlat==1) then
      allocate(wsave(2*jlon(jlat)+15))
      allocate(work(jlon(jlat)))
      allocate(atmp(1,jlon(jlat)))
            
      call hrffti(jlon(jlat),wsave)
   else if (jlon(jlat) .ne. jlon(jlat-1)) then

      deallocate(wsave)
      deallocate(work)
      deallocate(atmp)

      allocate(wsave(2*jlon(jlat)+15))
      allocate(work(jlon(jlat)))
      allocate(atmp(1,jlon(jlat)))

      call hrffti(jlon(jlat),wsave)
   end if
         
   atmp(1,1:jlon(jlat)) = reg1(jlat,1:jlon(jlat))/nlon  ! rescale wave numbers
   call hrfftb(1,jlon(jlat),atmp,1,wsave,work)
   red(jptr:jlon(jlat)+jptr-1) = atmp(1,1:jlon(jlat))
         
   jptr=jptr+jlon(jlat)
end do
      
deallocate(wsave)
deallocate(work)
deallocate(atmp)
deallocate(reg1)

end subroutine reg2red


subroutine find_diff(nlats,ngpts,ngpts_perlats,u,un, &
          v,vn,ue,ve,iue,ive,ulat,ulon,vlat,vlon)
implicit none
integer, intent(in) :: nlats,ngpts,ngpts_perlats(nlats)
real(8), dimension(ngpts), intent(in) :: u,un,v,vn
real(8), intent(out) :: ue,ve
integer, intent(out) :: iue, ive, ulat,ulon,vlat,vlon
real(8) :: udf, vdf, uet, vet
integer :: gp, jlat, klon
ue = 0.d0
ve = 0.d0
gp = 0
do jlat = 1, nlats
  do klon = 1, ngpts_perlats(jlat)
    gp = gp + 1
    udf = u(gp) - un(gp)
    uet = udf/u(gp)
    if(abs(uet).ge.abs(ue)) then
       ue = uet
       iue = gp
       ulat = jlat
       ulon = klon
    endif
    vdf = v(gp) - vn(gp)
    vet = vdf/v(gp)
    if(abs(vet).ge.abs(ve)) then
       ve = vet
       ive = gp
       vlat = jlat
       vlon = klon
    endif
  end do
end do
end subroutine find_diff

C
C	$Id: g01clp.f,v 1.10 2008-07-27 00:21:05 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE G01CLP(IFORCE)
C
C  Process clipping parameters.  If the current picture is empty,
C  then putting a clip indicator or clip rectangle into the metafile
C  is suppressed.  Setting IFORCE to 1 forces a clip indicator and 
C  clip rectangle into the metafile, and this is done when the picture
C  becomes non-empty.  In all other cases the clip indicator or
C  rectangle is put into the metafile depending upon whether a
C  change has been detected from the previous setting.
C
      include 'g01prm.h'
      include 'gksin.h'
      include 'g01wsl.h'
      include 'g01ins.h'
      include 'g01opc.h'
      include 'gksenu.h'
C
      INTEGER  NBYTES, I, ICRLOC(4)
      LOGICAL  CHANGE, DCLIP
C
      SAVE
C
C  Handle the case where a clip indicator and rectangle is forced
C  into the metafile.
C
      IF (IFORCE .NE. 0) GO TO 100
C
C  If the clipping indicator has changed, store it in the WSL.  If 
C  the picture is not empty, or NPFLG is non-zero, send the clip indicator.
C
      DCLIP = ID(1).NE.MRCLIP
      IF (DCLIP)  THEN
        MRCLIP = ID(1)
        IF (MDEMPT.EQ.GNEMPT .OR. NPFLG.NE.0) THEN
C
C  Put out opcode (CLASS and ID) and LENGTH
C
          NBYTES = 1+(MEFW-1)/8
          CALL GPUTNI (CLCLIN, IDCLIN, NBYTES, RERR)
          IF (RERR.NE.0)  RETURN
C
C  Put out clipping indicator parameter (DATA, PRECIS, COUNT).
C
          CALL GPUTPR (MRCLIP, MEFW,     1, RERR)
          IF (RERR.NE.0)  RETURN
        ENDIF
      END IF
C
C  Normalize the clipping rectangle and store it.  Send the rectangle
C  if the picture is not empty.
C
C  Normalize NDC limits of rectangle (assume bounds check
C  above WSI), store as rectangle corner points.
C
      ICRLOC(1) = MXOFF + MXSCAL*RX(1)
      ICRLOC(3) = MXOFF + MXSCAL*RX(2)
      ICRLOC(2) = MYOFF + MYSCAL*RY(1)
      ICRLOC(4) = MYOFF + MYSCAL*RY(2)
      CHANGE = .FALSE.
      DO 10 I=1,4
        IF (ICRLOC(I).NE.MRCREC(I))  THEN
          CHANGE = .TRUE.
          MRCREC(I) = ICRLOC(I)
        END IF
   10 CONTINUE
      IF (DCLIP .OR. CHANGE) THEN
        IF (MDEMPT .EQ. GNEMPT) THEN
C
C  Total byte length, based on VDC bit precision.
C
          NBYTES = 1 + (4*MVDCFW-1)/8
C
C  Put out opcode (CLASS and ID) and LENGTH.
C
          CALL GPUTNI (CLCREC, IDCREC, NBYTES, RERR)
          IF (RERR.NE.0)  RETURN
C
C  Put out clipping rectangle corner points (DATA, PRECIS, COUNT).
C
          CALL GPUTPR (MRCREC, MVDCFW,     4, RERR)
        END IF
      END IF
      RETURN
C
  100 CONTINUE
C
C  Put out opcode (CLASS and ID) and LENGTH
C
      NBYTES = 1+(MEFW-1)/8
       
      CALL GPUTNI (CLCLIN, IDCLIN, NBYTES, RERR)
      IF (RERR.NE.0)  RETURN
C
C  Put out clipping indicator parameter.
C
      CALL GPUTPR (MRCLIP, MEFW, 1, RERR)
      IF (RERR.NE.0)  RETURN

C  Total byte length, based on VDC bit precision.
C
      NBYTES = 1 + (4*MVDCFW-1)/8
C
C  Put out opcode (CLASS and ID) and LENGTH.
C
      CALL GPUTNI (CLCREC, IDCREC, NBYTES, RERR)
      IF (RERR.NE.0)  RETURN
C
C  Put out clipping rectangle corner points (DATA, PRECIS, COUNT).
C
      CALL GPUTPR (MRCREC, MVDCFW,     4, RERR)
      RETURN
C
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C   FFTPACK 5.0
C   Copyright (C) 1995-2004, Scientific Computing Division,
C   University Corporation for Atmospheric Research
C   Licensed under the GNU General Public License (GPL)
C
C   Authors:  Paul N. Swarztrauber and Richard A. Valent
C
C   $Id: rffti1.f,v 1.2 2006-11-21 01:10:19 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      SUBROUTINE DRFFTI1(N,WA,FAC)
      DOUBLE PRECISION FI
      DOUBLE PRECISION WA(N),FAC(15)
      INTEGER NTRYH(4)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION TPI,ARGH,ARGLD,ARG
      DATA NTRYH(1),NTRYH(2),NTRYH(3),NTRYH(4)/4,2,3,5/
C
      NL = N
      NF = 0
      J = 0
  101 J = J + 1
      IF (J-4) 102,102,103
  102 NTRY = NTRYH(J)
      GO TO 104
  103 NTRY = NTRY + 2
  104 NQ = NL/NTRY
      NR = NL - NTRY*NQ
      IF (NR) 101,105,101
  105 NF = NF + 1
      FAC(NF+2) = NTRY
      NL = NQ
      IF (NTRY.NE.2) GO TO 107
      IF (NF.EQ.1) GO TO 107
      DO 106 I = 2,NF
          IB = NF - I + 2
          FAC(IB+2) = FAC(IB+1)
  106 CONTINUE
      FAC(3) = 2
  107 IF (NL.NE.1) GO TO 104
      FAC(1) = N
      FAC(2) = NF
C*PT*WARNING* Constant already double-precision
C*PT*WARNING* Constant already double-precision
      TPI = 8.D0*DATAN(1.D0)
      ARGH = TPI/DBLE(N)
      IS = 0
      NFM1 = NF - 1
      L1 = 1
      IF (NFM1.EQ.0) RETURN
      DO 110 K1 = 1,NFM1
          IP = FAC(K1+2)
          LD = 0
          L2 = L1*IP
          IDO = N/L2
          IPM = IP - 1
          DO 109 J = 1,IPM
              LD = LD + L1
              I = IS
              ARGLD = DBLE(LD)*ARGH
              FI = 0.D0
              DO 108 II = 3,IDO,2
                  I = I + 2
                  FI = FI + 1.D0
                  ARG = FI*ARGLD
                  WA(I-1) = DCOS(ARG)
                  WA(I) = DSIN(ARG)
  108         CONTINUE
              IS = IS + IDO
  109     CONTINUE
          L1 = L2
  110 CONTINUE
      RETURN
      END

C
C $Id: pwrz.f,v 1.5 2008-07-27 00:17:34 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE PWRZ (X,Y,Z,ID,N,ISIZE,LIN3,ITOP,ICNT)
      WRITE (6,1001)
      WRITE (6,1002)
      STOP
C
 1001 FORMAT (1H1//////////)
 1002 FORMAT (' *****************************************'/
     1        ' *                                       *'/
     2        ' *                                       *'/
     3        ' *   THE ENTRY POINT PWRZ IS NO LONGER   *'/
     4        ' *   SUPPORTED.  THE CAPABILITIES OF     *'/
     5        ' *   THIS OLD ENTRY ARE NOW AVAILABLE    *'/
     6        ' *   IN THE NEW PORTABLE VERSIONS        *'/
     7        ' *                                       *'/
     8        ' *        PWRZS  FOR USE WITH SRFACE     *'/
     9        ' *        PWRZI  FOR USE WITH ISOSRF     *'/
     +        ' *        PWRZT  FOR USE WITH THREED     *'/
     1        ' *                                       *'/
     2        ' *   FOR USAGE OF THESE ROUTINES, SEE    *'/
     3        ' *   THE DOCUMENTATION FOR THE DESIRED   *'/
     4        ' *   ROUTINE.                            *'/
     5        ' *                                       *'/
     6        ' *                                       *'/
     7        ' *****************************************')
C
      END

c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by UCAR                 .
c  .                                                             .
c  .       University Corporation for Atmospheric Research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                         SPHEREPACK                       .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c ... visgeo.f
c
c     contains documentation and code for subroutine visgeo
c
      SUBROUTINE DVISGEO(M,IDP,JDP,X,Y,Z,H,EYER,EYELAT,EYELON,WORK,
     +                  LWORK,IWORK,LIWORK,IERROR)
      DOUBLE PRECISION X
      DOUBLE PRECISION Y
      DOUBLE PRECISION Z
      DOUBLE PRECISION H
      DOUBLE PRECISION EYER
      DOUBLE PRECISION EYELAT
      DOUBLE PRECISION EYELON
      DOUBLE PRECISION WORK
c
c     subroutine visgeo will display a function on the sphere
c     as a solid. ie. as a "lumpy" sphere. visgeo calls subroutine
c     vsurf to produce the visible surface rendering. X, Y, and Z
c     are the points on an icosahedral geodesic computed by
c     subroutine geopts available in spherepack.
c
c     requires routines visgeo1 ctos stoc vsurf vsurf1
c                       prjct box
c
c     visgeo uses the ncar graphics package.
c     compile with: ncargf77 (all programs above)
c
c     execute with:  a.out
c
c     on screen display with:  ctrans -d x11 gmeta
c
c     print with:  ctrans -d ps.color gmeta > gmeta.ps
c                  lpr -P(your printer) gmeta.ps
c
c
c     input parameters
c
c     m        the number of points on one edge of the icosahedron
c
c     idp,jdp  the first and second dimensions of the three
c              dimensional arrays x, y, z, and h.
c
c     x,y,z    the coordinates of the geodesic points on
c              the unit sphere computed by subroutine geopts.
c              the indices are defined on the unfolded
c              icosahedron as follows for the case m=3
c
c                north pole
c
c                 (5,1)          0      l
c        i     (4,1) (5,2)              a    (repeated for
c           (3,1) (4,2) (5,3)  theta1   t    k=2,3,4,5 in
c        (2,1) (3,2) (4,3)              i        -->
c     (1,1) (2,2) (3,3)        theta2   t    the longitudinal
c        (1,2) (2,3)                    u    direction)
c           (1,3)                pi     d
c      j                                e
c         south pole
c
c            total number of vertices is  10*(m-1)**2+2
c            total number of triangles is 20*(m-1)**2
c
c     h      a three dimensional array that contains the discrete
c            function to be displayed. h(i,j,k) is the distance from
c            the center of the sphere to the "lumpy" surface at the
c             point [x(i,j,k),y(i,j,k),z(i,j,k)] on the unit sphere.
c
c     eyer   the distance from the center of the sphere to the eye.
c
c     eyelat the colatitudinal coordinate of the eye (in degrees).
c
c     eyelon the longitudinal  coordinate of the eye (in degrees).
c
c     idp    the first dimension of the array h as it appears in
c            the program that calls visgeo
c
c     jdp    the second dimension of the array h as it appears in
c            the program that calls visgeo
c
c     work   a real work array
c
c     lwork  the dimension of the array work as it appears in the
c            program that calls visgeo. lwork must be at least
c                       480*(m-1)**2.
c
c     iwork  an integer work array
c
c     liwork the dimension of the array iwork as it appears in the
c            program that calls visgeo. liwork must be at least
c                       140*(m-1)**2.
c
c     input parameter
c
c     ierror = 0    no error
c            = 1    h(i,j,k) is less than zero for some i,j,k.
c            = 2    eyer is less than h(i,j,k) for some i,k,k.
c            = 3    lwork  is less than 480*(m-1)**2
c            = 4    liwork is less than 140*(m-1)**2
c
      DIMENSION H(IDP,JDP,5),X(IDP,JDP,5),Y(IDP,JDP,5),Z(IDP,JDP,5),
     +          WORK(*)
      INTEGER IWORK(*)

      MMSQ = (M-1)**2
      IERROR = 3
      IF (LWORK.LT.480*MMSQ) RETURN
      IERROR = 4
      IF (LIWORK.LT.140*MMSQ) RETURN
      DO 10 K = 1,5
          DO 10 J = 1,M
              DO 10 I = 1,M + M - 1
                  IF (H(I,J,K).GE.0.D0) GO TO 15
                  IERROR = 1
                  RETURN
   15             IF (EYER.GT.H(I,J,K)) GO TO 10
                  IERROR = 2
                  RETURN
   10 CONTINUE
      IERROR = 0
      LT = 20* (M-1)**2
      LG = 5*M* (M+M-1)
      I1 = 1
      I2 = I1 + LT
      I3 = I2 + LT
      I4 = I3 + LT
      I5 = I4 + LT
      I6 = I5 + LT
      I7 = I6 + LT
      I8 = I7 + LT
      I9 = I8 + LT
      I10 = I9 + LT
      I11 = I10 + LT
      I12 = I11
      I13 = I12 + LG
      I14 = I13 + LG
      CALL DVISGEO1(M,IDP,JDP,H,EYER,EYELAT,EYELON,X,Y,Z,WORK(I1),
     +             WORK(I2),WORK(I3),WORK(I4),WORK(I5),WORK(I6),
     +             WORK(I7),WORK(I8),WORK(I9),IWORK(1),WORK(I11),
     +             WORK(I12),WORK(I13),WORK(I14),IWORK(LT+1))
      RETURN
      END
      SUBROUTINE DVISGEO1(M,IDP,JDP,H,EYER,EYELAT,EYELON,XI,YI,ZI,X1,
     +                    Y1,Z1,X2,Y2,Z2,X3,Y3,Z3,ITYPE,WORK,X,Y,Z,
     +                    IWORK)
      DOUBLE PRECISION H
      DOUBLE PRECISION EYER
      DOUBLE PRECISION EYELAT
      DOUBLE PRECISION EYELON
      DOUBLE PRECISION XI
      DOUBLE PRECISION YI
      DOUBLE PRECISION ZI
      DOUBLE PRECISION X1
      DOUBLE PRECISION Y1
      DOUBLE PRECISION Z1
      DOUBLE PRECISION X2
      DOUBLE PRECISION Y2
      DOUBLE PRECISION Z2
      DOUBLE PRECISION X3
      DOUBLE PRECISION Y3
      DOUBLE PRECISION Z3
      DOUBLE PRECISION WORK
      DOUBLE PRECISION X
      DOUBLE PRECISION Y
      DOUBLE PRECISION Z
      DOUBLE PRECISION RAD
      DOUBLE PRECISION THETA
      DOUBLE PRECISION ELAMBDA
      DOUBLE PRECISION PI
      DOUBLE PRECISION DTR
      DOUBLE PRECISION XEYE
      DOUBLE PRECISION YEYE
      DOUBLE PRECISION ZEYE
      DIMENSION H(IDP,JDP,5),XI(IDP,JDP,5),YI(IDP,JDP,5),ZI(IDP,JDP,5),
     +          X1(*),Y1(*),Z1(*),X2(*),Y2(*),Z2(*),X3(*),Y3(*),Z3(*),
     +          ITYPE(*),WORK(*),X(M+M-1,M,5),Y(M+M-1,M,5),Z(M+M-1,M,5)
      INTEGER IWORK(*)
c
c     the * above refers to 20*(m-1)**2 locations which is the
c     number of triangles
c
      DO 10 K = 1,5
          DO 10 J = 1,M
              DO 10 I = 1,M + M - 1
                  CALL DCTOS(XI(I,J,K),YI(I,J,K),ZI(I,J,K),RAD,THETA,
     +                      ELAMBDA)
                  CALL DSTOC(H(I,J,K),THETA,ELAMBDA,X(I,J,K),Y(I,J,K),
     +                      Z(I,J,K))
   10 CONTINUE
      NTRI = 0
      DO 20 K = 1,5
          DO 20 J = 1,M - 1
              DO 20 I = 1,M + M - 2
                  NTRI = NTRI + 1
                  X1(NTRI) = X(I,J,K)
                  Y1(NTRI) = Y(I,J,K)
                  Z1(NTRI) = Z(I,J,K)
                  X2(NTRI) = X(I+1,J+1,K)
                  Y2(NTRI) = Y(I+1,J+1,K)
                  Z2(NTRI) = Z(I+1,J+1,K)
                  X3(NTRI) = X(I+1,J,K)
                  Y3(NTRI) = Y(I+1,J,K)
                  Z3(NTRI) = Z(I+1,J,K)
                  ITYPE(NTRI) = 13
                  NTRI = NTRI + 1
                  X1(NTRI) = X(I,J,K)
                  Y1(NTRI) = Y(I,J,K)
                  Z1(NTRI) = Z(I,J,K)
                  X2(NTRI) = X(I+1,J+1,K)
                  Y2(NTRI) = Y(I+1,J+1,K)
                  Z2(NTRI) = Z(I+1,J+1,K)
                  X3(NTRI) = X(I,J+1,K)
                  Y3(NTRI) = Y(I,J+1,K)
                  Z3(NTRI) = Z(I,J+1,K)
                  ITYPE(NTRI) = 3
   20 CONTINUE
c      write(6,22) ntri
   22 FORMAT (i10)
c      write(6,23) (x1(l2),y1(l2),z1(l2),x2(l2),y2(l2),z2(l2),
c     1             x3(l2),y3(l2),z3(l2),l2=1,ntri)
c 23   format(9f10.7)
c
      PI = 4.D0*ATAN(1.D0)
      DTR = PI/180.D0
      XEYE = EYER*SIN(DTR*EYELAT)
      YEYE = XEYE*SIN(DTR*EYELON)
      XEYE = XEYE*COS(DTR*EYELON)
      ZEYE = EYER*COS(DTR*EYELAT)
      CALL DVSURF(XEYE,YEYE,ZEYE,NTRI,X1,Y1,Z1,X2,Y2,Z2,X3,Y3,Z3,ITYPE,
     +           WORK,IWORK)
      RETURN
      END
      SUBROUTINE DCTOS(X,Y,Z,R,THETA,PHI)
      DOUBLE PRECISION X
      DOUBLE PRECISION Y
      DOUBLE PRECISION Z
      DOUBLE PRECISION R
      DOUBLE PRECISION THETA
      DOUBLE PRECISION PHI
      DOUBLE PRECISION R1

      R1 = X*X + Y*Y
      IF (R1.NE.0.D0) GO TO 10
      PHI = 0.D0
      THETA = 0.D0
      IF (Z.LT.0.D0) THETA = 4.D0*ATAN(1.D0)
      RETURN
   10 R = SQRT(R1+Z*Z)
      R1 = SQRT(R1)
      PHI = ATAN2(Y,X)
      THETA = ATAN2(R1,Z)
      RETURN
      END
      SUBROUTINE DSTOC(R,THETA,PHI,X,Y,Z)
      DOUBLE PRECISION R
      DOUBLE PRECISION THETA
      DOUBLE PRECISION PHI
      DOUBLE PRECISION X
      DOUBLE PRECISION Y
      DOUBLE PRECISION Z
      DOUBLE PRECISION ST

      ST = SIN(THETA)
      X = R*ST*COS(PHI)
      Y = R*ST*SIN(PHI)
      Z = R*COS(THETA)
      RETURN
      END
      SUBROUTINE DVSURF(XEYE,YEYE,ZEYE,NTRI,X1,Y1,Z1,X2,Y2,Z2,X3,Y3,Z3,
     +                 ITYPE,WORK,IWORK)
      DOUBLE PRECISION XEYE
      DOUBLE PRECISION YEYE
      DOUBLE PRECISION ZEYE
      DOUBLE PRECISION X1
      DOUBLE PRECISION Y1
      DOUBLE PRECISION Z1
      DOUBLE PRECISION X2
      DOUBLE PRECISION Y2
      DOUBLE PRECISION Z2
      DOUBLE PRECISION X3
      DOUBLE PRECISION Y3
      DOUBLE PRECISION Z3
      DOUBLE PRECISION WORK
c
c    subroutine vsurf is like subroutine hidel except the triangles
c    are categorized. vsurf is also like solid except triangles rather
c    than lines are covered.
c
c     written by paul n. swarztrauber, national center for atmospheric
c     research, p.o. box 3000, boulder, colorado, 80307
c
c    this program plots visible lines for the surface defined
c    by the input 3-d triangles with corners at (x1,y1,z1), (x2,y2,z2)
c    and (x3,y3,z3). the sides of these these triangles may or
c    may not be plotted depending on itype. if itype is 1 then the
c    side between points (x1,y1,z1) and (x2,y2,z2) is plotted if it
c    is visible. if itype is 2 then the side between (x2,y2,z2)
c    and (x3,y3,z3) is plotted. if itype is 3 then the visible portion
c    of the side between (x3,y3,z3) and (x1,y1,z1) is plotted.
c    any combination is possible by specifying itype to be one
c    of the following values: 0,1,2,3,12,13,23,123.
c
c    the length of real    array  work must be at least 14*ntri
c
c    the length of integer array iwork must be at least  6*ntri
c
c
c    the vertices of the triangles are renumbered by vsurf so that
c    their projections are orientated counterclockwise. the user need
c    only be aware that the vertices may be renumbered by vsurf.
c
      DIMENSION X1(NTRI),Y1(NTRI),Z1(NTRI),X2(NTRI),Y2(NTRI),Z2(NTRI),
     +          X3(NTRI),Y3(NTRI),Z3(NTRI),ITYPE(NTRI),WORK(14*NTRI)
      INTEGER IWORK(6*NTRI)
c
      CALL DVSURF1(XEYE,YEYE,ZEYE,NTRI,X1,Y1,Z1,X2,Y2,Z2,X3,Y3,Z3,
     +             ITYPE,WORK,WORK(NTRI+1),WORK(2*NTRI+1),
     +             WORK(3*NTRI+1),WORK(4*NTRI+1),WORK(5*NTRI+1),
     +             WORK(6*NTRI+1),WORK(7*NTRI+1),WORK(8*NTRI+1),
     +             WORK(9*NTRI+1),WORK(10*NTRI+1),WORK(11*NTRI+1),
     +             WORK(12*NTRI+1),WORK(13*NTRI+1),IWORK,
     +             IWORK(NTRI+1),IWORK(2*NTRI+1),IWORK(4*NTRI+1))
      RETURN
      END
      SUBROUTINE DVSURF1(XEYE,YEYE,ZEYE,NTRI,X1,Y1,Z1,X2,Y2,Z2,X3,Y3,
     +                   Z3,ITYPE,PX1,PY1,PX2,PY2,PX3,PY3,VX1,VY1,VX2,
     +                   VY2,VX3,VY3,TL,TR,KH,NEXT,ISTART,IFINAL)
      DOUBLE PRECISION XEYE
      DOUBLE PRECISION YEYE
      DOUBLE PRECISION ZEYE
      DOUBLE PRECISION X1
      DOUBLE PRECISION Y1
      DOUBLE PRECISION Z1
      DOUBLE PRECISION X2
      DOUBLE PRECISION Y2
      DOUBLE PRECISION Z2
      DOUBLE PRECISION X3
      DOUBLE PRECISION Y3
      DOUBLE PRECISION Z3
      DOUBLE PRECISION PX1
      DOUBLE PRECISION PY1
      DOUBLE PRECISION PX2
      DOUBLE PRECISION PY2
      DOUBLE PRECISION PX3
      DOUBLE PRECISION PY3
      DOUBLE PRECISION VX1
      DOUBLE PRECISION VY1
      DOUBLE PRECISION VX2
      DOUBLE PRECISION VY2
      DOUBLE PRECISION VX3
      DOUBLE PRECISION VY3
      DOUBLE PRECISION TL
      DOUBLE PRECISION TR
      DOUBLE PRECISION FNTRI
      DOUBLE PRECISION X
      DOUBLE PRECISION Y
      DOUBLE PRECISION Z
      DOUBLE PRECISION DUM1
      DOUBLE PRECISION DUM2
      DOUBLE PRECISION CPROD
      DOUBLE PRECISION PX1H
      DOUBLE PRECISION PY1H
      DOUBLE PRECISION X1HOLD
      DOUBLE PRECISION Y1HOLD
      DOUBLE PRECISION Z1HOLD
      DOUBLE PRECISION PMAX
      DOUBLE PRECISION PMIN
      DOUBLE PRECISION XMIN
      DOUBLE PRECISION XMAX
      DOUBLE PRECISION YMIN
      DOUBLE PRECISION YMAX
      DOUBLE PRECISION DMX
      DOUBLE PRECISION DMY
      DOUBLE PRECISION C
      DOUBLE PRECISION D
      DOUBLE PRECISION XMID
      DOUBLE PRECISION HDY
      DOUBLE PRECISION A
      DOUBLE PRECISION B
      DOUBLE PRECISION YMID
      DOUBLE PRECISION HDX
      DOUBLE PRECISION HGR
      DOUBLE PRECISION DXT
      DOUBLE PRECISION HR
      DOUBLE PRECISION TL1
      DOUBLE PRECISION TL2
      DOUBLE PRECISION PX4
      DOUBLE PRECISION PY4
      DOUBLE PRECISION PX5
      DOUBLE PRECISION PY5
      DOUBLE PRECISION X4
      DOUBLE PRECISION Y4
      DOUBLE PRECISION Z4
      DOUBLE PRECISION X5
      DOUBLE PRECISION Y5
      DOUBLE PRECISION Z5
      DOUBLE PRECISION X54
      DOUBLE PRECISION Y54
      DOUBLE PRECISION C17
      DOUBLE PRECISION C27
      DOUBLE PRECISION C37
      DOUBLE PRECISION C14
      DOUBLE PRECISION C25
      DOUBLE PRECISION C36
      DOUBLE PRECISION TMIN
      DOUBLE PRECISION TMAX
      DOUBLE PRECISION XPL
      DOUBLE PRECISION YPL
      DOUBLE PRECISION ZPL
      DOUBLE PRECISION XPR
      DOUBLE PRECISION YPR
      DOUBLE PRECISION ZPR
      DOUBLE PRECISION VX1T
      DOUBLE PRECISION VY1T
      DOUBLE PRECISION VZ1T
      DOUBLE PRECISION VX2T
      DOUBLE PRECISION VY2T
      DOUBLE PRECISION VZ2T
      DOUBLE PRECISION APL
      DOUBLE PRECISION BPL
      DOUBLE PRECISION CPL
      DOUBLE PRECISION DPL
      DOUBLE PRECISION VX3T
      DOUBLE PRECISION VY3T
      DOUBLE PRECISION VZ3T
      DOUBLE PRECISION DEN
      DOUBLE PRECISION TIL
      DOUBLE PRECISION TIR
      DOUBLE PRECISION TIM
      DOUBLE PRECISION THOLD
      DOUBLE PRECISION TLH
      DOUBLE PRECISION TRH
      DOUBLE PRECISION XA
      DOUBLE PRECISION YA
      DOUBLE PRECISION XB
      DOUBLE PRECISION YB
c
      DIMENSION X1(NTRI),Y1(NTRI),Z1(NTRI),X2(NTRI),Y2(NTRI),Z2(NTRI),
     +          X3(NTRI),Y3(NTRI),Z3(NTRI),ITYPE(NTRI),PX1(NTRI),
     +          PY1(NTRI),PX2(NTRI),PY2(NTRI),PX3(NTRI),PY3(NTRI),
     +          VX1(NTRI),VY1(NTRI),VX2(NTRI),VY2(NTRI),VX3(NTRI),
     +          VY3(NTRI),TL(NTRI),TR(NTRI),NEXT(NTRI),KH(NTRI),
     +          ISTART(2*NTRI),IFINAL(2*NTRI),LTP(3),IRD(11),IP2(11),
     +          NCT(11),NCV(11),LAST(11)
c
      DOUBLE PRECISION L2E
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION LE2
C*PT*WARNING* Constant already double-precision
c
c     compute projections of 3-d points
c
      LE2 = .6931471805599453094172321d0
C*PT*WARNING* Constant already double-precision
      L2E = 1.d0/LE2
      FNTRI = NTRI
      IRMAX = .5D0*L2E*LOG(FNTRI)
      IRMAX = MIN(IRMAX,10)
      IRMP1 = IRMAX + 1
      DO 4 ICV = 1,11
          NCV(ICV) = 0
    4 CONTINUE
      NCT(1) = 0
      IP2(1) = 1
      IRD(1) = 0
      ISIZE = 4
      DO 7 IRP1 = 2,IRMP1
          IR = IRP1 - 1
          NCT(IRP1) = 0
          IP2(IRP1) = 2**IR
          IRD(IRP1) = IRD(IR) + ISIZE
          ISIZE = (IP2(IRP1)+1)**2
    7 CONTINUE
      ISXM = IRD(IRMP1) + ISIZE + 1
      DO 8 ISX = 1,ISXM
          ISTART(ISX) = 0
          IFINAL(ISX) = 0
    8 CONTINUE
      DO 6 I = 1,NTRI
          NEXT(I) = 0
    6 CONTINUE
      CALL DPRJCT(0,XEYE,YEYE,ZEYE,X,Y,Z,DUM1,DUM2)
c      write(6,127) ntri
  127 FORMAT (' ntri in hidel',i5)
      DO 86 K = 1,NTRI
          CALL DPRJCT(1,XEYE,YEYE,ZEYE,X1(K),Y1(K),Z1(K),PX1(K),PY1(K))
          CALL DPRJCT(1,XEYE,YEYE,ZEYE,X2(K),Y2(K),Z2(K),PX2(K),PY2(K))
          CALL DPRJCT(1,XEYE,YEYE,ZEYE,X3(K),Y3(K),Z3(K),PX3(K),PY3(K))
          IF (K.LT.3) THEN
c          write(6,333) xeye,yeye,zeye,x1(k),y1(k),z1(k),px1(k),py1(k)
  333         FORMAT (' xeye, etc.',8D8.1)
          END IF
   86 CONTINUE
c
c     orientate triangles counter clockwise
c
      DO 70 K = 1,NTRI
          CPROD = (PX2(K)-PX1(K))* (PY3(K)-PY1(K)) -
     +            (PY2(K)-PY1(K))* (PX3(K)-PX1(K))
c      if(cprod.eq.0.) write(6,79) k,px1(k),px2(k),px3(k),
c     -                              py1(k),py2(k),py3(k)
   79     FORMAT ('  cprod=0 at k=',i5,6D9.2)
          IF (CPROD.GE.0.D0) GO TO 70
          PX1H = PX1(K)
          PY1H = PY1(K)
          PX1(K) = PX2(K)
          PY1(K) = PY2(K)
          PX2(K) = PX1H
          PY2(K) = PY1H
          X1HOLD = X1(K)
          Y1HOLD = Y1(K)
          Z1HOLD = Z1(K)
          X1(K) = X2(K)
          Y1(K) = Y2(K)
          Z1(K) = Z2(K)
          X2(K) = X1HOLD
          Y2(K) = Y1HOLD
          Z2(K) = Z1HOLD
          ITYP = ITYPE(K)
          IF (ITYP.EQ.2) ITYPE(K) = 3
          IF (ITYP.EQ.3) ITYPE(K) = 2
          IF (ITYP.EQ.12) ITYPE(K) = 13
          IF (ITYP.EQ.13) ITYPE(K) = 12
   70 CONTINUE
c
c     set screen limits
c
      PMAX = PX1(1)
      PMIN = PX1(1)
      DO 87 K = 1,NTRI
          PMIN = DMIN1(PMIN,PX1(K),PY1(K),PX2(K),PY2(K),PX3(K),PY3(K))
          PMAX = DMAX1(PMAX,PX1(K),PY1(K),PX2(K),PY2(K),PX3(K),PY3(K))
   87 CONTINUE
      PMIN = 1.1D0*PMIN
      PMAX = 1.1D0*PMAX
      CALL SET(0.D0,1.D0,0.D0,1.D0,PMIN,PMAX,PMIN,PMAX,1)
      XMIN = DMIN1(PX1(1),PX2(1),PX3(1))
      XMAX = DMAX1(PX1(1),PX2(1),PX3(1))
      YMIN = DMIN1(PY1(1),PY2(1),PY3(1))
      YMAX = DMAX1(PY1(1),PY2(1),PY3(1))
      DO 1 I = 2,NTRI
          XMIN = DMIN1(XMIN,PX1(I),PX2(I),PX3(I))
          XMAX = DMAX1(XMAX,PX1(I),PX2(I),PX3(I))
          YMIN = DMIN1(YMIN,PY1(I),PY2(I),PY3(I))
          YMAX = DMAX1(YMAX,PY1(I),PY2(I),PY3(I))
    1 CONTINUE
      DMX = XMAX - XMIN
      DMY = YMAX - YMIN
      IF (DMX.GT.DMY) GO TO 2
      C = YMIN
      D = YMAX
      XMID = .5D0* (XMIN+XMAX)
      HDY = .5D0*DMY
      A = XMID - HDY
      B = XMID + HDY
      GO TO 3
    2 A = XMIN
      B = XMAX
      YMID = .5D0* (YMIN+YMAX)
      HDX = .5D0*DMX
      C = YMID - HDX
      D = YMID + HDX
    3 HGR = B - A
c
c     categorize triangles
c
      DO 100 I = 1,NTRI
          XMIN = DMIN1(PX1(I),PX2(I),PX3(I))
          XMAX = DMAX1(PX1(I),PX2(I),PX3(I))
          YMIN = DMIN1(PY1(I),PY2(I),PY3(I))
          YMAX = DMAX1(PY1(I),PY2(I),PY3(I))
          DXT = DMAX1(XMAX-XMIN,YMAX-YMIN)
          IF (DXT.GT.0.D0) GO TO 10
          IR = IRMAX
          GO TO 20
   10     IR = L2E*LOG(HGR/DXT)
          IR = MIN(IR,IRMAX)
   20     IRP1 = IR + 1
          NCT(IRP1) = NCT(IRP1) + 1
          HR = HGR/IP2(IRP1)
          XMID = .5D0* (XMIN+XMAX)
          ID = (XMID-A)/HR + 1.5D0
          YMID = .5D0* (YMIN+YMAX)
          JD = (YMID-C)/HR + 1.5D0
          IJD = IP2(IRP1) + 1
          ISX = ID + (JD-1)*IJD + IRD(IRP1)
          IFX = IFINAL(ISX)
          IF (IFX.GT.0) GO TO 50
          ISTART(ISX) = I
          GO TO 60
   50     NEXT(IFX) = I
   60     IFINAL(ISX) = I
  100 CONTINUE
c      write(6,106) tcat,(irp1,nct(irp1),irp1=1,irmp1)
  106 FORMAT (' time to categorize   ',D15.6,/, (' ir+1',i3,' ntri',i7))
c
c     sort triangles into boxes
c
      L = 0
      DO 30 IRP1 = 1,IRMP1
          IF (NCT(IRP1).EQ.0) GO TO 30
          IST = IRD(IRP1) + 1
          ISD = IP2(IRP1) + 1
          CALL DBOX(ISD,ISTART(IST),NEXT,L,IFINAL)
          LAST(IRP1) = L + 1
   30 CONTINUE
      DO 35 IRP1 = 1,IRMP1
          IL = IRD(IRP1) + (IP2(IRP1)+1)**2 + 1
          IF (ISTART(IL).EQ.0) ISTART(IL) = LAST(IRP1)
   35 CONTINUE
c      write(6,31) tsort,l,ntri
   31 FORMAT (' time to sort  ',D15.6,'   l',i8,'   ntri',i8)
      DO 90 K = 1,NTRI
          VX1(K) = PX2(K) - PX1(K)
          VY1(K) = PY2(K) - PY1(K)
          VX2(K) = PX3(K) - PX2(K)
          VY2(K) = PY3(K) - PY2(K)
          VX3(K) = PX1(K) - PX3(K)
          VY3(K) = PY1(K) - PY3(K)
   90 CONTINUE
      TL1 = 0.D0
      TL2 = 0.D0
      MAXS = 0
      DO 500 IR2 = 1,IRMP1
          IF (NCT(IR2).EQ.0) GO TO 500
          IST = IRD(IR2)
          ISD = IP2(IR2) + 1
          DO 490 J2 = 1,ISD
              DO 480 I2 = 1,ISD
                  IST = IST + 1
                  LS = ISTART(IST)
                  LF = ISTART(IST+1) - 1
                  IF (LF.LT.LS) GO TO 480
c
c     define coverings
c
                  KCV = 0
                  I2M = I2 - 1
                  J2M = J2 - 1
                  DO 300 IR1 = 1,IRMP1
                      IF (NCT(IR1).EQ.0) GO TO 300
                      IF (IR1.GE.IR2) GO TO 260
                      IRDP = 2** (IR2-IR1)
                      I1S = (I2M-1)/IRDP
                      I1F = (I2M+1)/IRDP
                      IF = I2M + 1 - I1F*IRDP
                      IF (IF.GT.0) I1F = I1F + 1
                      J1S = (J2M-1)/IRDP
                      J1F = (J2M+1)/IRDP
                      JF = J2M + 1 - J1F*IRDP
                      IF (JF.GT.0) J1F = J1F + 1
                      GO TO 270
  260                 IRDP = 2** (IR1-IR2)
                      I1S = IRDP* (I2M-1)
                      I1F = IRDP* (I2M+1)
                      J1S = IRDP* (J2M-1)
                      J1F = IRDP* (J2M+1)
  270                 IJD = IP2(IR1) + 1
                      I1S = MAX(I1S+1,1)
                      I1F = MIN(I1F+1,IJD)
                      J1S = MAX(J1S+1,1)
                      J1F = MIN(J1F+1,IJD)
                      IXH = (J1S-2)*IJD + IRD(IR1)
                      IXS = I1S + IXH
                      IXF = I1F + IXH
                      DO 290 J1 = J1S,J1F
                          IXS = IXS + IJD
                          KDS = ISTART(IXS)
                          IXF = IXF + IJD
                          KDF = ISTART(IXF+1) - 1
                          IF (KDF.LT.KDS) GO TO 290
                          DO 280 KD = KDS,KDF
                              KCV = KCV + 1
                              KH(KCV) = IFINAL(KD)
  280                     CONTINUE
  290                 CONTINUE
  300             CONTINUE
                  DO 310 ICV = 1,10
                      IF (KCV.LE.NCV(ICV)) GO TO 310
                      NCV(ICV) = KCV
                      GO TO 320
  310             CONTINUE
c
c
  320             DO 470 LDO = LS,LF
                      L = IFINAL(LDO)
                      ITH = ITYPE(L)
                      IF (ITH.EQ.0) GO TO 470
                      LTP(1) = 0
                      LTP(2) = 0
                      LTP(3) = 0
                      ID1 = ITH/100
                      ITH = ITH - 100*ID1
                      ID2 = ITH/10
                      ID3 = ITH - 10*ID2
                      IF (ID1.NE.0) LTP(ID1) = 1
                      IF (ID2.NE.0) LTP(ID2) = 1
                      IF (ID3.NE.0) LTP(ID3) = 1
c     if((ith.eq.123) .or. (ith.eq.12) .or.(ith.eq.13)) ltp(1) = 1
c     if((ith.eq.123) .or. (ith.eq.23) .or.(ith.eq.12)) ltp(2) = 1
c     if((ith.eq.123) .or. (ith.eq.13) .or.(ith.eq.23)) ltp(3) = 1
                      DO 460 NS = 1,3
                          GO TO (101,102,103) NS
  101                     IF (LTP(NS).EQ.0) GO TO 460
                          PX4 = PX1(L)
                          PY4 = PY1(L)
                          PX5 = PX2(L)
                          PY5 = PY2(L)
                          X4 = X1(L)
                          Y4 = Y1(L)
                          Z4 = Z1(L)
                          X5 = X2(L)
                          Y5 = Y2(L)
                          Z5 = Z2(L)
                          GO TO 105
  102                     IF (LTP(NS).EQ.0) GO TO 460
                          PX4 = PX2(L)
                          PY4 = PY2(L)
                          PX5 = PX3(L)
                          PY5 = PY3(L)
                          X4 = X2(L)
                          Y4 = Y2(L)
                          Z4 = Z2(L)
                          X5 = X3(L)
                          Y5 = Y3(L)
                          Z5 = Z3(L)
                          GO TO 105
  103                     IF (LTP(NS).EQ.0) GO TO 460
                          PX4 = PX1(L)
                          PY4 = PY1(L)
                          PX5 = PX3(L)
                          PY5 = PY3(L)
                          X4 = X1(L)
                          Y4 = Y1(L)
                          Z4 = Z1(L)
                          X5 = X3(L)
                          Y5 = Y3(L)
                          Z5 = Z3(L)
  105                     X54 = PX5 - PX4
                          Y54 = PY5 - PY4
                          NSEG = 0
                          DO 440 KD = 1,KCV
                              K = KH(KD)
                              C17 = VX1(K)*Y54 - VY1(K)*X54
                              C27 = VX2(K)*Y54 - VY2(K)*X54
                              C37 = VX3(K)*Y54 - VY3(K)*X54
                              C14 = VY1(K)* (PX4-PX1(K)) -
     +                              VX1(K)* (PY4-PY1(K))
                              C25 = VY2(K)* (PX4-PX2(K)) -
     +                              VX2(K)* (PY4-PY2(K))
                              C36 = VY3(K)* (PX4-PX3(K)) -
     +                              VX3(K)* (PY4-PY3(K))
                              TMIN = 0.D0
                              TMAX = 1.D0
                              IF (C17) 151,152,153
  151                         TMAX = DMIN1(C14/C17,TMAX)
                              GO TO 154
  152                         IF (C14) 154,440,440
  153                         TMIN = DMAX1(C14/C17,TMIN)
  154                         IF (C27) 155,156,157
  155                         TMAX = DMIN1(C25/C27,TMAX)
                              GO TO 158
  156                         IF (C25) 158,440,440
  157                         TMIN = DMAX1(C25/C27,TMIN)
  158                         IF (C37) 159,160,161
  159                         TMAX = DMIN1(C36/C37,TMAX)
                              GO TO 162
  160                         IF (C36) 162,440,440
  161                         TMIN = DMAX1(C36/C37,TMIN)
  162                         IF (TMAX-TMIN.LT..00001D0) GO TO 440
                              XPL = X4 + TMIN* (X5-X4)
                              YPL = Y4 + TMIN* (Y5-Y4)
                              ZPL = Z4 + TMIN* (Z5-Z4)
                              XPR = X4 + TMAX* (X5-X4)
                              YPR = Y4 + TMAX* (Y5-Y4)
                              ZPR = Z4 + TMAX* (Z5-Z4)
c
c     the projections of line and plane intersect
c     now determine if plane covers line
c
                              VX1T = X2(K) - X1(K)
                              VY1T = Y2(K) - Y1(K)
                              VZ1T = Z2(K) - Z1(K)
                              VX2T = X3(K) - X1(K)
                              VY2T = Y3(K) - Y1(K)
                              VZ2T = Z3(K) - Z1(K)
                              APL = VY1T*VZ2T - VY2T*VZ1T
                              BPL = VX2T*VZ1T - VX1T*VZ2T
                              CPL = VX1T*VY2T - VX2T*VY1T
                              DPL = APL*X1(K) + BPL*Y1(K) + CPL*Z1(K)
                              VX3T = XPL - XEYE
                              VY3T = YPL - YEYE
                              VZ3T = ZPL - ZEYE
                              DEN = APL*VX3T + BPL*VY3T + CPL*VZ3T
                              TIL = 0.D0
                              IF (DEN.EQ.0.D0) GO TO 410
                              TIL = (DPL-APL*XEYE-BPL*YEYE-CPL*ZEYE)/DEN
  410                         VX3T = XPR - XEYE
                              VY3T = YPR - YEYE
                              VZ3T = ZPR - ZEYE
                              DEN = APL*VX3T + BPL*VY3T + CPL*VZ3T
                              TIR = 0.D0
                              IF (DEN.EQ.0.D0) GO TO 412
                              TIR = (DPL-APL*XEYE-BPL*YEYE-CPL*ZEYE)/DEN
  412                         IF (TIL.GE..99999D0 .AND.
     +                            TIR.GE..99999D0) GO TO 440
                              IF (TIL.LT.1.D0 .AND.
     +                            TIR.LT.1.D0) GO TO 164
                              VX3T = XPR - XPL
                              VY3T = YPR - YPL
                              VZ3T = ZPR - ZPL
                              DEN = APL*VX3T + BPL*VY3T + CPL*VZ3T
                              TIM = 0.D0
                              IF (DEN.EQ.0.D0) GO TO 414
                              TIM = (DPL-APL*XPL-BPL*YPL-CPL*ZPL)/DEN
  414                         THOLD = TMIN + TIM* (TMAX-TMIN)
                              IF (TIL.GE.1.D0) GO TO 163
                              TMAX = THOLD
                              GO TO 164
  163                         TMIN = THOLD
  164                         NSEG = NSEG + 1
                              TL(NSEG) = TMIN
                              TR(NSEG) = TMAX
  440                     CONTINUE
                          MAXS = MAX0(MAXS,NSEG)
                          IF (NSEG-1) 171,180,172
  171                     CALL LINE(PX4,PY4,PX5,PY5)
                          GO TO 460
c
c     order the segments according to left end point tl(k)
c
  172                     DO 173 K = 2,NSEG
                              DO 173 I = K,NSEG
                                  IF (TL(K-1).LE.TL(I)) GO TO 173
                                  TLH = TL(K-1)
                                  TRH = TR(K-1)
                                  TL(K-1) = TL(I)
                                  TR(K-1) = TR(I)
                                  TL(I) = TLH
                                  TR(I) = TRH
  173                     CONTINUE
c
c     eliminate segment overlap
c
                          K1 = 1
                          K2 = 1
  174                     K2 = K2 + 1
                          IF (K2.GT.NSEG) GO TO 176
                          IF (TR(K1).LT.TL(K2)) GO TO 175
                          TR(K1) = DMAX1(TR(K1),TR(K2))
                          GO TO 174
  175                     K1 = K1 + 1
                          TL(K1) = TL(K2)
                          TR(K1) = TR(K2)
                          GO TO 174
  176                     NSEG = K1
c
c     plot all segments of the line
c
  180                     DO 181 KS = 1,NSEG
                              KB = NSEG - KS + 1
                              TL(KB+1) = TR(KB)
                              TR(KB) = TL(KB)
  181                     CONTINUE
                          TL(1) = 0.D0
                          TR(NSEG+1) = 1.D0
                          NSEGP = NSEG + 1
                          DO 450 K = 1,NSEGP
                              IF (ABS(TR(K)-TL(K)).LT.
     +                            .000001D0) GO TO 450
                              XA = PX4 + TL(K)* (PX5-PX4)
                              YA = PY4 + TL(K)* (PY5-PY4)
                              XB = PX4 + TR(K)* (PX5-PX4)
                              YB = PY4 + TR(K)* (PY5-PY4)
                              CALL LINE(XA,YA,XB,YB)
  450                     CONTINUE
  460                 CONTINUE
  470             CONTINUE
  480         CONTINUE
  490     CONTINUE
  500 CONTINUE
c      write(6,903) tl1,tl2
  903 FORMAT (' time to cover',D15.6,/,' time to test ',D15.6)
c      write(6,904) maxs
  904 FORMAT (' maximum number of segments',i5)
c      write(6,250) (ncv(icv),icv=1,10)
  250 FORMAT ('  the ten largest coverings',/, (10i5))
      CALL FRAME
      END
      SUBROUTINE DPRJCT(INIT,XEYE,YEYE,ZEYE,X,Y,Z,PX,PY)
      DOUBLE PRECISION XEYE
      DOUBLE PRECISION YEYE
      DOUBLE PRECISION ZEYE
      DOUBLE PRECISION X
      DOUBLE PRECISION Y
      DOUBLE PRECISION Z
      DOUBLE PRECISION PX
      DOUBLE PRECISION PY
      DOUBLE PRECISION RADS1
      DOUBLE PRECISION RADS2
      DOUBLE PRECISION D1
      DOUBLE PRECISION D2
      DOUBLE PRECISION CX1
      DOUBLE PRECISION CY1
      DOUBLE PRECISION CX2
      DOUBLE PRECISION CY2
      DOUBLE PRECISION CZ2
      DOUBLE PRECISION CX3
      DOUBLE PRECISION CY3
      DOUBLE PRECISION CZ3
      DOUBLE PRECISION X1
      DOUBLE PRECISION Y1
      DOUBLE PRECISION Z1
      DOUBLE PRECISION RATIO
c
c     subroutine prjct projects the point x,y,z onto a plane through
c     the origin that is perpendicular to a line between the origin
c     and the eye. the projection is along the line between the eye
c     and the point x,y,z. px and py are the coordinates of the
c     projection in the plane.
c     (version 2 , 12-10-82)
c
      SAVE

      IF (INIT.NE.0) GO TO 1
      RADS1 = XEYE**2 + YEYE**2
      RADS2 = RADS1 + ZEYE**2
      D1 = SQRT(RADS1)
      D2 = SQRT(RADS2)
      IF (D1.NE.0.D0) GO TO 2
      CX1 = 1.D0
      CY1 = 0.D0
      CX2 = 0.D0
      CY2 = 1.D0
      CZ2 = 0.D0
      CX3 = 0.D0
      CY3 = 0.D0
      CZ3 = 1.D0
      RETURN
    2 CX1 = -YEYE/D1
      CY1 = XEYE/D1
      CX2 = -XEYE*ZEYE/ (D1*D2)
      CY2 = -YEYE*ZEYE/ (D1*D2)
      CZ2 = D1/D2
      CX3 = XEYE/D2
      CY3 = YEYE/D2
      CZ3 = ZEYE/D2
      RETURN
    1 X1 = CX1*X + CY1*Y
      Y1 = CX2*X + CY2*Y + CZ2*Z
      Z1 = CX3*X + CY3*Y + CZ3*Z
      RATIO = D2/ (D2-Z1)
      PX = RATIO*X1
      PY = RATIO*Y1
      RETURN
      END
      SUBROUTINE DBOX(ISD,ISTART,NEXT,L,LIST)
      DIMENSION ISTART(ISD,ISD),NEXT(1),LIST(1)

      DO 30 JD = 1,ISD
          DO 10 ID = 1,ISD
              IDX = ISTART(ID,JD)
              ISTART(ID,JD) = L + 1
              IF (IDX.EQ.0) GO TO 10
   20         L = L + 1
              LIST(L) = IDX
              IF (NEXT(IDX).EQ.0) GO TO 10
              IDX = NEXT(IDX)
              GO TO 20
   10     CONTINUE
   30 CONTINUE
      RETURN
      END

C
C       $Id: fitpack.f,v
C
CThis new version of FITPACK distributed by netlib is about 20% of 
Cthe total package in terms of characters, lines of code, and num-
Cber of subprograms. However, these 25 subprograms represent about
C95% of usages of the package.  What has been omitted are such ca-
Cpabilities as:
C  1. Automatic tension determination,
C  2. Derivatives, arclengths, and enclosed areas for planar 
C     curves,
C  3. Three dimensional curves,
C  4. Special surface fitting using equispacing assumptions,
C  5. Surface fitting in annular, wedge, polar, toroidal, lunar,
C     and spherical geometries,
C  6. B-splines in tension generation and usage,
C  7. General surface fitting in three dimensional space.
C
C(The code previously circulated in netlib is less than 10% of the
Ctotal  package  and is more than a decade old.  Its usage is dis-
Ccouraged.)
C
CPlease note:  Two versions of the subroutine snhcsh are included.
CBoth serve the same purpose:  obtaining approximations to certain
Chyperbolic trigonometric-like functions.  The first is less accu-
Crate (but more efficient) than the second.  Installers should se- 
Clect the one with the precision they desire.
C
CInterested parties can obtain the entire package on disk or  tape
Cfrom Pleasant  Valley Software, 8603 Altus Cove, Austin TX (USA),
C78759 at a cost of $495 US. A 340 page manual  is  available  for
C30 US dollars per  copy.  The  package  includes  examples and
Cmachine readable documentation.
C
      subroutine nhlcurv1 (n,x,y,slp1,slpn,islpsw,yp,temp,
     *                  sigma,ierr)
c
      integer n,islpsw,ierr
      real x(n),y(n),slp1,slpn,yp(n),temp(n),sigma
c
c                                 coded by alan kaylor cline
c                           from fitpack -- january 26, 1987
c                        a curve and surface fitting package
c                      a product of pleasant valley software
c                  8603 altus cove, austin, texas 78759, usa
c
c this subroutine determines the parameters necessary to
c compute an interpolatory spline under tension through
c a sequence of functional values. the slopes at the two
c ends of the curve may be specified or omitted.  for actual
c computation of points on the curve it is necessary to call
c the function nhlcurv2.
c
c on input--
c
c   n is the number of values to be interpolated (n.ge.2).
c
c   x is an array of the n increasing abscissae of the
c   functional values.
c
c   y is an array of the n ordinates of the values, (i. e.
c   y(k) is the functional value corresponding to x(k) ).
c
c   slp1 and slpn contain the desired values for the first
c   derivative of the curve at x(1) and x(n), respectively.
c   the user may omit values for either or both of these
c   parameters and signal this with islpsw.
c
c   islpsw contains a switch indicating which slope data
c   should be used and which should be estimated by this
c   subroutine,
c          = 0 if slp1 and slpn are to be used,
c          = 1 if slp1 is to be used but not slpn,
c          = 2 if slpn is to be used but not slp1,
c          = 3 if both slp1 and slpn are to be estimated
c              internally.
c
c   yp is an array of length at least n.
c
c   temp is an array of length at least n which is used for
c   scratch storage.
c
c and
c
c   sigma contains the tension factor. this value indicates
c   the curviness desired. if abs(sigma) is nearly zero
c   (e.g. .001) the resulting curve is approximately a
c   cubic spline. if abs(sigma) is large (e.g. 50.) the
c   resulting curve is nearly a polygonal line. if sigma
c   equals zero a cubic spline results.  a standard value
c   for sigma is approximately 1. in absolute value.
c
c on output--
c
c   yp contains the values of the second derivative of the
c   curve at the given nodes.
c
c   ierr contains an error flag,
c        = 0 for normal return,
c        = 1 if n is less than 2,
c        = 2 if x-values are not strictly increasing.
c
c and
c
c   n, x, y, slp1, slpn, islpsw and sigma are unaltered.
c
c this subroutine references package modules ceez, terms,
c and snhcsh.
c
c-----------------------------------------------------------
c
      nm1 = n-1
      np1 = n+1
      ierr = 0
      if (n .le. 1) go to 8
      if (x(n) .le. x(1)) go to 9
c
c denormalize tension factor
c
      sigmap = abs(sigma)*float(n-1)/(x(n)-x(1))
c
c approximate end slopes
c
      if (islpsw .ge. 2) go to 1
      slpp1 = slp1
      go to 2
    1 delx1 = x(2)-x(1)
      delx2 = delx1+delx1
      if (n .gt. 2) delx2 = x(3)-x(1)
      if (delx1 .le. 0. .or. delx2 .le. delx1) go to 9
      call ceez (delx1,delx2,sigmap,c1,c2,c3,n)
      slpp1 = c1*y(1)+c2*y(2)
      if (n .gt. 2) slpp1 = slpp1+c3*y(3)
    2 if (islpsw .eq. 1 .or. islpsw .eq. 3) go to 3
      slppn = slpn
      go to 4
    3 delxn = x(n)-x(nm1)
      delxnm = delxn+delxn
      if (n .gt. 2) delxnm = x(n)-x(n-2)
      if (delxn .le. 0. .or. delxnm .le. delxn) go to 9
      call ceez (-delxn,-delxnm,sigmap,c1,c2,c3,n)
      slppn = c1*y(n)+c2*y(nm1)
      if (n .gt. 2) slppn = slppn+c3*y(n-2)
c
c set up right hand side and tridiagonal system for yp and
c perform forward elimination
c
    4 delx1 = x(2)-x(1)
      if (delx1 .le. 0.) go to 9
      dx1 = (y(2)-y(1))/delx1
      call terms (diag1,sdiag1,sigmap,delx1)
      yp(1) = (dx1-slpp1)/diag1
      temp(1) = sdiag1/diag1
      if (n .eq. 2) go to 6
      do 5 i = 2,nm1
        delx2 = x(i+1)-x(i)
        if (delx2 .le. 0.) go to 9
        dx2 = (y(i+1)-y(i))/delx2
        call terms (diag2,sdiag2,sigmap,delx2)
        diag = diag1+diag2-sdiag1*temp(i-1)
        yp(i) = (dx2-dx1-sdiag1*yp(i-1))/diag
        temp(i) = sdiag2/diag
        dx1 = dx2
        diag1 = diag2
    5   sdiag1 = sdiag2
    6 diag = diag1-sdiag1*temp(nm1)
      yp(n) = (slppn-dx1-sdiag1*yp(nm1))/diag
c
c perform back substitution
c
      do 7 i = 2,n
        ibak = np1-i
    7   yp(ibak) = yp(ibak)-temp(ibak)*yp(ibak+1)
      return
c
c too few points
c
    8 ierr = 1
      return
c
c x-values not strictly increasing
c
    9 ierr = 2
      return
      end

      subroutine nhlcurv2 (t,ret,n,x,y,yp,sigma)
c
      integer n
      real t,x(n),y(n),yp(n),sigma,ret
c
c                                 coded by alan kaylor cline
c                           from fitpack -- january 26, 1987
c                        a curve and surface fitting package
c                      a product of pleasant valley software
c                  8603 altus cove, austin, texas 78759, usa
c
c this function interpolates a curve at a given point
c using a spline under tension. the subroutine nhlcurv1 should
c be called earlier to determine certain necessary
c parameters.
c
c on input--
c
c   t contains a real value to be mapped onto the interpo-
c   lating curve.
c
c   n contains the number of points which were specified to
c   determine the curve.
c
c   x and y are arrays containing the abscissae and
c   ordinates, respectively, of the specified points.
c
c   yp is an array of second derivative values of the curve
c   at the nodes.
c
c and
c
c   sigma contains the tension factor (its sign is ignored).
c
c the parameters n, x, y, yp, and sigma should be input
c unaltered from the output of nhlcurv1.
c
c on output--
c
c   nhlcurv2 contains the interpolated value.
c
c none of the input parameters are altered.
c
c this function references package modules intrvl and
c snhcsh.
c
c-----------------------------------------------------------
c
c determine interval
c
      im1 = intrvl(t,x,n)
      i = im1+1
c
c denormalize tension factor
c
      sigmap = abs(sigma)*float(n-1)/(x(n)-x(1))
c
c set up and perform interpolation
c
      del1 = t-x(im1)
      del2 = x(i)-t
      dels = x(i)-x(im1)
      sum = (y(i)*del1+y(im1)*del2)/dels
      if (sigmap .ne. 0.) go to 1
      ret = sum-del1*del2*(yp(i)*(del1+dels)+yp(im1)*
     *        (del2+dels))/(6.*dels)
      return
    1 sigdel = sigmap*dels
      call snhcsh (ss,dummy,sigdel,-1)
      call snhcsh (s1,dummy,sigmap*del1,-1)
      call snhcsh (s2,dummy,sigmap*del2,-1)
      ret = sum+(yp(i)*del1*(s1-ss)+yp(im1)*del2*(s2-ss))/
     *            (sigdel*sigmap*(1.+ss))
      return
      end
      function curvd (t,n,x,y,yp,sigma)
c
      integer n
      real t,x(n),y(n),yp(n),sigma
c
c                                 coded by alan kaylor cline
c                           from fitpack -- january 26, 1987
c                        a curve and surface fitting package
c                      a product of pleasant valley software
c                  8603 altus cove, austin, texas 78759, usa
c
c this function differentiates a curve at a given point
c using a spline under tension. the subroutine nhlcurv1 should
c be called earlier to determine certain necessary
c parameters.
c
c on input--
c
c   t contains a real value at which the derivative is to be
c   determined.
c
c   n contains the number of points which were specified to
c   determine the curve.
c
c   x and y are arrays containing the abscissae and
c   ordinates, respectively, of the specified points.
c
c   yp is an array of second derivative values of the curve
c   at the nodes.
c
c and
c
c   sigma contains the tension factor (its sign is ignored).
c
c the parameters n, x, y, yp, and sigma should be input
c unaltered from the output of nhlcurv1.
c
c on output--
c
c   curvd contains the derivative value.
c
c none of the input parameters are altered.
c
c this function references package modules intrvl and
c snhcsh.
c
c-----------------------------------------------------------
c
c determine interval
c
      im1 = intrvl(t,x,n)
      i = im1+1
c
c denormalize tension factor
c
      sigmap = abs(sigma)*float(n-1)/(x(n)-x(1))
c
c set up and perform differentiation
c
      del1 = t-x(im1)
      del2 = x(i)-t
      dels = x(i)-x(im1)
      sum = (y(i)-y(im1))/dels
      if (sigmap .ne. 0.) go to 1
      curvd = sum+(yp(i)*(2.*del1*del1-del2*(del1+dels))-
     *             yp(im1)*(2.*del2*del2-del1*(del2+dels)))
     *             /(6.*dels)
      return
    1 sigdel = sigmap*dels
      call snhcsh (ss,dummy,sigdel,-1)
      call snhcsh (dummy,c1,sigmap*del1,1)
      call snhcsh (dummy,c2,sigmap*del2,1)
      curvd = sum+(yp(i)*(c1-ss)-yp(im1)*(c2-ss))/
     *        (sigdel*sigmap*(1.+ss))
      return
      end
      function curvi (xl,xu,n,x,y,yp,sigma)
c
      integer n
      real xl,xu,x(n),y(n),yp(n),sigma
c
c                                 coded by alan kaylor cline
c                           from fitpack -- january 26, 1987
c                        a curve and surface fitting package
c                      a product of pleasant valley software
c                  8603 altus cove, austin, texas 78759, usa
c
c this function integrates a curve specified by a spline
c under tension between two given limits. the subroutine
c nhlcurv1 should be called earlier to determine necessary
c parameters.
c
c on input--
c
c   xl and xu contain the upper and lower limits of inte-
c   gration, respectively. (sl need not be less than or
c   equal to xu, curvi (xl,xu,...) .eq. -curvi (xu,xl,...) ).
c
c   n contains the number of points which were specified to
c   determine the curve.
c
c   x and y are arrays containing the abscissae and
c   ordinates, respectively, of the specified points.
c
c   yp is an array from subroutine nhlcurv1 containing
c   the values of the second derivatives at the nodes.
c
c and
c
c   sigma contains the tension factor (its sign is ignored).
c
c the parameters n, x, y, yp, and sigma should be input
c unaltered from the output of nhlcurv1.
c
c on output--
c
c   curvi contains the integral value.
c
c none of the input parameters are altered.
c
c this function references package modules intrvl and
c snhcsh.
c
c-----------------------------------------------------------
c
c denormalize tension factor
c
      sigmap = abs(sigma)*float(n-1)/(x(n)-x(1))
c
c determine actual upper and lower bounds
c
      xxl = xl
      xxu = xu
      ssign = 1.
      if (xl .lt. xu) go to 1
      xxl = xu
      xxu = xl
      ssign = -1.
      if (xl .gt. xu) go to 1
c
c return zero if xl .eq. xu
c
      curvi = 0.
      return
c
c search for proper intervals
c
    1 ilm1 = intrvl (xxl,x,n)
      il = ilm1+1
      ium1 = intrvl (xxu,x,n)
      iu = ium1+1
      if (il .eq. iu) go to 8
c
c integrate from xxl to x(il)
c
      sum = 0.
      if (xxl .eq. x(il)) go to 3
      del1 = xxl-x(ilm1)
      del2 = x(il)-xxl
      dels = x(il)-x(ilm1)
      t1 = (del1+dels)*del2/(2.*dels)
      t2 = del2*del2/(2.*dels)
      sum = t1*y(il)+t2*y(ilm1)
      if (sigma .eq. 0.) go to 2
      call snhcsh (dummy,c1,sigmap*del1,2)
      call snhcsh (dummy,c2,sigmap*del2,2)
      call snhcsh (ss,cs,sigmap*dels,3)
      sum = sum+((dels*dels*(cs-ss/2.)-del1*del1*(c1-ss/2.))
     *           *yp(il)+del2*del2*(c2-ss/2.)*yp(ilm1))/
     *          (sigmap*sigmap*dels*(1.+ss))
      go to 3
    2 sum = sum-t1*t1*dels*yp(il)/6.
     *         -t2*(del1*(del2+dels)+dels*dels)*yp(ilm1)/12.
c
c integrate over interior intervals
c
    3 if (iu-il .eq. 1) go to 6
      ilp1 = il+1
      do 5 i = ilp1,ium1
        dels = x(i)-x(i-1)
        sum = sum+(y(i)+y(i-1))*dels/2.
        if (sigma .eq. 0.) go to 4
        call snhcsh (ss,cs,sigmap*dels,3)
        sum = sum+(yp(i)+yp(i-1))*dels*(cs-ss/2.)/
     *            (sigmap*sigmap*(1.+ss))
        go to 5
    4   sum = sum-(yp(i)+yp(i-1))*dels*dels*dels/24.
    5   continue
c
c integrate from x(iu-1) to xxu
c
    6 if (xxu .eq. x(ium1)) go to 10
      del1 = xxu-x(ium1)
      del2 = x(iu)-xxu
      dels = x(iu)-x(ium1)
      t1 = del1*del1/(2.*dels)
      t2 = (del2+dels)*del1/(2.*dels)
      sum = sum+t1*y(iu)+t2*y(ium1)
      if (sigma .eq. 0.) go to 7
      call snhcsh (dummy,c1,sigmap*del1,2)
      call snhcsh (dummy,c2,sigmap*del2,2)
      call snhcsh (ss,cs,sigmap*dels,3)
      sum = sum+(yp(iu)*del1*del1*(c1-ss/2.)+yp(ium1)*
     *          (dels*dels*(cs-ss/2.)-del2*del2*(c2-ss/2.)))
     *         /(sigmap*sigmap*dels*(1.+ss))
      go to 10
    7 sum = sum-t1*(del2*(del1+dels)+dels*dels)*yp(iu)/12.
     *         -t2*t2*dels*yp(ium1)/6.
      go to 10
c
c integrate from xxl to xxu
c
    8 delu1 = xxu-x(ium1)
      delu2 = x(iu)-xxu
      dell1 = xxl-x(ium1)
      dell2 = x(iu)-xxl
      dels = x(iu)-x(ium1)
      deli = xxu-xxl
      t1 = (delu1+dell1)*deli/(2.*dels)
      t2 = (delu2+dell2)*deli/(2.*dels)
      sum = t1*y(iu)+t2*y(ium1)
      if (sigma .eq. 0.) go to 9
      call snhcsh (dummy,cu1,sigmap*delu1,2)
      call snhcsh (dummy,cu2,sigmap*delu2,2)
      call snhcsh (dummy,cl1,sigmap*dell1,2)
      call snhcsh (dummy,cl2,sigmap*dell2,2)
      call snhcsh (ss,dummy,sigmap*dels,-1)
      sum = sum+(yp(iu)*(delu1*delu1*(cu1-ss/2.)
     *            -dell1*dell1*(cl1-ss/2.))
     *          +yp(ium1)*(dell2*dell2*(cl2-ss/2.)
     *            -delu2*delu2*(cu2-ss/2.)))/
     *          (sigmap*sigmap*dels*(1.+ss))
      go to 10
    9 sum = sum-t1*(delu2*(dels+delu1)+dell2*(dels+dell1))*
     *             yp(iu)/12.
     *         -t2*(dell1*(dels+dell2)+delu1*(dels+delu2))*
     *             yp(ium1)/12.
c
c correct sign and return
c
   10 curvi = ssign*sum
      return
      end
      subroutine curvp1 (n,x,y,p,yp,temp,sigma,ierr)
c
      integer n,ierr
      real x(n),y(n),p,yp(n),temp(1),sigma
c
c                                 coded by alan kaylor cline
c                           from fitpack -- january 26, 1987
c                        a curve and surface fitting package
c                      a product of pleasant valley software
c                  8603 altus cove, austin, texas 78759, usa
c
c this subroutine determines the parameters necessary to
c compute a periodic interpolatory spline under tension
c through a sequence of functional values. for actual ends
c of the curve may be specified or omitted.  for actual
c computation of points on the curve it is necessary to call
c the function curvp2.
c
c on input--
c
c   n is the number of values to be interpolated (n.ge.2).
c
c   x is an array of the n increasing abscissae of the
c   functional values.
c
c   y is an array of the n ordinates of the values, (i. e.
c   y(k) is the functional value corresponding to x(k) ).
c
c   p is the period (p .gt. x(n)-x(1)).
c
c   yp is an array of length at least n.
c
c   temp is an array of length at least 2*n which is used
c   for scratch storage.
c
c and
c
c   sigma contains the tension factor.  this value indicates
c   the curviness desired. if abs(sigma) is nearly zero
c   (e.g. .001) the resulting curve is approximately a
c   cubic spline. if abs(sigma) is large (e.g. 50.) the
c   resulting curve is nearly a polygonal line. if sigma
c   equals zero a cubic spline results.  a standard value
c   for sigma is approximately 1. in absolute value.
c
c on output--
c
c   yp contains the values of the second derivative of the
c   curve at the given nodes.
c
c   ierr contains an error flag,
c        = 0 for normal return,
c        = 1 if n is less than 2,
c        = 2 if p is less than or equal to x(n)-x(1),
c        = 3 if x-values are not strictly increasing.
c
c and
c
c  n, x, y, and sigma are unaltered.
c
c this subroutine references package modules terms and
c snhcsh.
c
c-----------------------------------------------------------
c
      nm1 = n-1
      np1 = n+1
      ierr = 0
      if (n .le. 1) go to 6
      if (p .le. x(n)-x(1) .or. p .le. 0.) go to 7
c
c denormalize tension factor
c
      sigmap = abs(sigma)*float(n)/p
c
c set up right hand side and tridiagonal system for yp and
c perform forward elimination
c
      delx1 = p-(x(n)-x(1))
      dx1 = (y(1)-y(n))/delx1
      call terms (diag1,sdiag1,sigmap,delx1)
      delx2 = x(2)-x(1)
      if (delx2 .le. 0.) go to 8
      dx2 = (y(2)-y(1))/delx2
      call terms (diag2,sdiag2,sigmap,delx2)
      diag = diag1+diag2
      yp(1) = (dx2-dx1)/diag
      temp(np1) = -sdiag1/diag
      temp(1) = sdiag2/diag
      dx1 = dx2
      diag1 = diag2
      sdiag1 = sdiag2
      if (n .eq. 2) go to 2
      do 1 i = 2,nm1
        npi = n+i
        delx2 = x(i+1)-x(i)
        if (delx2 .le. 0.) go to 8
        dx2 = (y(i+1)-y(i))/delx2
        call terms (diag2,sdiag2,sigmap,delx2)
        diag = diag1+diag2-sdiag1*temp(i-1)
        yp(i) = (dx2-dx1-sdiag1*yp(i-1))/diag
        temp(npi) = -temp(npi-1)*sdiag1/diag
        temp(i) = sdiag2/diag
        dx1 = dx2
        diag1 = diag2
    1   sdiag1 = sdiag2
    2 delx2 = p-(x(n)-x(1))
      dx2 = (y(1)-y(n))/delx2
      call terms (diag2,sdiag2,sigmap,delx2)
      yp(n) = dx2-dx1
      temp(nm1) = temp(2*n-1)-temp(nm1)
      if (n .eq. 2) go to 4
c
c perform first step of back substitution
c
      do 3 i = 3,n
        ibak = np1-i
        npibak =n+ibak
        yp(ibak) = yp(ibak)-temp(ibak)*yp(ibak+1)
    3   temp(ibak) =temp(npibak)-temp(ibak)*temp(ibak+1)
    4 yp(n) = (yp(n)-sdiag2*yp(1)-sdiag1*yp(nm1))/
     *        (diag1+diag2+sdiag2*temp(1)+sdiag1*temp(nm1))
c
c perform second step of back substitution
c
      ypn =   yp(n)
      do 5 i = 1,nm1
    5    yp(i) = yp(i)+temp(i)*ypn
      return
c
c too few points
c
    6 ierr = 1
      return
c
c period too small
c
    7 ierr = 2
      return
c
c x-values not strictly increasing
c
    8 ierr = 3
      return
      end
      function curvp2 (t,n,x,y,p,yp,sigma)
c
      integer n
      real t,x(n),y(n),p,yp(n),sigma
c
c                                 coded by alan kaylor cline
c                           from fitpack -- january 26, 1987
c                        a curve and surface fitting package
c                      a product of pleasant valley software
c                  8603 altus cove, austin, texas 78759, usa
c
c this function interpolates a curve at a given point using
c a periodic spline under tension. the subroutine curvp1
c should be called earlier to determine certain necessary
c parameters.
c
c on input--
c
c   t contains a real value to be mapped onto the interpo-
c   lating curve.
c
c   n contains the number of points which were specified to
c   determine the curve.
c
c   x and y are arrays containing the abscissae and
c   ordinates, respectively, of the specified points.
c
c   p contains the period.
c
c   yp is an array of second derivative values of the curve
c   at the nodes.
c
c and
c
c   sigma contains the tension factor (its sign is ignored).
c
c the parameters n, x, y, p, yp, and sigma should be input
c unaltered from the output of curvp1.
c
c on output--
c
c   curvp2 contains the interpolated value.
c
c none of the input parameters are altered.
c
c this function references package modules intrvp and
c snhcsh.
c
c-----------------------------------------------------------
c
c determine interval
c
      im1 = intrvp (t,x,n,p,tp)
      i = im1+1
c
c denormalize tension factor
c
      sigmap = abs(sigma)*float(n)/p
c
c set up and perform interpolation
c
      del1 = tp-x(im1)
      if (im1 .eq. n) go to 1
      del2 = x(i)-tp
      dels = x(i)-x(im1)
      go to 2
    1 i = 1
      del2 = x(1)+p-tp
      dels = p-(x(n)-x(1))
    2 sum = (y(i)*del1+y(im1)*del2)/dels
      if (sigmap .ne. 0.) go to 3
      curvp2 = sum-del1*del2*(yp(i)*(del1+dels)+yp(im1)*
     *        (del2+dels))/(6.*dels)
      return
    3 sigdel = sigmap*dels
      call snhcsh (ss,dummy,sigdel,-1)
      call snhcsh (s1,dummy,sigmap*del1,-1)
      call snhcsh (s2,dummy,sigmap*del2,-1)
      curvp2 = sum+(yp(i)*del1*(s1-ss)+yp(im1)*del2*(s2-ss))/
     *            (sigdel*sigmap*(1.+ss))
      return
      end
      function curvpi (xl,xu,n,x,y,p,yp,sigma)
c
      integer n
      real xl,xu,x(n),y(n),p,yp(n),sigma
c
c                                 coded by alan kaylor cline
c                           from fitpack -- january 26, 1987
c                        a curve and surface fitting package
c                      a product of pleasant valley software
c                  8603 altus cove, austin, texas 78759, usa
c
c this function integrates a curve specified by a periodic
c spline under tension between two given limits. the
c subroutine curvp1 should be called earlier to determine
c necessary parameters.
c
c on input--
c
c   xl and xu contain the upper and lower limits of inte-
c   gration, respectively. (sl need not be less than or
c   equal to xu, curvpi (xl,xu,...) .eq. -curvpi (xu,xl,...) ).
c
c   n contains the number of points which were specified to
c   determine the curve.
c
c   x and y are arrays containing the abscissae and
c   ordinates, respectively, of the specified points.
c
c   p contains the period.
c
c   yp is an array from subroutine curvp1 containing
c   the values of the second derivatives at the nodes.
c
c and
c
c   sigma contains the tension factor (its sign is ignored).
c
c the parameters n, x, y, p, yp, and sigma should be input
c unaltered from the output of curvp1.
c
c on output--
c
c
c   curvpi contains the integral value.
c
c none of the input parameters are altered.
c
c this function references package modules intrvp and
c snhcsh.
c
c--------------------------------------------------------------
c
      integer uper
      logical bdy
c
c denormalize tension factor
c
      sigmap = abs(sigma)*float(n)/p
c
c determine actual upper and lower bounds
c
      x1pp = x(1)+p
      isign = 1
      ilm1 = intrvp (xl,x,n,p,xxl)
      lper = int((xl-x(1))/p)
      if (xl .lt. x(1)) lper = lper-1
      ium1 = intrvp (xu,x,n,p,xxu)
      uper = int((xu-x(1))/p)
      if (xu .lt. x(1)) uper = uper-1
      ideltp = uper-lper
      bdy = float(ideltp)*(xxu-xxl) .lt. 0.
      if ((ideltp .eq. 0 .and. xxu .lt. xxl) .or.
     *    ideltp .lt. 0) isign = -1
      if (bdy) ideltp = ideltp-isign
      if (xxu .ge. xxl) go to 1
      xsave = xxl
      xxl = xxu
      xxu = xsave
      isave = ilm1
      ilm1 = ium1
      ium1 = isave
    1 il = ilm1+1
      if (ilm1 .eq. n) il = 1
      xil = x(il)
      if (ilm1 .eq. n) xil = x1pp
      iu = ium1+1
      if (ium1 .eq. n) iu = 1
      xiu = x(iu)
      if (ium1 .eq. n) xiu = x1pp
      s1 = 0.
      if (ilm1 .eq. 1 .or. (ideltp .eq. 0 .and.
     *    .not. bdy)) go to 4
c
c integrate from x(1) to x(ilm1), store in s1
c
      do 3 i = 2,ilm1
        dels = x(i)-x(i-1)
        s1 = s1+(y(i)+y(i-1))*dels/2.
        if (sigma .eq. 0.) go to 2
        call snhcsh (ss,cs,sigmap*dels,3)
        s1 = s1+(yp(i)+yp(i-1))*dels*(cs-ss/2.)/
     *            (sigmap*sigmap*(1.+ss))
        go to 3
    2   s1 = s1-(yp(i)+yp(i-1))*dels*dels*dels/24.
    3   continue
    4 s2 = 0.
      if (x(ilm1) .ge. xxl .or. (ideltp .eq. 0
     *    .and. .not. bdy)) go to 6
c
c integrate from x(ilm1) to xxl, store in s2
c
      del1 = xxl-x(ilm1)
      del2 = xil-xxl
      dels = xil-x(ilm1)
      t1 = del1*del1/(2.*dels)
      t2 = (del2+dels)*del1/(2.*dels)
      s2 = t1*y(il)+t2*y(ilm1)
      if (sigma .eq. 0.) go to 5
      call snhcsh (dummy,c1,sigmap*del1,2)
      call snhcsh (dummy,c2,sigmap*del2,2)
      call snhcsh (ss,cs,sigmap*dels,3)
      s2 = s2+(yp(il)*del1*del1*(c1-ss/2.)+yp(ilm1)*
     *          (dels*dels*(cs-ss/2.)-del2*del2*(c2-ss/2.)))
     *         /(sigmap*sigmap*dels*(1.+ss))
      go to 6
    5 s2 = s2-t1*(del2*(del1+dels)
     *     +dels*dels)*yp(il)/12.
     *     -t2*t2*dels*yp(ilm1)/6.
    6 s3 = 0.
      if (xxl .ge. xil .or. (ideltp .eq. 0 .and. bdy)
     *    .or. ilm1 .eq. ium1) go to 8
c
c integrate from xxl to xil, store in s3
c
      del1 = xxl-x(ilm1)
      del2 = xil-xxl
      dels = xil-x(ilm1)
      t1 = (del1+dels)*del2/(2.*dels)
      t2 = del2*del2/(2.*dels)
      s3 = t1*y(il)+t2*y(ilm1)
      if (sigma .eq. 0.) go to 7
      call snhcsh (dummy,c1,sigmap*del1,2)
      call snhcsh (dummy,c2,sigmap*del2,2)
      call snhcsh (ss,cs,sigmap*dels,3)
      s3 = s3+((dels*dels*(cs-ss/2.)-del1*del1*(c1-ss/2.))
     *           *yp(il)+del2*del2*(c2-ss/2.)*yp(ilm1))/
     *          (sigmap*sigmap*dels*(1.+ss))
      go to 8
    7 s3 = s3-t1*t1*dels*yp(il)/6.
     *     -t2*(del1*(del2+dels)+dels*dels)*
     *     yp(ilm1)/12.
    8 s4 = 0.
      if (ilm1 .ge. ium1-1 .or. (ideltp .eq. 0 .and. bdy))
     *   go to 11
c
c integrate from xil to x(ium1), store in s4
c
      ilp1 = il+1
      do 10 i = ilp1,ium1
        dels = x(i)-x(i-1)
        s4 = s4+(y(i)+y(i-1))*dels/2.
        if (sigma .eq. 0.) go to 9
        call snhcsh (ss,cs,sigmap*dels,3)
        s4 = s4+(yp(i)+yp(i-1))*dels*(cs-ss/2.)/
     *            (sigmap*sigmap*(1.+ss))
        go to 10
    9   s4 = s4-(yp(i)+yp(i-1))*dels*dels*dels/24.
   10   continue
   11 s5 = 0.
      if (x(ium1) .ge. xxu .or. (ideltp .eq. 0 .and. bdy)
     *    .or. ilm1 .eq. ium1) go to 13
c
c integrate from x(ium1) to xxu, store in s5
c
      del1 = xxu-x(ium1)
      del2 = xiu-xxu
      dels = xiu-x(ium1)
      t1 = del1*del1/(2.*dels)
      t2 = (del2+dels)*del1/(2.*dels)
      s5 = t1*y(iu)+t2*y(ium1)
      if (sigma .eq. 0.) go to 12
      call snhcsh (dummy,c1,sigmap*del1,2)
      call snhcsh (dummy,c2,sigmap*del2,2)
      call snhcsh (ss,cs,sigmap*dels,3)
      s5 = s5+(yp(iu)*del1*del1*(c1-ss/2.)+yp(ium1)*
     *          (dels*dels*(cs-ss/2.)-del2*del2*(c2-ss/2.)))
     *         /(sigmap*sigmap*dels*(1.+ss))
      go to 13
   12 s5 = s5-t1*(del2*(del1+dels)
     *     +dels*dels)*yp(iu)/12.
     *     -t2*t2*dels*yp(ium1)/6.
   13 s6 = 0.
      if (xxu .ge. xiu .or. (ideltp .eq. 0 .and.
     *    .not. bdy)) go to 15
c
c integrate from xxu to xiu, store in s6
c
      del1 = xxu-x(ium1)
      del2 = xiu-xxu
      dels = xiu-x(ium1)
      t1 = (del1+dels)*del2/(2.*dels)
      t2 = del2*del2/(2.*dels)
      s6 = t1*y(iu)+t2*y(ium1)
      if (sigma .eq. 0.) go to 14
      call snhcsh (dummy,c1,sigmap*del1,2)
      call snhcsh (dummy,c2,sigmap*del2,2)
      call snhcsh (ss,cs,sigmap*dels,3)
      s6 = s6+((dels*dels*(cs-ss/2.)-del1*del1*(c1-ss/2.))
     *           *yp(iu)+del2*del2*(c2-ss/2.)*yp(ium1))/
     *          (sigmap*sigmap*dels*(1.+ss))
      go to 15
   14 s6 = s6-t1*t1*dels*yp(iu)/6.
     *     -t2*(del1*(del2+dels)+dels*dels)*
     *     yp(ium1)/12.
   15 s7 = 0.
      if (iu .eq. 1 .or. (ideltp .eq. 0 .and. .not. bdy))
     *    go to 18
c
c integrate from xiu to x1pp, store in s7
c
      np1 = n+1
      iup1 = iu+1
      do 17 ii = iup1,np1
        im1 = ii-1
        i = ii
        if (i .eq. np1) i=1
        dels = x(i)-x(im1)
        if (dels .le. 0.) dels=dels+p
        s7 = s7+(y(i)+y(im1))*dels/2.
        if (sigma .eq. 0.) go to 16
        call snhcsh (ss,cs,sigmap*dels,3)
        s7 = s7+(yp(i)+yp(im1))*dels*(cs-ss/2.)/
     *            (sigmap*sigmap*(1.+ss))
        go to 17
   16   s7 = s7-(yp(i)+yp(im1))*dels*dels*dels/24.
   17   continue
   18 s8 = 0.
      if (ilm1 .lt. ium1 .or. (ideltp .eq. 0 .and. bdy))
     *   go to 20
c
c integrate from xxl to xxu, store in s8
c
      delu1 = xxu-x(ium1)
      delu2 = xiu-xxu
      dell1 = xxl-x(ium1)
      dell2 = xiu-xxl
      dels = xiu-x(ium1)
      deli = xxu-xxl
      t1 = (delu1+dell1)*deli/(2.*dels)
      t2 = (delu2+dell2)*deli/(2.*dels)
      s8 = t1*y(iu)+t2*y(ium1)
      if (sigma .eq. 0.) go to 19
      call snhcsh (dummy,cu1,sigmap*delu1,2)
      call snhcsh (dummy,cu2,sigmap*delu2,2)
      call snhcsh (dummy,cl1,sigmap*dell1,2)
      call snhcsh (dummy,cl2,sigmap*dell2,2)
      call snhcsh (ss,dummy,sigmap*dels,-1)
      s8 = s8+(yp(iu)*(delu1*delu1*(cu1-ss/2.)
     *            -dell1*dell1*(cl1-ss/2.))
     *          +yp(ium1)*(dell2*dell2*(cl2-ss/2.)
     *            -delu2*delu2*(cu2-ss/2.)))/
     *          (sigmap*sigmap*dels*(1.+ss))
      go to 20
   19 s8 = s8-t1*(delu2*(dels+delu1)
     *     +dell2*(dels+dell1))*yp(iu)/12.
     *     -t2*(dell1*(dels+dell2)
     *     +delu1*(dels+delu2))*yp(ium1)/12.
   20 so = s1+s2+s6+s7
      si = s3+s4+s5+s8
      if (bdy) go to 21
      curvpi = float(ideltp)*(so+si)+float(isign)*si
      return
   21 curvpi = float(ideltp)*(so+si)+float(isign)*so
      return
      end
      subroutine kurv1 (n,x,y,slp1,slpn,islpsw,xp,yp,temp,s,
     *                  sigma,ierr)
c
      integer n,islpsw,ierr
      real x(n),y(n),slp1,slpn,xp(n),yp(n),temp(n),s(n),
     *     sigma
c
c                                 coded by alan kaylor cline
c                           from fitpack -- january 26, 1987
c                        a curve and surface fitting package
c                      a product of pleasant valley software
c                  8603 altus cove, austin, texas 78759, usa
c
c this subroutine determines the parameters necessary to
c compute a spline under tension forming a curve in the
c plane and passing through a sequence of pairs (x(1),y(1)),
c ...,(x(n),y(n)). for actual computation of points on the
c curve it is necessary to call the subroutine kurv2.
c
c on input--
c
c   n is the number of points to be interpolated (n.ge.2).
c
c   x is an array containing the n x-coordinates of the
c   points.
c
c   y is an array containing the n y-coordinates of the
c   points. (adjacent x-y pairs must be distinct, i. e.
c   either x(i) .ne. x(i+1) or y(i) .ne. y(i+1), for
c   i = 1,...,n-1.)
c
c   slp1 and slpn contain the desired values for the angles
c   (in radians) of the slope at (x(1),y(1)) and (x(n),y(n))
c   respectively. the angles are measured counter-clock-
c   wise from the x-axis and the positive sense of the curve
c   is assumed to be that moving from point 1 to point n.
c   the user may omit values for either or both of these
c   parameters and signal this with islpsw.
c
c   islpsw contains a switch indicating which slope data
c   should be used and which should be estimated by this
c   subroutine,
c          = 0 if slp1 and slpn are to be used,
c          = 1 if slp1 is to be used but not slpn,
c          = 2 if slpn is to be used but not slp1,
c          = 3 if both slp1 and slpn are to be estimated
c              internally.
c
c   xp and yp are arrays of length at least n.
c
c   temp is an array of length at least n which is used
c   for scratch storage.
c
c   s is an array of length at least n.
c
c and
c
c   sigma contains the tension factor. this value indicates
c   the curviness desired. if abs(sigma) is nearly zero
c   (e.g. .001) the resulting curve is approximately a cubic
c   spline. if abs(sigma) is large (e. g. 50.) the resulting
c   curve is nearly a polygonal line. if sigma equals zero a
c   cubic spline results. a standard value for sigma is
c   approximately 1. in absolute value.
c
c on output--
c
c   xp and yp contain information about the curvature of the
c   curve at the given nodes.
c
c   s contains the polygonal arclengths of the curve.
c
c   ierr contains an error flag,
c        = 0 for normal return,
c        = 1 if n is less than 2,
c        = 2 if adjacent coordinate pairs coincide.
c
c and
c
c   n, x, y, slp1, slpn, islpsw, and sigma are unaltered.
c
c this subroutine references package modules ceez, terms,
c and snhcsh.
c
c-----------------------------------------------------------
c
      nm1 = n-1
      np1 = n+1
      ierr = 0
      if (n .le. 1) go to 11
c
c determine polygonal arclengths
c
      s(1) = 0.
      do 1 i = 2,n
        im1 = i-1
    1   s(i) = s(im1)+sqrt((x(i)-x(im1))**2+
     *         (y(i)-y(im1))**2)
c
c denormalize tension factor
c
      sigmap = abs(sigma)*float(n-1)/s(n)
c
c approximate end slopes
c
      if (islpsw .ge. 2) go to 2
      slpp1x = cos(slp1)
      slpp1y = sin(slp1)
      go to 4
    2 dels1 = s(2)-s(1)
      dels2 = dels1+dels1
      if (n .gt. 2) dels2 = s(3)-s(1)
      if (dels1 .eq. 0. .or. dels2 .eq. 0.) go to 12
      call ceez (dels1,dels2,sigmap,c1,c2,c3,n)
      sx = c1*x(1)+c2*x(2)
      sy = c1*y(1)+c2*y(2)
      if (n .eq. 2) go to 3
      sx = sx+c3*x(3)
      sy = sy+c3*y(3)
    3 delt = sqrt(sx*sx+sy*sy)
      slpp1x = sx/delt
      slpp1y = sy/delt
    4 if (islpsw .eq. 1 .or. islpsw .eq. 3) go to 5
      slppnx = cos(slpn)
      slppny = sin(slpn)
      go to 7
    5 delsn = s(n)-s(nm1)
      delsnm = delsn+delsn
      if (n .gt. 2) delsnm = s(n)-s(n-2)
      if (delsn .eq. 0. .or. delsnm .eq. 0.) go to 12
      call ceez (-delsn,-delsnm,sigmap,c1,c2,c3,n)
      sx = c1*x(n)+c2*x(nm1)
      sy = c1*y(n)+c2*y(nm1)
      if (n .eq. 2) go to 6
      sx = sx+c3*x(n-2)
      sy = sy+c3*y(n-2)
    6 delt = sqrt(sx*sx+sy*sy)
      slppnx = sx/delt
      slppny = sy/delt
c
c set up right hand sides and tridiagonal system for xp and
c yp and perform forward elimination
c
    7 dx1 = (x(2)-x(1))/s(2)
      dy1 = (y(2)-y(1))/s(2)
      call terms (diag1,sdiag1,sigmap,s(2))
      xp(1) = (dx1-slpp1x)/diag1
      yp(1) = (dy1-slpp1y)/diag1
      temp(1) = sdiag1/diag1
      if (n .eq. 2) go to 9
      do 8 i = 2,nm1
        dels2 = s(i+1)-s(i)
        if (dels2 .eq. 0.) go to 12
        dx2 = (x(i+1)-x(i))/dels2
        dy2 = (y(i+1)-y(i))/dels2
        call terms (diag2,sdiag2,sigmap,dels2)
        diag = diag1+diag2-sdiag1*temp(i-1)
        diagin = 1./diag
        xp(i) = (dx2-dx1-sdiag1*xp(i-1))*diagin
        yp(i) = (dy2-dy1-sdiag1*yp(i-1))*diagin
        temp(i) = sdiag2*diagin
        dx1 = dx2
        dy1 = dy2
        diag1 = diag2
    8   sdiag1 = sdiag2
    9 diag = diag1-sdiag1*temp(nm1)
      xp(n) = (slppnx-dx1-sdiag1*xp(nm1))/diag
      yp(n) = (slppny-dy1-sdiag1*yp(nm1))/diag
c
c perform back substitution
c
      do 10 i = 2,n
        ibak = np1-i
        xp(ibak) = xp(ibak)-temp(ibak)*xp(ibak+1)
   10   yp(ibak) = yp(ibak)-temp(ibak)*yp(ibak+1)
      return
c
c too few points
c
   11 ierr = 1
      return
c
c coincident adjacent points
c
   12 ierr = 2
      return
      end
      subroutine kurv2 (t,xs,ys,n,x,y,xp,yp,s,sigma)
c
      integer n
      real t,xs,ys,x(n),y(n),xp(n),yp(n),s(n),sigma
c
c                                 coded by alan kaylor cline
c                           from fitpack -- january 26, 1987
c                        a curve and surface fitting package
c                      a product of pleasant valley software
c                  8603 altus cove, austin, texas 78759, usa
c
c this subroutine performs the mapping of points in the
c interval (0.,1.) onto a curve in the plane. the subroutine
c kurv1 should be called earlier to determine certain
c necessary parameters. the resulting curve has a parametric
c representation both of whose components are splines under
c tension and functions of the polygonal arclength
c parameter.
c
c on input--
c
c   t contains a real value to be mapped to a point on the
c   curve. the interval (0.,1.) is mapped onto the entire
c   curve, with 0. mapping to (x(1),y(1)) and 1. mapping
c   to (x(n),y(n)). values outside this interval result in
c   extrapolation.
c
c   n contains the number of points which were specified
c   to determine the curve.
c
c   x and y are arrays containing the x- and y-coordinates
c   of the specified points.
c
c   xp and yp are the arrays output from kurv1 containing
c   curvature information.
c
c   s is an array containing the polygonal arclengths of
c   the curve.
c
c and
c
c   sigma contains the tension factor (its sign is ignored).
c
c the parameters n, x, y, xp, yp, s, and sigma should be
c input unaltered from the output of kurv1.
c
c on output--
c
c   xs and ys contain the x- and y-coordinates of the image
c   point on the curve.
c
c none of the input parameters are altered.
c
c this subroutine references package modules intrvl and
c snhcsh.
c
c-----------------------------------------------------------
c
c determine interval
c
      tn = s(n)*t
      im1 = intrvl(tn,s,n)
      i = im1+1
c
c denormalize tension factor
c
      sigmap = abs(sigma)*float(n-1)/s(n)
c
c set up and perform interpolation
c
      del1 = tn-s(im1)
      del2 = s(i)-tn
      dels = s(i)-s(im1)
      sumx = (x(i)*del1+x(im1)*del2)/dels
      sumy = (y(i)*del1+y(im1)*del2)/dels
      if (sigmap .ne. 0.) go to 1
      d = del1*del2/(6.*dels)
      c1 = (del1+dels)*d
      c2 = (del2+dels)*d
      xs = sumx-xp(i)*c1-xp(im1)*c2
      ys = sumy-yp(i)*c1-yp(im1)*c2
      return
    1 sigdel = sigmap*dels
      call snhcsh(ss,dummy,sigdel,-1)
      call snhcsh(s1,dummy,sigmap*del1,-1)
      call snhcsh(s2,dummy,sigmap*del2,-1)
      d = sigdel*sigmap*(1.+ss)
      c1 = del1*(s1-ss)/d
      c2 = del2*(s2-ss)/d
      xs = sumx+xp(i)*c1+xp(im1)*c2
      ys = sumy+yp(i)*c1+yp(im1)*c2
      return
      end
      subroutine kurvd (t,xs,ys,xst,yst,xstt,ystt,n,x,y,xp,
     *                  yp,s,sigma)
c
      integer n
      real t,xs,ys,xst,yst,xstt,ystt,x(n),y(n),xp(n),yp(n),
     *     s(n),sigma
c
c                                 coded by alan kaylor cline
c                           from fitpack -- january 26, 1987
c                        a curve and surface fitting package
c                      a product of pleasant valley software
c                  8603 altus cove, austin, texas 78759, usa
c
c this subroutine performs the mapping of points in the
c interval (0.,1.) onto a curve in the plane. it also
c returns the first and second derivatives of the component
c functions. the subroutine kurv1 should be called earlier
c to determine certain necessary parameters. the resulting
c curve has a parametric representation both of whose
c components are splines under tension and functions of the
c polygonal arclength parameter.
c
c on input--
c
c   t contains a real value to be mapped to a point on the
c   curve. the interval (0.,1.) is mapped onto the entire
c   curve, with 0. mapping to (x(1),y(1)) and 1. mapping
c   to (x(n),y(n)). values outside this interval result in
c   extrapolation.
c
c   n contains the number of points which were specified
c   to determine the curve.
c
c   x and y are arrays containing the x- and y-coordinates
c   of the specified points.
c
c   xp and yp are the arrays output from kurv1 containing
c   curvature information.
c
c   s is an array containing the polygonal arclengths of
c   the curve.
c
c and
c
c   sigma contains the tension factor (its sign is ignored).
c
c the parameters n, x, y, xp, yp, s, and sigma should be
c input unaltered from the output of kurv1.
c
c on output--
c
c   xs and ys contain the x- and y-coordinates of the image
c   point on the curve. xst and yst contain the first
c   derivatives of the x- and y-components of the mapping
c   with respect to t. xstt and ystt contain the second
c   derivatives of the x- and y-components of the mapping
c   with respect to t.
c
c none of the input parameters are altered.
c
c this subroutine references package modules intrvl and
c snhcsh.
c
c-----------------------------------------------------------
c
c determine interval
c
      tn = s(n)*t
      im1 = intrvl(tn,s,n)
      i = im1+1
c
c denormalize tension factor
c
      sigmap = abs(sigma)*float(n-1)/s(n)
c
c set up and perform interpolation
c
      del1 = tn-s(im1)
      del2 = s(i)-tn
      dels = s(i)-s(im1)
      sumx = (x(i)*del1+x(im1)*del2)/dels
      sumy = (y(i)*del1+y(im1)*del2)/dels
      sumxt = s(n)*(x(i)-x(im1))/dels
      sumyt = s(n)*(y(i)-y(im1))/dels
      if (sigmap .ne. 0.) go to 1
      dels6 = 6.*dels
      d = del1*del2/dels6
      c1 = -(del1+dels)*d
      c2 = -(del2+dels)*d
      dels6 = dels6/s(n)
      ct1 = (2.*del1*del1-del2*(del1+dels))/dels6
      ct2 = -(2.*del2*del2-del1*(del2+dels))/dels6
      dels = dels/(s(n)*s(n))
      ctt1 = del1/dels
      ctt2 = del2/dels
      go to 2
    1 sigdel = sigmap*dels
      call snhcsh (ss,dummy,sigdel,-1)
      call snhcsh (s1,co1,sigmap*del1,0)
      call snhcsh (s2,co2,sigmap*del2,0)
      d = sigdel*sigmap*(1.+ss)
      c1 = del1*(s1-ss)/d
      c2 = del2*(s2-ss)/d
      ct1 = (co1-ss)*s(n)/d
      ct2 = -(co2-ss)*s(n)/d
      ctt1 = del1*(1.+s1)*s(n)*s(n)/(dels*(1.+ss))
      ctt2 = del2*(1.+s2)*s(n)*s(n)/(dels*(1.+ss))
    2 xs = sumx+c1*xp(i)+c2*xp(im1)
      ys = sumy+c1*yp(i)+c2*yp(im1)
      xst = sumxt+ct1*xp(i)+ct2*xp(im1)
      yst = sumyt+ct1*yp(i)+ct2*yp(im1)
      xstt = ctt1*xp(i)+ctt2*xp(im1)
      ystt = ctt1*yp(i)+ctt2*yp(im1)
      return
      end
      subroutine kurvp1 (n,x,y,xp,yp,temp,s,sigma,ierr)
c
      integer n,ierr
      real x(n),y(n),xp(n),yp(n),temp(1),s(n),sigma
c
c                                 coded by alan kaylor cline
c                           from fitpack -- january 26, 1987
c                        a curve and surface fitting package
c                      a product of pleasant valley software
c                  8603 altus cove, austin, texas 78759, usa
c
c this subroutine determines the parameters necessary to
c compute a spline under tension forming a closed curve in
c the plane and passing through a sequence of pairs
c (x(1),y(1)),...,(x(n),y(n)). for actual computation of
c points on the curve it is necessary to call the subroutine
c kurvp2.
c
c on input--
c
c   n is the number of points to be interpolated (n.ge.2).
c
c   x is an array containing the n x-coordinates of the
c   points.
c
c   y is an array containing the n y-coordinates of the
c   points. (adjacent x-y pairs must be distinct, i. e.
c   either x(i) .ne. x(i+1) or y(i) .ne. y(i+1), for
c   i = 1,...,n-1 and either x(1) .ne. x(n) or y(1) .ne. y(n).)
c
c   xp and yp are arrays of length at least n.
c
c   temp is an array of length at least 2*n which is used
c   for scratch storage.
c
c   s is an array of length at least n.
c
c and
c
c   sigma contains the tension factor. this value indicates
c   the curviness desired. if abs(sigma) is nearly zero
c   (e.g. .001) the resulting curve is approximately a cubic
c   spline. if abs(sigma) is large (e. g. 50.) the resulting
c   curve is nearly a polygonal line. if sigma equals zero a
c   cubic spline results. a standard value for sigma is
c   approximately 1. in absolute value.
c
c on output--
c
c   xp and yp contain information about the curvature of the
c   curve at the given nodes.
c
c   s contains the polygonal arclengths of the curve.
c
c   ierr contains an error flag,
c        = 0 for normal return,
c        = 1 if n is less than 2,
c        = 2 if adjacent coordinate pairs coincide.
c
c and
c
c   n, x, y, and sigma are unaltered,
c
c this subroutine references package modules terms and
c snhcsh.
c
c-----------------------------------------------------------
c
      nm1 = n-1
      np1 = n+1
      ierr = 0
      if (n .le. 1) go to 7
c
c determine polygonal arclengths
c
      s(1) = sqrt((x(n)-x(1))**2+(y(n)-y(1))**2)
      do 1 i = 2,n
        im1 = i-1
    1   s(i) = s(im1)+sqrt((x(i)-x(im1))**2+
     *         (y(i)-y(im1))**2)
c
c denormalize tension factor
c
      sigmap = abs(sigma)*float(n)/s(n)
c
c set up right hand sides of tridiagonal (with corner
c elements) linear system for xp and yp
c
      dels1 = s(1)
      if (dels1 .eq. 0.) go to 8
      dx1 = (x(1)-x(n))/dels1
      dy1 = (y(1)-y(n))/dels1
      call terms(diag1,sdiag1,sigmap,dels1)
      dels2 = s(2)-s(1)
      if (dels2 .eq. 0.) go to 8
      dx2 = (x(2)-x(1))/dels2
      dy2 = (y(2)-y(1))/dels2
      call terms(diag2,sdiag2,sigmap,dels2)
      diag = diag1+diag2
      diagin = 1./diag
      xp(1) = (dx2-dx1)*diagin
      yp(1) = (dy2-dy1)*diagin
      temp(np1) = -sdiag1*diagin
      temp(1) = sdiag2*diagin
      dx1 = dx2
      dy1 = dy2
      diag1 = diag2
      sdiag1 = sdiag2
      if (n .eq. 2) go to 3
      do 2 i = 2,nm1
        npi = n+i
        dels2 = s(i+1)-s(i)
        if (dels2 .eq. 0.) go to 8
        dx2 = (x(i+1)-x(i))/dels2
        dy2 = (y(i+1)-y(i))/dels2
        call terms(diag2,sdiag2,sigmap,dels2)
        diag = diag1+diag2-sdiag1*temp(i-1)
        diagin = 1./diag
        xp(i) = (dx2-dx1-sdiag1*xp(i-1))*diagin
        yp(i) = (dy2-dy1-sdiag1*yp(i-1))*diagin
        temp(npi) = -temp(npi-1)*sdiag1*diagin
        temp(i) = sdiag2*diagin
        dx1 = dx2
        dy1 = dy2
        diag1 = diag2
    2   sdiag1 = sdiag2
    3 dels2 = s(1)
      dx2 = (x(1)-x(n))/dels2
      dy2 = (y(1)-y(n))/dels2
      call terms(diag2,sdiag2,sigmap,dels2)
      xp(n) = dx2-dx1
      yp(n) = dy2-dy1
      temp(nm1) = temp(2*n-1)-temp(nm1)
      if (n.eq.2) go to 5
c
c perform first step of back substitution
c
      do 4 i = 3,n
        ibak = np1-i
        npibak = n+ibak
        xp(ibak) = xp(ibak)-temp(ibak)*xp(ibak+1)
        yp(ibak) = yp(ibak)-temp(ibak)*yp(ibak+1)
    4   temp(ibak) = temp(npibak)-temp(ibak)*temp(ibak+1)
    5 xp(n) = (xp(n)-sdiag2*xp(1)-sdiag1*xp(nm1))/
     *        (diag1+diag2+sdiag2*temp(1)+sdiag1*temp(nm1))
      yp(n) = (yp(n)-sdiag2*yp(1)-sdiag1*yp(nm1))/
     *        (diag1+diag2+sdiag2*temp(1)+sdiag1*temp(nm1))
c
c perform second step of back substitution
c
      xpn = xp(n)
      ypn = yp(n)
      do 6 i = 1,nm1
        xp(i) = xp(i)+temp(i)*xpn
    6   yp(i) = yp(i)+temp(i)*ypn
      return
c
c too few points
c
    7 ierr = 1
      return
c
c coincident adjacent points
c
    8 ierr = 2
      return
      end
      subroutine kurvp2 (t,xs,ys,n,x,y,xp,yp,s,sigma)
c
      integer n
      real t,xs,ys,x(n),y(n),xp(n),yp(n),s(n),sigma
c
c                                 coded by alan kaylor cline
c                           from fitpack -- january 26, 1987
c                        a curve and surface fitting package
c                      a product of pleasant valley software
c                  8603 altus cove, austin, texas 78759, usa
c
c this subroutine performs the mapping of points in the
c interval (0.,1.) onto a closed curve in the plane. the
c subroutine kurvp1 should be called earlier to determine
c certain necessary parameters. the resulting curve has a
c parametric representation both of whose components are
c periodic splines under tension and functions of the poly-
c gonal arclength parameter.
c
c on input--
c
c   t contains a value to be mapped onto the curve. the
c   interval (0.,1.) is mapped onto the entire closed curve
c   with both 0. and 1. mapping to (x(1),y(1)). the mapping
c   is periodic with period one thus any interval of the
c   form (tt,tt+1.) maps onto the entire curve.
c
c   n contains the number of points which were specified
c   to determine the curve.
c
c   x and y are arrays containing the x- and y-coordinates
c   of the specified points.
c
c   xp and yp are the arrays output from kurvp1 containing
c   curvature information.
c
c   s is an array containing the polygonal arclengths of
c   the curve.
c
c and
c
c   sigma contains the tension factor (its sign is ignored).
c
c the parameters n, x, y, xp, yp, s and sigma should
c be input unaltered from the output of kurvp1.
c
c on output--
c
c   xs and ys contain the x- and y-coordinates of the image
c   point on the curve.
c
c none of the input parameters are altered.
c
c this subroutine references package modules intrvl and
c snhcsh.
c
c-----------------------------------------------------------
c
c determine interval
c
      tn = t-float(ifix(t))
      if (tn .lt. 0.) tn = tn+1.
      tn = s(n)*tn+s(1)
      im1 = n
      if (tn .lt. s(n)) im1 = intrvl(tn,s,n)
      i = im1+1
      if (i .gt. n) i = 1
c
c denormalize tension factor
c
      sigmap = abs(sigma)*float(n)/s(n)
c
c set up and perform interpolation
c
      si = s(i)
      if (im1 .eq. n) si = s(n)+s(1)
      del1 = tn-s(im1)
      del2 = si-tn
      dels = si-s(im1)
      sumx = (x(i)*del1+x(im1)*del2)/dels
      sumy = (y(i)*del1+y(im1)*del2)/dels
      if (sigmap .ne. 0.) go to 1
      d = del1*del2/(6.*dels)
      c1 = (del1+dels)*d
      c2 = (del2+dels)*d
      xs = sumx-xp(i)*c1-xp(im1)*c2
      ys = sumy-yp(i)*c1-yp(im1)*c2
      return
    1 sigdel = sigmap*dels
      call snhcsh(ss,dummy,sigdel,-1)
      call snhcsh(s1,dummy,sigmap*del1,-1)
      call snhcsh(s2,dummy,sigmap*del2,-1)
      d = sigdel*sigmap*(1.+ss)
      ci = del1*(s1-ss)/d
      cim1 = del2*(s2-ss)/d
      xs = sumx+xp(i)*ci+xp(im1)*cim1
      ys = sumy+yp(i)*ci+yp(im1)*cim1
      return
      end
      subroutine kurvpd (t,xs,ys,xst,yst,xstt,ystt,n,x,y,xp,
     *                  yp,s,sigma)
c
      integer n
      real t,xs,ys,xst,yst,xstt,ystt,x(n),y(n),xp(n),yp(n),
     *     s(n),sigma
c
c                                 coded by alan kaylor cline
c                           from fitpack -- january 26, 1987
c                        a curve and surface fitting package
c                      a product of pleasant valley software
c                  8603 altus cove, austin, texas 78759, usa
c
c this subroutine performs the mapping of points in the
c interval (0.,1.) onto a closed curve in the plane. it also
c returns the first and second derivatives of the component
c functions. the subroutine kurvp1 should be called earlier
c to determine certain necessary parameters. the resulting
c curve has a parametric representation both of whose
c components are periodic splines under tension and
c functions of the polygonal arclength parameter.
c
c on input--
c
c   t contains a value to be mapped onto the curve. the
c   interval (0.,1.) is mapped onto the entire closed curve
c   with both 0. and 1. mapping to (x(1),y(1)). the mapping
c   is periodic with period one thus any interval of the
c   form (tt,tt+1.) maps onto the entire curve.
c
c   n contains the number of points which were specified
c   to determine the curve.
c
c   x and y are arrays containing the x- and y-coordinates
c   of the specified points.
c
c   xp and yp are the arrays output from kurvp1 containing
c   curvature information.
c
c   s is an array containing the polygonal arclengths of
c   the curve.
c
c and
c
c   sigma contains the tension factor (its sign is ignored).
c
c the parameters n, x, y, xp, yp, s and sigma should
c be input unaltered from the output of kurvp1.
c
c on output--
c
c   xs and ys contain the x- and y-coordinates of the image
c   point on the curve. xst and yst contain the first
c   derivatives of the x- and y-components of the mapping
c   with respect to t. xstt and ystt contain the second
c   derivatives of the x- and y-components of the mapping
c   with respect to t.
c
c none of the input parameters are altered.
c
c this subroutine references package modules intrvl and
c snhcsh.
c
c-----------------------------------------------------------
c
c determine interval
c
      tn = t-float(ifix(t))
      if (tn .lt. 0.) tn = tn+1.
      tn = s(n)*tn+s(1)
      im1 = n
      if (tn .lt. s(n)) im1 = intrvl(tn,s,n)
      i = im1+1
      if (i .gt. n) i = 1
c
c denormalize tension factor
c
      sigmap = abs(sigma)*float(n)/s(n)
c
c set up and perform interpolation
c
      si = s(i)
      if (im1 .eq. n) si = s(n)+s(1)
      del1 = tn-s(im1)
      del2 = si-tn
      dels = si-s(im1)
      sumx = (x(i)*del1+x(im1)*del2)/dels
      sumy = (y(i)*del1+y(im1)*del2)/dels
      sumxt = s(n)*(x(i)-x(im1))/dels
      sumyt = s(n)*(y(i)-y(im1))/dels
      if (sigmap .ne. 0.) go to 1
      dels6 = 6.*dels
      d = del1*del2/dels6
      c1 = -(del1+dels)*d
      c2 = -(del2+dels)*d
      dels6 = dels6/s(n)
      ct1 = (2.*del1*del1-del2*(del1+dels))/dels6
      ct2 = -(2.*del2*del2-del1*(del2+dels))/dels6
      dels = dels/(s(n)*s(n))
      ctt1 = del1/dels
      ctt2 = del2/dels
      go to 2
    1 sigdel = sigmap*dels
      call snhcsh (ss,dummy,sigdel,-1)
      call snhcsh (s1,co1,sigmap*del1,0)
      call snhcsh (s2,co2,sigmap*del2,0)
      d = sigdel*sigmap*(1.+ss)
      c1 = del1*(s1-ss)/d
      c2 = del2*(s2-ss)/d
      ct1 = (co1-ss)*s(n)/d
      ct2 = -(co2-ss)*s(n)/d
      ctt1 = del1*(1.+s1)*s(n)*s(n)/(dels*(1.+ss))
      ctt2 = del2*(1.+s2)*s(n)*s(n)/(dels*(1.+ss))
    2 xs = sumx+c1*xp(i)+c2*xp(im1)
      ys = sumy+c1*yp(i)+c2*yp(im1)
      xst = sumxt+ct1*xp(i)+ct2*xp(im1)
      yst = sumyt+ct1*yp(i)+ct2*yp(im1)
      xstt = ctt1*xp(i)+ctt2*xp(im1)
      ystt = ctt1*yp(i)+ctt2*yp(im1)
      return
      end
      subroutine surf1 (m,n,x,y,z,iz,zx1,zxm,zy1,zyn,zxy11,
     *                  zxym1,zxy1n,zxymn,islpsw,zp,temp,
     *                  sigma,ierr)
c
      integer m,n,iz,islpsw,ierr
      real x(m),y(n),z(iz,n),zx1(n),zxm(n),zy1(m),zyn(m),
     *     zxy11,zxym1,zxy1n,zxymn,zp(m,n,3),temp(1),sigma
c
c                                 coded by alan kaylor cline
c                           from fitpack -- january 26, 1987
c                        a curve and surface fitting package
c                      a product of pleasant valley software
c                  8603 altus cove, austin, texas 78759, usa
c
c this subroutine determines the parameters necessary to
c compute an interpolatory surface passing through a rect-
c angular grid of functional values. the surface determined
c can be represented as the tensor product of splines under
c tension. the x- and y-partial derivatives around the
c boundary and the x-y-partial derivatives at the four
c corners may be specified or omitted. for actual mapping
c of points onto the surface it is necessary to call the
c function surf2.
c
c on input--
c
c   m is the number of grid lines in the x-direction, i. e.
c   lines parallel to the y-axis (m .ge. 2).
c
c   n is the number of grid lines in the y-direction, i. e.
c   lines parallel to the x-axis (n .ge. 2).
c
c   x is an array of the m x-coordinates of the grid lines
c   in the x-direction. these should be strictly increasing.
c
c   y is an array of the n y-coordinates of the grid lines
c   in the y-direction. these should be strictly increasing.
c
c   z is an array of the m * n functional values at the grid
c   points, i. e. z(i,j) contains the functional value at
c   (x(i),y(j)) for i = 1,...,m and j = 1,...,n.
c
c   iz is the row dimension of the matrix z used in the
c   calling program (iz .ge. m).
c
c   zx1 and zxm are arrays of the m x-partial derivatives
c   of the function along the x(1) and x(m) grid lines,
c   respectively. thus zx1(j) and zxm(j) contain the x-part-
c   ial derivatives at the points (x(1),y(j)) and
c   (x(m),y(j)), respectively, for j = 1,...,n. either of
c   these parameters will be ignored (and approximations
c   supplied internally) if islpsw so indicates.
c
c   zy1 and zyn are arrays of the n y-partial derivatives
c   of the function along the y(1) and y(n) grid lines,
c   respectively. thus zy1(i) and zyn(i) contain the y-part-
c   ial derivatives at the points (x(i),y(1)) and
c   (x(i),y(n)), respectively, for i = 1,...,m. either of
c   these parameters will be ignored (and estimations
c   supplied internally) if islpsw so indicates.
c
c   zxy11, zxym1, zxy1n, and zxymn are the x-y-partial
c   derivatives of the function at the four corners,
c   (x(1),y(1)), (x(m),y(1)), (x(1),y(n)), and (x(m),y(n)),
c   respectively. any of the parameters will be ignored (and
c   estimations supplied internally) if islpsw so indicates.
c
c   islpsw contains a switch indicating which boundary
c   derivative information is user-supplied and which
c   should be estimated by this subroutine. to determine
c   islpsw, let
c        i1 = 0 if zx1 is user-supplied (and = 1 otherwise),
c        i2 = 0 if zxm is user-supplied (and = 1 otherwise),
c        i3 = 0 if zy1 is user-supplied (and = 1 otherwise),
c        i4 = 0 if zyn is user-supplied (and = 1 otherwise),
c        i5 = 0 if zxy11 is user-supplied
c                                       (and = 1 otherwise),
c        i6 = 0 if zxym1 is user-supplied
c                                       (and = 1 otherwise),
c        i7 = 0 if zxy1n is user-supplied
c                                       (and = 1 otherwise),
c        i8 = 0 if zxymn is user-supplied
c                                       (and = 1 otherwise),
c   then islpsw = i1 + 2*i2 + 4*i3 + 8*i4 + 16*i5 + 32*i6
c                   + 64*i7 + 128*i8
c   thus islpsw = 0 indicates all derivative information is
c   user-supplied and islpsw = 255 indicates no derivative
c   information is user-supplied. any value between these
c   limits is valid.
c
c   zp is an array of at least 3*m*n locations.
c
c   temp is an array of at least n+n+m locations which is
c   used for scratch storage.
c
c and
c
c   sigma contains the tension factor. this value indicates
c   the curviness desired. if abs(sigma) is nearly zero
c   (e. g. .001) the resulting surface is approximately the
c   tensor product of cubic splines. if abs(sigma) is large
c   (e. g. 50.) the resulting surface is approximately
c   bi-linear. if sigma equals zero tensor products of
c   cubic splines result. a standard value for sigma is
c   approximately 1. in absolute value.
c
c on output--
c
c   zp contains the values of the xx-, yy-, and xxyy-partial
c   derivatives of the surface at the given nodes.
c
c   ierr contains an error flag,
c        = 0 for normal return,
c        = 1 if n is less than 2 or m is less than 2,
c        = 2 if the x-values or y-values are not strictly
c            increasing.
c
c and
c
c   m, n, x, y, z, iz, zx1, zxm, zy1, zyn, zxy11, zxym1,
c   zxy1n, zxymn, islpsw, and sigma are unaltered.
c
c this subroutine references package modules ceez, terms,
c and snhcsh.
c
c-----------------------------------------------------------
c
      mm1 = m-1
      mp1 = m+1
      nm1 = n-1
      np1 = n+1
      npm = n+m
      ierr = 0
      if (n .le. 1 .or. m .le. 1) go to 46
      if (y(n) .le. y(1)) go to 47
c
c denormalize tension factor in y-direction
c
      sigmay = abs(sigma)*float(n-1)/(y(n)-y(1))
c
c obtain y-partial derivatives along y = y(1)
c
      if ((islpsw/8)*2 .ne. (islpsw/4)) go to 2
      do 1 i = 1,m
    1   zp(i,1,1) = zy1(i)
      go to 5
    2 dely1 = y(2)-y(1)
      dely2 = dely1+dely1
      if (n .gt. 2) dely2 = y(3)-y(1)
      if (dely1 .le. 0. .or. dely2 .le. dely1) go to 47
      call ceez (dely1,dely2,sigmay,c1,c2,c3,n)
      do 3 i = 1,m
    3   zp(i,1,1) = c1*z(i,1)+c2*z(i,2)
      if (n .eq. 2) go to 5
      do 4 i = 1,m
    4   zp(i,1,1) = zp(i,1,1)+c3*z(i,3)
c
c obtain y-partial derivatives along y = y(n)
c
    5 if ((islpsw/16)*2 .ne. (islpsw/8)) go to 7
      do 6 i = 1,m
        npi = n+i
    6   temp(npi) = zyn(i)
      go to 10
    7 delyn = y(n)-y(nm1)
      delynm = delyn+delyn
      if (n .gt. 2) delynm = y(n)-y(n-2)
      if (delyn .le. 0. .or. delynm .le. delyn) go to 47
      call ceez (-delyn,-delynm,sigmay,c1,c2,c3,n)
      do 8 i = 1,m
        npi = n+i
    8   temp(npi) = c1*z(i,n)+c2*z(i,nm1)
      if (n .eq. 2) go to 10
      do 9 i = 1,m
        npi = n+i
    9   temp(npi) = temp(npi)+c3*z(i,n-2)
   10 if (x(m) .le. x(1)) go to 47
c
c denormalize tension factor in x-direction
c
      sigmax = abs(sigma)*float(m-1)/(x(m)-x(1))
c
c obtain x-partial derivatives along x = x(1)
c
      if ((islpsw/2)*2 .ne. islpsw) go to 12
      do 11 j = 1,n
   11   zp(1,j,2) = zx1(j)
      if ((islpsw/32)*2 .eq. (islpsw/16) .and.
     *    (islpsw/128)*2  .eq. (islpsw/64)) go to 15
   12 delx1 = x(2)-x(1)
      delx2 = delx1+delx1
      if (m .gt. 2) delx2 = x(3)-x(1)
      if (delx1 .le. 0. .or. delx2 .le. delx1) go to 47
      call ceez (delx1,delx2,sigmax,c1,c2,c3,m)
      if ((islpsw/2)*2 .eq. islpsw) go to 15
      do 13 j = 1,n
   13   zp(1,j,2) = c1*z(1,j)+c2*z(2,j)
      if (m .eq. 2) go to 15
      do 14 j = 1,n
   14   zp(1,j,2) = zp(1,j,2)+c3*z(3,j)
c
c obtain x-y-partial derivative at (x(1),y(1))
c
   15 if ((islpsw/32)*2 .ne. (islpsw/16)) go to 16
      zp(1,1,3) = zxy11
      go to 17
   16 zp(1,1,3) = c1*zp(1,1,1)+c2*zp(2,1,1)
      if (m .gt. 2) zp(1,1,3) = zp(1,1,3)+c3*zp(3,1,1)
c
c obtain x-y-partial derivative at (x(1),y(n))
c
   17 if ((islpsw/128)*2 .ne. (islpsw/64)) go to 18
      zxy1ns = zxy1n
      go to 19
   18 zxy1ns = c1*temp(n+1)+c2*temp(n+2)
      if (m .gt. 2) zxy1ns = zxy1ns+c3*temp(n+3)
c
c obtain x-partial derivative along x = x(m)
c
   19 if ((islpsw/4)*2 .ne. (islpsw/2)) go to 21
      do 20 j = 1,n
        npmpj = npm+j
   20   temp(npmpj) = zxm(j)
      if ((islpsw/64)*2 .eq. (islpsw/32) .and.
     *    (islpsw/256)*2 .eq. (islpsw/128)) go to 24
   21 delxm = x(m)-x(mm1)
      delxmm = delxm+delxm
      if (m .gt. 2) delxmm = x(m)-x(m-2)
      if (delxm .le. 0. .or. delxmm .le. delxm) go to 47
      call ceez (-delxm,-delxmm,sigmax,c1,c2,c3,m)
      if ((islpsw/4)*2 .eq. (islpsw/2)) go to 24
      do 22 j = 1,n
        npmpj = npm+j
   22   temp(npmpj) = c1*z(m,j)+c2*z(mm1,j)
      if (m .eq. 2) go to 24
      do 23 j = 1,n
        npmpj = npm+j
   23   temp(npmpj) = temp(npmpj)+c3*z(m-2,j)
c
c obtain x-y-partial derivative at (x(m),y(1))
c
   24 if ((islpsw/64)*2 .ne. (islpsw/32)) go to 25
      zp(m,1,3) = zxym1
      go to 26
   25 zp(m,1,3) = c1*zp(m,1,1)+c2*zp(mm1,1,1)
      if (m .gt. 2) zp(m,1,3) = zp(m,1,3)+c3*zp(m-2,1,1)
c
c obtain x-y-partial derivative at (x(m),y(n))
c
   26 if ((islpsw/256)*2 .ne. (islpsw/128)) go to 27
      zxymns = zxymn
      go to 28
   27 zxymns = c1*temp(npm)+c2*temp(npm-1)
      if (m .gt. 2) zxymns = zxymns+c3*temp(npm-2)
c
c set up right hand sides and tridiagonal system for y-grid
c perform forward elimination
c
   28 del1 = y(2)-y(1)
      if (del1 .le. 0.) go to 47
      deli = 1./del1
      do 29 i = 1,m
   29   zp(i,2,1) = deli*(z(i,2)-z(i,1))
      zp(1,2,3) = deli*(zp(1,2,2)-zp(1,1,2))
      zp(m,2,3) = deli*(temp(npm+2)-temp(npm+1))
      call terms (diag1,sdiag1,sigmay,del1)
      diagi = 1./diag1
      do 30 i = 1,m
   30   zp(i,1,1) = diagi*(zp(i,2,1)-zp(i,1,1))
      zp(1,1,3) = diagi*(zp(1,2,3)-zp(1,1,3))
      zp(m,1,3) = diagi*(zp(m,2,3)-zp(m,1,3))
      temp(1) = diagi*sdiag1
      if (n .eq. 2) go to 34
      do 33 j = 2,nm1
        jm1 = j-1
        jp1 = j+1
        npmpj = npm+j
        del2 = y(jp1)-y(j)
        if (del2 .le. 0.) go to 47
        deli = 1./del2
        do 31 i = 1,m
   31     zp(i,jp1,1) = deli*(z(i,jp1)-z(i,j))
        zp(1,jp1,3) = deli*(zp(1,jp1,2)-zp(1,j,2))
        zp(m,jp1,3) = deli*(temp(npmpj+1)-temp(npmpj))
        call terms (diag2,sdiag2,sigmay,del2)
        diagin = 1./(diag1+diag2-sdiag1*temp(jm1))
        do 32 i = 1,m
   32     zp(i,j,1) = diagin*(zp(i,jp1,1)-zp(i,j,1)-
     *                        sdiag1*zp(i,jm1,1))
        zp(1,j,3) = diagin*(zp(1,jp1,3)-zp(1,j,3)-
     *                      sdiag1*zp(1,jm1,3))
        zp(m,j,3) = diagin*(zp(m,jp1,3)-zp(m,j,3)-
     *                      sdiag1*zp(m,jm1,3))
        temp(j) = diagin*sdiag2
        diag1 = diag2
   33   sdiag1 = sdiag2
   34 diagin = 1./(diag1-sdiag1*temp(nm1))
      do 35 i = 1,m
        npi = n+i
   35   zp(i,n,1) = diagin*(temp(npi)-zp(i,n,1)-
     *                      sdiag1*zp(i,nm1,1))
      zp(1,n,3) = diagin*(zxy1ns-zp(1,n,3)-
     *                    sdiag1*zp(1,nm1,3))
      temp(n) = diagin*(zxymns-zp(m,n,3)-
     *                  sdiag1*zp(m,nm1,3))
c
c perform back substitution
c
      do 37 j = 2,n
        jbak = np1-j
        jbakp1 = jbak+1
        t = temp(jbak)
        do 36 i = 1,m
   36     zp(i,jbak,1) = zp(i,jbak,1)-t*zp(i,jbakp1,1)
        zp(1,jbak,3) = zp(1,jbak,3)-t*zp(1,jbakp1,3)
   37   temp(jbak) = zp(m,jbak,3)-t*temp(jbakp1)
c
c set up right hand sides and tridiagonal system for x-grid
c perform forward elimination
c
      del1 = x(2)-x(1)
      if (del1 .le. 0.) go to 47
      deli = 1./del1
      do 38 j = 1,n
        zp(2,j,2) = deli*(z(2,j)-z(1,j))
   38   zp(2,j,3) = deli*(zp(2,j,1)-zp(1,j,1))
      call terms (diag1,sdiag1,sigmax,del1)
      diagi = 1./diag1
      do 39 j = 1,n
        zp(1,j,2) = diagi*(zp(2,j,2)-zp(1,j,2))
   39   zp(1,j,3) = diagi*(zp(2,j,3)-zp(1,j,3))
      temp(n+1) = diagi*sdiag1
      if (m  .eq. 2) go to 43
      do 42 i = 2,mm1
        im1 = i-1
        ip1 = i+1
        npi = n+i
        del2 = x(ip1)-x(i)
        if (del2 .le. 0.) go to 47
        deli = 1./del2
        do 40 j = 1,n
          zp(ip1,j,2) = deli*(z(ip1,j)-z(i,j))
   40     zp(ip1,j,3) = deli*(zp(ip1,j,1)-zp(i,j,1))
        call terms (diag2,sdiag2,sigmax,del2)
        diagin = 1./(diag1+diag2-sdiag1*temp(npi-1))
        do 41 j = 1,n
          zp(i,j,2) = diagin*(zp(ip1,j,2)-zp(i,j,2)-
     *                        sdiag1*zp(im1,j,2))
   41     zp(i,j,3) = diagin*(zp(ip1,j,3)-zp(i,j,3)-
     *                        sdiag1*zp(im1,j,3))
        temp(npi) = diagin*sdiag2
        diag1 = diag2
   42   sdiag1 = sdiag2
   43 diagin = 1./(diag1-sdiag1*temp(npm-1))
      do 44 j = 1,n
        npmpj = npm+j
        zp(m,j,2) = diagin*(temp(npmpj)-zp(m,j,2)-
     *                      sdiag1*zp(mm1,j,2))
   44   zp(m,j,3) = diagin*(temp(j)-zp(m,j,3)-
     *                      sdiag1*zp(mm1,j,3))
c
c perform back substitution
c
      do 45 i = 2,m
        ibak = mp1-i
        ibakp1 = ibak+1
        npibak = n+ibak
        t = temp(npibak)
        do 45 j = 1,n
          zp(ibak,j,2) = zp(ibak,j,2)-t*zp(ibakp1,j,2)
   45     zp(ibak,j,3) = zp(ibak,j,3)-t*zp(ibakp1,j,3)
      return
c
c too few points
c
   46 ierr = 1
      return
c
c points not strictly increasing
c
   47 ierr = 2
      return
      end
      function surf2 (xx,yy,m,n,x,y,z,iz,zp,sigma)
c
      integer m,n,iz
      real xx,yy,x(m),y(n),z(iz,n),zp(m,n,3),sigma
c
c                                 coded by alan kaylor cline
c                           from fitpack -- january 26, 1987
c                        a curve and surface fitting package
c                      a product of pleasant valley software
c                  8603 altus cove, austin, texas 78759, usa
c
c this function interpolates a surface at a given coordinate
c pair using a bi-spline under tension. the subroutine surf1
c should be called earlier to determine certain necessary
c parameters.
c
c on input--
c
c   xx and yy contain the x- and y-coordinates of the point
c   to be mapped onto the interpolating surface.
c
c   m and n contain the number of grid lines in the x- and
c   y-directions, respectively, of the rectangular grid
c   which specified the surface.
c
c   x and y are arrays containing the x- and y-grid values,
c   respectively, each in increasing order.
c
c   z is a matrix containing the m * n functional values
c   corresponding to the grid values (i. e. z(i,j) is the
c   surface value at the point (x(i),y(j)) for i = 1,...,m
c   and j = 1,...,n).
c
c   iz contains the row dimension of the array z as declared
c   in the calling program.
c
c   zp is an array of 3*m*n locations stored with the
c   various surface derivative information determined by
c   surf1.
c
c and
c
c   sigma contains the tension factor (its sign is ignored).
c
c the parameters m, n, x, y, z, iz, zp, and sigma should be
c input unaltered from the output of surf1.
c
c on output--
c
c   surf2 contains the interpolated surface value.
c
c none of the input parameters are altered.
c
c this function references package modules intrvl and
c snhcsh.
c
c-----------------------------------------------------------
c
c inline one dimensional cubic spline interpolation
c
      hermz (f1,f2,fp1,fp2) = (f2*del1+f1*del2)/dels-del1*
     *                        del2*(fp2*(del1+dels)+
     *                              fp1*(del2+dels))/
     *                        (6.*dels)
c
c inline one dimensional spline under tension interpolation
c
      hermnz (f1,f2,fp1,fp2,sigmap) = (f2*del1+f1*del2)/dels
     *          +(fp2*del1*(sinhm1-sinhms)
     *           +fp1*del2*(sinhm2-sinhms)
     *          )/(sigmap*sigmap*dels*(1.+sinhms))
c
c denormalize tension factor in x and y direction
c
      sigmax = abs(sigma)*float(m-1)/(x(m)-x(1))
      sigmay = abs(sigma)*float(n-1)/(y(n)-y(1))
c
c determine y interval
c
      jm1 = intrvl (yy,y,n)
      j = jm1+1
c
c determine x interval
c
      im1 = intrvl (xx,x,m)
      i = im1+1
      del1 = yy-y(jm1)
      del2 = y(j)-yy
      dels = y(j)-y(jm1)
      if (sigmay .ne. 0.) go to 1
c
c perform four interpolations in y-direction
c
      zim1 = hermz(z(i-1,j-1),z(i-1,j),zp(i-1,j-1,1),
     *                                  zp(i-1,j,1))
      zi = hermz(z(i,j-1),z(i,j),zp(i,j-1,1),zp(i,j,1))
      zxxim1 = hermz(zp(i-1,j-1,2),zp(i-1,j,2),
     *                zp(i-1,j-1,3),zp(i-1,j,3))
      zxxi = hermz(zp(i,j-1,2),zp(i,j,2),
     *              zp(i,j-1,3),zp(i,j,3))
      go to 2
    1 call snhcsh (sinhm1,dummy,sigmay*del1,-1)
      call snhcsh (sinhm2,dummy,sigmay*del2,-1)
      call snhcsh (sinhms,dummy,sigmay*dels,-1)
      zim1 = hermnz(z(i-1,j-1),z(i-1,j),zp(i-1,j-1,1),
     *               zp(i-1,j,1),sigmay)
      zi = hermnz(z(i,j-1),z(i,j),zp(i,j-1,1),zp(i,j,1),
     *             sigmay)
      zxxim1 = hermnz(zp(i-1,j-1,2),zp(i-1,j,2),
     *                 zp(i-1,j-1,3),zp(i-1,j,3),sigmay)
      zxxi = hermnz(zp(i,j-1,2),zp(i,j,2),
     *               zp(i,j-1,3),zp(i,j,3),sigmay)
c
c perform final interpolation in x-direction
c
    2 del1 = xx-x(im1)
      del2 = x(i)-xx
      dels = x(i)-x(im1)
      if (sigmax .ne. 0.) go to 3
      surf2 = hermz(zim1,zi,zxxim1,zxxi)
      return
    3 call snhcsh (sinhm1,dummy,sigmax*del1,-1)
      call snhcsh (sinhm2,dummy,sigmax*del2,-1)
      call snhcsh (sinhms,dummy,sigmax*dels,-1)
      surf2 = hermnz(zim1,zi,zxxim1,zxxi,sigmax)
      return
      end
      subroutine ceez (del1,del2,sigma,c1,c2,c3,n)
c
      real del1,del2,sigma,c1,c2,c3
c
c                                 coded by alan kaylor cline
c                           from fitpack -- january 26, 1987
c                        a curve and surface fitting package
c                      a product of pleasant valley software
c                  8603 altus cove, austin, texas 78759, usa
c
c this subroutine determines the coefficients c1, c2, and c3
c used to determine endpoint slopes. specifically, if
c function values y1, y2, and y3 are given at points x1, x2,
c and x3, respectively, the quantity c1*y1 + c2*y2 + c3*y3
c is the value of the derivative at x1 of a spline under
c tension (with tension factor sigma) passing through the
c three points and having third derivative equal to zero at
c x1. optionally, only two values, c1 and c2 are determined.
c
c on input--
c
c   del1 is x2-x1 (.gt. 0.).
c
c   del2 is x3-x1 (.gt. 0.). if n .eq. 2, this parameter is
c   ignored.
c
c   sigma is the tension factor.
c
c and
c
c   n is a switch indicating the number of coefficients to
c   be returned. if n .eq. 2 only two coefficients are
c   returned. otherwise all three are returned.
c
c on output--
c
c   c1, c2, and c3 contain the coefficients.
c
c none of the input parameters are altered.
c
c this subroutine references package module snhcsh.
c
c-----------------------------------------------------------
c
      if (n .eq. 2) go to 2
      if (sigma .ne. 0.) go to 1
      del = del2-del1
c
c tension .eq. 0.
c
      c1 = -(del1+del2)/(del1*del2)
      c2 = del2/(del1*del)
      c3 = -del1/(del2*del)
      return
c
c tension .ne. 0.
c
    1 call snhcsh (dummy,coshm1,sigma*del1,1)
      call snhcsh (dummy,coshm2,sigma*del2,1)
      delp = sigma*(del2+del1)/2.
      delm = sigma*(del2-del1)/2.
      call snhcsh (sinhmp,dummy,delp,-1)
      call snhcsh (sinhmm,dummy,delm,-1)
      denom = coshm1*(del2-del1)-2.*del1*delp*delm*
     *        (1.+sinhmp)*(1.+sinhmm)
      c1 = 2.*delp*delm*(1.+sinhmp)*(1.+sinhmm)/denom
      c2 = -coshm2/denom
      c3 = coshm1/denom
      return
c
c two coefficients
c
    2 c1 = -1./del1
      c2 = -c1
      return
      end
      function intrvl (t,x,n)
c
      integer n
      real t,x(n)
c
c                                 coded by alan kaylor cline
c                           from fitpack -- january 26, 1987
c                        a curve and surface fitting package
c                      a product of pleasant valley software
c                  8603 altus cove, austin, texas 78759, usa
c
c this function determines the index of the interval
c (determined by a given increasing sequence) in which
c a given value lies.
c
c on input--
c
c   t is the given value.
c
c   x is a vector of strictly increasing values.
c
c and
c
c   n is the length of x (n .ge. 2).
c
c on output--
c
c   intrvl returns an integer i such that
c
c          i =  1       if         e   t .lt. x(2)  ,
c          i =  n-1     if x(n-1) .le. t            ,
c          otherwise       x(i)  .le. t .le. x(i+1),
c
c none of the input parameters are altered.
c
c-----------------------------------------------------------
c
      save i
      data i /1/
c
      tt = t
c
c check for illegal i
c
      if (i .ge. n) i = n/2
c
c check old interval and extremes
c
      if (tt .lt. x(i)) then
        if (tt .le. x(2)) then
          i = 1
          intrvl = 1
          return
        else
          il = 2
          ih = i
        end if
      else if (tt .le. x(i+1)) then
        intrvl = i
        return
      else if (tt .ge. x(n-1)) then
        i = n-1
        intrvl = n-1
        return
      else
        il = i+1
        ih = n-1
      end if
c
c binary search loop
c
    1 i = (il+ih)/2
      if (tt .lt. x(i)) then
         ih = i
      else if (tt .gt. x(i+1)) then
         il = i+1
      else
         intrvl = i
         return
      end if
      go to 1
      end
      function intrvp (t,x,n,p,tp)
c
      integer n
      real t,x(n),p,tp
c
c                                 coded by alan kaylor cline
c                           from fitpack -- january 26, 1987
c                        a curve and surface fitting package
c                      a product of pleasant valley software
c                  8603 altus cove, austin, texas 78759, usa
c
c this function determines the index of the interval
c (determined by a given increasing sequence) in which a
c given value lies, after translating the value to within
c the correct period.  it also returns this translated value.
c
c on input--
c
c   t is the given value.
c
c   x is a vector of strictly increasing values.
c
c   n is the length of x (n .ge. 2).
c
c and
c
c   p contains the period.
c
c on output--
c
c   tp contains a translated value of t (i. e. x(1) .le. tp,
c   tp .lt. x(1)+p, and tp = t + k*p for some integer k).
c
c   intrvl returns an integer i such that
c
c          i = 1       if             tp .lt. x(2)  ,
c          i = n       if   x(n) .le. tp            ,
c          otherwise       x(i)  .le. tp .lt. x(i+1),
c
c none of the input parameters are altered.
c
c-----------------------------------------------------------
c
      save i
      data i /1/
c
      nper = (t-x(1))/p
      tp = t-float(nper)*p
      if (tp .lt. x(1)) tp = tp+p
      tt = tp
c
c check for illegal i
c
      if (i .ge. n) i = n/2
c
c check old interval and extremes
c
      if (tt .lt. x(i)) then
        if (tt .le. x(2)) then
          i = 1
          intrvp = 1
          return
        else
          il = 2
          ih = i
        end if
      else if (tt .le. x(i+1)) then
        intrvp = i
        return
      else if (tt .ge. x(n)) then
        i = n
        intrvp = n
        return
      else
        il = i+1
        ih = n
      end if
c
c binary search loop
c
    1 i = (il+ih)/2
      if (tt .lt. x(i)) then
         ih = i
      else if (tt .gt. x(i+1)) then
         il = i+1
      else
         intrvp = i
         return
      end if
      go to 1
      end
c      subroutine snhcsh (sinhm,coshm,x,isw)
c
c      integer isw
c      real sinhm,coshm,x
c
c                                 coded by alan kaylor cline
c                           from fitpack -- january 26, 1987
c                        a curve and surface fitting package
c                      a product of pleasant valley software
c                  8603 altus cove, austin, texas 78759, usa
c
c this subroutine returns approximations to
c       sinhm(x) = sinh(x)/x-1
c       coshm(x) = cosh(x)-1
c and
c       coshmm(x) = (cosh(x)-1-x*x/2)/(x*x)
c with relative error less than 1.0e-6
c
c on input--
c
c   x contains the value of the independent variable.
c
c   isw indicates the function desired
c           = -1 if only sinhm is desired,
c           =  0 if both sinhm and coshm are desired,
c           =  1 if only coshm is desired,
c           =  2 if only coshmm is desired,
c           =  3 if both sinhm and coshmm are desired.
c
c on output--
c
c   sinhm contains the value of sinhm(x) if isw .le. 0 or
c   isw .eq. 3 (sinhm is unaltered if isw .eq.1 or isw .eq.
c   2).
c
c   coshm contains the value of coshm(x) if isw .eq. 0 or
c   isw .eq. 1 and contains the value of coshmm(x) if isw
c   .ge. 2 (coshm is unaltered if isw .eq. -1).
c
c and
c
c   x and isw are unaltered.
c
c-----------------------------------------------------------
c
c      data sp13/.3029390e-5/,
c     *     sp12/.1975135e-3/,
c     *     sp11/.8334261e-2/,
c     *     sp10/.1666665e0/
c      data sp24/.3693467e-7/,
c     *     sp23/.2459974e-5/,
c     *     sp22/.2018107e-3/,
c     *     sp21/.8315072e-2/,
c     *     sp20/.1667035e0/
c      data sp33/.6666558e-5/,
c     *     sp32/.6646307e-3/,
c     *     sp31/.4001477e-1/,
c     *     sq32/.2037930e-3/,
c     *     sq31/-.6372739e-1/,
c     *     sq30/.6017497e1/
c      data sp43/.2311816e-4/,
c     *     sp42/.2729702e-3/,
c     *     sp41/.9868757e-1/,
c     *     sq42/.1776637e-3/,
c     *     sq41/-.7549779e-1/,
c     *     sq40/.9110034e1/
c      data cp4/.2982628e-6/,
c     *     cp3/.2472673e-4/,
c     *     cp2/.1388967e-2/,
c     *     cp1/.4166665e-1/,
c     *     cp0/.5000000e0/
cc
c      ax = abs(x)
c      if (isw .ge. 0) go to 5
cc
cc sinhm approximation
cc
c      if (ax .gt. 4.45) go to 2
c      xs = ax*ax
c      if (ax .gt. 2.3) go to 1
cc
cc sinhm approximation on (0.,2.3)
cc
c      sinhm = xs*(((sp13*xs+sp12)*xs+sp11)*xs+sp10)
c      return
cc
cc sinhm approximation on (2.3,4.45)
cc
c    1 sinhm = xs*((((sp24*xs+sp23)*xs+sp22)*xs+sp21)
c     .               *xs+sp20)
c      return
c    2 if (ax .gt. 7.65) go to 3
cc
cc sinhm approximation on (4.45,7.65)
cc
c      xs = ax*ax
c      sinhm = xs*(((sp33*xs+sp32)*xs+sp31)*xs+1.)/
c     .             ((sq32*xs+sq31)*xs+sq30)
c      return
c    3 if (ax .gt. 10.1) go to 4
cc
cc sinhm approximation on (7.65,10.1)
cc
c      xs = ax*ax
c      sinhm = xs*(((sp43*xs+sp42)*xs+sp41)*xs+1.)/
c     .             ((sq42*xs+sq41)*xs+sq40)
c      return
cc
cc sinhm approximation above 10.1
cc
c    4 sinhm = exp(ax)/(ax+ax)-1.
c      return
cc
cc coshm and (possibly) sinhm approximation
cc
c    5 if (isw .ge. 2) go to 7
c      if (ax .gt. 2.3) go to 6
c      xs = ax*ax
c      coshm = xs*((((cp4*xs+cp3)*xs+cp2)*xs+cp1)*xs+cp0)
c      if (isw .eq. 0) sinhm = xs*(((sp13*xs+sp12)*xs+sp11)
c     .                              *xs+sp10)
c      return
c    6 expx = exp(ax)
c      coshm = (expx+1./expx)/2.-1.
c      if (isw .eq. 0) sinhm = (expx-1./expx)/(ax+ax)-1.
c      return
cc
cc coshmm and (possibly) sinhm approximation
cc
c    7 xs = ax*ax
c      if (ax .gt. 2.3) go to 8
c      coshm = xs*(((cp4*xs+cp3)*xs+cp2)*xs+cp1)
c      if (isw .eq. 3) sinhm = xs*(((sp13*xs+sp12)*xs+sp11)
c     .                              *xs+sp10)
c      return
c    8 expx = exp(ax)
c      coshm = ((expx+1./expx-xs)/2.-1.)/xs
c      if (isw .eq. 3) sinhm = (expx-1./expx)/(ax+ax)-1.
c      return
c      end
      subroutine snhcsh (sinhm,coshm,x,isw)
c
      integer isw
      real sinhm,coshm,x
c
c                                 coded by alan kaylor cline
c                           from fitpack -- january 26, 1987
c                        a curve and surface fitting package
c                      a product of pleasant valley software
c                  8603 altus cove, austin, texas 78759, usa
c
c this subroutine returns approximations to
c       sinhm(x) = sinh(x)/x-1
c       coshm(x) = cosh(x)-1
c and
c       coshmm(x) = (cosh(x)-1-x*x/2)/(x*x)
c with relative error less than 4.0e-14.
c
c on input--
c
c   x contains the value of the independent variable.
c
c   isw indicates the function desired
c           = -1 if only sinhm is desired,
c           =  0 if both sinhm and coshm are desired,
c           =  1 if only coshm is desired,
c           =  2 if only coshmm is desired,
c           =  3 if both sinhm and coshmm are desired.
c
c on output--
c
c   sinhm contains the value of sinhm(x) if isw .le. 0 or
c   isw .eq. 3 (sinhm is unaltered if isw .eq.1 or isw .eq.
c   2).
c
c   coshm contains the value of coshm(x) if isw .eq. 0 or
c   isw .eq. 1 and contains the value of coshmm(x) if isw
c   .ge. 2 (coshm is unaltered if isw .eq. -1).
c
c and
c
c   x and isw are unaltered.
c
c-----------------------------------------------------------
c
      data sp14/.227581660976348e-7/,
     *     sp13/.612189863171694e-5/,
     *     sp12/.715314759211209e-3/,
     *     sp11/.398088289992973e-1/,
     *     sq12/.206382701413725e-3/,
     *     sq11/-.611470260009508e-1/,
     *     sq10/.599999999999986e+1/
      data sp25/.129094158037272e-9/,
     *     sp24/.473731823101666e-7/,
     *     sp23/.849213455598455e-5/,
     *     sp22/.833264803327242e-3/,
     *     sp21/.425024142813226e-1/,
     *     sq22/.106008515744821e-3/,
     *     sq21/-.449855169512505e-1/,
     *     sq20/.600000000268619e+1/
      data sp35/.155193945864942e-9/,
     *     sp34/.511529451668737e-7/,
     *     sp33/.884775635776784e-5/,
     *     sp32/.850447617691392e-3/,
     *     sp31/.428888148791777e-1/,
     *     sq32/.933128831061610e-4/,
     *     sq31/-.426677570538507e-1/,
     *     sq30/.600000145086489e+1/
      data sp45/.188070632058331e-9/,
     *     sp44/.545792817714192e-7/,
     *     sp43/.920119535795222e-5/,
     *     sp42/.866559391672985e-3/,
     *     sp41/.432535234960858e-1/,
     *     sq42/.824891748820670e-4/,
     *     sq41/-.404938841672262e-1/,
     *     sq40/.600005006283834e+1/
      data cp5/.552200614584744e-9/,
     *     cp4/.181666923620944e-6/,
     *     cp3/.270540125846525e-4/,
     *     cp2/.206270719503934e-2/,
     *     cp1/.744437205569040e-1/,
     *     cq2/.514609638642689e-4/,
     *     cq1/-.177792255528382e-1/,
     *     cq0/.200000000000000e+1/
      data zp4/.664418805876835e-8/,
     *     zp3/.218274535686385e-5/,
     *     zp2/.324851059327161e-3/,
     *     zp1/.244515150174258e-1/,
     *     zq2/.616165782306621e-3/,
     *     zq1/-.213163639579425e0/,
     *     zq0/.240000000000000e+2/
c
      ax = abs(x)
      if (isw .ge. 0) go to 5
c
c sinhm approximation
c
      if (ax .gt. 3.9) go to 2
      xs = ax*ax
      if (ax .gt. 2.2) go to 1
c
c sinhm approximation on (0.,2.2)
c
      sinhm = xs*((((sp14*xs+sp13)*xs+sp12)*xs+sp11)*xs+1.)/
     .             ((sq12*xs+sq11)*xs+sq10)
      return
c
c sinhm approximation on (2.2,3.9)
c
    1 sinhm = xs*(((((sp25*xs+sp24)*xs+sp23)*xs+sp22)*xs+sp21)
     .        *xs+1.)/((sq22*xs+sq21)*xs+sq20)
      return
    2 if (ax .gt. 5.1) go to 3
c
c sinhm approximation on (3.9,5.1)
c
      xs = ax*ax
      sinhm = xs*(((((sp35*xs+sp34)*xs+sp33)*xs+sp32)*xs+sp31)
     .        *xs+1.)/((sq32*xs+sq31)*xs+sq30)
      return
    3 if (ax .gt. 6.1) go to 4
c
c sinhm approximation on (5.1,6.1)
c
      xs = ax*ax
      sinhm = xs*(((((sp45*xs+sp44)*xs+sp43)*xs+sp42)*xs+sp41)
     .        *xs+1.)/((sq42*xs+sq41)*xs+sq40)
      return
c
c sinhm approximation above 6.1
c
    4 expx = exp(ax)
      sinhm = (expx-1./expx)/(ax+ax)-1.
      return
c
c coshm and (possibly) sinhm approximation
c
    5 if (isw .ge. 2) go to 7
      if (ax .gt. 2.2) go to 6
      xs = ax*ax
      coshm = xs*(((((cp5*xs+cp4)*xs+cp3)*xs+cp2)*xs+cp1)
     .        *xs+1.)/((cq2*xs+cq1)*xs+cq0)
      if (isw .eq. 0) sinhm = xs*((((sp14*xs+sp13)*xs+sp12)
     .          *xs+sp11)*xs+1.)/((sq12*xs+sq11)*xs+sq10)
      return
    6 expx = exp(ax)
      coshm = (expx+1./expx)/2.-1.
      if (isw .eq. 0) sinhm = (expx-1./expx)/(ax+ax)-1.
      return
c
c coshmm and (possibly) sinhm approximation
c
    7 xs = ax*ax
      if (ax .gt. 2.2) go to 8
      coshm = xs*((((zp4*xs+zp3)*xs+zp2)*xs+zp1)*xs+1.)/
     .             ((zq2*xs+zq1)*xs+zq0)
      if (isw .eq. 3) sinhm = xs*((((sp14*xs+sp13)*xs+sp12)
     .          *xs+sp11)*xs+1.)/((sq12*xs+sq11)*xs+sq10)
      return
    8 expx = exp(ax)
      coshm = ((expx+1./expx-xs)/2.-1.)/xs
      if (isw .eq. 3) sinhm = (expx-1./expx)/(ax+ax)-1.
      return
      end
      subroutine terms (diag,sdiag,sigma,del)
c
      real diag,sdiag,sigma,del
c
c                                 coded by alan kaylor cline
c                           from fitpack -- january 26, 1987
c                        a curve and surface fitting package
c                      a product of pleasant valley software
c                  8603 altus cove, austin, texas 78759, usa
c
c this subroutine computes the diagonal and superdiagonal
c terms of the tridiagonal linear system associated with
c spline under tension interpolation.
c
c on input--
c
c   sigma contains the tension factor.
c
c and
c
c   del contains the step size.
c
c on output--
c
c                sigma*del*cosh(sigma*del) - sinh(sigma*del)
c   diag = del*--------------------------------------------.
c                     (sigma*del)**2 * sinh(sigma*del)
c
c                   sinh(sigma*del) - sigma*del
c   sdiag = del*----------------------------------.
c                (sigma*del)**2 * sinh(sigma*del)
c
c and
c
c   sigma and del are unaltered.
c
c this subroutine references package module snhcsh.
c
c-----------------------------------------------------------
c
      if (sigma .ne. 0.) go to 1
      diag = del/3.
      sdiag = del/6.
      return
    1 sigdel = sigma*del
      call snhcsh (sinhm,coshm,sigdel,0)
      denom = sigma*sigdel*(1.+sinhm)
      diag = (coshm-sinhm)/denom
      sdiag = sinhm/denom
      return
      end

C
C $Id: pjindp.f,v 1.7 2008-07-27 00:17:12 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE PJINDP (ISYS,ZONE,ISPH,DATA)
C
      IMPLICIT DOUBLE PRECISION (A-Z)
      REAL SECS(5)
      INTEGER ITEMP
      INTEGER LAND, PATH, LIMIT, IND02, IND06, IND09, ISYS, KEEPZN
      INTEGER I,ZONE,ISPH,DEGS(5),MINS(5)
      INTEGER ID, IND, MODE, N
      INTEGER NAD27(134), NAD83(134)
C
      COMMON /STPLCH/ NM27,NM83
        CHARACTER*32 NM27(134),NM83(134)
      SAVE   /STPLCH/
      COMMON /STPLDP/ PA27,PA83
        DOUBLE PRECISION PA27(9,134),PA83(9,134)
      SAVE   /STPLDP/
      COMMON /STPLIR/ ID27,ID83
        INTEGER ID27(134),ID83(134)
      SAVE   /STPLIR/
C
      CHARACTER*32 PNAME
      CHARACTER*1 SGNA(5)
C
      DIMENSION DATA(15),BUFFL(15)
      DIMENSION TABLE(9)
      DIMENSION PR(20),XLR(20)
      DIMENSION ACOEF(6),BCOEF(6)
      COMMON /ERRMZ0/ IERR
        INTEGER IERR
      SAVE   /ERRMZ0/
      COMMON /PRINZ0/ IPEMSG,IPELUN,IPPARM,IPPLUN
        INTEGER IPEMSG,IPELUN,IPPARM,IPPLUN
      SAVE   /PRINZ0/
      COMMON /ELLPDP/ AZ,EZ,ESZ,E0Z,E1Z,E2Z,E3Z,E4Z
      COMMON /SPHRDP/ AZZ
      COMMON /NORMDP/ Q,T,U,W,ES22,P22,SA,CA,XJ
      COMMON /PC03DP/ A03,LON003,X003,Y003,C,E03,ES03,NS03,RH003
      COMMON /PC04DP/ A04,LON004,X004,Y004,E04,F04,NS04,RH004
      COMMON /PC05DP/ A05,LON005,X005,Y005,E05,M1
      COMMON /PC06DP/ A06,LON006,X006,Y006,E06,E4,FAC,MCS,TCS,IND06
      COMMON /PC07DP/ A07,LON007,X007,Y007,E07,E007,E107,E207,E307,ES07,
     .                ML007
      COMMON /PC08DP/ A08,LON008,X008,Y008,E008,E108,E208,E308,GL,NS08,
     .                RH008
      COMMON /PC09DP/ A09,LON009,X009,Y009,ES09,ESP,E009,E109,E209,E309,
     .                KS009,LAT009,ML009,IND09
      COMMON /PC10DP/ A10,LON010,X010,Y010,COSP10,LAT010,SINP10
      COMMON /PC11DP/ A11,LON011,X011,Y011,COSP11,LAT011,SINP11
      COMMON /PC12DP/ A12,LON012,X012,Y012,COSP12,LAT012,SINP12
      COMMON /PC13DP/ A13,LON013,X013,Y013,COSP13,LAT013,SINP13
      COMMON /PC14DP/ A14,LON014,X014,Y014,COSP14,LAT014,SINP14
      COMMON /PC15DP/ A15,LON015,X015,Y015,COSP15,LAT015,P,SINP15
      COMMON /PC16DP/ A16,LON016,X016,Y016
      COMMON /PC17DP/ A17,LON017,X017,Y017,LAT1
      COMMON /PC18DP/ A18,LON018,X018,Y018
      COMMON /PC19DP/ A19,LON019,X019,Y019
      COMMON /PC20DP/ LON020,X020,Y020,AL,BL,COSALF,COSGAM,E20,EL,
     +                SINALF,SINGAM,U0
      COMMON /PC21DP/ A21,LON021,X021,Y021,PR,XLR
      COMMON /PC22DP/ A22,X022,Y022,A2,A4,B,C1,C3,LAND,PATH
      COMMON /PC23DP/ A23,LON023,X023,Y023,ACOEF,BCOEF,EC,LAT023,
     .                CCHIO,SCHIO,N
C
      COMMON /USGSC1/  UTPA(15),UUMN,UUMX,UVMN,UVMX,IPRF
      DOUBLE PRECISION UTPA,UUMN,UUMX,UVMN,UVMX
      INTEGER IPRF
      SAVE   /USGSC1/
C
      DATA PI /3.14159265358979323846D0/
      DATA HALFPI /1.5707963267948966D0/
      DATA ZERO,HALF,ONE,TWO /0.0D0,0.5D0,1.0D0,2.0D0/
      DATA EPSLN /1.0D-10/
      DATA TOL /1.0D-7/
      DATA TOL09 /1.0D-5/
      DATA NINTYD /90000000.0D0/
      DATA DG1 /0.01745329252D0/
C
      DATA NAD27/0101,0102,5010,5300,0201,0202,0203,0301,0302,0401,0402,
     .           0403,0404,0405,0406,0407,0501,0502,0503,0600,0700,0901,
     .           0902,0903,1001,1002,5101,5102,5103,5104,5105,1101,1102,
     .           1103,1201,1202,1301,1302,1401,1402,1501,1502,1601,1602,
     .           1701,1702,1703,1801,1802,1900,2001,2002,2101,2102,2103,
     .           2111,2112,2113,2201,2202,2203,2301,2302,2401,2402,2403,
     .           2501,2502,2503,2601,2602,2701,2702,2703,2800,2900,3001,
     .           3002,3003,3101,3102,3103,3104,3200,3301,3302,3401,3402,
     .           3501,3502,3601,3602,3701,3702,3800,3901,3902,4001,4002,
     .           4100,4201,4202,4203,4204,4205,4301,4302,4303,4400,4501,
     .           4502,4601,4602,4701,4702,4801,4802,4803,4901,4902,4903,
     .           4904,5001,5002,5003,5004,5005,5006,5007,5008,5009,5201,
     .           5202,5400/
C
      DATA NAD83/0101,0102,5010,5300,0201,0202,0203,0301,0302,0401,0402,
     .           0403,0404,0405,0406,   0,0501,0502,0503,0600,0700,0901,
     .           0902,0903,1001,1002,5101,5102,5103,5104,5105,1101,1102,
     .           1103,1201,1202,1301,1302,1401,1402,1501,1502,1601,1602,
     .           1701,1702,1703,1801,1802,1900,2001,2002,2101,2102,2103,
     .           2111,2112,2113,2201,2202,2203,2301,2302,2401,2402,2403,
     .           2500,   0,   0,2600,   0,2701,2702,2703,2800,2900,3001,
     .           3002,3003,3101,3102,3103,3104,3200,3301,3302,3401,3402,
     .           3501,3502,3601,3602,3701,3702,3800,3900,   0,4001,4002,
     .           4100,4201,4202,4203,4204,4205,4301,4302,4303,4400,4501,
     .           4502,4601,4602,4701,4702,4801,4802,4803,4901,4902,4903,
     .           4904,5001,5002,5003,5004,5005,5006,5007,5008,5009,5200,
     .              0,5400/
C
C -- I N I T I A L I Z A T I O N   O F   P R O J E C T I O N S
C
      IPRF=0
      IERR=0
      IF (ISYS.NE.2) CALL SPHDDP (ISPH,DATA)
C
      GO TO ( 100, 200, 300, 400, 500, 600, 700, 800, 900,1000,
     +       1100,1200,1300,1400,1500,1600,1700,1800,1900,2000,
     +       2100,2200,2300) , ISYS
C
C -- U T M
C
  100    KEEPZN = ZONE
         ZONE = ABS(ZONE)
         IF (ZONE.LT.1 .OR. ZONE.GT.60) THEN
            IF (IPEMSG .EQ. 0) WRITE (IPELUN,140) KEEPZN
  140       FORMAT (/' ERROR PJ01DP'/
     .               ' ILLEGAL ZONE NO. : ',I10)
            IERR = 011
            RETURN
         END IF
         DATA(3) = 0.9996D0
         DATA(4) = ZERO
         DATA(5) = DBLE(6*ZONE-183)
         DATA(6) = ZERO
         DATA(7) = 500000.0D0
         DATA(8) = ZERO
         IF (KEEPZN .LT. 0) DATA(8) = 10000000.0D0
         ITEMP = IPPARM
         IPPARM = 1
         AZ = DATA(1)
         EZ = DATA(2)
         GO TO 900
C
C -- S T A T E   P L A N E
C
  200    IF (ISPH.NE.0.AND.ISPH.NE.8) THEN
            IF (IPEMSG .EQ. 0) WRITE (IPELUN,205) ISPH
  205       FORMAT(/' ERROR PJ02DP'/
     .              ' SPHEROID NO. ',I4,' IS INVALID FOR STATE PLANE',
     .              ' TRANSFORMATIONS')
            IERR = 020
            RETURN
         END IF
         IF (ZONE .GT. 0) THEN
            IND02 = 0
            IF (ISPH.EQ.0) THEN
               DO 210 I = 1,134
                  IF (ZONE .EQ. NAD27(I)) IND02 = I
  210          CONTINUE
            END IF
            IF (ISPH.EQ.8) THEN
               DO 220 I = 1,134
                  IF (ZONE .EQ. NAD83(I)) IND02 = I
  220          CONTINUE
            END IF
            IF (IND02 .EQ. 0) THEN
               IF (IPEMSG .EQ. 0) WRITE (IPELUN,240) ZONE,ISPH
               IERR = 021
               RETURN
            END IF
         ELSE
            IF (IPEMSG .EQ. 0) WRITE (IPELUN,240) ZONE,ISPH
            IERR = 021
            RETURN
         END IF
         IF (ISPH.EQ.0) THEN
            PNAME=NM27(IND02)
            ID=ID27(IND02)
            TABLE(1)=PA27(1,IND02)
            TABLE(2)=PA27(2,IND02)
            TABLE(3)=PA27(3,IND02)
            TABLE(4)=PA27(4,IND02)
            TABLE(5)=PA27(5,IND02)
            TABLE(6)=PA27(6,IND02)
            TABLE(7)=PA27(7,IND02)
            TABLE(8)=PA27(8,IND02)
            TABLE(9)=PA27(9,IND02)
         ELSE IF (ISPH.EQ.8) THEN
            PNAME=NM83(IND02)
            ID=ID83(IND02)
            TABLE(1)=PA83(1,IND02)
            TABLE(2)=PA83(2,IND02)
            TABLE(3)=PA83(3,IND02)
            TABLE(4)=PA83(4,IND02)
            TABLE(5)=PA83(5,IND02)
            TABLE(6)=PA83(6,IND02)
            TABLE(7)=PA83(7,IND02)
            TABLE(8)=PA83(8,IND02)
            TABLE(9)=PA83(9,IND02)
         END IF
         IF (ID .LE. 0) THEN
            IF (IPEMSG .EQ. 0) WRITE (IPELUN,240) ZONE,ISPH
  240       FORMAT(/' ERROR PJ02DP'/
     .              ' ILLEGAL ZONE NO. : ',I8,' FOR SPHEROID NO. : ',I4)
            IERR = 021
            RETURN
         END IF
         AZ = TABLE(1)
         ES = TABLE(2)
         ESZ = ES
         EZ  = SQRT(ES)
         E0Z = E0FNDP(ES)
         E1Z = E1FNDP(ES)
         E2Z = E2FNDP(ES)
         E3Z = E3FNDP(ES)
         E4Z = E4FNDP(EZ)
         ITEMP = IPPARM
         IPPARM = 1
C
C TRANSVERSE MERCATOR PROJECTION
C
         IF (ID.EQ.1) THEN
            DATA(3) = TABLE(4)
            DATA(5) = PAKRDP(PAKCDP(TABLE(3)))/.017453292519943D0
            DATA(6) = PAKRDP(PAKCDP(TABLE(7)))/.017453292519943D0
            DATA(7) = TABLE(8)
            DATA(8) = TABLE(9)
            GO TO 900
         END IF
C
C LAMBERT CONFORMAL PROJECTION
C
         IF (ID.EQ.2) THEN
            DATA(3) = PAKRDP(PAKCDP(TABLE(6)))/.017453292519943D0
            DATA(4) = PAKRDP(PAKCDP(TABLE(5)))/.017453292519943D0
            DATA(5) = PAKRDP(PAKCDP(TABLE(3)))/.017453292519943D0
            DATA(6) = PAKRDP(PAKCDP(TABLE(7)))/.017453292519943D0
            DATA(7) = TABLE(8)
            DATA(8) = TABLE(9)
            GO TO 400
         END IF
C
C POLYCONIC PROJECTION
C
         IF (ID.EQ.3) THEN
            DATA(5) = PAKRDP(PAKCDP(TABLE(3)))/.017453292519943D0
            DATA(6) = PAKRDP(PAKCDP(TABLE(4)))/.017453292519943D0
            DATA(7) = TABLE(5)
            DATA(8) = TABLE(6)
            GO TO 700
         END IF
C
C OBLIQUE MERCATOR PROJECTION
C
         IF (ID.EQ.4) THEN
            DATA(3) = TABLE(4)
            DATA(4) = PAKRDP(PAKCDP(TABLE(6)))/.017453292519943D0
            DATA(5) = PAKRDP(PAKCDP(TABLE(3)))/.017453292519943D0
            DATA(6) = PAKRDP(PAKCDP(TABLE(7)))/.017453292519943D0
            DATA(7) = TABLE(8)
            DATA(8) = TABLE(9)
            DATA(13) = ONE
            GO TO 2000
         END IF
C
C -- A L B E R S   C O N I C A L   E Q U A L   A R E A
C
  300    A03 = AZ
         E03 = EZ
         ES03 = ESZ
         LAT1 = .017453292519943D0 * DATA(3)
         LAT2 = .017453292519943D0 * DATA(4)
         IF (ABS(LAT1+LAT2) .LT. EPSLN) THEN
            IF (IPEMSG .EQ. 0) WRITE (IPELUN,340)
  340       FORMAT (/' ERROR PJ03DP'/
     .               ' EQUAL LATITUDES FOR ST. PARALLELS ON OPPOSITE',
     .               ' SIDES OF EQUATOR')
            IERR = 031
            RETURN
         END IF
         LON003 = .017453292519943D0 * DATA(5)
         LAT003 = .017453292519943D0 * DATA(6)
         X003 = DATA(7)
         Y003 = DATA(8)
         SINP03 = SIN (LAT1)
         CON = SINP03
         COSP03 = COS (LAT1)
         MS1 = MSFNDP (E03,SINP03,COSP03)
         QS1 = QSFNDP (E03,SINP03,COSP03)
         SINP03 = SIN (LAT2)
         COSP03 = COS (LAT2)
         MS2 = MSFNDP (E03,SINP03,COSP03)
         QS2 = QSFNDP (E03,SINP03,COSP03)
         SINP03 = SIN (LAT003)
         COSP03 = COS (LAT003)
         QS0 = QSFNDP (E03,SINP03,COSP03)
         IF (ABS(LAT1-LAT2) .GE. EPSLN) THEN
            NS03 = (MS1 * MS1 - MS2 * MS2) / (QS2 - QS1)
         ELSE
            NS03 = CON
         END IF
         C = MS1 * MS1 + NS03 * QS1
         RH003 = A03 * SQRT (C - NS03 * QS0) / NS03
C
C LIST RESULTS OF PARAMETER INITIALIZATION.
C
         CALL RADDDP (LAT1,SGNA(1),DEGS(1),MINS(1),SECS(1))
         CALL RADDDP (LAT2,SGNA(2),DEGS(2),MINS(2),SECS(2))
         CALL RADDDP (LON003,SGNA(3),DEGS(3),MINS(3),SECS(3))
         CALL RADDDP (LAT003,SGNA(4),DEGS(4),MINS(4),SECS(4))
         IF (IPPARM .EQ. 0) WRITE (IPPLUN,350) A03,ES03,
     .            (SGNA(I),DEGS(I),MINS(I),SECS(I),I=1,4),
     .            X003,Y003
  350   FORMAT (/' INITIALIZATION PARAMETERS (ALBERS CONICAL EQUAL-AREA'
     .          ,' PROJECTION)'/
     .           ' SEMI-MAJOR AXIS OF ELLIPSOID =',F12.2,' METERS'/
     .           ' ECCENTRICITY SQUARED         =',F12.9/
     .           ' LATITUDE OF 1ST ST. PARALLEL = ',A1,2I3,F7.3/
     .           ' LATITUDE OF 2ND ST. PARALLEL = ',A1,2I3,F7.3/
     .           ' LONGITUDE OF ORIGIN          = ',A1,2I3,F7.3/
     .           ' LATITUDE OF ORIGIN           = ',A1,2I3,F7.3/
     .           ' FALSE EASTING                =',F12.2,' METERS'/
     .           ' FALSE NORTHING               =',F12.2,' METERS')
         IPRF=3
         GO TO 9900
C
C -- L A M B E R T   C O N F O R M A L   C O N I C
C
  400    A04 = AZ
         E04 = EZ
         ES = ESZ
         LAT1 = .017453292519943D0 * DATA(3)
         LAT2 = .017453292519943D0 * DATA(4)
         IF (ABS(LAT1+LAT2) .LT. EPSLN) THEN
            IF (IPEMSG .EQ. 0) WRITE (IPELUN,440)
  440       FORMAT (/' ERROR PJ04DP'/
     .               ' EQUAL LATITUDES FOR ST. PARALLELS ON OPPOSITE',
     .               ' SIDES OF EQUATOR')
            IERR = 041
            RETURN
         END IF
         LON004 = .017453292519943D0 * DATA(5)
         LAT004 = .017453292519943D0 * DATA(6)
         X004 = DATA(7)
         Y004 = DATA(8)
         SINP04 = SIN (LAT1)
         CON = SINP04
         COSP04 = COS (LAT1)
         MS1 = MSFNDP (E04,SINP04,COSP04)
         TS1 = TSFNDP (E04,LAT1,SINP04)
         SINP04 = SIN (LAT2)
         COSP04 = COS (LAT2)
         MS2 = MSFNDP (E04,SINP04,COSP04)
         TS2 = TSFNDP (E04,LAT2,SINP04)
         SINP04 = SIN (LAT004)
         TS0 = TSFNDP (E04,LAT004,SINP04)
         IF (ABS(LAT1-LAT2) .GE. EPSLN) THEN
            NS04 = LOG (MS1 / MS2) / LOG (TS1 / TS2)
         ELSE
            NS04 = CON
         END IF
         F04 = MS1 / (NS04 * TS1 ** NS04)
         RH004 = A04 * F04 * TS0 ** NS04
C
C LIST RESULTS OF PARAMETER INITIALIZATION.
C
         CALL RADDDP (LAT1,SGNA(1),DEGS(1),MINS(1),SECS(1))
         CALL RADDDP (LAT2,SGNA(2),DEGS(2),MINS(2),SECS(2))
         CALL RADDDP (LON004,SGNA(3),DEGS(3),MINS(3),SECS(3))
         CALL RADDDP (LAT004,SGNA(4),DEGS(4),MINS(4),SECS(4))
         IF (IPPARM .EQ. 0) WRITE (IPPLUN,450) A04,ES,
     .            (SGNA(I),DEGS(I),MINS(I),SECS(I),I=1,4),
     .            X004,Y004
  450    FORMAT (/' INITIALIZATION PARAMETERS (LAMBERT CONFORMAL CONIC',
     .            ' PROJECTION)'/
     .            ' SEMI-MAJOR AXIS OF ELLIPSOID =',F12.2,' METERS'/
     .            ' ECCENTRICITY SQUARED         =',F12.9/
     .            ' LATITUDE OF 1ST ST. PARALLEL = ',A1,2I3,F7.3/
     .            ' LATITUDE OF 2ND ST. PARALLEL = ',A1,2I3,F7.3/
     .            ' LONGITUDE OF ORIGIN          = ',A1,2I3,F7.3/
     .            ' LATITUDE OF ORIGIN           = ',A1,2I3,F7.3/
     .            ' FALSE EASTING                =',F12.2,' METERS'/
     .            ' FALSE NORTHING               =',F12.2,' METERS')
         DATA(1) = A04
         DATA(2) = ES
C
C LIST STATE PLANE INITIALIZATION PARAMETERS IF NECESSARY
C
         IF (ISYS .EQ. 2) THEN
            IPPARM = ITEMP
            IF (IERR .NE. 0) RETURN
            IF (IPPARM .EQ. 0) WRITE (IPPLUN,470) ZONE, PNAME
  470    FORMAT (/' INITIALIZATION PARAMETERS (STATE PLANE PROJECTION)'/
     .            ' ZONE NUMBER = ',I4,5X,' ZONE NAME = ',A32)
            IF (IPPARM .EQ. 0) WRITE (IPPLUN,451) A04,ES,
     .               (SGNA(I),DEGS(I),MINS(I),SECS(I),I=1,4),
     .               X004,Y004
  451    FORMAT ( ' USING LAMBERT CONFORMAL CONIC PROJECTION'/
     .            ' SEMI-MAJOR AXIS OF ELLIPSOID =',F12.2,' METERS'/
     .            ' ECCENTRICITY SQUARED         =',F12.9/
     .            ' LATITUDE OF 1ST ST. PARALLEL = ',A1,2I3,F7.3/
     .            ' LATITUDE OF 2ND ST. PARALLEL = ',A1,2I3,F7.3/
     .            ' LONGITUDE OF ORIGIN          = ',A1,2I3,F7.3/
     .            ' LATITUDE OF ORIGIN           = ',A1,2I3,F7.3/
     .            ' FALSE EASTING                =',F12.2,' METERS'/
     .            ' FALSE NORTHING               =',F12.2,' METERS')
         END IF
C
         IPRF=4
         GO TO 9900
C
C -- M E R C A T O R
C
  500    A05 = AZ
         E05 = EZ
         ES = ESZ
         LON005 = .017453292519943D0 * DATA(5)
         LAT1 = .017453292519943D0 * DATA(6)
         M1 = COS(LAT1) / (SQRT( ONE - ES * SIN(LAT1) **2))
         X005 = DATA(7)
         Y005 = DATA(8)
C
C LIST RESULTS OF PARAMETER INITIALIZATION.
C
         CALL RADDDP (LAT1,SGNA(1),DEGS(1),MINS(1),SECS(1))
         CALL RADDDP (LON005,SGNA(2),DEGS(2),MINS(2),SECS(2))
         IF (IPPARM .EQ. 0) WRITE (IPPLUN,550) A05,ES,
     .            (SGNA(I),DEGS(I),MINS(I),SECS(I),I=1,2),
     .            X005,Y005
  550    FORMAT (/' INITIALIZATION PARAMETERS (MERCATOR',
     .            ' PROJECTION)'/
     .            ' SEMI-MAJOR AXIS OF ELLIPSOID =',F12.2,' METERS'/
     .            ' ECCENTRICITY SQUARED         =',F12.9/
     .            ' LATITUDE OF TRUE SCALE       = ',A1,2I3,F7.3/
     .            ' CENTRAL LONGITUDE            = ',A1,2I3,F7.3/
     .            ' FALSE EASTING                =',F12.2,' METERS'/
     .            ' FALSE NORTHING               =',F12.2,' METERS')
         IPRF=5
         GO TO 9900
C
C -- P O L A R   S T E R E O G R A P H I C
C
  600    A06 = AZ
         E06 = EZ
         ES = ESZ
         E4 = E4Z
         LON006 = .017453292519943D0 * DATA(5)
         SAVE = DATA(6)
         LATC = .017453292519943D0 * SAVE
         X006 = DATA(7)
         Y006 = DATA(8)
         FAC = ONE
         IF (SAVE .LT. ZERO) FAC =-ONE
         IND06 = 0
         IF (ABS(SAVE) .NE. NINTYD) THEN
            IND06 = 1
            CON1 = FAC * LATC
            SINPHI = SIN (CON1)
            COSPHI = COS (CON1)
            MCS = MSFNDP (E06,SINPHI,COSPHI)
            TCS = TSFNDP (E06,CON1,SINPHI)
         END IF
C
C LIST RESULTS OF PARAMETER INITIALIZATION.
C
         CALL RADDDP (LON006,SGNA(1),DEGS(1),MINS(1),SECS(1))
         CALL RADDDP (LATC,SGNA(2),DEGS(2),MINS(2),SECS(2))
         IF (IPPARM .EQ. 0) WRITE (IPPLUN,650) A06,ES,
     .            (SGNA(I),DEGS(I),MINS(I),SECS(I),I=1,2),
     .            X006,Y006
  650    FORMAT (/' INITIALIZATION PARAMETERS (POLAR STEREOGRAPHIC',
     .            ' PROJECTION)'/
     .            ' SEMI-MAJOR AXIS OF ELLIPSOID =',F12.2,' METERS'/
     .            ' ECCENTRICITY SQUARED         =',F12.9/
     .            ' LONGITUDE OF Y-AXIS          = ',A1,2I3,F7.3/
     .            ' LATITUDE OF TRUE SCALE       = ',A1,2I3,F7.3/
     .            ' FALSE EASTING                =',F12.2,' METERS'/
     .            ' FALSE NORTHING               =',F12.2,' METERS')
         IPRF=6
         GO TO 9900
C
C -- P O L Y C O N I C
C
  700    A07 = AZ
         E07 = EZ
         ES07 = ESZ
         E007 = E0Z
         E107 = E1Z
         E207 = E2Z
         E307 = E3Z
         LON007 = .017453292519943D0 * DATA(5)
         LAT007 = .017453292519943D0 * DATA(6)
         X007 = DATA(7)
         Y007 = DATA(8)
         ML007 = MLFNDP (E007,E107,E207,E307,LAT007)
C
C LIST RESULTS OF PARAMETER INITIALIZATION.
C
         CALL RADDDP (LON007,SGNA(1),DEGS(1),MINS(1),SECS(1))
         CALL RADDDP (LAT007,SGNA(2),DEGS(2),MINS(2),SECS(2))
         IF (IPPARM .EQ. 0) WRITE (IPPLUN,750) A07,ES07,
     .            (SGNA(I),DEGS(I),MINS(I),SECS(I),I=1,2),
     .            X007,Y007
  750    FORMAT (/' INITIALIZATION PARAMETERS (POLYCONIC',
     .            ' PROJECTION)'/
     .            ' SEMI-MAJOR AXIS OF ELLIPSOID =',F12.2,' METERS'/
     .            ' ECCENTRICITY SQUARED         =',F12.9/
     .            ' LONGITUDE OF ORIGIN          = ',A1,2I3,F7.3/
     .            ' LATITUDE OF ORIGIN           = ',A1,2I3,F7.3/
     .            ' FALSE EASTING                =',F12.2,' METERS'/
     .            ' FALSE NORTHING               =',F12.2,' METERS')
         DATA(1) = A07
         DATA(2) = ES07
C
C LIST STATE PLANE INITIALIZATION PARAMETERS IF NECESSARY
C
         IF (ISYS .EQ. 2) THEN
            IPPARM = ITEMP
            IF (IERR .NE. 0) RETURN
            IF (IPPARM .EQ. 0) WRITE (IPPLUN,470) ZONE, PNAME
            IF (IPPARM .EQ. 0) WRITE (IPPLUN,751) A07,ES07,
     .               (SGNA(I),DEGS(I),MINS(I),SECS(I),I=1,2),
     .               X007,Y007
  751    FORMAT ( ' USING POLYCONIC PROJECTION'/
     .            ' SEMI-MAJOR AXIS OF ELLIPSOID =',F12.2,' METERS'/
     .            ' ECCENTRICITY SQUARED         =',F12.9/
     .            ' LONGITUDE OF ORIGIN          = ',A1,2I3,F7.3/
     .            ' LATITUDE OF ORIGIN           = ',A1,2I3,F7.3/
     .            ' FALSE EASTING                =',F12.2,' METERS'/
     .            ' FALSE NORTHING               =',F12.2,' METERS')
         END IF
C
         IPRF=7
         GO TO 9900
C
C -- E Q U I D I S T A N T   C O N I C
C
  800    A08 = AZ
         E = EZ
         ES = ESZ
         E008 = E0Z
         E108 = E1Z
         E208 = E2Z
         E308 = E3Z
         LAT1 = .017453292519943D0 * DATA(3)
         LAT2 = .017453292519943D0 * DATA(4)
         IF (ABS(LAT1+LAT2) .LT. EPSLN) THEN
            IF (IPEMSG .EQ. 0) WRITE (IPELUN,840)
  840       FORMAT (/' ERROR PJ08DP'/
     .               ' EQUAL LATITUDES FOR ST. PARALLELS ON OPPOSITE',
     .               ' SIDES OF EQUATOR')
            IERR = 081
            RETURN
         END IF
         LON008 = .017453292519943D0 * DATA(5)
         LAT0 = .017453292519943D0 * DATA(6)
         X008 = DATA(7)
         Y008 = DATA(8)
         SINPHI = SIN (LAT1)
         COSPHI = COS (LAT1)
         MS1 = MSFNDP (E,SINPHI,COSPHI)
         ML1 = MLFNDP (E008,E108,E208,E308,LAT1)
         IND = 0
         IF (DATA(9) .NE. ZERO) THEN
            IND = 1
            SINPHI = SIN (LAT2)
            COSPHI = COS (LAT2)
            MS2 = MSFNDP (E,SINPHI,COSPHI)
            ML2 = MLFNDP (E008,E108,E208,E308,LAT2)
            IF (ABS(LAT1-LAT2) .GE. EPSLN) THEN
               NS08 = (MS1 - MS2) / (ML2 - ML1)
            ELSE
               NS08 = SINPHI
            END IF
         ELSE
            NS08 = SINPHI
         END IF
         GL = ML1 + MS1 / NS08
         ML0 = MLFNDP (E008,E108,E208,E308,LAT0)
         RH008 = A08 * (GL - ML0)
C
C LIST RESULTS OF PARAMETER INITIALIZATION.
C
         CALL RADDDP (LAT1,SGNA(1),DEGS(1),MINS(1),SECS(1))
         CALL RADDDP (LAT2,SGNA(2),DEGS(2),MINS(2),SECS(2))
         CALL RADDDP (LON008,SGNA(3),DEGS(3),MINS(3),SECS(3))
         CALL RADDDP (LAT0,SGNA(4),DEGS(4),MINS(4),SECS(4))
         IF (IND .NE. 0) THEN
            IF (IPPARM .EQ. 0) WRITE (IPPLUN,850) A08,ES,
     .               (SGNA(I),DEGS(I),MINS(I),SECS(I),I=1,4),
     .               X008,Y008
  850       FORMAT (/' INITIALIZATION PARAMETERS (EQUIDISTANT CONIC',
     .               ' PROJECTION)'/
     .               ' SEMI-MAJOR AXIS OF ELLIPSOID =',F12.2,' METERS'/
     .               ' ECCENTRICITY SQUARED         =',F12.9/
     .               ' LATITUDE OF 1ST ST. PARALLEL = ',A1,2I3,F7.3/
     .               ' LATITUDE OF 2ND ST. PARALLEL = ',A1,2I3,F7.3/
     .               ' LONGITUDE OF ORIGIN          = ',A1,2I3,F7.3/
     .               ' LATITUDE OF ORIGIN           = ',A1,2I3,F7.3/
     .               ' FALSE EASTING                =',F12.2,' METERS'/
     .               ' FALSE NORTHING               =',F12.2,' METERS')
         ELSE
            IF (IPPARM .EQ. 0) WRITE (IPPLUN,860) A08,ES,
     .                SGNA(1),DEGS(1),MINS(1),SECS(1),
     .               (SGNA(I),DEGS(I),MINS(I),SECS(I),I=3,4),
     .               X008,Y008
  860       FORMAT (/' INITIALIZATION PARAMETERS (EQUIDISTANT CONIC',
     .               ' PROJECTION)'/
     .               ' SEMI-MAJOR AXIS OF ELLIPSOID =',F12.2,' METERS'/
     .               ' ECCENTRICITY SQUARED         =',F12.9/
     .               ' LATITUDE OF ST. PARALLEL     = ',A1,2I3,F7.3/
     .               ' LONGITUDE OF ORIGIN          = ',A1,2I3,F7.3/
     .               ' LATITUDE OF ORIGIN           = ',A1,2I3,F7.3/
     .               ' FALSE EASTING                =',F12.2,' METERS'/
     .               ' FALSE NORTHING               =',F12.2,' METERS')
         END IF
         IPRF=8
         GO TO 9900
C
C -- T R A N S V E R S E   M E R C A T O R
C
  900    A09 = AZ
         E09 = EZ
         ES09 = ESZ
         E009 = E0Z
         E109 = E1Z
         E209 = E2Z
         E309 = E3Z
         KS009 = DATA(3)
         LON009 = .017453292519943D0 * DATA(5)
         LAT009 = .017453292519943D0 * DATA(6)
         X009 = DATA(7)
         Y009 = DATA(8)
         ML009 = A09 * MLFNDP (E009,E109,E209,E309,LAT009)
         IND09 = 1
         ESP = ES09
         IF (E09 .GE. TOL09) THEN
            IND09 = 0
            ESP = ES09 / (ONE - ES09)
         END IF
C
C LIST RESULTS OF PARAMETER INITIALIZATION.
C
         CALL RADDDP (LON009,SGNA(1),DEGS(1),MINS(1),SECS(1))
         CALL RADDDP (LAT009,SGNA(2),DEGS(2),MINS(2),SECS(2))
         IF (IPPARM .EQ. 0) WRITE (IPPLUN,950) A09,ES09,KS009,
     .            (SGNA(I),DEGS(I),MINS(I),SECS(I),I=1,2),
     .            X009,Y009
  950    FORMAT (/' INITIALIZATION PARAMETERS (TRANSVERSE MERCATOR',
     .            ' PROJECTION)'/
     .            ' SEMI-MAJOR AXIS OF ELLIPSOID =',F12.2,' METERS'/
     .            ' ECCENTRICITY SQUARED         =',F12.9/
     .            ' SCALE FACTOR AT C. MERIDIAN  =',F9.6/
     .            ' LONGITUDE OF C. MERIDIAN     = ',A1,2I3,F7.3/
     .            ' LATITUDE OF ORIGIN           = ',A1,2I3,F7.3/
     .            ' FALSE EASTING                =',F12.2,' METERS'/
     .            ' FALSE NORTHING               =',F12.2,' METERS')
         DATA(1) = A09
         DATA(2) = ES09
C
C LIST UTM PROJECTION INITIALIZATION PARAMETERS IF NECESSARY
C
         IF (ISYS .EQ. 1) THEN
            IPPARM = ITEMP
            BUFFL(1) = A09
            BUFFL(2) = ES09
            ZONE = KEEPZN
            IF (IERR .NE. 0) RETURN
            IF (IPPARM .EQ. 0) WRITE (IPPLUN,960) ZONE,BUFFL(1),
     .            BUFFL(2),BUFFL(3),
     .            SGNA(1),DEGS(1),MINS(1),SECS(1),
     .            BUFFL(7),BUFFL(8)
  960    FORMAT (/' INITIALIZATION PARAMETERS (U T M PROJECTION)'/
     .            ' ZONE = ',I3/
     .            ' SEMI-MAJOR AXIS OF ELLIPSOID = ',F12.2,' METERS'/
     .            ' ECCENTRICITY SQUARED         = ',F18.15/
     .            ' SCALE FACTOR AT C. MERIDIAN  = ',F9.6/
     .            ' LONGITUDE OF CENTRAL MERIDIAN= ',A1,2I3,F7.3/
     .            ' FALSE EASTING                = ',F12.2,' METERS'/
     .            ' FALSE NORTHING               = ',F12.2,' METERS')
         END IF
C
C LIST STATE PLANE INITIALIZATION PARAMETERS IF NECESSARY
C
         IF (ISYS .EQ. 2) THEN
            IPPARM = ITEMP
            IF (IERR .NE. 0) RETURN
            IF (IPPARM .EQ. 0) WRITE (IPPLUN,470) ZONE, PNAME
            IF (IPPARM .EQ. 0) WRITE (IPPLUN,951) A09,ES09,KS009,
     .               (SGNA(I),DEGS(I),MINS(I),SECS(I),I=1,2),
     .               X009,Y009
  951    FORMAT ( ' USING TRANSVERSE MERCATOR PROJECTION'/
     .            ' SEMI-MAJOR AXIS OF ELLIPSOID =',F12.2,' METERS'/
     .            ' ECCENTRICITY SQUARED         =',F12.9/
     .            ' SCALE FACTOR AT C. MERIDIAN  =',F9.6/
     .            ' LONGITUDE OF C. MERIDIAN     = ',A1,2I3,F7.3/
     .            ' LATITUDE OF ORIGIN           = ',A1,2I3,F7.3/
     .            ' FALSE EASTING                =',F12.2,' METERS'/
     .            ' FALSE NORTHING               =',F12.2,' METERS')
         END IF
C
         IPRF=9
         GO TO 9900
C
C -- S T E R E O G R A P H I C
C
 1000    A10 = AZZ
         LON010 = .017453292519943D0 * DATA(5)
         LAT010 = .017453292519943D0 * DATA(6)
         X010 = DATA(7)
         Y010 = DATA(8)
         SINP10 = SIN (LAT010)
         COSP10 = COS (LAT010)
C
C LIST RESULTS OF PARAMETER INITIALIZATION.
C
         CALL RADDDP (LON010,SGNA(1),DEGS(1),MINS(1),SECS(1))
         CALL RADDDP (LAT010,SGNA(2),DEGS(2),MINS(2),SECS(2))
         IF (IPPARM .EQ. 0) WRITE (IPPLUN,1050) A10,
     .            (SGNA(I),DEGS(I),MINS(I),SECS(I),I=1,2),
     .            X010,Y010
 1050    FORMAT (/' INITIALIZATION PARAMETERS (STEREOGRAPHIC',
     .            ' PROJECTION)'/
     .            ' RADIUS OF SPHERE             =',F12.2,' METERS'/
     .            ' LONGITUDE OF CENTER          = ',A1,2I3,F7.3/
     .            ' LATITUDE  OF CENTER          = ',A1,2I3,F7.3/
     .            ' FALSE EASTING                =',F12.2,' METERS'/
     .            ' FALSE NORTHING               =',F12.2,' METERS')
         IPRF=10
         GO TO 9900
C
C -- L A M B E R T   A Z I M U T H A L   E Q U A L - A R E A
C
 1100    A11 = AZZ
         LON011 = .017453292519943D0 * DATA(5)
         LAT011 = .017453292519943D0 * DATA(6)
         X011 = DATA(7)
         Y011 = DATA(8)
         SINP11 = SIN (LAT011)
         COSP11 = COS (LAT011)
C
C LIST RESULTS OF PARAMETER INITIALIZATION.
C
         CALL RADDDP (LON011,SGNA(1),DEGS(1),MINS(1),SECS(1))
         CALL RADDDP (LAT011,SGNA(2),DEGS(2),MINS(2),SECS(2))
         IF (IPPARM .EQ. 0) WRITE (IPPLUN,1150) A11,
     .            (SGNA(I),DEGS(I),MINS(I),SECS(I),I=1,2),
     .            X011,Y011
 1150    FORMAT (/' INITIALIZATION PARAMETERS (LAMBERT AZIMUTHAL EQUAL',
     .            '-AREA PROJECTION)'/
     .            ' RADIUS OF SPHERE             =',F12.2,' METERS'/
     .            ' LONGITUDE OF CENTER          = ',A1,2I3,F7.3/
     .            ' LATITUDE  OF CENTER          = ',A1,2I3,F7.3/
     .            ' FALSE EASTING                =',F12.2,' METERS'/
     .            ' FALSE NORTHING               =',F12.2,' METERS')
         IPRF=11
         GO TO 9900
C
C -- A Z I M U T H A L   E Q U I D I S T A N T
C
 1200    A12 = AZZ
         LON012 = .017453292519943D0 * DATA(5)
         LAT012 = .017453292519943D0 * DATA(6)
         X012 = DATA(7)
         Y012 = DATA(8)
         SINP12 = SIN (LAT012)
         COSP12 = COS (LAT012)
C
C LIST RESULTS OF PARAMETER INITIALIZATION.
C
         CALL RADDDP (LON012,SGNA(1),DEGS(1),MINS(1),SECS(1))
         CALL RADDDP (LAT012,SGNA(2),DEGS(2),MINS(2),SECS(2))
         IF (IPPARM .EQ. 0) WRITE (IPPLUN,1250) A12,
     .            (SGNA(I),DEGS(I),MINS(I),SECS(I),I=1,2),
     .            X012,Y012
 1250    FORMAT (/' INITIALIZATION PARAMETERS (AZIMUTHAL EQUIDISTANT',
     .            ' PROJECTION)'/
     .            ' RADIUS OF SPHERE             =',F12.2,' METERS'/
     .            ' LONGITUDE OF CENTER          = ',A1,2I3,F7.3/
     .            ' LATITUDE  OF CENTER          = ',A1,2I3,F7.3/
     .            ' FALSE EASTING                =',F12.2,' METERS'/
     .            ' FALSE NORTHING               =',F12.2,' METERS')
         IPRF=12
         GO TO 9900
C
C -- G N O M O N I C
C
 1300    A13 = AZZ
         LON013 = .017453292519943D0 * DATA(5)
         LAT013 = .017453292519943D0 * DATA(6)
         X013 = DATA(7)
         Y013 = DATA(8)
         SINP13 = SIN (LAT013)
         COSP13 = COS (LAT013)
C
C LIST RESULTS OF PARAMETER INITIALIZATION.
C
         CALL RADDDP (LON013,SGNA(1),DEGS(1),MINS(1),SECS(1))
         CALL RADDDP (LAT013,SGNA(2),DEGS(2),MINS(2),SECS(2))
         IF (IPPARM .EQ. 0) WRITE (IPPLUN,1350) A13,
     .            (SGNA(I),DEGS(I),MINS(I),SECS(I),I=1,2),
     .            X013,Y013
 1350    FORMAT (/' INITIALIZATION PARAMETERS (GNOMONIC',
     .            ' PROJECTION)'/
     .            ' RADIUS OF SPHERE             =',F12.2,' METERS'/
     .            ' LONGITUDE OF CENTER          = ',A1,2I3,F7.3/
     .            ' LATITUDE  OF CENTER          = ',A1,2I3,F7.3/
     .            ' FALSE EASTING                =',F12.2,' METERS'/
     .            ' FALSE NORTHING               =',F12.2,' METERS')
         IPRF=13
         GO TO 9900
C
C -- O R T H O G R A P H I C
C
 1400    A14 = AZZ
         LON014 = .017453292519943D0 * DATA(5)
         LAT014 = .017453292519943D0 * DATA(6)
         X014 = DATA(7)
         Y014 = DATA(8)
         SINP14 = SIN (LAT014)
         COSP14 = COS (LAT014)
C
C LIST RESULTS OF PARAMETER INITIALIZATION.
C
         CALL RADDDP (LON014,SGNA(1),DEGS(1),MINS(1),SECS(1))
         CALL RADDDP (LAT014,SGNA(2),DEGS(2),MINS(2),SECS(2))
         IF (IPPARM .EQ. 0) WRITE (IPPLUN,1450) A14,
     .            (SGNA(I),DEGS(I),MINS(I),SECS(I),I=1,2),
     .            X014,Y014
 1450    FORMAT (/' INITIALIZATION PARAMETERS (ORTHOGRAPHIC',
     .            ' PROJECTION)'/
     .            ' RADIUS OF SPHERE             =',F12.2,' METERS'/
     .            ' LONGITUDE OF CENTER          = ',A1,2I3,F7.3/
     .            ' LATITUDE  OF CENTER          = ',A1,2I3,F7.3/
     .            ' FALSE EASTING                =',F12.2,' METERS'/
     .            ' FALSE NORTHING               =',F12.2,' METERS')
         IPRF=14
         GO TO 9900
C
C -- V E R T I C A L   N E A R - S I D E   P E R S P E C T I V E
C
 1500    A15 = AZZ
         P = ONE + DATA(3) / A15
         LON015 = .017453292519943D0 * DATA(5)
         LAT015 = .017453292519943D0 * DATA(6)
         X015 = DATA(7)
         Y015 = DATA(8)
         SINP15 = SIN (LAT015)
         COSP15 = COS (LAT015)
C
C     LIST RESULTS OF PARAMETER INITIALIZATION.
C
         CALL RADDDP (LON015,SGNA(1),DEGS(1),MINS(1),SECS(1))
         CALL RADDDP (LAT015,SGNA(2),DEGS(2),MINS(2),SECS(2))
         IF (IPPARM .EQ. 0) WRITE (IPPLUN,1550) A15,DATA(3),
     .            (SGNA(I),DEGS(I),MINS(I),SECS(I),I=1,2),
     .            X015,Y015
 1550    FORMAT (/' INITIALIZATION PARAMETERS (GENERAL VERTICAL NEAR-S',
     .            'IDE PERSPECTIVE PROJECTION)'/
     .            ' RADIUS OF SPHERE             =',F12.2,' METERS'/
     .            ' HEIGHT OF PERSPECTIVE POINT'/
     .            ' ABOVE SPHERE                 =',F12.2,' METERS'/
     .            ' LONGITUDE OF CENTER          = ',A1,2I3,F7.3/
     .            ' LATITUDE  OF CENTER          = ',A1,2I3,F7.3/
     .            ' FALSE EASTING                =',F12.2,' METERS'/
     .            ' FALSE NORTHING               =',F12.2,' METERS')
         IPRF=15
         GO TO 9900
C
C -- S I N U S O I D A L
C
 1600    A16 = AZZ
         LON016 = .017453292519943D0 * DATA(5)
         X016 = DATA(7)
         Y016 = DATA(8)
C
C LIST RESULTS OF PARAMETER INITIALIZATION.
C
         CALL RADDDP (LON016,SGNA(1),DEGS(1),MINS(1),SECS(1))
         IF (IPPARM .EQ. 0) WRITE (IPPLUN,1650) A16,
     .            SGNA(1),DEGS(1),MINS(1),SECS(1),
     .            X016,Y016
 1650    FORMAT (/' INITIALIZATION PARAMETERS (SINUSOIDAL',
     .            ' PROJECTION)'/
     .            ' RADIUS OF SPHERE             =',F12.2,' METERS'/
     .            ' LONGITUDE OF C. MERIDIAN     = ',A1,2I3,F7.3/
     .            ' FALSE EASTING                =',F12.2,' METERS'/
     .            ' FALSE NORTHING               =',F12.2,' METERS')
         IPRF=16
         GO TO 9900
C
C -- E Q U I R E C T A N G U L A R
C
 1700    A17 = AZZ
         LAT1 = .017453292519943D0 * DATA(6)
         LON017 = .017453292519943D0 * DATA(5)
         X017 = DATA(7)
         Y017 = DATA(8)
C
C LIST RESULTS OF PARAMETER INITIALIZATION.
C
         CALL RADDDP (LAT1,SGNA(1),DEGS(1),MINS(1),SECS(1))
         CALL RADDDP (LON017,SGNA(2),DEGS(2),MINS(2),SECS(2))
         IF (IPPARM .EQ. 0) WRITE (IPPLUN,1750) A17,
     .            (SGNA(I),DEGS(I),MINS(I),SECS(I),I=1,2),
     .            X017,Y017
 1750    FORMAT (/' INITIALIZATION PARAMETERS (EQUIRECTANGULAR PROJECT',
     .            'ION)'/
     .            ' RADIUS OF SPHERE             =',F12.2,' METERS'/
     .            ' LATITUDE OF TRUE SCALE       = ',A1,2I2,F7.3/
     .            ' LONGITUDE OF C. MERIDIAN     = ',A1,2I3,F7.3/
     .            ' FALSE EASTING                =',F12.2,' METERS'/
     .            ' FALSE NORTHING               =',F12.2,' METERS')
         IPRF=17
         GO TO 9900
C
C -- M I L L E R   C Y L I N D R I C A L
C
 1800    A18 = AZZ
         LON018 = .017453292519943D0 * DATA(5)
         X018 = DATA(7)
         Y018 = DATA(8)
C
C LIST RESULTS OF PARAMETER INITIALIZATION.
C
         CALL RADDDP (LON018,SGNA(1),DEGS(1),MINS(1),SECS(1))
         IF (IPPARM .EQ. 0) WRITE (IPPLUN,1850) A18,
     .             SGNA(1),DEGS(1),MINS(1),SECS(1),
     .             X018,Y018
 1850    FORMAT (/' INITIALIZATION PARAMETERS (MILLER CYLINDRICAL',
     .            ' PROJECTION)'/
     .            ' RADIUS OF SPHERE             =',F12.2,' METERS'/
     .            ' LONGITUDE OF C. MERIDIAN     = ',A1,2I3,F7.3/
     .            ' FALSE EASTING                =',F12.2,' METERS'/
     .            ' FALSE NORTHING               =',F12.2,' METERS')
         IPRF=18
         GO TO 9900
C
C -- V A N   D E R   G R I N T E N   I
C
 1900    A19 = AZZ
         LON019 = .017453292519943D0 * DATA(5)
         X019 = DATA(7)
         Y019 = DATA(8)
C
C LIST RESULTS OF PARAMETER INITIALIZATION.
C
         CALL RADDDP (LON019,SGNA(1),DEGS(1),MINS(1),SECS(1))
         IF (IPPARM .EQ. 0) WRITE (IPPLUN,1950) A19,
     .             SGNA(1),DEGS(1),MINS(1),SECS(1),
     .             X019,Y019
 1950    FORMAT (/' INITIALIZATION PARAMETERS (VAN DER GRINTEN I',
     .            ' PROJECTION)'/
     .            ' RADIUS OF SPHERE             =',F12.2,' METERS'/
     .            ' LONGITUDE OF C. MERIDIAN     = ',A1,2I3,F7.3/
     .            ' FALSE EASTING                =',F12.2,' METERS'/
     .            ' FALSE NORTHING               =',F12.2,' METERS')
         IPRF=19
         GO TO 9900
C
C -- O B L I Q U E   M E R C A T O R   ( H O T I N E )
C
 2000    MODE = 0
         IF (DATA(13) .NE. ZERO) MODE = 1
         A = AZ
         E20 = EZ
         ES = ESZ
         KS0 = DATA(3)
         LAT0 = .017453292519943D0 * DATA(6)
         X020 = DATA(7)
         Y020 = DATA(8)
         SINPH0 = SIN (LAT0)
         COSPH0 = COS (LAT0)
         CON = ONE - ES * SINPH0 * SINPH0
         COM = SQRT (ONE - ES)
         BL = SQRT (ONE + ES * COSPH0 ** 4 / (ONE - ES))
         AL = A * BL * KS0 * COM / CON
         IF (ABS(LAT0).LT.EPSLN) TS0 = 1.0D0
         IF (ABS(LAT0).LT.EPSLN) D=1.0D0
         IF (ABS(LAT0).LT.EPSLN) EL=1.0D0
         IF (ABS(LAT0).GE.EPSLN) THEN
            TS0 = TSFNDP (E20,LAT0,SINPH0)
            CON = SQRT (CON)
            D = BL * COM / (COSPH0 * CON)
            F = D + SIGN (SQRT (MAX ((D * D - ONE), 0.0D0)) , LAT0)
            EL = F * TS0 ** BL
         END IF
         IF (IPPARM .EQ. 0) WRITE (IPPLUN,2050) A,ES,KS0,X020,Y020
 2050    FORMAT (/' INITIALIZATION PARAMETERS (OBLIQUE MERCATOR ''HOTI',
     .            'NE'' PROJECTION)'/
     .            ' SEMI-MAJOR AXIS OF ELLIPSOID =',F12.2,' METERS'/
     .            ' ECCENTRICITY SQUARED         =',F12.9/
     .            ' SCALE AT CENTER              =',F12.9/
     .            ' FALSE EASTING                =',F12.2,' METERS'/
     .            ' FALSE NORTHING               =',F12.2,' METERS')
         IF (MODE .NE. 0) THEN
            ALPHA = .017453292519943D0 * DATA(4)
            LONC = .017453292519943D0 * DATA(5)
            G = HALF * (F - ONE / F)
            GAMMA = ASINDP (SIN (ALPHA) / D)
            LON020 = LONC - ASINDP (G * TAN (GAMMA)) / BL
C
C LIST INITIALIZATION PARAMETERS (CASE B).
C
            CALL RADDDP (ALPHA,SGNA(1),DEGS(1),MINS(1),SECS(1))
            CALL RADDDP (LONC,SGNA(2),DEGS(2),MINS(2),SECS(2))
            CALL RADDDP (LAT0,SGNA(3),DEGS(3),MINS(3),SECS(3))
            IF (IPPARM .EQ. 0) WRITE (IPPLUN,2060)
     .               (SGNA(I),DEGS(I),MINS(I),SECS(I),I=1,3)
 2060       FORMAT (' AZIMUTH OF CENTRAL LINE      = ',A1,2I3,F7.3/
     .              ' LONGITUDE OF ORIGIN          = ',A1,2I3,F7.3/
     .              ' LATITUDE OF ORIGIN           = ',A1,2I3,F7.3)
            CON = ABS (LAT0)
            IF (CON.GT.EPSLN .AND. ABS(CON - HALFPI).GT.EPSLN) THEN
               SINGAM = SIN (GAMMA)
               COSGAM = COS (GAMMA)
               SINALF = SIN (ALPHA)
               COSALF = COS (ALPHA)
               U0 = SIGN((AL/BL)*ATAN(SQRT(D*D-ONE)/COSALF),LAT0)
               IF (IPPARM .EQ. 0) WRITE (IPPLUN,2080) X020,Y020
               DATA(1) = A
               DATA(2) = ES
C
C LIST STATE PLANE INITIALIZATION PARAMETERS IF NECESSARY
C
               IF (ISYS .EQ. 2) THEN
                  IPPARM = ITEMP
                  IF (IERR .NE. 0) RETURN
                  IF (IPPARM .EQ. 0) WRITE (IPPLUN,470) ZONE, PNAME
                  IF (IPPARM .EQ. 0) WRITE (IPPLUN,2051) A,ES,KS0,X020,
     .                                                            Y020
 2051 FORMAT ( ' USING OBLIQUE MERCATOR (''HOTINE'') PROJECTION'/
     .         ' SEMI-MAJOR AXIS OF ELLIPSOID =',F12.2,' METERS'/
     .         ' ECCENTRICITY SQUARED         =',F12.9/
     .         ' SCALE AT CENTER              =',F12.9/
     .         ' FALSE EASTING                =',F12.2,' METERS'/
     .         ' FALSE NORTHING               =',F12.2,' METERS')
                  IF (IPPARM .EQ. 0) WRITE (IPPLUN,2060)
     .                     (SGNA(I),DEGS(I),MINS(I),SECS(I),I=1,3)
               END IF
C
               IPRF=20
               GO TO 9900
            ELSE
               IF (IPEMSG .EQ. 0) WRITE (IPELUN,2040)
 2040          FORMAT (/' ERROR PJ20DP'/
     .                  ' INPUT DATA ERROR')
               IERR = 201
               RETURN
            END IF
         END IF
         LON1 = .017453292519943D0 * DATA(9)
         LAT1 = .017453292519943D0 * DATA(10)
         LON2 = .017453292519943D0 * DATA(11)
         LAT2 = .017453292519943D0 * DATA(12)
         SINPHI = SIN (LAT1)
         TS1 = TSFNDP (E20,LAT1,SINPHI)
         SINPHI = SIN (LAT2)
         TS2 = TSFNDP (E20,LAT2,SINPHI)
         H = TS1 ** BL
         L = TS2 ** BL
         F = EL / H
         G = HALF * (F - ONE / F)
         J = (EL * EL - L * H) / (EL * EL + L * H)
         P = (L - H) / (L + H)
         CALL RADDDP (LON2,SGNA(3),DEGS(3),MINS(3),SECS(3))
         DLON = LON1 - LON2
         IF (DLON .LT. -PI) LON2 = LON2 - 2.D0 * PI
         IF (DLON .GT.  PI) LON2 = LON2 + 2.D0 * PI
         DLON = LON1 - LON2
         LON020 = HALF * (LON1 + LON2) - ATAN (J * TAN (HALF * BL *
     .          DLON) / P) / BL
         DLON = ADJLDP (LON1 - LON020)
         GAMMA = ATAN (SIN (BL * DLON) / G)
         ALPHA = ASINDP (D * SIN (GAMMA))
         CALL RADDDP (LON1,SGNA(1),DEGS(1),MINS(1),SECS(1))
         CALL RADDDP (LAT1,SGNA(2),DEGS(2),MINS(2),SECS(2))
         CALL RADDDP (LAT2,SGNA(4),DEGS(4),MINS(4),SECS(4))
         CALL RADDDP (LAT0,SGNA(5),DEGS(5),MINS(5),SECS(5))
         IF (IPPARM .EQ. 0) WRITE (IPPLUN,2070)
     .            (SGNA(I),DEGS(I),MINS(I),SECS(I),I=1,5)
 2070    FORMAT (' LONGITUDE OF 1ST POINT       = ',A1,2I3,F7.3/
     .           ' LATITUDE OF 1ST POINT        = ',A1,2I3,F7.3/
     .           ' LONGITUDE OF 2ND POINT       = ',A1,2I3,F7.3/
     .           ' LATITUDE OF 2ND POINT        = ',A1,2I3,F7.3/
     .           ' LATITUDE OF ORIGIN           = ',A1,2I3,F7.3)
         IF (ABS(LAT1 - LAT2) .LE. EPSLN) THEN
            IF (IPEMSG .EQ. 0) WRITE (IPELUN,2040)
            IERR = 202
            RETURN
         ELSE
            CON = ABS (LAT1)
         END IF
         IF (CON.LE.EPSLN .OR. ABS(CON - HALFPI).LE.EPSLN) THEN
            IF (IPEMSG .EQ. 0) WRITE (IPELUN,2040)
            IERR = 202
            RETURN
         ELSE
            IF (ABS(ABS(LAT0) - HALFPI) .LE. EPSLN) THEN
               IF (IPEMSG .EQ. 0) WRITE (IPELUN,2040)
               IERR = 202
               RETURN
            END IF
         END IF
         SINGAM = SIN (GAMMA)
         COSGAM = COS (GAMMA)
         SINALF = SIN (ALPHA)
         COSALF = COS (ALPHA)
         U0 = SIGN((AL/BL)*ATAN(SQRT(D*D-ONE)/COSALF),LAT0)
         IF (IPPARM .EQ. 0) WRITE (IPPLUN,2080) X020,Y020
 2080    FORMAT (' FALSE EASTING                =',F12.2,' METERS'/
     .           ' FALSE NORTHING               =',F12.2,' METERS')
         IPRF=20
         GO TO 9900
C
C -- R O B I N S O N
C
 2100    A21 = AZZ
         LON021 = .017453292519943D0 * DATA(5)
         X021 = DATA(7)
         Y021 = DATA(8)
         PR(1)=-0.062D0
         XLR(1)=0.9986D0
         PR(2)=0.D0
         XLR(2)=1.D0
         PR(3)=0.062D0
         XLR(3)=0.9986D0
         PR(4)=0.124D0
         XLR(4)=0.9954D0
         PR(5)=0.186D0
         XLR(5)=0.99D0
         PR(6)=0.248D0
         XLR(6)=0.9822D0
         PR(7)=0.31D0
         XLR(7)=0.973D0
         PR(8)=0.372D0
         XLR(8)=0.96D0
         PR(9)=0.434D0
         XLR(9)=0.9427D0
         PR(10)=0.4958D0
         XLR(10)=0.9216D0
         PR(11)=0.5571D0
         XLR(11)=0.8962D0
         PR(12)=0.6176D0
         XLR(12)=0.8679D0
         PR(13)=0.6769D0
         XLR(13)=0.835D0
         PR(14)=0.7346D0
         XLR(14)=0.7986D0
         PR(15)=0.7903D0
         XLR(15)=0.7597D0
         PR(16)=0.8435D0
         XLR(16)=0.7186D0
         PR(17)=0.8936D0
         XLR(17)=0.6732D0
         PR(18)=0.9394D0
         XLR(18)=0.6213D0
         PR(19)=0.9761D0
         XLR(19)=0.5722D0
         PR(20)=1.0D0
         XLR(20)=0.5322D0
         DO 2110 I=1,20
 2110    XLR(I)=XLR(I) * 0.9858D0
C
C LIST RESULTS OF PARAMETER INITIALIZATION.
C
         CALL RADDDP (LON021,SGNA(1),DEGS(1),MINS(1),SECS(1))
         IF (IPPARM .EQ. 0) WRITE (IPPLUN,2150) A21,
     .             SGNA(1),DEGS(1),MINS(1),SECS(1),
     .             X021,Y021
 2150    FORMAT (/' INITIALIZATION PARAMETERS (ROBINSON',
     .            ' PROJECTION)'/
     .            ' RADIUS OF SPHERE             =',F12.2,' METERS'/
     .            ' LONGITUDE OF C. MERIDIAN     = ',A1,2I3,F7.3/
     .            ' FALSE EASTING                =',F12.2,' METERS'/
     .            ' FALSE NORTHING               =',F12.2,' METERS')
         IPRF=21
         GO TO 9900
C
C -- S P A C E   O B L I Q U E   M E R C A T O R
C
 2200    A22 = AZ
         E = EZ
         ES22 = ESZ
         X022 = DATA(7)
         Y022 = DATA(8)
         LAND = INT(DATA(3)+TOL)
         PATH = INT(DATA(4)+TOL)
C
C CHECK IF LANDSAT NUMBER IS WITHIN RANGE 1 - 5
C
         IF (LAND .GT. 0 .AND. LAND .LE. 5) THEN
            IF (LAND .LE. 3) LIMIT = 251
            IF (LAND .GE. 4) LIMIT = 233
         ELSE
            IF (IPEMSG .EQ. 0) WRITE (IPELUN,2240) LAND, PATH
            IERR = 221
            RETURN
         END IF
C
C CHECK IF PATH NUMBER IS WITHIN RANGE 1 - 251 FOR LANDSATS 1 - 3
C OR RANGE 1 - 233 FOR LANDSATS 4 - 5
C
         IF (PATH .LE. 0 .OR. PATH .GT. LIMIT) THEN
            IF (IPEMSG .EQ. 0) WRITE (IPELUN,2240) LAND, PATH
 2240       FORMAT (/' ERROR PJ22DP'/
     .               ' LANDSAT NUMBER ',I2,' AND / OR PATH NUMBER ',I4,
     .               ' ARE OUT OF RANGE')
            IERR = 221
            RETURN
         END IF
         P1=1440.0D0
         IF (LAND.LE.3) THEN
            P2=103.2669323D0
            ALF=99.092D0*DG1
         ELSE
            P2=98.8841202D0
            ALF=98.20D0*DG1
         END IF
         SA=SIN(ALF)
         CA=COS(ALF)
         IF (ABS(CA).LT.1.D-9) CA=1.D-9
         ESC=ES22*CA*CA
         ESS=ES22*SA*SA
         W=((ONE-ESC)/(ONE-ES22))**TWO-ONE
         Q=ESS/(ONE-ES22)
         T=(ESS*(TWO-ES22))/(ONE-ES22)**TWO
         U=ESC/(ONE-ES22)
         XJ=(ONE-ES22)**3
         P22=P2/P1
C
C COMPUTE FOURIER COEFFICIENTS.  LAM IS CURRENT VALUE OF
C LAMBDA DOUBLE-PRIME.
C
         LAM=0
         CALL SERADP (FB,FA2,FA4,FC1,FC3,LAM)
         SUMA2=FA2
         SUMA4=FA4
         SUMB=FB
         SUMC1=FC1
         SUMC3=FC3
         DO 2210 I=9,81,18
         LAM=I
         CALL SERADP (FB,FA2,FA4,FC1,FC3,LAM)
         SUMA2=SUMA2+4.0D0*FA2
         SUMA4=SUMA4+4.0D0*FA4
         SUMB=SUMB+4.0D0*FB
         SUMC1=SUMC1+4.0D0*FC1
         SUMC3=SUMC3+4.0D0*FC3
 2210    CONTINUE
         DO 2220 I=18,72,18
         LAM=I
         CALL SERADP (FB,FA2,FA4,FC1,FC3,LAM)
         SUMA2=SUMA2+TWO*FA2
         SUMA4=SUMA4+TWO*FA4
         SUMB=SUMB+TWO*FB
         SUMC1=SUMC1+TWO*FC1
         SUMC3=SUMC3+TWO*FC3
 2220    CONTINUE
         LAM=90.0D0
         CALL SERADP (FB,FA2,FA4,FC1,FC3,LAM)
         SUMA2=SUMA2+FA2
         SUMA4=SUMA4+FA4
         SUMB=SUMB+FB
         SUMC1=SUMC1+FC1
         SUMC3=SUMC3+FC3
C
C THESE ARE THE VALUES OF FOURIER CONSTANTS.
C
         A2=SUMA2/30.D0
         A4=SUMA4/60.D0
         B=SUMB/30.D0
         C1=SUMC1/15.D0
         C3=SUMC3/45.D0
C
C LIST RESULTS OF PARAMETER INITIALIZATION.
C
         IF (IPPARM .EQ. 0) WRITE (IPPLUN,2250) A22,ES22,LAND,PATH,
     .                                          X022,Y022
 2250    FORMAT (/' INITIALIZATION PARAMETERS (SPACE OBL. MERCATOR',
     .            ' PROJECTION)'/
     .            ' SEMI-MAJOR AXIS OF ELLIPSOID =',F12.2,' METERS'/
     .            ' ECCENTRICITY SQUARED         =',F12.9/
     .            ' LANDSAT NO.                  = ',I3/
     .            ' PATH                         = ',I5/
     .            ' FALSE EASTING                =',F12.2,' METERS'/
     .            ' FALSE NORTHING               =',F12.2,' METERS'/)
         IPRF=22
         GO TO 9900
C
C -- M O D I F I E D   S T E R E O G R A P H I C   -   A L A S K A
C
 2300    A23 = AZ
         EC2 = 0.6768657997291094D-02
         EC  = SQRT (EC2)
         N=6
         LON023 = -152.0D0*DG1
         LAT023 = 64.0D0*DG1
         X023 = DATA(7)
         Y023 = DATA(8)
         ACOEF(1)=0.9945303D0
         ACOEF(2)=0.0052083D0
         ACOEF(3)=0.0072721D0
         ACOEF(4)=-0.0151089D0
         ACOEF(5)=0.0642675D0
         ACOEF(6)=0.3582802D0
         BCOEF(1)=0.0D0
         BCOEF(2)=-.0027404D0
         BCOEF(3)=0.0048181D0
         BCOEF(4)=-0.1932526D0
         BCOEF(5)=-0.1381226D0
         BCOEF(6)=-0.2884586D0
         ESPHI=EC*SIN(LAT023)
         CHIO=TWO*ATAN(TAN((HALFPI+LAT023)/TWO)*((ONE-ESPHI)/
     .       (ONE+ESPHI))**(EC/TWO)) - HALFPI
         SCHIO=SIN(CHIO)
         CCHIO=COS(CHIO)
C
C LIST RESULTS OF PARAMETER INITIALIZATION.
C
         CALL RADDDP (LON023,SGNA(1),DEGS(1),MINS(1),SECS(1))
         CALL RADDDP (LAT023,SGNA(2),DEGS(2),MINS(2),SECS(2))
         IF (IPPARM .EQ. 0) WRITE (IPPLUN,2350) A23,EC2,
     .            (SGNA(I),DEGS(I),MINS(I),SECS(I),I=1,2),
     .            X023,Y023
 2350    FORMAT (/' INITIALIZATION PARAMETERS (MOD. STEREOGRAPHIC',
     .            ' CONFORMAL PROJECTION, ALASKA)'/
     .            ' SEMI-MAJOR AXIS OF ELLIPSOID =',F12.2,' METERS'/
     .            ' ECCENTRICITY SQUARED         =',F12.9/
     .            ' LONGITUDE OF CENTER          = ',A1,2I3,F7.3/
     .            ' LATITUDE  OF CENTER          = ',A1,2I3,F7.3/
     .            ' FALSE EASTING                =',F12.2,' METERS'/
     .            ' FALSE NORTHING               =',F12.2,' METERS')
         IPRF=23
         GO TO 9900
C
 9900 DO 9999 I=1,15
        UTPA(I)=DATA(I)
 9999 CONTINUE
C
      RETURN
C
      END

C
C	$Id: gsfai.f,v 1.5 2008-07-27 00:21:01 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GSFAI (INDEX)
C
C  SET FILL AREA INDEX
C
C  Currently this subroutine does nothing since ctrans does not support
C  the CGM FILL BUNDLE INDEX element.
C
      INTEGER ESFAI
      PARAMETER (ESFAI=35)
C
      include 'gkscom.h'
C
      INTEGER INDEX
C
C  Remove this RETURN and uncomment the appropriate lines
C  to activate the subroutine.
C
      RETURN
C
C  Check if GKS is in the proper state.
C
C     CALL GZCKST(8,ESFAI,IER)
C     IF (IER .NE. 0) RETURN
C
C  Check that the index is positive (0A specific).
C
C     IF (INDEX.LE.0 .OR. INDEX.GT.5) THEN
C       ERS = 1
C       CALL GERHND(80,ESFAI,ERF)
C       ERS = 0
C       RETURN
C     ENDIF
C
C  Set the current index in the GKS state list.
C
C     CFAI = INDEX
C
C  Invoke the workstation interface.
C
C     FCODE = 37
C     CONT  = 0
C     CALL GZROI(0)
C     IL1   = 1
C     IL2   = 1
C     ID(1) = INDEX
C     CALL GZTOWK
C     IF (RERR.NE.0 .AND. RERR.NE.-109) THEN
C       ERS = 1
C       CALL GERHND(RERR,ESFAI,ERF)
C       ERS = 0
C     ENDIF
C
C     RETURN
      END

      PROGRAM SPREVX
C
C  This test program is an example of X axis scale reversal
C  in the NCAR Graphics User Coordinate System.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C       Dimension a line of 100 points
C
      DIMENSION X(100),Y(100)

C
C       Open GKS
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C       Turn clipping off
C
      CALL GSCLIP(0)
C
C       Generate a straight line of 100 points.
C
      DO 1 I=1,100
      X(I) = I
      Y(I) = 10.*I
  1   CONTINUE
C
C       Select the normalization transformation
C        window and viewport.  Reverse X in the window.
C
      CALL SET(.10,.95,.20,.95,100.,1.,10.,1000.,1)
C
C       Set attributes for output
C        Assign yellow to color index 2
C
      CALL GSCR(IWKID,0,0.,0.,0.)
      CALL GSCR(IWKID,1,1.,1.,1.)
      CALL GSCR(IWKID,2,1.,1.,0.)
C
C       Generate output (GKS, SPPS, or NCAR utilities)
C
C         Set polyline color index to yellow
C
      CALL GSPLCI(2)
C
C         Initialize the AUTOGRAPH entry EZXY so that
C         the frame is not advanced.
C
      CALL DISPLA(2,0,1)
C
C         Tell EZXY that the SET ordering of the window
C         is to be used (LSET 3 or 4).
C
      CALL ANOTAT(' ',' ',1,4,0,' ')
C
C         Output the polyline (X,Y) using EZXY.
C
      CALL EZXY(X,Y,100,' ')
C
C       Add a yellow title.
C
C        PLOTCHAR uses stroked characters; thus, the yellow polyline
C        color index previously set will still apply.
C
C       Return the window to fractional coordinates for the title.
C
      CALL SET(0.,1.,0.,1.,0.,1.,0.,1.,1)
      CALL PLCHHQ(0.5,.05,'Example 5.2.  X Axis Reversal with SPPS',
     1 .019,0.,0.)
C
C       Advance the frame to ensure all output is plotted
C
      CALL FRAME
C
C       Close GKS
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END

      SUBROUTINE CPTSV( N, NRHS, D, E, B, LDB, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     February 25, 1997
*
*     .. Scalar Arguments ..
      INTEGER            INFO, LDB, N, NRHS
*     ..
*     .. Array Arguments ..
      REAL               D( * )
      COMPLEX            B( LDB, * ), E( * )
*     ..
*
*  Purpose
*  =======
*
*  CPTSV computes the solution to a complex system of linear equations
*  A*X = B, where A is an N-by-N Hermitian positive definite tridiagonal
*  matrix, and X and B are N-by-NRHS matrices.
*
*  A is factored as A = L*D*L**H, and the factored form of A is then
*  used to solve the system of equations.
*
*  Arguments
*  =========
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  NRHS    (input) INTEGER
*          The number of right hand sides, i.e., the number of columns
*          of the matrix B.  NRHS >= 0.
*
*  D       (input/output) REAL array, dimension (N)
*          On entry, the n diagonal elements of the tridiagonal matrix
*          A.  On exit, the n diagonal elements of the diagonal matrix
*          D from the factorization A = L*D*L**H.
*
*  E       (input/output) COMPLEX array, dimension (N-1)
*          On entry, the (n-1) subdiagonal elements of the tridiagonal
*          matrix A.  On exit, the (n-1) subdiagonal elements of the
*          unit bidiagonal factor L from the L*D*L**H factorization of
*          A.  E can also be regarded as the superdiagonal of the unit
*          bidiagonal factor U from the U**H*D*U factorization of A.
*
*  B       (input/output) COMPLEX array, dimension (LDB,NRHS)
*          On entry, the N-by-NRHS right hand side matrix B.
*          On exit, if INFO = 0, the N-by-NRHS solution matrix X.
*
*  LDB     (input) INTEGER
*          The leading dimension of the array B.  LDB >= max(1,N).
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*          > 0:  if INFO = i, the leading minor of order i is not
*                positive definite, and the solution has not been
*                computed.  The factorization has not been completed
*                unless i = N.
*
*  =====================================================================
*
*     .. External Subroutines ..
      EXTERNAL           CPTTRF, CPTTRS, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      IF( N.LT.0 ) THEN
         INFO = -1
      ELSE IF( NRHS.LT.0 ) THEN
         INFO = -2
      ELSE IF( LDB.LT.MAX( 1, N ) ) THEN
         INFO = -6
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'CPTSV ', -INFO )
         RETURN
      END IF
*
*     Compute the L*D*L' (or U'*D*U) factorization of A.
*
      CALL CPTTRF( N, D, E, INFO )
      IF( INFO.EQ.0 ) THEN
*
*        Solve the system A*X = B, overwriting B with X.
*
         CALL CPTTRS( 'Lower', N, NRHS, D, E, B, LDB, INFO )
      END IF
      RETURN
*
*     End of CPTSV
*
      END

      PROGRAM CCPHAND
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER (K=40,N=40,LRWK=1000,LIWK=1000,INCL=19)
      REAL Z(K,N), RWRK(LRWK), RLEVEL(INCL)
      INTEGER M, IWRK(LIWK)
      
      DATA RLEVEL /-20., -10., -5., -4., -3., -2., -1., 0., 
     1     1., 2., 3., 4., 5., 10., 20., 30., 40., 50., 100. /
      
      CALL GETDAT (Z, K, M, N) 
C 
C Open GKS, open and activate a workstation.
C 
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C     
C Read in hand picked levels
C     
      CALL CPSETI('CLS - CONTOUR LEVEL SELECTION FLAG',0)
      CALL CPSETI('NCL - NUMBER OF CONTOUR LEVELS',INCL)
      
      DO 10, I=1,INCL
         CALL CPSETI('PAI - PARAMETER ARRAY INDEX',I)
         CALL CPSETR('CLV - CONTOUR LEVEL VALUE',RLEVEL(I))
         IF (MOD(RLEVEL(I),5.).EQ.0)
     1        CALL CPSETI('CLU - CONTOUR LEVEL USE FLAG',3)
 10   CONTINUE
C     
C Call conpack normally
C     
      CALL CPRECT(Z,K,M,N,RWRK,LRWK,IWRK,LIWK)
      CALL CPBACK(Z, RWRK, IWRK)
      CALL CPCLDR(Z,RWRK,IWRK)
C     
C Close frame and close GKS
C     
      CALL FRAME
C 
C Deactivate and close workstation, close GKS.
C 
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      
      STOP
      END
      
      SUBROUTINE GETDAT (Z, K, M, N)
      INTEGER I,J,K,M,N
      REAL Z(K,N)
      
      M=K
      DO 10, I=1,M
         DO 20, J=1,N
            Z(I,J)= 10.E-5*(-16.*REAL(I**2*J) +
     1           34*REAL(I*J**2) - REAL(6*I) + 93.)
 20      CONTINUE
 10   CONTINUE
      
      RETURN
      END

      SUBROUTINE DGEQR2( M, N, A, LDA, TAU, WORK, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     February 29, 1992
*
*     .. Scalar Arguments ..
      INTEGER            INFO, LDA, M, N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), TAU( * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  DGEQR2 computes a QR factorization of a real m by n matrix A:
*  A = Q * R.
*
*  Arguments
*  =========
*
*  M       (input) INTEGER
*          The number of rows of the matrix A.  M >= 0.
*
*  N       (input) INTEGER
*          The number of columns of the matrix A.  N >= 0.
*
*  A       (input/output) DOUBLE PRECISION array, dimension (LDA,N)
*          On entry, the m by n matrix A.
*          On exit, the elements on and above the diagonal of the array
*          contain the min(m,n) by n upper trapezoidal matrix R (R is
*          upper triangular if m >= n); the elements below the diagonal,
*          with the array TAU, represent the orthogonal matrix Q as a
*          product of elementary reflectors (see Further Details).
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(1,M).
*
*  TAU     (output) DOUBLE PRECISION array, dimension (min(M,N))
*          The scalar factors of the elementary reflectors (see Further
*          Details).
*
*  WORK    (workspace) DOUBLE PRECISION array, dimension (N)
*
*  INFO    (output) INTEGER
*          = 0: successful exit
*          < 0: if INFO = -i, the i-th argument had an illegal value
*
*  Further Details
*  ===============
*
*  The matrix Q is represented as a product of elementary reflectors
*
*     Q = H(1) H(2) . . . H(k), where k = min(m,n).
*
*  Each H(i) has the form
*
*     H(i) = I - tau * v * v'
*
*  where tau is a real scalar, and v is a real vector with
*  v(1:i-1) = 0 and v(i) = 1; v(i+1:m) is stored on exit in A(i+1:m,i),
*  and tau in TAU(i).
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ONE
      PARAMETER          ( ONE = 1.0D+0 )
*     ..
*     .. Local Scalars ..
      INTEGER            I, K
      DOUBLE PRECISION   AII
*     ..
*     .. External Subroutines ..
      EXTERNAL           DLARF, DLARFG, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN
*     ..
*     .. Executable Statements ..
*
*     Test the input arguments
*
      INFO = 0
      IF( M.LT.0 ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( LDA.LT.MAX( 1, M ) ) THEN
         INFO = -4
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DGEQR2', -INFO )
         RETURN
      END IF
*
      K = MIN( M, N )
*
      DO 10 I = 1, K
*
*        Generate elementary reflector H(i) to annihilate A(i+1:m,i)
*
         CALL DLARFG( M-I+1, A( I, I ), A( MIN( I+1, M ), I ), 1,
     $                TAU( I ) )
         IF( I.LT.N ) THEN
*
*           Apply H(i) to A(i:m,i+1:n) from the left
*
            AII = A( I, I )
            A( I, I ) = ONE
            CALL DLARF( 'Left', M-I+1, N-I, A( I, I ), 1, TAU( I ),
     $                  A( I, I+1 ), LDA, WORK )
            A( I, I ) = AII
         END IF
   10 CONTINUE
      RETURN
*
*     End of DGEQR2
*
      END

C
C $Id: gerhnd.f,v 1.4 1997-05-05 21:45:41 boote Exp $
C
C****************************************************************
C                                                               *
C                       Copyright (C)  1994                     *
C       University Corporation for Atmospheric Research         *
C                       All Rights Reserved                     *
C                                                               *
C****************************************************************
C
C      File:            gerhnd.f
C
C      Author:          Jeff W. Boote
C                       National Center for Atmospheric Research
C                       PO 3000, Boulder, Colorado
C
C      Date:            Fri Aug 19 16:12:47 MDT 1994
C
C****************************************************************
C
C       GKS Error Handler function - this function will be called
C       in the event of a GKS error.
C
C****************************************************************
C
C If any version of GKS is used other than libncarg_gks, then
C the user will need to install their own version of this
C function to over-ride this one, it makes calls that will
C only be resolved in libncarg_gks.
C
C We don't care about the errfil - the hlu library uses it's own
C error logging scheme.
C
c     subroutine gerhnd(errnr,fctid,errfil)
c       integer errnr,fctid,errfil
c       character*6 fname
c       character*90 mesg

c       call gzname(fctid,fname)
c       call gzgte2(errnr,mesg)
c       call nhlpfgerhnd(errnr,fctid,fname,len(fname),mesg,len(mesg))

c       return
c     end
C
C       This function should always be called with 0 so the gerhnd
C       subroutine is not actually called.  It is just necessary
C       to make sure that subroutine is loaded by the time the
C       hlu library is loaded so it doesn't end up resolving to
C       the one in libncarg_gks.
C
      subroutine nhlfloadgerhnd(idum)
        integer idum
        if(idum .NE. 0) then
                call gerhnd(1,1,1)
        endif
      end

C
C	$Id: minmax.f,v 1.5 2008-07-27 00:16:56 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MINMAX (Z,L,MM,NN,ISSIZM,AASH,JOFFDT)
C
C THIS ROUTINE FINDS RELATIVE MINIMUMS AND MAXIMUMS.  A RELATIVE MINIMUM
C (OR MAXIMUM) IS DEFINED TO BE THE LOWEST (OR HIGHEST) POINT WITHIN
C A CERTAIN NEIGHBORHOOD OF THE POINT.  THE NEIGHBORHOOD USED HERE
C IS + OR - MN IN THE X DIRECTION AND + OR - NM IN THE Y DIRECTION.
C
C ORIGINATOR       DAVID KENNISON
C
      SAVE
      CHARACTER*7     IA
      DIMENSION       Z(L,NN)
C
C
C
      COMMON /CONRE1/ IOFFP      ,SPVAL
      COMMON /CONRE5/ SCLY
C
C     FX(X,Y) = X
C     FY(X,Y) = Y
C
      M = MM
      N = NN
C
C SET UP SCALING FOR LABELS
C
      SIZEM = (ISSIZM + 1)*256*SCLY
      ISIZEM = ISSIZM
C
      ASH = ABS(AASH)
      IOFFDT = JOFFDT
C
      IF (AASH .LT. 0.0) GO TO 128
C
      MN = MIN(15,MAX(2,INT(REAL(M)/8.)))
      NM = MIN(15,MAX(2,INT(REAL(N)/8.)))
      NM1 = N-1
      MM1 = M-1
C
C LINE LOOP FOLLOWS - THE COMPLETE TWO-DIMENSIONAL TEST FOR A MINIMUM OR
C MAXIMUM OF THE FIELD IS ONLY PERFORMED FOR POINTS WHICH ARE MINIMA OR
C MAXIMA ALONG SOME LINE - FINDING THESE CANDIDATES IS MADE EFFICIENT BY
C USING A COUNT OF CONSECUTIVE INCREASES OR DECREASES OF THE FUNCTION
C ALONG THE LINE
C
      DO 127 JP=2,NM1
C
         IM = MN-1
         IP = -1
         GO TO 126
C
C CONTROL RETURNS TO STATEMENT 10 AS LONG AS THE FUNCTION IS INCREASING
C ALONG THE LINE - WE SEEK A POSSIBLE MAXIMUM
C
  101    IP = IP+1
         AA = AN
         IF (IP .EQ. MM1) GO TO 104
         AN = Z(IP+1,JP)
         IF (IOFFP.NE.0 .AND. AN.EQ.SPVAL) GO TO 125
         IF (AA-AN) 102,103,104
  102    IM = IM+1
         GO TO 101
  103    IM = 0
         GO TO 101
C
C FUNCTION DECREASED - TEST FOR MAXIMUM ON LINE
C
  104    IF (IM .GE. MN) GO TO 106
         IS = MAX(1,IP-MN)
         IT = IP-IM-1
         IF (IS .GT. IT) GO TO 106
         DO 105 II=IS,IT
            IF (AA .LE. Z(II,JP)) GO TO 112
  105    CONTINUE
  106    IS = IP+2
         IT = MIN(M,IP+MN)
         IF (IS .GT. IT) GO TO 109
         DO 108 II=IS,IT
            IF (IOFFP.EQ.0 .OR. Z(II,JP).NE.SPVAL) GO TO 107
            IP = II-1
            GO TO 125
  107       IF (AA .LE. Z(II,JP)) GO TO 112
  108    CONTINUE
C
C WE HAVE MAXIMUM ON LINE - DO TWO-DIMENSIONAL TEST FOR MAXIMUM OF FIELD
C
  109    JS = MAX(1,JP-NM)
         JT = MIN(N,JP+NM)
         IS = MAX(1,IP-MN)
         IT = MIN(M,IP+MN)
         DO 111 JK=JS,JT
            IF (JK .EQ. JP) GO TO 111
            DO 110 IK=IS,IT
               IF (Z(IK,JK).GE.AA .OR.
     1             (IOFFP.NE.0 .AND. Z(IK,JK).EQ.SPVAL)) GO TO 112
  110       CONTINUE
  111    CONTINUE
C
         X = REAL(IP)
         Y = REAL(JP)
         CALL WTSTR ( FX(X,Y),FY(X,Y),'H',ISIZEM,0,0 )
         CALL FL2INT ( FX(X,Y),FY(X,Y),IFX,IFY )
C
C SCALE TO USER SET RESOLUTION
C
         IFY = IFY*SCLY
         CALL ENCD (AA,ASH,IA,NC,IOFFDT)
         MY = IFY - SIZEM
         TMY = CPUY ( MY )
         CALL WTSTR ( FX(X,Y),TMY,IA(1:NC),ISIZEM,0,0 )
  112    IM = 1
         IF (IP-MM1) 113,127,127
C
C CONTROL RETURNS TO STATEMENT 20 AS LONG AS THE FUNCTION IS DECREASING
C ALONG THE LINE - WE SEEK A POSSIBLE MINIMUM
C
  113    IP = IP+1
         AA = AN
         IF (IP .EQ. MM1) GO TO 116
         AN = Z(IP+1,JP)
         IF (IOFFP.NE.0 .AND. AN.EQ.SPVAL) GO TO 125
         IF (AA-AN) 116,115,114
  114    IM = IM+1
         GO TO 113
  115    IM = 0
         GO TO 113
C
C FUNCTION INCREASED - TEST FOR MINIMUM ON LINE
C
  116    IF (IM .GE. MN) GO TO 118
         IS = MAX(1,IP-MN)
         IT = IP-IM-1
         IF (IS .GT. IT) GO TO 118
         DO 117 II=IS,IT
            IF (AA .GE. Z(II,JP)) GO TO 124
  117    CONTINUE
  118    IS = IP+2
         IT = MIN(M,IP+MN)
         IF (IS .GT. IT) GO TO 121
         DO 120 II=IS,IT
            IF (IOFFP.EQ.0 .OR. Z(II,JP).NE.SPVAL) GO TO 119
            IP = II-1
            GO TO 125
  119       IF (AA .GE. Z(II,JP)) GO TO 124
  120    CONTINUE
C
C WE HAVE MINIMUM ON LINE - DO TWO-DIMENSIONAL TEST FOR MINIMUM OF FIELD
C
  121    JS = MAX(1,JP-NM)
         JT = MIN(N,JP+NM)
         IS = MAX(1,IP-MN)
         IT = MIN(M,IP+MN)
         DO 123 JK=JS,JT
            IF (JK .EQ. JP) GO TO 123
            DO 122 IK=IS,IT
               IF (Z(IK,JK).LE.AA .OR.
     1             (IOFFP.NE.0 .AND. Z(IK,JK).EQ.SPVAL)) GO TO 124
  122       CONTINUE
  123    CONTINUE
C
         X = REAL(IP)
         Y = REAL(JP)
         CALL WTSTR ( FX(X,Y),FY(X,Y),'L',ISIZEM,0,0 )
         CALL FL2INT( FX(X,Y),FY(X,Y),IFX,IFY )
         IFY = SCLY*IFY
         CALL ENCD (AA,ASH,IA,NC,IOFFDT)
         MY = IFY - SIZEM
         TMY = CPUY ( MY )
         CALL WTSTR ( FX(X,Y),TMY,IA(1:NC),ISIZEM,0,0 )
  124    IM = 1
         IF (IP-MM1) 101,127,127
C
C SKIP SPECIAL VALUES ON LINE
C
  125    IM = 0
  126    IP = IP+1
         IF (IP .GE. MM1) GO TO 127
         IF (IOFFP.NE.0 .AND. Z(IP+1,JP).EQ.SPVAL) GO TO 125
         IM = IM+1
         IF (IM .LE. MN) GO TO 126
         IM = 1
         AN = Z(IP+1,JP)
         IF (Z(IP,JP)-AN) 101,103,113
C
  127 CONTINUE
C
      RETURN
C
C ****************************** ENTRY PNTVAL **************************
C     ENTRY PNTVAL (Z,L,MM,NN,ISSIZM,AASH,JOFFDT)
C
  128 CONTINUE
      II = (M-1+24)/24
      JJ = (N-1+48)/48
      NIQ = 1
      NJQ = 1
      DO 130 J=NJQ,N,JJ
         Y = J
         DO 129 I=NIQ,M,II
            X = I
            ZZ = Z(I,J)
            IF (IOFFP.NE.0 .AND. ZZ.EQ.SPVAL) GO TO 129
            CALL ENCD (ZZ,ASH,IA,NC,IOFFDT)
            CALL WTSTR (FX(X,Y),FY(X,Y),IA(1:NC),ISIZEM,0,0 )
  129    CONTINUE
  130 CONTINUE
      RETURN
      END

C
C	$Id: conlin.f,v 1.4 2008-07-27 00:16:55 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CONLIN(XD,YD,ZD,NT,IWK,WK)
C
C  THIS ROUTINE GENERATES THE COORDINATES USED IN A LINEAR INTERPOLATION
C  OF THE TRIANGLES CREATED FROM IRREGULARLY DISTRIBUTED DATA.
C
C  INPUT
C       XD-X INPUT COORDINATES]
C       YD-Y INPUT COORDINATES
C       ZD-Z VALUE AT INPUT X,Y
C       NT-NUMBER OF TRIANGLES GENERATED
C       IWK-LIST OF TRIANGLE POINTS, RELATIVE TO XD,YD
C               GROUPED 3 PER TRIANGLE I.E. TRIANGLE 1 IWK(1,2,3),
C               TRIANGLE 2 IWK(4,5,6)  ETC.
C
C  OUTPUT
C       WK ARRAY OF COEFICENTS FOR LINEATION FORMUALS
C               GROUPED 3 PER TRIANGLE
C               POINTS ARE (TRI-1)*3 + 1,2,3
C
      DIMENSION IWK(1),WK(1),XD(1),YD(1),ZD(1)
C
        SAVE
C
C   LOOP FOR ALL TRIANGLES
C
      DO 1000 ITRI = 1,NT
C
C       GET THE POINTS OF THE TRIANGLE
C
        IPOINT = (ITRI-1)*3
        IP1 = IWK(IPOINT+1)
        IP2 = IWK(IPOINT+2)
        IP3 = IWK(IPOINT+3)
C
C       GET THE VALUES AT THE TRIANBGLE POINTS
C
        X1 = XD(IP1)
        Y1 = YD(IP1)
        Z1 = ZD(IP1)
        X2 = XD(IP2)
        Y2 = YD(IP2)
        Z2 = ZD(IP2)
        X3 = XD(IP3)
        Y3 = YD(IP3)
        Z3 = ZD(IP3)
C
C  COMPUTE THE INTERPLOATING COEFICIENTS
C
        WK(IPOINT+1) = (Y2-Y1)*(Z3-Z1)-(Y3-Y1)*(Z2-Z1)
        WK(IPOINT+2) = (X3-X1)*(Z2-Z1)-(X2-X1)*(Z3-Z1)
        WK(IPOINT+3) = (X3-X1)*(Y2-Y1)-(X2-X1)*(Y3-Y1)
C
 1000 CONTINUE
C
      RETURN
      END

C
C	$Id: wmblda.f,v 1.18 2010-01-05 03:52:14 fred Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE WMBLDA
C
C Calling this do-nothing subroutine forces "ld" to load the following
C block data routine (but only if they are in the same ".f" file).
C
        RETURN
C
      END
CNOSPLIT
      BLOCKDATA WMBLDAX
C
C  Initialize data.
C
      include 'wmcomn.h'
C
C  Default line widths for drawing wind barbs.
C
      DATA BRBLWD/1.0/
C
C  Default width for symbols along the front line (in NDC).
C
      DATA SYMWID/0.0325/
C
C  Spacings for positioning symbols on the curves. 
C
      DATA  BEGDST,ENDDST,BETDST/0.015, 0.015, 0.045/
C
C  Maximum number of symbols allowed on a front line.
C
      DATA MAXSYM/200/
C
C  User override for number of symbols on a front line.
C
      DATA NUMSYO/-1/
C
C  Front type (1=cold, 2=warm, 3=stationary, 4=occluded, 5=instability,
C              6=intertropical, 7=convergence).
C
      DATA IFRONT/2/
C
C  Array of symbol types initialized to all warm front symbols.
C
      DATA ISTYPE/ISDIM*2/
C
C  Current array index.
C
      DATA IARNDX/1/
C
C  Length of current curve.
C
      DATA CRVLEN/0.0/
C
C  Slope data.
C
      DATA ISLFLG,SLOPE1,SLOPE2,SLOPEL,SLOPER/3, 0.0, 0.0, 0.0, 0.0/
C
C  Flag for aloft or surface (0=surface; non-zero=aloft).
C
      DATA IALOFT/0/
C
C  Line widths for fronts when using the GKS linewidth scale factor;
C  line widths for squalls, tropical fronts, and convergence.
C
      DATA RLINWD,DLINWD/8.0,2.0/
C
C  Flags method of implementing linewidths (0=GKS linewidth; 1=internal)
C
      DATA IWDTYP/0/
C
C  Line width as fraction of screen height, used when IWDTYP=1.
C
      DATA SLINWD/0.00275/
C
C  Color index for all objects.
C
      DATA ICOLOR/1/
C
C  Number of points to use for Bezier curve for warm front symbols.
C
      DATA NPTSBZ/51/
C
C  Height of the boxed weather type labels like "BREEZY", "NICE", etc.
C  plotted with WMLABW, and height of the weather type legend boxes.
C
      DATA WSIZEW/0.014/
C
C  Height of the labels for city names and daily high/low temps. 
C  plotted with WMLABC.
C
      DATA WSIZEC/0.0105/
C
C  Height of the symbols comprising the regional weather areas like
C  flurries, snow, etc.
C
      DATA WSIZER/0.008/
C
C  Height of the regional temperature labels plotted with WMLABT.
C
      DATA WSIZET/0.0165/
C
C  Height of symbols plotted with WMLABS.
C
      DATA WSIZES/0.020/
C
C  Size of arrows as a fraction of the maximum screen height.
C
      DATA ARWSIZ/0.035/
C
C  Scale factor for the tail of an arrow, independent of its size.
C
      DATA ARWLEN/1.0/
C
C  Direction of arrows, in degrees.  
C
      DATA ARWDIR/0.0/
C
C  Diameter of dots used to mark cities.
C
      DATA CDOTSZ/0.006/
C
C  Size of background margins for cities and daily temperature highs
C  and lows.
C
      DATA CTYMRG/0.002/
C
C  Size of background margins for regional temperature labels.
C
      DATA TMPMRG/0.001/
C
C  Background color index for city names.
C
      DATA IBGCTY/0/
C
C  Color index for regional weather labels and regioanl temperature labels.
C
      DATA IFGTRG/1/
C
C  Flag for NCL to know if it is being used in conjunction with
C  mapping tools in certain applications.
C
      DATA IEZFLG/-1/
C
C  Colors for regional temperature label shadows and outlines.
C
      DATA IRLOUC,IRLBKC,IRLLSC/-1,-1,-1/
C
C  Colors of dot drawn for cities and its background.
      DATA IDOTBG,IDOTCO/0,1/
C
C  Length of windbarb shaft as a fraction of maximim screen height;
C  length of full windbarb tic as a percentage of the shaft length;
C  distance between tics along the barb; 
C  radius of larger circle drawn for calm (as percentage of shaft length); 
C  angle the barbs make with the shaft (in degrees);
C  diameter of the sky-cover symbol at base of wind barb in station model
C    (as a percentage of the shaft length).
C  flag to indicate whether the base of the windbarb should be centered
C    at the specified coordinate, or whether room should be made for
C    the sky cover circle that is drawn in the station model;
C  size of text label in the station model as a percentage of the
C    shaft length of the wind barb.
C
      DATA WBSHFT,WBFTIC,WBDIST,WBCLMR,WBBANG,WBBASE,IWBBAS,WBLSIZ
     +    / 0.035,  0.33,  0.10,  0.25,   62.,  0.30,     0,  0.17 /       
C
C  Wind barb direction (=0 away from wind; =1 toward the wind).
C
      DATA IWBDIR/0/
C
C  Extent of barb ticks.
C
      DATA WBXL,WBXR,WBYB,WBYT/0.,0.,0.,0./
C
C  Scale limits for vectors.  A vector of length VCUREF will
C  be scaled to NDC length VCNREF.
C
      DATA VCUREF,VCNREF/10.,0.02/
C
C  NDC length of vector arrow head line.
C
      DATA VCHSIZ/0.02/
C
C  Linewidth scale factor for vectors.
C
      DATA VCLWID/1.0/
C
C  Vector color.
C
      DATA VCCOLR/1/
C
C  Vector direction.
C
      DATA VCWDIR/0./
C
C  Vector size.
C
      DATA VCSIZE/10./
C
C  Angle between vector head and tail.
C
      DATA VHDANG/25./
C
C  Foreground color for vector label box.
C
      DATA VLBLFC/1/
C
C  Background color for vector label box.
C
      DATA VLBLBC/0/
C
C  Color indices for sun, cloud, and lightening bolt symbols.
C
      DATA ISUNC1, ISUNC2, ISUNC3, ISUNC4, ICLDC1, ICLDC2, ICLDC3, 
     +     ILTNC1, ILTNC2, ILTNC3
     +   /      2,      3,      1,      1,      2,      1,      1, 
     +          2,      1,      1                                 /
C
C  Color indices for warm front and cold front symbols.
C
      DATA IWARMC,ICOLDC/1,1/
C
C  Color indices for high and low symbols.
C
      DATA IHIGC1,IHIGC2,IHIGC3,IHIGC4/1,0,1,1/
      DATA ILOWC1,ILOWC2,ILOWC3,ILOWC4/0,1,0,1/
C
C  Color indices for regional weather label boxes.
C
      DATA IRGLC1,IRGLC2,IRGLC3,IRGLC4,IRGLC5/1,0,1,1,-1/
C
C  Color indices for tropical front alternate segments in dashed line.
C
      DATA ITRO1C,ITRO2C/1,1/
C
C  Arrow color, arrow shadow color, arrow outline color.
C
      DATA IAROWC,IARSHC,IAROUC/1,-1,-1/
C
C  Tension factor for spline routines, a negative value indicates that
C  the value has not been specified and a defualt value will be supplied
C  at run time.
C
      DATA TNSION/-1./
C
C  Smoothing parameter for the smoothing spline routines, a negative 
C  value indicates that the value has not been specified and a defualt 
C  value will be supplied at run time.
C
      DATA RSMOTH/-1./
C
C  Observational weights for data for smoothing spline routines.  A negative
C  value indicates that the value has not been specified and a defualt 
C  value will be supplied at run time.
C
      DATA OBSERR/-1./
C
C  Flags whether interpolation (=0) or smoothing (=1) is done.
C
      DATA ISMOTH/0/
C
C  Flags whether to use imperial units (as per the NOAA chart),
C  or metric units (as per SYNOP Data Format (FM-12) as in
C
C    http://weather.unisys.com/wxp/Appendices/Formats/SYNOP.html
C
      DATA IUNITS/0/
C
C  If IVVCOD equals 1, then plot the surface visibility as per
C  the raw two-character SYNOP codes, otherwise convert and plot
C  as mph or km as per the setting of IUNITS.
C
      DATA IVVCOD/0/
C
      END

      SUBROUTINE DEOFTS7(X,NROW,NCOL,NOBS,MSTA,XMSG,NEVAL,EVEC,JOPT,
     +                   IFLAG,XX,WRK,EVECTS,EVTSAV,IER)
      DOUBLE PRECISION XBAR
      DOUBLE PRECISION XVAR
      DOUBLE PRECISION XSTD
      DOUBLE PRECISION CON

c f77

c takes output of prneof.f and creates a time series of the
c .   eof amplitudes

c nomenclature :
c .   x         - matrix containing the data.  it contains n
c .               observations for each of m stations or grid pts.
c .   nrow,ncol - exact row (observation) and column (station)
c .               dimensions of x in the calling routine.
c .   nobs      - actual number of observations (nobs <= nrow)
c .   msta      - actual number of stations     (msta <= ncol)
c .   xmsg      - missing code (if no obs are missing set to some
c .               number which will not be encountered)
c .   neval     - no. of eigenvalues and eigen vectors computed by
c .               prneof.
c .   evec      - array created by prneof
c .               this must be dimensioned at least (ncol,neval) in the
c .               calling routine.
c .   jopt      - =0 means covariance  was used to generate evec
c .               =1 means correlation was used to generate evec
c .   xx        - work vector of the same dimensions as x
c .   wrk       - work vector of length nobs
c .   evects    - time series of eof amplitudes for each eigenvalue
c .   ier       - error code

C INPUT

C dimensions of x
      INTEGER NROW,NCOL,NOBS,MSTA

C monthly data from station/grid pt
C work array
C missing code (if any)
      DOUBLE PRECISION X(NROW,NCOL),EVEC(NCOL,NEVAL),XX(NROW,NCOL),
     +                 WRK(NOBS),XMSG
      INTEGER NEVAL,IFLAG

C OUTPUT

C monthly anomalies from long term monthly mean
      DOUBLE PRECISION EVECTS(NROW,NEVAL)
      DOUBLE PRECISION EVTSAV(NEVAL)
C error code
      INTEGER IER


      IER = 0
      IF (NROW.LE.0 .OR. NCOL.LE.0) IER = IER + 1
      IF (NOBS.LE.0 .OR. MSTA.LE.0) IER = IER + 10
      IF (IER.NE.0) THEN
          WRITE (*,FMT='(/,'' sub eofts7: ier='',5i5)') IER,NROW,NCOL,
     +      NOBS,MSTA
c          stop
          RETURN
      END IF

c set to msg as default

      DO M = 1,NCOL
          DO N = 1,NROW
              XX(N,M) = X(N,M)
          END DO
      END DO

c the following was added in Sept 2003 so that the
c 'normalization' that follows the "if" would
c not be done.

c c c if (iflag.eq.1 .and. jopt.eq.0) go to 10
      IF (JOPT.EQ.1) THEN

c calculate mean/stddev at each station/grid-pt


          DO M = 1,MSTA
              DO N = 1,NOBS
                  WRK(N) = X(N,M)
              END DO

              CALL DSTAT2(WRK,NOBS,XMSG,XBAR,XVAR,XSTD,KNTX,IER)
              CON = 1.0D0
              IF (JOPT.EQ.1 .AND. XSTD.GT.0.D0) THEN
                  CON = 1.D0/XSTD
              END IF

c         write (*,"(' eofts7: m,nobs,kntx,xbar,xstd=',3i5,2f8.2)")
c     *                        m,nobs,kntx,xbar,xstd

              DO N = 1,NOBS
                  IF (X(N,M).NE.XMSG .AND. XBAR.NE.XMSG) THEN
                      XX(N,M) = (X(N,M)-XBAR)*CON
                  ELSE
                      XX(N,M) = XMSG
                  END IF
              END DO

C end msta
          END DO

c c c write (*,"(//,'ANOMALIES',/)")
c c c do n=1,nobs
c c c     write (*,"(i5 , 10(1x,f9.3) )") n, (xx(n,m),m=1,msta)
c c c enddo

      END IF

c calculate the amplitude time series

   10 DO K = 1,NEVAL
          DO N = 1,NOBS
              KNTX = 0
              EVECTS(N,K) = 0.0D0
              DO M = 1,MSTA
                  IF (XX(N,M).NE.XMSG .AND. EVEC(M,K).NE.XMSG) THEN
                      KNTX = KNTX + 1
                      EVECTS(N,K) = EVECTS(N,K) + EVEC(M,K)*XX(N,M)
                  END IF
              END DO
              IF (KNTX.EQ.0) EVECTS(N,K) = XMSG
          END DO
          CALL DSTAT2(EVECTS(1,K),NOBS,XMSG,EVTSAV(K),XVAR,XSTD,KNTX,
     +                IER)
          IF (IFLAG.EQ.0 .AND. EVTSAV(K).NE.XMSG) THEN
              DO N = 1,NOBS
                  IF (EVECTS(N,K).NE.XMSG) THEN
                      EVECTS(N,K) = EVECTS(N,K) - EVTSAV(K)
                  END IF
              END DO
          END IF
      END DO

      RETURN
      END

      SUBROUTINE DEOFTSCA(XX,NROW,NCOL,NOBS,MSTA,XMSG
     +                   ,NEVAL,EVEC,JOPT,IFLAG,EVECTS,PCRIT,IER,X,WRK)
      IMPLICIT NONE

c takes output of prneof_ca.f and creates a time series of the
c .   eof amplitudes. It is essential that xx and pcrit not change
c .   from the call to prneof_ca.f

c use f90 to dynamically allocate/deallocate memory (work space)
c     also some array syntax

c nomenclature :
c .   xx        - matrix containing the data.  it contains n observations
c .               for each of m stations or grid pts.
c .   nrow,ncol - exact row (observation) and column (station)
c .               dimensions of x in the calling routine.
c .   nobs      - actual number of observations (nobs <= nrow)
c .   msta      - actual number of stations     (msta <= ncol)
c .   xmsg      - missing code (if no obs are missing set to some
c .               number which will not be encountered)
c .   neval     - no. of eigenvalues and eigen vectors computed by
c .               prneof.
c .   evec      - array created by prneof_ca
c .               this must be dimensioned at least (ncol,neval) in the
c .               calling routine.
c .   evects    - time series of eof amplitudes for each eigenvalue
c .   pcrit     - minimum % of non-missing values required for the
c .               station/grid-pt be used in the covariance/correlation
c .               matrix, must be between 0 and 100 inclusive
c .   ier       - error code
c INPUT

c dimensions of xx
      INTEGER NROW,NCOL,NOBS,MSTA
      INTEGER NEVAL, JOPT, IFLAG

c monthly data from station/grid pt
c missing code (if any)
      DOUBLE PRECISION XX(NROW,NCOL),EVEC(NCOL,NEVAL),XMSG
c OUTPUT

c monthly anomalies from long term monthly mean
      DOUBLE PRECISION EVECTS(NROW,NEVAL)
c error code
      INTEGER IER
c temporaray arrays 
      DOUBLE PRECISION X(NROW,NCOL),WRK(NOBS)

      DOUBLE PRECISION PCRIT
      DOUBLE PRECISION PCRITX
      DOUBLE PRECISION XBAR
      DOUBLE PRECISION XVAR
      DOUBLE PRECISION XSTD
      DOUBLE PRECISION CON
      INTEGER NSTA, NC, NR, KNTX, M, N, K

      IER = 0

      PCRITX = PCRIT*0.01D0

c counts the total number of
      NSTA = 0
      DO NC = 1,MSTA
c counter for this location
          KNTX = 0
          DO NR = 1,NOBS
              IF (XX(NR,NC).NE.XMSG) THEN
                  KNTX = KNTX + 1
              END IF
          END DO
          IF (DBLE(KNTX)/DBLE(NOBS).GE.PCRITX) THEN
              NSTA = NSTA + 1
              DO N = 1,NOBS
                  X(N,NSTA) = XX(N,NC)
              END DO
          END IF
      END DO

c this if added Sept 2003 to allow computation without
c removing the mean.

      IF (JOPT.EQ.0 .AND. IFLAG.EQ.1) GO TO 10

c calculate each station/grid-pt  long-term mean and standard deviation
c use the "nsta" limit; this pertains to array x

      DO M = 1,NSTA
          DO N = 1,NOBS
              WRK(N) = X(N,M)
          END DO

          CALL DSTAT2(WRK,NOBS,XMSG,XBAR,XVAR,XSTD,KNTX,IER)
          CON = 1.0D0
          IF (JOPT.EQ.1 .AND. XSTD.GT.0.D0) THEN
              CON = 1.D0/XSTD
          END IF

          DO N = 1,NOBS
              IF (X(N,M).NE.XMSG .AND. XBAR.NE.XMSG) THEN
                  X(N,M) = (X(N,M)-XBAR)*CON
              ELSE
                  X(N,M) = XMSG
              END IF
          END DO
c end nsta
c
      END DO
   10 CONTINUE

c calculate the amplitude time series

      DO K = 1,NEVAL
          DO N = 1,NOBS
              KNTX = 0
              EVECTS(N,K) = 0.0D0
              DO M = 1,NSTA
                  IF (X(N,M).NE.XMSG) THEN
                      KNTX = KNTX + 1
                      EVECTS(N,K) = EVECTS(N,K) + EVEC(M,K)*X(N,M)
                  END IF
              END DO
              if (KNTX.EQ.0) EVECTS(N,K) = XMSG
          END DO
      END DO

      RETURN
      END

C
C $Id: mdqtrn.f,v 1.8 2008-09-18 00:42:18 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MDQTRN (RLAT,RLON,U,V)
C
        DOUBLE PRECISION RLAT,RLON,U,V
C
C Given the latitude, RLAT, and the longitude, RLON, of a point on the
C earth, this routine returns the U and V coordinates of the projection
C of that point on the map.
C
C Declare a special common block, containing only those variables that
C MDQINI needs to set to make MDQTRA, MDQTRI, and MDQTRN carry out the
C transformation in effect at the time MDQINI was called.
C
        COMMON /MAQCMN/  ALFA,COSO,COSR,CSLS,CSLT,DCSA,DCSB,DSNA,DSNB,
     +                   DTOR,DTRH,OOPI,PLNO,  PI,PIOT,ROTA,RTDD,RTOD,
     +                   SALT,SINO,SINR,SRSS,SSMO,TOPI,UCNM,UMNM,UMXM,
     +                   UOFF,URNM,VCNM,VMNM,VMXM,VOFF,VRNM,UTPA,IPRF,
     +                   IPRJ,IROD,ELPM
        DOUBLE PRECISION ALFA,COSO,COSR,CSLS,CSLT,DCSA,DCSB,DSNA,DSNB,
     +                   DTOR,DTRH,OOPI,PLNO,  PI,PIOT,ROTA,RTDD,RTOD,
     +                   SALT,SINO,SINR,SRSS,SSMO,TOPI,UCNM,UMNM,UMXM,
     +                   UOFF,URNM,VCNM,VMNM,VMXM,VOFF,VRNM,UTPA(15)
C
        INTEGER IPRF,IPRJ,IROD
C
        LOGICAL ELPM
C
        SAVE   /MAQCMN/
C
C Declare local variables.
C
        DOUBLE PRECISION CHI,COSA,COSB,COSL,COSP,RLAP,RLOP,SINA,SINB,
     +                   SINL,SINP,TCOS,TEMP,TMP1,TMP2,UTM1,UTM2,UTM3,
     +                   VTM1,VTM2,VTM3,XVAL,YVAL,ZVAL
C
        DOUBLE PRECISION P,Q,R
C
        REAL             USNG,VSNG
C
C Declare function types.
C
        DOUBLE PRECISION MDGDDP,RBGDFE,RBGLEN
C
C Check for an uncleared prior error.
C
        IF (ICFELL('MDQTRN - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C Set up U and V for the fast paths.  U is a longitude, in degrees,
C between -180. and +180., inclusive, and V is a latitude, in degrees.
C
        TEMP=RLON-PLNO
        U=TEMP+(SIGN(180.D0,180.D0-TEMP)-SIGN(180.D0,TEMP+180.D0))
        V=MAX(-90.D0,MIN(90.D0,RLAT))
C
C If a fast-path projection is in use and the rotation angle is 180,
C adjust U and V.
C
        IF (IPRJ.GE.16.AND.IPRJ.LE.24.AND.
     +      ABS(ROTA).GT.179.999999D0) THEN
          U=-U
          V=-V
        END IF
C
C Jump to the proper piece of code, depending on the projection type.
C
C Projection:   US  LC  ST  OR  LE  GN  AE
C                   CE  ME  MT  RO  EA  AI  HA  MO  WT  (arbitrary)
C                   CE  ME  MT  RO  EA  AI  HA  MO  WT  (fast-path)
C                       RM
C
        GO TO (101,102,103,103,103,103,103,
     +             103,103,103,103,103,103,103,103,103,
     +             118,119,120,121,122,123,124,125,126,
     +                 127                            ) , IPRJ+1
C
C USGS projections.
C
  101   IF (IPRF.EQ.0) GO TO 901
C
        IF (IROD.EQ.0) THEN
          CALL MDUTFS (REAL(RLAT),REAL(RLON),USNG,VSNG)
          IF (USNG.NE.1.E12) THEN
            U=DBLE(USNG)
            V=DBLE(VSNG)
          ELSE
            U=1.D12
            V=1.D12
          END IF
        ELSE
          CALL MDUTFD (RLAT,RLON,U,V)
        END IF
C
        IF (IPRF.EQ. 3.OR.IPRF.EQ. 4.OR.IPRF.EQ. 5.OR.IPRF.EQ. 7.OR.
     +      IPRF.EQ. 8.OR.IPRF.EQ.16.OR.IPRF.EQ.17.OR.IPRF.EQ.18.OR.
     +      IPRF.EQ.19.OR.IPRF.EQ.21) THEN
          TMP1=RLON-UTPA(5)
          P=TMP1+(SIGN(180.D0,180.D0-TMP1)-SIGN(180.D0,TMP1+180.D0))
          IF ((IPRF.EQ.3.OR.IPRF.EQ.8).AND.ABS(RLAT).GT.89.999999D0)
     +                                                         GO TO 200
        ELSE IF (IPRF.EQ.9) THEN
          P=V
        ELSE IF (IPRF.EQ.11.OR.IPRF.EQ.12) THEN
          IF (MDGDDP(RLAT,RLON,UTPA(6),UTPA(5)).GT.179.99D0) GO TO 200
        ELSE IF (IPRF.EQ.20) THEN
          P=U*SIN(DTOR*UTPA(4))+V*COS(DTOR*UTPA(4))
        ELSE IF (IPRF.EQ.22) THEN
          P=U*SIN(DTOR*UTPA(4))+V*COS(DTOR*UTPA(4))
        END IF
C
        GO TO 199
C
C Lambert conformal conic.
C
  102   P=U
        CHI=90.D0-SINO*V
        IF (CHI.GT.179.999999D0) GO TO 200
        R=TAN(DTRH*CHI)**COSO
        U=U*COSO*DTOR
        V=-R*SINO*COS(U)
        U=R*SIN(U)
        GO TO 198
C
C Not Lambert conformal conic.  Calculate constants common to most of
C the other projections.  
C
  103   SINL=SIN(U*DTOR)
        COSL=COS(U*DTOR)
        SINP=SIN(V*DTOR)
        COSP=COS(V*DTOR)
C
        IF (IPRJ.LT.7) THEN
C
C The following code is for the azimuthal projections.  It computes the
C sines and cosines of two angles: A, which is the angular distance from
C the point (PLAT,PLON) to the point (RLAT,RLON-PLON); and B, which is
C the angle, in the projection plane, of the line from the origin of the
C U/V plane to the projection of the point (RLAT,RLON-PLON), measured
C clockwise from the positive V axis, prior to the rotation implied by
C the value of ROTA.  These equations may be derived by expressing the
C coordinates of (RLAT,RLON-PLON) in an XYZ system and then applying a
C transformation carrying (PLAT,PLON) into the North Pole.  Computing
C the sines and cosines of A and B then becomes relatively easy.  (The
C only kind of difficult step is justifying the division by the sine of
C A in the expressions for the sine and cosine of B.)
C 
          TCOS=COSP*COSL
          COSA=MAX(-1.D0,MIN(+1.D0,SINP*SINO+TCOS*COSO))
          SINA=SQRT(1.D0-COSA*COSA)
          IF (SINA.LT..000001D0) THEN
            SINA=0.D0
            IF (IPRJ.EQ.3.AND.ABS(SALT).GT.1.D0) THEN
              SINB=0.D0
              COSB=1.D0
              GO TO 105
            END IF
            IF (COSA.LT.0.D0) GO TO 200
            U=0.D0
            V=0.D0
            GO TO 197
          END IF
          SINB=COSP*SINL/SINA
          COSB=(SINP*COSO-TCOS*SINO)/SINA
C
        ELSE
C
C The following code is for the cylindrical and mixed projections.  It
C expresses the coordinates of (RLAT,RLON-PLON) in an XYZ system,
C performs two rotations (one that rotates (PLAT,PLON) down to the
C equator and another that rotates clockwise about the X axis by the
C angle ROTA), and then recomputes the transformed latitude and
C longitude (RLAP and RLOP) for use in the projection equations below.
C
          XVAL=COSL*COSP*COSO+SINP*SINO
          YVAL=SINL*COSP*COSR+(SINP*COSO-COSL*COSP*SINO)*SINR
          ZVAL=(SINP*COSO-COSL*COSP*SINO)*COSR-SINL*COSP*SINR
          RLAP=ASIN(MAX(-1.D0,MIN(+1.D0,ZVAL)))
          RLOP=ATAN2(YVAL,XVAL)
C
        END IF
C
C Jump to code appropriate for the chosen projection.
C
C Projection:   ST  OR  LE  GN  AE
C               CE  ME  MT  RO  EA  AI  HA  MO  WT  (arbitrary)
C
        GO TO (104,105,106,107,108,
     +         109,110,111,112,113,114,115,116,117) , IPRJ-1
C
C Stereographic.
C
  104   IF (ABS(SINA).LT..000001D0) THEN
          R=SINA/2.D0
        ELSE
          R=(1.D0-COSA)/SINA
        END IF
        GO TO 196
C
C Orthographic or satellite-view, depending on the value of SALT.
C
  105   IF (ABS(SALT).LE.1.D0) THEN
          IF (COSA.GT.0.D0) THEN
            R=SINA
          ELSE
            IF (SALT.GE.0.D0) GO TO 200
            R=2.D0-SINA
          END IF
          GO TO 196
        ELSE
          IF (COSA.GT.1.D0/ABS(SALT)) THEN
            R=SRSS*SINA/(ABS(SALT)-COSA)
          ELSE
            IF (SALT.GE.0.D0) GO TO 200
            R=2.D0-SRSS*SINA/(ABS(SALT)-COSA)
          END IF
          IF (ALFA.EQ.0.D0) GO TO 196
          UTM1=R*(SINB*COSR+COSB*SINR)
          VTM1=R*(COSB*COSR-SINB*SINR)
          UTM2=UTM1*DCSB+VTM1*DSNB
          VTM2=VTM1*DCSB-UTM1*DSNB
          IF ((SRSS*DCSA+UTM2*DSNA)/SRSS.LT..0001D0) GO TO 200
          UTM3=SRSS*(UTM2*DCSA-SRSS*DSNA)/
     +                    (UTM2*DSNA+SRSS*DCSA)
          VTM3=SRSS*VTM2/(UTM2*DSNA+SRSS*DCSA)
          U=UTM3*DCSB-VTM3*DSNB
          V=VTM3*DCSB+UTM3*DSNB
          GO TO 197
        END IF
C
C Lambert equal area.
C
  106   IF (ABS(COSA+1.D0).LT..000001D0) GO TO 200
        R=(1.D0+COSA)/SINA
        R=2.D0/SQRT(1.D0+R*R)
        GO TO 196
C
C Gnomonic.
C
  107   IF (COSA.LE..000001D0) GO TO 200
        R=SINA/COSA
        GO TO 196
C
C Azimuthal equidistant.
C
  108   IF (ABS(COSA+1.D0).LT..000001D0) GO TO 200
        R=ACOS(COSA)
        GO TO 196
C
C Cylindrical equidistant, arbitrary pole and orientation.
C
  109   U=RLOP*RTOD
        V=RLAP*RTOD/CSLT
        GO TO 197
C
C Mercator, arbitrary pole and orientation.
C
  110   IF (ABS(RLAP*RTOD).GT.89.999999D0) GO TO 200
        U=RLOP
        V=LOG(TAN((RLAP+PIOT)/2.D0))
        GO TO 197
C
C Mollweide-type, arbitrary pole and orientation.
C
  111   P=RLOP*TOPI
        V=SIN(RLAP)
        U=P*SQRT(1.D0-V*V)
        GO TO 198
C
C Robinson, arbitrary pole and orientation.
C
  112   P=RLOP*OOPI
        U=P*RBGLEN(RLAP*RTOD)
        V=RBGDFE(RLAP*RTOD)
        GO TO 198
C
C Cylindrical equal-area, arbitrary pole and orientation.
C
  113   U=RLOP
        V=SIN(RLAP)/CSLS
        GO TO 197
C
C Aitoff, arbitrary pole and orientation.
C
  114   CALL AIPROJ (RLAP,RLOP,U,V)
        P=RLOP
        GO TO 198
C
C Hammer, arbitrary pole and orientation.
C
  115   CALL HAPROJ (RLAP,RLOP,U,V)
        P=TSRT*RLOP/PI
        GO TO 198
C
C True Mollweide, arbitrary pole and orientation.
C
  116   CALL MOPROJ (RLAP,RLOP,U,V)
        P=TSRT*RLOP/PI
        GO TO 198
C
C Winkel tripel, arbitrary pole and orientation.
C
  117   CALL WTPROJ (RLAP,RLOP,U,V,CSLT)
        P=RLOP
        GO TO 198
C
C Cylindrical equidistant, fast-path.
C
  118   V=V/CSLT
        GO TO 197
C
C Mercator, fast-path.
C
  119   IF (ABS(V).GT.89.999999D0) GO TO 200
        U=U*DTOR
        V=LOG(TAN((V+90.D0)*DTRH))
        GO TO 197
C
C Mollweide-type, fast-path.
C
  120   P=U/90.D0
        V=SIN(V*DTOR)
        U=P*SQRT(1.D0-V*V)
        GO TO 198
C
C Robinson, fast-path.
C
  121   P=U/180.D0
        U=P*RBGLEN(V)
        V=RBGDFE(V)
        GO TO 198
C
C Cylindrical equal-area, fast-path.
C
  122   U=U*DTOR
        V=SIN(V*DTOR)/CSLS
        GO TO 197
C
C Aitoff, fast-path.
C
  123   RLAP=V*DTOR
        RLOP=U*DTOR
        CALL AIPROJ (RLAP,RLOP,U,V)
        P=RLOP
        GO TO 198
C
C Hammer, fast-path.
C
  124   RLAP=V*DTOR
        RLOP=U*DTOR
        CALL HAPROJ (RLAP,RLOP,U,V)
        P=TSRT*RLOP/PI
        GO TO 198
C
C True Mollweide, fast-path.
C
  125   RLAP=V*DTOR
        RLOP=U*DTOR
        CALL MOPROJ (RLAP,RLOP,U,V)
        P=TSRT*RLOP/PI
        GO TO 198
C
C Winkel tripel, fast-path.
C
  126   RLAP=V*DTOR
        RLOP=U*DTOR
        CALL WTPROJ (RLAP,RLOP,U,V,CSLT)
        P=RLOP
        GO TO 198
C
C Rotated Mercator.
C
  127   IF (ABS(V).GT.89.999999D0) GO TO 200
        UTM1=U*DTOR
        VTM1=LOG(TAN((V+90.D0)*DTRH))
        P=U
        Q=V
        U=UTM1*COSR+VTM1*SINR
        V=VTM1*COSR-UTM1*SINR
        GO TO 199
C
C Common terminal code for certain projections.
C
  196   U=R*(SINB*COSR+COSB*SINR)
        V=R*(COSB*COSR-SINB*SINR)
C
  197   P=U
C
  198   Q=V
C
C Normal exit.
C
  199   U=U-UOFF
        V=V-VOFF
C
        RETURN
C
C Projection of point is invisible or undefined.
C
  200   U=1.D12
        P=U
C
        RETURN
C
C Error exit.
C
  901   CALL SETER ('MDQTRN - USGS PROJECTION WAS NOT INITIALIZED',2,1)
        RETURN
C
      END

C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CSA2XD(NI,XI,UI,WTS,KNOTS,SSMTH,NDERIV,NXO,NYO,XO,YO,
     +                  UO,NWRK,WORK,IER)
      DOUBLE PRECISION XI
      DOUBLE PRECISION UI
      DOUBLE PRECISION WTS
      DOUBLE PRECISION SSMTH
      DOUBLE PRECISION XO
      DOUBLE PRECISION YO
      DOUBLE PRECISION UO
      DOUBLE PRECISION WORK
      DOUBLE PRECISION XMN
      DOUBLE PRECISION XMX
      DOUBLE PRECISION XV
      DOUBLE PRECISION SPLDED
C
      DIMENSION XI(2,NI),UI(NI),WTS(*),KNOTS(2),XO(NXO),YO(NYO),
     +          UO(NXO,NYO),WORK(NWRK),NDERIV(2)
      DIMENSION XMN(2),XMX(2),XV(2)
C
C  Check on the number of knots.
C
      NTOT = KNOTS(1)*KNOTS(2)
C
      DO 20 I = 1,2
          IF (KNOTS(I).LT.4) THEN
              CALL CFAERR(202,
     +' CSA2XD - must have at least four knots in every coordinate dire
     +ction',68)
              IER = 202
              RETURN
          END IF
   20 CONTINUE
C
C  Check on the size of the workspace.
C
      IF (NWRK.LT.NTOT* (NTOT+3)) THEN
          CALL CFAERR(203,' CSA2XD - workspace too small',28)
          IER = 203
          RETURN
      END IF
C
C  Calculate the min and max for the knots as the minimum value of
C  the input data and output data and the maximum of the input and
C  output data.
C
      DO 30 J = 1,2
          XMN(J) = XI(J,1)
          XMX(J) = XI(J,1)
          DO 10 I = 2,NI
              XMN(J) = MIN(XMN(J),XI(J,I))
              XMX(J) = MAX(XMX(J),XI(J,I))
   10     CONTINUE
   30 CONTINUE
      XMN(1) = MIN(XMN(1),XO(1))
      XMX(1) = MAX(XMX(1),XO(NXO))
      XMN(2) = MIN(XMN(2),YO(1))
      XMX(2) = MAX(XMX(2),YO(NYO))
C
C  Find the coefficients.
C
      CALL SPLCWD(2,XI,2,UI,WTS,NI,XMN,XMX,KNOTS,SSMTH,WORK,NTOT,
     +            WORK(NTOT+1),NWRK-NTOT,IERR)
      IF (IERR.NE.0) RETURN
C
C  Calculate the approximated values (coefficients are stored at
C  the beginnig of WORK).
C
      DO 60 I = 1,NXO
          XV(1) = XO(I)
          DO 40 J = 1,NYO
              XV(2) = YO(J)
              UO(I,J) = SPLDED(2,XV,NDERIV,WORK,XMN,XMX,KNOTS,IER)
              IF (IERR.NE.0) RETURN
   40     CONTINUE
   60 CONTINUE
C
      RETURN
      END

C
C $Id: ilsint.f,v 1.4 2008-07-27 00:17:31 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      FUNCTION ILSINT (XCPA,YCPA,XCPB,YCPB,XCPC,YCPC,XCPD,YCPD)
C
C This function has a non-zero value if and only if the 2D line
C segments AB and CD overlap.
C
C Initialize the value of the function to say that the line
C segments don't intersect.
C
        ILSINT=0
C
C Compute a denominator needed below.  (Its value is zero if and
C only if the line segments are parallel.)
C
        DNOM=(XCPB-XCPA)*(YCPD-YCPC)-(XCPD-XCPC)*(YCPB-YCPA)
C
C If the line segments are parallel, they don't intersect.
C
        IF (DNOM.EQ.0.) RETURN
C
C Otherwise, find the values of S and T, in the parametric equations
C for line segments AB and CD, for which intersection occurs.
C
        S=((XCPC-XCPA)*(YCPD-YCPC)-(XCPD-XCPC)*(YCPC-YCPA))/DNOM
        T=((XCPC-XCPA)*(YCPB-YCPA)-(XCPB-XCPA)*(YCPC-YCPA))/DNOM
C
C If both S and T are strictly between 0 and 1, the line segments
C intersect; otherwise, they don't.
C
        IF (S.GT.0..AND.S.LT.1..AND.T.GT.0..AND.T.LT.1.) ILSINT=1
C
C Done.
C
        RETURN
C
      END

      SUBROUTINE CSPTRS( UPLO, N, NRHS, AP, IPIV, B, LDB, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER          UPLO
      INTEGER            INFO, LDB, N, NRHS
*     ..
*     .. Array Arguments ..
      INTEGER            IPIV( * )
      COMPLEX            AP( * ), B( LDB, * )
*     ..
*
*  Purpose
*  =======
*
*  CSPTRS solves a system of linear equations A*X = B with a complex
*  symmetric matrix A stored in packed format using the factorization
*  A = U*D*U**T or A = L*D*L**T computed by CSPTRF.
*
*  Arguments
*  =========
*
*  UPLO    (input) CHARACTER*1
*          Specifies whether the details of the factorization are stored
*          as an upper or lower triangular matrix.
*          = 'U':  Upper triangular, form is A = U*D*U**T;
*          = 'L':  Lower triangular, form is A = L*D*L**T.
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  NRHS    (input) INTEGER
*          The number of right hand sides, i.e., the number of columns
*          of the matrix B.  NRHS >= 0.
*
*  AP      (input) COMPLEX array, dimension (N*(N+1)/2)
*          The block diagonal matrix D and the multipliers used to
*          obtain the factor U or L as computed by CSPTRF, stored as a
*          packed triangular matrix.
*
*  IPIV    (input) INTEGER array, dimension (N)
*          Details of the interchanges and the block structure of D
*          as determined by CSPTRF.
*
*  B       (input/output) COMPLEX array, dimension (LDB,NRHS)
*          On entry, the right hand side matrix B.
*          On exit, the solution matrix X.
*
*  LDB     (input) INTEGER
*          The leading dimension of the array B.  LDB >= max(1,N).
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0: if INFO = -i, the i-th argument had an illegal value
*
*  =====================================================================
*
*     .. Parameters ..
      COMPLEX            ONE
      PARAMETER          ( ONE = ( 1.0E+0, 0.0E+0 ) )
*     ..
*     .. Local Scalars ..
      LOGICAL            UPPER
      INTEGER            J, K, KC, KP
      COMPLEX            AK, AKM1, AKM1K, BK, BKM1, DENOM
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           CGEMV, CGERU, CSCAL, CSWAP, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX
*     ..
*     .. Executable Statements ..
*
      INFO = 0
      UPPER = LSAME( UPLO, 'U' )
      IF( .NOT.UPPER .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( NRHS.LT.0 ) THEN
         INFO = -3
      ELSE IF( LDB.LT.MAX( 1, N ) ) THEN
         INFO = -7
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'CSPTRS', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 .OR. NRHS.EQ.0 )
     $   RETURN
*
      IF( UPPER ) THEN
*
*        Solve A*X = B, where A = U*D*U'.
*
*        First solve U*D*X = B, overwriting B with X.
*
*        K is the main loop index, decreasing from N to 1 in steps of
*        1 or 2, depending on the size of the diagonal blocks.
*
         K = N
         KC = N*( N+1 ) / 2 + 1
   10    CONTINUE
*
*        If K < 1, exit from loop.
*
         IF( K.LT.1 )
     $      GO TO 30
*
         KC = KC - K
         IF( IPIV( K ).GT.0 ) THEN
*
*           1 x 1 diagonal block
*
*           Interchange rows K and IPIV(K).
*
            KP = IPIV( K )
            IF( KP.NE.K )
     $         CALL CSWAP( NRHS, B( K, 1 ), LDB, B( KP, 1 ), LDB )
*
*           Multiply by inv(U(K)), where U(K) is the transformation
*           stored in column K of A.
*
            CALL CGERU( K-1, NRHS, -ONE, AP( KC ), 1, B( K, 1 ), LDB,
     $                  B( 1, 1 ), LDB )
*
*           Multiply by the inverse of the diagonal block.
*
            CALL CSCAL( NRHS, ONE / AP( KC+K-1 ), B( K, 1 ), LDB )
            K = K - 1
         ELSE
*
*           2 x 2 diagonal block
*
*           Interchange rows K-1 and -IPIV(K).
*
            KP = -IPIV( K )
            IF( KP.NE.K-1 )
     $         CALL CSWAP( NRHS, B( K-1, 1 ), LDB, B( KP, 1 ), LDB )
*
*           Multiply by inv(U(K)), where U(K) is the transformation
*           stored in columns K-1 and K of A.
*
            CALL CGERU( K-2, NRHS, -ONE, AP( KC ), 1, B( K, 1 ), LDB,
     $                  B( 1, 1 ), LDB )
            CALL CGERU( K-2, NRHS, -ONE, AP( KC-( K-1 ) ), 1,
     $                  B( K-1, 1 ), LDB, B( 1, 1 ), LDB )
*
*           Multiply by the inverse of the diagonal block.
*
            AKM1K = AP( KC+K-2 )
            AKM1 = AP( KC-1 ) / AKM1K
            AK = AP( KC+K-1 ) / AKM1K
            DENOM = AKM1*AK - ONE
            DO 20 J = 1, NRHS
               BKM1 = B( K-1, J ) / AKM1K
               BK = B( K, J ) / AKM1K
               B( K-1, J ) = ( AK*BKM1-BK ) / DENOM
               B( K, J ) = ( AKM1*BK-BKM1 ) / DENOM
   20       CONTINUE
            KC = KC - K + 1
            K = K - 2
         END IF
*
         GO TO 10
   30    CONTINUE
*
*        Next solve U'*X = B, overwriting B with X.
*
*        K is the main loop index, increasing from 1 to N in steps of
*        1 or 2, depending on the size of the diagonal blocks.
*
         K = 1
         KC = 1
   40    CONTINUE
*
*        If K > N, exit from loop.
*
         IF( K.GT.N )
     $      GO TO 50
*
         IF( IPIV( K ).GT.0 ) THEN
*
*           1 x 1 diagonal block
*
*           Multiply by inv(U'(K)), where U(K) is the transformation
*           stored in column K of A.
*
            CALL CGEMV( 'Transpose', K-1, NRHS, -ONE, B, LDB, AP( KC ),
     $                  1, ONE, B( K, 1 ), LDB )
*
*           Interchange rows K and IPIV(K).
*
            KP = IPIV( K )
            IF( KP.NE.K )
     $         CALL CSWAP( NRHS, B( K, 1 ), LDB, B( KP, 1 ), LDB )
            KC = KC + K
            K = K + 1
         ELSE
*
*           2 x 2 diagonal block
*
*           Multiply by inv(U'(K+1)), where U(K+1) is the transformation
*           stored in columns K and K+1 of A.
*
            CALL CGEMV( 'Transpose', K-1, NRHS, -ONE, B, LDB, AP( KC ),
     $                  1, ONE, B( K, 1 ), LDB )
            CALL CGEMV( 'Transpose', K-1, NRHS, -ONE, B, LDB,
     $                  AP( KC+K ), 1, ONE, B( K+1, 1 ), LDB )
*
*           Interchange rows K and -IPIV(K).
*
            KP = -IPIV( K )
            IF( KP.NE.K )
     $         CALL CSWAP( NRHS, B( K, 1 ), LDB, B( KP, 1 ), LDB )
            KC = KC + 2*K + 1
            K = K + 2
         END IF
*
         GO TO 40
   50    CONTINUE
*
      ELSE
*
*        Solve A*X = B, where A = L*D*L'.
*
*        First solve L*D*X = B, overwriting B with X.
*
*        K is the main loop index, increasing from 1 to N in steps of
*        1 or 2, depending on the size of the diagonal blocks.
*
         K = 1
         KC = 1
   60    CONTINUE
*
*        If K > N, exit from loop.
*
         IF( K.GT.N )
     $      GO TO 80
*
         IF( IPIV( K ).GT.0 ) THEN
*
*           1 x 1 diagonal block
*
*           Interchange rows K and IPIV(K).
*
            KP = IPIV( K )
            IF( KP.NE.K )
     $         CALL CSWAP( NRHS, B( K, 1 ), LDB, B( KP, 1 ), LDB )
*
*           Multiply by inv(L(K)), where L(K) is the transformation
*           stored in column K of A.
*
            IF( K.LT.N )
     $         CALL CGERU( N-K, NRHS, -ONE, AP( KC+1 ), 1, B( K, 1 ),
     $                     LDB, B( K+1, 1 ), LDB )
*
*           Multiply by the inverse of the diagonal block.
*
            CALL CSCAL( NRHS, ONE / AP( KC ), B( K, 1 ), LDB )
            KC = KC + N - K + 1
            K = K + 1
         ELSE
*
*           2 x 2 diagonal block
*
*           Interchange rows K+1 and -IPIV(K).
*
            KP = -IPIV( K )
            IF( KP.NE.K+1 )
     $         CALL CSWAP( NRHS, B( K+1, 1 ), LDB, B( KP, 1 ), LDB )
*
*           Multiply by inv(L(K)), where L(K) is the transformation
*           stored in columns K and K+1 of A.
*
            IF( K.LT.N-1 ) THEN
               CALL CGERU( N-K-1, NRHS, -ONE, AP( KC+2 ), 1, B( K, 1 ),
     $                     LDB, B( K+2, 1 ), LDB )
               CALL CGERU( N-K-1, NRHS, -ONE, AP( KC+N-K+2 ), 1,
     $                     B( K+1, 1 ), LDB, B( K+2, 1 ), LDB )
            END IF
*
*           Multiply by the inverse of the diagonal block.
*
            AKM1K = AP( KC+1 )
            AKM1 = AP( KC ) / AKM1K
            AK = AP( KC+N-K+1 ) / AKM1K
            DENOM = AKM1*AK - ONE
            DO 70 J = 1, NRHS
               BKM1 = B( K, J ) / AKM1K
               BK = B( K+1, J ) / AKM1K
               B( K, J ) = ( AK*BKM1-BK ) / DENOM
               B( K+1, J ) = ( AKM1*BK-BKM1 ) / DENOM
   70       CONTINUE
            KC = KC + 2*( N-K ) + 1
            K = K + 2
         END IF
*
         GO TO 60
   80    CONTINUE
*
*        Next solve L'*X = B, overwriting B with X.
*
*        K is the main loop index, decreasing from N to 1 in steps of
*        1 or 2, depending on the size of the diagonal blocks.
*
         K = N
         KC = N*( N+1 ) / 2 + 1
   90    CONTINUE
*
*        If K < 1, exit from loop.
*
         IF( K.LT.1 )
     $      GO TO 100
*
         KC = KC - ( N-K+1 )
         IF( IPIV( K ).GT.0 ) THEN
*
*           1 x 1 diagonal block
*
*           Multiply by inv(L'(K)), where L(K) is the transformation
*           stored in column K of A.
*
            IF( K.LT.N )
     $         CALL CGEMV( 'Transpose', N-K, NRHS, -ONE, B( K+1, 1 ),
     $                     LDB, AP( KC+1 ), 1, ONE, B( K, 1 ), LDB )
*
*           Interchange rows K and IPIV(K).
*
            KP = IPIV( K )
            IF( KP.NE.K )
     $         CALL CSWAP( NRHS, B( K, 1 ), LDB, B( KP, 1 ), LDB )
            K = K - 1
         ELSE
*
*           2 x 2 diagonal block
*
*           Multiply by inv(L'(K-1)), where L(K-1) is the transformation
*           stored in columns K-1 and K of A.
*
            IF( K.LT.N ) THEN
               CALL CGEMV( 'Transpose', N-K, NRHS, -ONE, B( K+1, 1 ),
     $                     LDB, AP( KC+1 ), 1, ONE, B( K, 1 ), LDB )
               CALL CGEMV( 'Transpose', N-K, NRHS, -ONE, B( K+1, 1 ),
     $                     LDB, AP( KC-( N-K ) ), 1, ONE, B( K-1, 1 ),
     $                     LDB )
            END IF
*
*           Interchange rows K and -IPIV(K).
*
            KP = -IPIV( K )
            IF( KP.NE.K )
     $         CALL CSWAP( NRHS, B( K, 1 ), LDB, B( KP, 1 ), LDB )
            KC = KC - ( N-K+2 )
            K = K - 2
         END IF
*
         GO TO 90
  100    CONTINUE
      END IF
*
      RETURN
*
*     End of CSPTRS
*
      END

C
C $Id: tdcudp.f,v 1.2 2008-07-27 00:17:32 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE TDCUDP (UCRV,VCRV,WCRV,NCRV,IARH,ARHL,ARHW)
C
        DIMENSION UCRV(NCRV),VCRV(NCRV),WCRV(NCRV)
C
C Draw the projection of a curve in 3-space, as defined by the points
C (UCRV(I),VCRV(I),WCRV(I)), for I from 1 to NCRV.  This routine is just
C like TDCURV, except that it calls the DASHPACK routine DPDRAW instead
C of the SPPS routine PLOTIF and can therefore be made to draw a dashed
C line.  The points are defined by their positions in 3-space.
C
C In addition, if IARH is non-zero, draw, at the end of the curve, the
C projection of a cone-shaped arrowhead of length ARHL and width ARHW.
C The magnitude of IARH is of the form NPAC+1000*NPCT, where NPAC is the
C number of points to be used to draw the circular base of the cone and
C NPCT is the number of points on the base to be connected to the tip.
C NPAC is forced to be 32 or greater and NPCT is forced to be NPAC/4 or
C greater; therefore, if you use IARH=1, you'll get NPAC=32 and NPCT=8.
C
C Check for an uncleared prior error.
C
        IF (ICFELL('TDCUDP - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C Project the points of the curve, convert to the fractional coordinate
C system, and draw the curve using calls to the DASHPACK routine DPDRAW.
C
        DO 101 I=1,NCRV
          CALL TDPRPT (UCRV(I),VCRV(I),WCRV(I),XPOS,YPOS)
          CALL DPDRAW (CUFX(XPOS),CUFY(YPOS),MIN(I-1,1))
  101   CONTINUE
C
C Flush the point-draw buffers.
C
        CALL DPDRAW (0.,0.,2)
C
C If an arrowhead is to be drawn at the end of the curve, do that.
C
        IF (IARH.NE.0.AND.NCRV.GE.2) THEN
          NPAC=MAX(32,MOD(IARH,1000))
          NPCT=MAX(NPAC/4,IARH/1000)
          DNOM=SQRT((UCRV(NCRV)-UCRV(NCRV-1))**2+
     +              (VCRV(NCRV)-VCRV(NCRV-1))**2+
     +              (WCRV(NCRV)-WCRV(NCRV-1))**2)
          IF (DNOM.NE.0.) THEN
            UDCS=(UCRV(NCRV)-UCRV(NCRV-1))/DNOM
            VDCS=(VCRV(NCRV)-VCRV(NCRV-1))/DNOM
            WDCS=(WCRV(NCRV)-WCRV(NCRV-1))/DNOM
            UACC=UCRV(NCRV)-ARHL*UDCS
            VACC=VCRV(NCRV)-ARHL*VDCS
            WACC=WCRV(NCRV)-ARHL*WDCS
            CALL TDCONE (UACC,VACC,WACC,UDCS,VDCS,WDCS,ARHW/2.,NPAC,
     +                   NPCT,UCRV(NCRV),VCRV(NCRV),WCRV(NCRV))
          END IF
        END IF
C
C Done.
C
        RETURN
C
      END

      SUBROUTINE ZGELSD( M, N, NRHS, A, LDA, B, LDB, S, RCOND, RANK,
     $                   WORK, LWORK, RWORK, IWORK, INFO )
*
*  -- LAPACK driver routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     October 31, 1999
*
*     .. Scalar Arguments ..
      INTEGER            INFO, LDA, LDB, LWORK, M, N, NRHS, RANK
      DOUBLE PRECISION   RCOND
*     ..
*     .. Array Arguments ..
      INTEGER            IWORK( * )
      DOUBLE PRECISION   RWORK( * ), S( * )
      COMPLEX*16         A( LDA, * ), B( LDB, * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  ZGELSD computes the minimum-norm solution to a real linear least
*  squares problem:
*      minimize 2-norm(| b - A*x |)
*  using the singular value decomposition (SVD) of A. A is an M-by-N
*  matrix which may be rank-deficient.
*
*  Several right hand side vectors b and solution vectors x can be
*  handled in a single call; they are stored as the columns of the
*  M-by-NRHS right hand side matrix B and the N-by-NRHS solution
*  matrix X.
*
*  The problem is solved in three steps:
*  (1) Reduce the coefficient matrix A to bidiagonal form with
*      Householder tranformations, reducing the original problem
*      into a "bidiagonal least squares problem" (BLS)
*  (2) Solve the BLS using a divide and conquer approach.
*  (3) Apply back all the Householder tranformations to solve
*      the original least squares problem.
*
*  The effective rank of A is determined by treating as zero those
*  singular values which are less than RCOND times the largest singular
*  value.
*
*  The divide and conquer algorithm makes very mild assumptions about
*  floating point arithmetic. It will work on machines with a guard
*  digit in add/subtract, or on those binary machines without guard
*  digits which subtract like the Cray X-MP, Cray Y-MP, Cray C-90, or
*  Cray-2. It could conceivably fail on hexadecimal or decimal machines
*  without guard digits, but we know of none.
*
*  Arguments
*  =========
*
*  M       (input) INTEGER
*          The number of rows of the matrix A. M >= 0.
*
*  N       (input) INTEGER
*          The number of columns of the matrix A. N >= 0.
*
*  NRHS    (input) INTEGER
*          The number of right hand sides, i.e., the number of columns
*          of the matrices B and X. NRHS >= 0.
*
*  A       (input) COMPLEX*16 array, dimension (LDA,N)
*          On entry, the M-by-N matrix A.
*          On exit, A has been destroyed.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A. LDA >= max(1,M).
*
*  B       (input/output) COMPLEX*16 array, dimension (LDB,NRHS)
*          On entry, the M-by-NRHS right hand side matrix B.
*          On exit, B is overwritten by the N-by-NRHS solution matrix X.
*          If m >= n and RANK = n, the residual sum-of-squares for
*          the solution in the i-th column is given by the sum of
*          squares of elements n+1:m in that column.
*
*  LDB     (input) INTEGER
*          The leading dimension of the array B.  LDB >= max(1,M,N).
*
*  S       (output) DOUBLE PRECISION array, dimension (min(M,N))
*          The singular values of A in decreasing order.
*          The condition number of A in the 2-norm = S(1)/S(min(m,n)).
*
*  RCOND   (input) DOUBLE PRECISION
*          RCOND is used to determine the effective rank of A.
*          Singular values S(i) <= RCOND*S(1) are treated as zero.
*          If RCOND < 0, machine precision is used instead.
*
*  RANK    (output) INTEGER
*          The effective rank of A, i.e., the number of singular values
*          which are greater than RCOND*S(1).
*
*  WORK    (workspace/output) COMPLEX*16 array, dimension (LWORK)
*          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*
*  LWORK   (input) INTEGER
*          The dimension of the array WORK. LWORK must be at least 1.
*          The exact minimum amount of workspace needed depends on M,
*          N and NRHS. As long as LWORK is at least
*              2 * N + N * NRHS
*          if M is greater than or equal to N or
*              2 * M + M * NRHS
*          if M is less than N, the code will execute correctly.
*          For good performance, LWORK should generally be larger.
*
*          If LWORK = -1, then a workspace query is assumed; the routine
*          only calculates the optimal size of the WORK array, returns
*          this value as the first entry of the WORK array, and no error
*          message related to LWORK is issued by XERBLA.
*
*  RWORK   (workspace) DOUBLE PRECISION array, dimension at least
*             10*N + 2*N*SMLSIZ + 8*N*NLVL + 3*SMLSIZ*NRHS +
*             (SMLSIZ+1)**2
*          if M is greater than or equal to N or
*             10*M + 2*M*SMLSIZ + 8*M*NLVL + 3*SMLSIZ*NRHS +
*             (SMLSIZ+1)**2
*          if M is less than N, the code will execute correctly.
*          SMLSIZ is returned by ILAENV and is equal to the maximum
*          size of the subproblems at the bottom of the computation
*          tree (usually about 25), and
*             NLVL = MAX( 0, INT( LOG_2( MIN( M,N )/(SMLSIZ+1) ) ) + 1 )
*
*  IWORK   (workspace) INTEGER array, dimension (LIWORK)
*          LIWORK >= 3 * MINMN * NLVL + 11 * MINMN,
*          where MINMN = MIN( M,N ).
*
*  INFO    (output) INTEGER
*          = 0: successful exit
*          < 0: if INFO = -i, the i-th argument had an illegal value.
*          > 0:  the algorithm for computing the SVD failed to converge;
*                if INFO = i, i off-diagonal elements of an intermediate
*                bidiagonal form did not converge to zero.
*
*  Further Details
*  ===============
*
*  Based on contributions by
*     Ming Gu and Ren-Cang Li, Computer Science Division, University of
*       California at Berkeley, USA
*     Osni Marques, LBNL/NERSC, USA
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO, ONE
      PARAMETER          ( ZERO = 0.0D+0, ONE = 1.0D+0 )
      COMPLEX*16         CZERO
      PARAMETER          ( CZERO = ( 0.0D+0, 0.0D+0 ) )
*     ..
*     .. Local Scalars ..
      LOGICAL            LQUERY
      INTEGER            IASCL, IBSCL, IE, IL, ITAU, ITAUP, ITAUQ,
     $                   LDWORK, MAXMN, MAXWRK, MINMN, MINWRK, MM,
     $                   MNTHR, NRWORK, NWORK, SMLSIZ
      DOUBLE PRECISION   ANRM, BIGNUM, BNRM, EPS, SFMIN, SMLNUM
*     ..
*     .. External Subroutines ..
      EXTERNAL           DLABAD, DLASCL, DLASET, XERBLA, ZGEBRD, ZGELQF,
     $                   ZGEQRF, ZLACPY, ZLALSD, ZLASCL, ZLASET, ZUNMBR,
     $                   ZUNMLQ, ZUNMQR
*     ..
*     .. External Functions ..
      INTEGER            ILAENV
      DOUBLE PRECISION   DLAMCH, ZLANGE
      EXTERNAL           ILAENV, DLAMCH, ZLANGE
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          DCMPLX, MAX, MIN
*     ..
*     .. Executable Statements ..
*
*     Test the input arguments.
*
      INFO = 0
      MINMN = MIN( M, N )
      MAXMN = MAX( M, N )
      MNTHR = ILAENV( 6, 'ZGELSD', ' ', M, N, NRHS, -1 )
      LQUERY = ( LWORK.EQ.-1 )
      IF( M.LT.0 ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( NRHS.LT.0 ) THEN
         INFO = -3
      ELSE IF( LDA.LT.MAX( 1, M ) ) THEN
         INFO = -5
      ELSE IF( LDB.LT.MAX( 1, MAXMN ) ) THEN
         INFO = -7
      END IF
*
      SMLSIZ = ILAENV( 9, 'ZGELSD', ' ', 0, 0, 0, 0 )
*
*     Compute workspace.
*     (Note: Comments in the code beginning "Workspace:" describe the
*     minimal amount of workspace needed at that point in the code,
*     as well as the preferred amount for good performance.
*     NB refers to the optimal block size for the immediately
*     following subroutine, as returned by ILAENV.)
*
      MINWRK = 1
      IF( INFO.EQ.0 ) THEN
         MAXWRK = 0
         MM = M
         IF( M.GE.N .AND. M.GE.MNTHR ) THEN
*
*           Path 1a - overdetermined, with many more rows than columns.
*
            MM = N
            MAXWRK = MAX( MAXWRK, N*ILAENV( 1, 'ZGEQRF', ' ', M, N, -1,
     $               -1 ) )
            MAXWRK = MAX( MAXWRK, NRHS*ILAENV( 1, 'ZUNMQR', 'LC', M,
     $               NRHS, N, -1 ) )
         END IF
         IF( M.GE.N ) THEN
*
*           Path 1 - overdetermined or exactly determined.
*
            MAXWRK = MAX( MAXWRK, 2*N+( MM+N )*
     $               ILAENV( 1, 'ZGEBRD', ' ', MM, N, -1, -1 ) )
            MAXWRK = MAX( MAXWRK, 2*N+NRHS*
     $               ILAENV( 1, 'ZUNMBR', 'QLC', MM, NRHS, N, -1 ) )
            MAXWRK = MAX( MAXWRK, 2*N+( N-1 )*
     $               ILAENV( 1, 'ZUNMBR', 'PLN', N, NRHS, N, -1 ) )
            MAXWRK = MAX( MAXWRK, 2*N+N*NRHS )
            MINWRK = MAX( 2*N+MM, 2*N+N*NRHS )
         END IF
         IF( N.GT.M ) THEN
            IF( N.GE.MNTHR ) THEN
*
*              Path 2a - underdetermined, with many more columns
*              than rows.
*
               MAXWRK = M + M*ILAENV( 1, 'ZGELQF', ' ', M, N, -1, -1 )
               MAXWRK = MAX( MAXWRK, M*M+4*M+2*M*
     $                  ILAENV( 1, 'ZGEBRD', ' ', M, M, -1, -1 ) )
               MAXWRK = MAX( MAXWRK, M*M+4*M+NRHS*
     $                  ILAENV( 1, 'ZUNMBR', 'QLC', M, NRHS, M, -1 ) )
               MAXWRK = MAX( MAXWRK, M*M+4*M+( M-1 )*
     $                  ILAENV( 1, 'ZUNMLQ', 'LC', N, NRHS, M, -1 ) )
               IF( NRHS.GT.1 ) THEN
                  MAXWRK = MAX( MAXWRK, M*M+M+M*NRHS )
               ELSE
                  MAXWRK = MAX( MAXWRK, M*M+2*M )
               END IF
               MAXWRK = MAX( MAXWRK, M*M+4*M+M*NRHS )
            ELSE
*
*              Path 2 - underdetermined.
*
               MAXWRK = 2*M + ( N+M )*ILAENV( 1, 'ZGEBRD', ' ', M, N,
     $                  -1, -1 )
               MAXWRK = MAX( MAXWRK, 2*M+NRHS*
     $                  ILAENV( 1, 'ZUNMBR', 'QLC', M, NRHS, M, -1 ) )
               MAXWRK = MAX( MAXWRK, 2*M+M*
     $                  ILAENV( 1, 'ZUNMBR', 'PLN', N, NRHS, M, -1 ) )
               MAXWRK = MAX( MAXWRK, 2*M+M*NRHS )
            END IF
            MINWRK = MAX( 2*M+N, 2*M+M*NRHS )
         END IF
         MINWRK = MIN( MINWRK, MAXWRK )
         WORK( 1 ) = DCMPLX( MAXWRK, 0 )
         IF( LWORK.LT.MINWRK .AND. .NOT.LQUERY ) THEN
            INFO = -12
         END IF
      END IF
*
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'ZGELSD', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         GO TO 10
      END IF
*
*     Quick return if possible.
*
      IF( M.EQ.0 .OR. N.EQ.0 ) THEN
         RANK = 0
         RETURN
      END IF
*
*     Get machine parameters.
*
      EPS = DLAMCH( 'P' )
      SFMIN = DLAMCH( 'S' )
      SMLNUM = SFMIN / EPS
      BIGNUM = ONE / SMLNUM
      CALL DLABAD( SMLNUM, BIGNUM )
*
*     Scale A if max entry outside range [SMLNUM,BIGNUM].
*
      ANRM = ZLANGE( 'M', M, N, A, LDA, RWORK )
      IASCL = 0
      IF( ANRM.GT.ZERO .AND. ANRM.LT.SMLNUM ) THEN
*
*        Scale matrix norm up to SMLNUM
*
         CALL ZLASCL( 'G', 0, 0, ANRM, SMLNUM, M, N, A, LDA, INFO )
         IASCL = 1
      ELSE IF( ANRM.GT.BIGNUM ) THEN
*
*        Scale matrix norm down to BIGNUM.
*
         CALL ZLASCL( 'G', 0, 0, ANRM, BIGNUM, M, N, A, LDA, INFO )
         IASCL = 2
      ELSE IF( ANRM.EQ.ZERO ) THEN
*
*        Matrix all zero. Return zero solution.
*
         CALL ZLASET( 'F', MAX( M, N ), NRHS, CZERO, CZERO, B, LDB )
         CALL DLASET( 'F', MINMN, 1, ZERO, ZERO, S, 1 )
         RANK = 0
         GO TO 10
      END IF
*
*     Scale B if max entry outside range [SMLNUM,BIGNUM].
*
      BNRM = ZLANGE( 'M', M, NRHS, B, LDB, RWORK )
      IBSCL = 0
      IF( BNRM.GT.ZERO .AND. BNRM.LT.SMLNUM ) THEN
*
*        Scale matrix norm up to SMLNUM.
*
         CALL ZLASCL( 'G', 0, 0, BNRM, SMLNUM, M, NRHS, B, LDB, INFO )
         IBSCL = 1
      ELSE IF( BNRM.GT.BIGNUM ) THEN
*
*        Scale matrix norm down to BIGNUM.
*
         CALL ZLASCL( 'G', 0, 0, BNRM, BIGNUM, M, NRHS, B, LDB, INFO )
         IBSCL = 2
      END IF
*
*     If M < N make sure B(M+1:N,:) = 0
*
      IF( M.LT.N )
     $   CALL ZLASET( 'F', N-M, NRHS, CZERO, CZERO, B( M+1, 1 ), LDB )
*
*     Overdetermined case.
*
      IF( M.GE.N ) THEN
*
*        Path 1 - overdetermined or exactly determined.
*
         MM = M
         IF( M.GE.MNTHR ) THEN
*
*           Path 1a - overdetermined, with many more rows than columns
*
            MM = N
            ITAU = 1
            NWORK = ITAU + N
*
*           Compute A=Q*R.
*           (RWorkspace: need N)
*           (CWorkspace: need N, prefer N*NB)
*
            CALL ZGEQRF( M, N, A, LDA, WORK( ITAU ), WORK( NWORK ),
     $                   LWORK-NWORK+1, INFO )
*
*           Multiply B by transpose(Q).
*           (RWorkspace: need N)
*           (CWorkspace: need NRHS, prefer NRHS*NB)
*
            CALL ZUNMQR( 'L', 'C', M, NRHS, N, A, LDA, WORK( ITAU ), B,
     $                   LDB, WORK( NWORK ), LWORK-NWORK+1, INFO )
*
*           Zero out below R.
*
            IF( N.GT.1 ) THEN
               CALL ZLASET( 'L', N-1, N-1, CZERO, CZERO, A( 2, 1 ),
     $                      LDA )
            END IF
         END IF
*
         ITAUQ = 1
         ITAUP = ITAUQ + N
         NWORK = ITAUP + N
         IE = 1
         NRWORK = IE + N
*
*        Bidiagonalize R in A.
*        (RWorkspace: need N)
*        (CWorkspace: need 2*N+MM, prefer 2*N+(MM+N)*NB)
*
         CALL ZGEBRD( MM, N, A, LDA, S, RWORK( IE ), WORK( ITAUQ ),
     $                WORK( ITAUP ), WORK( NWORK ), LWORK-NWORK+1,
     $                INFO )
*
*        Multiply B by transpose of left bidiagonalizing vectors of R.
*        (CWorkspace: need 2*N+NRHS, prefer 2*N+NRHS*NB)
*
         CALL ZUNMBR( 'Q', 'L', 'C', MM, NRHS, N, A, LDA, WORK( ITAUQ ),
     $                B, LDB, WORK( NWORK ), LWORK-NWORK+1, INFO )
*
*        Solve the bidiagonal least squares problem.
*
         CALL ZLALSD( 'U', SMLSIZ, N, NRHS, S, RWORK( IE ), B, LDB,
     $                RCOND, RANK, WORK( NWORK ), RWORK( NRWORK ),
     $                IWORK, INFO )
         IF( INFO.NE.0 ) THEN
            GO TO 10
         END IF
*
*        Multiply B by right bidiagonalizing vectors of R.
*
         CALL ZUNMBR( 'P', 'L', 'N', N, NRHS, N, A, LDA, WORK( ITAUP ),
     $                B, LDB, WORK( NWORK ), LWORK-NWORK+1, INFO )
*
      ELSE IF( N.GE.MNTHR .AND. LWORK.GE.4*M+M*M+
     $         MAX( M, 2*M-4, NRHS, N-3*M ) ) THEN
*
*        Path 2a - underdetermined, with many more columns than rows
*        and sufficient workspace for an efficient algorithm.
*
         LDWORK = M
         IF( LWORK.GE.MAX( 4*M+M*LDA+MAX( M, 2*M-4, NRHS, N-3*M ),
     $       M*LDA+M+M*NRHS ) )LDWORK = LDA
         ITAU = 1
         NWORK = M + 1
*
*        Compute A=L*Q.
*        (CWorkspace: need 2*M, prefer M+M*NB)
*
         CALL ZGELQF( M, N, A, LDA, WORK( ITAU ), WORK( NWORK ),
     $                LWORK-NWORK+1, INFO )
         IL = NWORK
*
*        Copy L to WORK(IL), zeroing out above its diagonal.
*
         CALL ZLACPY( 'L', M, M, A, LDA, WORK( IL ), LDWORK )
         CALL ZLASET( 'U', M-1, M-1, CZERO, CZERO, WORK( IL+LDWORK ),
     $                LDWORK )
         ITAUQ = IL + LDWORK*M
         ITAUP = ITAUQ + M
         NWORK = ITAUP + M
         IE = 1
         NRWORK = IE + M
*
*        Bidiagonalize L in WORK(IL).
*        (RWorkspace: need M)
*        (CWorkspace: need M*M+4*M, prefer M*M+4*M+2*M*NB)
*
         CALL ZGEBRD( M, M, WORK( IL ), LDWORK, S, RWORK( IE ),
     $                WORK( ITAUQ ), WORK( ITAUP ), WORK( NWORK ),
     $                LWORK-NWORK+1, INFO )
*
*        Multiply B by transpose of left bidiagonalizing vectors of L.
*        (CWorkspace: need M*M+4*M+NRHS, prefer M*M+4*M+NRHS*NB)
*
         CALL ZUNMBR( 'Q', 'L', 'C', M, NRHS, M, WORK( IL ), LDWORK,
     $                WORK( ITAUQ ), B, LDB, WORK( NWORK ),
     $                LWORK-NWORK+1, INFO )
*
*        Solve the bidiagonal least squares problem.
*
         CALL ZLALSD( 'U', SMLSIZ, M, NRHS, S, RWORK( IE ), B, LDB,
     $                RCOND, RANK, WORK( NWORK ), RWORK( NRWORK ),
     $                IWORK, INFO )
         IF( INFO.NE.0 ) THEN
            GO TO 10
         END IF
*
*        Multiply B by right bidiagonalizing vectors of L.
*
         CALL ZUNMBR( 'P', 'L', 'N', M, NRHS, M, WORK( IL ), LDWORK,
     $                WORK( ITAUP ), B, LDB, WORK( NWORK ),
     $                LWORK-NWORK+1, INFO )
*
*        Zero out below first M rows of B.
*
         CALL ZLASET( 'F', N-M, NRHS, CZERO, CZERO, B( M+1, 1 ), LDB )
         NWORK = ITAU + M
*
*        Multiply transpose(Q) by B.
*        (CWorkspace: need NRHS, prefer NRHS*NB)
*
         CALL ZUNMLQ( 'L', 'C', N, NRHS, M, A, LDA, WORK( ITAU ), B,
     $                LDB, WORK( NWORK ), LWORK-NWORK+1, INFO )
*
      ELSE
*
*        Path 2 - remaining underdetermined cases.
*
         ITAUQ = 1
         ITAUP = ITAUQ + M
         NWORK = ITAUP + M
         IE = 1
         NRWORK = IE + M
*
*        Bidiagonalize A.
*        (RWorkspace: need M)
*        (CWorkspace: need 2*M+N, prefer 2*M+(M+N)*NB)
*
         CALL ZGEBRD( M, N, A, LDA, S, RWORK( IE ), WORK( ITAUQ ),
     $                WORK( ITAUP ), WORK( NWORK ), LWORK-NWORK+1,
     $                INFO )
*
*        Multiply B by transpose of left bidiagonalizing vectors.
*        (CWorkspace: need 2*M+NRHS, prefer 2*M+NRHS*NB)
*
         CALL ZUNMBR( 'Q', 'L', 'C', M, NRHS, N, A, LDA, WORK( ITAUQ ),
     $                B, LDB, WORK( NWORK ), LWORK-NWORK+1, INFO )
*
*        Solve the bidiagonal least squares problem.
*
         CALL ZLALSD( 'L', SMLSIZ, M, NRHS, S, RWORK( IE ), B, LDB,
     $                RCOND, RANK, WORK( NWORK ), RWORK( NRWORK ),
     $                IWORK, INFO )
         IF( INFO.NE.0 ) THEN
            GO TO 10
         END IF
*
*        Multiply B by right bidiagonalizing vectors of A.
*
         CALL ZUNMBR( 'P', 'L', 'N', N, NRHS, M, A, LDA, WORK( ITAUP ),
     $                B, LDB, WORK( NWORK ), LWORK-NWORK+1, INFO )
*
      END IF
*
*     Undo scaling.
*
      IF( IASCL.EQ.1 ) THEN
         CALL ZLASCL( 'G', 0, 0, ANRM, SMLNUM, N, NRHS, B, LDB, INFO )
         CALL DLASCL( 'G', 0, 0, SMLNUM, ANRM, MINMN, 1, S, MINMN,
     $                INFO )
      ELSE IF( IASCL.EQ.2 ) THEN
         CALL ZLASCL( 'G', 0, 0, ANRM, BIGNUM, N, NRHS, B, LDB, INFO )
         CALL DLASCL( 'G', 0, 0, BIGNUM, ANRM, MINMN, 1, S, MINMN,
     $                INFO )
      END IF
      IF( IBSCL.EQ.1 ) THEN
         CALL ZLASCL( 'G', 0, 0, SMLNUM, BNRM, N, NRHS, B, LDB, INFO )
      ELSE IF( IBSCL.EQ.2 ) THEN
         CALL ZLASCL( 'G', 0, 0, BIGNUM, BNRM, N, NRHS, B, LDB, INFO )
      END IF
*
   10 CONTINUE
      WORK( 1 ) = DCMPLX( MAXWRK, 0 )
      RETURN
*
*     End of ZGELSD
*
      END

C
C	$Id: cfvld.f,v 1.7 2008-07-27 00:16:58 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CFVLD (IENTRY,IIX,IIY)
C
C CFVLD CONNECTS POINTS WHOSE COORDINATES ARE SUPPLIED IN THE ARGUMENTS,
C ACCORDING TO THE DASH PATTERN WHICH IS PASSED FROM ROUTINE DASHDB OR
C DASHDC IN THE COMMON-BLOCK DASHD1.
C
      CHARACTER*16  IPC(100)
C
      COMMON/INTPR/IPAU,FPART,TENSN,NP,SMALL,L1,ADDLR,ADDTB,MLLINE,
     1    ICLOSE
C
C THE VARIABLES IN DASHD1 AND DASHD2 ARE USED FOR COMMUNICATION WITH
C DASHDC AND DASHDB.
C
      COMMON /DASHD1/  ISL,  L,  ISIZE,  IP(100),  NWDSM1,  IPFLAG(100)
     1                 ,MNCSTR, IGP
      COMMON /DASHD2/  IPC
C
C THE VARIABLES IN DSAVE1 HAVE TO BE SAVED FOR THE NEXT CALL TO CFVLD.
C
      COMMON /DSAVE1/ X,Y,X2,Y2,X3,Y3,M,BTI,IB,IX,IY
C
C THE FLAGS IFSTFL AND IVCTFG ARE INITIALIZED IN THE BLOCK DATA DASHBDX.
C IFSTFL CONTROLS THAT FRSTD IS CALLED BEFORE VECTD IS CALLED.
C IVCTFG IS A FLAG TO INDICATE IF CFVLD IS BEING CALLED FROM VECTD OR
C LASTD.
C
      COMMON /DCFLAG/ IFSTFL
      COMMON /CFFLAG/ IVCTFG
C
      SAVE
C
C
C CMN IS USED TO DETERMINE WHEN TO STOP DRAWING A LINE SEGMENT
C
      DATA CMN/1.5/
C
C IMPOS IS USED AS AN IMPOSSIBLE PEN POSITION.
C
      DATA IMPOS /-9999/
C
C
C  ISL= -1  ALL BLANK  ) FLAG TO AVOID MOST CALCULATIONS
C        0  DASHED     )   IF PATTERN IS ALL SOLID OR
C        1  ALL SOLID  )   ALL BLANK
C
C     X,IX,Y,IY    CURRENT POSITION
C     X1,Y1        START OF A USER LINE SEGMENT
C     X2,Y2        END OF A USER LINE SEGMENT
C     X3,Y3        START OF A GAP PATTERN SEGMENT
C
C  SYMBOLS,IF PRESENT ARE CENTERED IN AN IMMEDIATLY PRECEEDING
C     GAP SEGMENT, OR DONE AT THE CURRENT POSITION OTHERWISE
C
C  SEGMENT TYPES ARE RECOGNIZED AS FOLLOWS
C     SOLID - WORD IN IP-ARRAY CONTAINS POSITIVE INTEGER, CORRESPONDING
C             ELEMENT IN IPFLAG IS 1.
C     GAP - WORD IN IP-ARRAY CONTAINS POSITIVE INTEGER, CORRESPONDING
C             ELEMENT IN IPFLAG IS -1.
C     SYMBOL - WORD IN IP-ARRAY CONTAINS CHARACTER REPRESENTATIONS.
C             CORRESPONDING ELEMENT IN IPFLAG IS 0.
C             SYMBOL COUNT FOR CHAR STRING IN CHAR NUMBER MNCSTR+1.
C     THE IP ARRAY AND THE IPFLAG ARRAY ARE COMPOSED OF L ELEMENTS.
C
C     BTI - BITS THIS INCREMENT
C     BPBX,BPBY BITS PER BIT X(Y)
C
C
C Do a call forcing a BLOCKDATA to be loaded from a binary library.
C
      CALL DASHBD
C
C BRANCH DEPENDING ON FUNCTION TO BE PERFORMED.
C
      GO TO (330,305,350),IENTRY
C
C INITIALIZE VARIABLES (ENTRY FRSTD ONLY)
C
   30 CONTINUE
      X = IX
      Y = IY
      X2 = X
      X3 = X
      Y2 = Y
      Y3 = Y
      M = 1
      IB = IPFLAG(1)
      IF (IPFLAG(1) .NE. 0) GO TO 40
      IB = 0
      BTI = 0
   40 CONTINUE
      BTI = REAL(IP(1))*FPART
      GO TO 300
C
C MAIN LOOP START
C
   50 CONTINUE
         X1 = X2
         Y1 = Y2
         MX = IIX
         MY = IIY
         X2 = MX
         Y2 = MY
         DX = X2-X1
         DY = Y2-Y1
         D = SQRT(DX*DX+DY*DY)
         IF (D .LT. CMN) GO TO 190
   60    BPBX = DX/D
         BPBY = DY/D
         CALL DRAWPV (IX,IY,0)
   70    BTI = BTI-D
         IF (BTI) 100,100,80
C
C LINE SEGMENT WILL FIT IN CURRENT PATTERN ELEMENT
C
   80    X = X2
         Y = Y2
         IX = X2
         IY = Y2
         IF (IB) 200,160,90
   90    CALL DRAWPV (IX,IY,1)
         GO TO 200
C
C LINE SEGMENT WONT FIT IN CURRENT PATTERN ELEMENT
C DO IT TO END OF ELEMENT, SAVE HOW MUCH OF SEGMENT LEFT TO DO (D)
C
  100    BTI = BTI+D
         D = D-BTI
         X = X+BPBX*BTI
         Y = Y+BPBY*BTI
         IX = X+.5
         IY = Y+.5
         IF (IB) 110,160,120
  110    CALL DRAWPV (IX,IY,0)
         GO TO 130
  120    CALL DRAWPV (IX,IY,1)
C
C GET THE NEXT PATTERN ELEMENT
C
  130    M = MOD(M,L)+1
         IB = IPFLAG(M)
         IF (IB) 140,160,150
  140    X3 = X
         Y3 = Y
         BTI = REAL(IP(M))
         GO TO 70
  150    X3 = -1.
         BTI = REAL(IP(M))
         GO TO 70
C
C CHARACTER GENERATION
C
  160    S = 0.
         IF (IGP .NE. 9) GO TO 162
C
         DX = X-X3
         DY = Y-Y3
         GO TO 164
C
  162    CONTINUE
         DX = X - X1
         DY = Y - Y1
  164    CONTINUE
C
         IF (DY) 170,180,170
  170    S = ATAN2(DY,DX)
         IF (ABS(S-.00005) .GT. 1.5708) S = S-SIGN(3.14159,S)
  180    IF (IGP .NE. 9) GO TO 182
C
         MX = X3 + DX*.5
         MY = Y3 + DY*.5
         LIGP = 0
         GO TO 184
C
  182    CONTINUE
         MX = X
         MY = Y
         LIGP = 1
C
  184    CONTINUE
         IS = INT(S*180./3.14 + .5)
         IF (IS .LT. 0) IS = 360+IS
         CALL GETUSV('XF',LXSAVE)
         CALL GETUSV('YF',LYSAVE)
         MX = ISHIFT (MX,LXSAVE-15)
         MY = ISHIFT(MY,LYSAVE-15)
         CALL WTSTR(CPUX(MX),CPUY(MY),IPC(M)(1:IP(M)),ISIZE,IS,LIGP)
         CALL DRAWPV (IMPOS,IMPOS,2)
         CALL DRAWPV (IX,IY,0)
         GO TO 130
  190    X2 = X1
         Y2 = Y1
  200 CONTINUE
C
C EXIT IF CALL WAS TO VECTD.
C
      IF (IVCTFG .NE. 2) GO TO 210
      IVCTFG = 1
      GO TO 300
C
C EXIT IF NOT PLOTTING A GAP
C
  210 IF (IB .GE. 0) GO TO 300
C
C MUST BE IN A GAP AT END OF LASTD. EXIT IF NOT A LABEL GAP.
C
      MO = M
      M = MOD(M,L) + 1
      IF (IPFLAG(M) .NE. 0) GO TO 300
C
C CHECK PREVIOUS PLOTTED ELEMENT. WAS IT A GAP OR A LINE.
C
      MPREV = M - 2
      IF (MPREV .LE. 0) MPREV = MPREV + L
      IB = IPFLAG(MPREV)
      IF (IB .GE. 0) GO TO 250
C
C PREVIOUS ELEMENT WAS A GAP - LOOK FOR NEXT LINE.
C EXIT IF NO LINES IN PATTERN.
C
  230 CONTINUE
  240 M = MOD(M,L)+1
      IF (M .EQ. MO) GO TO 300
      IB = IPFLAG(M)
      IF (IB .EQ. 0) GOTO 245
      BTI = REAL(IP(M))
  245 CONTINUE
C
C IF IP(M) NOT A LINE, CONTINUE LOOKING.
C
      IF (IB) 240,230,280
C
C PREVIOUS ELEMENT WAS A LINE - LOOK FOR NEXT GAP.
C IF NO NON-LABEL GAPS IN PATTERN, GO TO 290.
C
  250 CONTINUE
  260 M = MOD(M,L)+1
      IF (M .EQ. MO) GO TO 290
      IB = IPFLAG(M)
      IF (IB .EQ. 0) GOTO 265
      BTI = REAL(IP(M))
  265 CONTINUE
C
C IF IP(M) NOT A GAP, CONTINUE LOOKING.
C
      IF (IB) 270,250,260
C
C FOUND A GAP. IF ITS A LABEL GAP, GO LOOK FOR NEXT GAP.
C
  270 MT = M
      M = MOD(M,L)+1
      IF (IPFLAG(M) .EQ. 0) GO TO 250
      M = MT
C
C M POINTS TO NEXT ELEMENT TO PLOT. SET UP AND GO PLOT.
C
  280 X1 = X3
      Y1 = Y3
      X = X3
      Y = Y3
      IX = X+0.5
      IY = Y+0.5
      DX = X2-X1
      DY = Y2-Y1
      D = SQRT(DX*DX+DY*DY)
      IF (D .GE. CMN) GO TO 60
      GO TO 300
C
C NO NON-LABEL GAPS IN THE PATTERN - FILL IN WITH SOLID LINE.
C
  290 IX = X3+0.5
      IY = Y3+0.5
      CALL DRAWPV (IX,IY,0)
      IX = X2
      IY = Y2
      CALL DRAWPV (IX,IY,1)
  300 RETURN
C
C *************************************
C
C ENTRY VECTD (XX,YY)
C
  305 CONTINUE
C
C TEST FOR PREVIOUS CALL TO FRSTD.
C
      IF (IFSTFL .EQ. 2) GO TO 310
C
C INFORM USER - NO PREVIOUS CALL TO FRSTD. TREAT CALL AS FRSTD CALL.
C
      CALL SETER ('CFVLD -- VECTD CALL OCCURS BEFORE A CALL TO FRSTD.',
     -             1,1)
      GO TO 330
  310 K = 1
      IVCTFG = 2
      IF (ISL) 300,50,320
  320 IX = IIX
      IY = IIY
      CALL DRAWPV (IX,IY,1)
      GO TO 300
C
C *************************************
C
C     ENTRY FRSTD (FLDX,FLDY)
C
  330 IX = IIX
      IY = IIY
      IFSTFL = 2
C AVOID UNEXPECTED PEN POSITION IF CALLS TO SYSTEM PLOT PACKAGE
C ROUTINES WERE MADE.
      CALL DRAWPV (IMPOS,IMPOS,2)
      IF (ISL) 300,30,340
  340 CALL DRAWPV (IX,IY,0)
      GO TO 300
C
C *************************************
C
C     ENTRY LASTD
C
  350 CONTINUE
C
C TEST FOR PREVIOUS CALL TO FRSTD
C
      IF (IFSTFL .NE. 2) GO TO 300
      IFSTFL = 1
      K = 1
      IF (ISL .NE. 0) GO TO 300
      GO TO 210
      END

      PROGRAM TCNSMT
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C OPEN GKS, OPEN WORKSTATION OF TYPE 1, ACTIVATE WORKSTATION
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C INVOKE DEMO DRIVER
C
      CALL CNSMT(IERR)
C
C DEACTIVATE AND CLOSE WORKSTATION, CLOSE GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END
C
      SUBROUTINE CNSMT (IERROR)
C
C PURPOSE                To provide a simple demonstration of
C                        the CONRECSMTH package.
C
C USAGE                  CALL CNSMT (IERROR)
C
C ARGUMENTS
C
C ON OUTPUT              IERROR
C                          An integer variable
C                          = 0, if the test was successful,
C                          = 1, otherwise
C
C I/O                    If the test is successful, the message
C
C               CONREC SMOOTH TEST EXECUTED--SEE PLOTS TO CERTIFY
C
C                        is printed on unit 6.  In addition, 2
C                        frames are produced on the machine graphics
C                        device.  In order to determine if the test
C                        was successful, it is necessary to examine
C                        the plots.
C
C PRECISION              Single
C
C LANGUAGE               FORTRAN 77
C
C REQUIRED ROUTINES      CONREC, DASHSMTH
C
C REQUIRED GKS LEVEL     0A
C
C ALGORITHM              The function
C
C                          Z(X,Y) = X + Y + 1./((X-.1)**2+Y**2+.09)
C                                   -1./((X+.1)**2+Y**2+.09)
C
C                        for X = -1. to +1. in increments of .1, and
C                            Y = -1.2 to +1.2 in increments of .1,
C                        is computed.  Then, entries EZCNTR and CONREC
C                        are called to generate contour plots of Z.
C
C                        This is a smoothed curve version of the CONREC
C                        family of utilities.
C
C
C Z contains the values to be plotted.
C
      REAL            Z(21,25)
C
C Define the center of a plot title string on a square grid of size
C 0. to 1.
C
      DATA TX/.4267/, TY/.9765/
C
C
C Initialize the error parameter.
C
      IERROR = 0
C
C Fill a 2-D array to be plotted.
C
      DO  20 I=1,21
         X = .1*REAL(I-11)
         DO  10 J=1,25
            Y = .1*REAL(J-13)
            Z(I,J) = X+Y+1./((X-.10)**2+Y**2+.09)-
     1               1./((X+.10)**2+Y**2+.09)
   10    CONTINUE
   20 CONTINUE
C
C Select normalization transformation number 0.
C
      CALL GSELNT (0)
C
C
C     Frame 1 -- EZCNTR entry of CONRECSMTH.
C
C Entry EZCNTR requires only the array name and dimensions.
C
      CALL PLCHLQ (TX, TY,
     1  'DEMONSTRATION PLOT FOR EZCNTR ENTRY OF CONRECSMTH',16.,0.,0.)
      CALL EZCNTR (Z,21,25)
C
C
C     Frame 2 -- CONREC entry of CONRECSMTH.
C
C Entry CONREC allows user definition of various plot parameters.
C
C In this example, the lowest contour level (-4.5), the highest contour
C level (4.5), and the increment between contour levels (0.3) are set.
C
      CALL PLCHLQ (TX,TY,
     1           'DEMONSTRATION PLOT FOR CONREC ENTRY OF CONRECSMTH',
     2           16.,0.,0.)
      CALL CONREC (Z,21,21,25,-4.5,4.5,.3,0,0,0)
      CALL FRAME
C
      WRITE (6,1001)
      RETURN
C
 1001 FORMAT (' CONREC SMOOTH TEST EXECUTED--SEE PLOTS TO CERTIFY')
      END

      SUBROUTINE DGGEV( JOBVL, JOBVR, N, A, LDA, B, LDB, ALPHAR, ALPHAI,
     $                  BETA, VL, LDVL, VR, LDVR, WORK, LWORK, INFO )
*
*  -- LAPACK driver routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          JOBVL, JOBVR
      INTEGER            INFO, LDA, LDB, LDVL, LDVR, LWORK, N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), ALPHAI( * ), ALPHAR( * ),
     $                   B( LDB, * ), BETA( * ), VL( LDVL, * ),
     $                   VR( LDVR, * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  DGGEV computes for a pair of N-by-N real nonsymmetric matrices (A,B)
*  the generalized eigenvalues, and optionally, the left and/or right
*  generalized eigenvectors.
*
*  A generalized eigenvalue for a pair of matrices (A,B) is a scalar
*  lambda or a ratio alpha/beta = lambda, such that A - lambda*B is
*  singular. It is usually represented as the pair (alpha,beta), as
*  there is a reasonable interpretation for beta=0, and even for both
*  being zero.
*
*  The right eigenvector v(j) corresponding to the eigenvalue lambda(j)
*  of (A,B) satisfies
*
*                   A * v(j) = lambda(j) * B * v(j).
*
*  The left eigenvector u(j) corresponding to the eigenvalue lambda(j)
*  of (A,B) satisfies
*
*                   u(j)**H * A  = lambda(j) * u(j)**H * B .
*
*  where u(j)**H is the conjugate-transpose of u(j).
*
*
*  Arguments
*  =========
*
*  JOBVL   (input) CHARACTER*1
*          = 'N':  do not compute the left generalized eigenvectors;
*          = 'V':  compute the left generalized eigenvectors.
*
*  JOBVR   (input) CHARACTER*1
*          = 'N':  do not compute the right generalized eigenvectors;
*          = 'V':  compute the right generalized eigenvectors.
*
*  N       (input) INTEGER
*          The order of the matrices A, B, VL, and VR.  N >= 0.
*
*  A       (input/output) DOUBLE PRECISION array, dimension (LDA, N)
*          On entry, the matrix A in the pair (A,B).
*          On exit, A has been overwritten.
*
*  LDA     (input) INTEGER
*          The leading dimension of A.  LDA >= max(1,N).
*
*  B       (input/output) DOUBLE PRECISION array, dimension (LDB, N)
*          On entry, the matrix B in the pair (A,B).
*          On exit, B has been overwritten.
*
*  LDB     (input) INTEGER
*          The leading dimension of B.  LDB >= max(1,N).
*
*  ALPHAR  (output) DOUBLE PRECISION array, dimension (N)
*  ALPHAI  (output) DOUBLE PRECISION array, dimension (N)
*  BETA    (output) DOUBLE PRECISION array, dimension (N)
*          On exit, (ALPHAR(j) + ALPHAI(j)*i)/BETA(j), j=1,...,N, will
*          be the generalized eigenvalues.  If ALPHAI(j) is zero, then
*          the j-th eigenvalue is real; if positive, then the j-th and
*          (j+1)-st eigenvalues are a complex conjugate pair, with
*          ALPHAI(j+1) negative.
*
*          Note: the quotients ALPHAR(j)/BETA(j) and ALPHAI(j)/BETA(j)
*          may easily over- or underflow, and BETA(j) may even be zero.
*          Thus, the user should avoid naively computing the ratio
*          alpha/beta.  However, ALPHAR and ALPHAI will be always less
*          than and usually comparable with norm(A) in magnitude, and
*          BETA always less than and usually comparable with norm(B).
*
*  VL      (output) DOUBLE PRECISION array, dimension (LDVL,N)
*          If JOBVL = 'V', the left eigenvectors u(j) are stored one
*          after another in the columns of VL, in the same order as
*          their eigenvalues. If the j-th eigenvalue is real, then
*          u(j) = VL(:,j), the j-th column of VL. If the j-th and
*          (j+1)-th eigenvalues form a complex conjugate pair, then
*          u(j) = VL(:,j)+i*VL(:,j+1) and u(j+1) = VL(:,j)-i*VL(:,j+1).
*          Each eigenvector will be scaled so the largest component have
*          abs(real part)+abs(imag. part)=1.
*          Not referenced if JOBVL = 'N'.
*
*  LDVL    (input) INTEGER
*          The leading dimension of the matrix VL. LDVL >= 1, and
*          if JOBVL = 'V', LDVL >= N.
*
*  VR      (output) DOUBLE PRECISION array, dimension (LDVR,N)
*          If JOBVR = 'V', the right eigenvectors v(j) are stored one
*          after another in the columns of VR, in the same order as
*          their eigenvalues. If the j-th eigenvalue is real, then
*          v(j) = VR(:,j), the j-th column of VR. If the j-th and
*          (j+1)-th eigenvalues form a complex conjugate pair, then
*          v(j) = VR(:,j)+i*VR(:,j+1) and v(j+1) = VR(:,j)-i*VR(:,j+1).
*          Each eigenvector will be scaled so the largest component have
*          abs(real part)+abs(imag. part)=1.
*          Not referenced if JOBVR = 'N'.
*
*  LDVR    (input) INTEGER
*          The leading dimension of the matrix VR. LDVR >= 1, and
*          if JOBVR = 'V', LDVR >= N.
*
*  WORK    (workspace/output) DOUBLE PRECISION array, dimension (LWORK)
*          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*
*  LWORK   (input) INTEGER
*          The dimension of the array WORK.  LWORK >= max(1,8*N).
*          For good performance, LWORK must generally be larger.
*
*          If LWORK = -1, then a workspace query is assumed; the routine
*          only calculates the optimal size of the WORK array, returns
*          this value as the first entry of the WORK array, and no error
*          message related to LWORK is issued by XERBLA.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value.
*          = 1,...,N:
*                The QZ iteration failed.  No eigenvectors have been
*                calculated, but ALPHAR(j), ALPHAI(j), and BETA(j)
*                should be correct for j=INFO+1,...,N.
*          > N:  =N+1: other than QZ iteration failed in DHGEQZ.
*                =N+2: error return from DTGEVC.
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO, ONE
      PARAMETER          ( ZERO = 0.0D+0, ONE = 1.0D+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            ILASCL, ILBSCL, ILV, ILVL, ILVR, LQUERY
      CHARACTER          CHTEMP
      INTEGER            ICOLS, IERR, IHI, IJOBVL, IJOBVR, ILEFT, ILO,
     $                   IN, IRIGHT, IROWS, ITAU, IWRK, JC, JR, MAXWRK,
     $                   MINWRK
      DOUBLE PRECISION   ANRM, ANRMTO, BIGNUM, BNRM, BNRMTO, EPS,
     $                   SMLNUM, TEMP
*     ..
*     .. Local Arrays ..
      LOGICAL            LDUMMA( 1 )
*     ..
*     .. External Subroutines ..
      EXTERNAL           DGEQRF, DGGBAK, DGGBAL, DGGHRD, DHGEQZ, DLACPY,
     $                   DLASCL, DLASET, DORGQR, DORMQR, DTGEVC, XERBLA
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            ILAENV
      DOUBLE PRECISION   DLAMCH, DLANGE
      EXTERNAL           LSAME, ILAENV, DLAMCH, DLANGE
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, MAX, SQRT
*     ..
*     .. Executable Statements ..
*
*     Decode the input arguments
*
      IF( LSAME( JOBVL, 'N' ) ) THEN
         IJOBVL = 1
         ILVL = .FALSE.
      ELSE IF( LSAME( JOBVL, 'V' ) ) THEN
         IJOBVL = 2
         ILVL = .TRUE.
      ELSE
         IJOBVL = -1
         ILVL = .FALSE.
      END IF
*
      IF( LSAME( JOBVR, 'N' ) ) THEN
         IJOBVR = 1
         ILVR = .FALSE.
      ELSE IF( LSAME( JOBVR, 'V' ) ) THEN
         IJOBVR = 2
         ILVR = .TRUE.
      ELSE
         IJOBVR = -1
         ILVR = .FALSE.
      END IF
      ILV = ILVL .OR. ILVR
*
*     Test the input arguments
*
      INFO = 0
      LQUERY = ( LWORK.EQ.-1 )
      IF( IJOBVL.LE.0 ) THEN
         INFO = -1
      ELSE IF( IJOBVR.LE.0 ) THEN
         INFO = -2
      ELSE IF( N.LT.0 ) THEN
         INFO = -3
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -5
      ELSE IF( LDB.LT.MAX( 1, N ) ) THEN
         INFO = -7
      ELSE IF( LDVL.LT.1 .OR. ( ILVL .AND. LDVL.LT.N ) ) THEN
         INFO = -12
      ELSE IF( LDVR.LT.1 .OR. ( ILVR .AND. LDVR.LT.N ) ) THEN
         INFO = -14
      END IF
*
*     Compute workspace
*      (Note: Comments in the code beginning "Workspace:" describe the
*       minimal amount of workspace needed at that point in the code,
*       as well as the preferred amount for good performance.
*       NB refers to the optimal block size for the immediately
*       following subroutine, as returned by ILAENV. The workspace is
*       computed assuming ILO = 1 and IHI = N, the worst case.)
*
      MINWRK = 1
      IF( INFO.EQ.0 .AND. ( LWORK.GE.1 .OR. LQUERY ) ) THEN
         MAXWRK = 7*N + N*ILAENV( 1, 'DGEQRF', ' ', N, 1, N, 0 )
         MINWRK = MAX( 1, 8*N )
         WORK( 1 ) = MAXWRK
      END IF
*
      IF( LWORK.LT.MINWRK .AND. .NOT.LQUERY )
     $   INFO = -16
*
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DGGEV ', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
*
*     Get machine constants
*
      EPS = DLAMCH( 'P' )
      SMLNUM = DLAMCH( 'S' )
      BIGNUM = ONE / SMLNUM
      CALL DLABAD( SMLNUM, BIGNUM )
      SMLNUM = SQRT( SMLNUM ) / EPS
      BIGNUM = ONE / SMLNUM
*
*     Scale A if max element outside range [SMLNUM,BIGNUM]
*
      ANRM = DLANGE( 'M', N, N, A, LDA, WORK )
      ILASCL = .FALSE.
      IF( ANRM.GT.ZERO .AND. ANRM.LT.SMLNUM ) THEN
         ANRMTO = SMLNUM
         ILASCL = .TRUE.
      ELSE IF( ANRM.GT.BIGNUM ) THEN
         ANRMTO = BIGNUM
         ILASCL = .TRUE.
      END IF
      IF( ILASCL )
     $   CALL DLASCL( 'G', 0, 0, ANRM, ANRMTO, N, N, A, LDA, IERR )
*
*     Scale B if max element outside range [SMLNUM,BIGNUM]
*
      BNRM = DLANGE( 'M', N, N, B, LDB, WORK )
      ILBSCL = .FALSE.
      IF( BNRM.GT.ZERO .AND. BNRM.LT.SMLNUM ) THEN
         BNRMTO = SMLNUM
         ILBSCL = .TRUE.
      ELSE IF( BNRM.GT.BIGNUM ) THEN
         BNRMTO = BIGNUM
         ILBSCL = .TRUE.
      END IF
      IF( ILBSCL )
     $   CALL DLASCL( 'G', 0, 0, BNRM, BNRMTO, N, N, B, LDB, IERR )
*
*     Permute the matrices A, B to isolate eigenvalues if possible
*     (Workspace: need 6*N)
*
      ILEFT = 1
      IRIGHT = N + 1
      IWRK = IRIGHT + N
      CALL DGGBAL( 'P', N, A, LDA, B, LDB, ILO, IHI, WORK( ILEFT ),
     $             WORK( IRIGHT ), WORK( IWRK ), IERR )
*
*     Reduce B to triangular form (QR decomposition of B)
*     (Workspace: need N, prefer N*NB)
*
      IROWS = IHI + 1 - ILO
      IF( ILV ) THEN
         ICOLS = N + 1 - ILO
      ELSE
         ICOLS = IROWS
      END IF
      ITAU = IWRK
      IWRK = ITAU + IROWS
      CALL DGEQRF( IROWS, ICOLS, B( ILO, ILO ), LDB, WORK( ITAU ),
     $             WORK( IWRK ), LWORK+1-IWRK, IERR )
*
*     Apply the orthogonal transformation to matrix A
*     (Workspace: need N, prefer N*NB)
*
      CALL DORMQR( 'L', 'T', IROWS, ICOLS, IROWS, B( ILO, ILO ), LDB,
     $             WORK( ITAU ), A( ILO, ILO ), LDA, WORK( IWRK ),
     $             LWORK+1-IWRK, IERR )
*
*     Initialize VL
*     (Workspace: need N, prefer N*NB)
*
      IF( ILVL ) THEN
         CALL DLASET( 'Full', N, N, ZERO, ONE, VL, LDVL )
         CALL DLACPY( 'L', IROWS-1, IROWS-1, B( ILO+1, ILO ), LDB,
     $                VL( ILO+1, ILO ), LDVL )
         CALL DORGQR( IROWS, IROWS, IROWS, VL( ILO, ILO ), LDVL,
     $                WORK( ITAU ), WORK( IWRK ), LWORK+1-IWRK, IERR )
      END IF
*
*     Initialize VR
*
      IF( ILVR )
     $   CALL DLASET( 'Full', N, N, ZERO, ONE, VR, LDVR )
*
*     Reduce to generalized Hessenberg form
*     (Workspace: none needed)
*
      IF( ILV ) THEN
*
*        Eigenvectors requested -- work on whole matrix.
*
         CALL DGGHRD( JOBVL, JOBVR, N, ILO, IHI, A, LDA, B, LDB, VL,
     $                LDVL, VR, LDVR, IERR )
      ELSE
         CALL DGGHRD( 'N', 'N', IROWS, 1, IROWS, A( ILO, ILO ), LDA,
     $                B( ILO, ILO ), LDB, VL, LDVL, VR, LDVR, IERR )
      END IF
*
*     Perform QZ algorithm (Compute eigenvalues, and optionally, the
*     Schur forms and Schur vectors)
*     (Workspace: need N)
*
      IWRK = ITAU
      IF( ILV ) THEN
         CHTEMP = 'S'
      ELSE
         CHTEMP = 'E'
      END IF
      CALL DHGEQZ( CHTEMP, JOBVL, JOBVR, N, ILO, IHI, A, LDA, B, LDB,
     $             ALPHAR, ALPHAI, BETA, VL, LDVL, VR, LDVR,
     $             WORK( IWRK ), LWORK+1-IWRK, IERR )
      IF( IERR.NE.0 ) THEN
         IF( IERR.GT.0 .AND. IERR.LE.N ) THEN
            INFO = IERR
         ELSE IF( IERR.GT.N .AND. IERR.LE.2*N ) THEN
            INFO = IERR - N
         ELSE
            INFO = N + 1
         END IF
         GO TO 110
      END IF
*
*     Compute Eigenvectors
*     (Workspace: need 6*N)
*
      IF( ILV ) THEN
         IF( ILVL ) THEN
            IF( ILVR ) THEN
               CHTEMP = 'B'
            ELSE
               CHTEMP = 'L'
            END IF
         ELSE
            CHTEMP = 'R'
         END IF
         CALL DTGEVC( CHTEMP, 'B', LDUMMA, N, A, LDA, B, LDB, VL, LDVL,
     $                VR, LDVR, N, IN, WORK( IWRK ), IERR )
         IF( IERR.NE.0 ) THEN
            INFO = N + 2
            GO TO 110
         END IF
*
*        Undo balancing on VL and VR and normalization
*        (Workspace: none needed)
*
         IF( ILVL ) THEN
            CALL DGGBAK( 'P', 'L', N, ILO, IHI, WORK( ILEFT ),
     $                   WORK( IRIGHT ), N, VL, LDVL, IERR )
            DO 50 JC = 1, N
               IF( ALPHAI( JC ).LT.ZERO )
     $            GO TO 50
               TEMP = ZERO
               IF( ALPHAI( JC ).EQ.ZERO ) THEN
                  DO 10 JR = 1, N
                     TEMP = MAX( TEMP, ABS( VL( JR, JC ) ) )
   10             CONTINUE
               ELSE
                  DO 20 JR = 1, N
                     TEMP = MAX( TEMP, ABS( VL( JR, JC ) )+
     $                      ABS( VL( JR, JC+1 ) ) )
   20             CONTINUE
               END IF
               IF( TEMP.LT.SMLNUM )
     $            GO TO 50
               TEMP = ONE / TEMP
               IF( ALPHAI( JC ).EQ.ZERO ) THEN
                  DO 30 JR = 1, N
                     VL( JR, JC ) = VL( JR, JC )*TEMP
   30             CONTINUE
               ELSE
                  DO 40 JR = 1, N
                     VL( JR, JC ) = VL( JR, JC )*TEMP
                     VL( JR, JC+1 ) = VL( JR, JC+1 )*TEMP
   40             CONTINUE
               END IF
   50       CONTINUE
         END IF
         IF( ILVR ) THEN
            CALL DGGBAK( 'P', 'R', N, ILO, IHI, WORK( ILEFT ),
     $                   WORK( IRIGHT ), N, VR, LDVR, IERR )
            DO 100 JC = 1, N
               IF( ALPHAI( JC ).LT.ZERO )
     $            GO TO 100
               TEMP = ZERO
               IF( ALPHAI( JC ).EQ.ZERO ) THEN
                  DO 60 JR = 1, N
                     TEMP = MAX( TEMP, ABS( VR( JR, JC ) ) )
   60             CONTINUE
               ELSE
                  DO 70 JR = 1, N
                     TEMP = MAX( TEMP, ABS( VR( JR, JC ) )+
     $                      ABS( VR( JR, JC+1 ) ) )
   70             CONTINUE
               END IF
               IF( TEMP.LT.SMLNUM )
     $            GO TO 100
               TEMP = ONE / TEMP
               IF( ALPHAI( JC ).EQ.ZERO ) THEN
                  DO 80 JR = 1, N
                     VR( JR, JC ) = VR( JR, JC )*TEMP
   80             CONTINUE
               ELSE
                  DO 90 JR = 1, N
                     VR( JR, JC ) = VR( JR, JC )*TEMP
                     VR( JR, JC+1 ) = VR( JR, JC+1 )*TEMP
   90             CONTINUE
               END IF
  100       CONTINUE
         END IF
*
*        End of eigenvector calculation
*
      END IF
*
*     Undo scaling if necessary
*
      IF( ILASCL ) THEN
         CALL DLASCL( 'G', 0, 0, ANRMTO, ANRM, N, 1, ALPHAR, N, IERR )
         CALL DLASCL( 'G', 0, 0, ANRMTO, ANRM, N, 1, ALPHAI, N, IERR )
      END IF
*
      IF( ILBSCL ) THEN
         CALL DLASCL( 'G', 0, 0, BNRMTO, BNRM, N, 1, BETA, N, IERR )
      END IF
*
  110 CONTINUE
*
      WORK( 1 ) = MAXWRK
*
      RETURN
*
*     End of DGGEV
*
      END

C NCLFORTSTART
      subroutine dobjanlx(plon,plat,pval,ntim,npts,grid,mlon,nlat
     &                   ,xmsg,pmsg ,rscan,nscan,glat,glon,smwgt,opt
     &                   ,zval,zlat,zlon,ip,work,lwork,ier)        
      implicit none
c                                                                               
c Objective Analysis via 'iterative improvement'  [driver]
c
c NCL: grid = objanalii(plon,plat,pval,rscan,glat,glon,opt)
c                                                                               
c nomenclature :                                                                
c .   plat,plon    - coordinates of observation in degrees                      
c .                  -90.<= plat =>90. ; {-180, 0}<= plon >=(180, 360}
c .   pval         - value of obs. [*] or ... [ntim][*]                                              
c .   grid         - array which will hold the interpolated grid                
c .   mlon,nlat    - no. of lon and lat points                                  
c .   glon,glat    - vectors containing the lat/lon coords of the grid          
c .                  longitudes must have same range as plon
c .   rscan        - vector containing scan radii (in degrees)                  
c .                  rscan(1)> rscan(2)> ...>rscan(nscan)                       
c .   nscan        - no. of scans to be performed (length of rscan)             
c .                  it is recommended that multiple scans be                   
c .                  performed. the max number of scans is currently            
c .                  10. this may easily be adjusted by changing the            
c .                  parameter nscmax and changing the length of the            
c .                  data statement for smwgt. this routine was tested          
c .                  with nscan=4 : rscan(1,2,3,4)=20.,15.,10.,7.5              
c .                  rscan(nscan) should be .ge. the grid spacing.              
c .   xmsg         - missing code for plat and plon
c .   pmsg         - missing code for pval
c .                  value to which grid points with no data                    
c .                  within rscan(1) degrees will be set                        
c .   opt          - option flag
c .   ier          - error code                                                 
c                                                                               
c                                                   INPUT
      integer   ntim,npts,mlon,nlat,nscan,lwork,ier
      double precision  plat(npts), plon(npts), pval(npts,ntim)
      double precision  rscan(nscan),glat(nlat),glon(mlon)
      double precision  smwgt(nscan), xmsg, pmsg
      integer ip(npts)
      double precision zval(npts,ntim),zlat(npts),zlon(npts)
      double precision work(lwork)
      logical   opt
c                                                   OUTPUT
      double precision  grid(mlon,nlat,ntim) 
C NCLEND
c                                                   DYNAMIC
c      double precision, allocatable, dimension(:,:) :: zval
c      double precision, allocatable, dimension(:)   :: zlat, zlon
c      integer, allocatable, dimension(:)            :: ip
c                                                   DEFAULT SETTING
      integer nscmax, kpts, k, n, nt, i, ker 
      parameter (nscmax=10)                                   
c
c 'smwgt' is being passed in by C driver here, so this 
c  code is commented out.
c
c      double precision smwgt(nscmax)
c completely arbitrary. use for 'blending' previous and current values
c      data smwgt/1.0d0, 0.85d0, 0.70d0, 0.50d0, 6*0.25d0/             

c sort the 'plat' into ascending latitude order: ip = permutation vector

C allocate this inside NCL C wrapper.
c      allocate (ip(npts), stat=ker)
      call dpsort(plat, npts, ip, 1, ker)

c eliminate bad or missing locations

C allocate these inside NCL C wrapper.
C      allocate (zlat(npts), zlon(npts), zval(npts,ntim), stat=ker)
      k = 0
      do n=1,npts
         i = ip(n)
         if (plat(i).ne.xmsg .and. plon(i).ne.xmsg .and. 
     &       abs(plat(i)).le.90.0d0 .and. plon(i).ge.-180.0d0 .and.
     &       plon(i).le.360.0d0 ) then
             k = k+1
             zlat(k) = plat(i)
             zlon(k) = plon(i)
             do nt=1,ntim
                zval(k,nt) = pval(i,nt)
             end do
         end if
      end do
      kpts = k

c opt if (opt .and. isatt(opt,"blend_wgt")) then
c opt     ier = 0
c opt     do n=1,nscan
c opt        smwgt(n) = opt@blend_wgt(n)
c opt        if (smwgt(n).lt.0.0do .or. smwgt(n).gt.1.0d0) ier = -77
c opt     end do
c opt     if (ier.lt.0) return
c opt end if

C allocate this inside NCL C wrapper.
C      lwork = 2*kpts
C      allocate (work(lwork), stat=ker)

      call dobjanl(zlon,zlat,zval,ntim,kpts,grid,mlon,nlat,pmsg
     &            ,rscan,nscan,work,lwork,glat,glon,smwgt,ier)

      return
      end
c -------------------------------------------------------------------
      subroutine dobjanl(plon,plat,pval,ntim,npts,grid,mlon,nlat,xmsg 
     &                  ,rscan,nscan,work,lwork,glat,glon,smwgt,ier) 
      implicit none
c                                                                               
c Objective Analysis vis 'iterative improvement'
c
c NCL: grid = objanal_ii(plon,plat,pval,rscan,glat,glon,opt)
c                                                                               
c nomenclature :                                                                
c .   plat,plon    - coordinates of observation in degrees                      
c .                  -90.<= plat =>90. ; {-180, 0}<= plon >=(180, 360}
c .   pval         - value of obs. [*] or ... [ntim][*]  

c NOTE: this assumes the input triplet is in ascending latitude order

c .   grid         - array which will hold the interpolated grid                
c .   mlon,nlat    - no. of lon and lat points                                  
c .   glon,glat    - vectors containing the lat/lon coords of the grid          
c .                  longitudes must have same range as plon
c .   rscan        - vector containing scan radii (in degrees)                  
c .                  rscan(1)> rscan(2)> ...>rscan(nscan)                       
c .   nscan        - no. of scans to be performed (length of rscan)             
c .                  it is recommended that multiple scans be                   
c .                  performed. the max number of scans is currently            
c .                  10. this may easily be adjusted by changing the            
c .                  parameter nscmax and changing the length of the            
c .                  data statement for smwgt. this routine was tested          
c .                  with nscan=4 : rscan(1,2,3,4)=20.,15.,10.,7.5              
c .                  rscan(nscan) should be .ge. the grid spacing.              
c .   xmsg         - value to which grid points with no data                    
c .                  within rscan(1) degrees will be set                        
c .   work         - work vector of length 2*npts                               
c .   lwork        - length of work vector = 2*npts or greater
c .   smwgt        - vector of length nscan containing blending weights 
c .                  0.0 < smwgt <=1.0
c .   iopt         - future option flag
c .   ier          - error code                                                 
c                                                                               
      integer   ntim,npts,mlon,nlat,nscan,lwork,iopt,ier
      double precision  plat(npts), plon(npts), pval(npts,ntim), xmsg 
      double precision  rscan(nscan),work(lwork),glat(nlat),glon(mlon)
      double precision  grid(mlon,nlat,ntim) 
      double precision  smwgt(nscan)
                                                               
      integer nscmax, n, nstrt, nlast, ns, nt, nl, ml, nptlat, nptscan  
      parameter (nscmax=10)                                   
      integer  nshold(nscmax) , nlhold(nscmax)                 
      double precision  coef, rad, radinv, sglat, cglat
     &                , wgt, toplat, botlat, dumy, swgt, val

                                                                                
      ier = 0                                             
      if (npts .lt.2) ier = ier+1                       
      if (mlon .lt.2 .or. nlat.lt.2) ier = ier+10        
      if (nscan.lt.1 .or. nscan.gt.nscmax) ier = ier+100
      if (ier.ne.0) return                             

      if (nscan.gt.1) then
          do n=2,nscan
             if (rscan(n).ge.rscan(n-1)) ier = -88 
          end do
          if (ier.lt.0) return
      end if
c                                                                               
      rad    = 4.0d0*atan(1.)/180.0d0                          
      radinv = 1.0d0/rad                                
c                                                                               
c set all the output grid points to msg                                                
c                                                                               
      do nt=1,ntim 
        do nl=1,nlat 
          do ml=1,mlon 
             grid(ml,nl,nt) = xmsg
          end do
        end do
      end do
c                                                                               
c circulate thru each grid pt                                                    
c                                                                               
      do nl=1,nlat                
         sglat = sin(glat(nl)*rad)      
         cglat = cos(glat(nl)*rad)     
c                                                                               
c isolate the observations within rscan(1,2,..nscan) deg of this lat            
c .   note:  1<=nstrt <=nlast <=npts                                            
c                                                                               
         nstrt = 1            
         nlast = npts        

        do ns=1,nscan          
           nshold(ns) = 0        
           nlhold(ns) = 0      

           toplat     = glat(nl)+rscan(ns)     
           botlat     = glat(nl)-rscan(ns)      
          do n=1,npts                        
             if (plat(n).gt.toplat) go to 18     
             if (plat(n).ge.botlat) then
                 if (nshold(ns).eq.0) nshold(ns) = n
                 nlhold(ns) = n                    
             end if
          end do
   18     continue
c c c     write(*,'(3f10.2,3i5)') botlat,glat(nl),toplat
c c c&                          , ns,nshold(ns),nlhold(ns)
        end do                      
   21   continue                   
        
c only do lon loop if there are obs within the lat bounds

      if (nshold(1).gt.0) then
        do ml=1,mlon            
           nstrt  = nshold(1)      
           nlast  = nlhold(1)     
           nptlat = nlast-nstrt+1     
c                                                                               
c determine the distance of all obs in this latitude band
c .   from the current grid point in degrees of latitude           
c                                                                               
          do n=nstrt,nlast              
             dumy    = sglat*sin(plat(n)*rad) + cglat*cos(plat(n)*rad)  
     &               * cos((plon(n)-glon(ml))*rad) 
             work(n) = acos( min(max( -1.0d0,dumy),1.0d0) )*radinv
c c c        work(n) = acos( min(max( -1.0d0,
c c c&                 sglat*sin(plat(n)*rad) + cglat*cos(plat(n)*rad)  
c c c&               * cos((plon(n)-glon(ml))*rad) 
c c c&                ),1.0d0) )*radinv
c c c        print * ,
c c c&       nl,ml,n,plat(n),plon(n),glat(nl),glon(ml),work(n)
          end do
c                                                                               
c use successively smaller scans to analyze smaller scale features               
c                                                                               
          do ns=1,nscan                    
             if (nshold(ns).gt.0) then
                 coef    = -4.0d0/rscan(ns)**2         
                 nstrt   = nshold(ns)              
                 nlast   = nlhold(ns)             
                 nptscan = nlast-nstrt+1      
c                                                                               
c compute the weights;  sum of wgt*obs; wgted average                           
c                                                                               
                 do nt=1,ntim
                    swgt = 0.0d0
                   do n=nstrt,nlast
                      if (work(n).gt.rscan(ns) .or.
     &                    pval(n,nt).eq.xmsg) then
                          work(n+npts) = 0.0d0
                      else
                          wgt  = exp(coef*work(n)**2)
                          work(n+npts) = pval(n,nt)*wgt         
                          swgt = swgt + wgt
                      end if
                   end do
 
                   if (swgt.gt.0.0d0) then
                       val = 0.0d0
                       do n=nstrt,nlast
                          val = val + work(npts+n)
                       end do
                       val = val/swgt                    
c                                                       ; blend
                       if (grid(ml,nl,nt).eq.xmsg) then     
                           grid(ml,nl,nt) = val
                       else
                           grid(ml,nl,nt) = smwgt(ns)*val         
     &                               +(1.0d0-smwgt(ns))*grid(ml,nl,nt) 
                       end if
                   end if
                 end do
             end if                                                
          end do
        end do
      end if

  100   continue
      end do
c                                                                               
      return 
      end

C
C $Id: TRANSFORMF.f,v 1.1 2001-10-09 00:18:36 haley Exp $
C
C****************************************************************
C                                                               *
C                       Copyright (C)  1994                     *
C       University Corporation for Atmospheric Research         *
C                       All Rights Reserved                     *
C                                                               *
C****************************************************************
C
C      File:            TRANSFORM.f
C
C      Author:          Jeff W. Boote
C                       National Center for Atmospheric Research
C                       PO 3000, Boulder, Colorado
C
C      Date:            Fri Apr 15 16:55:17 MDT 1994
C
C      Description:     
C
C
C       TRANSFORM
C
      subroutine nhlfndctodata(ipid,x,y,n,xout,yout,xmiss,ymiss,ixmiss,
     %iymiss,istat,routrange,ierr)
        integer ipid,n,ixmiss,iymiss,istat,ierr
        real x(n),y(n),xout(n),yout(n),xmiss,ymiss,routrange

        call nhlpfndctodata(ipid,x,y,n,xout,yout,xmiss,ymiss,ixmiss,
     %          iymiss,istat,routrange,ierr)
      end
      subroutine nhlfdatatondc(ipid,x,y,n,xout,yout,xmiss,ymiss,ixmiss,
     %iymiss,istat,routrange,ierr)
        integer ipid,n,ixmiss,iymiss,istat,ierr
        real x(n),y(n),xout(n),yout(n),xmiss,ymiss,routrange

        call nhlpfdatatondc(ipid,x,y,n,xout,yout,xmiss,ymiss,ixmiss,
     %          iymiss,istat,routrange,ierr)
      end
      subroutine nhlfdatapolyline(ipid,igid,x,y,n,ierr)
        integer ipid,igid,n,ierr
        real    x(n),y(n)

        call nhlpfdatapolyline(ipid,igid,x,y,n,ierr)
      end
      subroutine nhlfndcpolyline(ipid,igid,x,y,n,ierr)
        integer ipid,igid,n,ierr
        real    x(n),y(n)

        call nhlpfndcpolyline(ipid,igid,x,y,n,ierr)
      end
      subroutine nhlfdatapolygon(ipid,igid,x,y,n,ierr)
        integer ipid,igid,n,ierr
        real    x(n),y(n)

        call nhlpfdatapolygon(ipid,igid,x,y,n,ierr)
      end
      subroutine nhlfndcpolygon(ipid,igid,x,y,n,ierr)
        integer ipid,igid,n,ierr
        real    x(n),y(n)

        call nhlpfndcpolygon(ipid,igid,x,y,n,ierr)
      end
      subroutine nhlfdatapolymarker(ipid,igid,x,y,n,ierr)
        integer ipid,igid,n,ierr
        real    x(n),y(n)

        call nhlpfdatapolymarker(ipid,igid,x,y,n,ierr)
      end
      subroutine nhlfndcpolymarker(ipid,igid,x,y,n,ierr)
        integer ipid,igid,n,ierr
        real    x(n),y(n)

        call nhlpfndcpolymarker(ipid,igid,x,y,n,ierr)
      end
      subroutine nhlfistransform(id,istat)

        integer id,istat
        call nhlpfistransform(id,istat)
      end
      subroutine nhlfaddprimitive(itid,ipid,ibid,ierr)
        integer itid,ipid,ibid,ierr

        call nhlpfaddprimitive(itid,ipid,ibid,ierr)
      end
      subroutine nhlfremoveprimitive(itid,ipid,ierr)
        integer itid,ipid,ierr

        call nhlpfremoveprimitive(itid,ipid,ierr)
      end

      PROGRAM CIDSFFT
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER (NRAN=30,LRWK=3500,LIWK=4000)
      PARAMETER (MREG=50,NREG=50)
      REAL XRAN(NRAN), YRAN(NRAN), ZRAN(NRAN)
      REAL XREG(MREG), YREG(NREG), ZREG(MREG,NREG), RWRK(LRWK)
      REAL XDELTA(MREG)
      INTEGER IWRK(LIWK)

      DATA XRAN /12., 60., 14., 33.,  8., 12., 43., 57., 22., 15.,
     +     19., 12., 64., 19., 15., 55., 31., 32., 33., 29.,
     +     18.,  1., 18., 42., 56.,  9.,  6., 12., 44., 19./
      DATA YRAN / 1.,  2.,  3., 53.,  7., 11., 13., 17., 19., 49.,
     +     1., 31., 37.,  5.,  7., 47., 61., 17.,  5., 23.,
     +     29.,  3.,  5., 41., 43.,  9., 13., 59.,  1., 67./
      DATA ZRAN /1.0, 1.5, 1.7, 1.4, 1.9, 1.0, 1.5, 1.2, 1.8, 1.4,
     +     1.8, 1.7, 1.9, 1.5, 1.2, 1.1, 1.3, 1.7, 1.2, 1.6,
     +     1.9, 1.0, 1.6, 1.3, 1.4, 1.8, 1.7, 1.5, 1.1, 1.0/
      DATA XDELTA/.00,.02,.04,.06,.08,.10,.12,.14,.16,.18,.20,
     +            .22,.24,.26,.28,.30,.32,.34,.36,.38,.40,.42,
     +            .44,.46,.48,.50,.52,.54,.56,.58,.60,.62,.64,
     +            .66,.68,.70,.72,.74,.76,.78,.80,.82,.84,.86,
     +            .88,.90,.92,.94,.96,.98/
C
C Open GKS
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C  Find the min and max data values.
C
      XMIN = 0.0
      XMAX = 65.0
      YMIN =  0.0
      YMAX = 68.0
C
C Choose the X and Y coordinates for interpolation points on the 
C regular grid.
C
      XREG(1)=XMIN
      DO 101 I=2,MREG
         XREG(I)=XMIN + (XMAX - XMIN)*XDELTA(I)
 101  CONTINUE
C
      YREG(1)=YMIN
      DO 102 I=2,NREG
         YREG(I)=YMIN + (YMAX - YMIN)*XDELTA(I)
 102  CONTINUE
C
C Interpolate data onto a regular grid
C
      CALL IDSFFT (1,NRAN,XRAN,YRAN,ZRAN,
     +    MREG,NREG,MREG,XREG,YREG,ZREG,IWRK,RWRK)
C
C Initialize Conpack
C
      CALL CPRECT(ZREG, MREG, MREG, NREG, RWRK, LRWK, IWRK, LIWK)
C
C Draw Perimeter
C
      CALL CPBACK(ZREG, RWRK, IWRK)
C
C Draw Contours
C
      CALL CPCLDR(ZREG,RWRK,IWRK)
C
C Mark data points
C
      CALL MARK (XRAN,YRAN,NRAN)
C
C Close frame and close GKS
C
      CALL FRAME
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS

      STOP
      END

      SUBROUTINE MARK (XRAN, YRAN, NRAN)

      REAL XRAN(NRAN), YRAN(NRAN)
      INTEGER I

      CALL GETSET(DUM1,DUM2,DUM3,DUM4,XMIN,XMAX,YMIN,YMAX,IDUM5)
      CALL GSMKSC(.5)

      DO 11 I=1,NRAN
         CALL POINTS (XRAN(I), YRAN(I), 1, -4, 0)
 11   CONTINUE

      RETURN
      END

      SUBROUTINE CLACGV( N, X, INCX )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     October 31, 1992
*
*     .. Scalar Arguments ..
      INTEGER            INCX, N
*     ..
*     .. Array Arguments ..
      COMPLEX            X( * )
*     ..
*
*  Purpose
*  =======
*
*  CLACGV conjugates a complex vector of length N.
*
*  Arguments
*  =========
*
*  N       (input) INTEGER
*          The length of the vector X.  N >= 0.
*
*  X       (input/output) COMPLEX array, dimension
*                         (1+(N-1)*abs(INCX))
*          On entry, the vector of length N to be conjugated.
*          On exit, X is overwritten with conjg(X).
*
*  INCX    (input) INTEGER
*          The spacing between successive elements of X.
*
* =====================================================================
*
*     .. Local Scalars ..
      INTEGER            I, IOFF
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          CONJG
*     ..
*     .. Executable Statements ..
*
      IF( INCX.EQ.1 ) THEN
         DO 10 I = 1, N
            X( I ) = CONJG( X( I ) )
   10    CONTINUE
      ELSE
         IOFF = 1
         IF( INCX.LT.0 )
     $      IOFF = 1 - ( N-1 )*INCX
         DO 20 I = 1, N
            X( IOFF ) = CONJG( X( IOFF ) )
            IOFF = IOFF + INCX
   20    CONTINUE
      END IF
      RETURN
*
*     End of CLACGV
*
      END

      PROGRAM EXAMPL
C
C Define error file, Fortran unit number, and workstation type,
C and workstation ID.
C
        PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1, IWKID=1)
C
C This program creates a colorful picture to serve as a test for the
C translator.  It is based on EZMAP example 10 and parts of the new
C PLOTCHAR test program.
C
C Assume you have a FORTRAN function that, given the position of a
C point on the surface of the earth, returns the real value of some
C physical quantity there.  You would like to split the full range of
C values of the quantity into intervals, associate a different color
C with each interval, and then draw a colored map of the resulting
C globe.  One way to do this is to use the contouring package CONPACK;
C another way to do it is given below.
C
C This program constructs a rectangular cell array covering the part
C of the plotter frame occupied by a selected map of the globe.  Each
C element of the cell array occupies a small rectangular portion of
C the plotter frame.  The EZMAP routine MAPTRI, which does the inverse
C transformations, is used to find the values of latitude and longitude
C associated with each cell; these can be used to obtain the value of
C the physical quantity and therefore the color index associated with
C the cell.  When the cell array is complete, it is drawn by a call to
C the GKS routine GCA.
C
C Define an integer array in which to build the cell array.
C
        DIMENSION ICRA(1000,1000)
C
C Declare some required variables.
C
        CHARACTER*2 PROJ,JLTS
        DIMENSION PLM1(2),PLM2(2),PLM3(2),PLM4(2)
C
C NCLS specifies the number of cells along each edge of the cell array.
C Use a positive value less than or equal to 1000.
C
        DATA NCLS / 300 /
C
C NCLR specifies the number of different colors to be used.
C
        DATA NCLR / 64 /
C
C PROJ is the desired projection type.  Use one of 'LC', 'ST', 'OR',
C 'LE', 'GN', 'AE', 'SV', 'CE', 'ME', or 'MO'.
C
        DATA PROJ / 'OR' /
C
C PLAT and PLON are the desired latitude and longitude of the center of
C the projection, in degrees.
C
	DATA PLAT,PLON / 20. , -105. /
C
C ROTA is the desired final rotation of the map, in degrees.
C
	DATA ROTA / 15. /
C
C SALT, ALFA, and BETA are the desired values of the parameters 'SA',
C 'S1', and 'S2', which are only used with a satellite-view projection.
C SALT is the distance of the satellite from the center of the earth,
C in units of earth radii.  ALFA is the angle, in degrees, between the
C line of sight and the line to the center of the earth.  BETA is used
C only when ALFA is non-zero; it is the angle, in degrees, measured
C counterclockwise, from the plane passing through the satellite, the
C center of the earth, and the point which is due east on the horizon
C to the plane in which the line of sight and the line to the center
C of the earth both lie.
C
        DATA SALT,ALFA,BETA / 1.25 , 15. , 90. /
C
C JLTS, PLM1, PLM2, PLM3, and PLM4 are the required arguments of the
C EZMAP routine MAPSET, which determines the boundaries of the map.
C
        DATA JLTS / 'MA' /
        DATA PLM1(1),PLM2(1),PLM3(1),PLM4(1) / 0. , 0. , 0. , 0. /
        DATA PLM1(2),PLM2(2),PLM3(2),PLM4(2) / 0. , 0. , 0. , 0. /
C
C IGRD is the spacing, in degrees, of the EZMAP grid of latitudes and
C longitudes.  IGRD = 0 turns the grid off.
C
	DATA IGRD / 0 /
C
C Define the constant used to convert from degrees to radians.
C
        DATA DTOR / .017453292519943 /
C
C Open GKS.
C
        CALL GOPKS (IERRF, ISZDM)
        CALL GOPWK (IWKID, LUNIT, IWTYPE)
        CALL GACWK (IWKID)
C
C Define the color indices required.  0 and 1 are used for black and
C white (as is customary); the next NCLR values are distributed between
C pure blue (color 2) and pure red (color NCLR+1).  The colors NCLR+2,
C NCLR+3, and NCLR+4 are used for character shadows, outlines, and
C principal bodies, respectively.
C
        CALL GSCR (1,0,0.,0.,0.)
        CALL GSCR (1,1,1.,1.,1.)
C
        DO 101 ICLR=1,NCLR
          CALL GSCR (1,1+ICLR,REAL(ICLR-1)/REAL(NCLR-1),0.,
     +                        REAL(NCLR-ICLR)/REAL(NCLR-1))
  101   CONTINUE
C
	CALL GSCR (1,NCLR+2,0.,0.,0.)
	CALL GSCR (1,NCLR+3,1.,1.,0.)
	CALL GSCR (1,NCLR+4,0.,1.,1.)
C
C Set the EZMAP projection parameters.
C
        CALL MAPROJ (PROJ,PLAT,PLON,ROTA)
        IF (PROJ.EQ.'SV') THEN
          CALL MAPSTR ('SA',SALT)
          CALL MAPSTR ('S1',ALFA)
          CALL MAPSTR ('S2',BETA)
        END IF
C
C Set the limits of the map.
C
        CALL MAPSET (JLTS,PLM1,PLM2,PLM3,PLM4)
C
C Set the grid spacing.
C
        CALL MAPSTI ('GR - GRID SPACING',IGRD)
C
C Turn off the drawing of labels.
C
	CALL MAPSTI ('LA - LABELLING',0)
C
C Turn off the drawing of the perimeter.
C
	CALL MAPSTI ('PE - PERIMETER',0)
C
C Initialize EZMAP, so that calls to MAPTRI will work properly.
C
        CALL MAPINT
C
C Fill the cell array.  The data generator is rigged to create
C values between 0 and 1, so as to make it easy to interpolate to
C get a color index to be used.  Obviously, the statement setting
C DVAL can be replaced by one that yields a value of some real data
C field of interest (normalized to the range from 0 to 1).
C
        DO 103 I=1,NCLS
          X=CFUX(.05+.90*(REAL(I-1)+.5)/REAL(NCLS))
          DO 102 J=1,NCLS
            Y=CFUY(.05+.90*(REAL(J-1)+.5)/REAL(NCLS))
            CALL MAPTRI (X,Y,RLAT,RLON)
            IF (RLAT.NE.1.E12) THEN
	      DVAL=.25*(1.+COS(DTOR*15.*RLAT))+
     +             .25*(1.+SIN(DTOR*15.*RLON))*COS(DTOR*RLAT)
              ICRA(I,J)=MAX(2,MIN(NCLR+1,2+INT(DVAL*REAL(NCLR))))
            ELSE
              ICRA(I,J)=0
            END IF
  102     CONTINUE
  103   CONTINUE
C
C Draw the cell array.
C
        CALL GCA (CFUX(.05),CFUY(.05),CFUX(.95),CFUY(.95),1000,1000,
     +                                           1,1,NCLS,NCLS,ICRA)
C
C Quadruple the line width and put a map on top of the cell array.
C
	CALL PLOTIF (0.,0.,2)
	CALL GSLWSC (4.)
        CALL MAPDRW
C
C Using a doubled line width, put a bunch of logos on the globe.
C
	CALL PLOTIF (0.,0.,2)
	CALL GSLWSC (2.)
	CALL PCSETI ('MA - MAPPING FLAG',1)
	CALL PCSETR ('OR - OUT-OF-RANGE FLAG',1.E12)
	CALL PCSETI ('SF - SHADOW FLAG',1)
	CALL PCSETR ('SX - SHADOW OFFSET IN X',-.09)
	CALL PCSETR ('SY - SHADOW OFFSET IN Y',-.06)
	CALL PCSETI ('OF - OUTLINE FLAG',1)
	CALL PCSETI ('SC - SHADOW COLOR   ',NCLR+2)
	CALL PCSETI ('OC - OUTLINE COLOR  ',NCLR+3)
	CALL PCSETI ('CC - CHARACTER COLOR',NCLR+4)
	CALL PLCHHQ (-225.,-60.,':F25Y250:NCAR GRAPHICS',8.,0.,0.)
	CALL PLCHHQ (-225.,-30.,':F25Y250:NCAR GRAPHICS',8.,0.,0.)
	CALL PLCHHQ (-225.,  0.,':F25Y250:NCAR GRAPHICS',8.,0.,0.)
	CALL PLCHHQ (-225.,+30.,':F25Y250:NCAR GRAPHICS',8.,0.,0.)
	CALL PLCHHQ (-225.,+60.,':F25Y250:NCAR GRAPHICS',8.,0.,0.)
	CALL PLCHHQ (-105.,-60.,':F25Y250:NCAR GRAPHICS',8.,0.,0.)
	CALL PLCHHQ (-105.,-30.,':F25Y250:NCAR GRAPHICS',8.,0.,0.)
	CALL PLCHHQ (-105.,  0.,':F25Y250:NCAR GRAPHICS',8.,0.,0.)
	CALL PLCHHQ (-105.,+30.,':F25Y250:NCAR GRAPHICS',8.,0.,0.)
	CALL PLCHHQ (-105.,+60.,':F25Y250:NCAR GRAPHICS',8.,0.,0.)
	CALL PLCHHQ ( +15.,-60.,':F25Y250:NCAR GRAPHICS',8.,0.,0.)
	CALL PLCHHQ ( +15.,-30.,':F25Y250:NCAR GRAPHICS',8.,0.,0.)
	CALL PLCHHQ ( +15.,  0.,':F25Y250:NCAR GRAPHICS',8.,0.,0.)
	CALL PLCHHQ ( +15.,+30.,':F25Y250:NCAR GRAPHICS',8.,0.,0.)
	CALL PLCHHQ ( +15.,+60.,':F25Y250:NCAR GRAPHICS',8.,0.,0.)
C
C Advance the frame.
C
        CALL FRAME
C
C Close GKS.
C
        CALL GDAWK (IWKID)
        CALL GCLWK (IWKID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END

C
C	$Id: csgradg.f,v 1.5 2008-07-27 03:10:06 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CSGRADG (N,X,Y,Z,F,LIST,LPTR,LEND,IFLGS,
     .                  SIGMA, NIT,DGMAX,GRAD, IER)
      INTEGER N, LIST(*), LPTR(*), LEND(N), IFLGS, NIT, IER
      DOUBLE PRECISION X(N), Y(N), Z(N), F(N), SIGMA(*),
     .                 DGMAX, GRAD(3,N)
C
C***********************************************************
C
C                                              From SSRFPACK
C                                            Robert J. Renka
C                                  Dept. of Computer Science
C                                       Univ. of North Texas
C                                           renka@cs.unt.edu
C                                                   07/24/96
C
C   Given a triangulation of N nodes on the unit sphere with
C data values F at the nodes and tension factors SIGMA asso-
C ciated with the arcs, this routine uses a global method
C to compute estimated gradients at the nodes.  The method
C consists of minimizing a quadratic functional Q(G) over
C the N-vector G of gradients, where Q approximates the
C linearized curvature of the restriction to arcs of the
C interpolatory function F defined by Function CSFVAL.  The
C restriction of F to an arc of the triangulation is the
C Hermite interpolatory tension spline defined by the data
C values and tangential gradient components at the endpoints
C of the arc.  Letting D1F(A) and D2F(A) denote first and
C second derivatives of F with respect to a parameter A var-
C ying along a triangulation arc, Q is the sum of integrals
C over the arcs of D2F(A)**2 + ((SIGMA/L)*(D1F(A)-S))**2,
C where L denotes arc-length, SIGMA is the appropriate ten-
C sion factor, and S is the slope of the linear function of
C A which interpolates the values of F at the endpoints of
C the arc.
C
C   Since the gradient at node K lies in the plane tangent
C to the sphere surface at K, it is effectively defined by
C only two components -- its X and Y components in the coor-
C dinate system obtained by rotating K to the north pole.
C Thus, the minimization problem corresponds to an order-2N
C symmetric positive-definite sparse linear system which is
C solved by a block Gauss-Seidel method with 2 by 2 blocks.
C
C   An alternative method, Subroutine CSGRADL, computes a
C local approximation to the gradient at a single node and,
C although less efficient when all gradients are needed, was
C found to be generally more accurate (in the case of uni-
C form zero tension) when the nodal distribution is very
C dense, varies greatly, or does not cover the sphere.
C CSGRADG, on the other hand, was found to be slightly more
C accurate on a uniform distribution of 514 nodes.
C
C On input:
C
C       N = Number of nodes in the triangulation.  N .GE. 3.
C
C       X,Y,Z = Arrays of length N containing Cartesian
C               coordinates of the nodes.  X(I)**2 + Y(I)**2
C               + Z(I)**2 = 1 for I = 1,...,N.
C
C       F = Array of length N containing data values at the
C           nodes.  F(I) is associated with (X(I),Y(I),Z(I))
C           for I = 1,...,N.
C
C       LIST,LPTR,LEND = Data structure defining the trian-
C                        gulation.  Refer to STRIPACK
C                        Subroutine CSTRMESH.
C
C       IFLGS = Tension factor option:
C               IFLGS .LE. 0 if a single uniform tension
C                            factor is to be used.
C               IFLGS .GE. 1 if variable tension is desired.
C
C       SIGMA = Uniform tension factor (IFLGS .LE. 0), or
C               array containing tension factors associated
C               with arcs in one-to-one correspondence with
C               LIST entries (IFLGS .GE. 1).  Refer to Sub-
C               programs CSGETSIG, CSSIG0, CSSIG1, and CSSIG2.
C
C The above parameters are not altered by this routine.
C
C       NIT = Maximum number of Gauss-Seidel iterations to
C             be applied.  This maximum will likely be a-
C             chieved if DGMAX is smaller than the machine
C             precision.  NIT .GE. 0.
C
C       DGMAX = Nonnegative convergence criterion.  The
C               method is terminated when the maximum change
C               in a gradient between iterations is at most
C               DGMAX.  The change in a gradient is taken to
C               be the Euclidean norm of the difference (in
C               the rotated coordinate system) relative to 1
C               plus the norm of the old gradient value.
C
C       GRAD = 3 by N array whose columns contain initial
C              solution estimates (zero vectors are suffici-
C              ent).  GRAD(I,J) contains component I of the
C              gradient at node J for I = 1,2,3 (X,Y,Z) and
C              J = 1,...,N.  GRAD( ,J) must be orthogonal to
C              node J -- GRAD(1,J)*X(J) + GRAD(2,J)*Y(J) +
C              GRAD(3,J)*Z(J) = 0.
C
C On output:
C
C       NIT = Number of Gauss-Seidel iterations employed.
C
C       DGMAX = Maximum change in a gradient at the last
C               iteration.
C
C       GRAD = Estimated gradients.  See the description
C              under input parameters.  GRAD is not changed
C              if IER = -1.
C
C       IER = Error indicator:
C             IER = 0 if no errors were encountered and the
C                     convergence criterion was achieved.
C             IER = 1 if no errors were encountered but con-
C                     vergence was not achieved within NIT
C                     iterations.
C             IER = -1 if N or DGMAX is outside its valid
C                      range or NIT .LT. 0 on input.
C             IER = -2 if all nodes are collinear or the
C                      triangulation is invalid.
C             IER = -3 if duplicate nodes were encountered.
C
C SSRFPACK modules required by CSGRADG:  CSAPLYRT, CSCONSTR,
C                                        CSGRCOEF, CSSNHCSH
C
C Intrinsic functions called by CSGRADG:  ATAN, MAX, SQRT
C
C***********************************************************
C
      INTEGER IFL, ITER, J, K, LPJ, LPL, MAXIT, NN
      DOUBLE PRECISION ALFA, A11, A12, A22, CX, CY, D, DEN,
     .                 DET, DGK(3), DGMX, DG1, DG2, FK, G1,
     .                 G2, G3, R1, R2, SD, SIG, SINAL, SX,
     .                 SY, T, TOL, XK, YK, ZK, XJ, YJ, ZJ,
     .                 XS, YS
C
C Local parameters:
C
C ALFA =        Arc-length between nodes K and J
C A11,A12,A22 = Matrix components of the 2 by 2 block A*DG
C                 = R where A is symmetric, (DG1,DG2,0) is
C                 the change in the gradient at K, and R is
C                 the residual
C CX,CY =       Components of a rotation mapping K to the
C                 north pole (0,0,1)
C D =           Function of SIG computed by CSGRCOEF -- factor
C                 in the order-2 system
C DEN =         ALFA*SINAL**2 -- factor in the 2 by 2 system
C DET =         Determinant of the order-2 matrix
C DGK =         Change in GRAD( ,K) from the previous esti-
C                 mate in the original coordinate system
C DGMX =        Maximum change in a gradient between itera-
C                 tions
C DG1,DG2 =     Solution of the 2 by 2 system -- first 2
C                 components of DGK in the rotated coordi-
C                 nate system
C FK =          Data value F(K)
C G1,G2,G3 =    Components of GRAD( ,K)
C IFL =         Local copy of IFLGS
C ITER =        Number of iterations used
C J =           Neighbor of K
C K =           DO-loop and node index
C LPJ =         LIST pointer of node J as a neighbor of K
C LPL =         Pointer to the last neighbor of K
C MAXIT =       Input value of NIT
C NN =          Local copy of N
C R1,R2 =       Components of the residual -- derivatives of
C                 Q with respect to the components of the
C                 gradient at node K
C SD =          Function of SIG computed by CSGRCOEF -- factor
C                 in the order-2 system
C SIG =         Tension factor associated with ARC K-J
C SINAL =       SIN(ALFA) -- magnitude of the vector cross
C                 product between nodes K and J
C SX,SY =       Components of a rotation mapping K to the
C                 north pole (0,0,1)
C T =           Temporary storage for factors in the system
C                 components
C TOL =         Local copy of DGMAX
C XK,YK,ZK =    Coordinates of node K -- X(K), Y(K), Z(K)
C XJ,YJ,ZJ =    Coordinates of node J in the rotated coor-
C                 dinate system
C XS,YS =       XJ**2, YJ**2
C
      NN = N
      IFL = IFLGS
      MAXIT = NIT
      TOL = DGMAX
C
C Test for errors in input, and initialize iteration count,
C   tension factor, and output value of DGMAX.
C
      IF (NN .LT. 3  .OR.  MAXIT .LT. 0  .OR.  TOL .LT. 0.)
     .   GO TO 11
      ITER = 0
      SIG = SIGMA(1)
      DGMX = 0.
C
C Top of iteration loop.
C
    1 IF (ITER .EQ. MAXIT) GO TO 4
      DGMX = 0.
C
C Loop on nodes.
C
      DO 3 K = 1,NN
        XK = X(K)
        YK = Y(K)
        ZK = Z(K)
        FK = F(K)
        G1 = GRAD(1,K)
        G2 = GRAD(2,K)
        G3 = GRAD(3,K)
C
C   Construct the rotation mapping node K to the north pole.
C
        CALL CSCONSTR (XK,YK,ZK, CX,SX,CY,SY)
C
C   Initialize components of the 2 by 2 system for the
C     change (DG1,DG2,0) in the K-th solution components
C     (symmetric matrix in A and residual in R).
C
        A11 = 0.
        A12 = 0.
        A22 = 0.
        R1 = 0.
        R2 = 0.
C
C   Loop on neighbors J of node K.
C
        LPL = LEND(K)
        LPJ = LPL
    2   LPJ = LPTR(LPJ)
          J = ABS(LIST(LPJ))
C
C   Compute the coordinates of J in the rotated system.
C
          T = SX*Y(J) + CX*Z(J)
          YJ = CX*Y(J) - SX*Z(J)
          ZJ = SY*X(J) + CY*T
          XJ = CY*X(J) - SY*T
C
C   Compute arc-length ALFA between J and K, SINAL =
C     SIN(ALFA), and DEN = ALFA*SIN(ALFA)**2.
C
          ALFA = 2.D0*ATAN(SQRT((1.D0-ZJ)/(1.D0+ZJ)))
          XS = XJ*XJ
          YS = YJ*YJ
          SINAL = SQRT(XS+YS)
          DEN = ALFA*(XS+YS)
C
C   Test for coincident nodes and compute functions of SIG:
C     D = SIG*(SIG*COSHM-SINHM)/E and SD = SIG*SINHM/E for
C     E = SIG*SINH-2*COSHM.
C
          IF (DEN .EQ. 0.) GO TO 13
          IF (IFL .GE. 1) SIG = SIGMA(LPJ)
          CALL CSGRCOEF (SIG, D,SD)
C
C   Update the system components for node J.
C
          T = D/DEN
          A11 = A11 + T*XS
          A12 = A12 + T*XJ*YJ
          A22 = A22 + T*YS
          T = (D+SD)*(FK-F(J))/(ALFA*ALFA*SINAL) +
     .        ( D*(G1*X(J) + G2*Y(J) + G3*Z(J)) -
     .          SD*(GRAD(1,J)*XK + GRAD(2,J)*YK +
     .                 GRAD(3,J)*ZK) )/DEN
          R1 = R1 - T*XJ
          R2 = R2 - T*YJ
C
C   Bottom of loop on neighbors.
C
          IF (LPJ .NE. LPL) GO TO 2
C
C   Solve the 2 by 2 system and update DGMAX.
C
        DET = A11*A22 - A12*A12
        IF (DET .EQ. 0.  .OR.  A11 .EQ. 0.) GO TO 12
        DG2 = (A11*R2 - A12*R1)/DET
        DG1 = (R1 - A12*DG2)/A11
        DGMX = MAX(DGMX,SQRT(DG1*DG1+DG2*DG2)/
     .             (1.+SQRT(G1*G1+G2*G2+G3*G3)))
C
C   Rotate (DG1,DG2,0) back to the original coordinate
C     system and update GRAD( ,K).
C
        CALL CSAPLYRT (DG1,DG2,CX,SX,CY,SY, DGK)
        GRAD(1,K) = G1 + DGK(1)
        GRAD(2,K) = G2 + DGK(2)
        GRAD(3,K) = G3 + DGK(3)
    3   CONTINUE
C
C   Increment ITER and test for convergence.
C
      ITER = ITER + 1
      IF (DGMX .GT. TOL) GO TO 1
C
C The method converged.
C
      NIT = ITER
      DGMAX = DGMX
      IER = 0
      RETURN
C
C The method failed to converge within NIT iterations.
C
    4 DGMAX = DGMX
      IER = 1
      RETURN
C
C Invalid input parameter.
C
   11 NIT = 0
      DGMAX = 0.
      IER = -1
      RETURN
C
C Node K and its neighbors are collinear.
C
   12 NIT = 0
      DGMAX = DGMX
      IER = -2
      RETURN
C
C Nodes K and J coincide.
C
   13 NIT = 0
      DGMAX = DGMX
      IER = -3
      RETURN
      END

      SUBROUTINE DSBGVX( JOBZ, RANGE, UPLO, N, KA, KB, AB, LDAB, BB,
     $                   LDBB, Q, LDQ, VL, VU, IL, IU, ABSTOL, M, W, Z,
     $                   LDZ, WORK, IWORK, IFAIL, INFO )
*
*  -- LAPACK driver routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          JOBZ, RANGE, UPLO
      INTEGER            IL, INFO, IU, KA, KB, LDAB, LDBB, LDQ, LDZ, M,
     $                   N
      DOUBLE PRECISION   ABSTOL, VL, VU
*     ..
*     .. Array Arguments ..
      INTEGER            IFAIL( * ), IWORK( * )
      DOUBLE PRECISION   AB( LDAB, * ), BB( LDBB, * ), Q( LDQ, * ),
     $                   W( * ), WORK( * ), Z( LDZ, * )
*     ..
*
*  Purpose
*  =======
*
*  DSBGVX computes selected eigenvalues, and optionally, eigenvectors
*  of a real generalized symmetric-definite banded eigenproblem, of
*  the form A*x=(lambda)*B*x.  Here A and B are assumed to be symmetric
*  and banded, and B is also positive definite.  Eigenvalues and
*  eigenvectors can be selected by specifying either all eigenvalues,
*  a range of values or a range of indices for the desired eigenvalues.
*
*  Arguments
*  =========
*
*  JOBZ    (input) CHARACTER*1
*          = 'N':  Compute eigenvalues only;
*          = 'V':  Compute eigenvalues and eigenvectors.
*
*  RANGE   (input) CHARACTER*1
*          = 'A': all eigenvalues will be found.
*          = 'V': all eigenvalues in the half-open interval (VL,VU]
*                 will be found.
*          = 'I': the IL-th through IU-th eigenvalues will be found.
*
*  UPLO    (input) CHARACTER*1
*          = 'U':  Upper triangles of A and B are stored;
*          = 'L':  Lower triangles of A and B are stored.
*
*  N       (input) INTEGER
*          The order of the matrices A and B.  N >= 0.
*
*  KA      (input) INTEGER
*          The number of superdiagonals of the matrix A if UPLO = 'U',
*          or the number of subdiagonals if UPLO = 'L'.  KA >= 0.
*
*  KB      (input) INTEGER
*          The number of superdiagonals of the matrix B if UPLO = 'U',
*          or the number of subdiagonals if UPLO = 'L'.  KB >= 0.
*
*  AB      (input/output) DOUBLE PRECISION array, dimension (LDAB, N)
*          On entry, the upper or lower triangle of the symmetric band
*          matrix A, stored in the first ka+1 rows of the array.  The
*          j-th column of A is stored in the j-th column of the array AB
*          as follows:
*          if UPLO = 'U', AB(ka+1+i-j,j) = A(i,j) for max(1,j-ka)<=i<=j;
*          if UPLO = 'L', AB(1+i-j,j)    = A(i,j) for j<=i<=min(n,j+ka).
*
*          On exit, the contents of AB are destroyed.
*
*  LDAB    (input) INTEGER
*          The leading dimension of the array AB.  LDAB >= KA+1.
*
*  BB      (input/output) DOUBLE PRECISION array, dimension (LDBB, N)
*          On entry, the upper or lower triangle of the symmetric band
*          matrix B, stored in the first kb+1 rows of the array.  The
*          j-th column of B is stored in the j-th column of the array BB
*          as follows:
*          if UPLO = 'U', BB(ka+1+i-j,j) = B(i,j) for max(1,j-kb)<=i<=j;
*          if UPLO = 'L', BB(1+i-j,j)    = B(i,j) for j<=i<=min(n,j+kb).
*
*          On exit, the factor S from the split Cholesky factorization
*          B = S**T*S, as returned by DPBSTF.
*
*  LDBB    (input) INTEGER
*          The leading dimension of the array BB.  LDBB >= KB+1.
*
*  Q       (output) DOUBLE PRECISION array, dimension (LDQ, N)
*          If JOBZ = 'V', the n-by-n matrix used in the reduction of
*          A*x = (lambda)*B*x to standard form, i.e. C*x = (lambda)*x,
*          and consequently C to tridiagonal form.
*          If JOBZ = 'N', the array Q is not referenced.
*
*  LDQ     (input) INTEGER
*          The leading dimension of the array Q.  If JOBZ = 'N',
*          LDQ >= 1. If JOBZ = 'V', LDQ >= max(1,N).
*
*  VL      (input) DOUBLE PRECISION
*  VU      (input) DOUBLE PRECISION
*          If RANGE='V', the lower and upper bounds of the interval to
*          be searched for eigenvalues. VL < VU.
*          Not referenced if RANGE = 'A' or 'I'.
*
*  IL      (input) INTEGER
*  IU      (input) INTEGER
*          If RANGE='I', the indices (in ascending order) of the
*          smallest and largest eigenvalues to be returned.
*          1 <= IL <= IU <= N, if N > 0; IL = 1 and IU = 0 if N = 0.
*          Not referenced if RANGE = 'A' or 'V'.
*
*  ABSTOL  (input) DOUBLE PRECISION
*          The absolute error tolerance for the eigenvalues.
*          An approximate eigenvalue is accepted as converged
*          when it is determined to lie in an interval [a,b]
*          of width less than or equal to
*
*                  ABSTOL + EPS *   max( |a|,|b| ) ,
*
*          where EPS is the machine precision.  If ABSTOL is less than
*          or equal to zero, then  EPS*|T|  will be used in its place,
*          where |T| is the 1-norm of the tridiagonal matrix obtained
*          by reducing A to tridiagonal form.
*
*          Eigenvalues will be computed most accurately when ABSTOL is
*          set to twice the underflow threshold 2*DLAMCH('S'), not zero.
*          If this routine returns with INFO>0, indicating that some
*          eigenvectors did not converge, try setting ABSTOL to
*          2*DLAMCH('S').
*
*  M       (output) INTEGER
*          The total number of eigenvalues found.  0 <= M <= N.
*          If RANGE = 'A', M = N, and if RANGE = 'I', M = IU-IL+1.
*
*  W       (output) DOUBLE PRECISION array, dimension (N)
*          If INFO = 0, the eigenvalues in ascending order.
*
*  Z       (output) DOUBLE PRECISION array, dimension (LDZ, N)
*          If JOBZ = 'V', then if INFO = 0, Z contains the matrix Z of
*          eigenvectors, with the i-th column of Z holding the
*          eigenvector associated with W(i).  The eigenvectors are
*          normalized so Z**T*B*Z = I.
*          If JOBZ = 'N', then Z is not referenced.
*
*  LDZ     (input) INTEGER
*          The leading dimension of the array Z.  LDZ >= 1, and if
*          JOBZ = 'V', LDZ >= max(1,N).
*
*  WORK    (workspace/output) DOUBLE PRECISION array, dimension (7N)
*
*  IWORK   (workspace/output) INTEGER array, dimension (5N)
*
*  IFAIL   (input) INTEGER array, dimension (M)
*          If JOBZ = 'V', then if INFO = 0, the first M elements of
*          IFAIL are zero.  If INFO > 0, then IFAIL contains the
*          indices of the eigenvalues that failed to converge.
*          If JOBZ = 'N', then IFAIL is not referenced.
*
*  INFO    (output) INTEGER
*          = 0 : successful exit
*          < 0 : if INFO = -i, the i-th argument had an illegal value
*          <= N: if INFO = i, then i eigenvectors failed to converge.
*                  Their indices are stored in IFAIL.
*          > N : DPBSTF returned an error code; i.e.,
*                if INFO = N + i, for 1 <= i <= N, then the leading
*                minor of order i of B is not positive definite.
*                The factorization of B could not be completed and
*                no eigenvalues or eigenvectors were computed.
*
*  Further Details
*  ===============
*
*  Based on contributions by
*     Mark Fahey, Department of Mathematics, Univ. of Kentucky, USA
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO, ONE
      PARAMETER          ( ZERO = 0.0D+0, ONE = 1.0D+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            ALLEIG, INDEIG, UPPER, VALEIG, WANTZ
      CHARACTER          ORDER, VECT
      INTEGER            I, IINFO, INDD, INDE, INDEE, INDIBL, INDISP,
     $                   INDIWO, INDWRK, ITMP1, J, JJ, NSPLIT
      DOUBLE PRECISION   TMP1
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           DCOPY, DGEMV, DLACPY, DPBSTF, DSBGST, DSBTRD,
     $                   DSTEBZ, DSTEIN, DSTEQR, DSTERF, DSWAP, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MIN
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      WANTZ = LSAME( JOBZ, 'V' )
      UPPER = LSAME( UPLO, 'U' )
      ALLEIG = LSAME( RANGE, 'A' )
      VALEIG = LSAME( RANGE, 'V' )
      INDEIG = LSAME( RANGE, 'I' )
*
      INFO = 0
      IF( .NOT.( WANTZ .OR. LSAME( JOBZ, 'N' ) ) ) THEN
         INFO = -1
      ELSE IF( .NOT.( ALLEIG .OR. VALEIG .OR. INDEIG ) ) THEN
         INFO = -2
      ELSE IF( .NOT.( UPPER .OR. LSAME( UPLO, 'L' ) ) ) THEN
         INFO = -3
      ELSE IF( N.LT.0 ) THEN
         INFO = -4
      ELSE IF( KA.LT.0 ) THEN
         INFO = -5
      ELSE IF( KB.LT.0 .OR. KB.GT.KA ) THEN
         INFO = -6
      ELSE IF( LDAB.LT.KA+1 ) THEN
         INFO = -8
      ELSE IF( LDBB.LT.KB+1 ) THEN
         INFO = -10
      ELSE IF( LDQ.LT.1 ) THEN
         INFO = -12
      ELSE IF( VALEIG .AND. N.GT.0 .AND. VU.LE.VL ) THEN
         INFO = -14
      ELSE IF( INDEIG .AND. IL.LT.1 ) THEN
         INFO = -15
      ELSE IF( INDEIG .AND. ( IU.LT.MIN( N, IL ) .OR. IU.GT.N ) ) THEN
         INFO = -16
      ELSE IF( LDZ.LT.1 .OR. ( WANTZ .AND. LDZ.LT.N ) ) THEN
         INFO = -21
      END IF
*
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DSBGVX', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      M = 0
      IF( N.EQ.0 ) THEN
         WORK( 1 ) = 1
         RETURN
      END IF
*
*     Form a split Cholesky factorization of B.
*
      CALL DPBSTF( UPLO, N, KB, BB, LDBB, INFO )
      IF( INFO.NE.0 ) THEN
         INFO = N + INFO
         RETURN
      END IF
*
*     Transform problem to standard eigenvalue problem.
*
      CALL DSBGST( JOBZ, UPLO, N, KA, KB, AB, LDAB, BB, LDBB, Q, LDQ,
     $             WORK, IINFO )
*
*     Reduce symmetric band matrix to tridiagonal form.
*
      INDD = 1
      INDE = INDD + N
      INDWRK = INDE + N
      IF( WANTZ ) THEN
         VECT = 'U'
      ELSE
         VECT = 'N'
      END IF
      CALL DSBTRD( VECT, UPLO, N, KA, AB, LDAB, WORK( INDD ),
     $             WORK( INDE ), Q, LDQ, WORK( INDWRK ), IINFO )
*
*     If all eigenvalues are desired and ABSTOL is less than or equal
*     to zero, then call DSTERF or SSTEQR.  If this fails for some
*     eigenvalue, then try DSTEBZ.
*
      IF( ( ALLEIG .OR. ( INDEIG .AND. IL.EQ.1 .AND. IU.EQ.N ) ) .AND.
     $    ( ABSTOL.LE.ZERO ) ) THEN
         CALL DCOPY( N, WORK( INDD ), 1, W, 1 )
         INDEE = INDWRK + 2*N
         CALL DCOPY( N-1, WORK( INDE ), 1, WORK( INDEE ), 1 )
         IF( .NOT.WANTZ ) THEN
            CALL DSTERF( N, W, WORK( INDEE ), INFO )
         ELSE
            CALL DLACPY( 'A', N, N, Q, LDQ, Z, LDZ )
            CALL DSTEQR( JOBZ, N, W, WORK( INDEE ), Z, LDZ,
     $                   WORK( INDWRK ), INFO )
            IF( INFO.EQ.0 ) THEN
               DO 10 I = 1, N
                  IFAIL( I ) = 0
   10          CONTINUE
            END IF
         END IF
         IF( INFO.EQ.0 ) THEN
            M = N
            GO TO 30
         END IF
         INFO = 0
      END IF
*
*     Otherwise, call DSTEBZ and, if eigenvectors are desired,
*     call DSTEIN.
*
      IF( WANTZ ) THEN
         ORDER = 'B'
      ELSE
         ORDER = 'E'
      END IF
      INDIBL = 1
      INDISP = INDIBL + N
      INDIWO = INDISP + N
      CALL DSTEBZ( RANGE, ORDER, N, VL, VU, IL, IU, ABSTOL,
     $             WORK( INDD ), WORK( INDE ), M, NSPLIT, W,
     $             IWORK( INDIBL ), IWORK( INDISP ), WORK( INDWRK ),
     $             IWORK( INDIWO ), INFO )
*
      IF( WANTZ ) THEN
         CALL DSTEIN( N, WORK( INDD ), WORK( INDE ), M, W,
     $                IWORK( INDIBL ), IWORK( INDISP ), Z, LDZ,
     $                WORK( INDWRK ), IWORK( INDIWO ), IFAIL, INFO )
*
*        Apply transformation matrix used in reduction to tridiagonal
*        form to eigenvectors returned by DSTEIN.
*
         DO 20 J = 1, M
            CALL DCOPY( N, Z( 1, J ), 1, WORK( 1 ), 1 )
            CALL DGEMV( 'N', N, N, ONE, Q, LDQ, WORK, 1, ZERO,
     $                  Z( 1, J ), 1 )
   20    CONTINUE
      END IF
*
   30 CONTINUE
*
*     If eigenvalues are not in order, then sort them, along with
*     eigenvectors.
*
      IF( WANTZ ) THEN
         DO 50 J = 1, M - 1
            I = 0
            TMP1 = W( J )
            DO 40 JJ = J + 1, M
               IF( W( JJ ).LT.TMP1 ) THEN
                  I = JJ
                  TMP1 = W( JJ )
               END IF
   40       CONTINUE
*
            IF( I.NE.0 ) THEN
               ITMP1 = IWORK( INDIBL+I-1 )
               W( I ) = W( J )
               IWORK( INDIBL+I-1 ) = IWORK( INDIBL+J-1 )
               W( J ) = TMP1
               IWORK( INDIBL+J-1 ) = ITMP1
               CALL DSWAP( N, Z( 1, I ), 1, Z( 1, J ), 1 )
               IF( INFO.NE.0 ) THEN
                  ITMP1 = IFAIL( I )
                  IFAIL( I ) = IFAIL( J )
                  IFAIL( J ) = ITMP1
               END IF
            END IF
   50    CONTINUE
      END IF
*
      RETURN
*
*     End of DSBGVX
*
      END

C NCLFORTSTART
      SUBROUTINE DWGTAREARMSE2(T,Q,WGT,MX,NY,TMSG,QMSG,IFLAG,RMSE)
      IMPLICIT NONE
      INTEGER MX,NY,IFLAG
      DOUBLE PRECISION T(MX,NY),Q(MX,NY),WGT(MX,NY)
      DOUBLE PRECISION TMSG,QMSG
      DOUBLE PRECISION RMSE
C NCLEND

C NCL: rmseTQ = wgt_AreaRmse2 (t,q,wgt,flag)

      INTEGER NL,ML,KMSG
      DOUBLE PRECISION SUMD,SUMW

C compute the weighted root-mean-square-difference [rmse]

C Nomenclature:
C INPUT:
C t      - 2D array
C q      - 2D array
C wgty   - 1D array of length "ny" [eg: cos(0.01745*lat) or gau_wgt(:)]
C wgtx   - 1D array of length "mx"
C mx     - 1st [faster varying] dimension of "t" [eg, longitude]
C ny     - 2nd [slower varying] dimension of "t" [eg, latitude ]
C tmsg   - msg value
C iflag  - flag
C          =0 compute  rmse ignoring msg values
C          =1 if any msg data is encountered return as msg
c OUTPUT:
C rmse   - root-mean-square-difference [weighted]

      SUMD = 0.0D0
      SUMW = 0.0D0
      KMSG = 0
      RMSE = TMSG

      DO NL = 1,NY
          DO ML = 1,MX
              IF (T(ML,NL).NE.TMSG .AND. Q(ML,NL).NE.QMSG) THEN
                  SUMD = SUMD + WGT(ML,NL)* (T(ML,NL)-Q(ML,NL))**2
                  SUMW = SUMW + WGT(ML,NL)
              ELSE
                  KMSG = KMSG + 1
              END IF
          END DO
c                                      return if user desired
          IF (IFLAG.EQ.1 .AND. KMSG.NE.0) RETURN
      END DO
c                          compute wgted differense
      IF (SUMW.NE.0.D0) THEN
          RMSE = SQRT(SUMD/SUMW)
      END IF

      RETURN
      END

      SUBROUTINE SHSEQR( JOB, COMPZ, N, ILO, IHI, H, LDH, WR, WI, Z,
     $                   LDZ, WORK, LWORK, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          COMPZ, JOB
      INTEGER            IHI, ILO, INFO, LDH, LDZ, LWORK, N
*     ..
*     .. Array Arguments ..
      REAL               H( LDH, * ), WI( * ), WORK( * ), WR( * ),
     $                   Z( LDZ, * )
*     ..
*
*  Purpose
*  =======
*
*  SHSEQR computes the eigenvalues of a real upper Hessenberg matrix H
*  and, optionally, the matrices T and Z from the Schur decomposition
*  H = Z T Z**T, where T is an upper quasi-triangular matrix (the Schur
*  form), and Z is the orthogonal matrix of Schur vectors.
*
*  Optionally Z may be postmultiplied into an input orthogonal matrix Q,
*  so that this routine can give the Schur factorization of a matrix A
*  which has been reduced to the Hessenberg form H by the orthogonal
*  matrix Q:  A = Q*H*Q**T = (QZ)*T*(QZ)**T.
*
*  Arguments
*  =========
*
*  JOB     (input) CHARACTER*1
*          = 'E':  compute eigenvalues only;
*          = 'S':  compute eigenvalues and the Schur form T.
*
*  COMPZ   (input) CHARACTER*1
*          = 'N':  no Schur vectors are computed;
*          = 'I':  Z is initialized to the unit matrix and the matrix Z
*                  of Schur vectors of H is returned;
*          = 'V':  Z must contain an orthogonal matrix Q on entry, and
*                  the product Q*Z is returned.
*
*  N       (input) INTEGER
*          The order of the matrix H.  N >= 0.
*
*  ILO     (input) INTEGER
*  IHI     (input) INTEGER
*          It is assumed that H is already upper triangular in rows
*          and columns 1:ILO-1 and IHI+1:N. ILO and IHI are normally
*          set by a previous call to SGEBAL, and then passed to SGEHRD
*          when the matrix output by SGEBAL is reduced to Hessenberg
*          form. Otherwise ILO and IHI should be set to 1 and N
*          respectively.
*          1 <= ILO <= IHI <= N, if N > 0; ILO=1 and IHI=0, if N=0.
*
*  H       (input/output) REAL array, dimension (LDH,N)
*          On entry, the upper Hessenberg matrix H.
*          On exit, if JOB = 'S', H contains the upper quasi-triangular
*          matrix T from the Schur decomposition (the Schur form);
*          2-by-2 diagonal blocks (corresponding to complex conjugate
*          pairs of eigenvalues) are returned in standard form, with
*          H(i,i) = H(i+1,i+1) and H(i+1,i)*H(i,i+1) < 0. If JOB = 'E',
*          the contents of H are unspecified on exit.
*
*  LDH     (input) INTEGER
*          The leading dimension of the array H. LDH >= max(1,N).
*
*  WR      (output) REAL array, dimension (N)
*  WI      (output) REAL array, dimension (N)
*          The real and imaginary parts, respectively, of the computed
*          eigenvalues. If two eigenvalues are computed as a complex
*          conjugate pair, they are stored in consecutive elements of
*          WR and WI, say the i-th and (i+1)th, with WI(i) > 0 and
*          WI(i+1) < 0. If JOB = 'S', the eigenvalues are stored in the
*          same order as on the diagonal of the Schur form returned in
*          H, with WR(i) = H(i,i) and, if H(i:i+1,i:i+1) is a 2-by-2
*          diagonal block, WI(i) = sqrt(H(i+1,i)*H(i,i+1)) and
*          WI(i+1) = -WI(i).
*
*  Z       (input/output) REAL array, dimension (LDZ,N)
*          If COMPZ = 'N': Z is not referenced.
*          If COMPZ = 'I': on entry, Z need not be set, and on exit, Z
*          contains the orthogonal matrix Z of the Schur vectors of H.
*          If COMPZ = 'V': on entry Z must contain an N-by-N matrix Q,
*          which is assumed to be equal to the unit matrix except for
*          the submatrix Z(ILO:IHI,ILO:IHI); on exit Z contains Q*Z.
*          Normally Q is the orthogonal matrix generated by SORGHR after
*          the call to SGEHRD which formed the Hessenberg matrix H.
*
*  LDZ     (input) INTEGER
*          The leading dimension of the array Z.
*          LDZ >= max(1,N) if COMPZ = 'I' or 'V'; LDZ >= 1 otherwise.
*
*  WORK    (workspace/output) REAL array, dimension (LWORK)
*          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*
*  LWORK   (input) INTEGER
*          The dimension of the array WORK.  LWORK >= max(1,N).
*
*          If LWORK = -1, then a workspace query is assumed; the routine
*          only calculates the optimal size of the WORK array, returns
*          this value as the first entry of the WORK array, and no error
*          message related to LWORK is issued by XERBLA.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*          > 0:  if INFO = i, SHSEQR failed to compute all of the
*                eigenvalues in a total of 30*(IHI-ILO+1) iterations;
*                elements 1:ilo-1 and i+1:n of WR and WI contain those
*                eigenvalues which have been successfully computed.
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ZERO, ONE, TWO
      PARAMETER          ( ZERO = 0.0E+0, ONE = 1.0E+0, TWO = 2.0E+0 )
      REAL               CONST
      PARAMETER          ( CONST = 1.5E+0 )
      INTEGER            NSMAX, LDS
      PARAMETER          ( NSMAX = 15, LDS = NSMAX )
*     ..
*     .. Local Scalars ..
      LOGICAL            INITZ, LQUERY, WANTT, WANTZ
      INTEGER            I, I1, I2, IERR, II, ITEMP, ITN, ITS, J, K, L,
     $                   MAXB, NH, NR, NS, NV
      REAL               ABSW, OVFL, SMLNUM, TAU, TEMP, TST1, ULP, UNFL
*     ..
*     .. Local Arrays ..
      REAL               S( LDS, NSMAX ), V( NSMAX+1 ), VV( NSMAX+1 )
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            ILAENV, ISAMAX
      REAL               SLAMCH, SLANHS, SLAPY2
      EXTERNAL           LSAME, ILAENV, ISAMAX, SLAMCH, SLANHS, SLAPY2
*     ..
*     .. External Subroutines ..
      EXTERNAL           SCOPY, SGEMV, SLABAD, SLACPY, SLAHQR, SLARFG,
     $                   SLARFX, SLASET, SSCAL, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, MAX, MIN
*     ..
*     .. Executable Statements ..
*
*     Decode and test the input parameters
*
      WANTT = LSAME( JOB, 'S' )
      INITZ = LSAME( COMPZ, 'I' )
      WANTZ = INITZ .OR. LSAME( COMPZ, 'V' )
*
      INFO = 0
      WORK( 1 ) = MAX( 1, N )
      LQUERY = ( LWORK.EQ.-1 )
      IF( .NOT.LSAME( JOB, 'E' ) .AND. .NOT.WANTT ) THEN
         INFO = -1
      ELSE IF( .NOT.LSAME( COMPZ, 'N' ) .AND. .NOT.WANTZ ) THEN
         INFO = -2
      ELSE IF( N.LT.0 ) THEN
         INFO = -3
      ELSE IF( ILO.LT.1 .OR. ILO.GT.MAX( 1, N ) ) THEN
         INFO = -4
      ELSE IF( IHI.LT.MIN( ILO, N ) .OR. IHI.GT.N ) THEN
         INFO = -5
      ELSE IF( LDH.LT.MAX( 1, N ) ) THEN
         INFO = -7
      ELSE IF( LDZ.LT.1 .OR. WANTZ .AND. LDZ.LT.MAX( 1, N ) ) THEN
         INFO = -11
      ELSE IF( LWORK.LT.MAX( 1, N ) .AND. .NOT.LQUERY ) THEN
         INFO = -13
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'SHSEQR', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         RETURN
      END IF
*
*     Initialize Z, if necessary
*
      IF( INITZ )
     $   CALL SLASET( 'Full', N, N, ZERO, ONE, Z, LDZ )
*
*     Store the eigenvalues isolated by SGEBAL.
*
      DO 10 I = 1, ILO - 1
         WR( I ) = H( I, I )
         WI( I ) = ZERO
   10 CONTINUE
      DO 20 I = IHI + 1, N
         WR( I ) = H( I, I )
         WI( I ) = ZERO
   20 CONTINUE
*
*     Quick return if possible.
*
      IF( N.EQ.0 )
     $   RETURN
      IF( ILO.EQ.IHI ) THEN
         WR( ILO ) = H( ILO, ILO )
         WI( ILO ) = ZERO
         RETURN
      END IF
*
*     Set rows and columns ILO to IHI to zero below the first
*     subdiagonal.
*
      DO 40 J = ILO, IHI - 2
         DO 30 I = J + 2, N
            H( I, J ) = ZERO
   30    CONTINUE
   40 CONTINUE
      NH = IHI - ILO + 1
*
*     Determine the order of the multi-shift QR algorithm to be used.
*
      NS = ILAENV( 4, 'SHSEQR', JOB // COMPZ, N, ILO, IHI, -1 )
      MAXB = ILAENV( 8, 'SHSEQR', JOB // COMPZ, N, ILO, IHI, -1 )
      IF( NS.LE.2 .OR. NS.GT.NH .OR. MAXB.GE.NH ) THEN
*
*        Use the standard double-shift algorithm
*
         CALL SLAHQR( WANTT, WANTZ, N, ILO, IHI, H, LDH, WR, WI, ILO,
     $                IHI, Z, LDZ, INFO )
         RETURN
      END IF
      MAXB = MAX( 3, MAXB )
      NS = MIN( NS, MAXB, NSMAX )
*
*     Now 2 < NS <= MAXB < NH.
*
*     Set machine-dependent constants for the stopping criterion.
*     If norm(H) <= sqrt(OVFL), overflow should not occur.
*
      UNFL = SLAMCH( 'Safe minimum' )
      OVFL = ONE / UNFL
      CALL SLABAD( UNFL, OVFL )
      ULP = SLAMCH( 'Precision' )
      SMLNUM = UNFL*( NH / ULP )
*
*     I1 and I2 are the indices of the first row and last column of H
*     to which transformations must be applied. If eigenvalues only are
*     being computed, I1 and I2 are set inside the main loop.
*
      IF( WANTT ) THEN
         I1 = 1
         I2 = N
      END IF
*
*     ITN is the total number of multiple-shift QR iterations allowed.
*
      ITN = 30*NH
*
*     The main loop begins here. I is the loop index and decreases from
*     IHI to ILO in steps of at most MAXB. Each iteration of the loop
*     works with the active submatrix in rows and columns L to I.
*     Eigenvalues I+1 to IHI have already converged. Either L = ILO or
*     H(L,L-1) is negligible so that the matrix splits.
*
      I = IHI
   50 CONTINUE
      L = ILO
      IF( I.LT.ILO )
     $   GO TO 170
*
*     Perform multiple-shift QR iterations on rows and columns ILO to I
*     until a submatrix of order at most MAXB splits off at the bottom
*     because a subdiagonal element has become negligible.
*
      DO 150 ITS = 0, ITN
*
*        Look for a single small subdiagonal element.
*
         DO 60 K = I, L + 1, -1
            TST1 = ABS( H( K-1, K-1 ) ) + ABS( H( K, K ) )
            IF( TST1.EQ.ZERO )
     $         TST1 = SLANHS( '1', I-L+1, H( L, L ), LDH, WORK )
            IF( ABS( H( K, K-1 ) ).LE.MAX( ULP*TST1, SMLNUM ) )
     $         GO TO 70
   60    CONTINUE
   70    CONTINUE
         L = K
         IF( L.GT.ILO ) THEN
*
*           H(L,L-1) is negligible.
*
            H( L, L-1 ) = ZERO
         END IF
*
*        Exit from loop if a submatrix of order <= MAXB has split off.
*
         IF( L.GE.I-MAXB+1 )
     $      GO TO 160
*
*        Now the active submatrix is in rows and columns L to I. If
*        eigenvalues only are being computed, only the active submatrix
*        need be transformed.
*
         IF( .NOT.WANTT ) THEN
            I1 = L
            I2 = I
         END IF
*
         IF( ITS.EQ.20 .OR. ITS.EQ.30 ) THEN
*
*           Exceptional shifts.
*
            DO 80 II = I - NS + 1, I
               WR( II ) = CONST*( ABS( H( II, II-1 ) )+
     $                    ABS( H( II, II ) ) )
               WI( II ) = ZERO
   80       CONTINUE
         ELSE
*
*           Use eigenvalues of trailing submatrix of order NS as shifts.
*
            CALL SLACPY( 'Full', NS, NS, H( I-NS+1, I-NS+1 ), LDH, S,
     $                   LDS )
            CALL SLAHQR( .FALSE., .FALSE., NS, 1, NS, S, LDS,
     $                   WR( I-NS+1 ), WI( I-NS+1 ), 1, NS, Z, LDZ,
     $                   IERR )
            IF( IERR.GT.0 ) THEN
*
*              If SLAHQR failed to compute all NS eigenvalues, use the
*              unconverged diagonal elements as the remaining shifts.
*
               DO 90 II = 1, IERR
                  WR( I-NS+II ) = S( II, II )
                  WI( I-NS+II ) = ZERO
   90          CONTINUE
            END IF
         END IF
*
*        Form the first column of (G-w(1)) (G-w(2)) . . . (G-w(ns))
*        where G is the Hessenberg submatrix H(L:I,L:I) and w is
*        the vector of shifts (stored in WR and WI). The result is
*        stored in the local array V.
*
         V( 1 ) = ONE
         DO 100 II = 2, NS + 1
            V( II ) = ZERO
  100    CONTINUE
         NV = 1
         DO 120 J = I - NS + 1, I
            IF( WI( J ).GE.ZERO ) THEN
               IF( WI( J ).EQ.ZERO ) THEN
*
*                 real shift
*
                  CALL SCOPY( NV+1, V, 1, VV, 1 )
                  CALL SGEMV( 'No transpose', NV+1, NV, ONE, H( L, L ),
     $                        LDH, VV, 1, -WR( J ), V, 1 )
                  NV = NV + 1
               ELSE IF( WI( J ).GT.ZERO ) THEN
*
*                 complex conjugate pair of shifts
*
                  CALL SCOPY( NV+1, V, 1, VV, 1 )
                  CALL SGEMV( 'No transpose', NV+1, NV, ONE, H( L, L ),
     $                        LDH, V, 1, -TWO*WR( J ), VV, 1 )
                  ITEMP = ISAMAX( NV+1, VV, 1 )
                  TEMP = ONE / MAX( ABS( VV( ITEMP ) ), SMLNUM )
                  CALL SSCAL( NV+1, TEMP, VV, 1 )
                  ABSW = SLAPY2( WR( J ), WI( J ) )
                  TEMP = ( TEMP*ABSW )*ABSW
                  CALL SGEMV( 'No transpose', NV+2, NV+1, ONE,
     $                        H( L, L ), LDH, VV, 1, TEMP, V, 1 )
                  NV = NV + 2
               END IF
*
*              Scale V(1:NV) so that max(abs(V(i))) = 1. If V is zero,
*              reset it to the unit vector.
*
               ITEMP = ISAMAX( NV, V, 1 )
               TEMP = ABS( V( ITEMP ) )
               IF( TEMP.EQ.ZERO ) THEN
                  V( 1 ) = ONE
                  DO 110 II = 2, NV
                     V( II ) = ZERO
  110             CONTINUE
               ELSE
                  TEMP = MAX( TEMP, SMLNUM )
                  CALL SSCAL( NV, ONE / TEMP, V, 1 )
               END IF
            END IF
  120    CONTINUE
*
*        Multiple-shift QR step
*
         DO 140 K = L, I - 1
*
*           The first iteration of this loop determines a reflection G
*           from the vector V and applies it from left and right to H,
*           thus creating a nonzero bulge below the subdiagonal.
*
*           Each subsequent iteration determines a reflection G to
*           restore the Hessenberg form in the (K-1)th column, and thus
*           chases the bulge one step toward the bottom of the active
*           submatrix. NR is the order of G.
*
            NR = MIN( NS+1, I-K+1 )
            IF( K.GT.L )
     $         CALL SCOPY( NR, H( K, K-1 ), 1, V, 1 )
            CALL SLARFG( NR, V( 1 ), V( 2 ), 1, TAU )
            IF( K.GT.L ) THEN
               H( K, K-1 ) = V( 1 )
               DO 130 II = K + 1, I
                  H( II, K-1 ) = ZERO
  130          CONTINUE
            END IF
            V( 1 ) = ONE
*
*           Apply G from the left to transform the rows of the matrix in
*           columns K to I2.
*
            CALL SLARFX( 'Left', NR, I2-K+1, V, TAU, H( K, K ), LDH,
     $                   WORK )
*
*           Apply G from the right to transform the columns of the
*           matrix in rows I1 to min(K+NR,I).
*
            CALL SLARFX( 'Right', MIN( K+NR, I )-I1+1, NR, V, TAU,
     $                   H( I1, K ), LDH, WORK )
*
            IF( WANTZ ) THEN
*
*              Accumulate transformations in the matrix Z
*
               CALL SLARFX( 'Right', NH, NR, V, TAU, Z( ILO, K ), LDZ,
     $                      WORK )
            END IF
  140    CONTINUE
*
  150 CONTINUE
*
*     Failure to converge in remaining number of iterations
*
      INFO = I
      RETURN
*
  160 CONTINUE
*
*     A submatrix of order <= MAXB in rows and columns L to I has split
*     off. Use the double-shift QR algorithm to handle it.
*
      CALL SLAHQR( WANTT, WANTZ, N, L, I, H, LDH, WR, WI, ILO, IHI, Z,
     $             LDZ, INFO )
      IF( INFO.GT.0 )
     $   RETURN
*
*     Decrement number of remaining iterations, and return to start of
*     the main loop with a new value of I.
*
      ITN = ITN - ITS
      I = L - 1
      GO TO 50
*
  170 CONTINUE
      WORK( 1 ) = MAX( 1, N )
      RETURN
*
*     End of SHSEQR
*
      END

C NCLFORTSTART
      subroutine gammacomplete (nx, xin, xout, has_msg, xmsg)
      implicit none
c                              INPUT
      integer  nx, has_msg
      double precision xin(nx), xmsg
c                              OUTPUT
      double precision xout(nx)
C NCLEND
C NCL: gma = gamma( x )
c WRAPIT -L $NCARG_ROOT/lib -l nfpfort gamma_interface.f 
c                              LOCAL
      integer n
      double precision dgammaslatec

      if(has_msg.eq.0) then
        do n=1,nx
          xout(n) = dgammaslatec ( xin(n) )
        end do
      else
        do n=1,nx
           if(xin(n) .ne. xmsg) then
              xout(n) = dgammaslatec ( xin(n) )
           else
              xout(n) = xmsg
           end if
        end do
      endif

      return
      end 

      SUBROUTINE ZDROT( N, CX, INCX, CY, INCY, C, S )
*
*     applies a plane rotation, where the cos and sin (c and s) are real
*     and the vectors cx and cy are complex.
*     jack dongarra, linpack, 3/11/78.
*
*     .. Scalar Arguments ..
      INTEGER            INCX, INCY, N
      DOUBLE PRECISION   C, S
*     ..
*     .. Array Arguments ..
      COMPLEX*16         CX( * ), CY( * )
*
* =====================================================================
*     ..
*     .. Local Scalars ..
      INTEGER            I, IX, IY
      COMPLEX*16         CTEMP
*     ..
*     .. Executable Statements ..
*
      IF( N.LE.0 )
     $   RETURN
      IF( INCX.EQ.1 .AND. INCY.EQ.1 )
     $   GO TO 20
*
*        code for unequal increments or equal increments not equal
*          to 1
*
      IX = 1
      IY = 1
      IF( INCX.LT.0 )
     $   IX = ( -N+1 )*INCX + 1
      IF( INCY.LT.0 )
     $   IY = ( -N+1 )*INCY + 1
      DO 10 I = 1, N
         CTEMP = C*CX( IX ) + S*CY( IY )
         CY( IY ) = C*CY( IY ) - S*CX( IX )
         CX( IX ) = CTEMP
         IX = IX + INCX
         IY = IY + INCY
   10 CONTINUE
      RETURN
*
*        code for both increments equal to 1
*
   20 CONTINUE
      DO 30 I = 1, N
         CTEMP = C*CX( I ) + S*CY( I )
         CY( I ) = C*CY( I ) - S*CX( I )
         CX( I ) = CTEMP
   30 CONTINUE
      RETURN
      END

C
C $Id: point.f,v 1.8 2008-07-27 00:17:25 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE POINT (PX,PY)
C
C Draws a point at (PX,PY), defined in the user coordinate system.
C What is actually drawn, for various reasons, is a little X.
C
      IF (ICFELL('POINT - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
      QX=CUFX(PX)
      IF (ICFELL('POINT',2).NE.0) RETURN
      QY=CUFY(PY)
      IF (ICFELL('POINT',3).NE.0) RETURN
      CALL PLOTIF (QX-.0005,QY-.0005,0)
      IF (ICFELL('POINT',4).NE.0) RETURN
      CALL PLOTIF (QX+.0005,QY+.0005,1)
      IF (ICFELL('POINT',5).NE.0) RETURN
      CALL PLOTIF (QX-.0005,QY+.0005,0)
      IF (ICFELL('POINT',6).NE.0) RETURN
      CALL PLOTIF (QX+.0005,QY-.0005,1)
      IF (ICFELL('POINT',7).NE.0) RETURN
      CALL PLOTIF (0.,0.,2)
      IF (ICFELL('POINT',8).NE.0) RETURN
      RETURN
      END

      SUBROUTINE DPHYBRID(P0,HYA,HYB,PSFC,MLON,NLAT,KLEV,PHY,PMSG)

c NCL: phy = pres_hybrid_ccm (psfc,p0,hya,hyb)

c this routine interploates ccm2/3 hybrid coordinate data
c     to pressure coordinates.

c     formula for the pressure of a hybrid surface is;
c          phy(k) = hya(k)*p0 + hyb(k)*psfc

c     input
c          hya    - is the "a" or pressure hybrid coef
c          hyb    - is the "b" or sigma coeficient
c          p0     - is the base pressure in pascals [Pa]
c          psfc   - is the surface pressure in pascals [Pa]
c          mlon   - longitude dimension
c          nlat   - latitude  dimension
c          klev   - number of levels
c     output
c          phy    - pressure at hybrid levels [Pa]

      IMPLICIT NONE
      INTEGER MLON,NLAT,KLEV
      DOUBLE PRECISION P0,HYA(KLEV),HYB(KLEV),PSFC(MLON,NLAT),PMSG

      DOUBLE PRECISION PHY(MLON,NLAT,KLEV)

      INTEGER KL,NL,ML
c f77
      DO KL = 1,KLEV
          DO NL = 1,NLAT
              DO ML = 1,MLON
                 IF (PSFC(ML,NL).NE.PMSG) then
                     PHY(ML,NL,KL) = HYA(KL)*P0 + HYB(KL)*PSFC(ML,NL)
                 ELSE
                     PHY(ML,NL,KL) = PMSG
                 END IF
              END DO
          END DO
      END DO

c f90 do kl=1,klev
c f90    phy(:,:,kl) = hya(kl)*p0 + hyb(kl)*psfc(:,:)
c f90 end do

      RETURN
      END

C NCLFORTSTART
      SUBROUTINE DDPHYBRID(P0,HYA,HYB,PSFC,MLON,NLAT,KLEV,DPHY,PMSG)
      IMPLICIT NONE

c input
      INTEGER MLON,NLAT,KLEV
      DOUBLE PRECISION P0,HYA(KLEV),HYB(KLEV),PSFC(MLON,NLAT),PMSG
c output
      DOUBLE PRECISION DPHY(MLON,NLAT,KLEV-1)
C NCLEND

c NCL: dphy = dpres_hybrid_ccm (ps,p0,hyai,hybi)
c Note: dphy will have one less vertical level

c this routine interploates ccm2/3 hybrid coordinate data
c     to pressure coordinates. then it computes

c     formula for the pressure of a hybrid surface is;
c          phy(k) = hya(k)*p0 + hyb(k)*psfc

c     input
c          hya    - is the "a" or pressure hybrid coef
c          hyb    - is the "b" or sigma coeficient
c          p0     - is the base pressure in pascals [Pa]
c          psfc   - is the surface pressure in pascals [Pa]
c          mlon   - longitude dimension
c          nlat   - latitude  dimension
c          klev   - number of levels
c     output
c          dphy    - delta pressure [Pa; always positive]

c local
      INTEGER KL,NL,ML
      DOUBLE PRECISION PA,PB

      DO NL = 1,NLAT
          DO ML = 1,MLON
              DO KL = 1,KLEV - 1
                 IF (PSFC(ML,NL).NE.PMSG) then
                     PA = P0*HYA(KL)   + HYB(KL)*PSFC(ML,NL)
                     PB = P0*HYA(KL+1) + HYB(KL+1)*PSFC(ML,NL)
                     DPHY(ML,NL,KL) = ABS(PB-PA)
c c c       dphy(ml,nl,kl) = abs((hya(kl+1)-hya(kl))*p0
c c c*                     -     (hyb(kl+1)-hya(kl))*psfc(ml,nl))
                 ELSE
                     DPHY(ML,NL,KL) = PMSG
                 END IF
              END DO
          END DO
      END DO

      RETURN
      END

C NCLFORTSTART
      DOUBLE PRECISION FUNCTION DFLXEDY(X,Y,NPTS,XMSG,IER)
      INTEGER NPTS,IER
      DOUBLE PRECISION X(NPTS),Y(NPTS),XMSG
C*PT*WARNING* Already double-precision
C NCLEND

c NCL: z = fluxEddy (x,y) ; "z" will be allocated by the NCL driver

c NCL Note to Dennis: we could expand the calling sequence as follows
c  double precision function flxedy (x,y,npts,xmsg,xave,yave,xpxp,ypyp,
c                                    cc,ntot,ier)
c   and then return "xave,yave,xpxp,ypyp,cc,ntot" as attributes of "z"
c   Too much memory if doing this over a grid ... attributes
c   can not be multiply dimensioned.

c Calculate time mean eddy flux quantities (eg, ave{v'T'})
c .   Method: xy = XY + x'y' where x and y are instantaneous values
c .                                X     Y are time means of x and y
c .           x'y' = xy-XY
C*PL*ERROR* Comment line too long
c Calculate the correlation coef between x'y' (add to arguments if desired)
c .            cc  = x'y'/sqrt(x'x' + y'y')

C Example:   double u(ntims,mlon,nlat,klev), v(ntims,mlon,nlat,klev)
c .          double upvp(mlon,nlat,klev)
c .          do kl=1,klev
c .           do nl=1,nlat
c .            do ml=1,mlon
c .               upvp(ml,nl,kl) =
c .               dflxedy (u(1,ml,nl,kl),v(1,ml,nl,kl),ntims,xmsg,ier)
c .            end do
c .           end do
c .          end do

c local stuff

      DOUBLE PRECISION XAVE,YAVE,XXAVE,YYAVE,XYAVE,XPYP,XPXP,YPYP,XN,CC
      INTEGER N,NTOT

      IER = 0
      IF (NPTS.LE.0) THEN
          IER = 1
          DFLXEDY = XMSG
          RETURN
      END IF

      NTOT = 0
C*PT*WARNING* Constant already double-precision
      XAVE = 0.d0
C*PT*WARNING* Constant already double-precision
      YAVE = 0.d0
C*PT*WARNING* Constant already double-precision
      XYAVE = 0.d0
C*PT*WARNING* Constant already double-precision
      XXAVE = 0.d0
C*PT*WARNING* Constant already double-precision
      YYAVE = 0.d0
      DO N = 1,NPTS
          IF (X(N).NE.XMSG .AND. Y(N).NE.XMSG) THEN
              NTOT = NTOT + 1
C*PT*WARNING* Already double-precision (DBLE)
              XAVE = XAVE + DBLE(X(N))
C*PT*WARNING* Already double-precision (DBLE)
              YAVE = YAVE + DBLE(Y(N))
C*PT*WARNING* DPROD found - result may be incorrect
              XYAVE = XYAVE + X(N)*Y(N)
C*PT*WARNING* DPROD found - result may be incorrect
              XXAVE = XXAVE + X(N)*X(N)
C*PT*WARNING* DPROD found - result may be incorrect
              YYAVE = YYAVE + Y(N)*Y(N)
          END IF
      END DO

      IF (NTOT.GT.0) THEN
C*PT*WARNING* Already double-precision (DBLE)
          XN = DBLE(DBLE(NTOT))
          XAVE = XAVE/XN
          YAVE = YAVE/XN
          XYAVE = XYAVE/XN
          XXAVE = XXAVE/XN
          YYAVE = YYAVE/XN
          XPYP = XYAVE - XAVE*YAVE
          XPXP = XXAVE - XAVE*XAVE
          YPYP = YYAVE - YAVE*YAVE
          CC = XPYP/DSQRT(XPXP*YPYP)
      ELSE
          XAVE = XMSG
          YAVE = XMSG
          XYAVE = XMSG
          XPYP = XMSG
          XPXP = XMSG
          YPYP = XMSG
          CC = XMSG
      END IF
C*PT*WARNING* Non-reversible tranformation (SNGL)

      DFLXEDY = XPYP

      RETURN
      END

C
C $Id: cpux.f,v 1.7 2008-07-27 00:17:23 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      FUNCTION CPUX (IX)
C
C Given an x coordinate IX in the plotter system, CPUX(IX) is an x
C coordinate in the user system.
C
      COMMON /IUTLCM/ LL,MI,MX,MY,IU(96)
      SAVE /IUTLCM/
      DIMENSION WD(4),VP(4)
      CALL GQCNTN (IE,NT)
      IF (IE.NE.0) THEN
        CALL SETER ('CPUX - ERROR EXIT FROM GQCNTN',1,1)
        CPUX=0.
        RETURN
      END IF
      CALL GQNT (NT,IE,WD,VP)
      IF (IE.NE.0) THEN
        CALL SETER ('CPUX - ERROR EXIT FROM GQNT',2,1)
        CPUX=0.
        RETURN
      END IF
      I=1
      IF (MI.GE.3) I=2
      CPUX=WD(I)+(REAL(IX-1)/(2.**MX-1.)-VP(1))/(VP(2)-VP(1))*
     +           (WD(3-I)-WD(I))
      IF (LL.GE.3) CPUX=10.**CPUX
      RETURN
      END

C
C	$Id: gqlvks.f,v 1.5 2008-07-27 00:20:59 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GQLVKS(ERRIND,LEVEL)
C
C  INQUIRE LEVEL OF GKS
C
      include 'gkscom.h'
C
      INTEGER ERRIND,LEVEL
C
C  Check if GKS is in the proper state.
C
      CALL GZCKST(8,-1,ERRIND)
      IF (ERRIND .EQ. 0) THEN
        LEVEL = 0
      ELSE
        LEVEL = -4
      ENDIF
C
      RETURN
      END

C
C This subroutine removes missing values before
C calling SPCORR. It keeps count of the missing
C values via NMSG. 
C
       SUBROUTINE SPCORRZ(X,Y,N,IWRITE,SPC,HASXMSG,XMSG,
     +                    HASYMSG,YMSG,NMSG)
C INPUT
       INTEGER N, IWRITE
       INTEGER HASXMSG, HASYMSG
       DOUBLE PRECISION X(N), Y(N), XMSG,YMSG
C OUTPUT
       DOUBLE PRECISION SPC
       INTEGER NMSG
C
C LOCAL
       INTEGER NN, K
       DOUBLE PRECISION XX(N), YY(N)

       IF(HASXMSG.EQ.0.AND.HASYMSG.EQ.0) THEN
          CALL SPCORR(X,Y,N,IWRITE,SPC)
          NMSG = 0
       ELSE
          NN   = 0
          DO K=1,N
             IF (.NOT.((HASXMSG.EQ.1.AND.X(K).EQ.XMSG) .OR. 
     +                 (HASYMSG.EQ.1.AND.Y(K).EQ.YMSG))) THEN
                NN = NN+1
                XX(NN) = X(K)
                YY(NN) = Y(K)
             END IF
          END DO
          IF (NN.GT.0) THEN
             CALL SPCORR(XX,YY,NN,IWRITE,SPC)
          END IF
          NMSG = N - NN
       END IF
       RETURN
       END
C NCLFORTSTART
      SUBROUTINE SPCORR(X,Y,N,IWRITE,SPC)
C                                                  INPUT
      INTEGER N, IWRITE
      DOUBLE PRECISION X(N), Y(N)
C                                                  OUTPUT
      DOUBLE PRECISION SPC
C NCLEND
C
C     PURPOSE--THIS SUBROUTINE COMPUTES THE
C              SPEARMAN RANK CORRELATION COEFFICIENT
C              BETWEEN THE 2 SETS OF DATA IN THE INPUT VECTORS X AND Y.
C              THE SPEARMAN RANK CORRELATION COEFFICIENT WILL BE A
C              SINGLE PRECISION VALUE BETWEEN -1.0 AND 1.0
C              (INCLUSIVELY).
C     INPUT  ARGUMENTS--X      = THE SINGLE PRECISION VECTOR OF
C                                (UNSORTED OR SORTED) OBSERVATIONS
C                                WHICH CONSTITUTE THE FIRST SET
C                                OF DATA.
C                     --Y      = THE SINGLE PRECISION VECTOR OF
C                                (UNSORTED OR SORTED) OBSERVATIONS
C                                WHICH CONSTITUTE THE SECOND SET
C                                OF DATA.
C                     --N      = THE INTEGER NUMBER OF OBSERVATIONS
C                                IN THE VECTOR X, OR EQUIVALENTLY,
C                                THE INTEGER NUMBER OF OBSERVATIONS
C                                IN THE VECTOR Y.
C                     --IWRITE = AN INTEGER FLAG CODE WHICH
C                                (IF SET TO 0) WILL SUPPRESS
C                                THE PRINTING OF THE
C                                SPEARMAN RANK CORRELATION COEFFICIENT
C                                AS IT IS COMPUTED;
C                                OR (IF SET TO SOME INTEGER
C                                VALUE NOT EQUAL TO 0),
C                                LIKE, SAY, 1) WILL CAUSE
C                                THE PRINTING OF THE
C                                SPEARMAN CORRELATION COEFFICIENT
C                                AT THE TIME IT IS COMPUTED.
C     OUTPUT ARGUMENTS--SPC    = THE SINGLE PRECISION VALUE OF THE
C                                COMPUTED SPEARMAN RANK CORRELATION
C                                COEFFICIENT BETWEEN THE 2 SETS OF DATA
C                                IN THE INPUT VECTORS X AND Y.
C                                THIS SINGLE PRECISION VALUE
C                                WILL BE BETWEEN -1.0 AND 1.0
C                                (INCLUSIVELY).
C     OUTPUT--THE COMPUTED SINGLE PRECISION VALUE OF THE
C             SPEARMAN RANK CORRELATION COEFFICIENT BETWEEN THE 2 SETS
C             OF DATA IN THE INPUT VECTORS X AND Y.
C     PRINTING--NONE, UNLESS IWRITE HAS BEEN SET TO A NON-ZERO
C               INTEGER, OR UNLESS AN INPUT ARGUMENT ERROR
C               CONDITION EXISTS.
C     RESTRICTIONS--THE MAXIMUM ALLOWABLE VALUE OF N
C                   FOR THIS SUBROUTINE IS 7500.
C     OTHER DATAPAC   SUBROUTINES NEEDED--RANK AND SORT.
C     FORTRAN LIBRARY SUBROUTINES NEEDED--NONE.
C     MODE OF INTERNAL OPERATIONS--SINGLE PRECISION.
C     LANGUAGE--ANSI FORTRAN.
C     REFERENCES--KENDALL AND STUART, THE ADVANCED THEORY OF
C                 STATISTICS, VOLUME 2, EDITION 1, 1961, PAGES 476-477.
C               --SNEDECOR AND COCHRAN, STATISTICAL METHODS,
C                 EDITION 6, 1967, PAGES 193-195.
C               --DIXON AND MASSEY, INTRODUCTION TO STATISTICAL
C                 ANALYSIS, EDITION 2, 1957, PAGES 294-295.
C               --MOOD AND GRABLE, 'INTRODUCTION TO THE THEORY
C                 OF STATISTICS, EDITION 2, 1963, PAGE 424.
C     WRITTEN BY--JAMES J. FILLIBEN
C                 STATISTICAL ENGINEERING LABORATORY (205.03)
C                 NATIONAL BUREAU OF STANDARDS
C                 WASHINGTON, D. C. 20234
C                 PHONE:  301-921-2315
C     ORIGINAL VERSION--JUNE      1972.
C     UPDATED         --OCTOBER   1974.
C     UPDATED         --JANUARY   1975.
C     UPDATED         --SEPTEMBER 1975.
C     UPDATED         --NOVEMBER  1975.
C     UPDATED         --FEBRUARY  1976.
C
C---------------------------------------------------------------------
C
      DOUBLE PRECISION XR(N), YR(N)
      DOUBLE PRECISION AN
      DOUBLE PRECISION HOLD
      DOUBLE PRECISION SUM
C
      IPR = 6
C
C     CHECK THE INPUT ARGUMENTS FOR ERRORS
C
      AN  = N
      SPC = 0.0D0
      IFLAG = 0
      IF (N.EQ.1) GO TO 55
      HOLD = X(1)
      DO I = 2,N
          IF (X(I).NE.HOLD) GO TO 65
      END DO   
c c   WRITE (IPR,FMT=9) HOLD
      IFLAG = 1
   65 HOLD = Y(1)
      DO I = 2,N
          IF (Y(I).NE.HOLD) GO TO 80
      END DO   

c c c WRITE (IPR,FMT=19) HOLD
      IFLAG = 1
   80 IF (IFLAG.EQ.1) RETURN
      GO TO 90
c c50 WRITE (IPR,FMT=27) IUPPER
c c   WRITE (IPR,FMT=47) N
c c   RETURN
   55 CONTINUE  
c c   WRITE (IPR,FMT=28)
      RETURN
   90 CONTINUE
c c 9 FORMAT (1H ,
c c  +108H***** NON-FATAL DIAGNOSTIC--THE FIRST  INPUT ARGUMENT (A VECTO
c c  +R) TO THE SPCORR SUBROUTINE HAS ALL ELEMENTS =,D15.8,6H *****)
c c19 FORMAT (1H ,
c c  +108H***** NON-FATAL DIAGNOSTIC--THE SECOND INPUT ARGUMENT (A VECTO
c c  +R) TO THE SPCORR SUBROUTINE HAS ALL ELEMENTS =,D15.8,6H *****)
c c27 FORMAT (' ***** FATAL ERROR--THE THIRD  INPUT ARGUMENT TO THE SP',
c c  + 'CORR SUBROUTINE IS OUTSIDE THE ALLOWABLE (1,,I6,16H) INTERVAL *'
c c  +       ,'****')
c c28 FORMAT (1H ,
c c  +100H***** NON-FATAL DIAGNOSTIC--THE THIRD  INPUT ARGUMENT TO THE S
c c  +PCORR SUBROUTINE HAS THE VALUE 1 *****)
c c47 FORMAT (1H ,35H***** THE VALUE OF THE ARGUMENT IS ,I8,6H *****)
C
C-----START POINT-----------------------------------------------------
C
      CALL SPRANK(X,N,XR)
      CALL SPRANK(Y,N,YR)
 
      SUM = 0.0D0
      DO I = 1,N
          SUM = SUM + (XR(I)-YR(I))**2
      END DO  
      SPC = 1.0D0 - (6.0D0*SUM/ ((AN-1.0D0)*AN* (AN+1.0D0)))
C
c c   IF (IWRITE.NE.0) WRITE (IPR,FMT=105) N,SPC
c c05 FORMAT (1H ,
c c  +    59HTHE SPEARMAN RANK CORRELATION COEFFICIENT OF THE 2 SETS OF
c c  +       ,I6,17H OBSERVATIONS IS ,F14.5)
      RETURN
      END
C
      SUBROUTINE SPRANK(X,N,XR)
      INTEGER N
      DOUBLE PRECISION X(N), XR(N)
C  http://www.itl.nist.gov/div898/software/datapac/RANK.f
C
C     PURPOSE--THIS SUBROUTINE RANKS (IN ASCENDING ORDER)
C              THE N ELEMENTS OF THE SINGLE PRECISION VECTOR X,
C              AND PUTS THE RESULTING N RANKS INTO THE
C              SINGLE PRECISION VECTOR XR.
C              THIS SUBROUTINE GIVES THE DATA ANALYST
C              THE ABILITY TO (FOR EXAMPLE) RANK THE DATA
C              PRELIMINARY TO CERTAIN DISTRIBUTION-FREE
C              ANALYSES.
C     INPUT  ARGUMENTS--X      = THE SINGLE PRECISION VECTOR OF
C                                OBSERVATIONS TO BE RANKED.
C                     --N      = THE INTEGER NUMBER OF OBSERVATIONS
C                                IN THE VECTOR X.
C     OUTPUT ARGUMENTS--XR     = THE SINGLE PRECISION VECTOR
C                                INTO WHICH THE RANKS
C                                FROM X WILL BE PLACED.
C     OUTPUT--THE SINGLE PRECISION VECTOR XR
C             CONTAINING THE RANKS
C             (IN ASCENDING ORDER)
C             OF THE VALUES
C             IN THE SINGLE PRECISION VECTOR X.
C     PRINTING--NONE UNLESS AN INPUT ARGUMENT ERROR CONDITION EXISTS.
C     RESTRICTIONS--THE MAXIMUM ALLOWABLE VALUE OF N
C                   FOR THIS SUBROUTINE IS 7500.
C     OTHER DATAPAC   SUBROUTINES NEEDED--SORT.
C     FORTRAN LIBRARY SUBROUTINES NEEDED--NONE.
C     MODE OF INTERNAL OPERATIONS--SINGLE PRECISION.
C     LANGUAGE--ANSI FORTRAN.
C     COMMENT--THE RANK OF THE FIRST ELEMENT
C              OF THE VECTOR X
C              WILL BE PLACED IN THE FIRST POSITION
C              OF THE VECTOR XR,
C              THE RANK OF THE SECOND ELEMENT
C              OF THE VECTOR X
C              WILL BE PLACED IN THE SECOND POSITION
C              OF THE VECTOR XR,
C              ETC.
C     COMMENT--THE SMALLEST ELEMENT IN THE VECTOR X
C              WILL HAVE A RANK OF 1 (UNLESS TIES EXIST).
C              THE LARGEST ELEMENT IN THE VECTOR X
C              WILL HAVE A RANK OF N (UNLESS TIES EXIST).
C     COMMENT--ALTHOUGH RANKS ARE USUALLY (UNLESS TIES EXIST)
C              INTEGRAL VALUES FROM 1 TO N, IT IS TO BE
C              NOTED THAT THEY ARE OUTPUTED AS SINGLE
C              PRECISION INTEGERS IN THE SINGLE PRECISION
C              VECTOR XR.
C              XR IS SINGLE PRECISION SO AS TO BE
C              CONSISTENT WITH THE FACT THAT ALL
C              VECTOR ARGUMENTS IN ALL OTHER
C              DATAPAC SUBROUTINES ARE SINGLE PRECISION;
C              BUT MORE IMPORTANTLY, BECAUSE TIES FREQUENTLY
C              DO EXIST IN DATA SETS AND SO SOME OF THE
C              RESULTING RANKS WILL BE NON-INTEGRAL
C              AND SO THE OUTPUT VECTOR OF RANKS MUST NECESSARILY
C              BE SINGLE PRECISION AND NOT INTEGER.
C     COMMENT--THE INPUT VECTOR X REMAINS UNALTERED.
C     COMMENT--DUE TO CONFLICTING USE OF LABELED
C              COMMON /BLOCK2/ BY THIS RANK
C              SUBROUTINE AND THE SPCORR (SPEARMAN RANK
C              CORRELATION COEFFICIENT) SUBROUTINE,
C              THE VECTOR XS OF THIS RANK
C              SUBROUTINE HAS BEEN PLACED IN
C              LABELED COMMON /BLOCK4/
C     COMMENT--THE FIRST AND THIRD ARGUMENTS IN THE
C              CALLING SEQUENCE MAY
C              BE IDENTICAL; THAT IS, AN 'IN PLACE'
C              RANKING IS PERMITTED.
C              THE CALLING SEQUENCE
C              CALL RANK(X,N,X) IS VALID, IF DESIRED.
C     COMMENT--THE SORTING ALGORTHM USED HEREIN
C              IS THE BINARY SORT.
C              THIS ALGORTHIM IS EXTREMELY FAST AS THE
C              FOLLOWING TIME TRIALS INDICATE.
C              THESE TIME TRIALS WERE CARRIED OUT ON THE
C              UNIVAC 1108 EXEC 8 SYSTEM AT NBS
C              IN AUGUST OF 1974.
C              BY WAY OF COMPARISON, THE TIME TRIAL VALUES
C              FOR THE EASY-TO-PROGRAM BUT EXTREMELY
C              INEFFICIENT BUBBLE SORT ALGORITHM HAVE
C              ALSO BEEN INCLUDED--
C              NUMBER OF RANDOM        BINARY SORT       BUBBLE SORT
C               NUMBERS SORTED
C                N = 10                 .002 SEC          .002 SEC
C                N = 100                .011 SEC          .045 SEC
C                N = 1000               .141 SEC         4.332 SEC
C                N = 3000               .476 SEC        37.683 SEC
C                N = 10000             1.887 SEC      NOT COMPUTED
C     REFERENCES--CACM MARCH 1969, PAGE 186 (BINARY SORT ALGORITHM
C                 BY RICHARD C. SINGLETON).
C               --CACM JANUARY 1970, PAGE 54.
C               --CACM OCTOBER 1970, PAGE 624.
C               --JACM JANUARY 1961, PAGE 41.
C     WRITTEN BY--JAMES J. FILLIBEN
C                 STATISTICAL ENGINEERING LABORATORY (205.03)
C                 NATIONAL BUREAU OF STANDARDS
C                 WASHINGTON, D. C. 20234
C                 PHONE--301-921-2315
C     ORIGINAL VERSION--JUNE      1972.
C     UPDATED         --JANUARY   1975.
C     UPDATED         --NOVEMBER  1975.
C     UPDATED         --JANUARY   1977.
C
C---------------------------------------------------------------------
C
      DOUBLE PRECISION XS(N)
      DOUBLE PRECISION AN
      DOUBLE PRECISION HOLD
      DOUBLE PRECISION AVRANK
      DOUBLE PRECISION XPREV
      DOUBLE PRECISION RPREV
C
      AN = N
      IPR = 6
C
C     CHECK THE INPUT ARGUMENTS FOR ERRORS
C
      IF (N.EQ.1) GO TO 55
      HOLD = X(1)
      DO I = 2,N
          IF (X(I).NE.HOLD) GO TO 90
      END DO   

c c   WRITE (IPR,FMT=9) HOLD
      AVRANK = (AN+1.0D0)/2.0D0
      DO I = 1,N
          XR(I) = AVRANK
      END DO   
      RETURN

   50 CONTINUE
c c   WRITE (IPR,FMT=17) IUPPER
c c   WRITE (IPR,FMT=47) N
      RETURN
   55 CONTINUE
c c   WRITE (IPR,FMT=18)
      XR(1) = 1.0D0
      RETURN

   90 CONTINUE
c c 9 FORMAT (1H ,
c c  +109H***** NON-FATAL DIAGNOSTIC--THE FIRST  INPUT ARGUMENT (A VECTO
c c  +R) TO THE RANK   SUBROUTINE HAS ALL ELEMENTS = ,D15.8,6H *****)
c c17 FORMAT (1H ,
c c  +98H***** FATAL ERROR--THE SECOND INPUT ARGUMENT TO THE RANK   SUBR
c c  +OUTINE IS OUTSIDE THE ALLOWABLE (1,,I6,16H) INTERVAL *****)
c c18 FORMAT (1H ,
c c  +100H***** NON-FATAL DIAGNOSTIC--THE SECOND INPUT ARGUMENT TO THE R
c c  +ANK   SUBROUTINE HAS THE VALUE 1 *****)
c c47 FORMAT (1H ,35H***** THE VALUE OF THE ARGUMENT IS ,I8,6H *****)
C
C-----START POINT-----------------------------------------------------
C
C     FIRST SORT THE DATA FROM THE INPUT VECTOR X
C     INTO THE INTERMEDIATE STORAGE VECTOR XS.
C
      CALL SPSORT(X,N,XS)
C
C     NOW DETERMINE THE RANKS.
C     THE BASIC ALGORITHM IS TO TAKE A GIVEN ELEMENT
C     IN THE ORIGINAL INPUT VECTOR X,
C     AND SCAN THE SORTED VALUES IN THE XS VECTOR
C     UNTIL A MATCH IS FOUND;
C     WHEN A MATCH IS FOUND, THEN THE RANK FOR THAT
C     VALUE IN THE XS VECTOR IS DETERMINED.
C     THAT RANK IS THEN WRITTEN INTO THAT POSITION
C     IN THE OUTPUT Y VECTOR WHICH CORRESPONDS TO THE POSITION OF THE
C     GIVEN ELEMENT OF INTEREST IN THE ORIGINAL X VECTOR.
C     THE CODE IS LENGTHENED FROM THIS BASIC ALGORITHM
C     BY A SECTION WHICH CUTS DOWN THE SEARCH IN THE XS VECTOR,
C     AND BY A SECTION WHICH OBVIATES (UNDER CERTAIN CIRCUMSTANCES)
C     THE NEED FOR RECALCULATING THE RANK OF AN ELEMENT IN XS.
C
      NM1 = N - 1
      XPREV = X(1)
      DO I = 1,N
          JMIN = 1
          IF (X(I).GT.XPREV) GO TO 770
          IF (I.EQ.1) GO TO 790
          IF (X(I).EQ.XPREV) GO TO 750
          GO TO 790
  750     CONTINUE
          XR(I) = RPREV
          GO TO 880
  770     CONTINUE
          JMIN = K
          IF (JMIN.LT.N) GO TO 790
          IF (JMIN.EQ.N) GO TO 820
          IBRAN = 1
c c       WRITE (IPR,FMT=109) IBRAN
c c       WRITE (IPR,FMT=101) JMIN
c 109     FORMAT (1H ,40H*****INTERNAL ERROR IN RANK SUBROUTINE--,
c c  +           46HIMPOSSIBLE BRANCH CONDITION AT BRANCH POINT = ,I8)
c 101     FORMAT (1H ,'JMIN = ',I8)
          STOP
  790     CONTINUE
          DO 800 J = JMIN,NM1
              IF (X(I).NE.XS(J)) GO TO 800
              JP1 = J + 1
              DO K = JP1,N
                  IF (XS(K).NE.XS(J)) GO TO 950
              END DO   
              K = N + 1
  950         CONTINUE
              AVRANK = J + K - 1
              AVRANK = AVRANK/2.0D0
              XR(I) = AVRANK
              GO TO 880
  800     CONTINUE 
  820     CONTINUE
          J = N
          K = N + 1
          IF (X(I).EQ.XS(J)) GO TO 850
          IBRAN = 2
c c       WRITE (IPR,FMT=109) IBRAN
c c       WRITE (IPR,FMT=102) X(I),XS(J)
c 102     FORMAT (1H ,'X(I) = ',F15.7,'   XS(J) = ',F15.7)
          STOP
  850     CONTINUE
          XR(I) = N
  880     CONTINUE
          XPREV = X(I)
          RPREV = XR(I)
      END DO   
C
      RETURN
      END
c ======================================================
 
 
      SUBROUTINE SPSORT(X, N, Y)
      INTEGER N
      DOUBLE PRECISION  X(N), Y(N)

C
C     PURPOSE--THIS SUBROUTINE SORTS (IN ASCENDING ORDER)
C              THE N ELEMENTS OF THE SINGLE PRECISION VECTOR X
C              AND PUTS THE RESULTING N SORTED VALUES INTO THE
C              SINGLE PRECISION VECTOR Y.
C     INPUT  ARGUMENTS--X      = THE SINGLE PRECISION VECTOR OF
C                                OBSERVATIONS TO BE SORTED.
C                     --N      = THE INTEGER NUMBER OF OBSERVATIONS
C                                IN THE VECTOR X.
C     OUTPUT ARGUMENTS--Y      = THE SINGLE PRECISION VECTOR
C                                INTO WHICH THE SORTED DATA VALUES
C                                FROM X WILL BE PLACED.
C     OUTPUT--THE SINGLE PRECISION VECTOR Y
C             CONTAINING THE SORTED
C             (IN ASCENDING ORDER) VALUES
C             OF THE SINGLE PRECISION VECTOR X.
C     PRINTING--NONE UNLESS AN INPUT ARGUMENT ERROR CONDITION EXISTS.
C     RESTRICTIONS--THE DIMENSIONS OF THE VECTORS IL AND IU
C                   (DEFINED AND USED INTERNALLY WITHIN
C                   THIS SUBROUTINE) DICTATE THE MAXIMUM
C                   ALLOWABLE VALUE OF N FOR THIS SUBROUTINE.
C                   IF IL AND IU EACH HAVE DIMENSION K,
C                   THEN N MAY NOT EXCEED 2**(K+1) - 1.
C                   FOR THIS SUBROUTINE AS WRITTEN, THE DIMENSIONS
C                   OF IL AND IU HAVE BEEN SET TO 36,
C                   THUS THE MAXIMUM ALLOWABLE VALUE OF N IS
C                   APPROXIMATELY 137 BILLION.
C                   SINCE THIS EXCEEDS THE MAXIMUM ALLOWABLE
C                   VALUE FOR AN INTEGER VARIABLE IN MANY COMPUTERS,
C                   AND SINCE A SORT OF 137 BILLION ELEMENTS
C                   IS PRESENTLY IMPRACTICAL AND UNLIKELY,
C                   THEN THERE IS NO PRACTICAL RESTRICTION
C                   ON THE MAXIMUM VALUE OF N FOR THIS SUBROUTINE.
C                   (IN LIGHT OF THE ABOVE, NO CHECK OF THE
C                   UPPER LIMIT OF N HAS BEEN INCORPORATED
C                   INTO THIS SUBROUTINE.)
C     OTHER DATAPAC   SUBROUTINES NEEDED--NONE.
C     FORTRAN LIBRARY SUBROUTINES NEEDED--NONE.
C     MODE OF INTERNAL OPERATIONS--SINGLE PRECISION.
C     LANGUAGE--ANSI FORTRAN.
C     COMMENT--THE SMALLEST ELEMENT OF THE VECTOR X
C              WILL BE PLACED IN THE FIRST POSITION
C              OF THE VECTOR Y,
C              THE SECOND SMALLEST ELEMENT IN THE VECTOR X
C              WILL BE PLACED IN THE SECOND POSITION
C              OF THE VECTOR Y, ETC.
C     COMMENT--THE INPUT VECTOR X REMAINS UNALTERED.
C     COMMENT--IF THE ANALYST DESIRES A SORT 'IN PLACE',
C              THIS IS DONE BY HAVING THE SAME
C              OUTPUT VECTOR AS INPUT VECTOR IN THE CALLING SEQUENCE.
C              THUS, FOR EXAMPLE, THE CALLING SEQUENCE
C              CALL SORT(X,N,X)
C              IS ALLOWABLE AND WILL RESULT IN
C              THE DESIRED 'IN-PLACE' SORT.
C     COMMENT--THE SORTING ALGORTHM USED HEREIN
C              IS THE BINARY SORT.
C              THIS ALGORTHIM IS EXTREMELY FAST AS THE
C              FOLLOWING TIME TRIALS INDICATE.
C              THESE TIME TRIALS WERE CARRIED OUT ON THE
C              UNIVAC 1108 EXEC 8 SYSTEM AT NBS
C              IN AUGUST OF 1974.
C              BY WAY OF COMPARISON, THE TIME TRIAL VALUES
C              FOR THE EASY-TO-PROGRAM BUT EXTREMELY
C              INEFFICIENT BUBBLE SORT ALGORITHM HAVE
C              ALSO BEEN INCLUDED--
C              NUMBER OF RANDOM        BINARY SORT       BUBBLE SORT
C               NUMBERS SORTED
C                N = 10                 .002 SEC          .002 SEC
C                N = 100                .011 SEC          .045 SEC
C                N = 1000               .141 SEC         4.332 SEC
C                N = 3000               .476 SEC        37.683 SEC
C                N = 10000             1.887 SEC      NOT COMPUTED
C     REFERENCES--CACM MARCH 1969, PAGE 186 (BINARY SORT ALGORITHM
C                 BY RICHARD C. SINGLETON).
C               --CACM JANUARY 1970, PAGE 54.
C               --CACM OCTOBER 1970, PAGE 624.
C               --JACM JANUARY 1961, PAGE 41.
C     WRITTEN BY--JAMES J. FILLIBEN
C                 STATISTICAL ENGINEERING LABORATORY (205.03)
C                 NATIONAL BUREAU OF STANDARDS
C                 WASHINGTON, D. C. 20234
C                 PHONE--301-921-2315
C     ORIGINAL VERSION--JUNE      1972.
C     UPDATED         --NOVEMBER  1975.
C
C---------------------------------------------------------------------
C
      DOUBLE PRECISION  HOLD
      DOUBLE PRECISION  AMED
      DOUBLE PRECISION  TT
      INTEGER  IU(36), IL(36)
C
      IPR = 6
C
C     CHECK THE INPUT ARGUMENTS FOR ERRORS
C
      IF (N .GE. 1) THEN
         IF (N .EQ. 1) GO TO 55
         HOLD = X(1)
         DO I = 2, N
            IF (X(I) .NE. HOLD) GO TO 90
         END DO
c c      WRITE (IPR, FMT=9) HOLD
         DO I = 1, N
            Y(I) = X(I)
         END DO
         RETURN 
      ENDIF
c c   WRITE (IPR, FMT=15)
c c   WRITE (IPR, FMT=47) N
      RETURN 
   55 CONTINUE
c c   WRITE (IPR, FMT=18)
      Y(1) = X(1)
      RETURN 
   90 CONTINUE
c c 9 FORMAT(1H ,
c c  1108H***** NON-FATAL DIAGNOSTIC--THE FIRST  INPUT ARGUMENT (A VECTO
c c  2R) TO THE SORT   SUBROUTINE HAS ALL ELEMENTS =,D15.8,6H *****)
c c15 FORMAT(1H ,
c c  191H***** FATAL ERROR--THE SECOND INPUT ARGUMENT TO THE SORT   SUBR
c c  2OUTINE IS NON-POSITIVE *****)
c c18 FORMAT(1H ,
c c  1100H***** NON-FATAL DIAGNOSTIC--THE SECOND INPUT ARGUMENT TO THE S
c c  2ORT   SUBROUTINE HAS THE VALUE 1 *****)
c c47 FORMAT(1H ,35H***** THE VALUE OF THE ARGUMENT IS ,I8,6H *****)
C
C-----START POINT-----------------------------------------------------
C
C     COPY THE VECTOR X INTO THE VECTOR Y
      DO I = 1, N
         Y(I) = X(I)
      END DO
C
C     CHECK TO SEE IF THE INPUT VECTOR IS ALREADY SORTED
C
      NM1 = N - 1
      DO I = 1, NM1
         IP1 = I + 1
         IF (Y(I) .GT. Y(IP1)) GO TO 250
      END DO
      RETURN 
  250 CONTINUE
      M = 1
      I = 1
      J = N
  305 CONTINUE
      IF (I .GE. J) GO TO 370
  310 CONTINUE
      K = I
      MID = (I + J)/2
      AMED = Y(MID)
      IF (Y(I) .GT. AMED) THEN
         Y(MID) = Y(I)
         Y(I) = AMED
         AMED = Y(MID)
      ENDIF
      L = J
      IF (Y(J) .GE. AMED) GO TO 340
      Y(MID) = Y(J)
      Y(J) = AMED
      AMED = Y(MID)
      IF (Y(I) .LE. AMED) GO TO 340
      Y(MID) = Y(I)
      Y(I) = AMED
      AMED = Y(MID)
      GO TO 340
  330 CONTINUE
      Y(L) = Y(K)
      Y(K) = TT
  340 CONTINUE
      L = L - 1
      IF (Y(L) .GT. AMED) GO TO 340
      TT = Y(L)
  350 CONTINUE
      K = K + 1
      IF (Y(K) .LT. AMED) GO TO 350
      IF (K .LE. L) GO TO 330
      LMI = L - I
      JMK = J - K
      IF (LMI .GT. JMK) THEN
         IL(M) = I
         IU(M) = L
         I = K
         M = M + 1
         GO TO 380
      ENDIF
      IL(M) = K
      IU(M) = J
      J = L
      M = M + 1
      GO TO 380
  370 CONTINUE
      M = M - 1
      IF (M .EQ. 0) RETURN 
      I = IL(M)
      J = IU(M)
  380 CONTINUE
      JMI = J - I
      IF (JMI .GE. 11) GO TO 310
      IF (I .EQ. 1) GO TO 305
      I = I - 1
  390 CONTINUE
      I = I + 1
      IF (I .EQ. J) GO TO 370
      AMED = Y(I+1)
      IF (Y(I) .LE. AMED) GO TO 390
      K = I
  395 CONTINUE
      Y(K+1) = Y(K)
      K = K - 1
      IF (AMED .LT. Y(K)) GO TO 395
      Y(K+1) = AMED
      GO TO 390
      END 

      PROGRAM CTWNG1
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.  Use one
C of the following:
C
C       PARAMETER (IERF=6,LUNI=2,IWTY=1 ,IWID=1)  !  NCGM
C       PARAMETER (IERF=6,LUNI=2,IWTY=8 ,IWID=1)  !  X Windows
C       PARAMETER (IERF=6,LUNI=2,IWTY=20,IWID=1)  !  PostScript
C       PARAMETER (IERF=6,LUNI=2,IWTY=11,IWID=1)  !  PDF, Portrait
C       PARAMETER (IERF=6,LUNI=2,IWTY=12,IWID=1)  !  PDF, Landscape
C
        PARAMETER (IERF=6,LUNI=2,IWTYPE=1,IWTY=IWTYPE,IWID=1)
C
C The object of this program is to produce a set of plots illustrating
C the use of a triangular mesh derived from a SEAM grid on the surface
C of the globe (obtained from Houjun Wang):  Each face of a cube is
C divided into a 4-by-4 grid of squares (for a total of 6 x 4 x 4 = 96
C squares).  Each of those squares is further subdivided into an 7-by-7
C grid of rectangles, some of which are square (for a total of 96 x 7 x
C 7 = 4704 rectangles).  The rectangles are projected outward onto the
C surface of the globe to form a network of quadrilaterals, each of
C which is split into two triangles to form the triangular mesh.
C Routines developed for use with the geodesic mesh (method 2) are also
C used for this mesh.
C
C Selected frames are drawn for each of four different viewpoints.  If
C (CLAT,CLON) is the approximate position of the "center point" of the
C mesh (which is defined somewhat arbitrarily for certain meshes), the
C four viewpoints used are as follows: (CLAT+45,CLON), (CLAT-45,CLON),
C (CLAT+45,CLON+180), and (CLAT-45,CLON+180).
C
C At each of the four viewpoints, up to five different frames are drawn:
C
C   1) A frame showing the original rectangular grid on the globe.
C      This frame is drawn only if the parameter IMSH = 1 or 3.
C
C   2) A frame showing the triangular mesh on the globe.  This frame
C      is drawn only if the parameter IMSH = 2 or 3.
C
C   3) A frame showing simple contours on the globe.  This frame is
C      drawn only if the parameter ICON is non-zero.
C
C   4) A frame showing color-filled contour bands on the globe, drawn
C      using filled areas.  This frame is drawn only if the parameter
C      ICOL is non-zero.
C
C   5) A frame showing color-filled contour bands on the globe, drawn
C      using a cell array.  This frame is drawn only if the parameter
C      ICAP is non-zero.
C
C Define the parameter that says which frames showing the rectangular
C grid and/or the triangular mesh are to be drawn (frames 1 and 2):
C
C       PARAMETER (IMSH=0)  !  neither grid nor mesh
C       PARAMETER (IMSH=1)  !  simple rectangular grid only
C       PARAMETER (IMSH=2)  !  triangular mesh only
C       PARAMETER (IMSH=3)  !  both
C
        PARAMETER (IMSH=3)
C
C Define the parameter that says whether or not to draw simple contours
C (frame 3):
C
C       PARAMETER (ICON=0)  !  contours not drawn
C       PARAMETER (ICON=1)  !  contours drawn
C
        PARAMETER (ICON=1)
C
C Define the parameter that says whether or not to draw color-filled
C contours (frame 4):
C
C       PARAMETER (ICOL=0)  !  no color fill done
C       PARAMETER (ICOL=1)  !  color fill done
C
        PARAMETER (ICOL=1)
C
C Define the parameter that says whether or not to draw a cell array
C plot (frame 5):
C
C       PARAMETER (ICAP=0)  !  cell array plot not drawn
C       PARAMETER (ICAP=1)  !  cell array plot drawn
C
        PARAMETER (ICAP=1)
C
C To represent the triangular mesh, we use three singly-dimensioned
C arrays: RPNT holds points, IEDG holds edges, and ITRI holds triangles.
C The elements of each array form "nodes" having lengths as follows:
C
        PARAMETER (LOPN=5)
C
C The five elements of a point node are
C
C   1. the X coordinate of the point;
C   2. the Y coordinate of the point;
C   3. the Z coordinate of the point;
C   4. the field value at the point;
C   5. any additional value desired by the user.
C
        PARAMETER (LOEN=5)
C
C The five elements of an edge node are
C
C   1. the base index, in RPNT, of point 1 of the edge;
C   2. the base index, in RPNT, of point 2 of the edge;
C   3. the index, in ITRI, of the pointer to the edge in the triangle to
C      the left of the edge (-1 if there is no triangle to the left);
C   4. the index, in ITRI, of the pointer to the edge in the triangle to
C      the right of the edge (-1 if there is no triangle to the right);
C   5. a utility flag for use by algorithms that scan the structure.
C
C The "left" and "right" sides of an edge are defined as they would be
C by an observer standing on the globe at point 1 of the edge, looking
C toward point 2 of the edge.  It is possible, if there are "holes" in
C the mesh, that there will be no triangle to the left or to the right
C of an edge, but there must be a triangle on one side or the other.
C
        PARAMETER (LOTN=4)
C
C The four elements of a triangle node are
C
C   1. the base index, in IEDG, of edge 1 of the triangle;
C   2. the base index, in IEDG, of edge 2 of the triangle;
C   3. the base index, in IEDG, of edge 3 of the triangle;
C   4. a flag set non-zero to block use of the triangle, effectively
C      removing it from the mesh.
C
C The "base index" of a point node, an edge node, or a triangle node is
C always a multiple of the length of the node, to which can be added an
C offset to get the index of a particular element of the node.  For
C example, if I is the base index of a triangle of interest, ITRI(I+1)
C is its first element (the base index of its first edge).  Similarly,
C IEDG(ITRI(I+1)+2) is the base index of the second point of the first
C edge of the triangle with base index I, and RPNT(IEDG(ITRI(I+1)+2)+3)
C is the third (Z) coordinate of the second point of the first edge of
C the triangle with base index I.
C
C It is the pointers from the edge nodes back to the triangle nodes that
C allow CONPACKT to navigate the mesh, moving from triangle to triangle
C as it follows a contour line, but these pointers are tricky to define:
C if IPTE is the base index of an edge node and IEDG(IPTE+3) is zero or
C more, saying that there is a triangle to the left of the edge, then
C IEDG(IPTE+3) is the actual index of that element of the triangle node
C that points to the edge node; i.e., ITRI(IEDG(IPTE+3))=IPTE.  The base
C index of the triangle node defining that triangle is IPTT, where
C IPTT=LOTN*((IEDG(IPTE+3)-1)/LOTN), and the index of the pointer to
C the edge within the triangle node is IPTI=IEDG(IPTE+3)-IPTT, so that
C ITRI(IPTT+IPTI)=IPTE.  Similar comments apply to element 4 of an edge
C node, which points into the triangle node defining the triangle to the
C right of the edge.
C
C The numbers of points, edges, and triangles in the triangular mesh are
C as follows (obtained from a run in which the numbers were set larger
C than this):
C
        PARAMETER (MNOP= 4706)
        PARAMETER (MNOE=14112)
        PARAMETER (MNOT= 9408)
C
C Once we know how many points, edges, and triangles we're going to use
C (at most), we can set parameters defining the space reserved for the
C triangular mesh:
C
        PARAMETER (MPNT=MNOP*LOPN)
        PARAMETER (MEDG=MNOE*LOEN)
        PARAMETER (MTRI=MNOT*LOTN)
C
C Declare the arrays to hold the point nodes, edge nodes, and triangle
C nodes defining the triangular mesh.
C
        DIMENSION RPNT(MPNT),IEDG(MEDG),ITRI(MTRI)
C
C Declare sort arrays to be used in GTWNG1 to keep track of where points
C and edges were put in the structure defining the triangular mesh.
C
        DIMENSION IPPP(2,MNOP),IPPE(2,MNOE)
C
C Declare real and integer workspaces needed by CONPACKT.
C
        PARAMETER (LRWK=10000,LIWK=1000)
C
        DIMENSION RWRK(LRWK),IWRK(LIWK)
C
C Declare the area map array needed to do solid fill.
C
        PARAMETER (LAMA=400000)
C
        DIMENSION IAMA(LAMA)
C
C Declare workspace arrays to be used in calls to ARSCAM.
C
        PARAMETER (NCRA=LAMA/10,NGPS=2)
C
        DIMENSION XCRA(NCRA),YCRA(NCRA),IAAI(NGPS),IAGI(NGPS)
C
C Declare arrays in which to generate a cell array picture of the
C data on the triangular mesh.
C
C       PARAMETER (ICAM=1024,ICAN=1024)
        PARAMETER (ICAM= 512,ICAN= 512)
C
        DIMENSION ICRA(ICAM,ICAN)
C
C Declare arrays to hold color components for colors to be used at the
C four corners of an illustrative drawing of the rectangular grid.
C
        DIMENSION CCLL(3),CCLR(3),CCUL(3),CCUR(3)
C
C Declare external the routine that draws masked contour lines.
C
        EXTERNAL DRWMCL
C
C Declare external the routine that does color fill of contour bands.
C
        EXTERNAL DCFOCB
C
C Define a common block in which to keep track of the maximum space used
C in the arrays XCRA and YCRA.
C
        COMMON /COMONA/ MAXN
C
C Define the out-of-range flag.
C
        DATA OORV / 1.E12 /
C
C Define the tension on the splines to be used in smoothing contours.
C
C       DATA T2DS / 0.0 /  !  smoothing off
C       DATA T2DS / 2.5 /  !  smoothing on
C
        DATA T2DS / 0.0 /
C
C Define the distance between points on smoothed contour lines.
C
        DATA RSSL / .002 /
C
C Define the amount of real workspace to be used in drawing contours.
C
        DATA IRWC / 500 /
C
C Define the label-positioning flag.
C
C       DATA ILLP / 0 /  !  no labels
C       DATA ILLP / 1 /  !  dash-package writes labels
C       DATA ILLP / 2 /  !  regular scheme
C       DATA ILLP / 3 /  !  penalty scheme
C
        DATA ILLP / 2 /
C
C Define the high/low search radius.
C
        DATA HLSR / .075 /
C
C Define the high/low label overlap flag.
C
        DATA IHLO / 11 /
C
C Define the hachuring flag, hachure length, and hachure spacing.
C
C       DATA IHCF,HCHL,HCHS /  0 , +.004 , .010 /  !  off
C       DATA IHCF,HCHL,HCHS / +1 , -.004 , .020 /  !  on, all, uphill
C
        DATA IHCF,HCHL,HCHS /  0 , +.004 , .010 /
C
C Define the colors to be used in the lower left, lower right, upper
C left, and upper right corners of the rectangular grid when a drawing
C of it is made for the purpose of illustrating how it is wrapped around
C the globe.
C
        DATA CCLL / 0.2 , 0.2 , 0.2 /
        DATA CCLR / 1.0 , 0.0 , 1.0 /
        DATA CCUL / 0.0 , 1.0 , 1.0 /
        DATA CCUR / 1.0 , 1.0 , 0.0 /
C
C Define a constant to convert from radians to degrees.
C
        DATA RTOD / 57.2957795130823 /
C
C Read data and generate the required triangular mesh.
C
        PRINT * , ' '
        PRINT * , 'CREATING TRIANGULAR MESH:'
C
        CALL GTWNG1 (RPNT,MPNT,NPNT,LOPN,
     +               IEDG,MEDG,NEDG,LOEN,
     +               ITRI,MTRI,NTRI,LOTN,
     +               IPPP,IPPE,CLAT,CLON)
C
C Print the number of points, edges, and triangles.
C
        PRINT * , '  NUMBER OF POINTS:    ',NPNT/LOPN
        PRINT * , '  NUMBER OF EDGES:     ',NEDG/LOEN
        PRINT * , '  NUMBER OF TRIANGLES: ',NTRI/LOTN
C
C Write the contents of the point list, the edge list, and the triangle
C list to "fort.11" in a readable form.
C
c       WRITE (11,'(''P'',I8,5F10.4)')
c    +        (I,RPNT(I+1),RPNT(I+2),RPNT(I+3),RPNT(I+4),RPNT(I+5),
c    +                                               I=0,NPNT-LOPN,LOPN)
c       WRITE (11,'(''E'',I8,5I10)')
c    +        (I,IEDG(I+1),IEDG(I+2),IEDG(I+3),IEDG(I+4),IEDG(I+5),
c    +                                               I=0,NEDG-LOEN,LOEN)
c       WRITE (11,'(''T'',I8,4I10)')
c    +        (I,ITRI(I+1),ITRI(I+2),ITRI(I+3),ITRI(I+4),
c    +                                               I=0,NTRI-LOTN,LOTN)
C
C Open GKS.
C
        PRINT * , 'OPENING AND INITIALIZING GKS'
C
        CALL GOPKS (IERF,0)
        CALL GOPWK (IWID,LUNI,IWTY)
        CALL GACWK (IWID)
C
C Turn off the clipping indicator.
C
        CALL GSCLIP (0)
C
C Define a basic set of colors (0 = white, background; 1 = black,
C foreground; 2 = yellow; 3 = magenta; 4 = red; 5 = cyan; 6 = green;
C 7 = blue; 8 = darker light gray; 9 = lighter light gray; 10 = dark
C yellow; 11 = dark gray; 12 = medium gray; 13 = light red, for
C geographic lines; 14 = light blue, for lat/lon lines).
C
        CALL GSCR   (IWID, 0,1.,1.,1.)
        CALL GSCR   (IWID, 1,0.,0.,0.)
        CALL GSCR   (IWID, 2,1.,1.,0.)
        CALL GSCR   (IWID, 3,1.,0.,1.)
        CALL GSCR   (IWID, 4,1.,0.,0.)
        CALL GSCR   (IWID, 5,0.,1.,1.)
        CALL GSCR   (IWID, 6,0.,1.,0.)
        CALL GSCR   (IWID, 7,0.,0.,1.)
        CALL GSCR   (IWID, 8,.5,.5,.5)
        CALL GSCR   (IWID, 9,.8,.8,.8)
        CALL GSCR   (IWID,10,.3,.3,0.)
        CALL GSCR   (IWID,11,.3,.3,.3)
        CALL GSCR   (IWID,12,.5,.5,.5)
        CALL GSCR   (IWID,13,.8,.5,.5)
        CALL GSCR   (IWID,14,.5,.5,.8)
C
C Define 100 colors, associated with color indices 151 through 250, to
C be used for color-filled contour bands and in cell arrays, ranging
C from blue to red.
C
        CALL DFCLRS (IWID,151,250,0.,0.,1.,1.,0.,0.)
C
C Set parameters in the utilities.
C
        PRINT * , 'SETTING PARAMETERS IN CONPACKT, EZMAP, AND PLOTCHAR'
C
C Set the mapping flag.
C
        CALL CTSETI ('MAP - MAPPING FLAG',1)
C
C Set the out-of-range flag value.
C
        CALL CTSETR ('ORV - OUT-OF-RANGE VALUE',OORV)
C
C Turn on the drawing of the mesh edge and set the area identifier for
C areas outside the mesh.
C
        CALL CTSETI ('PAI - PARAMETER ARRAY INDEX',-1)
        CALL CTSETI ('CLU - CONTOUR LEVEL USE FLAG',1)
        CALL CTSETI ('AIA - AREA IDENTIFIER FOR AREA',1001)
C
C Set the area identifier for areas in "out-of-range" areas.
C
C       CALL CTSETI ('PAI',-2)
C       CALL CTSETI ('AIA - AREA IDENTIFIER FOR AREA',1002)
C
C Set the 2D smoother flag.
C
        CALL CTSETR ('T2D - TENSION ON 2D SPLINES',T2DS)
C
C Set the distance between points on smoothed lines.
C
        CALL CTSETR ('SSL - SMOOTHED SEGMENT LENGTH',RSSL)
C
C Set the amount of real workspace to be used in drawing contours.
C
        CALL CTSETI ('RWC - REAL WORKSPACE FOR CONTOURS',IRWC)
C
C Set the label-positioning flag.
C
        CALL CTSETI ('LLP - LINE LABEL POSITIONING FLAG',ILLP)
C
C Set the high/low search radius.
C
        CALL CTSETR ('HLR - HIGH/LOW SEARCH RADIUS',HLSR)
C
C Set the high/low label overlap flag.
C
        CALL CTSETI ('HLO - HIGH/LOW LABEL OVERLAP FLAG',IHLO)
C
C Set the hachuring flag, hachure length, and hachure spacing.
C
        CALL CTSETI ('HCF - HACHURING FLAG',IHCF)
        CALL CTSETR ('HCL - HACHURE LENGTH',HCHL)
        CALL CTSETR ('HCS - HACHURE SPACING',HCHS)
C
C Set the cell array flag.
C
        CALL CTSETI ('CAF - CELL ARRAY FLAG',-1)
C
C Tell CONPACKT not to do its own call to SET, since EZMAP will have
C done it.
C
        CALL CTSETI ('SET - DO-SET-CALL FLAG', 0)
C
C Move the informational label up a little.
C
        CALL CTSETR ('ILY - INFORMATIONAL LABEL Y POSITION',-.005)
C
C Tell EZMAP not to draw the perimeter.
C
        CALL MPSETI ('PE',0)
C
C Tell EZMAP to use solid lat/lon lines.
C
        CALL MPSETI ('DA',65535)
C
C Tell PLOTCHAR to use one of the filled fonts and to outline each
C character.
C
        CALL PCSETI ('FN',25)
        CALL PCSETI ('OF',1)
C
C Tell PLOTCHAR to expect a character other than a colon as the
C function-control signal character.
C
        CALL PCSETC ('FC','|')
C
C Loop through four different viewing angles.
C
        DO 104 IDIR=1,4
C
          PRINT * , ' '
          PRINT * , 'VIEW FROM DIRECTION NUMBER: ',IDIR
C
C Tell EZMAP what projection to use and what its limits are.
C
          IF      (IDIR.EQ.1) THEN
            CALL MAPROJ ('OR',CLAT+45.,CLON,      0.)
          ELSE IF (IDIR.EQ.2) THEN
            CALL MAPROJ ('OR',CLAT-45.,CLON,      0.)
          ELSE IF (IDIR.EQ.3) THEN
            CALL MAPROJ ('OR',CLAT+45.,CLON+180., 0.)
          ELSE IF (IDIR.EQ.4) THEN
            CALL MAPROJ ('OR',CLAT-45.,CLON+180., 0.)
          END IF
C
          CALL MAPSET ('MA',0.,0.,0.,0.)
C
C Initialize EZMAP.
C
          CALL MAPINT
C
C If the rectangular grid and/or the triangular mesh are to be drawn,
C do it.
C
          IF (IMSH.NE.0) THEN
C
            PRINT * , 'DRAWING MESHES'
C
C Simple rectangular grid:
C
            IF (MOD(IMSH,2).NE.0) THEN
C
              PRINT * , 'DRAWING SIMPLE RECTANGULAR GRID'
C
              CALL DSWNG1
C
C Label the first frame.
C
              CALL PLCHHQ (CFUX(.03),CFUY(.946),'SEAM GRID',
     +                                                      .024,0.,-1.)
              CALL PLCHHQ (CFUX(.03),CFUY(.906),'(EXAMPLE 1)',
     +                                                      .016,0.,-1.)
C
              IF (     IDIR.EQ.1) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 1',
     +                                                      .012,0.,-1.)
              ELSE IF (IDIR.EQ.2) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 2',
     +                                                      .012,0.,-1.)
              ELSE IF (IDIR.EQ.3) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 3',
     +                                                      .012,0.,-1.)
              ELSE IF (IDIR.EQ.4) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 4',
     +                                                      .012,0.,-1.)
              END IF
C
              CALL PLCHHQ (CFUX(.97),CFUY(.950),'ORIGINAL RECTANGULAR GR
     +ID',.012,0.,1.)
C
              CALL PLCHHQ (CFUX(.97),CFUY(.928),
     +                     'This grid is developed from a cube.',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.908),
     +                     'The numbers label 96 elements,',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.888),
     +                     'each of which derives from',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.868),
     +                     '1/16 of a cube face and',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.848),
     +                     'is subdivided into',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.828),
     +                     'a 7x7 array of',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.808),
     +                     'rectangular',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.788),
     +                     'patches.',
     +                                                       .010,0.,1.)
C
              CALL PLCHHQ (CFUX(.03),CFUY(.084),'Grid is gray.',
     +                                                      .012,0.,-1.)
              CALL PLCHHQ (CFUX(.03),CFUY(.060),'Shorelines are blue.',
     +                                                      .012,0.,-1.)
              CALL PLCHHQ (CFUX(.03),CFUY(.036),'Parallels/meridians are
     + red.',.012,0.,-1.)
C
C Advance the frame.
C
              CALL FRAME
C
            END IF
C
C Triangular mesh (with edges between blocked triangles somewhat fainter
C than the rest):
C
            IF (MOD(IMSH/2,2).NE.0) THEN
C
              PRINT * , 'DRAWING TRIANGULAR MESH'
C
              DO 101 IPTE=0,NEDG-LOEN,LOEN
C
                IFLL=0
C
                IF (IEDG(IPTE+3).GE.0) THEN
                  IF (ITRI(LOTN*((IEDG(IPTE+3)-1)/LOTN)+4).EQ.0) IFLL=1
                END IF
C
                IFLR=0
C
                IF (IEDG(IPTE+4).GE.0) THEN
                  IF (ITRI(LOTN*((IEDG(IPTE+4)-1)/LOTN)+4).EQ.0) IFLR=1
                END IF
C
                IF (IFLL.NE.0.OR.IFLR.NE.0) THEN
                  CALL PLOTIT (0,0,2)
                  CALL GSPLCI (8)
                ELSE
                  CALL PLOTIT (0,0,2)
                  CALL GSPLCI (9)
                END IF
C
                ALAT=RTOD*ASIN(RPNT(IEDG(IPTE+1)+3))
C
                IF (RPNT(IEDG(IPTE+1)+1).EQ.0..AND.
     +              RPNT(IEDG(IPTE+1)+2).EQ.0.) THEN
                  ALON=0.
                ELSE
                  ALON=RTOD*ATAN2(RPNT(IEDG(IPTE+1)+2),
     +                            RPNT(IEDG(IPTE+1)+1))
                END IF
C
                BLAT=RTOD*ASIN(RPNT(IEDG(IPTE+2)+3))
C
                IF (RPNT(IEDG(IPTE+2)+1).EQ.0..AND.
     +              RPNT(IEDG(IPTE+2)+2).EQ.0.) THEN
                  BLON=0.
                ELSE
                  BLON=RTOD*ATAN2(RPNT(IEDG(IPTE+2)+2),
     +                            RPNT(IEDG(IPTE+2)+1))
                END IF
C
                CALL DRSGCR (ALAT,ALON,BLAT,BLON)
C
  101         CONTINUE
C
              CALL PLOTIT (0,0,2)
              CALL GSPLCI (13)
              CALL MAPGRD
              CALL PLOTIT (0,0,2)
              CALL GSPLCI (14)
              CALL MAPLOT
C
C Label the second frame.
C
              CALL PLCHHQ (CFUX(.03),CFUY(.946),'SEAM GRID',
     +                                                      .024,0.,-1.)
              CALL PLCHHQ (CFUX(.03),CFUY(.906),'(EXAMPLE 1)',
     +                                                      .016,0.,-1.)
C
              IF (     IDIR.EQ.1) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 1',
     +                                                      .012,0.,-1.)
              ELSE IF (IDIR.EQ.2) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 2',
     +                                                      .012,0.,-1.)
              ELSE IF (IDIR.EQ.3) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 3',
     +                                                      .012,0.,-1.)
              ELSE IF (IDIR.EQ.4) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 4',
     +                                                      .012,0.,-1.)
              END IF
C
              CALL PLCHHQ (CFUX(.97),CFUY(.950),'DERIVED TRIANGULAR MESH
     +',.012,0.,1.)
C
              CALL PLCHHQ (CFUX(.97),CFUY(.928),
     +                     'Each quadrilateral of the grid',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.908),
     +                     'is split along a diagonal',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.888),
     +                     'to get two triangles',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.868),
     +                     'of the mesh.',
     +                                                       .010,0.,1.)
C
              CALL PLCHHQ (CFUX(.03),CFUY(.084),'Mesh is gray.',
     +                                                      .012,0.,-1.)
              CALL PLCHHQ (CFUX(.03),CFUY(.060),'Shorelines are blue.',
     +                                                      .012,0.,-1.)
              CALL PLCHHQ (CFUX(.03),CFUY(.036),'Parallels/meridians are
     + red.',.012,0.,-1.)
C
C Advance the frame.
C
              CALL FRAME
C
            END IF
C
          END IF
C
C If a frame showing simple contours is to be drawn, do it next (adding
C an overlay of lat/lon lines and continental outlines in light gray).
C
          IF (ICON.NE.0) THEN
C
            PRINT * , 'DRAWING PLOT SHOWING SIMPLE CONTOURS'
C
C Initialize CONPACKT.
C
            PRINT * , 'CALLING CTMESH'
C
            CALL CTMESH (RPNT,NPNT,LOPN,
     +                   IEDG,NEDG,LOEN,
     +                   ITRI,NTRI,LOTN,
     +                   RWRK,LRWK,
     +                   IWRK,LIWK)
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (1)
C
C Proceed as implied by the setting of the label-positioning flag.
C
            IF (ABS(ILLP).EQ.1) THEN
C
C Draw the contour lines with labels generated by the dash package.
C
              PRINT * , 'CALLING CTCLDR'
              CALL CTCLDR (RPNT,IEDG,ITRI,RWRK,IWRK)
C
C Add the informational and high/low labels.
C
              PRINT * , 'CALLING CTLBDR'
              CALL CTLBDR (RPNT,IEDG,ITRI,RWRK,IWRK)
C
            ELSE IF (ABS(ILLP).GT.1) THEN
C
C Create an area map for masking of labels.
C
              MAXN=0
C
              PRINT * , 'CALLING ARINAM'
              CALL ARINAM (IAMA,LAMA)
C
              PRINT * , 'CALLING CTLBAM'
              CALL CTLBAM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA)
C
C Draw the contour lines masked by the area map.
C
              PRINT * , 'CALLING CTCLDM'
              CALL CTCLDM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA,DRWMCL)
C
              PRINT * , 'AREA MAP SPACE REQUIRED:         ',
     +                                         IAMA(1)-IAMA(6)+IAMA(5)+1
C
              PRINT * , 'NUMBER OF POINTS IN LONGEST LINE:',MAXN
C
C Draw all the labels.
C
              PRINT * , 'CALLING CTLBDR'
              CALL CTLBDR (RPNT,IEDG,ITRI,RWRK,IWRK)
C
            END IF
C
            CALL CTGETI ('IWU - INTEGER WORKSPACE USED',IIWU)
            PRINT * , 'INTEGER WORKSPACE REQUIRED:      ',IIWU
C
            CALL CTGETI ('RWU -    REAL WORKSPACE USED',IRWU)
            PRINT * , 'REAL WORKSPACE REQUIRED:         ',IRWU
C
C Add lat/lon lines and continental outlines.
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (13)
            CALL MAPGRD
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (14)
            CALL MAPLOT
C
C Label the third frame.
C
            CALL PLCHHQ (CFUX(.03),CFUY(.946),'SEAM GRID',.024,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.906),'(EXAMPLE 1)',.016,0.,-1.)
C
            IF (     IDIR.EQ.1) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 1',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.2) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 2',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.3) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 3',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.4) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 4',
     +                                                      .012,0.,-1.)
            END IF
C
            CALL PLCHHQ (CFUX(.97),CFUY(.950),'SIMPLE CONTOURS ON',
     +                                                       .012,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.926),'TRIANGULAR MESH',
     +                                                       .012,0.,1.)
C
            CALL PLCHHQ (CFUX(.97),CFUY(.904),'Data values come from a',
     +                                                       .010,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.884),'land/water mask.',
     +                                                       .010,0.,1.)
C
            CALL PLCHHQ (CFUX(.03),CFUY(.060),'Shorelines are blue.',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.036),'Parallels/meridians are r
     +ed.',.012,0.,-1.)
C
C Advance the frame.
C
            CALL FRAME
C
          END IF
C
C If a frame showing color-filled contours is to be drawn, do it next.
C
          IF (ICOL.NE.0) THEN
C
            PRINT * , 'DRAWING PLOT SHOWING COLOR-FILLED CONTOURS'
C
            PRINT * , 'CALLING CTMESH'
C
            CALL CTMESH (RPNT,NPNT,LOPN,
     +                   IEDG,NEDG,LOEN,
     +                   ITRI,NTRI,LOTN,
     +                   RWRK,LRWK,
     +                   IWRK,LIWK)
C
            MAXN=0
C
            PRINT * , 'CALLING CTPKCL'
            CALL CTPKCL (RPNT,IEDG,ITRI,RWRK,IWRK)
C
            PRINT * , 'CALLING ARINAM'
            CALL ARINAM (IAMA,LAMA)
C
            PRINT * , 'CALLING CTCLAM'
            CALL CTCLAM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA)
C
C           PRINT * , 'CALLING CTLBAM'
C           CALL CTLBAM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA)
C
            PRINT * , 'CALLING ARSCAM'
            CALL ARSCAM (IAMA,XCRA,YCRA,NCRA,IAAI,IAGI,NGPS,DCFOCB)
C
            PRINT * , 'SPACE REQUIRED IN AREA MAP:      ',
     +                                         IAMA(1)-IAMA(6)+IAMA(5)+1
C
            PRINT * , 'NUMBER OF POINTS IN LARGEST AREA:',MAXN
C
            CALL CTGETI ('IWU - INTEGER WORKSPACE USED',IIWU)
            PRINT * , 'INTEGER WORKSPACE REQUIRED:      ',IIWU
C
            CALL CTGETI ('RWU -    REAL WORKSPACE USED',IRWU)
            PRINT * , 'REAL WORKSPACE REQUIRED:         ',IRWU
C
            CALL GSFACI (1)
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (13)
            CALL MAPGRD
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (14)
            CALL MAPLOT
C
C Label the fourth frame.
C
            CALL PLCHHQ (CFUX(.03),CFUY(.946),'SEAM GRID',.024,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.906),'(EXAMPLE 1)',.016,0.,-1.)
C
            IF (     IDIR.EQ.1) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 1',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.2) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 2',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.3) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 3',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.4) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 4',
     +                                                      .012,0.,-1.)
            END IF
C
            CALL PLCHHQ (CFUX(.97),CFUY(.950),'COLORED CONTOUR BANDS ON'
     +,.012,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.926),'TRIANGULAR MESH',
     +                                                       .012,0.,1.)
C
            CALL PLCHHQ (CFUX(.97),CFUY(.904),'Data values come from a',
     +                                                       .010,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.884),'land/water mask.',
     +                                                       .010,0.,1.)
C
            CALL PLCHHQ (CFUX(.03),CFUY(.132),'Off-mesh',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.108),'areas of the',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.084),'globe are yellow.',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.060),'Shorelines are blue.',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.036),'Parallels/meridians are r
     +ed.',.012,0.,-1.)
C
C Advance the frame.
C
            CALL FRAME
C
          END IF
C
C If the flag for it is set, do a cell array plot.
C
          IF (ICAP.NE.0) THEN
C
            PRINT * , 'DRAWING CELL-ARRAY PLOT OF DATA VALUES'
C
            PRINT * , 'CALLING CTMESH'
C
            CALL CTMESH (RPNT,NPNT,LOPN,
     +                   IEDG,NEDG,LOEN,
     +                   ITRI,NTRI,LOTN,
     +                   RWRK,LRWK,
     +                   IWRK,LIWK)
C
            CALL GETSET (XVPL,XVPR,YVPB,YVPT,XWDL,XWDR,YWDB,YWDT,LNLG)
C
            PRINT * , 'CALLING CTCICA'
            CALL CTCICA (RPNT,IEDG,ITRI,RWRK,IWRK,ICRA,ICAM,ICAM,ICAN,
     +                                            XVPL,YVPB,XVPR,YVPT)
C
            PRINT * , 'CALLING GCA'
            CALL GCA (XWDL,YWDB,XWDR,YWDT,ICAM,ICAN,1,1,ICAM,ICAN,ICRA)
C
            CALL CTGETI ('IWU - INTEGER WORKSPACE USED',IIWU)
            PRINT * , 'INTEGER WORKSPACE REQUIRED:      ',IIWU
C
            CALL CTGETI ('RWU -    REAL WORKSPACE USED',IRWU)
            PRINT * , 'REAL WORKSPACE REQUIRED:         ',IRWU
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (13)
            CALL MAPGRD
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (14)
            CALL MAPLOT
C
C Label the fifth frame.
C
            CALL PLCHHQ (CFUX(.03),CFUY(.946),'SEAM GRID',.024,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.906),'(EXAMPLE 1)',.016,0.,-1.)
C
            IF (     IDIR.EQ.1) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 1',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.2) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 2',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.3) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 3',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.4) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 4',
     +                                                      .012,0.,-1.)
            END IF
C
            CALL PLCHHQ (CFUX(.97),CFUY(.950),'CELL ARRAY DERIVED FROM',
     +.012,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.926),'TRIANGULAR MESH',
     +                                                       .012,0.,1.)
C
            CALL PLCHHQ (CFUX(.97),CFUY(.904),'Data values come from a',
     +                                                       .010,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.884),'land/water mask.',
     +                                                       .010,0.,1.)
C
            CALL PLCHHQ (CFUX(.03),CFUY(.132),'Off-mesh',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.108),'areas of the',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.084),'globe are yellow.',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.060),'Shorelines are blue.',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.036),'Parallels/meridians are r
     +ed.',.012,0.,-1.)
C
C Advance the frame.
C
            CALL FRAME
C
          END IF
C
  104   CONTINUE
C
C Close GKS.
C
        CALL GDAWK (IWID)
        CALL GCLWK (IWID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END


      SUBROUTINE DFCLRS (IWID,IOFC,IOLC,REDF,GRNF,BLUF,REDL,GRNL,BLUL)
C
C This routine defines color indices IOFC through IOLC on workstation
C IWID by interpolating values from REDF/GRNF/BLUF to REDL/GRNL/BLUL.
C
        DO 101 I=IOFC,IOLC
          P=REAL(IOLC-I)/REAL(IOLC-IOFC)
          Q=REAL(I-IOFC)/REAL(IOLC-IOFC)
          CALL GSCR (IWID,I,P*REDF+Q*REDL,P*GRNF+Q*GRNL,P*BLUF+Q*BLUL)
  101   CONTINUE
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE DRWMCL (XCRA,YCRA,NCRA,IAAI,IAGI,NGPS)
C
        DIMENSION XCRA(*),YCRA(*),IAAI(*),IAGI(*)
C
C This routine draws the curve defined by the points (XCRA(I),YCRA(I)),
C for I = 1 to NCRA, if and only if none of the area identifiers for the
C area containing the polyline are negative.  It calls either CURVE or
C CURVED to do the drawing, depending on the value of the internal
C parameter 'DPU'.
C
C It keeps track of the maximum value used for NCRA in a common block.
C
        COMMON /COMONA/ MAXN
C
        MAXN=MAX(MAXN,NCRA)
C
C Retrieve the value of the internal parameter 'DPU'.
C
        CALL CTGETI ('DPU - DASH PACKAGE USED',IDUF)
C
C Turn on drawing.
C
        IDRW=1
C
C If any area identifier is negative, turn off drawing.
C
        DO 101 I=1,NGPS
          IF (IAAI(I).LT.0) IDRW=0
  101   CONTINUE
C
C If drawing is turned on, draw the polyline.
C
        IF (IDRW.NE.0) THEN
          IF (IDUF.EQ.0) THEN
            CALL CURVE  (XCRA,YCRA,NCRA)
          ELSE IF (IDUF.LT.0) THEN
            CALL DPCURV (XCRA,YCRA,NCRA)
          ELSE
            CALL CURVED (XCRA,YCRA,NCRA)
          END IF
        END IF
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE DCFOCB (XCRA,YCRA,NCRA,IAAI,IAGI,NGPS)
C
C This routine fills the area defined by the points (XCRA(I),YCRA(I)),
C for I = 1 to NCRA, if and only if none of the area identifiers for
C the area are negative.  The color used is determined from the area
C identifier of the area relative to group 3; it is assumed that 100
C colors are defined having color indices 151 through 250.
C
        DIMENSION XCRA(*),YCRA(*),IAAI(*),IAGI(*)
C
C It keeps track of the maximum value used for NCRA in a common block.
C
        COMMON /COMONA/ MAXN
C
        MAXN=MAX(MAXN,NCRA)
C
C Retrieve the number of contour levels being used.
C
        CALL CTGETI ('NCL - NUMBER OF CONTOUR LEVELS',NOCL)
C
C If the number of contour levels is non-zero and the area has more
C than two points, fill it.
C
        IF (NOCL.NE.0.AND.NCRA.GT.2) THEN
C
          IAI3=-1
C
          DO 101 I=1,NGPS
            IF (IAGI(I).EQ.3) IAI3=IAAI(I)
  101     CONTINUE
C
          IF (IAI3.GE.1.AND.IAI3.LE.NOCL+1) THEN
            CALL GSFACI (151+INT(((REAL(IAI3)-.5)/REAL(NOCL+1))*100.))
            CALL GFA    (NCRA,XCRA,YCRA)
          ELSE IF (IAI3.EQ.1001) THEN
            CALL GSFACI (2)
            CALL GFA    (NCRA,XCRA,YCRA)
          ELSE IF (IAI3.EQ.1002) THEN
            CALL GSFACI (3)
            CALL GFA    (NCRA,XCRA,YCRA)
          END IF
C
        END IF
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE GTWNG1 (RPNT,MPNT,NPNT,LOPN,
     +                   IEDG,MEDG,NEDG,LOEN,
     +                   ITRI,MTRI,NTRI,LOTN,
     +                   IPPP,IPPE,CLAT,CLON)
C
        DIMENSION RPNT(MPNT),IEDG(MEDG),ITRI(MTRI),IPPP(2,*),IPPE(2,*)
C
C Construct a triangular mesh using SEAM data from Houjun Wang,
C using a routine (CTTMTL) that makes it easy to create an arbitrary
C triangular mesh (first used above in GTGEO2).  The "tree-sorts"
C used by this method are very inefficient for objects that are
C partially ordered, so, as the triangles of the mesh are generated,
C they are stored in a triangle buffer from which they can be dumped
C in random order by calls to the routine CTTMTL.
C
C Declare the array to use as the buffer for the triangles, so that the
C order in which they are processed can be somewhat randomized.  Up to
C a point, making this buffer larger will result in more randomization
C of the triangles and speed up the process.  MBUF is the number of
C triangles that will fit in the buffer at once, and KBUF is the number
C of those that are dumped whenever the buffer is found to be full; it
C turns out that it's better to dump more than 1 at a time (I suppose
C because the call and loop set-up time for CTTMTL are non-trivial, so
C it's better to dump a few triangles while you're there).  So ... use
C MBUF > KBUF > 1.
C
        PARAMETER (MBUF=5021,KBUF=173,MBM1=MBUF-1,DTOR=.017453292519943)
C
        DIMENSION TBUF(12,MBUF)
C
C Include definitions that "NetCDF" needs (now commented out, because
C the data are being read from an ASCII file, instead).
C
C       include 'netcdf.inc'
C
C Declare arrays to receive lat/lon coordinate data from Houjun's
C NetCDF data file.
C
        COMMON /CMWNG1/ TLAT(8,8,96),TLON(8,8,96),ELAT(96),ELON(96)
C
C Declare arrays to receive other data from Houjun's NetCDF data file.
C
        DIMENSION LAND(8,8,96)
C
C The data for this example were originally read from a user's "NetCDF"
C file.  The code used for the purpose follows, but has been commented
C out, as the data are now read from an ASCII file.  This gets around
C certain procedural problems in running the example from "ncargex".
C
C Open the "NetCDF" file.
C
C       ISTA=NF_OPEN('ctwng1.nc',0,NCID)
C
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'ERROR RETURN FROM NF_OPEN: ',ISTA
C         STOP
C       END IF
C
C Read the array of latitudes of cell centers.
C
C       ISTA=NF_INQ_VARID(NCID,'LATIXY',IVID)
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'ERROR RETURN FROM NF_INQ_VARID: ',ISTA
C         STOP
C       END IF
C       ISTA=NF_GET_VAR_REAL(NCID,IVID,TLAT)
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'ERROR RETURN FROM NF_GET_VAR_REAL: ',ISTA
C         STOP
C       END IF
C
C Read the array of longitudes of cell centers.
C
C       ISTA=NF_INQ_VARID(NCID,'LONGXY',IVID)
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'ERROR RETURN FROM NF_INQ_VARID: ',ISTA
C         STOP
C       END IF
C       ISTA=NF_GET_VAR_REAL(NCID,IVID,TLON)
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'ERROR RETURN FROM NF_GET_VAR_REAL: ',ISTA
C         STOP
C       END IF
C
C Read the "land/ocean mask" array.
C
C       ISTA=NF_INQ_VARID(NCID,'LANDMASK',IVID)
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'ERROR RETURN FROM NF_INQ_VARID: ',ISTA
C         STOP
C       END IF
C       ISTA=NF_GET_VAR_INT(NCID,IVID,LAND)
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'ERROR RETURN FROM NF_GET_VAR_INT: ',ISTA
C         STOP
C       END IF
C
C Close the "NetCDF" file.
C
C       ISTA=NF_CLOSE(NCID)
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'ERROR RETURN FROM NF_CLOSE: ',ISTA
C         STOP
C       END IF
C
C Write the data to unit 11.  (These statements are commented out; they
C were used to create a "fort.11" which was then renamed "ctwng1.dat".)
C
C       WRITE (11,'(5E16.8)') TLAT
C       WRITE (11,'(5E16.8)') TLON
C       WRITE (11,  '(20I4)') LAND
C
C Read the required data from the ASCII file "ctwng1.dat".
C
        OPEN (11,FILE='ctwng1.dat',STATUS='OLD',FORM='FORMATTED')
C
        READ (11,'(5E16.8)') TLAT
        READ (11,'(5E16.8)') TLON
        READ (11,  '(20I4)') LAND
C
        CLOSE (11)
C
C Find the center points of the elements of Wang's grid.
C
        DO 101 K=1,96
          CALL IPIQOS (TLAT(4,4,K),TLON(4,4,K),TLAT(5,4,K),TLON(5,4,K),
     +                 TLAT(4,5,K),TLON(4,5,K),TLAT(5,5,K),TLON(5,5,K),
     +                                           .5,.5,ELAT(K),ELON(K))
  101   CONTINUE
C
C Build structures forming the triangular mesh.  First, initialize the
C variables used to keep track of items in the sort arrays for points
C and edges, in the triangle buffer, and in the triangle list.
C
        MPPP=MPNT/LOPN
        NPPP=0
C
        MPPE=MEDG/LOEN
        NPPE=0
C
        NBUF=0
C
        NTRI=0
C
C Loop through the triangles derived from Houjun's SEAM grid.  K indexes
C the elements of the rectangular mesh, each of which is a 7-by-7 array
C of rectangles.  IROW and ICOL are the row and column numbers of the
C element within a square face of the cube; they are used to determine
C the "parity" of the rectangle, determining which diagonal of it to use
C to split it into two triangles.
C
        DO 107 K=1,96
C
          IROW=MOD(K-1,16)/4+1
          ICOL=MOD(K-1,4)+1
C
C I and J index the rectangular pieces of each square element.
C
          DO 106 I=1,7
            DO 105 J=1,7
C
C If the triangle buffer is almost full, dump a few randomly-chosen
C triangles from it to make room for two new ones.
C
              IF (NBUF.GE.MBM1) THEN
                CALL CTTMTL (KBUF,TBUF,MBUF,NBUF,
     +                       IPPP,MPPP,NPPP,
     +                       IPPE,MPPE,NPPE,
     +                       RPNT,MPNT,NPNT,LOPN,
     +                       IEDG,MEDG,NEDG,LOEN,
     +                       ITRI,MTRI,NTRI,LOTN)
              END IF
C
C Put two new triangles in the triangle buffer.
C
              IF (MOD(I+J+IROW+ICOL,2).EQ.0) THEN
C
                NBUF=NBUF+1
C
                TBUF( 1,NBUF)=COS(DTOR*TLAT(I  ,J  ,K))*
     +                        COS(DTOR*TLON(I  ,J  ,K))
                TBUF( 2,NBUF)=COS(DTOR*TLAT(I  ,J  ,K))*
     +                        SIN(DTOR*TLON(I  ,J  ,K))
                TBUF( 3,NBUF)=SIN(DTOR*TLAT(I  ,J  ,K))
                TBUF( 4,NBUF)=REAL(  LAND(I  ,J  ,K))
C
                TBUF( 5,NBUF)=COS(DTOR*TLAT(I+1,J  ,K))*
     +                        COS(DTOR*TLON(I+1,J  ,K))
                TBUF( 6,NBUF)=COS(DTOR*TLAT(I+1,J  ,K))*
     +                        SIN(DTOR*TLON(I+1,J  ,K))
                TBUF( 7,NBUF)=SIN(DTOR*TLAT(I+1,J  ,K))
                TBUF( 8,NBUF)=REAL(    LAND(I+1,J  ,K))
C
                TBUF( 9,NBUF)=COS(DTOR*TLAT(I+1,J+1,K))*
     +                        COS(DTOR*TLON(I+1,J+1,K))
                TBUF(10,NBUF)=COS(DTOR*TLAT(I+1,J+1,K))*
     +                        SIN(DTOR*TLON(I+1,J+1,K))
                TBUF(11,NBUF)=SIN(DTOR*TLAT(I+1,J+1,K))
                TBUF(12,NBUF)=REAL(    LAND(I+1,J+1,K))
C
                NBUF=NBUF+1
C
                TBUF( 1,NBUF)=COS(DTOR*TLAT(I  ,J  ,K))*
     +                        COS(DTOR*TLON(I  ,J  ,K))
                TBUF( 2,NBUF)=COS(DTOR*TLAT(I  ,J  ,K))*
     +                        SIN(DTOR*TLON(I  ,J  ,K))
                TBUF( 3,NBUF)=SIN(DTOR*TLAT(I  ,J  ,K))
                TBUF( 4,NBUF)=REAL(    LAND(I  ,J  ,K))
C
                TBUF( 5,NBUF)=COS(DTOR*TLAT(I+1,J+1,K))*
     +                        COS(DTOR*TLON(I+1,J+1,K))
                TBUF( 6,NBUF)=COS(DTOR*TLAT(I+1,J+1,K))*
     +                        SIN(DTOR*TLON(I+1,J+1,K))
                TBUF( 7,NBUF)=SIN(DTOR*TLAT(I+1,J+1,K))
                TBUF( 8,NBUF)=REAL(    LAND(I+1,J+1,K))
C
                TBUF( 9,NBUF)=COS(DTOR*TLAT(I  ,J+1,K))*
     +                        COS(DTOR*TLON(I  ,J+1,K))
                TBUF(10,NBUF)=COS(DTOR*TLAT(I  ,J+1,K))*
     +                        SIN(DTOR*TLON(I  ,J+1,K))
                TBUF(11,NBUF)=SIN(DTOR*TLAT(I  ,J+1,K))
                TBUF(12,NBUF)=REAL(    LAND(I  ,J+1,K))
C
              ELSE
C
                NBUF=NBUF+1
C
                TBUF( 1,NBUF)=COS(DTOR*TLAT(I  ,J  ,K))*
     +                        COS(DTOR*TLON(I  ,J  ,K))
                TBUF( 2,NBUF)=COS(DTOR*TLAT(I  ,J  ,K))*
     +                        SIN(DTOR*TLON(I  ,J  ,K))
                TBUF( 3,NBUF)=SIN(DTOR*TLAT(I  ,J  ,K))
                TBUF( 4,NBUF)=REAL(    LAND(I  ,J  ,K))
C
                TBUF( 5,NBUF)=COS(DTOR*TLAT(I+1,J  ,K))*
     +                        COS(DTOR*TLON(I+1,J  ,K))
                TBUF( 6,NBUF)=COS(DTOR*TLAT(I+1,J  ,K))*
     +                        SIN(DTOR*TLON(I+1,J  ,K))
                TBUF( 7,NBUF)=SIN(DTOR*TLAT(I+1,J  ,K))
                TBUF( 8,NBUF)=REAL(    LAND(I+1,J  ,K))
C
                TBUF( 9,NBUF)=COS(DTOR*TLAT(I  ,J+1,K))*
     +                        COS(DTOR*TLON(I  ,J+1,K))
                TBUF(10,NBUF)=COS(DTOR*TLAT(I  ,J+1,K))*
     +                        SIN(DTOR*TLON(I  ,J+1,K))
                TBUF(11,NBUF)=SIN(DTOR*TLAT(I  ,J+1,K))
                TBUF(12,NBUF)=REAL(    LAND(I  ,J+1,K))
C
                NBUF=NBUF+1
C
                TBUF( 1,NBUF)=COS(DTOR*TLAT(I+1,J  ,K))*
     +                        COS(DTOR*TLON(I+1,J  ,K))
                TBUF( 2,NBUF)=COS(DTOR*TLAT(I+1,J  ,K))*
     +                        SIN(DTOR*TLON(I+1,J  ,K))
                TBUF( 3,NBUF)=SIN(DTOR*TLAT(I+1,J  ,K))
                TBUF( 4,NBUF)=REAL(    LAND(I+1,J  ,K))
C
                TBUF( 5,NBUF)=COS(DTOR*TLAT(I+1,J+1,K))*
     +                        COS(DTOR*TLON(I+1,J+1,K))
                TBUF( 6,NBUF)=COS(DTOR*TLAT(I+1,J+1,K))*
     +                        SIN(DTOR*TLON(I+1,J+1,K))
                TBUF( 7,NBUF)=SIN(DTOR*TLAT(I+1,J+1,K))
                TBUF( 8,NBUF)=REAL(    LAND(I+1,J+1,K))
C
                TBUF( 9,NBUF)=COS(DTOR*TLAT(I  ,J+1,K))*
     +                        COS(DTOR*TLON(I  ,J+1,K))
                TBUF(10,NBUF)=COS(DTOR*TLAT(I  ,J+1,K))*
     +                        SIN(DTOR*TLON(I  ,J+1,K))
                TBUF(11,NBUF)=SIN(DTOR*TLAT(I  ,J+1,K))
                TBUF(12,NBUF)=REAL(    LAND(I  ,J+1,K))
C
              END IF
C
  105       CONTINUE
  106     CONTINUE
  107   CONTINUE
C
C Output all triangles remaining in the buffer.
C
        IF (NBUF.NE.0) THEN
          CALL CTTMTL (NBUF,TBUF,MBUF,NBUF,
     +                 IPPP,MPPP,NPPP,
     +                 IPPE,MPPE,NPPE,
     +                 RPNT,MPNT,NPNT,LOPN,
     +                 IEDG,MEDG,NEDG,LOEN,
     +                 ITRI,MTRI,NTRI,LOTN)
        END IF
C
C Set the pointers that tell the caller how many points and edges were
C created.
C
        NPNT=NPPP*LOPN
        NEDG=NPPE*LOEN
C
C Initialize the dummy-data generator and get data values for all the
C points of the mesh.
C
c       CALL TDGDIN (-1.,1.,-1.,1.,-1.,1.,21,21)
C
c       DO 108 I=0,NPNT-LOPN,LOPN
c         RPNT(I+4)=TDGDVA(RPNT(I+1),RPNT(I+2),RPNT(I+3))
c 108   CONTINUE
C
C Return the latitude and longitude of the approximate center point of
C the mesh on the globe.
C
        CLAT=0.
        CLON=0.
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE FNDBST (SLAT,SLON,IBST,JBST,KBST)
C
C Find that point in Houjun Wang's grid that is closest to the point
C with latitude SLAT and longitude SLON.
C
        COMMON /CMWNG1/ TLAT(8,8,96),TLON(8,8,96),ELAT(96),ELON(96)
C
C Initialize.
C
        IBST=0
        JBST=0
        KBST=0
        DBST=181.
C
C Find the index of the element whose center point is closest.
C
        DO 101 K=1,96
          DIST=ADSGCR(SLAT,SLON,ELAT(K),ELON(K))
          IF (DIST.LT.DBST) THEN
            KBST=K
            DBST=DIST
          END IF
  101   CONTINUE
C
C Now find the indices of the point of that element that is closest.
C
        DO 103 I=1,8
          DO 102 J=1,8
            DIST=ADSGCR(SLAT,SLON,TLAT(I,J,KBST),TLON(I,J,KBST))
            IF (DIST.LT.DBST) THEN
              IBST=I
              JBST=J
              DBST=DIST
            END IF
  102     CONTINUE
  103   CONTINUE
C
        RETURN
C
      END


      SUBROUTINE DSWNG1
C
C Draw the 96 simple rectangular grids that comprise the SEAM grid,
C using data passed in a common block.
C
        COMMON /CMWNG1/ TLAT(8,8,96),TLON(8,8,96),ELAT(96),ELON(96)
C
C Declare a character temporary in which to form labels.
C
        CHARACTER*2 CTMP
C
C Draw the grid.
C
        CALL PLOTIT (0,0,2)
        CALL GSPLCI (8)
        CALL GSLWSC (2.)
C
        DO 105 K=1,96
C
          DO 102 I=1,7
            DO 101 J=1,7
              CALL DRSGCR (TLAT(I  ,J  ,K),TLON(I  ,J  ,K),
     +                     TLAT(I  ,J+1,K),TLON(I  ,J+1,K))
  101       CONTINUE
  102     CONTINUE
C
          DO 104 J=1,7
            DO 103 I=1,7
              CALL DRSGCR (TLAT(I  ,J  ,K),TLON(I  ,J  ,K),
     +                     TLAT(I+1,J  ,K),TLON(I+1,J  ,K))
  103       CONTINUE
  104     CONTINUE
C
C Label each element with its index (from 1 to 96, inclusive).
C
          CALL MAPTRN (ELAT(K),ELON(K),XTMP,YTMP)
C
          IF (XTMP.NE.1.E12) THEN
            WRITE (CTMP,'(I2)') K
            IF (CTMP(1:1).EQ.' ') CTMP(1:1)='0'
            CALL PCSETI ('CC',1)
            CALL PLCHHQ (XTMP,YTMP,CTMP,.015,0.,0.)
            CALL PCSETI ('CC',-1)
          END IF
C
  105   CONTINUE
C
C Draw the continental outlines and lat/lon grid.
C
        CALL PLOTIT (0,0,2)
        CALL GSLWSC (1.)
        CALL GSPLCI (13)
        CALL MAPGRD
        CALL PLOTIT (0,0,2)
        CALL GSPLCI (14)
        CALL MAPLOT
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE DRSGCR (ALAT,ALON,BLAT,BLON)
C
C (DRSGCR = DRaw Shortest Great Circle Route)
C
C This routine draws the shortest great circle route joining two points
C on the globe.  Note that MPTS = INT(180./SIZE) + 1.
C
        PARAMETER (MPTS=181,SIZE=1.)
C
        DIMENSION QLAT(MPTS),QLON(MPTS)
C
        NPTS=MAX(1,MIN(MPTS,INT(ADSGCR(ALAT,ALON,BLAT,BLON)/SIZE)))
C
        CALL MAPGCI (ALAT,ALON,BLAT,BLON,NPTS,QLAT,QLON)
C
        CALL MAPIT (ALAT,ALON,0)
C
        DO 101 I=1,NPTS
          CALL MAPIT (QLAT(I),QLON(I),1)
  101   CONTINUE
C
        CALL MAPIT (BLAT,BLON,2)
C
        CALL MAPIQ
C
        RETURN
C
      END


      FUNCTION ADSGCR (ALAT,ALON,BLAT,BLON)
C
C (ADSGCR = Angle in Degrees along Shortest Great Circle Route)
C
C This function returns the shortest great circle distance, in degrees,
C between two points, A and B, on the surface of the globe.
C
        DATA DTOR / .017453292519943 /
        DATA RTOD / 57.2957795130823 /
C
        XCOA=COS(DTOR*ALAT)*COS(DTOR*ALON)
        YCOA=COS(DTOR*ALAT)*SIN(DTOR*ALON)
        ZCOA=SIN(DTOR*ALAT)
C
        XCOB=COS(DTOR*BLAT)*COS(DTOR*BLON)
        YCOB=COS(DTOR*BLAT)*SIN(DTOR*BLON)
        ZCOB=SIN(DTOR*BLAT)
C
        ADSGCR=2.*RTOD*ASIN(SQRT((XCOA-XCOB)**2+
     +                           (YCOA-YCOB)**2+
     +                           (ZCOA-ZCOB)**2)/2.)
C
        RETURN
C
      END


      SUBROUTINE IPIQOS (ALAT,ALON,BLAT,BLON,CLAT,CLON,DLAT,DLON,
     +                                       XFRA,YFRA,ELAT,ELON)
C
C (IPIQOS = Interpolate Point In Quadrilateral on Sphere)
C
C This routine, given the latitudes and longitudes of four points (A, B,
C C, and D) forming a "quadrilateral" on the globe and two interpolation
C fractions (XFRA and YFRA, each between 0 and 1, inclusive), finds the
C point E defined by the following diagram and returns its latitude and
C longitude.
C
C                              C------Q----D
C                              |      |    |
C                              |      E    |
C                              |      |    |
C                              |      |    |
C                              A------P----B
C
C P and Q are positioned such that AP/AB = CQ/CD = XFRA and then E is
C positioned such that PE/PQ = YFRA (where "XY" is interpreted to mean
C "the shortest great circle distance from X to Y").
C
C It is assumed that the "quadrilateral" ABDC is "convex" (a working
C definition of which might be that none of the four great circles
C defined by its edges - the ones through A and B, B and D, D and C,
C and C and A - cross it anywhere.  However, this is not verified.
C
C The code is easy:
C
        CALL FPSGCR (ALAT,ALON,BLAT,BLON,XFRA,PLAT,PLON)
        CALL FPSGCR (CLAT,CLON,DLAT,DLON,XFRA,QLAT,QLON)
        CALL FPSGCR (PLAT,PLON,QLAT,QLON,YFRA,ELAT,ELON)
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE FPSGCR (ALAT,ALON,BLAT,BLON,FRCT,FLAT,FLON)
C
C (FPSGCR = Find Point on Shortest Great Circle Route)
C
        REAL    ALAT,ALON,BLAT,BLON,FRCT,FLAT,FLON
C
C This routine, given the latitudes and longitudes of two points A and
C B on the surface of the globe and a fraction FRCT, between 0. and 1.,
C interpolates a point F along the shortest great circle route joining
C A to B such that the distance from A to F, divided by the distance
C from A to B, is equal to FRCT, and returns its latitude and longitude
C in FLAT and FLON.
C
C Define the constants used to convert from degrees to radians and
C vice-versa.
C
        DATA DTOR / .017453292519943 /
        DATA RTOD / 57.2957795130823 /
C
C Compute the X, Y, and Z coordinates (on a unit sphere) of the point B.
C
        CALL LLPXYZ (BLAT,BLON,XCPB,YCPB,ZCPB)
C
C Rotating about the Z axis by the angle -ALON would carry A into the XZ
C plane.
C
        CALL ROTXYZ (3,-ALON,XCPB,YCPB,ZCPB)
C
C Then, rotating about the Y axis by the angle ALAT would carry A into
C the point on the X axis with coordinates (1,0,0).
C
        CALL ROTXYZ (2,ALAT,XCPB,YCPB,ZCPB)
C
C Then, rotating about the X axis by the angle ALPH = -ATAN(ZCPB/YCPB)
C would leave the position of A unchanged but carry B into a point in
C the XY plane.
C
        IF (ZCPB.NE.0..OR.YCPB.NE.0.) THEN
          ALPH=-RTOD*ATAN2(ZCPB,YCPB)
        ELSE
          ALPH=0.
        END IF
C
        CALL ROTXYZ (1,ALPH,XCPB,YCPB,ZCPB)
C
C The angle BETA from A to B can now be computed easily.
C
        IF (XCPB.NE.0..OR.YCPB.NE.0.) THEN
          BETA=ATAN2(YCPB,XCPB)
        ELSE
          BETA=0.
        END IF
C
C Interpolate a point at the desired position between the points A and
C B, map it back to its original position on the great circle route from
C A to B, and get its latitude and longitude to return to the caller.
C
        GAMA=FRCT*BETA
C
        XCPF=COS(GAMA)
        YCPF=SIN(GAMA)
        ZCPF=0.
C
        CALL ROTXYZ (1,-ALPH,XCPF,YCPF,ZCPF)
        CALL ROTXYZ (2,-ALAT,XCPF,YCPF,ZCPF)
        CALL ROTXYZ (3, ALON,XCPF,YCPF,ZCPF)
C
        CALL XYZLLP (XCPF,YCPF,ZCPF,FLAT,FLON)
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE LLPXYZ (RLAT,RLON,RVOX,RVOY,RVOZ)
C
C (LLPXYZ = Lat/Lon Position to XYZ coordinates)
C
C Given the latitude and longitude of a point on the globe, return its
C X, Y, and Z coordinates.
C
        DATA DTOR / .017453292519943 /
C
        RVOX=COS(DTOR*RLAT)*COS(DTOR*RLON)
        RVOY=COS(DTOR*RLAT)*SIN(DTOR*RLON)
        RVOZ=SIN(DTOR*RLAT)
C
        RETURN
C
      END


      SUBROUTINE XYZLLP (RVOX,RVOY,RVOZ,RLAT,RLON)
C
C (XYZLLP = XYZ coordinates to Lat/Lon Position)
C
C Given the X, Y, and Z coordinates of a point on the globe, return its
C latitude and longitude.
C
        DATA RTOD / 57.2957795130823 /
C
        RLAT=RTOD*ASIN(RVOZ)
C
        IF (RVOX.NE.0.OR.RVOY.NE.0.) THEN
          RLON=RTOD*ATAN2(RVOY,RVOX)
        ELSE
          RLON=0.
        END IF
C
        RETURN
C
      END


      SUBROUTINE ROTXYZ (IAXS,ANGL,XCRD,YCRD,ZCRD)
C
C (ROTXYZ = ROTate a point defined by its X, Y, and Z coordinates)
C
C This is a modified version of a routine in the NCAR Graphics package,
C which is used in some of the examples.  It rotates the point having
C coordinates (XCRD,YCRD,ZCRD) by an angle ANGL about the axis specified
C by IAXS (1 for the X axis, 2 for the Y axis, 3 for the Z axis).
C
C One assumes a right-handed system with X, Y, and Z axes.  Rotating by
C an angle "a" about the X axis maps the point (x,y,z) into the point
C (x',y',z'), where
C
C       x' = x
C       y' = y cos(a) - z sin(a)
C       z' = z cos(a) + y sin(a)
C
C A positive value of "a" represents rotation in the direction from the
C Y axis to the Z axis.
C
C Similarly, rotating by an angle "a" about the Y axis maps the point
C (x,y,z) into the point (x',y',z'), where
C
C       x' = x cos(a) + z sin(a)
C       y' = y
C       z' = z cos(a) - x sin(a)
C
C A positive value of "a" represents rotation in the direction from the
C Z axis to the X axis.
C
C Rotating by an angle "a" about the Z axis maps the point (x,y,z) into
C the point (x',y',z'), where
C
C       x' = x cos(a) - y sin(a)
C       y' = y cos(a) + x sin(a)
C       y' = y
C
C A positive value of "a" represents rotation in the direction from the
C X axis to the Y axis.
C
C Define a multiplicative constant to convert from degrees to radians.
C
        DATA DTOR / .017453292519943 /
C
C Trigonometry.
C
        SINA=SIN(DTOR*ANGL)
        COSA=COS(DTOR*ANGL)
C
        XTMP=XCRD
        YTMP=YCRD
        ZTMP=ZCRD
C
        IF (IAXS.EQ.1) THEN
          YCRD=YTMP*COSA-ZTMP*SINA
          ZCRD=ZTMP*COSA+YTMP*SINA
        ELSE IF (IAXS.EQ.2) THEN
          XCRD=XTMP*COSA+ZTMP*SINA
          ZCRD=ZTMP*COSA-XTMP*SINA
        ELSE
          XCRD=XTMP*COSA-YTMP*SINA
          YCRD=YTMP*COSA+XTMP*SINA
        END IF
C
        RETURN
C
      END


      SUBROUTINE CTSCAE (ICRA,ICA1,ICAM,ICAN,XCPF,YCPF,XCQF,YCQF,
     +                                       IND1,IND2,ICAF,IAID)
        DIMENSION ICRA(ICA1,*)
C
C This routine is called by CTCICA when the internal parameter 'CAF' is
C given a negative value.  Each call is intended to create a particular
C element in the user's cell array.  The arguments are as follows:
C
C ICRA is the user's cell array.
C
C ICA1 is the first dimension of the FORTRAN array ICRA.
C
C ICAM and ICAN are the first and second dimensions of the cell array
C stored in ICRA.
C
C (XCPF,YCPF) is the point at that corner of the rectangular area
C into which the cell array maps that corresponds to the cell (1,1).
C The coordinates are given in the fractional coordinate system (unlike
C what is required in a call to GCA, in which the coordinates of the
C point P are in the world coordinate system).
C
C (XCQF,YCQF) is the point at that corner of the rectangular area into
C which the cell array maps that corresponds to the cell (ICAM,ICAN).
C The coordinates are given in the fractional coordinate system (unlike
C what is required in a call to GCA, in which the coordinates of the
C point Q are in the world coordinate system).
C
C IND1 is the 1st index of the cell that is to be updated.
C
C IND2 is the 2nd index of the cell that is to be updated.
C
C ICAF is the current value of the internal parameter 'CAF'.  This
C value will always be an integer which is less than zero (because
C when 'CAF' is zero or greater, this routine is not called).
C
C IAID is the area identifier associated with the cell.  It will have
C been given one of the values from the internal parameter array 'AIA'
C (the one for 'PAI' = -2 if the cell lies in an out-of-range area, the
C one for 'PAI' = -1 if the cell lies off the data grid, or the one for
C some value of 'PAI' between 1 and 'NCL' if the cell lies on the data
C grid).  The value zero may occur if the cell falls in an out-of-range
C area and the value of 'AIA' for 'PAI' = -2 is 0 or if the cell lies
C off the data grid and the value of 'AIA' for 'PAI' = -1 is 0, or if
C the cell falls on the data grid, but no contour level below the cell
C has a non-zero 'AIA' and no contour level above the cell has a
C non-zero 'AIB'.  Note that, if the values of 'AIA' for 'PAI' = -1
C and -2 are given non-zero values, IAID can only be given a zero
C value in one way.
C
C The default behavior of CTSCAE is as follows:  If the area identifier
C is non-negative, it is treated as a color index, to be stored in the
C appropriate cell in the cell array; but if the area identifier is
C negative, a zero is stored for the color index.  The user may supply
C a version of CTSCAE that does something different; it may simply map
C the area identifiers into color indices or it may somehow modify the
C existing cell array element to incorporate the information provided
C by the area identifier.
C
C       ICRA(IND1,IND2)=MAX(0,IAID)
C
C What follows is not the default behavior; instead, it is the behavior
C expected by many of the example programs for CONPACKT.
C
        CALL CTGETI ('NCL - NUMBER OF CONTOUR LEVELS',NOCL)
C
        IF (IAID.GE.1.AND.IAID.LE.NOCL+1) THEN
          ICRA(IND1,IND2)=151+INT(((REAL(IAID)-.5)/REAL(NOCL+1))*100.)
        ELSE IF (IAID.EQ.1001) THEN
          ICRA(IND1,IND2)=2
        ELSE IF (IAID.EQ.1002) THEN
          ICRA(IND1,IND2)=3
        END IF
C
        RETURN
C
      END

C
C	$Id: conrec.f,v 1.7 2008-07-27 00:23:01 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CONREC (Z,L,M,N,FLO,HI,FINC,NSET,NHI,NDOT)
C
C     DIMENSION OF           Z(L,N)
C     ARGUMENTS
C
C     PURPOSE                CONRECQCK draws a contour map from data stored
C                            in a rectangular array.  No line labels.
C
C     USAGE                  If the following assumptions are met, use
C
C                              CALL EZCNTR (Z,M,N)
C
C                              ASSUMPTIONS:
C                                  --All of the array is to be contoured.
C                                  --Contour levels are picked
C                                    internally.
C                                  --Contouring routine picks scale
C                                    factors.
C                                  --Highs and lows are marked.
C                                  --Negative lines are drawn with a
C                                    dashed line pattern.
C                                  --EZCNTR calls FRAME after drawing the
C                                    contour map.
C
C                            If these assumptions are not met, use
C
C                              CALL CONREC (Z,L,M,N,FLO,HI,FINC,NSET,
C                                           NHI,NDOT)
C
C     ARGUMENTS
C
C     ON INPUT               Z
C     FOR EZCNTR               M by N array to be contoured.
C
C                            M
C                              First dimension of Z.
C
C                            N
C                              Second dimension of Z.
C
C     ON OUTPUT              All arguments are unchanged.
C     FOR EZCNTR
C
C     ON INPUT               Z
C     FOR CONREC               The (origin of the) array to be
C                              contoured.  Z is dimensioned L by N.
C
C                            L
C                              The first dimension of Z in the calling
C                              program.
C
C                            M
C                              The number of data values to be contoured
C                              in the X-direction (the first subscript
C                              direction).  When plotting an entire
C                              array, L = M.
C
C                            N
C                              The number of data values to be contoured
C                              in the Y-direction (the second subscript
C                              direction).
C
C                            FLO
C                              The value of the lowest contour level.
C                              If FLO = HI = 0., a value rounded up from
C                              the minimum Z is generated by CONREC.
C
C                            HI
C                              The value of the highest contour level.
C                              If HI = FLO = 0., a value rounded down
C                              from the maximum Z is generated by
C                              CONREC.
C
C                            FINC
C                              > 0  Increment between contour levels.
C                              = 0  A value, which produces between 10
C                                   and 30 contour levels at nice values,
C                                   is generated by CONREC.
C                              < 0  The number of levels generated by
C                                   CONREC is ABS(FINC).
C
C                            NSET
C                              Flag to control scaling.
C                              = 0  CONREC automatically sets the
C                                   window and viewport to properly
C                                   scale the frame to the standard
C                                   configuration.
C                                   The GRIDAL entry PERIM is
C                                   called and tick marks are placed
C                                   corresponding to the data points.
C                              > 0  CONREC assumes that the user
C                                   has set the window and viewport
C                                   in such a way as to properly
C                                   scale the plotting
C                                   instructions generated by CONREC.
C                                   PERIM is not called.
C                              < 0  CONREC generates coordinates so as
C                                   to place the (untransformed) contour
C                                   plot within the limits of the
C                                   user's current window and
C                                   viewport.  PERIM is not called.
C
C                            NHI
C                              Flag to control extra information on the
C                              contour plot.
C                              = 0  Highs and lows are marked with an H
C                                   or L as appropriate, and the value
C                                   of the high or low is plotted under
C                                   the symbol.
C                              > 0  The data values are plotted at
C                                   each Z point, with the center of
C                                   the string indicating the data
C                                   point location.
C                              < 0  Neither of the above.
C
C                            NDOT
C                              A 10-bit constant designating the desired
C                              dashed line pattern.
C                              If ABS(NDOT) = 0, 1, or 1023, solid lines
C                              are drawn.
C                              > 0 NDOT pattern is used for all lines.
C                              < 0 ABS(NDOT) pattern is used for nega-
C                                tive-valued contour lines, and solid is
C                                used for positive-valued contours.
C                                CONREC converts NDOT
C                                to a 16-bit pattern and DASHDB is used.
C                                See DASHDB comments in the DASHLINE
C                                documentation for details.
C
C
C
C     ON OUTPUT              All arguments are unchanged.
C     FOR CONREC
C
C
C     ENTRY POINTS           CONREC, CLGEN, QUICK, MAXMIN, PNTVAL,
C                            CALCNT, EZCNTR, CONBD, CONBDX
C
C     COMMON BLOCKS          CONRE1, CONRE4, CONRE5
C
C     REQUIRED LIBRARY       GRIDAL, the ERPRT77 package, and the SPPS.
C     ROUTINES               DASHCHAR is also needed.
C
C     REQUIRED GKS LEVEL     0A
C
C     NOTE FOR NCAR USERS    This routine is NOT part of the default
C     USERS                  libraries at NCAR.  CONRECQCK must be
C                            be acquired, compiled and loaded to be
C                            used at NCAR.
C
C     I/O                    Plots contour map.
C
C     PRECISION              Single
C
C     LANGUAGE               FORTRAN 77
C
C     HISTORY                A faster version of CONREC without line
C                            labelling capabilities.
C
C     ALGORITHM              The grid space is divided into L*N
C                            cells.  Each cell is processed in turn,
C                            drawing all contour lines in the
C                            particular cell until the entire
C                            rectangular space is contoured.  (This
C                            could result in a relatively long plot
C                            time on mechanical plotters but does
C                            not affect the plot time on CRT-based
C                            plotters.
C
C     NOTE                   To draw non-uniform contour levels, see
C                            the comments in CLGEN.  To make special
C                            modifications for specific needs see the
C                            explanation of the internal parameters
C                            below.
C
C     TIMING                 Varies widely with size and smoothness of
C                            Z.
C
C     INTERNAL PARAMETERS    NAME   DEFAULT         FUNCTION
C                            ----   -------         --------
C
C                            ISIZEM   2      Size of labels for minimums
C                                            and maximums,
C                                            as per the size definitions
C                                            given in the SPPS
C                                            documentation for WTSTR.
C
C                            ISIZEP   0      Size of labels for data
C                                            point values as per the size
C                                            definitions given in the SPPS
C                                            documentation for WTSTR.
C
C                            NLA      16     Approximate number of
C                                            contour levels when
C                                            internally generated.
C
C                            NLM      40     Maximum number of contour
C                                            levels.  If this is to be
C                                            increased, the dimensions
C                                            of CL and RWORK in CONREC
C                                            must be increased by the
C                                            same amount.
C
C                            XLT      .05    Left hand edge of the plot
C                                            (0.0 is the left edge of
C                                            the frame and 1.0 is the
C                                            right edge of the frame.)
C
C                            YBT      .05    Bottom edge of the plot
C                                            (0.0 is the bottom of the
C                                            frame and 1.0 is the top
C                                            of the frame.)
C
C                            SIDE     0.9    Length of longer edge of
C                                            plot (see also EXT).
C
C                            IOFFD    0      Flag to control
C                                            normalization of label
C                                            numbers.
C                                            . IOFFD = 0 means include
C                                              decimal point when
C                                              possible (do not
C                                              normalize unless
C                                              required).
C                                            . IOFFD non-zero means
C                                              normalize all label
C                                              numbers and output a
C                                              scale factor in the
C                                              message below the graph.
C
C                            EXT      .25    Lengths of the sides of the
C                                            plot are proportional to M
C                                            and N (when CONREC sets
C                                            the window and viewport).
C                                            In extreme cases, when
C                                            MIN(M,N)/MAX(M,N) is less
C                                            than EXT, CONREC
C                                            produces a square plot.
C
C                            IOFFP      0    Flag to control special
C                                            value feature.
C                                            . IOFFP = 0 means special
C                                              value feature not in use.
C                                            . IOFFP non-zero means
C                                              special value feature in
C                                              use.  (SPVAL is set to the
C                                              special value.)  Contour
C                                              lines will then be
C                                              omitted from any cell
C                                              with any corner equal to
C                                              the special value.
C
C                            SPVAL    0.     Contains the special value
C                                            when IOFFP is non-zero.
C
C                            IOFFM    0      Flag to control the message
C                                            below the plot.
C                                            . IOFFM = 0  if the message
C                                              is to be plotted.
C                                            . IOFFM non-zero if the
C                                              message is to be omitted.
C
      SAVE
      CHARACTER       ENCSCR*22  ,IWORK*126
      DIMENSION       LNGTHS(5)  ,HOLD(5)
      DIMENSION       Z(L,N)     ,CL(40)
      DIMENSION       WIND(4)    ,VIEW(4)    ,RECT(4)
C
      COMMON /CONRE1/ IOFFP      ,SPVAL
      COMMON /CONRE4/ ISIZEL     ,ISIZEM     ,ISIZEP     ,NREP       ,
     1                NCRT       ,ILAB       ,NULBLL     ,IOFFD      ,
     2                EXT        ,IOFFM      ,ISOLID     ,NLA        ,
     3                NLM        ,XLT        ,YBT        ,SIDE
      COMMON /CONRE5/ SCLY
C
      DATA  LNGTHS(1),LNGTHS(2),LNGTHS(3),LNGTHS(4),LNGTHS(5)
     1      /  12,       3,        20,       9,        17       /
C
C Do a call forcing a BLOCKDATA to be loaded from a binary library.
C
      CALL CONBD
C
C THE FOLLOWING CALL IS FOR GATHERING STATISTICS ON LIBRARY USE AT NCAR
C
      CALL Q8QST4 ('GRAPHX','CONRECQCK','CONREC','VERSION 01')
C
C                       * * * * * * * * * *
C                            * * * * * * * * * *
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
      GL = FLO
      HA = HI
      GP = FINC
      MX = L
      NX = M
      NY = N
      IDASH = NDOT
C
      IF (IDASH.EQ.0 .OR. IDASH.EQ.1) IDASH = ISOLID
C
C SET CONTOUR LEVELS.
C
      CALL CLGEN (Z,MX,NX,NY,GL,HA,GP,NLA,NLM,CL,NCL,ICNST)
C
C
C                       * * * * * * * * * *
C                            * * * * * * * * * *
C
C
C Save the current SET parameters.
C
      CALL GETSET (VIEW(1),VIEW(2),VIEW(3),VIEW(4),
     +             WIND(1),WIND(2),WIND(3),WIND(4),IOLLS)
C
C SET UP SCALING  LABELS
C
      CALL GETUSV ( 'YF' , IYVAL )
      SCLY = 2.0 ** (IYVAL - 15)
C
C SET UP SCALING
C
      IF (NSET) 101,102,106
C
  101 X1 = VIEW(1)
      X2 = VIEW(2)
      Y1 = VIEW(3)
      Y2 = VIEW(4)
C
C
C
C
C
C DEFINE NORMALIZATION 1 AND LOG SCALING
C
      CALL SET(X1,X2,Y1,Y2,1.0,REAL(NX),1.0,REAL(NY),1)
      GO TO 106
  102 X1 = XLT
      X2 = XLT+SIDE
      Y1 = YBT
      Y2 = YBT+SIDE
      X3 = NX
      Y3 = NY
      IF (MIN(X3,Y3)/MAX(X3,Y3) .LT. EXT) GO TO 105
      IF (NX-NY) 103,105,104
  103 X2 = SIDE*X3/Y3+XLT
      GO TO 105
  104 Y2 = SIDE*Y3/X3+YBT
C
  105 CALL SET(X1,X2,Y1,Y2,1.0,X3,1.0,Y3,1)
      CALL PERIM (NX-1,1,NY-1,1)
  106 IF (ICNST .NE. 0) GO TO 111
C
C SET UP LABEL SCALING
C
      IOFFDT = IOFFD
      IF (GL.NE.0.0 .AND. (ABS(GL).LT.0.1 .OR. ABS(GL).GE.1.E5))
     1    IOFFDT = 1
      IF (HA.NE.0.0 .AND. (ABS(HA).LT.0.1 .OR. ABS(HA).GE.1.E5))
     1    IOFFDT = 1
      ASH = 10.**(3-INT(ALOG10(MAX(ABS(GL),ABS(HA),ABS(GP)))
     1                                                  -4999.999)-5000)
      IF (IOFFDT .EQ. 0) ASH = 1.
      IF (IOFFM .NE. 0) GO TO 110
         IWORK = 'CONTOUR FROM              TO              CONTOUR INTE
     1RVAL OF              PT(3,3)=              LABELS SCALED BY'
  107 CONTINUE
      HOLD(1) = GL
      HOLD(2) = HA
      HOLD(3) = GP
      HOLD(4) = Z(3,3)
      HOLD(5) = ASH
      NCHAR = 0
      DO 109 I=1,5
         WRITE (ENCSCR,'(G13.5)') HOLD(I)
         NCHAR = NCHAR+LNGTHS(I)
         DO 108 J=1,13
            NCHAR = NCHAR+1
            IWORK(NCHAR:NCHAR) = ENCSCR(J:J)
  108    CONTINUE
  109 CONTINUE
      IF (ASH .EQ. 1.) NCHAR = NCHAR-13-LNGTHS(5)
C
C WRITE PLOT TITLE
C
C
      CALL GQCLIP (IERR,ICLP,RECT)
      CALL GSCLIP (0)
      CALL WTSTR (CFUX(.5),CFUY(.015625),IWORK(1:NCHAR),0,0,0)
      CALL GSCLIP (ICLP)
C
C
C PROCESS ENTIRE GRID
C
C
C CHANGE 10 BIT PATTERN TO 16 BIT PATTERN FOR USE WITH DASHD
C
  110 IDASH = IOR ( ISHIFT(IDASH,6) , ISHIFT(IDASH,-4) )
      CALL DASHDB ( IDASH )
      CALL QUICK (Z,L,M,N,NCL,CL)
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C FIND RELATIVE MINIMUMS AND MAXIMUMS IF WANTED, AND MARK VALUES IF
C WANTED.
C
      IF (NHI .EQ. 0) CALL MAXMIN (Z,MX,NX,NY,ISIZEM,ASH,IOFFDT)
      IF (NHI .GT. 0) CALL MAXMIN (Z,MX,NX,NY,ISIZEP,-ASH,IOFFDT)
C
      GO TO 114
  111 CONTINUE
         IWORK = 'CONSTANT FIELD'
  112 CONTINUE
      WRITE (ENCSCR,'(G22.14)') GL
      DO 113 I=1,22
      IWORK(I+14:I+14) = ENCSCR(I:I)
  113 CONTINUE
C
C WRITE TITLE
      CALL GQCLIP (IERR,ICLP,RECT)
      CALL GSCLIP (0)
      CALL WTSTR (CFUX(.09765),CFUY(.48828),IWORK(1:36),3,0,-1 )
      CALL GSCLIP (ICLP)
  114 CONTINUE
C
C RESTORE NORMALIZATION TRANSFORMATION 1
C
      IF (NSET.LE.0)
     +    CALL SET(VIEW(1),VIEW(2),VIEW(3),VIEW(4),
     +             WIND(1),WIND(2),WIND(3),WIND(4),IOLLS)
C
C
C
C
C
C
      RETURN
C
C
      END

C
C	$Id: g01wdr.f,v 1.13 2008-07-27 00:21:06 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
        SUBROUTINE G01WDR(WKID,METANM)
C
C***********************************************************************
C***********************************************************************
C**                                                                   **
C**                                                                   **
C**            Workstation driver for workstation type 1              **
C**                       NCAR CGM generator                          **
C**                                                                   **
C**                                                                   **
C***********************************************************************
C***********************************************************************
C
      IMPLICIT INTEGER (A-Z)
      CHARACTER*(*) METANM
      CHARACTER*60 BEGSTR
C
C  Include all COMMONs .
C
      include 'g01prm.h'
      include 'gksin.h'
      include 'g01wdt.h'
      include 'g01wsl.h'
      include 'g01adc.h'
      include 'g01rqa.h'
      include 'g01ast.h'
      include 'g01dfa.h'
      include 'g01io.h'
      include 'g01ins.h'
      include 'g01opc.h'
      include 'gksenu.h'
C
      INTEGER   G01PBL
      CHARACTER FNAME*1024,DNAME*1
C
      DATA BEGSTR
     - /'                                                            '/
C
C  Initialize for this entry.
C
C  Clear the workstation interface error parameter.
C
      RERR = 0
C
C  Check FCODE if last invocation indicated continuation.
C
      IF (MCONTS.EQ.1 .AND. FCODE.NE.MCODES)  GOTO 905
C
C  Copy and save function code and continuation flag.
C
        MCODES = FCODE
        MCONTS = CONT
C
C  Branch for function processing.  Testing of code organized to
C  minimize number of tests, by testing for most frequently expected
C  functions first.
C
C
C  Output primitives.
C
C      Code:  11   12   13   14   15   16
      GOTO  (110, 120, 130, 140, 150, 160)  MCODES-10
C
C  Primitive attributes.
C
      IF (MCODES.GE.21 .AND. MCODES.LE.43)  THEN
        CALL G01PAT
        RETURN
      END IF
C
C  Control and escape functions.
C
C     Code:  -6,  -5,  -4,  -3   -2   -1    0    1
      GOTO (180, 190, 200, 210, 220, 230, 240, 250,
     +      910, 270, 910, 910, 300)  MCODES+7
C     Code:   2    3    4    5    6
C
C
C  Clipping control function(s).
C
      IF (MCODES.EQ.61)  THEN
        CALL G01CLP(0)
        RETURN
      END IF
C
C  Color table.
C
      IF (MCODES.EQ.56)  THEN
        CALL G01CTB
        RETURN
      END IF
C
C  New picture initialization.
C
      IF (MCODES .EQ. 91)  THEN
        CALL G01SNP(RERR)
        RETURN
      END IF
C
C  Set picture name.
C
      IF (MCODES.EQ.92) THEN
        MPNAME(1:60) = STR(1:60)
        RETURN
      ENDIF
C
C  Message for ctrans pause.
C
      IF (MCODES.EQ.93) THEN
        CALL G01MSG(1)
        RETURN
      ENDIF
C
C  Workstation transformation.
C
      IF (MCODES.EQ.71 .OR. MCODES.EQ.72)  THEN
        CALL G01WKT
        RETURN
      END IF
C
C  Segmentation functions.
C
      IF (MCODES.GE.80 .AND. MCODES.LE.84) THEN
        CALL G01SEG
        RETURN
      ENDIF
C
C  WDT inquiry (-100 thru -199)
C
      IF (MCODES.LE.-100 .AND. MCODES.GE.-199)  THEN
        CALL G01DIQ
        RETURN
      END IF
C
C  WSL inquiry (-200 thru -299)
C
      IF (MCODES.LE.-200 .AND. MCODES.GE.-299)  THEN
        CALL G01SIQ
        RETURN
      END IF
C
C  Fall through means undefined opcode.
C
        GOTO 910
C
C **********************************************************************
C *                                                                    *
C *          ========== OUTPUT PRIMITIVE PROCESSING ==========         *
C *                                                                    *
C **********************************************************************
C
C  POLYLINE.
C
  110 CONTINUE
      CALL G01PL
      RETURN
C
C  POLYMARKER.
C
  120 CONTINUE
      CALL G01PM
      RETURN
C
C  TEXT
C
  130 CONTINUE
      CALL G01TX
      RETURN
C
C  FILL AREA
C
  140 CONTINUE
      CALL G01FA
      RETURN
C
C  CELL ARRAY
C
  150 CONTINUE
      CALL G01CA
      RETURN
C
C  GDP (Not supported, just generates error).
C
  160 CONTINUE
      RERR = 104
      RETURN
C
C **********************************************************************
C *                                                                    *
C *         ---------- CONTROL FUNCTION PROCESSING ----------          *
C *                                                                    *
C **********************************************************************
C
C  Dump all attribute settings.
C
  180 CONTINUE
      CALL G01DMP(0)
      RETURN
C
C  Terminate workstation without putting out an END PICTURE or an
C  END METAFILE.
C
  190 CONTINUE
C
C  Mark workstation closed, flush buffer, close the output unit.
C
      MOPEN = GNO
C
C  Set parameters to tell G01CLW to conditionally finish picture and
C  not to put out an END PICTURE.
C
      ID(2) = GCONDI
      ID(3) = 0
      CALL G01CLW
C
C  Call central I/O routine to indicate file close.
C
      CALL G01MIO (2, MFGLUN, DNAME, MOUTBF, 1, RERR)
      RETURN
C
C  RE-OPEN WORKSTATION
C
  200 CONTINUE
C
      IF (CONT .EQ. 0) THEN
C
C  Call routine to flag memory resident files for UNIX ICTRANS use.
C
        CALL GOPNIC(IDUM)
C
C  Mark workstation open in WSL, set workstation ID, connection ID,
C  and workstation type.
C
        MOPEN  = GYES
        MWKID  = WKID
        MCONID = ID(2)
        MWTYPE = ID(3)
C
C  Set the file name.
C
        FNAME = METANM
        CALL GTNLEN(FNAME,ILEN,IER)
        IF (IER .EQ. 0) FNAME(ILEN+1:ILEN+1) = CHAR(0)
C
C  Initialize current-buffer-position pointer.
C
        MBFPOS = 32
C
C  Set number of bits per metacode record.
C
        MXBITS = 11520
C
C  Compute number of integer words needed for output buffer (MOUTBF).
C
        MOBFSZ = 1 + (MXBITS-1)/I1MACH(5)
C
C  Set data type for NCAR CGM.
C
        MDTYPE = 3
C
C  Copy LUN for output.
C
        MFGLUN = MCONID
C
C  Initialize begin-metafile and end-metafile flags.
C
        MBMFLG = GNO
        MEMFLG = GNO
C
C  Open metacode output unit.
C
        CALL G01MIO(11, MFGLUN, FNAME(1:ILEN), MOUTBF, MOBFSZ, RERR)
        IF (RERR .NE. 0)  RETURN
C
C  Determine the number of records in the file.
C
        MRECNM = 0
  100   CONTINUE
        CALL G01MIO(4, MFGLUN, DNAME, MOUTBF, MOBFSZ, RERR)
        IF (RERR .NE. 0) THEN
          IF (RERR .EQ. -1) THEN
            GO TO 105
          ELSE
            RETURN
          ENDIF
        ENDIF
        MRECNM = MRECNM+1
        GO TO 100
  105   CONTINUE
C
C  Back over the final record and read it.
C
        CALL G01MIO(7, MFGLUN, DNAME, MOUTBF, MOBFSZ, RERR)
        CALL G01MIO(6, MFGLUN, DNAME, IDM, 1, RERR)
        CALL G01MIO(7, MFGLUN, DNAME, MOUTBF, MOBFSZ, RERR)
        CALL G01MIO(4, MFGLUN, DNAME, MOUTBF, MOBFSZ, RERR)
        CALL G01MIO(7, MFGLUN, DNAME, MOUTBF, MOBFSZ, RERR)
C
C  If the record is an END METAFILE, back over it.
C
        CALL GBYTES(MOUTBF, IMFTMP, 0, 32, 0, 1)
        IF (IMFTMP .EQ. 143872) THEN
          CALL G01MIO(6, MFGLUN, DNAME, IDM, 1, RERR)
          CALL G01MIO(7, MFGLUN, DNAME, MOUTBF, MOBFSZ, RERR)
          IF (RERR .NE. 0)  RETURN
          MRECNM = MRECNM-1
        ENDIF
C
C  Back over the current last record and read it.
C
        CALL G01MIO(6, MFGLUN, DNAME, IDM, 1, RERR)
        CALL G01MIO(7, MFGLUN, DNAME, MOUTBF, MOBFSZ, RERR)
        CALL G01MIO(4, MFGLUN, DNAME, MOUTBF, MOBFSZ, RERR)
        CALL G01MIO(7, MFGLUN, DNAME, MOUTBF, MOBFSZ, RERR)
C
        CALL GBYTES(MOUTBF, IMFBSZ, 0, 16, 0, 1)
        CALL GBYTES(MOUTBF, IMFENP, (IMFBSZ+2)*8, 16, 0, 1)
        IF (IMFENP.NE.160 .AND. MRECNM.GT.1) THEN
C
C  No END PICTURE in current record; return an error flag of -10 to 
C  indicate a break in the middle of a picture; if the metafile
C  has only a single record (MRECNM = 1), then it doesn't have an
C  END PICTURE, but the reopen is still technically at a picture break,
C  so we do not flag a mid-picture file in that case.
C
          RERR = -10
          MDEMPT = GNEMPT
          RETURN
        ENDIF
C     
C  Initialize workstation state list parameters.
C
        CALL  G01IWS
C
C  Initialize attribute context.
C
        CALL  G01IAC
C
C  Initialize new-frame flag.
C
        MNFFLG = GNO
C
        RETURN
      ENDIF
C
C  OPEN WORKSTATION
C
  210 CONTINUE
C
C  Call routine to flag memory resident files for UNIX ICTRANS use.
C
      CALL GOPNIC(IDUM)
C
C  Mark workstation open in WSL, set workstation ID, connection ID,
C  and workstation type.
C
      MOPEN  = GYES
      MWKID  = WKID
      MCONID = ID(2)
      MWTYPE = ID(3)
C
C  Set the file name.
C
      IF (METANM(1:7) .EQ. 'DEFAULT') THEN
        FNAME = 'GMETA'
        ILEN = 5
      ELSE
        FNAME = METANM
        CALL GTNLEN(FNAME,ILEN,IER)
        FNAME(ILEN+1:ILEN+1) = CHAR(0)
      ENDIF
C
C  Initialize metacode record number.
C
      MRECNM = 1
C
C  Copy LUN for output.
C
      MFGLUN = MCONID
C
C  Open  metacode output unit.
C
      CALL G01MIO (1, MFGLUN, FNAME(1:ILEN), MOUTBF, 1, RERR)
      IF (RERR .NE. 0)  RETURN
C
C  Initialize current-buffer-position pointer.
C
      MBFPOS = 32
C
C  Set number of bits per metacode record.
C
      MXBITS = 11520
C
C  Compute number of integer words needed for output buffer (MOUTBF).
C
      MOBFSZ = 1 + (MXBITS-1)/I1MACH(5)
C
C  Set data type for NCAR CGM.
C
      MDTYPE = 3
C
C  Initialize workstation state list parameters.
C
      CALL  G01IWS
C
C  Initialize attribute context.
C
      CALL  G01IAC
C
C  Initialize new-frame, begin-metafile, end-metafile flags.
C
      MNFFLG = GNO
      MBMFLG = GYES
      MEMFLG = GNO
C
C  Generate BEGIN METAFILE element, 60 blank characters.
C
      CALL GPUTNI (CLBEGM, IDBEGM, G01PBL(60,0), RERR)
      CALL GPUTPS (BEGSTR, 60, 60, 0, RERR)
      IF (RERR .NE. 0)  RETURN
C
C  Put out METAFILE DESCRIPTOR and flush.
C
      CALL GPUTMD (RERR)
      CALL G01FLB (RERR)
      RETURN
C
C  Activate workstation.
C
  220 CONTINUE
      MSTATE = GACTIV
      RETURN
C
C  Deactivate workstation.
C
  230 CONTINUE
      MSTATE = GINACT
      RETURN
C
C  Close workstation.
C
  240 CONTINUE
C
C  Mark workstation closed, flush buffer, close the output unit.
C
      MOPEN = GNO
C
C  Set parameter to tell G01CLW to conditionally finish picture and
C  put out an END PICTURE.
C
      ID(2) = GCONDI
      ID(3) = 1
      CALL G01CLW
C
C  Put out END METAFILE record.
C
      MNFFLG = GNO
      MEMFLG = GYES
      MBFPOS = 32
      CALL GPUTNI (CLENDM, IDENDM, 0, RERR)
      CALL G01FLB (RERR)
C
C  Call central I/O routine to indicate 'CLOSE WORKSTATION'.
C
      CALL G01MIO (2, MFGLUN, DNAME, MOUTBF, 1, RERR)
      RETURN
C
C  Clear workstation.
C
  250 CONTINUE
      ID(3) = 1
      CALL G01CLW
      RETURN
C
C  Update workstation.
C
  270 CONTINUE
C
C  Flush output buffer.
C
      CALL G01FLB (RERR)
      RETURN
C
C  ESCAPE.
C
  300 CONTINUE
      CALL G01ESC
      RETURN
C
C
C  New code on 1st WSI call after a call indicating continuation.
C
  905 CONTINUE
      RERR = 325
      RETURN
C
C  Undefined/unsupported opcode.
C
  910 CONTINUE
      RERR = 320
      RETURN
C
      END

      SUBROUTINE ZPOTRS( UPLO, N, NRHS, A, LDA, B, LDB, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER          UPLO
      INTEGER            INFO, LDA, LDB, N, NRHS
*     ..
*     .. Array Arguments ..
      COMPLEX*16         A( LDA, * ), B( LDB, * )
*     ..
*
*  Purpose
*  =======
*
*  ZPOTRS solves a system of linear equations A*X = B with a Hermitian
*  positive definite matrix A using the Cholesky factorization
*  A = U**H*U or A = L*L**H computed by ZPOTRF.
*
*  Arguments
*  =========
*
*  UPLO    (input) CHARACTER*1
*          = 'U':  Upper triangle of A is stored;
*          = 'L':  Lower triangle of A is stored.
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  NRHS    (input) INTEGER
*          The number of right hand sides, i.e., the number of columns
*          of the matrix B.  NRHS >= 0.
*
*  A       (input) COMPLEX*16 array, dimension (LDA,N)
*          The triangular factor U or L from the Cholesky factorization
*          A = U**H*U or A = L*L**H, as computed by ZPOTRF.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(1,N).
*
*  B       (input/output) COMPLEX*16 array, dimension (LDB,NRHS)
*          On entry, the right hand side matrix B.
*          On exit, the solution matrix X.
*
*  LDB     (input) INTEGER
*          The leading dimension of the array B.  LDB >= max(1,N).
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*
*  =====================================================================
*
*     .. Parameters ..
      COMPLEX*16         ONE
      PARAMETER          ( ONE = ( 1.0D+0, 0.0D+0 ) )
*     ..
*     .. Local Scalars ..
      LOGICAL            UPPER
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           XERBLA, ZTRSM
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      UPPER = LSAME( UPLO, 'U' )
      IF( .NOT.UPPER .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( NRHS.LT.0 ) THEN
         INFO = -3
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -5
      ELSE IF( LDB.LT.MAX( 1, N ) ) THEN
         INFO = -7
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'ZPOTRS', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 .OR. NRHS.EQ.0 )
     $   RETURN
*
      IF( UPPER ) THEN
*
*        Solve A*X = B where A = U'*U.
*
*        Solve U'*X = B, overwriting B with X.
*
         CALL ZTRSM( 'Left', 'Upper', 'Conjugate transpose', 'Non-unit',
     $               N, NRHS, ONE, A, LDA, B, LDB )
*
*        Solve U*X = B, overwriting B with X.
*
         CALL ZTRSM( 'Left', 'Upper', 'No transpose', 'Non-unit', N,
     $               NRHS, ONE, A, LDA, B, LDB )
      ELSE
*
*        Solve A*X = B where A = L*L'.
*
*        Solve L*X = B, overwriting B with X.
*
         CALL ZTRSM( 'Left', 'Lower', 'No transpose', 'Non-unit', N,
     $               NRHS, ONE, A, LDA, B, LDB )
*
*        Solve L'*X = B, overwriting B with X.
*
         CALL ZTRSM( 'Left', 'Lower', 'Conjugate transpose', 'Non-unit',
     $               N, NRHS, ONE, A, LDA, B, LDB )
      END IF
*
      RETURN
*
*     End of ZPOTRS
*
      END

C
C $Id: tdplch.f,v 1.5 2008-07-27 00:17:33 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE TDPLCH (XPOS,YPOS,CHRS,SIZE,ANGD,CNTR)
C
        CHARACTER CHRS*(*)
C
C This is a 3D entry for the routine PLCHHQ.  It is expected that the
C caller has done a call to TDPARA, defining a parallelogram in 3-space
C within which characters are to be placed.  It just sets the PLOTCHAR
C mapping flag to the appropriate value, calls PLCHHQ, and then resets
C the mapping flag to its original value.
C
        CALL PCGETI ('MA - MAPPING FLAG      ',IMAP)
        CALL PCGETR ('OR - OUT-OF-RANGE VALUE',OORV)
        CALL PCSETI ('MA - MAPPING FLAG      ',3)
        CALL PCSETR ('OR - OUT-OF-RANGE VALUE',1.E12)
        CALL PLCHHQ (XPOS,YPOS,CHRS,SIZE,ANGD,CNTR)
        CALL PCSETI ('MA - MAPPING FLAG      ',IMAP)
        CALL PCSETR ('OR - OUT-OF-RANGE VALUE',OORV)
C
C Done.
C
        RETURN
C
      END

C
C $Id: tick3.f,v 1.6 2008-07-27 00:17:34 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE TICK3 (MAG,MIN)
      CALL TICK43 (MAG,MIN,MAG,MIN,MAG,MIN)
      RETURN
      END

      PROGRAM FAGCUCLR
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER (NPTS=200)
      PARAMETER (NCURVE=4)
      REAL YDRA(NPTS,NCURVE),XDRA(NPTS)

      DO 10 I=1,NPTS
          XDRA(I  )=I*0.1
          DO 10 J=1,NCURVE
              YDRA(I,J)=SIN(XDRA(I)+0.2*J)*EXP(-0.01*XDRA(I)*J**2)
  10  CONTINUE
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)

      CALL DEFCLR(IWKID)

      CALL EZMXY (XDRA,YDRA,NPTS,NCURVE,NPTS,'CURVE COLORS$')
C
C  Deactivate and close the workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS

      STOP
      END

      SUBROUTINE DEFCLR (IWKID)
      CALL GSCR(IWKID, 0, 0.0, 0.0, 0.0)
      CALL GSCR(IWKID, 1, 1.0, 1.0, 1.0)
      CALL GSCR(IWKID, 2, 1.0, 0.0, 0.0)
      CALL GSCR(IWKID, 3, 0.0, 1.0, 0.0)
      CALL GSCR(IWKID, 4, 0.4, 0.7, 0.9)
      CALL GSCR(IWKID, 5, 0.7, 0.4, 0.7)
      CALL GSCR(IWKID, 6, 0.9, 0.7, 0.4)
      CALL GSCR(IWKID, 7, 0.4, 0.9, 0.7)
      RETURN
      END

      SUBROUTINE AGCHCU(IFLG,KDSH)
      CALL PLOTIF (0.,0.,2)
      IF (IFLG .EQ. 0) THEN
          CALL GSPLCI( ABS(KDSH)+3 )
          CALL GSTXCI( ABS(KDSH)+3 )
      ELSE
          CALL GSPLCI(1)
          CALL GSTXCI(1)
      ENDIF
      RETURN
      END

C NCLFORTSTART
      subroutine betainc (x,a,b,result)
      implicit none
      double precision x,a,b,result

c NCL: alpha = betainc (x,a,b)
C NCLEND
      double precision dbetaislatec

      result = dbetaislatec(x,a,b)
      return
      end

c -----------------------------------------------
c All funtion names were changed by appending "SLATEC" to them
c I did this to avoid naming conflicts
c ----------------------------------------

      DOUBLE PRECISION FUNCTION DBETAISLATEC (X, PIN, QIN)
C***BEGIN PROLOGUE  DBETAISLATEC
C***PURPOSE  Calculate the incomplete Beta function.
C***LIBRARY   SLATEC (FNLIB)
C***CATEGORY  C7F
C***TYPE      DOUBLE PRECISION (BETAI-S, DBETAI-D)
C***KEYWORDS  FNLIB, INCOMPLETE BETA FUNCTION, SPECIAL FUNCTIONS
C***AUTHOR  Fullerton, W., (LANL)
C***DESCRIPTION
C
C   DBETAI calculates the DOUBLE PRECISION incomplete beta function.
C
C   The incomplete beta function ratio is the probability that a
C   random variable from a beta distribution having parameters PIN and
C   QIN will be less than or equal to X.
C
C     -- Input Arguments -- All arguments are DOUBLE PRECISION.
C   X      upper limit of integration.  X must be in (0,1) inclusive.
C   PIN    first beta distribution parameter.  PIN must be .GT. 0.0.
C   QIN    second beta distribution parameter.  QIN must be .GT. 0.0.
C
C***REFERENCES  Nancy E. Bosten and E. L. Battiste, Remark on Algorithm
C                 179, Communications of the ACM 17, 3 (March 1974),
C                 pp. 156.
C***ROUTINES CALLED  D1MACH, DLBETA, XERDJS
C***REVISION HISTORY  (YYMMDD)
C   770701  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890911  Removed unnecessary intrinsics.  (WRB)
C   890911  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERDJS.  (THJ)
C   920528  DESCRIPTION and REFERENCES sections revised.  (WRB)
C***END PROLOGUE  DBETAI
      DOUBLE PRECISION X, PIN, QIN, ALNEPS, ALNSML, C, EPS, FINSUM, P,
     1  PS, Q, SML, TERM, XB, XI, Y, D1MACH, DLBETASLATEC, P1
      LOGICAL FIRST
      SAVE EPS, ALNEPS, SML, ALNSML, FIRST
      DATA FIRST /.TRUE./
C***FIRST EXECUTABLE STATEMENT  DBETAI
      IF (FIRST) THEN
         EPS = D1MACH(3)
         ALNEPS = LOG (EPS)
         SML = D1MACH(1)
         ALNSML = LOG (SML)
      ENDIF
      FIRST = .FALSE.
C
cdjs  18 JAN 2016
cdjs  IF (X .LT. 0.D0 .OR. X .GT. 1.D0) CALL XERDJS ('SLATEC/NCL', 
cdjs +   'DBETAI','X IS NOT IN THE RANGE (0,1)', 1, 2)
cdjs  IF (PIN .LE. 0.D0 .OR. QIN .LE. 0.D0) CALL XERDJS ('SLATEC/NCL',
cdjs +   'DBETAI', 'P AND/OR Q IS LE ZERO', 2, 2)
C
      IF (X .LT. 0.D0 .OR. X .GT. 1.D0 .OR.
     +    PIN .LE. 0.D0 .OR. QIN .LE. 0.D0) THEN
          DBETAISLATEC = 1.0D30
          RETURN
      END IF
C
      Y = X
      P = PIN
      Q = QIN
      IF (Q.LE.P .AND. X.LT.0.8D0) GO TO 20
      IF (X.LT.0.2D0) GO TO 20
      Y = 1.0D0 - Y
      P = QIN
      Q = PIN
C
 20   IF ((P+Q)*Y/(P+1.D0).LT.EPS) GO TO 80
C
C EVALUATE THE INFINITE SUM FIRST.  TERM WILL EQUAL
C Y**P/BETA(PS,P) * (1.-PS)-SUB-I * Y**I / FAC(I) .
C
      PS = Q - AINT(Q)
      IF (PS.EQ.0.D0) PS = 1.0D0
      XB = P*LOG(Y) - DLBETASLATEC(PS,P) - LOG(P)
      DBETAISLATEC = 0.0D0
      IF (XB.LT.ALNSML) GO TO 40
C
      DBETAISLATEC = EXP (XB)
      TERM = DBETAISLATEC*P
      IF (PS.EQ.1.0D0) GO TO 40
      N = MAX (ALNEPS/LOG(Y), 4.0D0)
      DO 30 I=1,N
        XI = I
        TERM = TERM * (XI-PS)*Y/XI
        DBETAISLATEC = DBETAISLATEC + TERM/(P+XI)
 30   CONTINUE
C
C NOW EVALUATE THE FINITE SUM, MAYBE.
C
 40   IF (Q.LE.1.0D0) GO TO 70
C
      XB = P*LOG(Y) + Q*LOG(1.0D0-Y) - DLBETASLATEC(P,Q) - LOG(Q)
      IB = MAX (XB/ALNSML, 0.0D0)
      TERM = EXP(XB - IB*ALNSML)
      C = 1.0D0/(1.D0-Y)
      P1 = Q*C/(P+Q-1.D0)
C
      FINSUM = 0.0D0
      N = Q
      IF (Q.EQ.DBLE(N)) N = N - 1
      DO 50 I=1,N
        IF (P1.LE.1.0D0 .AND. TERM/EPS.LE.FINSUM) GO TO 60
        XI = I
        TERM = (Q-XI+1.0D0)*C*TERM/(P+Q-XI)
C
        IF (TERM.GT.1.0D0) IB = IB - 1
        IF (TERM.GT.1.0D0) TERM = TERM*SML
C
        IF (IB.EQ.0) FINSUM = FINSUM + TERM
 50   CONTINUE
C
 60   DBETAISLATEC = DBETAISLATEC + FINSUM
 70   IF (Y.NE.X .OR. P.NE.PIN) DBETAISLATEC = 1.0D0 - DBETAISLATEC
      DBETAISLATEC = MAX (MIN (DBETAISLATEC, 1.0D0), 0.0D0)
      RETURN
C
 80   DBETAISLATEC = 0.0D0
      XB = P*LOG(MAX(Y,SML)) - LOG(P) - DLBETASLATEC(P,Q)
      IF (XB.GT.ALNSML .AND. Y.NE.0.0D0) DBETAISLATEC = EXP(XB)
      IF (Y.NE.X .OR. P.NE.PIN) DBETAISLATEC = 1.0D0 - DBETAISLATEC
C
      RETURN
      END
C===> DECK D9LGMC
      DOUBLE PRECISION FUNCTION D9LGMCSLATEC (X)
C***BEGIN PROLOGUE  D9LGMC
C***SUBSIDIARY
C***PURPOSE  Compute the log Gamma correction factor so that
C            LOG(DGAMMA(X)) = LOG(SQRT(2*PI)) + (X-5.)*LOG(X) - X
C            + D9LGMC(X).
C***LIBRARY   SLATEC (FNLIB)
C***CATEGORY  C7E
C***TYPE      DOUBLE PRECISION (R9LGMC-S, D9LGMC-D, C9LGMC-C)
C***KEYWORDS  COMPLETE GAMMA FUNCTION, CORRECTION TERM, FNLIB,
C             LOG GAMMA, LOGARITHM, SPECIAL FUNCTIONS
C***AUTHOR  Fullerton, W., (LANL)
C***DESCRIPTION
C
C Compute the log gamma correction factor for X .GE. 10. so that
C LOG (DGAMMA(X)) = LOG(SQRT(2*PI)) + (X-.5)*LOG(X) - X + D9lGMC(X)
C
C Series for ALGM       on the interval  0.          to  1.00000E-02
C                                        with weighted error   1.28E-31
C                                         log weighted error  30.89
C                               significant figures required  29.81
C                                    decimal places required  31.48
C
C***REFERENCES  (NONE)
C***ROUTINES CALLED  D1MACH, DCSEVL, INITDS, XERDJS
C***REVISION HISTORY  (YYMMDD)
C   770601  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890531  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERDJS.  (THJ)
C   900720  Routine changed from user-callable to subsidiary.  (WRB)
C***END PROLOGUE  D9LGMC
      DOUBLE PRECISION X, ALGMCS(15), XBIG, XMAX, DCSEVLSLATEC, D1MACH
      LOGICAL FIRST
      SAVE ALGMCS, NALGM, XBIG, XMAX, FIRST
      DATA ALGMCS(  1) / +.1666389480 4518632472 0572965082 2 D+0      /
      DATA ALGMCS(  2) / -.1384948176 0675638407 3298605913 5 D-4      /
      DATA ALGMCS(  3) / +.9810825646 9247294261 5717154748 7 D-8      /
      DATA ALGMCS(  4) / -.1809129475 5724941942 6330626671 9 D-10     /
      DATA ALGMCS(  5) / +.6221098041 8926052271 2601554341 6 D-13     /
      DATA ALGMCS(  6) / -.3399615005 4177219443 0333059966 6 D-15     /
      DATA ALGMCS(  7) / +.2683181998 4826987489 5753884666 6 D-17     /
      DATA ALGMCS(  8) / -.2868042435 3346432841 4462239999 9 D-19     /
      DATA ALGMCS(  9) / +.3962837061 0464348036 7930666666 6 D-21     /
      DATA ALGMCS( 10) / -.6831888753 9857668701 1199999999 9 D-23     /
      DATA ALGMCS( 11) / +.1429227355 9424981475 7333333333 3 D-24     /
      DATA ALGMCS( 12) / -.3547598158 1010705471 9999999999 9 D-26     /
      DATA ALGMCS( 13) / +.1025680058 0104709120 0000000000 0 D-27     /
      DATA ALGMCS( 14) / -.3401102254 3167487999 9999999999 9 D-29     /
      DATA ALGMCS( 15) / +.1276642195 6300629333 3333333333 3 D-30     /
      DATA FIRST /.TRUE./
C***FIRST EXECUTABLE STATEMENT  D9LGMC
      IF (FIRST) THEN
         NALGM = INITDSSLATEC (ALGMCS, 15, REAL(D1MACH(3)) )
         XBIG = 1.0D0/SQRT(D1MACH(3))
         XMAX = EXP (MIN(LOG(D1MACH(2)/12.D0), -LOG(12.D0*D1MACH(1))))
      ENDIF
      FIRST = .FALSE.
C
      IF (X .LT. 10.D0) CALL XERDJS ('SLATEC/NCL', 'D9LGMC',
     +   'X MUST BE GE 10', 1, 2)
      IF (X.GE.XMAX) GO TO 20
C
      D9LGMCSLATEC = 1.D0/(12.D0*X)
      IF (X.LT.XBIG) D9LGMCSLATEC =DCSEVLSLATEC(2.0D0*(10.D0/X)**2-1.D0,
     1                                          ALGMCS, NALGM) / X
      RETURN
C
 20   D9LGMCSLATEC = 0.D0
      CALL XERDJS ('SLATEC/NCL','D9LGMC','X SO BIG D9LGMC UNDERFLOWS',2,
     +   1)
      RETURN
C
      END
C===> DECK DCSEVL
      DOUBLE PRECISION FUNCTION DCSEVLSLATEC (X, CS, N)
C***BEGIN PROLOGUE  DCSEVL
C***PURPOSE  Evaluate a Chebyshev series.
C***LIBRARY   SLATEC (FNLIB)
C***CATEGORY  C3A2
C***TYPE      DOUBLE PRECISION (CSEVL-S, DCSEVL-D)
C***KEYWORDS  CHEBYSHEV SERIES, FNLIB, SPECIAL FUNCTIONS
C***AUTHOR  Fullerton, W., (LANL)
C***DESCRIPTION
C
C  Evaluate the N-term Chebyshev series CS at X.  Adapted from
C  a method presented in the paper by Broucke referenced below.
C
C       Input Arguments --
C  X    value at which the series is to be evaluated.
C  CS   array of N terms of a Chebyshev series.  In evaluating
C       CS, only half the first coefficient is summed.
C  N    number of terms in array CS.
C
C***REFERENCES  R. Broucke, Ten subroutines for the manipulation of
C                 Chebyshev series, Algorithm 446, Communications of
C                 the A.C.M. 16, (1973) pp. 254-256.
C               L. Fox and I. B. Parker, Chebyshev Polynomials in
C                 Numerical Analysis, Oxford University Press, 1968,
C                 page 56.
C***ROUTINES CALLED  D1MACH, XERDJS
C***REVISION HISTORY  (YYMMDD)
C   770401  DATE WRITTEN
C   890831  Modified array declarations.  (WRB)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERDJS.  (THJ)
C   900329  Prologued revised extensively and code rewritten to allow
C           X to be slightly outside interval (-1,+1).  (WRB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  DCSEVL
      DOUBLE PRECISION B0, B1, B2, CS(*), ONEPL, TWOX, X, D1MACH
      LOGICAL FIRST
      SAVE FIRST, ONEPL
      DATA FIRST /.TRUE./
C***FIRST EXECUTABLE STATEMENT  DCSEVL
      IF (FIRST) ONEPL = 1.0D0 + D1MACH(4)
      FIRST = .FALSE.
      IF (N .LT. 1) CALL XERDJS ('SLATEC/NCL', 'DCSEVL',
     +   'NUMBER OF TERMS .LE. 0', 2, 2)
      IF (N .GT. 1000) CALL XERDJS ('SLATEC/NCL', 'DCSEVL',
     +   'NUMBER OF TERMS .GT. 1000', 3, 2)
      IF (ABS(X) .GT. ONEPL) CALL XERDJS ('SLATEC/NCL', 'DCSEVL',
     +   'X OUTSIDE THE INTERVAL (-1,+1)', 1, 1)
C
      B1 = 0.0D0
      B0 = 0.0D0
      TWOX = 2.0D0*X
      DO 10 I = 1,N
         B2 = B1
         B1 = B0
         NI = N + 1 - I
         B0 = TWOX*B1 - B2 + CS(NI)
   10 CONTINUE
C
      DCSEVLSLATEC = 0.5D0*(B0-B2)
C
      RETURN
      END
C===> DECK DGAMLM
      SUBROUTINE DGAMLM (XMIN, XMAX)
C***BEGIN PROLOGUE  DGAMLM
C***PURPOSE  Compute the minimum and maximum bounds for the argument in
C            the Gamma function.
C***LIBRARY   SLATEC (FNLIB)
C***CATEGORY  C7A, R2
C***TYPE      DOUBLE PRECISION (GAMLIM-S, DGAMLM-D)
C***KEYWORDS  COMPLETE GAMMA FUNCTION, FNLIB, LIMITS, SPECIAL FUNCTIONS
C***AUTHOR  Fullerton, W., (LANL)
C***DESCRIPTION
C
C Calculate the minimum and maximum legal bounds for X in gamma(X).
C XMIN and XMAX are not the only bounds, but they are the only non-
C trivial ones to calculate.
C
C             Output Arguments --
C XMIN   double precision minimum legal value of X in gamma(X).  Any
C        smaller value of X might result in underflow.
C XMAX   double precision maximum legal value of X in gamma(X).  Any
C        larger value of X might cause overflow.
C
C***REFERENCES  (NONE)
C***ROUTINES CALLED  D1MACH, XERDJS
C***REVISION HISTORY  (YYMMDD)
C   770601  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890531  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERDJS.  (THJ)
C***END PROLOGUE  DGAMLM
      DOUBLE PRECISION XMIN, XMAX, ALNBIG, ALNSML, XLN, XOLD, D1MACH
C***FIRST EXECUTABLE STATEMENT  DGAMLM
      ALNSML = LOG(D1MACH(1))
      XMIN = -ALNSML
      DO 10 I=1,10
        XOLD = XMIN
        XLN = LOG(XMIN)
        XMIN = XMIN - XMIN*((XMIN+0.5D0)*XLN - XMIN - 0.2258D0 + ALNSML)
     1    / (XMIN*XLN+0.5D0)
        IF (ABS(XMIN-XOLD).LT.0.005D0) GO TO 20
 10   CONTINUE
      CALL XERDJS ('SLATEC/NCL', 'DGAMLM', 'UNABLE TO FIND XMIN', 1, 2)
C
 20   XMIN = -XMIN + 0.01D0
C
      ALNBIG = LOG (D1MACH(2))
      XMAX = ALNBIG
      DO 30 I=1,10
        XOLD = XMAX
        XLN = LOG(XMAX)
        XMAX = XMAX - XMAX*((XMAX-0.5D0)*XLN - XMAX + 0.9189D0 - ALNBIG)
     1    / (XMAX*XLN-0.5D0)
        IF (ABS(XMAX-XOLD).LT.0.005D0) GO TO 40
 30   CONTINUE
      CALL XERDJS ('SLATEC/NCL', 'DGAMLM', 'UNABLE TO FIND XMAX', 2, 2)
C
 40   XMAX = XMAX - 0.01D0
      XMIN = MAX (XMIN, -XMAX+1.D0)
C
      RETURN
      END
C===> DECK DGAMMA
      DOUBLE PRECISION FUNCTION DGAMMASLATEC (X)
C***BEGIN PROLOGUE  DGAMMA
C***PURPOSE  Compute the complete Gamma function.
C***LIBRARY   SLATEC (FNLIB)
C***CATEGORY  C7A
C***TYPE      DOUBLE PRECISION (GAMMA-S, DGAMMA-D, CGAMMA-C)
C***KEYWORDS  COMPLETE GAMMA FUNCTION, FNLIB, SPECIAL FUNCTIONS
C***AUTHOR  Fullerton, W., (LANL)
C***DESCRIPTION
C
C DGAMMA(X) calculates the double precision complete Gamma function
C for double precision argument X.
C
C Series for GAM        on the interval  0.          to  1.00000E+00
C                                        with weighted error   5.79E-32
C                                         log weighted error  31.24
C                               significant figures required  30.00
C                                    decimal places required  32.05
C
C***REFERENCES  (NONE)
C***ROUTINES CALLED  D1MACH, D9LGMC, DCSEVL, DGAMLM, INITDS, XERDJS
C***REVISION HISTORY  (YYMMDD)
C   770601  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890911  Removed unnecessary intrinsics.  (WRB)
C   890911  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERDJS.  (THJ)
C   920618  Removed space from variable name.  (RWC, WRB)
C***END PROLOGUE  DGAMMA
      DOUBLE PRECISION X, GAMCS(42), DXREL, PI, SINPIY, SQ2PIL, XMAX,
     1  XMIN, Y, D9LGMCSLATEC, DCSEVLSLATEC, D1MACH
      LOGICAL FIRST
C
      SAVE GAMCS, PI, SQ2PIL, NGAM, XMIN, XMAX, DXREL, FIRST
      DATA GAMCS(  1) / +.8571195590 9893314219 2006239994 2 D-2      /
      DATA GAMCS(  2) / +.4415381324 8410067571 9131577165 2 D-2      /
      DATA GAMCS(  3) / +.5685043681 5993633786 3266458878 9 D-1      /
      DATA GAMCS(  4) / -.4219835396 4185605010 1250018662 4 D-2      /
      DATA GAMCS(  5) / +.1326808181 2124602205 8400679635 2 D-2      /
      DATA GAMCS(  6) / -.1893024529 7988804325 2394702388 6 D-3      /
      DATA GAMCS(  7) / +.3606925327 4412452565 7808221722 5 D-4      /
      DATA GAMCS(  8) / -.6056761904 4608642184 8554829036 5 D-5      /
      DATA GAMCS(  9) / +.1055829546 3022833447 3182350909 3 D-5      /
      DATA GAMCS( 10) / -.1811967365 5423840482 9185589116 6 D-6      /
      DATA GAMCS( 11) / +.3117724964 7153222777 9025459316 9 D-7      /
      DATA GAMCS( 12) / -.5354219639 0196871408 7408102434 7 D-8      /
      DATA GAMCS( 13) / +.9193275519 8595889468 8778682594 0 D-9      /
      DATA GAMCS( 14) / -.1577941280 2883397617 6742327395 3 D-9      /
      DATA GAMCS( 15) / +.2707980622 9349545432 6654043308 9 D-10     /
      DATA GAMCS( 16) / -.4646818653 8257301440 8166105893 3 D-11     /
      DATA GAMCS( 17) / +.7973350192 0074196564 6076717535 9 D-12     /
      DATA GAMCS( 18) / -.1368078209 8309160257 9949917230 9 D-12     /
      DATA GAMCS( 19) / +.2347319486 5638006572 3347177168 8 D-13     /
      DATA GAMCS( 20) / -.4027432614 9490669327 6657053469 9 D-14     /
      DATA GAMCS( 21) / +.6910051747 3721009121 3833697525 7 D-15     /
      DATA GAMCS( 22) / -.1185584500 2219929070 5238712619 2 D-15     /
      DATA GAMCS( 23) / +.2034148542 4963739552 0102605193 2 D-16     /
      DATA GAMCS( 24) / -.3490054341 7174058492 7401294910 8 D-17     /
      DATA GAMCS( 25) / +.5987993856 4853055671 3505106602 6 D-18     /
      DATA GAMCS( 26) / -.1027378057 8722280744 9006977843 1 D-18     /
      DATA GAMCS( 27) / +.1762702816 0605298249 4275966074 8 D-19     /
      DATA GAMCS( 28) / -.3024320653 7353062609 5877211204 2 D-20     /
      DATA GAMCS( 29) / +.5188914660 2183978397 1783355050 6 D-21     /
      DATA GAMCS( 30) / -.8902770842 4565766924 4925160106 6 D-22     /
      DATA GAMCS( 31) / +.1527474068 4933426022 7459689130 6 D-22     /
      DATA GAMCS( 32) / -.2620731256 1873629002 5732833279 9 D-23     /
      DATA GAMCS( 33) / +.4496464047 8305386703 3104657066 6 D-24     /
      DATA GAMCS( 34) / -.7714712731 3368779117 0390152533 3 D-25     /
      DATA GAMCS( 35) / +.1323635453 1260440364 8657271466 6 D-25     /
      DATA GAMCS( 36) / -.2270999412 9429288167 0231381333 3 D-26     /
      DATA GAMCS( 37) / +.3896418998 0039914493 2081663999 9 D-27     /
      DATA GAMCS( 38) / -.6685198115 1259533277 9212799999 9 D-28     /
      DATA GAMCS( 39) / +.1146998663 1400243843 4761386666 6 D-28     /
      DATA GAMCS( 40) / -.1967938586 3451346772 9510399999 9 D-29     /
      DATA GAMCS( 41) / +.3376448816 5853380903 3489066666 6 D-30     /
      DATA GAMCS( 42) / -.5793070335 7821357846 2549333333 3 D-31     /
      DATA PI / 3.1415926535 8979323846 2643383279 50 D0 /
      DATA SQ2PIL / 0.9189385332 0467274178 0329736405 62 D0 /
      DATA FIRST /.TRUE./
C***FIRST EXECUTABLE STATEMENT  DGAMMA
      IF (FIRST) THEN
         NGAM = INITDSSLATEC (GAMCS, 42, 0.1*REAL(D1MACH(3)) )
C
         CALL DGAMLM (XMIN, XMAX)
         DXREL = SQRT(D1MACH(4))
      ENDIF
      FIRST = .FALSE.
C
      Y = ABS(X)
      IF (Y.GT.10.D0) GO TO 50
C
C COMPUTE GAMMA(X) FOR -XBND .LE. X .LE. XBND.  REDUCE INTERVAL AND FIND
C GAMMA(1+Y) FOR 0.0 .LE. Y .LT. 1.0 FIRST OF ALL.
C
      N = X
      IF (X.LT.0.D0) N = N - 1
      Y = X - N
      N = N - 1
      DGAMMASLATEC = 0.9375D0 + DCSEVLSLATEC (2.D0*Y-1.D0, GAMCS, NGAM)
      IF (N.EQ.0) RETURN
C
      IF (N.GT.0) GO TO 30
C
C COMPUTE GAMMA(X) FOR X .LT. 1.0
C
      N = -N
      IF (X .EQ. 0.D0) CALL XERDJS ('SLATEC/NCL', 'DGAMMA','X IS 0',4,2)
      IF (X .LT. 0.0 .AND. X+N-2 .EQ. 0.D0) CALL XERDJS ('SLATEC/NCL',
     +   'DGAMMA', 'X IS A NEGATIVE INTEGER', 4, 2)
      IF (X .LT. (-0.5D0) .AND. ABS((X-AINT(X-0.5D0))/X) .LT. DXREL)
     +   CALL XERDJS ('SLATEC/NCL', 'DGAMMA',
     +   'ANSWER LT HALF PRECISION BECAUSE X TOO NEAR NEGATIVE INTEGER',
     +   1, 1)
C
      DO 20 I=1,N
        DGAMMASLATEC = DGAMMASLATEC/(X+I-1 )
 20   CONTINUE
      RETURN
C
C GAMMA(X) FOR X .GE. 2.0 AND X .LE. 10.0
C
 30   DO 40 I=1,N
        DGAMMASLATEC = (Y+I) * DGAMMASLATEC
 40   CONTINUE
      RETURN
C
C GAMMA(X) FOR ABS(X) .GT. 10.0.  RECALL Y = ABS(X).
C
 50   IF (X .GT. XMAX) CALL XERDJS ('SLATEC/NCL', 'DGAMMA',
     +   'X SO BIG GAMMA OVERFLOWS', 3, 2)
C
      DGAMMASLATEC = 0.D0
      IF (X .LT. XMIN) CALL XERDJS ('SLATEC/NCL', 'DGAMMA',
     +   'X SO SMALL GAMMA UNDERFLOWS', 2, 1)
      IF (X.LT.XMIN) RETURN
C
      DGAMMASLATEC = EXP((Y-0.5D0)*LOG(Y)- Y +SQ2PIL +D9LGMCSLATEC(Y))
      IF (X.GT.0.D0) RETURN
C
      IF (ABS((X-AINT(X-0.5D0))/X) .LT. DXREL) CALL XERDJS('SLATEC/NCL',
     +   'DGAMMA',
     +   'ANSWER LT HALF PRECISION, X TOO NEAR NEGATIVE INTEGER', 1, 1)
C
      SINPIY = SIN (PI*Y)
      IF (SINPIY .EQ. 0.D0) CALL XERDJS ('SLATEC/NCL', 'DGAMMA',
     +   'X IS A NEGATIVE INTEGER', 4, 2)
C
      DGAMMASLATEC = -PI/(Y*SINPIY*DGAMMASLATEC)
C
      RETURN
      END
C===> DECK DLBETA
      DOUBLE PRECISION FUNCTION DLBETASLATEC (A, B)
C***BEGIN PROLOGUE  DLBETA
C***PURPOSE  Compute the natural logarithm of the complete Beta
C            function.
C***LIBRARY   SLATEC (FNLIB)
C***CATEGORY  C7B
C***TYPE      DOUBLE PRECISION (ALBETA-S, DLBETA-D, CLBETA-C)
C***KEYWORDS  FNLIB, LOGARITHM OF THE COMPLETE BETA FUNCTION,
C             SPECIAL FUNCTIONS
C***AUTHOR  Fullerton, W., (LANL)
C***DESCRIPTION
C
C DLBETA(A,B) calculates the double precision natural logarithm of
C the complete beta function for double precision arguments
C A and B.
C
C***REFERENCES  (NONE)
C***ROUTINES CALLED  D9LGMC, DGAMMA, DLNGAM, DLNREL, XERDJS
C***REVISION HISTORY  (YYMMDD)
C   770701  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890531  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERDJS.  (THJ)
C   900727  Added EXTERNAL statement.  (WRB)
C***END PROLOGUE  DLBETA
      DOUBLE PRECISION A, B, P, Q, CORR, SQ2PIL, D9LGMCSLATEC, 
     1                 DGAMMASLATEC, DLNGAMSLATEC, DLNRELSLATEC
      EXTERNAL DGAMMASLATEC
      SAVE SQ2PIL
      DATA SQ2PIL / 0.9189385332 0467274178 0329736405 62 D0 /
C***FIRST EXECUTABLE STATEMENT  DLBETA
      P = MIN (A, B)
      Q = MAX (A, B)
C
      IF (P .LE. 0.D0) CALL XERDJS ('SLATEC/NCL', 'DLBETA',
     +   'BOTH ARGUMENTS MUST BE GT ZERO', 1, 2)
C
      IF (P.GE.10.D0) GO TO 30
      IF (Q.GE.10.D0) GO TO 20
C
C P AND Q ARE SMALL.
C
      DLBETASLATEC = 
     1      LOG(DGAMMASLATEC(P)*(DGAMMASLATEC(Q)/DGAMMASLATEC(P+Q)) )
      RETURN
C
C P IS SMALL, BUT Q IS BIG.
C
 20   CORR = D9LGMCSLATEC(Q) - D9LGMCSLATEC(P+Q)
      DLBETASLATEC = DLNGAMSLATEC(P) + CORR + P - P*LOG(P+Q)
     1  + (Q-0.5D0)*DLNRELSLATEC(-P/(P+Q))
      RETURN
C
C P AND Q ARE BIG.
C
 30   CORR = D9LGMCSLATEC(P) + D9LGMCSLATEC(Q) - D9LGMCSLATEC(P+Q)
      DLBETASLATEC = -0.5D0*LOG(Q)+ SQ2PIL+ CORR+ (P-0.5D0)*LOG(P/(P+Q))
     1  + Q*DLNRELSLATEC(-P/(P+Q))
      RETURN
C
      END
C===> DECK DLNGAM
      DOUBLE PRECISION FUNCTION DLNGAMSLATEC (X)
C***BEGIN PROLOGUE  DLNGAM
C***PURPOSE  Compute the logarithm of the absolute value of the Gamma
C            function.
C***LIBRARY   SLATEC (FNLIB)
C***CATEGORY  C7A
C***TYPE      DOUBLE PRECISION (ALNGAM-S, DLNGAM-D, CLNGAM-C)
C***KEYWORDS  ABSOLUTE VALUE, COMPLETE GAMMA FUNCTION, FNLIB, LOGARITHM,
C             SPECIAL FUNCTIONS
C***AUTHOR  Fullerton, W., (LANL)
C***DESCRIPTION
C
C DLNGAM(X) calculates the double precision logarithm of the
C absolute value of the Gamma function for double precision
C argument X.
C
C***REFERENCES  (NONE)
C***ROUTINES CALLED  D1MACH, D9LGMCSLATEC, DGAMMA, XERDJS
C***REVISION HISTORY  (YYMMDD)
C   770601  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890531  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERDJS.  (THJ)
C   900727  Added EXTERNAL statement.  (WRB)
C***END PROLOGUE  DLNGAM
      DOUBLE PRECISION X, DXREL, PI, SINPIY, SQPI2L, SQ2PIL, XMAX,
     1  Y, DGAMMASLATEC, D9LGMCSLATEC, D1MACH, TEMP
      LOGICAL FIRST
      EXTERNAL DGAMMASLATEC
      SAVE SQ2PIL, SQPI2L, PI, XMAX, DXREL, FIRST
      DATA SQ2PIL / 0.9189385332 0467274178 0329736405 62 D0 /
      DATA SQPI2L / +.2257913526 4472743236 3097614947 441 D+0    /
      DATA PI / 3.1415926535 8979323846 2643383279 50 D0 /
      DATA FIRST /.TRUE./
C***FIRST EXECUTABLE STATEMENT  DLNGAM
      IF (FIRST) THEN
         TEMP = 1.D0/LOG(D1MACH(2))
         XMAX = TEMP*D1MACH(2)
         DXREL = SQRT(D1MACH(4))
      ENDIF
      FIRST = .FALSE.
C
      Y = ABS (X)
      IF (Y.GT.10.D0) GO TO 20
C
C LOG (ABS (DGAMMASLATEC(X)) ) FOR ABS(X) .LE. 10.0
C
      DLNGAMSLATEC = LOG (ABS (DGAMMASLATEC(X)) )
      RETURN
C
C LOG ( ABS (DGAMMASLATEC(X)) ) FOR ABS(X) .GT. 10.0
C
 20   IF (Y .GT. XMAX) CALL XERDJS ('SLATEC/NCL', 'DLNGAM',
     +   'ABS(X) SO BIG DLNGAM OVERFLOWS', 2, 2)
C
      IF (X.GT.0.D0) DLNGAMSLATEC = SQ2PIL+(X-0.5D0)*LOG(X)
     +                                     -X+D9LGMCSLATEC(Y)
      IF (X.GT.0.D0) RETURN
C
      SINPIY = ABS (SIN(PI*Y))
      IF (SINPIY .EQ. 0.D0) CALL XERDJS ('SLATEC/NCL', 'DLNGAM',
     +   'X IS A NEGATIVE INTEGER', 3, 2)
C
      IF (ABS((X-AINT(X-0.5D0))/X) .LT. DXREL) CALL XERDJS('SLATEC/NCL',
     +   'DLNGAM',
     +   'ANSWER LT HALF PRECISION BECAUSE X TOO NEAR NEGATIVE INTEGER',
     +   1, 1)
C
      DLNGAMSLATEC = SQPI2L+(X-0.5D0)*LOG(Y)-X
     1                      -LOG(SINPIY)-D9LGMCSLATEC(Y)
      RETURN
C
      END
C===> DECK DLNREL
      DOUBLE PRECISION FUNCTION DLNRELSLATEC (X)
C***BEGIN PROLOGUE  DLNREL
C***PURPOSE  Evaluate ln(1+X) accurate in the sense of relative error.
C***LIBRARY   SLATEC (FNLIB)
C***CATEGORY  C4B
C***TYPE      DOUBLE PRECISION (ALNREL-S, DLNREL-D, CLNREL-C)
C***KEYWORDS  ELEMENTARY FUNCTIONS, FNLIB, LOGARITHM
C***AUTHOR  Fullerton, W., (LANL)
C***DESCRIPTION
C
C DLNREL(X) calculates the double precision natural logarithm of
C (1.0+X) for double precision argument X.  This routine should
C be used when X is small and accurate to calculate the logarithm
C accurately (in the relative error sense) in the neighborhood
C of 1.0.
C
C Series for ALNR       on the interval -3.75000E-01 to  3.75000E-01
C                                        with weighted error   6.35E-32
C                                         log weighted error  31.20
C                               significant figures required  30.93
C                                    decimal places required  32.01
C
C***REFERENCES  (NONE)
C***ROUTINES CALLED  D1MACH, DCSEVL, INITDS, XERDJS
C***REVISION HISTORY  (YYMMDD)
C   770601  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890531  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERDJS.  (THJ)
C***END PROLOGUE  DLNREL
      DOUBLE PRECISION ALNRCS(43), X, XMIN,  DCSEVLSLATEC, D1MACH
      LOGICAL FIRST
      SAVE ALNRCS, NLNREL, XMIN, FIRST
      DATA ALNRCS(  1) / +.1037869356 2743769800 6862677190 98 D+1     /
      DATA ALNRCS(  2) / -.1336430150 4908918098 7660415531 33 D+0     /
      DATA ALNRCS(  3) / +.1940824913 5520563357 9261993747 50 D-1     /
      DATA ALNRCS(  4) / -.3010755112 7535777690 3765377765 92 D-2     /
      DATA ALNRCS(  5) / +.4869461479 7154850090 4563665091 37 D-3     /
      DATA ALNRCS(  6) / -.8105488189 3175356066 8099430086 22 D-4     /
      DATA ALNRCS(  7) / +.1377884779 9559524782 9382514960 59 D-4     /
      DATA ALNRCS(  8) / -.2380221089 4358970251 3699929149 35 D-5     /
      DATA ALNRCS(  9) / +.4164041621 3865183476 3918599019 89 D-6     /
      DATA ALNRCS( 10) / -.7359582837 8075994984 2668370319 98 D-7     /
      DATA ALNRCS( 11) / +.1311761187 6241674949 1522943450 11 D-7     /
      DATA ALNRCS( 12) / -.2354670931 7742425136 6960923301 75 D-8     /
      DATA ALNRCS( 13) / +.4252277327 6034997775 6380529625 67 D-9     /
      DATA ALNRCS( 14) / -.7719089413 4840796826 1081074933 00 D-10    /
      DATA ALNRCS( 15) / +.1407574648 1359069909 2153564721 91 D-10    /
      DATA ALNRCS( 16) / -.2576907205 8024680627 5370786275 84 D-11    /
      DATA ALNRCS( 17) / +.4734240666 6294421849 1543950059 38 D-12    /
      DATA ALNRCS( 18) / -.8724901267 4742641745 3012632926 75 D-13    /
      DATA ALNRCS( 19) / +.1612461490 2740551465 7398331191 15 D-13    /
      DATA ALNRCS( 20) / -.2987565201 5665773006 7107924168 15 D-14    /
      DATA ALNRCS( 21) / +.5548070120 9082887983 0413216972 79 D-15    /
      DATA ALNRCS( 22) / -.1032461915 8271569595 1413339619 32 D-15    /
      DATA ALNRCS( 23) / +.1925023920 3049851177 8785032448 68 D-16    /
      DATA ALNRCS( 24) / -.3595507346 5265150011 1897078442 66 D-17    /
      DATA ALNRCS( 25) / +.6726454253 7876857892 1945742267 73 D-18    /
      DATA ALNRCS( 26) / -.1260262416 8735219252 0824256375 46 D-18    /
      DATA ALNRCS( 27) / +.2364488440 8606210044 9161589555 19 D-19    /
      DATA ALNRCS( 28) / -.4441937705 0807936898 8783891797 33 D-20    /
      DATA ALNRCS( 29) / +.8354659446 4034259016 2412939946 66 D-21    /
      DATA ALNRCS( 30) / -.1573155941 6479562574 8992535210 66 D-21    /
      DATA ALNRCS( 31) / +.2965312874 0247422686 1543697066 66 D-22    /
      DATA ALNRCS( 32) / -.5594958348 1815947292 1560132266 66 D-23    /
      DATA ALNRCS( 33) / +.1056635426 8835681048 1872841386 66 D-23    /
      DATA ALNRCS( 34) / -.1997248368 0670204548 3149994666 66 D-24    /
      DATA ALNRCS( 35) / +.3778297781 8839361421 0498559999 99 D-25    /
      DATA ALNRCS( 36) / -.7153158688 9081740345 0381653333 33 D-26    /
      DATA ALNRCS( 37) / +.1355248846 3674213646 5020245333 33 D-26    /
      DATA ALNRCS( 38) / -.2569467304 8487567430 0798293333 33 D-27    /
      DATA ALNRCS( 39) / +.4874775606 6216949076 4595199999 99 D-28    /
      DATA ALNRCS( 40) / -.9254211253 0849715321 1323733333 33 D-29    /
      DATA ALNRCS( 41) / +.1757859784 1760239233 2697600000 00 D-29    /
      DATA ALNRCS( 42) / -.3341002667 7731010351 3770666666 66 D-30    /
      DATA ALNRCS( 43) / +.6353393618 0236187354 1802666666 66 D-31    /
      DATA FIRST /.TRUE./
C***FIRST EXECUTABLE STATEMENT  DLNREL
      IF (FIRST) THEN
         NLNREL = INITDSSLATEC (ALNRCS, 43, 0.1*REAL(D1MACH(3)))
         XMIN = -1.0D0 + SQRT(D1MACH(4))
      ENDIF
      FIRST = .FALSE.
C
      IF (X .LE. (-1.D0)) CALL XERDJS ('SLATEC/NCL', 'DLNREL', 
     +   'X IS LE -1' , 2, 2)
      IF (X .LT. XMIN) CALL XERDJS ('SLATEC/NCL', 'DLNREL',
     +   'ANSWER LT HALF PRECISION BECAUSE X TOO NEAR -1', 1, 1)
C
      IF (ABS(X).LE.0.375D0) DLNRELSLATEC = X*(1.D0 -
     1  X*DCSEVLSLATEC (X/.375D0, ALNRCS, NLNREL))
C
      IF (ABS(X).GT.0.375D0) DLNRELSLATEC = LOG (1.0D0+X)
C
      RETURN
      END

C===> DECK INITDS
      FUNCTION INITDSSLATEC (OS, NOS, ETA)
C***BEGIN PROLOGUE  INITDS
C***PURPOSE  Determine the number of terms needed in an orthogonal
C            polynomial series so that it meets a specified accuracy.
C***LIBRARY   SLATEC (FNLIB)
C***CATEGORY  C3A2
C***TYPE      DOUBLE PRECISION (INITS-S, INITDS-D)
C***KEYWORDS  CHEBYSHEV, FNLIB, INITIALIZE, ORTHOGONAL POLYNOMIAL,
C             ORTHOGONAL SERIES, SPECIAL FUNCTIONS
C***AUTHOR  Fullerton, W., (LANL)
C***DESCRIPTION
C
C  Initialize the orthogonal series, represented by the array OS, so
C  that INITDS is the number of terms needed to insure the error is no
C  larger than ETA.  Ordinarily, ETA will be chosen to be one-tenth
C  machine precision.
C
C             Input Arguments --
C   OS     double precision array of NOS coefficients in an orthogonal
C          series.
C   NOS    number of coefficients in OS.
C   ETA    single precision scalar containing requested accuracy of
C          series.
C
C***REFERENCES  (NONE)
C***ROUTINES CALLED  XERDJS
C***REVISION HISTORY  (YYMMDD)
C   770601  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890831  Modified array declarations.  (WRB)
C   891115  Modified error message.  (WRB)
C   891115  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERDJS.  (THJ)
C***END PROLOGUE  INITDS
      DOUBLE PRECISION OS(*)
C***FIRST EXECUTABLE STATEMENT  INITDS
      IF (NOS .LT. 1) CALL XERDJS ('SLATEC/NCL', 'INITDS',
     +   'Number of coefficients is less than 1', 2, 1)
C
      ERR = 0.
      DO 10 II = 1,NOS
        I = NOS + 1 - II
        ERR = ERR + ABS(REAL(OS(I)))
        IF (ERR.GT.ETA) GO TO 20
   10 CONTINUE
C
   20 IF (I .EQ. NOS) CALL XERDJS ('SLATEC/NCL', 'INITDS',
     +   'Chebyshev series too short for specified accuracy', 1, 1)
      INITDSSLATEC = I
C
      RETURN
      END
C ++++++++++ DJS CREATED THIS SHORT ROUTINE***********
C ++++++++++ IT REPLACES "XERMSG"          ***********
      SUBROUTINE XERDJS (LIBRAR, SUBROU, MESSG, NERR, LEVEL)
      CHARACTER*(*) LIBRAR, SUBROU, MESSG
      INTEGER       NERR, LEVEL

      LENL = LEN(LIBRAR)
      LENS = LEN(SUBROU)
      LENM = LEN(MESSG)
      PRINT *,"==>", LIBRAR(1:LENL),": ",SUBROU(1:LENS),": "
     +             , MESSG(1:LENM), ": NERR=",NERR
     +             , ": LEVEL=",LEVEL

      RETURN
      END 

C
C $Id: WriteNameFile.f,v 1.5 2008-07-27 01:04:30 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      PROGRAM WRNMFI
C
C This program reads an ASCII file defining an EZMAP dataset and writes
C the name information from it to a binary file.
C
C The line data in the input files are grouped into logical records,
C each of which represents a single line segment and exists as a pair
C of FORTRAN records.  The first record of each pair contains four
C integers and four reals; if the first integer has a zero value, then
C there is no second record and the end of the line data has been
C reached.  The second record of each pair contains a varying number of
C real lat/lon coordinate pairs.  In terms of the variables into which
C the data are read:
C
C   INTS(1) = the number of reals in the second FORTRAN record, but if
C             the value is 0, there is no second FORTRAN record: this
C             signals the end of the line data in the input file.
C   INTS(2) = a "line type" for the line segment.
C   INTS(3) = the left area identifier for the line segment.
C   INTS(4) = the right area identifier for the line segment.
C   FLTS(1) = the biggest latitude in the line segment.
C   FLTS(2) = the smallest latitude in the line segment.
C   FLTS(3) = the biggest longitude in the line segment.
C   FLTS(4) = the smallest longitude in the line segment.
C  (FLTS(I),I=5,4+INTS(1)) = lat/lon pairs for the line segment.
C
C Following the line data are the names of the global areas described
C by the lines.  Each record contains an area identifier, an area type,
C a suggested color index for the area, the identifier of the "parent"
C area, and the name of the area.
C
C Dimension the arrays into which the data are to be read.
C
        DIMENSION INTS(4),FLTS(204)
C
C Set up an equivalent name for the array element specifying the length
C of the second FORTRAN record.
C
        EQUIVALENCE (INTS(1),LOSR)
C
C Declare a character variable to hold the dataset name.
C
        CHARACTER*71 FLNM
C
C Declare the variable into which names are copied and from which they
C are written.
C
        CHARACTER*64 NAME
C
C Declare an array to use as an output buffer.
C
        CHARACTER*1 CHRS(1024)
C
C Get the name of the file to be read.
C
        PRINT * , ' '
        PRINT * , 'Enter the name of the file to be read:'
        READ (*,'(A64)') FLNM
C
        IF (FLNM.EQ.' ') GO TO 901
C
        LFNM=MPILNB(FLNM)
C
C Open the specified input file.
C
        OPEN (1,FILE=FLNM(1:LFNM),STATUS='OLD',FORM='FORMATTED',ERR=902)
C
        REWIND 1
C
C Open the output name data file.
C
        FLNM(LFNM+1:LFNM+6)='.names'
        FLNM(LFNM+7:LFNM+7)=CHAR(0)
        CALL NGOFWO (FLNM(1:LFNM+7),IFDE,ISTA)
        IF (ISTA.NE.0) GO TO 904
C
C Read past the next input record.
C
  101   READ (1,'(4I4,4F10.5)',ERR=905,END=906) (INTS(I),I=1,4),
     +                                          (FLTS(I),I=1,4)
C
C If lat/lon data follow, read past them as well.
C
        IF (LOSR.NE.0) THEN
          READ (1,'(8F10.5)',ERR=905,END=906) (FLTS(4+I),I=1,LOSR)
          GO TO 101
        END IF
C
C Zero the count of characters sent to the output file so far.
C
        NCHR=0
C
C Read a line containing an area identifier, an area type, a suggested
C color index, a parent area identifier, and a name.
C
  102   READ (1,'(I4,2I2,I5,1X,A64)',ERR=905,END=906)
     +                                          IAID,IATY,ISCI,IPAR,NAME
C
C Unless the final line has been read, copy the information to the
C output name data file.
C
        IF (IAID.NE.0) THEN
          CALL WRCHAR (IFDE,CHRS,1024,NCHR, ' ')
          CALL WRNUMB (IFDE,CHRS,1024,NCHR,IAID)
          CALL WRCHAR (IFDE,CHRS,1024,NCHR, ' ')
          CALL WRNUMB (IFDE,CHRS,1024,NCHR,IATY)
          CALL WRCHAR (IFDE,CHRS,1024,NCHR, ' ')
          CALL WRNUMB (IFDE,CHRS,1024,NCHR,ISCI)
          CALL WRCHAR (IFDE,CHRS,1024,NCHR, ' ')
          CALL WRNUMB (IFDE,CHRS,1024,NCHR,IPAR)
          CALL WRCHAR (IFDE,CHRS,1024,NCHR, ' ')
          IBEG=MPIFNB(NAME)
          IEND=MPILNB(NAME)
          CALL WRNUMB (IFDE,CHRS,1024,NCHR,IEND-IBEG+1)
          CALL WRCHAR (IFDE,CHRS,1024,NCHR,        ' ')
          DO 103 I=IBEG,IEND
            CALL WRCHAR (IFDE,CHRS,1024,NCHR,NAME(I:I))
  103     CONTINUE
          GO TO 102
        END IF
C
C If there's something left in the output buffer, dump it.
C
        IF (NCHR.GT.0) THEN
          CALL NGWRCH (IFDE,CHRS,NCHR,ISTA)
          IF (ISTA.LE.0) GO TO 907
        END IF
C
C Close the output name data file.
C
        CALL NGCLFI (IFDE)
C
C Close the input file.
C
        CLOSE (1,ERR=903)
C
C Normal exit.
C
        STOP
C
C Error exits.
C
  901   PRINT * , 'ERROR - Input file name is blank.'
        STOP
C
  902   PRINT * , 'ERROR - Couldn''t open input file.'
        STOP
C
  903   PRINT * , 'ERROR - Couldn''t close input file.'
        STOP
C
  904   PRINT * , 'ERROR - NGOFWO returns bad status:',ISTA
        STOP
C
  905   PRINT * , 'ERROR - FORTRAN error on READ of input file.'
        STOP
C
  906   PRINT * , 'ERROR - Unexpected EOF on READ of input file.'
        STOP
C
  907   PRINT * , 'ERROR - NGWRCH returns bad status:',ISTA
        STOP
C
      END



      SUBROUTINE WRNUMB (IFDE,CHRS,MCHR,NCHR,INUM)
C
        CHARACTER*1 CHRS(MCHR)
C
C Translate the integer INUM to a character form and put it in the
C buffer CHRS.
C
        CHARACTER*1 CTMP(20)
C
C Copy the integer to a local variable.
C
        ITMP=INUM
C
C Generate digits from right to left in the temporary buffer CTMP.
C
        NDGT=0
C
  101   NDGT=NDGT+1
C
        IF (NDGT.GT.20) THEN
          PRINT * , 'WRNUMB - INTEGER TOO BIG - STOP'
          STOP
        END IF
C
        CTMP(NDGT)=CHAR(ICHAR('0')+MOD(ITMP,10))
C
        ITMP=ITMP/10
        IF (ITMP.NE.0) GO TO 101
C
C Send the digits to the output buffer in correct order.
C
        DO 102 IDGT=NDGT,1,-1
          CALL WRCHAR (IFDE,CHRS,MCHR,NCHR,CTMP(IDGT))
  102   CONTINUE
C
C Done.
C
        RETURN
C
      END



      SUBROUTINE WRCHAR (IFDE,CHRS,MCHR,NCHR,ICHR)
C
        CHARACTER*1 CHRS(MCHR),ICHR
C
C Put the character ICHR in the buffer CHRS.
C
        NCHR=NCHR+1
        CHRS(NCHR)=ICHR
C
C If the buffer is now full, dump it to the file specified by IFDE.
C
        IF (NCHR.GE.MCHR) THEN
          CALL NGWRCH (IFDE,CHRS,NCHR,ISTA)
          IF (ISTA.LE.0) THEN
            PRINT * , 'WRCHAR - BAD STATUS FROM NGWRCH = ',ISTA
            STOP
          END IF
          NCHR=0
        END IF
C
C Done.
C
        RETURN
C
      END



      INTEGER FUNCTION MPIFNB (CHRS)
C
        CHARACTER*(*) CHRS
C
C The value of MPIFNB(CHRS) is the index of the first non-blank in the
C character string CHRS.
C
        DO 101 I=1,LEN(CHRS)
          IF (CHRS(I:I).NE.' ') THEN
            MPIFNB=I
            RETURN
          END IF
  101   CONTINUE
C
        MPIFNB=1
C
        RETURN
C
      END



      INTEGER FUNCTION MPILNB (CHRS)
C
        CHARACTER*(*) CHRS
C
C The value of MPILNB(CHRS) is the index of the last non-blank in the
C character string CHRS.
C
        DO 101 I=LEN(CHRS),1,-1
          IF (CHRS(I:I).NE.' ') THEN
            MPILNB=I
            RETURN
          END IF
  101   CONTINUE
C
        MPILNB=1
C
        RETURN
C
      END

      PROGRAM FTHEX05
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Declare the common block in which the viewing distance will be
C communicated to THREED.
C
      COMMON /TEMPRT/ RZRO
C
C Declare the common block in which the internal parameters of
C SRFACE are stored.
C
      COMMON /SRFIP1/ IFR,ISTP,IROTS,IDRX,IDRY,IDRZ,IUPPER,ISKIRT,
     +     NCLA,THETA,HSKIRT,CHI,CLO,CINC,ISPVAL
C
C Declare an array in which to put an eye position for THREED and
C both the eye position and the position of the point looked at
C for SRFACE.
C
      DIMENSION PEYE(6)
C
C Declare arrays in which to define the surface to be drawn by
C SRFACE and to provide the workspace it needs.
C
      DIMENSION U(21),V(21),W(21,21),RWRK(882)
C
C Define a character variable in which to form numeric labels.
C
      CHARACTER*8 CHRS
C
C Declare a function W(U,V) that defines the surface to be drawn.
C
      WFUN(UU,VV)=.5+.25*SIN(5.*UU)+.25*COS(5.*VV)
C
C Turn off frame advances by SRFACE.
C
      IFR=0
C
C Turn on the drawing of skirts by SRFACE and set the base value
C for the skirts.
C
      ISKIRT=1
      HSKIRT=0.
C
C Define the surface to be drawn.
C
      DO 101 I=1,21
         U(I)=REAL(I-1)/20.
 101  CONTINUE
C
      DO 102 J=1,21
         V(J)=REAL(J-1)/20.
 102  CONTINUE
C
      DO 104 I=1,21
         UTMP=REAL(I-1)/20.
         DO 103 J=1,21
            VTMP=REAL(J-1)/20.
            W(I,J)=WFUN(UTMP,VTMP)
 103     CONTINUE
 104  CONTINUE
C
C Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Make the tick marks drawn by PERIM3 twice as long as the default.
C
      CALL TICK43 (24,16,24,16,24,16)
C
C Define the boundaries of the box to be projected from 3-space to
C 2-space.
C
      UMIN=0.
      UMAX=1.
      VMIN=0.
      VMAX=1.
      WMIN=0.
      WMAX=1.
C
C Define the distance from which the box, when viewed from the direction
C that makes it biggest, should just fill the screen.
C
      RZRO=8.
C
C Define the position of the eye.
C
      PEYE(1)=7.
      PEYE(2)=5.
      PEYE(3)=3.
C
C Define the position of the point looked at to be the point at the
C center of the box.  These three values in the array are seen only
C by SRFACE; THREED automatically assumes that you're looking at the
C center of the box.
C
      PEYE(4)=.5*(UMIN+UMAX)
      PEYE(5)=.5*(VMIN+VMAX)
      PEYE(6)=.5*(WMIN+WMAX)
C
C Communicate to SRFACE the dimensions of the box and the distance from
C which it is to be viewed.
C
      CALL SETR   (UMIN,UMAX,VMIN,VMAX,WMIN,WMAX,RZRO)
C
C Initialize THREED, using arguments that will make it use exactly the
C same projection as SRFACE.
C
      CALL SET3   (.0087976,.9902248,.0087976,.9902248,
     +     UMIN,UMAX,VMIN,VMAX,WMIN,WMAX,PEYE)
C
C Draw perimeters in each of the three coordinate planes.
C
      CALL PERIM3 (10,2,10,2,1,0.)
      CALL PERIM3 (10,2,10,2,2,0.)
      CALL PERIM3 (10,2,10,2,3,0.)
C
C Put some labels on the plot.  First, the U axis.
C
      CALL PWRZT (.5,0.,1.1,'U',1,3,-1,+3,0)
C 
      DO 106 ILAB=0,10
         UPOS=REAL(ILAB)/10.
         WRITE (CHRS,'(F8.1)') UPOS
         IBEG=0
         DO 105 ICHR=1,8
            IF (CHRS(ICHR:ICHR).NE.' ') THEN
               IF (IBEG.EQ.0) THEN
                  IBEG=ICHR
               END IF
               IEND=ICHR
            END IF
 105     CONTINUE
         CALL PWRZT (UPOS,0.,1.05,CHRS(IBEG:IEND),IEND-IBEG+1,
     +        3,-1,+3,0)
 106  CONTINUE
C
C Next, the V axis.
C  
      CALL PWRZT (0.,.5,1.1,'V',1,3,+2,+3,0)
C  
      DO 108 ILAB=1,10
         VPOS=REAL(ILAB)/10.
         WRITE (CHRS,'(F8.1)') VPOS
         IBEG=0
         DO 107 ICHR=1,8
            IF (CHRS(ICHR:ICHR).NE.' ') THEN
               IF (IBEG.EQ.0) THEN
                  IBEG=ICHR
               END IF
               IEND=ICHR
            END IF
 107     CONTINUE
         CALL PWRZT (0.,VPOS,1.05,CHRS(IBEG:IEND),IEND-IBEG+1,
     +        3,+2,+3,0)
 108  CONTINUE
C 
C Finally, the W axis.
C 
      CALL PWRZT (1.2,0.,.5,'W',1,3,-1,+3,1)
C 
      DO 110 ILAB=0,10
         WPOS=REAL(ILAB)/10.
         WRITE (CHRS,'(F8.1)') WPOS
         IBEG=0
         DO 109 ICHR=1,8
            IF (CHRS(ICHR:ICHR).NE.' ') THEN
               IF (IBEG.EQ.0) THEN
                  IBEG=ICHR
               END IF
               IEND=ICHR
            END IF
 109     CONTINUE
         CALL PWRZT (1.05,0.,WPOS,CHRS(IBEG:IEND),IEND-IBEG+1,
     +        3,-1,+3,1)
 110  CONTINUE
C 
C Using POINT3, draw grids inside the perimeters drawn by PERIM3.
C 
      DO 112 I=1,11
         PTMP=REAL(I-1)/10.
         DO 111 J=1,101
            QTMP=REAL(J-1)/100.
            CALL POINT3 (PTMP,QTMP,0.)
            CALL POINT3 (QTMP,PTMP,0.)
            CALL POINT3 (PTMP,0.,QTMP)
            CALL POINT3 (QTMP,0.,PTMP)
            CALL POINT3 (0.,PTMP,QTMP)
            CALL POINT3 (0.,QTMP,PTMP)
 111     CONTINUE
 112  CONTINUE
C 
C  Double the line width and draw the surface.
C 
      CALL PLOTIF (0.,0.,2)
      CALL GSLWSC (2.)
C 
      CALL SRFACE (U,V,W,RWRK,21,21,21,PEYE,0.)
C 
C Advance the frame.
C 
      CALL FRAME
C
C Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
C Done.
C
      STOP
C
      END

      SUBROUTINE HLUARPRAM (IAM,IF1,IF2,IF3)
C
      DIMENSION IAM(*)
C
C Examine the area map.  Find points of intersection, delete redundant
C edge segments, and adjust the area identifiers.
C
C IAM is the array which holds an area map previously initialized by a
C call to ARINAM and augmented by calls to AREDAM.
C
C IF1 specifies what kind of search is made for intersections.  If IF1
C is zero, all pairs of edge segments which could possibly intersect
C are examined for actual intersection, a very time-consuming process.
C If IF1 is one, a pair is examined only if one of its members has a
C left or a right identifier less than or equal to zero; this saves a
C lot of time and is intended for use with contour lines.
C
C IF2 specifies what kind of action is taken to remove unclosed edges.
C If IF2 is zero, a search is made for such edges and they are simply
C removed from the area map.  If IF2 is one, no such search is made;
C all edges are assumed closed.
C
C IF3 specifies what kind of search is made for area identifiers to be
C changed.  If IF3 is zero, all edges of all subareas are examined in
C complete detail, a very time-consuming process.  If IF3 is one, only
C those edges having a zero or negative area identifier are examined
C (all others being assumed correct) and holes are ignored, which saves
C a lot of time; this is intended for use with contour lines.
C
C Declare the AREAS common block.
C
C
C ARCOMN contains variables which are used by all the AREAS routines.
C
      COMMON /ARCOMN/ IAD,IAU,ILC,RLC,ILM,RLM,ILP,RLP,IBS,RBS,DBS,IDB,
     +                IDC,IDI,IRC(16),RLA,RWA,RDI,RSI
      SAVE   /ARCOMN/
C
C Define some double precision variables.
C
      DOUBLE PRECISION DPT,DP1,DP2,DX0,DY0,DLP
C
C Define the arrays which determine the multiple-precision operations
C to be done by ARMPIA.
C
      DIMENSION IO1(4,8),IO2(4,4),IO3(4,8),IO4(4,18),IO5(4,4)
      DIMENSION IO6(4,8),IO7(4,4)
C
      DATA IO1 / 1 ,  1 ,  0 ,  0 ,
     +           1 ,  2 ,  0 ,  0 ,
     +           1 ,  3 ,  0 ,  0 ,
     +           1 ,  4 ,  0 ,  0 ,
     +           4 ,  5 ,  1 ,  3 ,
     +           4 ,  6 ,  2 ,  4 ,
     +           2 ,  7 ,  5 ,  6 ,
     +           5 ,  7 ,  0 ,  0 /
      DATA IO2 / 4 ,  3 ,  1 ,  1 ,
     +           4 ,  4 ,  2 ,  2 ,
     +           2 ,  5 ,  3 ,  4 ,
     +           5 ,  5 ,  0 ,  0 /
      DATA IO3 / 1 ,  1 ,  0 ,  0 ,
     +           1 ,  2 ,  0 ,  0 ,
     +           1 ,  3 ,  0 ,  0 ,
     +           1 ,  4 ,  0 ,  0 ,
     +           4 ,  5 ,  1 ,  2 ,
     +           4 ,  6 ,  3 ,  4 ,
     +           3 ,  7 ,  5 ,  6 ,
     +           5 ,  7 ,  0 ,  0 /
      DATA IO4 / 1 ,  7 ,  0 ,  0 ,
     +           1 ,  8 ,  0 ,  0 ,
     +           4 ,  9 ,  7 ,  8 ,
     +           1 ,  7 ,  0 ,  0 ,
     +           1 ,  8 ,  0 ,  0 ,
     +           4 , 10 ,  7 ,  8 ,
     +           3 ,  5 ,  9 , 10 ,
     +           1 ,  7 ,  0 ,  0 ,
     +           1 ,  8 ,  0 ,  0 ,
     +           4 ,  9 ,  7 ,  8 ,
     +           1 ,  7 ,  0 ,  0 ,
     +           1 ,  8 ,  0 ,  0 ,
     +           4 , 10 ,  7 ,  8 ,
     +           3 ,  6 ,  9 , 10 ,
     +           4 ,  7 ,  3 ,  5 ,
     +           4 ,  8 ,  1 ,  6 ,
     +           3 ,  9 ,  7 ,  8 ,
     +           5 ,  9 ,  0 ,  0 /
      DATA IO5 / 4 ,  7 ,  2 ,  5 ,
     +           4 ,  8 ,  4 ,  6 ,
     +           3 ,  9 ,  7 ,  8 ,
     +           5 ,  9 ,  0 ,  0 /
      DATA IO6 / 1 ,  1 ,  0 ,  0 ,
     +           1 ,  2 ,  0 ,  0 ,
     +           1 ,  3 ,  0 ,  0 ,
     +           1 ,  4 ,  0 ,  0 ,
     +           4 ,  5 ,  1 ,  2 ,
     +           4 ,  6 ,  3 ,  4 ,
     +           3 ,  7 ,  5 ,  6 ,
     +           5 ,  7 ,  0 ,  0 /
      DATA IO7 / 4 ,  5 ,  1 ,  4 ,
     +           4 ,  6 ,  2 ,  3 ,
     +           2 ,  7 ,  5 ,  6 ,
     +           5 ,  7 ,  0 ,  0 /
C
C Added 8/2010, Jira NCL_32, RLB:
C This statement-function test whether a given node is a hole-connector.
C Such nodes have index greater than ILW, and have next/previous links
C greater than ILW (with the exception of the very first connector,
C which necessarily has a previous link pointing to the last
C regular node).
      LOGICAL ISHOLEC
      ISHOLEC(IDX) = (
     +    IDX.GT.ILW            .AND.
     +    IAM(IDX+3).GT.ILW  .AND.
     + (IAM(IDX+4).GT.ILW .OR. (IAM(IDX+4)+10).GT.ILW))
C
C Do a call forcing a BLOCKDATA to be loaded from a binary library.
C
      CALL ARBLDA
C
C Check for an uncleared prior error.
C
      IF (ICFELL('ARPRAM - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C Pull out the length of the area map and check for initialization.
C
      LAM=IAM(1)
C
      IF (.NOT.(IAU.EQ.0.OR.IAM(LAM).NE.LAM)) GO TO 10001
        CALL SETER ('ARPRAM - INITIALIZATION DONE IMPROPERLY',2,1)
        RETURN
10001 CONTINUE
C
C Save the pointer to the last word of the last node, so that, in case
C of error, we can remove new nodes added to the area map.  Also, zero
C the variable that saves the upper-end pointer; again, this is done so
C that, when an error occurs, the proper action can be taken to dispose
C of any space temporarily used at the upper end of the area map array.
C
      ILW=IAM(5)
      ISU=0
C
C Get a double-precision version of ILP.
C
      DLP=DBLE(ILP)
C
C Copy the fast-path flags to internal variables.
C
      KF1=IF1
      KF2=IF2
      KF3=IF3
C
C Initialize the pointer used in determining the coordinate ordering of
C new nodes.
C
      IPX=8
C
C If debugging is turned on, produce an initial plot.
C
      IF (.NOT.(IDB.NE.0)) GO TO 10002
        CALL ARDBPA (IAM,IDB,'AT START OF ARPRAM')
        IF (ICFELL('ARPRAM',3).NE.0) RETURN
10002 CONTINUE
C
C First, find the average length of the projection on the X axis of the
C line segments in the area map.
C
C
      NXL=0
      FXL=0.
      IPT=8
10003 CONTINUE
      IF (.NOT.(IAM(IPT+3).NE.18)) GO TO 10004
        IPT=IAM(IPT+3)
        IF (.NOT.(IAM(IPT+7).NE.0)) GO TO 10005
          NXL=NXL+1
          FXL=FXL+REAL(ABS(IAM(IPT+1)-IAM(IAM(IPT+4)+1)))
10005   CONTINUE
      GO TO 10003
10004 CONTINUE
      IF (.NOT.(NXL.EQ.0)) GO TO 10006
        CALL SETER ('ARPRAM - NO EDGES IN AREA MAP',4,1)
        GO TO 10008
10006 CONTINUE
      IXL=INT(FXL/REAL(NXL))
C
C Decide what the maximum such length should be and save it.  Adjust
C the X and Y coordinates in the dummy nodes at the ends of the list.
C
      IAM(2)=MAX(2,MIN(ILC,2*IXL))
      IAM(9)=-(IAM(2)+1)
      IAM(10)=-(IAM(2)+1)
      IAM(19)=ILC+(IAM(2)+1)
      IAM(20)=ILC+(IAM(2)+1)
C
C
C Now, break up any edge segments whose projections on the X axis are
C greater than the maximum.
C
C
      IPI=8
10009 CONTINUE
      IF (.NOT.(IAM(IPI+3).NE.18)) GO TO 10010
        IPI=IAM(IPI+3)
        IF (.NOT.(IAM(IPI+7).NE.0)) GO TO 10011
          NDO=1+(ABS(IAM(IPI+1)-IAM(IAM(IPI+4)+1))-1)/
     +                                              IAM(2)
          IF (.NOT.(NDO.GT.1)) GO TO 10012
            IXL=IAM(IAM(IPI+4)+1)
            IYL=IAM(IAM(IPI+4)+2)
            FXD=REAL(IAM(IPI+1)-IXL)/REAL(NDO)
            FYD=REAL(IAM(IPI+2)-IYL)/REAL(NDO)
              I = 1
              GO TO 10015
10013         CONTINUE
              I =I +1
10015         CONTINUE
              IF (I .GT.(NDO-1)) GO TO 10014
              IX0=IXL+NINT(REAL(I)*FXD)
              IY0=IYL+NINT(REAL(I)*FYD)
              L10017=    1
              GO TO 10017
10016         CONTINUE
            GO TO 10013
10014       CONTINUE
10012     CONTINUE
10011   CONTINUE
      GO TO 10009
10010 CONTINUE
C
C If debugging is turned on, produce a plot.
C
      IF (.NOT.(IDB.NE.0)) GO TO 10018
        CALL ARDBPA (IAM,IDB,'AFTER BREAKING UP LONG EDGE SEGMENTS')
        IF (ICFELL('ARPRAM',5).NE.0) RETURN
10018 CONTINUE
C
C
C Now, look for points of intersection between edges.  The algorithm
C used should run in O(nlogn) time, rather than O(n**2) time.  A
C vertical sweep line is passed over the plane from left to right.
C A list is kept of all the edge segments intersected by the sweep
C line, sorted in order of increasing Y coordinate.  Whenever a new
C edge segment is added to the list, a check is made for intersection
C of it with the edge segments on either side of it.  Whenever an edge
C segment is removed from the list, a check is made for intersection
C of the edge segments which were on either side of it.  There are
C various complications, mostly having to do with the fact that points
C of intersection are incorporated in the area map as they are found
C and that we are working with a discrete grid, rather than with the
C classic Euclidean plane.
C
C The list is kept at the upper end of the area map.  Each five-word
C node in it represents one edge segment intersecting the sweep line
C and has the following format:
C
C   Word 0:  A pointer to the next node in the list (0 if no more).
C   Word 1:  A pointer to the last node in the list (0 if no more).
C   Word 2:  A pointer to the left end of the edge segment.
C   Word 3:  A pointer to the right end of the edge segment.
C   Word 4:  A pointer to the drawing end of the edge segment.
C
  101 CONTINUE
C
C Save the index of the last element used at the upper end of the area
C map.
C
      ISU=IAM(6)
C
C IQB points to the beginning of the edge-segment list and IQE to a
C linked list of nodes removed from the edge-segment list and available
C for re-use.  Both start out empty.
C
      IQB=0
      IQE=0
C
C ISP points to the node in the area map defining the current position
C of the sweep line.
C
      ISP=8
C
C A WHILE loop moves the sweep line, one point position at a time,
C across the area map.
C
10019 CONTINUE
      IF (.NOT.(IAM(ISP+5).NE.18)) GO TO 10020
C
        ISP=IAM(ISP+5)
C
C Pull out the X and Y coordinates of the point defining the current
C position of the sweep line.
C
        ISX=IAM(ISP+1)
        FSX=REAL(ISX)
        ISY=IAM(ISP+2)
        FSY=REAL(ISY)
C
C Interpolate the new point along any line segment which passes within
C one unit of it and, at the same time, remove any line segment having
C the current point, or any with the same coordinates, as a right
C endpoint.
C
        IQT=IQB
C
10021   CONTINUE
C
          IF (IQT.EQ.0) GO TO 10022
C
          IX1=IAM(IAM(IQT+2)+1)
          FX1=REAL(IX1)
          IY1=IAM(IAM(IQT+2)+2)
          FY1=REAL(IY1)
          IX2=IAM(IAM(IQT+3)+1)
          FX2=REAL(IX2)
          IY2=IAM(IAM(IQT+3)+2)
          FY2=REAL(IY2)
C
          IF (.NOT.(IAU.EQ.1)) GO TO 10023
            TMP=MAX(0.,MIN(1.,
     +          ((FSX-FX1)*(FX2-FX1)+(FSY-FY1)*(FY2-FY1))/
     +          ((FX2-FX1)*(FX2-FX1)+(FY2-FY1)*(FY2-FY1))))
            DSQ=(FX1-FSX+(FX2-FX1)*TMP)**2+(FY1-FSY+(FY2-FY1)*TMP)**2
          GO TO 10024
10023     CONTINUE
          IF (.NOT.(IAU.EQ.2)) GO TO 10025
            DPT=MAX(0.D0,MIN(1.D0,(DBLE(ISX-IX1)*DBLE(IX2-IX1)+
     +                             DBLE(ISY-IY1)*DBLE(IY2-IY1))/
     +                            (DBLE(IX2-IX1)*DBLE(IX2-IX1)+
     +                             DBLE(IY2-IY1)*DBLE(IY2-IY1))))
            DSQ=REAL((DBLE(IX1-ISX)+DBLE(IX2-IX1)*DPT)**2+
     +               (DBLE(IY1-ISY)+DBLE(IY2-IY1)*DPT)**2)
          GO TO 10024
10025     CONTINUE
            IO1(3,1)=IX2-IX1
            IO1(3,2)=IY2-IY1
            IO1(3,3)=ISX-IX1
            IO1(3,4)=ISY-IY1
            CALL ARMPIA (IO1,DP1,IER)
            IF (.NOT.(IER.NE.0)) GO TO 10026
              GO TO 10028
10026       CONTINUE
            CALL ARMPIA (IO2,DP2,IER)
            IF (.NOT.(IER.NE.0)) GO TO 10029
              GO TO 10028
10029       CONTINUE
            DPT=MAX(0.D0,MIN(1.D0,DP1/DP2))
            DSQ=REAL((DBLE(IX1-ISX)+DBLE(IX2-IX1)*DPT)**2+
     +               (DBLE(IY1-ISY)+DBLE(IY2-IY1)*DPT)**2)
10024     CONTINUE
C
          IF (.NOT.((DSQ.LT.1.).AND.(IX1.NE.ISX.OR.IY1.NE.ISY).AND.(IX2.
     +NE.ISX.OR.IY2.NE.ISY))) GO TO 10031
            IPI=IAM(IQT+4)
            IX0=ISX
            IY0=ISY
            L10017=    2
            GO TO 10017
10032       CONTINUE
            IAM(IQT+3)=IPN
            IF (IAM(IQT+4).NE.IAM(IQT+2)) IAM(IQT+4)=IPN
10031     CONTINUE
C
          IF (.NOT.(IAM(IAM(IQT+3)+1).EQ.ISX.AND.IAM(IAM(IQT+3)+2).EQ.IS
     +Y)) GO TO 10033
            IF (.NOT.(IAM(IQT+1).EQ.0)) GO TO 10034
              IQB=IAM(IQT)
              IF (IQB.NE.0) IAM(IQB+1)=0
              IAM(IQT)=IQE
              IQE=IQT
              IQT=IQB
            GO TO 10035
10034       CONTINUE
            IF (.NOT.(IAM(IQT).EQ.0)) GO TO 10036
              IAM(IAM(IQT+1))=0
              IAM(IQT)=IQE
              IQE=IQT
              IQT=0
            GO TO 10035
10036       CONTINUE
              IQL=IAM(IQT+1)
              IQU=IAM(IQT)
              IAM(IQL)=IQU
              IAM(IQU+1)=IQL
              IAM(IQT)=IQE
              IQE=IQT
              IF (.NOT.(IAM(IAM(IQU+3)+1).NE.ISX.OR.IAM(IAM(IQU+3)+2).NE
     +.ISY))  GO TO 10037
                L10039=    1
                GO TO 10039
10038           CONTINUE
10037         CONTINUE
              IQT=IQU
10035       CONTINUE
          GO TO 10040
10033     CONTINUE
            IQT=IAM(IQT)
10040     CONTINUE
C
        GO TO 10021
10022   CONTINUE
C
C Add line segments having the current point as a left endpoint.
C
        IF (.NOT.(IAM(ISP+7).NE.0.AND.(IAM(ISP+1).LT.IAM(IAM(ISP+4)+1).O
     +R.(IAM(ISP+1).EQ.IAM(IAM(ISP+4)+1).AND.IAM(ISP+2).LT.IAM(IAM(ISP+4
     +)+2))))) GO TO 10041
          ISL=ISP
          ISR=IAM(ISP+4)
          ISD=ISP
          L10043=    1
          GO TO 10043
10042     CONTINUE
10041   CONTINUE
C
        IF (.NOT.(IAM(IAM(ISP+3)+7).NE.0.AND.(IAM(ISP+1).LT.IAM(IAM(ISP+
     +3)+1).OR.(IAM(ISP+1).EQ.IAM(IAM(ISP+3)+1).AND.IAM(ISP+2).LT.IAM(IA
     +M(ISP+3)+2))))) GO TO 10044
          ISL=ISP
          ISR=IAM(ISP+3)
          ISD=ISR
          L10043=    2
          GO TO 10043
10045     CONTINUE
10044   CONTINUE
C
      GO TO 10019
10020 CONTINUE
C
C The following internal procedure adds a segment to the list.  It also
C checks for intersection of that segment with the segments on either
C side of it in the list.
C
      GO TO 10046
10043 CONTINUE
C
        IQS=0
        IQT=IQB
        ILX=IAM(ISL+1)
        RLY=REAL(IAM(ISL+2))
C
        IF (.NOT.(IAM(ISL+1).NE.IAM(ISR+1))) GO TO 10047
          SLL=REAL(IAM(ISR+2)-IAM(ISL+2))/
     +  REAL(IAM(ISR+1)-IAM(ISL+1))
        GO TO 10048
10047   CONTINUE
          SLL=RLP
10048   CONTINUE
C
10049   CONTINUE
          IF (IQT.EQ.0) GO TO 10050
          IF (.NOT.(IAM(IAM(IQT+2)+1).NE.IAM(IAM(IQT+3)+1))) GO TO 10051
            IF (.NOT.(IAU.EQ.1)) GO TO 10052
              SLP=REAL(IAM(IAM(IQT+3)+2)-IAM(IAM(IQT+2)+2))/
     +      REAL(IAM(IAM(IQT+3)+1)-IAM(IAM(IQT+2)+1))
              RTY=REAL(IAM(IAM(IQT+2)+2))+
     +         REAL(ILX-IAM(IAM(IQT+2)+1))*SLP
            GO TO 10053
10052       CONTINUE
              DPT=DBLE(IAM(IAM(IQT+3)+2)-IAM(IAM(IQT+2)+2))/
     +      DBLE(IAM(IAM(IQT+3)+1)-IAM(IAM(IQT+2)+1))
              SLP=REAL(DPT)
              RTY=DBLE(IAM(IAM(IQT+2)+2))+
     +         DBLE(ILX-IAM(IAM(IQT+2)+1))*DPT
10053       CONTINUE
          GO TO 10054
10051     CONTINUE
            SLP=RLP
            RTY=REAL(IAM(IAM(IQT+2)+2))
10054     CONTINUE
          IF (RLY.LT.RTY.OR.(RLY.EQ.RTY.AND.SLL.LT.SLP)) GO TO 10050
          IQS=IQT
          IQT=IAM(IQT)
        GO TO 10049
10050   CONTINUE
C
        IF (.NOT.(IQE.NE.0)) GO TO 10055
          IQI=IQE
          IQE=IAM(IQE)
        GO TO 10056
10055   CONTINUE
          IF (.NOT.(IAM(6)-5.LE.IAM(5))) GO TO 10057
            CALL SETER ('ARPRAM - AREA-MAP ARRAY OVERFLOW',6,1)
            GO TO 10008
10057     CONTINUE
          IQI=IAM(6)-5
          IAM(6)=IQI
10056   CONTINUE
C
        IAM(IQI)=IQT
        IAM(IQI+1)=IQS
        IAM(IQI+2)=ISL
        IAM(IQI+3)=ISR
        IAM(IQI+4)=ISD
C
        IF (IQS.NE.0) IAM(IQS)=IQI
        IF (IQT.NE.0) IAM(IQT+1)=IQI
C
        IF (IQB.EQ.IQT) IQB=IQI
C
        IF (.NOT.(IQS.NE.0)) GO TO 10059
          IQL=IQS
          IQU=IQI
          L10039=    2
          GO TO 10039
10060     CONTINUE
10059   CONTINUE
C
        IF (.NOT.(IQT.NE.0)) GO TO 10061
          IQL=IQI
          IQU=IQT
          L10039=    3
          GO TO 10039
10062     CONTINUE
10061   CONTINUE
C
      GO TO (10042,10045) , L10043
10046 CONTINUE
C
C The following internal procedure looks for intersection between the
C segments identified by the pointers IQL and IQU.  When such points of
C intersection are found, they are interpolated along the intersecting
C line segments and any line segments which pass within one unit.
C
      GO TO 10063
10039 CONTINUE
C
        IF (.NOT.(KF1.EQ.0.OR.IAM(IAM(IQL+4)+8).LE.0.OR.IAM(IAM(IQL+4)+9
     +).LE.0.OR.IAM(IAM(IQU+4)+8).LE.0.OR.IAM(IAM(IQU+4)+9).LE.0))
     +  GO TO 10064
C
          IX1=IAM(IAM(IQL+2)+1)
          FX1=REAL(IX1)
          IY1=IAM(IAM(IQL+2)+2)
          FY1=REAL(IY1)
          IX2=IAM(IAM(IQL+3)+1)
          FX2=REAL(IX2)
          IY2=IAM(IAM(IQL+3)+2)
          FY2=REAL(IY2)
          IX3=IAM(IAM(IQU+2)+1)
          FX3=REAL(IX3)
          IY3=IAM(IAM(IQU+2)+2)
          FY3=REAL(IY3)
          IX4=IAM(IAM(IQU+3)+1)
          FX4=REAL(IX4)
          IY4=IAM(IAM(IQU+3)+2)
          FY4=REAL(IY4)
C
          IF (.NOT.(IAU.EQ.1)) GO TO 10065
            TMP=(FX2-FX1)*(FY4-FY3)-(FX4-FX3)*(FY2-FY1)
          GO TO 10066
10065     CONTINUE
          IF (.NOT.(IAU.EQ.2)) GO TO 10067
            DPT=DBLE(IX2-IX1)*DBLE(IY4-IY3)-
     +          DBLE(IX4-IX3)*DBLE(IY2-IY1)
            TMP=REAL(DPT)
          GO TO 10066
10067     CONTINUE
            IO3(3, 1)=IX2-IX1
            IO3(3, 2)=IY4-IY3
            IO3(3, 3)=IX4-IX3
            IO3(3, 4)=IY2-IY1
            CALL ARMPIA (IO3,DPT,IER)
            IF (.NOT.(IER.NE.0)) GO TO 10068
              GO TO 10028
10068       CONTINUE
            TMP=REAL(DPT)
10066     CONTINUE
C
          IF (.NOT.(ABS(TMP).GT..1)) GO TO 10070
C
            IF (.NOT.(IAU.EQ.1)) GO TO 10071
              IX0=INT(MAX(-1.,MIN(RLP,
     +                ((FX4-FX3)*(FX2*FY1-FX1*FY2)-
     +                 (FX2-FX1)*(FX4*FY3-FX3*FY4))/TMP+.5)))
            GO TO 10072
10071       CONTINUE
            IF (.NOT.(IAU.EQ.2)) GO TO 10073
              IX0=INT(MAX(-1.D0,MIN(DLP,
     +                (DBLE(IX4-IX3)*
     +                (DBLE(IX2)*DBLE(IY1)-DBLE(IX1)*DBLE(IY2))-
     +                 DBLE(IX2-IX1)*
     +                (DBLE(IX4)*DBLE(IY3)-DBLE(IX3)*DBLE(IY4)))/
     +                                                     DPT+.5D0)))
            GO TO 10072
10073       CONTINUE
              IO4(3, 1)=IX2
              IO4(3, 2)=IY1
              IO4(3, 4)=IX1
              IO4(3, 5)=IY2
              IO4(3, 8)=IX4
              IO4(3, 9)=IY3
              IO4(3,11)=IX3
              IO4(3,12)=IY4
              CALL ARMPIA (IO4,DX0,IER)
              IF (.NOT.(IER.NE.0)) GO TO 10074
                GO TO 10028
10074         CONTINUE
              IX0=INT(MAX(-1.D0,MIN(DLP,DX0/DPT+.5D0)))
10072       CONTINUE
C
            IF (.NOT.(IAU.EQ.1)) GO TO 10076
              IY0=INT(MAX(-1.,MIN(RLP,
     +                ((FY4-FY3)*(FX2*FY1-FX1*FY2)-
     +                 (FY2-FY1)*(FX4*FY3-FX3*FY4))/TMP+.5)))
            GO TO 10077
10076       CONTINUE
            IF (.NOT.(IAU.EQ.2)) GO TO 10078
              IY0=INT(MAX(-1.D0,MIN(DLP,
     +                (DBLE(IY4-IY3)*
     +                (DBLE(IX2)*DBLE(IY1)-DBLE(IX1)*DBLE(IY2))-
     +                 DBLE(IY2-IY1)*
     +                (DBLE(IX4)*DBLE(IY3)-DBLE(IX3)*DBLE(IY4)))/
     +                                                     DPT+.5D0)))
            GO TO 10077
10078       CONTINUE
              CALL ARMPIA (IO5,DY0,IER)
              IF (.NOT.(IER.NE.0)) GO TO 10079
                GO TO 10028
10079         CONTINUE
              IY0=INT(MAX(-1.D0,MIN(DLP,DY0/DPT+.5D0)))
10077       CONTINUE
C
            IF (IX0.EQ.ISX.AND.IY0.LT.ISY) IX0=IX0+1
C
            FX0=REAL(IX0)
            FY0=REAL(IY0)
C
            IF (.NOT.((FX0-FX1)*(FX0-FX2).LE.0..AND.(FY0-FY1)*(FY0-FY2).
     +LE.0..AND.(FX0-FX3)*(FX0-FX4).LE.0..AND.(FY0-FY3)*(FY0-FY4).LE.0.)
     +)     GO TO 10081
C
              INP=0
C
              IF (.NOT.((IX0.NE.IX1.OR.IY0.NE.IY1).AND.(IX0.NE.IX2.OR.IY
     +0.NE.IY2))) GO TO 10082
                INP=1
                IPI=IAM(IQL+4)
                L10017=    3
                GO TO 10017
10083           CONTINUE
                IAM(IQL+3)=IPN
                IF (IAM(IQL+4).NE.IAM(IQL+2)) IAM(IQL+4)=IPN
10082         CONTINUE
C
              IF (.NOT.((IX0.NE.IX3.OR.IY0.NE.IY3).AND.(IX0.NE.IX4.OR.IY
     +0.NE.IY4))) GO TO 10084
                INP=1
                IPI=IAM(IQU+4)
                L10017=    4
                GO TO 10017
10085           CONTINUE
                IAM(IQU+3)=IPN
                IF (IAM(IQU+4).NE.IAM(IQU+2)) IAM(IQU+4)=IPN
10084         CONTINUE
C
              IF (.NOT.(INP.NE.0)) GO TO 10086
                IQT=IQB
10087           CONTINUE
                  IF (IQT.EQ.0) GO TO 10088
                  IX1=IAM(IAM(IQT+2)+1)
                  FX1=REAL(IX1)
                  IY1=IAM(IAM(IQT+2)+2)
                  FY1=REAL(IY1)
                  IX2=IAM(IAM(IQT+3)+1)
                  FX2=REAL(IX2)
                  IY2=IAM(IAM(IQT+3)+2)
                  FY2=REAL(IY2)
C
                  IF (.NOT.(IAU.EQ.1)) GO TO 10089
                    TMP=MAX(0.,MIN(1.,
     +                  ((FX0-FX1)*(FX2-FX1)+(FY0-FY1)*(FY2-FY1))/
     +                  ((FX2-FX1)*(FX2-FX1)+(FY2-FY1)*(FY2-FY1))))
                    DSQ=(FX1-FX0+(FX2-FX1)*TMP)**2+
     +                  (FY1-FY0+(FY2-FY1)*TMP)**2
                  GO TO 10090
10089             CONTINUE
                  IF (.NOT.(IAU.EQ.2)) GO TO 10091
                    DPT=MAX(0.D0,MIN(1.D0,
     +                                 (DBLE(IX0-IX1)*DBLE(IX2-IX1)+
     +                                  DBLE(IY0-IY1)*DBLE(IY2-IY1))/
     +                                 (DBLE(IX2-IX1)*DBLE(IX2-IX1)+
     +                                  DBLE(IY2-IY1)*DBLE(IY2-IY1))))
                    DSQ=(DBLE(IX1-IX0)+DBLE(IX2-IX1)*DPT)**2+
     +                  (DBLE(IY1-IY0)+DBLE(IY2-IY1)*DPT)**2
                  GO TO 10090
10091             CONTINUE
                    IO1(3,1)=IX2-IX1
                    IO1(3,2)=IY2-IY1
                    IO1(3,3)=IX0-IX1
                    IO1(3,4)=IY0-IY1
                    CALL ARMPIA (IO1,DP1,IER)
                    IF (.NOT.(IER.NE.0)) GO TO 10092
                      GO TO 10028
10092               CONTINUE
                    CALL ARMPIA (IO2,DP2,IER)
                    IF (.NOT.(IER.NE.0)) GO TO 10094
                      GO TO 10028
10094               CONTINUE
                    DPT=MAX(0.D0,MIN(1.D0,DP1/DP2))
                    DSQ=(DBLE(IX1-IX0)+DBLE(IX2-IX1)*DPT)**2+
     +                  (DBLE(IY1-IY0)+DBLE(IY2-IY1)*DPT)**2
10090             CONTINUE
C
                  IF (.NOT.((DSQ.LT.1.).AND.(IX1.NE.IX0.OR.IY1.NE.IY0).A
     +ND.(IX2.NE.IX0.OR.IY2.NE.IY0))) GO TO 10096
                    IPI=IAM(IQT+4)
                    L10017=    5
                    GO TO 10017
10097               CONTINUE
                    IAM(IQT+3)=IPN
                    IF (IAM(IQT+4).NE.IAM(IQT+2)) IAM(IQT+4)=IPN
10096             CONTINUE
                  IQT=IAM(IQT)
                GO TO 10087
10088           CONTINUE
10086         CONTINUE
C
10081       CONTINUE
C
10070     CONTINUE
C
10064   CONTINUE
C
      GO TO (10038,10060,10062) , L10039
10063 CONTINUE
C
C Restore the index of the last element used at the upper end of the
C area map.
C
      IAM(6)=ISU
      ISU=0
C
C If debugging is turned on, produce a plot.
C
      IF (.NOT.(IDB.NE.0)) GO TO 10098
        CALL ARDBPA (IAM,IDB,'AFTER FINDING POINTS OF INTERSECTION')
        IF (ICFELL('ARPRAM',7).NE.0) RETURN
10098 CONTINUE
C
C
C Now look for coincident line segments in the list and remove them.
C
      ISP=8
10099 CONTINUE
      IF (.NOT.(IAM(ISP+5).NE.18)) GO TO 10100
        ISP=IAM(ISP+5)
        IF (.NOT.(IAM(ISP+7).NE.0)) GO TO 10101
          IF (.NOT.(IAM(IAM(ISP+3)+7).NE.0.AND.IAM(IAM(ISP+3)+1).EQ.IAM(
     +IAM(ISP+4)+1).AND.IAM(IAM(ISP+3)+2).EQ.IAM(IAM(ISP+4)+2))) GO TO 1
     +0102
            IP1=ISP
            IP2=IAM(ISP+3)
            L10104=    1
            GO TO 10104
10103       CONTINUE
10102     CONTINUE
          ISQ=IAM(ISP+5)
10105     CONTINUE
          IF (.NOT.(IAM(ISQ+1).EQ.IAM(ISP+1).AND.IAM(ISQ+2).EQ.IAM(ISP+2
     +))) GO TO 10106
            IF (.NOT.(IAM(ISQ+7).NE.0.AND.IAM(IAM(ISQ+4)+1).EQ.IAM(IAM(I
     +SP+4)+1).AND.IAM(IAM(ISQ+4)+2).EQ.IAM(IAM(ISP+4)+2))) GO TO 10107
              IP1=ISP
              IP2=ISQ
              L10104=    2
              GO TO 10104
10108         CONTINUE
10107       CONTINUE
            IF (.NOT.(IAM(IAM(ISQ+3)+7).NE.0.AND.IAM(IAM(ISQ+3)+1).EQ.IA
     +M(IAM(ISP+4)+1).AND.IAM(IAM(ISQ+3)+2).EQ.IAM(IAM(ISP+4)+2))) GO TO
     + 10109
              IP1=ISP
              IP2=IAM(ISQ+3)
              L10104=    3
              GO TO 10104
10110         CONTINUE
10109       CONTINUE
            ISQ=IAM(ISQ+5)
          GO TO 10105
10106     CONTINUE
10101   CONTINUE
        IF (.NOT.(IAM(IAM(ISP+3)+7).NE.0)) GO TO 10111
          ISQ=IAM(ISP+5)
10112     CONTINUE
          IF (.NOT.(IAM(ISQ+1).EQ.IAM(ISP+1).AND.IAM(ISQ+2).EQ.IAM(ISP+2
     +))) GO TO 10113
            IF (.NOT.(IAM(ISQ+7).NE.0.AND.IAM(IAM(ISQ+4)+1).EQ.IAM(IAM(I
     +SP+3)+1).AND.IAM(IAM(ISQ+4)+2).EQ.IAM(IAM(ISP+3)+2))) GO TO 10114
              IP1=IAM(ISP+3)
              IP2=ISQ
              L10104=    4
              GO TO 10104
10115         CONTINUE
10114       CONTINUE
            IF (.NOT.(IAM(IAM(ISQ+3)+7).NE.0.AND.IAM(IAM(ISQ+3)+1).EQ.IA
     +M(IAM(ISP+3)+1).AND.IAM(IAM(ISQ+3)+2).EQ.IAM(IAM(ISP+3)+2))) GO TO
     + 10116
              IP1=IAM(ISP+3)
              IP2=IAM(ISQ+3)
              L10104=    5
              GO TO 10104
10117         CONTINUE
10116       CONTINUE
            ISQ=IAM(ISQ+5)
          GO TO 10112
10113     CONTINUE
10111   CONTINUE
      GO TO 10099
10100 CONTINUE
C
C This internal procedure processes coincident pairs of segments found.
C If both members of the pair belong to the same group, area identifier
C information from both members is reconciled and one of the pair is
C deleted.  If they belong to different groups, the group id in one of
C them is negated, so that it is present when we are looking at edges
C belonging to a single group, but absent when we are looking at all
C the edges together.
C
      GO TO 10118
10104 CONTINUE

C this is HLU-specific code that makes this version of ARPRAM 
C different. If one of the area ids represents the Conpack grid
C boundary, then keep the other id rather than changing it to 0.
C The original version should be used with EZMAP ids.
C

      IF (ABS(IAM(IP1+7)).EQ.ABS(IAM(IP2+7))) THEN
         IL1=IAM(IP1+8)
         IR1=IAM(IP1+9)
         IF (IAM(IP1+1).EQ.IAM(IP2+1).AND.
     +        IAM(IP1+2).EQ.IAM(IP2+2)) THEN
            IL2=IAM(IP2+8)
            IR2=IAM(IP2+9)
         ELSE
            IL2=IAM(IP2+9)
            IR2=IAM(IP2+8)
         END IF
         IMN=MAX(-1,MIN(IL1,IL2))
         IMX=MAX(-1,MAX(IL1,IL2))
         IF (IMN.EQ.IMX) THEN
            IAM(IP1+8)=IMN
         ELSE IF (IMN.LE.0) THEN
            IAM(IP1+8) = IMX
         ELSE IF (IAM(IMN).EQ.199) THEN
            IAM(IP1+8) = IMX
         ELSE IF (IMX .LE. 0) THEN
            IAM(IP1+8) = IMN
         ELSE IF (IAM(IMX).EQ.199) THEN
            IAM(IP1+8) = IMN
         END IF
         IMN=MAX(-1,MIN(IR1,IR2))
         IMX=MAX(-1,MAX(IR1,IR2))
         IF (IMN.EQ.IMX) THEN
            IAM(IP1+9)=IMN
         ELSE IF (IMN.LE.0) THEN
            IAM(IP1+9) = IMX
         ELSE IF (IAM(IMN).EQ.199) THEN
            IAM(IP1+9) = IMX
         ELSE IF (IMX .LE. 0) THEN
            IAM(IP1+9) = IMN
         ELSE IF (IAM(IMX).EQ.199) THEN
            IAM(IP1+9) = IMN
         END IF
         IAM(IP2+8)=0
         IAM(IP2+9)=0
         IAM(IP2+7)=0
      ELSE
         IF (IAM(IP1+7).GT.0) THEN
            IAM(IP2+7) = -ABS(IAM(IP2+7))
         END IF
      END IF
C  
10128   CONTINUE
      GO TO (10103,10108,10110,10115,10117) , L10104
10118 CONTINUE
C
C If debugging is turned on, produce a plot.
C
      IF (.NOT.(IDB.NE.0)) GO TO 10129
        CALL ARDBPA (IAM,IDB,'AFTER REMOVING COINCIDENT SEGMENTS')
        IF (ICFELL('ARPRAM',8).NE.0) RETURN
10129 CONTINUE
C
C
C Look for unclosed edges, if that is to be done.
C
      IF (.NOT.(KF2.EQ.0)) GO TO 10130
10131   CONTINUE
          NPF=0
          IPT=8
10132     CONTINUE
          IF (.NOT.(IAM(IPT+3).NE.18)) GO TO 10133
            IPT=IAM(IPT+3)
            IF (.NOT.(IAM(IPT+7).NE.0.AND.IAM(IAM(IPT+4)+7).EQ.0)) GO TO
     + 10134
              IGI=ABS(IAM(IPT+7))
              IP1=IAM(IPT+4)
              IP2=IP1
10135         CONTINUE
              IF (.NOT.(IAM(IAM(IP2+6)+1).EQ.IAM(IP1+1).AND.IAM(IAM(IP2+
     +6)+2).EQ.IAM(IP1+2))) GO TO 10136
                IP2=IAM(IP2+6)
              GO TO 10135
10136         CONTINUE
              IP3=IP2
              IPF=0
10137         CONTINUE
                IF (.NOT.(IP2.NE.IP1.AND.(ABS(IAM(IP2+7)).EQ.IGI.OR.ABS(
     +IAM(IAM(IP2+3)+7)).EQ.IGI))) GO TO 10138
                  IPF=1
                  GO TO 10139
10138           CONTINUE
                IP2=IAM(IP2+5)
                IF (IAM(IP2+1).NE.IAM(IP1+1).OR.IAM(IP2+2).NE.IAM(IP1+2)
     +)         GO TO 10139
              GO TO 10137
10139         CONTINUE
              IF (.NOT.(IPF.EQ.0)) GO TO 10140
                IF (.NOT.(IAM(IPT+7).GT.0)) GO TO 10141
                  IP2=IP3
10142             CONTINUE
                    IF (.NOT.(IP2.NE.IP1)) GO TO 10143
                      IF (.NOT.(IAM(IP2+7).LT.0.AND.ABS(IAM(IP2+7)).NE.I
     +GI.AND.IAM(IAM(IP2+4)+1).EQ.IAM(IPT+1).AND.IAM(IAM(IP2+4)+2).EQ.IA
     +M(IPT+2)))      GO TO 10144
                        IAM(IP2+7)=ABS(IAM(IP2+7))
                        GO TO 10145
10144                 CONTINUE
                      IF (.NOT.(IAM(IAM(IP2+3)+7).LT.0.AND.ABS(IAM(IAM(I
     +P2+3)+7)).NE.IGI.AND.IAM(IAM(IP2+3)+1).EQ.IAM(IPT+1).AND.IAM(IAM(I
     +P2+3)+2).EQ.IAM(IPT+2))) GO TO 10146
                        IAM(IAM(IP2+3)+7)=
     +                              ABS(IAM(IAM(IP2+3)+7))
                        GO TO 10145
10146                 CONTINUE
10143               CONTINUE
                    IP2=IAM(IP2+5)
                    IF (IAM(IP2+1).NE.IAM(IP1+1).OR.IAM(IP2+2).NE.IAM(IP
     +1+2))         GO TO 10145
                  GO TO 10142
10145             CONTINUE
10141           CONTINUE
                IAM(IPT+7)=0
                NPF=NPF+1
10140         CONTINUE
10134       CONTINUE
          GO TO 10132
10133     CONTINUE
          IPT=18
10147     CONTINUE
          IF (.NOT.(IAM(IPT+4).NE.8)) GO TO 10148
            IPT=IAM(IPT+4)
            IF (.NOT.(IAM(IPT+7).NE.0.AND.IAM(IAM(IPT+3)+7).EQ.0)) GO TO
     + 10149
              IGI=ABS(IAM(IPT+7))
              IP1=IPT
              IP2=IP1
10150         CONTINUE
              IF (.NOT.(IAM(IAM(IP2+6)+1).EQ.IAM(IP1+1).AND.IAM(IAM(IP2+
     +6)+2).EQ.IAM(IP1+2))) GO TO 10151
                IP2=IAM(IP2+6)
              GO TO 10150
10151         CONTINUE
              IP3=IP2
              IPF=0
10152         CONTINUE
                IF (.NOT.(IP2.NE.IP1.AND.(ABS(IAM(IP2+7)).EQ.IGI.OR.ABS(
     +IAM(IAM(IP2+3)+7)).EQ.IGI))) GO TO 10153
                  IPF=1
                  GO TO 10154
10153           CONTINUE
                IP2=IAM(IP2+5)
                IF (IAM(IP2+1).NE.IAM(IP1+1).OR.IAM(IP2+2).NE.IAM(IP1+2)
     +)         GO TO 10154
              GO TO 10152
10154         CONTINUE
              IF (.NOT.(IPF.EQ.0)) GO TO 10155
                IF (.NOT.(IAM(IPT+7).GT.0)) GO TO 10156
                  IP2=IP3
10157             CONTINUE
                    IF (.NOT.(IP2.NE.IP1)) GO TO 10158
                      IF (.NOT.(IAM(IP2+7).LT.0.AND.ABS(IAM(IP2+7)).NE.I
     +GI.AND.IAM(IAM(IP2+4)+1).EQ.IAM(IAM(IPT+4)+1).AND.IAM(IAM(IP2+4)+2
     +).EQ.IAM(IAM(IPT+4)+2))) GO TO 10159
                        IAM(IP2+7)=ABS(IAM(IP2+7))
                        GO TO 10160
10159                 CONTINUE
                      IF (.NOT.(IAM(IAM(IP2+3)+7).LT.0.AND.ABS(IAM(IAM(I
     +P2+3)+7)).NE.IGI.AND.IAM(IAM(IP2+3)+1).EQ.IAM(IAM(IPT+4)+1).AND.IA
     +M(IAM(IP2+3)+2).EQ.IAM(IAM(IPT+4)+2))) GO TO 10161
                        IAM(IAM(IP2+3)+7)=
     +                              ABS(IAM(IAM(IP2+3)+7))
                        GO TO 10160
10161                 CONTINUE
10158               CONTINUE
                    IP2=IAM(IP2+5)
                    IF (IAM(IP2+1).NE.IAM(IP1+1).OR.IAM(IP2+2).NE.IAM(IP
     +1+2))         GO TO 10160
                  GO TO 10157
10160             CONTINUE
10156           CONTINUE
                IAM(IPT+7)=0
                NPF=NPF+1
10155         CONTINUE
10149       CONTINUE
          GO TO 10147
10148     CONTINUE
        IF (.NOT.(NPF.EQ.0)) GO TO 10131
C
C If debugging is turned on, produce a plot.
C
        IF (.NOT.(IDB.NE.0)) GO TO 10162
          CALL ARDBPA (IAM,IDB,'AFTER REMOVING UNCLOSED EDGES')
          IF (ICFELL('ARPRAM',9).NE.0) RETURN
10162   CONTINUE
C
C
10130 CONTINUE
C
C Adjust the area identifiers for all edge segments in the map.  We
C first make a pass over the entire area map, looking for holes and
C eliminating them by the insertion of some temporary connecting lines.
C
C Save the pointer to the last word of the last node, so that we can
C remove the nodes implementing the temporary connecting lines before
C returning to the caller.
C
      ILW=IAM(5)
C
C Each pass through the following loop traces the boundary of one
C connected loop.  In some cases (for contour maps, for example),
C this step can be omitted; in those cases, there is a small chance
C of failure, in which case we have to come back and force the step
C to occur.
C
  104 CONTINUE
      IF (.NOT.(KF3.EQ.0)) GO TO 10163
C
C
        IPT=8
C
10164   CONTINUE
C
C Move to the right across the area map, looking for an edge segment
C that has not yet been completely processed.  If no such segment can
C be found, all subareas have been done.
C
10165     CONTINUE
          IF (.NOT.(MOD(IAM(IPT),4).EQ.3.OR.ABS(IAM(IPT+7)).LT.IAM(6)))
     +    GO TO 10166
            IPT=IAM(IPT+5)
            IF (IPT.EQ.18) GO TO 10167
          GO TO 10165
10166     CONTINUE
C
C Pull out the group identifier for the segment.
C
          IGI=ABS(IAM(IPT+7))
C
C Decide whether to scan the subarea to the left of the edge being
C traced (IPU=1) or the one to the right (IPU=2).
C
          IF (.NOT.(MOD(IAM(IPT),2).EQ.0)) GO TO 10168
            IPU=1
          GO TO 10169
10168     CONTINUE
            IPU=2
10169     CONTINUE
C
C IPQ points to the node defining the beginning of the edge segment,
C IPR to the node defining the end of the edge segment, and IPS to
C the node defining the beginning of the edge, so that we can tell
C when we've gone all the way around it.
C
          IPQ=IAM(IPT+4)
          IPR=IPT
          IPS=IPQ
          IPM=IPR
          IPV=IPU
C Jira NCL_32: Test for special-case where IPP of first segment of the
C had been split to insert a hole-connector; if so, use the segment's
C original coordinates for angle calculation.
          IF (.NOT.(IPQ.GT.ILW)) GO TO 10170
            IF (IAM(IPQ+3).NE.IPT) IFRMXY=IAM(IPQ+3)
            IF (IAM(IPQ+4).NE.IPT) IFRMXY=IAM(IPQ+4)
          GO TO 10171
10170     CONTINUE
            IFRMXY=0
10171     CONTINUE
 
C
C We need to keep track of the highest point found along the loop and
C the total change in direction.  Initialize the variables involved.
C
          IPH=IPQ
          ANT=0.
C
C Each pass through the following loop moves one step along the edge of
C the subarea.
C
10172     CONTINUE
C
C Update the pointer to the highest point found along the loop.
C
            IF (IAM(IPR+2).GT.IAM(IPH+2)) IPH=IPR
C
C Move IPQ to IPP and IPR to IPQ.  They point to the nodes defining the
C ends of the current edge segment.
C
            IPP=IPQ
            IPQ=IPR
C
C Get the coordinates of the ends of the edge segment for use in
C computing change in direction to a possible next point.
C
            IF (.NOT.(IFRMXY.NE.0)) GO TO 10173
C               Jira NCL_32: use original endpoint of segments that were
C               split for hole-connectors.
              IXP=IAM(IFRMXY+1)
              IYP=IAM(IFRMXY+2)
              IFRMXY=0
            GO TO 10174
10173       CONTINUE
              IXP=IAM(IPP+1)
              IYP=IAM(IPP+2)
10174       CONTINUE
            IXQ=IAM(IPQ+1)
            IYQ=IAM(IPQ+2)
            FXP=REAL(IXP)
            FYP=REAL(IYP)
            FXQ=REAL(IXQ)
            FYQ=REAL(IYQ)
C
C Back up IPR to the beginning of the group of nodes which have the
C same X and Y coordinates as it does.
C
10175       CONTINUE
            IF (.NOT.(IAM(IPR+1).EQ.IAM(IAM(IPR+6)+1).AND.IAM(IPR+2).EQ.
     +IAM(IAM(IPR+6)+2))) GO TO 10176
              IPR=IAM(IPR+6)
            GO TO 10175
10176       CONTINUE
C
C Go through the group of nodes, examining all the possible ways to
C move from the current position to a new one.  Pick the direction
C which is leftmost (if IPU=1) or rightmost (if IPU=2).
C
            IP1=IPR
            IP2=IPR
            IPR=0
            IF (.NOT.(IPU.EQ.1)) GO TO 10177
              ANM=-3.14159265358979
            GO TO 10178
10177       CONTINUE
              ANM=+3.14159265358979
10178       CONTINUE
C
10179       CONTINUE
            IF (.NOT.(IAM(IP2+1).EQ.IAM(IP1+1).AND.IAM(IP2+2).EQ.IAM(IP1
     ++2))) GO TO 10180
              IF (.NOT.(ABS(IAM(IAM(IP2+3)+7)).EQ.IGI.AND.(IAM(IAM(IP2+3
     +)+1).NE.IAM(IPP+1).OR.IAM(IAM(IP2+3)+2).NE.IAM(IPP+2)))) GO TO 101
     +81
C                 Jira NCL_32: If test node is due to splitting a
C                 a line-segment to insert a hole-connector, use the
C                 original segment's end points for angle calculation.
                IF (.NOT.(IP2.LT.ILW.AND.IAM(IP2+3).GT.ILW)) GO TO 10182
                  IXR=IAM(IAM(IAM(IP2+3)+3)+1)
                  IYR=IAM(IAM(IAM(IP2+3)+3)+2)
                GO TO 10183
10182           CONTINUE
                  IXR=IAM(IAM(IP2+3)+1)
                  IYR=IAM(IAM(IP2+3)+2)
10183           CONTINUE
                FXR=REAL(IXR)
                FYR=REAL(IYR)
C
                IF (.NOT.(IAU.EQ.1)) GO TO 10184
                  ANG=ARRAT2((FXQ-FXP)*(FYR-FYQ)-(FYQ-FYP)*(FXR-FXQ),
     +                       (FXQ-FXP)*(FXR-FXQ)+(FYQ-FYP)*(FYR-FYQ))
                GO TO 10185
10184           CONTINUE
                IF (.NOT.(IAU.EQ.2)) GO TO 10186
                  ANG=ARDAT2(DBLE(IXQ-IXP)*DBLE(IYR-IYQ)-
     +                       DBLE(IYQ-IYP)*DBLE(IXR-IXQ),
     +                       DBLE(IXQ-IXP)*DBLE(IXR-IXQ)+
     +                       DBLE(IYQ-IYP)*DBLE(IYR-IYQ))
                GO TO 10185
10186           CONTINUE
                  IO6(3,1)=IXQ-IXP
                  IO6(3,2)=IYR-IYQ
                  IO6(3,3)=IYQ-IYP
                  IO6(3,4)=IXR-IXQ
                  CALL ARMPIA (IO6,DP1,IER)
                  IF (.NOT.(IER.NE.0)) GO TO 10187
                    GO TO 10028
10187             CONTINUE
                  CALL ARMPIA (IO7,DP2,IER)
                  IF (.NOT.(IER.NE.0)) GO TO 10189
                    GO TO 10028
10189             CONTINUE
                  ANG=ARDAT2(DP1,DP2)
10185           CONTINUE
C
                IF (.NOT.(IPU.EQ.1)) GO TO 10191
                  IF (.NOT.(ANG.GT.ANM)) GO TO 10192
                    IPR=IAM(IP2+3)
                    ANM=ANG
                    IPM=IPR
                    IPV=1
C                     Jira NCL_32: if this node was inserted to split
C                     a segment for a hole-connector, we want to use
C                     the original segment's endpoints on the next
C                     iteration through the inner loop.
C                     Note: because the first node (bottom) of the first
C                     hole-connector points *back* to a user-inserted
C                     node (i.e., IAM(IP2+$PD$).LT.ILW), we need to
C                     exclude that one special case from the following
C                     test; hence the factor (ILW+1).
                    IF (.NOT.(IP2.GT.(ILW+1).AND.IAM(IP2+4).LT.ILW)) GO
     +TO 10193
                      IFRMXY = IAM(IP2+4)
                    GO TO 10194
10193               CONTINUE
                      IFRMXY = 0
10194               CONTINUE
10192             CONTINUE
                GO TO 10195
10191           CONTINUE
                  IF (.NOT.(ANG.LT.ANM)) GO TO 10196
                    IPR=IAM(IP2+3)
                    ANM=ANG
                    IPM=IPR
                    IPV=2
C                     Jira NCL_32: if this node was inserted to split
C                     a segment for a hole-connector, we want to use
C                     the original segment's endpoints on the next
C                     iteration through the inner loop.
C                     Note: because the first node (bottom) of the first
C                     hole-connector points *back* to a user-inserted
C                     node (i.e., IAM(IP2+$PD$).LT.ILW), we need to
C                     exclude that one special case from the following
C                     test; hence the factor (ILW+1).
                    IF (.NOT.(IP2.GT.(ILW+1).AND.IAM(IP2+4).LT.ILW)) GO
     +TO 10197
                      IFRMXY = IAM(IP2+4)
                    GO TO 10198
10197               CONTINUE
                      IFRMXY = 0
10198               CONTINUE
10196             CONTINUE
10195           CONTINUE
10181         CONTINUE
              IF (.NOT.(ABS(IAM(IP2+7)).EQ.IGI.AND.(IAM(IAM(IP2+4)+1).NE
     +.IAM(IPP+1).OR.IAM(IAM(IP2+4)+2).NE.IAM(IPP+2)))) GO TO 10199
C                 Jira NCL_32: If test node is due to splitting a
C                 a line-segment to insert a hole-connector, use the
C                 original segment's end points for angle calculation.
                IF (.NOT.(IP2.LT.ILW.AND.IAM(IP2+4).GT.ILW)) GO TO 10200
                  IXR=IAM(IAM(IAM(IP2+4)+4)+1)
                  IYR=IAM(IAM(IAM(IP2+4)+4)+2)
                GO TO 10201
10200           CONTINUE
                  IXR=IAM(IAM(IP2+4)+1)
                  IYR=IAM(IAM(IP2+4)+2)
10201           CONTINUE
                FXR=REAL(IXR)
                FYR=REAL(IYR)
C
                IF (.NOT.(IAU.EQ.1)) GO TO 10202
                  ANG=ARRAT2((FXQ-FXP)*(FYR-FYQ)-(FYQ-FYP)*(FXR-FXQ),
     +                       (FXQ-FXP)*(FXR-FXQ)+(FYQ-FYP)*(FYR-FYQ))
                GO TO 10203
10202           CONTINUE
                IF (.NOT.(IAU.EQ.2)) GO TO 10204
                  ANG=ARDAT2(DBLE(IXQ-IXP)*DBLE(IYR-IYQ)-
     +                       DBLE(IYQ-IYP)*DBLE(IXR-IXQ),
     +                       DBLE(IXQ-IXP)*DBLE(IXR-IXQ)+
     +                       DBLE(IYQ-IYP)*DBLE(IYR-IYQ))
                GO TO 10203
10204           CONTINUE
                  IO6(3,1)=IXQ-IXP
                  IO6(3,2)=IYR-IYQ
                  IO6(3,3)=IYQ-IYP
                  IO6(3,4)=IXR-IXQ
                  CALL ARMPIA (IO6,DP1,IER)
                  IF (.NOT.(IER.NE.0)) GO TO 10205
                    GO TO 10028
10205             CONTINUE
                  CALL ARMPIA (IO7,DP2,IER)
                  IF (.NOT.(IER.NE.0)) GO TO 10207
                    GO TO 10028
10207             CONTINUE
                  ANG=ARDAT2(DP1,DP2)
10203           CONTINUE
C
                IF (.NOT.(IPU.EQ.1)) GO TO 10209
                  IF (.NOT.(ANG.GT.ANM)) GO TO 10210
                    IPR=IAM(IP2+4)
                    ANM=ANG
                    IPM=IP2
                    IPV=2
C                     Jira NCL_32: if this node was inserted to split
C                     a segment for a hole-connector, we want to use
C                     the original segment's endpoints on the next
C                     iteration through the inner loop.
                    IF (.NOT.(IP2.GT.ILW.AND.IAM(IP2+3).LT.ILW)) GO TO 1
     +0211
                      IFRMXY = IAM(IP2+3)
                    GO TO 10212
10211               CONTINUE
                      IFRMXY = 0
10212               CONTINUE
10210             CONTINUE
                GO TO 10213
10209           CONTINUE
                  IF (.NOT.(ANG.LT.ANM)) GO TO 10214
                    IPR=IAM(IP2+4)
                    ANM=ANG
                    IPM=IP2
                    IPV=1
C                     Jira NCL_32: if this node was inserted to split
C                     a segment for a hole-connector, we want to use
C                     the original segment's endpoints on the next
C                     iteration through the inner loop.
                    IF (.NOT.(IP2.GT.ILW.AND.IAM(IP2+3).LT.ILW)) GO TO 1
     +0215
                      IFRMXY = IAM(IP2+3)
                    GO TO 10216
10215               CONTINUE
                      IFRMXY = 0
10216               CONTINUE
10214             CONTINUE
10213           CONTINUE
10199         CONTINUE
              IP2=IAM(IP2+5)
            GO TO 10179
10180       CONTINUE
C
C If no possible exit was found, reverse direction.
C
            IF (.NOT.(IPR.EQ.0)) GO TO 10217
              IPR=IPP
              IPV=3-IPV
              IF (.NOT.(IPU.EQ.1)) GO TO 10218
                ANM=+3.14159265358979
              GO TO 10219
10218         CONTINUE
                ANM=-3.14159265358979
10219         CONTINUE
10217       CONTINUE
C
C Update the total angular change.
C
            ANT=ANT+ANM
C
C Set the marker for the edge segment picked.  If the marker is set
C already, either go back and do a slow-path intersection search or
C log an error.
C
            IF (.NOT.(IPV.EQ.1.AND.MOD(IAM(IPM),2).EQ.0)) GO TO 10220
              IAM(IPM)=IAM(IPM)+1
            GO TO 10221
10220       CONTINUE
            IF (.NOT.(IPV.EQ.2.AND.MOD(IAM(IPM)/2,2).EQ.0)) GO TO 10222
              IAM(IPM)=IAM(IPM)+2
            GO TO 10221
10222       CONTINUE
              IPT=IAM(5)-9
10223         CONTINUE
              IF (.NOT.(IPT.GT.ILW)) GO TO 10224
                IAM(IAM(IPT+4)+3)=IAM(IPT+3)
                IAM(IAM(IPT+3)+4)=IAM(IPT+4)
                IAM(IAM(IPT+6)+5)=IAM(IPT+5)
                IAM(IAM(IPT+5)+6)=IAM(IPT+6)
                IPT=IPT-10
              GO TO 10223
10224         CONTINUE
              IAM(5)=ILW
              DO 10225 IPT=8,IAM(5)-9,10
                IAM(IPT)=4*(IAM(IPT)/4)
10225         CONTINUE
              IF (.NOT.(KF1.NE.0)) GO TO 10226
                KF1=0
                GO TO 101
10226         CONTINUE
                CALL SETER ('ARPRAM - ALGORITHM FAILURE',10,1)
                GO TO 10008
10221       CONTINUE
C
C Exit if we're passing the start of the subarea.
C
            IF (IAM(IPQ+1).EQ.IAM(IPS+1).AND.IAM(IPQ+2).EQ.IAM(IPS+2).AN
     +D.IAM(IPR+1).EQ.IAM(IPT+1).AND.IAM(IPR+2).EQ.IAM(IPT+2)) GO TO 102
     +28
C
          GO TO 10172
10228     CONTINUE
C
C If the closed loop just traced was a hole, insert a temporary
C connecting line to get rid of the hole.
C
          IF (.NOT.((IPU.EQ.1.AND.ANT.LT.0.).OR.(IPU.EQ.2.AND.ANT.GT.0.)
     +))  GO TO 10229
            IOF=0
            XCI=REAL(IAM(IPH+1))
            YCI=REAL(IAM(IPH+2))
            YCO=RLP
            IP1=IPH
10230       CONTINUE
            IF (.NOT.(IAM(IAM(IP1+5)+1).EQ.IAM(IPH+1))) GO TO 10231
              IP1=IAM(IP1+5)
            GO TO 10230
10231       CONTINUE
10232       CONTINUE
            IF (.NOT.(IAM(IP1+1).GE.IAM(IPH+1)-IAM(2))) GO TO 10233
              IF (.NOT.(ABS(IAM(IP1+7)).EQ.IGI.AND.IAM(IAM(IP1+4)+1).GT.
     +IAM(IP1+1).AND.IAM(IAM(IP1+4)+1).GE.IAM(IPH+1))) GO TO 10234
                IF (.NOT.(IAU.EQ.1)) GO TO 10235
                  YTM=REAL(IAM(IP1+2))+
     +            (XCI-REAL(IAM(IP1+1)))*
     +         (REAL(IAM(IAM(IP1+4)+2)-IAM(IP1+2))/
     + REAL(IAM(IAM(IP1+4)+1)-IAM(IP1+1)))
                GO TO 10236
10235           CONTINUE
                  YTM=REAL(DBLE(IAM(IP1+2))+
     +            (DBLE(XCI)-DBLE(IAM(IP1+1)))*
     +         (DBLE(IAM(IAM(IP1+4)+2)-IAM(IP1+2))/
     + DBLE(IAM(IAM(IP1+4)+1)-IAM(IP1+1))))
10236           CONTINUE
                IF (.NOT.(YTM.GT.YCI.AND.YTM.LT.YCO)) GO TO 10237
                  IOF=IP1
                  YCO=YTM
10237           CONTINUE
10234         CONTINUE
              IF (.NOT.(ABS(IAM(IAM(IP1+3)+7)).EQ.IGI.AND.IAM(IAM(IP1+3)
     ++1).GT.IAM(IP1+1).AND.IAM(IAM(IP1+3)+1).GE.IAM(IPH+1))) GO TO 1023
     +8
                IF (.NOT.(IAU.EQ.1)) GO TO 10239
                  YTM=REAL(IAM(IP1+2))+
     +            (XCI-REAL(IAM(IP1+1)))*
     +         (REAL(IAM(IAM(IP1+3)+2)-IAM(IP1+2))/
     + REAL(IAM(IAM(IP1+3)+1)-IAM(IP1+1)))
                GO TO 10240
10239           CONTINUE
                  YTM=REAL(DBLE(IAM(IP1+2))+
     +            (DBLE(XCI)-DBLE(IAM(IP1+1)))*
     +         (DBLE(IAM(IAM(IP1+3)+2)-IAM(IP1+2))/
     + DBLE(IAM(IAM(IP1+3)+1)-IAM(IP1+1))))
10240           CONTINUE
                IF (.NOT.(YTM.GT.YCI.AND.YTM.LT.YCO)) GO TO 10241
                  IOF=IAM(IP1+3)
                  YCO=YTM
10241           CONTINUE
10238         CONTINUE
              IP1=IAM(IP1+6)
            GO TO 10232
10233       CONTINUE
            IF (.NOT.(IOF.NE.0)) GO TO 10242
              IX0=IAM(IPH+1)
              IY0=IAM(IPH+2)
              IF (.NOT.(INT(YCO+.5).NE.IY0)) GO TO 10243
                IPI=18
                L10017=    6
                GO TO 10017
10244           CONTINUE
                IAM(IPN+7)=0
                IAM(IPN+8)=0
                IAM(IPN+9)=0
                IY0=INT(YCO+.5)
                L10017=    7
                GO TO 10017
10245           CONTINUE
                IAM(IPN+7)=LAM-IGI
                IAM(IPN+8)=0
                IAM(IPN+9)=0
10243         CONTINUE
              IF (.NOT.((IX0.NE.IAM(IOF+1).OR.IY0.NE.IAM(IOF+2)).AND.(IX
     +0.NE.IAM(IAM(IOF+4)+1).OR.IY0.NE.IAM(IAM(IOF+4)+2)))) GO TO 10246
                IPI=IOF
                L10017=    8
                GO TO 10017
10247           CONTINUE
10246         CONTINUE
10242       CONTINUE
C
10229     CONTINUE
C
        GO TO 10164
10167   CONTINUE
C
C Zero the lower bits in the markers in all the nodes.
C
        DO 10248 IPT=8,IAM(5)-9,10
          IAM(IPT)=4*(IAM(IPT)/4)
10248   CONTINUE
C
C If debugging is turned on, produce a plot.
C
        IF (.NOT.(IDB.NE.0)) GO TO 10249
          CALL ARDBPA (IAM,IDB,'AFTER LOOKING FOR HOLES')
          IF (ICFELL('ARPRAM',11).NE.0) RETURN
10249   CONTINUE
C
C
10163 CONTINUE
C
C Now, make another pass through the area map, tracing one subarea at a
C time and setting the area identifiers in each.
C
C Each pass through the following loop traces the boundary of one
C subarea.
C
C
      IPT=8
C
10250 CONTINUE
C
C Move to the right across the area map, looking for an edge segment
C that has not yet been completely processed.  If no such segment can
C be found, all subareas have been done.
C
10251   CONTINUE
        IF (.NOT.(MOD(IAM(IPT),4).EQ.3.OR.ABS(IAM(IPT+7)).LT.IAM(6).OR.(
     +KF3.NE.0.AND.((MOD(IAM(IPT),2).NE.0.OR.IAM(IPT+8).GT.0).AND.(MOD(I
     +AM(IPT)/2,2).NE.0.OR.IAM(IPT+9).GT.0))))) GO TO 10252
          IPT=IAM(IPT+5)
          IF (IPT.EQ.18) GO TO 10253
        GO TO 10251
10252   CONTINUE
C
C Pull out the group identifier for the segment.
C
        IGI=ABS(IAM(IPT+7))
C
C Decide how contradictory area identifiers are to be reconciled.
C
        JRC=IRC(MAX(1,MIN(16,IAM(IGI)/2)))
C
C Decide whether to scan the subarea to the left of the edge being
C traced (IPU=1) or the one to the right (IPU=2) and initialize the
C area identifier.
C
        IF (.NOT.(MOD(IAM(IPT),2).EQ.0.AND.(KF3.EQ.0.OR.IAM(IPT+8).LE.0)
     +))GO TO 10254
          IPU=1
        GO TO 10255
10254   CONTINUE
          IPU=2
10255   CONTINUE
C
        IAI=0
        IAP=0
        IAX=0
C
        IF (.NOT.(JRC.NE.0)) GO TO 10256
          ICN=0
          ICZ=0
          IOS=LAM-IAM(6)
          IF (.NOT.(IOS.GT.IAM(6)-1-IAM(5))) GO TO 10257
            CALL SETER ('ARPRAM - AREA-MAP ARRAY OVERFLOW',12,1)
            GO TO 10008
10257     CONTINUE
          DO 10259 ITM=IAM(6),LAM-1
            IAM(ITM-IOS)=0
10259     CONTINUE
10256   CONTINUE
C
C IPQ points to the node defining the beginning of the edge segment,
C IPR to the node defining the end of the edge segment, and IPS to
C the node defining the beginning of the edge, so that we can tell
C when we've gone all the way around it.
C
        IPQ=IAM(IPT+4)
        IPR=IPT
        IPS=IPQ
        IPM=IPR
        IPV=IPU
C Jira NCL_32: Test for special-case where IPP of first segment of the
C had been split to insert a hole-connector; if so, use the segment's
C original coordinates for angle calculation.
        IF (.NOT.(IPQ.GT.ILW)) GO TO 10260
          IF (IAM(IPQ+3).NE.IPT) IFRMXY=IAM(IPQ+3)
          IF (IAM(IPQ+4).NE.IPT) IFRMXY=IAM(IPQ+4)
        GO TO 10261
10260   CONTINUE
          IFRMXY=0
10261   CONTINUE
 
C
C Each pass through the following loop moves one step along the edge of
C the subarea.
C
10262   CONTINUE
C
C Move IPQ to IPP and IPR to IPQ.
C
          IPP=IPQ
          IPQ=IPR
C
C Get the coordinates of the ends of the edge segment for use in
C computing change in direction to a possible next point.
C
          IF (.NOT.(IFRMXY.NE.0)) GO TO 10263
C             Jira NCL_32: use original endpoint of segments that were
C             split for hole-connectors.
            IXP=IAM(IFRMXY+1)
            IYP=IAM(IFRMXY+2)
            IFRMXY=0
          GO TO 10264
10263     CONTINUE
            IXP=IAM(IPP+1)
            IYP=IAM(IPP+2)
10264     CONTINUE
          IXQ=IAM(IPQ+1)
          IYQ=IAM(IPQ+2)
          FXP=REAL(IXP)
          FYP=REAL(IYP)
          FXQ=REAL(IXQ)
          FYQ=REAL(IYQ)
C
C Back up IPR to the beginning of the group of nodes which have the
C same X and Y coordinates as it does.
C
10265     CONTINUE
          IF (.NOT.(IAM(IPR+1).EQ.IAM(IAM(IPR+6)+1).AND.IAM(IPR+2).EQ.IA
     +M(IAM(IPR+6)+2))) GO TO 10266
            IPR=IAM(IPR+6)
          GO TO 10265
10266     CONTINUE
C
C If there is only one node in the group, the exit path is obvious.
C
          IF (.NOT.(IAM(IPR+1).NE.IAM(IAM(IPR+5)+1).OR.IAM(IPR+2).NE.IAM
     +(IAM(IPR+5)+2))) GO TO 10267
            IF (.NOT.(IAM(IAM(IPR+3)+1).NE.IAM(IPP+1).OR.IAM(IAM(IPR+3)+
     +2).NE.IAM(IPP+2))) GO TO 10268
              IF (.NOT.(IAM(IAM(IPR+3)+7).EQ.LAM-IGI.OR.ABS(IAM(IAM(IPR+
     +3)+7)).EQ.IGI)) GO TO 10269
                IPM=IAM(IPR+3)
                IPR=IPM
                IPV=IPU
              GO TO 10270
10269         CONTINUE
                IPR=0
10270         CONTINUE
            GO TO 10271
10268       CONTINUE
              IF (.NOT.(IAM(IPR+7).EQ.LAM-IGI.OR.ABS(IAM(IPR+7)).EQ.IGI)
     +)       GO TO 10272
                IPM=IPR
                IPR=IAM(IPR+4)
                IPV=3-IPU
              GO TO 10273
10272         CONTINUE
                IPR=0
10273         CONTINUE
10271       CONTINUE
C
C Otherwise, go through the group of nodes, examining all the possible
C ways to move from the current position to a new one.  Pick the
C direction which is leftmost (if IPU=1) or rightmost (if IPU=2).
C
          GO TO 10274
10267     CONTINUE
C
            IP1=IPR
            IP2=IPR
            IPR=0
            IF (.NOT.(IPU.EQ.1)) GO TO 10275
              ANM=-3.14159265358979
            GO TO 10276
10275       CONTINUE
              ANM=+3.14159265358979
10276       CONTINUE
C
10277       CONTINUE
            IF (.NOT.(IAM(IP2+1).EQ.IAM(IP1+1).AND.IAM(IP2+2).EQ.IAM(IP1
     ++2))) GO TO 10278
              IF (.NOT.((IAM(IAM(IP2+3)+7).EQ.LAM-IGI.OR.ABS(IAM(IAM(IP2
     ++3)+7)).EQ.IGI).AND.(IAM(IAM(IP2+3)+1).NE.IAM(IPP+1).OR.IAM(IAM(IP
     +2+3)+2).NE.IAM(IPP+2)))) GO TO 10279
C                 Jira NCL_32: If test node is due to splitting a
C                 a line-segment to insert a hole-connector, use the
C                 original segment's end points for angle calculation.
                IF (.NOT.(IP2.LT.ILW.AND.IAM(IP2+3).GT.ILW)) GO TO 10280
                  IXR=IAM(IAM(IAM(IP2+3)+3)+1)
                  IYR=IAM(IAM(IAM(IP2+3)+3)+2)
                GO TO 10281
10280           CONTINUE
                  IXR=IAM(IAM(IP2+3)+1)
                  IYR=IAM(IAM(IP2+3)+2)
10281           CONTINUE
                FXR=REAL(IXR)
                FYR=REAL(IYR)
C
                IF (.NOT.(IAU.EQ.1)) GO TO 10282
                  ANG=ARRAT2((FXQ-FXP)*(FYR-FYQ)-(FYQ-FYP)*(FXR-FXQ),
     +                       (FXQ-FXP)*(FXR-FXQ)+(FYQ-FYP)*(FYR-FYQ))
                GO TO 10283
10282           CONTINUE
                IF (.NOT.(IAU.EQ.2)) GO TO 10284
                  ANG=ARDAT2(DBLE(IXQ-IXP)*DBLE(IYR-IYQ)-
     +                       DBLE(IYQ-IYP)*DBLE(IXR-IXQ),
     +                       DBLE(IXQ-IXP)*DBLE(IXR-IXQ)+
     +                       DBLE(IYQ-IYP)*DBLE(IYR-IYQ))
                GO TO 10283
10284           CONTINUE
                  IO6(3,1)=IXQ-IXP
                  IO6(3,2)=IYR-IYQ
                  IO6(3,3)=IYQ-IYP
                  IO6(3,4)=IXR-IXQ
                  CALL ARMPIA (IO6,DP1,IER)
                  IF (.NOT.(IER.NE.0)) GO TO 10285
                    GO TO 10028
10285             CONTINUE
                  CALL ARMPIA (IO7,DP2,IER)
                  IF (.NOT.(IER.NE.0)) GO TO 10287
                    GO TO 10028
10287             CONTINUE
                  ANG=ARDAT2(DP1,DP2)
10283           CONTINUE
C
                IF (.NOT.(IPU.EQ.1)) GO TO 10289
                  IF (.NOT.(ANG.GT.ANM)) GO TO 10290
C                     Jira NCL_32: special-case code for Tomas example:
C                     Do not follow hole-connector segments that double
C                     back in the direction we just came from.
                    IF (.NOT.(ISHOLEC(IP2).AND.ANG.GE.3.14159265358979))
     + GO TO 10291
                      CONTINUE
                    GO TO 10292
10291               CONTINUE
                      IPR=IAM(IP2+3)
                      ANM=ANG
                      IPM=IPR
                      IPV=1
C                       Jira NCL_32: if this node was inserted to split
C                       a segment for a hole-connector, we want to use
C                       the original segment's endpoints on the next
C                       iteration through the inner loop.
C                       Note: because the first node (bottom) of the fir
C                       hole-connector points *back* to a user-inserted
C                       node (i.e., IAM(IP2+$PD$).LT.ILW), we need to
C                       exclude that one special case from the following
C                       test; hence the factor (ILW+1).
                      IF (.NOT.(IP2.GT.(ILW+1).AND.IAM(IP2+4).LT.ILW)) G
     +O TO 10293
                        IFRMXY = IAM(IP2+4)
                      GO TO 10294
10293                 CONTINUE
                        IFRMXY = 0
10294                 CONTINUE
10292               CONTINUE
10290             CONTINUE
                GO TO 10295
10289           CONTINUE
                  IF (.NOT.(ANG.LT.ANM)) GO TO 10296
C                     Jira NCL_32: special-case code for Tomas example:
C                     Do not follow hole-connector segments that double
C                     back in the direction we just came from.
                    IF (.NOT.(ISHOLEC(IP2).AND.ANG.LE.-3.14159265358979)
     +) GO TO 10297
                      CONTINUE
                    GO TO 10298
10297               CONTINUE
                      IPR=IAM(IP2+3)
                      ANM=ANG
                      IPM=IPR
                      IPV=2
C                       Jira NCL_32: if this node was inserted to split
C                       a segment for a hole-connector, we want to use
C                       the original segment's endpoints on the next
C                       iteration through the inner loop.
C                       Note: because the first node (bottom) of the fir
C                       hole-connector points *back* to a user-inserted
C                       node (i.e., IAM(IP2+$PD$).LT.ILW), we need to
C                       exclude that one special case from the following
C                       test; hence the factor (ILW+1).
                      IF (.NOT.(IP2.GT.(ILW+1).AND.IAM(IP2+4).LT.ILW)) G
     +O TO 10299
                        IFRMXY = IAM(IP2+4)
                      GO TO 10300
10299                 CONTINUE
                        IFRMXY = 0
10300                 CONTINUE
10298               CONTINUE
10296             CONTINUE
10295           CONTINUE
10279         CONTINUE
              IF (.NOT.((IAM(IP2+7).EQ.LAM-IGI.OR.ABS(IAM(IP2+7)).EQ.IGI
     +).AND.(IAM(IAM(IP2+4)+1).NE.IAM(IPP+1).OR.IAM(IAM(IP2+4)+2).NE.IAM
     +(IPP+2)))) GO TO 10301
C                 Jira NCL_32: If test node is due to splitting a
C                 a line-segment to insert a hole-connector, use the
C                 original segment's end points for angle calculation.
                IF (.NOT.(IP2.LT.ILW.AND.IAM(IP2+4).GT.ILW)) GO TO 10302
                  IXR=IAM(IAM(IAM(IP2+4)+4)+1)
                  IYR=IAM(IAM(IAM(IP2+4)+4)+2)
                GO TO 10303
10302           CONTINUE
                  IXR=IAM(IAM(IP2+4)+1)
                  IYR=IAM(IAM(IP2+4)+2)
10303           CONTINUE
                FXR=REAL(IXR)
                FYR=REAL(IYR)
C
                IF (.NOT.(IAU.EQ.1)) GO TO 10304
                  ANG=ARRAT2((FXQ-FXP)*(FYR-FYQ)-(FYQ-FYP)*(FXR-FXQ),
     +                       (FXQ-FXP)*(FXR-FXQ)+(FYQ-FYP)*(FYR-FYQ))
                GO TO 10305
10304           CONTINUE
                IF (.NOT.(IAU.EQ.2)) GO TO 10306
                  ANG=ARDAT2(DBLE(IXQ-IXP)*DBLE(IYR-IYQ)-
     +                       DBLE(IYQ-IYP)*DBLE(IXR-IXQ),
     +                       DBLE(IXQ-IXP)*DBLE(IXR-IXQ)+
     +                       DBLE(IYQ-IYP)*DBLE(IYR-IYQ))
                GO TO 10305
10306           CONTINUE
                  IO6(3,1)=IXQ-IXP
                  IO6(3,2)=IYR-IYQ
                  IO6(3,3)=IYQ-IYP
                  IO6(3,4)=IXR-IXQ
                  CALL ARMPIA (IO6,DP1,IER)
                  IF (.NOT.(IER.NE.0)) GO TO 10307
                    GO TO 10028
10307             CONTINUE
                  CALL ARMPIA (IO7,DP2,IER)
                  IF (.NOT.(IER.NE.0)) GO TO 10309
                    GO TO 10028
10309             CONTINUE
                  ANG=ARDAT2(DP1,DP2)
10305           CONTINUE
C
                IF (.NOT.(IPU.EQ.1)) GO TO 10311
                  IF (.NOT.(ANG.GT.ANM)) GO TO 10312
C                     Jira NCL_32: special-case code for Tomas example:
C                     Do not follow hole-connector segments that double
C                     back in the direction we just came from.
                    IF (.NOT.(ISHOLEC(IP2).AND.ANG.GE.3.14159265358979))
     + GO TO 10313
                      CONTINUE
                    GO TO 10314
10313               CONTINUE
                      IPR=IAM(IP2+4)
                      ANM=ANG
                      IPM=IP2
                      IPV=2
C                       Jira NCL_32: if this node was inserted to split
C                       a segment for a hole-connector, we want to use
C                       the original segment's endpoints on the next
C                       iteration through the inner loop.
                      IF (.NOT.(IP2.GT.ILW.AND.IAM(IP2+3).LT.ILW)) GO TO
     + 10315
                        IFRMXY = IAM(IP2+3)
                      GO TO 10316
10315                 CONTINUE
                        IFRMXY = 0
10316                 CONTINUE
10314               CONTINUE
10312             CONTINUE
                GO TO 10317
10311           CONTINUE
                  IF (.NOT.(ANG.LT.ANM)) GO TO 10318
C                     Jira NCL_32: special-case code for Tomas example:
C                     Do not follow hole-connector segments that double
C                     back in the direction we just came from.
                    IF (.NOT.(ISHOLEC(IP2).AND.ANG.LE.-3.14159265358979)
     +) GO TO 10319
                      CONTINUE
                    GO TO 10320
10319               CONTINUE
                      IPR=IAM(IP2+4)
                      ANM=ANG
                      IPM=IP2
                      IPV=1
C                       Jira NCL_32: if this node was inserted to split
C                       a segment for a hole-connector, we want to use
C                       the original segment's endpoints on the next
C                       iteration through the inner loop.
                      IF (.NOT.(IP2.GT.ILW.AND.IAM(IP2+3).LT.ILW)) GO TO
     + 10321
                        IFRMXY = IAM(IP2+3)
                      GO TO 10322
10321                 CONTINUE
                        IFRMXY = 0
10322                 CONTINUE
10320               CONTINUE
10318             CONTINUE
10317           CONTINUE
10301         CONTINUE
              IP2=IAM(IP2+5)
            GO TO 10277
10278       CONTINUE
C
10274     CONTINUE
C
C If no possible exit was found, reverse direction.
C
          IF (.NOT.(IPR.EQ.0)) GO TO 10323
            IPR=IPP
            IPV=3-IPV
10323     CONTINUE
C
C Update the markers for the edge segment picked.
C
          IF (.NOT.(IPV.EQ.1.AND.MOD(IAM(IPM),2).EQ.0)) GO TO 10324
            IAM(IPM)=IAM(IPM)+1
            IAQ=IPM+8
          GO TO 10325
10324     CONTINUE
          IF (.NOT.(IPV.EQ.2.AND.MOD(IAM(IPM)/2,2).EQ.0)) GO TO 10326
            IAM(IPM)=IAM(IPM)+2
            IAQ=IPM+9
          GO TO 10325
10326     CONTINUE
            CALL SETER ('ARPRAM - ALGORITHM FAILURE',13,1)
            GO TO 10008
10325     CONTINUE
C
          IF (.NOT.(IAM(IAQ).LE.0.OR.IAM(IAQ).GE.IAM(6))) GO TO 10328
C
            IF (.NOT.(JRC.EQ.0)) GO TO 10329
C
              IF (.NOT.(IAM(IAQ).LT.0)) GO TO 10330
                IAI=-1
                IAX=LAM*4
              GO TO 10331
10330         CONTINUE
              IF (.NOT.(IAM(IAQ).GE.IAM(6).AND.IAM(IPM).GT.IAX)) GO TO 1
     +0332
                IAI=IAM(IAQ)
                IAX=IAM(IPM)
10331         CONTINUE
10332         CONTINUE
C
            GO TO 10333
10329       CONTINUE
C
              IF (.NOT.(IAM(IAQ).LT.0)) GO TO 10334
                ICN=ICN+1
              GO TO 10335
10334         CONTINUE
              IF (.NOT.(IAM(IAQ).EQ.0)) GO TO 10336
                ICZ=ICZ+1
              GO TO 10335
10336         CONTINUE
              IF (.NOT.(IAM(IAQ).GE.IAM(6))) GO TO 10337
                IAM(IAM(IAQ)-IOS)=IAM(IAM(IAQ)-IOS)+1
10335         CONTINUE
10337         CONTINUE
C
10333       CONTINUE
C
            IAM(IAQ)=IAP
            IAP=IAQ
C
10328     CONTINUE
C
C Exit if we're passing the start of the subarea.
C
          IF (IAM(IPQ+1).EQ.IAM(IPS+1).AND.IAM(IPQ+2).EQ.IAM(IPS+2).AND.
     +IAM(IPR+1).EQ.IAM(IPT+1).AND.IAM(IPR+2).EQ.IAM(IPT+2)) GO TO 10338
C
        GO TO 10262
10338   CONTINUE
C
C If the new way of reconciling contradictory area-identifier info was
C requested, set IAI accordingly, using the counts that were generated
C while tracing the boundary of the area.
C
        IF (.NOT.(JRC.LT.0.AND.ICN.GT.0)) GO TO 10339
          IAI=-1
        GO TO 10340
10339   CONTINUE
        IF (.NOT.(JRC.NE.0)) GO TO 10341
          IF (.NOT.(ICN.GT.0)) GO TO 10342
            IAI=-1
            IAX=ICN
10342     CONTINUE
          IF (.NOT.(ICZ.GT.IAX.AND.ABS(JRC).EQ.2)) GO TO 10343
            IAI=0
            IAX=ICZ
10343     CONTINUE
          DO 10344 ITM=IAM(6),LAM-1
            IF (.NOT.(IAM(ITM-IOS).GE.IAX)) GO TO 10345
              IAI=ITM
              IAX=IAM(ITM-IOS)
10345       CONTINUE
10344     CONTINUE
10340   CONTINUE
10341   CONTINUE
C
C Go through the chain of area identifiers, updating them.
C
10346   CONTINUE
        IF (.NOT.(IAP.NE.0)) GO TO 10347
          IAQ=IAM(IAP)
          IAM(IAP)=IAI
          IAP=IAQ
        GO TO 10346
10347   CONTINUE
C
C If a zero identifier was selected for the area, see if the search for
C holes was suppressed and, if so, re-do it.
C
        IF (.NOT.(IAI.EQ.0.AND.KF3.NE.0)) GO TO 10348
          DO 10349 IPT=8,IAM(5)-9,10
            IAM(IPT)=4*(IAM(IPT)/4)
10349     CONTINUE
          KF3=0
          GO TO 104
10348   CONTINUE
C
      GO TO 10250
10253 CONTINUE
C
C Delete the nodes used to put in the temporary connecting lines.
C
      IPT=IAM(5)-9
C
10350 CONTINUE
      IF (.NOT.(IPT.GT.ILW)) GO TO 10351
        IAM(IAM(IPT+4)+3)=IAM(IPT+3)
        IAM(IAM(IPT+3)+4)=IAM(IPT+4)
        IAM(IAM(IPT+6)+5)=IAM(IPT+5)
        IAM(IAM(IPT+5)+6)=IAM(IPT+6)
        IPT=IPT-10
      GO TO 10350
10351 CONTINUE
C
      IAM(5)=ILW
C
C Zero the markers in all the remaining nodes.
C
      DO 10352 IPT=8,IAM(5)-9,10
        IAM(IPT)=0
10352 CONTINUE
C
C Update the map state.
C
      IAM(4)=1
C
C If debugging is turned on, produce a plot.
C
      IF (.NOT.(IDB.NE.0)) GO TO 10353
        CALL ARDBPA (IAM,IDB,'AFTER UPDATING AREA IDENTIFIERS')
        IF (ICFELL('ARPRAM',14).NE.0) RETURN
10353 CONTINUE
C
C
C Done.
C
      CALL CHECKAREAMAP(IAM)

      RETURN
C
C This internal procedure adds a new point in the existing part of the
C area map.  Note that ADD-A-POINT puts a new point which has the same
C coordinates as an old point after the old point in the area map (in
C coordinate order); this is important.
C
10017 CONTINUE
        IPN=IAM(5)+1
        IF (.NOT.(IAM(5)+10.GE.IAM(6))) GO TO 10354
          CALL SETER ('ARPRAM - AREA-MAP ARRAY OVERFLOW',15,1)
          GO TO 10008
10354   CONTINUE
        IAM(5)=IAM(5)+10
        IAM(IPN)=IAM(IPI)
        IAM(IPN+1)=IX0
        IAM(IPN+2)=IY0
        IAM(IPN+3)=IPI
        IAM(IPN+4)=IAM(IPI+4)
        IAM(IAM(IPI+4)+3)=IPN
        IAM(IPI+4)=IPN
10356   CONTINUE
          IF (.NOT.(IAM(IPN+1).LT.IAM(IPX+1))) GO TO 10357
            IPX=IAM(IPX+6)
          GO TO 10358
10357     CONTINUE
          IF (.NOT.(IAM(IPN+1).GT.IAM(IAM(IPX+5)+1))) GO TO 10359
            IPX=IAM(IPX+5)
          GO TO 10358
10359     CONTINUE
10360       CONTINUE
              IF (.NOT.(IAM(IPN+1).EQ.IAM(IPX+1).AND.IAM(IPN+2).LT.IAM(I
     +PX+2))) GO TO 10361
                IPX=IAM(IPX+6)
              GO TO 10362
10361         CONTINUE
              IF (.NOT.(IAM(IPN+1).EQ.IAM(IAM(IPX+5)+1).AND.IAM(IPN+2).G
     +T.IAM(IAM(IPX+5)+2))) GO TO 10363
                IPX=IAM(IPX+5)
              GO TO 10362
10363         CONTINUE
10364           CONTINUE
                IF (.NOT.(IAM(IAM(IPX+5)+1).EQ.IAM(IPN+1).AND.IAM(IAM(IP
     +X+5)+2).EQ.IAM(IPN+2))) GO TO 10365
                  IPX=IAM(IPX+5)
                GO TO 10364
10365           CONTINUE
                GO TO 10366
10362         CONTINUE
            GO TO 10360
10366       CONTINUE
            GO TO 10367
10358     CONTINUE
        GO TO 10356
10367   CONTINUE
        IAM(IPN+5)=IAM(IPX+5)
        IAM(IPN+6)=IAM(IAM(IPX+5)+6)
        IAM(IAM(IPX+5)+6)=IPN
        IAM(IPX+5)=IPN
        IAM(IPN+7)=IAM(IPI+7)
        IAM(IPN+8)=IAM(IPI+8)
        IAM(IPN+9)=IAM(IPI+9)
      GO TO (10016,10032,10083,10085,10097,10244,10245,10247) , L10017
C
C This internal procedure is called when an error occurs in ARMPIA.
C
10028 CONTINUE
        CALL SETER
     +  ('ARPRAM/ARMPIA - MULTIPLE-PRECISION QUANTITY IS TOO BIG',
     +                                                       16,1)
        GO TO 10008
C
C This internal procedure cleans up after an error condition occurs.
C It removes nodes used to put in temporary connecting lines, if any,
C and returns markers in the remaining nodes to zero.
C
10008 CONTINUE
C
C Delete new nodes from the area map.
C
        IPT=IAM(5)-9
C
10369   CONTINUE
        IF (.NOT.(IPT.GT.ILW)) GO TO 10370
          IAM(IAM(IPT+4)+3)=IAM(IPT+3)
          IAM(IAM(IPT+3)+4)=IAM(IPT+4)
          IAM(IAM(IPT+6)+5)=IAM(IPT+5)
          IAM(IAM(IPT+5)+6)=IAM(IPT+6)
          IPT=IPT-10
        GO TO 10369
10370   CONTINUE
C
        IAM(5)=ILW
C
C Zero the low-order bits of the markers in all the remaining nodes.
C
        DO 10371 IPT=8,IAM(5)-9,10
          IAM(IPT)=4*(IAM(IPT)/4)
10371   CONTINUE
C
C If appropriate, delete space temporarily used at the upper end of
C the area map array.
C
        IF (ISU.NE.0) IAM(6)=ISU
C
C Return to the calling routine.
C
        RETURN
C
C
      END

      PROGRAM MPEX03
C
C Produce a Mercator projection of the whole globe, using
C simplified continental outlines.  See the routine MAPEOD,
C below.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Define the label for the top of the map.
C
      CHARACTER*46 PLBL
C
      DATA PLBL/'SIMPLIFIED CONTINENTS ON A MERCATOR PROJECTION'/
C
C Open GKS.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Turn off the clipping indicator.
C
      CALL GSCLIP (0)
C
C Draw the map.
C
      CALL SUPMAP (9,0.,0.,0.,0.,0.,0.,0.,1,15,2,0,IERR)
C
C Put the label at the top of the plot.
C
      CALL SET (0.,1.,0.,1.,0.,1.,0.,1.,1)
      CALL PWRIT (.5,.975,PLBL,46,2,0,0)
C
C Draw a boundary around the edge of the plotter frame.
C
      CALL BNDARY
C
C Advance the frame.
C
      CALL FRAME
C
C Close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
C Done.
C
      STOP
C
      END
      SUBROUTINE MAPEOD (NOUT,NSEG,IDLS,IDRS,NPTS,PNTS)
C
      DIMENSION PNTS(*)
C
C This version of MAPEOD uses area identifiers for the outline
C dataset 'CO' to suppress all but the major global land masses.
C In honor of Cicely Ridley, the British Isles are included.
C
C Cull the segment if there's no ocean on either side of it ...
C
      IF (IDLS.NE.  2.AND.IDRS.NE.  2) NPTS=0
C
C or if it's not an edge of any of the desired areas.
C
      IF (IDLS.NE.  1.AND.IDRS.NE.  1.AND.
     +    IDLS.NE.  3.AND.IDRS.NE.  3.AND.
     +    IDLS.NE. 11.AND.IDRS.NE. 11.AND.
     +    IDLS.NE. 79.AND.IDRS.NE. 79.AND.
     +    IDLS.NE. 99.AND.IDRS.NE. 99.AND.
     +    IDLS.NE.104.AND.IDRS.NE.104.AND.
     +    IDLS.NE.107.AND.IDRS.NE.107.AND.
     +    IDLS.NE.163.AND.IDRS.NE.163     ) NPTS=0
C
C Done.
C
      RETURN
C
      END

C NCLFORTSTART

      subroutine writematrixi(fname,nrow,ncol,x,fmtx,title,titsp,iopt)
      implicit      none

C NCL procedure: writematrixi(fname, x, fmtx, title, titsp, iopt)

      character*(*) title, fname, fmtx
      integer       ncol,nrow,iopt,titsp
      integer       x(ncol,nrow)

C NCLEND

      integer       nr, nc
      character*96  newfmt, titfmt
      character*2   titspc

      if (titsp.gt.0) then
          write(titspc,"(i2)") titsp
          titfmt = "(" // titspc // "x, a)"
      else
          titfmt = "(x, a)"
      end if

      if (fname.ne."*") then
c write to a file
          open  (31,file=fname,form="formatted")
          if (.not.(title.eq." ")) then
              write (31,titfmt) title
          end if

          newfmt = "(" // fmtx // ")"

          if (iopt.eq.0) then
              newfmt = "(" // fmtx // ")"
              do nr=1,nrow
                 write (31,newfmt) (x(nc,nr),nc=1,ncol)
              end do
          else
              newfmt = "(i5," // "1X," // fmtx // ")"
              do nr=1,nrow
                 write (31,newfmt) nr-1, (x(nc,nr),nc=1,ncol)
              end do
          end if
          close (31)
      else
c write to standard out
          if (.not.(title.eq." ")) then
              write (*,titfmt) title
          end if

          print *, " "
          if (iopt.eq.0) then
              newfmt = "(" // fmtx // ")"
              do nr=1,nrow
                 write (*,newfmt) (x(nc,nr),nc=1,ncol)
              end do
          else
              newfmt = "(i5," // "1X," // fmtx // ")"
              do nr=1,nrow
                 write (*,newfmt) nr-1, (x(nc,nr),nc=1,ncol)
              end do
          end if
          print *," "
          call flush(6)
      end if

      return
      end

C NCLFORTSTART

      subroutine writematrixf(fname,nrow,ncol,x,fmtx,title,titsp,iopt)
      implicit      none

C NCL procedure: writematrixf(fname, x, fmtx, title, titsp, iopt)

      character*(*) title, fname, fmtx

      integer titsp
      character*2 titspc

      integer       ncol,nrow,iopt
      real          x(ncol,nrow)

C NCLEND

      integer       nr, nc
      character*96  newfmt, titfmt

      if (titsp.gt.0) then
          write(titspc,"(i2)") titsp
          titfmt = "(" // titspc // "x, a)" 
      else
          titfmt = "(x, a)" 
      end if

      if (fname.ne."*") then 
c write to a file
          open  (31,file=fname,form="formatted")
          if (.not.(title.eq." ")) then
              write (31,titfmt) title
          end if

          newfmt = "(" // fmtx // ")" 

          if (iopt.eq.0) then
              newfmt = "(" // fmtx // ")" 
              do nr=1,nrow
                 write (31,newfmt) (x(nc,nr),nc=1,ncol)
              end do
          else
              newfmt = "(i5," // "1X," // fmtx // ")" 
              do nr=1,nrow
                 write (31,newfmt) nr-1, (x(nc,nr),nc=1,ncol)
              end do
          end if
          close (31) 
      else
c write to standard out
          if (.not.(title.eq." ")) then
              write (*,titfmt) title
          end if
          
          print *, " "
          if (iopt.eq.0) then
              newfmt = "(" // fmtx // ")" 
              do nr=1,nrow
                 write (*,newfmt) (x(nc,nr),nc=1,ncol)
              end do
          else
              newfmt = "(i5," // "1X," // fmtx // ")" 
              do nr=1,nrow
                 write (*,newfmt) nr-1, (x(nc,nr),nc=1,ncol)
              end do
          end if
          print *," "
          call flush(6)
      end if

      return
      end



C NCLFORTSTART

      subroutine writematrixd(fname,nrow,ncol,x,fmtx,title,titsp,iopt)
      implicit      none

C NCL procedure: writematrixd(fname, x, fmtx, title, titsp, iopt)

      character*(*) title, fname, fmtx
      character*2   titspc
      integer       ncol,nrow,iopt,titsp
      double precision       x(ncol,nrow)

C NCLEND
      integer       nr, nc
      character*96  newfmt, titfmt

      if (titsp.gt.0) then
          write(titspc,"(i2)") titsp
          titfmt = "(" // titspc // "x, a)"
      else
          titfmt = "(x, a)"
      end if

      if (fname.ne."*") then

c write to a file
          open  (31,file=fname,form="formatted")
          if (.not.(title.eq." ")) then
              write (31,titfmt) title
          end if

          newfmt = "(" // fmtx // ")"

          if (iopt.eq.0) then
              newfmt = "(" // fmtx // ")"
              do nr=1,nrow
                 write (31,newfmt) (x(nc,nr),nc=1,ncol)
              end do
          else
              newfmt = "(i5," // "1X," // fmtx // ")"
              do nr=1,nrow
                 write (31,newfmt) nr-1, (x(nc,nr),nc=1,ncol)
              end do
          end if
          close (31)
      else
c write to standard out
          if (.not.(title.eq." ")) then
              write (*,titfmt) title
          end if

          print *, " "
          if (iopt.eq.0) then
              newfmt = "(" // fmtx // ")"
              do nr=1,nrow
                 write (*,newfmt) (x(nc,nr),nc=1,ncol)
              end do
          else
              newfmt = "(i5," // "1X," // fmtx // ")"
              do nr=1,nrow
                 write (*,newfmt) nr-1, (x(nc,nr),nc=1,ncol)
              end do
          end if
          print *," "
          call flush(6)
      end if

      return
      end

C NCLFORTSTART
      subroutine writematrixb(fname,nrow,ncol,x,fmtx,title,titsp,iopt)
      implicit      none

C NCL procedure: writematrixb(fname, x, fmtx, title, titsp, iopt)

      character*(*) title, fname, fmtx
      integer       ncol,nrow,iopt,titsp
      integer*1     x(ncol,nrow)

C NCLEND
c ------------------------------------------------------
c NOTE: integer*1  is non-standard fortran
c       The f77 standard does not support byte or short
c       However, these are common extensions and are supported
c       by g77.
c ------------------------------------------------------

      integer       nr, nc
      character*96  newfmt, titfmt
      character*2   titspc

      if (titsp.gt.0) then
          write(titspc,"(i2)") titsp
          titfmt = "(" // titspc // "x, a)"
      else
          titfmt = "(x, a)"
      end if

      if (fname.ne."*") then
c write to a file
          open  (31,file=fname,form="formatted")
          if (.not.(title.eq." ")) then
              write (31,titfmt) title
          end if

          newfmt = "(" // fmtx // ")"

          if (iopt.eq.0) then
              newfmt = "(" // fmtx // ")"
              do nr=1,nrow
                 write (31,newfmt) (x(nc,nr),nc=1,ncol)
              end do
          else
              newfmt = "(i5," // "1X," // fmtx // ")"
              do nr=1,nrow
                 write (31,newfmt) nr-1, (x(nc,nr),nc=1,ncol)
              end do
          end if
          close (31)
      else
c write to standard out
          if (.not.(title.eq." ")) then
              write (*,titfmt) title
          end if

          print *, " "
          if (iopt.eq.0) then
              newfmt = "(" // fmtx // ")"
              do nr=1,nrow
                 write (*,newfmt) (x(nc,nr),nc=1,ncol)
              end do
          else
              newfmt = "(i5," // "1X," // fmtx // ")"
              do nr=1,nrow
                 write (*,newfmt) nr-1, (x(nc,nr),nc=1,ncol)
              end do
          end if
          print *," "
          call flush(6)
      end if

      return
      end

C NCLFORTSTART

      subroutine writematrixs(fname,nrow,ncol,x,fmtx,title,titsp,iopt)
      implicit      none

C NCL procedure: writematrixi(fname, x, fmtx, title, titsp, iopt)

      character*(*) title, fname, fmtx
      integer       ncol,nrow,iopt,titsp
      integer*2     x(ncol,nrow)

C NCLEND
c ------------------------------------------------------
c NOTE: integer*2  is non-standard fortran
c       The f77 standard does not support byte or short
c       However, these are common extensions and are supported
c       by g77.
c ------------------------------------------------------

      integer       nr, nc
      character*96  newfmt, titfmt
      character*2   titspc

      if (titsp.gt.0) then
          write(titspc,"(i2)") titsp
          titfmt = "(" // titspc // "x, a)"
      else
          titfmt = "(x, a)"
      end if

      if (fname.ne."*") then
c write to a file
          open  (31,file=fname,form="formatted")
          if (.not.(title.eq." ")) then
              write (31,titfmt) title
          end if

          newfmt = "(" // fmtx // ")"

          if (iopt.eq.0) then
              newfmt = "(" // fmtx // ")"
              do nr=1,nrow
                 write (31,newfmt) (x(nc,nr),nc=1,ncol)
              end do
          else
              newfmt = "(i5," // "1X," // fmtx // ")"
              do nr=1,nrow
                 write (31,newfmt) nr-1, (x(nc,nr),nc=1,ncol)
              end do
          end if
          close (31)
      else
c write to standard out
          if (.not.(title.eq." ")) then
              write (*,titfmt) title
          end if

          print *, " "
          if (iopt.eq.0) then
              newfmt = "(" // fmtx // ")"
              do nr=1,nrow
                 write (*,newfmt) (x(nc,nr),nc=1,ncol)
              end do
          else
              newfmt = "(i5," // "1X," // fmtx // ")"
              do nr=1,nrow
                 write (*,newfmt) nr-1, (x(nc,nr),nc=1,ncol)
              end do
          end if
          print *," "
          call flush(6)
      end if

      return
      end

C NCLFORTSTART
      SUBROUTINE write_intermediate_wps(OUTPUT_NAME,FIELDIN,UNITSIN,
     +  DESCIN,HDATEIN,DATA_SOURCE,XLVL,IPROJ,START_LOCATION,STARTLAT,
     +  STARTLON,DELTALAT,DELTALON,XLONC,TRUELAT1,TRUELAT2, NLATS,DX,DY,
     +  NX,NY,IS_WIND_EARTH_REL,IFV,XFCST,EARTH_RADIUS,SLAB)

      character*(*) OUTPUT_NAME
      character*(*) FIELDIN,UNITSIN,DESCIN,HDATEIN
      character*(*) DATA_SOURCE,START_LOCATION
      integer IPROJ
      integer NX
      integer NY
      real DELTALAT
      real DELTALON
      real DX
      real DY
      real NLATS
      real STARTLAT
      real STARTLON
      real TRUELAT1
      real TRUELAT2
      real XLONC
      real XLVL
      logical IS_WIND_EARTH_REL
      integer IFV
      real XFCST
      real EARTH_RADIUS 
      real SLAB(NX,NY)

C NCLEND


C Declarations INTERNAL

      character(len=9)  FIELD
      character(len=25) UNITS
      character(len=46) DESC
      character(len=24) HDATE
      character(len=32) MAP_SOURCE 
      character(len=8)  STARTLOC
      character(len=80) OUT_FILE 
      
      integer IUNIT 
      integer OUNIT 
      integer ierr
      logical exists


CCC Made these part of calling routine
CCC      IFV=5
CCC      XFCST=0.0
CCC      EARTH_RADIUS = 6367470. * .001
      IUNIT = 10
      OUNIT = 11

      FIELD      = FIELDIN
      UNITS      = UNITSIN
      DESC       = DESCIN
      HDATE      = HDATEIN
      MAP_SOURCE = DATA_SOURCE
      STARTLOC   = START_LOCATION


C Create the WPS IM file name and test it it is already in use
      OUT_FILE = TRIM(OUTPUT_NAME)//":"//HDATE(1:13)

      inquire(file=OUT_FILE, exist=exists)
      if (exists) then
        open(OUNIT, file=OUT_FILE, status="old", 
     +       position="append", action="write", form='unformatted', 
     +       convert='big_endian')
      else
        open(OUNIT, file=OUT_FILE, status="new", action="write", 
     +       form='unformatted', convert='big_endian')
      end if


C WRITE WPS IM identifier - we always use the newer versions so this is always 5
      write (OUNIT, IOSTAT=IERR) IFV


C WRITE the second record, common to all projections:
      write (OUNIT) HDATE, XFCST, MAP_SOURCE, FIELD, UNITS, DESC, XLVL, 
     +       NX, NY, IPROJ


C WRITE the third record, which depends on the projection:
      if (IPROJ == 0) then            
C This is the Cylindrical Equidistant (lat/lon) projection:
        WRITE (OUNIT) STARTLOC, STARTLAT, STARTLON, DELTALAT, DELTALON, 
     +       EARTH_RADIUS

      elseif (IPROJ == 1) then        
C This is the Mercator projection:
        WRITE (OUNIT) STARTLOC, STARTLAT, STARTLON, DX, DY, TRUELAT1, 
     +       EARTH_RADIUS

      elseif (IPROJ == 3) then        
C This is the Lambert Conformal projection:
         WRITE (OUNIT) STARTLOC, STARTLAT, STARTLON, DX, DY, XLONC, 
     +       TRUELAT1, TRUELAT2, EARTH_RADIUS

      elseif (IPROJ == 4) then        
C Gaussian projection                         
        WRITE (OUNIT) STARTLOC, STARTLAT, STARTLON, NLATS, DELTALON, 
     +       EARTH_RADIUS
        
      elseif (IPROJ == 5) then        
C This is the Polar Stereographic projection:
        WRITE (OUNIT) STARTLOC, STARTLAT, STARTLON, DX, DY, XLONC, 
     +       TRUELAT1, EARTH_RADIUS

      endif
     
      WRITE (OUNIT) IS_WIND_EARTH_REL

      WRITE (OUNIT) slab
      WRITE(*, '("DONE WRITING ", A, " (level=", f7.0, ") for time ", 
     +       A, " to IM Format")' ) 
     +      TRIM(FIELD), XLVL, TRIM(HDATE)

      close(ounit)

      RETURN
      END

C
C $Id: agnumb.f,v 1.7 2008-07-27 00:14:35 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE AGNUMB (NBTP,SBSE,EXMU , NLTP,NLEX,NLFL ,
     +                             BFRM,MCIM,NCIM,IPXM , BFRE,MCIE,NCIE)
C
      CHARACTER*(*) BFRM,BFRE
C
C The routine AGNUMB converts the number specified by the arguments
C NBTP, SBSE, and EXMU to the label format specified by the arguments
C NLTP, NLEX, and NLFL, returning the characters of the mantissa in the
C buffer BFRM and the characters of the exponent in the buffer BFRE,
C ready for plotting.  The arguments of AGNUMB are as follows:
C
C -- NBTP is an integer specifying the type of number to be converted.
C    There are three possibilities:
C
C        NBTP = 1 - number of the form SBSE * EXMU.
C
C        NBTP = 2 - number of the form SBSE * 10**EXMU.
C
C        NBTP = 3 - number of the form SIGN(SBSE) * ABSV(SBSE)**EXMU.
C
C -- SBSE is a base value for a set of labels.  See NBTP description.
C
C -- EXMU is an exponent or a multiplier for a given label.  Although it
C    is a floating-point number, its value should be integral, unless
C    NBTP equals 1 and/or NLTP equals 1.  Using a non-integral EXMU in
C    other cases will have undesirable effects.  See NBTP description.
C
C -- NLTP is an integer specifying the type of label to be generated.
C    There are three possibilities:
C
C      -- NLTP = 1 - label is to have an exponent portion and is to be
C         expressed in scientific notation.
C
C      -- NLTP = 2 - label is to have an exponent portion and is to be
C         expressed in a form determined by the number type NBTP.
C
C      -- NLTP = 3 - label is to have no exponent portion and is to be
C         expressed in a form determined by the number type NBTP.
C
C    The possible label types will be described in greater detail below.
C
C -- NLEX (when used) is an integer specifying (in a manner depending on
C    the values of other parameters) the value of the exponent portion
C    of the label.  See the detailed discussion of label types, below.
C
C -- NLFL (when used) is an integer specifying (in a manner depending on
C    the values of other parameters) the length of the fractional por-
C    tion of the mantissa of the label.  See the detailed discussion of
C    label types, below.
C
C -- BFRM is a character variable in which the mantissa portion of the
C    label is to be returned.
C
C -- MCIM specifies the maximum number of characters BFRM can hold.
C
C -- NCIM is the number of characters returned in BFRM by AGNUMB.
C
C -- IPXM is the position of the character X in the mantissa.  If IPXM
C    is zero, the character X does not occur in the mantissa.
C
C -- BFRE, MCIE, and NCIE are analogous to BFRM, MCIM, and NCIM, but
C    pertain to the exponent portion of the label.
C
C Label types:  AGNUMB will produce many different types of labels, as
C directed by the various input parameters.  Each of these is described
C below.  The general form of a label is
C
C    (-) (1/) (I) (.) (F) (X 10) (E)
C
C where the parentheses are used to mark portions which may either be
C present or absent.  The minus sign is included only if the label value
C is negative.  I is the integer portion of the mantissa, included only
C if its value is non-zero.  The decimal point is included if the input
C parameter NLFL does not specifically direct that it should be omitted
C or if the fractional portion of the mantissa (F) is present.  F is the
C fractional portion of the mantissa.  The "X 10" is included if it is
C appropriate, and is considered to be a part of the mantissa; if it is
C included, a blank is actually returned for the character X, so the
C routine which plots the label should construct this character by
C drawing two short lines.  E is the exponent, returned in a separate
C buffer so that it may be plotted in a superscript form.  The possible
C label types are, then, as follows:
C
C -- Scientific notation - if the label type NLTP equals 1, the form
C
C        (-) (I) (.) (F) X 10 (E)
C
C    is used.  NLEX specifies the length of I (thus also specifying the
C    value of the exponent E).  If NLEX is .LE. 0, I is omitted.  If
C    NLEX is .LT. 0 and has the absolute value N, the fraction F is
C    forced to have N leading zeroes.  NLFL specifies the length of F.
C    If NLFL is .LE. 0, F is omitted.  If NLFL is .LT. 0, the decimal
C    point is omitted.  If (I.F) has the value 1, (I.F X) is omitted.
C    If the entire label has zero value, the character 0 is used.
C
C -- Exponential, but non-scientific notation - if the label type NLTP
C    equals 2, the form used depends on the argument NBTP, as follows:
C
C     -- If NBTP equals 1 (number of the form SBSE * EXMU), the form
C
C            (-) (I) (.) (F) X 10 (E)
C
C        is used.  NLEX specifies the value of the exponent E.  The
C        length of F is specified by NLFL.  If NLFL is .LE. 0, F is
C        omitted.  If NLFL is .LT. 0, the decimal point is omitted.  If
C        the label value is exactly 0, the character 0 is used.
C
C     -- If NBTP equals 2 (number of the form SBSE*10**EXMU), the form
C
C            (-) (I) (.) (F) X 10 (E)
C
C        is used.  The exponent E has the value NLEX+EXMU.  The length
C        of F is specified by NLFL.  If NLFL is .LE. 0, F is omitted.
C        If NLFL is .LT. 0, the decimal point is omitted.  If the label
C        value is exactly 0, the character 0 is used.  If (I.F) has the
C        value 1., then (I.F X) is omitted.
C
C     -- If NBTP equals 3, specifying that the number is of the form
C        SIGN(SBSE) * ABSV(SBSE)**EXMU, the form
C
C            (-) (I) (.) (F) (E)
C
C        is used.  The exponent E has the value EXMU.  The length of F
C        is specified by NLFL.  If NLFL is .LE. 0, F is omitted.  If
C        NLFL is .LT. 0, the decimal point is omitted.
C
C -- No-exponent notation - if the label type NLTP equals 3, the form
C    used depends on the argument NBTP, as follows:
C
C     -- If NBTP equals 1 (number of the form SBSE * EXMU), the form
C
C            (-) (I) (.) (F)
C
C        is used.  NLFL specifies the length of F.  If NLFL is .LE. 0,
C        F is omitted.  If NLFL is .LT. 0, the decimal point is omitted.
C        If the entire label has zero value, the character 0 is used.
C
C     -- If NBTP equals 2 (number of the form SBSE*10**EXMU), the form
C
C            (-) (I) (.) (F)
C
C        is used.  The length of F is specified by the function
C
C            MAX(NLFL,0)-EXMU  (if EXMU is .LT. MAX(NLFL,0))
C            MIN(NLFL,0)       (if EXMU is .GE. MAX(NLFL,0))
C
C        which may appear somewhat formidable, but produces a simple,
C        desirable result.  Suppose, for example, that SBSE = 3.6,
C        NLFL = 1, and EXMU ranges from -3 to +3 - the labels produced
C        are as follows:
C
C            .0036   .036   .36   3.6   36.   360.   3600.
C
C        NLFL may be viewed as specifying the length of F if EXMU is 0.
C        If the value of the function is .LE. 0, F is omitted - if its
C        value is .LT. 0, the decimal point is omitted.
C
C     -- If NBTP equals 3, specifying that the number is of the form
C        SIGN(SBSE) * ABSV(SBSE)**EXMU, the form
C
C            (-) (I) (.) (F)
C
C        is used if EXMU is positive (or zero), and the form
C
C            (-) 1 / (I) (.) (F)
C
C        is used if EXMU is negative.  The length of F is specified by
C        the function
C
C            NLFL * ABSV(EXMU)  (if EXMU is .NE. 0)
C            MIN(NLFL,0)        (if EXMU is .EQ. 0)
C
C        Again, this function produces a simple result.  Suppose that
C        SBSE = 1.1, NLFL = 1, and EXMU ranges from -3 to +3 - the
C        labels produced are as follows:
C
C            1/1.331   1/1.21   1/1.1   1.   1.1   1.21   1.331
C
C        NLFL may be viewed as specifying the length of F if EXMU is 1.
C        If the value of the function is .LE. 0, F is omitted - if its
C        value is .LT. 0, the decimal point is omitted.  As another
C        example, suppose that SBSE = 2., NLFL = -1, and EXMU ranges
C        from -4 to +4.  The labels produced are as follows:
C
C            1/16   1/8   1/4   1/2   1   2   4   8   16
C
C The following common block contains AUTOGRAPH variables which are
C not control parameters.  The only one used here is SMRL, which is a
C (machine-dependent) small real which, when added to a number in the
C range (1,10), will round it upward without seriously affecting the
C leading significant digits.  The object of this is to get rid of
C strings of nines.
C
      COMMON /AGORIP/ SMRL , ISLD , MWCL,MWCM,MWCE,MDLA,MWCD,MWDQ ,
     +                INIF
      SAVE /AGORIP/
C
C KHAR holds single characters to be stored away in BFRM or BFRE.
C
      CHARACTER*1 KHAR
C
C Zero character counters and pointers.
C
      NCIM=0
      NCIE=0
      IPXM=0
C
C Compute a jump parameter to allow a quick sorting-out of the possible
C number-type/label-type combinations below.
C
      NTLT=NBTP+3*(NLTP-1)
C
C Compute the value (XMAN) from which the characters of the mantissa
C will be generated.
C
      GO TO (101,102,103,101,102,104,101,102,105) , NTLT
C
  101 XMAN=SBSE*EXMU
      GO TO 106
C
  102 XMAN=SBSE*REAL(10.D0**DBLE(EXMU))
      GO TO 106
C
  103 XMAN=SIGN(1.,SBSE)*REAL(DBLE(ABS(SBSE))**DBLE(EXMU))
      GO TO 106
C
  104 XMAN=SBSE
      GO TO 106
C
  105 XMAN=SIGN(1.,SBSE)*REAL(DBLE(ABS(SBSE))**DBLE(ABS(EXMU)))
C
C If the mantissa-generator is negative, make it positive and put a
C minus sign in the mantissa buffer.
C
  106 IF (XMAN.LT.0.) THEN
        NCIM=NCIM+1
        IF (NCIM.GT.MCIM) GO TO 901
        BFRM(NCIM:NCIM)='-'
        XMAN=-XMAN
      END IF
C
C If the number is zero, put a zero in the mantissa buffer and quit.
C
      IF (XMAN.EQ.0.) THEN
        NCIM=NCIM+1
        IF (NCIM.GT.MCIM) GO TO 901
        BFRM(NCIM:NCIM)='0'
        RETURN
      END IF
C
C Reduce the mantissa-generator to the range (1.,10.), keeping track of
C the power of 10 required to do it.  Round the result, keeping in mind
C that the rounding may kick the value past 10. .
C
      IMAN=INT(ALOG10(XMAN))
      IF (XMAN.LT.1.) IMAN=IMAN-1
      XMAN=REAL(DBLE(XMAN)*10.D0**(-IMAN))+SMRL
      IF (XMAN.GE.10.) THEN
        XMAN=XMAN/10.
        IMAN=IMAN+1
      END IF
C
C Jump (depending on the number-type/label-type combination) to set up
C the label-generation control parameters, as follows:
C
C    NDPD - number of digits to precede decimal point - if NDPD .LT. 0,
C           ABS(NDPD) leading zeroes follow the decimal point, preceding
C           the first digit generated from XMAN.
C    NDFD - number of digits to follow decimal point - if NDFD .LT. 0,
C           the decimal point is suppressed.
C    IF10 - flag, set non-zero to force generation of the (X 10) portion
C           of the label.
C    IFEX - flag, set non-zero to force generation of an exponent.
C    IVEX - value of exponent (if any) - always equals (IMAN+1) - NDPD.
C
      GO TO (107,107,107,108,109,110,111,112,113) , NTLT
C
C Scientific notation.
C
  107 NDPD=NLEX
      NDFD=NLFL
      IF10=1
      IFEX=1
      GO TO 114
C
C Non-scientific exponential notation for SBSE * EXMU.
C
  108 NDPD=IMAN+1-NLEX
      NDFD=NLFL
      IF10=1
      IFEX=1
      GO TO 114
C
C Non-scientific exponential notation for SBSE * 10**EXMU.
C
  109 NDPD=IMAN+1-(NLEX+INT(EXMU+SMRL*EXMU))
      NDFD=NLFL
      IF10=1
      IFEX=1
      GO TO 114
C
C Non-scientific exponential notation for SIGN(SBSE) * ABSV(SBSE)**EXMU.
C
  110 NDPD=IMAN+1
      IMAN=IMAN+INT(EXMU+SMRL*EXMU)
      NDFD=NLFL
      IF10=0
      IFEX=1
      GO TO 115
C
C No-exponent notation for SBSE * EXMU.
C
  111 NDPD=IMAN+1
      NDFD=NLFL
      IF10=0
      IFEX=0
      GO TO 115
C
C No-exponent notation for SBSE * 10**EXMU.
C
  112 NDPD=IMAN+1
      NDFD=MAX(NLFL,0)-INT(EXMU+SMRL*EXMU)
      IF (NDFD.LE.0) NDFD=MIN(NLFL,0)
      IF10=0
      IFEX=0
      GO TO 115
C
C No-exponent notation for SIGN(SBSE) * ABSV(SBSE)**EXMU
C
  113 IF (EXMU.LT.0.) THEN
        NCIM=NCIM+1
        IF (NCIM.GT.MCIM) GO TO 901
        BFRM(NCIM:NCIM)='1'
        NCIM=NCIM+1
        IF (NCIM.GT.MCIM) GO TO 901
        BFRM(NCIM:NCIM)='/'
      END IF
C
      NDPD=IMAN+1
      NDFD=NLFL*INT(ABS(EXMU+SMRL*EXMU))
      IF (NDFD.EQ.0) NDFD=MIN(NLFL,0)
      IF10=0
      IFEX=0
      GO TO 115
C
C If there is an exponent of 10 and the mantissa is precisely 1, omit
C the (I.F X) portion of the mantissa.
C
  114 IF (NDPD.NE.1) GO TO 115
      IF (INT(XMAN).NE.1) GO TO 115
      IF (((XMAN-1.)*10.**MAX(0,NDFD)).GE.1.) GO TO 115
      IVEX=IMAN+1-NDPD
      GO TO 123
C
C Generate the characters of the mantissa (I.F).  Check first for zero-
C or-negative-length error.
C
  115 LMAN=MAX(NDPD,0)+1+MAX(NDFD,-1)
      IF (LMAN.LE.0) GO TO 903
C
C Make sure the mantissa buffer is big enough to hold (I.F).
C
      IF (NCIM+LMAN.GT.MCIM) GO TO 901
C
C Compute the value of the parameter IVEX before changing NDPD.
C
      IVEX=IMAN+1-NDPD
C
C Generate the digits preceding the decimal point, if any.
C
      IF (NDPD.LE.0) GO TO 117
C
      JUMP=1
      GO TO 121
C
  116 NDPD=NDPD-1
      IF (NDPD.NE.0) GO TO 121
C
C Generate the decimal point.
C
  117 KHAR='.'
      JUMP=2
      GO TO 122
C
C Generate leading zeroes, if any, after the decimal point.
C
  118 IF (NDPD.EQ.0) GO TO 120
      KHAR='0'
      JUMP=3
      GO TO 122
C
  119 NDPD=NDPD+1
      IF (NDPD.NE.0) GO TO 122
C
C Generate remaining fractional digits.
C
  120 JUMP=4
C
C Generate a digit from the mantissa-generator.  It is assumed that, for
C n between 1 and 9, ICHAR('n') = ICHAR('n-1') + 1 .
C
  121 IDGT=INT(XMAN)
      KHAR=CHAR(ICHAR('0')+IDGT)
      XMAN=XMAN-REAL(IDGT)
      XMAN=XMAN*10.
C
C Store a digit from KHAR into the mantissa buffer.
C
  122 NCIM=NCIM+1
      BFRM(NCIM:NCIM)=KHAR
C
C Check whether (I.F) is complete.
C
      LMAN=LMAN-1
      IF (LMAN.NE.0) GO TO (116,118,119,121) , JUMP
C
C If appropriate, leave space in the mantissa buffer for the "X" .
C
      IF (IF10.EQ.0) GO TO 124
      NCIM=NCIM+1
      IF (NCIM.GT.MCIM) GO TO 901
      IPXM=NCIM
      BFRM(IPXM:IPXM)=' '
C
C If appropriate, put a "10" in the mantissa buffer.
C
  123 NCIM=NCIM+1
      IF (NCIM.GT.MCIM) GO TO 901
      BFRM(NCIM:NCIM)='1'
      NCIM=NCIM+1
      IF (NCIM.GT.MCIM) GO TO 901
      BFRM(NCIM:NCIM)='0'
C
C If appropriate, generate an exponent in the exponent buffer.
C
  124 IF (IFEX.EQ.0) RETURN
C
      IF (IVEX) 126,125,127
C
  125 NCIE=NCIE+1
      IF (NCIE.GT.MCIE) GO TO 902
      BFRE(NCIE:NCIE)='0'
      RETURN
C
  126 NCIE=NCIE+1
      IF (NCIE.GT.MCIE) GO TO 902
      BFRE(NCIE:NCIE)='-'
      IVEX=-IVEX
C
  127 NCIE=NCIE+1
      IF (IVEX.GE.10) NCIE=NCIE+1
      IF (IVEX.GE.100) NCIE=NCIE+1
      IF (IVEX.GE.1000) NCIE=NCIE+1
      IF (NCIE.GT.MCIE) GO TO 902
C
      DO 128 I=1,4
        J=NCIE+1-I
        BFRE(J:J)=CHAR(ICHAR('0')+MOD(IVEX,10))
        IVEX=IVEX/10
        IF (IVEX.EQ.0) RETURN
  128 CONTINUE
C
      IF (IVEX.NE.0) GO TO 902
C
C Done.
C
      RETURN
C
C Error exits.
C
  901 CALL SETER ('AGNUMB - MANTISSA TOO LONG',4,2)
C
  902 CALL SETER ('AGNUMB - EXPONENT TOO LARGE',5,2)
C
  903 CALL SETER ('AGNUMB - ZERO-LENGTH MANTISSA',6,2)
C
      END

C NCLFORTSTART
      subroutine deof11( d, nx, nt, nmodes, icovcor, dmsg,
     &		         eigenvalues, eigenvectors, variance,
     &                   princomp)
c minimal argument list
        implicit none

	integer	nx, nt, nmodes, icovcor
	double precision d(nx,nt), eigenvalues(nmodes), 
     &		eigenvectors(nx,nmodes), variance(nmodes)
        double precision princomp(nt,nmodes), dmsg
C NCLEND
        integer iminnxnt, imaxnxnt
        integer n

c need  iminnxnt and imaxnxnt for automatic allocation

        iminnxnt = min(nx,nt)
        imaxnxnt = max(nx,nt)
        
	call deof22(d, nx, nt, nmodes, icovcor, dmsg,
     &		    eigenvalues, eigenvectors, variance,
     &		    iminnxnt, imaxnxnt, princomp )

        return
        end
c ----------------------------------------------------------------
      subroutine deof22(d, nx, nt, nmodes, icovcor, dmsg,
     &		         eigenvalues, eigenvectors, variance,
     &		         iminnxnt, imaxnxnt, princomp)
        implicit none

        integer nx, nt, nmodes, icovcor, iminnxnt, imaxnxnt
        double precision d(nx,nt), eigenvalues(nmodes),                                          
     &          eigenvectors(nx,nmodes), variance(nmodes)
        double precision princomp(nt,nmodes), dmsg

c local and  automatic arrays
        double precision cumvariance(nmodes),
     &          spacked(iminnxnt*(iminnxnt+1)/2), evals(iminnxnt),                                  
     &          evecs(iminnxnt,nmodes), rlawork(8*iminnxnt),                                        
     &          tentpcs(imaxnxnt,nmodes)
        double precision  sqrootweights(nx)                                         
        integer ilawork(5*iminnxnt), ifail(iminnxnt)    
        integer n

c NCL expects the user will do weighting externally

        do n=1,nx
           sqrootweights(n) = 1.d0
        end do

        call deof( d, nx, nt, nmodes, icovcor, dmsg,
     &		eigenvalues, eigenvectors, princomp, variance, cumvariance,
     &		iminnxnt, imaxnxnt, spacked, evals, evecs, rlawork, 
     &		ilawork, ifail, tentpcs, sqrootweights )
        return
        end
c ----------------------------------------------------------------
c --- Original Scripps Code: modified for missing values [dmsg]
c ---                        Dennis Shea [Aug 2005]
c ----------------------------------------------------------------
      subroutine deof( data, nx, nt, nmodes, icovcor, dmsg,
     &		eigenvalues, eigenvectors, princomp, variance, cumvariance,
     &		iminnxnt, imaxnxnt, spacked, evals, evecs, rlawork, 
     &		ilawork, ifail, tentpcs, sqrootweights )

c	------------------------------------------------------------------
c	This routine generates the Empirical Orthogonal Functions (EOFs)
c	for a given time-space data set.  (Note that although the routine
c	is set up as if the data is exactly two dimensional (X,T), that
c	you can compute the EOFs of 3-D (X,Y,T) fields simply by concat-
c	enating the data along the X,Y axes into one big 2-D array and
c	then computing the EOFs of that 2-D array).  The "typical" 
c	normalization is applied, i.e., the magnitude of the eigenvectors
c	is scaled to be equal to 1.
c
c	David W. Pierce
c	dpierce@ucsd.edu
c	Scripps Institution of Oceanography
c	Climate Research Division, 0224
c	Jan 29, 1996	
c	
c	Inputs:
c
c		data(nx,nt): data to compute the EOFs of.  THIS MUST
c			BE ANOMALIES.
c
c		nx, nt: number of space (nx) and time (nt) points in the
c			input data array.
c
c		nmodes: number of modes (EOFs) to compute.
c		
c		icovcor: if =0, then compute using covariance matrix;
c			 if =1, then compute using correlation matrix.
c			See, for example, discussion in Daniel S. Wilks
c			1995, "Statistical Methods in the Atmospheric
c			Sciences", p. 383 for a discussion.
c
c		iminnxnt: the SMALLER of 'nx' and 'nt'.
c
c		imaxnxnt: the LARGER of 'nx' and 'nt'.
c
c		spacked(iminnxnt*(iminnxnt+1)/2): workspace.  This is used to 
c			store the packed covariance or correlation matrix.
c
c		evals(iminnxnt): workspace.  This is used to store the
c			complete series of eigenvalues.  I suppose you
c			could access this if you wanted to, remembering
c			that a) it's more modes than you asked for; b)
c			they are in ASCENDING order rather than descending.
c
c		evecs(iminnxnt,nmodes): workspace.  This is used to store
c			the (possibly switched) eigenvectors, which are
c			in ascending order.
c
c		rlawork(8*iminnxnt): Real LAPACK workspace.
c
c		ilawork(5*iminnxnt): Integer LAPACK workspace.
c
c		ifail(iminnxnt): Integer LAPACK workspace.  This is used
c			to indicate which eigenvectors didn't converge,
c			if that happened.
c
c		tentpcs(imaxnxnt,nmodes): Real workspace.  This is 
c			used to store the 'tentative' principal components.
c
c		sqrootweights(nx) : NOT USED IN NCL IMPLEMENTATION [set to 1.0]
c                       the SQUARE ROOT of the areal weighting to
c			use.  Just set this to all 1.0's if you don't care
c			about areal weighting.  I think you can set places
c			which should be ignored to zero to have them not
c			participate in the calculation, thus implementing a
c			crude form of data masking.
c
c               dmsg    missing code
c
c	Outputs:
c
c		eigenvalues(nmodes): the computed eigenvalues of
c			the data, the largest returned first.
c
c		eigenvectors(nx,nmodes): the computed eigenvectors
c			of the data, the most important returned first.
c
c		princomp(nt,nmodes): the principal components of 
c			the data.
c
c		variance(nmodes): the percent of variance explained
c			by each mode.
c
c		cumvariance(nmodes): the cumulative percent of 
c			variance explained by each mode.  This is
c			a bit redundant -- it's just the sum
c			of "variance".
c			
c	Method:
c
c	EOFs are simply the eigenvectors of the covariance (or correlation)
c	matrix.  So form the proper matrix from the data and pass it to
c	a LAPACK routine which calculates eigenvectors/eigenvalues.  Then
c	calculate the principal components explicitly using the fact that
c	the principal component for mode M at time T is just the projection 
c	of the data at time T onto eigenvector M.  
c
c	There is a slight complication for efficiency's sake.  That is, 
c	we often have nx >> nt, i.e., there are many more spatial than
c	temporal points.  The traditional correlation/covariance matrix
c	is size (nx,nx), which can be huge.  Think, for example, of a 3-D
c	field of size (100,100,120) which has been concatenated into a
c	2-D field of size (10000,120).  The traditional covariance/correlation
c	matrix in this case is size (10000,10000)!  That's way too big to 
c	easily work with.  So, following the discussion in Preisendorfer
c	(1988, "Principal Component Analysis in Meteorology and Oceanography",
c	p. 64) we work, in such cases, in the "dual" of the space.  All
c	that means is that we logically switch X and T; the 
c	covariance/correlation matrix for the example given above is then
c	size (120,120), which is much easier and more efficient to work
c	with.  If you do this kind of switch, the basic idea is that
c	the eigenvectors of the switched matrix are the principal components
c	of the original matrix, and the principal components of the switched
c	matrix are the eigenvectors of the original matrix.  Which is to
c	say, if you switch T and X to begin with, the final result is that
c	the T dependence is in the X part and the X dependence is in the
c	T part.  There is also a normalization which has to be applied--
c	see Preisendorfer for details.
c	------------------------------------------------------------------

	implicit none

	integer	covariance, correlation
	parameter( covariance=0, correlation=1 )  ! possible values of 'icovcor'
	
c	-----------------
c	Passed parameters
c	-----------------
	integer	nx, nt, nmodes, icovcor, iminnxnt, imaxnxnt
        integer ifail(iminnxnt)
	double precision data(nx,nt), eigenvalues(nmodes), 
     &		eigenvectors(nx,nmodes), princomp(nt,nmodes), 
     &		variance(nmodes), cumvariance(nmodes),
     &		spacked(iminnxnt*(iminnxnt+1)/2), evals(iminnxnt), 
     &		evecs(iminnxnt,nmodes), rlawork(8*iminnxnt), 
     &		tentpcs(imaxnxnt,nmodes), sqrootweights(nx)
	double precision dmsg, deps
	integer ilawork(5*iminnxnt)

c	---------------
c	Local variables
c	---------------
	logical		doswitched
	integer		orderofs, i, j, jascending, jdescending
	double precision sum, fact, totvar
	character*1	jobz, range, uplo	! for LAPACK routine
	integer		m, n, il, iu, ldz, info	! for LAPACK routine
	double precision vl, vu, abstol		! for LAPACK routine
	integer 	lwork, mode

        logical DEBUG
        DEBUG = .false.

        if (DEBUG) then
            print *, 'entering deof with nx, nt, nmodes=',nx,nt,nmodes
c c c       print *, 'sqrootweights:',sqrootweights(1:10)
        end if

c	----------------------------------------------
c	Weight the data by the square root of the area
c	----------------------------------------------
        do j=1, nt
          do i=1, nx
             if (data(i,j).ne.dmsg) then
                 data(i,j) = data(i,j) * sqrootweights(i)
             end if
          end do
        end do
	
c	---------------------------------------------------------
c	Figure out whether we should do the 'regular' EOF or the
c	one with switched X and T axes.  The correlation matrix
c	for the regular method is size (nx,nx) and for the 
c	switched method it is size (nt,nt); choose based on which
c	of these is smaller.
c	---------------------------------------------------------
        if (DEBUG) then
            print *, 'figuring switched or not'
        end if

	doswitched = (nx .gt. nt)
	if( doswitched ) then
		orderofs = nt
		if (DEBUG) print *, 'deof: Working in switched mode'
	else
		orderofs = nx
		if (DEBUG) print *, 'deof: Working in unswitched mode'
	endif
	if( orderofs .gt. iminnxnt ) then
		print * , 'Error!  EOF routine must be supplied '
		print * , 'with enough workspace; passed parameter'
		print * , 'iminnxnt must be at least ', orderofs
		print * , 'Passed value was iminnxnt=',iminnxnt
		stop 'eof '
	endif
	if( nmodes .gt. orderofs ) then
		print * , 'Error! EOF routine called requesting more'
		print * , 'modes than exist!  Request=',nmodes,' exist=',
     &		           orderofs
		stop 'eof '
	endif

c	-------------------------------------------------
c	Form the covariance or correlation matrix, put it 
c	into 's'.  Note that 's' is always symmetric --
c	the correlation between X and Y is the same as 
c	between Y and X -- so use packed storage for 's'.
c	The packed storage scheme we use is the same as
c	LAPACK uses so we can pass 's' directly to the
c	solver routine: the matrix is lower triangular,
c	and s(i,j) = spacked(i+(j-1)*(2*n-j)/2).
c	-------------------------------------------------
        call deofcovcor( data, nx, nt, icovcor, covariance,
     &		correlation, spacked, doswitched, iminnxnt, dmsg )
c	------------------------------------------------------
c	Now call the LAPACK solver to get the eigenvalues
c	and eigenvectors.  The eigenvalues express the
c	amount of variance explained by the various modes,
c	so choose to return those 'nmodes' modes which 
c	explain the most variance.
c	Dims of arrays:
c		evals  (n)	  ! The calculated eigenvalues
c		evecs  (n,nmodes) ! The calculated eigenvectors
c		rlawork(8*n)
c		ilawork(5*n)
c		ifail  (n)
c	Remember that the calculated eigenvectors may not be
c	the ones we really want if we are doing switched
c	X and T axes.  However the eigen*values* are the same
c	either way, according to Preisendorfer.
c	*NOTE* that the LAPACK routine returns the eigenvalues
c	(and corresponding eigenvectors) in ASCENDING order,
c	but this routine returns them in DESCENDING order; 
c	this will be switched in the final assembly phase,
c	below.
c	------------------------------------------------------
	jobz  = 'V' 	! Both eigenvalues and eigenvectors
	range = 'I'	! Specify range of eigenvalues to get.
	uplo  = 'L'	! 'spacked' has lower triangular part of s
	n     = orderofs
	il    = n - nmodes + 1	! Smallest eigenvalue to get
	iu    = n		! Largest eigenvalue to get
	abstol= 0.0d0		! See LAPACK documentation
	ldz   = n

	lwork = 8*iminnxnt

	do j=1, nmodes
           evals(j) = 0.0d0
          do i=1, iminnxnt
             evecs(i,j) = 0.0d0
	  end do
	end do

        if (DEBUG) then
c c c       print *,'about to call dspevx, spacked=', spacked(1:10)
c c c       print *,'about to call dspevx, spacked=',(spacked(i),i=1,10)   
            do i=1,10
               print *,"spacked: n=",n,"  ",spacked(i)
            end do
        end if

	call dspevx( jobz, range, uplo, n, spacked,
     &		vl, vu, il, iu, abstol, m, evals, evecs, ldz,
     &		rlawork, ilawork, ifail, info )

c	------------------------------
c	Check for LAPACK routine error
c	------------------------------
	if( info .ne. 0 ) then
		if( info .lt. 0 ) then
			print *, 'LAPACK error: argument ',
     &				-info, ' had illegal value'
			stop 'eof'
		else
			print *, 'LAPACK error: ', info, 
     &				'eigenvectors failed to converge!'
			print *, 'Consult the LAPACK docs!'
			stop 'eof'
		endif
	endif

c	------------------------------------------------
c	Make sure that no eigenvalues <= zero.  Besides
c	being mathematically forbidden, this would cause
c	a divide by zero or negative sqrt error later on.
c
c       In the original code, it would exit if there was
c       an eigenvalue less than 0. For our purposes, however,
c       we'll just set the eigenvalue to 0 and let it continue.
c	------------------------------------------------
        DEPS = 1d-6
	do i=1, nmodes
          if(abs(evals(i)) .le. DEPS ) then
c	    print *, 'Error! LAPACK routine returned'
c	    print *, 'eigenvalue <= 0!! ', i, evals(i)
	    print *, 'Warning! LAPACK routine returned eigenvalue <= 0.'
	    print *, 'Setting it to zero...'
            evals(i) = 0.0d0
c	    do j=1, nmodes
c	      print *, j, evals(j)
c  	    end do
c	    print *, 'Note1: This means you may be asking'
c	    print *, 'for more modes than the data supports.'
c	    print *, 'Try reducing the number of requested'
c	    print *, 'modes.'
c  	    print *, 'Note2: missing values can'
c	    print *, 'result in a covariance matrix that'
c	    print *, 'is not positive definite.'  
c	    stop 'eofunc'
          endif
	end do

c	------------------------------------------------
c	Compute the tentative principal components; they
c	are 'tentative' because they might be the PCs 
c	of the switched data.  Put them into 'tentpcs',
c	which is of size (nt,nmodes) if we are doing
c	regular EOFs and (nx,nmodes) if we are doing 
c	switched EOFs.  These PCs come out in order
c	corresponding to the order of 'evecs', which is
c	in ASCENDING order.
c	------------------------------------------------
	call deofpcs( data, nx, nt, nmodes, iminnxnt, 
     &		imaxnxnt, evecs, doswitched, tentpcs, dmsg )

c	--------------------------------------------------
c	Now we have all the pieces to assemble our final 
c	result.  How we actually assemble them depends on
c	whether we are doing switched or unswitched EOFs
c	(except for the eigenVALUES, which are the same
c	either way).
c	--------------------------------------------------
	if( doswitched ) then 
c		------------------------------------------
c		In this case we must switch the principal
c		components and the eigenvectors, applying
c		the proper normalization. 
c		First get the unswitched eigenvectors, 
c		which are the switched (tentative) principal
c		components divided by the square root of the
c		appropriate eigenvalue.  Recall that the
c		LAPACK values are in ASCENDING order while
c		we want them in DESCENDING order; do the
c		switch in this loop.
c		--------------------------------------------
		do jascending=1, nmodes
			jdescending = nmodes - jascending + 1
                        if(abs(evals(jascending)) .le. DEPS ) then
                           fact        = 0.0d0
                        else
                           fact        = 1.0d0/sqrt(evals(jascending))
                        end if
			do i=1, nx
				eigenvectors(i,jdescending) = 
     &			 	  	tentpcs(i,jascending)*fact
			end do
		end do

c		-----------------------------------------------
c		Next get unswitched principal components, which 
c		are the switched eigenvectors multiplied by
c		the appropriate eigenvalues.
c		-----------------------------------------------
		do jascending=1, nmodes
			jdescending = nmodes - jascending + 1
			fact        = sqrt(evals(jascending))
			do i=1, nt
				princomp(i,jdescending) = 
     &					evecs(i,jascending)*fact
			end do
		end do
	else
c		-------------------------------------------------
c		This is the unswitched case, and so it is easier.
c		All we have to do is return things in DESCENDING
c		order despite the fact that LAPACK returns them
c		in ASCENDING order.
c		Do the eigenvectors first...
c		-------------------------------------------------
		do jascending=1, nmodes
			jdescending = nmodes - jascending + 1
			do i=1, nx
				eigenvectors(i,jdescending) =
     &					evecs(i,jascending)
			end do
		end do

c		--------------------------------
c		...then the principal components
c		--------------------------------
		do jascending=1, nmodes
			jdescending = nmodes - jascending + 1
			do i=1, nt
				princomp(i,jdescending) =
     &					tentpcs(i,jascending)
			end do
		end do

			
	endif 

c	--------------------------------------------
c	Do the second half of the areal weighting...
c	--------------------------------------------
	do mode=1, nmodes
	do i=1, nx
		if( sqrootweights(i) .eq. 0.0d0 ) then
			eigenvectors(i,mode) = 0.0d0
		else
			eigenvectors(i,mode) = 
     &				eigenvectors(i,mode) / sqrootweights(i)
		endif
	end do
	end do

c	------------------------------------------------
c	Scale the eigenvectors to have a magnitude of 1;
c	scale the corresponding principal components to
c	reproduce the original data.
c	------------------------------------------------
	do mode=1, nmodes
c		----------------------------
c		Get the normalization factor
c		----------------------------
		sum = 0.0d0
		do i=1, nx
			sum = sum + eigenvectors(i,mode)*eigenvectors(i,mode)
		end do
		fact = sqrt(sum)
c		--------------------------
c		Normalize the eigenvectors
c		--------------------------
                if (fact.eq.0.0d0) then
                   do i=1, nx
			eigenvectors(i,mode) = 0.0d0
                   end do
                else
                   do i=1, nx
			eigenvectors(i,mode) = eigenvectors(i,mode)/fact
                   end do
                end if
c		----------------------------------
c		Normalize the principal components
c		----------------------------------
		do i=1, nt
			princomp(i,mode) = princomp(i,mode)*fact
		end do
	end do

c	-------------------------------------------------
c	Copy over just the requested number of
c	eigenvalues, and calculate the cumulative percent
c	variance explained.  Start by getting the total
c	variance in the field, so we can normalize by 
c	that.
c	-------------------------------------------------
	call deoftotvar( data, nx, nt, totvar, doswitched,
     &		icovcor, covariance, correlation, dmsg )
        if (DEBUG) then
            print *," "
            print *,"totvar=",totvar
            print *," "
        end if

	sum = 0.0d0
	do jascending=nmodes, 1, -1
		jdescending = nmodes - jascending + 1
		eigenvalues(jdescending) = evals(jascending)
		variance(jdescending)    = 
     &			eigenvalues(jdescending)/totvar*100.0d0
		sum = sum + variance(jdescending)
		cumvariance(jdescending) = sum
	end do

	return
	end
c --------------------------------------------------------

	subroutine deofcovcor( data, nx, nt, icovcor, covariance,
     &		correlation, spacked, doswitched, iminnxnt, dmsg )

c	-------------------------------------------------
c	Form the covariance or correlation matrix, put it 
c	into 's'.  Note that 's' is always symmetric --
c	the correlation between X and Y is the same as 
c	between Y and X -- so use packed storage for 's'.
c	The packed storage scheme we use is the same as
c	LAPACK uses so we can pass 's' directly to the
c	solver routine: the matrix is lower triangular,
c	and s(i,j) = spacked(i+(j-1)*(1*n-j)/2).
c
c	Inputs:
c		data(nx,nt): The basic data array.  THIS MUST
c			BE ANOMALIES.
c
c		nx, nt: size of data array
c			[INTEGER]
c
c		icovcor: if .eq. covariance, then calculate
c			the covariance array;
c			 if .eq. correlation, then calculate
c			the correlation array.
c			[INTEGER]
c
c		covariance, correlation: integer values to
c			indicate each of these options.
c			[INTEGER]
c
c		doswitched: if .TRUE., then calculate the
c			'switched' array (which is of size
c			(nt,nt)); if .FALSE., then calculate
c			the normal array of size (nx,nx).
c			[LOGICAL]
c
c		iminnxnt: min(nt,nx).  Used to dimension
c			'spacked'.
c
c	Outputs:
c
c		spacked(iminnxnt*(iminnxnt+1)/2): the covariance 
c			or correlation array.  This is in packed 
c			form corresponding to LAPACK's lower
c			triangular form.  
c
c	David Pierce
c	Scripps Institution of Oceanography
c	Climate Research Division
c	dpierce@ucsd.edu
c	Jan 29, 1996
c	-------------------------------------------------

	implicit none

c	-----------------
c	Passed parameters
c	-----------------
	integer	nx, nt, icovcor, covariance, correlation, iminnxnt
	double precision data(nx,nt), spacked(iminnxnt*(iminnxnt+1)/2)
	double precision dmsg
	logical doswitched

c	---------------
c	Local variables
c	---------------
	integer	i, j, k, npts
	double precision sum, sum2, sum3, fact

	if( nx .le. 1 ) then
		print *, 'covariance: error: nx too small!! nx=', nx
c c c           call exit(-1)
                stop
	endif
	if( doswitched ) then
		do j=1, nt
		do i=j, nt
			sum  = 0.0d0
			sum2 = 0.0d0
			sum3 = 0.0d0
                        npts = 0
			do k=1, nx
                           if (data(k,i).ne.dmsg .and. 
     &                         data(k,j).ne.dmsg) then
				sum  = sum  + data(k,i)*data(k,j)
				sum2 = sum2 + data(k,i)*data(k,i)
				sum3 = sum3 + data(k,j)*data(k,j)
                                npts = npts + 1
                           end if
			enddo
			if( icovcor .eq. covariance ) then
c c c                       fact = 1.0d0/float(nx-1)
                            fact = 1.0d0/float(npts-1)
			else
                            fact = 1.0d0/(sqrt(sum2)*sqrt(sum3))
			endif
                        spacked(i+(j-1)*(2*nt-j)/2) = sum*fact
		enddo
		enddo
	else
		do j=1, nx
		do i=j, nx
			sum  = 0.0d0
			sum2 = 0.0d0
			sum3 = 0.0d0
                        npts = 0
			do k=1, nt
                           if (data(i,k).ne.dmsg .and.
     &                         data(j,k).ne.dmsg) then
				sum  = sum  + data(j,k)*data(i,k)
				sum2 = sum2 + data(i,k)*data(i,k)
				sum3 = sum3 + data(j,k)*data(j,k)
                                npts = npts + 1
                           end if
			enddo
			if( icovcor .eq. covariance ) then
c c c                       fact = 1.0d0/float(nt-1)
                            fact = 1.0d0/float(npts-1)
			else
                            fact = 1.0d0/(sqrt(sum2)*sqrt(sum3))
			endif
			spacked(i+(j-1)*(2*nx-j)/2) = sum*fact
		enddo
		enddo
	endif
			
	return
	end

c --------------------------------------------------------

	subroutine deofpcs( data, nx, nt, nmodes, iminnxnt,
     &		imaxnxnt, evecs, doswitched, tentpcs, dmsg )

c       ------------------------------------------------
c       Compute the tentative principal components; they
c       are 'tentative' because they might be the PCs
c       of the switched data.  Put them into 'tentpcs',
c       which is of size (nt,nmodes) if we are doing
c       regular EOFs and (nx,nmodes) if we are doing
c       switched EOFs.  These PCs come out in order
c       corresponding to the order of 'evecs', which is
c       in ASCENDING order.
c
c	Inputs:
c
c		data(nx,nt): The input data.  THESE MUST
c			BE ANOMALIES.
c
c		nmodes: # of modes to calculate.
c
c		iminnxnt: min(nx,nt)
c
c		evecs(iminnxnt,nmodes): the eigenvectors 
c			(which might be switched).
c
c		doswitched: if .TRUE., then we are doing
c			switched (space,time) calculation;
c			otherwise, regular (time,space)
c			calculation.
c
c	Outputs:
c
c		tentpcs(imaxnxnt,nmodes): the tentative
c			(possibly switched) principal
c			components.
c
c	David W. Pierce
c	Scripps Institution of Oceanography
c	Climate Research Division
c	dpierce@ucsd.edu
c	Jan 29, 1996
c       ------------------------------------------------

	implicit none

c	-----------------
c	Passed parameters
c	-----------------
	integer	nx, nt, nmodes, iminnxnt, imaxnxnt
	double precision data(nx,nt), evecs(iminnxnt,nmodes),
     &		tentpcs(imaxnxnt,nmodes), dmsg
	logical	doswitched

c	---------------
c	Local variables
c	---------------
	integer	i, j, k
	double precision	sum

	if( doswitched ) then
		do j=1, nmodes
		do i=1, nx
			sum = 0.0d0
			do k=1, nt
                           if (data(i,k).ne.dmsg) then
				sum = sum + data(i,k)*evecs(k,j)
                           end if
			enddo
			tentpcs(i,j) = sum
		enddo
		enddo
	else
		do j=1, nt
		do i=1, nmodes
			sum = 0.0d0
			do k=1, nx
                           if (data(k,j).ne.dmsg) then
				sum = sum + data(k,j)*evecs(k,i)
                           end if
			enddo
			tentpcs(j,i) = sum
		enddo
		enddo
	endif

	return
	end

c ------------------------------------------

	subroutine deoftotvar( data, nx, nt, totvar, doswitched,
     &		icovcor, covariance, correlation, dmsg )

c	-------------------------------------------------
c	Returns the total variance in the field so we can
c	normalize by it.
c
c	Inputs:
c
c		data(nx,nt): data to calculate upon
c
c		nx, nt:	size of 'data'.
c
c		doswitched: if .TRUE., then we are working
c			in switched (nx,nt) space, false 
c			otherwise.
c
c		icovcor: if (icovcor .eq. covariance), then
c			we are using the covariance array;
c			if( icovcor .eq. correlation) then
c			we are using the correlation array.
c
c	Outputs:
c
c		totvar: estimate of total variance
c
c	-------------------------------------------------

	implicit none

	integer	nx, nt, icovcor, covariance, correlation
	double precision data(nx,nt), totvar, sum, fact, dmsg
	logical	doswitched
	integer	i, j, npts

	if( icovcor .eq. correlation ) then
		if( doswitched ) then
			totvar = nt 
		else
			totvar = nx
		endif
		return
	endif

	totvar = 0.0d0
        if( doswitched ) then
            fact = 1.0d0/(nx-1.0d0)
        else
            fact = 1.0d0/(nt-1.0d0)
        endif
	do j=1, nt
		sum  = 0.0d0
		npts = 0
		do i=1, nx
                   if (data(i,j).ne.dmsg) then
			sum  = sum  + data(i,j)*data(i,j)
                        npts = npts + 1
                   end if
		enddo
                fact = 1.0d0/(npts-1.0d0)
		totvar = totvar + sum*fact
	enddo

	return
	end

      LOGICAL          FUNCTION LSAMEN( N, CA, CB )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER*( * )    CA, CB
      INTEGER            N
*     ..
*
*  Purpose
*  =======
*
*  LSAMEN  tests if the first N letters of CA are the same as the
*  first N letters of CB, regardless of case.
*  LSAMEN returns .TRUE. if CA and CB are equivalent except for case
*  and .FALSE. otherwise.  LSAMEN also returns .FALSE. if LEN( CA )
*  or LEN( CB ) is less than N.
*
*  Arguments
*  =========
*
*  N       (input) INTEGER
*          The number of characters in CA and CB to be compared.
*
*  CA      (input) CHARACTER*(*)
*  CB      (input) CHARACTER*(*)
*          CA and CB specify two character strings of length at least N.
*          Only the first N characters of each string will be accessed.
*
* =====================================================================
*
*     .. Local Scalars ..
      INTEGER            I
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          LEN
*     ..
*     .. Executable Statements ..
*
      LSAMEN = .FALSE.
      IF( LEN( CA ).LT.N .OR. LEN( CB ).LT.N )
     $   GO TO 20
*
*     Do for each character in the two strings.
*
      DO 10 I = 1, N
*
*        Test if the characters are equal using LSAME.
*
         IF( .NOT.LSAME( CA( I: I ), CB( I: I ) ) )
     $      GO TO 20
*
   10 CONTINUE
      LSAMEN = .TRUE.
*
   20 CONTINUE
      RETURN
*
*     End of LSAMEN
*
      END

        PROGRAM CPEX06
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
        PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Declare required data arrays and workspace arrays.
C
        DIMENSION ZDAT(27,23),RWRK(5000),IWRK(1000),IAMA(10000)
        DIMENSION IASF(13)
C
C Declare the routine which will draw contour lines, avoiding labels.
C
        EXTERNAL DRAWCL
C
C Define an array for GKS aspect source flags.
C
        DATA IASF / 13*1 /
C
C Open GKS.
C
        CALL GOPKS (IERRF, ISZDM)
        CALL GOPWK (IWKID, LUNIT, IWTYPE)
        CALL GACWK (IWKID)
C
C Turn off the clipping indicator.
C
        CALL GSCLIP (0)
C
C Set all aspect source flags to "individual".
C
        CALL GSASF (IASF)
C
C Define color indices.
C
        CALL DFCLRS(IWKID)
C
C Generate an array of test data.
C
        CALL GENDAT (ZDAT,27,27,23,25,25,-362.362E11,451.834E11)
C
C Increase the approximate number of contour levels used.
C
        CALL CPSETI ('CLS - CONTOUR LEVEL SELECTION',25)
C
C Turn on the positioning of labels by the penalty scheme.
C
        CALL CPSETI ('LLP - LINE LABEL POSITIONING',3)
C
C Label highs and low with just the number, boxed and colored green.
C
        CALL CPSETC ('HLT - HIGH/LOW TEXT','$ZDV$')
        CALL CPSETI ('HLB - HIGH/LOW LABEL BOX FLAG',1)
        CALL CPSETI ('HLC - HIGH/LOW LABEL COLOR INDEX',9)
C
C Tell CONPACK to delete high/low labels which overlap the informational
C label, another high/low label, or the edge.
C
        CALL CPSETI ('HLO - HIGH/LOW LABEL OVERLAP FLAG',7)
C
C Turn on the drawing of the grid edge ("contour line number -1"),
C thicken it somewhat, and make it white.
C
        CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',-1)
        CALL CPSETI ('CLU - CONTOUR LEVEL USE FLAG',1)
        CALL CPSETR ('CLL - CONTOUR LEVEL LINE WIDTH',2.)
        CALL CPSETI ('CLC - CONTOUR LINE COLOR',1)
C
C Initialize the drawing of the contour plot.
C
        CALL CPRECT (ZDAT,27,27,23,RWRK,5000,IWRK,1000)
C
C Force the selection of contour levels by CONPACK.
C
        CALL CPPKCL (ZDAT,RWRK,IWRK)
C
C Force the color of the negative contours to blue, the color of the
C positive contours to red, and the color of the zero contour to white.
C If a positive or negative contour is labelled, use a darker shade and
C make the color of the label match.
C
        CALL CPGETI ('NCL - NUMBER OF CONTOUR LEVELS',NCLV)
C
        DO 102 ICLV=1,NCLV
          CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',ICLV)
          CALL CPGETR ('CLV - CONTOUR LEVEL',CLEV)
          CALL CPGETI ('CLU - CONTOUR LEVEL USE',ICLU)
          IF (CLEV.LT.0.) THEN
            IF (ICLU.EQ.1) THEN
              CALL CPSETI ('CLC - CONTOUR LINE COLOR',7)
            ELSE
              CALL CPSETI ('CLC - CONTOUR LINE COLOR',6)
              CALL CPSETI ('LLC - LINE LABEL COLOR',6)
            END IF
          ELSE IF (CLEV.EQ.0.) THEN
            CALL CPSETI ('CLC - CONTOUR LINE COLOR',1)
            CALL CPSETI ('LLC - LINE LABEL COLOR',1)
          ELSE
            IF (ICLU.EQ.1) THEN
              CALL CPSETI ('CLC - CONTOUR LINE COLOR',13)
            ELSE
              CALL CPSETI ('CLC - CONTOUR LINE COLOR',14)
              CALL CPSETI ('LLC - LINE LABEL COLOR',14)
            END IF
          END IF
  102   CONTINUE
C
C Initialize the area map.
C
        CALL ARINAM (IAMA,10000)
C
C Put label boxes in the area map.
C
        CALL CPLBAM (ZDAT,RWRK,IWRK,IAMA)
C
C Draw contour lines, avoiding drawing through label boxes.
C
        CALL CPCLDM (ZDAT,RWRK,IWRK,IAMA,DRAWCL)
C
C Fill in the labels.
C
        CALL CPLBDR (ZDAT,RWRK,IWRK)
C
C Compute and print statistics for the plot, label it, and put a
C boundary line at the edge of the plotter frame.
C
        CALL CAPSAP ('EXAMPLE 6',IAMA,10000)
        CALL LABTOP ('EXAMPLE 6',.017)
        CALL BNDARY
C
C Advance the frame.
C
        CALL FRAME
C
C Close GKS.
C
        CALL GDAWK (IWKID)
        CALL GCLWK (IWKID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END


      SUBROUTINE DRAWCL (XCS,YCS,NCS,IAI,IAG,NAI)
C
C This version of DRAWCL draws the polyline defined by the points
C ((XCS(I),YCS(I)),I=1,NCS) if and only if none of the area identifiers
C for the area containing the polyline are negative.  The dash package
C routine CURVED is called to do the drawing.
C
        DIMENSION XCS(*),YCS(*),IAI(*),IAG(*)
C
C Turn on drawing.
C
        IDR=1
C
C If any area identifier is negative, turn off drawing.
C
        DO 101 I=1,NAI
          IF (IAI(I).LT.0) IDR=0
  101   CONTINUE
C
C If drawing is turned on, draw the polyline.
C
        IF (IDR.NE.0) CALL CURVED (XCS,YCS,NCS)
C
C Done.
C
        RETURN
C
      END

      SUBROUTINE SSTEDC( COMPZ, N, D, E, Z, LDZ, WORK, LWORK, IWORK,
     $                   LIWORK, INFO )
*
*  -- LAPACK driver routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          COMPZ
      INTEGER            INFO, LDZ, LIWORK, LWORK, N
*     ..
*     .. Array Arguments ..
      INTEGER            IWORK( * )
      REAL               D( * ), E( * ), WORK( * ), Z( LDZ, * )
*     ..
*
*  Purpose
*  =======
*
*  SSTEDC computes all eigenvalues and, optionally, eigenvectors of a
*  symmetric tridiagonal matrix using the divide and conquer method.
*  The eigenvectors of a full or band real symmetric matrix can also be
*  found if SSYTRD or SSPTRD or SSBTRD has been used to reduce this
*  matrix to tridiagonal form.
*
*  This code makes very mild assumptions about floating point
*  arithmetic. It will work on machines with a guard digit in
*  add/subtract, or on those binary machines without guard digits
*  which subtract like the Cray X-MP, Cray Y-MP, Cray C-90, or Cray-2.
*  It could conceivably fail on hexadecimal or decimal machines
*  without guard digits, but we know of none.  See SLAED3 for details.
*
*  Arguments
*  =========
*
*  COMPZ   (input) CHARACTER*1
*          = 'N':  Compute eigenvalues only.
*          = 'I':  Compute eigenvectors of tridiagonal matrix also.
*          = 'V':  Compute eigenvectors of original dense symmetric
*                  matrix also.  On entry, Z contains the orthogonal
*                  matrix used to reduce the original matrix to
*                  tridiagonal form.
*
*  N       (input) INTEGER
*          The dimension of the symmetric tridiagonal matrix.  N >= 0.
*
*  D       (input/output) REAL array, dimension (N)
*          On entry, the diagonal elements of the tridiagonal matrix.
*          On exit, if INFO = 0, the eigenvalues in ascending order.
*
*  E       (input/output) REAL array, dimension (N-1)
*          On entry, the subdiagonal elements of the tridiagonal matrix.
*          On exit, E has been destroyed.
*
*  Z       (input/output) REAL array, dimension (LDZ,N)
*          On entry, if COMPZ = 'V', then Z contains the orthogonal
*          matrix used in the reduction to tridiagonal form.
*          On exit, if INFO = 0, then if COMPZ = 'V', Z contains the
*          orthonormal eigenvectors of the original symmetric matrix,
*          and if COMPZ = 'I', Z contains the orthonormal eigenvectors
*          of the symmetric tridiagonal matrix.
*          If  COMPZ = 'N', then Z is not referenced.
*
*  LDZ     (input) INTEGER
*          The leading dimension of the array Z.  LDZ >= 1.
*          If eigenvectors are desired, then LDZ >= max(1,N).
*
*  WORK    (workspace/output) REAL array,
*                                         dimension (LWORK)
*          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*
*  LWORK   (input) INTEGER
*          The dimension of the array WORK.
*          If COMPZ = 'N' or N <= 1 then LWORK must be at least 1.
*          If COMPZ = 'V' and N > 1 then LWORK must be at least
*                         ( 1 + 3*N + 2*N*lg N + 3*N**2 ),
*                         where lg( N ) = smallest integer k such
*                         that 2**k >= N.
*          If COMPZ = 'I' and N > 1 then LWORK must be at least
*                         ( 1 + 4*N + N**2 ).
*
*          If LWORK = -1, then a workspace query is assumed; the routine
*          only calculates the optimal size of the WORK array, returns
*          this value as the first entry of the WORK array, and no error
*          message related to LWORK is issued by XERBLA.
*
*  IWORK   (workspace/output) INTEGER array, dimension (LIWORK)
*          On exit, if INFO = 0, IWORK(1) returns the optimal LIWORK.
*
*  LIWORK  (input) INTEGER
*          The dimension of the array IWORK.
*          If COMPZ = 'N' or N <= 1 then LIWORK must be at least 1.
*          If COMPZ = 'V' and N > 1 then LIWORK must be at least
*                         ( 6 + 6*N + 5*N*lg N ).
*          If COMPZ = 'I' and N > 1 then LIWORK must be at least
*                         ( 3 + 5*N ).
*
*          If LIWORK = -1, then a workspace query is assumed; the
*          routine only calculates the optimal size of the IWORK array,
*          returns this value as the first entry of the IWORK array, and
*          no error message related to LIWORK is issued by XERBLA.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit.
*          < 0:  if INFO = -i, the i-th argument had an illegal value.
*          > 0:  The algorithm failed to compute an eigenvalue while
*                working on the submatrix lying in rows and columns
*                INFO/(N+1) through mod(INFO,N+1).
*
*  Further Details
*  ===============
*
*  Based on contributions by
*     Jeff Rutter, Computer Science Division, University of California
*     at Berkeley, USA
*  Modified by Francoise Tisseur, University of Tennessee.
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ZERO, ONE, TWO
      PARAMETER          ( ZERO = 0.0E0, ONE = 1.0E0, TWO = 2.0E0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            LQUERY
      INTEGER            END, I, ICOMPZ, II, J, K, LGN, LIWMIN, LWMIN,
     $                   M, SMLSIZ, START, STOREZ, STRTRW
      REAL               EPS, ORGNRM, P, TINY
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            ILAENV
      REAL               SLAMCH, SLANST
      EXTERNAL           ILAENV, LSAME, SLAMCH, SLANST
*     ..
*     .. External Subroutines ..
      EXTERNAL           SGEMM, SLACPY, SLAED0, SLASCL, SLASET, SLASRT,
     $                   SSTEQR, SSTERF, SSWAP, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, INT, LOG, MAX, MOD, REAL, SQRT
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      LQUERY = ( LWORK.EQ.-1 .OR. LIWORK.EQ.-1 )
*
      IF( LSAME( COMPZ, 'N' ) ) THEN
         ICOMPZ = 0
      ELSE IF( LSAME( COMPZ, 'V' ) ) THEN
         ICOMPZ = 1
      ELSE IF( LSAME( COMPZ, 'I' ) ) THEN
         ICOMPZ = 2
      ELSE
         ICOMPZ = -1
      END IF
      IF( N.LE.1 .OR. ICOMPZ.LE.0 ) THEN
         LIWMIN = 1
         LWMIN = 1
      ELSE
         LGN = INT( LOG( REAL( N ) ) / LOG( TWO ) )
         IF( 2**LGN.LT.N )
     $      LGN = LGN + 1
         IF( 2**LGN.LT.N )
     $      LGN = LGN + 1
         IF( ICOMPZ.EQ.1 ) THEN
            LWMIN = 1 + 3*N + 2*N*LGN + 3*N**2
            LIWMIN = 6 + 6*N + 5*N*LGN
         ELSE IF( ICOMPZ.EQ.2 ) THEN
            LWMIN = 1 + 4*N + N**2
            LIWMIN = 3 + 5*N
         END IF
      END IF
      IF( ICOMPZ.LT.0 ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( ( LDZ.LT.1 ) .OR. ( ICOMPZ.GT.0 .AND. LDZ.LT.MAX( 1,
     $         N ) ) ) THEN
         INFO = -6
      ELSE IF( LWORK.LT.LWMIN .AND. .NOT.LQUERY ) THEN
         INFO = -8
      ELSE IF( LIWORK.LT.LIWMIN .AND. .NOT.LQUERY ) THEN
         INFO = -10
      END IF
*
      IF( INFO.EQ.0 ) THEN
         WORK( 1 ) = LWMIN
         IWORK( 1 ) = LIWMIN
      END IF
*
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'SSTEDC', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         RETURN 
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN 
      IF( N.EQ.1 ) THEN
         IF( ICOMPZ.NE.0 )
     $      Z( 1, 1 ) = ONE
         RETURN 
      END IF
*
      SMLSIZ = ILAENV( 9, 'SSTEDC', ' ', 0, 0, 0, 0 )
*
*     If the following conditional clause is removed, then the routine
*     will use the Divide and Conquer routine to compute only the
*     eigenvalues, which requires (3N + 3N**2) real workspace and
*     (2 + 5N + 2N lg(N)) integer workspace.
*     Since on many architectures SSTERF is much faster than any other
*     algorithm for finding eigenvalues only, it is used here
*     as the default.
*
*     If COMPZ = 'N', use SSTERF to compute the eigenvalues.
*
      IF( ICOMPZ.EQ.0 ) THEN
         CALL SSTERF( N, D, E, INFO )
         RETURN 
      END IF
*
*     If N is smaller than the minimum divide size (SMLSIZ+1), then
*     solve the problem with another solver.
*
      IF( N.LE.SMLSIZ ) THEN
         IF( ICOMPZ.EQ.0 ) THEN
            CALL SSTERF( N, D, E, INFO )
            RETURN 
         ELSE IF( ICOMPZ.EQ.2 ) THEN
            CALL SSTEQR( 'I', N, D, E, Z, LDZ, WORK, INFO )
            RETURN
         ELSE
            CALL SSTEQR( 'V', N, D, E, Z, LDZ, WORK, INFO )
            RETURN 
         END IF
      END IF
*
*     If COMPZ = 'V', the Z matrix must be stored elsewhere for later
*     use.
*
      IF( ICOMPZ.EQ.1 ) THEN
         STOREZ = 1 + N*N
      ELSE
         STOREZ = 1
      END IF
*
      IF( ICOMPZ.EQ.2 ) THEN
         CALL SLASET( 'Full', N, N, ZERO, ONE, Z, LDZ )
      END IF
*
*     Scale.
*
      ORGNRM = SLANST( 'M', N, D, E )
      IF( ORGNRM.EQ.ZERO )
     $   RETURN
*
      EPS = SLAMCH( 'Epsilon' )
*
      START = 1
*
*     while ( START <= N )
*
   10 CONTINUE
      IF( START.LE.N ) THEN
*
*     Let END be the position of the next subdiagonal entry such that
*     E( END ) <= TINY or END = N if no such subdiagonal exists.  The
*     matrix identified by the elements between START and END
*     constitutes an independent sub-problem.
*
         END = START
   20    CONTINUE
         IF( END.LT.N ) THEN
            TINY = EPS*SQRT( ABS( D( END ) ) )*SQRT( ABS( D( END+1 ) ) )
            IF( ABS( E( END ) ).GT.TINY ) THEN
               END = END + 1
               GO TO 20
            END IF
         END IF
*
*        (Sub) Problem determined.  Compute its size and solve it.
*
         M = END - START + 1
         IF( M.EQ.1 ) THEN
            START = END + 1
            GO TO 10
         END IF
         IF( M.GT.SMLSIZ ) THEN
            INFO = SMLSIZ
*
*           Scale.
*
            ORGNRM = SLANST( 'M', M, D( START ), E( START ) )
            CALL SLASCL( 'G', 0, 0, ORGNRM, ONE, M, 1, D( START ), M,
     $                   INFO )
            CALL SLASCL( 'G', 0, 0, ORGNRM, ONE, M-1, 1, E( START ),
     $                   M-1, INFO )
*
            IF( ICOMPZ.EQ.1 ) THEN
               STRTRW = 1
            ELSE
               STRTRW = START
            END IF
            CALL SLAED0( ICOMPZ, N, M, D( START ), E( START ),
     $                   Z( STRTRW, START ), LDZ, WORK( 1 ), N,
     $                   WORK( STOREZ ), IWORK, INFO )
            IF( INFO.NE.0 ) THEN
               INFO = ( INFO / ( M+1 )+START-1 )*( N+1 ) +
     $                MOD( INFO, ( M+1 ) ) + START - 1
               RETURN 
            END IF
*
*           Scale back.
*
            CALL SLASCL( 'G', 0, 0, ONE, ORGNRM, M, 1, D( START ), M,
     $                   INFO )
*
         ELSE
            IF( ICOMPZ.EQ.1 ) THEN
*
*     Since QR won't update a Z matrix which is larger than the
*     length of D, we must solve the sub-problem in a workspace and
*     then multiply back into Z.
*
               CALL SSTEQR( 'I', M, D( START ), E( START ), WORK, M,
     $                      WORK( M*M+1 ), INFO )
               CALL SLACPY( 'A', N, M, Z( 1, START ), LDZ,
     $                      WORK( STOREZ ), N )
               CALL SGEMM( 'N', 'N', N, M, M, ONE, WORK( STOREZ ), LDZ,
     $                     WORK, M, ZERO, Z( 1, START ), LDZ )
            ELSE IF( ICOMPZ.EQ.2 ) THEN
               CALL SSTEQR( 'I', M, D( START ), E( START ),
     $                      Z( START, START ), LDZ, WORK, INFO )
            ELSE
               CALL SSTERF( M, D( START ), E( START ), INFO )
            END IF
            IF( INFO.NE.0 ) THEN
               INFO = START*( N+1 ) + END
               RETURN 
            END IF
         END IF
*
         START = END + 1
         GO TO 10
      END IF
*
*     endwhile
*
*     If the problem split any number of times, then the eigenvalues
*     will not be properly ordered.  Here we permute the eigenvalues
*     (and the associated eigenvectors) into ascending order.
*
      IF( M.NE.N ) THEN
         IF( ICOMPZ.EQ.0 ) THEN
*
*        Use Quick Sort
*
            CALL SLASRT( 'I', N, D, INFO )
*
         ELSE
*
*        Use Selection Sort to minimize swaps of eigenvectors
*
            DO 40 II = 2, N
               I = II - 1
               K = I
               P = D( I )
               DO 30 J = II, N
                  IF( D( J ).LT.P ) THEN
                     K = J
                     P = D( J )
                  END IF
   30          CONTINUE
               IF( K.NE.I ) THEN
                  D( K ) = D( I )
                  D( I ) = P
                  CALL SSWAP( N, Z( 1, I ), 1, Z( 1, K ), 1 )
               END IF
   40       CONTINUE
         END IF
      END IF
*
      WORK( 1 ) = LWMIN
      IWORK( 1 ) = LIWMIN
*
      RETURN
*
*     End of SSTEDC
*
      END

      PROGRAM FPCLOQU
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C INVOKE DEMO DRIVER
C
      CALL EXPCLQ (IWKID)
C
C Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      STOP
      END
C
C
      SUBROUTINE EXPCLQ (IWKID)
C
C PURPOSE                To provide a simple demonstration of the
C                        PLCHLQ text drawing techniques.
C
C USAGE                  CALL EXPCLQ (IWKID)
C
C ARGUMENTS
C
C ON INPUT               IWKID
C                          A workstation id
C
C LANGUAGE               FORTRAN
C
C PORTABILITY            FORTRAN 77
C
C NOTE                   The call to GOPWK will have to be modified
C                        when using a non-NCAR GKS package.  The third
C                        argument must be the workstation type for WISS.
C
C
      REAL XCOOR2(500), YCOOR2(500)
C
C Turn buffering off
C
      CALL SETUSV('PB',2)
C
C Set up a color table
C
C  White background
C
      CALL GSCR (IWKID,0,1.,1.,1.)
C
C  Black foreground
C
      CALL GSCR (IWKID,1,0.,0.,0.)
C
C  Red
C
      CALL GSCR (IWKID,2,1.,0.,0.)
C
C  Green
C
      CALL GSCR (IWKID,3,0.,1.,0.)
C
C  Blue
C
      CALL GSCR (IWKID,4,0.,0.,1.)
C
C Establish the viewport and window.
C
      CALL SET(.0,1.,0.,1.,0.,1.,0.,1.,1)
C
C Get the coordinates for a Spiral in the center of the frame
C
      CALL GNSPRL(.5,.5,.45,500,4,XCOOR2, YCOOR2)
C
C  Set line width
C
      CALL GSLWSC(3.)
C
C  Set line color
C
      CALL GSPLCI(2)
C
C  Draw the spiral
C
      CALL CURVED(XCOOR2,YCOOR2,500)
C
C Draw labels
C  Set text color
C
      CALL GSTXCI(4)
C
C Set the font
C
      CALL GSTXFP(-13,2)
C
C Plot the strings
C
      CALL PLCHLQ(.41,.58,'Use',.04,55.,0.)
      CALL PLCHLQ(.58,.62,'PLCHLQ',.03,-25.,0.)
C
C Set the font
C
      CALL GSTXFP(-6,2)
C
C Plot the strings
C
      CALL PLCHLQ(.66,.47,'to',.04,-90.,0.)
      CALL PLCHLQ(.57,.33,'access',.05,-145.,0.)
C
C Set the font
C
      CALL GSTXFP(-12,2)
C
C Plot the strings
C
      CALL PLCHLQ(.39,.32,'the',.05,150.,0.)
      CALL PLCHLQ(.28,.47,'GKS',.05,110.,0.)
C
C Set the font
C
      CALL GSTXFP(-16,2)
C
C Plot the strings
C
      CALL PLCHLQ(.34,.67,'fonts',.05,45.,0.)
      CALL PLCHLQ(.525,.75,'and',.05,0.,0.)
C
C Set the font
C
      CALL GSTXFP(-7,2)
C
C  Plot the strings
C
      CALL PLCHLQ(.74,.59,'position',.05,-65.,0.)
      CALL PLCHLQ(.73,.31,'text',.05,-130.,0.)
C
C Set the font
C
      CALL GSTXFP(1,2)
C
C  Plot the strings
C
      CALL PLCHLQ(.57,.20,'at',.05,-165.,0.)
      CALL PLCHLQ(.40,.20,'any',.05,165.,0.)
C
C Set the font
C
      CALL GSTXFP(-9,2)
C
C Plot the string
C
      CALL PLCHLQ(.23,.32,'angle.',.05,130.,0.)
C
C Advance the Frame
C
      CALL FRAME
C
      END

      SUBROUTINE GNSPRL(XCNTR,YCNTR,IRADUS,NPTS,LOOPS,XCOORD,YCOORD)
      INTEGER NPTS, LOOPS
      REAL XCNTR, YCNTR, IRADUS, XCOORD(NPTS), YCOORD(NPTS)
C
C This function generates the coordinates for a spiral with
C center at XCNTR, YCNTR, and an initial radius of IRADUS. The spiral
C will turn on itself LOOPS times.  There are
C NPTS in the Spiral and the coordinates are returned in the
C arrays XCOORD and YCOORD.
C
      RADIUS = IRADUS
C
C Compute number of radians per degree
C
      RADPDG = 2.*3.14159/360.
C
C Initialize the angle
C
       ANGLE = 0.
C
C Calculate the change in angle (360./number of points in circle)
C
       DELTA = REAL(LOOPS) * 360./(REAL(NPTS-1))
C
C Convert to radians
C
       DELTA = DELTA * RADPDG
C
C Calculate the change in radius
C
       DRAD = RADIUS/(REAL(NPTS - 1))
C
C Calculate each coordinate
C
       DO 12 I=1,NPTS
          XCOORD(I) = RADIUS * (COS(ANGLE)) + XCNTR
          YCOORD(I) = RADIUS * (SIN(ANGLE)) + YCNTR
C
C Increase the angle
C
          ANGLE = ANGLE + DELTA
C
C Reduce the radius
C
          RADIUS = RADIUS - DRAD
  12   CONTINUE

      RETURN
      END

C
C $Id: tdstri.f,v 1.4 2008-07-27 00:17:33 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE TDSTRI (U,NU,V,NV,W,LW1D,RTRI,MTRI,NTRI,IRST)
C
        DIMENSION U(NU),V(NV),W(LW1D,*),RTRI(10,MTRI)
C
C The routine TDSTRI, given a two-dimensional array of function values,
C generates a set of triangles representing the surface defined by those
C values and adds them to a list of triangles tendered by the user.  The
C arguments are as follows:
C
C   U is an input array of real values of the independent variable U.
C
C   NU is an input integer specifying the dimension of the array U.
C
C   V is an input array of real values of the independent variable V.
C
C   NV is an input integer specifying the dimension of the array V.
C
C   W is the two-dimensional real array of function values.  For each
C   I from 1 to NU and for each J from 1 to NV, (U(I),V(J),W(I,J)) is
C   a point on the surface represented by the arrays U, V, and W.
C
C   LW1D is an input integer specifying the first (FORTRAN) dimension of
C   the array W.  It must be the case that LW1D is greater than or equal
C   to NU.
C
C   RTRI is a real array in which a list of triangles is being
C   generated; it is dimensioned 10 x MTRI.  Each 10-word entry in
C   the list consists of the U, V, and W coordinates of each of three
C   points, followed by a rendering style index.
C
C   MTRI is an input integer specifying the second dimension of the
C   array RTRI: the maximum number of triangles the list will hold.
C
C   NTRI is an input/output integer specifying the number of triangles
C   currently in the array RTRI.  Initially, NTRI must be zeroed by the
C   user.  Each call to one of the routines TDSTRI or TDITRI updates the
C   value of NTRI to reflect the number of triangles added to the list.
C
C   IRST is an input integer specifying the rendering style index to be
C   used for all the triangles generated by a particular call to TDSTRI.
C   Note that more than one surface can be represented by the triangles
C   in the triangle list and that each surface can be rendered in its
C   own particular style.
C
C Get the real equivalent of the rendering style index.
C
        RRST=REAL(IRST)
C
C Loop through the grid boxes, generating two triangles apiece.  Note
C that each triangle is traced in a counterclockwise direction as
C viewed from above; this is important, as it enables the renderer to
C tell which side of a triangle is being looked at.
C
        DO 102 I=1,NU-1
          DO 101 J=1,NV-1
            IF (NTRI.LT.MTRI) THEN
              NTRI=NTRI+1
              RTRI(1,NTRI)=U(I)
              RTRI(2,NTRI)=V(J+1)
              RTRI(3,NTRI)=W(I,J+1)
              RTRI(4,NTRI)=U(I)
              RTRI(5,NTRI)=V(J)
              RTRI(6,NTRI)=W(I,J)
              RTRI(7,NTRI)=U(I+1)
              RTRI(8,NTRI)=V(J)
              RTRI(9,NTRI)=W(I+1,J)
              RTRI(10,NTRI)=RRST
            END IF
            IF (NTRI.LT.MTRI) THEN
              NTRI=NTRI+1
              RTRI(1,NTRI)=U(I+1)
              RTRI(2,NTRI)=V(J)
              RTRI(3,NTRI)=W(I+1,J)
              RTRI(4,NTRI)=U(I+1)
              RTRI(5,NTRI)=V(J+1)
              RTRI(6,NTRI)=W(I+1,J+1)
              RTRI(7,NTRI)=U(I)
              RTRI(8,NTRI)=V(J+1)
              RTRI(9,NTRI)=W(I,J+1)
              RTRI(10,NTRI)=RRST
            END IF
  101     CONTINUE
  102   CONTINUE
C
C Done.
C
        RETURN
C
      END

C
C $Id: agchil.f,v 1.6 2008-07-27 00:14:33 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE AGCHIL (IFLG,LBNM,LNNO)
C
      CHARACTER*(*) LBNM
C
C The routine AGCHIL is called by AGLBLS just before and just after each
C informational-label line of text is drawn.  The default version does
C nothing.  A user may supply a version to change the appearance of the
C text lines.  The arguments are as follows:
C
C - IFLG is zero if a text line is about to be drawn, non-zero if one
C   has just been drawn.
C
C - LBNM is the name of the label containing the line in question.
C
C - LNNO is the number of the line.
C
C Done.
C
      RETURN
C
      END

subroutine plotfmt_rdhead(istatus,head_real,field,hdate, &
                          units, map_source, desc)

  implicit none

  integer, parameter :: MAX_VAR = 14
  integer :: funit, i
  integer, intent(inout) :: istatus

  integer :: version, nx, ny, iproj
  real :: nlats, xfcst, xlvl, startlat, startlon, deltalat, deltalon
  real :: dx, dy, xlonc, truelat1, truelat2, earth_radius
  logical :: is_wind_grid_rel
  character (len = 8) :: startloc
  character (len = 9) :: field
  character (len = 24) :: hdate
  character (len = 25) :: units
  character (len = 32) :: map_source
  character (len = 46) :: desc

  real, dimension(MAX_VAR) :: head_real(MAX_VAR)

  funit = 10
  istatus = 1

  do i=1,MAX_VAR
    head_real(i) = -999.0
  end do

  read(unit=funit,end=1001) version
  read(unit=funit) hdate, xfcst, map_source, field, &
                   units, desc, xlvl, nx, ny, iproj

  if(iproj == 0) then
    read(unit=funit,err=1001,end=1001) startloc, startlat, startlon, &
                                       deltalat, deltalon, earth_radius

  else if(iproj == 1) then
    read(unit=funit,err=1001,end=1001) startloc, startlat, startlon, dx, dy, &
                                       truelat1, earth_radius

  else if(iproj == 3) then
    read(unit=funit,err=1001,end=1001) startloc, startlat, startlon, dx, dy, &
                                       xlonc, truelat1, truelat2, earth_radius

  else if(iproj == 4) then
    read(unit=funit,err=1001,end=1001) startloc, startlat, startlon, &
                                       nlats, deltalon, earth_radius
  else if(iproj == 5) then
    read(unit=funit,err=1001,end=1001) startloc, startlat, startlon, dx, dy, &
                                       xlonc, truelat1, earth_radius
  end if

  read(unit=funit,err=1001,end=1001) is_wind_grid_rel

  head_real(1) = version
  head_real(2) = xfcst
  head_real(3) = xlvl
  head_real(4) = nx
  head_real(5) = ny
  head_real(6) = iproj
  if(iproj == 0) then
    head_real(7) = startlat
    head_real(8) = startlon
    head_real(9) = deltalat
    head_real(10) = deltalon
    head_real(11) = earth_radius
  else if(iproj == 1) then
    head_real(7) = startlat
    head_real(8) = startlon
    head_real(9) = dx
    head_real(10) = dy
    head_real(11) = truelat1
    head_real(12) = earth_radius
  else if(iproj == 3) then
    head_real(7) = startlat
    head_real(8) = startlon
    head_real(9) = dx
    head_real(10) = dy
    head_real(11) = xlonc
    head_real(12) = truelat1
    head_real(13) = truelat2
    head_real(14) = earth_radius
  else if(iproj == 4) then
    head_real(7) = startlat
    head_real(8) = startlon
    head_real(9) = nlats
    head_real(10) = deltalon
    head_real(11) = earth_radius
  else if(iproj == 5) then
    head_real(7) = startlat
    head_real(8) = startlon
    head_real(9) = dx
    head_real(10) = dy
    head_real(11) = xlonc
    head_real(12) = truelat1
    head_real(13) = earth_radius
  end if

  istatus = 0

  return

   1001 return

  istatus = 1

end subroutine plotfmt_rdhead

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C   FFTPACK 5.0
C   Copyright (C) 1995-2004, Scientific Computing Division,
C   University Corporation for Atmospheric Research
C   Licensed under the GNU General Public License (GPL)
C
C   Authors:  Paul N. Swarztrauber and Richard A. Valent
C
C   $Id: sinq1b.f,v 1.2 2006-11-21 01:10:19 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      SUBROUTINE DSINQ1B(N,INC,X,LENX,WSAVE,LENSAV,WORK,LENWRK,IER)
      DOUBLE PRECISION XHOLD
      INTEGER N,INC,LENX,LENSAV,LENWRK,IER
      DOUBLE PRECISION X(INC,*),WSAVE(LENSAV),WORK(LENWRK)
C
      IER = 0
C
      IF (LENX.LT.INC* (N-1)+1) THEN
          IER = 1
          CALL DXERFFT('SINQ1B',6)
      ELSE IF (LENSAV.LT.2*N+INT(LOG(DBLE(N)))+4) THEN
          IER = 2
          CALL DXERFFT('SINQ1B',8)
      ELSE IF (LENWRK.LT.N) THEN
          IER = 3
          CALL DXERFFT('SINQ1B',10)
      END IF
C
      IF (N.GT.1) GO TO 101
      X(1,1) = 4.D0*X(1,1)
      RETURN
  101 NS2 = N/2
      DO 102 K = 2,N,2
          X(1,K) = -X(1,K)
  102 CONTINUE
      CALL DCOSQ1B(N,INC,X,LENX,WSAVE,LENSAV,WORK,LENWRK,IER1)
      IF (IER1.NE.0) THEN
          IER = 20
          CALL DXERFFT('SINQ1B',-5)
          GO TO 300
      END IF
      DO 103 K = 1,NS2
          KC = N - K
          XHOLD = X(1,K)
          X(1,K) = X(1,KC+1)
          X(1,KC+1) = XHOLD
  103 CONTINUE
  300 RETURN
      END

C
C	$Id: tior.f,v 1.4 2008-07-27 00:59:03 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE TIOR(MASK,MSKDIM,IWDLNG,INTLNG,IOUT,IER)
      DIMENSION MASK(MSKDIM)
      IER=-1
      WRITE (IOUT,108)
      IWDP1=IWDLNG+1
      INTP1=INTLNG+1
      IF (MSKDIM.LT.IWDP1) GOTO 102
      IF (IWDLNG.LT.4 .OR. IWDP1.GT.99) GOTO 102
      IF (INTLNG.LT.4 .OR. INTLNG.GT.IWDLNG) GOTO 102
      IER=1
      IF (INTLNG.LT.IWDLNG) WRITE (IOUT,109) INTLNG
      K = IOR(0,0)
      IF (K.NE.0) GOTO 103
      K = IOR(3,10)
      IF (K.NE.11) GOTO 104
           DO 101 I=2,INTP1
           K = IOR(MASK(I),MASK(I-1))
           IF (K.NE.MASK(I)) GOTO 105
           K = IOR(MASK(I-1),MASK(I))
           IF (K.NE.MASK(I)) GOTO 106
  101      CONTINUE
      K=IOR(MASK(INTP1),MASK(INTP1))
      IF (K.NE.MASK(INTP1)) GOTO 107
      WRITE (IOUT,110)
      IER=0
      RETURN
  102 WRITE (IOUT,111) IWDLNG,INTLNG,MSKDIM
      RETURN
  103 WRITE (IOUT,112) K
      RETURN
  104 WRITE (IOUT,113) K
      RETURN
  105 WRITE (IOUT,114)
      CALL MSKOUT(' ',0,I-1,0,IOUT)
      WRITE (IOUT,115)
      IM2=I-2
      CALL MSKOUT(' ',1,IM2,0,IOUT)
      WRITE (IOUT,116) K
      IF (I.GT.2) WRITE (IOUT,117) IM2
      RETURN
  106 WRITE (IOUT,114)
      IM2=I-2
      CALL MSKOUT(' ',1,IM2,0,IOUT)
      WRITE (IOUT,115)
      CALL MSKOUT(' ',0,I-1,0,IOUT)
      WRITE (IOUT,116) K
      IF (I.GT.2) WRITE (IOUT,117) IM2
      WRITE (IOUT,118)
      CALL MSKOUT(' ',0,I-1,0,IOUT)
      WRITE (IOUT,119)
      CALL MSKOUT(' ',1,I-2,0,IOUT)
      WRITE (IOUT,120)
      CALL MSKOUT(' ',1,I-2,0,IOUT)
      WRITE (IOUT,119)
      CALL MSKOUT(' ',0,I-1,0,IOUT)
      RETURN
  107 WRITE (IOUT,114)
      CALL MSKOUT(' ',0,INTLNG,0,IOUT)
      WRITE (IOUT,115)
      CALL MSKOUT(' ',0,INTLNG,0,IOUT)
      WRITE (IOUT,116) K
      WRITE (IOUT,117) INTLNG
      RETURN
  108 FORMAT('1NOW TESTING IOR.')
  109 FORMAT ('0WARNING.  BECAUSE YOUR FORTRAN DOES NOT USE AN ',
     1     'ENTIRE WORD WHEN'/
     2     ' COMPARING OR ASSIGNING INTEGERS, IOR WILL BE TESTED ',
     3     'ONLY WITH THE'/
     4     ' LOWER ',I2,' BITS.')
  110 FORMAT ('0FINISHED TESTING IOR.  IOR APPARENTLY WORKS.')
  111 FORMAT ('0ERROR IN TEST PACKAGE DETECTED IN TIOR.  THE WORD ',
     1     'LENGTH MUST BE AT'/
     2     ' LEAST 4.  THE NUMBER OF BITS IN INTEGER COMPARISONS ',
     3     'AND ASSIGNMENTS'/
     4     ' MUST BE AT LEAST 4 AND .LE. WORD LENGTH.  AN I2 FORMAT ',
     5     'CONSTRAINS THE'/
     6     ' WORD LENGTH TO BE .LT. 99.  THE DIMENSION OF THE MASK ',
     7     'MUST BE .GT. WORD'/
     8     ' LENGTH.'/
     9     ' IWDLNG=',I16,'.  INTLNG=',I16,'.'/
     +     ' MSKDIM=',I16,'.')
  112 FORMAT ('0IOR DID NOT SUCCESSFULLY .OR. 0 WITH 0.  IT RETURNED ',
     1     'THE BINARY'/
     2     ' EQUIVALENT OF ',I16,'.')
  113 FORMAT ('0IOR DID NOT SUCCESSFULLY .OR. 0011 BINARY WITH 1010 ',
     1     'BINARY.  IT'/
     2     ' RETURNED THE BINARY EQUIVALENT OF ,I16,10H.  IOR DID'/
     3     ' SUCCESSFULLY .OR. 0 WITH 0.')
  114 FORMAT ('0IOR DID NOT SUCCESSFULLY .OR.')
  115 FORMAT (' WITH')
  116 FORMAT (' IT RETURNED THE BINARY EQUIVALENT OF ',I16,'.  IOR ',
     1     'DID'/
     2     ' SUCCESSFULLY .OR. 0 WITH 0, AND 0011 BINARY WITH 1010 ',
     3     'BINARY.')
  117 FORMAT ('0IOR ALSO PASSED THE TEST OF .OR.ING WORDS CONTAINING ',
     1     'ONES IN THE LOW'/
     2     ' ORDER K BITS WITH WORDS CONTAINING ONES IN THE LOW ORDER',
     3     ' K-1 BITS, FOR'/
     4     ' K=1 TO ',I2,'.  THIS TEST WAS APPLIED COMMUTATIVELY, SO ',
     5     'THAT THE FIRST'/
     6     ' ARGUMENT TO IOR CONTAINED K ONES AND THE SECOND ',
     7     'CONTAINED K-1.  THEN'/
     8     ' IOR WAS CALLED AGAIN WITH THE FIRST ARGUMENT CONTAINING',
     9     ' K-1 ONES, AND'/
     +     ' THE SECOND K ONES.')
  118 FORMAT ('0FURTHER, IOR SUCCESSFULLY PASSED THE COMMUTATIVE TEST',
     1     ' OF THE ONE IT'/
     2     ' FAILED.  THAT IS, IT WORKED WHEN THE FIRST ARGUMENT TO ',
     3     'IOR WAS')
  119 FORMAT (' AND THE SECOND WAS')
  120 FORMAT (' IT FAILED WHEN THE FIRST ARGUMENT WAS')
      END

      SUBROUTINE ZLAEV2( A, B, C, RT1, RT2, CS1, SN1 )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     October 31, 1992
*
*     .. Scalar Arguments ..
      DOUBLE PRECISION   CS1, RT1, RT2
      COMPLEX*16         A, B, C, SN1
*     ..
*
*  Purpose
*  =======
*
*  ZLAEV2 computes the eigendecomposition of a 2-by-2 Hermitian matrix
*     [  A         B  ]
*     [  CONJG(B)  C  ].
*  On return, RT1 is the eigenvalue of larger absolute value, RT2 is the
*  eigenvalue of smaller absolute value, and (CS1,SN1) is the unit right
*  eigenvector for RT1, giving the decomposition
*
*  [ CS1  CONJG(SN1) ] [    A     B ] [ CS1 -CONJG(SN1) ] = [ RT1  0  ]
*  [-SN1     CS1     ] [ CONJG(B) C ] [ SN1     CS1     ]   [  0  RT2 ].
*
*  Arguments
*  =========
*
*  A      (input) COMPLEX*16
*         The (1,1) element of the 2-by-2 matrix.
*
*  B      (input) COMPLEX*16
*         The (1,2) element and the conjugate of the (2,1) element of
*         the 2-by-2 matrix.
*
*  C      (input) COMPLEX*16
*         The (2,2) element of the 2-by-2 matrix.
*
*  RT1    (output) DOUBLE PRECISION
*         The eigenvalue of larger absolute value.
*
*  RT2    (output) DOUBLE PRECISION
*         The eigenvalue of smaller absolute value.
*
*  CS1    (output) DOUBLE PRECISION
*  SN1    (output) COMPLEX*16
*         The vector (CS1, SN1) is a unit right eigenvector for RT1.
*
*  Further Details
*  ===============
*
*  RT1 is accurate to a few ulps barring over/underflow.
*
*  RT2 may be inaccurate if there is massive cancellation in the
*  determinant A*C-B*B; higher precision or correctly rounded or
*  correctly truncated arithmetic would be needed to compute RT2
*  accurately in all cases.
*
*  CS1 and SN1 are accurate to a few ulps barring over/underflow.
*
*  Overflow is possible only if RT1 is within a factor of 5 of overflow.
*  Underflow is harmless if the input data is 0 or exceeds
*     underflow_threshold / macheps.
*
* =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO
      PARAMETER          ( ZERO = 0.0D0 )
      DOUBLE PRECISION   ONE
      PARAMETER          ( ONE = 1.0D0 )
*     ..
*     .. Local Scalars ..
      DOUBLE PRECISION   T
      COMPLEX*16         W
*     ..
*     .. External Subroutines ..
      EXTERNAL           DLAEV2
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, DBLE, DCONJG
*     ..
*     .. Executable Statements ..
*
      IF( ABS( B ).EQ.ZERO ) THEN
         W = ONE
      ELSE
         W = DCONJG( B ) / ABS( B )
      END IF
      CALL DLAEV2( DBLE( A ), ABS( B ), DBLE( C ), RT1, RT2, CS1, T )
      SN1 = W*T
      RETURN
*
*     End of ZLAEV2
*
      END

C
C $Id: tdcurv.f,v 1.2 2008-07-27 00:17:32 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE TDCURV (UCRV,VCRV,WCRV,NCRV,IARH,ARHL,ARHW)
C
        DIMENSION UCRV(NCRV),VCRV(NCRV),WCRV(NCRV)
C
C Draw the projection of a curve in 3-space, as defined by the points
C (UCRV(I),VCRV(I),WCRV(I)), for I from 1 to NCRV.
C
C In addition, if IARH is non-zero, draw, at the end of the curve, the
C projection of a cone-shaped arrowhead of length ARHL and width ARHW.
C The magnitude of IARH is of the form NPAC+1000*NPCT, where NPAC is the
C number of points to be used to draw the circular base of the cone and
C NPCT is the number of points on the base to be connected to the tip.
C NPAC is forced to be 32 or greater and NPCT is forced to be NPAC/4 or
C greater; therefore, if you use IARH=1, you'll get NPAC=32 and NPCT=8.
C
C Check for an uncleared prior error.
C
        IF (ICFELL('TDCURV - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C Project the points of the curve, convert to the fractional coordinate
C system, and draw the curve using calls to the SPPS routine PLOTIF.
C
        DO 101 I=1,NCRV
          CALL TDPRPT (UCRV(I),VCRV(I),WCRV(I),XPOS,YPOS)
          CALL PLOTIF (CUFX(XPOS),CUFY(YPOS),MIN(I-1,1))
  101   CONTINUE
C
C Flush the point-draw buffers.
C
        CALL PLOTIF (0.,0.,2)
C
C If an arrowhead is to be drawn at the end of the curve, do that.
C
        IF (IARH.NE.0.AND.NCRV.GE.2) THEN
          NPAC=MAX(32,MOD(IARH,1000))
          NPCT=MAX(NPAC/4,IARH/1000)
          DNOM=SQRT((UCRV(NCRV)-UCRV(NCRV-1))**2+
     +              (VCRV(NCRV)-VCRV(NCRV-1))**2+
     +              (WCRV(NCRV)-WCRV(NCRV-1))**2)
          IF (DNOM.NE.0.) THEN
            UDCS=(UCRV(NCRV)-UCRV(NCRV-1))/DNOM
            VDCS=(VCRV(NCRV)-VCRV(NCRV-1))/DNOM
            WDCS=(WCRV(NCRV)-WCRV(NCRV-1))/DNOM
            UACC=UCRV(NCRV)-ARHL*UDCS
            VACC=VCRV(NCRV)-ARHL*VDCS
            WACC=WCRV(NCRV)-ARHL*WDCS
            CALL TDCONE (UACC,VACC,WACC,UDCS,VDCS,WDCS,ARHW/2.,NPAC,
     +                   NPCT,UCRV(NCRV),VCRV(NCRV),WCRV(NCRV))
          END IF
        END IF
C
C Done.
C
        RETURN
C
      END

C NCLFORTSTART
      subroutine buttfilt(xr,yr,er,fca,fcb,dt,m,n,mzer,ier)
      implicit none
c                                                  INPUT
      integer m, n, mzer, ier
      double precision xr(n), dt, fca,fcb
c
c                                                  OUTPUT
      double precision yr(n), er(n)
C NCLEND
c
c NCL: y  = bfband(x,m,fca,fcb,dt,iflag)            ; y(2,:)
C NCL: y  = dim_bfband_n(x,m,fca,fcb,dt,iflag,dims) ; y(...,:)
c
c ***Missing values not allowed***
c
c local
      integer k
      double precision ermx, f0, fc, fnyq
c
c initialize
c
      ier  = 0
      ermx = 1.0d0

      do k=1,n
         yr(k) = 1.0d20
         er(k) = 1.0d20
      end do

      f0   = (fca+fcb)*0.5d0
      fc   = abs(fca-f0) 
      fnyq = 1.0d0/(2.0d0*dt)

c.......error check on frequencies
      ier = 0
ccccc if ((f0-fc).le.0.0d0) then
      if (fca.le.0.0d0) then
          ier = 1
ccccc     write(6,*)'low corner frequency [fca=(f0-fc)] <= 0.0'
      endif
ccccc if ((f0+fc).ge.fnyq) then
      if (fcb.ge.fnyq) then
          ier = 2
ccccc     write(6,*)'high corner frequency [fcb=(f0+fc)] >= nyquist'
      endif
      if (ier.ne.0) return

      call bfilter(xr,yr,er,ermx,f0,fc,dt,m,n,mzer,ier)

      return
      end
       
c****************************
c Butterworth Filter
c****************************
      subroutine bfilter(xr,yr,er,ermx,f0,fc,dt,m,n,mzer,ier)
      implicit none
      integer m,n,mzer,ier
      double precision xr(n),yr(n),er(n),dt,ermx,f0,fc
c
c.......subroutine bfilter
c     Electronic Supplement to Development of a Time-Domain, Variable-Period 
c     Surface Wave Magnitude Procedure for Application at Regional and 
c     Teleseismic Distances, Part I: Theory; David R. Russell
c     Bulletin of the Seismological Society of America
c
c     http://www.seismosoc.org/publications/BSSA_html/bssa_96-2/05055-esupp/
c
c	Written by:  David R. Russell, AFTAC/TT 10 December 2004
c
c       Subroutine bfilter executes a fast, stable zero phase butterworth
c       bandpass filter of order (m), which is optimized for narrow band
c       applications.  The method produces a complex time series output,
c       of which the real portion is used to calculate the filtered time
c       series, and the modulus is used to calculate the envelope function.
c       Stability of the method is achieved by reducing the bandpass 
c       filter calculations to simple cascaded first order filters,
c       which are forward and reverse filtered for zero phase.  The method
c       also does a linear shift of a butterworth lowpass filter 
c       to an equivalent bandpass, without going through a standard
c       non-linear translation (Kanasewich, E.R., 1975) to bandpass. An option
c       is included to remove the signal mean initially to compensate for
c       large DC offsets
c         
c	INPUT:
c
c	m:      Order of Butterworth filter
c	n:      Number of input, output time series points
c       mzer:   Integer flag to remove mean (0 no, 1 yes)
c	xr(n):  Input (real) time series
c       f0:     Center value of bandpass filter
c       fc:     Corners of filter [ flow= f0-fc; fhigh= f0+fc ]
c       dt:     Time series sampling interval
c
c	OUTPUT:
c
c       yr(n):  Output filtered (real) time series
c	er(n):  Output envelope function for filtered time series
c       ermx:   Maximum value of envelope function er.
c       ier:    error code (DJS added)
c
c       LOCAL:

c       mmax = highest possible order of butterworth filter
c
c local 
      integer mmax,j,k
      double complex z1(n),z2(n)

      parameter (mmax=10)
      double complex a1(mmax),a2(mmax),a1c(mmax),a2c(mmax),p,s,ctemp
      double precision pi,w0,wc,w1,w2,dtemp,dtt,fnyq,xmean
c
c
      fnyq=1.0d0/(2.0d0*dt)
c
c.......initialize double precision pi, dtt, angular frequencies w0,wc
c
      pi=3.14159265358979d0
      w0=2.0d0*pi*f0
      wc=2.0d0*pi*fc
      dtt=dt
c
c.......prewarp frequencies for bilinear z-transform
c
      w1=w0-wc
      w2=w0+wc
      w1=2.0d0/dtt*dtan(w1*dtt/2.0d0)
      w2=2.0d0/dtt*dtan(w2*dtt/2.0d0)
      w0=(w1+w2)/2.0d0
      wc=(w2-w1)/2.0d0
c
c.......calculate (m) prototype lowpass poles (p), translate into bandpass
c       poles (s), calculate bilinear recursive coefficients (a1,a2),
c       conjugates of coefficients (a1c,a2c)
c
      do j=1,m
        dtemp=pi*(2.0d0*dble(j)-1.0d0+dble(m))/(2.0d0*dble(m))
        ctemp=dcmplx(0.0d0,dtemp)
        p=cdexp(ctemp)
        s=p*wc+dcmplx(0.0d0,w0)
        a1(j)=wc*dtt/(2.0d0-s*dtt)
        a2(j)=(2.0d0+s*dtt)/(2.0d0-s*dtt)
        a1c(j)=dconjg(a1(j))
        a2c(j)=dconjg(a2(j))
      enddo
c
c.......put real time series xr into complex series z1 and remove mean
c       if mzer set to 1
c
      xmean=0.0d0
      if(mzer.eq.1) then
        do k=1,n
          xmean=xmean+xr(k)
        enddo
        xmean=xmean/n
      endif
      do k=1,n
        z1(k)=xr(k)-xmean
      enddo
c
c.......calculate (m) cascaded first order complex filters
c 
      do j=1,m
        do k=1,n
          z2(k)=z1(k)
        enddo
        z1(1)=a1(j)*z2(1)
        do k=2,n
          z1(k)=a1(j)*(z2(k)+z2(k-1))+a2(j)*z1(k-1)
        enddo
      enddo
c
c.......reverse filtered time series
c
      do k=1,n
        z2(k)=z1(n-k+1)
      enddo
c
c.......calculate (m) cascaded first order complex filters on
c       reversed series - note conjugate bilinear coefficients
c       for complex conjugate of filter
c
      do j=1,m
        do k=1,n
          z1(k)=z2(k)
        enddo
        z2(1)=a1c(j)*z1(1)
        do k=2,n
          z2(k)=a1c(j)*(z1(k)+z1(k-1))+a2c(j)*z2(k-1)
        enddo
      enddo
c
c.......reverse filtered time series
c
      do k=1,n
        z1(k)=z2(n-k+1)
      enddo
c
c.......calculate real output time series (yr), envelope (er),
c       envelope maximum (ermx)
c
      ermx=0.0d0
      do k=1,n
        yr(k)=2.0d0*dreal(z1(k))
        er(k)=2.0d0*cdabs(z1(k))
        ermx=amax1(er(k),ermx)
      enddo
      return
      end

      SUBROUTINE SOPGTR( UPLO, N, AP, TAU, Q, LDQ, WORK, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER          UPLO
      INTEGER            INFO, LDQ, N
*     ..
*     .. Array Arguments ..
      REAL               AP( * ), Q( LDQ, * ), TAU( * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  SOPGTR generates a real orthogonal matrix Q which is defined as the
*  product of n-1 elementary reflectors H(i) of order n, as returned by
*  SSPTRD using packed storage:
*
*  if UPLO = 'U', Q = H(n-1) . . . H(2) H(1),
*
*  if UPLO = 'L', Q = H(1) H(2) . . . H(n-1).
*
*  Arguments
*  =========
*
*  UPLO    (input) CHARACTER*1
*          = 'U': Upper triangular packed storage used in previous
*                 call to SSPTRD;
*          = 'L': Lower triangular packed storage used in previous
*                 call to SSPTRD.
*
*  N       (input) INTEGER
*          The order of the matrix Q. N >= 0.
*
*  AP      (input) REAL array, dimension (N*(N+1)/2)
*          The vectors which define the elementary reflectors, as
*          returned by SSPTRD.
*
*  TAU     (input) REAL array, dimension (N-1)
*          TAU(i) must contain the scalar factor of the elementary
*          reflector H(i), as returned by SSPTRD.
*
*  Q       (output) REAL array, dimension (LDQ,N)
*          The N-by-N orthogonal matrix Q.
*
*  LDQ     (input) INTEGER
*          The leading dimension of the array Q. LDQ >= max(1,N).
*
*  WORK    (workspace) REAL array, dimension (N-1)
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ZERO, ONE
      PARAMETER          ( ZERO = 0.0E+0, ONE = 1.0E+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            UPPER
      INTEGER            I, IINFO, IJ, J
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           SORG2L, SORG2R, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX
*     ..
*     .. Executable Statements ..
*
*     Test the input arguments
*
      INFO = 0
      UPPER = LSAME( UPLO, 'U' )
      IF( .NOT.UPPER .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( LDQ.LT.MAX( 1, N ) ) THEN
         INFO = -6
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'SOPGTR', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
*
      IF( UPPER ) THEN
*
*        Q was determined by a call to SSPTRD with UPLO = 'U'
*
*        Unpack the vectors which define the elementary reflectors and
*        set the last row and column of Q equal to those of the unit
*        matrix
*
         IJ = 2
         DO 20 J = 1, N - 1
            DO 10 I = 1, J - 1
               Q( I, J ) = AP( IJ )
               IJ = IJ + 1
   10       CONTINUE
            IJ = IJ + 2
            Q( N, J ) = ZERO
   20    CONTINUE
         DO 30 I = 1, N - 1
            Q( I, N ) = ZERO
   30    CONTINUE
         Q( N, N ) = ONE
*
*        Generate Q(1:n-1,1:n-1)
*
         CALL SORG2L( N-1, N-1, N-1, Q, LDQ, TAU, WORK, IINFO )
*
      ELSE
*
*        Q was determined by a call to SSPTRD with UPLO = 'L'.
*
*        Unpack the vectors which define the elementary reflectors and
*        set the first row and column of Q equal to those of the unit
*        matrix
*
         Q( 1, 1 ) = ONE
         DO 40 I = 2, N
            Q( I, 1 ) = ZERO
   40    CONTINUE
         IJ = 3
         DO 60 J = 2, N
            Q( 1, J ) = ZERO
            DO 50 I = J + 1, N
               Q( I, J ) = AP( IJ )
               IJ = IJ + 1
   50       CONTINUE
            IJ = IJ + 2
   60    CONTINUE
         IF( N.GT.1 ) THEN
*
*           Generate Q(2:n,2:n)
*
            CALL SORG2R( N-1, N-1, N-1, Q( 2, 2 ), LDQ, TAU, WORK,
     $                   IINFO )
         END IF
      END IF
      RETURN
*
*     End of SOPGTR
*
      END

C
C       $Id: veldat.f,v 1.6 2008-07-27 00:17:34 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE VELDAT
C
C Calling this do-nothing subroutine forces "ld" to load the following
C block data routine (but only if they are in the same ".f" file).
C
        RETURN
C
      END
CNOSPLIT
      BLOCKDATA VELDATX
C
C THIS 'ROUTINE' DEFINES THE DEFAULT VALUES OF THE VELVCT PARAMETERS.
C
        SAVE
C
      COMMON /VEC1/   ASH        ,EXT        ,ICTRFG     ,ILAB       ,
     +                IOFFD      ,IOFFM      ,ISX        ,ISY        ,
     +                RMN        ,RMX        ,SIDE       ,SIZE       ,
     +                XLT        ,YBT        ,ZMN        ,ZMX
C
      COMMON /VEC2/   BIG        ,INCX       ,INCY
C
      DATA     EXT /    0.25 /
      DATA  ICTRFG /    1    /
      DATA    ILAB /    0    /
      DATA   IOFFD /    0    /
      DATA   IOFFM /    0    /
      DATA     RMN /  160.00 /
      DATA     RMX / 6400.00 /
      DATA    SIDE /    0.90 /
      DATA    SIZE /  256.00 /
      DATA     XLT /    0.05 /
      DATA     YBT /    0.05 /
      DATA     ZMX /    0.00 /
      DATA    INCX /    1     /
      DATA    INCY /    1     /
C
C REVISION HISTORY ----------------------------------------------------
C
C FEBRUARY, 1979   ADDED REVISION HISTORY
C                  MODIFIED CODE TO CONFORM TO FORTRAN 66 STANDARD
C
C JULY, 1979       FIXED HI VECTOR TRAP AND MESSAGE INDICATING
C                  MAXIMUM VECTOR PLOTTED.
C
C DECEMBER, 1979   CHANGED THE STATISTICS CALL FROM CRAYLIB TO NSSL
C
C MARCH, 1981      FIXED SOME FRINGE-CASE ERRORS, CHANGED THE CODE TO
C                  USE FL2INTT AND PLOTIT INSTEAD OF MXMY, FRSTPT, AND
C                  VECTOR, AND MADE THE ARROWHEADS NARROWER (45 DEGREES
C                  APART, RATHER THAN 60 DEGREES APART)
C
C FEBRUARY, 1984   PROVIDED A DIMENSION STATEMENT FOR A VARIABLE INTO
C                  WHICH A TEN-CHARACTER STRING WAS BEING ENCODED.  ON
C                  THE CRAY, WHEN THE ENCODE WAS DONE, A WORD FOLLOWING
C                  THE VARIABLE WAS CLOBBERED, BUT THIS APPARENTLY MADE
C                  NO DIFFERENCE.  ON AT LEAST ONE OTHER MACHINE, THE
C                  CODE BLEW UP.  (ERROR REPORTED BY GREG WOODS)
C
C JULY, 1984       CONVERTED TO FORTRAN77 AND GKS.
C
C MARCH, 1990      CORRECTED THE USE OF SET CALLS.
C
C ---------------------------------------------------------------------
      END

C
C	$Id: gqwkt.f,v 1.5 2008-07-27 00:21:01 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GQWKT(WKID,ERRIND,TUS,RWINDO,CWINDO,
     +                 RVIEWP,CVIEWP)
C
C  INQUIRE WORKSTATION TRANSFORMATION
C
      include 'gkscom.h'
C
      INTEGER WKID,ERRIND,TUS
      REAL    RWINDO(4),CWINDO(4),RVIEWP(4),CVIEWP(4)
C
C  Check if GKS is in the proper state.
C
      CALL GZCKST(7,-1,ERRIND)
      IF (ERRIND .NE. 0) GOTO 100
C
C  Check that the workstation identifier is valid.
C
      CALL GZCKWK(20,-1,WKID,IDUM,ERRIND)
      IF (ERRIND .NE. 0) GO TO 100
C
C  Check if the specified workstation is open.
C
      CALL GZCKWK(25,-1,WKID,IDUM,ERRIND)
      IF (ERRIND .NE. 0) GO TO 100
C
C  Check for invalid workstation categories.
C
      CALL GQWKC(WKID,ERRIND,ICONID,ITYPE)
      IF (ERRIND .NE. 0) GO TO 100
      CALL GQWKCA(ITYPE,ERRIND,ICAT)
      IF (ERRIND .NE. 0) GO TO 100
      IF (ICAT .EQ. GMI) THEN
        ERRIND = 33
        GO TO 100
      ELSE IF (ICAT .EQ. GWISS) THEN
        ERRIND = 36
        GO TO 100
      ENDIF
C
C  Invoke interface.
C
      FCODE = -202
      CONT  = 0
      CALL GZROI(0)
      IL1   = 1
      IL2   = 1
      ID(1) = WKID
      CALL GZIQWK(ITYPE,WKID)
      IF (RERR .NE. 0) THEN
        ERRIND = RERR
        GOTO 100
      ENDIF
      TUS = ID(2)
      RWINDO(1) = RX(1)
      RWINDO(2) = RX(2)
      RWINDO(3) = RX(3)
      RWINDO(4) = RX(4)
      CWINDO(1) = RX(5)
      CWINDO(2) = RX(6)
      CWINDO(3) = RX(7)
      CWINDO(4) = RX(8)
      RVIEWP(1) = RY(1)
      RVIEWP(2) = RY(2)
      RVIEWP(3) = RY(3)
      RVIEWP(4) = RY(4)
      CVIEWP(1) = RY(5)
      CVIEWP(2) = RY(6)
      CVIEWP(3) = RY(7)
      CVIEWP(4) = RY(8)
      RETURN
C
  100 CONTINUE
      TUS = -1
      RWINDO(1) = 0.
      RWINDO(2) = 0.
      RWINDO(3) = 0.
      RWINDO(4) = 0.
      CWINDO(1) = 0.
      CWINDO(2) = 0.
      CWINDO(3) = 0.
      CWINDO(4) = 0.
      RVIEWP(1) = 0.
      RVIEWP(2) = 0.
      RVIEWP(3) = 0.
      RVIEWP(4) = 0.
      CVIEWP(1) = 0.
      CVIEWP(2) = 0.
      CVIEWP(3) = 0.
      CVIEWP(4) = 0.
C
      RETURN
      END

C
C	$Id: ps.bkg_white.f,v 1.4 2008-07-27 00:59:05 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      PROGRAM BKGWHT
C
C  This Fortran code is a filter (reads from standard input, writes
C  to standard output) for PostScript files produced from the NCAR
C  Graphics package.  It reverses the intensity color values in a
C  PostScript file (the reversal applies only to gray scale values,
C  i.e. color values with R=G=B).  This filter is written as an ad
C  hoc solution to an incompatibility with PostScript files created
C  with NCAR CGM generators prior to Release 3.01.
C
      INTEGER      CTFLG,CRFLG
      CHARACTER*80 LIN,LOUT
C
      DATA EPS /0.00001/
   10 CONTINUE
C
C  Read an input line
C
      LIN = ' '
      READ(5,100,END=80) LIN
  100 FORMAT(A80)
C
C  Determine if this is a color table setting.
C
      CTFLG = 0
      DO 20 I=1,80
      IF (LIN(I:I) .EQ. ' ') THEN
        GO TO 20
      ELSE
        IF (LIN(I:I).EQ.'c' .AND. LIN(I+1:I+1).EQ.'t') THEN
          CTFLG = I
          GO TO 30
        ENDIF
      ENDIF
   20 CONTINUE
   30 CONTINUE
      IF (CTFLG .GT. 0) THEN
C
C  Determine if the color values represent a gray value.
C
        CALL CKGRY(LIN,EPS,CTFLG,CRFLG,IDX,R,G,B)
C
C  Encode the complemented color values in LOUT.
C
        IF (CRFLG.NE.0) THEN
          LOUT = ' '
          WRITE(LOUT,500) IDX, R,G,B
  500     FORMAT(' ct ',I3,' [',F5.3,' ',F5.3,' ',F5.3,'] put')
        ELSE
          LOUT = LIN
        ENDIF
      ELSE
          LOUT = LIN
      ENDIF
C
C  Trim blanks and write to output.
C
      KPOS = 1
      DO 110 I=80,1,-1
        IF (LOUT(I:I) .NE. ' ') THEN
          KPOS = I
          GO TO 120
        ENDIF
  110 CONTINUE
  120 CONTINUE
      WRITE(6,130) (LOUT(LL:LL),LL=1,KPOS)
  130 FORMAT(80A1)
C
      GO TO 10
C
   80 CONTINUE
      STOP
      END
      SUBROUTINE CKGRY(LIN,EPS,JFLG,IFLG,IDX,R,G,B)
C
C  Check if the input line in LIN contains a gray intensity value
C  (within the limits of EPS).  IFLG is 1 if a gray value is found;
C  IFLG is 0 otherwise.  If IFLG is 1, then IDX is the color index,
C  and R, G, and B are the complemented color vlaues.
C
      CHARACTER*80 LIN,CTMP
      REAL         EPS,COLORS(3)
C
      IFLG = 0
C
C  Determine the location of the left bracket.
C
      ICOL = 0
      DO 10 I=1,80
        IF (LIN(I:I) .EQ. '[') THEN
          ICOL = I
          GO TO 20
        ELSE
          IF (I .EQ. 80) GO TO 40
          GO TO 10
        ENDIF
   10 CONTINUE
   20 CONTINUE
C
C  Get the color index.
C
      READ(LIN(JFLG+2:ICOL-2),520) IDX
  520 FORMAT(I4)
C
C  Get the three color values.
C
      JSTRT = ICOL+1
      DO 50 I=1,3
        CTMP = ' '
        K = 0
        DO 60 J=JSTRT,80
          K = K+1
          IF (LIN(J:J).EQ.' ' .OR. LIN(J:J).EQ.']') THEN
            IF (K .GT. 1) THEN
              CTMP(1:K-1) = LIN(JSTRT:J-1)
            ELSE
              GO TO 40
            ENDIF
            GO TO 70
          ELSE
            GO TO 60
          ENDIF
   60   CONTINUE
   70   CONTINUE
        READ(CTMP(1:K-1),500) COLORS(I)
  500   FORMAT(F10.3)
        JSTRT = J+1
   50 CONTINUE
C
C  Determine if we have a gray value.
C
      IFLG = 0
      IF (ABS(COLORS(1)-COLORS(2)).LE.EPS .AND.
     -    ABS(COLORS(2)-COLORS(3)).LE.EPS) IFLG = 1
C
C  Complement the color values.
C
      IF (IFLG .EQ. 1) THEN
        DO 90 I =1,3
          IF (COLORS(I) .GT. .79) THEN
            COLORS(I) = 0.
          ELSE
            COLORS(I) = 1.-COLORS(I)
          ENDIF
   90   CONTINUE
        R = COLORS(1)
        G = COLORS(2)
        B = COLORS(3)
      ELSE
        GO TO 40
      ENDIF
C
   40 CONTINUE
      RETURN
      END

      SUBROUTINE DORGHR( N, ILO, IHI, A, LDA, TAU, WORK, LWORK, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      INTEGER            IHI, ILO, INFO, LDA, LWORK, N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), TAU( * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  DORGHR generates a real orthogonal matrix Q which is defined as the
*  product of IHI-ILO elementary reflectors of order N, as returned by
*  DGEHRD:
*
*  Q = H(ilo) H(ilo+1) . . . H(ihi-1).
*
*  Arguments
*  =========
*
*  N       (input) INTEGER
*          The order of the matrix Q. N >= 0.
*
*  ILO     (input) INTEGER
*  IHI     (input) INTEGER
*          ILO and IHI must have the same values as in the previous call
*          of DGEHRD. Q is equal to the unit matrix except in the
*          submatrix Q(ilo+1:ihi,ilo+1:ihi).
*          1 <= ILO <= IHI <= N, if N > 0; ILO=1 and IHI=0, if N=0.
*
*  A       (input/output) DOUBLE PRECISION array, dimension (LDA,N)
*          On entry, the vectors which define the elementary reflectors,
*          as returned by DGEHRD.
*          On exit, the N-by-N orthogonal matrix Q.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A. LDA >= max(1,N).
*
*  TAU     (input) DOUBLE PRECISION array, dimension (N-1)
*          TAU(i) must contain the scalar factor of the elementary
*          reflector H(i), as returned by DGEHRD.
*
*  WORK    (workspace/output) DOUBLE PRECISION array, dimension (LWORK)
*          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*
*  LWORK   (input) INTEGER
*          The dimension of the array WORK. LWORK >= IHI-ILO.
*          For optimum performance LWORK >= (IHI-ILO)*NB, where NB is
*          the optimal blocksize.
*
*          If LWORK = -1, then a workspace query is assumed; the routine
*          only calculates the optimal size of the WORK array, returns
*          this value as the first entry of the WORK array, and no error
*          message related to LWORK is issued by XERBLA.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO, ONE
      PARAMETER          ( ZERO = 0.0D+0, ONE = 1.0D+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            LQUERY
      INTEGER            I, IINFO, J, LWKOPT, NB, NH
*     ..
*     .. External Subroutines ..
      EXTERNAL           DORGQR, XERBLA
*     ..
*     .. External Functions ..
      INTEGER            ILAENV
      EXTERNAL           ILAENV
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN
*     ..
*     .. Executable Statements ..
*
*     Test the input arguments
*
      INFO = 0
      NH = IHI - ILO
      LQUERY = ( LWORK.EQ.-1 )
      IF( N.LT.0 ) THEN
         INFO = -1
      ELSE IF( ILO.LT.1 .OR. ILO.GT.MAX( 1, N ) ) THEN
         INFO = -2
      ELSE IF( IHI.LT.MIN( ILO, N ) .OR. IHI.GT.N ) THEN
         INFO = -3
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -5
      ELSE IF( LWORK.LT.MAX( 1, NH ) .AND. .NOT.LQUERY ) THEN
         INFO = -8
      END IF
*
      IF( INFO.EQ.0 ) THEN
         NB = ILAENV( 1, 'DORGQR', ' ', NH, NH, NH, -1 )
         LWKOPT = MAX( 1, NH )*NB
         WORK( 1 ) = LWKOPT
      END IF
*
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DORGHR', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 ) THEN
         WORK( 1 ) = 1
         RETURN
      END IF
*
*     Shift the vectors which define the elementary reflectors one
*     column to the right, and set the first ilo and the last n-ihi
*     rows and columns to those of the unit matrix
*
      DO 40 J = IHI, ILO + 1, -1
         DO 10 I = 1, J - 1
            A( I, J ) = ZERO
   10    CONTINUE
         DO 20 I = J + 1, IHI
            A( I, J ) = A( I, J-1 )
   20    CONTINUE
         DO 30 I = IHI + 1, N
            A( I, J ) = ZERO
   30    CONTINUE
   40 CONTINUE
      DO 60 J = 1, ILO
         DO 50 I = 1, N
            A( I, J ) = ZERO
   50    CONTINUE
         A( J, J ) = ONE
   60 CONTINUE
      DO 80 J = IHI + 1, N
         DO 70 I = 1, N
            A( I, J ) = ZERO
   70    CONTINUE
         A( J, J ) = ONE
   80 CONTINUE
*
      IF( NH.GT.0 ) THEN
*
*        Generate Q(ilo+1:ihi,ilo+1:ihi)
*
         CALL DORGQR( NH, NH, NH, A( ILO+1, ILO+1 ), LDA, TAU( ILO ),
     $                WORK, LWORK, IINFO )
      END IF
      WORK( 1 ) = LWKOPT
      RETURN
*
*     End of DORGHR
*
      END

      SUBROUTINE ZPPTRI( UPLO, N, AP, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     March 31, 1993
*
*     .. Scalar Arguments ..
      CHARACTER          UPLO
      INTEGER            INFO, N
*     ..
*     .. Array Arguments ..
      COMPLEX*16         AP( * )
*     ..
*
*  Purpose
*  =======
*
*  ZPPTRI computes the inverse of a complex Hermitian positive definite
*  matrix A using the Cholesky factorization A = U**H*U or A = L*L**H
*  computed by ZPPTRF.
*
*  Arguments
*  =========
*
*  UPLO    (input) CHARACTER*1
*          = 'U':  Upper triangular factor is stored in AP;
*          = 'L':  Lower triangular factor is stored in AP.
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  AP      (input/output) COMPLEX*16 array, dimension (N*(N+1)/2)
*          On entry, the triangular factor U or L from the Cholesky
*          factorization A = U**H*U or A = L*L**H, packed columnwise as
*          a linear array.  The j-th column of U or L is stored in the
*          array AP as follows:
*          if UPLO = 'U', AP(i + (j-1)*j/2) = U(i,j) for 1<=i<=j;
*          if UPLO = 'L', AP(i + (j-1)*(2n-j)/2) = L(i,j) for j<=i<=n.
*
*          On exit, the upper or lower triangle of the (Hermitian)
*          inverse of A, overwriting the input factor U or L.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*          > 0:  if INFO = i, the (i,i) element of the factor U or L is
*                zero, and the inverse could not be computed.
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ONE
      PARAMETER          ( ONE = 1.0D+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            UPPER
      INTEGER            J, JC, JJ, JJN
      DOUBLE PRECISION   AJJ
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      COMPLEX*16         ZDOTC
      EXTERNAL           LSAME, ZDOTC
*     ..
*     .. External Subroutines ..
      EXTERNAL           XERBLA, ZDSCAL, ZHPR, ZTPMV, ZTPTRI
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          DBLE
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      UPPER = LSAME( UPLO, 'U' )
      IF( .NOT.UPPER .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'ZPPTRI', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
*
*     Invert the triangular Cholesky factor U or L.
*
      CALL ZTPTRI( UPLO, 'Non-unit', N, AP, INFO )
      IF( INFO.GT.0 )
     $   RETURN
      IF( UPPER ) THEN
*
*        Compute the product inv(U) * inv(U)'.
*
         JJ = 0
         DO 10 J = 1, N
            JC = JJ + 1
            JJ = JJ + J
            IF( J.GT.1 )
     $         CALL ZHPR( 'Upper', J-1, ONE, AP( JC ), 1, AP )
            AJJ = AP( JJ )
            CALL ZDSCAL( J, AJJ, AP( JC ), 1 )
   10    CONTINUE
*
      ELSE
*
*        Compute the product inv(L)' * inv(L).
*
         JJ = 1
         DO 20 J = 1, N
            JJN = JJ + N - J + 1
            AP( JJ ) = DBLE( ZDOTC( N-J+1, AP( JJ ), 1, AP( JJ ), 1 ) )
            IF( J.LT.N )
     $         CALL ZTPMV( 'Lower', 'Conjugate transpose', 'Non-unit',
     $                     N-J, AP( JJN ), AP( JJ+1 ), 1 )
            JJ = JJN
   20    CONTINUE
      END IF
*
      RETURN
*
*     End of ZPPTRI
*
      END

      SUBROUTINE CTRSYL( TRANA, TRANB, ISGN, M, N, A, LDA, B, LDB, C,
     $                   LDC, SCALE, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          TRANA, TRANB
      INTEGER            INFO, ISGN, LDA, LDB, LDC, M, N
      REAL               SCALE
*     ..
*     .. Array Arguments ..
      COMPLEX            A( LDA, * ), B( LDB, * ), C( LDC, * )
*     ..
*
*  Purpose
*  =======
*
*  CTRSYL solves the complex Sylvester matrix equation:
*
*     op(A)*X + X*op(B) = scale*C or
*     op(A)*X - X*op(B) = scale*C,
*
*  where op(A) = A or A**H, and A and B are both upper triangular. A is
*  M-by-M and B is N-by-N; the right hand side C and the solution X are
*  M-by-N; and scale is an output scale factor, set <= 1 to avoid
*  overflow in X.
*
*  Arguments
*  =========
*
*  TRANA   (input) CHARACTER*1
*          Specifies the option op(A):
*          = 'N': op(A) = A    (No transpose)
*          = 'C': op(A) = A**H (Conjugate transpose)
*
*  TRANB   (input) CHARACTER*1
*          Specifies the option op(B):
*          = 'N': op(B) = B    (No transpose)
*          = 'C': op(B) = B**H (Conjugate transpose)
*
*  ISGN    (input) INTEGER
*          Specifies the sign in the equation:
*          = +1: solve op(A)*X + X*op(B) = scale*C
*          = -1: solve op(A)*X - X*op(B) = scale*C
*
*  M       (input) INTEGER
*          The order of the matrix A, and the number of rows in the
*          matrices X and C. M >= 0.
*
*  N       (input) INTEGER
*          The order of the matrix B, and the number of columns in the
*          matrices X and C. N >= 0.
*
*  A       (input) COMPLEX array, dimension (LDA,M)
*          The upper triangular matrix A.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A. LDA >= max(1,M).
*
*  B       (input) COMPLEX array, dimension (LDB,N)
*          The upper triangular matrix B.
*
*  LDB     (input) INTEGER
*          The leading dimension of the array B. LDB >= max(1,N).
*
*  C       (input/output) COMPLEX array, dimension (LDC,N)
*          On entry, the M-by-N right hand side matrix C.
*          On exit, C is overwritten by the solution matrix X.
*
*  LDC     (input) INTEGER
*          The leading dimension of the array C. LDC >= max(1,M)
*
*  SCALE   (output) REAL
*          The scale factor, scale, set <= 1 to avoid overflow in X.
*
*  INFO    (output) INTEGER
*          = 0: successful exit
*          < 0: if INFO = -i, the i-th argument had an illegal value
*          = 1: A and B have common or very close eigenvalues; perturbed
*               values were used to solve the equation (but the matrices
*               A and B are unchanged).
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ONE
      PARAMETER          ( ONE = 1.0E+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            NOTRNA, NOTRNB
      INTEGER            J, K, L
      REAL               BIGNUM, DA11, DB, EPS, SCALOC, SGN, SMIN,
     $                   SMLNUM
      COMPLEX            A11, SUML, SUMR, VEC, X11
*     ..
*     .. Local Arrays ..
      REAL               DUM( 1 )
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      REAL               CLANGE, SLAMCH
      COMPLEX            CDOTC, CDOTU, CLADIV
      EXTERNAL           LSAME, CLANGE, SLAMCH, CDOTC, CDOTU, CLADIV
*     ..
*     .. External Subroutines ..
      EXTERNAL           CSSCAL, SLABAD, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, AIMAG, CMPLX, CONJG, MAX, MIN, REAL
*     ..
*     .. Executable Statements ..
*
*     Decode and Test input parameters
*
      NOTRNA = LSAME( TRANA, 'N' )
      NOTRNB = LSAME( TRANB, 'N' )
*
      INFO = 0
      IF( .NOT.NOTRNA .AND. .NOT.LSAME( TRANA, 'T' ) .AND. .NOT.
     $    LSAME( TRANA, 'C' ) ) THEN
         INFO = -1
      ELSE IF( .NOT.NOTRNB .AND. .NOT.LSAME( TRANB, 'T' ) .AND. .NOT.
     $         LSAME( TRANB, 'C' ) ) THEN
         INFO = -2
      ELSE IF( ISGN.NE.1 .AND. ISGN.NE.-1 ) THEN
         INFO = -3
      ELSE IF( M.LT.0 ) THEN
         INFO = -4
      ELSE IF( N.LT.0 ) THEN
         INFO = -5
      ELSE IF( LDA.LT.MAX( 1, M ) ) THEN
         INFO = -7
      ELSE IF( LDB.LT.MAX( 1, N ) ) THEN
         INFO = -9
      ELSE IF( LDC.LT.MAX( 1, M ) ) THEN
         INFO = -11
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'CTRSYL', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( M.EQ.0 .OR. N.EQ.0 )
     $   RETURN
*
*     Set constants to control overflow
*
      EPS = SLAMCH( 'P' )
      SMLNUM = SLAMCH( 'S' )
      BIGNUM = ONE / SMLNUM
      CALL SLABAD( SMLNUM, BIGNUM )
      SMLNUM = SMLNUM*REAL( M*N ) / EPS
      BIGNUM = ONE / SMLNUM
      SMIN = MAX( SMLNUM, EPS*CLANGE( 'M', M, M, A, LDA, DUM ),
     $       EPS*CLANGE( 'M', N, N, B, LDB, DUM ) )
      SCALE = ONE
      SGN = ISGN
*
      IF( NOTRNA .AND. NOTRNB ) THEN
*
*        Solve    A*X + ISGN*X*B = scale*C.
*
*        The (K,L)th block of X is determined starting from
*        bottom-left corner column by column by
*
*            A(K,K)*X(K,L) + ISGN*X(K,L)*B(L,L) = C(K,L) - R(K,L)
*
*        Where
*                    M                        L-1
*          R(K,L) = SUM [A(K,I)*X(I,L)] +ISGN*SUM [X(K,J)*B(J,L)].
*                  I=K+1                      J=1
*
         DO 30 L = 1, N
            DO 20 K = M, 1, -1
*
               SUML = CDOTU( M-K, A( K, MIN( K+1, M ) ), LDA,
     $                C( MIN( K+1, M ), L ), 1 )
               SUMR = CDOTU( L-1, C( K, 1 ), LDC, B( 1, L ), 1 )
               VEC = C( K, L ) - ( SUML+SGN*SUMR )
*
               SCALOC = ONE
               A11 = A( K, K ) + SGN*B( L, L )
               DA11 = ABS( REAL( A11 ) ) + ABS( AIMAG( A11 ) )
               IF( DA11.LE.SMIN ) THEN
                  A11 = SMIN
                  DA11 = SMIN
                  INFO = 1
               END IF
               DB = ABS( REAL( VEC ) ) + ABS( AIMAG( VEC ) )
               IF( DA11.LT.ONE .AND. DB.GT.ONE ) THEN
                  IF( DB.GT.BIGNUM*DA11 )
     $               SCALOC = ONE / DB
               END IF
               X11 = CLADIV( VEC*CMPLX( SCALOC ), A11 )
*
               IF( SCALOC.NE.ONE ) THEN
                  DO 10 J = 1, N
                     CALL CSSCAL( M, SCALOC, C( 1, J ), 1 )
   10             CONTINUE
                  SCALE = SCALE*SCALOC
               END IF
               C( K, L ) = X11
*
   20       CONTINUE
   30    CONTINUE
*
      ELSE IF( .NOT.NOTRNA .AND. NOTRNB ) THEN
*
*        Solve    A' *X + ISGN*X*B = scale*C.
*
*        The (K,L)th block of X is determined starting from
*        upper-left corner column by column by
*
*            A'(K,K)*X(K,L) + ISGN*X(K,L)*B(L,L) = C(K,L) - R(K,L)
*
*        Where
*                   K-1                         L-1
*          R(K,L) = SUM [A'(I,K)*X(I,L)] + ISGN*SUM [X(K,J)*B(J,L)]
*                   I=1                         J=1
*
         DO 60 L = 1, N
            DO 50 K = 1, M
*
               SUML = CDOTC( K-1, A( 1, K ), 1, C( 1, L ), 1 )
               SUMR = CDOTU( L-1, C( K, 1 ), LDC, B( 1, L ), 1 )
               VEC = C( K, L ) - ( SUML+SGN*SUMR )
*
               SCALOC = ONE
               A11 = CONJG( A( K, K ) ) + SGN*B( L, L )
               DA11 = ABS( REAL( A11 ) ) + ABS( AIMAG( A11 ) )
               IF( DA11.LE.SMIN ) THEN
                  A11 = SMIN
                  DA11 = SMIN
                  INFO = 1
               END IF
               DB = ABS( REAL( VEC ) ) + ABS( AIMAG( VEC ) )
               IF( DA11.LT.ONE .AND. DB.GT.ONE ) THEN
                  IF( DB.GT.BIGNUM*DA11 )
     $               SCALOC = ONE / DB
               END IF
*
               X11 = CLADIV( VEC*CMPLX( SCALOC ), A11 )
*
               IF( SCALOC.NE.ONE ) THEN
                  DO 40 J = 1, N
                     CALL CSSCAL( M, SCALOC, C( 1, J ), 1 )
   40             CONTINUE
                  SCALE = SCALE*SCALOC
               END IF
               C( K, L ) = X11
*
   50       CONTINUE
   60    CONTINUE
*
      ELSE IF( .NOT.NOTRNA .AND. .NOT.NOTRNB ) THEN
*
*        Solve    A'*X + ISGN*X*B' = C.
*
*        The (K,L)th block of X is determined starting from
*        upper-right corner column by column by
*
*            A'(K,K)*X(K,L) + ISGN*X(K,L)*B'(L,L) = C(K,L) - R(K,L)
*
*        Where
*                    K-1
*           R(K,L) = SUM [A'(I,K)*X(I,L)] +
*                    I=1
*                           N
*                     ISGN*SUM [X(K,J)*B'(L,J)].
*                          J=L+1
*
         DO 90 L = N, 1, -1
            DO 80 K = 1, M
*
               SUML = CDOTC( K-1, A( 1, K ), 1, C( 1, L ), 1 )
               SUMR = CDOTC( N-L, C( K, MIN( L+1, N ) ), LDC,
     $                B( L, MIN( L+1, N ) ), LDB )
               VEC = C( K, L ) - ( SUML+SGN*CONJG( SUMR ) )
*
               SCALOC = ONE
               A11 = CONJG( A( K, K )+SGN*B( L, L ) )
               DA11 = ABS( REAL( A11 ) ) + ABS( AIMAG( A11 ) )
               IF( DA11.LE.SMIN ) THEN
                  A11 = SMIN
                  DA11 = SMIN
                  INFO = 1
               END IF
               DB = ABS( REAL( VEC ) ) + ABS( AIMAG( VEC ) )
               IF( DA11.LT.ONE .AND. DB.GT.ONE ) THEN
                  IF( DB.GT.BIGNUM*DA11 )
     $               SCALOC = ONE / DB
               END IF
*
               X11 = CLADIV( VEC*CMPLX( SCALOC ), A11 )
*
               IF( SCALOC.NE.ONE ) THEN
                  DO 70 J = 1, N
                     CALL CSSCAL( M, SCALOC, C( 1, J ), 1 )
   70             CONTINUE
                  SCALE = SCALE*SCALOC
               END IF
               C( K, L ) = X11
*
   80       CONTINUE
   90    CONTINUE
*
      ELSE IF( NOTRNA .AND. .NOT.NOTRNB ) THEN
*
*        Solve    A*X + ISGN*X*B' = C.
*
*        The (K,L)th block of X is determined starting from
*        bottom-left corner column by column by
*
*           A(K,K)*X(K,L) + ISGN*X(K,L)*B'(L,L) = C(K,L) - R(K,L)
*
*        Where
*                    M                          N
*          R(K,L) = SUM [A(K,I)*X(I,L)] + ISGN*SUM [X(K,J)*B'(L,J)]
*                  I=K+1                      J=L+1
*
         DO 120 L = N, 1, -1
            DO 110 K = M, 1, -1
*
               SUML = CDOTU( M-K, A( K, MIN( K+1, M ) ), LDA,
     $                C( MIN( K+1, M ), L ), 1 )
               SUMR = CDOTC( N-L, C( K, MIN( L+1, N ) ), LDC,
     $                B( L, MIN( L+1, N ) ), LDB )
               VEC = C( K, L ) - ( SUML+SGN*CONJG( SUMR ) )
*
               SCALOC = ONE
               A11 = A( K, K ) + SGN*CONJG( B( L, L ) )
               DA11 = ABS( REAL( A11 ) ) + ABS( AIMAG( A11 ) )
               IF( DA11.LE.SMIN ) THEN
                  A11 = SMIN
                  DA11 = SMIN
                  INFO = 1
               END IF
               DB = ABS( REAL( VEC ) ) + ABS( AIMAG( VEC ) )
               IF( DA11.LT.ONE .AND. DB.GT.ONE ) THEN
                  IF( DB.GT.BIGNUM*DA11 )
     $               SCALOC = ONE / DB
               END IF
*
               X11 = CLADIV( VEC*CMPLX( SCALOC ), A11 )
*
               IF( SCALOC.NE.ONE ) THEN
                  DO 100 J = 1, N
                     CALL CSSCAL( M, SCALOC, C( 1, J ), 1 )
  100             CONTINUE
                  SCALE = SCALE*SCALOC
               END IF
               C( K, L ) = X11
*
  110       CONTINUE
  120    CONTINUE
*
      END IF
*
      RETURN
*
*     End of CTRSYL
*
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C   FFTPACK 5.0
C   Copyright (C) 1995-2004, Scientific Computing Division,
C   University Corporation for Atmospheric Research
C   Licensed under the GNU General Public License (GPL)
C
C   Authors:  Paul N. Swarztrauber and Richard A. Valent
C
C   $Id: cosq1b.f,v 1.2 2006-11-21 01:10:16 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      SUBROUTINE DCOSQ1B(N,INC,X,LENX,WSAVE,LENSAV,WORK,LENWRK,IER)
      DOUBLE PRECISION SSQRT2
      DOUBLE PRECISION X1
      INTEGER N,INC,LENX,LENSAV,LENWRK,IER
      DOUBLE PRECISION X(INC,*),WSAVE(LENSAV),WORK(LENWRK)
C
      IER = 0
C
      IF (LENX.LT.INC* (N-1)+1) THEN
          IER = 1
          CALL DXERFFT('COSQ1B',6)
          GO TO 300
      ELSE IF (LENSAV.LT.2*N+INT(LOG(DBLE(N)))+4) THEN
          IER = 2
          CALL DXERFFT('COSQ1B',8)
          GO TO 300
      ELSE IF (LENWRK.LT.N) THEN
          IER = 3
          CALL DXERFFT('COSQ1B',10)
          GO TO 300
      END IF
C
      IF (N-2) 300,102,103
  102 SSQRT2 = 1.D0/SQRT(2.D0)
      X1 = X(1,1) + X(1,2)
      X(1,2) = SSQRT2* (X(1,1)-X(1,2))
      X(1,1) = X1
      RETURN
  103 CALL DCOSQB1(N,INC,X,WSAVE,WORK,IER1)
      IF (IER1.NE.0) THEN
          IER = 20
          CALL DXERFFT('COSQ1B',-5)
      END IF
C
  300 RETURN
      END

C
C $Id: pj19dp.f,v 1.5 2008-07-27 00:17:11 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE PJ19DP (COORD,CRDIO,INDIC)
C
C -- V A N   D E R   G R I N T E N   I
C
      IMPLICIT DOUBLE PRECISION (A-Z)
      INTEGER INDIC
      DIMENSION GEOG(2),PROJ(2),COORD(2),CRDIO(2)
C **** PARAMETERS **** A,LON0,X0,Y0 ************************************
      COMMON /ERRMZ0/ IERR
        INTEGER IERR
      SAVE   /ERRMZ0/
      COMMON /PRINZ0/ IPEMSG,IPELUN,IPPARM,IPPLUN
        INTEGER IPEMSG,IPELUN,IPPARM,IPPLUN
      SAVE   /PRINZ0/
      COMMON /PC19DP/ A,LON0,X0,Y0
      DATA PI /3.14159265358979323846D0/
      DATA HALFPI /1.5707963267948966D0/
      DATA EPSLN/1.0D-10/
      DATA ZERO,HALF,ONE,TWO,THREE/0.0D0,0.5D0,1.0D0,2.0D0,3.0D0/
C
C -- F O R W A R D   . . .
C
      IF (INDIC .EQ. 0) THEN
C
         GEOG(1) = COORD(1)
         GEOG(2) = COORD(2)
         IERR = 0
         LON = ADJLDP (GEOG(1) - LON0)
         LAT = GEOG(2)
         IF (ABS(LAT) .GT. EPSLN) GO TO 140
         PROJ(1) = X0 + A * LON
         PROJ(2) = Y0
         CRDIO(1) = PROJ(1)
         CRDIO(2) = PROJ(2)
         RETURN
  140    THETA = ASINDP (MIN(ABS (LAT /HALFPI),ONE))
         IF (ABS(LON).GT.EPSLN.AND.ABS(ABS(LAT)-HALFPI).GT.EPSLN)
     .       GO TO 160
         PROJ(1) = X0
         PROJ(2) = Y0 + PI * A * SIGN( TAN (HALF * THETA), LAT)
         CRDIO(1) = PROJ(1)
         CRDIO(2) = PROJ(2)
         RETURN
  160    AL = HALF * ABS (PI / LON - LON / PI)
         ASQ = AL * AL
         SINTHT = SIN (THETA)
         COSTHT = COS (THETA)
         G = COSTHT / (SINTHT + COSTHT - ONE)
         GSQ = G * G
         M = G * (TWO / SINTHT - ONE)
         MSQ = M * M
         CON = PI * A * (AL * (G - MSQ) + SQRT (ASQ * (G - MSQ)**2 -
     .         (MSQ + ASQ) * (GSQ - MSQ))) / (MSQ + ASQ)
         CON = SIGN (CON , LON)
         PROJ(1) = X0 + CON
         CON = ABS (CON / (PI * A))
         PROJ(2)=Y0+SIGN(PI*A*SQRT(MAX(ZERO,ONE-CON*CON
     .                                                -TWO*AL*CON)),LAT)
         CRDIO(1) = PROJ(1)
         CRDIO(2) = PROJ(2)
         RETURN
      END IF
C
C -- I N V E R S E   . . .
C
C ---------------------------------------------------------------------
C     ALGORITHM DEVELOPED BY D.P. RUBINCAM, THE AMERICAN CARTOGRAPHER,
C                1981, V. 8, NO. 2, P. 177-180.
C ---------------------------------------------------------------------
C
      IF (INDIC .EQ. 1) THEN
C
         PROJ(1) = COORD(1)
         PROJ(2) = COORD(2)
         IERR = 0
         X = PROJ(1) - X0
         Y = PROJ(2) - Y0
         CON = PI * A
         XX = X / CON
         YY = Y / CON
         XYS = XX * XX + YY * YY
         C1 = -ABS(YY) * (ONE + XYS)
         C2 = C1 - TWO * YY * YY + XX * XX
         C3 = -TWO * C1 + ONE + TWO * YY * YY + XYS*XYS
         D = YY * YY / C3 + (TWO * C2 * C2 * C2/ C3/ C3/ C3 - 9.0D0 * C1
     .       * C2/ C3/ C3) / 27.0D0
         A1 = (C1 - C2 * C2/ THREE/ C3)/ C3
         M1 = TWO * SQRT(-A1/ THREE)
         CON = ((THREE * D) / A1) / M1
         IF (ABS(CON).GT.ONE) CON = SIGN(ONE,CON)
         TH1 = ACOS(CON)/THREE
         GEOG(2) = (-M1 * COS(TH1 + PI/ THREE) - C2/ THREE/ C3)
     .   * SIGN(PI,Y)
         IF (ABS(XX).GE.EPSLN) GO TO 230
         GEOG(1) = LON0
         CRDIO(1) = GEOG(1)
         CRDIO(2) = GEOG(2)
         RETURN
  230    CONTINUE
         GEOG(1) = LON0 + PI * (XYS - ONE + SQRT(ONE + TWO * (XX * XX
     .      - YY * YY) + XYS * XYS))/ TWO/ XX
         CRDIO(1) = GEOG(1)
         CRDIO(2) = GEOG(2)
         RETURN
      END IF
C
      END

C NCLFORTSTART
      subroutine spareapolyi(vlat,vlon,nv,rad,area)
      implicit none
c input
      integer nv
      double precision  vlat(nv), vlon(nv), rad
c output
      double precision  area
C NCLEND
c local 
      integer npts

c Are beginning and end pts the same?
c If so, pass one less value. spareapoly wants no duplicate pts.

      npts = nv
      if (vlat(1).eq.vlat(nv) .and. vlon(1).eq.vlon(nv)) then
          npts = nv-1
      end if
      call spareapoly(vlat,vlon,npts,rad,area)

      return
      end
      
c --------------
      subroutine spareapoly(vlat,vlon,nv,rad,area)
      implicit none
c input
      integer nv
      double precision  vlat(nv), vlon(nv), rad
c output
      double precision  area

C*************************************************************
C Computing the Area of a Spherical Polygon of Arbitrary Shape
C     Bevis and Cambareri (1987)
C     Mathematical Geology, vol.19, Issue 4, pp 335-346 
C*************************************************************
c Computes the area of a spherical polygon with nv vertices and sides.

c ARGUMENTS:
c vlat,vlon ...  vectors containing the latitude and longitude
c                of each vertex.  The ith.  vertex is located at 
c                [vlat(i),vlon(i)].
c nv        ...  the number of vertices and sides in the spherical
c                polygon
c rad       ...  the radius of the sphere

c area      ...  the area of the spherical polygon

c UNITS:
c   Latitudes and longitudes are specified in degrees.  The user selects
c   the units of length in which to specify the radius, and the polygon
c   area will be returned in the square of these units.
c SIGN CONVENTION:
c   Latitudes are positive to the north and negative to the south.
c   Longitudes are positive to the east and negative to the west.
c VERTEX ENUMERATION: 
c   The vertices are numbered sequentially around the border of the
c   spherical polygon.  Vertex 1 lies between vertex nv and vertex 2.
c   The user must follow the convention whereby in moving around the
c   polygon border in the direction of increasing vertex number clockwise
c   bends occur at salient vertices.  A vertex is salient if the interior
c   angle'is less than 180 degrees.  (In the case of a convex polygon
c   this convention implies that the vertices are numbered in clockwise
c   sequence).
c
c   Two adjacent vertices may never be exactly 180 degrees apart
c   because they could be connected by infinitely many different
c   great circle arcs, and thus the border of the spherical
c   polygon would not be uniquely defined.  


c local
      integer iv
      double precision  pi, twopi, suma
      double precision  flat, flon, blat, blon, fang, bang, fvb
      parameter (pi=3.141592654d0, twopi=2.0d0*pi)

      suma = 0.0d0
      do iv=1,nv
         if (iv.eq.1) then
             flat=vlat(2)
             flon=vlon(2)
             blat=vlat(nv)
             blon=vlon(nv)
         elseif (iv.lt.nv) then
             flat=vlat(iv+1)
             flon=vlon(iv+1)
             blat=vlat(iv-1)
             blon=vlon(iv-1)
         else
             flat=vlat(1)
             flon=vlon(1)
             blat=vlat(nv-1)
             blon=vlon(nv-1)
         end if 
      
         call trnsfrmlon (vlat(iv),vlon(iv),flat,flon,fang)
         call trnsfrmlon (vlat(iv),vlon(iv),blat,blon,bang) 

         fvb = bang-fang
         if (fvb.lt. 0.0d0) fvb = fvb+twopi
         suma = suma+fvb
      end do

      area = (suma-pi*(nv-2))*rad**2

      return
      end
c --- 
      subroutine trnsfrmlon(plat,plon,qlat,qlon,tranlon)
      implicit none
c Finds the "longitude" of point Q in a geographic coordinate system
c  for which point P acts as a "north pole'.
c input
c   plat,plon,qlat,qlon ....  degrees
c output
c   tranlon ... radians
c input
      double precision plat,plon,qlat,qlon
c output
      double precision tranlon
c local
      double precision pi, dtr, tt, bb
      parameter (pi=3.141592654d0,dtr=pi/180.0d0)

      tt = sin((qlon-plon)*dtr)*cos(qlat*dtr)

      bb = sin(qlat*dtr)*cos(plat*dtr)-cos(qlat*dtr)*sin(plat*dtr)   
     &    *cos((qlon-plon)*dtr)

      tranlon = atan2(tt,bb)

      return
      end 

      SUBROUTINE PASSB5(IDO,L1,CC,CH,WA1,WA2,WA3,WA4)
      DOUBLE PRECISION CC
      DOUBLE PRECISION CH
      DOUBLE PRECISION WA1
      DOUBLE PRECISION WA2
      DOUBLE PRECISION WA3
      DOUBLE PRECISION WA4
      DOUBLE PRECISION TR11
      DOUBLE PRECISION TI11
      DOUBLE PRECISION TR12
      DOUBLE PRECISION TI12
      DOUBLE PRECISION TI5
      DOUBLE PRECISION TI2
      DOUBLE PRECISION TI4
      DOUBLE PRECISION TI3
      DOUBLE PRECISION TR5
      DOUBLE PRECISION TR2
      DOUBLE PRECISION TR4
      DOUBLE PRECISION TR3
      DOUBLE PRECISION CR2
      DOUBLE PRECISION CI2
      DOUBLE PRECISION CR3
      DOUBLE PRECISION CI3
      DOUBLE PRECISION CR5
      DOUBLE PRECISION CI5
      DOUBLE PRECISION CR4
      DOUBLE PRECISION CI4
      DOUBLE PRECISION DR3
      DOUBLE PRECISION DR4
      DOUBLE PRECISION DI3
      DOUBLE PRECISION DI4
      DOUBLE PRECISION DR5
      DOUBLE PRECISION DR2
      DOUBLE PRECISION DI5
      DOUBLE PRECISION DI2
      DIMENSION CC(IDO,5,L1),CH(IDO,L1,5),WA1(*),WA2(*),WA3(*),WA4(*)
      DATA TR11,TI11,TR12,TI12/.309016994374947D0,.951056516295154D0,
     +     -.809016994374947D0,.587785252292473D0/

      IF (IDO.NE.2) GO TO 102
      DO 101 K = 1,L1
          TI5 = CC(2,2,K) - CC(2,5,K)
          TI2 = CC(2,2,K) + CC(2,5,K)
          TI4 = CC(2,3,K) - CC(2,4,K)
          TI3 = CC(2,3,K) + CC(2,4,K)
          TR5 = CC(1,2,K) - CC(1,5,K)
          TR2 = CC(1,2,K) + CC(1,5,K)
          TR4 = CC(1,3,K) - CC(1,4,K)
          TR3 = CC(1,3,K) + CC(1,4,K)
          CH(1,K,1) = CC(1,1,K) + TR2 + TR3
          CH(2,K,1) = CC(2,1,K) + TI2 + TI3
          CR2 = CC(1,1,K) + TR11*TR2 + TR12*TR3
          CI2 = CC(2,1,K) + TR11*TI2 + TR12*TI3
          CR3 = CC(1,1,K) + TR12*TR2 + TR11*TR3
          CI3 = CC(2,1,K) + TR12*TI2 + TR11*TI3
          CR5 = TI11*TR5 + TI12*TR4
          CI5 = TI11*TI5 + TI12*TI4
          CR4 = TI12*TR5 - TI11*TR4
          CI4 = TI12*TI5 - TI11*TI4
          CH(1,K,2) = CR2 - CI5
          CH(1,K,5) = CR2 + CI5
          CH(2,K,2) = CI2 + CR5
          CH(2,K,3) = CI3 + CR4
          CH(1,K,3) = CR3 - CI4
          CH(1,K,4) = CR3 + CI4
          CH(2,K,4) = CI3 - CR4
          CH(2,K,5) = CI2 - CR5
  101 CONTINUE
      RETURN
  102 DO 104 K = 1,L1
          DO 103 I = 2,IDO,2
              TI5 = CC(I,2,K) - CC(I,5,K)
              TI2 = CC(I,2,K) + CC(I,5,K)
              TI4 = CC(I,3,K) - CC(I,4,K)
              TI3 = CC(I,3,K) + CC(I,4,K)
              TR5 = CC(I-1,2,K) - CC(I-1,5,K)
              TR2 = CC(I-1,2,K) + CC(I-1,5,K)
              TR4 = CC(I-1,3,K) - CC(I-1,4,K)
              TR3 = CC(I-1,3,K) + CC(I-1,4,K)
              CH(I-1,K,1) = CC(I-1,1,K) + TR2 + TR3
              CH(I,K,1) = CC(I,1,K) + TI2 + TI3
              CR2 = CC(I-1,1,K) + TR11*TR2 + TR12*TR3
              CI2 = CC(I,1,K) + TR11*TI2 + TR12*TI3
              CR3 = CC(I-1,1,K) + TR12*TR2 + TR11*TR3
              CI3 = CC(I,1,K) + TR12*TI2 + TR11*TI3
              CR5 = TI11*TR5 + TI12*TR4
              CI5 = TI11*TI5 + TI12*TI4
              CR4 = TI12*TR5 - TI11*TR4
              CI4 = TI12*TI5 - TI11*TI4
              DR3 = CR3 - CI4
              DR4 = CR3 + CI4
              DI3 = CI3 + CR4
              DI4 = CI3 - CR4
              DR5 = CR2 + CI5
              DR2 = CR2 - CI5
              DI5 = CI2 - CR5
              DI2 = CI2 + CR5
              CH(I-1,K,2) = WA1(I-1)*DR2 - WA1(I)*DI2
              CH(I,K,2) = WA1(I-1)*DI2 + WA1(I)*DR2
              CH(I-1,K,3) = WA2(I-1)*DR3 - WA2(I)*DI3
              CH(I,K,3) = WA2(I-1)*DI3 + WA2(I)*DR3
              CH(I-1,K,4) = WA3(I-1)*DR4 - WA3(I)*DI4
              CH(I,K,4) = WA3(I-1)*DI4 + WA3(I)*DR4
              CH(I-1,K,5) = WA4(I-1)*DR5 - WA4(I)*DI5
              CH(I,K,5) = WA4(I-1)*DI5 + WA4(I)*DR5
  103     CONTINUE
  104 CONTINUE
      RETURN
      END

C
C $Id: basic02f.f,v 1.15 2010-03-15 22:49:23 haley Exp $
C
C***********************************************************************
C                                                                      *
C                            Copyright (C)  1995                       *
C                 University Corporation for Atmospheric Research      *
C                            All Rights Reserved                       *
C                                                                      *
C***********************************************************************
C
C      File:            basic02f.f
C
C      Author:          Tim Scheitlin (converted by Ed Stautler)
C                       National Center for Atmospheric Research
C                       PO 3000, Boulder, Colorado
C
C      Date:            Mon Mar 20 10:43:42 MST 1995
C
C      Description:     The first frame in this example demonstrates how
C                       to set the view port for a contour plot.
C                       Note: no data is used in this example, so the
C                       output appears only as a bounding box with
C                       tickmarks.
C
C                       The second frame in this example demonstrates how
C                       to produce multiple plots on a single frame.
C
      program basic02f
      implicit none

      external NhlFAppClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFCairoWindowWorkstationClass
      external NhlFContourPlotClass

      integer appid,wks,con1,rlist,ierr
      character*7  wks_type
C
C Define the workstation type
C
      wks_type = "x11"
C
C Initialize the graphics libraries and create a resource list that
C is normally used to assign name/value pairs within objects.  Then
C clear (empty) this list, and create an application object.  This
C object manages multiple resource databases used by separate objects.
C
      call NhlFInitialize
      call NhlFRLCreate(rlist,'SETRL')

      call NhlFRLClear(rlist)
      call NhlFCreate(appid,"basic02",NhlFAppClass,0,rlist,ierr)
C
C ###########
C # FRAME 1 #
C ###########
C Choose the type of output you want to create.  You may write your
C output to an NCGM, file, X workstation window, or a PostScript file. 
C 

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkMetaName','./basic02f.ncgm',ierr)
         call NhlFCreate(wks,"wks",NhlFNcgmWorkstationClass,0,
     1        rlist,ierr)
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPause','True',ierr)
         call NhlFCreate(wks,"wks",
     +        NhlFCairoWindowWorkstationClass,0,
     1        rlist,ierr)
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PostScript workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPSFileName','./basic02f.ps',ierr)
         call NhlFCreate(wks,"wks",NhlFPSWorkstationClass,0,
     1        rlist,ierr)
C
C Create an older-style PDF workstation.
C
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPDFFileName','./basic02f.pdf',
     1        ierr)
         call NhlFCreate(wks,"wks",NhlFPDFWorkstationClass,0,
     1        rlist,ierr)
C
C Create a cairo PS/PDF object.
C
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     1         wks_type.eq."ps".or.wks_type.eq."PS") then
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkFileName','./basic02f',
     1        ierr)
         call NhlFRLSetstring(rlist,'wkFormat',wks_type,
     1        ierr)
         call NhlFCreate(wks,"wks",NhlFCairoPSPDFWorkstationClass,0,
     1        rlist,ierr)
C
C Create a cairo PNG object.
C
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkFileName','./basic02f',
     1        ierr)
         call NhlFRLSetstring(rlist,'wkFormat',wks_type,
     1        ierr)
         call NhlFCreate(wks,"wks",NhlFCairoImageWorkstationClass,0,
     1        rlist,ierr)
      endif
C
C
C Create a plot object.  In this example, we will create a contour plot.
C
C Four view class resources, vpXF, vpYF, vpWidthF, and vpHeightF, are
C assigned values in the following create call.  The combination of
C these four resources determines where the plot will display in the
C output window.  The values of these resources are specified in 
C Normalized Device Coordinates (NDCs).  In this two-dimensional
C coordinate system (0,0) specifies the lower-left corner and (1,1)
C specifies the upper-right corner of a plot.

      call NhlFRLClear(rlist)
      call NhlFRLSetFloat(rlist,"vpXF",0.05,ierr) 
      call NhlFRLSetFloat(rlist,"vpYF",0.95,ierr) 
      call NhlFRLSetFloat(rlist,"vpWidthF",0.4,ierr) 
      call NhlFRLSetFloat(rlist,"vpHeightF",0.4,ierr) 
      call NhlFCreate(con1,"con1",NhlFContourPlotClass,wks,
     $     rlist,ierr)
C
C Draw the plot. 
C
      call NhlFDraw(con1,ierr)
C
C The frame call updates and then clears the workstation.
C Anything written to the workstation after a frame call is made will be
C drawn in a subsequent frame. 
C
      call NhlFFrame(wks,ierr)
C
C ###########
C # FRAME 2 #
C ###########
C
C This example demonstrates drawing multiple plots in a single frame.
C
C Calling draw again will produce the identical plot that was drawn in
C the first frame.
C
      call NhlFDraw(con1,ierr)
C
C To add another plot to the same frame, we first need to reset the 
C viewport resources so that the next plot does not overwrite the first
C one.  The setvalues expression is used to set resources after an object
C has already been created.  The first argument, "con1", in the setvalues
C expression specifies an object id of a plot that was generated earlier
C with the create call.  This is then followed by a list of resource
C value pairs that apply to the object.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetFloat(rlist,"vpXF",0.55,ierr) 
      call NhlFRLSetFloat(rlist,"vpYF",0.45,ierr) 
      call NhlFRLSetFloat(rlist,"vpWidthF",0.2,ierr) 
      call NhlFRLSetFloat(rlist,"vpHeightF",0.2,ierr) 
      call NhlFSetValues(con1,rlist,ierr)
C
C Because of the new viewport resource settings, calling draw produces 
C a plot in the lower-right quadrant of the frame.
C
      call NhlFDraw(con1,ierr)
C
C Updates and clear the workstation.
C
      call NhlFFrame(wks,ierr)
C
C Clean up (destroying the parent object recursively destroys all of its 
C children).
C
      call NhlFDestroy(con1,ierr)
      call NhlFClose

      stop
      end

C
C	$Id: fftbkd.f,v 1.5 2008-07-27 12:23:42 haley Exp $
C                                                                      
C			     Copyright (C)  1997
C	     University Corporation for Atmospheric Research
C			     All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE FFTBKD
C
C Calling this do-nothing subroutine forces "ld" to load the following
C block data routine (but only if they are in the same ".f" file).
C
        RETURN
C
      END
CNOSPLIT
      BLOCKDATA FFTBKDX
C
      include 'fntcom.h'
C
C  Data for the fontcap preprocessing for the filled fonts.
C
C  Error numbers.
C      EEOF   -- Unexpected EOF encountered.
C      ERED   -- Error reading file.
C      EINM   -- Invalid font name.
C      EORD   -- Invalid fontcap ordering.
C      EXWD   -- X coordinates too large to encode.
C      EYWD   -- Y coordinates too large to encode.
C      ESWD   -- Special value flags too large to encode.
C
      DATA EEOF,ERED,EINM,EORD,EXWD,EYWD,ESWD/1,2,3,4,5,6,7/
C
C  List all possible fontcap keywords in sequence.
C
      DATA KEYLST/'FONT_NAME           ',
     +            'CHARACTER_START     ',
     +            'CHARACTER_END       ',
     +            'FONT_RIGHT          ',
     +            'FONT_TOP            ',
     +            'FONT_CAP_OVERSHOOT  ',
     +            'FONT_CAP            ',
     +            'FONT_X-HEIGHT_OVERSH',
     +            'FONT_X-HEIGHT       ',
     +            'FONT_HALF           ',
     +            'FONT_BASE           ',
     +            'FONT_BOTTOM         ',
     +            'FONT_CAP_HORIZONTAL_',
     +            'FONT_CAP_VERTICAL_ST',
     +            'FONT_BOUNDING_BOX   ', 
     +            'FONT_EXTENDED_BOUNDI'/
C
C  Legal font names.
C
      DATA FNTNMS/'NCAR:HELVETICA                          ',
     +            'NCAR:HELVETICA-BOLD                     ',
     +            'NCAR:TIMES-ROMAN                        ',
     +            'NCAR:TIMES-BOLD                         ',
     +            'NCAR:COURIER                            ',
     +            'NCAR:COURIER-BOLD                       ',
     +            'NCAR:GREEK                              ',
     +            'NCAR:MATH-SYMBOLS                       ',
     +            'NCAR:TEXT-SYMBOLS                       ',
     +            'NCAR:WEATHER1                           ',
     +            'NCAR:WEATHER2                           ',
     +            'NCAR:TEST                               '/
C
C  Specify the Fortran logical unit number for I/O.
C
      DATA UNIT/1/
C
C  Blank line.
C
      DATA BLNKL/'                                                     
     +                          '/
C
C  Special value flags (SVNUM is the number of special value flags).
C
      DATA SVNUM/7/
      DATA COORD, ENDR, BEGINH, ENDH, BEZIER, ENDC, BEGINC, ENDL
     +    /    0,    1,      2,    3,      4,    5,      6,    7/       
C
C  Verbose flag.
C
      DATA VERBOS/0/
      END

C
C $Id: slrset.f,v 1.4 2008-07-27 00:17:27 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE SLRSET
C
C This routine, when called, restores the default values of the
C internal parameters of STITLE.
C
C The common block SLCOMN holds all of the internal parameters of
C the package STITLE except for color-table parameters.
C
        COMMON /SLCOMN/ GPSZ,IBGC,IBGF,ICOP,IDOT,IFGC,IFGF,IJMP,IMAP,
     +                  INCU,IWLU,IWRK,IWWI,IXND,IXST,OORV,PCSZ,RNFS,
     +                  RVPB,RVPL,RVPR,RVPT,TFIN,TFOU,TGP1,TGP2,TGP3
        SAVE   /SLCOMN/
C
C The common block SLCLRS holds color-table parameters.
C
        COMMON /SLCLRS/ CRED(256),CGRN(256),CBLU(256),LOCI(256),NOCI
        SAVE   /SLCLRS/
C
C Check for an uncleared prior error.
C
        IF (ICFELL('SLRSET - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C Do it.
C
        GPSZ=40.
        IBGC=0
        IBGF=-2
        ICOP=1
        IDOT=0
        IFGC=1
        IFGF=-2
        IJMP=300
        IMAP=100
        INCU=5
        IWLU=4
        IWRK=-1
        IWWI=9
        NOCI=0
        IXND=512
        IXST=512
        OORV=1.E12
        PCSZ=21.
        RNFS=24.
        RVPB=0.
        RVPL=0.
        RVPR=1.
        RVPT=1.
        TFIN=0.
        TFOU=0.
        TGP1=1.
        TGP2=.5
        TGP3=0.
C
C Done.
C
        RETURN
C
      END

C
C	$Id: gputmd.f,v 1.7 2008-07-27 00:21:06 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GPUTMD (ERROR)
C
C  Generate metafile descriptor elements.
C
      INTEGER  ERROR
C
      include 'g01prm.h'
      include 'g01wdt.h'
      include 'g01opc.h'
      include 'g01ins.h'
C
      INTEGER  NBYTES, DRSET(2), G01PBL
C
C  CLASS and ID for drawing-set and control set pseudo op.
C
      DATA  DRSET /-1, 1/
C
      ERROR = 0
C
C  Put out METAFILE VERSION element.
C
      NBYTES = 1 + (MINTFW-1)/8
      CALL GPUTNI (CLMVER, IDMVER, NBYTES, ERROR)
      CALL GPUTPR (MVERSN, MINTFW, 1, ERROR)
      IF (ERROR.NE.0)  RETURN
C
C  Put out METAFILE DESCRIPTION.
C
      NBYTES = G01PBL(24,0)
      CALL GPUTNI (CLDSCR, IDDSCR, NBYTES, ERROR)
      CALL GPUTPS ('NCAR_GKS0A--VERSION_4.1 ', 24, 24, 0, ERROR)
      IF (ERROR.NE.0)  RETURN
C
C  Put out METAFIlE ELEMENTS LIST, drawing-set pseudo op.
C
      NBYTES = 1 + (MINTFW + 2*MIXFW - 1)/8
      CALL GPUTNI (CLMELT, IDMELT, NBYTES, ERROR)
      CALL GPUTPR (1, MINTFW, 1, ERROR)
      CALL GPUTPR (DRSET, MIXFW, 2, ERROR)
C
C  Put out MAXIMUM COLOR INDEX.
C
      NBYTES = 1 + (MCIXFW-1)/8
      ICLTMP = 1
      IELTMP = 9
      CALL GPUTNI (ICLTMP,IELTMP,NBYTES,ERROR)
      IMXTMP = 255
      CALL GPUTPR (IMXTMP,MCIXFW,1,ERROR)
C
C  Put out FONT LIST.  There are 20 fonts.
C
      NBYTES = 20 + ( 7+26+26+21+21+22+21+21+22+22+24+20+21+22+21+
     -               22+22+20+19+19)
      CALL GPUTNI(CLFLST,IDFLST,NBYTES,ERROR)
      CALL GPUTPS('DEFAULT'                   , 7, 7,0,ERROR)
      CALL GPUTPS('HERSHEY:CARTOGRAPHIC_ROMAN',26,26,0,ERROR)
      CALL GPUTPS('HERSHEY:CARTOGRAPHIC_GREEK',26,26,0,ERROR)
      CALL GPUTPS('HERSHEY:SIMPLEX_ROMAN'     ,21,21,0,ERROR)
      CALL GPUTPS('HERSHEY:SIMPLEX_GREEK'     ,21,21,0,ERROR)
      CALL GPUTPS('HERSHEY:SIMPLEX_SCRIPT'    ,22,22,0,ERROR)
      CALL GPUTPS('HERSHEY:COMPLEX_ROMAN'     ,21,21,0,ERROR)
      CALL GPUTPS('HERSHEY:COMPLEX_GREEK'     ,21,21,0,ERROR)
      CALL GPUTPS('HERSHEY:COMPLEX_SCRIPT'    ,22,22,0,ERROR)
      CALL GPUTPS('HERSHEY:COMPLEX_ITALIC'    ,22,22,0,ERROR)
      CALL GPUTPS('HERSHEY:COMPLEX_CYRILLIC'  ,24,24,0,ERROR)
      CALL GPUTPS('HERSHEY:DUPLEX_ROMAN'      ,20,20,0,ERROR)
      CALL GPUTPS('HERSHEY:TRIPLEX_ROMAN'     ,21,21,0,ERROR)
      CALL GPUTPS('HERSHEY:TRIPLEX_ITALIC'    ,22,22,0,ERROR)
      CALL GPUTPS('HERSHEY:GOTHIC_GERMAN'     ,21,21,0,ERROR)
      CALL GPUTPS('HERSHEY:GOTHIC_ENGLISH'    ,22,22,0,ERROR)
      CALL GPUTPS('HERSHEY:GOTHIC_ITALIAN'    ,22,22,0,ERROR)
      CALL GPUTPS('HERSHEY:MATH_SYMBOLS'      ,20,20,0,ERROR)
      CALL GPUTPS('HERSHEY:SYMBOL_SET1'       ,19,19,0,ERROR)
      CALL GPUTPS('HERSHEY:SYMBOL_SET2'       ,19,19,0,ERROR)
C
      RETURN
      END

      PROGRAM DSEX04
C
      PARAMETER (NUM=16, NX=21, NY=21)       
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
      REAL XI(NUM), YI(NUM), ZI(NUM)
      REAL XO(NX), YO(NY), OUTPUT(NX,NY)
      REAL XINC, YINC
C
C  Input data points and values.
C
      DATA XI/0.00, 1.00, 0.00, 1.00, 0.30, 0.30, 0.30, 0.69, 
     +        0.71, 0.71, 0.69, 0.70, 0.70, 0.70, 0.69, 0.71/
      DATA YI/0.00, 0.00, 1.00, 1.00, 0.70, 0.30, 0.70, 0.69, 
     +        0.69, 0.71, 0.71, 0.70, 0.69, 0.71, 0.70, 0.70/
      DATA ZI/0.00, 0.00, 0.00, 0.50, 0.50, 0.50, 0.50, 1.00, 
     +        1.00, 1.00, 1.00, 1.00, 1.00, 1.00, 1.00, 1.00/
      DATA RHO, THETA, PHI/3.0, -45., 55./
C
C  Specify the output grid.
C
      XINC = 1./ REAL(NX-1)
      YINC = 1./ REAL(NY-1)
      DO 30 I=1,NX
        XO(I) = REAL((I-1)*XINC)
        DO 40 J=1,NY
          YO(J) = REAL((J-1)*YINC)
   40   CONTINUE
   30 CONTINUE
C
C  Set shadowing flag.
C
      CALL DSSETI('SHD',1)
      CALL DSGRID2S(NUM, XI, YI, ZI, NX, NY, XO, YO, OUTPUT, IER)
      IF (IER .NE. 0) THEN
        WRITE(6,520) IER
  520   FORMAT(' Error ',I3,' returned from DSGRID2S')
        STOP
      ENDIF
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
      CALL TDEZ2D(NX, NY, XO, YO, OUTPUT, RHO, THETA, PHI, 6)
      CALL FRAME()
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END

      SUBROUTINE SGEBRD( M, N, A, LDA, D, E, TAUQ, TAUP, WORK, LWORK,
     $                   INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      INTEGER            INFO, LDA, LWORK, M, N
*     ..
*     .. Array Arguments ..
      REAL               A( LDA, * ), D( * ), E( * ), TAUP( * ),
     $                   TAUQ( * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  SGEBRD reduces a general real M-by-N matrix A to upper or lower
*  bidiagonal form B by an orthogonal transformation: Q**T * A * P = B.
*
*  If m >= n, B is upper bidiagonal; if m < n, B is lower bidiagonal.
*
*  Arguments
*  =========
*
*  M       (input) INTEGER
*          The number of rows in the matrix A.  M >= 0.
*
*  N       (input) INTEGER
*          The number of columns in the matrix A.  N >= 0.
*
*  A       (input/output) REAL array, dimension (LDA,N)
*          On entry, the M-by-N general matrix to be reduced.
*          On exit,
*          if m >= n, the diagonal and the first superdiagonal are
*            overwritten with the upper bidiagonal matrix B; the
*            elements below the diagonal, with the array TAUQ, represent
*            the orthogonal matrix Q as a product of elementary
*            reflectors, and the elements above the first superdiagonal,
*            with the array TAUP, represent the orthogonal matrix P as
*            a product of elementary reflectors;
*          if m < n, the diagonal and the first subdiagonal are
*            overwritten with the lower bidiagonal matrix B; the
*            elements below the first subdiagonal, with the array TAUQ,
*            represent the orthogonal matrix Q as a product of
*            elementary reflectors, and the elements above the diagonal,
*            with the array TAUP, represent the orthogonal matrix P as
*            a product of elementary reflectors.
*          See Further Details.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(1,M).
*
*  D       (output) REAL array, dimension (min(M,N))
*          The diagonal elements of the bidiagonal matrix B:
*          D(i) = A(i,i).
*
*  E       (output) REAL array, dimension (min(M,N)-1)
*          The off-diagonal elements of the bidiagonal matrix B:
*          if m >= n, E(i) = A(i,i+1) for i = 1,2,...,n-1;
*          if m < n, E(i) = A(i+1,i) for i = 1,2,...,m-1.
*
*  TAUQ    (output) REAL array dimension (min(M,N))
*          The scalar factors of the elementary reflectors which
*          represent the orthogonal matrix Q. See Further Details.
*
*  TAUP    (output) REAL array, dimension (min(M,N))
*          The scalar factors of the elementary reflectors which
*          represent the orthogonal matrix P. See Further Details.
*
*  WORK    (workspace/output) REAL array, dimension (LWORK)
*          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*
*  LWORK   (input) INTEGER
*          The length of the array WORK.  LWORK >= max(1,M,N).
*          For optimum performance LWORK >= (M+N)*NB, where NB
*          is the optimal blocksize.
*
*          If LWORK = -1, then a workspace query is assumed; the routine
*          only calculates the optimal size of the WORK array, returns
*          this value as the first entry of the WORK array, and no error
*          message related to LWORK is issued by XERBLA.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit 
*          < 0:  if INFO = -i, the i-th argument had an illegal value.
*
*  Further Details
*  ===============
*
*  The matrices Q and P are represented as products of elementary
*  reflectors:
*
*  If m >= n,
*
*     Q = H(1) H(2) . . . H(n)  and  P = G(1) G(2) . . . G(n-1)
*
*  Each H(i) and G(i) has the form:
*
*     H(i) = I - tauq * v * v'  and G(i) = I - taup * u * u'
*
*  where tauq and taup are real scalars, and v and u are real vectors;
*  v(1:i-1) = 0, v(i) = 1, and v(i+1:m) is stored on exit in A(i+1:m,i);
*  u(1:i) = 0, u(i+1) = 1, and u(i+2:n) is stored on exit in A(i,i+2:n);
*  tauq is stored in TAUQ(i) and taup in TAUP(i).
*
*  If m < n,
*
*     Q = H(1) H(2) . . . H(m-1)  and  P = G(1) G(2) . . . G(m)
*
*  Each H(i) and G(i) has the form:
*
*     H(i) = I - tauq * v * v'  and G(i) = I - taup * u * u'
*
*  where tauq and taup are real scalars, and v and u are real vectors;
*  v(1:i) = 0, v(i+1) = 1, and v(i+2:m) is stored on exit in A(i+2:m,i);
*  u(1:i-1) = 0, u(i) = 1, and u(i+1:n) is stored on exit in A(i,i+1:n);
*  tauq is stored in TAUQ(i) and taup in TAUP(i).
*
*  The contents of A on exit are illustrated by the following examples:
*
*  m = 6 and n = 5 (m > n):          m = 5 and n = 6 (m < n):
*
*    (  d   e   u1  u1  u1 )           (  d   u1  u1  u1  u1  u1 )
*    (  v1  d   e   u2  u2 )           (  e   d   u2  u2  u2  u2 )
*    (  v1  v2  d   e   u3 )           (  v1  e   d   u3  u3  u3 )
*    (  v1  v2  v3  d   e  )           (  v1  v2  e   d   u4  u4 )
*    (  v1  v2  v3  v4  d  )           (  v1  v2  v3  e   d   u5 )
*    (  v1  v2  v3  v4  v5 )
*
*  where d and e denote diagonal and off-diagonal elements of B, vi
*  denotes an element of the vector defining H(i), and ui an element of
*  the vector defining G(i).
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ONE
      PARAMETER          ( ONE = 1.0E+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            LQUERY
      INTEGER            I, IINFO, J, LDWRKX, LDWRKY, LWKOPT, MINMN, NB,
     $                   NBMIN, NX
      REAL               WS
*     ..
*     .. External Subroutines ..
      EXTERNAL           SGEBD2, SGEMM, SLABRD, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN, REAL
*     ..
*     .. External Functions ..
      INTEGER            ILAENV
      EXTERNAL           ILAENV
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters
*
      INFO = 0
      NB = MAX( 1, ILAENV( 1, 'SGEBRD', ' ', M, N, -1, -1 ) )
      LWKOPT = ( M+N )*NB
      WORK( 1 ) = REAL( LWKOPT )
      LQUERY = ( LWORK.EQ.-1 )
      IF( M.LT.0 ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( LDA.LT.MAX( 1, M ) ) THEN
         INFO = -4
      ELSE IF( LWORK.LT.MAX( 1, M, N ) .AND. .NOT.LQUERY ) THEN
         INFO = -10
      END IF
      IF( INFO.LT.0 ) THEN
         CALL XERBLA( 'SGEBRD', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         RETURN
      END IF
*
*     Quick return if possible
*
      MINMN = MIN( M, N )
      IF( MINMN.EQ.0 ) THEN
         WORK( 1 ) = 1
         RETURN
      END IF
*
      WS = MAX( M, N )
      LDWRKX = M
      LDWRKY = N
*
      IF( NB.GT.1 .AND. NB.LT.MINMN ) THEN
*
*        Set the crossover point NX.
*
         NX = MAX( NB, ILAENV( 3, 'SGEBRD', ' ', M, N, -1, -1 ) )
*
*        Determine when to switch from blocked to unblocked code.
*
         IF( NX.LT.MINMN ) THEN
            WS = ( M+N )*NB
            IF( LWORK.LT.WS ) THEN
*
*              Not enough work space for the optimal NB, consider using
*              a smaller block size.
*
               NBMIN = ILAENV( 2, 'SGEBRD', ' ', M, N, -1, -1 )
               IF( LWORK.GE.( M+N )*NBMIN ) THEN
                  NB = LWORK / ( M+N )
               ELSE
                  NB = 1
                  NX = MINMN
               END IF
            END IF
         END IF
      ELSE
         NX = MINMN
      END IF
*
      DO 30 I = 1, MINMN - NX, NB
*
*        Reduce rows and columns i:i+nb-1 to bidiagonal form and return
*        the matrices X and Y which are needed to update the unreduced
*        part of the matrix
*
         CALL SLABRD( M-I+1, N-I+1, NB, A( I, I ), LDA, D( I ), E( I ),
     $                TAUQ( I ), TAUP( I ), WORK, LDWRKX,
     $                WORK( LDWRKX*NB+1 ), LDWRKY )
*
*        Update the trailing submatrix A(i+nb:m,i+nb:n), using an update
*        of the form  A := A - V*Y' - X*U'
*
         CALL SGEMM( 'No transpose', 'Transpose', M-I-NB+1, N-I-NB+1,
     $               NB, -ONE, A( I+NB, I ), LDA,
     $               WORK( LDWRKX*NB+NB+1 ), LDWRKY, ONE,
     $               A( I+NB, I+NB ), LDA )
         CALL SGEMM( 'No transpose', 'No transpose', M-I-NB+1, N-I-NB+1,
     $               NB, -ONE, WORK( NB+1 ), LDWRKX, A( I, I+NB ), LDA,
     $               ONE, A( I+NB, I+NB ), LDA )
*
*        Copy diagonal and off-diagonal elements of B back into A
*
         IF( M.GE.N ) THEN
            DO 10 J = I, I + NB - 1
               A( J, J ) = D( J )
               A( J, J+1 ) = E( J )
   10       CONTINUE
         ELSE
            DO 20 J = I, I + NB - 1
               A( J, J ) = D( J )
               A( J+1, J ) = E( J )
   20       CONTINUE
         END IF
   30 CONTINUE
*
*     Use unblocked code to reduce the remainder of the matrix
*
      CALL SGEBD2( M-I+1, N-I+1, A( I, I ), LDA, D( I ), E( I ),
     $             TAUQ( I ), TAUP( I ), WORK, IINFO )
      WORK( 1 ) = WS
      RETURN
*
*     End of SGEBRD
*
      END

C
C	$Id: pccfff.f,v 1.7 2008-07-27 00:17:19 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE PCCFFF (IPSS,IBNU,NFNT,NASC,CHGT,SIZE,RDGU,LDGU,NDGU)        
C
      include 'pcffme.h'
      include 'pcffdx.h'
C
      DIMENSION RDGU(LDGU)
C
C The subroutine PCCFFF retrieves the digitization of a specified
C character from one of the locally-defined NCAR Graphics fontcaps
C that are defined for filled fonts.
C
C IPSS is the number of the pass being executed by PLCHHQ.
C
C IBNU is the number of a unit to be used in reading the fontcaps.
C
C NFNT is the number of the desired font.
C
C NASC is the ASCII decimal equivalent of the desired character.
C
C CHGT is a REAL specifying the desired character height in digitization
C      units (this is the value into which  FNTCAP-FNTBAS is mapped.)
C
C SIZE is a REAL specifying the approximate desired character height
C      in NDC units.
C
C RDGU is a real array in which the digitization is to be returned.
C
C LDGU is the length of RDGU.
C
C NDGU is the number of elements returned in RDGU.
C
C The digitization is to be in the form expected by PLCHHQ, in a
C coordinate system centered at the center of the character.  RDGU(1)
C must be a negative number whose magnitude is the distance from the
C center of the character to its left edge.  RDGU(2) must be a positive
C number whose magnitude is the distance from the center of the
C character to its right edge.
C
C For each odd value of I greater than 2, RDGU(I) is an X coordinate
C and RDGU(I+1) is a Y coordinate of some point on a polyline that is
C to be drawn or filled, with the following exception:  each polyline
C is terminated by a "point" with X coordinate -2048. or -2047.; 
C the value -2048. implies that the polyline is to be drawn and -2047. 
C that it is to be filled.  This point is not actually part of the 
C polyline, it simply marks the end of the polyline.  The Y coordinate
C paired with it says what color is to be used for the draw or fill.  
C If the Y coordinate is 0., no special color is implied; drawing or
C filling will be done using whatever color is implied by internal
C parameters of PLOTCHAR determining the colors to be used for the 
C various parts of normal characters.  If the Y coordinate is positive,
C a special color is implied (as, for example in state and federal
C highway signs).  
C
C ---------------------------------
C
C The variable NFRL, if non-zero, defines the number of the font read
C last.
C
      SAVE NFRL
C
      DATA NFRL / 0/
C
C Zero the count of digitization elements returned.
C
      NDGU=0
      NFNTL = NFNT
C
C If the desired font is not the one read last, read it.  If there is
C any problem with reading it, just return with NDGU zeroed to indicate
C that the desired character was not available.
C
      IF (NFRL .NE. NFNT) THEN
C
C  Set the OUTLIN flag for outline fonts and reassign the font number.
C
        IF (NFNT.EQ.121 .OR. NFNT.EQ.122 .OR. NFNT.EQ.125 .OR.
     +      NFNT.EQ.126 .OR. NFNT.EQ.129 .OR. NFNT.EQ.130 .OR.
     +      NFNT.EQ.133 .OR. NFNT.EQ.134 .OR. NFNT.EQ.135 .OR.
     +      NFNT.EQ.136 .OR. NFNT.EQ.137 .OR. NFNT.EQ.199) THEN
          OUTLIN = 1
          NFNTL = NFNT - 100
        ELSE
          OUTLIN = 0
        ENDIF
C
C Open the fontcap file.
C
        IBNS=IBNU
        CALL PCFOPN (IBNU,NFNTL)
C
C Read the fontcap.
C
        CALL PCFRED (IBNU,NFNTL,IBFC,IFCLEN)
C
C Close the fontcap file.
C
        CALL PCFCLS (IBNU,NFNTL)
        IBNU=IBNS
C
C Set the variable NFRL to reflect the number of the font last read.
C
        NFRL=NFNT
C
C Get the font metric information from the fontcap and store in common
C PCINDX.
C
        CALL PCFFME (CHGT)
      END IF
C
C  Calculate the scale factor to go from the font coordinate space 
C  to the height specified in the call to PCCFFF.
C
      SCALE = CHGT/REAL(FCAP-FBASE)
C
C Get the digitization.
C
      CALL PCFFGD (IPSS,NASC,CHGT,SIZE,RDGU,LDGU,NDGU)
C
C Done.
C
      RETURN
C
      END

c -------------------------------------------------------------------
      SUBROUTINE DLINMSG(X,NPTS,XMSG,MFLAG,MPTCRT)
c     implicit none

c NCL: xnew = linmsg(x,mflag)

c given a series x of length npts : this routine will linearly
c .   interpolate to fill in the missing pts. missing values at the
c .   beginning and end of the series will be be determined
c .   by the sign of mprcrt.
c
c nomenclature :
c .   x         - input series which may or may not contain msg values
c .   npts      - length of the series
c .   xmsg      - missing code
c .   mflag     - note: if mflag.lt.0 then the missing values at the
c .               beginning and end of the series will be set to the
c .               value of the nearest non-msg value. if mflag.ge.0
c .               then set these values to missing.
c .   mptcrt    - if more than "mptcrt" consecutive values are 
c .               encountered, the routine will not interpolate across
c .               that segment. If mptcrt=npts [most common option], 
c .               then the routine will interpolate as many values as
c .               it can.
c .
c OTHER variables
c .   ncode     - code number
c .               ncode = -1  : whole series is missing
c .               ncode =  0  : series has no missing points upon return
c .                             to the calling routine. either the serie
c .                             had no missing points or this routine
c .                             has filled them with interpolated values
c .               ncode = nn  : series still has missing values. this
c .                             occurs when iabs(mptcrt) is exceeded.
c .                             nn is the number of missing values
c .                             still present.
c .   nitp      - No. of InTerpolated Points : user shouldcheck
c .               the ratio (nitp/npts)

      INTEGER NPTS,MPTCRT,NCODE,NITP,N,NEND,NSTRT
      DOUBLE PRECISION X(1:NPTS),XMSG
      INTEGER NPTCRT,NN,NBASE
      DOUBLE PRECISION SLOPE
C
C This do loop was added later to check for the special
C case were all values in X are missing.
C
      DO 5 N=1,NPTS
         IF (X(N).NE.XMSG) GO TO 10
 5    END DO   
      RETURN

c c c MPTCRT = NPTS   ! updated version

 10   NSTRT = 0
      NEND = 0
      NCODE = 0
      NITP = 0
      NPTCRT = IABS(MPTCRT)
      DO 40 N = 1,NPTS
          IF (X(N).EQ.XMSG) THEN
C must be a msg pt : set indices
              IF (NSTRT.EQ.0) NSTRT = N
              NEND = N
          ELSE

c must be a valid pt : check for prior missing values
c        (1) if nstrt=0 then there are no msg prior values : skip out
c        (2) if (nend-nstrt+1).gt.nptcrt the set ncode : skip out
c        (3) if nstrt=1 then initial series values are msg : set to
c            first non-msg value
c        ... else
c            perform the linear interpolation

              IF (NSTRT.NE.0) THEN
                  IF ((NEND-NSTRT+1).GT.NPTCRT) THEN
                      GO TO 30
                  END IF

                  IF (NSTRT.EQ.1) THEN
                      NITP = NITP + (NEND-NSTRT+1)
                      IF (MFLAG.LT.0) THEN
                          DO 15 NN = NSTRT,NEND
   15                     X(NN) = X(N)
                      ELSE
                          DO 16 NN = NSTRT,NEND
   16                     X(NN) = XMSG
                      END IF
                  ELSE
                      NBASE = NSTRT - 1
                      SLOPE = (X(N)-X(NBASE))/DBLE(N-NBASE)
                      NITP = NITP + (NEND-NSTRT+1)
                      DO 20 NN = NSTRT,NEND
   20                 X(NN) = X(NBASE) + SLOPE*DBLE(NN-NBASE)
                  END IF

   30             NSTRT = 0
                  NEND = 0
              END IF
          END IF
   40 CONTINUE

c check the end points

      IF (NEND.EQ.NPTS) THEN
          NITP = NITP + (NEND-NSTRT+1)
          IF (MFLAG.LT.0) THEN
              DO 49 NN = NSTRT,NPTS
   49         X(NN) = X(NSTRT-1)
          ELSE
              DO 50 NN = NSTRT,NPTS
   50         X(NN) = XMSG
          END IF
      END IF

c     nn = 0
c     do 60 n=1,npts
c     if (x(n).eq.xmsg) then
c         nn = nn+1
c     endif
c  60 continue

c     ncode = nn
c     if (nn.eq.npts) then
C for historical reasons
c         ncode = -1
c     endif

      RETURN
      END

C
C $Id: bcbkd.f,v 1.5 2008-07-27 00:17:29 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE BCBKD
C
C Calling this do-nothing subroutine forces "ld" to load the following
C block data routine (but only if they are in the same ".f" file).
C
        RETURN
C
      END
CNOSPLIT
      BLOCKDATA BCBKDX
C
C  Data for the Bezier curve package.
C
      include 'bccom.h'
C
C  FRATIO  --  The tolerance limit for the recursive subdivision
C              algorithm.  This limit specifies how close the
C              interpolated curve must be to the actual Bezier
C              curve before subdivision ceases.  This ratio is 
C              specified as a ratio of the maximum screen height
C              (the maximum Y extent in user space that can be mapped 
C              onto the unit interval in NDC space).  It is applied 
C              to the current user space to get a value in user 
C              coordinates.  As implemented the subdivision will 
C              cease after eight levels under any circumstance.
C  NPPC    --  A flag to indicate whether the recursive subdivision
C              algorithm will be overridden.  If NPPC .LT. 2 (the
C              default), then recursive subdivision will be utilized; 
C              if NPPC.GE.2 and NPPC.LE.128, then that many points 
C              will be returned along the curve at equally spaced 
C              values for the parameter in the parametric definition 
C              of the curve.
C      
      DATA FRATIO/.00003/
C
C  Flag for the number of points on a curve.
C
      DATA NPPC/0/
C
      END

C
C      $Id: xy06f.f,v 1.14 2010-03-15 22:49:25 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C                Copyright (C)  1995                                   C
C        University Corporation for Atmospheric Research               C
C                All Rights Reserved                                   C
C                                                                      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C  File:       xy06f.f
C
C  Author:     Mary Haley
C          National Center for Atmospheric Research
C          PO 3000, Boulder, Colorado
C
C  Date:       Fri Mar 10 15:08:06 MST 1995
C
C Description:    This example shows how to do several things:
C
C                 1) How to create an XyPlot object with multiple
C                    lines using the CoordArrays and Data objects.
C                 2) How to change the data to create a different
C                    plot, without having to create a new data object
C                    (using the NhlFSetValues call).
C                 3) How to overlay a Legend object and to tweak
C                    several kinds of resources (see "xy06.res").
C                 4) How to use netCDF interface routines to open
C                    and access a netCDF file.
C                 5) How to use a kludgy method for using the resource
C                    file to specify which stations you want to observe.
C                
C                 This example requires that you have the netCDF
C                 library built on your system!  It's available via
C                 anonymous ftp to unidata.ucar.edu.
C
      external NhlFAppClass 
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFCairoWindowWorkstationClass
      external NhlFXyPlotClass
      external NhlFCoordArraysClass
C
C Define the maximum number of weather stations and hours in a day.
C The actual stations you want to get data values for should be
C defined in the "xy06.res" resource file using the
C "xyExplicitLegendLabels" resource.
C
C You cannot request more than NSTATIONS station ids in the resource
C file.
C
      parameter(NSTATIONS=8,NHOURS=24,NCOLORS=10)
C
C Declare array that will hold station ids.
C
      character*20 station_abrev(NSTATIONS)
C
C Declare variables for the HLU routine calls.
C
      integer appid,xworkid,plotid,dataid
      integer grlist, rlist, i, j
      integer dspec(1), num_dspec
      data num_dspec/1/
      integer length(2), flen
      data length/NHOURS,NSTATIONS/
      real special_value
      data special_value/-9999./
C
C Declare variables for getting information from netCDF file.
C
      character*100 error_msg
      character*50 dir, recname, idname
      character*256 filename
      character*12 station_name
      integer ncid, stid, stdmid, tempid, presid, windid, recid
      integer ndims, nvars, ngatts, nhour
      integer num_values, have_value(NSTATIONS)
      integer stid_len, rec_len, numids
      data numids/NSTATIONS/
      integer ststart(2), stcount(2), idx(1)
C
C Declare 2-d arrays to hold data values.
C 
      real temp(NHOURS,NSTATIONS)
      real pressure(NHOURS,NSTATIONS)
      real wind_speed(NHOURS,NSTATIONS)
C
C Modify the color map.  Color indices '1' and '2' are the background
C and foreground colors respectively.
C
      real cmap(3,NCOLORS)
      data cmap/0.00,0.00,0.00,
     +          1.00,1.00,1.00,
     +          0.00,0.00,1.00,
     +          0.00,1.00,0.00,
     +          0.00,1.00,0.75,
     +          0.50,0.50,0.63,
     +          1.00,0.00,0.00,
     +          0.75,0.38,0.25,
     +          0.75,0.00,0.75,
     +          1.00,1.00,0.00/

      CHARACTER*7  wks_type
C
C Define the workstation type
C
      wks_type = "x11"
C
C
C Initialize the HLU library and set up resource template.
C
      call NhlFInitialize
      call NhlFRLCreate(rlist,'setrl')
C
C Create Application object.  The Application object name is used to
C determine the name of the resource file, which is "xy06.res" in
C this case.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'appDefaultParent','True',ierr)
      call NhlFRLSetString(rlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'xy06',NhlFAppClass,0,rlist,ierr)

      length(1) = 3
      length(2) = NCOLORS

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkMetaName','./xy06f.ncgm',ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',cmap,2,length,
     +        ierr)
         call NhlFCreate(xworkid,'xy06Work',
     +        NhlFNcgmWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X11 workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPause','True',ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',cmap,2,length,
     +        ierr)
         call NhlFCreate(xworkid,'xy06Work',
     +        NhlFCairoWindowWorkstationClass,
     +        0,rlist,ierr)
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PostScript workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPSFileName','./xy06f.ps',ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',cmap,2,length,
     +        ierr)
         call NhlFCreate(xworkid,'xy06Work',
     +        NhlFPSWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPDFFileName','./xy06f.pdf',ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',cmap,2,length,
     +        ierr)
         call NhlFCreate(xworkid,'xy06Work',
     +        NhlFPDfWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFileName','./xy06f',ierr)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',cmap,2,length,
     +        ierr)
         call NhlFCreate(xworkid,'xy06Work',
     +        NhlFcairoPSPDFWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFileName','./xy06f',ierr)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',cmap,2,length,
     +        ierr)
         call NhlFCreate(xworkid,'xy06Work',
     +        NhlFcairoImageWorkstationClass,0,rlist,ierr)
      endif
C
C We need to initialize a non-constant dummy array for our Data
C object, otherwise we'll get error messages.
C
      do 10 j = 1,NHOURS
         temp(j,1) = real(j)
 10   continue
C
C Define a dummy Data object.  We do this so a DataSpec object is
C created automatically and then we can use a NhlFGetValues call to
C get the names of the stations we want data values for.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetFloatArray(rlist,'caYArray',temp,NHOURS,ierr)
      call NhlFCreate(dataid,'xyData',NhlFCoordArraysClass,0,
     +     rlist,ierr)
C
C The id for this dummy Data object will now become the resource
C value for "xyCoordData".
C
      call NhlFRLClear(rlist)
      call NhlFRLSetInteger(rlist,'xyCoordData',dataid,ierr)
      call NhlFCreate(plotid,'xyPlot1',NhlFXyPlotClass,xworkid,
     +     rlist,ierr)
C
C Get the DataSpec object id.
C
      call NhlFRLCreate(grlist,'getrl')
      call NhlFRLClear(grlist)
      call NhlFRLGetintegerarray(grlist,'xyCoordDataSpec',dspec,
     +     num_dspec,ierr)
      call NhlFGetValues(plotid,grlist,ierr)
C
C Get station id names that have been set in resource file.  This
C is a round-about way of doing things, but it makes it convenient to
C be able to specify the stations we want.  We used the
C 'xyExplicitLegendLabels' resource, because we also want to use the 
C station names to label the lines in the legend.
C
      call NhlFRLClear(grlist)
      call NhlFRLGetstringarray(grlist,'xyExplicitLegendLabels',
     +     station_abrev,numids,ierr)
      call NhlFGetValues(dspec(1),grlist,ierr)
C
C Make sure we didn't request too many stations or none at all.
C
      if( numids .gt. NSTATIONS ) then
         write(error_msg,25)numids
 25      format('Number of requested stations ', i2,' is illegal.')
         call NhlFPError('FATAL','EUNKNOWN',error_msg)
         write(error_msg,26)NSTATIONS
 26      format('Can only request 1-',i2,' stations.')
         call NhlFPError('FATAL','EUNKNOWN',error_msg)
         stop
      endif
C
C Loop through all NHOURS hours.
C
      do 40 nhour=1,NHOURS
C
C Initialize the data arrays to our special value that we have set
C above.
C
         num_values = 0
         do 30 i = 1,numids
            have_value(i) = 0
            temp(nhour,i) = special_value
            pressure(nhour,i) = special_value
            wind_speed(nhour,i) = special_value
 30      continue
C
C Open the netCDF file for a particular hour.
C
         call gngpat(filename,"data",ierr)
         write(dir,31)nhour-1
 31      format('/cdf/950318',i2.2,'_sao.cdf' )
         flen = 20
         do 32 i=1,256
            if( filename(i:i).eq.char(0) ) then
               filename(i:i+flen)=dir
               goto 34
            endif
 32      continue
C      
C The second argument to 'ncopn' should be NCNOWRIT, but since we
C can't include 'netcdf.inc', we are using the value '0' instead.
C
 34      ncid = ncopn(filename,0,ierr)
C
C Get the station id dimension.
C
         stdmid = ncdid(ncid,'id_len',ierr)
         call ncdinq(ncid, stdmid, idname, stid_len, ierr )
C
C Get the record length and dimension name.
C
         call ncinq(ncid, ndims, nvars, ngatts, recid, ierr)
         call ncdinq(ncid, recid, recname, rec_len, ierr)
C
C Get the id of the station ids, temperature, pressure, and 
C wind speed variables.
C
         stid = ncvid(ncid,'id',ierr)
         tempid = ncvid(ncid,'T',ierr)
         presid = ncvid(ncid,'PSL',ierr)
         windid = ncvid(ncid,'SPD',ierr)
C
C Get data values for the stations we have selected.
C
         ststart(1) = 1
         stcount(2) = 1
         stcount(1) = stid_len
         do 37 i = 1, rec_len
            ststart(2) = i
            call ncvgtc(ncid,stid,ststart,stcount,station_name,
     +           12,ierr)
            do 35 j = 1, numids
C
C Check if this is one of the stations we've requested and that we
C don't already have a data value for this station.
C
               if( station_abrev(j).eq.station_name(1:3) .and.
     +              have_value(j).eq.0 .and.
     +              ichar(station_name(4:4)).eq.0) then
                  idx(1) = i
C
C Get the temperature value.
C
                  call ncvgt1(ncid,tempid,idx,temp(nhour,j),ierr)
C
C Get the pressure value.
C
                  call ncvgt1(ncid,presid,idx,pressure(nhour,j),ierr)
C
C Get the wind speed.
C
                  call ncvgt1(ncid,windid,idx,wind_speed(nhour,j),ierr)
C
C Keep track of how many values we've received.
C 
                  have_value(j) = 1
                  num_values = num_values + 1
                  goto 36
               endif
 35         continue
C
C Check if we have received data values for each station.  If
C so, then we don't need to loop through the rest of the stations.
C
 36         if( num_values .eq. numids ) goto 40
 37      continue
C
C Let the user know if there are some stations missing.  Special
C values will be used in this case.
C
         do j = 1,numids
            if(have_value(j).eq.0  ) then
               write(error_msg,38)station_abrev(j),nhour
 38            format('Station ',a3,' not in netCDF file for hour ',i2)
               call NhlFPError('WARNING',1000,error_msg)
               write(error_msg,39)special_value
 39            format('Will substitute missing value = ', f7.1)
               call NhlFPError('WARNING',1000,error_msg)
            endif
         end do
C
C Close the netCDF file.
C
         call ncclos(ncid,ierr)
 40   continue
C
C Define the Data object.  Since only the Y values are specified here,
C each Y value will be paired with its integer array index.  The data
C id from this object will become the value for the XyPlot resource
C "xyCoordData".
C
      length(1) = NHOURS
      length(2) = numids
      call NhlFRLClear(rlist)
      call NhlFRLSetMDFloatArray(rlist,'caYArray',temp,2,length,ierr)
      call NhlFRLSetFloat(rlist,'caYMissingV',special_value,ierr)
      call NhlFCreate(dataid,'xyData',NhlFCoordArraysClass,0,
     +     rlist,ierr)
C
C The id for this Data object is now the resource value for
C xyCoordData.  Tweak some XyPlot resources in the resource file
C ("xy06.res").
C
      call NhlFRLClear(rlist)
      call NhlFRLSetInteger(rlist,'xyCoordData',dataid,ierr)
      call NhlFCreate(plotid,'xyPlot1',NhlFXyPlotClass,xworkid,
     +     rlist,ierr)
C     
C Draw the plot.
C
      call NhlFDraw(plotid,ierr)
      call NhlFFrame(xworkid,ierr)
C
C Change the data in our Data object.  Notice we use NhlFSetValues
C instead of NhlFCreate, so our data object will have the same
C name as when we originally created it, "xyData".
C
      call NhlFRLClear(rlist)
      call NhlFRLSetMDFloatArray(rlist,'caYArray',pressure,2,length,
     +     ierr)
      call NhlFSetValues(dataid,rlist,ierr)
C
C Create another XyPlot object with this new Data object.  We have to
C create another object instead of just changing the current one,
C because we want to change some resource values to title our axes
C differently.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetInteger(rlist,'xyCoordData',dataid,ierr)
      call NhlFCreate(plotid,'xyPlot2',NhlFXyPlotClass,xworkid,
     +     rlist,ierr)
C
C Draw the plot.
C
      call NhlFDraw(plotid,ierr)
      call NhlFFrame(xworkid,ierr)
C
C Change the data in our Data object.  Notice we use NhlFSetValues
C instead of NhlFCreate, so our data object will have the same
C name as when we originally created it, "xyData".
C
      call NhlFRLClear(rlist)
      call NhlFRLSetMDFloatArray(rlist,'caYArray',wind_speed,2,length,
     +     ierr)
      call NhlFSetValues(dataid,rlist,ierr)
C
C Create another XyPlot object with this new Data object.  We have to
C create another object instead of just changing the current one,
C because we want to change some resource values to title our axes
C differently.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetInteger(rlist,'xyCoordData',dataid,ierr)
      call NhlFCreate(plotid,'xyPlot3',NhlFXyPlotClass,xworkid,
     +     rlist,ierr)
C
C Draw the plot.
C
      call NhlFDraw(plotid,ierr)
      call NhlFFrame(xworkid,ierr)
C
C NhlFDestroy destroys the given id and all of its children so
C destroying "appid will destroy "xworkid" which will also destroy
C "plotid".
C
      call NhlFRLDestroy(rlist)
      call NhlFRLDestroy(grlist)
      call NhlFDestroy(xworkid,ierr)
C
C Restores state.
C
      call NhlFClose
      stop
      end

C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE DHLSRGB(H,L,S,R,G,B)
C
C_BEGIN PROLOGUE DHLSRGB
C
C_PURPOSE
C    This subroutine converts a color specification given in
C    the Hue, Lightness, and Saturation color space to
C    Red, Green, and Blue intensity values in the RGB color
C    space.
C
C_DESCRIPTION
C    This subroutine converts color values given in the
C    Hue, Lightness, Saturation (HLS) color space to color values
C    in the Red, Green, and Blue (RGB) color space.
C    The input value H is a floating point number in the
C    range [0.,360.); a value of H=0. in the input space
C    will result in a full blue (red and green values of 0.)
C    in the RGB space.  The input value L is in the range
C    [0.,100.]; lightness is used to signify the amount of light--
C    L=0. will result in R=G=B=0. and L=1. will result in
C    R=G=B=1. regardless of H and S.  The input value S is
C    in the range [0.,100.];  saturation is a measure of the
C    mixture of white light with a pure fully-saturated hue--
C    S=0. will result in R=G=B=L.  The output values
C    R, G, and B are red, green, and blue intensities
C    in the range 0. to 1. .
C
C_ARGUMENTS
C
C H       (INPUT,DOUBLE,VARIABLE)  A real variable in the range
C         [0.,360.) which represents the hue of the input color
C         in HLS color space.  H=0. corresponds to blue.
C
C L       (INPUT,DOUBLE,VARIABLE)  A real variable in the range
C         [0.,100.] which represents the lightness value of the
C         input color in HLS color space.  Lightness is a measure
C         of the quantity of light--a lightness of 0. is black,
C         and a lightness of 100. gives white.  The pure hues occur
C         at lightness value 50.
C
C S       (INPUT,DOUBLE,VARIABLE)  A real variable in the range
C         [0.,100.] which represents the saturation value of the
C         input color in HLS color space.  Saturation is a measure
C         of how much white light is mixed with the color. Colors
C         having a satuartion value of 0. represent greys
C         with a grey intensity value equal to the lightness L.
C         Colors with a saturation value of 100. are
C         fully saturated colors.  The hue is undefined
C         when S=0.  The fully saturated pure hues occur when S=100.
C         and L=50.
C
C R       (OUTPUT,DOUBLE,VARIABLE)  A real variable in the range
C         [0.,1.] which represents the red intensity component
C         of the output color in RGB color space.
C
C G       (OUTPUT,DOUBLE,VARIABLE)  A real variable in the range
C         [0.,1.] which represents the green intensity component
C         of the output color in RGB color space.
C
C B       (OUTPUT,DOUBLE,VARIABLE)  A real variable in the range
C         [0.,1.] which represents the blue intensity component
C         of the output color in RGB color space.
C
C_I/O
C    (NONE)
C
C_ROUTINES CALLED
C    DSIGPLC
C
C_COMMON BLOCKS
C    (NONE)
C
C_MAXIMUM GKS LEVEL
C    (NONE)
C
C_LANGUAGE
C    FORTRAN
C
C_REVISION DATE
C    880511 (YYMMDD)
C
C_HISTORY
C    This subroutine was originally coded at NCAR by Roy Barnes
C    using the algorithm presented in Foley and van Dam (see
C    REFERENCES below); it was prepared for the NCAR Graphics
C    package by Fred Clare.
C
C_REFERENCES
C    Foley, James D. and van Dam, Andries,"Fundamentals of Interactive
C    Computer Graphics",Addison-Wesley Publishing Company, 1982.
C
C    Smith, A.R.,"Color Gamut Transformation Pairs",SIGGRAPH '78
C    Proceedings, published as Computer Graphics, 12(3),August 1978,
C    pp.12-19.
C
C_LONG DESCRIPTION
C    The idea of the algorithm can be understood if one were to
C    plot the red output values vs. hue for S=100. and L=50.  The red
C    values so plotted form a piecewise linear curve.  The blue
C    and green values plotted in the same way form the same
C    piecewise linear curve except shifted.  Decreasing the
C    saturation pushes the curves toward the lightness value,
C    and varying the lightness introduces an amplitude scale
C    factor and vertical offset.
C
C_EXAMPLES
C    Example 1 --  Pure hue to red.
C          SUBROUTINE HLS2
C          DOUBLE PRECISION  R,G,B,EPS
C          PARAMETER (EPS=0.00001)
C          CALL DHLSRGB(120.,50.,100.,R,G,B)
C          IF ( (ABS(R-1.) .GT. EPS) .OR. (ABS(G) .GT. EPS) .OR.
C         *     (ABS(B) .GT. EPS) ) THEN
C            IUN = I1MACH(4)
C            WRITE(IUN,10)
C          ENDIF
C          RETURN
C       10 FORMAT(' HLS2 returned incorrect values')
C          END
C
C_END PROLOGUE DHLSRGB
C
      DOUBLE PRECISION H,HH,L,S,R,G,B,LL,SS,M1,M2,DSIGPLC
C
C  Check on the input values.
C
C_FIRST EXECUTABLE STATEMENT DHLSRGB
      HH = MOD(H,360.D0)
      IF (HH.LT.0.D0) HH = HH + 360.D0
      IF (L.LT.0.D0 .OR. L.GT.100.D0)
     +    CALL SETER(' DHLSRGB - L out of range',1,1)
      IF (S.LT.0.D0 .OR. S.GT.100.D0)
     +    CALL SETER(' DHLSRGB - S out of range',1,1)
C
C  Normalize lightness and saturation values.
C
      LL = L/100.D0
      SS = S/100.D0
      IF (SS.EQ.0.0D0) THEN
C
C  Achromatic case; RGB value is a grey equal to the lightness.
C
          R = LL
          G = LL
          B = LL
      ELSE
C
C  Calculate the max and min of the generic piecewise linear
C  color component function.
C
          IF (LL.LE.0.5D0) THEN
              M2 = LL* (1.0D0+SS)
          ELSE
              M2 = LL + SS - (LL*SS)
          END IF
          M1 = 2.0D0*LL - M2
C
C  Compute RGB values.
C
          R = DSIGPLC(M1,M2,HH+0.D0)
          G = DSIGPLC(M1,M2,HH-120.D0)
          B = DSIGPLC(M1,M2,HH+120.D0)
      END IF
      RETURN
      END
      SUBROUTINE DHSVRGB(H,S,V,R,G,B)
C
C_BEGIN PROLOGUE HSVRGB
C
C_PURPOSE
C    This subroutine converts a color specification given in
C    the Hue, Saturation, and Value color space to
C    Red, Green, and Blue intensity values in the RGB color
C    space.
C
C_DESCRIPTION
C    This subroutine converts color values given in the
C    Hue, Saturation, and Value (HSV) color space to color values
C    in the Red, Green, and Blue (RGB) color space.
C    The input value H is a floating point number in the
C    range [0.,360.); a value of H=0. in the input space
C    will result in a full red (green and blue values of 0.)
C    in the RGB space.  The input value V is in the range
C    [0.,1.];  the input value S is
C    in the range [0.,1.];  saturation is a measure of the
C    mixture of white light with a pure fully-saturated hue--
C    S=0. will result in R=G=B=V.  The output values
C    R, G, and B are red, green, and blue intensities
C    in the range [0.,1.] .
C
C_ARGUMENTS
C
C H       (INPUT,DOUBLE,VARIABLE)  A real variable in the range
C         [0.,360.) which represents the hue of the input color
C         in HSV color space.
C
C S       (INPUT,DOUBLE,VARIABLE)  A real variable in the range
C         [0.,1.] which represents the saturation value of the
C         input color in HSV color space.  Saturation is a measure
C         of how much white light is mixed with the color. Saturation
C         values of 0. represent greys (with a grey value equal to
C         the value V).  Saturation values of 1. are fully
C         saturated colors.  The hue is undefined when S=0.  The
C         fully saturated pure hues occur when S=1. and V=1.
C
C V       (INPUT,DOUBLE,VARIABLE)  A real variable in the range
C         [0.,1.] which represents the value of the
C         input color in HSV color space.
C
C R       (OUTPUT,DOUBLE,VARIABLE)  A real variable in the range
C         [0.,1.] which represents the red intensity component
C         of the output color in RGB color space.
C
C G       (OUTPUT,DOUBLE,VARIABLE)  A real variable in the range
C         [0.,1.] which represents the green intensity component
C         of the output color in RGB color space.
C
C B       (OUTPUT,DOUBLE,VARIABLE)  A real variable in the range
C         [0.,1.] which represents the blue intensity component
C         of the output color in RGB color space.
C
C_I/O
C    (NONE)
C
C_ROUTINES CALLED
C    DSIGPLC
C
C_COMMON BLOCKS
C    (NONE)
C
C_MAXIMUM GKS LEVEL
C    (NONE)
C
C_LANGUAGE
C    FORTRAN
C
C_REVISION DATE
C    880511 (YYMMDD)
C
C_HISTORY
C    This subroutine was originally coded and prepared for the
C    NCAR Graphics package by Fred Clare based on algorithms
C    in Foley and van Dam (see REFERENCES below).
C
C_REFERENCES
C    Foley, James D. and van Dam, Andries,"Fundamentals of Interactive
C    Computer Graphics",Addison-Wesley Publishing Company, 1982.
C
C    Smith, A.R.,"Color Gamut Transformation Pairs",SIGGRAPH '78
C    Proceedings, published as Computer Graphics, 12(3),August 1978,
C    pp.12-19.
C
C_LONG DESCRIPTION
C    The idea of the algorithm can be understood if one were to
C    plot the red output values vs. hue with S=1. and V=1.  The red
C    values so plotted form a piecewise linear curve.  The blue
C    and green values plotted in the same way form the same
C    piecewise linear curve except shifted.  Decreasing the
C    saturation pushes the curves toward the input value V,,
C    and varying the value, V, introduces an amplitude scale
C    factor.  Drawing plots of the red, green, and blue output
C    values vs. hue for selected values of S, and V should
C    provide an intuitive feel for the algorithm.
C
C_EXAMPLES
C    Example 1 --  Pure hue in HSV to green in RGB.
C          SUBROUTINE HSV2
C          DOUBLE PRECISION    R,G,B,EPS
C          PARAMETER (EPS=0.00001)
C          CALL HSVRGB(120.,1.,1.,R,G,B)
C          IF ( (ABS(R-0.) .GT. EPS) .OR. (ABS(G-1.) .GT. EPS) .OR.
C         *     (ABS(B-0.) .GT. EPS) ) THEN
C            IUN = I1MACH(4)
C            WRITE(IUN,10)
C          ENDIF
C          RETURN
C       10 FORMAT(' HSV2 returned incorrect values')
C          END
C
C_END PROLOGUE HSVRGB
C
      DOUBLE PRECISION H,HH,S,V,R,G,B,SM1,DSIGPLC
C
C  Check on the input values.
C
C_FIRST EXECUTABLE STATEMENT HSVRGB
      HH = MOD(H,360.D0)
      IF (HH.LT.0.D0) HH = HH + 360.D0
      IF (S.LT.0.D0 .OR. S.GT.1.D0) CALL SETER
     +    (' HSVRGB - S out of range',1,1)
      IF (V.LT.0.D0 .OR. V.GT.1.D0) CALL SETER
     +    (' HSVRGB - V out of range',1,1)
C
      IF (S.EQ.0.0D0) THEN
C
C  Achromatic case; RGB value is a grey equal to V;
C  H is not defined.
C
          R = V
          G = V
          B = V
      ELSE
C
C  Calculate RGB values.
C
          SM1 = (1.D0-S)*V
          R = DSIGPLC(SM1,V,HH+120.D0)
          G = DSIGPLC(SM1,V,HH+0.D0)
          B = DSIGPLC(SM1,V,HH+240.D0)
      END IF
      RETURN
      END
C
C     $Id: dcolconv.f,v 1.2 2008-07-27 03:40:25 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
      SUBROUTINE DRGBHLS(R,G,B,H,L,S)
C
C_BEGIN PROLOGUE RGBHLS
C
C_PURPOSE
C    This subroutine converts a color specification given as
C    Red, Green, and Blue intensity values to a color specification
C    given as Hue, Lightness, and Saturation values.
C
C_DESCRIPTION
C    This subroutine converts color values given in the
C    Red, Green, Blue (RGB) color space to color values
C    in the Hue, Lightness, and Saturation (HLS) color space.
C    The input Red, Green, and Blue values are intensities
C    in the range [0.,1.]; the output value H is returned
C    as a floating point number in the range [0.,360.);
C    full blue in the input space (red and green values of 0.)
C    corresponds to a hue of 0. in the
C    output space; the output value L is returned as a
C    floating point number in the range [0.,100.];
C    the output value S is returned as a floating
C    point number in the range [0.,100.] .
C
C_ARGUMENTS
C
C R       (INPUT,DOUBLE,VARIABLE)  A real variable in the range
C         [0.,1.] which represents the red intensity component
C         of the input point in RGB color space.
C
C G       (INPUT,DOUBLE,VARIABLE)  A real variable in the range
C         [0.,1.] which represents the green intensity component
C         of the input point in RGB color space.
C
C B       (INPUT,DOUBLE,VARIABLE)  A real variable in the range
C         [0.,1.] which represents the blue intensity component
C         of the input point in RGB color space.
C
C H       (OUTPUT,DOUBLE,VARIABLE)  A real variable in the range
C         [0.,360.) which represents the hue of the input point
C         in HLS color space.  A value of (0.,0.,B) in the input
C         space will result in a hue of 0. in the output space.
C
C L       (OUTPUT,DOUBLE,VARIABLE)  A real variable in the range
C         [0.,100.] which represents the lightness value of the
C         input point in HLS color space.  Lightness is a measure
C         of the quantity of light--a lightness of 0. is black,
C         and a lightness of 100. gives white.  The pure hues occur
C         at lightness value 50.  The lightness should be thought
C         of as a percentage.
C
C S       (OUTPUT,DOUBLE,VARIABLE)  A real variable in the range
C         [0.,100.] which represents the saturation value of the
C         input point in HLS color space.  Saturation is a measure
C         of how much white light is mixed with the color.  Saturation
C         values of 0. represent greys (with a grey value equal to
C         the lightness value L).  Saturation values of 100. are fully
C         saturated colors.  The hue is undefined when S=0.  The
C         fully saturated pure hues occur when S=100. and L=50.
C         The saturation value should be thought of as a percentage.
C
C_I/O
C    (NONE)
C
C_ROUTINES CALLED
C    (NONE)
C
C_COMMON BLOCKS
C    (NONE)
C
C_MAXIMUM GKS LEVEL
C    (NONE)
C
C_LANGUAGE
C    FORTRAN
C
C_REVISION DATE
C    880511 (YYMMDD)
C
C_HISTORY
C    This subroutine was originally coded at NCAR by Roy Barnes
C    based on the algorithm presented in Foley and van Dam (see
C    REFERENCES below); it was prepared for the NCAR Graphics
C    package by Fred Clare.
C
C_REFERENCES
C    Foley, James D. and van Dam, Andries,"Fundamentals of Interactive
C    Computer Graphics",Addison-Wesley Publishing Company, 1982.
C
C    Smith, A.R.,"Color Gamut Transformation Pairs",SIGGRAPH '78
C    Proceedings, published as Computer Graphics, 12(3),August 1978,
C    pp.12-19.
C
C_LONG DESCRIPTION
C    The hues returned can be made to put 0 degrees at red instead
C    of blue by changing the offsets to the computation of H in the
C    code.  Hue 0. representing blue, and S and L values ranging
C    from 0. to 100. instead of 0. to 1. were chosen for compatability
C    with the Tektronix color model, and compatibility with the
C    NCAR FORTRAN CGM translator GRAPHCAPs.
C
C_EXAMPLES
C    Example 1 --  Pure red at full intensity to HLS
C          SUBROUTINE HLS1
C          DOUBLE PRECISION    H,L,S,EPS
C          PARAMETER (EPS=0.00001)
C          CALL RGBHLS(1.,0.,0.,H,L,S)
C          IF ( (ABS(H-120.) .GT. EPS) .OR. (ABS(L-50.) .GT. EPS) .OR.
C         *     (ABS(S-100.) .GT. EPS) ) THEN
C            IUN = I1MACH(4)
C            WRITE(IUN,10)
C          ENDIF
C          RETURN
C       10 FORMAT(' HLS1 returned incorrect values')
C          END
C
C_END PROLOGUE RGBHLS
C
      DOUBLE PRECISION R,G,B,H,L,S,MXINTS,MNINTS,MAXMIN,HSAV,BC,GC,RC,
     +                 RMM
      SAVE HSAV
      DATA HSAV/0.D0/
C
C  Check on input arguments.
C
C_FIRST EXECUTABLE STATEMENT RGBHLS
      IF (R.LT.0.D0 .OR. R.GT.1.D0) CALL SETER
     +    (' RGBHLS - R out of range',1,1)
      IF (G.LT.0.D0 .OR. G.GT.1.D0) CALL SETER
     +    (' RGBHLS - G out of range',1,1)
      IF (B.LT.0.D0 .OR. B.GT.1.D0) CALL SETER
     +    (' RGBHLS - B out of range',1,1)
      MXINTS = MAX(R,G,B)
      MNINTS = MIN(R,G,B)
C
C  Compute lightness
C
      L = (MXINTS+MNINTS)*0.5D0
      IF (MXINTS.EQ.MNINTS) THEN
C
C  Achromatic case.  If the saturation is 0., then leave H
C  as it was in the previous call as per the suggestion of
C  A.V. Smith (see REFERENCES).
C
          S = 0.0D0
          H = HSAV
      ELSE
C
C  Chromatic case.
C
          MAXMIN = MXINTS - MNINTS
          IF (L.LE.0.5D0) THEN
              S = MAXMIN/ (MXINTS+MNINTS)
          ELSE
              S = MAXMIN/ (2.0D0-MXINTS-MNINTS)
          END IF
          RMM = 1.D0/MAXMIN
          RC = (MXINTS-R)*RMM
          GC = (MXINTS-G)*RMM
          BC = (MXINTS-B)*RMM
          IF (R.EQ.MXINTS) THEN
              H = 2.D0 + BC - GC
          ELSE IF (G.EQ.MXINTS) THEN
              H = 4.D0 + RC - BC
          ELSE IF (B.EQ.MXINTS) THEN
              H = 0.D0 + GC - RC
          END IF
C
C  Convert H to degrees.
C
          H = H*60.D0
          IF (H.LT.0.D0) H = H + 360.D0
          HSAV = H
      END IF
C
C  Scale lightness and saturation values.
C
      L = L*100.D0
      S = S*100.D0
      L = MIN(100.D0,MAX(0.D0,L))
      S = MIN(100.D0,MAX(0.D0,S))
      RETURN
      END
C
C     $Id: dcolconv.f,v 1.2 2008-07-27 03:40:25 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE DRGBHSV(R,G,B,H,S,V)
C
C_BEGIN PROLOGUE RGBHSV
C
C_PURPOSE
C    This subroutine converts a color specification given as
C    Red, Green, and Blue intensity values to a color specification
C    in the Hue, Saturation, Value color space.
C
C_DESCRIPTION
C    This subroutine converts color values given in the
C    Red, Green, Blue (RGB) color space to color values
C    in the Hue, Saturation, and Value (HSV) color space.
C    The input Red, Green, and Blue values are intensities
C    in the range [0.,1.]; the output value H is returned
C    as a floating point number in the range [0.,360.) .
C    Full red (green and blue values of 0.) in the
C    input space corresponds to a hue of 0 in the
C    output space; the output value V is returned as a
C    floating point number in the range [0.,1.];
C    the output value S is returned as a floating
C    point number in the range [0.,1.] .
C
C_ARGUMENTS
C
C R       (INPUT,DOUBLE,VARIABLE)  A real variable in the range
C         [0.,1.] which represents the red intensity component
C         of the input point in RGB color space.
C
C G       (INPUT,DOUBLE,VARIABLE)  A real variable in the range
C         [0.,1.] which represents the green intensity component
C         of the input point in RGB color space.
C
C B       (INPUT,DOUBLE,VARIABLE)  A real variable in the range
C         [0.,1.] which represents the blue intensity component
C         of the input point in RGB color space.
C
C H       (OUTPUT,DOUBLE,VARIABLE)  A real variable in the range
C         [0.,360.) which represents the hue of the input point
C         in HSV color space.  A value of (R,0.,0.) in the input
C         space will result in a hue of 0. in the output space.
C
C S       (OUTPUT,DOUBLE,VARIABLE)  A real variable in the range
C         [0.,1.] which represents the saturation value of the
C         input point in HSV color space.  Saturation is a measure
C         of how much white light is mixed with the color. Saturation
C         values of 0. represent greys (with a grey value equal to
C         V).  Saturation values of 1. are fully saturated colors.
C         The hue is technically undefined when S=0; the code leaves
C         H at its previous value when S=0. (0. initially).  The
C         fully saturated pure hues occur when S=1. and V=1.
C
C V       (OUTPUT,DOUBLE,VARIABLE)  A real variable in the range
C         [0.,1.] which represents the value in HSV space.
C
C_I/O
C    (NONE)
C
C_ROUTINES CALLED
C    (NONE)
C
C_COMMON BLOCKS
C    (NONE)
C
C_MAXIMUM GKS LEVEL
C    (NONE)
C
C_LANGUAGE
C    FORTRAN
C
C_REVISION DATE
C    880511 (YYMMDD)
C
C_HISTORY
C    This subroutine was originally coded and prepared for the
C    NCAR Graphics package by Fred Clare based on algorithms
C    in Foley and van Dam (see REFERENCES below).
C
C_REFERENCES
C    Foley, James D. and van Dam, Andries,"Fundamentals of Interactive
C    Computer Graphics",Addison-Wesley Publishing Company, 1982.
C
C    Smith, A.R.,"Color Gamut Transformation Pairs",SIGGRAPH '78
C    Proceedings, published as Computer Graphics, 12(3),August 1978,
C    pp.12-19.
C
C_LONG DESCRIPTION
C    The hues returned can be made to put 0 degrees at blue instead
C    of red by changing the offsets to the computation of H in the
C    code.
C
C_EXAMPLES
C    Example 1 --  Blue to HSV.
C          SUBROUTINE THSV1
C          DOUBLE PRECISION    H,S,V,EPS
C          PARAMETER (EPS=0.00001)
C          CALL RGBHSV(0.,0.,1.,H,S,V)
C          IF ( (ABS(H-240.) .GT. EPS) .OR. (ABS(S-1.) .GT. EPS) .OR.
C         *     (ABS(V-1.) .GT. EPS) ) THEN
C            IUN = I1MACH(4)
C            WRITE(IUN,10)
C          ENDIF
C          RETURN
C       10 FORMAT(' THSV1 returned incorrect values')
C          END
C
C_END PROLOGUE RGBHSV
C
      DOUBLE PRECISION R,G,B,H,S,V,HSAV,RMM,MXINTS,MNINTS,MAXMIN,BC,GC,
     +                 RC
      SAVE HSAV
      DATA HSAV/0.D0/
C
C  Check on input arguments.
C
C_FIRST EXECUTABLE STATEMENT RGBHSV
      IF (R.LT.0.D0 .OR. R.GT.1.D0) CALL SETER
     +    (' RGBHSV - R out of range',1,1)
      IF (G.LT.0.D0 .OR. G.GT.1.D0) CALL SETER
     +    (' RGBHSV - G out of range',1,1)
      IF (B.LT.0.D0 .OR. B.GT.1.D0) CALL SETER
     +    (' RGBHSV - B out of range',1,1)
C
      MXINTS = MAX(R,G,B)
      MNINTS = MIN(R,G,B)
      MAXMIN = MXINTS - MNINTS
C
C  Compute value.
C
      V = MXINTS
C
C  Compute saturation.
C
      IF (MXINTS.EQ.0.D0) THEN
          S = 0.D0
      ELSE
          S = MAXMIN/MXINTS
      END IF
C
C  Compute hue.  If the saturation is 0., then do not define the hue--
C  leave it as it was in the previous call as per the suggestion of
C  A.V. Smith (see REFERENCES).
C
      IF (S.GT.0.D0) THEN
          RMM = 1.D0/MAXMIN
          RC = (MXINTS-R)*RMM
          GC = (MXINTS-G)*RMM
          BC = (MXINTS-B)*RMM
          IF (R.EQ.MXINTS) THEN
              H = 0.D0 + BC - GC
          ELSE IF (G.EQ.MXINTS) THEN
              H = 2.D0 + RC - BC
          ELSE IF (B.EQ.MXINTS) THEN
              H = 4.D0 + GC - RC
          END IF
C
C  Convert H to degrees.
C
          H = H*60.D0
          IF (H.LT.0.D0) H = H + 360.D0
          HSAV = H
      ELSE
          H = HSAV
      END IF
C
C  Guarantee saturation and value are in range.
C
      S = MIN(1.D0,MAX(0.D0,S))
      V = MIN(1.D0,MAX(0.D0,V))
      RETURN
      END
C
      SUBROUTINE DRGBYIQ(R,G,B,Y,I,Q)
C
C_BEGIN PROLOGUE RGBYIQ
C
C_PURPOSE
C    This subroutine converts a color specification given as
C    Red, Green, and Blue intensity values to a color specification
C    in the YIQ color space.
C
C_DESCRIPTION
C    This subroutine converts color values given in the
C    Red, Green, Blue (RGB) color space to color values
C    in the YIQ color space.  The input Red, Green,
C    and Blue values are intensities in the range [0.,1.] .
C
C_ARGUMENTS
C
C R       (INPUT,DOUBLE,VARIABLE)  A real variable in the range
C         [0.,1.] which represents the red intensity component
C         of the input point in RGB color space.
C
C G       (INPUT,DOUBLE,VARIABLE)  A real variable in the range
C         [0.,1.] which represents the green intensity component
C         of the input point in RGB color space.
C
C B       (INPUT,DOUBLE,VARIABLE)  A real variable in the range
C         [0.,1.] which represents the blue intensity component
C         of the input point in RGB color space.
C
C Y       (OUTPUT,DOUBLE,VARIABLE)  A real variable in the range
C         [0.,1.] .  Y is the color component of a television
C         signal which is shown on black-and-white televisions;
C         Y minimizes the effect of two colors appearing different
C         to the human eye but mapping to similar monochrome
C         intensities.
C
C I       (OUTPUT,DOUBLE,VARIABLE)  A real variable in the range
C         [-.6,.6] .  I attains its maximum when the input triple
C         is (1.,0.,0.); I attains its minimum when the input triple
C         is (0.,1.,1.) .
C
C Q       (OUTPUT,DOUBLE,VARIABLE)  A real variable in the range
C         [-.52,.52].  Q attains its maximum when the input triple
C         is (1.,0.,1.); Q attains its minimum when the input triple
C         is (0.,1.,0.).
C
C_I/O
C    (NONE)
C
C_ROUTINES CALLED
C    (NONE)
C
C_COMMON BLOCKS
C    (NONE)
C
C_MAXIMUM GKS LEVEL
C    (NONE)
C
C_LANGUAGE
C    FORTRAN
C
C_REVISION DATE
C    880511 (YYMMDD)
C
C_HISTORY
C    This subroutine was originally coded and prepared for the
C    NCAR Graphics package by Fred Clare based on algorithms
C    in Foley and van Dam (see REFERENCES below).
C
C_REFERENCES
C    Foley, James D. and van Dam, Andries,"Fundamentals of Interactive
C    Computer Graphics",Addison-Wesley Publishing Company, 1982.
C
C_EXAMPLES
C    Example 1 --  Full white to YIQ.
C          SUBROUTINE TYIQ1
C          DOUBLE PRECISION    Y,I,Q,EPS
C          PARAMETER (EPS=0.01)
C          CALL RGBYIQ(1.,1.,1.,Y,I,Q)
C          IF ( (ABS(Y-1.) .GT. EPS) .OR. (ABS(I) .GT. EPS) .OR.
C         *     (ABS(Q) .GT. EPS) ) THEN
C            IUN = I1MACH(4)
C            WRITE(IUN,10)
C          ENDIF
C          RETURN
C       10 FORMAT(' TYIQ1 returned incorrect values')
C          END
C
C_END PROLOGUE RGBYIQ
C
      DOUBLE PRECISION R,G,B,Y,I,Q
C
C_FIRST EXECUTABLE STATEMENT RGBYIQ
      Y = 0.2988922D0*R + 0.5870147D0*G + 0.1140931D0*B
      I = 0.5960695D0*R - 0.2743087D0*G - 0.3217608D0*B
      Q = 0.2113775D0*R - 0.5229881D0*G + 0.3116106D0*B
C
      RETURN
      END
C
      SUBROUTINE DYIQRGB(Y,I,Q,R,G,B)
C
C_BEGIN PROLOGUE YIQRGB
C
C_PURPOSE
C    This subroutine converts a color specification given in
C    the YIQ coordinate system to the equivalent color
C    specification in the Red, Green, Blue coordinate system.
C
C_DESCRIPTION
C    This subroutine converts color values given in the
C    YIQ coordinate system to colors in the RGB coordinate
C    system.  The input value Y is in the range [0.,1.];
C    I is in the range [-.6,.6]; Q is in the range [-.52,.52].
C    The output values R, G, and B are red, green, and blue
C    intensities in the range [0.,1.] .
C
C_ARGUMENTS
C
C Y       (INPUT,DOUBLE,VARIABLE)  A real variable in the range
C         [0.,1.] .  Y is the color component of a television
C         signal which is shown on black-and-white televisions;
C         Y minimizes the effect of two colors appearing different
C         to the human eye but mapping to similar monochrome
C         intensities.
C
C I       (INPUT,DOUBLE,VARIABLE)  A real variable in the range
C         [-.6,.6] .
C
C Q       (INPUT,DOUBLE,VARIABLE)  A real variable in the range
C         [-.52,.52].
C
C R       (OUTPUT,DOUBLE,VARIABLE)  A real variable in the range
C         [0.,1.] which represents the red intensity component
C         of the output color in RGB color space.
C
C G       (OUTPUT,DOUBLE,VARIABLE)  A real variable in the range
C         [0.,1.] which represents the green intensity component
C         of the output color in RGB color space.
C
C B       (OUTPUT,DOUBLE,VARIABLE)  A real variable in the range
C         [0.,1.] which represents the blue intensity component
C         of the output color in RGB color space.
C
C_I/O
C    (NONE)
C
C_ROUTINES CALLED
C    (NONE)
C
C_COMMON BLOCKS
C    (NONE)
C
C_MAXIMUM GKS LEVEL
C    (NONE)
C
C_LANGUAGE
C    FORTRAN
C
C_REVISION DATE
C    880511 (YYMMDD)
C
C_HISTORY
C    This subroutine was originally coded and prepared for the
C    NCAR Graphics package by Fred Clare based on algorithms
C    in Foley and van Dam (see REFERENCES below).
C
C_REFERENCES
C    Foley, James D. and van Dam, Andries,"Fundamentals of Interactive
C    Computer Graphics",Addison-Wesley Publishing Company, 1982.
C
C_EXAMPLES
C    Example 1 --  Convert green from YIQ to RGB.
C          SUBROUTINE TYIQ2
C          DOUBLE PRECISION    R,G,B,EPS
C          PARAMETER (EPS=0.01)
C          CALL YIQRGB(.59,-.28,-.52,R,G,B)
C          IF ( (ABS(R-0.) .GT. EPS) .OR. (ABS(G-1.) .GT. EPS) .OR.
C         *     (ABS(B-0.) .GT. EPS) ) THEN
C            IUN = I1MACH(4)
C            WRITE(IUN,10)
C          ENDIF
C          RETURN
C       10 FORMAT(' TYIQ2 returned incorrect values')
C          END
C
C_END PROLOGUE YIQRGB
C
      DOUBLE PRECISION R,G,B,Y,I,Q
C
C  Check on the input values.
C
C_FIRST EXECUTABLE STATEMENT YIQRGB
C
      R = Y + .956D0*I + .621D0*Q
      G = Y - .272D0*I - .647D0*Q
      B = Y - 1.105D0*I + 1.702D0*Q
      R = MIN(MAX(R,0.D0),1.D0)
      G = MIN(MAX(G,0.D0),1.D0)
      B = MIN(MAX(B,0.D0),1.D0)
      RETURN
      END
      DOUBLE PRECISION FUNCTION DSIGPLC(M1,M2,HUE)
C
C_BEGIN PROLOGUE DSIGPLC
C
C_SUBSIDIARY DHLSRGB, DHSVRGB
C
C_PURPOSE
C    To define a generic piecewise linear curve (as a function
C    of HUE) which can be used to calculate the R, G, B
C    values.
C
C_DESCRIPTION
C    This subroutine takes a minimum and maximum value and
C    defines a piecewise linear curve as a function of HUE.
C
C_ARGUMENTS
C
C M1      (INPUT,SINGLE,VARIABLE)  The minimum value.
C
C M2      (INPUT,SINGLE,VARIABLE)  The maximum value.
C
C HUE     (INPUT,SINGLE,VARIABLE)  Hue.
C
C_I/O
C    (NONE)
C
C_ROUTINES CALLED
C    (NONE)
C
C_COMMON BLOCKS
C    (NONE)
C
C_MAXIMUM GKS LEVEL
C    (NONE)
C
C_LANGUAGE
C    FORTRAN
C
C_REVISION DATE
C    070803 (YYMMDD)
C
C_HISTORY
C    This subroutine was originally coded at NCAR by Roy Barnes
C    using the algorithm presented in Foley and van Dam (see
C    REFERENCES); it was prepared for the NCAR Graphics
C    package by Fred Clare.
C
C_REFERENCES
C    Foley, James D. and van Dam, Andries,"Fundamentals of Interactive
C    Computer Graphics",Addison-Wesley Publishing Company, 1982.
C
C    Smith, A.R.,"Color Gamut Transformation Pairs",SIGGRAPH '78
C    Proceedings, published as Computer Graphics, 12(3),August 1978,
C    pp.12-19.
C
C_END PROLOGUE DSIGPLC
C
      DOUBLE PRECISION M1,M2,HUE,H
C_FIRST EXECUTABLE STATEMENT DSIGPLC
      H = HUE
      H = MOD(H,360.D0)
      IF (H.LT.0.D0) H = H + 360.D0
      IF (H.LT.60.0D0) THEN
C
C  Linear curve from M1 to M2 if HUE is in [0.,60.)
C
          DSIGPLC = M1 + (M2-M1)*H/60.0D0
      ELSE IF (H.LT.180.0D0) THEN
C
C  Maximum value for HUE in [60.,180.)
C
          DSIGPLC = M2
      ELSE IF (H.LT.240.0D0) THEN
C
C  Linear curve from M2 to M1 for HUE in [180.,240.)
C
          DSIGPLC = M1 + (M2-M1)* (240.0D0-H)/60.0D0
      ELSE
C
C  Minimum value for HUE in [240.,360.)
C
          DSIGPLC = M1
      END IF
C
C  Guarantee DSIGPLC is in the range 0. to 1.
C
      DSIGPLC = MIN(1.D0,MAX(0.D0,DSIGPLC))
      RETURN
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C   FFTPACK 5.0
C   Copyright (C) 1995-2004, Scientific Computing Division,
C   University Corporation for Atmospheric Research
C   Licensed under the GNU General Public License (GPL)
C
C   Authors:  Paul N. Swarztrauber and Richard A. Valent
C
C   $Id: r1f2kb.f,v 1.2 2006-11-21 01:10:18 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      SUBROUTINE DR1F2KB(IDO,L1,CC,IN1,CH,IN2,WA1)
      DOUBLE PRECISION CC(IN1,IDO,2,L1),CH(IN2,IDO,L1,2),WA1(IDO)
C
      DO 101 K = 1,L1
          CH(1,1,K,1) = CC(1,1,1,K) + CC(1,IDO,2,K)
          CH(1,1,K,2) = CC(1,1,1,K) - CC(1,IDO,2,K)
  101 CONTINUE
      IF (IDO-2) 107,105,102
  102 IDP2 = IDO + 2
      DO 104 K = 1,L1
          DO 103 I = 3,IDO,2
              IC = IDP2 - I

              CH(1,I-1,K,1) = CC(1,I-1,1,K) + CC(1,IC-1,2,K)
              CH(1,I,K,1) = CC(1,I,1,K) - CC(1,IC,2,K)

              CH(1,I-1,K,2) = WA1(I-2)* (CC(1,I-1,1,K)-CC(1,IC-1,2,K)) -
     +                        WA1(I-1)* (CC(1,I,1,K)+CC(1,IC,2,K))
              CH(1,I,K,2) = WA1(I-2)* (CC(1,I,1,K)+CC(1,IC,2,K)) +
     +                      WA1(I-1)* (CC(1,I-1,1,K)-CC(1,IC-1,2,K))

  103     CONTINUE
  104 CONTINUE
      IF (MOD(IDO,2).EQ.1) RETURN
  105 DO 106 K = 1,L1
          CH(1,IDO,K,1) = CC(1,IDO,1,K) + CC(1,IDO,1,K)
          CH(1,IDO,K,2) = - (CC(1,1,2,K)+CC(1,1,2,K))
  106 CONTINUE
  107 RETURN
      END

      SUBROUTINE CGEHD2( N, ILO, IHI, A, LDA, TAU, WORK, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      INTEGER            IHI, ILO, INFO, LDA, N
*     ..
*     .. Array Arguments ..
      COMPLEX            A( LDA, * ), TAU( * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  CGEHD2 reduces a complex general matrix A to upper Hessenberg form H
*  by a unitary similarity transformation:  Q' * A * Q = H .
*
*  Arguments
*  =========
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  ILO     (input) INTEGER
*  IHI     (input) INTEGER
*          It is assumed that A is already upper triangular in rows
*          and columns 1:ILO-1 and IHI+1:N. ILO and IHI are normally
*          set by a previous call to CGEBAL; otherwise they should be
*          set to 1 and N respectively. See Further Details.
*          1 <= ILO <= IHI <= max(1,N).
*
*  A       (input/output) COMPLEX array, dimension (LDA,N)
*          On entry, the n by n general matrix to be reduced.
*          On exit, the upper triangle and the first subdiagonal of A
*          are overwritten with the upper Hessenberg matrix H, and the
*          elements below the first subdiagonal, with the array TAU,
*          represent the unitary matrix Q as a product of elementary
*          reflectors. See Further Details.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(1,N).
*
*  TAU     (output) COMPLEX array, dimension (N-1)
*          The scalar factors of the elementary reflectors (see Further
*          Details).
*
*  WORK    (workspace) COMPLEX array, dimension (N)
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value.
*
*  Further Details
*  ===============
*
*  The matrix Q is represented as a product of (ihi-ilo) elementary
*  reflectors
*
*     Q = H(ilo) H(ilo+1) . . . H(ihi-1).
*
*  Each H(i) has the form
*
*     H(i) = I - tau * v * v'
*
*  where tau is a complex scalar, and v is a complex vector with
*  v(1:i) = 0, v(i+1) = 1 and v(ihi+1:n) = 0; v(i+2:ihi) is stored on
*  exit in A(i+2:ihi,i), and tau in TAU(i).
*
*  The contents of A are illustrated by the following example, with
*  n = 7, ilo = 2 and ihi = 6:
*
*  on entry,                        on exit,
*
*  ( a   a   a   a   a   a   a )    (  a   a   h   h   h   h   a )
*  (     a   a   a   a   a   a )    (      a   h   h   h   h   a )
*  (     a   a   a   a   a   a )    (      h   h   h   h   h   h )
*  (     a   a   a   a   a   a )    (      v2  h   h   h   h   h )
*  (     a   a   a   a   a   a )    (      v2  v3  h   h   h   h )
*  (     a   a   a   a   a   a )    (      v2  v3  v4  h   h   h )
*  (                         a )    (                          a )
*
*  where a denotes an element of the original matrix A, h denotes a
*  modified element of the upper Hessenberg matrix H, and vi denotes an
*  element of the vector defining H(i).
*
*  =====================================================================
*
*     .. Parameters ..
      COMPLEX            ONE
      PARAMETER          ( ONE = ( 1.0E+0, 0.0E+0 ) )
*     ..
*     .. Local Scalars ..
      INTEGER            I
      COMPLEX            ALPHA
*     ..
*     .. External Subroutines ..
      EXTERNAL           CLARF, CLARFG, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          CONJG, MAX, MIN
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters
*
      INFO = 0
      IF( N.LT.0 ) THEN
         INFO = -1
      ELSE IF( ILO.LT.1 .OR. ILO.GT.MAX( 1, N ) ) THEN
         INFO = -2
      ELSE IF( IHI.LT.MIN( ILO, N ) .OR. IHI.GT.N ) THEN
         INFO = -3
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -5
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'CGEHD2', -INFO )
         RETURN
      END IF
*
      DO 10 I = ILO, IHI - 1
*
*        Compute elementary reflector H(i) to annihilate A(i+2:ihi,i)
*
         ALPHA = A( I+1, I )
         CALL CLARFG( IHI-I, ALPHA, A( MIN( I+2, N ), I ), 1, TAU( I ) )
         A( I+1, I ) = ONE
*
*        Apply H(i) to A(1:ihi,i+1:ihi) from the right
*
         CALL CLARF( 'Right', IHI, IHI-I, A( I+1, I ), 1, TAU( I ),
     $               A( 1, I+1 ), LDA, WORK )
*
*        Apply H(i)' to A(i+1:ihi,i+1:n) from the left
*
         CALL CLARF( 'Left', IHI-I, N-I, A( I+1, I ), 1,
     $               CONJG( TAU( I ) ), A( I+1, I+1 ), LDA, WORK )
*
         A( I+1, I ) = ALPHA
   10 CONTINUE
*
      RETURN
*
*     End of CGEHD2
*
      END

C
C	$Id: wmstnm.f,v 1.17 2010-01-05 03:52:14 fred Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE WMSTNM(X,Y,IMDAT)
C
C  This subroutine plots station model data as per the NOAA/WMO
C  guidelines.  (X,Y) is a world coordinate specifying the center
C  of the tail of the windbarb shaft.  IMDAT is a CHARACTER*5 array 
C  of length 9 that contains the coded model data.  The first member 
C  of the  IMDAT array contains IR,IX,H,VV (in that order), and the 
C  second member contains N,DD,FF (in that order).  The remaining members
C  of IMDAT contain, as their first character, a group identifier.
C
C  In a little more detail:
C
C     IMDAT(1)( 1: 1) = iR - precipitation data indictor.
C     IMDAT(1)( 2: 2) = iX - weather data and station type indicator. 
C     IMDAT(1)( 3: 3) =  h - height above ground of base lowest cloud.
C     IMDAT(1)( 4: 5) = VV - visibility in miles and fractions for
C                            imperial units (UNT=0), or kilometers
C                            in metric units (UNT=1).
C
C     IMDAT(2)( 1: 1) =  N - total amount of cloud cover.
C     IMDAT(2)( 2: 3) = dd - direction from which wind is blowing.
C     IMDAT(2)( 4: 5) = ff - wind speed in knots.
C
C     For I=3,9 if IMDAT(I)(1:1) =
C
C             '1', then IMDAT(I)(2:2) =  sn - sign of temperature
C                       IMDAT(I)(3:5) = TTT - current air temperature
C
C             '2', then IMDAT(I)(2:2) =  sn - sign of temperature
C                       IMDAT(I)(3:5) =  Td - dew point
C
C             '3', then IMDAT(I)(2:5) =  PO - station pressure
C
C             '4', then IMDAT(I)(2:5) =  PPPP - pressure reduced to sea level
C
C             '5', then IMDAT(I)(2:2) =   a - characteristic of barograph trace
C                       IMDAT(I)(3:5) = ppp - pressure change, last 3 hrs.
C
C             '6', then IMDAT(I)(2:4) = RRR - precipitation
C                       IMDAT(I)(5:5) =  tr - time duration of precipitation
C
C             '7', then IMDAT(I)(2:3) =  ww - present weather
C                       IMDAT(I)(4:4) =  W1 - most significant past weather
C                       IMDAT(I)(5:5) =  W2 - 2nd most significant past weather
C
C             '8', then IMDAT(I)(2:2) =  Nh - fraction of sky cover
C                       IMDAT(I)(3:3) =  CL - cloud type, low clouds
C                       IMDAT(I)(4:4) =  CM - cloud type, medium clouds
C                       IMDAT(I)(5:5) =  CH - cloud type, high clouds
C
      include 'wmcomn.h'
C
      INTEGER WMGTLN
      PARAMETER (NFIELD=10,NPARMS=25)
      INTEGER WDATA(NPARMS)
C
C  Variables for the encoded fields.
C
C    IR   - Precipitation data indicator.
C    IX   - Weather data and station type indicator.
C    H    - Height above ground of lowest cloud.
C    VV   - Visibility in miles and fractions.
C    N    - Amount of cloud cover.
C    DD   - Wind direction.
C    FF   - Wind speed in knots.
C    SN1  - Sign of the ambient temperature.
C    TTT  - Current air temperature.
C    SN2  - Sign of temperature of the dew point.
C    TD   - Temperature of the dew point.
C    PO   - Station pressure (not plotted).
C    PPPP - Baromatric pressure.
C    A    - Barometric pressure tendency.
C    PPP  - Pressure change in last three hours.
C    RRR  - Amount of precipitation in last six hours.
C    TR   - Time period for the precipitation amount.
C    WW   - Present weather.
C    W1   - Most significant past weather.
C    W2   - Second most significant past weather.
C    NH   - Fraction of the sky covered by low or middle clouds.
C    CL   - Cloud type for low clouds.
C    CM   - Cloud type for medium clouds.
C    CH   - Cloud type for high clouds.
C
      COMMON /WMSLOC/ IR,IX,H,VV,N,DD,FF,SN1,TTT,SN2,TD,PO,PPPP,A,
     +                PPP,RRR,TR,WW,W1,W2,NH,CL,CM,CH,GPID
      INTEGER         IR,IX,H,VV,N,DD,FF,SN1,TTT,SN2,TD,PO,PPPP,A,
     +                PPP,RRR,TR,WW,W1,W2,NH,CL,CM,CH,GPID
      EQUIVALENCE(WDATA,IR)
C
      PARAMETER (NUMSYM=14,D2RAD=0.017453293)
      CHARACTER*5 IMDAT(NFIELD)
C
C  IPRSNT is an array indicating whether a value for a symbol
C  has been entered.
C
C    IPRSNT -
C     index sym       type          IMDAT          Character #
C     ----- ---  ---------------  --------------   -----------
C       1    CH      high clouds   IMDAT(10)(5:5)         49
C       2    CM    medium clouds   IMDAT(10)(4:4)         48
C       3   TTT      temperature   IMDAT( 3)(2:5)      11-14
C       4   PPP   pressure @ sea   IMDAT( 6)(2:5)      26-29
C       5    VV       visibility   IMDAT( 1)(4:5)       3- 4
C       6    WW     past weather   IMDAT( 9)(4:4)         43
C       7    PP    pressure chg.   IMDAT( 7)(3:5)      32-34
C       8     A        barograph   IMDAT( 7)(2:2)         31
C       9    Td        dew point   IMDAT( 4)(2:5)      16-19
C      10    CL       low clouds   IMDAT(10)(3:3)         47
C      11    Nh        sky cover   IMDAT(10)(2:2)         46
C      12     W   prsent weather   IMDAT( 9)(2:3)      41-42
C      13     h     lowest cloud   IMDAT( 1)(3:3)          2
C      14    RR           precip.  IMDAT( 8)(2:4)      36-38
C
      DIMENSION SYMPOS(2,NUMSYM),IFNTNM(NUMSYM),IPRSNT(NUMSYM)
      CHARACTER*3 CHRS(NUMSYM)
      CHARACTER CHR5*5,CHR3*3,IFMT*8
C
      DIMENSION BRBEXT(4),CHREXT(4),RINTSC(4)
      REAL CTEMP
C
C  Sample character strings to help position labels.
C
      DATA IFNTNM/37,37,21,21,21,37,21,21,21,37,21,21,21,21/
      DATA CHRS/'Q'  ,'E'  ,'XX' ,'XpX','XXX',')'  ,'+Xp',
     +          'X'  ,'XX' ,'?'  ,'XX' ,'W'  ,'X'  ,'XX'  /
C
C  Check error status.
C
      IF (ICFELL('WMSTNM - Uncleared prior error',1) .NE. 0) RETURN
C
C  Color setting.
C
      CALL WMGETI('COL',ICOL)
      ICOLOR = ICOL
      CALL GQTXCI(IER,ITXCOL)
      CALL GSTXCI(ICOL)
      CALL PCGETI('CC',IPCOL)
      CALL PCSETI('CC',ICOL)
C
C  Initialize and decode the data.
C
      DO 210 I=1,NPARMS
        WDATA(I) = 0
  210 CONTINUE
      DO 45 I=1,NUMSYM
        IPRSNT(I) = 0
   45 CONTINUE
      READ(IMDAT(1)(1:1),'(I1)') IR 
      READ(IMDAT(1)(2:2),'(I1)') IX 
      IF (IX.EQ.2 .OR. IX.EQ.5) RETURN
C
      IF (IMDAT(1)(3:3) .EQ. '/') THEN
        IPRSNT(13) = 0
      ELSE
        READ(IMDAT(1)(3:3),'(I1)') H
        IPRSNT(13) = 1
      ENDIF
C
      IF (IMDAT(1)(4:5) .EQ. '//') THEN
        IPRSNT(5) = 0
      ELSE
        READ(IMDAT(1)(4:5),'(I2)') VV
        IPRSNT(5) = 1
      ENDIF
C
      IF (IMDAT(2)(1:1) .EQ. '/') THEN
        N = 0
      ELSE
        READ(IMDAT(2)(1:1),'(I1)') N
      ENDIF
      READ(IMDAT(2)(2:3),'(I2)') DD
      IBFLAG = 1
C
C  Do not plot a wind barb if the wind direction is specified as blanks.
C
      IF (IMDAT(2)(2:3) .EQ. '  ') THEN
        IBFLAG = 0
      ENDIF
      READ(IMDAT(2)(4:5),'(I2)') FF
      DO 200 I=3,NFIELD
        READ(IMDAT(I)(1:1),'(I1)') GPID
        IF (GPID .EQ. 1) THEN
          READ(IMDAT(I)(2:2),'(I1)') SN1
          READ(IMDAT(I)(3:5),'(I3)') TTT
          IF (SN1 .GT. 0) TTT = -TTT
          IPRSNT(3) = 1
        ELSE IF (GPID .EQ. 2) THEN
          READ(IMDAT(I)(2:2),'(I1)') SN2
          READ(IMDAT(I)(3:5),'(I3)') TD
          IPRSNT(9) = 1
          IF (SN2 .GT. 0) TD = -TD
        ELSE IF (GPID .EQ. 3) THEN
          READ(IMDAT(I)(2:5),'(I4)') PO
        ELSE IF (GPID .EQ. 4) THEN
          READ(IMDAT(I)(3:5),'(I3)') PPPP
          IPRSNT(4) = 1
        ELSE IF (GPID .EQ. 5) THEN
          READ(IMDAT(I)(2:2),'(I1)') A
          IPRSNT(8) = 1
          READ(IMDAT(I)(3:5),'(I3)') PPP
          IPRSNT(7) = 1
        ELSE IF (GPID .EQ. 6) THEN
          READ(IMDAT(I)(2:4),'(I3)') RRR
          IPRSNT(14) = 1
          READ(IMDAT(I)(5:5),'(I1)') TR
        ELSE IF (GPID .EQ. 7) THEN
          READ(IMDAT(I)(2:3),'(I2)') WW
          IPRSNT(6) = 1
          READ(IMDAT(I)(4:4),'(I1)') W1
          IPRSNT(12) = 1
          READ(IMDAT(I)(5:5),'(I1)') W2
        ELSE IF (GPID .EQ. 8) THEN
          READ(IMDAT(I)(2:2),'(I1)') NH
          IPRSNT(11) = 1
          READ(IMDAT(I)(3:3),'(I1)') CL
          IPRSNT(10) = 1
          READ(IMDAT(I)(4:4),'(I1)') CM
          IPRSNT(2) = 1
          READ(IMDAT(I)(5:5),'(I1)') CH
          IPRSNT(1) = 1
        ENDIF 
  200 CONTINUE
C
      CALL PCGETI('FN',IFOLD)
      EPS = 0.06*WBSHFT
C
C  Convert X and Y to NDC and work in NDC space.
C
      CALL WMW2NX(1,X,XNDC)
      CALL WMW2NY(1,Y,YNDC)
      CALL GQCNTN(IER,NTRO)
      CALL GSELNT(0)
      SIZ = WBLSIZ*WBSHFT
C
C  Draw the wind barb and cloud cover.  Define the barb angle in 
C  degrees and radians (0 degrees is North); define the corresponding
C  trig angle (90 is north) in degrees and radians.
C
      BANGD = REAL(10*DD)
      BANGR = BANGD*D2RAD
      TANGD = REAL(90-10*DD)
      TANGR = TANGD*D2RAD
      UX = COS(TANGR)
      UY = SIN(TANGR)
      CALL WMGETI('WBF',IBO)
      CALL WMSETI('WBF',1)
      IF (IBFLAG .EQ. 1) THEN
        CALL WMBARB(XNDC,YNDC,REAL(FF)*UX,REAL(FF)*UY)
        CALL WMSETI('WBF',IBO)
        IF (FF.EQ.0 .AND. DD.EQ.0) THEN
          CALL NGWSYM('N',N,XNDC,YNDC,WBCLMR*WBSHFT,ICOLOR,0)
        ELSE
          CALL NGWSYM('N',N,XNDC,YNDC,WBBASE*WBSHFT,ICOLOR,0)
        ENDIF
      ENDIF
C
C  Set up initial coordinates for the symbol positions relative to 
C  the the position of the wind barb and its length.
C
C
C  High clouds (CH).
C
      SYMPOS(1,1) = XNDC
      SYMPOS(2,1) = YNDC+0.83*WBSHFT
C
C  Medium clouds (CM).
C
      SYMPOS(1,2) = XNDC
      SYMPOS(2,2) = YNDC+0.47*WBSHFT
C
C  Current temperature (TT).
C
      SYMPOS(1,3) = XNDC-0.5*WBSHFT
      SYMPOS(2,3) = YNDC+0.36*WBSHFT
C
C  Barometric pressure (ppp).
C
      SYMPOS(1,4) = XNDC+0.55*WBSHFT
      SYMPOS(2,4) = YNDC+0.36*WBSHFT
C
C  Visibility (VV).
C
      SYMPOS(1,5) = XNDC-.95*WBSHFT
      SYMPOS(2,5) = YNDC
C
C  Present weather (ww).
C
      SYMPOS(1,6) = XNDC-0.45*WBSHFT
      SYMPOS(2,6) = YNDC
C
C  Pressure change (pp).
C
      SYMPOS(1,7) = XNDC+0.5*WBSHFT
      SYMPOS(2,7) = YNDC
C
C  Pressure tendency (a).
C
      SYMPOS(1,8) = XNDC+1.00*WBSHFT
      SYMPOS(2,8) = YNDC
C
C  Temperature of dewpoint (TD).
C
      SYMPOS(1,9) = XNDC-0.65*WBSHFT
      SYMPOS(2,9) = YNDC-0.42*WBSHFT
C
C  Low clouds (CL).
C
      SYMPOS(1,10) = XNDC-0.17*WBSHFT
      SYMPOS(2,10) = YNDC-0.42*WBSHFT
C
C  Sky cover (NH).
C
      SYMPOS(1,11) = XNDC+0.31*WBSHFT
      SYMPOS(2,11) = YNDC-0.42*WBSHFT
C
C  Past weather (W).
C
      SYMPOS(1,12) = XNDC+0.75*WBSHFT
      SYMPOS(2,12) = YNDC-0.42*WBSHFT
C
C  Cloud height (h).
C
      SYMPOS(1,13) = XNDC-0.12*WBSHFT
      SYMPOS(2,13) = YNDC-0.72*WBSHFT
C
C  Precipitation in last 6 hours (RR).
C
      SYMPOS(1,NUMSYM) = XNDC+0.53*WBSHFT
      SYMPOS(2,NUMSYM) = YNDC-0.72*WBSHFT
C
C  If the wind speed is not calm, revise the symbol positions based 
C  on the wind barb direction and the rectangular area containing the 
C  tick marks on the barb.
C
      IF (FF .EQ. 0) GO TO 220
      CALL WMGETR('WXL',BRBEXT(1))
      CALL WMGETR('WXR',BRBEXT(3))
      CALL WMGETR('WYB',BRBEXT(2))
      CALL WMGETR('WYT',BRBEXT(4))
      IF (BANGD .EQ. 0.) THEN
C
C  Move CH, CM, and TT to the left.
C
        ISYM = 1
        CALL WMCEXT(ISYM,IFNTNM(ISYM),SYMPOS(1,ISYM),SYMPOS(2,ISYM),
     +            CHRS(ISYM),SIZ,CHREXT)
        OFFSET = EPS+0.5*(CHREXT(3)-CHREXT(1))
        SYMPOS(1,1) = SYMPOS(1,1)-OFFSET
        SYMPOS(1,2) = SYMPOS(1,2)-OFFSET
        SYMPOS(1,3) = SYMPOS(1,3)-OFFSET
      ELSE IF (BANGD.GT.0. .AND. BANGD.LE.50.) THEN
C
C  If CH is present, find the intersection of its text extent box
C  with that of the extent box of the wind barb, and move symbols
C  CH, CM, and TT left by a suitable amount.
C
        IF (IPRSNT(1) .EQ. 1) THEN
          ISYM = 1
          CALL WMCEXT(ISYM,IFNTNM(ISYM),SYMPOS(1,ISYM),SYMPOS(2,ISYM),
     +                CHRS(ISYM),SIZ,CHREXT)
          CALL WMSECT(BRBEXT,CHREXT,IFLG,RINTSC)
          IF (IFLG .EQ. 1) THEN
            SYMPOS(1,ISYM) = BRBEXT(1)-EPS-0.5*(CHREXT(3)-CHREXT(1))
          ENDIF
        ENDIF
        ORIG = SYMPOS(2,2)
C
C  If CM is present, find the intersection of its text extent box
C  with that of the extent box of the wind barb, and move symbols
C  CM, and TT left by a suitable amount.
C
        IF (IPRSNT(2) .EQ. 1) THEN
          ISYM = 2
          CALL WMCEXT(ISYM,IFNTNM(ISYM),SYMPOS(1,ISYM),SYMPOS(2,ISYM),
     +                CHRS(ISYM),SIZ,CHREXT)
          CALL WMSECT(BRBEXT,CHREXT,IFLG,RINTSC)
          IF (IFLG .EQ. 1) THEN
            SYMPOS(1,ISYM) = BRBEXT(1)-EPS-0.5*(CHREXT(3)-CHREXT(1))
            ODIFF = ABS(ORIG-SYMPOS(1,ISYM))
            SYMPOS(1,3) = SYMPOS(1,3)-ODIFF
          ENDIF
        ENDIF
C
C  If the pressure reading runs into the windbarb ticks, move it.
C
        IF (IPRSNT(4) .EQ. 1) THEN
          ISYM = 4
          CALL WMCEXT(ISYM,IFNTNM(ISYM),SYMPOS(1,ISYM),SYMPOS(2,ISYM),
     +                CHRS(ISYM),SIZ,CHREXT)
          CALL WMSECT(BRBEXT,CHREXT,IFLG,RINTSC)
          IF (IFLG .EQ. 1) THEN
            OFFSET = (BRBEXT(4)-BRBEXT(2))-(WBFTIC*WBSHFT*SIN(BANGR))
            OFFSET = OFFSET*TAN(BANGR)
            SYMPOS(1,ISYM) = BRBEXT(3)-OFFSET+0.25*WBSHFT+
     +                         0.5*(CHREXT(3)-CHREXT(1))
            OFFSET = 0.0025*BANGD*WBSHFT
            SYMPOS(2,ISYM) = SYMPOS(2,ISYM)-OFFSET
          ENDIF
          IF (BANGD .GE. 25.) THEN
            OFFSET = 0.005*(BANGD-25.)*WBSHFT
            SYMPOS(2,7) = SYMPOS(2,7)-OFFSET
            SYMPOS(2,8) = SYMPOS(2,8)-OFFSET
          ENDIF
        ENDIF
      ELSE IF (BANGD.GT.50. .AND. BANGD.LE.60.) THEN
C
C  Move pressure reading up and pressure change and tendency down.
C
        IF (IPRSNT(4) .EQ. 1) THEN
          ISYM = 4
          CALL WMCEXT(ISYM,IFNTNM(ISYM),SYMPOS(1,ISYM),SYMPOS(2,ISYM),
     +                CHRS(ISYM),SIZ,CHREXT)
          CALL WMSECT(BRBEXT,CHREXT,IFLG,RINTSC)
          IF (IFLG .EQ. 1) THEN
            SYMPOS(2,ISYM) = BRBEXT(4)+EPS+
     +                         0.5*(CHREXT(4)-CHREXT(2))
          ENDIF
        ENDIF
        IF (IPRSNT(7) .EQ. 1) THEN
          ISYM = 7
          CALL WMCEXT(ISYM,IFNTNM(ISYM),SYMPOS(1,ISYM),SYMPOS(2,ISYM),
     +                CHRS(ISYM),SIZ,CHREXT)
          CALL WMSECT(BRBEXT,CHREXT,IFLG,RINTSC)
          IF (IFLG .EQ. 1) THEN
            SYMPOS(2,ISYM) = BRBEXT(2)-EPS-
     +                         0.5*(CHREXT(4)-CHREXT(2))
            SYMPOS(2,8) = BRBEXT(2)-EPS-
     +                         0.5*(CHREXT(4)-CHREXT(2))
          ENDIF
        ELSE IF (IPRSNT(8) .EQ. 1) THEN
          ISYM = 8
          CALL WMCEXT(ISYM,IFNTNM(ISYM),SYMPOS(1,ISYM),SYMPOS(2,ISYM),
     +                CHRS(ISYM),SIZ,CHREXT)
          CALL WMSECT(BRBEXT,CHREXT,IFLG,RINTSC)
          IF (IFLG .EQ. 1) THEN
            SYMPOS(2,ISYM) = BRBEXT(2)-EPS-
     +                         0.5*(CHREXT(4)-CHREXT(2))
          ENDIF
        ENDIF
      ELSE IF (BANGD.GE.60. .AND. BANGD.LT.80.) THEN
C
C  Move pressure reading up and pressure change and tendency down.
C
        IF (IPRSNT(4) .EQ. 1) THEN
          ISYM = 4
          CALL WMCEXT(ISYM,IFNTNM(ISYM),SYMPOS(1,ISYM),SYMPOS(2,ISYM),
     +                CHRS(ISYM),SIZ,CHREXT)
          CALL WMSECT(BRBEXT,CHREXT,IFLG,RINTSC)
          IF (IFLG .EQ. 1) THEN
            SYMPOS(2,ISYM) = BRBEXT(4)+EPS+
     +                         0.5*(CHREXT(4)-CHREXT(2))
          ENDIF
        ENDIF
        ORIGP = YNDC
        DIFFP = 0.
        IF (IPRSNT(7) .EQ. 1) THEN
          ISYM = 7
          CALL WMCEXT(ISYM,IFNTNM(ISYM),SYMPOS(1,ISYM),SYMPOS(2,ISYM),
     +                CHRS(ISYM),SIZ,CHREXT)
          CALL WMSECT(BRBEXT,CHREXT,IFLG,RINTSC)
          IF (IFLG .EQ. 1) THEN
            SYMPOS(2,ISYM) = BRBEXT(2)-EPS-
     +                         0.5*(CHREXT(4)-CHREXT(2))
            SYMPOS(2,8) = BRBEXT(2)-EPS-
     +                         0.5*(CHREXT(4)-CHREXT(2))
            DIFFP = ABS(ORIGP-SYMPOS(2,ISYM))  
          ENDIF
        ENDIF
        IF (IPRSNT(8) .EQ. 1) THEN
          ISYM = 8
          CALL WMCEXT(ISYM,IFNTNM(ISYM),SYMPOS(1,ISYM),SYMPOS(2,ISYM),
     +                CHRS(ISYM),SIZ,CHREXT)
          CALL WMSECT(BRBEXT,CHREXT,IFLG,RINTSC)
          IF (IFLG .EQ. 1) THEN
            SYMPOS(2,ISYM) = BRBEXT(2)-EPS-
     +                         0.5*(CHREXT(4)-CHREXT(2))
            DIFFP = ABS(ORIGP-SYMPOS(2,ISYM))  
          ENDIF
        ENDIF
        IF (DIFFP .GT. 0.125*WBSHFT) THEN
          OFFSET = DIFFP - 0.125*WBSHFT
          SYMPOS(2,9) = SYMPOS(2,9)-OFFSET
          SYMPOS(2,10) = SYMPOS(2,10)-OFFSET
          SYMPOS(2,11) = SYMPOS(2,11)-OFFSET
          SYMPOS(2,12) = SYMPOS(2,12)-OFFSET
          SYMPOS(2,13) = SYMPOS(2,13)-OFFSET
          SYMPOS(2,14) = SYMPOS(2,14)-OFFSET
        ENDIF
      ELSE IF (BANGD.GE.80. .AND. BANGD.LT.100.) THEN
C
C  Move pressure reading up and pressure change and tendency up.
C
        ORIGP = YNDC
        DIFFP = 0.
        IF (IPRSNT(7) .EQ. 1) THEN
          ISYM = 7
          CALL WMCEXT(ISYM,IFNTNM(ISYM),SYMPOS(1,ISYM),SYMPOS(2,ISYM),
     +                CHRS(ISYM),SIZ,CHREXT)
          CALL WMSECT(BRBEXT,CHREXT,IFLG,RINTSC)
          IF (IFLG .EQ. 1) THEN
            SYMPOS(2,ISYM) = BRBEXT(4)+EPS+
     +                         0.5*(CHREXT(4)-CHREXT(2))
            SYMPOS(2,8) = BRBEXT(4)+EPS+
     +                         0.5*(CHREXT(4)-CHREXT(2))
            DIFFP = ABS(ORIGP-SYMPOS(2,ISYM))  
          ENDIF
        ENDIF
        IF (IPRSNT(8) .EQ. 1) THEN
          ISYM = 8
          CALL WMCEXT(ISYM,IFNTNM(ISYM),SYMPOS(1,ISYM),SYMPOS(2,ISYM),
     +                CHRS(ISYM),SIZ,CHREXT)
          CALL WMSECT(BRBEXT,CHREXT,IFLG,RINTSC)
          IF (IFLG .EQ. 1) THEN
            SYMPOS(2,ISYM) = BRBEXT(4)+EPS+
     +                         0.5*(CHREXT(4)-CHREXT(2))
            DIFFP = ABS(ORIGP-SYMPOS(2,ISYM))  
          ENDIF
        ENDIF
        IF (DIFFP .GT. 0.) THEN
          SYMPOS(2,4) = SYMPOS(2,4)+DIFFP
        ENDIF
C
C  Move sky cover, past weather, rainfall down.
C
        ORIGP = YNDC-0.42*WBSHFT
        DIFFP = 0.
        IF (IPRSNT(11) .EQ. 1) THEN
          ISYM = 11
          CALL WMCEXT(ISYM,IFNTNM(ISYM),SYMPOS(1,ISYM),SYMPOS(2,ISYM),
     +                CHRS(ISYM),SIZ,CHREXT)
          CALL WMSECT(BRBEXT,CHREXT,IFLG,RINTSC)
          IF (IFLG .EQ. 1) THEN
            SYMPOS(2,ISYM) = BRBEXT(2)-EPS-
     +                         0.5*(CHREXT(4)-CHREXT(2))
            SYMPOS(2,12) = BRBEXT(2)-EPS-
     +                         0.5*(CHREXT(4)-CHREXT(2))
            DIFFP = ABS(ORIGP-SYMPOS(2,ISYM))  
          ENDIF
        ENDIF
        IF (IPRSNT(12) .EQ. 1) THEN
          ISYM = 12
          CALL WMCEXT(ISYM,IFNTNM(ISYM),SYMPOS(1,ISYM),SYMPOS(2,ISYM),
     +                CHRS(ISYM),SIZ,CHREXT)
          CALL WMSECT(BRBEXT,CHREXT,IFLG,RINTSC)
          IF (IFLG .EQ. 1) THEN
            SYMPOS(2,ISYM) = BRBEXT(2)-EPS-
     +                         0.5*(CHREXT(4)-CHREXT(2))
            DIFFP = ABS(ORIGP-SYMPOS(2,ISYM))  
          ENDIF
        ENDIF
        IF (DIFFP .GT. 0.) THEN
          SYMPOS(2,14) = SYMPOS(2,14)-DIFFP
        ENDIF
      ELSE IF (BANGD.GE.100. .AND. BANGD.LT.110.) THEN
C
C  Move pressure reading up and pressure change and tendency up.
C  Dew point, low clouds, sky cover, past weather over.
C
        ORIGP = YNDC
        DIFFP = 0.
        IF (IPRSNT(7) .EQ. 1) THEN
          ISYM = 7
          CALL WMCEXT(ISYM,IFNTNM(ISYM),SYMPOS(1,ISYM),SYMPOS(2,ISYM),
     +                CHRS(ISYM),SIZ,CHREXT)
          CALL WMSECT(BRBEXT,CHREXT,IFLG,RINTSC)
          IF (IFLG .EQ. 1) THEN
            SYMPOS(2,ISYM) = BRBEXT(4)+EPS+
     +                         0.5*(CHREXT(4)-CHREXT(2))
            SYMPOS(2,8) = BRBEXT(4)+EPS+
     +                         0.5*(CHREXT(4)-CHREXT(2))
            DIFFP = ABS(ORIGP-SYMPOS(2,ISYM))  
          ENDIF
        ELSE IF (IPRSNT(8) .EQ. 1) THEN
          ISYM = 8
          CALL WMCEXT(ISYM,IFNTNM(ISYM),SYMPOS(1,ISYM),SYMPOS(2,ISYM),
     +                CHRS(ISYM),SIZ,CHREXT)
          CALL WMSECT(BRBEXT,CHREXT,IFLG,RINTSC)
          IF (IFLG .EQ. 1) THEN
            SYMPOS(2,ISYM) = BRBEXT(4)+EPS+
     +                         0.5*(CHREXT(4)-CHREXT(2))
            DIFFP = ABS(ORIGP-SYMPOS(2,ISYM))  
          ENDIF
        ENDIF
        IF (DIFFP .GT. 0.) THEN
          SYMPOS(2,4) = SYMPOS(2,4)+DIFFP
        ENDIF
C
C  Dew point, low clouds, sky cover, past weather over.
C
        OFFSET = 0.
        IF (IPRSNT(12) .EQ. 1) THEN
          ISYM = 12
          CALL WMCEXT(ISYM,IFNTNM(ISYM),SYMPOS(1,ISYM),SYMPOS(2,ISYM),
     +                CHRS(ISYM),SIZ,CHREXT)
          CALL WMSECT(BRBEXT,CHREXT,IFLG,RINTSC)
          IF (IFLG .EQ. 1) THEN
            OFFSET = ABS(CHREXT(3)-BRBEXT(1))
          ENDIF
        ELSE IF (IPRSNT(11) .EQ. 1) THEN
          ISYM = 11
          CALL WMCEXT(ISYM,IFNTNM(ISYM),SYMPOS(1,ISYM),SYMPOS(2,ISYM),
     +                CHRS(ISYM),SIZ,CHREXT)
          CALL WMSECT(BRBEXT,CHREXT,IFLG,RINTSC)
          IF (IFLG .EQ. 1) THEN
            OFFSET = ABS(CHREXT(3)-BRBEXT(1))
          ENDIF
        ENDIF
        SYMPOS(1,9) = SYMPOS(1,9)-OFFSET-EPS
        SYMPOS(1,10) = SYMPOS(1,10)-OFFSET-EPS
        SYMPOS(1,11) = SYMPOS(1,11)-OFFSET-EPS
        SYMPOS(1,12) = SYMPOS(1,12)-OFFSET-EPS
      ELSE IF (BANGD.GE.110. .AND. BANGD.LT.120.) THEN
C
C  Dew point, low clouds, sky cover, past weather over.
C  Cloud height, rainfall over.
C
        OFFSET = 0.
        IF (IPRSNT(12) .EQ. 1) THEN
          ISYM = 12
          CALL WMCEXT(ISYM,IFNTNM(ISYM),SYMPOS(1,ISYM),SYMPOS(2,ISYM),
     +                CHRS(ISYM),SIZ,CHREXT)
          CALL WMSECT(BRBEXT,CHREXT,IFLG,RINTSC)
          IF (IFLG .EQ. 1) THEN
            OFFSET = ABS(CHREXT(3)-BRBEXT(1))
          ENDIF
        ELSE IF (IPRSNT(11) .EQ. 1) THEN
          ISYM = 11
          CALL WMCEXT(ISYM,IFNTNM(ISYM),SYMPOS(1,ISYM),SYMPOS(2,ISYM),
     +                CHRS(ISYM),SIZ,CHREXT)
          CALL WMSECT(BRBEXT,CHREXT,IFLG,RINTSC)
          IF (IFLG .EQ. 1) THEN
            OFFSET = ABS(CHREXT(3)-BRBEXT(1))
          ENDIF
        ELSE IF (IPRSNT(14) .EQ. 1) THEN
          ISYM = 14
          CALL WMCEXT(ISYM,IFNTNM(ISYM),SYMPOS(1,ISYM),SYMPOS(2,ISYM),
     +                CHRS(ISYM),SIZ,CHREXT)
          CALL WMSECT(BRBEXT,CHREXT,IFLG,RINTSC)
          IF (IFLG .EQ. 1) THEN
            OFFSET = ABS(CHREXT(3)-BRBEXT(1))
          ENDIF
        ENDIF
        SYMPOS(1,9) = SYMPOS(1,9)-OFFSET-EPS
        SYMPOS(1,10) = SYMPOS(1,10)-OFFSET-EPS
        SYMPOS(1,11) = SYMPOS(1,11)-OFFSET-EPS
        SYMPOS(1,12) = SYMPOS(1,12)-OFFSET-EPS
        SYMPOS(1,13) = SYMPOS(1,13)-OFFSET
        SYMPOS(1,14) = SYMPOS(1,14)-OFFSET
      ELSE IF (BANGD.GE.120. .AND. BANGD.LT.140.) THEN
C
C  Dew point, low clouds, sky cover to the left.  Past weather to
C  right.  Cloud height, rainfall to left.
C
        OFFSET = 0.
        IF (IPRSNT(11) .EQ. 1) THEN
          ISYM = 11
          CALL WMCEXT(ISYM,IFNTNM(ISYM),SYMPOS(1,ISYM),SYMPOS(2,ISYM),
     +                CHRS(ISYM),SIZ,CHREXT)
          CALL WMSECT(BRBEXT,CHREXT,IFLG,RINTSC)
          IF (IFLG .EQ. 1) THEN
            OFFSET = ABS(CHREXT(3)-BRBEXT(1))
          ENDIF
          SYMPOS(1,9) = SYMPOS(1,9)-OFFSET-EPS
          SYMPOS(1,10) = SYMPOS(1,10)-OFFSET-EPS
          SYMPOS(1,11) = SYMPOS(1,11)-OFFSET-EPS
        ENDIF          
        IF (IPRSNT(14) .EQ. 1) THEN
          ISYM = 14
          CALL WMCEXT(ISYM,IFNTNM(ISYM),SYMPOS(1,ISYM),SYMPOS(2,ISYM),
     +                CHRS(ISYM),SIZ,CHREXT)
          CALL WMSECT(BRBEXT,CHREXT,IFLG,RINTSC)
          IF (IFLG .EQ. 1) THEN
            OFFSET = ABS(CHREXT(3)-BRBEXT(1))
            SYMPOS(1,13) = SYMPOS(1,13)-OFFSET
            SYMPOS(1,14) = SYMPOS(1,14)-OFFSET
          ENDIF
        ENDIF
        IF (IPRSNT(12) .EQ. 1) THEN
          ISYM = 12
          CALL WMCEXT(ISYM,IFNTNM(ISYM),SYMPOS(1,ISYM),SYMPOS(2,ISYM),
     +                CHRS(ISYM),SIZ,CHREXT)
          CALL WMSECT(BRBEXT,CHREXT,IFLG,RINTSC)
          IF (IFLG .EQ. 1) THEN
            SYMPOS(1,12) = BRBEXT(3)+
     +                       EPS+0.5*(CHREXT(3)-CHREXT(1))
          ENDIF
        ENDIF
      ELSE IF (BANGD.GE.140. .AND. BANGD.LT.190.) THEN
C
        EXPFCT = MAX(0.,0.0133*(170.-BANGD))
        SYMPOS(1,11) = SYMPOS(1,11)+EXPFCT*WBSHFT
        SYMPOS(1,12) = SYMPOS(1,12)+EXPFCT*WBSHFT
        SYMPOS(1,14) = SYMPOS(1,14)+EXPFCT*WBSHFT
        OFFSET = 0.
        IF (IPRSNT(10) .EQ. 1) THEN
          ISYM = 10
          CALL WMCEXT(ISYM,IFNTNM(ISYM),SYMPOS(1,ISYM),SYMPOS(2,ISYM),
     +                CHRS(ISYM),SIZ,CHREXT)
          IF (CHREXT(3) .GT. BRBEXT(1)) THEN
            OFFSET = CHREXT(3)-BRBEXT(1)
            SYMPOS(1,9) = SYMPOS(1,9)-OFFSET-EPS
            SYMPOS(1,10) = SYMPOS(1,10)-OFFSET-EPS
          ENDIF
        ENDIF          
        IF (IPRSNT(13) .EQ. 1) THEN
          ISYM = 13
          CALL WMCEXT(ISYM,IFNTNM(ISYM),SYMPOS(1,ISYM),SYMPOS(2,ISYM),
     +                CHRS(ISYM),SIZ,CHREXT)
          IF (CHREXT(3) .GT. BRBEXT(1)) THEN
            OFFSET = CHREXT(3)-BRBEXT(1)
            SYMPOS(1,13) = SYMPOS(1,13)-OFFSET-EPS
          ENDIF
        ENDIF          
      ELSE IF (BANGD.GE.190. .AND. BANGD.LT.230.) THEN
C
        OFFSET = 0.
        IF (IPRSNT(9) .EQ. 1) THEN
          ISYM = 9
          CALL WMCEXT(ISYM,IFNTNM(ISYM),SYMPOS(1,ISYM),SYMPOS(2,ISYM),
     +                CHRS(ISYM),SIZ,CHREXT)
          IF (CHREXT(3) .GT. BRBEXT(1)) THEN
            OFFSET = CHREXT(3)-BRBEXT(1)
          ENDIF
          SYMPOS(1,9) = SYMPOS(1,9)-OFFSET
        ENDIF          
        IF (IPRSNT(10) .EQ. 1) THEN
          ISYM = 10
          CALL WMCEXT(ISYM,IFNTNM(ISYM),SYMPOS(1,ISYM),SYMPOS(2,ISYM),
     +                CHRS(ISYM),SIZ,CHREXT)
          IF (CHREXT(1) .LT. BRBEXT(3)) THEN
            OFFSET = BRBEXT(3)-CHREXT(1)
            SYMPOS(1,10) = SYMPOS(1,10)+OFFSET
            SYMPOS(1,11) = SYMPOS(1,11)+OFFSET
            SYMPOS(1,12) = SYMPOS(1,12)+OFFSET
          ENDIF
        ENDIF          
        IF (IPRSNT(13) .EQ. 1) THEN
          ISYM = 13
          CALL WMCEXT(ISYM,IFNTNM(ISYM),SYMPOS(1,ISYM),SYMPOS(2,ISYM),
     +                CHRS(ISYM),SIZ,CHREXT)
          IF (CHREXT(1) .LT. BRBEXT(3)) THEN
            OFFSET = BRBEXT(3)-CHREXT(1)
            SYMPOS(1,13) = SYMPOS(1,13)+OFFSET
            SYMPOS(1,14) = SYMPOS(1,14)+OFFSET
          ENDIF
        ENDIF
        IF (IPRSNT(5) .EQ. 1) THEN
          ISYM = 5
          CALL WMCEXT(ISYM,IFNTNM(ISYM),SYMPOS(1,ISYM),SYMPOS(2,ISYM),
     +                CHRS(ISYM),SIZ,CHREXT)
          IF (CHREXT(2) .LT. BRBEXT(4)) THEN
            OFFSET = BRBEXT(4)-CHREXT(2)
            SYMPOS(2,ISYM) = SYMPOS(2,ISYM)+OFFSET+EPS
          ENDIF
        ENDIF          
        IF (IPRSNT(6) .EQ. 1) THEN
          ISYM = 6
          CALL WMCEXT(ISYM,IFNTNM(ISYM),SYMPOS(1,ISYM),SYMPOS(2,ISYM),
     +                CHRS(ISYM),SIZ,CHREXT)
          IF (CHREXT(2) .LT. BRBEXT(4)) THEN
            OFFSET = BRBEXT(4)-CHREXT(2)
            SYMPOS(2,ISYM) = SYMPOS(2,ISYM)+OFFSET+EPS
          ENDIF
        ENDIF          
      ELSE IF (BANGD.GE.230. .AND. BANGD.LT.250.) THEN
        OFFSET = 0.
        IF (IPRSNT(5) .EQ. 1) THEN
          ISYM = 5
          CALL WMCEXT(ISYM,IFNTNM(ISYM),SYMPOS(1,ISYM),SYMPOS(2,ISYM),
     +                CHRS(ISYM),SIZ,CHREXT)
          IF (CHREXT(2) .LT. BRBEXT(4)) THEN
            OFFSET = BRBEXT(4) - CHREXT(2)
            SYMPOS(2,ISYM) = SYMPOS(2,ISYM)+OFFSET+EPS
          ENDIF
        ENDIF          
        IF (IPRSNT(6) .EQ. 1) THEN
          ISYM = 6
          CALL WMCEXT(ISYM,IFNTNM(ISYM),SYMPOS(1,ISYM),SYMPOS(2,ISYM),
     +                CHRS(ISYM),SIZ,CHREXT)
          IF (CHREXT(2) .LT. BRBEXT(4)) THEN
            OFFSET = BRBEXT(4) - CHREXT(2)
            SYMPOS(2,6) = SYMPOS(2,6)+OFFSET+EPS
            SYMPOS(2,3) = SYMPOS(2,3)+OFFSET+EPS
          ENDIF
        ENDIF          
        ADJUST = WBSHFT*(0.38-0.012*(250.-BANGD))
        IF (IPRSNT(9) .EQ. 1) THEN
          ISYM = 9
          CALL WMCEXT(ISYM,IFNTNM(ISYM),SYMPOS(1,ISYM),SYMPOS(2,ISYM),
     +                CHRS(ISYM),SIZ,CHREXT)
          IF (CHREXT(3) .GT. BRBEXT(1)) THEN
            OFFSET = CHREXT(3) - BRBEXT(1) - ADJUST
            SYMPOS(1,9) = SYMPOS(1,9)+OFFSET
            SYMPOS(1,10) = SYMPOS(1,10)+OFFSET
            SYMPOS(1,11) = SYMPOS(1,11)+OFFSET
            SYMPOS(1,12) = SYMPOS(1,12)+OFFSET
          ENDIF
        ENDIF          
      ELSE IF (BANGD.GE.250. .AND. BANGD.LT.265.) THEN
        OFFSET = 0.
        IF (IPRSNT(5) .EQ. 1) THEN
          ISYM = 5
          CALL WMCEXT(ISYM,IFNTNM(ISYM),SYMPOS(1,ISYM),SYMPOS(2,ISYM),
     +                CHRS(ISYM),SIZ,CHREXT)
          IF (CHREXT(2) .LT. BRBEXT(4)) THEN
            OFFSET = BRBEXT(4) - CHREXT(2)
            SYMPOS(2,5) = SYMPOS(2,5)+OFFSET+EPS
          ENDIF
        ENDIF          
        IF (IPRSNT(6) .EQ. 1) THEN
          ISYM = 6
          CALL WMCEXT(ISYM,IFNTNM(ISYM),SYMPOS(1,ISYM),SYMPOS(2,ISYM),
     +                CHRS(ISYM),SIZ,CHREXT)
          IF (CHREXT(2) .LT. BRBEXT(4)) THEN
            OFFSET = BRBEXT(4) - CHREXT(2)
            SYMPOS(2,6) = SYMPOS(2,6)+OFFSET+EPS
            SYMPOS(2,3) = SYMPOS(2,3)+OFFSET+EPS
          ENDIF
        ENDIF          
      ELSE IF (BANGD.GE.265. .AND. BANGD.LT.300.) THEN
        OFFSET = 0.
        ORIGP = YNDC
        DIFFP = 0.
        IF (IPRSNT(3) .EQ. 1) THEN
          ISYM = 3
          CALL WMCEXT(ISYM,IFNTNM(ISYM),SYMPOS(1,ISYM),SYMPOS(2,ISYM),
     +                CHRS(ISYM),SIZ,CHREXT)
          IF (CHREXT(2) .LT. BRBEXT(4)) THEN
            OFFSET = BRBEXT(4) - CHREXT(2)
            SYMPOS(2,3) = SYMPOS(2,3)+OFFSET
          ENDIF
        ENDIF          
        IF (IPRSNT(5) .EQ. 1) THEN
          ISYM = 5
          CALL WMCEXT(ISYM,IFNTNM(ISYM),SYMPOS(1,ISYM),SYMPOS(2,ISYM),
     +                CHRS(ISYM),SIZ,CHREXT)
          IF (CHREXT(4) .GT. BRBEXT(2)) THEN
            OFFSET = CHREXT(4) - BRBEXT(2)
            SYMPOS(2,5) = SYMPOS(2,5)-OFFSET-EPS
            DIFFP = ABS(SYMPOS(2,5)-ORIGP) 
          ENDIF
        ENDIF
        IF (IPRSNT(6) .EQ. 1) THEN
          ISYM = 6
          CALL WMCEXT(ISYM,IFNTNM(ISYM),SYMPOS(1,ISYM),SYMPOS(2,ISYM),
     +                CHRS(ISYM),SIZ,CHREXT)
          IF (CHREXT(4) .GT. BRBEXT(2)) THEN
            OFFSET = CHREXT(4) - BRBEXT(2)
            SYMPOS(2,6) = SYMPOS(2,6)-OFFSET-EPS
            DIFFP = ABS(SYMPOS(2,6)-ORIGP) 
          ENDIF
        ENDIF
        IF (DIFFP .GT. 0.125*WBSHFT) THEN
          OFFSET = DIFFP - 0.125*WBSHFT
          SYMPOS(2,9) = SYMPOS(2,9)-OFFSET-EPS
          SYMPOS(2,10) = SYMPOS(2,10)-OFFSET-EPS
          SYMPOS(2,13) = SYMPOS(2,13)-OFFSET-EPS
          SYMPOS(2,11) = SYMPOS(2,11)-EPS
          SYMPOS(2,12) = SYMPOS(2,12)-EPS
          SYMPOS(2,14) = SYMPOS(2,14)-EPS
        ENDIF
      ELSE IF (BANGD.GE.300. .AND. BANGD.LT.360.) THEN
        OFFSET = 0.
        IF (IPRSNT(1) .EQ. 1) THEN
          ISYM = 1
          CALL WMCEXT(ISYM,IFNTNM(ISYM),SYMPOS(1,ISYM),SYMPOS(2,ISYM),
     +                CHRS(ISYM),SIZ,CHREXT)
          IF (CHREXT(1) .LT. BRBEXT(3)) THEN
            OFFSET = BRBEXT(3) - CHREXT(1)
            SYMPOS(1,ISYM) = SYMPOS(1,ISYM)+OFFSET+EPS
          ENDIF
        ENDIF          
        IF (IPRSNT(2) .EQ. 1) THEN
          ISYM = 2
          CALL WMCEXT(ISYM,IFNTNM(ISYM),SYMPOS(1,ISYM),SYMPOS(2,ISYM),
     +                CHRS(ISYM),SIZ,CHREXT)
          IF (CHREXT(1) .LT. BRBEXT(3)) THEN
            OFFSET = BRBEXT(3) - CHREXT(1)
            SYMPOS(1,ISYM) = SYMPOS(1,ISYM)+OFFSET+EPS
          ENDIF
        ENDIF          
        IF (IPRSNT(4).EQ.1 .AND. BANGD.GE.325.) THEN
          SYMPOS(1,4) = SYMPOS(1,4)+OFFSET+EPS
        ENDIF 
        IF (IPRSNT(3) .EQ. 1) THEN
          ISYM = 3
          CALL WMCEXT(ISYM,IFNTNM(ISYM),SYMPOS(1,ISYM),SYMPOS(2,ISYM),
     +                CHRS(ISYM),SIZ,CHREXT)
          IF (CHREXT(3) .GT. BRBEXT(1)) THEN
            OFFSET = CHREXT(3) - BRBEXT(1)
            SYMPOS(1,ISYM) = SYMPOS(1,ISYM)-OFFSET+0.125*WBSHFT
          ENDIF
        ENDIF
      ENDIF
  220 CONTINUE
C
C  Draw the labels.
C
      CALL PCGETI('TE',ITEOLD)
      CALL PCSETI('TE',1)
      CALL PCGETI('FN',IFOLD)
      CALL PCSETI('FN',4)
C
C   High Clouds.
C
      IF (CH.GE.1 .AND. CH.LE.9) THEN
        IF (IPRSNT(1) .EQ. 1)  THEN
          CALL NGWSYM('CH',CH,SYMPOS(1,1),SYMPOS(2,1),
     +                2.*SIZ,ICOLOR,0)       
        ENDIF
      ENDIF
C
C   Medium clouds.
C
      IF (CM.GE.1 .AND. CM.LE.9) THEN
        IF (IPRSNT(2) .EQ. 1)  THEN
          CALL NGWSYM('CM',CM,SYMPOS(1,2),SYMPOS(2,2),
     +                2.*SIZ,ICOLOR,0)       
        ENDIF
      ENDIF
C
C   Current air temperature.
C
C     The input data is assumed to be expressed in whole degrees C 
C     and tenths.  So, for example, an input value of 211 would 
C     be 21.1 degrees C.  If IUNITS=0 (the default), then use Imperial 
C     units, so an input of 211 would be plotted as 70 degrees F.
C     If IUNITS is non-zero, then the temperature is plotted in
C     metric units as whole degrees C and tenths.  So, 211 would 
C     be plotted as 21.1.
C
      IF (IUNITS .EQ. 0) THEN
        IRTEMP = NINT(0.18*REAL(TTT)+32.)
        CHR5 = ' '
        WRITE(CHR5,'(I5)') IRTEMP
        LL = WMGTLN(CHR5,LEN(CHR5),1)
        IF (IPRSNT(3) .EQ. 1) THEN
          CALL PLCHHQ(SYMPOS(1,3),SYMPOS(2,3),CHR5(LL:LEN(CHR5)),
     +                SIZ,0.,0.)       
        ENDIF
      ELSE
        CTEMP = REAL(TTT)/10.
        CHR5 = ' '
        WRITE(CHR5,'(F5.1)') CTEMP
        LL = WMGTLN(CHR5,LEN(CHR5),1)
        IF (IPRSNT(3) .EQ. 1) THEN
          CALL PLCHHQ(SYMPOS(1,3),SYMPOS(2,3),CHR5(LL:LEN(CHR5)),
     +                SIZ,0.,0.)       
        ENDIF
      ENDIF
C
C   Barometric pressure.
C
      CHR3 = ' '
      WRITE(CHR3,'(I3)') PPPP 
      DO 65 I=1,3
        IF (CHR3(I:I) .EQ. ' ') CHR3(I:I)='0'
   65 CONTINUE
      IF (IPRSNT(4) .EQ. 1) THEN
        CALL PLCHHQ(SYMPOS(1,4),SYMPOS(2,4),CHR3,SIZ,0.,0.)       
      ENDIF
C
C   Horizontal visibility at surface.
C
C   If IVVCOD equals 1, then just plot the raw SYNOP two-character
C   code.  Otherwise, convert to mph (if IUNITS equals 0) or km
C   (if IUNITS equals 1) and plot.
C
      IF (IVVCOD .EQ. 1) THEN
        IF (VV .LE. 50. .OR. VV .GE. 56.) THEN
          CALL PLCHHQ(SYMPOS(1,5),SYMPOS(2,5),IMDAT(1)(4:5),SIZ,0.,0.)
        ENDIF
        GO TO 150
      ENDIF
C   
C
C   Imperial units if IUNITS .EQ. 0.
C
      IF (IUNITS .EQ. 0) THEN
        IPLFLG = 1
        IFR = 0
        IF (VV .LE. 50) THEN
          IF (VV .EQ. 0) THEN
            IWH = 0
          ELSE
            IWH = VV/16
            IFR = MOD(VV,16)
          ENDIF
        ELSE IF (VV.GE.56 .AND. VV.LE.80) THEN
          IWH = NINT((6. + (VV-56))*0.6213712)
          IFR = 0
        ELSE IF (VV.GT.80 .AND. VV.LT.90) THEN
          IWH = NINT(30. + 5.*(VV-80)*0.6213712)
          IFR = 0
        ELSE IF (VV.EQ.90) THEN
          IWH = 0
        ELSE IF (VV.EQ.91) THEN
          IWH = 0
          IFR = 1
        ELSE IF (VV.EQ.92) THEN
          IWH = 0
          IFR = 2
        ELSE IF (VV.EQ.93) THEN
          IWH = 0
          IFR = 5
        ELSE IF (VV.EQ.94) THEN
          IWH = 0
          IFR = 10
        ELSE IF (VV.EQ.95) THEN
          IWH = 1
          IFR = 4
        ELSE IF (VV.EQ.96) THEN
          IWH = 2
          IFR = 8
        ELSE IF (VV.EQ.97) THEN
          IWH = 6
          IFR = 2
        ELSE IF (VV.EQ.98) THEN
          IWH = 12
          IFR = 8
        ELSE IF (VV.EQ.99) THEN
          IWH = 31
          IFR = 4
        ELSE
          IPLFLG = 0
        ENDIF 
        ASIZ = .67*SIZ
        BOFF = .33*SIZ
C
C  The NOAA chart "Explanation of the Weather Map indicates that 
C  visibilities above 10 should be omitted from the map.
C
        IF (IPRSNT(5).EQ.1 .AND. IWH.LE.10 .AND. IPLFLG.EQ.1) THEN
C
C  If the fraction of a mile is 0, then plot the whole mile number.
C
          IF (IFR .EQ. 0) THEN
            CHR3 = ' '
            WRITE(CHR3,'(I3)') IWH
            LL = WMGTLN(CHR3,LEN(CHR3),1)
            CALL PLCHHQ(SYMPOS(1,5),SYMPOS(2,5),CHR3(LL:3),SIZ,0.,0.)
C
C  Plot the fractional part (the whole part will be plotted after
C  this whole IF block.
C
          ELSE
            CALL PLCHHQ(SYMPOS(1,5),SYMPOS(2,5),'/',SIZ,0.,0.)
            IF (IFR .EQ. 1) THEN
              CALL PLCHHQ(SYMPOS(1,5)+BOFF,SYMPOS(2,5)-BOFF,
     +                    '16',ASIZ,0.,-1.)
              CALL PLCHHQ(SYMPOS(1,5)-BOFF,SYMPOS(2,5)+BOFF,
     +                    '1',ASIZ,0.,+1.)
            ELSE IF (IFR .EQ. 2) THEN
              CALL PLCHHQ(SYMPOS(1,5)+BOFF,SYMPOS(2,5)-BOFF,
     +                    '8',ASIZ,0.,-1.)
              CALL PLCHHQ(SYMPOS(1,5)-BOFF,SYMPOS(2,5)+BOFF,
     +                    '1',ASIZ,0.,+1.)
            ELSE IF (IFR .EQ. 3) THEN
              CALL PLCHHQ(SYMPOS(1,5)+BOFF,SYMPOS(2,5)-BOFF,
     +                    '16',ASIZ,0.,-1.)
              CALL PLCHHQ(SYMPOS(1,5)-BOFF,SYMPOS(2,5)+BOFF,
     +                    '3',ASIZ,0.,+1.)
            ELSE IF (IFR .EQ. 4) THEN
              CALL PLCHHQ(SYMPOS(1,5)+BOFF,SYMPOS(2,5)-BOFF,
     +                    '4',ASIZ,0.,-1.)
              CALL PLCHHQ(SYMPOS(1,5)-BOFF,SYMPOS(2,5)+BOFF,
     +                    '1',ASIZ,0.,+1.)
            ELSE IF (IFR .EQ. 5) THEN
              CALL PLCHHQ(SYMPOS(1,5)+BOFF,SYMPOS(2,5)-BOFF,
     +                    '16',ASIZ,0.,-1.)
              CALL PLCHHQ(SYMPOS(1,5)-BOFF,SYMPOS(2,5)+BOFF,
     +                    '5',ASIZ,0.,+1.)
            ELSE IF (IFR .EQ. 6) THEN
              CALL PLCHHQ(SYMPOS(1,5)+BOFF,SYMPOS(2,5)-BOFF,
     +                    '8',ASIZ,0.,-1.)
              CALL PLCHHQ(SYMPOS(1,5)-BOFF,SYMPOS(2,5)+BOFF,
     +                    '3',ASIZ,0.,+1.)
            ELSE IF (IFR .EQ. 7) THEN
              CALL PLCHHQ(SYMPOS(1,5)+BOFF,SYMPOS(2,5)-BOFF,
     +                    '16',ASIZ,0.,-1.)
              CALL PLCHHQ(SYMPOS(1,5)-BOFF,SYMPOS(2,5)+BOFF,
     +                    '7',ASIZ,0.,+1.)
            ELSE IF (IFR .EQ. 8) THEN
              CALL PLCHHQ(SYMPOS(1,5)+BOFF,SYMPOS(2,5)-BOFF,
     +                    '2',ASIZ,0.,-1.)
              CALL PLCHHQ(SYMPOS(1,5)-BOFF,SYMPOS(2,5)+BOFF,
     +                    '1',ASIZ,0.,+1.)
            ELSE IF (IFR .EQ. 9) THEN
              CALL PLCHHQ(SYMPOS(1,5)+BOFF,SYMPOS(2,5)-BOFF,
     +                    '16',ASIZ,0.,-1.)
              CALL PLCHHQ(SYMPOS(1,5)-BOFF,SYMPOS(2,5)+BOFF,
     +                    '9',ASIZ,0.,+1.)
            ELSE IF (IFR .EQ. 10) THEN
              CALL PLCHHQ(SYMPOS(1,5)+BOFF,SYMPOS(2,5)-BOFF,
     +                    '8',ASIZ,0.,-1.)
              CALL PLCHHQ(SYMPOS(1,5)-BOFF,SYMPOS(2,5)+BOFF,
     +                    '5',ASIZ,0.,+1.)
            ELSE IF (IFR .EQ. 11) THEN
              CALL PLCHHQ(SYMPOS(1,5)+BOFF,SYMPOS(2,5)-BOFF,
     +                    '16',ASIZ,0.,-1.)
              CALL PLCHHQ(SYMPOS(1,5)-BOFF,SYMPOS(2,5)+BOFF,
     +                    '11',ASIZ,0.,+1.)
            ELSE IF (IFR .EQ. 12) THEN
              CALL PLCHHQ(SYMPOS(1,5)+BOFF,SYMPOS(2,5)-BOFF,
     +                    '4',ASIZ,0.,-1.)
              CALL PLCHHQ(SYMPOS(1,5)-BOFF,SYMPOS(2,5)+BOFF,
     +                    '3',ASIZ,0.,+1.)
            ELSE IF (IFR .EQ. 13) THEN
              CALL PLCHHQ(SYMPOS(1,5)+BOFF,SYMPOS(2,5)-BOFF,
     +                    '16',ASIZ,0.,-1.)
              CALL PLCHHQ(SYMPOS(1,5)-BOFF,SYMPOS(2,5)+BOFF,
     +                    '13',ASIZ,0.,+1.)
            ELSE IF (IFR .EQ. 14) THEN
              CALL PLCHHQ(SYMPOS(1,5)+BOFF,SYMPOS(2,5)-BOFF,
     +                    '8',ASIZ,0.,-1.)
              CALL PLCHHQ(SYMPOS(1,5)-BOFF,SYMPOS(2,5)+BOFF,
     +                    '7',ASIZ,0.,+1.)
            ELSE IF (IFR .EQ. 15) THEN
              CALL PLCHHQ(SYMPOS(1,5)+BOFF,SYMPOS(2,5)-BOFF,
     +                    '16',ASIZ,0.,-1.)
              CALL PLCHHQ(SYMPOS(1,5)-BOFF,SYMPOS(2,5)+BOFF,
     +                    '15',ASIZ,0.,+1.)
            ENDIF
C
C  Plot the whole mile part if required.
C
            IF (IWH .NE. 0) THEN
C
C  Get the left extent of the last character string (which was the
C  numerator of the fraction).
C
              CALL PCGETR('DL',XL)
              XP = SYMPOS(1,5)-2.*BOFF-XL
              CHR3 = ' '
              WRITE(CHR3,'(I3)') IWH
              LL = WMGTLN(CHR3,LEN(CHR3),1)
              CALL PLCHHQ(XP,SYMPOS(2,5),CHR3(LL:3),SIZ,0.,+1.)
            ENDIF
          ENDIF
        ENDIF
      ELSE
C
C  Metric units if IUNITS .NE. 0.
C
        IPLFLG = 1
        IF (VV .LE. 50) THEN
          IF (VV .EQ. 0) THEN
            RWH = 0.
          ELSE
            RWH = 0.1*REAL(VV)
          ENDIF
C
C  Values of VV strictly between 50 and 56 are not used.
C
        ELSE IF (VV.GT.50 .AND. VV.LT.56) THEN
          IPLFLG = 0
        ELSE IF (VV.GE.56 .AND. VV.LE.80) THEN
          RWH = REAL(VV) - 50.
        ELSE IF (VV.GT.80 .AND. VV.LT.90) THEN
          RWH = 30. + 5.*(REAL(VV)-80.)
        ELSE IF (VV.EQ.90) THEN
          RWH = 0.
        ELSE IF (VV.EQ.91) THEN
          RWH = 0.05
        ELSE IF (VV.EQ.92) THEN
          RWH = 0.20
        ELSE IF (VV.EQ.93) THEN
          RWH = 0.50
        ELSE IF (VV.EQ.94) THEN
          RWH = 1.
        ELSE IF (VV.EQ.95) THEN
          RWH = 2.
        ELSE IF (VV.EQ.96) THEN
          RWH = 4.
        ELSE IF (VV.EQ.97) THEN
          RWH = 10.
        ELSE IF (VV.EQ.98) THEN
          RWH = 20.
        ELSE IF (VV.EQ.99) THEN
          RWH = 50.
        ELSE
          IPLFLG = 0
        ENDIF 
        ASIZ = .67*SIZ
        IF (IPRSNT(5).EQ.1 .AND. VV.GE.0 .AND. VV .LE. 50 .AND. 
     +    IPLFLG.EQ.1) THEN
          CHR3 = ' '
          WRITE(CHR3,'(F3.1)') RWH
          CALL PLCHHQ(SYMPOS(1,5),SYMPOS(2,5),CHR3,SIZ,0.,0.)
        ELSE IF (IPRSNT(5).EQ.1 .AND. VV.GE.56 .AND. VV.LT.89 .AND. 
     +           IPLFLG.EQ.1) THEN
          CHR3 = ' '
          WRITE(CHR3,'(F3.0)') RWH
          CALL PLCHHQ(SYMPOS(1,5),SYMPOS(2,5),CHR3(1:3),SIZ,0.,0.)
        ELSE IF (IPRSNT(5).EQ.1 .AND. VV.EQ.89 .AND. IPLFLG.EQ.1) THEN      
          CALL PLCHHQ(SYMPOS(1,5),SYMPOS(2,5),'>70',SIZ,0.,0.)
        ELSE IF (IPRSNT(5).EQ.1 .AND. VV.EQ.90 .AND. IPLFLG.EQ.1) THEN      
          CALL PLCHHQ(SYMPOS(1,5),SYMPOS(2,5),'<.05',SIZ,0.,0.)
        ELSE IF (IPRSNT(5).EQ.1 .AND. VV.EQ.91 .AND. IPLFLG.EQ.1) THEN      
          CALL PLCHHQ(SYMPOS(1,5),SYMPOS(2,5),'.05',SIZ,0.,0.)
        ELSE IF (IPRSNT(5).EQ.1 .AND. VV.EQ.92 .AND. IPLFLG.EQ.1) THEN      
          CALL PLCHHQ(SYMPOS(1,5),SYMPOS(2,5),'0.2',SIZ,0.,0.)
        ELSE IF (IPRSNT(5).EQ.1 .AND. VV.EQ.93 .AND. IPLFLG.EQ.1) THEN      
          CALL PLCHHQ(SYMPOS(1,5),SYMPOS(2,5),'0.5',SIZ,0.,0.)
        ELSE IF (IPRSNT(5).EQ.1 .AND. VV.EQ.94 .AND. IPLFLG.EQ.1) THEN      
          CALL PLCHHQ(SYMPOS(1,5),SYMPOS(2,5),'1.0',SIZ,0.,0.)
        ELSE IF (IPRSNT(5).EQ.1 .AND. VV.EQ.95 .AND. IPLFLG.EQ.1) THEN      
          CALL PLCHHQ(SYMPOS(1,5),SYMPOS(2,5),'2.0',SIZ,0.,0.)
        ELSE IF (IPRSNT(5).EQ.1 .AND. VV.EQ.96 .AND. IPLFLG.EQ.1) THEN      
          CALL PLCHHQ(SYMPOS(1,5),SYMPOS(2,5),'4.0',SIZ,0.,0.)
        ELSE IF (IPRSNT(5).EQ.1 .AND. VV.EQ.97 .AND. IPLFLG.EQ.1) THEN      
          CALL PLCHHQ(SYMPOS(1,5),SYMPOS(2,5),'10.',SIZ,0.,0.)
        ELSE IF (IPRSNT(5).EQ.1 .AND. VV.EQ.98 .AND. IPLFLG.EQ.1) THEN      
          CALL PLCHHQ(SYMPOS(1,5),SYMPOS(2,5),'20.',SIZ,0.,0.)
        ELSE IF (IPRSNT(5).EQ.1 .AND. VV.EQ.99 .AND. IPLFLG.EQ.1) THEN      
          CALL PLCHHQ(SYMPOS(1,5),SYMPOS(2,5),'>50.',SIZ,0.,0.)
        ENDIF
      ENDIF
C
  150 CONTINUE
C     
C  Present weather
C
      IF (IPRSNT(6) .EQ. 1) THEN
        CALL NGWSYM('WW',WW,SYMPOS(1,6),SYMPOS(2,6),2.0*SIZ,ICOLOR,0)
      ENDIF
C
C  Pressure change.
C
      IF (IPRSNT(7) .EQ. 1) THEN
        CHR3 = ' '
        WRITE(CHR3,'(I3)') PPP
        LL = WMGTLN(CHR3,LEN(CHR3),1)
        CHR5 = ' '
        IF (A .LE. 4) THEN
          WRITE(IFMT,502) 4-LL
  502     FORMAT('(''+'',A',I1,')')
          WRITE(CHR5,IFMT) CHR3(LL:3)
        ELSE
          WRITE(IFMT,503) 4-LL
  503     FORMAT('(''-'',A',I1,')')
          WRITE(CHR5,IFMT) CHR3(LL:3)
        ENDIF
        LL = WMGTLN(CHR5,LEN(CHR5),0)
        IF (LL .EQ. 4) THEN
          SYMPOS(1,7) = SYMPOS(1,7)+0.1*WBSHFT
          SYMPOS(1,8) = SYMPOS(1,8)+0.2*WBSHFT
        ENDIF
        CALL PLCHHQ(SYMPOS(1,7),SYMPOS(2,7),CHR5(1:LL),SIZ,0.,0.)       
      ENDIF
C     
C  Pressure tendency.
C
      IF (IPRSNT(8).EQ.1 .AND. A.GE.0 .AND. A.LE.8) THEN
        CALL NGWSYM('a',A,SYMPOS(1,8),SYMPOS(2,8),1.5*SIZ,ICOLOR,0)
      ENDIF
C
C  Dew point.
C
      IF (IUNITS .EQ. 0) THEN
        IRTEMP = NINT(0.18*REAL(TD)+32.)
        CHR5 = ' '
        WRITE(CHR5,'(I5)') IRTEMP
        LL = WMGTLN(CHR5,LEN(CHR5),1)
        IF (IPRSNT(9) .EQ. 1) THEN
          CALL PLCHHQ(SYMPOS(1,9),SYMPOS(2,9),CHR5(LL:LEN(CHR5)),
     +                SIZ,0.,0.)       
        ENDIF
      ELSE
        CTEMP = REAL(TD)/10.
        CHR5 = ' '
        WRITE(CHR5,'(F5.1)') CTEMP
        LL = WMGTLN(CHR5,LEN(CHR5),1)
        IF (IPRSNT(9) .EQ. 1) THEN
          CALL PLCHHQ(SYMPOS(1,9),SYMPOS(2,9),CHR5(LL:LEN(CHR5)),
     +                SIZ,0.,0.)       
        ENDIF
      ENDIF
C
C  Low clouds.
C
      IF (CL.GE.1 .AND. CL.LE.9) THEN
        IF (IPRSNT(10) .EQ. 1)  THEN
          CALL NGWSYM('CL',CL,SYMPOS(1,10),SYMPOS(2,10),
     +                2.*SIZ,ICOLOR,0)       
        ENDIF
      ENDIF
C
C  Cloud cover - low or medium clouds.
C
      WRITE(CHR5,'(I5)') NH
      LL = WMGTLN(CHR5,LEN(CHR5),1)
      IF (IPRSNT(11) .EQ. 1) THEN
        CALL PLCHHQ(SYMPOS(1,11),SYMPOS(2,11),CHR5(LL:LEN(CHR5)),
     +              SIZ,0.,0.)       
      ENDIF
C     
C  Past weather.
C
      IF (IPRSNT(12).EQ.1 .AND. W1.GE.3 .AND. W1.LE.9) THEN
        CALL NGWSYM('W',W1,SYMPOS(1,12),SYMPOS(2,12),1.5*SIZ,ICOLOR,0)
      ENDIF
C
C  Cloud height.
C
      WRITE(CHR5,'(I5)') H
      LL = WMGTLN(CHR5,LEN(CHR5),1)
      IF (IPRSNT(13).EQ.1 .AND. N.GT.0) THEN
        CALL PLCHHQ(SYMPOS(1,13),SYMPOS(2,13),CHR5(LL:LEN(CHR5)),
     +              SIZ,0.,0.)       
      ENDIF
C
C  Precipitation.
C
      IF (IPRSNT(14).EQ.1 .AND. RRR.GT.0) THEN
        IF (RRR .EQ. 990) THEN
          CALL PLCHHQ(SYMPOS(1,14),SYMPOS(2,14),'T',SIZ,0.,0.)       
          GO TO 75
        ENDIF
        IF (RRR .GT. 990) THEN
          INCHES = NINT(10.*REAL(RRR-990)/25.4)
        ELSE
          INCHES = NINT(100.*REAL(RRR)/25.4)
        ENDIF
        CHR5 = ' '
        WRITE(CHR5,'(I5)') INCHES
        LL = WMGTLN(CHR5,LEN(CHR5),1)
        CALL PLCHHQ(SYMPOS(1,14),SYMPOS(2,14),CHR5(LL:LEN(CHR5)),
     +              SIZ,0.,0.)       
      ENDIF
   75 CONTINUE
C
C  Restore original settings.
C
      CALL GSELNT(NTRO)
      CALL GSTXCI(ITXCOL)
      CALL PCSETI('CC',IPCOL)
      CALL PCSETI('FN',IFOLD)
      CALL PCSETI('TE',ITEOLD)
C
      RETURN
      END

C
C      $Id: xy08f.f,v 1.6 2010-03-15 22:49:25 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                     C
C                Copyright (C)  1995                                  C
C        University Corporation for Atmospheric Research              C
C                All Rights Reserved                                  C
C                                                                     C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C  File:       xy08f.f
C
C  Author:     Mary Haley
C          National Center for Atmospheric Research
C          PO 3000, Boulder, Colorado
C
C  Date:       Tue Apr  4 09:49:35 MDT 1995
C
C  Description: This example is similar to the ncargex Autograph
C               example "agex13".  It shows how to use Irregular
C               points to change the transformation of your plot.
C
C               The "CoordArrays" object is used to set up the data.
C               (The C version uses the "CoordArrTable" object which
C               is not available in Fortran or NCL.)
C
C
      external NhlFAppClass
      external NhlFCairoWindowWorkstationClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFCoordArraysClass
      external NhlFXyPlotClass

      parameter(NPTS=61,NCURVE=3,NCOLORS=3)
C
C Create data arrays for XyPlot object.
C
      real xdra(NPTS,NCURVE), ydra(NPTS,NCURVE), xcoord(2*NPTS,NCURVE)
      integer len(NCURVE)
      data len/12,37,61/

      integer appid,xworkid,plotid,dataid(NCURVE)
      integer rlist, i, j
      character*10 datastr
C
C Create array for customizing the plot.
C
      real explicit_values(14)
C
C Set up data file name.
C
      character*8 filenm
      data filenm/'xy08.asc'/
C
C Modify the color map.  Color indices '1' and '2' are the background
C and foreground colors respectively.
C
      integer clen(2)
      data clen/3,NCOLORS/
      real cmap(3,NCOLORS)
      data cmap/1.00,1.00,1.00,
     +          0.00,0.00,0.00,
     +          0.00,0.00,1.00/

      CHARACTER*7  wks_type
C
C Define the workstation type
C
      wks_type = "x11"
C
C
C Fill the data arrays.
C
      do 10 i = 1,14
         explicit_values(i) = 2.**real(i-7)
 10   continue
      open(unit=10,file=filenm,status='old',form='formatted',err=104)
      do 30 i = 1,NCURVE
         read(10,1001)(xcoord(j,i),j=1,len(i)*2)
         do 20 j = 1,len(i)*2
            xcoord(j,i) = 2.**((xcoord(j,i)-15.)/2.5)
 20      continue
 30   continue
 1001 format(1X,24F5.1)
      do 50 i = 1,NCURVE
         do 40 j = 2,len(i)*2,2
            xdra(j/2,i) = xcoord(j-1,i)
            ydra(j/2,i) = xcoord(j,i)
 40      continue
 50   continue
C
C Initialize the HLU library and set up resource template
C
      call NhlFInitialize
      call NhlFRLCreate(rlist,'setrl')
C
C Create Application object.  The Application object name is used to
C determine the name of the resource file, which is "xy08.res" in this
C case.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'appDefaultParent','True',ierr)
      call NhlFRLSetString(rlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'xy08',NhlFAppClass,0,rlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkMetaName','./xy08f.ncgm',ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',cmap,2,clen,ierr)
         call NhlFCreate(xworkid,'xy08Work',
     +        NhlFNcgmWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X11 workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPause','True',ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',cmap,2,clen,ierr)
         call NhlFCreate(xworkid,'xy08Work',
     +                NhlFCairoWindowWorkstationClass,
     +                0,rlist,ierr)
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PS workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPSFileName','./xy08f.ps',ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',cmap,2,clen,ierr)
         call NhlFCreate(xworkid,'xy08Work',
     +        NhlFPSWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPDFFileName','./xy08f.pdf',ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',cmap,2,clen,ierr)
         call NhlFCreate(xworkid,'xy08Work',
     +        NhlFPDFWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFileName','./xy08f',ierr)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',cmap,2,clen,ierr)
         call NhlFCreate(xworkid,'xy08Work',
     +        NhlFcairoPSPDFWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFileName','./xy08f',ierr)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',cmap,2,clen,ierr)
         call NhlFCreate(xworkid,'xy08Work',
     +        NhlFcairoImageWorkstationClass,0,rlist,ierr)
      endif
C
C Create NCURVE CoordArray objects which define the data for the XyPlot
C object. The id array from this object will become the value for the
C XyPlot resource, "xyCoordData".
C
      do 60 i=1,NCURVE
         call NhlFRLClear(rlist)
         call NhlFRLSetFloatArray(rlist,'caYArray',ydra(1,i),
     +        len(i),ierr)
         call NhlFRLSetFloatArray(rlist,'caXArray',xdra(1,i),
     +        len(i),ierr)
         write(datastr,70)i-1
         call NhlFCreate(dataid(i),datastr,NhlFCoordArraysClass,
     +                0,rlist,ierr)
 60   continue
 70   format('xyData',i1)
C
C Create the XyPlot object and customize tick marks.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetFloatArray(rlist,'tmXBValues',explicit_values,14,
     +     ierr)
      call NhlFRLSetFloatArray(rlist,'tmYLValues',explicit_values,14,
     +     ierr)
      call NhlFRLSetFloatArray(rlist,'xyXIrregularPoints',
     +     explicit_values,14,ierr)
      call NhlFRLSetFloatArray(rlist,'xyYIrregularPoints',
     +     explicit_values,14,ierr)
      call NhlFRLSetIntegerArray(rlist,'xyCoordData',dataid,NCURVE,
     +     ierr)
      call NhlFCreate(plotid,'xyPlot',NhlFXyPlotClass,xworkid,
     +     rlist,ierr)
C
C Draw the plot.
C
      call NhlFDraw(plotid,ierr)
      call NhlFFrame(xworkid,ierr)
C
C NhlDestroy destroys the given id and all of its children
C so destroying "xworkid" will also destroy "plotid".
C
      call NhlFRLDestroy(rlist)
      call NhlFDestroy(xworkid,ierr)
      call NhlFDestroy(appid,ierr)
C
C Restores state.
C
      call NhlFClose
      stop
 104  write (6,*) 'error in opening file: ',filenm
      end

C
C	$Id: maxmin.f,v 1.5 2008-07-27 00:23:01 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MAXMIN (Z,L,MM,NN,JSIZEM,AASH,JOFFDT)
      SAVE
C
C THIS ROUTINE FINDS RELATIVE MINIMUMS AND MAXIMUMS.  A RELATIVE MINIMUM
C (OR MAXIMUM) IS DEFINED TO BE THE LOWEST (OR HIGHEST) POINT WITHIN
C A CERTAIN NEIGHBORHOOD OF THE POINT.  THE NEIGHBORHOOD USED HERE
C IS + OR - MN IN THE X DIRECTION AND + OR - NM IN THE Y DIRECTION.
C
C
      CHARACTER*7     IA
      DIMENSION       IW(4)
      DIMENSION       Z(L,NN)
C
C
      COMMON /CONRE1/ IOFFP      ,SPVAL
      COMMON /CONRE5/ SCLY
      DATA IW(1),IW(2),IW(3),IW(4)/4,6,8,12/
C
C     FX(X,Y) = X
C     FY(X,Y) = Y
C
      M = MM
      N = NN
      ISIZEM = JSIZEM
      ASH = ABS(AASH)
      IOFFDT = JOFFDT
C
      IF (AASH .LT. 0.0) GO TO 128
C
      MN = MIN(15,MAX(2,INT(REAL(M)/8.)))
      NM = MIN(15,MAX(2,INT(REAL(N)/8.)))
      NM1 = N-1
      MM1 = M-1
      IH1 = 4*IW(ISIZEM+1)
C
C SCALE IH1 TO COMPENSATE FOR USER CHANGE IN RESOLUTION
C
      IH1 = 32*SCLY*IH1
C
C LINE LOOP FOLLOWS - THE COMPLETE TWO-DIMENSIONAL TEST FOR A MINIMUM OR
C MAXIMUM OF THE FIELD IS ONLY PERFORMED FOR POINTS WHICH ARE MINIMA OR
C MAXIMA ALONG SOME LINE - FINDING THESE CANDIDATES IS MADE EFFICIENT BY
C USING A COUNT OF CONSECUTIVE INCREASES OR DECREASES OF THE FUNCTION
C ALONG THE LINE
C
      DO 127 JP=2,NM1
C
         IM = MN-1
         IP = -1
         GO TO 126
C
C CONTROL RETURNS TO STATEMENT 10 AS LONG AS THE FUNCTION IS INCREASING
C ALONG THE LINE - WE SEEK A POSSIBLE MAXIMUM
C
  101    IP = IP+1
         AA = AN
         IF (IP .EQ. MM1) GO TO 104
         AN = Z(IP+1,JP)
         IF (IOFFP.NE.0 .AND. AN.EQ.SPVAL) GO TO 125
         IF (AA-AN) 102,103,104
  102    IM = IM+1
         GO TO 101
  103    IM = 0
         GO TO 101
C
C FUNCTION DECREASED - TEST FOR MAXIMUM ON LINE
C
  104    IF (IM .GE. MN) GO TO 106
         IS = MAX(1,IP-MN)
         IT = IP-IM-1
         IF (IS .GT. IT) GO TO 106
         DO 105 II=IS,IT
            IF (AA .LE. Z(II,JP)) GO TO 112
  105    CONTINUE
  106    IS = IP+2
         IT = MIN(M,IP+MN)
         IF (IS .GT. IT) GO TO 109
         DO 108 II=IS,IT
            IF (IOFFP.EQ.0 .OR. Z(II,JP).NE.SPVAL) GO TO 107
            IP = II-1
            GO TO 125
  107       IF (AA .LE. Z(II,JP)) GO TO 112
  108    CONTINUE
C
C WE HAVE MAXIMUM ON LINE - DO TWO-DIMENSIONAL TEST FOR MAXIMUM OF FIELD
C
  109    JS = MAX(1,JP-NM)
         JT = MIN(N,JP+NM)
         IS = MAX(1,IP-MN)
         IT = MIN(M,IP+MN)
         DO 111 JK=JS,JT
            IF (JK .EQ. JP) GO TO 111
            DO 110 IK=IS,IT
               IF (Z(IK,JK).GE.AA .OR.
     1             (IOFFP.NE.0 .AND. Z(IK,JK).EQ.SPVAL)) GO TO 112
  110       CONTINUE
  111    CONTINUE
C
         X = REAL(IP)
         Y = REAL(JP)
         CALL WTSTR ( FX(X,Y),FY(X,Y),'H',ISIZEM,0,0 )
         CALL FL2INT ( FX(X,Y),FY(X,Y),IFX,IFY )
         IFY = IFY*SCLY
         CALL ENCD (AA,ASH,IA,NC,IOFFDT)
         MY = IFY - IH1
         TMY = CPUY ( MY )
         CALL WTSTR ( FX(X,Y),TMY,IA(1:NC),ISIZEM,0,0 )
  112    IM = 1
         IF (IP-MM1) 113,127,127
C
C CONTROL RETURNS TO STATEMENT 20 AS LONG AS THE FUNCTION IS DECREASING
C ALONG THE LINE - WE SEEK A POSSIBLE MINIMUM
C
  113    IP = IP+1
         AA = AN
         IF (IP .EQ. MM1) GO TO 116
         AN = Z(IP+1,JP)
         IF (IOFFP.NE.0 .AND. AN.EQ.SPVAL) GO TO 125
         IF (AA-AN) 116,115,114
  114    IM = IM+1
         GO TO 113
  115    IM = 0
         GO TO 113
C
C FUNCTION INCREASED - TEST FOR MINIMUM ON LINE
C
  116    IF (IM .GE. MN) GO TO 118
         IS = MAX(1,IP-MN)
         IT = IP-IM-1
         IF (IS .GT. IT) GO TO 118
         DO 117 II=IS,IT
            IF (AA .GE. Z(II,JP)) GO TO 124
  117    CONTINUE
  118    IS = IP+2
         IT = MIN(M,IP+MN)
         IF (IS .GT. IT) GO TO 121
         DO 120 II=IS,IT
            IF (IOFFP.EQ.0 .OR. Z(II,JP).NE.SPVAL) GO TO 119
            IP = II-1
            GO TO 125
  119       IF (AA .GE. Z(II,JP)) GO TO 124
  120    CONTINUE
C
C WE HAVE MINIMUM ON LINE - DO TWO-DIMENSIONAL TEST FOR MINIMUM OF FIELD
C
  121    JS = MAX(1,JP-NM)
         JT = MIN(N,JP+NM)
         IS = MAX(1,IP-MN)
         IT = MIN(M,IP+MN)
         DO 123 JK=JS,JT
            IF (JK .EQ. JP) GO TO 123
            DO 122 IK=IS,IT
               IF (Z(IK,JK).LE.AA .OR.
     1             (IOFFP.NE.0 .AND. Z(IK,JK).EQ.SPVAL)) GO TO 124
  122       CONTINUE
  123    CONTINUE
C
         X = REAL(IP)
         Y = REAL(JP)
         CALL WTSTR (FX(X,Y),FY(X,Y),'L',ISIZEM,0,0 )
         CALL FL2INT (FX(X,Y),FY(X,Y),IFX,IFY)
         IFY = IFY*SCLY
         CALL ENCD (AA,ASH,IA,NC,IOFFDT)
         MY = IFY-IH1
         TMY = CPUY ( MY )
         CALL WTSTR ( FX(X,Y),TMY,IA(1:NC),ISIZEM,0,0 )
  124    IM = 1
         IF (IP-MM1) 101,127,127
C
C SKIP SPECIAL VALUES ON LINE
C
  125    IM = 0
  126    IP = IP+1
         IF (IP .GE. MM1) GO TO 127
         IF (IOFFP.NE.0 .AND. Z(IP+1,JP).EQ.SPVAL) GO TO 125
         IM = IM+1
         IF (IM .LE. MN) GO TO 126
         IM = 1
         AN = Z(IP+1,JP)
         IF (Z(IP,JP)-AN) 101,103,113
C
  127 CONTINUE
C
      RETURN
C
C ****************************** ENTRY PNTVAL **************************
C     ENTRY PNTVAL (Z,L,MM,NN,JSIZEM,AASH,JOFFDT)
C
  128 CONTINUE
      II = (M-1+24)/24
      JJ = (N-1+48)/48
      NIQ = 1
      NJQ = 1
      DO 130 J=NJQ,N,JJ
         Y = J
         DO 129 I=NIQ,M,II
            X = I
            ZZ = Z(I,J)
            IF (IOFFP.NE.0 .AND. ZZ.EQ.SPVAL) GO TO 129
            CALL ENCD (ZZ,ASH,IA,NC,IOFFDT)
            CALL WTSTR ( FX(X,Y),FY(X,Y),IA(1:NC),ISIZEM,0,0 )
  129    CONTINUE
  130 CONTINUE
      RETURN
      END

C
C The object of this subroutine is to produce a set of plots illustrating
C the use of a triangular mesh derived from a SEAM grid on the surface
C of the globe (obtained from Jim Edwards):  Each face of a cube is
C divided into a 5-by-5 grid of squares (for a total of 6 x 5 x 5 = 150
C squares).  Each of those squares is further subdivided into an 7-by-7
C grid of rectangles, some of which are square (for a total of 150 x 7 x
C 7 = 7350 rectangles).  The rectangles are projected outward onto the
C surface of the globe to form a network of quadrilaterals, each of
C which is split into two triangles to form the triangular mesh.
C Routines developed for use with the geodesic mesh (method 2) are also
C used for this mesh.
C
      SUBROUTINE CTDRIVER(IWID,TLAT,TLON,PDAT,NLAT,NLON,IDIM,JDIM,RPNT,
     +                    MPNT,RWRK,LRWK,XCRA,YCRA,NCRA,IWRK,LIWK,IAMA,
     +                    LAMA,IAAI,IAGI,NGPS,ICRA,ICAM,ICAN,IEDG,MEDG,
     +                    ITRI,MTRI,IPPP,MNOP,IPPE,MNOE,LOPN,LOEN,LOTN,
     +                    IGRD,IMSH,ICON,ICOL,ICAP,IMAP,FNAM,ITIM,ILEV,
     +                    IDBG)

C
C Selected frames are drawn for each of four different viewpoints.  If
C (CLAT,CLON) is the approximate position of the "center point" of the
C mesh (which is defined somewhat arbitrarily for certain meshes), the
C four viewpoints used are as follows: (CLAT+45,CLON), (CLAT-45,CLON),
C (CLAT+45,CLON+180), and (CLAT-45,CLON+180).
C
C At each of the four viewpoints, up to five different frames are drawn:
C
C   1) A frame showing the original rectangular grid on the globe.
C      This frame is drawn only if the parameter IGRD is non-zero.
C
C   2) A frame showing the triangular mesh on the globe.  This frame
C      is drawn only if the parameter IMSH is non-zero.
C
C   3) A frame showing simple contours on the globe.  This frame is
C      drawn only if the parameter ICON is non-zero.
C
C   4) A frame showing color-filled contour bands on the globe, drawn
C      using filled areas.  This frame is drawn only if the parameter
C      ICOL is non-zero.
C
C   5) A frame showing color-filled contour bands on the globe, drawn
C      using a cell array.  This frame is drawn only if the parameter
C      ICAP is non-zero.
C
C IGRD defines the parameter that says whether or not to draw
C a rectangular grid.
C
C       IGRD=0  :  rectangular grid not drawn
C       IGRD=1  :  rectangular grid drawn
C
C IMSH defines the parameter that says whether or not to draw
C a triangular mesh.
C
C       IMSH=0  :  triangular mesh not drawn
C       IMSH=1  :  triangular mesh drawn
C
C ICON defines the parameter that says whether or not to draw simple
C contours (frame 3):
C
C       ICON=0  :  contours not drawn
C       ICON=1  :  contours drawn
C
C ICOL defines the parameter that says whether or not to draw
C color-filled contours (frame 4):
C
C       ICOL=0  : no color fill done
C       ICOL=1  : color fill done
C
C Define the parameter that says whether or not to draw a cell array
C plot (frame 5):
C
C       ICAP=0  :  cell array plot not drawn
C       ICAP=1  :  cell array plot drawn
C
C To represent the triangular mesh, we use three singly-dimensioned
C arrays: RPNT holds points, IEDG holds edges, and ITRI holds triangles.
C The elements of each array form "nodes" having lengths as follows:
C
C       LOPN  :  length of a point node
C
C The five elements of a point node are
C
C   1. the X coordinate of the point;
C   2. the Y coordinate of the point;
C   3. the Z coordinate of the point;
C   4. the field value at the point;
C   5. any additional value desired by the user.
C
C      LOEN  :  length of an edge node
C
C The five elements of an edge node are
C
C   1. the base index, in RPNT, of point 1 of the edge;
C   2. the base index, in RPNT, of point 2 of the edge;
C   3. the index, in ITRI, of the pointer to the edge in the triangle to
C      the left of the edge (-1 if there is no triangle to the left);
C   4. the index, in ITRI, of the pointer to the edge in the triangle to
C      the right of the edge (-1 if there is no triangle to the right);
C   5. a utility flag for use by algorithms that scan the structure.
C
C The "left" and "right" sides of an edge are defined as they would be
C by an observer standing on the globe at point 1 of the edge, looking
C toward point 2 of the edge.  It is possible, if there are "holes" in
C the mesh, that there will be no triangle to the left or to the right
C of an edge, but there must be a triangle on one side or the other.
C
C      LOTN  :  length of a triangle node
C
C The four elements of a triangle node are
C
C   1. the base index, in IEDG, of edge 1 of the triangle;
C   2. the base index, in IEDG, of edge 2 of the triangle;
C   3. the base index, in IEDG, of edge 3 of the triangle;
C   4. a flag set non-zero to block use of the triangle, effectively
C      removing it from the mesh.  Use the ISSCP grid and play with
C      the setting of the parameter ISCP (which see, below) to get
C      examples of the use of this feature.
C
C The "base index" of a point node, an edge node, or a triangle node is
C always a multiple of the length of the node, to which can be added an
C offset to get the index of a particular element of the node.  For
C example, if I is the base index of a triangle of interest, ITRI(I+1)
C is its first element (the base index of its first edge).  Similarly,
C IEDG(ITRI(I+1)+2) is the base index of the second point of the first
C edge of the triangle with base index I, and RPNT(IEDG(ITRI(I+1)+2)+3)
C is the third (Z) coordinate of the second point of the first edge of
C the triangle with base index I.
C
C It is the pointers from the edge nodes back to the triangle nodes that
C allow CONPACKT to navigate the mesh, moving from triangle to triangle
C as it follows a contour line, but these pointers are tricky to define:
C if IPTE is the base index of an edge node and IEDG(IPTE+3) is zero or
C more, saying that there is a triangle to the left of the edge, then
C IEDG(IPTE+3) is the actual index of that element of the triangle node
C that points to the edge node; i.e., ITRI(IDGE(IPTE+3))=IPTE.  The base
C index of the triangle node defining that triangle is IPTT, where
C IPTT=LOTN*((IEDG(IPTE+3)-1)/LOTN), and the index of the pointer to
C the edge within the triangle node is IPTI=IEDG(IPTE+3)-IPTT, so that
C IEDG(IPTT+IPTI)=IPTE.  Similar comments apply to element 4 of an edge
C node, which points into the triangle node defining the triangle to the
C right of the edge.
C
C The numbers of points, edges, and triangles in the triangular mesh are
C represented by MNOP, MNOE, and MNOT.
C
C Parameters defining the space reserved for the triangular mesh are
C MPNT (points), MEDG (edges), and MTRI (triangles).
C
C Declare the arrays to hold the point nodes, edge nodes, and triangle
C nodes defining the triangular mesh.
C
        DIMENSION RPNT(MPNT),IEDG(MEDG),ITRI(MTRI)
C
C Declare sort arrays to be used in GTJE02 to keep track of where points
C and edges were put in the structure defining the triangular mesh.
C
        DIMENSION IPPP(2,MNOP),IPPE(2,MNOE)
C
C Real and integer workspaces needed by CONPACKT
C
        DIMENSION RWRK(LRWK),IWRK(LIWK)
C
C Area map array needed to do solid fill
C
        DIMENSION IAMA(LAMA)
C
C Workspace arrays to be used in calls to ARSCAM
C
        DIMENSION XCRA(NCRA),YCRA(NCRA),IAAI(NGPS),IAGI(NGPS)
C
C Arrays in which to generate a cell array picture of the
C data on the triangular mesh
C
        DIMENSION ICRA(ICAM,ICAN)
C
C Name of field (optional)
C
        CHARACTER*(*) FNAM
C
C Declare arrays to hold color components for colors to be used at the
C four corners of an illustrative drawing of the rectangular grid.
C
        DIMENSION CCLL(3),CCLR(3),CCUL(3),CCUR(3)
C
C Declare external the routine that draws masked contour lines.
C
        EXTERNAL DRWMCL
C
C Declare external the routine that does color fill of contour bands.
C
        EXTERNAL DCFOCB
C
C Define a common block in which to keep track of the maximum space used
C in the arrays XCRA and YCRA.
C
        COMMON /COMONA/ MAXN
C
C Declare a temporary character buffer.
C
        CHARACTER*32 BUFF
C
C Declare arrays for lat/lon coordinate data.
C
        DIMENSION TLAT(IDIM,JDIM,NLAT),TLON(IDIM,JDIM,NLAT)
C
C Declare arrays in which to compute center points of elements of the
C SEAM grid.
C
        DIMENSION ELAT(NLAT),ELON(NLAT)
C
C Declare main data array.
C
        DIMENSION PDAT(IDIM,JDIM,NLAT)
C
C Define the out-of-range flag.
C
        DATA OORV / 1.E12 /
C
C Define the tension on the splines to be used in smoothing contours.
C
        DATA T2DS / 0.0 /  !  smoothing off
C       DATA T2DS / 2.5 /  !  smoothing on
C
C Define the distance between points on smoothed contour lines.
C
        DATA RSSL / .002 /
C
C Define the amount of real workspace to be used in drawing contours.
C
        DATA IRWC / 500 /
C
C Define the label-positioning flag.
C
C       DATA ILLP / 0 /  !  no labels
C       DATA ILLP / 1 /  !  dash-package writes labels
        DATA ILLP / 2 /  !  regular scheme
C       DATA ILLP / 3 /  !  penalty scheme
C
C Define the high/low search radius.
C
        DATA HLSR / .075 /
C
C Define the high/low label overlap flag.
C
        DATA IHLO / 11 /
C
C Define the hachuring flag, hachure length, and hachure spacing.
C
        DATA IHCF,HCHL,HCHS /  0 , +.004 , .010 /  !  off
C       DATA IHCF,HCHL,HCHS / +1 , -.004 , .020 /  !  on, all, uphill
C
C Define the colors to be used in the lower left, lower right, upper
C left, and upper right corners of the rectangular grid when a drawing
C of it is made for the purpose of illustrating how it is wrapped around
C the globe.
C
        DATA CCLL / 0.2 , 0.2 , 0.2 /
        DATA CCLR / 1.0 , 0.0 , 1.0 /
        DATA CCUL / 0.0 , 1.0 , 1.0 /
        DATA CCUR / 1.0 , 1.0 , 0.0 /
C
C Define a constant to convert from radians to degrees.
C
        DATA RTOD / 57.2957795130823 /
C
C Construct a label saying what data are being used.
C
        NCIB=0
        BUFF=' '
        IF (IDBG.NE.0.and.FNAM.NE.'') THEN
          CALL ADDCHS (BUFF,NCIB,FNAM)
        END IF
        IF (IDBG.NE.0.AND.ILEV.GE.0) THEN
          CALL ADDCHS (BUFF,NCIB,', LEVEL')
          CALL ADDCHR (BUFF,NCIB,' ')
          CALL ADDINT (BUFF,NCIB,ILEV)
        END IF
        IF (IDBG.NE.0.AND.ITIM.GE.0) THEN
          CALL ADDCHS (BUFF,NCIB,', TIME')
          CALL ADDCHR (BUFF,NCIB,' ')
          CALL ADDINT (BUFF,NCIB,ITIM)
        END IF
C
C Generate the required triangular mesh.
C
        IF(IDBG.EQ.1) THEN
           PRINT * , ' '
           PRINT * , 'CREATING TRIANGULAR MESH:'
        END IF
C
C Make the triangular mesh.
C
        CALL MKMESH (TLAT,TLON,IDIM,JDIM,NLAT,  !  lat/lon data
     +               RPNT,MPNT,NPNT,LOPN,       !  point list
     +               IEDG,MEDG,NEDG,LOEN,       !  edge list
     +               ITRI,MTRI,NTRI,LOTN,       !  triangle list
     +               IPPP,IPPE,CLAT,CLON,       !  other stuff
     +               ELAT,ELON)                 !  other stuff
C
C Print the number of points, edges, and triangles.
C
        IF(IDBG.EQ.1) THEN
           PRINT * , '  NUMBER OF POINTS:    ',NPNT/LOPN
           PRINT * , '  NUMBER OF EDGES:     ',NEDG/LOEN
           PRINT * , '  NUMBER OF TRIANGLES: ',NTRI/LOTN
        END IF
C
C Copy the "data" values, which are really combined index values we
C will need later, from node position 4 to node position 5.
C
        DO 101 IPNT=0,NPNT-LOPN,LOPN
          RPNT(IPNT+5)=RPNT(IPNT+4)
  101   CONTINUE
C
C Incorporate the data values into the mesh.
C
        DO 102 IPNT=0,NPNT-LOPN,LOPN
          I=INT(RPNT(IPNT+5))/(JDIM*NLAT)+1
          J=MOD(INT(RPNT(IPNT+5)),JDIM*NLAT)/NLAT+1
          K=MOD(INT(RPNT(IPNT+5)),NLAT)+1
          RPNT(IPNT+4)=PDAT(I,J,K)
  102   CONTINUE
C
C Write the contents of the point list, the edge list, and the triangle
C list to "fort.11" in a readable form.
C
c       WRITE (11,'(''P'',I8,5F10.4)')
c    +        (I,RPNT(I+1),RPNT(I+2),RPNT(I+3),RPNT(I+4),RPNT(I+5),
c    +                                               I=0,NPNT-LOPN,LOPN)
c       WRITE (11,'(''E'',I8,5I10)')
c    +        (I,IEDG(I+1),IEDG(I+2),IEDG(I+3),IEDG(I+4),IEDG(I+5),
c    +                                               I=0,NEDG-LOEN,LOEN)
c       WRITE (11,'(''T'',I8,4I10)')
c    +        (I,ITRI(I+1),ITRI(I+2),ITRI(I+3),ITRI(I+4),
c    +                                               I=0,NTRI-LOTN,LOTN)
C
C Open GKS.
C
C
C Turn off the clipping indicator.
C
        CALL GSCLIP (0)
C
C Define a basic set of colors.
C
        CALL GSCR   (IWID, 0,1.,1.,1.)  !  white (background)
        CALL GSCR   (IWID, 1,0.,0.,0.)  !  black (foreground)
        CALL GSCR   (IWID, 2,1.,1.,0.)  !  yellow
        CALL GSCR   (IWID, 3,1.,0.,1.)  !  magenta
        CALL GSCR   (IWID, 4,1.,0.,0.)  !  red
        CALL GSCR   (IWID, 5,0.,1.,1.)  !  cyan
        CALL GSCR   (IWID, 6,0.,1.,0.)  !  green
        CALL GSCR   (IWID, 7,0.,0.,1.)  !  blue
        CALL GSCR   (IWID, 8,.5,.5,.5)  !  darker light gray
        CALL GSCR   (IWID, 9,.8,.8,.8)  !  lighter light gray
        CALL GSCR   (IWID,10,.3,.3,0.)  !  dark yellow
        CALL GSCR   (IWID,11,.3,.3,.3)  !  dark gray
        CALL GSCR   (IWID,12,.5,.5,.5)  !  medium gray
        CALL GSCR   (IWID,13,.8,.5,.5)  !  light red - geographic lines
        CALL GSCR   (IWID,14,.5,.5,.8)  !  light blue - lat/lon lines
C
C Define 100 colors, associated with color indices 151 through 250, to
C be used for color-filled contour bands and in cell arrays, ranging
C from blue to red.
C
        CALL DFCLRS (IWID,151,250,0.,0.,1.,1.,0.,0.)
C
C Set parameters in the utilities.
C
        IF(IDBG.EQ.1) THEN
          PRINT *,'SETTING PARAMETERS IN CONPACKT, EZMAP, AND PLOTCHAR'
        END IF
C
C Set the mapping flag.
C
        CALL CTSETI ('MAP - MAPPING FLAG',1)
C
C Set the out-of-range flag value.
C
        CALL CTSETR ('ORV - OUT-OF-RANGE VALUE',OORV)
C
C Turn on the drawing of the mesh edge and set the area identifier for
C areas outside the mesh.
C
        CALL CTSETI ('PAI - PARAMETER ARRAY INDEX',-1)
        CALL CTSETI ('CLU - CONTOUR LEVEL USE FLAG',1)
        CALL CTSETI ('AIA - AREA IDENTIFIER FOR AREA',1001)
C
C Set the area identifier for areas in "out-of-range" areas.
C
C       CALL CTSETI ('PAI',-2)
C       CALL CTSETI ('AIA - AREA IDENTIFIER FOR AREA',1002)
C
C Set the 2D smoother flag.
C
        CALL CTSETR ('T2D - TENSION ON 2D SPLINES',T2DS)
C
C Set the distance between points on smoothed lines.
C
        CALL CTSETR ('SSL - SMOOTHED SEGMENT LENGTH',RSSL)
C
C Set the amount of real workspace to be used in drawing contours.
C
        CALL CTSETI ('RWC - REAL WORKSPACE FOR CONTOURS',IRWC)
C
C Set the label-positioning flag.
C
        CALL CTSETI ('LLP - LINE LABEL POSITIONING FLAG',ILLP)
C
C Set the high/low search radius.
C
        CALL CTSETR ('HLR - HIGH/LOW SEARCH RADIUS',HLSR)
C
C Set the high/low label overlap flag.
C
        CALL CTSETI ('HLO - HIGH/LOW LABEL OVERLAP FLAG',IHLO)
C
C Set the hachuring flag, hachure length, and hachure spacing.
C
        CALL CTSETI ('HCF - HACHURING FLAG',IHCF)
        CALL CTSETR ('HCL - HACHURE LENGTH',HCHL)
        CALL CTSETR ('HCS - HACHURE SPACING',HCHS)
C
C Set the cell array flag.
C
        CALL CTSETI ('CAF - CELL ARRAY FLAG',-1)
C
C Tell CONPACKT not to do its own call to SET, since EZMAP will have
C done it.
C
        CALL CTSETI ('SET - DO-SET-CALL FLAG', 0)
C
C Move the informational label up a little.
C
        CALL CTSETR ('ILY - INFORMATIONAL LABEL Y POSITION',-.005)
C
C Tell EZMAP not to draw the perimeter.
C
        CALL MPSETI ('PE',0)
C
C Tell EZMAP to use solid lat/lon lines.
C
        CALL MPSETI ('DA',65535)
C
C Tell PLOTCHAR to use one of the filled fonts and to outline each
C character.
C
        CALL PCSETI ('FN',25)
        CALL PCSETI ('OF',1)
C
C Tell PLOTCHAR to expect a character other than a colon as the
C function-control signal character.
C
C        CALL PCSETC ('FC','~')
C
        IF(IMAP.EQ.1) THEN          !  four different (OR) views of the globe
           IDIR1 = 1
           IDIR2 = 4
        ELSE IF(IMAP.EQ.2) THEN     !  one (CE) view of the globe
           IDIR1 = 5
           IDIR2 = 5
        ELSE IF(IMAP.EQ.3) THEN     !  one (RO) view of the globe
           IDIR1 = 6
           IDIR2 = 6
        ELSE IF(IMAP.EQ.4) THEN     !  one (LE) view of the globe
           IDIR1 = 7
           IDIR2 = 7
        END IF
C
C Loop through the different viewing angles.
C
       DO 104 IDIR=IDIR1,IDIR2
C
           IF(IDBG.EQ.1) THEN
              PRINT * , ' '
              PRINT * , 'VIEW FROM DIRECTION NUMBER: ',IDIR
           END IF
C
C Tell EZMAP what projection to use and what its limits are.
C
          IF      (IDIR.EQ.1) THEN
            CALL MAPROJ ('OR',CLAT+45.,CLON,      0.)
          ELSE IF (IDIR.EQ.2) THEN
            CALL MAPROJ ('OR',CLAT-45.,CLON,      0.)
          ELSE IF (IDIR.EQ.3) THEN
            CALL MAPROJ ('OR',CLAT+45.,CLON+180., 0.)
          ELSE IF (IDIR.EQ.4) THEN
            CALL MAPROJ ('OR',CLAT-45.,CLON+180., 0.)
          ELSE IF (IDIR.EQ.5) THEN
            CALL MAPROJ ('CE',0.,0.,0.)
          ELSE IF (IDIR.EQ.6) THEN
            CALL MAPROJ ('RO',0.,0.,0.)
          ELSE IF (IDIR.EQ.7) THEN
            CALL MAPROJ ('LE',40.,-105.,0.)
          END IF
C
          CALL MAPSET ('MA',0.,0.,0.,0.)
C
C Initialize EZMAP.
C
          CALL MAPINT
C
C If the rectangular grid and/or the triangular mesh are to be drawn,
C do it.
C
          IF (IGRD.NE.0) THEN
C
C Simple rectangular grid:
C
             IF(IDBG.EQ.1) THEN
                PRINT * , 'DRAWING SIMPLE RECTANGULAR GRID'
             END IF
C
             CALL DSJE02 (TLAT,TLON,ELAT,ELON,IDIM,JDIM,NLAT)
C
C Label the first frame.
C
              CALL PLCHHQ (CFUX(.03),CFUY(.946),'SEAM GRID',
     +                                                      .024,0.,-1.)
              CALL PLCHHQ (CFUX(.03),CFUY(.906),'(EXAMPLE 3)',
     +                                                      .016,0.,-1.)
C
              IF (     IDIR.EQ.1) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 1',
     +                                                      .012,0.,-1.)
              ELSE IF (IDIR.EQ.2) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 2',
     +                                                      .012,0.,-1.)
              ELSE IF (IDIR.EQ.3) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 3',
     +                                                      .012,0.,-1.)
              ELSE IF (IDIR.EQ.4) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 4',
     +                                                      .012,0.,-1.)
              END IF
C
              CALL PLCHHQ (CFUX(.97),CFUY(.950),'ORIGINAL RECTANGULAR GR
     +ID',.012,0.,1.)
C
              CALL PLCHHQ (CFUX(.97),CFUY(.928),
     +                     'This grid is developed from a cube.',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.908),
     +                     'The numbers label 150 elements,',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.888),
     +                     'each of which derives from',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.868),
     +                     '1/25 of a cube face and',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.848),
     +                     'is subdivided into',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.828),
     +                     'a 7x7 array of',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.808),
     +                     'rectangular',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.788),
     +                     'patches.',
     +                                                       .010,0.,1.)
C
              CALL PLCHHQ (CFUX(.03),CFUY(.084),'Grid is gray.',
     +                                                      .012,0.,-1.)
              CALL PLCHHQ (CFUX(.03),CFUY(.060),'Shorelines are blue.',
     +                                                      .012,0.,-1.)
              CALL PLCHHQ (CFUX(.03),CFUY(.036),'Parallels/meridians are
     + red.',.012,0.,-1.)
C
C Advance the frame.
C
             CALL FRAME
C
          END IF
C
C Triangular mesh (with edges between blocked triangles somewhat fainter
C than the rest):
C
          IF (IMSH.NE.0) THEN
C
             IF(IDBG.EQ.1) THEN
                PRINT * , 'DRAWING TRIANGULAR MESH'
             END IF
C
             DO 103 IPTE=0,NEDG-LOEN,LOEN
C
                IFLL=0
C
                IF (IEDG(IPTE+3).GE.0) THEN
                   IF (ITRI(LOTN*((IEDG(IPTE+3)-1)/LOTN)+4).EQ.0) IFLL=1
                END IF
C
                IFLR=0
C
                IF (IEDG(IPTE+4).GE.0) THEN
                  IF (ITRI(LOTN*((IEDG(IPTE+4)-1)/LOTN)+4).EQ.0) IFLR=1
                END IF
C
                IF (IFLL.NE.0.OR.IFLR.NE.0) THEN
                  CALL PLOTIT (0,0,2)
                  CALL GSPLCI (8)
                ELSE
                  CALL PLOTIT (0,0,2)
                  CALL GSPLCI (9)
                END IF
C
                ALAT=RTOD*ASIN(RPNT(IEDG(IPTE+1)+3))
C
                IF (RPNT(IEDG(IPTE+1)+1).EQ.0..AND.
     +              RPNT(IEDG(IPTE+1)+2).EQ.0.) THEN
                  ALON=0.
                ELSE
                  ALON=RTOD*ATAN2(RPNT(IEDG(IPTE+1)+2),
     +                            RPNT(IEDG(IPTE+1)+1))
                END IF
C
                BLAT=RTOD*ASIN(RPNT(IEDG(IPTE+2)+3))
C
                IF (RPNT(IEDG(IPTE+2)+1).EQ.0..AND.
     +              RPNT(IEDG(IPTE+2)+2).EQ.0.) THEN
                  BLON=0.
                ELSE
                  BLON=RTOD*ATAN2(RPNT(IEDG(IPTE+2)+2),
     +                            RPNT(IEDG(IPTE+2)+1))
                END IF
C
                CALL DRSGCR (ALAT,ALON,BLAT,BLON)
C
  103         CONTINUE
C
              CALL PLOTIT (0,0,2)
              CALL GSPLCI (13)
              CALL MAPGRD
              CALL PLOTIT (0,0,2)
              CALL GSPLCI (14)
              CALL MAPLOT
C
C Label the second frame.
C
              CALL PLCHHQ (CFUX(.03),CFUY(.946),'SEAM GRID',
     +                                                      .024,0.,-1.)
              CALL PLCHHQ (CFUX(.03),CFUY(.906),'(EXAMPLE 3)',
     +                                                      .016,0.,-1.)
C
              IF (     IDIR.EQ.1) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 1',
     +                                                      .012,0.,-1.)
              ELSE IF (IDIR.EQ.2) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 2',
     +                                                      .012,0.,-1.)
              ELSE IF (IDIR.EQ.3) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 3',
     +                                                      .012,0.,-1.)
              ELSE IF (IDIR.EQ.4) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 4',
     +                                                      .012,0.,-1.)
              END IF
C
              CALL PLCHHQ (CFUX(.97),CFUY(.950),'DERIVED TRIANGULAR MESH
     +',.012,0.,1.)
C
              CALL PLCHHQ (CFUX(.97),CFUY(.928),
     +                     'Each quadrilateral of the grid',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.908),
     +                     'is split along a diagonal',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.888),
     +                     'to get two triangles',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.868),
     +                     'of the mesh.',
     +                                                       .010,0.,1.)
C
              CALL PLCHHQ (CFUX(.03),CFUY(.084),'Mesh is gray.',
     +                                                      .012,0.,-1.)
              CALL PLCHHQ (CFUX(.03),CFUY(.060),'Shorelines are blue.',
     +                                                      .012,0.,-1.)
              CALL PLCHHQ (CFUX(.03),CFUY(.036),'Parallels/meridians are
     + red.',.012,0.,-1.)
C
C Advance the frame.
C
              CALL FRAME
C
           END IF
C
C If a frame showing simple contours is to be drawn, do it next (adding
C an overlay of lat/lon lines and continental outlines in light gray).
C
          IF (ICON.NE.0) THEN
C
             IF(IDBG.EQ.1) THEN
                PRINT * , 'DRAWING PLOT SHOWING SIMPLE CONTOURS'
             END IF
C
C Initialize CONPACKT.
C
             IF(IDBG.EQ.1) THEN
                PRINT * , 'CALLING CTMESH'
             END IF
C
            CALL CTMESH (RPNT,NPNT,LOPN,  !  point list
     +                   IEDG,NEDG,LOEN,  !  edge list
     +                   ITRI,NTRI,LOTN,  !  triangle list
     +                   RWRK,LRWK,       !  real workspace
     +                   IWRK,LIWK)       !  integer workspace
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (1)
C
C Proceed as implied by the setting of the label-positioning flag.
C
            IF (ABS(ILLP).EQ.1) THEN
C
C Draw the contour lines with labels generated by the dash package.
C
               IF(IDBG.EQ.1) THEN
                  PRINT * , 'CALLING CTCLDR'
               END IF
               CALL CTCLDR (RPNT,IEDG,ITRI,RWRK,IWRK)
C
C Add the informational and high/low labels.
C
               IF(IDBG.EQ.1) THEN
                  PRINT * , 'CALLING CTLBDR'
               END IF
               CALL CTLBDR (RPNT,IEDG,ITRI,RWRK,IWRK)
C
            ELSE IF (ABS(ILLP).GT.1) THEN
C
C Create an area map for masking of labels.
C
              MAXN=0
C
              IF(IDBG.EQ.1) THEN
                 PRINT * , 'CALLING ARINAM'
              END IF
              CALL ARINAM (IAMA,LAMA)
C
              IF(IDBG.EQ.1) THEN
                 PRINT * , 'CALLING CTLBAM'
              END IF
              CALL CTLBAM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA)
C
C Draw the contour lines masked by the area map.
C
              IF(IDBG.EQ.1) THEN
                 PRINT * , 'CALLING CTCLDM'
              END IF
              CALL CTCLDM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA,DRWMCL)
C
              IF(IDBG.EQ.1) THEN
                 PRINT * , 'AREA MAP SPACE REQUIRED:         ',
     +                IAMA(1)-IAMA(6)+IAMA(5)+1
C
                 PRINT * , 'NUMBER OF POINTS IN LONGEST LINE:',MAXN
              END IF
C
C Draw all the labels.
C
              IF(IDBG.EQ.1) THEN
                 PRINT * , 'CALLING CTLBDR'
              END IF
              CALL CTLBDR (RPNT,IEDG,ITRI,RWRK,IWRK)
C
            END IF
C
            CALL CTGETI ('IWU - INTEGER WORKSPACE USED',IIWU)
            IF(IDBG.EQ.1) THEN
               PRINT * , 'INTEGER WORKSPACE REQUIRED:      ',IIWU
            END IF
C
            CALL CTGETI ('RWU -    REAL WORKSPACE USED',IRWU)
            IF(IDBG.EQ.1) THEN
               PRINT * , 'REAL WORKSPACE REQUIRED:         ',IRWU
            END IF
C
C Add lat/lon lines and continental outlines.
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (13)
            CALL MAPGRD
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (14)
            CALL MAPLOT
C
C Label the third frame.
C
            CALL PLCHHQ (CFUX(.03),CFUY(.946),'SEAM GRID',.024,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.906),'(EXAMPLE 3)',.016,0.,-1.)
C
            IF (     IDIR.EQ.1) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 1',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.2) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 2',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.3) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 3',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.4) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 4',
     +                                                      .012,0.,-1.)
            END IF
C
            CALL PLCHHQ (CFUX(.97),CFUY(.950),'SIMPLE CONTOURS ON',
     +                                                       .012,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.926),'TRIANGULAR MESH',
     +                                                       .012,0.,1.)
C
            IF(NCIB.GE.0) THEN
              CALL PLCHHQ (CFUX(.97),CFUY(.904),BUFF(1:NCIB),.008,0.,1.)
            END IF
C
              CALL PLCHHQ (CFUX(.03),CFUY(.060),'Shorelines are blue.',
     +                                                      .012,0.,-1.)
              CALL PLCHHQ (CFUX(.03),CFUY(.036),'Parallels/meridians are
     + red.',.012,0.,-1.)
C
C Advance the frame.
C
            CALL FRAME
C
          END IF
C
C If a frame showing color-filled contours is to be drawn, do it next.
C
          IF (ICOL.NE.0) THEN
C
             IF(IDBG.EQ.1) THEN
                PRINT * , 'DRAWING PLOT SHOWING COLOR-FILLED CONTOURS'
             END IF
C
             IF(IDBG.EQ.1) THEN
                PRINT * , 'CALLING CTMESH'
             END IF
C
            CALL CTMESH (RPNT,NPNT,LOPN,  !  point list
     +                   IEDG,NEDG,LOEN,  !  edge list
     +                   ITRI,NTRI,LOTN,  !  triangle list
     +                   RWRK,LRWK,       !  real workspace
     +                   IWRK,LIWK)       !  integer workspace
C
            MAXN=0
C
            IF(IDBG.EQ.1) THEN
               PRINT * , 'CALLING CTPKCL'
            END IF
            CALL CTPKCL (RPNT,IEDG,ITRI,RWRK,IWRK)
C
            IF(IDBG.EQ.1) THEN
               PRINT * , 'CALLING ARINAM'
            END IF
            CALL ARINAM (IAMA,LAMA)
C
            IF(IDBG.EQ.1) THEN
               PRINT * , 'CALLING CTCLAM'
            END IF
            CALL CTCLAM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA)
C
            IF(IDBG.EQ.1) THEN
               PRINT * , 'CALLING CTLBAM'
            END IF
C           CALL CTLBAM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA)
C
            IF(IDBG.EQ.1) THEN
               PRINT * , 'CALLING ARSCAM'
            END IF
            CALL ARSCAM (IAMA,XCRA,YCRA,NCRA,IAAI,IAGI,NGPS,DCFOCB)
C
            IF(IDBG.EQ.1) THEN
               PRINT * , 'SPACE REQUIRED IN AREA MAP:      ',
     +              IAMA(1)-IAMA(6)+IAMA(5)+1
C
               PRINT * , 'NUMBER OF POINTS IN LARGEST AREA:',MAXN
            END IF
C
            CALL CTGETI ('IWU - INTEGER WORKSPACE USED',IIWU)
            IF(IDBG.EQ.1) THEN
               PRINT * , 'INTEGER WORKSPACE REQUIRED:      ',IIWU
            END IF
C
            CALL CTGETI ('RWU -    REAL WORKSPACE USED',IRWU)
            IF(IDBG.EQ.1) THEN
               PRINT * , 'REAL WORKSPACE REQUIRED:         ',IRWU
            END IF
C
            CALL GSFACI (1)
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (13)
            CALL MAPGRD
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (14)
            CALL MAPLOT
C
C Label the fourth frame.
C
            CALL PLCHHQ (CFUX(.03),CFUY(.946),'SEAM GRID',.024,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.906),'(EXAMPLE 3)',.016,0.,-1.)
C
            IF (     IDIR.EQ.1) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 1',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.2) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 2',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.3) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 3',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.4) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 4',
     +                                                      .012,0.,-1.)
            END IF
C
            CALL PLCHHQ (CFUX(.97),CFUY(.950),'COLORED CONTOUR BANDS ON'
     +,.012,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.926),'TRIANGULAR MESH',
     +                                                       .012,0.,1.)
C
            IF(NCIB.GE.0) THEN
              CALL PLCHHQ (CFUX(.97),CFUY(.904),BUFF(1:NCIB),.008,0.,1.)
            END IF
C
            CALL PLCHHQ (CFUX(.03),CFUY(.132),'Off-mesh',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.108),'areas of the',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.084),'globe are yellow.',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.060),'Shorelines are blue.',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.036),'Parallels/meridians are r
     +ed.',.012,0.,-1.)
C
C Advance the frame.
C
            CALL FRAME
C
          END IF
C
C If the flag for it is set, do a cell array plot.
C
          IF (ICAP.NE.0) THEN
C
             IF(IDBG.EQ.1) THEN
                PRINT * , 'DRAWING CELL-ARRAY PLOT OF DATA VALUES'
             END IF
C
             IF(IDBG.EQ.1) THEN
                PRINT * , 'CALLING CTMESH'
             END IF
C
            CALL CTMESH (RPNT,NPNT,LOPN,  !  point list
     +                   IEDG,NEDG,LOEN,  !  edge list
     +                   ITRI,NTRI,LOTN,  !  triangle list
     +                   RWRK,LRWK,       !  real workspace
     +                   IWRK,LIWK)       !  integer workspace
C
            CALL GETSET (XVPL,XVPR,YVPB,YVPT,XWDL,XWDR,YWDB,YWDT,LNLG)
C
            IF(IDBG.EQ.1) THEN
               PRINT * , 'CALLING CTCICA'
            END IF
            CALL CTCICA (RPNT,IEDG,ITRI,RWRK,IWRK,ICRA,ICAM,ICAM,ICAN,
     +                                            XVPL,YVPB,XVPR,YVPT)
C
            IF(IDBG.EQ.1) THEN
               PRINT * , 'CALLING GCA'
            END IF
            CALL GCA (XWDL,YWDB,XWDR,YWDT,ICAM,ICAN,1,1,ICAM,ICAN,ICRA)
C
            CALL CTGETI ('IWU - INTEGER WORKSPACE USED',IIWU)
            IF(IDBG.EQ.1) THEN
               PRINT * , 'INTEGER WORKSPACE REQUIRED:      ',IIWU
            END IF
C
            CALL CTGETI ('RWU -    REAL WORKSPACE USED',IRWU)
            IF(IDBG.EQ.1) THEN
               PRINT * , 'REAL WORKSPACE REQUIRED:         ',IRWU
            END IF
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (13)
            CALL MAPGRD
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (14)
            CALL MAPLOT
C
C Label the fifth frame.
C
            CALL PLCHHQ (CFUX(.03),CFUY(.946),'SEAM GRID',.024,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.906),'(EXAMPLE 3)',.016,0.,-1.)
C
            IF (     IDIR.EQ.1) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 1',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.2) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 2',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.3) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 3',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.4) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 4',
     +                                                      .012,0.,-1.)
            END IF
C
            CALL PLCHHQ (CFUX(.97),CFUY(.950),'CELL ARRAY DERIVED FROM',
     +.012,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.926),'TRIANGULAR MESH',
     +                                                       .012,0.,1.)
C
            IF(NCIB.GE.0) THEN
              CALL PLCHHQ (CFUX(.97),CFUY(.904),BUFF(1:NCIB),.008,0.,1.)
            END IF
            CALL PLCHHQ (CFUX(.03),CFUY(.132),'Off-mesh',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.108),'areas of the',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.084),'globe are yellow.',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.060),'Shorelines are blue.',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.036),'Parallels/meridians are r
     +ed.',.012,0.,-1.)
C
C Advance the frame.
C
            CALL FRAME
C
          END IF
C
  104   CONTINUE
C
C Done.
C
        STOP
C
      END

      SUBROUTINE DFCLRS (IWID,IOFC,IOLC,REDF,GRNF,BLUF,REDL,GRNL,BLUL)
C
C This routine defines color indices IOFC through IOLC on workstation
C IWID by interpolating values from REDF/GRNF/BLUF to REDL/GRNL/BLUL.
C
        DO 101 I=IOFC,IOLC
          P=REAL(IOLC-I)/REAL(IOLC-IOFC)
          Q=REAL(I-IOFC)/REAL(IOLC-IOFC)
          CALL GSCR (IWID,I,P*REDF+Q*REDL,P*GRNF+Q*GRNL,P*BLUF+Q*BLUL)
  101   CONTINUE
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE DRWMCL (XCRA,YCRA,NCRA,IAAI,IAGI,NGPS)
C
        DIMENSION XCRA(*),YCRA(*),IAAI(*),IAGI(*)
C
C This routine draws the curve defined by the points (XCRA(I),YCRA(I)),
C for I = 1 to NCRA, if and only if none of the area identifiers for the
C area containing the polyline are negative.  It calls either CURVE or
C CURVED to do the drawing, depending on the value of the internal
C parameter 'DPU'.
C
C It keeps track of the maximum value used for NCRA in a common block.
C
        COMMON /COMONA/ MAXN
C
        MAXN=MAX(MAXN,NCRA)
C
C Retrieve the value of the internal parameter 'DPU'.
C
        CALL CTGETI ('DPU - DASH PACKAGE USED',IDUF)
C
C Turn on drawing.
C
        IDRW=1
C
C If any area identifier is negative, turn off drawing.
C
        DO 101 I=1,NGPS
          IF (IAAI(I).LT.0) IDRW=0
  101   CONTINUE
C
C If drawing is turned on, draw the polyline.
C
        IF (IDRW.NE.0) THEN
          IF (IDUF.EQ.0) THEN
            CALL CURVE  (XCRA,YCRA,NCRA)
          ELSE IF (IDUF.LT.0) THEN
            CALL DPCURV (XCRA,YCRA,NCRA)
          ELSE
            CALL CURVED (XCRA,YCRA,NCRA)
          END IF
        END IF
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE DCFOCB (XCRA,YCRA,NCRA,IAAI,IAGI,NGPS)
C
C This routine fills the area defined by the points (XCRA(I),YCRA(I)),
C for I = 1 to NCRA, if and only if none of the area identifiers for
C the area are negative.  The color used is determined from the area
C identifier of the area relative to group 3; it is assumed that 100
C colors are defined having color indices 151 through 250.
C
        DIMENSION XCRA(*),YCRA(*),IAAI(*),IAGI(*)
C
C It keeps track of the maximum value used for NCRA in a common block.
C
        COMMON /COMONA/ MAXN
C
        MAXN=MAX(MAXN,NCRA)
C
C Retrieve the number of contour levels being used.
C
        CALL CTGETI ('NCL - NUMBER OF CONTOUR LEVELS',NOCL)
C
C If the number of contour levels is non-zero and the area has more
C than two points, fill it.
C
        IF (NOCL.NE.0.AND.NCRA.GT.2) THEN
C
          IAI3=-1
C
          DO 101 I=1,NGPS
            IF (IAGI(I).EQ.3) IAI3=IAAI(I)
  101     CONTINUE
C
          IF (IAI3.GE.1.AND.IAI3.LE.NOCL+1) THEN
            CALL GSFACI (151+INT(((REAL(IAI3)-.5)/REAL(NOCL+1))*100.))
            CALL GFA    (NCRA,XCRA,YCRA)
          ELSE IF (IAI3.EQ.1001) THEN
            CALL GSFACI (2)
            CALL GFA    (NCRA,XCRA,YCRA)
          ELSE IF (IAI3.EQ.1002) THEN
            CALL GSFACI (3)
            CALL GFA    (NCRA,XCRA,YCRA)
          END IF
C
        END IF
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE MKMESH (TLAT,TLON,IDIM,JDIM,NLAT,  !  lat/lon data
     +                   RPNT,MPNT,NPNT,LOPN,       !  point list
     +                   IEDG,MEDG,NEDG,LOEN,       !  edge list
     +                   ITRI,MTRI,NTRI,LOTN,       !  triangle list
     +                   IPPP,IPPE,CLAT,CLON,       !  other stuff
     +                   ELAT,ELON)                 !  other stuff
C
        DIMENSION TLAT(IDIM,JDIM,NLAT),TLON(IDIM,JDIM,NLAT)
        DIMENSION RPNT(MPNT),IEDG(MEDG),ITRI(MTRI),IPPP(2,*),IPPE(2,*)
        DIMENSION ELAT(NLAT),ELON(NLAT)
C
C Construct a triangular mesh using SEAM data from Jim Edwards,
C using a routine (CTTMTL) that makes it easy to create an arbitrary
C triangular mesh (first used above in GTGEO2).  The "quicksorts"
C used by this method are very inefficient for objects that are
C partially ordered, so, as the triangles of the mesh are generated,
C they are stored in a triangle buffer from which they can be dumped
C in random order by calls to the routine CTTMTL.
C
C Declare the array to use as the buffer for the triangles, so that the
C order in which they are processed can be somewhat randomized.  Up to
C a point, making this buffer larger will result in more randomization
C of the triangles and speed up the process.  MBUF is the number of
C triangles that will fit in the buffer at once, and KBUF is the number
C of those that are dumped whenever the buffer is found to be full; it
C turns out that it's better to dump more than 1 at a time (I suppose
C because the call and loop set-up time for CTTMTL are non-trivial, so
C it's better to dump a few triangles while you're there).  So ... use
C MBUF > KBUF > 1.
C
        PARAMETER (MBUF=5021,KBUF=173,MBM1=MBUF-1,DTOR=.017453292519943)
C
        DIMENSION TBUF(12,MBUF)
C
C Find the center points of the elements of Edwards' grid.
C
        DO 101 K=1,NLAT
          CALL IPIQOS (TLAT(IDIM/2  ,JDIM/2  ,K),
     +                 TLON(IDIM/2  ,JDIM/2  ,K),
     +                 TLAT(IDIM/2+1,JDIM/2  ,K),
     +                 TLON(IDIM/2+1,JDIM/2  ,K),
     +                 TLAT(IDIM/2  ,JDIM/2+1,K),
     +                 TLON(IDIM/2  ,JDIM/2+1,K),
     +                 TLAT(IDIM/2+1,JDIM/2+1,K),
     +                 TLON(IDIM/2+1,JDIM/2+1,K),.5,.5,ELAT(K),ELON(K))
  101   CONTINUE
C
C Build structures forming the triangular mesh.  First, initialize the
C variables used to keep track of items in the sort arrays for points
C and edges, in the triangle buffer, and in the triangle list.
C
        MPPP=MPNT/LOPN  !  point sorting
        NPPP=0
C
        MPPE=MEDG/LOEN  !  edge sorting
        NPPE=0
C
        NBUF=0  !  triangle buffer
C
        NTRI=0  !  triangle list
C
C Loop through the triangles derived from Jim's SEAM grid.  K indexes
C the elements of the rectangular mesh, each of which is a IDIM-by-JDIM
C array of rectangles.  IROW and ICOL are the row and column numbers of
C the element within a square face of the cube; together, they determine
C the "parity" of the rectangle, determining which diagonal of it to use
C to split it into two triangles.
C
        KONE=NLAT/6
        KTWO=INT(SQRT(REAL(KONE)))
        IF (KONE.NE.KTWO*KTWO) THEN
          PRINT * , 'MKMESH - POSSIBLE PROBLEM WITH KONE AND KTWO'
        END IF
C
        DO 107 K=1,NLAT
C
          IROW=MOD(K-1,KONE)/KTWO+1
          ICOL=MOD(K-1,KTWO)     +1
C
C I and J index the rectangular pieces of each square element.
C
          DO 106 I=1,IDIM-1
            DO 105 J=1,JDIM-1
C
C If the triangle buffer is almost full, dump a few randomly-chosen
C triangles from it to make room for two new ones.
C
              IF (NBUF.GE.MBM1) THEN
                CALL CTTMTL (KBUF,TBUF,MBUF,NBUF,
     +                       IPPP,MPPP,NPPP,
     +                       IPPE,MPPE,NPPE,
     +                       RPNT,MPNT,NPNT,LOPN,
     +                       IEDG,MEDG,NEDG,LOEN,
     +                       ITRI,MTRI,NTRI,LOTN)
              END IF
C
C Put two new triangles in the triangle buffer.  For the "data", use
C a value from which we can extract the indices I, J, and K.
C
              IF (MOD(I+J+IROW+ICOL,2).EQ.0) THEN
C
                NBUF=NBUF+1
C
                TBUF( 1,NBUF)=COS(DTOR*TLAT(I  ,J  ,K))*
     +                        COS(DTOR*TLON(I  ,J  ,K))
                TBUF( 2,NBUF)=COS(DTOR*TLAT(I  ,J  ,K))*
     +                        SIN(DTOR*TLON(I  ,J  ,K))
                TBUF( 3,NBUF)=SIN(DTOR*TLAT(I  ,J  ,K))
                TBUF( 4,NBUF)=REAL((I-1)*JDIM*NLAT+(J-1)*NLAT+K-1)
C
                TBUF( 5,NBUF)=COS(DTOR*TLAT(I+1,J  ,K))*
     +                        COS(DTOR*TLON(I+1,J  ,K))
                TBUF( 6,NBUF)=COS(DTOR*TLAT(I+1,J  ,K))*
     +                        SIN(DTOR*TLON(I+1,J  ,K))
                TBUF( 7,NBUF)=SIN(DTOR*TLAT(I+1,J  ,K))
                TBUF( 8,NBUF)=REAL((I  )*JDIM*NLAT+(J-1)*NLAT+K-1)
C
                TBUF( 9,NBUF)=COS(DTOR*TLAT(I+1,J+1,K))*
     +                        COS(DTOR*TLON(I+1,J+1,K))
                TBUF(10,NBUF)=COS(DTOR*TLAT(I+1,J+1,K))*
     +                        SIN(DTOR*TLON(I+1,J+1,K))
                TBUF(11,NBUF)=SIN(DTOR*TLAT(I+1,J+1,K))
                TBUF(12,NBUF)=REAL((I  )*JDIM*NLAT+(J  )*NLAT+K-1)
C
                NBUF=NBUF+1
C
                TBUF( 1,NBUF)=COS(DTOR*TLAT(I  ,J  ,K))*
     +                        COS(DTOR*TLON(I  ,J  ,K))
                TBUF( 2,NBUF)=COS(DTOR*TLAT(I  ,J  ,K))*
     +                        SIN(DTOR*TLON(I  ,J  ,K))
                TBUF( 3,NBUF)=SIN(DTOR*TLAT(I  ,J  ,K))
                TBUF( 4,NBUF)=REAL((I-1)*JDIM*NLAT+(J-1)*NLAT+K-1)
C
                TBUF( 5,NBUF)=COS(DTOR*TLAT(I+1,J+1,K))*
     +                        COS(DTOR*TLON(I+1,J+1,K))
                TBUF( 6,NBUF)=COS(DTOR*TLAT(I+1,J+1,K))*
     +                        SIN(DTOR*TLON(I+1,J+1,K))
                TBUF( 7,NBUF)=SIN(DTOR*TLAT(I+1,J+1,K))
                TBUF( 8,NBUF)=REAL((I  )*JDIM*NLAT+(J  )*NLAT+K-1)
C
                TBUF( 9,NBUF)=COS(DTOR*TLAT(I  ,J+1,K))*
     +                        COS(DTOR*TLON(I  ,J+1,K))
                TBUF(10,NBUF)=COS(DTOR*TLAT(I  ,J+1,K))*
     +                        SIN(DTOR*TLON(I  ,J+1,K))
                TBUF(11,NBUF)=SIN(DTOR*TLAT(I  ,J+1,K))
                TBUF(12,NBUF)=REAL((I-1)*JDIM*NLAT+(J  )*NLAT+K-1)
C
              ELSE
C
                NBUF=NBUF+1
C
                TBUF( 1,NBUF)=COS(DTOR*TLAT(I  ,J  ,K))*
     +                        COS(DTOR*TLON(I  ,J  ,K))
                TBUF( 2,NBUF)=COS(DTOR*TLAT(I  ,J  ,K))*
     +                        SIN(DTOR*TLON(I  ,J  ,K))
                TBUF( 3,NBUF)=SIN(DTOR*TLAT(I  ,J  ,K))
                TBUF( 4,NBUF)=REAL((I-1)*JDIM*NLAT+(J-1)*NLAT+K-1)
C
                TBUF( 5,NBUF)=COS(DTOR*TLAT(I+1,J  ,K))*
     +                        COS(DTOR*TLON(I+1,J  ,K))
                TBUF( 6,NBUF)=COS(DTOR*TLAT(I+1,J  ,K))*
     +                        SIN(DTOR*TLON(I+1,J  ,K))
                TBUF( 7,NBUF)=SIN(DTOR*TLAT(I+1,J  ,K))
                TBUF( 8,NBUF)=REAL((I  )*JDIM*NLAT+(J-1)*NLAT+K-1)
C
                TBUF( 9,NBUF)=COS(DTOR*TLAT(I  ,J+1,K))*
     +                        COS(DTOR*TLON(I  ,J+1,K))
                TBUF(10,NBUF)=COS(DTOR*TLAT(I  ,J+1,K))*
     +                        SIN(DTOR*TLON(I  ,J+1,K))
                TBUF(11,NBUF)=SIN(DTOR*TLAT(I  ,J+1,K))
                TBUF(12,NBUF)=REAL((I-1)*JDIM*NLAT+(J  )*NLAT+K-1)
C
                NBUF=NBUF+1
C
                TBUF( 1,NBUF)=COS(DTOR*TLAT(I+1,J  ,K))*
     +                        COS(DTOR*TLON(I+1,J  ,K))
                TBUF( 2,NBUF)=COS(DTOR*TLAT(I+1,J  ,K))*
     +                        SIN(DTOR*TLON(I+1,J  ,K))
                TBUF( 3,NBUF)=SIN(DTOR*TLAT(I+1,J  ,K))
                TBUF( 4,NBUF)=REAL((I  )*JDIM*NLAT+(J-1)*NLAT+K-1)
C
                TBUF( 5,NBUF)=COS(DTOR*TLAT(I+1,J+1,K))*
     +                        COS(DTOR*TLON(I+1,J+1,K))
                TBUF( 6,NBUF)=COS(DTOR*TLAT(I+1,J+1,K))*
     +                        SIN(DTOR*TLON(I+1,J+1,K))
                TBUF( 7,NBUF)=SIN(DTOR*TLAT(I+1,J+1,K))
                TBUF( 8,NBUF)=REAL((I  )*JDIM*NLAT+(J  )*NLAT+K-1)
C
                TBUF( 9,NBUF)=COS(DTOR*TLAT(I  ,J+1,K))*
     +                        COS(DTOR*TLON(I  ,J+1,K))
                TBUF(10,NBUF)=COS(DTOR*TLAT(I  ,J+1,K))*
     +                        SIN(DTOR*TLON(I  ,J+1,K))
                TBUF(11,NBUF)=SIN(DTOR*TLAT(I  ,J+1,K))
                TBUF(12,NBUF)=REAL((I-1)*JDIM*NLAT+(J  )*NLAT+K-1)
C
              END IF
C
  105       CONTINUE
  106     CONTINUE
  107   CONTINUE
C
C Output all triangles remaining in the buffer.
C
        IF (NBUF.NE.0) THEN
          CALL CTTMTL (NBUF,TBUF,MBUF,NBUF,
     +                 IPPP,MPPP,NPPP,
     +                 IPPE,MPPE,NPPE,
     +                 RPNT,MPNT,NPNT,LOPN,
     +                 IEDG,MEDG,NEDG,LOEN,
     +                 ITRI,MTRI,NTRI,LOTN)
        END IF
C
C Set the pointers that tell the caller how many points and edges were
C created.
C
        NPNT=NPPP*LOPN
        NEDG=NPPE*LOEN
C
C Return the latitude and longitude of the approximate center point of
C the mesh on the globe.
C
        CLAT=0.
        CLON=0.
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE DSJE02 (TLAT,TLON,ELAT,ELON,IDIM,JDIM,NLAT)
C
        DIMENSION TLAT(IDIM,JDIM,NLAT),TLON(IDIM,JDIM,NLAT)
        DIMENSION ELAT(NLAT),ELON(NLAT)
C
C Draw the 150 simple rectangular grids that comprise the SEAM grid,
C using data passed as arguments.
C
C Declare a character temporary in which to form labels.
C
        CHARACTER*3 CTMP
C
C Draw the grid.
C
        CALL PLOTIT (0,0,2)
        CALL GSPLCI (8)
        CALL GSLWSC (2.)
C
        DO 105 K=1,NLAT
C
          DO 102 I=1,IDIM-1
            DO 101 J=1,JDIM-1
              CALL DRSGCR (TLAT(I  ,J  ,K),TLON(I  ,J  ,K),
     +                     TLAT(I  ,J+1,K),TLON(I  ,J+1,K))
  101       CONTINUE
  102     CONTINUE
C
          DO 104 J=1,JDIM-1
            DO 103 I=1,IDIM-1
              CALL DRSGCR (TLAT(I  ,J  ,K),TLON(I  ,J  ,K),
     +                     TLAT(I+1,J  ,K),TLON(I+1,J  ,K))
  103       CONTINUE
  104     CONTINUE
C
C Label each element with its index (from 1 to 150, inclusive).
C
          CALL MAPTRN (ELAT(K),ELON(K),XTMP,YTMP)
C
          IF (XTMP.NE.1.E12) THEN
            WRITE (CTMP,'(I3)') K
            IF (CTMP(1:1).EQ.' ') CTMP(1:1)='0'
            IF (CTMP(2:2).EQ.' ') CTMP(2:2)='0'
            CALL PCSETI ('CC',1)
            CALL PLCHHQ (XTMP,YTMP,CTMP,.015,0.,0.)
            CALL PCSETI ('CC',-1)
          END IF
C
  105   CONTINUE
C
C Draw the continental outlines and lat/lon grid.
C
        CALL PLOTIT (0,0,2)
        CALL GSLWSC (1.)
        CALL GSPLCI (13)
        CALL MAPGRD
        CALL PLOTIT (0,0,2)
        CALL GSPLCI (14)
        CALL MAPLOT
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE DRSGCR (ALAT,ALON,BLAT,BLON)
C
C (DRSGCR = DRaw Shortest Great Circle Route)
C
C This routine draws the shortest great circle route joining two points
C on the globe.
C
        PARAMETER (MPTS=181,SIZE=1.)  !  MPTS = INT(180./SIZE) + 1
C
        DIMENSION QLAT(MPTS),QLON(MPTS)
C
        NPTS=MAX(1,MIN(MPTS,INT(ADSGCR(ALAT,ALON,BLAT,BLON)/SIZE)))
C
        CALL MAPGCI (ALAT,ALON,BLAT,BLON,NPTS,QLAT,QLON)
C
        CALL MAPIT (ALAT,ALON,0)
C
        DO 101 I=1,NPTS
          CALL MAPIT (QLAT(I),QLON(I),1)
  101   CONTINUE
C
        CALL MAPIT (BLAT,BLON,1)
C
        CALL MAPIQ
C
        RETURN
C
      END


      FUNCTION ADSGCR (ALAT,ALON,BLAT,BLON)
C
C (ADSGCR = Angle in Degrees along Shortest Great Circle Route)
C
C This function returns the shortest great circle distance, in degrees,
C between two points, A and B, on the surface of the globe.
C
        DATA DTOR / .017453292519943 /
        DATA RTOD / 57.2957795130823 /
C
        XCOA=COS(DTOR*ALAT)*COS(DTOR*ALON)
        YCOA=COS(DTOR*ALAT)*SIN(DTOR*ALON)
        ZCOA=SIN(DTOR*ALAT)
C
        XCOB=COS(DTOR*BLAT)*COS(DTOR*BLON)
        YCOB=COS(DTOR*BLAT)*SIN(DTOR*BLON)
        ZCOB=SIN(DTOR*BLAT)
C
        ADSGCR=2.*RTOD*ASIN(SQRT((XCOA-XCOB)**2+
     +                           (YCOA-YCOB)**2+
     +                           (ZCOA-ZCOB)**2)/2.)
C
        RETURN
C
      END


      SUBROUTINE IPIQOS (ALAT,ALON,BLAT,BLON,CLAT,CLON,DLAT,DLON,
     +                                       XFRA,YFRA,ELAT,ELON)
C
C (IPIQOS = Interpolate Point In Quadrilateral on Sphere)
C
C This routine, given the latitudes and longitudes of four points (A, B,
C C, and D) forming a "quadrilateral" on the globe and two interpolation
C fractions (XFRA and YFRA, each between 0 and 1, inclusive), finds the
C point E defined by the following diagram and returns its latitude and
C longitude.
C
C                              C------Q----D
C                              |      |    |
C                              |      E    |
C                              |      |    |
C                              |      |    |
C                              A------P----B
C
C P and Q are positioned such that AP/AB = CQ/CD = XFRA and then E is
C positioned such that PE/PQ = YFRA (where "XY" is interpreted to mean
C "the shortest great circle distance from X to Y").
C
C It is assumed that the "quadrilateral" ABDC is "convex" (a working
C definition of which might be that none of the four great circles
C defined by its edges - the ones through A and B, B and D, D and C,
C and C and A - cross it anywhere.  However, this is not verified.
C
C The code is easy:
C
        CALL FPSGCR (ALAT,ALON,BLAT,BLON,XFRA,PLAT,PLON)
        CALL FPSGCR (CLAT,CLON,DLAT,DLON,XFRA,QLAT,QLON)
        CALL FPSGCR (PLAT,PLON,QLAT,QLON,YFRA,ELAT,ELON)
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE FPSGCR (ALAT,ALON,BLAT,BLON,FRCT,FLAT,FLON)
C
C (FPSGCR = Find Point on Shortest Great Circle Route)
C
        REAL    ALAT,ALON,BLAT,BLON,FRCT,FLAT,FLON
C
C This routine, given the latitudes and longitudes of two points A and
C B on the surface of the globe and a fraction FRCT, between 0. and 1.,
C interpolates a point F along the shortest great circle route joining
C A to B such that the distance from A to F, divided by the distance
C from A to B, is equal to FRCT, and returns its latitude and longitude
C in FLAT and FLON.
C
C Define the constants used to convert from degrees to radians and
C vice-versa.
C
        DATA DTOR / .017453292519943 /
        DATA RTOD / 57.2957795130823 /
C
C Compute the X, Y, and Z coordinates (on a unit sphere) of the point B.
C
        CALL LLPXYZ (BLAT,BLON,XCPB,YCPB,ZCPB)
C
C Rotating about the Z axis by the angle -ALON would carry A into the XZ
C plane.
C
        CALL ROTXYZ (3,-ALON,XCPB,YCPB,ZCPB)
C
C Then, rotating about the Y axis by the angle ALAT would carry A into
C the point on the X axis with coordinates (1,0,0).
C
        CALL ROTXYZ (2,ALAT,XCPB,YCPB,ZCPB)
C
C Then, rotating about the X axis by the angle ALPH = -ATAN(ZCPB/YCPB)
C would leave the position of A unchanged but carry B into a point in
C the XY plane.
C
        IF (ZCPB.NE.0..OR.YCPB.NE.0.) THEN
          ALPH=-RTOD*ATAN2(ZCPB,YCPB)
        ELSE
          ALPH=0.
        END IF
C
        CALL ROTXYZ (1,ALPH,XCPB,YCPB,ZCPB)
C
C The angle BETA from A to B can now be computed easily.
C
        IF (XCPB.NE.0..OR.YCPB.NE.0.) THEN
          BETA=ATAN2(YCPB,XCPB)
        ELSE
          BETA=0.
        END IF
C
C Interpolate a point at the desired position between the points A and
C B, map it back to its original position on the great circle route from
C A to B, and get its latitude and longitude to return to the caller.
C
        GAMA=FRCT*BETA
C
        XCPF=COS(GAMA)
        YCPF=SIN(GAMA)
        ZCPF=0.
C
        CALL ROTXYZ (1,-ALPH,XCPF,YCPF,ZCPF)
        CALL ROTXYZ (2,-ALAT,XCPF,YCPF,ZCPF)
        CALL ROTXYZ (3, ALON,XCPF,YCPF,ZCPF)
C
        CALL XYZLLP (XCPF,YCPF,ZCPF,FLAT,FLON)
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE LLPXYZ (RLAT,RLON,RVOX,RVOY,RVOZ)
C
C (LLPXYZ = Lat/Lon Position to XYZ coordinates)
C
C Given the latitude and longitude of a point on the globe, return its
C X, Y, and Z coordinates.
C
        DATA DTOR / .017453292519943 /
C
        RVOX=COS(DTOR*RLAT)*COS(DTOR*RLON)
        RVOY=COS(DTOR*RLAT)*SIN(DTOR*RLON)
        RVOZ=SIN(DTOR*RLAT)
C
        RETURN
C
      END


      SUBROUTINE XYZLLP (RVOX,RVOY,RVOZ,RLAT,RLON)
C
C (XYZLLP = XYZ coordinates to Lat/Lon Position)
C
C Given the X, Y, and Z coordinates of a point on the globe, return its
C latitude and longitude.
C
        DATA RTOD / 57.2957795130823 /
C
        RLAT=RTOD*ASIN(RVOZ)
C
        IF (RVOX.NE.0.OR.RVOY.NE.0.) THEN
          RLON=RTOD*ATAN2(RVOY,RVOX)
        ELSE
          RLON=0.
        END IF
C
        RETURN
C
      END


      SUBROUTINE ROTXYZ (IAXS,ANGL,XCRD,YCRD,ZCRD)
C
C (ROTXYZ = ROTate a point defined by its X, Y, and Z coordinates)
C
C This is a modified version of a routine in the NCAR Graphics package,
C which is used in some of the examples.  It rotates the point having
C coordinates (XCRD,YCRD,ZCRD) by an angle ANGL about the axis specified
C by IAXS (1 for the X axis, 2 for the Y axis, 3 for the Z axis).
C
C One assumes a right-handed system with X, Y, and Z axes.  Rotating by
C an angle "a" about the X axis maps the point (x,y,z) into the point
C (x',y',z'), where
C
C       x' = x
C       y' = y cos(a) - z sin(a)
C       z' = z cos(a) + y sin(a)
C
C A positive value of "a" represents rotation in the direction from the
C Y axis to the Z axis.
C
C Similarly, rotating by an angle "a" about the Y axis maps the point
C (x,y,z) into the point (x',y',z'), where
C
C       x' = x cos(a) + z sin(a)
C       y' = y
C       z' = z cos(a) - x sin(a)
C
C A positive value of "a" represents rotation in the direction from the
C Z axis to the X axis.
C
C Rotating by an angle "a" about the Z axis maps the point (x,y,z) into
C the point (x',y',z'), where
C
C       x' = x cos(a) - y sin(a)
C       y' = y cos(a) + x sin(a)
C       y' = y
C
C A positive value of "a" represents rotation in the direction from the
C X axis to the Y axis.
C
C Define a multiplicative constant to convert from degrees to radians.
C
        DATA DTOR / .017453292519943 /
C
C Trigonometry.
C
        SINA=SIN(DTOR*ANGL)
        COSA=COS(DTOR*ANGL)
C
        XTMP=XCRD
        YTMP=YCRD
        ZTMP=ZCRD
C
        IF (IAXS.EQ.1) THEN
          YCRD=YTMP*COSA-ZTMP*SINA
          ZCRD=ZTMP*COSA+YTMP*SINA
        ELSE IF (IAXS.EQ.2) THEN
          XCRD=XTMP*COSA+ZTMP*SINA
          ZCRD=ZTMP*COSA-XTMP*SINA
        ELSE
          XCRD=XTMP*COSA-YTMP*SINA
          YCRD=YTMP*COSA+XTMP*SINA
        END IF
C
        RETURN
C
      END


      SUBROUTINE ADDCHR (BUFF,NCIB,CHAR)
        CHARACTER*(*) BUFF
        CHARACTER*1 CHAR
        IF (NCIB.LT.LEN(BUFF)) THEN
          NCIB=NCIB+1
          BUFF(NCIB:NCIB)=CHAR
        END IF
        RETURN
      END


      SUBROUTINE ADDCHS (BUFF,NCIB,CHRS)
        CHARACTER*(*) BUFF,CHRS
        DO 101 I=IFNBCH(CHRS),ILNBCH(CHRS)
          CALL ADDCHR (BUFF,NCIB,CHRS(I:I))
  101   CONTINUE
        RETURN
      END


      SUBROUTINE ADDINT (BUFF,NCIB,IVAL)
        CHARACTER*(*) BUFF
        CHARACTER*12 CTMP
        WRITE (CTMP,'(I12)') IVAL
        CALL ADDCHS (BUFF,NCIB,CTMP)
        RETURN
      END


      FUNCTION IFNBCH(CHRS)
        CHARACTER*(*) CHRS
        DO 101 I=1,LEN(CHRS)
          IF (CHRS(I:I).NE.' ') THEN
            IFNBCH=I
            RETURN
          END IF
  101   CONTINUE
        IFNBCH=LEN(CHRS)+1
        RETURN
      END


      FUNCTION ILNBCH(CHRS)
        CHARACTER*(*) CHRS
        DO 101 I=LEN(CHRS),1,-1
          IF (CHRS(I:I).NE.' ') THEN
            ILNBCH=I
            RETURN
          END IF
  101   CONTINUE
        ILNBCH=0
        RETURN
      END


      SUBROUTINE TDGDIN (XMIN,XMAX,YMIN,YMAX,ZMIN,ZMAX,MLOW,MHGH)
C
C This is a routine to generate test data for three-dimensional graphics
C routines.  The function used is a sum of exponentials.
C
C "MLOW" and "MHGH" are each forced to be greater than or equal to 1 and
C less than or equal to 25.
C
        COMMON /TDGDCO/ XRNG,YRNG,ZRNG,NCNT,CCNT(4,50)
        SAVE   /TDGDCO/
C
        XRNG=XMAX-XMIN
        YRNG=YMAX-YMIN
        ZRNG=ZMAX-ZMIN
C
        NLOW=MAX0(1,MIN0(25,MLOW))
        NHGH=MAX0(1,MIN0(25,MHGH))
        NCNT=NLOW+NHGH
C
        DO 101 ICNT=1,NCNT
          CCNT(1,ICNT)=XMIN+XRNG*FRAN()
          CCNT(2,ICNT)=YMIN+YRNG*FRAN()
          CCNT(3,ICNT)=ZMIN+ZRNG*FRAN()
          IF (ICNT.LE.NLOW) THEN
            CCNT(4,ICNT)=-1.
          ELSE
            CCNT(4,ICNT)=+1.
          END IF
  101   CONTINUE
C
        RETURN
C
      END


      FUNCTION TDGDVA (XPOS,YPOS,ZPOS)
C
        COMMON /TDGDCO/ XRNG,YRNG,ZRNG,NCNT,CCNT(4,50)
        SAVE   /TDGDCO/
C
        TDGDVA=0.
C
        DO 101 ICNT=1,NCNT
          TEMP=-50.*(((XPOS-CCNT(1,ICNT))/XRNG)**2+
     +               ((YPOS-CCNT(2,ICNT))/YRNG)**2+
     +               ((ZPOS-CCNT(3,ICNT))/YRNG)**2)
          IF (TEMP.GE.-20.) TDGDVA=TDGDVA+CCNT(4,ICNT)*EXP(TEMP)
  101   CONTINUE
C
C Done.
C
        RETURN
C
      END


      FUNCTION FRAN ()
C
C Pseudo-random-number generator.
C
        DOUBLE PRECISION X
        SAVE X
C
        DATA X / 2.718281828459045 /
C
        X=MOD(9821.D0*X+.211327D0,1.D0)
        FRAN=REAL(X)
C
        RETURN
C
      END

c nclfortstart
      SUBROUTINE PALEOOUTLINE (MASK,ZDAT,LAT,LON,NLAT,NLON,JM,IM,
     +                         IWRK,LIWK,FLINES,FNAMES,MSKVAL)
C
        INTEGER NLAT,NLON
        INTEGER IM,JM,LIWK
        REAL LAT1,LATN,LON1,LONN
        DOUBLE PRECISION MASK(NLON,NLAT),LAT(NLAT),LON(NLON)
        REAL ZDAT(IM,JM),MSKVAL
        CHARACTER*(*) FLINES, FNAMES
        INTEGER IWRK(LIWK)
c nclend
        INTEGER I,J
C
C The object of this routine is to generate the map database files
C required by EZMAP to represent the land/water boundaries defined by
C a given "mask" array.  It does this using a routine called SVBLED
C (which was originally written for Pat Behling) and it makes use of
C this routine in a particular way; certain restrictions on the nature
C of the the input data are assumed.  (It could perhaps be modified to
C ease some of these restrictions, but that has not been done.)
C
C The arguments of PALEOOUTLINE are as follows:
C
C   MASK is an array, dimensioned NLONxNLAT, in which a value equal to
C   MSKVAL represents a land element and a value not equal to MSKVAL
C   represents a water element.
C
C   ZDAT is a scratch array, dimensioned IMxJM.
C
C   LAT is an array of latitudes, dimensioned NLAT, and LON is an array
C   of longitudes, dimensioned NLON.  The value of MASK(I,J) represents
C   the nature of the point on the earth with lat/lon coordinates
C   (LAT(J),LON(I)).  Note, however, that SVBLED assumes that both the
C   latitude values and the longitude values are evenly spaced.  Note
C   also that there should be no points of overlap in the longitudinal
C   direction.
C
C   JM is the second dimension of ZDAT and must be equal to 2*NLAT+1.
C
C   IM is the first dimension of ZDAT and must be equal to 2*NLON+1.
C
C   IWRK is an integer scratch array, dimensioned LIWK.
C
C   LIWK is the size of IWRK; its size depends on both the size and
C   the complexity of the array MASK.
C
C   FLINES and FNAMES are of type CHARACTER and are the names of the
C   files to be created. This code used to just have FLNM, which was
C   the base name used to form FLINES and FNAMES. This was causing
C   problems if the basename was really long, because FLINES and FNAMES
C   were originally hard-coded to only allow 128 characters. The C
C   wrapper that calls this function now allocates the space for
C   these two strings and sets them, so this code doesn't need to
C   do that any more.
C   
C   MSKVAL is the value that, when used in the array MASK, represents
C   land.
C
C Each dimension of SVBLED's input array "ZDAT" is required to have
C one more than twice as many elements as the corresponding dimension
C of the original mask array ("MASK").  The elements of MASK are
C embedded in ZDAT, using only even values of its subscripts.
C
        DO 102 I=1,IM
          DO 101 J=1,JM
            ZDAT(I,J)=1.-MSKVAL
  101     CONTINUE
  102   CONTINUE
C
        DO 104 I=1,NLON
          DO 103 J=1,NLAT
            ZDAT(2*I,2*J)=REAL(MASK(I,J))
  103     CONTINUE
  104   CONTINUE
C
C We have to tell SVBLED what the latitude is corresponding to values
C of the second subscript equal to 2 and 2*NLAT.  The latitudes for
C other values of the second subscript will be inferred from these by
C assuming a linear mapping.
C
        IBOT=2
        LAT1=REAL(LAT(1))
C
        ITOP=2*NLAT
        LATN=REAL(LAT(NLAT))
C
C Similarly, we have to tell SVBLED what longitudes correspond to
C values of the first subscript equal to 2 and 2*NLON.  The longitudes
C for other values of the first subscript will be inferred from these
C by assuming a linear mapping.
C
        ILFT=2
        LON1=REAL(LON(1))
C
        IRGT=2*NLON
        LONN=REAL(LON(NLON))
C
C Call SVBLED to finish the job.
C
        CALL SVBLED (ZDAT,IM,JM,IWRK,LIWK,MSKVAL,ILFT,LON1,IRGT,LONN,
     +               IBOT,LAT1,ITOP,LATN,'Land','Water',FLINES,FNAMES)
C
C Done.
C
      RETURN
C
      END


      SUBROUTINE SVBLED (ZDAT,IDIM,JDIM,IWRK,LIWK,SVAL,ILFT,XLFT,
     +                   IRGT,XRGT,JBOT,YBOT,JTOP,YTOP,NAML,NAMR,
     +                   FLINES,FNAMES)
C
C This routine is adapted from the CONPACK routine CPTRES, which traces
C the edge of the special-value area in a contour field.  (The mnemonic
C SVBLED stands for "Special Value Boundary Line to Ezmap Dataset".)
C The boundary of the special-value area is generated in such a way
C that special values are to the left and non-special values are to the
C right.  SVBLED has the following arguments: ZDAT is an array of data,
C dimensioned IDIM by JDIM.  IWRK is an integer scratch array of length
C LIWK.  SVAL is the "special value".  The "special value" area of the
C data array is considered to be the union of all grid boxes having a
C special value at one or more of their corners.  XLFT is the longitude
C associated with a first subscript of ILFT and XRGT the longitude
C associated with a first subscript of IRGT.  YBOT is the latitude
C associated with a second subscript of JBOT and YTOP the latitude
C associated with a second subscript of JTOP.  NAML and NAMR are the
C names of the areas to the left and right, respectively, of the
C boundary lines.  FLINES and FNAMES are the names of the two files to
C which the EZMAP data are to be written.
C
C Declare argument dimensions and sizes.
C
        DIMENSION ZDAT(IDIM,JDIM),IWRK(LIWK)
C
        CHARACTER*(*) NAML,NAMR,FLINES,FNAMES
C
C Declare local variables used in the tracing algorithm.
C
        DIMENSION INCX(8),JNCY(8)
C
C Declare arrays from which the data are to be written to the line
C data file.
C
        DIMENSION INTS(4),FLTS(204)
C
C Declare an array to use as an output buffer to the name data file.
C
        CHARACTER*1 CHRS(1024)
C
C Define vectors pointing in eight different directions for use in the
C tracing algorithm.
C
        DATA INCX / -1 , -1 ,  0 ,  1 ,  1 ,  1 ,  0 , -1 /
        DATA JNCY /  0 ,  1 ,  1 ,  1 ,  0 , -1 , -1 , -1 /
C
C Open the file to which the line data will be written.
C
        CALL NGOFWO (FLINES,IFDE,ISTA)
C
        IF (ISTA.NE.0) THEN
          PRINT * , 'SVBLED - FAILED TO OPEN LINE DATA FILE'
          STOP
        END IF
C
        INTS(1)=0
        INTS(2)=1
        INTS(3)=1
        INTS(4)=2
C
        NHSS=0
C
        DO 107 I=1,IDIM-1
          DO 106 J=1,JDIM-1
            IF (J.EQ.1) THEN
              IF (ZDAT(I  ,1  ).EQ.SVAL.OR.
     +            ZDAT(I+1,1  ).EQ.SVAL.OR.
     +            ZDAT(I  ,2  ).EQ.SVAL.OR.
     +            ZDAT(I+1,2  ).EQ.SVAL) GO TO 101
            ELSE
              IF (ZDAT(I  ,J-1).NE.SVAL.AND.
     +            ZDAT(I+1,J-1).NE.SVAL.AND.
     +            ZDAT(I  ,J  ).NE.SVAL.AND.
     +            ZDAT(I+1,J  ).NE.SVAL.AND.
     +           (ZDAT(I  ,J+1).EQ.SVAL.OR.
     +            ZDAT(I+1,J+1).EQ.SVAL)) GO TO 101
            END IF
            GO TO 106
  101       IPXY=JDIM*I+J
            DO 102 K=1,NHSS
              IF (IPXY.EQ.IWRK(K)) GO TO 106
  102       CONTINUE
            IF (NHSS.GE.LIWK) THEN
              PRINT * , 'SVBLED - INTEGER WORKSPACE OVERFLOW'
              STOP
            END IF
            NHSS=NHSS+1
            IWRK(NHSS)=IPXY
            INTS(1)=0
            XCES=XLFT+(REAL(I-ILFT)/REAL(IRGT-ILFT))*(XRGT-XLFT)
            YCES=YBOT+(REAL(J-JBOT)/REAL(JTOP-JBOT))*(YTOP-YBOT)
            INSX=I
            JNSY=J
            INOX=I
            JNOY=J
            INDX=I+1
            JNDY=J
            IDIR=5
  103       XCSS=XCES
            YCSS=YCES
            XCES=XLFT+(REAL(INDX-ILFT)/REAL(IRGT-ILFT))*(XRGT-XLFT)
            YCES=YBOT+(REAL(JNDY-JBOT)/REAL(JTOP-JBOT))*(YTOP-YBOT)
            IDRW=1
            IF (INDX.EQ.INOX) THEN
              IF ((REAL(IDIM-1)/REAL(IRGT-ILFT))*(XRGT-XLFT).GT.359.99)
     +                                                              THEN
                IF (INDX.EQ.1) THEN
                  IF (ZDAT(IDIM  ,JNDY).EQ.SVAL.OR.
     +                ZDAT(IDIM-1,JNDY).EQ.SVAL.OR.
     +                ZDAT(IDIM  ,JNOY).EQ.SVAL.OR.
     +                ZDAT(IDIM-1,JNOY).EQ.SVAL) IDRW=0
                ELSE IF (INDX.EQ.IDIM) THEN
                  IF (ZDAT(1,JNDY).EQ.SVAL.OR.
     +                ZDAT(2,JNDY).EQ.SVAL.OR.
     +                ZDAT(1,JNOY).EQ.SVAL.OR.
     +                ZDAT(2,JNOY).EQ.SVAL) IDRW=0
                END IF
              END IF
            ELSE IF (JNDY.EQ.JNOY.AND.ABS(ABS(YCES)-90.).LT..01) THEN
              IDRW=0
            END IF
            IF (IDRW.EQ.0) THEN
              IF (INTS(1).NE.0) THEN
                CALL WTEMLR (IFDE,INTS,FLTS)
                INTS(1)=0
              END IF
            ELSE
              IF (INTS(1).EQ.0) THEN
                INTS(1)=2
                FLTS(5)=YCSS
                FLTS(6)=XCSS
              END IF
              IF (INTS(1).EQ.200) CALL WTEMLR (IFDE,INTS,FLTS)
              INTS(1)=INTS(1)+2
              FLTS(3+INTS(1))=YCES
              FLTS(4+INTS(1))=XCES
            END IF
            IF (INDX.EQ.INSX.AND.JNDY.EQ.JNSY) THEN
              IF (INTS(1).NE.0) THEN
                CALL WTEMLR (IFDE,INTS,FLTS)
                INTS(1)=0
              END IF
              GO TO 106
            END IF
            INOX=INDX
            JNOY=JNDY
            IDIR=MOD(IDIR+1,8)+1
            DO 104 K=1,3
              IF (IDIR.EQ.5) THEN
                IF (INOX.NE.IDIM.AND.JNOY.NE.JDIM) THEN
                  IF (JNOY.EQ.1) THEN
                    IF (ZDAT(INOX  ,JNOY  ).EQ.SVAL.OR.
     +                  ZDAT(INOX+1,JNOY  ).EQ.SVAL.OR.
     +                  ZDAT(INOX  ,JNOY+1).EQ.SVAL.OR.
     +                  ZDAT(INOX+1,JNOY+1).EQ.SVAL) GO TO 105
                  ELSE
                    IF (ZDAT(INOX  ,JNOY-1).NE.SVAL.AND.
     +                  ZDAT(INOX+1,JNOY-1).NE.SVAL.AND.
     +                  ZDAT(INOX  ,JNOY  ).NE.SVAL.AND.
     +                  ZDAT(INOX+1,JNOY  ).NE.SVAL.AND.
     +                 (ZDAT(INOX  ,JNOY+1).EQ.SVAL.OR.
     +                  ZDAT(INOX+1,JNOY+1).EQ.SVAL)) GO TO 105
                  END IF
                END IF
              ELSE IF (IDIR.EQ.3) THEN
                IF (INOX.NE.1.AND.JNOY.NE.JDIM) THEN
                  IF (INOX.EQ.IDIM) THEN
                    IF (ZDAT(INOX  ,JNOY  ).EQ.SVAL.OR.
     +                  ZDAT(INOX  ,JNOY+1).EQ.SVAL.OR.
     +                  ZDAT(INOX-1,JNOY  ).EQ.SVAL.OR.
     +                  ZDAT(INOX-1,JNOY+1).EQ.SVAL) GO TO 105
                  ELSE
                    IF (ZDAT(INOX+1,JNOY  ).NE.SVAL.AND.
     +                  ZDAT(INOX+1,JNOY+1).NE.SVAL.AND.
     +                  ZDAT(INOX  ,JNOY  ).NE.SVAL.AND.
     +                  ZDAT(INOX  ,JNOY+1).NE.SVAL.AND.
     +                 (ZDAT(INOX-1,JNOY  ).EQ.SVAL.OR.
     +                  ZDAT(INOX-1,JNOY+1).EQ.SVAL)) GO TO 105
                  END IF
                END IF
              ELSE IF (IDIR.EQ.1) THEN
                IF (INOX.NE.1.AND.JNOY.NE.1) THEN
                  IF (JNOY.EQ.JDIM) THEN
                    IF (ZDAT(INOX  ,JNOY  ).EQ.SVAL.OR.
     +                  ZDAT(INOX-1,JNOY  ).EQ.SVAL.OR.
     +                  ZDAT(INOX  ,JNOY-1).EQ.SVAL.OR.
     +                  ZDAT(INOX-1,JNOY-1).EQ.SVAL) GO TO 105
                  ELSE
                    IF (ZDAT(INOX  ,JNOY+1).NE.SVAL.AND.
     +                  ZDAT(INOX-1,JNOY+1).NE.SVAL.AND.
     +                  ZDAT(INOX  ,JNOY  ).NE.SVAL.AND.
     +                  ZDAT(INOX-1,JNOY  ).NE.SVAL.AND.
     +                 (ZDAT(INOX  ,JNOY-1).EQ.SVAL.OR.
     +                  ZDAT(INOX-1,JNOY-1).EQ.SVAL)) GO TO 105
                  END IF
                END IF
              ELSE
                IF (INOX.NE.IDIM.AND.JNOY.NE.1) THEN
                  IF (INOX.EQ.1) THEN
                    IF (ZDAT(INOX  ,JNOY  ).EQ.SVAL.OR.
     +                  ZDAT(INOX  ,JNOY-1).EQ.SVAL.OR.
     +                  ZDAT(INOX+1,JNOY  ).EQ.SVAL.OR.
     +                  ZDAT(INOX+1,JNOY-1).EQ.SVAL) GO TO 105
                  ELSE
                    IF (ZDAT(INOX-1,JNOY  ).NE.SVAL.AND.
     +                  ZDAT(INOX-1,JNOY-1).NE.SVAL.AND.
     +                  ZDAT(INOX  ,JNOY  ).NE.SVAL.AND.
     +                  ZDAT(INOX  ,JNOY-1).NE.SVAL.AND.
     +                 (ZDAT(INOX+1,JNOY  ).EQ.SVAL.OR.
     +                  ZDAT(INOX+1,JNOY-1).EQ.SVAL)) GO TO 105
                  END IF
                END IF
              END IF
              IDIR=MOD(IDIR+5,8)+1
  104       CONTINUE
            PRINT * , 'SVBLED - EDGE-FOLLOWING ALGORITHM FAILURE'
            STOP
  105       INDX=INOX+INCX(IDIR)
            JNDY=JNOY+JNCY(IDIR)
            IF (IDIR.EQ.5) THEN
              IF (NHSS.GE.LIWK) THEN
                PRINT * , 'SVBLED - INTEGER WORKSPACE OVERFLOW'
                STOP
              END IF
              NHSS=NHSS+1
              IWRK(NHSS)=JDIM*INOX+JNOY
            END IF
            GO TO 103
  106     CONTINUE
  107   CONTINUE
C
C Write a final logical record to the line data file.
C
        INTS(1)=0
        INTS(2)=0
        INTS(3)=0
        INTS(4)=0
C
        CALL WTEMLR (IFDE,INTS,FLTS)
C
C Close the line data file.
C
        CALL NGCLFI (IFDE)
C
C Open the name data file, write the required items to it, and close it.
C
C        CALL NGOFWO (FNAMES(1:LFNM+7),IFDE,ISTA)
        CALL NGOFWO (FNAMES,IFDE,ISTA)
C
        IF (ISTA.NE.0) THEN
          PRINT * , 'SVBLED - FAILED TO OPEN NAME DATA FILE'
          STOP
        END IF
C
        NCHR=0
C
        CALL WRCHAR (IFDE,CHRS,1024,NCHR, ' ')
        CALL WRNUMB (IFDE,CHRS,1024,NCHR,   1)  !  index of 1st area
        CALL WRCHAR (IFDE,CHRS,1024,NCHR, ' ')
        CALL WRNUMB (IFDE,CHRS,1024,NCHR,   1)  !  type of 1st area
        CALL WRCHAR (IFDE,CHRS,1024,NCHR, ' ')
        CALL WRNUMB (IFDE,CHRS,1024,NCHR,   2)  !  color of 1st area
        CALL WRCHAR (IFDE,CHRS,1024,NCHR, ' ')
        CALL WRNUMB (IFDE,CHRS,1024,NCHR,   0)  !  parent of 1st area
        CALL WRCHAR (IFDE,CHRS,1024,NCHR, ' ')
        IBEG=IOFNBC(NAML)
        IEND=IOLNBC(NAML)
        CALL WRNUMB (IFDE,CHRS,1024,NCHR,IEND-IBEG+1)  !  name length
        CALL WRCHAR (IFDE,CHRS,1024,NCHR,        ' ')
        DO 108 I=IBEG,IEND
          CALL WRCHAR (IFDE,CHRS,1024,NCHR,NAML(I:I))  !  name of area
  108   CONTINUE
        CALL WRCHAR (IFDE,CHRS,1024,NCHR, ' ')
        CALL WRNUMB (IFDE,CHRS,1024,NCHR,   2)  !  index of 2nd area
        CALL WRCHAR (IFDE,CHRS,1024,NCHR, ' ')
        CALL WRNUMB (IFDE,CHRS,1024,NCHR,   1)  !  type of 2nd area
        CALL WRCHAR (IFDE,CHRS,1024,NCHR, ' ')
        CALL WRNUMB (IFDE,CHRS,1024,NCHR,   1)  !  color of 2nd area
        CALL WRCHAR (IFDE,CHRS,1024,NCHR, ' ')
        CALL WRNUMB (IFDE,CHRS,1024,NCHR,   0)  !  parent of 2nd area
        CALL WRCHAR (IFDE,CHRS,1024,NCHR, ' ')
        IBEG=IOFNBC(NAMR)
        IEND=IOLNBC(NAMR)
        CALL WRNUMB (IFDE,CHRS,1024,NCHR,IEND-IBEG+1)  !  name length
        CALL WRCHAR (IFDE,CHRS,1024,NCHR,        ' ')
        DO 109 I=IBEG,IEND
          CALL WRCHAR (IFDE,CHRS,1024,NCHR,NAMR(I:I))  !  name of area
  109   CONTINUE
C
        IF (NCHR.GT.0) THEN
          CALL NGWRCH (IFDE,CHRS,NCHR,ISTA)
          IF (ISTA.LE.0) THEN
            PRINT * , 'SVBLED - ERROR WRITING CHARS TO NAME DATA FILE'
            STOP
          END IF
        END IF
C
        CALL NGCLFI (IFDE)
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE WTEMLR (IFDE,INTS,FLTS)
C
C Write a logical record to the EZMAP line data file.
C
        DIMENSION INTS(4),FLTS(204)
C
        CALL NGWRIN (IFDE,INTS,4,ISTA)
C
        IF (ISTA.NE.4) THEN
          PRINT * , 'WTEMLR - ERROR WRITING INTEGERS TO LINE DATA FILE'
          STOP
        END IF
C
        IF (INTS(1).NE.0) THEN
C
          FLTS(1)=FLTS(5)
          FLTS(2)=FLTS(5)
          FLTS(3)=FLTS(6)
          FLTS(4)=FLTS(6)
C
          DO 101 I=7,3+INTS(1),2
            FLTS(1)=MAX(FLTS(1),FLTS(I  ))
            FLTS(2)=MIN(FLTS(2),FLTS(I  ))
            FLTS(3)=MAX(FLTS(3),FLTS(I+1))
            FLTS(4)=MIN(FLTS(4),FLTS(I+1))
  101     CONTINUE
C
          CALL NGWRFL (IFDE,FLTS,4+INTS(1),ISTA)
C
          IF (ISTA.NE.4+INTS(1)) THEN
            PRINT * , 'WTEMLR - ERROR WRITING REALS TO LINE DATA FILE'
            STOP
          END IF
C
          FLTS(5)=FLTS(3+INTS(1))
          FLTS(6)=FLTS(4+INTS(1))
C
          INTS(1)=2
C
        END IF
C
        RETURN
C
      END


      SUBROUTINE WRNUMB (IFDE,CHRS,MCHR,NCHR,INUM)
C
        CHARACTER*1 CHRS(MCHR)
C
C Translate the integer INUM to a character form and put it in the
C buffer CHRS.
C
        CHARACTER*1 CTMP(20)
C
C Copy the integer to a local variable.
C
        ITMP=INUM
C
C Generate digits from right to left in the temporary buffer CTMP.
C
        NDGT=0
C
  101   NDGT=NDGT+1
C
        IF (NDGT.GT.20) THEN
          PRINT * , 'WRNUMB - INTEGER TOO BIG - STOP'
          STOP
        END IF
C
        CTMP(NDGT)=CHAR(ICHAR('0')+MOD(ITMP,10))
C
        ITMP=ITMP/10
        IF (ITMP.NE.0) GO TO 101
C
C Send the digits to the output buffer in correct order.
C
        DO 102 IDGT=NDGT,1,-1
          CALL WRCHAR (IFDE,CHRS,MCHR,NCHR,CTMP(IDGT))
  102   CONTINUE
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE WRCHAR (IFDE,CHRS,MCHR,NCHR,ICHR)
C
        CHARACTER*1 CHRS(MCHR),ICHR
C
C Put the character ICHR in the buffer CHRS.
C
        NCHR=NCHR+1
        CHRS(NCHR)=ICHR
C
C If the buffer is now full, dump it to the file specified by IFDE.
C
        IF (NCHR.GE.MCHR) THEN
          CALL NGWRCH (IFDE,CHRS,NCHR,ISTA)
          IF (ISTA.LE.0) THEN
            PRINT * , 'WRCHAR - BAD STATUS FROM NGWRCH = ',ISTA
            STOP
          END IF
          NCHR=0
        END IF
C
C Done.
C
        RETURN
C
      END


      INTEGER FUNCTION IOFNBC (CHRS)
C
        CHARACTER*(*) CHRS
C
C The value of IOFNBC(CHRS) is the index of the first non-blank in the
C character string CHRS.
C
        DO 101 I=1,LEN(CHRS)
          IF (CHRS(I:I).NE.' ') THEN
            IOFNBC=I
            RETURN
          END IF
  101   CONTINUE
C
        IOFNBC=1
C
        RETURN
C
      END


      INTEGER FUNCTION IOLNBC (CHRS)
C
        CHARACTER*(*) CHRS
C
C The value of IOLNBC(CHRS) is the index of the last non-blank in the
C character string CHRS.
C
        DO 101 I=LEN(CHRS),1,-1
          IF (CHRS(I:I).NE.' ') THEN
            IOLNBC=I
            RETURN
          END IF
  101   CONTINUE
C
        IOLNBC=1
C
        RETURN
C
      END

C
C $Id: mdlnri.f,v 1.4 2008-07-27 00:17:07 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MDLNRI (FLNM)
C
        CHARACTER*(*) FLNM
C
        PARAMETER (MNAI=8000)
C
C This routine, given the name, FLNM, of a file of map data in the new
C (as of 4/98) format, reads the ".names" file and stores information
C from it in common blocks MAPCMX and MAPCMY.
C
C The following COMMON blocks are used to share information with various
C other routines in EZMAPB.
C
        COMMON /MAPCMX/  IATY(MNAI),ISCI(MNAI),IPAR(MNAI)
        INTEGER          IATY,ISCI,IPAR
        SAVE   /MAPCMX/
C
        COMMON /MAPCMY/  NAME(MNAI),FLNS
        CHARACTER*64     NAME
        CHARACTER*512    FLNS
        SAVE   /MAPCMY/
C
C FLNL and FLND are character variables in which to form the names of
C files to be read (locally or in the NCAR Graphics database directory).
C
        CHARACTER*519    FLNL
        CHARACTER*1024   FLND
C
C CHRS is a buffer used to read name information.
C
        CHARACTER*1      CHRS(512)
C
C Declare other local variables.
C
        INTEGER          I,IAID,IFDE,ISTA,LFND,LFNL,LFNM,LONM,MCHR,NCHR
C
C Check for an uncleared prior error.
C
        IF (ICFELL('MDLNRI - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C Form the full names of the ".names" file (locally and in the NCAR
C Graphics database directory).
C
        LFNM=MDILNB(FLNM)
        IF (LFNM.GT.512) GO TO 901
C
        FLNL=FLNM(1:LFNM)//'.names'//CHAR(0)
        LFNL=LFNM+7
C
        CALL MPDBDI (FLND,ISTA)
        IF (ISTA.EQ.-1) GO TO 901
        DO 101 I=1,LEN(FLND)-7-LFNM
          IF (FLND(I:I).EQ.CHAR(0)) THEN
            FLND(I:LEN(FLND))='/'//FLNM(1:LFNM)//'.names'//CHAR(0)
            LFND=I+LFNM+7
            GO TO 102
          ENDIF
  101   CONTINUE
        GO TO 901
C
C Open the ".names" file.  Look for a local version first; if that one
C can't be found, look for one in the NCAR Graphics database directory.
C
  102   CALL NGOFRO (FLNL(1:LFNL),IFDE,ISTA)
        IF (ISTA.NE.0) THEN
          CALL NGOFRO (FLND(1:LFND),IFDE,ISTA)
          IF (ISTA.NE.0) GO TO 902
        END IF
C
C Clear the arrays into which the name information is to be read.
C
        DO 103 I=1,MNAI
          IATY(I)=0
          ISCI(I)=0
          IPAR(I)=0
          NAME(I)=' '
  103   CONTINUE
C
C Read and process all the name information.
C
        MCHR=0
        NCHR=0
C
  104   CALL MDRDNM (IFDE,CHRS,512,MCHR,NCHR,IAID)
        IF (MCHR.EQ.0) GO TO 105
        IF (IAID.LT.1.OR.IAID.GT.MNAI) GO TO 903
        CALL MDRDNM (IFDE,CHRS,512,MCHR,NCHR,IATY(IAID))
        IF (MCHR.EQ.0) GO TO 904
        CALL MDRDNM (IFDE,CHRS,512,MCHR,NCHR,ISCI(IAID))
        IF (MCHR.EQ.0) GO TO 904
        CALL MDRDNM (IFDE,CHRS,512,MCHR,NCHR,IPAR(IAID))
        IF (MCHR.EQ.0) GO TO 904
        CALL MDRDNM (IFDE,CHRS,512,MCHR,NCHR,LONM)
        IF (MCHR.EQ.0) GO TO 904
        NAME(IAID)=' '
        CALL MDRDCS (IFDE,CHRS,512,MCHR,NCHR,NAME(IAID)(1:LONM))
        IF (MCHR.EQ.0) GO TO 904
        GO TO 104
C
  105   CALL NGCLFI (IFDE)
C
C Save the file name, so that other routines that read the info will
C know it's unnecessary.
C
        FLNS=FLNM
C
C Done.
C
        RETURN
C
C Error exits.
C
  901   CALL SETER ('MDLNRI - Can''t form name of ".names" file',2,1)
        RETURN
C
  902   CALL SETER ('MDLNRI - Can''t open the ".names" file',3,1)
        RETURN
C
  903   CALL SETER ('MDLNRI - Read bad index from ".names" file',4,1)
        CALL NGCLFI (IFDE)
        RETURN
C
  904   CALL SETER ('MDLNRI - Read error on ".names" file',5,1)
        CALL NGCLFI (IFDE)
        RETURN
C
      END

C
C	$Id: gmarat.f,v 1.5 2008-07-27 00:20:58 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
        SUBROUTINE GMARAT(IOS,STATUS)
C
C  Set the marker attributes.
C
C  Valid attributes:
C    POLYMARKER INDEX
C    MARKER TYPE
C    MARKER SIZE 
C    MARKER COLOR
C
      include 'trinst.h'
      include 'trstat.h'
      include 'trpars.h'
      include 'trcode.h'
      include 'gkscom.h'
C
      INTEGER IOS, STATUS
C
      IF (OPID .EQ. ATELMB) THEN
C
C  POLYMARKER BUNDLE INDEX
C
        CALL GOPDEC(MARIDX,MIXCPR,1,IOS,STATUS)
        CALL GSPMI(MARIDX)
      ELSE IF (OPID .EQ. ATELMT) THEN
C
C  MARKER TYPE
C
        CALL GOPDEC(MARTYP,MIXCPR,1,IOS,STATUS)
        CALL GSMK(MARTYP)
      ELSE IF (OPID .EQ. ATELMZ) THEN
C
C  MARKER SIZE
C
        CALL GTFLT(MARSIZ,MFLCPR,IOS,STATUS)
C
C  Scale the marker size by the current transformation matrix.
C  Take a vector (0,MARSIZ), transform it with the
C  current transformation matrix, then find the length of the
C  transformed vector.
C
        YSCALE = SQRT(CURTM(1,2)*CURTM(1,2)+CURTM(2,2)*CURTM(2,2))
        HS = MARSIZ*YSCALE
        IF (HS .LT. 0.00004) HS = 0.00004
        CALL GSMKSC(HS)
      ELSE IF (OPID .EQ. ATELMC) THEN
C
C  Set the marker color
C
        CALL GOPDEC(MARCOL,MCICPR,1,IOS,STATUS)
        CALL GSPMCI(MARCOL)
      ENDIF
C
      RETURN
      END

      SUBROUTINE SDISNA( JOB, M, N, D, SEP, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER          JOB
      INTEGER            INFO, M, N
*     ..
*     .. Array Arguments ..
      REAL               D( * ), SEP( * )
*     ..
*
*  Purpose
*  =======
*
*  SDISNA computes the reciprocal condition numbers for the eigenvectors
*  of a real symmetric or complex Hermitian matrix or for the left or
*  right singular vectors of a general m-by-n matrix. The reciprocal
*  condition number is the 'gap' between the corresponding eigenvalue or
*  singular value and the nearest other one.
*
*  The bound on the error, measured by angle in radians, in the I-th
*  computed vector is given by
*
*         SLAMCH( 'E' ) * ( ANORM / SEP( I ) )
*
*  where ANORM = 2-norm(A) = max( abs( D(j) ) ).  SEP(I) is not allowed
*  to be smaller than SLAMCH( 'E' )*ANORM in order to limit the size of
*  the error bound.
*
*  SDISNA may also be used to compute error bounds for eigenvectors of
*  the generalized symmetric definite eigenproblem.
*
*  Arguments
*  =========
*
*  JOB     (input) CHARACTER*1
*          Specifies for which problem the reciprocal condition numbers
*          should be computed:
*          = 'E':  the eigenvectors of a symmetric/Hermitian matrix;
*          = 'L':  the left singular vectors of a general matrix;
*          = 'R':  the right singular vectors of a general matrix.
*
*  M       (input) INTEGER
*          The number of rows of the matrix. M >= 0.
*
*  N       (input) INTEGER
*          If JOB = 'L' or 'R', the number of columns of the matrix,
*          in which case N >= 0. Ignored if JOB = 'E'.
*
*  D       (input) REAL array, dimension (M) if JOB = 'E'
*                              dimension (min(M,N)) if JOB = 'L' or 'R'
*          The eigenvalues (if JOB = 'E') or singular values (if JOB =
*          'L' or 'R') of the matrix, in either increasing or decreasing
*          order. If singular values, they must be non-negative.
*
*  SEP     (output) REAL array, dimension (M) if JOB = 'E'
*                               dimension (min(M,N)) if JOB = 'L' or 'R'
*          The reciprocal condition numbers of the vectors.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit.
*          < 0:  if INFO = -i, the i-th argument had an illegal value.
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ZERO
      PARAMETER          ( ZERO = 0.0E+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            DECR, EIGEN, INCR, LEFT, RIGHT, SING
      INTEGER            I, K
      REAL               ANORM, EPS, NEWGAP, OLDGAP, SAFMIN, THRESH
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      REAL               SLAMCH
      EXTERNAL           LSAME, SLAMCH
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, MAX, MIN
*     ..
*     .. External Subroutines ..
      EXTERNAL           XERBLA
*     ..
*     .. Executable Statements ..
*
*     Test the input arguments
*
      INFO = 0
      EIGEN = LSAME( JOB, 'E' )
      LEFT = LSAME( JOB, 'L' )
      RIGHT = LSAME( JOB, 'R' )
      SING = LEFT .OR. RIGHT
      IF( EIGEN ) THEN
         K = M
      ELSE IF( SING ) THEN
         K = MIN( M, N )
      END IF
      IF( .NOT.EIGEN .AND. .NOT.SING ) THEN
         INFO = -1
      ELSE IF( M.LT.0 ) THEN
         INFO = -2
      ELSE IF( K.LT.0 ) THEN
         INFO = -3
      ELSE
         INCR = .TRUE.
         DECR = .TRUE.
         DO 10 I = 1, K - 1
            IF( INCR )
     $         INCR = INCR .AND. D( I ).LE.D( I+1 )
            IF( DECR )
     $         DECR = DECR .AND. D( I ).GE.D( I+1 )
   10    CONTINUE
         IF( SING .AND. K.GT.0 ) THEN
            IF( INCR )
     $         INCR = INCR .AND. ZERO.LE.D( 1 )
            IF( DECR )
     $         DECR = DECR .AND. D( K ).GE.ZERO
         END IF
         IF( .NOT.( INCR .OR. DECR ) )
     $      INFO = -4
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'SDISNA', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( K.EQ.0 )
     $   RETURN
*
*     Compute reciprocal condition numbers
*
      IF( K.EQ.1 ) THEN
         SEP( 1 ) = SLAMCH( 'O' )
      ELSE
         OLDGAP = ABS( D( 2 )-D( 1 ) )
         SEP( 1 ) = OLDGAP
         DO 20 I = 2, K - 1
            NEWGAP = ABS( D( I+1 )-D( I ) )
            SEP( I ) = MIN( OLDGAP, NEWGAP )
            OLDGAP = NEWGAP
   20    CONTINUE
         SEP( K ) = OLDGAP
      END IF
      IF( SING ) THEN
         IF( ( LEFT .AND. M.GT.N ) .OR. ( RIGHT .AND. M.LT.N ) ) THEN
            IF( INCR )
     $         SEP( 1 ) = MIN( SEP( 1 ), D( 1 ) )
            IF( DECR )
     $         SEP( K ) = MIN( SEP( K ), D( K ) )
         END IF
      END IF
*
*     Ensure that reciprocal condition numbers are not less than
*     threshold, in order to limit the size of the error bound
*
      EPS = SLAMCH( 'E' )
      SAFMIN = SLAMCH( 'S' )
      ANORM = MAX( ABS( D( 1 ) ), ABS( D( K ) ) )
      IF( ANORM.EQ.ZERO ) THEN
         THRESH = EPS
      ELSE
         THRESH = MAX( EPS*ANORM, SAFMIN )
      END IF
      DO 30 I = 1, K
         SEP( I ) = MAX( SEP( I ), THRESH )
   30 CONTINUE
*
      RETURN
*
*     End of SDISNA
*
      END

C*PL*ERROR* Comment line too long
c -----------------------------------------------------------------------
      DOUBLE PRECISION FUNCTION DPSLHY1(PRES,Z,TV,XMSG)
      IMPLICIT NONE

c Compute sea level pressure (Pa) via the hypsometric eqn

c NCL: slp = pslhy1 (pres,z,tv)

c input

c pressure on lowest vertical level (Pa)
      DOUBLE PRECISION PRES
c Geopotential hgt of lowest vertical level (m)
      DOUBLE PRECISION Z
c virtual temperature (K)
      DOUBLE PRECISION TV
c missing value
      DOUBLE PRECISION XMSG

c output

c sea level pressure (Pa)
c     real pslhy1

c local

c gravity (m/s2)
      DOUBLE PRECISION G
c gas const dry air (j/{kg-k})
      DOUBLE PRECISION RDAIR
      DATA G/9.80665D0/
      DATA RDAIR/287.04D0/

c pres_msg, zmsg, tvmsg
      IF (PRES.NE.XMSG .AND. Z.NE.XMSG .AND. TV.NE.XMSG) THEN
          DPSLHY1 = PRES*EXP(G*Z/ (RDAIR*TV))
      ELSE
c pres_msg
          DPSLHY1 = XMSG
      END IF

      RETURN
      END
C*PL*ERROR* Comment line too long
c -----------------------------------------------------------------------
      DOUBLE PRECISION FUNCTION DPSLHY2(PRES,Z,T,W,XMSG)
      IMPLICIT NONE

c Compute sea level pressure (Pa) via the hypsometric eqn

c NCL: slp = pslhy2 (pres,z,t,w)

c input

c pressure on lowest vertical level (Pa)
      DOUBLE PRECISION PRES
c Geopotential hgt of lowest vertical level (m)
      DOUBLE PRECISION Z
c temperature (K)
      DOUBLE PRECISION T
c mixing ratio (kg/kg) [specific hum couls also be used]
      DOUBLE PRECISION W
c missing value
      DOUBLE PRECISION XMSG

c output

c sea level pressure (Pa)
c     real pslhy2

c local

c virtual temperature (K)
      DOUBLE PRECISION TV
c gravity (m/s2)
      DOUBLE PRECISION G
c gas const dry air (j/{kg-k})
      DOUBLE PRECISION RDAIR
      DATA G/9.80665D0/
      DATA RDAIR/287.04D0/

c pres_msg, zmsg, tvmsg, wmsg
      IF (PRES.NE.XMSG .AND. Z.NE.XMSG .AND. T.NE.XMSG .AND.
     +    W.NE.XMSG) THEN
          TV = T* (1.D0+0.608D0*W)
          DPSLHY2 = PRES*EXP(G*Z/ (RDAIR*TV))
      ELSE
c pres_msg
          DPSLHY2 = XMSG
      END IF

      RETURN
      END
C*PL*ERROR* Comment line too long
c ----------------------------------------------------------------------------
      SUBROUTINE DPSLEC(T,PHIS,PS,PRES,MLON,NLAT,PSL)
      IMPLICIT NONE

c Compute sea level pressure using the ECMWF formulation.
c Uses same routine as CCM Processor's derived field: PSLECMWF

c NCL: slp = pslec (t,phis,ps,pres)
c input

c Number of longitude values
      INTEGER MLON
c Number of latitude values
      INTEGER NLAT

c Temperature of lowest vertical level (K)
      DOUBLE PRECISION T(MLON,NLAT)
c Surface geopotential (m^2/s^2)
      DOUBLE PRECISION PHIS(MLON,NLAT)
c Surface pressure (Pascals)
      DOUBLE PRECISION PS(MLON,NLAT)
c Pressure on lowest vertical level (Pa)
      DOUBLE PRECISION PRES(MLON,NLAT)

c output

c Sea Level Pressure (Pa)
      DOUBLE PRECISION PSL(MLON,NLAT)

c local

c latitude counter
      INTEGER NL


C*PL*ERROR* Comment line too long
c The CCM Processor routine cpslec processes one latitude slice at a time.

      DO NL = 1,NLAT
          CALL DCPSLEC(PRES(1,NL),PHIS(1,NL),PS(1,NL),T(1,NL),MLON,MLON,
     +                 1,PSL(1,NL))
      END DO

      RETURN
      END
C*PL*ERROR* Comment line too long
c ----------------------------------------------------------------------------
      SUBROUTINE DPSLHOR(Z,T,PHIS,PS,PRES,LATS,MLON,NLAT,KLEV,PSL,PSLU,
     +                   ZX,TX,PRESX)
      IMPLICIT NONE

c Compute sea level pressure (Pa)  using the ECMWF formulation and
c     Trenberth's horizontal correction.

c Uses same routine as CCM Processor's derived field: PSLHOR2.

c NCL: slp = pslhor (z,t,phis,ps,pres,lats)

c input

c Number of longitude values
      INTEGER MLON
c Number of latitude values
      INTEGER NLAT
c Number of vertical levels
      INTEGER KLEV

c Geopotential Height Units: meters
      DOUBLE PRECISION Z(MLON,NLAT,KLEV)
c Temperature (K)
      DOUBLE PRECISION T(MLON,NLAT,KLEV)
c Surface geopotential (m^2/s^2)
      DOUBLE PRECISION PHIS(MLON,NLAT)
c Surface pressure (Pa)
      DOUBLE PRECISION PS(MLON,NLAT)
c Pressure (Pa)
      DOUBLE PRECISION PRES(MLON,NLAT,KLEV)
c Latitudes (degrees)
      DOUBLE PRECISION LATS(NLAT)

c output

c Sea Level Pressure (Pa)
      DOUBLE PRECISION PSL(MLON,NLAT)

c local (arrays auto allocation)

c loop counters
      INTEGER ML,NL,KL
c psl from PSLEC, uncorrected
      DOUBLE PRECISION PSLU(MLON,NLAT)
c temp
      DOUBLE PRECISION ZX(MLON,KLEV)
c temp
      DOUBLE PRECISION TX(MLON,KLEV)
c temp
      DOUBLE PRECISION PRESX(MLON,KLEV)


C*PL*ERROR* Comment line too long
c The CCM Processor routine cpslec processes one latitude slice at a time.

      KL = 1
      DO NL = 1,NLAT
          CALL DCPSLEC(PRES(1,NL,KL),PHIS(1,NL),PS(1,NL),T(1,NL,KL),
     +                 MLON,MLON,1,PSLU(1,NL))
      END DO

c Do the horizontal correction
C*PL*ERROR* Comment line too long
c The CCM Processor routine cpslhor2 processes one latitude slice at a time
c   and expects data from top to bottom.

      DO NL = 1,NLAT

          DO KL = 1,KLEV
              DO ML = 1,MLON
c must be in reverse order
                  ZX(ML,KL) = Z(ML,NL,KLEV+1-KL)
c must be in reverse order
                  TX(ML,KL) = T(ML,NL,KLEV+1-KL)
c must be in reverse order
                  PRESX(ML,KL) = PRES(ML,NL,KLEV+1-KL)
              END DO
          END DO

          CALL DCPSLHOR2(PRESX,ZX,PHIS(1,NL),PSLU(1,NL),PS(1,NL),TX,
     +                   MLON,MLON,KLEV,LATS(NL),PSL(1,NL))
      END DO

      RETURN
      END
C*PL*ERROR* Comment line too long
c ----------------------------------------------------------------------------
      SUBROUTINE DCPSLEC(PRES,PHIS,PS,T,IDIM,IMAX,KMAX,PSL)
      DOUBLE PRECISION RD
      DOUBLE PRECISION G
      DOUBLE PRECISION XLAPSE
      DOUBLE PRECISION ALPHA
      DOUBLE PRECISION TSTAR
      DOUBLE PRECISION T0
      DOUBLE PRECISION ALPH
      DOUBLE PRECISION BETA
c
c       File:   /crestone/u0/ccmproc2/src/src/cpslec.F  (2312 bytes)
c       Date:   Wed Dec  1 16:07:19 1993
c       Author: Lawrence Buja <ccmproc2@sunny>
c
c       From:   inderf
c       Calls:  ** none **
c       Blocks: ** none **
c
c-----------------------------------------------------------------------
c
c       CCM2 hybrid coord version using ECMWF formulation
c       Purpose:   Compute sea level pressure for a latitude line
c       Algorithm: See section 3.1.b in NCAR NT-396 "Vertical
c                  Interpolation and Truncation of Model-Coordinate Data
c
c-----------------------------Arguments---------------------------------
c
c Input
c Atmospheric pressure (pascals)
      DOUBLE PRECISION PRES(IDIM,KMAX)
c Surface geopotential (m**2/sec**2)
      DOUBLE PRECISION PHIS(IDIM)
c Surface pressure (pascals)
      DOUBLE PRECISION PS(IDIM)
c Vertical slice of temperature (top to bot)
      DOUBLE PRECISION T(IDIM,KMAX)
c First dimension of phis, ps, and t
      INTEGER IDIM
c Number of longitude points to compute
      INTEGER IMAX
c Number of levels in t (2nd dimension)
      INTEGER KMAX
c
c Output
c
c Sea level pressures (pascals)
      DOUBLE PRECISION PSL(IDIM)
c
c-----------------------------Parameters--------------------------------
c
      PARAMETER (RD=287.04D0,G=9.80616D0,XLAPSE=6.5D-3)
      PARAMETER (ALPHA=RD*XLAPSE/G)
c
c-----------------------------------------------------------------------
c
      DO I = 1,IMAX
         IF (ABS(PHIS(I)/G) .LT. 1.D-4) THEN
            PSL(I) = PS(I)
         ELSE
c pg 7 eq 5
            TSTAR = T(I,KMAX)* (1.D0+ALPHA* (PS(I)/PRES(I,KMAX)-1.D0))

c pg 8 eq 13
            T0 = TSTAR + XLAPSE*PHIS(I)/G

c pg 8 eq 14.1
            IF (TSTAR.LE.290.5D0 .AND. T0.GT.290.5D0) THEN
               ALPH = RD/PHIS(I)* (290.5D0-TSTAR)
c pg 8 eq 14.2
            ELSE IF (TSTAR.GT.290.5D0 .AND. T0.GT.290.5D0) THEN
               ALPH = 0.D0
               TSTAR = 0.5D0* (290.5D0+TSTAR)
            ELSE
               ALPH = ALPHA
            END IF
            IF (TSTAR.LT.255.D0) THEN
c pg 8 eq 14.3
               TSTAR = 0.5D0* (255.D0+TSTAR)
            END IF
            BETA = PHIS(I)/ (RD*TSTAR)
            PSL(I) = PS(I)*EXP(BETA* (1.D0-ALPH*BETA/2.D0+
     +           ((ALPH*BETA)**2)/3.D0))
         END IF
      END DO
      RETURN
      END
C*PL*ERROR* Comment line too long
c ----------------------------------------------------------------------------
      SUBROUTINE DCPSLHOR2(PRES,Z,PHIS,PSL,PS,T,IDIM,IMAX,KMAX,DLAT,
     +                     PSLHOR)
      DOUBLE PRECISION RD
      DOUBLE PRECISION G
      DOUBLE PRECISION XLAPSE
      DOUBLE PRECISION ALPHA
      DOUBLE PRECISION ZMIN
      DOUBLE PRECISION ZMID
      DOUBLE PRECISION ZA
      DOUBLE PRECISION ZF
      DOUBLE PRECISION PA
      DOUBLE PRECISION PF
      DOUBLE PRECISION DPA
      DOUBLE PRECISION DPF
      DOUBLE PRECISION FACTOR
c
c       File:   /crestone/u0/ccmproc2/src/src/cpslhor.F  (12843 bytes)
c       Date:   Wed Dec  8 13:42:48 1993
c       Author: Lawrence Buja <ccmproc2@sunny>
c
c       From:   inderf
c       Calls:  ** none **
c       Blocks: ** none **
c
c-----------------------------------------------------------------------
c
c       PSL via Trenberth's horizontal formulation
c       Purpose:   Compute sea level pressure for a latitude line
c       Algorithm:
c
c Designation:  --Low Area----|-------High Area------|---Low Area--
c                               ___________________
c                              /
c                             /_ _ _ _ _ _ _ _ _ _ _
c                            /      2000 meters
c                           /
c Surface:      ------------                           ------------
c Gridpoints:        X     X     X     X     X     X     X     X
c Counters:          A     B     C     D     E     F     G     H
c
c-----------------------------Arguments---------------------------------
c
c Input
c Atmospheric pressure (pascals)
      DOUBLE PRECISION PRES(IDIM,KMAX)
c Geopotential of hybrid levels (m**2/sec**2)
      DOUBLE PRECISION Z(IDIM,KMAX)
c Surface geopotential (m**2/sec**2)
      DOUBLE PRECISION PHIS(IDIM)
c Sea level pressures (pascals)
      DOUBLE PRECISION PSL(IDIM)
c Surface pressure (pascals)
      DOUBLE PRECISION PS(IDIM)
c Vertical slice of temperature (top to bot)
      DOUBLE PRECISION T(IDIM,KMAX)
c First dimension of phis, ps, and t
      INTEGER IDIM
c Number of longitude points to compute
      INTEGER IMAX
c Number of levels in t (2nd dimension)
      INTEGER KMAX
c Current latitude (-90. <= dlat <= +90.00)
      DOUBLE PRECISION DLAT
c
c Output
c
c PSL with Horiz correction (pascals)
      DOUBLE PRECISION PSLHOR(IDIM)
c
c-----------------------------Parameters--------------------------------
c
      PARAMETER (RD=287.04D0,G=9.80616D0,XLAPSE=6.5D-3)
      PARAMETER (ALPHA=RD*XLAPSE/G)
c
c--------------------------Local variables------------------------------
c
c Surrounding end points (2 on each bdry)
      INTEGER IENDPTS(10,2)
c if region lon1 thru lon2 is > 2000meters

c  1st dim: Assume there are multiple high

c           areas on 1 latitude line.

c  2nd dim: (N,1)= 1st  lon of high area N

c           (N,2)= Last lon of high area N

c Counter for first dimension of iendpts.
      INTEGER NEND
c .True. = looking for high area
      LOGICAL LSTART
c .False.= looking for low area

c
c-----------------------------------------------------------------------
c
c Min height of a "high" area.
      ZMIN = 2000.D0
c Max height to use PSL data for interpolation
      ZMID = 1250.D0
      NEND = 0
      LSTART = .true.
      LASTINDEX = 0
      DO I = 1,IMAX
c This a high area and
c Latitude is .gt. -60.00
          IF (PHIS(I)/G.GT.ZMIN .AND. DLAT.GT.-60.00D0) THEN
c Is this 1st long of high area?
              IF (LSTART) THEN
c > 2 points away from last area
                  IF (I-LASTINDEX.GT.3) THEN
c Increment counter.
                      NEND = NEND + 1
c Set beginning point index (i1)
                      IENDPTS(NEND,1) = I
c In High area, search for low area
                      LSTART = .false.
c < 2 points from last high area.
                  ELSE
c  merge last area into this area
                      LSTART = .false.
                  END IF
              END IF
c This is a low area
          ELSE
c PSL is not modified.
              PSLHOR(I) = PSL(I)
c 1st long of low area
              IF (.NOT.LSTART) THEN
c In low area, search for high area
                  LSTART = .true.
c Set end point index (i2)
                  IENDPTS(NEND,2) = I - 1
                  LASTINDX = I - 1
              END IF
          END IF
      END DO

      DO N = 1,NEND
c Beginning index of high area
          I1 = IENDPTS(N,1)
c Last index of high area
          I2 = IENDPTS(N,2)
          DO WHILE (PHIS(I1)/G.GT.ZMID)
              I1 = I1 - 1
          END DO
          DO WHILE (PHIS(I2)/G.GT.ZMID)
              I2 = I2 + 1
          END DO
          I1 = I1 + 1
          I2 = I2 - 1
c loop over longitude from C to F
          DO I = I1,I2
c Z Foes from 1=top to kmax=bottom
              DO LEV = 1,KMAX
                  IF (Z(I1-1,LEV).GT.PHIS(I)/G) LEVA = LEV
                  IF (Z(I2+1,LEV).GT.PHIS(I)/G) LEVF = LEV
              END DO
c
c  zA is hgt of PHIS(i1) at point i1 minus 2.
c
              ZA = (PHIS(I)/G-Z(I1-1,LEVA+1))/
     +             (Z(I1-1,LEVA)-Z(I1-1,LEVA+1))
              ZF = (PHIS(I)/G-Z(I2+1,LEVF+1))/
     +             (Z(I2+1,LEVF)-Z(I2+1,LEVF+1))
c
c PA is Pressure at the 2000 meter level at point i1 minus 2
c        (pres goes from 1=top down to kmax=bottom)
c
              PA = EXP(LOG(PRES(I1-1,LEVA+1))-
     +             LOG(PRES(I1-1,LEVA+1)/PRES(I1-1,LEVA))*ZA)
              PF = EXP(LOG(PRES(I2+1,LEVF+1))-
     +             LOG(PRES(I2+1,LEVF+1)/PRES(I2+1,LEVF))*ZF)

              DPA = PSL(I1-1) - PA
              DPF = PSL(I2+1) - PF
              FACTOR = DBLE(I-I1)/DBLE(I2-I1)
              PSLHOR(I) = PS(I) + (FACTOR*DPF+ (1-FACTOR)*DPA)
          END DO
      END DO

      RETURN
      END

C======================================================================

      SUBROUTINE DCPSLHOR(PRES,Z,PHIS,PSL,PS,T,IDIM,IMAX,KMAX,DLAT,
     +                    PSLHOR)
      DOUBLE PRECISION RD
      DOUBLE PRECISION G
      DOUBLE PRECISION XLAPSE
      DOUBLE PRECISION ALPHA
      DOUBLE PRECISION ZMIN
      DOUBLE PRECISION ZA
      DOUBLE PRECISION ZB
      DOUBLE PRECISION ZG
      DOUBLE PRECISION ZH
      DOUBLE PRECISION PA
      DOUBLE PRECISION PB
      DOUBLE PRECISION PG
      DOUBLE PRECISION PH
      DOUBLE PRECISION DPA
      DOUBLE PRECISION DPB
      DOUBLE PRECISION DPG
      DOUBLE PRECISION DPH
      DOUBLE PRECISION DPAB
      DOUBLE PRECISION DPGH
      DOUBLE PRECISION FACTOR
c
c       File:   /crestone/u0/ccmproc2/src/src/cpslhor.F  (6747 bytes)
c       Date:   Tue Dec  7 13:52:48 1993
c       Author: Lawrence Buja <ccmproc2@sunny>
c
c       From:   inderf
c       Calls:  ** none **
c       Blocks: ** none **
c
c-----------------------------------------------------------------------
c
c       PSL via Trenberth's horizontal formulation
c       Purpose:   Compute sea level pressure for a latitude line
c       Algorithm:
c
c Designation:  --Low Area----|-------High Area------|---Low Area--
c                               ___________________
c                              /
c                             /_ _ _ _ _ _ _ _ _ _ _
c                            /      2000 meters
c                           /
c Surface:      ------------                           ------------
c Gridpoints:        X     X     X     X     X     X     X     X
c Counters:          A     B     C     D     E     F     G     H
c
c-----------------------------Arguments---------------------------------
c
c Input
c Atmospheric pressure (pascals)
      DOUBLE PRECISION PRES(IDIM,KMAX)
c Geopotential of hybrid levels (m**2/sec**2)
      DOUBLE PRECISION Z(IDIM,KMAX)
c Surface geopotential (m**2/sec**2)
      DOUBLE PRECISION PHIS(IDIM)
c Sea level pressures (pascals)
      DOUBLE PRECISION PSL(IDIM)
c Surface pressure (pascals)
      DOUBLE PRECISION PS(IDIM)
c Vertical slice of temperature (top to bot)
      DOUBLE PRECISION T(IDIM,KMAX)
c First dimension of phis, ps, and t
      INTEGER IDIM
c Number of longitude points to compute
      INTEGER IMAX
c Number of levels in t (2nd dimension)
      INTEGER KMAX
c Current latitude (-90. <= dlat <= +90.00)
      DOUBLE PRECISION DLAT
c
c Output
c
c PSL with Horiz correction (pascals)
      DOUBLE PRECISION PSLHOR(IDIM)
c
c-----------------------------Parameters--------------------------------
c
      PARAMETER (RD=287.04D0,G=9.80616D0,XLAPSE=6.5D-3)
      PARAMETER (ALPHA=RD*XLAPSE/G)
c
c--------------------------Local variables------------------------------
c
c Surrounding end points (2 on each bdry)
      INTEGER IENDPTS(10,2)
c if region lon1 thru lon2 is > 2000meters

c  1st dim: Assume there are multiple high

c           areas on 1 latitude line.

c  2nd dim: (N,1)= 1st  lon of high area N

c           (N,2)= Last lon of high area N

c Counter for first dimension of iendpts.
      INTEGER NEND
c .True. = looking for high area
      LOGICAL LSTART
c .False.= looking for low area

c
c-----------------------------------------------------------------------
c
      ZMIN = 2000.D0
      NEND = 0
      LSTART = .true.
      LASTINDEX = 0
      DO I = 1,IMAX
c This a high area and
c Latitude is .gt. -60.00
          IF (PHIS(I)/G.GT.ZMIN .AND. DLAT.GT.-60.00D0) THEN
c Is this 1st long of high area?
              IF (LSTART) THEN
c > 2 points away from last area
                  IF (I-LASTINDEX.GT.3) THEN
c Increment counter.
                      NEND = NEND + 1
c Set beginning point index (i1)
                      IENDPTS(NEND,1) = I
c In High area, search for low area
                      LSTART = .false.
c < 2 points from last high area.
                  ELSE
c  merge last area into this area
                      LSTART = .false.
                  END IF
              END IF
c This is a low area
          ELSE
c PSL is not modified.
              PSLHOR(I) = PSL(I)
c 1st long of low area
              IF (.NOT.LSTART) THEN
c In low area, search for high area
                  LSTART = .true.
c Set end point index (i2)
                  IENDPTS(NEND,2) = I - 1
                  LASTINDX = I - 1
              END IF
          END IF
      END DO

      DO N = 1,NEND
c Beginning index of high area
          I1 = IENDPTS(N,1)
c Last index of high area
          I2 = IENDPTS(N,2)
c loop over longitude from C to F
          DO I = I1,I2
c Z goes from 1=top to kmax=bottom
              DO LEV = 1,KMAX
                  IF (Z(I1-2,LEV).GT.PHIS(I)/G) LEVA = LEV
                  IF (Z(I1-1,LEV).GT.PHIS(I)/G) LEVB = LEV
                  IF (Z(I2+1,LEV).GT.PHIS(I)/G) LEVG = LEV
                  IF (Z(I2+2,LEV).GT.PHIS(I)/G) LEVH = LEV
              END DO
c
c  zA is hgt of PHIS(i1) at point i1 minus 2.
c
              ZA = (PHIS(I)/G-Z(I1-2,LEVA+1))/
     +             (Z(I1-2,LEVA)-Z(I1-2,LEVA+1))
              ZB = (PHIS(I)/G-Z(I1-1,LEVB+1))/
     +             (Z(I1-1,LEVB)-Z(I1-1,LEVB+1))
              ZG = (PHIS(I)/G-Z(I2+1,LEVG+1))/
     +             (Z(I2+1,LEVG)-Z(I2+1,LEVG+1))
              ZH = (PHIS(I)/G-Z(I2+2,LEVH+1))/
     +             (Z(I2+2,LEVH)-Z(I2+2,LEVH+1))
c
c PA is Pressure at the 2000 meter level at point i1 minus 2
c        (pres goes from 1=top down to kmax=bottom)
c
              PA = EXP(LOG(PRES(I1-2,LEVA+1))-
     +             LOG(PRES(I1-2,LEVA+1)/PRES(I1-2,LEVA))*ZA)
              PB = EXP(LOG(PRES(I1-1,LEVB+1))-
     +             LOG(PRES(I1-1,LEVB+1)/PRES(I1-1,LEVB))*ZB)
              PG = EXP(LOG(PRES(I2+1,LEVG+1))-
     +             LOG(PRES(I2+1,LEVG+1)/PRES(I2+1,LEVG))*ZG)
              PH = EXP(LOG(PRES(I2+2,LEVH+1))-
     +             LOG(PRES(I2+2,LEVH+1)/PRES(I2+2,LEVH))*ZH)
              DPA = PSL(I1-2) - PA
              DPB = PSL(I1-1) - PB
              DPG = PSL(I2+1) - PG
              DPH = PSL(I2+2) - PH
              DPAB = (DPA+DPB)*0.5D0
              DPGH = (DPG+DPH)*0.5D0
c          if (Lprint) then
c             print *,' cpslhor.100: Levs= ',levA,levB,levG,levH
c             print *,' cpslhor.101: Zs=   ',zA,zB,zG,zH
c             print *,' cpslhor.102: Ps=   ',pA,pB,pG,pH
c             print *,' cpslhor.103: dps=  ',dpA,dpB,dpG,dpH,dpAB,dpGH
c           endif
              FACTOR = (I-I1+1.5D0)/ (I2-I1+3)
              PSLHOR(I) = PS(I) + (FACTOR*DPGH+ (1-FACTOR)*DPAB)
          END DO
      END DO
      RETURN
      END

C
C $Id: kurvp2.f,v 1.5 2008-07-27 03:10:12 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
C NOTE: If you make any changes to this software, please remember to
C make the same changes to the corresponding double precision routine.
C
      subroutine kurvp2 (t,xs,ys,n,x,y,xp,yp,s,sigma)
c
      integer n
      real t,xs,ys,x(n),y(n),xp(n),yp(n),s(n),sigma
c
c                                 coded by alan kaylor cline
c                           from fitpack -- january 26, 1987
c                        a curve and surface fitting package
c                      a product of pleasant valley software
c                  8603 altus cove, austin, texas 78759, usa
c
c this subroutine performs the mapping of points in the
c interval (0.,1.) onto a closed curve in the plane. the
c subroutine kurvp1 should be called earlier to determine
c certain necessary parameters. the resulting curve has a
c parametric representation both of whose components are
c periodic splines under tension and functions of the poly-
c gonal arclength parameter.
c
c on input--
c
c   t contains a value to be mapped onto the curve. the
c   interval (0.,1.) is mapped onto the entire closed curve
c   with both 0. and 1. mapping to (x(1),y(1)). the mapping
c   is periodic with period one thus any interval of the
c   form (tt,tt+1.) maps onto the entire curve.
c
c   n contains the number of points which were specified
c   to determine the curve.
c
c   x and y are arrays containing the x- and y-coordinates
c   of the specified points.
c
c   xp and yp are the arrays output from kurvp1 containing
c   curvature information.
c
c   s is an array containing the polygonal arclengths of
c   the curve.
c
c and
c
c   sigma contains the tension factor (its sign is ignored).
c
c the parameters n, x, y, xp, yp, s and sigma should
c be input unaltered from the output of kurvp1.
c
c on output--
c
c   xs and ys contain the x- and y-coordinates of the image
c   point on the curve.
c
c none of the input parameters are altered.
c
c this subroutine references package modules intrvl and
c snhcsh.
c
c-----------------------------------------------------------
c
c determine interval
c
      tn = t-float(ifix(t))
      if (tn .lt. 0.) tn = tn+1.
      tn = s(n)*tn+s(1)
      im1 = n
      if (tn .lt. s(n)) im1 = intrvl(tn,s,n)
      i = im1+1
      if (i .gt. n) i = 1
c
c denormalize tension factor
c
      sigmap = abs(sigma)*float(n)/s(n)
c
c set up and perform interpolation
c
      si = s(i)
      if (im1 .eq. n) si = s(n)+s(1)
      del1 = tn-s(im1)
      del2 = si-tn
      dels = si-s(im1)
      sumx = (x(i)*del1+x(im1)*del2)/dels
      sumy = (y(i)*del1+y(im1)*del2)/dels
      if (sigmap .ne. 0.) go to 1
      d = del1*del2/(6.*dels)
      c1 = (del1+dels)*d
      c2 = (del2+dels)*d
      xs = sumx-xp(i)*c1-xp(im1)*c2
      ys = sumy-yp(i)*c1-yp(im1)*c2
      return
    1 sigdel = sigmap*dels
      call snhcsh(ss,dummy,sigdel,-1)
      call snhcsh(s1,dummy,sigmap*del1,-1)
      call snhcsh(s2,dummy,sigmap*del2,-1)
      d = sigdel*sigmap*(1.+ss)
      ci = del1*(s1-ss)/d
      cim1 = del2*(s2-ss)/d
      xs = sumx+xp(i)*ci+xp(im1)*cim1
      ys = sumy+yp(i)*ci+yp(im1)*cim1
      return
      end

C
C $Id: seblda.f,v 1.6 2008-07-27 00:17:31 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE SEBLDA
C
C Calling this do-nothing subroutine forces "ld" to load the following
C block data routine (but only if they are in the same ".f" file).
C
        RETURN
C
      END
CNOSPLIT
      BLOCKDATA SEBLDAX
C
C The common blocks SECOMI and SECOMC are used to hold shared variables
C of types INTEGER and CHARACTER, respectively, for the routine SETER
C and associated routines.  For descriptions of these variables and for
C default values of them, see the block data routine SEBLDAX.
C
        COMMON /SECOMI/ IERRU,IERRF,IRECF,LOMSG
        SAVE   /SECOMI/
C
        COMMON /SECOMC/ ERMSG
          CHARACTER*256 ERMSG
        SAVE   /SECOMC/
C
C IERRU is the logical unit for error messages.  Its default value is
C zero, which serves as a signal to SETER that the proper value should
C be gotten from I1MACH.
C
        DATA IERRU / 0 /
C
C IERRF is the error flag.  Initially, it is zero.  A non-zero value
C means that there is an uncleared prior error.
C
        DATA IERRF / 0 /
C
C IRECF is the recovery flag, which can have values of 1, which turns
C recovery mode on, or 2, which turns recovery mode off and causes all
C errors to be treated as fatal errors.  The latter is the default.
C
        DATA IRECF / 2 /
C
C LOMSG is the actual length of the error message in ERMSG.
C
        DATA LOMSG / 1 /
C
C ERMSG is the text of the current error message, only meaningful when
C IERRF is non-zero.
C
        DATA ERMSG / ' ' /
C
      END

C
C $Id: slpwrv.f,v 1.5 2008-07-27 00:17:26 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE SLPWRV (XPOS,YPOS,CHRS,SIZE)
C
C This routine is used by STITLE to write a message vertically.  The
C message is centered at the position (XPOS,YPOS) in the fractional
C coordinate system.  The characters are as specified by CHRS and they
C are of the size specified by SIZE (a character width, between 0 and
C 1, in the fractional coordinate system).
C
C Note: The current "user" coordinate system must be the fractional
C coordinate system for this routine to work properly.
C
        CHARACTER*(*) CHRS
C
C Find the length of the character string.
C
        NCHR=LEN(CHRS)
C
C Compute the appropriate size to tell WTSTR to use.
C
        ISIZ=INT(1023.*SIZE)
C
C Write the characters one at a time, using WTSTR.
C
        DO 101 I=1,NCHR
          CALL WTSTR (XPOS,YPOS+SIZE*(NCHR+1-2*I),CHRS(I:I),ISIZ,0,0)
          IF (ICFELL('SLPWRV',1).NE.0) RETURN
  101   CONTINUE
C
        RETURN
C
      END

C NCLFORTSTART
      subroutine dpresplvl(klvl,plevel,ntim,nlat,mlon,psfc,pmsg
     +                    ,ptop,dp,iopt,kflag,ier)
      implicit none
C                                                ! input 
      integer  klvl,ntim,nlat,mlon,iopt,kflag,ier
      double precision     plevel(klvl), psfc(mlon,nlat,ntim),ptop,pmsg
C                                                ! output
      double precision     dp(mlon,nlat,klvl,ntim)
C NCLEND
c     dpres = dpres_plevel(plevel, psfc, ptop, iopt)
c
      integer nt, ml, nl, kl, jer, kloop 
      double precision  dplvl(klvl)
cdebugdouble precision  dpsum, pdif   

      kflag = 0
      kloop = -999

c loop over all grid points

      do nt=1,ntim
        do nl=1,nlat
          do ml=1,mlon

c calculate vertical 'dp' at current grid point

             call dpres1d(klvl,plevel,psfc(ml,nl,nt),pmsg
     +                    ,ptop,dplvl,iopt,kloop,ier)
             if (kloop.eq.1) then
                 kflag = 1
             end if

c transfer to return array

             do kl=1,klvl
                dp(ml,nl,kl,nt) = dplvl(kl)
             end do

cdebug       dpsum = sum(dplvl, 1, dplvl.ne.pmsg)   ! f90 array function
cdebug       pdif  = psfc(ml,nl,nt)-ptop
cdebug       print *,"dpsum=", dpsum,"  pdif=",pdif

          end do
        end do
      end do

      return
      end
c ------------------------------------------------------------------------
C NCLFORTSTART
      subroutine dpres1d(klvl,plevel,psfc,pmsg,ptop,dp,iopt,kflag,ier) 
      implicit none
C                                                ! input 
      integer              klvl, iopt, kflag, ier
      double precision     plevel(klvl), psfc, ptop, pmsg
C                                                ! output
      double precision     dp(klvl)
C NCLEND
c     dpres = dpres_plevel(plevel, psfc, ptop, iopt)
c
c isobaric (constant) pressure level equivalent of dpres_hybrid_ccm
c The returned 'dp' are equivalent to having used  beta factors.
 
C                                                ! local
      integer             mono, kl, klStrt, klLast
      double precision    plvl(klvl), work(klvl)
      double precision    dpsum, pspan, peps, plow, phi

      peps  = 0.001d0
c
c check to see if ptop is reasonable
c .   psfc = pmsg   is not allowed
c .   ptop < 0      is not allowed
c .   ptop > psfcmx is probably due to units difference

      ier    = 0
      if (psfc.eq.pmsg .or. psfc.lt.0.0d0) ier = ier + 100
      if (ptop.lt.0.0d0) ier = ier + 1
      if (ptop.ge.psfc)  ier = ier + 10

c if ier.ne.0; input error with psfc and/or ptop

      if (ier.ne.0) then   
          kflag = 1
          do kl=1,klvl 
             dp(kl)   = pmsg
          end do
          dpsum = pmsg
          return
      end if

c monotonically increasing or decreasing? Code wants top to bottom
c if decreasing pressure make increasing; then flip back 

      if (plevel(2).gt.plevel(1)) then
          mono =  1
          do kl=1,klvl
             plvl(kl) = plevel(kl)
          end do
      else
          mono = -1
          do kl=1,klvl
             plvl(kl) = plevel(klvl-kl+1)
          end do
      end if

c initialize to missing

      do kl=1,klvl
         dp(kl) = pmsg                 
      end do

c calculate 'dp'; check if dpsum.eq.(psfc-ptop) within peps then return

      if (ptop.le.plvl(1) .and. psfc.ge.plvl(klvl)) then
          kflag = 0

          dp(1) = (plvl(1)+plvl(2))*0.5d0 - ptop
          do kl=2,klvl-1 
             dp(kl)= 0.5d0*(plvl(kl+1) - plvl(kl-1))
          end do
          dp(klvl) = psfc -(plvl(klvl)+plvl(klvl-1))*0.5d0

      else 
          kflag  = 1

c The klvl pressure levels in plvl define (klvl-1) layers.  There is
c  one fewer layer than pressure levels.
c Find klStrt and klLast so they define the smallest possible 
c  interval [plev(klLast), plev(klStrt)] that contains all 
c  layer mid-points within the interval [ptop, psfc].
c
c Starting with the bottom and moving up, find the first layer whose
c  midpoint is at or above ptop. klStrt is the bottom of this layer. 
          do klStrt=klvl,2,-1
             if ((plvl(klStrt-1)+plvl(klStrt))/2.lt.ptop) then
                 exit
             end if
          end do

c Starting the top layer and moving downward, find the first layer whose
c midpoint is at or below psfc. klLast is the top of this layer. 
          do klLast=1,klvl-1
             if ((plvl(klLast+1)+plvl(klLast))/2.gt.psfc) then
                 exit
             end if
          end do

cdebugprint *,"klStrt=",klStrt," klLast=",klLast," ptop=",ptop
cdebugprint *,"plvl(klStrt)=",plvl(klStrt)," plvl(klLast)=",plvl(klLast)
cdebugprint *,"plvl(klStrt  )=",plvl(klStrt)  
cdebugprint *,"plvl(klStrt+1)=",plvl(klStrt+1)
cdebugprint *,"dp(klStrt)=",dp(klStrt)

          if (klStrt.eq.klLast) then
              dp(klStrt) = psfc-ptop
          elseif (klStrt.lt.klLast) then
              dp(klStrt) = (plvl(klStrt)+plvl(klStrt+1))*0.5d0 - ptop
              do kl=klStrt+1,klLast-1 
                 dp(kl)= 0.5d0*(plvl(kl+1) - plvl(kl-1))
              end do
              dp(klLast) = psfc -(plvl(klLast)+plvl(klLast-1))*0.5d0

c c c     else     ! klStrt>klLast  is a pathological case
c c c              ! plev(?)=500  plev(?+1)=550, psfc=540, ptop=510
c c c              ! both level are *between* levels
          end if

      end if

c error check

c f90 dpsum = sum(dplvl, 1, dplvl.ne.pmsg)  
      dpsum = 0.0d0
      do kl=1,klvl
         if (dp(kl).ne.pmsg) then
             dpsum = dpsum + dp(kl)
         end if
      end do

      pspan = psfc-ptop

      if (dpsum.gt.0.0d0 .and. pspan.ne.dpsum) then
          plow = pspan-peps 
          phi  = pspan+peps 
          if (dpsum.gt.phi .or. dpsum.lt.plow) then
              ier = -1
              do kl=1,klvl
                 dp(kl) = pmsg                 
              end do
          end if
      end if

c if necessary return to original order

      if (mono.lt.0) then
          do kl=1,klvl
             work(kl) = dp(kl)
          end do

          do kl=1,klvl
             dp(kl) = work(klvl-kl+1)
          end do
       end if

      return
      end

C
C $Id: mdrgam.f,v 1.7 2008-09-18 00:42:18 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MDRGAM (IAMA,XCRA,YCRA,NCRA,IGID,IAIL,IAIR)
C
        DIMENSION IAMA(*),XCRA(NCRA),YCRA(NCRA)
C
C The object of this routine is to break a polygon being sent to an area
C map into pieces that lie along the edges of the unit square and pieces
C that lie strictly within the interior of the unit square.  Only the
C latter are actually sent to the area map.
C
C NPCS counts the number of pieces of the polygon sent to the area map
C so far.
C
        NPCS=0
C
C IBEG is the index of the first point of the current interior piece of
C the polygon being traced, zero if no interior piece is being traced.
C
        IBEG=0
C
C ICRA is the index of the current polygon point being examined.
C
        ICRA=1
C
C Loop through the points of the polygon.
C
  101   IF (ICRA.LT.NCRA) THEN
C
C Advance ICRA to point to the next point.
C
          ICRA=ICRA+1
C
C Test whether the segment from point ICRA-1 to point ICRA is on the
C boundary of the unit square or not.
C
          IF ((XCRA(ICRA-1).EQ.0..AND.XCRA(ICRA).EQ.0.).OR.
     +        (XCRA(ICRA-1).EQ.1..AND.XCRA(ICRA).EQ.1.).OR.
     +        (YCRA(ICRA-1).EQ.0..AND.YCRA(ICRA).EQ.0.).OR.
     +        (YCRA(ICRA-1).EQ.1..AND.YCRA(ICRA).EQ.1.)) THEN
C
C It's on the boundary.  If an interior piece was being traced, send it
C to the area map, bump the piece count, and resume searching for the
C beginning of another interior piece.
C
            IF (IBEG.NE.0) THEN
              CALL AREDAM (IAMA,XCRA(IBEG),YCRA(IBEG),ICRA-IBEG,
     +                                                   IGID,IAIL,IAIR)
              NPCS=NPCS+1
              IBEG=0
            END IF
C
          ELSE
C
C It's in the interior.  If no interior piece is currently being
C traced, set the pointer to begin tracing a new such piece.
C
            IF (IBEG.EQ.0) IBEG=ICRA-1
C
          END IF
C
C Loop back for the next point of the polygon.
C
          GO TO 101
C
        END IF
C
C All segments of the polygon have been examined.  If the trace of an
C interior piece was in progress, send it to the area map and bump the
C piece count.
C
        IF (IBEG.NE.0) THEN
          CALL AREDAM (IAMA,XCRA(IBEG),YCRA(IBEG),ICRA-IBEG+1,
     +                                                   IGID,IAIL,IAIR)
          NPCS=NPCS+1
        END IF
C
C If nothing was sent to the area map, all segments of the polygon were
C on the edge of the unit square.  In that special case, we send the
C entire polygon to the area map as an enclosing boundary for what is
C to follow.  We must force the smaller of the area ID's to zero.
C
        IF (NPCS.EQ.0) THEN
          CALL MDRGIP (XCRA,YCRA,NCRA)
          IF (IAIL.LT.IAIR) THEN
            CALL AREDAM (IAMA,XCRA,YCRA,-NCRA,IGID,0,IAIR)
          ELSE
            CALL AREDAM (IAMA,XCRA,YCRA,-NCRA,IGID,IAIL,0)
          END IF
        END IF
C
C Done.
C
        RETURN
C
      END

      SUBROUTINE ZPTRFS( UPLO, N, NRHS, D, E, DF, EF, B, LDB, X, LDX,
     $                   FERR, BERR, WORK, RWORK, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER          UPLO
      INTEGER            INFO, LDB, LDX, N, NRHS
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   BERR( * ), D( * ), DF( * ), FERR( * ),
     $                   RWORK( * )
      COMPLEX*16         B( LDB, * ), E( * ), EF( * ), WORK( * ),
     $                   X( LDX, * )
*     ..
*
*  Purpose
*  =======
*
*  ZPTRFS improves the computed solution to a system of linear
*  equations when the coefficient matrix is Hermitian positive definite
*  and tridiagonal, and provides error bounds and backward error
*  estimates for the solution.
*
*  Arguments
*  =========
*
*  UPLO    (input) CHARACTER*1
*          Specifies whether the superdiagonal or the subdiagonal of the
*          tridiagonal matrix A is stored and the form of the
*          factorization:
*          = 'U':  E is the superdiagonal of A, and A = U**H*D*U;
*          = 'L':  E is the subdiagonal of A, and A = L*D*L**H.
*          (The two forms are equivalent if A is real.)
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  NRHS    (input) INTEGER
*          The number of right hand sides, i.e., the number of columns
*          of the matrix B.  NRHS >= 0.
*
*  D       (input) DOUBLE PRECISION array, dimension (N)
*          The n real diagonal elements of the tridiagonal matrix A.
*
*  E       (input) COMPLEX*16 array, dimension (N-1)
*          The (n-1) off-diagonal elements of the tridiagonal matrix A
*          (see UPLO).
*
*  DF      (input) DOUBLE PRECISION array, dimension (N)
*          The n diagonal elements of the diagonal matrix D from
*          the factorization computed by ZPTTRF.
*
*  EF      (input) COMPLEX*16 array, dimension (N-1)
*          The (n-1) off-diagonal elements of the unit bidiagonal
*          factor U or L from the factorization computed by ZPTTRF
*          (see UPLO).
*
*  B       (input) COMPLEX*16 array, dimension (LDB,NRHS)
*          The right hand side matrix B.
*
*  LDB     (input) INTEGER
*          The leading dimension of the array B.  LDB >= max(1,N).
*
*  X       (input/output) COMPLEX*16 array, dimension (LDX,NRHS)
*          On entry, the solution matrix X, as computed by ZPTTRS.
*          On exit, the improved solution matrix X.
*
*  LDX     (input) INTEGER
*          The leading dimension of the array X.  LDX >= max(1,N).
*
*  FERR    (output) DOUBLE PRECISION array, dimension (NRHS)
*          The forward error bound for each solution vector
*          X(j) (the j-th column of the solution matrix X).
*          If XTRUE is the true solution corresponding to X(j), FERR(j)
*          is an estimated upper bound for the magnitude of the largest
*          element in (X(j) - XTRUE) divided by the magnitude of the
*          largest element in X(j).
*
*  BERR    (output) DOUBLE PRECISION array, dimension (NRHS)
*          The componentwise relative backward error of each solution
*          vector X(j) (i.e., the smallest relative change in
*          any element of A or B that makes X(j) an exact solution).
*
*  WORK    (workspace) COMPLEX*16 array, dimension (N)
*
*  RWORK   (workspace) DOUBLE PRECISION array, dimension (N)
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*
*  Internal Parameters
*  ===================
*
*  ITMAX is the maximum number of steps of iterative refinement.
*
*  =====================================================================
*
*     .. Parameters ..
      INTEGER            ITMAX
      PARAMETER          ( ITMAX = 5 )
      DOUBLE PRECISION   ZERO
      PARAMETER          ( ZERO = 0.0D+0 )
      DOUBLE PRECISION   ONE
      PARAMETER          ( ONE = 1.0D+0 )
      DOUBLE PRECISION   TWO
      PARAMETER          ( TWO = 2.0D+0 )
      DOUBLE PRECISION   THREE
      PARAMETER          ( THREE = 3.0D+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            UPPER
      INTEGER            COUNT, I, IX, J, NZ
      DOUBLE PRECISION   EPS, LSTRES, S, SAFE1, SAFE2, SAFMIN
      COMPLEX*16         BI, CX, DX, EX, ZDUM
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            IDAMAX
      DOUBLE PRECISION   DLAMCH
      EXTERNAL           LSAME, IDAMAX, DLAMCH
*     ..
*     .. External Subroutines ..
      EXTERNAL           XERBLA, ZAXPY, ZPTTRS
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, DBLE, DCMPLX, DCONJG, DIMAG, MAX
*     ..
*     .. Statement Functions ..
      DOUBLE PRECISION   CABS1
*     ..
*     .. Statement Function definitions ..
      CABS1( ZDUM ) = ABS( DBLE( ZDUM ) ) + ABS( DIMAG( ZDUM ) )
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      UPPER = LSAME( UPLO, 'U' )
      IF( .NOT.UPPER .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( NRHS.LT.0 ) THEN
         INFO = -3
      ELSE IF( LDB.LT.MAX( 1, N ) ) THEN
         INFO = -9
      ELSE IF( LDX.LT.MAX( 1, N ) ) THEN
         INFO = -11
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'ZPTRFS', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 .OR. NRHS.EQ.0 ) THEN
         DO 10 J = 1, NRHS
            FERR( J ) = ZERO
            BERR( J ) = ZERO
   10    CONTINUE
         RETURN
      END IF
*
*     NZ = maximum number of nonzero elements in each row of A, plus 1
*
      NZ = 4
      EPS = DLAMCH( 'Epsilon' )
      SAFMIN = DLAMCH( 'Safe minimum' )
      SAFE1 = NZ*SAFMIN
      SAFE2 = SAFE1 / EPS
*
*     Do for each right hand side
*
      DO 100 J = 1, NRHS
*
         COUNT = 1
         LSTRES = THREE
   20    CONTINUE
*
*        Loop until stopping criterion is satisfied.
*
*        Compute residual R = B - A * X.  Also compute
*        abs(A)*abs(x) + abs(b) for use in the backward error bound.
*
         IF( UPPER ) THEN
            IF( N.EQ.1 ) THEN
               BI = B( 1, J )
               DX = D( 1 )*X( 1, J )
               WORK( 1 ) = BI - DX
               RWORK( 1 ) = CABS1( BI ) + CABS1( DX )
            ELSE
               BI = B( 1, J )
               DX = D( 1 )*X( 1, J )
               EX = E( 1 )*X( 2, J )
               WORK( 1 ) = BI - DX - EX
               RWORK( 1 ) = CABS1( BI ) + CABS1( DX ) +
     $                      CABS1( E( 1 ) )*CABS1( X( 2, J ) )
               DO 30 I = 2, N - 1
                  BI = B( I, J )
                  CX = DCONJG( E( I-1 ) )*X( I-1, J )
                  DX = D( I )*X( I, J )
                  EX = E( I )*X( I+1, J )
                  WORK( I ) = BI - CX - DX - EX
                  RWORK( I ) = CABS1( BI ) +
     $                         CABS1( E( I-1 ) )*CABS1( X( I-1, J ) ) +
     $                         CABS1( DX ) + CABS1( E( I ) )*
     $                         CABS1( X( I+1, J ) )
   30          CONTINUE
               BI = B( N, J )
               CX = DCONJG( E( N-1 ) )*X( N-1, J )
               DX = D( N )*X( N, J )
               WORK( N ) = BI - CX - DX
               RWORK( N ) = CABS1( BI ) + CABS1( E( N-1 ) )*
     $                      CABS1( X( N-1, J ) ) + CABS1( DX )
            END IF
         ELSE
            IF( N.EQ.1 ) THEN
               BI = B( 1, J )
               DX = D( 1 )*X( 1, J )
               WORK( 1 ) = BI - DX
               RWORK( 1 ) = CABS1( BI ) + CABS1( DX )
            ELSE
               BI = B( 1, J )
               DX = D( 1 )*X( 1, J )
               EX = DCONJG( E( 1 ) )*X( 2, J )
               WORK( 1 ) = BI - DX - EX
               RWORK( 1 ) = CABS1( BI ) + CABS1( DX ) +
     $                      CABS1( E( 1 ) )*CABS1( X( 2, J ) )
               DO 40 I = 2, N - 1
                  BI = B( I, J )
                  CX = E( I-1 )*X( I-1, J )
                  DX = D( I )*X( I, J )
                  EX = DCONJG( E( I ) )*X( I+1, J )
                  WORK( I ) = BI - CX - DX - EX
                  RWORK( I ) = CABS1( BI ) +
     $                         CABS1( E( I-1 ) )*CABS1( X( I-1, J ) ) +
     $                         CABS1( DX ) + CABS1( E( I ) )*
     $                         CABS1( X( I+1, J ) )
   40          CONTINUE
               BI = B( N, J )
               CX = E( N-1 )*X( N-1, J )
               DX = D( N )*X( N, J )
               WORK( N ) = BI - CX - DX
               RWORK( N ) = CABS1( BI ) + CABS1( E( N-1 ) )*
     $                      CABS1( X( N-1, J ) ) + CABS1( DX )
            END IF
         END IF
*
*        Compute componentwise relative backward error from formula
*
*        max(i) ( abs(R(i)) / ( abs(A)*abs(X) + abs(B) )(i) )
*
*        where abs(Z) is the componentwise absolute value of the matrix
*        or vector Z.  If the i-th component of the denominator is less
*        than SAFE2, then SAFE1 is added to the i-th components of the
*        numerator and denominator before dividing.
*
         S = ZERO
         DO 50 I = 1, N
            IF( RWORK( I ).GT.SAFE2 ) THEN
               S = MAX( S, CABS1( WORK( I ) ) / RWORK( I ) )
            ELSE
               S = MAX( S, ( CABS1( WORK( I ) )+SAFE1 ) /
     $             ( RWORK( I )+SAFE1 ) )
            END IF
   50    CONTINUE
         BERR( J ) = S
*
*        Test stopping criterion. Continue iterating if
*           1) The residual BERR(J) is larger than machine epsilon, and
*           2) BERR(J) decreased by at least a factor of 2 during the
*              last iteration, and
*           3) At most ITMAX iterations tried.
*
         IF( BERR( J ).GT.EPS .AND. TWO*BERR( J ).LE.LSTRES .AND.
     $       COUNT.LE.ITMAX ) THEN
*
*           Update solution and try again.
*
            CALL ZPTTRS( UPLO, N, 1, DF, EF, WORK, N, INFO )
            CALL ZAXPY( N, DCMPLX( ONE ), WORK, 1, X( 1, J ), 1 )
            LSTRES = BERR( J )
            COUNT = COUNT + 1
            GO TO 20
         END IF
*
*        Bound error from formula
*
*        norm(X - XTRUE) / norm(X) .le. FERR =
*        norm( abs(inv(A))*
*           ( abs(R) + NZ*EPS*( abs(A)*abs(X)+abs(B) ))) / norm(X)
*
*        where
*          norm(Z) is the magnitude of the largest component of Z
*          inv(A) is the inverse of A
*          abs(Z) is the componentwise absolute value of the matrix or
*             vector Z
*          NZ is the maximum number of nonzeros in any row of A, plus 1
*          EPS is machine epsilon
*
*        The i-th component of abs(R)+NZ*EPS*(abs(A)*abs(X)+abs(B))
*        is incremented by SAFE1 if the i-th component of
*        abs(A)*abs(X) + abs(B) is less than SAFE2.
*
         DO 60 I = 1, N
            IF( RWORK( I ).GT.SAFE2 ) THEN
               RWORK( I ) = CABS1( WORK( I ) ) + NZ*EPS*RWORK( I )
            ELSE
               RWORK( I ) = CABS1( WORK( I ) ) + NZ*EPS*RWORK( I ) +
     $                      SAFE1
            END IF
   60    CONTINUE
         IX = IDAMAX( N, RWORK, 1 )
         FERR( J ) = RWORK( IX )
*
*        Estimate the norm of inv(A).
*
*        Solve M(A) * x = e, where M(A) = (m(i,j)) is given by
*
*           m(i,j) =  abs(A(i,j)), i = j,
*           m(i,j) = -abs(A(i,j)), i .ne. j,
*
*        and e = [ 1, 1, ..., 1 ]'.  Note M(A) = M(L)*D*M(L)'.
*
*        Solve M(L) * x = e.
*
         RWORK( 1 ) = ONE
         DO 70 I = 2, N
            RWORK( I ) = ONE + RWORK( I-1 )*ABS( EF( I-1 ) )
   70    CONTINUE
*
*        Solve D * M(L)' * x = b.
*
         RWORK( N ) = RWORK( N ) / DF( N )
         DO 80 I = N - 1, 1, -1
            RWORK( I ) = RWORK( I ) / DF( I ) +
     $                   RWORK( I+1 )*ABS( EF( I ) )
   80    CONTINUE
*
*        Compute norm(inv(A)) = max(x(i)), 1<=i<=n.
*
         IX = IDAMAX( N, RWORK, 1 )
         FERR( J ) = FERR( J )*ABS( RWORK( IX ) )
*
*        Normalize error.
*
         LSTRES = ZERO
         DO 90 I = 1, N
            LSTRES = MAX( LSTRES, ABS( X( I, J ) ) )
   90    CONTINUE
         IF( LSTRES.NE.ZERO )
     $      FERR( J ) = FERR( J ) / LSTRES
*
  100 CONTINUE
*
      RETURN
*
*     End of ZPTRFS
*
      END

C
C      $Id: pr04f.f,v 1.6 2010-03-15 22:49:24 haley Exp $
C
C***********************************************************************
C                                                                      *
C                Copyright (C)  1996                                   *
C        University Corporation for Atmospheric Research               *
C                All Rights Reserved                                   *
C                                                                      *
C***********************************************************************
C
C  File:       pr04f.f
C
C  Author:     David Brown (converted by Mary Haley)
C          National Center for Atmospheric Research
C          PO 3000, Boulder, Colorado
C
C  Date:       Fri Jun 28 11:06:23 MDT 1996
C
C  Description:    Demonstrates graphics primitives drawn in NDC and 
C                  and data space into an IrregularPlot (and therefore 
C                  using the IrregularTransformation).
C
      external NhlFAppClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFCairoWindowWorkstationClass
      external NhlFirregularPlotClass

      integer rlist,grlist
      integer appid,wid,canvas
      integer i 
      real plx(5),ply(5),pmx(4),pmy(4),pgx(4),pgy(4)
      real dpgx(7),dpgy(7)
      data plx/0.1,0.9,0.5,0.1,0./
      data ply/0.1,0.1,0.9,0.1,0./
      data pmx/0.05,0.95,0.5,0.5/
      data pmy/0.05,0.05,1.05,0.5/
      data pgx/0.2,0.8,0.5,0.2/
      data pgy/0.25,0.25,0.85,0.25/
      data dpgx/5.0,110.0,110.0,0.0,110.0,5.0,5.0/
      data dpgy/10.,10.,20.0,20.,110.,110.,10.0/
      character*7  wks_type
C
C Define the workstation type
C
      wks_type = "x11"

C
C Initialize the high level utility library
C
      call NhlFInitialize()
C
C Create an application context. Set the app dir to the current
C directory so the application looks for a resource file in the working
C directory. 
C
      call NhlFRLCreate(rlist,'SETRL')
      call NhlFRLCreate(grlist,'GETRL')

      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'pr04',NhlFappClass,
     1     0,rlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C  Create a meta file workstation.
C   
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'wkMetaName','./pr04f.ncgm',ierr)
      call NhlFCreate(wid,'pr04Work',NhlFncgmWorkstationClass,
     1    0,rlist,ierr)
    
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C  Create an X workstation.
C   
      call NhlFRLClear(rlist)
      call NhlFRLSetInteger(rlist,'wkPause','true',ierr)
      call NhlFCreate(wid,'pr04Work',
     1            NhlFCairoWindowWorkstationClass,
     1            appid,rlist,ierr)
    
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C  Create an older-style PS workstation.
C   
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'wkPSFileName','./pr04f.ps',ierr)
      call NhlFCreate(wid,'pr04Work',NhlFpsWorkstationClass,
     1    appid,rlist,ierr)

      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C  Create an older-style PDF workstation.
C   
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'wkPDFFileName','./pr04f.pdf',ierr)
      call NhlFCreate(wid,'pr04Work',NhlFpdfWorkstationClass,
     1    appid,rlist,ierr)

      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C  Create a cairo PS/PDF workstation.
C   
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
      call NhlFRLSetString(rlist,'wkFileName','./pr04f',ierr)
      call NhlFCreate(wid,'pr04Work',
     1    NhlFCairoPSpdfWorkstationClass,appid,rlist,ierr)

      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C  Create a cairo PNG workstation.
C   
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
      call NhlFRLSetString(rlist,'wkFileName','./pr04f',ierr)
      call NhlFCreate(wid,'pr04Work',
     1    NhlFCairoImageWorkstationClass,appid,rlist,ierr)

      endif    
C
C Create an IrregularPlot that covers the entire NDC space 
C to use as a drawing canvas
C
      call NhlFRLClear(rlist)
      call NhlFRLSetFloat(rlist,'vpXF',0.1,ierr)
      call NhlFRLSetFloat(rlist,'vpYF',0.9,ierr)
      call NhlFRLSetFloat(rlist,'vpWidthF',0.8,ierr)
      call NhlFRLSetFloat(rlist,'vpHeightF',0.8,ierr)
      call NhlFRLSetString(rlist,'pmTitleDisplayMode','always',ierr)
      call NhlFRLSetString(rlist,'tiMainString',
     +     'Irregular Plot with NDC Primitives',ierr)
      call NhlFCreate(canvas,'canvas',NhlFirregularPlotClass,wid,rlist,
     +     ierr)

      call NhlFDraw(canvas,ierr)
      call NhlFNDCPolyline(canvas,0,plx,ply,4,ierr)
      call NhlFNDCPolygon(canvas,0,pgx,pgy,4,ierr)
      call NhlFNDCPolymarker(canvas,0,pmx,pmy,4,ierr)
      call NhlFFrame(wid,ierr)

      do 20 i=1,4
         plx(i) = plx(i) * 100.0 + 50.
         ply(i) = ply(i) * 100.0 + 50.
         pgx(i) = pgx(i) * 100.0 + 50.
         pgy(i) = pgy(i) * 100.0 + 50.
         pmx(i) = pmx(i) * 100.0 + 50.
         pmy(i) = pmy(i) * 100.0 + 50.
 20   continue

      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'tiMainString',
     +     'Clipped Data Space Primitives',ierr)
      call NhlFSetValues(canvas,rlist,ierr)

      call NhlFDraw(canvas,ierr)
      call NhlFDataPolyline(canvas,0,plx,ply,4,ierr)
      call NhlFDataPolymarker(canvas,0,pmx,pmy,4,ierr)
      call NhlFDataPolygon(canvas,0,pgx,pgy,4,ierr)
      call NhlFFrame(wid,ierr)

      do 30 i=1,4
         plx(i) = plx(i) - 40.
         ply(i) = ply(i) - 40.
         pgx(i) = pgx(i) - 40.
         pgy(i) = pgy(i) - 40.
         pmx(i) = pmx(i) - 40.
         pmy(i) = pmy(i) - 40.
 30   continue

      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'tiMainString',
     +     'Data Space Primitives Repositioned',ierr)
      call NhlFSetValues(canvas,rlist,ierr)

      call NhlFDraw(canvas,ierr)
      call NhlFDataPolyline(canvas,0,plx,ply,4,ierr)
      call NhlFDataPolymarker(canvas,0,pmx,pmy,4,ierr)
      call NhlFDataPolygon(canvas,0,pgx,pgy,4,ierr)
      call NhlFFrame(wid,ierr)


      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'tiMainString',
     +     'A Diamond in Data Space',ierr)
      call NhlFSetValues(canvas,rlist,ierr)
      call NhlFDraw(canvas,ierr)
      plx(1) = 10.0
      plx(2) = 50.0
      plx(3) = 90.0
      plx(4) = 50.0
      plx(5) = 10.0
      ply(1) = 50.0
      ply(2) = 10.0
      ply(3) = 50.0
      ply(4) = 90.0
      ply(5) = 50.0
      call NhlFDataPolygon(canvas,0,plx,ply,4,ierr)
      plx(1) = 5.0
      plx(3) = 95.0
      plx(5) = 5.0
      ply(2) = 5.0
      ply(4) = 95.0
      call NhlFDataPolyline(canvas,0,plx,ply,5,ierr)
      call NhlFFrame(wid,ierr)

      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'tiMainString',
     +     'A Self-Intersecting Data Polygon',ierr)
      call NhlFSetValues(canvas,rlist,ierr)
      call NhlFDraw(canvas,ierr)
      call NhlFDataPolygon(canvas,0,dpgx,dpgy,7,ierr)
      call NhlFFrame(wid,ierr)

      call NhlFClose()
      stop
      end

C
C	$Id: g01diq.f,v 1.6 2008-07-27 00:21:05 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE G01DIQ
C
C  Workstation description table (WDT) inquiry.
C  (OPCODE -100 thru -199)
C
      include 'g01prm.h'
      include 'gksin.h'
      include 'g01wdt.h'
      include 'g01ins.h'
C
      INTEGER  ICODE
C
C
C  All defined WDT inquiry codes lie in range -11o thru -128.
C  Only -127 is legal for MO.  The rest are error 31 or 39,
C  except -125 and -126, which are undefined.  
C
      ICODE = ABS(MCODES) - 109
C
C      CODE -110 -111 -112 -113 -114 -115 -116 -117 -118 -119
      GOTO  ( 39,  39,  39,  39,  31,  39,  39,  39,  39,  39,
     +        39,  39,  39,  39,  39,   5,   5, 127,  31     )  ICODE
C      CODE -120 -121 -122 -123 -124 -125 -126 -127 -128
C
C  Fall through is undefined opcode.
C
    5 CONTINUE
      RERR = 320
      RETURN
C
C  Error 31, "SPECIFIED WORKSTATION IS OF CATEGORY MO".
C
   31 CONTINUE
      RERR = 31
      RETURN
C
C  Error 39, "SPECIFIED WORKSTATION IS NEITHER OF CATEGORY OUTPUT
C  NOR OF CATEGORY OUTIN".
C
   39 CONTINUE
      RERR = 39
      RETURN
C
C  Inquire workstation category.
C
  127 CONTINUE
      ID(2) = LWKCAT
C
      RETURN
      END

C NCLFORTSTART 
      SUBROUTINE BINDATAAVG(NZ,ZLON,ZLAT,Z,ZMSG,MLON,NLAT,GLON,GLAT 
     +                     ,GBINKNT,IOPT,IER)
      IMPLICIT NONE
c                                             ; INPUT
      INTEGER NLAT,MLON,NZ,IOPT,IER
      DOUBLE PRECISION ZLON(NZ),ZLAT(NZ),Z(NZ),ZMSG
      DOUBLE PRECISION GLON(MLON),GLAT(NLAT)
c                                             ; OUTPUT
      DOUBLE PRECISION GBINKNT(MLON,NLAT,2)
C NCLEND

c NCL:   function bin_avg(zlon[*],zlat[*],z[*], glon[*], glat[*], opt )

      INTEGER K,NL,ML,IFLAG
      DOUBLE PRECISION DLAT,DLON,DEPS,DLO,DHI
      DOUBLE PRECISION GLATBND1,GLATBND2
      DOUBLE PRECISION GLONBND1,GLONBND2

      IER  = 0
      DEPS = 0.0001          ! good enough

c                            ; monotonically {in/de}creasing
      DLAT = GLAT(2)-GLAT(1)
      IF (DLAT.GT.0.0D0) THEN
          IFLAG = 1
      ELSEIF (DLAT.LT.0.0D0) THEN
          IFLAG = -1
      ELSE
          IER = 1            ! 0 difference: FATAL            
      END IF
      DLAT = ABS(DLAT)
      DLO  = DLAT-DEPS
      DHI  = DLAT+DEPS

c                            check for equal lat spacing
      DO NL = 1,NLAT - 1
          IF (ABS(GLAT(NL+1)-GLAT(NL)).LT.DLO .OR. 
     +        ABS(GLAT(NL+1)-GLAT(NL)).GT.DHI) THEN
              IER = IER + 10
              GO TO 10
          END IF
      END DO
   10 CONTINUE
c                            check for equal lon spacing
      DLON = GLON(2)-GLON(1)
      DLON = ABS(DLON)
      DLO  = DLON-DEPS
      DHI  = DLON+DEPS
      IF (DLON.LE.0.0D0) THEN
          IER = 1
      END IF

      DO ML = 1,MLON - 1
          IF (ABS(GLON(ML+1)-GLON(ML)).LT.DLO .OR. 
     +        ABS(GLON(ML+1)-GLON(ML)).GT.DHI) THEN
              IER = IER + 100
              GO TO 20
          END IF
      END DO
   20 CONTINUE
c                            set all msg if error
      IF (IER.NE.0) THEN
          DO NL = 1,NLAT
              DO ML = 1,MLON
                  GBINKNT(ML,NL,1) = ZMSG
                  GBINKNT(ML,NL,2) = ZMSG
              END DO
          END DO
          RETURN
      END IF
c                            initialize
      DO NL = 1,NLAT
          DO ML = 1,MLON
              GBINKNT(ML,NL,1) = 0.0D0
              GBINKNT(ML,NL,2) = 0.0D0
          END DO
      END DO

      GLATBND1 = MIN(GLAT(1),GLAT(NLAT)) - DLAT/2
      GLATBND2 = MAX(GLAT(1),GLAT(NLAT)) + DLAT/2
      GLONBND1 = GLON(1)    - DLON/2
      GLONBND2 = GLON(MLON) + DLON/2

      DO K = 1,NZ
          IF (Z(K).NE.ZMSG .AND.
     +       (ZLAT(K).GE.GLATBND1 .AND. ZLAT(K).LE.GLATBND2)  .AND.
     +       (ZLON(K).GE.GLONBND1 .AND. ZLON(K).LE.GLONBND2)) THEN
              ML = ABS((ZLON(K)-GLONBND1)/DLON) + 1
              NL = ABS((ZLAT(K)-GLATBND1)/DLAT) + 1
              IF (IFLAG.EQ.-1) NL = NLAT-NL+1
c c c         IF (NL.GT.0 .AND. NL.LE.NLAT .AND. ML.GT.0 .AND.
c c c             ML.LE.MLON) THEN
                  GBINKNT(ML,NL,1) = GBINKNT(ML,NL,1) + Z(K)
                  GBINKNT(ML,NL,2) = GBINKNT(ML,NL,2) + 1
c c c         END IF
          END IF
      END DO
c                                     compute bin average
      DO NL = 1,NLAT
          DO ML = 1,MLON
              IF (GBINKNT(ML,NL,2).GT.0.0D0) THEN
                  GBINKNT(ML,NL,1) = GBINKNT(ML,NL,1)/GBINKNT(ML,NL,2)
              ELSE
                  GBINKNT(ML,NL,1) = ZMSG
              END IF
          END DO
      END DO

      RETURN
      END

      SUBROUTINE SLAR1V( N, B1, BN, SIGMA, D, L, LD, LLD, GERSCH, Z,
     $                   ZTZ, MINGMA, R, ISUPPZ, WORK )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      INTEGER            B1, BN, N, R
      REAL               MINGMA, SIGMA, ZTZ
*     ..
*     .. Array Arguments ..
      INTEGER            ISUPPZ( * )
      REAL               D( * ), GERSCH( * ), L( * ), LD( * ), LLD( * ),
     $                   WORK( * ), Z( * )
*     ..
*
*  Purpose
*  =======
*
*  SLAR1V computes the (scaled) r-th column of the inverse of
*  the sumbmatrix in rows B1 through BN of the tridiagonal matrix
*  L D L^T - sigma I. The following steps accomplish this computation :
*  (a) Stationary qd transform,  L D L^T - sigma I = L(+) D(+) L(+)^T,
*  (b) Progressive qd transform, L D L^T - sigma I = U(-) D(-) U(-)^T,
*  (c) Computation of the diagonal elements of the inverse of
*      L D L^T - sigma I by combining the above transforms, and choosing
*      r as the index where the diagonal of the inverse is (one of the)
*      largest in magnitude.
*  (d) Computation of the (scaled) r-th column of the inverse using the
*      twisted factorization obtained by combining the top part of the
*      the stationary and the bottom part of the progressive transform.
*
*  Arguments
*  =========
*
*  N        (input) INTEGER
*           The order of the matrix L D L^T.
*
*  B1       (input) INTEGER
*           First index of the submatrix of L D L^T.
*
*  BN       (input) INTEGER
*           Last index of the submatrix of L D L^T.
*
*  SIGMA    (input) REAL
*           The shift. Initially, when R = 0, SIGMA should be a good
*           approximation to an eigenvalue of L D L^T.
*
*  L        (input) REAL array, dimension (N-1)
*           The (n-1) subdiagonal elements of the unit bidiagonal matrix
*           L, in elements 1 to N-1.
*
*  D        (input) REAL array, dimension (N)
*           The n diagonal elements of the diagonal matrix D.
*
*  LD       (input) REAL array, dimension (N-1)
*           The n-1 elements L(i)*D(i).
*
*  LLD      (input) REAL array, dimension (N-1)
*           The n-1 elements L(i)*L(i)*D(i).
*
*  GERSCH   (input) REAL array, dimension (2*N)
*           The n Gerschgorin intervals. These are used to restrict
*           the initial search for R, when R is input as 0.
*
*  Z        (output) REAL array, dimension (N)
*           The (scaled) r-th column of the inverse. Z(R) is returned
*           to be 1.
*
*  ZTZ      (output) REAL
*           The square of the norm of Z.
*
*  MINGMA   (output) REAL
*           The reciprocal of the largest (in magnitude) diagonal
*           element of the inverse of L D L^T - sigma I.
*
*  R        (input/output) INTEGER
*           Initially, R should be input to be 0 and is then output as
*           the index where the diagonal element of the inverse is
*           largest in magnitude. In later iterations, this same value
*           of R should be input.
*
*  ISUPPZ   (output) INTEGER array, dimension (2)
*           The support of the vector in Z, i.e., the vector Z is
*           nonzero only in elements ISUPPZ(1) through ISUPPZ( 2 ).
*
*  WORK     (workspace) REAL array, dimension (4*N)
*
*  Further Details
*  ===============
*
*  Based on contributions by
*     Inderjit Dhillon, IBM Almaden, USA
*     Osni Marques, LBNL/NERSC, USA
*
*  =====================================================================
*
*     .. Parameters ..
      INTEGER            BLKSIZ
      PARAMETER          ( BLKSIZ = 32 )
      REAL               ZERO, ONE
      PARAMETER          ( ZERO = 0.0E0, ONE = 1.0E0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            SAWNAN
      INTEGER            FROM, I, INDP, INDS, INDUMN, J, R1, R2, TO
      REAL               DMINUS, DPLUS, EPS, S, TMP
*     ..
*     .. External Functions ..
      REAL               SLAMCH
      EXTERNAL           SLAMCH
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, MAX, MIN
*     ..
*     .. Executable Statements ..
*
      EPS = SLAMCH( 'Precision' )
      IF( R.EQ.0 ) THEN
*
*        Eliminate the top and bottom indices from the possible values
*        of R where the desired eigenvector is largest in magnitude.
*
         R1 = B1
         DO 10 I = B1, BN
            IF( SIGMA.GE.GERSCH( 2*I-1 ) .OR. SIGMA.LE.GERSCH( 2*I ) )
     $           THEN
               R1 = I
               GO TO 20
            END IF
   10    CONTINUE
   20    CONTINUE
         R2 = BN
         DO 30 I = BN, B1, -1
            IF( SIGMA.GE.GERSCH( 2*I-1 ) .OR. SIGMA.LE.GERSCH( 2*I ) )
     $           THEN
               R2 = I
               GO TO 40
            END IF
   30    CONTINUE
   40    CONTINUE
      ELSE
         R1 = R
         R2 = R
      END IF
*
      INDUMN = N
      INDS = 2*N + 1
      INDP = 3*N + 1
      SAWNAN = .FALSE.
*
*     Compute the stationary transform (using the differential form)
*     untill the index R2
*
      IF( B1.EQ.1 ) THEN
         WORK( INDS ) = ZERO
      ELSE
         WORK( INDS ) = LLD( B1-1 )
      END IF
      S = WORK( INDS ) - SIGMA
      DO 50 I = B1, R2 - 1
         DPLUS = D( I ) + S
         WORK( I ) = LD( I ) / DPLUS
         WORK( INDS+I ) = S*WORK( I )*L( I )
         S = WORK( INDS+I ) - SIGMA
   50 CONTINUE
*
      IF( .NOT.( S.GT.ZERO .OR. S.LT.ONE ) ) THEN
*
*        Run a slower version of the above loop if a NaN is detected
*
         SAWNAN = .TRUE.
         J = B1 + 1
   60    CONTINUE
         IF( WORK( INDS+J ).GT.ZERO .OR. WORK( INDS+J ).LT.ONE ) THEN
            J = J + 1
            GO TO 60
         END IF
         WORK( INDS+J ) = LLD( J )
         S = WORK( INDS+J ) - SIGMA
         DO 70 I = J + 1, R2 - 1
            DPLUS = D( I ) + S
            WORK( I ) = LD( I ) / DPLUS
            IF( WORK( I ).EQ.ZERO ) THEN
               WORK( INDS+I ) = LLD( I )
            ELSE
               WORK( INDS+I ) = S*WORK( I )*L( I )
            END IF
            S = WORK( INDS+I ) - SIGMA
   70    CONTINUE
      END IF
      WORK( INDP+BN-1 ) = D( BN ) - SIGMA
      DO 80 I = BN - 1, R1, -1
         DMINUS = LLD( I ) + WORK( INDP+I )
         TMP = D( I ) / DMINUS
         WORK( INDUMN+I ) = L( I )*TMP
         WORK( INDP+I-1 ) = WORK( INDP+I )*TMP - SIGMA
   80 CONTINUE
      TMP = WORK( INDP+R1-1 )
      IF( .NOT.( TMP.GT.ZERO .OR. TMP.LT.ONE ) ) THEN
*
*        Run a slower version of the above loop if a NaN is detected
*
         SAWNAN = .TRUE.
         J = BN - 3
   90    CONTINUE
         IF( WORK( INDP+J ).GT.ZERO .OR. WORK( INDP+J ).LT.ONE ) THEN
            J = J - 1
            GO TO 90
         END IF
         WORK( INDP+J ) = D( J+1 ) - SIGMA
         DO 100 I = J, R1, -1
            DMINUS = LLD( I ) + WORK( INDP+I )
            TMP = D( I ) / DMINUS
            WORK( INDUMN+I ) = L( I )*TMP
            IF( TMP.EQ.ZERO ) THEN
               WORK( INDP+I-1 ) = D( I ) - SIGMA
            ELSE
               WORK( INDP+I-1 ) = WORK( INDP+I )*TMP - SIGMA
            END IF
  100    CONTINUE
      END IF
*
*     Find the index (from R1 to R2) of the largest (in magnitude)
*     diagonal element of the inverse
*
      MINGMA = WORK( INDS+R1-1 ) + WORK( INDP+R1-1 )
      IF( MINGMA.EQ.ZERO )
     $   MINGMA = EPS*WORK( INDS+R1-1 )
      R = R1
      DO 110 I = R1, R2 - 1
         TMP = WORK( INDS+I ) + WORK( INDP+I )
         IF( TMP.EQ.ZERO )
     $      TMP = EPS*WORK( INDS+I )
         IF( ABS( TMP ).LT.ABS( MINGMA ) ) THEN
            MINGMA = TMP
            R = I + 1
         END IF
  110 CONTINUE
*
*     Compute the (scaled) r-th column of the inverse
*
      ISUPPZ( 1 ) = B1
      ISUPPZ( 2 ) = BN
      Z( R ) = ONE
      ZTZ = ONE
      IF( .NOT.SAWNAN ) THEN
         FROM = R - 1
         TO = MAX( R-BLKSIZ, B1 )
  120    CONTINUE
         IF( FROM.GE.B1 ) THEN
            DO 130 I = FROM, TO, -1
               Z( I ) = -( WORK( I )*Z( I+1 ) )
               ZTZ = ZTZ + Z( I )*Z( I )
  130       CONTINUE
            IF( ABS( Z( TO ) ).LE.EPS .AND. ABS( Z( TO+1 ) ).LE.EPS )
     $           THEN
               ISUPPZ( 1 ) = TO + 2
            ELSE
               FROM = TO - 1
               TO = MAX( TO-BLKSIZ, B1 )
               GO TO 120
            END IF
         END IF
         FROM = R + 1
         TO = MIN( R+BLKSIZ, BN )
  140    CONTINUE
         IF( FROM.LE.BN ) THEN
            DO 150 I = FROM, TO
               Z( I ) = -( WORK( INDUMN+I-1 )*Z( I-1 ) )
               ZTZ = ZTZ + Z( I )*Z( I )
  150       CONTINUE
            IF( ABS( Z( TO ) ).LE.EPS .AND. ABS( Z( TO-1 ) ).LE.EPS )
     $           THEN
               ISUPPZ( 2 ) = TO - 2
            ELSE
               FROM = TO + 1
               TO = MIN( TO+BLKSIZ, BN )
               GO TO 140
            END IF
         END IF
      ELSE
         DO 160 I = R - 1, B1, -1
            IF( Z( I+1 ).EQ.ZERO ) THEN
               Z( I ) = -( LD( I+1 ) / LD( I ) )*Z( I+2 )
            ELSE IF( ABS( Z( I+1 ) ).LE.EPS .AND. ABS( Z( I+2 ) ).LE.
     $               EPS ) THEN
               ISUPPZ( 1 ) = I + 3
               GO TO 170
            ELSE
               Z( I ) = -( WORK( I )*Z( I+1 ) )
            END IF
            ZTZ = ZTZ + Z( I )*Z( I )
  160    CONTINUE
  170    CONTINUE
         DO 180 I = R, BN - 1
            IF( Z( I ).EQ.ZERO ) THEN
               Z( I+1 ) = -( LD( I-1 ) / LD( I ) )*Z( I-1 )
            ELSE IF( ABS( Z( I ) ).LE.EPS .AND. ABS( Z( I-1 ) ).LE.EPS )
     $                THEN
               ISUPPZ( 2 ) = I - 2
               GO TO 190
            ELSE
               Z( I+1 ) = -( WORK( INDUMN+I )*Z( I ) )
            END IF
            ZTZ = ZTZ + Z( I+1 )*Z( I+1 )
  180    CONTINUE
  190    CONTINUE
      END IF
      DO 200 I = B1, ISUPPZ( 1 ) - 3
         Z( I ) = ZERO
  200 CONTINUE
      DO 210 I = ISUPPZ( 2 ) + 3, BN
         Z( I ) = ZERO
  210 CONTINUE
*
      RETURN
*
*     End of SLAR1V
*
      END

C
C	$Id: lined.f,v 1.4 2008-07-27 00:23:03 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE LINED (XA,YA,XB,YB)
C USER ENTRY POINT.
C
      DATA IDUMMY /0/
      CALL FL2INT (XA,YA,IXA,IYA)
      CALL FL2INT (XB,YB,IXB,IYB)
C
      CALL CFVLD (1,IXA,IYA)
      CALL CFVLD (2,IXB,IYB)
      CALL CFVLD (3,IDUMMY,IDUMMY)
C
      RETURN
C
C------REVISION HISTORY
C
C JUNE 1984          CONVERTED TO FORTRAN77 AND GKS
C
C DECEMBER 1979      ADDED REVISION HISTORY AND STATISTICS
C                    CALL
C
C JUNE 1988          CHANGED THE NAME OF A COMMON BLOCK TO GET RID OF A
C                    WARNING FROM SEGLDR.  (DJK)
C
C NOVEMBER 1988      REMOVED KURV1S AND KURV2S.  IMPLEMENTED CALLS TO
C                    MSKRV1 AND MSKRV2 INSTEAD.
C
C-----------------------------------------------------------------------
C
      END

      PROGRAM NNEX08
C
      PARAMETER(ISLIM = 11, NUMXOUT = 26, NUMYOUT = 26)
C
      REAL X(ISLIM), Y(ISLIM), Z(ISLIM)
      REAL XI(NUMXOUT), YI(NUMYOUT), ZI(NUMXOUT,NUMYOUT)
C
      DATA X/0.00,0.15,0.10,0.35,0.50,0.55,0.55,0.65,0.85,0.80,1.00/
      DATA Y/0.50,0.80,0.30,0.60,0.35,1.00,0.00,0.55,0.80,0.25,0.45/
C
      DO 130 I=1,ISLIM
          Z(I) = (X(I)-0.25)**2 + (Y(I)-0.50)**2
  130 CONTINUE
C
      XINC = 1./(NUMXOUT-1.) 
      DO 20 I=1,NUMXOUT
        XI(I) = REAL(I-1) * XINC
   20 CONTINUE
C
      YINC = 1./(NUMYOUT-1.)
      DO 30 J=1,NUMYOUT
        YI(J) = REAL(J-1) * YINC
   30 CONTINUE 
C
      CALL NNSETI('ADF',1)
      CALL NNSETC('ALG','example8.dat')
      CALL NNSETI('IGR',0)
      CALL NATGRIDS(ISLIM,X,Y,Z,NUMXOUT,NUMYOUT,XI,YI,ZI,IER)
C 
      STOP
      END

C
C $Id: WORKSPACEF.f,v 1.1 2001-10-09 00:18:37 haley Exp $
C
C****************************************************************
C                                                               *
C                       Copyright (C)  1994                     *
C       University Corporation for Atmospheric Research         *
C                       All Rights Reserved                     *
C                                                               *
C****************************************************************
C
C      File:            WORKSPACE.f
C
C      Author:          Jeff W. Boote
C                       National Center for Atmospheric Research
C                       PO 3000, Boulder, Colorado
C
C      Date:            Fri Apr 15 16:55:57 MDT 1994
C
C      Description:     
C
      subroutine nhlfgetworkspaceobjectid(id)
        integer id

        call nhlpfgetworkspaceobjectid(id)
      end

      PROGRAM PGKEX07
C
C  Illustrate polymarkers.

C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER (ID=50)
      DIMENSION XM1(ID),YM1(ID),XM2(ID),YM2(ID),XM3(ID),YM3(ID)
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF,IDUM)
      CALL GOPWK (IWKID,LUNIT,IWTYPE)
      CALL GACWK (IWKID)
C
C  Define colors.
C
      CALL GSCR(IWKID,0, 1.0, 1.0, 1.0)
      CALL GSCR(IWKID,1, 0.0, 0.0, 0.0)
      CALL GSCR(IWKID,2, 1.0, 0.0, 0.0)
      CALL GSCR(IWKID,3, 0.0, 0.0, 1.0)
      CALL GSCR(IWKID,4, 0.0, 1.0, 0.0)
      CALL GSCR(IWKID,5, 0.4, 0.0, 0.4)
      CALL GSCR(IWKID,6, 1.0, 0.0, 0.0)
C
C  Marker 1, dot (fill a large circular dot with markers of type 1).
C
C
C   Position and radius of the dot outline.
C
      X0 = .5
      Y0 = .7
      R  = .08
      JL = 17
      AINC = R/REAL(JL)
      CALL GSMK(1)
      DO 10 J=0,JL
      Y = Y0+REAL(J)*AINC
      XE = X0+SQRT(MAX(R**2-(Y-Y0)**2,0.))
      X = X0
   20 CONTINUE
C
C   Fill the circle with dot markers using symmetries.
C	
      CALL GPM(1,X,Y)
      CALL GSPMCI(1)
      CALL GPM(1,X,2*Y0-Y)
      CALL GPM(1,2*X0-X,2*Y0-Y)
      CALL GPM(1,2*X0-X,Y)
      X = X+AINC
      IF (X .GT. XE) GO TO 10
      GO TO 20
   10 CONTINUE
C
C   Label the dot.
C
      CALL PCSETI('FN',21)
      CALL PCSETI('CC',5)
      CALL PLCHHQ(X0,Y0+R+.05,'Marker 1 (dot)',.022,0.,0.)
C
C  Marker 2, plus (make a plus from the plus markers.)
C
C
C   Center of big plus.
C
      X0 = .83
      Y0 = .5
      R  = .1
      JL = 7
      AINC = R/REAL(JL)
      DO 30 J=-JL,JL,1
      Y = Y0+REAL(J)*AINC
      IDX = J+JL+1
      XM1(IDX) = X0
      YM1(IDX) = Y
      X = X0+REAL(J)*AINC
      XM2(IDX) = X
      YM2(IDX) = Y0
   30 CONTINUE
      CALL GSMK(2)
      CALL GSPMCI(3)
C
C  Put plus markers along the two axes of the big plus.
C
      CALL GPM(2*JL+1,XM1,YM1)
      CALL GPM(2*JL+1,XM2,YM2)
C
C   Label the big plus.
C
      CALL PCSETI('FN',21)
      CALL PCSETI('CC',5)
      CALL PLCHHQ(X0,Y0+R+.05,'Marker 2 (plus)',.022,0.,0.)
C
C  Marker 3, asterisk (make an asterisk from the asterisk markers.)
C
      X0 = .7
      Y0 = .15
      R  = .1
      JL = 5
      AINC = R/REAL(JL)
      DO 40 J=-JL,JL,1
      Y = Y0+REAL(J)*AINC
      IDX = J+JL+1
      XM1(IDX) = X0
      YM1(IDX) = Y
      P = 0.5*SQRT(2.)*(Y-Y0)
      IF (Y .GE. 0.) THEN
        XM2(IDX) = X0+P
        YM2(IDX) = Y0+P
        XM3(IDX) = X0-P
        YM3(IDX) = Y0+P
      ELSE
        XM2(IDX) = X0-P
        YM2(IDX) = Y0-P
        XM3(IDX) = X0+P
        YM3(IDX) = Y0-P
      ENDIF
   40 CONTINUE
      CALL GSMK(3)
      CALL GSPMCI(4)
C
c Put asterisk markers along the axes of the big asterisk.
C
      CALL GPM(2*JL+1,XM1,YM1)
      CALL GPM(2*JL+1,XM2,YM2)
      CALL GPM(2*JL+1,XM3,YM3)
C
C   Label the big asterisk.
C
      CALL PCSETI('FN',21)
      CALL PCSETI('CC',5)
      CALL PLCHHQ(X0,Y0+R+.05,'Marker 3 (asterisk)',.022,0.,0.)
C
C  Marker 4, circle (make a big circle from the circle markers.)
C
      X0 = .3
      Y0 = .15
      R  = .1
      JL = 50
      RADINC = 2.*3.1415926/REAL(JL)
      DO 50 J=1,JL
      X = X0+R*COS(REAL(J)*RADINC)
      Y = Y0+R*SIN(REAL(J)*RADINC)
      XM1(J) = X
      YM1(J) = Y
   50 CONTINUE
      CALL GSMK(4)
      CALL GSPMCI(1)
      CALL GPM(JL,XM1,YM1)
C
C   Label the big circle.
C
      CALL PCSETI('FN',21)
      CALL PCSETI('CC',5)
      CALL PLCHHQ(X0,Y0+R+.05,'Marker 4 (circle)',.022,0.,0.)
C
C  Marker 5, cross (make a big cross from the cross markers.)
C
      X0 = .17
      Y0 = .5
      R  = .1
      JL = 5
      AINC = R/REAL(JL)
      DO 60 J=-JL,JL,1
      Y = Y0+REAL(J)*AINC
      IDX = J+JL+1
      P = 0.5*SQRT(2.)*(Y-Y0)
      IF (Y .GE. 0.) THEN
        XM2(IDX) = X0+P
        YM2(IDX) = Y0+P
        XM3(IDX) = X0-P
        YM3(IDX) = Y0+P
      ELSE
        XM2(IDX) = X0-P
        YM2(IDX) = Y0-P
        XM3(IDX) = X0+P
        YM3(IDX) = Y0-P
      ENDIF
   60 CONTINUE
      CALL GSMK(5)
      CALL GSPMCI(6)
C
C  Plot cross markers along the axes of the big cross.
C
      CALL GPM(2*JL+1,XM2,YM2)
      CALL GPM(2*JL+1,XM3,YM3)
C
C   Label the big cross.
C
      CALL PCSETI('FN',21)
      CALL PCSETI('CC',5)
      CALL PLCHHQ(X0,Y0+R+.05,'Marker 5 (cross)',.022,0.,0.)
C
C  Draw a big circle in the center by applying a large marker size
C  scale factor to the circle marker.
C
      X0 = .5
      Y0 = .46
      CALL GSMK(4)
      CALL GSPMCI(1)
      CALL GSMKSC(15.)
      CALL GPM(1,X0,Y0)
C
      CALL PCSETI('FN',21)
      CALL PCSETI('CC',5)
      CALL PLCHHQ(X0,Y0+.035,'Circle',.021,0.,0.)
      CALL PLCHHQ(X0,Y0     ,'Scaled',.021,0.,0.)
      CALL PLCHHQ(X0,Y0-.035,'by 15.',.021,0.,0.)
C
C  Label the plot using Plotchar.
C
      CALL PCSETI('FN',25)
      CALL PCSETI('CC',5)
      CALL PLCHHQ(.5,.915,'Polymarkers',.035,0.,0.)
C
      CALL FRAME
C
C  Deactivate and close the workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END

C
C $Id: pccffc.f,v 1.13 2008-07-27 00:17:19 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE PCCFFC (IPSS,IBNU,NFNT,IASC,CHGT,RDGU,LDGU,NDGU)
C
      DIMENSION RDGU(LDGU)
C
C The subroutine PCCFFC retrieves the digitization of a specified
C character from one of the locally-defined NCAR Graphics fontcaps.
C
C IPSS is the number of the pass being executed by PLCHHQ.
C
C IBNU is the number of a unit to be used in reading the fontcaps.
C
C NFNT is the number of the desired font.
C
C IASC is the ASCII index of the desired character.
C
C CHGT is the desired height of the character, in digitization units.
C
C RDGU is a real array in which the digitization is to be returned.
C
C LDGU is the length of RDGU.
C
C NDGU is the number of elements returned in RDGU.
C
C The digitization is to be in the form expected by PLCHHQ, in a
C coordinate system centered at the center of the character.  RDGU(1)
C must be a negative number whose magnitude is the distance from the
C center of the character to its left edge.  RDGU(2) must be a positive
C number whose magnitude is the distance from the center of the
C character to its right edge.  (RDGU(3),RDGU(4)) is the first point,
C (RDGU(5),RDGU(6)) the second point, etc.  (-2048.,-2048.) is used
C to represent a position in the coordinate string at which the "pen"
C is to be picked up and moved.
C
C Define the quantities required to read and work with the fontcaps.
C These definitions are essentially copied from the translator.
C
      COMMON /CAPFNT/ CHRSTR,CHREND,CHRWDT,CHRSCH,FNTRHT,FNTTOP,FNTCAP,
     +                FNTHLF,FNTBAS,FNTBOT,FNTTYP,FNTSCH,CORXST,CORXLN,
     +                CORYST,CORYLN,CORPST,CORPLN,PBEGST,PBEGLN,PENDST,
     +                PENDLN,CORSCH,NEWCLS,CPNTRS,CPNLST,CSTRKS,
     +                XLFT,XRGT,XCNT
      SAVE  /CAPFNT/
C
      INTEGER         CHRSTR,CHREND,CHRWDT,CHRSCH(11),FNTRHT,FNTTOP,
     +                FNTCAP,FNTHLF,FNTBAS,FNTBOT,FNTTYP,FNTSCH(9),
     +                CORXST,CORXLN,CORYST,CORYLN,CORPST,CORPLN,PBEGST,
     +                PBEGLN,PENDST,PENDLN,CORSCH(10),NEWCLS(300),
     +                CPNTRS(128),CPNLST,CSTRKS(5121)
C
      DIMENSION IFCP(5600)
      EQUIVALENCE (CHRSTR,IFCP(1))
C
      DIMENSION       XLFT(128),XRGT(128),XCNT(128)
C
C The variable NFRL, if non-zero, defines the number of the font read
C last.  Some other quantities need to be saved from call to call, as
C well.
C
      SAVE NFRL,LSHX,LSHY,LSHP,MSKX,MSKY,MSKP,FDGE
C
C NFRL starts off zeroed.
C
      DATA NFRL / 0 /
C
C Zero the count of digitization elements returned.
C
      NDGU=0
C
C If the desired font is not the one read last, read it.  If there is
C any problem with reading it, just return with NDGU zeroed to indicate
C that the desired character was not available.
C
      IF (NFRL.NE.NFNT) THEN
C
C Open the fontcap file.
C
        IBNS=IBNU
        CALL PCFOPN (IBNU,NFNT)
        IF (ICFELL('PCCFFC',1).NE.0) RETURN
C
C Read the fontcap.
C
        CALL PCFRED (IBNU,NFNT,IFCP,5600)
        IF (ICFELL('PCCFFC',2).NE.0) RETURN
C
C Close the fontcap file.
C
        CALL PCFCLS (IBNU,NFNT)
        IF (ICFELL('PCCFFC',3).NE.0) RETURN
        IBNU=IBNS
C
C Compute quantities needed to unpack X and Y coordinates and pen
C up/down indicators.
C
        LSHX=CORXLN-CORXST-1
        LSHY=CORYLN-CORYST-1
        LSHP=CORPLN-CORPST-1
        MSKX=2**CORXLN-1
        MSKY=2**CORYLN-1
        MSKP=2**CORPLN-1
C
C Calculate the character left (in font units) and the character right
C (in font units) for each character in the font.
C
        DO 101 I=1,128
          XLFT(I)=0.
          XRGT(I)=0.
          XCNT(I)=0.
  101   CONTINUE
C
        DO 102 I=CHRSTR,CHREND
          INDX=I-CHRSTR+1
          IPNT=CPNTRS(INDX)
          IF (IPNT.GT.0) THEN
            IF (FNTTYP.EQ.1.OR.FNTTYP.EQ.3) THEN
              XLFT(INDX)=REAL(IAND(ISHIFT(CSTRKS(IPNT),LSHX),MSKX))
              XRGT(INDX)=REAL(IAND(ISHIFT(CSTRKS(IPNT),LSHY),MSKY))
            ELSE IF (FNTTYP.EQ.0.OR.FNTTYP.EQ.2) THEN
              XLFT(INDX)=0.
              XRGT(INDX)=REAL(CHRWDT)
            END IF
            XCNT(INDX)=999999.
          END IF
  102   CONTINUE
C
C Set a fudge factor which will make fonts 1-20 work better with the
C PWRITX characters.
C
        IF (NFNT.GE.1.AND.NFNT.LE.20) THEN
          FDGE=.5
        ELSE
          FDGE=0.
        END IF
C
C Set the variable NFRL to reflect the number of the font last read.
C
        NFRL=NFNT
C
      END IF
C
C Now that the proper font has been read in, return the digitization of
C the desired character.
C
      IF (IASC.GE.CHRSTR.AND.IASC.LE.CHREND) THEN
C
        INDX=IASC-CHRSTR+1
C
C Calculate the start pointer for the character digitization (add 1
C to skip over character left and character right information for
C proportionally spaced fonts).
C
        IF (FNTTYP.EQ.0.OR.FNTTYP.EQ.2) THEN
          ICST=CPNTRS(INDX)
        ELSE IF (FNTTYP.EQ.1.OR.FNTTYP.EQ.3) THEN
          ICST=CPNTRS(INDX)+1
        END IF
C
        IF (ICST.GT.0) THEN
C
C Calculate the end pointer for the digitization.
C
          IF (INDX.EQ.CHREND-CHRSTR+1) THEN
            ICND=CPNLST
          ELSE
            ICND=CPNTRS(INDX+1)-1
          END IF
C
          IF (ICND.GT.ICST) THEN
C
C If it hasn't already been done for this character, find the range of
C X coordinates used in the digitization and use the midpoint of that
C range as the horizontal center of the character.
C
            IF (XCNT(INDX).EQ.999999.) THEN
              IXMN=IAND(ISHIFT(CSTRKS(ICST),LSHX),MSKX)
              IXMX=IXMN
              DO 103 I=ICST+1,ICND
                IXCD=IAND(ISHIFT(CSTRKS(I),LSHX),MSKX)
                IXMN=MIN(IXMN,IXCD)
                IXMX=MAX(IXMX,IXCD)
  103         CONTINUE
              XCNT(INDX)=.5*REAL(IXMN+IXMX)
            END IF
C
C Compute multipliers required to give the character the proper size
C and shape.
C
            HMUL=CHGT/REAL(FNTCAP-FNTBAS)
            WMUL=HMUL
C
C Compute the required offsets to the left and right edges.
C
            RDGU(1)=WMUL*(XLFT(INDX)-XCNT(INDX))
            RDGU(2)=WMUL*(XRGT(INDX)-XCNT(INDX))
            NDGU=2
C
C During pass 1, that's all that's required.
C
            IF (IPSS.EQ.1) RETURN
C
C Extract the digitization and put it in the expected form.
C
            DO 104 I=ICST,ICND
              IXCD=IAND(ISHIFT(CSTRKS(I),LSHX),MSKX)
              IYCD=IAND(ISHIFT(CSTRKS(I),LSHY),MSKY)
              IPEN=IAND(ISHIFT(CSTRKS(I),LSHP),MSKP)
              IF (IPEN.EQ.0.AND.NDGU.NE.2) THEN
                IF (NDGU.GE.LDGU) RETURN
                NDGU=NDGU+1
                RDGU(NDGU)=-2048.
                NDGU=NDGU+1
                RDGU(NDGU)=0.
              END IF
              IF (NDGU.GE.LDGU) RETURN
              NDGU=NDGU+1
              RDGU(NDGU)=WMUL*(REAL(IXCD)-XCNT(INDX))
              NDGU=NDGU+1
              RDGU(NDGU)=HMUL*(REAL(IYCD-FNTHLF)-FDGE)
  104       CONTINUE
C
            IF (NDGU.GE.LDGU) RETURN
            NDGU=NDGU+1
            RDGU(NDGU)=-2048.
            NDGU=NDGU+1
            RDGU(NDGU)=0.
C
          END IF
C
        END IF
C
      END IF
C
C Done.
C
      RETURN
C
      END

      SUBROUTINE SLARRF( N, D, L, LD, LLD, IFIRST, ILAST, W, DPLUS,
     $                   LPLUS, WORK, IWORK, INFO )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      INTEGER            IFIRST, ILAST, INFO, N
*     ..
*     .. Array Arguments ..
      INTEGER            IWORK( * )
      REAL               D( * ), DPLUS( * ), L( * ), LD( * ), LLD( * ),
     $                   LPLUS( * ), W( * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  Given the initial representation L D L^T and its cluster of close
*  eigenvalues (in a relative measure), W( IFIRST ), W( IFIRST+1 ), ...
*  W( ILAST ), SLARRF finds a new relatively robust representation
*  L D L^T - SIGMA I = L(+) D(+) L(+)^T such that at least one of the
*  eigenvalues of L(+) D(+) L(+)^T is relatively isolated.
*
*  Arguments
*  =========
*
*  N       (input) INTEGER
*          The order of the matrix.
*
*  D       (input) REAL array, dimension (N)
*          The n diagonal elements of the diagonal matrix D.
*
*  L       (input) REAL array, dimension (N-1)
*          The (n-1) subdiagonal elements of the unit bidiagonal
*          matrix L.
*
*  LD      (input) REAL array, dimension (N-1)
*          The n-1 elements L(i)*D(i).
*
*  LLD     (input) REAL array, dimension (N-1)
*          The n-1 elements L(i)*L(i)*D(i).
*
*  IFIRST  (input) INTEGER
*          The index of the first eigenvalue in the cluster.
*
*  ILAST   (input) INTEGER
*          The index of the last eigenvalue in the cluster.
*
*  W       (input/output) REAL array, dimension (N)
*          On input, the eigenvalues of L D L^T in ascending order.
*          W( IFIRST ) through W( ILAST ) form the cluster of relatively
*          close eigenalues.
*          On output, W( IFIRST ) thru' W( ILAST ) are estimates of the
*          corresponding eigenvalues of L(+) D(+) L(+)^T.
*
*  SIGMA   (input) REAL
*          The shift used to form L(+) D(+) L(+)^T.
*
*  DPLUS   (output) REAL array, dimension (N)
*          The n diagonal elements of the diagonal matrix D(+).
*
*  LPLUS   (output) REAL array, dimension (N)
*          The first (n-1) elements of LPLUS contain the subdiagonal
*          elements of the unit bidiagonal matrix L(+). LPLUS( N ) is
*          set to SIGMA.
*
*  WORK    (input) REAL array, dimension (???)
*          Workspace.
*
*  Further Details
*  ===============
*
*  Based on contributions by
*     Inderjit Dhillon, IBM Almaden, USA
*     Osni Marques, LBNL/NERSC, USA
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ZERO, TWO
      PARAMETER          ( ZERO = 0.0E0, TWO = 2.0E0 )
*     ..
*     .. Local Scalars ..
      INTEGER            I
      REAL               DELTA, EPS, S, SIGMA
*     ..
*     .. External Functions ..
      REAL               SLAMCH
      EXTERNAL           SLAMCH
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS
*     ..
*     .. Executable Statements ..
*
      INFO = 0
      EPS = SLAMCH( 'Precision' )
      IF( IFIRST.EQ.1 ) THEN
         SIGMA = W( IFIRST )
      ELSE IF( ILAST.EQ.N ) THEN
         SIGMA = W( ILAST )
      ELSE
         INFO = 1
         RETURN
      END IF
*
*     Compute the new relatively robust representation (RRR)
*
      DELTA = TWO*EPS
   10 CONTINUE
      IF( IFIRST.EQ.1 ) THEN
         SIGMA = SIGMA - ABS( SIGMA )*DELTA
      ELSE
         SIGMA = SIGMA + ABS( SIGMA )*DELTA
      END IF
      S = -SIGMA
      DO 20 I = 1, N - 1
         DPLUS( I ) = D( I ) + S
         LPLUS( I ) = LD( I ) / DPLUS( I )
         S = S*LPLUS( I )*L( I ) - SIGMA
   20 CONTINUE
      DPLUS( N ) = D( N ) + S
      IF( IFIRST.EQ.1 ) THEN
         DO 30 I = 1, N
            IF( DPLUS( I ).LT.ZERO ) THEN
               DELTA = TWO*DELTA
               GO TO 10
            END IF
   30    CONTINUE
      ELSE
         DO 40 I = 1, N
            IF( DPLUS( I ).GT.ZERO ) THEN
               DELTA = TWO*DELTA
               GO TO 10
            END IF
   40    CONTINUE
      END IF
      DO 50 I = IFIRST, ILAST
         W( I ) = W( I ) - SIGMA
   50 CONTINUE
      LPLUS( N ) = SIGMA
*
      RETURN
*
*     End of SLARRF
*
      END

subroutine plotfmt_open(fname,istatus)

  implicit none

  integer :: istatus, funit
  character(*) :: fname

  integer :: io_status

  istatus = 0

  ! Open intermediate file
  funit = 10
  open(funit,file=fname,status='old',form='unformatted',convert='big_endian',iostat=io_status)

  if(io_status > 0) istatus = 1

  return

end subroutine plotfmt_open

subroutine plotfmt_close()

  implicit none
  integer :: funit

  ! Close file
  funit = 10
  close(funit)

  return

end subroutine plotfmt_close

C
C	$Id: calcnt.f,v 1.4 2008-07-27 00:23:01 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CALCNT (Z,M,N,A1,A2,A3,I1,I2,I3)
      SAVE
      DIMENSION       Z(M,N)
C
C***CRAYLIB HAS THIS BLANK COMMENT
C THIS ENTRY POINT IS FOR USERS WHO ARE TOO LAZY TO SWITCH OLD DECKS
C TO THE NEW CALLING SEQUENCE.
C THE FOLLOWING CALL IS FOR GATHERING STATISTICS ON LIBRARY USE AT NCAR
C
      CALL Q8QST4 ('GRAPHX','CONRECQCK','CALCNT','VERSION 01')
C
C***CRAYLIB HAS THIS BLANK COMMENT
C
      CALL CONREC (Z,M,M,N,A1,A2,A3,I1,I2,I3)
      RETURN
      END

C
C $Id: kurv2dp.f,v 1.3 2008-07-27 03:10:11 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
C NOTE: If you make any changes to this software, please remember to
C make the same changes to the corresponding single precision routine.
C
      SUBROUTINE KURV2DP(T,XS,YS,N,X,Y,XP,YP,S,SIGMA)
      DOUBLE PRECISION TN
      DOUBLE PRECISION SIGMAP
      DOUBLE PRECISION DEL1
      DOUBLE PRECISION DEL2
      DOUBLE PRECISION DELS
      DOUBLE PRECISION SUMX
      DOUBLE PRECISION SUMY
      DOUBLE PRECISION D
      DOUBLE PRECISION C1
      DOUBLE PRECISION C2
      DOUBLE PRECISION SIGDEL
      DOUBLE PRECISION SS
      DOUBLE PRECISION DUMMY
      DOUBLE PRECISION S1
      DOUBLE PRECISION S2
c
      INTEGER N
      DOUBLE PRECISION T,XS,YS,X(N),Y(N),XP(N),YP(N),S(N),SIGMA
c
c                                 coded by alan kaylor cline
c                           from fitpack -- january 26, 1987
c                        a curve and surface fitting package
c                      a product of pleasant valley software
c                  8603 altus cove, austin, texas 78759, usa
c
c this subroutine performs the mapping of points in the
c interval (0.,1.) onto a curve in the plane. the subroutine
c kurv1 should be called earlier to determine certain
c necessary parameters. the resulting curve has a parametric
c representation both of whose components are splines under
c tension and functions of the polygonal arclength
c parameter.
c
c on input--
c
c   t contains a real value to be mapped to a point on the
c   curve. the interval (0.,1.) is mapped onto the entire
c   curve, with 0. mapping to (x(1),y(1)) and 1. mapping
c   to (x(n),y(n)). values outside this interval result in
c   extrapolation.
c
c   n contains the number of points which were specified
c   to determine the curve.
c
c   x and y are arrays containing the x- and y-coordinates
c   of the specified points.
c
c   xp and yp are the arrays output from kurv1 containing
c   curvature information.
c
c   s is an array containing the polygonal arclengths of
c   the curve.
c
c and
c
c   sigma contains the tension factor (its sign is ignored).
c
c the parameters n, x, y, xp, yp, s, and sigma should be
c input unaltered from the output of kurv1.
c
c on output--
c
c   xs and ys contain the x- and y-coordinates of the image
c   point on the curve.
c
c none of the input parameters are altered.
c
c this subroutine references package modules intrvldp and
c snhcshdp.
c
c-----------------------------------------------------------
c
c determine interval
c
      TN = S(N)*T
      IM1 = INTRVLDP(TN,S,N)
      I = IM1 + 1
c
c denormalize tension factor
c
      SIGMAP = ABS(SIGMA)*DBLE(N-1)/S(N)
c
c set up and perform interpolation
c
      DEL1 = TN - S(IM1)
      DEL2 = S(I) - TN
      DELS = S(I) - S(IM1)
      SUMX = (X(I)*DEL1+X(IM1)*DEL2)/DELS
      SUMY = (Y(I)*DEL1+Y(IM1)*DEL2)/DELS
      IF (SIGMAP.NE.0.D0) GO TO 1
      D = DEL1*DEL2/ (6.D0*DELS)
      C1 = (DEL1+DELS)*D
      C2 = (DEL2+DELS)*D
      XS = SUMX - XP(I)*C1 - XP(IM1)*C2
      YS = SUMY - YP(I)*C1 - YP(IM1)*C2
      RETURN
    1 SIGDEL = SIGMAP*DELS
      CALL SNHCSHDP(SS,DUMMY,SIGDEL,-1)
      CALL SNHCSHDP(S1,DUMMY,SIGMAP*DEL1,-1)
      CALL SNHCSHDP(S2,DUMMY,SIGMAP*DEL2,-1)
      D = SIGDEL*SIGMAP* (1.D0+SS)
      C1 = DEL1* (S1-SS)/D
      C2 = DEL2* (S2-SS)/D
      XS = SUMX + XP(I)*C1 + XP(IM1)*C2
      YS = SUMY + YP(I)*C1 + YP(IM1)*C2
      RETURN
      END

c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by UCAR                 .
c  .                                                             .
c  .       University Corporation for Atmospheric Research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                         SPHEREPACK                          .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c
c
c     file alf.f contains subroutines alfk,lfim,lfim1,lfin,lfin1,lfpt
c     for computing normalized associated legendre polynomials
c
c subroutine alfk (n,m,cp)
c
c dimension of           real cp(n/2 + 1)
c arguments
c
c purpose                routine alfk computes single precision fourier
c                        coefficients in the trigonometric series
c                        representation of the normalized associated
c                        legendre function pbar(n,m,theta) for use by
c                        routines lfp and lfpt in calculating single
c                        precision pbar(n,m,theta).
c
c                        first define the normalized associated
c                        legendre functions
c
c                        pbar(m,n,theta) = sqrt((2*n+1)*factorial(n-m)
c                        /(2*factorial(n+m)))*sin(theta)**m/(2**n*
c                        factorial(n)) times the (n+m)th derivative of
c                        (x**2-1)**n with respect to x=cos(theta)
c
c                        where theta is colatitude.
c
c                        then subroutine alfk computes the coefficients
c                        cp(k) in the following trigonometric
c                        expansion of pbar(m,n,theta).
c
c                        1) for n even and m even, pbar(m,n,theta) =
c                           .5*cp(1) plus the sum from k=1 to k=n/2
c                           of cp(k+1)*cos(2*k*th)
c
c                        2) for n even and m odd, pbar(m,n,theta) =
c                           the sum from k=1 to k=n/2 of
c                           cp(k)*sin(2*k*th)
c
c                        3) for n odd and m even, pbar(m,n,theta) =
c                           the sum from k=1 to k=(n+1)/2 of
c                           cp(k)*cos((2*k-1)*th)
c
c                        4) for n odd and m odd,  pbar(m,n,theta) =
c                           the sum from k=1 to k=(n+1)/2 of
c                           cp(k)*sin((2*k-1)*th)
c
c
c usage                  call alfk(n,m,cp)
c
c arguments
c
c on input               n
c                          nonnegative integer specifying the degree of
c                          pbar(n,m,theta)
c
c                        m
c                          is the order of pbar(n,m,theta). m can be
c                          any integer however cp is computed such that
c                          pbar(n,m,theta) = 0 if abs(m) is greater
c                          than n and pbar(n,m,theta) = (-1)**m*
c                          pbar(n,-m,theta) for negative m.
c
c on output              cp
c                          single precision array of length (n/2)+1
c                          which contains the fourier coefficients in
c                          the trigonometric series representation of
c                          pbar(n,m,theta)
c
c
c special conditions     none
c
c precision              single
c
c algorithm              the highest order coefficient is determined in
c                        closed form and the remainig coefficients are
c                        determined as the solution of a backward
c                        recurrence relation.
c
c accuracy               comparison between routines alfk and double
c                        precision dalfk on the cray1 indicates
c                        greater accuracy for smaller values
c                        of input parameter n.  agreement to 14
c                        places was obtained for n=10 and to 13
c                        places for n=100.
c
      SUBROUTINE DALFK(N,M,CP)
      DOUBLE PRECISION CP
      DOUBLE PRECISION SC10
      DOUBLE PRECISION SC20
      DOUBLE PRECISION SC40
      DOUBLE PRECISION FNUM
      DOUBLE PRECISION FNMH
      DOUBLE PRECISION PM1
      DOUBLE PRECISION T1
      DOUBLE PRECISION FDEN
      DOUBLE PRECISION T2
      DOUBLE PRECISION CP2
      DOUBLE PRECISION FNNP1
      DOUBLE PRECISION FNMSQ
      DOUBLE PRECISION FK
      DOUBLE PRECISION A1
      DOUBLE PRECISION B1
      DOUBLE PRECISION C1
      DIMENSION CP(N/2+1)
      PARAMETER (SC10=1024.D0)
      PARAMETER (SC20=SC10*SC10)
      PARAMETER (SC40=SC20*SC20)
c
      CP(1) = 0.D0
      MA = IABS(M)
      IF (MA.GT.N) RETURN
      IF (N-1) 2,3,5
    2 CP(1) = SQRT(2.D0)
      RETURN
    3 IF (MA.NE.0) GO TO 4
      CP(1) = SQRT(1.5D0)
      RETURN
    4 CP(1) = SQRT(.75D0)
      IF (M.EQ.-1) CP(1) = -CP(1)
      RETURN
    5 IF (MOD(N+MA,2).NE.0) GO TO 10
      NMMS2 = (N-MA)/2
      FNUM = N + MA + 1
      FNMH = N - MA + 1
      PM1 = 1.D0
      GO TO 15
   10 NMMS2 = (N-MA-1)/2
      FNUM = N + MA + 2
      FNMH = N - MA + 2
      PM1 = -1.D0
   15 T1 = 1.D0/SC20
      NEX = 20
      FDEN = 2.D0
      IF (NMMS2.LT.1) GO TO 20
      DO 18 I = 1,NMMS2
          T1 = FNUM*T1/FDEN
          IF (T1.GT.SC20) THEN
              T1 = T1/SC40
              NEX = NEX + 40
          END IF
          FNUM = FNUM + 2.D0
          FDEN = FDEN + 2.D0
   18 CONTINUE
   20 T1 = T1/2.D0** (N-1-NEX)
      IF (MOD(MA/2,2).NE.0) T1 = -T1
      T2 = 1.D0
      IF (MA.EQ.0) GO TO 26
      DO 25 I = 1,MA
          T2 = FNMH*T2/ (FNMH+PM1)
          FNMH = FNMH + 2.D0
   25 CONTINUE
   26 CP2 = T1*SQRT((N+.5D0)*T2)
      FNNP1 = N* (N+1)
      FNMSQ = FNNP1 - 2.D0*MA*MA
      L = (N+1)/2
      IF (MOD(N,2).EQ.0 .AND. MOD(MA,2).EQ.0) L = L + 1
      CP(L) = CP2
      IF (M.GE.0) GO TO 29
      IF (MOD(MA,2).NE.0) CP(L) = -CP(L)
   29 IF (L.LE.1) RETURN
      FK = N
      A1 = (FK-2.D0)* (FK-1.D0) - FNNP1
      B1 = 2.D0* (FK*FK-FNMSQ)
      CP(L-1) = B1*CP(L)/A1
   30 L = L - 1
      IF (L.LE.1) RETURN
      FK = FK - 2.D0
      A1 = (FK-2.D0)* (FK-1.D0) - FNNP1
      B1 = -2.D0* (FK*FK-FNMSQ)
      C1 = (FK+1.D0)* (FK+2.D0) - FNNP1
      CP(L-1) = - (B1*CP(L)+C1*CP(L+1))/A1
      GO TO 30
      END
c subroutine lfim (init,theta,l,n,nm,pb,id,wlfim)
c
c dimension of           theta(l),  pb(id,nm+1),  wlfim(4*l*(nm+1))
c arguments
c
c purpose                given n and l, routine lfim calculates
c                        the normalized associated legendre functions
c                        pbar(n,m,theta) for m=0,...,n and theta(i)
c                        for i=1,...,l where
c
c                        pbar(m,n,theta) = sqrt((2*n+1)*factorial(n-m)
c                        /(2*factorial(n+m)))*sin(theta)**m/(2**n*
c                        factorial(n)) times the (n+m)th derivative of
c                        (x**2-1)**n with respect to x=cos(theta)
c
c usage                  call lfim (init,theta,l,n,nm,pb,id,wlfim)
c
c arguments
c on input               init
c                        = 0
c                            initialization only - using parameters
c                            l, nm and array theta, subroutine lfim
c                            initializes array wlfim for subsequent
c                            use in the computation of the associated
c                            legendre functions pb. initialization
c                            does not have to be repeated unless
c                            l, nm, or array theta are changed.
c                        = 1
c                            subroutine lfim uses the array wlfim that
c                            was computed with init = 0 to compute pb.
c
c                        theta
c                          an array that contains the colatitudes
c                          at which the associated legendre functions
c                          will be computed. the colatitudes must be
c                          specified in radians.
c
c                        l
c                          the length of the theta array. lfim is
c                          vectorized with vector length l.
c
c                        n
c                          nonnegative integer, less than nm, specifying
c                          degree of pbar(n,m,theta). subroutine lfim
c                          must be called starting with n=0. n must be
c                          incremented by one in subsequent calls and
c                          must not exceed nm.
c
c                        nm
c                          the maximum value of n and m
c
c                        id
c                          the first dimension of the two dimensional
c                          array pb as it appears in the program that
c                          calls lfim. (see output parameter pb)
c
c                        wlfim
c                          an array with length 4*l*(nm+1) which
c                          must be initialized by calling lfim
c                          with init=0 (see parameter init)  it
c                          must not be altered between calls to
c                          lfim.
c
c
c on output              pb
c                          a two dimensional array with first
c                          dimension id in the program that calls
c                          lfim. the second dimension of pb must
c                          be at least nm+1. starting with n=0
c                          lfim is called repeatedly with n being
c                          increased by one between calls. on each
c                          call, subroutine lfim computes
c                          = pbar(m,n,theta(i)) for m=0,...,n and
c                          i=1,...l.
c
c                        wlfim
c                          array containing values which must not
c                          be altered unless l, nm or the array theta
c                          are changed in which case lfim must be
c                          called with init=0 to reinitialize the
c                          wlfim array.
c
c special conditions     n must be increased by one between calls
c                        of lfim in which n is not zero.
c
c precision              single
c
c
c algorithm              routine lfim calculates pbar(n,m,theta) using
c                        a four term recurrence relation. (unpublished
c                        notes by paul n. swarztrauber)
c
      SUBROUTINE DLFIM(INIT,THETA,L,N,NM,PB,ID,WLFIM)
      DOUBLE PRECISION THETA
      DOUBLE PRECISION PB
      DOUBLE PRECISION WLFIM
      DIMENSION PB(1),WLFIM(1)
c
c     total length of wlfim is 4*l*(nm+1)
c
      LNX = L* (NM+1)
      IW1 = LNX + 1
      IW2 = IW1 + LNX
      IW3 = IW2 + LNX
      CALL DLFIM1(INIT,THETA,L,N,NM,ID,PB,WLFIM,WLFIM(IW1),WLFIM(IW2),
     +           WLFIM(IW3),WLFIM(IW2))
      RETURN
      END
      SUBROUTINE DLFIM1(INIT,THETA,L,N,NM,ID,P3,PHZ,PH1,P1,P2,CP)
      DOUBLE PRECISION THETA
      DOUBLE PRECISION P3
      DOUBLE PRECISION PHZ
      DOUBLE PRECISION PH1
      DOUBLE PRECISION P1
      DOUBLE PRECISION P2
      DOUBLE PRECISION CP
      DOUBLE PRECISION SSQRT2
      DOUBLE PRECISION SQ5S6
      DOUBLE PRECISION SQ1S6
      DOUBLE PRECISION FN
      DOUBLE PRECISION TN
      DOUBLE PRECISION CN
      DOUBLE PRECISION FM
      DOUBLE PRECISION FNPM
      DOUBLE PRECISION FNMM
      DOUBLE PRECISION TEMP
      DOUBLE PRECISION CC
      DOUBLE PRECISION DD
      DOUBLE PRECISION EE
      DIMENSION P1(L,1),P2(L,1),P3(ID,1),PHZ(L,1),PH1(L,1),CP(1),
     +          THETA(1)

      NMP1 = NM + 1
      IF (INIT.NE.0) GO TO 5
      SSQRT2 = 1.D0/SQRT(2.D0)
      DO 10 I = 1,L
          PHZ(I,1) = SSQRT2
   10 CONTINUE
      DO 15 NP1 = 2,NMP1
          NH = NP1 - 1
          CALL DALFK(NH,0,CP)
          DO 16 I = 1,L
              CALL DLFPT(NH,0,THETA(I),CP,PHZ(I,NP1))
   16     CONTINUE
          CALL DALFK(NH,1,CP)
          DO 17 I = 1,L
              CALL DLFPT(NH,1,THETA(I),CP,PH1(I,NP1))
   17     CONTINUE
   15 CONTINUE
      RETURN
    5 IF (N.GT.2) GO TO 60
      IF (N-1) 25,30,35
   25 DO 45 I = 1,L
          P3(I,1) = PHZ(I,1)
   45 CONTINUE
      RETURN
   30 DO 50 I = 1,L
          P3(I,1) = PHZ(I,2)
          P3(I,2) = PH1(I,2)
   50 CONTINUE
      RETURN
   35 SQ5S6 = SQRT(5.D0/6.D0)
      SQ1S6 = SQRT(1.D0/6.D0)
      DO 55 I = 1,L
          P3(I,1) = PHZ(I,3)
          P3(I,2) = PH1(I,3)
          P3(I,3) = SQ5S6*PHZ(I,1) - SQ1S6*P3(I,1)
          P1(I,1) = PHZ(I,2)
          P1(I,2) = PH1(I,2)
          P2(I,1) = PHZ(I,3)
          P2(I,2) = PH1(I,3)
          P2(I,3) = P3(I,3)
   55 CONTINUE
      RETURN
   60 NM1 = N - 1
      NP1 = N + 1
      FN = DBLE(N)
      TN = FN + FN
      CN = (TN+1.D0)/ (TN-3.D0)
      DO 65 I = 1,L
          P3(I,1) = PHZ(I,NP1)
          P3(I,2) = PH1(I,NP1)
   65 CONTINUE
      IF (NM1.LT.3) GO TO 71
      DO 70 MP1 = 3,NM1
          M = MP1 - 1
          FM = DBLE(M)
          FNPM = FN + FM
          FNMM = FN - FM
          TEMP = FNPM* (FNPM-1.D0)
          CC = SQRT(CN* (FNPM-3.D0)* (FNPM-2.D0)/TEMP)
          DD = SQRT(CN*FNMM* (FNMM-1.D0)/TEMP)
          EE = SQRT((FNMM+1.D0)* (FNMM+2.D0)/TEMP)
          DO 70 I = 1,L
              P3(I,MP1) = CC*P1(I,MP1-2) + DD*P1(I,MP1) - EE*P3(I,MP1-2)
   70 CONTINUE
   71 FNPM = FN + FN - 1.D0
      TEMP = FNPM* (FNPM-1.D0)
      CC = SQRT(CN* (FNPM-3.D0)* (FNPM-2.D0)/TEMP)
      EE = SQRT(6.D0/TEMP)
      DO 75 I = 1,L
          P3(I,N) = CC*P1(I,N-2) - EE*P3(I,N-2)
   75 CONTINUE
      FNPM = FN + FN
      TEMP = FNPM* (FNPM-1.D0)
      CC = SQRT(CN* (FNPM-3.D0)* (FNPM-2.D0)/TEMP)
      EE = SQRT(2.D0/TEMP)
      DO 80 I = 1,L
          P3(I,N+1) = CC*P1(I,N-1) - EE*P3(I,N-1)
   80 CONTINUE
      DO 90 MP1 = 1,NP1
          DO 90 I = 1,L
              P1(I,MP1) = P2(I,MP1)
              P2(I,MP1) = P3(I,MP1)
   90 CONTINUE
      RETURN
      END
c subroutine lfin (init,theta,l,m,nm,pb,id,wlfin)
c
c dimension of           theta(l),  pb(id,nm+1),  wlfin(4*l*(nm+1))
c arguments
c
c purpose                given m and l, routine lfin calculates
c                        the normalized associated legendre functions
c                        pbar(n,m,theta) for n=m,...,nm and theta(i)
c                        for i=1,...,l where
c
c                        pbar(m,n,theta) = sqrt((2*n+1)*factorial(n-m)
c                        /(2*factorial(n+m)))*sin(theta)**m/(2**n*
c                        factorial(n)) times the (n+m)th derivative of
c                        (x**2-1)**n with respect to x=cos(theta)
c
c usage                  call lfin (init,theta,l,m,nm,pb,id,wlfin)
c
c arguments
c on input               init
c                        = 0
c                            initialization only - using parameters
c                            l, nm and the array theta, subroutine lfin
c                            initializes the array wlfin for subsequent
c                            use in the computation of the associated
c                            legendre functions pb. initialization does
c                            not have to be repeated unless l, nm or
c                            the array theta are changed.
c                        = 1
c                            subroutine lfin uses the array wlfin that
c                            was computed with init = 0 to compute pb
c
c                        theta
c                          an array that contains the colatitudes
c                          at which the associated legendre functions
c                          will be computed. the colatitudes must be
c                          specified in radians.
c
c                        l
c                          the length of the theta array. lfin is
c                          vectorized with vector length l.
c
c                        m
c                          nonnegative integer, less than nm, specifying
c                          degree of pbar(n,m,theta). subroutine lfin
c                          must be called starting with n=0. n must be
c                          incremented by one in subsequent calls and
c                          must not exceed nm.
c
c                        nm
c                          the maximum value of n and m
c
c                        id
c                          the first dimension of the two dimensional
c                          array pb as it appears in the program that
c                          calls lfin. (see output parameter pb)
c
c                        wlfin
c                          an array with length 4*l*(nm+1) which
c                          must be initialized by calling lfin
c                          with init=0 (see parameter init)  it
c                          must not be altered between calls to
c                          lfin.
c
c
c on output              pb
c                          a two dimensional array with first
c                          dimension id in the program that calls
c                          lfin. the second dimension of pb must
c                          be at least nm+1. starting with m=0
c                          lfin is called repeatedly with m being
c                          increased by one between calls. on each
c                          call, subroutine lfin computes pb(i,n+1)
c                          = pbar(m,n,theta(i)) for n=m,...,nm and
c                          i=1,...l.
c
c                        wlfin
c                          array containing values which must not
c                          be altered unless l, nm or the array theta
c                          are changed in which case lfin must be
c                          called with init=0 to reinitialize the
c                          wlfin array.
c
c special conditions     m must be increased by one between calls
c                        of lfin in which m is not zero.
c
c precision              single
c
c algorithm              routine lfin calculates pbar(n,m,theta) using
c                        a four term recurrence relation. (unpublished
c                        notes by paul n. swarztrauber)
c
      SUBROUTINE DLFIN(INIT,THETA,L,M,NM,PB,ID,WLFIN)
      DOUBLE PRECISION THETA
      DOUBLE PRECISION PB
      DOUBLE PRECISION WLFIN
      DIMENSION PB(1),WLFIN(1)
c
c     total length of wlfin is 4*l*(nm+1)
c
      LNX = L* (NM+1)
      IW1 = LNX + 1
      IW2 = IW1 + LNX
      IW3 = IW2 + LNX
      CALL DLFIN1(INIT,THETA,L,M,NM,ID,PB,WLFIN,WLFIN(IW1),WLFIN(IW2),
     +           WLFIN(IW3),WLFIN(IW2))
      RETURN
      END
      SUBROUTINE DLFIN1(INIT,THETA,L,M,NM,ID,P3,PHZ,PH1,P1,P2,CP)
      DOUBLE PRECISION THETA
      DOUBLE PRECISION P3
      DOUBLE PRECISION PHZ
      DOUBLE PRECISION PH1
      DOUBLE PRECISION P1
      DOUBLE PRECISION P2
      DOUBLE PRECISION CP
      DOUBLE PRECISION SSQRT2
      DOUBLE PRECISION FM
      DOUBLE PRECISION TM
      DOUBLE PRECISION TEMP
      DOUBLE PRECISION CC
      DOUBLE PRECISION EE
      DOUBLE PRECISION FN
      DOUBLE PRECISION TN
      DOUBLE PRECISION CN
      DOUBLE PRECISION FNPM
      DOUBLE PRECISION FNMM
      DOUBLE PRECISION DD
      DIMENSION P1(L,1),P2(L,1),P3(ID,1),PHZ(L,1),PH1(L,1),CP(1),
     +          THETA(1)

      NMP1 = NM + 1
      IF (INIT.NE.0) GO TO 5
      SSQRT2 = 1.D0/SQRT(2.D0)
      DO 10 I = 1,L
          PHZ(I,1) = SSQRT2
   10 CONTINUE
      DO 15 NP1 = 2,NMP1
          NH = NP1 - 1
          CALL DALFK(NH,0,CP)
          DO 16 I = 1,L
              CALL DLFPT(NH,0,THETA(I),CP,PHZ(I,NP1))
   16     CONTINUE
          CALL DALFK(NH,1,CP)
          DO 17 I = 1,L
              CALL DLFPT(NH,1,THETA(I),CP,PH1(I,NP1))
   17     CONTINUE
   15 CONTINUE
      RETURN
    5 MP1 = M + 1
      FM = DBLE(M)
      TM = FM + FM
      IF (M-1) 25,30,35
   25 DO 45 NP1 = 1,NMP1
          DO 45 I = 1,L
              P3(I,NP1) = PHZ(I,NP1)
              P1(I,NP1) = PHZ(I,NP1)
   45 CONTINUE
      RETURN
   30 DO 50 NP1 = 2,NMP1
          DO 50 I = 1,L
              P3(I,NP1) = PH1(I,NP1)
              P2(I,NP1) = PH1(I,NP1)
   50 CONTINUE
      RETURN
   35 TEMP = TM* (TM-1.D0)
      CC = SQRT((TM+1.D0)* (TM-2.D0)/TEMP)
      EE = SQRT(2.D0/TEMP)
      DO 85 I = 1,L
          P3(I,M+1) = CC*P1(I,M-1) - EE*P1(I,M+1)
   85 CONTINUE
      IF (M.EQ.NM) RETURN
      TEMP = TM* (TM+1.D0)
      CC = SQRT((TM+3.D0)* (TM-2.D0)/TEMP)
      EE = SQRT(6.D0/TEMP)
      DO 70 I = 1,L
          P3(I,M+2) = CC*P1(I,M) - EE*P1(I,M+2)
   70 CONTINUE
      MP3 = M + 3
      IF (NMP1.LT.MP3) GO TO 80
      DO 75 NP1 = MP3,NMP1
          N = NP1 - 1
          FN = DBLE(N)
          TN = FN + FN
          CN = (TN+1.D0)/ (TN-3.D0)
          FNPM = FN + FM
          FNMM = FN - FM
          TEMP = FNPM* (FNPM-1.D0)
          CC = SQRT(CN* (FNPM-3.D0)* (FNPM-2.D0)/TEMP)
          DD = SQRT(CN*FNMM* (FNMM-1.D0)/TEMP)
          EE = SQRT((FNMM+1.D0)* (FNMM+2.D0)/TEMP)
          DO 75 I = 1,L
              P3(I,NP1) = CC*P1(I,NP1-2) + DD*P3(I,NP1-2) - EE*P1(I,NP1)
   75 CONTINUE
   80 DO 90 NP1 = M,NMP1
          DO 90 I = 1,L
              P1(I,NP1) = P2(I,NP1)
              P2(I,NP1) = P3(I,NP1)
   90 CONTINUE
      RETURN
      END
c subroutine lfpt (n,m,theta,cp,pb)
c
c dimension of
c arguments
c                        cp((n/2)+1)
c
c purpose                routine lfpt uses coefficients computed by
c                        routine alfk to compute the single precision
c                        normalized associated legendre function pbar(n,
c                        m,theta) at colatitude theta.
c
c usage                  call lfpt(n,m,theta,cp,pb)
c
c arguments
c
c on input               n
c                          nonnegative integer specifying the degree of
c                          pbar(n,m,theta)
c                        m
c                          is the order of pbar(n,m,theta). m can be
c                          any integer however pbar(n,m,theta) = 0
c                          if abs(m) is greater than n and
c                          pbar(n,m,theta) = (-1)**m*pbar(n,-m,theta)
c                          for negative m.
c
c                        theta
c                          single precision colatitude in radians
c
c                        cp
c                          single precision array of length (n/2)+1
c                          containing coefficients computed by routine
c                          alfk
c
c on output              pb
c                          single precision variable containing
c                          pbar(n,m,theta)
c
c special conditions     calls to routine lfpt must be preceded by an
c                        appropriate call to routine alfk.
c
c precision              single
c
c algorithm              the trigonometric series formula used by
c                        routine lfpt to calculate pbar(n,m,th) at
c                        colatitude th depends on m and n as follows:
c
c                           1) for n even and m even, the formula is
c                              .5*cp(1) plus the sum from k=1 to k=n/2
c                              of cp(k)*cos(2*k*th)
c                           2) for n even and m odd. the formula is
c                              the sum from k=1 to k=n/2 of
c                              cp(k)*sin(2*k*th)
c                           3) for n odd and m even, the formula is
c                              the sum from k=1 to k=(n+1)/2 of
c                              cp(k)*cos((2*k-1)*th)
c                           4) for n odd and m odd, the formula is
c                              the sum from k=1 to k=(n+1)/2 of
c                              cp(k)*sin((2*k-1)*th)
c
c accuracy               comparison between routines lfpt and double
c                        precision dlfpt on the cray1 indicates greater
c                        accuracy for greater values on input parameter
c                        n.  agreement to 13 places was obtained for
c                        n=10 and to 12 places for n=100.
c
c timing                 time per call to routine lfpt is dependent on
c                        the input parameter n.
c
      SUBROUTINE DLFPT(N,M,THETA,CP,PB)
      DOUBLE PRECISION THETA
      DOUBLE PRECISION CP
      DOUBLE PRECISION PB
      DOUBLE PRECISION CDT
      DOUBLE PRECISION SDT
      DOUBLE PRECISION CT
      DOUBLE PRECISION ST
      DOUBLE PRECISION SUM
      DOUBLE PRECISION CTH
      DIMENSION CP(1)
c
      PB = 0.D0
      MA = IABS(M)
      IF (MA.GT.N) RETURN
      IF (N) 10,10,30
   10 IF (MA) 20,20,30
   20 PB = SQRT(.5D0)
      GO TO 140
   30 NP1 = N + 1
      NMOD = MOD(N,2)
      MMOD = MOD(MA,2)
      IF (NMOD) 40,40,90
   40 IF (MMOD) 50,50,70
   50 KDO = N/2 + 1
      CDT = COS(THETA+THETA)
      SDT = SIN(THETA+THETA)
      CT = 1.D0
      ST = 0.D0
      SUM = .5D0*CP(1)
      DO 60 KP1 = 2,KDO
          CTH = CDT*CT - SDT*ST
          ST = SDT*CT + CDT*ST
          CT = CTH
          SUM = SUM + CP(KP1)*CT
   60 CONTINUE
      PB = SUM
      GO TO 140
   70 KDO = N/2
      CDT = COS(THETA+THETA)
      SDT = SIN(THETA+THETA)
      CT = 1.D0
      ST = 0.D0
      SUM = 0.D0
      DO 80 K = 1,KDO
          CTH = CDT*CT - SDT*ST
          ST = SDT*CT + CDT*ST
          CT = CTH
          SUM = SUM + CP(K)*ST
   80 CONTINUE
      PB = SUM
      GO TO 140
   90 KDO = (N+1)/2
      IF (MMOD) 100,100,120
  100 CDT = COS(THETA+THETA)
      SDT = SIN(THETA+THETA)
      CT = COS(THETA)
      ST = -SIN(THETA)
      SUM = 0.D0
      DO 110 K = 1,KDO
          CTH = CDT*CT - SDT*ST
          ST = SDT*CT + CDT*ST
          CT = CTH
          SUM = SUM + CP(K)*CT
  110 CONTINUE
      PB = SUM
      GO TO 140
  120 CDT = COS(THETA+THETA)
      SDT = SIN(THETA+THETA)
      CT = COS(THETA)
      ST = -SIN(THETA)
      SUM = 0.D0
      DO 130 K = 1,KDO
          CTH = CDT*CT - SDT*ST
          ST = SDT*CT + CDT*ST
          CT = CTH
          SUM = SUM + CP(K)*ST
  130 CONTINUE
      PB = SUM
  140 RETURN
      END

C
C $Id: pwrit.f,v 1.7 2008-07-27 00:17:25 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE PWRIT (PX,PY,CH,NC,IS,IO,IC)
      CHARACTER*(*) CH
C
C PWRIT is called to draw a character string in a specified position.
C It is just like WTSTR, but has one extra argument.  NC is the number
C of characters to be written from the string CH.
C
      IF (ICFELL('PWRIT - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
      CALL WTSTR (PX,PY,CH(1:NC),IS,IO,IC)
      IF (ICFELL('PWRIT',2).NE.0) RETURN
C
C Done.
C
      RETURN
C
      END

C
C $Id: agrpch.f,v 1.6 2008-07-27 00:14:35 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE AGRPCH (CHST,LNCS,IDCS)
C
      CHARACTER*(*) CHST
C
C This routine is used to replace a character string previously stored
C by the routine AGSTCH (which see).  This could be done by an AGDLCH
C followed by an AGSTCH, and, in fact, under certain conditions, does
C exactly that.  Only when it is easy to do so does AGRPCH operate more
C efficiently.  Nevertheless, a user who (for example) repeatedly and
C perhaps redundantly defines x-axis labels of the same length may
C greatly benefit thereby; repeated deletes and stores would lead to
C frequent garbage collection by AGSTCH.
C
C AGRPCH has the following arguments:
C
C -- CHST is the new character string, to replace what was originally
C    stored.
C
C -- LNCS is the length of the character string in CHST.
C
C -- IDCS is the identifier returned by AGSTCH when the original string
C    was stored.  The value of IDCS may be changed by the call.
C
C The following common blocks contain variables which are required for
C the character-storage-and-retrieval scheme of AUTOGRAPH.
C
      COMMON /AGCHR1/ LNIC,INCH(2,50),LNCA,INCA
      SAVE /AGCHR1/
C
      COMMON /AGCHR2/ CHRA(2000)
      CHARACTER*1 CHRA
      SAVE /AGCHR2/
C
C If the identifier is positive or is negative but less than -LNIC, the
C original string was never stored in CHRA; just treat the replacement
C as a store and return a new value of IDCS.
C
      IF (IDCS.GT.(-1).OR.IDCS.LT.(-LNIC)) THEN
        CALL AGSTCH (CHST,LNCS,IDCS)
C
      ELSE
C
C The absolute value of the identifier is the index, in INCH, of the
C descriptor of the character string stored in CHRA.  If the new string
C is shorter than the old one, store it and zero remaining character
C positions.  Otherwise, treat the replacement as a delete followed by
C a store.
C
        I=-IDCS
        IF (LNCS.LE.INCH(2,I)) THEN
          J=INCH(1,I)-1
          DO 101 K=1,LNCS
            J=J+1
            CHRA(J)=CHST(K:K)
  101     CONTINUE
          DO 102 K=LNCS+1,INCH(2,I)
            J=J+1
            CHRA(J)=CHAR(0)
  102     CONTINUE
          INCH(2,I)=LNCS
        ELSE
          CALL AGDLCH (IDCS)
          CALL AGSTCH (CHST,LNCS,IDCS)
        END IF
C
      END IF
C
C Done.
C
      RETURN
C
      END

C
C	$Id: gssgt.f,v 1.4 2008-07-27 00:21:02 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GSSGT(SGNA,M)
C
C  SET SEGMENT TRANSFORMATION
C
      INTEGER ESSGT
      PARAMETER (ESSGT=64)
C
      include 'gkscom.h'
C
      INTEGER SGNA
      REAL    M(2,3)
C
C  Check if GKS is in the proper state.
C
      CALL GZCKST(7,ESSGT,IER)
      IF (IER .NE. 0) RETURN
C
C  Check that the segment name is valid.
C
      IF (SGNA.LT.0 .OR. SGNA.GT.99) THEN
        ERS = 1
        CALL GERHND(120,ESSGT,ERF)
        ERS = 0
        RETURN
      ENDIF
C
C  Check if the segment exists.
C
      NXST = 0
      DO 200 I=1,NUMSEG
        IF (SEGS(I) .EQ. SGNA) THEN
          NXST = 1
          ISNDX = I
        ENDIF
  200 CONTINUE
      IF (NXST .EQ. 0) THEN
        ERS = 1
        CALL GERHND(122,ESSGT,ERF)
        ERS = 0
        RETURN
      ENDIF
C
C  Define the segment transformation matrix for segment SGNA.
C
      SEGT(ISNDX,1,1) = M(1,1)
      SEGT(ISNDX,1,2) = M(1,2)
      SEGT(ISNDX,1,3) = M(1,3)
      SEGT(ISNDX,2,1) = M(2,1)
      SEGT(ISNDX,2,2) = M(2,2)
      SEGT(ISNDX,2,3) = M(2,3)
C
      RETURN
      END

C
C $Id: tdsetr.f,v 1.5 2008-07-27 00:17:33 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE TDSETR (PNAM,RVAL)
C
      CHARACTER*(*) PNAM
C
C The subroutine TDSETR may be used to set TDPACK parameters which have
C values of type REAL.
C
C The variables in the following common block define the mapping from
C 3-space to 2-space.
C
        COMMON /TDCOM1/ IH,IT,XM,YM,ZM,XO,YO,ZO,XT,YT,ZT,OE,XE,YE,ZE
        COMMON /TDCOM1/ A1,B1,C1,D1,E1,A2,B2,C2,D2,E2,A3,B3,C3,D3,E3
        COMMON /TDCOM1/ IS,FV,VL,VR,VB,VT,WL,WR,WB,WT
        SAVE   /TDCOM1/
C
C The variables in the following common block define the parallelogram.
C
        COMMON /TDCOM2/ XACP,YACP,ZACP,XCDX,YCDX,ZCDX,XCDY,YCDY,ZCDY
        SAVE   /TDCOM2/
C
C The variables in the following common block together determine how
C big characters written by TDLBLA will be.
C
        COMMON /TDCOM4/ CSM1,CSM2
        SAVE   /TDCOM4/
C
C The variables in the following common block define the shading type
C and the position of the light source.
C
        COMMON /TDCOM6/ ISHD,XPLS,YPLS,ZPLS
        SAVE   /TDCOM6/
C
C Do a call forcing a BLOCKDATA to be loaded from a binary library.
C
        CALL TDBLDA
C
C Check for an uncleared prior error.
C
        IF (ICFELL('TDSETR - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C Set the selected parameter.
C
        IF      (PNAM(1:3).EQ.'CS1'.OR.PNAM(1:3).EQ.'cs1') THEN
          CSM1=MAX(0.,RVAL)
        ELSE IF (PNAM(1:3).EQ.'CS2'.OR.PNAM(1:3).EQ.'cs2') THEN
          CSM2=MAX(0.,RVAL)
        ELSE IF (PNAM(1:3).EQ.'FOV'.OR.PNAM(1:3).EQ.'fov') THEN
          FV=RVAL
        ELSE IF (PNAM(1:3).EQ.'HND'.OR.PNAM(1:3).EQ.'hnd') THEN
          IH=MAX(0,MIN(1,INT(RVAL)))
        ELSE IF (PNAM(1:3).EQ.'LSU'.OR.PNAM(1:3).EQ.'lsu') THEN
          XPLS=RVAL
        ELSE IF (PNAM(1:3).EQ.'LSV'.OR.PNAM(1:3).EQ.'lsv') THEN
          YPLS=RVAL
        ELSE IF (PNAM(1:3).EQ.'LSW'.OR.PNAM(1:3).EQ.'lsw') THEN
          ZPLS=RVAL
        ELSE IF (PNAM(1:3).EQ.'SET'.OR.PNAM(1:3).EQ.'set') THEN
          IS=MAX(0,MIN(1,INT(RVAL)))
        ELSE IF (PNAM(1:3).EQ.'SHD'.OR.PNAM(1:3).EQ.'shd') THEN
          ISHD=MAX(0,MIN(1,INT(RVAL)))
        ELSE IF (PNAM(1:3).EQ.'STE'.OR.PNAM(1:3).EQ.'ste') THEN
          IT=MAX(0,MIN(1,INT(RVAL)))
        ELSE IF (PNAM(1:3).EQ.'VPB'.OR.PNAM(1:3).EQ.'vpb') THEN
          VB=MAX(0.,MIN(1.,RVAL))
        ELSE IF (PNAM(1:3).EQ.'VPL'.OR.PNAM(1:3).EQ.'vpl') THEN
          VL=MAX(0.,MIN(1.,RVAL))
        ELSE IF (PNAM(1:3).EQ.'VPR'.OR.PNAM(1:3).EQ.'vpr') THEN
          VR=MAX(0.,MIN(1.,RVAL))
        ELSE IF (PNAM(1:3).EQ.'VPT'.OR.PNAM(1:3).EQ.'vpt') THEN
          VT=MAX(0.,MIN(1.,RVAL))
        ELSE
          CALL SETER ('TDSETR - UNRECOGNIZED PARAMETER NAME',2,1)
          RETURN
        END IF
C
C Done.
C
        RETURN
C
      END

C NCLFORTSTART
      SUBROUTINE WAVELETI(N,Y,DT,MOTHER,PARAM,S0,DJ,JTOT,NPAD,NOISE,
     +                    ISIGTEST,SIGLVL,NADOF,WAVE,SCALE,PERIOD,COI,
     +                    DOF,FFTTHEOR,SIGNIF,GWS,YMEAN,YSD,LAG1,
     +                    CDELTA,PSI0,POWER,PHASE,R1)
      IMPLICIT NONE

C     wave = wavelet (y,mother \
C                    ,param,s0,dj,jtot,npad,noise,isigtest,siglvl,nadof)

C     return arguments:  all must be allocated in the C interface
C              JTOT must be calculated in the default case
C              wave(N,JTOT,2)   <=== fortran order
C              wave@scale(JTOT), wave@period(JTOT), wave@coi(N)
C              wave@dof(JTOT), wave@ffttheor(JTOT), wave@signif(JTOT)
C              wave@mean , wave@st_dev, wave@lag1

C                                             INPUT
      INTEGER N,MOTHER,JTOT,NPAD,NOISE,ISIGTEST
      DOUBLE PRECISION Y(N),DT,PARAM,S0,DJ,SIGLVL,NADOF(*)
C                                             OUTPUT: must be allocated
C                                                     in interface
      DOUBLE PRECISION WAVE(N,JTOT,2)
C                                             RETURN AS ATTRIBUTES
      DOUBLE PRECISION SCALE(JTOT),PERIOD(JTOT),COI(N),GWS(JTOT)
      DOUBLE PRECISION POWER(N,JTOT),PHASE(N,JTOT)
      DOUBLE PRECISION DOF(JTOT),FFTTHEOR(JTOT),SIGNIF(JTOT)
      DOUBLE PRECISION YMEAN,YSD,LAG1,CDELTA,PSI0,R1
C NCLEND
C                                             LOCAL and  AUTOMATIC
      DOUBLE COMPLEX CWAVE(N,JTOT)
      DOUBLE PRECISION YVAR,RAD
      INTEGER J,K
C
      YMEAN = 0.0D0
      YVAR = 0.0D0
      YSD = 0.0D0
      LAG1 = 0.0D0
      NADOF(1) = 0.0D0
      NADOF(2) = 0.0D0
C
      DO J = 1,JTOT
          SCALE(J) = 0.0D0
          FFTTHEOR(J) = 0.0D0
          SIGNIF(J) = 0.0D0
          PERIOD(J) = 0.0D0
      END DO

      DO K = 1,N
          COI(K) = 0.0D0
      END DO

      RAD = 4.D0*ATAN(1.)/180.d0

    1 DO J = 1,JTOT
          DO K = 1,N
              CWAVE(K,J) = (0.0D0,0.0D0)
              POWER(K,J) = 0.0D0
              PHASE(K,J) = 0.0D0
          END DO
      END DO
C                                             CALCULATE SOME STATS
      CALL STATSWAVE(N,Y,NOISE,YMEAN,YVAR,YSD,LAG1)
C                                             CALL USING COMPLEX
      CALL WAVELET(N,Y,DT,MOTHER,PARAM,S0,DJ,JTOT,NPAD,YMEAN,YVAR,
     +             CWAVE,SCALE,PERIOD,COI)
C                                             RETURN REALS to NCL
      DO J = 1,JTOT
        GWS(J) = 0.0D0
        DO K = 1,N
          WAVE(K,J,1) = DBLE(CWAVE(K,J))
          WAVE(K,J,2) = DIMAG(CWAVE(K,J))
          POWER(K,J)  = WAVE(K,J,1)**2 + WAVE(K,J,2)**2
          PHASE(K,J)  = ATAN2(DIMAG(CWAVE(K,J)),DBLE(CWAVE(K,J)))/RAD
          GWS(J) = GWS(J) + WAVE(K,J,1)**2 + WAVE(K,J,2)**2
        END DO
        GWS(J) = GWS(J)/DBLE(N)
      END DO
C                            NADOF could be used here
      IF (ISIGTEST.EQ.1) THEN
          DO J = 1,JTOT
              DOF(J) = N - SCALE(J)
          END DO
      ELSE
          IF (ISIGTEST.EQ.2) THEN
              DOF(1) = NADOF(1)
              DOF(2) = NADOF(2)
          END IF
      END IF

      R1 = LAG1
      IF (NOISE.EQ.0) THEN
          R1 = 0.0D0
      END IF

C                                             SIGNIFICANCE TESTING
      CALL WAVE_SIGNIF(ISIGTEST,N,Y,DT,MOTHER,PARAM,DJ,JTOT,SCALE,
     +                 PERIOD,R1,SIGLVL,DOF,FFTTHEOR,SIGNIF,YMEAN,
     +                 YVAR,CDELTA,PSI0)

      RETURN
      END

C -------- wavelet_default ----------------------------
C     SUBROUTINE WAVELETDF90 (N,Y,MOTHER)
C     INTEGER N, MOTHER
C     REAL    Y(N)
C     real, allocatable, dimension(:)     :: scale, period, coi
C     real, allocatable, dimension(:)     :: dof, ffttheor,signif
C     real, allocatable, dimension(:,:,:) :: wave

C                                             INPUT
C     INTEGER  N, MOTHER, JTOT, NPAD, NOISE, ISIGTEST
C     REAL  Y(N), DT, PARAM, S0, DJ, SIGLVL


C NCL: wave = wavelet_default (y, mother)

c     IF (MOTHER.LE.0 .OR. MOTHER.GT.2) THEN
c         PARAM = 6.0
c     ELSEIF (MOTHER.EQ.1) THEN
c         PARAM = 4.0
c     ELSEIF (MOTHER.EQ.2) THEN
c         PARAM = 2.0
c     END IF
C                                             DEFAULT/TYPICAL VALUES
C     DT = 1.0
c     S0 = 2.*DT
c     DJ = 0.25
c     JTOT = 1+(LOG2(N*DT/S0))/DJ
c     NPAD = N
c     NOISE= 1
c     ISIGTEST = 0
c     SIGLVL   = 0.05

c     ALLOCATE (COI(N), STAT=KER)

c     ALLOCATE (SCALE(JTOT), STAT=KER)
c     ALLOCATE (PERIOD(JTOT), STAT=KER)
c     ALLOCATE (DOF(JTOT), STAT=KER)
c     ALLOCATE (FFTTHEOR(JTOT), STAT=KER)
c     ALLOCATE (SIGNIF(JTOT), STAT=KER)

C     ALLOCATE (WAVE(N,JTOT,2), STAT=KER)

c     CALL WAVELETI(N, Y,DT,MOTHER,PARAM,S0,DJ,JTOT,NPAD,NOISE
c    1             ,ISIGTEST,SIGLVL
c    2             ,WAVE, SCALE, PERIOD, COI, DOF, FFTTHEOR
c    3             ,SIGNIF,YMEAN, YSD, LAG1)
C -----------------------------------------------------

      SUBROUTINE STATSWAVE (N, Y, NOISE, YMEAN, YVAR, YSD, LAG1)

      IMPLICIT NONE
      INTEGER  N, NOISE
      DOUBLE PRECISION  Y(N), YMEAN, YVAR, YSD, LAG1
      
      DOUBLE PRECISION  YTMP
      INTEGER K
 
      YMEAN = 0.0
      YVAR  = 0.0
      DO K=1,N
         YMEAN = YMEAN + Y(K)
         YVAR  = YVAR  + Y(K)*Y(K)
      END DO

      YTMP  = YMEAN*YMEAN/N
      YVAR  = MAX( (YVAR-YTMP)/N , 0.D0 ) ! prevent possible roundoff
      YMEAN = YMEAN/N

      DO K=1,N-1
         LAG1 = LAG1 + (Y(K+1)-YMEAN)*(Y(K)-YMEAN)
      END DO 
      LAG1 = (LAG1/(N-1.))/YVAR

      YSD   = SQRT(YVAR)

      RETURN
      END

C -------------------------------------------------------
      SUBROUTINE WAVEJTOT(N,DT,S0,DJ,JTOT)
      DOUBLE PRECISION DT,S0,DJ
      INTEGER JTOT,N

C      JTOT = 1 + (LOG2(N*DT/S0))/DJ
      JTOT = 1 + ((LOG(N*DT/S0))/DJ)/LOG(2.D0)

      RETURN
      END

C****************************************************************************
C
C WAVEPACK:  routines to compute the wavelet transform of a time series,
C            and significance levels.
C
C Written by:   Christopher Torrence and Gilbert P. Compo
C
C Available from:  http://paos.colorado.edu/research/wavelets/
C
C Requires the following packages:   CFFTPACK, CHISQR
C
C Notes:
C
C  (1) All routines are written in single precision (DOUBLE PRECISION),
C      except for CHISQR, which requires double precision input.
C      Single precision should be sufficient for most applications.
C
C  (2) The CFFTPACK and CHISQR routines were not written by us,
C      and no guarentees are made as to their reliability or efficiency.
C
C  (3) No provision is made for output to files or to graphics packages.
C      The user is expected to call these routines from within
C      their own programs. See sample program "wavetest.f".
C
C  (4) Little error checking is done. Check your input carefully.
C      The programs are not completely ANSI compatible, so use caution.
C
C  (5) Time series are currently limited to 65535 points.
C
C
C Reference: Torrence, C. and G. P. Compo, 1998: A Practical Guide to
C            Wavelet Analysis. <I>Bull. Amer. Meteor. Soc.</I>, 79, 61-78.
C
C Notice: Please acknowledge the use of this software in any publications:
C    ``Wavelet software was provided by C. Torrence and G. Compo,
C      and is available at URL: http://paos.colorado.edu/research/wavelets/''.
C
C  Copyright (C) 1998, Christopher Torrence
C This software may be used, copied, or redistributed as long as it is not
C sold and this copyright notice is reproduced on each copy made.  This
C routine is provided as is without any express or implied warranties
C whatsoever.
C
C
C Modified: November 1999 by Arjan van Dijk to include IMPLICIT NONE and
C           to convert all routines to DOUBLE precision.
C****************************************************************************




C****************************************************************************
C WAVELET: computes the wavelet transform of a time series,
C          with appropriate parameters.
C
C
C INPUTS:
C
C  n [INT] = the number of points in "y".
C
C  y [DOUBLE PRECISION] = the time series of length "n".
C
C  dt [DOUBLE PRECISION] = amount of time between each Y value, i.e. the sampling time.
C
C  mother [INT] = An integer giving the mother wavelet to use.
C                     0='Morlet'
C                     1='Paul'
C                     2='DOG' (derivative of Gaussian)
C                 If (mother<0 or >2) then default is 'Morlet'.
C
C  param [DOUBLE PRECISION] = mother wavelet parameter. If <0 then default is used.
C            For 'Morlet' this is k0 (wavenumber), default is 6.
C            For 'Paul' this is m (order), default is 4.
C            For 'DOG' this is m (m-th derivative), default is 2.
C
C
C  s0 [DOUBLE PRECISION] = the smallest scale of the wavelet.  Typically = 2*dt.
C         Note: for accurate reconstruction and variance computation
C             set s0=dt for Morlet; s0=dt/4 for Paul
C
C  dj [DOUBLE PRECISION] = the spacing between discrete scales. Typically = 0.25.
C         A smaller # will give better scale resolution, but be slower.
C
C  jtot [INT] = the # of scales.
C               Scales range from s0 up to s0*2^[(jtot-1)*dj],
C               Typically jtot=1+(LOG2(n dt/s0))/dj
C
C  npad [INT] = the total number of points (including padding) to
C               use for the wavelet transform. Typically this is some
C               power of 2. It must be greater or equal to "n".
C               If npad>n, then zeroes are padded onto the end
C               of the time series.
C
C
C OUTPUTS:
C
C  wave [DCMPLX(n,jtot)] = 2D array of the real & imaginary parts
C                   of the wavelet transform, versus time & scale.
C                   CABS(wave) gives the WAVELET amplitude,
C                   ATAN2(AIMAG(wave),DBLE(wave)) gives WAVELET phase.
C                   The WAVELET power spectrum is CABS(wave)**2.
C
C  scale [DOUBLE PRECISION(jtot)] = the wavelet scales that were used.
C
C  period [DOUBLE PRECISION(jtot)] = the "Fourier" periods (in time units) corresponding
C            to "scale".
C
C  coi [DOUBLE PRECISION(n)] = the e-folding factor used for the cone of influence.
C
C
C REQUIRES:   WAVE_FUNCTION, CFFTPACK
C
C  Copyright (C) 1998, Christopher Torrence and Gilbert P. Compo
C This software may be used, copied, or redistributed as long as it is not
C sold and this copyright notice is reproduced on each copy made.  This
C routine is provided as is without any express or implied warranties
C whatsoever.

      SUBROUTINE WAVELET (n,y,dt,mother,param,s0,dj,jtot,npad,ymean,
     &                    yvar,wave,scale,period,coi)
      IMPLICIT none

      INTEGER n,mother,jtot,npad
      DOUBLE PRECISION y(n),dt,param,s0,dj,scale(jtot),period(jtot),
     &  coi(n)
      DOUBLE COMPLEX wave(n,jtot)

      INTEGER i,j,k,nk
      DOUBLE PRECISION ymean,yvar,freq1,pi,period1,coi1

C** initialize work arrays
      PARAMETER (nk=65535)
      DOUBLE PRECISION wsave(4*nk+15),kwave(nk)
      DOUBLE COMPLEX yfft(nk),daughter(nk)

      pi = 4.D0*ATAN(1.D0)

      IF (npad.LT.n) THEN
        PRINT*,'**WAVELET: "npad" must be greater than or equal to "n"'
        RETURN
      END IF

      IF ((mother.LT.0).OR.(mother.GT.2)) mother = 0

C** find the time-series mean & remove it
c Don't need to calculate the mean here because it is being done in the
c NCL driver interface for wavelet.
c
c      ymean = 0.D0
c      DO 10 i=1,n
c        ymean = ymean + y(i)
c10    CONTINUE
c      ymean = ymean/n
      DO 15 i=1,n
        yfft(i) = y(i) - ymean
15    CONTINUE

C** if desired, pad with extra zeroes
      DO 20 i=n+1,npad
        yfft(i) = 0.D0
20    CONTINUE

C** find the FFT of the time series [Eqn(3)]
      CALL CFFTI(npad,wsave)
      CALL CFFTF(npad,yfft,wsave)
      DO 30 k=1,npad
        yfft(k) = yfft(k)/npad
30    CONTINUE

C** construct the wavenumber array [Eqn(5)]
      freq1 = 2.D0*pi/(DBLE(npad)*dt)
      kwave(1) = 0.D0
      DO 40 i=2,npad/2+1
        kwave(i) = (DBLE(i)-1.D0)*freq1
40    CONTINUE
      DO 50 i=npad/2+2,npad
        kwave(i) = -kwave(npad-i+2)
50    CONTINUE

c**----- Main wavelet loop
c      PRINT '(A8,2A12,/,5X,27("-"))','j','scale','period'
      DO 100 j=1,jtot
        scale(j) = s0*(2.D0**(DBLE(j-1)*dj))
        CALL WAVE_FUNCTION(npad,dt,mother,param,scale(j),
     &                   kwave,period1,coi1,daughter)
        period(j) = period1
C**    multiply the daughter by the time-series FFT
        DO 60 k=1,npad
          daughter(k) = daughter(k)*yfft(k)
60      CONTINUE
C**    inverse FFT [Eqn(4)]
        CALL CFFTB(npad,daughter,wsave)
C**    store the wavelet transform, discard zero-padding at end
        DO 70 i=1,n
          wave(i,j) = daughter(i)
70      CONTINUE
c        PRINT '(I8,2F12.3)',j,scale(j),period(j)
100   CONTINUE
c**----- end loop

C** construct the cone of influence
      DO 110 i=1,(n+1)/2
        coi(i) = coi1*dt*(DBLE(i)-1.D0)
        coi(n-i+1) = coi(i)
110   CONTINUE

      RETURN
      END


C****************************************************************************
C WAVE_FUNCTION: computes the daughter wavelets for a particular
C                wavelet function, with appropriate parameters.
C
C
C INPUTS:
C
C  nk [INT] = the number of points in "kwave"
C
C  dt [DOUBLE PRECISION] = amount of time between each Y value, i.e. the sampling time.
C
C  mother [INT] = An integer giving the mother wavelet to use.
C                     0='Morlet'
C                     1='Paul'
C                     2='DOG' (derivative of Gaussian)
C
C  param [DOUBLE PRECISION] = mother wavelet parameter. If <0 then default is used.
C            For 'Morlet' this is k0 (wavenumber), default is 6.
C            For 'Paul' this is m (order), default is 4.
C            For 'DOG' this is m (m-th derivative), default is 2.
C
C  scale1 [DOUBLE PRECISION] = the wavelet scale used to construct the daughter.
C
C  kwave [DOUBLE PRECISION(n)] = vector of wavenumbers, used to construct daughter.
C
C
C OUTPUTS:
C
C  period1 [DOUBLE PRECISION] = the "Fourier" period (in time units) that corresponds
C            to "scale1".
C
C  coi1 [DOUBLE PRECISION] = the e-folding factor used for the cone of influence.
C
C  daughter [DCMPLX(nk)] = real & imaginary parts of the wavelet function
C                         at "scale1" and "kwave".
C
C
C REQUIRES:   FACTORIAL, CHISQR
C
C
C Reference: Tables 1 & 2 in
C            Torrence, C. and G. P. Compo, 1998: A Practical Guide to
C            Wavelet Analysis. <I>Bull. Amer. Meteor. Soc.</I>, 79, 61-78.
C
C  Copyright (C) 1998, Christopher Torrence and Gilbert P. Compo
C This software may be used, copied, or redistributed as long as it is not
C sold and this copyright notice is reproduced on each copy made.  This
C routine is provided as is without any express or implied warranties
C whatsoever.

      SUBROUTINE WAVE_FUNCTION (nk,dt,mother,param,scale1,
     &                          kwave,period1,coi1,daughter)
      IMPLICIT none

      INTEGER nk,mother
      DOUBLE PRECISION dt,kwave(nk),param,scale1,period1,coi1
      DOUBLE COMPLEX daughter(nk)

      DOUBLE PRECISION expnt,sk,pi,norm,fourier_factor
      INTEGER k,m,factorial
      DOUBLE PRECISION gamma

      pi = 4.D0*ATAN(1.D0)

      IF (mother.EQ.0) THEN
C*******************************************   Morlet wavelet
        IF (param.LT.0) param = 6.D0
        norm = SQRT(2.D0*pi*scale1/dt)*(pi**(-0.25D0))
        DO 10 k=1,nk/2+1
          expnt = -0.5D0*(scale1*kwave(k) - param)**2
          daughter(k) = DCMPLX(norm*EXP(expnt))
10      CONTINUE
         DO 20 k=nk/2+2,nk
          daughter(k) = DCMPLX(0.D0)
20      CONTINUE
        fourier_factor = (4.D0*pi)/(param + SQRT(2.D0+param**2))
        period1 = scale1*fourier_factor
        coi1 = fourier_factor/SQRT(2.D0)
      ELSE IF (mother.EQ.1) THEN
C*******************************************   Paul wavelet
        IF (param.LT.0) param = 4.D0
        m = INT(param)
        norm = SQRT(2.D0*pi*scale1/dt)*
     &         (2.D0**m/SQRT(DBLE(m*FACTORIAL(2*m-1))))
        DO 30 k=1,nk/2+1
          expnt = -scale1*kwave(k)
          daughter(k) = DCMPLX(norm*(scale1*kwave(k))**m*EXP(expnt))
30      CONTINUE
         DO 40 k=nk/2+2,nk
          daughter(k) = DCMPLX(0.D0)
40      CONTINUE
        fourier_factor = (4.D0*pi)/(2.D0*m + 1.D0)
        period1 = scale1*fourier_factor
        coi1 = fourier_factor*SQRT(2.D0)
      ELSE IF (mother.EQ.2) THEN
C*******************************************   DOG wavelet
        IF (param.LT.0) param = 2.D0
        m = INT(param)
        norm = SQRT(2.D0*pi*scale1/dt)*SQRT(1.D0/GAMMA(m+0.5D0))
        norm = -norm*(DCMPLX(0.D0,1.D0)**m)
        DO 50 k=1,nk
          sk = scale1*kwave(k)
          daughter(k) = norm*(sk**m)*EXP(-0.5D0*sk**2)
50      CONTINUE
        fourier_factor = 2.D0*pi*SQRT(2.D0/(2.D0*m+1.D0))
        period1 = scale1*fourier_factor
        coi1 = fourier_factor/SQRT(2.D0)
      ELSE
        stop
      END IF
      RETURN
      END


C****************************************************************************
C FACTORIAL: compute the factorial (n!) of an integer n
C  Copyright (C) 1998, Christopher Torrence
      FUNCTION FACTORIAL(n)
      IMPLICIT NONE
      INTEGER factorial,n,i

      factorial = 1
      DO 10 i=1,n
        factorial = factorial*i
10    CONTINUE
      END



C****************************************************************************
C WAVE_SIGNIF: computes the significance levels for a wavelet transform.
C
C
C INPUTS:
C
C  isigtest [INT] = 0, 1, or 2.
C
C          If 0, then just do a regular chi-square test,
C                i.e. Eqn (18) from Torrence & Compo.
C          If 1, then do a "time-average" test, i.e. Eqn (23).
C                In this case, DOF(j) should be set to NA, the number
C                of local wavelet spectra that were averaged together
C                at each scale. For the Global Wavelet Spectrum,
C                this would be dof(j)=N-scale(j),
C                where N is the number of points in your time series.
C          If 2, then do a "scale-average" test, i.e. Eqns (25)-(28).
C                In this case, "dof(1)" and "dof(2)" should be set to the
C                smallest (S1) and largest (S2) scales that were averaged
C                together, respectively.
C                e.g. if you scale-averaged scales between 2 and 8,
C                     then dof(1)=2.0 and dof(2)=8.0
C
C
C  n [INT] = the number of points in "y".
C
C  y [DOUBLE PRECISION] = the time series of length "n".
C
C  dt [DOUBLE PRECISION] = amount of time between each Y value, i.e. the sampling time.
C
C  mother [INT] = An integer giving the mother wavelet to use.
C                     0='Morlet'
C                     1='Paul'
C                     2='DOG' (derivative of Gaussian)
C
C  param [DOUBLE PRECISION] = mother wavelet parameter.
C
C  s0 [DOUBLE PRECISION] = the smallest scale of the wavelet.
C
C  dj [DOUBLE PRECISION] = the spacing between discrete scales.
C
C  jtot [INT] = the # of scales.
C
C  scale [DOUBLE PRECISION(jtot)] = the wavelet scales that were used.
C
C  period [DOUBLE PRECISION(jtot)] = the "Fourier" periods corresponding to "scale".
C
C  lag1 [DOUBLE PRECISION] = lag 1 Autocorrelation, used for signif levels.
C                Default is 0.0, which corresponds to white-noise.
C
C  siglvl [DOUBLE PRECISION] = significance level to use. Default is 0.05 (the "5%" level)
C
C  dof [DOUBLE PRECISION(jtot)] = degrees-of-freedom for signif test.
C     IF SIGTEST=0, then the input dof is ignored.
C     IF SIGTEST=1, then dof(j) = NA, the number of times averaged together.
C     IF SIGTEST=2, then dof(1)=S1, dof(2)=S2, the range of scales averaged.
C
C
C OUTPUTS:
C
C  dof [DOUBLE PRECISION(jtot)] = degrees-of-freedom that were actually used.
C     IF SIGTEST=0, then dof(j) = 2 (or 1 for the 'DOG')
C     IF SIGTEST=1, then dof(j) = degrees-of-freedom versus scale.
C     IF SIGTEST=2, then dof(1)=degrees-of-freedom, dof(2...jtot)=0.0
C
C  fft_theor [DOUBLE PRECISION(jtot)] = theoretical red-noise spectrum vs scale.
C     IF SIGTEST=2, then fft_theor(1) = the average spectrum from S1-->S2
C                        fft_theor(2...jtot) = 0.0
C
C  signif [DOUBLE PRECISION(jtot)] = significance levels vs scale.
C     IF SIGTEST=2, then signif(1) = the significance level
C                        signif(2...jtot) = 0.0
C
C  ymean [DOUBLE PRECISION] = the mean of the time series.
C
C  variance [DOUBLE PRECISION] = the variance of the time series.
C
C  Cdelta [DOUBLE PRECISION] = the constant "Cdelta" for the mother wavelet (Table 2).
C
C  psi0[DOUBLE PRECISION] = the constant 'psi(0)' for the mother wavelet (Table 2)
C
C REQUIRES:   CHISQR
C
C  Copyright (C) 1998, Christopher Torrence and Gilbert P. Compo
C This software may be used, copied, or redistributed as long as it is not
C sold and this copyright notice is reproduced on each copy made.  This
C routine is provided as is without any express or implied warranties
C whatsoever.

      SUBROUTINE WAVE_SIGNIF (isigtest,n,y,dt,mother,param,dj,jtot,
     &       scale,period,lag1,siglvl,dof,fft_theor,signif,
     &       ymean,variance,Cdelta,psi0)
      IMPLICIT none

      INTEGER isigtest,n,mother,jtot
      DOUBLE PRECISION y(n),dt,param,dj,scale(jtot),period(jtot)
      DOUBLE PRECISION lag1,siglvl,dof(jtot),fft_theor(jtot),
     &  signif(jtot)
      DOUBLE PRECISION ymean,variance,Cdelta,psi0

      INTEGER i,j,m,status,javg1,javg2,navg
      DOUBLE PRECISION pi,freq1,dofmin,gammafac,dj0,Savg,Smid
      DOUBLE PRECISION fft_theor1
      DOUBLE PRECISION chisqr,p,q,bound

      pi = 4.D0*ATAN(1.D0)

      IF (siglvl.LE.0.) siglvl = 0.05D0
      IF (lag1.LE.0.D0) lag1 = 0.D0

      Cdelta = -1.D0
      gammafac = -1.D0
      dj0 = -1.D0
      psi0 = -1.D0

      IF (mother.EQ.0) THEN
C*******************************************   Morlet wavelet
        dofmin = 2.D0
        IF (param.EQ.6.D0) THEN
          Cdelta = 0.776D0
          gammafac = 2.32D0
          dj0 = 0.60D0
          psi0 = pi**(-0.25D0)
        END IF
      ELSE IF (mother.EQ.1) THEN
C*******************************************   Paul wavelet
        m = INT(param)
        dofmin = 2.D0
        IF (m.EQ.4) THEN
          Cdelta = 1.132D0
          gammafac = 1.17D0
          dj0 = 1.5D0
          psi0 = 1.079D0
        END IF
      ELSE IF (mother.EQ.2) THEN
C*******************************************   DOG wavelet
        m = INT(param)
        dofmin = 1.D0
        IF (m.EQ.2) THEN
          Cdelta = 3.541D0
          gammafac = 1.43D0
          dj0 = 1.4D0
          psi0 = 0.867D0
        ELSE IF (m.EQ.6) THEN
          Cdelta = 1.966D0
          gammafac = 1.37D0
          dj0 = 0.97D0
          psi0 = 0.884D0
        END IF
      ELSE
        stop
      END IF

C** find the time-series variance
      ymean = 0.D0
      DO 10 i=1,n
        ymean = ymean + y(i)
10    CONTINUE
      ymean = ymean/n
      variance = 0.D0
      DO 15 i=1,n
        variance = variance + (y(i) - ymean)**2
15    CONTINUE
      variance = variance/(DBLE(n)) ! - 1.D0)

C** construct theoretical red(white)-noise power spectrum [Eqn(16)]
      DO 20 j=1,jtot
        freq1 = dt/period(j)
        fft_theor(j) = variance*(1.D0-lag1**2)/
     &                 (1.D0 - 2.D0*lag1*COS(freq1*2.D0*pi) + lag1**2)
20    CONTINUE

      q = DBLE(siglvl)
      p = 1d0 - q

      IF (isigtest.EQ.0) THEN
C*******************************************   no smoothing, dof=dofmin
C   see Eqn(18)
        DO 30 j=1,jtot
          dof(j) = dofmin
          CALL CDFCHI(2,p,q,chisqr,DBLE(dofmin),status,bound)
          signif(j) = fft_theor(j)*chisqr/dofmin
30      CONTINUE
      ELSE IF (isigtest.EQ.1) THEN
C***********************************   time-averaged, dof depend on scale
        IF (gammafac.LE.0.D0) THEN
        PRINT*,'**WAVE_SIGNIF: "gammafac" undefined for this wavelet'
          RETURN
        END IF
        DO 40 j=1,jtot
            IF (dof(j).LT.1.) dof(j) = 1.D0
C   see Eqn(23)
            dof(j) = dofmin*SQRT(1.D0+(dof(j)*dt/gammafac/scale(j))**2)
            IF (dof(j).LT.dofmin) dof(j) = dofmin
            CALL CDFCHI(2,p,q,chisqr,DBLE(dof(j)),status,bound)
            signif(j) = fft_theor(j)*chisqr/dof(j)
40      CONTINUE
       ELSE IF (isigtest.EQ.2) THEN
C***********************************   scale-averaged, dof depend on scale
        IF (Cdelta.LE.0.) THEN
          PRINT*,'**WAVE_SIGNIF: "Cdelta" and "dj0" '//
     &     'undefined for this wavelet'
          RETURN
        END IF
        javg1 = 0
        javg2 = 0
        DO 50 j=1,jtot
          IF ((scale(j).GE.dof(1)).AND.(javg1.EQ.0)) javg1 = j
          IF (scale(j).LE.dof(2)) javg2 = j
50      CONTINUE
        IF ((javg1.EQ.0).OR.(javg2.EQ.0).OR.(javg1.GT.javg2)) THEN
          PRINT*,'**WAVE_SIGNIF: Scales in "dof(1)" & "dof(2)" '//
     &     'are out of range.'
          RETURN
        END IF
        navg = javg2 - javg1 + 1
C   see Eqn(25)
        Savg = 0.D0
        DO 60 j=javg1,javg2
          Savg = Savg + 1.D0/scale(j)
60      CONTINUE
        Savg = 1.D0/Savg
C   see Eqn(27)
        fft_theor1 = 0.D0
        DO 70 j=javg1,javg2
          fft_theor1 = fft_theor1 + fft_theor(j)/scale(j)
70      CONTINUE
        fft_theor(1) = Savg*fft_theor1
C   see Eqn(28)
        Smid = EXP(0.5D0*(LOG(scale(javg1)) + LOG(scale(javg2))))
        dof(1) = (dofmin*navg*Savg/Smid)*SQRT(1 + (navg*dj/dj0)**2)
C   see Eqn(26)
        CALL CDFCHI(2,p,q,chisqr,DBLE(dof(1)),status,bound)
        signif(1)=(dj*dt/Cdelta/Savg)*fft_theor(1)*chisqr/dof(1)
        DO 80 j=2,jtot
          dof(j) = 0.D0
          fft_theor(j) = 0.D0
          signif(j) = 0.D0
80      CONTINUE
      ELSE
        stop
      END IF

      END

C
C	$Id: agpwrt.f,v 1.5 2008-07-27 00:23:00 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE AGPWRT (PX,PY,CS,NC,IS,IO,IC)
C
      CHARACTER*(*) CS
C
C This subroutine enables one to use PWRITX with AUTOGRAPH.  The results
C should be reasonably good, as long as nothing too fancy is tried.
C
C The basic notion of the routine is that calls to it with IC zeroed,
C implying that the string is to be centered on the point (PX,PY), may
C simply be passed directly to PWRITX without change and without much
C fear of problems caused by circumventing AUTOGRAPH's checks for labels
C that overlap.  Calls to it with IC non-zero, implying that the left
C or right end of the label is to be placed at (PX,PY) must be handled
C differently:  One character at a time is passed to PWRITX.
C
C What this means for the user is that function codes may appear in the
C x- and y-axis labels, in the graph label, and in any other label which
C has the centering parameter zeroed.  A label in which lots of function
C codes are used may look very long to AUTOGRAPH and cause it to shrink
C the character size for the label in order to prevent what it thinks is
C a potential overlap problem.  If this happens, see the consultants.
C
C CH holds single characters of CS.
C
      CHARACTER*1 CH
C
C If the centering option is zero, use PWRITX to do the whole string.
C
      IF (IC.EQ.0) THEN
        CALL PWRITX (PX,PY,CS,NC,IS,IO,0)
        RETURN
      END IF
C
C Otherwise, use PWRITX to produce one character at a time.
C
      CALL GETSET (F1,F2,G1,G2,X1,X2,Y1,Y2,LL)
C
      XS=REAL(IS)*COS(.017453292519943*REAL(IO))*(X2-X1)/
     +                                           REAL(KFPX(F2)-KFPX(F1))
      YS=REAL(IS)*SIN(.017453292519943*REAL(IO))*(Y2-Y1)/
     +                                           REAL(KFPY(G2)-KFPY(G1))
C
      FX=PX
      FY=PY
C
      IF (IC.GT.0) THEN
        FX=FX-REAL(NC)*XS
        FY=FY-REAL(NC)*YS
      END IF
C
      FX=FX-.5*XS
      FY=FY-.5*YS
C
         DO 101 I=1,NC
         FX=FX+XS
         FY=FY+YS
         CH=CS(I:I)
         CALL PWRITX (FX,FY,CH,1,IS,IO,0)
  101    CONTINUE
C
      RETURN
C
C REVISION HISTORY -----------------------------------------------------
C
C December, 1984        First put on XLIB.  Adapted from AGUSEPWRX.
C
C June, 1987            Modified to be GKS-compatible.
C
C August, 1987          Took out comments about XLIB.
C
C ----------------------------------------------------------------------
      END

C NCLFORTSTART
      subroutine gamfitd3 (datarr, n, dmsg, pcrit, invscale
     +                    ,alpha , scale, shape, pzero,ier)
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c based upon: www.unicam.it/matinf/pasef/docs/CDIIIsem/home/pidieffe/spi.pdf
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Estimate incomplete gamma parameters.
c
c Input:
c	datarr - data array
c	n      - size of datarr
c	dmsg   - missing data
c	pcrit  - scalar (int,float,double) specifying % non missing data
c	invscale -  if invscale=1, then return (1/beta)
c
c Output:
c	alpha (???), beta (scale), eta (shape) - gamma parameters
c	pzero - probability of zero.
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      implicit none
c                                                        INPUT
      integer n, invscale,  ier
      double precision datarr(n), dmsg, pcrit
c                                                        OUTPUT
      double precision shape, scale, alpha, pzero
c NCLEND
c                                                        LOCAL 
      integer i, nact, nmsg
      double precision    sum, sumlog, av, pobs, pc
      double precision    beta, eta
c     double precision    s, kappa

      shape = dmsg
      scale = dmsg
      alpha = dmsg

      beta  = scale
      eta   = shape
      pzero = dmsg

      ier = 0
      if (n .le. 0) then
          ier   = 1
c c c     write(*, *) 'Error in gamfit - empty data array'
          return
      end if

      sum    = 0.0d0
      sumlog = 0.0d0
      pzero  = 0.0d0
      nact   = 0
      nmsg   = 0

c	compute sums and counts

      do i = 1, n
         if (datarr(i) .ne. dmsg) then
             if (datarr(i) .gt. 0.0d0) then
                 sum    = sum + datarr(i)
                 sumlog = sumlog + log(datarr(i))
                 nact   = nact + 1
             else
                 pzero  = pzero + 1.0d0
             end if
         else
             nmsg = nmsg+1
         end if
      end do
c                             pobs id the total # of non-missing obs
      pobs = nact + pzero        
      pc   = 100d0*pobs/n
      if (pc.lt.pcrit) then
          ier = 2
c c c     write(*, *) 'too few observations'
          return
      end if

      pzero = pzero/pobs
      if (nact .gt. 0) av = sum / nact

c	Bogus data array but do something reasonable
      if (nact .eq. 1) then
          alpha = 0.0d0
          eta   = 1.0d0
          beta  = av
          return
      end if

c	They were all zeroes.
      if (pzero .eq. 1) then
          alpha = 0.0d0
          eta   = 1.0d0
          beta  = av
          return
      end if

c	Use MLE  (Maximum Liklihood Estimate)
c       A Note on the Gamma Distribution
c       Thom (1958): Monthly Weather Review, pp 117-122.
c       eqn 22 for gamma; just above eqn 21 "A" => alpha


      alpha = log(av)-(sumlog/nact)
      eta   = (1.0d0+sqrt(1.0d0+4.0d0*alpha/3.0d0))/(4.0d0*alpha)
      beta  = av/eta

c ------------
c http://en.wikipedia.org/wiki/Gamma_distribution#Maximum_likelihood_estimation
c alpha is "s" at the above url
c eta (shape)  is approximately "kappa" at the above url
c       The numbers for eta and kappa are very similar

c c c s     = alpha
c c c kappa = (3-s+sqrt((s-3)**2 + 24*s))/(12*s)
c ------------

      if (invscale.eq.1 .and. beta.gt.0.0d0) then
          beta = 1.0d0/beta
      end if

      shape = eta  
      scale = beta

      return
      end

c======================================================================
c
c !IROUTINE: WETBULBCALC -- Calculate wet bulb temperature (C)
c
c !DESCRIPTION:
c
c   Calculates wet bulb temperature in C, given pressure in 
c      temperature in K and mixing ratio in kg/kg.
c
c !INPUT:
c    nx     - index for x dimension
c    ny     - index for y dimension
c    nz     - index for z dimension
c    prs    - pressure (mb)
c    tmk    - temperature (K)
c    qvp    - water vapor mixing ratio (kg/kg)
c
c !OUTPUT:
c    twb    - Wet bulb temperature (C)
c
c !ASSUMPTIONS:
c
c !REVISION HISTORY:
c     2009-March  - Mark T. Stoelinga - from RIP4.5
c     2010-August - J. Schramm
c     2014-March - A. Jaye - modified to run with NCL and ARW wrf output
c
c !INTERFACE:
c ------------------------------------------------------------------
C NCLFORTSTART
      subroutine wetbulbcalc(prs,tmk,qvp,twb,nx,ny,nz,psafile)
      implicit none
      integer nx, ny, nz
      double precision prs(nz,ny,nx)
      double precision tmk(nz,ny,nx)
      double precision qvp(nz,ny,nx)
      double precision twb(nz,ny,nx)
      character*(*) psafile
C NCLEND
      integer i,j,k
      integer jtch,jt,ipch,ip
      double precision q, t, p, e, tlcl, eth
      double precision fracip,fracip2,fracjt,fracjt2
      double precision PSADITHTE(150),PSADIPRS(150),PSADITMK(150,150)
      double precision tonpsadiabat
      double precision eps,tlclc1,tlclc2,tlclc3,tlclc4,gamma
      double precision gammamd,thtecon1,thtecon2,thtecon3,celkel
      double precision rgas,rgasmd,cp,cpmd

c
c  Before looping, set lookup table for getting temperature on
c  a pseudoadiabat.
c
      CALL DLOOKUP_TABLE(PSADITHTE,PSADIPRS,PSADITMK,psafile)

c  Define constants

      rgas=287.04  !J/K/kg
      rgasmd=.608   ! rgas_moist=rgas*(1.+rgasmd*qvp)
      cp=1004.     ! J/K/kg  Note: not using Bolton's value of 1005.7
      cpmd=.887   ! cp_moist=cp*(1.+cpmd*qvp)
      eps=0.622
      tlclc1=2840.
      tlclc2=3.5
      tlclc3=4.805
      tlclc4=55.
      gamma=rgas/cp
      gammamd=rgasmd-cpmd  ! gamma_moist=gamma*(1.+gammamd*qvp)
      thtecon1=3376. ! K
      thtecon2=2.54
      thtecon3=.81
      celkel=273.15

      DO k=1,nx
        DO j=1,ny
          DO i=1,nz
            q=dmax1(qvp(i,j,k),1.d-15)
            t=tmk(i,j,k)
            p=prs(i,j,k)/100.
            e=q*p/(eps+q)
            tlcl=tlclc1/(dlog(t**tlclc2/e)-tlclc3)+tlclc4
            eth=t*(1000./p)**(gamma*(1.+gammamd*q))*
     &         exp((thtecon1/tlcl-thtecon2)*q*(1.+thtecon3*q))


c
c   Now we need to find the temperature (in K) on a moist adiabat
c   (specified by eth in K) given pressure in hPa.  It uses a
c   lookup table, with data that was generated by the Bolton (1980)
c   formula for theta_e.
c
c     First check if pressure is less than min pressure in lookup table.
c     If it is, assume parcel is so dry that the given theta-e value can
c     be interpretted as theta, and get temperature from the simple dry
c     theta formula.
c

            if (p.le.psadiprs(150)) then
              tonpsadiabat=eth*(p/1000.)**gamma
            else   
c
c   Otherwise, look for the given thte/prs point in the lookup table.
c
            do jtch=1,150-1
              if (eth.ge.psadithte(jtch).and.eth.lt.
     &              psadithte(jtch+1)) then
                 jt=jtch
                 goto 213
              endif
            enddo
            jt=-1
 213        continue
            do ipch=1,150-1
              if (p.le.psadiprs(ipch).and.p.gt.psadiprs(ipch+1)) then
                 ip=ipch
                 goto 215
              endif
            enddo
            ip=-1
 215        continue
            if (jt.eq.-1.or.ip.eq.-1) then
               print*,
     &           'Outside of lookup table bounds. prs,thte=',p,eth
              stop
            endif
            fracjt=(eth-psadithte(jt))/(psadithte(jt+1)-psadithte(jt))
            fracjt2=1.-fracjt
            fracip=(psadiprs(ip)-p)/(psadiprs(ip)-psadiprs(ip+1))
            fracip2=1.-fracip
            if (psaditmk(ip,jt).gt.1e9.or.psaditmk(ip+1,jt).gt.1e9.or.
     &          psaditmk(ip,jt+1).gt.1e9.or.
     &          psaditmk(ip+1,jt+1).gt.1e9) then
                print*,
     &            'Tried to access missing tmperature in lookup table.'
                print*,
     &            'Prs and Thte probably unreasonable. prs,thte='
     &                   ,p,eth
               stop
            endif
            tonpsadiabat=fracip2*fracjt2*psaditmk(ip  ,jt  )+
     &             fracip *fracjt2*psaditmk(ip+1,jt  )+
     &             fracip2*fracjt *psaditmk(ip  ,jt+1)+
     &             fracip *fracjt *psaditmk(ip+1,jt+1)
            endif

            twb(i,j,k)=tonpsadiabat

          ENDDO
        ENDDO
      ENDDO

c
      return
      end
c======================================================================
c
c !IROUTINE: omgcalc -- Calculate omega (dp/dt)
c
c !DESCRIPTION:
c
c   Calculate approximate omega, based on vertical velocity w (dz/dt).
c   It is approximate because it cannot take into account the vertical
c   motion of pressure surfaces.
c
c !INPUT:
c    mx - index for x dimension
c    my - index for y dimension
c    mx -  index for vertical dimension
c    qvp - water vapor mixing ratio (kg/kg)
c    tmk - temperature (K)
c    www - vertical velocity (m/s)
c    prs -  pressure (Pa)
c
c !OUTPUT:
c    omg - omega (Pa/sec)
c
c !ASSUMPTIONS:
c
c !REVISION HISTORY:
c     2009-March  - Mark T. Stoelinga - from RIP4.5
c     2010-August - J. Schramm
c     2014-March - A. Jaye - modified to run with NCL and ARW wrf output
c
c ------------------------------------------------------------------
c NCLFORTSTART
      subroutine omgcalc(qvp,tmk,www,prs,omg,mx,my,mz)
      implicit none
      integer mx, my, mz
      double precision qvp(mz,my,mx)
      double precision tmk(mz,my,mx)
      double precision www(mz,my,mx)
      double precision prs(mz,my,mx) 
      double precision omg(mz,my,mx)
c NCLEND
c Local variables
      integer i, j, k
      double precision grav,rgas,eps 
c
c Constants
c
      grav=9.81           ! m/s**2
      rgas=287.04  !J/K/kg
      eps=0.622

      do k=1,mx
        do j=1,my
          do i=1,mz
            omg(i,j,k)=-grav*prs(i,j,k)/
     &        (rgas*((tmk(i,j,k)*(eps+qvp(i,j,k)))/
     &        (eps*(1.+qvp(i,j,k)))))*www(i,j,k)
          enddo
        enddo
      enddo
c
      return
      end
c======================================================================
c
c !IROUTINE: VIRTUAL_TEMP -- Calculate virtual temperature (K)
c
c !DESCRIPTION:
c
c   Calculates virtual temperature in K, given temperature
c      in K and mixing ratio in kg/kg.
c
c !INPUT:
c    NX     - index for x dimension
c    NY     - index for y dimension
c    NZ     - index for z dimension
c    RATMIX - water vapor mixing ratio (kg/kg)
c    TEMP   - temperature (K)
c
c !OUTPUT:
c    TV     - Virtual temperature (K)
c
c !ASSUMPTIONS:
c
c !REVISION HISTORY:
c     2009-March  - Mark T. Stoelinga - from RIP4.5
c     2010-August - J. Schramm
c     2014-March - A. Jaye - modified to run with NCL and ARW wrf output
c
c ------------------------------------------------------------------
C NCLFORTSTART
      SUBROUTINE VIRTUAL_TEMP(TEMP,RATMIX,TV,NX,NY,NZ)
      IMPLICIT NONE
      INTEGER NX,NY,NZ
      DOUBLE PRECISION TEMP(NZ,NY,NX)
      DOUBLE PRECISION RATMIX(NZ,NY,NX)
      DOUBLE PRECISION TV(NZ,NY,NX)
C NCLEND
      INTEGER I,J,K
      DOUBLE PRECISION EPS
      EPS = 0.622D0
      DO K=1,NX
        DO J=1,NY
          DO I=1,NZ
            TV(I,J,K) = TEMP(I,J,K)* (EPS+RATMIX(I,J,K))/ 
     &                     (EPS* (1.D0+RATMIX(I,J,K)))
          ENDDO
        ENDDO
      ENDDO
      RETURN
      END

C
C $Id: mdproj.f,v 1.12 2008-09-18 12:19:11 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MDPROJ (ARG1,ARG2,ARG3,ARG4)
C
        CHARACTER*(*)    ARG1
        DOUBLE PRECISION ARG2,ARG3,ARG4
C
C Declare required common blocks.  See MAPBDX for descriptions of these
C common blocks and the variables in them.
C
        COMMON /MAPCM0/  COS1,DTOR,DTRH,OOPI,PI,PIOF,PIOT,RTDD,RTOD,
     +                   SROT,SIN1,TOPI,TSRT
        DOUBLE PRECISION COS1,DTOR,DTRH,OOPI,PI,PIOF,PIOT,RTDD,RTOD,
     +                   SROT,SIN1,TOPI,TSRT
        SAVE   /MAPCM0/
C
        COMMON /MAPCM4/  GRDR,GRID,GRLA,GRLO,GRPO,OTOL,PDRE,PLA1,PLA2,
     +                   PLA3,PLA4,PLB1,PLB2,PLB3,PLB4,PLNO,PLTO,ROTA,
     +                   SRCH,XLOW,XROW,YBOW,YTOW,IDOT,IDSH,IDTL,ILCW,
     +                   ILTS,JPRJ,ELPF,INTF,LBLF,PRMF
        DOUBLE PRECISION GRDR,GRID,GRLA,GRLO,GRPO,OTOL,PDRE,PLA1,PLA2,
     +                   PLA3,PLA4,PLB1,PLB2,PLB3,PLB4,PLNO,PLTO,ROTA,
     +                   SRCH,XLOW,XROW,YBOW,YTOW
        INTEGER          IDOT,IDSH,IDTL,ILCW,ILTS,JPRJ
        LOGICAL          ELPF,INTF,LBLF,PRMF
        SAVE   /MAPCM4/
C
        COMMON /MAPCM5/  DDCT(5),DDCL(5),LDCT(6),LDCL(6),PDCT(19),
     +                   PDCL(19)
        CHARACTER*2      DDCT,DDCL,LDCT,LDCL,PDCT,PDCL
        SAVE   /MAPCM5/
C
        COMMON /MAPCMW/  CSLS,CSLT,SLTD,ISLT
        DOUBLE PRECISION CSLS,CSLT,SLTD
        INTEGER ISLT
        SAVE  /MAPCMW/
C
        COMMON /MAPSAT/  ALFA,BETA,DCSA,DCSB,DSNA,DSNB,SALT,SSMO,SRSS
        DOUBLE PRECISION ALFA,BETA,DCSA,DCSB,DSNA,DSNB,SALT,SSMO,SRSS
        SAVE   /MAPSAT/
C
C Declare local variables.
C
        INTEGER          I
C
C Check for an uncleared prior error.
C
        IF (ICFELL('MDPROJ - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C Transfer the parameters defining the projection.
C
        I=IDICTL(ARG1,PDCT,19)
        IF (I.EQ.0) I=IDICTL(ARG1,PDCL,19)
        IF (I.EQ.0) GO TO 901
C
        JPRJ=I-1
C
        PLTO=MAX(-90.D0,MIN(90.D0,ARG2))
        PLNO=ARG3+(SIGN(180.D0,180.D0-ARG3)-SIGN(180.D0,ARG3+180.D0))
C
C Fix for NCL-2558 -- dbrown -- 2/14/2016
C If Lambert Conformal then ARG4 is a latitude so treat it like ARG2
C
        IF (JPRJ .EQ. 1) THEN
          ROTA=MAX(-90.D0,MIN(90.D0,ARG4))
        ELSE
          ROTA=ARG4+(SIGN(180.D0,180.D0-ARG4)-SIGN(180.D0,ARG4+180.D0))
        END IF
C
        IF (JPRJ.EQ.3) THEN
          CALL MDSETD ('SA',0.D0)
          IF (ICFELL('MDPROJ',2).NE.0) RETURN
        ELSE IF (JPRJ.EQ.7) THEN
          ISLT=0
        ELSE IF (JPRJ.EQ.16) THEN
          JPRJ=3
          IF (ABS(SALT).LE.1.D0) THEN
            CALL MDSETD ('SA',6.631D0)
            IF (ICFELL('MDPROJ',3).NE.0) RETURN
          END IF
        ELSE IF (JPRJ.EQ.17) THEN
          JPRJ=7
          ISLT=1
        ELSE IF (JPRJ.EQ.18) THEN
          JPRJ=25
          PLTO=0.D0
        END IF
C
C Set the flag to indicate that initialization is now required.
C
        INTF=.TRUE.
C
C Done.
C
        RETURN
C
C Error exit.
C
  901   CALL MDPCEM ('MDPROJ - UNKNOWN PROJECTION NAME ',ARG1,4,1)
        RETURN
C
      END

      SUBROUTINE SLAED2( K, N, N1, D, Q, LDQ, INDXQ, RHO, Z, DLAMDA, W,
     $                   Q2, INDX, INDXC, INDXP, COLTYP, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     October 31, 1999
*
*     .. Scalar Arguments ..
      INTEGER            INFO, K, LDQ, N, N1
      REAL               RHO
*     ..
*     .. Array Arguments ..
      INTEGER            COLTYP( * ), INDX( * ), INDXC( * ), INDXP( * ),
     $                   INDXQ( * )
      REAL               D( * ), DLAMDA( * ), Q( LDQ, * ), Q2( * ),
     $                   W( * ), Z( * )
*     ..
*
*  Purpose
*  =======
*
*  SLAED2 merges the two sets of eigenvalues together into a single
*  sorted set.  Then it tries to deflate the size of the problem.
*  There are two ways in which deflation can occur:  when two or more
*  eigenvalues are close together or if there is a tiny entry in the
*  Z vector.  For each such occurrence the order of the related secular
*  equation problem is reduced by one.
*
*  Arguments
*  =========
*
*  K      (output) INTEGER
*         The number of non-deflated eigenvalues, and the order of the
*         related secular equation. 0 <= K <=N.
*
*  N      (input) INTEGER
*         The dimension of the symmetric tridiagonal matrix.  N >= 0.
*
*  N1     (input) INTEGER
*         The location of the last eigenvalue in the leading sub-matrix.
*         min(1,N) <= N1 <= N/2.
*
*  D      (input/output) REAL array, dimension (N)
*         On entry, D contains the eigenvalues of the two submatrices to
*         be combined.
*         On exit, D contains the trailing (N-K) updated eigenvalues
*         (those which were deflated) sorted into increasing order.
*
*  Q      (input/output) REAL array, dimension (LDQ, N)
*         On entry, Q contains the eigenvectors of two submatrices in
*         the two square blocks with corners at (1,1), (N1,N1)
*         and (N1+1, N1+1), (N,N).
*         On exit, Q contains the trailing (N-K) updated eigenvectors
*         (those which were deflated) in its last N-K columns.
*
*  LDQ    (input) INTEGER
*         The leading dimension of the array Q.  LDQ >= max(1,N).
*
*  INDXQ  (input/output) INTEGER array, dimension (N)
*         The permutation which separately sorts the two sub-problems
*         in D into ascending order.  Note that elements in the second
*         half of this permutation must first have N1 added to their
*         values. Destroyed on exit.
*
*  RHO    (input/output) REAL
*         On entry, the off-diagonal element associated with the rank-1
*         cut which originally split the two submatrices which are now
*         being recombined.
*         On exit, RHO has been modified to the value required by
*         SLAED3.
*
*  Z      (input) REAL array, dimension (N)
*         On entry, Z contains the updating vector (the last
*         row of the first sub-eigenvector matrix and the first row of
*         the second sub-eigenvector matrix).
*         On exit, the contents of Z have been destroyed by the updating
*         process.
*
*  DLAMDA (output) REAL array, dimension (N)
*         A copy of the first K eigenvalues which will be used by
*         SLAED3 to form the secular equation.
*
*  W      (output) REAL array, dimension (N)
*         The first k values of the final deflation-altered z-vector
*         which will be passed to SLAED3.
*
*  Q2     (output) REAL array, dimension (N1**2+(N-N1)**2)
*         A copy of the first K eigenvectors which will be used by
*         SLAED3 in a matrix multiply (SGEMM) to solve for the new
*         eigenvectors.
*
*  INDX   (workspace) INTEGER array, dimension (N)
*         The permutation used to sort the contents of DLAMDA into
*         ascending order.
*
*  INDXC  (output) INTEGER array, dimension (N)
*         The permutation used to arrange the columns of the deflated
*         Q matrix into three groups:  the first group contains non-zero
*         elements only at and above N1, the second contains
*         non-zero elements only below N1, and the third is dense.
*
*  INDXP  (workspace) INTEGER array, dimension (N)
*         The permutation used to place deflated values of D at the end
*         of the array.  INDXP(1:K) points to the nondeflated D-values
*         and INDXP(K+1:N) points to the deflated eigenvalues.
*
*  COLTYP (workspace/output) INTEGER array, dimension (N)
*         During execution, a label which will indicate which of the
*         following types a column in the Q2 matrix is:
*         1 : non-zero in the upper half only;
*         2 : dense;
*         3 : non-zero in the lower half only;
*         4 : deflated.
*         On exit, COLTYP(i) is the number of columns of type i,
*         for i=1 to 4 only.
*
*  INFO   (output) INTEGER
*          = 0:  successful exit.
*          < 0:  if INFO = -i, the i-th argument had an illegal value.
*
*  Further Details
*  ===============
*
*  Based on contributions by
*     Jeff Rutter, Computer Science Division, University of California
*     at Berkeley, USA
*  Modified by Francoise Tisseur, University of Tennessee.
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               MONE, ZERO, ONE, TWO, EIGHT
      PARAMETER          ( MONE = -1.0E0, ZERO = 0.0E0, ONE = 1.0E0,
     $                   TWO = 2.0E0, EIGHT = 8.0E0 )
*     ..
*     .. Local Arrays ..
      INTEGER            CTOT( 4 ), PSM( 4 )
*     ..
*     .. Local Scalars ..
      INTEGER            CT, I, IMAX, IQ1, IQ2, J, JMAX, JS, K2, N1P1,
     $                   N2, NJ, PJ
      REAL               C, EPS, S, T, TAU, TOL
*     ..
*     .. External Functions ..
      INTEGER            ISAMAX
      REAL               SLAMCH, SLAPY2
      EXTERNAL           ISAMAX, SLAMCH, SLAPY2
*     ..
*     .. External Subroutines ..
      EXTERNAL           SCOPY, SLACPY, SLAMRG, SROT, SSCAL, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, MAX, MIN, SQRT
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
*
      IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( LDQ.LT.MAX( 1, N ) ) THEN
         INFO = -6
      ELSE IF( MIN( 1, ( N / 2 ) ).GT.N1 .OR. ( N / 2 ).LT.N1 ) THEN
         INFO = -3
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'SLAED2', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
*
      N2 = N - N1
      N1P1 = N1 + 1
*
      IF( RHO.LT.ZERO ) THEN
         CALL SSCAL( N2, MONE, Z( N1P1 ), 1 )
      END IF
*
*     Normalize z so that norm(z) = 1.  Since z is the concatenation of
*     two normalized vectors, norm2(z) = sqrt(2).
*
      T = ONE / SQRT( TWO )
      CALL SSCAL( N, T, Z, 1 )
*
*     RHO = ABS( norm(z)**2 * RHO )
*
      RHO = ABS( TWO*RHO )
*
*     Sort the eigenvalues into increasing order
*
      DO 10 I = N1P1, N
         INDXQ( I ) = INDXQ( I ) + N1
   10 CONTINUE
*
*     re-integrate the deflated parts from the last pass
*
      DO 20 I = 1, N
         DLAMDA( I ) = D( INDXQ( I ) )
   20 CONTINUE
      CALL SLAMRG( N1, N2, DLAMDA, 1, 1, INDXC )
      DO 30 I = 1, N
         INDX( I ) = INDXQ( INDXC( I ) )
   30 CONTINUE
*
*     Calculate the allowable deflation tolerance
*
      IMAX = ISAMAX( N, Z, 1 )
      JMAX = ISAMAX( N, D, 1 )
      EPS = SLAMCH( 'Epsilon' )
      TOL = EIGHT*EPS*MAX( ABS( D( JMAX ) ), ABS( Z( IMAX ) ) )
*
*     If the rank-1 modifier is small enough, no more needs to be done
*     except to reorganize Q so that its columns correspond with the
*     elements in D.
*
      IF( RHO*ABS( Z( IMAX ) ).LE.TOL ) THEN
         K = 0
         IQ2 = 1
         DO 40 J = 1, N
            I = INDX( J )
            CALL SCOPY( N, Q( 1, I ), 1, Q2( IQ2 ), 1 )
            DLAMDA( J ) = D( I )
            IQ2 = IQ2 + N
   40    CONTINUE
         CALL SLACPY( 'A', N, N, Q2, N, Q, LDQ )
         CALL SCOPY( N, DLAMDA, 1, D, 1 )
         GO TO 190
      END IF
*
*     If there are multiple eigenvalues then the problem deflates.  Here
*     the number of equal eigenvalues are found.  As each equal
*     eigenvalue is found, an elementary reflector is computed to rotate
*     the corresponding eigensubspace so that the corresponding
*     components of Z are zero in this new basis.
*
      DO 50 I = 1, N1
         COLTYP( I ) = 1
   50 CONTINUE
      DO 60 I = N1P1, N
         COLTYP( I ) = 3
   60 CONTINUE
*
*
      K = 0
      K2 = N + 1
      DO 70 J = 1, N
         NJ = INDX( J )
         IF( RHO*ABS( Z( NJ ) ).LE.TOL ) THEN
*
*           Deflate due to small z component.
*
            K2 = K2 - 1
            COLTYP( NJ ) = 4
            INDXP( K2 ) = NJ
            IF( J.EQ.N )
     $         GO TO 100
         ELSE
            PJ = NJ
            GO TO 80
         END IF
   70 CONTINUE
   80 CONTINUE
      J = J + 1
      NJ = INDX( J )
      IF( J.GT.N )
     $   GO TO 100
      IF( RHO*ABS( Z( NJ ) ).LE.TOL ) THEN
*
*        Deflate due to small z component.
*
         K2 = K2 - 1
         COLTYP( NJ ) = 4
         INDXP( K2 ) = NJ
      ELSE
*
*        Check if eigenvalues are close enough to allow deflation.
*
         S = Z( PJ )
         C = Z( NJ )
*
*        Find sqrt(a**2+b**2) without overflow or
*        destructive underflow.
*
         TAU = SLAPY2( C, S )
         T = D( NJ ) - D( PJ )
         C = C / TAU
         S = -S / TAU
         IF( ABS( T*C*S ).LE.TOL ) THEN
*
*           Deflation is possible.
*
            Z( NJ ) = TAU
            Z( PJ ) = ZERO
            IF( COLTYP( NJ ).NE.COLTYP( PJ ) )
     $         COLTYP( NJ ) = 2
            COLTYP( PJ ) = 4
            CALL SROT( N, Q( 1, PJ ), 1, Q( 1, NJ ), 1, C, S )
            T = D( PJ )*C**2 + D( NJ )*S**2
            D( NJ ) = D( PJ )*S**2 + D( NJ )*C**2
            D( PJ ) = T
            K2 = K2 - 1
            I = 1
   90       CONTINUE
            IF( K2+I.LE.N ) THEN
               IF( D( PJ ).LT.D( INDXP( K2+I ) ) ) THEN
                  INDXP( K2+I-1 ) = INDXP( K2+I )
                  INDXP( K2+I ) = PJ
                  I = I + 1
                  GO TO 90
               ELSE
                  INDXP( K2+I-1 ) = PJ
               END IF
            ELSE
               INDXP( K2+I-1 ) = PJ
            END IF
            PJ = NJ
         ELSE
            K = K + 1
            DLAMDA( K ) = D( PJ )
            W( K ) = Z( PJ )
            INDXP( K ) = PJ
            PJ = NJ
         END IF
      END IF
      GO TO 80
  100 CONTINUE
*
*     Record the last eigenvalue.
*
      K = K + 1
      DLAMDA( K ) = D( PJ )
      W( K ) = Z( PJ )
      INDXP( K ) = PJ
*
*     Count up the total number of the various types of columns, then
*     form a permutation which positions the four column types into
*     four uniform groups (although one or more of these groups may be
*     empty).
*
      DO 110 J = 1, 4
         CTOT( J ) = 0
  110 CONTINUE
      DO 120 J = 1, N
         CT = COLTYP( J )
         CTOT( CT ) = CTOT( CT ) + 1
  120 CONTINUE
*
*     PSM(*) = Position in SubMatrix (of types 1 through 4)
*
      PSM( 1 ) = 1
      PSM( 2 ) = 1 + CTOT( 1 )
      PSM( 3 ) = PSM( 2 ) + CTOT( 2 )
      PSM( 4 ) = PSM( 3 ) + CTOT( 3 )
      K = N - CTOT( 4 )
*
*     Fill out the INDXC array so that the permutation which it induces
*     will place all type-1 columns first, all type-2 columns next,
*     then all type-3's, and finally all type-4's.
*
      DO 130 J = 1, N
         JS = INDXP( J )
         CT = COLTYP( JS )
         INDX( PSM( CT ) ) = JS
         INDXC( PSM( CT ) ) = J
         PSM( CT ) = PSM( CT ) + 1
  130 CONTINUE
*
*     Sort the eigenvalues and corresponding eigenvectors into DLAMDA
*     and Q2 respectively.  The eigenvalues/vectors which were not
*     deflated go into the first K slots of DLAMDA and Q2 respectively,
*     while those which were deflated go into the last N - K slots.
*
      I = 1
      IQ1 = 1
      IQ2 = 1 + ( CTOT( 1 )+CTOT( 2 ) )*N1
      DO 140 J = 1, CTOT( 1 )
         JS = INDX( I )
         CALL SCOPY( N1, Q( 1, JS ), 1, Q2( IQ1 ), 1 )
         Z( I ) = D( JS )
         I = I + 1
         IQ1 = IQ1 + N1
  140 CONTINUE
*
      DO 150 J = 1, CTOT( 2 )
         JS = INDX( I )
         CALL SCOPY( N1, Q( 1, JS ), 1, Q2( IQ1 ), 1 )
         CALL SCOPY( N2, Q( N1+1, JS ), 1, Q2( IQ2 ), 1 )
         Z( I ) = D( JS )
         I = I + 1
         IQ1 = IQ1 + N1
         IQ2 = IQ2 + N2
  150 CONTINUE
*
      DO 160 J = 1, CTOT( 3 )
         JS = INDX( I )
         CALL SCOPY( N2, Q( N1+1, JS ), 1, Q2( IQ2 ), 1 )
         Z( I ) = D( JS )
         I = I + 1
         IQ2 = IQ2 + N2
  160 CONTINUE
*
      IQ1 = IQ2
      DO 170 J = 1, CTOT( 4 )
         JS = INDX( I )
         CALL SCOPY( N, Q( 1, JS ), 1, Q2( IQ2 ), 1 )
         IQ2 = IQ2 + N
         Z( I ) = D( JS )
         I = I + 1
  170 CONTINUE
*
*     The deflated eigenvalues and their corresponding vectors go back
*     into the last N - K slots of D and Q respectively.
*
      CALL SLACPY( 'A', N, CTOT( 4 ), Q2( IQ1 ), N, Q( 1, K+1 ), LDQ )
      CALL SCOPY( N-K, Z( K+1 ), 1, D( K+1 ), 1 )
*
*     Copy CTOT into COLTYP for referencing in SLAED3.
*
      DO 180 J = 1, 4
         COLTYP( J ) = CTOT( J )
  180 CONTINUE
*
  190 CONTINUE
      RETURN
*
*     End of SLAED2
*
      END

C
C $Id: mdgetr.f,v 1.9 2008-09-18 00:42:17 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MDGETR (WHCH,RVAL)
C
        CHARACTER*(*) WHCH
        REAL          RVAL
C
C Declare required common blocks.  See MAPBDX for descriptions of these
C common blocks and the variables in them.
C
        COMMON /MAPCM0/  COS1,DTOR,DTRH,OOPI,PI,PIOF,PIOT,RTDD,RTOD,
     +                   SROT,SIN1,TOPI,TSRT
        DOUBLE PRECISION COS1,DTOR,DTRH,OOPI,PI,PIOF,PIOT,RTDD,RTOD,
     +                   SROT,SIN1,TOPI,TSRT
        SAVE   /MAPCM0/
C
        COMMON /MAPCM4/  GRDR,GRID,GRLA,GRLO,GRPO,OTOL,PDRE,PLA1,PLA2,
     +                   PLA3,PLA4,PLB1,PLB2,PLB3,PLB4,PLNO,PLTO,ROTA,
     +                   SRCH,XLOW,XROW,YBOW,YTOW,IDOT,IDSH,IDTL,ILCW,
     +                   ILTS,JPRJ,ELPF,INTF,LBLF,PRMF
        DOUBLE PRECISION GRDR,GRID,GRLA,GRLO,GRPO,OTOL,PDRE,PLA1,PLA2,
     +                   PLA3,PLA4,PLB1,PLB2,PLB3,PLB4,PLNO,PLTO,ROTA,
     +                   SRCH,XLOW,XROW,YBOW,YTOW
        INTEGER          IDOT,IDSH,IDTL,ILCW,ILTS,JPRJ
        LOGICAL          ELPF,INTF,LBLF,PRMF
        SAVE   /MAPCM4/
C
        COMMON /MAPCMA/  DATL,DBTD,DDTS,DPLT,DPSQ,DSCA,DSSQ
        DOUBLE PRECISION DATL,DBTD,DDTS,DPLT,DPSQ,DSCA,DSSQ
        SAVE   /MAPCMA/
C
        COMMON /MAPCMW/  CSLS,CSLT,SLTD,ISLT
        DOUBLE PRECISION CSLS,CSLT,SLTD
        INTEGER ISLT
        SAVE   /MAPCMW/
C
        COMMON /MAPSAT/  ALFA,BETA,DCSA,DCSB,DSNA,DSNB,SALT,SSMO,SRSS
        DOUBLE PRECISION ALFA,BETA,DCSA,DCSB,DSNA,DSNB,SALT,SSMO,SRSS
        SAVE   /MAPSAT/
C
        IF (ICFELL('MDGETR - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
        IF      (WHCH(1:2).EQ.'DD'.OR.WHCH(1:2).EQ.'dd') THEN
          RVAL=REAL(DDTS)
        ELSE IF (WHCH(1:2).EQ.'GD'.OR.WHCH(1:2).EQ.'gd') THEN
          RVAL=REAL(GRDR)
        ELSE IF (WHCH(1:2).EQ.'GN'.OR.WHCH(1:2).EQ.'gn') THEN
          RVAL=REAL(GRLO)
        ELSE IF (WHCH(1:2).EQ.'GP'.OR.WHCH(1:2).EQ.'gp') THEN
          RVAL=REAL(GRPO)
        ELSE IF (WHCH(1:2).EQ.'GR'.OR.WHCH(1:2).EQ.'gr') THEN
          RVAL=REAL(GRID)
        ELSE IF (WHCH(1:2).EQ.'GT'.OR.WHCH(1:2).EQ.'gt') THEN
          RVAL=REAL(GRLA)
        ELSE IF (WHCH(1:2).EQ.'MV'.OR.WHCH(1:2).EQ.'mv') THEN
          RVAL=REAL(DPLT)
        ELSE IF (WHCH(1:2).EQ.'OT'.OR.WHCH(1:2).EQ.'ot') THEN
          RVAL=REAL(OTOL)
        ELSE IF (WHCH(1:2).EQ.'PN'.OR.WHCH(1:2).EQ.'pn') THEN
          RVAL=REAL(PLNO)
        ELSE IF (WHCH(1:2).EQ.'PT'.OR.WHCH(1:2).EQ.'pt') THEN
          RVAL=REAL(PLTO)
        ELSE IF (WHCH(1:2).EQ.'P1'.OR.WHCH(1:2).EQ.'p1') THEN
          RVAL=REAL(PLA1)
        ELSE IF (WHCH(1:2).EQ.'P2'.OR.WHCH(1:2).EQ.'p2') THEN
          RVAL=REAL(PLA2)
        ELSE IF (WHCH(1:2).EQ.'P3'.OR.WHCH(1:2).EQ.'p3') THEN
          RVAL=REAL(PLA3)
        ELSE IF (WHCH(1:2).EQ.'P4'.OR.WHCH(1:2).EQ.'p4') THEN
          RVAL=REAL(PLA4)
        ELSE IF (WHCH(1:2).EQ.'P5'.OR.WHCH(1:2).EQ.'p5') THEN
          RVAL=REAL(PLB1)
        ELSE IF (WHCH(1:2).EQ.'P6'.OR.WHCH(1:2).EQ.'p6') THEN
          RVAL=REAL(PLB2)
        ELSE IF (WHCH(1:2).EQ.'P7'.OR.WHCH(1:2).EQ.'p7') THEN
          RVAL=REAL(PLB3)
        ELSE IF (WHCH(1:2).EQ.'P8'.OR.WHCH(1:2).EQ.'p8') THEN
          RVAL=REAL(PLB4)
        ELSE IF (WHCH(1:2).EQ.'RE'.OR.WHCH(1:2).EQ.'re') THEN
          RVAL=REAL(PDRE)
        ELSE IF (WHCH(1:2).EQ.'RO'.OR.WHCH(1:2).EQ.'ro') THEN
          RVAL=REAL(ROTA)
        ELSE IF (WHCH(1:2).EQ.'SA'.OR.WHCH(1:2).EQ.'sa') THEN
          RVAL=REAL(SALT)
        ELSE IF (WHCH(1:2).EQ.'SL'.OR.WHCH(1:2).EQ.'sl') THEN
          RVAL=REAL(SLTD)
        ELSE IF (WHCH(1:2).EQ.'S1'.OR.WHCH(1:2).EQ.'s1') THEN
          RVAL=REAL(ALFA)
        ELSE IF (WHCH(1:2).EQ.'S2'.OR.WHCH(1:2).EQ.'s2') THEN
          RVAL=REAL(BETA)
        ELSE IF (WHCH(1:2).EQ.'SR'.OR.WHCH(1:2).EQ.'sr') THEN
          RVAL=REAL(SRCH)
        ELSE IF (WHCH(1:2).EQ.'XL'.OR.WHCH(1:2).EQ.'xl') THEN
          RVAL=REAL(XLOW)
        ELSE IF (WHCH(1:2).EQ.'XR'.OR.WHCH(1:2).EQ.'xr') THEN
          RVAL=REAL(XROW)
        ELSE IF (WHCH(1:2).EQ.'YB'.OR.WHCH(1:2).EQ.'yb') THEN
          RVAL=REAL(YBOW)
        ELSE IF (WHCH(1:2).EQ.'YT'.OR.WHCH(1:2).EQ.'yt') THEN
          RVAL=REAL(YTOW)
        ELSE
          GO TO 901
        END IF
C
C Done.
C
        RETURN
C
C Error exits.
C
  901   CALL MDPCEM ('MDGETR - UNKNOWN PARAMETER NAME ',WHCH,2,1)
        RVAL=0.
        RETURN
C
      END

C
C       $Id: ngsrat.f,v 1.4 2008-07-27 00:17:18 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE NGSRAT(IOPT, IAT, RAT)
C
C Save/restore/set NCAR GKS attributes.
C
C ARGUMENTS
C
C ON INPUT  
C    
C   IOPT  An integer argument indicating the desired action:
C
C           = 0, then save the current settings of all attributes 
C                internal to the subroutine, i.e. not in the IAT and
C                RAT arrays.
C           = 1, then restore the context from the most recent
C                saved state.
C           = 2, then return the current context in the output arrays
C                IAT (integer attributes) and RAT (floating-point
C                attributes) as follows:
C
C                IAT - An array containing GKS integer state variables 
C                      as follows:
C
C                        IAT( 1) = Clip indicator
C                        IAT( 2) = Line type
C                        IAT( 3) = Polyline color index
C                        IAT( 4) = Marker type
C                        IAT( 5) = Polymarker color index
C                        IAT( 6) = Text font
C                        IAT( 7) = Text precision
C                        IAT( 8) = Text color index
C                        IAT( 9) = Text path
C                        IAT(10) = Text horizontal alignment
C                        IAT(11) = Text vertical alignment
C                        IAT(12) = Fill area interior style
C                        IAT(13) = Fill are style index
C                        IAT(14) = Fill area color index
C
C                RAT - A REAL array containing GKS floating-point
C                      state variables as follows:
C
C                        RAT( 1) = Linewidth scale factor
C                        RAT( 2) = Marker scale factor
C                        RAT( 3) = Character expansion factor
C                        RAT( 4) = Character spacing
C                        RAT( 5) = Character height in world coordinates
C                        RAT( 6) = Character up vector, X component in
C                                  world coordinates
C                        RAT( 7) = Character up vector, Y component in
C                                  world coordinates
C 
C           = 3, then set the context to the values specified
C                in the IAT and RAT arrays (as described above).
C
C  IAT   An integer array that has meaning only if IOPT equals 2 or 3
C        as indicated above in the description of IOPT.
C
C  RAT   A real array that has meaning only if IOPT equals 2 or 3
C        as indicated above in the description of IOPT.
C
C ---------------------------------------------------------------------------
C  Modified 1/2012 in support of 32bit argb color -- RLB
C
C  Argb colors are generally very large integer values, much bigger
C  than the 5-character field originally allotted for conversion to/from
C  integers.  For simplicity, changed all integer character-fields to
C  10 characters; note that this change necessitated writing across
C  4 80-character records (i.e, IDR), rather than 3.
C ---------------------------------------------------------------------------

      DIMENSION IAT(14),RAT(7)
      CHARACTER*80 IDR(4),ODR(4)
C
      WRITE(IDR(1)(1:5),500) IOPT
  500 FORMAT(I5)
      IF (IOPT.EQ.0 .OR. IOPT.EQ.1) THEN
        CALL GESC(-1388,1,IDR,4,4,ODR)
      ELSE IF (IOPT .EQ. 2) THEN
        CALL GESC(-1388,1,IDR,4,4,ODR)
CRLB:   READ (ODR(1),510) (IAT(LL),LL=1,14)
        READ (ODR(1), 511) (IAT(LL),LL=1,7)
        READ (ODR(2), 511) (IAT(LL),LL=8,14)
  510   FORMAT(14I5)
  511   FORMAT(7I10)
        READ (ODR(3),520) (RAT(LL),LL=1,5)
  520   FORMAT(5E16.7)
        READ (ODR(4),530) (RAT(LL),LL=6,7)
  530   FORMAT(2E16.7)
      ELSE IF (IOPT.EQ.3) THEN
CRLB:   WRITE(IDR(1)(6:75),510) (IAT(LL),LL=1,14)
        WRITE(IDR(1)(6:75),511) (IAT(LL),LL=1,7)
        WRITE(IDR(2),511) (IAT(LL),LL=8,14)
        WRITE(IDR(3),520) (RAT(LL),LL=1,5)
        WRITE(IDR(4),530) (RAT(LL),LL=6,7)
        CALL GESC(-1388,1,IDR,4,4,ODR)
      ENDIF
C
      RETURN
      END

C
C	$Id: dashdb.f,v 1.5 2008-07-27 00:23:04 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE DASHDB (IPAT)
C
C ARGUMENTS              IPAT
C ON INPUT                 IPAT IS A 16-BIT DASH PATTERN.  BY DEFAULT
C                          EACH BIT IN THE PATTERN REPRESENTS 3 PLOTTER
C                          ADDRESS UNITS (1=SOLID, 0=BLANK)
C
C
C
C USER ENTRY POINT.
C DASHDB GIVES AN INTERNAL REPRESENTATION TO THE DASH PATTERN WHICH IS
C SPECIFIED IN ITS ARGUMENT. THIS INTERNAL REPRESENTATION IS PASSED
C TO ROUTINE CFVLD IN THE COMMON-BLOCK DASHD1.
C
      DIMENSION IPAT(1)
      COMMON/INTPR/IPAU,FPART,TENSN,NP,SMALL,L1,ADDLR,ADDTB,MLLINE,
     1    ICLOSE
C
C DASHD1 IS FOR COMMUNICATION BETWEEN THE ROUTINES DASHDB AND CFVLD.
C ISL, MNCSTR AND IGP ARE INITIALIZED IN DASHBDX.
C
      COMMON /DASHD1/  ISL,  L,  ISIZE,  IP(100),  NWDSM1,  IPFLAG(100)
     1                 ,MNCSTR, IGP
C
C IFCFLG IS THE FIRST CALL FLAG FOR DASHDB. IT IS INITIALIZED IN
C DASHBDX.
C
      COMMON /DDFLAG/ IFCFLG
C
C IFSTFL CONTROLS THAT FRSTD IS CALLED BEFORE VECTD IS CALLED (IN CFVLD)
C WHENEVER DASHDB HAS BEEN CALLED. IT IS INITIALIZED IN DASHBDX AND
C REFERENCED IN CFVLD.
C
      COMMON /DCFLAG/ IFSTFL
C
C IFSTF2 CONTROLS THAT THE FRSTD ENTRY IS CALLED IN FDVDLD BEFORE THE
C VECTD ENTRY IS CALLED WHENEVER DASHDB OR DASHDC HAS BEEN CALLED.
C IT IS INITIALIZED IN DASHBDX AND REFERENCED IN FDVDLD.
C
      COMMON /DFFLAG/ IFSTF2
C
C LOCAL VARIABLES TO DASHDB ARE SAVED IN DSAVE6 FOR THE NEXT CALL TO
C DASHDB.
C
      COMMON /DSAVE6/ MASK, NCHRWD, NBWD, MNCST1
      SAVE
C
C Do a call forcing a BLOCKDATA to be loaded from a binary library.
C
      CALL DASHBD
C THE FOLLOWING CALL IS FOR LIBRARY STATISTICS GATHERING AT NCAR
      CALL Q8QST4 ('GRAPHX', 'DASHSUPR', 'DASHDB', 'VERSION  1')
      IF (IFCFLG .EQ. 2) GOTO 10
C
C CHECK IF THE CONSTANTS IN THE BLOCKDATA DASHBDX ARE LOADED CORRECTLY
C
      IF (MNCSTR .EQ. 15) GOTO 6
      CALL SETER('DASHDB -- BLOCKDATA DASHBDX APPARENTLY NOT LOADED CORR
     1ECTLY',1,2)
    6 CONTINUE
C
C INITIALIZATION
C
      MNCST1 = MNCSTR + 1
C
C MASK IS AN ALL SOLID PATTERN
C
      MASK=IOR(ISHIFT(32767,1),1)
C
      IFCFLG = 2
C
C L - NUMBER OF WORDS IN THE FINAL PATTERN, POINTER TO IP ARRAY.
C ISL - FLAG FOR ALL SOLID PATTERN (1) OR ALL GAP PATTERN (-1).
C IFSTFL - FLAG TO CONTROL THAT FRSTD IS CALLED IN CFVLD BEFORE VECTD IS
C          CALLED, WHENEVER DASHDB OR DASHDC HAS BEEN CALLED.
C IFSTF2 - FLAG TO CONTROL THAT FRSTD IS CALLED IN FDVDLD BEFORE VECTD
C          IS CALLED, WHENEVER DASHDB OR DASHDC HAS BEEN CALLED.
C
   10 CONTINUE
      NCHRTS = 0
      L = 0
      ISL = 0
      IFSTFL = 1
      IFSTF2 = 1
C
      ICRT = IPAU*ISHIFT(1,15-10)
      IF (IPAT(1) .NE. 0) GO TO 260
      ISL = -1
      RETURN
  260 IF (IPAT(1) .NE. MASK) GO TO 270
      ISL = 1
      RETURN
  270 NMODE1 = IAND(ISHIFT(IPAT(1),-15),1)
      DO 290 I = 1,16
      IF (NMODE1 .NE. IAND(ISHIFT(IPAT(1),I-16),1)) GO TO 280
      NMODE1 = 1 - NMODE1
      L = L + 1
      IP(L) = 0
      IPFLAG(L) = 1 - 2*NMODE1
  280 IP(L) = IP(L) + ICRT
  290 CONTINUE
      RETURN
      END

C NCLFORTSTART
      subroutine evssm (nvar, lssm, cssm, neval, weval, wevec,info,iopt)
      implicit none
                                                  ! input
      integer          nvar, lssm, info, neval, iopt
      double precision cssm(lssm)
                                                  ! output
      double precision weval(neval), wevec(nvar,neval)
C NCLEND
      integer          il  , iu  , mout, ldz, n, nn
     +                ,iwork(5*nvar), ifail(nvar)
      double precision vl  , vu  , abstol, work(8*nvar) 
      character*1      jobz, rang, uplo

c .   jobz    = "V"       ; compute eigen{values/vectors}
c .   rang    = "I"       ; compute user specified iL to iU eigenvalues
c .   uplo    = "U"       ; input is lower(L)/upper(U) triangle
c .   vl      = 1d20      ; not used if:  range= "A" or "I"
c .   vu      = 1d20      ; not used
c .   neval   = iu-il+1   ; number of eigenvalues and vectors
c .   abstol  = 0.0       ; this mean use the default tolerance
c .   mout    = 0         ; ouput number of eigenvalues

      jobz    = "V"
      rang    = "I"
      uplo    = "U"

      il      = max(nvar-neval+1,1)
      iu      = nvar

      mout    = -99       
      ldz     = nvar

      vl      = 1d20    
      vu      = 1d20   
      abstol  = 0.0d0     

      call dspevx(jobz, rang, uplo, nvar, cssm, vl, vu, il, iu
     +           ,abstol ,mout, weval, wevec, ldz, work, iwork
     +           ,ifail, info)

      if (iopt.eq.0) then

c reverse the order of arrays returned from "dspevx" so
c .   largest eigenvalues/vectors are first.

          do n=1,neval
             work(n) = weval(n)
          end do
          do n=1,neval
             weval(n) = work(neval+1-n)
          end do
    
          do n=1,nvar
              do nn=1,neval
                 work(nn) = wevec(n,nn)
              end do
              do nn=1,neval
                 wevec(n,nn) = work(neval+1-nn)
              end do
          end do
      end if

      return
      end

C
C	$Id: ezcntr.f,v 1.4 2008-07-27 00:23:02 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE EZCNTR (Z,M,N)
C
C USER ENTRY.  SEE COMMENT CARD DESCRIPTION CONTAINED IN CONEC.
C
      SAVE
      DIMENSION       Z(M,N)
      DATA NSET,NHI,NDASH/0,0,682/
C
C                             682=1252B
C THE FOLLOWING CALL IS FOR GATHERING STATISTICS ON LIBRARY USE AT NCAR
      CALL Q8QST4 ('GRAPHX', 'CONRECSUPR', 'EZCNTR', 'VERSION 01')
C
      CALL CONREC (Z,M,M,N,0.,0.,0.,NSET,NHI,-NDASH)
      CALL FRAME
      RETURN
      END

      PROGRAM AGEX12
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Create a sort of histogram.
C
      REAL XDRA(249),YDRA(249),WORK(204),IWRK(204)
C
C Initialize GKS.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Fill the data arrays.  First, we define the histogram
C outline.  This will be used in the call to SFWRLD which
C fills in the area under the histogram.
C
      XDRA(1)=0.
      YDRA(1)=0.
C
      DO 101 I=2,100,2
        XDRA(I  )=XDRA(I-1)
        YDRA(I  )=EXP(-16.*(REAL(I/2)/50.-.51)**2)+.1*FRAN()
        XDRA(I+1)=XDRA(I-1)+.02
        YDRA(I+1)=YDRA(I)
  101 CONTINUE
C
      XDRA(102)=1.
      YDRA(102)=0.
C
C Define lines separating vertical boxes from each other.
C
      NDRA=102
C
      DO 102 I=3,99,2
        XDRA(NDRA+1)=1.E36
        YDRA(NDRA+1)=1.E36
        XDRA(NDRA+2)=XDRA(I)
        YDRA(NDRA+2)=0.
        XDRA(NDRA+3)=XDRA(I)
        YDRA(NDRA+3)=MIN(YDRA(I),YDRA(I+1))
        NDRA=NDRA+3
  102 CONTINUE
C
C Draw a boundary around the edge of the plotter frame.
C
      CALL BNDARY
C
C Suppress the frame advance.
C
      CALL AGSETI ('FRAME.',2)
C
C Draw the graph, using EZXY.
C
      CALL EZXY (XDRA,YDRA,249,'EXAMPLE 12 (HISTOGRAM)$')
C
C Use the package SOFTFILL to fill the area defined by the
C data.
C
      CALL SFSETI ('AN',45)
      CALL SFSETR ('SP',.004)
      CALL SFWRLD (XDRA,YDRA,102,WORK,204,IWRK,204)
C
C Advance the frame.
C
      CALL FRAME
C
C Close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
C
      END
      FUNCTION FRAN()
C
C Pseudo-random-number generator.
C
        DOUBLE PRECISION X
        SAVE X
        DATA X / 2.718281828459045D0 /
        X=MOD(9821.D0*X+.211327D0,1.D0)
        FRAN=REAL(X)
        RETURN
      END
      SUBROUTINE BNDARY
C
C Routine to draw the plotter-frame edge.
C
      CALL PLOTIT (    0,    0,0)
      CALL PLOTIT (32767,    0,1)
      CALL PLOTIT (32767,32767,1)
      CALL PLOTIT (    0,32767,1)
      CALL PLOTIT (    0,    0,1)
      RETURN
      END

      PROGRAM WMEX02
C
C  Examples of spline fits for weather fronts and regions.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C  Color index for cross markers.
C
      DATA ICCLR/3/
C
C  Data for two lines and a region illustrating spline fits.
C
      PARAMETER (NS=3)
      DIMENSION XS(NS),YS(NS)
      DATA XS/ 0.10, 0.30, 0.50/ 
      DATA YS/ 0.45, 0.70, 0.75/ 
      PARAMETER (NT=5)
      DIMENSION XT(NT),YT(NT)
      DATA XT/ 0.15, 0.20, 0.50, 0.70, 0.85/
      DATA YT/ 0.05, 0.28, 0.53, 0.58, 0.75/
      PARAMETER (NU=8)
      DIMENSION XU(NU),YU(NU)
      DATA XU/ 0.35, 0.40, 0.60, 0.80, 0.85, 0.70, 0.50, 0.35/
      DATA YU/ 0.10, 0.30, 0.31, 0.43, 0.15, 0.10, 0.05, 0.10/
C
C  Data for picture two illustrating slope control at end points.
C
      PARAMETER (NV=5)
      DIMENSION XV(NV),YV(NV)
      DATA XV/ 0.10, 0.30, 0.50, 0.70, 0.90 /
      DATA YV/ 1.00, 1.08, 1.00, 0.95, 0.94 /
      
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C  Define a color table.
C
      CALL GSCR(IWKID, 0, 1.0, 1.0, 1.0)
      CALL GSCR(IWKID, 1, 0.0, 0.0, 0.0)
      CALL GSCR(IWKID, 2, 1.0, 0.0, 0.0)
      CALL GSCR(IWKID, 3, 0.0, 0.0, 1.0)
C
C  Plot title.
C
      CALL PLCHHQ(0.50,0.94,':F26:Spline fits for fronts and regions',
     +            0.03,0.,0.)
      CALL PLCHHQ(0.50,0.88,':F22: - marks the input coordinates',
     +            .025,0.,-.06)
      CALL PCGETR('XB',XB)
      CALL CROSS(XB-.015,0.875,ICCLR)
C
C  Define some parameters.
C
      CALL WMSETR('LIN - line widths of front lines',3.)
      CALL WMSETI('NMS - number of symbols on front line',0)
      CALL WMSETI('WFC - color for warm fronts',2)
C
      CALL WMDRFT(NS,XS,YS)
      DO 10 I=1,NS
        CALL CROSS(XS(I),YS(I),ICCLR)
   10 CONTINUE
      CALL WMDRFT(NT,XT,YT)
      DO 20 I=1,NT
        CALL CROSS(XT(I),YT(I),ICCLR)
   20 CONTINUE
      CALL WMDRRG(NU,XU,YU,'INDEX2',1,XU,YU)
      DO 30 I=1,NU
        CALL CROSS(XU(I),YU(I),ICCLR)
   30 CONTINUE
C
      CALL FRAME
C
      CALL GDAWK(IWKID)
      CALL GCLWK(IWKID)
      CALL GCLKS
      STOP
C
      END
      SUBROUTINE CROSS(X,Y,ICLR)
C
C  Draw a green filled cross at (X,Y).
C
      PARAMETER(ID=16)
      PARAMETER(IX=15, IMX=100,IMXH=IMX/2)
      PARAMETER(IMXM=IMX-IX, IMXP=IMX+IX, IMXHM=IMXH-IX, IMXHP=IMXH+IX)
      DIMENSION ICX(ID),ICY(ID),RCX(ID),RCY(ID)
C
      DATA ICX( 1),ICX( 2),ICX( 3),ICX( 4)/    0,    IX,  IMXH, IMXM/
      DATA ICY( 1),ICY( 2),ICY( 3),ICY( 4)/    0,     0, IMXHM,    0/
      DATA ICX( 5),ICX( 6),ICX( 7),ICX( 8)/  IMX,   IMX, IMXHP,  IMX/
      DATA ICY( 5),ICY( 6),ICY( 7),ICY( 8)/    0,    IX,  IMXH, IMXM/
      DATA ICX( 9),ICX(10),ICX(11),ICX(12)/  IMX,  IMXM,  IMXH,   IX/
      DATA ICY( 9),ICY(10),ICY(11),ICY(12)/  IMX,   IMX, IMXHP,  IMX/
      DATA ICX(13),ICX(14),ICX(15),ICX(16)/    0,     0, IMXHM,    0/
      DATA ICY(13),ICY(14),ICY(15),ICY(16)/  IMX,  IMXM,  IMXH,   IX/
C
      DO 10 I=1,ID
        RCX(I) = X-0.00027*(REAL(IMXH)-REAL(ICX(I)))
        RCY(I) = Y-0.00027*(REAL(IMXH)-REAL(ICY(I)))
   10 CONTINUE
      CALL GSFAIS(1)
      CALL GQFACI(IOC,IERR)
      CALL GSFACI(ICLR)
      CALL GFA(ID,RCX,RCY)
      CALL GSFACI(IOC)
C
      RETURN
      END

C
C       $Id: vvgetc.f,v 1.15 2008-07-27 00:17:35 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
C
C-----------------------------------------------------------------------
C
      SUBROUTINE VVGETC (CNM,CVL)
C
      CHARACTER*(*) CNM,CVL
C
C This subroutine is called to retrieve the character value of a
C specified parameter.
C
C CNM is the name of the parameter whose value is to be retrieved.
C
C CVL is a character variable in which the desired value is to be
C returned by VVGETC.
C
C ---------------------------------------------------------------------
C
C NOTE:
C Since implicit typing is used for all real and integer variables
C a consistent length convention has been adopted to help clarify the
C significance of the variables encountered in the code for this 
C utility. All local variable and subroutine parameter identifiers 
C are limited to 1,2,or 3 characters. Four character names identify  
C members of common blocks. Five and 6 character variable names 
C denote PARAMETER constants or subroutine or function names.
C
C Declare the VV common blocks.
C
C IPLVLS - Maximum number of color threshold level values
C IPAGMX - Maximum number of area groups allowed in the area map
C
      PARAMETER (IPLVLS = 256, IPAGMX = 64)
C
C Integer and real common block variables
C
C
      COMMON /VVCOM/
     +                IUD1       ,IVD1       ,IPD1       ,IXDM       ,
     +                IYDN       ,VLOM       ,VHIM       ,ISET       ,
     +                VRMG       ,VRLN       ,VFRC       ,IXIN       ,
     +                IYIN       ,ISVF       ,UUSV       ,UVSV       ,
     +                UPSV       ,IMSK       ,ICPM       ,UVPS       ,
     +                UVPL       ,UVPR       ,UVPB       ,UVPT       ,
     +                UWDL       ,UWDR       ,UWDB       ,UWDT       ,
     +                UXC1       ,UXCM       ,UYC1       ,UYCN       ,
     +                NLVL       ,IPAI       ,ICTV       ,WDLV       ,
     +                UVMN       ,UVMX       ,PMIN       ,PMAX       ,
     +                RVMN       ,RVMX       ,RDMN       ,RDMX       ,
     +                ISPC       ,RVMD       ,IPLR       ,IVST       ,
     +                IVPO       ,ILBL       ,IDPF       ,IMSG       ,
     +                ICLR(IPLVLS)           ,TVLU(IPLVLS)
C
C Arrow size/shape parameters
C
        COMMON / VVARO /
     +                HDSZ       ,HINF       ,HANG       ,IAST       ,
     +                HSIN       ,HCOS       ,FAMN       ,FAMX       ,
     +                UVMG       ,FAIR       ,FAWR       ,FAWF       ,
     +                FAXR       ,FAXF       ,FAYR       ,FAYF       ,
     +                AROX(8)    ,AROY(8)    ,FXSZ       ,FYSZ       ,
     +                FXRF       ,FXMN       ,FYRF       ,FYMN       ,
     +                FWRF       ,FWMN       ,FIRF       ,FIMN       ,
     +                AXMN       ,AXMX       ,AYMN       ,AYMX       ,
     +                IACM       ,IAFO       ,WBAD       ,WBTF       ,
     +                WBCF       ,WBDF       ,WBSC
C
C
C Text related parameters
C
        COMMON /VVTXP /
     +                FCWM    ,ICSZ    ,
     +                FMNS    ,FMNX    ,FMNY    ,IMNP    ,IMNC  ,
     +                FMXS    ,FMXX    ,FMXY    ,IMXP    ,IMXC  ,
     +                FZFS    ,FZFX    ,FZFY    ,IZFP    ,IZFC  ,
     +                FILS    ,FILX    ,FILY    ,IILP    ,IILC  ,
     +                FLBS    ,ILBC

C
C Character variable declartions
C
      CHARACTER*160 CSTR
      PARAMETER (IPCHSZ=36)
      CHARACTER*(IPCHSZ)  CMNT,CMXT,CZFT,CLBT,CILT
C
C Text string parameters
C
      COMMON /VVCHAR/ CSTR,CMNT,CMXT,CZFT,CLBT,CILT
C
      SAVE /VVCOM/, /VVARO/, /VVTXP/, /VVCHAR/
C
C The mapping common block: made available to user mapping routines
C
      COMMON /VVMAP/
     +                IMAP       ,
     +                XVPL       ,XVPR       ,YVPB       ,YVPT       ,
     +                WXMN       ,WXMX       ,WYMN       ,WYMX       ,
     +                XLOV       ,XHIV       ,YLOV       ,YHIV       ,
     +                SXDC       ,SYDC       ,NXCT       ,NYCT       ,
     +                RLEN       ,LNLG       ,INVX       ,INVY       ,
     +                ITRT       ,IWCT       ,FW2W       ,FH2H       ,
     +                DVMN       ,DVMX       ,RBIG       ,IBIG
C
      SAVE /VVMAP/
C
C Math constants
C
      PARAMETER (PDTOR  = 0.017453292519943,
     +           PRTOD  = 57.2957795130823,
     +           P1XPI  = 3.14159265358979,
     +           P2XPI  = 6.28318530717959,
     +           P1D2PI = 1.57079632679489,
     +           P5D2PI = 7.85398163397448) 
C
C --------------------------------------------------------------------
C
C Check for a parameter name that is too short.
C
      IF (LEN(CNM).LT.3) THEN
        CSTR(1:36)='VVGETC - PARAMETER NAME TOO SHORT - '
        CSTR(37:36+LEN(CNM))=CNM
        CALL SETER (CSTR(1:36+LEN(CNM)),1,1)
        RETURN
      END IF
C
C Get the proper parameter.
C
      IF (CNM(1:3).EQ.'MNT'.OR.CNM(1:3).EQ.'mnt') THEN
         CALL VVTXLN(CMNT,IPCHSZ,IB,IE)
         CVL=CMNT(IB:IE)
      ELSE IF (CNM(1:3).EQ.'MXT'.OR.CNM(1:3).EQ.'mxt') THEN
         CALL VVTXLN(CMXT,IPCHSZ,IB,IE)
         CVL=CMXT(IB:IE)
      ELSE IF (CNM(1:3).EQ.'ZFT'.OR.CNM(1:3).EQ.'zft') THEN
         CALL VVTXLN(CZFT,IPCHSZ,IB,IE)
         CVL=CZFT(IB:IE)
      ELSE IF (CNM(1:3).EQ.'ILT'.OR.CNM(1:3).EQ.'ilt') THEN
         CALL VVTXLN(CILT,IPCHSZ,IB,IE)
         CVL=CILT(IB:IE)
      ELSE
C
         CSTR(1:36)='VVGETC - PARAMETER NAME NOT KNOWN - '
         CSTR(37:39)=CNM(1:3)
         CALL SETER (CSTR(1:39),2,1)
         RETURN
C
      END IF
C
C
C Done.
C
      RETURN
C
      END

C
C       $Id: vvthin.f,v 1.10 2008-07-27 00:17:35 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE VVTHIN (U,V,P,UFR,VFR)
C
C Argument dimensions
C
      DIMENSION U(IUD1,*), V(IVD1,*), P(IPD1,*)
      DIMENSION UFR(IXDM,IYDN),VFR(IXDM,IYDN)
C
C Input parameters
C
C U,V    - 2-d arrays holding the component values of a vector field
C UF,VF  - A 2-d array containing a scalar data field. The contents
C          of this array may be used to color the vectors 
C
C Output parameters:
C
C UF,VF  - 2-d arrays in which are placed the NDC locations of each
C          vector. After the positions are calculated, for vectors that
C          are not to be drawn, the UF array element is replaced with
C          the value -1.0.
C
C ---------------------------------------------------------------------
C
C NOTE:
C Since implicit typing is used for all real and integer variables
C a consistent length convention has been adopted to help clarify the
C significance of the variables encountered in the code for this 
C utility. All local variable and subroutine parameter identifiers 
C are limited to 1,2,or 3 characters. Four character names identify  
C members of common blocks. Five and 6 character variable names 
C denote PARAMETER constants or subroutine or function names.
C
C Declare the VV common blocks.
C
C IPLVLS - Maximum number of color threshold level values
C IPAGMX - Maximum number of area groups allowed in the area map
C
      PARAMETER (IPLVLS = 256, IPAGMX = 64)
C
C Integer and real common block variables
C
C
      COMMON /VVCOM/
     +                IUD1       ,IVD1       ,IPD1       ,IXDM       ,
     +                IYDN       ,VLOM       ,VHIM       ,ISET       ,
     +                VRMG       ,VRLN       ,VFRC       ,IXIN       ,
     +                IYIN       ,ISVF       ,UUSV       ,UVSV       ,
     +                UPSV       ,IMSK       ,ICPM       ,UVPS       ,
     +                UVPL       ,UVPR       ,UVPB       ,UVPT       ,
     +                UWDL       ,UWDR       ,UWDB       ,UWDT       ,
     +                UXC1       ,UXCM       ,UYC1       ,UYCN       ,
     +                NLVL       ,IPAI       ,ICTV       ,WDLV       ,
     +                UVMN       ,UVMX       ,PMIN       ,PMAX       ,
     +                RVMN       ,RVMX       ,RDMN       ,RDMX       ,
     +                ISPC       ,RVMD       ,IPLR       ,IVST       ,
     +                IVPO       ,ILBL       ,IDPF       ,IMSG       ,
     +                ICLR(IPLVLS)           ,TVLU(IPLVLS)
C
C Arrow size/shape parameters
C
        COMMON / VVARO /
     +                HDSZ       ,HINF       ,HANG       ,IAST       ,
     +                HSIN       ,HCOS       ,FAMN       ,FAMX       ,
     +                UVMG       ,FAIR       ,FAWR       ,FAWF       ,
     +                FAXR       ,FAXF       ,FAYR       ,FAYF       ,
     +                AROX(8)    ,AROY(8)    ,FXSZ       ,FYSZ       ,
     +                FXRF       ,FXMN       ,FYRF       ,FYMN       ,
     +                FWRF       ,FWMN       ,FIRF       ,FIMN       ,
     +                AXMN       ,AXMX       ,AYMN       ,AYMX       ,
     +                IACM       ,IAFO       ,WBAD       ,WBTF       ,
     +                WBCF       ,WBDF       ,WBSC
C
C
C Text related parameters
C
        COMMON /VVTXP /
     +                FCWM    ,ICSZ    ,
     +                FMNS    ,FMNX    ,FMNY    ,IMNP    ,IMNC  ,
     +                FMXS    ,FMXX    ,FMXY    ,IMXP    ,IMXC  ,
     +                FZFS    ,FZFX    ,FZFY    ,IZFP    ,IZFC  ,
     +                FILS    ,FILX    ,FILY    ,IILP    ,IILC  ,
     +                FLBS    ,ILBC

C
C Character variable declartions
C
      CHARACTER*160 CSTR
      PARAMETER (IPCHSZ=36)
      CHARACTER*(IPCHSZ)  CMNT,CMXT,CZFT,CLBT,CILT
C
C Text string parameters
C
      COMMON /VVCHAR/ CSTR,CMNT,CMXT,CZFT,CLBT,CILT
C
      SAVE /VVCOM/, /VVARO/, /VVTXP/, /VVCHAR/
C
C The mapping common block: made available to user mapping routines
C
      COMMON /VVMAP/
     +                IMAP       ,
     +                XVPL       ,XVPR       ,YVPB       ,YVPT       ,
     +                WXMN       ,WXMX       ,WYMN       ,WYMX       ,
     +                XLOV       ,XHIV       ,YLOV       ,YHIV       ,
     +                SXDC       ,SYDC       ,NXCT       ,NYCT       ,
     +                RLEN       ,LNLG       ,INVX       ,INVY       ,
     +                ITRT       ,IWCT       ,FW2W       ,FH2H       ,
     +                DVMN       ,DVMX       ,RBIG       ,IBIG
C
      SAVE /VVMAP/
C
C Math constants
C
      PARAMETER (PDTOR  = 0.017453292519943,
     +           PRTOD  = 57.2957795130823,
     +           P1XPI  = 3.14159265358979,
     +           P2XPI  = 6.28318530717959,
     +           P1D2PI = 1.57079632679489,
     +           P5D2PI = 7.85398163397448) 
C
C --------------------------------------------------------------------
C
C Local variables
C
C
C The following status and count variables are used to gather
C statistics that are not currently available to the user
C
C IST - Status flag returned from the mapping routine
C
C Vector length adjustment
C
C I,J - loop indices for traversing the vector arrays
C UI,VI - local copies of the current vector values
C UVM   - magnitude of the current vector
C XB,XE,YB,XE - the beginning/ending points of the vector in 
C               the fractional system
C X,Y - mapping of the array indices to a coordinate system
C XGV,YGV - X and Y grid value, the scaled distance between each
C           array grid point
C ---------------------------------------------------------------------
C
C Calculate the grid interval represented by adjacent array
C elements along each axis
C
      XGV=(XHIV-XLOV)/REAL(MAX(1,IXDM-1))
      YGV=(YHIV-YLOV)/REAL(MAX(1,IYDN-1))
C
C Calculate the vector locations.
C Vectors not to be plotted are marked with the following special codes:
C      -1.0: vector removed by thinning process
C      -2.0: special value
C      -3.0: below minimum magnitude
C      -4.0: abobe maximum magnitude
C      -5.0: zero-length vector
C      -6.0: rejected by mapping routine
C
      DO 201 J=1,IYDN,IYIN
         DO 200 I=1,IXDM,IXIN
C
            UI = U(I,J)
            VI = V(I,J)
C
C Cull out special values
C
            IF (ISVF .GT. 0) THEN
               IF (UI .EQ. UUSV) THEN
                  IF (ISVF .EQ. 1 .OR. ISVF .EQ. 3) GO TO 199
                  IF (VI .EQ. UVSV .AND. ISVF .EQ. 4) GO TO 199
               ELSE IF (VI .EQ. UVSV) THEN
                  IF (ISVF .EQ. 2 .OR. ISVF .EQ. 3) GO TO 199
               END IF
            END IF
C
C Calculate the vector magnitude or if the polar flag is set
C compute the cartesian component values
C
            IF (IPLR .LE. 0) THEN
               UVM = SQRT(UI*UI+VI*VI)
            ELSE
               UVM = UI
               IF (IPLR .EQ. 1) VI = PDTOR * VI
               UI = UVM * COS(VI)
               VI = UVM * SIN(VI)
            END IF
            UVMG = UVM
C
C Bypass vectors that fall outside the user-specified range.
C
            IF (UVM .LT. UVMN) GO TO 196
C
            IF (UVM .GT. UVMX) GO TO 197
C
            IF (UVM .LE. 0.0) GO TO 198
C
C If using a scalar array, check for special values in the array, 
C then determine the color to use for the vector
C
            IF (ABS(ICTV) .GE. 2) THEN
               IF (ISPC .EQ. 0 .AND. P(I,J) .EQ. UPSV) THEN
                  GO TO 199
               END IF
            END IF
C
C Map the vector. If the compatiblity flag is set use the 
C compatibility subroutine.
C
            IF (ICPM .GT. 0) THEN
C
               CALL VVFCPM(I,J,UI,VI,UVM,XB,YB,XE,YE,IST)
               IF (IST .NE. 0) GO TO 195
C
            ELSE
C
               X=XLOV+REAL(I-1)*XGV
               Y=YLOV+REAL(J-1)*YGV
               CALL HLUVVMPXY(X,Y,UI,VI,UVM,XB,YB,XE,YE,IST)
               IF (IST .NE. 0) GO TO 195
C
            END IF
C
            UFR(I,J)=XB
            VFR(I,J)=YB
            GOTO 200
C
 195        CONTINUE
C
C Vectors rejected by mapping routine
C
            UFR(I,J) = -5.0
            GO TO 200
C
 196        CONTINUE
C
C Vectors under minimum magnitude
C
            UFR(I,J) = -3.0
            GO TO 200
C
 197        CONTINUE
C
C Vectors over maximum magnitude
C
            UFR(I,J) = -4.0
            GO TO 200
C
C Zero length vectors cannot be drawn even if UVMN is 0.0, but
C need to be treated as if they were drawn.
C
 198        CONTINUE
C
            UFR(I,J) = -5.0
            GO TO 200
C
C Special values
C
 199        CONTINUE
            UFR(I,J) = -2.0
C
 200     CONTINUE
 201  CONTINUE
C
C End of location loop.
C
C For each vector determine the vectors nearby that are too close;
C eliminate these vectors      
C
      VMD = RVMD*FW2W
      VSQ = VMD*VMD
      DO 501 J=1,IYDN,IYIN
         DO 500 I=1,IXDM,IXIN
            IF (UFR(I,J) .LT. 0.0) GO TO 500
C
            MXI = I+IXIN
            DO 401 JJ=J,IYDN,IYIN
               IF (MXI.LE.I) THEN
                  GO TO 405
               END IF
               ICM = I
               DO 400 II=I,IXDM,IXIN
                  IF (I.EQ.II .AND. J.EQ.JJ) THEN
                     ICM = I+IXIN
                     GO TO 400
                  END IF
                  IF (UFR(II,JJ).LT.0.0) THEN
                     ICM = II + IXIN
                     GO TO 400
                  END IF
                  UT = UFR(I,J) - UFR(II,JJ)
                  VT = VFR(I,J) - VFR(II,JJ)
                  VLS = UT*UT+VT*VT
                  IF (VLS .LT. VSQ) THEN
                     UFR(II,JJ) = -1.0
                     ICM = II + IXIN
                     GO TO 400
                  ELSE 
                     MXI = ICM
                     GO TO 401
                  END IF
 400           CONTINUE
 401        CONTINUE
C
 405        CONTINUE
C
            JJMX = MIN(JJ,IYDN)
            MNI = I - 2*IXIN
            DO 411 JJ=J+IYIN,JJMX,IYIN
               IF (MNI.GE.I) THEN
                  GO TO 500
               END IF
               ICM = I - IXIN
               DO 410 II = I - IXIN,1,-IXIN
                  IF (UFR(II,JJ).EQ.-1.0) THEN
                     GO TO 411
                  END IF
                  IF (UFR(II,JJ).LT.0.0) THEN
                     ICM = II - IXIN
                     GO TO 410
                  END IF
                  UT = UFR(I,J) - UFR(II,JJ)
                  VT = VFR(I,J) - VFR(II,JJ)
                  VLS = UT*UT+VT*VT
                  IF (VLS .LT. VSQ) THEN
                     UFR(II,JJ) = -1.0
                     ICM = II - IXIN
                     GO TO 410
                  ELSE 
                     MNI = ICM
                     GO TO 411
                  END IF
 410           CONTINUE
 411        CONTINUE
C
 500     CONTINUE
 501  CONTINUE
C
C Check the edge elements backwards in case the grid wraps
C First along the left edge
C
      MXX = (IXDM-1)/IXIN * IXIN + 1
C
      DO 700 J=1,IYDN,IYIN
         IF (UFR(1,J) .LT. 0.0) THEN
            GO TO 700
         END IF
         DO 650 I=1,IXDM,IXIN
            IF (UFR(I,J) .LT. 0.0) THEN
               IF (I.EQ.MXX) GO TO 700
               GO TO 650
            END IF
            GO TO 651
 650     CONTINUE
 651     CONTINUE
C
         MNI = MXX - IXIN
         DO 601 JJ=J,IYDN,IYIN
            IF (MNI.GE.MXX) THEN
               GO TO 700
            END IF
            ICM = MXX
            DO 600 II=MXX,1,-IXIN
               IF (JJ.EQ.J) THEN
                  IF (II.EQ.1) THEN
                     GO TO 601
                  END IF
                  ICM = MXX - IXIN
               END IF
               IF (UFR(II,JJ).LT.0.0) THEN
                  ICM = II - IXIN
                  GO TO 600
               END IF
               UT = UFR(1,J) - UFR(II,JJ)
               VT = VFR(1,J) - VFR(II,JJ)
               VLS = UT*UT+VT*VT
               IF (VLS .LT. VSQ) THEN
                  ICM = II - IXIN
                  UFR(II,JJ) = -1.0
                  GO TO 600
               ELSE IF (II.GT.MNI) THEN
                  GO TO 600
               ELSE
                  MNI = ICM
                  GO TO 601
               END IF
 600        CONTINUE
 601        CONTINUE
C
 700  CONTINUE
C
      MXY = (IYDN-1)/IYIN * IYIN + 1
C
      DO 900 I=  1,IXDM,IXIN
         ITMP = 0
         DO 750 J=1,IYDN,IYIN
            IF (UFR(I,J) .LT. 0.0) THEN
               IF (J.EQ.MXY) GO TO 900
               GO TO 750
            END IF
            GO TO 751
 750     CONTINUE
 751     CONTINUE
C
         MNJ = MXY - IYIN
         DO 801 II=I,IXDM,IXIN
            IF (MNJ.GE.MXY) THEN
               GO TO 900
            END IF
            ICM = MXY
            DO 800 JJ=MXY,1,-IYIN
               IF (II.EQ.I) THEN
                  ICM = MXY - IXIN
                  IF (JJ.EQ.J) THEN
                     GO TO 800
                  END IF
               END IF   
               IF (UFR(II,JJ).LT.0.0) THEN
                  ICM = JJ - IYIN
                  GO TO 800
               END IF
               UT = UFR(I,J) - UFR(II,JJ)
               VT = VFR(I,J) - VFR(II,JJ)
               VLS = UT*UT+VT*VT
               IF (VLS .LT. VSQ) THEN
                  ICM = JJ - IYIN
                  UFR(II,JJ) = -1.0
                  GO TO 800
               ELSE IF (JJ.GE.MNJ) THEN
                  GO TO 801
               ELSE
                  MNJ = ICM
                  GO TO 801
               END IF
 800        CONTINUE
 801        CONTINUE
C
 900  CONTINUE
C
C Done
C
      RETURN
      END
C
      SUBROUTINE VVTHND(I,J,UFR,IS)
C
C Argument dimensions
C
      DIMENSION UFR(IXDM,IYDN)
C
C Input parameters
C I,J    - Indexes of grid point
C UFR    - A 2-d array containing the value -1.0 for all vectors 
C          to be thinned from the plot
C Output parameters:
C
C IS     - set to 1 if vector is to be culled, 0 otherwise.
C
C ---------------------------------------------------------------------
C
C NOTE:
C Since implicit typing is used for all real and integer variables
C a consistent length convention has been adopted to help clarify the
C significance of the variables encountered in the code for this 
C utility. All local variable and subroutine parameter identifiers 
C are limited to 1,2,or 3 characters. Four character names identify  
C members of common blocks. Five and 6 character variable names 
C denote PARAMETER constants or subroutine or function names.
C
C Declare the VV common blocks.
C
C IPLVLS - Maximum number of color threshold level values
C IPAGMX - Maximum number of area groups allowed in the area map
C
      PARAMETER (IPLVLS = 256, IPAGMX = 64)
C
C Integer and real common block variables
C
C
      COMMON /VVCOM/
     +                IUD1       ,IVD1       ,IPD1       ,IXDM       ,
     +                IYDN       ,VLOM       ,VHIM       ,ISET       ,
     +                VRMG       ,VRLN       ,VFRC       ,IXIN       ,
     +                IYIN       ,ISVF       ,UUSV       ,UVSV       ,
     +                UPSV       ,IMSK       ,ICPM       ,UVPS       ,
     +                UVPL       ,UVPR       ,UVPB       ,UVPT       ,
     +                UWDL       ,UWDR       ,UWDB       ,UWDT       ,
     +                UXC1       ,UXCM       ,UYC1       ,UYCN       ,
     +                NLVL       ,IPAI       ,ICTV       ,WDLV       ,
     +                UVMN       ,UVMX       ,PMIN       ,PMAX       ,
     +                RVMN       ,RVMX       ,RDMN       ,RDMX       ,
     +                ISPC       ,RVMD       ,IPLR       ,IVST       ,
     +                IVPO       ,ILBL       ,IDPF       ,IMSG       ,
     +                ICLR(IPLVLS)           ,TVLU(IPLVLS)
C
C Arrow size/shape parameters
C
        COMMON / VVARO /
     +                HDSZ       ,HINF       ,HANG       ,IAST       ,
     +                HSIN       ,HCOS       ,FAMN       ,FAMX       ,
     +                UVMG       ,FAIR       ,FAWR       ,FAWF       ,
     +                FAXR       ,FAXF       ,FAYR       ,FAYF       ,
     +                AROX(8)    ,AROY(8)    ,FXSZ       ,FYSZ       ,
     +                FXRF       ,FXMN       ,FYRF       ,FYMN       ,
     +                FWRF       ,FWMN       ,FIRF       ,FIMN       ,
     +                AXMN       ,AXMX       ,AYMN       ,AYMX       ,
     +                IACM       ,IAFO       ,WBAD       ,WBTF       ,
     +                WBCF       ,WBDF       ,WBSC
C
C
C Text related parameters
C
        COMMON /VVTXP /
     +                FCWM    ,ICSZ    ,
     +                FMNS    ,FMNX    ,FMNY    ,IMNP    ,IMNC  ,
     +                FMXS    ,FMXX    ,FMXY    ,IMXP    ,IMXC  ,
     +                FZFS    ,FZFX    ,FZFY    ,IZFP    ,IZFC  ,
     +                FILS    ,FILX    ,FILY    ,IILP    ,IILC  ,
     +                FLBS    ,ILBC

C
C Character variable declartions
C
      CHARACTER*160 CSTR
      PARAMETER (IPCHSZ=36)
      CHARACTER*(IPCHSZ)  CMNT,CMXT,CZFT,CLBT,CILT
C
C Text string parameters
C
      COMMON /VVCHAR/ CSTR,CMNT,CMXT,CZFT,CLBT,CILT
C
      SAVE /VVCOM/, /VVARO/, /VVTXP/, /VVCHAR/
C
      IF (UFR(I,J) .EQ. -1.0) THEN
         IS = 1
      ELSE
         IS = 0
      END IF
C
C Done
C
      RETURN
      END
            

      SUBROUTINE CLABRD( M, N, NB, A, LDA, D, E, TAUQ, TAUP, X, LDX, Y,
     $                   LDY )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      INTEGER            LDA, LDX, LDY, M, N, NB
*     ..
*     .. Array Arguments ..
      REAL               D( * ), E( * )
      COMPLEX            A( LDA, * ), TAUP( * ), TAUQ( * ), X( LDX, * ),
     $                   Y( LDY, * )
*     ..
*
*  Purpose
*  =======
*
*  CLABRD reduces the first NB rows and columns of a complex general
*  m by n matrix A to upper or lower real bidiagonal form by a unitary
*  transformation Q' * A * P, and returns the matrices X and Y which
*  are needed to apply the transformation to the unreduced part of A.
*
*  If m >= n, A is reduced to upper bidiagonal form; if m < n, to lower
*  bidiagonal form.
*
*  This is an auxiliary routine called by CGEBRD
*
*  Arguments
*  =========
*
*  M       (input) INTEGER
*          The number of rows in the matrix A.
*
*  N       (input) INTEGER
*          The number of columns in the matrix A.
*
*  NB      (input) INTEGER
*          The number of leading rows and columns of A to be reduced.
*
*  A       (input/output) COMPLEX array, dimension (LDA,N)
*          On entry, the m by n general matrix to be reduced.
*          On exit, the first NB rows and columns of the matrix are
*          overwritten; the rest of the array is unchanged.
*          If m >= n, elements on and below the diagonal in the first NB
*            columns, with the array TAUQ, represent the unitary
*            matrix Q as a product of elementary reflectors; and
*            elements above the diagonal in the first NB rows, with the
*            array TAUP, represent the unitary matrix P as a product
*            of elementary reflectors.
*          If m < n, elements below the diagonal in the first NB
*            columns, with the array TAUQ, represent the unitary
*            matrix Q as a product of elementary reflectors, and
*            elements on and above the diagonal in the first NB rows,
*            with the array TAUP, represent the unitary matrix P as
*            a product of elementary reflectors.
*          See Further Details.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(1,M).
*
*  D       (output) REAL array, dimension (NB)
*          The diagonal elements of the first NB rows and columns of
*          the reduced matrix.  D(i) = A(i,i).
*
*  E       (output) REAL array, dimension (NB)
*          The off-diagonal elements of the first NB rows and columns of
*          the reduced matrix.
*
*  TAUQ    (output) COMPLEX array dimension (NB)
*          The scalar factors of the elementary reflectors which
*          represent the unitary matrix Q. See Further Details.
*
*  TAUP    (output) COMPLEX array, dimension (NB)
*          The scalar factors of the elementary reflectors which
*          represent the unitary matrix P. See Further Details.
*
*  X       (output) COMPLEX array, dimension (LDX,NB)
*          The m-by-nb matrix X required to update the unreduced part
*          of A.
*
*  LDX     (input) INTEGER
*          The leading dimension of the array X. LDX >= max(1,M).
*
*  Y       (output) COMPLEX array, dimension (LDY,NB)
*          The n-by-nb matrix Y required to update the unreduced part
*          of A.
*
*  LDY     (output) INTEGER
*          The leading dimension of the array Y. LDY >= max(1,N).
*
*  Further Details
*  ===============
*
*  The matrices Q and P are represented as products of elementary
*  reflectors:
*
*     Q = H(1) H(2) . . . H(nb)  and  P = G(1) G(2) . . . G(nb)
*
*  Each H(i) and G(i) has the form:
*
*     H(i) = I - tauq * v * v'  and G(i) = I - taup * u * u'
*
*  where tauq and taup are complex scalars, and v and u are complex
*  vectors.
*
*  If m >= n, v(1:i-1) = 0, v(i) = 1, and v(i:m) is stored on exit in
*  A(i:m,i); u(1:i) = 0, u(i+1) = 1, and u(i+1:n) is stored on exit in
*  A(i,i+1:n); tauq is stored in TAUQ(i) and taup in TAUP(i).
*
*  If m < n, v(1:i) = 0, v(i+1) = 1, and v(i+1:m) is stored on exit in
*  A(i+2:m,i); u(1:i-1) = 0, u(i) = 1, and u(i:n) is stored on exit in
*  A(i,i+1:n); tauq is stored in TAUQ(i) and taup in TAUP(i).
*
*  The elements of the vectors v and u together form the m-by-nb matrix
*  V and the nb-by-n matrix U' which are needed, with X and Y, to apply
*  the transformation to the unreduced part of the matrix, using a block
*  update of the form:  A := A - V*Y' - X*U'.
*
*  The contents of A on exit are illustrated by the following examples
*  with nb = 2:
*
*  m = 6 and n = 5 (m > n):          m = 5 and n = 6 (m < n):
*
*    (  1   1   u1  u1  u1 )           (  1   u1  u1  u1  u1  u1 )
*    (  v1  1   1   u2  u2 )           (  1   1   u2  u2  u2  u2 )
*    (  v1  v2  a   a   a  )           (  v1  1   a   a   a   a  )
*    (  v1  v2  a   a   a  )           (  v1  v2  a   a   a   a  )
*    (  v1  v2  a   a   a  )           (  v1  v2  a   a   a   a  )
*    (  v1  v2  a   a   a  )
*
*  where a denotes an element of the original matrix which is unchanged,
*  vi denotes an element of the vector defining H(i), and ui an element
*  of the vector defining G(i).
*
*  =====================================================================
*
*     .. Parameters ..
      COMPLEX            ZERO, ONE
      PARAMETER          ( ZERO = ( 0.0E+0, 0.0E+0 ),
     $                   ONE = ( 1.0E+0, 0.0E+0 ) )
*     ..
*     .. Local Scalars ..
      INTEGER            I
      COMPLEX            ALPHA
*     ..
*     .. External Subroutines ..
      EXTERNAL           CGEMV, CLACGV, CLARFG, CSCAL
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MIN
*     ..
*     .. Executable Statements ..
*
*     Quick return if possible
*
      IF( M.LE.0 .OR. N.LE.0 )
     $   RETURN
*
      IF( M.GE.N ) THEN
*
*        Reduce to upper bidiagonal form
*
         DO 10 I = 1, NB
*
*           Update A(i:m,i)
*
            CALL CLACGV( I-1, Y( I, 1 ), LDY )
            CALL CGEMV( 'No transpose', M-I+1, I-1, -ONE, A( I, 1 ),
     $                  LDA, Y( I, 1 ), LDY, ONE, A( I, I ), 1 )
            CALL CLACGV( I-1, Y( I, 1 ), LDY )
            CALL CGEMV( 'No transpose', M-I+1, I-1, -ONE, X( I, 1 ),
     $                  LDX, A( 1, I ), 1, ONE, A( I, I ), 1 )
*
*           Generate reflection Q(i) to annihilate A(i+1:m,i)
*
            ALPHA = A( I, I )
            CALL CLARFG( M-I+1, ALPHA, A( MIN( I+1, M ), I ), 1,
     $                   TAUQ( I ) )
            D( I ) = ALPHA
            IF( I.LT.N ) THEN
               A( I, I ) = ONE
*
*              Compute Y(i+1:n,i)
*
               CALL CGEMV( 'Conjugate transpose', M-I+1, N-I, ONE,
     $                     A( I, I+1 ), LDA, A( I, I ), 1, ZERO,
     $                     Y( I+1, I ), 1 )
               CALL CGEMV( 'Conjugate transpose', M-I+1, I-1, ONE,
     $                     A( I, 1 ), LDA, A( I, I ), 1, ZERO,
     $                     Y( 1, I ), 1 )
               CALL CGEMV( 'No transpose', N-I, I-1, -ONE, Y( I+1, 1 ),
     $                     LDY, Y( 1, I ), 1, ONE, Y( I+1, I ), 1 )
               CALL CGEMV( 'Conjugate transpose', M-I+1, I-1, ONE,
     $                     X( I, 1 ), LDX, A( I, I ), 1, ZERO,
     $                     Y( 1, I ), 1 )
               CALL CGEMV( 'Conjugate transpose', I-1, N-I, -ONE,
     $                     A( 1, I+1 ), LDA, Y( 1, I ), 1, ONE,
     $                     Y( I+1, I ), 1 )
               CALL CSCAL( N-I, TAUQ( I ), Y( I+1, I ), 1 )
*
*              Update A(i,i+1:n)
*
               CALL CLACGV( N-I, A( I, I+1 ), LDA )
               CALL CLACGV( I, A( I, 1 ), LDA )
               CALL CGEMV( 'No transpose', N-I, I, -ONE, Y( I+1, 1 ),
     $                     LDY, A( I, 1 ), LDA, ONE, A( I, I+1 ), LDA )
               CALL CLACGV( I, A( I, 1 ), LDA )
               CALL CLACGV( I-1, X( I, 1 ), LDX )
               CALL CGEMV( 'Conjugate transpose', I-1, N-I, -ONE,
     $                     A( 1, I+1 ), LDA, X( I, 1 ), LDX, ONE,
     $                     A( I, I+1 ), LDA )
               CALL CLACGV( I-1, X( I, 1 ), LDX )
*
*              Generate reflection P(i) to annihilate A(i,i+2:n)
*
               ALPHA = A( I, I+1 )
               CALL CLARFG( N-I, ALPHA, A( I, MIN( I+2, N ) ),
     $                      LDA, TAUP( I ) )
               E( I ) = ALPHA
               A( I, I+1 ) = ONE
*
*              Compute X(i+1:m,i)
*
               CALL CGEMV( 'No transpose', M-I, N-I, ONE, A( I+1, I+1 ),
     $                     LDA, A( I, I+1 ), LDA, ZERO, X( I+1, I ), 1 )
               CALL CGEMV( 'Conjugate transpose', N-I, I, ONE,
     $                     Y( I+1, 1 ), LDY, A( I, I+1 ), LDA, ZERO,
     $                     X( 1, I ), 1 )
               CALL CGEMV( 'No transpose', M-I, I, -ONE, A( I+1, 1 ),
     $                     LDA, X( 1, I ), 1, ONE, X( I+1, I ), 1 )
               CALL CGEMV( 'No transpose', I-1, N-I, ONE, A( 1, I+1 ),
     $                     LDA, A( I, I+1 ), LDA, ZERO, X( 1, I ), 1 )
               CALL CGEMV( 'No transpose', M-I, I-1, -ONE, X( I+1, 1 ),
     $                     LDX, X( 1, I ), 1, ONE, X( I+1, I ), 1 )
               CALL CSCAL( M-I, TAUP( I ), X( I+1, I ), 1 )
               CALL CLACGV( N-I, A( I, I+1 ), LDA )
            END IF
   10    CONTINUE
      ELSE
*
*        Reduce to lower bidiagonal form
*
         DO 20 I = 1, NB
*
*           Update A(i,i:n)
*
            CALL CLACGV( N-I+1, A( I, I ), LDA )
            CALL CLACGV( I-1, A( I, 1 ), LDA )
            CALL CGEMV( 'No transpose', N-I+1, I-1, -ONE, Y( I, 1 ),
     $                  LDY, A( I, 1 ), LDA, ONE, A( I, I ), LDA )
            CALL CLACGV( I-1, A( I, 1 ), LDA )
            CALL CLACGV( I-1, X( I, 1 ), LDX )
            CALL CGEMV( 'Conjugate transpose', I-1, N-I+1, -ONE,
     $                  A( 1, I ), LDA, X( I, 1 ), LDX, ONE, A( I, I ),
     $                  LDA )
            CALL CLACGV( I-1, X( I, 1 ), LDX )
*
*           Generate reflection P(i) to annihilate A(i,i+1:n)
*
            ALPHA = A( I, I )
            CALL CLARFG( N-I+1, ALPHA, A( I, MIN( I+1, N ) ), LDA,
     $                   TAUP( I ) )
            D( I ) = ALPHA
            IF( I.LT.M ) THEN
               A( I, I ) = ONE
*
*              Compute X(i+1:m,i)
*
               CALL CGEMV( 'No transpose', M-I, N-I+1, ONE, A( I+1, I ),
     $                     LDA, A( I, I ), LDA, ZERO, X( I+1, I ), 1 )
               CALL CGEMV( 'Conjugate transpose', N-I+1, I-1, ONE,
     $                     Y( I, 1 ), LDY, A( I, I ), LDA, ZERO,
     $                     X( 1, I ), 1 )
               CALL CGEMV( 'No transpose', M-I, I-1, -ONE, A( I+1, 1 ),
     $                     LDA, X( 1, I ), 1, ONE, X( I+1, I ), 1 )
               CALL CGEMV( 'No transpose', I-1, N-I+1, ONE, A( 1, I ),
     $                     LDA, A( I, I ), LDA, ZERO, X( 1, I ), 1 )
               CALL CGEMV( 'No transpose', M-I, I-1, -ONE, X( I+1, 1 ),
     $                     LDX, X( 1, I ), 1, ONE, X( I+1, I ), 1 )
               CALL CSCAL( M-I, TAUP( I ), X( I+1, I ), 1 )
               CALL CLACGV( N-I+1, A( I, I ), LDA )
*
*              Update A(i+1:m,i)
*
               CALL CLACGV( I-1, Y( I, 1 ), LDY )
               CALL CGEMV( 'No transpose', M-I, I-1, -ONE, A( I+1, 1 ),
     $                     LDA, Y( I, 1 ), LDY, ONE, A( I+1, I ), 1 )
               CALL CLACGV( I-1, Y( I, 1 ), LDY )
               CALL CGEMV( 'No transpose', M-I, I, -ONE, X( I+1, 1 ),
     $                     LDX, A( 1, I ), 1, ONE, A( I+1, I ), 1 )
*
*              Generate reflection Q(i) to annihilate A(i+2:m,i)
*
               ALPHA = A( I+1, I )
               CALL CLARFG( M-I, ALPHA, A( MIN( I+2, M ), I ), 1,
     $                      TAUQ( I ) )
               E( I ) = ALPHA
               A( I+1, I ) = ONE
*
*              Compute Y(i+1:n,i)
*
               CALL CGEMV( 'Conjugate transpose', M-I, N-I, ONE,
     $                     A( I+1, I+1 ), LDA, A( I+1, I ), 1, ZERO,
     $                     Y( I+1, I ), 1 )
               CALL CGEMV( 'Conjugate transpose', M-I, I-1, ONE,
     $                     A( I+1, 1 ), LDA, A( I+1, I ), 1, ZERO,
     $                     Y( 1, I ), 1 )
               CALL CGEMV( 'No transpose', N-I, I-1, -ONE, Y( I+1, 1 ),
     $                     LDY, Y( 1, I ), 1, ONE, Y( I+1, I ), 1 )
               CALL CGEMV( 'Conjugate transpose', M-I, I, ONE,
     $                     X( I+1, 1 ), LDX, A( I+1, I ), 1, ZERO,
     $                     Y( 1, I ), 1 )
               CALL CGEMV( 'Conjugate transpose', I, N-I, -ONE,
     $                     A( 1, I+1 ), LDA, Y( 1, I ), 1, ONE,
     $                     Y( I+1, I ), 1 )
               CALL CSCAL( N-I, TAUQ( I ), Y( I+1, I ), 1 )
            ELSE
               CALL CLACGV( N-I+1, A( I, I ), LDA )
            END IF
   20    CONTINUE
      END IF
      RETURN
*
*     End of CLABRD
*
      END

C
C $Id: agsrch.f,v 1.8 2008-07-27 00:14:35 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE AGSRCH (TPID,IPID,IKWL,UKWL,LKWL)
C
      CHARACTER*(*) TPID,UKWL,LKWL
C
C The routine AGSRCH is used by AGSCAN to search a parameter identifier
C for the next keyword and return the index of that keyword in a list of
C keywords.  It has the following arguments.
C
C -- TPID is the parameter identifier, a character string.
C
C -- IPID is the index of the last character examined in TPID.  It is
C    updated by AGSRCH to point to the first slash or period following
C    the next keyword.
C
C -- IKWL is returned containing the index (in the keyword list) of the
C    next keyword in the parameter identifier (list length, plus one,
C    if the keyword is not found in the list).
C
C -- UKWL is the keyword list - 4*NOKW characters in all.
C
C -- LKWL is identical to UKWL, but in lower case.
C
C ICHR is used to hold up to four characters of a keyword.
C
      CHARACTER*4 ICHR
C
C LPID is the assumed maximum length of a parameter identifier.
C
      DATA LPID / 100 /
C
C Compute the number of 4-character keywords in the keyword list.
C
      NOKW=LEN(UKWL)/4
C
C Find the next non-blank in the parameter identifier.
C
  101 IPID=IPID+1
      IF (IPID.GT.LPID) GO TO 107
      IF (TPID(IPID:IPID).EQ.' ') GO TO 101
C
C Pick up at most four characters of the keyword, stopping on the first
C blank, slash, or period encountered.
C
      NCHR=0
C
  102 IF (TPID(IPID:IPID).EQ.' '.OR.
     +    TPID(IPID:IPID).EQ.'/'.OR.
     +    TPID(IPID:IPID).EQ.'.') GO TO 103
C
      NCHR=NCHR+1
      ICHR(NCHR:NCHR)=TPID(IPID:IPID)
C
      IPID=IPID+1
C
      IF (NCHR.LT.4) GO TO 102
C
C If the keyword found has zero length, error.
C
  103 IF (NCHR.EQ.0) GO TO 107
C
C Scan ahead for the next slash or period.
C
  104 IF (TPID(IPID:IPID).EQ.'/'.OR.TPID(IPID:IPID).EQ.'.') GO TO 105
C
      IPID=IPID+1
      IF (IPID.GT.LPID) GO TO 107
      GO TO 104
C
C Search the keyword list for the keyword found.
C
  105 DO 106 I=1,NOKW
        IKWL=I
        ISTR=(I-1)*4+1
        IEND=(I-1)*4+NCHR
        IF (ICHR(1:NCHR).EQ.UKWL(ISTR:IEND).OR.
     +      ICHR(1:NCHR).EQ.LKWL(ISTR:IEND)) RETURN
  106 CONTINUE
C
C Keyword not found - set IKWL to impossible value and return.
C
  107 IKWL=NOKW+1
      RETURN
C
      END

C NCLFORTSTART
      SUBROUTINE DSHSGCR42(A,B,GVAR,WORK,LWORK)
C NCL  gvar = shsgsc_R42(a,b)
      IMPLICIT NONE
      INTEGER LWORK
      DOUBLE PRECISION A(43,43),B(43,43),GVAR(128,108)
      DOUBLE PRECISION WORK(LWORK)
C NCLEND

c driver to subroutines provided by: "Bao Qing" <baoqing@mail.iap.ac.cn>
c array sizes are *hard wired* for gaussian rhomboidal truncation R42
c
c arguments:
c .     a, b    - real, imaginary spherical harmonic coef (input)
c .     gvar    - grid variable (out)
c local
c .     glat    - gaussian latitude
c .     gw      - gaussian weights

c local
      INTEGER NLAT, IER
C     PARAMETER (NLAT=108, LWORK=4*NLAT*(NLAT+1)+2)
      PARAMETER (NLAT=108)
      INTEGER I
      DOUBLE PRECISION GLAT(108),GWGT(108)
      DOUBLE PRECISION RADTODEG
      PARAMETER (RADTODEG=57.2957795)
C
C Generate gaussian lats and weights.
C 
      CALL GAQDNCL(NLAT,GLAT,GWGT,WORK,LWORK,IER)
C
C Convert to degrees and subtract 90.
C
      DO 10 I=1,NLAT
         GLAT(I) = (RADTODEG * GLAT(I)) - 90.0
 10   END DO

      CALL DTRME(A,B,GVAR,GLAT,GWGT)

      END

      SUBROUTINE DTRME(A,B,GVAR,XLAT,GW)
      DOUBLE PRECISION PS1
c rhombical truncation parameter
      INTEGER IRES
c number of longitudes
      INTEGER IX
c ix>=3*ires for rhombical truncation

c number of latitudes
      INTEGER IY
c iy>=(5*ires+1)/2 for rhombical truncation

      PARAMETER (IRES=42)
      PARAMETER (IX=128)
      PARAMETER (IY=108)

      INTEGER JXX,JX,MX
      INTEGER JXXMX,JXMX,MX2
      INTEGER IYH
      PARAMETER (JXX=IRES+2,JX=IRES+1,MX=IRES+1)
      PARAMETER (JXXMX=JXX*MX,JXMX=JX*MX,MX2=MX*2)
      PARAMETER (IYH=IY/2)
C
      INTEGER IHEM,IH,ILEV
      COMMON /LEVPOS/IHEM,IH,ILEV
      DOUBLE PRECISION EPSINV
      COMMON /KERNEL/EPSINV(JXX,MX)
      COMMON /LEGPOL/POLY(JXX,MX),W(IY),WOCS(IY),COA(IY),SIA(IY),
     +       DELTA(IY)
      DOUBLE PRECISION POLY,W,WOCS,COA,SIA,DELTA
c
c
c
      INTEGER IR,IRP1,IRP2,IRMAX,IRMAX1,IRMAX2,I2IR,I4IR,ND2P1
      COMMON /SPECT/IR,IRP1,IRP2,IRMAX,IRMAX1,IRMAX2,I2IR,I4IR,ND2P1
      COMMON /LOCLOC/EPSI(JXX,MX),ILAT,ILATH,ILONG,ILONGL
      INTEGER ILAT,ILATH,ILONG,ILONGL
      DOUBLE PRECISION EPSI
c
      DOUBLE PRECISION ALLALP(JXX,MX,IYH)
c *** dimension information
c
      DOUBLE COMPLEX SVAR(JX,MX),PSS(JXX,MX),FTPS(MX)
c
      DOUBLE PRECISION A(JX,MX),B(JX,MX),GVAR(IX,IY)

c
c local variable
c
      INTEGER I,J,K
      INTEGER JJ,INHSH,LATREL
      INTEGER KI,KS,KK
      INTEGER M
      DOUBLE PRECISION XLAT(IY),GW(IY)
c----------------------------------------------------------------------
c
c Set some constants.
c
      CALL DINITAL
c
c set lat information
c
      DO J = 1,IY
          W(J) = GW(J)
      END DO
c
      DO J = 1,IY
          COA(J) = SIN(XLAT(J)*ASIN(1.0D0)/90.D0)
      END DO
c
c     svar = cmplx(a,b)       original code had f90  array syntax
      DO I = 1,MX
          DO J = 1,JX
              SVAR(J,I) = DCMPLX(A(J,I),B(J,I))
          END DO
      END DO
c
      CALL DGAUSSV(ILAT,ILONG)
c
      CALL DEPSCAL(EPSI,IR)
c
      DO M = 1,IRP1
          EPSINV(1,M) = 0.0D0
      END DO
      DO M = 1,IRP1
          DO J = 2,IRP2
              EPSINV(J,M) = 1.0D0/EPSI(J,M)
          END DO
      END DO
c
c Precompute legendre functions and put on disk
c
      DO IH = 1,ILATH
          CALL DALPMN1(POLY,COA(IH),MX,JXX,EPSI)
          DO J = 1,MX
              DO I = 1,JXX
                  ALLALP(I,J,IH) = POLY(I,J)
              END DO
          END DO
      END DO
c
c     calculate PS fields and map if requested
c
      PS1 = 0
      DO 335 M = 1,MX
          PSS(JXX,M) = (0.D0,0.D0)
          DO 335 J = 1,JX
              PSS(J,M) = SVAR(J,M)
  335 CONTINUE
      DO 130 IH = 1,IYH
          DO J = 1,MX
              DO I = 1,JXX
                  POLY(I,J) = ALLALP(I,J,IH)
              END DO
          END DO
          DO 130 INHSH = 1,2
              IF (INHSH.EQ.1) LATREL = IH
              IF (INHSH.EQ.2) LATREL = IY + 1 - IH
              IF (INHSH.EQ.2) CALL DASS
              CALL DLGNTJM(FTPS,PSS,POLY,JXX,MX,1)
              CALL DMFFTG(GVAR(1,LATREL),FTPS,1,0)
c
  130 CONTINUE
      END
c
      SUBROUTINE DALPMN1(ALP,SINLAT,IRP1,IRP2,EPSI)
      DOUBLE PRECISION ALP
      DOUBLE PRECISION SINLAT
      DOUBLE PRECISION EPSI
      DOUBLE PRECISION PROD
      DOUBLE PRECISION EPSINV
      DOUBLE PRECISION COS2
      DOUBLE PRECISION COS2A
      DOUBLE PRECISION B
      DOUBLE PRECISION FMPTH
c
c     *fills alp(irp2,irp1) for a given sin(lat)
c
c djs include 'res.h'
c rhombical truncation parameter
      INTEGER IRES
c number of longitudes
      INTEGER IX
c ix>=3*ires for rhombical truncation

c number of latitudes
      INTEGER IY
c iy>=(5*ires+1)/2 for rhombical truncation

      PARAMETER (IRES=42)
      PARAMETER (IX=128)
      PARAMETER (IY=108)

      PARAMETER (JXX=IRES+2,JX=IRES+1,MX=IRES+1)
      PARAMETER (JXXMX=JXX*MX,JXMX=JX*MX,MX2=MX*2)
c
      DIMENSION ALP(IRP2,IRP1),EPSI(IRP2,IRP1),PROD(MX)
      COMMON /KERNEL/EPSINV(JXX,MX)
c     --------------------------------------------------------------
c
      COS2 = 1.0D0 - SINLAT*SINLAT
      COS2A = COS2
      PROD(1) = 1.0D0
      B = 0.0D0
c
      DO M = 2,IRP1
          COS2A = COS2A + COS2 + COS2
          B = B + 2.0D0
          PROD(M) = PROD(M-1)*COS2A/B
      END DO
c
      ALP(1,1) = SQRT(0.5D0)
      ALP(2,1) = SQRT(1.5D0)*SINLAT
      DO M = 2,IRP1
          FMPTH = M + 0.5D0
          ALP(1,M) = SQRT(0.5D0*PROD(M))
          ALP(2,M) = SQRT(FMPTH+FMPTH)*SINLAT*ALP(1,M)
      END DO
c
      DO 20 N = 3,IRP2
          DO 20 M = 1,IRP1
              ALP(N,M) = (SINLAT*ALP(N-1,M)-EPSI(N-1,M)*ALP(N-2,M))*
     +                   EPSINV(N,M)
   20 CONTINUE
c
      RETURN
      END
C
      SUBROUTINE DCOOL(DATA,NPREV,N,NREM,ISIGN,IFACT)
      DOUBLE PRECISION DATA
      DOUBLE PRECISION ROOTRA
      DOUBLE PRECISION ROOTIA
      DOUBLE PRECISION WSTPRA
      DOUBLE PRECISION WSTPIA
      DOUBLE PRECISION ZSTPRA
      DOUBLE PRECISION ZSTPIA
      DOUBLE PRECISION TWOPI
      DOUBLE PRECISION ROOTR
      DOUBLE PRECISION ROOTI
      DOUBLE PRECISION WSTPR
      DOUBLE PRECISION WSTPI
      DOUBLE PRECISION WR
      DOUBLE PRECISION WI
      DOUBLE PRECISION W2R
      DOUBLE PRECISION W2I
      DOUBLE PRECISION W3R
      DOUBLE PRECISION W3I
      DOUBLE PRECISION TEMPR
      DOUBLE PRECISION TEMPI
      DOUBLE PRECISION SUMR
      DOUBLE PRECISION SUMI
      DOUBLE PRECISION DIFR
      DOUBLE PRECISION DIFI
      DOUBLE PRECISION T0R
      DOUBLE PRECISION T0I
      DOUBLE PRECISION T1R
      DOUBLE PRECISION T1I
      DOUBLE PRECISION T2R
      DOUBLE PRECISION T2I
      DOUBLE PRECISION T3R
      DOUBLE PRECISION T3I
c     fourier transform of length n.  in place cooley-tukey method,
c     digit-reversed to normal order, sande-tukey factoring (2).
c     dimension data(nprev,n,nrem)
c     complex data
c     data(i1,j2,i3) = sum(data(i1,i2,i3)*exp(isign*2*pi*i*((i2-1)*
c     (j2-1)/n))), summed over i2 = 1 to n for all i1 from 1 to nprev,
c     j2 from 1 to n and i3 from 1 to nrem.  the factors of n are given
c     in any order in array ifact.  factors of two are done in pairs
c     as much as possible (fourier transform of length four), factors of
c     three are done separately, and all factors five or higher
c     are done by goertzels algorithm (4).
      DIMENSION DATA(1),IFACT(1)
      PARAMETER (IX=128)
      COMMON /BREN2/ROOTRA(6,2),ROOTIA(6,2),WSTPRA(6,2),WSTPIA(6,2),
     +       ZSTPRA(2),ZSTPIA(2),IORD(IX+2)
      COMMON /FFTLOC/IHM1(30),LEV
c
      TWOPI = 6.2831853071795865D0*DBLE(ISIGN)
      IP0 = 2
      IP1 = IP0*NPREV
      IP4 = IP1*N
      IP5 = IP4*NREM
      IF = 0
      IP2 = IP1
   10 IF (IP2-IP4) 20,240,240
   20 IF = IF + 1
      IFCUR = IFACT(IF)
      IF (IFCUR-2) 60,30,60
   30 IF (4*IP2-IP4) 40,40,60
   40 IF (IFACT(IF+1)-2) 60,50,60
   50 IF = IF + 1
      IFCUR = 4
   60 IP3 = IP2*IFCUR
      IS = 1
      IF (ISIGN.GT.0) IS = 2
      ROOTR = ROOTRA(IF,IS)
      ROOTI = ROOTIA(IF,IS)
      WSTPR = WSTPRA(IF,IS)
      WSTPI = WSTPIA(IF,IS)
      WR = 1.D0
      WI = 0.D0
      DO 230 I2 = 1,IP2,IP1
          IF (IFCUR-4) 70,70,210
   70     IF ((I2-1)* (IFCUR-2)) 240,90,80
   80     W2R = WR*WR - WI*WI
          W2I = 2.D0*WR*WI
          W3R = W2R*WR - W2I*WI
          W3I = W2R*WI + W2I*WR
   90     I1MAX = I2 + IP1 - IP0
          DO 200 I1 = I2,I1MAX,IP0
              DO 200 I5 = I1,IP5,IP3
                  DO 200 IH = 1,LEV
                      J0 = I5 + IHM1(IH)
                      J1 = J0 + IP2
                      J2 = J1 + IP2
                      J3 = J2 + IP2
                      IF (I2-1) 140,140,100
  100                 IF (IFCUR-3) 130,120,110
c     apply the phase shift factors
  110                 TEMPR = DATA(J3)
                      DATA(J3) = W3R*TEMPR - W3I*DATA(J3+1)
                      DATA(J3+1) = W3R*DATA(J3+1) + W3I*TEMPR
                      TEMPR = DATA(J2)
                      DATA(J2) = WR*TEMPR - WI*DATA(J2+1)
                      DATA(J2+1) = WR*DATA(J2+1) + WI*TEMPR
                      TEMPR = DATA(J1)
                      DATA(J1) = W2R*TEMPR - W2I*DATA(J1+1)
                      DATA(J1+1) = W2R*DATA(J1+1) + W2I*TEMPR
                      GO TO 140
  120                 TEMPR = DATA(J2)
                      DATA(J2) = W2R*TEMPR - W2I*DATA(J2+1)
                      DATA(J2+1) = W2R*DATA(J2+1) + W2I*TEMPR
  130                 TEMPR = DATA(J1)
                      DATA(J1) = WR*TEMPR - WI*DATA(J1+1)
                      DATA(J1+1) = WR*DATA(J1+1) + WI*TEMPR
  140                 IF (IFCUR-3) 150,160,170
c     do a fourier transform of length two
  150                 TEMPR = DATA(J1)
                      TEMPI = DATA(J1+1)
                      DATA(J1) = DATA(J0) - TEMPR
                      DATA(J1+1) = DATA(J0+1) - TEMPI
                      DATA(J0) = DATA(J0) + TEMPR
                      DATA(J0+1) = DATA(J0+1) + TEMPI
                      GO TO 200
c     do a fourier transform of length three
  160                 SUMR = DATA(J1) + DATA(J2)
                      SUMI = DATA(J1+1) + DATA(J2+1)
                      TEMPR = DATA(J0) - .5D0*SUMR
                      TEMPI = DATA(J0+1) - .5D0*SUMI
                      DATA(J0) = DATA(J0) + SUMR
                      DATA(J0+1) = DATA(J0+1) + SUMI
                      DIFR = ROOTI* (DATA(J2+1)-DATA(J1+1))
                      DIFI = ROOTI* (DATA(J1)-DATA(J2))
                      DATA(J1) = TEMPR + DIFR
                      DATA(J1+1) = TEMPI + DIFI
                      DATA(J2) = TEMPR - DIFR
                      DATA(J2+1) = TEMPI - DIFI
                      GO TO 200
c     do a fourier transform of length four (from bit reversed order)
  170                 T0R = DATA(J0) + DATA(J1)
                      T0I = DATA(J0+1) + DATA(J1+1)
                      T1R = DATA(J0) - DATA(J1)
                      T1I = DATA(J0+1) - DATA(J1+1)
                      T2R = DATA(J2) + DATA(J3)
                      T2I = DATA(J2+1) + DATA(J3+1)
                      T3R = DATA(J2) - DATA(J3)
                      T3I = DATA(J2+1) - DATA(J3+1)
                      DATA(J0) = T0R + T2R
                      DATA(J0+1) = T0I + T2I
                      DATA(J2) = T0R - T2R
                      DATA(J2+1) = T0I - T2I
                      IF (ISIGN) 180,180,190
  180                 T3R = -T3R
                      T3I = -T3I
  190                 DATA(J1) = T1R - T3I
                      DATA(J1+1) = T1I + T3R
                      DATA(J3) = T1R + T3I
                      DATA(J3+1) = T1I - T3R
  200     CONTINUE
          GO TO 220
c     do a fourier transform of length five or more
c210  call goert (data(i2),nprev,ip2/ip1,ifcur,ip5/ip3,work,wr,wi,rootr,
c    $rooti)
  210     CONTINUE
  220     TEMPR = WR
          WR = WSTPR*TEMPR - WSTPI*WI + TEMPR
  230 WI = WSTPR*WI + WSTPI*TEMPR + WI
      IP2 = IP3
      GO TO 10
  240 RETURN
      END
c
      SUBROUTINE DFIXRL(DATA,N,NREM,ISIGN,IFORM)
c     for iform = 0, convert the transform of a doubled-up real array,
c     considered complex, into its true transform.  supply only the
c     first half of the complex transform, as the second half has
c     conjugate symmetry.  for iform = -1, convert the first half
c     of the true transform into the transform of a doubled-up real
c     array.  n must be even.
c     using complex notation and subscripts starting at zero, the
c     transformation is--
c     dimension data(n,nrem)
c     zstp = exp(isign*2*pi*i/n)
c     do 10 i2=0,nrem-1
c     data(0,i2) = conj(data(0,i2))*(1+i)
c     do 10 i1=1,n/4
c     z = (1+(2*iform+1)*i*zstp**i1)/2
c     i1cnj = n/2-i1
c     dif = data(i1,i2)-conj(data(i1cnj,i2))
c     temp = z*dif
c     data(i1,i2) = (data(i1,i2)-temp)*(1-iform)
c 10  data(i1cnj,i2) = (data(i1cnj,i2)+conj(temp))*(1-iform)
c     if i1=i1cnj, the calculation for that value collapses into
c     a simple conjugation of data(i1,i2).
      PARAMETER (IX=128)
      DOUBLE PRECISION DATA
      DOUBLE PRECISION ROOTRA
      DOUBLE PRECISION ROOTIA
      DOUBLE PRECISION WSTPRA
      DOUBLE PRECISION WSTPIA
      DOUBLE PRECISION ZSTPRA
      DOUBLE PRECISION ZSTPIA
      DOUBLE PRECISION TWOPI
      DOUBLE PRECISION TEMPR
      DOUBLE PRECISION ZSTPR
      DOUBLE PRECISION ZSTPI
      DOUBLE PRECISION ZR
      DOUBLE PRECISION ZI
      DOUBLE PRECISION DIFR
      DOUBLE PRECISION DIFI
      DOUBLE PRECISION TEMPI
      COMMON /BREN2/ROOTRA(6,2),ROOTIA(6,2),WSTPRA(6,2),WSTPIA(6,2),
     +       ZSTPRA(2),ZSTPIA(2),IORD(IX+2)
c     common /fftloc/ihm1(9),lev
      COMMON /FFTLOC/IHM1(30),LEV
      DIMENSION DATA(1)
c
      TWOPI = 6.2831853071795865D0*DBLE(ISIGN)
      IP0 = 2
      IP1 = IP0* (N/2)
      IP2 = IP1*NREM
      IF (IFORM) 10,70,70
c     pack the real input values (two per column)
   10 CONTINUE
      DO 119 IH = 1,LEV
          J1 = IP1 + 1 + IHM1(IH)
          DATA(2+IHM1(IH)) = DATA(J1)
  119 CONTINUE
      IF (NREM-1) 70,70,20
   20 DO 60 IH = 1,LEV
          J1 = IP1 + 1 + IHM1(IH) + IP0
          I2MIN = IP1 + 1
          DO 60 I22 = I2MIN,IP2,IP1
              I2 = I22 + IHM1(IH)
              DATA(I2) = DATA(J1)
              J1 = J1 + IP0
              IF (N-2) 50,50,30
   30         I1MIN = I2 + IP0
              I1MAX = I2 + IP1 - IP0
              DO 40 I1 = I1MIN,I1MAX,IP0
                  DATA(I1) = DATA(J1)
                  DATA(I1+1) = DATA(J1+1)
   40         J1 = J1 + IP0
   50         DATA(I2+1) = DATA(J1)
   60 J1 = J1 + IP0
   70 DO 80 IH = 1,LEV
          DO 80 I22 = 1,IP2,IP1
              I2 = I22 + IHM1(IH)
              TEMPR = DATA(I2)
              DATA(I2) = DATA(I2) + DATA(I2+1)
   80 DATA(I2+1) = TEMPR - DATA(I2+1)
      IF (N-2) 200,200,90
   90 IS = 1
      IF (ISIGN.GT.0) IS = 2
      ZSTPR = ZSTPRA(IS)
      ZSTPI = ZSTPIA(IS)
      ZR = (1.D0-ZSTPI)/2.D0
      ZI = (1.D0+ZSTPR)/2.D0
      IF (IFORM) 100,110,110
  100 ZR = 1.D0 - ZR
      ZI = -ZI
  110 I1MIN = IP0 + 1
      I1MAX = IP0* (N/4) + 1
      DO 190 I11 = I1MIN,I1MAX,IP0
          DO 180 I22 = I11,IP2,IP1
              DO 180 IH = 1,LEV
                  I1 = I11 + IHM1(IH)
                  I2 = I22 + IHM1(IH)
                  I2CNJ = IP0* (N/2+1) - 2*I11 + I22
                  I2CNJ = I2CNJ + IHM1(IH)
                  IF (I2-I2CNJ) 150,120,120
  120             IF (ISIGN* (2*IFORM+1)) 130,140,140
  130             DATA(I2+1) = -DATA(I2+1)
  140             IF (IFORM) 170,180,180
  150             DIFR = DATA(I2) - DATA(I2CNJ)
                  DIFI = DATA(I2+1) + DATA(I2CNJ+1)
                  TEMPR = DIFR*ZR - DIFI*ZI
                  TEMPI = DIFR*ZI + DIFI*ZR
                  DATA(I2) = DATA(I2) - TEMPR
                  DATA(I2+1) = DATA(I2+1) - TEMPI
                  DATA(I2CNJ) = DATA(I2CNJ) + TEMPR
                  DATA(I2CNJ+1) = DATA(I2CNJ+1) - TEMPI
                  IF (IFORM) 160,180,180
  160             DATA(I2CNJ) = DATA(I2CNJ) + DATA(I2CNJ)
                  DATA(I2CNJ+1) = DATA(I2CNJ+1) + DATA(I2CNJ+1)
  170             DATA(I2) = DATA(I2) + DATA(I2)
                  DATA(I2+1) = DATA(I2+1) + DATA(I2+1)
  180     CONTINUE
          TEMPR = ZR - .5D0
          ZR = ZSTPR*TEMPR - ZSTPI*ZI + ZR
  190 ZI = ZSTPR*ZI + ZSTPI*TEMPR + ZI
c     recursion saves time, at a slight loss in accuracy.  if available,
c     use double precision to compute zr and zi.
  200 IF (IFORM) 270,210,210
c     unpack the real transform values (two per column)
  210 DO 260 IH = 1,LEV
          I2 = IP2 + 1 + IHM1(IH)
          I1 = I2
          J1 = IP0* (N/2+1)*NREM + 1 + IHM1(IH)
          GO TO 250
  220     DATA(J1) = DATA(I1)
          DATA(J1+1) = DATA(I1+1)
          I1 = I1 - IP0
          J1 = J1 - IP0
  230     IF (I2-I1) 220,240,240
  240     DATA(J1) = DATA(I1)
          DATA(J1+1) = 0.D0
  250     I2 = I2 - IP1
          J1 = J1 - IP0
          DATA(J1) = DATA(I2+1)
          DATA(J1+1) = 0.D0
          I1 = I1 - IP0
          J1 = J1 - IP0
          IF (I2-1-IHM1(IH)) 260,260,230
  260 DATA(2+IHM1(IH)) = 0.0D0
  270 RETURN
      END
c
      SUBROUTINE DGAUSSV(ILAT,ILONG)
      DOUBLE PRECISION ROOTRA
      DOUBLE PRECISION ROOTIA
      DOUBLE PRECISION WSTPRA
      DOUBLE PRECISION WSTPIA
      DOUBLE PRECISION ZSTPRA
      DOUBLE PRECISION ZSTPIA
      DOUBLE PRECISION DATA
      DOUBLE PRECISION WORK
      DOUBLE PRECISION PI
      DOUBLE PRECISION TWOPIC
      DOUBLE PRECISION TWOPI
      DOUBLE PRECISION THETA
      DOUBLE PRECISION SINTH
      DOUBLE PRECISION ROOTR
      DOUBLE PRECISION ROOTI
      DOUBLE PRECISION WSTPR
      DOUBLE PRECISION WSTPI
      DOUBLE PRECISION ZSTPR
      DOUBLE PRECISION ZSTPI
c djs include 'res.h'
c rhombical truncation parameter
      INTEGER IRES
c number of longitudes
      INTEGER IX
c ix>=3*ires for rhombical truncation

c number of latitudes
      INTEGER IY
c iy>=(5*ires+1)/2 for rhombical truncation

      PARAMETER (IRES=42)
      PARAMETER (IX=128)
      PARAMETER (IY=108)

      PARAMETER (JXX=IRES+2,JX=IRES+1,MX=IRES+1)
      PARAMETER (JXXMX=JXX*MX,JXMX=JX*MX,MX2=MX*2)
c
      DOUBLE PRECISION ALP,W,WOCS,COA,SIA,DELTA
      COMMON /LEGPOL/ALP(JXXMX),W(IY),WOCS(IY),COA(IY),SIA(IY),DELTA(IY)
      COMMON /BRENN/NCURR,IFACT(32),NFACT,ISYM,IFSYM(32),NFSYM,ICENT,
     +       IFCNT(10),NFCNT
      COMMON /BREN2/ROOTRA(6,2),ROOTIA(6,2),WSTPRA(6,2),WSTPIA(6,2),
     +       ZSTPRA(2),ZSTPIA(2),IORD(IX+2)

      DIMENSION DATA(IX+2),WORK(12)
      COMMON /FFTLOC/IHM1(30),LEV
      COMMON /LEVPOS/IHEM,IH,ILEV
c
      PI = 4.0D0*ATAN(1.0D0)
c
      DO IH = 1,ILEV
          IHM1(IH) = (IH-1)* (ILONG+2)
      END DO
c
      NCURR = ILONG/2
      DO I = 1,ILAT
          W(I) = W(I)/ILONG
          DELTA(I) = ACOS(COA(I))
          SIA(I) = SIN(DELTA(I))
          WOCS(I) = W(I)/ (SIA(I)*SIA(I))
      END DO
c
      CALL DFACTR(NCURR,IFACT,NFACT)
      CALL DSMFAC(IFACT,NFACT,ISYM,IFSYM,NFSYM,ICENT,IFCNT,NFCNT)
      TWOPIC = 2.0D0*PI
      IPO = 2
      N = ILONG
      IP1 = IPO
      IP4 = IP1*NCURR
      IP5 = IP1
      DO 480 IS = 1,2
          IF = 0
          IP2 = IP1
          TWOPI = -TWOPIC
          IF (IS.EQ.2) TWOPI = TWOPIC
  200     IF (IP2.GE.IP4) GO TO 480
          IF = IF + 1
          IFCUR = IFACT(IF)
          IF (IFCUR.NE.2) GO TO 120
          IF (4*IP2.GT.IP4) GO TO 120
          IF (IFACT(IF+1).NE.2) GO TO 120
          IF = IF + 1
          IFCUR = 4
  120     IP3 = IP2*IFCUR
          THETA = TWOPI/DBLE(IFCUR)
          SINTH = SIN(THETA/2.0D0)
          ROOTR = -2.0D0*SINTH*SINTH
          ROOTI = SIN(THETA)
          THETA = TWOPI/DBLE(IP3/IP1)
          SINTH = SIN(THETA/2.0D0)
          WSTPR = -2.0D0*SINTH*SINTH
          WSTPI = SIN(THETA)
          ROOTRA(IF,IS) = ROOTR
          ROOTIA(IF,IS) = ROOTI
          WSTPRA(IF,IS) = WSTPR
          WSTPIA(IF,IS) = WSTPI
          IP2 = IP3
          GO TO 200
  480 CONTINUE
  240 CONTINUE
c
      IF (N.LE.2) GO TO 900
      DO IS = 1,2
          TWOPI = -TWOPIC
          IF (IS.EQ.2) TWOPI = TWOPIC
          THETA = TWOPI/DBLE(N)
          SINTH = SIN(THETA/2.0D0)
          ZSTPR = -2.0D0*SINTH*SINTH
          ZSTPI = SIN(THETA)
          ZSTPRA(IS) = ZSTPR
          ZSTPIA(IS) = ZSTPI
      END DO
  900 CONTINUE
c
      NP2 = ILONG + 2
      DO I = 1,NP2
          DATA(I) = DBLE(I)
      END DO
c
      CALL DSYMRV(DATA,1,NCURR,1,IFSYM,NFSYM)
      CALL DASMRV(DATA,ISYM,ICENT,ISYM,IFCNT,NFCNT,WORK)
c
      DO I = 1,NP2
          IORD(I) = DATA(I)
      END DO
c
      RETURN
      END
c
      SUBROUTINE DLGNTJM(FTVAR,VAR,P,JX,MX,KX)
      DOUBLE PRECISION P
      DOUBLE COMPLEX VAR(JX,MX,KX),FTVAR(MX,KX)
      DIMENSION P(JX,MX)
c
      DO 10 K = 1,KX
          DO 10 M = 1,MX
              FTVAR(M,K) = (0.0D0,0.0D0)
              DO 10 J = 1,JX
                  FTVAR(M,K) = FTVAR(M,K) + VAR(J,M,K)*P(J,M)
   10 CONTINUE
c
      RETURN
      END
c
      SUBROUTINE DMFFTG(FG,FM,NLEV,NADJ)
      DOUBLE PRECISION FG
      DOUBLE PRECISION EPSI
      DOUBLE PRECISION ROOTRA
      DOUBLE PRECISION ROOTIA
      DOUBLE PRECISION WSTPRA
      DOUBLE PRECISION WSTPIA
      DOUBLE PRECISION ZSTPRA
      DOUBLE PRECISION ZSTPIA
      DOUBLE PRECISION BDATA
c djs include 'res.h'
c rhombical truncation parameter
      INTEGER IRES
c number of longitudes
      INTEGER IX
c ix>=3*ires for rhombical truncation

c number of latitudes
      INTEGER IY
c iy>=(5*ires+1)/2 for rhombical truncation

      PARAMETER (IRES=42)
      PARAMETER (IX=128)
      PARAMETER (IY=108)

      PARAMETER (JXX=IRES+2,JX=IRES+1,MX=IRES+1)
      PARAMETER (JXXMX=JXX*MX,JXMX=JX*MX,MX2=MX*2)
      PARAMETER (IX2=IX+2,IX2H=IX2/2)
c
      DIMENSION FM(MX,1),FG(IX,7),TRAN(IX2H,7),DATA(IX2,7)
      COMMON /FFTLOC/IHM1(30),LEV
      EQUIVALENCE (TRAN(1,1),DATA(1,1))
      DOUBLE COMPLEX WORK(6),TRAN
      DOUBLE PRECISION DATA
      DOUBLE COMPLEX FM
      COMMON /SPECT/IR,IRP1,IRP2,IRMAX,IRMAX1,IRMAX2,I2IR,I4IR,ND2P1
      COMMON /LOCLOC/EPSI(JXXMX),ILAT,ILATH,ILONG,ILONGL
      COMMON /BRENN/NCURR,IFACT(32),NFACT,ISYM,IFSYM(32),NFSYM,ICENT,
     +       IFCNT(10),NFCNT
      COMMON /BREN2/ROOTRA(6,2),ROOTIA(6,2),WSTPRA(6,2),WSTPIA(6,2),
     +       ZSTPRA(2),ZSTPIA(2),IORD(IX2)
      DIMENSION BDATA(IX2)
c
      NWORK = 6
      N = ILONG
      LEV = NLEV
      NP2 = N + 2
      IF (NADJ.EQ.1) N = ILONGL
      ISIGN = 1
      IFORM = -1
      DO 40 IH = 1,LEV
          DO MP = 1,IRP1
              TRAN(MP,IH) = FM(MP,IH)
          END DO
          DO MP = IRP2,ND2P1
              TRAN(MP,IH) = (0.0D0,0.0D0)
          END DO
   40 CONTINUE
c
      NREM = 1
      CALL DFIXRL(DATA,N,NREM,ISIGN,IFORM)
c
      NPREV = 1
      DO 60 IH = 1,LEV
          DO J = 1,NP2
              BDATA(J) = DATA(IORD(J),IH)
          END DO
          DO J = 1,NP2
              DATA(J,IH) = BDATA(J)
          END DO
   60 CONTINUE
c
      CALL DCOOL(DATA,NPREV,NCURR,NREM,ISIGN,IFACT)
c
      DO 100 IH = 1,NLEV
          DO J = 1,N
              FG(J,IH) = DATA(J,IH)
          END DO
  100 CONTINUE
c
      RETURN
      END
c
      SUBROUTINE DINITAL
      DOUBLE PRECISION EPSI
C djs include 'res.h'
c rhombical truncation parameter
      INTEGER IRES
c number of longitudes
      INTEGER IX
c ix>=3*ires for rhombical truncation

c number of latitudes
      INTEGER IY
c iy>=(5*ires+1)/2 for rhombical truncation

      PARAMETER (IRES=42)
      PARAMETER (IX=128)
      PARAMETER (IY=108)

      PARAMETER (JXX=IRES+2,JX=IRES+1,MX=IRES+1)
      PARAMETER (JXXMX=JXX*MX,JXMX=JX*MX,MX2=MX*2)
c
      COMMON /SPECT/IR,IRP1,IRP2,IRMAX,IRMAX1,IRMAX2,I2IR,I4IR,ND2P1
      COMMON /LOCLOC/EPSI(JXX,MX),ILAT,ILATH,ILONG,ILONGL
      COMMON /LEVPOS/IHEM,IH,ILEV
      COMMON /INDEX/KMJX(MX),KMJXX(MX)
c
      ILAT = IY
      ILATH = ILAT/2
      ILONG = IX
      ILONGL = ILONG
c
      IR = IRES
      IRP2 = IR + 2
      IRP1 = IR + 1
      IRMAX = IR
      ND2P1 = ILONG/2 + 1
      IRMAX1 = IRMAX + 1
      IRMAX2 = IRMAX + 2
      I2IR = 2*IR
      I4IR = 2*I2IR
c
      IHEM = 1
      IH = 1
      ILEV = 1
c
c     now set up indexing arrays to improve efficiency
c
      DO 7 M = 1,MX
          KMJX(M) = (M-1)*JX
          KMJXX(M) = (M-1)*JXX
    7 CONTINUE
c
      RETURN
      END
c
      SUBROUTINE DASS
      DOUBLE PRECISION ALP
      DOUBLE PRECISION W
      DOUBLE PRECISION WOCS
      DOUBLE PRECISION COA
      DOUBLE PRECISION SIA
      DOUBLE PRECISION DELTA
c djs include 'res.h'
c rhombical truncation parameter
      INTEGER IRES
c number of longitudes
      INTEGER IX
c ix>=3*ires for rhombical truncation

c number of latitudes
      INTEGER IY
c iy>=(5*ires+1)/2 for rhombical truncation

      PARAMETER (IRES=42)
      PARAMETER (IX=128)
      PARAMETER (IY=108)

      PARAMETER (JXX=IRES+2,JX=IRES+1,MX=IRES+1)
      PARAMETER (JXXMX=JXX*MX,JXMX=JX*MX,MX2=MX*2)
c
      COMMON /SPECT/IR,IRP1,IRP2,IRMAX,IRMAX1,IRMAX2,I2IR,I4IR,ND2P1
      COMMON /INDEX/KMJX(MX),KMJXX(MX)
      COMMON /LEGPOL/ALP(JXXMX),W(IY),WOCS(IY),COA(IY),SIA(IY),DELTA(IY)
c
      LPFIN = IRP1
      IF (MOD(IR,2).EQ.0) LPFIN = JXX

      DO 50 MP = 1,IRP1
          DO 50 LP = 2,LPFIN,2
              ILM = KMJXX(MP) + LP
              ALP(ILM) = -ALP(ILM)
   50 CONTINUE

      RETURN
      END
c
      SUBROUTINE DEPSCAL(EPSI,IR)
      DOUBLE PRECISION EPSI
      DOUBLE PRECISION T
      DOUBLE PRECISION B
c
c     *calculates epsi(lm)=sqrt(l**2-m**2)/(4*l**2-1)
c                  l=0,irp1,   m=0,ir
c               epsi must have size  (irp2,irp1)
c
      DIMENSION EPSI(1)

      IRP1 = IR + 1
      IPM = 1 - IRP1
c
      DO 30 MP = 1,IRP1
          M = MP - 1
          IPM = IPM + IRP1
          INIT = M
          IF (M.EQ.0) INIT = 1
          MPIRP1 = M + IRP1
          DO 30 L = INIT,MPIRP1
              IL = IPM + L
              T = (L+M)* (L-M)
              B = 4*L*L - 1
              EPSI(IL) = SQRT(T/B)
   30 CONTINUE
      EPSI(1) = 0.0D0
c
      RETURN
      END
c
      SUBROUTINE DSYMRV(DATA,NPREV,N,NREM,IFACT,NFACT)
      DOUBLE PRECISION DATA
      DOUBLE PRECISION TEMPR
      DOUBLE PRECISION TEMPI
c     shuffle the data array by reversing the digits of one index.
c     dimension data(nprev,n,nrem)
c     replace data(i1,i2,i3) by data(i1,i2rev,i3) for all i1 from 1 to
c     nprev, i2 from 1 to n and i3 from 1 to nrem.  i2rev-1 is the
c     integer whose digit representation in the multi-radix notation
c     of factors ifact(if) is the reverse of the representation of i2-1.
c     for example, if all ifact(if) = 2, i2-1 = 11001, i2rev-1 = 10011.
c     the factors must be symmetrically arranged, i.e., ifact(if) =
c     ifact(nfact+1-if).
      DIMENSION DATA(1),IFACT(1)
c
      IF (NFACT.LE.1) RETURN
c
      IP0 = 2
      IP1 = IP0*NPREV
      IP4 = IP1*N
      IP5 = IP4*NREM
      I4REV = 1
      DO 70 I4 = 1,IP4,IP1
          IF (I4-I4REV) 20,40,40
   20     I1MAX = I4 + IP1 - IP0
          DO 30 I1 = I4,I1MAX,IP0
              DO 30 I5 = I1,IP5,IP4
                  I5REV = I4REV + I5 - I4
                  TEMPR = DATA(I5)
                  TEMPI = DATA(I5+1)
                  DATA(I5) = DATA(I5REV)
                  DATA(I5+1) = DATA(I5REV+1)
                  DATA(I5REV) = TEMPR
   30     DATA(I5REV+1) = TEMPI
   40     IP3 = IP4
          DO 60 IF = 1,NFACT
              IP2 = IP3/IFACT(IF)
              I4REV = I4REV + IP2
              IF (I4REV-IP3) 70,70,50
   50         I4REV = I4REV - IP3
   60     IP3 = IP2
   70 CONTINUE
c
      RETURN
      END
c
      SUBROUTINE DASMRV(DATA,NPREV,N,NREM,IFACT,NFACT,WORK)
      DOUBLE PRECISION DATA
      DOUBLE PRECISION WORK
c     shuffle the data array by reversing the digits of one index.
c     the operation is the same as in symrv, except that the factors
c     need not be symmetrically arranged, i.e., generally ifact(if) not=
c     ifact(nfact+1-if).  consequently, a work array of length n is
c     needed.
      DIMENSION DATA(1),WORK(1),IFACT(1)
c
      IF (NFACT-1) 60,60,10
   10 IP0 = 2
      IP1 = IP0*NPREV
      IP4 = IP1*N
      IP5 = IP4*NREM
      DO 50 I1 = 1,IP1,IP0
          DO 50 I5 = I1,IP5,IP4
              IWORK = 1
              I4REV = I5
              I4MAX = I5 + IP4 - IP1
              DO 40 I4 = I5,I4MAX,IP1
                  WORK(IWORK) = DATA(I4REV)
                  WORK(IWORK+1) = DATA(I4REV+1)
                  IP3 = IP4
                  DO 30 IF = 1,NFACT
                      IP2 = IP3/IFACT(IF)
                      I4REV = I4REV + IP2
                      IF (I4REV-IP3-I5) 40,20,20
   20                 I4REV = I4REV - IP3
   30             IP3 = IP2
   40         IWORK = IWORK + IP0
              IWORK = 1
              DO 50 I4 = I5,I4MAX,IP1
                  DATA(I4) = WORK(IWORK)
                  DATA(I4+1) = WORK(IWORK+1)
                  IWORK = IWORK + IP0
   50 CONTINUE
c
   60 RETURN
      END
      SUBROUTINE DFACTR(N,IFACT,NFACT)
c     factor n into its prime factors, nfact in number.  for example,
c     for n = 1960, nfact = 6 and ifact(if) = 2, 2, 2, 5, 7 and 7.
      DIMENSION IFACT(1)
c
      IF = 0
      NPART = N
      DO 50 ID = 1,N,2
          IDIV = ID
          IF (ID-1) 10,10,20
   10     IDIV = 2
   20     IQUOT = NPART/IDIV
          IF (NPART-IDIV*IQUOT) 40,30,40
   30     IF = IF + 1
          IFACT(IF) = IDIV
          NPART = IQUOT
          GO TO 20
   40     IF (IQUOT-IDIV) 60,60,50
   50 CONTINUE
c
   60 IF (NPART-1) 80,80,70
   70 IF = IF + 1
      IFACT(IF) = NPART
   80 NFACT = IF
c
      RETURN
      END
c
      SUBROUTINE DSMFAC(IFACT,NFACT,ISYM,IFSYM,NFSYM,ICENT,IFCNT,NFCNT)
c     rearrange the prime factors of n into a square and a non-
c     square.  n = isym*icent*isym, where icent is square-free.
c     isym = ifsym(1)*...*ifsym(nfsym), each a prime factor.
c     icent = ifcnt(1)*...*ifcnt(nfcnt), each a prime factor.
c     for example, n = 1960 = 14*10*14.  then isym = 14, icent = 10,
c     nfsym = 2, nfcnt = 2, nfact = 6, ifsym(ifs) = 2, 7, ifcnt(ifc) =
c     2, 5 and ifact(if) = 2, 7, 2, 5, 7, 2.
      DIMENSION IFSYM(1),IFCNT(1),IFACT(1)
c
      ISYM = 1
      ICENT = 1
      IFS = 0
      IFC = 0
      IF = 1
   10 IF (IF-NFACT) 20,40,50
   20 IF (IFACT(IF)-IFACT(IF+1)) 40,30,40
   30 IFS = IFS + 1
      IFSYM(IFS) = IFACT(IF)
      ISYM = IFACT(IF)*ISYM
      IF = IF + 2
      GO TO 10
   40 IFC = IFC + 1
      IFCNT(IFC) = IFACT(IF)
      ICENT = IFACT(IF)*ICENT
      IF = IF + 1
      GO TO 10
   50 NFSYM = IFS
      NFCNT = IFC
      NFSM2 = 2*NFSYM
      NFACT = 2*NFSYM + NFCNT
      IF (NFCNT) 80,80,60
   60 NFSM2 = NFSM2 + 1
      IFSYM(NFSYM+1) = ICENT
      DO 70 IFC = 1,NFCNT
          IF = NFSYM + IFC
   70 IFACT(IF) = IFCNT(IFC)
   80 IF (NFSYM) 110,110,90
   90 DO 100 IFS = 1,NFSYM
          IFSCJ = NFSM2 + 1 - IFS
          IFSYM(IFSCJ) = IFSYM(IFS)
          IFACT(IFS) = IFSYM(IFS)
          IFCNJ = NFACT + 1 - IFS
  100 IFACT(IFCNJ) = IFSYM(IFS)
  110 NFSYM = NFSM2
c
      RETURN
      END

C NCLFORTSTART
      SUBROUTINE DLSPOLY(N,M,X,Y,WGT,COEF,IER)
      INTEGER N,M,IER
      DOUBLE PRECISION X(M),Y(M),WGT(M),COEF(N)
C NCLEND

C NCL:   coef = lspoly(x,y,wgt,n)

C AUTOMATIC ARRAYS AND LOCAL VARIABLES
      INTEGER IC(N)
      DOUBLE PRECISION WRK(N,N),WRK2(M)
      INTEGER I
C
C TEST INPUT PARAMETERS
C .   IER=1:  M LESS THAN N IN LSPOLY
C .   IER=2:  DEGREE OF POLYNOMIAL GREATER THAN 4 IN LSPOLY **WARNING**
C .   IER=3:  MATRIX SINGULAR IN LSPOLY
C
      IER = 0
      IF (M.LE.N) IER = 1
      IF (N.GT.5) IER = 2
      IF (IER.NE.0) THEN
          DO I = 1,N
              COEF(I) = 1D20
          END DO
          RETURN
      END IF
C
      CALL DLSPLY2(M,N,X,Y,COEF,WGT,WRK,WRK2,IC,IER)
C
      RETURN
      END
C----------------------------------------------------------------------
C ++++ ORIGINAL LSPOLY DOCUMENTATION ++++
C     SUBROUTINE DLSPOLY (N,M,X,Y,W,C,WRK,IER)
C DIMENSION OF           X(M),Y(M),W(M),C(N),WRK(N**2+N+M)
C ARGUMENTS
C
C LATEST REVISION        FEBRUARY 1985
C
C PURPOSE                GIVEN A SET OF DATA (X(I),Y(I)), I = 1,...,M,
C                        LSPOLY CALCULATES A SET OF COEFFICIENTS FOR A
C                        WEIGHTED LEAST SQUARES POLYNOMIAL FIT TO THE
C                        GIVEN DATA.  IT IS NECESSARY THAT M (THE NUMBER
C                        OF DATA POINTS) BE GREATER THAN OR EQUAL TO N
C                        (THE NUMBER OF COEFFICIENTS).
C
C USAGE                  CALL DLSPOLY (N,M,X,Y,W,C,WRK,IER)
C
C ARGUMENTS
C
C ON INPUT               N
C                          AN INTEGER VARIABLE SET EQUAL TO THE NUMBER
C                          OF COEFFICIENTS DESIRED (I.E., N-1 WILL BE
C                          THE DEGREE OF THE POLYNOMIAL).
C
C                        M
C                          AN INTEGER VARIABLE SET EQUAL TO THE NUMBER
C                          OF DATA POINTS.  M MUST BE GREATER THAN OR
C                          EQUAL TO N.
C
C                        X
C                          A REAL ARRAY WITH DIMENSION AT LEAST M.  ON
C                          INPUT, X CONTAINS THE ABSCISSA VALUES OF THE
C                          DATA POINTS.
C
C                        Y
C                          A REAL ARRAY WITH DIMENSION AT LEAST M.  ON
C                          INPUT, Y CONTAINS THE ORDINATE VALUES OF THE
C                          DATA POINTS.
C
C                        W
C                          A REAL ARRAY WITH DIMENSION AT LEAST M.  ON
C                          INPUT, W IS A VECTOR OF WEIGHTS FOR A
C                          WEIGHTED LEAST SQUARES MODEL.  IF NO
C                          WEIGHTING IS DESIRED, THE ELEMENTS OF W
C                          SHOULD BE SET TO 1 .
C
C                        WRK
C                          A REAL ARRAY WITH DIMENSION AT LEAST N*N+N+M.
C                          WRK IS USED INTERNALLY FOR WORKING STORAGE.
C
C ON OUTPUT              C
C                          A REAL ARRAY WITH DIMENSION AT LEAST N.  ON
C                          OUTPUT, C CONTAINS THE COEFFICIENTS FOR THE
C                          POLYNOMIAL.  C(1) WILL CONTAIN THE CONSTANT
C                          TERM.
C
C                        IER
C                          AN INTEGER ERROR FLAG
C                          = 1  IF M .LT. N.
C                          = 2  IF N .GT. 5 (NON-FATAL).
C                          = 3  IF THE LINEAR SYSTEM IS SINGULAR.
C                          = 0  OTHERWISE.
C
C I/O                    ALL MESSAGES ARE PRINTED USING ROUTINE ULIBER.
C
C                        FOR IER = 1, THE FOLLOWING MESSAGE IS PRINTED.
C                            M LESS THAN N IN LSPOLY
C
C                        FOR IER = 2, THE FOLLOWING MESSAGE IS PRINTED.
C                            **WARNING** DEGREE OF POLYNOMIAL GREATER
C                                        THAN 4 IN LSPOLY
C
C                        FOR IER = 3, THE FOLLOWING MESSAGE IS PRINTED.
C                            *MATRIX SINGULAR IN LSPOLY*
C
C HISTORY                LSPOLY WAS WRITTEN IN THE EARLY 1970'S
C                        BY MEMBERS OF NCAR'S SCIENTIFIC COMPUTING
C                        DIVISION.  LSPOLY REPLACES FORMER ULIB
C                        ROUTINE LSTSQR.
C
C PORTABILITY            FORTRAN 66.
C
C ALGORITHM              LSPOLY FORMS THE NORMAL EQUATIONS AND SOLVES
C                        THE RESULTING SQUARE LINEAR SYSTEM USING
C                        GAUSSIAN ELIMINATION WITH FULL PIVOTING.
C
C ACCURACY               FOR LOWER ORDER POLYNOMIALS (N .LE. 5), LSPOLY
C                        CAN BE EXPECTED TO GIVE SATISFACTORY RESULTS.
C                        AS THE DEGREE OF THE FITTING POLYNOMIAL IS
C                        INCREASED, THE PROBLEM BECOMES NUMERICALLY
C                        UNSTABLE.  IF A HIGHER DEGREE POLYNOMIAL FIT
C                        IS DESIRED, THEN ROUTINE RGRSN1 SHOULD
C                        BE USED.
C
C **********************************************************************
c c c SUBROUTINE DLSPOLY (N,M,X,Y,W,C,WRK,IER)
c c c DIMENSION       X(M)       ,Y(M)       ,W(M)       ,C(N)       ,
c c c1                WRK(1)
c c c SAVE
c c c I1 = N*N+1
c c c I2 = N*N+M+1
c c c CALL DLSPLY2 (M,N,X,Y,C,W,WRK,WRK(I1),WRK(I2),IER)
c c c RETURN
c c   END
C **************************************************************
C the following was modified to provide explicit array sizes
C **************************************************************
      SUBROUTINE DLSPLY2(M,N,X,Y,C,W,WRK,WRK2,IC,IER)
C
      IMPLICIT NONE
      INTEGER M,N,IC(N),IER
      DOUBLE PRECISION X(M),Y(M),W(M),WRK(N,N),WRK2(M)
      DOUBLE PRECISION C(N)
C
      DOUBLE PRECISION C1,HOLD,A,AMXA,AMXFS
      INTEGER I,J,NM1,NP1,NMI,K,KP1,ICT,ICNMI,IRT

C
C FORM NORMAL EQUATIONS
C
      DO I = 1,M
          WRK2(I) = W(I)
      END DO

      DO J = 1,N
          WRK(1,J) = 0.D0
          C(J) = 0.D0
          DO I = 1,M
              WRK(1,J) = WRK(1,J) + WRK2(I)
              C(J) = C(J) + WRK2(I)*Y(I)
              WRK2(I) = WRK2(I)*X(I)
          END DO
      END DO

      IF (N.NE.1) THEN
          DO J = 2,N
              WRK(J,N) = 0.D0
              DO I = 1,M
                  WRK(J,N) = WRK(J,N) + WRK2(I)
                  WRK2(I) = WRK2(I)*X(I)
              END DO
          END DO
          DO I = 2,N
              DO J = 2,N
                  WRK(I,J-1) = WRK(I-1,J)
              END DO
          END DO
      END IF
      NM1 = N - 1

      IF (N.EQ.1) GO TO 240
C
C DECOMPOSE MATRIX USING GAUSSIAN ELIMINATION WITH FULL PIVOTING
C
      NP1 = N + 1
      DO K = 1,NM1
          KP1 = K + 1
          AMXA = 0.D0
          DO J = K,N
              DO I = K,N
                  A = ABS(WRK(I,J))
                  IF ((AMXA-A).LT.0.D0) THEN
                      AMXA = A
                      IRT = I
                      ICT = J
                  END IF
              END DO
          END DO
          IC(K) = ICT
          IF ((IRT-K).NE.0) THEN
              DO J = 1,N
                  HOLD = WRK(IRT,J)
                  WRK(IRT,J) = WRK(K,J)
                  WRK(K,J) = HOLD
              END DO
              HOLD = C(IRT)
              C(IRT) = C(K)
              C(K) = HOLD
          END IF
          IF ((ICT-K).NE.0) THEN
              DO I = 1,N
                  HOLD = WRK(I,ICT)
                  WRK(I,ICT) = WRK(I,K)
                  WRK(I,K) = HOLD
              END DO
          END IF
          IF (K.EQ.1) AMXFS = ABS(AMXA)
          IF ((ABS(AMXA/DBLE(K))+AMXFS).EQ.AMXFS) GO TO 290
          C1 = 1.D0/AMXA
          DO J = KP1,N
              WRK(K,J) = WRK(K,J)*C1
          END DO
          C(K) = C(K)*C1
          DO I = KP1,N
              DO J = KP1,N
                  WRK(I,J) = WRK(I,J) - WRK(I,K)*WRK(K,J)
              END DO
              C(I) = C(I) - WRK(I,K)*C(K)
          END DO
      END DO
C
C SOLVE FOR COEFFICIENTS USING BACK SUBSTITUTION
C
      IF ((ABS(WRK(N,N)/DBLE(N))+AMXFS).EQ.AMXFS) GO TO 290
  240 C(N) = C(N)/WRK(N,N)
      IF (N.EQ.1) RETURN
      DO I = 1,NM1
          NMI = N - I
          DO K = NMI,NM1
              C(NMI) = C(NMI) - WRK(NMI,K+1)*C(K+1)
          END DO
      END DO
C
C PERMUTE SOLUTION VECTOR
C
      DO I = 1,NM1
          NMI = N - I
          ICNMI = IC(NMI)
          IF (ICNMI-NMI.NE.0) THEN
              HOLD = C(ICNMI)
              C(ICNMI) = C(NMI)
              C(NMI) = HOLD
          END IF
      END DO
      RETURN

  290 IER = 3
c c c CALL ULIBER (33,28H *MATRIX SINGULAR IN LSPOLY*,28)
      RETURN
      END

C
C	$Id: gopdec.f,v 1.4 2008-07-27 00:20:58 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GOPDEC(OPRNS,OPNLEN,COUNT,IOS,STATUS)
C
C  This subroutine extracts the requested number of operands from the
C  input segment and decodes them.
C
C  INPUT
C    OPNLEN --  Length of each operand in bits.
C    COUNT  --  Number of operands to fetch.
C
C  Note that this routine will decode according to the operand length
C  flag.  Errors will result if this value is greater than the machine
C  word length.
C
      include 'trbufr.h'
C
      INTEGER OPNLEN, COUNT, OPRNS(*), IOS, STATUS
      INTEGER ZERO, BCOUNT, TCOUNT, SCOUNT
C
C  Define the 8 bit byte size.
C
      DATA ZERO/0/
C
      STATUS = 0
C
C  Initialize the operand pointers.
C
      BCOUNT = 1
      TCOUNT = COUNT
 10   CONTINUE
C
C  Calculate the amount of operands in the buffer.
C
      IF ((OPNLEN * TCOUNT + MOPRST) .GT. MRECLN) THEN
C
C  Not enough room for the operand list, so set up for a partial move.
C
        SCOUNT = ((MRECLN-MOPRST)) / OPNLEN
        TCOUNT = TCOUNT - SCOUNT
      ELSE
C
C  Room for all the remaining operands.
C
        SCOUNT = TCOUNT
        TCOUNT = ZERO
      END IF
C
C  Get the operands.
C
      IF (SCOUNT .NE. ZERO) THEN
        CALL GBYTES(MBUFER,OPRNS(BCOUNT),MOPRST,OPNLEN,ZERO,SCOUNT)
      END IF
C
C  Increment the operand pointer.
C
      MOPRST = MOPRST + (OPNLEN * SCOUNT)
C
C  Test if we have all the operands.
C
      IF (TCOUNT .NE. ZERO) THEN
C
C  Get another record.
C
        CALL GSEGRD(IOS,STATUS)
        IF (STATUS .NE. 0) RETURN
C
        MOPRST = METBIT
        BCOUNT = BCOUNT + SCOUNT
        GO TO 10
      END IF
C
C  Move the next instruction pointer past the current operands fetched.
C
      METBIT = MOPRST
C
      RETURN
      END

C
C $Id: idblda.f,v 1.5 2008-07-27 00:17:30 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE IDBLDA
C
C Calling this do-nothing subroutine forces "ld" to load the following
C block data routine (but only if they are in the same ".f" file).
C
        RETURN
C
      END
CNOSPLIT
      BLOCKDATA IDBLDAX
C
C This "routine" provides default values for the internal parameters of
C BIVAR.
C
C The common block IDCOMN holds BIVAR variables associated with changes
C made in October, 1995, including a couple of internal parameters.
C
        COMMON /IDCOMN/ INTY,ITTY,ALSP,BLSP,CLSP,XAVG,YAVG
        SAVE   /IDCOMN/
C
C INTY is the flag that says what type of interpolation to use (0 for
C quintic interpolation, 1 for linear interpolation).
C
        DATA INTY / 0 /
C
C ITTY is the flag that says what type of triangulation to use (0 for
C the original, 1 for the new).
C
        DATA ITTY / 0 /
C
C ALSP, BLSP, CLSP, XAVG, and YAVG are not actually internal parameters
C of BIVAR.  They are computed and used when linear interpolation is
C selected.  The first three are coefficients in the equation of the
C plane that best fits the data and the final two are mean X and Y
C values computed from the data.
C
        DATA ALSP,BLSP,CLSP,XAVG,YAVG / 5*0. /
C
      END

c subroutine lfim (init,theta,l,n,nm,pb,id,wlfim)
c
c dimension of           theta(l),  pb(id,nm+1),  wlfim(4*l*(nm+1))
c arguments
c
c purpose                given n and l, routine lfim calculates
c                        the normalized associated legendre functions
c                        pbar(n,m,theta) for m=0,...,n and theta(i)
c                        for i=1,...,l where
c
c                        pbar(m,n,theta) = sqrt((2*n+1)*factorial(n-m)
c                        /(2*factorial(n+m)))*sin(theta)**m/(2**n*
c                        factorial(n)) times the (n+m)th derivative of
c                        (x**2-1)**n with respect to x=cos(theta)
c
c usage                  call lfim (init,theta,l,n,nm,pb,id,wlfim)
c
c arguments
c on input               init
c                        = 0
c                            initialization only - using parameters
c                            l, nm and array theta, subroutine lfim
c                            initializes array wlfim for subsequent
c                            use in the computation of the associated
c                            legendre functions pb. initialization
c                            does not have to be repeated unless
c                            l, nm, or array theta are changed.
c                        = 1
c                            subroutine lfim uses the array wlfim that
c                            was computed with init = 0 to compute pb.
c
c                        theta
c                          an array that contains the colatitudes
c                          at which the associated legendre functions
c                          will be computed. the colatitudes must be
c                          specified in radians.
c
c                        l
c                          the length of the theta array. lfim is
c                          vectorized with vector length l.
c
c                        n
c                          nonnegative integer, less than nm, specifying
c                          degree of pbar(n,m,theta). subroutine lfim
c                          must be called starting with n=0. n must be
c                          incremented by one in subsequent calls and
c                          must not exceed nm.
c
c                        nm
c                          the maximum value of n and m
c
c                        id
c                          the first dimension of the two dimensional
c                          array pb as it appears in the program that
c                          calls lfim. (see output parameter pb)
c
c                        wlfim
c                          an array with length 4*l*(nm+1) which
c                          must be initialized by calling lfim
c                          with init=0 (see parameter init)  it
c                          must not be altered between calls to
c                          lfim.
c
c
c on output              pb
c                          a two dimensional array with first
c                          dimension id in the program that calls
c                          lfim. the second dimension of pb must
c                          be at least nm+1. starting with n=0
c                          lfim is called repeatedly with n being
c                          increased by one between calls. on each
c                          call, subroutine lfim computes
c                          = pbar(m,n,theta(i)) for m=0,...,n and
c                          i=1,...l.
c
c                        wlfim
c                          array containing values which must not
c                          be altered unless l, nm or the array theta
c                          are changed in which case lfim must be
c                          called with init=0 to reinitialize the
c                          wlfim array.
c
c special conditions     n must be increased by one between calls
c                        of lfim in which n is not zero.
c
c precision              single
c
c
c algorithm              routine lfim calculates pbar(n,m,theta) using
c                        a four term recurrence relation. (unpublished
c                        notes by paul n. swarztrauber)
c
      SUBROUTINE DLFIM(INIT,THETA,L,N,NM,PB,ID,WLFIM)
      DOUBLE PRECISION THETA
      DOUBLE PRECISION PB
      DOUBLE PRECISION WLFIM
      DIMENSION PB(1),WLFIM(1)
c
c     total length of wlfim is 4*l*(nm+1)
c
      LNX = L* (NM+1)
      IW1 = LNX + 1
      IW2 = IW1 + LNX
      IW3 = IW2 + LNX
      CALL DLFIM1(INIT,THETA,L,N,NM,ID,PB,WLFIM,WLFIM(IW1),WLFIM(IW2),
     +           WLFIM(IW3),WLFIM(IW2))
      RETURN
      END
      SUBROUTINE DLFIM1(INIT,THETA,L,N,NM,ID,P3,PHZ,PH1,P1,P2,CP)
      DOUBLE PRECISION THETA
      DOUBLE PRECISION P3
      DOUBLE PRECISION PHZ
      DOUBLE PRECISION PH1
      DOUBLE PRECISION P1
      DOUBLE PRECISION P2
      DOUBLE PRECISION CP
      DOUBLE PRECISION SSQRT2
      DOUBLE PRECISION SQ5S6
      DOUBLE PRECISION SQ1S6
      DOUBLE PRECISION FN
      DOUBLE PRECISION TN
      DOUBLE PRECISION CN
      DOUBLE PRECISION FM
      DOUBLE PRECISION FNPM
      DOUBLE PRECISION FNMM
      DOUBLE PRECISION TEMP
      DOUBLE PRECISION CC
      DOUBLE PRECISION DD
      DOUBLE PRECISION EE
      DIMENSION P1(L,1),P2(L,1),P3(ID,1),PHZ(L,1),PH1(L,1),CP(1),
     +          THETA(1)

      NMP1 = NM + 1
      IF (INIT.NE.0) GO TO 5
      SSQRT2 = 1.D0/SQRT(2.D0)
      DO 10 I = 1,L
          PHZ(I,1) = SSQRT2
   10 CONTINUE
      DO 15 NP1 = 2,NMP1
          NH = NP1 - 1
          CALL DALFK(NH,0,CP)
          DO 16 I = 1,L
              CALL DLFPT(NH,0,THETA(I),CP,PHZ(I,NP1))
   16     CONTINUE
          CALL DALFK(NH,1,CP)
          DO 17 I = 1,L
              CALL DLFPT(NH,1,THETA(I),CP,PH1(I,NP1))
   17     CONTINUE
   15 CONTINUE
      RETURN
    5 IF (N.GT.2) GO TO 60
      IF (N-1) 25,30,35
   25 DO 45 I = 1,L
          P3(I,1) = PHZ(I,1)
   45 CONTINUE
      RETURN
   30 DO 50 I = 1,L
          P3(I,1) = PHZ(I,2)
          P3(I,2) = PH1(I,2)
   50 CONTINUE
      RETURN
   35 SQ5S6 = SQRT(5.D0/6.D0)
      SQ1S6 = SQRT(1.D0/6.D0)
      DO 55 I = 1,L
          P3(I,1) = PHZ(I,3)
          P3(I,2) = PH1(I,3)
          P3(I,3) = SQ5S6*PHZ(I,1) - SQ1S6*P3(I,1)
          P1(I,1) = PHZ(I,2)
          P1(I,2) = PH1(I,2)
          P2(I,1) = PHZ(I,3)
          P2(I,2) = PH1(I,3)
          P2(I,3) = P3(I,3)
   55 CONTINUE
      RETURN
   60 NM1 = N - 1
      NP1 = N + 1
      FN = DBLE(N)
      TN = FN + FN
      CN = (TN+1.D0)/ (TN-3.D0)
      DO 65 I = 1,L
          P3(I,1) = PHZ(I,NP1)
          P3(I,2) = PH1(I,NP1)
   65 CONTINUE
      IF (NM1.LT.3) GO TO 71
      DO 70 MP1 = 3,NM1
          M = MP1 - 1
          FM = DBLE(M)
          FNPM = FN + FM
          FNMM = FN - FM
          TEMP = FNPM* (FNPM-1.D0)
          CC = SQRT(CN* (FNPM-3.D0)* (FNPM-2.D0)/TEMP)
          DD = SQRT(CN*FNMM* (FNMM-1.D0)/TEMP)
          EE = SQRT((FNMM+1.D0)* (FNMM+2.D0)/TEMP)
          DO 70 I = 1,L
              P3(I,MP1) = CC*P1(I,MP1-2) + DD*P1(I,MP1) - EE*P3(I,MP1-2)
   70 CONTINUE
   71 FNPM = FN + FN - 1.D0
      TEMP = FNPM* (FNPM-1.D0)
      CC = SQRT(CN* (FNPM-3.D0)* (FNPM-2.D0)/TEMP)
      EE = SQRT(6.D0/TEMP)
      DO 75 I = 1,L
          P3(I,N) = CC*P1(I,N-2) - EE*P3(I,N-2)
   75 CONTINUE
      FNPM = FN + FN
      TEMP = FNPM* (FNPM-1.D0)
      CC = SQRT(CN* (FNPM-3.D0)* (FNPM-2.D0)/TEMP)
      EE = SQRT(2.D0/TEMP)
      DO 80 I = 1,L
          P3(I,N+1) = CC*P1(I,N-1) - EE*P3(I,N-1)
   80 CONTINUE
      DO 90 MP1 = 1,NP1
          DO 90 I = 1,L
              P1(I,MP1) = P2(I,MP1)
              P2(I,MP1) = P3(I,MP1)
   90 CONTINUE
      RETURN
      END

c ----------------------------------------------------------- 
C NCLFORTSTART
      SUBROUTINE DRCM2POINTS(NGRD,NYI,NXI,YI,XI,FI,NXYO,YO,XO,FO
     +                      ,XMSG,OPT,NCRIT,KVAL,IER)
      IMPLICIT NONE
      INTEGER NGRD,NXI,NYI,NXYO,OPT,NCRIT,KVAL,IER
      DOUBLE PRECISION XI(NXI,NYI),YI(NXI,NYI),FI(NXI,NYI,NGRD)
      DOUBLE PRECISION XO(NXYO),YO(NXYO),FO(NXYO,NGRD),XMSG
C NCLEND

C This is written  with GNU f77 acceptable extensions
c .   This could be improved considerably with f90

c nomenclature:
c .   nxi,nyi - lengths of xi,yi and dimensions of fi (must be >= 2)
c .   xi      - coordinates of fi (eg, lon [2D] )
c .   yi      - coordinates of fi (eg, lat [2D] )
c .   fi      - functional input values [2D]
c .   nxyo    - number of output points
c .   xo      - lon coordinates of fo (eg, lon [1D])
c .   yo      - lat coordinates of fo (eg, lat [1D])
c .   fo      - functional output values [interpolated]
c .   xmsg    - missing code
c .   opt     - 0/1 = inv distance, 2 = bilinear
c .   ier     - error code
c .             =0;   no error
c .             =1;   not enough points in input/output array
c .             =2/3; xi or yi are not monotonically increasing
c .             =4/5; xo or yo are not monotonically increasing
c
c                              local
      INTEGER NG,NX,NY,NXY,NEXACT,IX,IY,M,N,NW,NER,K
      DOUBLE PRECISION FW(2,2),W(2,2),SUMF,SUMW,CHKLAT(NYI),CHKLON(NXI)
      DOUBLE PRECISION DGCDIST, WX, WY
      DOUBLE PRECISION REARTH, DLAT, PI, RAD, DKM, DIST 
c                              error checking
      IER = 0
      IF (NXI.LE.1 .OR. NYI.LE.1 .OR. NXYO.LE.0) THEN
          IER = 1
          RETURN
      END IF
      IF (IER.NE.0) RETURN

      DO NY = 1,NYI
          CHKLAT(NY) = YI(1,NY)
c c c    print *,"chklat: ny=",ny,"  chklat=",chklat(ny)
      END DO
      CALL DMONOINC(CHKLAT,NYI,IER,NER)
      IF (IER.NE.0) RETURN

      DO NX = 1,NXI
          CHKLON(NX) = XI(NX,1)
c c c    print *,"chklon: nx=",nx,"  chklon=",chklon(nx)
      END DO
      CALL DMONOINC(CHKLAT,NYI,IER,NER)
      IF (IER.NE.0) RETURN

C ORIGINAL  (k = op, never implemented)
      IF (KVAL.LE.0) THEN
         K = 1
      ELSE
         K = KVAL
      END IF
      DO NG = 1,NGRD
        DO NXY = 1,NXYO
           FO(NXY,NG) = XMSG
        END DO
      END DO
c                              main loop [exact matches]
      NEXACT = 0
      DO NXY = 1,NXYO

          DO IY = 1,NYI
              DO IX = 1,NXI
                  IF (XO(NXY).EQ.XI(IX,IY) .AND.
     +                YO(NXY).EQ.YI(IX,IY)) THEN
                      DO NG = 1,NGRD
                         FO(NXY,NG) = FI(IX,IY,NG)
                         NEXACT     = NEXACT + 1
                      END DO
                      GO TO 10
                  END IF
              END DO
          END DO

   10     CONTINUE
      END DO

c c c print *, "nexact=",nexact
c                              main loop [interpolation]
      DO NXY = 1,NXYO

              DO IY = 1,NYI - K
                DO IX = 1,NXI - K
                   IF (XO(NXY).GE.XI(IX,IY) .AND.
     +                 XO(NXY).LE.XI(IX+K,IY) .AND.
     +                 YO(NXY).GE.YI(IX,IY) .AND.
     +                 YO(NXY).LE.YI(IX,IY+K)) THEN

                   IF (ABS(OPT).EQ.2) THEN
                       WX = (XO(NXY)-XI(IX,IY))/
     +                      (XI(IX+K,IY)-XI(IX,IY))
                       WY = (YO(NXY)-YI(IX,IY))/
     +                      (YI(IX,IY+K)-YI(IX,IY))
                       W(1,1) = (1.D0-WX)*(1.D0-WY)
                       W(2,1) = WX*(1.D0-WY)
                       W(1,2) = (1.D0-WX)*WY
                       W(2,2) = WX*WY
                   ELSE
                       W(1,1) = (1.D0/DGCDIST(YO(NXY),XO(NXY),
     +                           YI(IX,IY),XI(IX,IY),2))**2
                       W(2,1) = (1.D0/DGCDIST(YO(NXY),XO(NXY),
     +                           YI(IX+K,IY),XI(IX+K,IY),2))**2
                       W(1,2) = (1.D0/DGCDIST(YO(NXY),XO(NXY),
     +                           YI(IX,IY+K),XI(IX,IY+K),2))**2
                       W(2,2) = (1.D0/DGCDIST(YO(NXY),XO(NXY),
     +                           YI(IX+K,IY+K),XI(IX+K,IY+K),2))**2
                   END IF

                   DO NG = 1,NGRD
                      IF (FO(NXY,NG).EQ.XMSG) THEN
                          
                          FW(1,1) = FI(IX,IY,NG)
                          FW(2,1) = FI(IX+K,IY,NG)
                          FW(1,2) = FI(IX,IY+K,NG)
                          FW(2,2) = FI(IX+K,IY+K,NG)

                          NW = 0
                          SUMF = 0.0D0
                          SUMW = 0.0D0
                          DO N = 1,2
                              DO M = 1,2
                                  IF (FW(M,N).NE.XMSG) THEN
                                      SUMF = SUMF + FW(M,N)*W(M,N)
                                      SUMW = SUMW + W(M,N)
                                      NW = NW + 1
                                  END IF
                              END DO
                          END DO
c                                             nw >=3 arbitrary
                          IF (NW.GE.NCRIT .AND. SUMW.GT.0.D0) THEN
                              FO(NXY,NG) = SUMF/SUMW
                          END IF
                      END IF
                    END DO
                    GO TO 20
                  END IF
                END DO
              END DO

   20         CONTINUE
      END DO

C Are all the output points filled in? Check the 1st grid
C If so, return

      DO NG = 1,NGRD   
        DO NXY = 1,NXYO
           IF (FO(NXY,NG).EQ.XMSG) GO TO 30
        END DO
      END DO
      RETURN

C only enter if some points are not interpolated to
C DLAT is arbitrary.  It ould be made an option.
C DLAT is expressed in terms of degrees of latitude.
C DKM  is DLAT in KILOMETERS

   30 REARTH= 6371D0
      DLAT  = 5  
      PI    = 4D0*ATAN(1.0D0)
      RAD   = PI/180D0
      DKM   = DLAT*(2D0*PI*REARTH)/360D0

C LOOP OVER EACH GRID ... INEFFICIENT 
C THE RUB IS THAT SOME LEVELS COULD HAVE XMSG.

      DO NG = 1,NGRD   

        DO NXY = 1,NXYO
           IF(FO(NXY,NG).EQ.XMSG) THEN

C FIND ALL GRID POINTS WITHIN 'DKM' KILOMETERS OF PT 

              NW   = 0
              SUMF = 0.0D0
              SUMW = 0.0D0

              DO IY = 1,NYI
                DO IX = 1,NXI
                   IF ((YI(IX,IY).GE.YO(NXY)-DLAT)  .AND.
     +                 (YI(IX,IY).LE.YO(NXY)+DLAT)) THEN      
                        DIST = DGCDIST(YO(NXY),XO(NXY) 
     +                                ,YI(IX,IY),XI(IX,IY),2)
                        IF (DIST.LE.DKM .AND. DIST.GT.0.0D0 .AND.
     +                      FI(IX,IY,NG).NE.XMSG) THEN
                            DIST = 1.0D0/DIST**2
                            SUMF = SUMF + FI(IX,IY,NG)*DIST
                            SUMW = SUMW + DIST
                            NW   = NW + 1
                        END IF
                   END IF
                END DO
              END DO

C C C         IF (NW.GE.NCRIT .AND. SUMW.GT. 0.0D0) THEN
              IF (SUMW.GT.0.0D0) THEN
                  FO(NXY,NG) = SUMF/SUMW
              END IF
           END IF
        END DO
      END DO

      RETURN
      END

C
C $Id: ifixmm.f,v 1.5 2008-07-27 00:14:36 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      FUNCTION IFIXMM(RVAL)
C
C This function may be called in place of the FORTRAN function INT.
C If the argument is a special value, a zero is returned, and otherwise
C INT(RVAL) is returned.
C
C The following common block contains the AUTOGRAPH control parameters,
C all of which are real.  If it is changed, all of AUTOGRAPH (especially
C the routine AGSCAN) must be examined for possible side effects.
C
      COMMON /AGCONP/ QFRA,QSET,QROW,QIXY,QWND,QBAC , SVAL(2) ,
     +                XLGF,XRGF,YBGF,YTGF , XLGD,XRGD,YBGD,YTGD , SOGD ,
     +                XMIN,XMAX,QLUX,QOVX,QCEX,XLOW,XHGH ,
     +                YMIN,YMAX,QLUY,QOVY,QCEY,YLOW,YHGH ,
     +                QDAX(4),QSPA(4),PING(4),PINU(4),FUNS(4),QBTD(4),
     +                BASD(4),QMJD(4),QJDP(4),WMJL(4),WMJR(4),QMND(4),
     +                QNDP(4),WMNL(4),WMNR(4),QLTD(4),QLED(4),QLFD(4),
     +                QLOF(4),QLOS(4),DNLA(4),WCLM(4),WCLE(4) ,
     +                QODP,QCDP,WOCD,WODQ,QDSH(26) ,
     +                     QDLB,QBIM,FLLB(10,8),QBAN ,
     +                QLLN,TCLN,QNIM,FLLN(6,16),QNAN ,
     +                XLGW,XRGW,YBGW,YTGW , XLUW,XRUW,YBUW,YTUW ,
     +                XLCW,XRCW,YBCW,YTCW , WCWP,HCWP,SCWP ,
     +                XBGA(4),YBGA(4),UBGA(4),XNDA(4),YNDA(4),UNDA(4),
     +                QBTP(4),BASE(4),QMNT(4),QLTP(4),QLEX(4),QLFL(4),
     +                QCIM(4),QCIE(4),RFNL(4),WNLL(4),WNLR(4),WNLB(4),
     +                WNLE(4),QLUA(4) ,
     +                RBOX(6),DBOX(6,4),SBOX(6,4)
      SAVE /AGCONP/
C
      IF (ABS(RVAL).NE.SVAL(1).AND.ABS(RVAL).NE.SVAL(2)) THEN
        IFIXMM=INT(RVAL)
      ELSE
        IFIXMM=0
      END IF
C
      RETURN
C
      END

      SUBROUTINE CTGEXC( WANTQ, WANTZ, N, A, LDA, B, LDB, Q, LDQ, Z,
     $                   LDZ, IFST, ILST, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      LOGICAL            WANTQ, WANTZ
      INTEGER            IFST, ILST, INFO, LDA, LDB, LDQ, LDZ, N
*     ..
*     .. Array Arguments ..
      COMPLEX            A( LDA, * ), B( LDB, * ), Q( LDQ, * ),
     $                   Z( LDZ, * )
*     ..
*
*  Purpose
*  =======
*
*  CTGEXC reorders the generalized Schur decomposition of a complex
*  matrix pair (A,B), using an unitary equivalence transformation
*  (A, B) := Q * (A, B) * Z', so that the diagonal block of (A, B) with
*  row index IFST is moved to row ILST.
*
*  (A, B) must be in generalized Schur canonical form, that is, A and
*  B are both upper triangular.
*
*  Optionally, the matrices Q and Z of generalized Schur vectors are
*  updated.
*
*         Q(in) * A(in) * Z(in)' = Q(out) * A(out) * Z(out)'
*         Q(in) * B(in) * Z(in)' = Q(out) * B(out) * Z(out)'
*
*  Arguments
*  =========
*
*  WANTQ   (input) LOGICAL
*          .TRUE. : update the left transformation matrix Q;
*          .FALSE.: do not update Q.
*
*  WANTZ   (input) LOGICAL
*          .TRUE. : update the right transformation matrix Z;
*          .FALSE.: do not update Z.
*
*  N       (input) INTEGER
*          The order of the matrices A and B. N >= 0.
*
*  A       (input/output) COMPLEX array, dimension (LDA,N)
*          On entry, the upper triangular matrix A in the pair (A, B).
*          On exit, the updated matrix A.
*
*  LDA     (input)  INTEGER
*          The leading dimension of the array A. LDA >= max(1,N).
*
*  B       (input/output) COMPLEX array, dimension (LDB,N)
*          On entry, the upper triangular matrix B in the pair (A, B).
*          On exit, the updated matrix B.
*
*  LDB     (input)  INTEGER
*          The leading dimension of the array B. LDB >= max(1,N).
*
*  Q       (input/output) COMPLEX array, dimension (LDZ,N)
*          On entry, if WANTQ = .TRUE., the unitary matrix Q.
*          On exit, the updated matrix Q.
*          If WANTQ = .FALSE., Q is not referenced.
*
*  LDQ     (input) INTEGER
*          The leading dimension of the array Q. LDQ >= 1;
*          If WANTQ = .TRUE., LDQ >= N.
*
*  Z       (input/output) COMPLEX array, dimension (LDZ,N)
*          On entry, if WANTZ = .TRUE., the unitary matrix Z.
*          On exit, the updated matrix Z.
*          If WANTZ = .FALSE., Z is not referenced.
*
*  LDZ     (input) INTEGER
*          The leading dimension of the array Z. LDZ >= 1;
*          If WANTZ = .TRUE., LDZ >= N.
*
*  IFST    (input/output) INTEGER
*  ILST    (input/output) INTEGER
*          Specify the reordering of the diagonal blocks of (A, B).
*          The block with row index IFST is moved to row ILST, by a
*          sequence of swapping between adjacent blocks.
*
*  INFO    (output) INTEGER
*           =0:  Successful exit.
*           <0:  if INFO = -i, the i-th argument had an illegal value.
*           =1:  The transformed matrix pair (A, B) would be too far
*                from generalized Schur form; the problem is ill-
*                conditioned. (A, B) may have been partially reordered,
*                and ILST points to the first row of the current
*                position of the block being moved.
*
*
*  Further Details
*  ===============
*
*  Based on contributions by
*     Bo Kagstrom and Peter Poromaa, Department of Computing Science,
*     Umea University, S-901 87 Umea, Sweden.
*
*  [1] B. Kagstrom; A Direct Method for Reordering Eigenvalues in the
*      Generalized Real Schur Form of a Regular Matrix Pair (A, B), in
*      M.S. Moonen et al (eds), Linear Algebra for Large Scale and
*      Real-Time Applications, Kluwer Academic Publ. 1993, pp 195-218.
*
*  [2] B. Kagstrom and P. Poromaa; Computing Eigenspaces with Specified
*      Eigenvalues of a Regular Matrix Pair (A, B) and Condition
*      Estimation: Theory, Algorithms and Software, Report
*      UMINF - 94.04, Department of Computing Science, Umea University,
*      S-901 87 Umea, Sweden, 1994. Also as LAPACK Working Note 87.
*      To appear in Numerical Algorithms, 1996.
*
*  [3] B. Kagstrom and P. Poromaa, LAPACK-Style Algorithms and Software
*      for Solving the Generalized Sylvester Equation and Estimating the
*      Separation between Regular Matrix Pairs, Report UMINF - 93.23,
*      Department of Computing Science, Umea University, S-901 87 Umea,
*      Sweden, December 1993, Revised April 1994, Also as LAPACK working
*      Note 75. To appear in ACM Trans. on Math. Software, Vol 22, No 1,
*      1996.
*
*  =====================================================================
*
*     .. Local Scalars ..
      INTEGER            HERE
*     ..
*     .. External Subroutines ..
      EXTERNAL           CTGEX2, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX
*     ..
*     .. Executable Statements ..
*
*     Decode and test input arguments.
      INFO = 0
      IF( N.LT.0 ) THEN
         INFO = -3
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -5
      ELSE IF( LDB.LT.MAX( 1, N ) ) THEN
         INFO = -7
      ELSE IF( LDQ.LT.1 .OR. WANTQ .AND. ( LDQ.LT.MAX( 1, N ) ) ) THEN
         INFO = -9
      ELSE IF( LDZ.LT.1 .OR. WANTZ .AND. ( LDZ.LT.MAX( 1, N ) ) ) THEN
         INFO = -11
      ELSE IF( IFST.LT.1 .OR. IFST.GT.N ) THEN
         INFO = -12
      ELSE IF( ILST.LT.1 .OR. ILST.GT.N ) THEN
         INFO = -13
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'CTGEXC', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.LE.1 )
     $   RETURN
      IF( IFST.EQ.ILST )
     $   RETURN
*
      IF( IFST.LT.ILST ) THEN
*
         HERE = IFST
*
   10    CONTINUE
*
*        Swap with next one below
*
         CALL CTGEX2( WANTQ, WANTZ, N, A, LDA, B, LDB, Q, LDQ, Z, LDZ,
     $                HERE, INFO )
         IF( INFO.NE.0 ) THEN
            ILST = HERE
            RETURN
         END IF
         HERE = HERE + 1
         IF( HERE.LT.ILST )
     $      GO TO 10
         HERE = HERE - 1
      ELSE
         HERE = IFST - 1
*
   20    CONTINUE
*
*        Swap with next one above
*
         CALL CTGEX2( WANTQ, WANTZ, N, A, LDA, B, LDB, Q, LDQ, Z, LDZ,
     $                HERE, INFO )
         IF( INFO.NE.0 ) THEN
            ILST = HERE
            RETURN
         END IF
         HERE = HERE - 1
         IF( HERE.GE.ILST )
     $      GO TO 20
         HERE = HERE + 1
      END IF
      ILST = HERE
      RETURN
*
*     End of CTGEXC
*
      END

C
C	$Id: cfwrit.f,v 1.4 2008-07-27 12:23:41 haley Exp $
C                                                                      
C			     Copyright (C)  1997
C	     University Corporation for Atmospheric Research
C			     All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C

      SUBROUTINE CFWRIT(IUNIT,ITYP,IOS,STATUS)
C  
C  Write the binary fontcap file.
C
C  INPUT
C	UNIT - The fortran logical unit number to be written to.
C       ITYP - = 0  for stroked font
C              = 1  for filled font
C
C  OUTPUT
C	IOS    - The I/O status word, IOS has meaning only if STATUS indicates
C                an error condition (i.e. if STATUS.GT.0).
C	STATUS - Integer-valued status indicator, see subroutine SFPRCF
C                for details.
C
      include 'fnterr.h'
      include 'capfnt.h'
      include 'fntcom.h'
C
      INTEGER IUNIT, IOS, STATUS
C
C  Set error STATUS to ALLOK
C
      STATUS = ALLOK
C
C  Write out the font description.
C
      IF (ITYP .EQ. 0) THEN
        CALL BINWRI(IUNIT, WRLEN, CHSTRT, IOS, STATUS)
      ELSE IF (ITYP .EQ. 1) THEN
        CALL BINWRI(IUNIT, NWRDS, BUFFER, IOS, STATUS)
      ENDIF
C
      RETURN
      END

C
C       $Id: shrot.f,v 1.4 2008-07-27 03:10:13 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE SHROT (N,C,S, X,Y )
      INTEGER N
      REAL    C, S, X(N), Y(N)
C
C***********************************************************
C
C                                               ROBERT RENKA
C                                       UNIV. OF NORTH TEXAS
C                                             (817) 565-2767
C
C                                           ( C  S)
C  This routine applies the Givens rotation (     ) to the
C                                           (-S  C)
C                (X(1) ... X(N))
C  2 by N matrix (             ).
C                (Y(1) ... Y(N))
C
C  ON INPUT --
C
C    N   = Number of columns to be rotated.
C
C    C,S = Elements of the Givens rotation.  These may be
C          determined by subroutine SHGIVENS.
C
C    X,Y = Arrays of length .GE. N containing the vectors
C          to be rotated.
C
C  Parameters N, C, and S are not altered by this routine.
C
C  ON OUTPUT --
C
C    X,Y = rotated vectors.
C
C  MODULES REQUIRED BY SHROT -- NONE
C
C***********************************************************
C
      INTEGER I
      REAL    XI, YI
C
C  Local parameters --
C
C    I =     DO-LOOP INDEX
C    XI,YI = X(I), Y(I)
C
      IF (N.LE.0 .OR. (C.EQ.1. .AND. S.EQ.0.)) RETURN
      DO 1 I = 1,N
        XI = X(I)
        YI = Y(I)
        X(I) =  C*XI + S*YI
        Y(I) = -S*XI + C*YI
    1   CONTINUE
      RETURN
      END

      PROGRAM CTSWTH
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.  Use one
C of the following:
C
C       PARAMETER (IERF=6,LUNI=2,IWTY=1 ,IWID=1)  !  NCGM
C       PARAMETER (IERF=6,LUNI=2,IWTY=8 ,IWID=1)  !  X Windows
C       PARAMETER (IERF=6,LUNI=2,IWTY=20,IWID=1)  !  PostScript
C       PARAMETER (IERF=6,LUNI=2,IWTY=11,IWID=1)  !  PDF, Portrait
C       PARAMETER (IERF=6,LUNI=2,IWTY=12,IWID=1)  !  PDF, Landscape
C
        PARAMETER (IERF=6,LUNI=2,IWTYPE=1,IWTY=IWTYPE,IWID=1)
C
C The object of this program is to produce a set of plots illustrating
C the use of a particular triangular mesh on the surface of the globe.
C The triangular mesh used here is derived from a rectangular mesh
C that came from Simona Bordoni and probably represents data sampled
C by a satellite orbiting once around the earth.
C
C Selected frames are drawn for each of four different viewpoints.  If
C (CLAT,CLON) is the approximate position of the "center point" of the
C mesh (which is defined somewhat arbitrarily for certain meshes), the
C four viewpoints used are as follows: (CLAT+45,CLON), (CLAT-45,CLON),
C (CLAT+45,CLON+180), and (CLAT-45,CLON+180).
C
C At each of the four viewpoints, up to four different frames may be
C drawn:
C
C   1) A frame showing the triangular mesh on the globe.  This frame
C      is drawn only if the parameter IMSH is non-zero.
C
C   2) A frame showing simple contours on the globe.  This frame is
C      drawn only if the parameter ICON is non-zero.
C
C   3) A frame showing color-filled contour bands on the globe, drawn
C      using filled areas.  This frame is drawn only if the parameter
C      ICOL is non-zero.
C
C   4) A frame showing color-filled contour bands on the globe, drawn
C      using a cell array.  This frame is drawn only if the parameter
C      ICAP is non-zero.
C
C Define the parameter that says which frames showing the rectangular
C grid and/or the triangular mesh are to be drawn (frame 1):
C
C       PARAMETER (IMSH=0)  !  triangular mesh not drawn
C       PARAMETER (IMSH=1)  !  triangular mesh drawn
C
        PARAMETER (IMSH=1)
C
C Define the parameter that says whether or not to draw simple contours
C (frame 2):
C
C       PARAMETER (ICON=0)  !  contours not drawn
C       PARAMETER (ICON=1)  !  contours drawn
C
        PARAMETER (ICON=1)
C
C Define the parameter that says whether or not to draw color-filled
C contours (frame 3):
C
C       PARAMETER (ICOL=0)  !  no color fill done
C       PARAMETER (ICOL=1)  !  color fill done
C
        PARAMETER (ICOL=1)
C
C Define the parameter that says whether or not to draw a cell array
C plot (frame 4):
C
C       PARAMETER (ICAP=0)  !  cell array plot not drawn
C       PARAMETER (ICAP=1)  !  cell array plot drawn
C
        PARAMETER (ICAP=1)
C
C To represent the triangular mesh, we use three singly-dimensioned
C arrays: RPNT holds points, IEDG holds edges, and ITRI holds triangles.
C The elements of each array form "nodes" having lengths as follows:
C
        PARAMETER (LOPN=5)
C
C The five elements of a point node are
C
C   1. the X coordinate of the point;
C   2. the Y coordinate of the point;
C   3. the Z coordinate of the point;
C   4. the field value at the point;
C   5. any additional value desired by the user.
C
        PARAMETER (LOEN=5)
C
C The five elements of an edge node are
C
C   1. the base index, in RPNT, of point 1 of the edge;
C   2. the base index, in RPNT, of point 2 of the edge;
C   3. the index, in ITRI, of the pointer to the edge in the triangle to
C      the left of the edge (-1 if there is no triangle to the left);
C   4. the index, in ITRI, of the pointer to the edge in the triangle to
C      the right of the edge (-1 if there is no triangle to the right);
C   5. a utility flag for use by algorithms that scan the structure.
C
C The "left" and "right" sides of an edge are defined as they would be
C by an observer standing on the globe at point 1 of the edge, looking
C toward point 2 of the edge.  It is possible, if there are "holes" in
C the mesh, that there will be no triangle to the left or to the right
C of an edge, but there must be a triangle on one side or the other.
C
        PARAMETER (LOTN=4)
C
C The four elements of a triangle node are
C
C   1. the base index, in IEDG, of edge 1 of the triangle;
C   2. the base index, in IEDG, of edge 2 of the triangle;
C   3. the base index, in IEDG, of edge 3 of the triangle;
C   4. a flag set non-zero to block use of the triangle, effectively
C      removing it from the mesh.
C
C The "base index" of a point node, an edge node, or a triangle node is
C always a multiple of the length of the node, to which can be added an
C offset to get the index of a particular element of the node.  For
C example, if I is the base index of a triangle of interest, ITRI(I+1)
C is its first element (the base index of its first edge).  Similarly,
C IEDG(ITRI(I+1)+2) is the base index of the second point of the first
C edge of the triangle with base index I, and RPNT(IEDG(ITRI(I+1)+2)+3)
C is the third (Z) coordinate of the second point of the first edge of
C the triangle with base index I.
C
C It is the pointers from the edge nodes back to the triangle nodes that
C allow CONPACKT to navigate the mesh, moving from triangle to triangle
C as it follows a contour line, but these pointers are tricky to define:
C if IPTE is the base index of an edge node and IEDG(IPTE+3) is zero or
C more, saying that there is a triangle to the left of the edge, then
C IEDG(IPTE+3) is the actual index of that element of the triangle node
C that points to the edge node; i.e., ITRI(IEDG(IPTE+3))=IPTE.  The base
C index of the triangle node defining that triangle is IPTT, where
C IPTT=LOTN*((IEDG(IPTE+3)-1)/LOTN), and the index of the pointer to
C the edge within the triangle node is IPTI=IEDG(IPTE+3)-IPTT, so that
C ITRI(IPTT+IPTI)=IPTE.  Similar comments apply to element 4 of an edge
C node, which points into the triangle node defining the triangle to the
C right of the edge.
C
C The maximum numbers of points, edges, and triangles in a triangular
C mesh can be computed in the following manner:  Since the triangular
C mesh is created from a rectangular one by splitting each rectangular
C cell in half, we can declare the largest values we expect to use for
C the dimensions of that mesh:
C
        PARAMETER (IDIM=76,JDIM=1624,IDM1=IDIM-1,JDM1=JDIM-1)
C
C and then compute from those values the maximum number of points,
C edges, and triangles that the triangular mesh arrays will need to
C hold.  The computed values will be exactly as required if no points
C or edges of the rectangular grid are repeated in it; if there are
C repeating points or edges, space for slightly fewer points and edges
C will be needed:
C
        PARAMETER (MNOP=IDIM*JDIM)
        PARAMETER (MNOE=3*IDM1*JDM1+IDM1+JDM1)
        PARAMETER (MNOT=2*IDM1*JDM1)
C
C Once we know how many points, edges, and triangles we're going to use
C (at most), we can set parameters defining the space reserved for the
C triangular mesh:
C
        PARAMETER (MPNT=MNOP*LOPN)
        PARAMETER (MEDG=MNOE*LOEN)
        PARAMETER (MTRI=MNOT*LOTN)
C
C Declare the arrays to hold the point nodes, edge nodes, and triangle
C nodes defining the triangular mesh.
C
        DIMENSION RPNT(MPNT),IEDG(MEDG),ITRI(MTRI)
C
C Declare real and integer workspaces needed by CONPACKT.
C
        PARAMETER (LRWK=10000,LIWK=1000)
C
        DIMENSION RWRK(LRWK),IWRK(LIWK)
C
C Declare the area map array needed to do solid fill.
C
        PARAMETER (LAMA=2000000)
C
        DIMENSION IAMA(LAMA)
C
C Declare workspace arrays to be used in calls to ARSCAM.
C
        PARAMETER (NCRA=LAMA/10,NGPS=2)
C
        DIMENSION XCRA(NCRA),YCRA(NCRA),IAAI(NGPS),IAGI(NGPS)
C
C Declare arrays in which to generate a cell array picture of the
C data on the triangular mesh.
C
C       PARAMETER (ICAM=1024,ICAN=1024)
        PARAMETER (ICAM= 512,ICAN= 512)
C
        DIMENSION ICRA(ICAM,ICAN)
C
C Declare arrays to hold color components for colors to be used at the
C four corners of an illustrative drawing of the rectangular grid.
C
        DIMENSION CCLL(3),CCLR(3),CCUL(3),CCUR(3)
C
C Declare external the routine that draws masked contour lines.
C
        EXTERNAL DRWMCL
C
C Declare external the routine that does color fill of contour bands.
C
        EXTERNAL DCFOCB
C
C Define a common block in which to keep track of the maximum space used
C in the arrays XCRA and YCRA.
C
        COMMON /COMONA/ MAXN
C
C Define the out-of-range flag.
C
        DATA OORV / 1.E12 /
C
C Define the tension on the splines to be used in smoothing contours.
C
C       DATA T2DS / 0.0 /  !  smoothing off
C       DATA T2DS / 2.5 /  !  smoothing on
C
        DATA T2DS / 0.0 /
C
C Define the distance between points on smoothed contour lines.
C
        DATA RSSL / .002 /
C
C Define the amount of real workspace to be used in drawing contours.
C
        DATA IRWC / 500 /
C
C Define the label-positioning flag.
C
C       DATA ILLP / 0 /  !  no labels
C       DATA ILLP / 1 /  !  dash-package writes labels
C       DATA ILLP / 2 /  !  regular scheme
C       DATA ILLP / 3 /  !  penalty scheme
C
        DATA ILLP / 2 /
C
C Define the high/low search radius.
C
        DATA HLSR / .075 /
C
C Define the high/low label overlap flag.
C
        DATA IHLO / 11 /
C
C Define the hachuring flag, hachure length, and hachure spacing.
C
C       DATA IHCF,HCHL,HCHS /  0 , +.004 , .010 /  !  off
C       DATA IHCF,HCHL,HCHS / +1 , -.004 , .020 /  !  on, all, uphill
C
        DATA IHCF,HCHL,HCHS /  0 , +.004 , .010 /
C
C Define the colors to be used in the lower left, lower right, upper
C left, and upper right corners of the rectangular grid when a drawing
C of it is made for the purpose of illustrating how it is wrapped around
C the globe.
C
        DATA CCLL / 0.2 , 0.2 , 0.2 /
        DATA CCLR / 1.0 , 0.0 , 1.0 /
        DATA CCUL / 0.0 , 1.0 , 1.0 /
        DATA CCUR / 1.0 , 1.0 , 0.0 /
C
C Define a constant to convert from radians to degrees.
C
        DATA RTOD / 57.2957795130823 /
C
C Read data and generate the required triangular mesh.
C
        PRINT * , ' '
        PRINT * , 'CREATING TRIANGULAR MESH:'
C
        CALL GTSWTH (RPNT,MPNT,NPNT,LOPN,
     +               IEDG,MEDG,NEDG,LOEN,
     +               ITRI,MTRI,NTRI,LOTN,
     +               CLAT,CLON)
C
C Print the number of points, edges, and triangles.
C
        PRINT * , '  NUMBER OF POINTS:    ',NPNT/LOPN
        PRINT * , '  NUMBER OF EDGES:     ',NEDG/LOEN
        PRINT * , '  NUMBER OF TRIANGLES: ',NTRI/LOTN
C
C Write the contents of the point list, the edge list, and the triangle
C list to "fort.11" in a readable form.
C
c       WRITE (11,'(''P'',I8,5F10.4)')
c    +        (I,RPNT(I+1),RPNT(I+2),RPNT(I+3),RPNT(I+4),RPNT(I+5),
c    +                                               I=0,NPNT-LOPN,LOPN)
c       WRITE (11,'(''E'',I8,5I10)')
c    +        (I,IEDG(I+1),IEDG(I+2),IEDG(I+3),IEDG(I+4),IEDG(I+5),
c    +                                               I=0,NEDG-LOEN,LOEN)
c       WRITE (11,'(''T'',I8,4I10)')
c    +        (I,ITRI(I+1),ITRI(I+2),ITRI(I+3),ITRI(I+4),
c    +                                               I=0,NTRI-LOTN,LOTN)
C
C Open GKS.
C
        PRINT * , 'OPENING AND INITIALIZING GKS'
C
        CALL GOPKS (IERF,0)
        CALL GOPWK (IWID,LUNI,IWTY)
        CALL GACWK (IWID)
C
C Turn off the clipping indicator.
C
        CALL GSCLIP (0)
C
C Define a basic set of colors (0 = white, background; 1 = black,
C foreground; 2 = yellow; 3 = magenta; 4 = red; 5 = cyan; 6 = green;
C 7 = blue; 8 = darker light gray; 9 = lighter light gray; 10 = dark
C yellow; 11 = dark gray; 12 = medium gray; 13 = light red, for
C geographic lines; 14 = light blue, for lat/lon lines).
C
        CALL GSCR   (IWID, 0,1.,1.,1.)
        CALL GSCR   (IWID, 1,0.,0.,0.)
        CALL GSCR   (IWID, 2,1.,1.,0.)
        CALL GSCR   (IWID, 3,1.,0.,1.)
        CALL GSCR   (IWID, 4,1.,0.,0.)
        CALL GSCR   (IWID, 5,0.,1.,1.)
        CALL GSCR   (IWID, 6,0.,1.,0.)
        CALL GSCR   (IWID, 7,0.,0.,1.)
        CALL GSCR   (IWID, 8,.5,.5,.5)
        CALL GSCR   (IWID, 9,.8,.8,.8)
        CALL GSCR   (IWID,10,.3,.3,0.)
        CALL GSCR   (IWID,11,.3,.3,.3)
        CALL GSCR   (IWID,12,.5,.5,.5)
        CALL GSCR   (IWID,13,.8,.5,.5)
        CALL GSCR   (IWID,14,.5,.5,.8)
C
C Define 100 colors, associated with color indices 151 through 250, to
C be used for color-filled contour bands and in cell arrays, ranging
C from blue to red.
C
        CALL DFCLRS (IWID,151,250,0.,0.,1.,1.,0.,0.)
C
C Set parameters in the utilities.
C
        PRINT * , 'SETTING PARAMETERS IN CONPACKT, EZMAP, AND PLOTCHAR'
C
C Set the mapping flag.
C
        CALL CTSETI ('MAP - MAPPING FLAG',1)
C
C Set the out-of-range flag value.
C
        CALL CTSETR ('ORV - OUT-OF-RANGE VALUE',OORV)
C
C Turn on the drawing of the mesh edge and set the area identifier for
C areas outside the mesh.
C
        CALL CTSETI ('PAI - PARAMETER ARRAY INDEX',-1)
        CALL CTSETI ('CLU - CONTOUR LEVEL USE FLAG',1)
        CALL CTSETI ('AIA - AREA IDENTIFIER FOR AREA',1001)
C
C Set the area identifier for areas in "out-of-range" areas.
C
C       CALL CTSETI ('PAI',-2)
C       CALL CTSETI ('AIA - AREA IDENTIFIER FOR AREA',1002)
C
C Set the 2D smoother flag.
C
        CALL CTSETR ('T2D - TENSION ON 2D SPLINES',T2DS)
C
C Set the distance between points on smoothed lines.
C
        CALL CTSETR ('SSL - SMOOTHED SEGMENT LENGTH',RSSL)
C
C Set the amount of real workspace to be used in drawing contours.
C
        CALL CTSETI ('RWC - REAL WORKSPACE FOR CONTOURS',IRWC)
C
C Set the label-positioning flag.
C
        CALL CTSETI ('LLP - LINE LABEL POSITIONING FLAG',ILLP)
C
C Set the high/low search radius.
C
        CALL CTSETR ('HLR - HIGH/LOW SEARCH RADIUS',HLSR)
C
C Set the high/low label overlap flag.
C
        CALL CTSETI ('HLO - HIGH/LOW LABEL OVERLAP FLAG',IHLO)
C
C Set the hachuring flag, hachure length, and hachure spacing.
C
        CALL CTSETI ('HCF - HACHURING FLAG',IHCF)
        CALL CTSETR ('HCL - HACHURE LENGTH',HCHL)
        CALL CTSETR ('HCS - HACHURE SPACING',HCHS)
C
C Set the cell array flag.
C
        CALL CTSETI ('CAF - CELL ARRAY FLAG',-1)
C
C Tell CONPACKT not to do its own call to SET, since EZMAP will have
C done it.
C
        CALL CTSETI ('SET - DO-SET-CALL FLAG', 0)
C
C Move the informational label up a little.
C
        CALL CTSETR ('ILY - INFORMATIONAL LABEL Y POSITION',-.005)
C
C Tell EZMAP not to draw the perimeter.
C
        CALL MPSETI ('PE',0)
C
C Tell EZMAP to use solid lat/lon lines.
C
        CALL MPSETI ('DA',65535)
C
C Tell PLOTCHAR to use one of the filled fonts and to outline each
C character.
C
        CALL PCSETI ('FN',25)
        CALL PCSETI ('OF',1)
C
C Tell PLOTCHAR to expect a character other than a colon as the
C function-control signal character.
C
        CALL PCSETC ('FC','|')
C
C Loop through four different viewing angles.
C
        DO 104 IDIR=1,4
C
          PRINT * , ' '
          PRINT * , 'VIEW FROM DIRECTION NUMBER: ',IDIR
C
C Tell EZMAP what projection to use and what its limits are.
C
          IF      (IDIR.EQ.1) THEN
            CALL MAPROJ ('OR',CLAT+45.,CLON,      0.)
          ELSE IF (IDIR.EQ.2) THEN
            CALL MAPROJ ('OR',CLAT-45.,CLON,      0.)
          ELSE IF (IDIR.EQ.3) THEN
            CALL MAPROJ ('OR',CLAT+45.,CLON+180., 0.)
          ELSE IF (IDIR.EQ.4) THEN
            CALL MAPROJ ('OR',CLAT-45.,CLON+180., 0.)
          END IF
C
          CALL MAPSET ('MA',0.,0.,0.,0.)
C
C Initialize EZMAP.
C
          CALL MAPINT
C
C If the triangular mesh is to be drawn, do it.
C
          IF (IMSH.NE.0) THEN
C
            PRINT * , 'DRAWING TRIANGULAR MESH'
C
            DO 101 IPTE=0,NEDG-LOEN,LOEN
C
              IFLL=0
C
              IF (IEDG(IPTE+3).GE.0) THEN
                IF (ITRI(LOTN*((IEDG(IPTE+3)-1)/LOTN)+4).EQ.0) IFLL=1
              END IF
C
              IFLR=0
C
              IF (IEDG(IPTE+4).GE.0) THEN
                IF (ITRI(LOTN*((IEDG(IPTE+4)-1)/LOTN)+4).EQ.0) IFLR=1
              END IF
C
              IF (IFLL.NE.0.OR.IFLR.NE.0) THEN
                CALL PLOTIT (0,0,2)
                CALL GSPLCI (8)
              ELSE
                CALL PLOTIT (0,0,2)
                CALL GSPLCI (9)
              END IF
C
              ALAT=RTOD*ASIN(RPNT(IEDG(IPTE+1)+3))
C
              IF (RPNT(IEDG(IPTE+1)+1).EQ.0..AND.
     +            RPNT(IEDG(IPTE+1)+2).EQ.0.) THEN
                ALON=0.
              ELSE
                ALON=RTOD*ATAN2(RPNT(IEDG(IPTE+1)+2),
     +                          RPNT(IEDG(IPTE+1)+1))
              END IF
C
              BLAT=RTOD*ASIN(RPNT(IEDG(IPTE+2)+3))
C
              IF (RPNT(IEDG(IPTE+2)+1).EQ.0..AND.
     +            RPNT(IEDG(IPTE+2)+2).EQ.0.) THEN
                BLON=0.
              ELSE
                BLON=RTOD*ATAN2(RPNT(IEDG(IPTE+2)+2),
     +                          RPNT(IEDG(IPTE+2)+1))
              END IF
C
              CALL DRSGCR (ALAT,ALON,BLAT,BLON)
C
  101       CONTINUE
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (13)
            CALL MAPGRD
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (14)
            CALL MAPLOT
C
C Label the first frame.
C
            CALL PLCHHQ (CFUX(.03),CFUY(.946),'A "SWATH" GRID',
     +                                                      .024,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.908),'(from Simona Bordoni)',
     +                                                      .014,0.,-1.)
C
            IF (     IDIR.EQ.1) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 1',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.2) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 2',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.3) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 3',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.4) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 4',
     +                                                      .012,0.,-1.)
            END IF
C
            CALL PLCHHQ (CFUX(.97),CFUY(.950),'DERIVED TRIANGULAR MESH',
     +.012,0.,1.)
C
            CALL PLCHHQ (CFUX(.97),CFUY(.928),
     +                   'Zoom on the mesh to see its',
     +                                                       .010,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.908),
     +                   'structure in detail.',
     +                                                       .010,0.,1.)
C
            CALL PLCHHQ (CFUX(.03),CFUY(.084),'Mesh is gray.',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.060),'Shorelines are blue.',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.036),'Parallels/meridians are r
     +ed.',.012,0.,-1.)
C
C Advance the frame.
C
            CALL FRAME
C
          END IF
C
C If a frame showing simple contours is to be drawn, do it next (adding
C an overlay of lat/lon lines and continental outlines in light gray).
C
          IF (ICON.NE.0) THEN
C
            PRINT * , 'DRAWING PLOT SHOWING SIMPLE CONTOURS'
C
C Initialize CONPACKT.
C
            PRINT * , 'CALLING CTMESH'
C
            CALL CTMESH (RPNT,NPNT,LOPN,
     +                   IEDG,NEDG,LOEN,
     +                   ITRI,NTRI,LOTN,
     +                   RWRK,LRWK,
     +                   IWRK,LIWK)
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (1)
C
C Proceed as implied by the setting of the label-positioning flag.
C
            IF (ABS(ILLP).EQ.1) THEN
C
C Draw the contour lines with labels generated by the dash package.
C
              PRINT * , 'CALLING CTCLDR'
              CALL CTCLDR (RPNT,IEDG,ITRI,RWRK,IWRK)
C
C Add the informational and high/low labels.
C
              PRINT * , 'CALLING CTLBDR'
              CALL CTLBDR (RPNT,IEDG,ITRI,RWRK,IWRK)
C
            ELSE IF (ABS(ILLP).GT.1) THEN
C
C Create an area map for masking of labels.
C
              MAXN=0
C
              PRINT * , 'CALLING ARINAM'
              CALL ARINAM (IAMA,LAMA)
C
              PRINT * , 'CALLING CTLBAM'
              CALL CTLBAM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA)
C
C Draw the contour lines masked by the area map.
C
              PRINT * , 'CALLING CTCLDM'
              CALL CTCLDM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA,DRWMCL)
C
              PRINT * , 'AREA MAP SPACE REQUIRED:         ',
     +                                         IAMA(1)-IAMA(6)+IAMA(5)+1
C
              PRINT * , 'NUMBER OF POINTS IN LONGEST LINE:',MAXN
C
C Draw all the labels.
C
              PRINT * , 'CALLING CTLBDR'
              CALL CTLBDR (RPNT,IEDG,ITRI,RWRK,IWRK)
C
            END IF
C
            CALL CTGETI ('IWU - INTEGER WORKSPACE USED',IIWU)
            PRINT * , 'INTEGER WORKSPACE REQUIRED:      ',IIWU
C
            CALL CTGETI ('RWU -    REAL WORKSPACE USED',IRWU)
            PRINT * , 'REAL WORKSPACE REQUIRED:         ',IRWU
C
C Add lat/lon lines and continental outlines.
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (13)
            CALL MAPGRD
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (14)
            CALL MAPLOT
C
C Label the second frame.
C
            CALL PLCHHQ (CFUX(.03),CFUY(.946),'A "SWATH" GRID',
     +                                                      .024,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.908),'(from Simona Bordoni)',
     +                                                      .014,0.,-1.)
C
            IF (     IDIR.EQ.1) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 1',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.2) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 2',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.3) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 3',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.4) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 4',
     +                                                      .012,0.,-1.)
            END IF
C
            CALL PLCHHQ (CFUX(.97),CFUY(.950),'SIMPLE CONTOURS ON',
     +                                                       .012,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.926),'TRIANGULAR MESH',
     +                                                       .012,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.904),'The data are probably',
     +                                                       .010,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.884),'wind speeds, in',
     +                                                       .010,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.864),'meters/sec.',
     +                                                       .010,0.,1.)
C
            CALL PLCHHQ (CFUX(.03),CFUY(.060),'Shorelines are blue.',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.036),'Parallels/meridians are r
     +ed.',.012,0.,-1.)
C
C Advance the frame.
C
            CALL FRAME
C
          END IF
C
C If a frame showing color-filled contours is to be drawn, do it next.
C
          IF (ICOL.NE.0) THEN
C
            PRINT * , 'DRAWING PLOT SHOWING COLOR-FILLED CONTOURS'
C
            PRINT * , 'CALLING CTMESH'
C
            CALL CTMESH (RPNT,NPNT,LOPN,
     +                   IEDG,NEDG,LOEN,
     +                   ITRI,NTRI,LOTN,
     +                   RWRK,LRWK,
     +                   IWRK,LIWK)
C
            MAXN=0
C
            PRINT * , 'CALLING CTPKCL'
            CALL CTPKCL (RPNT,IEDG,ITRI,RWRK,IWRK)
C
            PRINT * , 'CALLING ARINAM'
            CALL ARINAM (IAMA,LAMA)
C
            PRINT * , 'CALLING CTCLAM'
            CALL CTCLAM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA)
C
C           PRINT * , 'CALLING CTLBAM'
C           CALL CTLBAM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA)
C
            PRINT * , 'CALLING ARSCAM'
            CALL ARSCAM (IAMA,XCRA,YCRA,NCRA,IAAI,IAGI,NGPS,DCFOCB)
C
            PRINT * , 'SPACE REQUIRED IN AREA MAP:      ',
     +                                         IAMA(1)-IAMA(6)+IAMA(5)+1
C
            PRINT * , 'NUMBER OF POINTS IN LARGEST AREA:',MAXN
C
            CALL CTGETI ('IWU - INTEGER WORKSPACE USED',IIWU)
            PRINT * , 'INTEGER WORKSPACE REQUIRED:      ',IIWU
C
            CALL CTGETI ('RWU -    REAL WORKSPACE USED',IRWU)
            PRINT * , 'REAL WORKSPACE REQUIRED:         ',IRWU
C
            CALL GSFACI (1)
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (13)
            CALL MAPGRD
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (14)
            CALL MAPLOT
C
C Label the third frame.
C
            CALL PLCHHQ (CFUX(.03),CFUY(.946),'A "SWATH" GRID',
     +                                                      .024,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.908),'(from Simona Bordoni)',
     +                                                      .014,0.,-1.)
C
            IF (     IDIR.EQ.1) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 1',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.2) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 2',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.3) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 3',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.4) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 4',
     +                                                      .012,0.,-1.)
            END IF
C
            CALL PLCHHQ (CFUX(.97),CFUY(.950),'COLORED CONTOUR BANDS ON'
     +,.012,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.926),'TRIANGULAR MESH',
     +                                                       .012,0.,1.)
C
            CALL PLCHHQ (CFUX(.97),CFUY(.904),'The data are probably',
     +                                                       .010,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.884),'wind speeds, in',
     +                                                       .010,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.864),'meters/sec.',
     +                                                       .010,0.,1.)
C
            CALL PLCHHQ (CFUX(.03),CFUY(.132),'Off-mesh',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.108),'areas of the',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.084),'globe are yellow.',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.060),'Shorelines are blue.',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.036),'Parallels/meridians are r
     +ed.',.012,0.,-1.)
C
C Advance the frame.
C
            CALL FRAME
C
          END IF
C
C If the flag for it is set, do a cell array plot.
C
          IF (ICAP.NE.0) THEN
C
            PRINT * , 'DRAWING CELL-ARRAY PLOT OF DATA VALUES'
C
            PRINT * , 'CALLING CTMESH'
C
            CALL CTMESH (RPNT,NPNT,LOPN,
     +                   IEDG,NEDG,LOEN,
     +                   ITRI,NTRI,LOTN,
     +                   RWRK,LRWK,
     +                   IWRK,LIWK)
C
            CALL GETSET (XVPL,XVPR,YVPB,YVPT,XWDL,XWDR,YWDB,YWDT,LNLG)
C
            PRINT * , 'CALLING CTCICA'
            CALL CTCICA (RPNT,IEDG,ITRI,RWRK,IWRK,ICRA,ICAM,ICAM,ICAN,
     +                                            XVPL,YVPB,XVPR,YVPT)
C
            PRINT * , 'CALLING GCA'
            CALL GCA (XWDL,YWDB,XWDR,YWDT,ICAM,ICAN,1,1,ICAM,ICAN,ICRA)
C
            CALL CTGETI ('IWU - INTEGER WORKSPACE USED',IIWU)
            PRINT * , 'INTEGER WORKSPACE REQUIRED:      ',IIWU
C
            CALL CTGETI ('RWU -    REAL WORKSPACE USED',IRWU)
            PRINT * , 'REAL WORKSPACE REQUIRED:         ',IRWU
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (13)
            CALL MAPGRD
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (14)
            CALL MAPLOT
C
C Label the fourth frame.
C
            CALL PLCHHQ (CFUX(.03),CFUY(.946),'A "SWATH" GRID',
     +                                                      .024,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.908),'(from Simona Bordoni)',
     +                                                      .014,0.,-1.)
C
            IF (     IDIR.EQ.1) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 1',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.2) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 2',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.3) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 3',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.4) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 4',
     +                                                      .012,0.,-1.)
            END IF
C
            CALL PLCHHQ (CFUX(.97),CFUY(.950),'CELL ARRAY DERIVED FROM',
     +.012,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.926),'TRIANGULAR MESH',
     +                                                       .012,0.,1.)
C
            CALL PLCHHQ (CFUX(.97),CFUY(.904),'The data are probably',
     +                                                       .010,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.884),'wind speeds, in',
     +                                                       .010,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.864),'meters/sec.',
     +                                                       .010,0.,1.)
C
            CALL PLCHHQ (CFUX(.03),CFUY(.132),'Off-mesh',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.108),'areas of the',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.084),'globe are yellow.',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.060),'Shorelines are blue.',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.036),'Parallels/meridians are r
     +ed.',.012,0.,-1.)
C
C Advance the frame.
C
            CALL FRAME
C
          END IF
C
  104   CONTINUE
C
C Close GKS.
C
        CALL GDAWK (IWID)
        CALL GCLWK (IWID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END


      SUBROUTINE DFCLRS (IWID,IOFC,IOLC,REDF,GRNF,BLUF,REDL,GRNL,BLUL)
C
C This routine defines color indices IOFC through IOLC on workstation
C IWID by interpolating values from REDF/GRNF/BLUF to REDL/GRNL/BLUL.
C
        DO 101 I=IOFC,IOLC
          P=REAL(IOLC-I)/REAL(IOLC-IOFC)
          Q=REAL(I-IOFC)/REAL(IOLC-IOFC)
          CALL GSCR (IWID,I,P*REDF+Q*REDL,P*GRNF+Q*GRNL,P*BLUF+Q*BLUL)
  101   CONTINUE
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE DRWMCL (XCRA,YCRA,NCRA,IAAI,IAGI,NGPS)
C
        DIMENSION XCRA(*),YCRA(*),IAAI(*),IAGI(*)
C
C This routine draws the curve defined by the points (XCRA(I),YCRA(I)),
C for I = 1 to NCRA, if and only if none of the area identifiers for the
C area containing the polyline are negative.  It calls either CURVE or
C CURVED to do the drawing, depending on the value of the internal
C parameter 'DPU'.
C
C It keeps track of the maximum value used for NCRA in a common block.
C
        COMMON /COMONA/ MAXN
C
        MAXN=MAX(MAXN,NCRA)
C
C Retrieve the value of the internal parameter 'DPU'.
C
        CALL CTGETI ('DPU - DASH PACKAGE USED',IDUF)
C
C Turn on drawing.
C
        IDRW=1
C
C If any area identifier is negative, turn off drawing.
C
        DO 101 I=1,NGPS
          IF (IAAI(I).LT.0) IDRW=0
  101   CONTINUE
C
C If drawing is turned on, draw the polyline.
C
        IF (IDRW.NE.0) THEN
          IF (IDUF.EQ.0) THEN
            CALL CURVE  (XCRA,YCRA,NCRA)
          ELSE IF (IDUF.LT.0) THEN
            CALL DPCURV (XCRA,YCRA,NCRA)
          ELSE
            CALL CURVED (XCRA,YCRA,NCRA)
          END IF
        END IF
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE DCFOCB (XCRA,YCRA,NCRA,IAAI,IAGI,NGPS)
C
C This routine fills the area defined by the points (XCRA(I),YCRA(I)),
C for I = 1 to NCRA, if and only if none of the area identifiers for
C the area are negative.  The color used is determined from the area
C identifier of the area relative to group 3; it is assumed that 100
C colors are defined having color indices 151 through 250.
C
        DIMENSION XCRA(*),YCRA(*),IAAI(*),IAGI(*)
C
C It keeps track of the maximum value used for NCRA in a common block.
C
        COMMON /COMONA/ MAXN
C
        MAXN=MAX(MAXN,NCRA)
C
C Retrieve the number of contour levels being used.
C
        CALL CTGETI ('NCL - NUMBER OF CONTOUR LEVELS',NOCL)
C
C If the number of contour levels is non-zero and the area has more
C than two points, fill it.
C
        IF (NOCL.NE.0.AND.NCRA.GT.2) THEN
C
          IAI3=-1
C
          DO 101 I=1,NGPS
            IF (IAGI(I).EQ.3) IAI3=IAAI(I)
  101     CONTINUE
C
          IF (IAI3.GE.1.AND.IAI3.LE.NOCL+1) THEN
            CALL GSFACI (151+INT(((REAL(IAI3)-.5)/REAL(NOCL+1))*100.))
            CALL GFA    (NCRA,XCRA,YCRA)
          ELSE IF (IAI3.EQ.1001) THEN
            CALL GSFACI (2)
            CALL GFA    (NCRA,XCRA,YCRA)
          ELSE IF (IAI3.EQ.1002) THEN
            CALL GSFACI (3)
            CALL GFA    (NCRA,XCRA,YCRA)
          END IF
C
        END IF
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE GTSWTH (RPNT,MPNT,NPNT,LOPN,
     +                   IEDG,MEDG,NEDG,LOEN,
     +                   ITRI,MTRI,NTRI,LOTN,
     +                             CLAT,CLON)
C
        DIMENSION RPNT(MPNT),IEDG(MEDG),ITRI(MTRI)
C
C Include definitions that "NetCDF" needs (now commented out, because
C the data are being read from an ASCII file, instead).
C
C       include 'netcdf.inc'
C
C This program reads a NetCDF file for which the header (as output by
C the command "ncdump -h ctswth.nc") is as follows:
C
C   netcdf simone {
C   dimensions:
C           ncl0 = 1624 ;
C           ncl1 = 76 ;
C           ncl2 = 1624 ;
C           ncl3 = 76 ;
C           ncl4 = 1624 ;
C           ncl5 = 76 ;
C   variables:
C           float lat2d(ncl0, ncl1) ;
C                   lat2d:_FillValue = -999.f ;
C           float lon2d(ncl2, ncl3) ;
C                   lon2d:_FillValue = -999.f ;
C           float wnds(ncl4, ncl5) ;
C                   wnds:_FillValue = -999.f ;
C   }
C
C Each of the rectangular arrays that are read is dimensioned IDIM by
C JDIM.  Define these values and a couple of secondary values.
C
        PARAMETER (IDIM=76,JDIM=1624,IDM1=IDIM-1,JDM1=JDIM-1)
C
C Declare arrays to receive the user grid data.  XLAT is the array of
C latitudes, XLON the array of longitudes, and ZDAT the array of data
C values.  Each of these arrays has one point of overlap in the first
C dimension: for each value of J from 1 to JDIM, a value indexed [1,J]
C is the same as a value indexed [IDIM,J].
C
        DIMENSION XLAT(IDIM,JDIM),XLON(IDIM,JDIM),ZDAT(IDIM,JDIM)
C
C Each cell of the rectangular grid for which data is available at all
C four corners is split in half along one of its diagonals; resulting
C triangles form the triangular mesh.  As we create the triangular mesh,
C we have to keep track of where the points and edges of the rectangular
C grid were put (so as to avoid the problem of duplicating points and
C edges in the structure).  The array ISCR is used for this.
C
        DIMENSION ISCR(4,IDIM,JDIM)
C
C Declare external a routine to tell CTTMRG about points of overlap on
C the lat/lon grid.
C
        EXTERNAL MISWTH
C
C Define the value that indicates a missing datum in this POP grid.
C
        DATA SVAL / -999. /
C
C The data for this example were originally read from a user's "NetCDF"
C file.  The code used for the purpose follows, but has been commented
C out, as the data are now read from an ASCII file.  This gets around
C certain procedural problems in running the example from "ncargex".
C
C Open the "NetCDF" file.
C
C       ISTA=NF_OPEN('ctswth.nc',0,NCID)
C
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'GTSWTH - ERROR RETURN FROM NF_OPEN: ',ISTA
C         STOP
C       END IF
C
C Read the array of latitudes.
C
C       ISTA=NF_INQ_VARID(NCID,'lat2d',IVID)
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'GTSWTH - ERROR RETURN 1 FROM NF_INQ_VARID: ',ISTA
C         STOP
C       END IF
C       ISTA=NF_GET_VAR_REAL(NCID,IVID,XLAT)
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'GTSWTH - ERROR RETURN FROM NF_GET_VAR_REAL: ',ISTA
C         STOP
C       END IF
C
C Read the array of longitudes.
C
C       ISTA=NF_INQ_VARID(NCID,'lon2d',IVID)
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'GTSWTH - ERROR RETURN 2 FROM NF_INQ_VARID: ',ISTA
C         STOP
C       END IF
C       ISTA=NF_GET_VAR_REAL(NCID,IVID,XLON)
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'GTSWTH - ERROR RETURN FROM NF_GET_VAR_REAL: ',ISTA
C         STOP
C       END IF
C
C Read the array of data values.
C
C       ISTA=NF_INQ_VARID(NCID,'wnds',IVID)
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'GTSWTH - ERROR RETURN 3 FROM NF_INQ_VARID: ',ISTA
C         STOP
C       END IF
C       ISTA=NF_GET_VAR_REAL(NCID,IVID,ZDAT)
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'GTSWTH - ERROR RETURN FROM NF_GET_VAR_REAL: ',ISTA
C         STOP
C       END IF
C
C Close the "NetCDF" file.
C
C       ISTA=NF_CLOSE(NCID)
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'GTSWTH - ERROR RETURN FROM NF_CLOSE: ',ISTA
C         STOP
C       END IF
C
C Write the data to unit 11.  (These statements are commented out; they
C were used to create a "fort.11" which was then renamed "ctswth.dat".)
C
C       WRITE (11,'(5E16.8)') XLAT
C       WRITE (11,'(5E16.8)') XLON
C       WRITE (11,'(5E16.8)') ZDAT
C
C Read the required data from the ASCII file "ctswth.dat".
C
        OPEN (11,FILE='ctswth.dat',STATUS='OLD',FORM='FORMATTED')
C
        READ (11,'(5E16.8)') XLAT
        READ (11,'(5E16.8)') XLON
        READ (11,'(5E16.8)') ZDAT
C
        CLOSE (11)
C
C Call a general-purpose subroutine that accepts a rectangular grid
C mapped onto the surface of the globe and returns a triangular mesh
C equivalent to it.
C
        CALL CTTMRG (IDIM,JDIM,XLAT,XLON,ZDAT,ISCR,SVAL,MISWTH,
     +               RPNT,MPNT,NPNT,LOPN,
     +               IEDG,MEDG,NEDG,LOEN,
     +               ITRI,MTRI,NTRI,LOTN)
C
C Adjust the data values to make the plot more interesting.  (This
C counteracts the effect of a single dramatic high off the coast of
C South America.)
C
        DO 101 I=0,NPNT-LOPN,LOPN
          IF (RPNT(I+4).GT.24.) RPNT(I+4)=24.+(RPNT(I+4)-24.)/10.
  101   CONTINUE
C
C Return the latitude and longitude of the approximate center point of
C the mesh on the globe.
C
        CLAT=  0.
        CLON=-30.
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE MISWTH (IDIM,JDIM,IINI,JINI,IINO,JINO)
C
C Given the dimensions, IDIM and JDIM, of a simple lat/lon grid on the
C globe, and the indices, IINI and JINI, of a point on the grid, this
C routine returns the indices, IINO and JINO, of that coincident point
C on the grid which is to be used to represent it.  This version assumes
C that all points of the grid map into unique points on the globe.
C
        IINO=IINI
        JINO=JINI
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE DRSGCR (ALAT,ALON,BLAT,BLON)
C
C (DRSGCR = DRaw Shortest Great Circle Route)
C
C This routine draws the shortest great circle route joining two points
C on the globe.  Note that MPTS = INT(180./SIZE) + 1.
C
        PARAMETER (MPTS=181,SIZE=1.)
C
        DIMENSION QLAT(MPTS),QLON(MPTS)
C
        NPTS=MAX(1,MIN(MPTS,INT(ADSGCR(ALAT,ALON,BLAT,BLON)/SIZE)))
C
        CALL MAPGCI (ALAT,ALON,BLAT,BLON,NPTS,QLAT,QLON)
C
        CALL MAPIT (ALAT,ALON,0)
C
        DO 101 I=1,NPTS
          CALL MAPIT (QLAT(I),QLON(I),1)
  101   CONTINUE
C
        CALL MAPIT (BLAT,BLON,2)
C
        CALL MAPIQ
C
        RETURN
C
      END


      FUNCTION ADSGCR (ALAT,ALON,BLAT,BLON)
C
C (ADSGCR = Angle in Degrees along Shortest Great Circle Route)
C
C This function returns the shortest great circle distance, in degrees,
C between two points, A and B, on the surface of the globe.
C
        DATA DTOR / .017453292519943 /
        DATA RTOD / 57.2957795130823 /
C
        XCOA=COS(DTOR*ALAT)*COS(DTOR*ALON)
        YCOA=COS(DTOR*ALAT)*SIN(DTOR*ALON)
        ZCOA=SIN(DTOR*ALAT)
C
        XCOB=COS(DTOR*BLAT)*COS(DTOR*BLON)
        YCOB=COS(DTOR*BLAT)*SIN(DTOR*BLON)
        ZCOB=SIN(DTOR*BLAT)
C
        ADSGCR=2.*RTOD*ASIN(SQRT((XCOA-XCOB)**2+
     +                           (YCOA-YCOB)**2+
     +                           (ZCOA-ZCOB)**2)/2.)
C
        RETURN
C
      END


      SUBROUTINE CTSCAE (ICRA,ICA1,ICAM,ICAN,XCPF,YCPF,XCQF,YCQF,
     +                                       IND1,IND2,ICAF,IAID)
        DIMENSION ICRA(ICA1,*)
C
C This routine is called by CTCICA when the internal parameter 'CAF' is
C given a negative value.  Each call is intended to create a particular
C element in the user's cell array.  The arguments are as follows:
C
C ICRA is the user's cell array.
C
C ICA1 is the first dimension of the FORTRAN array ICRA.
C
C ICAM and ICAN are the first and second dimensions of the cell array
C stored in ICRA.
C
C (XCPF,YCPF) is the point at that corner of the rectangular area
C into which the cell array maps that corresponds to the cell (1,1).
C The coordinates are given in the fractional coordinate system (unlike
C what is required in a call to GCA, in which the coordinates of the
C point P are in the world coordinate system).
C
C (XCQF,YCQF) is the point at that corner of the rectangular area into
C which the cell array maps that corresponds to the cell (ICAM,ICAN).
C The coordinates are given in the fractional coordinate system (unlike
C what is required in a call to GCA, in which the coordinates of the
C point Q are in the world coordinate system).
C
C IND1 is the 1st index of the cell that is to be updated.
C
C IND2 is the 2nd index of the cell that is to be updated.
C
C ICAF is the current value of the internal parameter 'CAF'.  This
C value will always be an integer which is less than zero (because
C when 'CAF' is zero or greater, this routine is not called).
C
C IAID is the area identifier associated with the cell.  It will have
C been given one of the values from the internal parameter array 'AIA'
C (the one for 'PAI' = -2 if the cell lies in an out-of-range area, the
C one for 'PAI' = -1 if the cell lies off the data grid, or the one for
C some value of 'PAI' between 1 and 'NCL' if the cell lies on the data
C grid).  The value zero may occur if the cell falls in an out-of-range
C area and the value of 'AIA' for 'PAI' = -2 is 0 or if the cell lies
C off the data grid and the value of 'AIA' for 'PAI' = -1 is 0, or if
C the cell falls on the data grid, but no contour level below the cell
C has a non-zero 'AIA' and no contour level above the cell has a
C non-zero 'AIB'.  Note that, if the values of 'AIA' for 'PAI' = -1
C and -2 are given non-zero values, IAID can only be given a zero
C value in one way.
C
C The default behavior of CTSCAE is as follows:  If the area identifier
C is non-negative, it is treated as a color index, to be stored in the
C appropriate cell in the cell array; but if the area identifier is
C negative, a zero is stored for the color index.  The user may supply
C a version of CTSCAE that does something different; it may simply map
C the area identifiers into color indices or it may somehow modify the
C existing cell array element to incorporate the information provided
C by the area identifier.
C
C       ICRA(IND1,IND2)=MAX(0,IAID)
C
C What follows is not the default behavior; instead, it is the behavior
C expected by many of the example programs for CONPACKT.
C
        CALL CTGETI ('NCL - NUMBER OF CONTOUR LEVELS',NOCL)
C
        IF (IAID.GE.1.AND.IAID.LE.NOCL+1) THEN
          ICRA(IND1,IND2)=151+INT(((REAL(IAID)-.5)/REAL(NOCL+1))*100.)
        ELSE IF (IAID.EQ.1001) THEN
          ICRA(IND1,IND2)=2
        ELSE IF (IAID.EQ.1002) THEN
          ICRA(IND1,IND2)=3
        END IF
C
        RETURN
C
      END

C
C $Id: agdash.f,v 1.6 2008-07-27 00:14:34 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE AGDASH (DASH,WODQ,WOCD,SCWP)
C
C AGDASH sets up the DASHD call required to establish the dash pattern
C desired for the next curve.  The arguments are as follows:
C
C -- DASH specifies the desired dash pattern.  A positive value implies
C    that a binary dash pattern is to be used, a negative value that a
C    character-string dash pattern is to be used.
C
C -- WODQ is the width of the solid-line segment specified by a dollar
C    sign and the gap specified by a quote, expressed as a fraction of
C    the smaller side of the curve window.
C
C -- WOCD is the width of a character which is to be a part of the dash
C    pattern, expressed in the same units as WODQ.
C
C -- SCWP is the length of the smaller side of the curve window, in
C    plotter coordinate units.
C
C The following common block contains other AUTOGRAPH variables, both
C real and integer, which are not control parameters.  The only ones
C used here are MWCD and MWDQ - the minimum widths of characters and
C spaces, respectively, in the dash pattern.
C
      COMMON /AGORIP/ SMRL , ISLD , MWCL,MWCM,MWCE,MDLA,MWCD,MWDQ ,
     +                INIF
      SAVE /AGORIP/
C
C The following common block contains other AUTOGRAPH variables, of type
C character.
C
      COMMON /AGOCHP/ CHS1,CHS2
      CHARACTER*504 CHS1,CHS2
      SAVE /AGOCHP/
C
C The AUTOGRAPH function AGFPBN is of type integer.
C
      INTEGER AGFPBN
C
      IWCD=MAX(MWCD,INT(WOCD*SCWP))
      IWDQ=MAX(MWDQ,INT(WODQ*SCWP))
C
      IF (DASH.GE.0.) THEN
        CALL DASHDB (AGFPBN(DASH))
      ELSE
        CALL AGGTCH (INT(DASH),CHS1,LNC1)
        CALL DASHDC (CHS1(1:LNC1),IWDQ,IWCD)
      END IF
C
      RETURN
C
      END

C
C $Id: surf2dp.f,v 1.3 2008-07-27 03:10:12 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
C NOTE: If you make any changes to this software, please remember to
C make the same changes to the corresponding single precision routine.
C
      FUNCTION SURF2DP(XX,YY,M,N,X,Y,Z,IZ,ZP,SIGMA)
      DOUBLE PRECISION SURF2DP
      DOUBLE PRECISION HERMZ
      DOUBLE PRECISION F1
      DOUBLE PRECISION F2
      DOUBLE PRECISION FP1
      DOUBLE PRECISION FP2
      DOUBLE PRECISION DEL1
      DOUBLE PRECISION DEL2
      DOUBLE PRECISION DELS
      DOUBLE PRECISION HERMNZ
      DOUBLE PRECISION SIGMAP
      DOUBLE PRECISION SINHM1
      DOUBLE PRECISION SINHMS
      DOUBLE PRECISION SINHM2
      DOUBLE PRECISION SIGMAX
      DOUBLE PRECISION SIGMAY
      DOUBLE PRECISION ZIM1
      DOUBLE PRECISION ZI
      DOUBLE PRECISION ZXXIM1
      DOUBLE PRECISION ZXXI
      DOUBLE PRECISION DUMMY
c
      INTEGER M,N,IZ
      DOUBLE PRECISION XX,YY,X(M),Y(N),Z(IZ,N),ZP(M,N,3),SIGMA
c
c                                 coded by alan kaylor cline
c                           from fitpack -- january 26, 1987
c                        a curve and surface fitting package
c                      a product of pleasant valley software
c                  8603 altus cove, austin, texas 78759, usa
c
c this function interpolates a surface at a given coordinate
c pair using a bi-spline under tension. the subroutine surf1
c should be called earlier to determine certain necessary
c parameters.
c
c on input--
c
c   xx and yy contain the x- and y-coordinates of the point
c   to be mapped onto the interpolating surface.
c
c   m and n contain the number of grid lines in the x- and
c   y-directions, respectively, of the rectangular grid
c   which specified the surface.
c
c   x and y are arrays containing the x- and y-grid values,
c   respectively, each in increasing order.
c
c   z is a matrix containing the m * n functional values
c   corresponding to the grid values (i. e. z(i,j) is the
c   surface value at the point (x(i),y(j)) for i = 1,...,m
c   and j = 1,...,n).
c
c   iz contains the row dimension of the array z as declared
c   in the calling program.
c
c   zp is an array of 3*m*n locations stored with the
c   various surface derivative information determined by
c   surf1.
c
c and
c
c   sigma contains the tension factor (its sign is ignored).
c
c the parameters m, n, x, y, z, iz, zp, and sigma should be
c input unaltered from the output of surf1.
c
c on output--
c
c   surf2dp contains the interpolated surface value.
c
c none of the input parameters are altered.
c
c this function references package modules intrvldp and
c snhcshdp.
c
c-----------------------------------------------------------
c
c inline one dimensional cubic spline interpolation
c
      HERMZ(F1,F2,FP1,FP2) = (F2*DEL1+F1*DEL2)/DELS -
     +                       DEL1*DEL2* (FP2* (DEL1+DELS)+
     +                       FP1* (DEL2+DELS))/ (6.D0*DELS)
c
c inline one dimensional spline under tension interpolation
c
      HERMNZ(F1,F2,FP1,FP2,SIGMAP) = (F2*DEL1+F1*DEL2)/DELS +
     +                               (FP2*DEL1* (SINHM1-SINHMS)+
     +                               FP1*DEL2* (SINHM2-SINHMS))/
     +                               (SIGMAP*SIGMAP*DELS* (1.D0+SINHMS))
c
c denormalize tension factor in x and y direction
c
      SIGMAX = ABS(SIGMA)*DBLE(M-1)/ (X(M)-X(1))
      SIGMAY = ABS(SIGMA)*DBLE(N-1)/ (Y(N)-Y(1))
c
c determine y interval
c
      JM1 = INTRVLDP(YY,Y,N)
      J = JM1 + 1
c
c determine x interval
c
      IM1 = INTRVLDP(XX,X,M)
      I = IM1 + 1
      DEL1 = YY - Y(JM1)
      DEL2 = Y(J) - YY
      DELS = Y(J) - Y(JM1)
      IF (SIGMAY.NE.0.D0) GO TO 1
c
c perform four interpolations in y-direction
c
      ZIM1 = HERMZ(Z(I-1,J-1),Z(I-1,J),ZP(I-1,J-1,1),ZP(I-1,J,1))
      ZI = HERMZ(Z(I,J-1),Z(I,J),ZP(I,J-1,1),ZP(I,J,1))
      ZXXIM1 = HERMZ(ZP(I-1,J-1,2),ZP(I-1,J,2),ZP(I-1,J-1,3),
     +         ZP(I-1,J,3))
      ZXXI = HERMZ(ZP(I,J-1,2),ZP(I,J,2),ZP(I,J-1,3),ZP(I,J,3))
      GO TO 2
    1 CALL SNHCSHDP(SINHM1,DUMMY,SIGMAY*DEL1,-1)
      CALL SNHCSHDP(SINHM2,DUMMY,SIGMAY*DEL2,-1)
      CALL SNHCSHDP(SINHMS,DUMMY,SIGMAY*DELS,-1)
      ZIM1 = HERMNZ(Z(I-1,J-1),Z(I-1,J),ZP(I-1,J-1,1),ZP(I-1,J,1),
     +       SIGMAY)
      ZI = HERMNZ(Z(I,J-1),Z(I,J),ZP(I,J-1,1),ZP(I,J,1),SIGMAY)
      ZXXIM1 = HERMNZ(ZP(I-1,J-1,2),ZP(I-1,J,2),ZP(I-1,J-1,3),
     +         ZP(I-1,J,3),SIGMAY)
      ZXXI = HERMNZ(ZP(I,J-1,2),ZP(I,J,2),ZP(I,J-1,3),ZP(I,J,3),SIGMAY)
c
c perform final interpolation in x-direction
c
    2 DEL1 = XX - X(IM1)
      DEL2 = X(I) - XX
      DELS = X(I) - X(IM1)
      IF (SIGMAX.NE.0.D0) GO TO 3
      SURF2DP = HERMZ(ZIM1,ZI,ZXXIM1,ZXXI)
      RETURN
    3 CALL SNHCSHDP(SINHM1,DUMMY,SIGMAX*DEL1,-1)
      CALL SNHCSHDP(SINHM2,DUMMY,SIGMAX*DEL2,-1)
      CALL SNHCSHDP(SINHMS,DUMMY,SIGMAX*DELS,-1)
      SURF2DP = HERMNZ(ZIM1,ZI,ZXXIM1,ZXXI,SIGMAX)
      RETURN
      END

C
C	$Id: gxmdef.f,v 1.4 2008-07-27 00:21:03 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GXMDEF
C
C  Set all the current values to default.
C
      include 'trdefl.h'
      include 'trstat.h'
C
      INTEGER  II, TLNCOL, TTXCOL, TFLCOL
C
C  Set the default polyline information.
C
      POLIDX = POLIDF
      LINTYP = LINTDF
      LINWTH = LINWDF
      TLNCOL = TLNCDF
C
C  Set the default polymarker information.
C
      MARIDX = MARIDF
      MARTYP = MARTDF
      MARSIZ = MARSDF
C
C  Set the default TEXT information.
C
      HORIZ  = HORIDF
      VERT   = VERTDF
      PATH   = PATHDF
      CHIGHT = CHIGDF
      XU = XUDF
      YU = YUDF
      XB = XBDF
      YB = YBDF
      TXTIDX = TXTIDF
      TTXCOL = TTXCDF
      TXTPRE = TXTPDF
      CEXPN  = CEXPDF
      CSPACE = CSPADF
C
C  Set the default POLYGON information.
C
      FILIDX = FILIDF
      INTSTL = INTSDF
      HATIDX = HATIDF
      PATIDX = PATIDF
      FILRPT(1) = FILRDF(1)
      FILRPT(2) = FILRPT(2)
      TFLCOL = TFLCDF
      FILCOL = TFLCOL
      TXTCOL = TTXCOL
      LINCOL = TLNCOL
C
C  Set the aspect source flags.
C
      DO 160 II=1,ASFMAX
        ASFSRF(II) = ASFSDF(II)
 160  CONTINUE
C
      RETURN
      END

C
C $Id: agpwrt.f,v 1.6 2008-07-27 00:14:35 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE AGPWRT (XPOS,YPOS,CHRS,NCHS,ISIZ,IORI,ICEN)
C
      CHARACTER*(*) CHRS
C
C This routine just passes its arguments along to the character-drawing
C routine PWRIT, in the system plot package.  By substituting his/her
C own version of AGPWRT, the user can cause a fancier character-drawer
C to be used.
C
      CALL PWRIT (XPOS,YPOS,CHRS,NCHS,ISIZ,IORI,ICEN)
C
C Done.
C
      RETURN
C
      END

C
C $Id: WORKSTATIONF.f,v 1.1 2001-10-09 00:18:38 haley Exp $
C
C****************************************************************
C                                                               *
C                       Copyright (C)  1994                     *
C       University Corporation for Atmospheric Research         *
C                       All Rights Reserved                     *
C                                                               *
C****************************************************************
C
C      File:            WORKSTATION.f
C
C      Author:          Jeff W. Boote
C                       National Center for Atmospheric Research
C                       PO 3000, Boulder, Colorado
C
C      Date:            Fri Apr 15 16:57:55 MDT 1994
C
C      Description:     
C
      subroutine nhlfupdateworkstation(idwork,ierr)
        call nhlpfupdateworkstation(idwork,ierr)
      end
      subroutine nhlfclearworkstation(idwork,ierr)
        call nhlpfclearworkstation(idwork,ierr)
      end
      subroutine nhlfframe(id_work,ierr)
        call nhlpfframe(id_work,ierr)
      end
      subroutine nhlfsetcolor(id_work,index,rred,rgreen,rblue,ierr)
        call nhlpfsetcolor(id_work,index,rred,rgreen,rblue,ierr)
      end
      subroutine nhlffreecolor(id_work,index,ierr)
        call nhlpffreecolor(id_work,index,ierr)
      end
      subroutine nhlfnewcolor(id_work,rred,rgreen,rblue,indx_ret)
        call nhlpfnewcolor(id_work,rred,rgreen,rblue,indx_ret)
      end
      subroutine nhlfgetgksci(id_work,indx_hlu,indx_gks_ret)
        call nhlpfgetgksci(id_work,indx_hlu,indx_gks_ret)
      end
      subroutine nhlfisallocatedcolor(id_work,indx,iret)
        call nhlpfisallocatedcolor(id_work,indx,iret)
      end
      subroutine nhlfnewmarker(id_work,marker,xoff,yoff,aspadj,sizeadj,
     %  indx_ret)

        integer id_work,indx_ret
        character*(*) marker
        real xoff,yoff,aspadj,sizeadj

        call nhlpfnewmarker(id_work,marker,len(marker),xoff,yoff,aspadj,
     %          sizeadj,indx_ret)
      end
      subroutine nhlfsetmarker(id_work,indx,marker,xoff,yoff,aspadj,
     %  sizeadj,ierr)

        integer id_work,indx,ierr
        character*(*) marker
        real xoff,yoff,aspadj,sizeadj

        call nhlpfsetmarker(id_work,indx,marker,len(marker),xoff,yoff,
     %          aspadj,sizeadj,indx_ret)
      end
      subroutine nhlfisworkstation(id,istat)

        integer id,istat
        call nhlpfisworkstation(id,istat)
      end

C
C $Id: slgeti.f,v 1.6 2008-07-27 00:17:26 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE SLGETI (PNAM,IVAL)
C
C Get in IVAL the integer value of the STITLE parameter named PNAM.
C
        CHARACTER*(*) PNAM
C
C Check for an uncleared prior error.
C
        IF (ICFELL('SLGETI - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C Call SLGETR to obtain the real value of the parameter and then
C return the integer portion of that.
C
        CALL SLGETR (PNAM,RVAL)
        IF (ICFELL('SLGETI',2).NE.0) RETURN
        IVAL=INT(RVAL)
C
C Done.
C
        RETURN
C
      END

C
C	$Id: gtnum.f,v 1.4 2008-07-27 00:17:21 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
C============================================================
C                       GTNUM
C============================================================
      SUBROUTINE GTNUM (IDPC,N,II,NUM)
C
C EXTRACTS AN OPTIONALLY SIGNED INTEGER FROM CHARACTER STRING IDPC.
C
C ON ENTRY:
C   IDPC - A character string
C   N -    The number of characters in IDPC
C   II -   Pointer to the character preceding a possible integer
C   NUM -  can have any value
C
C ON EXIT:
C   IDPC - UNCHANGED
C   N    - UNCHANGED
C   NUM  - 1) IF THE (II+1)-TH CHARACTER IN IDPC IS THE FIRST CHARACTER
C             IN A SUBSTRING REPRESENTING A SIGNED INTEGER, THEN THE
C             VALUE OF THIS INTEGER
C          2) OTHERWISE 0
C   II   - 1) IF AN INTEGER WAS FOUND THEN II POINTS
C             TO THE LAST CHARACTER OF THE INTEGER
C          2) OTHERWISE  unchanged
C
C CALLS
C   GTSIGN
C   GTDGTS
C
C CALLED BY
C   PWRITX
C
C ASSUMPTION
C   THE REPRESENTATION OF DIGITS IN THE MACHINE IS ORDERED AND COMPACT.
C
C
      CHARACTER*(*) IDPC
C
C
C **********************************************************************
C
C LOCAL VARIABLES
C
C BASE   - A string representing the base of the number to be extracted
C ISIN =  1  Indicates the integer is positive ( sign = '+' or no sign)
C      = -1  Indicates the integer began with a negative sign
C
C **********************************************************************
C
C
C THE BASE OF THE NUMBER TO BE EXTRACTED.
C
      CHARACTER*2 BASE
      BASE = '10'
C
      ISIN = 1
      NUM  = 0
C                    Point to the first possible sign or digit
      II = II + 1
C                    If at least two characters, check for a sign
      IF (II .LT. N) THEN
           CALL GTSIGN(IDPC,II,ISIN)
      ENDIF
C                    If it still may be a number, find the value of
C                    the string of digits.
      IF (ISIN .NE. 0) THEN
           CALL GTDGTS(IDPC,II,N,BASE,NUM)
      ENDIF
C
C                    Compute the value of the signed number
      NUM = NUM*ISIN
C                    Point to the last digit or reset to initial value
      II = II - 1
C
C
      RETURN
      END

C NCLFORTSTART
      SUBROUTINE DRELHUMI(P,TK,QW, RH)
      IMPLICIT NONE
C NCL: qw = relhum_ice(p:numeric,tk:numeric,qw:numeric)

c"Improved Magnus' Form Approx. of Saturation Vapor pressure"
c Oleg A. Alduchov and Robert E. Eskridge
c  http://www.osti.gov/scitech/servlets/purl/548871/
c  One of Three best approx for +50 to -80 C max relative errors of (0.337/0.823) ?

c input
      DOUBLE PRECISION P,TK,QW
c output
      DOUBLE PRECISION RH
c NCLEND

c computes rh (relative humidity) from p, t and qw (mixing ratio)

c definition of mixing ratio
c if,
c    es  - is the saturation mixing ratio
c    ep  - is the ratio of the molecular weights of water vapor to
c          dry air
c    p   - is the atmospheric pressure
c    rh  - is the relative humidity (given as a percent)

c    rh =  100*  q / ( (ep*es)/(p-es) )

c input-
c    p      - pressure (Pa) (this function was originally written for 
c             hPa/mb, so we have to do conversion below)
c    tk     - temperature (k)
c    qw     - mixing ratio (kg/kg)

c output-
c    rh     - relative humidity as %

c local
      DOUBLE PRECISION T0,EP,ONEMEP,ES0,A,B,EST,QST
      DATA T0,EP,ONEMEP,ES0,A,B/273.15D0,0.622D0,0.378D0,6.1128D0,
     +     22.571D0,273.71D0/

      EST = ES0*EXP((A* (TK-T0))/ ((TK-T0)+B))
      QST = (EP*EST)/ ((P*0.01D0)-ONEMEP*EST)
c                                    mix ratio
      RH =  100* (QW / QST)

      RETURN
      END

      SUBROUTINE HLUGPROJ(PHI0, LAMBDA0, PHI, LAMBDA, X, Y)
C
C  Find the projection onto the plane tangent to the globe at
C  (PHI0,LAMBDA0) of the point on the globe (PHI,LAMBDA).
C  The projected point is returned in Cartesian coordinate
C  (X,Y).
C
      DOUBLE PRECISION PHI0, LAMBDA0, PHI, LAMBDA, X, Y
      DOUBLE PRECISION SIN0, COS0, SINP, COSP, SIND, COSD, DENOM
      DOUBLE PRECISION D2R
      PARAMETER (D2R = 0.017453292519943D0)
C
      SIN0 = SIN(D2R*PHI0)
      COS0 = COS(D2R*PHI0)
      SINP = SIN(D2R*PHI)
      COSP = COS(D2R*PHI)
      SIND = SIN(D2R*(LAMBDA-LAMBDA0))
      COSD = COS(D2R*(LAMBDA-LAMBDA0))
      DENOM = SIN0*SINP + COS0*COSP*COSD
      X = (COSP*SIND)/DENOM
      Y = (COS0*SINP - SIN0*COSP*COSD)/DENOM
C
      RETURN
      END

C NCLFORTSTART
      subroutine xy2pdf77(nxy,x,y, xmsg,ymsg, nby, mbx, pdf
     *                   ,mbxp1,nbyp1,binxbnd, binybnd,ipcnt,ier)
      implicit none
      integer  nxy, nby, mbx, mbxp1, nbyp1, ipcnt,ier
      double precision x(nxy), y(nxy), xmsg, ymsg
     *                ,binxbnd(mbxp1), binybnd(nbyp1)
      double precision pdf(mbx,nby)
C NCLEND
      integer m, n, mb, nb, kxy, unit, msgflg 

      ier = 0
      do nb=1,nby
        do mb=1,mbx
           pdf(mb,nb) = 0.0d0
        end do
      end do

      kxy = 0
      do n=1,nxy 
         if (x(n).ne.xmsg .and. y(n).ne.ymsg) kxy = kxy + 1
      end do

c Valid data check

      if (kxy.eq.0) then
          ier = 1
          return
      end if

c Very large arrays can result in slow execution times. 
c .   To minimize unnecessary do loop checks, see if missing
c .   values are present.

      msgflg = 1
      if (kxy.eq.nxy) msgflg = 0

c Binning

      if (msgflg.eq.1) then
          do nb=1,nby
            do mb=1,mbx
              do n=1,nxy 
                 if (x(n).ne.xmsg .and. y(n).ne.ymsg) then
                     if (x(n).ge.binxbnd(mb)  .and. 
     *                   x(n).lt.binxbnd(mb+1).and. 
     *                   y(n).ge.binybnd(nb)  .and.
     *                   y(n).lt.binybnd(nb+1)) then 
                         pdf(mb,nb) = pdf(mb,nb) + 1
                     end if
                 end if
              end do
            end do
          end do
      else
          do nb=1,nby
            do mb=1,mbx
               do n=1,nxy 
                  if (x(n).ge.binxbnd(mb)  .and. 
     *                x(n).lt.binxbnd(mb+1).and. 
     *                y(n).ge.binybnd(nb)  .and.
     *                y(n).lt.binybnd(nb+1)) then 
                      pdf(mb,nb) = pdf(mb,nb) + 1
                  end if
               end do
            end do
          end do
      end if

c change return units to % if flag set

      unit = 1
      if (ipcnt.eq.1) then
          unit = 100
      end if

      do nb=1,nby
        do mb=1,mbx
           pdf(mb,nb) = unit*(pdf(mb,nb)/kxy)
        end do
      end do

      return
      end

C
C	$Id: conrec.f,v 1.6 2008-07-27 00:16:56 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CONREC (Z,L,M,N,FLO,HI,FINC,NSET,NHI,NDOT)
C
C     DIMENSION OF           Z(L,N)
C     ARGUMENTS
C
C     PURPOSE                CONREC draws a contour map from data stored
C                            in a rectangular array, labeling the lines.
C
C     USAGE                  If the following assumptions are met, use
C
C                              CALL EZCNTR (Z,M,N)
C
C                              ASSUMPTIONS:
C                                  --All of the array is to be contoured.
C                                  --Contour levels are picked
C                                    internally.
C                                  --Contouring routine picks scale
C                                    factors.
C                                  --Highs and lows are marked.
C                                  --Negative lines are drawn with a
C                                    dashed line pattern.
C                                  --EZCNTR calls FRAME after drawing the
C                                    contour map.
C
C                            If these assumptions are not met, use
C
C                              CALL CONREC (Z,L,M,N,FLO,HI,FINC,NSET,
C                                           NHI,NDOT)
C
C     ARGUMENTS
C
C     ON INPUT               Z
C     FOR EZCNTR               M by N array to be contoured.
C
C                            M
C                              First dimension of Z.
C
C                            N
C                              Second dimension of Z.
C
C     ON OUTPUT              All arguments are unchanged.
C     FOR EZCNTR
C
C     ON INPUT               Z
C     FOR CONREC               The (origin of the) array to be
C                              contoured.  Z is dimensioned L by N.
C
C                            L
C                              The first dimension of Z in the calling
C                              program.
C
C                            M
C                              The number of data values to be contoured
C                              in the X-direction (the first subscript
C                              direction).  When plotting an entire
C                              array, L = M.
C
C                            N
C                              The number of data values to be contoured
C                              in the Y-direction (the second subscript
C                              direction).
C
C                            FLO
C                              The value of the lowest contour level.
C                              If FLO = HI = 0., a value rounded up from
C                              the minimum Z is generated by CONREC.
C
C                            HI
C                              The value of the highest contour level.
C                              If HI = FLO = 0., a value rounded down
C                              from the maximum Z is generated by
C                              CONREC.
C
C                            FINC
C                              > 0  Increment between contour levels.
C                              = 0  A value, which produces between 10
C                                   and 30 contour levels at nice values,
C                                   is generated by CONREC.
C                              < 0  The number of levels generated by
C                                   CONREC is ABS(FINC).
C
C                            NSET
C                              Flag to control scaling.
C                              = 0  CONREC automatically sets the
C                                   window and viewport to properly
C                                   scale the frame to the standard
C                                   configuration.
C                                   The GRIDAL entry PERIM is
C                                   called and tick marks are placed
C                                   corresponding to the data points.
C                              > 0  CONREC assumes that the user
C                                   has set the window and viewport
C                                   in such a way as to properly
C                                   scale the plotting
C                                   instructions generated by CONREC.
C                                   PERIM is not called.
C                              < 0  CONREC generates coordinates so as
C                                   to place the (untransformed) contour
C                                   plot within the limits of the
C                                   user's current window and
C                                   viewport.  PERIM is not called.
C
C                            NHI
C                              Flag to control extra information on the
C                              contour plot.
C                              = 0  Highs and lows are marked with an H
C                                   or L as appropriate, and the value
C                                   of the high or low is plotted under
C                                   the symbol.
C                              > 0  The data values are plotted at
C                                   each Z point, with the center of
C                                   the string indicating the data
C                                   point location.
C                              < 0  Neither of the above.
C
C                            NDOT
C                              A 10-bit constant designating the desired
C                              dashed line pattern.
C                              If ABS(NDOT) = 0, 1, or 1023, solid lines
C                              are drawn.
C                              > 0 NDOT pattern is used for all lines.
C                              < 0 ABS(NDOT) pattern is used for nega-
C                                tive-valued contour lines, and solid is
C                                used for positive-valued contours.
C                                CONREC converts NDOT
C                                to a 16-bit pattern and DASHDB is used.
C                                See DASHDB comments in the DASHLINE
C                                documentation for details.
C
C
C
C     ON OUTPUT              All arguments are unchanged.
C     FOR CONREC
C
C
C     ENTRY POINTS           CONREC, CLGEN, REORD, STLINE, CRDRLN,
C                            MINMAX, PNTVAL, CALCNT, EZCNTR, CONBD,
C                            CONBDX
C
C     COMMON BLOCKS          INTPR, RECINT, CONRE1, CONRE2, CONRE3,
C                            CONRE4,CONRE5
C
C     REQUIRED LIBRARY       Standard version: DASHCHAR, which at
C     ROUTINES               NCAR is loaded by default.
C                            Smooth version: DASHSMTH which must be
C                            requested at NCAR.
C                            Both versions require  GRIDAL, the
C                            ERPRT77 package, and the SPPS.
C
C     REQUIRED GKS LEVEL     0A
C
C     I/O                    Plots contour map.
C
C     PRECISION              Single
C
C     LANGUAGE               FORTRAN 77
C
C     HISTORY                Replaces old contouring package called
C                            CALCNT at NCAR.
C
C     ALGORITHM              Each line is followed to completion.  Points
C                            along a line are found on boundaries of the
C                            (rectangular) cells. These points are
C                            connected by line segments using the
C                            software dashed line package, DASHCHAR.
C                            DASHCHAR is also used to label the
C                            lines.
C
C     NOTE                   To draw non-uniform contour levels, see
C                            the comments in CLGEN.  To make special
C                            modifications for specific needs see the
C                            explanation of the internal parameters
C                            below.
C
C     TIMING                 Varies widely with size and smoothness of
C                            Z.
C
C     INTERNAL PARAMETERS    NAME   DEFAULT         FUNCTION
C                            ----   -------         --------
C
C                            ISIZEL   1      Size of line labels,
C                                            as per the size definitions
C                                            given in the SPPS
C                                            documentation for WTSTR.
C
C                            ISIZEM   2      size of labels for minimums
C                                            and maximums,
C                                            as per the size definitions
C                                            given in the SPPS
C                                            documentation for WTSTR.
C
C                            ISIZEP   0      Size of labels for data
C                                            point values as per the size
C                                            definitions given in the SPPS
C                                            documentation for WTSTR.
C
C                            NLA      16     Approximate number of
C                                            contour levels when
C                                            internally generated.
C
C                            NLM      40     Maximum number of contour
C                                            levels.  If this is to be
C                                            increased, the dimensions
C                                            of CL and RWORK in CONREC
C                                            must be increased by the
C                                            same amount.
C
C                            XLT      .05    Left hand edge of the plot
C                                            (0.0 is the left edge of
C                                            the frame and 1.0 is the
C                                            right edge of the frame.)
C
C                            YBT      .05    Bottom edge of the plot
C                                            (0.0 is the bottom of the
C                                            frame and 1.0 is the top
C                                            of the frame.)
C
C                            SIDE     0.9    Length of longer edge of
C                                            plot (see also EXT).
C
C                            NREP     6      Number of repetitions of
C                                            the dash pattern between
C                                            line labels.
C
C                            NCRT     4      Number of CRT units per
C                                            element (bit) in the dash
C                                            pattern.
C
C                            ILAB     1      Flag to control the drawing
C                                            of line labels.
C                                            . ILAB non-zero means label
C                                              the lines.
C                                            . ILAB = 0 means do not
C                                              label the lines.
C
C                            NULBLL   3      Number of unlabeled lines
C                                            between labeled lines.  For
C                                            example, when NULBLL = 3,
C                                            every fourth level is
C                                            labeled.
C
C                            IOFFD    0      Flag to control
C                                            normalization of label
C                                            numbers.
C                                            . IOFFD = 0 means include
C                                              decimal point when
C                                              possible (do not
C                                              normalize unless
C                                              required).
C                                            . IOFFD non-zero means
C                                              normalize all label
C                                              numbers and output a
C                                              scale factor in the
C                                              message below the graph.
C
C                            EXT      .25    Lengths of the sides of the
C                                            plot are proportional to M
C                                            and N (when CONREC sets
C                                            the window and viewport).
C                                            In extreme cases, when
C                                            MIN(M,N)/MAX(M,N) is less
C                                            than EXT, CONREC
C                                            produces a square plot.
C
C                            IOFFP      0    Flag to control special
C                                            value feature.
C                                            . IOFFP = 0 means special
C                                              value feature not in use.
C                                            . IOFFP non-zero means
C                                              special value feature in
C                                              use.  (SPVAL is set to the
C                                              special value.)  Contour
C                                              lines will then be
C                                              omitted from any cell
C                                              with any corner equal to
C                                              the special value.
C
C                            SPVAL    0.     Contains the special value
C                                            when IOFFP is non-zero.
C
C                            IOFFM    0      Flag to control the message
C                                            below the plot.
C                                            . IOFFM = 0  if the message
C                                              is to be plotted.
C                                            . IOFFM non-zero if the
C                                              message is to be omitted.
C
C                            ISOLID   1023   Dash pattern for
C                                            non-negative contour lines.
C
C
      SAVE
      CHARACTER*1     IGAP       ,ISOL       ,RCHAR
      CHARACTER       ENCSCR*22  ,IWORK*126
      DIMENSION       LNGTHS(5)  ,HOLD(5)    ,WIND(4),VIEW(4),RECT(4)
      DIMENSION       Z(L,N)     ,CL(40)     ,RWORK(40)  ,LASF(13)
      COMMON /INTPR/ PAD1, FPART, PAD(8)
      COMMON /CONRE1/ IOFFP      ,SPVAL
      COMMON /CONRE3/ IXBITS     ,IYBITS
      COMMON /CONRE4/ ISIZEL     ,ISIZEM     ,ISIZEP     ,NREP       ,
     1                NCRT       ,ILAB       ,NULBLL     ,IOFFD      ,
     2                EXT        ,IOFFM      ,ISOLID     ,NLA        ,
     3                NLM        ,XLT        ,YBT        ,SIDE
      COMMON /CONRE5/ SCLY
      COMMON /RECINT/ IRECMJ     ,IRECMN     ,IRECTX
      DATA  LNGTHS(1),LNGTHS(2),LNGTHS(3),LNGTHS(4),LNGTHS(5)
     1      /  12,       3,        20,       9,        17       /
      DATA  ISOL, IGAP /'$', ''''/
C
C ISOL AND IGAP (DOLLAR-SIGN AND APOSTROPHE) ARE USED TO CONSTRUCT PAT-
C TERNS PASSED TO ROUTINE DASHDC IN THE SOFTWARE DASHED-LINE PACKAGE.
C
C Do a call forcing a BLOCKDATA to be loaded from a binary library.
C
      CALL CONBD
C
C THE FOLLOWING CALL IS FOR GATHERING STATISTICS ON LIBRARY USE AT NCAR
C
      CALL Q8QST4 ('GRAPHX','CONREC','CONREC','VERSION 01')
C
C NONSMOOTHING VERSION
C
C
C
C  CALL RESET FOR COMPATIBILITY WITH ALL DASH ROUTINES(EXCEPT DASHLINE)
C
      CALL RESET
C
C  GET NUMBER OF BITS IN INTEGER ARITHMETIC
C
      IARTH = I1MACH(8)
      IXBITS = 0
      DO 101 I=1,IARTH
         IF (M .LE. (2**I-1)) GO TO 102
         IXBITS = I+1
  101 CONTINUE
  102 IYBITS = 0
      DO 103 I=1,IARTH
         IF (N .LE. (2**I-1)) GO TO 104
         IYBITS = I+1
  103 CONTINUE
  104 IF ((IXBITS*IYBITS).GT.0 .AND. (IXBITS+IYBITS).LE.24) GO TO 105
C
C REPORT ERROR NUMBER ONE
C
      IWORK =    'CONREC  - DIMENSION ERROR - M*N .GT. (2**IARTH)    M =
     +            N = '
      WRITE (IWORK(56:62),'(I6)') M
      WRITE (IWORK(73:79),'(I6)') N
      CALL SETER( IWORK, 1, 1 )
      RETURN
  105 CONTINUE
C
C INQUIRE CURRENT TEXT AND LINE COLOR INDEX
C
      CALL GQTXCI ( IERR, ITXCI )
      CALL GQPLCI ( IERR, IPLCI )
C
C Set requested text color.
C
      CALL GSTXCI(IRECTX)
C
C SET LINE AND TEXT ASF TO INDIVIDUAL
C
      CALL GQASF ( IERR, LASF )
      LSV3  = LASF(3)
      LSV10 = LASF(10)
      LASF(3)  = 1
      LASF(10) = 1
      CALL GSASF ( LASF )
C
      GL = FLO
      HA = HI
      GP = FINC
      MX = L
      NX = M
      NY = N
      IDASH = NDOT
      NEGPOS = SIGN(1,IDASH)
      IDASH = ABS(IDASH)
      IF (IDASH.EQ.0 .OR. IDASH.EQ.1) IDASH = ISOLID
C
C SET CONTOUR LEVELS.
C
      CALL CLGEN (Z,MX,NX,NY,GL,HA,GP,NLA,NLM,CL,NCL,ICNST)
C
C FIND MAJOR AND MINOR LINES
C
      IF (ILAB .NE. 0) CALL REORD (CL,NCL,RWORK,NML,NULBLL+1)
      IF (ILAB .EQ. 0) NML = 0
C
C Save the current SET parameters.
C
      CALL GETSET (VIEW(1),VIEW(2),VIEW(3),VIEW(4),
     +             WIND(1),WIND(2),WIND(3),WIND(4),IOLLS)
C
C SET UP SCALING
C
      CALL GETUSV ( 'YF' , IYVAL )
      SCLY = 1.0 / ISHIFT ( 1, 15 - IYVAL )
C
      IF (NSET) 106,107,111
C
  106 X1 = VIEW(1)
      X2 = VIEW(2)
      Y1 = VIEW(3)
      Y2 = VIEW(4)
C
C
C
C
C
C DEFINE NORMALIZATION TRANS AND LOG SCALING
C
      CALL SET(X1, X2, Y1, Y2, 1.0, REAL(NX), 1.0, REAL(NY), 1)
      GO TO 111
  107 CONTINUE
      X1 = XLT
      X2 = XLT+SIDE
      Y1 = YBT
      Y2 = YBT+SIDE
      X3 = NX
      Y3 = NY
      IF (MIN(X3,Y3)/MAX(X3,Y3) .LT. EXT) GO TO 110
      IF (NX-NY) 108,110,109
  108 X2 = SIDE*X3/Y3+XLT
      GO TO 110
  109 Y2 = SIDE*Y3/X3+YBT
C
C
C
C
C
C DEFINE NORMALIZATION TRANS 1 AND LOG SCALING
C
  110 CALL SET(X1,X2,Y1,Y2,1.0,X3,1.0,Y3,1)
C
C DRAW PERIMETER
C
      CALL PERIM (NX-1,1,NY-1,1)
  111 IF (ICNST .NE. 0) GO TO 124
C
C SET UP LABEL SCALING
C
      IOFFDT = IOFFD
      IF (GL.NE.0.0 .AND. (ABS(GL).LT.0.1 .OR. ABS(GL).GE.1.E5))
     1    IOFFDT = 1
      IF (HA.NE.0.0 .AND. (ABS(HA).LT.0.1 .OR. ABS(HA).GE.1.E5))
     1    IOFFDT = 1
      ASH = 10.**(3-INT(ALOG10(MAX(ABS(GL),ABS(HA),ABS(GP)))
     1                                                  -4999.999)-5000)
      IF (IOFFDT .EQ. 0) ASH = 1.
      IF (IOFFM .NE. 0) GO TO 115
      IWORK ='CONTOUR FROM              TO              CONTOUR INTERVAL
     1 OF              PT(3,3)=              LABELS SCALED BY'
      HOLD(1) = GL
      HOLD(2) = HA
      HOLD(3) = GP
      HOLD(4) = Z(3,3)
      HOLD(5) = ASH
      NCHAR = 0
      DO 114 I=1,5
         WRITE ( ENCSCR, '(G13.5)' ) HOLD(I)
         NCHAR = NCHAR+LNGTHS(I)
         DO 113 J=1,13
            NCHAR = NCHAR+1
            IWORK(NCHAR:NCHAR) = ENCSCR(J:J)
  113    CONTINUE
  114 CONTINUE
      IF (ASH .EQ. 1.) NCHAR = NCHAR-13-LNGTHS(5)
C
C WRITE TITLE
C
C
      CALL GQCLIP (IERR,ICLP,RECT)
      CALL GSCLIP (0)
      CALL WTSTR (CFUX(.5),CFUY(.015625),IWORK(1:NCHAR),0,0,0)
      CALL GSCLIP (ICLP)
C
C
C
C
C                       * * * * * * * * * *
C                            * * * * * * * * * *
C
C
C PROCESS EACH LEVEL
C
  115 FPART = .5
C
      DO 123 I=1,NCL
         CALL PLOTIT(0,0,0)
         CALL GSPLCI ( IRECMJ )
         CONTR = CL(I)
         NDASH = IDASH
         IF (NEGPOS.LT.0 .AND. CONTR.GE.0.) NDASH = ISOLID
C
C CHANGE 10 BIT PATTERN TO 10 CHARACTER PATTERN.
C
         DO 116 J=1,10
            IBIT = IAND(ISHIFT(NDASH,(J-10)),1)
            RCHAR = IGAP
            IF (IBIT .NE. 0) RCHAR = ISOL
            IWORK(J:J) = RCHAR
  116    CONTINUE
         IF (I .GT. NML) GO TO 121
C
C SET UP MAJOR LINE (LABELED)
C
C
C NREP REPITITIONS OF PATTERN PER LABEL.
C
         NCHAR = 10
         IF (NREP .LT. 2) GO TO 119
         DO 118 J=1,10
            NCHAR = J
            RCHAR = IWORK(J:J)
            DO 117 K=2,NREP
               NCHAR = NCHAR+10
               IWORK(NCHAR:NCHAR) = RCHAR
  117       CONTINUE
  118    CONTINUE
  119    CONTINUE
C
C PUT IN LABEL.
C
         CALL ENCD (CONTR,ASH,ENCSCR,NCUSED,IOFFDT)
         DO 120 J=1,NCUSED
            NCHAR = NCHAR+1
            IWORK(NCHAR:NCHAR) = ENCSCR(J:J)
  120    CONTINUE
         GO TO 122
C
C SET UP MINOR LINE (UNLABELED).
C
  121    CONTINUE
C
C SET LINE INTENSITY TO LOW
C
         CALL GSPLCI ( IRECMN )
         NCHAR = 10
  122    CALL DASHDC ( IWORK(1:NCHAR),NCRT, ISIZEL )
C
C DRAW ALL LINES AT THIS LEVEL.
C
         CALL STLINE (Z,MX,NX,NY,CONTR)
C
  123 CONTINUE
      CALL GSPLCI(IRECMJ)
C
C FIND RELATIVE MINIMUMS AND MAXIMUMS IF WANTED, AND MARK VALUES IF
C WANTED.
C
      IF (NHI .EQ. 0) CALL MINMAX (Z,MX,NX,NY,ISIZEM,ASH,IOFFDT)
      IF (NHI .GT. 0) CALL MINMAX (Z,MX,NX,NY,ISIZEP,-ASH,IOFFDT)
      FPART = 1.
      GO TO 127
  124 CONTINUE
         IWORK = 'CONSTANT FIELD'
      WRITE( ENCSCR, '(G22.14)' ) GL
      DO 126 I=1,22
         IWORK(I+14:I+14) = ENCSCR(I:I)
  126 CONTINUE
C
C WRITE TITLE
C
      CALL GQCLIP (IERR,ICLP,RECT)
      CALL GSCLIP (0)
      CALL WTSTR (CFUX(.09765),CFUY(.48825),IWORK(1:36),3,0,-1)
      CALL GSCLIP (ICLP)
C
C RESTORE NORMALIZATION TRANS 1, LINE AND TEXT INTENSITY TO ORIGINAL
C
  127 IF (NSET.LE.0)
     +    CALL SET(VIEW(1),VIEW(2),VIEW(3),VIEW(4),
     +             WIND(1),WIND(2),WIND(3),WIND(4),IOLLS)
C
      CALL GSPLCI ( IPLCI )
      CALL GSTXCI ( ITXCI )
C
C Restore the original aspect source flags.
C
C
      LASF(3)  = LSV3
      LASF(10) = LSV10
      CALL GSASF ( LASF )
C
      RETURN
C
C
      END

      PROGRAM TEZMAP
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C OPEN GKS, OPEN WORKSTATION OF TYPE 1, ACTIVATE WORKSTATION
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C INVOKE DEMO DRIVER
C
      CALL EZMAP(IERR)
C
C DEACTIVATE AND CLOSE WORKSTATION, CLOSE GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END
C
      SUBROUTINE EZMAP (IERROR)
C
C PURPOSE                To provide a simple demonstration of
C                        the mapping utility, EZMAP.
C
C USAGE                  CALL EZMAP (IERROR)
C
C ARGUMENTS
C
C ON OUTPUT              IERROR
C                          An integer variable
C                          = 0, if the test was successful,
C                          = 1, the test was not successful.
C
C I/O                    The map dataset must be connected to a
C                        FORTRAN unit.  See the open statement in
C                        this test deck.
C
C                        If the test is successful, the message
C
C              EZMAP TEST EXECUTED--SEE PLOTS TO CERTIFY
C
C                        is printed on unit 6.  In addition, 10
C                        frames are produced on the machine graphics
C                        device.  In order to determine if the test
C                        was successful, it is necessary to examine
C                        the plots.
C
C PRECISION              Single
C
C LANGUAGE               FORTRAN 77
C
C REQUIRED ROUTINES      EZMAP, GRIDAL
C
C REQUIRED GKS LEVEL     0A
C
C ALGORITHM              TEZMAP calls routine MAPROJ once for each of
C                        the 10 types of projections:
C                          stereographic,
C                          orthographic,
C                          Lambert conformal conic with 2 standard
C                            parallels,
C                          Lambert equal area,
C                          gnomonic,
C                          azimuthal equidistant,
C                          cylindrical equidistant,
C                          Mercator,
C                          Mollweide type, and
C                          satellite view.
C
C HISTORY                Written October, 1976, main entry SUPMAP.
C                        Updated September, 1985, main entry EZMAP.
C
      DIMENSION PLM1(2),PLM2(2),PLM3(2),PLM4(2)
      COMMON /ERROR/ IFRAME, IERRR
C
      DATA PLM1,PLM2,PLM3,PLM4 /8*0.0/
C
C Define the center of a plot title string on a square grid of size
C 0. to 1.
C
      DATA TX/0.5/, TY/0.9765/
C
C Initialize the error parameter.
C
      IERRR = 0
C
C Turn on the error recovery mode.
C
      CALL ENTSR(IDUM,1)
C
C
C     Frame 1 -- The stereographic projection.
C
       IFRAME = 1
C
C Set the projection-type parameter.
C
      CALL MAPROJ('ST',80.0,-160.0,0.0)
C
C Set the limit parameters.
C
      CALL MAPSET('MA',PLM1,PLM2,PLM3,PLM4)
C
C Set the outline-dataset parameter.
C
      CALL MAPSTC('OU','PS')
C
C Draw the map.
C
      CALL MAPDRW
C
C Report any errors encountered.
C
       IF( NERRO(IERR).NE.0) CALL RPTERR
C
C Select normalization transformation 0.
C
      CALL GSELNT(0)
C
C Call PLCHLQ to write the plot title.
C
      CALL PLCHLQ(TX,TY,'EZMAP DEMONSTRATION:  STEREOGRAPHIC PROJECTION'
     +           ,16.,0.,0.)
      CALL FRAME
 10   CONTINUE
C
C
C     Frame 2 -- The orthographic projection.
C
      IFRAME = 2
C
C
C Set the projection-type parameter.
C
      CALL MAPROJ('OR',60.0,-120.0,0.0)
C
C Draw the map.
C
      CALL MAPDRW
C Report any errors encountered.
C
      IF( NERRO(IERR).NE.0) CALL RPTERR
C
C Write the title.
C
C
C Select normalization transformation 0.
C
      CALL GSELNT(0)
C
C Call PLCHLQ to write the plot title.
C
      CALL PLCHLQ(TX,TY,
     +     'EZMAP DEMONSTRATION:  ORTHOGRAPHIC PROJECTION',16.,0.,0.)
      CALL FRAME
 20   CONTINUE
C
C
C     Frame 3 -- The Lambert conformal conic projection.
C
      IFRAME = 3
C
C
C Set the projection-type, limits, and outline-dataset parameters.
C
      CALL MAPROJ('LC',45.0,-100.0,45.0)
      CALL MAPSET('CO',50.0,-130.0,20.0,-75.0)
      CALL MAPSTC('OU','US')
C
C Draw the map.
C
      CALL MAPDRW
C
C Report any errors encountered.
C
      IF( NERRO(IERR).NE.0) CALL RPTERR
C
C Select normalization transformation 0.
C
      CALL GSELNT(0)
C
C Call PLCHLQ to write the plot title.
C
      CALL PLCHLQ(TX,TY,
     +     'EZMAP DEMONSTRATION: LAMBERT CONFORMAL CONIC PROJECTION',
     +           16.,0.,0.)
      CALL FRAME
 30   CONTINUE
C
C
C     Frame 4 -- The Lambert equal area projection.
C
      IFRAME = 4
C
C Set the projection-type, limits, and outline-dataset parameters.
C
      CALL MAPROJ('LE',20.0,-40.0,0.0)
      CALL MAPSET('MA',PLM1,PLM2,PLM3,PLM4)
      CALL MAPSTC('OU','CO')
C
C Draw the map.
C
      CALL MAPDRW
C
C Report any errors encountered.
C
      IF( NERRO(IERR).NE.0) CALL RPTERR
C
C Select normalization transformation 0.
C
      CALL GSELNT(0)
C
C Call PLCHLQ to write the plot title.
C
      CALL PLCHLQ(TX,TY,
     +     'EZMAP DEMONSTRATION:  LAMBERT EQUAL AREA PROJECTION',
     +     16.,0.,0.)
      CALL FRAME
 40   CONTINUE
C
C
C     Frame 5 -- The gnomonic projection.
C
      IFRAME = 5
C
C Set the projection-type parameter.
C
      CALL MAPROJ('GN',0.0,0.0,0.0)
C
C Draw the map.
C
      CALL MAPDRW
C Report any errors encountered.
C
      IF( NERRO(IERR).NE.0) CALL RPTERR
C
C Select normalization transformation 0.
C
      CALL GSELNT(0)
C
C Call PLCHLQ to write the plot title.
C
      CALL PLCHLQ(TX,TY,'EZMAP DEMONSTRATION:  GNOMONIC PROJECTION',
     +           16.,0.,0.)
      CALL FRAME
 50   CONTINUE
C
C
C     Frame 6 -- The azimuthal equidistant projection.
C
      IFRAME = 6
C
C Set the projection-type parameter.
C
      CALL MAPROJ('AE',-20.0,40.0,0.0)
C
C Set the grid spacing.
C
      CALL MAPSTR('GR',5.0)
C
C Draw the map.
C
      CALL MAPDRW
C
C Report any errors encountered.
C
      IF( NERRO(IERR).NE.0) CALL RPTERR
C
C Select normalization transformation 0.
C
      CALL GSELNT(0)
C
C Call PLCHLQ to write the plot title.
C
      CALL PLCHLQ(TX,TY,
     +     'EZMAP DEMONSTRATION:  AZIMUTHAL EQUIDISTANT PROJECTION',
     +           16.,0.,0.)
      CALL FRAME
 60   CONTINUE
C
C
C     Frame 7 -- The cylindrical equidistant projection.
C
      IFRAME = 7
C
C Set the map projection type parameter.
C
      CALL MAPROJ('CE',-40.0,80.0,0.0)
C
C Draw the map.
C
      CALL MAPDRW
C
C Report any errors encountered.
C
      IF( NERRO(IERR).NE.0) CALL RPTERR
C
C Select normalization transformation 0.
C
      CALL GSELNT(0)
C
C Call PLCHLQ to write the plot title.
C
      CALL PLCHLQ(TX,TY,
     +     'EZMAP DEMONSTRATION:  CYLINDRICAL EQUIDISTANT PROJECTION',
     +           16.,0.,0.)
      CALL FRAME
 70   CONTINUE
C
C
C     Frame 8 -- The mercator projection.
C
      IFRAME = 8
C
C Set the map projection type parameter.
C
      CALL MAPROJ('ME',-60.0,120.0,0.0)
C
C Draw the map.
C
      CALL MAPDRW
C
C Report any errors encountered.
C
      IF( NERRO(IERR).NE.0) CALL RPTERR
C
C Select normalization transformation 0.
C
      CALL GSELNT(0)
C
C Call PLCHLQ to write the plot title.
C
      CALL PLCHLQ(TX,TY,'EZMAP DEMONSTRATION: MERCATOR PROJECTION',
     +           16.,0.,0.)
      CALL FRAME
 80   CONTINUE
C
C
C     Frame 9 -- The Mollyweide-type projection.
C
      IFRAME = 9
C
C Set the map projection type parameter.
C
      CALL MAPROJ('MO',-80.0,160.0,0.0)
C
C Draw the map.
C
      CALL MAPDRW
C
C Report any errors encountered.
C
      IF( NERRO(IERR).NE.0) CALL RPTERR
C
C Select normalization transformation 0.
C
      CALL GSELNT(0)
C
C Call PLCHLQ to write the plot title.
C
      CALL PLCHLQ(TX,TY,
     +     'EZMAP DEMONSTRATION:  MOLLWEIDE-TYPE PROJECTION',
     +     16.,0.,0.)
      CALL FRAME
 90   CONTINUE
C
C
C     Frame 10 -- The satellite view projection.
C
      IFRAME = 10
C
C Set the map projection type parameter.
C
      CALL MAPROJ('SV',0.0,-135.0,0.0)
C
C Set the satellite distance and supress grid lines.
C
      CALL MAPSTR('SA',6.631)
      CALL MAPSTI('GR',0)
C
C Draw the map.
C
      CALL MAPDRW
C
C Report any errors encountered.
C
      IF( NERRO(IERR).NE.0) CALL RPTERR
C
C Select normalization transformation 0.
C
      CALL GSELNT(0)
C
C Call PLCHLQ to write the plot title.
C
      CALL PLCHLQ(TX,TY,
     +     'EZMAP DEMONSTRATION: SATELLITE VIEW PROJECTION',16.,0.,0.)
      CALL FRAME
 100  CONTINUE
C
      IF(IERRR.EQ.0) WRITE(6,1000)
      IF(IERRR.EQ.1) WRITE(6,1001)
      IERROR = IERR
      RETURN
C
 1000 FORMAT(' EZMAP TEST EXECUTED--SEE PLOTS TO CERTIFY')
 1001 FORMAT(' EZMAP TEST UNSUCCESSFUL')
      END
      SUBROUTINE RPTERR
C
C ROUTINE TO REPORT ERROR MESSEGES
C
      COMMON /ERROR/ IFRAME,IERRR
C
      WRITE(6,1000) IFRAME
      CALL EPRIN
      WRITE(6,1001)
      CALL ERROF
      IERRR = 1
      RETURN
C
 1000 FORMAT(' ERROR IN FRAME ',I2,5X,'ERROR MESSAGE FOLLOWS:')
 1001 FORMAT(' ******',//)
      END

c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by UCAR                 .
c  .                                                             .
c  .       University Corporation for Atmospheric Research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                         SPHEREPACK                          .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c
c
c ... file ivlapgs.f
c
c     this file includes documentation and code for
c     subroutine ivlapgs
c
c ... files which must be loaded with ivlapgs.f
c
c     sphcom.f, hrfft.f, vhags.f, vhsgs.f, gaqd.f
c
c
c     subroutine ivlapgs(nlat,nlon,ityp,nt,v,w,idvw,jdvw,br,bi,cr,ci,
c    +mdbc,ndbc,wvhsgs,lvhsgs,work,lwork,ierror)
c
c     given the vector spherical harmonic coefficients (br,bi,cr,ci)
c     precomputed by subroutine vhags for a vector field (vlap,wlap),
c     subroutine ivlapgs computes a vector field (v,w) whose vector
c     laplacian is (vlap,wlap).  v,vlap are the colatitudinal
c     components and w,wlap are the east longitudinal components of
c     the vectors.  (v,w) have the same symmetry or lack of symmetry
c     about the equator as (vlap,wlap).  the input parameters ityp,
c     nt,mdbc,ndbc must have the same values used by vhags to compute
c     br,bi,cr,ci for (vlap,wlap).
c
c
c     input parameters
c
c     nlat   the number of points in the gaussian colatitude grid on the
C*PL*ERROR* Comment line too long
c            full sphere. these lie in the interval (0,pi) and are computed
C*PL*ERROR* Comment line too long
c            in radians in theta(1) <...< theta(nlat) by subroutine gaqd.
C*PL*ERROR* Comment line too long
c            if nlat is odd the equator will be included as the grid point
c            theta((nlat+1)/2).  if nlat is even the equator will be
c            excluded as a grid point and will lie half way between
c            theta(nlat/2) and theta(nlat/2+1). nlat must be at least 3.
c            note: on the half sphere, the number of grid points in the
c            colatitudinal direction is nlat/2 if nlat is even or
c            (nlat+1)/2 if nlat is odd.
c
c     nlon   the number of distinct longitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater
c            than zero. the axisymmetric case corresponds to nlon=1.
c            the efficiency of the computation is improved when nlon
c            is a product of small prime numbers.
c
C*PL*ERROR* Comment line too long
c     ityp   this parameter should have the same value input to subroutine
c            vhags to compute the coefficients br,bi,cr, and ci for the
c            vector field (vlap,wlap).  ityp is set as follows:
c
C*PL*ERROR* Comment line too long
c            = 0  no symmetries exist in (vlap,wlap) about the equator. (v,w)
C*PL*ERROR* Comment line too long
c                 is computed and stored on the entire sphere in the arrays
C*PL*ERROR* Comment line too long
c                 arrays v(i,j) and w(i,j) for i=1,...,nlat and j=1,...,nlon.
c
C*PL*ERROR* Comment line too long
c            = 1  no symmetries exist in (vlap,wlap) about the equator. (v,w)
C*PL*ERROR* Comment line too long
c                 is computed and stored on the entire sphere in the arrays
C*PL*ERROR* Comment line too long
c                 v(i,j) and w(i,j) for i=1,...,nlat and j=1,...,nlon.  the
C*PL*ERROR* Comment line too long
c                 vorticity of (vlap,wlap) is zero so the coefficients cr and
C*PL*ERROR* Comment line too long
c                 ci are zero and are not used.  the vorticity of (v,w) is
c                 also zero.
c
c
C*PL*ERROR* Comment line too long
c            = 2  no symmetries exist in (vlap,wlap) about the equator. (v,w)
C*PL*ERROR* Comment line too long
c                 is computed and stored on the entire sphere in the arrays
C*PL*ERROR* Comment line too long
c                 w(i,j) and v(i,j) for i=1,...,nlat and j=1,...,nlon.  the
C*PL*ERROR* Comment line too long
c                 divergence of (vlap,wlap) is zero so the coefficients br and
C*PL*ERROR* Comment line too long
c                 bi are zero and are not used.  the divergence of (v,w) is
c                 also zero.
c
c            = 3  wlap is antisymmetric and vlap is symmetric about the
C*PL*ERROR* Comment line too long
c                 equator. consequently w is antisymmetric and v is symmetric.
C*PL*ERROR* Comment line too long
c                 (v,w) is computed and stored on the northern hemisphere
C*PL*ERROR* Comment line too long
c                 only.  if nlat is odd, storage is in the arrays v(i,j),
C*PL*ERROR* Comment line too long
c                 w(i,j) for i=1,...,(nlat+1)/2 and j=1,...,nlon.  if nlat
c                 is even, storage is in the arrays v(i,j),w(i,j) for
c                 i=1,...,nlat/2 and j=1,...,nlon.
c
c            = 4  wlap is antisymmetric and vlap is symmetric about the
C*PL*ERROR* Comment line too long
c                 equator. consequently w is antisymmetric and v is symmetric.
C*PL*ERROR* Comment line too long
c                 (v,w) is computed and stored on the northern hemisphere
C*PL*ERROR* Comment line too long
c                 only.  if nlat is odd, storage is in the arrays v(i,j),
C*PL*ERROR* Comment line too long
c                 w(i,j) for i=1,...,(nlat+1)/2 and j=1,...,nlon.  if nlat
c                 is even, storage is in the arrays v(i,j),w(i,j) for
C*PL*ERROR* Comment line too long
c                 i=1,...,nlat/2 and j=1,...,nlon.  the vorticity of (vlap,
c                 wlap) is zero so the coefficients cr,ci are zero and
c                 are not used. the vorticity of (v,w) is also zero.
c
c            = 5  wlap is antisymmetric and vlap is symmetric about the
C*PL*ERROR* Comment line too long
c                 equator. consequently w is antisymmetric and v is symmetric.
C*PL*ERROR* Comment line too long
c                 (v,w) is computed and stored on the northern hemisphere
C*PL*ERROR* Comment line too long
c                 only.  if nlat is odd, storage is in the arrays w(i,j),
C*PL*ERROR* Comment line too long
c                 v(i,j) for i=1,...,(nlat+1)/2 and j=1,...,nlon.  if nlat
c                 is even, storage is in the arrays w(i,j),v(i,j) for
C*PL*ERROR* Comment line too long
c                 i=1,...,nlat/2 and j=1,...,nlon.  the divergence of (vlap,
c                 wlap) is zero so the coefficients br,bi are zero and
c                 are not used. the divergence of (v,w) is also zero.
c
c
c            = 6  wlap is symmetric and vlap is antisymmetric about the
C*PL*ERROR* Comment line too long
c                 equator. consequently w is symmetric and v is antisymmetric.
C*PL*ERROR* Comment line too long
c                 (v,w) is computed and stored on the northern hemisphere
C*PL*ERROR* Comment line too long
c                 only.  if nlat is odd, storage is in the arrays w(i,j),
C*PL*ERROR* Comment line too long
c                 v(i,j) for i=1,...,(nlat+1)/2 and j=1,...,nlon.  if nlat
c                 is even, storage is in the arrays w(i,j),v(i,j) for
c                 i=1,...,nlat/2 and j=1,...,nlon.
c
c            = 7  wlap is symmetric and vlap is antisymmetric about the
C*PL*ERROR* Comment line too long
c                 equator. consequently w is symmetric and v is antisymmetric.
C*PL*ERROR* Comment line too long
c                 (v,w) is computed and stored on the northern hemisphere
C*PL*ERROR* Comment line too long
c                 only.  if nlat is odd, storage is in the arrays w(i,j),
C*PL*ERROR* Comment line too long
c                 v(i,j) for i=1,...,(nlat+1)/2 and j=1,...,nlon.  if nlat
c                 is even, storage is in the arrays w(i,j),v(i,j) for
C*PL*ERROR* Comment line too long
c                 i=1,...,nlat/2 and j=1,...,nlon.  the vorticity of (vlap,
c                 wlap) is zero so the coefficients cr,ci are zero and
c                 are not used. the vorticity of (v,w) is also zero.
c
c            = 8  wlap is symmetric and vlap is antisymmetric about the
C*PL*ERROR* Comment line too long
c                 equator. consequently w is symmetric and v is antisymmetric.
C*PL*ERROR* Comment line too long
c                 (v,w) is computed and stored on the northern hemisphere
C*PL*ERROR* Comment line too long
c                 only.  if nlat is odd, storage is in the arrays w(i,j),
C*PL*ERROR* Comment line too long
c                 v(i,j) for i=1,...,(nlat+1)/2 and j=1,...,nlon.  if nlat
c                 is even, storage is in the arrays w(i,j),v(i,j) for
C*PL*ERROR* Comment line too long
c                 i=1,...,nlat/2 and j=1,...,nlon.  the divergence of (vlap,
c                 wlap) is zero so the coefficients br,bi are zero and
c                 are not used. the divergence of (v,w) is also zero.
c
c
C*PL*ERROR* Comment line too long
c     nt     nt is the number of vector fields (vlap,wlap). some computational
c            efficiency is obtained for multiple fields.  in the program
c            that calls ivlapgs, the arrays v,w,br,bi,cr and ci can be
C*PL*ERROR* Comment line too long
c            three dimensional corresponding to an indexed multiple vector
C*PL*ERROR* Comment line too long
c            field.  in this case multiple vector synthesis will be performed
c            to compute the (v,w) for each field (vlap,wlap).  the third
C*PL*ERROR* Comment line too long
c            index is the synthesis index which assumes the values k=1,...,nt.
c            for a single synthesis set nt=1.  the description of the
c            remaining parameters is simplified by assuming that nt=1 or
c            that all arrays are two dimensional.
c
c   idvw     the first dimension of the arrays w and v as it appears in
C*PL*ERROR* Comment line too long
c            the program that calls ivlapgs.  if ityp=0,1, or 2  then idvw
C*PL*ERROR* Comment line too long
c            must be at least nlat.  if ityp > 2 and nlat is even then idvw
C*PL*ERROR* Comment line too long
c            must be at least nlat/2. if ityp > 2 and nlat is odd then idvw
c            must be at least (nlat+1)/2.
c
c   jdvw     the second dimension of the arrays w and v as it appears in
c            the program that calls ivlapgs. jdvw must be at least nlon.
c
c
c   br,bi    two or three dimensional arrays (see input parameter nt)
c   cr,ci    that contain vector spherical harmonic coefficients of the
c            vector field (vlap,wlap) as computed by subroutine vhags.
c            br,bi,cr and ci must be computed by vhags prior to calling
c            ivlapgs.  if ityp=1,4, or 7 then cr,ci are not used and can
c            be dummy arguments.  if ityp=2,5, or 8 then br,bi are not
c            used and can be dummy arguments.
c
c    mdbc    the first dimension of the arrays br,bi,cr and ci as it
c            appears in the program that calls ivlapgs.  mdbc must be
c            at least min0(nlat,nlon/2) if nlon is even or at least
c            min0(nlat,(nlon+1)/2) if nlon is odd.
c
c    ndbc    the second dimension of the arrays br,bi,cr and ci as it
c            appears in the program that calls ivlapgs. ndbc must be at
c            least nlat.
c
c    wvhsgs  an array which must be initialized by subroutine vhsgsi.
c            once initialized, wvhsgsi
c            can be used repeatedly by ivlapgs as long as nlat and nlon
c            remain unchanged.  wvhsgs must not be altered between calls
c            of ivlapgs.
c
c    lvhsgs  the dimension of the array wvhsgs as it appears in the
c            program that calls ivlapgs.  let
c
c               l1 = min0(nlat,nlon/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd.
c
c            let
c
c               lsavmin = (l1*l2*(nlat+nlat-l1+1))/2+nlon+15
c
c            then lvhsgs must be greater than or equal to lsavmin
c            (see ierror=9 below).
c
c     work   a work array that does not have to be saved.
c
c     lwork  the dimension of the array work as it appears in the
c            program that calls ivlapgs. define
c
c               l2 = nlat/2                    if nlat is even or
c               l2 = (nlat+1)/2                if nlat is odd
c               l1 = min0(nlat,nlon/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            if ityp .le. 2 then
c
c               (2*nt+1)*nlat*nlon + nlat*(4*nt*l1+1)
c
c            or if ityp .gt. 2 then
c
c               (2*nt+1)*l2*nlon + nlat*(4*nt*l1+1)
c
c            will suffice as a length for lwork.
c
c     **************************************************************
c
c     output parameters
c
c
C*PL*ERROR* Comment line too long
c    v,w     two or three dimensional arrays (see input parameter nt) that
C*PL*ERROR* Comment line too long
c            contain a vector field whose vector laplacian is (vlap,wlap).
C*PL*ERROR* Comment line too long
c            w(i,j) is the east longitude and v(i,j) is the colatitudinal
c            component of the vector. v(i,j) and w(i,j) are given on the
c            sphere at the guassian colatitude theta(i) for i=1,...,nlat
C*PL*ERROR* Comment line too long
c            and east longitude lambda(j)=(j-1)*2*pi/nlon for j = 1,...,nlon.
C*PL*ERROR* Comment line too long
c            let cost and sint be the cosine and sine at colatitude theta.
C*PL*ERROR* Comment line too long
c            let d( )/dlambda  and d( )/dtheta be the first order partial
C*PL*ERROR* Comment line too long
c            derivatives in longitude and colatitude.  let sf be either v
c            or w.  define:
c
c                 del2s(sf) = [d(sint*d(sf)/dtheta)/dtheta +
c                               2            2
c                              d (sf)/dlambda /sint]/sint
c
c            then the vector laplacian of (v,w) in (vlap,wlap) satisfies
c
c                 vlap = del2s(v) + (2*cost*dw/dlambda - v)/sint**2
c
c            and
c
c                 wlap = del2s(w) - (2*cost*dv/dlambda + w)/sint**2
c
c
C*PL*ERROR* Comment line too long
c  ierror    a parameter which flags errors in input parameters as follows:
c
c            = 0  no errors detected
c
c            = 1  error in the specification of nlat
c
c            = 2  error in the specification of nlon
c
c            = 3  error in the specification of ityp
c
c            = 4  error in the specification of nt
c
c            = 5  error in the specification of idvw
c
c            = 6  error in the specification of jdvw
c
c            = 7  error in the specification of mdbc
c
c            = 8  error in the specification of ndbc
c
c            = 9  error in the specification of lvhsgs
c
c            = 10 error in the specification of lwork
c
c
c **********************************************************************
c
c     end of documentation for ivlapgs
c
c **********************************************************************
c
      SUBROUTINE DIVLAPGS(NLAT,NLON,ITYP,NT,V,W,IDVW,JDVW,BR,BI,CR,CI,
     +                   MDBC,NDBC,WVHSGS,LVHSGS,WORK,LWORK,IERROR)
      DOUBLE PRECISION V
      DOUBLE PRECISION W
      DOUBLE PRECISION BR
      DOUBLE PRECISION BI
      DOUBLE PRECISION CR
      DOUBLE PRECISION CI
      DOUBLE PRECISION WVHSGS
      DOUBLE PRECISION WORK
      DIMENSION V(IDVW,JDVW,NT),W(IDVW,JDVW,NT)
      DIMENSION BR(MDBC,NDBC,NT),BI(MDBC,NDBC,NT)
      DIMENSION CR(MDBC,NDBC,NT),CI(MDBC,NDBC,NT)
      DIMENSION WVHSGS(LVHSGS),WORK(LWORK)

      IERROR = 1
      IF (NLAT.LT.3) RETURN
      IERROR = 2
      IF (NLON.LT.1) RETURN
      IERROR = 3
      IF (ITYP.LT.0 .OR. ITYP.GT.8) RETURN
      IERROR = 4
      IF (NT.LT.0) RETURN
      IERROR = 5
      IMID = (NLAT+1)/2
      IF ((ITYP.LE.2.AND.IDVW.LT.NLAT) .OR.
     +    (ITYP.GT.2.AND.IDVW.LT.IMID)) RETURN
      IERROR = 6
      IF (JDVW.LT.NLON) RETURN
      IERROR = 7
      MMAX = MIN0(NLAT, (NLON+1)/2)
      IF (MDBC.LT.MMAX) RETURN
      IERROR = 8
      IF (NDBC.LT.NLAT) RETURN
      IERROR = 9
c
c     set minimum and verify saved workspace length
c
      IDZ = (MMAX* (NLAT+NLAT-MMAX+1))/2
      LZIMN = IDZ*IMID
      LSAVMIN = LZIMN + LZIMN + NLON + 15
      IF (LVHSGS.LT.LSAVMIN) RETURN
c
c     set minimum and verify unsaved work space length
c
      MN = MMAX*NLAT*NT
      L2 = (NLAT+1)/2
      L1 = MIN0(NLAT, (NLON+1)/2)
      IF (ITYP.LE.2) THEN
          LWKMIN = (2*NT+1)*NLAT*NLON + NLAT* (4*NT*L1+1)
      ELSE
          LWKMIN = (2*NT+1)*L2*NLON + NLAT* (4*NT*L1+1)
      END IF
      IF (LWORK.LT.LWKMIN) RETURN
      IERROR = 0
c
c     set work space pointers for vector laplacian coefficients
c
      IF (ITYP.EQ.0 .OR. ITYP.EQ.3 .OR. ITYP.EQ.6) THEN
          IBR = 1
          IBI = IBR + MN
          ICR = IBI + MN
          ICI = ICR + MN
      ELSE IF (ITYP.EQ.1 .OR. ITYP.EQ.4 .OR. ITYP.EQ.7) THEN
          IBR = 1
          IBI = IBR + MN
          ICR = IBI + MN
          ICI = ICR
      ELSE
          IBR = 1
          IBI = 1
          ICR = IBI + MN
          ICI = ICR + MN
      END IF
      IFN = ICI + MN
      IWK = IFN + NLAT
      IF (ITYP.EQ.0 .OR. ITYP.EQ.3 .OR. ITYP.EQ.6) THEN
          LIWK = LWORK - 4*MN - NLAT
      ELSE
          LIWK = LWORK - 2*MN - NLAT
      END IF
      CALL DIVLAPGS1(NLAT,NLON,ITYP,NT,V,W,IDVW,JDVW,WORK(IBR),
     +               WORK(IBI),WORK(ICR),WORK(ICI),MMAX,WORK(IFN),MDBC,
     +               NDBC,BR,BI,CR,CI,WVHSGS,LVHSGS,WORK(IWK),LIWK,
     +               IERROR)
      RETURN
      END

      SUBROUTINE DIVLAPGS1(NLAT,NLON,ITYP,NT,V,W,IDVW,JDVW,BRVW,BIVW,
     +                    CRVW,CIVW,MMAX,FNN,MDBC,NDBC,BR,BI,CR,CI,
     +                    WSAVE,LSAVE,WK,LWK,IERROR)
      DOUBLE PRECISION V
      DOUBLE PRECISION W
      DOUBLE PRECISION BRVW
      DOUBLE PRECISION BIVW
      DOUBLE PRECISION CRVW
      DOUBLE PRECISION CIVW
      DOUBLE PRECISION FNN
      DOUBLE PRECISION BR
      DOUBLE PRECISION BI
      DOUBLE PRECISION CR
      DOUBLE PRECISION CI
      DOUBLE PRECISION WSAVE
      DOUBLE PRECISION WK
      DOUBLE PRECISION FN
      DIMENSION V(IDVW,JDVW,NT),W(IDVW,JDVW,NT)
      DIMENSION FNN(NLAT),BRVW(MMAX,NLAT,NT),BIVW(MMAX,NLAT,NT)
      DIMENSION CRVW(MMAX,NLAT,NT),CIVW(MMAX,NLAT,NT)
      DIMENSION BR(MDBC,NDBC,NT),BI(MDBC,NDBC,NT)
      DIMENSION CR(MDBC,NDBC,NT),CI(MDBC,NDBC,NT)
      DIMENSION WSAVE(LSAVE),WK(LWK)
c
c     preset coefficient multiplyers
c
      DO 1 N = 2,NLAT
          FN = DBLE(N-1)
          FNN(N) = -1.0D0/ (FN* (FN+1.D0))
    1 CONTINUE
c
c     set (u,v) coefficients from br,bi,cr,ci
c
      IF (ITYP.EQ.0 .OR. ITYP.EQ.3 .OR. ITYP.EQ.6) THEN
c
c     all coefficients needed
c
          DO 2 K = 1,NT
              DO 3 N = 1,NLAT
                  DO 4 M = 1,MMAX
                      BRVW(M,N,K) = 0.0D0
                      BIVW(M,N,K) = 0.0D0
                      CRVW(M,N,K) = 0.0D0
                      CIVW(M,N,K) = 0.0D0
    4             CONTINUE
    3         CONTINUE
              DO 5 N = 2,NLAT
                  BRVW(1,N,K) = FNN(N)*BR(1,N,K)
                  BIVW(1,N,K) = FNN(N)*BI(1,N,K)
                  CRVW(1,N,K) = FNN(N)*CR(1,N,K)
                  CIVW(1,N,K) = FNN(N)*CI(1,N,K)
    5         CONTINUE
              DO 6 M = 2,MMAX
                  DO 7 N = M,NLAT
                      BRVW(M,N,K) = FNN(N)*BR(M,N,K)
                      BIVW(M,N,K) = FNN(N)*BI(M,N,K)
                      CRVW(M,N,K) = FNN(N)*CR(M,N,K)
                      CIVW(M,N,K) = FNN(N)*CI(M,N,K)
    7             CONTINUE
    6         CONTINUE
    2     CONTINUE
      ELSE IF (ITYP.EQ.1 .OR. ITYP.EQ.4 .OR. ITYP.EQ.7) THEN
c
c     vorticity is zero so cr,ci=0 not used
c
          DO 12 K = 1,NT
              DO 13 N = 1,NLAT
                  DO 14 M = 1,MMAX
                      BRVW(M,N,K) = 0.0D0
                      BIVW(M,N,K) = 0.0D0
   14             CONTINUE
   13         CONTINUE
              DO 15 N = 2,NLAT
                  BRVW(1,N,K) = FNN(N)*BR(1,N,K)
                  BIVW(1,N,K) = FNN(N)*BI(1,N,K)
   15         CONTINUE
              DO 16 M = 2,MMAX
                  DO 17 N = M,NLAT
                      BRVW(M,N,K) = FNN(N)*BR(M,N,K)
                      BIVW(M,N,K) = FNN(N)*BI(M,N,K)
   17             CONTINUE
   16         CONTINUE
   12     CONTINUE
      ELSE
c
c     divergence is zero so br,bi=0 not used
c
          DO 22 K = 1,NT
              DO 23 N = 1,NLAT
                  DO 24 M = 1,MMAX
                      CRVW(M,N,K) = 0.0D0
                      CIVW(M,N,K) = 0.0D0
   24             CONTINUE
   23         CONTINUE
              DO 25 N = 2,NLAT
                  CRVW(1,N,K) = FNN(N)*CR(1,N,K)
                  CIVW(1,N,K) = FNN(N)*CI(1,N,K)
   25         CONTINUE
              DO 26 M = 2,MMAX
                  DO 27 N = M,NLAT
                      CRVW(M,N,K) = FNN(N)*CR(M,N,K)
                      CIVW(M,N,K) = FNN(N)*CI(M,N,K)
   27             CONTINUE
   26         CONTINUE
   22     CONTINUE
      END IF
c
c     sythesize coefs into vector field (v,w)
c
      CALL DVHSGS(NLAT,NLON,ITYP,NT,V,W,IDVW,JDVW,BRVW,BIVW,CRVW,CIVW,
     +           MMAX,NLAT,WSAVE,LSAVE,WK,LWK,IERROR)
      RETURN
      END

      SUBROUTINE DEQTHECALC(QVP,TMK,PRS,ETH,MIY,MJX,MKZH)
      DOUBLE PRECISION EPS
      DOUBLE PRECISION RGAS
      DOUBLE PRECISION RGASMD
      DOUBLE PRECISION CP
      DOUBLE PRECISION CPMD
      DOUBLE PRECISION GAMMA
      DOUBLE PRECISION GAMMAMD
      DOUBLE PRECISION TLCLC1
      DOUBLE PRECISION TLCLC2
      DOUBLE PRECISION TLCLC3
      DOUBLE PRECISION TLCLC4
      DOUBLE PRECISION THTECON1
      DOUBLE PRECISION THTECON2
      DOUBLE PRECISION THTECON3
      DOUBLE PRECISION Q
      DOUBLE PRECISION T
      DOUBLE PRECISION P
      DOUBLE PRECISION E
      DOUBLE PRECISION TLCL
c
c Input variables
c Qvapor [g/kg]
      DOUBLE PRECISION QVP(MIY,MJX,MKZH)
c Temperature [K]
      DOUBLE PRECISION TMK(MIY,MJX,MKZH)
c full pressure (=P+PB) [hPa]
      DOUBLE PRECISION PRS(MIY,MJX,MKZH)
c
c Output variable
c equivalent potential temperature [K]
      DOUBLE PRECISION ETH(MIY,MJX,MKZH)
c
c parameters
      PARAMETER (EPS=0.622D0)

c J/K/kg
      RGAS = 287.04D0
c rgas_moist=rgas*(1.+rgasmd*qvp)
      RGASMD = .608D0
c J/K/kg  Note: not using Bolton's value of 1005.7
      CP = 1004.D0
c cp_moist=cp*(1.+cpmd*qvp)
      CPMD = .887D0
      GAMMA = RGAS/CP
c gamma_moist=gamma*(1.+gammamd*qvp)
      GAMMAMD = RGASMD - CPMD

      TLCLC1 = 2840.D0
      TLCLC2 = 3.5D0
      TLCLC3 = 4.805D0
      TLCLC4 = 55.D0
c K
      THTECON1 = 3376.D0
      THTECON2 = 2.54D0
      THTECON3 = .81D0
c
      DO 1000 K = 1,MKZH
          DO 1000 J = 1,MJX
              DO 1000 I = 1,MIY
                  Q = MAX(QVP(I,J,K),1.D-15)
                  T = TMK(I,J,K)
                  P = PRS(I,J,K)/100.
                  E = Q*P/ (EPS+Q)
                  TLCL = TLCLC1/ (LOG(T**TLCLC2/E)-TLCLC3) + TLCLC4
                  ETH(I,J,K) = T* (1000.D0/P)**
     +                         (GAMMA* (1.D0+GAMMAMD*Q))*
     +                         EXP((THTECON1/TLCL-THTECON2)*Q*
     +                         (1.D0+THTECON3*Q))
 1000 CONTINUE
      RETURN
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C   FFTPACK 5.0
C   Copyright (C) 1995-2004, Scientific Computing Division,
C   University Corporation for Atmospheric Research
C   Licensed under the GNU General Public License (GPL)
C
C   Authors:  Paul N. Swarztrauber and Richard A. Valent
C
C   $Id: xerfft.f,v 1.2 2006-11-21 01:10:20 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      SUBROUTINE DXERFFT(SRNAME,INFO)
C
C     .. Scalar Arguments ..
      CHARACTER*6 SRNAME
      INTEGER INFO
C
C     ..
C
C  Purpose
C  =======
C
C  XERFFT  is an error handler for library FFTPACK version 5.0 routines.
C  It is called by an FFTPACK 5.0 routine if an input parameter has an
C  invalid value.  A message is printed and execution stops.
C
C  Installers may consider modifying the STOP statement in order to
C  call system-specific exception-handling facilities.
C
C  Arguments
C  =========
C
C  SRNAME  (input) CHARACTER*6
C          The name of the routine which called XERFFT.
C
C  INFO    (input) INTEGER
C          When a single  invalid parameter in the parameter list of
C          the calling routine has been detected, INFO is the position
C          of that parameter.  In the case when an illegal combination
C          of LOT, JUMP, N, and INC has been detected, the calling
C          subprogram calls XERFFT with INFO = -1.
C
C =====================================================================
C
C     .. Executable Statements ..
C
      IF (INFO.GE.1) THEN
          WRITE (*,FMT='(A,A,A,I3,A)') ' ** On entry to ',SRNAME,
     +      ' parameter number ',INFO,' had an illegal value'
      ELSE IF (INFO.EQ.-1) THEN
          WRITE (*,FMT='(A,A,A,A)') ' ** On entry to ',SRNAME,
     +      ' parameters LOT, JUMP, N and INC are inconsistent'
      ELSE IF (INFO.EQ.-2) THEN
          WRITE (*,FMT='(A,A,A,A)') ' ** On entry to ',SRNAME,
     +      ' parameter L is greater than LDIM'
      ELSE IF (INFO.EQ.-3) THEN
          WRITE (*,FMT='(A,A,A,A)') ' ** On entry to ',SRNAME,
     +      ' parameter M is greater than MDIM'
      ELSE IF (INFO.EQ.-5) THEN
          WRITE (*,FMT='(A,A,A,A)') ' ** Within ',SRNAME,
     +      ' input error returned by lower level routine'
      ELSE IF (INFO.EQ.-6) THEN
          WRITE (*,FMT='(A,A,A,A)') ' ** On entry to ',SRNAME,
     +      ' parameter LDIM is less than 2*(L/2+1)'
      END IF
*
      STOP
*
*     End of XERFFT
*
      END

      PROGRAM CMPCLR
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Open GKS, Turn Clipping off
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Invoke demo driver
C
      CALL TCMPCLR(IWKID)
C
C Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS

      STOP
      END

      SUBROUTINE TCMPCLR(IWKID) 
C
C CMPCLR demonstrates using the color parameters in Maps
C
C Set up Maps.
C
      REAL PLIM1(2), PLIM2(2), PLIM3(2), PLIM4(2)

      DATA PLIM1 /0.,0./
      DATA PLIM2 /0.,0./
      DATA PLIM3 /0.,0./
      DATA PLIM4 /0.,0./

      CALL COLOR(IWKID)
      CALL MAPSTC ('OU - OUTLINE DATASET SELECTOR','PS')
      CALL MAPSTI ('C1 - PERIMETER COLOR',1)
      CALL MAPSTI ('C2 - GRID COLOR',2)
      CALL MAPSTI ('C3 - LABEL COLOR',3)
      CALL MAPSTI ('C4 - LIMB COLOR',4)
      CALL MAPSTI ('C5 - CONTINENTAL OUTLINE COLOR',5)
      CALL MAPSTI ('C6 - US STATE OUTLINE COLOR',6)
      CALL MAPSTI ('C7 - COUNTRY OUTLINE COLOR',7)
      CALL MAPROJ ('SV',40.,-50.,0.)
      CALL MAPSTR ('SA - SATELLITE DISTANCE',5.)
      CALL MAPSET ('MA',PLIM1,PLIM2,PLIM3,PLIM4)
C
C Initialize Maps.
C
      CALL MAPINT
C
C Draw a perimeter and outline all the countries.
C
      CALL MAPGRD
      CALL MAPLBL
      CALL MAPLOT
C
C Advance the frame.
C
      CALL FRAME
C
C Done.
C
      RETURN
      END
      SUBROUTINE COLOR(IWKID)
C
C Background color
C The background is white here for better visibility on paper
C
      CALL GSCR(IWKID,0,1.,1.,1.)
C
C Foreground colors
C
      CALL GSCR(IWKID,1,.7,0.,0.)
      CALL GSCR(IWKID,2,0.,.7,0.)
      CALL GSCR(IWKID,3,.7,.4,0.)
      CALL GSCR(IWKID,4,.3,.3,.7)
      CALL GSCR(IWKID,5,.7,0.,.7)
      CALL GSCR(IWKID,6,0.,.7,.7)
      CALL GSCR(IWKID,7,0.,0.,0.)

      RETURN
      END

C
C $Id: mdlnam.f,v 1.5 2008-07-27 00:17:07 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MDLNAM (FLNM,ILVL,IAMA)
C
        CHARACTER*(*) FLNM
        INTEGER       ILVL
        INTEGER       IAMA(*)
C
        PARAMETER (MNAI=8000)
C
C This routine, given the name, FLNM, of a file of map data in the new
C (as of 4/98) format and the level, ILVL, at which those data are to
C be used, sends the line data from the file to the area map array IAMA.
C
C The following COMMON blocks are used to share information with various
C other routines in EZMAPB or in EZMAP proper.
C
        COMMON /MAPCM2/  BLAM,BLOM,PEPS,SLAM,SLOM,UCEN,UMAX,UMIN,UOFF,
     +                   URNG,VCEN,VMAX,VMIN,VOFF,VRNG,ISSL
        DOUBLE PRECISION BLAM,BLOM,PEPS,SLAM,SLOM,UCEN,UMAX,UMIN,UOFF,
     +                   URNG,VCEN,VMAX,VMIN,VOFF,VRNG
        INTEGER          ISSL
        SAVE   /MAPCM2/
C
        COMMON /MAPCMX/  IATY(MNAI),ISCI(MNAI),IPAR(MNAI)
        INTEGER          IATY,ISCI,IPAR
        SAVE   /MAPCMX/
C
        COMMON /MAPCMY/  NAME(MNAI),FLNS
        CHARACTER*64     NAME
        CHARACTER*512    FLNS
        SAVE   /MAPCMY/
C
        COMMON /MAPCMZ/  NNMS,ILTY,IAIL,IAIR,BLAG,SLAG,BLOG,SLOG,
     +                   PNTS(200)
        INTEGER          NNMS,ILTY,IAIL,IAIR
        REAL             BLAG,SLAG,BLOG,SLOG,PNTS
        SAVE   /MAPCMZ/
C
C FLNL and FLND are character variables in which to form the names of
C files to be read (locally or in the NCAR Graphics database directory).
C
        CHARACTER*519    FLNL
        CHARACTER*1024   FLND
C
C CHRS is a buffer used to read name information.
C
        CHARACTER*1      CHRS(512)
C
C XCRA and YCRA are used to hold coordinates defining a line segment
C conveying coloring information to the area map in the degenerate
C case where no lines from the map dataset do so.
C
        REAL             XCRA(2),YCRA(2)
C
C SVOU is a character variable in which to save the value of the EZMAP
C internal parameter named 'OU'.
C
        CHARACTER*2      SVOU
C
C Declare other local variables.
C
        DOUBLE PRECISION RLAT,RLON,UVAL,VVAL
        INTEGER          I,IAID,IAM5,IDIV,IFDE,IGI1,INTF,IOAL,IOAR,ISTA,
     +                   IWGF,J,LFND,LFNL,LFNM,LONM,MCHR,NCHR,NCOL,NPTS,
     +                   NROW,NTMS
C
C Check for an uncleared prior error.
C
        IF (ICFELL('MDLNAM - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C Form the full names of the ".names" file (locally and in the NCAR
C Graphics database directory).
C
        LFNM=MDILNB(FLNM)
        IF (LFNM.GT.512) GO TO 901
C
        FLNL=FLNM(1:LFNM)//'.names'//CHAR(0)
        LFNL=LFNM+7
C
        CALL MPDBDI (FLND,ISTA)
        IF (ISTA.EQ.-1) GO TO 901
        DO 101 I=1,LEN(FLND)-7-LFNM
          IF (FLND(I:I).EQ.CHAR(0)) THEN
            FLND(I:LEN(FLND))='/'//FLNM(1:LFNM)//'.names'//CHAR(0)
            LFND=I+LFNM+7
            GO TO 102
          ENDIF
  101   CONTINUE
        GO TO 901
C
C If the name of the file to be used is not the same as the one last
C time, re-read name information.
C
  102   IF (FLNM.NE.FLNS) THEN
C
C Open the ".names" file.  Look for a local version first; if that one
C can't be found, look for one in the NCAR Graphics database directory.
C
          CALL NGOFRO (FLNL(1:LFNL),IFDE,ISTA)
          IF (ISTA.NE.0) THEN
            CALL NGOFRO (FLND(1:LFND),IFDE,ISTA)
            IF (ISTA.NE.0) GO TO 902
          END IF
C
C Clear the arrays into which the name information is to be read.
C
          DO 103 I=1,MNAI
            IATY(I)=0
            ISCI(I)=0
            IPAR(I)=0
            NAME(I)=' '
  103     CONTINUE
C
C Read and process all the name information.
C
          MCHR=0
          NCHR=0
C
  104     CALL MDRDNM (IFDE,CHRS,512,MCHR,NCHR,IAID)
          IF (MCHR.EQ.0) GO TO 105
          IF (IAID.LT.1.OR.IAID.GT.MNAI) GO TO 903
          CALL MDRDNM (IFDE,CHRS,512,MCHR,NCHR,IATY(IAID))
          IF (MCHR.EQ.0) GO TO 904
          CALL MDRDNM (IFDE,CHRS,512,MCHR,NCHR,ISCI(IAID))
          IF (MCHR.EQ.0) GO TO 904
          CALL MDRDNM (IFDE,CHRS,512,MCHR,NCHR,IPAR(IAID))
          IF (MCHR.EQ.0) GO TO 904
          CALL MDRDNM (IFDE,CHRS,512,MCHR,NCHR,LONM)
          IF (MCHR.EQ.0) GO TO 904
          NAME(IAID)=' '
          CALL MDRDCS (IFDE,CHRS,512,MCHR,NCHR,NAME(IAID)(1:LONM))
          IF (MCHR.EQ.0) GO TO 904
          GO TO 104
C
  105     CALL NGCLFI (IFDE)
C
C Save the file name, so that the read next time can be skipped.
C
          FLNS=FLNM
C
        END IF
C
C If EZMAP needs initialization, do it.
C
        CALL MDGETI ('IN',INTF)
C
        IF (INTF.NE.0) THEN
          CALL MDPINT
          IF (ICFELL('MDLNAM',2).NE.0) RETURN
        END IF
C
C Use the EZMAPA routine MDPBLA to generate limb lines (if any) and a
C perimeter and send them to the area map.
C
        CALL MDGETC ('OU',SVOU)
        CALL MDSETC ('OU','NO')
        CALL MDPBLA (IAMA)
        IF (ICFELL('MDLNAM',3).NE.0) RETURN
        CALL MDSETC ('OU',SVOU)
C
C Open the ".lines" file.  Again, look for a local version first and, if
C that one can't be found, look in the NCAR Graphics database directory.
C
        FLNL(LFNL-6:LFNL-1)='.lines'
        CALL NGOFRO (FLNL(1:LFNL),IFDE,ISTA)
        IF (ISTA.NE.0) THEN
          FLND(LFND-6:LFND-1)='.lines'
          CALL NGOFRO (FLND(1:LFND),IFDE,ISTA)
          IF (ISTA.NE.0) GO TO 905
        END IF
C
C Get the group identifier to be used for geographical entities.
C
        CALL MDGETI ('G1',IGI1)
C
C Set the flag IWGF to say whether or not the whole globe is shown by
C the current projection.  If so (IWGF=1), there's no need to waste the
C time required to check each outline point group for intersection with
C the window; otherwise, it is worth it and we do so.
C
        IWGF=0
        IF (BLAM-SLAM.GT.179.D0.AND.BLOM-SLOM.GT.359.D0) IWGF=1
C
C Save some pointers that will tell us whether anything actually got
C put into the area map, so that, if not, we can take remedial action.
C
        IAM5=IAMA(5)
C
C Read and process each of the lines.
C
  106   CALL NGRDIN (IFDE,NNMS,4,ISTA)
        IF (ISTA.NE.4) GO TO 906
C
        IF (NNMS.LE.1) GO TO 108
C
        IOAL=MDIOSA(IAIL,ILVL)
        IOAR=MDIOSA(IAIR,ILVL)
C
        CALL NGRDFL (IFDE,BLAG,4+NNMS,ISTA)
        IF (ISTA.NE.4+NNMS) GO TO 906
C
        IF (IWGF.EQ.0) THEN
          IF (SLAG.GT.BLAM.OR.BLAG.LT.SLAM) GO TO 106
          IF ((SLOG     .GT.BLOM.OR.BLOG     .LT.SLOM).AND.
     +        (SLOG-360..GT.BLOM.OR.BLOG-360..LT.SLOM).AND.
     +        (SLOG+360..GT.BLOM.OR.BLOG+360..LT.SLOM)) GO TO 106
        END IF
C
        IF (IOAL.NE.IOAR) THEN
          NPTS=NNMS/2
          CALL HLUMPCHLN (+1,ILTY,IOAL,IOAR,NPTS,PNTS)
          IF (NPTS.LE.1) GO TO 106
          CALL MAPITA (PNTS(1),PNTS(2),0,IAMA,IGI1,IOAL,IOAR)
          IF (ICFELL('MDLNAM',4).NE.0) GO TO 907
          DO 107 I=3,NNMS-3,2
            CALL MAPITA (PNTS(I),PNTS(I+1),1,IAMA,IGI1,IOAL,IOAR)
            IF (ICFELL('MDLNAM',5).NE.0) GO TO 907
  107     CONTINUE
          CALL MAPITA (PNTS(NNMS-1),PNTS(NNMS),2,IAMA,IGI1,IOAL,IOAR)
          IF (ICFELL('MDLNAM',6).NE.0) GO TO 907
          CALL MAPIQA (IAMA,IGI1,IOAL,IOAR)
          IF (ICFELL('MDLNAM',7).NE.0) GO TO 907
          CALL HLUMPCHLN (-1,ILTY,IOAL,IOAR,NPTS,PNTS)
        END IF
C
        GO TO 106
C
  108   CALL NGCLFI (IFDE)
C
C See if anything was actually put into the area map and, if not, take
C action to supply AREAS with a correct area identifier.  Again, look
C for a local version of the required file and, if it can't be found,
C look in the NCAR Graphics database directory.
C
        IF (IAMA(5).EQ.IAM5) THEN
          FLNL(LFNL-6:LFNL-1)='.areas'
          CALL NGOFRO (FLNL(1:LFNL),IFDE,ISTA)
          IF (ISTA.NE.0) THEN
            FLND(LFND-6:LFND-1)='.areas'
            CALL NGOFRO (FLND(1:LFND),IFDE,ISTA)
            IF (ISTA.NE.0) GO TO 113
          END IF
          NTMS=0
          MCHR=0
          NCHR=0
          DO 111 IDIV=0,15
            NROW=2**IDIV
            NCOL=2*NROW
            DO 110 J=1,NROW
              RLAT=-90.D0+(DBLE(J)-.5D0)*(180.D0/DBLE(NROW))
              DO 109 I=1,NCOL
                RLON=-180.D0+(DBLE(I)-.5D0)*(360.D0/DBLE(NCOL))
                IF (NTMS.EQ.0) THEN
                  CALL MDRDNM (IFDE,CHRS,512,MCHR,NCHR,NTMS)
                  IF (MCHR.EQ.0) GO TO 112
                  CALL MDRDNM (IFDE,CHRS,512,MCHR,NCHR,IAID)
                  IF (MCHR.EQ.0) GO TO 112
                END IF
                CALL MDPTRA (RLAT,RLON,UVAL,VVAL)
                IF (UVAL.NE.1.D12) THEN
                  XCRA(1)=REAL(UMIN)
                  XCRA(2)=REAL(UMAX)
                  YCRA(1)=REAL(VMIN)
                  YCRA(2)=REAL(VMAX)
                  IAID=MDIOSA(IAID,ILVL)
                  CALL AREDAM (IAMA,XCRA,YCRA,2,IGI1,IAID,IAID)
                  IF (ICFELL('MDLNAM',8).NE.0) GO TO 907
                  GO TO 112
                END IF
                NTMS=NTMS-1
  109         CONTINUE
  110       CONTINUE
  111     CONTINUE
  112     CALL NGCLFI (IFDE)
C
        END IF
C
C Done.
C
  113   RETURN
C
C Error exits.
C
  901   CALL SETER ('MDLNAM - Can''t form name of ".names" file',9,1)
        RETURN
C
  902   CALL SETER ('MDLNAM - Can''t open the ".names" file',10,1)
        RETURN
C
  903   CALL SETER ('MDLNAM - Read bad index from ".names" file',11,1)
        CALL NGCLFI (IFDE)
        RETURN
C
  904   CALL SETER ('MDLNAM - Read error on ".names" file',12,1)
        CALL NGCLFI (IFDE)
        RETURN
C
  905   CALL SETER ('MDLNAM - Can''t open the ".lines" file',13,1)
        RETURN
C
  906   CALL SETER ('MDLNAM - Read error on ".lines" file',14,1)
        CALL NGCLFI (IFDE)
        RETURN
C
  907   CALL NGCLFI (IFDE)
        RETURN
C
      END

C
C	$Id: wmbarb.f,v 1.7 2008-07-27 00:17:36 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE WMBARB(X,Y,U,V)
C
C  This subroutine plots wind barbs with the origin of the barb at
C  (X,Y).  U and V are the components of the wind vector.
C
      include 'wmcomn.h'
C
      PARAMETER (D2RAD=.017453293)
      DIMENSION XX(4),YY(4)
C
C  TRIINC - Increment for which triangles are drawn.
C  TICINC - Increment for which a full tic is drawn.
C
      DATA TRIINC,TICINC/50.,10./
C
C  Save the current line and fill colors and set them to ICOLOR.
C
      CALL GQFAIS(IER,IFAISO)
      CALL GQFACI(IER,IFCLRO)
      CALL GQPLCI(IER,ILCLRO)
      CALL GQLWSC(IER,RLNWTH)
      CALL GSFAIS(1)
      CALL GSFACI(ICOLOR)
      CALL GSPLCI(ICOLOR)
      CALL WMGETR('BLW',BRBLWD)
      CALL GSLWSC(BRBLWD)
      CALL PCGETI ('FN',IFNO)
C
C  Convert X and Y to NDC and work in NDC space.
C
      CALL WMW2NX(1,X,XNDC)
      CALL WMW2NY(1,Y,YNDC)
      CALL GQCNTN(IER,NTRO)
      CALL GSELNT(0)
C
      SPEED  = SQRT(U*U+V*V)
C
C  Handle some initial special cases.
C
      WBXL = 1.
      WBXR = 0.
      WBYB = 1.
      WBYT = 0.
      IF (SPEED .LT. 0.5) THEN
C
C  Calm.
C
        CALL NGGETI('CT',ICTYPO)
        CALL NGSETI('CT',1)
        CALL NGDOTS(XNDC,YNDC,1,WBCLMR*WBSHFT,ICOLOR)
        CALL NGDOTS(XNDC,YNDC,1,1.50*WBCLMR*WBSHFT,ICOLOR)
        CALL NGSETI('CT',ICTYPO)
        WBXL = XNDC
        WBXR = XNDC
        WBYB = YNDC
        WBYT = YNDC
        GO TO 100
      ENDIF
C
C  Shift the wind direction by 180 degrees if the user has
C  set the direction flag.
C
      IF (IWBDIR .NE. 0) THEN
        UP = -U
        VP = -V
      ELSE
        UP =  U
        VP =  V
      ENDIF
      COSANG = UP/SPEED
      SINANG = VP/SPEED
C
C  Draw shaft (adjust if the flag is set to allow for the sky cover
C  circle to be drawn at the base).
C
      IF (IWBBAS .EQ. 0) THEN
        XX(1) = XNDC
        YY(1) = YNDC
      ELSE
        XX(1) = XNDC+0.5*WBBASE*WBSHFT*COSANG
        YY(1) = YNDC+0.5*WBBASE*WBSHFT*SINANG
      ENDIF
      XEND  = XNDC+WBSHFT*COSANG
      YEND  = YNDC+WBSHFT*SINANG
      XX(2) = XEND
      YY(2) = YEND
      CALL GPL(2,XX,YY)
      IF (SPEED .LT. 2.5) THEN
C
C  Shaft already drawn.
C
        WBXL = XEND
        WBXR = XEND
        WBYB = YEND
        WBYT = YEND
        GO TO 100
      ENDIF
C
C  Compute some local variables.
C
      RANG = WBBANG*D2RAD
      XNOM =  COS(RANG)*WBFTIC*WBSHFT
      YNOM = -SIN(RANG)*WBFTIC*WBSHFT
      XTIC = XNOM*COSANG-YNOM*SINANG
      YTIC = XNOM*SINANG+YNOM*COSANG
      XINC = WBDIST*WBSHFT*COSANG
      YINC = WBDIST*WBSHFT*SINANG
      XSID = XNOM*COSANG
      YSID = XNOM*SINANG
      XPOS = XEND
      YPOS = YEND
      IF (SPEED .LT. 7.5) THEN
C
C  Draw a half tic spaced WBDIST down the shaft.
C
        XX(1) = XEND-XINC
        YY(1) = YEND-YINC
        XX(2) = XX(1)+0.5*XTIC
        YY(2) = YY(1)+0.5*YTIC
        CALL GPL(2,XX,YY)
        WBXL = MIN(XX(1),XX(2))
        WBXR = MAX(XX(1),XX(2))
        WBYB = MIN(YY(1),YY(2))
        WBYT = MAX(YY(1),YY(2))
        GO TO 100
      ENDIF
C
C  Draw the appropriate number of triangles.
C
      NUMTRI = INT((SPEED+2.5)/TRIINC)
      IF (NUMTRI .GT. 0) THEN
        DO 10 NT=1,NUMTRI
          IF (NT .EQ. 1) THEN
C
C  Extend the shaft and redraw it (it would not be correct otherwise
C  if it were being drawn in a non-default linewidth, for example).
C
            IF (IWBBAS .EQ. 0) THEN
              XX(1) = XNDC
              YY(1) = YNDC
            ELSE
              XX(1) = XNDC+0.5*WBBASE*WBSHFT*COSANG
              YY(1) = YNDC+0.5*WBBASE*WBSHFT*SINANG
            ENDIF
            XX(2) = XEND+XSID
            YY(2) = YEND+YSID
            CALL GPL(2,XX,YY)
            XPOS = XPOS+XINC
            YPOS = YPOS+YINC
          ENDIF
C
C  Draw triangles.
C
          XPOS  = XPOS-XINC
          YPOS  = YPOS-YINC
          XX(1) = XPOS
          YY(1) = YPOS
          XX(2) = XPOS+XTIC
          YY(2) = YPOS+YTIC
          XX(3) = XPOS+XSID
          YY(3) = YPOS+YSID
          XX(4) = XX(1)
          YY(4) = YY(1)
          CALL GFA(4,XX,YY)
          DO 30 NE=1,4
            WBXL = MIN(WBXL,XX(NE))
            WBXR = MAX(WBXR,XX(NE))
            WBYB = MIN(WBYB,YY(NE))
            WBYT = MAX(WBYT,YY(NE))
   30     CONTINUE
          XPOS  = XPOS-XINC
          YPOS  = YPOS-YINC
          SPEED = SPEED-TRIINC
   10   CONTINUE
      ENDIF
C
C  Draw the full ticks.
C
      NUMTIC = INT((SPEED+2.5)/TICINC)
      IF (NUMTIC .GT. 0) THEN
        DO 20 I=1,NUMTIC
          XX(1) = XPOS
          YY(1) = YPOS
          XX(2) = XPOS+XTIC
          YY(2) = YPOS+YTIC
          CALL GPL(2,XX,YY)
          DO 40 NE=1,2
            WBXL = MIN(WBXL,XX(NE))
            WBXR = MAX(WBXR,XX(NE))
            WBYB = MIN(WBYB,YY(NE))
            WBYT = MAX(WBYT,YY(NE))
   40     CONTINUE
          XPOS  = XPOS-XINC
          YPOS  = YPOS-YINC
          SPEED = SPEED-TICINC
   20   CONTINUE
      ENDIF
C
C  Draw a half tick if needed.
C
      IF (SPEED .GT. 2.5) THEN
        XX(1) = XPOS
        YY(1) = YPOS
        XX(2) = XPOS+0.5*XTIC
        YY(2) = YPOS+0.5*YTIC
        CALL GPL(2,XX,YY)
        DO 50 NE=1,2
          WBXL = MIN(WBXL,XX(NE))
          WBXR = MAX(WBXR,XX(NE))
          WBYB = MIN(WBYB,YY(NE))
          WBYT = MAX(WBYT,YY(NE))
   50   CONTINUE
      ENDIF
  100 CONTINUE
C
C  Restore the original environment.
C
      CALL GSFAIS(IFAISO)
      CALL GSFACI(IFCLRO)
      CALL GSPLCI(ILCLRO)
      CALL GSELNT(NTRO)
      CALL GSLWSC(RLNWTH)
      CALL PCSETI ('FN',IFNO)
C
      RETURN
      END

      SUBROUTINE DLAQGE( M, N, A, LDA, R, C, ROWCND, COLCND, AMAX,
     $                   EQUED )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     February 29, 1992
*
*     .. Scalar Arguments ..
      CHARACTER          EQUED
      INTEGER            LDA, M, N
      DOUBLE PRECISION   AMAX, COLCND, ROWCND
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), C( * ), R( * )
*     ..
*
*  Purpose
*  =======
*
*  DLAQGE equilibrates a general M by N matrix A using the row and
*  scaling factors in the vectors R and C.
*
*  Arguments
*  =========
*
*  M       (input) INTEGER
*          The number of rows of the matrix A.  M >= 0.
*
*  N       (input) INTEGER
*          The number of columns of the matrix A.  N >= 0.
*
*  A       (input/output) DOUBLE PRECISION array, dimension (LDA,N)
*          On entry, the M by N matrix A.
*          On exit, the equilibrated matrix.  See EQUED for the form of
*          the equilibrated matrix.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(M,1).
*
*  R       (input) DOUBLE PRECISION array, dimension (M)
*          The row scale factors for A.
*
*  C       (input) DOUBLE PRECISION array, dimension (N)
*          The column scale factors for A.
*
*  ROWCND  (input) DOUBLE PRECISION
*          Ratio of the smallest R(i) to the largest R(i).
*
*  COLCND  (input) DOUBLE PRECISION
*          Ratio of the smallest C(i) to the largest C(i).
*
*  AMAX    (input) DOUBLE PRECISION
*          Absolute value of largest matrix entry.
*
*  EQUED   (output) CHARACTER*1
*          Specifies the form of equilibration that was done.
*          = 'N':  No equilibration
*          = 'R':  Row equilibration, i.e., A has been premultiplied by
*                  diag(R).
*          = 'C':  Column equilibration, i.e., A has been postmultiplied
*                  by diag(C).
*          = 'B':  Both row and column equilibration, i.e., A has been
*                  replaced by diag(R) * A * diag(C).
*
*  Internal Parameters
*  ===================
*
*  THRESH is a threshold value used to decide if row or column scaling
*  should be done based on the ratio of the row or column scaling
*  factors.  If ROWCND < THRESH, row scaling is done, and if
*  COLCND < THRESH, column scaling is done.
*
*  LARGE and SMALL are threshold values used to decide if row scaling
*  should be done based on the absolute size of the largest matrix
*  element.  If AMAX > LARGE or AMAX < SMALL, row scaling is done.
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ONE, THRESH
      PARAMETER          ( ONE = 1.0D+0, THRESH = 0.1D+0 )
*     ..
*     .. Local Scalars ..
      INTEGER            I, J
      DOUBLE PRECISION   CJ, LARGE, SMALL
*     ..
*     .. External Functions ..
      DOUBLE PRECISION   DLAMCH
      EXTERNAL           DLAMCH
*     ..
*     .. Executable Statements ..
*
*     Quick return if possible
*
      IF( M.LE.0 .OR. N.LE.0 ) THEN
         EQUED = 'N'
         RETURN
      END IF
*
*     Initialize LARGE and SMALL.
*
      SMALL = DLAMCH( 'Safe minimum' ) / DLAMCH( 'Precision' )
      LARGE = ONE / SMALL
*
      IF( ROWCND.GE.THRESH .AND. AMAX.GE.SMALL .AND. AMAX.LE.LARGE )
     $     THEN
*
*        No row scaling
*
         IF( COLCND.GE.THRESH ) THEN
*
*           No column scaling
*
            EQUED = 'N'
         ELSE
*
*           Column scaling
*
            DO 20 J = 1, N
               CJ = C( J )
               DO 10 I = 1, M
                  A( I, J ) = CJ*A( I, J )
   10          CONTINUE
   20       CONTINUE
            EQUED = 'C'
         END IF
      ELSE IF( COLCND.GE.THRESH ) THEN
*
*        Row scaling, no column scaling
*
         DO 40 J = 1, N
            DO 30 I = 1, M
               A( I, J ) = R( I )*A( I, J )
   30       CONTINUE
   40    CONTINUE
         EQUED = 'R'
      ELSE
*
*        Row and column scaling
*
         DO 60 J = 1, N
            CJ = C( J )
            DO 50 I = 1, M
               A( I, J ) = CJ*R( I )*A( I, J )
   50       CONTINUE
   60    CONTINUE
         EQUED = 'B'
      END IF
*
      RETURN
*
*     End of DLAQGE
*
      END

      SUBROUTINE ZTPTRI( UPLO, DIAG, N, AP, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER          DIAG, UPLO
      INTEGER            INFO, N
*     ..
*     .. Array Arguments ..
      COMPLEX*16         AP( * )
*     ..
*
*  Purpose
*  =======
*
*  ZTPTRI computes the inverse of a complex upper or lower triangular
*  matrix A stored in packed format.
*
*  Arguments
*  =========
*
*  UPLO    (input) CHARACTER*1
*          = 'U':  A is upper triangular;
*          = 'L':  A is lower triangular.
*
*  DIAG    (input) CHARACTER*1
*          = 'N':  A is non-unit triangular;
*          = 'U':  A is unit triangular.
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  AP      (input/output) COMPLEX*16 array, dimension (N*(N+1)/2)
*          On entry, the upper or lower triangular matrix A, stored
*          columnwise in a linear array.  The j-th column of A is stored
*          in the array AP as follows:
*          if UPLO = 'U', AP(i + (j-1)*j/2) = A(i,j) for 1<=i<=j;
*          if UPLO = 'L', AP(i + (j-1)*((2*n-j)/2) = A(i,j) for j<=i<=n.
*          See below for further details.
*          On exit, the (triangular) inverse of the original matrix, in
*          the same packed storage format.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*          > 0:  if INFO = i, A(i,i) is exactly zero.  The triangular
*                matrix is singular and its inverse can not be computed.
*
*  Further Details
*  ===============
*
*  A triangular matrix A can be transferred to packed storage using one
*  of the following program segments:
*
*  UPLO = 'U':                      UPLO = 'L':
*
*        JC = 1                           JC = 1
*        DO 2 J = 1, N                    DO 2 J = 1, N
*           DO 1 I = 1, J                    DO 1 I = J, N
*              AP(JC+I-1) = A(I,J)              AP(JC+I-J) = A(I,J)
*      1    CONTINUE                    1    CONTINUE
*           JC = JC + J                      JC = JC + N - J + 1
*      2 CONTINUE                       2 CONTINUE
*
*  =====================================================================
*
*     .. Parameters ..
      COMPLEX*16         ONE, ZERO
      PARAMETER          ( ONE = ( 1.0D+0, 0.0D+0 ),
     $                   ZERO = ( 0.0D+0, 0.0D+0 ) )
*     ..
*     .. Local Scalars ..
      LOGICAL            NOUNIT, UPPER
      INTEGER            J, JC, JCLAST, JJ
      COMPLEX*16         AJJ
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           XERBLA, ZSCAL, ZTPMV
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      UPPER = LSAME( UPLO, 'U' )
      NOUNIT = LSAME( DIAG, 'N' )
      IF( .NOT.UPPER .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = -1
      ELSE IF( .NOT.NOUNIT .AND. .NOT.LSAME( DIAG, 'U' ) ) THEN
         INFO = -2
      ELSE IF( N.LT.0 ) THEN
         INFO = -3
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'ZTPTRI', -INFO )
         RETURN
      END IF
*
*     Check for singularity if non-unit.
*
      IF( NOUNIT ) THEN
         IF( UPPER ) THEN
            JJ = 0
            DO 10 INFO = 1, N
               JJ = JJ + INFO
               IF( AP( JJ ).EQ.ZERO )
     $            RETURN
   10       CONTINUE
         ELSE
            JJ = 1
            DO 20 INFO = 1, N
               IF( AP( JJ ).EQ.ZERO )
     $            RETURN
               JJ = JJ + N - INFO + 1
   20       CONTINUE
         END IF
         INFO = 0
      END IF
*
      IF( UPPER ) THEN
*
*        Compute inverse of upper triangular matrix.
*
         JC = 1
         DO 30 J = 1, N
            IF( NOUNIT ) THEN
               AP( JC+J-1 ) = ONE / AP( JC+J-1 )
               AJJ = -AP( JC+J-1 )
            ELSE
               AJJ = -ONE
            END IF
*
*           Compute elements 1:j-1 of j-th column.
*
            CALL ZTPMV( 'Upper', 'No transpose', DIAG, J-1, AP,
     $                  AP( JC ), 1 )
            CALL ZSCAL( J-1, AJJ, AP( JC ), 1 )
            JC = JC + J
   30    CONTINUE
*
      ELSE
*
*        Compute inverse of lower triangular matrix.
*
         JC = N*( N+1 ) / 2
         DO 40 J = N, 1, -1
            IF( NOUNIT ) THEN
               AP( JC ) = ONE / AP( JC )
               AJJ = -AP( JC )
            ELSE
               AJJ = -ONE
            END IF
            IF( J.LT.N ) THEN
*
*              Compute elements j+1:n of j-th column.
*
               CALL ZTPMV( 'Lower', 'No transpose', DIAG, N-J,
     $                     AP( JCLAST ), AP( JC+1 ), 1 )
               CALL ZSCAL( N-J, AJJ, AP( JC+1 ), 1 )
            END IF
            JCLAST = JC
            JC = JC - N + J - 2
   40    CONTINUE
      END IF
*
      RETURN
*
*     End of ZTPTRI
*
      END

C
C $Id: utilbd.f,v 1.9 2008-07-27 00:17:25 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE UTILBD
C
C Calling this do-nothing subroutine forces "ld" to load the following
C block data routine (but only if they are in the same ".f" file).
C
        RETURN
C
      END
CNOSPLIT
      BLOCKDATA UTILBDX
C
C The common block IUTLCM contains integer utility variables which are
C user-settable by the routine SETUSV and user-retrievable by the
C routine GETUSV.
C
      COMMON /IUTLCM/ IU(100)
      SAVE /IUTLCM/
C
C The common block VCTSEQ contains variables realizing the buffering
C scheme used by PLOTIF/T for pen moves.  The dimension of QX and QY
C must be an even number greater than or equal to the value of IU(5).
C The dimension of IF must be half that of QX and QY.
C
      COMMON /VCTSEQ/ NQ,QX(50),QY(50),NF,IF(25)
      SAVE /VCTSEQ/
C
C In the common block PLTCM are recorded the coordinates of the last
C point to which a pen move was requested by a call to PLOTIF/T.
C
      COMMON /PLTCM/ JX,JY
      SAVE /PLTCM/
C
C IU(1) contains the log scaling parameter, which may take on the
C following possible values:
C
C     1 = linear-linear
C     2 = log-linear
C     3 = linear-log
C     4 = log-log
C
      DATA IU(1) / 1 /
C
C IU(2) specifies the mirror-imaging of the x and y axes, as follows:
C
C     1 = x normal, y normal
C     2 = x normal, y reversed
C     3 = x reversed, y normal
C     4 = x reversed, y reversed
C
      DATA IU(2) / 1 /
C
C IU(3) specifies the assumed resolution of the plotter in the x
C direction.  Plotter x coordinates are assumed to lie between 1 and
C 2**IU(3), inclusive.
C
      DATA IU(3) / 10 /
C
C IU(4) specifies the assumed resolution of the plotter in the y
C direction.  Plotter y coordinates are assumed to lie between 1 and
C 2**IU(4), inclusive.
C
      DATA IU(4) / 10 /
C
C IU(5) specifies the size of the buffers used by PLOTIF/T.  Its value
C must be greater than or equal to 2 and not greater than the dimension
C of the variables QX and QY.  Using the value 2 effectively turns off
C the buffering.
C
      DATA IU(5) / 50 /
C
C IU(6) specifies the current metacode unit, which is machine-dependent.
C IU(6) is made negative when OPNGKS is called and positive when CLSGKS
C is called.
C
      DATA IU(6) / 2 /
C
C IU(7), IU(8), IU(9), and IU(10) specify color and intensity, in the
C following way (letting IR=IU(7), IG=IU(8), IB=IU(9), and IN=IU(10)):
C
C     The red intensity is IR/(IR+IG+IB)*IN/10000.
C     The green intensity is IG/(IR+IG+IB)*IN/10000.
C     The blue intensity is IB/(IR+IG+IB)*IN/10000.
C
C The GKS calls to set these intensities are executed in response to a
C "CALL SETUSV ('IN',IN)", using the existing values of IR, IG, and IB.
C Thus, to completely determine the color and the intensity, the user
C must execute four calls, as follows:
C
C     CALL SETUSV ('IR',IR)
C     CALL SETUSV ('IG',IG)
C     CALL SETUSV ('IB',IB)
C     CALL SETUSV ('IN',IN)
C
C The default values create a white line at .8 x maximum intensity.
C
      DATA IU(7) / 1 /
      DATA IU(8) / 1 /
      DATA IU(9) / 1 /
C
      DATA IU(10) / 8000 /
C
C IU(11) and IU(12) specify, respectively, the last color index used
C and the maximum number of color indices it is permissible to use.
C
      DATA IU(11) / 0 /
      DATA IU(12) / 1 /
C
C IU(13)/1000 specifies the current line width scale factor.
C
      DATA IU(13) / 1000 /
C
C IU(14)/1000 specifies the current marker size scale factor.
C
      DATA IU(14) / 1000 /
C
C IU(15) through IU(100) are currently undefined.
C
C Initialization for the routines PLOTIF/T:  For values of I from 1 to
C NQ, (QX(I),QY(I)) is a point to which a pen move has been requested
C by a past call to PLOTIF/T.  Coordinates are stated in the fractional
C coordinate system.  For values of I between 1 and NF, IF(I) is the
C index, in QX and QY, of the coordinates of a point to which a pen-up
C move was requested.  NQ and NF are never allowed to be less than one.
C
      DATA NQ,QX(1),QY(1),NF,IF(1) / 1 , 0. , 0. , 1 , 1 /
C
C JX and JY are the coordinates, in the metacode system, of the last
C point to which a pen move was requested by a call to PLOTIF/T.
C
      DATA JX,JY / 0 , 0 /
C
      END

      SUBROUTINE CUNGTR( UPLO, N, A, LDA, TAU, WORK, LWORK, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          UPLO
      INTEGER            INFO, LDA, LWORK, N
*     ..
*     .. Array Arguments ..
      COMPLEX            A( LDA, * ), TAU( * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  CUNGTR generates a complex unitary matrix Q which is defined as the
*  product of n-1 elementary reflectors of order N, as returned by
*  CHETRD:
*
*  if UPLO = 'U', Q = H(n-1) . . . H(2) H(1),
*
*  if UPLO = 'L', Q = H(1) H(2) . . . H(n-1).
*
*  Arguments
*  =========
*
*  UPLO    (input) CHARACTER*1
*          = 'U': Upper triangle of A contains elementary reflectors
*                 from CHETRD;
*          = 'L': Lower triangle of A contains elementary reflectors
*                 from CHETRD.
*
*  N       (input) INTEGER
*          The order of the matrix Q. N >= 0.
*
*  A       (input/output) COMPLEX array, dimension (LDA,N)
*          On entry, the vectors which define the elementary reflectors,
*          as returned by CHETRD.
*          On exit, the N-by-N unitary matrix Q.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A. LDA >= N.
*
*  TAU     (input) COMPLEX array, dimension (N-1)
*          TAU(i) must contain the scalar factor of the elementary
*          reflector H(i), as returned by CHETRD.
*
*  WORK    (workspace/output) COMPLEX array, dimension (LWORK)
*          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*
*  LWORK   (input) INTEGER
*          The dimension of the array WORK. LWORK >= N-1.
*          For optimum performance LWORK >= (N-1)*NB, where NB is
*          the optimal blocksize.
*
*          If LWORK = -1, then a workspace query is assumed; the routine
*          only calculates the optimal size of the WORK array, returns
*          this value as the first entry of the WORK array, and no error
*          message related to LWORK is issued by XERBLA.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*
*  =====================================================================
*
*     .. Parameters ..
      COMPLEX            ZERO, ONE
      PARAMETER          ( ZERO = ( 0.0E+0, 0.0E+0 ),
     $                   ONE = ( 1.0E+0, 0.0E+0 ) )
*     ..
*     .. Local Scalars ..
      LOGICAL            LQUERY, UPPER
      INTEGER            I, IINFO, J, LWKOPT, NB
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            ILAENV
      EXTERNAL           ILAENV, LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           CUNGQL, CUNGQR, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX
*     ..
*     .. Executable Statements ..
*
*     Test the input arguments
*
      INFO = 0
      LQUERY = ( LWORK.EQ.-1 )
      UPPER = LSAME( UPLO, 'U' )
      IF( .NOT.UPPER .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -4
      ELSE IF( LWORK.LT.MAX( 1, N-1 ) .AND. .NOT.LQUERY ) THEN
         INFO = -7
      END IF
*
      IF( INFO.EQ.0 ) THEN
         IF ( UPPER ) THEN
           NB = ILAENV( 1, 'CUNGQL', ' ', N-1, N-1, N-1, -1 )
         ELSE
           NB = ILAENV( 1, 'CUNGQR', ' ', N-1, N-1, N-1, -1 )
         END IF
         LWKOPT = MAX( 1, N-1 )*NB
         WORK( 1 ) = LWKOPT
      END IF
*
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'CUNGTR', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 ) THEN
         WORK( 1 ) = 1
         RETURN
      END IF
*
      IF( UPPER ) THEN
*
*        Q was determined by a call to CHETRD with UPLO = 'U'
*
*        Shift the vectors which define the elementary reflectors one
*        column to the left, and set the last row and column of Q to
*        those of the unit matrix
*
         DO 20 J = 1, N - 1
            DO 10 I = 1, J - 1
               A( I, J ) = A( I, J+1 )
   10       CONTINUE
            A( N, J ) = ZERO
   20    CONTINUE
         DO 30 I = 1, N - 1
            A( I, N ) = ZERO
   30    CONTINUE
         A( N, N ) = ONE
*
*        Generate Q(1:n-1,1:n-1)
*
         CALL CUNGQL( N-1, N-1, N-1, A, LDA, TAU, WORK, LWORK, IINFO )
*
      ELSE
*
*        Q was determined by a call to CHETRD with UPLO = 'L'.
*
*        Shift the vectors which define the elementary reflectors one
*        column to the right, and set the first row and column of Q to
*        those of the unit matrix
*
         DO 50 J = N, 2, -1
            A( 1, J ) = ZERO
            DO 40 I = J + 1, N
               A( I, J ) = A( I, J-1 )
   40       CONTINUE
   50    CONTINUE
         A( 1, 1 ) = ONE
         DO 60 I = 2, N
            A( I, 1 ) = ZERO
   60    CONTINUE
         IF( N.GT.1 ) THEN
*
*           Generate Q(2:n,2:n)
*
            CALL CUNGQR( N-1, N-1, N-1, A( 2, 2 ), LDA, TAU, WORK,
     $                   LWORK, IINFO )
         END IF
      END IF
      WORK( 1 ) = LWKOPT
      RETURN
*
*     End of CUNGTR
*
      END

      SUBROUTINE SHSEIN( SIDE, EIGSRC, INITV, SELECT, N, H, LDH, WR, WI,
     $                   VL, LDVL, VR, LDVR, MM, M, WORK, IFAILL,
     $                   IFAILR, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER          EIGSRC, INITV, SIDE
      INTEGER            INFO, LDH, LDVL, LDVR, M, MM, N
*     ..
*     .. Array Arguments ..
      LOGICAL            SELECT( * )
      INTEGER            IFAILL( * ), IFAILR( * )
      REAL               H( LDH, * ), VL( LDVL, * ), VR( LDVR, * ),
     $                   WI( * ), WORK( * ), WR( * )
*     ..
*
*  Purpose
*  =======
*
*  SHSEIN uses inverse iteration to find specified right and/or left
*  eigenvectors of a real upper Hessenberg matrix H.
*
*  The right eigenvector x and the left eigenvector y of the matrix H
*  corresponding to an eigenvalue w are defined by:
*
*               H * x = w * x,     y**h * H = w * y**h
*
*  where y**h denotes the conjugate transpose of the vector y.
*
*  Arguments
*  =========
*
*  SIDE    (input) CHARACTER*1
*          = 'R': compute right eigenvectors only;
*          = 'L': compute left eigenvectors only;
*          = 'B': compute both right and left eigenvectors.
*
*  EIGSRC  (input) CHARACTER*1
*          Specifies the source of eigenvalues supplied in (WR,WI):
*          = 'Q': the eigenvalues were found using SHSEQR; thus, if
*                 H has zero subdiagonal elements, and so is
*                 block-triangular, then the j-th eigenvalue can be
*                 assumed to be an eigenvalue of the block containing
*                 the j-th row/column.  This property allows SHSEIN to
*                 perform inverse iteration on just one diagonal block.
*          = 'N': no assumptions are made on the correspondence
*                 between eigenvalues and diagonal blocks.  In this
*                 case, SHSEIN must always perform inverse iteration
*                 using the whole matrix H.
*
*  INITV   (input) CHARACTER*1
*          = 'N': no initial vectors are supplied;
*          = 'U': user-supplied initial vectors are stored in the arrays
*                 VL and/or VR.
*
*  SELECT  (input/output) LOGICAL array, dimension (N)
*          Specifies the eigenvectors to be computed. To select the
*          real eigenvector corresponding to a real eigenvalue WR(j),
*          SELECT(j) must be set to .TRUE.. To select the complex
*          eigenvector corresponding to a complex eigenvalue
*          (WR(j),WI(j)), with complex conjugate (WR(j+1),WI(j+1)),
*          either SELECT(j) or SELECT(j+1) or both must be set to
*          .TRUE.; then on exit SELECT(j) is .TRUE. and SELECT(j+1) is
*          .FALSE..
*
*  N       (input) INTEGER
*          The order of the matrix H.  N >= 0.
*
*  H       (input) REAL array, dimension (LDH,N)
*          The upper Hessenberg matrix H.
*
*  LDH     (input) INTEGER
*          The leading dimension of the array H.  LDH >= max(1,N).
*
*  WR      (input/output) REAL array, dimension (N)
*  WI      (input) REAL array, dimension (N)
*          On entry, the real and imaginary parts of the eigenvalues of
*          H; a complex conjugate pair of eigenvalues must be stored in
*          consecutive elements of WR and WI.
*          On exit, WR may have been altered since close eigenvalues
*          are perturbed slightly in searching for independent
*          eigenvectors.
*
*  VL      (input/output) REAL array, dimension (LDVL,MM)
*          On entry, if INITV = 'U' and SIDE = 'L' or 'B', VL must
*          contain starting vectors for the inverse iteration for the
*          left eigenvectors; the starting vector for each eigenvector
*          must be in the same column(s) in which the eigenvector will
*          be stored.
*          On exit, if SIDE = 'L' or 'B', the left eigenvectors
*          specified by SELECT will be stored consecutively in the
*          columns of VL, in the same order as their eigenvalues. A
*          complex eigenvector corresponding to a complex eigenvalue is
*          stored in two consecutive columns, the first holding the real
*          part and the second the imaginary part.
*          If SIDE = 'R', VL is not referenced.
*
*  LDVL    (input) INTEGER
*          The leading dimension of the array VL.
*          LDVL >= max(1,N) if SIDE = 'L' or 'B'; LDVL >= 1 otherwise.
*
*  VR      (input/output) REAL array, dimension (LDVR,MM)
*          On entry, if INITV = 'U' and SIDE = 'R' or 'B', VR must
*          contain starting vectors for the inverse iteration for the
*          right eigenvectors; the starting vector for each eigenvector
*          must be in the same column(s) in which the eigenvector will
*          be stored.
*          On exit, if SIDE = 'R' or 'B', the right eigenvectors
*          specified by SELECT will be stored consecutively in the
*          columns of VR, in the same order as their eigenvalues. A
*          complex eigenvector corresponding to a complex eigenvalue is
*          stored in two consecutive columns, the first holding the real
*          part and the second the imaginary part.
*          If SIDE = 'L', VR is not referenced.
*
*  LDVR    (input) INTEGER
*          The leading dimension of the array VR.
*          LDVR >= max(1,N) if SIDE = 'R' or 'B'; LDVR >= 1 otherwise.
*
*  MM      (input) INTEGER
*          The number of columns in the arrays VL and/or VR. MM >= M.
*
*  M       (output) INTEGER
*          The number of columns in the arrays VL and/or VR required to
*          store the eigenvectors; each selected real eigenvector
*          occupies one column and each selected complex eigenvector
*          occupies two columns.
*
*  WORK    (workspace) REAL array, dimension ((N+2)*N)
*
*  IFAILL  (output) INTEGER array, dimension (MM)
*          If SIDE = 'L' or 'B', IFAILL(i) = j > 0 if the left
*          eigenvector in the i-th column of VL (corresponding to the
*          eigenvalue w(j)) failed to converge; IFAILL(i) = 0 if the
*          eigenvector converged satisfactorily. If the i-th and (i+1)th
*          columns of VL hold a complex eigenvector, then IFAILL(i) and
*          IFAILL(i+1) are set to the same value.
*          If SIDE = 'R', IFAILL is not referenced.
*
*  IFAILR  (output) INTEGER array, dimension (MM)
*          If SIDE = 'R' or 'B', IFAILR(i) = j > 0 if the right
*          eigenvector in the i-th column of VR (corresponding to the
*          eigenvalue w(j)) failed to converge; IFAILR(i) = 0 if the
*          eigenvector converged satisfactorily. If the i-th and (i+1)th
*          columns of VR hold a complex eigenvector, then IFAILR(i) and
*          IFAILR(i+1) are set to the same value.
*          If SIDE = 'L', IFAILR is not referenced.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*          > 0:  if INFO = i, i is the number of eigenvectors which
*                failed to converge; see IFAILL and IFAILR for further
*                details.
*
*  Further Details
*  ===============
*
*  Each eigenvector is normalized so that the element of largest
*  magnitude has magnitude 1; here the magnitude of a complex number
*  (x,y) is taken to be |x|+|y|.
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ZERO, ONE
      PARAMETER          ( ZERO = 0.0E+0, ONE = 1.0E+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            BOTHV, FROMQR, LEFTV, NOINIT, PAIR, RIGHTV
      INTEGER            I, IINFO, K, KL, KLN, KR, KSI, KSR, LDWORK
      REAL               BIGNUM, EPS3, HNORM, SMLNUM, ULP, UNFL, WKI,
     $                   WKR
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      REAL               SLAMCH, SLANHS
      EXTERNAL           LSAME, SLAMCH, SLANHS
*     ..
*     .. External Subroutines ..
      EXTERNAL           SLAEIN, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, MAX
*     ..
*     .. Executable Statements ..
*
*     Decode and test the input parameters.
*
      BOTHV = LSAME( SIDE, 'B' )
      RIGHTV = LSAME( SIDE, 'R' ) .OR. BOTHV
      LEFTV = LSAME( SIDE, 'L' ) .OR. BOTHV
*
      FROMQR = LSAME( EIGSRC, 'Q' )
*
      NOINIT = LSAME( INITV, 'N' )
*
*     Set M to the number of columns required to store the selected
*     eigenvectors, and standardize the array SELECT.
*
      M = 0
      PAIR = .FALSE.
      DO 10 K = 1, N
         IF( PAIR ) THEN
            PAIR = .FALSE.
            SELECT( K ) = .FALSE.
         ELSE
            IF( WI( K ).EQ.ZERO ) THEN
               IF( SELECT( K ) )
     $            M = M + 1
            ELSE
               PAIR = .TRUE.
               IF( SELECT( K ) .OR. SELECT( K+1 ) ) THEN
                  SELECT( K ) = .TRUE.
                  M = M + 2
               END IF
            END IF
         END IF
   10 CONTINUE
*
      INFO = 0
      IF( .NOT.RIGHTV .AND. .NOT.LEFTV ) THEN
         INFO = -1
      ELSE IF( .NOT.FROMQR .AND. .NOT.LSAME( EIGSRC, 'N' ) ) THEN
         INFO = -2
      ELSE IF( .NOT.NOINIT .AND. .NOT.LSAME( INITV, 'U' ) ) THEN
         INFO = -3
      ELSE IF( N.LT.0 ) THEN
         INFO = -5
      ELSE IF( LDH.LT.MAX( 1, N ) ) THEN
         INFO = -7
      ELSE IF( LDVL.LT.1 .OR. ( LEFTV .AND. LDVL.LT.N ) ) THEN
         INFO = -11
      ELSE IF( LDVR.LT.1 .OR. ( RIGHTV .AND. LDVR.LT.N ) ) THEN
         INFO = -13
      ELSE IF( MM.LT.M ) THEN
         INFO = -14
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'SHSEIN', -INFO )
         RETURN
      END IF
*
*     Quick return if possible.
*
      IF( N.EQ.0 )
     $   RETURN
*
*     Set machine-dependent constants.
*
      UNFL = SLAMCH( 'Safe minimum' )
      ULP = SLAMCH( 'Precision' )
      SMLNUM = UNFL*( N / ULP )
      BIGNUM = ( ONE-ULP ) / SMLNUM
*
      LDWORK = N + 1
*
      KL = 1
      KLN = 0
      IF( FROMQR ) THEN
         KR = 0
      ELSE
         KR = N
      END IF
      KSR = 1
*
      DO 120 K = 1, N
         IF( SELECT( K ) ) THEN
*
*           Compute eigenvector(s) corresponding to W(K).
*
            IF( FROMQR ) THEN
*
*              If affiliation of eigenvalues is known, check whether
*              the matrix splits.
*
*              Determine KL and KR such that 1 <= KL <= K <= KR <= N
*              and H(KL,KL-1) and H(KR+1,KR) are zero (or KL = 1 or
*              KR = N).
*
*              Then inverse iteration can be performed with the
*              submatrix H(KL:N,KL:N) for a left eigenvector, and with
*              the submatrix H(1:KR,1:KR) for a right eigenvector.
*
               DO 20 I = K, KL + 1, -1
                  IF( H( I, I-1 ).EQ.ZERO )
     $               GO TO 30
   20          CONTINUE
   30          CONTINUE
               KL = I
               IF( K.GT.KR ) THEN
                  DO 40 I = K, N - 1
                     IF( H( I+1, I ).EQ.ZERO )
     $                  GO TO 50
   40             CONTINUE
   50             CONTINUE
                  KR = I
               END IF
            END IF
*
            IF( KL.NE.KLN ) THEN
               KLN = KL
*
*              Compute infinity-norm of submatrix H(KL:KR,KL:KR) if it
*              has not ben computed before.
*
               HNORM = SLANHS( 'I', KR-KL+1, H( KL, KL ), LDH, WORK )
               IF( HNORM.GT.ZERO ) THEN
                  EPS3 = HNORM*ULP
               ELSE
                  EPS3 = SMLNUM
               END IF
            END IF
*
*           Perturb eigenvalue if it is close to any previous
*           selected eigenvalues affiliated to the submatrix
*           H(KL:KR,KL:KR). Close roots are modified by EPS3.
*
            WKR = WR( K )
            WKI = WI( K )
   60       CONTINUE
            DO 70 I = K - 1, KL, -1
               IF( SELECT( I ) .AND. ABS( WR( I )-WKR )+
     $             ABS( WI( I )-WKI ).LT.EPS3 ) THEN
                  WKR = WKR + EPS3
                  GO TO 60
               END IF
   70       CONTINUE
            WR( K ) = WKR
*
            PAIR = WKI.NE.ZERO
            IF( PAIR ) THEN
               KSI = KSR + 1
            ELSE
               KSI = KSR
            END IF
            IF( LEFTV ) THEN
*
*              Compute left eigenvector.
*
               CALL SLAEIN( .FALSE., NOINIT, N-KL+1, H( KL, KL ), LDH,
     $                      WKR, WKI, VL( KL, KSR ), VL( KL, KSI ),
     $                      WORK, LDWORK, WORK( N*N+N+1 ), EPS3, SMLNUM,
     $                      BIGNUM, IINFO )
               IF( IINFO.GT.0 ) THEN
                  IF( PAIR ) THEN
                     INFO = INFO + 2
                  ELSE
                     INFO = INFO + 1
                  END IF
                  IFAILL( KSR ) = K
                  IFAILL( KSI ) = K
               ELSE
                  IFAILL( KSR ) = 0
                  IFAILL( KSI ) = 0
               END IF
               DO 80 I = 1, KL - 1
                  VL( I, KSR ) = ZERO
   80          CONTINUE
               IF( PAIR ) THEN
                  DO 90 I = 1, KL - 1
                     VL( I, KSI ) = ZERO
   90             CONTINUE
               END IF
            END IF
            IF( RIGHTV ) THEN
*
*              Compute right eigenvector.
*
               CALL SLAEIN( .TRUE., NOINIT, KR, H, LDH, WKR, WKI,
     $                      VR( 1, KSR ), VR( 1, KSI ), WORK, LDWORK,
     $                      WORK( N*N+N+1 ), EPS3, SMLNUM, BIGNUM,
     $                      IINFO )
               IF( IINFO.GT.0 ) THEN
                  IF( PAIR ) THEN
                     INFO = INFO + 2
                  ELSE
                     INFO = INFO + 1
                  END IF
                  IFAILR( KSR ) = K
                  IFAILR( KSI ) = K
               ELSE
                  IFAILR( KSR ) = 0
                  IFAILR( KSI ) = 0
               END IF
               DO 100 I = KR + 1, N
                  VR( I, KSR ) = ZERO
  100          CONTINUE
               IF( PAIR ) THEN
                  DO 110 I = KR + 1, N
                     VR( I, KSI ) = ZERO
  110             CONTINUE
               END IF
            END IF
*
            IF( PAIR ) THEN
               KSR = KSR + 2
            ELSE
               KSR = KSR + 1
            END IF
         END IF
  120 CONTINUE
*
      RETURN
*
*     End of SHSEIN
*
      END

C
C	$Id: wmdrfs.f,v 1.4 2008-07-27 00:17:36 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE WMDRFS(X1,Y1,X2,Y2)
C
C  Draw a line of width SLINWD from (X1,Y1) to (X2,Y2).
C
      PARAMETER (NDIM=4)
C
      include 'wmcomn.h'
C
      DIMENSION XL(NDIM),YL(NDIM),REFX(NDIM),REFY(NDIM)
C
C  Save the current fill attributes and reset.
C
      CALL GQFACI(IER,ICOLD)
      CALL GQFAIS(IER,IFOLD)
      CALL GSFACI(ICOLOR)
      CALL GSFAIS(1)
C
C  Set up a reference rectangle.
C
      D  = SQRT((Y2-Y1)**2+(X2-X1)**2)
      HLFW = 0.5*SLINWD
      REFX(1) = 0.
      REFX(2) = D
      REFX(3) = D
      REFX(4) = 0.
      REFY(1) = -HLFW
      REFY(2) = -HLFW
      REFY(3) =  HLFW
      REFY(4) =  HLFW
C
C  Rotate the reference rectangle.
C
      COSANG = (X2-X1)/D
      SINANG = (Y2-Y1)/D
      DO 20 I=1,NDIM
        XL(I) = REFX(I)*COSANG-REFY(I)*SINANG
        YL(I) = REFX(I)*SINANG+REFY(I)*COSANG
   20 CONTINUE
C
C  Translate.
C
      DO 40 I=1,NDIM
        XL(I) = X1+XL(I)
        YL(I) = Y1+YL(I)
   40 CONTINUE
C
      CALL GFA(NDIM,XL,YL)
C
C  Restore fill attributes.
C
      CALL GSFACI(ICOLD)
      CALL GSFAIS(IFOLD)
C
      RETURN
      END

      subroutine drotg(da,db,c,s)
c
c     construct givens plane rotation.
c     jack dongarra, linpack, 3/11/78.
c
      double precision da,db,c,s,roe,scale,r,z
c
      roe = db
      if( dabs(da) .gt. dabs(db) ) roe = da
      scale = dabs(da) + dabs(db)
      if( scale .ne. 0.0d0 ) go to 10
         c = 1.0d0
         s = 0.0d0
         r = 0.0d0
         z = 0.0d0
         go to 20
   10 r = scale*dsqrt((da/scale)**2 + (db/scale)**2)
      r = dsign(1.0d0,roe)*r
      c = da/r
      s = db/r
      z = 1.0d0
      if( dabs(da) .gt. dabs(db) ) z = s
      if( dabs(db) .ge. dabs(da) .and. c .ne. 0.0d0 ) z = 1.0d0/c
   20 da = r
      db = z
      return
      end

C
C $Id: kfpy.f,v 1.7 2008-07-27 00:17:24 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      FUNCTION KFPY (RY)
C
C Given a Y coordinate RY in the fractional system, KFPY(RY) is a Y
C coordinate in the plotter system.
C
      COMMON /IUTLCM/ LL,MI,MX,MY,IU(96)
      SAVE /IUTLCM/
      KFPY=1+INT(RY*(2.**MX-1.))
      RETURN
      END

      SUBROUTINE SGBRFS( TRANS, N, KL, KU, NRHS, AB, LDAB, AFB, LDAFB,
     $                   IPIV, B, LDB, X, LDX, FERR, BERR, WORK, IWORK,
     $                   INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER          TRANS
      INTEGER            INFO, KL, KU, LDAB, LDAFB, LDB, LDX, N, NRHS
*     ..
*     .. Array Arguments ..
      INTEGER            IPIV( * ), IWORK( * )
      REAL               AB( LDAB, * ), AFB( LDAFB, * ), B( LDB, * ),
     $                   BERR( * ), FERR( * ), WORK( * ), X( LDX, * )
*     ..
*
*  Purpose
*  =======
*
*  SGBRFS improves the computed solution to a system of linear
*  equations when the coefficient matrix is banded, and provides
*  error bounds and backward error estimates for the solution.
*
*  Arguments
*  =========
*
*  TRANS   (input) CHARACTER*1
*          Specifies the form of the system of equations:
*          = 'N':  A * X = B     (No transpose)
*          = 'T':  A**T * X = B  (Transpose)
*          = 'C':  A**H * X = B  (Conjugate transpose = Transpose)
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  KL      (input) INTEGER
*          The number of subdiagonals within the band of A.  KL >= 0.
*
*  KU      (input) INTEGER
*          The number of superdiagonals within the band of A.  KU >= 0.
*
*  NRHS    (input) INTEGER
*          The number of right hand sides, i.e., the number of columns
*          of the matrices B and X.  NRHS >= 0.
*
*  AB      (input) REAL array, dimension (LDAB,N)
*          The original band matrix A, stored in rows 1 to KL+KU+1.
*          The j-th column of A is stored in the j-th column of the
*          array AB as follows:
*          AB(ku+1+i-j,j) = A(i,j) for max(1,j-ku)<=i<=min(n,j+kl).
*
*  LDAB    (input) INTEGER
*          The leading dimension of the array AB.  LDAB >= KL+KU+1.
*
*  AFB     (input) REAL array, dimension (LDAFB,N)
*          Details of the LU factorization of the band matrix A, as
*          computed by SGBTRF.  U is stored as an upper triangular band
*          matrix with KL+KU superdiagonals in rows 1 to KL+KU+1, and
*          the multipliers used during the factorization are stored in
*          rows KL+KU+2 to 2*KL+KU+1.
*
*  LDAFB   (input) INTEGER
*          The leading dimension of the array AFB.  LDAFB >= 2*KL*KU+1.
*
*  IPIV    (input) INTEGER array, dimension (N)
*          The pivot indices from SGBTRF; for 1<=i<=N, row i of the
*          matrix was interchanged with row IPIV(i).
*
*  B       (input) REAL array, dimension (LDB,NRHS)
*          The right hand side matrix B.
*
*  LDB     (input) INTEGER
*          The leading dimension of the array B.  LDB >= max(1,N).
*
*  X       (input/output) REAL array, dimension (LDX,NRHS)
*          On entry, the solution matrix X, as computed by SGBTRS.
*          On exit, the improved solution matrix X.
*
*  LDX     (input) INTEGER
*          The leading dimension of the array X.  LDX >= max(1,N).
*
*  FERR    (output) REAL array, dimension (NRHS)
*          The estimated forward error bound for each solution vector
*          X(j) (the j-th column of the solution matrix X).
*          If XTRUE is the true solution corresponding to X(j), FERR(j)
*          is an estimated upper bound for the magnitude of the largest
*          element in (X(j) - XTRUE) divided by the magnitude of the
*          largest element in X(j).  The estimate is as reliable as
*          the estimate for RCOND, and is almost always a slight
*          overestimate of the true error.
*
*  BERR    (output) REAL array, dimension (NRHS)
*          The componentwise relative backward error of each solution
*          vector X(j) (i.e., the smallest relative change in
*          any element of A or B that makes X(j) an exact solution).
*
*  WORK    (workspace) REAL array, dimension (3*N)
*
*  IWORK   (workspace) INTEGER array, dimension (N)
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*
*  Internal Parameters
*  ===================
*
*  ITMAX is the maximum number of steps of iterative refinement.
*
*  =====================================================================
*
*     .. Parameters ..
      INTEGER            ITMAX
      PARAMETER          ( ITMAX = 5 )
      REAL               ZERO
      PARAMETER          ( ZERO = 0.0E+0 )
      REAL               ONE
      PARAMETER          ( ONE = 1.0E+0 )
      REAL               TWO
      PARAMETER          ( TWO = 2.0E+0 )
      REAL               THREE
      PARAMETER          ( THREE = 3.0E+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            NOTRAN
      CHARACTER          TRANST
      INTEGER            COUNT, I, J, K, KASE, KK, NZ
      REAL               EPS, LSTRES, S, SAFE1, SAFE2, SAFMIN, XK
*     ..
*     .. External Subroutines ..
      EXTERNAL           SAXPY, SCOPY, SGBMV, SGBTRS, SLACON, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, MAX, MIN
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      REAL               SLAMCH
      EXTERNAL           LSAME, SLAMCH
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      NOTRAN = LSAME( TRANS, 'N' )
      IF( .NOT.NOTRAN .AND. .NOT.LSAME( TRANS, 'T' ) .AND. .NOT.
     $    LSAME( TRANS, 'C' ) ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( KL.LT.0 ) THEN
         INFO = -3
      ELSE IF( KU.LT.0 ) THEN
         INFO = -4
      ELSE IF( NRHS.LT.0 ) THEN
         INFO = -5
      ELSE IF( LDAB.LT.KL+KU+1 ) THEN
         INFO = -7
      ELSE IF( LDAFB.LT.2*KL+KU+1 ) THEN
         INFO = -9
      ELSE IF( LDB.LT.MAX( 1, N ) ) THEN
         INFO = -12
      ELSE IF( LDX.LT.MAX( 1, N ) ) THEN
         INFO = -14
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'SGBRFS', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 .OR. NRHS.EQ.0 ) THEN
         DO 10 J = 1, NRHS
            FERR( J ) = ZERO
            BERR( J ) = ZERO
   10    CONTINUE
         RETURN
      END IF
*
      IF( NOTRAN ) THEN
         TRANST = 'T'
      ELSE
         TRANST = 'N'
      END IF
*
*     NZ = maximum number of nonzero elements in each row of A, plus 1
*
      NZ = MIN( KL+KU+2, N+1 )
      EPS = SLAMCH( 'Epsilon' )
      SAFMIN = SLAMCH( 'Safe minimum' )
      SAFE1 = NZ*SAFMIN
      SAFE2 = SAFE1 / EPS
*
*     Do for each right hand side
*
      DO 140 J = 1, NRHS
*
         COUNT = 1
         LSTRES = THREE
   20    CONTINUE
*
*        Loop until stopping criterion is satisfied.
*
*        Compute residual R = B - op(A) * X,
*        where op(A) = A, A**T, or A**H, depending on TRANS.
*
         CALL SCOPY( N, B( 1, J ), 1, WORK( N+1 ), 1 )
         CALL SGBMV( TRANS, N, N, KL, KU, -ONE, AB, LDAB, X( 1, J ), 1,
     $               ONE, WORK( N+1 ), 1 )
*
*        Compute componentwise relative backward error from formula
*
*        max(i) ( abs(R(i)) / ( abs(op(A))*abs(X) + abs(B) )(i) )
*
*        where abs(Z) is the componentwise absolute value of the matrix
*        or vector Z.  If the i-th component of the denominator is less
*        than SAFE2, then SAFE1 is added to the i-th components of the
*        numerator and denominator before dividing.
*
         DO 30 I = 1, N
            WORK( I ) = ABS( B( I, J ) )
   30    CONTINUE
*
*        Compute abs(op(A))*abs(X) + abs(B).
*
         IF( NOTRAN ) THEN
            DO 50 K = 1, N
               KK = KU + 1 - K
               XK = ABS( X( K, J ) )
               DO 40 I = MAX( 1, K-KU ), MIN( N, K+KL )
                  WORK( I ) = WORK( I ) + ABS( AB( KK+I, K ) )*XK
   40          CONTINUE
   50       CONTINUE
         ELSE
            DO 70 K = 1, N
               S = ZERO
               KK = KU + 1 - K
               DO 60 I = MAX( 1, K-KU ), MIN( N, K+KL )
                  S = S + ABS( AB( KK+I, K ) )*ABS( X( I, J ) )
   60          CONTINUE
               WORK( K ) = WORK( K ) + S
   70       CONTINUE
         END IF
         S = ZERO
         DO 80 I = 1, N
            IF( WORK( I ).GT.SAFE2 ) THEN
               S = MAX( S, ABS( WORK( N+I ) ) / WORK( I ) )
            ELSE
               S = MAX( S, ( ABS( WORK( N+I ) )+SAFE1 ) /
     $             ( WORK( I )+SAFE1 ) )
            END IF
   80    CONTINUE
         BERR( J ) = S
*
*        Test stopping criterion. Continue iterating if
*           1) The residual BERR(J) is larger than machine epsilon, and
*           2) BERR(J) decreased by at least a factor of 2 during the
*              last iteration, and
*           3) At most ITMAX iterations tried.
*
         IF( BERR( J ).GT.EPS .AND. TWO*BERR( J ).LE.LSTRES .AND.
     $       COUNT.LE.ITMAX ) THEN
*
*           Update solution and try again.
*
            CALL SGBTRS( TRANS, N, KL, KU, 1, AFB, LDAFB, IPIV,
     $                   WORK( N+1 ), N, INFO )
            CALL SAXPY( N, ONE, WORK( N+1 ), 1, X( 1, J ), 1 )
            LSTRES = BERR( J )
            COUNT = COUNT + 1
            GO TO 20
         END IF
*
*        Bound error from formula
*
*        norm(X - XTRUE) / norm(X) .le. FERR =
*        norm( abs(inv(op(A)))*
*           ( abs(R) + NZ*EPS*( abs(op(A))*abs(X)+abs(B) ))) / norm(X)
*
*        where
*          norm(Z) is the magnitude of the largest component of Z
*          inv(op(A)) is the inverse of op(A)
*          abs(Z) is the componentwise absolute value of the matrix or
*             vector Z
*          NZ is the maximum number of nonzeros in any row of A, plus 1
*          EPS is machine epsilon
*
*        The i-th component of abs(R)+NZ*EPS*(abs(op(A))*abs(X)+abs(B))
*        is incremented by SAFE1 if the i-th component of
*        abs(op(A))*abs(X) + abs(B) is less than SAFE2.
*
*        Use SLACON to estimate the infinity-norm of the matrix
*           inv(op(A)) * diag(W),
*        where W = abs(R) + NZ*EPS*( abs(op(A))*abs(X)+abs(B) )))
*
         DO 90 I = 1, N
            IF( WORK( I ).GT.SAFE2 ) THEN
               WORK( I ) = ABS( WORK( N+I ) ) + NZ*EPS*WORK( I )
            ELSE
               WORK( I ) = ABS( WORK( N+I ) ) + NZ*EPS*WORK( I ) + SAFE1
            END IF
   90    CONTINUE
*
         KASE = 0
  100    CONTINUE
         CALL SLACON( N, WORK( 2*N+1 ), WORK( N+1 ), IWORK, FERR( J ),
     $                KASE )
         IF( KASE.NE.0 ) THEN
            IF( KASE.EQ.1 ) THEN
*
*              Multiply by diag(W)*inv(op(A)**T).
*
               CALL SGBTRS( TRANST, N, KL, KU, 1, AFB, LDAFB, IPIV,
     $                      WORK( N+1 ), N, INFO )
               DO 110 I = 1, N
                  WORK( N+I ) = WORK( N+I )*WORK( I )
  110          CONTINUE
            ELSE
*
*              Multiply by inv(op(A))*diag(W).
*
               DO 120 I = 1, N
                  WORK( N+I ) = WORK( N+I )*WORK( I )
  120          CONTINUE
               CALL SGBTRS( TRANS, N, KL, KU, 1, AFB, LDAFB, IPIV,
     $                      WORK( N+1 ), N, INFO )
            END IF
            GO TO 100
         END IF
*
*        Normalize error.
*
         LSTRES = ZERO
         DO 130 I = 1, N
            LSTRES = MAX( LSTRES, ABS( X( I, J ) ) )
  130    CONTINUE
         IF( LSTRES.NE.ZERO )
     $      FERR( J ) = FERR( J ) / LSTRES
*
  140 CONTINUE
*
      RETURN
*
*     End of SGBRFS
*
      END

C
C	$Id: csarclen.f,v 1.6 2008-07-27 03:10:05 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      DOUBLE PRECISION FUNCTION CSARCLEN (P,Q)
      DOUBLE PRECISION P(3), Q(3)
C
C***********************************************************
C
C                                              From SSRFPACK
C                                            Robert J. Renka
C                                  Dept. of Computer Science
C                                       Univ. of North Texas
C                                           renka@cs.unt.edu
C                                                   05/09/92
C
C   This function computes the arc-length (angle in radians)
C between a pair of points on the unit sphere.
C
C On input:
C
C       P,Q = Arrays of length 3 containing the X, Y, and Z
C             coordinates (in that order) of points on the
C             unit sphere.
C
C Input parameters are not altered by this function.
C
C On output:
C
C       CSARCLEN = Angle in radians between the unit vectors
C                P and Q.  0 .LE. CSARCLEN .LE. PI.
C
C Modules required by CSARCLEN:  None
C
C Intrinsic functions called by CSARCLEN:  ATAN, SQRT
C
C***********************************************************
C
      INTEGER I
      DOUBLE PRECISION D
C
C Local parameters:
C
C D = Euclidean norm squared of P+Q
C I = DO-loop index
C
      D = 0.
      DO 1 I = 1,3
        D = D + (P(I) + Q(I))**2
    1   CONTINUE
      IF (D .EQ. 0.) THEN
C
C P and Q are separated by 180 degrees.
C
        CSARCLEN = 4.D0*ATAN(1.D0)
      ELSEIF (D .GE. 4.D0) THEN
C
C P and Q coincide.
C
        CSARCLEN = 0.
      ELSE
        CSARCLEN = 2.D0*ATAN(SQRT((4.D0-D)/D))
      ENDIF
      RETURN
      END

C
C $Id: isgfxy.f,v 1.5 2008-07-27 00:17:16 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE ISGFXY (X,Y,RMX,RMY)
C
C This routine, given two coordinates of a point on the current slab,
C supplies the missing third coordinate and computes the fractional
C coordinates of the projection of that point on the plotter frame.
C
      COMMON /ISCOMN/ BIG,BIGD,DBPI,IDONE,IFILL,IFLIP,IONES,IHSS(1000),
     +                IREF,ISCA(16,256),ISCALE,ISCR(16,256),ISLBT,ISDR,
     +                LHSS,LX,NFPW,NINU,NINV,NINW,NX,NY,R0,RNX,RNY,
     +                SMALL,SVAL,TENSN,U,V,W,XMAX,XMIN,YMAX,YMIN,XVPL,
     +                XVPR,YVPB,YVPT
      SAVE   /ISCOMN/
C
C Arithmetic statement functions for scaling.
C
      SU(UTEMP) = UTEMP
      SV(VTEMP) = VTEMP
      SW(WTEMP) = WTEMP
C
      XX = X
      YY = Y
      IF (ISLBT) 10,20,30
   10 CALL ISTR32 (SU(U),SV(XX-1.),SW(YY-1.),RMX,RMY,DUM,2)
      GO TO  40
   20 CALL ISTR32 (SU(XX-1.),SV(V),SW(YY-1.),RMX,RMY,DUM,2)
      GO TO  40
   30 CALL ISTR32 (SU(XX-1.),SV(YY-1.),SW(W),RMX,RMY,DUM,2)
   40 RETURN
C
      END

C
C $Id: pcgtdi.f,v 1.11 2008-07-27 00:17:19 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE PCGTDI (CHRS,NCHR,ICHR,NUMV)
C
C The subroutine PCGTDI gets an optionally signed decimal integer from
C the character string CHRS.  Its arguments are as follows:
C
C   CHRS is an input variable.  It contains a character string.
C
C   NCHR is an input variable specifying the number of characters in
C   CHRS.
C
C   ICHR is both an input variable and an output variable.  On entry,
C   it contains the index of the character in CHRS immediately after
C   which a decimal integer may occur.  On exit, it contains the index
C   of the last character of the integer, if one was found; otherwise,
C   it is unchanged.
C
C   NUMV is an output variable containing the value of the decimal
C   integer found.  The value zero indicates that no such integer was
C   found.
C
C COMMON block declarations.
C
      COMMON /PCSVEM/ ICOD,IDDA(8625),IDDL,RDGU(7000),IDPC(256),IERU,
     +                INDA(789),INDL,INIT,IVCO,IVDU,NBPW,NPPW
      SAVE   /PCSVEM/
C
      CHARACTER*(*) CHRS
C
C Initialize the value of the sign multiplier and the number.
C
      ISGN=1
      NUMV=0
C
C Increment the character index to the possible beginning of the number.
C
      ICHR=ICHR+1
C
C If there are at least two characters past this point in the string,
C look for a sign.
C
      IF (ICHR.LT.NCHR) THEN
        IF (CHRS(ICHR:ICHR).EQ.'-') THEN
          ISGN=-1
          ICHR=ICHR+1
        ELSE IF (CHRS(ICHR:ICHR).EQ.'+') THEN
          ISGN=1
          ICHR=ICHR+1
        ELSE IF (IDPC(ICHAR(CHRS(ICHR:ICHR))).LT.27.OR.
     +           IDPC(ICHAR(CHRS(ICHR:ICHR))).GT.36) THEN
          ISGN=0
        END IF
      END IF
C
C If we haven't found any character implying that no decimal integer
C starts at character index ICHR, find the numeric value.
C
      IF (ISGN.NE.0) THEN
        CALL PCGTPI (CHRS,NCHR,ICHR,10,NUMV)
      END IF
C
C Tack on the proper sign.
C
      NUMV=ISGN*NUMV
C
C Decrement the character index.
C
      ICHR=ICHR-1
C
C Done.
C
      RETURN
C
      END

C NCLFORTSTART
      subroutine patcor1 (mlon,nlat,x,y,xmsg,ymsg,w, r, ier)

c compute the patternanomaly correlation: 1-dimensional weight array 

c nomenclature:
c INPUT  
c .    mlon, nlat  - dimension sizes
c .    x,y         - arrays/grids 
c .    xmsg,ymsg   - missing codes [if none set to some value]
c .    w           - contains weights specified by user [eg: gaussian wgts]
c OUTPUT 
c .    r           - anomaly (pattern) correlation
c .    ier         - error code
c .                  =0  no errors
c .                  =1  x or y contains all msg values
c .                  =2  x or y contains all constant values
c
      implicit none
c                                               !  INPUT
      integer  mlon, nlat, ier
      double precision x(mlon,nlat), y(mlon,nlat), w(nlat), xmsg, ymsg
c                                               !  OUTPUT
      double precision r
C NCLEND
c                                               !  LOCAL
      integer ml, nl
      double precision xave , yave , wsum
      double precision xycov, xanom2, yanom2

      ier    = 0

c wgted area mean

      xave = 0.0d0
      yave = 0.0d0
      wsum = 0.0d0
      do nl=1,nlat
        do ml=1,mlon
           if (x(ml,nl).ne.xmsg .and. y(ml,nl).ne.ymsg) then 
               xave = xave + w(nl)*x(ml,nl)
               yave = yave + w(nl)*y(ml,nl)
               wsum = wsum + w(nl)
           end if
        end do
      end do

c all missing?

      if (wsum.eq.0.0d0) then
          ier = 1
          r   = xmsg
          return
      end if
      
      xave = xave/wsum
      yave = yave/wsum

c covariance and anomalies

      xycov  = 0.0d0
      xanom2 = 0.0d0
      yanom2 = 0.0d0
      
      do nl=1,nlat
        do ml=1,mlon
           if (x(ml,nl).ne.xmsg .and. y(ml,nl).ne.ymsg) then 
               xycov  = xycov  + w(nl)*(x(ml,nl)-xave)*(y(ml,nl)-yave)
               xanom2 = xanom2 + w(nl)*(x(ml,nl)-xave)**2
               yanom2 = yanom2 + w(nl)*(y(ml,nl)-yave)**2
           end if
        end do
      end do

      if (xanom2.gt.0.0d0 .and. yanom2.gt.0.0d0) then
          r   = xycov/(sqrt(xanom2)*sqrt(yanom2))
      else
          ier = 2
          r   = xmsg
      end if

      return
      end
c ======================================================
C NCLFORTSTART
      subroutine patcor2 (mlon,nlat,x,y,xmsg,ymsg,w, r, ier)

c compute the pattern anomaly correlation: 2-dimensional weight array 

c nomenclature:
c INPUT  
c .    mlon, nlat  - dimension sizes
c .    x,y         - arrays/grids 
c .    xmsg,ymsg   - missing codes [if none set to some value]
c .    w           - contains weights specified by user [eg: POP area]
c OUTPUT 
c .    r           - anomaly (pattern) correlation
c .    ier         - error code
c .                  =0  no errors
c .                  =1  x or y contains all msg values
c .                  =2  x or y contains all constant values
c
      implicit none
c                                               !  INPUT
      integer  mlon, nlat, ier
      double precision x(mlon,nlat), y(mlon,nlat), w(mlon,nlat)
     $               , xmsg, ymsg
c                                               !  OUTPUT
      double precision r
C NCLEND
c                                               !  LOCAL
      integer ml, nl
      double precision xave , yave , wsum
      double precision xycov, xanom2, yanom2

      ier    = 0

c wgted area mean

      xave = 0.0d0
      yave = 0.0d0
      wsum = 0.0d0
      do nl=1,nlat
        do ml=1,mlon
           if (x(ml,nl).ne.xmsg .and. y(ml,nl).ne.ymsg) then 
               xave = xave + w(ml,nl)*x(ml,nl)
               yave = yave + w(ml,nl)*y(ml,nl)
               wsum = wsum + w(ml,nl)
           end if
        end do
      end do

c all missing?

      if (wsum.eq.0.0d0) then
          ier = 1
          r   = xmsg
          return
      end if
      
      xave = xave/wsum
      yave = yave/wsum

c covariance and anomalies

      xycov  = 0.0d0
      xanom2 = 0.0d0
      yanom2 = 0.0d0
      
      do nl=1,nlat
        do ml=1,mlon
           if (x(ml,nl).ne.xmsg .and. y(ml,nl).ne.ymsg) then 
               xycov  = xycov  +w(ml,nl)*(x(ml,nl)-xave)*(y(ml,nl)-yave)
               xanom2 = xanom2 +w(ml,nl)*(x(ml,nl)-xave)**2
               yanom2 = yanom2 +w(ml,nl)*(y(ml,nl)-yave)**2
           end if
        end do
      end do

      if (xanom2.gt.0.0d0 .and. yanom2.gt.0.0d0) then
          r   = xycov/(sqrt(xanom2)*sqrt(yanom2))
      else
          ier = 2
          r   = xmsg
      end if

      return
      end

C
C $Id: tdlblp.f,v 1.2 2008-07-27 00:17:32 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE TDLBLP (AXIS,VLBL,PLBL)
C
        CHARACTER*1 AXIS
C
C AXIS is a single alphabetic character copied from the beginning of a
C string containing numeric labels to be used on a particular axis; it
C specifies how the label value passed in VLBL is to be used to compute
C a label position to be returned in PLBL.  The default version just
C puts the labels where their numeric values indicate they should go,
C but a user version may be supplied to modify the positions of numeric
C labels along any of the axes more or less at will.
C
        IF      (AXIS.EQ.'U') THEN
          PLBL=VLBL
        ELSE IF (AXIS.EQ.'V') THEN
          PLBL=VLBL
        ELSE IF (AXIS.EQ.'W') THEN
          PLBL=VLBL
        ELSE
          PLBL=VLBL
        END IF
C
        RETURN
C
      END

C
C $Id: mdgeti.f,v 1.9 2008-09-18 00:42:17 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MDGETI (WHCH,IVAL)
C
        CHARACTER*(*) WHCH
        INTEGER       IVAL
C
C Declare required common blocks.  See MAPBDX for descriptions of these
C common blocks and the variables in them.
C
        COMMON /MAPCM4/  GRDR,GRID,GRLA,GRLO,GRPO,OTOL,PDRE,PLA1,PLA2,
     +                   PLA3,PLA4,PLB1,PLB2,PLB3,PLB4,PLNO,PLTO,ROTA,
     +                   SRCH,XLOW,XROW,YBOW,YTOW,IDOT,IDSH,IDTL,ILCW,
     +                   ILTS,JPRJ,ELPF,INTF,LBLF,PRMF
        DOUBLE PRECISION GRDR,GRID,GRLA,GRLO,GRPO,OTOL,PDRE,PLA1,PLA2,
     +                   PLA3,PLA4,PLB1,PLB2,PLB3,PLB4,PLNO,PLTO,ROTA,
     +                   SRCH,XLOW,XROW,YBOW,YTOW
        INTEGER          IDOT,IDSH,IDTL,ILCW,ILTS,JPRJ
        LOGICAL          ELPF,INTF,LBLF,PRMF
        SAVE   /MAPCM4/
C
        COMMON /MAPCMA/  DATL,DBTD,DDTS,DPLT,DPSQ,DSCA,DSSQ
        DOUBLE PRECISION DATL,DBTD,DDTS,DPLT,DPSQ,DSCA,DSSQ
        SAVE   /MAPCMA/
C
        COMMON /MAPCMC/  IGI1,IGI2,NCRA,NOVS,XCRA(100),YCRA(100)
        INTEGER          IGI1,IGI2,NCRA,NOVS
        REAL             XCRA,YCRA
        SAVE   /MAPCMC/
C
        COMMON /MAPCMQ/  ICIN(8)
        INTEGER          ICIN
        SAVE   /MAPCMQ/
C
        COMMON /MAPRGD/  ICOL(5),ICSF(5),IDPF,LCRA,NILN,NILT,OLAT,OLON
        INTEGER          ICOL,ICSF,IDPF,LCRA,NILN,NILT
        REAL             OLAT,OLON
        SAVE   /MAPRGD/
C
        COMMON /MAPSAT/  ALFA,BETA,DCSA,DCSB,DSNA,DSNB,SALT,SSMO,SRSS
        DOUBLE PRECISION ALFA,BETA,DCSA,DCSB,DSNA,DSNB,SALT,SSMO,SRSS
        SAVE   /MAPSAT/
C
        IF (ICFELL('MDGETI - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
        IF      (WHCH(1:2).EQ.'C1'.OR.WHCH(1:2).EQ.'c1') THEN
          IVAL=ICIN(1)
        ELSE IF (WHCH(1:2).EQ.'C2'.OR.WHCH(1:2).EQ.'c2') THEN
          IVAL=ICIN(2)
        ELSE IF (WHCH(1:2).EQ.'C3'.OR.WHCH(1:2).EQ.'c3') THEN
          IVAL=ICIN(3)
        ELSE IF (WHCH(1:2).EQ.'C4'.OR.WHCH(1:2).EQ.'c4') THEN
          IVAL=ICIN(4)
        ELSE IF (WHCH(1:2).EQ.'C5'.OR.WHCH(1:2).EQ.'c5') THEN
          IVAL=ICIN(5)
        ELSE IF (WHCH(1:2).EQ.'C6'.OR.WHCH(1:2).EQ.'c6') THEN
          IVAL=ICIN(6)
        ELSE IF (WHCH(1:2).EQ.'C7'.OR.WHCH(1:2).EQ.'c7') THEN
          IVAL=ICIN(7)
        ELSE IF (WHCH(1:2).EQ.'C8'.OR.WHCH(1:2).EQ.'c8') THEN
          IVAL=ICIN(8)
        ELSE IF (WHCH(1:2).EQ.'DA'.OR.WHCH(1:2).EQ.'da') THEN
          IVAL=IDSH
        ELSE IF (WHCH(1:2).EQ.'DD'.OR.WHCH(1:2).EQ.'dd') THEN
          IVAL=INT(DDTS)
        ELSE IF (WHCH(1:2).EQ.'DL'.OR.WHCH(1:2).EQ.'dl') THEN
          IVAL=IDTL
        ELSE IF (WHCH(1:2).EQ.'DO'.OR.WHCH(1:2).EQ.'do') THEN
          IVAL=IDOT
        ELSE IF (WHCH(1:2).EQ.'EL'.OR.WHCH(1:2).EQ.'el') THEN
          IVAL=0
          IF (ELPF) IVAL=1
        ELSE IF (WHCH(1:2).EQ.'GN'.OR.WHCH(1:2).EQ.'gn') THEN
          IVAL=INT(GRLO)
        ELSE IF (WHCH(1:2).EQ.'GP'.OR.WHCH(1:2).EQ.'gp') THEN
          IVAL=INT(GRPO)
        ELSE IF (WHCH(1:2).EQ.'GR'.OR.WHCH(1:2).EQ.'gr') THEN
          IVAL=INT(GRID)
        ELSE IF (WHCH(1:2).EQ.'GT'.OR.WHCH(1:2).EQ.'gt') THEN
          IVAL=INT(GRLA)
        ELSE IF (WHCH(1:2).EQ.'G1'.OR.WHCH(1:2).EQ.'g1') THEN
          IVAL=IGI1
        ELSE IF (WHCH(1:2).EQ.'G2'.OR.WHCH(1:2).EQ.'g2') THEN
          IVAL=IGI2
        ELSE IF (WHCH(1:2).EQ.'IN'.OR.WHCH(1:2).EQ.'in') THEN
          IVAL=0
          IF (INTF) IVAL=1
        ELSE IF (WHCH(1:2).EQ.'II'.OR.WHCH(1:2).EQ.'ii') THEN
          IVAL=1000*NILT+NILN
        ELSE IF (WHCH(1:2).EQ.'LA'.OR.WHCH(1:2).EQ.'la') THEN
          IVAL=0
          IF (LBLF) IVAL=1
        ELSE IF (WHCH(1:2).EQ.'LS'.OR.WHCH(1:2).EQ.'ls') THEN
          IVAL=ILCW
        ELSE IF (WHCH(1:2).EQ.'MV'.OR.WHCH(1:2).EQ.'mv') THEN
          IVAL=INT(DPLT)
        ELSE IF (WHCH(1:2).EQ.'PE'.OR.WHCH(1:2).EQ.'pe') THEN
          IVAL=0
          IF (PRMF) IVAL=1
        ELSE IF (WHCH(1:2).EQ.'PN'.OR.WHCH(1:2).EQ.'pn') THEN
          IVAL=INT(PLNO)
        ELSE IF (WHCH(1:2).EQ.'PT'.OR.WHCH(1:2).EQ.'pt') THEN
          IVAL=INT(PLTO)
        ELSE IF (WHCH(1:2).EQ.'P1'.OR.WHCH(1:2).EQ.'p1') THEN
          IVAL=INT(PLA1)
        ELSE IF (WHCH(1:2).EQ.'P2'.OR.WHCH(1:2).EQ.'p2') THEN
          IVAL=INT(PLA2)
        ELSE IF (WHCH(1:2).EQ.'P3'.OR.WHCH(1:2).EQ.'p3') THEN
          IVAL=INT(PLA3)
        ELSE IF (WHCH(1:2).EQ.'P4'.OR.WHCH(1:2).EQ.'p4') THEN
          IVAL=INT(PLA4)
        ELSE IF (WHCH(1:2).EQ.'P5'.OR.WHCH(1:2).EQ.'p5') THEN
          IVAL=INT(PLB1)
        ELSE IF (WHCH(1:2).EQ.'P6'.OR.WHCH(1:2).EQ.'p6') THEN
          IVAL=INT(PLB2)
        ELSE IF (WHCH(1:2).EQ.'P7'.OR.WHCH(1:2).EQ.'p7') THEN
          IVAL=INT(PLB3)
        ELSE IF (WHCH(1:2).EQ.'P8'.OR.WHCH(1:2).EQ.'p8') THEN
          IVAL=INT(PLB4)
        ELSE IF (WHCH(1:2).EQ.'RE'.OR.WHCH(1:2).EQ.'re') THEN
          IVAL=INT(PDRE)
        ELSE IF (WHCH(1:2).EQ.'RO'.OR.WHCH(1:2).EQ.'ro') THEN
          IVAL=INT(ROTA)
        ELSE IF (WHCH(1:2).EQ.'RP'.OR.WHCH(1:2).EQ.'rp') THEN
          IVAL=IDPF
        ELSE IF (WHCH(1:2).EQ.'SA'.OR.WHCH(1:2).EQ.'sa') THEN
          IVAL=INT(SALT)
        ELSE IF (WHCH(1:2).EQ.'S1'.OR.WHCH(1:2).EQ.'s1') THEN
          IVAL=INT(ALFA)
        ELSE IF (WHCH(1:2).EQ.'S2'.OR.WHCH(1:2).EQ.'s2') THEN
          IVAL=INT(BETA)
        ELSE IF (WHCH(1:2).EQ.'VS'.OR.WHCH(1:2).EQ.'vs') THEN
          IVAL=NOVS
        ELSE
          GO TO 901
        END IF
C
C Done.
C
        RETURN
C
C Error exits.
C
  901   CALL MDPCEM ('MDGETI - UNKNOWN PARAMETER NAME ',WHCH,2,1)
        IVAL=0
        RETURN
C
      END

      subroutine crotg(ca,cb,c,s)
      complex ca,cb,s
      real c
      real norm,scale
      complex alpha
      if (cabs(ca) .ne. 0.) go to 10
         c = 0.
         s = (1.,0.)
         ca = cb
         go to 20
   10 continue
         scale = cabs(ca) + cabs(cb)
         norm = scale * sqrt((cabs(ca/scale))**2 + (cabs(cb/scale))**2)
         alpha = ca /cabs(ca)
         c = cabs(ca) / norm
         s = alpha * conjg(cb) / norm
         ca = alpha * norm
   20 continue
      return
      end

c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by UCAR                 .
c  .                                                             .
c  .       University Corporation for Atmospheric Research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                         SPHEREPACK                          .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c
c
c ... file vhags.f
c
c     this file contains code and documentation for subroutines
c     vhags and vhagsi
c
c ... files which must be loaded with vhags.f
c
c     sphcom.f, hrfft.f, gaqd.f
c
c     subroutine vhags(nlat,nlon,ityp,nt,v,w,idvw,jdvw,br,bi,cr,ci,
c    +                 mdab,ndab,wvhags,lvhags,work,lwork,ierror)
c
c     subroutine vhags performs the vector spherical harmonic analysis
c     on the vector field (v,w) and stores the result in the arrays
c     br, bi, cr, and ci. v(i,j) and w(i,j) are the colatitudinal
c     (measured from the north pole) and east longitudinal components
c     respectively, located at the gaussian colatitude point theta(i)
c     and longitude phi(j) = (j-1)*2*pi/nlon. the spectral
c     representation of (v,w) is given at output parameters v,w in
c     subroutine vhses.
c
c     input parameters
c
c     nlat   the number of points in the gaussian colatitude grid on the
C*PL*ERROR* Comment line too long
c            full sphere. these lie in the interval (0,pi) and are computed
C*PL*ERROR* Comment line too long
c            in radians in theta(1) <...< theta(nlat) by subroutine gaqd.
C*PL*ERROR* Comment line too long
c            if nlat is odd the equator will be included as the grid point
c            theta((nlat+1)/2).  if nlat is even the equator will be
c            excluded as a grid point and will lie half way between
c            theta(nlat/2) and theta(nlat/2+1). nlat must be at least 3.
c            note: on the half sphere, the number of grid points in the
c            colatitudinal direction is nlat/2 if nlat is even or
c            (nlat+1)/2 if nlat is odd.
c
c
c     nlon   the number of distinct londitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater
c            than zero. the axisymmetric case corresponds to nlon=1.
c            the efficiency of the computation is improved when nlon
c            is a product of small prime numbers.
c
c     ityp   = 0  no symmetries exist about the equator. the analysis
c                 is performed on the entire sphere.  i.e. on the
c                 arrays v(i,j),w(i,j) for i=1,...,nlat and
c                 j=1,...,nlon.
c
c            = 1  no symmetries exist about the equator. the analysis
c                 is performed on the entire sphere.  i.e. on the
c                 arrays v(i,j),w(i,j) for i=1,...,nlat and
c                 j=1,...,nlon. the curl of (v,w) is zero. that is,
c                 (d/dtheta (sin(theta) w) - dv/dphi)/sin(theta) = 0.
c                 the coefficients cr and ci are zero.
c
c            = 2  no symmetries exist about the equator. the analysis
c                 is performed on the entire sphere.  i.e. on the
c                 arrays v(i,j),w(i,j) for i=1,...,nlat and
c                 j=1,...,nlon. the divergence of (v,w) is zero. i.e.,
c                 (d/dtheta (sin(theta) v) + dw/dphi)/sin(theta) = 0.
c                 the coefficients br and bi are zero.
c
c            = 3  v is symmetric and w is antisymmetric about the
c                 equator. the analysis is performed on the northern
c                 hemisphere only.  i.e., if nlat is odd the analysis
c                 is performed on the arrays v(i,j),w(i,j) for
c                 i=1,...,(nlat+1)/2 and j=1,...,nlon. if nlat is
c                 even the analysis is performed on the the arrays
c                 v(i,j),w(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
c
c            = 4  v is symmetric and w is antisymmetric about the
c                 equator. the analysis is performed on the northern
c                 hemisphere only.  i.e., if nlat is odd the analysis
c                 is performed on the arrays v(i,j),w(i,j) for
c                 i=1,...,(nlat+1)/2 and j=1,...,nlon. if nlat is
c                 even the analysis is performed on the the arrays
c                 v(i,j),w(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
c                 the curl of (v,w) is zero. that is,
c                 (d/dtheta (sin(theta) w) - dv/dphi)/sin(theta) = 0.
c                 the coefficients cr and ci are zero.
c
c            = 5  v is symmetric and w is antisymmetric about the
c                 equator. the analysis is performed on the northern
c                 hemisphere only.  i.e., if nlat is odd the analysis
c                 is performed on the arrays v(i,j),w(i,j) for
c                 i=1,...,(nlat+1)/2 and j=1,...,nlon. if nlat is
c                 even the analysis is performed on the the arrays
c                 v(i,j),w(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
c                 the divergence of (v,w) is zero. i.e.,
c                 (d/dtheta (sin(theta) v) + dw/dphi)/sin(theta) = 0.
c                 the coefficients br and bi are zero.
c
c            = 6  v is antisymmetric and w is symmetric about the
c                 equator. the analysis is performed on the northern
c                 hemisphere only.  i.e., if nlat is odd the analysis
c                 is performed on the arrays v(i,j),w(i,j) for
c                 i=1,...,(nlat+1)/2 and j=1,...,nlon. if nlat is
c                 even the analysis is performed on the the arrays
c                 v(i,j),w(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
c
c            = 7  v is antisymmetric and w is symmetric about the
c                 equator. the analysis is performed on the northern
c                 hemisphere only.  i.e., if nlat is odd the analysis
c                 is performed on the arrays v(i,j),w(i,j) for
c                 i=1,...,(nlat+1)/2 and j=1,...,nlon. if nlat is
c                 even the analysis is performed on the the arrays
c                 v(i,j),w(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
c                 the curl of (v,w) is zero. that is,
c                 (d/dtheta (sin(theta) w) - dv/dphi)/sin(theta) = 0.
c                 the coefficients cr and ci are zero.
c
c            = 8  v is antisymmetric and w is symmetric about the
c                 equator. the analysis is performed on the northern
c                 hemisphere only.  i.e., if nlat is odd the analysis
c                 is performed on the arrays v(i,j),w(i,j) for
c                 i=1,...,(nlat+1)/2 and j=1,...,nlon. if nlat is
c                 even the analysis is performed on the the arrays
c                 v(i,j),w(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
c                 the divergence of (v,w) is zero. i.e.,
c                 (d/dtheta (sin(theta) v) + dw/dphi)/sin(theta) = 0.
c                 the coefficients br and bi are zero.
c
c
c     nt     the number of analyses.  in the program that calls vhags,
c            the arrays v,w,br,bi,cr, and ci can be three dimensional
c            in which case multiple analyses will be performed.
c            the third index is the analysis index which assumes the
c            values k=1,...,nt.  for a single analysis set nt=1. the
c            discription of the remaining parameters is simplified
c            by assuming that nt=1 or that all the arrays are two
c            dimensional.
c
c     v,w    two or three dimensional arrays (see input parameter nt)
c            that contain the vector function to be analyzed.
c            v is the colatitudnal component and w is the east
c            longitudinal component. v(i,j),w(i,j) contain the
c            components at the gaussian colatitude point theta(i)
c            and longitude phi(j) = (j-1)*2*pi/nlon. the index ranges
c            are defined above at the input parameter ityp.
c
c     idvw   the first dimension of the arrays v,w as it appears in
c            the program that calls vhags. if ityp .le. 2 then idvw
c            must be at least nlat.  if ityp .gt. 2 and nlat is
c            even then idvw must be at least nlat/2. if ityp .gt. 2
c            and nlat is odd then idvw must be at least (nlat+1)/2.
c
c     jdvw   the second dimension of the arrays v,w as it appears in
c            the program that calls vhags. jdvw must be at least nlon.
c
c     mdab   the first dimension of the arrays br,bi,cr, and ci as it
c            appears in the program that calls vhags. mdab must be at
c            least min0(nlat,nlon/2) if nlon is even or at least
c            min0(nlat,(nlon+1)/2) if nlon is odd.
c
c     ndab   the second dimension of the arrays br,bi,cr, and ci as it
c            appears in the program that calls vhags. ndab must be at
c            least nlat.
c
c     wvhags an array which must be initialized by subroutine vhgsi.
c            once initialized, wvhags can be used repeatedly by vhags
c            as long as nlon and nlat remain unchanged.  wvhags must
c            not be altered between calls of vhags.
c
c     lvhags the dimension of the array wvhags as it appears in the
c            program that calls vhags. define
c
c               l1 = min0(nlat,nlon/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            then lvhags must be at least
c
c            l1*l2(nlat+nlat-l1+1)+nlon+15
c
c        ??? (nlat+1)*(nlat+1)*nlat/2 + nlon + 15
c
c
c
c     work   a work array that does not have to be saved.
c
c     lwork  the dimension of the array work as it appears in the
c            program that calls vhags. define
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            if ityp .le. 2 then lwork must be at least
c            the larger of the two quantities
c
c               3*nlat*(nlat+1)+2  (required by vhagsi)
c
c            and
c
c               (2*nt+1)*nlat*nlon
c
c            if ityp .gt. 2 then lwork must be at least
c            the larger of the two quantities
c
c               3*nlat*(nlat+1)+2  (required by vhagsi)
c
c            and
c
c              (2*nt+1)*l2*nlon
c
c
c     **************************************************************
c
c     output parameters
c
c     br,bi  two or three dimensional arrays (see input parameter nt)
c     cr,ci  that contain the vector spherical harmonic coefficients
c            in the spectral representation of v(i,j) and w(i,j) given
c            in the discription of subroutine vhses. br(mp1,np1),
c            bi(mp1,np1),cr(mp1,np1), and ci(mp1,np1) are computed
c            for mp1=1,...,mmax and np1=mp1,...,nlat except for np1=nlat
c            and odd mp1. mmax=min0(nlat,nlon/2) if nlon is even or
c            mmax=min0(nlat,(nlon+1)/2) if nlon is odd.
c
c     ierror = 0  no errors
c            = 1  error in the specification of nlat
c            = 2  error in the specification of nlon
c            = 3  error in the specification of ityp
c            = 4  error in the specification of nt
c            = 5  error in the specification of idvw
c            = 6  error in the specification of jdvw
c            = 7  error in the specification of mdab
c            = 8  error in the specification of ndab
c            = 9  error in the specification of lvhags
c            = 10 error in the specification of lwork
c
c
c     subroutine vhagsi(nlat,nlon,wvhags,lvhags,work,lwork,ierror)
c
c     subroutine vhagsi initializes the array wvhags which can then be
c     used repeatedly by subroutine vhags until nlat or nlon is changed.
c
c     input parameters
c
c     nlat   the number of points in the gaussian colatitude grid on the
C*PL*ERROR* Comment line too long
c            full sphere. these lie in the interval (0,pi) and are computed
C*PL*ERROR* Comment line too long
c            in radians in theta(1) <...< theta(nlat) by subroutine gaqd.
C*PL*ERROR* Comment line too long
c            if nlat is odd the equator will be included as the grid point
c            theta((nlat+1)/2).  if nlat is even the equator will be
c            excluded as a grid point and will lie half way between
c            theta(nlat/2) and theta(nlat/2+1). nlat must be at least 3.
c            note: on the half sphere, the number of grid points in the
c            colatitudinal direction is nlat/2 if nlat is even or
c            (nlat+1)/2 if nlat is odd.
c
c     nlon   the number of distinct londitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater
c            than zero. the axisymmetric case corresponds to nlon=1.
c            the efficiency of the computation is improved when nlon
c            is a product of small prime numbers.
c
c     lvhags the dimension of the array wvhags as it appears in the
c            program that calls vhagsi.  define
c
c               l1 = min0(nlat,nlon/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            then lvhags must be at least
c
c               3*nlat*(nlat+1)+2  (required by vhagsi)
c
C*PL*ERROR* Comment line too long
c     dwork  a double precision work space that does not need to be saved
c
c     ldwork the dimension of the array dwork as it appears in the
c            program that calls vhagsi. ldwork must be at least
c
c                   (3*nlat*(nlat+3)+2)/2
c
c     **************************************************************
c
c     output parameters
c
c     wvhags an array which is initialized for use by subroutine vhags.
c            once initialized, wvhags can be used repeatedly by vhags
c            as long as nlat and nlon remain unchanged.  wvhags must not
c            be altered between calls of vhags.
c
c
c     ierror = 0  no errors
c            = 1  error in the specification of nlat
c            = 2  error in the specification of nlon
c            = 3  error in the specification of lvhags
c            = 4  error in the specification of ldwork
c
      SUBROUTINE DVHAGS(NLAT,NLON,ITYP,NT,V,W,IDVW,JDVW,BR,BI,CR,CI,
     +                  MDAB,NDAB,WVHAGS,LVHAGS,WORK,LWORK,IERROR)
      DOUBLE PRECISION V
      DOUBLE PRECISION W
      DOUBLE PRECISION BR
      DOUBLE PRECISION BI
      DOUBLE PRECISION CR
      DOUBLE PRECISION CI
      DOUBLE PRECISION WVHAGS
      DOUBLE PRECISION WORK
      DIMENSION V(IDVW,JDVW,1),W(IDVW,JDVW,1),BR(MDAB,NDAB,1),
     +          BI(MDAB,NDAB,1),CR(MDAB,NDAB,1),CI(MDAB,NDAB,1),WORK(1),
     +          WVHAGS(1)

      IERROR = 1
      IF (NLAT.LT.3) RETURN
      IERROR = 2
      IF (NLON.LT.1) RETURN
      IERROR = 3
      IF (ITYP.LT.0 .OR. ITYP.GT.8) RETURN
      IERROR = 4
      IF (NT.LT.0) RETURN
      IERROR = 5
      IMID = (NLAT+1)/2
      IF ((ITYP.LE.2.AND.IDVW.LT.NLAT) .OR.
     +    (ITYP.GT.2.AND.IDVW.LT.IMID)) RETURN
      IERROR = 6
      IF (JDVW.LT.NLON) RETURN
      IERROR = 7
      MMAX = MIN0(NLAT, (NLON+1)/2)
      IF (MDAB.LT.MMAX) RETURN
      IERROR = 8
      IF (NDAB.LT.NLAT) RETURN
      IERROR = 9
      IDZ = (MMAX* (NLAT+NLAT-MMAX+1))/2
      LZIMN = IDZ*IMID
      IF (LVHAGS.LT.LZIMN+LZIMN+NLON+15) RETURN
      IERROR = 10
      IDV = NLAT
      IF (ITYP.GT.2) IDV = IMID
      LNL = NT*IDV*NLON
      IF (LWORK.LT.LNL+LNL+IDV*NLON) RETURN
      IERROR = 0
      IST = 0
      IF (ITYP.LE.2) IST = IMID
c
c     set wvhags pointers
c
      LMN = NLAT* (NLAT+1)/2
      JW1 = 1
      JW2 = JW1 + IMID*LMN
      JW3 = JW2 + IMID*LMN
c
c     set work pointers
c
      IW1 = IST + 1
      IW2 = LNL + 1
      IW3 = IW2 + IST
      IW4 = IW2 + LNL
      CALL DVHAGS1(NLAT,NLON,ITYP,NT,IMID,IDVW,JDVW,V,W,MDAB,NDAB,BR,
     +             BI,CR,CI,IDV,WORK,WORK(IW1),WORK(IW2),WORK(IW3),
     +             WORK(IW4),IDZ,WVHAGS(JW1),WVHAGS(JW2),WVHAGS(JW3))
      RETURN
      END

      SUBROUTINE DVHAGS1(NLAT,NLON,ITYP,NT,IMID,IDVW,JDVW,V,W,MDAB,NDAB,
     +                   BR,BI,CR,CI,IDV,VE,VO,WE,WO,WORK,IDZ,VB,WB,
     +                   WRFFT)
      DOUBLE PRECISION V
      DOUBLE PRECISION W
      DOUBLE PRECISION BR
      DOUBLE PRECISION BI
      DOUBLE PRECISION CR
      DOUBLE PRECISION CI
      DOUBLE PRECISION VE
      DOUBLE PRECISION VO
      DOUBLE PRECISION WE
      DOUBLE PRECISION WO
      DOUBLE PRECISION WORK
      DOUBLE PRECISION VB
      DOUBLE PRECISION WB
      DOUBLE PRECISION WRFFT
      DOUBLE PRECISION TSN
      DOUBLE PRECISION FSN
      DIMENSION V(IDVW,JDVW,1),W(IDVW,JDVW,1),BR(MDAB,NDAB,1),
     +          BI(MDAB,NDAB,1),CR(MDAB,NDAB,1),CI(MDAB,NDAB,1),
     +          VE(IDV,NLON,1),VO(IDV,NLON,1),WE(IDV,NLON,1),
     +          WO(IDV,NLON,1),WORK(1),VB(IMID,1),WB(IMID,1),WRFFT(1)

      NLP1 = NLAT + 1
      TSN = 2.D0/NLON
      FSN = 4.D0/NLON
      MLAT = MOD(NLAT,2)
      MLON = MOD(NLON,2)
      MMAX = MIN0(NLAT, (NLON+1)/2)
      IMM1 = IMID
      IF (MLAT.NE.0) IMM1 = IMID - 1
      IF (ITYP.GT.2) GO TO 3
      DO 5 K = 1,NT
          DO 5 I = 1,IMM1
              DO 5 J = 1,NLON
                  VE(I,J,K) = TSN* (V(I,J,K)+V(NLP1-I,J,K))
                  VO(I,J,K) = TSN* (V(I,J,K)-V(NLP1-I,J,K))
                  WE(I,J,K) = TSN* (W(I,J,K)+W(NLP1-I,J,K))
                  WO(I,J,K) = TSN* (W(I,J,K)-W(NLP1-I,J,K))
    5 CONTINUE
      GO TO 2
    3 DO 8 K = 1,NT
          DO 8 I = 1,IMM1
              DO 8 J = 1,NLON
                  VE(I,J,K) = FSN*V(I,J,K)
                  VO(I,J,K) = FSN*V(I,J,K)
                  WE(I,J,K) = FSN*W(I,J,K)
                  WO(I,J,K) = FSN*W(I,J,K)
    8 CONTINUE
    2 IF (MLAT.EQ.0) GO TO 7
      DO 6 K = 1,NT
          DO 6 J = 1,NLON
              VE(IMID,J,K) = TSN*V(IMID,J,K)
              WE(IMID,J,K) = TSN*W(IMID,J,K)
    6 CONTINUE
    7 DO 9 K = 1,NT
          CALL DHRFFTF(IDV,NLON,VE(1,1,K),IDV,WRFFT,WORK)
          CALL DHRFFTF(IDV,NLON,WE(1,1,K),IDV,WRFFT,WORK)
    9 CONTINUE
      NDO1 = NLAT
      NDO2 = NLAT
      IF (MLAT.NE.0) NDO1 = NLAT - 1
      IF (MLAT.EQ.0) NDO2 = NLAT - 1
      IF (ITYP.EQ.2 .OR. ITYP.EQ.5 .OR. ITYP.EQ.8) GO TO 11
      DO 10 K = 1,NT
          DO 10 MP1 = 1,MMAX
              DO 10 NP1 = MP1,NLAT
                  BR(MP1,NP1,K) = 0.D0
                  BI(MP1,NP1,K) = 0.D0
   10 CONTINUE
   11 IF (ITYP.EQ.1 .OR. ITYP.EQ.4 .OR. ITYP.EQ.7) GO TO 13
      DO 12 K = 1,NT
          DO 12 MP1 = 1,MMAX
              DO 12 NP1 = MP1,NLAT
                  CR(MP1,NP1,K) = 0.D0
                  CI(MP1,NP1,K) = 0.D0
   12 CONTINUE
   13 ITYPP = ITYP + 1
      GO TO (1,100,200,300,400,500,600,700,800) ITYPP
c
c     case ityp=0 ,  no symmetries
c
c     case m=0
c
    1 DO 15 K = 1,NT
          DO 15 I = 1,IMID
              DO 15 NP1 = 2,NDO2,2
                  BR(1,NP1,K) = BR(1,NP1,K) + VB(I,NP1)*VE(I,1,K)
                  CR(1,NP1,K) = CR(1,NP1,K) - VB(I,NP1)*WE(I,1,K)
   15 CONTINUE
      DO 16 K = 1,NT
          DO 16 I = 1,IMM1
              DO 16 NP1 = 3,NDO1,2
                  BR(1,NP1,K) = BR(1,NP1,K) + VB(I,NP1)*VO(I,1,K)
                  CR(1,NP1,K) = CR(1,NP1,K) - VB(I,NP1)*WO(I,1,K)
   16 CONTINUE
c
c     case m = 1 through nlat-1
c
      IF (MMAX.LT.2) RETURN
      DO 20 MP1 = 2,MMAX
          M = MP1 - 1
          MB = M*NLAT - (M* (M+1))/2
          MP2 = MP1 + 1
          IF (MP1.GT.NDO1) GO TO 17
          DO 23 K = 1,NT
              DO 23 I = 1,IMM1
                  DO 23 NP1 = MP1,NDO1,2
                      BR(MP1,NP1,K) = BR(MP1,NP1,K) +
     +                                VB(I,NP1+MB)*VO(I,2*MP1-2,K) +
     +                                WB(I,NP1+MB)*WE(I,2*MP1-1,K)
                      BI(MP1,NP1,K) = BI(MP1,NP1,K) +
     +                                VB(I,NP1+MB)*VO(I,2*MP1-1,K) -
     +                                WB(I,NP1+MB)*WE(I,2*MP1-2,K)
                      CR(MP1,NP1,K) = CR(MP1,NP1,K) -
     +                                VB(I,NP1+MB)*WO(I,2*MP1-2,K) +
     +                                WB(I,NP1+MB)*VE(I,2*MP1-1,K)
                      CI(MP1,NP1,K) = CI(MP1,NP1,K) -
     +                                VB(I,NP1+MB)*WO(I,2*MP1-1,K) -
     +                                WB(I,NP1+MB)*VE(I,2*MP1-2,K)
   23     CONTINUE
          IF (MLAT.EQ.0) GO TO 17
          DO 24 K = 1,NT
              DO 24 NP1 = MP1,NDO1,2
                  BR(MP1,NP1,K) = BR(MP1,NP1,K) +
     +                            WB(IMID,NP1+MB)*WE(IMID,2*MP1-1,K)
                  BI(MP1,NP1,K) = BI(MP1,NP1,K) -
     +                            WB(IMID,NP1+MB)*WE(IMID,2*MP1-2,K)
                  CR(MP1,NP1,K) = CR(MP1,NP1,K) +
     +                            WB(IMID,NP1+MB)*VE(IMID,2*MP1-1,K)
                  CI(MP1,NP1,K) = CI(MP1,NP1,K) -
     +                            WB(IMID,NP1+MB)*VE(IMID,2*MP1-2,K)
   24     CONTINUE
   17     IF (MP2.GT.NDO2) GO TO 20
          DO 21 K = 1,NT
              DO 21 I = 1,IMM1
                  DO 21 NP1 = MP2,NDO2,2
                      BR(MP1,NP1,K) = BR(MP1,NP1,K) +
     +                                VB(I,NP1+MB)*VE(I,2*MP1-2,K) +
     +                                WB(I,NP1+MB)*WO(I,2*MP1-1,K)
                      BI(MP1,NP1,K) = BI(MP1,NP1,K) +
     +                                VB(I,NP1+MB)*VE(I,2*MP1-1,K) -
     +                                WB(I,NP1+MB)*WO(I,2*MP1-2,K)
                      CR(MP1,NP1,K) = CR(MP1,NP1,K) -
     +                                VB(I,NP1+MB)*WE(I,2*MP1-2,K) +
     +                                WB(I,NP1+MB)*VO(I,2*MP1-1,K)
                      CI(MP1,NP1,K) = CI(MP1,NP1,K) -
     +                                VB(I,NP1+MB)*WE(I,2*MP1-1,K) -
     +                                WB(I,NP1+MB)*VO(I,2*MP1-2,K)
   21     CONTINUE
          IF (MLAT.EQ.0) GO TO 20
          DO 22 K = 1,NT
              DO 22 NP1 = MP2,NDO2,2
                  BR(MP1,NP1,K) = BR(MP1,NP1,K) +
     +                            VB(IMID,NP1+MB)*VE(IMID,2*MP1-2,K)
                  BI(MP1,NP1,K) = BI(MP1,NP1,K) +
     +                            VB(IMID,NP1+MB)*VE(IMID,2*MP1-1,K)
                  CR(MP1,NP1,K) = CR(MP1,NP1,K) -
     +                            VB(IMID,NP1+MB)*WE(IMID,2*MP1-2,K)
                  CI(MP1,NP1,K) = CI(MP1,NP1,K) -
     +                            VB(IMID,NP1+MB)*WE(IMID,2*MP1-1,K)
   22     CONTINUE
   20 CONTINUE
      RETURN
c
c     case ityp=1 ,  no symmetries but cr and ci equal zero
c
c     case m=0
c
  100 DO 115 K = 1,NT
          DO 115 I = 1,IMID
              DO 115 NP1 = 2,NDO2,2
                  BR(1,NP1,K) = BR(1,NP1,K) + VB(I,NP1)*VE(I,1,K)
  115 CONTINUE
      DO 116 K = 1,NT
          DO 116 I = 1,IMM1
              DO 116 NP1 = 3,NDO1,2
                  BR(1,NP1,K) = BR(1,NP1,K) + VB(I,NP1)*VO(I,1,K)
  116 CONTINUE
c
c     case m = 1 through nlat-1
c
      IF (MMAX.LT.2) RETURN
      DO 120 MP1 = 2,MMAX
          M = MP1 - 1
          MB = M*NLAT - (M* (M+1))/2
          MP2 = MP1 + 1
          IF (MP1.GT.NDO1) GO TO 117
          DO 123 K = 1,NT
              DO 123 I = 1,IMM1
                  DO 123 NP1 = MP1,NDO1,2
                      BR(MP1,NP1,K) = BR(MP1,NP1,K) +
     +                                VB(I,NP1+MB)*VO(I,2*MP1-2,K) +
     +                                WB(I,NP1+MB)*WE(I,2*MP1-1,K)
                      BI(MP1,NP1,K) = BI(MP1,NP1,K) +
     +                                VB(I,NP1+MB)*VO(I,2*MP1-1,K) -
     +                                WB(I,NP1+MB)*WE(I,2*MP1-2,K)
  123     CONTINUE
          IF (MLAT.EQ.0) GO TO 117
          DO 124 K = 1,NT
              DO 124 NP1 = MP1,NDO1,2
                  BR(MP1,NP1,K) = BR(MP1,NP1,K) +
     +                            WB(IMID,NP1+MB)*WE(IMID,2*MP1-1,K)
                  BI(MP1,NP1,K) = BI(MP1,NP1,K) -
     +                            WB(IMID,NP1+MB)*WE(IMID,2*MP1-2,K)
  124     CONTINUE
  117     IF (MP2.GT.NDO2) GO TO 120
          DO 121 K = 1,NT
              DO 121 I = 1,IMM1
                  DO 121 NP1 = MP2,NDO2,2
                      BR(MP1,NP1,K) = BR(MP1,NP1,K) +
     +                                VB(I,NP1+MB)*VE(I,2*MP1-2,K) +
     +                                WB(I,NP1+MB)*WO(I,2*MP1-1,K)
                      BI(MP1,NP1,K) = BI(MP1,NP1,K) +
     +                                VB(I,NP1+MB)*VE(I,2*MP1-1,K) -
     +                                WB(I,NP1+MB)*WO(I,2*MP1-2,K)
  121     CONTINUE
          IF (MLAT.EQ.0) GO TO 120
          DO 122 K = 1,NT
              DO 122 NP1 = MP2,NDO2,2
                  BR(MP1,NP1,K) = BR(MP1,NP1,K) +
     +                            VB(IMID,NP1+MB)*VE(IMID,2*MP1-2,K)
                  BI(MP1,NP1,K) = BI(MP1,NP1,K) +
     +                            VB(IMID,NP1+MB)*VE(IMID,2*MP1-1,K)
  122     CONTINUE
  120 CONTINUE
      RETURN
c
c     case ityp=2 ,  no symmetries but br and bi equal zero
c
c     case m=0
c
  200 DO 215 K = 1,NT
          DO 215 I = 1,IMID
              DO 215 NP1 = 2,NDO2,2
                  CR(1,NP1,K) = CR(1,NP1,K) - VB(I,NP1)*WE(I,1,K)
  215 CONTINUE
      DO 216 K = 1,NT
          DO 216 I = 1,IMM1
              DO 216 NP1 = 3,NDO1,2
                  CR(1,NP1,K) = CR(1,NP1,K) - VB(I,NP1)*WO(I,1,K)
  216 CONTINUE
c
c     case m = 1 through nlat-1
c
      IF (MMAX.LT.2) RETURN
      DO 220 MP1 = 2,MMAX
          M = MP1 - 1
          MB = M*NLAT - (M* (M+1))/2
          MP2 = MP1 + 1
          IF (MP1.GT.NDO1) GO TO 217
          DO 223 K = 1,NT
              DO 223 I = 1,IMM1
                  DO 223 NP1 = MP1,NDO1,2
                      CR(MP1,NP1,K) = CR(MP1,NP1,K) -
     +                                VB(I,NP1+MB)*WO(I,2*MP1-2,K) +
     +                                WB(I,NP1+MB)*VE(I,2*MP1-1,K)
                      CI(MP1,NP1,K) = CI(MP1,NP1,K) -
     +                                VB(I,NP1+MB)*WO(I,2*MP1-1,K) -
     +                                WB(I,NP1+MB)*VE(I,2*MP1-2,K)
  223     CONTINUE
          IF (MLAT.EQ.0) GO TO 217
          DO 224 K = 1,NT
              DO 224 NP1 = MP1,NDO1,2
                  CR(MP1,NP1,K) = CR(MP1,NP1,K) +
     +                            WB(IMID,NP1+MB)*VE(IMID,2*MP1-1,K)
                  CI(MP1,NP1,K) = CI(MP1,NP1,K) -
     +                            WB(IMID,NP1+MB)*VE(IMID,2*MP1-2,K)
  224     CONTINUE
  217     IF (MP2.GT.NDO2) GO TO 220
          DO 221 K = 1,NT
              DO 221 I = 1,IMM1
                  DO 221 NP1 = MP2,NDO2,2
                      CR(MP1,NP1,K) = CR(MP1,NP1,K) -
     +                                VB(I,NP1+MB)*WE(I,2*MP1-2,K) +
     +                                WB(I,NP1+MB)*VO(I,2*MP1-1,K)
                      CI(MP1,NP1,K) = CI(MP1,NP1,K) -
     +                                VB(I,NP1+MB)*WE(I,2*MP1-1,K) -
     +                                WB(I,NP1+MB)*VO(I,2*MP1-2,K)
  221     CONTINUE
          IF (MLAT.EQ.0) GO TO 220
          DO 222 K = 1,NT
              DO 222 NP1 = MP2,NDO2,2
                  CR(MP1,NP1,K) = CR(MP1,NP1,K) -
     +                            VB(IMID,NP1+MB)*WE(IMID,2*MP1-2,K)
                  CI(MP1,NP1,K) = CI(MP1,NP1,K) -
     +                            VB(IMID,NP1+MB)*WE(IMID,2*MP1-1,K)
  222     CONTINUE
  220 CONTINUE
      RETURN
c
c     case ityp=3 ,  v even , w odd
c
c     case m=0
c
  300 DO 315 K = 1,NT
          DO 315 I = 1,IMID
              DO 315 NP1 = 2,NDO2,2
                  BR(1,NP1,K) = BR(1,NP1,K) + VB(I,NP1)*VE(I,1,K)
  315 CONTINUE
      DO 316 K = 1,NT
          DO 316 I = 1,IMM1
              DO 316 NP1 = 3,NDO1,2
                  CR(1,NP1,K) = CR(1,NP1,K) - VB(I,NP1)*WO(I,1,K)
  316 CONTINUE
c
c     case m = 1 through nlat-1
c
      IF (MMAX.LT.2) RETURN
      DO 320 MP1 = 2,MMAX
          M = MP1 - 1
          MB = M*NLAT - (M* (M+1))/2
          MP2 = MP1 + 1
          IF (MP1.GT.NDO1) GO TO 317
          DO 323 K = 1,NT
              DO 323 I = 1,IMM1
                  DO 323 NP1 = MP1,NDO1,2
                      CR(MP1,NP1,K) = CR(MP1,NP1,K) -
     +                                VB(I,NP1+MB)*WO(I,2*MP1-2,K) +
     +                                WB(I,NP1+MB)*VE(I,2*MP1-1,K)
                      CI(MP1,NP1,K) = CI(MP1,NP1,K) -
     +                                VB(I,NP1+MB)*WO(I,2*MP1-1,K) -
     +                                WB(I,NP1+MB)*VE(I,2*MP1-2,K)
  323     CONTINUE
          IF (MLAT.EQ.0) GO TO 317
          DO 324 K = 1,NT
              DO 324 NP1 = MP1,NDO1,2
                  CR(MP1,NP1,K) = CR(MP1,NP1,K) +
     +                            WB(IMID,NP1+MB)*VE(IMID,2*MP1-1,K)
                  CI(MP1,NP1,K) = CI(MP1,NP1,K) -
     +                            WB(IMID,NP1+MB)*VE(IMID,2*MP1-2,K)
  324     CONTINUE
  317     IF (MP2.GT.NDO2) GO TO 320
          DO 321 K = 1,NT
              DO 321 I = 1,IMM1
                  DO 321 NP1 = MP2,NDO2,2
                      BR(MP1,NP1,K) = BR(MP1,NP1,K) +
     +                                VB(I,NP1+MB)*VE(I,2*MP1-2,K) +
     +                                WB(I,NP1+MB)*WO(I,2*MP1-1,K)
                      BI(MP1,NP1,K) = BI(MP1,NP1,K) +
     +                                VB(I,NP1+MB)*VE(I,2*MP1-1,K) -
     +                                WB(I,NP1+MB)*WO(I,2*MP1-2,K)
  321     CONTINUE
          IF (MLAT.EQ.0) GO TO 320
          DO 322 K = 1,NT
              DO 322 NP1 = MP2,NDO2,2
                  BR(MP1,NP1,K) = BR(MP1,NP1,K) +
     +                            VB(IMID,NP1+MB)*VE(IMID,2*MP1-2,K)
                  BI(MP1,NP1,K) = BI(MP1,NP1,K) +
     +                            VB(IMID,NP1+MB)*VE(IMID,2*MP1-1,K)
  322     CONTINUE
  320 CONTINUE
      RETURN
c
c     case ityp=4 ,  v even, w odd, and cr and ci equal 0.
c
c     case m=0
c
  400 DO 415 K = 1,NT
          DO 415 I = 1,IMID
              DO 415 NP1 = 2,NDO2,2
                  BR(1,NP1,K) = BR(1,NP1,K) + VB(I,NP1)*VE(I,1,K)
  415 CONTINUE
c
c     case m = 1 through nlat-1
c
      IF (MMAX.LT.2) RETURN
      DO 420 MP1 = 2,MMAX
          M = MP1 - 1
          MB = M*NLAT - (M* (M+1))/2
          MP2 = MP1 + 1
          IF (MP2.GT.NDO2) GO TO 420
          DO 421 K = 1,NT
              DO 421 I = 1,IMM1
                  DO 421 NP1 = MP2,NDO2,2
                      BR(MP1,NP1,K) = BR(MP1,NP1,K) +
     +                                VB(I,NP1+MB)*VE(I,2*MP1-2,K) +
     +                                WB(I,NP1+MB)*WO(I,2*MP1-1,K)
                      BI(MP1,NP1,K) = BI(MP1,NP1,K) +
     +                                VB(I,NP1+MB)*VE(I,2*MP1-1,K) -
     +                                WB(I,NP1+MB)*WO(I,2*MP1-2,K)
  421     CONTINUE
          IF (MLAT.EQ.0) GO TO 420
          DO 422 K = 1,NT
              DO 422 NP1 = MP2,NDO2,2
                  BR(MP1,NP1,K) = BR(MP1,NP1,K) +
     +                            VB(IMID,NP1+MB)*VE(IMID,2*MP1-2,K)
                  BI(MP1,NP1,K) = BI(MP1,NP1,K) +
     +                            VB(IMID,NP1+MB)*VE(IMID,2*MP1-1,K)
  422     CONTINUE
  420 CONTINUE
      RETURN
c
c     case ityp=5   v even, w odd, and br and bi equal zero
c
c     case m=0
c
  500 DO 516 K = 1,NT
          DO 516 I = 1,IMM1
              DO 516 NP1 = 3,NDO1,2
                  CR(1,NP1,K) = CR(1,NP1,K) - VB(I,NP1)*WO(I,1,K)
  516 CONTINUE
c
c     case m = 1 through nlat-1
c
      IF (MMAX.LT.2) RETURN
      DO 520 MP1 = 2,MMAX
          M = MP1 - 1
          MB = M*NLAT - (M* (M+1))/2
          MP2 = MP1 + 1
          IF (MP1.GT.NDO1) GO TO 520
          DO 523 K = 1,NT
              DO 523 I = 1,IMM1
                  DO 523 NP1 = MP1,NDO1,2
                      CR(MP1,NP1,K) = CR(MP1,NP1,K) -
     +                                VB(I,NP1+MB)*WO(I,2*MP1-2,K) +
     +                                WB(I,NP1+MB)*VE(I,2*MP1-1,K)
                      CI(MP1,NP1,K) = CI(MP1,NP1,K) -
     +                                VB(I,NP1+MB)*WO(I,2*MP1-1,K) -
     +                                WB(I,NP1+MB)*VE(I,2*MP1-2,K)
  523     CONTINUE
          IF (MLAT.EQ.0) GO TO 520
          DO 524 K = 1,NT
              DO 524 NP1 = MP1,NDO1,2
                  CR(MP1,NP1,K) = CR(MP1,NP1,K) +
     +                            WB(IMID,NP1+MB)*VE(IMID,2*MP1-1,K)
                  CI(MP1,NP1,K) = CI(MP1,NP1,K) -
     +                            WB(IMID,NP1+MB)*VE(IMID,2*MP1-2,K)
  524     CONTINUE
  520 CONTINUE
      RETURN
c
c     case ityp=6 ,  v odd , w even
c
c     case m=0
c
  600 DO 615 K = 1,NT
          DO 615 I = 1,IMID
              DO 615 NP1 = 2,NDO2,2
                  CR(1,NP1,K) = CR(1,NP1,K) - VB(I,NP1)*WE(I,1,K)
  615 CONTINUE
      DO 616 K = 1,NT
          DO 616 I = 1,IMM1
              DO 616 NP1 = 3,NDO1,2
                  BR(1,NP1,K) = BR(1,NP1,K) + VB(I,NP1)*VO(I,1,K)
  616 CONTINUE
c
c     case m = 1 through nlat-1
c
      IF (MMAX.LT.2) RETURN
      DO 620 MP1 = 2,MMAX
          M = MP1 - 1
          MB = M*NLAT - (M* (M+1))/2
          MP2 = MP1 + 1
          IF (MP1.GT.NDO1) GO TO 617
          DO 623 K = 1,NT
              DO 623 I = 1,IMM1
                  DO 623 NP1 = MP1,NDO1,2
                      BR(MP1,NP1,K) = BR(MP1,NP1,K) +
     +                                VB(I,NP1+MB)*VO(I,2*MP1-2,K) +
     +                                WB(I,NP1+MB)*WE(I,2*MP1-1,K)
                      BI(MP1,NP1,K) = BI(MP1,NP1,K) +
     +                                VB(I,NP1+MB)*VO(I,2*MP1-1,K) -
     +                                WB(I,NP1+MB)*WE(I,2*MP1-2,K)
  623     CONTINUE
          IF (MLAT.EQ.0) GO TO 617
          DO 624 K = 1,NT
              DO 624 NP1 = MP1,NDO1,2
                  BR(MP1,NP1,K) = BR(MP1,NP1,K) +
     +                            WB(IMID,NP1+MB)*WE(IMID,2*MP1-1,K)
                  BI(MP1,NP1,K) = BI(MP1,NP1,K) -
     +                            WB(IMID,NP1+MB)*WE(IMID,2*MP1-2,K)
  624     CONTINUE
  617     IF (MP2.GT.NDO2) GO TO 620
          DO 621 K = 1,NT
              DO 621 I = 1,IMM1
                  DO 621 NP1 = MP2,NDO2,2
                      CR(MP1,NP1,K) = CR(MP1,NP1,K) -
     +                                VB(I,NP1+MB)*WE(I,2*MP1-2,K) +
     +                                WB(I,NP1+MB)*VO(I,2*MP1-1,K)
                      CI(MP1,NP1,K) = CI(MP1,NP1,K) -
     +                                VB(I,NP1+MB)*WE(I,2*MP1-1,K) -
     +                                WB(I,NP1+MB)*VO(I,2*MP1-2,K)
  621     CONTINUE
          IF (MLAT.EQ.0) GO TO 620
          DO 622 K = 1,NT
              DO 622 NP1 = MP2,NDO2,2
                  CR(MP1,NP1,K) = CR(MP1,NP1,K) -
     +                            VB(IMID,NP1+MB)*WE(IMID,2*MP1-2,K)
                  CI(MP1,NP1,K) = CI(MP1,NP1,K) -
     +                            VB(IMID,NP1+MB)*WE(IMID,2*MP1-1,K)
  622     CONTINUE
  620 CONTINUE
      RETURN
c
c     case ityp=7   v odd, w even, and cr and ci equal zero
c
c     case m=0
c
  700 DO 716 K = 1,NT
          DO 716 I = 1,IMM1
              DO 716 NP1 = 3,NDO1,2
                  BR(1,NP1,K) = BR(1,NP1,K) + VB(I,NP1)*VO(I,1,K)
  716 CONTINUE
c
c     case m = 1 through nlat-1
c
      IF (MMAX.LT.2) RETURN
      DO 720 MP1 = 2,MMAX
          M = MP1 - 1
          MB = M*NLAT - (M* (M+1))/2
          MP2 = MP1 + 1
          IF (MP1.GT.NDO1) GO TO 720
          DO 723 K = 1,NT
              DO 723 I = 1,IMM1
                  DO 723 NP1 = MP1,NDO1,2
                      BR(MP1,NP1,K) = BR(MP1,NP1,K) +
     +                                VB(I,NP1+MB)*VO(I,2*MP1-2,K) +
     +                                WB(I,NP1+MB)*WE(I,2*MP1-1,K)
                      BI(MP1,NP1,K) = BI(MP1,NP1,K) +
     +                                VB(I,NP1+MB)*VO(I,2*MP1-1,K) -
     +                                WB(I,NP1+MB)*WE(I,2*MP1-2,K)
  723     CONTINUE
          IF (MLAT.EQ.0) GO TO 720
          DO 724 K = 1,NT
              DO 724 NP1 = MP1,NDO1,2
                  BR(MP1,NP1,K) = BR(MP1,NP1,K) +
     +                            WB(IMID,NP1+MB)*WE(IMID,2*MP1-1,K)
                  BI(MP1,NP1,K) = BI(MP1,NP1,K) -
     +                            WB(IMID,NP1+MB)*WE(IMID,2*MP1-2,K)
  724     CONTINUE
  720 CONTINUE
      RETURN
c
c     case ityp=8   v odd, w even, and both br and bi equal zero
c
c     case m=0
c
  800 DO 815 K = 1,NT
          DO 815 I = 1,IMID
              DO 815 NP1 = 2,NDO2,2
                  CR(1,NP1,K) = CR(1,NP1,K) - VB(I,NP1)*WE(I,1,K)
  815 CONTINUE
c
c     case m = 1 through nlat-1
c
      IF (MMAX.LT.2) RETURN
      DO 820 MP1 = 2,MMAX
          M = MP1 - 1
          MB = M*NLAT - (M* (M+1))/2
          MP2 = MP1 + 1
          IF (MP2.GT.NDO2) GO TO 820
          DO 821 K = 1,NT
              DO 821 I = 1,IMM1
                  DO 821 NP1 = MP2,NDO2,2
                      CR(MP1,NP1,K) = CR(MP1,NP1,K) -
     +                                VB(I,NP1+MB)*WE(I,2*MP1-2,K) +
     +                                WB(I,NP1+MB)*VO(I,2*MP1-1,K)
                      CI(MP1,NP1,K) = CI(MP1,NP1,K) -
     +                                VB(I,NP1+MB)*WE(I,2*MP1-1,K) -
     +                                WB(I,NP1+MB)*VO(I,2*MP1-2,K)
  821     CONTINUE
          IF (MLAT.EQ.0) GO TO 820
          DO 822 K = 1,NT
              DO 822 NP1 = MP2,NDO2,2
                  CR(MP1,NP1,K) = CR(MP1,NP1,K) -
     +                            VB(IMID,NP1+MB)*WE(IMID,2*MP1-2,K)
                  CI(MP1,NP1,K) = CI(MP1,NP1,K) -
     +                            VB(IMID,NP1+MB)*WE(IMID,2*MP1-1,K)
  822     CONTINUE
  820 CONTINUE
      RETURN
      END
      SUBROUTINE DVHAGSI(NLAT,NLON,WVHAGS,LVHAGS,DWORK,LDWORK,IERROR)
      DOUBLE PRECISION WVHAGS
      DIMENSION WVHAGS(LVHAGS)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION DWORK(LDWORK)

      IERROR = 1
      IF (NLAT.LT.3) RETURN
      IERROR = 2
      IF (NLON.LT.1) RETURN
      IERROR = 3
      IMID = (NLAT+1)/2
      LMN = (NLAT* (NLAT+1))/2
      IF (LVHAGS.LT.2* (IMID*LMN)+NLON+15) RETURN
      IERROR = 4
c     if (ldwork.lt.nlat*(3*nlat+9)+2) return
      IF (LDWORK.LT. (NLAT* (3*NLAT+9)+2)/2) RETURN
      IERROR = 0
      JW1 = 1
      JW2 = JW1 + IMID*LMN
      JW3 = JW2 + IMID*LMN
      IW1 = 1
      IW2 = IW1 + NLAT
      IW3 = IW2 + NLAT
      IW4 = IW3 + 3*IMID*NLAT
c     iw2 = iw1+nlat+nlat
c     iw3 = iw2+nlat+nlat
c     iw4 = iw3+6*imid*nlat
      CALL DVHGAI1(NLAT,IMID,WVHAGS(JW1),WVHAGS(JW2),DWORK(IW1),
     +             DWORK(IW2),DWORK(IW3),DWORK(IW4))
      CALL DHRFFTI(NLON,WVHAGS(JW3))
      RETURN
      END
      SUBROUTINE DVHGAI1(NLAT,IMID,VB,WB,DTHET,DWTS,DPBAR,WORK)
      DOUBLE PRECISION VB
      DOUBLE PRECISION WB
      DIMENSION VB(IMID,*),WB(IMID,*)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION ABEL,BBEL,CBEL,SSQR2,DCF
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION DPBAR(IMID,NLAT,3),DTHET(*),DWTS(*),WORK(*)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION DN,DM
c     lwk = 4*nlat*(nlat+2)
      LWK = NLAT* (NLAT+2)
      CALL DGAQD(NLAT,DTHET,DWTS,DPBAR,LWK,IERROR)
C*PT*WARNING* Constant already double-precision
c
c     compute associated legendre functions
c
c     compute m=n=0 legendre polynomials for all theta(i)
c
      SSQR2 = 1.D0/DSQRT(2.d0)
      DO 90 I = 1,IMID
          DPBAR(I,1,1) = SSQR2
          VB(I,1) = 0.D0
          WB(I,1) = 0.D0
   90 CONTINUE
c
c     main loop for remaining vb, and wb
c
      DO 100 N = 1,NLAT - 1
C*PT*WARNING* Already double-precision (DBLE)
          DN = DBLE(N)
          NM = MOD(N-2,3) + 1
          NZ = MOD(N-1,3) + 1
          NP = MOD(N,3) + 1
c
c     compute dpbar for m=0
c
          CALL DDNLFK(0,N,WORK)
          MN = INDX(0,N,NLAT)
          DO 105 I = 1,IMID
              CALL DDNLFT(0,N,DTHET(I),WORK,DPBAR(I,1,NP))
  105     CONTINUE
c
c     compute dpbar for m=1
c
          CALL DDNLFK(1,N,WORK)
          MN = INDX(1,N,NLAT)
          DO 106 I = 1,IMID
              CALL DDNLFT(1,N,DTHET(I),WORK,DPBAR(I,2,NP))
c      pbar(i,mn) = dpbar(i,2,np)
  106     CONTINUE
  104     CONTINUE
c
c     compute and store dpbar for m=2,n
c
          IF (N.LT.2) GO TO 108
          DO 107 M = 2,N
C*PT*WARNING* Already double-precision (DBLE)
              DM = DBLE(M)
              ABEL = DSQRT(((2*DN+1)* (DM+DN-2)* (DM+DN-3))/
     +               ((2*DN-3)* (DM+DN-1)* (DM+DN)))
              BBEL = DSQRT(((2*DN+1)* (DN-DM-1)* (DN-DM))/
     +               ((2*DN-3)* (DM+DN-1)* (DM+DN)))
              CBEL = DSQRT(((DN-DM+1)* (DN-DM+2))/ ((DM+DN-1)* (DM+DN)))
              ID = INDX(M,N,NLAT)
              IF (M.GE.N-1) GO TO 102
              DO 103 I = 1,IMID
                  DPBAR(I,M+1,NP) = ABEL*DPBAR(I,M-1,NM) +
     +                              BBEL*DPBAR(I,M+1,NM) -
     +                              CBEL*DPBAR(I,M-1,NP)
  103         CONTINUE
              GO TO 107
  102         DO 101 I = 1,IMID
                  DPBAR(I,M+1,NP) = ABEL*DPBAR(I,M-1,NM) -
     +                              CBEL*DPBAR(I,M-1,NP)
  101         CONTINUE
  107     CONTINUE
c
c     compute the derivative of the functions
c
  108     CONTINUE
          IX = INDX(0,N,NLAT)
          IY = INDX(N,N,NLAT)
          DO 125 I = 1,IMID
              VB(I,IX) = -DPBAR(I,2,NP)*DWTS(I)
              VB(I,IY) = DPBAR(I,N,NP)/DSQRT(2* (DN+1))*DWTS(I)
  125     CONTINUE
c
          IF (N.EQ.1) GO TO 131
          DCF = DSQRT(4*DN* (DN+1))
          DO 130 M = 1,N - 1
              DM = DBLE(M)
              IX = INDX(M,N,NLAT)
              ABEL = DSQRT((DN+DM)* (DN-DM+1))/DCF
              BBEL = DSQRT((DN-DM)* (DN+DM+1))/DCF
              DO 130 I = 1,IMID
                  VB(I,IX) = (ABEL*DPBAR(I,M,NP)-BBEL*DPBAR(I,M+2,NP))*
     +                       DWTS(I)
  130     CONTINUE
c
c     compute the vector harmonic w(theta) = m*pbar/cos(theta)
c
c     set wb=0 for m=0
c
  131     CONTINUE
          IX = INDX(0,N,NLAT)
          DO 220 I = 1,IMID
C*PT*WARNING* Constant already double-precision
              WB(I,IX) = 0.d0
  220     CONTINUE
c
c     compute wb for m=1,n
c
          DCF = DSQRT((DN+DN+1)/ (4*DN* (DN+1)* (DN+DN-1)))
          DO 230 M = 1,N
              DM = DBLE(M)
              IX = INDX(M,N,NLAT)
              ABEL = DCF*DSQRT((DN+DM)* (DN+DM-1))
              BBEL = DCF*DSQRT((DN-DM)* (DN-DM-1))
              IF (M.GE.N-1) GO TO 231
              DO 229 I = 1,IMID
                  WB(I,IX) = (ABEL*DPBAR(I,M,NZ)+BBEL*DPBAR(I,M+2,NZ))*
     +                       DWTS(I)
  229         CONTINUE
              GO TO 230
  231         DO 228 I = 1,IMID
                  WB(I,IX) = ABEL*DPBAR(I,M,NZ)*DWTS(I)
  228         CONTINUE
  230     CONTINUE
  100 CONTINUE
      RETURN
      END

      FUNCTION INDX(M,N,NLAT)
      INTEGER INDX

      INDX = M*NLAT - (M* (M+1))/2 + N + 1
      RETURN
      END

C
C $Id: slubkg.f,v 1.6 2008-07-27 00:17:27 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE SLUBKG (IPOC)
C
C This routine may be replaced by the user with code to add graphics to
C the background over which the titles are being scrolled.  Care should
C be taken when altering the state of GKS or SPPS.
C
C IPOC says what is going on in STITLE at the time that SLUBKG is
C called, as follows:
C
C IPOC  Position of call to SLUBKG
C ----  ---------------------------------------------------------------
C  -1   Just before drawing titles on a "fade-in" frame.
C  +1   Just after drawing titles on a "fade-in" frame.
C  -2   Just before drawing titles on a "start" frame.
C  +2   Just after drawing titles on a "start" frame.
C  -3   Just before drawing titles on a "move" frame.
C  +3   Just after drawing titles on a "move" frame.
C  -4   Just before drawing titles on an "end" frame.
C  +4   Just after drawing titles on an "end" frame.
C  -5   Just before drawing titles on a "fade-out" frame.
C  +5   Just after drawing titles on a "fade-out" frame.
C
C The default version of the routine does nothing.
C
        RETURN
C
      END

      SUBROUTINE CGESC2( N, A, LDA, RHS, IPIV, JPIV, SCALE )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      INTEGER            LDA, N
      REAL               SCALE
*     ..
*     .. Array Arguments ..
      INTEGER            IPIV( * ), JPIV( * )
      COMPLEX            A( LDA, * ), RHS( * )
*     ..
*
*  Purpose
*  =======
*
*  CGESC2 solves a system of linear equations
*
*            A * X = scale* RHS
*
*  with a general N-by-N matrix A using the LU factorization with
*  complete pivoting computed by CGETC2.
*
*
*  Arguments
*  =========
*
*  N       (input) INTEGER
*          The number of columns of the matrix A.
*
*  A       (input) COMPLEX array, dimension (LDA, N)
*          On entry, the  LU part of the factorization of the n-by-n
*          matrix A computed by CGETC2:  A = P * L * U * Q
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(1, N).
*
*  RHS     (input/output) COMPLEX array, dimension N.
*          On entry, the right hand side vector b.
*          On exit, the solution vector X.
*
*  IPIV    (iput) INTEGER array, dimension (N).
*          The pivot indices; for 1 <= i <= N, row i of the
*          matrix has been interchanged with row IPIV(i).
*
*  JPIV    (iput) INTEGER array, dimension (N).
*          The pivot indices; for 1 <= j <= N, column j of the
*          matrix has been interchanged with column JPIV(j).
*
*  SCALE    (output) REAL
*           On exit, SCALE contains the scale factor. SCALE is chosen
*           0 <= SCALE <= 1 to prevent owerflow in the solution.
*
*  Further Details
*  ===============
*
*  Based on contributions by
*     Bo Kagstrom and Peter Poromaa, Department of Computing Science,
*     Umea University, S-901 87 Umea, Sweden.
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ZERO, ONE, TWO
      PARAMETER          ( ZERO = 0.0E+0, ONE = 1.0E+0, TWO = 2.0E+0 )
*     ..
*     .. Local Scalars ..
      INTEGER            I, J
      REAL               BIGNUM, EPS, SMLNUM
      COMPLEX            TEMP
*     ..
*     .. External Subroutines ..
      EXTERNAL           CLASWP, CSCAL, SLABAD
*     ..
*     .. External Functions ..
      INTEGER            ICAMAX
      REAL               SLAMCH
      EXTERNAL           ICAMAX, SLAMCH
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, CMPLX, REAL
*     ..
*     .. Executable Statements ..
*
*     Set constant to control overflow
*
      EPS = SLAMCH( 'P' )
      SMLNUM = SLAMCH( 'S' ) / EPS
      BIGNUM = ONE / SMLNUM
      CALL SLABAD( SMLNUM, BIGNUM )
*
*     Apply permutations IPIV to RHS
*
      CALL CLASWP( 1, RHS, LDA, 1, N-1, IPIV, 1 )
*
*     Solve for L part
*
      DO 20 I = 1, N - 1
         DO 10 J = I + 1, N
            RHS( J ) = RHS( J ) - A( J, I )*RHS( I )
   10    CONTINUE
   20 CONTINUE
*
*     Solve for U part
*
      SCALE = ONE
*
*     Check for scaling
*
      I = ICAMAX( N, RHS, 1 )
      IF( TWO*SMLNUM*ABS( RHS( I ) ).GT.ABS( A( N, N ) ) ) THEN
         TEMP = CMPLX( ONE / TWO, ZERO ) / ABS( RHS( I ) )
         CALL CSCAL( N, TEMP, RHS( 1 ), 1 )
         SCALE = SCALE*REAL( TEMP )
      END IF
      DO 40 I = N, 1, -1
         TEMP = CMPLX( ONE, ZERO ) / A( I, I )
         RHS( I ) = RHS( I )*TEMP
         DO 30 J = I + 1, N
            RHS( I ) = RHS( I ) - RHS( J )*( A( I, J )*TEMP )
   30    CONTINUE
   40 CONTINUE
*
*     Apply permutations JPIV to the solution (RHS)
*
      CALL CLASWP( 1, RHS, LDA, 1, N-1, JPIV, -1 )
      RETURN
*
*     End of CGESC2
*
      END

C
C	$Id: csrotate.f,v 1.5 2008-07-27 03:10:07 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CSROTATE (N,C,S, X,Y )
      INTEGER N
      DOUBLE PRECISION C, S, X(N), Y(N)
C
C***********************************************************
C
C                                              From SSRFPACK
C                                            Robert J. Renka
C                                  Dept. of Computer Science
C                                       Univ. of North Texas
C                                           renka@cs.unt.edu
C                                                   09/01/88
C
C                                                ( C  S)
C   This subroutine applies the Givens rotation  (     )  to
C                                                (-S  C)
C                    (X(1) ... X(N))
C the 2 by N matrix  (             ) .
C                    (Y(1) ... Y(N))
C
C   This routine is identical to Subroutine SROT from the
C LINPACK BLAS (Basic Linear Algebra Subroutines).
C
C On input:
C
C       N = Number of columns to be rotated.
C
C       C,S = Elements of the Givens rotation.  Refer to
C             Subroutine CSGIVENS.
C
C The above parameters are not altered by this routine.
C
C       X,Y = Arrays of length .GE. N containing the compo-
C             nents of the vectors to be rotated.
C
C On output:
C
C       X,Y = Arrays containing the rotated vectors (not
C             altered if N < 1).
C
C Modules required by CSROTATE:  None
C
C***********************************************************
C
      INTEGER I
      DOUBLE PRECISION XI, YI
C
      DO 1 I = 1,N
        XI = X(I)
        YI = Y(I)
        X(I) = C*XI + S*YI
        Y(I) = -S*XI + C*YI
    1   CONTINUE
      RETURN
      END

C NCLFORTSTART
      subroutine weibfit(maxn,xin,xmsg,nmin,level,weib,ier)
      implicit none
C                                                 ! INPUT
      integer maxn, nmin, ier
      double precision xin(maxn), xmsg, level
C                                                 ! OUTPUT
      double precision  weib(6)
C NCLEND
C
C
C Modified from:  http://ftp.uni-bayreuth.de/math/statlib/jqt/29-1-2
C Shea directory name: weibull.2_param_mle.ncl.f
c
c  Weibull Maximum Likelihood Parameter Estimates with Censored Data
c  J. Bert Keats, Frederick P. Lawrence, and F. K. Wang
c  Journal of Quality Technology, Volume 29, Number 1, pp. 105--110, January 1997

C                                                 ! LOCAL
      double precision x(maxn)
c     double precision y(maxn), cycle(maxn)
C      integer censor(maxn)
C****************************************************
C* FORTRAN PROGRAM USES MAXIMUM LIKELIHOOD TO       *
C* ESTIMATE THE PARAMETERS OF TWO-PARAMETER WEIBULL *
C* DISTRIBUTION. THE PROGRAM CAN BE USED FOR ALL    *
C* CENSORING CASES:                                 *
C*     CASE 1: MULTIPLY CENSORED DATA               *
C*     CASE 2: SINGLY CENSORED DATA                 *
C*     CASE 3: COMPLETE DATA                        *
C* CENSORED TYPE (0: FAILURE; 1: NON-FAILURE)*
C****************************************************
      INTEGER I,R,S,J,L,CC,ERROR,CASE
C     INTEGER INDEX
      INTEGER N,K,K1
      DOUBLE PRECISION BETA, THETA
      DOUBLE PRECISION PI,T2,T3,T4,ST1,ST2,NUM,NUM1
      DOUBLE PRECISION VARB,VART,COVBT,DEM1,DEM2,DEM3
      DOUBLE PRECISION S1R,S2R,S3R,S4R,S2S,S3S,S4S
      DOUBLE PRECISION DENOM,DENOM1,DENOM2,DENOM3,DENOM4
      DOUBLE PRECISION CON,IB,IT,COV,LOW1,LOW2,UP1,UP2
      DOUBLE PRECISION ALPHA,NORM,DELTA,L1,L2

      ier = 0
      do i=1,6
         weib(i) = xmsg
      end do

      case  = 3

      n = 0
      do 10 i=1,maxn
         if (xin(i).ne.xmsg .and. xin(i).gt.0.0d0) then
             n = n+1
         end if
10    continue

      if (n.lt.nmin) then
c c c     print *,"weibfit: not enough values: n=",n
          ier = 1
          return
      end if
    
      ALPHA = (1.0 - LEVEL) / 2.0D0
      R = 0
      S = 0
      J = 1
      L = 1
      DO 20 I=1,N
C C C   IF (CENSOR(I) .EQ. 0) THEN
        IF (xin(i).ne.xmsg .and. xin(i).gt.0.0d0) THEN
C C C     X(J) = CYCLE(I)
          X(J) = xin(i)
          J = J + 1
          R = R + 1
C C C   ELSE
C C C     Y(L) = CYCLE(I)
C C C     L = L + 1
C C C     S = S + 1
        END IF
20      CONTINUE
C
C MENON'S ESTIMATE OF BETA AS INITIAL
C APPROXIMATION OF BETA
C
      PI  = 3.141592653589793
      ST1 = 0
      ST2 = 0
      DO I = 1, R
        ST1 = ST1 +  DLOG(X(I))
        ST2 = ST2 + ( DLOG(X(I)))**2
      END DO

      S1R = ST1
      ST1 = (ST1**2)/(FLOAT(R))
      BETA = (6.0 * (ST2 - ST1))/((PI**2)*(FLOAT(R - 1)))
      IF (BETA .EQ. 0.0) BETA = .0001
      BETA = 1. / SQRT(BETA)
      CC = 0
      DELTA = 0
C
C NEWTON-RAPHSON ITERATIVE ESTIMATE OF BETA
C
      DO 100 K = 1,25
        S2R = 0
        S3R = 0
        S4R = 0
        S2S = 0
        S3S = 0
        S4S = 0
        DO 80 I = 1,R
          S2R = S2R + X(I)**BETA
          S3R = S3R + (X(I)**BETA) *  DLOG(X(I))
          S4R = S4R + (X(I)**BETA) * ( DLOG(X(I))**2)
80        CONTINUE
C C C     DO 85 I = 1,S
C C C      S2S = S2S + Y(I)**BETA
C C C      S3S = S3S + (Y(I)**BETA) *  DLOG(Y(I))
C C C      S4S = S4S + (Y(I)**BETA) * ( DLOG(Y(I))**2)
C C C 85   CONTINUE
        NUM1 = (S3R + S3S) / (S2R + S2S)
        NUM = (1. / BETA) + (S1R / R) - NUM1
        DENOM1 = (S3R + S3S)**2
        DENOM2 = (S2R + S2S) * (S4R + S4S)
        DENOM3 = (S2R + S2S)**2
        DENOM4 = 1.0 / BETA**2
        DENOM = DENOM4 - ((DENOM1 - DENOM2) / DENOM3)
        DELTA = NUM / DENOM
        BETA = BETA + DELTA
        K1 = K
C
C TEST FOR CONVERGENCE
C
        IF (ABS(DELTA) .LT. 0.0001) THEN
          CC = 1
          GOTO 105
        END IF
100     CONTINUE
C
C INDICATE NON-CONVERGENCE
C
105   IF (CC .EQ. 0) THEN
c c c   WRITE(*,*) ' THE NEWTON-RAPHSON IS NOT ', *  'CONVERGED'
          ier   = 2
          return
      ELSE
C
C IF CONVERGENCE HAS OCCURRED CALCULATE THETA & BETA
C
        S2R = 0
        S3R = 0
        S4R = 0
        S2S = 0
        S3S = 0
        S4S = 0
        DO 90 I = 1,R
          S2R = S2R + X(I)**BETA
          S3R = S3R + (X(I)**BETA) *  DLOG(X(I))
          S4R = S4R + (X(I)**BETA) * ( DLOG(X(I))**2)
90        CONTINUE
C C C   DO 95 I = 1,S
C C C     S2S = S2S + Y(I)**BETA
C C C     S3S = S3S + (Y(I)**BETA) *  DLOG(Y(I))
C C C     S4S = S4S + (Y(I)**BETA) * ( DLOG(Y(I))**2)
C C C   95        CONTINUE
        T2 = S2R + S2S
        T3 = S3R + S3S
        T4 = S4R + S4S
        THETA = (T2 / FLOAT(R))**(1.0 / BETA)
      END IF
C
C COMPUTE THE CONFIDENCE INTERVAL OF THE PARAMETERS
C THETA & BETA
C
      DEM1 = THETA**BETA
      DEM2 = THETA**(1 + BETA)
      DEM3 = THETA**(2 + BETA)
      L1   =  DLOG(THETA)
      L2   = ( DLOG(THETA))**2
      IB   = R / BETA**2 + (L2 * T2 - 2 * L1 * T3 + T4)/ DEM1
      IT   = (BETA * (BETA + 1) / DEM3 * T2) - (R * BETA / THETA**2)
      COV  = R / THETA - (T2 - BETA * L1 * T2 + BETA * T3) / DEM2

C Determinant of 2x2 matrix
C    [A  B               [Var(B)    Cov(B,T)
C     C  D]               Cov(B,T)  VAR(T)  ]
C          = A*D-B*C     = Var(B)*VAR(T)-Cov(B,T)**2
C                           IB     iT     COV**2

      CON  = (IB *IT) - COV**2
      VARB = IT / CON            
      VART = IB / CON
      COVBT= COV / CON
C                                    AVOID ANY NAMING CONFLICT
C C C CALL NORMAL(ALPHA,NORM,ERROR)
      CALL QNORMALQ(ALPHA,NORM,ERROR)

      LOW1 = BETA  - NORM * SQRT(VARB)
      UP1  = BETA  + NORM * SQRT(VARB)
      LOW2 = THETA - NORM * SQRT(VART)
      UP2  = THETA + NORM * SQRT(VART)

      weib(1) = BETA
      weib(2) = THETA
      weib(3) = LOW1
      weib(4) = UP1
      weib(5) = LOW2
      weib(6) = UP2

      return

C C C IF (CASE .EQ. 1) THEN
C C C   WRITE(*,300) N,R,S
C C C   WRITE(1,300) N,R,S
C300C C CFORMAT(10X,'MAXIMUM LIKELIHOOD ESTIMATION',//,
C C C*C C C10X,'FOR MULTIPLY CENSORED DATA',//,
C C C*C C C10X,'SAMPLE SIZE IS ',I3,//,
C C C*C C C10X,'NUMBER OF FAILURES IS ',I3,//,
C C C*C C C10X,'NUMBER OF NON-FAILURES IS ',I3,//)
C C C ELSE IF (CASE .EQ. 2) THEN
C C C   WRITE(*,301) N,R,S
C C C   WRITE(1,301) N,R,S
C301C C CFORMAT(10X,'MAXIMUM LIKELIHOOD ESTIMATION',//,
C C C*   10X,'FOR SINGLY CENSORED DATA',//,
C C C*   10X,'SAMPLE SIZE IS ',I3,//,
C C C*   10X,'NUMBER OF FAILURES IS ',I3,//,
C C C*   10X,'NUMBER OF NON-FAILURES IS ',I3,//)

C C C ELSE IF (CASE .EQ. 3) THEN
C C C   WRITE(*,302) N,R,S
C C C   WRITE(1,302) N,R,S
C302C C CFORMAT(10X,'MAXIMUM LIKELIHOOD ESTIMATION',//,
C C C*    10X,'FOR COMPLETE DATA',//,
C C C*    10X,'SAMPLE SIZE IS ',I3,//,
C C C*    10X,'NUMBER OF FAILURES IS ',I3,//,
C C C*    10X,'NUMBER OF NON-FAILURES IS ',I3,//)
C C C END IF

C C C LEVEL = LEVEL*100.
C C C WRITE(*,600) LEVEL
C C C WRITE(1,600) LEVEL
C600  FORMAT(25X,F5.2,' % CONFIDENCE INTERVAL',/,
C C C*25X,'--------------------------',/,
C C C*1X,'PARAMETER ESTIMATE ',6X,' LOWER LIMIT ',
C C C*'UPPER LIMIT',/,
C C C*1X,'------------------------------------------',
C C C*'--------',/)
C C C WRITE(*,700) BETA,LOW1,UP1
C C C WRITE(1,700) BETA,LOW1,UP1
C C C700   FORMAT(3X,'BETA',5X,F9.4,5X,F9.4,4X,F9.4,/)
C C C WRITE(*,800) THETA,LOW2,UP2
C C C WRITE(1,800) THETA,LOW2,UP2
C800  FORMAT(3X,'THETA',4X,F9.4,5X,F9.4,4X,F9.4,/)
      RETURN
      END
C****************************************************
C* SUBROUTINE TO GENERATE THE INVERSE NORMAL VALUE, *
C* TAKEN FROM: ``STATISTICAL COMPUTING'' BY KENNEDY,*
C* W. J. & GENTLE, J. E. (1980), pp. 95.            *
C****************************************************
      SUBROUTINE QNORMALQ(ALPHA,NORM,ERROR)
C C C SUBROUTINE NORMAL(ALPHA,NORM,ERROR)
      implicit none 
      INTEGER ERROR
      DOUBLE PRECISION ALPHA,NORM,LIM,P0,P1,P2,P3,P4
      DOUBLE PRECISION Q0,Q1,Q2,Q3,Q4,Y
      LIM = 1.0D-20
      P0 = -0.322232431088
      P1 = -1.0
      P2 = -0.342242088547
      P3 = -0.0204231210245
      P4 = -0.453642210148D-4
      Q0 = 0.0993484626060
      Q1 = 0.588581570495
      Q2 = 0.531103462366
      Q3 = 0.103537752850
      Q4 = 0.0038560700634
      ERROR = 1
      NORM = 0
      IF (ALPHA .GT. 0.5) ALPHA = 1. - ALPHA
      IF (ALPHA .LT. LIM) THEN
        NORM = 0
        GO TO 10
      END IF
      ERROR = 0
      IF (ALPHA .EQ. 0.5) THEN
        NORM = 0
        GO TO 10
      END IF
      Y = DSQRT(DLOG(1. / ALPHA**2))
      NORM = Y + ((((Y*P4+P3)*Y+P2)*Y+P1)*Y+P0)/
     *           ((((Y*Q4+Q3)*Y+Q2)*Y+Q1)*Y+Q0)
      IF (ALPHA .GT. 0.5) NORM = -NORM
10    RETURN
      END

      SUBROUTINE SSYGVD( ITYPE, JOBZ, UPLO, N, A, LDA, B, LDB, W, WORK,
     $                   LWORK, IWORK, LIWORK, INFO )
*
*  -- LAPACK driver routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          JOBZ, UPLO
      INTEGER            INFO, ITYPE, LDA, LDB, LIWORK, LWORK, N
*     ..
*     .. Array Arguments ..
      INTEGER            IWORK( * )
      REAL               A( LDA, * ), B( LDB, * ), W( * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  SSYGVD computes all the eigenvalues, and optionally, the eigenvectors
*  of a real generalized symmetric-definite eigenproblem, of the form
*  A*x=(lambda)*B*x,  A*Bx=(lambda)*x,  or B*A*x=(lambda)*x.  Here A and
*  B are assumed to be symmetric and B is also positive definite.
*  If eigenvectors are desired, it uses a divide and conquer algorithm.
*
*  The divide and conquer algorithm makes very mild assumptions about
*  floating point arithmetic. It will work on machines with a guard
*  digit in add/subtract, or on those binary machines without guard
*  digits which subtract like the Cray X-MP, Cray Y-MP, Cray C-90, or
*  Cray-2. It could conceivably fail on hexadecimal or decimal machines
*  without guard digits, but we know of none.
*
*  Arguments
*  =========
*
*  ITYPE   (input) INTEGER
*          Specifies the problem type to be solved:
*          = 1:  A*x = (lambda)*B*x
*          = 2:  A*B*x = (lambda)*x
*          = 3:  B*A*x = (lambda)*x
*
*  JOBZ    (input) CHARACTER*1
*          = 'N':  Compute eigenvalues only;
*          = 'V':  Compute eigenvalues and eigenvectors.
*
*  UPLO    (input) CHARACTER*1
*          = 'U':  Upper triangles of A and B are stored;
*          = 'L':  Lower triangles of A and B are stored.
*
*  N       (input) INTEGER
*          The order of the matrices A and B.  N >= 0.
*
*  A       (input/output) REAL array, dimension (LDA, N)
*          On entry, the symmetric matrix A.  If UPLO = 'U', the
*          leading N-by-N upper triangular part of A contains the
*          upper triangular part of the matrix A.  If UPLO = 'L',
*          the leading N-by-N lower triangular part of A contains
*          the lower triangular part of the matrix A.
*
*          On exit, if JOBZ = 'V', then if INFO = 0, A contains the
*          matrix Z of eigenvectors.  The eigenvectors are normalized
*          as follows:
*          if ITYPE = 1 or 2, Z**T*B*Z = I;
*          if ITYPE = 3, Z**T*inv(B)*Z = I.
*          If JOBZ = 'N', then on exit the upper triangle (if UPLO='U')
*          or the lower triangle (if UPLO='L') of A, including the
*          diagonal, is destroyed.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(1,N).
*
*  B       (input/output) REAL array, dimension (LDB, N)
*          On entry, the symmetric matrix B.  If UPLO = 'U', the
*          leading N-by-N upper triangular part of B contains the
*          upper triangular part of the matrix B.  If UPLO = 'L',
*          the leading N-by-N lower triangular part of B contains
*          the lower triangular part of the matrix B.
*
*          On exit, if INFO <= N, the part of B containing the matrix is
*          overwritten by the triangular factor U or L from the Cholesky
*          factorization B = U**T*U or B = L*L**T.
*
*  LDB     (input) INTEGER
*          The leading dimension of the array B.  LDB >= max(1,N).
*
*  W       (output) REAL array, dimension (N)
*          If INFO = 0, the eigenvalues in ascending order.
*
*  WORK    (workspace/output) REAL array, dimension (LWORK)
*          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*
*  LWORK   (input) INTEGER
*          The dimension of the array WORK.
*          If N <= 1,               LWORK >= 1.
*          If JOBZ = 'N' and N > 1, LWORK >= 2*N+1.
*          If JOBZ = 'V' and N > 1, LWORK >= 1 + 6*N + 2*N**2.
*
*          If LWORK = -1, then a workspace query is assumed; the routine
*          only calculates the optimal size of the WORK array, returns
*          this value as the first entry of the WORK array, and no error
*          message related to LWORK is issued by XERBLA.
*
*  IWORK   (workspace/output) INTEGER array, dimension (LIWORK)
*          On exit, if INFO = 0, IWORK(1) returns the optimal LIWORK.
*
*  LIWORK  (input) INTEGER
*          The dimension of the array IWORK.
*          If N <= 1,                LIWORK >= 1.
*          If JOBZ  = 'N' and N > 1, LIWORK >= 1.
*          If JOBZ  = 'V' and N > 1, LIWORK >= 3 + 5*N.
*
*          If LIWORK = -1, then a workspace query is assumed; the
*          routine only calculates the optimal size of the IWORK array,
*          returns this value as the first entry of the IWORK array, and
*          no error message related to LIWORK is issued by XERBLA.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*          > 0:  SPOTRF or SSYEVD returned an error code:
*             <= N:  if INFO = i, SSYEVD failed to converge;
*                    i off-diagonal elements of an intermediate
*                    tridiagonal form did not converge to zero;
*             > N:   if INFO = N + i, for 1 <= i <= N, then the leading
*                    minor of order i of B is not positive definite.
*                    The factorization of B could not be completed and
*                    no eigenvalues or eigenvectors were computed.
*
*  Further Details
*  ===============
*
*  Based on contributions by
*     Mark Fahey, Department of Mathematics, Univ. of Kentucky, USA
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ONE
      PARAMETER          ( ONE = 1.0E+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            LQUERY, UPPER, WANTZ
      CHARACTER          TRANS
      INTEGER            LIOPT, LIWMIN, LOPT, LWMIN, NEIG
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           SPOTRF, SSYEVD, SSYGST, STRMM, STRSM, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, REAL
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      WANTZ = LSAME( JOBZ, 'V' )
      UPPER = LSAME( UPLO, 'U' )
      LQUERY = ( LWORK.EQ.-1 .OR. LIWORK.EQ.-1 )
*
      INFO = 0
      IF( N.LE.1 ) THEN
         LIWMIN = 1
         LWMIN = 1
         LOPT = LWMIN
         LIOPT = LIWMIN
      ELSE
         IF( WANTZ ) THEN
            LIWMIN = 3 + 5*N
            LWMIN = 1 + 6*N + 2*N**2
         ELSE
            LIWMIN = 1
            LWMIN = 2*N + 1
         END IF
         LOPT = LWMIN
         LIOPT = LIWMIN
      END IF
      IF( ITYPE.LT.0 .OR. ITYPE.GT.3 ) THEN
         INFO = -1
      ELSE IF( .NOT.( WANTZ .OR. LSAME( JOBZ, 'N' ) ) ) THEN
         INFO = -2
      ELSE IF( .NOT.( UPPER .OR. LSAME( UPLO, 'L' ) ) ) THEN
         INFO = -3
      ELSE IF( N.LT.0 ) THEN
         INFO = -4
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -6
      ELSE IF( LDB.LT.MAX( 1, N ) ) THEN
         INFO = -8
      ELSE IF( LWORK.LT.LWMIN .AND. .NOT.LQUERY ) THEN
         INFO = -11
      ELSE IF( LIWORK.LT.LIWMIN .AND. .NOT.LQUERY ) THEN
         INFO = -13
      END IF
*
      IF( INFO.EQ.0 ) THEN
         WORK( 1 ) = LOPT
         IWORK( 1 ) = LIOPT
      END IF
*
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'SSYGVD', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
*
*     Form a Cholesky factorization of B.
*
      CALL SPOTRF( UPLO, N, B, LDB, INFO )
      IF( INFO.NE.0 ) THEN
         INFO = N + INFO
         RETURN
      END IF
*
*     Transform problem to standard eigenvalue problem and solve.
*
      CALL SSYGST( ITYPE, UPLO, N, A, LDA, B, LDB, INFO )
      CALL SSYEVD( JOBZ, UPLO, N, A, LDA, W, WORK, LWORK, IWORK, LIWORK,
     $             INFO )
      LOPT = MAX( REAL( LOPT ), REAL( WORK( 1 ) ) )
      LIOPT = MAX( REAL( LIOPT ), REAL( IWORK( 1 ) ) )
*
      IF( WANTZ ) THEN
*
*        Backtransform eigenvectors to the original problem.
*
         NEIG = N
         IF( INFO.GT.0 )
     $      NEIG = INFO - 1
         IF( ITYPE.EQ.1 .OR. ITYPE.EQ.2 ) THEN
*
*           For A*x=(lambda)*B*x and A*B*x=(lambda)*x;
*           backtransform eigenvectors: x = inv(L)'*y or inv(U)*y
*
            IF( UPPER ) THEN
               TRANS = 'N'
            ELSE
               TRANS = 'T'
            END IF
*
            CALL STRSM( 'Left', UPLO, TRANS, 'Non-unit', N, NEIG, ONE,
     $                  B, LDB, A, LDA )
*
         ELSE IF( ITYPE.EQ.3 ) THEN
*
*           For B*A*x=(lambda)*x;
*           backtransform eigenvectors: x = L*y or U'*y
*
            IF( UPPER ) THEN
               TRANS = 'T'
            ELSE
               TRANS = 'N'
            END IF
*
            CALL STRMM( 'Left', UPLO, TRANS, 'Non-unit', N, NEIG, ONE,
     $                  B, LDB, A, LDA )
         END IF
      END IF
*
      WORK( 1 ) = LOPT
      IWORK( 1 ) = LIOPT
*
      RETURN
*
*     End of SSYGVD
*
      END

      PROGRAM CTTD01
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.  Use one
C of the following:
C
C       PARAMETER (IERF=6,LUNI=2,IWTY=1 ,IWID=1)  !  NCGM
C       PARAMETER (IERF=6,LUNI=2,IWTY=8 ,IWID=1)  !  X Windows
C       PARAMETER (IERF=6,LUNI=2,IWTY=20,IWID=1)  !  PostScript
C       PARAMETER (IERF=6,LUNI=2,IWTY=11,IWID=1)  !  PDF, Portrait
C       PARAMETER (IERF=6,LUNI=2,IWTY=12,IWID=1)  !  PDF, Landscape
C
        PARAMETER (IERF=6,LUNI=2,IWTYPE=1,IWTY=IWTYPE,IWID=1)
C
C The object of this program is to produce a set of plots illustrating
C the use of a simple, closed, grid wrapped around an arbitrary blob.
C The triangular mesh is created from a rectangular grid by calling
C the CONPACKT routine CTTMRG, which returns a triangular mesh on the
C surface of the unit sphere, and then putting the triangular mesh
C through a couple of steps that deform it.  Dummy data are supplied
C for its vertices, and the data are contoured using a mapping supplied
C by the 3D package TDPACK.
C
C Various frames can be drawn or not drawn:
C
C   1) The triangular mesh on the globe.  This is drawn only if the
C      parameter IMSH is non-zero.
C
C   2) Simple contours on the globe.  This is drawn only if the
C      parameter ICON is non-zero.
C
C   3) Color-filled contour bands on the globe, done using an area
C      map.  This is drawn only if the parameter ICOL is non-zero.
C
C   4) Color-filled contour bands on the globe, done using a cell
C      array.  This is drawn only if the parameter ICAP is non-zero.
C
C Define parameters that say whether or not the triangular mesh is to be
C drawn on the various frames
C
C       PARAMETER (IMSH=0)  !  frame 1 (mesh only) not drawn
C       PARAMETER (IMSH=1)  !  frame 1 (mesh only) drawn
C
        PARAMETER (IMSH=1)
C
C Define the parameter that says whether or not parts of the triangular
C mesh that were diagonals of the rectangular mesh are to be drawn.
C
C       PARAMETER (IDIA=0)  !  diagonals not drawn
C       PARAMETER (IDIA=1)  !  diagonals drawn
C
        PARAMETER (IDIA=0)
C
C Define the parameter that says whether or not simple contours are to
C be drawn:
C
C       PARAMETER (ICON=0)  !  contours not drawn
C       PARAMETER (ICON=1)  !  contours drawn
C
        PARAMETER (ICON=1)
C
C       PARAMETER (IMSN=0)  !  mesh not drawn on frame
C       PARAMETER (IMSN=1)  !  mesh drawn on frame
C
        PARAMETER (IMSN=1)
C
C Define the parameter that says whether or not color-filled contours
C (drawn using an area map) are to be drawn:
C
C       PARAMETER (ICOL=0)  !  no color fill done
C       PARAMETER (ICOL=1)  !  color fill done
C
        PARAMETER (ICOL=1)
C
C       PARAMETER (IMSL=0)  !  mesh not drawn on frame
C       PARAMETER (IMSL=1)  !  mesh drawn on frame
C
        PARAMETER (IMSL=0)
C
C       PARAMETER (ICSL=0)  !  contours not drawn on frame
C       PARAMETER (ICSL=1)  !  contours drawn on frame
C
        PARAMETER (ICSL=1)
C
C Define the parameter that says whether or not color-filled contours
C (drawn using a cell array) are to be drawn:
C
C       PARAMETER (ICAP=0)  !  no color fill done
C       PARAMETER (ICAP=1)  !  color fill done
C
        PARAMETER (ICAP=1)
C
C       PARAMETER (IMSP=0)  !  mesh not drawn on frame
C       PARAMETER (IMSP=1)  !  mesh drawn on frame
C
        PARAMETER (IMSP=0)
C
C       PARAMETER (ICOP=0)  !  contours not drawn on frame
C       PARAMETER (ICOP=1)  !  contours drawn on frame
C
        PARAMETER (ICOP=1)
C
C To represent the triangular mesh, we use three singly-dimensioned
C arrays: RPNT holds points, IEDG holds edges, and ITRI holds triangles.
C The elements of each array form "nodes" having lengths as follows:
C
        PARAMETER (LOPN=5)
C
C The five elements of a point node are
C
C   1. the X coordinate of the point;
C   2. the Y coordinate of the point;
C   3. the Z coordinate of the point;
C   4. the field value at the point;
C   5. any additional value desired by the user.
C
        PARAMETER (LOEN=6)
C
C The six elements of an edge node are
C
C   1. the base index, in RPNT, of point 1 of the edge;
C   2. the base index, in RPNT, of point 2 of the edge;
C   3. the index, in ITRI, of the pointer to the edge in the triangle to
C      the left of the edge (-1 if there is no triangle to the left);
C   4. the index, in ITRI, of the pointer to the edge in the triangle to
C      the right of the edge (-1 if there is no triangle to the right);
C   5. a utility flag for use by algorithms that scan the structure.
C   6. a flag used to distinguish certain edges from others (allowing
C      one to suppress the drawing of edges that were diagonals of the
C      rectangular grid).
C
C The "left" and "right" sides of an edge are defined as they would be
C by an observer standing on the globe at point 1 of the edge, looking
C toward point 2 of the edge.  It is possible, if there are "holes" in
C the mesh, that there will be no triangle to the left or to the right
C of an edge, but there must be a triangle on one side or the other.
C
        PARAMETER (LOTN=4)
C
C The four elements of a triangle node are
C
C   1. the base index, in IEDG, of edge 1 of the triangle;
C   2. the base index, in IEDG, of edge 2 of the triangle;
C   3. the base index, in IEDG, of edge 3 of the triangle;
C   4. a flag set non-zero to block use of the triangle, effectively
C      removing it from the mesh.  Different bits of this flag are
C      used for different purposes, as discussed below just prior to
C      the call to the routine CTTDBF.
C
C The "base index" of a point node, an edge node, or a triangle node is
C always a multiple of the length of the node, to which can be added an
C offset to get the index of a particular element of the node.  For
C example, if I is the base index of a triangle of interest, ITRI(I+1)
C is its first element (the base index of its first edge).  Similarly,
C IEDG(ITRI(I+1)+2) is the base index of the second point of the first
C edge of the triangle with base index I, and RPNT(IEDG(ITRI(I+1)+2)+3)
C is the third (Z) coordinate of the second point of the first edge of
C the triangle with base index I.
C
C It is the pointers from the edge nodes back to the triangle nodes that
C allow CONPACKT to navigate the mesh, moving from triangle to triangle
C as it follows a contour line, but these pointers are tricky to define:
C if IPTE is the base index of an edge node and IEDG(IPTE+3) is zero or
C more, saying that there is a triangle to the left of the edge, then
C IEDG(IPTE+3) is the actual index of that element of the triangle node
C that points to the edge node; i.e., ITRI(IEDG(IPTE+3))=IPTE.  The base
C index of the triangle node defining that triangle is IPTT, where
C IPTT=LOTN*((IEDG(IPTE+3)-1)/LOTN), and the index of the pointer to
C the edge within the triangle node is IPTI=IEDG(IPTE+3)-IPTT, so that
C ITRI(IPTT+IPTI)=IPTE.  Similar comments apply to element 4 of an edge
C node, which points into the triangle node defining the triangle to the
C right of the edge.
C
C The maximum numbers of points, edges, and triangles in a triangular
C mesh can be computed in the following manner:  Since the triangular
C mesh is created from a rectangular one by splitting each rectangular
C cell in half, we can declare the largest values we expect to use for
C the dimensions of that mesh:
C
C       PARAMETER (IDIM=361,JDIM=181,IDM1=IDIM-1,JDM1=JDIM-1)
C       PARAMETER (IDIM=181,JDIM= 91,IDM1=IDIM-1,JDM1=JDIM-1)
C       PARAMETER (IDIM=121,JDIM= 61,IDM1=IDIM-1,JDM1=JDIM-1)
        PARAMETER (IDIM= 81,JDIM= 41,IDM1=IDIM-1,JDM1=JDIM-1)
C       PARAMETER (IDIM= 41,JDIM= 21,IDM1=IDIM-1,JDM1=JDIM-1)
C
C and then compute from those values the maximum number of points,
C edges, and triangles that the triangular mesh arrays will need to
C hold.  The computed values will be exactly as required if no points
C or edges of the rectangular grid are repeated in it; if there are
C repeating points or edges, space for slightly fewer points and edges
C will be needed:
C
        PARAMETER (MNOP=IDIM*JDIM)
        PARAMETER (MNOE=3*IDM1*JDM1+IDM1+JDM1)
        PARAMETER (MNOT=2*IDM1*JDM1)
C
C A simple lat/lon grid is a rectangular array, at each point of which
C we have latitude, longitude, and a data value.  From this rectangular
C grid, we construct a triangular mesh to test the contouring algorithm.
C XLAT and XLON are the arrays of latitudes and longitudes and ZDAT is
C the array of field values.
C
        DIMENSION XLAT(IDIM,JDIM),XLON(IDIM,JDIM),ZDAT(IDIM,JDIM)
C
C Each cell of the rectangular grid for which data is available at all
C four corners is split in half along one of its diagonals; resulting
C triangles form the triangular mesh.  As we create the triangular mesh,
C we have to keep track of where the points and edges of the rectangular
C grid were put (so as to avoid the problem of duplicating points and
C edges in the structure).  The array ISCR is used for this.
C
        DIMENSION ISCR(4,IDIM,JDIM)
C
C Once we know how many points, edges, and triangles we're going to use
C (at most), we can set parameters defining the space reserved for the
C triangular mesh:
C
        PARAMETER (MPNT=MNOP*LOPN)
        PARAMETER (MEDG=MNOE*LOEN)
        PARAMETER (MTRI=MNOT*LOTN)
C
C Declare the arrays to hold the point nodes, edge nodes, and triangle
C nodes defining the triangular mesh.
C
        DIMENSION RPNT(MPNT),IEDG(MEDG),ITRI(MTRI)
C
C Declare real and integer workspaces needed by CONPACKT.
C
        PARAMETER (LRWK=10000,LIWK=5000)
C
        DIMENSION RWRK(LRWK),IWRK(LIWK)
C
C Declare the area map array needed to do solid fill.
C
        PARAMETER (LAMA=2000000)
C
        DIMENSION IAMA(LAMA)
C
C Declare workspace arrays to be used in calls to ARSCAM.
C
        PARAMETER (NCRA=LAMA/10,NGPS=2)
C
        DIMENSION XCRA(NCRA),YCRA(NCRA),IAAI(NGPS),IAGI(NGPS)
C
C Declare arrays in which to generate a cell array picture of the
C data on the triangular mesh.
C
        PARAMETER (ICAM= 512,ICAN= 512)
C       PARAMETER (ICAM=1024,ICAN=1024)
C       PARAMETER (ICAM=2048,ICAN=2048)
C
        DIMENSION ICRA(ICAM,ICAN)
C
C Declare external the routine that draws masked contour lines.
C
        EXTERNAL DRWMCL
C
C Declare external the routine that does color fill of contour bands.
C
        EXTERNAL DCFOCB
C
C Define a common block in which to keep track of the maximum space used
C in the arrays XCRA and YCRA.
C
        COMMON /COMONA/ MAXN
C
C DEBUG: CHARACTER TEMPORARY FOR LABELLING PURPOSES.
C
C       CHARACTER*5 CTMP
C
C Set the desired minimum and maximum values of X, Y, and Z.
C
        DATA XMIN,YMIN,ZMIN,XMAX,YMAX,ZMAX / -1.,-1.,-1.,1.,1.,1. /
C
C Set the desired values of parameters determining the eye position.
C ANG1 is a bearing angle, ANG2 is an elevation angle, and RMUL is a
C multiplier of the length of the diagonal of the data box, specifying
C the distance from the center of the box to the eye.
C
        DATA ANG1,ANG2,RMUL / -35.,55.,2.9 /
C
C ISTE is a flag that says whether to do a simple image (ISTE=0),
C a one-frame stereo image (ISTE=-1), or a two-frame stereo image
C (ISTE=+1).
C
C       DATA ISTE /  0 /  !  simple image
C       DATA ISTE / -1 /  !  one-frame stereo image
C       DATA ISTE / +1 /  !  two-frame stereo image
C
        DATA ISTE / -1 /
C
C ASTE is the desired angle (in degrees) between the lines of sight for
C a pair of stereo views.
C
        DATA ASTE / 2. /
C
C WOSW is the width of the stereo windows to be used in one-frame stereo
C images; the width is stated as a fraction of the width of the plotter
C frame.  (The windows are centered vertically; horizontally, they are
C placed as far apart as possible in the plotter frame.)  The value used
C must be positive and non-zero; it may be slightly greater than .5, if
C it is desired that the stereo windows should overlap slightly.
C
        DATA WOSW / .5 /
C
C Define the tension on the splines to be used in smoothing contours.
C
C       DATA T2DS / 0.0 /  !  smoothing off
C       DATA T2DS / 2.5 /  !  smoothing on
C
        DATA T2DS / 0.0 /
C
C Define the distance between points on smoothed contour lines.
C
        DATA RSSL / .002 /
C
C Define the amount of real workspace to be used in drawing contours.
C
        DATA IRWC / 500 /
C
C Define the label-positioning flag.
C
C       DATA ILLP / 0 /  !  no labels
C       DATA ILLP / 1 /  !  dash-package writes labels
C       DATA ILLP / 2 /  !  regular scheme
C       DATA ILLP / 3 /  !  penalty scheme
C
        DATA ILLP / 2 /
C
C Define the high/low search radius.
C
        DATA HLSR / .075 /
C
C Define the high/low label overlap flag.
C
        DATA IHLO / 11 /
C
C Define the hachuring flag, hachure length, and hachure spacing.
C
C       DATA IHCF,HCHL,HCHS /  0 , +.004 , .010 /  !  off
C       DATA IHCF,HCHL,HCHS / +1 , -.004 , .020 /  !  on, all, uphill
C
        DATA IHCF,HCHL,HCHS /  0 , +.004 , .010 /
C
C Define conversion constants to convert from degrees to radians and
C vice-versa.
C
        DATA DTOR / .017453292519943 /
        DATA RTOD / 57.2957795130823 /
C
C Define a constant to be used in the code that blocks triangles too
C nearly parallel to the line of sight.
C
        DATA ATOL / 4. /
C
C Define the three radii of the initial ellipsoid; it cuts the X axis
C at + or - ARAD, the Y axis at + or - BRAD, and the Z axis at + or -
C CRAD.
C
        ARAD=1.0
        BRAD=1.4
        CRAD=1.8
C
C Create data and generate the required triangular mesh.
C
        PRINT * , ' '
        PRINT * , 'CREATING TRIANGULAR MESH:'
C
        CALL GTTD01 (RPNT,MPNT,NPNT,LOPN,
     +               IEDG,MEDG,NEDG,LOEN,
     +               ITRI,MTRI,NTRI,LOTN,
     +               IDIM,JDIM,XLAT,XLON,ZDAT,ISCR)
C
C Print the number of points, edges, and triangles.
C
        PRINT * , '  NUMBER OF POINTS:    ',NPNT/LOPN
        PRINT * , '  NUMBER OF EDGES:     ',NEDG/LOEN
        PRINT * , '  NUMBER OF TRIANGLES: ',NTRI/LOTN
C
C Set the flags in the edge nodes that will allow us to distinguish
C "diagonal" edges from others.
C
        DO 101 IPTE=0,NEDG-LOEN,LOEN
C
          XSP1=RPNT(IEDG(IPTE+1)+1)
          YSP1=RPNT(IEDG(IPTE+1)+2)
          ZSP1=RPNT(IEDG(IPTE+1)+3)
C
          RLT1=ASIN(ZSP1)
C
          IF (XSP1.NE.0..AND.YSP1.NE.0.) THEN
            RLN1=ATAN2(YSP1,XSP1)
          ELSE
            RLN1=0.
          END IF
C
          XSP2=RPNT(IEDG(IPTE+2)+1)
          YSP2=RPNT(IEDG(IPTE+2)+2)
          ZSP2=RPNT(IEDG(IPTE+2)+3)
C
          RLT2=ASIN(ZSP2)
C
          IF (XSP2.NE.0..AND.YSP2.NE.0.) THEN
            RLN2=ATAN2(YSP2,XSP2)
          ELSE
            RLN2=0.
          END IF
C
          IEDG(IPTE+6)=0
C
          IF (ABS(ZSP1).LT..9999.AND.ABS(ZSP2).LT..9999.AND.
     +        ABS(RLT1-RLT2).GT..0001.AND.
     +        ABS(RLN1-RLN2).GT..0001) IEDG(IPTE+6)=1
C
  101   CONTINUE
C
C Deform the triangular mesh to fit on the surface of the ellipsoid,
C further deform it to create a sort of distorted "dumbbell", and
C then supply dummy data values.
C
        CALL TDGDIN (-1.,1.,-1.,1.,-1.,1.,21,21)
C
        DO 102 IPTP=0,NPNT-LOPN,LOPN
          TRAD=1./SQRT(RPNT(IPTP+1)*RPNT(IPTP+1)/(ARAD*ARAD)+
     +                 RPNT(IPTP+2)*RPNT(IPTP+2)/(BRAD*BRAD)+
     +                 RPNT(IPTP+3)*RPNT(IPTP+3)/(CRAD*CRAD))
          RPNT(IPTP+1)=TRAD*RPNT(IPTP+1)
          RPNT(IPTP+2)=TRAD*RPNT(IPTP+2)
          RPNT(IPTP+3)=TRAD*RPNT(IPTP+3)
          RPNT(IPTP+1)=RPNT(IPTP+1)*(.3+.5*RPNT(IPTP+3)**2)
          RPNT(IPTP+2)=RPNT(IPTP+2)*(.3+.5*RPNT(IPTP+3)**2)
          RPNT(IPTP+3)=RPNT(IPTP+3)*(.7+.2*(RPNT(IPTP+1)**3+
     +                                      RPNT(IPTP+2)**3))
          RPNT(IPTP+4)=TDGDVA(RPNT(IPTP+1),RPNT(IPTP+2),RPNT(IPTP+3))
  102   CONTINUE
C
C Write the contents of the point list, the edge list, and the triangle
C list to "fort.11" in a readable form.
C
c       WRITE (11,'(''P'',I8,5F10.4)')
c    +        (I,RPNT(I+1),RPNT(I+2),RPNT(I+3),RPNT(I+4),RPNT(I+5),
c    +                                               I=0,NPNT-LOPN,LOPN)
c       WRITE (11,'(''E'',I8,5I10)')
c    +        (I,IEDG(I+1),IEDG(I+2),IEDG(I+3),IEDG(I+4),IEDG(I+5),
c    +                                               I=0,NEDG-LOEN,LOEN)
c       WRITE (11,'(''T'',I8,4I10)')
c    +        (I,ITRI(I+1),ITRI(I+2),ITRI(I+3),ITRI(I+4),
c    +                                               I=0,NTRI-LOTN,LOTN)
C
C Open GKS.
C
        PRINT * , 'OPENING AND INITIALIZING GKS'
C
        CALL GOPKS (IERF,0)
        CALL GOPWK (IWID,LUNI,IWTY)
        CALL GACWK (IWID)
C
C Turn on the clipping indicator.
C
        CALL GSCLIP (1)
C
C Define a basic set of colors (0 = white, background; 1 = black,
C foreground; 2 = yellow; 3 = magenta; 4 = red; 5 = cyan; 6 = green;
C 7 = blue; 8 = darker light gray; 9 = lighter light gray; 10 = dark
C yellow; 11 = dark gray; 12 = medium gray; 13 = light red, for
C geographic lines; 14 = light blue, for lat/lon lines).
C
        CALL GSCR   (IWID, 0,1.,1.,1.)
        CALL GSCR   (IWID, 1,0.,0.,0.)
        CALL GSCR   (IWID, 2,1.,1.,0.)
        CALL GSCR   (IWID, 3,1.,0.,1.)
        CALL GSCR   (IWID, 4,1.,0.,0.)
        CALL GSCR   (IWID, 5,0.,1.,1.)
        CALL GSCR   (IWID, 6,0.,1.,0.)
        CALL GSCR   (IWID, 7,0.,0.,1.)
        CALL GSCR   (IWID, 8,.5,.5,.5)
        CALL GSCR   (IWID, 9,.8,.8,.8)
        CALL GSCR   (IWID,10,.3,.3,0.)
        CALL GSCR   (IWID,11,.3,.3,.3)
        CALL GSCR   (IWID,12,.5,.5,.5)
        CALL GSCR   (IWID,13,.8,.5,.5)
        CALL GSCR   (IWID,14,.5,.5,.8)
C
C Define 100 colors, associated with color indices 151 through 250, to
C be used for color-filled contour bands and in cell arrays, ranging
C from blue to red.
C
C       CALL DFCRGB (IWID,151,250,0.,0.,1.,0.,1.,0.,0.) ! blue to green
C       CALL DFCRGB (IWID,151,250,0.,1.,0.,1.,0.,0.,0.) ! green to red
C       CALL DFCRGB (IWID,151,250,0.,0.,1.,1.,0.,0.,.4) ! blue to red
C       CALL DFCRGB (IWID,151,250,0.,1.,1.,1.,0.,1.,0.) ! cyan to magenta
C       CALL DFCRGB (IWID,151,250,0.,1.,1.,1.,1.,0.,0.) ! cyan to yellow
C
        CALL DFCRGB (IWID,151,250,0.,1.,1.,1.,0.,1.,0.)
C
C       CALL DFCHLS (IWID,151,250,0.,50.,100.,120.,50.,100.)
C
C Set parameters in the utilities.
C
        PRINT * , 'SETTING PARAMETERS IN CONPACKT AND PLOTCHAR'
C
C Set the mapping flag to select the TDPACK mapping (implies use of a
C special version of CTMXYZ).
C
        CALL CTSETI ('MAP - MAPPING FLAG',2)
C
C Set the area identifier for cells associated with triangles that are
C seen from "the back".
C
C       CALL CTSETI ('PAI - PARAMETER ARRAY INDEX',-1)
C       CALL CTSETI ('AIA - AREA IDENTIFIER FOR AREA',1001)
C
C Set the area identifier for cells associated with no triangles of the
C mesh.
C
C       CALL CTSETI ('PAI - PARAMETER ARRAY INDEX',-2)
C       CALL CTSETI ('AIA - AREA IDENTIFIER FOR AREA',1002)
C
C Set the 2D smoother flag.
C
        CALL CTSETR ('T2D - TENSION ON 2D SPLINES',T2DS)
C
C Set the distance between points on smoothed lines.
C
        CALL CTSETR ('SSL - SMOOTHED SEGMENT LENGTH',RSSL)
C
C Set the amount of real workspace to be used in drawing contours.
C
        CALL CTSETI ('RWC - REAL WORKSPACE FOR CONTOURS',IRWC)
C
C Set the label-positioning flag.
C
        CALL CTSETI ('LLP - LINE LABEL POSITIONING FLAG',ILLP)
C
C Set the high/low search radius.
C
        CALL CTSETR ('HLR - HIGH/LOW SEARCH RADIUS',HLSR)
C
C Set the high/low label overlap flag.
C
        CALL CTSETI ('HLO - HIGH/LOW LABEL OVERLAP FLAG',IHLO)
C
C Set the hachuring flag, hachure length, and hachure spacing.
C
        CALL CTSETI ('HCF - HACHURING FLAG',IHCF)
        CALL CTSETR ('HCL - HACHURE LENGTH',HCHL)
        CALL CTSETR ('HCS - HACHURE SPACING',HCHS)
C
C Set the cell array flag.
C
        CALL CTSETI ('CAF - CELL ARRAY FLAG',-1)
C
C Set the point-interpolation threshold value.
C
        CALL CTSETR ('PIT - POINT INTERPOLATION THRESHOLD VALUE',.005)
C
C Tell CONPACKT not to do its own call to SET, since TDPACK will have
C done it.
C
        CALL CTSETI ('SET - DO-SET-CALL FLAG', 0)
C
C Move the informational label up a little.
C
        CALL CTSETR ('ILY - INFORMATIONAL LABEL Y POSITION',-.005)
C
C Tell CONPACKT to use a little more workspace in CTTDBF.
C
        CALL CTSETI ('IWB - INTEGER WORKSPACE FOR BLOCKING',5000)
C
C Tell PLOTCHAR to use one of the filled fonts and to outline each
C character.
C
        CALL PCSETI ('FN',25)
        CALL PCSETI ('OF',1)
C
C Tell PLOTCHAR to expect a character other than a colon as the
C function-control signal character.
C
        CALL PCSETC ('FC','|')
C
C Find the midpoint of the data box (to be used as the point looked at).
C
        XMID=.5*(XMIN+XMAX)
        YMID=.5*(YMIN+YMAX)
        ZMID=.5*(ZMIN+ZMAX)
C
C Determine the distance (R) from which the data box will be viewed and,
C given that, the eye position.
C
        R=RMUL*SQRT((XMAX-XMIN)**2+(YMAX-YMIN)**2+(ZMAX-ZMIN)**2)
C
        XEYE=XMID+R*COS(DTOR*ANG1)*COS(DTOR*ANG2)
        YEYE=YMID+R*SIN(DTOR*ANG1)*COS(DTOR*ANG2)
        ZEYE=ZMID+R*SIN(DTOR*ANG2)
C
C SET THE TRIANGLE BLOCKING FLAGS FOR THE VIEWS TO BE DRAWN.
C --- --- -------- -------- ----- --- --- ----- -- -- ------
C
        PRINT * , 'SETTING TRIANGLE BLOCKING FLAGS'
C
C Initialize the stereo offset argument to do either a single view or
C a left-eye view (whichever is selected by the value of ISTE).
C
        IF (ISTE.EQ.0) THEN
          OTEP=0.
        ELSE
          OTEP=-R*TAN(DTOR*ASTE/2.)
        END IF
C
C Initialize TDPACK.
C
  103   PRINT * , '  INITIALIZING TDPACK'
C
        CALL TDINIT (XEYE,YEYE,ZEYE,XMID,YMID,ZMID,
     +                              XMID,YMID,ZMID+R,OTEP)
C
C If stereo views are being done, do the requested thing, either by
C redoing the SET call to put them side by side on the same frame,
C or by calling FRAME to put them on separate frames.
C
          IF (OTEP.NE.0.) THEN
            IF (ISTE.LT.0) THEN
              CALL GETSET (XVPL,XVPR,YVPB,YVPT,XWDL,XWDR,YWDB,YWDT,LNLG)
              IF (OTEP.LT.0.) THEN
                CALL SET  (1.-WOSW,1.,.5-.5*WOSW,.5+.5*WOSW,
     +                             XWDL,XWDR,YWDB,YWDT,LNLG)
              ELSE
                CALL SET  (  0., WOSW,.5-.5*WOSW,.5+.5*WOSW,
     +                             XWDL,XWDR,YWDB,YWDT,LNLG)
              END IF
            END IF
          END IF
C
C Initialize CONPACKT.
C
          PRINT * , '  INITIALIZING CONPACKT'
C
          PRINT * , '  CALLING CTMESH'
          CALL CTMESH (RPNT,NPNT,LOPN,
     +                 IEDG,NEDG,LOEN,
     +                 ITRI,NTRI,LOTN,
     +                 RWRK,LRWK,
     +                 IWRK,LIWK)
C
C CTTDBF is called to set blocking flag bits for triangles according to
C various criteria.  Its next-to-last argument may take on the following
C values:
C
C   0 => just clear the blocking flags for all triangles.
C   1 => set blocking flags for triangles that are nearly edge-on to
C        the line of sight or that are seen from the "wrong" side (so
C        that they appear to be defined by points given in clockwise
C        order, rather than in counter-clockwise order).
C   2 => set blocking flags for triangles that are hidden by other
C        triangles of the mesh.
C   3 => do both 1 and 2.
C
C Its final argument is a tolerance value, in degrees, defining what
C it means for a triangle to be nearly edge-on to the line of sight.
C Using the value zero turns off the setting of nearly-edge-on bits.
C
C The bits used in the blocking flags are as follows.  Assume that the
C seven rightmost (lowest-order) bits of the blocking flags are numbered
C as follows:
C
C   . . . B6 B5 B4 B3 B2 B1 B0
C
C Bit B0 of the blocking flag for a triangle is untouched by a call to
C CTTDBF; a user may set it to block the triangle.
C
C Bits B3, B2, and B1 are used for the view from the right eye (when
C stereo views are being drawn) or the only eye (when a simple view is
C being drawn).  If B3 is set, it indicates that the triangle is hidden
C by another triangle of the mesh; if B2 is set, it indicates that the
C triangle is nearly edge-on to the line of sight; if B1 is set, it
C indicates that the triangle is seen from the wrong side.
C
C Bits B6, B5, and B4 are defined similarly, but apply to the view from
C the left eye, rather than the right eye (when stereo views are being
C done).
C
          PRINT * , '  CALLING CTTDBF'
C
          CALL CTTDBF (RPNT,IEDG,ITRI,RWRK,IWRK,3,2.)
C
C If a left-eye view has just been done, loop back for a right-eye view.
C
          IF (OTEP.LT.0.) THEN
            OTEP=-OTEP
            GO TO 103
          END IF
C
C Once bits B6, B5, B4, B3, B2, B1, and B0 are set in all the triangle
C blocking flags, one may use them to determine what is drawn in a
C particular view.  This is done by calling the routine CTTDBM, which
C has eight integer arguments.  The first four arguments are used to
C toggle bit values from the triangle's blocking flag, while the final
C four arguments are used to determine which of those bit values are
C considered to be meaningful.  For example, using the values "0, 0,
C 0, 0, 1, 1, 0, 1" says that none of the four values is to be toggled
C and that all will be allowed to block the triangle except the third;
C the net effect is to block triangles that are hidden, nearly edge-on,
C or blocked by the user, but none that are viewed from the wrong side.
C The four bits used from the blocking flag of each triangle are either
C bits B3, B2, B1, and B0, if the right (or only) eye is in use or bits
C B6, B5, B4, and B0, if the left eye is in use.
C
C Set masks for 3-D| t t t t u u u u | toggle/use
C triangle blocking| h e w u h e w u | hidden/edge-on/wrongside/user
C
C       CALL CTTDBM (0,0,0,0,1,1,0,1)
C
C In this example, there is a single call to CTTDBM, as just described:
C
        CALL CTTDBM (0,0,0,0,1,1,0,1)
C
C DRAW THE TRIANGULAR MESH, IF REQUESTED.
C ---- --- ---------- ----- -- ----------
C
        IF (IMSH.NE.0) THEN
C
          PRINT * , 'DRAWING TRIANGULAR MESH'
C
C Initialize the stereo offset argument to do either a single view or
C a left-eye view (whichever is selected by the value of ISTE).
C
          IF (ISTE.EQ.0) THEN
            OTEP=0.
          ELSE
            OTEP=-R*TAN(DTOR*ASTE/2.)
          END IF
C
C Initialize TDPACK.
C
  104     PRINT * , '  INITIALIZING TDPACK'
C
          CALL TDINIT (XEYE,YEYE,ZEYE,XMID,YMID,ZMID,
     +                                XMID,YMID,ZMID+R,OTEP)
C
C If stereo views are being done, do the requested thing, either by
C redoing the SET call to put them side by side on the same frame,
C or by calling FRAME to put them on separate frames.
C
          IF (OTEP.NE.0.) THEN
            IF (ISTE.LT.0) THEN
              CALL GETSET (XVPL,XVPR,YVPB,YVPT,XWDL,XWDR,YWDB,YWDT,LNLG)
              IF (OTEP.LT.0.) THEN
                CALL SET  (1.-WOSW,1.,.5-.5*WOSW,.5+.5*WOSW,
     +                             XWDL,XWDR,YWDB,YWDT,LNLG)
              ELSE
                CALL SET  (  0., WOSW,.5-.5*WOSW,.5+.5*WOSW,
     +                             XWDL,XWDR,YWDB,YWDT,LNLG)
              END IF
            ELSE
              IF (OTEP.GT.0.) CALL FRAME
            END IF
          END IF
C
C Draw the mesh, showing only the edges of unblocked triangles.
C
          CALL PLOTIT (0,0,2)
          CALL GSPLCI (8)
C
          CALL CTTDDM (RPNT,IEDG,ITRI,RWRK,IWRK,(1-IDIA)*6)
C
          CALL PLOTIT (0,0,2)
          CALL GSPLCI (1)
C
C If a left-eye view has just been done, loop back for a right-eye view.
C
          IF (OTEP.LT.0.) THEN
            OTEP=-OTEP
            GO TO 104
          END IF
C
C Advance the frame.
C
          CALL FRAME
C
        END IF
C
C DRAW SIMPLE CONTOURS, IF REQUESTED.
C ---- ------ --------- -- ----------
C
        IF (ICON.NE.0) THEN
C
          PRINT * , 'DRAWING SIMPLE CONTOUR PLOT'
C
C Initialize the stereo offset argument to do either a single view or
C a left-eye view (whichever is selected by the value of ISTE).
C
          IF (ISTE.EQ.0) THEN
            OTEP=0.
          ELSE
            OTEP=-R*TAN(DTOR*ASTE/2.)
          END IF
C
C Initialize TDPACK.
C
  105     PRINT * , '  INITIALIZING TDPACK'
C
          CALL TDINIT (XEYE,YEYE,ZEYE,XMID,YMID,ZMID,
     +                                XMID,YMID,ZMID+R,OTEP)
C
C If stereo views are being done, do the requested thing, either by
C redoing the SET call to put them side by side on the same frame,
C or by calling FRAME to put them on separate frames.
C
          IF (OTEP.NE.0.) THEN
            IF (ISTE.LT.0) THEN
              CALL GETSET (XVPL,XVPR,YVPB,YVPT,XWDL,XWDR,YWDB,YWDT,LNLG)
              IF (OTEP.LT.0.) THEN
                CALL SET  (1.-WOSW,1.,.5-.5*WOSW,.5+.5*WOSW,
     +                             XWDL,XWDR,YWDB,YWDT,LNLG)
              ELSE
                CALL SET  (  0., WOSW,.5-.5*WOSW,.5+.5*WOSW,
     +                             XWDL,XWDR,YWDB,YWDT,LNLG)
              END IF
            ELSE
              IF (OTEP.GT.0.) CALL FRAME
            END IF
          END IF
C
C Initialize CONPACKT.
C
          PRINT * , '  INITIALIZING CONPACKT'
C
          PRINT * , '  CALLING CTMESH'
          CALL CTMESH (RPNT,NPNT,LOPN,
     +                 IEDG,NEDG,LOEN,
     +                 ITRI,NTRI,LOTN,
     +                 RWRK,LRWK,
     +                 IWRK,LIWK)
C
          IF (IMSN.NE.0) THEN
C
            PRINT * , '  DRAWING TRIANGULAR MESH'
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (8)
C
            CALL CTTDDM (RPNT,IEDG,ITRI,RWRK,IWRK,(1-IDIA)*6)
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (1)
C
C Debug code: number the triangles.
C
C           CALL PLOTIT (0,0,2)
C           CALL GSPLCI (4)
C
C           DO 999 IPTT=0,NTRI-LOTN,LOTN
C             WRITE (CTMP,'(I5)') IPTT/LOTN+1
C             XPOS=(RPNT(IEDG(ITRI(IPTT+1)+1)+1)+
C    +              RPNT(IEDG(ITRI(IPTT+1)+2)+1)+
C    +              RPNT(IEDG(ITRI(IPTT+2)+1)+1)+
C    +              RPNT(IEDG(ITRI(IPTT+2)+2)+1)+
C    +              RPNT(IEDG(ITRI(IPTT+3)+1)+1)+
C    +              RPNT(IEDG(ITRI(IPTT+3)+2)+1))/6.
C             YPOS=(RPNT(IEDG(ITRI(IPTT+1)+1)+2)+
C    +              RPNT(IEDG(ITRI(IPTT+1)+2)+2)+
C    +              RPNT(IEDG(ITRI(IPTT+2)+1)+2)+
C    +              RPNT(IEDG(ITRI(IPTT+2)+2)+2)+
C    +              RPNT(IEDG(ITRI(IPTT+3)+1)+2)+
C    +              RPNT(IEDG(ITRI(IPTT+3)+2)+2))/6.
C             ZPOS=(RPNT(IEDG(ITRI(IPTT+1)+1)+3)+
C    +              RPNT(IEDG(ITRI(IPTT+1)+2)+3)+
C    +              RPNT(IEDG(ITRI(IPTT+2)+1)+3)+
C    +              RPNT(IEDG(ITRI(IPTT+2)+2)+3)+
C    +              RPNT(IEDG(ITRI(IPTT+3)+1)+3)+
C    +              RPNT(IEDG(ITRI(IPTT+3)+2)+3))/6.
C             CALL TDPRPT (XPOS,YPOS,ZPOS,XLBL,YLBL)
C             DO 998 I=1,5
C               J=6-I
C               IF (CTMP(I:I).NE.' ') ILNB=I
C               IF (CTMP(J:J).NE.' ') IFNB=J
C 998         CONTINUE
C             CALL PLCHMQ (XLBL,YLBL,CTMP(IFNB:ILNB),.0004,0.,0.)
C 999       CONTINUE
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (1)
C
          END IF
C
C Proceed as implied by the setting of the label-positioning flag.
C
          IF (ABS(ILLP).EQ.1) THEN
C
C Draw the contour lines with labels generated by the dash package.
C
            PRINT * , '  CALLING CTCLDR'
            CALL CTCLDR (RPNT,IEDG,ITRI,RWRK,IWRK)
C
C Add the informational and high/low labels.
C
            PRINT * , '  CALLING CTLBDR'
            CALL CTLBDR (RPNT,IEDG,ITRI,RWRK,IWRK)
C
          ELSE IF (ABS(ILLP).GT.1) THEN
C
C Create an area map for masking of labels.
C
            MAXN=0
C
            PRINT * , '  CALLING ARINAM'
            CALL ARINAM (IAMA,LAMA)
C
            PRINT * , '  CALLING CTLBAM'
            CALL CTLBAM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA)
C
C Draw the contour lines masked by the area map.
C
            PRINT * , '  CALLING CTCLDM'
            CALL CTCLDM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA,DRWMCL)
C
            PRINT * , '  AREA MAP SPACE REQUIRED:         ',
     +                                         IAMA(1)-IAMA(6)+IAMA(5)+1
C
            PRINT * , '  NUMBER OF POINTS IN LONGEST LINE:',MAXN
C
C Draw all the labels.
C
            PRINT * , '  CALLING CTLBDR'
            CALL CTLBDR (RPNT,IEDG,ITRI,RWRK,IWRK)
C
          END IF
C
          CALL CTGETI ('IWU - INTEGER WORKSPACE USED',IIWU)
          PRINT * , '  INTEGER WORKSPACE REQUIRED:      ',IIWU
C
          CALL CTGETI ('RWU -    REAL WORKSPACE USED',IRWU)
          PRINT * , '  REAL WORKSPACE REQUIRED:         ',IRWU
C
C If a left-eye view has just been done, loop back for a right-eye view.
C
          IF (OTEP.LT.0.) THEN
            OTEP=-OTEP
            GO TO 105
          END IF
C
C Advance the frame.
C
          CALL FRAME
C
        END IF
C
C DRAW COLOR-FILLED CONTOUR BANDS (USING AN AREA MAP), IF REQUESTED.
C ---- ------------ ------- ----- ------ -- ---- ----- -- ----------
C
        IF (ICOL.NE.0) THEN
C
          PRINT * , 'DRAWING COLOR-FILLED CONTOUR PLOT (USING AREA MAP)'
C
C Initialize the stereo offset argument to do either a single view or
C a left-eye view (whichever is selected by the value of ISTE).
C
          IF (ISTE.EQ.0) THEN
            OTEP=0.
          ELSE
            OTEP=-R*TAN(DTOR*ASTE/2.)
          END IF
C
C Initialize TDPACK.
C
  106     PRINT * , '  INITIALIZING TDPACK'
C
          CALL TDINIT (XEYE,YEYE,ZEYE,XMID,YMID,ZMID,
     +                                XMID,YMID,ZMID+R,OTEP)
C
C If stereo views are being done, do the requested thing, either by
C redoing the SET call to put them side by side on the same frame,
C or by calling FRAME to put them on separate frames.
C
          IF (OTEP.NE.0.) THEN
            IF (ISTE.LT.0) THEN
              CALL GETSET (XVPL,XVPR,YVPB,YVPT,XWDL,XWDR,YWDB,YWDT,LNLG)
              IF (OTEP.LT.0.) THEN
                CALL SET  (1.-WOSW,1.,.5-.5*WOSW,.5+.5*WOSW,
     +                             XWDL,XWDR,YWDB,YWDT,LNLG)
              ELSE
                CALL SET  (  0., WOSW,.5-.5*WOSW,.5+.5*WOSW,
     +                             XWDL,XWDR,YWDB,YWDT,LNLG)
              END IF
            ELSE
              IF (OTEP.GT.0.) CALL FRAME
            END IF
          END IF
C
C Initialize CONPACKT.
C
          PRINT * , '  INITIALIZING CONPACKT'
C
          PRINT * , '  CALLING CTMESH'
          CALL CTMESH (RPNT,NPNT,LOPN,
     +                 IEDG,NEDG,LOEN,
     +                 ITRI,NTRI,LOTN,
     +                 RWRK,LRWK,
     +                 IWRK,LIWK)
C
          MAXN=0
C
          PRINT * , '  CALLING CTPKCL'
          CALL CTPKCL (RPNT,IEDG,ITRI,RWRK,IWRK)
C
          PRINT * , '  CALLING ARINAM'
          CALL ARINAM (IAMA,LAMA)
C
          PRINT * , '  CALLING CTCLAM'
          CALL CTCLAM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA)
C
C         PRINT * , '  CALLING CTLBAM'
C         CALL CTLBAM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA)
C
          PRINT * , '  CALLING ARSCAM'
          CALL ARSCAM (IAMA,XCRA,YCRA,NCRA,IAAI,IAGI,NGPS,DCFOCB)
C
          PRINT * , '  SPACE REQUIRED IN AREA MAP:      ',
     +                                         IAMA(1)-IAMA(6)+IAMA(5)+1
C
          PRINT * , '  NUMBER OF POINTS IN LARGEST AREA:',MAXN
C
          CALL CTGETI ('IWU - INTEGER WORKSPACE USED',IIWU)
          PRINT * , '  INTEGER WORKSPACE REQUIRED:      ',IIWU
C
          CALL CTGETI ('RWU -    REAL WORKSPACE USED',IRWU)
          PRINT * , '  REAL WORKSPACE REQUIRED:         ',IRWU
C
          IF (IMSL.NE.0) THEN
C
            PRINT * , '  DRAWING TRIANGULAR MESH'
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (8)
C
            CALL CTTDDM (RPNT,IEDG,ITRI,RWRK,IWRK,(1-IDIA)*6)
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (1)
C
          END IF
C
          IF (ICSL.NE.0) THEN
C
            IF (ABS(ILLP).EQ.1) THEN
C
              PRINT * , '  CALLING CTCLDR'
              CALL CTCLDR (RPNT,IEDG,ITRI,RWRK,IWRK)
C
              PRINT * , '  CALLING CTLBDR'
              CALL CTLBDR (RPNT,IEDG,ITRI,RWRK,IWRK)
C
            ELSE IF (ABS(ILLP).GT.1) THEN
C
              MAXN=0
C
              PRINT * , '  CALLING ARINAM'
              CALL ARINAM (IAMA,LAMA)
C
              PRINT * , '  CALLING CTLBAM'
              CALL CTLBAM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA)
C
              PRINT * , '  CALLING CTCLDM'
              CALL CTCLDM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA,DRWMCL)
C
              PRINT * , '  AREA MAP SPACE REQUIRED:         ',
     +                                         IAMA(1)-IAMA(6)+IAMA(5)+1
C
              PRINT * , '  NUMBER OF POINTS IN LONGEST LINE:',MAXN
C
              PRINT * , '  CALLING CTLBDR'
              CALL CTLBDR (RPNT,IEDG,ITRI,RWRK,IWRK)
C
            END IF
C
            CALL CTGETI ('IWU - INTEGER WORKSPACE USED',IIWU)
            PRINT * , '  INTEGER WORKSPACE REQUIRED:      ',IIWU
C
            CALL CTGETI ('RWU -    REAL WORKSPACE USED',IRWU)
            PRINT * , '  REAL WORKSPACE REQUIRED:         ',IRWU
C
          END IF
C
C If a left-eye view has just been done, loop back for a right-eye view.
C
          IF (OTEP.LT.0.) THEN
            OTEP=-OTEP
            GO TO 106
          END IF
C
C Advance the frame.
C
          CALL FRAME
C
        END IF
C
C DRAW COLOR-FILLED CONTOUR BANDS (USING A CELL ARRAY), IF REQUESTED.
C ---- ------------ ------- ----- ------ - ---- ------- -- ----------
C
        IF (ICAP.NE.0) THEN
C
          PRINT * , 'DRAWING COLOR-FILLED CONTOUR PLOT (CELL ARRAY)'
C
C Initialize the stereo offset argument to do either a single view or
C a left-eye view (whichever is selected by the value of ISTE).
C
          IF (ISTE.EQ.0) THEN
            OTEP=0.
          ELSE
            OTEP=-R*TAN(DTOR*ASTE/2.)
          END IF
C
C Initialize TDPACK.
C
  107     PRINT * , '  INITIALIZING TDPACK'
C
          CALL TDINIT (XEYE,YEYE,ZEYE,XMID,YMID,ZMID,
     +                                XMID,YMID,ZMID+R,OTEP)
C
C If stereo views are being done, do the requested thing, either by
C redoing the SET call to put them side by side on the same frame,
C or by calling FRAME to put them on separate frames.
C
          IF (OTEP.NE.0.) THEN
            IF (ISTE.LT.0) THEN
              CALL GETSET (XVPL,XVPR,YVPB,YVPT,XWDL,XWDR,YWDB,YWDT,LNLG)
              IF (OTEP.LT.0.) THEN
                CALL SET  (1.-WOSW,1.,.5-.5*WOSW,.5+.5*WOSW,
     +                             XWDL,XWDR,YWDB,YWDT,LNLG)
              ELSE
                CALL SET  (  0., WOSW,.5-.5*WOSW,.5+.5*WOSW,
     +                             XWDL,XWDR,YWDB,YWDT,LNLG)
              END IF
            ELSE
              IF (OTEP.GT.0.) CALL FRAME
            END IF
          END IF
C
C Initialize CONPACKT.
C
          PRINT * , '  INITIALIZING CONPACKT'
C
          PRINT * , '  CALLING CTMESH'
          CALL CTMESH (RPNT,NPNT,LOPN,
     +                 IEDG,NEDG,LOEN,
     +                 ITRI,NTRI,LOTN,
     +                 RWRK,LRWK,
     +                 IWRK,LIWK)
C
C Retrieve the arguments with which SET was called.
C
          CALL GETSET (XVPL,XVPR,YVPB,YVPT,XWDL,XWDR,YWDB,YWDT,LNLG)
C
          PRINT * , '  CALLING CTTDCA'
          CALL CTTDCA (RPNT,IEDG,ITRI,RWRK,IWRK,ICRA,ICAM,ICAM,ICAN,
     +                                          XVPL,YVPB,XVPR,YVPT)
C
          PRINT * , '  CALLING GCA'
          CALL GCA (XWDL,YWDB,XWDR,YWDT,ICAM,ICAN,1,1,ICAM,ICAN,ICRA)
C
          CALL CTGETI ('IWU - INTEGER WORKSPACE USED',IIWU)
          PRINT * , '  INTEGER WORKSPACE REQUIRED:      ',IIWU
C
          CALL CTGETI ('RWU -    REAL WORKSPACE USED',IRWU)
          PRINT * , '  REAL WORKSPACE REQUIRED:         ',IRWU
C
          IF (IMSP.NE.0) THEN
C
            PRINT * , '  DRAWING TRIANGULAR MESH'
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (8)
C
            CALL CTTDDM (RPNT,IEDG,ITRI,RWRK,IWRK,(1-IDIA)*6)
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (1)
C
          END IF
C
          IF (ICOP.NE.0) THEN
C
            IF (ABS(ILLP).EQ.1) THEN
C
              PRINT * , '  CALLING CTCLDR'
              CALL CTCLDR (RPNT,IEDG,ITRI,RWRK,IWRK)
C
              PRINT * , '  CALLING CTLBDR'
              CALL CTLBDR (RPNT,IEDG,ITRI,RWRK,IWRK)
C
            ELSE IF (ABS(ILLP).GT.1) THEN
C
              MAXN=0
C
              PRINT * , '  CALLING ARINAM'
              CALL ARINAM (IAMA,LAMA)
C
              PRINT * , '  CALLING CTLBAM'
              CALL CTLBAM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA)
C
              PRINT * , '  CALLING CTCLDM'
              CALL CTCLDM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA,DRWMCL)
C
              PRINT * , '  AREA MAP SPACE REQUIRED:         ',
     +                                         IAMA(1)-IAMA(6)+IAMA(5)+1
C
              PRINT * , '  NUMBER OF POINTS IN LONGEST LINE:',MAXN
C
              PRINT * , '  CALLING CTLBDR'
              CALL CTLBDR (RPNT,IEDG,ITRI,RWRK,IWRK)
C
            END IF
C
            CALL CTGETI ('IWU - INTEGER WORKSPACE USED',IIWU)
            PRINT * , '  INTEGER WORKSPACE REQUIRED:      ',IIWU
C
            CALL CTGETI ('RWU -    REAL WORKSPACE USED',IRWU)
            PRINT * , '  REAL WORKSPACE REQUIRED:         ',IRWU
C
          END IF
C
C If a left-eye view has just been done, loop back for a right-eye view.
C
          IF (OTEP.LT.0.) THEN
            OTEP=-OTEP
            GO TO 107
          END IF
C
C Advance the frame.
C
          CALL FRAME
C
        END IF
C
C DONE.
C -----
C
C Close GKS.
C
        CALL GDAWK (IWID)
        CALL GCLWK (IWID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END


      SUBROUTINE DFCRGB (IWID,IOFC,IOLC,BRED,BGRN,BBLU,ERED,EGRN,EBLU,
     +                                                           AMUL)
C
C This routine defines color indices IOFC through IOLC on workstation
C IWID by interpolating values from BRED/BGRN/BBLU to ERED/EGRN/EBLU.
C
C BRED, BGRN, BBLE, ERED, EGRN, and EBLU are all reals between 0 and 1.
C
C AMUL should be a real between zero and one: zero gives interpolated
C values along a straight line in the RGB color cube; larger values
C give interpolated values along a curved line that bends toward the
C black corner of the cube.  On some of the newer color laser jet
C printers, using a non-zero value of AMUL gives colors closer to what
C one sees on one's monitor; for example, if the colors range from pure
C blue to pure red, using AMUL=.6 works pretty well.
C
        DO 101 I=IOFC,IOLC
          P=REAL(IOLC-I)/REAL(IOLC-IOFC)
          Q=REAL(I-IOFC)/REAL(IOLC-IOFC)
          RRED=P*BRED+Q*ERED
          RGRN=P*BGRN+Q*EGRN
          RBLU=P*BBLU+Q*EBLU
          DMIN=SQRT(MIN((RRED-0.)**2+(RGRN-0.)**2+(RBLU-0.)**2,
     +                  (RRED-0.)**2+(RGRN-0.)**2+(RBLU-1.)**2,
     +                  (RRED-0.)**2+(RGRN-1.)**2+(RBLU-0.)**2,
     +                  (RRED-0.)**2+(RGRN-1.)**2+(RBLU-1.)**2,
     +                  (RRED-1.)**2+(RGRN-0.)**2+(RBLU-0.)**2,
     +                  (RRED-1.)**2+(RGRN-0.)**2+(RBLU-1.)**2,
     +                  (RRED-1.)**2+(RGRN-1.)**2+(RBLU-0.)**2,
     +                  (RRED-1.)**2+(RGRN-1.)**2+(RBLU-1.)**2))
          DNOM=1.-(2.*DMIN/SQRT(3.))*MAX(0.,MIN(1.,AMUL))
          RRED=RRED*DNOM
          RGRN=RGRN*DNOM
          RBLU=RBLU*DNOM
          CALL GSCR (IWID,I,RRED,RGRN,RBLU)
  101   CONTINUE
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE DFCHLS (IWID,IOFC,IOLC,BHUE,BLIT,BSAT,EHUE,ELIT,ESAT)
C
C This routine defines color indices IOFC through IOLC on workstation
C IWID by interpolating values from BHUE/BLIT/BSAT to EHUE/ELIT/ESAT.
C
C BHUE and EHUE are expressed as angles between 0 and 720.  Linear
C interpolation will be used to get intermediate values and then the
C result will be reduced modulo 360.
C
C BLIT, BSAT, ELIT, and ESAT are expressed as percentages between 0 and
C 100.
C
        DO 101 I=IOFC,IOLC
          P=REAL(IOLC-I)/REAL(IOLC-IOFC)
          Q=REAL(I-IOFC)/REAL(IOLC-IOFC)
          RHUE=MOD(P*BHUE+Q*EHUE,360.)
          RLIT=MAX(0.,MIN(100.,P*BLIT+Q*ELIT))
          RSAT=MAX(0.,MIN(100.,P*BSAT+Q*ESAT))
          CALL HLSRGB (RHUE,RLIT,RSAT,RRED,RGRN,RBLU)
          CALL GSCR   (IWID,I,RRED,RGRN,RBLU)
  101   CONTINUE
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE DRWMCL (XCRA,YCRA,NCRA,IAAI,IAGI,NGPS)
C
        DIMENSION XCRA(*),YCRA(*),IAAI(*),IAGI(*)
C
C This routine draws the curve defined by the points (XCRA(I),YCRA(I)),
C for I = 1 to NCRA, if and only if none of the area identifiers for the
C area containing the polyline are negative.  It calls either CURVE or
C CURVED to do the drawing, depending on the value of the internal
C parameter 'DPU'.
C
C It keeps track of the maximum value used for NCRA in a common block.
C
        COMMON /COMONA/ MAXN
C
        MAXN=MAX(MAXN,NCRA)
C
C Retrieve the value of the internal parameter 'DPU'.
C
        CALL CTGETI ('DPU - DASH PACKAGE USED',IDUF)
C
C Turn on drawing.
C
        IDRW=1
C
C If any area identifier is negative, turn off drawing.
C
        DO 101 I=1,NGPS
          IF (IAAI(I).LT.0) IDRW=0
  101   CONTINUE
C
C If drawing is turned on, draw the polyline.
C
        IF (IDRW.NE.0) THEN
          IF (IDUF.EQ.0) THEN
            CALL CURVE  (XCRA,YCRA,NCRA)
          ELSE IF (IDUF.LT.0) THEN
            CALL DPCURV (XCRA,YCRA,NCRA)
          ELSE
            CALL CURVED (XCRA,YCRA,NCRA)
          END IF
        END IF
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE DCFOCB (XCRA,YCRA,NCRA,IAAI,IAGI,NGPS)
C
C This routine fills the area defined by the points (XCRA(I),YCRA(I)),
C for I = 1 to NCRA, if and only if none of the area identifiers for
C the area are negative.  The color used is determined from the area
C identifier of the area relative to group 3; it is assumed that 100
C colors are defined having color indices 151 through 250.
C
        DIMENSION XCRA(*),YCRA(*),IAAI(*),IAGI(*)
C
C It keeps track of the maximum value used for NCRA in a common block.
C
        COMMON /COMONA/ MAXN
C
        MAXN=MAX(MAXN,NCRA)
C
C Retrieve the number of contour levels being used.
C
        CALL CTGETI ('NCL - NUMBER OF CONTOUR LEVELS',NOCL)
C
C If the number of contour levels is non-zero and the area has more
C than two points, fill it.
C
        IF (NOCL.NE.0.AND.NCRA.GT.2) THEN
C
          IAI3=-1
C
          DO 101 I=1,NGPS
            IF (IAGI(I).EQ.3) IAI3=IAAI(I)
  101     CONTINUE
C
          IF (IAI3.GE.1.AND.IAI3.LE.NOCL+1) THEN
            CALL GSFACI (151+INT(((REAL(IAI3)-.5)/REAL(NOCL+1))*100.))
            CALL GFA    (NCRA,XCRA,YCRA)
          ELSE IF (IAI3.EQ.1001) THEN
            CALL GSFACI (2)
            CALL GFA    (NCRA,XCRA,YCRA)
          ELSE IF (IAI3.EQ.1002) THEN
            CALL GSFACI (3)
            CALL GFA    (NCRA,XCRA,YCRA)
          END IF
C
        END IF
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE GTTD01 (RPNT,MPNT,NPNT,LOPN,
     +                   IEDG,MEDG,NEDG,LOEN,
     +                   ITRI,MTRI,NTRI,LOTN,
     +                   IDIM,JDIM,XLAT,XLON,ZDAT,ISCR)
C
        DIMENSION RPNT(MPNT),IEDG(MEDG),ITRI(MTRI)
C
C A simple lat/lon grid is a rectangular array, at each point of which
C we have latitude, longitude, and a data value.  From this rectangular
C grid, we construct a triangular mesh to test the contouring algorithm.
C Declare arrays to receive the grid data.  XLAT and XLON are arrays of
C latitudes and longitudes and ZDAT the array of field values.
C
        DIMENSION XLAT(IDIM,JDIM),XLON(IDIM,JDIM),ZDAT(IDIM,JDIM)
C
C Each cell of the rectangular grid for which data is available at all
C four corners is split in half along one of its diagonals; resulting
C triangles form the triangular mesh.  As we create the triangular mesh,
C we have to keep track of where the points and edges of the rectangular
C grid were put (so as to avoid the problem of duplicating points and
C edges in the structure).  The array ISCR is used for this.
C
        DIMENSION ISCR(4,IDIM,JDIM)
C
C Declare external a routine to tell CTTMRG about points of overlap on
C the lat/lon grid.
C
        EXTERNAL MITD01
C
C Define a constant used to convert from degrees to radians.
C
        DATA DTOR / .017453292519943 /
C
C Define latitudes, longitudes, and dummy field values on a rectangular
C mesh to be wrapped around the globe.
C
        DO 102 I=1,IDIM
          DO 101 J=1,JDIM
            XLAT(I,J)= -90.+(REAL(J-1)/REAL(JDIM-1))*180.
            XLON(I,J)=-180.+(REAL(I-1)/REAL(IDIM-1))*360.
            ZDAT(I,J)=1.
  101     CONTINUE
  102   CONTINUE
C
C Call a general-purpose subroutine that accepts a rectangular grid
C mapped onto the surface of the globe and returns a triangular mesh
C equivalent to it.
C
        CALL CTTMRG (IDIM,JDIM,
     +               XLAT,XLON,ZDAT,ISCR,
     +                 0.,MITD01,
     +               RPNT,MPNT,NPNT,LOPN,
     +               IEDG,MEDG,NEDG,LOEN,
     +               ITRI,MTRI,NTRI,LOTN)

C Done.
C
        RETURN
C
      END


      SUBROUTINE MITD01 (IDIM,JDIM,IINI,JINI,IINO,JINO)
C
C Given the dimensions, IDIM and JDIM, of a simple lat/lon grid on the
C globe, and the indices, IINI and JINI, of a point on the grid, this
C routine returns the indices, IINO and JINO, of that coincident point
C on the grid which is to be used to represent it.  This version assumes
C that the first and last rows of the grid each map into a single point
C (perhaps the south pole and the north pole, respectively) and that
C the right and left edges of the grid lie on top of each other.
C
        IF (JINI.EQ.1) THEN
          IINO=1
          JINO=1
        ELSE IF (JINI.EQ.JDIM) THEN
          IINO=1
          JINO=JDIM
        ELSE IF (IINI.EQ.IDIM) THEN
          IINO=1
          JINO=JINI
        ELSE
          IINO=IINI
          JINO=JINI
        END IF
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE TDGDIN (XMIN,XMAX,YMIN,YMAX,ZMIN,ZMAX,MLOW,MHGH)
C
C This is a routine to generate test data for three-dimensional graphics
C routines.  The function used is a sum of exponentials.
C
C "MLOW" and "MHGH" are each forced to be greater than or equal to 1 and
C less than or equal to 25.
C
        COMMON /TDGDCO/ XRNG,YRNG,ZRNG,NCNT,CCNT(4,50)
        SAVE   /TDGDCO/
C
        XRNG=XMAX-XMIN
        YRNG=YMAX-YMIN
        ZRNG=ZMAX-ZMIN
C
        NLOW=MAX(1,MIN(25,MLOW))
        NHGH=MAX(1,MIN(25,MHGH))
        NCNT=NLOW+NHGH
C
        DO 101 ICNT=1,NCNT
          CCNT(1,ICNT)=XMIN+XRNG*FRAN()
          CCNT(2,ICNT)=YMIN+YRNG*FRAN()
          CCNT(3,ICNT)=ZMIN+ZRNG*FRAN()
          IF (ICNT.LE.NLOW) THEN
            CCNT(4,ICNT)=-1.
          ELSE
            CCNT(4,ICNT)=+1.
          END IF
  101   CONTINUE
C
        RETURN
C
      END


      FUNCTION TDGDVA (XPOS,YPOS,ZPOS)
C
        COMMON /TDGDCO/ XRNG,YRNG,ZRNG,NCNT,CCNT(4,50)
        SAVE   /TDGDCO/
C
        TDGDVA=0.
C
        DO 101 ICNT=1,NCNT
          TEMP=-50.*(((XPOS-CCNT(1,ICNT))/XRNG)**2+
     +               ((YPOS-CCNT(2,ICNT))/YRNG)**2+
     +               ((ZPOS-CCNT(3,ICNT))/YRNG)**2)
          IF (TEMP.GE.-20.) TDGDVA=TDGDVA+CCNT(4,ICNT)*EXP(TEMP)
  101   CONTINUE
C
C Done.
C
        RETURN
C
      END


      FUNCTION FRAN ()
C
C Pseudo-random-number generator.
C
        DOUBLE PRECISION X
        SAVE X
C
        DATA X / 2.718281828459045D0 /
C
        X=MOD(9821.D0*X+.211327D0,1.D0)
        FRAN=REAL(X)
C
        RETURN
C
      END


      SUBROUTINE CTSCAE (ICRA,ICA1,ICAM,ICAN,XCPF,YCPF,XCQF,YCQF,
     +                                       IND1,IND2,ICAF,IAID)
        DIMENSION ICRA(ICA1,*)
C
C This routine is called by CTCICA when the internal parameter 'CAF' is
C given a negative value.  Each call is intended to create a particular
C element in the user's cell array.  The arguments are as follows:
C
C ICRA is the user's cell array.
C
C ICA1 is the first dimension of the FORTRAN array ICRA.
C
C ICAM and ICAN are the first and second dimensions of the cell array
C stored in ICRA.
C
C (XCPF,YCPF) is the point at that corner of the rectangular area
C into which the cell array maps that corresponds to the cell (1,1).
C The coordinates are given in the fractional coordinate system (unlike
C what is required in a call to GCA, in which the coordinates of the
C point P are in the world coordinate system).
C
C (XCQF,YCQF) is the point at that corner of the rectangular area into
C which the cell array maps that corresponds to the cell (ICAM,ICAN).
C The coordinates are given in the fractional coordinate system (unlike
C what is required in a call to GCA, in which the coordinates of the
C point Q are in the world coordinate system).
C
C IND1 is the 1st index of the cell that is to be updated.
C
C IND2 is the 2nd index of the cell that is to be updated.
C
C ICAF is the current value of the internal parameter 'CAF'.  This
C value will always be an integer which is less than zero (because
C when 'CAF' is zero or greater, this routine is not called).
C
C IAID is the area identifier associated with the cell.  It will have
C been given one of the values from the internal parameter array 'AIA'
C (the one for 'PAI' = -2 if the cell lies in an out-of-range area, the
C one for 'PAI' = -1 if the cell lies off the data grid, or the one for
C some value of 'PAI' between 1 and 'NCL' if the cell lies on the data
C grid).  The value zero may occur if the cell falls in an out-of-range
C area and the value of 'AIA' for 'PAI' = -2 is 0 or if the cell lies
C off the data grid and the value of 'AIA' for 'PAI' = -1 is 0, or if
C the cell falls on the data grid, but no contour level below the cell
C has a non-zero 'AIA' and no contour level above the cell has a
C non-zero 'AIB'.  Note that, if the values of 'AIA' for 'PAI' = -1
C and -2 are given non-zero values, IAID can only be given a zero
C value in one way.
C
C The default behavior of CTSCAE is as follows:  If the area identifier
C is non-negative, it is treated as a color index, to be stored in the
C appropriate cell in the cell array; but if the area identifier is
C negative, a zero is stored for the color index.  The user may supply
C a version of CTSCAE that does something different; it may simply map
C the area identifiers into color indices or it may somehow modify the
C existing cell array element to incorporate the information provided
C by the area identifier.
C
C       ICRA(IND1,IND2)=MAX(0,IAID)
C
C What follows is not the default behavior; instead, it is the behavior
C expected by many of the example programs for CONPACKT.
C
        CALL CTGETI ('NCL - NUMBER OF CONTOUR LEVELS',NOCL)
C
        IF (IAID.GE.1.AND.IAID.LE.NOCL+1) THEN
          ICRA(IND1,IND2)=151+INT(((REAL(IAID)-.5)/REAL(NOCL+1))*100.)
        ELSE IF (IAID.EQ.1001) THEN
          ICRA(IND1,IND2)=2
        ELSE IF (IAID.EQ.1002) THEN
          ICRA(IND1,IND2)=3
        END IF
C
        RETURN
C
      END

C
C	$Id: fort_ictrans.f,v 1.6 2008-07-27 03:18:45 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
C
C	subroutine GOPNIC
C
C	Flag GKS I/O module (wks.c) to direct output to a memory file and to 
C	call ictrans when workstation is closed
C 
C on entry
C	STATUS		: 1 => GKS output sent to ictrans, 
C			  0 => normal operation
      SUBROUTINE GOPNIC(STATUS)
        INTEGER STATUS

        CALL INITIC

        STATUS = 1

        RETURN
      END

C
C	subroutine	GIARGS
C
C	Provide an argument list to be passed to ictrans when invoked by
C	'close workstation' (GCLWK)
C
C on entry
C	UNIT		: workstation connection identifier
C	ARGS		: ictrans argument string
C on exit
C	STATUS		: == -1 => failure, else ok
C

      SUBROUTINE GIARGS(UNIT, ARGS, STATUS)
        INTEGER UNIT, STATUS
        CHARACTER*(*) ARGS


        CHARACTER*200 NARGS

        I = LEN(ARGS) + 1

        IF (I .GT. 200) THEN
          STATUS = -1
          RETURN
        END IF

        NARGS = ARGS
        NARGS(I:I) = CHAR(0)

        CALL ICTARG(UNIT, NARGS, STATUS)

        RETURN
      END

      SUBROUTINE PASSF(NAC,IDO,IP,L1,IDL1,CC,C1,C2,CH,CH2,WA)
      DOUBLE PRECISION CC
      DOUBLE PRECISION C1
      DOUBLE PRECISION C2
      DOUBLE PRECISION CH
      DOUBLE PRECISION CH2
      DOUBLE PRECISION WA
      DOUBLE PRECISION WAR
      DOUBLE PRECISION WAI
      DIMENSION CH(IDO,L1,IP),CC(IDO,IP,L1),C1(IDO,L1,IP),WA(*),
     +          C2(IDL1,IP),CH2(IDL1,IP)

      IDOT = IDO/2
      NT = IP*IDL1
      IPP2 = IP + 2
      IPPH = (IP+1)/2
      IDP = IP*IDO
C
      IF (IDO.LT.L1) GO TO 106
      DO 103 J = 2,IPPH
          JC = IPP2 - J
          DO 102 K = 1,L1
              DO 101 I = 1,IDO
                  CH(I,K,J) = CC(I,J,K) + CC(I,JC,K)
                  CH(I,K,JC) = CC(I,J,K) - CC(I,JC,K)
  101         CONTINUE
  102     CONTINUE
  103 CONTINUE
      DO 105 K = 1,L1
          DO 104 I = 1,IDO
              CH(I,K,1) = CC(I,1,K)
  104     CONTINUE
  105 CONTINUE
      GO TO 112
  106 DO 109 J = 2,IPPH
          JC = IPP2 - J
          DO 108 I = 1,IDO
              DO 107 K = 1,L1
                  CH(I,K,J) = CC(I,J,K) + CC(I,JC,K)
                  CH(I,K,JC) = CC(I,J,K) - CC(I,JC,K)
  107         CONTINUE
  108     CONTINUE
  109 CONTINUE
      DO 111 I = 1,IDO
          DO 110 K = 1,L1
              CH(I,K,1) = CC(I,1,K)
  110     CONTINUE
  111 CONTINUE
  112 IDL = 2 - IDO
      INC = 0
      DO 116 L = 2,IPPH
          LC = IPP2 - L
          IDL = IDL + IDO
          DO 113 IK = 1,IDL1
              C2(IK,L) = CH2(IK,1) + WA(IDL-1)*CH2(IK,2)
              C2(IK,LC) = -WA(IDL)*CH2(IK,IP)
  113     CONTINUE
          IDLJ = IDL
          INC = INC + IDO
          DO 115 J = 3,IPPH
              JC = IPP2 - J
              IDLJ = IDLJ + INC
              IF (IDLJ.GT.IDP) IDLJ = IDLJ - IDP
              WAR = WA(IDLJ-1)
              WAI = WA(IDLJ)
              DO 114 IK = 1,IDL1
                  C2(IK,L) = C2(IK,L) + WAR*CH2(IK,J)
                  C2(IK,LC) = C2(IK,LC) - WAI*CH2(IK,JC)
  114         CONTINUE
  115     CONTINUE
  116 CONTINUE
      DO 118 J = 2,IPPH
          DO 117 IK = 1,IDL1
              CH2(IK,1) = CH2(IK,1) + CH2(IK,J)
  117     CONTINUE
  118 CONTINUE
      DO 120 J = 2,IPPH
          JC = IPP2 - J
          DO 119 IK = 2,IDL1,2
              CH2(IK-1,J) = C2(IK-1,J) - C2(IK,JC)
              CH2(IK-1,JC) = C2(IK-1,J) + C2(IK,JC)
              CH2(IK,J) = C2(IK,J) + C2(IK-1,JC)
              CH2(IK,JC) = C2(IK,J) - C2(IK-1,JC)
  119     CONTINUE
  120 CONTINUE
      NAC = 1
      IF (IDO.EQ.2) RETURN
      NAC = 0
      DO 121 IK = 1,IDL1
          C2(IK,1) = CH2(IK,1)
  121 CONTINUE
      DO 123 J = 2,IP
          DO 122 K = 1,L1
              C1(1,K,J) = CH(1,K,J)
              C1(2,K,J) = CH(2,K,J)
  122     CONTINUE
  123 CONTINUE
      IF (IDOT.GT.L1) GO TO 127
      IDIJ = 0
      DO 126 J = 2,IP
          IDIJ = IDIJ + 2
          DO 125 I = 4,IDO,2
              IDIJ = IDIJ + 2
              DO 124 K = 1,L1
                  C1(I-1,K,J) = WA(IDIJ-1)*CH(I-1,K,J) +
     +                          WA(IDIJ)*CH(I,K,J)
                  C1(I,K,J) = WA(IDIJ-1)*CH(I,K,J) -
     +                        WA(IDIJ)*CH(I-1,K,J)
  124         CONTINUE
  125     CONTINUE
  126 CONTINUE
      RETURN
  127 IDJ = 2 - IDO
      DO 130 J = 2,IP
          IDJ = IDJ + IDO
          DO 129 K = 1,L1
              IDIJ = IDJ
              DO 128 I = 4,IDO,2
                  IDIJ = IDIJ + 2
                  C1(I-1,K,J) = WA(IDIJ-1)*CH(I-1,K,J) +
     +                          WA(IDIJ)*CH(I,K,J)
                  C1(I,K,J) = WA(IDIJ-1)*CH(I,K,J) -
     +                        WA(IDIJ)*CH(I-1,K,J)
  128         CONTINUE
  129     CONTINUE
  130 CONTINUE
      RETURN
      END

c--------------------------------------------------------
C NCLFORTSTART
      SUBROUTINE DCOMPUTEPV(PV,U,V,THETA,PRS,MSFU,MSFV,MSFT,COR,DX,DY,
     +                      NX,NY,NZ,NXP1,NYP1)

      IMPLICIT NONE
      INTEGER NX,NY,NZ,NXP1,NYP1
      DOUBLE PRECISION U(NXP1,NY,NZ),V(NX,NYP1,NZ),PRS(NX,NY,NZ)
      DOUBLE PRECISION THETA(NX,NY,NZ),PV(NX,NY,NZ)
      DOUBLE PRECISION MSFU(NXP1,NY),MSFV(NX,NYP1),MSFT(NX,NY)
      DOUBLE PRECISION COR(NX,NY)
      DOUBLE PRECISION DX,DY
C NCLEND
      INTEGER KP1,KM1,JP1,JM1,IP1,IM1,I,J,K
      DOUBLE PRECISION DSY,DSX,DP,DUDY,DVDX,DUDP,DVDP,DTHDP,AVORT
      DOUBLE PRECISION DTHDX,DTHDY,MM

c          print*,'nx,ny,nz,nxp1,nyp1'
c          print*,nx,ny,nz,nxp1,nyp1
      DO K = 1,NZ
          KP1 = MIN(K+1,NZ)
          KM1 = MAX(K-1,1)
          DO J = 1,NY
              JP1 = MIN(J+1,NY)
              JM1 = MAX(J-1,1)
              DO I = 1,NX
                  IP1 = MIN(I+1,NX)
                  IM1 = MAX(I-1,1)
c         print *,jp1,jm1,ip1,im1
                  DSX = (IP1-IM1)*DX
                  DSY = (JP1-JM1)*DY
                  MM = MSFT(I,J)*MSFT(I,J)
c         print *,j,i,u(i,jp1,k),msfu(i,jp1),u(i,jp1,k)/msfu(i,jp1)
                  DUDY = 0.5D0* (U(I,JP1,K)/MSFU(I,JP1)+
     +                   U(I+1,JP1,K)/MSFU(I+1,JP1)-
     +                   U(I,JM1,K)/MSFU(I,JM1)-
     +                   U(I+1,JM1,K)/MSFU(I+1,JM1))/DSY*MM
                  DVDX = 0.5D0* (V(IP1,J,K)/MSFV(IP1,J)+
     +                   V(IP1,J+1,K)/MSFV(IP1,J+1)-
     +                   V(IM1,J,K)/MSFV(IM1,J)-
     +                   V(IM1,J+1,K)/MSFV(IM1,J+1))/DSX*MM
                  AVORT = DVDX - DUDY + COR(I,J)
                  DP = PRS(I,J,KP1) - PRS(I,J,KM1)
                  DUDP = 0.5D0* (U(I,J,KP1)+U(I+1,J,KP1)-U(I,J,KM1)-
     +                   U(I+1,J,KM1))/DP
                  DVDP = 0.5D0* (V(I,J,KP1)+V(I,J+1,KP1)-V(I,J,KM1)-
     +                   V(I,J+1,KM1))/DP
                  DTHDP = (THETA(I,J,KP1)-THETA(I,J,KM1))/DP
                  DTHDX = (THETA(IP1,J,K)-THETA(IM1,J,K))/DSX*MSFT(I,J)
                  DTHDY = (THETA(I,JP1,K)-THETA(I,JM1,K))/DSY*MSFT(I,J)
                  PV(I,J,K) = -9.81D0* (DTHDP*AVORT-DVDP*DTHDX+
     +                        DUDP*DTHDY)*10000.D0
c               if(i.eq.300 .and. j.eq.300) then
c                 print*,'avort,dudp,dvdp,dthdp,dthdx,dthdy,pv'
c                 print*,avort,dudp,dvdp,dthdp,dthdx,dthdy,pv(i,j,k)
c               endif
                  PV(I,J,K) = PV(I,J,K)*1.D2
              END DO
          END DO
      END DO
      RETURN
      END

c--------------------------------------------------------
C NCLFORTSTART
      SUBROUTINE DCOMPUTEABSVORT(AV,U,V,MSFU,MSFV,MSFT,COR,DX,DY,NX,NY,
     +                           NZ,NXP1,NYP1)

      IMPLICIT NONE
      INTEGER NX,NY,NZ,NXP1,NYP1
      DOUBLE PRECISION U(NXP1,NY,NZ),V(NX,NYP1,NZ)
      DOUBLE PRECISION AV(NX,NY,NZ)
      DOUBLE PRECISION MSFU(NXP1,NY),MSFV(NX,NYP1),MSFT(NX,NY)
      DOUBLE PRECISION COR(NX,NY)
      DOUBLE PRECISION DX,DY
C NCLEND
      INTEGER KP1,KM1,JP1,JM1,IP1,IM1,I,J,K
      DOUBLE PRECISION DSY,DSX,DP,DUDY,DVDX,DUDP,DVDP,DTHDP,AVORT
      DOUBLE PRECISION DTHDX,DTHDY,MM

c          print*,'nx,ny,nz,nxp1,nyp1'
c          print*,nx,ny,nz,nxp1,nyp1
      DO K = 1,NZ
          DO J = 1,NY
              JP1 = MIN(J+1,NY)
              JM1 = MAX(J-1,1)
              DO I = 1,NX
                  IP1 = MIN(I+1,NX)
                  IM1 = MAX(I-1,1)
c         print *,jp1,jm1,ip1,im1
                  DSX = (IP1-IM1)*DX
                  DSY = (JP1-JM1)*DY
                  MM = MSFT(I,J)*MSFT(I,J)
c         print *,j,i,u(i,jp1,k),msfu(i,jp1),u(i,jp1,k)/msfu(i,jp1)
                  DUDY = 0.5D0* (U(I,JP1,K)/MSFU(I,JP1)+
     +                   U(I+1,JP1,K)/MSFU(I+1,JP1)-
     +                   U(I,JM1,K)/MSFU(I,JM1)-
     +                   U(I+1,JM1,K)/MSFU(I+1,JM1))/DSY*MM
                  DVDX = 0.5D0* (V(IP1,J,K)/MSFV(IP1,J)+
     +                   V(IP1,J+1,K)/MSFV(IP1,J+1)-
     +                   V(IM1,J,K)/MSFV(IM1,J)-
     +                   V(IM1,J+1,K)/MSFV(IM1,J+1))/DSX*MM
                  AVORT = DVDX - DUDY + COR(I,J)
                  AV(I,J,K) = AVORT*1.D5
              END DO
          END DO
      END DO
      RETURN
      END

C
C	$Id: mskrv2.f,v 1.5 2008-07-27 00:17:30 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MSKRV2 (T,XS,YS,N,X,Y,XP,YP,S,SIGMA,ICS,SLP)
C
      DIMENSION X(N),Y(N),XP(N),YP(N),S(N)
C
C ---------------------------------------------------------------------
C Note:  This routine comes from a proprietary package called FITPACK.
C It is used in the NCAR graphics package by permission of the author,
C Alan Cline.
C ---------------------------------------------------------------------
C
C                                            CODED BY ALAN KAYLOR CLINE
C                                         FROM FITPACK -- JUNE 22, 1986
C                                   A CURVE AND SURFACE FITTING PACKAGE
C                                 A PRODUCT OF PLEASANT VALLEY SOFTWARE
C                             8603 ALTUS COVE, AUSTIN, TEXAS 78759, USA
C
C ---------------------------------------------------------------------
C
C THIS SUBROUTINE PERFORMS THE MAPPING OF POINTS IN THE
C INTERVAL (0.,1.) ONTO A CURVE IN THE PLANE. THE SUBROUTINE
C MSKRV1 SHOULD BE CALLED EARLIER TO DETERMINE CERTAIN
C NECESSARY PARAMETERS. THE RESULTING CURVE HAS A PARAMETRIC
C REPRESENTATION BOTH OF WHOSE COMPONENTS ARE SPLINES UNDER
C TENSION AND FUNCTIONS OF THE POLYGONAL ARCLENGTH
C PARAMETER.
C
C ON INPUT--
C
C   T CONTAINS A REAL VALUE TO BE MAPPED TO A POINT ON THE
C   CURVE. THE INTERVAL (0.,1.) IS MAPPED ONTO THE ENTIRE
C   CURVE, WITH 0. MAPPING TO (X(1),Y(1)) AND 1. MAPPING
C   TO (X(N),Y(N)). VALUES OUTSIDE THIS INTERVAL RESULT IN
C   EXTRAPOLATION.
C
C   N CONTAINS THE NUMBER OF POINTS WHICH WERE SPECIFIED
C   TO DETERMINE THE CURVE.
C
C   X AND Y ARE ARRAYS CONTAINING THE X- AND Y-COORDINATES
C   OF THE SPECIFIED POINTS.
C
C   XP AND YP ARE THE ARRAYS OUTPUT FROM MSKRV1 CONTAINING
C   CURVATURE INFORMATION.
C
C   S IS AN ARRAY CONTAINING THE POLYGONAL ARCLENGTHS OF
C   THE CURVE.
C
C   SIGMA CONTAINS THE TENSION FACTOR (ITS SIGN IS IGNORED).
C
C   ICS IS A FLAG, NON-ZERO IF THE ANGLE OF THE SLOPE IS TO
C   BE COMPUTED AND RETURNED AS WELL.
C
C THE PARAMETERS N, X, Y, XP, YP, S, AND SIGMA SHOULD BE
C INPUT UNALTERED FROM THE OUTPUT OF MSKRV1.
C
C ON OUTPUT--
C
C   XS AND YS CONTAIN THE X- AND Y-COORDINATES OF THE IMAGE
C   POINT ON THE CURVE.
C
C   IF ICS IS NON-ZERO, SLP CONTAINS THE ANGLE (IN DEGREES)
C   OF THE SLOPE AT THE POINT.
C
C NONE OF THE INPUT PARAMETERS ARE ALTERED.
C
C THIS SUBROUTINE REFERENCES PACKAGE MODULES MSINTR AND
C MSSHCH.
C
C-----------------------------------------------------------
C
C THE INDEX I IS SAVED FROM CALL TO CALL FOR THE SAKE OF
C EFFICIENCY
C
      SAVE I
      DATA I /1/
C
C DETERMINE INTERVAL
C
      TN = S(N)*T
C
      IF (I .GE. N) I = N/2
C
      IF (TN .LT. S(I)) THEN
        IF (TN .LE. S(2)) THEN
          I = 1
          GO TO 2
        ELSE
          IL = 2
          IH = I
        END IF
      ELSE IF (TN .LE. S(I+1)) THEN
        GO TO 2
      ELSE IF (TN .GE. S(N-1)) THEN
        I = N-1
        GO TO 2
      ELSE
        IL = I+1
        IH = N-1
      END IF
C
    1 I = (IL+IH)/2
      IF (TN .LT. S(I)) THEN
        IH = I
      ELSE IF (TN .GT. S(I+1)) THEN
        IL = I+1
      ELSE
        GO TO 2
      END IF
      GO TO 1
C
    2 IP1 = I+1
C
C DENORMALIZE TENSION FACTOR
C
      SIGMAP = ABS(SIGMA)*REAL(N-1)/S(N)
C
C SET UP AND PERFORM INTERPOLATION
C
      DEL1 = TN-S(I)
      DEL2 = S(IP1)-TN
      DELS = S(IP1)-S(I)
      SUMX = (X(IP1)*DEL1+X(I)*DEL2)/DELS
      SUMY = (Y(IP1)*DEL1+Y(I)*DEL2)/DELS
      IF (SIGMAP .EQ. 0.) THEN
        D = DEL1*DEL2/(6.*DELS)
        C1 = (DEL1+DELS)*D
        C2 = (DEL2+DELS)*D
        XS = SUMX-XP(IP1)*C1-XP(I)*C2
        YS = SUMY-YP(IP1)*C1-YP(I)*C2
        IF (ICS.NE.0) THEN
          DD = (DEL2-DEL1)/(6.*DELS)
          DC1 = (DEL1+DELS)*DD+D
          DC2 = (DEL2+DELS)*DD-D
          XT = (X(IP1)-X(I))/DELS-XP(IP1)*DC1-XP(I)*DC2
          YT = (Y(IP1)-Y(I))/DELS-YP(IP1)*DC1-YP(I)*DC2
          SLP = 57.2957795130823*ATAN2(YT,XT)
        END IF
      ELSE
        SIGDEL = SIGMAP*DELS
        CALL MSSHCH(SS,DUMMY,SIGDEL,-1)
        CALL MSSHCH(S1,DUMMY,SIGMAP*DEL1,-1)
        CALL MSSHCH(S2,DUMMY,SIGMAP*DEL2,-1)
        D = SIGDEL*SIGMAP*(1.+SS)
        C1 = DEL1*(S1-SS)/D
        C2 = DEL2*(S2-SS)/D
        XS = SUMX+XP(IP1)*C1+XP(I)*C2
        YS = SUMY+YP(IP1)*C1+YP(I)*C2
        IF (ICS.NE.0) THEN
          CALL MSSHCH (DUMMY,HC1,SIGMAP*DEL1,1)
          CALL MSSHCH (DUMMY,HC2,SIGMAP*DEL2,1)
          DC1 = (HC1-SS)/D
          DC2 = (SS-HC2)/D
          XT = (X(IP1)-X(I))/DELS+XP(IP1)*DC1+XP(I)*DC2
          YT = (Y(IP1)-Y(I))/DELS+YP(IP1)*DC1+YP(I)*DC2
          SLP = 57.2957795130823*ATAN2(YT,XT)
        END IF
      END IF
      RETURN
      END

      PROGRAM CMPTIT
C
C The program EXMPL5 produces a single frame with maximal-area
C views of all the EZMAP projections of the globe.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Define area map array and size for area fill applications
C
      PARAMETER (LMAP=250000, MCS=10000, NIDS=2)
      INTEGER MAP(LMAP), IAREA(NIDS), IGRP(NIDS)
      REAL XCS(MCS), YCS(MCS)
C
C Declare masking and area shading routines external
C
      EXTERNAL MASK
      EXTERNAL SHADE1
      EXTERNAL SHADE2
      EXTERNAL CFILL
C
C Open GKS.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Turn off the clipping indicator.
C
      CALL GSCLIP (0)
C
C Set up color table and dash pattern
C 
      CALL COLOR(IWKID)
      CALL DASHDB(65535)
C
C Set the outline-dataset parameter.
C
      CALL MAPSTC ('OU - OUTLINE DATASET SELECTOR','CO')
      CALL MAPSTI ('LA - LABEL FLAG',0)
C
C Put meridians and parallels every 15 degrees.
C
      CALL MAPSTI ('GR - GRID SPACING',15)
C
C Don't draw labels
C
      CALL MAPSTI ('LA - LABEL FLAG',0)
C
C Do draw elliptical perimeter
C
      CALL MAPSTI ('EL - ELLIPTICAL-PERIMETER SELECTOR',1)
C
C Lambert conformal conic.
C
      CALL MAPPOS (.025,.24375,.63125,.85)
      CALL MAPROJ ('LC',30.,0.,45.)
      CALL MAPINT
C
C Yellow Grid
C
      CALL GSPLCI (13)
      CALL MAPGRD
      CALL MAPLBL
C
C Green Contenental Outline
C
      CALL GSPLCI (6)
      CALL MAPLOT
C
C Stereographic.
C
      CALL MAPPOS (.26875,.4875,.63125,.85)
      CALL MAPROJ ('ST',0.,0.,0.)
C
C Aqua
C
      CALL MAPINT
      CALL GSPLCI (8)
      CALL MAPGRD
      CALL MAPLBL
C
C Chartreuse
C
      CALL GSPLCI (2)
      CALL MAPLOT
C
C Orthographic.
C
      CALL MAPPOS (.5125,.73125,.63125,.85)
      CALL MAPROJ ('OR',0.,0.,0.)
C
C Orchid
C
      CALL MAPINT
      CALL GSPLCI (15)
      CALL MAPGRD
      CALL MAPLBL
C
C SlateBlue
C
      CALL GSPLCI (8)
      CALL MAPLOT
C
C Lambert equal-area.
C
      CALL MAPPOS (.75625,.975,.63125,.85)
      CALL MAPROJ ('LE',0.,0.,0.)
C
C Red
C
      CALL MAPINT
      CALL GSPLCI (3)
      CALL MAPGRD
      CALL MAPLBL
C
C Yellow
C
      CALL GSPLCI (6)
      CALL MAPLOT
C
C Gnomonic.
C
C Draw lat/lon lines only over the oceans
C
      CALL GSPLCI (1)
      CALL MAPPOS (.025,.24375,.3875,.60625)
      CALL MAPROJ ('GN',0.,0.,0.)
      CALL ARINAM (MAP, LMAP)
      CALL MAPINT
      CALL MAPBLA (MAP)
      CALL MAPGRM (MAP, XCS, YCS, MCS, IAREA, IGRP, NIDS, MASK)
      CALL MAPLBL
      CALL MAPLOT
C
C Azimuthal equidistant.
C
      CALL ARINAM (MAP, LMAP)
      CALL MAPPOS (.26875,.4875,.3875,.60625)
      CALL MAPROJ ('AE',0.,0.,0.)
      CALL MAPINT
      CALL MAPBLA (MAP)
      CALL MAPGRM (MAP, XCS, YCS, MCS, IAREA, IGRP, NIDS, MASK)
      CALL GSPLCI (2)
      CALL MAPLBL
      CALL MAPLOT 
C
C Satellite-view.
C
C Do this plot in white with Softfill over the water and no lat/lon
C lines
C
      CALL ARINAM (MAP, LMAP)
      CALL GSPLCI (1)
      CALL MAPPOS (.5125,.73125,.3875,.60625)
      CALL MAPROJ ('SV',0.,0.,0.)
      CALL MAPSTR ('SA - SATELLITE DISTANCE',2.)
      CALL MAPSTC ('OU - OUTLINE DATASET SELECTOR','PO')
      CALL MAPINT
      CALL MAPBLA (MAP)
      CALL ARSCAM (MAP, XCS, YCS, MCS, IAREA, IGRP, NIDS, SHADE1)
      CALL MAPLBL
      CALL MAPLOT
C
C Mercator.
C
      CALL ARINAM (MAP, LMAP)
      CALL GSPLCI (1)
      CALL MAPPOS (.75625,.975,.3875,.60625)
      CALL MAPROJ ('ME',0.,0.,0.)
      CALL MAPINT
      CALL MAPBLA (MAP)
      CALL ARSCAM (MAP, XCS, YCS, MCS, IAREA, IGRP, NIDS, SHADE2)
      CALL MAPLBL
      CALL MAPLOT
C
C Cylindrical equidistant.
C
      CALL ARINAM (MAP, LMAP)
      CALL GSPLCI (1)
      CALL MAPPOS (.025,.4875,.13125,.3625)
      CALL MAPROJ ('CE',0.,0.,0.)
      CALL MAPINT
      CALL MAPBLA (MAP)
      CALL ARSCAM (MAP, XCS, YCS, MCS, IAREA, IGRP, NIDS, CFILL)
      CALL MAPLBL
      CALL MAPLOT
C
C Mollweide type.
C
      CALL ARINAM (MAP, LMAP)
      CALL GSPLCI (1)
      CALL MAPPOS (.5125,.975,.13125,.3625)
      CALL MAPROJ ('MO',0.,0.,0.)
      CALL MAPINT
      CALL MAPBLA (MAP)
      CALL ARSCAM (MAP, XCS, YCS, MCS, IAREA, IGRP, NIDS, CFILL)
      CALL MAPLBL
      CALL MAPLOT
C
C and the labels under each sub-plot.
C
      CALL GSLWSC(2.)
      CALL SET (0.,1.,0.,1.,0.,1.,0.,1.,1)
      CALL PLCHHQ (.134375,.61875,'LAMBERT CONFORMAL CONIC',
     +      .0085,0.,0.)
      CALL PLCHHQ (.378125,.61875,'STEREOGRAPHIC',
     +      .0085,0.,0.)
      CALL PLCHHQ (.621875,.61875,'ORTHOGRAPHIC',
     +      .0085,0.,0.)
      CALL PLCHHQ (.865625,.61875,'LAMBERT EQUAL-AREA',
     +      .0085,0.,0.)
      CALL PLCHHQ (.134375,.375,'GNOMONIC',
     +      .0085,0.,0.)
      CALL PLCHHQ (.378125,.375,'AZIMUTHAL EQUIDISTANT',
     +      .0085,0.,0.)
      CALL PLCHHQ (.621875,.375,'SATELLITE-VIEW',
     +      .0085,0.,0.)
      CALL PLCHHQ (.865625,.375,'MERCATOR',
     +      .0085,0.,0.)
      CALL PLCHHQ (.25625,.11875,'CYLINDRICAL EQUIDISTANT',
     +      .0085,0.,0.)
      CALL PLCHHQ (.74375,.11875,'MOLLWEIDE TYPE',
     +      .0085,0.,0.)
C
C Draw a boundary around the edge of the plotter frame.
C
C      CALL BNDARY
C
C Advance the frame.
C
      CALL FRAME
C
C Close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
C Done.
C
      STOP
C
      END
      SUBROUTINE MASK(XC,YC,MCS,AREAID,GRPID,IDSIZE)

      INTEGER AREAID(IDSIZE),GRPID(IDSIZE),ID
      REAL XC(MCS),YC(MCS)
C
C Retrieve area id for geographical area
C
      DO 10, I=1,IDSIZE
         IF (GRPID(I).EQ.1) ID=AREAID(I)
 10   CONTINUE
C
C If the line is over water, and has 2 or more points draw it.
C
      IF ((MAPACI(ID).EQ.1).AND.(MCS.GE.2)) THEN
         CALL CURVED(XC,YC,MCS)
      ENDIF
C
C Otherwise, don't draw the line - mask it.
C
      RETURN
      END

      SUBROUTINE SHADE1 (XC, YC, NPTS, AREAID, GRPID, IDSIZE)
C
C Fill area map
C
      INTEGER IDSIZE, NPTS
      INTEGER AREAID(IDSIZE),GRPID(IDSIZE),IWRK(5000)
      REAL XC(NPTS), YC(NPTS), RWRK(5000)

      IAID = 0
      DO 10 I=1,IDSIZE
         IF (GRPID(I) .EQ. 1) IAID = AREAID(I)
 10   CONTINUE
C
C Fill Areas over land using softfill
C
C Areas over water have area color indices of 1 so we use that to 
C distinguish them.
C
      IF ((IAID .GT. 0) .AND. (MAPACI(IAID) .EQ. 1)) THEN
         CALL SFSETR('SP',.005)
         CALL SFSETR('ANGLE', 45.)
         CALL SFWRLD(XC, YC, NPTS-1, RWRK, 5000, IWRK, 5000)
      ENDIF

      RETURN
      END

      SUBROUTINE SHADE2 (XC, YC, NPTS, AREAID, GRPID, IDSIZE)
C
C Fill area map
C
      INTEGER IDSIZE, NPTS
      INTEGER AREAID(IDSIZE),GRPID(IDSIZE),IWRK(10000)
      REAL XC(NPTS), YC(NPTS), RWRK(10000)
      
      CALL GSFAIS (1)
      IAID = 0
      DO 10 I=1,IDSIZE
         IF (GRPID(I) .EQ. 1) IAID = AREAID(I)
 10   CONTINUE
C
C Fill Areas over land using softfill
C
C Areas over water have area color indices of 1 so we use that to 
C distinguish them.
C
      IF (IAID .GT. 0) THEN
         IF (MAPACI(IAID) .EQ. 1) THEN
            CALL SFSETR('SP',.005)
            CALL SFSETR('ANGLE', 45.)
            CALL SFWRLD(XC, YC, NPTS-1, RWRK, 10000, IWRK, 10000)
         ELSE 
            CALL GSFACI (MAPACI(IAID))
            CALL GFA (NPTS, XC, YC)
         ENDIF
      ENDIF

      RETURN
      END

      SUBROUTINE CFILL (XC, YC, NPTS, AREAID, GRPID, IDSIZE)
C
C Fill area map
C
      INTEGER IDSIZE, NPTS
      INTEGER AREAID(IDSIZE), GRPID(IDSIZE), ICOL
      REAL XC(NPTS), YC(NPTS)
      
      ICOL = 0
      DO 10, I=1,IDSIZE
         IF (GRPID(I).EQ.1) IAREA=AREAID(I)
 10   CONTINUE
      
      IF (IAREA .GE. 1) THEN
         ICOL = MAPACI(IAREA)
         IF (ICOL .eq. 1) THEN
C
C Color the ocean blue.
C
            CALL GSFACI(2)
            CALL GFA(NPTS-1, XC, YC)
         ELSE 
C
C If the area is over land, fill it using the country color id.
C
            CALL GSFACI(ICOL+2)
            CALL GFA(NPTS-1, XC, YC)
         ENDIF
      ENDIF
      
      RETURN
      END

      SUBROUTINE COLOR(IWKID)
C
C Background color
C Black
C
      CALL GSCR(IWKID,0,0.,0.,0.)
C
C Foreground colors
C White
C
      CALL GSCR(IWKID,  1, 1.0, 1.0, 1.0)
C
C Aqua
C
      CALL GSCR(IWKID,  2, 0.0, 0.9, 1.0)
C
C Red
C
      CALL GSCR(IWKID,  3, 0.9, 0.25, 0.0)
C
C OrangeRed
C
      CALL GSCR(IWKID,  4, 1.0, 0.0, 0.2)
C
C Orange
C
      CALL GSCR(IWKID,  5, 1.0, 0.65, 0.0)
C
C Yellow
C
      CALL GSCR(IWKID,  6, 1.0, 1.0, 0.0)
C
C GreenYellow
C
      CALL GSCR(IWKID,  7, 0.7, 1.0, 0.2)
C
C Chartreuse
C
      CALL GSCR(IWKID,  8, 0.5, 1.0, 0.0)
C
C Celeste
C
      CALL GSCR(IWKID,  9, 0.2, 1.0, 0.5)
C
C Green
C
      CALL GSCR(IWKID, 10, 0.2, 0.8, 0.2)
C
C DeepSkyBlue
C
      CALL GSCR(IWKID, 11, 0.0, 0.75, 1.0)
C
C RoyalBlue
C
      CALL GSCR(IWKID, 12, 0.25, 0.45, 0.95)
C
C SlateBlue
C
      CALL GSCR(IWKID, 13, 0.4, 0.35, 0.8)
C
C DarkViolet
C
      CALL GSCR(IWKID, 14, 0.6, 0.0, 0.8)
C
C Orchid
C
      CALL GSCR(IWKID, 15, 0.85, 0.45, 0.8)
C
C Lavender
C
      CALL GSCR(IWKID, 16, 0.8, 0.8, 1.0)
C
C Gray
C
      CALL GSCR(IWKID, 17, 0.7, 0.7, 0.7)
C
C Done.
C
      RETURN
C
      END

      SUBROUTINE GENDAT (DATA,IDIM,M,N,MLOW,MHGH,DLOW,DHGH)
C
C This is a routine to generate test data for two-dimensional graphics
C routines.  Given an array "DATA", dimensioned "IDIM x 1", it fills
C the sub-array ((DATA(I,J),I=1,M),J=1,N) with a two-dimensional field
C of data having approximately "MLOW" lows and "MHGH" highs, a minimum
C value of exactly "DLOW" and a maximum value of exactly "DHGH".
C
C "MLOW" and "MHGH" are each forced to be greater than or equal to 1
C and less than or equal to 25.
C
C The function used is a sum of exponentials.
C
        DIMENSION DATA(IDIM,1),CCNT(3,50)
C
        FOVM=9./REAL(M)
        FOVN=9./REAL(N)
C
        NLOW=MAX(1,MIN(25,MLOW))
        NHGH=MAX(1,MIN(25,MHGH))
        NCNT=NLOW+NHGH
C
        DO 101 K=1,NCNT
          CCNT(1,K)=1.+(REAL(M)-1.)*FRAN()
          CCNT(2,K)=1.+(REAL(N)-1.)*FRAN()
          IF (K.LE.NLOW) THEN
            CCNT(3,K)=-1.
          ELSE
            CCNT(3,K)=+1.
          END IF
  101   CONTINUE
C
        DMIN=+1.E36
        DMAX=-1.E36
        DO 104 J=1,N
          DO 103 I=1,M
            DATA(I,J)=.5*(DLOW+DHGH)
            DO 102 K=1,NCNT
              TEMP=-((FOVM*(REAL(I)-CCNT(1,K)))**2+
     +               (FOVN*(REAL(J)-CCNT(2,K)))**2)
              IF (TEMP.GE.-20.) DATA(I,J)=DATA(I,J)+
     +            .5*(DHGH-DLOW)*CCNT(3,K)*EXP(TEMP)
  102       CONTINUE
            DMIN=MIN(DMIN,DATA(I,J))
            DMAX=MAX(DMAX,DATA(I,J))
  103     CONTINUE
  104   CONTINUE
C
        DO 106 J=1,N
          DO 105 I=1,M
            DATA(I,J)=(DATA(I,J)-DMIN)/(DMAX-DMIN)*(DHGH-DLOW)+DLOW
  105     CONTINUE
  106   CONTINUE
C
        RETURN
C
      END


      FUNCTION FRAN ()
        DIMENSION RSEQ (100)
        SAVE ISEQ
        DATA RSEQ / .749,.973,.666,.804,.081,.483,.919,.903,.951,.960 ,
     +              .039,.269,.270,.756,.222,.478,.621,.063,.550,.798 ,
     +              .027,.569,.149,.697,.451,.738,.508,.041,.266,.249 ,
     +              .019,.191,.266,.625,.492,.940,.508,.406,.972,.311 ,
     +              .757,.378,.299,.536,.619,.844,.342,.295,.447,.499 ,
     +              .688,.193,.225,.520,.954,.749,.997,.693,.217,.273 ,
     +              .961,.948,.902,.104,.495,.257,.524,.100,.492,.347 ,
     +              .981,.019,.225,.806,.678,.710,.235,.600,.994,.758 ,
     +              .682,.373,.009,.469,.203,.730,.588,.603,.213,.495 ,
     +              .884,.032,.185,.127,.010,.180,.689,.354,.372,.429 /
        DATA ISEQ / 0 /
        ISEQ=MOD(ISEQ,100)+1
        FRAN=RSEQ(ISEQ)
        RETURN
      END


      SUBROUTINE CAPSAP (LABL,IAMA,LAMA)
C
        DIMENSION IAMA(*)
C
        CHARACTER*(*) LABL
C
C Compute and print the time required to draw the contour plot and how
C much space was used in the various arrays.
C
        PRINT * , 'PLOT TITLE WAS ',LABL
        CALL CPGETI ('IWU - INTEGER WORKSPACE USAGE',IIWU)
        CALL CPGETI ('RWU - REAL WORKSPACE USAGE',IRWU)
        PRINT * , 'INTEGER WORKSPACE USED ',IIWU
        PRINT * , '   REAL WORKSPACE USED ',IRWU
        IF (LAMA.NE.0) THEN
          IAMU=LAMA-(IAMA(6)-IAMA(5)-1)
          PRINT * , '   AREA MAP SPACE USED ',IAMU
        END IF
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE LABTOP (LABL,SIZE)
C
        CHARACTER*(*) LABL
C
C Put a label just above the top of the plot.  The SET call is re-done
C to allow for the use of fractional coordinates, and the text extent
C capabilities of the package PLOTCHAR are used to determine the label
C position.
C
        CALL GETSET (XVPL,XVPR,YVPB,YVPT,XWDL,XWDR,YWDB,YWDT,LNLG)
        SZFS=SIZE*(XVPR-XVPL)
        CALL    SET (0.,1.,0.,1.,0.,1.,0.,1.,1)
        CALL PCGETI ('QU - QUALITY FLAG',IQUA)
        CALL PCSETI ('QU - QUALITY FLAG',0)
        CALL PCSETI ('TE - TEXT EXTENT COMPUTATION FLAG',1)
        CALL PLCHHQ (.5,.5,LABL,SZFS,360.,0.)
        CALL PCGETR ('DB - DISTANCE TO BOTTOM OF STRING',DBOS)
        CALL PLCHHQ (.5*(XVPL+XVPR),YVPT+SZFS+DBOS,LABL,SZFS,0.,0.)
        CALL PCSETI ('QU - QUALITY FLAG',IQUA)
        CALL    SET (XVPL,XVPR,YVPB,YVPT,XWDL,XWDR,YWDB,YWDT,LNLG)
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE BNDARY
C
C Draw a line showing where the edge of the plotter frame is.
C
        CALL PLOTIF (0.,0.,0)
        CALL PLOTIF (1.,0.,1)
        CALL PLOTIF (1.,1.,1)
        CALL PLOTIF (0.,1.,1)
        CALL PLOTIF (0.,0.,1)
        CALL PLOTIF (0.,0.,2)
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE DFCLRS(IWKID)
C
C Define a set of RGB color triples for colors 1 through 15.
C
        DIMENSION RGBV(3,15)
C
C Define the RGB color triples needed below.
C
        DATA RGBV / 1.00 , 1.00 , 1.00 ,
     +              0.70 , 0.70 , 0.70 ,
     +              0.75 , 0.50 , 1.00 ,
     +              0.50 , 0.00 , 1.00 ,
     +              0.00 , 0.00 , 1.00 ,
     +              0.00 , 0.50 , 1.00 ,
     +              0.00 , 1.00 , 1.00 ,
     +              0.00 , 1.00 , 0.60 ,
     +              0.00 , 1.00 , 0.00 ,
     +              0.70 , 1.00 , 0.00 ,
     +              1.00 , 1.00 , 0.00 ,
     +              1.00 , 0.75 , 0.00 ,
     +              1.00 , 0.38 , 0.38 ,
     +              1.00 , 0.00 , 0.38 ,
     +              1.00 , 0.00 , 0.00 /
C
C Define 16 different color indices, for indices 0 through 15.  The
C color corresponding to index 0 is black and the color corresponding
C to index 1 is white.
C
        CALL GSCR (IWKID,0,0.,0.,0.)
C
        DO 101 I=1,15
          CALL GSCR (IWKID,I,RGBV(1,I),RGBV(2,I),RGBV(3,I))
  101   CONTINUE
C
C Done.
C
        RETURN
C
      END

      SUBROUTINE SLAE2( A, B, C, RT1, RT2 )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     October 31, 1992
*
*     .. Scalar Arguments ..
      REAL               A, B, C, RT1, RT2
*     ..
*
*  Purpose
*  =======
*
*  SLAE2  computes the eigenvalues of a 2-by-2 symmetric matrix
*     [  A   B  ]
*     [  B   C  ].
*  On return, RT1 is the eigenvalue of larger absolute value, and RT2
*  is the eigenvalue of smaller absolute value.
*
*  Arguments
*  =========
*
*  A       (input) REAL
*          The (1,1) element of the 2-by-2 matrix.
*
*  B       (input) REAL
*          The (1,2) and (2,1) elements of the 2-by-2 matrix.
*
*  C       (input) REAL
*          The (2,2) element of the 2-by-2 matrix.
*
*  RT1     (output) REAL
*          The eigenvalue of larger absolute value.
*
*  RT2     (output) REAL
*          The eigenvalue of smaller absolute value.
*
*  Further Details
*  ===============
*
*  RT1 is accurate to a few ulps barring over/underflow.
*
*  RT2 may be inaccurate if there is massive cancellation in the
*  determinant A*C-B*B; higher precision or correctly rounded or
*  correctly truncated arithmetic would be needed to compute RT2
*  accurately in all cases.
*
*  Overflow is possible only if RT1 is within a factor of 5 of overflow.
*  Underflow is harmless if the input data is 0 or exceeds
*     underflow_threshold / macheps.
*
* =====================================================================
*
*     .. Parameters ..
      REAL               ONE
      PARAMETER          ( ONE = 1.0E0 )
      REAL               TWO
      PARAMETER          ( TWO = 2.0E0 )
      REAL               ZERO
      PARAMETER          ( ZERO = 0.0E0 )
      REAL               HALF
      PARAMETER          ( HALF = 0.5E0 )
*     ..
*     .. Local Scalars ..
      REAL               AB, ACMN, ACMX, ADF, DF, RT, SM, TB
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, SQRT
*     ..
*     .. Executable Statements ..
*
*     Compute the eigenvalues
*
      SM = A + C
      DF = A - C
      ADF = ABS( DF )
      TB = B + B
      AB = ABS( TB )
      IF( ABS( A ).GT.ABS( C ) ) THEN
         ACMX = A
         ACMN = C
      ELSE
         ACMX = C
         ACMN = A
      END IF
      IF( ADF.GT.AB ) THEN
         RT = ADF*SQRT( ONE+( AB / ADF )**2 )
      ELSE IF( ADF.LT.AB ) THEN
         RT = AB*SQRT( ONE+( ADF / AB )**2 )
      ELSE
*
*        Includes case AB=ADF=0
*
         RT = AB*SQRT( TWO )
      END IF
      IF( SM.LT.ZERO ) THEN
         RT1 = HALF*( SM-RT )
*
*        Order of execution important.
*        To get fully accurate smaller eigenvalue,
*        next line needs to be executed in higher precision.
*
         RT2 = ( ACMX / RT1 )*ACMN - ( B / RT1 )*B
      ELSE IF( SM.GT.ZERO ) THEN
         RT1 = HALF*( SM+RT )
*
*        Order of execution important.
*        To get fully accurate smaller eigenvalue,
*        next line needs to be executed in higher precision.
*
         RT2 = ( ACMX / RT1 )*ACMN - ( B / RT1 )*B
      ELSE
*
*        Includes case RT1 = RT2 = 0
*
         RT1 = HALF*RT
         RT2 = -HALF*RT
      END IF
      RETURN
*
*     End of SLAE2
*
      END

C NCLFORTSTART
      SUBROUTINE DPHYBRIDJRA55(HYA,HYB,PSFC,MLON,NLAT,KLEV,PHY,PMSG
     +                        ,KLEVI,PI)  

c NCL: phy = pres_hybrid_jra55 (psfc,hya,hyb)

c this routine iuses the JRA55 hybrid interface coordinate data
c     to derive pressure coordinates.

c source: http://rda.ucar.edu/datasets/ds628.0/docs/JRA-55.handbook_TL319_en.pdf
c         pgs 18-19

c     input
c          hya    - is the "a" *interface* pressure hybrid coef
c          hyb    - is the "b" *interface* sigma coeficient
c          psfc   - is the surface pressure in pascals [Pa]
c          mlon   - longitude dimension
c          nlat   - latitude  dimension
c          klev   - number of levels
c          pi     - work array containing pressure at interface levels
c          klevi  - number of interface levels (klev+1)
c     output
c          phy    - mid-layer pressures at hybrid levels [Pa]

      IMPLICIT NONE
      INTEGER MLON,NLAT,KLEV,KLEVI
      DOUBLE PRECISION HYA(KLEVI),HYB(KLEVI),PSFC(MLON,NLAT),PMSG
      DOUBLE PRECISION PHY(MLON,NLAT,KLEV), PI(MLON,NLAT,KLEVI)
C NCLEND

      DOUBLE PRECISION DP
      INTEGER KL,NL,ML

c pressure at interfaces levels
     
      DO KL = 1,KLEVI
          DO NL = 1,NLAT
              DO ML = 1,MLON
                 IF (PSFC(ML,NL).NE.PMSG) then
                     PI(ML,NL,KL) = HYA(KL) + HYB(KL)*PSFC(ML,NL)
                 ELSE
                     PI(ML,NL,KL) = PMSG
                 END IF
              END DO
          END DO
      END DO

c f90 do kl=1,klev
c f90    pi(:,:,kl) = hya(kl) + hyb(kl)*psfc(:,:)
c f90 end do
c ---
c use formula in the above pdf doc to get mid-layer pressures
c ---

      DO NL = 1,NLAT
        DO ML = 1,MLON
          DO KL = 1,KLEV
             IF (PSFC(ML,NL).NE.PMSG) THEN
                 DP = PI(ML,NL,KL)-PI(ML,NL,KL+1)
                 PHY(ML,NL,KL) = 
     +               EXP((1/DP)*(PI(ML,NL,KL  )*LOG(PI(ML,NL,KL  )) 
     +                          -PI(ML,NL,KL+1)*LOG(PI(ML,NL,KL+1)))-1)      
             ELSE
                 PHY(ML,NL,KL) = PMSG
             END IF
          END DO
        END DO
      END DO

c force 

      DO NL = 1,NLAT
        DO ML = 1,MLON
           PHY(ML,NL,KLEV) = 10d0
        END DO
      END DO

      RETURN
      END

C
C $Id: cmux.f,v 1.7 2008-07-27 00:17:23 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      FUNCTION CMUX (IX)
C
C Given an X coordinate IX in the metacode system, CMUX(IX) is an X
C coordinate in the user system.
C
      COMMON /IUTLCM/ LL,MI,MX,MY,IU(96)
      SAVE /IUTLCM/
      DIMENSION WD(4),VP(4)
      CALL GQCNTN (IE,NT)
      IF (IE.NE.0) THEN
        CALL SETER ('CMUX - ERROR EXIT FROM GQCNTN',1,1)
        CMUX=0.
        RETURN
      END IF
      CALL GQNT (NT,IE,WD,VP)
      IF (IE.NE.0) THEN
        CALL SETER ('CMUX - ERROR EXIT FROM GQNT',2,1)
        CMUX=0.
        RETURN
      END IF
      I=1
      IF (MI.GE.3) I=2
      CMUX=WD(I)+(REAL(IX)/32767.-VP(1))/(VP(2)-VP(1))*(WD(3-I)-WD(I))
      IF (LL.GE.3) CMUX=10.**CMUX
      RETURN
      END

C
C $Id: tdez1d.f,v 1.2 2008-07-27 03:40:25 haley Exp $
C                                                                      
C                Copyright (C)  2001
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE TDEZ1D(NX,X,Y,Z,IMRK,RMRK,SMRK,RMULT,THETA,PHI,IST)
C
C  This subroutine uses the NCAR Graphics functions in Tdpack
C  to draw a series of markers along a curve.  TDEZ1D is meant to be
C  a simplified interface to Tdpack for the purpose of quickly
C  drawing a plot.  
C  TDEZ1D sacrifices much of the flexibility and functionality of 
C  Tdpack in its attempt to be simple.
C
C  The data values plotted are:
C
C      Z(I) = data value at (X(I),Y(I)) for I=1,NX.
C
C   IMRK is an integer expression whose absolute value may be from 1 to
C   5, inclusive, to select markers that are tetrahedrons, octahedrons,
C   cubes, icosahedrons, or elaborated icosahedrons (effectively,
C   spheres), respectively.  If IMRK is less than zero, the marks are
C   not clipped at the faces of the box defined by the last six
C   arguments; otherwise, they are.
C
C   RMRK is a real expression whose value is the desired radius of each
C   mark.  Its value must be greater than zero.
C
C   SMRK is a real expression whose value is the desired gap between two
C   marks along the trajectory.  A negative value can be used if it is
C   desired that the marks should overlap.  However, don't try to make
C   SMRK negative and larger in absolute value than 2.*RMRK.
C
C  The point looked at is the midpoint of the surface.
C
C  The eye position is calculated from the 3D coordinate
C  (RMULT,THETA,PHI) as provided in the argument list:
C
C      RMULT  is a multiplier of the diagonal length (DL) of 
C             the smallest box containing the surface to be drawn.
C      THETA  is an angle (in degrees) in the XY plane measured
C             positive counter-clockwise from the X axis
C      PHI    is an angle (in degrees) measured from the positive Z 
C             axis toward the XY plane.  
C
C  Thus, the coordinate (RMULT*DL,THETA,PHI) is the spherical 
C  coordinate for the eye position.  If RMULT = THETA = PHI = 0., 
C  a default eye position ( 2.5,-55.,70.) is chosen.
C
C      IST    is a style index defining the colors used to shade the
C             surface as per:
C
C               1  -  wire frame
C               2  -  gray shades underneath; gray shades on top.
C               3  -  gray shades underneath; red shades on top.
C               4  -  gray shades underneath; green shades on top.
C               5  -  gray shades underneath; blue shades on top.
C               6  -  gray shades underneath; cyan shades on top.
C               7  -  gray shades underneath; magenta shades on top.
C               8  -  gray shades underneath; yellow shades on top.
C
C             If IST is positive, then black is used for the background
C             color and white for the foreground color; if IST is 
C             the negative of any of the above values, then white
C             is used for the background color and black for the
C             foreground color.
C  
C  When TDEZ1D is called, a color table is defined for all open
C  workstations that implements IST as described above.  *This 
C  color table will supersede any color table that has been 
C  previously defined.*  The color table that is defined is:
C
C      Color 
C      index   Colors
C    -------   ----------------------------------------------------
C          0   black if IST is positive; white if IST is negative
C          1   white if IST is positive; black if IST is negative
C          2   red
C          3   green
C          4   blue
C          5   cyan
C          6   magenta
C          7   yellow
C      8- 37   grayscale from white to black.
C     38- 67   shades of gray
C     68- 97   shades of red
C     98-127   shades of green
C    128-157   shades of blue
C    158-187   shades of cyan
C    188-217   shades of magenta
C    218-247   shades of yellow
C
C  TDEZ1D does not call FRAME.
C
C  If the image is too small, decrease the size of RMULT; if the
C  image is too large, increase the size of RMULT.
C
C  Example:
C
C    CALL TDEZ1D(NX,X,Y,Z,0,0.,0.,0.,0.,0.,6)
C
C    would draw a series of markers in shades of cyan with a black
C    background and with a default eye position selected.
C
C--------------------------------------------------------------------------
C
C  Set the maximum number of triangles.
C
      PARAMETER (MTRI=110000)
C
C  Specify the number of shades for each color, the starting 
C  color index for the color shades part of the color table,
C  the color index of the first gray value, and the color index
C  of the last gray value.
C
      PARAMETER (NSHD=30, ICST=8, IGS=ICST+NSHD, IGL=IGS+NSHD-1)
C
C  Dimension the input arrays.
C
      DIMENSION X(NX),Y(NX),Z(NX)
C
C  Dimension the Tdpack work arrays.
C
      DIMENSION RTRI(10,MTRI),RTWK(MTRI,2),ITWK(MTRI)
      COMMON /DSTDDT/ RTRI,RTWK,ITWK
C
C  Define the spherical coordinates for the default eye position.
C
      DATA ANG1,ANG2,RMUL / -55.,70.,2.5 /
C
C  Set the desired values of the shading parameters.  Values of SHDE
C  near 0 give brighter colors and values near 1 give pastel shades.
C  Values of SHDR near 0 give a narrow range of shades and values near
C  1 give a wide range of shades.
C
      DATA SHDE,SHDR / 0.0 , 0.8 /
C
C  Factor for converting from degrees to radians.
C
      DATA DTOR / .017453292519943 /
C
C  Determine the number of open workstations (NUMOP).
C
      CALL GQOPWK(1,IER,NUMOP,IWKID)
C
C  Loop through the open workstations and define a color table.
C
      IFC = ICST
      ILC = ICST+NSHD-1
      DO 10 I=1,NUMOP
        CALL GQOPWK(I,IER,NUMTMP,IWKID)
C
C  Set colors only for workstations of the correct category.
C
        CALL GQWKC(IWKID,IER,ICON,ITYP)
        CALL GQWKCA(ITYP,IER,ICAT)
        IF (ICAT.EQ.0 .OR. ICAT.EQ.2 .OR. ICAT.EQ.4) THEN
C          CALL TDCLRS(IWKID,1-(SIGN(1,IST)+1)/2,SHDE,SHDR,IFC,ILC,8)
          CALL TDCLRS(IWKID,1,0.1,0.8,11,42,5)
        ENDIF
   10 CONTINUE
C
C  Find data mins and maxs.
C
      XMIN = X(1)
      XMAX = X(1)
      YMIN = Y(1)
      YMAX = Y(1)
      ZMIN = Z(1)
      ZMAX = Z(1)
      DO 130 I=1,NX
        XMIN = MIN(XMIN,X(I))
        XMAX = MAX(XMAX,X(I))
        YMIN = MIN(YMIN,Y(I))
        YMAX = MAX(YMAX,Y(I))
        ZMIN = MIN(ZMIN,Z(I))
        ZMAX = MAX(ZMAX,Z(I))
  130 CONTINUE
      XRNG = XMAX-XMIN
      YRNG = YMAX-YMIN
      ZRNG = ZMAX-ZMIN
      XMID = 0.5*(XMIN+XMAX)
      YMID = 0.5*(YMIN+YMAX)
      ZMID = 0.5*(ZMIN+ZMAX)
C
C   If IMRK, RMRK, and/or SMRK are not set, then calculate default
C   values.
C
      IF(IMRK.LT.1.OR.IMRK.GT.5) IMRK = 5
      IF(RMRK.LE.0.) RMRK = MIN(XRNG,YRNG,ZRNG)/50.
      IF(SMRK.EQ.0.) SMRK = RMRK/8.
C
C   IRST specifies the rendering style index to be used for all the
C   triangles generated by a particular call to TDTTRI.
C   Note that more than one surface can be represented by the triangles
C   in the triangle list and that each surface can be rendered in its
C   own particular style.
C
      IRST = 4
C
C  Define TDPACK rendering styles 1 through 8.  The 
C  indices 1-8 can then be used as final arguments in 
C  calls to TDITRI, TDSTRI, and TDMTRI.
C
      XSL = 0.05*XRNG
      YSL = 0.05*YRNG
      ZSL = 0.00*ZRNG
      CALL TDSTRS (1,43,74, 43, 74,-1,-1,1,0.,0.,0.) ! gray/gray
      CALL TDSTRS (2,43,74, 75,106,-1,-1,1,0.,0.,0.) ! gray/red
      CALL TDSTRS (3,43,74,107,138,-1,-1,1,0.,0.,0.) ! gray/green
      CALL TDSTRS (4,43,74,139,170,-1,-1,1,0.,0.,0.) ! gray/blue
      CALL TDSTRS (5,43,74,171,202,-1,-1,1,0.,0.,0.) ! gray/cyan
      CALL TDSTRS (6,43,74,203,234,-1,-1,1,0.,0.,0.) ! gray/magenta
      CALL TDSTRS (7,43,74,235,266,-1,-1,1,0.,0.,0.) ! gray/yellow
C
C  Create the triangle list representing the markers.  If the specified
C  value for IST is out of range, set it to 6.
C
      NTRI=0
      IF (ABS(IST).GT.8 .OR. ABS(IST).LT.1) THEN
        JST = 6
      ELSE
        JST = ABS(IST)
      ENDIF
      CALL TDTTRI (X,Y,Z,NX,IMRK,RMRK,SMRK,RTRI,MTRI,NTRI,IRST,
     +             XMIN,YMIN,ZMIN,XMAX,YMAX,ZMAX)
      IF (NTRI .EQ. MTRI) THEN
        PRINT * , 'Triangle list overflow in TDTTRI'
        STOP
      END IF
C
C  Determine a default eye position if none is specified.
C
      IF (THETA.EQ.0. .AND. PHI.EQ.0. .AND. RMULT.EQ.0.) THEN
        R = RMUL*SQRT(XRNG*XRNG + YRNG*YRNG + ZRNG*ZRNG)
        XEYE = XMID+R*SIN(DTOR*ANG2)*COS(DTOR*ANG1)
        YEYE = YMID+R*SIN(DTOR*ANG2)*SIN(DTOR*ANG1)
        ZEYE = ZMID+R*COS(DTOR*ANG2)
      ELSE
C
C  Convert the user-specified eye position to Cartesian coordinates.
C
        R = RMULT*SQRT(XRNG*XRNG + YRNG*YRNG + ZRNG*ZRNG)
        XEYE = XMID+R*SIN(DTOR*PHI)*COS(DTOR*THETA)
        YEYE = YMID+R*SIN(DTOR*PHI)*SIN(DTOR*THETA)
        ZEYE = ZMID+R*COS(DTOR*PHI)
      ENDIF
C
C Initialize TDPACK.
C
      CALL TDINIT (XEYE, YEYE, ZEYE, XMID, YMID, ZMID,
     +                   XMID, YMID, ZMID+0.1*ZRNG, 0)
C
C Order the triangles.
C
      CALL TDOTRI (RTRI,MTRI,NTRI,RTWK,ITWK,1)
      IF (NTRI .EQ. MTRI) THEN
        PRINT * , 'Triangle list overflow in TDOTRI'
        STOP
      END IF
C
C  Draw the triangles.
C
      CALL TDDTRI (RTRI,MTRI,NTRI,ITWK)
C
      RETURN
      END

c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by UCAR                 .
c  .                                                             .
c  .       University Corporation for Atmospheric Research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                         SPHEREPACK                          .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c
C*PL*ERROR* Comment line too long
c ... file sshifte.f contains code and documentation for subroutine sshifte
c     and its' initialization subroutine sshifti
c
c ... required files off spherepack3.0
c
c     hrfft.f
c
C*PL*ERROR* Comment line too long
c     subroutine sshifte(ioff,nlon,nlat,goff,greg,wsav,lsav,work,lwork,ier)
c
c *** purpose
c
c     subroutine sshifte does a highly accurate 1/2 grid increment shift
C*PL*ERROR* Comment line too long
c     in both longitude and latitude of equally spaced data on the sphere.
c     data is transferred between the nlon by nlat "offset grid" in goff
C*PL*ERROR* Comment line too long
c     (which excludes poles) and the nlon by nlat+1 "regular grid" in greg
C*PL*ERROR* Comment line too long
c     (which includes poles).  the transfer can go from goff to greg or from
C*PL*ERROR* Comment line too long
c     greg to goff (see ioff).  the grids which underly goff and greg are
C*PL*ERROR* Comment line too long
c     described below.  the north and south poles are at latitude 0.5*pi and
c     -0.5*pi radians respectively where pi = 4.*atan(1.).
c
c *** grid descriptions
c
c     let dlon = (pi+pi)/nlon and dlat = pi/nlat be the uniform grid
c     increments in longitude and latitude
c
c     offset grid
c
C*PL*ERROR* Comment line too long
c     the "1/2 increment offset" grid (long(j),lat(i)) on which goff(j,i)
c     is given (ioff=0) or generated (ioff=1) is
c
c          long(j) =0.5*dlon + (j-1)*dlon  (j=1,...,nlon)
c
c     and
c
c          lat(i) = -0.5*pi + 0.5*dlat + (i-1)*dlat (i=1,...,nlat)
c
C*PL*ERROR* Comment line too long
c     the data in goff is "shifted" one half a grid increment in longitude
c     and latitude and excludes the poles.  each goff(j,1) is given at
C*PL*ERROR* Comment line too long
c     latitude -0.5*pi+0.5*dlat and goff(j,nlat) is given at 0.5*pi-0.5*dlat
C*PL*ERROR* Comment line too long
c     (1/2 a grid increment away from the poles).  each goff(1,i),goff(nlon,i)
c     is given at longitude 0.5*dlon and 2.*pi-0.5*dlon.
c
c     regular grid
c
c     let dlat,dlon be as above.  then the nlon by nlat+1 grid on which
c     greg(j,i) is generated (ioff=0) or given (ioff=1) is given by
c
c          lone(j) = (j-1)*dlon (j=1,...,nlon)
c
c      and
c
c          late(i) = -0.5*pi + (i-1)*dlat (i=1,...,nlat+1)
c
C*PL*ERROR* Comment line too long
c     values in greg include the poles and start at zero degrees longitude.
c
c *** remark
c
C*PL*ERROR* Comment line too long
c     subroutine sshifte can be used in conjunction with subroutine trssph
C*PL*ERROR* Comment line too long
c     when transferring data from an equally spaced "1/2 increment offset"
C*PL*ERROR* Comment line too long
c     grid to a gaussian or equally spaced grid (which includes poles) of
c     any resolution.  this problem (personal communication with dennis
c     shea) is encountered in geophysical modeling and data analysis.
c
c *** method
c
c     fast fourier transform software from spherepack2 and trigonometric
c     identities are used to accurately "shift" periodic vectors half a
c     grid increment in latitude and longitude.  latitudinal shifts are
C*PL*ERROR* Comment line too long
c     accomplished by setting periodic 2*nlat vectors over the pole for each
C*PL*ERROR* Comment line too long
c     longitude.  when nlon is odd, this requires an additional longitude
C*PL*ERROR* Comment line too long
c     shift.  longitudinal shifts are then executed for each shifted latitude.
c     when necessary (ioff=0) poles are obtained by averaging the nlon
c     shifted polar values.
c
c *** required files from spherepack3.0
c
c     hrfft.f
c
c *** argument description
c
c ... ioff
c
c     ioff = 0 if values on the offset grid in goff are given and values
c              on the regular grid in greg are to be generated.
c
C*PL*ERROR* Comment line too long
c     ioff = 1 if values on the regular grid in greg are given and values
c              on the offset grid in goff are to be generated.
c
c ... nlon
c
c     the number of longitude points on both the "offset" and "regular"
c     uniform grid in longitude (see "grid description" above).  nlon
C*PL*ERROR* Comment line too long
c     is also the first dimension of array goff and greg.  nlon determines
C*PL*ERROR* Comment line too long
c     the grid increment in longitude as dlon = 2.*pi/nlon.  for example,
C*PL*ERROR* Comment line too long
c     nlon = 144 for a 2.5 degree grid.  nlon can be even or odd and must
c     be greater than or equal to 4.  the efficiency of the computation
c     is improved when nlon is a product of small primes.
c
c ... nlat
c
C*PL*ERROR* Comment line too long
c     the number of latitude points on the "offset" uniform grid.  nlat+1
C*PL*ERROR* Comment line too long
c     is the number of latitude points on the "regular" uniform grid (see
C*PL*ERROR* Comment line too long
c     "grid description" above).  nlat is the second dimension of array goff.
C*PL*ERROR* Comment line too long
c     nlat+1 must be the second dimension of the array greg in the program
c     calling sshifte.  nlat determines the grid in latitude as pi/nlat.
C*PL*ERROR* Comment line too long
c     for example, nlat = 36 for a five degree grid.  nlat must be at least 3.
c
c ... goff
c
c     a nlon by nlat array that contains data on the offset grid
c     described above.  goff is a given input argument if ioff=0.
c     goff is a generated output argument if ioff=1.
c
c ... greg
c
c     a nlon by nlat+1 array that contains data on the regular grid
c     described above.  greg is a given input argument if ioff=1.
c     greg is a generated output argument if ioff=0.
c
c ... wsav
c
c     a real saved work space array that must be initialized by calling
C*PL*ERROR* Comment line too long
c     subroutine sshifti(ioff,nlon,nlat,wsav,ier) before calling sshifte.
c     wsav can then be used repeatedly by sshifte as long as ioff, nlon,
c     and nlat do not change.  this bypasses redundant computations and
c     saves time.  undetectable errors will result if sshifte is called
c     without initializing wsav whenever ioff, nlon, or nlat change.
c
c ... lsav
c
C*PL*ERROR* Comment line too long
c     the length of the saved work space wsav in the routine calling sshifte
C*PL*ERROR* Comment line too long
c     and sshifti.  lsave must be greater than or equal to 2*(2*nlat+nlon+16).
c
c ... work
c
c     a real unsaved work space
c
c ... lwork
c
C*PL*ERROR* Comment line too long
c     the length of the unsaved work space in the routine calling sshifte
C*PL*ERROR* Comment line too long
c     lwork must be greater than or equal to 2*nlon*(nlat+1) if nlon is even.
C*PL*ERROR* Comment line too long
c     lwork must be greater than or equal to nlon*(5*nlat+1) if nlon is odd.
c
c ... ier
c
c     indicates errors in input parameters
c
c     = 0 if no errors are detected
c
c     = 1 if ioff is not equal to 0 or 1
c
c     = 1 if nlon < 4
c
c     = 2 if nlat < 3
c
c     = 3 if lsave < 2*(nlon+2*nlat+16)
c
c     = 4 if lwork < 2*nlon*(nlat+1) for nlon even or
c            lwork < nlon*(5*nlat+1) for nlon odd
c
c *** end of sshifte documentation
c
c     subroutine sshifti(ioff,nlon,nlat,lsav,wsav,ier)
c
c     subroutine sshifti initializes the saved work space wsav
c     for ioff and nlon and nlat (see documentation for sshifte).
c     sshifti must be called before sshifte whenever ioff or nlon
c     or nlat change.
c
c ... ier
c
c     = 0 if no errors with input arguments
c
c     = 1 if ioff is not 0 or 1
c
c     = 2 if nlon < 4
c
c     = 3 if nlat < 3
c
c     = 4 if lsav < 2*(2*nlat+nlon+16)
c
c *** end of sshifti documentation
c
      SUBROUTINE DSSHIFTE(IOFF,NLON,NLAT,GOFF,GREG,WSAV,LSAV,WRK,LWRK,
     +                   IER)
      IMPLICIT NONE
      INTEGER IOFF,NLON,NLAT,N2,NR,NLAT2,NLATP1,LSAV,LWRK,I1,I2,IER
      DOUBLE PRECISION GOFF(NLON,NLAT),GREG(NLON,*),WSAV(LSAV),WRK(LWRK)
c
c     check input parameters
c
      IER = 1
      IF (IOFF* (IOFF-1).NE.0) RETURN
      IER = 2
      IF (NLON.LT.4) RETURN
      IER = 3
      IF (NLAT.LT.3) RETURN
      IER = 4
      IF (LSAV.LT.2* (2*NLAT+NLON+16)) RETURN
      IER = 5
      N2 = (NLON+1)/2
      IF (2*N2.EQ.NLON) THEN
          IF (LWRK.LT.2*NLON* (NLAT+1)) RETURN
          I1 = 1
          NR = N2
      ELSE
          IF (LWRK.LT.NLON* (5*NLAT+1)) RETURN
          I1 = 1 + 2*NLAT*NLON
          NR = NLON
      END IF
      IER = 0
      NLAT2 = NLAT + NLAT
      I2 = I1 + (NLAT+1)*NLON
      IF (IOFF.EQ.0) THEN
          CALL DSHFTOFF(NLON,NLAT,GOFF,GREG,WSAV,NR,NLAT2,WRK,WRK(I1),
     +                 WRK(I2))
      ELSE
          NLATP1 = NLAT + 1
          CALL DSHFTREG(NLON,NLAT,GOFF,GREG,WSAV,NR,NLAT2,NLATP1,WRK,
     +                 WRK(I1),WRK(I2))
      END IF
      END

      SUBROUTINE DSHFTOFF(NLON,NLAT,GOFF,GREG,WSAV,NR,NLAT2,RLAT,RLON,
     +                   WRK)
c
c     shift offset grid to regular grid, i.e.,
c     goff is given, greg is to be generated
c
      IMPLICIT NONE
      INTEGER NLON,NLAT,NLAT2,N2,NR,J,I,JS,ISAV
      DOUBLE PRECISION GOFF(NLON,NLAT),GREG(NLON,NLAT+1)
      DOUBLE PRECISION RLAT(NR,NLAT2),RLON(NLAT,NLON)
      DOUBLE PRECISION WSAV(*),WRK(*)
      DOUBLE PRECISION GNORTH,GSOUTH

      ISAV = 4*NLAT + 17
      N2 = (NLON+1)/2
c
c     execute full circle latitude shifts for nlon odd or even
c
      IF (2*N2.GT.NLON) THEN
c
c     odd number of longitudes
c
          DO I = 1,NLAT
              DO J = 1,NLON
                  RLON(I,J) = GOFF(J,I)
              END DO
          END DO
c
c       half shift in longitude
c
          CALL DSHIFTH(NLAT,NLON,RLON,WSAV(ISAV),WRK)
c
c       set full 2*nlat circles in rlat using shifted values in rlon
c
          DO J = 1,N2 - 1
              JS = J + N2
              DO I = 1,NLAT
                  RLAT(J,I) = GOFF(J,I)
                  RLAT(J,NLAT+I) = RLON(NLAT+1-I,JS)
              END DO
          END DO
          DO J = N2,NLON
              JS = J - N2 + 1
              DO I = 1,NLAT
                  RLAT(J,I) = GOFF(J,I)
                  RLAT(J,NLAT+I) = RLON(NLAT+1-I,JS)
              END DO
          END DO
c
c       shift the nlon rlat vectors one half latitude grid
c
          CALL DSHIFTH(NLON,NLAT2,RLAT,WSAV,WRK)
c
c       set nonpole values in greg and average for poles
c
          GNORTH = 0.0D0
          GSOUTH = 0.0D0
          DO J = 1,NLON
              GNORTH = GNORTH + RLAT(J,1)
              GSOUTH = GSOUTH + RLAT(J,NLAT+1)
              DO I = 2,NLAT
                  GREG(J,I) = RLAT(J,I)
              END DO
          END DO
          GNORTH = GNORTH/NLON
          GSOUTH = GSOUTH/NLON

      ELSE
c
c     even number of longitudes (no initial longitude shift necessary)
C*PL*ERROR* Comment line too long
c     set full 2*nlat circles (over poles) for each longitude pair (j,js)
c
          DO J = 1,N2
              JS = N2 + J
              DO I = 1,NLAT
                  RLAT(J,I) = GOFF(J,I)
                  RLAT(J,NLAT+I) = GOFF(JS,NLAT+1-I)
              END DO
          END DO
c
c       shift the n2=(nlon+1)/2 rlat vectors one half latitude grid
c
          CALL DSHIFTH(N2,NLAT2,RLAT,WSAV,WRK)
c
c       set nonpole values in greg and average poles
c
          GNORTH = 0.0D0
          GSOUTH = 0.0D0
          DO J = 1,N2
              JS = N2 + J
              GNORTH = GNORTH + RLAT(J,1)
              GSOUTH = GSOUTH + RLAT(J,NLAT+1)
              DO I = 2,NLAT
                  GREG(J,I) = RLAT(J,I)
                  GREG(JS,I) = RLAT(J,NLAT2-I+2)
              END DO
          END DO
          GNORTH = GNORTH/N2
          GSOUTH = GSOUTH/N2
      END IF
c
c     set poles
c
      DO J = 1,NLON
          GREG(J,1) = GNORTH
          GREG(J,NLAT+1) = GSOUTH
      END DO
c
c     execute full circle longitude shift
c
      DO J = 1,NLON
          DO I = 1,NLAT
              RLON(I,J) = GREG(J,I)
          END DO
      END DO
      CALL DSHIFTH(NLAT,NLON,RLON,WSAV(ISAV),WRK)
      DO J = 1,NLON
          DO I = 2,NLAT
              GREG(J,I) = RLON(I,J)
          END DO
      END DO
      END

      SUBROUTINE DSHFTREG(NLON,NLAT,GOFF,GREG,WSAV,NR,NLAT2,NLATP1,RLAT,
     +                   RLON,WRK)
c
c     shift regular grid to offset grid, i.e.,
c     greg is given, goff is to be generated
c
      IMPLICIT NONE
      INTEGER NLON,NLAT,NLAT2,NLATP1,N2,NR,J,I,JS,ISAV
      DOUBLE PRECISION GOFF(NLON,NLAT),GREG(NLON,NLATP1)
      DOUBLE PRECISION RLAT(NR,NLAT2),RLON(NLATP1,NLON)
      DOUBLE PRECISION WSAV(*),WRK(*)

      ISAV = 4*NLAT + 17
      N2 = (NLON+1)/2
c
c     execute full circle latitude shifts for nlon odd or even
c
      IF (2*N2.GT.NLON) THEN
c
c     odd number of longitudes
c
          DO I = 1,NLAT + 1
              DO J = 1,NLON
                  RLON(I,J) = GREG(J,I)
              END DO
          END DO
c
c       half shift in longitude in rlon
c
          CALL DSHIFTH(NLAT+1,NLON,RLON,WSAV(ISAV),WRK)
c
c       set full 2*nlat circles in rlat using shifted values in rlon
c
          DO J = 1,N2
              JS = J + N2 - 1
              RLAT(J,1) = GREG(J,1)
              DO I = 2,NLAT
                  RLAT(J,I) = GREG(J,I)
                  RLAT(J,NLAT+I) = RLON(NLAT+2-I,JS)
              END DO
              RLAT(J,NLAT+1) = GREG(J,NLAT+1)
          END DO
          DO J = N2 + 1,NLON
              JS = J - N2
              RLAT(J,1) = GREG(J,1)
              DO I = 2,NLAT
                  RLAT(J,I) = GREG(J,I)
                  RLAT(J,NLAT+I) = RLON(NLAT+2-I,JS)
              END DO
              RLAT(J,NLAT+1) = GREG(J,NLAT+1)
          END DO
c
c       shift the nlon rlat vectors one halflatitude grid
c
          CALL DSHIFTH(NLON,NLAT2,RLAT,WSAV,WRK)
c
c       set values in goff
c
          DO J = 1,NLON
              DO I = 1,NLAT
                  GOFF(J,I) = RLAT(J,I)
              END DO
          END DO

      ELSE
c
c     even number of longitudes (no initial longitude shift necessary)
C*PL*ERROR* Comment line too long
c     set full 2*nlat circles (over poles) for each longitude pair (j,js)
c
          DO J = 1,N2
              JS = N2 + J
              RLAT(J,1) = GREG(J,1)
              DO I = 2,NLAT
                  RLAT(J,I) = GREG(J,I)
                  RLAT(J,NLAT+I) = GREG(JS,NLAT+2-I)
              END DO
              RLAT(J,NLAT+1) = GREG(J,NLAT+1)
          END DO
c
c       shift the n2=(nlon+1)/2 rlat vectors one half latitude grid
c
          CALL DSHIFTH(N2,NLAT2,RLAT,WSAV,WRK)
c
c       set values in goff
c
          DO J = 1,N2
              JS = N2 + J
              DO I = 1,NLAT
                  GOFF(J,I) = RLAT(J,I)
                  GOFF(JS,I) = RLAT(J,NLAT2+1-I)
              END DO
          END DO
      END IF
c
c     execute full circle longitude shift for all latitude circles
c
      DO J = 1,NLON
          DO I = 1,NLAT
              RLON(I,J) = GOFF(J,I)
          END DO
      END DO
      CALL DSHIFTH(NLAT+1,NLON,RLON,WSAV(ISAV),WRK)
      DO J = 1,NLON
          DO I = 1,NLAT
              GOFF(J,I) = RLON(I,J)
          END DO
      END DO
      END

      SUBROUTINE DSSHIFTI(IOFF,NLON,NLAT,LSAV,WSAV,IER)
      INTEGER IOFF,NLAT,NLON,NLAT2,ISAV,IER
      DOUBLE PRECISION WSAV(LSAV)
      DOUBLE PRECISION PI,DLAT,DLON,DP

      IER = 1
      IF (IOFF* (IOFF-1).NE.0) RETURN
      IER = 2
      IF (NLON.LT.4) RETURN
      IER = 3
      IF (NLAT.LT.3) RETURN
      IER = 4
      IF (LSAV.LT.2* (2*NLAT+NLON+16)) RETURN
      IER = 0
      PI = 4.0D0*ATAN(1.0D0)
c
c     set lat,long increments
c
      DLAT = PI/NLAT
      DLON = (PI+PI)/NLON
c
c     initialize wsav for left or right latitude shifts
c
      IF (IOFF.EQ.0) THEN
          DP = -0.5D0*DLAT
      ELSE
          DP = 0.5D0*DLAT
      END IF
      NLAT2 = NLAT + NLAT
      CALL DSHIFTHI(NLAT2,DP,WSAV)
c
c     initialize wsav for left or right longitude shifts
c
      IF (IOFF.EQ.0) THEN
          DP = -0.5D0*DLON
      ELSE
          DP = 0.5D0*DLON
      END IF
      ISAV = 4*NLAT + 17
      CALL DSHIFTHI(NLON,DP,WSAV(ISAV))
      RETURN
      END

      SUBROUTINE DSHIFTH(M,N,R,WSAV,WORK)
      IMPLICIT NONE
      INTEGER M,N,N2,K,L
      DOUBLE PRECISION R(M,N),WSAV(*),WORK(*),R2KM2,R2KM1

      N2 = (N+1)/2
c
c     compute fourier coefficients for r on shifted grid
c
      CALL DHRFFTF(M,N,R,M,WSAV(N+2),WORK)
      DO L = 1,M
          DO K = 2,N2
              R2KM2 = R(L,K+K-2)
              R2KM1 = R(L,K+K-1)
              R(L,K+K-2) = R2KM2*WSAV(N2+K) - R2KM1*WSAV(K)
              R(L,K+K-1) = R2KM2*WSAV(K) + R2KM1*WSAV(N2+K)
          END DO
      END DO
c
c     shift r with fourier synthesis and normalization
c
      CALL DHRFFTB(M,N,R,M,WSAV(N+2),WORK)
      DO L = 1,M
          DO K = 1,N
              R(L,K) = R(L,K)/N
          END DO
      END DO
      RETURN
      END

      SUBROUTINE DSHIFTHI(N,DP,WSAV)
c
c     initialize wsav for subroutine shifth
c
      IMPLICIT NONE
      INTEGER N,N2,K
      DOUBLE PRECISION WSAV(*),DP

      N2 = (N+1)/2
      DO K = 2,N2
          WSAV(K) = SIN((K-1)*DP)
          WSAV(K+N2) = COS((K-1)*DP)
      END DO
      CALL DHRFFTI(N,WSAV(N+2))
      RETURN
      END

c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by UCAR                 .
c  .                                                             .
c  .       University Corporation for Atmospheric Research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                          SPHEREPACK                          .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c                             August 2003
c
c
c     This version of gaqd implements the method presented in:
c     P. N. swarztrauber, Computing the points and weights for
c     Gauss-Legendre quadrature, SIAM J. Sci. Comput.,
c     24(2002) pp. 945-954.
c
c     It the version that is new to spherepack 3.1
c     The w and lwork arrays are dummy and included only to
c     permit a simple pluggable exchange with the
c     old gaqd in spherepack 3.0.
c
c
c
      SUBROUTINE DGAQD(NLAT,THETA,WTS,W,LWORK,IERROR)
      DOUBLE PRECISION EPS
      DOUBLE PRECISION DDZEPS
      DOUBLE PRECISION SGND
C*PT*WARNING* Already double-precision
c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 2001 by ucar                 .
c  .                                                             .
c  .       university corporation for atmospheric research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c                             February 2002
c
c     gauss points and weights are computed using the fourier-newton
c     described in "on computing the points and weights for
c     gauss-legendre quadrature", paul n. swarztrauber, siam journal
c     on scientific computing that has been accepted for publication.
c     This routine is faster and more accurate than older program
c     with the same name.
c
c     subroutine gaqd computes the nlat gaussian colatitudes and weights
c     in double precision. the colatitudes are in radians and lie in the
c     in the interval (0,pi).
c
c     input parameters
c
c     nlat    the number of gaussian colatitudes in the interval (0,pi)
c             (between the two poles).  nlat must be greater than zero.
c
c     w       unused double precision variable that permits a simple
c             exchange with the old routine with the same name
c             in spherepack.
c
c     lwork   unused variable that permits a simple exchange with the
c             old routine with the same name in spherepack.
c
c     output parameters
c
c     theta   a double precision array with length nlat
c             containing the gaussian colatitudes in
c             increasing radians on the interval (0,pi).
c
c     wts     a double precision array with lenght nlat
c             containing the gaussian weights.
c
c     ierror = 0 no errors
c            = 1 if nlat.le.0
c
c  *****************************************************************
c
      DOUBLE PRECISION THETA(NLAT),WTS(NLAT),W,X,PI,PIS2,DTHETA,DTHALF,
     +                 CMAX,ZPREV,ZLAST,ZERO,ZHOLD,PB,DPB,DCOR,SUM,CZ
c
c     check work space length
c
      IERROR = 1
      IF (NLAT.LE.0) RETURN
      IERROR = 0
c
c     compute weights and points analytically when nlat=1,2
c
      IF (NLAT.EQ.1) THEN
C*PT*WARNING* Constant already double-precision
          THETA(1) = DACOS(0.0d0)
C*PT*WARNING* Constant already double-precision
          WTS(1) = 2.0d0
          RETURN
      END IF
      IF (NLAT.EQ.2) THEN
C*PT*WARNING* Constant already double-precision
C*PT*WARNING* Constant already double-precision
          X = DSQRT(1.0d0/3.0d0)
          THETA(1) = DACOS(X)
          THETA(2) = DACOS(-X)
C*PT*WARNING* Constant already double-precision
          WTS(1) = 1.0d0
C*PT*WARNING* Constant already double-precision
          WTS(2) = 1.0d0
          RETURN
      END IF
C*PT*WARNING* Constant already double-precision
      EPS = SQRT(DDZEPS(1.0d0))
      EPS = EPS*SQRT(EPS)
C*PT*WARNING* Constant already double-precision
C*PT*WARNING* Constant already double-precision
      PIS2 = 2.0d0*DATAN(1.0d0)
      PI = PIS2 + PIS2
      MNLAT = MOD(NLAT,2)
      NS2 = NLAT/2
      NHALF = (NLAT+1)/2
      IDX = NS2 + 2
c
      CALL DCPDP(NLAT,CZ,THETA(NS2+1),WTS(NS2+1))
c
      DTHETA = PIS2/NHALF
C*PT*WARNING* Constant already double-precision
      DTHALF = DTHETA/2.0d0
C*PT*WARNING* Constant already double-precision
      CMAX = .2d0*DTHETA
c
c     estimate first point next to theta = pi/2
c
      IF (MNLAT.NE.0) THEN
          ZERO = PIS2 - DTHETA
          ZPREV = PIS2
          NIX = NHALF - 1
      ELSE
          ZERO = PIS2 - DTHALF
          NIX = NHALF
      END IF
    9 IT = 0
   10 IT = IT + 1
      ZLAST = ZERO
c
c     newton iterations
c
      CALL DTPDP(NLAT,ZERO,CZ,THETA(NS2+1),WTS(NS2+1),PB,DPB)
      DCOR = PB/DPB
      SGND = 1.0D0
C*PT*WARNING* Constant already double-precision
      IF (DCOR.NE.0.0d0) SGND = DCOR/DABS(DCOR)
      DCOR = SGND*MIN(DABS(DCOR),CMAX)
      ZERO = ZERO - DCOR
      IF (DABS(ZERO-ZLAST).GT.EPS*DABS(ZERO)) GO TO 10
      THETA(NIX) = ZERO
      ZHOLD = ZERO
c      wts(nix) = (nlat+nlat+1)/(dpb*dpb)
c
c     yakimiw's formula permits using old pb and dpb
c
      WTS(NIX) = (NLAT+NLAT+1)/ (DPB+PB*DCOS(ZLAST)/DSIN(ZLAST))**2
      NIX = NIX - 1
      IF (NIX.EQ.0) GO TO 30
      IF (NIX.EQ.NHALF-1) ZERO = 3.0D0*ZERO - PI
      IF (NIX.LT.NHALF-1) ZERO = ZERO + ZERO - ZPREV
      ZPREV = ZHOLD
      GO TO 9
c
c     extend points and weights via symmetries
c
   30 IF (MNLAT.NE.0) THEN
          THETA(NHALF) = PIS2
          CALL DTPDP(NLAT,PIS2,CZ,THETA(NS2+1),WTS(NS2+1),PB,DPB)
          WTS(NHALF) = (NLAT+NLAT+1)/ (DPB*DPB)
      END IF
      DO I = 1,NS2
          WTS(NLAT-I+1) = WTS(I)
          THETA(NLAT-I+1) = PI - THETA(I)
      END DO
C*PT*WARNING* Constant already double-precision
      SUM = 0.0d0
      DO I = 1,NLAT
          SUM = SUM + WTS(I)
      END DO
      DO I = 1,NLAT
C*PT*WARNING* Constant already double-precision
          WTS(I) = 2.0d0*WTS(I)/SUM
      END DO
      RETURN
      END
      SUBROUTINE DCPDP(N,CZ,CP,DCP)
C*PT*WARNING* Already double-precision
c
c     computes the fourier coefficients of the legendre
c     polynomial p_n^0 and its derivative.
c     n is the degree and n/2 or (n+1)/2
c     coefficients are returned in cp depending on whether
c     n is even or odd. The same number of coefficients
c     are returned in dcp. For n even the constant
c     coefficient is returned in cz.
c
      DOUBLE PRECISION CP(N/2+1),DCP(N/2+1),T1,T2,T3,T4,CZ

      NCP = (N+1)/2
C*PT*WARNING* Constant already double-precision
      T1 = -1.0d0
C*PT*WARNING* Constant already double-precision
      T2 = N + 1.0d0
C*PT*WARNING* Constant already double-precision
      T3 = 0.0d0
C*PT*WARNING* Constant already double-precision
      T4 = N + N + 1.0d0
      IF (MOD(N,2).EQ.0) THEN
C*PT*WARNING* Constant already double-precision
          CP(NCP) = 1.0d0
          DO J = NCP,2,-1
C*PT*WARNING* Constant already double-precision
              T1 = T1 + 2.0d0
C*PT*WARNING* Constant already double-precision
              T2 = T2 - 1.0d0
C*PT*WARNING* Constant already double-precision
              T3 = T3 + 1.0d0
C*PT*WARNING* Constant already double-precision
              T4 = T4 - 2.0d0
              CP(J-1) = (T1*T2)/ (T3*T4)*CP(J)
          END DO
C*PT*WARNING* Constant already double-precision
          T1 = T1 + 2.0d0
C*PT*WARNING* Constant already double-precision
          T2 = T2 - 1.0d0
C*PT*WARNING* Constant already double-precision
          T3 = T3 + 1.0d0
C*PT*WARNING* Constant already double-precision
          T4 = T4 - 2.0d0
          CZ = (T1*T2)/ (T3*T4)*CP(1)
          DO J = 1,NCP
              DCP(J) = (J+J)*CP(J)
          END DO
      ELSE
C*PT*WARNING* Constant already double-precision
          CP(NCP) = 1.0d0
          DO J = NCP - 1,1,-1
C*PT*WARNING* Constant already double-precision
              T1 = T1 + 2.0d0
C*PT*WARNING* Constant already double-precision
              T2 = T2 - 1.0d0
C*PT*WARNING* Constant already double-precision
              T3 = T3 + 1.0d0
C*PT*WARNING* Constant already double-precision
              T4 = T4 - 2.0d0
              CP(J) = (T1*T2)/ (T3*T4)*CP(J+1)
          END DO
          DO J = 1,NCP
              DCP(J) = (J+J-1)*CP(J)
          END DO
      END IF
      RETURN
      END
      SUBROUTINE DTPDP(N,THETA,CZ,CP,DCP,PB,DPB)
C*PT*WARNING* Already double-precision
c
c     computes pn(theta) and its derivative dpb(theta) with
c     respect to theta
c
      DOUBLE PRECISION CP(N/2+1),DCP(N/2+1),CZ,PB,DPB,FN,THETA,CDT,SDT,
     +                 CTH,STH,CHH
c
      FN = N
      CDT = DCOS(THETA+THETA)
      SDT = DSIN(THETA+THETA)
      IF (MOD(N,2).EQ.0) THEN
c
c     n even
c
          KDO = N/2
C*PT*WARNING* Constant already double-precision
          PB = .5d0*CZ
C*PT*WARNING* Constant already double-precision
          DPB = 0.0d0
          IF (N.GT.0) THEN
              CTH = CDT
              STH = SDT
              DO 170 K = 1,KDO
c      pb = pb+cp(k)*cos(2*k*theta)
                  PB = PB + CP(K)*CTH
c      dpb = dpb-(k+k)*cp(k)*sin(2*k*theta)
                  DPB = DPB - DCP(K)*STH
                  CHH = CDT*CTH - SDT*STH
                  STH = SDT*CTH + CDT*STH
                  CTH = CHH
  170         CONTINUE
          END IF
      ELSE
c
c     n odd
c
          KDO = (N+1)/2
C*PT*WARNING* Constant already double-precision
          PB = 0.0d0
C*PT*WARNING* Constant already double-precision
          DPB = 0.0d0
          CTH = DCOS(THETA)
          STH = DSIN(THETA)
          DO 190 K = 1,KDO
c      pb = pb+cp(k)*cos((2*k-1)*theta)
              PB = PB + CP(K)*CTH
c      dpb = dpb-(k+k-1)*cp(k)*sin((2*k-1)*theta)
              DPB = DPB - DCP(K)*STH
              CHH = CDT*CTH - SDT*STH
              STH = SDT*CTH + CDT*STH
              CTH = CHH
  190     CONTINUE
      END IF
      RETURN
      END
      DOUBLE PRECISION FUNCTION DDZEPS(X)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION X
C*PT*WARNING* Already double-precision
c
c     estimate unit roundoff in quantities of size x.
c
      DOUBLE PRECISION A,B,C,EPS
C*PT*WARNING* Constant already double-precision
C*PT*WARNING* Constant already double-precision
c
c     this program should function properly on all systems
c     satisfying the following two assumptions,
c        1.  the base used in representing floating point
c            numbers is not a power of three.
c        2.  the quantity  a  in statement 10 is represented to
c            the accuracy used in floating point variables
c            that are stored in memory.
c     the statement number 10 and the go to 10 are intended to
c     force optimizing compilers to generate code satisfying
c     assumption 2.
c     under these assumptions, it should be true that,
c            a  is not exactly equal to four-thirds,
c            b  has a zero for its last bit or digit,
c            c  is not exactly equal to one,
c            eps  measures the separation of 1.0 from
c                 the next larger floating point number.
c     the developers of eispack would appreciate being informed
c     about any systems where these assumptions do not hold.
c
c     this version dated 4/6/83.
c
      A = 4.0d0/3.0d0
C*PT*WARNING* Constant already double-precision
   10 B = A - 1.0d0
      C = B + B + B
C*PT*WARNING* Constant already double-precision
      EPS = ABS(C-1.0d0)
C*PT*WARNING* Constant already double-precision
      IF (EPS.EQ.0.0d0) GO TO 10
      DDZEPS = EPS*DABS(X)
      RETURN
      END

C
C	$Id: g01bkd.f,v 1.10 2008-07-27 00:21:05 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE G01BKD
C
C Calling this do-nothing subroutine forces "ld" to load the following
C block data routine (but only if they are in the same ".f" file).
C
        RETURN
C
      END
CNOSPLIT
      BLOCKDATA G01BKDX
C
C  BLOCK DATA module for workstation type 1.
C
      include 'g01prm.h'
      include 'g01wsl.doc'
      include 'g01wsl.h'
      include 'g01wdt.doc'
      include 'g01wdt.h'
      include 'g01ins.doc'
      include 'g01ins.h'
      include 'g01dfa.doc'
      include 'g01dfa.h'
      include 'g01adc.doc'
      include 'g01adc.h'
      include 'g01io.doc'
      include 'g01io.h'
      include 'gksenu.doc'
      include 'gksenu.h'
      include 'g01opc.doc'
      include 'g01opc.h'
C
C  Workstation state list.
C
C  Length of color table arrays.
C
      DATA  MOLMAX/256/
C
C  Workstation description table.
C
C  Workstation type and category.
C
      DATA LWTYPE,LWKCAT/1,4/
C
C  Metafile version.
C
      DATA MVERSN/1/
C
C  Internal constants.
C
C
C  Most recent function code, Most recent continuation flag.
C
      DATA  MCODES/0/,  MCONTS/0/
C
C  VDC, color index, direct color component field widths.
C
      DATA  MVDCFW/16/,  MCIXFW/ 8/,  MDCCFW/ 8/
      DATA  MIXFW /16/,  MINTFW/16/,  MEFW  /16/
C
C  2**MDCCFW - 1
C  (should be tied parametrically to MCIXFW).
C
      DATA  MDCCRG/255/
C
C  MIN and MAX VDC address limits in X and Y directions,
C  the VDC extent (the two concepts should be separated).
C
      DATA  MINXVD/0/,  MAXXVD/32767/,  MINYVD/0/,  MAXYVD/32767/
C
C  NDC to VDC mapping coefficients, X and Y directions.
C
      DATA  MXOFF/0/,  MXSCAL/32767/,  MYOFF/0/,  MYSCAL/32767/
C
C  Color table change, background color change.
C
      DATA  MCTCHG/0/,  MBCCHG/0/
C
C  Size of the holding buffer.
C
      DATA  MPXYSZ/256/
C
C  Precision (in bits) of the two components of the representation
C  of real numbers in the metafile.
C
      DATA  MCFPP/16/
C
C  Default attribute context.
C
C
C  POLYLINE INDEX, LINETYPE, LINE COLOR INDEX, LINEWIDTH SCALE.
C
      DATA  MDPLIX/1/,  MDLTYP/1/,  MDPLCI/1/,  ADLWSC/1.0/
C
C  POLYMARKER INDEX, MARKER TYPE, MARKER COLOR INDEX, MARKER SCALE.
C
      DATA  MDPMIX/1/,  MDMTYP/3/,  MDPMCI/1/,  ADMSZS/1.0/
C
C  TEXT INDEX, TEXT PATH, TEXT ALIGNMENT, TEXT FONT.
C
      DATA  MDTXIX/1/,  MDTXP/0/,  MDTXAL/0,0/,  MDTXFO/1/
C
C  TEXT PRECISION, TEXT COLOR INDEX, CHARACTER HEIGHT.
C  (MDCHH should eventually be tied parametrically to VDC extent).
C
      DATA  MDTXPR/0/,  MDTXCI/1/,  MDCHH/328/
C
C  CHARACTER ORIENTATION VECTORS.
C  (MDCHOV should eventually be tied parametrically to VDC extent).
C
      DATA  MDCHOV/0,328,328,0/
C
C  Character expansion factor, character spacing.
C
      DATA  ADCHXP/1.0/,  ADCHSP/0.0/
C
C  FILL AREA INDEX, PATTERN SIZE, PATTERN REF POINT.
C  (MDPASZ should eventually be tied parametrically to VDC extent).
C
      DATA  MDFAIX/1/,  MDPASZ/0,32767,32767,0/,  MDPARF/0,0/
C
C  FILL AREA INTERIOR STYLE, STYLE INDEX, COLOR INDEX.
C
      DATA  MDFAIS/0/,  MDFASI/1/,  MDFACI/1/
C
C  ASF values (these are defaulted to individual).  Note that the
C  CGM values for bundled and individual are reversed from the GKS
C  Fortran binding.
C
      DATA  MDASF/13*0/
C
C  Pointers into attribute structure, VALCHG variables.
C
      DATA  IVPLIX/ 1/,  IVLTYP/ 2/,  IVLWSC/ 3/,  IVPLCI/ 4/
      DATA  IVPMIX/ 5/,  IVMTYP/ 6/,  IVMSZS/ 7/,  IVPMCI/ 8/
      DATA  IVTXIX/ 9/,  IVTXP /10/,  IVTXAL/11/,  IVCHH /12/
      DATA  IVCHOV/13/,  IVTXFO/14/,  IVTXPR/15/,  IVCHXP/16/
      DATA  IVCHSP/17/,  IVTXCI/18/,  IVFAIX/19/,  IVPASZ/20/
      DATA  IVPARF/21/,  IVFAIS/22/,  IVFASI/23/,  IVFACI/24/
      DATA  IVASF /25/
C
C  Pointers into attribute equivalencing arrays.
C
      DATA  IP2AEA/  1,  2, -3,  4,  5,  6, -7,  8,  9, 10, 11, 13,
     +              14, 18, 19,-20,-21, 22, 23, 24, 28, 30, 31, 32,
     +              33, 46 /
C
C  Pointers into ASF arrays.
C
      DATA  IALTYP/ 1/,  IALWSC/ 2/,  IAPLCI/ 3/,  IAMTYP/ 4/
      DATA  IAMSZS/ 5/,  IAPMCI/ 6/,  IATXFP/ 7/,  IACHXP/ 8/
      DATA  IACHSP/ 9/,  IATXCI/10/,  IAFAIS/11/,  IAFASI/12/
      DATA  IAFACI/13/
C
C  Number of CGM and GKS ASFs, GKS to CGM mapping array.
C
      DATA  NCGASF/18/,  NGKASF/13/
      DATA  MASMAP/1,2,3,4,5,6,7,7,8,9,10,11,13,12,12,0,0,0/
C
C  GKS enumeratives.
C
      DATA  GNO   /0/,     GYES/1/,   GCONDI/0/,   GALWAY/1/
      DATA  GINACT/0/,   GACTIV/1/,   GNEMPT/0/,   GEMPTY/1/
      DATA  GNPEND/0/,    GPEND/1/,    GCLIP/1/,   GNCLIP/0/
C
C  CGM opcodes, CLASS and ID codes.
C
      DATA  IDNOOP/0/,   IDBEGM/1/,   IDENDM/2/,   IDBEGP/3/
      DATA  IDBGPB/4/,   IDENDP/5/,   IDMVER/1/,   IDMELT/11/
      DATA  IDDREP/12/,  IDCSEL/2/,   IDVEXT/6/,   IDVINT/1/
      DATA  IDCREC/5/,   IDCLIN/6/,   IDPLIN/1/,   IDPMRK/3/
      DATA  IDTEXT/4/,   IDPGON/7/,   IDCARY/9/,   IDGDP/10/
      DATA  IDLBIX/1/,   IDLTYP/2/,   IDLWID/3/,   IDLCLR/4/
      DATA  IDMBIX/5/,   IDMTYP/6/,   IDMSIZ/7/,   IDMCLR/8/
      DATA  IDTBIX/9/,   IDTFON/10/,  IDTPRE/11/,  IDCHEX/12/
      DATA  IDCHSP/13/,  IDTCLR/14/,  IDCHHT/15/,  IDCHOR/16/
      DATA  IDTXPA/17/,  IDTXAL/18/,  IDFBIX/21/,  IDINTS/22/
      DATA  IDFCLR/23/,  IDHAIX/24/,  IDPTIX/25/,  IDFRPT/31/
      DATA  IDPTBL/32/,  IDPTSZ/33/,  IDCTBL/34/,  IDASFS/35/
      DATA  IDESC/1/,    IDMESS/1/,   IDAPLD/2/,   IDBKGC/7/
      DATA  IDDSCR/2/,   IDFLST/13/
      DATA  CLDELM/0/,   CLMDES/1/,   CLPDES/2/,   CLCNTL/3/
      DATA  CLPRIM/4/,   CLPRAT/5/,   CLESCE/6/,   CLEXTE/7/
C
C  Flag value in I/O common block.
C
      DATA  MIOFLG/-9999/
C
C  Default picture name.
C
      DATA MPNAME/
     +     '                                                              
     +                    '/
C
C  Flag for whether new picture information has been sent out.
C
      DATA NPFLG/0/
C
      END

C
C $Id: curvpidp.f,v 1.3 2008-07-27 03:10:10 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
C NOTE: If you make any changes to this software, please remember to
C make the same changes to the corresponding single precision routine.
C
      FUNCTION CURVPIDP(XL,XU,N,X,Y,P,YP,SIGMA)
      DOUBLE PRECISION CURVPIDP
      DOUBLE PRECISION SIGMAP
      DOUBLE PRECISION X1PP
      DOUBLE PRECISION XXL
      DOUBLE PRECISION XXU
      DOUBLE PRECISION XSAVE
      DOUBLE PRECISION XIL
      DOUBLE PRECISION XIU
      DOUBLE PRECISION S1
      DOUBLE PRECISION DELS
      DOUBLE PRECISION SS
      DOUBLE PRECISION CS
      DOUBLE PRECISION S2
      DOUBLE PRECISION DEL1
      DOUBLE PRECISION DEL2
      DOUBLE PRECISION T1
      DOUBLE PRECISION T2
      DOUBLE PRECISION DUMMY
      DOUBLE PRECISION C1
      DOUBLE PRECISION C2
      DOUBLE PRECISION S3
      DOUBLE PRECISION S4
      DOUBLE PRECISION S5
      DOUBLE PRECISION S6
      DOUBLE PRECISION S7
      DOUBLE PRECISION S8
      DOUBLE PRECISION DELU1
      DOUBLE PRECISION DELU2
      DOUBLE PRECISION DELL1
      DOUBLE PRECISION DELL2
      DOUBLE PRECISION DELI
      DOUBLE PRECISION CU1
      DOUBLE PRECISION CU2
      DOUBLE PRECISION CL1
      DOUBLE PRECISION CL2
      DOUBLE PRECISION SO
      DOUBLE PRECISION SI
c
      INTEGER N
      DOUBLE PRECISION XL,XU,X(N),Y(N),P,YP(N),SIGMA
c
c                                 coded by alan kaylor cline
c                           from fitpack -- january 26, 1987
c                        a curve and surface fitting package
c                      a product of pleasant valley software
c                  8603 altus cove, austin, texas 78759, usa
c
c this function integrates a curve specified by a periodic
c spline under tension between two given limits. the
c subroutine curvp1 should be called earlier to determine
c necessary parameters.
c
c on input--
c
c   xl and xu contain the upper and lower limits of inte-
c   gration, respectively. (sl need not be less than or
c   equal to xu, curvpidp (xl,xu,...) .eq. -curvpidp (xu,xl,...) ).
c
c   n contains the number of points which were specified to
c   determine the curve.
c
c   x and y are arrays containing the abscissae and
c   ordinates, respectively, of the specified points.
c
c   p contains the period.
c
c   yp is an array from subroutine curvp1 containing
c   the values of the second derivatives at the nodes.
c
c and
c
c   sigma contains the tension factor (its sign is ignored).
c
c the parameters n, x, y, p, yp, and sigma should be input
c unaltered from the output of curvp1.
c
c on output--
c
c
c   curvpidp contains the integral value.
c
c none of the input parameters are altered.
c
c this function references package modules intrvpdp and
c snhcshdp.
c
c--------------------------------------------------------------
c
      INTEGER UPER
      LOGICAL BDY
c
c denormalize tension factor
c
      SIGMAP = ABS(SIGMA)*DBLE(N)/P
c
c determine actual upper and lower bounds
c
      X1PP = X(1) + P
      ISIGN = 1
      ILM1 = INTRVPDP(XL,X,N,P,XXL)
      LPER = INT((XL-X(1))/P)
      IF (XL.LT.X(1)) LPER = LPER - 1
      IUM1 = INTRVPDP(XU,X,N,P,XXU)
      UPER = INT((XU-X(1))/P)
      IF (XU.LT.X(1)) UPER = UPER - 1
      IDELTP = UPER - LPER
      BDY = DBLE(IDELTP)* (XXU-XXL) .LT. 0.D0
      IF ((IDELTP.EQ.0.AND.XXU.LT.XXL) .OR. IDELTP.LT.0) ISIGN = -1
      IF (BDY) IDELTP = IDELTP - ISIGN
      IF (XXU.GE.XXL) GO TO 1
      XSAVE = XXL
      XXL = XXU
      XXU = XSAVE
      ISAVE = ILM1
      ILM1 = IUM1
      IUM1 = ISAVE
    1 IL = ILM1 + 1
      IF (ILM1.EQ.N) IL = 1
      XIL = X(IL)
      IF (ILM1.EQ.N) XIL = X1PP
      IU = IUM1 + 1
      IF (IUM1.EQ.N) IU = 1
      XIU = X(IU)
      IF (IUM1.EQ.N) XIU = X1PP
      S1 = 0.D0
      IF (ILM1.EQ.1 .OR. (IDELTP.EQ.0.AND..NOT.BDY)) GO TO 4
c
c integrate from x(1) to x(ilm1), store in s1
c
      DO 3 I = 2,ILM1
          DELS = X(I) - X(I-1)
          S1 = S1 + (Y(I)+Y(I-1))*DELS/2.D0
          IF (SIGMA.EQ.0.D0) GO TO 2
          CALL SNHCSHDP(SS,CS,SIGMAP*DELS,3)
          S1 = S1 + (YP(I)+YP(I-1))*DELS* (CS-SS/2.D0)/
     +         (SIGMAP*SIGMAP* (1.D0+SS))
          GO TO 3
    2     S1 = S1 - (YP(I)+YP(I-1))*DELS*DELS*DELS/24.D0
    3 CONTINUE
    4 S2 = 0.D0
      IF (X(ILM1).GE.XXL .OR. (IDELTP.EQ.0.AND..NOT.BDY)) GO TO 6
c
c integrate from x(ilm1) to xxl, store in s2
c
      DEL1 = XXL - X(ILM1)
      DEL2 = XIL - XXL
      DELS = XIL - X(ILM1)
      T1 = DEL1*DEL1/ (2.D0*DELS)
      T2 = (DEL2+DELS)*DEL1/ (2.D0*DELS)
      S2 = T1*Y(IL) + T2*Y(ILM1)
      IF (SIGMA.EQ.0.D0) GO TO 5
      CALL SNHCSHDP(DUMMY,C1,SIGMAP*DEL1,2)
      CALL SNHCSHDP(DUMMY,C2,SIGMAP*DEL2,2)
      CALL SNHCSHDP(SS,CS,SIGMAP*DELS,3)
      S2 = S2 + (YP(IL)*DEL1*DEL1* (C1-SS/2.D0)+
     +     YP(ILM1)* (DELS*DELS* (CS-SS/2.D0)-DEL2*DEL2* (C2-SS/2.D0)))/
     +     (SIGMAP*SIGMAP*DELS* (1.D0+SS))
      GO TO 6
    5 S2 = S2 - T1* (DEL2* (DEL1+DELS)+DELS*DELS)*YP(IL)/12.D0 -
     +     T2*T2*DELS*YP(ILM1)/6.D0
    6 S3 = 0.D0
      IF (XXL.GE.XIL .OR. (IDELTP.EQ.0.AND.BDY) .OR.
     +    ILM1.EQ.IUM1) GO TO 8
c
c integrate from xxl to xil, store in s3
c
      DEL1 = XXL - X(ILM1)
      DEL2 = XIL - XXL
      DELS = XIL - X(ILM1)
      T1 = (DEL1+DELS)*DEL2/ (2.D0*DELS)
      T2 = DEL2*DEL2/ (2.D0*DELS)
      S3 = T1*Y(IL) + T2*Y(ILM1)
      IF (SIGMA.EQ.0.D0) GO TO 7
      CALL SNHCSHDP(DUMMY,C1,SIGMAP*DEL1,2)
      CALL SNHCSHDP(DUMMY,C2,SIGMAP*DEL2,2)
      CALL SNHCSHDP(SS,CS,SIGMAP*DELS,3)
      S3 = S3 + ((DELS*DELS* (CS-SS/2.D0)-DEL1*DEL1* (C1-SS/2.D0))*
     +     YP(IL)+DEL2*DEL2* (C2-SS/2.D0)*YP(ILM1))/
     +     (SIGMAP*SIGMAP*DELS* (1.D0+SS))
      GO TO 8
    7 S3 = S3 - T1*T1*DELS*YP(IL)/6.D0 -
     +     T2* (DEL1* (DEL2+DELS)+DELS*DELS)*YP(ILM1)/12.D0
    8 S4 = 0.D0
      IF (ILM1.GE.IUM1-1 .OR. (IDELTP.EQ.0.AND.BDY)) GO TO 11
c
c integrate from xil to x(ium1), store in s4
c
      ILP1 = IL + 1
      DO 10 I = ILP1,IUM1
          DELS = X(I) - X(I-1)
          S4 = S4 + (Y(I)+Y(I-1))*DELS/2.D0
          IF (SIGMA.EQ.0.D0) GO TO 9
          CALL SNHCSHDP(SS,CS,SIGMAP*DELS,3)
          S4 = S4 + (YP(I)+YP(I-1))*DELS* (CS-SS/2.D0)/
     +         (SIGMAP*SIGMAP* (1.D0+SS))
          GO TO 10
    9     S4 = S4 - (YP(I)+YP(I-1))*DELS*DELS*DELS/24.D0
   10 CONTINUE
   11 S5 = 0.D0
      IF (X(IUM1).GE.XXU .OR. (IDELTP.EQ.0.AND.BDY) .OR.
     +    ILM1.EQ.IUM1) GO TO 13
c
c integrate from x(ium1) to xxu, store in s5
c
      DEL1 = XXU - X(IUM1)
      DEL2 = XIU - XXU
      DELS = XIU - X(IUM1)
      T1 = DEL1*DEL1/ (2.D0*DELS)
      T2 = (DEL2+DELS)*DEL1/ (2.D0*DELS)
      S5 = T1*Y(IU) + T2*Y(IUM1)
      IF (SIGMA.EQ.0.D0) GO TO 12
      CALL SNHCSHDP(DUMMY,C1,SIGMAP*DEL1,2)
      CALL SNHCSHDP(DUMMY,C2,SIGMAP*DEL2,2)
      CALL SNHCSHDP(SS,CS,SIGMAP*DELS,3)
      S5 = S5 + (YP(IU)*DEL1*DEL1* (C1-SS/2.D0)+
     +     YP(IUM1)* (DELS*DELS* (CS-SS/2.D0)-DEL2*DEL2* (C2-SS/2.D0)))/
     +     (SIGMAP*SIGMAP*DELS* (1.D0+SS))
      GO TO 13
   12 S5 = S5 - T1* (DEL2* (DEL1+DELS)+DELS*DELS)*YP(IU)/12.D0 -
     +     T2*T2*DELS*YP(IUM1)/6.D0
   13 S6 = 0.D0
      IF (XXU.GE.XIU .OR. (IDELTP.EQ.0.AND..NOT.BDY)) GO TO 15
c
c integrate from xxu to xiu, store in s6
c
      DEL1 = XXU - X(IUM1)
      DEL2 = XIU - XXU
      DELS = XIU - X(IUM1)
      T1 = (DEL1+DELS)*DEL2/ (2.D0*DELS)
      T2 = DEL2*DEL2/ (2.D0*DELS)
      S6 = T1*Y(IU) + T2*Y(IUM1)
      IF (SIGMA.EQ.0.D0) GO TO 14
      CALL SNHCSHDP(DUMMY,C1,SIGMAP*DEL1,2)
      CALL SNHCSHDP(DUMMY,C2,SIGMAP*DEL2,2)
      CALL SNHCSHDP(SS,CS,SIGMAP*DELS,3)
      S6 = S6 + ((DELS*DELS* (CS-SS/2.D0)-DEL1*DEL1* (C1-SS/2.D0))*
     +     YP(IU)+DEL2*DEL2* (C2-SS/2.D0)*YP(IUM1))/
     +     (SIGMAP*SIGMAP*DELS* (1.D0+SS))
      GO TO 15
   14 S6 = S6 - T1*T1*DELS*YP(IU)/6.D0 -
     +     T2* (DEL1* (DEL2+DELS)+DELS*DELS)*YP(IUM1)/12.D0
   15 S7 = 0.D0
      IF (IU.EQ.1 .OR. (IDELTP.EQ.0.AND..NOT.BDY)) GO TO 18
c
c integrate from xiu to x1pp, store in s7
c
      NP1 = N + 1
      IUP1 = IU + 1
      DO 17 II = IUP1,NP1
          IM1 = II - 1
          I = II
          IF (I.EQ.NP1) I = 1
          DELS = X(I) - X(IM1)
          IF (DELS.LE.0.D0) DELS = DELS + P
          S7 = S7 + (Y(I)+Y(IM1))*DELS/2.D0
          IF (SIGMA.EQ.0.D0) GO TO 16
          CALL SNHCSHDP(SS,CS,SIGMAP*DELS,3)
          S7 = S7 + (YP(I)+YP(IM1))*DELS* (CS-SS/2.D0)/
     +         (SIGMAP*SIGMAP* (1.D0+SS))
          GO TO 17
   16     S7 = S7 - (YP(I)+YP(IM1))*DELS*DELS*DELS/24.D0
   17 CONTINUE
   18 S8 = 0.D0
      IF (ILM1.LT.IUM1 .OR. (IDELTP.EQ.0.AND.BDY)) GO TO 20
c
c integrate from xxl to xxu, store in s8
c
      DELU1 = XXU - X(IUM1)
      DELU2 = XIU - XXU
      DELL1 = XXL - X(IUM1)
      DELL2 = XIU - XXL
      DELS = XIU - X(IUM1)
      DELI = XXU - XXL
      T1 = (DELU1+DELL1)*DELI/ (2.D0*DELS)
      T2 = (DELU2+DELL2)*DELI/ (2.D0*DELS)
      S8 = T1*Y(IU) + T2*Y(IUM1)
      IF (SIGMA.EQ.0.D0) GO TO 19
      CALL SNHCSHDP(DUMMY,CU1,SIGMAP*DELU1,2)
      CALL SNHCSHDP(DUMMY,CU2,SIGMAP*DELU2,2)
      CALL SNHCSHDP(DUMMY,CL1,SIGMAP*DELL1,2)
      CALL SNHCSHDP(DUMMY,CL2,SIGMAP*DELL2,2)
      CALL SNHCSHDP(SS,DUMMY,SIGMAP*DELS,-1)
      S8 = S8 + (YP(IU)* (DELU1*DELU1* (CU1-SS/2.D0)-DELL1*DELL1* (CL1-
     +     SS/2.D0))+YP(IUM1)* (DELL2*DELL2* (CL2-SS/2.D0)-
     +     DELU2*DELU2* (CU2-SS/2.D0)))/ (SIGMAP*SIGMAP*DELS* (1.D0+SS))
      GO TO 20
   19 S8 = S8 - T1* (DELU2* (DELS+DELU1)+DELL2* (DELS+DELL1))*YP(IU)/
     +     12.D0 - T2* (DELL1* (DELS+DELL2)+DELU1* (DELS+DELU2))*
     +     YP(IUM1)/12.D0
   20 SO = S1 + S2 + S6 + S7
      SI = S3 + S4 + S5 + S8
      IF (BDY) GO TO 21
      CURVPIDP = DBLE(IDELTP)* (SO+SI) + DBLE(ISIGN)*SI
      RETURN
   21 CURVPIDP = DBLE(IDELTP)* (SO+SI) + DBLE(ISIGN)*SO
      RETURN
      END

      SUBROUTINE CHEEVD( JOBZ, UPLO, N, A, LDA, W, WORK, LWORK, RWORK,
     $                   LRWORK, IWORK, LIWORK, INFO )
*
*  -- LAPACK driver routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          JOBZ, UPLO
      INTEGER            INFO, LDA, LIWORK, LRWORK, LWORK, N
*     ..
*     .. Array Arguments ..
      INTEGER            IWORK( * )
      REAL               RWORK( * ), W( * )
      COMPLEX            A( LDA, * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  CHEEVD computes all eigenvalues and, optionally, eigenvectors of a
*  complex Hermitian matrix A.  If eigenvectors are desired, it uses a
*  divide and conquer algorithm.
*
*  The divide and conquer algorithm makes very mild assumptions about
*  floating point arithmetic. It will work on machines with a guard
*  digit in add/subtract, or on those binary machines without guard
*  digits which subtract like the Cray X-MP, Cray Y-MP, Cray C-90, or
*  Cray-2. It could conceivably fail on hexadecimal or decimal machines
*  without guard digits, but we know of none.
*
*  Arguments
*  =========
*
*  JOBZ    (input) CHARACTER*1
*          = 'N':  Compute eigenvalues only;
*          = 'V':  Compute eigenvalues and eigenvectors.
*
*  UPLO    (input) CHARACTER*1
*          = 'U':  Upper triangle of A is stored;
*          = 'L':  Lower triangle of A is stored.
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  A       (input/output) COMPLEX array, dimension (LDA, N)
*          On entry, the Hermitian matrix A.  If UPLO = 'U', the
*          leading N-by-N upper triangular part of A contains the
*          upper triangular part of the matrix A.  If UPLO = 'L',
*          the leading N-by-N lower triangular part of A contains
*          the lower triangular part of the matrix A.
*          On exit, if JOBZ = 'V', then if INFO = 0, A contains the
*          orthonormal eigenvectors of the matrix A.
*          If JOBZ = 'N', then on exit the lower triangle (if UPLO='L')
*          or the upper triangle (if UPLO='U') of A, including the
*          diagonal, is destroyed.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(1,N).
*
*  W       (output) REAL array, dimension (N)
*          If INFO = 0, the eigenvalues in ascending order.
*
*  WORK    (workspace/output) COMPLEX array, dimension (LWORK)
*          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*
*  LWORK   (input) INTEGER
*          The length of the array WORK.
*          If N <= 1,                LWORK must be at least 1.
*          If JOBZ  = 'N' and N > 1, LWORK must be at least N + 1.
*          If JOBZ  = 'V' and N > 1, LWORK must be at least 2*N + N**2.
*
*          If LWORK = -1, then a workspace query is assumed; the routine
*          only calculates the optimal size of the WORK array, returns
*          this value as the first entry of the WORK array, and no error
*          message related to LWORK is issued by XERBLA.
*
*  RWORK   (workspace/output) REAL array,
*                                         dimension (LRWORK)
*          On exit, if INFO = 0, RWORK(1) returns the optimal LRWORK.
*
*  LRWORK  (input) INTEGER
*          The dimension of the array RWORK.
*          If N <= 1,                LRWORK must be at least 1.
*          If JOBZ  = 'N' and N > 1, LRWORK must be at least N.
*          If JOBZ  = 'V' and N > 1, LRWORK must be at least
*                         1 + 5*N + 2*N**2.
*
*          If LRWORK = -1, then a workspace query is assumed; the
*          routine only calculates the optimal size of the RWORK array,
*          returns this value as the first entry of the RWORK array, and
*          no error message related to LRWORK is issued by XERBLA.
*
*  IWORK   (workspace/output) INTEGER array, dimension (LIWORK)
*          On exit, if INFO = 0, IWORK(1) returns the optimal LIWORK.
*
*  LIWORK  (input) INTEGER
*          The dimension of the array IWORK.
*          If N <= 1,                LIWORK must be at least 1.
*          If JOBZ  = 'N' and N > 1, LIWORK must be at least 1.
*          If JOBZ  = 'V' and N > 1, LIWORK must be at least 3 + 5*N.
*
*          If LIWORK = -1, then a workspace query is assumed; the
*          routine only calculates the optimal size of the IWORK array,
*          returns this value as the first entry of the IWORK array, and
*          no error message related to LIWORK is issued by XERBLA.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*          > 0:  if INFO = i, the algorithm failed to converge; i
*                off-diagonal elements of an intermediate tridiagonal
*                form did not converge to zero.
*
*  Further Details
*  ===============
*
*  Based on contributions by
*     Jeff Rutter, Computer Science Division, University of California
*     at Berkeley, USA
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ZERO, ONE
      PARAMETER          ( ZERO = 0.0E0, ONE = 1.0E0 )
      COMPLEX            CONE
      PARAMETER          ( CONE = ( 1.0E0, 0.0E0 ) )
*     ..
*     .. Local Scalars ..
      LOGICAL            LOWER, LQUERY, WANTZ
      INTEGER            IINFO, IMAX, INDE, INDRWK, INDTAU, INDWK2,
     $                   INDWRK, ISCALE, LIOPT, LIWMIN, LLRWK, LLWORK,
     $                   LLWRK2, LOPT, LROPT, LRWMIN, LWMIN
      REAL               ANRM, BIGNUM, EPS, RMAX, RMIN, SAFMIN, SIGMA,
     $                   SMLNUM
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      REAL               CLANHE, SLAMCH
      EXTERNAL           LSAME, CLANHE, SLAMCH
*     ..
*     .. External Subroutines ..
      EXTERNAL           CHETRD, CLACPY, CLASCL, CSTEDC, CUNMTR, SSCAL,
     $                   SSTERF, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          INT, MAX, REAL, SQRT
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      WANTZ = LSAME( JOBZ, 'V' )
      LOWER = LSAME( UPLO, 'L' )
      LQUERY = ( LWORK.EQ.-1 .OR. LRWORK.EQ.-1 .OR. LIWORK.EQ.-1 )
*
      INFO = 0
      IF( N.LE.1 ) THEN
         LWMIN = 1
         LRWMIN = 1
         LIWMIN = 1
         LOPT = LWMIN
         LROPT = LRWMIN
         LIOPT = LIWMIN
      ELSE
         IF( WANTZ ) THEN
            LWMIN = 2*N + N*N
            LRWMIN = 1 + 5*N + 2*N**2
            LIWMIN = 3 + 5*N
         ELSE
            LWMIN = N + 1
            LRWMIN = N
            LIWMIN = 1
         END IF
         LOPT = LWMIN
         LROPT = LRWMIN
         LIOPT = LIWMIN
      END IF
      IF( .NOT.( WANTZ .OR. LSAME( JOBZ, 'N' ) ) ) THEN
         INFO = -1
      ELSE IF( .NOT.( LOWER .OR. LSAME( UPLO, 'U' ) ) ) THEN
         INFO = -2
      ELSE IF( N.LT.0 ) THEN
         INFO = -3
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -5
      ELSE IF( LWORK.LT.LWMIN .AND. .NOT.LQUERY ) THEN
         INFO = -8
      ELSE IF( LRWORK.LT.LRWMIN .AND. .NOT.LQUERY ) THEN
         INFO = -10
      ELSE IF( LIWORK.LT.LIWMIN .AND. .NOT.LQUERY ) THEN
         INFO = -12
      END IF
*
      IF( INFO.EQ.0 ) THEN
         WORK( 1 ) = LOPT
         RWORK( 1 ) = LROPT
         IWORK( 1 ) = LIOPT
      END IF
*
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'CHEEVD', -INFO )
         RETURN 
      ELSE IF( LQUERY ) THEN
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
*
      IF( N.EQ.1 ) THEN
         W( 1 ) = A( 1, 1 )
         IF( WANTZ )
     $      A( 1, 1 ) = CONE
         RETURN
      END IF
*
*     Get machine constants.
*
      SAFMIN = SLAMCH( 'Safe minimum' )
      EPS = SLAMCH( 'Precision' )
      SMLNUM = SAFMIN / EPS
      BIGNUM = ONE / SMLNUM
      RMIN = SQRT( SMLNUM )
      RMAX = SQRT( BIGNUM )
*
*     Scale matrix to allowable range, if necessary.
*
      ANRM = CLANHE( 'M', UPLO, N, A, LDA, RWORK )
      ISCALE = 0
      IF( ANRM.GT.ZERO .AND. ANRM.LT.RMIN ) THEN
         ISCALE = 1
         SIGMA = RMIN / ANRM
      ELSE IF( ANRM.GT.RMAX ) THEN
         ISCALE = 1
         SIGMA = RMAX / ANRM
      END IF
      IF( ISCALE.EQ.1 )
     $   CALL CLASCL( UPLO, 0, 0, ONE, SIGMA, N, N, A, LDA, INFO )
*
*     Call CHETRD to reduce Hermitian matrix to tridiagonal form.
*
      INDE = 1
      INDTAU = 1
      INDWRK = INDTAU + N
      INDRWK = INDE + N
      INDWK2 = INDWRK + N*N
      LLWORK = LWORK - INDWRK + 1
      LLWRK2 = LWORK - INDWK2 + 1
      LLRWK = LRWORK - INDRWK + 1
      CALL CHETRD( UPLO, N, A, LDA, W, RWORK( INDE ), WORK( INDTAU ),
     $             WORK( INDWRK ), LLWORK, IINFO )
      LOPT = MAX( REAL( LOPT ), REAL( N )+REAL( WORK( INDWRK ) ) )
*
*     For eigenvalues only, call SSTERF.  For eigenvectors, first call
*     CSTEDC to generate the eigenvector matrix, WORK(INDWRK), of the
*     tridiagonal matrix, then call CUNMTR to multiply it to the
*     Householder transformations represented as Householder vectors in
*     A.
*
      IF( .NOT.WANTZ ) THEN
         CALL SSTERF( N, W, RWORK( INDE ), INFO )
      ELSE
         CALL CSTEDC( 'I', N, W, RWORK( INDE ), WORK( INDWRK ), N,
     $                WORK( INDWK2 ), LLWRK2, RWORK( INDRWK ), LLRWK,
     $                IWORK, LIWORK, INFO )
         CALL CUNMTR( 'L', UPLO, 'N', N, N, A, LDA, WORK( INDTAU ),
     $                WORK( INDWRK ), N, WORK( INDWK2 ), LLWRK2, IINFO )
         CALL CLACPY( 'A', N, N, WORK( INDWRK ), N, A, LDA )
         LOPT = MAX( LOPT, N+N**2+INT( WORK( INDWK2 ) ) )
      END IF
*
*     If matrix was scaled, then rescale eigenvalues appropriately.
*
      IF( ISCALE.EQ.1 ) THEN
         IF( INFO.EQ.0 ) THEN
            IMAX = N
         ELSE
            IMAX = INFO - 1
         END IF
         CALL SSCAL( IMAX, ONE / SIGMA, W, 1 )
      END IF
*
      WORK( 1 ) = LOPT
      RWORK( 1 ) = LROPT
      IWORK( 1 ) = LIOPT
*
      RETURN
*
*     End of CHEEVD
*
      END

      PROGRAM PGKEX18
C
C  Produce an NX x NY  CELL ARRAY based on the Mandelbrot set--color
C  the cells depending upon the speed of convergence or divergence.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
      PARAMETER (NX=20, NY=20, NITER=101)
      INTEGER COLIA(NX,NY)
      COMPLEX Z
C
C  Region of interest.
C
      DATA XL,XR,YB,YT/-2.,.5,-1.25,1.25/
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF,IDUM)
      CALL GOPWK (IWKID,LUNIT,IWTYPE)
      CALL GACWK (IWKID)
C
C  Set up normalizaton transformation.
C
      CALL GSWN(1,XL,XR,YB,YT)
      CALL GSVP(1,.1,.9,0.,.8)
      CALL GSELNT(1)
C
C  Define color indices in a continuous spectrum.
C
      DO 11 K = 1,NITER
        H = REAL(K)/REAL(NITER)*360.
        CALL HLSRGB(H,50.,100.,RV,GV,BV)
        CALL GSCR(IWKID,K,RV,GV,BV)
   11 CONTINUE
      CALL GSCR(IWKID,NITER+1,0.,0.,1.)
C
C  Set up the cell array and call GCA.
C
      DX = (XR-XL)/NX
      DY = (YT-YB)/NY
      DO 10 J=1,NY
        Y = YB+DY*REAL(J-1)
        DO 20 I=1,NX
          X = XL+DX*REAL(I-1)
          Z = CMPLX(X,Y)
          CALL CONVG(Z,NITER,.001,10000.,ITER)
          COLIA(I,J) = ITER
   20   CONTINUE
   10 CONTINUE
      CALL GCA(XL,YB,XR,YT,NX,NY,1,1,NX,NY,COLIA)
C
C  Label the plot using Plotchar.
C
      CALL GSCLIP(0)
      CALL PCSETI('FN',25)
      CALL PCSETI('CC',NITER+1)
      CALL PLCHHQ(XL+.5*(XR-XL),YB+(YT-YB)*1.07,'Cell array',.033,0.,0.)
      CALL FRAME
C
C  Deactivate and close the workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C	
      STOP
      END
      SUBROUTINE CONVG(Z,NUM,TOLSM,TOLLG,ITER)
C
C  Iterate Z(N+1) = Z(N)**2+Z0 for N=1,...,NUM .  If the complex absolute
C  values get smaller than TOLSM, then set ITER equal to the number of
C  iterations and return.  If the complex absolute value gets larger than
C  TOLLG, set ITER to NUM and return.
C
      COMPLEX Z,ZS,ZN,ZO
      ZS = Z
      ZO = Z
      DO 10 I=1,NUM
        ZN = ZO*ZO+ZS
        IF (CABS(ZN-ZO) .LT. TOLSM) THEN
          ITER = I
          RETURN
        ELSE IF (CABS(ZN-ZO) .GT. TOLLG) THEN
          ITER = I
          RETURN
        ENDIF
        ZO = ZN
   10 CONTINUE
      ITER=NUM
      RETURN
      END

      PROGRAM FTEX04
C
C  Example of KURV1, KURV2, KURVD.
C
      PARAMETER (IDIM=11,IOUT=201,IDTEMP=9*IDIM)
      DIMENSION X(IDIM),Y(IDIM),TEMP(IDTEMP),U(IOUT),XO(IOUT),YO(IOUT),
     +          XS(IOUT),YS(IOUT),XD(IOUT),YD(IOUT),XDD(IOUT),YDD(IOUT)       
      DIMENSION XP(IDIM),YP(IDIM),S(IDIM)
C
      DATA X/ 3.,  4.,  9., 16., 21., 27., 34., 36., 34., 26., 18./
      DATA Y/ 2.4,  9.6, 14.4, 12.0,  9.6,  8.4, 
     +       13.2, 21.6, 30.0, 37.2, 38.4/
C
C  Do KURV1 set up.
C
      SIGMA = 1.
      ISF   = 3
      CALL KURV1(IDIM,X,Y,SLOP1,SLOP2,ISF,XP,YP,TEMP,S,SIGMA,IERR)
      IF (IERR .NE. 0) THEN
        PRINT *, 'Error return from KURV1 =',IERR
        STOP
      ENDIF
C
C  Get interpolated points using KURV2.
C
      TINC = 1.0/(IOUT-1)
      DO 10 I=1,IOUT
        U(I) = (I-1)*TINC
        CALL KURV2(U(I),XO(I),YO(I),IDIM,X,Y,XP,YP,S,SIGMA)
   10 CONTINUE
C
C  Get the derivatives.
C
      DO 20 I=1,IOUT
        CALL KURVD(U(I),XS(I),YS(I),XD(I),YD(I),XDD(I),YDD(I),
     +             IDIM,X,Y,XP,YP,S,SIGMA)
   20 CONTINUE
C
C  Draw plot.
C
      CALL DRWFT4(IDIM,X,Y,IOUT,XO,YO,U,XD,YD)
C
      STOP
      END
      SUBROUTINE DRWFT4(II,X,Y,IOUT,XO,YO,U,XD,YD)
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C  Define a color table.
C
      CALL GSCR(IWKID, 0, 1.0, 1.0, 1.0)
      CALL GSCR(IWKID, 1, 0.0, 0.0, 0.0)
      CALL GSCR(IWKID, 2, 1.0, 0.0, 0.0)
      CALL GSCR(IWKID, 3, 0.0, 1.0, 0.0)
      CALL GSCR(IWKID, 4, 0.0, 0.0, 1.0)
C
C  Draw markers at original points.
C
      CALL BKGFT4(0.,40.,0.,40.,0.15,0.85,'Demo for KURV1/KURV2',0.035,
     +            0.5,0.93,0)
      CALL GRIDAL(4,5,4,5,1,1,10,0.,0.)
      CALL GSMKSC(2.)
      CALL GSPMCI(4)
      CALL GPM(II,X,Y)
C
C  Draw the interpolated curve
C
      CALL CURVE(XO,YO,IOUT)
      CALL FRAME
C
C  Plot the first derivatives of X and Y with respect to the parametric
C  variable U.
C
      CALL SET(0.,1.,0.,1.,0.,1.,0.,1.,1)
      CALL PCSETI('FN',21)
      CALL PLCHHQ(0.5,0.95,'Derivatives from KURVD',0.035,0.,0.)
      CALL BKGFT4(0.,1.,-80.,80.,0.55,0.87,'dx/du',0.030,0.65,0.82,1)
      CALL GRIDAL(5,5,4,5,1,1,10,0.,-80.)
      CALL CURVE(U,XD,IOUT)
      CALL BKGFT4(0.,1.,-40.,80.,0.10,0.42,'dy/du',0.030,0.39,0.37,1)
      CALL GRIDAL(5,5,3,5,1,1,10,0.,-40.)
      CALL CURVE(U,YD,IOUT)
      CALL FRAME
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      RETURN
      END
      SUBROUTINE BKGFT4(XL,XR,YB,YT,YPB,YPT,LABEL,SIZL,POSXL,POSYL,IZL)
      DIMENSION XX(2),YY(2)
      CHARACTER*(*) LABEL
C
      CALL SET(0.,1.,0.,1.,0.,1.,0.,1.,1)
      CALL PCSETI('FN',21)
      CALL PLCHHQ(POSXL,POSYL,LABEL,SIZL,0.,0.)
      CALL SET(0.17,0.87,YPB,YPT,XL,XR,YB,YT,1)
      IF (IZL .NE. 0) THEN
        XX(1) = XL
        XX(2) = XR
        YY(1) = 0.
        YY(2) = 0.
        CALL GSPLCI(2)
        CALL GPL(2,XX,YY)
        CALL GSPLCI(1)
      ENDIF
C 
      CALL GASETI('LTY',1)
      CALL PCSETI('FN',21)
      CALL GASETR('XLS',0.02)
      CALL GASETC('XLF','(F4.1)')
      CALL GASETR('YLS',0.02)
      CALL GASETC('YLF','(F5.1)')
      CALL GASETR('XMJ',0.02)
      CALL GASETR('YMJ',0.02)
C
      RETURN
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C   FFTPACK 5.0
C   Copyright (C) 1995-2004, Scientific Computing Division,
C   University Corporation for Atmospheric Research
C   Licensed under the GNU General Public License (GPL)
C
C   Authors:  Paul N. Swarztrauber and Richard A. Valent
C
C   $Id: mcstf1.f,v 1.2 2006-11-21 01:10:17 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      SUBROUTINE DMCSTF1(LOT,JUMP,N,INC,X,WSAVE,DSUM,WORK,IER)
      DOUBLE PRECISION WORK
      DOUBLE PRECISION X1H
      DOUBLE PRECISION X1P3
      DOUBLE PRECISION TX2
      DOUBLE PRECISION T1
      DOUBLE PRECISION T2
      DOUBLE PRECISION SNM1
      DOUBLE PRECISION XI
      DOUBLE PRECISION X(INC,*),WSAVE(*)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION DSUM(*)

      IER = 0
      NM1 = N - 1
      NP1 = N + 1
      NS2 = N/2
      LJ = (LOT-1)*JUMP + 1
      IF (N-2) 200,101,102
  101 DO 111 M = 1,LJ,JUMP
          X1H = X(M,1) + X(M,2)
          X(M,2) = .5D0* (X(M,1)-X(M,2))
          X(M,1) = .5D0*X1H
  111 CONTINUE
      GO TO 200
  102 IF (N.GT.3) GO TO 103
      DO 112 M = 1,LJ,JUMP
          X1P3 = X(M,1) + X(M,3)
          TX2 = X(M,2) + X(M,2)
          X(M,2) = .5D0* (X(M,1)-X(M,3))
          X(M,1) = .25D0* (X1P3+TX2)
          X(M,3) = .25D0* (X1P3-TX2)
  112 CONTINUE
      GO TO 200
  103 M1 = 0
      DO 113 M = 1,LJ,JUMP
          M1 = M1 + 1
          DSUM(M1) = X(M,1) - X(M,N)
          X(M,1) = X(M,1) + X(M,N)
  113 CONTINUE
      DO 104 K = 2,NS2
          M1 = 0
          DO 114 M = 1,LJ,JUMP
              M1 = M1 + 1
              KC = NP1 - K
              T1 = X(M,K) + X(M,KC)
              T2 = X(M,K) - X(M,KC)
              DSUM(M1) = DSUM(M1) + WSAVE(KC)*T2
              T2 = WSAVE(K)*T2
              X(M,K) = T1 - T2
              X(M,KC) = T1 + T2
  114     CONTINUE
  104 CONTINUE
      MODN = MOD(N,2)
      IF (MODN.EQ.0) GO TO 124
      DO 123 M = 1,LJ,JUMP
          X(M,NS2+1) = X(M,NS2+1) + X(M,NS2+1)
  123 CONTINUE
  124 CONTINUE
      LENX = (LOT-1)*JUMP + INC* (NM1-1) + 1
      LNSV = NM1 + INT(LOG(DBLE(NM1))) + 4
      LNWK = LOT*NM1
C
      CALL DRFFTMF(LOT,JUMP,NM1,INC,X,LENX,WSAVE(N+1),LNSV,WORK,LNWK,
     +            IER1)
      IF (IER1.NE.0) THEN
          IER = 20
          CALL DXERFFT('MCSTF1',-5)
          GO TO 200
      END IF
C
      SNM1 = 1.D0/DBLE(NM1)
      DO 10 M = 1,LOT
          DSUM(M) = SNM1*DSUM(M)
   10 CONTINUE
      IF (MOD(NM1,2).NE.0) GO TO 30
      DO 20 M = 1,LJ,JUMP
          X(M,NM1) = X(M,NM1) + X(M,NM1)
   20 CONTINUE
   30 DO 105 I = 3,N,2
          M1 = 0
          DO 115 M = 1,LJ,JUMP
              M1 = M1 + 1
              XI = .5D0*X(M,I)
              X(M,I) = .5D0*X(M,I-1)
              X(M,I-1) = DSUM(M1)
              DSUM(M1) = DSUM(M1) + XI
  115     CONTINUE
  105 CONTINUE
      IF (MODN.NE.0) GO TO 117
      M1 = 0
      DO 116 M = 1,LJ,JUMP
          M1 = M1 + 1
          X(M,N) = DSUM(M1)
  116 CONTINUE
  117 DO 118 M = 1,LJ,JUMP
          X(M,1) = .5D0*X(M,1)
          X(M,N) = .5D0*X(M,N)
  118 CONTINUE
C
  200 CONTINUE
      RETURN
      END

C
C $Id: idgrid.f,v 1.5 2008-07-27 00:17:30 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE IDGRID (XD,YD,NT,IPT,NL,IPL,NXI,NYI,XI,YI,NGP,IGP)
C
C This subroutine organizes grid points for surface fitting by
C sorting them in ascending order of triangle number or border
C line segment number.
C
C The input arguments are as follows:
C
C   XD,YD  arrays of dimension NDP containing the X and Y
C          coordinates of the data points, where NDP is the
C          number of the data points.
C
C   NT     number of triangles.
C
C   IPT    integer array of dimension 3*NT containing the
C          point numbers of the vertices of the triangles.
C
C   NL     number of border line segments.
C
C   IPL    integer array of dimension 3*NL containing the
C          point numbers of the end points of the border
C          line segments and their respective triangle
C          numbers.
C
C   NXI    number of grid points in the X coordinate.
C
C   NYI    number of grid points in the Y coordinate.
C
C   XI,YI  arrays of dimension NXI and NYI containing
C          the X and Y coordinates of the grid points,
C          respectively.
C
C The output arguments are as follows:
C
C   NGP    integer array of dimension 2*(NT+2*NL) where the
C          number of grid points that belong to each of the
C          triangles or of the border line segments are to
C          be stored.
C
C   IGP    integer array of dimension NXI*NYI where the
C          grid point numbers are to be stored in ascending
C          order of the triangle number or border line
C          segment number.
C
C Declaration statements:
C
      DIMENSION XD(*),YD(*),IPT(*),IPL(*),XI(*),YI(*),NGP(*),IGP(*)
C
      COMMON /IDCOMN/ INTY,ITTY,ALSP,BLSP,CLSP,XAVG,YAVG
      SAVE   /IDCOMN/
C
C Statement functions.
C
      SPDT(U1,V1,U2,V2,U3,V3)=(U1-U2)*(U3-U2)+(V1-V2)*(V3-V2)
      VPDT(U1,V1,U2,V2,U3,V3)=(U1-U3)*(V2-V3)-(V1-V3)*(U2-U3)
C
C Preliminary processing.
C
      NXINYI=NXI*NYI
C
      XIMN=MIN(XI(1),XI(NXI))
      XIMX=MAX(XI(1),XI(NXI))
      YIMN=MIN(YI(1),YI(NYI))
      YIMX=MAX(YI(1),YI(NYI))
C
C Determine grid points inside the data area.
C
      JNGP0=0
      JNGP1=2*(NT+2*NL)+1
C
      JIGP0=0
      JIGP1=NXINYI+1
C
      DO 114 IT0=1,NT
C
        NGP0=0
        NGP1=0
C
        X1=XD(IPT(IT0*3-2))
        Y1=YD(IPT(IT0*3-2))
        X2=XD(IPT(IT0*3-1))
        Y2=YD(IPT(IT0*3-1))
        X3=XD(IPT(IT0*3))
        Y3=YD(IPT(IT0*3))
C
        XMN=MIN(X1,X2,X3)
        XMX=MAX(X1,X2,X3)
        YMN=MIN(Y1,Y2,Y3)
        YMX=MAX(Y1,Y2,Y3)
C
        INSD=0
C
        DO 102 IXI=1,NXI
          IF (XI(IXI).GE.XMN.AND.XI(IXI).LE.XMX) GO TO 101
          IF (INSD.EQ.0) GO TO 102
          IXIMX=IXI-1
          GO TO 103
  101     IF (INSD.EQ.1) GO TO 102
          INSD=1
          IXIMN=IXI
  102   CONTINUE
C
        IF (INSD.EQ.0) GO TO 113
C
        IXIMX=NXI
C
  103   DO 112 IYI=1,NYI
C
          YII=YI(IYI)
C
          IF (YII.LT.YMN.OR.YII.GT.YMX) GO TO 112
C
          DO 111  IXI=IXIMN,IXIMX
C
            XII=XI(IXI)
C
            L=0
            IF (VPDT(X1,Y1,X2,Y2,XII,YII)) 111,104,105
  104       L=1
  105       IF (VPDT(X2,Y2,X3,Y3,XII,YII)) 111,106,107
  106       L=1
  107       IF (VPDT(X3,Y3,X1,Y1,XII,YII)) 111,108,109
  108       L=1
  109       IZI=NXI*(IYI-1)+IXI
C
            IF (L.EQ.0) THEN
              NGP0=NGP0+1
              JIGP0=JIGP0+1
              IF (JIGP0.GE.JIGP1) THEN
                CALL SETER ('IDGRID (BIVAR) - INTERNAL ERROR - SEE CONSU
     +LTANT',1,1)
                RETURN
              END IF
              IGP(JIGP0)=IZI
            ELSE
              IF (JIGP1.LE.NXINYI) THEN
                DO 110 JIGP1I=JIGP1,NXINYI
                  IF (IZI.EQ.IGP(JIGP1I)) GO TO 111
  110           CONTINUE
              END IF
              NGP1=NGP1+1
              JIGP1=JIGP1-1
              IF (JIGP1.LE.JIGP0) THEN
                CALL SETER ('IDGRID (BIVAR) - INTERNAL ERROR - SEE CONSU
     +LTANT',2,1)
                RETURN
              END IF
              IGP(JIGP1)=IZI
            END IF
C
  111     CONTINUE
C
  112   CONTINUE
C
  113   JNGP0=JNGP0+1
        NGP(JNGP0)=NGP0
C
        JNGP1=JNGP1-1
        NGP(JNGP1)=NGP1
C
  114 CONTINUE
C
C If linear interpolation is selected, jump to do the semi-infinite
C quadrangular areas formed by rays emanating from (XAVG,YAVG).
C
      IF (INTY.NE.0) GO TO 300
C
C Determine grid points outside the data area in each of the
C semi-infinite rectangular and triangular areas.
C
      DO 263 IL0=1,NL
C
C Rectangular area ...
C
        NGP0=0
        NGP1=0
C
        X1=XD(IPL(IL0*3-2))
        Y1=YD(IPL(IL0*3-2))
        X2=XD(IPL(IL0*3-1))
        Y2=YD(IPL(IL0*3-1))
C
        XMN=XIMN
        XMX=XIMX
        YMN=YIMN
        YMX=YIMX
C
        IF (Y2.GE.Y1) XMN=MIN(X1,X2)
        IF (Y2.LE.Y1) XMX=MAX(X1,X2)
        IF (X2.LE.X1) YMN=MIN(Y1,Y2)
        IF (X2.GE.X1) YMX=MAX(Y1,Y2)
C
        INSD=0
C
        DO 202 IXI=1,NXI
          IF (XI(IXI).GE.XMN.AND.XI(IXI).LE.XMX) GO TO 201
          IF (INSD.EQ.0) GO TO 202
          IXIMX=IXI-1
          GO TO 203
  201     IF (INSD.EQ.1) GO TO 202
          INSD=1
          IXIMN=IXI
  202   CONTINUE
C
        IF (INSD.EQ.0) GO TO 213
C
        IXIMX=NXI
C
  203   DO 212 IYI=1,NYI
C
          YII=YI(IYI)
C
          IF (YII.LT.YMN.OR.YII.GT.YMX) GO TO 212
C
          DO 211 IXI=IXIMN,IXIMX
C
            XII=XI(IXI)
C
            L=0
            IF (VPDT(X1,Y1,X2,Y2,XII,YII)) 205,204,211
  204       L=1
  205       IF (SPDT(X2,Y2,X1,Y1,XII,YII)) 211,206,207
  206       L=1
  207       IF (SPDT(X1,Y1,X2,Y2,XII,YII)) 211,208,209
  208       L=1
  209       IZI=NXI*(IYI-1)+IXI
C
            IF (L.EQ.0) THEN
              NGP0=NGP0+1
              JIGP0=JIGP0+1
              IF (JIGP0.GE.JIGP1) THEN
                CALL SETER ('IDGRID (BIVAR) - INTERNAL ERROR - SEE CONSU
     +LTANT',3,1)
                RETURN
              END IF
              IGP(JIGP0)=IZI
            ELSE
              IF (JIGP1.LE.NXINYI) THEN
                DO 210 JIGP1I=JIGP1,NXINYI
                  IF (IZI.EQ.IGP(JIGP1I)) GO TO 211
  210           CONTINUE
              END IF
              NGP1=NGP1+1
              JIGP1=JIGP1-1
              IF (JIGP1.LE.JIGP0) THEN
                CALL SETER ('IDGRID (BIVAR) - INTERNAL ERROR - SEE CONSU
     +LTANT',4,1)
                RETURN
              END IF
              IGP(JIGP1)=IZI
            END IF
C
  211     CONTINUE
C
  212   CONTINUE
C
  213   JNGP0=JNGP0+1
        NGP(JNGP0)=NGP0
C
        JNGP1=JNGP1-1
        NGP(JNGP1)=NGP1
C
C Triangular area ...
C
        NGP0=0
        NGP1=0
C
        ILP1=MOD(IL0,NL)+1
C
        X3=XD(IPL(ILP1*3-1))
        Y3=YD(IPL(ILP1*3-1))
C
        XMN=XIMN
        XMX=XIMX
        YMN=YIMN
        YMX=YIMX
C
        IF (Y3.GE.Y2.AND.Y2.GE.Y1) XMN=X2
        IF (Y3.LE.Y2.AND.Y2.LE.Y1) XMX=X2
        IF (X3.LE.X2.AND.X2.LE.X1) YMN=Y2
        IF (X3.GE.X2.AND.X2.GE.X1) YMX=Y2
C
        INSD=0
C
        DO 252 IXI=1,NXI
          IF (XI(IXI).GE.XMN.AND.XI(IXI).LE.XMX) GO TO 251
          IF (INSD.EQ.0) GO TO 252
          IXIMX=IXI-1
          GO TO 253
  251     IF (INSD.EQ.1) GO TO 252
          INSD=1
          IXIMN=IXI
  252   CONTINUE
C
        IF (INSD.EQ.0) GO TO 261
C
        IXIMX=NXI
C
  253   DO 260 IYI=1,NYI
C
          YII=YI(IYI)
C
          IF (YII.LT.YMN.OR.YII.GT.YMX) GO TO 260
C
          DO 259 IXI=IXIMN,IXIMX
C
            XII=XI(IXI)
C
            L=0
            IF (SPDT(X1,Y1,X2,Y2,XII,YII)) 255,254,259
  254       L=1
  255       IF (SPDT(X3,Y3,X2,Y2,XII,YII)) 257,256,259
  256       L=1
  257       IZI=NXI*(IYI-1)+IXI
C
            IF (L.EQ.0) THEN
              NGP0=NGP0+1
              JIGP0=JIGP0+1
              IF (JIGP0.GE.JIGP1) THEN
                CALL SETER ('IDGRID (BIVAR) - INTERNAL ERROR - SEE CONSU
     +LTANT',5,1)
                RETURN
              END IF
              IGP(JIGP0)=IZI
            ELSE
              IF (JIGP1.LE.NXINYI) THEN
                DO 258 JIGP1I=JIGP1,NXINYI
                  IF (IZI.EQ.IGP(JIGP1I)) GO TO 259
  258           CONTINUE
              END IF
              NGP1=NGP1+1
              JIGP1=JIGP1-1
              IF (JIGP1.LE.JIGP0) THEN
                CALL SETER ('IDGRID (BIVAR) - INTERNAL ERROR - SEE CONSU
     +LTANT',6,1)
                RETURN
              END IF
              IGP(JIGP1)=IZI
            END IF
C
  259     CONTINUE
C
  260   CONTINUE
C
  261   JNGP0=JNGP0+1
        NGP(JNGP0)=NGP0
C
        JNGP1=JNGP1-1
        NGP(JNGP1)=NGP1
C
  263 CONTINUE
C
      RETURN
C
C Linear interpolation was selected.  Examine semi-infinite quadrangular
C areas formed by rays emanating from (XAVG,YAVG) and passing through
C the endpoints of a line segment on the edge of the data area.
C
  300 DO 314 IL0=1,NL
C
        NGP0=0
        NGP1=0
C
        X1=XD(IPL(IL0*3-2))
        Y1=YD(IPL(IL0*3-2))
        X2=XD(IPL(IL0*3-1))
        Y2=YD(IPL(IL0*3-1))
C
        XMN=XIMN
        XMX=XIMX
        YMN=YIMN
        YMX=YIMX
C
        IF (XAVG.LE.X1.AND.XAVG.LE.X2) XMN=MIN(X1,X2)
        IF (XAVG.GE.X1.AND.XAVG.GE.X2) XMX=MAX(X1,X2)
        IF (YAVG.LE.Y1.AND.YAVG.LE.Y2) YMN=MIN(Y1,Y2)
        IF (YAVG.GE.Y1.AND.YAVG.GE.Y2) YMX=MAX(Y1,Y2)
C
        INSD=0
C
        DO 302 IXI=1,NXI
          IF (XI(IXI).GE.XMN.AND.XI(IXI).LE.XMX) GO TO 301
          IF (INSD.EQ.0) GO TO 302
          IXIMX=IXI-1
          GO TO 303
  301     IF (INSD.EQ.1) GO TO 302
          INSD=1
          IXIMN=IXI
  302   CONTINUE
C
        IF (INSD.EQ.0) GO TO 313
C
        IXIMX=NXI
C
  303   DO 312 IYI=1,NYI
C
          YII=YI(IYI)
C
          IF (YII.LT.YMN.OR.YII.GT.YMX) GO TO 312
C
          DO 311 IXI=IXIMN,IXIMX
C
            XII=XI(IXI)
C
            L=0
            IF (VPDT(X1  ,Y1  ,X2,Y2,XII,YII)) 305,304,311
  304       L=1
  305       IF (VPDT(XAVG,YAVG,X1,Y1,XII,YII)) 311,306,307
  306       L=1
  307       IF (VPDT(XAVG,YAVG,X2,Y2,XII,YII)) 309,308,311
  308       L=1
  309       IZI=NXI*(IYI-1)+IXI
C
            IF (L.EQ.0) THEN
              NGP0=NGP0+1
              JIGP0=JIGP0+1
              IGP(JIGP0)=IZI
            ELSE
              IF (JIGP1.LE.NXINYI) THEN
                DO 310 JIGP1I=JIGP1,NXINYI
                  IF (IZI.EQ.IGP(JIGP1I)) GO TO 311
  310           CONTINUE
              END IF
              NGP1=NGP1+1
              JIGP1=JIGP1-1
              IGP(JIGP1)=IZI
            END IF
C
  311     CONTINUE
C
  312   CONTINUE
C
  313   JNGP0=JNGP0+1
        NGP(JNGP0)=NGP0
C
        JNGP1=JNGP1-1
        NGP(JNGP1)=NGP1
C
        JNGP0=JNGP0+1
        NGP(JNGP0)=0
C
        JNGP1=JNGP1-1
        NGP(JNGP1)=0
C
  314 CONTINUE
C
      RETURN
C
      END

      SUBROUTINE DLARGV( N, X, INCX, Y, INCY, C, INCC )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      INTEGER            INCC, INCX, INCY, N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   C( * ), X( * ), Y( * )
*     ..
*
*  Purpose
*  =======
*
*  DLARGV generates a vector of real plane rotations, determined by
*  elements of the real vectors x and y. For i = 1,2,...,n
*
*     (  c(i)  s(i) ) ( x(i) ) = ( a(i) )
*     ( -s(i)  c(i) ) ( y(i) ) = (   0  )
*
*  Arguments
*  =========
*
*  N       (input) INTEGER
*          The number of plane rotations to be generated.
*
*  X       (input/output) DOUBLE PRECISION array,
*                         dimension (1+(N-1)*INCX)
*          On entry, the vector x.
*          On exit, x(i) is overwritten by a(i), for i = 1,...,n.
*
*  INCX    (input) INTEGER
*          The increment between elements of X. INCX > 0.
*
*  Y       (input/output) DOUBLE PRECISION array,
*                         dimension (1+(N-1)*INCY)
*          On entry, the vector y.
*          On exit, the sines of the plane rotations.
*
*  INCY    (input) INTEGER
*          The increment between elements of Y. INCY > 0.
*
*  C       (output) DOUBLE PRECISION array, dimension (1+(N-1)*INCC)
*          The cosines of the plane rotations.
*
*  INCC    (input) INTEGER
*          The increment between elements of C. INCC > 0.
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO, ONE
      PARAMETER          ( ZERO = 0.0D+0, ONE = 1.0D+0 )
*     ..
*     .. Local Scalars ..
      INTEGER            I, IC, IX, IY
      DOUBLE PRECISION   F, G, T, TT
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, SQRT
*     ..
*     .. Executable Statements ..
*
      IX = 1
      IY = 1
      IC = 1
      DO 10 I = 1, N
         F = X( IX )
         G = Y( IY )
         IF( G.EQ.ZERO ) THEN
            C( IC ) = ONE
         ELSE IF( F.EQ.ZERO ) THEN
            C( IC ) = ZERO
            Y( IY ) = ONE
            X( IX ) = G
         ELSE IF( ABS( F ).GT.ABS( G ) ) THEN
            T = G / F
            TT = SQRT( ONE+T*T )
            C( IC ) = ONE / TT
            Y( IY ) = T*C( IC )
            X( IX ) = F*TT
         ELSE
            T = F / G
            TT = SQRT( ONE+T*T )
            Y( IY ) = ONE / TT
            C( IC ) = T*Y( IY )
            X( IX ) = G*TT
         END IF
         IC = IC + INCC
         IY = IY + INCY
         IX = IX + INCX
   10 CONTINUE
      RETURN
*
*     End of DLARGV
*
      END

C NCLFORTSTART
      subroutine dzhgtdrv(mlon,nlat,klvl
     +                   ,z,zsfc,zmsg,ztop,dz,iopt,ier)
      implicit none
C                                                ! input 
      integer          mlon,nlat,klvl,iopt,ier
      double precision z(mlon,nlat,klvl), zsfc(mlon,nlat), ztop, zmsg
C                                                ! output
      double precision dz(mlon,nlat,klvl)
C NCLEND
c
c     dzres = dz_height(z, zsfc, ztop, iopt)
c                                                ! local
      double precision zlvl(klvl), dzlvl(klvl)
      integer          mono, kl, nl, ml

c check to see if ztop is reasonable
c .   ztop < 0      is not allowed

      ier    = 0

      if (ztop.lt.0.0) then
          ier = 1
      end if

      do kl=1,klvl
        do nl=1,nlat
          do ml=1,mlon
             dz(ml,nl,kl) = zmsg
          end do
        end do
      end do
c select one grid pt for monoticity test
      nl = 1
      ml = 1
      do kl=1,klvl
         zlvl(kl) = z(ml,nl,kl)
      end do

      call dzmono (klvl,zlvl,zmsg,mono,ier)
      if (ier.ne.0) return 

      do nl=1,nlat
        do ml=1,mlon
           if (zsfc(ml,nl).ne.zmsg) then

               if (mono.eq. 1) then
                   do kl=1,klvl
                      zlvl(kl) = z(ml,nl,kl)
                   end do
               else
                   do kl=1,klvl
                      zlvl(kl) = z(ml,nl,klvl-kl+1)
                   end do
               end if

               call dzheight(klvl,zlvl,zsfc(ml,nl),zmsg,ztop
     +                      ,dzlvl,iopt,ier)

               if (mono.eq. 1) then
                   do kl=1,klvl
                      dz(ml,nl,kl) = dzlvl(kl)
                   end do
               else
                   do kl=1,klvl
                      dz(ml,nl,klvl-kl+1) = dzlvl(kl)
                   end do
               end if

           end if
        end do
      end do

      return
      end
c ==================
C NCLFORTSTART
      subroutine dzheight(klvl,z,zsfc,zmsg,ztop,dzlvl,iopt,ier)
      implicit none
C                                                ! input 
      integer          klvl,iopt,ier
      double precision z(klvl), zsfc, ztop, zmsg
C                                                ! output
      double precision dzlvl(klvl)
C NCLEND
c The input *must* be monotonically increasing
c     dzres = dz_height(z, zsfc, ztop, iopt)
c
c The returned 'dz' are equivalent to having used  beta factors.
c must be monotonically increasing
 
C                                                ! local
      integer          kl, kll
      double precision zlvl(klvl), zbot, zspan, zeps
      double precision dzsum, zsfcmx, zsfcmn, work(klvl)
      data             zeps /0.001d0/

      ier = 0

c lower/upper boundaries missing?

      if (zsfc.eq.zmsg .or. ztop.eq.zmsg) then
          do kl=1,klvl
             dzlvl(kl) = zmsg
          end do
          ier = 15
          return
      end if

c monotonically increasing?

      if (z(2).lt.z(1)) then
          ier = 25
          return
      end if

c initialize to nominal dzlvl

      dzlvl(1)    = (z(1)+z(2))*0.5d0 - zsfc 
      do kl=2,klvl-1 
         dzlvl(kl)= (z(kl+1) - z(kl-1))*0.5d0 
      end do
      dzlvl(klvl) = ztop -(z(klvl)+z(klvl-1))*0.5d0 

c if zsfc<z(1) and ztop>z(klvl) ... this is it

      if (zsfc.lt.z(1) .and. ztop.gt.z(klvl)) go to 200

c levels outside the range should be set to 0.0

      do kl=1,klvl 
         if (z(kl).lt.zsfc .or. z(kl).gt.ztop) dzlvl(kl) = 0.0d0 
      end do

c modify the default dz

      if (ztop.lt.z(klvl)) then
          do kl=klvl,2,-1
             if (ztop.le.z(kl) .and. ztop.gt.z(kl-1)) then
                 kll = kl-1
                 dzlvl(kll) = ztop-(z(kll)+z(kll-1))*0.5d0
                 go to 100
             end if
          end do
      end if

  100 if (zsfc.gt.z(1)) then
          do kl=1,klvl-2
             if (zsfc.ge.z(kl) .and. zsfc.lt.z(kl+1)) then
                 kll = kl+1
                 dzlvl(kll)= (z(kll)+z(kll+1))*0.5d0 -zsfc
                 go to 200
             end if
          end do
      end if

  200 zspan = ztop-zsfc

c check to make sure:     sum(dz)=zspan
c zeps could me much smaller [1e-5]
c should probably be a fatal error .... indicates something is wrong

      dzsum = 0.0d0
      do kl=1,klvl
         dzsum = dzsum + dzlvl(kl)
      end do
      if (dzsum.gt.(zspan+zeps) .or. dzsum.lt.(zspan-zeps) ) then
          ier = -1
c c c     print *,"ier=",ier,"  zspan=",zspan, "   dzsum=",dzsum
      end if

      return
      end
c --------
      subroutine dzmono(klvl,z,zmsg,mono,ier)
      implicit none
C                                                ! input 
      integer          klvl, ier
      double precision z(klvl), zmsg
C                                                ! output
      integer  mono
C                                                ! local 
      integer  kl 

      ier = 0
      do kl=2,klvl
         if (z(kl).ne.zmsg .and. z(kl-1).ne.zmsg) then
             if (z(kl).gt.z(kl-1)) then
                 mono =  1
                 return
             elseif(z(kl).lt.z(kl-1)) then
                 mono = -1
                 return
             else
                 mono = 0
                 ier  = 5
                 return
             end if
         end if
      end do

      return 
      end

C
C $Id: pcmqlq.f,v 1.11 2008-07-27 00:17:20 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE PCMQLQ (XSUB,YSUB,CHRS,SIZE,ANGD,CNTR)
C
C When lower-quality characters have been selected by the user, this
C routine is called by PLCHHQ to write out the substrings, using one
C of the routines PLCHMQ or PLCHLQ.  The user may substitute his own
C version of this routine to call some other character-drawer.
C
C The arguments are identical to those of PLCHHQ.
C
      CHARACTER*(*) CHRS
C
C COMMON block declarations.
C
      COMMON /PCPRMS/ ADDS,CONS,DSTB,DSTL,DSTR,DSTT,HPIC(3),IBNU,
     +                IBXC(3),IBXF,ICEN,IORD,IOUC,IOUF,IPCC,IQUF,
     +                ISHC,ISHF,ITEF,JCOD,LSCI(16),NFCC,NODF,RBXL,
     +                RBXM,RBXX,RBXY,ROLW,RPLW,RSLW,SHDX,SHDY,SIZA,
     +                SSIC,SSPR,SUBS,VPIC(3),WPIC(3),XBEG,XCEN,XEND,
     +                XMUL(3),YBEG,YCEN,YEND,YMUL(3),ZINX,ZINY,ZINZ
      SAVE   /PCPRMS/
C
C Call the appropriate routine.
C
      IF (IQUF.EQ.1) THEN
        CALL PLCHMQ (XSUB,YSUB,CHRS,SIZE,ANGD,CNTR)
        IF (ICFELL('PCMQLQ',1).NE.0) RETURN
      ELSE
        CALL PLCHLQ (XSUB,YSUB,CHRS,SIZE,ANGD,CNTR)
        IF (ICFELL('PCMQLQ',2).NE.0) RETURN
      END IF
C
C Done.
C
      RETURN
C
      END

c (1) Routines from the "thermo.f" package that are
c .   used to generate the skewT plot.
c (2) Routines used to plot the data

c only routines that have NCLFORTSTART/NCLEND need have wrappers
C -----------------------------------------------------------
C NCLFORTSTART
      SUBROUTINE DSKEWTY(PRES,NP,YSKEWT)

C       NCL: y = ySkewT (pres[*]:numeric)   ; np is dimension of pres

      INTEGER NP
      DOUBLE PRECISION PRES(NP)
C                                dynamically allocate ySkewT in wrapper
      DOUBLE PRECISION YSKEWT(NP)
C NCLEND
      INTEGER N

      DO N = 1,NP
          YSKEWT(N) = 132.182D0 - 44.061D0*LOG10(PRES(NP))
      END DO

      RETURN
      END
C -----------------------------------------------------------
C NCLFORTSTART
      SUBROUTINE DSKEWTX(TEMP,Y,NTY,XSKEWT)


C NCL: y = xSkewT (temp[*]:numeric, y[*]:numeric) ; nty dimension of y

      INTEGER NTY
      DOUBLE PRECISION TEMP(NTY),Y(NTY)
C                                dynamically allocate in wrapper
      DOUBLE PRECISION XSKEWT(NTY)
C NCLEND
      INTEGER N

      DO N = 1,NTY
          XSKEWT(N) = 0.54D0*TEMP(N) + 0.90692D0*Y(N)
      END DO

      RETURN
      END
C -----------------------------------------------------------
C NCLFORTSTART
      DOUBLE PRECISION FUNCTION DTMRSKEWT(W,P)
      DOUBLE PRECISION W
      DOUBLE PRECISION P
      DOUBLE PRECISION C1
      DOUBLE PRECISION C2
      DOUBLE PRECISION C3
      DOUBLE PRECISION C4
      DOUBLE PRECISION C5
      DOUBLE PRECISION C6
      DOUBLE PRECISION X
      DOUBLE PRECISION TMRK

C       NCL: tmr = tmrSkewT (w:numeric, p:numeric)

C NCLEND
c   this function returns the temperature (celsius) on a mixing
c   ratio line w (g/kg) at pressure p (mb). the formula is given in
c   table 1 on page 7 of stipanuk (1973).
c
      DATA C1/.0498646455D0/,C2/2.4082965D0/,C3/7.07475D0/
      DATA C4/38.9114D0/,C5/.0915D0/,C6/1.2035D0/

      X = DLOG10(W*P/ (622.D0+W))
      TMRK = 10.D0** (C1*X+C2) - C3 + C4* ((10.D0** (C5*X)-C6)**2.D0)
      DTMRSKEWT = TMRK - 273.15D0
      RETURN
      END
C -----------------------------------------------------------
C NCLFORTSTART
      DOUBLE PRECISION FUNCTION DTDASKEWT(O,P)
      DOUBLE PRECISION O
      DOUBLE PRECISION P
      DOUBLE PRECISION OK
      DOUBLE PRECISION TDAK

C       NCL: tda = tdaSkewT (o:numeric, p:numeric)

c NCLEND
c   this function returns the temperature tda (celsius) on a dry adiabat
c   at pressure p (millibars). the dry adiabat is given by
c   potential temperature o (celsius). the computation is based on
c   poisson's equation.

      OK = O + 273.15D0
      TDAK = OK* ((P*.001D0)**.286D0)
      DTDASKEWT = TDAK - 273.15D0
      RETURN
      END
C -----------------------------------------------------------
C NCLFORTSTART
      DOUBLE PRECISION FUNCTION DSATLFTSKEWT(THW,P)
      DOUBLE PRECISION THW
      DOUBLE PRECISION P
      DOUBLE PRECISION CTA
      DOUBLE PRECISION AKAP
      DOUBLE PRECISION PWRP
      DOUBLE PRECISION TONE
      DOUBLE PRECISION EONE
      DOUBLE PRECISION DWOBFSKEWT
      DOUBLE PRECISION RATE
      DOUBLE PRECISION TTWO
      DOUBLE PRECISION ETWO
      DOUBLE PRECISION PT
      DOUBLE PRECISION DLT

C       NCL: satlft = satlftSkewT (thw:numeric, p:numeric)

c NCLEND

c   input:  thw = wet-bulb potential temperature (celsius).
c                 thw defines a moist adiabat.
c           p = pressure (millibars)
c   output: satlft = temperature (celsius) where the moist adiabat
c                 crosses p

      DATA CTA,AKAP/273.15D0,0.28541D0/

c   cta = difference between kelvin and celsius temperatures
c   akap = (gas constant for dry air) / (specific heat at constant
c           pressure for dry air)

c        the algorithm below can best be understood by referring to a
c   skew-t/log p chart.  it was devised by herman wobus, a mathemati-
c   cian formerly at the navy weather research facility but now retired.
c   the value returned by satlft can be checked by referring to table
c   78, pp.319-322, smithsonian meteorological tables, by roland list
c   (6th revised edition).

      IF (P.NE.1000.D0) GO TO 5
      DSATLFTSKEWT = THW
      RETURN
    5 CONTINUE

c   compute tone, the temperature where the dry adiabat with value thw
c   (celsius) crosses p.

      PWRP = (P/1000.D0)**AKAP
      TONE = (THW+CTA)*PWRP - CTA

c   consider the moist adiabat ew1 through tone at p.  using the defini-
c   tion of the wobus function (see documentation on wobf), it can be
c   shown that eone = ew1-thw.

      EONE = DWOBFSKEWT(TONE) - DWOBFSKEWT(THW)
      RATE = 1.D0
      GO TO 15

c   in the loop below, the estimate of satlft is iteratively improved.

   10 CONTINUE

c   rate is the ratio of a change in t to the corresponding change in
c   e.  its initial value was set to 1 above.

      RATE = (TTWO-TONE)/ (ETWO-EONE)
      TONE = TTWO
      EONE = ETWO
   15 CONTINUE

c   ttwo is an improved estimate of satlft.

      TTWO = TONE - EONE*RATE

c   pt is the potential temperature (celsius) corresponding to ttwo at p

      PT = (TTWO+CTA)/PWRP - CTA

c   consider the moist adiabat ew2 through ttwo at p. using the defini-
c   tion of the wobus function, it can be shown that etwo = ew2-thw.

      ETWO = PT + DWOBFSKEWT(TTWO) - DWOBFSKEWT(PT) - THW

c   dlt is the correction to be subtracted from ttwo.

      DLT = ETWO*RATE
      IF (ABS(DLT).GT.0.1D0) GO TO 10
      DSATLFTSKEWT = TTWO - DLT
      RETURN
      END
c ----------------------------------------------------------
C NCLFORTSTART
      SUBROUTINE DPTLCLSKEWT(P,T,TD,PC,TC)
      DOUBLE PRECISION P
      DOUBLE PRECISION T
      DOUBLE PRECISION TD
      DOUBLE PRECISION PC
      DOUBLE PRECISION TC
      DOUBLE PRECISION AKAP
      DOUBLE PRECISION CTA
      DOUBLE PRECISION C1
      DOUBLE PRECISION C2

C       NCL: ptlclSkewT (p:numeric, t:numeric,  td:numeric\
C                      , pc:numeric, tc:numeric)
C NCLEND

      DATA AKAP,CTA/0.28541D0,273.15D0/

      C1 = 4098.026D0/ (TD+237.3D0)**2
      C2 = 1.D0/ (AKAP* (T+CTA))
      PC = P*EXP(C1*C2* (T-TD)/ (C2-C1))
      TC = T + C1* (T-TD)/ (C2-C1)

      RETURN
      END
c ----------------------------------------------------------
C NCLFORTSTART
      DOUBLE PRECISION FUNCTION DSHOWALSKEWT(P,T,TD,NLVLS)
      DOUBLE PRECISION SHWLTR
      DOUBLE PRECISION FLAG

C NCL: showal = showalSkewT(p[*]:numeric, t[*]:numeric, td[*]:numeric)
c               nlvls = dimsizes(p)

      INTEGER NLVLS
      DOUBLE PRECISION P(NLVLS),T(NLVLS),TD(NLVLS)
C NCLEND
C
C Statement of purpose.
C ---------------------
C This routine computes the Showalter stability index for a sounding.
C ----------
C SHWLTR      Real          Showalter stability index (C).
C
C Internal variables.
C
      DOUBLE PRECISION P1,P2,P3,T850,TD850,T500,TP500
      DOUBLE PRECISION TMOIST,PRES
      INTEGER I
C
C External functions.
C
      DOUBLE PRECISION DINTERPSKEWT,DTSASKEWT,DEPTSKEWT
C
C Subroutine constants.
C
      PARAMETER (FLAG = -9999.D0)
C
C Initialize showalter index to flag.  Exit if surface pressure too low.
C
      SHWLTR = FLAG
      IF (P(1).LE.820.D0) GO TO 999
C
C Determine 850 mb temperature and dew point from sounding.  If the
C surface is above 900 mb, use 800 mb temp and dew point.
C
      IF (P(1).LT.900.D0) THEN
          PRES = 800.D0
      ELSE
          PRES = 850.D0
      END IF
      DO 1 I = 1,NLVLS
          IF (P(I).LE.PRES) THEN
              P1 = DLOG(P(I-1))
              P2 = DLOG(PRES)
              P3 = DLOG(P(I))
              T850 = DINTERPSKEWT(T(I-1),T(I),P1,P2,P3)
              TD850 = DINTERPSKEWT(TD(I-1),TD(I),P1,P2,P3)
              GO TO 2
          END IF
    1 CONTINUE
    2 CONTINUE
C
C Compute the moist adiabat (given by an equivalent potential
C temperature) through the 850 mb based LCL.
C
      TMOIST = DEPTSKEWT(T850,TD850,PRES)
C
C Compute the parcel temperature along this moist adiabat at 500 mb.
C
      TP500 = DTSASKEWT(TMOIST,500.D0)
C
C Determine 500 mb temperature from the sounding.
C
      PRES = 500.D0
      DO 3 I = 1,NLVLS
          IF (P(I).LE.PRES) THEN
              P1 = DLOG(P(I-1))
              P2 = DLOG(PRES)
              P3 = DLOG(P(I))
              T500 = DINTERPSKEWT(T(I-1),T(I),P1,P2,P3)
              GO TO 4
          END IF
    3 CONTINUE
    4 CONTINUE
C
C Compute the showalter index.
C
      SHWLTR = T500 - TP500
      DSHOWALSKEWT = SHWLTR

  999 CONTINUE
      RETURN
      END
c ---------------------------------------------------------------------
C NCLFORTSTART
      DOUBLE PRECISION FUNCTION DPWSKEWT(TD,P,N)
      DOUBLE PRECISION G
      DOUBLE PRECISION PW
      DOUBLE PRECISION WBOT
      DOUBLE PRECISION DWMRSKEWT
      DOUBLE PRECISION WTOP
      DOUBLE PRECISION W
      DOUBLE PRECISION WL
      DOUBLE PRECISION QL
      DOUBLE PRECISION DP
      INTEGER N
      DOUBLE PRECISION TD(N),P(N)

C       NCL: precpw = pwSkewT (td[*]:numeric, p[*]:numeric)
C            Note: n= dimsizes(p)
c NCLEND
c   this function computes total precipitable water precpw (cm) in a
c   vertical column of air based upon sounding data at n levels:
c          td = dew point (celsius)
c          p = pressure (millibars)
c   calculations are done in cgs units.

c   g = acceleration due to the earth's gravity (cm/s**2)
      DATA G/980.616D0/
c   initialize value of precipitable water
      PW = 0.D0
      NL = N - 1
c   calculate the mixing ratio at the lowest level.
      WBOT = DWMRSKEWT(P(1),TD(1))
      DO 5 I = 1,NL
          WTOP = DWMRSKEWT(P(I+1),TD(I+1))
c   calculate the layer-mean mixing ratio (g/kg).
          W = 0.5D0* (WTOP+WBOT)
c   make the mixing ratio dimensionless.
          WL = .001D0*W
c   calculate the specific humidity.
          QL = WL/ (WL+1.D0)
c   the factor of 1000. below converts from millibars to dynes/cm**2.
          DP = 1000.D0* (P(I)-P(I+1))
          PW = PW + (QL/G)*DP
          WBOT = WTOP
    5 CONTINUE
      DPWSKEWT = PW
      RETURN
      END

C -------------------------------------------------------
C NCLFORTSTART
      DOUBLE PRECISION FUNCTION DCAPETHERMO(PENV,TENV,NLVL,LCLMB,IPRNT,
     +                 TPARCEL,TMSG,JLCL,JLFC,JCROSS)
      DOUBLE PRECISION TNOT
      DOUBLE PRECISION CAPEVAL

      INTEGER NLVL,IPRNT
c                               ! mb [hPa]
      DOUBLE PRECISION PENV(NLVL)
c                               ! C
      DOUBLE PRECISION TENV(NLVL)
c                               ! lifting condensation lvl [mb]
      DOUBLE PRECISION LCLMB
c                               ! returned parcel temp [C]
      DOUBLE PRECISION TPARCEL(NLVL)
      DOUBLE PRECISION TMSG
c c c   real capethermo           ! J  [ignore here]

C NCL: cape = capeThermo(penv[*]:numeric, tenv[*]:numeric, lclmb:numeric\
C                       ,iprnt:integer)
C
C                   nlvl = dimsizes(penv)
C                tparcel = returned as vector attribute of cape
C                   jlcl = returned as attribute of cape
C                          (integer) subscript of lifting condensation
C                          level
C                   jlfc = returned as attribute of cape
C                          (integer) subscript of level of free
C                          convection
C                 jcross = returned as attribute of cape
C                          (integer) subscript where tparcel crosses env
C                          sounding
C NCLEND
C                               ! maximum number of sounding levels
      PARAMETER (NLMAX=5000)
C                               ! must match "tpar" in capedjs
      DOUBLE PRECISION TPAR(NLMAX)


      IER = 0
      IPLOT = 0
      TNOT = 273.15D0

      DO NL = 1,NLVL
          TPARCEL(NL) = TMSG
      END DO

      DO NL = 1,NLVL
          IF (TENV(NL).EQ.TMSG) THEN
              PRINT *,'fortran: capethermo: no missing values allowed'
              DCAPETHERMO = TMSG
              RETURN
          END IF
      END DO

      DO NL = 1,NLVL
          TENV(NL) = TENV(NL) + TNOT
      END DO

      DO N = 1,NLMAX
          TPAR(N) = TMSG
      END DO

      CALL DCAPEDJS(PENV,TENV,NLVL,LCLMB,IPLOT,IPRNT,CAPEVAL,TPAR,JLCL,
     +     JLFC,JCROSS,IER)

      DO NL = 1,NLVL
          TENV(NL) = TENV(NL) - TNOT
          TPARCEL(NL) = TPAR(NL) - TNOT
c          write (*,"(' capethermo: ',i5,4f10.2)") nl, penv(nl),tenv(nl)
c    *                          ,tparcel(nl)
c    *                          ,(tparcel(nl)-tenv(nl))
      END DO

      JLCL = JLCL - 1
      JLFC = JLFC - 1
      JCROSS = JCROSS - 1

      DCAPETHERMO = CAPEVAL
c       print *,"dcapethermo=",dcapethermo

      RETURN
      END
C -------------------------------------------------------
C ---> NO MORE FUNCTIONS FOR NCL ------------------------
C -------------------------------------------------------
      DOUBLE PRECISION FUNCTION DWOBFSKEWT(T)
      DOUBLE PRECISION T
      DOUBLE PRECISION X
      DOUBLE PRECISION POL
C called by satlftSkewT
      X = T - 20.D0
      IF (X.LE.0.D0) THEN
          POL = 1.D0 + X* (-8.8416605D-03+
     +          X* (1.4714143D-04+X* (-9.6719890D-07+X* (-3.2607217D-08+
     +          X* (-3.8598073D-10)))))
          DWOBFSKEWT = 15.130D0/POL**4
      ELSE
          POL = 1.D0 + X* (3.6182989D-03+
     +          X* (-1.3603273D-05+X* (4.9618922D-07+X* (-6.1059365D-09+
     +          X* (3.9401551D-11+X* (-1.2588129D-13+
     +          X* (1.6688280D-16)))))))
          DWOBFSKEWT = 29.930D0/POL**4 + 0.96D0*X - 14.8D0
      END IF

      RETURN
      END
c ----------------------------------------------------------
      DOUBLE PRECISION FUNCTION DINTERPSKEWT(Y1,Y3,X1,X2,X3)
      DOUBLE PRECISION Y1,Y3,X1,X2,X3

      DINTERPSKEWT = Y1 + ((Y3-Y1)* ((X2-X1)/ (X3-X1)))
      RETURN
      END
c ----------------------------------------------------------
      DOUBLE PRECISION FUNCTION DTSASKEWT(OS,P)
      DOUBLE PRECISION OS
      DOUBLE PRECISION P
      DOUBLE PRECISION B
      DOUBLE PRECISION A
      DOUBLE PRECISION TQ
      DOUBLE PRECISION D
      DOUBLE PRECISION TQK
      DOUBLE PRECISION X
      DOUBLE PRECISION DWXSKEWT

c   this function returns the temperature tsa (celsius) on a saturation
c   adiabat at pressure p (millibars). os is the equivalent potential
c   temperature of the parcel (celsius). sign(a,b) replaces the
c   algebraic sign of a with that of b.
c   b is an empirical constant approximately equal to 0.001 of the
c   latent heat of vaporization for water divided by the specific heat
c   at constant pressure for dry air.

      DATA B/2.6518986D0/

      A = OS + 273.15D0
c   tq is the first guess for tsa.
c   d is an initial value used in the iteration below.
      TQ = 253.15D0
      D = 120.D0

c   iterate to obtain sufficient accuracy....see table 1, p.8
c   of stipanuk (1973) for equation used in iteration.

      DO 1 I = 1,12
          TQK = TQ - 273.15D0
          D = D/2.D0
          X = A*EXP(-B*DWXSKEWT(TQK,P)/TQ) - TQ* ((1000.D0/P)**.286D0)
          IF (ABS(X).LT.1D-7) GO TO 2
          TQ = TQ + SIGN(D,X)
    1 CONTINUE
    2 DTSASKEWT = TQ - 273.15D0
      RETURN
      END

c ---------------------------------------------------------------------
      DOUBLE PRECISION FUNCTION DWXSKEWT(T,P)
      DOUBLE PRECISION T
      DOUBLE PRECISION P
      DOUBLE PRECISION X
      DOUBLE PRECISION DESATSKEWT

c  this function returns the mixing ratio (grams of water vapor per
c  kilogram of dry air) given the dew point (celsius) and pressure
c  (millibars). if the temperture  is input instead of the
c  dew point, then saturation mixing ratio (same units) is returned.
c  the formula is found in most meteorological texts.

      X = DESATSKEWT(T)
      DWXSKEWT = 622.D0*X/ (P-X)
      RETURN
      END
c ---------------------------------------------------------------------
      DOUBLE PRECISION FUNCTION DESATSKEWT(T)
      DOUBLE PRECISION T
      DOUBLE PRECISION TK
      DOUBLE PRECISION P1
      DOUBLE PRECISION P2
      DOUBLE PRECISION C1
      DOUBLE PRECISION ESAT

c   this function returns the saturation vapor pressure over
c   water (mb) given the temperature (celsius).
c   the algorithm is due to nordquist, w.s.,1973: "numerical approxima-
c   tions of selected meteorlolgical parameters for cloud physics prob-
c   lems," ecom-5475, atmospheric sciences laboratory, u.s. army
c   electronics command, white sands missile range, new mexico 88002.

      TK = T + 273.15D0
      P1 = 11.344D0 - 0.0303998D0*TK
      P2 = 3.49149D0 - 1302.8844D0/TK
      C1 = 23.832241D0 - 5.02808D0*DLOG10(TK)
      ESAT = 10.D0** (C1-1.3816D-7*10.D0**P1+8.1328D-3*10.D0**P2-
     +       2949.076D0/TK)
      DESATSKEWT = ESAT
      RETURN
      END
c -----------------------------------------
      DOUBLE PRECISION FUNCTION DEPTSKEWT(T,TD,P)
      DOUBLE PRECISION T
      DOUBLE PRECISION TD
      DOUBLE PRECISION P
      DOUBLE PRECISION W
      DOUBLE PRECISION DWMRSKEWT
      DOUBLE PRECISION TLCL
      DOUBLE PRECISION DTCONSKEWT
      DOUBLE PRECISION TK
      DOUBLE PRECISION TL
      DOUBLE PRECISION PT
      DOUBLE PRECISION EPTK

c   compute the mixing ratio (grams of water vapor per kilogram of
c   dry air).

      W = DWMRSKEWT(P,TD)

c   compute the temperature (celsius) at the lifting condensation level.

      TLCL = DTCONSKEWT(T,TD)
      TK = T + 273.15D0
      TL = TLCL + 273.15D0
      PT = TK* (1000.D0/P)** (0.2854D0* (1.D0-0.00028D0*W))
      EPTK = PT*EXP((3.376D0/TL-0.00254D0)*W* (1.D0+0.00081D0*W))
      DEPTSKEWT = EPTK - 273.15D0
      RETURN
      END
c -----------------------------------------
      DOUBLE PRECISION FUNCTION DWMRSKEWT(P,T)
      DOUBLE PRECISION P
      DOUBLE PRECISION T
      DOUBLE PRECISION EPS
      DOUBLE PRECISION X
      DOUBLE PRECISION WFW
      DOUBLE PRECISION FWESW
      DOUBLE PRECISION DESWSKEWT
      DOUBLE PRECISION R

c   this function approximates the mixing ratio wmr (grams of water
c   vapor per kilogram of dry air) given the pressure p (mb) and the
c   temperature t (celsius). the formula used is given on p. 302 of the
c   smithsonian meteorological tables by roland list (6th edition).

c   eps = ratio of the mean molecular weight of water (18.016 g/mole)
c         to that of dry air (28.966 g/mole)

      DATA EPS/0.62197D0/

c   the next two lines contain a formula by herman wobus for the
c   correction factor wfw for the departure of the mixture of air
c   and water vapor from the ideal gas law. the formula fits values
c   in table 89, p. 340 of the smithsonian meteorological tables,
c   but only for temperatures and pressures normally encountered in
c   in the atmosphere.

      X = 0.02D0* (T-12.5D0+7500.D0/P)
      WFW = 1.D0 + 4.5D-06*P + 1.4D-03*X*X
      FWESW = WFW*DESWSKEWT(T)
      R = EPS*FWESW/ (P-FWESW)

c   convert r from a dimensionless ratio to grams/kilogram.

      DWMRSKEWT = 1000.D0*R
      RETURN
      END
c -----------------------------------------
      DOUBLE PRECISION FUNCTION DESWSKEWT(T)
      DOUBLE PRECISION T
      DOUBLE PRECISION ES0
      DOUBLE PRECISION POL

c   this function returns the saturation vapor pressure esw (millibars)
c   over liquid water given the temperature t (celsius). the polynomial
c   approximation below is due to herman wobus, a mathematician who
c   worked at the navy weather research facility, norfolk, virginia,
c   but who is now retired. the coefficients of the polynomial were
c   chosen to fit the values in table 94 on pp. 351-353 of the smith-
c   sonian meteorological tables by roland list (6th edition). the
c   approximation is valid for -50 < t < 100c.
c
c   es0 = saturation vapor ressure over liquid water at 0c

      DATA ES0/6.1078D0/

      POL = 0.99999683D0 + T* (-0.90826951D-02+
     +      T* (0.78736169D-04+T* (-0.61117958D-06+T* (0.43884187D-08+
     +      T* (-0.29883885D-10+T* (0.21874425D-12+T* (-0.17892321D-14+
     +      T* (0.11112018D-16+T* (-0.30994571D-19)))))))))
      DESWSKEWT = ES0/POL**8
      RETURN
      END
c ---------------------------------------------------------------------
      DOUBLE PRECISION FUNCTION DTCONSKEWT(T,D)
      DOUBLE PRECISION T
      DOUBLE PRECISION D
      DOUBLE PRECISION S
      DOUBLE PRECISION DLT
C       NCL: tcon = tconSkewT (t:numeric, d:numeric)

c   this function returns the temperature tcon (celsius) at the lifting
c   condensation level, given the temperature t (celsius) and the
c   dew point d (celsius).
c
c   compute the dew point depression s.
      S = T - D
c   the approximation below, a third order polynomial in s and t,
c   is due to herman wobus. the source of data for fitting the
c   polynomial is unknown.

      DLT = S* (1.2185D0+1.278D-03*T+S*
     +      (-2.19D-03+1.173D-05*S-5.2D-06*T))
      DTCONSKEWT = T - DLT
      RETURN
      END
c ---------------------------------------------------------------------
c ------capedjs not called directly by NCL--------------------------
cNAME
c     cape - calculates CAPE, given temperature/pressure
c              data from a vertical sounding
c
cSYNOPSIS
c  call capedjs(penv,tenv,nlvl,lclmb,iplot,iprnt,capeval,ier) (old)
c  call capedjs(penv,tenv,nlvl,lclmb,iplot,iprnt,capeval,tparcel,ier)
c           (change for NCL)
c
cDESCRIPTION
c     cape will compute the convective available potential energy
c     given vertical soundings of temperature and pressure.
c     optional plots of environmental temperature, parcel
c     temperature, and cape as a function of altitude are available
c
c     definition of CAPE: the integral wrt -ln(p/p0) of
c             R*(Tparcel-Tenv)   from the Level of Free Convection
c             'up' to the 'crossing level'.
c
cPARAMETERS
c     Parameter Type    Description
c
c     penv              (i)     environmental pressure sounding array in mb;
c                             the pressure array is assumed to be
c                             loaded in a monotonically decreasing
c                             sequence.
c
c     tenv              (i)     temperature sounding array in Kelvin at
c                             the pressure levels
c
c     nlvl              (i)     number of sounding levels
c
c     lclmb             (i)     approximate pressure at lifting condensation
c                   level (mb). the pressure ACTUALLY USED will
c                   be the first value on the sounding grid greater
c                   than or equal to lclmb.
c
c     iplot             (i)     plotting flag: plots (=1); no plots (=other).
c                             the parcel and environmental temperature
c                             profiles are plotted throughout the
c                             sounding depth; the CAPE profile is
c                             plotted only between the LFC and the 
c                             crossing level.
c
c     iprnt             (i)     printing flag: print (>0); no print (=0). DJS
c
c     capeval           (o)     CAPE at the 'crossing level',
c                             defined to be the height where the
c                             parcel temp has decreased enough to
c                             again equal the environmental temp.
c                             if the Level of Free Convection DOES NOT
c                             exist (so that CAPE will be zero or
c                             negative) capeval will be assigned ZERO.
c                             if the Level of Free Convection DOES exist
c                             but the 'crossing level' DOES NOT exist,
c                             capeval will be assigned the value of
c                             CAPE at the "top" of the
c                             sounding (i.e. smallest pressure)
c
c     tparcel           (o)     temperature of parcel
c
c     ier               (o)     error status:
c                             zero on successful return;
c                             minus one on error;
c                             minus two if 'crossing level' does not
c                             exist;
cTECHNICAL NOTES
c     The parcel used to compute CAPE is assumed to initially lie at the
c     level of the largest pressure value in the sounding.
c
cGENERAL NOTES
c     No input parameters are modified by this routine.
c
c     No error checking for missing data is done in this routine.
c     It is the user's responsibility to ensure that no missing data
c     is present.
c
c       Opening and closing NCAR graphics (via opgks and clsgks) must be
c       performed in the calling program, if iplot = 1
cAUTHOR
c     GLF 9/95

      SUBROUTINE DCAPEDJS(PENV,TENV,NLVL,LCLMB,IPLOT,IPRNT,CAPEVAL,
     +                    TPARCEL,JLCL,JLFC,JCROSS,IER)

      IMPLICIT NONE
      INTEGER NLVL,IPLOT,IPRNT,IER,IFLAG
      INTEGER NLMAX,II,JLCL,JLCL1,NDIM,JSTRT,JCROSS,JLFC
      DOUBLE PRECISION PENV(NLVL),TENV(NLVL),LCLMB,CAPEVAL
      DOUBLE PRECISION CENTKEL,G,CP,RD,PLCL,TLCL,FRET,PMB,MDLNP
      DOUBLE PRECISION GAMMADRY,PPAR0,TPAR0,PARCELMB,PELFC

C                ! special for NCL return [dimensioned NLMAX]
      DOUBLE PRECISION TPARCEL(*)

C                               max number of sounding levels
c                               see also cape routine
      PARAMETER (NLMAX=5000)
      PARAMETER (CENTKEL=273.15D0)
      PARAMETER (G=9.81D0)
      PARAMETER (CP=1004.D0)

      DOUBLE PRECISION ZLEV,TPAR,PE,TEMPENV,ZZLEV,PPE
      DIMENSION ZLEV(NLMAX),TPAR(NLMAX),PE(NLMAX),TEMPENV(NLMAX)
      DIMENSION ZZLEV(NLMAX),PPE(NLMAX)
      DOUBLE PRECISION DTMLAPSKEWT

c     arrays and equivalences for NCAR graphics   [ NOT USED]
      DOUBLE PRECISION WORK,XI,THE
      DIMENSION WORK(NLMAX,2),XI(5),THE(5)
      EQUIVALENCE (WORK(1,1),TEMPENV(1)), (WORK(1,2),TPAR(1))

      RD = 287.D0
      IF (NLVL.GT.NLMAX) THEN
          PRINT *,'cape.f: too many sounding levels'
          IER = -1
          RETURN
      END IF

c     determine approximate location of lcl

      JLCL = 1
      DO II = 2,NLVL
          IF (LCLMB.LE.PENV(II)) THEN
              JLCL = II
          END IF
      END DO
      IF (IPRNT.GT.0) THEN
          PRINT *,'cape.f: LCL pressure: original ',LCLMB,' mb'
          PRINT *,'cape.f: adjusted to ',PENV(JLCL),' mb'
          PRINT *,'cape.f: and lies at level ',JLCL
          DO II = 1,NLVL
              PRINT *,' data=',PENV(II),TENV(II)
          END DO
      END IF
      PLCL = PENV(JLCL)

c     to compute cape, the parcel is assumed to lie initially at the
c     level of largest pressure

      JSTRT = 1
      PARCELMB = PENV(JSTRT)
      IF (IPRNT.GT.0) THEN
          PRINT *,'cape.f: initial parcel pressure: ',PENV(JSTRT),' mb'
          PRINT *,'cape.f: parcel temp is ',TENV(JSTRT),' K'
          PRINT *,'cape.f: initial P and T lie at level ',JSTRT
      END IF
      PPAR0 = PENV(JSTRT)
      TPAR0 = TENV(JSTRT)

c     assign log-pressure levels for input data,
c     referenced to parcel's initial pressure.

      DO II = 1,NLVL
          ZLEV(II) = -DLOG(PENV(II)/PPAR0)
      END DO

c  compute parcel temperature at dry lapse rate until the LCL is
c  reached
      GAMMADRY = G/CP
      DO II = 1,JLCL
          TPAR(II) = TPAR0*EXP((RD*GAMMADRY/G)* (-ZLEV(II)))
      END DO
      JLCL1 = JLCL + 1

c     above LCL compute temperature of saturated parcel

C                                   convert to C
      TLCL = TPAR(JLCL) - CENTKEL
      THE(1) = 62.D0
      XI(1) = 1.D0
      NDIM = 1

c     linmin determines theta_e


      FRET = 0.D0
      CALL DLINMIN(THE,XI,NDIM,FRET,PLCL,TLCL)

      DO II = JLCL1,NLVL
          PMB = PPAR0*EXP(-ZLEV(II))

c        tmlapskewt computes temperature given theta_e and pressure

          TPAR(II) = CENTKEL + DTMLAPSKEWT(THE(1),PMB)
      END DO
      IF (IPRNT.GT.0) THEN
          PRINT *,' '
          WRITE (*,FMT=
     +'(''cape.f:'',16x,''P'',6x,''zlev''
     +                 , 6x,''tpar'',6x,''tenv'')')
          DO II = 1,NLVL
              WRITE (*,FMT='(i4,7x,4f10.2)') II,PENV(II),ZLEV(II),
     +          TPAR(II),TENV(II)
          END DO
          PRINT *,' '
      END IF

c     determine approximate location of 1) the upper limit of
c     CAPE integration (the so-called 'crossing level')
c     and 2) the Level of Free Convection

      IF (TPAR(NLVL).GT.TENV(NLVL)) THEN
C                                       ! no  crossinglevel exists
          JCROSS = NLVL
C                                       ! so assign one
          IER = -2
C                                       ! now locate LFC
          IFLAG = 0
          DO II = NLVL - 1,1,-1
              IF ((TPAR(II).EQ.TENV(II)) .AND. (IFLAG.EQ.0)) THEN
                  JLFC = II
                  IFLAG = 1
              END IF
              IF ((TPAR(II).LT.TENV(II)) .AND. (IFLAG.EQ.0)) THEN
                  JLFC = II + 1
                  IFLAG = 1
              END IF
          END DO
          IF (IFLAG.EQ.0) THEN
              JLFC = 1
          END IF
      ELSE
          IFLAG = 0
          DO II = NLVL,1,-1
              IF ((TPAR(II).GE.TENV(II)) .AND. (IFLAG.EQ.0)) THEN
                  JCROSS = II
                  IFLAG = 1
              END IF
          END DO
          IF ((IFLAG.EQ.0) .OR. (JCROSS.EQ.1)) THEN
              CAPEVAL = 0.0D0
              IER = 0
              RETURN
          END IF
          IFLAG = 0
          DO II = JCROSS - 1,1,-1
              IF ((TPAR(II).EQ.TENV(II)) .AND. (IFLAG.EQ.0)) THEN
                  JLFC = II
                  IFLAG = 1
              END IF
              IF ((TPAR(II).LT.TENV(II)) .AND. (IFLAG.EQ.0)) THEN
                  JLFC = II + 1
                  IFLAG = 1
              END IF
          END DO
          IF (IFLAG.EQ.0) THEN
              JLFC = 1
          END IF
      END IF
      IF (IPRNT.GT.0) THEN
          PRINT *,'LFC pressure= ',PENV(JLFC),' Crossing pressure= ',
     +      PENV(JCROSS)
      END IF

c     determine CAPE profile

      PE(1) = 0.0D0
      DO II = 2,JCROSS
          MDLNP = ZLEV(II) - ZLEV(II-1)
          PE(II) = PE(II-1) + (RD*MDLNP*
     +             ((TPAR(II)+TPAR(II-1))- (TENV(II)+TENV(II-1)))/2.D0)
      END DO
      PELFC = PE(JLFC)
      DO II = 1,JCROSS
          PE(II) = PE(II) - PELFC
      END DO

c     save CAPE computed by integrating from LFC to crossing level

      CAPEVAL = PE(JCROSS)


      DO II = JLFC,JCROSS
          ZZLEV(II+1-JLFC) = ZLEV(II)
          PPE(II+1-JLFC) = PE(II)
      END DO
      DO II = 1,NLVL
          TPARCEL(II) = TPAR(II)
      END DO

      IF (IPRNT.GT.0) THEN
          WRITE (*,FMT='(/,'' jlfc, jcross='',2i5)') JLFC,JCROSS
          WRITE (*,FMT='(/,''Env Temp & Parcel Temp'',/)')
          DO II = 1,JCROSS
              WRITE (*,FMT='(i4,f7.1,4f9.2,f6.2)') II,PENV(II),PE(II),
     +          ZLEV(II), (TEMPENV(II)-273.15D0), (TPAR(II)-273.15D0),
     +          (TPAR(II)-TEMPENV(II))
c              write (*,"(i4,f7.1,4f9.2,f6.2)") ii
c    *                           ,penv(ii),pe(ii),zlev(ii)
c    *                           ,(work(ii,1)-273.15)
c    *                           ,(work(ii,2)-273.15)
c    *                           ,(work(ii,2)-work(ii,1))
          END DO
          WRITE (*,FMT='(  ''----------------------'',/)')
      END IF

      RETURN
      END
c ----------Not called by NCL directly--------------------------
      SUBROUTINE DLINMIN(P,XI,N,FRET,PLCL,TLCL)
      DOUBLE PRECISION P
      DOUBLE PRECISION XI
      DOUBLE PRECISION FRET
      DOUBLE PRECISION PLCL
      DOUBLE PRECISION TLCL
      DOUBLE PRECISION TOL
      DOUBLE PRECISION PCOM
      DOUBLE PRECISION XICOM
      DOUBLE PRECISION PLCLX
      DOUBLE PRECISION TLCLX
      DOUBLE PRECISION AX
      DOUBLE PRECISION XX
      DOUBLE PRECISION BX
      DOUBLE PRECISION FA
      DOUBLE PRECISION FX
      DOUBLE PRECISION FB
      DOUBLE PRECISION DBRENT
      DOUBLE PRECISION XMIN
c
c  LINMIN: given the n-dim point P and n-dim direction XI, move and
c      reset P to whee the function 'dfd' takes on a minimum along the
c      direction XI from P, and replaces XI by the actual vector
c      displacement that P was moved. Also returns as FRET the value
c      of the function at P.
c=================================================================
      SAVE
      PARAMETER (NMAX=50,TOL=1.D-5)
      COMMON /F1COM/PCOM(NMAX),XICOM(NMAX),PLCLX,TLCLX,NCOM
      DIMENSION P(N),XI(N)
      DOUBLE PRECISION DFUNCSHEA
      EXTERNAL DFUNCSHEA
c
c  set common block
c---------------------
      PLCLX = PLCL
      TLCLX = TLCL
      NCOM = N
      DO 100 J = 1,N
          PCOM(J) = P(J)
          XICOM(J) = XI(J)
  100 CONTINUE
c
c  find minimum point
c---------------------
      AX = 0.0D0
      XX = 1.0D0
      BX = 2.0D0
      CALL DMNBRAK(AX,XX,BX,FA,FX,FB,DFUNCSHEA)
      FRET = DBRENT(AX,XX,BX,DFUNCSHEA,TOL,XMIN)
c
c  construct vector results
c---------------------------
      DO 200 J = 1,N
          XI(J) = XMIN*XI(J)
          P(J) = P(J) + XI(J)
  200 CONTINUE
c
c  end routine
c---------------
      RETURN
      END
c ----------Not called by NCL directly--------------------------
      SUBROUTINE DMNBRAK(AX,BX,CX,FA,FB,FC,DFUNCSHEA)
      DOUBLE PRECISION AX
      DOUBLE PRECISION BX
      DOUBLE PRECISION CX
      DOUBLE PRECISION FA
      DOUBLE PRECISION FB
      DOUBLE PRECISION FC
      DOUBLE PRECISION DFUNCSHEA
      DOUBLE PRECISION GOLD
      DOUBLE PRECISION GLIMIT
      DOUBLE PRECISION TINY
      DOUBLE PRECISION DUM
      DOUBLE PRECISION R
      DOUBLE PRECISION Q
      DOUBLE PRECISION U
      DOUBLE PRECISION ULIM
      DOUBLE PRECISION FU
c
c  MNBRAK: given the subroutine 'func' which returns a function
c     value, and given distinct initail points AX and BX, this routine
c     searches in the downhill direction (defined by the function as
c     evaluated at the intial points) and returns new points ZX, BX, CX
c     which bracket a minimum of the funtion. Also returned are the
c     function values at the three points, FA, FB, FC.
c===================================================================
      SAVE
      parameter(GOLD=1.618034d0,GLIMIT=100.d0,TINY=1.d-20)
cc    parameter(GOLD=1.6180340,GLIMIT=100.0,TINY=1.e-7)
c      PARAMETER (GOLD=1.6180340D0,GLIMIT=100.0D0,TINY=1.D-5)
      EXTERNAL DFUNCSHEA
c
c  get intial function values switch roles of A and B if needed.
c------------------------------------------------------------------
      FA = DFUNCSHEA(AX)
      FB = DFUNCSHEA(BX)
      IF (FB.GT.FA) THEN
          DUM = AX
          AX = BX
          BX = DUM
          DUM = FB
          FB = FA
          FA = DUM
      END IF
c
c  first guess
c-------------
      CX = BX + GOLD* (BX-AX)
      FC = DFUNCSHEA(CX)
c
c  loop point for bracketing
c=============================
  100 CONTINUE
      IF (FB.GE.FC) THEN
          R = (BX-AX)* (FB-FC)
          Q = (BX-CX)* (FB-FA)
          U = BX - ((BX-CX)*Q- (BX-AX)*R)/
     +        (2.0D0*SIGN(MAX(ABS(Q-R),TINY),Q-R))
          ULIM = BX + GLIMIT* (CX-BX)
          IF ((BX-U)* (U-CX).GT.0.0D0) THEN
              FU = DFUNCSHEA(U)
              IF (FU.LT.FC) THEN
                  AX = BX
                  FA = FB
                  BX = U
                  FB = FU
                  GO TO 100
              ELSE IF (FU.GT.FB) THEN
                  CX = U
                  FC = FU
                  GO TO 100
              END IF
              U = CX + GOLD* (CX-BX)
              FU = DFUNCSHEA(U)
          ELSE IF ((CX-U)* (U-ULIM).GT.0.0D0) THEN
              FU = DFUNCSHEA(U)
              IF (FU.LT.FC) THEN
                  BX = CX
                  CX = U
                  U = CX + GOLD* (CX-BX)
                  FB = FC
                  FC = FU
                  FU = DFUNCSHEA(U)
              END IF
          ELSE IF ((U-ULIM)* (ULIM-CX).GE.0.0D0) THEN
              U = ULIM
              FU = DFUNCSHEA(U)
          ELSE
              U = CX + GOLD* (CX-BX)
              FU = DFUNCSHEA(U)
          END IF
          AX = BX
          BX = CX
          CX = U
          FA = FB
          FB = FC
          FC = FU
          GO TO 100
      END IF
c
c  end routine
c--------------
      RETURN
      END
c ----------Not called by NCL directly--------------------------
      FUNCTION DBRENT(AX,BX,CX,DFUNCSHEA,TOL,XMIN)
      DOUBLE PRECISION DBRENT
      DOUBLE PRECISION AX
      DOUBLE PRECISION BX
      DOUBLE PRECISION CX
      DOUBLE PRECISION DFUNCSHEA
      DOUBLE PRECISION TOL
      DOUBLE PRECISION XMIN
      DOUBLE PRECISION CGOLD
      DOUBLE PRECISION ZEPS
      DOUBLE PRECISION A
      DOUBLE PRECISION B
      DOUBLE PRECISION V
      DOUBLE PRECISION W
      DOUBLE PRECISION X
      DOUBLE PRECISION E
      DOUBLE PRECISION FX
      DOUBLE PRECISION FV
      DOUBLE PRECISION FW
      DOUBLE PRECISION XM
      DOUBLE PRECISION TOL1
      DOUBLE PRECISION TOL2
      DOUBLE PRECISION R
      DOUBLE PRECISION Q
      DOUBLE PRECISION P
      DOUBLE PRECISION ETEMP
      DOUBLE PRECISION D
      DOUBLE PRECISION U
      DOUBLE PRECISION FU
c
c DBRENT: given a subroutine 'func' which returns a function value,
c    and given a bracketing triplet of abscissas AX, BX, CX (such that
c    BX is between AX and CX, and F(BX) is less than both F(AX) and
c    F(CX) ), this routine isolates the minimum to a frational precision
c    of about TOL using brent's method.
c    the abscissa of the minimum is returned as XMIN, and the minimum
c    function value is returned as BRENT.
c======================================================================
      SAVE
      parameter(ITMAX=100,CGOLD=.3819660,ZEPS=1.e-10)
ccc      PARAMETER (ITMAX=100,CGOLD=.3819660D0,ZEPS=1.D-3)
      EXTERNAL DFUNCSHEA
c
c  set initial values
c-------------------------
      A = MIN(AX,CX)
      B = MAX(AX,CX)
cc    print *,' ax=',ax,' bx=',bx,' cx=',cx,' a=',a,' b=',b
      V = BX
      W = V
      X = V
      E = 0.0D0
      FX = DFUNCSHEA(X)
      FV = FX
      FW = FX
c
c  loop over the maximum number of iterations
c================================================
      DO 300 ITER = 1,ITMAX
          XM = 0.50D0* (A+B)
          TOL1 = TOL*ABS(X) + ZEPS
          TOL2 = 2.0D0*TOL1
          IF (ABS(X-XM).LE. (TOL2-.5D0* (B-A))) GO TO 400
cc    print *,'|x-xm|=',abs(x-xm),' t2-(b-a)/2=',(tol2-.5e0*(b-a))
          IF (ABS(E).GT.TOL1) THEN
              R = (X-W)* (FX-FV)
              Q = (X-V)* (FX-FW)
              P = (X-V)*Q - (X-W)*R
              Q = 2.D0* (Q-R)
              IF (Q.GT.0.D0) P = -P
              Q = ABS(Q)
              ETEMP = E
              E = D

              IF ((ABS(P).GT.ABS(0.5D0*Q*ETEMP)) .OR.
     +            (P.LE.Q* (A-X)) .OR. (P.GE.Q* (B-X))) GO TO 100
              D = P/Q
              U = X + D
              IF (((U-A).LT.TOL2) .OR. ((B-U).LT.TOL2)) D = SIGN(TOL1,
     +            XM-X)
              GO TO 200
          END IF
  100     CONTINUE
          IF (X.GE.XM) THEN
              E = A - X
          ELSE
              E = B - X
          END IF
          D = CGOLD*E
  200     CONTINUE
          IF (ABS(D).GE.TOL1) THEN
              U = X + D
          ELSE
              U = X + SIGN(TOL1,D)
          END IF
          FU = DFUNCSHEA(U)
          IF (FU.LE.FX) THEN
              IF (U.GE.X) THEN
                  A = X
              ELSE
                  B = X
              END IF
              V = W
              FV = FW
              W = X
              FW = FX
              X = U
              FX = FU
          ELSE
              IF (U.LT.X) THEN
                  A = U
              ELSE
                  B = U
              END IF
              IF ((FU.LE.FW) .OR. (W.EQ.X)) THEN
                  V = W
                  FV = FW
                  W = U
                  FW = FU
              ELSE IF ((FU.LE.FV) .OR. (V.EQ.X) .OR. (V.EQ.W)) THEN
                  V = U
                  FV = FU
              END IF
          END IF
  300 CONTINUE
      PRINT *,' DBRENT ERROR STOP: Maximum Number of Iterations'
      PRINT *,'      reached, ITMAX=',ITMAX
      STOP
c
c  end routine
c-----------------
  400 CONTINUE
      XMIN = X
      DBRENT = FX
      RETURN
      END
c ----------Not called by NCL directly--------------------------
      DOUBLE PRECISION FUNCTION DFUNCSHEA(X)
      DOUBLE PRECISION X
      DOUBLE PRECISION P
      DOUBLE PRECISION XI
      DOUBLE PRECISION PLCL
      DOUBLE PRECISION TLCL
      DOUBLE PRECISION XT
      DOUBLE PRECISION DTMLAPSKEWT
c
      SAVE
      PARAMETER (NMAX=50)
      COMMON /F1COM/P(NMAX),XI(NMAX),PLCL,TLCL,NCOM
      DIMENSION XT(NMAX)
c
      DO 100 J = 1,NCOM
          XT(J) = P(J) + (X*XI(J))
  100 CONTINUE
c
c  end routine
c--------------
      DFUNCSHEA = ABS(TLCL-DTMLAPSKEWT(XT,PLCL))
      RETURN
      END
c ---------------------------------------------------------------------
      DOUBLE PRECISION FUNCTION DTMLAPSKEWT(THETAE,P)
      DOUBLE PRECISION THETAE
      DOUBLE PRECISION P
      DOUBLE PRECISION CRIT
      DOUBLE PRECISION EQ0
      DOUBLE PRECISION TLEV
      DOUBLE PRECISION EQ1
      DOUBLE PRECISION DEPTSKEWT
      DOUBLE PRECISION DIF
      DOUBLE PRECISION DT
c c c   real FUNCTION DtmlapsSkewT(thetae,p)

c   this function returns the temperature tmlapskewt (celsius) at
c   pressure p (millibars) along the moist adiabat corresponding
c   to an equivalent potential temperature thetae (celsius).
c   the algorithm was written by eric smith at colorado state
c   university.

      DATA CRIT/0.1D0/
c   cta = difference between kelvin and celsius temperatures.
c   crit = convergence criterion (degrees kelvin)

      EQ0 = THETAE

c   initial guess for solution

      TLEV = 25.D0

c   compute the saturation equivalent potential temperature correspon-
c   ding to temperature tlev and pressure p.

      EQ1 = DEPTSKEWT(TLEV,TLEV,P)
      DIF = ABS(EQ1-EQ0)
      IF (DIF.LT.CRIT) GO TO 3
      IF (EQ1.GT.EQ0) GO TO 1

c   dt is the initial stepping increment.

      DT = 10.D0
      I = -1
      GO TO 2
    1 DT = -10.D0
      I = 1
    2 TLEV = TLEV + DT
      EQ1 = DEPTSKEWT(TLEV,TLEV,P)
      DIF = ABS(EQ1-EQ0)
      IF (DIF.LT.CRIT) GO TO 3
      J = -1
      IF (EQ1.GT.EQ0) J = 1
      IF (I.EQ.J) GO TO 2

c   the solution has been passed. reverse the direction of search
c   and decrease the stepping increment.

      TLEV = TLEV - DT
      DT = DT/10.D0
      GO TO 2
    3 DTMLAPSKEWT = TLEV
      RETURN
      END

C
C	$Id: ffprsa.f,v 1.5 2008-07-27 12:23:42 haley Exp $
C                                                                      
C			     Copyright (C)  1997
C	     University Corporation for Atmospheric Research
C			     All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C

      SUBROUTINE FFPRSA(IER)
C
C  Parse the ASCII fontcap.
C
      include 'fntcom.h'
C
      PARAMETER (NLEN=40)
      INTEGER ITMP(NLEN)
      DATA IFRST/0/
C
C  Retrieve the font name.
C
      IF (IFRST .EQ. 0) THEN
        IF (LINE(1:9) .NE. 'FONT_NAME') THEN
          IER = EORD
          IFRST = 1
          RETURN
        ELSE
          CALL CFRDLN(IDUM1,IDUM2,IER)
          DO 20 I=1,NUMFTS
            IF (LINE(1:NLEN) .EQ. FNTNMS(I)) THEN
              FNAME = FNTNMS(I)
              IFRST = 1
              GO TO 30
            ENDIF
   20     CONTINUE
          IER = EINM
          RETURN
        ENDIF
      ENDIF
   30 CONTINUE
C
C  Retrieve all keyword values except for the character outlines.
C
      INDX = 1
      DO 40 I=2,NUMKYS
        CALL CFRDLN(IDUM1,IDUM2,IER)
        IF (LINE(1:20) .NE. KEYLST(I)) THEN
          IER = EORD
          RETURN
        ELSE
          CALL CFRDLN(IDUM1,IDUM2,IER)
          CALL FFTKIN(LINE,NUM,ITMP,IER)
          DO 60 J=1,NUM
            INDX = INDX+1
            INTARR(INDX) = ITMP(J)
   60     CONTINUE
        ENDIF 
   40 CONTINUE
C
C  Fill in all of the values for the technical information part
C  of the fontcap and write them to the buffer.
C
      CALL FFINFO(IER)
      IF (IER .NE. 0) RETURN
C
C  Type flag.
C
      CALL SBYTES(BUFFER,TYPFLG,0,16,0,1)
C
C  Font name.
C
      DO 70 I=1,NLEN
        ITMP(I) = ICHAR(FNAME(I:I))
   70 CONTINUE
      CALL SBYTES(BUFFER,ITMP,16,8,0,NLEN)
C
C  Remaining information fields.
C
      CALL SBYTES(BUFFER,INTARR(2),336,16,0,NUMNTR-1)
C
C  Process the characters.
C
      CALL FFPRCF(IER)
C
      RETURN
      END

C
C $Id: mplndr.f,v 1.14 2008-07-27 00:17:07 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MPLNDR (FLNM,ILVL)
        CHARACTER*(*) FLNM
        INTEGER       ILVL
        IF (ICFELL('MPLNDR - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
        CALL MDLNDR (FLNM,ILVL)
        IF (ICFELL('MPLNDR',2).NE.0) RETURN
        RETURN
      END

C
C	$Id: gwelod.f,v 1.4 2008-07-27 00:21:07 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GWELOD(GKSERR)
C
C  This routine loads the current instruction into the segment.
C  The current instruction includes the opcode class and id,
C  and the size filled which may be short or long.
C
C    OUTPUT
C      GKSERR -- The error status flag.
C
C
C  All data is type INTEGER unless otherwise indicated.
C
      IMPLICIT INTEGER (A-Z)
C
C  COMMON for communication of instruction and length.
C
      include 'gwiins.h'
      include 'gwiio.h'
C
      SAVE
C
C  Define the ALLOK status and the opcode class and id lengths.
C
      DATA ALLOK,OPCLLN,OPIDLN/0,4,7/
C
C  Define the short format length, short format count, long format flag,
C  continue flag on, continue flag off, continue length, long format
C  length.
C
      DATA SHFMLN,SHTFMT,LFMFLG,CONON,CONOFF,CFMLNG,LFMLNG
     1    /     5,    30,    31,    1,     0,     1,    15/
      DATA SHORT/0/, LONG/1/
C
      GKSERR = ALLOK
C
C  Make sure the instruction starts on a 16 bit boundry.
C
      TEMP = MOD(WBFPOS,16)
      IF (TEMP .NE. 0) WBFPOS = WBFPOS + (16-TEMP)
C
C  Load the opcode class and id into the buffer.
C
      CALL GWILOD(MCOPCL,OPCLLN,1,GKSERR)
      IF (GKSERR .NE. ALLOK) RETURN
      CALL GWILOD(MCOPID,OPIDLN,1,GKSERR)
      IF (GKSERR .NE. ALLOK) RETURN
C
C  Determine if a long format or short format instruction.
C
      IF (MCCBYT .LE. SHTFMT) THEN
C
C  Short format instruction.
C
        MSLFMT = SHORT
        CALL GWILOD (MCCBYT,SHFMLN,1,GKSERR)
        IF (GKSERR .NE. ALLOK) RETURN
      ELSE
C
C  Long format instruction, set the long format flag.
C
        MSLFMT = LONG
        CALL GWILOD (LFMFLG,SHFMLN,1,GKSERR)
        IF (GKSERR .NE. ALLOK) RETURN
C
C  Set the continue flag.
C
        IF (MCNBYT .NE. 0) THEN
C
C  There is another partition.
C
          CALL GWILOD(CONON,CFMLNG,1,GKSERR)
        ELSE
C
C  Last partition.
C
          CALL GWILOD(CONOFF,CFMLNG,1,GKSERR)
        END IF
C
        IF (GKSERR .NE. ALLOK) RETURN
C
C  Set the long format operand list size.
C
        CALL GWILOD(MCCBYT,LFMLNG,1,GKSERR)
      END IF
C
      RETURN
      END

C NCLFORTSTART
      subroutine poisxy1 ( xio, mx,ny, xmsg
     +           , guess, gtype, nscan, epsx, relc, mscan, ier)
      implicit none
      integer             mx, ny, nscan, guess, gtype, mscan, ier
      double precision    xio(mx,ny), xmsg, epsx, relc
C NCLEND
C
C NCL:    xout = fill_msg_grid(xio, gtype, nscan, eps, guess, opt)
      integer             nmsg, n, m
      double precision    resmax

      ier  = 0
      nmsg = 0
      do n=1,ny
        do m=1,mx
           if (xio(m,n).eq.xmsg) nmsg = nmsg + 1
        end do
      end do

c if no missing values return the original array

      if (nmsg.eq.0) return

      call poisxy2(xio,mx,ny,xmsg,nscan,epsx,relc,guess,gtype
     +            ,resmax, mscan)

      return
      end

      subroutine poisxy2(a,il,jl,amsg,maxscn,crit,relc,guess,gtype
     +                  ,resmax, mscan)
c=======================================================================
c Not sure of the original source. ? MOM ?
c=======================================================================
c     inputs:
c     a       = array with missing areas to be filled. 
c     il      = number of points along 1st dimension to be filled
c     jl      = number of points along 2nd dimension to be filled
c     maxscn  = maximum number of passes allowed in relaxation
c     crit    = criterion for ending relaxation before "maxscn" limit
c     relc    = relaxation constant
c     gtype   = 0 : not cyclic in x
c               1 : cyclic in x
c     guess   = 0 : use 0.0 as an initial guess
c             = 1 : at each "y" use the average values for that "y"
c                   think zonal averages
c     outputs:
c
c     a       = array with interpolated values 
c               non missing areas remain unchanged.
c     resmax  = max residual
c
c
      implicit   none
      logical    done
      integer    il, jl, maxscn, guess, gtype, mscan
      double precision       a(il,jl), amsg, crit, resmax

c local
c     sor     = scratch area

      integer    i, j, n, im1, ip1, jm1, jp1
      double precision       p25, relc
      double precision       sor(il,jl), res, aavg
c
      p25 = 0.25d0 

      do j=1,jl
         n    = 0
         aavg = 0.0d0
        do i=1,il
          if (a(i,j) .eq. amsg) then
              sor(i,j) = relc
          else
              n        = n + 1
              aavg     = aavg+ a(i,j)
              sor(i,j) = 0.0d0
          endif
        end do

	if (n.gt.0) then
            aavg = aavg/n
        end if

	if (guess.eq.0) then
            do i=1,il
               if (a(i,j) .eq. amsg) a(i,j) = 0.0d0
            end do
        elseif (guess.eq.1) then
            do i=1,il
              if (a(i,j) .eq. amsg) a(i,j) = aavg
            end do
        end if

      end do

c-----------------------------------------------------------------------
c     iterate until errors are acceptable.
c-----------------------------------------------------------------------
c     
      mscan = 0
100   continue
        resmax = 0.0d0
        done   = .false.
        mscan  = mscan + 1
        do j=1,jl
	   jp1 = j+1
	   jm1 = j-1
           if (j.eq.1 ) jm1 = 2
           if (j.eq.jl) jp1 = jl-1
          do i=1,il
c                                      only work on missing value locations
             if (sor(i,j).ne.0.0) then 
   	         im1 = i-1
       	         ip1 = i+1
c                                      cyclic in x           
    	         if (i.eq.1  .and. gtype.eq.1) im1 = il 
    	         if (i.eq.il .and. gtype.eq.1) ip1 = 1
c                                      not cyclic in x           
    	         if (i.eq.1  .and. gtype.eq.0) im1 = 2
    	         if (i.eq.il .and. gtype.eq.0) ip1 = il-1 
    
                 res = p25*(a(im1,j)+a(ip1,j)+a(i,jm1)+a(i,jp1)) -a(i,j)
                 res     = res*sor(i,j)
                 a(i,j)  = a(i,j) + res
                 resmax  = max(abs(res),resmax)
             end if
          end do
        end do
c
      if (resmax .le. crit .or. n.eq.maxscn)  done = .true.
c
      if (.not. done .and. mscan .lt. maxscn) go to 100
c
c     write (6,99) mscan, resmax
c  99 format (1x,'==> Extrapolated  mscan=',i4
c    &,       ' scans.  max residual=', g14.7)

      return
      end

C
C $Id: mapint.f,v 1.25 2008-09-18 00:42:16 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MAPINT
        IF (ICFELL('MAPINT - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
        CALL MDPINT
        IF (ICFELL('MAPINT',2).NE.0) RETURN
        RETURN
      END

C
C	$Id: g01tx.f,v 1.9 2008-07-27 00:21:06 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE G01TX
C
C  Process TEXT elements.
C
C ************************************************************************
C **                                                                    **
C **     NOTE:  Continuation across character partitions is not         **
C **            implemented.  This limits character strings to          **
C **            lengths less than 32768.                                **
C **                                                                    **
C ************************************************************************
C
C
      include 'g01prm.h'
      include 'gksin.h'
      include 'g01io.h'
      include 'g01ins.h'
      include 'g01wsl.h'
      include 'g01rqa.h'
      include 'g01ast.h'
      include 'g01adc.h'
      include 'g01opc.h'
      include 'gksenu.h'
C
      INTEGER  NUMO(2), KALL, IPRIM, NBYTES, GFINAL, G01PBL
      SAVE KALL
C
      DATA KALL/0/,  IPRIM/3/,  GFINAL/1/
C
      KALL = KALL+1
      IF  (KALL.EQ.1) THEN
C
C  First call of text element.
C
C  Set the WSL entry "DISPLAY SURFACE EMPTY" to "NOT EMPTY".
C
        MDEMPT = GNEMPT
C
C  Process pending attributes.
C
        IF (AGPEND(IPRIM)) THEN
C
C  Some changes are pending.
C
          IF (VALCHG(IVTXIX))  THEN
C
C  TEXT INDEX, send CGM text bundle index.
C
            NBYTES = 1+(MIXFW-1)/8
            CALL GPUTNI (CLTBIX, IDTBIX, NBYTES, RERR)
            CALL GPUTPR (MRTXIX, MIXFW, 1, RERR)
            IF (RERR .NE. 0) RETURN
C
C  Set sent value to requested, clear change flag.
C
            MSTXIX         = MRTXIX
            VALCHG(IVTXIX) = .FALSE.
          END IF
          IF (VALCHG(IVTXFO))  THEN
C
C  FONT component of GKS TEXT FONT/PRECISION, send CGM text precision.
C
            NBYTES = 1+(MEFW-1)/8
            CALL GPUTNI (CLTFON, IDTFON, NBYTES, RERR)
            CALL GPUTPR (MRTXFO, MEFW, 1, RERR)
            IF (RERR .NE. 0) RETURN
C
C  Set sent value to requested, clear change flag.
C
            MSTXFO         = MRTXFO
            VALCHG(IVTXFO) = .FALSE.
          END IF
          IF (VALCHG(IVTXPR)) THEN
C
C  PRECISION component of GKS TEXT FONT/PRECISION, send CGM text precsion.
C
            NBYTES         = 1+(MIXFW-1)/8
            CALL GPUTNI (CLTPRE, IDTPRE, NBYTES, RERR)
            CALL GPUTPR (MRTXPR, MIXFW, 1, RERR)
            IF (RERR .NE. 0) RETURN
C
C  Set sent value to requested, clear change flag.
C
            MSTXPR         = MRTXPR
            VALCHG(IVTXPR) = .FALSE.
          END IF
          IF (VALCHG(IVCHXP)) THEN
C
C  CHARACTER EXPANSION FACTOR, send CGM character expansion factor.
C
            NBYTES = 1+(2*MCFPP-1)/8
            CALL GPUTNI (CLCHEX, IDCHEX, NBYTES, RERR)
            CALL GFLCNV (ARCHXP, NUMO)
            CALL GPUTPR (NUMO, MCFPP, 2, RERR)
            IF (RERR .NE. 0) RETURN
C
C  Set sent value to requested, clear change flag.
C
            ASCHXP         = ARCHXP
            VALCHG(IVCHXP) = .FALSE.
          END IF
          IF (VALCHG(IVCHSP)) THEN
C
C  CHARACTER SPACING, send CGM character spacing.
C
            NBYTES = 1+(2*MCFPP-1)/8
            CALL GPUTNI (CLCHSP, IDCHSP, NBYTES, RERR)
            CALL GFLCNV (ARCHSP, NUMO)
            CALL GPUTPR (NUMO, MCFPP, 2, RERR)
C
C  Set sent value to requested, clear change flag.
C
            ASCHSP         = ARCHSP
            VALCHG(IVCHSP) = .FALSE.
          END IF
          IF (VALCHG(IVTXCI)) THEN
C
C  TEXT COLOR INDEX, send CGM text color.
C
            NBYTES = 1+(MCIXFW-1)/8
            CALL GPUTNI (CLTCLR, IDTCLR, NBYTES, RERR)
            CALL GPUTPR (MRTXCI, MCIXFW, 1, RERR)
            IF (RERR .NE. 0) RETURN
C
C  Set sent value to requested, clear change flag.
C
            MSTXCI         = MRTXCI
            VALCHG(IVTXCI) = .FALSE.
          END IF
          IF (VALCHG(IVTXP)) THEN
C
C  TEXT PATH, send CGM text path.
C
            NBYTES = 1+(MEFW-1)/8
            CALL GPUTNI (CLTXPA, IDTXPA, NBYTES, RERR)
            CALL GPUTPR (MRTXP , MEFW,  1, RERR)
            IF (RERR .NE. 0) RETURN
C
C  Set sent value to requested, clear change flag.
C
            MSTXP         = MRTXP
            VALCHG(IVTXP) = .FALSE.
          END IF
          IF (VALCHG(IVTXAL)) THEN
C
C  TEXT ALIGNMENT, send CGM text alignment.
C
            NBYTES = 1+(2*MEFW + 4*MCFPP - 1)/8
            CALL GPUTNI (CLTXAL, IDTXAL, NBYTES, RERR)
C
C  Put in GKS/CGM discrete alignment values.
C
            CALL GPUTPR (MRTXAL, MEFW, 2, RERR)
C
C  Add (unused) CGM continuous parameters.
C
            NUMO(1) = 0
            NUMO(2) = 0
            CALL GPUTPR (NUMO, MCFPP, 2, RERR)
            CALL GPUTPR (NUMO, MCFPP, 2, RERR)
            IF (RERR .NE. 0) RETURN
C
C  Set sent value to requested, clear change flag.
C
            MSTXAL(1)      = MRTXAL(1)
            MSTXAL(2)      = MRTXAL(2)
            VALCHG(IVTXAL) = .FALSE.
          END IF
          IF (VALCHG(IVCHH)) THEN
C
C  CHARACTER HEIGHT (derived from interface vector pair),
C  put out CGM character height.
C
            NBYTES = 1+(MVDCFW-1)/8
            CALL GPUTNI (CLCHHT, IDCHHT, NBYTES, RERR)
            CALL GPUTPR (MRCHH, MVDCFW,  1, RERR)
            IF (RERR .NE. 0) RETURN
C
C  Set sent value to requested, clear change flag.
C
            MSCHH         = MRCHH
            VALCHG(IVCHH) = .FALSE.
          END IF
          IF (VALCHG(IVCHOV)) THEN
C
C  CHARACTER UP VECTOR (as per interface vector pair),
C  send CGM character orientation (vector pair).
C
            NBYTES = 1+(4*MVDCFW-1)/8
            CALL GPUTNI (CLCHOR, IDCHOR, NBYTES, RERR)
            CALL GPUTPR (MRCHOV(1) , MVDCFW,  4, RERR)
            IF (RERR .NE. 0) RETURN
C
C  Set sent value to requested, clear change flag.
C
            MSCHOV(1)      = MRCHOV(1)
            MSCHOV(2)      = MRCHOV(2)
            MSCHOV(3)      = MRCHOV(3)
            MSCHOV(4)      = MRCHOV(4)
            VALCHG(IVCHOV) = .FALSE.
          END IF
          IF (ANYASF)  THEN
C
C  Some ASF has changed.
C
            CALL G01SAS (IPRIM, RERR)
            IF (RERR.NE.0)  RETURN
          END IF
C
C  Clear aggregate change variable.
C
           AGPEND(IPRIM) = .FALSE.
        END IF
C
C  Treat first call, put out opcode, and points.
C
C  Put out opcode (CLASS and ID) and total LENGTH.
C
        NBYTES = G01PBL (STRL1, 1+(MEFW+2*MVDCFW-1)/8 )
        CALL GPUTNI (CLTEXT, IDTEXT, NBYTES, RERR)
C
C  Put out starting point.
C
C  Truncate point to limits of the NDC unit square, convert to VDC,
C  and store in MPXPY.
C
        MPXPY(1) = MXOFF + INT(REAL(MXSCAL)*
     +             (MAX(0.,MIN(1.0,RX(1)))))
        MPXPY(2) = MYOFF + INT(REAL(MYSCAL)*
     +             (MAX(0.,MIN(1.0,RY(1)))))
        CALL GPUTPR (MPXPY, MVDCFW, 2, RERR)
C
C  Put out final flag.
C
        CALL GPUTPR (GFINAL, MEFW, 1, RERR)
C
C  Put out first (and perhaps only) part of character string.
C
        CALL GPUTPS (STR, STRL1, STRL2, 0, RERR)
        IF (RERR .NE. 0) RETURN
C
C  End of processing for first call of element.
C
      ELSE IF (KALL .GT. 1) THEN
C
C  This is a continuation call for the element.
C
        CALL GPUTPS (STR, STRL1, STRL2, 1, RERR)
        IF (RERR .NE. 0) RETURN
      END IF
C
C  If there is to be no continuation, reset the parameter "KALL".
C
      IF (CONT .EQ. 0) THEN
         KALL = 0
      END IF
C
      RETURN
      END

C
C	$Id: pwrzgs.f,v 1.4 2008-07-27 00:17:22 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE PWRZGS (KCHAR,JCHAR,INDEX,NSIZE,IPOINT)
C
C THIS ROUTINE FINDS WHERE KCHAR IS IN JCHAR AND RETURNS THE CORRES-
C PONDING INDEX IN IPOINT.  BINARY HALVING IS USED.
C
      SAVE
      CHARACTER*1     JCHAR(NSIZE)     ,KCHAR
      DIMENSION       INDEX(NSIZE)
C
C IT IS ASSUMED THAT JCHAR IS LESS THAT 2**9 IN LENGTH, SO IF KCHAR IS
C NOT FOUND IN 10 STEPS, THE SEARCH IS STOPPED.
C
      KOUNT = 0
      IBOT = 1
      ITOP = NSIZE
      I = ITOP
      GO TO 102
  101 I = (IBOT+ITOP)/2
      KOUNT = KOUNT+1
      IF (KOUNT .GT. 10) GO TO 106
  102 IF (ICHAR(JCHAR(I))-ICHAR(KCHAR)) 103,105,104
  103 IBOT = I
      GO TO 101
  104 ITOP = I
      GO TO 101
  105 IPOINT = INDEX(I)
      RETURN
C
C IPOINT=-1 MEANS THAT KCHAR WAS NOT IN THE TABLE.
C
  106 IPOINT = -1
      RETURN
C
C
C
C REVISION HISTORY----------
C
C MARCH    1980    FIRST ADDED TO ULIB AS A SEPARATE FILE TO BE
C                  USED IN CONJUNCTION WITH THE ULIB ROUTINE
C                  SRFACE
C
C JULY     1984    CONVERTED TO GKS AND FORTRAN 77
C
C MARCH    1990    FIXED HANDLING OF SET CALLS
C
C------------------------------------------------------------------
      END

C
C	$Id: patset.f,v 1.4 2008-07-27 00:59:05 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE PATSET(IPAT)
C
C  SET THE PATTERN FOR SOFTWARE DASHED LINE EMULATION
C
C  INPUT
C       IPAT-THE REQUESTED PATTERN
C               1 TO 4 PREDEFINED PATTERNS SET BY GKS
C               0 - A INVISIBLE LINE
C               ALL OTHERS THE 16 BIT VALUE DEFINES THE LOOK OF THE PATTERN
C
      COMMON /TRDASH/ PATFLG, DASPAT, PATBIT, DEFPAT, DASHX, DASHY,
     1                PATVDC
      INTEGER DPATSZ, PATSIZ, DFPTSZ
      PARAMETER (DPATSZ=16, PATSIZ=320, DFPTSZ=4)
      INTEGER PATFLG, DASPAT, PATBIT, DEFPAT(DFPTSZ), DASHX,
     1        DASHY, PATVDC
      COMMON /TRTYPE/ METMIN, METEXT, METPRT, METHED, MIOPCL, MXOPCL,
     1                MIOPID, MXOPID, ASCDEC, ASCHEX, ASCOCT, BINARY,
     2                GAHNOR, GALEFT, GACENT, GARITE, GAVNOR, GATOP ,
     3                GACAP , GAHALF, GABASE, GABOTT, GRIGHT, GLEFT ,
     4                GUP   ,
     5                GDOWN , CINDEX, CDIRCT, PENUP , PENDN , FLAGVL,
     6                SEPRVL, ASCTEK, TYPRGB, TYPBGR,
     7                TYPHLS, TYPMON, SOLID , DASHED, INVSBL, SOLPAT,
     8                ASFIND, ASFBND, ASFLNT, ASFLNW, ASFLNC, ASFMRT,
     9                ASFMRS, ASFMRC, ASFFIS, ASFFHI, ASFFPI, ASFFCO,
     A                ASFFPT, ASFFPW, ASFFPC, ASFTFI, ASFTPR, ASFTCX,
     B                ASFTCS, ASFTCO, ASCFLT, PHOLLO, PSOLID, PPATTR,
     C                PHATCH, PEMPTY, HHORIZ, HVERTI, HPOSLP, HNESLP,
     D                HHOAVE, HPOANE
      INTEGER         METMIN, METEXT, METPRT, METHED, MIOPCL, MXOPCL,
     1                MIOPID, MXOPID, ASCDEC, ASCHEX, ASCOCT, BINARY,
     2                GAHNOR, GALEFT, GACENT, GARITE, GAVNOR, GATOP ,
     3                GACAP , GAHALF, GABASE, GABOTT, GRIGHT, GLEFT ,
     4                GUP   ,
     5                GDOWN , CINDEX, CDIRCT, PENUP , PENDN , FLAGVL,
     6                SEPRVL, ASCTEK, TYPRGB, TYPBGR,
     7                TYPHLS, TYPMON, SOLID , DASHED, INVSBL, SOLPAT,
     8                ASFIND, ASFBND, ASFLNT, ASFLNW, ASFLNC, ASFMRT,
     9                ASFMRS, ASFMRC, ASFFIS, ASFFHI, ASFFPI, ASFFCO,
     A                ASFFPT, ASFFPW, ASFFPC, ASFTFI, ASFTPR, ASFTCX,
     B                ASFTCS, ASFTCO, ASCFLT, PHOLLO, PSOLID, PPATTR,
     C                PHATCH, PEMPTY, HHORIZ, HVERTI, HPOSLP, HNESLP,
     D                HHOAVE, HPOANE
      COMMON /TRMACH/ BTSWRD
      INTEGER BTSWRD
      COMMON /CAPDEV/ DGISTR, DGISIZ, DGESTR, DGESIZ, DTISTR,
     1                DTISIZ, DCDLLX, DCDLLY, DCDURX, DCDURY,
     3                DCOAVL, CORFMT, CORFIN, BATCH , DHCSIZ,
     4                DHCSTR, CORXOF, CORYOF, DASBIT, CORXSC,
     5                CORYSC, VDWLLX, VDWLLY, VDWURX, VDWURY
      INTEGER         DGIMAX, DGEMAX, DTIMAX, DCFTMX, DHCMAX
      PARAMETER   (DGIMAX=300, DGEMAX=150, DTIMAX=100)
      PARAMETER   (DCFTMX=30 , DHCMAX=50)
      INTEGER         DGISTR(DGIMAX), DGISIZ, DGESTR(DGEMAX),
     1                DGESIZ, DTISTR(DTIMAX), DTISIZ, DCDLLX,
     2                DCDLLY, DCDURX, DCDURY, CORFMT(DCFTMX,4),
     3                CORFIN(8)     , DHCSIZ, DHCSTR(DHCMAX),
     4                CORXOF, CORYOF, DASBIT, VDWLLX, VDWLLY,
     5                VDWURX, VDWURY
      REAL            CORXSC, CORYSC, CORRIN(8)
      LOGICAL         DCOAVL, BATCH
C  Size of the COMMON
      INTEGER         LENDEV
      PARAMETER   (LENDEV=DGIMAX+1+DGEMAX+1+DTIMAX+1+4+1+4*DCFTMX+
     1                  8+2+DHCMAX+9)
      EQUIVALENCE (CORFIN,CORRIN)
C
      INTEGER IPAT
C
C  IF PATTERN CLEAR THEN SET THE INVISIBLE FLAG
C
      IF (IPAT .EQ. INVSBL) THEN
        PATFLG = INVSBL
C
C  CHECK FOR SOLID PATTERN
C
      ELSE IF (IPAT.EQ.SOLID .OR. IPAT.EQ.SOLPAT) THEN
        PATFLG = SOLID
C
C  ELSE SET THE DASHED FLAG
C
      ELSE
        PATFLG = DASHED
        PATBIT = 1
        PATVDC = DASBIT
        DASHX = 0
        DASHY = 0
        IF (IPAT .GE. 2 .AND. IPAT .LT. 5) THEN
                CALL SBYTES(DASPAT, DEFPAT(IPAT), 0, DPATSZ, 0, 1)
        ELSE
                CALL SBYTES(DASPAT, IPAT, 0, DPATSZ, 0, 1)
        END IF
      END IF
C
      RETURN
      END

C
C	$Id: gflas4.f,v 1.8 2008-07-27 00:17:13 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GFLAS4(ID,FNAME)
C
C_BEGIN PROLOGUE GFLAS4
C
C_PURPOSE
C    A call to this subroutine does the necessary bookkeeping
C    to allow a dataset of plotting instructions created in a previous
C    job step with a GFLAS1/GFLAS2 sequence to be used in the
C    current program with a GFLAS3 call.  GFLAS4 can be used
C    only with the NCAR GKS package.
C
C
C_DESCRIPTION
C    A call to this subroutine does the necessary bookkeeping
C    to allow a dataset of plotting instructions created in a previous
C    job step with a GFLAS1/GFLAS2 sequence to be used in the
C    current program with a GFLAS3 call.  This allows for inserting
C    previously-created plotting instructions into the output
C    pipeline at any user-selected point.  GFLAS4 can be used only
C    with the NCAR GKS package.
C
C_ARGUMENTS
C
C ID      (INPUT,SINGLE,VARIABLE)  An integer variable in the range
C         [0,99] which is used as a user-defined identifier for the
C         dataset of graphics instructions contained in FNAME (see
C         below.)  ID can be used as an argument to subsequent
C         GFLAS3 calls.  ID cannot be equal to an identifier
C         used as an argument to GFLAS1 in the current program.
C FNAME   (INPUT,SINGLE,VARIABLE)  A character string containing
C         the dataset name of the dataset which contains plotting
C         instructions generated previously with a GFLAS1/GFLAS2
C         sequence.  FNAME can be at most seven characters in length.
C
C_I/O
C    (None)
C
C_ROUTINES CALLED
C    PLOTIT, SETER
C
C_COMMON BLOCKS
C    GFLASH
C
C_MAXIMUM GKS LEVEL
C    0A
C
C_LANGUAGE
C    FORTRAN
C
C_REVISION DATE
C    890117 (YYMMDD)
C
C_HISTORY
C    This subroutine was coded at NCAR by Fred Clare.  Its purpose
C    is to duplicate the functionality of the previous NCAR System
C    Plot Package entry FLASH4 in a GKS environment.
C
C_REFERENCES
C    "The System Plot Package", NCAR Technical Note number
C    NCAR-TN/162+IA, May, 1983.
C
C    "NCAR Graphics User's Guide", Version 2.00, NCAR Technical Note
C    number NCAR/TN-283+IA, August, 1987.
C
C_LONG DESCRIPTION
C    GFLAS4 finds the number of records in FNAME and does the
C    necessary bookkeeping to establish the dataset as valid for
C    subsequent use by GFLAS3.  GFLAS4 utilizes a GKS ESCAPE
C    function unique to the NCAR GKS package.  The function
C    identifier for this ESCAPE function is -1392.  If one tries
C    to use GFLAS4 with a non-NCAR GKS package, he will get an
C    error to the effect that no ESCAPE function exists with
C    function idendifier -1392.
C
C_EXAMPLES
C    Example 1 --  Establish a previously existing dataset of plotting
C                  instructions -- MF09 -- for use with GFLAS3.
C          SUBROUTINE INSDAT
C          CALL GFLAS4(9,'MF09')
C          CALL GFLAS3(9)
C          RETURN
C          END
C
C_END PROLOGUE GFLAS4
C
C-------------------------------------------------------------
C
C  Common for FLASH package.
C
      COMMON /GFLASH/MODEF,IOPWKS(100),IOACT(100),NUMOP,IWISSI
C
      CHARACTER*(*) FNAME
      CHARACTER*80 IDR(2),ODR(1)
C
      IF (MODEF .EQ. 1) THEN
        GO TO 106
      ELSE
        MODEF = 4
      ENDIF
C
C  Check if GKS is open.
C
      CALL GQOPS(IOPSTA)
      IF (IOPSTA .LT. 1) GO TO 105
C
C  Make sure that this GKS implementation has WISS (level 2).
C
      CALL GQEWK(1,IER,NUMB,NTYP)
      DO 10 I=1,NUMB
        CALL GQEWK(I,IER,NUMB,NTYP)
        CALL GQWKCA(NTYP,IER,NCAT)
        IF (NCAT .EQ. 3) GO TO 20
   10 CONTINUE
      GO TO 102
   20 CONTINUE
C
C  Make sure that WISS is open (IWISSI is initialized to an
C  arbitrary illegal value).
C
      IWISSI = -1335
      CALL GQOPWK(1,IER,IOL,IWKID)
      NUMOP = IOL
      IF (NUMOP .LT. 1) GO TO 103
      IF (NUMOP .GT. 100) GO TO 104
      DO 30 I=1,NUMOP
      CALL GQOPWK(I,IER,IOL,IOPWKS(I))
      IOACT(I) = 0
      CALL GQWKS(IOPWKS(I),IER,IOACT(I))
      CALL GQWKC(IOPWKS(I),IER,ICON,ITYPE)
      CALL GQWKCA(ITYPE,IER,ICAT)
      IF (ICAT .EQ. 3) THEN
        IWISSI = IOPWKS(I)
        CALL GQWKC(IWISSI,IER,ICONW,ITYPE)
      ENDIF
   30 CONTINUE
      IF (IWISSI .EQ. -1335) GO TO 103
C
C  Encode parameters into input data record.
C
      IDR(1) = ' '
      IDR(2) = ' '
      IFID = -1392
      ILEN = LEN(FNAME)
      WRITE(IDR(1)( 1:10),500) IFID
      WRITE(IDR(1)(11:20),500) ID
      WRITE(IDR(1)(21:23),501) ICONW
      IF (ILEN .LE. 57) THEN
        IDR(1)(24:24+ILEN-1) = FNAME(1:ILEN)
      ELSE IF (ILEN .LE. 137) THEN
        IDR(1)(24:24+ILEN-1) = FNAME(1:57)
        IDR(2)(1:ILEN-57) = FNAME(58:ILEN)
      ELSE
        GO TO 107
      ENDIF
      CALL PLOTIT(0,0,2)
      IF (ILEN .LE. 57) THEN
        CALL GESC(IFID,1,IDR,1,IDUM,ODR)
      ELSE
        CALL GESC(IFID,2,IDR,1,IDUM,ODR)
      ENDIF
      CALL PLOTIT(0,0,2)
      RETURN
C
  102 CONTINUE
      CALL GECLKS
      CALL SETER(' GFLAS4 -- THE NON NCAR GKS PACKAGE IS NOT LEVEL 2',
     -           10,2)
      STOP
  103 CONTINUE
      CALL GECLKS
      CALL SETER(' GFLAS4 -- WISS MUST BE OPEN BEFORE CALL TO GFLAS4',
     -           11,2)
      STOP
  104 CONTINUE
      CALL GECLKS
      CALL SETER(' GFLAS4 -- MAXIMUM NUMBER OF OPEN WORKSTATIONS ALLOWED
     - IS 100',12,2)
      STOP
  105 CONTINUE
      CALL GECLKS
      CALL SETER(' GFLAS4 -- GKS MUST BE OPEN BEFORE A CALL TO GFLAS4',
     -  13,2)
  106 CONTINUE
      CALL GECLKS
      CALL SETER(' GFLAS4 -- CANNOT BE CALLED WHILE GFLAS1 IS STILL OPEN
     -',14,2)
  107 CONTINUE
      CALL GECLKS
      CALL SETER(' GFLAS4 -- Maximum length of a file name is 137 charac
     -ters',15,2)
C
  500 FORMAT(I10)
  501 FORMAT(I3)
C
      END

C
C $Id: tdctri.f,v 1.5 2008-07-27 00:17:32 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE TDCTRI (RTRI,MTRI,NTRI,IAXS,RCUT)
C
        DIMENSION RTRI(10,MTRI)
C
C The object of this routine is to cut into pieces all the triangles in
C a TDPACK triangle list that intersect a plane perpendicular to one of
C the axes; each piece lies entirely on one side or the other of that
C plane.  IAXS says which axis the plane is perpendicular to (IAXS = 1,
C 2, or 3 for the X, Y, or Z axis).  RCUT is the value along the axis at
C which the plane is positioned.
C
        NTIN=NTRI
C
        IF (IAXS.EQ.1) THEN
C
          DO 101 I=1,NTIN
            IF          (RTRI(1,I).LT.RCUT) THEN
              IF        (RTRI(4,I).LT.RCUT) THEN
                IF      (RTRI(7,I).LT.RCUT) THEN
C                 1 <  4 <  7 <
                  GO TO 101
                ELSE IF (RTRI(7,I).GT.RCUT) THEN
C                 1 <  4 <  7 >
                  IODD=7
                ELSE IF (RTRI(7,I).EQ.RCUT) THEN
C                 1 <  4 <  7 =
                  GO TO 101
                END IF
              ELSE IF   (RTRI(4,I).GT.RCUT) THEN
                IF      (RTRI(7,I).LT.RCUT) THEN
C                 1 <  4 >  7 <
                  IODD=4
                ELSE IF (RTRI(7,I).GT.RCUT) THEN
C                 1 <  4 >  7 >
                  IODD=1
                ELSE IF (RTRI(7,I).EQ.RCUT) THEN
C                 1 <  4 >  7 =
                  IODD=7
                END IF
              ELSE IF   (RTRI(4,I).EQ.RCUT) THEN
                IF      (RTRI(7,I).LT.RCUT) THEN
C                 1 <  4 =  7 <
                  GO TO 101
                ELSE IF (RTRI(7,I).GT.RCUT) THEN
C                 1 <  4 =  7 >
                  IODD=4
                ELSE IF (RTRI(7,I).EQ.RCUT) THEN
C                 1 <  4 =  7 =
                  GO TO 101
                END IF
              END IF
            ELSE IF     (RTRI(1,I).GT.RCUT) THEN
              IF        (RTRI(4,I).LT.RCUT) THEN
                IF      (RTRI(7,I).LT.RCUT) THEN
C                 1 >  4 <  7 <
                  IODD=1
                ELSE IF (RTRI(7,I).GT.RCUT) THEN
C                 1 >  4 <  7 >
                  IODD=4
                ELSE IF (RTRI(7,I).EQ.RCUT) THEN
C                 1 >  4 <  7 =
                  IODD=7
                END IF
              ELSE IF   (RTRI(4,I).GT.RCUT) THEN
                IF      (RTRI(7,I).LT.RCUT) THEN
C                 1 >  4 >  7 <
                  IODD=7
                ELSE IF (RTRI(7,I).GT.RCUT) THEN
C                 1 >  4 >  7 >
                  GO TO 101
                ELSE IF (RTRI(7,I).EQ.RCUT) THEN
C                 1 >  4 >  7 =
                  GO TO 101
                END IF
              ELSE IF   (RTRI(4,I).EQ.RCUT) THEN
                IF      (RTRI(7,I).LT.RCUT) THEN
C                 1 >  4 =  7 <
                  IODD=4
                ELSE IF (RTRI(7,I).GT.RCUT) THEN
C                 1 >  4 =  7 >
                  GO TO 101
                ELSE IF (RTRI(7,I).EQ.RCUT) THEN
C                 1 >  4 =  7 =
                  GO TO 101
                END IF
              END IF
            ELSE IF     (RTRI(1,I).EQ.RCUT) THEN
              IF        (RTRI(4,I).LT.RCUT) THEN
                IF      (RTRI(7,I).LT.RCUT) THEN
C                 1 =  4 <  7 <
                  GO TO 101
                ELSE IF (RTRI(7,I).GT.RCUT) THEN
C                 1 =  4 <  7 >
                  IODD=1
                ELSE IF (RTRI(7,I).EQ.RCUT) THEN
C                 1 =  4 <  7 =
                  GO TO 101
                END IF
              ELSE IF   (RTRI(4,I).GT.RCUT) THEN
                IF      (RTRI(7,I).LT.RCUT) THEN
C                 1 =  4 >  7 <
                  IODD=1
                ELSE IF (RTRI(7,I).GT.RCUT) THEN
C                 1 =  4 >  7 >
                  GO TO 101
                ELSE IF (RTRI(7,I).EQ.RCUT) THEN
C                 1 =  4 >  7 =
                  GO TO 101
                END IF
              ELSE IF   (RTRI(4,I).EQ.RCUT) THEN
                IF      (RTRI(7,I).LT.RCUT) THEN
C                 1 =  4 =  7 <
                  GO TO 101
                ELSE IF (RTRI(7,I).GT.RCUT) THEN
C                 1 =  4 =  7 >
                  GO TO 101
                ELSE IF (RTRI(7,I).EQ.RCUT) THEN
C                 1 =  4 =  7 =
                  GO TO 101
                END IF
              END IF
            END IF
            IOMI=MOD(IODD+5,9)+1
            IOPL=MOD(IODD+2,9)+1
            IF (RTRI(IODD,I).EQ.RCUT) THEN
              NTRI=NTRI+1
              RTRI(1,NTRI)=RCUT
              RTRI(2,NTRI)=RTRI(IOMI+1,I)+
     +                     (RTRI(IOPL+1,I)-RTRI(IOMI+1,I))*
     +                     ((         RCUT-RTRI(IOMI  ,I))/
     +                     (RTRI(IOPL  ,I)-RTRI(IOMI  ,I)))
              RTRI(3,NTRI)=RTRI(IOMI+2,I)+
     +                     (RTRI(IOPL+2,I)-RTRI(IOMI+2,I))*
     +                     ((         RCUT-RTRI(IOMI  ,I))/
     +                     (RTRI(IOPL  ,I)-RTRI(IOMI  ,I)))
              RTRI(4,NTRI)=RTRI(IODD  ,I)
              RTRI(5,NTRI)=RTRI(IODD+1,I)
              RTRI(6,NTRI)=RTRI(IODD+2,I)
              RTRI(7,NTRI)=RTRI(IOPL  ,I)
              RTRI(8,NTRI)=RTRI(IOPL+1,I)
              RTRI(9,NTRI)=RTRI(IOPL+2,I)
              RTRI(10,NTRI)=RTRI(10,I)
              RTRI(IOPL  ,I)=RTRI(1,NTRI)
              RTRI(IOPL+1,I)=RTRI(2,NTRI)
              RTRI(IOPL+2,I)=RTRI(3,NTRI)
              IF (NTRI.EQ.MTRI) RETURN
            ELSE
              NTRI=NTRI+1
              RTRI(1,NTRI)=RCUT
              RTRI(2,NTRI)=RTRI(IOMI+1,I)+
     +                     (RTRI(IODD+1,I)-RTRI(IOMI+1,I))*
     +                     ((         RCUT-RTRI(IOMI  ,I))/
     +                     (RTRI(IODD  ,I)-RTRI(IOMI  ,I)))
              RTRI(3,NTRI)=RTRI(IOMI+2,I)+
     +                     (RTRI(IODD+2,I)-RTRI(IOMI+2,I))*
     +                     ((         RCUT-RTRI(IOMI  ,I))/
     +                     (RTRI(IODD  ,I)-RTRI(IOMI  ,I)))
              RTRI(4,NTRI)=RCUT
              RTRI(5,NTRI)=RTRI(IOPL+1,I)+
     +                     (RTRI(IODD+1,I)-RTRI(IOPL+1,I))*
     +                     ((         RCUT-RTRI(IOPL  ,I))/
     +                     (RTRI(IODD  ,I)-RTRI(IOPL  ,I)))
              RTRI(6,NTRI)=RTRI(IOPL+2,I)+
     +                     (RTRI(IODD+2,I)-RTRI(IOPL+2,I))*
     +                     ((         RCUT-RTRI(IOPL  ,I))/
     +                     (RTRI(IODD  ,I)-RTRI(IOPL  ,I)))
              RTRI(7,NTRI)=RTRI(IOPL  ,I)
              RTRI(8,NTRI)=RTRI(IOPL+1,I)
              RTRI(9,NTRI)=RTRI(IOPL+2,I)
              RTRI(10,NTRI)=RTRI(10,I)
              IF (NTRI.EQ.MTRI) RETURN
              NTRI=NTRI+1
              RTRI(1,NTRI)=RTRI(IOMI  ,I)
              RTRI(2,NTRI)=RTRI(IOMI+1,I)
              RTRI(3,NTRI)=RTRI(IOMI+2,I)
              RTRI(4,NTRI)=RTRI(1,NTRI-1)
              RTRI(5,NTRI)=RTRI(2,NTRI-1)
              RTRI(6,NTRI)=RTRI(3,NTRI-1)
              RTRI(7,NTRI)=RTRI(IOPL  ,I)
              RTRI(8,NTRI)=RTRI(IOPL+1,I)
              RTRI(9,NTRI)=RTRI(IOPL+2,I)
              RTRI(10,NTRI)=RTRI(10,I)
              RTRI(IOMI  ,I)=RTRI(1,NTRI-1)
              RTRI(IOMI+1,I)=RTRI(2,NTRI-1)
              RTRI(IOMI+2,I)=RTRI(3,NTRI-1)
              RTRI(IOPL  ,I)=RTRI(4,NTRI-1)
              RTRI(IOPL+1,I)=RTRI(5,NTRI-1)
              RTRI(IOPL+2,I)=RTRI(6,NTRI-1)
              IF (NTRI.EQ.MTRI) RETURN
            END IF
  101     CONTINUE
C
        ELSE IF (IAXS.EQ.2) THEN
C
          DO 102 I=1,NTIN
            IF          (RTRI(2,I).LT.RCUT) THEN
              IF        (RTRI(5,I).LT.RCUT) THEN
                IF      (RTRI(8,I).LT.RCUT) THEN
C                 2 <  5 <  8 <
                  GO TO 102
                ELSE IF (RTRI(8,I).GT.RCUT) THEN
C                 2 <  5 <  8 >
                  IODD=8
                ELSE IF (RTRI(8,I).EQ.RCUT) THEN
C                 2 <  5 <  8 =
                  GO TO 102
                END IF
              ELSE IF   (RTRI(5,I).GT.RCUT) THEN
                IF      (RTRI(8,I).LT.RCUT) THEN
C                 2 <  5 >  8 <
                  IODD=5
                ELSE IF (RTRI(8,I).GT.RCUT) THEN
C                 2 <  5 >  8 >
                  IODD=2
                ELSE IF (RTRI(8,I).EQ.RCUT) THEN
C                 2 <  5 >  8 =
                  IODD=8
                END IF
              ELSE IF   (RTRI(5,I).EQ.RCUT) THEN
                IF      (RTRI(8,I).LT.RCUT) THEN
C                 2 <  5 =  8 <
                  GO TO 102
                ELSE IF (RTRI(8,I).GT.RCUT) THEN
C                 2 <  5 =  8 >
                  IODD=5
                ELSE IF (RTRI(8,I).EQ.RCUT) THEN
C                 2 <  5 =  8 =
                  GO TO 102
                END IF
              END IF
            ELSE IF     (RTRI(2,I).GT.RCUT) THEN
              IF        (RTRI(5,I).LT.RCUT) THEN
                IF      (RTRI(8,I).LT.RCUT) THEN
C                 2 >  5 <  8 <
                  IODD=2
                ELSE IF (RTRI(8,I).GT.RCUT) THEN
C                 2 >  5 <  8 >
                  IODD=5
                ELSE IF (RTRI(8,I).EQ.RCUT) THEN
C                 2 >  5 <  8 =
                  IODD=8
                END IF
              ELSE IF   (RTRI(5,I).GT.RCUT) THEN
                IF      (RTRI(8,I).LT.RCUT) THEN
C                 2 >  5 >  8 <
                  IODD=8
                ELSE IF (RTRI(8,I).GT.RCUT) THEN
C                 2 >  5 >  8 >
                  GO TO 102
                ELSE IF (RTRI(8,I).EQ.RCUT) THEN
C                 2 >  5 >  8 =
                  GO TO 102
                END IF
              ELSE IF   (RTRI(5,I).EQ.RCUT) THEN
                IF      (RTRI(8,I).LT.RCUT) THEN
C                 2 >  5 =  8 <
                  IODD=5
                ELSE IF (RTRI(8,I).GT.RCUT) THEN
C                 2 >  5 =  8 >
                  GO TO 102
                ELSE IF (RTRI(8,I).EQ.RCUT) THEN
C                 2 >  5 =  8 =
                  GO TO 102
                END IF
              END IF
            ELSE IF     (RTRI(2,I).EQ.RCUT) THEN
              IF        (RTRI(5,I).LT.RCUT) THEN
                IF      (RTRI(8,I).LT.RCUT) THEN
C                 2 =  5 <  8 <
                  GO TO 102
                ELSE IF (RTRI(8,I).GT.RCUT) THEN
C                 2 =  5 <  8 >
                  IODD=2
                ELSE IF (RTRI(8,I).EQ.RCUT) THEN
C                 2 =  5 <  8 =
                  GO TO 102
                END IF
              ELSE IF   (RTRI(5,I).GT.RCUT) THEN
                IF      (RTRI(8,I).LT.RCUT) THEN
C                 2 =  5 >  8 <
                  IODD=2
                ELSE IF (RTRI(8,I).GT.RCUT) THEN
C                 2 =  5 >  8 >
                  GO TO 102
                ELSE IF (RTRI(8,I).EQ.RCUT) THEN
C                 2 =  5 >  8 =
                  GO TO 102
                END IF
              ELSE IF   (RTRI(5,I).EQ.RCUT) THEN
                IF      (RTRI(8,I).LT.RCUT) THEN
C                 2 =  5 =  8 <
                  GO TO 102
                ELSE IF (RTRI(8,I).GT.RCUT) THEN
C                 2 =  5 =  8 >
                  GO TO 102
                ELSE IF (RTRI(8,I).EQ.RCUT) THEN
C                 2 =  5 =  8 =
                  GO TO 102
                END IF
              END IF
            END IF
            IOMI=MOD(IODD+5,9)+1
            IOPL=MOD(IODD+2,9)+1
            IF (RTRI(IODD,I).EQ.RCUT) THEN
              NTRI=NTRI+1
              RTRI(1,NTRI)=RTRI(IOMI-1,I)+
     +                     (RTRI(IOPL-1,I)-RTRI(IOMI-1,I))*
     +                     ((         RCUT-RTRI(IOMI  ,I))/
     +                     (RTRI(IOPL  ,I)-RTRI(IOMI  ,I)))
              RTRI(2,NTRI)=RCUT
              RTRI(3,NTRI)=RTRI(IOMI+1,I)+
     +                     (RTRI(IOPL+1,I)-RTRI(IOMI+1,I))*
     +                     ((         RCUT-RTRI(IOMI  ,I))/
     +                     (RTRI(IOPL  ,I)-RTRI(IOMI  ,I)))
              RTRI(4,NTRI)=RTRI(IODD-1,I)
              RTRI(5,NTRI)=RTRI(IODD  ,I)
              RTRI(6,NTRI)=RTRI(IODD+1,I)
              RTRI(7,NTRI)=RTRI(IOPL-1,I)
              RTRI(8,NTRI)=RTRI(IOPL  ,I)
              RTRI(9,NTRI)=RTRI(IOPL+1,I)
              RTRI(10,NTRI)=RTRI(10,I)
              RTRI(IOPL-1,I)=RTRI(1,NTRI)
              RTRI(IOPL  ,I)=RTRI(2,NTRI)
              RTRI(IOPL+1,I)=RTRI(3,NTRI)
              IF (NTRI.EQ.MTRI) RETURN
            ELSE
              NTRI=NTRI+1
              RTRI(1,NTRI)=RTRI(IOMI-1,I)+
     +                     (RTRI(IODD-1,I)-RTRI(IOMI-1,I))*
     +                     ((         RCUT-RTRI(IOMI  ,I))/
     +                     (RTRI(IODD  ,I)-RTRI(IOMI  ,I)))
              RTRI(2,NTRI)=RCUT
              RTRI(3,NTRI)=RTRI(IOMI+1,I)+
     +                     (RTRI(IODD+1,I)-RTRI(IOMI+1,I))*
     +                     ((         RCUT-RTRI(IOMI  ,I))/
     +                     (RTRI(IODD  ,I)-RTRI(IOMI  ,I)))
              RTRI(4,NTRI)=RTRI(IOPL-1,I)+
     +                     (RTRI(IODD-1,I)-RTRI(IOPL-1,I))*
     +                     ((         RCUT-RTRI(IOPL  ,I))/
     +                     (RTRI(IODD  ,I)-RTRI(IOPL  ,I)))
              RTRI(5,NTRI)=RCUT
              RTRI(6,NTRI)=RTRI(IOPL+1,I)+
     +                     (RTRI(IODD+1,I)-RTRI(IOPL+1,I))*
     +                     ((         RCUT-RTRI(IOPL  ,I))/
     +                     (RTRI(IODD  ,I)-RTRI(IOPL  ,I)))
              RTRI(7,NTRI)=RTRI(IOPL-1,I)
              RTRI(8,NTRI)=RTRI(IOPL  ,I)
              RTRI(9,NTRI)=RTRI(IOPL+1,I)
              RTRI(10,NTRI)=RTRI(10,I)
              IF (NTRI.EQ.MTRI) RETURN
              NTRI=NTRI+1
              RTRI(1,NTRI)=RTRI(IOMI-1,I)
              RTRI(2,NTRI)=RTRI(IOMI  ,I)
              RTRI(3,NTRI)=RTRI(IOMI+1,I)
              RTRI(4,NTRI)=RTRI(1,NTRI-1)
              RTRI(5,NTRI)=RTRI(2,NTRI-1)
              RTRI(6,NTRI)=RTRI(3,NTRI-1)
              RTRI(7,NTRI)=RTRI(IOPL-1,I)
              RTRI(8,NTRI)=RTRI(IOPL  ,I)
              RTRI(9,NTRI)=RTRI(IOPL+1,I)
              RTRI(10,NTRI)=RTRI(10,I)
              RTRI(IOMI-1,I)=RTRI(1,NTRI-1)
              RTRI(IOMI  ,I)=RTRI(2,NTRI-1)
              RTRI(IOMI+1,I)=RTRI(3,NTRI-1)
              RTRI(IOPL-1,I)=RTRI(4,NTRI-1)
              RTRI(IOPL  ,I)=RTRI(5,NTRI-1)
              RTRI(IOPL+1,I)=RTRI(6,NTRI-1)
              IF (NTRI.EQ.MTRI) RETURN
            END IF
  102     CONTINUE
C
        ELSE IF (IAXS.EQ.3) THEN
C
          DO 103 I=1,NTIN
            IF          (RTRI(3,I).LT.RCUT) THEN
              IF        (RTRI(6,I).LT.RCUT) THEN
                IF      (RTRI(9,I).LT.RCUT) THEN
C                 3 <  6 <  9 <
                  GO TO 103
                ELSE IF (RTRI(9,I).GT.RCUT) THEN
C                 3 <  6 <  9 >
                  IODD=9
                ELSE IF (RTRI(9,I).EQ.RCUT) THEN
C                 3 <  6 <  9 =
                  GO TO 103
                END IF
              ELSE IF   (RTRI(6,I).GT.RCUT) THEN
                IF      (RTRI(9,I).LT.RCUT) THEN
C                 3 <  6 >  9 <
                  IODD=6
                ELSE IF (RTRI(9,I).GT.RCUT) THEN
C                 3 <  6 >  9 >
                  IODD=3
                ELSE IF (RTRI(9,I).EQ.RCUT) THEN
C                 3 <  6 >  9 =
                  IODD=9
                END IF
              ELSE IF   (RTRI(6,I).EQ.RCUT) THEN
                IF      (RTRI(9,I).LT.RCUT) THEN
C                 3 <  6 =  9 <
                  GO TO 103
                ELSE IF (RTRI(9,I).GT.RCUT) THEN
C                 3 <  6 =  9 >
                  IODD=6
                ELSE IF (RTRI(9,I).EQ.RCUT) THEN
C                 3 <  6 =  9 =
                  GO TO 103
                END IF
              END IF
            ELSE IF     (RTRI(3,I).GT.RCUT) THEN
              IF        (RTRI(6,I).LT.RCUT) THEN
                IF      (RTRI(9,I).LT.RCUT) THEN
C                 3 >  6 <  9 <
                  IODD=3
                ELSE IF (RTRI(9,I).GT.RCUT) THEN
C                 3 >  6 <  9 >
                  IODD=6
                ELSE IF (RTRI(9,I).EQ.RCUT) THEN
C                 3 >  6 <  9 =
                  IODD=9
                END IF
              ELSE IF   (RTRI(6,I).GT.RCUT) THEN
                IF      (RTRI(9,I).LT.RCUT) THEN
C                 3 >  6 >  9 <
                  IODD=9
                ELSE IF (RTRI(9,I).GT.RCUT) THEN
C                 3 >  6 >  9 >
                  GO TO 103
                ELSE IF (RTRI(9,I).EQ.RCUT) THEN
C                 3 >  6 >  9 =
                  GO TO 103
                END IF
              ELSE IF   (RTRI(6,I).EQ.RCUT) THEN
                IF      (RTRI(9,I).LT.RCUT) THEN
C                 3 >  6 =  9 <
                  IODD=6
                ELSE IF (RTRI(9,I).GT.RCUT) THEN
C                 3 >  6 =  9 >
                  GO TO 103
                ELSE IF (RTRI(9,I).EQ.RCUT) THEN
C                 3 >  6 =  9 =
                  GO TO 103
                END IF
              END IF
            ELSE IF     (RTRI(3,I).EQ.RCUT) THEN
              IF        (RTRI(6,I).LT.RCUT) THEN
                IF      (RTRI(9,I).LT.RCUT) THEN
C                 3 =  6 <  9 <
                  GO TO 103
                ELSE IF (RTRI(9,I).GT.RCUT) THEN
C                 3 =  6 <  9 >
                  IODD=3
                ELSE IF (RTRI(9,I).EQ.RCUT) THEN
C                 3 =  6 <  9 =
                  GO TO 103
                END IF
              ELSE IF   (RTRI(6,I).GT.RCUT) THEN
                IF      (RTRI(9,I).LT.RCUT) THEN
C                 3 =  6 >  9 <
                  IODD=3
                ELSE IF (RTRI(9,I).GT.RCUT) THEN
C                 3 =  6 >  9 >
                  GO TO 103
                ELSE IF (RTRI(9,I).EQ.RCUT) THEN
C                 3 =  6 >  9 =
                  GO TO 103
                END IF
              ELSE IF   (RTRI(6,I).EQ.RCUT) THEN
                IF      (RTRI(9,I).LT.RCUT) THEN
C                 3 =  6 =  9 <
                  GO TO 103
                ELSE IF (RTRI(9,I).GT.RCUT) THEN
C                 3 =  6 =  9 >
                  GO TO 103
                ELSE IF (RTRI(9,I).EQ.RCUT) THEN
C                 3 =  6 =  9 =
                  GO TO 103
                END IF
              END IF
            END IF
            IOMI=MOD(IODD+5,9)+1
            IOPL=MOD(IODD+2,9)+1
            IF (RTRI(IODD,I).EQ.RCUT) THEN
              NTRI=NTRI+1
              RTRI(1,NTRI)=RTRI(IOMI-2,I)+
     +                     (RTRI(IOPL-2,I)-RTRI(IOMI-2,I))*
     +                     ((         RCUT-RTRI(IOMI  ,I))/
     +                     (RTRI(IOPL  ,I)-RTRI(IOMI  ,I)))
              RTRI(2,NTRI)=RTRI(IOMI-1,I)+
     +                     (RTRI(IOPL-1,I)-RTRI(IOMI-1,I))*
     +                     ((         RCUT-RTRI(IOMI  ,I))/
     +                     (RTRI(IOPL  ,I)-RTRI(IOMI  ,I)))
              RTRI(3,NTRI)=RCUT
              RTRI(4,NTRI)=RTRI(IODD-2,I)
              RTRI(5,NTRI)=RTRI(IODD-1,I)
              RTRI(6,NTRI)=RTRI(IODD  ,I)
              RTRI(7,NTRI)=RTRI(IOPL-2,I)
              RTRI(8,NTRI)=RTRI(IOPL-1,I)
              RTRI(9,NTRI)=RTRI(IOPL  ,I)
              RTRI(10,NTRI)=RTRI(10,I)
              RTRI(IOPL-2,I)=RTRI(1,NTRI)
              RTRI(IOPL-1,I)=RTRI(2,NTRI)
              RTRI(IOPL  ,I)=RTRI(3,NTRI)
              IF (NTRI.EQ.MTRI) RETURN
            ELSE
              NTRI=NTRI+1
              RTRI(1,NTRI)=RTRI(IOMI-2,I)+
     +                     (RTRI(IODD-2,I)-RTRI(IOMI-2,I))*
     +                     ((         RCUT-RTRI(IOMI  ,I))/
     +                     (RTRI(IODD  ,I)-RTRI(IOMI  ,I)))
              RTRI(2,NTRI)=RTRI(IOMI-1,I)+
     +                     (RTRI(IODD-1,I)-RTRI(IOMI-1,I))*
     +                     ((         RCUT-RTRI(IOMI  ,I))/
     +                     (RTRI(IODD  ,I)-RTRI(IOMI  ,I)))
              RTRI(3,NTRI)=RCUT
              RTRI(4,NTRI)=RTRI(IOPL-2,I)+
     +                     (RTRI(IODD-2,I)-RTRI(IOPL-2,I))*
     +                     ((         RCUT-RTRI(IOPL  ,I))/
     +                     (RTRI(IODD  ,I)-RTRI(IOPL  ,I)))
              RTRI(5,NTRI)=RTRI(IOPL-1,I)+
     +                     (RTRI(IODD-1,I)-RTRI(IOPL-1,I))*
     +                     ((         RCUT-RTRI(IOPL  ,I))/
     +                     (RTRI(IODD  ,I)-RTRI(IOPL  ,I)))
              RTRI(6,NTRI)=RCUT
              RTRI(7,NTRI)=RTRI(IOPL-2,I)
              RTRI(8,NTRI)=RTRI(IOPL-1,I)
              RTRI(9,NTRI)=RTRI(IOPL  ,I)
              RTRI(10,NTRI)=RTRI(10,I)
              IF (NTRI.EQ.MTRI) RETURN
              NTRI=NTRI+1
              RTRI(1,NTRI)=RTRI(IOMI-2,I)
              RTRI(2,NTRI)=RTRI(IOMI-1,I)
              RTRI(3,NTRI)=RTRI(IOMI  ,I)
              RTRI(4,NTRI)=RTRI(1,NTRI-1)
              RTRI(5,NTRI)=RTRI(2,NTRI-1)
              RTRI(6,NTRI)=RTRI(3,NTRI-1)
              RTRI(7,NTRI)=RTRI(IOPL-2,I)
              RTRI(8,NTRI)=RTRI(IOPL-1,I)
              RTRI(9,NTRI)=RTRI(IOPL  ,I)
              RTRI(10,NTRI)=RTRI(10,I)
              RTRI(IOMI-2,I)=RTRI(1,NTRI-1)
              RTRI(IOMI-1,I)=RTRI(2,NTRI-1)
              RTRI(IOMI  ,I)=RTRI(3,NTRI-1)
              RTRI(IOPL-2,I)=RTRI(4,NTRI-1)
              RTRI(IOPL-1,I)=RTRI(5,NTRI-1)
              RTRI(IOPL  ,I)=RTRI(6,NTRI-1)
              IF (NTRI.EQ.MTRI) RETURN
            END IF
  103     CONTINUE
C
        END IF
C
C Done.
C
        RETURN
C
      END

C
C	$Id: wmdrfl.f,v 1.4 2008-07-27 00:17:36 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE WMDRFL(N,X,Y)
C
C  Draw the polyline (X(L),Y(L),L=1,N) with a thickness of SLINWD.
C
      DIMENSION X(N),Y(N)
C
      include 'wmcomn.h'
C
C  First, make sure that a line is drawn in case SLINWD is too
C  small.
C
      IF (SLINWD .LT. 0.01) THEN
        CALL GQLWSC(IER,OLDSCL)
        CALL GSLWSC(1.)
        CALL GPL(N,X,Y)
        CALL GSLWSC(OLDSCL)
      ENDIF
C
C  Draw fat line segments.
C
      DO 10 I=1,N-1
        CALL WMDRFS(X(I),Y(I),X(I+1),Y(I+1))
   10 CONTINUE
C
C  Draw circles at line segment joins so that there are no notches.
C
      CALL NGDOTS(X,Y,N,SLINWD,1)
C
      RETURN
      END

      PROGRAM TCNSUP
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C OPEN GKS, OPEN WORKSTATION OF TYPE 1, ACTIVATE WORKSTATION
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C INVOKE DEMO DRIVER
C
      CALL CNSUP(IERR)
C
C DEACTIVATE AND CLOSE WORKSTATION, CLOSE GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END
C
      SUBROUTINE CNSUP (IERROR)
C
C PURPOSE                To provide a simple demonstration of
C                        the CONRECSPR package.
C
C USAGE                  CALL CNSUP (IERROR)
C
C ARGUMENTS
C
C ON OUTPUT              IERROR
C                          An integer variable
C                          = 0, if the test was successful,
C                          = 1, otherwise
C
C I/O                    If the test is successful, the message
C
C               CONRECSPR TEST EXECUTED--SEE PLOTS TO CERTIFY
C
C                        is printed on unit 6.  In addition, 2 output
C                        frames are produced on the machine graphics
C                        device.  In order to determine if the test
C                        was successful, it is necessary to examine
C                        the plots.
C
C PRECISION              Single
C
C LANGUAGE               FORTRAN 77
C
C REQUIRED ROUTINES      CONRECSPR, DASHSUPR
C
C REQUIRED GKS LEVEL     0A
C
C ALGORITHM              The function
C
C                          Z(X,Y) = X + Y + 1./((X-.1)**2+Y**2+.09)
C                                   -1./((X+.1)**2+Y**2+.09)
C
C                        for X = -1. to +1. in increments of .1, and
C                            Y = -1.2 to +1.2 in increments of .1,
C                        is computed.  Then, entries EZCNTR and CONREC
C                        are called to generate contour plots of Z.
C
C                        This is the highest quality entry of the
C                        CONREC family of utilities.
C
C
C Z contains the values to be plotted.
C
      REAL            Z(21,25)
C
C Define the position of the title.
C
      DATA TX/.4267/, TY/.9765/
C
C
C Initialize the error parameter.
C
      IERROR = 0
C
C Fill a 2-D array to be plotted.
C
      DO  20 I=1,21
         X = .1*REAL(I-11)
         DO  10 J=1,25
            Y = .1*REAL(J-13)
            Z(I,J) = X+Y+1./((X-.10)**2+Y**2+.09)-
     1               1./((X+.10)**2+Y**2+.09)
   10    CONTINUE
   20 CONTINUE
C
C Select normalization transformation number 0.
C
      CALL GSELNT (0)
C
C
C     Frame 1 -- EZCNTR entry of CONRECSPR.
C
C Entry EZCNTR requires only the array name and dimensions.
C
      CALL PLCHLQ (TX, TY,
     1   'DEMONSTRATION PLOT FOR EZCNTR ENTRY OF CONRECSPR',16.,0.,0.)
      CALL EZCNTR (Z,21,25)
C
C
C     Frame 2 -- CONREC entry of CONRECSPR.
C
C Entry CONREC allows user definition of various plot parameters.
C
C In this example, the lowest contour level (-4.5), the highest contour
C level (4.5), and the increment between contour levels (0.3) are set.
C
      CALL PLCHLQ (TX,TY,
     1           'DEMONSTRATION PLOT FOR CONREC ENTRY OF CONRECSPR',
     2           16.,0.,0.)
      CALL CONREC (Z,21,21,25,-4.5,4.5,.3,0,-1,0)
      CALL FRAME
C
      WRITE (6,1001)
      RETURN
C
 1001 FORMAT (' CONRECSPR TEST EXECUTED--SEE PLOTS TO CERTIFY')
C
      END

c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by UCAR                 .
c  .                                                             .
c  .       University Corporation for Atmospheric Research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                         SPHEREPACK                          .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c
c
c ... file vtses.f
c
c     this file includes documentation and code for
c     subroutines vtses and vtsesi
c
c ... files which must be loaded with vtses.f
c
c     sphcom.f, hrfft.f, vhaes.f, vhses.f
c
c
c     subroutine vtses(nlat,nlon,ityp,nt,vt,wt,idvw,jdvw,br,bi,cr,ci,
c    +                 mdab,ndab,wvts,lwvts,work,lwork,ierror)
c
c     given the vector harmonic analysis br,bi,cr, and ci (computed
c     by subroutine vhaes) of some vector function (v,w), this
c     subroutine computes the vector function (vt,wt) which is
c     the derivative of (v,w) with respect to colatitude theta. vtses
c     is similar to vhses except the vector harmonics are replaced by
c     their derivative with respect to colatitude with the result that
c     (vt,wt) is computed instead of (v,w). vt(i,j) is the derivative
c     of the colatitudinal component v(i,j) at the point theta(i) =
c     (i-1)*pi/(nlat-1) and longitude phi(j) = (j-1)*2*pi/nlon. the
c     spectral representation of (vt,wt) is given below at output
c     parameters vt,wt.
c
c     input parameters
c
c     nlat   the number of colatitudes on the full sphere including the
c            poles. for example, nlat = 37 for a five degree grid.
c            nlat determines the grid increment in colatitude as
c            pi/(nlat-1).  if nlat is odd the equator is located at
c            grid point i=(nlat+1)/2. if nlat is even the equator is
c            located half way between points i=nlat/2 and i=nlat/2+1.
c            nlat must be at least 3. note: on the half sphere, the
c            number of grid points in the colatitudinal direction is
c            nlat/2 if nlat is even or (nlat+1)/2 if nlat is odd.
c
c     nlon   the number of distinct londitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater
c            than zero. the axisymmetric case corresponds to nlon=1.
c            the efficiency of the computation is improved when nlon
c            is a product of small prime numbers.
c
c     ityp   = 0  no symmetries exist about the equator. the synthesis
c                 is performed on the entire sphere. i.e. the arrays
c                 vt(i,j),wt(i,j) are computed for i=1,...,nlat and
c                 j=1,...,nlon.
c
c            = 1  no symmetries exist about the equator however the
c                 the coefficients cr and ci are zero. the synthesis
c                 is performed on the entire sphere.  i.e. the arrays
c                 vt(i,j),wt(i,j) are computed for i=1,...,nlat and
c                 j=1,...,nlon.
c
c            = 2  no symmetries exist about the equator however the
c                 the coefficients br and bi are zero. the synthesis
c                 is performed on the entire sphere.  i.e. the arrays
c                 vt(i,j),wt(i,j) are computed for i=1,...,nlat and
c                 j=1,...,nlon.
c
c            = 3  vt is odd and wt is even about the equator. the
c                 synthesis is performed on the northern hemisphere
c                 only.  i.e., if nlat is odd the arrays vt(i,j),wt(i,j)
c                 are computed for i=1,...,(nlat+1)/2 and j=1,...,nlon.
C*PL*ERROR* Comment line too long
c                 if nlat is even the arrays vt(i,j),wt(i,j) are computed
c                 for i=1,...,nlat/2 and j=1,...,nlon.
c
c            = 4  vt is odd and wt is even about the equator and the
c                 coefficients cr and ci are zero. the synthesis is
c                 performed on the northern hemisphere only. i.e. if
c                 nlat is odd the arrays vt(i,j),wt(i,j) are computed
c                 for i=1,...,(nlat+1)/2 and j=1,...,nlon. if nlat is
c                 even the arrays vt(i,j),wt(i,j) are computed for
c                 i=1,...,nlat/2 and j=1,...,nlon.
c
c            = 5  vt is odd and wt is even about the equator and the
c                 coefficients br and bi are zero. the synthesis is
c                 performed on the northern hemisphere only. i.e. if
c                 nlat is odd the arrays vt(i,j),wt(i,j) are computed
c                 for i=1,...,(nlat+1)/2 and j=1,...,nlon. if nlat is
c                 even the arrays vt(i,j),wt(i,j) are computed for
c                 i=1,...,nlat/2 and j=1,...,nlon.
c
c            = 6  vt is even and wt is odd about the equator. the
c                 synthesis is performed on the northern hemisphere
c                 only.  i.e., if nlat is odd the arrays vt(i,j),wt(i,j)
c                 are computed for i=1,...,(nlat+1)/2 and j=1,...,nlon.
C*PL*ERROR* Comment line too long
c                 if nlat is even the arrays vt(i,j),wt(i,j) are computed
c                 for i=1,...,nlat/2 and j=1,...,nlon.
c
c            = 7  vt is even and wt is odd about the equator and the
c                 coefficients cr and ci are zero. the synthesis is
c                 performed on the northern hemisphere only. i.e. if
c                 nlat is odd the arrays vt(i,j),wt(i,j) are computed
c                 for i=1,...,(nlat+1)/2 and j=1,...,nlon. if nlat is
c                 even the arrays vt(i,j),wt(i,j) are computed for
c                 i=1,...,nlat/2 and j=1,...,nlon.
c
c            = 8  vt is even and wt is odd about the equator and the
c                 coefficients br and bi are zero. the synthesis is
c                 performed on the northern hemisphere only. i.e. if
c                 nlat is odd the arrays vt(i,j),wt(i,j) are computed
c                 for i=1,...,(nlat+1)/2 and j=1,...,nlon. if nlat is
c                 even the arrays vt(i,j),wt(i,j) are computed for
c                 i=1,...,nlat/2 and j=1,...,nlon.
c
c     nt     the number of syntheses.  in the program that calls vtses,
c            the arrays vt,wt,br,bi,cr, and ci can be three dimensional
c            in which case multiple syntheses will be performed.
c            the third index is the synthesis index which assumes the
c            values k=1,...,nt.  for a single synthesis set nt=1. the
c            discription of the remaining parameters is simplified
c            by assuming that nt=1 or that all the arrays are two
c            dimensional.
c
c     idvw   the first dimension of the arrays vt,wt as it appears in
c            the program that calls vtses. if ityp .le. 2 then idvw
c            must be at least nlat.  if ityp .gt. 2 and nlat is
c            even then idvw must be at least nlat/2. if ityp .gt. 2
c            and nlat is odd then idvw must be at least (nlat+1)/2.
c
c     jdvw   the second dimension of the arrays vt,wt as it appears in
c            the program that calls vtses. jdvw must be at least nlon.
c
c     br,bi  two or three dimensional arrays (see input parameter nt)
c     cr,ci  that contain the vector spherical harmonic coefficients
c            of (v,w) as computed by subroutine vhaes.
c
c     mdab   the first dimension of the arrays br,bi,cr, and ci as it
c            appears in the program that calls vtses. mdab must be at
c            least min0(nlat,nlon/2) if nlon is even or at least
c            min0(nlat,(nlon+1)/2) if nlon is odd.
c
c     ndab   the second dimension of the arrays br,bi,cr, and ci as it
c            appears in the program that calls vtses. ndab must be at
c            least nlat.
c
c     wvts   an array which must be initialized by subroutine vtsesi.
c            once initialized, wvts can be used repeatedly by vtses
c            as long as nlon and nlat remain unchanged.  wvts must
c            not be altered between calls of vtses.
c
c     lwvts  the dimension of the array wvts as it appears in the
c            program that calls vtses. define
c
c               l1 = min0(nlat,nlon/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            then lwvts must be at least
c
c                 l1*l2*(nlat+nlat-l1+1)+nlon+15
c
c
c     work   a work array that does not have to be saved.
c
c     lwork  the dimension of the array work as it appears in the
c            program that calls vtses. define
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            if ityp .le. 2 then lwork must be at least
c
c                       (2*nt+1)*nlat*nlon
c
c            if ityp .gt. 2 then lwork must be at least
c
c                        (2*nt+1)*l2*nlon
c
c     **************************************************************
c
c     output parameters
c
c     vt,wt  two or three dimensional arrays (see input parameter nt)
c            in which the derivative of (v,w) with respect to
c            colatitude theta is stored. vt(i,j),wt(i,j) contain the
c            derivatives at colatitude theta(i) = (i-1)*pi/(nlat-1)
c            and longitude phi(j) = (j-1)*2*pi/nlon. the index ranges
c            are defined above at the input parameter ityp. vt and wt
c            are computed from the formulas for v and w given in
c            subroutine vhses but with vbar and wbar replaced with
c            their derivatives with respect to colatitude. these
c            derivatives are denoted by vtbar and wtbar.
c
c
c   *************************************************************
c
c   in terms of real variables this expansion takes the form
c
c             for i=1,...,nlat and  j=1,...,nlon
c
c     vt(i,j) = the sum from n=1 to n=nlat-1 of
c
c               .5*br(1,n+1)*vtbar(0,n,theta(i))
c
c     plus the sum from m=1 to m=mmax-1 of the sum from n=m to
c     n=nlat-1 of the real part of
c
c       (br(m+1,n+1)*vtbar(m,n,theta(i))
c                   -ci(m+1,n+1)*wtbar(m,n,theta(i)))*cos(m*phi(j))
c      -(bi(m+1,n+1)*vtbar(m,n,theta(i))
c                   +cr(m+1,n+1)*wtbar(m,n,theta(i)))*sin(m*phi(j))
c
c    and for i=1,...,nlat and  j=1,...,nlon
c
c     wt(i,j) = the sum from n=1 to n=nlat-1 of
c
c              -.5*cr(1,n+1)*vtbar(0,n,theta(i))
c
c     plus the sum from m=1 to m=mmax-1 of the sum from n=m to
c     n=nlat-1 of the real part of
c
c      -(cr(m+1,n+1)*vtbar(m,n,theta(i))
c                   +bi(m+1,n+1)*wtbar(m,n,theta(i)))*cos(m*phi(j))
c      +(ci(m+1,n+1)*vtbar(m,n,theta(i))
c                   -br(m+1,n+1)*wtbar(m,n,theta(i)))*sin(m*phi(j))
c
c
c      br(m+1,nlat),bi(m+1,nlat),cr(m+1,nlat), and ci(m+1,nlat) are
c      assumed zero for m even.
c
c
c     ierror = 0  no errors
c            = 1  error in the specification of nlat
c            = 2  error in the specification of nlon
c            = 3  error in the specification of ityp
c            = 4  error in the specification of nt
c            = 5  error in the specification of idvw
c            = 6  error in the specification of jdvw
c            = 7  error in the specification of mdab
c            = 8  error in the specification of ndab
c            = 9  error in the specification of lwvts
c            = 10 error in the specification of lwork
c
c
c *******************************************************************
c
c     subroutine vtsesi(nlat,nlon,wvts,lwvts,work,lwork,dwork,ldwork,
c    +                  ierror)
c
c     subroutine vtsesi initializes the array wvts which can then be
c     used repeatedly by subroutine vtses until nlat or nlon is changed.
c
c     input parameters
c
c     nlat   the number of colatitudes on the full sphere including the
c            poles. for example, nlat = 37 for a five degree grid.
c            nlat determines the grid increment in colatitude as
c            pi/(nlat-1).  if nlat is odd the equator is located at
c            grid point i=(nlat+1)/2. if nlat is even the equator is
c            located half way between points i=nlat/2 and i=nlat/2+1.
c            nlat must be at least 3. note: on the half sphere, the
c            number of grid points in the colatitudinal direction is
c            nlat/2 if nlat is even or (nlat+1)/2 if nlat is odd.
c
c     nlon   the number of distinct londitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater
c            than zero. the axisymmetric case corresponds to nlon=1.
c            the efficiency of the computation is improved when nlon
c            is a product of small prime numbers.
c
c     lwvts  the dimension of the array wvts as it appears in the
c            program that calls vtses. define
c
c               l1 = min0(nlat,nlon/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            then lwvts must be at least
c
c                  l1*l2*(nlat+nlat-l1+1)+nlon+15
c
c
c     work   a work array that does not have to be saved.
c
c     lwork  the dimension of the array work as it appears in the
c            program that calls vtses. lwork must be at least
c
c              3*(max0(l1-2,0)*(nlat+nlat-l1-1))/2+5*l2*nlat
c
c     dwork  a double precision work array that does have to be saved.
c
c     ldwork the length of dwork.  ldwork must be at least 2*(nlat+1)
c
c     **************************************************************
c
c     output parameters
c
c     wvts   an array which is initialized for use by subroutine vtses.
c            once initialized, wvts can be used repeatedly by vtses
c            as long as nlat or nlon remain unchanged.  wvts must not
c            be altered between calls of vtses.
c
c
c     ierror = 0  no errors
c            = 1  error in the specification of nlat
c            = 2  error in the specification of nlon
c            = 3  error in the specification of lwvts
c            = 4  error in the specification of lwork
c            = 5  error in the specification of ldwork
c
c ********************************************************************
c
      SUBROUTINE DVTSES(NLAT,NLON,ITYP,NT,VT,WT,IDVW,JDVW,BR,BI,CR,CI,
     +                 MDAB,NDAB,WVTS,LWVTS,WORK,LWORK,IERROR)
      DOUBLE PRECISION VT
      DOUBLE PRECISION WT
      DOUBLE PRECISION BR
      DOUBLE PRECISION BI
      DOUBLE PRECISION CR
      DOUBLE PRECISION CI
      DOUBLE PRECISION WVTS
      DOUBLE PRECISION WORK
c
      DIMENSION VT(IDVW,JDVW,1),WT(IDVW,JDVW,1),BR(MDAB,NDAB,1),
     +          BI(MDAB,NDAB,1),CR(MDAB,NDAB,1),CI(MDAB,NDAB,1),WORK(1),
     +          WVTS(1)

      IERROR = 1
      IF (NLAT.LT.3) RETURN
      IERROR = 2
      IF (NLON.LT.1) RETURN
      IERROR = 3
      IF (ITYP.LT.0 .OR. ITYP.GT.8) RETURN
      IERROR = 4
      IF (NT.LT.0) RETURN
      IERROR = 5
      IMID = (NLAT+1)/2
      IF ((ITYP.LE.2.AND.IDVW.LT.NLAT) .OR.
     +    (ITYP.GT.2.AND.IDVW.LT.IMID)) RETURN
      IERROR = 6
      IF (JDVW.LT.NLON) RETURN
      IERROR = 7
      MMAX = MIN0(NLAT, (NLON+1)/2)
      IF (MDAB.LT.MMAX) RETURN
      IERROR = 8
      IF (NDAB.LT.NLAT) RETURN
      IERROR = 9
      IDZ = (MMAX* (NLAT+NLAT-MMAX+1))/2
      LZIMN = IDZ*IMID
      IF (LWVTS.LT.LZIMN+LZIMN+NLON+15) RETURN
      IERROR = 10
      IDV = NLAT
      IF (ITYP.GT.2) IDV = IMID
      LNL = NT*IDV*NLON
      IF (LWORK.LT.LNL+LNL+IDV*NLON) RETURN
      IERROR = 0
      IST = 0
      IF (ITYP.LE.2) IST = IMID
      IW1 = IST + 1
      IW2 = LNL + 1
      IW3 = IW2 + IST
      IW4 = IW2 + LNL
      JW1 = LZIMN + 1
      JW2 = JW1 + LZIMN
      CALL DVTSES1(NLAT,NLON,ITYP,NT,IMID,IDVW,JDVW,VT,WT,MDAB,NDAB,BR,
     +            BI,CR,CI,IDV,WORK,WORK(IW1),WORK(IW2),WORK(IW3),
     +            WORK(IW4),IDZ,WVTS,WVTS(JW1),WVTS(JW2))
      RETURN
      END
      SUBROUTINE DVTSES1(NLAT,NLON,ITYP,NT,IMID,IDVW,JDVW,VT,WT,MDAB,
     +                  NDAB,BR,BI,CR,CI,IDV,VTE,VTO,WTE,WTO,WORK,IDZ,
     +                  VB,WB,WRFFT)
      DOUBLE PRECISION VT
      DOUBLE PRECISION WT
      DOUBLE PRECISION BR
      DOUBLE PRECISION BI
      DOUBLE PRECISION CR
      DOUBLE PRECISION CI
      DOUBLE PRECISION VTE
      DOUBLE PRECISION VTO
      DOUBLE PRECISION WTE
      DOUBLE PRECISION WTO
      DOUBLE PRECISION WORK
      DOUBLE PRECISION VB
      DOUBLE PRECISION WB
      DOUBLE PRECISION WRFFT
      DIMENSION VT(IDVW,JDVW,1),WT(IDVW,JDVW,1),BR(MDAB,NDAB,1),
     +          BI(MDAB,NDAB,1),CR(MDAB,NDAB,1),CI(MDAB,NDAB,1),
     +          VTE(IDV,NLON,1),VTO(IDV,NLON,1),WTE(IDV,NLON,1),
     +          WTO(IDV,NLON,1),WORK(1),WRFFT(1),VB(IMID,1),WB(IMID,1)

      NLP1 = NLAT + 1
      MLAT = MOD(NLAT,2)
      MLON = MOD(NLON,2)
      MMAX = MIN0(NLAT, (NLON+1)/2)
      IMM1 = IMID
      IF (MLAT.NE.0) IMM1 = IMID - 1
      DO 10 K = 1,NT
          DO 10 J = 1,NLON
              DO 10 I = 1,IDV
                  VTE(I,J,K) = 0.D0
                  WTE(I,J,K) = 0.D0
   10 CONTINUE
      NDO1 = NLAT
      NDO2 = NLAT
      IF (MLAT.NE.0) NDO1 = NLAT - 1
      IF (MLAT.EQ.0) NDO2 = NLAT - 1
   18 ITYPP = ITYP + 1
      GO TO (1,100,200,300,400,500,600,700,800) ITYPP
c
c     case ityp=0   no symmetries
c
c     case m = 0
c
    1 DO 15 K = 1,NT
          DO 15 NP1 = 2,NDO2,2
              DO 15 I = 1,IMM1
                  VTO(I,1,K) = VTO(I,1,K) + BR(1,NP1,K)*VB(I,NP1)
                  WTO(I,1,K) = WTO(I,1,K) - CR(1,NP1,K)*VB(I,NP1)
   15 CONTINUE
      DO 16 K = 1,NT
          DO 16 NP1 = 3,NDO1,2
              DO 16 I = 1,IMID
                  VTE(I,1,K) = VTE(I,1,K) + BR(1,NP1,K)*VB(I,NP1)
                  WTE(I,1,K) = WTE(I,1,K) - CR(1,NP1,K)*VB(I,NP1)
   16 CONTINUE
c
c     case m = 1 through nlat-1
c
      IF (MMAX.LT.2) GO TO 950
      DO 30 MP1 = 2,MMAX
          M = MP1 - 1
          MB = M* (NLAT-1) - (M* (M-1))/2
          MP2 = MP1 + 1
          IF (MP1.GT.NDO1) GO TO 26
          DO 25 K = 1,NT
              DO 24 NP1 = MP1,NDO1,2
                  MN = MB + NP1
                  DO 23 I = 1,IMM1
                      VTE(I,2*MP1-2,K) = VTE(I,2*MP1-2,K) +
     +                                   BR(MP1,NP1,K)*VB(I,MN)
                      VTO(I,2*MP1-2,K) = VTO(I,2*MP1-2,K) -
     +                                   CI(MP1,NP1,K)*WB(I,MN)
                      VTE(I,2*MP1-1,K) = VTE(I,2*MP1-1,K) +
     +                                   BI(MP1,NP1,K)*VB(I,MN)
                      VTO(I,2*MP1-1,K) = VTO(I,2*MP1-1,K) +
     +                                   CR(MP1,NP1,K)*WB(I,MN)
                      WTE(I,2*MP1-2,K) = WTE(I,2*MP1-2,K) -
     +                                   CR(MP1,NP1,K)*VB(I,MN)
                      WTO(I,2*MP1-2,K) = WTO(I,2*MP1-2,K) -
     +                                   BI(MP1,NP1,K)*WB(I,MN)
                      WTE(I,2*MP1-1,K) = WTE(I,2*MP1-1,K) -
     +                                   CI(MP1,NP1,K)*VB(I,MN)
                      WTO(I,2*MP1-1,K) = WTO(I,2*MP1-1,K) +
     +                                   BR(MP1,NP1,K)*WB(I,MN)
   23             CONTINUE
                  IF (MLAT.EQ.0) GO TO 24
                  VTE(IMID,2*MP1-2,K) = VTE(IMID,2*MP1-2,K) +
     +                                  BR(MP1,NP1,K)*VB(IMID,MN)
                  VTE(IMID,2*MP1-1,K) = VTE(IMID,2*MP1-1,K) +
     +                                  BI(MP1,NP1,K)*VB(IMID,MN)
                  WTE(IMID,2*MP1-2,K) = WTE(IMID,2*MP1-2,K) -
     +                                  CR(MP1,NP1,K)*VB(IMID,MN)
                  WTE(IMID,2*MP1-1,K) = WTE(IMID,2*MP1-1,K) -
     +                                  CI(MP1,NP1,K)*VB(IMID,MN)
   24         CONTINUE
   25     CONTINUE
   26     IF (MP2.GT.NDO2) GO TO 30
          DO 29 K = 1,NT
              DO 28 NP1 = MP2,NDO2,2
                  MN = MB + NP1
                  DO 27 I = 1,IMM1
                      VTO(I,2*MP1-2,K) = VTO(I,2*MP1-2,K) +
     +                                   BR(MP1,NP1,K)*VB(I,MN)
                      VTE(I,2*MP1-2,K) = VTE(I,2*MP1-2,K) -
     +                                   CI(MP1,NP1,K)*WB(I,MN)
                      VTO(I,2*MP1-1,K) = VTO(I,2*MP1-1,K) +
     +                                   BI(MP1,NP1,K)*VB(I,MN)
                      VTE(I,2*MP1-1,K) = VTE(I,2*MP1-1,K) +
     +                                   CR(MP1,NP1,K)*WB(I,MN)
                      WTO(I,2*MP1-2,K) = WTO(I,2*MP1-2,K) -
     +                                   CR(MP1,NP1,K)*VB(I,MN)
                      WTE(I,2*MP1-2,K) = WTE(I,2*MP1-2,K) -
     +                                   BI(MP1,NP1,K)*WB(I,MN)
                      WTO(I,2*MP1-1,K) = WTO(I,2*MP1-1,K) -
     +                                   CI(MP1,NP1,K)*VB(I,MN)
                      WTE(I,2*MP1-1,K) = WTE(I,2*MP1-1,K) +
     +                                   BR(MP1,NP1,K)*WB(I,MN)
   27             CONTINUE
                  IF (MLAT.EQ.0) GO TO 28
                  VTE(IMID,2*MP1-2,K) = VTE(IMID,2*MP1-2,K) -
     +                                  CI(MP1,NP1,K)*WB(IMID,MN)
                  VTE(IMID,2*MP1-1,K) = VTE(IMID,2*MP1-1,K) +
     +                                  CR(MP1,NP1,K)*WB(IMID,MN)
                  WTE(IMID,2*MP1-2,K) = WTE(IMID,2*MP1-2,K) -
     +                                  BI(MP1,NP1,K)*WB(IMID,MN)
                  WTE(IMID,2*MP1-1,K) = WTE(IMID,2*MP1-1,K) +
     +                                  BR(MP1,NP1,K)*WB(IMID,MN)
   28         CONTINUE
   29     CONTINUE
   30 CONTINUE
      GO TO 950
c
c     case ityp=1   no symmetries,  cr and ci equal zero
c
c     case m = 0
c
  100 DO 115 K = 1,NT
          DO 115 NP1 = 2,NDO2,2
              DO 115 I = 1,IMM1
                  VTO(I,1,K) = VTO(I,1,K) + BR(1,NP1,K)*VB(I,NP1)
  115 CONTINUE
      DO 116 K = 1,NT
          DO 116 NP1 = 3,NDO1,2
              DO 116 I = 1,IMID
                  VTE(I,1,K) = VTE(I,1,K) + BR(1,NP1,K)*VB(I,NP1)
  116 CONTINUE
c
c     case m = 1 through nlat-1
c
      IF (MMAX.LT.2) GO TO 950
      DO 130 MP1 = 2,MMAX
          M = MP1 - 1
          MB = M* (NLAT-1) - (M* (M-1))/2
          MP2 = MP1 + 1
          IF (MP1.GT.NDO1) GO TO 126
          DO 125 K = 1,NT
              DO 124 NP1 = MP1,NDO1,2
                  MN = MB + NP1
                  DO 123 I = 1,IMM1
                      VTE(I,2*MP1-2,K) = VTE(I,2*MP1-2,K) +
     +                                   BR(MP1,NP1,K)*VB(I,MN)
                      VTE(I,2*MP1-1,K) = VTE(I,2*MP1-1,K) +
     +                                   BI(MP1,NP1,K)*VB(I,MN)
                      WTO(I,2*MP1-2,K) = WTO(I,2*MP1-2,K) -
     +                                   BI(MP1,NP1,K)*WB(I,MN)
                      WTO(I,2*MP1-1,K) = WTO(I,2*MP1-1,K) +
     +                                   BR(MP1,NP1,K)*WB(I,MN)
  123             CONTINUE
                  IF (MLAT.EQ.0) GO TO 124
                  VTE(IMID,2*MP1-2,K) = VTE(IMID,2*MP1-2,K) +
     +                                  BR(MP1,NP1,K)*VB(IMID,MN)
                  VTE(IMID,2*MP1-1,K) = VTE(IMID,2*MP1-1,K) +
     +                                  BI(MP1,NP1,K)*VB(IMID,MN)
  124         CONTINUE
  125     CONTINUE
  126     IF (MP2.GT.NDO2) GO TO 130
          DO 129 K = 1,NT
              DO 128 NP1 = MP2,NDO2,2
                  MN = MB + NP1
                  DO 127 I = 1,IMM1
                      VTO(I,2*MP1-2,K) = VTO(I,2*MP1-2,K) +
     +                                   BR(MP1,NP1,K)*VB(I,MN)
                      VTO(I,2*MP1-1,K) = VTO(I,2*MP1-1,K) +
     +                                   BI(MP1,NP1,K)*VB(I,MN)
                      WTE(I,2*MP1-2,K) = WTE(I,2*MP1-2,K) -
     +                                   BI(MP1,NP1,K)*WB(I,MN)
                      WTE(I,2*MP1-1,K) = WTE(I,2*MP1-1,K) +
     +                                   BR(MP1,NP1,K)*WB(I,MN)
  127             CONTINUE
                  IF (MLAT.EQ.0) GO TO 128
                  WTE(IMID,2*MP1-2,K) = WTE(IMID,2*MP1-2,K) -
     +                                  BI(MP1,NP1,K)*WB(IMID,MN)
                  WTE(IMID,2*MP1-1,K) = WTE(IMID,2*MP1-1,K) +
     +                                  BR(MP1,NP1,K)*WB(IMID,MN)
  128         CONTINUE
  129     CONTINUE
  130 CONTINUE
      GO TO 950
c
c     case ityp=2   no symmetries,  br and bi are equal to zero
c
c     case m = 0
c
  200 DO 215 K = 1,NT
          DO 215 NP1 = 2,NDO2,2
              DO 215 I = 1,IMM1
                  WTO(I,1,K) = WTO(I,1,K) - CR(1,NP1,K)*VB(I,NP1)
  215 CONTINUE
      DO 216 K = 1,NT
          DO 216 NP1 = 3,NDO1,2
              DO 216 I = 1,IMID
                  WTE(I,1,K) = WTE(I,1,K) - CR(1,NP1,K)*VB(I,NP1)
  216 CONTINUE
c
c     case m = 1 through nlat-1
c
      IF (MMAX.LT.2) GO TO 950
      DO 230 MP1 = 2,MMAX
          M = MP1 - 1
          MB = M* (NLAT-1) - (M* (M-1))/2
          MP2 = MP1 + 1
          IF (MP1.GT.NDO1) GO TO 226
          DO 225 K = 1,NT
              DO 224 NP1 = MP1,NDO1,2
                  MN = MB + NP1
                  DO 223 I = 1,IMM1
                      VTO(I,2*MP1-2,K) = VTO(I,2*MP1-2,K) -
     +                                   CI(MP1,NP1,K)*WB(I,MN)
                      VTO(I,2*MP1-1,K) = VTO(I,2*MP1-1,K) +
     +                                   CR(MP1,NP1,K)*WB(I,MN)
                      WTE(I,2*MP1-2,K) = WTE(I,2*MP1-2,K) -
     +                                   CR(MP1,NP1,K)*VB(I,MN)
                      WTE(I,2*MP1-1,K) = WTE(I,2*MP1-1,K) -
     +                                   CI(MP1,NP1,K)*VB(I,MN)
  223             CONTINUE
                  IF (MLAT.EQ.0) GO TO 224
                  WTE(IMID,2*MP1-2,K) = WTE(IMID,2*MP1-2,K) -
     +                                  CR(MP1,NP1,K)*VB(IMID,MN)
                  WTE(IMID,2*MP1-1,K) = WTE(IMID,2*MP1-1,K) -
     +                                  CI(MP1,NP1,K)*VB(IMID,MN)
  224         CONTINUE
  225     CONTINUE
  226     IF (MP2.GT.NDO2) GO TO 230
          DO 229 K = 1,NT
              DO 228 NP1 = MP2,NDO2,2
                  MN = MB + NP1
                  DO 227 I = 1,IMM1
                      VTE(I,2*MP1-2,K) = VTE(I,2*MP1-2,K) -
     +                                   CI(MP1,NP1,K)*WB(I,MN)
                      VTE(I,2*MP1-1,K) = VTE(I,2*MP1-1,K) +
     +                                   CR(MP1,NP1,K)*WB(I,MN)
                      WTO(I,2*MP1-2,K) = WTO(I,2*MP1-2,K) -
     +                                   CR(MP1,NP1,K)*VB(I,MN)
                      WTO(I,2*MP1-1,K) = WTO(I,2*MP1-1,K) -
     +                                   CI(MP1,NP1,K)*VB(I,MN)
  227             CONTINUE
                  IF (MLAT.EQ.0) GO TO 228
                  VTE(IMID,2*MP1-2,K) = VTE(IMID,2*MP1-2,K) -
     +                                  CI(MP1,NP1,K)*WB(IMID,MN)
                  VTE(IMID,2*MP1-1,K) = VTE(IMID,2*MP1-1,K) +
     +                                  CR(MP1,NP1,K)*WB(IMID,MN)
  228         CONTINUE
  229     CONTINUE
  230 CONTINUE
      GO TO 950
c
c     case ityp=3   v odd,  w even
c
c     case m = 0
c
  300 DO 315 K = 1,NT
          DO 315 NP1 = 2,NDO2,2
              DO 315 I = 1,IMM1
                  VTO(I,1,K) = VTO(I,1,K) + BR(1,NP1,K)*VB(I,NP1)
  315 CONTINUE
      DO 316 K = 1,NT
          DO 316 NP1 = 3,NDO1,2
              DO 316 I = 1,IMID
                  WTE(I,1,K) = WTE(I,1,K) - CR(1,NP1,K)*VB(I,NP1)
  316 CONTINUE
c
c     case m = 1 through nlat-1
c
      IF (MMAX.LT.2) GO TO 950
      DO 330 MP1 = 2,MMAX
          M = MP1 - 1
          MB = M* (NLAT-1) - (M* (M-1))/2
          MP2 = MP1 + 1
          IF (MP1.GT.NDO1) GO TO 326
          DO 325 K = 1,NT
              DO 324 NP1 = MP1,NDO1,2
                  MN = MB + NP1
                  DO 323 I = 1,IMM1
                      VTO(I,2*MP1-2,K) = VTO(I,2*MP1-2,K) -
     +                                   CI(MP1,NP1,K)*WB(I,MN)
                      VTO(I,2*MP1-1,K) = VTO(I,2*MP1-1,K) +
     +                                   CR(MP1,NP1,K)*WB(I,MN)
                      WTE(I,2*MP1-2,K) = WTE(I,2*MP1-2,K) -
     +                                   CR(MP1,NP1,K)*VB(I,MN)
                      WTE(I,2*MP1-1,K) = WTE(I,2*MP1-1,K) -
     +                                   CI(MP1,NP1,K)*VB(I,MN)
  323             CONTINUE
                  IF (MLAT.EQ.0) GO TO 324
                  WTE(IMID,2*MP1-2,K) = WTE(IMID,2*MP1-2,K) -
     +                                  CR(MP1,NP1,K)*VB(IMID,MN)
                  WTE(IMID,2*MP1-1,K) = WTE(IMID,2*MP1-1,K) -
     +                                  CI(MP1,NP1,K)*VB(IMID,MN)
  324         CONTINUE
  325     CONTINUE
  326     IF (MP2.GT.NDO2) GO TO 330
          DO 329 K = 1,NT
              DO 328 NP1 = MP2,NDO2,2
                  MN = MB + NP1
                  DO 327 I = 1,IMM1
                      VTO(I,2*MP1-2,K) = VTO(I,2*MP1-2,K) +
     +                                   BR(MP1,NP1,K)*VB(I,MN)
                      VTO(I,2*MP1-1,K) = VTO(I,2*MP1-1,K) +
     +                                   BI(MP1,NP1,K)*VB(I,MN)
                      WTE(I,2*MP1-2,K) = WTE(I,2*MP1-2,K) -
     +                                   BI(MP1,NP1,K)*WB(I,MN)
                      WTE(I,2*MP1-1,K) = WTE(I,2*MP1-1,K) +
     +                                   BR(MP1,NP1,K)*WB(I,MN)
  327             CONTINUE
                  IF (MLAT.EQ.0) GO TO 328
                  WTE(IMID,2*MP1-2,K) = WTE(IMID,2*MP1-2,K) -
     +                                  BI(MP1,NP1,K)*WB(IMID,MN)
                  WTE(IMID,2*MP1-1,K) = WTE(IMID,2*MP1-1,K) +
     +                                  BR(MP1,NP1,K)*WB(IMID,MN)
  328         CONTINUE
  329     CONTINUE
  330 CONTINUE
      GO TO 950
c
c     case ityp=4   v odd,  w even, and both cr and ci equal zero
c
c     case m = 0
c
  400 DO 415 K = 1,NT
          DO 415 NP1 = 2,NDO2,2
              DO 415 I = 1,IMM1
                  VTO(I,1,K) = VTO(I,1,K) + BR(1,NP1,K)*VB(I,NP1)
  415 CONTINUE
c
c     case m = 1 through nlat-1
c
      IF (MMAX.LT.2) GO TO 950
      DO 430 MP1 = 2,MMAX
          M = MP1 - 1
          MB = M* (NLAT-1) - (M* (M-1))/2
          MP2 = MP1 + 1
          IF (MP2.GT.NDO2) GO TO 430
          DO 429 K = 1,NT
              DO 428 NP1 = MP2,NDO2,2
                  MN = MB + NP1
                  DO 427 I = 1,IMM1
                      VTO(I,2*MP1-2,K) = VTO(I,2*MP1-2,K) +
     +                                   BR(MP1,NP1,K)*VB(I,MN)
                      VTO(I,2*MP1-1,K) = VTO(I,2*MP1-1,K) +
     +                                   BI(MP1,NP1,K)*VB(I,MN)
                      WTE(I,2*MP1-2,K) = WTE(I,2*MP1-2,K) -
     +                                   BI(MP1,NP1,K)*WB(I,MN)
                      WTE(I,2*MP1-1,K) = WTE(I,2*MP1-1,K) +
     +                                   BR(MP1,NP1,K)*WB(I,MN)
  427             CONTINUE
                  IF (MLAT.EQ.0) GO TO 428
                  WTE(IMID,2*MP1-2,K) = WTE(IMID,2*MP1-2,K) -
     +                                  BI(MP1,NP1,K)*WB(IMID,MN)
                  WTE(IMID,2*MP1-1,K) = WTE(IMID,2*MP1-1,K) +
     +                                  BR(MP1,NP1,K)*WB(IMID,MN)
  428         CONTINUE
  429     CONTINUE
  430 CONTINUE
      GO TO 950
c
c     case ityp=5   v odd,  w even,     br and bi equal zero
c
c     case m = 0
c
  500 DO 516 K = 1,NT
          DO 516 NP1 = 3,NDO1,2
              DO 516 I = 1,IMID
                  WTE(I,1,K) = WTE(I,1,K) - CR(1,NP1,K)*VB(I,NP1)
  516 CONTINUE
c
c     case m = 1 through nlat-1
c
      IF (MMAX.LT.2) GO TO 950
      DO 530 MP1 = 2,MMAX
          M = MP1 - 1
          MB = M* (NLAT-1) - (M* (M-1))/2
          MP2 = MP1 + 1
          IF (MP1.GT.NDO1) GO TO 530
          DO 525 K = 1,NT
              DO 524 NP1 = MP1,NDO1,2
                  MN = MB + NP1
                  DO 523 I = 1,IMM1
                      VTO(I,2*MP1-2,K) = VTO(I,2*MP1-2,K) -
     +                                   CI(MP1,NP1,K)*WB(I,MN)
                      VTO(I,2*MP1-1,K) = VTO(I,2*MP1-1,K) +
     +                                   CR(MP1,NP1,K)*WB(I,MN)
                      WTE(I,2*MP1-2,K) = WTE(I,2*MP1-2,K) -
     +                                   CR(MP1,NP1,K)*VB(I,MN)
                      WTE(I,2*MP1-1,K) = WTE(I,2*MP1-1,K) -
     +                                   CI(MP1,NP1,K)*VB(I,MN)
  523             CONTINUE
                  IF (MLAT.EQ.0) GO TO 524
                  WTE(IMID,2*MP1-2,K) = WTE(IMID,2*MP1-2,K) -
     +                                  CR(MP1,NP1,K)*VB(IMID,MN)
                  WTE(IMID,2*MP1-1,K) = WTE(IMID,2*MP1-1,K) -
     +                                  CI(MP1,NP1,K)*VB(IMID,MN)
  524         CONTINUE
  525     CONTINUE
  530 CONTINUE
      GO TO 950
c
c     case ityp=6   v even  ,  w odd
c
c     case m = 0
c
  600 DO 615 K = 1,NT
          DO 615 NP1 = 2,NDO2,2
              DO 615 I = 1,IMM1
                  WTO(I,1,K) = WTO(I,1,K) - CR(1,NP1,K)*VB(I,NP1)
  615 CONTINUE
      DO 616 K = 1,NT
          DO 616 NP1 = 3,NDO1,2
              DO 616 I = 1,IMID
                  VTE(I,1,K) = VTE(I,1,K) + BR(1,NP1,K)*VB(I,NP1)
  616 CONTINUE
c
c     case m = 1 through nlat-1
c
      IF (MMAX.LT.2) GO TO 950
      DO 630 MP1 = 2,MMAX
          M = MP1 - 1
          MB = M* (NLAT-1) - (M* (M-1))/2
          MP2 = MP1 + 1
          IF (MP1.GT.NDO1) GO TO 626
          DO 625 K = 1,NT
              DO 624 NP1 = MP1,NDO1,2
                  MN = MB + NP1
                  DO 623 I = 1,IMM1
                      VTE(I,2*MP1-2,K) = VTE(I,2*MP1-2,K) +
     +                                   BR(MP1,NP1,K)*VB(I,MN)
                      VTE(I,2*MP1-1,K) = VTE(I,2*MP1-1,K) +
     +                                   BI(MP1,NP1,K)*VB(I,MN)
                      WTO(I,2*MP1-2,K) = WTO(I,2*MP1-2,K) -
     +                                   BI(MP1,NP1,K)*WB(I,MN)
                      WTO(I,2*MP1-1,K) = WTO(I,2*MP1-1,K) +
     +                                   BR(MP1,NP1,K)*WB(I,MN)
  623             CONTINUE
                  IF (MLAT.EQ.0) GO TO 624
                  VTE(IMID,2*MP1-2,K) = VTE(IMID,2*MP1-2,K) +
     +                                  BR(MP1,NP1,K)*VB(IMID,MN)
                  VTE(IMID,2*MP1-1,K) = VTE(IMID,2*MP1-1,K) +
     +                                  BI(MP1,NP1,K)*VB(IMID,MN)
  624         CONTINUE
  625     CONTINUE
  626     IF (MP2.GT.NDO2) GO TO 630
          DO 629 K = 1,NT
              DO 628 NP1 = MP2,NDO2,2
                  MN = MB + NP1
                  DO 627 I = 1,IMM1
                      VTE(I,2*MP1-2,K) = VTE(I,2*MP1-2,K) -
     +                                   CI(MP1,NP1,K)*WB(I,MN)
                      VTE(I,2*MP1-1,K) = VTE(I,2*MP1-1,K) +
     +                                   CR(MP1,NP1,K)*WB(I,MN)
                      WTO(I,2*MP1-2,K) = WTO(I,2*MP1-2,K) -
     +                                   CR(MP1,NP1,K)*VB(I,MN)
                      WTO(I,2*MP1-1,K) = WTO(I,2*MP1-1,K) -
     +                                   CI(MP1,NP1,K)*VB(I,MN)
  627             CONTINUE
                  IF (MLAT.EQ.0) GO TO 628
                  VTE(IMID,2*MP1-2,K) = VTE(IMID,2*MP1-2,K) -
     +                                  CI(MP1,NP1,K)*WB(IMID,MN)
                  VTE(IMID,2*MP1-1,K) = VTE(IMID,2*MP1-1,K) +
     +                                  CR(MP1,NP1,K)*WB(IMID,MN)
  628         CONTINUE
  629     CONTINUE
  630 CONTINUE
      GO TO 950
c
c     case ityp=7   v even, w odd   cr and ci equal zero
c
c     case m = 0
c
  700 DO 716 K = 1,NT
          DO 716 NP1 = 3,NDO1,2
              DO 716 I = 1,IMID
                  VTE(I,1,K) = VTE(I,1,K) + BR(1,NP1,K)*VB(I,NP1)
  716 CONTINUE
c
c     case m = 1 through nlat-1
c
      IF (MMAX.LT.2) GO TO 950
      DO 730 MP1 = 2,MMAX
          M = MP1 - 1
          MB = M* (NLAT-1) - (M* (M-1))/2
          MP2 = MP1 + 1
          IF (MP1.GT.NDO1) GO TO 730
          DO 725 K = 1,NT
              DO 724 NP1 = MP1,NDO1,2
                  MN = MB + NP1
                  DO 723 I = 1,IMM1
                      VTE(I,2*MP1-2,K) = VTE(I,2*MP1-2,K) +
     +                                   BR(MP1,NP1,K)*VB(I,MN)
                      VTE(I,2*MP1-1,K) = VTE(I,2*MP1-1,K) +
     +                                   BI(MP1,NP1,K)*VB(I,MN)
                      WTO(I,2*MP1-2,K) = WTO(I,2*MP1-2,K) -
     +                                   BI(MP1,NP1,K)*WB(I,MN)
                      WTO(I,2*MP1-1,K) = WTO(I,2*MP1-1,K) +
     +                                   BR(MP1,NP1,K)*WB(I,MN)
  723             CONTINUE
                  IF (MLAT.EQ.0) GO TO 724
                  VTE(IMID,2*MP1-2,K) = VTE(IMID,2*MP1-2,K) +
     +                                  BR(MP1,NP1,K)*VB(IMID,MN)
                  VTE(IMID,2*MP1-1,K) = VTE(IMID,2*MP1-1,K) +
     +                                  BI(MP1,NP1,K)*VB(IMID,MN)
  724         CONTINUE
  725     CONTINUE
  730 CONTINUE
      GO TO 950
c
c     case ityp=8   v even,  w odd,   br and bi equal zero
c
c     case m = 0
c
  800 DO 815 K = 1,NT
          DO 815 NP1 = 2,NDO2,2
              DO 815 I = 1,IMM1
                  WTO(I,1,K) = WTO(I,1,K) - CR(1,NP1,K)*VB(I,NP1)
  815 CONTINUE
c
c     case m = 1 through nlat-1
c
      IF (MMAX.LT.2) GO TO 950
      DO 830 MP1 = 2,MMAX
          M = MP1 - 1
          MB = M* (NLAT-1) - (M* (M-1))/2
          MP2 = MP1 + 1
          IF (MP2.GT.NDO2) GO TO 830
          DO 829 K = 1,NT
              DO 828 NP1 = MP2,NDO2,2
                  MN = MB + NP1
                  DO 827 I = 1,IMM1
                      VTE(I,2*MP1-2,K) = VTE(I,2*MP1-2,K) -
     +                                   CI(MP1,NP1,K)*WB(I,MN)
                      VTE(I,2*MP1-1,K) = VTE(I,2*MP1-1,K) +
     +                                   CR(MP1,NP1,K)*WB(I,MN)
                      WTO(I,2*MP1-2,K) = WTO(I,2*MP1-2,K) -
     +                                   CR(MP1,NP1,K)*VB(I,MN)
                      WTO(I,2*MP1-1,K) = WTO(I,2*MP1-1,K) -
     +                                   CI(MP1,NP1,K)*VB(I,MN)
  827             CONTINUE
                  IF (MLAT.EQ.0) GO TO 828
                  VTE(IMID,2*MP1-2,K) = VTE(IMID,2*MP1-2,K) -
     +                                  CI(MP1,NP1,K)*WB(IMID,MN)
                  VTE(IMID,2*MP1-1,K) = VTE(IMID,2*MP1-1,K) +
     +                                  CR(MP1,NP1,K)*WB(IMID,MN)
  828         CONTINUE
  829     CONTINUE
  830 CONTINUE
  950 DO 14 K = 1,NT
          CALL DHRFFTB(IDV,NLON,VTE(1,1,K),IDV,WRFFT,WORK)
          CALL DHRFFTB(IDV,NLON,WTE(1,1,K),IDV,WRFFT,WORK)
   14 CONTINUE
      IF (ITYP.GT.2) GO TO 12
      DO 60 K = 1,NT
          DO 60 J = 1,NLON
              DO 60 I = 1,IMM1
                  VT(I,J,K) = .5D0* (VTE(I,J,K)+VTO(I,J,K))
                  WT(I,J,K) = .5D0* (WTE(I,J,K)+WTO(I,J,K))
                  VT(NLP1-I,J,K) = .5D0* (VTE(I,J,K)-VTO(I,J,K))
                  WT(NLP1-I,J,K) = .5D0* (WTE(I,J,K)-WTO(I,J,K))
   60 CONTINUE
      GO TO 13
   12 DO 11 K = 1,NT
          DO 11 J = 1,NLON
              DO 11 I = 1,IMM1
                  VT(I,J,K) = .5D0*VTE(I,J,K)
                  WT(I,J,K) = .5D0*WTE(I,J,K)
   11 CONTINUE
   13 IF (MLAT.EQ.0) RETURN
      DO 65 K = 1,NT
          DO 65 J = 1,NLON
              VT(IMID,J,K) = .5D0*VTE(IMID,J,K)
              WT(IMID,J,K) = .5D0*WTE(IMID,J,K)
   65 CONTINUE
      RETURN
      END
      SUBROUTINE DVTSESI(NLAT,NLON,WVTS,LWVTS,WORK,LWORK,DWORK,LDWORK,
     +                  IERROR)
      DOUBLE PRECISION WVTS
      DOUBLE PRECISION WORK
c
      DIMENSION WVTS(LWVTS),WORK(LWORK)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION DWORK(LDWORK)

      IERROR = 1
      IF (NLAT.LT.3) RETURN
      IERROR = 2
      IF (NLON.LT.1) RETURN
      IERROR = 3
      MMAX = MIN0(NLAT, (NLON+1)/2)
      IMID = (NLAT+1)/2
      LZIMN = (IMID*MMAX* (NLAT+NLAT-MMAX+1))/2
      IF (LWVTS.LT.LZIMN+LZIMN+NLON+15) RETURN
      IERROR = 4
      LABC = 3* (MAX0(MMAX-2,0)* (NLAT+NLAT-MMAX-1))/2
      IF (LWORK.LT.5*NLAT*IMID+LABC) RETURN
      IERROR = 5
      IF (LDWORK.LT.2* (NLAT+1)) RETURN
      IERROR = 0
      IW1 = 3*NLAT*IMID + 1
      IDZ = (MMAX* (NLAT+NLAT-MMAX+1))/2
      CALL DVET1(NLAT,NLON,IMID,WVTS,WVTS(LZIMN+1),IDZ,WORK,WORK(IW1),
     +          DWORK)
      CALL DHRFFTI(NLON,WVTS(2*LZIMN+1))
      RETURN
      END
      SUBROUTINE DVET1(NLAT,NLON,IMID,VB,WB,IDZ,VIN,WZVIN,DWORK)
      DOUBLE PRECISION VB
      DOUBLE PRECISION WB
      DOUBLE PRECISION VIN
      DOUBLE PRECISION WZVIN
      DIMENSION VB(IMID,*),WB(IMID,*),VIN(IMID,NLAT,3),WZVIN(*)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION DWORK(*)

      MMAX = MIN0(NLAT, (NLON+1)/2)
      CALL DVTINIT(NLAT,NLON,WZVIN,DWORK)
      DO 33 MP1 = 1,MMAX
          M = MP1 - 1
          CALL DVBIN(0,NLAT,NLON,M,VIN,I3,WZVIN)
          DO 33 NP1 = MP1,NLAT
              MN = M* (NLAT-1) - (M* (M-1))/2 + NP1
              DO 33 I = 1,IMID
                  VB(I,MN) = VIN(I,NP1,I3)
   33 CONTINUE
      CALL DWTINIT(NLAT,NLON,WZVIN,DWORK)
      DO 34 MP1 = 1,MMAX
          M = MP1 - 1
          CALL DWBIN(0,NLAT,NLON,M,VIN,I3,WZVIN)
          DO 34 NP1 = MP1,NLAT
              MN = M* (NLAT-1) - (M* (M-1))/2 + NP1
              DO 34 I = 1,IMID
                  WB(I,MN) = VIN(I,NP1,I3)
   34 CONTINUE
      RETURN
      END

subroutine plotgrids_var(fname,plotvar)

   implicit none

   ! Parameters
   integer, parameter :: MAX_DOMAINS = 21
   integer, parameter :: NVAR = 19

   ! Variables
   integer :: i, j, funit, io_form_geogrid
   integer :: interval_seconds

   real, dimension(MAX_DOMAINS) :: parent_grid_ratio, parent_id, ixdim, jydim
   real, dimension(MAX_DOMAINS) :: i_parent_start, j_parent_start, &
                        s_we, e_we, s_sn, e_sn, &
                        start_year, start_month, start_day, start_hour, &
                        end_year,   end_month,   end_day,   end_hour
   logical, dimension(MAX_DOMAINS) :: active_grid
   logical :: is_used

   real :: stand_lon, truelat1, truelat2, &
           ref_lat, ref_lon, ref_x, ref_y, pole_lat, pole_lon
   real :: dx, dy, mproj_int, max_dom

   character (len=128) :: geog_data_path, opt_output_from_geogrid_path, opt_geogrid_tbl_path
   character (len=128), dimension(MAX_DOMAINS) :: geog_data_res
   character (len=128) :: map_proj
   character (len=128), dimension(MAX_DOMAINS) :: start_date, end_date
   character (len=3) :: wrf_core
   character (*) :: fname

   integer :: debug_level

   real, dimension(NVAR,MAX_DOMAINS) :: plotvar(NVAR,MAX_DOMAINS)

   namelist /share/ wrf_core, max_dom, start_date, end_date, &
                     start_year, end_year, start_month, end_month, &
                     start_day, end_day, start_hour, end_hour, &
                     interval_seconds, io_form_geogrid, opt_output_from_geogrid_path, &
                     debug_level, active_grid
   namelist /geogrid/ parent_id, parent_grid_ratio, &
                      i_parent_start, j_parent_start, s_we, e_we, s_sn, e_sn, &
                      map_proj, ref_x, ref_y, ref_lat, ref_lon, &
                      truelat1, truelat2, stand_lon, dx, dy, pole_lat, pole_lon, &
                      geog_data_res, geog_data_path, opt_geogrid_tbl_path

   !Initialize array

   ref_x = -999.0
   ref_y = -999.0
   ref_lat = -999.0
   ref_lon = -999.0
   do i=1,NVAR
    do j=1,MAX_DOMAINS
      plotvar(i,j) = -999.0
    end do
   end do

   ! Read parameters from Fortran namelist
   do funit=10,100
      inquire(unit=funit, opened=is_used)
      if (.not. is_used) exit
   end do
   open(funit,file=fname,status='old',form='formatted')
   read(funit,share)
   read(funit,geogrid)
   close(funit)

   !Assign integers to map projections

   if (index(map_proj, 'lambert') /= 0) then
      mproj_int = 1
   else if (index(map_proj, 'mercator') /= 0) then
      mproj_int = 2
   else if (index(map_proj, 'polar') /= 0) then
      mproj_int = 3
   else if (index(map_proj, 'lat-lon') /= 0) then
      mproj_int = 4
   end if

   !Put all the variables into an array

   plotvar(1,1) = max_dom
   plotvar(2,1) = dx
   plotvar(3,1) = dy
   plotvar(4,1) = ref_lat
   plotvar(5,1) = ref_lon
   plotvar(6,1) = ref_x
   plotvar(7,1) = ref_y
   plotvar(8,1) = truelat1
   plotvar(9,1) = truelat2
   plotvar(10,1) = stand_lon
   plotvar(11,1) = mproj_int
   plotvar(12,1) = pole_lat
   plotvar(13,1) = pole_lon
   do j=1,int(max_dom)
     plotvar(14,j) = parent_id(j)
     plotvar(15,j) = parent_grid_ratio(j)
     plotvar(16,j) = i_parent_start(j)
     plotvar(17,j) = j_parent_start(j)
     plotvar(18,j) = e_we(j)
     plotvar(19,j) = e_sn(j)
   end do

end subroutine plotgrids_var

      PROGRAM FTHEX03
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Declare an array in which to put an eye position for THREED.
C
      DIMENSION PEYE(3)
C
C Define a character variable in which to form numeric labels.
C
      CHARACTER*8 CHRS
C
C Declare arrays in which to put coordinates for a curve to be drawn.
C
      DIMENSION UCRV(361),VCRV(361),WCRV(361)
C
C Declare a function W(U,V) to be used in the example.
C
      WFUN(U,V)=.5+.25*SIN(5.*U)+.25*COS(5.*V)
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Make the tick marks drawn by PERIM3 twice as long as the default.
C
      CALL TICK43 (24,16,24,16,24,16)
C
C Define the boundaries of the box to be projected from 3-space to
C 2-space.
C
      UMIN=0.
      UMAX=1.
      VMIN=0.
      VMAX=1.
      WMIN=0.
      WMAX=1.
C
C Define the position of the eye.
C
      PEYE(1)=6.
      PEYE(2)=4.
      PEYE(3)=5.
C
C Initialize THREED.
C
      CALL SET3 (.1,.9,.1,.9,UMIN,UMAX,VMIN,VMAX,WMIN,WMAX,PEYE)
C
C Draw perimeters in each of the three coordinate planes.
C
      CALL PERIM3 (10,2,10,2,1,0.)
      CALL PERIM3 (10,2,10,2,2,0.)
      CALL PERIM3 (10,2,10,2,3,0.)
C
C Put some labels on the plot.  First, the U axis.
C
      CALL PWRZT (.5,0.,1.1,'U',1,3,-1,+3,0)
C
      DO 102 ILAB=1,10
         UPOS=REAL(ILAB)/10.
         WRITE (CHRS,'(F8.1)') UPOS
         IBEG=0
         DO 101 ICHR=1,8
            IF (CHRS(ICHR:ICHR).NE.' ') THEN
               IF (IBEG.EQ.0) THEN
                  IBEG=ICHR
               END IF
               IEND=ICHR
            END IF
 101     CONTINUE
         IF (CHRS(IBEG:IBEG).EQ.'0') IBEG=MIN(IBEG+1,IEND)
         CALL PWRZT (UPOS,0.,1.05,CHRS(IBEG:IEND),IEND-IBEG+1,
     +        3,-1,+3,0)
 102  CONTINUE
C
C Next, the V axis.
C
      CALL PWRZT (0.,.5,1.1,'V',1,3,+2,+3,0)
C     
      DO 104 ILAB=1,10
         VPOS=REAL(ILAB)/10.
         WRITE (CHRS,'(F8.1)') VPOS
         IBEG=0
         DO 103 ICHR=1,8
            IF (CHRS(ICHR:ICHR).NE.' ') THEN
               IF (IBEG.EQ.0) THEN
                  IBEG=ICHR
               END IF
               IEND=ICHR
            END IF
 103     CONTINUE
         IF (CHRS(IBEG:IBEG).EQ.'0') IBEG=MIN(IBEG+1,IEND)
         CALL PWRZT (0.,VPOS,1.05,CHRS(IBEG:IEND),IEND-IBEG+1,
     +        3,+2,+3,0)
 104  CONTINUE
C  
C Finally, the W axis.
C
      CALL PWRZT (1.2,0.,.5,'W',1,3,-1,+3,1)
C
      DO 106 ILAB=0,10
         WPOS=REAL(ILAB)/10.
         WRITE (CHRS,'(F8.1)') WPOS
         IBEG=0
         DO 105 ICHR=1,8
            IF (CHRS(ICHR:ICHR).NE.' ') THEN
               IF (IBEG.EQ.0) THEN
                  IBEG=ICHR
               END IF
               IEND=ICHR
            END IF
 105     CONTINUE
         IF (CHRS(IBEG:IBEG).EQ.'0') IBEG=MIN(IBEG+1,IEND)
         CALL PWRZT (1.05,0.,WPOS,CHRS(IBEG:IEND),IEND-IBEG+1,
     +        3,-1,+3,1)
 106  CONTINUE
C
C Using POINT3, draw grids inside the perimeters drawn by PERIM3.
C
      DO 108 I=1,11
         PTMP=REAL(I-1)/10.
         DO 107 J=1,101
            QTMP=REAL(J-1)/100.
            CALL POINT3 (PTMP,QTMP,0.)
            CALL POINT3 (QTMP,PTMP,0.)
            CALL POINT3 (PTMP,0.,QTMP)
            CALL POINT3 (QTMP,0.,PTMP)
            CALL POINT3 (0.,PTMP,QTMP)
            CALL POINT3 (0.,QTMP,PTMP)
 107     CONTINUE
 108  CONTINUE
C
C Draw a wire-frame representation of the surface defined by the
C function WFUN, using the routines FRST3 and VECT3.
C
      DO 110 I=1,11
         UTMP=REAL(I-1)/10.
         CALL FRST3 (UTMP,0.,WFUN(UTMP,0.))
         DO 109 J=2,11
            VTMP=REAL(J-1)/10.
            CALL VECT3 (UTMP,VTMP,WFUN(UTMP,VTMP))
 109     CONTINUE
 110  CONTINUE
C
      DO 112 J=1,11
         VTMP=REAL(J-1)/10.
         CALL FRST3 (0.,VTMP,WFUN(0.,VTMP))
         DO 111 I=2,11
            UTMP=REAL(I-1)/10.
            CALL VECT3 (UTMP,VTMP,WFUN(UTMP,VTMP))
 111     CONTINUE
 112  CONTINUE
C 
C Double the line width and draw a curve using CURVE3.
C
      CALL PLOTIF (0.,0.,2)
      CALL GSLWSC (2.)
C
      DO 113 I=1,361
         TEMP=5.*REAL(I-1)
         UCRV(I)=.5+TEMP/3600.*COS(.017453292519943*TEMP)
         VCRV(I)=.5+TEMP/3600.*SIN(.017453292519943*TEMP)
         WCRV(I)=WFUN(UCRV(I),VCRV(I))
 113  CONTINUE
C
      CALL CURVE3 (UCRV,VCRV,WCRV,361)
C
C Advance the frame.
C
      CALL FRAME
C
C Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
C Done.
C
      STOP
C
      END

C NCLFORTSTART
      SUBROUTINE DEOF2DATA(NEVAL,NPTS,NTIM,EV,EVTS,X,XMSG)
      IMPLICIT NONE
C                                                 INPUT
      INTEGER NEVAL,NPTS,NTIM
      DOUBLE PRECISION EV(NPTS,NEVAL),EVTS(NTIM,NEVAL),XMSG
C                                                 OUTPUT
      DOUBLE PRECISION X(NTIM,NPTS)
C NCLEND

C NCL: xEof = eof2data(ev,evts[*][*])

c construct a data array [x] from the ev and evts arrays
c .   if neval is the maximum number the reconstruction
c .   should be exact

      INTEGER NP,NE,NT,KNT
      DOUBLE PRECISION SUME
c
      DO NT = 1,NTIM
          DO NP = 1,NPTS
              X(NT,NP) = XMSG
              KNT = 0
              SUME = 0.D0
              DO NE = 1,NEVAL
                  IF (EVTS(NT,NE).NE.XMSG .AND. EV(NP,NE).NE.XMSG) THEN
                      KNT = KNT + 1
                      SUME = SUME + EVTS(NT,NE)*EV(NP,NE)
                  END IF
              END DO
              IF (KNT.GT.0) X(NT,NP) = SUME
          END DO
      END DO

      RETURN
      END

      SUBROUTINE SSYCON( UPLO, N, A, LDA, IPIV, ANORM, RCOND, WORK,
     $                   IWORK, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     March 31, 1993 
*
*     .. Scalar Arguments ..
      CHARACTER          UPLO
      INTEGER            INFO, LDA, N
      REAL               ANORM, RCOND
*     ..
*     .. Array Arguments ..
      INTEGER            IPIV( * ), IWORK( * )
      REAL               A( LDA, * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  SSYCON estimates the reciprocal of the condition number (in the
*  1-norm) of a real symmetric matrix A using the factorization
*  A = U*D*U**T or A = L*D*L**T computed by SSYTRF.
*
*  An estimate is obtained for norm(inv(A)), and the reciprocal of the
*  condition number is computed as RCOND = 1 / (ANORM * norm(inv(A))).
*
*  Arguments
*  =========
*
*  UPLO    (input) CHARACTER*1
*          Specifies whether the details of the factorization are stored
*          as an upper or lower triangular matrix.
*          = 'U':  Upper triangular, form is A = U*D*U**T;
*          = 'L':  Lower triangular, form is A = L*D*L**T.
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  A       (input) REAL array, dimension (LDA,N)
*          The block diagonal matrix D and the multipliers used to
*          obtain the factor U or L as computed by SSYTRF.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(1,N).
*
*  IPIV    (input) INTEGER array, dimension (N)
*          Details of the interchanges and the block structure of D
*          as determined by SSYTRF.
*
*  ANORM   (input) REAL
*          The 1-norm of the original matrix A.
*
*  RCOND   (output) REAL
*          The reciprocal of the condition number of the matrix A,
*          computed as RCOND = 1/(ANORM * AINVNM), where AINVNM is an
*          estimate of the 1-norm of inv(A) computed in this routine.
*
*  WORK    (workspace) REAL array, dimension (2*N)
*
*  IWORK    (workspace) INTEGER array, dimension (N)
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ONE, ZERO
      PARAMETER          ( ONE = 1.0E+0, ZERO = 0.0E+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            UPPER
      INTEGER            I, KASE
      REAL               AINVNM
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           SLACON, SSYTRS, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      UPPER = LSAME( UPLO, 'U' )
      IF( .NOT.UPPER .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -4
      ELSE IF( ANORM.LT.ZERO ) THEN
         INFO = -6
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'SSYCON', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      RCOND = ZERO
      IF( N.EQ.0 ) THEN
         RCOND = ONE
         RETURN
      ELSE IF( ANORM.LE.ZERO ) THEN
         RETURN
      END IF
*
*     Check that the diagonal matrix D is nonsingular.
*
      IF( UPPER ) THEN
*
*        Upper triangular storage: examine D from bottom to top
*
         DO 10 I = N, 1, -1
            IF( IPIV( I ).GT.0 .AND. A( I, I ).EQ.ZERO )
     $         RETURN
   10    CONTINUE
      ELSE
*
*        Lower triangular storage: examine D from top to bottom.
*
         DO 20 I = 1, N
            IF( IPIV( I ).GT.0 .AND. A( I, I ).EQ.ZERO )
     $         RETURN
   20    CONTINUE
      END IF
*
*     Estimate the 1-norm of the inverse.
*
      KASE = 0
   30 CONTINUE
      CALL SLACON( N, WORK( N+1 ), WORK, IWORK, AINVNM, KASE )
      IF( KASE.NE.0 ) THEN
*
*        Multiply by inv(L*D*L') or inv(U*D*U').
*
         CALL SSYTRS( UPLO, N, 1, A, LDA, IPIV, WORK, N, INFO )
         GO TO 30
      END IF
*
*     Compute the estimate of the reciprocal condition number.
*
      IF( AINVNM.NE.ZERO )
     $   RCOND = ( ONE / AINVNM ) / ANORM
*
      RETURN
*
*     End of SSYCON
*
      END

C
C $Id: tdez3d.f,v 1.8 2008-07-27 00:17:32 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE TDEZ3D(NX,NY,NZ,X,Y,Z,U,VALUE,
     +                           RMULT,THETA,PHI,IST)
C
C  This subroutine uses the NCAR Graphics functions in Tdpack
C  to draw an isosurface plot.  TDEZ3D is meant to be a simplified
C  interface to Tdpack for the purpose of quickly drawing a plot.
C  TDEZ3D sacrifices much of the flexibility and functionality of
C  Tdpack in its attempt to be simple.
C
C  TDEZ3D draws a 3-dimensional surface using an isovalue of
C  VALUE for the data given by:
C
C     U(I,J,K) = data value at (X(I),Y(J),Z(K)) for
C                I=1,NX and J=1,NY and K=1,NZ.
C
C  The point looked at is the midpoint of the data box specified
C  by X, Y, and Z.
C
C  The eye position is calculated from the 3D coordinate
C  (RMULT,THETA,PHI) as provided in the argument list:
C
C      RMULT  is a multiplier of the diagonal length (DL) of
C             the smallest box containing the surface to be drawn.
C      THETA  is an angle (in degrees) in the XY plane measured
C             positive counter-clockwise from the X axis
C      PHI    is an angle (in degrees) measured from the positive Z
C             axis toward the XY plane.
C
C  Thus, the coordinate (RMULT*DL,THETA,PHI) is the spherical
C  coordinate for the eye position.  If RMULT = THETA = PHI = 0.,
C  a default eye position ( 2.5,-55.,70.) is chosen.
C
C      IST    is a style index defining the colors used to shade the
C             surface as per:
C
C                1  -  wire frame
C                2  -  gray shades underneath; gray shades on top.
C                3  -  gray shades underneath; red shades on top.
C                4  -  gray shades underneath; green shades on top.
C                5  -  gray shades underneath; blue shades on top.
C                6  -  gray shades underneath; cyan shades on top.
C                7  -  gray shades underneath; magenta shades on top.
C                8  -  gray shades underneath; yellow shades on top.
C
C             If IST is positive, then black is used for the background
C             color and white for the foreground color; if IST is
C             the negative of any of the above values, then white
C             is used for the background color and black for the
C             foreground color.
C
C  When TDEZ3D is called, a color table is defined for all open
C  workstations that implements IST as described above.  *This
C  color table will supersede any color table that has been
C  previously defined.*  The color table that is defined is:
C
C      Color
C      index   Colors
C    -------   ----------------------------------------------------
C          0   black if IST is positive; white if IST is negative
C          1   white if IST is positive; black if IST is negative
C          2   red
C          3   green
C          4   blue
C          5   cyan
C          6   magenta
C          7   yellow
C      8- 37   grayscale from white to black.
C     38- 67   shades of gray
C     68- 97   shades of red
C     98-127   shades of green
C    128-157   shades of blue
C    158-187   shades of cyan
C    188-217   shades of magenta
C    218-247   shades of yellow
C
C  TDEZ3D does not call FRAME.
C
C  If the image is too small, decrease the size of RMULT; if the
C  image is too large, increase the size of RMULT.
C
C  Example:
C
C    CALL TDEZ3D(NX,NY,NZ,X,Y,Z,U,1.,0.,0.,0.,6)
C
C    would draw a isosurface (using an isovalue of 1.) in shades of 
C    cyan with a black background and with a default eye position 
C    selected.
C
C--------------------------------------------------------------------------
C
C  Set the maximum number of triangles.
C
      PARAMETER (MTRI=110000)
C
C  Specify the number of shades for each color, the starting
C  color index for the color shades part of the color table,
C  the color index of the first gray value, and the color index
C  of the last gray value.
C
      PARAMETER (NSHD=30, ICST=8, IGS=ICST+NSHD, IGL=IGS+NSHD-1)
C
C  Dimension the input arrays.
C
      DIMENSION X(NX),Y(NY),Z(NZ),U(NX,NY,NZ)
C
C  Dimension the Tdpack work arrays.
C
      DIMENSION RTRI(10,MTRI),RTWK(MTRI,2),ITWK(MTRI)
      COMMON /DSTDDT/ RTRI,RTWK,ITWK
C
C  Define the spherical coordinates for the default eye position.
C
      DATA ANG1,ANG2,RMUL / -55.,70.,2.5 /
C
C  Set the desired values of the shading parameters.  Values of SHDE
C  near 0 give brighter colors and values near 1 give pastel shades.
C  Values of SHDR near 0 give a narrow range of shades and values near
C  1 give a wide range of shades.
C
      DATA SHDE,SHDR / 0.0 , 0.8 /
C
C  Factor for converting from degrees to radians.
C
      DATA DTOR / .017453292519943 /
C
C  Determine the number of open workstations (NUMOP).
C
      CALL GQOPWK(1,IER,NUMOP,IWKID)
C
C  Loop through the open workstations and define a color table.
C
      IFC = ICST
      ILC = ICST+NSHD-1
      DO 10 I=1,NUMOP
        CALL GQOPWK(I,IER,NUMTMP,IWKID)
C     
C  Set colors only for workstations of the correct category.
C
        CALL GQWKC(IWKID,IER,ICON,ITYP)
        CALL GQWKCA(ITYP,IER,ICAT)
        IF (ICAT.EQ.0 .OR. ICAT.EQ.2 .OR. ICAT.EQ.4) THEN
          CALL TDCLRS(IWKID,1-(SIGN(1,IST)+1)/2,SHDE,SHDR,IFC,ILC,8)
        ENDIF
   10 CONTINUE
C
C  Find mins and maxs.
C
      XMIN = X(1)
      XMAX = X(NX)
      YMIN = Y(1)
      YMAX = Y(NY)
      ZMIN = Z(1)
      ZMAX = Z(NZ)
C
      XRNG = XMAX-XMIN
      YRNG = YMAX-YMIN
      ZRNG = ZMAX-ZMIN
      XMID = 0.5*(XMIN+XMAX)
      YMID = 0.5*(YMIN+YMAX)
      ZMID = 0.5*(ZMIN+ZMAX)
C
C  Define TDPACK rendering styles 1 through 8.  The indices 1-8 can 
C  then be used as final arguments in calls to TDITRI, TDSTRI, 
C  and TDMTRI.
C
      XSL = 0.05*XRNG
      YSL = 0.05*YRNG
      ZSL = 0.00*ZRNG
      CALL TDSTRS (1,  0,  0,         0,         0,1,1,0,XSL,YSL,ZSL)
      CALL TDSTRS (2,IGS,IGL,IFC+1*NSHD,ILC+1*NSHD,1,1,0,XSL,YSL,ZSL)
      CALL TDSTRS (3,IGS,IGL,IFC+2*NSHD,ILC+2*NSHD,1,1,0,XSL,YSL,ZSL)
      CALL TDSTRS (4,IGS,IGL,IFC+3*NSHD,ILC+3*NSHD,1,1,0,XSL,YSL,ZSL)
      CALL TDSTRS (5,IGS,IGL,IFC+4*NSHD,ILC+4*NSHD,1,1,0,XSL,YSL,ZSL)
      CALL TDSTRS (6,IGS,IGL,IFC+5*NSHD,ILC+5*NSHD,1,1,0,XSL,YSL,ZSL)
      CALL TDSTRS (7,IGS,IGL,IFC+6*NSHD,ILC+6*NSHD,1,1,0,XSL,YSL,ZSL)
      CALL TDSTRS (8,IGS,IGL,IFC+7*NSHD,ILC+7*NSHD,1,1,0,XSL,YSL,ZSL)
C
C  Create the triangle list representing an isosurface.  If the 
C  specified value for IST is out of range, set it to 6.
C
      NTRI=0
      IF (ABS(IST).GT.8 .OR. ABS(IST).LT.1) THEN
        JST = 6
      ELSE
        JST = ABS(IST)
      ENDIF
      CALL TDITRI (X,NX,Y,NY,Z,NZ,U,NX,NY,VALUE,
     +             RTRI,MTRI,NTRI,JST)
      IF (NTRI .EQ. MTRI) THEN
        PRINT * , 'Triangle list overflow in TDITRI'
        STOP
      END IF
C
C  Determine a default eye position if none is specified.
C
      IF (THETA.EQ.0. .AND. PHI.EQ.0. .AND. RMULT.EQ.0.) THEN
        R = RMUL*SQRT(XRNG*XRNG + YRNG*YRNG + ZRNG*ZRNG)
        XEYE = XMID+R*SIN(DTOR*ANG2)*COS(DTOR*ANG1)
        YEYE = YMID+R*SIN(DTOR*ANG2)*SIN(DTOR*ANG1)
        ZEYE = ZMID+R*COS(DTOR*ANG2)
      ELSE
C
C  Convert the user-specified eye position to Cartesian coordinates.
C
        R = RMULT*SQRT(XRNG*XRNG + YRNG*YRNG + ZRNG*ZRNG)
        XEYE = XMID+R*SIN(DTOR*PHI)*COS(DTOR*THETA)
        YEYE = YMID+R*SIN(DTOR*PHI)*SIN(DTOR*THETA)
        ZEYE = ZMID+R*COS(DTOR*PHI)
      ENDIF
C
C  Initialize TDPACK.
C
      CALL TDINIT (XEYE, YEYE, ZEYE, XMID, YMID, ZMID,
     +                   XMID, YMID, ZMID+0.1*ZRNG, 0)
C
C  Order the triangles.
C
      CALL TDOTRI (RTRI,MTRI,NTRI,RTWK,ITWK,1)
      IF (NTRI .EQ. MTRI) THEN
        PRINT * , 'Triangle list overflow in TDOTRI'
        STOP
      END IF
C
C  Draw the triangles.
C
      CALL TDDTRI (RTRI,MTRI,NTRI,ITWK)
C
      RETURN
      END

      PROGRAM SREX01
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
      COMMON /SRFIP1/ IFR        ,ISTP       ,IROTS      ,IDRX       ,
     1                IDRY       ,IDRZ       ,IUPPER     ,ISKIRT     ,
     2                NCLA       ,THETA      ,HSKIRT     ,CHI        ,
     3                CLO        ,CINC       ,ISPVAL
C
C Define the required arrays.
C
      DIMENSION XDAT(100),YDAT(100),ODAT(40,40),ZDAT(100,100),
     +                                          QDAT(100,100),
     +          WORK(20000),STLN(6)
C
C Define the data for the label on top of the graph.
C
      CHARACTER*30 PLBL
      DATA PLBL / 'Longs Peak relief using SRFACE' /
C 
C Define the line of sight (viewpoint and point looked at).
C
      DATA STLN / 5247.5 , 5247.5 , 2530. , 247.5 , 247.5 , 1280. /
C
C Open GKS, open workstation of type 1, activate workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Generate x-coordinate values.
C
      DO 10 I=1,100
         XDAT(I)=5.*REAL(I-1)
 10   CONTINUE
C
C Generate y-coordinate values.
C
      DO 15 J=1,100
         YDAT(J)=5.*REAL(J-1)
 15   CONTINUE
C
C Put the original Long's Peak data in the array ODAT.
C
      DO 20 J=1,40
         READ (5,1001)  (ODAT(I,J),I=1,40)
 20   CONTINUE
C
C Interpolate to get more closely-spaced data in the array QDAT.
C
      DO 30 J=1,100
         FL=1.+39.*REAL(J-1)/99.
         L=MAX(1,MIN(39,INT(FL)))
         FL=FL-REAL(L)
         DO 40 I=1,100
            FK=1.+39.*REAL(I-1)/99.
            K=MAX(1,MIN(39,INT(FK)))
            FK=FK-REAL(K)
            QDAT(I,J)=(1.-FL)*((1.-FK)*ODAT(K,L  )+FK*ODAT(K+1,L  ))+
     +                    FL *((1.-FK)*ODAT(K,L+1)+FK*ODAT(K+1,L+1))
 40      CONTINUE
 30   CONTINUE
C
C Apply a nine-point smoother to get smoother data in the array ZDAT.
C
      DO 50 J=1,100
         JM1=MAX(J-1,1)
         JP1=MIN(J+1,100)
         DO 60 I=1,100
            IM1=MAX(I-1,1)
            IP1=MIN(I+1,100)
            ZDAT(I,J)=.2500*QDAT(I,J)+
     +                .1250*(QDAT(IM1,J)+QDAT(IP1,J)+
     +                       QDAT(I,JM1)+QDAT(I,JP1))+
     +                .0625*(QDAT(IM1,JM1)+QDAT(IP1,JM1)+
     +                       QDAT(IM1,JP1)+QDAT(IP1,JP1))
 60      CONTINUE
 50   CONTINUE
C
C Plot the data four times.
C
      DO 70 NPLT=1,4
C
C Before the 2nd, 3rd, and 4th plots, rotate the data by 90 degrees.
C
         IF (NPLT.NE.1) THEN
            DO 80 J=1,100
               DO 90 I=1,100
                  QDAT(I,J)=ZDAT(I,J)
 90            CONTINUE
 80         CONTINUE
            DO 100 J=1,100
               K=101-J
               DO 110 I=1,100
                  L=I
                  ZDAT(I,J)=QDAT(K,L)
 110           CONTINUE
 100        CONTINUE
         END IF
C
C Call LOGO to add NCAR and SCD logos.
C
         CALL LOGO
C
C Set common variables for skirt and frame calls.
C
         ISKIRT = 1
         HSKIRT = 1100
         IFR    = 0
C
C Use SRFACE to draw a representation of the surface.
C
         CALL SRFACE (XDAT,YDAT,ZDAT,WORK,100,100,100,STLN,0.)
C
C Put in label on the top of the map.
C
         CALL PWRIT (.5,.850,PLBL,30,3,0,0)
C
C Advance to the next frame.
C
         CALL FRAME
C
C End of loop.
C
 70   CONTINUE
C
C Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      STOP
C
C Formats.
C
 1001 FORMAT (1X,15F5.0)
C
      END
C
      SUBROUTINE LOGO
C
      CALL NCAR(.55,.92)
      CALL SCD(.04,.04)
      CALL IRONS(0.09,0.090)
C
      RETURN
      END
C
      SUBROUTINE NCAR(XPOS,YPOS)
C
      CALL PCSETI ('CD', 1)
      CALL PLCHHQ ( XPOS,YPOS, 'NCAR  GRAPHICS',
     + .038, 0.0, 0.0 )
C
      CALL PCSETI ('CD', 0)
C
      RETURN
      END
C
      SUBROUTINE SCD(XBOT, YBOT)
C
      REAL XBOT, YBOT
C
      CALL PCSETI ('CD', 1)
      CALL PLCHHQ ( XBOT, YBOT, 'SCD', .04, 0.0, -1.0 )
C
      CALL PLCHHQ ( XBOT + .145, YBOT + .008,
     + 'SCIENTIFIC COMPUTING DIVISION', .012, 0.0, -1.0)
C
      CALL PLCHHQ ( XBOT + .145, YBOT - .016,
     + 'NATIONAL CENTER FOR ATMOSPHERIC RESEARCH', .012, 0.0, -1.0)
C
      CALL PCSETI ('CD', 0)
C
      CALL LINE (0.93,0.07,.18,0.07)
C
      RETURN
      END
C
      SUBROUTINE IRONS(X1,Y1)
C
      CALL LINE (X1+.039,Y1+.050,X1+0.015,Y1+0.054)
      CALL LINE (X1+.015,Y1+.054,X1-.032,Y1+0.013)
C
C Devil's Thumb.
C
      CALL LINE (X1+.010,Y1+.048,X1+.007,Y1+0.054)
      CALL LINE (X1+.007,Y1+.054,X1+.007,Y1+0.059)
      CALL LINE (X1+.007,Y1+.059,X1+.005,Y1+0.053)
      CALL LINE (X1+.005,Y1+.053,X1+.006,Y1+0.044)
C
C Bear Mountain.
C
      CALL LINE (X1+0.026,Y1+0.03,X1+.038,Y1+.05)
      CALL LINE (X1+.038,Y1+.05,X1+.053,Y1+.07)
      CALL LINE (X1+.053,Y1+.07,X1+.078,Y1+.03)
      CALL LINE (X1+.078,Y1+.03,X1+.098,Y1+.05)
      CALL LINE (X1+.098,Y1+.05,X1+.1,Y1+.04)
      CALL LINE (X1+.1,Y1+.04,X1+.13,Y1+.065)
      CALL LINE (X1+.13,Y1+.065,X1+.18,Y1+.029)
      CALL LINE (X1+.18,Y1+.029,X1+.25,Y1+.039)
      CALL LINE (X1+.25,Y1+.039,X1+.27,Y1+.026)
C
      CALL LINE (X1+.27,Y1+.026,X1+.81,Y1+.026)
      RETURN
      END

      SUBROUTINE DSPECX(X,NX,IOPT,JAVE,PCT,SCL,WORK,LWORK,FRQ,SPCX,NSPC,
     +                  SINFO,IER)
      DOUBLE PRECISION PCT
      DOUBLE PRECISION SCL
      DOUBLE PRECISION COEF
      DOUBLE PRECISION XINFO
      DOUBLE PRECISION SPVAL
      DOUBLE PRECISION X1X
      DOUBLE PRECISION FRQSP
      DOUBLE PRECISION DOF

      INTEGER NX,IOPT,JAVE,LWORK,NSPC,IER
      DOUBLE PRECISION X(NX),FRQ(*),SPCX(*),WORK(LWORK),SINFO(50)


c specx will perform a spectral analysis on the series x of length nx.

c comment :
c .   common block /spblk3/ contains assorted info the user may find
c .   useful.  it was used primarily to debug this routine.

c nomenclature:

c .   input
c .
c .   x         - real series containing the data (unchanged upon
c .               return)
c .   nx        - number of points in x
c .               nx need not be a power of 2 but the fft will run
c .               optimally if nx is highly factorable.
c .   iopt      - detrending option
c .               iopt<0 : do no detrending.
c .               iopt=0 : remove series mean (minimum recommended
c .                        option)
c .               iopt=1 : remove the series mean and lst sqrs linear
c .                        trend
c .               iopt=2 : remove the series mean and lst sqrs
c .                        quadratic trend
c .                        know what you are doing before applying
c .                        this option
c .   jave      - smoothing to be performed on the periodiogram
c .               this should be an odd number (>=3) , if not, the
c .               routine will force it to the next largest odd number.
c .               jave=0 : do no smoothing
c .                        spcx contains raw spectral estimates 
c .                        (periodogram)
c .               jave>0 : average jave periodogram estimates together
c .                        utilizing modified daniell smoothing (good
c .                        stability but may lead to large bias ).
c .                        all weights are 1/jave except wgt(1) and
c .                        wgt(jave) which are 1/(2*jave). this is 
c .                        the recommended option.
c .   pct       - % of the series to be tapered [0.<=pct>=1.]
c .               if pct=0. no tapering will be done
c .               if pct=1. the whole series is effected
c .               a pct of 0.10 is common. tapering should always be
c .               done unless the data is strictly periodic.
c .   scl       - scaling factor (there are 4 special cases.)
c .               scl = -1.: spcx estimates are scaled so that the area
c .                          under the curve [ s(f)*df ] equals one.
c .               scl = 0. : spcx estimates are scaled so that the sum
c .                          of the spectral estimates is the same as
c .                          the variance of the detrended (optional)
c .                          input series
c .               scl = 1. : spcx estimates are as calculated  by g13cbf
c .               scl = 2. : spcx estimates are scaled so that the area
c .                          under the curve [ s(f)*df ] equals the
c .                          variance of the detrended (optional)
c .                          input series.
c .               scl= 2 or -1. is recommended
c .   work      - work array
c .               if jave.ne.0 then upon return work(1 thru nspc) will
c .               contain the raw spectral estimates [i.e. , 
c .               periodogram]
c .   lwork     - length of work [ must be >= 5*nx + 17 +iabs(jave) + 1]
c .
c .   output
c .
c .   frq       - frequency vector of length nspc
c .   spcx      - spectrum : vector of length nspc
c .               spcx(1)     - this will be the **mean* of the
c .                             detrended-tapered series. it
c .                             is not a variance. it is not the
c .                             spectral estimate at freq = 0
c .               spcx(2)     - spectral estimate at freq = 1/nx
c .               spcx(3)     - spectral estimate at freq = 2/nx
c .                           .
c .               spcx(nspc) - spectral estimate at freq = 0.5
c .   nspc      - the number of spectral estimates returned (=nx/2+1)
c .   sinfo     - vector of length 10 ==> 23 for NCL
c .        (1)  - equivalent degrees of freedom
c .        (2)  - lag1 autocor of detrended/tapered x series
c .        (3)  - lag1 autocor of detrended/tapered y series for specxy
c .        (4)  - unused
c .        (5)  - freq spacing between estimates
c .        (6)  - band width (=sinfo(1)*sinfo(5)*0.5)
c .        (7)  - mult factor for  5% limit
c .        (8)  - mult factor for 95% limit
c .        (9)  - dof for series via spectrum shape(blackmon-tukey)
c .        (10) - unused
c .   ier       - error code
c .               ier=0 : no error
c .               ier'0 : see code

c sample call :

c .   real x(nx) , frq(nx/2+1) , spcx(nx/2+1)
c .              , workk(5*nx+18+iabs(jave)) , sinfo(50)
c .   iopt = 0     : remove mean
c .   jave = 11    : block average 11 periodogram est together
c .   pct  = 0.10  : taper 10% of the series
c .   scl  = 1.0   : no scaling. leave ``as"
c .   call specx  (x,nx,iopt,jave,pct,scl,work,lwork
c .              ,frq,spcx,nspc,frqsp,dof,ier)

c common block /spblk / contains other potentially useful info

c .   coef      - contains coef utilized to remove trend (if any)
c .   xinfo(1)  - mean of x prior to tapering / detrending
c .        (2)  - variance of x prior to tapering / detrending
c .        (3)  - variance of x after detrending and prior to tapering
c .        (4)  - raw sum of spcx(2 thru nspc) with no scaling or
c .               smoothing
c .               this is the variance of the detrended - tapered
c .               series.
c .        (5)  - raw sum of spcx(2 thru nspc) after smoothing
c .        (6)  - scaling utilized to normalize the spectrum to xinfo(3)
c .        (7)  - white noise level [=scale*xinfo(3)/(nspc-1)]
c .        (8)  - correction factor to dof due to tapering  (cftapr)
c .        (9)  - unused
c .        (10) - unused

      COMMON /SPBLK/COEF(3),XINFO(10)

      DATA SPVAL/1.D+36/

c check input for errors

      IER = 0
      IF (NX.LE.3) IER = 1
      IF (IOPT.GT.2) IER = IER + 20
      IF (PCT.LT.0.D0 .OR. PCT.GT.1.0D0) IER = IER + 300
      IF (LWORK.LT. (5*NX+18+IABS(JAVE))) IER = IER + 4000
      IF (IABS(JAVE).GT. (NX/2)) IER = IER + 50000

c c c do 3 n=1,nx
C check for missing values
c c c if (x(n).ne.spval) go to 4
c c 3 continue
c c c ier = ier+60000
    4 X1X = X(1)
      DO 5 N = 1,NX
C check for series of constant values
          IF (X(N).NE.X1X) GO TO 6
    5 CONTINUE
      IER = IER + 700000

C set common block to spval
    6 DO 7 N = 1,3
    7 COEF(N) = SPVAL
      DO 8 N = 1,10
          SINFO(N) = SPVAL
    8 XINFO(N) = SPVAL
      DO 88 N = 11,50
   88 SINFO(N) = SPVAL

      DO 9 N = 1,(NX/2+1)
          FRQ(N) = SPVAL
C set spectral estimates to spval
    9 SPCX(N) = SPVAL
      NSPC = 0

      IF (IER.NE.0) THEN
C return to calling prog
          RETURN
      END IF

c initilize pointers for work vector

      NX2 = NX/2
      NSPC = NX2 + 1
C pointer to real fourier coef vector
      KPTRC = NX + 1
C pointer to imag fourier coef vector
      KPTIC = KPTRC + NX2
C pointer to work vector for ezfft
      KPTSAV = KPTIC + NX2
C pointer to wgt  vector
      KPTWGT = KPTSAV + (3*NX+17)

c transfer the input series x to the work array

      DO 10 N = 1,NX
   10 WORK(N) = X(N)
      DO 15 N = NX + 1,LWORK
   15 WORK(N) = SPVAL

c initilize fft work space

      CALL DEZFFTI(NX,WORK(KPTSAV))

c spectral driver

      NLAG1 = 2
      CALL DSPECXD(WORK,NX,IOPT,JAVE,PCT,SCL,FRQ,SPCX,NSPC,FRQSP,DOF,
     +            IER,WORK(KPTRC),WORK(KPTIC),WORK(KPTSAV),WORK(KPTWGT),
     +            SPVAL,NX2,COEF,XINFO,SINFO,NLAG1)

C NCL add to sinfo
      DO 133 N = 1,10
          SINFO(10+N) = XINFO(N)
  133 CONTINUE
      DO 134 N = 1,3
          SINFO(30+N) = COEF(N)
  134 CONTINUE

      RETURN
      END
c -------------------------------------------------------------------
      SUBROUTINE DSPECXY(X,Y,NX,IOPT,JAVE,PCT,SCL,WORK,LWORK,FRQ,SPCX,
     +                   SPCY,COSPC,QUSPC,COHER,PHASE,NSPC,SINFO,IER)
      DOUBLE PRECISION PCT
      DOUBLE PRECISION SCL
      DOUBLE PRECISION XCOEF
      DOUBLE PRECISION XINFO
      DOUBLE PRECISION YCOEF
      DOUBLE PRECISION YINFO
      DOUBLE PRECISION SPVAL
      DOUBLE PRECISION X1X
      DOUBLE PRECISION Y1Y
      DOUBLE PRECISION FRQSP
      DOUBLE PRECISION DOF
      DOUBLE PRECISION SCLCS
      DOUBLE PRECISION SCLCOH

c specxy will perform a spectral/cross spc analysis on series x and y.

c nomenclature:

c .   input
c .
c .   x         - real series containing the data (unchanged upon
c .               return)
c .   y         - real series containing the data (unchanged upon
c .               return)
c .   nx        - number of points in x and y (need not be a power of 2)
c .   iopt      - detrending option
c .               iopt<0 : do no detrending.
c .               iopt=0 : remove series mean (minimum recommended 
c .                        option)
c .               iopt=1 : remove the series mean and lst sqrs linear
c .                        trend
c .               iopt=2 : remove the series mean and lst sqrs
c .                        quadratic trend
c .                        know what you are doing before applying
c .                        this option
c .   jave      - no. of spectral estimates to be averaged
c .   pct       - % of the series to be tapered [0.<=pct>=1.]
c .               if pct=0. no tapering will be done
c .               if pct=1. the whole series is effected
c .               a pct of 0.10 is common. tapering should always be
c .               done unless the data is strictly periodic.
c .   scl       - scaling factor (there are 4 special cases.)
c .               scl = -1.: spcx estimates are scaled so that the area
c .                          under the curve [ s(f)*df ] equals one.
c .               scl = 0. : spcx estimates are scaled so that the sum
c .                          of the spectral estimates is the same as
c .                          the variance of the detrended (optional)
c .                          input series
c .               scl = 1. : spcx estimates are as calculated  by g13cbf
c .               scl = 2. : spcx estimates are scaled so that the area
c .                          under the curve [ s(f)*df ] equals the
c .                          variance of the detrended (optional) 
c .                          input series.
c .   work      - work array
c .   lwork     - length of work [ must be >= 10*nx ]
c .
c .   output
c .
c .   spcx,spcy - spectrum vector of length nspc for x and y series
c .               spcx(1)    - spectral estimate at freq = 0 (ignore)
c .               spcx(nspc) - spectral estimate at freq = 0.5
c .   cospc     - cospectrum : vector of length nspc
c .               this is the real part of the cross spectrum. it
c .               measures the extent to which there are oscillations
c .               with the same phase in the two series (or with
c .               opposite sign ,i.e. , with a phase shift of half a
c .               cycle). In other words : it measures the
c .               contribution of different frequencies to the total
c .               cross-covariance at zero lag.
c .   quspc     - quadrature spectrum  : vector of length nspc
c .               this is the imaginary part of the cross spectrum. it
c .               measures the extent to which there are oscillations
c .               with a phase difference of a quarter cycle in either
c .               direction. i.e., it measures the contribution of
c .               different frequencies to the total cross-covariance
c .               of the series when all harmonics of one series
c .               are delayed a quarter cycle relative to the other
c .               relative to the other series.
c .   coher     - coherence squared  : vector of length nspc
c .               this is analogous to the square of the correlation
c .               coef except that the coherence squared is a
c .               function of frequency.
c .   phase     - phase (in degrees)  : vector of length nspc.
C)
c .               a positive phase indicates that y leads x (i think
c .   nspc      - the number of spectral estimates returned
c .               routine is set up so that nspc=nx/2+1
c .   sinfo     - must be dimensioned at least 10 in calling prog
c .               sinfo(1)  - degrees of freedom  (dof)
c .                           the dof for the cospc,quspc,coher and
c .                            phase is approximately dof-2 .
c .                    (2)  - lag1 autocor of detrended/tapered x series
c .                    (3)  - lag1 autocor of detrended/tapered y series
c .                    (4)  - unused
c .                    (5)  - freq spacing at which values should be
c .                           plotted
c .                    (6)  - `normal' bandwidth
c .                    (7)  - mult factor for  5% limit (imsl)
c .                    (8)  - mult factor for 95% limit (imsl)
c .                    (9)  - unused
c .                    (10) - unused
c .   ier       - error code
c .               ier=0 : no error
c .               ier<0 : error detected by spcng2: see code
c .               ier>0 : error detected by nag routine

c common blocks /spblkx,spblky/ contain other potentially useful info

c .   x/ycoef     - contains coef utilized to remove trend (if any)
c .   x/yinfo(1)  - mean of x prior to tapering / detrending
c .          (2)  - variance of x prior to tapering / detrending
c .          (3)  - variance of x after detrending and prior to tapering
c .          (4)  - raw sum of spcx(2 thru nspc) after smoothing
c .          (5)  - same as xinfo(4)
c .          (6)  - scaling utilized to normalize the spectrum to
c .                 xinfo(3)
c .          (7)  - white noise level [=xinfo(3)/(nspc-1)]
c .          (8)  - correction factor to dof due to tapering  (cftapr)
c .          (9)  - unused
c .          (10) - unused

      DOUBLE PRECISION X(NX),Y(NX),FRQ(*),SPCX(*),SPCY(*),WORK(LWORK),
     +                 COSPC(*),QUSPC(*),PHASE(*),COHER(*),SINFO(50)

      COMMON /SPBLKX/XCOEF(3),XINFO(10)
      COMMON /SPBLKY/YCOEF(3),YINFO(10)

      DATA SPVAL/1.D+36/

c check input for errors

      IER = 0
      IF (NX.LE.3) IER = 1
      IF (IOPT.GT.2) IER = IER + 20
      IF (PCT.LT.0.D0 .OR. PCT.GT.1.0D0) IER = IER + 300
      IF (LWORK.LT.10*NX) IER = IER + 4000
      IF (IABS(JAVE).GT. (NX/2)) IER = IER + 50000

      DO 2 N = 1,NX
C chk for msg values
          IF (X(N).EQ.SPVAL .OR. Y(N).EQ.SPVAL) THEN
              IER = IER + 60000
              GO TO 3
          END IF
    2 CONTINUE
    3 X1X = X(1)
      DO 4 N = 1,NX
C check for series of constant values
          IF (X(N).NE.X1X) GO TO 5
    4 CONTINUE
      IER = IER + 700000
      GO TO 6
    5 Y1Y = Y(1)
      DO 55 N = 1,NX
C check for series of constant values
          IF (Y(N).NE.Y1Y) GO TO 6
   55 CONTINUE
      IER = IER + 700000

    6 IF (IER.NE.0) THEN
C set common block to spval
          DO 7 N = 1,3
              XCOEF(N) = SPVAL
    7     YCOEF(N) = SPVAL
          DO 8 N = 1,10
              SINFO(N) = SPVAL
              YINFO(N) = SPVAL
    8     XINFO(N) = SPVAL
          DO 88 N = 11,50
   88     SINFO(N) = SPVAL
          DO 9 N = 1,(NX/2+1)
              FRQ(N) = SPVAL
              COSPC(N) = SPVAL
              QUSPC(N) = SPVAL
              COHER(N) = SPVAL
              PHASE(N) = SPVAL
              SPCY(N) = SPVAL
    9     SPCX(N) = SPVAL
          NSPC = 0
C return to calling prog
          RETURN
      END IF

c initilize pointers for work vector

      NX2 = NX/2
      NSPC = NX2 + 1
C pointer to real fourier coef vec x
      KPTRCX = NX + 1
C pointer to imag fourier coef vec x
      KPTICX = KPTRCX + NX2
C pointer to real fourier coef vec y
      KPTRCY = KPTICX + NX2
C pointer to imag fourier coef vec y
      KPTICY = KPTRCY + NX2
C pointer to imag fourier coef vec y
      KPTSAV = KPTICY + NX2
C pointer to wgt  vector
      KPTWGT = KPTSAV + (3*NX+17)

c transfer the input series x to the work array

      DO 10 N = 1,NX
   10 WORK(N) = X(N)
      DO 15 N = NX + 1,LWORK
   15 WORK(N) = SPVAL

c initilize fft work space

      CALL DEZFFTI(NX,WORK(KPTSAV))

c spectral driver (x vector)

      NLAG1 = 2
      CALL DSPECXD(WORK,NX,IOPT,JAVE,PCT,SCL,FRQ,SPCX,NSPC,FRQSP,DOF,
     +            IER,WORK(KPTRCX),WORK(KPTICX),WORK(KPTSAV),
     +            WORK(KPTWGT),SPVAL,NX2,XCOEF,XINFO,SINFO,NLAG1)

c transfer the input series y to the work array

      DO 20 N = 1,NX
   20 WORK(N) = Y(N)

c spectral driver (y vector)

      NLAG1 = 3
      CALL DSPECXD(WORK,NX,IOPT,JAVE,PCT,SCL,FRQ,SPCY,NSPC,FRQSP,DOF,
     +            IER,WORK(KPTRCY),WORK(KPTICY),WORK(KPTSAV),
     +            WORK(KPTWGT),SPVAL,NX2,YCOEF,YINFO,SINFO,NLAG1)

c compute the cospectrum and quadrature spectrum

      SCLCS = SQRT(XINFO(6)*YINFO(6))
      COSPC(1) = SPCX(1)*SPCY(1)
      QUSPC(1) = SPCX(1)*SPCY(1)
      DO 60 N = 0,NX2 - 1
          COSPC(N+2) = SCLCS* (WORK(KPTRCX+N)*WORK(KPTRCY+N)+
     +                 WORK(KPTICX+N)*WORK(KPTICY+N))
C minus sign is to match nag output
   60 QUSPC(N+2) = -SCLCS* (WORK(KPTICX+N)*WORK(KPTRCY+N)-
     +             WORK(KPTRCX+N)*WORK(KPTICY+N))

      KOPT = 1
      JAVODD = 2*IABS(JAVE/2) + 1
C can use work again
      CALL DSWRNAV(COSPC(2),NSPC-1,WORK(KPTWGT),JAVODD,KOPT,SPVAL,WORK,
     +            IER)
      CALL DSWRNAV(QUSPC(2),NSPC-1,WORK(KPTWGT),JAVODD,KOPT,SPVAL,WORK,
     +            IER)

c compute the coherence and phase now that the co/quspc have been
c calculated

      SCLCOH = 1.0D0
      DO 70 N = 1,NSPC
          PHASE(N) = ATAN2(QUSPC(N),COSPC(N))*57.29578D0
          IF (SPCX(N).NE.0.D0 .AND. SPCY(N).NE.0.D0) THEN
              COHER(N) = SCLCOH* (COSPC(N)**2+QUSPC(N)**2)/
     +                   (SPCX(N)*SPCY(N))
          ELSE
              COHER(N) = 0.D0
          END IF
   70 CONTINUE

C NCL add to sinfo
      DO 133 N = 1,10
          SINFO(10+N) = XINFO(N)
          SINFO(20+N) = YINFO(N)
  133 CONTINUE
      DO 134 N = 1,3
          SINFO(30+N) = XCOEF(N)
          SINFO(33+N) = YCOEF(N)
  134 CONTINUE

      RETURN
      END
c --------------------------------------------------------------------
      SUBROUTINE DSPECXD(X,NX,IOPT,JAVE,PCT,SCL,FRQ,SPC,NSPC,FRQSP,DOF,
     +                   IER,CR,CI,SAVE,WGT,SPVAL,NX2,COEF,XINFO,SINFO,
     +                   NLAG1)
      DOUBLE PRECISION PCT
      DOUBLE PRECISION SCL
      DOUBLE PRECISION FRQSP
      DOUBLE PRECISION DOF
      DOUBLE PRECISION SPVAL
      DOUBLE PRECISION XMSG
      DOUBLE PRECISION PI
      DOUBLE PRECISION WGTSQ
      DOUBLE PRECISION CFTAPR
      DOUBLE PRECISION SCALE
      DOUBLE PRECISION XMEAN
      DOUBLE PRECISION XMEANX
      DOUBLE PRECISION XVARX
      DOUBLE PRECISION AZERO
      DOUBLE PRECISION WGTSUM

      DOUBLE PRECISION X(NX),FRQ(NSPC),SPC(NSPC),SAVE(*),WGT(*),CR(NX2),
     +                 CI(NX2),COEF(3),XINFO(10),SINFO(50)
      PARAMETER (MXLAG=1,XMSG=1.D+36)
      DOUBLE PRECISION ACV(0:MXLAG),ACR(0:MXLAG)

      DATA PI/3.141592653589D0/

c initilize some constants

      DF   = 1.0D0/DBLE(NX)
      NXP1 = NX + 1
      NXM1 = NX - 1
      NSPCM1 = NSPC - 1
      FRQSP = 1.D0/DBLE(NX)
      WGTSQ = 1.0D0
      DOF = 2.0D0
      CFTAPR = 1.0D0
      SCALE = SCL
      DO 20 N = 1,10
   20 XINFO(N) = SPVAL

c perform detrending option (iopt)
c .   the mean and variance will always be calculated
c .   note : if iopt=1 or 2 then the variance of x on output [xinfo(3)]
c .   may be considerably different (reduced) from the variance of x
c .   on input [xinfo(2)]. xinfo(1) will contain the mean of the
c .   input series.

      CALL DDTRNDX (X,NX,IOPT,XINFO(1),XINFO(2),XINFO(3),COEF,IER)

c perform tapering on detrended x vector
c .   the tapering procedure alters the variance of the input
c .   series and as a result lowers the dof associated with each
c .   spectral estimate. if pct is 0.05 or 0.10 then the effect is
c .   small.
c .   the purpose of tapering when viewed from the frequency domain
c .   is to suppress large side lobes in the effective filter obtained
c .   with the raw transform. in the time domain , the object of
c .   tapering is to round off potential discontinuities at each end
c .   of the finite segment being analyzed.

      IF (PCT.GT.0.0D0) THEN
          IF (IOPT.GE.0) THEN
              XMEAN = 0.0D0
          ELSE
              XMEAN = XINFO(1)
          END IF
          CALL DTAPERX(X,NX,PCT,XMEAN,CFTAPR)
      END IF

c calculate lag1 autocorrelation

      XMEANX = XMSG
      XVARX = XMSG
      CALL DESAUTO(X,NX,XMSG,XMEANX,XVARX,MXLAG,ACV,ACR,IER)
      SINFO(NLAG1) = ACR(1)

c perform an fft on the detrended-tapered series with zeros added

      CALL DEZFFTF(NX,X,AZERO,CR,CI,SAVE)

c calculate the raw spectrum  sum the spectral estimates

      SPC(1) = AZERO
      DO 40 N = 2,NSPC
   40 SPC(N) = (CR(N-1)**2+CI(N-1)**2)

      XINFO(4) = 0.0D0
      DO 41 N = 2,NSPC
   41 XINFO(4) = XINFO(4) + SPC(N)
      XINFO(5) = XINFO(4)

c smooth the raw spectral estimates (if desired)

C make sure its odd
      IF (IABS(JAVE).GT.2) THEN
          JAVODD = 2*IABS(JAVE/2) + 1
          DO 70 N = 2,JAVODD - 1
   70     WGT(N) = 1.00D0
          WGT(1) = 0.5D0
          WGT(JAVODD) = 0.5D0

c normalize the sum of the wgts to one then sum the square of the
c .   normalized wgts to calculate the deg of freedom

          WGTSUM = 0.0D0
          DO 120 N = 1,JAVODD
  120     WGTSUM = WGTSUM + WGT(N)

          DO 123 N = 1,JAVODD
  123     WGT(N) = WGT(N)/WGTSUM

          WGTSQ = 0.0D0
          DO 125 N = 1,JAVODD
  125     WGTSQ = WGTSQ + WGT(N)**2

c perform weighted running ave
c .   kopt = 1 means to utilize symmetric averaging at the ends of
c .   the spectrum. note : spc(1) is not utilized. if the user does
c .   want this estimate included in the averaging change the (2) to
c .   (1) for both spc and x and nspcm1 to nspc.

          KOPT = 1
          X(1) = SPC(1)
          CALL DSWRNAV(SPC(2),NSPCM1,WGT,JAVODD,KOPT,SPVAL,X(2),IER)

      END IF

c sum the spectral estimates
C only half the width

      XINFO(5) = (SPC(2)+SPC(NSPC))*0.5D0*DF
      DO 150 N = 3,NSPC-1
  150 XINFO(5) = XINFO(5) + SPC(N)*DF

      IF (SCL.EQ.0.D0) THEN
C scale sum spcx to input variance
          XINFO(6) = XINFO(3)/XINFO(5)
C white noise level
          XINFO(7) = XINFO(3)/DBLE(NSPC)
      ELSE IF (SCL.EQ.1.D0) THEN
C keep spcx as returned by g13cbf
          XINFO(6) = 1.0D0
C white noise level
          XINFO(7) = XINFO(5)/DBLE(NSPC-1)
      ELSE IF (SCL.EQ.-1.D0) THEN
C scal spcx estimate to 1.0
          XINFO(6) = 1.0D0*DBLE(NX)/XINFO(5)
C white noise level
          XINFO(7) = 1.0D0/DBLE(NSPC)
C white noise level
c        xinfo(7) = 1.0*float(nx)/float(nspc)
      ELSE IF (SCL.EQ.2.D0) THEN
C area under curve=total variance
          XINFO(6) = XINFO(3)/XINFO(5)
C white noise level
          XINFO(7) = XINFO(3)/DBLE(NSPC)
      ELSE
C user specified scaling
          XINFO(6) = SCL
C white noise level
          XINFO(7) = SCL*XINFO(5)/DBLE(NSPC)
      END IF

      DO 250 N = 2,NSPC
  250 SPC(N) = SPC(N)*XINFO(6)

      XINFO(8) = CFTAPR

c correct the dof for :
c .   (1) the tapering , if any  [the factor cftapr]
c .   (2) the weighting utilized [the factor wgtsq]

      DOF = DOF/ (CFTAPR*WGTSQ)


      SINFO(1) = DOF
      SINFO(5) = FRQSP
C see jones pg 202: murphy + katz
      SINFO(6) = SINFO(1)*SINFO(5)*0.5D0
      IF (DOF.GT.0.50D0) THEN
C imsl
c imsl   sinfo(7) = chiin (0.05,dof)/dof
c imsl   sinfo(8) = chiin (0.95,dof)/dof
          IFAIL = 0
          JFAIL = 0
C nag
c nag    sinfo(7) = g01ccf (0.05,dof,ifail)/dof
c nag    sinfo(8) = g01ccf (0.95,dof,jfail)/dof
          SINFO(7) = SPVAL
          SINFO(8) = SPVAL
      ELSE
          SINFO(7) = SPVAL
          SINFO(8) = SPVAL
      END IF

      DO 270 N = 1,NSPC
  270 FRQ(N) = SINFO(5)*DBLE(N-1)

c c c call specdf  (frq,spc,nspc,sinfo(9),ier)

      RETURN
      END
c --------------------------------------------------------------------
      SUBROUTINE DTAPERX(X,N,P,XAV,CFT)
      DOUBLE PRECISION X
      DOUBLE PRECISION P
      DOUBLE PRECISION XAV
      DOUBLE PRECISION CFT
      DOUBLE PRECISION PI
      DOUBLE PRECISION PIM
      DOUBLE PRECISION WEIGHT
c
c this subroutine applies split-cosine-bell tapering tothe series x.
c .   the series will be tapered to the mean of x.
c
c arguments:
c .   x   series to be tapered (tapering done in place)
c .   n   series length
c .   p   the proportion of the time series to be tapered [p=0.10 means
c .   xav mean of the input series x (i.e., value to which the series
c .       should be tapered). if the series mean has been removed then
c .       xav = 0.0
c .   cft correction factor for taper (not used , for info only)
c
      DIMENSION X(N)
      DATA PI/3.141592653589D0/

      M = MAX0(1,INT(P*DBLE(N)+0.5D0)/2)
      PIM = PI/DBLE(M)
      DO I = 1,M
          WEIGHT = 0.5D0 - 0.5D0*COS(PIM* (DBLE(I)-0.5D0))
          X(I) = (X(I)-XAV)*WEIGHT + XAV
          X(N+1-I) = (X(N+1-I)-XAV)*WEIGHT + XAV
      END DO
      CFT = 0.5D0* (128.D0-93.D0*P)/ (8.D0-5.D0*P)**2
      RETURN
      END
c -------------------------------------------------------------------
      SUBROUTINE DSWRNAV(X,NPTS,WGT,NPTAV,KOPT,SPVL,WORK,IER)
      DOUBLE PRECISION X
      DOUBLE PRECISION WGT
      DOUBLE PRECISION SPVL
      DOUBLE PRECISION WORK
      DOUBLE PRECISION WSUM
      DOUBLE PRECISION XNAV
c
c this routine will perform a weighted running average on x
c .   several options are given for end points
c
c nomenclature:
c .   x         - on input the series to be smoothed
c .               on output the smoothed series
c .   npts      - no of pts in x
c .   wgt       - vector of length nptav containing the wgts
c .               e.g. , nptav=3 : wgt(1) = 1. , wgt(2) = 2. , wgt(3) =
c .                             or wgt(1) = .25, wgt(2) = .50, wgt(3) =
c .   nptav     - no. of pts to be utilized in the running average
c .               nptav must be odd and >= 3
c .   kopt      - end-point option
c .               kopt < 0 : utilize cyclic conditions
c .                          e.g.,  nptav=3 at n=1
c .                          x(1)=(wgt(1)*x(npts)+wgt(2)*x(1)+ 
c .                                wgt(3)*x(2))/(wgt(1)+wgt(2)+wgt(3))
c .               kopt = 0 : set unsmoothed beginning and end pts to
c .                          spvl
c .                          e.g.,  nptav=3 , x(1) = spvl and x(npts) =
c .               kopt > 0 : utilize reflective (symmetric) conditions
c .                          e.g.,  nptav=3 at n=1
c .                          x(1)=(wgt(1)*x(2)+wgt(2)*x(1)+wgt(3)*x(2))
c .                              /(wgt(1)+wgt(2)+wgt(3))
c .   spvl      - if kopt=0 set end points to this special value
c .               spvl = 0. or 1.e+36 or the series mean are common
c .   work      - work vector of length npts
c .               on return this will contain the unsmoothed series
c .   ier       - error flag
c .               ier = 0 : no errors
c .               ier = -11 : npts @ 0
c .               ier = -12 : npts < nptav
c .               ier = -13 : nptav is not odd
c
      DIMENSION X(NPTS),WORK(NPTS),WGT(NPTAV)

      IER = 0
      IF (NPTS.LT.1) IER = -11
      IF (NPTAV.GT.NPTS) IER = -12
      IF (MOD(NPTAV,2).EQ.0) IER = -13
      IF (IER.LT.0) RETURN

c dup the vectors

      DO N = 1,NPTS
          WORK(N) = X(N)
      END DO

      IF (NPTAV.LT.3) RETURN

c sum the wgts

      WSUM = 0.0D0
      DO N = 1,NPTAV
          WSUM = WSUM + WGT(N)
      END DO
      IF (WSUM.GT.1.0D0) THEN
          XNAV = 1.0D0/WSUM
      ELSE
          XNAV = 1.0D0
      END IF

c do the middle pts first

      NAV = NPTAV
      NAV2 = NAV/2
      NSTRT = NAV2 + 1
      NEND = NPTS - NAV2

      DO N = NSTRT,NEND
          MSTRT = N - NAV2
          MEND = N + NAV2
          ML = 0
          WSUM = 0.D0
          DO M = MSTRT,MEND
              ML = ML + 1
              WSUM = WSUM + WORK(M)*WGT(ML)
          END DO
          X(N) = WSUM*XNAV
      END DO
      IF (KOPT.NE.0) THEN
          NAV2P2 = NAV2 + 2
          DO N = 1,NAV2
              MEND = NAV2 + N
              MLSTRT = NAV2P2 - N
              ML = MLSTRT - 1
              WSUM = 0.0D0
              DO M = 1,MEND
                  ML = ML + 1
                  WSUM = WSUM + WORK(M)*WGT(ML)
              END DO

              MEND = NAV2P2 - N
              ML = MLSTRT
              DO M = 2,MEND
                  ML = ML - 1
                  MLOC = M
                  IF (KOPT.LT.0) MLOC = NPTS + 1 - M
                  WSUM = WSUM + WORK(MLOC)*WGT(ML)
              END DO

              X(N) = WSUM*XNAV
          END DO

c do the final portion of x

          NPTS2 = 2*NPTS
          NSTRT = NPTS - NAV2 + 1
          DO N = NSTRT,NPTS
              MSTRT = N - NAV2
              MEND = N + NAV2
              ML = 0
              WSUM = 0.0D0
              DO M = MSTRT,MEND
                  ML = ML + 1
                  MLOC = M
                  IF (MLOC.GT.NPTS .AND. KOPT.GT.0) MLOC = NPTS2 - MLOC
                  IF (MLOC.GT.NPTS .AND. KOPT.LT.0) MLOC = MLOC - NPTS
                  WSUM = WSUM + WORK(MLOC)*WGT(ML)
              END DO
              X(N) = WSUM*XNAV
          END DO
          RETURN
      END IF
      DO N = 1,NAV2
          X(N) = SPVL
      END DO
      NSTRT = NPTS - NAV2 + 1
      DO N = NSTRT,NPTS
          X(N) = SPVL
      END DO

      RETURN
      END

      SUBROUTINE HLUCPCLAM (ZDAT,RWRK,IWRK,IAMA)
C
      DIMENSION ZDAT(IZD1,*),RWRK(*),IWRK(*),IAMA(*)
C
C This routine adds contour lines to an area map.
C
C ZDAT is the user's data array.
C
C RWRK is the user's real workspace array.
C
C IWRK is the user's integer workspace array.
C
C IAMA is the user's area map.
C
C
C Declare all of the CONPACK common blocks.
C
C
C CPCOM1 contains integer and real variables.
C
      COMMON /CPCOM1/ ANCF,ANHL,ANIL,ANLL,CDMX,CHWM,CINS,CINT(10)
      COMMON /CPCOM1/ CINU,CLDB(256),CLDL(256),CLDR(256)
      COMMON /CPCOM1/ CLDT(256),CLEV(256),CLWA(259),CXCF
      COMMON /CPCOM1/ CXIL,CYCF,CYIL,DBLF,DBLM,DBLN,DBLV,DFLD,DOPT
      COMMON /CPCOM1/ EPSI,FNCM,GRAV,GRSD,GSDM,HCHL,HCHS,IAIA(259)
      COMMON /CPCOM1/ IAIB(256),IBCF,IBHL,IBIL,IBLL,ICAF,ICCF
      COMMON /CPCOM1/ ICCL(259),ICFF,ICHI,ICHL,ICIL,ICLL(256)
      COMMON /CPCOM1/ ICLO,ICLP(256),ICLS,ICLU(259),ICLV,ICLW
      COMMON /CPCOM1/ IDUF,IGCL,IGLB,IGRM,IGRN,IGVS,IHCF,IHLE,IHLX
      COMMON /CPCOM1/ IHLY,IIWS(2),IIWU,ILBC,IMPF,INCX(8),INCY(8)
      COMMON /CPCOM1/ INHL,INIL,INIT,INLL,IOCF,IOHL,IOLL,IPAI,IPCF
      COMMON /CPCOM1/ IPIC,IPIE,IPIL,IPLL,IRWS(4),IRWU,ISET,IWSO
      COMMON /CPCOM1/ IZD1,IZDM,IZDN,IZDS,JODP,JOMA,JOTZ,LCTM,LEA1
      COMMON /CPCOM1/ LEA2,LEA3,LEE1,LEE2,LEE3,LINS,LINT(10),LINU
      COMMON /CPCOM1/ LIWK,LIWM,LIWS(2),LNLG,LRWC,LRWG,LRWK
      COMMON /CPCOM1/ LRWM,LRWS(4),LSDD,LSDL,LSDM,LTCF,LTHI
      COMMON /CPCOM1/ LTIL,LTLO,MIRO,NCLB(256),NCLV,NDGL,NEXL
      COMMON /CPCOM1/ NEXT,NEXU,NLBS,NLSD,NLZF,NOMF,NOVS,NR04,NSDL
      COMMON /CPCOM1/ NSDR,OORV,PITH,SCFS,SCFU,SEGL,SVAL,T2DS,T3DS
      COMMON /CPCOM1/ UCMN,UCMX,UVPB,UVPL,UVPR,UVPS,UVPT,UWDB,UWDL
      COMMON /CPCOM1/ UWDR,UWDT,UXA1,UXAM,UYA1,UYAN,WCCF,WCHL,WCIL
      COMMON /CPCOM1/ WCLL,WLCF,WLHL,WLIL,WLLL,WOCH,WODA,WTCD,WTGR
      COMMON /CPCOM1/ WTNC,WTOD,WWCF,WWHL,WWIL,WWLL,XAT1,XATM,XLBC
      COMMON /CPCOM1/ XVPL,XVPR,XWDL,XWDR,YAT1,YATN,YLBC,YVPB,YVPT
      COMMON /CPCOM1/ YWDB,YWDT,ZDVL,ZMAX,ZMIN
      EQUIVALENCE (IIWS(1),II01),(LIWS(1),LI01)
      EQUIVALENCE (IIWS(2),II02),(LIWS(2),LI02)
      EQUIVALENCE (IRWS(1),IR01),(LRWS(1),LR01)
      EQUIVALENCE (IRWS(2),IR02),(LRWS(2),LR02)
      EQUIVALENCE (IRWS(3),IR03),(LRWS(3),LR03)
      EQUIVALENCE (IRWS(4),IR04),(LRWS(4),LR04)
      SAVE   /CPCOM1/
C
C CPCOM2 holds character parameters.
C
      COMMON /CPCOM2/ CHEX,CLBL(256),CLDP(259),CTMA,CTMB,FRMT
      COMMON /CPCOM2/ TXCF,TXHI,TXIL,TXLO
      CHARACTER*13 CHEX
      CHARACTER*64 CLBL
      CHARACTER*128 CLDP
      CHARACTER*500 CTMA,CTMB
      CHARACTER*8 FRMT
      CHARACTER*64 TXCF
      CHARACTER*32 TXHI
      CHARACTER*128 TXIL
      CHARACTER*32 TXLO
      SAVE   /CPCOM2/
C
C Declare the common block that holds the clipping-window parameters
C for the routine CPWLAM.
C
      COMMON /CPWCMN/ XMIN,XMAX,YMIN,YMAX
C
C Define a couple of little workspace arrays required by CPTROE.
C
      DIMENSION RWKL(12),RWKR(12)
C
C Check for an uncleared prior error.
C
      IF (ICFELL('CPCLAM - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C If initialization has not been done, log an error and quit.
C
      IF (INIT.EQ.0) THEN
        CALL SETER ('CPCLAM - INITIALIZATION CALL NOT DONE',2,1)
        RETURN
      END IF
C
C Do the proper SET call.
C
      CALL SET (XVPL,XVPR,YVPB,YVPT,XWDL,XWDR,YWDB,YWDT,LNLG)
      IF (ICFELL('CPCLAM',3).NE.0) RETURN
C
C If no contour levels are defined, try to pick a set of levels.
C
      IF (NCLV.LE.0) THEN
        CALL CPPKCL (ZDAT,RWRK,IWRK)
        IF (ICFELL('CPCLAM',4).NE.0) RETURN
      END IF
C
C Get indices for the contour levels in ascending order.
C
      IF (NCLV.GT.0) CALL CPSORT (CLEV,NCLV,ICLP)
C
C Get a little real workspace to use and re-do the call to SET so that
C we can use fractional coordinates.
C
      CALL CPGRWS (RWRK,1,10,IWSE)
      IF (IWSE.NE.0.OR.ICFELL('CPCLAM',5).NE.0) RETURN
      CALL SET (XVPL,XVPR,YVPB,YVPT,XVPL,XVPR,YVPB,YVPT,1)
      IF (ICFELL('CPCLAM',6).NE.0) RETURN
C
C Add the viewport perimeter to the area map.  This avoids problems
C which arise when mapping is turned on and the mapping function has
C a discontinuity (as, for example, a cylindrical equidistant EZMAP
C projection does).  This used to be done only when the mapping flag
C was turned on, but now it is done unconditionally, so as to force
C an area identifier of "-1" outside the viewport.  Also, as of
C 06/04/91, the area identifier on the inside of the viewport is set
C to zero, rather than to a value associated with a contour level.
C (And, as of 8/24/04, I'm pinching in the viewport just slightly.)
C
      RWRK(IR01+ 1)=XVPL+.000001
      RWRK(IR01+ 2)=XVPR-.000001
      RWRK(IR01+ 3)=XVPR-.000001
      RWRK(IR01+ 4)=XVPL+.000001
      RWRK(IR01+ 5)=XVPL+.000001
      RWRK(IR01+ 6)=YVPB+.000001
      RWRK(IR01+ 7)=YVPB+.000001
      RWRK(IR01+ 8)=YVPT-.000001
      RWRK(IR01+ 9)=YVPT-.000001
      RWRK(IR01+10)=YVPB+.000001
C
      CALL AREDAM (IAMA,RWRK(IR01+1),RWRK(IR01+6),5,IGCL,0,-1)
      IF (ICFELL('CPCLAM',7).NE.0) RETURN
C
C If it is to be done, put into the area map edges creating a set of
C vertical strips.
C
      IF (NOVS.NE.0) THEN
        CALL AREDAM (IAMA,RWRK(IR01+1),RWRK(IR01+6),5,IGVS,0,-1)
        IF (ICFELL('CPCLAM',8).NE.0) RETURN
        DO 10001 IOVS=1,NOVS-1
          RWRK(IR01+1)=XVPL+REAL(IOVS)*(XVPR-XVPL)/REAL(NOVS)
          RWRK(IR01+2)=RWRK(IR01+1)
          CALL AREDAM (IAMA,RWRK(IR01+1),RWRK(IR01+9),2,IGVS,0,0)
          IF (ICFELL('CPCLAM',9).NE.0) RETURN
10001   CONTINUE
      END IF
C
C Discard the real workspace used above and re-call SET.
C
      LR01=0
      CALL SET (XVPL,XVPR,YVPB,YVPT,XWDL,XWDR,YWDB,YWDT,LNLG)
      IF (ICFELL('CPCLAM',10).NE.0) RETURN
C
C Put edges of areas which are invisible into the area map.  This one
C is done first because the area-identifier information on the visible
C side is not as good as that provided by the other edges.  Of course,
C it is only done if the mapping flag is turned on and there is the
C possibility that some points are invisible under the mapping.
C
      IF (IMPF.NE.0.AND.OORV.NE.0.) THEN
C
C There are two ways to trace these edges, depending on whether the
C user-supplied CPMPXY will do the inverse transformation or not.  By
C convention, if CPMPXY is called with its first argument equal to zero
C and its second argument equal to the real equivalent of a particular
C mapping index, the third argument will be returned as a 0. if neither
C mapping is defined, as a 1. if only the forward mapping is defined,
C as a 2. if only the inverse mapping is defined, and as a 3. if both
C the forward and the inverse mappings are defined.  Find out if the
C inverse mapping is available.
C
        TST1=REAL(IMPF)
        TST2=0.
C
        CALL HLUCPMPXY (0,TST1,TST2,TST3,TST4)
        IF (ICFELL('CPCLAM',11).NE.0) RETURN
C
        IF (TST2.NE.2..AND.TST2.NE.3.) THEN
C
C CPMPXY will not do the inverse transformation.  We do the best we can.
C
          IJMP=0
          IAIC=0
C
10002     CONTINUE
            CALL CPTREV (ZDAT,RWRK,IWRK,IJMP,IAIC,IRW1,IRW2,NRWK)
            IF (ICFELL('CPCLAM',12).NE.0) RETURN
            IF (IJMP.EQ.0) GO TO 10003
            IF (MIRO.EQ.0) THEN
              CALL AREDAM (IAMA,RWRK(IRW1+1),RWRK(IRW2+1),NRWK,IGCL,
     +                                              IAIA(259),IAIC)
              IF (ICFELL('CPCLAM',13).NE.0) RETURN
            ELSE
              CALL AREDAM (IAMA,RWRK(IRW1+1),RWRK(IRW2+1),NRWK,IGCL,
     +                                              IAIC,IAIA(259))
              IF (ICFELL('CPCLAM',14).NE.0) RETURN
            END IF
          GO TO 10002
10003     CONTINUE
C
C CPMPXY will do the inverse transformation.  We use it to generate the
C desired edges.  Note that mirror imaging, which can affect the use of
C coordinates returned by all of the other edge-tracing routines, does
C not affect the use of coordinates returned by CPTRVE.
C
        ELSE
C
          XMIN=XVPL
          XMAX=XVPR
          YMIN=YVPB
          YMAX=YVPT
C
          IJMP=0
          IAIC=0
C
10004     CONTINUE
            CALL CPTRVE (ZDAT,RWRK,IWRK,IJMP,IAIC,IRW1,IRW2,NRWK)
            IF (ICFELL('CPCLAM',15).NE.0) RETURN
            IF (IJMP.EQ.0) GO TO 10005
            DO 10006 I=1,NRWK
              RWRK(IRW1+I)=CUFX(RWRK(IRW1+I))
              IF (ICFELL('CPCLAM',16).NE.0) RETURN
              RWRK(IRW2+I)=CUFY(RWRK(IRW2+I))
              IF (ICFELL('CPCLAM',17).NE.0) RETURN
10006       CONTINUE
            CALL CPTROE (RWRK(IRW1+1),RWRK(IRW2+1),NRWK,+.0005,RWKL,
     +                             IOCF,IAMA,IGCL,IAIA(259),IAIC)
            IF (ICFELL('CPCLAM',18).NE.0) RETURN
            CALL CPTROE (RWRK(IRW1+1),RWRK(IRW2+1),NRWK,-.0005,RWKR,
     +                             IOCF,IAMA,IGCL,IAIA(259),IAIC)
            IF (ICFELL('CPCLAM',19).NE.0) RETURN
          GO TO 10004
10005     CONTINUE
C
        END IF
C
      END IF
C
C Add the edge of the grid.
C
C  2016-08-12:
C  Modified such that the grid boundary is added only if the area
C  outside the grid is to be filled. Otherwise this does not seem
C  to be needed and causes problems;
C  See jira ncl-2443. Similar changes have been made for Conpackt
C
      IJMP=0
      IAIC=0
C
      IF (IAIA(257).GT.0) THEN
10007   CONTINUE
          CALL CPTREG (ZDAT,RWRK,IWRK,IJMP,IAIC,IRW1,IRW2,NRWK)
          IF (ICFELL('CPCLAM',20).NE.0) RETURN
          IF (IJMP.EQ.0) GO TO 10008
          IF (MIRO.EQ.0) THEN
            CALL AREDAM (IAMA,RWRK(IRW1+1),RWRK(IRW2+1),NRWK,IGCL,
     +                                              IAIC,IAIA(257))
            IF (ICFELL('CPCLAM',21).NE.0) RETURN
          ELSE
            CALL AREDAM (IAMA,RWRK(IRW1+1),RWRK(IRW2+1),NRWK,IGCL,
     +                                              IAIA(257),IAIC)
            IF (ICFELL('CPCLAM',22).NE.0) RETURN
          END IF
        GO TO 10007
10008   CONTINUE
      END IF
C
C Add edges of areas filled with special values.
C
      IJMP=0
      IAIC=0
C
10009 CONTINUE
        CALL CPTRES (ZDAT,RWRK,IWRK,IJMP,IAIC,IRW1,IRW2,NRWK,0)
        IF (ICFELL('CPCLAM',23).NE.0) RETURN
        IF (IJMP.EQ.0) GO TO 10010
        IF (MIRO.EQ.0) THEN
          CALL AREDAM (IAMA,RWRK(IRW1+1),RWRK(IRW2+1),NRWK,IGCL,
     +                                              IAIA(258),IAIC)
          IF (ICFELL('CPCLAM',24).NE.0) RETURN
        ELSE
          CALL AREDAM (IAMA,RWRK(IRW1+1),RWRK(IRW2+1),NRWK,IGCL,
     +                                              IAIC,IAIA(258))
          IF (ICFELL('CPCLAM',25).NE.0) RETURN
        END IF
      GO TO 10009
10010 CONTINUE
C
C If the constant-field flag is not set, add the selected contour lines
C to the area map.
C
      CLVP=0.
C
      IF (ICFF.EQ.0) THEN
C
          I = 1
          GO TO 10013
10011     CONTINUE
          I =I +1
10013     CONTINUE
          IF (I .GT.(NCLV)) GO TO 10012
C
          ICLV=ICLP(I)
C
          IF (I.EQ.1.OR.CLEV(ICLV).NE.CLVP) THEN
C
            CLVP=CLEV(ICLV)
C
            IF (CLEV(ICLV).GT.ZMIN.AND.CLEV(ICLV).LT.ZMAX) THEN
C
              JAIA=IAIA(ICLV)
              JAIB=IAIB(ICLV)
C
              DO 10014 J=I+1,NCLV
                JCLV=ICLP(J)
                IF (CLEV(JCLV).NE.CLEV(ICLV)) GO TO 105
                IF (IAIA(JCLV).NE.0) THEN
                  IF (JAIA.NE.0.AND.JAIA.NE.IAIA(JCLV)) THEN
                    CALL SETER ('CPCLAM - CONTRADICTORY AREA-IDENTIFIER
     +INFORMATION',26,1)
                    RETURN
                  END IF
                  JAIA=IAIA(JCLV)
                END IF
                IF (IAIB(JCLV).NE.0) THEN
                  IF (JAIB.NE.0.AND.JAIB.NE.IAIB(JCLV)) THEN
                    CALL SETER ('CPCLAM - CONTRADICTORY AREA-IDENTIFIER
     +INFORMATION',27,1)
                    RETURN
                  END IF
                  JAIB=IAIB(JCLV)
                END IF
10014         CONTINUE
C
  105         IF (JAIA.NE.0.OR.JAIB.NE.0) THEN
C
                IJMP=0
C
10015           CONTINUE
                  CALL CPTRCL (ZDAT,RWRK,IWRK,CLEV(ICLV),IJMP,
     +                                         IRW1,IRW2,NRWK)
                  IF (ICFELL('CPCLAM',28).NE.0) RETURN
                  IF (IJMP.EQ.0) GO TO 10016
                  IF (MIRO.EQ.0) THEN
                    CALL AREDAM (IAMA,RWRK(IRW1+1),RWRK(IRW2+1),NRWK,
     +                                                 IGCL,JAIB,JAIA)
                    IF (ICFELL('CPCLAM',29).NE.0) RETURN
                  ELSE
                    CALL AREDAM (IAMA,RWRK(IRW1+1),RWRK(IRW2+1),NRWK,
     +                                                 IGCL,JAIA,JAIB)
                    IF (ICFELL('CPCLAM',30).NE.0) RETURN
                  END IF
                GO TO 10015
10016           CONTINUE
C
              END IF
C
            END IF
C
          END IF
C
        GO TO 10011
10012   CONTINUE
C
      END IF
C
C Done.
C
      RETURN
C
      END

      SUBROUTINE ZTGSY2( TRANS, IJOB, M, N, A, LDA, B, LDB, C, LDC, D,
     $                   LDD, E, LDE, F, LDF, SCALE, RDSUM, RDSCAL,
     $                   INFO )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          TRANS
      INTEGER            IJOB, INFO, LDA, LDB, LDC, LDD, LDE, LDF, M, N
      DOUBLE PRECISION   RDSCAL, RDSUM, SCALE
*     ..
*     .. Array Arguments ..
      COMPLEX*16         A( LDA, * ), B( LDB, * ), C( LDC, * ),
     $                   D( LDD, * ), E( LDE, * ), F( LDF, * )
*     ..
*
*  Purpose
*  =======
*
*  ZTGSY2 solves the generalized Sylvester equation
*
*              A * R - L * B = scale *   C               (1)
*              D * R - L * E = scale * F
*
*  using Level 1 and 2 BLAS, where R and L are unknown M-by-N matrices,
*  (A, D), (B, E) and (C, F) are given matrix pairs of size M-by-M,
*  N-by-N and M-by-N, respectively. A, B, D and E are upper triangular
*  (i.e., (A,D) and (B,E) in generalized Schur form).
*
*  The solution (R, L) overwrites (C, F). 0 <= SCALE <= 1 is an output
*  scaling factor chosen to avoid overflow.
*
*  In matrix notation solving equation (1) corresponds to solve
*  Zx = scale * b, where Z is defined as
*
*         Z = [ kron(In, A)  -kron(B', Im) ]             (2)
*             [ kron(In, D)  -kron(E', Im) ],
*
*  Ik is the identity matrix of size k and X' is the transpose of X.
*  kron(X, Y) is the Kronecker product between the matrices X and Y.
*
*  If TRANS = 'C', y in the conjugate transposed system Z'y = scale*b
*  is solved for, which is equivalent to solve for R and L in
*
*              A' * R  + D' * L   = scale *  C           (3)
*              R  * B' + L  * E'  = scale * -F
*
*  This case is used to compute an estimate of Dif[(A, D), (B, E)] =
*  = sigma_min(Z) using reverse communicaton with ZLACON.
*
*  ZTGSY2 also (IJOB >= 1) contributes to the computation in ZTGSYL
*  of an upper bound on the separation between to matrix pairs. Then
*  the input (A, D), (B, E) are sub-pencils of two matrix pairs in
*  ZTGSYL.
*
*  Arguments
*  =========
*
*  TRANS   (input) CHARACTER
*          = 'N', solve the generalized Sylvester equation (1).
*          = 'T': solve the 'transposed' system (3).
*
*  IJOB    (input) INTEGER
*          Specifies what kind of functionality to be performed.
*          =0: solve (1) only.
*          =1: A contribution from this subsystem to a Frobenius
*              norm-based estimate of the separation between two matrix
*              pairs is computed. (look ahead strategy is used).
*          =2: A contribution from this subsystem to a Frobenius
*              norm-based estimate of the separation between two matrix
*              pairs is computed. (DGECON on sub-systems is used.)
*          Not referenced if TRANS = 'T'.
*
*  M       (input) INTEGER
*          On entry, M specifies the order of A and D, and the row
*          dimension of C, F, R and L.
*
*  N       (input) INTEGER
*          On entry, N specifies the order of B and E, and the column
*          dimension of C, F, R and L.
*
*  A       (input) COMPLEX*16 array, dimension (LDA, M)
*          On entry, A contains an upper triangular matrix.
*
*  LDA     (input) INTEGER
*          The leading dimension of the matrix A. LDA >= max(1, M).
*
*  B       (input) COMPLEX*16 array, dimension (LDB, N)
*          On entry, B contains an upper triangular matrix.
*
*  LDB     (input) INTEGER
*          The leading dimension of the matrix B. LDB >= max(1, N).
*
*  C       (input/ output) COMPLEX*16 array, dimension (LDC, N)
*          On entry, C contains the right-hand-side of the first matrix
*          equation in (1).
*          On exit, if IJOB = 0, C has been overwritten by the solution
*          R.
*
*  LDC     (input) INTEGER
*          The leading dimension of the matrix C. LDC >= max(1, M).
*
*  D       (input) COMPLEX*16 array, dimension (LDD, M)
*          On entry, D contains an upper triangular matrix.
*
*  LDD     (input) INTEGER
*          The leading dimension of the matrix D. LDD >= max(1, M).
*
*  E       (input) COMPLEX*16 array, dimension (LDE, N)
*          On entry, E contains an upper triangular matrix.
*
*  LDE     (input) INTEGER
*          The leading dimension of the matrix E. LDE >= max(1, N).
*
*  F       (input/ output) COMPLEX*16 array, dimension (LDF, N)
*          On entry, F contains the right-hand-side of the second matrix
*          equation in (1).
*          On exit, if IJOB = 0, F has been overwritten by the solution
*          L.
*
*  LDF     (input) INTEGER
*          The leading dimension of the matrix F. LDF >= max(1, M).
*
*  SCALE   (output) DOUBLE PRECISION
*          On exit, 0 <= SCALE <= 1. If 0 < SCALE < 1, the solutions
*          R and L (C and F on entry) will hold the solutions to a
*          slightly perturbed system but the input matrices A, B, D and
*          E have not been changed. If SCALE = 0, R and L will hold the
*          solutions to the homogeneous system with C = F = 0.
*          Normally, SCALE = 1.
*
*  RDSUM   (input/output) DOUBLE PRECISION
*          On entry, the sum of squares of computed contributions to
*          the Dif-estimate under computation by ZTGSYL, where the
*          scaling factor RDSCAL (see below) has been factored out.
*          On exit, the corresponding sum of squares updated with the
*          contributions from the current sub-system.
*          If TRANS = 'T' RDSUM is not touched.
*          NOTE: RDSUM only makes sense when ZTGSY2 is called by
*          ZTGSYL.
*
*  RDSCAL  (input/output) DOUBLE PRECISION
*          On entry, scaling factor used to prevent overflow in RDSUM.
*          On exit, RDSCAL is updated w.r.t. the current contributions
*          in RDSUM.
*          If TRANS = 'T', RDSCAL is not touched.
*          NOTE: RDSCAL only makes sense when ZTGSY2 is called by
*          ZTGSYL.
*
*  INFO    (output) INTEGER
*          On exit, if INFO is set to
*            =0: Successful exit
*            <0: If INFO = -i, input argument number i is illegal.
*            >0: The matrix pairs (A, D) and (B, E) have common or very
*                close eigenvalues.
*
*  Further Details
*  ===============
*
*  Based on contributions by
*     Bo Kagstrom and Peter Poromaa, Department of Computing Science,
*     Umea University, S-901 87 Umea, Sweden.
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO, ONE
      INTEGER            LDZ
      PARAMETER          ( ZERO = 0.0D+0, ONE = 1.0D+0, LDZ = 2 )
*     ..
*     .. Local Scalars ..
      LOGICAL            NOTRAN
      INTEGER            I, IERR, J, K
      DOUBLE PRECISION   SCALOC
      COMPLEX*16         ALPHA
*     ..
*     .. Local Arrays ..
      INTEGER            IPIV( LDZ ), JPIV( LDZ )
      COMPLEX*16         RHS( LDZ ), Z( LDZ, LDZ )
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           XERBLA, ZAXPY, ZGESC2, ZGETC2, ZLATDF, ZSCAL
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          DCMPLX, DCONJG, MAX
*     ..
*     .. Executable Statements ..
*
*     Decode and test input parameters
*
      INFO = 0
      IERR = 0
      NOTRAN = LSAME( TRANS, 'N' )
      IF( .NOT.NOTRAN .AND. .NOT.LSAME( TRANS, 'C' ) ) THEN
         INFO = -1
      ELSE IF( ( IJOB.LT.0 ) .OR. ( IJOB.GT.2 ) ) THEN
         INFO = -2
      ELSE IF( M.LE.0 ) THEN
         INFO = -3
      ELSE IF( N.LE.0 ) THEN
         INFO = -4
      ELSE IF( LDA.LT.MAX( 1, M ) ) THEN
         INFO = -5
      ELSE IF( LDB.LT.MAX( 1, N ) ) THEN
         INFO = -8
      ELSE IF( LDC.LT.MAX( 1, M ) ) THEN
         INFO = -10
      ELSE IF( LDD.LT.MAX( 1, M ) ) THEN
         INFO = -12
      ELSE IF( LDE.LT.MAX( 1, N ) ) THEN
         INFO = -14
      ELSE IF( LDF.LT.MAX( 1, M ) ) THEN
         INFO = -16
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'ZTGSY2', -INFO )
         RETURN
      END IF
*
      IF( NOTRAN ) THEN
*
*        Solve (I, J) - system
*           A(I, I) * R(I, J) - L(I, J) * B(J, J) = C(I, J)
*           D(I, I) * R(I, J) - L(I, J) * E(J, J) = F(I, J)
*        for I = M, M - 1, ..., 1; J = 1, 2, ..., N
*
         SCALE = ONE
         SCALOC = ONE
         DO 30 J = 1, N
            DO 20 I = M, 1, -1
*
*              Build 2 by 2 system
*
               Z( 1, 1 ) = A( I, I )
               Z( 2, 1 ) = D( I, I )
               Z( 1, 2 ) = -B( J, J )
               Z( 2, 2 ) = -E( J, J )
*
*              Set up right hand side(s)
*
               RHS( 1 ) = C( I, J )
               RHS( 2 ) = F( I, J )
*
*              Solve Z * x = RHS
*
               CALL ZGETC2( LDZ, Z, LDZ, IPIV, JPIV, IERR )
               IF( IERR.GT.0 )
     $            INFO = IERR
               IF( IJOB.EQ.0 ) THEN
                  CALL ZGESC2( LDZ, Z, LDZ, RHS, IPIV, JPIV, SCALOC )
                  IF( SCALOC.NE.ONE ) THEN
                     DO 10 K = 1, N
                        CALL ZSCAL( M, DCMPLX( SCALOC, ZERO ),
     $                              C( 1, K ), 1 )
                        CALL ZSCAL( M, DCMPLX( SCALOC, ZERO ),
     $                              F( 1, K ), 1 )
   10                CONTINUE
                     SCALE = SCALE*SCALOC
                  END IF
               ELSE
                  CALL ZLATDF( IJOB, LDZ, Z, LDZ, RHS, RDSUM, RDSCAL,
     $                         IPIV, JPIV )
               END IF
*
*              Unpack solution vector(s)
*
               C( I, J ) = RHS( 1 )
               F( I, J ) = RHS( 2 )
*
*              Substitute R(I, J) and L(I, J) into remaining equation.
*
               IF( I.GT.1 ) THEN
                  ALPHA = -RHS( 1 )
                  CALL ZAXPY( I-1, ALPHA, A( 1, I ), 1, C( 1, J ), 1 )
                  CALL ZAXPY( I-1, ALPHA, D( 1, I ), 1, F( 1, J ), 1 )
               END IF
               IF( J.LT.N ) THEN
                  CALL ZAXPY( N-J, RHS( 2 ), B( J, J+1 ), LDB,
     $                        C( I, J+1 ), LDC )
                  CALL ZAXPY( N-J, RHS( 2 ), E( J, J+1 ), LDE,
     $                        F( I, J+1 ), LDF )
               END IF
*
   20       CONTINUE
   30    CONTINUE
      ELSE
*
*        Solve transposed (I, J) - system:
*           A(I, I)' * R(I, J) + D(I, I)' * L(J, J) = C(I, J)
*           R(I, I) * B(J, J) + L(I, J) * E(J, J)   = -F(I, J)
*        for I = 1, 2, ..., M, J = N, N - 1, ..., 1
*
         SCALE = ONE
         SCALOC = ONE
         DO 80 I = 1, M
            DO 70 J = N, 1, -1
*
*              Build 2 by 2 system Z'
*
               Z( 1, 1 ) = DCONJG( A( I, I ) )
               Z( 2, 1 ) = -DCONJG( B( J, J ) )
               Z( 1, 2 ) = DCONJG( D( I, I ) )
               Z( 2, 2 ) = -DCONJG( E( J, J ) )
*
*
*              Set up right hand side(s)
*
               RHS( 1 ) = C( I, J )
               RHS( 2 ) = F( I, J )
*
*              Solve Z' * x = RHS
*
               CALL ZGETC2( LDZ, Z, LDZ, IPIV, JPIV, IERR )
               IF( IERR.GT.0 )
     $            INFO = IERR
               CALL ZGESC2( LDZ, Z, LDZ, RHS, IPIV, JPIV, SCALOC )
               IF( SCALOC.NE.ONE ) THEN
                  DO 40 K = 1, N
                     CALL ZSCAL( M, DCMPLX( SCALOC, ZERO ), C( 1, K ),
     $                           1 )
                     CALL ZSCAL( M, DCMPLX( SCALOC, ZERO ), F( 1, K ),
     $                           1 )
   40             CONTINUE
                  SCALE = SCALE*SCALOC
               END IF
*
*              Unpack solution vector(s)
*
               C( I, J ) = RHS( 1 )
               F( I, J ) = RHS( 2 )
*
*              Substitute R(I, J) and L(I, J) into remaining equation.
*
               DO 50 K = 1, J - 1
                  F( I, K ) = F( I, K ) + RHS( 1 )*DCONJG( B( K, J ) ) +
     $                        RHS( 2 )*DCONJG( E( K, J ) )
   50          CONTINUE
               DO 60 K = I + 1, M
                  C( K, J ) = C( K, J ) - DCONJG( A( I, K ) )*RHS( 1 ) -
     $                        DCONJG( D( I, K ) )*RHS( 2 )
   60          CONTINUE
*
   70       CONTINUE
   80    CONTINUE
      END IF
      RETURN
*
*     End of ZTGSY2
*
      END

C NCLFORTSTART
      subroutine dcancorxy (nobs,mx,my,mxy,minxy,maxxy,lrdim,x,y      
     +                     ,ndf,canr,eval,wlam,chisq
     +                     ,coefxr,coefyl,rr,yx,rx,lrr,ier)
c
c NCL:   canr = cancor(x,y,opt)
c .             ndf, chisq, coefyl [1d], coefxr [1d] 
c .             coefyl and coefxr converted to 2D before return
c .             returned as attributes

      implicit none
c                                            INPUT
      integer              nobs,mx,my,mxy,minxy,maxxy,lrdim,lrr,ier
      double precision     x(nobs,mx) , y(nobs,my)
c                                            OUTPUT
      integer              ndf(mx)
      double precision     canr(mx)
      double precision     eval(mx), wlam(mx), chisq(mx)
      double precision     coefxr(lrdim), coefyl(lrdim)
c rr        - symmetric storage mode correlation matrix
c yx(nobs,m)- merged data matrix which contains the x and y variables
c rx        - 2D work array
      double precision     rr(lrr)
      double precision     yx(nobs,mxy)
      double precision     rx(mxy,mxy)
C NCLEND
c
c nobs   - total number of observations
c mx     - number of x variables
c my     - number of y variables
c mxy    - total number of variables [ mxy = mx+my ]
c minxy  - min( mx,my )
c maxxy  - max( mx,my )
c lrdim  - N*maxxy  [Normally, N=2]
c          The coefxr and coefyl arrays kept going out
c          of bounds in dcanorx. Arbitrarily made these larger.
c x      - independent variables  (nobs,mx)
c y      - dependent variables    (nobs,my)
c ndf    - number of dof
c eval   - eigenvalues
c wlam   - lambda ... used for debug
c chisq  - chisq numbers
c coefxr - x [A, RIGHT] cononical vectors
c coefyl - y [B, LEFT ] cononical vectors
c ier    - error code

c local
c
      integer              m, n, lrwork, icov
      integer              ncend, ncstrt, nc,ncs 
      double precision     xmsg
      logical              debug

      ier  = 0
      xmsg = 1.d20
c      lrr  = ((mxy+1)*mxy)/2 
      lrwork  = mxy*mxy 
      debug   = .false.

c      do m=1,minxy
      do m=1,mx
         ndf(m)   = 0
         canr(m)  = 0.0d0
         eval(m)  = 0.0d0
         wlam(m)  = 0.0d0
         chisq(m) = 0.0d0
      end do

      do m=1,lrdim
         coefyl(m) = 0.0d0
         coefxr(m) = 0.0d0
      end do

      if (ier.ne.0) return
c
c combine y and x  
c

      do m=1,my
        do n=1,nobs
           yx(n,m) = y(n,m)
        end do
      end do

      do m=1,mx
        do n=1,nobs
           yx(n,my+m) = x(n,m)
        end do
      end do
c
c use correlation matrix [icov=1]
c
      icov = 1
      if (icov.eq.1) then
          call dcrmssm(yx,nobs,mxy,nobs,mxy,xmsg,rr,lrr,ier)
      else
          call dvcmssm(yx,nobs,mxy,nobs,mxy,xmsg,rr,lrr,ier)
      end if

      if (debug) then
c                  print is lower triangular cuz it is easier
c                  Visually reverse output order foe upper triangular
          ncend=0
          print *, "cancor_xy: rr:"
          do nc=1,mxy
             ncstrt = ncend+1
             ncend  = ncstrt+nc-1
             write( * ,'(2x,i5,10(1x,f12.3),/, (7x,(10(1x,f12.3))))')
     *                   nc,(rr(n),n=ncstrt,ncend)
          end do
      end if

      call dcanorx (nobs,my,mx,rr,eval,wlam,canr,chisq,ndf
     +             ,coefxr,coefyl,rx,lrdim,lrr,lrwork)

      return
      end
c ------------------------
C     ..................................................................CANO  20
C http://pdp-10.trailing-edge.com/decuslib10-02/01/43,50145/canor.ssp
C     ..................................................................CANO  20
C                                                                       CANO  30
C        SUBROUTINE CANOR                                               CANO  40
C                                                                       CANO  50
C        PURPOSE                                                        CANO  60
C           COMPUTE THE CANONICAL CORRELATIONS BETWEEN TWO SETS OF      CANO  70
C           VARIABLES.  CANOR IS NORMALLY PRECEDED BY A CALL TO SUBROU- CANO  80
C           TINE CORRE.                                                 CANO  90
C                                                                       CANO 100
C        USAGE                                                          CANO 110
C           CALL CANOR (N,MP,MQ,RR,ROOTS,WLAM,CANR,CHISQ,NDF,COEFR,     CANO 120
C                       COEFL,R)                                        CANO 130
C                                                                       CANO 140
C        DESCRIPTION OF PARAMETERS                                      CANO 150
C           N     - NUMBER OF OBSERVATIONS                              CANO 160
C           MP    - NUMBER OF LEFT HAND VARIABLES                       CANO 170
c                 ? left refers to independent variables [x]
C           MQ    - NUMBER OF RIGHT HAND VARIABLES                      CANO 180
c                 ? right refers to dependent variables  [y]
C           RR    - INPUT MATRIX (ONLY UPPER TRIANGULAR PORTION OF THE  CANO 190
C                   SYMMETRIC MATRIX OF M X M, WHERE M = MP + MQ)       CANO 200
C                   CONTAINING CORRELATION COEFFICIENTS.  (STORAGE MODE CANO 210
C                   OF 1)                                               CANO 220
C           ROOTS - OUTPUT VECTOR OF LENGTH MQ CONTAINING EIGENVALUES   CANO 230
C                   COMPUTED IN THE NROOT SUBROUTINE.                   CANO 240
C           WLAM  - OUTPUT VECTOR OF LENGTH MQ CONTAINING LAMBDA.       CANO 250
C           CANR  - OUTPUT VECTOR OF LENGTH MQ CONTAINING CANONICAL     CANO 260
C                   CORRELATIONS.                                       CANO 270
C           CHISQ - OUTPUT VECTOR OF LENGTH MQ CONTAINING THE           CANO 280
C                   VALUES OF CHI-SQUARES.                              CANO 290
C           NDF   - OUTPUT VECTOR OF LENGTH MQ CONTAINING THE DEGREES   CANO 300
C                   OF FREEDOM ASSOCIATED WITH CHI-SQUARES.             CANO 310
C           COEFR - OUTPUT MATRIX (MQ X MQ) CONTAINING MQ SETS OF       CANO 320
C                   RIGHT HAND COEFFICIENTS COLUMNWISE.                 CANO 330
C           COEFL - OUTPUT MATRIX (MP X MQ) CONTAINING MQ SETS OF       CANO 340
C                   LEFT HAND COEFFICIENTS COLUMNWISE.                  CANO 350
C           R     - WORK MATRIX (M X M)                                 CANO 360
c
c       remark-djs
c       Using the recommended sizes resulted in bounds errors.
c       lrdim is an (arbitrarily) large number [say, 2*mp*mq] 
C                                                                       CANO 370
C        REMARKS                                                        CANO 380
C           THE NUMBER OF LEFT HAND VARIABLES (MP) SHOULD BE GREATER    CANO 390
C           THAN OR EQUAL TO THE NUMBER OF RIGHT HAND VARIABLES (MQ).   CANO 400
c              The above is why I *think* MP=MX  and MQ=MY
C           THE VALUES OF CANONICAL CORRELATION, LAMBDA, CHI-SQUARE,    CANO 410
C           DEGREES OF FREEDOM, AND CANONICAL COEFFICIENTS ARE COMPUTED CANO 420
C           ONLY FOR THOSE EIGENVALUES IN ROOTS WHICH ARE GREATER THAN  CANO 430
C           ZERO.                                                       CANO 440
C                                                                       CANO 450
C        SUBROUTINES AND FUNCTION SUBPROGRAMS REQUIRED                  CANO 460
C           MINV                                                        CANO 470
C           NROOT  (WHICH, IN TURN, CALLS THE SUBROUTINE EIGEN.)        CANO 480
C                                                                       CANO 490
C        METHOD                                                         CANO 500
C           REFER TO W. W. COOLEY AND P. R. LOHNES, 'MULTIVARIATE PRO-  CANO 510
C           CEDURES FOR THE BEHAVIORAL SCIENCES', JOHN WILEY AND SONS,  CANO 520
C           1962, CHAPTER 3.                                            CANO 530
C                                                                       CANO 540
c     added LCRX,LCLY,LRR,LRWORK for bounds checking
C     ..................................................................CANO 550
C                                                                       CANO 560
      SUBROUTINE DCANORX (N,MP,MQ,RR,ROOTS,WLAM,CANR,CHISQ,NDF,COEFR    CANO 570
     1                   ,COEFL,R,LRDIM,LRR,LRWORK)
      IMPLICIT NONE
      INTEGER          N, MP, MQ, NDF(MQ), LRDIM, LRR, LRWORK
      DOUBLE PRECISION RR(LRR),COEFL(LRDIM),COEFR(LRDIM),R(LRWORK)  
      DOUBLE PRECISION ROOTS(MQ),WLAM(MQ),CANR(MQ),CHISQ(MQ)
C                                                                       CANO 610
C        ...............................................................CANO 620
C                                                                       CANO 630
C        IF A DOUBLE PRECISION VERSION OF THIS ROUTINE IS DESIRED, THE  CANO 640
C        C IN COLUMN 1 SHOULD BE REMOVED FROM THE DOUBLE PRECISION      CANO 650
C        STATEMENT WHICH FOLLOWS.                                       CANO 660
C                                                                       CANO 670
C     DOUBLE PRECISION RR,ROOTS,WLAM,CANR,CHISQ,COEFR,COEFL,R,DET,SUM   CANO 680
C                                                                       CANO 690
C        THE C MUST ALSO BE REMOVED FROM DOUBLE PRECISION STATEMENTS    CANO 700
C        APPEARING IN OTHER ROUTINES USED IN CONJUNCTION WITH THIS      CANO 710
C        ROUTINE.                                                       CANO 720
C                                                                       CANO 730
C        THE DOUBLE PRECISION VERSION OF THIS SUBROUTINE MUST ALSO      CANO 740
C        CONTAIN DOUBLE PRECISION FORTRAN FUNCTIONS.  SQRT IN STATEMENT CANO 750
C        165 MUST BE CHANGED TO DSQRT.  ALOG IN STATEMENT 175 MUST BE   CANO 760
C        CHANGED TO DLOG.                                               CANO 770
C                                                                       CANO 780
C        ...............................................................CANO 790
C                                                                       CANO 800
C     PARTITION INTERCORRELATIONS AMONG LEFT HAND VARIABLES, BETWEEN    CANO 810
C     LEFT AND RIGHT HAND VARIABLES, AND AMONG RIGHT HAND VARIABLES.    CANO 820
C                                                                       CANO 830
      INTEGER          M, N1, N2, N3, I, J, K, L, JJ 
      DOUBLE PRECISION FN, FMP, FMQ, SUMX, DET

      M=MP+MQ                                                           CANO 840
      N1=0                                                              CANO 850
      DO 105 I=1,M                                                      CANO 860
      DO 105 J=1,M                                                      CANO 870
      IF(I-J) 102, 103, 103                                             CANO 880
  102 L=I+(J*J-J)/2                                                     CANO 890
      GO TO 104                                                         CANO 900
  103 L=J+(I*I-I)/2                                                     CANO 910
  104 N1=N1+1                                                           CANO 920
  105 R(N1)=RR(L)                                                       CANO 930
c c c print *, "debug 105: N1=",N1," L=",L

      L=MP                                                              CANO 940
      DO 108 J=2,MP                                                     CANO 950
      N1=M*(J-1)                                                        CANO 960
      DO 108 I=1,MP                                                     CANO 970
      L=L+1                                                             CANO 980
      N1=N1+1                                                           CANO 990
  108 R(L)=R(N1)                                                        CANO1000
c c c print *, "debug 108: N1=",N1," L=",L

      N2=MP+1                                                           CANO1010
      L=0                                                               CANO1020
      DO 110 J=N2,M                                                     CANO1030
      N1=M*(J-1)                                                        CANO1040
      DO 110 I=1,MP                                                     CANO1050
      L=L+1                                                             CANO1060
      N1=N1+1                                                           CANO1070
c c c if (L.gt.lrdim .or. N1.gt.lrwork) then
c c c     print *,"debug: 110 bounds: L=",L,"  N1=",N1
c c c end if
  110 COEFL(L)=R(N1)                                                    CANO1080

c c c print *, "debug 110: COEFL: L=",L,"    <========"
      L=0                                                               CANO1090
      DO 120 J=N2,M                                                     CANO1100
      N1=M*(J-1)+MP                                                     CANO1110
      DO 120 I=N2,M                                                     CANO1120
      L=L+1                                                             CANO1130
      N1=N1+1                                                           CANO1140
c c c if (L.gt.lrdim .or. N1.gt.lrwork) then
c c c     print *,"debug: 120 bounds: L=",L,"  N1=",N1
c c c end if
  120 COEFR(L)=R(N1)                                                    CANO1150

c c c print *, "debug 120: COEFR: L=",L,"    <========"
C                                                                       CANO1160
C     SOLVE THE CANONICAL EQUATION                                      CANO1170
C                                                                       CANO1180
      L=MP*MP+1                                                         CANO1190
      K=L+MP                                                            CANO1200
c c c print *, "SOLVE THE CANONICAL EQUATION: L,K=",L,K,"    <========"
      CALL DMINVX (R,MP,DET,R(L),R(K))                                  CANO1210
C                                                                       CANO1220
C        CALCULATE T = INVERSE OF R11 * R12                             CANO1230
C                                                                       CANO1240
      DO 140 I=1,MP                                                     CANO1250
      N2=0                                                              CANO1260
      DO 130 J=1,MQ                                                     CANO1270
      N1=I-MP                                                           CANO1280
      ROOTS(J)=0.0D0                                                    CANO1290
      DO 130 K=1,MP                                                     CANO1300
      N1=N1+MP                                                          CANO1310
      N2=N2+1                                                           CANO1320
  130 ROOTS(J)=ROOTS(J)+R(N1)*COEFL(N2)                                 CANO1330
      L=I-MP                                                            CANO1340
      DO 140 J=1,MQ                                                     CANO1350
      L=L+MP                                                            CANO1360
  140 R(L)=ROOTS(J)                                                     CANO1370
C                                                                       CANO1380
C        CALCULATE A = R21 * T                                          CANO1390
C                                                                       CANO1400
      L=MP*MQ                                                           CANO1410
      N3=L+1                                                            CANO1420
      DO 160 J=1,MQ                                                     CANO1430
      N1=0                                                              CANO1440
      DO 160 I=1,MQ                                                     CANO1450
      N2=MP*(J-1)                                                       CANO1460
      SUMX=0.0D0                                                        CANO1470
      DO 150 K=1,MP                                                     CANO1480
      N1=N1+1                                                           CANO1490
      N2=N2+1                                                           CANO1500
  150 SUMX=SUMX+COEFL(N1)*R(N2)                                         CANO1510
      L=L+1                                                             CANO1520
  160 R(L)=SUMX                                                         CANO1530
C                                                                       CANO1540
C        CALCULATE EIGENVALUES WITH ASSOCIATED EIGENVECTORS OF THE      CANO1550
C        INVERSE OF R22 * A                                             CANO1560
C                                                                       CANO1570
      L=L+1                                                             CANO1580
      CALL DNROOTX (MQ,R(N3),COEFR,ROOTS,R(L))                          CANO1590
C                                                                       CANO1600
C     FOR EACH VALUE OF I = 1, 2, ..., MQ, CALCULATE THE FOLLOWING      CANO1610
C     STATISTICS                                                        CANO1620
C                                                                       CANO1630
      DO 210 I=1,MQ                                                     CANO1640
C                                                                       CANO1650
C        TEST WHETHER EIGENVALUE IS GREATER THAN ZERO                   CANO1660
C                                                                       CANO1670
      IF(ROOTS(I)) 220, 220, 165                                        CANO1680
C                                                                       CANO1690
C        CANONICAL CORRELATION                                          CANO1700
C                                                                       CANO1710
  165 CANR(I)= SQRT(ROOTS(I))                                           CANO1720
C                                                                       CANO1730
C        CHI-SQUARE                                                     CANO1740
C                                                                       CANO1750
      WLAM(I)=1.0D0                                                     CANO1760
      DO 170 J=I,MQ                                                     CANO1770
  170 WLAM(I)=WLAM(I)*(1.0D0-ROOTS(J))                                  CANO1780
      FN=N                                                              CANO1790
      FMP=MP                                                            CANO1800
      FMQ=MQ                                                            CANO1810
  175 CHISQ(I)=-(FN-0.5D0*(FMP+FMQ+1.0D0))*LOG(WLAM(I))                 CANO1820
C                                                                       CANO1830
C        DEGREES OF FREEDOM FOR CHI-SQUARE                              CANO1840
C                                                                       CANO1850
      N1=I-1                                                            CANO1860
      NDF(I)=(MP-N1)*(MQ-N1)                                            CANO1870
C                                                                       CANO1880
C        I-TH SET OF RIGHT HAND COEFFICIENTS                            CANO1890
C                                                                       CANO1900
      N1=MQ*(I-1)                                                       CANO1910
      N2=MQ*(I-1)+L-1                                                   CANO1920
      DO 180 J=1,MQ                                                     CANO1930
      N1=N1+1                                                           CANO1940
      N2=N2+1                                                           CANO1950
  180 COEFR(N1)=R(N2)                                                   CANO1960
C                                                                       CANO1970
C        I-TH SET OF LEFT HAND COEFFICIENTS                             CANO1980
C                                                                       CANO1990
      DO 200 J=1,MP                                                     CANO2000
      N1=J-MP                                                           CANO2010
      N2=MQ*(I-1)                                                       CANO2020
      K=MP*(I-1)+J                                                      CANO2030
      COEFL(K)=0.0D0                                                    CANO2040
      DO 190 JJ=1,MQ                                                    CANO2050
      N1=N1+MP                                                          CANO2060
      N2=N2+1                                                           CANO2070
  190 COEFL(K)=COEFL(K)+R(N1)*COEFR(N2)                                 CANO2080
  200 COEFL(K)=COEFL(K)/CANR(I)                                         CANO2090
  210 CONTINUE                                                          CANO2100
  220 RETURN                                                            CANO2110
      END                                                               CANO2120
C**************************************************************************
C
C     SUBROUTINE MINV
C
C     PURPOSE
C        INVERT A MATRIX
C
C     USAGE
C        CALL MINV(A,N,D,L,M)
C
C     DESCRIPTION OF PARAMETERS
C        A - INPUT MATRIX, DESTROYED IN COMPUTATION AND REPLACED BY
C             RESULTANT INVERSE.
C        N - ORDER OF MATRIX A
C        D - RESULTANT DETERMINANT
C        L - WORK VECTOR OF LENGTH N
C        M - WORK VECTOR OF LENGTH N
C
C     REMARKS
C        MATRIX AX MUST BE A GENERAL MATRIX
C
C     SUBROUTINES AND FUNCTION SUBPROGRAMS REQUIRED
C        NONE
C
C     METHOD
C        THE STANDARD GAUSS-JORDAN METHOD IS USED. THE DETERMINANT
C        IS ALSO CALCULATED. A DETERMINANT OF ZERO INDICATES THAT
C        THE MATRIX IS SINGULAR.
C
C **********************************************************************
C
      SUBROUTINE DMINVX(A,N,D,L,M)
      IMPLICIT  NONE
      INTEGER   N
      DOUBLE PRECISION   A(*), L(*), M(*) 
      DOUBLE PRECISION   BIGA, D, HOLD

      INTEGER   NK, I, J, K, IJ, IZ, KK, KI, JP, JK, JI, JQ, JR, IK, KJ
C
C **********************************************************************
C
C
C        SEARCH FOR LARGEST ELEMENT
C
      D=1.D0
      NK=-N
      DO 80 K=1,N
      NK=NK+N
      L(K)=K
      M(K)=K
      KK=NK+K
      BIGA=A(KK)
      DO 20 J=K,N
      IZ=N*(J-1)
      DO 20 I=K,N
      IJ=IZ+I
10    IF (ABS(BIGA)-ABS(A(IJ))) 15,20,20
15    BIGA=A(IJ)
      L(K)=I
      M(K)=J
20    CONTINUE
C
C        INTERCHANGE ROWS
C
      J=L(K)
      IF(J-K) 35,35,25
25    KI=K-N
      DO 30 I=1,N
      KI=KI+N
      HOLD=-A(KI)
      JI=KI-K+J
      A(KI)=A(JI)
30    A(JI)=HOLD
C
C        INTERCHANGE COLUMNS
C
35    I=M(K)
      IF(I-K) 45,45,38
38    JP=N*(I-1)
      DO 40 J=1,N
      JK=NK+J
      JI=JP+J
      HOLD=-A(JK)
      A(JK)=A(JI)
40    A(JI)=HOLD
C
C        DIVIDE COLUMN BY MINUS PIVOT (VALUE OF PIVOT ELEMENT IS
C        CONTAINED IN BIGA)
C
45    IF(BIGA) 48,46,48
46    D=0.D0
      RETURN
48    DO 55 I=1,N
      IF (I-K) 50,55,50
50    IK=NK+I
      A(IK)=A(IK)/(-BIGA)
55    CONTINUE
C
C        REDUCE MATRIX
C
      DO 65 I=1,N
      IK=NK+I
      HOLD=A(IK)
      IJ=I-N
      DO 65 J=1,N
      IJ=IJ+N
      IF(I-K) 60,65,60
60    IF(J-K) 62,65,62
62    KJ=IJ-I+K
      A(IJ)=HOLD*A(KJ)+A(IJ)
65    CONTINUE
C
C        DIVIDE ROW BY PIVOT
C
      KJ=K-N
      DO 75 J=1,N
      KJ=KJ+N
      IF(J-K) 70,75,70
70    A(KJ)=A(KJ)/BIGA
75    CONTINUE
C
C        PRODUCT OF PIVOTS
C
      D=D*BIGA
C
C        REPLACE PIVOT BY RECIPROCAL
C
      A(KK)=1.D0/BIGA
80    CONTINUE
C
C        FINAL ROW AND COLUMN INTERCHANGE
C
      K=N
100   K=(K-1)
      IF(K) 150,150,105
105   I=L(K)
      IF(I-K) 120,120,108
108   JQ=N*(K-1)
      JR=N*(I-1)
      DO 110 J=1,N
      JK=JQ+J
      HOLD=A(JK)
      JI=JR+J
      A(JK)=-A(JI)
110   A(JI)=HOLD
120   J=M(K)
      IF(J-K) 100,100,125
125   KI=K-N
      DO 130 I=1,N
      KI=KI+N
      HOLD=A(KI)
      JI=KI-K+J
      A(KI)=-A(JI)
130   A(JI)=HOLD
      GO TO 100
150   RETURN
      END
C     ..................................................................NROO  20
C                                                                       NROO  30
C        SUBROUTINE NROOT                                               NROO  40
C                   DNROOTX   [djs]
C                                                                       NROO  50
C        PURPOSE                                                        NROO  60
C           COMPUTE EIGENVALUES AND EIGENVECTORS OF A REAL NONSYMMETRIC NROO  70
C           MATRIX OF THE FORM B-INVERSE TIMES A.  THIS SUBROUTINE IS   NROO  80
C           NORMALLY CALLED BY SUBROUTINE CANOR IN PERFORMING A         NROO  90
C           CANONICAL CORRELATION ANALYSIS.                             NROO 100
C                                                                       NROO 110
C        USAGE                                                          NROO 120
C           CALL NROOT (M,A,B,XL,X)                                     NROO 130
C           CALL DNROOTX (M,A,B,XL,X) 
C                                                                       NROO 140
C        DESCRIPTION OF PARAMETERS                                      NROO 150
C           M  - ORDER OF SQUARE MATRICES A, B, AND X.                  NROO 160
C           A  - INPUT MATRIX (M X M).                                  NROO 170
C           B  - INPUT MATRIX (M X M).                                  NROO 180
C           XL - OUTPUT VECTOR OF LENGTH M CONTAINING EIGENVALUES OF    NROO 190
C                B-INVERSE TIMES A.                                     NROO 200
C           X  - OUTPUT MATRIX (M X M) CONTAINING EIGENVECTORS COLUMN-  NROO 210
C                WISE.                                                  NROO 220
C                                                                       NROO 230
C        REMARKS                                                        NROO 240
C           NONE                                                        NROO 250
C                                                                       NROO 260
C        SUBROUTINES AND FUNCTION SUBPROGRAMS REQUIRED                  NROO 270
C           EIGEN                                                       NROO 280
C                                                                       NROO 290
C        METHOD                                                         NROO 300
C           REFER TO W. W. COOLEY AND P. R. LOHNES, 'MULTIVARIATE PRO-  NROO 310
C           CEDURES FOR THE BEHAVIORAL SCIENCES', JOHN WILEY AND SONS,  NROO 320
C           1962, CHAPTER 3.                                            NROO 330
C                                                                       NROO 340
C     ..................................................................NROO 350
C                                                                       NROO 360
      SUBROUTINE DNROOTX (M,A,B,XL,X)                                   NROO 370
      IMPLICIT  NONE
      INTEGER   M
      DOUBLE PRECISION XL(M)                                            NROO 380
      DOUBLE PRECISION A(*),B(*),X(*)                                   NROO 380
C                                                                       NROO 390
C        ...............................................................NROO 400
C                                                                       NROO 410
C        IF A DOUBLE PRECISION VERSION OF THIS ROUTINE IS DESIRED, THE  NROO 420
C        C IN COLUMN 1 SHOULD BE REMOVED FROM THE DOUBLE PRECISION      NROO 430
C        STATEMENT WHICH FOLLOWS.                                       NROO 440
C                                                                       NROO 450
C     DOUBLE PRECISION A,B,XL,X,SUMV                                    NROO 460
C                                                                       NROO 470
C        THE C MUST ALSO BE REMOVED FROM DOUBLE PRECISION STATEMENTS    NROO 480
C        APPEARING IN OTHER ROUTINES USED IN CONJUNCTION WITH THIS      NROO 490
C        ROUTINE.                                                       NROO 500
C                                                                       NROO 510
C        THE DOUBLE PRECISION VERSION OF THIS SUBROUTINE MUST ALSO      NROO 520
C        CONTAIN DOUBLE PRECISION FORTRAN FUNCTIONS.  SQRT IN STATEMENTSNROO 530
C        110 AND 175 MUST BE CHANGED TO DSQRT.  ABS IN STATEMENT 110    NROO 540
C        MUST BE CHANGED TO DABS.                                       NROO 550
C                                                                       NROO 560
C        ...............................................................NROO 570
      INTEGER I, J, K, L, MV, N1, N2
      DOUBLE PRECISION SUMV
C                                                                       NROO 580
C     COMPUTE EIGENVALUES AND EIGENVECTORS OF B                         NROO 590
C                                                                       NROO 600
      K=1                                                               NROO 610
      DO 100 J=2,M                                                      NROO 620
      L=M*(J-1)                                                         NROO 630
      DO 100 I=1,J                                                      NROO 640
      L=L+1                                                             NROO 650
      K=K+1                                                             NROO 660
  100 B(K)=B(L)                                                         NROO 670
C                                                                       NROO 680
C        THE MATRIX B IS A REAL SYMMETRIC MATRIX.                       NROO 690
C                                                                       NROO 700
      MV=0                                                              NROO 710
      CALL DEIGENX (B,X,M,MV)                                           NROO 720
C                                                                       NROO 730
C     FORM RECIPROCALS OF SQUARE ROOT OF EIGENVALUES.  THE RESULTS      NROO 740
C     ARE PREMULTIPLIED BY THE ASSOCIATED EIGENVECTORS.                 NROO 750
C                                                                       NROO 760
      L=0                                                               NROO 770
      DO 110 J=1,M                                                      NROO 780
      L=L+J                                                             NROO 790
  110 XL(J)=1.0D0/SQRT( ABS(B(L)))                                      NROO 800
      K=0                                                               NROO 810
      DO 115 J=1,M                                                      NROO 820
      DO 115 I=1,M                                                      NROO 830
      K=K+1                                                             NROO 840
  115 B(K)=X(K)*XL(J)                                                   NROO 850
C                                                                       NROO 860
C     FORM (B**(-1/2))PRIME * A * (B**(-1/2))                           NROO 870
C                                                                       NROO 880
      DO 120 I=1,M                                                      NROO 890
      N2=0                                                              NROO 900
      DO 120 J=1,M                                                      NROO 910
      N1=M*(I-1)                                                        NROO 920
      L=M*(J-1)+I                                                       NROO 930
      X(L)=0.0D0                                                        NROO 940
      DO 120 K=1,M                                                      NROO 950
      N1=N1+1                                                           NROO 960
      N2=N2+1                                                           NROO 970
  120 X(L)=X(L)+B(N1)*A(N2)                                             NROO 980
      L=0                                                               NROO 990
      DO 130 J=1,M                                                      NROO1000
      DO 130 I=1,J                                                      NROO1010
      N1=I-M                                                            NROO1020
      N2=M*(J-1)                                                        NROO1030
      L=L+1                                                             NROO1040
      A(L)=0.0D0                                                        NROO1050
      DO 130 K=1,M                                                      NROO1060
      N1=N1+M                                                           NROO1070
      N2=N2+1                                                           NROO1080
  130 A(L)=A(L)+X(N1)*B(N2)                                             NROO1090
C                                                                       NROO1100
C     COMPUTE EIGENVALUES AND EIGENVECTORS OF A                         NROO1110
C                                                                       NROO1120
      CALL DEIGENX (A,X,M,MV)                                           NROO1130
      L=0                                                               NROO1140
      DO 140 I=1,M                                                      NROO1150
      L=L+I                                                             NROO1160
  140 XL(I)=A(L)                                                        NROO1170
C                                                                       NROO1180
C     COMPUTE THE NORMALIZED EIGENVECTORS                               NROO1190
C                                                                       NROO1200
      DO 150 I=1,M                                                      NROO1210
      N2=0                                                              NROO1220
      DO 150 J=1,M                                                      NROO1230
      N1=I-M                                                            NROO1240
      L=M*(J-1)+I                                                       NROO1250
      A(L)=0.0D0                                                        NROO1260
      DO 150 K=1,M                                                      NROO1270
      N1=N1+M                                                           NROO1280
      N2=N2+1                                                           NROO1290
  150 A(L)=A(L)+B(N1)*X(N2)                                             NROO1300
      L=0                                                               NROO1310
      K=0                                                               NROO1320
      DO 180 J=1,M                                                      NROO1330
      SUMV=0.0D0                                                        NROO1340
      DO 170 I=1,M                                                      NROO1350
      L=L+1                                                             NROO1360
  170 SUMV=SUMV+A(L)*A(L)                                               NROO1370
  175 SUMV= SQRT(SUMV)                                                  NROO1380
      DO 180 I=1,M                                                      NROO1390
      K=K+1                                                             NROO1400
  180 X(K)=A(K)/SUMV                                                    NROO1410
      RETURN                                                            NROO1420
      END                                                               NROO1430
C SUBROUTINE 'EIGEN' FROM THE IBM SCIENTIFIC SUBROUTINE PACKAGE.
C
C NOTE:  TO CONFORM WITH THE FORTRAN77 STANDARD, DUMMY ARRAY DIMENSIONS
C        (1) HAVE BEEN CHANGED TO (*).
C
C     ..................................................................
C
C        SUBROUTINE  EIGEN 
C                   DEIGENX   [djs]
C
C        PURPOSE
C           COMPUTE EIGENVALUES AND EIGENVECTORS OF A REAL SYMMETRIC
C           MATRIX
C
C        USAGE
C           CALL EIGEN(A,R,N,MV)
C
C        DESCRIPTION OF PARAMETERS
C           A - ORIGINAL MATRIX (SYMMETRIC), DESTROYED IN COMPUTATION.
C               RESULTANT EIGENVALUES ARE DEVELOPED IN DIAGONAL OF
C               MATRIX A IN DESCENDING ORDER.
C           R - RESULTANT MATRIX OF EIGENVECTORS (STORED COLUMNWISE,
C               IN SAME SEQUENCE AS EIGENVALUES)
C           N - ORDER OF MATRICES A AND R
C           MV- INPUT CODE
C                   0   COMPUTE EIGENVALUES AND EIGENVECTORS
C                   1   COMPUTE EIGENVALUES ONLY (R NEED NOT BE
C                       DIMENSIONED BUT MUST STILL APPEAR IN CALLING
C                       SEQUENCE)
C
C        REMARKS
C           ORIGINAL MATRIX A MUST BE REAL SYMMETRIC (STORAGE MODE=1)
C           MATRIX A CANNOT BE IN THE SAME LOCATION AS MATRIX R
C
C        SUBROUTINES AND FUNCTION SUBPROGRAMS REQUIRED
C           NONE
C
C        METHOD
C           DIAGONALIZATION METHOD ORIGINATED BY JACOBI AND ADAPTED
C           BY VON NEUMANN FOR LARGE COMPUTERS AS FOUND IN 'MATHEMATICAL
C           METHODS FOR DIGITAL COMPUTERS', EDITED BY A. RALSTON AND
C           H.S. WILF, JOHN WILEY AND SONS, NEW YORK, 1962, CHAPTER 7
C
C     ..................................................................
C
      SUBROUTINE DEIGENX(A,R,N,MV)
      IMPLICIT NONE
      INTEGER  N, MV
      DOUBLE PRECISION A(*),R(*)
C
C        ...............................................................
C
C        IF A DOUBLE PRECISION VERSION OF THIS ROUTINE IS DESIRED, THE
C        C IN COLUMN 1 SHOULD BE REMOVED FROM THE DOUBLE PRECISION
C        STATEMENT WHICH FOLLOWS.
C
C     DOUBLE PRECISION A,R,ANORM,ANRMX,THR,X,Y,SINX,SINX2,COSX,
C    1                 COSX2,SINCS,RANGE
C
C        THE C MUST ALSO BE REMOVED FROM DOUBLE PRECISION STATEMENTS
C        APPEARING IN OTHER ROUTINES USED IN CONJUNCTION WITH THIS
C        ROUTINE.
C
C        THE DOUBLE PRECISION VERSION OF THIS SUBROUTINE MUST ALSO
C        CONTAIN DOUBLE PRECISION FORTRAN FUNCTIONS.  SQRT IN STATEMENTS
C        40, 68, 75, AND 78 MUST BE CHANGED TO DSQRT.  ABS IN STATEMENT
C        62 MUST BE CHANGED TO DABS. THE CONSTANT IN STATEMENT 5 SHOULD
C        BE CHANGED TO 1.0D-12.
C
C        ...............................................................
      INTEGER I, J, IQ, IJ, IND, MQ, LQ, ILO, IMQ, ILR, IMR,
     +        IA, L, M, LM, LL, MM, ILQ, IM, IL, JQ, K 
      DOUBLE PRECISION RANG, ANORM, ANRMX, THR, X, Y,
     +                 SINX, SINX2, COSX, COSX2, SINCS
C
C        GENERATE IDENTITY MATRIX
C
    5 RANG=1.0D-12
      IF(MV-1) 10,25,10
   10 IQ=-N
      DO 20 J=1,N
      IQ=IQ+N
      DO 20 I=1,N
      IJ=IQ+I
      R(IJ)=0.0
      IF(I-J) 20,15,20
   15 R(IJ)=1.0D0
   20 CONTINUE
C
C        COMPUTE INITIAL AND FINAL NORMS (ANORM AND ANORMX)
C
   25 ANORM=0.0D0
      DO 35 I=1,N
      DO 35 J=I,N
      IF(I-J) 30,35,30
   30 IA=I+(J*J-J)/2
      ANORM=ANORM+A(IA)*A(IA)
   35 CONTINUE
      IF(ANORM) 165,165,40
   40 ANORM=1.414D0*SQRT(ANORM)
      ANRMX=ANORM*RANG/N
C
C        INITIALIZE INDICATORS AND COMPUTE THRESHOLD, THR
C
      IND=0
      THR=ANORM
   45 THR=THR/N
   50 L=1
   55 M=L+1
C
C        COMPUTE SIN AND COS
C
   60 MQ=(M*M-M)/2
      LQ=(L*L-L)/2
      LM=L+MQ
   62 IF( ABS(A(LM))-THR) 130,65,65
   65 IND=1
      LL=L+LQ
      MM=M+MQ
      X=0.5D0*(A(LL)-A(MM))
   68 Y=-A(LM)/ SQRT(A(LM)*A(LM)+X*X)
      IF(X) 70,75,75
   70 Y=-Y
   75 SINX=Y/ SQRT(2.0D0*(1.0D0+( SQRT(1.0D0-Y*Y))))
      SINX2=SINX*SINX
   78 COSX= SQRT(1.0D0-SINX2)
      COSX2=COSX*COSX
      SINCS =SINX*COSX
C
C        ROTATE L AND M COLUMNS
C
      ILQ=N*(L-1)
      IMQ=N*(M-1)
      DO 125 I=1,N
      IQ=(I*I-I)/2
      IF(I-L) 80,115,80
   80 IF(I-M) 85,115,90
   85 IM=I+MQ
      GO TO 95
   90 IM=M+IQ
   95 IF(I-L) 100,105,105
  100 IL=I+LQ
      GO TO 110
  105 IL=L+IQ
  110 X=A(IL)*COSX-A(IM)*SINX
      A(IM)=A(IL)*SINX+A(IM)*COSX
      A(IL)=X
  115 IF(MV-1) 120,125,120
  120 ILR=ILQ+I
      IMR=IMQ+I
      X=R(ILR)*COSX-R(IMR)*SINX
      R(IMR)=R(ILR)*SINX+R(IMR)*COSX
      R(ILR)=X
  125 CONTINUE
      X=2.0D0*A(LM)*SINCS
      Y=A(LL)*COSX2+A(MM)*SINX2-X
      X=A(LL)*SINX2+A(MM)*COSX2+X
      A(LM)=(A(LL)-A(MM))*SINCS+A(LM)*(COSX2-SINX2)
      A(LL)=Y
      A(MM)=X
C
C        TESTS FOR COMPLETION
C
C        TEST FOR M = LAST COLUMN
C
  130 IF(M-N) 135,140,135
  135 M=M+1
      GO TO 60
C
C        TEST FOR L = SECOND FROM LAST COLUMN
C
  140 IF(L-(N-1)) 145,150,145
  145 L=L+1
      GO TO 55
  150 IF(IND-1) 160,155,160
  155 IND=0
      GO TO 50
C
C        COMPARE THRESHOLD WITH FINAL NORM
C
  160 IF(THR-ANRMX) 165,165,45
C
C        SORT EIGENVALUES AND EIGENVECTORS
C
  165 IQ=-N
      DO 185 I=1,N
      IQ=IQ+N
      LL=I+(I*I-I)/2
      JQ=N*(I-2)
      DO 185 J=I,N
      JQ=JQ+N
      MM=J+(J*J-J)/2
      IF(A(LL)-A(MM)) 170,185,185
  170 X=A(LL)
      A(LL)=A(MM)
      A(MM)=X
      IF(MV-1) 175,185,175
  175 DO 180 K=1,N
      ILR=IQ+K
      IMR=JQ+K
      X=R(ILR)
      R(ILR)=R(IMR)
  180 R(IMR)=X
  185 CONTINUE
      RETURN
      END

C
C	$Id: gtsign.f,v 1.4 2008-07-27 00:17:21 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
C
C============================================================
C                       GTSIGN
C============================================================
      SUBROUTINE GTSIGN(STRING,POS,SIGN)
C
C Checks for a '+' or '-' character at specified position in string
C
C ON Entry:
C    STRING is a character string
C    POS    points to the position to look for the sign character
C
C ON Exit :
C
C    SIGN   =  1 if a '+' or a digit was found at POS
C           = -1 if a '-' was found at POS
C           =  0 if no sign and no digit were found at POS
C    POS    =  POS + 1 if a '+' or '-' was found
C              UNCHANGED if no sign was found
C ======================================================================
C
C INPUT argument
C
      CHARACTER*(*) STRING
C
C INPUT/OUTPUT argument
C
      INTEGER       POS
C
C OUTPUT argument
C
      INTEGER       SIGN
C
C INTERNAL variable
C
      CHARACTER*1 CHR
C
C ======================================================================
C
C Begin
C
      CHR = STRING(POS:POS)
      IF (CHR .EQ. '-') THEN
           SIGN = -1
           POS  = POS + 1
      ELSE IF (CHR .EQ. '+') THEN
           SIGN = 1
           POS  = POS + 1
      ELSE IF ((CHR .LT. '0') .OR. (CHR .GT. '9')) THEN
           SIGN = 0
      ENDIF
C
      RETURN
      END

      subroutine meemd(LXY,indata,An,Ns,Nesb,Nm,Nt,idum,rslt)
!-----------------------------------------------------------------------------
! This is a subroutine to decompose data(LXY) in terms of its EEMD component.
! When the added noise amplitude is zero (An=0) and the ensemble number
! is one (Nesb=0), the code degenerates to standard EMD
!
! In this code, the number of the oscillatory components is specified as an
! input, Nm. For most cases, automatic calculation, Nm can be set to log2(LXY)-2
!
! INPUT DATA:
!		indata(LXY)		input array with a length of LXY
!  		An 			amplitude of added noise
!               Ns                      fixed number of siftings
!  		Nesb 			number of ensemble members
!  		Nm 			number of mode in each decomposition
!               Nt                      Nm + 2 to deal with WRAPIT
!  		idum 			seed for the random number
! OUTPUT DATA:
!  		rslt(LXY, Nt) 	output rseults, which contains Nm+2 columns
!					The first column is the original indata;
!					The second column is the first component;
!					The third column is the second component;
!					and so on
!					The last column is the residue
!-------------------------------------------------------------------------------
      implicit none

      real :: An                                ! noise amplitude
      integer, intent(in) :: LXY, Nesb, Nm, Nt, Ns
      integer, intent(inout):: idum
      real, dimension(LXY), intent(in) :: indata
      real, dimension(LXY) :: ximf              ! data for sifting
      real, dimension(LXY) :: spmax             ! upper envelope, cubic spline
      real, dimension(LXY) :: spmin             ! lower envelope, cubic spline
      real, dimension(LXY) :: ave               ! the average of spmax and spmin
      real, dimension(LXY) :: remp              ! the input data for sifting
      real, dimension(LXY) :: rem               ! the remainder (remp-ximf)

      real, dimension(LXY,Nt) :: rslt           ! the final output data
      real, dimension(LXY,Nt) :: allmode        ! the results of a single EMD decomposition

      integer :: nmax, nmin                     ! numbers of maximum and minimum
      real, dimension(LXY) :: trend             ! linear trend of indata
      real :: std               ! standard deviation of the linearly detrended indata
      integer:: i,j,IE,im,ii
      real :: fNesb, gasdev


!  initialize the output
      rslt=0.0

!
!  ensemble EMD
!
!  *******************************************************
      do IE=1,Nesb
!  *******************************************************
!
        call standev(LXY,indata,trend, std)

!  inputted data + noise
        if(Nesb.eq.1) then
          ximf=indata
        else
          do i=1,LXY
            ximf(i)=indata(i)+An*std*gasdev(idum)
          enddo
        endif

!  save modified data
        do i=1,LXY
          allmode(i,1)=ximf(i)
        enddo

!  calculate modes
!       =======================================================
        do im=1,Nm
!       =======================================================
!
!  leave a copy of the input data before IMF is calculated
          remp=ximf
!
!  Sifting
!         ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
          do ii=1,Ns
!         ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

            call min_max(LXY,ximf,spmax,spmin,nmax,nmin)
            call natural_spline(spmax,LXY,nmax)
            call natural_spline(spmin,LXY,nmin)

            ave=(spmax+spmin)/2.0
            ximf=ximf-ave

!         ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
          enddo                     ! siftings loop
!         ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~     

          rem=remp-ximf

          do i=1,LXY
            allmode(i,im+1)=ximf(i)
          enddo

          ximf=rem

!       =======================================================
        enddo                        ! Modes loop
!       =======================================================

        do i=1,LXY
          allmode(i,Nt)=ximf(i)      ! store final residual as trend
        enddo

        do j=1,Nt
          do i=1,LXY
            rslt(i,j)=rslt(i,j)+allmode(i,j)   ! store and cumulate all IMFs
          enddo
        enddo

!     ---------------------------------------------------------
      enddo                         ! ensemble members loop
!     ---------------------------------------------------------

      fNesb=real(Nesb)
      rslt=rslt/fNesb               ! Take the ensemble mean

      end subroutine meemd

      function ran2(idum)
!---------------------------------------------------------------------
!  See NUMERICAL RECIPES for detail of the function under the same
!  name
!  PARAMETERS:
!       idum       : random seed
!---------------------------------------------------------------------
      implicit none

      real :: ran2
      integer, intent(inout) :: idum
      integer, parameter :: im1=2147483563, im2=2147483399, imm1=im1-1
      integer, parameter :: ia1=40014, ia2=40692, iq1=53668, iq2=52774
      integer, parameter :: ir1=12211, ir2=3791, ntab=32, ndiv=1+imm1/ntab
      real, parameter :: am=1./im1, eps=1.2e-7, rnmx=1.-eps
      integer :: idum2=123456789, iy=0, j, k
      integer, dimension(ntab) :: iv
      
      save iv,iy,idum2


      do j=1,ntab
        iv(j)=0
      enddo

      if(idum.le.0) then
        idum=max(-idum,1)
        idum2=idum
        do j=ntab+8,1,-1
          k=idum/iq1
          idum=ia1*(idum-k*iq1)-k*ir1
          if(idum.lt.0) idum=idum+im1
          if(j.le.ntab) iv(j)=idum
        enddo
        iy=iv(1)
      endif
      k=idum/iq1
      idum=ia1*(idum-k*iq1)-k*ir1
      if(idum.lt.0) idum=idum+im1
      k=idum2/iq2
      idum2=ia2*(idum2-k*iq2)-k*ir2
      if(idum2.lt.0) idum2=idum2+im2
      j=1+iy/ndiv
      iy=iv(j)-idum2
      iv(j)=idum
      if(iy.lt.1) iy=iy+imm1
      ran2=min(am*iy,rnmx)
      
      end function ran2

!**********************************************************************


      FUNCTION GASDEV(IDUM)
!----------------------------------------------------------------------
!  Gaussian white noise generator using uniformly distributed white
!  noise generator
!---------------------------------------------------------------------- 

      implicit none
      real:: gasdev, ran2
      integer, intent(inout):: idum
      real :: v1, v2, gv1, gv2
      real, parameter :: pi=3.1415927

      V1=RAN2(IDUM)
      V2=RAN2(IDUM)

      gv1=sqrt(-2.0*log(v1))*cos(2.0*pi*v2)
      gv2=sqrt(-2.0*log(v2))*cos(2.0*pi*v1)

      gasdev=gv1

      END FUNCTION GASDEV



      subroutine min_max(LEX,ximf,spmax,spmin,nmax,nmin)
!------------------------------------------------------------------
!  This is a routine to define maxima and minima from series ximf.
!  All the extrema are defined as the corresponding values of
!  ximf in spmax and spmin. All non-extrema values in spmax and
!  spmin are defined as 1.0e31.
!------------------------------------------------------------------
      implicit none

      integer, intent(in):: LEX
      real, dimension(LEX), intent(in):: ximf
      real, dimension(LEX), intent(out):: spmax, spmin
      integer, intent(out):: nmax, nmin
      integer:: i
      
      nmax=0
      nmin=0

      spmax(1)=ximf(1)
      spmax(LEX)=ximf(LEX)
      spmin(1)=spmax(1)
      spmin(LEX)=spmax(LEX)

      nmax=2
      nmin=2

      do i=2,LEX-1
        if(ximf(i) > ximf(i-1) .and. ximf(i) >= ximf(i+1)) then
          spmax(i) = ximf(i)
          nmax = nmax+1
        else
          spmax(i)=1.0e31
        endif
        if(ximf(i) < ximf(i-1) .and. ximf(i) <= ximf(i+1)) then
          spmin(i)=ximf(i)
          nmin=nmin+1
        else
          spmin(i)=1.0e31
        endif
      enddo

      call endmax(LEX, spmax, nmax)
      call endmin(LEX, spmin, nmin)

      end subroutine min_max

!****************************************************************

      subroutine endmax(LEX, temp, nmax)
!--------------------------------------------------------------------
! This is a subroutine to determine end values of the upper envolope
! using the method described in Appendix B of Wu and Huang (2009, 
! AADA, Vol. 1, pp1).
!--------------------------------------------------------------------
      implicit none

      integer, intent(in) :: nmax, LEX
      real, dimension(LEX), intent(inout):: temp 
      real, dimension(nmax) :: exmax, X
      integer :: I, J, lend
      real :: slope1, slope2, tmp1, tmp2
     
      lend=nmax

      J=1
      DO I=1, LEX
        IF( temp(I).LT.1.0E30 ) THEN
          X(J)=float(I)
          exmax(J)=temp(I)
          J=J+1
        ENDIF
      ENDDO

      if (nmax >= 4) then
        slope1=(exmax(2)-exmax(3))/(X(2)-X(3))
        tmp1=slope1*(X(1)-X(2))+exmax(2)
        if(tmp1 > exmax(1)) then
          temp(1)=tmp1
        endif
        
        slope2=(exmax(lend-1)-exmax(lend-2))/(X(lend-1)-X(lend-2))
        tmp2=slope2*(X(lend)-X(lend-1))+exmax(lend-1)
        if(tmp2 > exmax(lend)) then
          temp(LEX)=tmp2
        endif
      endif
      
      end subroutine endmax


!****************************************************************

      subroutine endmin(LEX, temp, nmax)
!--------------------------------------------------------------------
! This is a subroutine to determine end values of the lower envolope
! using the method described in Appendix B of Wu and Huang (2009, 
! AADA, Vol. 1, pp1).
!--------------------------------------------------------------------
      implicit none

      integer, intent(in) :: nmax, LEX
      real, dimension(LEX), intent(inout):: temp 
      real, dimension(nmax) :: exmax, X
      integer :: I, J, lend
      real :: slope1, slope2, tmp1, tmp2
     
      lend=nmax

      J=1
      DO I=1, LEX
        IF( temp(I).LT.1.0E30 ) THEN
          X(J)=float(I)
          exmax(J)=temp(I)
          J=J+1
        ENDIF
      ENDDO

      if (nmax >= 4) then
        slope1=(exmax(2)-exmax(3))/(X(2)-X(3))
        tmp1=slope1*(X(1)-X(2))+exmax(2)
        if(tmp1 < exmax(1)) then
          temp(1)=tmp1
        endif
        
        slope2=(exmax(lend-1)-exmax(lend-2))/(X(lend-1)-X(lend-2))
        tmp2=slope2*(X(lend)-X(lend-1))+exmax(lend-1)
        if(tmp2 < exmax(lend)) then
          temp(LEX)=tmp2
        endif
      endif
      
      end subroutine endmin



      SUBROUTINE NATURAL_SPLINE(YA,LEX,N)
!----------------------------------------------------------------------
!  This is a program of cubic spline interpolation. The imported
!  series, YA have a length of LEX, with N numbers of value
!  not equal to 1.0E31. The program is to use the cubic line to
!  interpolate the values for the points other thatn these N
!  numbers.        
!-----------------------------------------------------------------------

      implicit none

      integer, intent(in):: N, LEX      
      real, dimension(LEX), intent(inout):: YA
      real, dimension(N):: Y, Y2
      integer, dimension(N):: LX
      integer:: J, I, KLO, KHI
      real:: YP1, YPN, H, A, B 


!  The following code is to realocate the series of X(N), Y(N)

      J=1
      DO I=1, LEX
        IF( YA(I).LT.1.0E30 ) THEN
          LX(J)=I
          Y(J)=YA(I)
          J=J+1
        ENDIF
      ENDDO

!  The following code is used to calculate the second order derivative, 
!  set the derivatives at both ends for a natural cubic spline.
      YP1=1.0E31
      YPN=1.0E31

      CALL SPLINE(LX,Y,N,YP1,YPN,Y2)

!  calculate the cubic spline
      DO I=2,N
        KLO=LX(I-1)
        KHI=LX(I)
        H=real(KHI-KLO)
        DO J=KLO+1,KHI-1
          A=REAL(KHI-J)/H
          B=REAL(J-KLO)/H
          YA(J)=A*Y(I-1)+B*Y(I)   &
                +((A*A*A-A)*Y2(I-1)+(B*B*B-B)*Y2(I))*(H*H)/6.0
        ENDDO
      ENDDO

      END SUBROUTINE NATURAL_SPLINE


!**************************************************************************


      SUBROUTINE SPLINE(LX,Y,N,YP1,YPN,Y2)
!-----------------------------------------------------------------
!  see NUMEIRCAL RECIPES to find out meaning of each variables
!-----------------------------------------------------------------
      implicit none
    
      integer, intent(in) :: N, YP1, YPN
      integer, dimension(N), intent(in):: LX
      real, dimension(N) :: X, U
      real, dimension(N), intent(inout):: Y, Y2 
      integer:: I, K
      real:: SIG, P, QN, UN

      DO I=1,N
        X(I)=real(LX(I))
      ENDDO

      Y2(1)=0.
      U(1)=0.
      
      DO I=2,N-1
        SIG=(X(I)-X(I-1))/(X(I+1)-X(I-1))
        P=SIG*Y2(I-1)+2.
        Y2(I)=(SIG-1.)/P
        U(I)=(6.*((Y(I+1)-Y(I))/(X(I+1)-X(I))-(Y(I)-Y(I-1)) &
             /(X(I)-X(I-1)))/(X(I+1)-X(I-1))-SIG*U(I-1))/P
      ENDDO

      QN=0.
      UN=0.

      Y2(N)=(UN-QN*U(N-1))/(QN*Y2(N-1)+1.)

      DO K=N-1,1,-1
        Y2(K)=Y2(K)*Y2(K+1)+U(K)
      ENDDO

      END SUBROUTINE SPLINE


      subroutine standev(nsize, indata, trend, std)
!-------------------------------------------------------------------
!  This is a program to obtain standard deviation of the linearly
!  detrended data
!  
!  PARAMETERS:
!  nsize    :    indata size
!  indata   :    input data
!  trend    :    the linear trend of "indata"
!  std      :    standard deviation
!--------------------------------------------------------------------

      implicit none

      integer, intent(in) :: nsize
      real, dimension(nsize) :: indata
      real, dimension(nsize), intent(out):: trend
      real, intent(out) :: std
      real sigmaX, sigmaY, sigmaX2, sigmaXY, real_nsize, Xbar, Ybar, real_i
      integer :: i
      real :: trend_const, trend_slope, temp

      sigmaX = 0.0
      sigmaY = 0.0
      do i = 1, nsize
        sigmaX = sigmaX + real(i)
        sigmaY = sigmaY + indata(i)
      enddo

      real_nsize=real(nsize)

      Xbar=sigmaX/real_nsize
      Ybar=sigmaY/real_nsize

      sigmaX2 = 0.0
      sigmaXY = 0.0
      do i = 1, nsize
        real_i=real(i)
        sigmaX2 = sigmaX2+(real_i-xbar)*(real_i-xbar)
        sigmaXY = sigmaXY+(real_i-xbar)*(indata(i)-ybar)
      enddo

      trend_slope=sigmaXY/sigmaX2
      trend_const=Ybar-trend_slope*Xbar

      do i=1, nsize
        trend(i)= trend_const + trend_slope*real(i)
      enddo

      std=0.0

      do i=1,nsize
        temp= indata(i)-trend(i)
        std=std+temp*temp
      enddo
      std=std/real(nsize)
      std=sqrt(std)

      end subroutine standev

      PROGRAM FTEX01
C
C  Example of CURV1, CURV2, CURVD, CURVI.
C
C  Define dimensions, declare arrays.
C
      PARAMETER (IDIM=11,IOUT=201)
      DIMENSION X(IDIM),Y(IDIM),YP(IDIM),TEMP(IDIM,2)
      DIMENSION XO(IOUT),YO(IOUT),YD(IOUT),YI(IOUT)
C
C Specify the input data.
C
C
      DATA X/  0.00,   2.00,   5.00,   8.00,  10.00,  13.00,
     +        15.00,  18.00,  21.00,  23.00,  30.00         /
      DATA Y/  1.00,   0.81,   0.00,  -0.81,  -1.00,  -0.84,
     +        -0.56,   0.04,   0.73,   1.18,   2.0          /
C
C  Call CURV1 setup, specifying that the derivatives should be
C  zero at the end points.
C
      SLP1   = 0.
      SLPN   = 0.
      ISLPSW = 0
      SIGMA  = 1.
      CALL CURV1(IDIM, X, Y, SLP1, SLPN, ISLPSW, YP, TEMP, SIGMA, IERR)
C
C  Call CURV2 and calculate the interpolated values, the derivatives,
C  and the integrals.
C
      XINC = 30./(IOUT-1)
      DO 10 I=1,IOUT
        XO(I) = (I-1)*XINC
        YO(I) = CURV2(XO(I),IDIM,X,Y,YP,SIGMA)
        YD(I) = CURVD(XO(I),IDIM,X,Y,YP,SIGMA)
        YI(I) = CURVI(XO(1),XO(I),IDIM,X,Y,YP,SIGMA)
   10 CONTINUE
C
C  Draw a plot of the interpolated functions and mark the original points.
C
      CALL DRWFT1(IDIM,X,Y,IOUT,XO,YO,YD,YI)
C
      STOP
      END
      SUBROUTINE DRWFT1(II,X,Y,IO,XO,YO,YD,YI)
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
      DATA YPOS_TOP/0.88/
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C  Define a color table.
C
      CALL GSCR(IWKID, 0, 1.0, 1.0, 1.0)
      CALL GSCR(IWKID, 1, 0.0, 0.0, 0.0)
      CALL GSCR(IWKID, 2, 1.0, 0.0, 0.0)
      CALL GSCR(IWKID, 3, 0.0, 1.0, 0.0)
      CALL GSCR(IWKID, 4, 0.0, 0.0, 1.0)
      CALL GSCLIP(0)
C
C  Plot main title.
C
      CALL PLCHHQ(0.50,0.95,':F25:Demo for CURV, CURVD, CURVI',
     +            0.030,0.,0.)
C
C  Graph the interpolated function values and mark the original
C  input data points.
C
      YB = -1.0
      YT =  2.0
      CALL BKGFT1(YPOS_TOP,'Function',YB,YT)
      CALL GRIDAL(6,5,3,1,1,1,10,0.0,YB)
C
C  Mark the original data points.
C
      CALL GSMKSC(2.)
      CALL GSPMCI(4)
      CALL GSLWSC(1.)
      CALL GPM(II,X,Y)
C
C  Graph the interpolated function values.
C
      CALL GPL(IO,XO,YO)
C
C  Graph the derivative.
C
      YB = -0.3
      YT =  0.3
      CALL BKGFT1(YPOS_TOP-0.3,'Derivative',YB,YT)
      CALL GRIDAL(6,5,3,1,1,1,10,0.0,YB)
      CALL GPL(IO,XO,YD)
      CALL GSPLCI(1)
C
C  Graph the integral.
C
      YB = -6.0
      YT = 10.0
      CALL BKGFT1(YPOS_TOP-0.6,'Integral',YB,YT)
      CALL GRIDAL(6,5,4,1,1,1,10,0.0,YB)
      CALL GPL(IO,XO,YI)
      CALL GSPLCI(1)
      CALL FRAME
C
      CALL GDAWK(IWKID)
      CALL GCLWK(IWKID)
      CALL GCLKS
C
      RETURN
      END
      SUBROUTINE BKGFT1(YPOS,LABEL,YB,YT)
      DIMENSION XX(2),YY(2)
      CHARACTER*(*) LABEL
C
      CALL SET(0.,1.,0.,1.,0.,1.,0.,1.,1)
      CALL PCSETI('FN',21)
      CALL PLCHHQ(0.20,YPOS - 0.03,LABEL,0.025,0.,-1.)
      CALL SET(0.13,0.93,YPOS-0.2,YPOS,0.0,30.0, YB, YT, 1)
      XX(1) = 0.
      XX(2) = 30.
      YY(1) = 0.
      YY(2) = 0.
      CALL GSPLCI(2)
      CALL GPL(2,XX,YY)
      CALL GSPLCI(1)

      CALL GASETI('LTY',1)
      CALL PCSETI('FN',21)
      CALL GASETR('XLS',0.02)
      CALL GASETC('XLF','(I3)')
      CALL GASETR('YLS',0.02)
      CALL GASETC('YLF','(F5.1)')
      CALL GASETR('XMJ',0.02)
      CALL GASETR('YMJ',0.02)
C
      RETURN
      END

      SUBROUTINE CGTRFS( TRANS, N, NRHS, DL, D, DU, DLF, DF, DUF, DU2,
     $                   IPIV, B, LDB, X, LDX, FERR, BERR, WORK, RWORK,
     $                   INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER          TRANS
      INTEGER            INFO, LDB, LDX, N, NRHS
*     ..
*     .. Array Arguments ..
      INTEGER            IPIV( * )
      REAL               BERR( * ), FERR( * ), RWORK( * )
      COMPLEX            B( LDB, * ), D( * ), DF( * ), DL( * ),
     $                   DLF( * ), DU( * ), DU2( * ), DUF( * ),
     $                   WORK( * ), X( LDX, * )
*     ..
*
*  Purpose
*  =======
*
*  CGTRFS improves the computed solution to a system of linear
*  equations when the coefficient matrix is tridiagonal, and provides
*  error bounds and backward error estimates for the solution.
*
*  Arguments
*  =========
*
*  TRANS   (input) CHARACTER*1
*          Specifies the form of the system of equations:
*          = 'N':  A * X = B     (No transpose)
*          = 'T':  A**T * X = B  (Transpose)
*          = 'C':  A**H * X = B  (Conjugate transpose)
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  NRHS    (input) INTEGER
*          The number of right hand sides, i.e., the number of columns
*          of the matrix B.  NRHS >= 0.
*
*  DL      (input) COMPLEX array, dimension (N-1)
*          The (n-1) subdiagonal elements of A.
*
*  D       (input) COMPLEX array, dimension (N)
*          The diagonal elements of A.
*
*  DU      (input) COMPLEX array, dimension (N-1)
*          The (n-1) superdiagonal elements of A.
*
*  DLF     (input) COMPLEX array, dimension (N-1)
*          The (n-1) multipliers that define the matrix L from the
*          LU factorization of A as computed by CGTTRF.
*
*  DF      (input) COMPLEX array, dimension (N)
*          The n diagonal elements of the upper triangular matrix U from
*          the LU factorization of A.
*
*  DUF     (input) COMPLEX array, dimension (N-1)
*          The (n-1) elements of the first superdiagonal of U.
*
*  DU2     (input) COMPLEX array, dimension (N-2)
*          The (n-2) elements of the second superdiagonal of U.
*
*  IPIV    (input) INTEGER array, dimension (N)
*          The pivot indices; for 1 <= i <= n, row i of the matrix was
*          interchanged with row IPIV(i).  IPIV(i) will always be either
*          i or i+1; IPIV(i) = i indicates a row interchange was not
*          required.
*
*  B       (input) COMPLEX array, dimension (LDB,NRHS)
*          The right hand side matrix B.
*
*  LDB     (input) INTEGER
*          The leading dimension of the array B.  LDB >= max(1,N).
*
*  X       (input/output) COMPLEX array, dimension (LDX,NRHS)
*          On entry, the solution matrix X, as computed by CGTTRS.
*          On exit, the improved solution matrix X.
*
*  LDX     (input) INTEGER
*          The leading dimension of the array X.  LDX >= max(1,N).
*
*  FERR    (output) REAL array, dimension (NRHS)
*          The estimated forward error bound for each solution vector
*          X(j) (the j-th column of the solution matrix X).
*          If XTRUE is the true solution corresponding to X(j), FERR(j)
*          is an estimated upper bound for the magnitude of the largest
*          element in (X(j) - XTRUE) divided by the magnitude of the
*          largest element in X(j).  The estimate is as reliable as
*          the estimate for RCOND, and is almost always a slight
*          overestimate of the true error.
*
*  BERR    (output) REAL array, dimension (NRHS)
*          The componentwise relative backward error of each solution
*          vector X(j) (i.e., the smallest relative change in
*          any element of A or B that makes X(j) an exact solution).
*
*  WORK    (workspace) COMPLEX array, dimension (2*N)
*
*  RWORK   (workspace) REAL array, dimension (N)
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*
*  Internal Parameters
*  ===================
*
*  ITMAX is the maximum number of steps of iterative refinement.
*
*  =====================================================================
*
*     .. Parameters ..
      INTEGER            ITMAX
      PARAMETER          ( ITMAX = 5 )
      REAL               ZERO, ONE
      PARAMETER          ( ZERO = 0.0E+0, ONE = 1.0E+0 )
      REAL               TWO
      PARAMETER          ( TWO = 2.0E+0 )
      REAL               THREE
      PARAMETER          ( THREE = 3.0E+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            NOTRAN
      CHARACTER          TRANSN, TRANST
      INTEGER            COUNT, I, J, KASE, NZ
      REAL               EPS, LSTRES, S, SAFE1, SAFE2, SAFMIN
      COMPLEX            ZDUM
*     ..
*     .. External Subroutines ..
      EXTERNAL           CAXPY, CCOPY, CGTTRS, CLACON, CLAGTM, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, AIMAG, CMPLX, MAX, REAL
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      REAL               SLAMCH
      EXTERNAL           LSAME, SLAMCH
*     ..
*     .. Statement Functions ..
      REAL               CABS1
*     ..
*     .. Statement Function definitions ..
      CABS1( ZDUM ) = ABS( REAL( ZDUM ) ) + ABS( AIMAG( ZDUM ) )
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      NOTRAN = LSAME( TRANS, 'N' )
      IF( .NOT.NOTRAN .AND. .NOT.LSAME( TRANS, 'T' ) .AND. .NOT.
     $    LSAME( TRANS, 'C' ) ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( NRHS.LT.0 ) THEN
         INFO = -3
      ELSE IF( LDB.LT.MAX( 1, N ) ) THEN
         INFO = -13
      ELSE IF( LDX.LT.MAX( 1, N ) ) THEN
         INFO = -15
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'CGTRFS', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 .OR. NRHS.EQ.0 ) THEN
         DO 10 J = 1, NRHS
            FERR( J ) = ZERO
            BERR( J ) = ZERO
   10    CONTINUE
         RETURN
      END IF
*
      IF( NOTRAN ) THEN
         TRANSN = 'N'
         TRANST = 'C'
      ELSE
         TRANSN = 'C'
         TRANST = 'N'
      END IF
*
*     NZ = maximum number of nonzero elements in each row of A, plus 1
*
      NZ = 4
      EPS = SLAMCH( 'Epsilon' )
      SAFMIN = SLAMCH( 'Safe minimum' )
      SAFE1 = NZ*SAFMIN
      SAFE2 = SAFE1 / EPS
*
*     Do for each right hand side
*
      DO 110 J = 1, NRHS
*
         COUNT = 1
         LSTRES = THREE
   20    CONTINUE
*
*        Loop until stopping criterion is satisfied.
*
*        Compute residual R = B - op(A) * X,
*        where op(A) = A, A**T, or A**H, depending on TRANS.
*
         CALL CCOPY( N, B( 1, J ), 1, WORK, 1 )
         CALL CLAGTM( TRANS, N, 1, -ONE, DL, D, DU, X( 1, J ), LDX, ONE,
     $                WORK, N )
*
*        Compute abs(op(A))*abs(x) + abs(b) for use in the backward
*        error bound.
*
         IF( NOTRAN ) THEN
            IF( N.EQ.1 ) THEN
               RWORK( 1 ) = CABS1( B( 1, J ) ) +
     $                      CABS1( D( 1 ) )*CABS1( X( 1, J ) )
            ELSE
               RWORK( 1 ) = CABS1( B( 1, J ) ) +
     $                      CABS1( D( 1 ) )*CABS1( X( 1, J ) ) +
     $                      CABS1( DU( 1 ) )*CABS1( X( 2, J ) )
               DO 30 I = 2, N - 1
                  RWORK( I ) = CABS1( B( I, J ) ) +
     $                         CABS1( DL( I-1 ) )*CABS1( X( I-1, J ) ) +
     $                         CABS1( D( I ) )*CABS1( X( I, J ) ) +
     $                         CABS1( DU( I ) )*CABS1( X( I+1, J ) )
   30          CONTINUE
               RWORK( N ) = CABS1( B( N, J ) ) +
     $                      CABS1( DL( N-1 ) )*CABS1( X( N-1, J ) ) +
     $                      CABS1( D( N ) )*CABS1( X( N, J ) )
            END IF
         ELSE
            IF( N.EQ.1 ) THEN
               RWORK( 1 ) = CABS1( B( 1, J ) ) +
     $                      CABS1( D( 1 ) )*CABS1( X( 1, J ) )
            ELSE
               RWORK( 1 ) = CABS1( B( 1, J ) ) +
     $                      CABS1( D( 1 ) )*CABS1( X( 1, J ) ) +
     $                      CABS1( DL( 1 ) )*CABS1( X( 2, J ) )
               DO 40 I = 2, N - 1
                  RWORK( I ) = CABS1( B( I, J ) ) +
     $                         CABS1( DU( I-1 ) )*CABS1( X( I-1, J ) ) +
     $                         CABS1( D( I ) )*CABS1( X( I, J ) ) +
     $                         CABS1( DL( I ) )*CABS1( X( I+1, J ) )
   40          CONTINUE
               RWORK( N ) = CABS1( B( N, J ) ) +
     $                      CABS1( DU( N-1 ) )*CABS1( X( N-1, J ) ) +
     $                      CABS1( D( N ) )*CABS1( X( N, J ) )
            END IF
         END IF
*
*        Compute componentwise relative backward error from formula
*
*        max(i) ( abs(R(i)) / ( abs(op(A))*abs(X) + abs(B) )(i) )
*
*        where abs(Z) is the componentwise absolute value of the matrix
*        or vector Z.  If the i-th component of the denominator is less
*        than SAFE2, then SAFE1 is added to the i-th components of the
*        numerator and denominator before dividing.
*
         S = ZERO
         DO 50 I = 1, N
            IF( RWORK( I ).GT.SAFE2 ) THEN
               S = MAX( S, CABS1( WORK( I ) ) / RWORK( I ) )
            ELSE
               S = MAX( S, ( CABS1( WORK( I ) )+SAFE1 ) /
     $             ( RWORK( I )+SAFE1 ) )
            END IF
   50    CONTINUE
         BERR( J ) = S
*
*        Test stopping criterion. Continue iterating if
*           1) The residual BERR(J) is larger than machine epsilon, and
*           2) BERR(J) decreased by at least a factor of 2 during the
*              last iteration, and
*           3) At most ITMAX iterations tried.
*
         IF( BERR( J ).GT.EPS .AND. TWO*BERR( J ).LE.LSTRES .AND.
     $       COUNT.LE.ITMAX ) THEN
*
*           Update solution and try again.
*
            CALL CGTTRS( TRANS, N, 1, DLF, DF, DUF, DU2, IPIV, WORK, N,
     $                   INFO )
            CALL CAXPY( N, CMPLX( ONE ), WORK, 1, X( 1, J ), 1 )
            LSTRES = BERR( J )
            COUNT = COUNT + 1
            GO TO 20
         END IF
*
*        Bound error from formula
*
*        norm(X - XTRUE) / norm(X) .le. FERR =
*        norm( abs(inv(op(A)))*
*           ( abs(R) + NZ*EPS*( abs(op(A))*abs(X)+abs(B) ))) / norm(X)
*
*        where
*          norm(Z) is the magnitude of the largest component of Z
*          inv(op(A)) is the inverse of op(A)
*          abs(Z) is the componentwise absolute value of the matrix or
*             vector Z
*          NZ is the maximum number of nonzeros in any row of A, plus 1
*          EPS is machine epsilon
*
*        The i-th component of abs(R)+NZ*EPS*(abs(op(A))*abs(X)+abs(B))
*        is incremented by SAFE1 if the i-th component of
*        abs(op(A))*abs(X) + abs(B) is less than SAFE2.
*
*        Use CLACON to estimate the infinity-norm of the matrix
*           inv(op(A)) * diag(W),
*        where W = abs(R) + NZ*EPS*( abs(op(A))*abs(X)+abs(B) )))
*
         DO 60 I = 1, N
            IF( RWORK( I ).GT.SAFE2 ) THEN
               RWORK( I ) = CABS1( WORK( I ) ) + NZ*EPS*RWORK( I )
            ELSE
               RWORK( I ) = CABS1( WORK( I ) ) + NZ*EPS*RWORK( I ) +
     $                      SAFE1
            END IF
   60    CONTINUE
*
         KASE = 0
   70    CONTINUE
         CALL CLACON( N, WORK( N+1 ), WORK, FERR( J ), KASE )
         IF( KASE.NE.0 ) THEN
            IF( KASE.EQ.1 ) THEN
*
*              Multiply by diag(W)*inv(op(A)**H).
*
               CALL CGTTRS( TRANST, N, 1, DLF, DF, DUF, DU2, IPIV, WORK,
     $                      N, INFO )
               DO 80 I = 1, N
                  WORK( I ) = RWORK( I )*WORK( I )
   80          CONTINUE
            ELSE
*
*              Multiply by inv(op(A))*diag(W).
*
               DO 90 I = 1, N
                  WORK( I ) = RWORK( I )*WORK( I )
   90          CONTINUE
               CALL CGTTRS( TRANSN, N, 1, DLF, DF, DUF, DU2, IPIV, WORK,
     $                      N, INFO )
            END IF
            GO TO 70
         END IF
*
*        Normalize error.
*
         LSTRES = ZERO
         DO 100 I = 1, N
            LSTRES = MAX( LSTRES, CABS1( X( I, J ) ) )
  100    CONTINUE
         IF( LSTRES.NE.ZERO )
     $      FERR( J ) = FERR( J ) / LSTRES
*
  110 CONTINUE
*
      RETURN
*
*     End of CGTRFS
*
      END

      INTEGER FUNCTION GCCONVEX (NPTS, QLAT, QLON)
C
C  This function determines if the spherical polygon
C  (QLAT(I),QLON(I)),I=1,NPTS) is convex.  One is returned
C  if so, zero otherwise.  The input polygon must have at
C  least three points and be closed.
C
      DOUBLE PRECISION GCDANGLE,QLAT(NPTS),QLON(NPTS)
C
C  Find the initial direction.
C
      IDIR = SIGN(1.D0,GCDANGLE(QLAT(1),QLON(1),QLAT(2),QLON(2),
     +            QLAT(3),QLON(3)))
      DO 10 I=2,NPTS
        ISGN = SIGN(1.D0,GCDANGLE(QLAT(I),QLON(I),
     +                       QLAT(MOD(I+1,NPTS)),QLON(MOD(I+1,NPTS)),
     +                       QLAT(MOD(I+2,NPTS)),QLON(MOD(I+2,NPTS))))
        IF (ISGN .NE. IDIR) THEN
          GCCONVEX = 0
          RETURN
        ENDIF
   10 CONTINUE
      GCCONVEX = 1
      RETURN
C
      END
      INTEGER FUNCTION GCINOUT (PLAT, PLON, QLAT, QLON, NPTS, WORK)
C
C  This function determines if the coordinate (PLAT,PLON) is
C  inside or outside of the spherical patch
C  (QLAT(I),QLON(I)),I=1,NPTS).  Zero is returned if
C  in, non-zero otherwise.  WORK is a work array
C  dimensioned for 4*NPTS.  A point on the boundary is
C  considered to be inside.
C
      DOUBLE PRECISION PLAT, PLON, QLAT(NPTS), QLON(NPTS), WORK(4,NPTS)
      DOUBLE PRECISION P(4), D2R
      DATA D2R/0.017453292519943D0/
      INTEGER GCONARC
C

C
C  Check that the input polygon is closed.
C
      IF (QLAT(NPTS).NE.QLAT(1) .OR. QLON(NPTS).NE.QLON(1)) THEN
        WRITE(6,500) 
  500   FORMAT('GCINOUT: The input spherical polygon must be closed.')

        GCINOUT = -1
        RETURN
      ENDIF
C
      DO 10 I=1,NPTS
        WORK(1,I) = DCOS(D2R*QLAT(I))
        WORK(2,I) = DSIN(D2R*QLAT(I))
        WORK(3,I) = DCOS(D2R*QLON(I))
        WORK(4,I) = DSIN(D2R*QLON(I))
   10 CONTINUE
      P(1) = DCOS(D2R*PLAT)
      P(2) = DSIN(D2R*PLAT)
      P(3) = DCOS(D2R*PLON)
      P(4) = DSIN(D2R*PLON)

C
C  Return if inside (may still be on boundary).
C
C       
      GCINOUT = ICAPDP(P,WORK,NPTS)
      IF (GCINOUT .EQ. 0) THEN
        RETURN
      ENDIF
C
C  Check if on boundary.
C
      DO 20 I=1,NPTS-1
        IF (GCONARC(PLAT,PLON,QLAT(I),QLON(I),QLAT(I+1),QLON(I+1),
     +               1.D-10) .EQ. 1) THEN
          GCINOUT = 0
          RETURN
        ENDIF
   20 CONTINUE
C     
C  Default return flags outside.
C
      GCINOUT = 1
      RETURN
      END
      DOUBLE PRECISION FUNCTION GCDIST(LAT1,LON1,LAT2,LON2)
C
C  Computes the shortest (undirected) angular distance between the points
C  on the globe (LAT1,LON1) and (LAT2,LON2).
C
      DOUBLE PRECISION AT(4), BT(4), D2R, XADGCDP
      DOUBLE PRECISION LAT1,LON1,LAT2,LON2
      DATA D2R/0.017453292519943D0/
C
      AT(1) = COS(D2R*LAT1)
      AT(2) = SIN(D2R*LAT1)
      AT(3) = COS(D2R*LON1)
      AT(4) = SIN(D2R*LON1)
C
      BT(1) = COS(D2R*LAT2)
      BT(2) = SIN(D2R*LAT2)
      BT(3) = COS(D2R*LON2)
      BT(4) = SIN(D2R*LON2)
C
      GCDIST = XADGCDP(AT,BT)
C
      RETURN
      END
      INTEGER FUNCTION GCONARC(PLAT,PLON,LAT1,LON1,LAT2,LON2,TOL)
C 
C  Determines whether (PLAT,PLON) lies on the arc of the
C  great circle formed by (LAT1,LON1) and (LAT2,LON2) within 
C  a tolerance of TOL.  The arc is taken to be the shorter of 
C  the two possible arcs between (LAT1,LON1) and (LAT2,LON2).
C  Return 1 if on arc, 0 otherwise.
C
      DOUBLE PRECISION PLAT,PLON,LAT1,LON1,LAT2,LON2,TOL
      DOUBLE PRECISION ADIST,BDIST,CDIST,GCPNT2GC,GCDIST
      ADIST = GCPNT2GC(LAT1,LON1,LAT2,LON2,PLAT,PLON)
      IF (ABS(ADIST) .LE. TOL) THEN
        BDIST = ABS(GCDIST(PLAT,PLON,LAT1,LON1)) + 
     +          ABS(GCDIST(PLAT,PLON,LAT2,LON2))
        CDIST = ABS(GCDIST(LAT1,LON1,LAT2,LON2))
        IF (ABS(BDIST - CDIST) .LE. TOL) THEN
          GCONARC = 1
        ELSE
          GCONARC = 0
        ENDIF
      ELSE
        GCONARC = 0
      ENDIF
      RETURN 
      END
      DOUBLE PRECISION FUNCTION GCCONVERT(ANGLE,TYPE)
C
C  Converts an angle (in degrees) along a great circle on the earth
C  as per:
C
C  TYPE -- A string indicating the units you want to convert
C          to. Legal values are:
C
C          "radians"
C          "meters" 
C          "kilometers"
C          "feet"     
C          "miles"   
C
      DOUBLE PRECISION ANGLE
      CHARACTER*(*) TYPE
      DOUBLE PRECISION D2R
      DATA D2R/0.017453292519943D0/
C
C  Since the radius of the earth is not a precise number, the
C  following conversion ratios need not be double precision.
C
      DOUBLE PRECISION R2M, M2F
      DATA R2M,M2F/6371220.,3.2808/
C
      IF (TYPE(1:2).EQ.'ra' .OR. TYPE(1:2).EQ.'RA') THEN
        GCCONVERT = D2R*ANGLE
      ELSE IF (TYPE(1:2).EQ.'me' .OR. TYPE(1:2).EQ.'ME') THEN
        GCCONVERT = D2R*ANGLE*R2M
      ELSE IF (TYPE(1:2).EQ.'ki' .OR. TYPE(1:2).EQ.'KI') THEN
        GCCONVERT = D2R*ANGLE*R2M/1000.
      ELSE IF (TYPE(1:2).EQ.'fe' .OR. TYPE(1:2).EQ.'FE') THEN
        GCCONVERT = D2R*ANGLE*R2M*M2F
      ELSE IF (TYPE(1:2).EQ.'mi' .OR. TYPE(1:2).EQ.'MI') THEN
        GCCONVERT = D2R*ANGLE*R2M*M2F/5280.
      ELSE
        PRINT *,'GCCONVERT: unrecognized conversion type'
      ENDIF
C
      RETURN
      END
      SUBROUTINE GCINTERP(LAT1, LON1, LAT2, LON2, NPTS, OLAT, OLON)
C
C  Interpolates NPTS points along a great circle from (LAT1,LON1) to
C  (LAT2,LON2) and returns them in the OLAT and OLON arrays.  The 
C  beginning and ending points are included in the result, so, for
C  example, if NPTS=2, then only the end points are returned.  
C 
      DOUBLE PRECISION LAT1, LON1, LAT2, LON2, OLAT(NPTS), OLON(NPTS)
      DOUBLE PRECISION NLAT1, NLON1, NLAT2, NLON2, NORMANG
      DOUBLE PRECISION D2R,R2D
      DATA D2R,R2D/0.017453292519943D0,57.2957795130823D0/
C
      NLAT1 = R2D*NORMANG(D2R*LAT1)
      NLON1 = R2D*NORMANG(D2R*LON1)
      NLAT2 = R2D*NORMANG(D2R*LAT2)
      NLON2 = R2D*NORMANG(D2R*LON2)
C     
      OLAT(1)    = NLAT1
      OLON(1)    = NLON1
      OLAT(NPTS) = NLAT2
      OLON(NPTS) = NLON2
      IF (NPTS .EQ. 2) THEN
        RETURN
      ENDIF
      CALL DMAPGCI (LAT1,LON1,LAT2,LON2,NPTS-2,OLAT(2),OLON(2))
      RETURN
      END
      DOUBLE PRECISION FUNCTION GCQAREA(LAT1, LON1, LAT2, LON2,
     +                                  LAT3, LON3, LAT4, LON4,
     +                                  IER)
C
C  Finds the area of a convex quadrilateral patch on a sphere whose 
C  vertices are given in degrees as lat/lon pairs.
C
      DOUBLE PRECISION GCTAREA
      DOUBLE PRECISION LAT1, LON1, LAT2, LON2, LAT3, LON3, LAT4, LON4
      DOUBLE PRECISION GC1, GC2
      INTEGER IER, IER1, IER2
C
      GC1 = ABS(GCTAREA(LAT1, LON1, LAT2, LON2, LAT3, LON3, IER1))
      GC2 = ABS(GCTAREA(LAT1, LON1, LAT3, LON3, LAT4, LON4, IER2))
      IF(IER1.EQ.0.and.IER2.EQ.0) THEN
        GCQAREA = GC1 + GC2
        IER = 0
      ELSE
        GCQAREA = 1.D30
        IER = 1
      END IF
C     
      RETURN
      END      
      DOUBLE PRECISION FUNCTION GCTAREA(LAT1, LON1, LAT2, LON2,
     +                                  LAT3, LON3, IER)
C
C  Finds the area of a spherical triangle by finding the three
C  spherical angles and subtracting off PI.
C
      DOUBLE PRECISION LAT1, LON1, LAT2, LON2, LAT3, LON3
      DOUBLE PRECISION GCDANGLE,ALPHA,BETA,GAMMA,PI
      DOUBLE PRECISION D2R
      INTEGER IER
      DATA D2R/0.017453292519943D0/
C
      PI = 2.D0*DASIN(1.D0)
C
      IF (.NOT. ( ((LAT1.EQ.LAT2).AND.(LON1.EQ.LON2)) .OR.
     +            ((LAT1.EQ.LAT3).AND.(LON1.EQ.LON3)) .OR.
     +            ((LAT2.EQ.LAT3).AND.(LON2.EQ.LON3)) )) THEN
        ALPHA  = ABS(D2R*GCDANGLE(LAT1, LON1, LAT2, LON2, LAT3, LON3))
        BETA   = ABS(D2R*GCDANGLE(LAT2, LON2, LAT3, LON3, LAT1, LON1))
        GAMMA  = ABS(D2R*GCDANGLE(LAT3, LON3, LAT1, LON1, LAT2, LON2))
        GCTAREA = ALPHA+BETA+GAMMA - PI
        IER = 0
      ELSE
        WRITE(6,500) 
  500   FORMAT('GCTAREA: The three input points must be distinct.')   
        GCTAREA = 1.D30
        IER = 1
      ENDIF
C
      RETURN
      END      
      DOUBLE PRECISION FUNCTION GCPNT2GC(LAT1, LON1, LAT2, LON2,
     +                                    LAT3, LON3)
C
C  Distance from a point (LAT3,LON3) to a great circle defined by the
C  arc from (LAT1,LON1) to (LAT2,LON2).
C
      DOUBLE PRECISION LAT1, LON1, LAT2, LON2, LAT3, LON3
      DOUBLE PRECISION AT(4), BT(4), CT(4), D2R, XDPGCDP
      DATA D2R/0.017453292519943D0/
C
      AT(1) = COS(D2R*LAT1)
      AT(2) = SIN(D2R*LAT1)
      AT(3) = COS(D2R*LON1)
      AT(4) = SIN(D2R*LON1)
C
      BT(1) = COS(D2R*LAT2)
      BT(2) = SIN(D2R*LAT2)
      BT(3) = COS(D2R*LON2)
      BT(4) = SIN(D2R*LON2)
C
      CT(1) = COS(D2R*LAT3)
      CT(2) = SIN(D2R*LAT3)
      CT(3) = COS(D2R*LON3)
      CT(4) = SIN(D2R*LON3)
C
      GCPNT2GC = XDPGCDP (AT,BT,CT)
C 
      RETURN
      END 
      DOUBLE PRECISION FUNCTION XDPGCDP (AQDP,BQDP,CQDP)
C
C (XDPGCDP = Distance of Point from Great Circle, Double Precision)
C 
C Author: David Kennison
C
        DOUBLE PRECISION AQDP(4),BQDP(4),CQDP(4)
C
C This function, given points A, B, and C on the globe, returns the
C directed distance, in degrees of arc, from the great circle through
C A and B to the point C, positive if the point C is in the hemisphere
C to the "left" of the great circle and negative otherwise.
C
C All variables with names of the form XQDP are four-element arrays
C containing the cosine and sine of the latitude and the cosine and
C sine of the longitude, in that order, of the point X.  Describing
C the point positions in this way makes this routine execute faster
C than if the latitudes and longitudes themselves are used.
C
        DOUBLE PRECISION RTOD
        DOUBLE PRECISION XCB2,YCB2,ZCB2
        DOUBLE PRECISION      YCB3,ZCB3
        DOUBLE PRECISION XCC2,YCC2,ZCC2
        DOUBLE PRECISION      YCC3,ZCC3
        DOUBLE PRECISION DNOM
C
        DOUBLE PRECISION XADGCDP
C
C Define a multiplicative constant to convert from radians to degrees.
C
        DATA RTOD / 57.2957795130823D0 /
C
C Get XYZ coordinates for B, rotate them by -ALON about the Z axis (which
C would put A on the prime meridian), and then rotate them by ALAT about
C the Y axis (which would put A on the equator).
C
        XCB2=BQDP(1)*BQDP(3)*AQDP(3)+BQDP(1)*BQDP(4)*AQDP(4)
        YCB2=BQDP(1)*BQDP(4)*AQDP(3)-BQDP(1)*BQDP(3)*AQDP(4)
        ZCB2=BQDP(2)
C
        YCB3=YCB2
        ZCB3=ZCB2*AQDP(1)-XCB2*AQDP(2)
C
C Do the same for C.
C
        XCC2=CQDP(1)*CQDP(3)*AQDP(3)+CQDP(1)*CQDP(4)*AQDP(4)
        YCC2=CQDP(1)*CQDP(4)*AQDP(3)-CQDP(1)*CQDP(3)*AQDP(4)
        ZCC2=CQDP(2)
C
        YCC3=YCC2
        ZCC3=ZCC2*AQDP(1)-XCC2*AQDP(2)
C
C Rotate C about the X axis by the angle ALPH required to put B on the
C equator.
C
C The following code returns the distance from A to C (in the degenerate 
C case when A and B are the same point as well).
C
        IF (YCB3.NE.0.D0 .OR. ZCB3.NE.0.D0) THEN
          DNOM   = SQRT(YCB3*YCB3+ZCB3*ZCB3)
          XDPGCDP = RTOD*ASIN((ZCC3*YCB3-YCC3*ZCB3)/DNOM)
        ELSE
          XDPGCDP = XADGCDP(AQDP,CQDP)
        END IF
C
        RETURN
      END
      DOUBLE PRECISION FUNCTION XADGCDP (AQDP,BQDP)
C
C (XADGCDP = Angle in Degrees along Great Circle, Double Precision)
C
        DOUBLE PRECISION AQDP(4),BQDP(4)
C
C This function returns the shortest great circle distance, in degrees,
C between two points, A and B, on the surface of the globe.
C
C All variables with names of the form XQDP are four-element arrays
C containing the cosine and sine of the latitude and the cosine and
C sine of the longitude, in that order, of the point X.  Describing
C the point positions in this way makes this routine execute faster
C than if the latitudes and longitudes themselves are used.
C
        DOUBLE PRECISION RDTT
C
C Define a multiplicative constant to convert from radians to degrees
C and multiply by two.
C
        DATA RDTT / 114.5915590261646D0 /
C
        XADGCDP=RDTT*
     +         ASIN(SQRT((AQDP(1)*AQDP(3)-BQDP(1)*BQDP(3))**2+
     +                   (AQDP(1)*AQDP(4)-BQDP(1)*BQDP(4))**2+
     +                   (AQDP(2)        -BQDP(2)        )**2)/2.D0)
C
        RETURN
C
      END
      SUBROUTINE LATLON2CART(LAT,LON,X,Y,Z)
C
C  Converts a (lat,lon) coordinate to Cartesian coordinates on the
C  unit sphere.
C
      DOUBLE PRECISION LAT,LON,X,Y,Z,RLAT,RLON,NORMANG,PI,D2R
      DATA D2R/0.017453292519943D0/
C
      IF (LAT .GT. 90.D0 .OR. LAT .LT. -90.D0) THEN
        WRITE (6,500) LAT
  500   FORMAT('LATLON2CART: Latitude value out of range',F20.15)
        X = 1.D20
        Y = 1.D20
        Z = 1.D20
        RETURN
      ENDIF
C
      RLON = NORMANG(D2R*LON)
      RLAT = D2R*(90.D0 - LAT)
      PI = 2.D0*DASIN(1.D0)
      X = DSIN(RLAT)*DCOS(RLON)
      Y = DSIN(RLAT)*DSIN(RLON)
      Z = DCOS(RLAT)
C      
      RETURN
      END
      DOUBLE PRECISION FUNCTION NORMANG(ANGLE)
C
C  Adjusts the input ANGLE (in radians) by adding or subtracting 
C  enough multiples of 2*PI so that the result lies in the range
C  [-PI,PI)
C
      DOUBLE PRECISION ANGLE, PI, RVAL
      INTEGER I
C
      PI = 2.D0*DASIN(1.D0)
C
      RVAL = ANGLE 
      DO 10 I=1,50
        IF (RVAL .LT. -PI) THEN
          RVAL = RVAL+2.D0*PI
        ELSE
          GO TO 30
        ENDIF
   10 CONTINUE
   30 CONTINUE
      DO 20 I=1,50
        IF (RVAL .GE. PI) THEN
          RVAL = RVAL-2.D0*PI
        ELSE
          GO TO 40
        ENDIF
   20 CONTINUE
   40 CONTINUE
C
      NORMANG = RVAL
      RETURN
      END
      DOUBLE PRECISION FUNCTION GCAANGLE(LAT1, LON1, LAT2, LON2,
     +                                   LAT3, LON3, LAT4, LON4)
C
C  Find the (acute) angle between two great circles given two arcs
C  defining the circles - one circle containing the arc between
C  (lat1, lon1) and (lat2,lon2) and the other containing the arc
C  between (lat3, lon3) and (lat4,lon4).
C
      DOUBLE PRECISION LAT1,LON1,LAT2,LON2,LAT3,LON3,LAT4,LON4
      DOUBLE PRECISION PTS1(3,3),PTS2(3,3),ANGPLANES
C
C  Get Cartesian coordinates for all four points.
C
      CALL LATLON2CART(LAT1,LON1,PTS1(1,1),PTS1(1,2),PTS1(1,3))
      CALL LATLON2CART(LAT2,LON2,PTS1(2,1),PTS1(2,2),PTS1(2,3))
      PTS1(3,1) = 0.D0
      PTS1(3,2) = 0.D0
      PTS1(3,3) = 0.D0
C
      CALL LATLON2CART(LAT3,LON3,PTS2(1,1),PTS2(1,2),PTS2(1,3))
      CALL LATLON2CART(LAT4,LON4,PTS2(2,1),PTS2(2,2),PTS2(2,3))
      PTS2(3,1) = 0.D0
      PTS2(3,2) = 0.D0
      PTS2(3,3) = 0.D0
C
      GCAANGLE = ANGPLANES (PTS1, PTS2)
C          
      RETURN
      END
      DOUBLE PRECISION FUNCTION GCDANGLE(LAT1, LON1, LAT2, LON2,
     +                                    LAT3, LON3)
C
C  Find the directed angle in degrees between two great circles that 
C  intersect in a given point.  Given three points on the globe 
C  A = (LAT1,LON1), B = (LAT2,LON2), and C = (LAT3,LON3) this function 
C  finds the angle between the great circles that contain the arcs
C  AB and AC.  The returned angle is positive if C is in the hemisphere 
C  to the "left" of the great circle through A and B, negative otherwise.
C  
      DOUBLE PRECISION D2R,XABGCDP,LAT1,LON1,LAT2,LON2,LAT3,LON3
      PARAMETER (D2R=0.017453292519943D0)
C
      DOUBLE PRECISION PT1(4),PT2(4),PT3(4)
C        
      PT1(1) = DCOS(D2R*LAT1)
      PT1(2) = DSIN(D2R*LAT1)
      PT1(3) = DCOS(D2R*LON1)
      PT1(4) = DSIN(D2R*LON1)
C
      PT2(1) = DCOS(D2R*LAT2)
      PT2(2) = DSIN(D2R*LAT2)
      PT2(3) = DCOS(D2R*LON2)
      PT2(4) = DSIN(D2R*LON2)
C
      PT3(1) = DCOS(D2R*LAT3)
      PT3(2) = DSIN(D2R*LAT3)
      PT3(3) = DCOS(D2R*LON3)
      PT3(4) = DSIN(D2R*LON3)
C
      GCDANGLE = XABGCDP(PT1,PT2,PT3)
C          
      RETURN
      END
      DOUBLE PRECISION FUNCTION ANGPLANES (PTS1, PTS2)
C
C  Finds the angle between two planes, one plane determined
C  by the three points in three space by PTS1 and the second 
C  by the three points in in PTS2.
C
      DOUBLE PRECISION PTS1(3,3), PTS2(3,3), CF1(4), CF2(4)
      DOUBLE PRECISION DOTP,PNORM,THETA,TMP
C
      DOUBLE PRECISION R2D
      DATA R2D / 57.2957795130823D0 /
C
C  Get the coefficients for the equations of the planes.
C
      CALL EQNPLANE(PTS1,CF1)
      CALL EQNPLANE(PTS2,CF2)
C
C  Calculate the cosine of the angle using:
C
C     COS(THETA) = (norm_vct(pts1) dot norm_vct(pts2))/
C                   (norm(pts1) * norm(pts2))
C
      DOTP = 0.D0
      DO 10 I=1,3
        DOTP = DOTP + CF1(I)*CF2(I)
   10 CONTINUE
      PNORM = (DSQRT(CF1(1)*CF1(1) + CF1(2)*CF1(2) + CF1(3)*CF1(3))) *
     +        (DSQRT(CF2(1)*CF2(1) + CF2(2)*CF2(2) + CF2(3)*CF2(3)))
      IF (PNORM .EQ. 0.D0) THEN
        WRITE(6,500)
  500   FORMAT('EQPLANE: Input points must be distinct.')
      ENDIF
      THETA = DOTP/PNORM
      TMP = R2D*DACOS(THETA)
      IF (TMP .GT. 90.D0) TMP = 180.D0-TMP
      ANGPLANES = TMP
C
      RETURN
      END
      SUBROUTINE EQNPLANE(PNT, COEF)
C
C  Finds the coefficients of the equation of a plane:
C
C    A*X + B*Y + C*Z = D
C
C  given three points in three-space in array PNT.
C  The four coefficients are returned in the COEF array.
C
      DOUBLE PRECISION PNT(3,3), COEF(4)
      DOUBLE PRECISION X1, X2, X3, Y1, Y2, Y3, Z1, Z2, Z3
C
      X1 = PNT(1,1)
      X2 = PNT(2,1)
      X3 = PNT(3,1)
      Y1 = PNT(1,2)
      Y2 = PNT(2,2)
      Y3 = PNT(3,2)
      Z1 = PNT(1,3)
      Z2 = PNT(2,3)
      Z3 = PNT(3,3)
C
      COEF(1) =  (Y1*(Z2-Z3) - Z1*(Y2-Y3) + (Y2*Z3 - Z2*Y3))
      COEF(2) = -(X1*(Z2-Z3) - Z1*(X2-X3) + (X2*Z3 - Z2*X3))
      COEF(3) =  (X1*(Y2-Y3) - Y1*(X2-X3) + (X2*Y3 - Y2*X3))
      COEF(4) =  X1*(Y2*Z3 - Z2*Y3) - Y1*(X2*Z3 - Z2*X3) + 
     +             Z1*(X2*Y3 - X3*Y2)       
C
      RETURN
      END 
      DOUBLE PRECISION FUNCTION XABGCDP (AQDP,BQDP,CQDP)
C
C (XABGCDP = Angle Between Great Circles, Double Precision)
C
        DOUBLE PRECISION AQDP(4),BQDP(4),CQDP(4)
C
C This function, given information about the points A, B, and C on the
C sphere, returns the angle, in degrees, from the great circle through
C A and B to the great circle through A and C, positive if the point C
C is in the hemisphere to the "left" of the great circle through A and
C B, negative otherwise.
C
C All variables with names of the form XQDP are four-element arrays
C containing the cosine and sine of the latitude and the cosine and
C sine of the longitude, in that order, of the point X.  Describing
C the point positions in this way makes this routine execute faster
C than if the latitudes and longitudes themselves are used.
C
C Code that is commented out either produces unneeded results or is
C superseded by code that executes faster.
C
        DOUBLE PRECISION RTOD
C       DOUBLE PRECISION XCB1,YCB1,ZCB1
        DOUBLE PRECISION XCB2,YCB2,ZCB2
        DOUBLE PRECISION      YCB3,ZCB3
C       DOUBLE PRECISION XCC1,YCC1,ZCC1
        DOUBLE PRECISION XCC2,YCC2,ZCC2
        DOUBLE PRECISION      YCC3,ZCC3
        DOUBLE PRECISION      YCC4,ZCC4
        DOUBLE PRECISION DNOM,CANG,SANG
C
C Define a multiplicative constant to convert from radians to degrees.
C
        DATA RTOD / 57.2957795130823D0 /
C
C Get XYZ coordinates for B, rotate them by -ALON about the Z axis (which
C would put A on the prime meridian), and then rotate them by ALAT about
C the Y axis (which would put A on the equator).
C
C       XCB1=BQDP(1)*BQDP(3)
C       YCB1=BQDP(1)*BQDP(4)
C       ZCB1=BQDP(2)
C
C       XCB2=XCB1*AQDP(3)+YCB1*AQDP(4)
C       YCB2=YCB1*AQDP(3)-XCB1*AQDP(4)
C       ZCB2=ZCB1
C
        XCB2=BQDP(1)*BQDP(3)*AQDP(3)+BQDP(1)*BQDP(4)*AQDP(4)
        YCB2=BQDP(1)*BQDP(4)*AQDP(3)-BQDP(1)*BQDP(3)*AQDP(4)
        ZCB2=BQDP(2)
C
C       XCB3=XCB2*AQDP(1)+ZCB2*AQDP(2)
        YCB3=YCB2
        ZCB3=ZCB2*AQDP(1)-XCB2*AQDP(2)
C
C Do the same for the point C.
C
C       XCC1=CQDP(1)*CQDP(3)
C       YCC1=CQDP(1)*CQDP(4)
C       ZCC1=CQDP(2)
C
C       XCC2=XCC1*AQDP(3)+YCC1*AQDP(4)
C       YCC2=YCC1*AQDP(3)-XCC1*AQDP(4)
C       ZCC2=ZCC1
C
        XCC2=CQDP(1)*CQDP(3)*AQDP(3)+CQDP(1)*CQDP(4)*AQDP(4)
        YCC2=CQDP(1)*CQDP(4)*AQDP(3)-CQDP(1)*CQDP(3)*AQDP(4)
        ZCC2=CQDP(2)
C
C       XCC3=XCC2*AQDP(1)+ZCC2*AQDP(2)
        YCC3=YCC2
        ZCC3=ZCC2*AQDP(1)-XCC2*AQDP(2)
C
C Now, rotate C about the X axis by an amount which would put B on the
C equator.
C
        IF (YCB3.NE.0D0.OR.ZCB3.NE.0.D0) THEN
          DNOM=SQRT(YCB3*YCB3+ZCB3*ZCB3)
          CANG=YCB3/DNOM
          SANG=ZCB3/DNOM
        ELSE
          CANG=1.D0
          SANG=0.D0
        END IF
C
C       XCC4=XCC3
        YCC4=YCC3*CANG+ZCC3*SANG
        ZCC4=ZCC3*CANG-YCC3*SANG
C
C The angle between the great circles is now easily computed.
C
        IF (YCC4.NE.0.D0.OR.ZCC4.NE.0.D0) THEN
          XABGCDP=RTOD*DATAN2(ZCC4,YCC4)
        ELSE
          XABGCDP=0.D0
        END IF
C
C Done.
C
        RETURN
C
      END
      FUNCTION ICAPDP(PQDP,QQDP,NPIQ)
C
C (ICAPDP = Integer Check Along Polygon, Double Precision)
C
        DOUBLE PRECISION PQDP(4),QQDP(4,NPIQ)
C
C The value of this function is zero if and only if the point P is
C inside the smaller of the two portions of the sphere formed by the
C boundary Q, which is the edge of a "polygon" defined by the points
C (QQSP(I)), for I from 1 to NPIQ.  (The edge of the polygon is formed
C of shortest great circle routes from point to point.)  The first and
C last points of Q should be identical.
C
C All variables with names of the form XQSP are four-element arrays
C containing the cosine and sine of the latitude and the cosine and
C sine of the longitude, in that order, of the point X.  Describing
C the point positions in this way makes this routine execute faster
C than if the latitudes and longitudes themselves are used.
C
        DOUBLE PRECISION ADST,ACAPDP,XADGCDP
C
C If the total angle swept out by a vector tangent to the sphere at the
C point P and pointing in the direction of the shortest great circle
C route to a point tracing Q is near zero, then both the point P and its
C antipodal point P' are in the same area, which must therefore be the
C larger of the two areas created by Q.
C
        IF (ABS(ACAPDP(PQDP,QQDP,NPIQ)).LT.180.D0) THEN
          ICAPDP=1
          RETURN
        END IF
C
C Otherwise, P is in one of the two areas and P' is in the other, so
C we perform a somewhat heuristic test to see if P is in the smaller
C of the two areas: we compute the average distance from P to Q and
C see if it is less than 90 degrees or more than 90 degrees.
C
        ADST=0.D0
C
C Sum over all distinct points of Q:
C
        DO 101 I=1,NPIQ-1
          ADST=ADST+XADGCDP(PQDP,QQDP(1,I))
  101   CONTINUE
C
C Set the function value.
C
        ADST=ADST/DBLE(NPIQ-1)
C
        IF (ADST.LT.90.D0) THEN
          ICAPDP=0
        ELSE
          ICAPDP=1
        END IF
C
        RETURN
      END
      DOUBLE PRECISION FUNCTION ACAPDP (PQDP,QQDP,NPIQ)
C
C (ACAPDP = Angular Change Along Polyline, Double Precision)
C
        DOUBLE PRECISION PQDP(4),QQDP(4,NPIQ)
C
C The value of this function is the total angle swept out by a vector
C tangent to the sphere at the point P and pointing in the direction of
C the shortest great circle route to a point tracing Q, a "polyline"
C defined by the points (QQDP(I)), for I from 1 to NPIQ.  (The edge of
C the polyline is formed of shortest great circle routes from point to
C point.)
C
C If the first and last points of Q are the same, the polyline becomes
C a closed polygon dividing the surface of the sphere into two areas -
C one to the left, and one to the right, of Q.  Let P' denote the point
C opposite P on the sphere.  Note that P' = (-PLAT,PLON+180).  In theory
C (ignoring computational inaccuracies), the function can only have
C three possible values: +360, if P is to the left of Q and P' is to
C the right of Q; -360, if P is to the right of Q and P' is to the
C left of Q; and zero, if both P and P' are on the same side of Q (left
C or right, but we don't know which).
C
C All variables with names of the form XQDP are four-element arrays
C containing the cosine and sine of the latitude and the cosine and
C sine of the longitude, in that order, of the point X.  Describing
C the point positions in this way makes this routine execute faster
C than if the latitudes and longitudes themselves are used.
C
        DOUBLE PRECISION ANCH,XABGCDP
C
        ANCH=0.D0
C
C Trace the edge:
C
        DO 101 I=1,NPIQ-1
          ANCH=ANCH+XABGCDP(PQDP,QQDP(1,I),QQDP(1,I+1))
  101   CONTINUE
C
C Set the function value.
C
        ACAPDP=ANCH
C
        RETURN
C
      END
      INTEGER FUNCTION GCCWISE(RLAT,RLON,NPTS)
C
C  Given NPTS pairs of (RLAT,RLON) values, this function 
C  returns 1 if they are entered in counterclockwise order
C  and 0 if in clockwise order.
C
      DOUBLE PRECISION RLAT(NPTS),RLON(NPTS)
      DOUBLE PRECISION AREA, X, Y, XP, YP
C
C  Check that the input polygon is closed.
C
      IF (RLAT(NPTS).NE.RLAT(1) .OR. RLON(NPTS).NE.RLON(1)) THEN
        WRITE(6,500) 
  500   FORMAT('GCINOUT: The input spherical polygon must be closed.')
        GCCWISE = -1
        RETURN
      ENDIF
C
      X = 0.D0
      Y = 0.D0
      AREA = 0.D0
C
C  Project the points onto a plane touching the globe at 
C  (RLAT(1),RLON(1)) and use the algebraic sign of 
C  the area computation formula.  Since (RLAT(1),RLON(1)) is 
C  projected onto Cartesian coordinate (0,0), the initial X and
C  Y values are 0., as specified above.
C
      DO 10 I=1,NPTS-1
        CALL GPROJ(RLAT(1),RLON(1),RLAT(I+1),RLON(I+1),XP,YP)
        AREA = AREA + X*YP - XP*Y
        X = XP
        Y = YP
   10 CONTINUE
C
      IF (AREA .LE. 0.D0) THEN
        GCCWISE = 0
      ELSE
        GCCWISE = 1
      ENDIF
C
      RETURN
      END
      SUBROUTINE GPROJ(PHI0, LAMBDA0, PHI, LAMBDA, X, Y)
C
C  Find the projection onto the plane tangent to the globe at
C  (PHI0,LAMBDA0) of the point on the globe (PHI,LAMBDA).
C  The projected point is returned in Cartesian coordinate
C  (X,Y).
C
      DOUBLE PRECISION PHI0, LAMBDA0, PHI, LAMBDA, X, Y
      DOUBLE PRECISION SIN0, COS0, SINP, COSP, SIND, COSD, DENOM
      DOUBLE PRECISION D2R
      PARAMETER (D2R = 0.017453292519943D0)
C
      SIN0 = SIN(D2R*PHI0)
      COS0 = COS(D2R*PHI0)
      SINP = SIN(D2R*PHI)
      COSP = COS(D2R*PHI)
      SIND = SIN(D2R*(LAMBDA-LAMBDA0))
      COSD = COS(D2R*(LAMBDA-LAMBDA0))
      DENOM = SIN0*SINP + COS0*COSP*COSD
      X = (COSP*SIND)/DENOM
      Y = (COS0*SINP - SIN0*COSP*COSD)/DENOM
C
      RETURN
      END

C NCLFORTSTART
      SUBROUTINE DVINTH2PNODES(DATI,DATO,HBCOFA,HBCOFB,P0,PLEVI,PLEVO,
     +                    INTYP,ILEV,PSFC,SPVL,KXTRP,NPTS,NLEVI,NLEVIP1,
     +                    NLEVO)
      IMPLICIT NONE
      DOUBLE PRECISION SPVL,DATI,DATO,HBCOFA,HBCOFB,PLEVI,PLEVO,PSFC,P0
      INTEGER INTYP,ILEV,NPTS,NLEVI,NLEVIP1,NLEVO,KXTRP
C
      DIMENSION DATI(NPTS,NLEVI),DATO(NPTS,NLEVO),
     +          HBCOFA(NLEVIP1),HBCOFB(NLEVIP1),PLEVI(NLEVIP1),
     +          PLEVO(NLEVO),PSFC(NPTS)
C NCLEND   
C
C****     THIS ROUTINE INTERPLOATES CCM2/3 HYBRID COORDINATE DATA
C****     TO PRESSURE COORDINATES USING PRESSURE SURFACES AS THE
C****     COORDINATE SURFACE WHERE THE INTERPOLATION IS DONE.  THE
C****     TYPE OF INTERPOLATION IS CURRENTLY A VARIANT OF TRANSFORMED
C****     PRESSURE COORDINATES WITH THE  INTERPOLATION TYPE
C****     SPECIFIED BY INTYP.  ALL HYBRID COORDINATE VALUES ARE
C****     TRANSFORMED TO PRESSURE VALUES. WHERE THE
C****     FORMULA FOR THE PRESSURE OF A HYBRID SURFACE IS;
C****          P(K) = HBCOFA(LEVH,K)*P0 + HBCOFB(LEVH,K)*PSFC
C****     WHERE,
C****          HBCOFA - IS THE "A" OR PRESSURE HYBRID COEF
C****          LEVH   - IS THE LAYER SURFACE (INTERFACE=1 MIDPOINT=2)
C****          P0     - IS THE BASE PRESSURE IN MB
C****          K      - THE LEVEL INDEX (RUNNING FROM TOP TO BOTTOM)
C****          HBCOFB - IS THE "B" OR SIGMA COEFICIENT
C****          P(K)   - IS THE PRESSURE OF A HYBRID SURFACE IN MB.
C****          PSFC   - IS THE SURFACE PRESSURE IN PASCALS
C****                   (MB = .01*PASCALS
C
C****     FOR HYBRID DATA AT LEVEL INTERFACES SINCE THERE IS ONE
C****     MORE VERTICAL LEVEL FOR INTERFACES THAN FOR LEVEL MIDPOINTS
C****     IT IS ASSUNMED THAT THE FIRST INTERFACE LEVEL WITH A DATA
C****     VALUE IS THE SECOND LEVEL FROM THE TOP.
C
C****     ON INPUT-
C****        DATI    - 2 DIMENSIONAL ARRAY (J,KI) CONTAINING DATA
C****                  ON HYBRID SURFACES  WHERE I IS LONGTIUDE, J
C****                  IS LATITUDE AND K IS THE VERTICAL HYBRID
C****                  COORDINATE.  THE VERTICAL DATA RUN TOP TO BOTTOM.
C****                  SIGMA DATA WITH THE DATA ORDERED TOP TO BOTTOM.
C****        HBCOFA  - 2 DIMENSIONAL ARRAY CONTAINING "A" OR PRESSURE
C****                  COEFICIENTS FOR COMPUTING PRESSURE AT A LEVEL.
C****                  ARRAY IS 2XNLEVIP1.  THE 1ST INDEX TAKES ON
C****                  THE VALUE OF EITHER
C****                   1 - FOR LEVEL INTERFACES (OR 1/2 LEVELS) OR;
C****                   2 - FOR LEVEL MIDPOINTS  (OR FULL LEVELS WHERE
C****                       VIRTUALLY ALL VARIABLES ARE LOCATED)
C****                  NOTE THAT COEFICIENTS ARE SCALED TO YIELD A
C****                  PRESSURE IN MB.  THEY ARE ORDERED FROM TOP
C****                  OF THE MODEL TO THE BOTTOM.
C****        HBCOFB  - SAME AS HCOFA BUT FOR THE "B" OR SIGMA COEFICIENT
C****        P0      - BASE PRESSURE IN MB FOR COMPUTING PRESSURE
C****                  OF A HYBRID COORDINATE LEVEL
C****        PLEVI -  1 DIMENSIONAL ARRAY TO HOLD PRESSURE VALUES
C****                  OF HYBRID SURFACES FOR A VERTICAL COLUMN
C****                  SLICE
C****        PLEVO   - LIST OF OUTPUT PRESSURE SURFACES IN MB
C****                  LOW TO HIGH PRESSURE
C****        INTYP   - A FLAG INDICATING INTERPOLATION FOR EACH
C****                  FIELD (1 - LINEAR,2 - LOG ,3 - LOG LOG)
C****                  WHERE EACH INTERPOLATION IS DONE IN TRANSFORMED
C****                  PRESSURE COORDINATES.
C****        ILEV    - FLAG TO SHOW WHETHER FIELD IS ON LEVEL INTERFACE
C****                  1/2 LEVEL WHICH HAS A VALUE OF 1 OR A LEVEL
C****                  MIDPOINT A FULL LEVEL (WHERE ALMOST ALL VARIABLES
C****                  ARE LOCATED
C****        PSFC    - MODEL SFC PRESSURE IN PASCALS (WILL BE CONVERTED
C****                  TO MB)
C****        VCOLI   - ARRAY TO STORE A LONGITUDINAL VERTICAL SLICE OF
C****                  INPUT DATA (IMAX BY NLEVI).
C****        VCOLO   - SAME BUT FOR OUTPUT DATA (IMAX BY NLEVO)
C****        IMAX    - LONGITUDINAL DIMENSION OF THE DATA.
C****        NLAT    - LATITUDINAL DIMENSION OF THE DATA.
C****        NLEVI   - NO. OF LEVELS FOR THE HYBRID DATA
C****        NLEVIP1 - NLEVI + 1
C****        NLEVO   - NUMBER OF OUTPUT LEVELS FOR PRESSURE DATA
C****        KXTRP   - FLAG WHICH INDICATES WHETHER OR NOT
C****                  EXTRAPOLATION WILL BE USED WHEN THE OUTPUT
C****                  PRESSURE SURFACE IS BELOW THE LOWEST LEVEL
C****                  OF THE MODEL.
C****                     0 - DON'T EXTRAPOLATE USE SPECIAL VALUE SPVL
C****                     1 - EXTRAPOLATE DATA
C****        SPVL    - SPECIAL VALUE TO USE WHEN DATA IS NOT
C****                  EXTRAPOLATED
C
C****     ON OUTPUT-
C****        DATO  - 3 DIMENSIONAL ARRAY TO HOLD DATA INTERPOLATED
C****                TO PRESSURE SURFACES.
C
      DOUBLE PRECISION A2LN,A1
      INTEGER J,K,KP,KPI,IPRINT
C
C
C
C****     STATEMENT FCN. FOR DOUBLE ALOG. INTERP ON PRESSURE SURFACES
C****     PRESUMES PRESSURE IS IN MB
C
      A2LN(A1) = DLOG(DLOG(A1+2.72D0))
C
C****     STATEMENT FCN. FOR DOUBLE ALOG. INTERP ON SIGMA SURFACES.
C****     SETS UP ROUGH UPPER BPOUND SIMILAR TO STATEMENT FCN FOR
C****     PRESSURE. I.E.    FIXED VALUE LN(LN(P) = LN(LN(FIXED VAL)
C****     AT .001 SIGMA OR ABOUT 1 MB
C
C     A2LN(A1)=ALOG(ALOG(A1+1.001))

C
C****
C****
C
      DO 70 J = 1,NPTS
c ==========================================================
           if (psfc(j).eq.spvl) then
               do k=1,nlevo
                  dato(j,k) = spvl
               end do
               go to 60  
           end if
c ===========================================================

C
C****     GET PRESSURE VALUES FOR HYBRID SURFACES FOR THIS POINT
C****     AND FOR THE TYPE OF MODEL SURFACE THE DATA IS ON.
C****     INTERFACE DATA STARTS AT THE SECOND INTERFACE LEVEL SO
C****     IF THE DATA IS ON THOSE LEVELS START THE
C
              DO K = 1,NLEVI
                  KPI = K
                  PLEVI(K) = (HBCOFA(KPI)*P0) +
     +                       HBCOFB(KPI)* (PSFC(J)*.01D0)
              END DO
              IPRINT = 1
C      IF (I.EQ.1.AND.J.EQ.1.AND.IPRINT.EQ.1) THEN
C         PRINT 601
C  601    FORMAT(/,' PRINTOUT FROM VINTHB ')
C         PRINT 602,J,NLEVI,NLEVO,IMAX,ILEV
C  602    FORMAT(' J,NLEVI,NLEVO,IMAX,ILEV ',6I4)
C         PRINT 603,PSFC(J),P0
C  603    FORMAT(' PSFC,P0 ',1P2E12.5)
C         CALL PRNT('HBCOFA',HBCOFA,2,NLEVIP1,1,1)
C         CALL PRNT('HBCOFB',HBCOFB,2,NLEVIP1,1,1)
C         CALL PRNT(' PLEVI',PLEVI,NLEVI,1,1,1)
C         CALL PRNT(' PLEVO',PLEVO,NLEVO,1,1,1)
C      ENDIF
C
C****     CALL P2HBD TO PERFORM VERTICAL INTERP. THEN TRANSFER DATA TO
C****     THE OUTPUT ARRAY
C
              DO 50 K = 1,NLEVO
C
C****     CHECK FOR BRACKETING LEVEL KP WILL BE THE INPUT LEVEL THAT
C****     IS THE UPPER PORTION OF 2 INPUT BRACKETING LEVELS.
C
C****     IF BRANCH FOR MODEL TOP
C
                  IF (PLEVO(K).LE.PLEVI(1)) THEN
                      KP = 1
                      GO TO 30
C
C****     IF BRANCH FOR LEVEL BELOW LOWEST HYBRID LEVEL
C
                  ELSE IF (PLEVO(K).GT.PLEVI(NLEVI)) THEN
                      IF (KXTRP.EQ.0) THEN
                          DATO(J,K) = SPVL
                          GO TO 40
                      ELSE
                          KP = NLEVI - 1
                          GO TO 30
                      END IF
C
C****     IF BRANCH FOR TO CHECK IF OUTPOT LEVEL IN BETWEEN
C****     2 LOWEST HYBRID LEVELS
C
                  ELSE IF (PLEVO(K).GE.PLEVI(NLEVI-1)) THEN
                      KP = NLEVI - 1
                      GO TO 30
C
C****     IF BRANCH FOR MODEL INTERIOR
C****     LOOP THROUGH INPUT LEVELS TILL YOU ARE BRACKETING
C****     OUTPUT LEVEL
C
                  ELSE
                      KP = 0
   20                 CONTINUE
                      KP = KP + 1
                      IF (PLEVO(K).LE.PLEVI(KP+1)) GO TO 30
                      IF (KP.GT.NLEVI) THEN
                          WRITE (6,FMT=25) KP,NLEVI
   25                     FORMAT (' KP.GT.KLEVI IN P2HBD.  KP,KLEVI= ',
     +                           2I5)
C            CALL PRNT(' PLEVI',PLEVI,NLEVIP1,1,1,1)
C            CALL PRNT(' PLEVO',PLEVO,NLEVO,1,1,1)
C            CALL ABORT(' KP.GT.NLEVI IN P2HBD')
                      END IF
                      GO TO 20
                  END IF
   30             CONTINUE
C
C****     LEVEL BRACKETED PICK TYPE OF INTERP.
C
C
C****     LINEAR INTERP.
C
                  IF (INTYP.EQ.1) THEN
                      DATO(J,K) = DATI(J,KP) +
     +                              (DATI(J,KP+1)-DATI(J,KP))*
     +                              (PLEVO(K)-PLEVI(KP))/
     +                              (PLEVI(KP+1)-PLEVI(KP))
C
C****     LOG INTERPOLATION.
C
                  ELSE IF (INTYP.EQ.2) THEN
                      IPRINT = 1
C      IF (I.EQ.1.AND.IPRINT.EQ.1) THEN
C         PRINT 101,J,K,KP,ILEV
C  101    FORMAT('  IN S2HBD J,K,KP,ILEV ',5I3)
C         PRINT 102,DATI(J,KP),DATI(J,KP+1),PLEVO(K),
C     *             PLEVI(KP),PLEVI(KP+1)
C  102    FORMAT(' DATI(KP),DATI(KP+1),PLEVO(K),',
C     *          'PLEVI(KP),PLEVI(KP+1) ',
C     *          /,1X,1P5E12.5)
C      ENDIF
                      DATO(J,K) = DATI(J,KP) +
     +                              (DATI(J,KP+1)-DATI(J,KP))*
     +                              DLOG(PLEVO(K)/PLEVI(KP))/
     +                              DLOG(PLEVI(KP+1)/PLEVI(KP))
C
C****     FOR LOG LOG INTERP. NOTE A2LN IS A STATEMENT FCN.
C
                  ELSE IF (INTYP.EQ.3) THEN
                      DATO(J,K) = DATI(J,KP) +
     +                              (DATI(J,KP+1)-DATI(J,KP))*
     +                              (A2LN(PLEVO(K))-A2LN(PLEVI(KP)))/
     +                              (A2LN(PLEVI(KP+1))-A2LN(PLEVI(KP)))
                  END IF
   40             CONTINUE
C
   50         CONTINUE
   60     CONTINUE
   70 CONTINUE
      RETURN
      END

      SUBROUTINE CSYR2K( UPLO, TRANS, N, K, ALPHA, A, LDA, B, LDB,
     $                   BETA, C, LDC )
*     .. Scalar Arguments ..
      CHARACTER*1        UPLO, TRANS
      INTEGER            N, K, LDA, LDB, LDC
      COMPLEX            ALPHA, BETA
*     .. Array Arguments ..
      COMPLEX            A( LDA, * ), B( LDB, * ), C( LDC, * )
*     ..
*
*  Purpose
*  =======
*
*  CSYR2K  performs one of the symmetric rank 2k operations
*
*     C := alpha*A*B' + alpha*B*A' + beta*C,
*
*  or
*
*     C := alpha*A'*B + alpha*B'*A + beta*C,
*
*  where  alpha and beta  are scalars,  C is an  n by n symmetric matrix
*  and  A and B  are  n by k  matrices  in the  first  case  and  k by n
*  matrices in the second case.
*
*  Parameters
*  ==========
*
*  UPLO   - CHARACTER*1.
*           On  entry,   UPLO  specifies  whether  the  upper  or  lower
*           triangular  part  of the  array  C  is to be  referenced  as
*           follows:
*
*              UPLO = 'U' or 'u'   Only the  upper triangular part of  C
*                                  is to be referenced.
*
*              UPLO = 'L' or 'l'   Only the  lower triangular part of  C
*                                  is to be referenced.
*
*           Unchanged on exit.
*
*  TRANS  - CHARACTER*1.
*           On entry,  TRANS  specifies the operation to be performed as
*           follows:
*
*              TRANS = 'N' or 'n'    C := alpha*A*B' + alpha*B*A' +
*                                         beta*C.
*
*              TRANS = 'T' or 't'    C := alpha*A'*B + alpha*B'*A +
*                                         beta*C.
*
*           Unchanged on exit.
*
*  N      - INTEGER.
*           On entry,  N specifies the order of the matrix C.  N must be
*           at least zero.
*           Unchanged on exit.
*
*  K      - INTEGER.
*           On entry with  TRANS = 'N' or 'n',  K  specifies  the number
*           of  columns  of the  matrices  A and B,  and on  entry  with
*           TRANS = 'T' or 't',  K  specifies  the number of rows of the
*           matrices  A and B.  K must be at least zero.
*           Unchanged on exit.
*
*  ALPHA  - COMPLEX         .
*           On entry, ALPHA specifies the scalar alpha.
*           Unchanged on exit.
*
*  A      - COMPLEX          array of DIMENSION ( LDA, ka ), where ka is
*           k  when  TRANS = 'N' or 'n',  and is  n  otherwise.
*           Before entry with  TRANS = 'N' or 'n',  the  leading  n by k
*           part of the array  A  must contain the matrix  A,  otherwise
*           the leading  k by n  part of the array  A  must contain  the
*           matrix A.
*           Unchanged on exit.
*
*  LDA    - INTEGER.
*           On entry, LDA specifies the first dimension of A as declared
*           in  the  calling  (sub)  program.   When  TRANS = 'N' or 'n'
*           then  LDA must be at least  max( 1, n ), otherwise  LDA must
*           be at least  max( 1, k ).
*           Unchanged on exit.
*
*  B      - COMPLEX          array of DIMENSION ( LDB, kb ), where kb is
*           k  when  TRANS = 'N' or 'n',  and is  n  otherwise.
*           Before entry with  TRANS = 'N' or 'n',  the  leading  n by k
*           part of the array  B  must contain the matrix  B,  otherwise
*           the leading  k by n  part of the array  B  must contain  the
*           matrix B.
*           Unchanged on exit.
*
*  LDB    - INTEGER.
*           On entry, LDB specifies the first dimension of B as declared
*           in  the  calling  (sub)  program.   When  TRANS = 'N' or 'n'
*           then  LDB must be at least  max( 1, n ), otherwise  LDB must
*           be at least  max( 1, k ).
*           Unchanged on exit.
*
*  BETA   - COMPLEX         .
*           On entry, BETA specifies the scalar beta.
*           Unchanged on exit.
*
*  C      - COMPLEX          array of DIMENSION ( LDC, n ).
*           Before entry  with  UPLO = 'U' or 'u',  the leading  n by n
*           upper triangular part of the array C must contain the upper
*           triangular part  of the  symmetric matrix  and the strictly
*           lower triangular part of C is not referenced.  On exit, the
*           upper triangular part of the array  C is overwritten by the
*           upper triangular part of the updated matrix.
*           Before entry  with  UPLO = 'L' or 'l',  the leading  n by n
*           lower triangular part of the array C must contain the lower
*           triangular part  of the  symmetric matrix  and the strictly
*           upper triangular part of C is not referenced.  On exit, the
*           lower triangular part of the array  C is overwritten by the
*           lower triangular part of the updated matrix.
*
*  LDC    - INTEGER.
*           On entry, LDC specifies the first dimension of C as declared
*           in  the  calling  (sub)  program.   LDC  must  be  at  least
*           max( 1, n ).
*           Unchanged on exit.
*
*
*  Level 3 Blas routine.
*
*  -- Written on 8-February-1989.
*     Jack Dongarra, Argonne National Laboratory.
*     Iain Duff, AERE Harwell.
*     Jeremy Du Croz, Numerical Algorithms Group Ltd.
*     Sven Hammarling, Numerical Algorithms Group Ltd.
*
*
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     .. External Subroutines ..
      EXTERNAL           XERBLA
*     .. Intrinsic Functions ..
      INTRINSIC          MAX
*     .. Local Scalars ..
      LOGICAL            UPPER
      INTEGER            I, INFO, J, L, NROWA
      COMPLEX            TEMP1, TEMP2
*     .. Parameters ..
      COMPLEX            ONE
      PARAMETER        ( ONE  = ( 1.0E+0, 0.0E+0 ) )
      COMPLEX            ZERO
      PARAMETER        ( ZERO = ( 0.0E+0, 0.0E+0 ) )
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      IF( LSAME( TRANS, 'N' ) )THEN
         NROWA = N
      ELSE
         NROWA = K
      END IF
      UPPER = LSAME( UPLO, 'U' )
*
      INFO = 0
      IF(      ( .NOT.UPPER               ).AND.
     $         ( .NOT.LSAME( UPLO , 'L' ) )      )THEN
         INFO = 1
      ELSE IF( ( .NOT.LSAME( TRANS, 'N' ) ).AND.
     $         ( .NOT.LSAME( TRANS, 'T' ) )      )THEN
         INFO = 2
      ELSE IF( N  .LT.0               )THEN
         INFO = 3
      ELSE IF( K  .LT.0               )THEN
         INFO = 4
      ELSE IF( LDA.LT.MAX( 1, NROWA ) )THEN
         INFO = 7
      ELSE IF( LDB.LT.MAX( 1, NROWA ) )THEN
         INFO = 9
      ELSE IF( LDC.LT.MAX( 1, N     ) )THEN
         INFO = 12
      END IF
      IF( INFO.NE.0 )THEN
         CALL XERBLA( 'CSYR2K', INFO )
         RETURN
      END IF
*
*     Quick return if possible.
*
      IF( ( N.EQ.0 ).OR.
     $    ( ( ( ALPHA.EQ.ZERO ).OR.( K.EQ.0 ) ).AND.( BETA.EQ.ONE ) ) )
     $   RETURN
*
*     And when  alpha.eq.zero.
*
      IF( ALPHA.EQ.ZERO )THEN
         IF( UPPER )THEN
            IF( BETA.EQ.ZERO )THEN
               DO 20, J = 1, N
                  DO 10, I = 1, J
                     C( I, J ) = ZERO
   10             CONTINUE
   20          CONTINUE
            ELSE
               DO 40, J = 1, N
                  DO 30, I = 1, J
                     C( I, J ) = BETA*C( I, J )
   30             CONTINUE
   40          CONTINUE
            END IF
         ELSE
            IF( BETA.EQ.ZERO )THEN
               DO 60, J = 1, N
                  DO 50, I = J, N
                     C( I, J ) = ZERO
   50             CONTINUE
   60          CONTINUE
            ELSE
               DO 80, J = 1, N
                  DO 70, I = J, N
                     C( I, J ) = BETA*C( I, J )
   70             CONTINUE
   80          CONTINUE
            END IF
         END IF
         RETURN
      END IF
*
*     Start the operations.
*
      IF( LSAME( TRANS, 'N' ) )THEN
*
*        Form  C := alpha*A*B' + alpha*B*A' + C.
*
         IF( UPPER )THEN
            DO 130, J = 1, N
               IF( BETA.EQ.ZERO )THEN
                  DO 90, I = 1, J
                     C( I, J ) = ZERO
   90             CONTINUE
               ELSE IF( BETA.NE.ONE )THEN
                  DO 100, I = 1, J
                     C( I, J ) = BETA*C( I, J )
  100             CONTINUE
               END IF
               DO 120, L = 1, K
                  IF( ( A( J, L ).NE.ZERO ).OR.
     $                ( B( J, L ).NE.ZERO )     )THEN
                     TEMP1 = ALPHA*B( J, L )
                     TEMP2 = ALPHA*A( J, L )
                     DO 110, I = 1, J
                        C( I, J ) = C( I, J ) + A( I, L )*TEMP1 +
     $                                          B( I, L )*TEMP2
  110                CONTINUE
                  END IF
  120          CONTINUE
  130       CONTINUE
         ELSE
            DO 180, J = 1, N
               IF( BETA.EQ.ZERO )THEN
                  DO 140, I = J, N
                     C( I, J ) = ZERO
  140             CONTINUE
               ELSE IF( BETA.NE.ONE )THEN
                  DO 150, I = J, N
                     C( I, J ) = BETA*C( I, J )
  150             CONTINUE
               END IF
               DO 170, L = 1, K
                  IF( ( A( J, L ).NE.ZERO ).OR.
     $                ( B( J, L ).NE.ZERO )     )THEN
                     TEMP1 = ALPHA*B( J, L )
                     TEMP2 = ALPHA*A( J, L )
                     DO 160, I = J, N
                        C( I, J ) = C( I, J ) + A( I, L )*TEMP1 +
     $                                          B( I, L )*TEMP2
  160                CONTINUE
                  END IF
  170          CONTINUE
  180       CONTINUE
         END IF
      ELSE
*
*        Form  C := alpha*A'*B + alpha*B'*A + C.
*
         IF( UPPER )THEN
            DO 210, J = 1, N
               DO 200, I = 1, J
                  TEMP1 = ZERO
                  TEMP2 = ZERO
                  DO 190, L = 1, K
                     TEMP1 = TEMP1 + A( L, I )*B( L, J )
                     TEMP2 = TEMP2 + B( L, I )*A( L, J )
  190             CONTINUE
                  IF( BETA.EQ.ZERO )THEN
                     C( I, J ) = ALPHA*TEMP1 + ALPHA*TEMP2
                  ELSE
                     C( I, J ) = BETA *C( I, J ) +
     $                           ALPHA*TEMP1 + ALPHA*TEMP2
                  END IF
  200          CONTINUE
  210       CONTINUE
         ELSE
            DO 240, J = 1, N
               DO 230, I = J, N
                  TEMP1 = ZERO
                  TEMP2 = ZERO
                  DO 220, L = 1, K
                     TEMP1 = TEMP1 + A( L, I )*B( L, J )
                     TEMP2 = TEMP2 + B( L, I )*A( L, J )
  220             CONTINUE
                  IF( BETA.EQ.ZERO )THEN
                     C( I, J ) = ALPHA*TEMP1 + ALPHA*TEMP2
                  ELSE
                     C( I, J ) = BETA *C( I, J ) +
     $                           ALPHA*TEMP1 + ALPHA*TEMP2
                  END IF
  230          CONTINUE
  240       CONTINUE
         END IF
      END IF
*
      RETURN
*
*     End of CSYR2K.
*
      END

C
C $Id: mapbd.f,v 1.31 2008-09-18 12:31:28 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MAPBD
C
C Calling this do-nothing subroutine forces "ld" to load the following
C block data routine (but only if they are in the same ".f" file).
C
        RETURN
C
      END
CNOSPLIT
      BLOCKDATA MAPBDX
C
        PARAMETER (MNAI=8000)
C
C The common block MAPCM0 contains mathematical constants.
C
        COMMON /MAPCM0/  COS1,DTOR,DTRH,OOPI,PI,PIOF,PIOT,RTDD,RTOD,
     +                   SROT,SIN1,TOPI,TSRT
        DOUBLE PRECISION COS1,DTOR,DTRH,OOPI,PI,PIOF,PIOT,RTDD,RTOD,
     +                   SROT,SIN1,TOPI,TSRT
        SAVE   /MAPCM0/
C
C The common block MAPCM1 contains transformation constants.
C
        COMMON /MAPCM1/  COSO,COSR,SINO,SINR,IPRJ,IROD
        DOUBLE PRECISION COSO,COSR,SINO,SINR
        INTEGER          IPRJ,IROD
        SAVE   /MAPCM1/
C
C The common block MAPCM2 contains area-specification variables.
C
        COMMON /MAPCM2/  BLAM,BLOM,PEPS,SLAM,SLOM,UCEN,UMAX,UMIN,UOFF,
     +                   URNG,VCEN,VMAX,VMIN,VOFF,VRNG,ISSL
        DOUBLE PRECISION BLAM,BLOM,PEPS,SLAM,SLOM,UCEN,UMAX,UMIN,UOFF,
     +                   URNG,VCEN,VMAX,VMIN,VOFF,VRNG
        INTEGER          ISSL
        SAVE   /MAPCM2/
C
C The common block MAPCM3 contains parameters having to do with reading
C the data for outlines.
C
        COMMON /MAPCM3/  ITPN,NOUT,NPTS,IGID,IDLS,IDRS,BLAG,SLAG,BLOG,
     +                   SLOG,PNTS(200),IDOS(4)
        INTEGER          ITPN,NOUT,NPTS,IGID,IDLS,IDRS,IDOS
        REAL             BLAG,SLAG,BLOG,SLOG,PNTS
        SAVE   /MAPCM3/
C
C The common block MAPCM4 contains most of the input parameters.
C
        COMMON /MAPCM4/  GRDR,GRID,GRLA,GRLO,GRPO,OTOL,PDRE,PLA1,PLA2,
     +                   PLA3,PLA4,PLB1,PLB2,PLB3,PLB4,PLNO,PLTO,ROTA,
     +                   SRCH,XLOW,XROW,YBOW,YTOW,IDOT,IDSH,IDTL,ILCW,
     +                   ILTS,JPRJ,ELPF,INTF,LBLF,PRMF
        DOUBLE PRECISION GRDR,GRID,GRLA,GRLO,GRPO,OTOL,PDRE,PLA1,PLA2,
     +                   PLA3,PLA4,PLB1,PLB2,PLB3,PLB4,PLNO,PLTO,ROTA,
     +                   SRCH,XLOW,XROW,YBOW,YTOW
        INTEGER          IDOT,IDSH,IDTL,ILCW,ILTS,JPRJ
        LOGICAL          ELPF,INTF,LBLF,PRMF
        SAVE   /MAPCM4/
C
C The common block MAPCM5 contains various lists ("dictionaries") of
C two-character codes required by EZMAP for parameter-setting.
C
        COMMON /MAPCM5/  DDCT(5),DDCL(5),LDCT(6),LDCL(6),PDCT(19),
     +                   PDCL(19)
        CHARACTER*2      DDCT,DDCL,LDCT,LDCL,PDCT,PDCL
        SAVE   /MAPCM5/
C
C The common block MAPCM6 contains quantities needed by the routines
C MDPTRA and MDPTRI.
C
        COMMON /MAPCM6/  UCNM,UMNM,UMXM,URNM,VCNM,VMNM,VMXM,VRNM,ELPM
        DOUBLE PRECISION UCNM,UMNM,UMXM,URNM,VCNM,VMNM,VMXM,VRNM
        LOGICAL ELPM
        SAVE   /MAPCM6/
C
C The common block MAPCM7 contains parameters describing the portion of
C the plotter frame being used.
C
        COMMON /MAPCM7/  ULOW,UROW,VBOW,VTOW
        DOUBLE PRECISION ULOW,UROW,VBOW,VTOW
        SAVE   /MAPCM7/
C
C The common block MAPCM8 contains parameters set by MDPTRN and used by
C MAPIT in handling "cross-over" problems.
C
        COMMON /MAPCM8/  P,Q,R
        DOUBLE PRECISION P,Q,R
        SAVE   /MAPCM8/
C
C The common block MAPCMA contains values which are used to position
C dots along dotted outlines and to avoid drawing vectors which are
C too short.
C
        COMMON /MAPCMA/  DATL,DBTD,DDTS,DPLT,DPSQ,DSCA,DSSQ
        DOUBLE PRECISION DATL,DBTD,DDTS,DPLT,DPSQ,DSCA,DSSQ
        SAVE   /MAPCMA/
C
C The common block MAPCMC contains variables for MDPBLA.
C
        COMMON /MAPCMC/  IGI1,IGI2,NCRA,NOVS,XCRA(100),YCRA(100)
        INTEGER          IGI1,IGI2,NCRA,NOVS
        REAL             XCRA,YCRA
        SAVE   /MAPCMC/
C
C The common block MAPCMP contains the buffers in which the X and Y
C coordinates of points are collected for an eventual call to POINTS.
C
        COMMON /MAPCMP/  NPTB,XPTB(50),YPTB(50)
        INTEGER          NPTB
        REAL             XPTB,YPTB
        SAVE   /MAPCMP/
C
C The common block MAPCMQ contains quantities specifying the color
C indices to be used for various portions of the plot.
C
        COMMON /MAPCMQ/  ICIN(8)
        INTEGER          ICIN
        SAVE   /MAPCMQ/
C
C The common block MAPCMW contains variables affecting the definitions
C of the equirectangular, cylindrical equal-area, and Winkel tripel
C projections.
C
        COMMON /MAPCMW/  CSLS,CSLT,SLTD,ISLT
        DOUBLE PRECISION CSLS,CSLT,SLTD
        INTEGER ISLT
        SAVE  /MAPCMW/
C
C The common blocks MAPCMX and MAPCMY contain variables used by the new
C routines in EZMAPB (implementing access to the new dataset created in
C early 1998).  MAPCMX contains integer variables and MAPCMY contains
C character variables.
C
        COMMON /MAPCMX/  IATY(MNAI),ISCI(MNAI),IPAR(MNAI)
        INTEGER          IATY,ISCI,IPAR
        SAVE   /MAPCMX/
C
        COMMON /MAPCMY/  NAME(MNAI),FLNS
        CHARACTER*64     NAME
        CHARACTER*512    FLNS
        SAVE   /MAPCMY/
C
C The common block MAPRGD contains two arrays of color indices and
C a couple of point-interpolation values used by the routines that plot
C data from the RANGS/GSHHS dataset.
C
        COMMON /MAPRGD/  ICOL(5),ICSF(5),IDPF,LCRA,NILN,NILT,OLAT,OLON
        INTEGER          ICOL,ICSF,IDPF,LCRA,NILN,NILT
        REAL             OLAT,OLON
        SAVE   /MAPRGD/
C
C The common block MAPSAT contains parameters for the satellite-view
C projection.
C
        COMMON /MAPSAT/  ALFA,BETA,DCSA,DCSB,DSNA,DSNB,SALT,SSMO,SRSS
        DOUBLE PRECISION ALFA,BETA,DCSA,DCSB,DSNA,DSNB,SALT,SSMO,SRSS
        SAVE   /MAPSAT/
C
C Below are descriptions of the variables in each of the common blocks,
C together with data statements giving default values to those variables
C which need default variables.
C
C Variables in MAPCM0:
C
C COS1 is the cosine of 1 degree; DTOR is a conversion constant to go
C from degrees to radians; DTRH is a conversion constant to go from
C degrees to radians, halved; OOPI is one over pi; PI is pi; PIOT is
C pi over two; PIOF is pi over four; RTDD is a conversion constant to go
C from radians to degrees, doubled; RTOD is a conversion constant to go
C from radians to degrees; SIN1 is the sine of 1 degree; SROT is the
C square root of two; TOPI is two over pi; and TSRT is two times the
C square root of two.
C
        DATA COS1 / .999847695156390D0 /
        DATA DTOR / .017453292519943D0 /
        DATA DTRH / .008726646259971D0 /
        DATA OOPI / .318309886183790D0 /
        DATA PI   / 3.14159265358979D0 /
        DATA PIOT / 1.57079632679489D0 /
        DATA PIOF / .785398163397445D0 /
        DATA RTDD / 114.591559026165D0 /
        DATA RTOD / 57.2957795130823D0 /
        DATA SIN1 / .017452406437283D0 /
        DATA SROT / 1.41421356237310D0 /
        DATA TOPI / .636619772367581D0 /
        DATA TSRT / 2.82842712474619D0 /
C
C Variables in MAPCM1:
C
C IPRJ is an integer between 0 and 25, specifying what projection is
C currently in use.  The following table defines the meanings of the
C various possible values of IPRJ.  In the table, the word "arbitrary"
C is used to indicate the the projection may be centered at any point
C on the globe and the word "fast-path" is used to indicate that the
C projection is centered at (0,0) on the globe (which usually speeds
C up the evaluation of the equations).  Projections 16 through 24 are
C fast-path versions of projections 7 through 15.
C
C     IPRJ    Projection Selected                         Type
C     ----    ------------------------------------        -----------
C       0     (UT) USGS transformations                   Various 
C       1     (LC) Lambert Conformal                      Conical 
C       2     (ST) Stereographic                          Azimuthal
C       3     (OR or SA) Orthographic or Satellite        Azimuthal
C       4     (LE) Lambert Equal-Area                     Azimuthal
C       5     (GN) Gnomonic                               Azimuthal
C       6     (AE) Azimuthal Equidistant                  Azimuthal
C       7     (CE) Cylindrical Equidistant (arbitrary)    Cylindrical
C       8     (ME) Mercator (arbitrary)                   Cylindrical
C       9     (MT) Mollweide-type (arbitrary)             Cylindrical
C      10     (RO) Robinson (arbitrary)                   Cylindrical
C      11     (EA) Cylindrical Equal-Area (arbitrary)     Cylindrical
C      12     (AI) Aitoff (arbitrary)                     Mixed
C      13     (HA) Hammer (arbitrary)                     Mixed
C      14     (TM) True Mollweide (arbitrary)             Mixed
C      15     (WT) Winkel tripel (arbitrary)              Mixed
C      16     (CE) Cylindrical Equidistant (fast-path)    Cylindrical
C      17     (ME) Mercator (fast-path)                   Cylindrical
C      18     (MT) Mollweide-type (fast-path)             Cylindrical
C      19     (RO) Robinson (fast-path)                   Cylindrical
C      20     (EA) Cylindrical Equal-Area (fast-path)     Cylindrical
C      21     (AI) Aitoff (fast-path)                     Mixed
C      22     (HA) Hammer (fast-path)                     Mixed
C      23     (MO) True Mollweide (fast-path)             Mixed
C      24     (WT) Winkel tripel (fast-path)              Mixed
C      25     (RM) Rotated Mercator (fast-path)           Cylindrical
C
C IROD is a flag which, if non-zero, says that we have to use double
C precision at selected points.  SINO, COSO, SINR, and COSR are
C projection variables computed by MDPINT for use by MDPTRN.
C
      DATA IROD / 0 /
C
C Variables in MAPCM2:
C
C UMIN, UMAX, VMIN, and VMAX specify the limits of the rectangle to be
C drawn, in projection space.  UCEN, VCEN, URNG, and VRNG are computed
C by MDPINT for use when the map perimeter is made elliptical (by
C setting the flag ELPF).  BLAM, SLAM, BLOM, and SLOM are respectively
C the biggest latitude, the smallest latitude, the biggest longitude,
C and the smallest longitude on the map.  They are used in MDPGRD and
C in MDPLOT to make the drawing of grids and outlines more efficient.
C ISSL is a flag set by MDPINT to indicate the success (ISSL=1) or
C failure (ISSL=0) of the code setting BLAM, SLAM, BLOM, and SLOM;
C failure indicates that default values were used and that it is not
C safe to take the efficient paths in MDPGRD.  PEPS is set by MDPINT
C for use in MAPIT in testing for cross-over problems.  UMIN and UMAX
C are given default values to prevent code in MDSETI and MDSETR from
C blowing up when PDRE is set prior to the first call to MDPINT.
C (08/07/2001) UOFF and VOFF are being added to this common block to
C support the use of U/V coordinates from which an offset has been
C subtracted to avoid loss of resolution when zooming in on a small
C portion of a projection.
C
      DATA UMIN,UMAX / 0.D0,1.D0 /
C
C Variables in MAPCM3:
C
C ITPN is the unit number of the "tape" from which outline data is to
C be read.  NOUT is the number of the outline to be used; the values 0
C through 5 imply 'NO', 'CO', 'US', 'PS', and 'PO', respectively; thus,
C if NOUT is zero, no outlines are to be used, and, if it is non-zero,
C it is the number of the "file" to be read from unit ITPN.  NPTS, just
C after a read, is the number of elements read into PNTS; it is then
C divided by 2 to become the number of points defined by the group just
C read.  IGID is an identifier for the group, so that, for example, one
C can distinguish a group belonging to a international boundary from
C one belonging to a U.S. state boundary.  IDLS and IDRS are integers
C identifying the areas to the left and right of the edge defined by
C the group of points just read.  BLAG, SLAG, BLOG, and SLOG specify
C the biggest and smallest latitude and the biggest and smallest
C longitude of the points in the group, so that, in some cases at least,
C one can decide quickly not to bother with the group.  PNTS contains
C NPTS coordinate pairs, each consisting of a latitude and a longitude,
C in degrees.  IDOS is an array of area-identifier offsets; for a given
C EZMAP dataset with index NOUT, the area identifiers in the dataset
C are biased by the addition of IDOS(NOUT) in order to generate a
C unique value.
C
      DATA ITPN,NOUT / 1,1 /
C
      DATA IDOS / 0,222,439,1003 /
C
C Variables in MAPCM4:
C
C INTF is a flag whose value at any given time indicates whether the
C package EZMAP is in need of initialization (.TRUE.) or not (.FALSE.).
C JPRJ is an integer between 0 and 13 indicating the type of projection
C currently in use.  PLTO, PLNO, and ROTA are the pole latitude and
C longitude and the rotation angle specified by the last user call to
C MAPROJ.  ILTS is an integer between 1 and 6, specifying how the limits
C of the map are to be chosen.  PLA1-4 and PLB1-4 are the values given
C by the user for PLM1(1), PLM2(1), ..., PLM1(2), PLM2(2), ..., in the
C last call to MAPSET.  PDRE is the plotter resolution - effectively,
C the number of addressable points in the x direction.  GRID, if zero,
C turns off the drawing of the lat/lon grid; if non-zero, it specifies
C the desired default spacing between grid lines, in degrees.  IDSH is
C the desired dash pattern (16-bit binary) for grid lines.  IDOT is a
C flag selecting solid outlines (0) or dotted outlines (1).  LBLF is
C a logical flag indicating whether the international date line, the
C equator, the Greenwich meridian, and the poles are to be labelled or
C not.  PRMF is a logical flag indicating whether or not a perimeter
C is to be drawn.  ELPF is a logical flag indicating whether the map
C perimeter is to be rectangular (.FALSE.) or elliptical (.TRUE.).
C XLOW, XROW, YBOW, and YTOW are fractions between 0. and 1. specifying
C the position of area of the plotter frame in which the map is to be
C put; the map is centered in this area and made as large as possible.
C IDTL is a flag specifying that MAPIT should draw solid outlines (0)
C or dotted outlines (1).  GRDR and SRCH are measured in degrees and
C lie in the range from .001 to 10.  GRDR specifies the resolution with
C which the grid is to be drawn and SRCH the accuracy with which the
C latitude/longitude limits of the map are to be found.  ILCW is the
C character width for characters in the label, as required for use in a
C call to PWRIT.  GRLA and GRLO specify the desired spacings of latitude
C and longitude grid lines, respectively (in degrees); if either is less
C than or equal to zero, the value of GRID is used instead.  GRPO
C specifies the way in which the lat/lon grid is to be modified near
C the poles on projections which map the poles into single points; it
C has a value of the form 1000*GRP1+GRP2, where GRP1 is an integer
C between 0 and 90 and GRP2 is a positive real between 0 and 360.  If
C GRP1 is zero, all the latitude lines of the grid are drawn; if GRP1
C is non-zero, latitude lines at latitudes from GRP1 to 90, inclusive
C (South or North) are omitted.   If GRP2 is zero, no longitude lines
C are drawn near the poles; if GRP2 is non-zero, only longitude lines
C of the grid at multiples of GRP2 are drawn near the poles.  Examples:
C GRPO=0 says "draw all the latitude lines of the grid; omit longitude
C lines of the grid near the poles."  GRPO=1 says "draw entire grid."
C GRPO=75045 says "suppress latitude lines of the grid above 75N and
C below 75S; near the poles, draw longitude lines of the grid only at
C multiples of 45 degrees."  The default is GRPO=90, which says "draw
C all latitude lines of the grid; near the poles, omit longitude lines
C of the grid except those at multiples of 90 degrees".  OTOL is an
C "offset tolerance" (new in 08/08/2001): when the absolute value of the
C difference of the U values at the left and right edges of a map is
C less than OTOL times the absolute value of their sum, or the absolute
C value of the difference of the V values at the bottom and top edges of
C a map is less than OTOL times the absolute value of their sum, MDPINT
C will initialize the projection to use offset values of U and V, thus
C avoiding a loss of precision.
C
      DATA INTF,JPRJ,PLTO,PLNO,ROTA,ILTS,PLA1,PLA2,PLA3,PLA4,PLB1,PLB2 /
     1   .TRUE.,   7,0.D0,0.D0,0.D0,   1,0.D0,0.D0,0.D0,0.D0,0.D0,0.D0 /
C
      DATA PLB3,PLB4,    PDRE, GRID, IDSH,IDOT, LBLF , PRMF ,  ELPF  /
     1     0.D0,0.D0,32768.D0,10.D0,21845,   0,.TRUE.,.TRUE.,.FALSE. /
C
      DATA IDTL,  OTOL /
     1        0,.001D0 /
C
      DATA XLOW,XROW,YBOW,YTOW / .05D0,.95D0,.05D0,.95D0 /
C
      DATA GRDR,SRCH / 1.D0,1.D0 /
C
      DATA ILCW / 1 /
C
      DATA GRLA,GRLO,GRPO / 0.D0,0.D0,90.D0 /
C
C Variables in MAPCM5:
C
C DDCT is the dictionary of available datasets, LDCT the dictionary of
C map limit definition types, and PDCT the dictionary of map projection
C names.  DDCL, LDCL, and PDCL are lower-case equivalents.
C
      DATA DDCT
     +        / 'NO','CO','US','PS','PO' /
      DATA DDCL
     +        / 'no','co','us','ps','po' /
C
      DATA LDCT
     +        / 'MA','CO','PO','AN','LI','GR' /
      DATA LDCL
     +        / 'ma','co','po','an','li','gr' /
C
      DATA PDCT
     +        / 'UT','LC','ST','OR','LE','GN','AE','CE','ME','MT',
     +          'RO','EA','AI','HA','MO','WT','SV','ER','RM' /
      DATA PDCL
     +        / 'ut','lc','st','or','le','gn','ae','ce','me','mt',
     +          'ro','ea','ai','ha','mo','wt','sv','er','rm' /
C
C Variables in MAPCM6:
C
C All of the variables in this common block are basically copies of
C variables in other common blocks (perhaps somewhat modified) for use
C by transformation routines.  ELPM is a copy of the logical variable
C ELPF, which indicates whether the map perimeter is to be rectangular
C or elliptical.  UMNM, UMXM, UMXM, and VMNM specify a rectangular
C perimeter just a little outside the one specified by UMIN, UMAX, VMIN,
C and VMAX.  UCNM, VCNM, URNM, and VRNM are just copies of the values
C UCEN, VCEN, URNG, and VRNG, respectively; they are used when the map
C perimeter is elliptical.  None of these parameters needs a default
C value.
C
C Variables in MAPCM7:
C
C ULOW, UROW, VBOW, and VTOW define the fraction of the plotter frame
C to be occupied by the map - they may be thought of as the first four
C arguments of the SET call or, in the GKS scheme, as the viewport.
C They are computed by MDPINT.  ULOW and UROW are given default values
C to prevent code in MDSETI and MDSETR from blowing up when PDRE is
C set prior to the first call to MDPINT.
C
      DATA ULOW,UROW / 0.D0,1.D0 /
C
C Variables in MAPCM8:
C
C P, Q, and R are set by MDPTRN each time it maps (RLAT,RLON) to (U,V).
C Q is always equal to V, but P is not always equal to U.  Instead, it
C is a value of U from an intermediate step in the projection process.
C For the Lambert conformal conic, P is the distance, in longitude, from
C the central meridian.  For the cylindrical projections, P is a value
C of U prior to multiplication by a function of V shrinking the map
C toward a vertical bisector.  They are all used by MAPIT, while drawing
C lines from point to point, to detect "cross-over" (a jump from one
C side of the map to the other, caused by the projection's having slit
C the globe along some half of a great circle and laid it open with the
C two sides of the slit at opposite ends of the map).
C
C Variables in MAPCMA:
C
C DPLT is the mimimum vector length; MAPIT requires two points to be at
C least DPLT plotter units apart before it will join them with a vector.
C DDTS is the desired distance in plotter units between dots in a dotted
C outline.  These values are relative to the "plotter resolution" PDRE;
C DPLT/PDRE is a fraction of the plotter frame.  DSCA is the ratio of
C the length of a vector, measured in plotter units, to the length of
C the same vector, measured in the u/v plane.  Thus, given a vector of
C length D in the u/v plane, D*DSCA is its length in plotter units.
C DPSQ and DSSQ are the squares of DPLT and DSCA, respectively.  DBTD
C is the distance, in the u/v plane, between two dots DDTS plotter
C units apart.  DPLT and DDTS have the values given below and are not
C reset by the code; DSCA, DPSQ, DSSQ, and DBTD are computed by MDPINT.
C DSCA is given a default value only to keep the routines MDSETI and
C MDSETR from blowing up when DDTS is set prior to any call to MDPINT.
C DATL is used by MAPIT and MDPVP to keep track of where the next point
C along a curve should go.
C
      DATA DPLT,DDTS,DSCA / 1.D0,96.D0,1.D0 /
C
C Variables in MAPCMC:
C
C IGI1 is the group identifier for the principal edge group - the one
C containing all the real map boundaries.  IGI2 is the group identifier
C for the dummy group that splits the map into vertical strips.  NOVS
C is the number of vertical strips to be used.  XCRA and YCRA hold X
C and Y coordinates for delivery to AREDAM.  NCRA is the number of
C coordinates in XCRA and YCRA.
C
      DATA IGI1,IGI2,NOVS,NCRA / 1,2,1,0 /
C
C Variables in MAPCMP:
C
C NPTB is the number of points whose coordinates have been collected in
C the arrays XPTB and YPTB for eventual output by a call to POINTS.
C
      DATA NPTB / 0 /
C
C Variables in MAPCMQ:
C
C The array ICIN specifies color indices to be used for the perimeter,
C for the grid, for labelling, for limbs, for the continental outlines,
C for the U.S. state outlines, and for international political outlines.
C See the routine MDPCHI.  The default values are all negative, to say
C that color should not be set.
C
      DATA ICIN / -1,-1,-1,-1,-1,-1,-1,-1 /
C
C Variables in MAPCMW:
C
C SLTD is a "standard latitude" parameter affecting the behavior of
C three projections: the equirectangular, the cylindrical equal-area,
C and the Winkel tripel.  CSLT is the cosine of SLTD and CSLS is the
C square of CSLT.  When IPRJ is 7, ISLT is 0 if the cylindrical
C equidistant projection is to be used or 1 if the equirectangular
C projection is to be used.
C
      DATA CSLS,CSLT,SLTD,ISLT / 1.D0,1.D0,-1.D0,0 /
C
C Variables in MAPCMX and MAPCMY:
C
C For each I from 1 to MNAI, IATY(I), if non-zero, is the type of the
C area with area identifier I, ISCI(I) is a suggested color index for
C that area, IPAR(I) is the index of the parent area, and NAME(I) is
C the name of the area.  FLNS is the full name of the file from which
C the data in IATY, ISCI, IPAR, and NAME were read; it allows us to
C avoid re-reading the data when that isn't necessary.
C
      DATA (IATY(I),I=1,MNAI) / MNAI*0   /
      DATA (ISCI(I),I=1,MNAI) / MNAI*0   /
      DATA (IPAR(I),I=1,MNAI) / MNAI*0   /
      DATA (NAME(I),I=1,MNAI) / MNAI*' ' /
C
      DATA FLNS / ' ' /
C
C Variables in MAPRGD:
C
C The array ICOL contains five color indices to be used in drawing
C the outlines of polygons of the five different types defined by the
C RANGS/GSHHS data, and the array ICSF contains five color indices to
C be used in filling the polygons.  The routine MDRGSC may be called
C by the user to set these colors and the routine MDRGGC may be called
C to retrieve them.  The indices of each of these arrays are assigned
C to features as follows: 1 => ocean; 2 => land; 3 => lake; 4 =>
C island in lake; and 5 => pond on island.  NILN and NILT determine
C how many points are to be interpolated per degree of longitude or
C degree of latitude, respectively, along those parts of the filled
C polygons lying along the edges of 1-degree cells.  The object of this
C interpolation is to reduce the probability of having little gaps
C along the seams between adjacent cells.  (If it is not done and a
C projection is used that maps the 1-degree cells into patches whose
C edges are neither horizontal nor vertical, the gaps can be quite
C noticeable.)  OLAT and OLON are temporary variables in which some
C values are passed from MPRGSX to MPRGFA; they do not need to be
C initialized.  IDPF is a flag indicating how the RANGS/GSHHS data
C to be processed.  IDPF = 0 means that the data are to be used in
C are unedited form (MDRGSQ is called).  IDPF = 1 means that the data
C are to be edited and that polygon fills are to be done using direct
C calls to GFA, without using an area map (MDRGSX is called).  IDPF =
C 2 means that the data are to be edited and that fills are to be done
C using an area map (MDRGSX is called).
C
      DATA ICOL / 1 , 1 , 1 , 1 , 1 /
      DATA ICSF / 0 , 1 , 0 , 1 , 0 /
C
      DATA IDPF / 1 /
C
      DATA NILN,NILT / 50 , 50 /
C
C Variables in MAPSAT:
C
C The absolute value of SALT, if greater than 1, serves as a flag that
C a satellite-view projection is to be used in place of an orthographic
C projection; its value is the distance of the satellite from the center
C of the earth, in units of earth radii.  In this case, SSMO is the
C square of SALT minus 1 and SRSS is the square root of SSMO.  If ALFA
C is zero, the projection shows the view seen by a satellite looking
C straight at the center of the earth; call this the basic satellite
C view.  If ALFA is non-zero, it and BETA are angles, in degrees,
C determining where the line of sight of the projection is.  If E is
C at the center of the earth, S is at the satellite, and P is a point
C along the line of sight, then ALFA measures the angle ESP.  If O is
C the point at the origin of the basic satellite view and P is the
C projection of the line of sight, then BETA measures the angular
C distance from the positive u axis to the line OP, positive if
C measured counter-clockwise.  DSNA, DCSA, DSNB, and DCSB are sines
C and cosines of ALFA and BETA.  The sign of SALT says whether a normal
C projection (positive) or an extended projection (negative) is to be
C used.  The latter makes it easier to overlay CONREC output on one of
C these projections, by projecting points out of sight around the limb
C to points just outside the limb on the projected view.
C
      DATA SALT,ALFA,BETA / 0.D0,0.D0,0.D0 /
C
      DATA DSNA,DCSA,DSNB,DCSB / 0.D0,1.D0,0.D0,1.D0 /
C
      END
CNOSPLIT
      BLOCKDATA MAPBDQ
C
C The common block MAQCMN contains only those variables that are needed
C for MDQTRA, MDQTRI, and MDQTRN to carry out the transformation that
C was in effect at the time MDQINI was called.  All of them are copies
C of variables in other common blocks and are described above, in the
C commenting for BLOCKDATA MAPBDX.  They are given default values here
C mostly to protect the transformation routines from blowing up if they
C are erroneously called prior to a call to MDQINI.
C
        COMMON /MAQCMN/  ALFA,COSO,COSR,CSLS,CSLT,DCSA,DCSB,DSNA,DSNB,
     +                   DTOR,DTRH,OOPI,PLNO,  PI,PIOT,ROTA,RTDD,RTOD,
     +                   SALT,SINO,SINR,SRSS,SSMO,TOPI,UCNM,UMNM,UMXM,
     +                   UOFF,URNM,VCNM,VMNM,VMXM,VOFF,VRNM,UTPA,IPRF,
     +                   IPRJ,IROD,ELPM
        DOUBLE PRECISION ALFA,COSO,COSR,CSLS,CSLT,DCSA,DCSB,DSNA,DSNB,
     +                   DTOR,DTRH,OOPI,PLNO,  PI,PIOT,ROTA,RTDD,RTOD,
     +                   SALT,SINO,SINR,SRSS,SSMO,TOPI,UCNM,UMNM,UMXM,
     +                   UOFF,URNM,VCNM,VMNM,VMXM,VOFF,VRNM,UTPA(15)
C
        INTEGER IPRF,IPRJ,IROD
C
        LOGICAL ELPM
C
        SAVE   /MAQCMN/
C
        DATA ALFA / 0.D0 /
        DATA COSO / 1.D0 /
        DATA COSR / 1.D0 /
        DATA CSLS / 1.D0 /
        DATA CSLT / 1.D0 /
        DATA DCSA / 1.D0 /
        DATA DCSB / 1.D0 /
        DATA DSNA / 0.D0 /
        DATA DSNB / 0.D0 /
        DATA DTOR / .017453292519943D0 /
        DATA DTRH / .008726646259971D0 /
        DATA ELPM / .FALSE. /
        DATA IPRJ / 16 /
        DATA IROD / 1 /
        DATA OOPI / .318309886183790D0 /
        DATA PLNO / 0.D0 /
        DATA PI   / 3.14159265358979D0 /
        DATA PIOT / 1.57079632679489D0 /
        DATA ROTA / 0.D0 /
        DATA RTDD / 114.591559026165D0 /
        DATA RTOD / 57.2957795130823D0 /
        DATA SALT / 0.D0 /
        DATA SINO / 0.D0 /
        DATA SINR / 0.D0 /
        DATA SRSS / 0.D0 /
        DATA SSMO / 0.D0 /
        DATA TOPI / .636619772367581D0 /
        DATA UCNM / 0.D0 /
        DATA UMNM / -180.000360D0 /
        DATA UMXM / +180.000360D0 /
        DATA UOFF / 0.D0 /
        DATA URNM / 0.D0 /
        DATA VCNM / 0.D0 /
        DATA VMNM / -90.000180D0 /
        DATA VMXM / +90.000180D0 /
        DATA VOFF / 0.D0 /
        DATA VRNM / 0.D0 /
C
        DATA IPRF / 0 /
C
        DATA UTPA / 15*0.D0 /
C
      END

C
C $Id: mdplbl.f,v 1.9 2008-09-18 00:42:17 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MDPLBL
C
C Declare required common blocks.  See MAPBDX for descriptions of these
C common blocks and the variables in them.
C
        COMMON /MAPCM0/  COS1,DTOR,DTRH,OOPI,PI,PIOF,PIOT,RTDD,RTOD,
     +                   SROT,SIN1,TOPI,TSRT
        DOUBLE PRECISION COS1,DTOR,DTRH,OOPI,PI,PIOF,PIOT,RTDD,RTOD,
     +                   SROT,SIN1,TOPI,TSRT
        SAVE   /MAPCM0/
C
        COMMON /MAPCM1/  COSO,COSR,SINO,SINR,IPRJ,IROD
        DOUBLE PRECISION COSO,COSR,SINO,SINR
        INTEGER          IPRJ,IROD
        SAVE   /MAPCM1/
C
        COMMON /MAPCM2/  BLAM,BLOM,PEPS,SLAM,SLOM,UCEN,UMAX,UMIN,UOFF,
     +                   URNG,VCEN,VMAX,VMIN,VOFF,VRNG,ISSL
        DOUBLE PRECISION BLAM,BLOM,PEPS,SLAM,SLOM,UCEN,UMAX,UMIN,UOFF,
     +                   URNG,VCEN,VMAX,VMIN,VOFF,VRNG
        INTEGER          ISSL
        SAVE   /MAPCM2/
C
        COMMON /MAPCM4/  GRDR,GRID,GRLA,GRLO,GRPO,OTOL,PDRE,PLA1,PLA2,
     +                   PLA3,PLA4,PLB1,PLB2,PLB3,PLB4,PLNO,PLTO,ROTA,
     +                   SRCH,XLOW,XROW,YBOW,YTOW,IDOT,IDSH,IDTL,ILCW,
     +                   ILTS,JPRJ,ELPF,INTF,LBLF,PRMF
        DOUBLE PRECISION GRDR,GRID,GRLA,GRLO,GRPO,OTOL,PDRE,PLA1,PLA2,
     +                   PLA3,PLA4,PLB1,PLB2,PLB3,PLB4,PLNO,PLTO,ROTA,
     +                   SRCH,XLOW,XROW,YBOW,YTOW
        INTEGER          IDOT,IDSH,IDTL,ILCW,ILTS,JPRJ
        LOGICAL          ELPF,INTF,LBLF,PRMF
        SAVE   /MAPCM4/
C
        COMMON /MAPCMA/  DATL,DBTD,DDTS,DPLT,DPSQ,DSCA,DSSQ
        DOUBLE PRECISION DATL,DBTD,DDTS,DPLT,DPSQ,DSCA,DSSQ
        SAVE   /MAPCMA/
C
C Declare local variables.
C
        DOUBLE PRECISION RLAT,RLON,U,UMAXX,UMINX,UOLD,V,VMAXX,VMINX,VOLD
        INTEGER          I,ILAT,ILON
C
C Check for an uncleared prior error.
C
        IF (ICFELL('MDPLBL - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C If EZMAP needs initialization, do it.
C
        IF (INTF) THEN
          CALL MDPINT
          IF (ICFELL('MDPLBL',2).NE.0) RETURN
        END IF
C
C If requested, letter key meridians and poles.
C
        IF (LBLF) THEN
C
C Reset the color index, dotting, and dash pattern for labelling.
C
          CALL MDPCHI (3,1,0)
          IF (ICFELL('MDPLBL',3).NE.0) RETURN
C
C First, the North pole.
C
          CALL MDPTRA (90.D0,0.D0,U,V)
          IF (ICFELL('MDPLBL',4).NE.0) RETURN
          IF (U.LT.1.D12) THEN
            CALL WTSTR (REAL(U),REAL(V),'NP',ILCW,0,0)
            IF (ICFELL('MDPLBL',5).NE.0) RETURN
          END IF
C
C Then, the South pole.
C
          CALL MDPTRA (-90.D0,0.D0,U,V)
          IF (ICFELL('MDPLBL',6).NE.0) RETURN
          IF (U.LT.1.D12) THEN
            CALL WTSTR (REAL(U),REAL(V),'SP',ILCW,0,0)
            IF (ICFELL('MDPLBL',7).NE.0) RETURN
          END IF
C
C The equator.
C
          RLON=PLNO-10.D0
C
          DO 101 ILON=1,36
            RLON=RLON+10.D0
            CALL MDPTRA (0.D0,RLON,U,V)
            IF (ICFELL('MDPLBL',8).NE.0) RETURN
            IF (U.LT.1.D12) THEN
              CALL WTSTR (REAL(U),REAL(V),'EQ',ILCW,0,0)
              IF (ICFELL('MDPLBL',9).NE.0) RETURN
              GO TO 102
            END IF
  101     CONTINUE
C
C The Greenwich meridian.
C
  102     DO 103 ILAT=75,-75,-10
            RLAT=DBLE(ILAT)
            CALL MDPTRA (RLAT,0.D0,U,V)
            IF (ICFELL('MDPLBL',10).NE.0) RETURN
            IF (U.LT.1.D12) THEN
              CALL WTSTR (REAL(U),REAL(V),'GM',ILCW,0,0)
              IF (ICFELL('MDPLBL',11).NE.0) RETURN
              GO TO 104
            END IF
  103     CONTINUE
C
C International date line.
C
  104     DO 105 ILAT=75,-75,-10
            RLAT=DBLE(ILAT)
            CALL MDPTRA (RLAT,180.D0,U,V)
            IF (ICFELL('MDPLBL',12).NE.0) RETURN
            IF (U.LT.1.D12) THEN
              CALL WTSTR (REAL(U),REAL(V),'ID',ILCW,0,0)
              IF (ICFELL('MDPLBL',13).NE.0) RETURN
              GO TO 106
            END IF
  105     CONTINUE
C
C Restore the color index, dotting, and dash pattern.
C
  106     CALL MDPCHI (-3,0,0)
          IF (ICFELL('MDPLBL',14).NE.0) RETURN
C
        END IF
C
C Draw perimeter, if requested.
C
        IF (PRMF) THEN
C
C Reset the color index, dotting, and dash pattern for the perimeter.
C
          CALL MDPCHI (1,0,IOR(ISHIFT(32767,1),1))
          IF (ICFELL('MDPLBL',15).NE.0) RETURN
C
C The perimeter is either an ellipse or a rectangle, depending on ELPF.
C
          IF (ELPF) THEN
            U=.9999D0*URNG
            V=0.D0
            IF (IDTL.EQ.0) THEN
              CALL FRSTD (REAL(UCEN+U),REAL(VCEN))
              IF (ICFELL('MDPLBL',16).NE.0) RETURN
            ELSE
              DATL=0.D0
            END IF
            DO 110 I=1,360
              UOLD=U
              VOLD=V
              U=COS1*UOLD-SIN1*VOLD
              V=SIN1*UOLD+COS1*VOLD
              CALL MDPVP (UCEN+UOLD,VCEN+VOLD*VRNG/URNG,
     +                    UCEN+U   ,VCEN+V   *VRNG/URNG)
              IF (ICFELL('MDPLBL',17).NE.0) RETURN
  110       CONTINUE
          ELSE
            UMINX=UMIN+.9999D0*(UMAX-UMIN)
            UMAXX=UMAX-.9999D0*(UMAX-UMIN)
            VMINX=VMIN+.9999D0*(VMAX-VMIN)
            VMAXX=VMAX-.9999D0*(VMAX-VMIN)
            IF (IDTL.EQ.0) THEN
              CALL FRSTD (REAL(UMINX),REAL(VMINX))
              IF (ICFELL('MDPLBL',18).NE.0) RETURN
            ELSE
              DATL=0.D0
            END IF
            CALL MDPVP (UMINX,VMINX,UMAXX,VMINX)
            IF (ICFELL('MDPLBL',19).NE.0) RETURN
            CALL MDPVP (UMAXX,VMINX,UMAXX,VMAXX)
            IF (ICFELL('MDPLBL',20).NE.0) RETURN
            CALL MDPVP (UMAXX,VMAXX,UMINX,VMAXX)
            IF (ICFELL('MDPLBL',21).NE.0) RETURN
            CALL MDPVP (UMINX,VMAXX,UMINX,VMINX)
            IF (ICFELL('MDPLBL',22).NE.0) RETURN
          END IF
C
C Restore the color index, dotting, and dash pattern.
C
          CALL MDPCHI (-1,0,0)
          IF (ICFELL('MDPLBL',23).NE.0) RETURN
C
        END IF
C
C Done.
C
        RETURN
C
      END

c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by UCAR                 .
c  .                                                             .
c  .       University Corporation for Atmospheric Research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                         SPHEREPACK                          .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c
c
c ... file vlapec.f
c
c     this file includes documentation and code for
c     subroutine vlapec          i
c
c ... files which must be loaded with vlapec.f
c
c     sphcom.f, hrfft.f, vhaec.f, vhsec.f
c
c
C*PL*ERROR* Comment line too long
c     subroutine vlapec(nlat,nlon,ityp,nt,vlap,wlap,idvw,jdvw,br,bi,cr,ci,
c    +mdbc,ndbc,wvhsec,lvhsec,work,lwork,ierror)
c
c
C*PL*ERROR* Comment line too long
c     subroutine vlapec computes the vector laplacian of the vector field
C*PL*ERROR* Comment line too long
c     (v,w) in (vlap,wlap) (see the definition of the vector laplacian at
c     the output parameter description of vlap,wlap below).  w and wlap
c     are east longitudinal components of the vectors.  v and vlap are
c     colatitudinal components of the vectors.  br,bi,cr, and ci are the
C*PL*ERROR* Comment line too long
c     vector harmonic coefficients of (v,w).  these must be precomputed by
C*PL*ERROR* Comment line too long
c     vhaec and are input parameters to vlapec.  the laplacian components
C*PL*ERROR* Comment line too long
c     in (vlap,wlap) have the same symmetry or lack of symmetry about the
C*PL*ERROR* Comment line too long
c     equator as (v,w).  the input parameters ityp,nt,mdbc,nbdc must have
C*PL*ERROR* Comment line too long
c     the same values used by vhaec to compute br,bi,cr, and ci for (v,w).
c     vlap(i,j) and wlap(i,j) are given on the sphere at the colatitude
c
c            theta(i) = (i-1)*pi/(nlat-1)
c
c     for i=1,...,nlat and east longitude
c
c            lambda(j) = (j-1)*2*pi/nlon
c
c     for j=1,...,nlon.
c
c
c     input parameters
c
c     nlat   the number of colatitudes on the full sphere including the
c            poles. for example, nlat = 37 for a five degree grid.
c            nlat determines the grid increment in colatitude as
c            pi/(nlat-1).  if nlat is odd the equator is located at
c            grid point i=(nlat+1)/2. if nlat is even the equator is
c            located half way between points i=nlat/2 and i=nlat/2+1.
c            nlat must be at least 3. note: on the half sphere, the
c            number of grid points in the colatitudinal direction is
c            nlat/2 if nlat is even or (nlat+1)/2 if nlat is odd.
c
c     nlon   the number of distinct longitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater
c            than zero. the axisymmetric case corresponds to nlon=1.
c            the efficiency of the computation is improved when nlon
c            is a product of small prime numbers.
c
C*PL*ERROR* Comment line too long
c     ityp   this parameter should have the same value input to subroutine
c            vhaec to compute the coefficients br,bi,cr, and ci for the
c            vector field (v,w).  ityp is set as follows:
c
C*PL*ERROR* Comment line too long
c            = 0  no symmetries exist in (v,w) about the equator. (vlap,wlap)
C*PL*ERROR* Comment line too long
c                 is computed and stored on the entire sphere in the arrays
C*PL*ERROR* Comment line too long
c                 vlap(i,j) and wlap(i,j) for i=1,...,nlat and j=1,...,nlon.
c
c
C*PL*ERROR* Comment line too long
c            = 1  no symmetries exist in (v,w) about the equator. (vlap,wlap)
C*PL*ERROR* Comment line too long
c                 is computed and stored on the entire sphere in the arrays
C*PL*ERROR* Comment line too long
c                 vlap(i,j) and wlap(i,j) for i=1,...,nlat and j=1,...,nlon.
C*PL*ERROR* Comment line too long
c                 the vorticity of (v,w) is zero so the coefficients cr and
C*PL*ERROR* Comment line too long
c                 ci are zero and are not used.  the vorticity of (vlap,wlap)
c                 is also zero.
c
c
C*PL*ERROR* Comment line too long
c            = 2  no symmetries exist in (v,w) about the equator. (vlap,wlap)
C*PL*ERROR* Comment line too long
c                 is computed and stored on the entire sphere in the arrays
C*PL*ERROR* Comment line too long
c                 vlap(i,j) and wlap(i,j) for i=1,...,nlat and j=1,...,nlon.
C*PL*ERROR* Comment line too long
c                 the divergence of (v,w) is zero so the coefficients br and
C*PL*ERROR* Comment line too long
c                 bi are zero and are not used.  the divergence of (vlap,wlap)
c                 is also zero.
c
C*PL*ERROR* Comment line too long
c            = 3  w is antisymmetric and v is symmetric about the equator.
C*PL*ERROR* Comment line too long
c                 consequently wlap is antisymmetric and vlap is symmetric.
c                 (vlap,wlap) is computed and stored on the northern
C*PL*ERROR* Comment line too long
c                 hemisphere only.  if nlat is odd, storage is in the arrays
C*PL*ERROR* Comment line too long
c                 vlap(i,j),wlap(i,j) for i=1,...,(nlat+1)/2 and j=1,...,nlon.
c                 if nlat is even, storage is in the arrays vlap(i,j),
c                 wlap(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
c
C*PL*ERROR* Comment line too long
c            = 4  w is antisymmetric and v is symmetric about the equator.
C*PL*ERROR* Comment line too long
c                 consequently wlap is antisymmetric and vlap is symmetric.
c                 (vlap,wlap) is computed and stored on the northern
C*PL*ERROR* Comment line too long
c                 hemisphere only.  if nlat is odd, storage is in the arrays
C*PL*ERROR* Comment line too long
c                 vlap(i,j),wlap(i,j) for i=1,...,(nlat+1)/2 and j=1,...,nlon.
c                 if nlat is even, storage is in the arrays vlap(i,j),
c                 wlap(i,j) for i=1,...,nlat/2 and j=1,...,nlon.  the
C*PL*ERROR* Comment line too long
c                 vorticity of (v,w) is zero so the coefficients cr,ci are
c                 zero and are not used. the vorticity of (vlap,wlap) is
c                 also zero.
c
C*PL*ERROR* Comment line too long
c            = 5  w is antisymmetric and v is symmetric about the equator.
C*PL*ERROR* Comment line too long
c                 consequently wlap is antisymmetric and vlap is symmetric.
c                 (vlap,wlap) is computed and stored on the northern
C*PL*ERROR* Comment line too long
c                 hemisphere only.  if nlat is odd, storage is in the arrays
C*PL*ERROR* Comment line too long
c                 vlap(i,j),wlap(i,j) for i=1,...,(nlat+1)/2 and j=1,...,nlon.
c                 if nlat is even, storage is in the arrays vlap(i,j),
c                 wlap(i,j) for i=1,...,nlat/2 and j=1,...,nlon.  the
c                 divergence of (v,w) is zero so the coefficients br,bi
C*PL*ERROR* Comment line too long
c                 are zero and are not used. the divergence of (vlap,wlap)
c                 is also zero.
c
c
C*PL*ERROR* Comment line too long
c            = 6  w is symmetric and v is antisymmetric about the equator.
C*PL*ERROR* Comment line too long
c                 consequently wlap is symmetric and vlap is antisymmetric.
c                 (vlap,wlap) is computed and stored on the northern
C*PL*ERROR* Comment line too long
c                 hemisphere only.  if nlat is odd, storage is in the arrays
C*PL*ERROR* Comment line too long
c                 vlap(i,j),wlap(i,j) for i=1,...,(nlat+1)/2 and j=1,...,nlon.
c                 if nlat is even, storage is in the arrays vlap(i,j),
c                 wlap(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
c
C*PL*ERROR* Comment line too long
c            = 7  w is symmetric and v is antisymmetric about the equator.
C*PL*ERROR* Comment line too long
c                 consequently wlap is symmetric and vlap is antisymmetric.
c                 (vlap,wlap) is computed and stored on the northern
C*PL*ERROR* Comment line too long
c                 hemisphere only.  if nlat is odd, storage is in the arrays
C*PL*ERROR* Comment line too long
c                 vlap(i,j),wlap(i,j) for i=1,...,(nlat+1)/2 and j=1,...,nlon.
c                 if nlat is even, storage is in the arrays vlap(i,j),
c                 wlap(i,j) for i=1,...,nlat/2 and j=1,...,nlon.  the
C*PL*ERROR* Comment line too long
c                 vorticity of (v,w) is zero so the coefficients cr,ci are
c                 zero and are not used. the vorticity of (vlap,wlap) is
c                 also zero.
c
C*PL*ERROR* Comment line too long
c            = 8  w is symmetric and v is antisymmetric about the equator.
C*PL*ERROR* Comment line too long
c                 consequently wlap is symmetric and vlap is antisymmetric.
c                 (vlap,wlap) is computed and stored on the northern
C*PL*ERROR* Comment line too long
c                 hemisphere only.  if nlat is odd, storage is in the arrays
C*PL*ERROR* Comment line too long
c                 vlap(i,j),wlap(i,j) for i=1,...,(nlat+1)/2 and j=1,...,nlon.
c                 if nlat is even, storage is in the arrays vlap(i,j),
c                 wlap(i,j) for i=1,...,nlat/2 and j=1,...,nlon.  the
c                 divergence of (v,w) is zero so the coefficients br,bi
C*PL*ERROR* Comment line too long
c                 are zero and are not used. the divergence of (vlap,wlap)
c                 is also zero.
c
c
C*PL*ERROR* Comment line too long
c     nt     nt is the number of vector fields (v,w).  some computational
c            efficiency is obtained for multiple fields.  in the program
c            that calls vlapec, the arrays vlap,wlap,br,bi,cr and ci
C*PL*ERROR* Comment line too long
c            can be three dimensional corresponding to an indexed multiple
c            vector field.  in this case multiple vector synthesis will
C*PL*ERROR* Comment line too long
c            be performed to compute the vector laplacian for each field.
C*PL*ERROR* Comment line too long
c            the third index is the synthesis index which assumes the values
C*PL*ERROR* Comment line too long
c            k=1,...,nt.  for a single synthesis set nt=1.  the description
C*PL*ERROR* Comment line too long
c            of the remaining parameters is simplified by assuming that nt=1
c            or that all arrays are two dimensional.
c
C*PL*ERROR* Comment line too long
c   idvw     the first dimension of the arrays vlap and wlap as it appears
C*PL*ERROR* Comment line too long
c            in the program that calls vlapec.  if ityp=0,1, or 2  then idvw
C*PL*ERROR* Comment line too long
c            must be at least nlat.  if ityp > 2 and nlat is even then idvw
C*PL*ERROR* Comment line too long
c            must be at least nlat/2. if ityp > 2 and nlat is odd then idvw
c            must be at least (nlat+1)/2.
c
C*PL*ERROR* Comment line too long
c   jdvw     the second dimension of the arrays vlap and wlap as it appears
C*PL*ERROR* Comment line too long
c            in the program that calls vlapec. jdvw must be at least nlon.
c
c
c   br,bi    two or three dimensional arrays (see input parameter nt)
c   cr,ci    that contain vector spherical harmonic coefficients
c            of the vector field (v,w) as computed by subroutine vhaec.
c            br,bi,cr and ci must be computed by vhaec prior to calling
c            vlapec.  if ityp=1,4, or 7 then cr,ci are not used and can
c            be dummy arguments.  if ityp=2,5, or 8 then br,bi are not
c            used and can be dummy arguments.
c
c    mdbc    the first dimension of the arrays br,bi,cr and ci as it
c            appears in the program that calls vlapec.  mdbc must be
c            at least min0(nlat,nlon/2) if nlon is even or at least
c            min0(nlat,(nlon+1)/2) if nlon is odd.
c
c    ndbc    the second dimension of the arrays br,bi,cr and ci as it
c            appears in the program that calls vlapec. ndbc must be at
c            least nlat.
c
c    wvhsec  an array which must be initialized by subroutine vhseci.
c            once initialized, wvhsec
c            can be used repeatedly by vlapec as long as nlat and nlon
c            remain unchanged.  wvhsec must not be altered between calls
c            of vlapec.
c
c    lvhsec  the dimension of the array wvhsec as it appears in the
c            program that calls vlapec.  let
c
c               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd.
c
c            then lvhsec must be at least
c
c            4*nlat*l2+3*max0(l1-2,0)*(nlat+nlat-l1-1)+nlon+15

c            (see ierror=9 below).
c
c     work   a work array that does not have to be saved.
c
c     lwork  the dimension of the array work as it appears in the
c            program that calls vlapec. define
c
c               l2 = nlat/2                    if nlat is even or
c               l2 = (nlat+1)/2                if nlat is odd
c               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c
c            if ityp .le. 2 then
c
c               nlat*(2*nt*nlon+max0(6*l2,nlon)) + nlat*(4*nt*l1+1)
c
c            or if ityp .gt. 2 let
c
c               l2*(2*nt*nlon+max0(6*nlat,nlon)) + nlat*(4*nt*l1+1)
c
c            will suffice as a minimum length for lwork
c            (see ierror=10 below)
c
c     **************************************************************
c
c     output parameters
c
c
C*PL*ERROR* Comment line too long
c    vlap,   two or three dimensional arrays (see input parameter nt) that
C*PL*ERROR* Comment line too long
c    wlap    contain the vector laplacian of the field (v,w).  wlap(i,j) is
C*PL*ERROR* Comment line too long
c            the east longitude component and vlap(i,j) is the colatitudinal
c            component of the vector laplacian.  the definition of the
c            vector laplacian follows:
c
C*PL*ERROR* Comment line too long
c            let cost and sint be the cosine and sine at colatitude theta.
C*PL*ERROR* Comment line too long
c            let d( )/dlambda  and d( )/dtheta be the first order partial
C*PL*ERROR* Comment line too long
c            derivatives in longitude and colatitude.  let del2 be the scalar
c            laplacian operator
c
c                 del2(s) = [d(sint*d(s)/dtheta)/dtheta +
c                             2            2
c                            d (s)/dlambda /sint]/sint
c
c            then the vector laplacian opeator
c
c                 dvel2(v,w) = (vlap,wlap)
c
c            is defined by
c
c                 vlap = del2(v) - (2*cost*dw/dlambda + v)/sint**2
c
c                 wlap = del2(w) + (2*cost*dv/dlambda - w)/sint**2
c
C*PL*ERROR* Comment line too long
c  ierror    a parameter which flags errors in input parameters as follows:
c
c            = 0  no errors detected
c
c            = 1  error in the specification of nlat
c
c            = 2  error in the specification of nlon
c
c            = 3  error in the specification of ityp
c
c            = 4  error in the specification of nt
c
c            = 5  error in the specification of idvw
c
c            = 6  error in the specification of jdvw
c
c            = 7  error in the specification of mdbc
c
c            = 8  error in the specification of ndbc
c
c            = 9  error in the specification of lvhsec
c
c            = 10 error in the specification of lwork (lwork < lwkmin)
c
c
c **********************************************************************
c
c     end of documentation for vlapec
c
c **********************************************************************
c
      SUBROUTINE DVLAPEC(NLAT,NLON,ITYP,NT,VLAP,WLAP,IDVW,JDVW,BR,BI,CR,
     +                  CI,MDBC,NDBC,WVHSEC,LVHSEC,WORK,LWORK,IERROR)
      DOUBLE PRECISION VLAP
      DOUBLE PRECISION WLAP
      DOUBLE PRECISION BR
      DOUBLE PRECISION BI
      DOUBLE PRECISION CR
      DOUBLE PRECISION CI
      DOUBLE PRECISION WVHSEC
      DOUBLE PRECISION WORK
      DIMENSION VLAP(IDVW,JDVW,NT),WLAP(IDVW,JDVW,NT)
      DIMENSION BR(MDBC,NDBC,NT),BI(MDBC,NDBC,NT)
      DIMENSION CR(MDBC,NDBC,NT),CI(MDBC,NDBC,NT)
      DIMENSION WVHSEC(LVHSEC),WORK(LWORK)

      IERROR = 1
      IF (NLAT.LT.3) RETURN
      IERROR = 2
      IF (NLON.LT.1) RETURN
      IERROR = 3
      IF (ITYP.LT.0 .OR. ITYP.GT.8) RETURN
      IERROR = 4
      IF (NT.LT.0) RETURN
      IERROR = 5
      IMID = (NLAT+1)/2
      IF ((ITYP.LE.2.AND.IDVW.LT.NLAT) .OR.
     +    (ITYP.GT.2.AND.IDVW.LT.IMID)) RETURN
      IERROR = 6
      IF (JDVW.LT.NLON) RETURN
      IERROR = 7
      MMAX = MIN0(NLAT, (NLON+1)/2)
      IF (MDBC.LT.MMAX) RETURN
      IERROR = 8
      IF (NDBC.LT.NLAT) RETURN
      IERROR = 9
      IDZ = (MMAX* (NLAT+NLAT-MMAX+1))/2
      LZIMN = IDZ*IMID
c
c     check saved work space
c
      L1 = MIN0(NLAT, (NLON+1)/2)
      L2 = (NLAT+1)/2
      LWMIN = 4*NLAT*L2 + 3*MAX0(L1-2,0)* (NLAT+NLAT-L1-1) + NLON + 15
      IF (LVHSEC.LT.LWMIN) RETURN
c
c     verify unsaved work space length
c
      IERROR = 10
      MN = MMAX*NLAT*NT
      IF (ITYP.LT.3) THEN
c       no symmetry
          IF (ITYP.EQ.0) THEN
c       br,bi,cr,ci nonzero
              LWKMIN = NLAT* (2*NT*NLON+MAX0(6*IMID,NLON)+1) + 4*MN
          ELSE
c       br,bi or cr,ci zero
              LWKMIN = NLAT* (2*NT*NLON+MAX0(6*IMID,NLON)+1) + 2*MN
          END IF
      ELSE
c     symmetry about equator
          IF (ITYP.EQ.3 .OR. ITYP.EQ.6) THEN
c       br,bi,cr,ci nonzero
              LWKMIN = IMID* (2*NT*NLON+MAX0(6*NLAT,NLON)) + 4*MN + NLAT
          ELSE
c       br,bi or cr,ci zero
              LWKMIN = IMID* (2*NT*NLON+MAX0(6*NLAT,NLON)) + 2*MN + NLAT
          END IF
      END IF
      IF (LWORK.LT.LWKMIN) RETURN
      IERROR = 0
c
c     set work space pointers for vector laplacian coefficients
c
      IF (ITYP.EQ.0 .OR. ITYP.EQ.3 .OR. ITYP.EQ.6) THEN
          IBR = 1
          IBI = IBR + MN
          ICR = IBI + MN
          ICI = ICR + MN
      ELSE IF (ITYP.EQ.1 .OR. ITYP.EQ.4 .OR. ITYP.EQ.7) THEN
          IBR = 1
          IBI = IBR + MN
          ICR = IBI + MN
          ICI = ICR
      ELSE
          IBR = 1
          IBI = 1
          ICR = IBI + MN
          ICI = ICR + MN
      END IF
      IFN = ICI + MN
      IWK = IFN + NLAT
      LIWK = LWORK - 4*MN - NLAT
      CALL DVLAPEC1(NLAT,NLON,ITYP,NT,VLAP,WLAP,IDVW,JDVW,WORK(IBR),
     +             WORK(IBI),WORK(ICR),WORK(ICI),MMAX,WORK(IFN),MDBC,
     +             NDBC,BR,BI,CR,CI,WVHSEC,LVHSEC,WORK(IWK),LIWK,IERROR)
      RETURN
      END

      SUBROUTINE DVLAPEC1(NLAT,NLON,ITYP,NT,VLAP,WLAP,IDVW,JDVW,BRLAP,
     +                   BILAP,CRLAP,CILAP,MMAX,FNN,MDB,NDB,BR,BI,CR,CI,
     +                   WSAVE,LWSAV,WK,LWK,IERROR)
      DOUBLE PRECISION VLAP
      DOUBLE PRECISION WLAP
      DOUBLE PRECISION BRLAP
      DOUBLE PRECISION BILAP
      DOUBLE PRECISION CRLAP
      DOUBLE PRECISION CILAP
      DOUBLE PRECISION FNN
      DOUBLE PRECISION BR
      DOUBLE PRECISION BI
      DOUBLE PRECISION CR
      DOUBLE PRECISION CI
      DOUBLE PRECISION WSAVE
      DOUBLE PRECISION WK
      DOUBLE PRECISION FN
      DIMENSION VLAP(IDVW,JDVW,NT),WLAP(IDVW,JDVW,NT)
      DIMENSION FNN(NLAT),BRLAP(MMAX,NLAT,NT),BILAP(MMAX,NLAT,NT)
      DIMENSION CRLAP(MMAX,NLAT,NT),CILAP(MMAX,NLAT,NT)
      DIMENSION BR(MDB,NDB,NT),BI(MDB,NDB,NT)
      DIMENSION CR(MDB,NDB,NT),CI(MDB,NDB,NT)
      DIMENSION WSAVE(LWSAV),WK(LWK)
c
c     preset coefficient multiplyers
c
      DO 1 N = 2,NLAT
          FN = DBLE(N-1)
          FNN(N) = -FN* (FN+1.D0)
    1 CONTINUE
c
c     set laplacian coefficients from br,bi,cr,ci
c
      IF (ITYP.EQ.0 .OR. ITYP.EQ.3 .OR. ITYP.EQ.6) THEN
c
c     all coefficients needed
c
          DO 2 K = 1,NT
              DO 3 N = 1,NLAT
                  DO 4 M = 1,MMAX
                      BRLAP(M,N,K) = 0.0D0
                      BILAP(M,N,K) = 0.0D0
                      CRLAP(M,N,K) = 0.0D0
                      CILAP(M,N,K) = 0.0D0
    4             CONTINUE
    3         CONTINUE
              DO 5 N = 2,NLAT
                  BRLAP(1,N,K) = FNN(N)*BR(1,N,K)
                  BILAP(1,N,K) = FNN(N)*BI(1,N,K)
                  CRLAP(1,N,K) = FNN(N)*CR(1,N,K)
                  CILAP(1,N,K) = FNN(N)*CI(1,N,K)
    5         CONTINUE
              DO 6 M = 2,MMAX
                  DO 7 N = M,NLAT
                      BRLAP(M,N,K) = FNN(N)*BR(M,N,K)
                      BILAP(M,N,K) = FNN(N)*BI(M,N,K)
                      CRLAP(M,N,K) = FNN(N)*CR(M,N,K)
                      CILAP(M,N,K) = FNN(N)*CI(M,N,K)
    7             CONTINUE
    6         CONTINUE
    2     CONTINUE
      ELSE IF (ITYP.EQ.1 .OR. ITYP.EQ.4 .OR. ITYP.EQ.7) THEN
c
c     vorticity is zero so cr,ci=0 not used
c
          DO 12 K = 1,NT
              DO 13 N = 1,NLAT
                  DO 14 M = 1,MMAX
                      BRLAP(M,N,K) = 0.0D0
                      BILAP(M,N,K) = 0.0D0
   14             CONTINUE
   13         CONTINUE
              DO 15 N = 2,NLAT
                  BRLAP(1,N,K) = FNN(N)*BR(1,N,K)
                  BILAP(1,N,K) = FNN(N)*BI(1,N,K)
   15         CONTINUE
              DO 16 M = 2,MMAX
                  DO 17 N = M,NLAT
                      BRLAP(M,N,K) = FNN(N)*BR(M,N,K)
                      BILAP(M,N,K) = FNN(N)*BI(M,N,K)
   17             CONTINUE
   16         CONTINUE
   12     CONTINUE
      ELSE
c
c     divergence is zero so br,bi=0 not used
c
          DO 22 K = 1,NT
              DO 23 N = 1,NLAT
                  DO 24 M = 1,MMAX
                      CRLAP(M,N,K) = 0.0D0
                      CILAP(M,N,K) = 0.0D0
   24             CONTINUE
   23         CONTINUE
              DO 25 N = 2,NLAT
                  CRLAP(1,N,K) = FNN(N)*CR(1,N,K)
                  CILAP(1,N,K) = FNN(N)*CI(1,N,K)
   25         CONTINUE
              DO 26 M = 2,MMAX
                  DO 27 N = M,NLAT
                      CRLAP(M,N,K) = FNN(N)*CR(M,N,K)
                      CILAP(M,N,K) = FNN(N)*CI(M,N,K)
   27             CONTINUE
   26         CONTINUE
   22     CONTINUE
      END IF
c
c     sythesize coefs into vector field (vlap,wlap)
c
      CALL DVHSEC(NLAT,NLON,ITYP,NT,VLAP,WLAP,IDVW,JDVW,BRLAP,BILAP,
     +           CRLAP,CILAP,MMAX,NLAT,WSAVE,LWSAV,WK,LWK,IERROR)
      RETURN
      END

C
C $Id: agdflt.f,v 1.7 2008-07-27 00:14:34 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE AGDFLT
C
C Calling this do-nothing subroutine forces "ld" to load the following
C block data routine (but only if they are in the same ".f" file).
C
        RETURN
C
      END
CNOSPLIT
      BLOCKDATA AGDFLTX
C
C The block data subroutine AGDFLTX defines the default values of those
C AUTOGRAPH parameters which can be declared in a DATA statement.  See
C AGINIT for code initializing other AUTOGRAPH parameters.
C
C Following are declarations of all the AUTOGRAPH common blocks.
C
C The following common block contains the AUTOGRAPH control parameters,
C all of which are real.  If it is changed, all of AUTOGRAPH (especially
C the routine AGSCAN) must be examined for possible side effects.
C
      COMMON /AGCONP/ QFRA,QSET,QROW,QIXY,QWND,QBAC , SVAL(2) ,
     +                XLGF,XRGF,YBGF,YTGF , XLGD,XRGD,YBGD,YTGD , SOGD ,
     +                XMIN,XMAX,QLUX,QOVX,QCEX,XLOW,XHGH ,
     +                YMIN,YMAX,QLUY,QOVY,QCEY,YLOW,YHGH ,
     +                QDAX(4),QSPA(4),PING(4),PINU(4),FUNS(4),QBTD(4),
     +                BASD(4),QMJD(4),QJDP(4),WMJL(4),WMJR(4),QMND(4),
     +                QNDP(4),WMNL(4),WMNR(4),QLTD(4),QLED(4),QLFD(4),
     +                QLOF(4),QLOS(4),DNLA(4),WCLM(4),WCLE(4) ,
     +                QODP,QCDP,WOCD,WODQ,QDSH(26) ,
     +                     QDLB,QBIM,FLLB(10,8),QBAN ,
     +                QLLN,TCLN,QNIM,FLLN(6,16),QNAN ,
     +                XLGW,XRGW,YBGW,YTGW , XLUW,XRUW,YBUW,YTUW ,
     +                XLCW,XRCW,YBCW,YTCW , WCWP,HCWP,SCWP ,
     +                XBGA(4),YBGA(4),UBGA(4),XNDA(4),YNDA(4),UNDA(4),
     +                QBTP(4),BASE(4),QMNT(4),QLTP(4),QLEX(4),QLFL(4),
     +                QCIM(4),QCIE(4),RFNL(4),WNLL(4),WNLR(4),WNLB(4),
     +                WNLE(4),QLUA(4) ,
     +                RBOX(6),DBOX(6,4),SBOX(6,4)
      SAVE /AGCONP/
C
C The following common block contains other AUTOGRAPH variables, both
C real and integer, which are not control parameters.
C
      COMMON /AGORIP/ SMRL , ISLD , MWCL,MWCM,MWCE,MDLA,MWCD,MWDQ ,
     +                INIF
      SAVE /AGORIP/
C
C The following common block contains other AUTOGRAPH variables, of
C type character.
C
      COMMON /AGOCHP/ CHS1,CHS2
      CHARACTER*504 CHS1,CHS2
      SAVE /AGOCHP/
C
C The following common blocks contain variables which are required for
C the character-storage-and-retrieval scheme of AUTOGRAPH.
C
      COMMON /AGCHR1/ LNIC,INCH(2,50),LNCA,INCA
      SAVE /AGCHR1/
C
      COMMON /AGCHR2/ CHRA(2000)
      CHARACTER*1 CHRA
      SAVE /AGCHR2/
C
C ---------------------------------------------------------------------
C
C Following are declarations of default values of variables in the
C AUTOGRAPH common blocks.
C
C ---------------------------------------------------------------------
C
C QFRA defines the control parameter 'FRAME.', which specifies when, if
C ever, the EZ... routines are to call FRAME to advance to a new frame.
C
      DATA QFRA / 1. /
C
C QSET defines the control parameter 'SET.', which determines how the
C last call to the plot-package routine "SET" is to affect AUTOGRAPH.
C
      DATA QSET / 1. /
C
C QROW defines the control parameter 'ROW.', which determines how the x
C and y input arrays (in calls to AGSTUP and AGCURV) are to be used.
C
      DATA QROW / 1. /
C
C QIXY defines the control parameter 'INVERT.', which, if set non-zero,
C causes the routines AGSTUP and AGCURV to behave as if the arguments
C defining the x and y data had been interchanged.
C
      DATA QIXY / 0. /
C
C QWND defines the control parameter 'WINDOW.', which, if set non-zero,
C causes curves drawn to be scissored by the edge of the curve window.
C
      DATA QWND / 0. /
C
C QBAC defines the control parameter 'BACKGROUND.', which can be given
C any of four values to set up four specific types of plot background.
C
      DATA QBAC / 1. /
C
C SVAL defines the control parameters 'NULL/1.' and 'NULL/2.', which are
C used in various ways by AUTOGRAPH.
C
      DATA SVAL(1) / 1E36 / , SVAL(2) / 2E36 /
C
C XLGF, XRGF, YBGF, and YTGF define the parameter-group 'GRAPH.'; they
C specify the position of the graph window within the plotter frame.
C
      DATA XLGF / 0. / , XRGF / 1. / , YBGF / 0. / , YTGF / 1. /
C
C XLGD, XRGD, YBGD, and YTGD define the first four parameters in the
C group 'GRID.'; they specify the position of the grid window within
C the graph window.
C
      DATA XLGD / .15 / , XRGD / .95 / , YBGD / .15 / , YTGD / .95 /
C
C SOGD defines the control parameter 'GRID/SHAPE.', which defines the
C shape of the grid window.
C
      DATA SOGD / 0. /
C
C XMIN and XMAX define the control parameters 'X/MIN.' and 'X/MAX.',
C which determine how minimum and maximum values of x are to be chosen.
C Null values imply that AUTOGRAPH is to choose real values; non-null
C values are the actual values to be used (perhaps after rounding).
C
      DATA XMIN / 1E36 / , XMAX / 1E36 /
C
C QLUX defines the control parameter 'X/LOG.', which is set non-zero to
C specify that the horizontal axis is to be logarithmic.
C
      DATA QLUX / 0. /
C
C QOVX defines the control parameter 'X/ORDER.', which is set non-zero
C to flip the horizontal axis end-for-end.
C
      DATA QOVX / 0. /
C
C QCEX defines the control parameter 'X/NICE.', which determines which,
C if either, of the horizontal axes is to have "nice" (rounded) values
C at its ends.
C
      DATA QCEX / -1. /
C
C XLOW and XHGH define the control parameters 'X/SMALLEST.' and
C 'X/LARGEST.'; they come into play only when XMIN and/or XMAX are null
C and they are non-null, in which case they set limits on the range of
C x data to be considered when choosing the minimum and/or maximum.
C
      DATA XLOW / 1E36 / , XHGH / 1E36 /
C
C YMIN and YMAX define the control parameters 'Y/MIN.' and 'Y/MAX.',
C which determine how minimum and maximum values of y are to be chosen.
C Null values imply that AUTOGRAPH is to choose real values; non-null
C values are the actual values to be used (perhaps after rounding).
C
      DATA YMIN / 1E36 / , YMAX / 1E36 /
C
C QLUY defines the control parameter 'Y/LOG.', which is set non-zero to
C specify that the horizontal axis is to be logarithmic.
C
      DATA QLUY / 0. /
C
C QOVY defines the control parameter 'Y/ORDER.', which is set non-zero
C to flip the horizontal axis end-for-end.
C
      DATA QOVY / 0. /
C
C QCEY defines the control parameter 'Y/NICE.', which determines which,
C if either, of the horizontal axes is to have "nice" (rounded) values
C at its ends.
C
      DATA QCEY / -1. /
C
C YLOW and YHGH define the control parameters 'Y/SMALLEST.' and
C 'Y/LARGEST.'; they come into play only when YMIN and/or YMAX are null
C and they are non-null, in which case they set limits on the range of
C y data to be considered when choosing the minimum and/or maximum.
C
      DATA YLOW / 1E36 / , YHGH / 1E36 /
C
C QDAX(i) defines the control parameters 'AXIS/s/CONTROL.' (i=1 implies
C s='LEFT', i=2 implies s='RIGHT', i=3 implies s='BOTTOM', i=4 implies
C s='TOP').  Each of these specifies whether or not a given axis will
C be drawn or not and what liberties may be taken with numeric labels
C on the axis.
C
      DATA QDAX(1)/ 4. / , QDAX(2)/ 4. / , QDAX(3)/ 4. / , QDAX(4)/ 4. /
C
C Each QSPA(i) defines a control parameter 'AXIS/s/LINE.', which says
C whether or not the line portion of a particular axis is to be drawn.
C
      DATA QSPA(1)/ 0. / , QSPA(2)/ 0. / , QSPA(3)/ 0. / , QSPA(4)/ 0. /
C
C Each PING(i) defines a control parameter 'AXIS/s/INTERSECTION/GRID.',
C which may be used to move a particular axis to a specified position.
C
      DATA PING(1)/1E36/ , PING(2)/1E36/ , PING(3)/1E36/ , PING(4)/1E36/
C
C Each PINU(i) defines a control parameter 'AXIS/s/INTERSECTION/USER.',
C which may be used to move a particular axis to a specified position.
C
      DATA PINU(1)/1E36/ , PINU(2)/1E36/ , PINU(3)/1E36/ , PINU(4)/1E36/
C
C Each FUNS(i) defines a control parameter 'AXIS/s/FUNCTION.', which is
C used within a user-supplied version of AGUTOL to select a particular
C uset-system-to-label-system mapping for a particular axis.  The
C default value selects the identity mapping.
C
      DATA FUNS(1)/ 0. / , FUNS(2)/ 0. / , FUNS(3)/ 0. / , FUNS(4)/ 0. /
C
C The values of QBTD(i), BASD(i), QMJD(i), QJDP(i), WMJL(i), and WMJR(i)
C together define the control-parameter group 'AXIS/s/TICKS/MAJOR.',
C which determines the positioning and appearance of the major ticks on
C a particular axis.
C
      DATA QBTD(1)/1E36/ , QBTD(2)/1E36/ , QBTD(3)/1E36/ , QBTD(4)/1E36/
      DATA BASD(1)/1E36/ , BASD(2)/1E36/ , BASD(3)/1E36/ , BASD(4)/1E36/
      DATA QMJD(1)/ 6. / , QMJD(2)/ 6. / , QMJD(3)/ 6. / , QMJD(4)/ 6. /
      DATA QJDP(1)/1E36/ , QJDP(2)/1E36/ , QJDP(3)/1E36/ , QJDP(4)/1E36/
      DATA WMJL(1)/ 0. / , WMJL(2)/ 0. / , WMJL(3)/ 0. / , WMJL(4)/ 0. /
      DATA WMJR(1)/.015/ , WMJR(2)/.015/ , WMJR(3)/.015/ , WMJR(4)/.015/
C
C The values of QMND(i), QNDP(i), WMNL(i), and WMNR(i) together define
C the control-parameter group 'AXIS/s/TICKS/MINOR.', which determines
C the positioning and appearance of the major ticks on a particular
C axis.
C
      DATA QMND(1)/1E36/ , QMND(2)/1E36/ , QMND(3)/1E36/ , QMND(4)/1E36/
      DATA QNDP(1)/1E36/ , QNDP(2)/1E36/ , QNDP(3)/1E36/ , QNDP(4)/1E36/
      DATA WMNL(1)/ 0. / , WMNL(2)/ 0. / , WMNL(3)/ 0. / , WMNL(4)/ 0. /
      DATA WMNR(1)/.010/ , WMNR(2)/.010/ , WMNR(3)/.010/ , WMNR(4)/.010/
C
C The values of QLTD(i), QLED(i), QLFD(i), QLOF(i), QLOS(i), DNLA(i),
C WCLM(i), and WCLE(i) together define the control-parameter group
C 'AXIS/s/NUMERIC.', which determines the positioning and appearance of
C the numeric labels on a particular axis.
C
      DATA QLTD(1)/1E36/ , QLTD(2)/  0./ , QLTD(3)/1E36/ , QLTD(4)/  0./
      DATA QLED(1)/1E36/ , QLED(2)/1E36/ , QLED(3)/1E36/ , QLED(4)/1E36/
      DATA QLFD(1)/1E36/ , QLFD(2)/1E36/ , QLFD(3)/1E36/ , QLFD(4)/1E36/
      DATA QLOF(1)/ 0. / , QLOF(2)/ 0. / , QLOF(3)/ 0. / , QLOF(4)/ 0. /
      DATA QLOS(1)/ 90./ , QLOS(2)/ 90./ , QLOS(3)/ 90./ , QLOS(4)/ 90./
      DATA DNLA(1)/.015/ , DNLA(2)/.015/ , DNLA(3)/.015/ , DNLA(4)/.015/
      DATA WCLM(1)/.015/ , WCLM(2)/.015/ , WCLM(3)/.015/ , WCLM(4)/.015/
      DATA WCLE(1)/.010/ , WCLE(2)/.010/ , WCLE(3)/.010/ , WCLE(4)/.010/
C
C QODP defines the control parameter 'DASH/SELECTOR.', the sign of which
C determines which set of dash patterns is used by EZMY and EZMXY (the
C alphabetic set or the user-specified set); if the user-specified set
C is selected, the magnitude of QODP determines how many of them are to
C be used.
C
      DATA QODP / 1. /
C
C QCDP defines the control parameter 'DASH/LENGTH.', which specifies the
C assumed length of dash patterns tendered to AUTOGRAPH.
C
      DATA QCDP / 8. /
C
C WOCD and WODQ define the control parameters 'DASH/CHARACTER.' and
C 'DASH/DOLLAR-QUOTE.', which specify the widths of characters used in
C character-string dash patterns.
C
      DATA WOCD / .010 / , WODQ / .010 /
C
C QDSH defines the control-parameter group 'DASH/PATTERN.'.  Each value,
C if positive, defines a binary dash pattern, and, if negative, serves
C as an identifier in retrieving a character-string dash pattern.
C
      DATA QDSH / 26*65535. /
C
C QDLB defines the control parameter 'LABEL/CONTROL.', which specifies
C what may be done with informational labels in response to overlap
C problems.
C
      DATA QDLB /2./
C
C QBIM defines the control parameter 'LABEL/BUFFER/LENGTH.' and must
C be equal to the second dimension of the array FLLB.
C
      DATA QBIM / 8. /
C
C QBAN defines the control parameter 'LABEL/NAME.'; its value is really
C a pointer into the label list.  The default value, zero, means that
C the pointer has not been set.
C
      DATA QBAN / 0. /
C
C QLLN defines the control parameter 'LINE/MAXIMUM.' - the assumed
C maximum length of character strings intended for use as the text of a
C line of a label.
C
      DATA QLLN /40./
C
C TCLN defines the control parameter 'LINE/TERMINATOR.' - which is used
C to mark the end of character strings intended for use as the text of a
C line of a label.  It is initialized in AGINIT.
C
C QNIM defines the control parameter 'LINE/BUFFER/LENGTH.' and must be
C equal to the second dimension of FLLN.
C
      DATA QNIM / 16. /
C
C QNAN defines the control parameter 'LINE/NUMBER.'; its value is really
C a pointer into the line list.  The default value, zero, says that the
C pointer has not been set.
C
      DATA QNAN / 0. /
C
C (FLLB(I,1),I=1,10) and (FLLN(I,1),I=1,6) define the label to the left
C of the grid.  The name, in FLLB(1,1), and the line text, in FLLN(4,1),
C must be filled in by AGINIT.
C
      DATA FLLB( 1,1)/   0./ , FLLB( 2,1)/   0./ , FLLB( 3,1)/   0./ ,
     +     FLLB( 4,1)/   .5/ , FLLB( 5,1)/-.015/ , FLLB( 6,1)/   0./ ,
     +     FLLB( 7,1)/  90./ , FLLB( 8,1)/   0./ , FLLB( 9,1)/   1./ ,
     +     FLLB(10,1)/   1./ , FLLN( 1,1)/+100./ , FLLN( 2,1)/   0./ ,
     +     FLLN( 3,1)/ .015/ , FLLN( 4,1)/  -2./ , FLLN( 5,1)/   1./ ,
     +     FLLN( 6,1)/   0./
C
C (FLLB(I,2),I=1,10) and (FLLN(I,2),I=1,6) define the label to the right
C of the grid.  The name, in FLLB(1,2), and the line text, in FLLN(4,2),
C must be filled in by AGINIT.
C
      DATA FLLB( 1,2)/   0./ , FLLB( 2,2)/   0./ , FLLB( 3,2)/   1./ ,
     +     FLLB( 4,2)/   .5/ , FLLB( 5,2)/+.015/ , FLLB( 6,2)/   0./ ,
     +     FLLB( 7,2)/  90./ , FLLB( 8,2)/   0./ , FLLB( 9,2)/   1./ ,
     +     FLLB(10,2)/   2./ , FLLN( 1,2)/-100./ , FLLN( 2,2)/   0./ ,
     +     FLLN( 3,2)/ .015/ , FLLN( 4,2)/  -3./ , FLLN( 5,2)/   0./ ,
     +     FLLN( 6,2)/   0./
C
C (FLLB(I,3),I=1,10) and (FLLN(I,3),I=1,6) define the label below the
C grid.  The name, in FLLB(1,3), and the line text, in FLLN(4,3), must
C be filled in by AGINIT.
C
      DATA FLLB( 1,3)/   0./ , FLLB( 2,3)/   0./ , FLLB( 3,3)/   .5/ ,
     +     FLLB( 4,3)/   0./ , FLLB( 5,3)/   0./ , FLLB( 6,3)/-.015/ ,
     +     FLLB( 7,3)/   0./ , FLLB( 8,3)/   0./ , FLLB( 9,3)/   1./ ,
     +     FLLB(10,3)/   3./ , FLLN( 1,3)/-100./ , FLLN( 2,3)/   0./ ,
     +     FLLN( 3,3)/ .015/ , FLLN( 4,3)/  -1./ , FLLN( 5,3)/   1./ ,
     +     FLLN( 6,3)/   0./
C
C (FLLB(I,4),I=1,10) and (FLLN(I,4),I=1,6) define the label above the
C grid.  The name, in FLLB(1,4), and the line text, in FLLN(4,4), must
C be filled in by AGINIT.
C
      DATA FLLB( 1,4)/   0./ , FLLB( 2,4)/   0./ , FLLB( 3,4)/   .5/ ,
     +     FLLB( 4,4)/   1./ , FLLB( 5,4)/   0./ , FLLB( 6,4)/+.020/ ,
     +     FLLB( 7,4)/   0./ , FLLB( 8,4)/   0./ , FLLB( 9,4)/   1./ ,
     +     FLLB(10,4)/   4./ , FLLN( 1,4)/+100./ , FLLN( 2,4)/   0./ ,
     +     FLLN( 3,4)/ .020/ , FLLN( 4,4)/  -3./ , FLLN( 5,4)/   0./ ,
     +     FLLN( 6,4)/   0./
C
C Certain secondary parameters must be initialized to prevent bombing.
C
      DATA QBTP(1)/  0./ , QBTP(2)/  0./ , QBTP(3)/  0./ , QBTP(4)/  0./
      DATA BASE(1)/  0./ , BASE(2)/  0./ , BASE(3)/  0./ , BASE(4)/  0./
      DATA QMNT(1)/  0./ , QMNT(2)/  0./ , QMNT(3)/  0./ , QMNT(4)/  0./
      DATA QLTP(1)/  0./ , QLTP(2)/  0./ , QLTP(3)/  0./ , QLTP(4)/  0./
      DATA QLEX(1)/  0./ , QLEX(2)/  0./ , QLEX(3)/  0./ , QLEX(4)/  0./
      DATA QLFL(1)/  0./ , QLFL(2)/  0./ , QLFL(3)/  0./ , QLFL(4)/  0./
      DATA QCIM(1)/  0./ , QCIM(2)/  0./ , QCIM(3)/  0./ , QCIM(4)/  0./
      DATA QCIE(1)/  0./ , QCIE(2)/  0./ , QCIE(3)/  0./ , QCIE(4)/  0./
      DATA RFNL(1)/  0./ , RFNL(2)/  0./ , RFNL(3)/  0./ , RFNL(4)/  0./
      DATA QLUA(1)/  0./ , QLUA(2)/  0./ , QLUA(3)/  0./ , QLUA(4)/  0./
C
C SMRL and ISLD are set by the routine AGINIT (which see, below).
C
C MWCL, MWCM, MWCE, MDLA, MWCD, and MWDQ are the minimum widths of label
C characters, mantissa characters, exponent characters, label-to-axis
C distances, dash-pattern characters, and dash-pattern spaces, respect-
C ively (in the plotter coordinate system).
C
      DATA MWCL /8/, MWCM /8/, MWCE /8/, MDLA /8/, MWCD /8/, MWDQ /8/
C
C INIF is an initialization flag, set non-zero to indicate that the
C routine AGINIT has been executed to set the values of AUTOGRAPH
C parameters which, for one reason or another, cannot be preset by
C this block data routine.
C
      DATA INIF / 0 /
C
C CHS1 and CHS2 are used within AUTOGRAPH when manipulating character
C strings retrieved by calls to AGGTCH.  They need not be preset.
C
C LNIC is the second dimension of the array (INCH) which holds an index
C of the character strings stored by AGSTCH.
C
      DATA LNIC / 50 /
C
C INCH is an index of character strings currently stored in CHRA.  Each
C entry has the following format:
C
C    INCH(1,I), if non-zero, is the index, in the array CHRA, of the
C    first character of the Ith character string.
C
C    INCH(2,I) is the length of the Ith character string.
C
      DATA (INCH(1,I),I=1,50) / 50*0 /
      DATA (INCH(2,I),I=1,50) / 50*0 /
C
C LNCA is the size of the array (CHRA) in which AGSTCH stores character
C strings.
C
      DATA LNCA / 2000 /
C
C INCA is the index of the last character used in CHRA.
C
      DATA INCA / 0 /
C
C CHRA holds character strings stored by AGSTCH.  It need not be pre-set
C to anything.
C
      END

C
C	$Id: gqchb.f,v 1.5 2008-07-27 00:20:58 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GQCHB (ERRIND,CHBX,CHBY)
C
C  INQUIRE CHARACTER BASE VECTOR
C
      include 'gkscom.h'
C
      INTEGER ERRIND
      REAL    CHBX,CHBY
C
C  Check if GKS is in the proper state.
C
      CALL GZCKST(8,-1,ERRIND)
C
      IF (ERRIND .EQ. 0) THEN
        CHBX =  CCHUP(2)
        CHBY = -CCHUP(1)
      ELSE
        CHBX = 0.
        CHBY = 0.
      ENDIF
C
      RETURN
      END

C
C	$Id: alover.f,v 1.4 2008-07-27 00:59:04 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE ALOVER(IOS,STATUS)
C
C  pre2ncgm is a package for converting NCAR metafiles produced from the
C  pre-GKS NCAR graphics package to NCAR CGM format--the format of the
C  metafiles produced from the GKS-based NCAR Graphics package.
C
C  Implementation:
C
C  On UNIX systems, to get an executable you just compile the Fortran
C  code with "ncargf77".  This will give you an executable which reads
C  its input metafile from standard input and writes its output to
C  the metafile produced by the NCAR GKS package (gmeta by default).
C
C  On non-UNIX systems you will have to load the enclosed Frotran
C  code with all of the necessary support routines from the NCAR
C  graphics package.
C
C  The enclosed code is structured for 32-bit machines.  To run on other
C  hosts, the setting for MNWRDS must be changed everywhere in the code
C  to equal the number of machine words needed to hold 1440 bytes.
C  MNWRDS is set to 360 in this code.
C
C---------------------------------------------------------------------------
C
C  Description of ALOVER:
C
C  THIS ROUTINE PROCESSES FATAL ERRORS
C  IT WILL
C       1. PUT AN ERROR MESSAGE ON THE META TRANSLATOR ERROR UNIT
C       2. CLEAN UP THE DEVICE BEING USED
C       3. TERMINATE EXECUTION OF THE META TRANSLATOR
C
C  INPUT
C       IOS-READ STATUS ONLY HAS MEANING IF STATUS = REDERR
C       STATUS-THE FATAL ERROR NUMBER
C
      COMMON/TREROR/ ALLOK, MFRCHK, MTOPER, METRDC, REDERR, TYPCHG
     1             ,INVTYP, MINVLD, TYPERR, FRMEND, ENCINT, IVDCDT
     2             ,GCOERR, GCRERR, GCCERR, FCOERR, FCRERR, FCCERR
     3             ,PLIDXG, PMIDXG, TXIDXG, PGIDXG, INVLMT, CELERR
     4             ,COIERR, COLNRM, UNKNOW, UNKOPC, ENDMTF, VNEROR
     5             ,BADRSZ, DEVOUT, NOVERS, BADFNT, PGMERR, FASERR
     6             ,HINERR, VDWERR, RDWERR, RIXLIM
      INTEGER        ALLOK, MFRCHK, MTOPER, METRDC, REDERR, TYPCHG
     1             ,INVTYP, MINVLD, TYPERR, FRMEND, ENCINT, IVDCDT
     2             ,GCOERR, GCRERR, GCCERR, FCOERR, FCRERR, FCCERR
     3             ,PLIDXG, PMIDXG, TXIDXG, PGIDXG, INVLMT, CELERR
     4             ,COIERR, COLNRM, UNKNOW, UNKOPC, ENDMTF, VNEROR
     5             ,BADRSZ, DEVOUT, NOVERS, BADFNT, PGMERR, FASERR
     6             ,HINERR, VDWERR, RDWERR, RIXLIM
      COMMON/TRINOT/ IPTR, MBUFOT, MAXBYT, DEVUNT, METUNT,
     1          METIPT, ERRUNT, FNTUNT
      INTEGER MAXCNT
      PARAMETER (MAXCNT=200)
      INTEGER IPTR, MBUFOT(MAXCNT), MAXBYT, DEVUNT, METUNT, ERRUNT,
     1        FNTUNT
      LOGICAL METIPT
C
      INTEGER IOS, STATUS
C
C  CLEAN UP THE GRAPHICS DEVICE
C
      CALL GECLKS
C
C  TERMINATE EXECUTION OF THE META TRANSLATOR
C
      STOP
C
      END

C
C	$Id: geclks.f,v 1.5 2008-07-27 00:20:57 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GECLKS
C
C  EMERGENCY CLOSE GKS
C
      include 'gkscom.h'
C
C  Update all open workstations.
C
      IF (OPS .GE. GWSOP) THEN
        IF (NOPWK .NE. 0) THEN
          DO 200 I=1,NOPWK
            CALL GUWK(SOPWK(I),1)
  200     CONTINUE
        ENDIF
      ENDIF
C
C  Close the open segment if in state GSGOP.
C
      IF (OPS .EQ. GSGOP) THEN
        CALL GQOPSG(IER,ISGNE)
        IF (IER .EQ. 0) THEN
          CALL GCLSG
        ENDIF
      ENDIF
C
C  Deactivate all active workstations.
C
      IF (OPS .EQ. GWSAC) THEN
        IF (NACWK .NE. 0) THEN
          NACWKT = NACWK
          DO 201 I=1,NACWKT
            CALL GDAWK(SACWK(NACWK))
  201     CONTINUE
        ENDIF
      ENDIF
C
C  Close all open workstations.
C
      IF (OPS .GE. GWSOP) THEN
        IF (NOPWK .NE. 0) THEN
          NOPWKT = NOPWK
          DO 202 I=1,NOPWKT
            CALL GCLWK(SOPWK(NOPWK))
  202     CONTINUE
        ENDIF
      ENDIF
C
C  Mark GKS closed.
C
      OPS = GGKCL
C
      RETURN
      END

C
C $Id: pj03dp.f,v 1.5 2008-07-27 00:17:10 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE PJ03DP (COORD,CRDIO,INDIC)
C
C -- A L B E R S   C O N I C A L   E Q U A L   A R E A
C
      IMPLICIT DOUBLE PRECISION (A-Z)
      INTEGER INDIC
      DIMENSION GEOG(2),PROJ(2),COORD(2),CRDIO(2)
C **** PARAMETERS **** A,E,ES,LAT1,LAT2,LON0,LAT0,X0,Y0,NS,C,RH0 *******
      COMMON /ERRMZ0/ IERR
        INTEGER IERR
      SAVE   /ERRMZ0/
      COMMON /PRINZ0/ IPEMSG,IPELUN,IPPARM,IPPLUN
        INTEGER IPEMSG,IPELUN,IPPARM,IPPLUN
      SAVE   /PRINZ0/
      COMMON /PC03DP/ A,LON0,X0,Y0,C,E,ES,NS,RH0
      DATA TOL /1.0D-7/
      DATA HALFPI /1.5707963267948966D0/
      DATA ZERO,HALF,ONE /0.0D0,0.5D0,1.0D0/
C
C -- F O R W A R D   . . .
C
      IF (INDIC .EQ. 0) THEN
C
         GEOG(1) = COORD(1)
         GEOG(2) = COORD(2)
         IERR = 0
         SINPHI = SIN (GEOG(2))
         COSPHI = COS (GEOG(2))
         QS = QSFNDP (E,SINPHI,COSPHI)
         RH = A * SQRT (C - NS * QS) / NS
         THETA = NS * ADJLDP (GEOG(1) - LON0)
         PROJ(1) = X0 + RH * SIN (THETA)
         PROJ(2) = Y0 + RH0 - RH * COS (THETA)
         CRDIO(1) = PROJ(1)
         CRDIO(2) = PROJ(2)
         RETURN
      END IF
C
C -- I N V E R S E   . . .
C
      IF (INDIC .EQ. 1) THEN
C
         PROJ(1) = COORD(1)
         PROJ(2) = COORD(2)
         IERR = 0
         X = PROJ(1) - X0
         Y = RH0 - PROJ(2) + Y0
         RH = SIGN (SQRT (X * X + Y * Y) , NS)
         THETA = ZERO
         CON = SIGN (ONE , NS)
         IF (RH .NE. ZERO) THETA = ATAN2 (CON * X , CON * Y)
         CON = RH * NS / A
         QS = (C - CON * CON) / NS
         IF (E .LT. TOL) GO TO 260
         CON = ONE - HALF * (ONE - ES) * LOG ((ONE - E) /
     .         (ONE + E)) / E
         IF ((ABS(CON) - ABS(QS)) .GT. TOL) GO TO 260
         GEOG(2) = SIGN (HALFPI , QS)
         GO TO 280
  260    GEOG(2) = PHI1DP (E,QS)
         IF (IERR .EQ. 0) GO TO 280
         IERR = 035
         RETURN
  280    GEOG(1) = ADJLDP (THETA / NS + LON0)
         CRDIO(1) = GEOG(1)
         CRDIO(2) = GEOG(2)
         RETURN
      END IF
C
      END

      PROGRAM WMEX05
C
C  Examples of regional weather and temperatures.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C  Number of points defining region; number of regions; number of points
C  in clip region.
C
      PARAMETER (NU=8, NO=8, NOP1=NO+1, NC=5)
C
C  Data for a region.
C
      DIMENSION XU(NU),YU(NU),XP(NU),YP(NU)
      DIMENSION XOFF(NO),YOFF(NO)
      DIMENSION XCLIP(NC),YCLIP(NC)
      CHARACTER*13 LABELS(NOP1)
C
      DATA XU/ 0.05, 0.20, 0.40, 0.70, 0.80, 0.65, 0.40, 0.05/
      DATA YU/ 0.70, 0.45, 0.60, 0.70, 0.80, 0.95, 0.84, 0.70/
      DATA XOFF/0.10, 0.52, 0.10, 0.52, 0.10, 0.52,  0.10,  0.52/
      DATA YOFF/0.47, 0.47, 0.27, 0.27, 0.07, 0.07, -0.13, -0.13/
      DATA XCLIP/0.10, 0.75, 0.75, 0.10, 0.10/
      DATA YCLIP/0.50, 0.50, 0.85, 0.85, 0.50/
      DATA LABELS/'Ice','Snow','Flurries','Rain','Showers',
     +            'Thunderstorms','Temperature',
     +            'Temperature','(clipped)'/
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C  Define a color table.
C
      CALL GSCR(IWKID, 0, 1.0, 1.0, 1.0)
      CALL GSCR(IWKID, 1, 0.0, 0.0, 0.0)
      CALL GSCR(IWKID, 2, 1.0, 0.0, 0.0)
      CALL GSCR(IWKID, 3, 0.0, 0.0, 1.0)
      CALL GSCR(IWKID, 4, 0.0, 1.0, 0.0)
C
      CALL PLCHHQ(0.50,0.93,':F26:Weather and temperature regions',
     +            0.033,0.,0.)       
C
      CALL WMSETI('COL',3)
      SCALE = .4
      CALL WMSETR('RHT - size scale',0.015)
      CALL PCSETI('FN',26)
      DO 10 I=1,NO
        DO 20 J=1,NU
          XP(J) = SCALE*XU(J)+XOFF(I)
          YP(J) = SCALE*YU(J)+YOFF(I)
   20   CONTINUE
        IF (I .LE. NO-2) THEN
          CALL WMDRRG(NU,XP,YP,LABELS(I),1,XP,YP)
          CALL PLCHHQ(XP(3)+.01,YP(3)-.025,LABELS(I),0.02,0.,-1.)       
        ELSE IF (I .EQ. NO-1) THEN
          CALL WMDRRG(NU,XP,YP,'INDEX2',1,XP,YP)
          CALL PLCHHQ(XP(3)+.01,YP(3)-.025,LABELS(I),0.02,0.,-1.)       
        ELSE IF (I .EQ. NO) THEN
          DO 30 J=1,NC
            XCLIP(J) = SCALE*XCLIP(J)+XOFF(I)
            YCLIP(J) = SCALE*YCLIP(J)+YOFF(I)
   30     CONTINUE
          CALL WMDRRG(NU,XP,YP,'INDEX4',NC,XCLIP,YCLIP)
          CALL PLCHHQ(XP(3)+.01,YP(3)-.025,LABELS(I),0.02,0.,-1.)       
          CALL PLCHHQ(XP(3)+.01,YP(3)-.060,LABELS(I+1),0.02,0.,-1.)       
        ENDIF
   10 CONTINUE
C
      CALL FRAME
C
      CALL GDAWK(IWKID)
      CALL GCLWK(IWKID)
      CALL GCLKS
      STOP
C
      END

C
C	$Id: ccheck.f,v 1.4 2008-07-27 00:17:20 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CCHECK (IERR)
C
C SHORT TEST ROUTINE FOR THE CORRECT ACCESSING OF THE COMPLEX CHARACTER
C SET.
C
C ON ENTRY
C   IERR MAY CONTAIN ANY VALUE.
C ON EXIT
C   IERR = 0 IF 2 SHORT TESTS OF THE DIGITIZATION RETRIEVAL PROCESS
C            WERE SUCCESSFUL
C        = 2 IF THE TEST WAS SUCCESSFUL FOR 6-BIT DIGITIZATION UNITS
C            BUT NOT SUCCESSFUL FOR 12-BIT DIGITIZATION UNITS
C        = 1 IF THE TEST WAS SUCCESSFUL FOR 12-BIT DIGITIZATION UNITS
C            BUT NOT SUCCESSFUL FOR 6-BIT DIGITIZATION UNITS.
C        = 3 IF NEITHER OF THE 2 TESTS WAS SUCCESSFUL.
C CALLS
C   XTCH
C
C
C PWRC1 IS FOR COMMUNICATION WITH SUBROUTINE XTCH.
      COMMON /PWRC1/ LC(150)
C
C THE ARRAY CONTAINING THE CORRECT DIGITIZATION OF CHARACTER +.
      DIMENSION LCPCOR(14)
C THE ARRAY CONTAINING THE CORRECT DIGITIZATION OF THE CHARACTER DEFINED
C BY THE OCTAL NUMBER 751.
      DIMENSION LCOCOR(30)
C
C TEST 1
C   RETRIEVE DIGITIZATION OF CHARACTER + WITH DEFAULT FUNCTION CODES
C   AND COMPARE IT TO THE CORRECT DIGITIZATION.
C   (TEST 6-BIT DIGITIZATION UNITS)
C TEST 2
C   RETRIEVE DIGITIZATION OF CHARACTER DEFINED BY THE OCTAL NUMBER 751
C   AND COMPARE IT WITH THE CORRECT DIGITIZATION.
C   (TEST 12-BIT DIGITIZATION UNITS)
C
C        ** DATA FOR TEST 1 **
C
C THE NUMBER OF THE UNIT IN ARRAY IND POINTING TO THE DIGITIZATION
C OF CHARACTER +.
      DATA IPLUSP /37/
C
C THE CORRECT NUMBER OF DIGITIZATION UNITS FOR CHARACTER +.
      DATA IPLUSN /14/
C
C THE CORRECT DIGITIZATION OF CHARACTER +.
      DATA LCPCOR(1) /-13/
      DATA LCPCOR(2) /13/
      DATA LCPCOR(3) /0/
      DATA LCPCOR(4) /9/
      DATA LCPCOR(5) /0/
      DATA LCPCOR(6) /-9/
      DATA LCPCOR(7) /-2048/
      DATA LCPCOR(8) /0/
      DATA LCPCOR(9) /-9/
      DATA LCPCOR(10) /0/
      DATA LCPCOR(11) /9/
      DATA LCPCOR(12) /0/
      DATA LCPCOR(13) /-2048/
      DATA LCPCOR(14) /-2048/
C
C        ** DATA FOR TEST 2 **
C
C THE NUMBER OF THE UNIT IN ARRAY IND POINTING TO THE DIGITIZATION OF
C THE CHARACTER DEFINED BY THE OCTAL NUMBER 751.
      DATA IOCTP /489/
C
C THE CORRECT NUMBER OF DIGITIZATION UNITS OF THE CHARACTER DEFINED BY
C THE OCTAL NUMBER 751.
      DATA IOCTN /30/
C
C THE CORRECT DIGITIZATION OF THE CHARACTER DEFINED BY THE OCTAL
C NUMBER 751.
      DATA LCOCOR(1) /-9/
      DATA LCOCOR(2) /9/
      DATA LCOCOR(3) /-5/
      DATA LCOCOR(4) /39/
      DATA LCOCOR(5) /-5/
      DATA LCOCOR(6) /0/
      DATA LCOCOR(7) /-5/
      DATA LCOCOR(8) /-39/
      DATA LCOCOR(9) /-2048/
      DATA LCOCOR(10) /0/
      DATA LCOCOR(11) /-4/
      DATA LCOCOR(12) /39/
      DATA LCOCOR(13) /-4/
      DATA LCOCOR(14) /0/
      DATA LCOCOR(15) /-4/
      DATA LCOCOR(16) /-39/
      DATA LCOCOR(17) /-2048/
      DATA LCOCOR(18) /0/
      DATA LCOCOR(19) /-5/
      DATA LCOCOR(20) /39/
      DATA LCOCOR(21) /6/
      DATA LCOCOR(22) /39/
      DATA LCOCOR(23) /-2048/
      DATA LCOCOR(24) /0/
      DATA LCOCOR(25) /-5/
      DATA LCOCOR(26) /-39/
      DATA LCOCOR(27) /6/
      DATA LCOCOR(28) /-39/
      DATA LCOCOR(29) /-2048/
      DATA LCOCOR(30) /-2048/
C
C
C THE PASS THROUGH PWRX TO BE SIMULATED IN BOTH TESTS.
      DATA IPASS /2/
C
C
      IER1 = 0
      IER2 = 0
C
C        ***** TEST 1 *****
C
C RETRIEVE DIGITIZATION OF CHARACTER +.
      CALL XTCH (IPLUSP,IPASS,NACT1)
C
C COMPARE THE NUMBER OF DIGITIZATION UNITS RETRIEVED TO THE CORRECT
C NUMBER.
      IF (NACT1 .EQ. IPLUSN) GOTO 1
      IER1 = 1
      GOTO 10
    1 CONTINUE
C
C COMPARE EACH OF THE RETRIEVED DIGITIZATION UNITS TO THE CORRECT UNIT.
      DO 2 I=1,NACT1
      IF (LC(I) .EQ. LCPCOR(I)) GOTO 2
      IER1 = 1
      GOTO 10
    2 CONTINUE
C
C        ***** TEST 2 *****
C
   10 CONTINUE
C RETRIEVE DIGITIZATION OF CHARACTER DEFINED BY OCTAL NUMBER 751.
      CALL XTCH (IOCTP,IPASS,NACT2)
C
C COMPARE THE NUMBER OF DIGITIZATION UNITS RETRIEVED TO THE CORRECT
C NUMBER.
      IF (NACT2 .EQ. IOCTN) GOTO 11
      IER2 = 2
      GOTO 30
   11 CONTINUE
C
C COMPARE EACH OF THE RETRIEVED DIGITIZATION UNITS TO THE CORRECT UNIT.
      DO 20 I = 1,NACT2
      IF (LC(I) .EQ. LCOCOR(I)) GOTO 20
      IER2 = 2
      GOTO 30
   20 CONTINUE
C
C
   30 CONTINUE
      IERR = IER1 + IER2
C
C
      RETURN
      END

C
C	$Id: reord.f,v 1.5 2008-07-27 00:23:02 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE REORD (CL,NCL,C1,MARK,NMG)
      DIMENSION       CL(NCL)    ,C1(NCL)
      DIMENSION IEND(5)
      LOGICAL ENDIT,FLAG
      SAVE
C
C THIS ROUTINE PUTS THE MAJOR (LABELED) LEVELS IN THE BEGINNING OF CL
C AND THE MINOR (UNLABELED) LEVELS IN END OF CL.  THE NUMBER OF MAJOR
C LEVELS IS RETURNED IN MARK.  C1 IS USED AS A WORK SPACE.  NMG IS THE
C NUMBER OF MINOR GAPS (ONE MORE THAN THE NUMBER OF MINOR LEVELS BETWEEN
C MAJOR LEVELS).
C
      NL = NCL
      IF (NL.LE.4 .OR. NMG.LE.1) GO TO 120
      NML = NMG-1
      IF (NL .LE. 10) NML = 1
C
C CHECK FOR ZERO OR OTHER NICE NUMBER FOR A MAJOR LINE
C
      NMLP1 = NML+1
      DO 101 I=1,NL
         ISAVE = I
         IF (CL(I) .EQ. 0.) GO TO 104
  101 CONTINUE
      L = NL/2
      L = ALOG10(ABS(CL(L)))+1.
      Q = 10.**L
      DO 103 J=1,3
         Q = Q/10.
         DO 102 I=1,NL
            ISAVE = I
            IF (MOD(ABS(CL(I)+1.E-9*CL(I))/Q,REAL(NMLP1)) .LE. .0001)
     1          GO TO 104
  102    CONTINUE
  103 CONTINUE
      ISAVE = NL/2
C
C PUT MAJOR LEVELS IN C1
C
  104 ISTART = MOD(ISAVE,NMLP1)
      IF (ISTART .EQ. 0) ISTART = NMLP1
      NMAJL = 0
      DO 105 I=ISTART,NL,NMLP1
         NMAJL = NMAJL+1
         C1(NMAJL) = CL(I)
  105 CONTINUE
      MARK = NMAJL
      ENDIT = .FALSE.
C
C     START OF MINOR LEVEL REORDERING
C
  111 IC1 = MARK+1
      IBEG = 0
      DO 112 I=1,NMG
         IF (C1(1) .EQ. CL(I))  GO TO 113
  112 CONTINUE
  113 IEND(1) = I
      ND = 1
 1135 FLAG = .FALSE.
  114 MID = (IEND(ND)+IBEG+1)/2
      IF (MID .EQ. IEND(ND))  GO TO 115
      IEND(ND+1) = MID
      ND = ND+1
      FLAG = .TRUE.
      C1(IC1) = CL(MID)
      IC1 = IC1+1
      GO TO 114
  115 IF ( .NOT. FLAG)  ND = ND+1
      IBEG = IEND(ND-1)
      IF (ND .EQ. 2)  GO TO 117
      ND = ND-2
      GO TO 1135
  117 IEND(1) = IEND(1) + NMG
      IF (ENDIT)  GO TO 118
      ND = 1
      IF (IEND(1) .LE. NL) GO TO 1135
      IEND(1) = NL+1
      ENDIT = .TRUE.
      GO TO 1135
  118 DO 119 I=1,NL
         CL(I) = C1(I)
  119 CONTINUE
      RETURN
  120 MARK = NL
      RETURN
      END

C NCLFORTSTART
      SUBROUTINE DINT2P(PPIN,XXIN,PIN,XIN,P,X,NPIN,PPOUT,XXOUT,NPOUT
     +                 ,LINLOG,XMSG,IER)
      IMPLICIT NONE
c
c This code was designed for one simple task. It has since
c been mangled and abused for assorted reasons. For example,
c early gfortran compilers had some issues with automatic arrays.
c Hence, the C-Wrapper was used to create 'work' arrays which
c were then passed to this code.  The original focused (non-NCL) 
c task was to handle PPIN & PPOUT that had the same 'monotonicity.' 
c Extra code was added to handle the more general case. 
c Blah-Blah:  Punch line: it is embarrassingly convoluted!!!
c
c                                                ! input types
      INTEGER NPIN,NPOUT,LINLOG,IER
      DOUBLE PRECISION PPIN(NPIN),XXIN(NPIN),PPOUT(NPOUT),XMSG
C                                                ! output
      DOUBLE PRECISION XXOUT(NPOUT)
C                                                ! work
      DOUBLE PRECISION PIN(NPIN),XIN(NPIN),P(NPIN),X(NPIN)
      DOUBLE PRECISION POUT(NPOUT),XOUT(NPOUT)
C NCLEND

c local
      INTEGER J1,NP,NL,NIN,NLMAX,NPLVL,NLSAVE,NP1,NO1,N1,N2,LOGLIN,
     +        NLSTRT
      DOUBLE PRECISION SLOPE,PA,PB,PC
c
      LOGLIN = ABS(LINLOG)

c error check: enough points: pressures consistency?

      IER = 0
      IF (NPOUT.GT.0) THEN
          DO NP = 1,NPOUT
              XXOUT(NP) = XMSG
          END DO
      END IF

      IF (NPIN.LT.2 .OR. NPOUT.LT.1) IER = IER + 1

C C C IF (NPOUT.GT.1) THEN
C C C     IF ((PPIN(1).GT.PPIN(2).AND.PPOUT(1).LT.PPOUT(2)) .OR.
C C C+        (PPIN(1).LT.PPIN(2).AND.PPOUT(1).GT.PPOUT(2))) THEN
C C C         IER = IER + 10
C              PRINT *,'INT2P: ppout is in different order than ppin'
C              PRINT *,'       Must both be monotonic {in/de}creasing'
C C C     END IF
C C C END IF

      IF (IER.NE.0) THEN
C          PRINT *,'INT2P: error exit: ier=',IER
          RETURN
      END IF

c should *input arrays* be reordered? want p(1) > p(2) > p(3) etc
c so that it will match order for which code was originally designed
c copy to 'work'  arrays

      NP1 = 0
      NO1 = 0
      IF (PPIN(1).LT.PPIN(2)) THEN    
          NP1 = NPIN + 1
      END IF
      IF (PPOUT(1).LT.PPOUT(2)) THEN 
          NO1 = NPOUT + 1
      END IF

      DO NP = 1,NPIN
          PIN(NP) = PPIN(ABS(NP1-NP))
          XIN(NP) = XXIN(ABS(NP1-NP))
      END DO

      DO NP = 1,NPOUT   
          POUT(NP) = PPOUT(ABS(NO1-NP))
      END DO
c
c eliminate XIN levels with missing data. 
c .   This can happen with observational data.
c
      NL = 0
      DO NP = 1,NPIN
          IF (XIN(NP).NE.XMSG .AND. PIN(NP).NE.XMSG) THEN
              NL = NL + 1
              P(NL) = PIN(NP)
              X(NL) = XIN(NP)
          END IF
      END DO
      NLMAX = NL
C                                                ! all missing data
      IF (NLMAX.LT.2) THEN
          IER = IER + 1000
C          PRINT *,'INT2P: ier=',IER
          RETURN
      END IF

c ===============> pressure in decreasing order <================
c perform the interpolation  [pin(1)>pin(2)>...>pin(npin)]
c                                                      ( p ,x)
c ------------------------- p(nl+1), x(nl+1)   example (200,5)
c .
c ------------------------- pout(np), xout(np)         (250,?)
c .
c ------------------------- p(nl)  , x(nl)             (300,10)


c exact p-level matches
      NLSTRT = 1
      NLSAVE = 1
      DO NP = 1,NPOUT
          XOUT(NP) = XMSG
          DO NL = NLSTRT,NLMAX
              IF (POUT(NP).EQ.P(NL)) THEN
                  XOUT(NP) = X(NL)
                  NLSAVE = NL + 1
                  GO TO 10
              END IF
          END DO
   10     NLSTRT = NLSAVE
      END DO

      IF (LOGLIN.EQ.1) THEN
          DO NP = 1,NPOUT
              DO NL = 1,NLMAX - 1
                  IF (POUT(NP).LT.P(NL) .AND. POUT(NP).GT.P(NL+1)) THEN
                      SLOPE = (X(NL)-X(NL+1))/ (P(NL)-P(NL+1))
                      XOUT(NP) = X(NL+1) + SLOPE* (POUT(NP)-P(NL+1))
                  END IF
              END DO
          END DO
      ELSE
          DO NP = 1,NPOUT
              DO NL = 1,NLMAX - 1
                  IF (POUT(NP).LT.P(NL) .AND. POUT(NP).GT.P(NL+1)) THEN
                      PA = DLOG(P(NL))
                      PB = DLOG(POUT(NP))
c special case: In case someome inadvertently enter p=0.
                      if (p(nl+1).gt.0.d0) then
                          PC = DLOG(P(NL+1))
                      else
                          PC = DLOG(1.d-4)
                      end if

                      SLOPE = (X(NL)-X(NL+1))/ (PA-PC)
                      XOUT(NP) = X(NL+1) + SLOPE* (PB-PC)
                  END IF
              END DO
          END DO
      END IF

c extrapolate?
c . use the 'last' valid slope for extrapolating

      IF (LINLOG.LT.0) THEN
          DO NP = 1,NPOUT
              DO NL = 1,NLMAX
                  IF (POUT(NP).GT.P(1)) THEN
                      IF (LOGLIN.EQ.1) THEN
                          SLOPE = (X(2)-X(1))/ (P(2)-P(1))
                          XOUT(NP) = X(1) + SLOPE* (POUT(NP)-P(1))
                      ELSE
                          PA = DLOG(P(2))
                          PB = DLOG(POUT(NP))
                          PC = DLOG(P(1))
                          SLOPE = (X(2)-X(1))/ (PA-PC)
                          XOUT(NP) = X(1) + SLOPE* (PB-PC)
                      END IF
                  ELSE IF (POUT(NP).LT.P(NLMAX)) THEN
                      N1 = NLMAX
                      N2 = NLMAX - 1
                      IF (LOGLIN.EQ.1) THEN
                          SLOPE = (X(N1)-X(N2))/ (P(N1)-P(N2))
                          XOUT(NP) = X(N1) + SLOPE* (POUT(NP)-P(N1))
                      ELSE
                          PA = DLOG(P(N1))
                          PB = DLOG(POUT(NP))
                          PC = DLOG(P(N2))
                          SLOPE = (X(N1)-X(N2))/ (PA-PC)
                          XOUT(NP) = X(N1) + SLOPE* (PB-PC)
                      END IF
                  END IF
              END DO
          END DO
      END IF

c place results in the return array;
c .   possibly .... reverse to original order

      if (NO1.GT.0) THEN
          DO NP = 1,NPOUT
             n1 = ABS(NO1-NP)
             PPOUT(NP) = POUT(n1)
             XXOUT(NP) = XOUT(n1)
          END DO
      ELSE
          DO NP = 1,NPOUT
             PPOUT(NP) = POUT(NP)
             XXOUT(NP) = XOUT(NP)
          END DO
      END IF

      RETURN
      END

      SUBROUTINE ZLATZM( SIDE, M, N, V, INCV, TAU, C1, C2, LDC, WORK )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER          SIDE
      INTEGER            INCV, LDC, M, N
      COMPLEX*16         TAU
*     ..
*     .. Array Arguments ..
      COMPLEX*16         C1( LDC, * ), C2( LDC, * ), V( * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  This routine is deprecated and has been replaced by routine ZUNMRZ.
*
*  ZLATZM applies a Householder matrix generated by ZTZRQF to a matrix.
*
*  Let P = I - tau*u*u',   u = ( 1 ),
*                              ( v )
*  where v is an (m-1) vector if SIDE = 'L', or a (n-1) vector if
*  SIDE = 'R'.
*
*  If SIDE equals 'L', let
*         C = [ C1 ] 1
*             [ C2 ] m-1
*               n
*  Then C is overwritten by P*C.
*
*  If SIDE equals 'R', let
*         C = [ C1, C2 ] m
*                1  n-1
*  Then C is overwritten by C*P.
*
*  Arguments
*  =========
*
*  SIDE    (input) CHARACTER*1
*          = 'L': form P * C
*          = 'R': form C * P
*
*  M       (input) INTEGER
*          The number of rows of the matrix C.
*
*  N       (input) INTEGER
*          The number of columns of the matrix C.
*
*  V       (input) COMPLEX*16 array, dimension
*                  (1 + (M-1)*abs(INCV)) if SIDE = 'L'
*                  (1 + (N-1)*abs(INCV)) if SIDE = 'R'
*          The vector v in the representation of P. V is not used
*          if TAU = 0.
*
*  INCV    (input) INTEGER
*          The increment between elements of v. INCV <> 0
*
*  TAU     (input) COMPLEX*16
*          The value tau in the representation of P.
*
*  C1      (input/output) COMPLEX*16 array, dimension
*                         (LDC,N) if SIDE = 'L'
*                         (M,1)   if SIDE = 'R'
*          On entry, the n-vector C1 if SIDE = 'L', or the m-vector C1
*          if SIDE = 'R'.
*
*          On exit, the first row of P*C if SIDE = 'L', or the first
*          column of C*P if SIDE = 'R'.
*
*  C2      (input/output) COMPLEX*16 array, dimension
*                         (LDC, N)   if SIDE = 'L'
*                         (LDC, N-1) if SIDE = 'R'
*          On entry, the (m - 1) x n matrix C2 if SIDE = 'L', or the
*          m x (n - 1) matrix C2 if SIDE = 'R'.
*
*          On exit, rows 2:m of P*C if SIDE = 'L', or columns 2:m of C*P
*          if SIDE = 'R'.
*
*  LDC     (input) INTEGER
*          The leading dimension of the arrays C1 and C2.
*          LDC >= max(1,M).
*
*  WORK    (workspace) COMPLEX*16 array, dimension
*                      (N) if SIDE = 'L'
*                      (M) if SIDE = 'R'
*
*  =====================================================================
*
*     .. Parameters ..
      COMPLEX*16         ONE, ZERO
      PARAMETER          ( ONE = ( 1.0D+0, 0.0D+0 ),
     $                   ZERO = ( 0.0D+0, 0.0D+0 ) )
*     ..
*     .. External Subroutines ..
      EXTERNAL           ZAXPY, ZCOPY, ZGEMV, ZGERC, ZGERU, ZLACGV
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MIN
*     ..
*     .. Executable Statements ..
*
      IF( ( MIN( M, N ).EQ.0 ) .OR. ( TAU.EQ.ZERO ) )
     $   RETURN
*
      IF( LSAME( SIDE, 'L' ) ) THEN
*
*        w :=  conjg( C1 + v' * C2 )
*
         CALL ZCOPY( N, C1, LDC, WORK, 1 )
         CALL ZLACGV( N, WORK, 1 )
         CALL ZGEMV( 'Conjugate transpose', M-1, N, ONE, C2, LDC, V,
     $               INCV, ONE, WORK, 1 )
*
*        [ C1 ] := [ C1 ] - tau* [ 1 ] * w'
*        [ C2 ]    [ C2 ]        [ v ]
*
         CALL ZLACGV( N, WORK, 1 )
         CALL ZAXPY( N, -TAU, WORK, 1, C1, LDC )
         CALL ZGERU( M-1, N, -TAU, V, INCV, WORK, 1, C2, LDC )
*
      ELSE IF( LSAME( SIDE, 'R' ) ) THEN
*
*        w := C1 + C2 * v
*
         CALL ZCOPY( M, C1, 1, WORK, 1 )
         CALL ZGEMV( 'No transpose', M, N-1, ONE, C2, LDC, V, INCV, ONE,
     $               WORK, 1 )
*
*        [ C1, C2 ] := [ C1, C2 ] - tau* w * [ 1 , v']
*
         CALL ZAXPY( M, -TAU, WORK, 1, C1, 1 )
         CALL ZGERC( M, N-1, -TAU, WORK, 1, V, INCV, C2, LDC )
      END IF
*
      RETURN
*
*     End of ZLATZM
*
      END

C
C $Id: trmrectgrid.f,v 1.1 2004-03-11 02:00:34 dbrown Exp $
C
      SUBROUTINE TRMRGR (IDIM,JDIM,XARR,YARR,
     +                   RDAT,ISCR,SVAL,
     +                   RPNT,MPNT,NPNT,LOPN,
     +                   IEDG,MEDG,NEDG,LOEN,
     +                   ITRI,MTRI,NTRI,LOTN)
C
      DIMENSION XARR(IDIM,JDIM),YARR(IDIM,JDIM),RDAT(IDIM,JDIM)
      DIMENSION ISCR(IDIM,JDIM,4)
      DIMENSION RPNT(MPNT),IEDG(MEDG),ITRI(MTRI)
C
C Given arrays defining a rectangular mesh of data, TRMRGR returns a
C triangular mesh representing the data.
C
C The arguments are as follows:
C
C IDIM - an input expression of type INTEGER - the first dimension of
C the rectangular mesh.
C
C JDIM - an input expression of type INTEGER - the second dimension of
C the rectangular mesh.
C
C XARR - an input array of type REAL, dimensioned IDIM by JDIM - the
C values of X for the points of the rectangular mesh.
C
C YARR - an input array of type REAL, dimensioned IDIM by JDIM - the
C values of Y for the points of the rectangular mesh.
C
C RDAT - an input array of type REAL, dimensioned IDIM by JDIM - the
C values of the data field for the points of the rectangular mesh.
C
C ISCR - a scratch array of type INTEGER, dimensioned IDIM*JDIM*4.
C
C SVAL - an input expression of type REAL - a value which, if used in
C the array RDAT, marks that datum as "special" or "missing".
C
C RPNT is a one-dimensional output array of type REAL in which the list
C of the points of the triangular mesh is placed.
C
C MPNT is an input expression of type INTEGER specifying the length of
C RPNT.
C
C NPNT is an output variable whose value is the index of the last
C element of RPNT used for the list of points.
C
C LOPN is the length of a point node in RPNT.
C
C IEDG is a one-dimensional output array of type INTEGER in which the
C list of the edges of the triangular mesh is placed.
C
C MEDG is an input expression of type INTEGER specifying the length of
C IEDG.
C
C NEDG is an output variable whose value is the index of the last
C element of IEDG used for the list of edges.
C
C LOEN is the length of an edge node in IEDG.
C
C ITRI is a one-dimensional output array of type INTEGER in which the
C list of the triangles of the triangular mesh is placed.
C
C MTRI is an input expression of type INTEGER specifying the length of
C ITRI.
C
C NTRI is an output variable whose value is the index of the last
C element of ITRI used for the list of triangles.
C
C LOTN is the length of a triangle node in IEDG.
C
C Check for an uncleared prior error.
C
        IF (ICFELL('TRMRGR - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C Build structures forming the triangular mesh.  First, zero the count
C of points, edges, and triangles formed.
C
        NPNT=0
        NEDG=0
        NTRI=0
C
C Initialize the array that keeps track of where in the triangular mesh
C the points and edges of the original rectangular grid were put.
C
        DO 103 I=1,IDIM
          DO 102 J=1,JDIM
            DO 101 K=1,4
              ISCR(I,J,K)=-1
  101       CONTINUE
  102     CONTINUE
  103   CONTINUE
C
C Loop through the cells of the rectangular grid.
C
        DO 106 I=1,IDIM-1
C
          DO 105 J=1,JDIM-1
C
C Use only rectangular cells with data at each of their four corners.
C
            IF (RDAT(I  ,J  ).NE.SVAL.AND.
     +          RDAT(I+1,J  ).NE.SVAL.AND.
     +          RDAT(I  ,J+1).NE.SVAL.AND.
     +          RDAT(I+1,J+1).NE.SVAL) THEN
C
C Within each rectangular cell, loop to produce the two triangles into
C which it will be divided.
C
              DO 104 K=0,1
C
C The cell is split into triangles using one of the two diagonals.  The
C following code determines which diagonal to use; it creates a sort of
C checkerboard pattern, using the diagonal from lower left to upper
C right on cells of one "color" and that from upper left to lower right
C on cells of the other "color".  The logic can be changed to use other
C patterns, but it is important that the points of each triangle be
C specified in counterclockwise order.  We have to take action near the
C poles to avoid forming degenerate triangles there.
C
                IF (MOD(I+J,2).EQ.0) THEN
                  IF (K.EQ.0) THEN
                    INI1=I
                    INJ1=J
                    INI2=I+1
                    INJ2=J
                    INI3=I
                    INJ3=J+1
                  ELSE
                    INI1=I
                    INJ1=J+1
                    INI2=I+1
                    INJ2=J
                    INI3=I+1
                    INJ3=J+1
                  END IF
                ELSE
                  IF (K.EQ.0) THEN
                    INI1=I
                    INJ1=J
                    INI2=I+1
                    INJ2=J+1
                    INI3=I
                    INJ3=J+1
                  ELSE
                    INI1=I
                    INJ1=J
                    INI2=I+1
                    INJ2=J
                    INI3=I+1
                    INJ3=J+1
                  END IF
                END IF
C
C Deal with the first point of the triangle.  We are careful not to put
C the point into the structure more than once.  (That way, we can test
C to see if two edges contain the same point by looking at pointers; we
C don't have to look at coordinates.)
C
                IF (ISCR(INI1,INJ1,4).GE.0) THEN
                  IPP1=ISCR(INI1,INJ1,4)
                ELSE IF (NPNT+LOPN.GT.MPNT) THEN
                  CALL SETER ('TRMRGR - POINT ARRAY IS TOO SMALL',2,1)
                  RETURN
                ELSE
                  IPP1=NPNT
                  NPNT=NPNT+LOPN
                  ISCR(INI1,INJ1,4)=IPP1
                END IF
C
                RPNT(IPP1+1)=XARR(INI1,INJ1)
                RPNT(IPP1+2)=YARR(INI1,INJ1)
                RPNT(IPP1+3)=0
                RPNT(IPP1+4)=RDAT(INI1,INJ1)
C
C Deal with the second point of the triangle.
C
                IF (ISCR(INI2,INJ2,4).GE.0) THEN
                  IPP2=ISCR(INI2,INJ2,4)
                ELSE IF (NPNT+LOPN.GT.MPNT) THEN
                  CALL SETER ('TRMRGR - POINT ARRAY IS TOO SMALL',3,1)
                  RETURN
                ELSE
                  IPP2=NPNT
                  NPNT=NPNT+LOPN
                  ISCR(INI2,INJ2,4)=IPP2
                END IF
C
                RPNT(IPP2+1)=XARR(INI2,INJ2)
                RPNT(IPP2+2)=YARR(INI2,INJ2)
                RPNT(IPP2+3)=0
                RPNT(IPP2+4)=RDAT(INI2,INJ2)
C
C Deal with the third point of the triangle.
C
                IF (ISCR(INI3,INJ3,4).GE.0) THEN
                  IPP3=ISCR(INI3,INJ3,4)
                ELSE IF (NPNT+LOPN.GT.MPNT) THEN
                  CALL SETER ('TRMRGR - POINT ARRAY IS TOO SMALL',4,1)
                  RETURN
                ELSE
                  IPP3=NPNT
                  NPNT=NPNT+LOPN
                  ISCR(INI3,INJ3,4)=IPP3
                END IF
C
                RPNT(IPP3+1)=XARR(INI3,INJ3)
                RPNT(IPP3+2)=YARR(INI3,INJ3)
                RPNT(IPP3+3)=0
                RPNT(IPP3+4)=RDAT(INI3,INJ3)
C
C Deal with the first edge of the triangle (joining points 1 and 2).
C Again, we are careful not to put an edge into the structure more
C than once.  (That way, two triangles that share an edge contain
C pointers to the same edge.)
C
                IF (INI1.EQ.INI2) THEN
                  ITYP=1
                ELSE IF (INJ1.EQ.INJ2) THEN
                  ITYP=2
                ELSE
                  ITYP=3
                END IF
C
                INIM=MIN(INI1,INI2)
                INJM=MIN(INJ1,INJ2)
C
                IF (ISCR(INIM,INJM,ITYP).GE.0) THEN
                  IPE1=ISCR(INIM,INJM,ITYP)
                  IEDG(IPE1+4)=NTRI+1
                ELSE IF (NEDG+LOEN.GT.MEDG) THEN
                  CALL SETER ('TRMRGR - EDGE ARRAY IS TOO SMALL',5,1)
                  RETURN
                ELSE
                  IPE1=NEDG
                  NEDG=NEDG+LOEN
                  ISCR(INIM,INJM,ITYP)=IPE1
                  IEDG(IPE1+1)=IPP1
                  IEDG(IPE1+2)=IPP2
                  IEDG(IPE1+3)=NTRI+1
                  IEDG(IPE1+4)=-1
                END IF
C
C Deal with the second edge of the triangle (joining points 2 and 3).
C
                IF (INI2.EQ.INI3) THEN
                  ITYP=1
                ELSE IF (INJ2.EQ.INJ3) THEN
                  ITYP=2
                ELSE
                  ITYP=3
                END IF
C
                INIM=MIN(INI2,INI3)
                INJM=MIN(INJ2,INJ3)
C
                IF (ISCR(INIM,INJM,ITYP).GE.0) THEN
                  IPE2=ISCR(INIM,INJM,ITYP)
                  IEDG(IPE2+4)=NTRI+2
                ELSE IF (NEDG+LOEN.GT.MEDG) THEN
                  CALL SETER ('TRMRGR - EDGE ARRAY IS TOO SMALL',6,1)
                  RETURN
                ELSE
                  IPE2=NEDG
                  NEDG=NEDG+LOEN
                  ISCR(INIM,INJM,ITYP)=IPE2
                  IEDG(IPE2+1)=IPP2
                  IEDG(IPE2+2)=IPP3
                  IEDG(IPE2+3)=NTRI+2
                  IEDG(IPE2+4)=-1
                END IF
C
C Deal with the third edge of the triangle (joining points 3 and 1).
C
                IF (INI3.EQ.INI1) THEN
                  ITYP=1
                ELSE IF (INJ3.EQ.INJ1) THEN
                  ITYP=2
                ELSE
                  ITYP=3
                END IF
C
                INIM=MIN(INI3,INI1)
                INJM=MIN(INJ3,INJ1)
C
                IF (ISCR(INIM,INJM,ITYP).GE.0) THEN
                  IPE3=ISCR(INIM,INJM,ITYP)
                  IEDG(IPE3+4)=NTRI+3
                ELSE IF (NEDG+LOEN.GT.MEDG) THEN
                  CALL SETER ('TRMRGR - EDGE ARRAY IS TOO SMALL',7,1)
                  RETURN
                ELSE
                  IPE3=NEDG
                  NEDG=NEDG+LOEN
                  ISCR(INIM,INJM,ITYP)=IPE3
                  IEDG(IPE3+1)=IPP3
                  IEDG(IPE3+2)=IPP1
                  IEDG(IPE3+3)=NTRI+3
                  IEDG(IPE3+4)=-1
                END IF
C
C Finally, add the triangle itself to the triangle list.
C
                IF (NTRI+LOTN.GT.MTRI) THEN
                  CALL SETER('TRMRGR - TRIANGLE ARRAY IS TOO SMALL',8,1)
                  RETURN
                ELSE
                  IPTT=NTRI
                  NTRI=NTRI+LOTN
                  ITRI(IPTT+1)=IPE1
                  ITRI(IPTT+2)=IPE2
                  ITRI(IPTT+3)=IPE3
                  ITRI(IPTT+4)=0
                END IF
C
  104         CONTINUE
C
            END IF
C
  105     CONTINUE
C
  106   CONTINUE
C
C Done.
C
      RETURN
C
      END

      SUBROUTINE STRSYL( TRANA, TRANB, ISGN, M, N, A, LDA, B, LDB, C,
     $                   LDC, SCALE, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     March 31, 1993 
*
*     .. Scalar Arguments ..
      CHARACTER          TRANA, TRANB
      INTEGER            INFO, ISGN, LDA, LDB, LDC, M, N
      REAL               SCALE
*     ..
*     .. Array Arguments ..
      REAL               A( LDA, * ), B( LDB, * ), C( LDC, * )
*     ..
*
*  Purpose
*  =======
*
*  STRSYL solves the real Sylvester matrix equation:
*
*     op(A)*X + X*op(B) = scale*C or
*     op(A)*X - X*op(B) = scale*C,
*
*  where op(A) = A or A**T, and  A and B are both upper quasi-
*  triangular. A is M-by-M and B is N-by-N; the right hand side C and
*  the solution X are M-by-N; and scale is an output scale factor, set
*  <= 1 to avoid overflow in X.
*
*  A and B must be in Schur canonical form (as returned by SHSEQR), that
*  is, block upper triangular with 1-by-1 and 2-by-2 diagonal blocks;
*  each 2-by-2 diagonal block has its diagonal elements equal and its
*  off-diagonal elements of opposite sign.
*
*  Arguments
*  =========
*
*  TRANA   (input) CHARACTER*1
*          Specifies the option op(A):
*          = 'N': op(A) = A    (No transpose)
*          = 'T': op(A) = A**T (Transpose)
*          = 'C': op(A) = A**H (Conjugate transpose = Transpose)
*
*  TRANB   (input) CHARACTER*1
*          Specifies the option op(B):
*          = 'N': op(B) = B    (No transpose)
*          = 'T': op(B) = B**T (Transpose)
*          = 'C': op(B) = B**H (Conjugate transpose = Transpose)
*
*  ISGN    (input) INTEGER
*          Specifies the sign in the equation:
*          = +1: solve op(A)*X + X*op(B) = scale*C
*          = -1: solve op(A)*X - X*op(B) = scale*C
*
*  M       (input) INTEGER
*          The order of the matrix A, and the number of rows in the
*          matrices X and C. M >= 0.
*
*  N       (input) INTEGER
*          The order of the matrix B, and the number of columns in the
*          matrices X and C. N >= 0.
*
*  A       (input) REAL array, dimension (LDA,M)
*          The upper quasi-triangular matrix A, in Schur canonical form.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A. LDA >= max(1,M).
*
*  B       (input) REAL array, dimension (LDB,N)
*          The upper quasi-triangular matrix B, in Schur canonical form.
*
*  LDB     (input) INTEGER
*          The leading dimension of the array B. LDB >= max(1,N).
*
*  C       (input/output) REAL array, dimension (LDC,N)
*          On entry, the M-by-N right hand side matrix C.
*          On exit, C is overwritten by the solution matrix X.
*
*  LDC     (input) INTEGER
*          The leading dimension of the array C. LDC >= max(1,M)
*
*  SCALE   (output) REAL
*          The scale factor, scale, set <= 1 to avoid overflow in X.
*
*  INFO    (output) INTEGER
*          = 0: successful exit
*          < 0: if INFO = -i, the i-th argument had an illegal value
*          = 1: A and B have common or very close eigenvalues; perturbed
*               values were used to solve the equation (but the matrices
*               A and B are unchanged).
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ZERO, ONE
      PARAMETER          ( ZERO = 0.0E+0, ONE = 1.0E+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            NOTRNA, NOTRNB
      INTEGER            IERR, J, K, K1, K2, KNEXT, L, L1, L2, LNEXT
      REAL               A11, BIGNUM, DA11, DB, EPS, SCALOC, SGN, SMIN,
     $                   SMLNUM, SUML, SUMR, XNORM
*     ..
*     .. Local Arrays ..
      REAL               DUM( 1 ), VEC( 2, 2 ), X( 2, 2 )
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      REAL               SDOT, SLAMCH, SLANGE
      EXTERNAL           LSAME, SDOT, SLAMCH, SLANGE
*     ..
*     .. External Subroutines ..
      EXTERNAL           SLABAD, SLALN2, SLASY2, SSCAL, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, MAX, REAL
*     ..
*     .. Executable Statements ..
*
*     Decode and Test input parameters
*
      NOTRNA = LSAME( TRANA, 'N' )
      NOTRNB = LSAME( TRANB, 'N' )
*
      INFO = 0
      IF( .NOT.NOTRNA .AND. .NOT.LSAME( TRANA, 'T' ) .AND. .NOT.
     $    LSAME( TRANA, 'C' ) ) THEN
         INFO = -1
      ELSE IF( .NOT.NOTRNB .AND. .NOT.LSAME( TRANB, 'T' ) .AND. .NOT.
     $         LSAME( TRANB, 'C' ) ) THEN
         INFO = -2
      ELSE IF( ISGN.NE.1 .AND. ISGN.NE.-1 ) THEN
         INFO = -3
      ELSE IF( M.LT.0 ) THEN
         INFO = -4
      ELSE IF( N.LT.0 ) THEN
         INFO = -5
      ELSE IF( LDA.LT.MAX( 1, M ) ) THEN
         INFO = -7
      ELSE IF( LDB.LT.MAX( 1, N ) ) THEN
         INFO = -9
      ELSE IF( LDC.LT.MAX( 1, M ) ) THEN
         INFO = -11
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'STRSYL', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( M.EQ.0 .OR. N.EQ.0 )
     $   RETURN
*
*     Set constants to control overflow
*
      EPS = SLAMCH( 'P' )
      SMLNUM = SLAMCH( 'S' )
      BIGNUM = ONE / SMLNUM
      CALL SLABAD( SMLNUM, BIGNUM )
      SMLNUM = SMLNUM*REAL( M*N ) / EPS
      BIGNUM = ONE / SMLNUM
*
      SMIN = MAX( SMLNUM, EPS*SLANGE( 'M', M, M, A, LDA, DUM ),
     $       EPS*SLANGE( 'M', N, N, B, LDB, DUM ) )
*
      SCALE = ONE
      SGN = ISGN
*
      IF( NOTRNA .AND. NOTRNB ) THEN
*
*        Solve    A*X + ISGN*X*B = scale*C.
*
*        The (K,L)th block of X is determined starting from
*        bottom-left corner column by column by
*
*         A(K,K)*X(K,L) + ISGN*X(K,L)*B(L,L) = C(K,L) - R(K,L)
*
*        Where
*                  M                         L-1
*        R(K,L) = SUM [A(K,I)*X(I,L)] + ISGN*SUM [X(K,J)*B(J,L)].
*                I=K+1                       J=1
*
*        Start column loop (index = L)
*        L1 (L2) : column index of the first (first) row of X(K,L).
*
         LNEXT = 1
         DO 70 L = 1, N
            IF( L.LT.LNEXT )
     $         GO TO 70
            IF( L.EQ.N ) THEN
               L1 = L
               L2 = L
            ELSE
               IF( B( L+1, L ).NE.ZERO ) THEN
                  L1 = L
                  L2 = L + 1
                  LNEXT = L + 2
               ELSE
                  L1 = L
                  L2 = L
                  LNEXT = L + 1
               END IF
            END IF
*
*           Start row loop (index = K)
*           K1 (K2): row index of the first (last) row of X(K,L).
*
            KNEXT = M
            DO 60 K = M, 1, -1
               IF( K.GT.KNEXT )
     $            GO TO 60
               IF( K.EQ.1 ) THEN
                  K1 = K
                  K2 = K
               ELSE
                  IF( A( K, K-1 ).NE.ZERO ) THEN
                     K1 = K - 1
                     K2 = K
                     KNEXT = K - 2
                  ELSE
                     K1 = K
                     K2 = K
                     KNEXT = K - 1
                  END IF
               END IF
*
               IF( L1.EQ.L2 .AND. K1.EQ.K2 ) THEN
                  SUML = SDOT( M-K1, A( K1, MIN( K1+1, M ) ), LDA,
     $                         C( MIN( K1+1, M ), L1 ), 1 )
                  SUMR = SDOT( L1-1, C( K1, 1 ), LDC, B( 1, L1 ), 1 )
                  VEC( 1, 1 ) = C( K1, L1 ) - ( SUML+SGN*SUMR )
                  SCALOC = ONE
*
                  A11 = A( K1, K1 ) + SGN*B( L1, L1 )
                  DA11 = ABS( A11 )
                  IF( DA11.LE.SMIN ) THEN
                     A11 = SMIN
                     DA11 = SMIN
                     INFO = 1
                  END IF
                  DB = ABS( VEC( 1, 1 ) )
                  IF( DA11.LT.ONE .AND. DB.GT.ONE ) THEN
                     IF( DB.GT.BIGNUM*DA11 )
     $                  SCALOC = ONE / DB
                  END IF
                  X( 1, 1 ) = ( VEC( 1, 1 )*SCALOC ) / A11
*
                  IF( SCALOC.NE.ONE ) THEN
                     DO 10 J = 1, N
                        CALL SSCAL( M, SCALOC, C( 1, J ), 1 )
   10                CONTINUE
                     SCALE = SCALE*SCALOC
                  END IF
                  C( K1, L1 ) = X( 1, 1 )
*
               ELSE IF( L1.EQ.L2 .AND. K1.NE.K2 ) THEN
*
                  SUML = SDOT( M-K2, A( K1, MIN( K2+1, M ) ), LDA,
     $                         C( MIN( K2+1, M ), L1 ), 1 )
                  SUMR = SDOT( L1-1, C( K1, 1 ), LDC, B( 1, L1 ), 1 )
                  VEC( 1, 1 ) = C( K1, L1 ) - ( SUML+SGN*SUMR )
*
                  SUML = SDOT( M-K2, A( K2, MIN( K2+1, M ) ), LDA,
     $                         C( MIN( K2+1, M ), L1 ), 1 )
                  SUMR = SDOT( L1-1, C( K2, 1 ), LDC, B( 1, L1 ), 1 )
                  VEC( 2, 1 ) = C( K2, L1 ) - ( SUML+SGN*SUMR )
*
                  CALL SLALN2( .FALSE., 2, 1, SMIN, ONE, A( K1, K1 ),
     $                         LDA, ONE, ONE, VEC, 2, -SGN*B( L1, L1 ),
     $                         ZERO, X, 2, SCALOC, XNORM, IERR )
                  IF( IERR.NE.0 )
     $               INFO = 1
*
                  IF( SCALOC.NE.ONE ) THEN
                     DO 20 J = 1, N
                        CALL SSCAL( M, SCALOC, C( 1, J ), 1 )
   20                CONTINUE
                     SCALE = SCALE*SCALOC
                  END IF
                  C( K1, L1 ) = X( 1, 1 )
                  C( K2, L1 ) = X( 2, 1 )
*
               ELSE IF( L1.NE.L2 .AND. K1.EQ.K2 ) THEN
*
                  SUML = SDOT( M-K1, A( K1, MIN( K1+1, M ) ), LDA,
     $                         C( MIN( K1+1, M ), L1 ), 1 )
                  SUMR = SDOT( L1-1, C( K1, 1 ), LDC, B( 1, L1 ), 1 )
                  VEC( 1, 1 ) = SGN*( C( K1, L1 )-( SUML+SGN*SUMR ) )
*
                  SUML = SDOT( M-K1, A( K1, MIN( K1+1, M ) ), LDA,
     $                         C( MIN( K1+1, M ), L2 ), 1 )
                  SUMR = SDOT( L1-1, C( K1, 1 ), LDC, B( 1, L2 ), 1 )
                  VEC( 2, 1 ) = SGN*( C( K1, L2 )-( SUML+SGN*SUMR ) )
*
                  CALL SLALN2( .TRUE., 2, 1, SMIN, ONE, B( L1, L1 ),
     $                         LDB, ONE, ONE, VEC, 2, -SGN*A( K1, K1 ),
     $                         ZERO, X, 2, SCALOC, XNORM, IERR )
                  IF( IERR.NE.0 )
     $               INFO = 1
*
                  IF( SCALOC.NE.ONE ) THEN
                     DO 40 J = 1, N
                        CALL SSCAL( M, SCALOC, C( 1, J ), 1 )
   40                CONTINUE
                     SCALE = SCALE*SCALOC
                  END IF
                  C( K1, L1 ) = X( 1, 1 )
                  C( K1, L2 ) = X( 2, 1 )
*
               ELSE IF( L1.NE.L2 .AND. K1.NE.K2 ) THEN
*
                  SUML = SDOT( M-K2, A( K1, MIN( K2+1, M ) ), LDA,
     $                         C( MIN( K2+1, M ), L1 ), 1 )
                  SUMR = SDOT( L1-1, C( K1, 1 ), LDC, B( 1, L1 ), 1 )
                  VEC( 1, 1 ) = C( K1, L1 ) - ( SUML+SGN*SUMR )
*
                  SUML = SDOT( M-K2, A( K1, MIN( K2+1, M ) ), LDA,
     $                         C( MIN( K2+1, M ), L2 ), 1 )
                  SUMR = SDOT( L1-1, C( K1, 1 ), LDC, B( 1, L2 ), 1 )
                  VEC( 1, 2 ) = C( K1, L2 ) - ( SUML+SGN*SUMR )
*
                  SUML = SDOT( M-K2, A( K2, MIN( K2+1, M ) ), LDA,
     $                         C( MIN( K2+1, M ), L1 ), 1 )
                  SUMR = SDOT( L1-1, C( K2, 1 ), LDC, B( 1, L1 ), 1 )
                  VEC( 2, 1 ) = C( K2, L1 ) - ( SUML+SGN*SUMR )
*
                  SUML = SDOT( M-K2, A( K2, MIN( K2+1, M ) ), LDA,
     $                         C( MIN( K2+1, M ), L2 ), 1 )
                  SUMR = SDOT( L1-1, C( K2, 1 ), LDC, B( 1, L2 ), 1 )
                  VEC( 2, 2 ) = C( K2, L2 ) - ( SUML+SGN*SUMR )
*
                  CALL SLASY2( .FALSE., .FALSE., ISGN, 2, 2,
     $                         A( K1, K1 ), LDA, B( L1, L1 ), LDB, VEC,
     $                         2, SCALOC, X, 2, XNORM, IERR )
                  IF( IERR.NE.0 )
     $               INFO = 1
*
                  IF( SCALOC.NE.ONE ) THEN
                     DO 50 J = 1, N
                        CALL SSCAL( M, SCALOC, C( 1, J ), 1 )
   50                CONTINUE
                     SCALE = SCALE*SCALOC
                  END IF
                  C( K1, L1 ) = X( 1, 1 )
                  C( K1, L2 ) = X( 1, 2 )
                  C( K2, L1 ) = X( 2, 1 )
                  C( K2, L2 ) = X( 2, 2 )
               END IF
*
   60       CONTINUE
*
   70    CONTINUE
*
      ELSE IF( .NOT.NOTRNA .AND. NOTRNB ) THEN
*
*        Solve    A' *X + ISGN*X*B = scale*C.
*
*        The (K,L)th block of X is determined starting from
*        upper-left corner column by column by
*
*          A(K,K)'*X(K,L) + ISGN*X(K,L)*B(L,L) = C(K,L) - R(K,L)
*
*        Where
*                   K-1                        L-1
*          R(K,L) = SUM [A(I,K)'*X(I,L)] +ISGN*SUM [X(K,J)*B(J,L)]
*                   I=1                        J=1
*
*        Start column loop (index = L)
*        L1 (L2): column index of the first (last) row of X(K,L)
*
         LNEXT = 1
         DO 130 L = 1, N
            IF( L.LT.LNEXT )
     $         GO TO 130
            IF( L.EQ.N ) THEN
               L1 = L
               L2 = L
            ELSE
               IF( B( L+1, L ).NE.ZERO ) THEN
                  L1 = L
                  L2 = L + 1
                  LNEXT = L + 2
               ELSE
                  L1 = L
                  L2 = L
                  LNEXT = L + 1
               END IF
            END IF
*
*           Start row loop (index = K)
*           K1 (K2): row index of the first (last) row of X(K,L)
*
            KNEXT = 1
            DO 120 K = 1, M
               IF( K.LT.KNEXT )
     $            GO TO 120
               IF( K.EQ.M ) THEN
                  K1 = K
                  K2 = K
               ELSE
                  IF( A( K+1, K ).NE.ZERO ) THEN
                     K1 = K
                     K2 = K + 1
                     KNEXT = K + 2
                  ELSE
                     K1 = K
                     K2 = K
                     KNEXT = K + 1
                  END IF
               END IF
*
               IF( L1.EQ.L2 .AND. K1.EQ.K2 ) THEN
                  SUML = SDOT( K1-1, A( 1, K1 ), 1, C( 1, L1 ), 1 )
                  SUMR = SDOT( L1-1, C( K1, 1 ), LDC, B( 1, L1 ), 1 )
                  VEC( 1, 1 ) = C( K1, L1 ) - ( SUML+SGN*SUMR )
                  SCALOC = ONE
*
                  A11 = A( K1, K1 ) + SGN*B( L1, L1 )
                  DA11 = ABS( A11 )
                  IF( DA11.LE.SMIN ) THEN
                     A11 = SMIN
                     DA11 = SMIN
                     INFO = 1
                  END IF
                  DB = ABS( VEC( 1, 1 ) )
                  IF( DA11.LT.ONE .AND. DB.GT.ONE ) THEN
                     IF( DB.GT.BIGNUM*DA11 )
     $                  SCALOC = ONE / DB
                  END IF
                  X( 1, 1 ) = ( VEC( 1, 1 )*SCALOC ) / A11
*
                  IF( SCALOC.NE.ONE ) THEN
                     DO 80 J = 1, N
                        CALL SSCAL( M, SCALOC, C( 1, J ), 1 )
   80                CONTINUE
                     SCALE = SCALE*SCALOC
                  END IF
                  C( K1, L1 ) = X( 1, 1 )
*
               ELSE IF( L1.EQ.L2 .AND. K1.NE.K2 ) THEN
*
                  SUML = SDOT( K1-1, A( 1, K1 ), 1, C( 1, L1 ), 1 )
                  SUMR = SDOT( L1-1, C( K1, 1 ), LDC, B( 1, L1 ), 1 )
                  VEC( 1, 1 ) = C( K1, L1 ) - ( SUML+SGN*SUMR )
*
                  SUML = SDOT( K1-1, A( 1, K2 ), 1, C( 1, L1 ), 1 )
                  SUMR = SDOT( L1-1, C( K2, 1 ), LDC, B( 1, L1 ), 1 )
                  VEC( 2, 1 ) = C( K2, L1 ) - ( SUML+SGN*SUMR )
*
                  CALL SLALN2( .TRUE., 2, 1, SMIN, ONE, A( K1, K1 ),
     $                         LDA, ONE, ONE, VEC, 2, -SGN*B( L1, L1 ),
     $                         ZERO, X, 2, SCALOC, XNORM, IERR )
                  IF( IERR.NE.0 )
     $               INFO = 1
*
                  IF( SCALOC.NE.ONE ) THEN
                     DO 90 J = 1, N
                        CALL SSCAL( M, SCALOC, C( 1, J ), 1 )
   90                CONTINUE
                     SCALE = SCALE*SCALOC
                  END IF
                  C( K1, L1 ) = X( 1, 1 )
                  C( K2, L1 ) = X( 2, 1 )
*
               ELSE IF( L1.NE.L2 .AND. K1.EQ.K2 ) THEN
*
                  SUML = SDOT( K1-1, A( 1, K1 ), 1, C( 1, L1 ), 1 )
                  SUMR = SDOT( L1-1, C( K1, 1 ), LDC, B( 1, L1 ), 1 )
                  VEC( 1, 1 ) = SGN*( C( K1, L1 )-( SUML+SGN*SUMR ) )
*
                  SUML = SDOT( K1-1, A( 1, K1 ), 1, C( 1, L2 ), 1 )
                  SUMR = SDOT( L1-1, C( K1, 1 ), LDC, B( 1, L2 ), 1 )
                  VEC( 2, 1 ) = SGN*( C( K1, L2 )-( SUML+SGN*SUMR ) )
*
                  CALL SLALN2( .TRUE., 2, 1, SMIN, ONE, B( L1, L1 ),
     $                         LDB, ONE, ONE, VEC, 2, -SGN*A( K1, K1 ),
     $                         ZERO, X, 2, SCALOC, XNORM, IERR )
                  IF( IERR.NE.0 )
     $               INFO = 1
*
                  IF( SCALOC.NE.ONE ) THEN
                     DO 100 J = 1, N
                        CALL SSCAL( M, SCALOC, C( 1, J ), 1 )
  100                CONTINUE
                     SCALE = SCALE*SCALOC
                  END IF
                  C( K1, L1 ) = X( 1, 1 )
                  C( K1, L2 ) = X( 2, 1 )
*
               ELSE IF( L1.NE.L2 .AND. K1.NE.K2 ) THEN
*
                  SUML = SDOT( K1-1, A( 1, K1 ), 1, C( 1, L1 ), 1 )
                  SUMR = SDOT( L1-1, C( K1, 1 ), LDC, B( 1, L1 ), 1 )
                  VEC( 1, 1 ) = C( K1, L1 ) - ( SUML+SGN*SUMR )
*
                  SUML = SDOT( K1-1, A( 1, K1 ), 1, C( 1, L2 ), 1 )
                  SUMR = SDOT( L1-1, C( K1, 1 ), LDC, B( 1, L2 ), 1 )
                  VEC( 1, 2 ) = C( K1, L2 ) - ( SUML+SGN*SUMR )
*
                  SUML = SDOT( K1-1, A( 1, K2 ), 1, C( 1, L1 ), 1 )
                  SUMR = SDOT( L1-1, C( K2, 1 ), LDC, B( 1, L1 ), 1 )
                  VEC( 2, 1 ) = C( K2, L1 ) - ( SUML+SGN*SUMR )
*
                  SUML = SDOT( K1-1, A( 1, K2 ), 1, C( 1, L2 ), 1 )
                  SUMR = SDOT( L1-1, C( K2, 1 ), LDC, B( 1, L2 ), 1 )
                  VEC( 2, 2 ) = C( K2, L2 ) - ( SUML+SGN*SUMR )
*
                  CALL SLASY2( .TRUE., .FALSE., ISGN, 2, 2, A( K1, K1 ),
     $                         LDA, B( L1, L1 ), LDB, VEC, 2, SCALOC, X,
     $                         2, XNORM, IERR )
                  IF( IERR.NE.0 )
     $               INFO = 1
*
                  IF( SCALOC.NE.ONE ) THEN
                     DO 110 J = 1, N
                        CALL SSCAL( M, SCALOC, C( 1, J ), 1 )
  110                CONTINUE
                     SCALE = SCALE*SCALOC
                  END IF
                  C( K1, L1 ) = X( 1, 1 )
                  C( K1, L2 ) = X( 1, 2 )
                  C( K2, L1 ) = X( 2, 1 )
                  C( K2, L2 ) = X( 2, 2 )
               END IF
*
  120       CONTINUE
  130    CONTINUE
*
      ELSE IF( .NOT.NOTRNA .AND. .NOT.NOTRNB ) THEN
*
*        Solve    A'*X + ISGN*X*B' = scale*C.
*
*        The (K,L)th block of X is determined starting from
*        top-right corner column by column by
*
*           A(K,K)'*X(K,L) + ISGN*X(K,L)*B(L,L)' = C(K,L) - R(K,L)
*
*        Where
*                     K-1                          N
*            R(K,L) = SUM [A(I,K)'*X(I,L)] + ISGN*SUM [X(K,J)*B(L,J)'].
*                     I=1                        J=L+1
*
*        Start column loop (index = L)
*        L1 (L2): column index of the first (last) row of X(K,L)
*
         LNEXT = N
         DO 190 L = N, 1, -1
            IF( L.GT.LNEXT )
     $         GO TO 190
            IF( L.EQ.1 ) THEN
               L1 = L
               L2 = L
            ELSE
               IF( B( L, L-1 ).NE.ZERO ) THEN
                  L1 = L - 1
                  L2 = L
                  LNEXT = L - 2
               ELSE
                  L1 = L
                  L2 = L
                  LNEXT = L - 1
               END IF
            END IF
*
*           Start row loop (index = K)
*           K1 (K2): row index of the first (last) row of X(K,L)
*
            KNEXT = 1
            DO 180 K = 1, M
               IF( K.LT.KNEXT )
     $            GO TO 180
               IF( K.EQ.M ) THEN
                  K1 = K
                  K2 = K
               ELSE
                  IF( A( K+1, K ).NE.ZERO ) THEN
                     K1 = K
                     K2 = K + 1
                     KNEXT = K + 2
                  ELSE
                     K1 = K
                     K2 = K
                     KNEXT = K + 1
                  END IF
               END IF
*
               IF( L1.EQ.L2 .AND. K1.EQ.K2 ) THEN
                  SUML = SDOT( K1-1, A( 1, K1 ), 1, C( 1, L1 ), 1 )
                  SUMR = SDOT( N-L1, C( K1, MIN( L1+1, N ) ), LDC,
     $                         B( L1, MIN( L1+1, N ) ), LDB )
                  VEC( 1, 1 ) = C( K1, L1 ) - ( SUML+SGN*SUMR )
                  SCALOC = ONE
*
                  A11 = A( K1, K1 ) + SGN*B( L1, L1 )
                  DA11 = ABS( A11 )
                  IF( DA11.LE.SMIN ) THEN
                     A11 = SMIN
                     DA11 = SMIN
                     INFO = 1
                  END IF
                  DB = ABS( VEC( 1, 1 ) )
                  IF( DA11.LT.ONE .AND. DB.GT.ONE ) THEN
                     IF( DB.GT.BIGNUM*DA11 )
     $                  SCALOC = ONE / DB
                  END IF
                  X( 1, 1 ) = ( VEC( 1, 1 )*SCALOC ) / A11
*
                  IF( SCALOC.NE.ONE ) THEN
                     DO 140 J = 1, N
                        CALL SSCAL( M, SCALOC, C( 1, J ), 1 )
  140                CONTINUE
                     SCALE = SCALE*SCALOC
                  END IF
                  C( K1, L1 ) = X( 1, 1 )
*
               ELSE IF( L1.EQ.L2 .AND. K1.NE.K2 ) THEN
*
                  SUML = SDOT( K1-1, A( 1, K1 ), 1, C( 1, L1 ), 1 )
                  SUMR = SDOT( N-L2, C( K1, MIN( L2+1, N ) ), LDC,
     $                         B( L1, MIN( L2+1, N ) ), LDB )
                  VEC( 1, 1 ) = C( K1, L1 ) - ( SUML+SGN*SUMR )
*
                  SUML = SDOT( K1-1, A( 1, K2 ), 1, C( 1, L1 ), 1 )
                  SUMR = SDOT( N-L2, C( K2, MIN( L2+1, N ) ), LDC,
     $                         B( L1, MIN( L2+1, N ) ), LDB )
                  VEC( 2, 1 ) = C( K2, L1 ) - ( SUML+SGN*SUMR )
*
                  CALL SLALN2( .TRUE., 2, 1, SMIN, ONE, A( K1, K1 ),
     $                         LDA, ONE, ONE, VEC, 2, -SGN*B( L1, L1 ),
     $                         ZERO, X, 2, SCALOC, XNORM, IERR )
                  IF( IERR.NE.0 )
     $               INFO = 1
*
                  IF( SCALOC.NE.ONE ) THEN
                     DO 150 J = 1, N
                        CALL SSCAL( M, SCALOC, C( 1, J ), 1 )
  150                CONTINUE
                     SCALE = SCALE*SCALOC
                  END IF
                  C( K1, L1 ) = X( 1, 1 )
                  C( K2, L1 ) = X( 2, 1 )
*
               ELSE IF( L1.NE.L2 .AND. K1.EQ.K2 ) THEN
*
                  SUML = SDOT( K1-1, A( 1, K1 ), 1, C( 1, L1 ), 1 )
                  SUMR = SDOT( N-L2, C( K1, MIN( L2+1, N ) ), LDC,
     $                         B( L1, MIN( L2+1, N ) ), LDB )
                  VEC( 1, 1 ) = SGN*( C( K1, L1 )-( SUML+SGN*SUMR ) )
*
                  SUML = SDOT( K1-1, A( 1, K1 ), 1, C( 1, L2 ), 1 )
                  SUMR = SDOT( N-L2, C( K1, MIN( L2+1, N ) ), LDC,
     $                         B( L2, MIN( L2+1, N ) ), LDB )
                  VEC( 2, 1 ) = SGN*( C( K1, L2 )-( SUML+SGN*SUMR ) )
*
                  CALL SLALN2( .FALSE., 2, 1, SMIN, ONE, B( L1, L1 ),
     $                         LDB, ONE, ONE, VEC, 2, -SGN*A( K1, K1 ),
     $                         ZERO, X, 2, SCALOC, XNORM, IERR )
                  IF( IERR.NE.0 )
     $               INFO = 1
*
                  IF( SCALOC.NE.ONE ) THEN
                     DO 160 J = 1, N
                        CALL SSCAL( M, SCALOC, C( 1, J ), 1 )
  160                CONTINUE
                     SCALE = SCALE*SCALOC
                  END IF
                  C( K1, L1 ) = X( 1, 1 )
                  C( K1, L2 ) = X( 2, 1 )
*
               ELSE IF( L1.NE.L2 .AND. K1.NE.K2 ) THEN
*
                  SUML = SDOT( K1-1, A( 1, K1 ), 1, C( 1, L1 ), 1 )
                  SUMR = SDOT( N-L2, C( K1, MIN( L2+1, N ) ), LDC,
     $                         B( L1, MIN( L2+1, N ) ), LDB )
                  VEC( 1, 1 ) = C( K1, L1 ) - ( SUML+SGN*SUMR )
*
                  SUML = SDOT( K1-1, A( 1, K1 ), 1, C( 1, L2 ), 1 )
                  SUMR = SDOT( N-L2, C( K1, MIN( L2+1, N ) ), LDC,
     $                         B( L2, MIN( L2+1, N ) ), LDB )
                  VEC( 1, 2 ) = C( K1, L2 ) - ( SUML+SGN*SUMR )
*
                  SUML = SDOT( K1-1, A( 1, K2 ), 1, C( 1, L1 ), 1 )
                  SUMR = SDOT( N-L2, C( K2, MIN( L2+1, N ) ), LDC,
     $                         B( L1, MIN( L2+1, N ) ), LDB )
                  VEC( 2, 1 ) = C( K2, L1 ) - ( SUML+SGN*SUMR )
*
                  SUML = SDOT( K1-1, A( 1, K2 ), 1, C( 1, L2 ), 1 )
                  SUMR = SDOT( N-L2, C( K2, MIN( L2+1, N ) ), LDC,
     $                         B( L2, MIN(L2+1, N ) ), LDB )
                  VEC( 2, 2 ) = C( K2, L2 ) - ( SUML+SGN*SUMR )
*
                  CALL SLASY2( .TRUE., .TRUE., ISGN, 2, 2, A( K1, K1 ),
     $                         LDA, B( L1, L1 ), LDB, VEC, 2, SCALOC, X,
     $                         2, XNORM, IERR )
                  IF( IERR.NE.0 )
     $               INFO = 1
*
                  IF( SCALOC.NE.ONE ) THEN
                     DO 170 J = 1, N
                        CALL SSCAL( M, SCALOC, C( 1, J ), 1 )
  170                CONTINUE
                     SCALE = SCALE*SCALOC
                  END IF
                  C( K1, L1 ) = X( 1, 1 )
                  C( K1, L2 ) = X( 1, 2 )
                  C( K2, L1 ) = X( 2, 1 )
                  C( K2, L2 ) = X( 2, 2 )
               END IF
*
  180       CONTINUE
  190    CONTINUE
*
      ELSE IF( NOTRNA .AND. .NOT.NOTRNB ) THEN
*
*        Solve    A*X + ISGN*X*B' = scale*C.
*
*        The (K,L)th block of X is determined starting from
*        bottom-right corner column by column by
*
*            A(K,K)*X(K,L) + ISGN*X(K,L)*B(L,L)' = C(K,L) - R(K,L)
*
*        Where
*                      M                          N
*            R(K,L) = SUM [A(K,I)*X(I,L)] + ISGN*SUM [X(K,J)*B(L,J)'].
*                    I=K+1                      J=L+1
*
*        Start column loop (index = L)
*        L1 (L2): column index of the first (last) row of X(K,L)
*
         LNEXT = N
         DO 250 L = N, 1, -1
            IF( L.GT.LNEXT )
     $         GO TO 250
            IF( L.EQ.1 ) THEN
               L1 = L
               L2 = L
            ELSE
               IF( B( L, L-1 ).NE.ZERO ) THEN
                  L1 = L - 1
                  L2 = L
                  LNEXT = L - 2
               ELSE
                  L1 = L
                  L2 = L
                  LNEXT = L - 1
               END IF
            END IF
*
*           Start row loop (index = K)
*           K1 (K2): row index of the first (last) row of X(K,L)
*
            KNEXT = M
            DO 240 K = M, 1, -1
               IF( K.GT.KNEXT )
     $            GO TO 240
               IF( K.EQ.1 ) THEN
                  K1 = K
                  K2 = K
               ELSE
                  IF( A( K, K-1 ).NE.ZERO ) THEN
                     K1 = K - 1
                     K2 = K
                     KNEXT = K - 2
                  ELSE
                     K1 = K
                     K2 = K
                     KNEXT = K - 1
                  END IF
               END IF
*
               IF( L1.EQ.L2 .AND. K1.EQ.K2 ) THEN
                  SUML = SDOT( M-K1, A( K1, MIN(K1+1, M ) ), LDA,
     $                   C( MIN( K1+1, M ), L1 ), 1 )
                  SUMR = SDOT( N-L1, C( K1, MIN( L1+1, N ) ), LDC,
     $                         B( L1, MIN( L1+1, N ) ), LDB )
                  VEC( 1, 1 ) = C( K1, L1 ) - ( SUML+SGN*SUMR )
                  SCALOC = ONE
*
                  A11 = A( K1, K1 ) + SGN*B( L1, L1 )
                  DA11 = ABS( A11 )
                  IF( DA11.LE.SMIN ) THEN
                     A11 = SMIN
                     DA11 = SMIN
                     INFO = 1
                  END IF
                  DB = ABS( VEC( 1, 1 ) )
                  IF( DA11.LT.ONE .AND. DB.GT.ONE ) THEN
                     IF( DB.GT.BIGNUM*DA11 )
     $                  SCALOC = ONE / DB
                  END IF
                  X( 1, 1 ) = ( VEC( 1, 1 )*SCALOC ) / A11
*
                  IF( SCALOC.NE.ONE ) THEN
                     DO 200 J = 1, N
                        CALL SSCAL( M, SCALOC, C( 1, J ), 1 )
  200                CONTINUE
                     SCALE = SCALE*SCALOC
                  END IF
                  C( K1, L1 ) = X( 1, 1 )
*
               ELSE IF( L1.EQ.L2 .AND. K1.NE.K2 ) THEN
*
                  SUML = SDOT( M-K2, A( K1, MIN( K2+1, M ) ), LDA,
     $                         C( MIN( K2+1, M ), L1 ), 1 )
                  SUMR = SDOT( N-L2, C( K1, MIN( L2+1, N ) ), LDC,
     $                         B( L1, MIN( L2+1, N ) ), LDB )
                  VEC( 1, 1 ) = C( K1, L1 ) - ( SUML+SGN*SUMR )
*
                  SUML = SDOT( M-K2, A( K2, MIN( K2+1, M ) ), LDA,
     $                         C( MIN( K2+1, M ), L1 ), 1 )
                  SUMR = SDOT( N-L2, C( K2, MIN( L2+1, N ) ), LDC,
     $                         B( L1, MIN( L2+1, N ) ), LDB )
                  VEC( 2, 1 ) = C( K2, L1 ) - ( SUML+SGN*SUMR )
*
                  CALL SLALN2( .FALSE., 2, 1, SMIN, ONE, A( K1, K1 ),
     $                         LDA, ONE, ONE, VEC, 2, -SGN*B( L1, L1 ),
     $                         ZERO, X, 2, SCALOC, XNORM, IERR )
                  IF( IERR.NE.0 )
     $               INFO = 1
*
                  IF( SCALOC.NE.ONE ) THEN
                     DO 210 J = 1, N
                        CALL SSCAL( M, SCALOC, C( 1, J ), 1 )
  210                CONTINUE
                     SCALE = SCALE*SCALOC
                  END IF
                  C( K1, L1 ) = X( 1, 1 )
                  C( K2, L1 ) = X( 2, 1 )
*
               ELSE IF( L1.NE.L2 .AND. K1.EQ.K2 ) THEN
*
                  SUML = SDOT( M-K1, A( K1, MIN( K1+1, M ) ), LDA,
     $                         C( MIN( K1+1, M ), L1 ), 1 )
                  SUMR = SDOT( N-L2, C( K1, MIN( L2+1, N ) ), LDC,
     $                         B( L1, MIN( L2+1, N ) ), LDB )
                  VEC( 1, 1 ) = SGN*( C( K1, L1 )-( SUML+SGN*SUMR ) )
*
                  SUML = SDOT( M-K1, A( K1, MIN( K1+1, M ) ), LDA,
     $                         C( MIN( K1+1, M ), L2 ), 1 )
                  SUMR = SDOT( N-L2, C( K1, MIN( L2+1, N ) ), LDC,
     $                         B( L2, MIN( L2+1, N ) ), LDB )
                  VEC( 2, 1 ) = SGN*( C( K1, L2 )-( SUML+SGN*SUMR ) )
*
                  CALL SLALN2( .FALSE., 2, 1, SMIN, ONE, B( L1, L1 ),
     $                         LDB, ONE, ONE, VEC, 2, -SGN*A( K1, K1 ),
     $                         ZERO, X, 2, SCALOC, XNORM, IERR )
                  IF( IERR.NE.0 )
     $               INFO = 1
*
                  IF( SCALOC.NE.ONE ) THEN
                     DO 220 J = 1, N
                        CALL SSCAL( M, SCALOC, C( 1, J ), 1 )
  220                CONTINUE
                     SCALE = SCALE*SCALOC
                  END IF
                  C( K1, L1 ) = X( 1, 1 )
                  C( K1, L2 ) = X( 2, 1 )
*
               ELSE IF( L1.NE.L2 .AND. K1.NE.K2 ) THEN
*
                  SUML = SDOT( M-K2, A( K1, MIN( K2+1, M ) ), LDA,
     $                         C( MIN( K2+1, M ), L1 ), 1 )
                  SUMR = SDOT( N-L2, C( K1, MIN( L2+1, N ) ), LDC,
     $                         B( L1, MIN( L2+1, N ) ), LDB )
                  VEC( 1, 1 ) = C( K1, L1 ) - ( SUML+SGN*SUMR )
*
                  SUML = SDOT( M-K2, A( K1, MIN( K2+1, M ) ), LDA,
     $                         C( MIN( K2+1, M ), L2 ), 1 )
                  SUMR = SDOT( N-L2, C( K1, MIN( L2+1, N ) ), LDC,
     $                         B( L2, MIN( L2+1, N ) ), LDB )
                  VEC( 1, 2 ) = C( K1, L2 ) - ( SUML+SGN*SUMR )
*
                  SUML = SDOT( M-K2, A( K2, MIN( K2+1, M ) ), LDA,
     $                         C( MIN( K2+1, M ), L1 ), 1 )
                  SUMR = SDOT( N-L2, C( K2, MIN( L2+1, N ) ), LDC,
     $                         B( L1, MIN( L2+1, N ) ), LDB )
                  VEC( 2, 1 ) = C( K2, L1 ) - ( SUML+SGN*SUMR )
*
                  SUML = SDOT( M-K2, A( K2, MIN( K2+1, M ) ), LDA,
     $                         C( MIN( K2+1, M ), L2 ), 1 )
                  SUMR = SDOT( N-L2, C( K2, MIN( L2+1, N ) ), LDC,
     $                         B( L2, MIN( L2+1, N ) ), LDB )
                  VEC( 2, 2 ) = C( K2, L2 ) - ( SUML+SGN*SUMR )
*
                  CALL SLASY2( .FALSE., .TRUE., ISGN, 2, 2, A( K1, K1 ),
     $                         LDA, B( L1, L1 ), LDB, VEC, 2, SCALOC, X,
     $                         2, XNORM, IERR )
                  IF( IERR.NE.0 )
     $               INFO = 1
*
                  IF( SCALOC.NE.ONE ) THEN
                     DO 230 J = 1, N
                        CALL SSCAL( M, SCALOC, C( 1, J ), 1 )
  230                CONTINUE
                     SCALE = SCALE*SCALOC
                  END IF
                  C( K1, L1 ) = X( 1, 1 )
                  C( K1, L2 ) = X( 1, 2 )
                  C( K2, L1 ) = X( 2, 1 )
                  C( K2, L2 ) = X( 2, 2 )
               END IF
*
  240       CONTINUE
  250    CONTINUE
*
      END IF
*
      RETURN
*
*     End of STRSYL
*
      END

C
C	$Id: wmdrsm.f,v 1.8 2008-07-27 00:17:36 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE WMDRSM(NUMSYM,DSTBTW,IPTS,XIN,YIN,ARCLEN,XT,YT,IPOSIT)       
C
C  Draw weather symbols along the curve  ((XIN,YIN),I=1,IPTS).
C  ARCLEN contains the cumulative polygonal arclengths of the curve.
C  XT and YT are arrays to be used for plotting the symbols.
C
      include 'wmcomn.h'
C
      PARAMETER (EPS=0.0001)
      DIMENSION XIN(IPTS),YIN(IPTS),ARCLEN(IPTS),XT(IPTS),YT(IPTS)
      DIMENSION IPOSIT(NUMSYM)
C
C  Arithmetic statement function for computing square of distance.
C
      DSQ(A,B) = A**2 + B**2
C
C  Check error status.
C
      IF (ICFELL('WMDRSM - Uncleared prior error',1) .NE. 0) RETURN
C
C  Save fill attribures and set to current values.
C
C
C  Save the current fill attributes and reset.
C
      CALL GQFACI(IER,ICOLD)
      CALL GQPLCI(IER,IPOLD)
      CALL GQFAIS(IER,IFOLD)
      CALL GSFACI(ICOLOR)
      CALL GSFAIS(1)
C
C  Handle the case of drawing a single symbol.
C
      SYMWDH = 0.5*SYMWID
      WDTHSQ = SYMWID*SYMWID 
      IF (NUMSYM.EQ.1 .AND. IFRONT.NE.7 .AND.
     +             ARCLEN(IPTS).LT.BEGDST+SYMWID+ENDDST) THEN
C
C  Draw a single symbol in the center of the curve in the direction
C  determined by the slope of the endpoints of the line.  Extend
C  the line by the amounts in BEGDST and ENDDST.
C
C  Find the midpoint of the input curve and the angle created by the
C  endpoints.
C
        SYMPOS = 0.5*ARCLEN(IPTS)
        CALL WMINTV(SYMPOS,ARCLEN,IPTS,NDX)
        IPOSIT(1) = NDX
        XPM = XIN(NDX)
        YPM = YIN(NDX)
        TDST = SQRT(DSQ(YIN(IPTS)-YIN(1),XIN(IPTS)-XIN(1)))
        SINANG = (YIN(IPTS)-YIN(1))/TDST
        COSANG = (XIN(IPTS)-XIN(1))/TDST
C
C  Calculate the end points for positioning the symbol.
C  
        XPR = XPM+SYMWDH*COSANG
        YPR = YPM+SYMWDH*SINANG
        XPL = XPM-SYMWDH*COSANG
        YPL = YPM-SYMWDH*SINANG
C
C  Get the points making up the symbol.
C
        IF (ABS(ISTYPE(1)) .EQ. 1) THEN
          NOUT = 3
        ELSE
          NOUT = NPTSBZ
        ENDIF
        CALL WMGTSO(XPL,YPL,XPR,YPR,NOUT,XT,YT,ISTYPE(1))
C
C  Close the curve and draw it.
C
        XT(NOUT+1) = XT(1)
        YT(NOUT+1) = YT(1)
        NF = NOUT+1
        IF (IALOFT .NE. 0) THEN
          CALL WMLGPL(NF,XT,YT)
        ELSE
          CALL GFA(NF,XT,YT)
        ENDIF
C
C  Draw end lines.
C
        XT(1) = XPR+ENDDST*COSANG
        YT(1) = YPR+ENDDST*SINANG
        XT(2) = XPL-ENDDST*COSANG
        YT(2) = YPL-ENDDST*SINANG
        CALL WMLGPL(2,XT,YT)
        GO TO 120
      ENDIF
C
      DO 60 I=1,NUMSYM
C
C  Calculate the distance along the curve where the symbol should
C  be placed and find the point on the curve where this is.
C
        IF (NUMSYM .EQ. 1) THEN
          SYMPOS = 0.5*ARCLEN(IPTS)
        ELSE
          SYMPOS = BEGDST+SYMWDH+REAL(I-1)*(DSTBTW+SYMWID)
        ENDIF
        CALL WMINTV(SYMPOS,ARCLEN,IPTS,NDX)
        IPOSIT(I) = NDX
C
C  Back up along the curve half a symbol width.
C
        DO 20 J=1,IPTS
          IF (NDX-J .LT. 1) THEN
            NDXL = 1
            XPL = XIN(NDXL)
            YPL = YIN(NDXL)
            GO TO 90
          ENDIF
          IF (ARCLEN(NDX)-ARCLEN(NDX-J) .LT. SYMWDH) GO TO 20
          NDXL = NDX-J
          GO TO 70
   20   CONTINUE
   70   CONTINUE
C
C  We know that the desired coordinate lies between 
C  (XIN(NDXL),YIN(NDXL)) and (XIN(NDXL+1),YIN(NDXL+1)) -- interpolate 
C  to get the coordinate more accurately.
C
        VNTRVL = ARCLEN(NDXL+1)-ARCLEN(NDXL)
        IF (VNTRVL .LT. EPS) THEN
C
C  Spacing is small enough that interpolation will not matter.
C
          XPL = XIN(NDXL)
          YPL = YIN(NDXL)
        ELSE
          RATIO = (ARCLEN(NDX)-ARCLEN(NDXL)-SYMWDH)/VNTRVL
          XPL = XIN(NDXL)+RATIO*(XIN(NDXL+1)-XIN(NDXL))
          YPL = YIN(NDXL)+RATIO*(YIN(NDXL+1)-YIN(NDXL))
        ENDIF
   90   CONTINUE
C
C  Now, move forward along the curve so that the straight line distance
C  from (XPL,YPL) is a full symbol width.
C
        DO 30 J=1,IPTS
          IF (NDX+J .GT. IPTS) THEN
            NDXR = IPTS
            XPR = XIN(NDXR)
            YPR = YIN(NDXR)
            GO TO 100
          ENDIF
          IF (DSQ(XIN(NDX+J)-XPL,YIN(NDX+J)-YPL) .LT. WDTHSQ) 
     +        GO TO 30
          NDXR = NDX+J
          GO TO 80
   30   CONTINUE
   80   CONTINUE
C
C  We know that the desired coordinate lies between 
C  (XIN(NDXR),YIN(NDXR)) and (XIN(NDXR-1),YIN(NDXR-1)) -- 
C  interpolate to get the coordinate more accurately.
C
        DSTM = SQRT(DSQ(XIN(NDXR-1)-XPL,YIN(NDXR-1)-YPL))
        DSTN = SQRT(DSQ(XIN(NDXR)-XPL,YIN(NDXR)-YPL))
        VNTRVL = ABS(DSTN-DSTM)
        IF (VNTRVL .LT. EPS) THEN
C
C  Spacing is small enough that interpolation will not matter.
C
          XPR = XIN(NDXR)
          YPR = YIN(NDXR)
        ELSE
          RATIO = (SYMWID-DSTM)/VNTRVL
          XPR = XIN(NDXR-1)+RATIO*(XIN(NDXR)-XIN(NDXR-1))
          YPR = YIN(NDXR-1)+RATIO*(YIN(NDXR)-YIN(NDXR-1))
        ENDIF
  100   CONTINUE
C
C  Get the points making up the symbol.
C
        IF (ABS(ISTYPE(I)).EQ.1 .OR. ABS(ISTYPE(I)).EQ.3) THEN
          NOUT = 3
        ELSE
          NOUT = NPTSBZ
        ENDIF
        CALL WMGTSO(XPL,YPL,XPR,YPR,NOUT,XT,YT,ISTYPE(I))
C
C  Add points along the curve and draw.
C
        IF (NDXR-NDXL .GE. 2) THEN
          DO 40 J=NDXL+1,NDXR-1
            XT(NOUT+J-NDXL) = XIN(J)
            YT(NOUT+J-NDXL) = YIN(J)
   40     CONTINUE
          NF = NOUT+NDXR-NDXL-1
        ELSE
          NF = NOUT
        ENDIF
        IF (IALOFT .NE. 0) THEN
          ICOLO = ICOLOR
          IF (ABS(ISTYPE(I)) .EQ. 2) THEN
            ICOLOR = IWARMC
          ELSE IF (ABS(ISTYPE(I)) .EQ. 1) THEN
            ICOLOR = ICOLDC
          ENDIF
          CALL WMLGPL(NF,XT,YT)
          ICOLOR = ICOLO
        ELSE IF(IFRONT.EQ.7) THEN
          CALL GQLWSC(IER,OSCL)
          CALL GSLWSC(DLINWD)
          CALL GPL(2,XT,YT)
          CALL GSLWSC(OSCL)
        ELSE
          IF (ABS(ISTYPE(I)) .EQ. 2) THEN
            CALL GSFACI(IWARMC)
          ELSE IF (ABS(ISTYPE(I)) .EQ. 1) THEN
            CALL GSFACI(ICOLDC)
          ENDIF
          CALL GFA(NF,XT,YT)
        ENDIF
C          
   60 CONTINUE
  120 CONTINUE
C
C  Restore fill attributes.
C
      CALL GSFACI(ICOLD)
      CALL GSPLCI(IPOLD)
      CALL GSFAIS(IFOLD)
C
      RETURN
      END

C
C	$Id: hafton.f,v 1.6 2008-07-27 00:17:14 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE HAFTON (Z,L,M,N,FLO,HI,NLEV,NOPT,NPRM,ISPV,SPVAL)
C
C     SUBROUTINE HAFTON (Z,L,M,N,FLO,HI,NLEV,NOPT,NPRM,ISPV,SPVAL)
C
C
C     DIMENSION OF           Z(L,M)
C     ARGUMENTS
C
C     PURPOSE                HAFTON draws a half-tone picture from data
C                            stored in a rectangular array with the
C                            intensity in the picture proportional to
C                            the data value.
C
C     USAGE                  If the following assumptions are met, use
C
C                                 CALL EZHFTN (Z,M,N)
C
C                              Assumptions:
C                                  .All of the array is to be drawn.
C                                  .Lowest value in Z will be at lowest
C                                   intensity on reader/printer output.
C                                  .Highest value in Z will be at
C                                   highest intensity.
C                                  .Values in between will appear
C                                   linearly spaced.
C                                  .Maximum possible number of
C                                   intensities are used.
C                                  .The picture will have a perimeter
C                                   drawn.
C                                  .FRAME will be called after the
C                                   picture is drawn.
C                                  .Z is filled with numbers that should
C                                   be used (no missing values).
C
C                            If these assumptions are not met, use
C
C                                 CALL HAFTON (Z,L,M,N,FLO,HI,NLEV,
C                                              NOPT,NPRM,ISPV,SPVAL)
C
C     ARGUMENTS
C
C     ON INPUT               Z
C     FOR EZHFTN               M by N array to be used to generate a
C                              half-tone plot.
C
C                            M
C                              First dimension of Z.
C
C                            N
C                              Second dimension of Z.
C
C     ON OUTPUT              All arguments are unchanged.
C     FOR EZHFTN
C
C     ON INPUT               Z
C     FOR HAFTON               The origin of the array to be plotted.
C
C                            L
C                              The first dimension of Z in the calling
C                              program.
C
C                            M
C                              The number of data values to be plotted
C                              in the x-direction (the first subscript
C                              direction).  When plotting all of an
C                              array, L = M.
C
C                            N
C                              The number of data values to be plotted
C                              in the y-direction (the second subscript
C                              direction).
C
C                            FLO
C                              The value of Z that corresponds to the
C                              lowest intensity.  (When NOPT.LT.0, FLO
C                              corresponds to the highest intensity.)
C                              If FLO=HI=0.0, MIN(Z) will be used for FLO.
C
C                            HI
C                              The value of Z that corresponds to the
C                              highest intensity.  (When NOPT.LT.0, HI
C                              corresponds to the lowest intensity.)  If
C                              HI=FLO=0.0, MAX(Z) will be used for HI.
C
C                            NLEV
C                              The number of intensity levels desired.
C                              16 maximum.  If NLEV = 0 or 1, 16 levels
C                              are used.
C
C                            NOPT
C                              Flag to control the mapping of Z onto the
C                              intensities.  The sign of NOPT controls
C                              the directness or inverseness of the
C                              mapping.
C
C                              . NOPT positive yields direct mapping.
C                                The largest value of Z produces the
C                                most dense dots.  On mechanical plotters,
C                                large values of Z will produce a dark
C                                area on the paper.  With the film
C                                development methods used at NCAR,
C                                large values of Z will produce many
C                                (white) dots on the film, also
C                                resulting in a dark area on
C                                reader-printer paper.
C                              . NOPT negative yields inverse mapping.
C                                The smallest values of Z produce the
C                                most dense dots resulting in dark
C                                areas on the paper.
C
C                              The absolute value of NOPT determines the
C                              mapping of Z onto the intensities.  For
C                              ABS(NOPT)
C                              = 0  The mapping is linear.  For
C                                   each intensity there is an equal
C                                   range in Z value.
C                              = 1  The mapping is linear.  For
C                                   each intensity there is an equal
C                                   range in Z value.
C                              = 2  The mapping is exponential.  For
C                                   larger values of Z, there is a
C                                   larger difference in intensity for
C                                   relatively close values of Z.  Details
C                                   in the larger values of Z are displayed
C                                   at the expense of the smaller values
C                                   of Z.
C                              = 3  The mapping is logrithmic, so
C                                   details of smaller values of Z are shown
C                                   at the expense of larger values of Z.
C                              = 4  Sinusoidal mapping, so mid-range values
C                                   of Z show details at the expense of
C                                   extreme values of Z.
C                              = 5  Arcsine mapping, so extreme values of
C                                   Z are shown at the expense of mid-range
C                                   values of Z.
C
C                            NPRM
C                              Flag to control the drawing of a
C                              perimeter around the half-tone picture.
C
C                              . NPRM=0:  The perimeter is drawn with
C                                ticks pointing at data locations.
C                                (Side lengths are proportional to number
C                                of data values.)
C                              . NPRM positive:  No perimeter is drawn.  The
C                                picture fills the frame.
C                              . NPRM negative:  The picture is within the
C                                confines of the user's current viewport
C                                setting.
C
C                            ISPV
C                              Flag to tell if the special value feature
C                              is being used.  The special value feature
C                              is used to mark areas where the data is
C                              not known or holes are wanted in the
C                              picture.
C
C                              . ISPV = 0:  Special value feature not in
C                                use.  SPVAL is ignored.
C                              . ISPV non-zero:  Special value feature
C                                in use.  SPVAL defines the special
C                                value.  Where Z contains the special
C                                value, no half-tone is drawn.  If ISPV
C                                = 0  Special value feature not in use.
C                                     SPVAL is ignored.
C                                = 1  Nothing is drawn in special value
C                                     area.
C                                = 2  Contiguous special value areas are
C                                     surrounded by a polygonal line.
C                                = 3  Special value areas are filled
C                                     with X(s).
C                                = 4  Special value areas are filled in
C                                     with the highest intensity.
C
C                            SPVAL
C                              The value used in Z to denote missing
C                              values.  This argument is ignored if
C                              ISPV = 0.
C
C     ON OUTPUT              All arguments are unchanged.
C     FOR HAFTON
C
C     NOTE                   This routine produces a huge number of
C                            plotter instructions per picture, averaging
C                            over 100,000 line-draws per frame when M = N.
C
C
C     ENTRY POINTS           EZHFTN, HAFTON, ZLSET, GRAY, BOUND, HFINIT,
C                            HFINITX
C
C     COMMON BLOCKS          HAFT01, HAFT02, HAFT03, HAFT04
C
C     REQUIRED LIBRARY       GRIDAL, the ERPRT77 package and the SPPS.
C     ROUTINES
C
C     REQUIRED GKS LEVEL     0A
C
C     I/O                    Plots half-tone picture.
C
C     PRECISION              Single
C
C     LANGUAGE               FORTRAN
C
C     HISTORY                Rewrite of PHOMAP originally written by
C                            M. Perry of High Altitude Observatory,
C                            NCAR.
C
C     ALGORITHM              Bi-linear interpolation on plotter
C                            (resolution-limited) grid of normalized
C                            representation of data.
C
C     PORTABILITY            ANSI FORTRAN 77.
C
C
C
C INTERNAL PARAMTERSs
C VALUES SET IN BLOCK DATA
C         NAME  DEFAULT                   FUNCTION
C         ----  -------                   ________
C
C         XLT     0.1    Left-hand edge of the plot when NSET=0.  (0.0=
C                        left edge of frame, 1.0=right edge of frame.)
C         YBT     0.1    Bottom edge of the plot when NSET=0.  (0.0=
C                        bottom of frame, 1.0=top of frame.)
C         SIDE    0.8    Length of longer edge of plot (see also EXT).
C         EXT     .25    Lengths of the sides of the plot are propor-
C                        tional to M and N (when NSET=0) except in
C                        extreme cases, namely, when MIN(M,N)/MAX(M,N)
C                        is less than EXT.  Then a square plot is pro-
C                        duced.  When a rectangular plot is produced,
C                        the plot is centered on the frame (as long as
C                        SIDE+2*XLT = SIDE+2*YBT=1., as with the
C                        defaults.)
C         ALPHA   1.6    A parameter to control the extremeness of the
C                        mapping function specified by NOPT.  (For
C                        ABS(NOPT)=0 or 1, the mapping function is
C                        linear and independent of ALPHA.)  For the non-
C                        linear mapping functions, when ALPHA is changed
C                        to a number closer to 1., the mapping function
C                        becomes more linear; when ALPHA is changed to
C                        a larger number, the mapping function becomes
C                        more extreme.
C         MXLEV   16     Maximum number of levels.  Limited by plotter.
C         NCRTG   8      Number of CRT units per gray-scale cell.
C                        Limited by plotter.
C         NCRTF   1024   Number of plotter address units per frame.
C         IL    (Below)  An array defining which of the available in-
C                        tensities are used when less than the maximum
C                        number of intensities are requested.
C
C
C   NLEV         Intensities Used
C   ____         ________________
C    2           5,11,
C    3           4, 8,12,
C    4           3, 6,10,13,
C    5           2, 5, 8,11,14,
C    6           1, 4, 7, 9,12,15,
C    7           1, 4, 6, 8,10,12,15,
C    8           1, 3, 5, 7, 9,11,13,15,
C    9           1, 3, 4, 6, 8,10,12,13,15
C   10           1, 3, 4, 6, 7, 9,10,12,13,15,
C   11           1, 2, 3, 5, 6, 8,10,11,13,14,15,
C   12           1, 2, 3, 5, 6, 7, 9,10,11,13,14,15,
C   13           1, 2, 3, 4, 6, 7, 8, 9,10,12,13,14,15
C   14           1, 2, 3, 4, 5, 6, 7, 9,10,11,12,13,14,15,
C   15           1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15,
C   16           0, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15
C
C

      SAVE
      DIMENSION       Z(L,N)      ,PX(2)       ,PY(2)
      DIMENSION       ZLEV(16)    ,VIEW(4)     ,WIND(4)  ,RECT(4)
      DIMENSION                    VIEW2(4)    ,WIND2(4)
      CHARACTER*11    IDUMMY
C
C
      COMMON /HAFTO1/ I          ,J          ,INTEN
      COMMON /HAFTO2/ GLO        ,HA         ,NOPTN      ,ALPHA      ,
     1                NSPV       ,SP         ,ICNST
      COMMON /HAFTO3/ XLT        ,YBT        ,SIDE       ,EXT        ,
     1                IOFFM      ,ALPH       ,MXLEV      ,NCRTG      ,
     2                NCRTF      ,IL(135)
      COMMON /HAFTO4/ NPTMAX     ,NPOINT     ,XPNT(50)  ,YPNT(50)
C
C Do a call forcing a BLOCKDATA to be loaded from a binary library.
C
      CALL HFINIT
C
C THE FOLLOWING CALL IS FOR GATHERING STATISTICS ON LIBRARY USE AT NCAR
C
      CALL Q8QST4 ('GRAPHX','HAFTON','HAFTON','VERSION  1')
C
      NPOINT = 0
      ALPHA = ALPH
      GLO = FLO
      HA = HI
      NLEVL = MIN(ABS(NLEV),MXLEV)
      IF (NLEVL .LE. 1) NLEVL = MXLEV
      NOPTN = NOPT
      IF (NOPTN .EQ. 0) NOPTN = 1
      NPRIM = NPRM
      NSPV = MAX(MIN(ISPV,4),0)
      IF (NSPV .NE. 0) SP = SPVAL
      MX = L
      NX = M
      NY = N
      CRTF = NCRTF
      MSPV = 0
C
C SET INTENSITY BOUNDARY LEVELS
C
      CALL ZLSET (Z,MX,NX,NY,ZLEV,NLEVL)
C
C SET UP PERIMETER
C
      X3 = NX
      Y3 = NY
      CALL GETSET (VIEW(1),VIEW(2),VIEW(3),VIEW(4),
     +             WIND(1),WIND(2),WIND(3),WIND(4),IOLLS)
      IF (NPRIM.LT.0) THEN
C
         X1 = VIEW(1)
         X2 = VIEW(2)
         Y1 = VIEW(3)
         Y2 = VIEW(4)
      ELSE IF (NPRIM.EQ.0) THEN
         X1 = XLT
         X2 = XLT+SIDE
         Y1 = YBT
         Y2 = YBT+SIDE
         IF (MIN(X3,Y3)/MAX(X3,Y3) .GE. EXT) THEN
            IF (NX-NY.LT.0) THEN
               X2 =SIDE*X3/Y3+XLT
               X2 = (REAL(INT(X2*CRTF/REAL(NCRTG)))*REAL(NCRTG))/CRTF
            ELSE IF (NX-NY.GT.0) THEN
               Y2 = SIDE*Y3/X3+YBT
               Y2 = (REAL(INT(Y2*CRTF/REAL(NCRTG)))*REAL(NCRTG))/CRTF
            END IF
         END IF
      ELSE IF (NPRIM.GT.0) THEN
         X1 = 0.0
         X2 = 1.0
         Y1 = 0.0
         Y2 = 1.0
      END IF
      MX1 = X1*CRTF
      MX2 = X2*CRTF
      MY1 = Y1*CRTF
      MY2 = Y2*CRTF
      IF (NPRIM.GT.0) THEN
         MX1 = 1
         MY1 = 1
         MX2 = NCRTF
         MY2 = NCRTF
      END IF
C
C
C
C
C
C
C Define scaling for PERIM and draw perimeter if NPRIM is zero.
C
        CALL SET (X1,X2,Y1,Y2,1.0,X3,1.0,Y3,1)
        IF (NPRIM .EQ. 0) CALL PERIM (NX-1,1,NY-1,1)
        IF (ICNST .NE. 0) THEN
C
        CALL WTSTR((X3+1.)/2.,(Y3+1.)/2.,'CONSTANT FIELD',2,0,0)
        GO TO 132
      END IF
C
C FIND OFFSET FOR REFERENCE TO IL, WHICH IS TRIANGULAR
C
      IOFFST = NLEVL*((NLEVL-1)/2)+MOD(NLEVL-1,2)*(NLEVL/2)-1
C
C OUTPUT INTENSITY SCALE
C
      IF (NPRIM .GT. 0) GO TO 112
      LEV = 0
      KX = (1.1*XLT+SIDE)*CRTF
      KY = YBT*CRTF
      NNX = KX/NCRTG
  109 LEV = LEV+1
      ISUB = IOFFST+LEV
      INTEN = IL(ISUB)
      IF (NOPTN .LT. 0) INTEN = MXLEV-INTEN
      NNY = KY/NCRTG
      DO 111 JJ=1,3
         DO 110 II=1,10
            I = NNX+II
            J = NNY+JJ
            CALL GRAY
  110    CONTINUE
  111 CONTINUE
      IF (LEV .GE. NLEVL) GO TO 112
        WRITE(IDUMMY,'(G11.4)') ZLEV(LEV)
C     TKX = KX
C     TKY = KY+38
      CALL GQCLIP (IERR,ICLP,RECT)
      CALL GSCLIP (0)
      CALL WTSTR (CPUX(KX),CPUY(KY+38),IDUMMY,0,0,-1)
      CALL GSCLIP (ICLP)
C
C
C ADJUST 38 TO PLOTTER.
C
      KY = KY+52
C
C ADJUST 52 TO PLOTTER.
C
      GO TO 109
C
C STEP THROUGH PLOTTER GRID OF INTENSITY CELLS.
C
  112 IMIN = (MX1-1)/NCRTG+1
      IMAX = (MX2-1)/NCRTG
      JMIN = (MY1-1)/NCRTG+1
      JMAX = (MY2-1)/NCRTG
      XL = IMAX-IMIN+1
      YL = JMAX-JMIN+1
      XN = NX
      YN = NY
      LSRT = NLEVL/2
      DO 130 J=JMIN,JMAX
C
C FIND Y FOR THIS J AND Z FOR THIS Y.
C
       YJ = (REAL(J-JMIN)+.5)/YL*(YN-1.)+1.
         LOWY = YJ
         YPART = YJ-REAL(LOWY)
         IF (LOWY .NE. NY) GO TO 113
         LOWY = LOWY-1
         YPART = 1.
  113    IPEN = 0
         ZLFT = Z(1,LOWY)+YPART*(Z(1,LOWY+1)-Z(1,LOWY))
         ZRHT = Z(2,LOWY)+YPART*(Z(2,LOWY+1)-Z(2,LOWY))
         IF (NSPV .EQ. 0) GO TO 114
         IF (Z(1,LOWY).EQ.SP .OR. Z(2,LOWY).EQ.SP .OR.
     1       Z(1,LOWY+1).EQ.SP .OR. Z(2,LOWY+1).EQ.SP) IPEN = 1
  114    IF (IPEN .EQ. 1) GO TO 117
C
C FIND INT FOR THIS Z.
C
         IF (ZLFT .GT. ZLEV(LSRT+1)) GO TO 116
  115    IF (ZLFT .GE. ZLEV(LSRT)) GO TO 117
C
C LOOK LOWER
C
         IF (LSRT .LE. 1) GO TO 117
         LSRT = LSRT-1
         GO TO 115
C
C LOOK HIGHER
C
  116    IF (LSRT .GE. NLEVL) GO TO 117
         LSRT = LSRT+1
         IF (ZLFT .GT. ZLEV(LSRT+1)) GO TO 116
C
C OK
C
  117    IRHT = 2
         LAST = LSRT
         DO 129 I=IMIN,IMAX
C
C FIND X FOR THIS I AND Z FOR THIS X AND Y.
C
            IADD = 1
            XI = (REAL(I-IMIN)+.5)/XL*(XN-1.)+1.
            LOWX = XI
            XPART = XI-REAL(LOWX)
            IF (LOWX .NE. NX) GO TO 118
            LOWX = LOWX-1
            XPART = 1.
C
C TEST FOR INTERPOLATION POSITIONING
C
  118       IF (LOWX .LT. IRHT) GO TO 119
C
C MOVE INTERPOLATION ONE CELL TO THE RIGHT
C
            ZLFT = ZRHT
            IRHT = IRHT+1
            ZRHT = Z(IRHT,LOWY)+YPART*(Z(IRHT,LOWY+1)-Z(IRHT,LOWY))
            IF (NSPV .EQ. 0) GO TO 118
            IPEN = 0
            IF (Z(IRHT-1,LOWY).EQ.SP .OR. Z(IRHT,LOWY).EQ.SP .OR.
     1          Z(IRHT-1,LOWY+1).EQ.SP .OR. Z(IRHT,LOWY+1).EQ.SP)
     2          IPEN = 1
            GO TO 118
  119       IF (IPEN .NE. 1) GO TO 123
C
C SPECIAL VALUE AREA
C
            GO TO (129,120,121,122),NSPV
  120       MSPV = 1
            GO TO 129
  121       PX(1) = I*NCRTG
            PY(1) = J*NCRTG
            PX(2) = PX(1)+NCRTG-1
            PY(2) = PY(1)+NCRTG-1
            CALL GPL (2,PX,PY)
            PYTMP = PY(1)
            PY(1) = PY(2)
            PY(2) = PYTMP
            CALL GPL (2,PX,PY)
C
            GO TO 129
  122       INTEN = MXLEV
            GO TO 128
  123       ZZ = ZLFT+XPART*(ZRHT-ZLFT)
C
C TEST FOR SAME INT AS LAST TIME.
C
            IF (ZZ .GT. ZLEV(LAST+1)) GO TO 126
  124       IF (ZZ .GE. ZLEV(LAST)) GO TO 127
C
C LOOK LOWER
C
            IF (LAST .LE. 1) GO TO 125
            LAST = LAST-1
            GO TO 124
  125       IF (ZZ .LT. ZLEV(LAST)) IADD = 0
            GO TO 127
C
C LOOK HIGHER
C
  126       IF (LAST .GE. NLEVL) GO TO 127
            LAST = LAST+1
            IF (ZZ .GE. ZLEV(LAST+1)) GO TO 126
C
C OK
C
  127       ISUB = LAST+IOFFST+IADD
            INTEN = IL(ISUB)
            IF (NOPTN .LT. 0) INTEN = MXLEV-INTEN
  128       CALL GRAY
  129    CONTINUE
  130 CONTINUE
C
C PUT OUT ANY REMAINING BUFFERED POINTS.
      IF (NPOINT.GT.0) THEN
        CALL GETSET (VIEW2(1),VIEW2(2),VIEW2(3),VIEW2(4),
     +               WIND2(1),WIND2(2),WIND2(3),WIND2(4),IOLLS2)
        CALL SET (0.,1.,0.,1.,0.,1023.,0.,1023.,1)
        CALL POINTS (XPNT,YPNT,NPOINT,0,0)
        CALL SET (VIEW2(1),VIEW2(2),VIEW2(3),VIEW2(4),
     +            WIND2(1),WIND2(2),WIND2(3),WIND2(4),IOLLS2)
      ENDIF
C
C CALL BOUND IF ISPV=2 AND SPECIAL VALUES WERE FOUND.
C
      IF (MSPV .EQ. 1) THEN
        CALL SET (X1,X2,Y1,Y2,1.0,X3,1.0,Y3,1)
        CALL BOUND (Z,MX,NX,NY,SP)
      END IF
  132 CONTINUE
C
C Restore the original SET call.
C
      CALL SET (VIEW(1),VIEW(2),VIEW(3),VIEW(4),
     +          WIND(1),WIND(2),WIND(3),WIND(4),IOLLS)
C
C
      RETURN
C
      END

      SUBROUTINE ZTZRQF( M, N, A, LDA, TAU, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      INTEGER            INFO, LDA, M, N
*     ..
*     .. Array Arguments ..
      COMPLEX*16         A( LDA, * ), TAU( * )
*     ..
*
*  Purpose
*  =======
*
*  This routine is deprecated and has been replaced by routine ZTZRZF.
*
*  ZTZRQF reduces the M-by-N ( M<=N ) complex upper trapezoidal matrix A
*  to upper triangular form by means of unitary transformations.
*
*  The upper trapezoidal matrix A is factored as
*
*     A = ( R  0 ) * Z,
*
*  where Z is an N-by-N unitary matrix and R is an M-by-M upper
*  triangular matrix.
*
*  Arguments
*  =========
*
*  M       (input) INTEGER
*          The number of rows of the matrix A.  M >= 0.
*
*  N       (input) INTEGER
*          The number of columns of the matrix A.  N >= M.
*
*  A       (input/output) COMPLEX*16 array, dimension (LDA,N)
*          On entry, the leading M-by-N upper trapezoidal part of the
*          array A must contain the matrix to be factorized.
*          On exit, the leading M-by-M upper triangular part of A
*          contains the upper triangular matrix R, and elements M+1 to
*          N of the first M rows of A, with the array TAU, represent the
*          unitary matrix Z as a product of M elementary reflectors.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(1,M).
*
*  TAU     (output) COMPLEX*16 array, dimension (M)
*          The scalar factors of the elementary reflectors.
*
*  INFO    (output) INTEGER
*          = 0: successful exit
*          < 0: if INFO = -i, the i-th argument had an illegal value
*
*  Further Details
*  ===============
*
*  The  factorization is obtained by Householder's method.  The kth
*  transformation matrix, Z( k ), whose conjugate transpose is used to
*  introduce zeros into the (m - k + 1)th row of A, is given in the form
*
*     Z( k ) = ( I     0   ),
*              ( 0  T( k ) )
*
*  where
*
*     T( k ) = I - tau*u( k )*u( k )',   u( k ) = (   1    ),
*                                                 (   0    )
*                                                 ( z( k ) )
*
*  tau is a scalar and z( k ) is an ( n - m ) element vector.
*  tau and z( k ) are chosen to annihilate the elements of the kth row
*  of X.
*
*  The scalar tau is returned in the kth element of TAU and the vector
*  u( k ) in the kth row of A, such that the elements of z( k ) are
*  in  a( k, m + 1 ), ..., a( k, n ). The elements of R are returned in
*  the upper triangular part of A.
*
*  Z is given by
*
*     Z =  Z( 1 ) * Z( 2 ) * ... * Z( m ).
*
* =====================================================================
*
*     .. Parameters ..
      COMPLEX*16         CONE, CZERO
      PARAMETER          ( CONE = ( 1.0D+0, 0.0D+0 ),
     $                   CZERO = ( 0.0D+0, 0.0D+0 ) )
*     ..
*     .. Local Scalars ..
      INTEGER            I, K, M1
      COMPLEX*16         ALPHA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          DCONJG, MAX, MIN
*     ..
*     .. External Subroutines ..
      EXTERNAL           XERBLA, ZAXPY, ZCOPY, ZGEMV, ZGERC, ZLACGV,
     $                   ZLARFG
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      IF( M.LT.0 ) THEN
         INFO = -1
      ELSE IF( N.LT.M ) THEN
         INFO = -2
      ELSE IF( LDA.LT.MAX( 1, M ) ) THEN
         INFO = -4
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'ZTZRQF', -INFO )
         RETURN
      END IF
*
*     Perform the factorization.
*
      IF( M.EQ.0 )
     $   RETURN
      IF( M.EQ.N ) THEN
         DO 10 I = 1, N
            TAU( I ) = CZERO
   10    CONTINUE
      ELSE
         M1 = MIN( M+1, N )
         DO 20 K = M, 1, -1
*
*           Use a Householder reflection to zero the kth row of A.
*           First set up the reflection.
*
            A( K, K ) = DCONJG( A( K, K ) )
            CALL ZLACGV( N-M, A( K, M1 ), LDA )
            ALPHA = A( K, K )
            CALL ZLARFG( N-M+1, ALPHA, A( K, M1 ), LDA, TAU( K ) )
            A( K, K ) = ALPHA
            TAU( K ) = DCONJG( TAU( K ) )
*
            IF( TAU( K ).NE.CZERO .AND. K.GT.1 ) THEN
*
*              We now perform the operation  A := A*P( k )'.
*
*              Use the first ( k - 1 ) elements of TAU to store  a( k ),
*              where  a( k ) consists of the first ( k - 1 ) elements of
*              the  kth column  of  A.  Also  let  B  denote  the  first
*              ( k - 1 ) rows of the last ( n - m ) columns of A.
*
               CALL ZCOPY( K-1, A( 1, K ), 1, TAU, 1 )
*
*              Form   w = a( k ) + B*z( k )  in TAU.
*
               CALL ZGEMV( 'No transpose', K-1, N-M, CONE, A( 1, M1 ),
     $                     LDA, A( K, M1 ), LDA, CONE, TAU, 1 )
*
*              Now form  a( k ) := a( k ) - conjg(tau)*w
*              and       B      := B      - conjg(tau)*w*z( k )'.
*
               CALL ZAXPY( K-1, -DCONJG( TAU( K ) ), TAU, 1, A( 1, K ),
     $                     1 )
               CALL ZGERC( K-1, N-M, -DCONJG( TAU( K ) ), TAU, 1,
     $                     A( K, M1 ), LDA, A( 1, M1 ), LDA )
            END IF
   20    CONTINUE
      END IF
*
      RETURN
*
*     End of ZTZRQF
*
      END

C
C	$Id: frstd.f,v 1.4 2008-07-27 00:23:02 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE FRSTD (X,Y)
      SAVE
C USER ENTRY PPINT.
      CALL FL2INT (X,Y,IIX,IIY)
      CALL CFVLD (1,IIX,IIY)
      RETURN
      END

C
C      $Id: xy10f.f,v 1.11 2010-03-15 22:49:25 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C                Copyright (C)  1995                                   C
C        University Corporation for Atmospheric Research               C
C                All Rights Reserved                                   C
C                                                                      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C  File:       xy10f.f
C
C  Author:     Mary Haley
C          National Center for Atmospheric Research
C          PO 3000, Boulder, Colorado
C
C  Date:       Fri May  5 11:18:07 MDT 1995
C
C Description:        This example shows how to overlay an XyPlot
C                     on a MapPlot.
C
      external NhlFAppClass 
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFCairoWindowWorkstationClass
      external NhlFXyPlotClass
      external NhlFMapPlotClass
      external NhlFCoordArraysClass
C
C Define the day and the hour for which we are getting data values.
C (March 18, 1995, hour 0).
C
      character*21 file
      data file/'/cdf/95031800_sao.cdf'/
C
C Declare variables for the HLU routine calls.
C
      integer appid, xworkid, xyid1, xyid2, mpid1, mpid2, dataid
      integer rlist, i
      real special_value
      real lat(3000), lon(3000)
      data special_value/-9999./
C
C Declare variables for getting information from netCDF file.
C
      character*50 recname
      character*256 filename
      integer ncid, latid, lonid, recid
      integer ndims, nvars, ngatts, rec_len
      integer start(1), count(1)

      CHARACTER*7  wks_type
C
C Define the workstation type
C
      wks_type = "x11"
C
C
C Initialize the HLU library and set up resource template.
C
      call NhlFInitialize
      call NhlFRLCreate(rlist,'setrl')
C
C Create Application object.  The Application object name is used to
C determine the name of the resource file, which is "xy10.res" in
C this case.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'appDefaultParent','True',ierr)
      call NhlFRLSetString(rlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'xy10',NhlFAppClass,0,rlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkMetaName','./xy10f.ncgm',ierr)
         call NhlFCreate(xworkid,'xy10Work',
     +        NhlFNcgmWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X11 workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPause','True',ierr)
         call NhlFCreate(xworkid,'xy10Work',
     +        NhlFCairoWindowWorkstationClass,
     +        0,rlist,ierr)
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PS workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPSFileName','./xy10f.ps',ierr)
         call NhlFCreate(xworkid,'xy10Work',
     +        NhlFPSWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPDFFileName','./xy10f.pdf',ierr)
         call NhlFCreate(xworkid,'xy10Work',
     +        NhlFPDFWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFileName','./xy10f',ierr)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(xworkid,'xy10Work',
     +        NhlFcairoPSPDFWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFileName','./xy10f',ierr)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(xworkid,'xy10Work',
     +        NhlFcairoImageWorkstationClass,0,rlist,ierr)
      endif
C
C Open the netCDF file.
C
      call gngpat(filename,"data",ierr)
      do 32 i=1,256
         if( filename(i:i).eq.char(0) ) then
            filename(i:i+20)=file
            goto 34
         endif
 32   continue
C      
C The second argument to 'ncopn' should be NCNOWRIT, but since we
C can't include 'netcdf.inc', we are using the value '0' instead.
C
 34   ncid = ncopn(filename,0,ierr)
C
C Get the record length and dimension name.
C
      call ncinq(ncid, ndims, nvars, ngatts, recid, ierr)
      call ncdinq(ncid, recid, recname, rec_len, ierr)
C
C Get the ids of the lat/lon arrays.
C
      latid = ncvid(ncid,'lat',ierr)
      lonid = ncvid(ncid,'lon',ierr)
C
C Get lat/lon data values.
C
      start(1) = 1
      count(1) = rec_len
      call ncvgt(ncid,latid,start,count,lat,ierr)
      call ncvgt(ncid,lonid,start,count,lon,ierr)
C
C Close the netCDF file.
C
      call ncclos(ncid,ierr)
C
C Throw out values that may be incorrect.
C
      do 50 i=1,rec_len
         if( lat(i) .lt. -90. .or. lat(i) .gt. 90.) then
            lat(i) = special_value
         endif
         if( lon(i) .lt. -180. .or. lon(i) .gt. 180.) then
            lon(i) = special_value
         endif
 50   continue
C
C Define the Data object.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetFloatArray(rlist,'caXArray',lon,rec_len,ierr)
      call NhlFRLSetFloatArray(rlist,'caYArray',lat,rec_len,ierr)
      call NhlFCreate(dataid,'xyData',NhlFCoordArraysClass,0,
     +     rlist,ierr)
C
C The id for this Data object is now the resource value for
C xyCoordData.  Tweak some XyPlot resources in the resource file
C ("xy10.res").
C
      call NhlFRLClear(rlist)
      call NhlFRLSetInteger(rlist,'xyCoordData',dataid,ierr)
      call NhlFCreate(xyid1,'xyPlot1',NhlFXyPlotClass,xworkid,
     +     rlist,ierr)
C     
C Plot all of the station ids.
C
      call NhlFDraw(xyid1,ierr)
      call NhlFFrame(xworkid,ierr)
C
C Create a second XyPlot object with a different name so we can
C change the "tr" resources to limit the plot within the mainland
C United States.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetInteger(rlist,'xyCoordData',dataid,ierr)
      call NhlFCreate(xyid2,'xyPlot2',NhlFXyPlotClass,xworkid,
     +     rlist,ierr)
C
C Plot station ids over mainland United States only.  This is done
C using resources in the "xy10.res" resource file.
C
      call NhlFDraw(xyid2,ierr)
      call NhlFFrame(xworkid,ierr)
C
C Create two MapPlots, one of the United States  and one of just
C Colorado (projection parameters are set up in the "xy10.res"
C resource file).
C
      call NhlFCreate(mpid1,'mpPlot1',NhlFMapPlotClass,xworkid,
     +     0,ierr)

      call NhlFCreate(mpid2,'mpPlot2',NhlFMapPlotClass,xworkid,
     +     0,ierr)
C
C Draw the two plots.
C
      call NhlFDraw(mpid1,ierr)
      call NhlFFrame(xworkid,ierr)

      call NhlFDraw(mpid2,ierr)
      call NhlFFrame(xworkid,ierr)
C
C Overlay the first XyPlot object on the first MapPlot object.  This
C will plot station ids over the mainland United States.
C
      call NhlFAddOverlay(mpid1,xyid1,-1,ierr)
      call NhlFDraw(mpid1,ierr)
      call NhlFFrame(xworkid,ierr)
C
C Overlay the second XyPlot object on the second MapPlot object.  This
C will plot station ids over Colorado.
C
      call NhlFAddOverlay(mpid2,xyid2,-1,ierr)
      call NhlFDraw(mpid2,ierr)
      call NhlFFrame(xworkid,ierr)
C
C NhlFDestroy destroys the given id and all of its children so
C destroying "appid will destroy "xworkid" which will also destroy
C "plotid".
C
      call NhlFRLDestroy(rlist)
      call NhlFDestroy(xworkid,ierr)
C
C Restores state.
C
      call NhlFClose
      stop
      end

C
C	$Id: gselnt.f,v 1.6 2008-07-27 00:21:01 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GSELNT (TNR)
C
C  SELECT NORMALIZATION TRANSFORMATION
C
      INTEGER ESELNT
      PARAMETER (ESELNT=52)
C
      include 'gkscom.h'
C
      INTEGER TNR
C
C  Check if GKS is in the proper state.
C
      CALL GZCKST(8,ESELNT,IER)
      IF (IER .NE. 0) RETURN
C
C  Check that the normalization transformation number is valid.
C
      IF (TNR.LT.0 .OR. TNR.GT.MNT) THEN
        ERS = 1
        CALL GERHND(50,ESELNT,ERF)
        ERS = 0
        RETURN
      ENDIF
C
C  Set the current normalization transformation variable in
C  the GKS state list.
C
      CNT = TNR
C
C  Reestablish character height and up vector, and
C  pattern size and reference point, and clipping rectangle.
C
      CALL GSCHH(CCHH)
      CALL GSCHUP(CCHUP(1),CCHUP(2))
C
C  Pattern size and pattern reference point currently not implemented.
C
C     CALL GSPA(CPA(1),CPA(2))
C     CALL GSPARF(CPARF(1),CPARF(2))
      CALL GSCLIP(CCLIP)
C
      RETURN
      END

      SUBROUTINE PASSB2(IDO,L1,CC,CH,WA1)
      DOUBLE PRECISION CC
      DOUBLE PRECISION CH
      DOUBLE PRECISION WA1
      DOUBLE PRECISION TR2
      DOUBLE PRECISION TI2
      DIMENSION CC(IDO,2,L1),CH(IDO,L1,2),WA1(1)

      IF (IDO.GT.2) GO TO 102
      DO 101 K = 1,L1
          CH(1,K,1) = CC(1,1,K) + CC(1,2,K)
          CH(1,K,2) = CC(1,1,K) - CC(1,2,K)
          CH(2,K,1) = CC(2,1,K) + CC(2,2,K)
          CH(2,K,2) = CC(2,1,K) - CC(2,2,K)
  101 CONTINUE
      RETURN
  102 DO 104 K = 1,L1
          DO 103 I = 2,IDO,2
              CH(I-1,K,1) = CC(I-1,1,K) + CC(I-1,2,K)
              TR2 = CC(I-1,1,K) - CC(I-1,2,K)
              CH(I,K,1) = CC(I,1,K) + CC(I,2,K)
              TI2 = CC(I,1,K) - CC(I,2,K)
              CH(I,K,2) = WA1(I-1)*TI2 + WA1(I)*TR2
              CH(I-1,K,2) = WA1(I-1)*TR2 - WA1(I)*TI2
  103     CONTINUE
  104 CONTINUE
      RETURN
      END

C
C $Id: hststr.f,v 1.6 2008-07-27 00:17:15 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
C *****************************************************
C
        SUBROUTINE HSTSTR(LABEL,FIRST,LAST)
C
C *****************************************************
C
C  THIS CALCULATES THE POSITION OF THE FIRST NON-BLANK CHARACTER
C  AND THE POSITION OF THE LAST NON-BLANK CHARACTER IN LABEL
C
      INTEGER   FIRST, LAST
        CHARACTER*(*) LABEL
C
        LAST = LEN(LABEL)
        DO 860 I = 1,LAST
            IF (LABEL(I:I) .NE. ' ') GOTO 870
 860  CONTINUE
 870  FIRST = I
        IF (FIRST .NE. LAST) THEN
            DO 880 J = LAST,FIRST,-1
                  IF (LABEL(J:J) .NE. ' ') THEN
                  LAST = J
                  GOTO 890
                  ENDIF
 880      CONTINUE
 890  CONTINUE
        ENDIF
      RETURN
        END

      PROGRAM CMPGCI
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER(IGRD=2)
      PARAMETER(M=180/IGRD,N=360/IGRD)
      REAL RLAT(100),RLON(100)
C
C Open GKS.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Draw a map
C
      CALL SUPMAP(8,0.,-50.,0.,0.,-80.,90.,10.,2,0.,0,0,IERR)
C
C Get data values defining a great circle between Washinton DC and
C London
C
      CALL MAPGCI(38.,-77.,51.,0.,100,RLAT,RLON)
C
C Draw the great circle
C
      CALL MAPIT(38.,-77.,0)
      DO 10, I=1,100
         CALL MAPIT(RLAT(I),RLON(I),1)
 10   CONTINUE
      CALL MAPIT(51.,0.,1)
      CALL MAPIQ
C
C Advance the frame.
C
      CALL FRAME
C
C Close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
C Done.
C
      STOP
C
      END

C
C	$Id: bndcls.f,v 1.4 2008-07-27 12:23:43 haley Exp $
C                                                                      
C			     Copyright (C)  1997
C	     University Corporation for Atmospheric Research
C			     All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C

      SUBROUTINE BNDCLS(WHICH, IOS, STATUS)
C
C  Process the BUNDLE class keywords.
C
C  INPUT
C       WHICH   --  the encoded path flags.
C
C  OUTPUT
C       IOS     --  I/O status flag.  This flag is valid only
C                   if STATUS indicates an error.
C       STATUS  --  The error status as defined in COMMON CAPERR.
C
      COMMON /PARTB1/ PART1, KEYSEP, KEYTER, FRMCOM
      COMMON /PARTB2/ PART2, PART3, PART4, PART5, CTSTR, CTLOC
C
C  THE NUMBER OF WORDS IN THE SEARCH PATH MUST BE BIG ENOUGH TO HOLD
C       THE NUMBER OF BITS PER PATH TIMES THE NUMBER OF LEVELS
C
      INTEGER WHSIZE
      PARAMETER (WHSIZE=20)
C
      INTEGER PARTSZ, OTHSZ, NTABLE
      PARAMETER(PARTSZ=3000, OTHSZ=150, NTABLE=50)
      CHARACTER*1 KEYSEP,KEYTER
      CHARACTER*1 FRMCOM(2)
      INTEGER PART2(OTHSZ), PART3(OTHSZ), PART4(NTABLE), PART5(NTABLE*2)
      CHARACTER*1 PART1(PARTSZ)
      INTEGER CTSTR, CTLOC
      COMMON /CAPERR/ ALLOK, EOFFL, INTERR, MAXINT, PLBERR, PMBERR,
     1                FABERR, TXBERR, FLTERR, MAXFLT, NOTINT, SIZERR,
     2                UNDASC, DEVERR, DOCERR, TBLERR , STSZER, ENTERR,
     3                TABERR, TABSER, PRSFIL
      INTEGER ALLOK, EOFFL, INTERR, MAXINT, PLBERR, PMBERR,
     1        FABERR, TXBERR, FLTERR, MAXFLT, NOTINT, SIZERR, UNDASC,
     2        DEVERR, DOCERR, STSZER, ENTERR, TABERR, TABSER, TBLERR,
     3        PRSFIL
      COMMON/CAPBND/PLBTEC, PLIBTB, PLTBTB, PLWBTB, PLCBTB,
     1              PMBTEC, PMIBTB, PMTBTB, PMSBTB, PMCBTB,
     2              TXBTEC, TXIBTB, TXFBTB, TXPBTB, TCXBTB,
     3              TCSBTB, TXCBTB, FABTEC, FAIBTB, FISBTB,
     4              FASBTB, FACBTB
      INTEGER       TBLSIZ
      PARAMETER (TBLSIZ=6)
      INTEGER PLBTEC,PLIBTB(TBLSIZ),PLTBTB(TBLSIZ),PLCBTB(TBLSIZ),
     1        PMBTEC,PMIBTB(TBLSIZ),PMTBTB(TBLSIZ),PMCBTB(TBLSIZ),
     2        TXBTEC,TXIBTB(TBLSIZ),TXFBTB(TBLSIZ),TXPBTB(TBLSIZ),
     3        TXCBTB(TBLSIZ),FACBTB(TBLSIZ),
     4        FABTEC,FAIBTB(TBLSIZ),FISBTB(TBLSIZ),FASBTB(TBLSIZ)
      REAL PLWBTB(TBLSIZ),PMSBTB(TBLSIZ),TCXBTB(TBLSIZ),TCSBTB(TBLSIZ)
      INTEGER LENBND
      PARAMETER (LENBND=4+18*TBLSIZ)
C
      INTEGER WHICH(WHSIZE), IOS, STATUS
      INTEGER ROW1, ROW2
      INTEGER DUMMY
C
C  Branch to the proper level 2 processing.
C
      ROW1 = WHICH(2)
      ROW2 = WHICH(3)
C
C  BUNDLE processing--
C
C      ROW1    ROW2     Keyword
C      ----    ----     -------------------------
C       1       1       BUNDLE_LINE_INDEX
C       1       2       BUNDLE_LINE_TYPE
C       1       3       BUNDLE_LINE_WIDTH
C       1       4       BUNDLE_LINE_COLOR
C       2       1       BUNDLE_MARKER_INDEX
C       2       2       BUNDLE_MARKER_TYPE
C       2       3       BUNDLE_MARKER_SIZE
C       2       4       BUNDLE_MARKER_COLOR
C       3       1       BUNDLE_POLYGON_INDEX
C       3       2       BUNDLE_POLYGON_INTERIOR
C       3       3       BUNDLE_POLYGON_STYLE
C       3       4       BUNDLE_POLYGON_COLOR
C       4       1       BUNDLE_TEXT_INDEX
C       4       2       BUNDLE_TEXT_FONT
C       4       3       BUNDLE_TEXT_PRECISION
C       4       4       BUNDLE_TEXT_CEXPN
C       4       5       BUNDLE_TEXT_CSPACE
C       4       6       BUNDLE_TEXT_COLOR
C
C  Branch to proper level 2 .
C
      GO TO (100,200,300,400),ROW1
C
C  BUNDLE_LINE class.
C
 100  GO TO (110,120,130,140),ROW2
 110    CONTINUE
        CALL GTINT(PLIBTB, TBLSIZ, DUMMY, IOS, STATUS)
        GO TO 190
 120    CONTINUE
        CALL GTINT(PLTBTB, TBLSIZ, DUMMY, IOS, STATUS)
        GO TO 190
 130    CONTINUE
        CALL GTFLT(PLWBTB, TBLSIZ, DUMMY, IOS, STATUS)
        GO TO 190
 140    CONTINUE
        CALL GTINT(PLCBTB, TBLSIZ, DUMMY, IOS, STATUS)
 190    CONTINUE
        IF (STATUS.NE.ALLOK) RETURN
C
C  Check if the lengths of all the tables are the same.
C
        IF (PLBTEC .EQ. -1) THEN
                PLBTEC = DUMMY
        ELSE
                IF (PLBTEC.NE.DUMMY) STATUS = PLBERR
        END IF
        RETURN
C
C  BUNDLE_MARKER class.
C
 200  GO TO (210,220,230,240),ROW2
 210    CONTINUE
        CALL GTINT(PMIBTB, TBLSIZ, DUMMY, IOS, STATUS)
        GO TO 290
 220    CONTINUE
        CALL GTINT(PMTBTB, TBLSIZ, DUMMY, IOS, STATUS)
        GO TO 290
 230    CONTINUE
        CALL GTFLT(PMSBTB, TBLSIZ, DUMMY, IOS, STATUS)
        GO TO 290
 240    CONTINUE
        CALL GTINT(PMCBTB, TBLSIZ, DUMMY, IOS, STATUS)
 290    CONTINUE
        IF (STATUS.NE.ALLOK) RETURN
C
C  Check if the lengths of all the tables are the same.
C
        IF (PMBTEC .EQ. -1) THEN
                PMBTEC = DUMMY
        ELSE
                IF (PMBTEC.NE.DUMMY) STATUS = PMBERR
        END IF
        RETURN
C
C  BUNDLE_POLYGON class.
C
 300  GO TO (310,320,330,340),ROW2
 310    CONTINUE
        CALL GTINT(FAIBTB, TBLSIZ, DUMMY, IOS, STATUS)
        GO TO 390
 320    CONTINUE
        CALL GTINT(FISBTB, TBLSIZ, DUMMY, IOS, STATUS)
        GO TO 390
 330    CONTINUE
        CALL GTINT(FASBTB, TBLSIZ, DUMMY, IOS, STATUS)
        GO TO 390
 340    CONTINUE
        CALL GTINT(FACBTB, TBLSIZ, DUMMY, IOS, STATUS)
 390    CONTINUE
        IF (STATUS.NE.ALLOK) RETURN
C
C  Check if the lengths of all the tables are the same.
C
        IF (FABTEC .EQ. -1) THEN
                FABTEC = DUMMY
        ELSE
                IF (FABTEC.NE.DUMMY) STATUS = FABERR
        END IF
        RETURN
C
C  BUNDLE_TEXT class.
C
 400  GO TO (410,420,430,440,450,460),ROW2
 410    CONTINUE
        CALL GTINT(TXIBTB, TBLSIZ, DUMMY, IOS, STATUS)
        GO TO 490
 420    CONTINUE
        CALL GTINT(TXFBTB, TBLSIZ, DUMMY, IOS, STATUS)
        GO TO 490
 430    CONTINUE
        CALL GTINT(TXPBTB, TBLSIZ, DUMMY, IOS, STATUS)
        GO TO 490
 440    CONTINUE
        CALL GTFLT(TCXBTB, TBLSIZ, DUMMY, IOS, STATUS)
        GO TO 490
 450    CONTINUE
        CALL GTFLT(TCSBTB, TBLSIZ, DUMMY, IOS, STATUS)
        GO TO 490
 460    CONTINUE
        CALL GTINT(TXCBTB, TBLSIZ, DUMMY, IOS, STATUS)
 490    CONTINUE
        IF (STATUS.NE.ALLOK) RETURN
C
C  Check if the lengths of all the tables are the same.
C
        IF (TXBTEC .EQ. -1) THEN
                TXBTEC = DUMMY
        ELSE
                IF (TXBTEC.NE.DUMMY) STATUS = TXBERR
        END IF
        RETURN
C
      END

C NCLFORTSTART
      subroutine spigamd (ntim, pp, pmsg, nrun, index)
      implicit none
      integer ntim, nrun 
      double precision pp(ntim), index(ntim), pmsg
C NCLEND
c compute SPI: Standardized Precipitation Index using gamma distribution

c local/dynamic
      integer maxyrs, j, i, im, n, kmsg, k
      double precision tmparr(ntim/12+1), pcon
      double precision alpha(12), beta(12), gamm(12), pzero(12)
      double precision anvnrmd, gamcdfd

      maxyrs = ntim/12
c
c	Initialize index and check for all missing values 
c
      kmsg = 0
      do j=1,ntim    
         index(j) = pmsg
         if (pp(j).eq.pmsg) then
             kmsg = kmsg+1
         end if
      end do
      if (kmsg.eq.ntim) return
c
c	check for all constant values; can not fit a distribution
c
      do j=1,ntim    
         if (pp(j).ne.pmsg) then
             pcon = pp(j)
             go to 13
         end if
      end do
   13 continue

      do j=1,ntim    
         if (pp(j).ne.pmsg .and. pp(j).ne.pcon) then
             go to 18
         end if
      end do
      return
   18 continue

      do j=1,12
         beta(j)  = pmsg
         gamm(j)  = pmsg
         alpha(j) = pmsg
         pzero(j) = pmsg
      end do
c
c	Sum nrun precip. values;
c	store them in the appropriate index location.
c	The first nrun-1 index values will be missing.
c
c	If any value is missing; set the sum to missing.
c
      do j=nrun,ntim
         index(j) = 0.0d0
        do i=0,nrun-1
           if (pp(j-i) .ne. pmsg) then
               index(j) = index(j) + pp(j-i)
           else
               index(j) = pmsg
               goto 30
           endif
       end do
  30   continue
      end do
c
c	For nrun<12, the monthly distributions will be substantially
c       different. So we need to compute gamma parameters for
c	each month starting with the (nrun-1)th.
c
      do i=0,11
        n=0
        do j=nrun+i,ntim,12
           if(index(j) .ne. pmsg) then
              n=n+1
              tmparr(n) = index(j)
           endif
        end do   
        im = mod (nrun+i-1, 12) + 1
c
c	Here's where we do the fitting.
c
        if (n.gt.0) then
c
c avoid trying to fit a series of constant values
c
            do k=2,n
               if (tmparr(k).ne.tmparr(1)) then     
                   call gamfitd(tmparr,n
     +                  ,alpha(im), beta(im), gamm(im), pzero(im))
                   go to 37
               end if
            end do
        end if

   37   continue
      end do
c
c	Replace precip. sums stored in index with SPI's
c
      do j = nrun, ntim
         im = mod (j-1,12) + 1
         if (index(j) .ne. pmsg .and. beta(im).ne.pmsg) then
c
c	Get the probability
c
             index(j) = gamcdfd(beta(im), gamm(im), pzero(im), index(j))
c
c	Convert prob. to z value.
c
             index(j) = anvnrmd(index(j))
         endif
      end do

      return
      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
ccc
c	input prob; return z.
c	See Abromowitz and Stegun _Handbook of Mathematical Functions_, p. 933
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
ccc
      double precision function anvnrmd (prob)
      implicit none
      double precision sign, prob, t, c0, c1, c2, d1, d2, d3
      data c0, c1, c2 /2.515517d0, 0.802853d0, 0.010328d0/
      data d1, d2, d3 /1.432788d0, 0.189269d0, 0.001308d0/

      if (prob .gt. 0.5d0) then
          sign = 1.0d0
          prob = 1.0d0 - prob
      else
          sign = -1.0d0
      endif
      if (prob .lt. 0.0d0) then
c c c     write(*, *) 'Error in anvnrmd(). Prob. not in [0,1.0]'
          anvnrmd = 0.0d0
          return
      endif
      if (prob .eq. 0.0d0) then
          anvnrmd = 1.0d37 * sign
          return
      endif
      t       = sqrt(log (1.0d0 / (prob * prob)))
      anvnrmd = (sign * (t - ((((c2 * t) + c1) * t) + c0) /
     1          ((((((d3*t)+d2)*t)+d1)*t)+1.0)))
      return
      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c Estimate incomplete gamma parameters.
c
c Input:
c	datarr - data array
c	n - size of datarr
c
c Output:
c	alpha, beta, gamma - gamma paarameters
c	pzero - probability of zero.
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine gamfitd (datarr, n, alpha, beta, gamm, pzero)
      implicit none
      integer n
      double precision datarr(*), alpha, beta, gamm, pzero

      integer nact, i
      double precision sum, sumlog, av 

      if (n .le. 0) then
          write(*, *) 'Error in gamfitd - empty data array'
          stop
      endif
      sum    = 0.0d0
      sumlog = 0.0d0
      pzero  = 0.0d0
      nact   = 0

c	compute sums
      do 10 i = 1, n
      if (datarr(i) .gt. 0.0d0) then
          sum = sum + datarr(i)
          sumlog = sumlog + log(datarr(i))
          nact = nact + 1
      else
          pzero = pzero + 1
      endif
   10 continue
      pzero = pzero / n
      if (nact .ne. 0) av = sum / nact

c	Bogus data array but do something reasonable
      if(nact .eq. 1) then
         alpha = 0.0d0
         gamm  = 1.0d0
         beta  = av
         return
      endif

c	They were all zeroes.
      if(pzero .eq. 1.0d0) then
         alpha = 0.0d0
         gamm  = 1.0d0
         beta  = av
         return
      endif

c	Use MLE 
c       A Note on the Gamma Distribution
c       Thom (1958): Monthly Weather Review, pp 117-122.
c       eqn 22 for gamma; just above eqn 21 "A" => alpha

      alpha = log(av) - sumlog / nact
      gamm  = (1.0d0 + sqrt(1.0d0 + 4.0d0*alpha/ 3.0d0)) /(4.0d0*alpha)
      beta  = av / gamm
      
      return
      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c Compute probability of a<=x using incomplete gamma parameters.
c
c Input:
c	beta, gamma - gamma parameters
c	pzero - probability of zero.
c	x - value.
c
c Return:
c	Probability a<=x.
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      double precision function gamcdfd (beta, gamm, pzero, x)
      implicit none
      double precision beta, gamm, pzero, x
      double precision gammapd

      if(x .le. 0.0d0) then
         gamcdfd = pzero
      else
         gamcdfd = pzero + (1.0d0 - pzero) * gammapd (gamm, x / beta)
      endif

      return
      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c Compute inverse gamma function i.e. return x given p where CDF(x) = p.
c
c Input:
c	beta, gamma - gamma parameters
c	pzero - probability of zero.
c	prob - probability.
c
c Return:
c	x as above.
c
c Method:
c	We use a simple binary search to first bracket out initial
c	guess and then to refine our guesses until two guesses are within
c	tolerance (eps). Is there a better way to do this?
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      double precision function gaminvd (beta, gamm, pzero, prob)
      implicit none
      double precision beta, gamm, pzero, prob

      integer niter
      double precision eps, phigh, thigh, tlow, t, p
      data eps /1.0d-7/
      double precision gamcdfd

c	Check if prob < prob of zero
      if (prob .le. pzero) then
          gaminvd = 0.0d0
          return
      endif

c	Otherwise adjust prob
      prob = (prob - pzero) / (1.0d0 - pzero)

c	Make initial guess. Keep doubling estimate until prob is
c	bracketed.
      thigh = 2.0d0*eps
 10   continue
      phigh = gamcdfd (beta, gamm, pzero, thigh)
      if(phigh .ge. prob) goto 20
      thigh = thigh*2.0d0
      goto 10
 20   continue
      tlow = thigh / 2.0d0
c     Iterate to find root.
      niter = 0
 30   continue
      if((thigh - tlow) .le. eps) goto 40
         niter = niter + 1
         t = (tlow + thigh) / 2.0d0
         p = gamcdfd (beta, gamm, pzero, t)
         if (p .lt. prob) then
             tlow = t
         else
            thigh = t
         endif
      goto 30
 40   continue

      gaminvd = (tlow + thigh) / 2.0d0
      return
      end
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c Functions for the incomplete gamma functions P and Q
c
c	1 /x-ta-1
c P(a,x)=--------| e t dt, a>0
c	Gamma(x)/ 0
c
c Q(a,x)=1-P(a,x)
c
c Reference: Press, Flannery, Teukolsky, and Vetterling,
c	_Numerical Recipes_, pp. 160-163
c
c Thanks to kenny@cs.uiuc.edu
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c Evaluate P(a,x) by its series representation.
c
      double precision function gamserd (a, x)
      implicit none
      double precision a, x

      integer maxitr, n, iwarn
      double precision eps, ap, sum, del, gln
      double precision gammlnd

c     Maximum number of iterations, and bound on error.
      parameter (maxitr=100, eps=3.0d-7)
      data iwarn /0/

      gln = gammlnd (a)

      if (x .eq. 0.0) then
          gamserd = 0.0d0
          return
      endif

      ap  = a
      sum = 1.0d0 / a
      del = sum
      do 10 n = 1, maxitr
         ap  = ap + 1.0d0
         del = del * (x / ap)
         sum = sum + del
         if (abs (del) .lt. eps * abs (sum)) goto 20
   10 continue

      iwarn = iwarn + 1
c djs if (iwarn .lt. 20) then
c djs     write (*, *) 'gamserd(',a,x,'): not converging.'
c djs     write (*, *) 'Approximate value of ',sum,' + /-',del,' used.'
c djs endif
 20   continue

      gamserd= sum*exp(-x+a*log(x)-gln)

      return
      end
c
c	Evaluate P(a,x) in its continued fraction representation.
c
      double precision function gammcfd (a, x)
      implicit none
      double precision a, x

      integer maxitr, nwarn, n
      double precision    eps, gln, gold, a0,a1,b0,b1,fac,an,ana,anf,g
      parameter (maxitr=200, eps=3.0d-7)
      data nwarn / 0 /, g / 0.0d0 /

      double precision gammlnd

      gln  = gammlnd (a)
      gold = 0.0d0
      a0   = 1.0d0
      a1   = x
      b0   = 0.0d0
      b1   = 1.0d0
      fac  = 1.0d0

      do 10 n = 1, maxitr
         an  = n
         ana = an - a
         a0  = (a1 + a0 * ana) * fac
         b0  = (b1 + b0 * ana) * fac
         anf = an * fac
         a1  = x * a0 + anf * a1
         b1  = x * b0 + anf * b1
         if (a1 .ne. 0.0d0) then
             fac = 1.0d0 / a1
             g = b1 * fac
             if (abs((g - gold) / g) .lt. eps) goto 20
             gold = g
         endif
 10   continue

      nwarn = nwarn + 1
c djs if (nwarn .lt. 20) then
c djs     write (*, *) 'gammcfd(',a,x,'): not converging.'
c djs     write (*, *) 'Inaccurate value of ', g, ' +/- ',
c djs1	  abs(g - gold), ' used.'
c djs endif
 20   continue

      gammcfd= g*exp(-x+a*log(x)-gln)
      return
      end
c
c	Evaluate the incomplete gamma function P(a,x), choosing the most
c	appropriate representation.
c
      double precision function gammapd (a, x)
      implicit none
      double precision a, x
      double precision gamserd, gammcfd

      if (x .lt. a + 1.0d0) then
          gammapd = gamserd (a, x)
      else
          gammapd = 1.0d0 - gammcfd (a, x)
      endif

      return
      end
c
c	Evaluate the incomplete gamma function Q(a,x), choosing the most
c	appropriate representation.
c
      double precision function gammaqd (a, x)
      implicit none
      double precision a, x
      double precision gamserd, gammcfd

      if (x .lt. a + 1.0d0) then
          gammaqd = 1.0d0 - gamserd (a, x)
      else
          gammaqd = gammcfd (a, x)
      endif
      return
      end
c
c	For those who don't have a ln(gamma) function.
c
      double precision function gammlnd(xx)
      implicit none
      double precision xx
       
      integer j
      double precision cof(6), x, tmp, ser
      data cof / 76.18009173d0, -86.50532033d0, 24.01409822d0
     +         , -1.231739516d0, 0.120858003d-2, -0.536382d-5/

      x   = xx - 1.0d0
      tmp = x + 5.5d0
      tmp = tmp - (x+0.5d0) * log(tmp)
      ser = 1.0d0

      do 10 j = 1, 5
         x   = x + 1.0d0
         ser = ser + cof(j) / x
 10   continue

      gammlnd = -tmp + log(2.50662827465d0 * ser)

      return
      end

c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by UCAR                 .
c  .                                                             .
c  .       University Corporation for Atmospheric Research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                         SPHEREPACK                          .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c
c
c ... file vrtes.f
c
c     this file includes documentation and code for
c     subroutine divec          i
c
c ... files which must be loaded with vrtes.f
c
c     sphcom.f, hrfft.f, vhaes.f,shses.f
c
c     subroutine vrtes(nlat,nlon,isym,nt,vt,ivrt,jvrt,cr,ci,mdc,ndc,
c    +                 wshses,lshses,work,lwork,ierror)
c
C*PL*ERROR* Comment line too long
c     given the vector spherical harmonic coefficients cr and ci, precomputed
c     by subroutine vhaes for a vector field (v,w), subroutine vrtes
c     computes the vorticity of the vector field in the scalar array
c     vt.  vt(i,j) is the vorticity at the colatitude
c
c            theta(i) = (i-1)*pi/(nlat-1)
c
c     and longitude
c
c            lambda(j) = (j-1)*2*pi/nlon
c
c     on the sphere.  i.e.,
c
c            vt(i,j) =  [-dv/dlambda + d(sint*w)/dtheta]/sint
c
c     where sint = sin(theta(i)).  w is the east longitudinal and v
c     is the colatitudinal component of the vector field from which
c     cr,ci were precomputed.  required associated legendre polynomials
C*PL*ERROR* Comment line too long
c     are stored rather than recomputed  as they are in subroutine vrtec.
c
c
c     input parameters
c
c     nlat   the number of colatitudes on the full sphere including the
c            poles. for example, nlat = 37 for a five degree grid.
c            nlat determines the grid increment in colatitude as
c            pi/(nlat-1).  if nlat is odd the equator is located at
c            grid point i=(nlat+1)/2. if nlat is even the equator is
c            located half way between points i=nlat/2 and i=nlat/2+1.
c            nlat must be at least 3. note: on the half sphere, the
c            number of grid points in the colatitudinal direction is
c            nlat/2 if nlat is even or (nlat+1)/2 if nlat is odd.
c
c     nlon   the number of distinct londitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater
c            than 3. the axisymmetric case corresponds to nlon=1.
c            the efficiency of the computation is improved when nlon
c            is a product of small prime numbers.
c
c
c     isym   a parameter which determines whether the vorticity is
c            computed on the full or half sphere as follows:
c
c      = 0
c            the symmetries/antsymmetries described in isym=1,2 below
c            do not exist in (v,w) about the equator.  in this case the
c            vorticity is neither symmetric nor antisymmetric about
c            the equator.  the vorticity is computed on the entire
c            sphere.  i.e., in the array vt(i,j) for i=1,...,nlat and
c            j=1,...,nlon.
c
c      = 1
c            w is antisymmetric and v is symmetric about the equator.
c            in this case the vorticity is symmetyric about the
c            equator and is computed for the northern hemisphere
c            only.  i.e., if nlat is odd the vorticity is computed
c            in the array vt(i,j) for i=1,...,(nlat+1)/2 and for
c            j=1,...,nlon.  if nlat is even the vorticity is computed
c            in the array vt(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
c
c      = 2
c            w is symmetric and v is antisymmetric about the equator
c            in this case the vorticity is antisymmetric about the
c            equator and is computed for the northern hemisphere
c            only.  i.e., if nlat is odd the vorticity is computed
c            in the array vt(i,j) for i=1,...,(nlat+1)/2 and for
c            j=1,...,nlon.  if nlat is even the vorticity is computed
c            in the array vt(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
c
c
c      nt    nt is the number of scalar and vector fields.  some
c            computational efficiency is obtained for multiple fields.
c            in the program that calls vrtes, the arrays cr,ci, and vort
C*PL*ERROR* Comment line too long
c            can be three dimensional corresponding to an indexed multiple
c            vector field.  in this case multiple scalar synthesis will
c            be performed to compute the vorticity for each field.  the
c            third index is the synthesis index which assumes the values
c            k=1,...,nt.  for a single synthesis set nt = 1.  the
c            description of the remaining parameters is simplified by
C*PL*ERROR* Comment line too long
c            assuming that nt=1 or that all the arrays are two dimensional.
c
c     ivrt   the first dimension of the array vt as it appears in
c            the program that calls vrtes. if isym = 0 then ivrt
c            must be at least nlat.  if isym = 1 or 2 and nlat is
c            even then ivrt must be at least nlat/2. if isym = 1 or 2
c            and nlat is odd then ivrt must be at least (nlat+1)/2.
c
c     jvrt   the second dimension of the array vt as it appears in
c            the program that calls vrtes. jvrt must be at least nlon.
c
c    cr,ci   two or three dimensional arrays (see input parameter nt)
c            that contain vector spherical harmonic coefficients
c            of the vector field (v,w) as computed by subroutine vhaes.
c     ***    cr and ci must be computed by vhaes prior to calling
c            vrtes.
c
c      mdc   the first dimension of the arrays cr and ci as it
c            appears in the program that calls vrtes. mdc must be at
c            least min0(nlat,nlon/2) if nlon is even or at least
c            min0(nlat,(nlon+1)/2) if nlon is odd.
c
c      ndc   the second dimension of the arrays cr and ci as it
c            appears in the program that calls vrtes. ndc must be at
c            least nlat.
c
c   wshses   an array which must be initialized by subroutine shsesi.
c            once initialized,
c            wshses can be used repeatedly by vrtes as long as nlon
c            and nlat remain unchanged.  wshses must not be altered
c            between calls of vrtes
c
c   lshses   the dimension of the array wshses as it appears in the
c            program that calls vrtes. define
c
c               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            then lshses must be at least
c
c               (l1*l2*(nlat+nlat-l1+1))/2+nlon+15
c
c     work   a work array that does not have to be saved.
c
c    lwork   the dimension of the array work as it appears in the
c            program that calls vrtes. define
c
c               l1 = min0(nlat,nlon/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd.
c
c            if isym = 0 then lwork must be at least
c
c               nlat*((nt+1)*nlon+2*nt*l1+1)
c
c            if isym > 0 then lwork must be at least
c
c               (nt+1)*l2*nlon+nlat*(2*nt*l1+1)
c
c
c     **************************************************************
c
c     output parameters
c
c
c     vt     a two or three dimensional array (see input parameter nt)
c            that contains the vorticity of the vector field (v,w)
C*PL*ERROR* Comment line too long
c            whose coefficients cr,ci where computed by subroutine vhaes.
c            vt(i,j) is the vorticity at the colatitude point theta(i) =
c            (i-1)*pi/(nlat-1) and longitude point lambda(j) =
c            (j-1)*2*pi/nlon. the index ranges are defined above at the
c            input parameter isym.
c
c
c   ierror   an error parameter which indicates fatal errors with input
c            parameters when returned positive.
c          = 0  no errors
c          = 1  error in the specification of nlat
c          = 2  error in the specification of nlon
c          = 3  error in the specification of isym
c          = 4  error in the specification of nt
c          = 5  error in the specification of ivrt
c          = 6  error in the specification of jvrt
c          = 7  error in the specification of mdc
c          = 8  error in the specification of ndc
c          = 9  error in the specification of lshses
c          = 10 error in the specification of lwork
c **********************************************************************
c
c
      SUBROUTINE DVRTES(NLAT,NLON,ISYM,NT,VORT,IVRT,JVRT,CR,CI,MDC,NDC,
     +                 WSHSES,LSHSES,WORK,LWORK,IERROR)
      DOUBLE PRECISION VORT
      DOUBLE PRECISION CR
      DOUBLE PRECISION CI
      DOUBLE PRECISION WSHSES
      DOUBLE PRECISION WORK

      DIMENSION VORT(IVRT,JVRT,NT),CR(MDC,NDC,NT),CI(MDC,NDC,NT)
      DIMENSION WSHSES(LSHSES),WORK(LWORK)
c
c     check input parameters
c
      IERROR = 1
      IF (NLAT.LT.3) RETURN
      IERROR = 2
      IF (NLON.LT.4) RETURN
      IERROR = 3
      IF (ISYM.LT.0 .OR. ISYM.GT.2) RETURN
      IERROR = 4
      IF (NT.LT.0) RETURN
      IERROR = 5
      IMID = (NLAT+1)/2
      IF ((ISYM.EQ.0.AND.IVRT.LT.NLAT) .OR.
     +    (ISYM.GT.0.AND.IVRT.LT.IMID)) RETURN
      IERROR = 6
      IF (JVRT.LT.NLON) RETURN
      IERROR = 7
      IF (MDC.LT.MIN0(NLAT, (NLON+1)/2)) RETURN
      MMAX = MIN0(NLAT, (NLON+2)/2)
      IERROR = 8
      IF (NDC.LT.NLAT) RETURN
      IERROR = 9
      IMID = (NLAT+1)/2
      LPIMN = (IMID*MMAX* (NLAT+NLAT-MMAX+1))/2
      IF (LSHSES.LT.LPIMN+NLON+15) RETURN
      IERROR = 10
c
c     verify unsaved work space (add to what shses requires, file f3)
c
c
c     set first dimension for a,b (as requried by shses)
c
      MAB = MIN0(NLAT,NLON/2+1)
      MN = MAB*NLAT*NT
      LS = NLAT
      IF (ISYM.GT.0) LS = IMID
      NLN = NT*LS*NLON
      IF (LWORK.LT.NLN+LS*NLON+2*MN+NLAT) RETURN
      IERROR = 0
c
c     set work space pointers
c
      IA = 1
      IB = IA + MN
      IS = IB + MN
      IWK = IS + NLAT
      LWK = LWORK - 2*MN - NLAT
      CALL DVRTES1(NLAT,NLON,ISYM,NT,VORT,IVRT,JVRT,CR,CI,MDC,NDC,
     +            WORK(IA),WORK(IB),MAB,WORK(IS),WSHSES,LSHSES,
     +            WORK(IWK),LWK,IERROR)
      RETURN
      END

      SUBROUTINE DVRTES1(NLAT,NLON,ISYM,NT,VORT,IVRT,JVRT,CR,CI,MDC,NDC,
     +                  A,B,MAB,SQNN,WSAV,LWSAV,WK,LWK,IERROR)
      DOUBLE PRECISION VORT
      DOUBLE PRECISION CR
      DOUBLE PRECISION CI
      DOUBLE PRECISION A
      DOUBLE PRECISION B
      DOUBLE PRECISION SQNN
      DOUBLE PRECISION WSAV
      DOUBLE PRECISION WK
      DOUBLE PRECISION FN
      DIMENSION VORT(IVRT,JVRT,NT),CR(MDC,NDC,NT),CI(MDC,NDC,NT)
      DIMENSION A(MAB,NLAT,NT),B(MAB,NLAT,NT),SQNN(NLAT)
      DIMENSION WSAV(LWSAV),WK(LWK)
c
c     set coefficient multiplyers
c
      DO 1 N = 2,NLAT
          FN = DBLE(N-1)
          SQNN(N) = SQRT(FN* (FN+1.D0))
    1 CONTINUE
c
c     compute divergence scalar coefficients for each vector field
c
      DO 2 K = 1,NT
          DO 3 N = 1,NLAT
              DO 4 M = 1,MAB
                  A(M,N,K) = 0.0D0
                  B(M,N,K) = 0.0D0
    4         CONTINUE
    3     CONTINUE
c
c     compute m=0 coefficients
c
          DO 5 N = 2,NLAT
              A(1,N,K) = SQNN(N)*CR(1,N,K)
              B(1,N,K) = SQNN(N)*CI(1,N,K)
    5     CONTINUE
c
c     compute m>0 coefficients
c
          MMAX = MIN0(NLAT, (NLON+1)/2)
          DO 6 M = 2,MMAX
              DO 7 N = M,NLAT
                  A(M,N,K) = SQNN(N)*CR(M,N,K)
                  B(M,N,K) = SQNN(N)*CI(M,N,K)
    7         CONTINUE
    6     CONTINUE
    2 CONTINUE
c
c     synthesize a,b into vort
c
      CALL DSHSES(NLAT,NLON,ISYM,NT,VORT,IVRT,JVRT,A,B,MAB,NLAT,WSAV,
     +           LWSAV,WK,LWK,IERROR)
      RETURN
      END

C
C	$Id: drawpv.f,v 1.5 2008-07-27 00:23:03 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE DRAWPV (IX,IY,IND)
C
C DRAWPV INTERCEPTS THE CALL TO PLOTIT TO CHECK IF THE PEN HAS TO BE
C MOVED OR IF IT IS ALREADY CLOSE ENOUGH TO THE WANTED POSITION.
C IF IND=2 NEVER MOVE PEN, JUST UPDATE VARIABLES IXSTOR AND IYSTOR.
C
C IN IXSTOR AND IYSTOR THE CURRENT POSITION OF THE PEN IS SAVED.
C
      COMMON /DSAVE3/ IXSTOR,IYSTOR
C
      COMMON/INTPR/IPAU,FPART,TENSN,NP,SMALL,L1,ADDLR,ADDTB,MLLINE,
     1    ICLOSE
      SAVE
      IIND = IND + 1
      GOTO (100,90,105), IIND
C
   90 CONTINUE
C
C DRAW LINE AND SAVE POSITION OF PEN.
C
      IXSTOR = IX
      IYSTOR = IY
      CALL PLOTIT (IXSTOR,IYSTOR,1)
      GOTO 110
C
  100 CONTINUE
C
C CHECK IF PEN IS ALREADY CLOSE ENOUGH TO THE WANTED POSITION.
C
      DIFF = REAL(ABS(IXSTOR-IX)+ABS(IYSTOR-IY))
      IF (DIFF .LE. REAL(ICLOSE)) GO TO 110
C
      IXSTOR = IX
      IYSTOR = IY
      CALL PLOTIT (IXSTOR,IYSTOR,0)
      GOTO 110
C
  105 CONTINUE
C
C DO NOT MOVE PEN. JUST UPDATE VARIABLES IXSTOR AND IYSTOR.
C
      IXSTOR = IX
      IYSTOR = IY
C
  110 CONTINUE
C
      RETURN
      END

C
C $Id: mpifnb.f,v 1.7 2008-07-27 00:17:07 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      INTEGER FUNCTION MPIFNB (CHRS)
        CHARACTER*(*) CHRS
        MPIFNB=MDIFNB(CHRS)
        RETURN
      END

C
C $Id: slsclr.f,v 1.4 2008-07-27 00:17:27 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE SLSCLR (ICLR,FRED,FGRN,FBLU)
C
C Given a color index ICLR and the RGB components to be associated with
C it, SLSCLR updates STITLES's information about the color.  If one of
C FRED, FGRN, or FBLU is negative, it just says that the associated
C component is not to be updated in the saved information.
C
C The common block SLCOMN holds all of the internal parameters of
C the package STITLE except for color-table parameters.
C
        COMMON /SLCOMN/ GPSZ,IBGC,IBGF,ICOP,IDOT,IFGC,IFGF,IJMP,IMAP,
     +                  INCU,IWLU,IWRK,IWWI,IXND,IXST,OORV,PCSZ,RNFS,
     +                  RVPB,RVPL,RVPR,RVPT,TFIN,TFOU,TGP1,TGP2,TGP3
        SAVE   /SLCOMN/
C
C The common block SLCLRS holds color-table parameters.
C
        COMMON /SLCLRS/ CRED(256),CGRN(256),CBLU(256),LOCI(256),NOCI
        SAVE   /SLCLRS/
C
C If it wasn't done yet, get the ID of the first active workstation.
C
        IF (IWRK.LT.0) THEN
          CALL SLGWID
          IF (ICFELL('SLSCLR',1).NE.0) RETURN
        END IF
C
C Look for the color index in the current list of color indices.  If
C it's there, update the RGB components associated with it as directed
C by the values of FRED, FGRN, and FBLU.
C
        DO 101 I=1,NOCI
          IF (LOCI(I).EQ.ICLR) THEN
            IF (FRED.GE.0.) CRED(I)=MIN(1.,FRED)
            IF (FGRN.GE.0.) CGRN(I)=MIN(1.,FGRN)
            IF (FBLU.GE.0.) CBLU(I)=MIN(1.,FBLU)
            RETURN
          END IF
  101   CONTINUE
C
C The color index is not in the current list.  If the list isn't full,
C create an entry for the desired color index and initialize the RGB
C components associated with it, using values returned by GQCR.  If
C GQCR doesn't return good values, use all 0s for color index 0 and all
C 1s for any other color index.  In any case, once the entry has been
C created, update the RGB components associated with it as directed
C by the values of FRED, FGRN, and FBLU.
C
        IF (NOCI.LT.256) THEN
          NOCI=NOCI+1
          LOCI(NOCI)=ICLR
          CALL GQCR (IWRK,ICLR,0,IERR,CRED(NOCI),CGRN(NOCI),CBLU(NOCI))
          IF (IERR.NE.0) THEN
            CRED(NOCI)=REAL(MAX(0,MIN(1,ICLR)))
            CGRN(NOCI)=REAL(MAX(0,MIN(1,ICLR)))
            CBLU(NOCI)=REAL(MAX(0,MIN(1,ICLR)))
          END IF
          IF (FRED.GE.0.) CRED(NOCI)=MIN(1.,FRED)
          IF (FGRN.GE.0.) CGRN(NOCI)=MIN(1.,FGRN)
          IF (FBLU.GE.0.) CBLU(NOCI)=MIN(1.,FBLU)
        ELSE
          CALL SETER ('SLSCLR - TOO MANY COLORS DEFINED',2,1)
          RETURN
        END IF
C
C Done.
C
        RETURN
C
      END

      SUBROUTINE DLARRV( N, D, L, ISPLIT, M, W, IBLOCK, GERSCH, TOL, Z,
     $                   LDZ, ISUPPZ, WORK, IWORK, INFO )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      INTEGER            INFO, LDZ, M, N
      DOUBLE PRECISION   TOL
*     ..
*     .. Array Arguments ..
      INTEGER            IBLOCK( * ), ISPLIT( * ), ISUPPZ( * ),
     $                   IWORK( * )
      DOUBLE PRECISION   D( * ), GERSCH( * ), L( * ), W( * ), WORK( * ),
     $                   Z( LDZ, * )
*     ..
*
*  Purpose
*  =======
*
*  DLARRV computes the eigenvectors of the tridiagonal matrix
*  T = L D L^T given L, D and the eigenvalues of L D L^T.
*  The input eigenvalues should have high relative accuracy with
*  respect to the entries of L and D. The desired accuracy of the
*  output can be specified by the input parameter TOL.
*
*  Arguments
*  =========
*
*  N       (input) INTEGER
*          The order of the matrix.  N >= 0.
*
*  D       (input/output) DOUBLE PRECISION array, dimension (N)
*          On entry, the n diagonal elements of the diagonal matrix D.
*          On exit, D may be overwritten.
*
*  L       (input/output) DOUBLE PRECISION array, dimension (N-1)
*          On entry, the (n-1) subdiagonal elements of the unit
*          bidiagonal matrix L in elements 1 to N-1 of L. L(N) need
*          not be set. On exit, L is overwritten.
*
*  ISPLIT  (input) INTEGER array, dimension (N)
*          The splitting points, at which T breaks up into submatrices.
*          The first submatrix consists of rows/columns 1 to
*          ISPLIT( 1 ), the second of rows/columns ISPLIT( 1 )+1
*          through ISPLIT( 2 ), etc.
*
*  TOL     (input) DOUBLE PRECISION
*          The absolute error tolerance for the
*          eigenvalues/eigenvectors.
*          Errors in the input eigenvalues must be bounded by TOL.
*          The eigenvectors output have residual norms
*          bounded by TOL, and the dot products between different
*          eigenvectors are bounded by TOL. TOL must be at least
*          N*EPS*|T|, where EPS is the machine precision and |T| is
*          the 1-norm of the tridiagonal matrix.
*
*  M       (input) INTEGER
*          The total number of eigenvalues found.  0 <= M <= N.
*          If RANGE = 'A', M = N, and if RANGE = 'I', M = IU-IL+1.
*
*  W       (input) DOUBLE PRECISION array, dimension (N)
*          The first M elements of W contain the eigenvalues for
*          which eigenvectors are to be computed.  The eigenvalues
*          should be grouped by split-off block and ordered from
*          smallest to largest within the block ( The output array
*          W from DLARRE is expected here ).
*          Errors in W must be bounded by TOL (see above).
*
*  IBLOCK  (input) INTEGER array, dimension (N)
*          The submatrix indices associated with the corresponding
*          eigenvalues in W; IBLOCK(i)=1 if eigenvalue W(i) belongs to
*          the first submatrix from the top, =2 if W(i) belongs to
*          the second submatrix, etc.
*
*  Z       (output) DOUBLE PRECISION array, dimension (LDZ, max(1,M) )
*          If JOBZ = 'V', then if INFO = 0, the first M columns of Z
*          contain the orthonormal eigenvectors of the matrix T
*          corresponding to the selected eigenvalues, with the i-th
*          column of Z holding the eigenvector associated with W(i).
*          If JOBZ = 'N', then Z is not referenced.
*          Note: the user must ensure that at least max(1,M) columns are
*          supplied in the array Z; if RANGE = 'V', the exact value of M
*          is not known in advance and an upper bound must be used.
*
*  LDZ     (input) INTEGER
*          The leading dimension of the array Z.  LDZ >= 1, and if
*          JOBZ = 'V', LDZ >= max(1,N).
*
*  ISUPPZ  (output) INTEGER ARRAY, dimension ( 2*max(1,M) )
*          The support of the eigenvectors in Z, i.e., the indices
*          indicating the nonzero elements in Z. The i-th eigenvector
*          is nonzero only in elements ISUPPZ( 2*i-1 ) through
*          ISUPPZ( 2*i ).
*
*  WORK    (workspace) DOUBLE PRECISION array, dimension (13*N)
*
*  IWORK   (workspace) INTEGER array, dimension (6*N)
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*          > 0:  if INFO = 1, internal error in DLARRB
*                if INFO = 2, internal error in DSTEIN
*
*  Further Details
*  ===============
*
*  Based on contributions by
*     Inderjit Dhillon, IBM Almaden, USA
*     Osni Marques, LBNL/NERSC, USA
*
*  =====================================================================
*
*     .. Parameters ..
      INTEGER            MGSSIZ
      PARAMETER          ( MGSSIZ = 20 )
      DOUBLE PRECISION   ZERO, ONE, FOUR
      PARAMETER          ( ZERO = 0.0D0, ONE = 1.0D0, FOUR = 4.0D0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            MGSCLS
      INTEGER            I, IBEGIN, IEND, IINDC1, IINDC2, IINDR, IINDWK,
     $                   IINFO, IM, IN, INDERR, INDGAP, INDLD, INDLLD,
     $                   INDWRK, ITER, ITMP1, ITMP2, J, JBLK, K, KTOT,
     $                   LSBDPT, MAXITR, NCLUS, NDEPTH, NDONE, NEWCLS,
     $                   NEWFRS, NEWFTT, NEWLST, NEWSIZ, NSPLIT, OLDCLS,
     $                   OLDFST, OLDIEN, OLDLST, OLDNCL, P, Q
      DOUBLE PRECISION   EPS, GAP, LAMBDA, MGSTOL, MINGMA, MINRGP,
     $                   NRMINV, RELGAP, RELTOL, RESID, RQCORR, SIGMA,
     $                   TMP1, ZTZ
*     ..
*     .. External Functions ..
      DOUBLE PRECISION   DDOT, DLAMCH, DNRM2
      EXTERNAL           DDOT, DLAMCH, DNRM2
*     ..
*     .. External Subroutines ..
      EXTERNAL           DAXPY, DCOPY, DLAR1V, DLARRB, DLARRF, DLASET,
     $                   DSCAL, DSTEIN
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, DBLE, MAX, MIN, SQRT
*     ..
*     .. Local Arrays ..
      INTEGER            TEMP( 1 )
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INDERR = N + 1
      INDLD = 2*N
      INDLLD = 3*N
      INDGAP = 4*N
      INDWRK = 5*N + 1
*
      IINDR = N
      IINDC1 = 2*N
      IINDC2 = 3*N
      IINDWK = 4*N + 1
*
      EPS = DLAMCH( 'Precision' )
*
      DO 10 I = 1, 2*N
         IWORK( I ) = 0
   10 CONTINUE
      DO 20 I = 1, M
         WORK( INDERR+I-1 ) = EPS*ABS( W( I ) )
   20 CONTINUE
      CALL DLASET( 'Full', N, N, ZERO, ZERO, Z, LDZ )
      MGSTOL = 5.0D0*EPS
*
      NSPLIT = IBLOCK( M )
      IBEGIN = 1
      DO 170 JBLK = 1, NSPLIT
         IEND = ISPLIT( JBLK )
*
*        Find the eigenvectors of the submatrix indexed IBEGIN
*        through IEND.
*
         IF( IBEGIN.EQ.IEND ) THEN
            Z( IBEGIN, IBEGIN ) = ONE
            ISUPPZ( 2*IBEGIN-1 ) = IBEGIN
            ISUPPZ( 2*IBEGIN ) = IBEGIN
            IBEGIN = IEND + 1
            GO TO 170
         END IF
         OLDIEN = IBEGIN - 1
         IN = IEND - OLDIEN
         RELTOL = MIN( 1.0D-2, ONE / DBLE( IN ) )
         IM = IN
         CALL DCOPY( IM, W( IBEGIN ), 1, WORK, 1 )
         DO 30 I = 1, IN - 1
            WORK( INDGAP+I ) = WORK( I+1 ) - WORK( I )
   30    CONTINUE
         WORK( INDGAP+IN ) = MAX( ABS( WORK( IN ) ), EPS )
         NDONE = 0
*
         NDEPTH = 0
         LSBDPT = 1
         NCLUS = 1
         IWORK( IINDC1+1 ) = 1
         IWORK( IINDC1+2 ) = IN
*
*        While( NDONE.LT.IM ) do
*
   40    CONTINUE
         IF( NDONE.LT.IM ) THEN
            OLDNCL = NCLUS
            NCLUS = 0
            LSBDPT = 1 - LSBDPT
            DO 150 I = 1, OLDNCL
               IF( LSBDPT.EQ.0 ) THEN
                  OLDCLS = IINDC1
                  NEWCLS = IINDC2
               ELSE
                  OLDCLS = IINDC2
                  NEWCLS = IINDC1
               END IF
*
*              If NDEPTH > 1, retrieve the relatively robust
*              representation (RRR) and perform limited bisection
*              (if necessary) to get approximate eigenvalues.
*
               J = OLDCLS + 2*I
               OLDFST = IWORK( J-1 )
               OLDLST = IWORK( J )
               IF( NDEPTH.GT.0 ) THEN
                  J = OLDIEN + OLDFST
                  CALL DCOPY( IN, Z( IBEGIN, J ), 1, D( IBEGIN ), 1 )
                  CALL DCOPY( IN, Z( IBEGIN, J+1 ), 1, L( IBEGIN ), 1 )
                  SIGMA = L( IEND )
               END IF
               K = IBEGIN
               DO 50 J = 1, IN - 1
                  WORK( INDLD+J ) = D( K )*L( K )
                  WORK( INDLLD+J ) = WORK( INDLD+J )*L( K )
                  K = K + 1
   50          CONTINUE
               IF( NDEPTH.GT.0 ) THEN
                  CALL DLARRB( IN, D( IBEGIN ), L( IBEGIN ),
     $                         WORK( INDLD+1 ), WORK( INDLLD+1 ),
     $                         OLDFST, OLDLST, SIGMA, RELTOL, WORK,
     $                         WORK( INDGAP+1 ), WORK( INDERR ),
     $                         WORK( INDWRK ), IWORK( IINDWK ), IINFO )
                  IF( IINFO.NE.0 ) THEN
                     INFO = 1
                     RETURN
                  END IF
               END IF
*
*              Classify eigenvalues of the current representation (RRR)
*              as (i) isolated, (ii) loosely clustered or (iii) tightly
*              clustered
*
               NEWFRS = OLDFST
               DO 140 J = OLDFST, OLDLST
                  IF( J.EQ.OLDLST .OR. WORK( INDGAP+J ).GE.RELTOL*
     $                ABS( WORK( J ) ) ) THEN
                     NEWLST = J
                  ELSE
*
*                    continue (to the next loop)
*
                     RELGAP = WORK( INDGAP+J ) / ABS( WORK( J ) )
                     IF( J.EQ.NEWFRS ) THEN
                        MINRGP = RELGAP
                     ELSE
                        MINRGP = MIN( MINRGP, RELGAP )
                     END IF
                     GO TO 140
                  END IF
                  NEWSIZ = NEWLST - NEWFRS + 1
                  MAXITR = 10
                  NEWFTT = OLDIEN + NEWFRS
                  IF( NEWSIZ.GT.1 ) THEN
                     MGSCLS = NEWSIZ.LE.MGSSIZ .AND. MINRGP.GE.MGSTOL
                     IF( .NOT.MGSCLS ) THEN
                        CALL DLARRF( IN, D( IBEGIN ), L( IBEGIN ),
     $                               WORK( INDLD+1 ), WORK( INDLLD+1 ),
     $                               NEWFRS, NEWLST, WORK,
     $                               Z( IBEGIN, NEWFTT ),
     $                               Z( IBEGIN, NEWFTT+1 ),
     $                               WORK( INDWRK ), IWORK( IINDWK ),
     $                               INFO )
                        IF( INFO.EQ.0 ) THEN
                           NCLUS = NCLUS + 1
                           K = NEWCLS + 2*NCLUS
                           IWORK( K-1 ) = NEWFRS
                           IWORK( K ) = NEWLST
                        ELSE
                           INFO = 0
                           IF( MINRGP.GE.MGSTOL ) THEN
                              MGSCLS = .TRUE.
                           ELSE
*
*                             Call DSTEIN to process this tight cluster.
*                             This happens only if MINRGP <= MGSTOL
*                             and DLARRF returns INFO = 1. The latter
*                             means that a new RRR to "break" the
*                             cluster could not be found.
*
                              WORK( INDWRK ) = D( IBEGIN )
                              DO 60 K = 1, IN - 1
                                 WORK( INDWRK+K ) = D( IBEGIN+K ) +
     $                                              WORK( INDLLD+K )
   60                         CONTINUE
                              DO 70 K = 1, NEWSIZ
                                 IWORK( IINDWK+K-1 ) = 1
   70                         CONTINUE
                              DO 80 K = NEWFRS, NEWLST
                                 ISUPPZ( 2*( IBEGIN+K )-3 ) = 1
                                 ISUPPZ( 2*( IBEGIN+K )-2 ) = IN
   80                         CONTINUE
                              TEMP( 1 ) = IN
                              CALL DSTEIN( IN, WORK( INDWRK ),
     $                                     WORK( INDLD+1 ), NEWSIZ,
     $                                     WORK( NEWFRS ),
     $                                     IWORK( IINDWK ), TEMP( 1 ),
     $                                     Z( IBEGIN, NEWFTT ), LDZ,
     $                                     WORK( INDWRK+IN ),
     $                                     IWORK( IINDWK+IN ),
     $                                     IWORK( IINDWK+2*IN ), IINFO )
                              IF( IINFO.NE.0 ) THEN
                                 INFO = 2
                                 RETURN
                              END IF
                              NDONE = NDONE + NEWSIZ
                           END IF
                        END IF
                     END IF
                  ELSE
                     MGSCLS = .FALSE.
                  END IF
                  IF( NEWSIZ.EQ.1 .OR. MGSCLS ) THEN
                     KTOT = NEWFTT
                     DO 100 K = NEWFRS, NEWLST
                        ITER = 0
   90                   CONTINUE
                        LAMBDA = WORK( K )
                        CALL DLAR1V( IN, 1, IN, LAMBDA, D( IBEGIN ),
     $                               L( IBEGIN ), WORK( INDLD+1 ),
     $                               WORK( INDLLD+1 ),
     $                               GERSCH( 2*OLDIEN+1 ),
     $                               Z( IBEGIN, KTOT ), ZTZ, MINGMA,
     $                               IWORK( IINDR+KTOT ),
     $                               ISUPPZ( 2*KTOT-1 ),
     $                               WORK( INDWRK ) )
                        TMP1 = ONE / ZTZ
                        NRMINV = SQRT( TMP1 )
                        RESID = ABS( MINGMA )*NRMINV
                        RQCORR = MINGMA*TMP1
                        IF( K.EQ.IN ) THEN
                           GAP = WORK( INDGAP+K-1 )
                        ELSE IF( K.EQ.1 ) THEN
                           GAP = WORK( INDGAP+K )
                        ELSE
                           GAP = MIN( WORK( INDGAP+K-1 ),
     $                           WORK( INDGAP+K ) )
                        END IF
                        ITER = ITER + 1
                        IF( RESID.GT.TOL*GAP .AND. ABS( RQCORR ).GT.
     $                      FOUR*EPS*ABS( LAMBDA ) ) THEN
                           WORK( K ) = LAMBDA + RQCORR
                           IF( ITER.LT.MAXITR ) THEN
                              GO TO 90
                           END IF
                        END IF
                        IWORK( KTOT ) = 1
                        IF( NEWSIZ.EQ.1 )
     $                     NDONE = NDONE + 1
                        CALL DSCAL( IN, NRMINV, Z( IBEGIN, KTOT ), 1 )
                        KTOT = KTOT + 1
  100                CONTINUE
                     IF( NEWSIZ.GT.1 ) THEN
                        ITMP1 = ISUPPZ( 2*NEWFTT-1 )
                        ITMP2 = ISUPPZ( 2*NEWFTT )
                        KTOT = OLDIEN + NEWLST
                        DO 120 P = NEWFTT + 1, KTOT
                           DO 110 Q = NEWFTT, P - 1
                              TMP1 = -DDOT( IN, Z( IBEGIN, P ), 1,
     $                               Z( IBEGIN, Q ), 1 )
                              CALL DAXPY( IN, TMP1, Z( IBEGIN, Q ), 1,
     $                                    Z( IBEGIN, P ), 1 )
  110                      CONTINUE
                           TMP1 = ONE / DNRM2( IN, Z( IBEGIN, P ), 1 )
                           CALL DSCAL( IN, TMP1, Z( IBEGIN, P ), 1 )
                           ITMP1 = MIN( ITMP1, ISUPPZ( 2*P-1 ) )
                           ITMP2 = MAX( ITMP2, ISUPPZ( 2*P ) )
  120                   CONTINUE
                        DO 130 P = NEWFTT, KTOT
                           ISUPPZ( 2*P-1 ) = ITMP1
                           ISUPPZ( 2*P ) = ITMP2
  130                   CONTINUE
                        NDONE = NDONE + NEWSIZ
                     END IF
                  END IF
                  NEWFRS = J + 1
  140          CONTINUE
  150       CONTINUE
            NDEPTH = NDEPTH + 1
            GO TO 40
         END IF
         J = 2*IBEGIN
         DO 160 I = IBEGIN, IEND
            ISUPPZ( J-1 ) = ISUPPZ( J-1 ) + OLDIEN
            ISUPPZ( J ) = ISUPPZ( J ) + OLDIEN
            J = J + 2
  160    CONTINUE
         IBEGIN = IEND + 1
  170 CONTINUE
*
      RETURN
*
*     End of DLARRV
*
      END

c ------------
c NCLFORTSTART
      SUBROUTINE DCDFCDFTT(N, P, T, DF, IER )
c NCL: p = cdft_t(p,df)
      IMPLICIT NONE
c input
      INTEGER N
      DOUBLE PRECISION P(N),DF(N)
c output
      INTEGER IER
      DOUBLE PRECISION T(N)
c NCLEND
c local
      INTEGER WHICH, I
      DOUBLE PRECISION Q,BOUND

C iwhich = 2 : Calculate T from P and DF
c              Q not returned
      WHICH = 2
      BOUND = -999.D0
      DO I=1,N
         Q = 1.0D0 - P(I)
         CALL CDFT(WHICH,P(I),Q,T(I),DF(I),IER,BOUND)
         IF (IER.NE.0) CALL DCDFTERR('CDFT_T',IER)
      END DO

      RETURN
      END
c ------------
c NCLFORTSTART
      SUBROUTINE DCDFCDFTP(N, P, T, DF, IER )
c NCL: p = cdft_p(t,df)
      IMPLICIT NONE
c input
      INTEGER N
      DOUBLE PRECISION T(N),DF(N)
c output
      INTEGER IER
      DOUBLE PRECISION P(N)
c NCLEND
c local
      INTEGER WHICH, I
      DOUBLE PRECISION Q,BOUND

C iwhich = 1 : Calculate P from T and DF
c              Q not returned
      WHICH = 1
      BOUND = -999.D0
      DO I=1,N
         Q = 1.0D0 - P(I)
         CALL CDFT(WHICH,P(I),Q,T(I),DF(I),IER,BOUND)
         IF (IER.NE.0) CALL DCDFTERR('CDFT_T',IER)
      END DO

      RETURN
      END
c ------------
      SUBROUTINE DCDFTERR(NAME,IER)
c error messages for cdft_{t, p} functions
      IMPLICIT NONE
      CHARACTER*(*) NAME
      INTEGER IER

      IF (IER.NE.0) THEN
          IF (IER.LT.0) PRINT *,NAME,': bad input parameter, IER=', IER
          IF (IER.EQ.1) PRINT *,NAME,': lower bound error'
          IF (IER.EQ.2) PRINT *,NAME,': upper bound error'
          IF (IER.EQ.3) PRINT *,NAME,': P+Q .ne. 1'
      END IF
      RETURN
      END

C NCLFORTSTART
      subroutine dmlegevi(x, nx, xmsg, vals, xx, ierr)
      implicit none
C                                               !  INPUT
      integer nx
      double precision x(nx),  xx(nx), xmsg
C                                               !  OUTPUT
      integer ierr
      double precision vals(6)
C NCLEND
c
c Interface to AS-215 algorithm
c     (1) remove msg values
c     (2) create 1st guess for parameters
c     (2) return a selected subset of values
c                                               ! LOCAL
      integer monit, nxn, n
      double precision para(3), vcov(6)         ! see subroutine
      double precision euler, pi, six, zero     ! local variables  
      double precision x1, x2, x3, xvar, xstd, xavg

c c c double precision xx(nx)                   ! f90 auto array
c c c double precision,allocatable::xx(:)       ! allocate in calling routine
      
      pi    = 3.141592653589793d0
      euler = 0.577215664901532d0        ! Euler–Mascheroni constant
      six   = 6.0d0
      zero  = 0.0d0
c                                               ! strip msg
c     allocate(xx(nx))
      nxn = 0
      do n=1,nx
         if (x(n).ne.xmsg) then
             nxn = nxn+1
             xx(nxn) = x(n)
         end if
      end do

c c c if (nxn.eq.0) then
      if (nxn.lt.10) then                       ! arbitrary
          do n=1,6
             vals(n) = xmsg
          end do
          ierr  = -999                          ! all msg
      else
          x1  = zero 
          x2  = zero 
          do n=1,nxn
             x1 = x1 + xx(n)
             x2 = x2 + xx(n)*xx(n) 
          end do
          x3    = x1*x1/nxn
          xvar  = (x2-x3)/(nxn-1)
          xstd  = sqrt(max(xvar,zero))          ! prevent possible roundoff
          xavg  = x1/nxn
                                                ! 1st guess at parameters
          para(1) = zero                        ! location, center, shift
          para(2) = xstd*sqrt(six/pi)           ! scale
          para(3) = xavg-euler*para(1)          ! shape

          monit = 0                             ! no monitoring
          call dmlegev(xx, nxn, para, vcov, monit, ierr)

          vals(1) = para(1)                     ! location (center, shift)
          vals(2) = para(2)                     ! scale parameter
          vals(3) = para(3)                     ! shape parameter

c                                               ! std errors
          vals(4) = sqrt(vcov(1))               ! location (center, shift)
          vals(5) = sqrt(vcov(3))               ! scale
          vals(6) = sqrt(vcov(6))               ! shape
      end if
      return
      end
C-----------------------------------------------------------------
c Algorithm AS 215
c Maximum-Likelihood Estimation of the Parameters of the Generalized Extreme-Value Distribution
c J. R. M. Hosking
c Journal of the Royal Statistical Society. Series C (Applied Statistics) 
c Vol. 34, No. 3 (1985), pp. 301-310
c Stable URL: http://www.jstor.org/stable/2347483
C-----------------------------------------------------------------
      SUBROUTINE DMLEGEV(X, N, PARA, VCOV, MONIT, IFAULT)
      IMPLICIT NONE
      INTEGER N, MONIT, IFAULT
      DOUBLE PRECISION PARA(3), VCOV(6), X(N)

C CODE:    http://ftp.uni-bayreuth.de/math/statlib/apstat/215
C ARTICLE: http://www.jstor.org/stable/pdf/2347483

c INPUT
c  X  Double precision array (N) input: data array
c  N Integer input: sample size
c  PARA Double precision array (3) input: initial estimates of the parameters, in the order #, ae, k
c
C OUTPUT
C VCOV(6) double precision array (6): on successful exit (IFAULT= 0)
C         the lower triangle of the estimated variance-covariance matrix, H-1, 
C         of the maximum-likelihood estimates, stored row by row.
C MONIT  Integer input: flag for monitoring of iterations (see below)
C IFAULT Integer output: failure indicator (see below)
C      0 on successful exit
C      1 if N < 2. PARA and VCO V are set to zero
C      2 if maximum number of iterations reached
C      3 if maximum number of evaluations of log-likelihood reached
C      4 if maximum number of steplength reductions reache
C
      INTEGER I, ITYPE, KK, MAXEV, MAXIT, MAXSR, NEVAL, NITER, NSR

C        ALGORITHM AS215   APPL. STATIST. (1985) VOL. 34, NO. 3
C        Modifications in AS R76 (1989) have been incorporated.
C
C        Additional modifications by J. R. M. Hosking, August 1994:
C        Modify steepest-ascent step so that it is invariant to
C        rescaling the data.  Improves chance of convergence from
C        poor initial values.
C
C        MAXIMUM-LIKELIHOOD ESTIMATION OF GENERALIZED EXTREME-VALUE
C        DISTRIBUTION
C
      DOUBLE PRECISION A, ACCA, ACCG, ACCU, AI, AIGI, AN, D, DA, DAA,
     *  DAG, DELA, DELG, DELU, DG, DGG, DU, DUA, DUG, DUU, E, F, FOLD,
     *  G, GAI, GG, GI, GIPQ, GNORM, H, HALF, HE, HH, ONE, P, PA, PQ,
     *  PQG, PU, Q, QA, QU, R, RA, RATIO, RG, RU, SE, SH, SHE, SHH,
     *  SHHE, SMALL, SRF, STEPA, STEPG, STEPU, SY, SYE, SYHE, SYYE,
     *  TEMP1, TEMP2, U, VLNEG, XMAX, XMIN, Y, YE, Z, ZERO
      CHARACTER*8 ACTI1, ACTI2, ACTI3, ACTI4, ACTI5, ACTI6, ACTI7,
     *  ACTI8, ACTI9
      DATA ACTI1/'  NEWTON'/, ACTI2/'  ST.ASC'/, ACTI3/'  RESETK'/,
     *  ACTI4/'  SR.INF'/, ACTI5/'  SR.LIK'/, ACTI6/'  MAX.SR'/,
     *  ACTI7/'  MAX.EV'/, ACTI8/'  MAX.IT'/, ACTI9/'  CONVGD'/
      DATA ZERO /0.0D0/, HALF /0.5D0/, ONE/1.0D0/
C
C        ADDU,ACCA,ACCG ARE ACCURACY CRITERIA FOR TESTING CONVERGENCE
C        STEPU,STEPA,STEPG ARE MAXIMUM STEPLENGTHS FOR ITERATIONS
C        ACCU,ACCA,STEPU,STEPA ARE SCALED BY CURRENT VALUE OF A WHEN
C        USED IN PROGRAM
C
      DATA ACCU, ACCA, ACCG /3 * 1D-5/, STEPU, STEPA, STEPG /
     *  0.5D0, 0.25D0, 0.2D0/
C
C        MAXIT IS MAX. NO. OF ITERATIONS
C        MAXEV IS MAX. NO. OF EVALUATIONS OF LIKELIHOOD FUNCTION
C        SRF IS STEPLENGTH REDUCTION FACTOR
C        MAXSR IS MAX. NO. OF STEPLENGTH REDUCTIONS PERMITTED PER
C        ITERATION
C
      DATA MAXIT /30/, MAXEV /50/, SRF /0.25D0/, MAXSR /30/
C
C        SMALL IS A SMALL NUMBER, USED TO ADJUST THE SHAPE PARAMETER TO
C        AVOID AN EXACT ZERO VALUE OR BORDERLINE INFEASIBILITY
C        ALNEG IS A LARGE NEGATIVE NUMBER, USED TO INITIALIZE
C        LOG-LIKELIHOOD
C
      DATA SMALL /1.D-3/, VLNEG /-1.D37/
C
C        FIND MIN AND MAX DATA VALUE
C
      DO 10 I = 1, 6
  10  VCOV(I) = ZERO
      IFAULT = 1
      IF (N .LE. 2) GOTO 170
      XMIN = X(1)
      XMAX = X(1)
      DO 20 I = 2, N
        IF (X(I) .LT. XMIN) XMIN = X(I)
        IF (X(I) .GT. XMAX) XMAX = X(I)
   20 CONTINUE
C
C       INITIALIZATION
C       U IS LOCATION PARAMETER
C       A IS SCALE PARAMETER
C       G IS SHAPE PARAMETER
C
      IF (MONIT .GT. 0) WRITE (6, 6000)
      IFAULT = 0
      NITER = 0
      NEVAL =0
      FOLD = VLNEG
      U = PARA(1)
      A = PARA(2)
      G = PARA(3)
      IF (ABS(G) .LT. SMALL) G = SMALL
      IF (A .LE. ZERO) A = ONE
      AN = DBLE(FLOAT(N))
C
C        CHECK WHETHER ALL DATA POINTS LIE WITHIN THE RANGE OF THE GEV
C        DISTRIBUTION WITH THE INITIAL PARAMETERS - IF NOT, ADJUST THE
C        SHAPE PARAMETER SO AS TO BRING ALL POINTS WITHIN RANGE
C
      IF (G .GT. ZERO) GOTO 30
      IF (XMIN .GE. U) GOTO 40
      Z = A / (XMIN - U)
      IF (G .GT. Z) GOTO 40
      IF (MONIT .GT. 0) WRITE (6, 6010) NITER, NEVAL, U, A, G, ACTI3
      G = Z + SMALL
      IF (G .GE. ZERO) G = HALF * Z
      GOTO 40
   30 IF (XMAX .LE. U) GOTO 40
      Z = A / (XMAX - U)
      IF (G .LT. Z) GOTO 40
      IF(MONIT .GT. 0) WRITE (6, 6010) NITER, NEVAL, U, A, G, ACTI3
      G = Z - SMALL
      IF (G .LE. ZERO) G = HALF * Z
C
C        START OF MAIN LOOP
C
   40 DO 140 NITER = 1, MAXIT
C
      NSR = 0
   50 IF (NEVAL .GE. MAXEV) GOTO 150
      NEVAL = NEVAL + 1
      AI = ONE / A
      GI = ONE /G
      GAI = G * AI
      AIGI = AI * GI
      GG = ONE - G
C
C       ACCUMULATE SUMS OF QUANTITIES OCCURRING IN LIKELIHOOD
C       DERIVATIVES
C
C       IN PRESCOTT AND WALDEN'S NOTATION:
C       Z IS 1 - K * (X(I)-U) / A
C       Y IS THE REDUCED VARIATE - (1/K) * LOG(Z)
C       E IS EXP(-Y)
C       H IS EXP(K*Y)
C
      SY = ZERO
      SE = ZERO
      SYE = ZERO
      SYYE = ZERO
      SH = ZERO
      SHE = ZERO
      SYHE = ZERO
      SHHE = ZERO
      SHH = ZERO
      DO 60 I = 1, N
        Z = ONE -GAI * (X(I) - U)
        Y = -GI * LOG(Z)
        E = EXP(-Y)
        H = ONE / Z
        YE = Y * E
        HE = H * E
        HH = H * H
        SY = SY + Y
        SE = SE + E
        SYE = SYE + YE
        SYYE = SYYE + Y * YE
        SH = SH + H
        SHE = SHE + HE
        SYHE = SYHE + Y * HE
        SHHE = SHHE + HH * E
        SHH = SHH + HH
   60 CONTINUE
C
C       F IS CURRENT VALUE OF LIKELIHOOD FUNCTIONN
C
      F = -AN * LOG(A) - GG * SY - SE
      IF (F .GT. FOLD) GOTO 90
C
C       LIKELIHOOD HAS NOT INCREASED - REDUCE STEPLENGTH AND TRY AGAIN
C
      IF (MONIT .GT. 0) WRITE(6, 6010) NITER, NEVAL, U, A, G, ACTI5, F
      IF (NSR .EQ. MAXSR) GOTO 80
   70 NSR = NSR + 1
      U = U - DELU
      A = A - DELA
      G = G - DELG
      DELU = SRF * DELU
      DELA = SRF * DELA
      DELG = SRF * DELG
      U = U + DELU
      A = A + DELA
      G = G + DELG
      IF (A .GT. G * (XMIN - U) .AND. A .GT. G * (XMAX - U) .AND. G .NE.
     *  ZERO) GO TO 50
      IF (MONIT .GT. 0) WRITE (6, 6010) NITER, NEVAL, U, A, G, ACTI4
      IF (NSR .LT. MAXSR) GOTO 70
C
C        MAX. NO. OF STEPLENGTH REDUCTIONS REACHED
C        IF CURRENT ITERATION IS NEWTON-RAPHSON, TRY STEEPEST ASCENT
C        INSTEAD.  IF CURRENT ITERATION IS STEEPEST ASCENT, GIVE UP.
C
   80 U = U - DELU
      A = A - DELA
      G = G - DELG
      IF (MONIT .GT. 0) WRITE(6, 6010) NITER, NEVAL, U, A, G, ACTI6
      IF (ITYPE .EQ. 1) GOTO 100
      IFAULT = 4
      GOTO 160
C
C        P,Q,R, ARE AS DEFINED IN FLOOD STUDIES REPORT
C
   90 FOLD = F
      P = AN - SE
      Q = SHE - GG * SH
      R = AN - SY + SYE
      PQ = P + Q
      GIPQ = GI * PQ
C
C        FIRST DERIVATIVES OF LOG-LIKELIHOOD
C
      DU = -AI * Q
      DA = -AIGI * PQ
      DG = -GI * (R - GIPQ)
      IF (MONIT .GT. 0) GNORM = SQRT(DU * DU + DA * DA + DG * DG)
C
C        DERIVATIVES OF P,Q,R
C
      PU = -AI * SHE
      PA = GI * PU + AIGI * SE
      QU = GG * AI * (SHHE + G * SHH)
      RU = AI * (SH - SHE + SYHE)
      RA = GI * RU - AIGI * (AN - SE + SYE)
      RG = GI * (SY - SYE + SYYE - A * RA)
      QA = AI * Q + GI * (PU + QU)
      PQG = GIPQ + A * (RA - GI * (PA + QA))
C
C         MINUS SECOND DERIVATIVE OF LOG-LIKELIHOOD (HESSIAN MATRIX)
C
      DUU = AI * QU
      DUA = AIGI * (PU + QU)
      DAA = -AIGI * (AI * PQ - PA - QA)
      DUG = GI * (RU - GI * (PU + QU))
      DAG = -AIGI * (GIPQ - PQG)
      DGG = GI * (RG - GI * (PQG + R - GIPQ - GIPQ))
C
C         INVERT HESSIAN MATRIX
C
      DO 95 KK = 1, 3
        IF (DUU .LE. ZERO) GO TO 100
        D = ONE / DUU
        TEMP1 = -DUA * D
        IF (KK .GT. 2) TEMP1 = -TEMP1
        TEMP2 = -DUG * D
        IF (KK .GT. 1) TEMP2 = -TEMP2
        DUU = DAA + TEMP1 * DUA
        DUA = DAG + TEMP1 * DUG
        DAA = DGG + TEMP2 * DUG
        DUG = TEMP1
        DAG = TEMP2
        DGG = D
   95 CONTINUE
C
C        CALCULATE STEPLENGTHS
C
      ITYPE = 1
      IF (MONIT .GT. 0) WRITE(6, 6010) NITER, NEVAL, U, A, G, ACTI1, F,
     *  GNORM
      DELU = DUU * DU + DUA * DA + DUG * DG
      DELA = DUA * DU + DAA * DA + DAG * DG
      DELG = DUG * DU + DAG * DA + DGG * DG
      RATIO = MAX(ABS(DELU) / (STEPU * A), ABS(DELA) / (STEPA * A),
     *  ABS(DELG) / STEPG)
      IF (RATIO .LT. ONE) GOTO 110
      RATIO = ONE / RATIO
      DELU = DELU * RATIO
      DELA = DELA * RATIO
      DELG = DELG * RATIO
      GOTO 110
C
C        HESSIAN IS NOT POSITIVE DEFINITE - MAKE A LARGE STEP IN THE
C        DIRECTION OF STEEPEST ASCENT
C
  100 ITYPE = 2
      IF (MONIT .GT. 0) WRITE(6, 6010) NITER, NEVAL, U, A, G, ACTI2, F,
     *  GNORM
C---------------------------------------  NEXT 11 LINES ADDED, AUG.94
      D = ABS(VLNEG)
      TEMP1 = D
      IF (DU .NE. ZERO) TEMP1 = STEPU / (ABS(DU) * A)
      TEMP2 = D
      IF (DA .NE. ZERO) TEMP2 = STEPA / (ABS(DA) * A)
      Z = D
      IF (DG .NE. ZERO) Z = STEPG / ABS(DG)
      RATIO = MIN(TEMP1, TEMP2, Z)
      DELU = RATIO * DU * A * A
      DELA = RATIO * DA * A * A
      DELG = RATIO * DG
C---------------------------------------  NEXT 11 LINES REMOVED, AUG.94
C      D = ABS(VLNEG)
C      TEMP1 = D
C      IF (DU .NE. ZERO) TEMP1 = STEPU * A / ABS(DU)
C      TEMP2 = D
C      IF (DA .NE. ZERO) TEMP2 = STEPA * A / ABS(DA)
C      Z = D
C      IF (DG .NE. ZERO) Z = STEPG / ABS(DG)
C      RATIO = MIN(TEMP1, TEMP2, Z)
C      DELU = RATIO * DU
C      DELA = RATIO * DA
C      DELG = RATIO * DG
C---------------------------------------  END OF DELETED CODE
C
C        ADJUST PARAMETERS
C
  110 U = U + DELU
      A = A + DELA
      G = G + DELG
C
C        TEST FOR FEASIBILITY
C
      IF (A .GT. G * (XMIN - U) .AND. A .GT. G * (XMAX - U) .AND. G .NE.
     *  ZERO) GOTO 130
      DO 120 NSR = 1, MAXSR
        IF (MONIT .GT. 0) WRITE(6, 6010) NITER, NEVAL, U, A, G, ACTI4
        U = U - DELU
        A = A - DELA
        G = G - DELG
        DELU = SRF * DELU
        DELA = SRF * DELA
        DELG = SRF * DELG
        U = U + DELU
        A = A + DELA
        G = G + DELG
        IF (A .GT. G * (XMIN - U) .AND. A .GT. G * (XMAX - Y) .AND.
     *     G .NE. ZERO) GOTO 140
  120 CONTINUE
      GOTO 80
C
C        TEST FOR CONVERGENCE
C
  130 IF (ABS(DELU) .GT. ACCU * A) GOTO 140
      IF (ABS(DELA) .GT. ACCA * A) GOTO 140
      IF (ABS(DELG) .GT. ACCG) GOTO 140
      IF (MONIT .GT. 0) WRITE(6, 6010) NITER, NEVAL, U, A, G, ACTI9
      VCOV(1) = DUU
      VCOV(2) = DUA
      VCOV(3) = DAA
      VCOV(4) = DUG
      VCOV(5) = DAG
      VCOV(6) = DGG
      GOTO 160
C
C        END OF MAIN LOOP
C
  140 CONTINUE
C
C        ITERATIONS NOT CONVERGED - SET FAULT FLAG
C
      IFAULT = 2
      IF (MONIT .GT. 0) WRITE(6, 6010) MAXIT, NEVAL, U, A, G, ACTI8
      GOTO 160
  150 IFAULT = 3
      IF (MONIT .GT. 0) WRITE(6, 6010) NITER, MAXEV, U, A, G, ACTI7
C
C        ITERATION FINISHED -COPY RESULTS INTO ARRAY PARA
C
  160 IF (MONIT .GT. 0) WRITE(6, 6020)
      PARA(1) = U
      PARA(2) = A
      PARA(3) = G
      RETURN
C
  170 DO 180 I = 1, 3
  180 PARA(I) = ZERO
      RETURN
C
 6000 FORMAT(/' MAXIMUM-LIKELIHOOD ESTIMATION OF GENERALIZED EXTREME',
     *  1X, 'VALUE DISTRIBUTION'// ' ITER EVAL', 8X, 'XI', 5X, 'ALPHA',
     *  9X, 'K  ACTION', 6X, 'LOG-L', 7X, 'GNORM')
 6010 FORMAT(1X, I4, I5, 3F10.4, 1X, A, F11.3, 1PD12.2)
 6020 FORMAT(1H0)
      END

      PROGRAM PGKEX26
C
C  Illustrate creating multiple metafiles in the same job.
C
      DIMENSION XA(2),YA(2)
      DATA XA(1),XA(2),YA(1),YA(2)/0.,1.,0.,1./
C
C  Open GKS.
C
      CALL GOPKS (6,IDUM)
C
C  Open and activate a metafile with the name META01.
C
      CALL NGSETC('ME','META01')
      CALL GOPWK (1, 2, 1)
      CALL GACWK (1)
C
C  Draw a single red line in the only frame in META01 .
C
      CALL GSCR(1,1,1.,0.,0.)
      CALL GSPLCI(1)
      CALL GPL(2,XA,YA)
      CALL FRAME
C
C  Deactivate and close the META01 metafile.
C
      CALL GDAWK (1)
      CALL GCLWK (1)
C
C  Open and activate META02.
C
      CALL NGSETC('ME','META02')
      CALL GOPWK (1, 2, 1)
      CALL GACWK (1)
C
C  Draw a single green line in the only frame in META02 (all color
C  table entries have to be redefined).
C
      CALL GSCR(1,2,0.,1.,0.)
      CALL GSPLCI(2)
      CALL GPL(2,XA,YA)
      CALL FRAME
C
C  Deactivate and close the META02 metafile.
C
      CALL GDAWK (1)
      CALL GCLWK (1)
C
C  Close GKS.
C
      CALL GCLKS
C
      STOP
      END

C
C $Id: idiot.f,v 1.9 2008-07-27 00:14:36 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE IDIOT (XDRA,YDRA,NPTS,LTYP,LDSH,LABX,LABY,LABG,LFRA)
C
      REAL XDRA(*),YDRA(*)
C
      INTEGER LDSH(*)
C
      CHARACTER*(*) LABX,LABY,LABG
C
      CHARACTER*16 AGBNCH
C
C This is an implementation of the routine from which AUTOGRAPH grew.
C It should work pretty much as the original did (if you can figure out
C what that was).
C
      CALL ANOTAT (LABX,LABY,1,2-SIGN(1,NPTS),1,AGBNCH(LDSH))
C
      CALL DISPLA (2-MAX(-1,MIN(1,LFRA)),1,LTYP)
C
      CALL AGEZSU (5,XDRA,YDRA,ABS(NPTS),1,ABS(NPTS),LABG,IIVX,IIEX,
     +                                                        IIVY,IIEY)
      CALL AGBACK
C
      CALL AGCURV (XDRA,1,YDRA,1,ABS(NPTS),1)
C
      IF (LFRA.GT.0) CALL FRAME
C
      RETURN
C
      END

      SUBROUTINE DGGSVD( JOBU, JOBV, JOBQ, M, N, P, K, L, A, LDA, B,
     $                   LDB, ALPHA, BETA, U, LDU, V, LDV, Q, LDQ, WORK,
     $                   IWORK, INFO )
*
*  -- LAPACK driver routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          JOBQ, JOBU, JOBV
      INTEGER            INFO, K, L, LDA, LDB, LDQ, LDU, LDV, M, N, P
*     ..
*     .. Array Arguments ..
      INTEGER            IWORK( * )
      DOUBLE PRECISION   A( LDA, * ), ALPHA( * ), B( LDB, * ),
     $                   BETA( * ), Q( LDQ, * ), U( LDU, * ),
     $                   V( LDV, * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  DGGSVD computes the generalized singular value decomposition (GSVD)
*  of an M-by-N real matrix A and P-by-N real matrix B:
*
*      U'*A*Q = D1*( 0 R ),    V'*B*Q = D2*( 0 R )
*
*  where U, V and Q are orthogonal matrices, and Z' is the transpose
*  of Z.  Let K+L = the effective numerical rank of the matrix (A',B')',
*  then R is a K+L-by-K+L nonsingular upper triangular matrix, D1 and
*  D2 are M-by-(K+L) and P-by-(K+L) "diagonal" matrices and of the
*  following structures, respectively:
*
*  If M-K-L >= 0,
*
*                      K  L
*         D1 =     K ( I  0 )
*                  L ( 0  C )
*              M-K-L ( 0  0 )
*
*                    K  L
*         D2 =   L ( 0  S )
*              P-L ( 0  0 )
*
*                  N-K-L  K    L
*    ( 0 R ) = K (  0   R11  R12 )
*              L (  0    0   R22 )
*
*  where
*
*    C = diag( ALPHA(K+1), ... , ALPHA(K+L) ),
*    S = diag( BETA(K+1),  ... , BETA(K+L) ),
*    C**2 + S**2 = I.
*
*    R is stored in A(1:K+L,N-K-L+1:N) on exit.
*
*  If M-K-L < 0,
*
*                    K M-K K+L-M
*         D1 =   K ( I  0    0   )
*              M-K ( 0  C    0   )
*
*                      K M-K K+L-M
*         D2 =   M-K ( 0  S    0  )
*              K+L-M ( 0  0    I  )
*                P-L ( 0  0    0  )
*
*                     N-K-L  K   M-K  K+L-M
*    ( 0 R ) =     K ( 0    R11  R12  R13  )
*                M-K ( 0     0   R22  R23  )
*              K+L-M ( 0     0    0   R33  )
*
*  where
*
*    C = diag( ALPHA(K+1), ... , ALPHA(M) ),
*    S = diag( BETA(K+1),  ... , BETA(M) ),
*    C**2 + S**2 = I.
*
*    (R11 R12 R13 ) is stored in A(1:M, N-K-L+1:N), and R33 is stored
*    ( 0  R22 R23 )
*    in B(M-K+1:L,N+M-K-L+1:N) on exit.
*
*  The routine computes C, S, R, and optionally the orthogonal
*  transformation matrices U, V and Q.
*
*  In particular, if B is an N-by-N nonsingular matrix, then the GSVD of
*  A and B implicitly gives the SVD of A*inv(B):
*                       A*inv(B) = U*(D1*inv(D2))*V'.
*  If ( A',B')' has orthonormal columns, then the GSVD of A and B is
*  also equal to the CS decomposition of A and B. Furthermore, the GSVD
*  can be used to derive the solution of the eigenvalue problem:
*                       A'*A x = lambda* B'*B x.
*  In some literature, the GSVD of A and B is presented in the form
*                   U'*A*X = ( 0 D1 ),   V'*B*X = ( 0 D2 )
*  where U and V are orthogonal and X is nonsingular, D1 and D2 are
*  ``diagonal''.  The former GSVD form can be converted to the latter
*  form by taking the nonsingular matrix X as
*
*                       X = Q*( I   0    )
*                             ( 0 inv(R) ).
*
*  Arguments
*  =========
*
*  JOBU    (input) CHARACTER*1
*          = 'U':  Orthogonal matrix U is computed;
*          = 'N':  U is not computed.
*
*  JOBV    (input) CHARACTER*1
*          = 'V':  Orthogonal matrix V is computed;
*          = 'N':  V is not computed.
*
*  JOBQ    (input) CHARACTER*1
*          = 'Q':  Orthogonal matrix Q is computed;
*          = 'N':  Q is not computed.
*
*  M       (input) INTEGER
*          The number of rows of the matrix A.  M >= 0.
*
*  N       (input) INTEGER
*          The number of columns of the matrices A and B.  N >= 0.
*
*  P       (input) INTEGER
*          The number of rows of the matrix B.  P >= 0.
*
*  K       (output) INTEGER
*  L       (output) INTEGER
*          On exit, K and L specify the dimension of the subblocks
*          described in the Purpose section.
*          K + L = effective numerical rank of (A',B')'.
*
*  A       (input/output) DOUBLE PRECISION array, dimension (LDA,N)
*          On entry, the M-by-N matrix A.
*          On exit, A contains the triangular matrix R, or part of R.
*          See Purpose for details.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A. LDA >= max(1,M).
*
*  B       (input/output) DOUBLE PRECISION array, dimension (LDB,N)
*          On entry, the P-by-N matrix B.
*          On exit, B contains the triangular matrix R if M-K-L < 0.
*          See Purpose for details.
*
*  LDB     (input) INTEGER
*          The leading dimension of the array B. LDA >= max(1,P).
*
*  ALPHA   (output) DOUBLE PRECISION array, dimension (N)
*  BETA    (output) DOUBLE PRECISION array, dimension (N)
*          On exit, ALPHA and BETA contain the generalized singular
*          value pairs of A and B;
*            ALPHA(1:K) = 1,
*            BETA(1:K)  = 0,
*          and if M-K-L >= 0,
*            ALPHA(K+1:K+L) = C,
*            BETA(K+1:K+L)  = S,
*          or if M-K-L < 0,
*            ALPHA(K+1:M)=C, ALPHA(M+1:K+L)=0
*            BETA(K+1:M) =S, BETA(M+1:K+L) =1
*          and
*            ALPHA(K+L+1:N) = 0
*            BETA(K+L+1:N)  = 0
*
*  U       (output) DOUBLE PRECISION array, dimension (LDU,M)
*          If JOBU = 'U', U contains the M-by-M orthogonal matrix U.
*          If JOBU = 'N', U is not referenced.
*
*  LDU     (input) INTEGER
*          The leading dimension of the array U. LDU >= max(1,M) if
*          JOBU = 'U'; LDU >= 1 otherwise.
*
*  V       (output) DOUBLE PRECISION array, dimension (LDV,P)
*          If JOBV = 'V', V contains the P-by-P orthogonal matrix V.
*          If JOBV = 'N', V is not referenced.
*
*  LDV     (input) INTEGER
*          The leading dimension of the array V. LDV >= max(1,P) if
*          JOBV = 'V'; LDV >= 1 otherwise.
*
*  Q       (output) DOUBLE PRECISION array, dimension (LDQ,N)
*          If JOBQ = 'Q', Q contains the N-by-N orthogonal matrix Q.
*          If JOBQ = 'N', Q is not referenced.
*
*  LDQ     (input) INTEGER
*          The leading dimension of the array Q. LDQ >= max(1,N) if
*          JOBQ = 'Q'; LDQ >= 1 otherwise.
*
*  WORK    (workspace) DOUBLE PRECISION array,
*                      dimension (max(3*N,M,P)+N)
*
*  IWORK   (workspace/output) INTEGER array, dimension (N)
*          On exit, IWORK stores the sorting information. More
*          precisely, the following loop will sort ALPHA
*             for I = K+1, min(M,K+L)
*                 swap ALPHA(I) and ALPHA(IWORK(I))
*             endfor
*          such that ALPHA(1) >= ALPHA(2) >= ... >= ALPHA(N).
*
*  INFO    (output)INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value.
*          > 0:  if INFO = 1, the Jacobi-type procedure failed to
*                converge.  For further details, see subroutine DTGSJA.
*
*  Internal Parameters
*  ===================
*
*  TOLA    DOUBLE PRECISION
*  TOLB    DOUBLE PRECISION
*          TOLA and TOLB are the thresholds to determine the effective
*          rank of (A',B')'. Generally, they are set to
*                   TOLA = MAX(M,N)*norm(A)*MAZHEPS,
*                   TOLB = MAX(P,N)*norm(B)*MAZHEPS.
*          The size of TOLA and TOLB may affect the size of backward
*          errors of the decomposition.
*
*  Further Details
*  ===============
*
*  2-96 Based on modifications by
*     Ming Gu and Huan Ren, Computer Science Division, University of
*     California at Berkeley, USA
*
*  =====================================================================
*
*     .. Local Scalars ..
      LOGICAL            WANTQ, WANTU, WANTV
      INTEGER            I, IBND, ISUB, J, NCYCLE
      DOUBLE PRECISION   ANORM, BNORM, SMAX, TEMP, TOLA, TOLB, ULP, UNFL
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      DOUBLE PRECISION   DLAMCH, DLANGE
      EXTERNAL           LSAME, DLAMCH, DLANGE
*     ..
*     .. External Subroutines ..
      EXTERNAL           DCOPY, DGGSVP, DTGSJA, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters
*
      WANTU = LSAME( JOBU, 'U' )
      WANTV = LSAME( JOBV, 'V' )
      WANTQ = LSAME( JOBQ, 'Q' )
*
      INFO = 0
      IF( .NOT.( WANTU .OR. LSAME( JOBU, 'N' ) ) ) THEN
         INFO = -1
      ELSE IF( .NOT.( WANTV .OR. LSAME( JOBV, 'N' ) ) ) THEN
         INFO = -2
      ELSE IF( .NOT.( WANTQ .OR. LSAME( JOBQ, 'N' ) ) ) THEN
         INFO = -3
      ELSE IF( M.LT.0 ) THEN
         INFO = -4
      ELSE IF( N.LT.0 ) THEN
         INFO = -5
      ELSE IF( P.LT.0 ) THEN
         INFO = -6
      ELSE IF( LDA.LT.MAX( 1, M ) ) THEN
         INFO = -10
      ELSE IF( LDB.LT.MAX( 1, P ) ) THEN
         INFO = -12
      ELSE IF( LDU.LT.1 .OR. ( WANTU .AND. LDU.LT.M ) ) THEN
         INFO = -16
      ELSE IF( LDV.LT.1 .OR. ( WANTV .AND. LDV.LT.P ) ) THEN
         INFO = -18
      ELSE IF( LDQ.LT.1 .OR. ( WANTQ .AND. LDQ.LT.N ) ) THEN
         INFO = -20
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DGGSVD', -INFO )
         RETURN
      END IF
*
*     Compute the Frobenius norm of matrices A and B
*
      ANORM = DLANGE( '1', M, N, A, LDA, WORK )
      BNORM = DLANGE( '1', P, N, B, LDB, WORK )
*
*     Get machine precision and set up threshold for determining
*     the effective numerical rank of the matrices A and B.
*
      ULP = DLAMCH( 'Precision' )
      UNFL = DLAMCH( 'Safe Minimum' )
      TOLA = MAX( M, N )*MAX( ANORM, UNFL )*ULP
      TOLB = MAX( P, N )*MAX( BNORM, UNFL )*ULP
*
*     Preprocessing
*
      CALL DGGSVP( JOBU, JOBV, JOBQ, M, P, N, A, LDA, B, LDB, TOLA,
     $             TOLB, K, L, U, LDU, V, LDV, Q, LDQ, IWORK, WORK,
     $             WORK( N+1 ), INFO )
*
*     Compute the GSVD of two upper "triangular" matrices
*
      CALL DTGSJA( JOBU, JOBV, JOBQ, M, P, N, K, L, A, LDA, B, LDB,
     $             TOLA, TOLB, ALPHA, BETA, U, LDU, V, LDV, Q, LDQ,
     $             WORK, NCYCLE, INFO )
*
*     Sort the singular values and store the pivot indices in IWORK
*     Copy ALPHA to WORK, then sort ALPHA in WORK
*
      CALL DCOPY( N, ALPHA, 1, WORK, 1 )
      IBND = MIN( L, M-K )
      DO 20 I = 1, IBND
*
*        Scan for largest ALPHA(K+I)
*
         ISUB = I
         SMAX = WORK( K+I )
         DO 10 J = I + 1, IBND
            TEMP = WORK( K+J )
            IF( TEMP.GT.SMAX ) THEN
               ISUB = J
               SMAX = TEMP
            END IF
   10    CONTINUE
         IF( ISUB.NE.I ) THEN
            WORK( K+ISUB ) = WORK( K+I )
            WORK( K+I ) = SMAX
            IWORK( K+I ) = K + ISUB
         ELSE
            IWORK( K+I ) = K + I
         END IF
   20 CONTINUE
*
      RETURN
*
*     End of DGGSVD
*
      END

c -----------------------------------
      INTEGER FUNCTION greg2juli (yyyy,mm,dd) 
      implicit none
      integer  yyyy,mm,dd

c NCL: julian_day = greg2juld_int (yyyy,mm,dd)

c converts calendar date to Julian date
c .   cf Fliegel & Van Flandern, CACM 11(10):657, 1968

c nomenclature:
c .   yyyy   - year
c .   mm     - month [1 to 12]
c .   dd     - day   [1 to 31]

c A Julian day is defined as the number of days 
c .   since January 1, 4713 B.C. 
c A Julian day begins at noon Universal Time [UT; 12Z] 
c .   of the given date.

c Examples:
c .   integer gregjuli,  julday
c .   julday = greg2juli (1900,1,1)   ==>  julday=2415021

      greg2juli = 
     +       dd - 32075 + 1461*(yyyy + 4800 + (mm - 14)/12)/4 +  
     +       367*(mm - 2 - ((mm - 14)/12)*12)/12 -              
     +       3*((yyyy + 4900 + (mm - 14)/12)/100)/4

      return
      end
c -----------------------------------
      REAL*8 FUNCTION greg2juld (yyyy,mm,dd,hr) 
      implicit none
      integer yyyy,mm,dd,hr

c NCL: julian_day = greg2juld_double (yyyy,mm,dd,hr)

c converts calendar date to Julian date
c .   cf Fliegel & Van Flandern, CACM 11(10):657, 1968
c .   =====> minor modifications by Shea <===== 

c nomenclature:
c .   yyyy   - year
c .   mm     - month [1 to 12]
c .   dd     - day   [1 to 31]
c .   hr     - hour  [0 =< hour <= 23]

c A Julian day is defined as the number of days 
c .   since January 1, 4713 B.C. 
c A Julian day begins at noon Universal Time [UT; 12Z] 
c .   of the given date.

c Examples:
c .   real julday
c .   julday = greg2juld (1900,1,1,0)    ==>  julday=2415020.5
c .   julday = greg2juld (1900,1,1,3)    ==>  julday=2415020.625
c .   julday = greg2juld (1900,1,1,6)    ==>  julday=2415020.75 
c .   julday = greg2juld (1900,1,1,12)   ==>  julday=2415021.
c .   julday = greg2juld (1900,1,1,15)   ==>  julday=2415021.125
c .   julday = greg2juld (1900,1,1,18)   ==>  julday=2415021.25

      integer juld ! local  (julian day)

      juld = dd - 32075 + 1461*(yyyy + 4800 + (mm - 14)/12)/4 +  
     +       367*(mm - 2 - ((mm - 14)/12)*12)/12 -              
     +       3*((yyyy + 4900 + (mm - 14)/12)/100)/4

      greg2juld = dble(juld)  + dble(hr-12)/dble(24.)

      return
      end
c -------------------------------------------
      SUBROUTINE juld2greg (juld,yyyy,mm,dd,hr)
      implicit none

c NCL: itime = juld2greg_int (juld) where itime(4)

      REAL*8  juld            ! input
      INTEGER yyyy,mm,dd,hr   ! output
      INTEGER jd, k,n         ! local

c expands a Julian date into a calendar date
c cf Fliegel & Van Flandern, CACM 11(10):657, 1968
c .   =====> minor modifications by Shea <===== 

c A Julian day is defined as the number of days 
c .   since January 1, 4713 B.C. 
c A Julian day begins at noon Universal Time [UT; 12Z] 
c .   of the given date.

c Examples:
c .   call juld2greg (2415020.5 ,yyyy,mm,dd,hr) ==> 1900,1,1,0
c .   call juld2greg (2415020.75,yyyy,mm,dd,hr) ==> 1900,1,1,6
c .   call juld2greg (2415021.  ,yyyy,mm,dd,hr) ==> 1900,1,1,12
c .   call juld2greg (2415021.25,yyyy,mm,dd,hr) ==> 1900,1,1,18
 
      jd = int(juld+0.5)                   ! shea

      k  = jd + 68569
      n  = 4*k/146097
      k  = k - (146097*n + 3)/4
      yyyy = 4000*(k + 1)/1461001
      k  = k - 1461*yyyy/4 + 31
      mm = 80*k/2447
      dd = k - 2447*mm/80
      k  = mm/11
      mm = mm + 2 - 12*k
      yyyy = 100*(n - 49) + yyyy + k

      hr = nint(24.*sngl((juld-dble(jd))) + 12.)      ! shea

      return
      end
c -------------------------------------------
      SUBROUTINE juli2greg (juld,yyyy,mm,dd)
      implicit none

c NCL: itime = juld2greg_int (juli) where itime(3)

      INTEGER juld            ! input
      INTEGER yyyy,mm,dd      ! output
      INTEGER jd, k,n         ! local

c expands a Julian date into a calendar date
c cf Fliegel & Van Flandern, CACM 11(10):657, 1968
c .   =====> minor modifications by Shea <===== 

c A Julian day is defined as the number of days 
c .   since January 1, 4713 B.C. 
c A Julian day begins at noon Universal Time [UT; 12Z] 
c .   of the given date.

c Examples:
c .   call juli2greg (2415021,nyear,nmo,ndy,nhr) ==> 1900,1,1,12
     
      jd = juld 
      k  = jd + 68569
      n  = 4*k/146097
      k  = k - (146097*n + 3)/4
      yyyy = 4000*(k + 1)/1461001
      k  = k - 1461*yyyy/4 + 31
      mm = 80*k/2447
      dd = k - 2447*mm/80
      k  = mm/11
      mm = mm + 2 - 12*k
      yyyy = 100*(n - 49) + yyyy + k

      return
      end

C
C $Id: slogap.f,v 1.5 2008-07-27 00:17:26 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE SLOGAP (TIME,MTST)
C
C Provide a TIME-second gap in the movie (or, if MTST is non-zero, a
C test frame representing such a gap).
C
C The common block SLCOMN holds all of the internal parameters of
C the package STITLE except for color-table parameters.
C
        COMMON /SLCOMN/ GPSZ,IBGC,IBGF,ICOP,IDOT,IFGC,IFGF,IJMP,IMAP,
     +                  INCU,IWLU,IWRK,IWWI,IXND,IXST,OORV,PCSZ,RNFS,
     +                  RVPB,RVPL,RVPR,RVPT,TFIN,TFOU,TGP1,TGP2,TGP3
        SAVE   /SLCOMN/
C
C Define a character variable in which messages may be formed.
C
        CHARACTER*42 CMSG
C
C Check for an uncleared prior error.
C
        IF (ICFELL('SLOGAP - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C NFRM is the number of blank frames required for a TIME-second gap.
C
        NFRM=INT(RNFS*TIME+.5)
C
C There's nothing to do if a non-positive number of frames is specified.
C
        IF (NFRM.LE.0) RETURN
C
C Set the background and the default foreground colors as defined by
C STITLE's color table.  (This really has an effect only when FTITLE
C puts out an initial gap: it ensures that the gap will be similar
C to the gaps that are generated after calling STITLE.)
C
        CALL SLGCLR (IBGC,BRED,BGRN,BBLU)
        IF (ICFELL('SLOGAP',2).NE.0) RETURN
        CALL GSCR   (IWRK,IBGC,BRED,BGRN,BBLU)
C
        CALL SLGCLR (IFGC,FRED,FGRN,FBLU)
        IF (ICFELL('SLOGAP',3).NE.0) RETURN
        CALL GSCR   (IWRK,IFGC,FRED,FGRN,FBLU)
C
C Output depends on whether this is a real run or a practice run.
C
        IF (MTST.EQ.0) THEN
C
C Real run - output NFRM blank frames.
C
          DO 101 IFRM=1,NFRM
            CALL SLFRME
            IF (ICFELL('SLOGAP',4).NE.0) RETURN
  101     CONTINUE
C
        ELSE
C
C Practice run - output a single frame saying how many blank frames it
C stands for, making sure to use the default foreground color.  Again,
C the code to ensure the latter is necessary only during a call by
C FTITLE to put out an initial gap.
C
          CALL GQTXCI (IERR,ISTX)
          IF (IERR.NE.0) THEN
            CMSG(1:34)='SLOGAP - ERROR RETURN FROM GQTXCI:'
            WRITE (CMSG(35:42),'(I8)') IERR
            CALL SETER (CMSG(1:42),5,1)
            RETURN
          END IF
          CALL GSTXCI (IFGC)

          WRITE (CMSG,'(I3)') NFRM
          CMSG(4:16)=' BLANK FRAMES'
          CALL WTSTR (.5,.5,CMSG(1:16),2,0,0)
          IF (ICFELL('SLOGAP',6).NE.0) RETURN
          CALL SLFRME
          IF (ICFELL('SLOGAP',7).NE.0) RETURN
C
          CALL GSTXCI (ISTX)
C
        END IF
C
C Done.
C
        RETURN
C
      END

C
C	$Id: sbytes.f,v 1.4 2008-07-27 12:23:45 haley Exp $
C                                                                      
C			     Copyright (C)  2000
C	     University Corporation for Atmospheric Research
C			     All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C

      SUBROUTINE SBYTES (NPACK,ISAM,IBIT,NBITS,NSKIP,ITER)
C
C     This subroutine packs bits from the input array ISAM to the
C     output array NPACK.  After skipping "IBIT" bits in NPACK,
C     the "NBITS" rightmost bits from "ITER" successive words
C     in "ISAM" are packed into "NPACK" with "NSKIP" bits between each
C     moved block.
C
C
C     NPACK
C       Address of the first word of the array to be packed.
C
C     ISAM
C       Array to be packed into NPACK.  The right-most NBITS
C       bits of each word will be packed.  ISAM should be
C       dimensioned for at least ITER.
C
C     IBIT
C       A bit-count offset to be used before the first bits are
C       packed into NPACK.  For example, if IBIT=3 and NBITS=5,
C       3 bits in NPACK will be skipped before the right-most
C       5 bits of ISAM(1) are packed into it.
C
C     NBITS
C       The number of bits in each word of ISAM to be unpacked.
C       NBITS must not exceed the word size on the given machine.
C
C     NSKIP
C       The number of bits to skip in NPACK between packing each
C       bit chunk from ISAM.
C
C     ITER
C       The number of bit chunks to be packed.
C
C
C Example:
C
C     CALL SBYTES(NPC,ISB,45,6,3,2)
C
C In this call, 45 bits would be skipped at the beginning of NPC;
C the right-most 6 bits of ISB(1) would be packed into NPC; 3 bits
C would be skipped in NPC; the right-most 6 bits of ISB(2) would
C be packed into NPC.
C
C
      IMPLICIT INTEGER (A-Z)
      DIMENSION ISAM(*),NPACK(*),MASK(64)
      SAVE NCALL,BPERI,MASK
      DATA NCALL/0/
C
C     Do initialization which needs to be done only on the
C     first call to SBYTES.
C
      IF (NCALL .EQ. 0) THEN
C
C       Get number of bits in an integer
C
        BPERI = I1MACH(5)
C
C       Set up masks
C
        MASK(1) = 1
        DO 10 I=2,BPERI
        MASK(I) = IOR(ISHIFT(MASK(I-1),1),1)
   10   CONTINUE
        NCALL = 1
      ENDIF
C
C     Check if NBITS is valid
C
      IF (NBITS.LE.BPERI .AND. NBITS.GT.0) GO TO 20
      WRITE(6,*)  'SBYTES--NBITS OUT OF RANGE'
      STOP
   20 CONTINUE
C
C     Define bit mask to be used for the words in ISAM
C
      MSK1 = MASK(NBITS)
C
C     Define bit mask to be used for bits in NPACK
C
      IF (BPERI .EQ. NBITS) THEN
        MSK2 = 0
      ELSE
        MSK2 = MASK(BPERI-NBITS)
      ENDIF
C
C     Calculate the total number of bits in the output array
C     used by each move from words in the input array
C
      BITSEP = NBITS+NSKIP
C
C     Loop through the input array
C
      DO 30 I=1,ITER
C
C     Get bits to be moved from ISAM
C
      SBITS = IAND(MSK1,ISAM(I))
C
C     Calculate the bit position in the output array where
C     the bits from the input word are to go
C
      BPO = IBIT+(I-1)*BITSEP
C
C     Calculate the word position in the output array where
C     the bits from the input word are to go
C
      WPO = BPO/BPERI+1
C
C     Calculate the number of bits in the current output word
C     which still remain to be filled
C
      RBITS = BPERI*WPO-BPO
C
C     Calculate the number of bits in the current output word
C     which have already been filled
C
      UBITS = BPERI-RBITS
C
C     Treat the case where there are enough bits in the current
C     output word to receive the bits from the input word
C
      IF (RBITS .LT. NBITS) GO TO 40
C
C     Calculate the number of bits to left shift SBITS
C
      LSHIFT = BPERI-UBITS-NBITS
C
C     Fill the output word
C
      NPACK(WPO) = IAND(NPACK(WPO),ISHIFT(MSK2,LSHIFT+NBITS))
      NPACK(WPO) = IOR(NPACK(WPO),ISHIFT(SBITS,LSHIFT))
      GO TO 50
C
C     Treat the case where the moved bits cross a word boundary
C     in the output buffer
C
   40 CONTINUE
      RSHIFT = RBITS-NBITS
      BTMP = ISHIFT(SBITS,RSHIFT)
      NPACK(WPO) = IAND(NPACK(WPO),ISHIFT(MASK(UBITS),RBITS))
      NPACK(WPO) = IOR(NPACK(WPO),BTMP)
      BTMP = ISHIFT(IAND(MASK(-RSHIFT),SBITS),BPERI+RSHIFT)
      NPACK(WPO+1) = IAND(NPACK(WPO+1),MASK(BPERI+RSHIFT))
      NPACK(WPO+1) = IOR(NPACK(WPO+1),BTMP)
   50 CONTINUE
   30 CONTINUE
      RETURN
      END

C
C       $Id: shsetup.f,v 1.4 2008-07-27 03:10:14 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE SHSETUP (XK,YK,ZK,FK,XI,YI,ZI,FI,S1,S2,
     +                   R, ROW)
      REAL XK, YK, ZK, FK, XI, YI, ZI, FI, S1, S2,
     +     R, ROW(10)
C
C***********************************************************
C
C                                               ROBERT RENKA
C                                       UNIV. OF NORTH TEXAS
C                                             (817) 565-2767
C
C  This routine sets up the I-th row of an augmented re-
C  gression matrix for a weighted least-squares fit of a
C  quadratic function Q(X,Y,Z) to a set of data values F,
C  where Q(XK,YK,ZK) = FK.  The first 6 columns (quadratic
C  terms) are scaled by 1/S2, and columns 7, 8, and 9 (linear
C  terms) are scaled by 1/S1.  The weight is (R-D)/(R*D) if
C  R .GT. D, and 0 if R .LE. D, where D is the distance between
C  nodes I and K.
C
C  ON INPUT --
C
C    XK,YK,ZK,FK = Coordinates and data value at node K
C                  (interpolated by Q).
C
C    XI,YI,ZI,FI = Coordinates and data value at node I.
C
C    S1,S2 = Reciprocals of the scale factors.
C
C    R = Radius of influence about node K defining the weight.
C
C    ROW = Array of length 10.
C
C  Input parameters are not altered by this routine.
C
C  ON OUTPUT --
C
C    ROW = Array containing a row of the augmented regression matrix.
C
C  MODULES REQUIRED BY SHSETUP -- NONE
C
C  INTRINSIC FUNCTION CALLED BY SHSETUP -- SQRT
C
C***********************************************************
C
      INTEGER I
      REAL    DX, DY, DZ, DXSQ, DYSQ, DZSQ, D, W, W1, W2
C
C  Local parameters -
C
C  I =    DO-LOOP INDEX
C  DX =   XI - XK
C  DY =   YI - YK
C  DZ =   ZI - ZK
C  DXSQ = DX*DX
C  DYSQ = DY*DY
C  DZSQ = DZ*DZ
C  D =    distance between nodes K and I
C  W =    weight associated with the row
C  W1 =   W/S1
C  W2 =   W/S2
C
      DX = XI - XK
      DY = YI - YK
      DZ = ZI - ZK
      DXSQ = DX*DX
      DYSQ = DY*DY
      DZSQ = DZ*DZ
      D = SQRT(DXSQ + DYSQ + DZSQ)
      IF (D .LE. 0.  .OR.  D .GE. R) GO TO 1
      W = (R-D)/R/D
      W1 = W/S1
      W2 = W/S2
      ROW(1) = DXSQ*W2
      ROW(2) = DX*DY*W2
      ROW(3) = DYSQ*W2
      ROW(4) = DX*DZ*W2
      ROW(5) = DY*DZ*W2
      ROW(6) = DZSQ*W2
      ROW(7) = DX*W1
      ROW(8) = DY*W1
      ROW(9) = DZ*W1
      ROW(10) = (FI - FK)*W
      RETURN
C
C  Nodes K and I coincide or node I is outside of the radiuS
C  of influence.  Set ROW to the zero vector.
C
    1 DO 2 I = 1,10
    2   ROW(I) = 0.
      RETURN
      END

C
C       $Id: quick.f,v 1.5 2008-07-27 00:23:01 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE QUICK (Z,L,M,N,NL,CL)
      SAVE
C
C QUICK CONTOURS Z
C
      DIMENSION       Z(L,N)     ,CL(NL)
C
      COMMON /CONRE1/ IOFFP      ,SPVAL
C
C     FX(X,Y) = X
C     FY(X,Y) = Y
C
      C(P1,P2,B) = B+(P1-CV)/(P1-P2)
C
      IDUB = 0
      JUMP = 2
      IF (IOFFP .NE. 0) JUMP = 1
      DO 128 JP1=2,N
         J = JP1-1
         Y1 = J
         Y2 = JP1
         DO 127 IP1=2,M
            I = IP1-1
            X1 = I
            X2 = IP1
            H1 = Z(I,J)
            H2 = Z(I,JP1)
            H3 = Z(IP1,JP1)
            H4 = Z(IP1,J)
            GO TO (101,102) , JUMP
  101       IF (H1.EQ.SPVAL .OR. H2.EQ.SPVAL .OR. H3.EQ.SPVAL .OR.
     1          H4.EQ.SPVAL) GO TO 127
  102       DO 126 K=1,NL
               CV = CL(K)
C
C FIND WHAT SITUATION FOR THIS CV IN THIS CELL
C
               IF (H1-CV) 103,110,110
  103          IF (H2-CV) 104,106,106
  104          IF (H3-CV) 105,107,107
  105          IF (H4-CV) 127,127,117
  106          IF (H3-CV) 108,109,109
  107          IF (H4-CV) 118,119,119
  108          IF (H4-CV) 120,121,121
  109          IF (H4-CV) 122,123,123
  110          IF (H2-CV) 111,113,113
  111          IF (H3-CV) 112,114,114
  112          IF (H4-CV) 123,122,122
  113          IF (H3-CV) 115,116,116
  114          IF (H4-CV) 124,120,120
  115          IF (H4-CV) 119,118,118
  116          IF (H4-CV) 117,126,126
C
C INTERPOLATE LINE SEGMENT ENDPOINTS
C
  117          XA = C(H1,H4,X1)
               YB = C(H4,H3,Y1)
               XB = X2
               YA = Y1
               GO TO 125
  118          XA = C(H2,H3,X1)
               YB = C(H4,H3,Y1)
               XB = X2
               YA = Y2
               GO TO 125
  119          XA = C(H1,H4,X1)
               XB = C(H2,H3,X1)
               YA = Y1
               YB = Y2
               GO TO 125
  120          XB = C(H2,H3,X1)
               YA = C(H1,H2,Y1)
               XA = X1
               YB = Y2
               IDUB = 0
               GO TO 125
  121          IDUB = 1
               GO TO 117
  122          YA = C(H1,H2,Y1)
               YB = C(H4,H3,Y1)
               XA = X1
               XB = X2
               GO TO 125
  123          XB = C(H1,H4,X1)
               YA = C(H1,H2,Y1)
               XA = X1
               YB = Y1
               IDUB = 0
               GO TO 125
  124          IDUB = -1
               GO TO 118
  125          XX1 = FX(XA,YA)
               YY1 = FY(XA,YA)
               XX2 = FX(XB,YB)
               YY2 = FY(XB,YB)
C
C DRAW LINE SEGMENT
C
               CALL LINED ( XX1, YY1, XX2, YY2 )
               IF (IDUB) 123,126,120
  126       CONTINUE
  127    CONTINUE
  128 CONTINUE
C
C
      RETURN
      END

C NCLFORTSTART
      subroutine cfftfdriver (nmx,xr,xi,acoef,bcoef,work,nw)
      implicit none
c                                      ! INPUT       
      integer  nmx,nw
      double precision xr(nmx),xi(nmx),work(nw)
c                                      ! OUTPUT       
      double precision acoef(nmx), bcoef(nmx) 
c NCLEND
c
c NCL:  coef = cfftf( xr, xi, opt)     ! coef(2,...)
c                                      ! LOCAL        
      integer  n
c     double precision work(4*nmx+25)  
      double complex   carr(nmx)       

      call cffti(nmx,work)               
c                                      ! create complex input
      do n=1,nmx
         carr(n) = cmplx( xr(n), xi(n) )     
      end do

      call cfftf(nmx, carr, work)

      do n=1,nmx
         acoef(n) = dble ( carr(n) ) 
         bcoef(n) = dimag( carr(n) )
      end do

      return
      end

C NCLFORTSTART
      subroutine cfftbdriver (nmx,xr,xi,acoef,bcoef,work,nw)
      implicit none
c                                      ! INPUT       
      integer  nmx,nw
      double precision acoef(nmx), bcoef(nmx), work(nw)
c                                      ! OUTPUT       
      double precision xr(nmx), xi(nmx)
c NCLEND
c
c NCL:  coef = cfftb( acoef, bcoef, opt )
c                                      ! LOCAL        
      integer  n
c      double precision work(4*nmx+25)
      double complex   carr(nmx)       

      call cffti(nmx,work)               
c                                      ! create complex input
      do n=1,nmx
         carr(n) = cmplx( acoef(n), bcoef(n))     
      end do

      call cfftb(nmx, carr, work)
c                                      ! reconstruct ... normalize 
      do n=1,nmx
         xr(n) = dble ( carr(n) ) / nmx
         xi(n) = dimag( carr(n) ) / nmx
      end do

      return
      end

C NCLFORTSTART
      subroutine frqcfft (npts,frq)
      implicit none
c
c SPECIAL to generate frequencies for frq attribute: cfftf
c .   Need to allow for a back transform so no order change
c                                                  ! input
      integer npts
c                                                  ! output
      double precision frq(npts)
C NCLEND
c                                                  ! local
      integer n
      double precision df
c                                      frequency interval
      df  =  1.0d0/npts
c                                      generate frequencies
      do n=1,npts
         frq(n) = (n-1)*df
         if (frq(n).gt.0.5d0) frq(n) = frq(n) - 1.0d0
      end do

      return
      end

C NCLFORTSTART
      subroutine cfftffrqreorder (npts,frqi,cfai,cfbi,frqo,cfao,cfbo)
      implicit none
c
c SPECIAL to reorder frequencies to range from -0.5 to +0.5
c .   Generally, for graphics reasons only. 
c                                                  ! input
      integer npts
      double precision frqi(npts), cfai(npts), cfbi(npts) 
c                                                  ! output
      double precision frqo(npts), cfao(npts), cfbo(npts)
C NCLEND
c
c NCL: cf_reorder = cfftf_frq_reorder( cf )
c                                                  ! local
      integer n, n2

      n2  = npts/2
c                             for clarity use two differnt sections
      if (mod(npts,2).eq.0) then
c                                                  ! even         
          do n=1,n2
             frqo(n) = frqi(n+n2)
             cfao(n) = cfai(n+n2)
             cfbo(n) = cfbi(n+n2)
          end do

          if (frqo(1).gt.0.0d0) frqo(1) = -frqo(1) 
    
          do n=1,n2
             frqo(n2+n) = frqi(n)
             cfao(n2+n) = cfai(n)
             cfbo(n2+n) = cfbi(n)
          end do
      else
c                                                  ! odd          
          do n=1,n2
             frqo(n)    = frqi(n+n2+1)
             cfao(n)    = cfai(n+n2+1)
             cfbo(n)    = cfbi(n+n2+1)
          end do

          do n=1,n2+1
             frqo(n2+n) = frqi(n)
             cfao(n2+n) = cfai(n)
             cfbo(n2+n) = cfbi(n)
          end do
      end if

      return
      end

      SUBROUTINE PASSB3(IDO,L1,CC,CH,WA1,WA2)
      DOUBLE PRECISION CC
      DOUBLE PRECISION CH
      DOUBLE PRECISION WA1
      DOUBLE PRECISION WA2
      DOUBLE PRECISION TAUR
      DOUBLE PRECISION TAUI
      DOUBLE PRECISION TR2
      DOUBLE PRECISION CR2
      DOUBLE PRECISION TI2
      DOUBLE PRECISION CI2
      DOUBLE PRECISION CR3
      DOUBLE PRECISION CI3
      DOUBLE PRECISION DR2
      DOUBLE PRECISION DR3
      DOUBLE PRECISION DI2
      DOUBLE PRECISION DI3
      DIMENSION CC(IDO,3,L1),CH(IDO,L1,3),WA1(*),WA2(*)
      DATA TAUR,TAUI/-.5D0,.866025403784439D0/

      IF (IDO.NE.2) GO TO 102
      DO 101 K = 1,L1
          TR2 = CC(1,2,K) + CC(1,3,K)
          CR2 = CC(1,1,K) + TAUR*TR2
          CH(1,K,1) = CC(1,1,K) + TR2
          TI2 = CC(2,2,K) + CC(2,3,K)
          CI2 = CC(2,1,K) + TAUR*TI2
          CH(2,K,1) = CC(2,1,K) + TI2
          CR3 = TAUI* (CC(1,2,K)-CC(1,3,K))
          CI3 = TAUI* (CC(2,2,K)-CC(2,3,K))
          CH(1,K,2) = CR2 - CI3
          CH(1,K,3) = CR2 + CI3
          CH(2,K,2) = CI2 + CR3
          CH(2,K,3) = CI2 - CR3
  101 CONTINUE
      RETURN
  102 DO 104 K = 1,L1
          DO 103 I = 2,IDO,2
              TR2 = CC(I-1,2,K) + CC(I-1,3,K)
              CR2 = CC(I-1,1,K) + TAUR*TR2
              CH(I-1,K,1) = CC(I-1,1,K) + TR2
              TI2 = CC(I,2,K) + CC(I,3,K)
              CI2 = CC(I,1,K) + TAUR*TI2
              CH(I,K,1) = CC(I,1,K) + TI2
              CR3 = TAUI* (CC(I-1,2,K)-CC(I-1,3,K))
              CI3 = TAUI* (CC(I,2,K)-CC(I,3,K))
              DR2 = CR2 - CI3
              DR3 = CR2 + CI3
              DI2 = CI2 + CR3
              DI3 = CI2 - CR3
              CH(I,K,2) = WA1(I-1)*DI2 + WA1(I)*DR2
              CH(I-1,K,2) = WA1(I-1)*DR2 - WA1(I)*DI2
              CH(I,K,3) = WA2(I-1)*DI3 + WA2(I)*DR3
              CH(I-1,K,3) = WA2(I-1)*DR3 - WA2(I)*DI3
  103     CONTINUE
  104 CONTINUE
      RETURN
      END

C
C	$Id: gqwkca.f,v 1.10 2009-04-08 23:18:21 fred Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GQWKCA(WTYPE,ERRIND,WKCAT)
C
C  INQUIRE WORKSTATION CATEGORY
C
      include 'gkscom.h'
C
      INTEGER WTYPE,ERRIND,WKCAT
C
C  Check if GKS is in the proper state.
C
      CALL GZCKST(8,-1,ERRIND)
      IF (ERRIND .NE. 0) GOTO 100
C
C  Check that the workstation type is valid.
C
      CALL GZCKWK(22,-1,IDUM,WTYPE,ERRIND)
      IF (ERRIND .NE. 0) GO TO 100
C
C  Provide the requested information.
C
      IF (WTYPE .EQ. GWSS) THEN
        WKCAT = GWISS
      ELSE IF (WTYPE.EQ.GCGM) THEN
        WKCAT = GMO
      ELSE IF (WTYPE.GE.GPSMIN .AND. WTYPE.LE.GPSMAX) THEN
        WKCAT = GMO
      ELSE IF (WTYPE.GE.GCROMIN .AND. WTYPE.LE.GCROMAX) THEN
        WKCAT = GMO
      ELSE IF (WTYPE.EQ.GPDFP .OR. WTYPE.EQ.GPDFL) THEN
        WKCAT = GMO
      ELSE IF (WTYPE.EQ.GXWC .OR. WTYPE.EQ.GXWE) THEN       
        WKCAT = GOUTIN
      ELSE IF (WTYPE .EQ. GDMP) THEN
        WKCAT = GOUTPT
      ELSE IF (WTYPE .EQ. GPIX) THEN
        WKCAT = GOUTIN
      ELSE
        WKCAT = -1
      ENDIF
      RETURN
C
  100 CONTINUE
      WKCAT = -1
      RETURN
      END

      PROGRAM CMPOU
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Open GKS, Turn Clipping off
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Invoke demo driver
C
      CALL TCMPOU
C
C Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS

      STOP
      END

      SUBROUTINE TCMPOU 

      REAL PLIM1(2), PLIM2(2), PLIM3(2), PLIM4(2)

      DATA PLIM1 /30.,0./
      DATA PLIM2 /-15.,0./
      DATA PLIM3 /60.,0./
      DATA PLIM4 /30.,0./
C
C CMPOU demonstrates political boundaries in the Maps utility.
C
C Set up Maps.
C
      CALL MAPSTC ('OU - OUTLINE DATASET SELECTOR','PO')
      CALL MAPROJ ('ME',0.,0.,0.)
      CALL MAPSET ('CO',PLIM1,PLIM2,PLIM3,PLIM4)
C
C Initialize Maps.
C
      CALL MAPINT
C
C Draw a perimeter and outline all the countries.
C
      CALL MAPSTI('LA - LABEL FLAG',0)
      CALL MAPLBL
      CALL MAPLOT
C
C Advance the frame.
C
      CALL FRAME
C
C Done.
C
      RETURN
      END

C NCLFORTSTART
      SUBROUTINE ZROTEOF (NV,NF,V,ND, EVAL, ROTPCV, ROTVAR, VMSG, IOPT,
     +                    KFLAG)
      IMPLICIT NONE
      INTEGER  NV,NF,ND, IOPT, KFLAG
      DOUBLE PRECISION V(ND,NF),EVAL(NF),ROTPCV(NF),ROTVAR(NF), VMSG
C NCLEND
      INTEGER N,M
      DOUBLE PRECISION A(NV),B(NV),C(NV), TVAR

      TVAR = EVAL(1)/(ROTPCV(1)*0.01d0)
c     PRINT *, "TVAR=",TVAR

C check for missing values: Use appropriate subroutine
      KFLAG = 0
      DO N=1,NF
        DO M=1,ND
           IF (V(M,N).EQ.VMSG) THEN
               KFLAG = 1
               GO TO 100
           END IF
        END DO
      END DO
  100 CONTINUE

      IF (IOPT.NE.0) THEN
C Scale the input eigenvector matrix
          DO N=1,NF
            DO M=1,ND
               IF (V(M,N).NE.VMSG) THEN
                   V(M,N) = V(M,N)*DSQRT( EVAL(N) )
               END IF
            END DO
          END DO
      END IF

      DO M=1,NV
         A(M) = VMSG
         B(M) = VMSG
         C(M) = VMSG
      END DO

      IF (KFLAG.EQ.0) THEN
          CALL ZVORS(NV,NF,V,A,B,C,ND) 
      ELSE
          CALL VORSMSG(NV,NF,V,A,B,C,ND,VMSG) 
      END IF  

      DO N=1,NF
        ROTVAR(N) = 0.0D0
        DO M=1,ND
           IF (V(M,N).NE.VMSG) THEN
              ROTVAR(N) = ROTVAR(N) + V(M,N)**2
           END IF
        END DO
      END DO
      
C % variance explained

      IF (IOPT.NE.0) THEN
          DO N=1,NF
            ROTPCV(N) = (ROTVAR(N)/TVAR)*100D0
          END DO
      ELSE 
          DO N=1,NF
            ROTPCV(N) = 100.D0/ND
          END DO
      END IF
      
      IF (IOPT.LE.0) RETURN

C unscale [denormalize]

      DO N=1,NF
        DO M=1,ND
           IF (V(M,N).NE.VMSG) THEN
               V(M,N) = V(M,N)/DSQRT( ROTVAR(N) )
           END IF
        END DO
      END DO


      RETURN
      END
c ------------------------------------
      SUBROUTINE ZVORS(NV,NF,V,A,B,C,ND)
      IMPLICIT NONE
      INTEGER NV,NF,ND
      DOUBLE PRECISION V(ND,NF),A(NV),B(NV),C(NV)

      INTEGER I,J,KR,M,N
      DOUBLE PRECISION T,PI,TWOPI,REPS,AA,BB,CC,DD,XN,XD,Y,CY,SY,TEMP

      DOUBLE PRECISION DSUMFR,DSCPFR
      DOUBLE PRECISION VC, VCL, X1, X2, X3

c +++ very old fortran 66 ++++ used arithmetic "if"
c         I have made some minor changes made

c note: changed names SCPF=>DSCPFR and   SUMF=>DSUMFR
c       to minimize possible name conflicts with other funtions/subroutines
c
c ***** This gives the same answers as IMSL's FROTA *****
c *****      with w=1.0, norm=1, maxit=30           *****
c
c nv    - # of variables [rows]
c nf    - # of factors   [columns]
c v     - matrix to be rotated
c a     - % variation of rotated factors
c b     - communalities of variables [%]
c c     - work vector
c nd    - lead dimension [# rows] of v in the main program
c
c Orthogonal Rotation according to varimax  criteria.
c Kaiser row normalization is used prior to rotation.
c ie: On input, each row is normalized by dividing each row
c     by the square root of the sum of its squared elements.
c     Before returning each row is denormalized.

c Each possible pair of factor vectors [principal components]
c    is rotated to maximize the column-variance criterion
c    in turn until a complete pass through all combinations
c    does not result in any rotations of more than "reps" radians.
c The percentages of trace are recomputed for each factor vector
c    and returned in vector "a" (actually, the first "nfac" 
c    elements of "a").
c The percentages of trace are computed for each row of the
c    rotated matrix and returned in vector "b". When  computed
c    as proportions (row sums of squares of the loading matrix)
c    they are called "communalities" and are not affected by the
c    rotation process. This will be exactly 100% only when all
c    the variance of the particular variable is completely
c    accounted for by the extracted factors.
c
c D.J. Veldman
c Fortran Programming for the Behavioral Sciences
c Holt, Rinehart, Winston, 1967
c pp 214-215


C      write(*,*) NF,ND,NV


      T = NV
      PI = 4.D0*ATAN(1.D0)
      TWOPI = 2.D0*PI
C epsilon (radians)=1 deg
c c c reps = pi/180.
C this matches IMSL
      REPS = 0.0001D0

C normalize the rows of v
      DO I = 1,NV
          B(I) = SQRT(DSUMFR(V, (-I), (-NF),ND))
          DO J = 1,NF
              V(I,J) = V(I,J)/B(I)
          END DO
      END DO
      
      
      
      X1 = 0
      X3 = 0
      
      DO J = 1, NF
         X2 = 0
         DO I = 1, ND
            X1 = X1 + V(I,J)**4
            X2 = X2 + V(I,J)**2
         END DO         
         X3 = X3 + X2**2
      END DO
      
      VC = X1 - X3 / ND
      

   10 CONTINUE
      
      DO WHILE(.true.)
      
      VCL = VC
      
      DO M = 1,NF
          DO N = M,NF
              IF (M.NE.N) THEN
C compute angle of rotation
                  DO I = 1,NV
                      A(I) = V(I,M)*V(I,M) - V(I,N)*V(I,N)
                      C(I) = 2.0D0*V(I,M)*V(I,N)
                  END DO

                  AA = DSUMFR(A,1,NV,ND)
                  BB = DSUMFR(C,1,NV,ND)
                  CC = DSUMFR(A,1, (-NV),ND) - DSUMFR(C,1, (-NV),ND)
                  DD = DSCPFR(A,C,1,1,NV,ND)*2.0D0
                  XN = DD - 2.0D0*AA*BB/T
c compute angle of rotation
                  XD = CC - (AA*AA-BB*BB)/T

                  Y = ATAN(XN/XD)
                  IF (XD.LT.0.D0) THEN
                      IF (XN.GE.0.D0) Y = Y + TWOPI
                      Y = Y - PI
                  END IF
                  Y = Y/4.0D0

c count rotations
                  CY = COS(Y)
                  SY = SIN(Y)
c rotate the axis
                  DO I = 1,NV
                      TEMP = V(I,M)*CY + V(I,N)*SY
                      V(I,N) = V(I,N)*CY - V(I,M)*SY
                      V(I,M) = TEMP
                  END DO
              END IF
          END DO
      END DO
     
      X1 = 0
      X3 = 0
      
      DO J = 1, NF
         X2 = 0
         DO I = 1, ND
            X1 = X1 + V(I,J)**4
            X2 = X2 + V(I,J)**2
         END DO         
         X3 = X3 + X2**2
      END DO
      
      VC = X1 - X3 / ND      
      
      
      IF(ABS(VC-VCL) .lt. 1E-5) EXIT      
      
      END DO
      
c denormailize rows of v
      DO J = 1,NF
          DO I = 1,NV
              V(I,J) = V(I,J)*B(I)
          END DO
c % variation: note the A is dimensioned A(NV)
c              but the % variation is in A(NF) [a subset of A]
          A(J) = (DSUMFR(V,J, (-NV),ND)/T)*100.D0
      END DO

      DO I = 1,NV
C % communitalities
          B(I) = B(I)*B(I)*100.D0
      END DO

      RETURN
      END

C
C $Id: agkurv.f,v 1.9 2008-07-27 00:14:34 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE AGKURV (XVEC,IIEX,YVEC,IIEY,NEXY,SVAL)
C
      DIMENSION XVEC(1),YVEC(1)
C
C AGKURV plots the curve defined by the points ((X(I),Y(I)),I=1,NEXY),
C where
C
C    X(I)=XVEC(1+(I-1)*IIEX) (unless IIEX=0, in which case X(I)=I), and
C    Y(I)=YVEC(1+(I-1)*IIEY) (unless IIEY=0, in which case Y(I)=I).
C
C If, for some I, X(I)=SVAL or Y(I)=SVAL, curve line segments having
C (X(I),Y(I)) as an endpoint are omitted.
C
C No windowing is performed.
C
C Check first whether the number of curve points is properly specified.
C
      IF (NEXY.LE.0) GO TO 901
C
C Initialization.  Pretend that the last point was point number zero.
C Set the indices for the x and y vectors accordingly.  Clear the line-
C drawn-to-last-point flag.
C
      INDP=0
      INDX=1-IIEX
      INDY=1-IIEY
      LDLP=0
C
C Initialization.  Retrieve the current curve window, user window, and
C x/y linear/logarithmic flags.
C
      CALL GETSET (XLCW,XRCW,YBCW,YTCW,XLUW,XRUW,YBUW,YTUW,LTYP)
C
C Initialization.  Set linear/log flag and linear-window limits for
C x-axis values.
C
      IF (LTYP.EQ.1.OR.LTYP.EQ.2) THEN
        LLUX=0
        XLLW=XLUW
        XRLW=XRUW
      ELSE
        LLUX=1
        XLLW=ALOG10(XLUW)
        XRLW=ALOG10(XRUW)
      END IF
C
C Initialization.  Set linear/log flag and linear-window limits for
C y-axis values.
C
      IF (LTYP.EQ.1.OR.LTYP.EQ.3) THEN
        LLUY=0
        YBLW=YBUW
        YTLW=YTUW
      ELSE
        LLUY=1
        YBLW=ALOG10(YBUW)
        YTLW=ALOG10(YTUW)
      END IF
C
C Initialization.  Call SET, if necessary, to define a linear mapping.
C
      IF (LTYP.NE.1) THEN
        CALL PLOTIT (0,0,2)
        CALL SET (XLCW,XRCW,YBCW,YTCW,XLLW,XRLW,YBLW,YTLW,1)
      END IF
C
C Beginning of loop through points.  Update indices and determine the
C user-space coordinates of the next point.
C
  101 IF (INDP.EQ.NEXY) GO TO 102
      INDP=INDP+1
C
      INDX=INDX+IIEX
      XNXT=XVEC(INDX)
      IF (IIEX.EQ.0) XNXT=REAL(INDP)
      IF (LLUX.NE.0.AND.XNXT.LE.0.) XNXT=SVAL
C
      INDY=INDY+IIEY
      YNXT=YVEC(INDY)
      IF (IIEY.EQ.0) YNXT=REAL(INDP)
      IF (LLUY.NE.0.AND.YNXT.LE.0.) YNXT=SVAL
C
C Check whether (XNXT,YNXT) is a special-value point.  Handle that case.
C
      IF (XNXT.EQ.SVAL.OR.YNXT.EQ.SVAL) THEN
        IF (LDLP.EQ.0) GO TO 101
        IF (LDLP.EQ.1) CALL VECTD (XLST,YLST)
        CALL LASTD
        LDLP=0
        GO TO 101
      END IF
C
C If user space is not linear/linear, modify XNXT and YNXT accordingly.
C
      IF (LLUX.NE.0) XNXT=ALOG10(XNXT)
      IF (LLUY.NE.0) YNXT=ALOG10(YNXT)
C
C Start or continue line.
C
      IF (LDLP.EQ.0) THEN
        CALL FRSTD (XNXT,YNXT)
        XLST=XNXT
        YLST=YNXT
      ELSE
        CALL VECTD (XNXT,YNXT)
      END IF
C
      LDLP=LDLP+1
      GO TO 101
C
C Last point was final point.  Finish up.
C
  102 IF (LDLP.NE.0) THEN
        IF (LDLP.EQ.1) CALL VECTD (XLST,YLST)
        CALL LASTD
      END IF
C
C Restore logarithmic mapping, if appropriate.
C
      IF (LTYP.NE.1) THEN
        CALL PLOTIT (0,0,2)
        CALL SET (XLCW,XRCW,YBCW,YTCW,XLUW,XRUW,YBUW,YTUW,LTYP)
      END IF
C
C Return to caller.
C
      RETURN
C
C Error exit.
C
  901 CALL SETER ('AGKURV - NUMBER OF POINTS IS LESS THAN OR EQUAL TO ZE
     +RO',3,2)
C
      END

C
C	$Id: wmgtln.f,v 1.4 2008-07-27 00:17:36 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      INTEGER FUNCTION WMGTLN(LAB,LABLEN,ILR)
C
C  Given a character variable LAB of length LABLEN, calculate
C  the character position in LAB that marks the final non-blank
C  if ILR=0, and marks the first non-blank if ILR=1.
C  
      CHARACTER*(*) LAB
C
      IF (ILR .EQ. 0) THEN
        DO 10 I=LABLEN,1,-1
          IF (LAB(I:I) .NE. ' ') THEN
            WMGTLN = I
            RETURN
          ENDIF
   10   CONTINUE
        WMGTLN = 1
        RETURN
      ELSE 
        DO 20 I=1,LABLEN
          IF (LAB(I:I) .NE. ' ') THEN
            WMGTLN = I
            RETURN
          ENDIF
   20   CONTINUE
        WMGTLN = LABLEN
        RETURN
      ENDIF
C
      END

C
C	$Id: gqopsg.f,v 1.5 2008-07-27 00:20:59 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GQOPSG(ERRIND,SGNA)
C
C  INQUIRE NAME OF OPEN SEGMENT
C
      include 'gkscom.h'
C
      INTEGER ERRIND,SGNA
      ERRIND = 0
C
      IF (OPS .EQ. GSGOP) THEN
        SGNA = CURSEG
      ELSE
        ERRIND = 4
      ENDIF
C
      RETURN
      END

C NCLFORTSTART
      SUBROUTINE SPCTIMCROSS1 (NL,NM,NT,X,Y,STC
     +                        ,NLP1,NTP1,NT2P1)
C INPUT
      INTEGER  NL, NM, NT
      DOUBLE PRECISION X(NL,NM,NT), Y(NL,NM,NT)
C OUTPUT
      DOUBLE PRECISION STC(NLP1,NT2P1,16)
C NCLEND
C NCL:    stc = spaceTimeCrossSegment(X,Y,NT,opt)

C                        ; DIMSENSION SIZES
      NLP1   = NL+1
      NTP1   = NT+1
      NT2M1  = NT/2-1
      NT2P1  = NT/2+1
      LSAVE1 = 4*NL+15
      LSAVE2 = 4*NT+15

      CALL SPCTIMCROSS2 (NL,NM,NT,X,Y,STC
     +                  ,NLP1,NTP1,NT2M1,NT2P1,LSAVE1,LSAVE2)

      RETURN
      END
c --------------------------------------
      SUBROUTINE SPCTIMCROSS2 (NL,NM,NT,X,Y,STC 
     +                        ,NLP1,NTP1,NT2M1,NT2P1,LSAVE1,LSAVE2)
      IMPLICIT NONE
      INTEGER  NL, NM, NT, NLP1,NTP1,NT2M1,NT2P1,LSAVE1,LSAVE2, TSTRT
C INPUT
      DOUBLE PRECISION X(NL,NM,NT), Y(NL,NM,NT)
C RETURN
      DOUBLE PRECISION STC(NLP1,NT2P1,16)
 
c OUTPUT VARIABLES THAT WILL BE PLACED INTO "STC"
      DOUBLE PRECISION  PEE1SUM_SYM(NLP1,NT2P1), PEE2SUM_SYM(NLP1,NT2P1)
      DOUBLE PRECISION  PEE1SUM_ASY(NLP1,NT2P1), PEE2SUM_ASY(NLP1,NT2P1)
      DOUBLE PRECISION  P12SUM_SYM (NLP1,NT2P1), Q12SUM_SYM(NLP1,NT2P1)
      DOUBLE PRECISION  P12SUM_ASY(NLP1,NT2P1) , Q12SUM_ASY(NLP1,NT2P1)
      DOUBLE PRECISION  COH2_SYM(NLP1,NT2P1)   , PHAS_SYM(NLP1,NT2P1)
      DOUBLE PRECISION  COH2_ASY(NLP1,NT2P1)   , PHAS_ASY(NLP1,NT2P1)
      DOUBLE PRECISION  V1_SYM(NLP1,NT2P1)     , V2_SYM(NLP1,NT2P1)
      DOUBLE PRECISION  V1_ASY(NLP1,NT2P1)     , V2_ASY(NLP1,NT2P1)
 
c LOCAL VARIABLES ASSOCIATED WITH THE INTERNAL PROCESSING 
      DOUBLE PRECISION  WSAVE1(LSAVE1), WSAVE2(LSAVE2)
      DOUBLE PRECISION  FRQ(NT2P1)
      DOUBLE COMPLEX    EE1(NL,NT), EEO1(NL,NT)
      DOUBLE COMPLEX    EE2(NL,NT), EEO2(NL,NT)
      DOUBLE COMPLEX    CEEA(NL)  , CEEB(NT)

c djs DOUBLE PRECISION FF(NTP1), SS(NLP1)
c
      INTEGER  IP, M , J, TT, N, T, PN, PT, PP

c------------------------MAIN PROGRAM--------------------------------
c EE(n,t) = the initial (real) data set that later becomes the
c         (complex) space-time spectrum
c ss() and ff() are arrays of wavenumbers and frequencies
c         (cycles per day) corresponding to PEE( )
 
      IF (MOD(NT,2).NE.0) THEN
         WRITE (6, *) 'NT must be event way: NT=',NT
         STOP 
      ELSE IF (MOD(NL,2).NE.0) THEN
         WRITE (6, *) 'NL must be even: NL=', NL
         STOP 
      ENDIF
 
c frequency and spatial wave number
c djs: needed for GrADS binary: do in NCL
 
c djs DO T = 1, NT + 1
c djs    FF(T) = DBLE(T - 1 - NT/2)/DBLE(NT)
c djs END DO
c djs DO N = 1, NL + 1
c djs    SS(N) = DBLE(N - 1 - NL/2)
c djs END DO
 
c Initialize SUM arrays
c djs: This had an error (memory bounds) *DO T=1,NT+1*

      DO T = 1, NT/2 + 1
         DO N = 1, NL + 1
            PEE1SUM_SYM(N,T) = 0.D0
            PEE2SUM_SYM(N,T) = 0.D0
            P12SUM_SYM(N,T)  = 0.D0
            Q12SUM_SYM(N,T)  = 0.D0
 
            PEE1SUM_ASY(N,T) = 0.D0
            PEE2SUM_ASY(N,T) = 0.D0
            P12SUM_ASY(N,T)  = 0.D0
            Q12SUM_ASY(N,T)  = 0.D0
         END DO
      END DO

c djs added ... explicitly initialize
      do n=1,nt/2+1
         frq(n) = 0.d0
      end do
C***************HERE IS THE BIG LOOP**********************************
c djs: Just pass in one time segment at a time at the NCL level.
c djs: accumulate and average in NCL     
C***************HERE IS THE BIG LOOP**********************************

      pp = 1

      DO IP = 1, PP
c read binary
c djs     DO T = 1,NT
c djs         READ (11,REC= (IP-1)*NT+T) ((X(N,M,T),N=1,NL),M=1,NM)
c djs         READ (12,REC= (IP-1)*NT+T) ((Y(N,M,T),N=1,NL),M=1,NM)
c djs     END DO
 
c Do a loop in latitude (M)!! - average
         DO M = 1, NM
            DO T = 1, NT
               DO N = 1, NL
                  EE1(N,T) = X(N,M,T)
                  EE2(N,T) = Y(N,M,T)
               END DO
            END DO
 
c Initialize FFTs
c djs: this should be moved outside loop but keep during debug
            CALL CFFTI (NL, WSAVE1)
            CALL CFFTI (NT, WSAVE2)
 
c--------------------------------------------------------------------
c---------------COMPUTING SPACE-TIME SPECTRUM for EE1----------------
 
            DO T = 1, NT
               DO N = 1, NL
c CEEa(n) contains the grid values around a latitude circle
                  CEEA(N) = EE1(N,T)
               END DO
               CALL CFFTF (NL, CEEA, WSAVE1)
               DO N = 1, NL
c Normalize
                  EE1(N,T) = CEEA(N)/DBLE(NL)
               END DO
            END DO
 
c Now the array EE(n,t) contains the Fourier coefficients (in planetary
c wavenumber space) for each time.
 
            DO N = 1, NL
               DO T = 1, NT
c CEEb(t) contains a time-series of the coefficients for a single
c planetary zonal wavenumber
                  CEEB(T) = EE1(N,T)
               END DO
               CALL CFFTF (NT, CEEB, WSAVE2)
               DO T = 1, NT
C Normalize
                  EE1(N,T) = CEEB(T)/DBLE(NT)
               END DO
            END DO
 
c Now the array EE1(n,t) contains the space-time spectrum.
 
c--------------------------------------------------------------------
c---------------COMPUTING SPACE-TIME SPECTRUM for EE2----------------
 
            DO T = 1, NT
               DO N = 1, NL
c CEEa(n) contains the grid values around a latitude circle
                  CEEA(N) = EE2(N,T)
               END DO
               CALL CFFTF (NL, CEEA, WSAVE1)
               DO N = 1, NL
                  EE2(N,T) = CEEA(N)/DBLE(NL)
               END DO
            END DO
 
c Now the array EE(n,t) contains the Fourier coefficients (in planetary
c wavenumber space) for each time.
 
            DO N = 1, NL
               DO T = 1, NT
c CEEb(t) contains a time-series of the coefficients for a single
c planetary zonal wavenumber
                  CEEB(T) = EE2(N,T)
               END DO
               CALL CFFTF (NT, CEEB, WSAVE2)
               DO T = 1, NT
                  EE2(N,T) = CEEB(T)/DBLE(NT)
               END DO
            END DO
 
c Now the array EE2(n,t) contains the space-time spectrum.
 
c-------------------------------------------------------------------
 
c Create array PEE(NL+1,NT+1) which contains the (real) power spectrum.
c In this array, the negative wavenumbers will be from pn=1 to NL/2;
c The positive wavenumbers will be for pn=NL/2+2 to NL+1.
c Negative frequencies will be from pt=1 to NT/2.
c Positive frequencies will be from pt=NT/2+2 to NT+1.
c Information about zonal mean will be for pn=NL/2+1.
c Information about time mean will be for pt=NT/2+1.
c Information about the Nyquist Frequency is at pt=1 and pt=NT+1
c In PEE, I define the WESTWARD waves to be either +ve frequency
c and -ve wavenumber or -ve freq and +ve wavenumber.
c EASTWARD waves are either +ve freq and +ve wavenumber OR -ve
c freq and -ve wavenumber.
 
c original one
c     do 191 pt=1,NT+1
c      do 189 pn=1,NL+1
c       if(pn.le.NL/2) then
c        n=NL/2+2-pn
c        if(pt.le.NT/2) then
c         t=NT/2+pt
c        else
c         t=pt-NT/2
c        endif
c       elseif(pn.ge.NL/2+1) then
c        n=pn-NL/2
c        if (pt.le.NT/2+1) then
c         t=NT/2+2-pt
c        else
c         t=NT+NT/2+2-pt
c        endif
c       endif
 
            DO PT = 1, NT/2 + 1
               DO PN = 1, NL + 1
 
                  IF (PN .LE. NL/2) THEN
                     N = NL/2 + 2 - PN
                     T = PT
                  ELSE IF (PN .EQ. NL/2+1) THEN
                     N = 1
                     T = PT
                  ELSE IF (PN .GE. NL/2+2) THEN
                     N = PN - NL/2
                     IF (PT .EQ. 1) THEN
                        T = PT
                     ELSE
                        T = NT + 2 - PT
                     ENDIF
                  ENDIF
 
                  IF (M.GE.1 .AND. M.LE.NM/2+1) THEN
 
                     PEE1SUM_SYM(PN,PT) = PEE1SUM_SYM(PN,PT) 
     +                      + CDABS(EE1(N,T))**2/DBLE(PP*(NM/2+1))
                     PEE2SUM_SYM(PN,PT) = PEE2SUM_SYM(PN,PT) 
     +                      + CDABS(EE2(N,T))**2/DBLE(PP*(NM/2+1))
 
                     P12SUM_SYM(PN,PT) = P12SUM_SYM(PN,PT) 
     +           + DBLE(DCONJG(EE1(N,T))*EE2(N,T))/DBLE(PP*(NM/2+1))
                     Q12SUM_SYM(PN,PT) = Q12SUM_SYM(PN,PT) 
     +  + DBLE((0.D0,1.D0)*DCONJG(EE1(N,T))*EE2(N,T))/DBLE(PP*(NM/2+1))
 
                  ELSE
 
                     PEE1SUM_ASY(PN,PT) = PEE1SUM_ASY(PN,PT) 
     +                      + CDABS(EE1(N,T))**2/DBLE(PP*(NM/2))
                     PEE2SUM_ASY(PN,PT) = PEE2SUM_ASY(PN,PT) 
     +                      + CDABS(EE2(N,T))**2/DBLE(PP*(NM/2))
 
                     P12SUM_ASY(PN,PT) = P12SUM_ASY(PN,PT) 
     +           + DBLE(DCONJG(EE1(N,T))*EE2(N,T))/DBLE(PP*(NM/2))
                     Q12SUM_ASY(PN,PT) = Q12SUM_ASY(PN,PT) 
     +  + DBLE((0.D0,1.D0)*DCONJG(EE1(N,T))*EE2(N,T))/DBLE(PP*(NM/2))
 
                  ENDIF
 
               END DO
            END DO
 
 
c     do pt=1,NT+1
c     do pn=1,NL+1
c      Coh2(pn,pt)=(P12sum(pn,pt)**2+Q12sum(pn,pt)**2)/
c    #                        (PEE1sum(pn,pt)*PEE2sum(pn,pt))
c      Phas(pn,pt)=ATAN(Q12sum(pn,pt)/P12sum(pn,pt))
c     enddo
c     enddo
c                          END of NM [LON] loop
         END DO
c                          END of IP loop
      END DO
c***************END BIG LOOP HERE*****************************

      DO T = 1, NT/2 + 1
         DO N = 1, NL + 1
            STC(N,T,1)  = PEE1SUM_SYM(N,T) 
            STC(N,T,2)  = PEE1SUM_ASY(N,T) 
            STC(N,T,3)  = PEE2SUM_SYM(N,T) 
            STC(N,T,4)  = PEE2SUM_ASY(N,T) 
            STC(N,T,5)  = P12SUM_SYM(N,T)  
            STC(N,T,6)  = P12SUM_ASY(N,T)  
            STC(N,T,7)  = Q12SUM_SYM(N,T)  
            STC(N,T,8)  = Q12SUM_ASY(N,T)  
         END DO
      END DO
 
c ********* APPLY SMOOTHING TO THE SPECTRUM ************************
c Apply smoothing to PEE1,PEE2,P12, and Q12
c then calculate Coh2 and Phase.

      CALL SPCTIMCROSS3 (NL,NT,STC,NLP1,NTP1,NT2P1)

      RETURN
      END 
c --------------------------------------
C NCLFORTSTART
      SUBROUTINE SPCTIMCROSS3 (NL,NT,STC,NLP1,NTP1,NT2P1)  
      IMPLICIT NONE
      INTEGER  NL, NT, NLP1,NTP1,NT2P1
C INPUT (1 thru 8) and OUTPUT (9 to 16)
      DOUBLE PRECISION STC(NLP1,NT2P1,16)
C NCLEND

C NCL:  
      
c TEMPORARY VARIABLES THAT WILL BE PLACED EXTRACTED FROM "STC"
      DOUBLE PRECISION  PEE1SUM_SYM(NLP1,NT2P1), PEE2SUM_SYM(NLP1,NT2P1)
      DOUBLE PRECISION  PEE1SUM_ASY(NLP1,NT2P1), PEE2SUM_ASY(NLP1,NT2P1)
      DOUBLE PRECISION  P12SUM_SYM (NLP1,NT2P1), Q12SUM_SYM(NLP1,NT2P1)
      DOUBLE PRECISION  P12SUM_ASY(NLP1,NT2P1) , Q12SUM_ASY(NLP1,NT2P1)

c LOCAL VARIABLES THAT WILL BE PLACED INTO "STC"
      DOUBLE PRECISION  COH2_SYM(NLP1,NT2P1)   , PHAS_SYM(NLP1,NT2P1)
      DOUBLE PRECISION  COH2_ASY(NLP1,NT2P1)   , PHAS_ASY(NLP1,NT2P1)
      DOUBLE PRECISION  V1_SYM(NLP1,NT2P1)     , V2_SYM(NLP1,NT2P1)
      DOUBLE PRECISION  V1_ASY(NLP1,NT2P1)     , V2_ASY(NLP1,NT2P1)

      DOUBLE PRECISION  FRQ(NT2P1)
      INTEGER  TSTRT, N, T
      
      DO T = 1, NT/2 + 1
         DO N = 1, NL + 1
            PEE1SUM_SYM(N,T) = STC(N,T,1) 
            PEE1SUM_ASY(N,T) = STC(N,T,2)
            PEE2SUM_SYM(N,T) = STC(N,T,3) 
            PEE2SUM_ASY(N,T) = STC(N,T,4) 
            P12SUM_SYM(N,T)  = STC(N,T,5)  
            P12SUM_ASY(N,T)  = STC(N,T,6)  
            Q12SUM_SYM(N,T)  = STC(N,T,7)  
            Q12SUM_ASY(N,T)  = STC(N,T,8)  
         END DO
      END DO

c Smoothing in frq only
c djs not sure smoothing was not put into a subroutine
c djs not sure why the 4 offset TSTRT=4
c     Several arguments were changed
      TSTRT = 1
      DO N = 1, NL + 1
         DO T = TSTRT, NT/2 + 1
            FRQ(T-TSTRT+1) = PEE1SUM_SYM(N,T)
         END DO
         CALL SMTH121STCP (FRQ, NT/2 + 1, NT/2 + 1)
         DO T = TSTRT, NT/2 + 1
            PEE1SUM_SYM(N,T) = FRQ(T-TSTRT+1)
         END DO
      END DO
 
      DO N = 1, NL + 1
         DO T = TSTRT, NT/2 + 1
            FRQ(T-TSTRT+1) = PEE2SUM_SYM(N,T)
         END DO
         CALL SMTH121STCP (FRQ, NT/2 + 1, NT/2 + 1)
         DO T = TSTRT, NT/2 + 1
            PEE2SUM_SYM(N,T) = FRQ(T-TSTRT+1)
         END DO
      END DO
 
      DO N = 1, NL + 1
         DO T = TSTRT, NT/2 + 1
            FRQ(T-TSTRT+1) = P12SUM_SYM(N,T)
         END DO
         CALL SMTH121STCP (FRQ, NT/2 + 1, NT/2 + 1)
         DO T = TSTRT, NT/2 + 1
            P12SUM_SYM(N,T) = FRQ(T-TSTRT+1)
         END DO
      END DO
 
      DO N = 1, NL + 1
         DO T = TSTRT, NT/2 + 1
            FRQ(T-TSTRT+1) = Q12SUM_SYM(N,T)
         END DO
         CALL SMTH121STCP (FRQ, NT/2 + 1, NT/2 + 1)
         DO T = TSTRT, NT/2 + 1
            Q12SUM_SYM(N,T) = FRQ(T-TSTRT+1)
         END DO
      END DO
 
c asymmetric
      DO N = 1, NL + 1
         DO T = TSTRT, NT/2 + 1
            FRQ(T-TSTRT+1) = PEE1SUM_ASY(N,T)
         END DO
         CALL SMTH121STCP (FRQ, NT/2 + 1, NT/2 + 1)
         DO T = TSTRT, NT/2 + 1
            PEE1SUM_ASY(N,T) = FRQ(T-TSTRT+1)
         END DO
      END DO
 
      DO N = 1, NL + 1
         DO T = TSTRT, NT/2 + 1
            FRQ(T-TSTRT+1) = PEE2SUM_ASY(N,T)
         END DO
         CALL SMTH121STCP (FRQ, NT/2 + 1, NT/2 + 1)
         DO T = TSTRT, NT/2 + 1
            PEE2SUM_ASY(N,T) = FRQ(T-TSTRT+1)
         END DO
      END DO
 
      DO N = 1, NL + 1
         DO T = TSTRT, NT/2 + 1
            FRQ(T-TSTRT+1) = P12SUM_ASY(N,T)
         END DO
         CALL SMTH121STCP (FRQ, NT/2 + 1, NT/2 + 1)
         DO T = TSTRT, NT/2 + 1
            P12SUM_ASY(N,T) = FRQ(T-TSTRT+1)
         END DO
      END DO
 
      DO N = 1, NL + 1
         DO T = TSTRT, NT/2 + 1
            FRQ(T-TSTRT+1) = Q12SUM_ASY(N,T)
         END DO
         CALL SMTH121STCP (FRQ, NT/2 + 1, NT/2 + 1)
         DO T = TSTRT, NT/2 + 1
            Q12SUM_ASY(N,T) = FRQ(T-TSTRT+1)
         END DO
      END DO
 
c Calculate the Coherence-squared statistic and the phase.
      DO T = 1, NT/2 + 1
         DO N = 1, NL + 1
c       if (PEE1sum_sym(n,t).ne.dmiss) then
            COH2_SYM(N,T) = (P12SUM_SYM(N,T)**2+Q12SUM_SYM(N,T)**2)
     +                    / (PEE1SUM_SYM(N,T)*PEE2SUM_SYM(N,T))
            PHAS_SYM(N,T) = ATAN(Q12SUM_SYM(N,T)/P12SUM_SYM(N,T))

            IF (N .LE. NL/2+1) THEN
               V1_SYM(N,T) = Q12SUM_SYM(N,T)/SQRT(Q12SUM_SYM(N,T)**2
     +                     + P12SUM_SYM(N,T)**2)
            ELSE
               V1_SYM(N,T) = -1.D0*Q12SUM_SYM(N,T)
     +                     / SQRT(Q12SUM_SYM(N,T)**2+P12SUM_SYM(N,T)**2)
               Q12SUM_SYM(N,T) = -1.D0*Q12SUM_SYM(N,T)
            ENDIF
            V2_SYM(N,T) = P12SUM_SYM(N,T)/SQRT(Q12SUM_SYM(N,T)**2
     +                  + P12SUM_SYM(N,T)**2)
c       else
c        Coh2_sym(n,t)=dmiss
c        Phas_sym(n,t)=dmiss
c       endif
 
            IF (COH2_SYM(N,T) .LT. 0.05D0) THEN
               V1_SYM(N,T) = 0.0D0
               V2_SYM(N,T) = 0.0D0
            ENDIF
         END DO
      END DO
 
      DO T = 1, NT/2 + 1
         DO N = 1, NL + 1
c       if (PEE1sum_asy(n,t).ne.dmiss) then
            COH2_ASY(N,T) = (P12SUM_ASY(N,T)**2+Q12SUM_ASY(N,T)**2)
     +                     /(PEE1SUM_ASY(N,T)*PEE2SUM_ASY(N,T))
            PHAS_ASY(N,T) = ATAN(Q12SUM_ASY(N,T)/P12SUM_ASY(N,T))

            IF (N .LE. NL/2+1) THEN
               V1_ASY(N,T) = Q12SUM_ASY(N,T)/SQRT(Q12SUM_ASY(N,T)**2
     +                      +P12SUM_ASY(N,T)**2)
            ELSE
               V1_ASY(N,T) = -1.D0*Q12SUM_ASY(N,T)/SQRT(Q12SUM_ASY(N,T) 
     +                        **2+P12SUM_ASY(N,T)**2)
               Q12SUM_ASY(N,T) = -1.D0*Q12SUM_ASY(N,T)
            ENDIF
            V2_ASY(N,T) = P12SUM_ASY(N,T)/SQRT(Q12SUM_ASY(N,T)**2
     +                   +P12SUM_ASY(N,T)**2)

            IF (COH2_ASY(N,T) .LT. 0.05D0) THEN
               V1_ASY(N,T) = 0.0D0
               V2_ASY(N,T) = 0.0D0
            ENDIF
         END DO
      END DO
      
      DO T = 1, NT/2 + 1
         DO N = 1, NL + 1
            STC(N,T, 9)   = COH2_SYM(N,T)  
            STC(N,T,10)   = COH2_ASY(N,T)  
            STC(N,T,11)   = PHAS_SYM(N,T)  
            STC(N,T,12)   = PHAS_ASY(N,T)  
            STC(N,T,13)   = V1_SYM(N,T)  
            STC(N,T,14)   = V1_ASY(N,T)  
            STC(N,T,15)   = V2_SYM(N,T)  
            STC(N,T,16)   = V2_ASY(N,T)  
         END DO
      END DO

      RETURN
      END 
c--------------------------------------------------------
      SUBROUTINE SMTH121STCP(VV, VN, NN)
c SpaceTimeCoherence2Phase (STCP)
c Smooths vv by passing it through a 1-2-1 filter.
c The first and last points are given 3-1 (1st) or 1-3 (last)
c weightings (Note that this conserves the total sum).
c The routine also skips-over missing data (assigned to be
c a value of -999.).
c There are 'nn' pieces of useful information, which may be less
c than or equal to 'vn'.
 
      IMPLICIT NONE
      INTEGER  NN, I, VN
      DOUBLE PRECISION  SPV, VV(VN), DUM(9999)
 
      IF (NN .GT. 5000) THEN
         WRITE (6, *) 'need to increase 9999 in smooth121.f'
         STOP 
      ENDIF
 
      SPV = -999.D0
      I = 0
   10 CONTINUE
      I = I + 1
      IF (VV(I) .EQ. SPV) THEN
         DUM(I) = SPV
      ELSE IF (I.EQ.1 .OR. VV(I-1).EQ.SPV) THEN
         DUM(I) = (3.D0*VV(I)+VV(I+1))/4.D0
      ELSE IF (I.EQ.NN .OR. VV(I+1).EQ.SPV) THEN
         DUM(I) = (VV(I-1)+3.D0*VV(I))/4.D0
      ELSE
         DUM(I) = (VV(I-1)+2.D0*VV(I)+VV(I+1))/4.D0
      ENDIF
      IF (I .NE. NN) GO TO 10
 
      DO I = 1, NN
         VV(I) = DUM(I)
      END DO

      RETURN 
c djs same answers
c djs do i=2,nn-1
c djs    dum(i) = (vv(i-1)+2.d0*vv(i)+vv(i+1))/4.d0
c djs end do
c djs dum(1 ) = (3.d0*vv( 1)+vv( 2)  )/4.d0
c djs dum(nn) = (3.d0*vv(nn)+vv(nn-1))/4.d0
c djs do i=1,nn
c djs    vv(i) = dum(i)
c djs end do
      END 

C
C $Id: lbblda.f,v 1.6 2008-07-27 00:17:17 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE LBBLDA
C
C Calling this do-nothing subroutine forces "ld" to load the following
C block data routine (but only if they are in the same ".f" file).
C
        RETURN
C
      END
CNOSPLIT
      BLOCKDATA LBBLDAX
C
C This block data subroutine defines the default values of internal
C parameters for LBLBAR.
C
C Declare the common block where internal parameters are stored.
C
        COMMON /LBCOMN/ ICBL,ICFL,ICLB,WOBL,WOFL,WOLB
        SAVE   /LBCOMN/
C
C ICBL is the color index to be used for box lines.  A negative value
C implies that the color index is to be that specified by the current
C value of the GKS polyline color index.
C
        DATA ICBL / -1 /
C
C ICFL is the color index to be used for fill lines.  A negative value
C implies that the color index is to be that specified by the current
C value of the GKS polyline color index.
C
        DATA ICFL / -1 /
C
C ICLB is the color index to be used for labels.  A negative value
C implies that the color index is to be that specified by the current
C value of the GKS text color index.
C
        DATA ICLB / -1 /
C
C WOBL is the desired width of the box lines.  A value less than or
C equal to zero implies that line width is to be inherited.
C
        DATA WOBL / 0. /
C
C WOFL is the desired width of the fill lines.  A value less than or
C equal to zero implies that line width is to be inherited.
C
        DATA WOFL / 0. /
C
C WOLB is the desired width of lines to be used when plotting labels
C (which will only affect characters drawn by software).  A value less
C than or equal to zero implies that line width is to be inherited.
C
        DATA WOLB / 0. /
C
      END

C NCLFORTSTART
      SUBROUTINE P2HYO(PI,MLON,NLAT,KLEVI,XI,PSFC
     +                 ,P0,HYAO,HYBO,KLEVO,XO,XMSG
     +                 ,IFLAG,KFLAG,IER)    
      IMPLICIT NONE

c NCL: xo = p2hyo (p,xi,psfc,hyao,hybo)

c this routine interploates constant pres levels to hybrid
c     the formula for the pressure of a hybrid surface is;
c          phy(k) = pOut(k) = hya(k)*p0 + hyb(k)*psfc
c
c     input  ["i" input ... "o" output]
c          pi     - pressure level                     [input]
c          psfc   - is the surface pressure Pa         [input]
c          mlon   - longitude dimension
c          nlat   - latitude  dimension
c          klevi  - number of input  levels
c          hyao   - is the "a" or pressure hybrid coef
c          hybo   - is the "b" or sigma coeficient
c          klevo  - number of output levels
c          kflag  - specify how values outside the "pi" will be handled
c                   By "outside" I mean [pOut < pi(1)] or [pOut > pi(klevi)]
c                   Extrapolation is via log-linear extrapolation.
c                   =0   no extrapolation. Values set to _FillValue
c                   =1   values set to nearest valid value
c                   =2   values at pOut less    than pi(1) set to nearest value
c                        values at pOut greater than pi(klevi) are extrapolated 
c                   =3   values at pOut less    than pi(1) are extrapolated
c                        values at pOut greater than pi(klevi) set to nearest value 
c                   =4   values at pOut less    than pi(1) are extrapolated
c                        values at pOut greater than pi(klevi) are extrapolated
c               
c          ier    - error code  [=0 no error detected]
c                               [.ne.0 error detected: one or both
c                                      pressure arrays not top->bot order]
c     output
c          iflag  - indicates whether missing values in output
c          xo     - pressure at hybrid levels [Pa]
c                                                 ! input
      INTEGER MLON,NLAT,KLEVI,KLEVO,IFLAG,KFLAG,IER
      DOUBLE PRECISION P0,PI(KLEVI),PSFC(MLON,NLAT),XI(MLON,NLAT,KLEVI),
     +                 HYAO(KLEVO),HYBO(KLEVO),XMSG
c                                                 ! output
      DOUBLE PRECISION XO(MLON,NLAT,KLEVO)
C NCLEND
c                                                 ! local (automatic)
      DOUBLE PRECISION PO(KLEVO)

      IFLAG = 0
c                                                 ! ? input asending order     
      IER   = 0
      IF (PI(1).GT.PI(KLEVI)) THEN
          IER = 1
      END IF

      PO(1)     = HYAO(1)*P0     + HYBO(1)*PSFC(1,1)
      PO(KLEVO) = HYAO(KLEVO)*P0 + HYBO(KLEVO)*PSFC(1,1)
c                                                 ! ? output ascending order     
      IF (PO(1).GT.PO(KLEVO)) THEN
          IER = 20 + IER
      END IF

      IF (IER.NE.0) RETURN

      CALL P2HYB(PI,MLON,NLAT,KLEVI,XI,PSFC,P0,HYAO,HYBO,KLEVO,XO,PO 
     +          ,IFLAG, KFLAG, XMSG)
      RETURN
      END

C NCLFORTSTART
      SUBROUTINE P2HYB(PI,MLON,NLAT,KLEVI,XI,PSFC,P0,HYAO,HYBO,KLEVO 
     +                ,XO,PO,IFLAG, KFLAG, XMSG)
      IMPLICIT NONE
c                                                 ! input
      INTEGER MLON,NLAT,KLEVI,KLEVO,IFLAG, KFLAG
      DOUBLE PRECISION P0,HYAI(KLEVI),HYBI(KLEVI),HYAO(KLEVO),
     +                 HYBO(KLEVO),PSFC(MLON,NLAT),XI(MLON,NLAT,KLEVI),
     +                 PI(KLEVI),PO(KLEVO),XMSG
c                                                 ! output
      DOUBLE PRECISION XO(MLON,NLAT,KLEVO)
C NCLEND
c                                                 ! local
      INTEGER NL,ML,KI,KO
      DOUBLE PRECISION PIMIN, PIMAX, POMIN, POMAX, DXDP
c f77
      PIMIN = PI(1)   
      PIMAX = PI(KLEVI)

      DO NL = 1,NLAT
        DO ML = 1,MLON

          DO KO = 1,KLEVO
             PO(KO) = HYAO(KO)*P0 + HYBO(KO)*PSFC(ML,NL)
          END DO

          POMIN = PO(1)
          POMAX = PO(KLEVO)

          DO KO = 1,KLEVO
             XO(ML,NL,KO) = XMSG
            DO KI = 1,KLEVI-1
               IF (PO(KO).GE.PIMIN .AND. PO(KO).LE.PIMAX ) THEN     

                   IF (PO(KO).GE.PI(KI) .AND. PO(KO).LT.PI(KI+1)) THEN
                       XO(ML,NL,KO) = XI(ML,NL,KI) 
     +                              +(XI(ML,NL,KI+1)-XI(ML,NL,KI))*
     +                               (DLOG(PO(KO))  -DLOG(PI(KI)))/
     +                               (DLOG(PI(KI+1))-DLOG(PI(KI)))
                   END IF
               ELSE
                   IF (KFLAG.EQ.0) THEN
                       IFLAG = 1
                       GO TO 100
                   END IF

                   IF (KFLAG.EQ.1) THEN
                       IF (PO(KO).LT.PIMIN) THEN
                           XO(ML,NL,KO) = XI(ML,NL,1)
                       END IF
                       IF (PO(KO).GT.PIMAX) THEN
                           XO(ML,NL,KO) = XI(ML,NL,KLEVI)
                       END IF
                       GO TO 100
                   END IF

                   IF (KFLAG.EQ.2) THEN
                       IF (PO(KO).LT.PIMIN) THEN
                           XO(ML,NL,KO) = XI(ML,NL,1)   
                       END IF
                       IF (PO(KO).GT.PIMAX) THEN
                           DXDP = (XI(ML,NL,KLEVI)-XI(ML,NL,KLEVI-1))* 
     +                            (DLOG(PI(KLEVI))-DLOG(PI(KLEVI-1)))
                           XO(ML,NL,KO) = XI(ML,NL,KLEVI)
     +                            + (DLOG(PO(KO))-DLOG(PI(KLEVI)))*DXDP   
                       END IF
                       GO TO 100
                   END IF

                   IF (KFLAG.EQ.3) THEN
                       IF (PO(KO).LT.PIMIN) THEN
                           DXDP = (XI(ML,NL,2)-XI(ML,NL,1))* 
     +                            (DLOG(PI(2))-DLOG(PI(1)))
                           XO(ML,NL,KO) = XI(ML,NL,1)
     +                            + (DLOG(PO(KO))-DLOG(PI(1)))*DXDP   
                       END IF
                       IF (PO(KO).GT.PIMAX) THEN
                           XO(ML,NL,KO) = XI(ML,NL,KLEVI)   
                       END IF
                       GO TO 100
                   END IF

                   IF (KFLAG.EQ.4) THEN
                       IF (PO(KO).LT.PIMIN) THEN
                           DXDP = (XI(ML,NL,2)-XI(ML,NL,1))* 
     +                            (DLOG(PI(2))-DLOG(PI(1)))
                           XO(ML,NL,KO) = XI(ML,NL,1)
     +                            + (DLOG(PO(KO))-DLOG(PI(1)))*DXDP   
                       END IF
                       IF (PO(KO).GT.PIMAX) THEN
                           DXDP = (XI(ML,NL,KLEVI)-XI(ML,NL,KLEVI-1))* 
     +                            (DLOG(PI(KLEVI))-DLOG(PI(KLEVI-1)))
                           XO(ML,NL,KO) = XI(ML,NL,KLEVI)
     +                            + (DLOG(PO(KO))-DLOG(PI(KLEVI)))*DXDP   
                       END IF
c c c                  GO TO 100
                   END IF

  100              CONTINUE
               END IF
             END DO
          END DO


        END DO
      END DO

      RETURN
      END

      SUBROUTINE DLALSD( UPLO, SMLSIZ, N, NRHS, D, E, B, LDB, RCOND,
     $                   RANK, WORK, IWORK, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     October 31, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          UPLO
      INTEGER            INFO, LDB, N, NRHS, RANK, SMLSIZ
      DOUBLE PRECISION   RCOND
*     ..
*     .. Array Arguments ..
      INTEGER            IWORK( * )
      DOUBLE PRECISION   B( LDB, * ), D( * ), E( * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  DLALSD uses the singular value decomposition of A to solve the least
*  squares problem of finding X to minimize the Euclidean norm of each
*  column of A*X-B, where A is N-by-N upper bidiagonal, and X and B
*  are N-by-NRHS. The solution X overwrites B.
*
*  The singular values of A smaller than RCOND times the largest
*  singular value are treated as zero in solving the least squares
*  problem; in this case a minimum norm solution is returned.
*  The actual singular values are returned in D in ascending order.
*
*  This code makes very mild assumptions about floating point
*  arithmetic. It will work on machines with a guard digit in
*  add/subtract, or on those binary machines without guard digits
*  which subtract like the Cray XMP, Cray YMP, Cray C 90, or Cray 2.
*  It could conceivably fail on hexadecimal or decimal machines
*  without guard digits, but we know of none.
*
*  Arguments
*  =========
*
*  UPLO   (input) CHARACTER*1
*         = 'U': D and E define an upper bidiagonal matrix.
*         = 'L': D and E define a  lower bidiagonal matrix.
*
*  SMLSIZ (input) INTEGER
*         The maximum size of the subproblems at the bottom of the
*         computation tree.
*
*  N      (input) INTEGER
*         The dimension of the  bidiagonal matrix.  N >= 0.
*
*  NRHS   (input) INTEGER
*         The number of columns of B. NRHS must be at least 1.
*
*  D      (input/output) DOUBLE PRECISION array, dimension (N)
*         On entry D contains the main diagonal of the bidiagonal
*         matrix. On exit, if INFO = 0, D contains its singular values.
*
*  E      (input) DOUBLE PRECISION array, dimension (N-1)
*         Contains the super-diagonal entries of the bidiagonal matrix.
*         On exit, E has been destroyed.
*
*  B      (input/output) DOUBLE PRECISION array, dimension (LDB,NRHS)
*         On input, B contains the right hand sides of the least
*         squares problem. On output, B contains the solution X.
*
*  LDB    (input) INTEGER
*         The leading dimension of B in the calling subprogram.
*         LDB must be at least max(1,N).
*
*  RCOND  (input) DOUBLE PRECISION
*         The singular values of A less than or equal to RCOND times
*         the largest singular value are treated as zero in solving
*         the least squares problem. If RCOND is negative,
*         machine precision is used instead.
*         For example, if diag(S)*X=B were the least squares problem,
*         where diag(S) is a diagonal matrix of singular values, the
*         solution would be X(i) = B(i) / S(i) if S(i) is greater than
*         RCOND*max(S), and X(i) = 0 if S(i) is less than or equal to
*         RCOND*max(S).
*
*  RANK   (output) INTEGER
*         The number of singular values of A greater than RCOND times
*         the largest singular value.
*
*  WORK   (workspace) DOUBLE PRECISION array, dimension at least
*         (9*N + 2*N*SMLSIZ + 8*N*NLVL + N*NRHS + (SMLSIZ+1)**2),
*         where NLVL = max(0, INT(log_2 (N/(SMLSIZ+1))) + 1).
*
*  IWORK  (workspace) INTEGER array, dimension at least
*         (3*N*NLVL + 11*N)
*
*  INFO   (output) INTEGER
*         = 0:  successful exit.
*         < 0:  if INFO = -i, the i-th argument had an illegal value.
*         > 0:  The algorithm failed to compute an singular value while
*               working on the submatrix lying in rows and columns
*               INFO/(N+1) through MOD(INFO,N+1).
*
*  Further Details
*  ===============
*
*  Based on contributions by
*     Ming Gu and Ren-Cang Li, Computer Science Division, University of
*       California at Berkeley, USA
*     Osni Marques, LBNL/NERSC, USA
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO, ONE, TWO
      PARAMETER          ( ZERO = 0.0D0, ONE = 1.0D0, TWO = 2.0D0 )
*     ..
*     .. Local Scalars ..
      INTEGER            BX, BXST, C, DIFL, DIFR, GIVCOL, GIVNUM,
     $                   GIVPTR, I, ICMPQ1, ICMPQ2, IWK, J, K, NLVL,
     $                   NM1, NSIZE, NSUB, NWORK, PERM, POLES, S, SIZEI,
     $                   SMLSZP, SQRE, ST, ST1, U, VT, Z
      DOUBLE PRECISION   CS, EPS, ORGNRM, R, SN, TOL
*     ..
*     .. External Functions ..
      INTEGER            IDAMAX
      DOUBLE PRECISION   DLAMCH, DLANST
      EXTERNAL           IDAMAX, DLAMCH, DLANST
*     ..
*     .. External Subroutines ..
      EXTERNAL           DCOPY, DGEMM, DLACPY, DLALSA, DLARTG, DLASCL,
     $                   DLASDA, DLASDQ, DLASET, DLASRT, DROT, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, DBLE, INT, LOG, SIGN
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
*
      IF( N.LT.0 ) THEN
         INFO = -3
      ELSE IF( NRHS.LT.1 ) THEN
         INFO = -4
      ELSE IF( ( LDB.LT.1 ) .OR. ( LDB.LT.N ) ) THEN
         INFO = -8
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DLALSD', -INFO )
         RETURN
      END IF
*
      EPS = DLAMCH( 'Epsilon' )
*
*     Set up the tolerance.
*
      IF( ( RCOND.LE.ZERO ) .OR. ( RCOND.GE.ONE ) ) THEN
         RCOND = EPS
      END IF
*
      RANK = 0
*
*     Quick return if possible.
*
      IF( N.EQ.0 ) THEN
         RETURN
      ELSE IF( N.EQ.1 ) THEN
         IF( D( 1 ).EQ.ZERO ) THEN
            CALL DLASET( 'A', 1, NRHS, ZERO, ZERO, B, LDB )
         ELSE
            RANK = 1
            CALL DLASCL( 'G', 0, 0, D( 1 ), ONE, 1, NRHS, B, LDB, INFO )
            D( 1 ) = ABS( D( 1 ) )
         END IF
         RETURN
      END IF
*
*     Rotate the matrix if it is lower bidiagonal.
*
      IF( UPLO.EQ.'L' ) THEN
         DO 10 I = 1, N - 1
            CALL DLARTG( D( I ), E( I ), CS, SN, R )
            D( I ) = R
            E( I ) = SN*D( I+1 )
            D( I+1 ) = CS*D( I+1 )
            IF( NRHS.EQ.1 ) THEN
               CALL DROT( 1, B( I, 1 ), 1, B( I+1, 1 ), 1, CS, SN )
            ELSE
               WORK( I*2-1 ) = CS
               WORK( I*2 ) = SN
            END IF
   10    CONTINUE
         IF( NRHS.GT.1 ) THEN
            DO 30 I = 1, NRHS
               DO 20 J = 1, N - 1
                  CS = WORK( J*2-1 )
                  SN = WORK( J*2 )
                  CALL DROT( 1, B( J, I ), 1, B( J+1, I ), 1, CS, SN )
   20          CONTINUE
   30       CONTINUE
         END IF
      END IF
*
*     Scale.
*
      NM1 = N - 1
      ORGNRM = DLANST( 'M', N, D, E )
      IF( ORGNRM.EQ.ZERO ) THEN
         CALL DLASET( 'A', N, NRHS, ZERO, ZERO, B, LDB )
         RETURN
      END IF
*
      CALL DLASCL( 'G', 0, 0, ORGNRM, ONE, N, 1, D, N, INFO )
      CALL DLASCL( 'G', 0, 0, ORGNRM, ONE, NM1, 1, E, NM1, INFO )
*
*     If N is smaller than the minimum divide size SMLSIZ, then solve
*     the problem with another solver.
*
      IF( N.LE.SMLSIZ ) THEN
         NWORK = 1 + N*N
         CALL DLASET( 'A', N, N, ZERO, ONE, WORK, N )
         CALL DLASDQ( 'U', 0, N, N, 0, NRHS, D, E, WORK, N, WORK, N, B,
     $                LDB, WORK( NWORK ), INFO )
         IF( INFO.NE.0 ) THEN
            RETURN
         END IF
         TOL = RCOND*ABS( D( IDAMAX( N, D, 1 ) ) )
         DO 40 I = 1, N
            IF( D( I ).LE.TOL ) THEN
               CALL DLASET( 'A', 1, NRHS, ZERO, ZERO, B( I, 1 ), LDB )
            ELSE
               CALL DLASCL( 'G', 0, 0, D( I ), ONE, 1, NRHS, B( I, 1 ),
     $                      LDB, INFO )
               RANK = RANK + 1
            END IF
   40    CONTINUE
         CALL DGEMM( 'T', 'N', N, NRHS, N, ONE, WORK, N, B, LDB, ZERO,
     $               WORK( NWORK ), N )
         CALL DLACPY( 'A', N, NRHS, WORK( NWORK ), N, B, LDB )
*
*        Unscale.
*
         CALL DLASCL( 'G', 0, 0, ONE, ORGNRM, N, 1, D, N, INFO )
         CALL DLASRT( 'D', N, D, INFO )
         CALL DLASCL( 'G', 0, 0, ORGNRM, ONE, N, NRHS, B, LDB, INFO )
*
         RETURN
      END IF
*
*     Book-keeping and setting up some constants.
*
      NLVL = INT( LOG( DBLE( N ) / DBLE( SMLSIZ+1 ) ) / LOG( TWO ) ) + 1
*
      SMLSZP = SMLSIZ + 1
*
      U = 1
      VT = 1 + SMLSIZ*N
      DIFL = VT + SMLSZP*N
      DIFR = DIFL + NLVL*N
      Z = DIFR + NLVL*N*2
      C = Z + NLVL*N
      S = C + N
      POLES = S + N
      GIVNUM = POLES + 2*NLVL*N
      BX = GIVNUM + 2*NLVL*N
      NWORK = BX + N*NRHS
*
      SIZEI = 1 + N
      K = SIZEI + N
      GIVPTR = K + N
      PERM = GIVPTR + N
      GIVCOL = PERM + NLVL*N
      IWK = GIVCOL + NLVL*N*2
*
      ST = 1
      SQRE = 0
      ICMPQ1 = 1
      ICMPQ2 = 0
      NSUB = 0
*
      DO 50 I = 1, N
         IF( ABS( D( I ) ).LT.EPS ) THEN
            D( I ) = SIGN( EPS, D( I ) )
         END IF
   50 CONTINUE
*
      DO 60 I = 1, NM1
         IF( ( ABS( E( I ) ).LT.EPS ) .OR. ( I.EQ.NM1 ) ) THEN
            NSUB = NSUB + 1
            IWORK( NSUB ) = ST
*
*           Subproblem found. First determine its size and then
*           apply divide and conquer on it.
*
            IF( I.LT.NM1 ) THEN
*
*              A subproblem with E(I) small for I < NM1.
*
               NSIZE = I - ST + 1
               IWORK( SIZEI+NSUB-1 ) = NSIZE
            ELSE IF( ABS( E( I ) ).GE.EPS ) THEN
*
*              A subproblem with E(NM1) not too small but I = NM1.
*
               NSIZE = N - ST + 1
               IWORK( SIZEI+NSUB-1 ) = NSIZE
            ELSE
*
*              A subproblem with E(NM1) small. This implies an
*              1-by-1 subproblem at D(N), which is not solved
*              explicitly.
*
               NSIZE = I - ST + 1
               IWORK( SIZEI+NSUB-1 ) = NSIZE
               NSUB = NSUB + 1
               IWORK( NSUB ) = N
               IWORK( SIZEI+NSUB-1 ) = 1
               CALL DCOPY( NRHS, B( N, 1 ), LDB, WORK( BX+NM1 ), N )
            END IF
            ST1 = ST - 1
            IF( NSIZE.EQ.1 ) THEN
*
*              This is a 1-by-1 subproblem and is not solved
*              explicitly.
*
               CALL DCOPY( NRHS, B( ST, 1 ), LDB, WORK( BX+ST1 ), N )
            ELSE IF( NSIZE.LE.SMLSIZ ) THEN
*
*              This is a small subproblem and is solved by DLASDQ.
*
               CALL DLASET( 'A', NSIZE, NSIZE, ZERO, ONE,
     $                      WORK( VT+ST1 ), N )
               CALL DLASDQ( 'U', 0, NSIZE, NSIZE, 0, NRHS, D( ST ),
     $                      E( ST ), WORK( VT+ST1 ), N, WORK( NWORK ),
     $                      N, B( ST, 1 ), LDB, WORK( NWORK ), INFO )
               IF( INFO.NE.0 ) THEN
                  RETURN
               END IF
               CALL DLACPY( 'A', NSIZE, NRHS, B( ST, 1 ), LDB,
     $                      WORK( BX+ST1 ), N )
            ELSE
*
*              A large problem. Solve it using divide and conquer.
*
               CALL DLASDA( ICMPQ1, SMLSIZ, NSIZE, SQRE, D( ST ),
     $                      E( ST ), WORK( U+ST1 ), N, WORK( VT+ST1 ),
     $                      IWORK( K+ST1 ), WORK( DIFL+ST1 ),
     $                      WORK( DIFR+ST1 ), WORK( Z+ST1 ),
     $                      WORK( POLES+ST1 ), IWORK( GIVPTR+ST1 ),
     $                      IWORK( GIVCOL+ST1 ), N, IWORK( PERM+ST1 ),
     $                      WORK( GIVNUM+ST1 ), WORK( C+ST1 ),
     $                      WORK( S+ST1 ), WORK( NWORK ), IWORK( IWK ),
     $                      INFO )
               IF( INFO.NE.0 ) THEN
                  RETURN
               END IF
               BXST = BX + ST1
               CALL DLALSA( ICMPQ2, SMLSIZ, NSIZE, NRHS, B( ST, 1 ),
     $                      LDB, WORK( BXST ), N, WORK( U+ST1 ), N,
     $                      WORK( VT+ST1 ), IWORK( K+ST1 ),
     $                      WORK( DIFL+ST1 ), WORK( DIFR+ST1 ),
     $                      WORK( Z+ST1 ), WORK( POLES+ST1 ),
     $                      IWORK( GIVPTR+ST1 ), IWORK( GIVCOL+ST1 ), N,
     $                      IWORK( PERM+ST1 ), WORK( GIVNUM+ST1 ),
     $                      WORK( C+ST1 ), WORK( S+ST1 ), WORK( NWORK ),
     $                      IWORK( IWK ), INFO )
               IF( INFO.NE.0 ) THEN
                  RETURN
               END IF
            END IF
            ST = I + 1
         END IF
   60 CONTINUE
*
*     Apply the singular values and treat the tiny ones as zero.
*
      TOL = RCOND*ABS( D( IDAMAX( N, D, 1 ) ) )
*
      DO 70 I = 1, N
*
*        Some of the elements in D can be negative because 1-by-1
*        subproblems were not solved explicitly.
*
         IF( ABS( D( I ) ).LE.TOL ) THEN
            CALL DLASET( 'A', 1, NRHS, ZERO, ZERO, WORK( BX+I-1 ), N )
         ELSE
            RANK = RANK + 1
            CALL DLASCL( 'G', 0, 0, D( I ), ONE, 1, NRHS,
     $                   WORK( BX+I-1 ), N, INFO )
         END IF
         D( I ) = ABS( D( I ) )
   70 CONTINUE
*
*     Now apply back the right singular vectors.
*
      ICMPQ2 = 1
      DO 80 I = 1, NSUB
         ST = IWORK( I )
         ST1 = ST - 1
         NSIZE = IWORK( SIZEI+I-1 )
         BXST = BX + ST1
         IF( NSIZE.EQ.1 ) THEN
            CALL DCOPY( NRHS, WORK( BXST ), N, B( ST, 1 ), LDB )
         ELSE IF( NSIZE.LE.SMLSIZ ) THEN
            CALL DGEMM( 'T', 'N', NSIZE, NRHS, NSIZE, ONE,
     $                  WORK( VT+ST1 ), N, WORK( BXST ), N, ZERO,
     $                  B( ST, 1 ), LDB )
         ELSE
            CALL DLALSA( ICMPQ2, SMLSIZ, NSIZE, NRHS, WORK( BXST ), N,
     $                   B( ST, 1 ), LDB, WORK( U+ST1 ), N,
     $                   WORK( VT+ST1 ), IWORK( K+ST1 ),
     $                   WORK( DIFL+ST1 ), WORK( DIFR+ST1 ),
     $                   WORK( Z+ST1 ), WORK( POLES+ST1 ),
     $                   IWORK( GIVPTR+ST1 ), IWORK( GIVCOL+ST1 ), N,
     $                   IWORK( PERM+ST1 ), WORK( GIVNUM+ST1 ),
     $                   WORK( C+ST1 ), WORK( S+ST1 ), WORK( NWORK ),
     $                   IWORK( IWK ), INFO )
            IF( INFO.NE.0 ) THEN
               RETURN
            END IF
         END IF
   80 CONTINUE
*
*     Unscale and sort the singular values.
*
      CALL DLASCL( 'G', 0, 0, ONE, ORGNRM, N, 1, D, N, INFO )
      CALL DLASRT( 'D', N, D, INFO )
      CALL DLASCL( 'G', 0, 0, ORGNRM, ONE, N, NRHS, B, LDB, INFO )
*
      RETURN
*
*     End of DLALSD
*
      END

c------------------------------------------------------------------
c     Computes double covariance or correlation matrix
c------------------------------------------------------------------
C NCLFORTSTART
      subroutine dcovarxy(x,y,xmsg,ymsg,cxy,n,m,lag,ncrit,iopt)
      implicit none
c                                                      INPUT
      integer n, m, lag, ncrit, iopt
      double precision x(n,m), y(n,m), xmsg, ymsg
c                                                      OUTPUT
      double precision cxy(m,m)
C NCLEND
c                                                      LOCAL 
      integer i, j, k
      double precision sumxx, sumyy, sumxy, sumx, sumy, nxy, xvar, yvar

      do i=1,m
        do j=1,m
           cxy(i,j) = xmsg
        end do
      end do

      do i=1,m
        do j=1,m
          nxy  = 0.0d0
          sumx = 0.0d0
          sumy = 0.0d0
          sumxy= 0.0d0
          sumxx= 0.0d0
          sumyy= 0.0d0

          do k=lag+1, n
            if (x(k,i).ne.xmsg .and. y(k-lag,j).ne.ymsg) then
                nxy   = nxy + 1
                sumx  = sumx  + x(k,i)
                sumy  = sumy  + y(k-lag,j)
                sumxy = sumxy + x(k,i)*y(k-lag,j)
                sumxx = sumxx + x(k,i)*x(k,i)     
                sumyy = sumyy + y(k-lag,j)*y(k-lag,j)
            end if
          end do
          if (nxy.gt.1d0 .and. nxy.ge.ncrit) then
              cxy(i,j) = (sumxy-(sumx*sumy)/nxy)/(nxy-1d0)

              if (iopt.eq.1 .and. 
     &            sumxx.gt.0.0d0 .and. sumyy.gt.0.0d0) then
                  xvar =  (sumxx-((sumx*sumx)/(nxy)) )/(nxy-1.)
                  yvar =  (sumyy-((sumy*sumy)/(nxy)) )/(nxy-1.)
                  cxy(i,j) = cxy(i,j)/(sqrt(xvar)*sqrt(yvar)) 
              end if

          end if
        end do
      end do      

      return
      end

      PROGRAM FTEX02D
C
C  Example of CURVP1DP, CURVPIDP.
C
C  Define dimensions, declare arrays.
C
      PARAMETER (IDIM=10,IOUT=201)
      DOUBLE PRECISION X
      DOUBLE PRECISION Y
      DOUBLE PRECISION YP
      DOUBLE PRECISION TEMP
      DOUBLE PRECISION XO
      DOUBLE PRECISION YO
      DOUBLE PRECISION YI
      DOUBLE PRECISION PERIOD
      DOUBLE PRECISION SIGMA
      DOUBLE PRECISION XR
      DOUBLE PRECISION XL
      DOUBLE PRECISION XINC
      DOUBLE PRECISION CURVP2DP
      DOUBLE PRECISION CURVPIDP
      DIMENSION X(IDIM),Y(IDIM),YP(IDIM),TEMP(IDIM,2)
      DIMENSION XO(IOUT),YO(IOUT),YI(IOUT)
C
C Specify the input data.
C
      DATA X/0.000D0,0.210D0,0.360D0,0.540D0,1.000D0,1.500D0,1.970D0,
     +     2.300D0,2.500D0,2.700D0/
      DATA Y/0.000D0,2.600D0,3.000D0,2.500D0,0.000D0,-1.000D0,0.000D0,
     +     0.800D0,0.920D0,0.700D0/
C
C  Call CURVP1DP setup.
C
      PERIOD = 3.D0
      SIGMA = 1.D0
      CALL CURVP1DP(IDIM,X,Y,PERIOD,YP,TEMP,SIGMA,IERR)
C
C  Call CURVP2DP and calculate the interpolated values and the integrals.
C
      XR = 5.D0
      XL = -1.D0
      XINC = (XR-XL)/ (IOUT-1)
      DO 10 I = 1,IOUT
          XO(I) = XL + (I-1)*XINC
          YO(I) = CURVP2DP(XO(I),IDIM,X,Y,PERIOD,YP,SIGMA)
          YI(I) = CURVPIDP(0.D0,XO(I),IDIM,X,Y,PERIOD,YP,SIGMA)
   10 CONTINUE
C
C This next section plots the data. You must have a double precision
C version of NCAR Graphics in order for this section to compile and
C run correctly.  For now, it is commented out.
C
C  Draw a plot of the interpolated functions and mark the original
C  points.
C
C      CALL DRWFT2(XL,XR,IDIM,X,Y,IOUT,XO,YO,YI)
C
      STOP
      END
C      SUBROUTINE DRWFT2(XL,XR,II,X,Y,IO,XO,YO,YI)
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C      DOUBLE PRECISION XL
C      DOUBLE PRECISION XR
C      DOUBLE PRECISION X
C      DOUBLE PRECISION Y
C      DOUBLE PRECISION XO
C      DOUBLE PRECISION YO
C      DOUBLE PRECISION YI
C      DOUBLE PRECISION YPOS_TOP
C      DOUBLE PRECISION YB
C      DOUBLE PRECISION YT
C
C      DATA YPOS_TOP/0.85D0/
C
C  Open GKS, open and activate a workstation.
C
C      CALL GOPKS(IERRF,ISZDM)
C      CALL GOPWK(IWKID,LUNIT,IWTYPE)
C      CALL GACWK(IWKID)
C
C  Define a color table.
C
C      CALL GSCR(IWKID,0,1.0D0,1.0D0,1.0D0)
C      CALL GSCR(IWKID,1,0.0D0,0.0D0,0.0D0)
C      CALL GSCR(IWKID,2,1.0D0,0.0D0,0.0D0)
C      CALL GSCR(IWKID,3,0.0D0,1.0D0,0.0D0)
C      CALL GSCR(IWKID,4,0.0D0,0.0D0,1.0D0)
C      CALL GSCLIP(0)
C
C  Plot main title.
C
C      CALL PLCHHQ(0.50D0,0.95D0,':F25:Demo for CURVP1DP, CURVPIDP',
C     +            0.032D0,0.D0,0.D0)
C
C  Graph the interpolated function values and mark the original
C  input data points.
C
C      YB = -2.0D0
C      YT = 3.0D0
C      CALL BKGFT2(XL,XR,YPOS_TOP,'Function',0.42D0,YB,YT)
C      CALL GRIDAL(6,5,5,1,1,1,10,XL,YB)
C
C  Mark the original data points.
C
C      CALL GSMKSC(2.D0)
C      CALL GSPMCI(4)
C      CALL GPM(II,X,Y)
C
C  Graph the interpolated function values.
C
C      CALL GPL(IO,XO,YO)
C
C  Graph the integral.
C
C      YB = -1.0D0
C      YT = 4.0D0
C      CALL BKGFT2(XL,XR,YPOS_TOP-0.47D0,'Integral (from X = 0.)',0.2D0,
C     +            YB,YT)
C      CALL GRIDAL(6,5,5,1,1,1,10,XL,YB)
C      CALL GPL(IO,XO,YI)
C      CALL GSPLCI(1)
C
C  Indicate the period.
C
C      CALL DRWPRD(0.D0,3.D0,6.5D0)
C
C      CALL FRAME
C
C      CALL GDAWK(IWKID)
C      CALL GCLWK(IWKID)
C      CALL GCLKS
C
C      RETURN
C      END
C      SUBROUTINE BKGFT2(XL,XR,YPOS,LABEL,XLP,YB,YT)
C      DOUBLE PRECISION XL
C      DOUBLE PRECISION XR
C      DOUBLE PRECISION YPOS
C      DOUBLE PRECISION XLP
C      DOUBLE PRECISION YB
C      DOUBLE PRECISION YT
C      DOUBLE PRECISION XX
C      DOUBLE PRECISION YY
C      DIMENSION XX(2),YY(2)
C      CHARACTER*(*) LABEL
C
C      CALL SET(0.D0,1.D0,0.D0,1.D0,0.D0,1.D0,0.D0,1.D0,1)
C      CALL PCSETI('FN',21)
C      CALL PLCHHQ(XLP,YPOS-0.03D0,LABEL,0.025D0,0.D0,-1.D0)
C      CALL SET(0.13D0,0.93D0,YPOS-0.25D0,YPOS,XL,XR,YB,YT,1)
C      XX(1) = XL
C      XX(2) = XR
C      YY(1) = 0.D0
C      YY(2) = 0.D0
C      CALL GSPLCI(2)
C      CALL GPL(2,XX,YY)
C      CALL GSPLCI(1)
C
C      CALL GASETI('LTY',1)
C      CALL PCSETI('FN',21)
C      CALL GASETR('XLS',0.02D0)
C      CALL GASETC('XLF','(F4.1)')
C      CALL GASETR('YLS',0.02D0)
C      CALL GASETC('YLF','(F5.2)')
C      CALL GASETR('XMJ',0.02D0)
C      CALL GASETR('YMJ',0.02D0)
C
C      RETURN
C      END
C      SUBROUTINE DRWPRD(XL,XR,Y)
C      DOUBLE PRECISION XL
C      DOUBLE PRECISION XR
C      DOUBLE PRECISION Y
C      DOUBLE PRECISION XX
C      DOUBLE PRECISION YY
C      DOUBLE PRECISION YOFF
C      DOUBLE PRECISION XMID
C      DOUBLE PRECISION XB
C      DOUBLE PRECISION XE
C      DOUBLE PRECISION CFUX
C      DOUBLE PRECISION YI
C
C  Draws a bounding indicator for the period of the function.
C
C      DIMENSION XX(2),YY(2)
C
C      YOFF = 0.4D0
C      CALL GSPLCI(2)
C      XMID = 0.5D0* (XR-XL)
C      CALL PLCHHQ(XMID,Y,':F25:Period',0.02D0,0.D0,0.D0)
C
C  Vertical lines at the period limits.
C
C      XX(1) = XL
C      XX(2) = XL
C      YY(1) = Y + YOFF
C      YY(2) = Y - YOFF
C      CALL GPL(2,XX,YY)
C      XX(1) = XR
C      XX(2) = XR
C      CALL GPL(2,XX,YY)
C
C  Horizontal lines between label and vertical lines.
C
C      CALL PCSETI('TE',1)
C      CALL PCGETR('XB',XB)
C      CALL PCGETR('XE',XE)
C      XX(1) = XL
C      XX(2) = CFUX(XB) - 0.09D0
C      YY(1) = Y
C      YY(2) = Y
C      CALL GPL(2,XX,YY)
C
C  Left arrow.
C
C      XX(1) = XL
C      YY(1) = Y
C      YI = 0.5D0*YOFF
C      YY(2) = Y + YI
C      XX(2) = XL + YI
C      CALL GPL(2,XX,YY)
C      YY(2) = Y - YI
C      CALL GPL(2,XX,YY)
C
C      XX(1) = XR
C      XX(2) = CFUX(XE) + 0.09D0
C      YY(1) = Y
C      YY(2) = Y
C      CALL GPL(2,XX,YY)
C
C  Right arrow.
C
C      XX(1) = XR
C      YY(1) = Y
C      YY(2) = Y + YI
C      XX(2) = XR - YI
C      CALL GPL(2,XX,YY)
C      YY(2) = Y - YI
C      CALL GPL(2,XX,YY)
C
C      RETURN
C      END

      PROGRAM AGEX06
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Define the data arrays.
C
      REAL XDRA(501),YDRA(501)
C
C Define the graph-window parameter array.
C
      REAL GWND (4,4)
C
C Define variables used in setting up informational labels.
C
      CHARACTER*35 GLAB
      CHARACTER*23 BACK(4)
      CHARACTER*12 LNLG(4)
C
      DATA (GWND(I,1),I=1,4) / 0.0 , 0.5 , 0.5 , 1.0 /
      DATA (GWND(I,2),I=1,4) / 0.5 , 1.0 , 0.5 , 1.0 /
      DATA (GWND(I,3),I=1,4) / 0.0 , 0.5 , 0.0 , 0.5 /
      DATA (GWND(I,4),I=1,4) / 0.5 , 1.0 , 0.0 , 0.5 /
C
      DATA BACK(1) / '(PERIMETER BACKGROUND)$' /
      DATA BACK(2) / '(GRID BACKGROUND)$     ' /
      DATA BACK(3) / '(HALF-AXIS BACKGROUND)$' /
      DATA BACK(4) / '(NO BACKGROUND)$       ' /
C
      DATA LNLG(1) / 'LINEAR$' /
      DATA LNLG(2) / 'LOGARITHMIC$' /
C
C Initialize GKS.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Fill the data arrays.
C
      DO 101 I=1,501
        THETA=.031415926535898*REAL(I-1)
        XDRA(I)=500.+.9*REAL(I-1)*COS(THETA)
        YDRA(I)=500.+.9*REAL(I-1)*SIN(THETA)
  101 CONTINUE
C
C Suppress the frame advance.
C
      CALL AGSETI ('FRAME.',2)
C
C Do four graphs on the same frame, using different
C backgrounds.
C
      DO 102 IGRF = 1,4
C
C Position the graph window.
C
        CALL AGSETP ('GRAPH WINDOW.',GWND(1,IGRF),4)
C
C Declare the background type.
C
        CALL AGSETI ('BACKGROUND TYPE.',IGRF)
C
C Setting the background type may have turned informational
C labels off.  In that case, turn them back on.
C
        IF (IGRF.EQ.4) CALL AGSETI ('LABEL/CONTROL.',2)
C
C Set up parameters determining linear/log nature of axes.
C
        ILLX=(IGRF-1)/2
        ILLY=MOD(IGRF-1,2)
C
C Declare the linear/log nature of the graph.
C
        CALL AGSETI ('X/LOGARITHMIC.',ILLX)
        CALL AGSETI ('Y/LOGARITHMIC.',ILLY)
C
C Change the x- and y-axis labels to reflect the linear/log
C nature of the graph.
C
        CALL AGSETC ('LABEL/NAME.','B')
        CALL AGSETI ('LINE/NUMBER.',-100)
        CALL AGSETC ('LINE/TEXT.',LNLG(ILLX+1))
C
        CALL AGSETC ('LABEL/NAME.','L')
        CALL AGSETI ('LINE/NUMBER.',100)
        CALL AGSETC ('LINE/TEXT.',LNLG(ILLY+1))
C
C Set up the label for the top of the graph.
C
        WRITE (GLAB,1001) IGRF,BACK(IGRF)
C
C Draw the graph, using EZXY.
C
        CALL EZXY (XDRA,YDRA,501,GLAB)
C
  102 CONTINUE
C
C Draw a boundary around the edge of the plotter frame.
C
      CALL BNDARY
C
C Advance the frame.
C
      CALL FRAME
C
C Close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
C
C Format for encode.
C
 1001 FORMAT ('EXAMPLE 6-',I1,' ',A23)
      END
      SUBROUTINE BNDARY
C
C Routine to draw the plotter-frame edge.
C
      CALL PLOTIT (    0,    0,0)
      CALL PLOTIT (32767,    0,1)
      CALL PLOTIT (32767,32767,1)
      CALL PLOTIT (    0,32767,1)
      CALL PLOTIT (    0,    0,1)
      RETURN
      END

C NCLFORTSTART
      subroutine stuprobt (t,df,tmsg,result)
      implicit none
      double precision t,df,tmsg,result

c NCL: alpha = student_probt (t,df)
C NCLEND
      double precision dbetaislatec

      if (t.ne.tmsg .and. df.gt.0) then
          result = dbetaislatec(df/(df+t**2), df*0.5d0, 0.5d0)
      else
          result = tmsg
      end if

      return
      end

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C   FFTPACK 5.0
C   Copyright (C) 1995-2004, Scientific Computing Division,
C   University Corporation for Atmospheric Research
C   Licensed under the GNU General Public License (GPL)
C
C   Authors:  Paul N. Swarztrauber and Richard A. Valent
C
C   $Id: cfft2f.f,v 1.2 2006-11-21 01:10:16 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      SUBROUTINE DCFFT2F(LDIM,L,M,C,WSAVE,LENSAV,WORK,LENWRK,IER)
      INTEGER L,M,LDIM,LENSAV,LENWRK,IER
      DOUBLE COMPLEX C(LDIM,M)
      DOUBLE PRECISION WSAVE(LENSAV),WORK(LENWRK)
C
C Initialize error return
C
      IER = 0
C
      IF (L.GT.LDIM) THEN
          IER = 5
          CALL DXERFFT('CFFT2F',-2)
          GO TO 100
      ELSE IF (LENSAV.LT.2*L+INT(LOG(DBLE(L)))+2*M+INT(LOG(DBLE(M)))+
     +         8) THEN
          IER = 2
          CALL DXERFFT('CFFT2F',6)
          GO TO 100
      ELSE IF (LENWRK.LT.2*L*M) THEN
          IER = 3
          CALL DXERFFT('CFFT2F',8)
          GO TO 100
      END IF
C
C Transform X lines of C array
      IW = 2*L + INT(LOG(DBLE(L))*LOG(2.D0)) + 3
      CALL DCFFTMF(L,1,M,LDIM,C, (L-1)+LDIM* (M-1)+1,WSAVE(IW),
     +            2*M+INT(LOG(DBLE(M)))+4,WORK,2*L*M,IER1)
      IF (IER1.NE.0) THEN
          IER = 20
          CALL DXERFFT('CFFT2F',-5)
          GO TO 100
      END IF
C
C Transform Y lines of C array
      IW = 1
      CALL DCFFTMF(M,LDIM,L,1,C, (M-1)*LDIM+L,WSAVE(IW),
     +            2*L+INT(LOG(DBLE(L)))+4,WORK,2*M*L,IER1)
      IF (IER1.NE.0) THEN
          IER = 20
          CALL DXERFFT('CFFT2F',-5)
      END IF
C
  100 CONTINUE
      RETURN
      END

C
C $Id: ERRORF.f,v 1.1 2001-10-09 00:18:35 haley Exp $
C
C****************************************************************
C                                                               *
C                       Copyright (C)  1994                     *
C       University Corporation for Atmospheric Research         *
C                       All Rights Reserved                     *
C                                                               *
C****************************************************************
C
C      File:            ERROR.f
C
C      Author:          Jeff W. Boote
C                       National Center for Atmospheric Research
C                       PO 3000, Boulder, Colorado
C
C      Date:            Fri Apr 15 16:52:28 MDT 1994
C
C      Description:     
C

C****************************************************************
C
C       Private functions used by Error
C
C****************************************************************
C
C find out if iunit is connected - return 0 if not 1 if is
C
      subroutine nhlpfinqunit(iunit,iconn,ierr)
        integer iunit,iconn
        logical opn

        inquire(iunit,OPENED=opn,IOSTAT=ierr)
        if(ierr .EQ. 0) then
                if (opn .EQV. .TRUE.) then
                        iconn = 1
                else
                        iconn = 0
                endif
        endif
        return
      end
C
C open the given file with the given unit number
C
      subroutine nhlpfopnunit(iunit,fname,fname_len,ierr)
        integer iunit,fname_len,ierr
        character*(*) fname

        open(iunit,FILE=fname(:fname_len),IOSTAT=ierr,STATUS='UNKNOWN')
        return
      end
C
C close the given unit number
C
      subroutine nhlpfclsunit(iunit,ierr)
        integer iunit,ierr
        close(iunit,IOSTAT=ierr)
        return
      end

C
C print a message to the unit number
C

      subroutine nhlpfprnmes(iunit,ermess,ierlen)
        external i1mach
        integer iunit,ierlen,ierr
        character*(*) ermess
        
        write(iunit,*,IOSTAT=ierr) ermess(:ierlen)
        if(ierr .NE. 0) then
                write(i1mach(4),*,IOSTAT=ierr)
     %                          'Unable to print Error Messages???'
        endif
        return
      end
C
C****************************************************************
C
C       Public Functions
C
C****************************************************************
C
      subroutine nhlfperror(slevel,ienum,estring)
        character*(*) slevel,estring
        integer ienum
        call nhlpfperror(slevel,len(slevel),ienum,estring,len(estring))
        return
      end
C
C
C
      subroutine nhlferrgetid(id_ret)
        integer id_ret
        call nhlpferrgetid(id_ret)
        return
      end
C
C
C
      subroutine nhlferrnummsgs(nummsg)
        integer nummsg
        call nhlpferrnummsgs(nummsg)
        return
      end
C
C
C
      subroutine nhlferrgetmsg(imsg,ilevel,emess,enum,smess,line,file,
     %  ierr)
        integer imsg,ilevel,enum,line,ierr
        character*(*) emess,smess,file
        call nhlpferrgetmsg(imsg,ilevel,emess,len(emess),enum,smess,
     %          len(smess),line,file,len(file),ierr)
        return
      end
C
C
C
      subroutine nhlferrclearmsgs(ierr)
        call nhlpferrclearmsgs(ierr)
        return
      end
C
C
C
      subroutine nhlferrsprintmsg(smess,imsg)
        character*(*) smess
        integer imsg
        call nhlpferrsprintmsg(smess,len(smess),imsg)
        return
      end
C
C
C
      subroutine nhlferrfprintmsg(iunit,imsg)
        integer iunit,imsg
        character*10240 smsg

        call nhlferrsprintmsg(smsg,imsg)
        call nhlpfprnmes(iunit,smsg,len(smsg))
        return
      end

C
C	$Id: conpdv.f,v 1.5 2008-07-27 00:16:57 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CONPDV (XD,YD,ZD,NDP)
C
C  PLOT THE DATA VALUES ON THE CONTOUR MAP
C  CURRENTLY UP TO 10 CHARACTERS FOR EACH VALUE ARE DISPLAYED
C
C
C
      COMMON /CONRA1/ CL(30)     ,NCL        ,OLDZ       ,PV(210)    ,
     1                FINC       ,HI         ,FLO
      COMMON /CONRA2/ REPEAT     ,EXTRAP     ,PER        ,MESS       ,
     1                ISCALE     ,LOOK       ,PLDVLS     ,GRD        ,
     2                CINC       ,CHILO      ,CON        ,LABON      ,
     3                PMIMX      ,SCALE      ,FRADV      ,EXTRI      ,
     4                BPSIZ      ,LISTOP
      COMMON /CONRA3/ IREC
      COMMON /CONRA4/ NCP        ,NCPSZ
      COMMON /CONRA5/ NIT        ,ITIPV
      COMMON /CONRA6/ XST        ,YST        ,XED        ,YED        ,
     1                STPSZ      ,IGRAD      ,IG         ,XRG        ,
     2                YRG        ,BORD       ,PXST       ,PYST       ,
     3                PXED       ,PYED       ,ITICK
      COMMON /CONR18/ TITLE      ,ICNT   ,ITLSIZ
      COMMON /CONR19/ IHIGH      ,INMAJ      ,INLAB      ,INDAT      ,
     1              LEN      ,IFMT       ,LEND       ,
     2                IFMTD      ,ISIZEP     ,INMIN
      COMMON /CONRA9/ ICOORD(500),NP         ,MXXY       ,TR         ,
     1                BR         ,TL         ,BL         ,CONV       ,
     2                XN         ,YN         ,ITLL       ,IBLL       ,
     3                ITRL       ,IBRL       ,XC         ,YC         ,
     4                ITLOC(210) ,JX         ,JY         ,ILOC       ,
     5                ISHFCT     ,XO         ,YO         ,IOC        ,NC
      COMMON /CONR10/ NT         ,NL         ,NTNL       ,JWIPT      ,
     1                JWIWL      ,JWIWP      ,JWIPL      ,IPR        ,
     2                ITPV
      COMMON /CONR20/ NREP       ,NCRT       ,ISIZEL     ,
     1                MINGAP     ,ISIZEM         ,
     2                TENS
      COMMON /CONR12/ IXMAX      ,IYMAX      ,XMAX       ,YMAX
      LOGICAL         REPEAT     ,EXTRAP     ,PER        ,MESS       ,
     1                LOOK       ,PLDVLS     ,GRD        ,LABON      ,
     2                PMIMX      ,FRADV      ,EXTRI      ,CINC       ,
     3                TITLE      ,LISTOP     ,CHILO      ,CON
      COMMON /CONR15/ ISTRNG
        CHARACTER*64 ISTRNG
        COMMON /CONR16/ FORM
        CHARACTER*10 FORM
        COMMON /CONR17/ NDASH, IDASH, EDASH
        CHARACTER*10 NDASH, IDASH, EDASH
        COMMON /RANINT/ IRANMJ, IRANMN, IRANTX
        COMMON /RAQINT/ IRAQMJ, IRAQMN, IRAQTX
        COMMON /RASINT/ IRASMJ, IRASMN, IRASTX
C
C
      CHARACTER*10  ISTR
      DIMENSION       XD(1)      ,YD(1)      ,ZD(1)
C
        SAVE
C
C  DATA TO CONVERT 0-32767 COORIDNATES TO 1-1024 VALUES
C
        DATA TRANS/32./
C
C  SET INTENSITY
C
        IF (INDAT .NE. 1) THEN
          CALL GSTXCI (INDAT)
        ELSE
            CALL GSTXCI (IRANTX)
      ENDIF
C
C  SET FORMAT IF NONE SPECIFIED
C
      IF (LEN .NE. 0) GO TO  110
        FORM = '(G10.3)'
      LEN = LEND
      IFMT = IFMTD
C
C  LOOP AND PLOT ALL VALUES
C
  110 DO  120 K=1,NDP
         CALL FL2INT (XD(K),YD(K),MX,MY)
         MX = INT(REAL(MX)/TRANS)+1
         MY = INT(REAL(MY)/TRANS)+1
       WRITE(ISTR,FORM)ZD(K)
C
C  POSITION STRINGS PROPERLY IF COORDS ARE IN PAU'S
C
      CALL GQCNTN(IER,ICN)
      CALL GSELNT(0)
      XC = CPUX(MX)
      YC = CPUY(MY)
C
         CALL WTSTR(XC,YC,ISTR,ISIZEP,0,0)
      CALL GSELNT(ICN)
  120 CONTINUE
        IF (INDAT .NE. 1) THEN
            CALL GSTXCI (IRANTX)
        ENDIF
      RETURN
      END

C NCLFORTSTART
      subroutine kerdeni(x,n,xmsg,z,m,f,h)
      implicit none
C                                   ! INPUT
      integer n, m
      double precision x(n) , z(m), xmsg        !
C                                   ! OUTPUT
      double precision f(m) , h
C NCLEND
      integer nn, k
      double precision work(n)      ! automatic (allocate)

C                                   ! work array
      nn = 0 
      do k=1,n 
         if (x(k).ne.xmsg) then
             nn = nn+1
             work(nn) = x(k)
         end if
      end do
C                                   !return if nn=0
      if (nn.eq.0) then
          do k=1,m 
             f(k) = xmsg
          end do 
          h = xmsg
         return
      end if
C                                   ! ascending order
      call dsortu(work,nn)          ! already in NCL?
C
      call plugin(work,nn,z,m,f,h)

      return 
      end
C====================================
         
      
      SUBROUTINE PLUGIN(X,N,Z,M,F,H)                      
C-----------------------------------------------------------------------
C       Version: 1995
C       fortran77 
C                                                                       
C       Purpose:                                                        
C                                                                       
C       Simple  Subroutine for kernel density estimation 
c       with iterative plug-in bandwidth selection
C       
C       This version only uses the gauss kernel and estimates only
c       the density itself and not its derivatives.
C                                                                       
C  INPUT    X(N)   DOUBLE PRECISION   sorted data
C  INPUT    N      INTEGER            length of  X
C  INPUT    Z(M)   DOUBLE PRECISION   output grid (sorted)
C  INPUT    M      INTEGER            length of Z
C  OUTPUT   F(M)   DOUBLE PRECISION   estimated density
C  OUTPUT   H      DOUBLE PRECISION   estimated iterative plugin bandwidth
C                                                                       
C                                                                       
C-----------------------------------------------------------------------
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N),Z(M),F(M)

      XN    = DBLE(N)
      XIQR  = X(NINT(.75*XN))-X(NINT(.25*XN)+1)
      PI    = 3.141592645D0
      RT2PI = DSQRT(2.D0*PI)
      ITER  = 5
C-------  Estimate inflation constant C
          H2=(.920*XIQR)/(XN**(1.D0/7.D0))
          H3=(.912*XIQR)/(XN**(1.D0/9.D0))
          S2 = 0.D0
          S3 = 0.D0
          DO 20 I = 1, N-1
           DO 30 J = I+1, N
                     D2 = ((X(I) - X(J))/H2)**2
                     D3 = ((X(I) - X(J))/H3)**2
                     IF(D2.GT.50.AND.D3.GT.60) GOTO 20
                     E2 = DEXP(-0.5D0*D2)
                     E3 = DEXP(-0.5D0*D3)
                     S2 = S2 + (D2**2 - 6.D0*D2 + 3.D0)*E2
               S3 = S3 + (D3**3 - 15.D0*D3**2 + 45.D0*D3 - 15.D0)*E3
30          CONTINUE
20         CONTINUE
          RHAT2 = (2.D0*S2)/((XN**2)*(H2**5)*RT2PI)
          RHAT2 = RHAT2 + 3.D0/(RT2PI*XN*(H2**5))
          RHAT3 = (-2.D0*S3)/((XN**2)*(H3**7)*RT2PI)
          RHAT3 = RHAT3 + 15.D0/(RT2PI*XN*(H3**7))
          CO1 = 1.357D0*(RHAT2/RHAT3)**(1.D0/7.D0)
C-
C-------  Compute constant of asymptotic formula
C-
       CONST = 1.D0/(2.D0*DSQRT(PI))
       A     = 1.132795764/RHAT3**(1.D0/7.D0)*XN**(-1.D0/2.D0)
C
C------  Loop over iterations
C-
       DO 100 IT=1,ITER
C-                                                                     
C-------  Estimate functional
C
        S=0.D0                                                    
        DO 40 I = 1, N-1
           DO 50 J = I+1, N
                     D2 = ((X(I) - X(J))/A)**2
                     IF(D2.GT.50) GOTO 40
                     E2 = DEXP(-0.5D0*D2)
                     S = S + (D2**2 - 6.D0*D2 + 3.D0)*E2
50          CONTINUE
40       CONTINUE
        R2 = (2.D0*S)/((XN**2)*(A**5)*RT2PI)
        R2 = R2 + 3.D0/(RT2PI*XN*(A**5))
C-                                                                     
C-------  Estimate bandwidth by asymptotic formula
C-
         H=(CONST/(R2*XN))**(.2D0)                                    
         A=CO1*H**(5./7.)
100     CONTINUE
C-
C------- Estimate density with plugin bandwidth
C-             
      JBEGIN=1
      JEND=1                                             
      DO 200 I=1,M                                                      
         S=0.D0    
         DO 210 J=JBEGIN,JEND
                T=(Z(I)-X(J))/H
                IF(T.GT.5.0.AND.JBEGIN.LT.N) THEN
                   JBEGIN=JBEGIN+1
                   GOTO 210
                END IF
                S=S+DEXP(-T*T/2.)
210             CONTINUE         
         DO 220 JEND=J,N
                T=(Z(I)-X(JEND))/H
                IF(T.LT.-5.0) GOTO 230
                S=S+DEXP(-T*T/2.)
220             CONTINUE
230         F(I)=S/(XN*H*RT2PI)
            JEND=JEND-1
C-                         
200      CONTINUE                                             
      RETURN                                                            
      END                                                               

C
C	$Id: dashdc.f,v 1.7 2008-07-27 00:16:58 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE DASHDC (IPAT,JCRT,JSIZE)
C
C Software dashed line package with character capability
C
C PURPOSE                DASHCHAR is a software dashed line package.
C
C USAGE                  First, either
C                             CALL DASHDB (IPAT)
C                        where IPAT is a 16-bit dash pattern as
C                        described in the subroutine DASHDB (see
C                        DASHLINE documentation), or
C                             CALL DASHDC (IPAT,JCRT,JSIZE)
C                        as described below.
C
C                        Then, call any of the following:
C                             CALL CURVED (X,Y,N)
C                             CALL FRSTD (X,Y)
C                             CALL VECTD (X,Y)
C                             CALL LASTD
C
C                        LASTD is called only after the last
C                        point of a line has been processed in VECTD.
C
C                        The following may also be called, but no
C                        smoothing will result:
C                             CALL LINED (XA,YA,XB,YB)
C
C
C ARGUMENTS              IPAT
C ON INPUT                 A character string of arbitrary length
C TO DASHDC                (60 characters seems to be a practical
C                          limit) which specifies the dash pattern
C                          to be used.  A dollar sign in IPAT
C                          indicates solid; an apostrophe indicates
C                          a gap; blanks are ignored.  Any character
C                          in IPAT which is not a dollar sign,
C                          apostrophe, or blank is considered to be
C                          part of a line label.  Each line label
C                          can be at most 15 characters in length.
C                          Sufficient white space is reserved in the
C                          dashed line for writing line labels.
C
C                        JCRT
C                          The length in plotter address units per
C                          $ or apostrophe.
C
C                        JSIZE
C                          Is the size of the plotted characters:
C                          . If between 0 and 3 , it is 1., 1.5, 2.
C                            and 3. times an 8 plotter address unit
C                            width.
C                          . If greater than 3, it is the character
C                            width in plotter address units.
C
C
C ARGUMENTS TO           CURVED(X,Y,N)
C OTHER LINE-DRAWING       X and Y are arrays of world coordinate values
C ROUTINES                 of length N or greater.  Line segments obeying
C                          the specified dash pattern are drawn to
C                          connect the N points.
C
C                        FRSTD(X,Y)
C                          The current pen position is set to
C                          the world coordinate value (X,Y)
C
C                        VECTD(X,Y)
C                          A line segment is drawn between the
C                          world coordinate value (X,Y) and the
C                          most recent pen position.  (X,Y) then
C                          becomes the most recent pen position.
C
C                        LINED(XA,XB,YA,YB)
C                          A line is drawn between world coordinate
C                          values (XA,YA) and (XB,YB).
C
C                        LASTD
C                          When using FRSTD and VECTD, LASTD may be
C                          called (no arguments needed). If the dashed
C                          line package was leaving a space for characters,
C                          and the line ended before there was enough space
C                          for the characters, the space left will be
C                          filled in if LASTD is called.
C
C
C ON OUTPUT                All arguments are unchanged for all routines.
C
C
C NOTE                     When switching from the regular plotting
C                          routines to a dashed line package the first
C                          call should not be to VECTD.
C
C ENTRY POINTS             DASHDB, DASHDC, CURVED, FRSTD, VECTD, LINED,
C                          RESET, LASTD, CFVLD, DRAWPV, DASHBD, DASHBDX
C
C COMMON BLOCKS            INTPR, DASHD1, DASHD2, DDFLAG, DCFLAG, DSAVE1,
C                          DSAVE6, DSAVE3, CFFLAG, DCFLAG
C
C REQUIRED LIBRARY         The ERPRT77 package and the SPPS.
C ROUTINES
C
C REQUIRED LEVEL OF GKS    0A
C
C I/O                      Plots solid or dashed lines, possibly with
C                          characters at intervals in the line.
C
C PRECISION                Single
C
C LANGUAGE                 FORTRAN
C
C HISTORY                  Written in 1969, standardized in November 1972.
C                          Made portable in September 1977 for use
C                          with all computer systems which
C                          support plotters with up to 15 bit resolution.
C                          Converted to FORTRAN77 and GKS in May 1984.
C
C ALGORITHM                The position in the dash pattern is
C                          remembered as points are processed.  The
C                          distance transversed in plotter address space
C                          is used to determine whether to draw segments,
C                          parts of segments, characters, or nothing.
C
C ACCURACY                 Plus or minus .5 plotter address units per call.
C                          There is no cumulative error.
C
C TIMING                   For solid or blank lines, there is almost no
C                          overhead.  Dashed lines take about 4 times as
C                          long as drawing solid lines.  (The line
C                          drawing software is so fast that the increase
C                          will not be noticed in most programs.) Patterns
C                          with characters do not take much longer than
C                          those without.
C
C PORTABILITY              FORTRAN77
C
C INTERNAL PARAMETERS      NAME   DEFAULT  FUNCTION  DECLARED IN BLOCK DATA
C                          ----   -------  --------
C
C                          IPAU      3     Number of plotter addresses per
C                                          element in the dash pattern for
C                                          solid lines and gaps. The
C                                          pattern is repeated every
C                                          IPAU*16 plotter address units.
C
C                          FPART     1.    Multiplicative factor for
C                                          first solid line segment.
C                                          This can be used to off-set
C                                          labels.  For example, if
C                                          FPART = .5, the first solid
C                                          line segment is only
C                                          one-half as long as the other
C                                          solid line segments.  This
C                                          moves all labels on this
C                                          line towards the beginning,
C                                          which reduces the
C                                          probability of the label
C                                          being written on top of a
C                                          label of a nearby line
C                                          drawn with FPART = 1.
C
C                          IGP       9     Flag to control whether a gap
C                                          is left for characters when
C                                          plotting.
C                                            = 9  Gap is left.
C                                            = 0  No gap is left.
C
C                          ICLOSE    6     An internal or external call to
C                                          set the pen (pen-up) to a
C                                          specific position is executed
C                                          only if this position is
C                                          more than ICLOSE metacode
C                                          address units away from the
C                                          current pen position (distance=
C                                          difference in X-coordinates +
C                                          difference in Y-coordinates).
C
C
C
      COMMON/INTPR/IPAU,FPART,TENSN,NP,SMALL,L1,ADDLR,ADDTB,MLLINE,
     1    ICLOSE
C
C USER ENTRY POINT.
C DASHDC GIVES AN INTERNAL REPRESENTATION TO THE DASH PATTERN WHICH IS
C SPECIFIED IN ITS ARGUMENTS. THIS INTERNAL REPRESENTATION IS PASSED
C TO ROUTINE CFVLD IN THE COMMON-BLOCK DASHD1.
C
      CHARACTER*(*) IPAT
      CHARACTER*1   ICR
      CHARACTER*16  IPC(100)
C
C DASHD1 AND DASHD2 ARE USED
C FOR COMMUNICATION BETWEEN THE ROUTINES DASHDB, DASHDC, AND CFVLD.
C ISL, MNCSTR AND IGP ARE INITIALIZED IN DASHBDX.
C
      COMMON /DASHD1/  ISL,  L,  ISIZE,  IP(100),  NWDSM1,  IPFLAG(100)
     1                 ,MNCSTR, IGP
      COMMON /DASHD2/  IPC
C
C IFCFLG IS THE FIRST CALL FLAG FOR DASHDB AND DASHDC.
C IT IS INITIALIZED IN DASHBDX.
C
      COMMON /DDFLAG/ IFCFLG
C
C IFSTFL CONTROLS THAT FRSTD IS CALLED BEFORE VECTD IS CALLED (IN CFVLD)
C WHENEVER DASHDB OR DASHDC HAVE BEEN CALLED.
C IT IS INITIALIZED IN DASHBDX AND REFERENCED IN CFVLD.
C
      COMMON /DCFLAG/ IFSTFL
C
C LOCAL VARIABLES TO DASHDB AND DASHDC ARE SAVED IN DSAVE6 FOR
C THE NEXT CALL.
C
      COMMON /DSAVE6/ MASK, NCHRWD, NBWD, MNCST1
C
C Make definitions of a blank, a gap, and a solid externally visible.
C
      COMMON /BLGASO/ IBLK,IGAP,ISOL
      CHARACTER*1     IBLK,IGAP,ISOL
C
C SAVE ALL VARIABLES
C
      SAVE
C
C Do a call forcing a BLOCKDATA to be loaded from a binary library.
C
      CALL DASHBD
C
C THE FOLLOWING CALL IS FOR LIBRARY STATISTICS GATHERING AT NCAR
C
      CALL Q8QST4 ('GRAPHX', 'DASHCHAR', 'DASHDC', 'VERSION  1')
C
C     NC IS THE NUMBER OF CHARACTERS IN IPAT
C
      NC = LEN(IPAT)
      IF (IFCFLG .EQ. 2) GOTO 10
C
C CHECK IF THE CONSTANTS IN THE BLOCKDATA DASHBDX ARE LOADED CORRECTLY
C
      IF (MNCSTR .EQ. 15) GOTO 6
      CALL SETER('DASHDC -- BLOCKDATA DASHBDX APPARENTLY NOT LOADED CORR
     1ECTLY',1,2)
    6 CONTINUE
C
C INITIALIZATION
C
      MNCST1 = MNCSTR + 1
C
C MASK IS AN ALL SOLID PATTERN TO BE PASSED TO OPTN (65535=177777B).
C
      MASK=IOR(ISHIFT(32767,1),1)
C
C
      IFCFLG = 2
C
C NCHRTS - NUMBER OF CHARS IN THIS HOLLERITH STRING.
C L      - NUMBER OF WORDS IN THE FINAL PATTERN, POINTER TO IP ARRAY.
C ISL    - FLAG FOR ALL SOLID PATTERN (1) OR ALL GAP PATTERN (-1).
C IFSTFL - FLAG TO CONTROL THAT FRSTD IS CALLED IN CFVLD BEFORE VECTD IS
C          CALLED, WHENEVER DASHDB OR DASHDC HAVE BEEN CALLED.
C
   10 CONTINUE
      NCHRTS = 0
      L = 0
      ISL = 0
      IFSTFL = 1
C
C RETRIEVE THE RESOLUTION AS SET BY THE USER.
C
      CALL GETUSV('XF',LXSAVE)
      CALL GETUSV('YF',LYSAVE)
C
C IADJUS - TO ADJUST NUMBERS TO THE GIVEN RESOLUTION.
C
      IADJUS = ISHIFT(1,15-LXSAVE)
      ICRT = JCRT*IADJUS
      ISIZE = JSIZE
      CHARW = REAL(ISIZE*IADJUS)
      IF (ISIZE .GT. 3) GO TO 30
      CHARW = 256. + REAL(ISIZE)*128.
      IF (ISIZE .EQ. 3) CHARW = 768.
C
   30 CONTINUE
      IF (ICRT .LT. 1) GO TO 230
      MODE = 2
C
C START MAIN LOOP
C
C THIS LOOP GENERATES THE IP ARRAY (NEEDED BY CURVED,VECTD,ETC.) FROM
C THE CHARACTER STRING IN IPAT.  EACH ITERATION OF THE LOOP PROCESSES
C ONE CHAR OF IPAT.  A SOLID OR GAP IS CONSIDERED TO BE A TYPE 1 ENTRY,
C AND A LABEL CHARACTER IS CONSIDERED TO BE A TYPE 2 ENTRY.
C
C IN THE CODE, L IS THE NUMBER OF CHANGES IN THE LINESTYLE (FROM GAP
C TO SOLID, SOLID TO CHARACTER, ETC.)  THE IP AND IPFLAG ARRAYS DESCRIBE
C THE LINE TO BE DRAWN, AND THESE ARRAYS ARE INDEXED FROM 1 TO L.  THE
C RELATIONSHIP BETWEEN IP AND IPFLAG IS:
C
C      IPFLAG(N)    IP(N)
C      ---------    -----
C          1        LENGTH (IN PLOTTER ADDRESS UNITS) OF SOLID LINE TO
C                   BE DRAWN.
C          0        NUMBER OF CHARACTERS TO BE PLOTTED.
C         -1        LENGTH (IN PLOTTER ADDRESS UNITS) OF GAP.
C
C THE 160 LOOP HANDLES 5 CASES:
C
C    1.)  CONTINUE TYPE 2 ENTRY (60-80)
C    2.)  START TYPE 2 ENTRY (80-90)
C    3.)  END TYPE 2 ENTRY AND START TYPE 1 ENTRY (90-160)
C    4.)  START TYPE 1 ENTRY, OR SWITCH TYPE 1 ENTRY FROM SOLID TO
C         GAP OR FROM GAP TO SOLID (140-160)
C    5.)  CONTINUE TYPE 1 ENTRY (150-160)
C
      DO 160 J=1,NC
C
C GET NEXT CHAR INTO ICR, RIGHT JUSTIFIED ZERO FILLED.
C
            ICR = IPAT(J:J)
C
C MODE SPECIFIES WHAT THE LAST CHARACTER PROCESSED WAS:
C
C    LAST ICR WAS $ (SOLID),      MODE IS 8
C    LAST ICR WAS ' (GAP),        MODE IS 2
C    LAST ICR WAS HOLLERITH CHAR, MODE IS 5
C
C NMODE SPECIFIES WHAT THE CURRENT CHARACTER TO BE PROCESSED IS:
C
C      ICR     NMODE
C      ---     -----
C       $        1
C       CHAR     0
C       '       -1
C
            NMODE = 0
            IF (ICR .EQ. IBLK) GO TO 160
            IF (ICR .EQ. IGAP) NMODE = -1
            IF (ICR .EQ. ISOL) NMODE = 1
            IF (L.EQ.0 .AND. NMODE.EQ.-1) MODE = 8
C
C NGO DETERMINES WHERE TO BRANCH BASED ON CASE TO BE PROCESSED.
C COMPUTE MODE FOR NEXT ITERATION.
C
            NGO = NMODE+MODE
            MODE = NMODE*3+5
            GO TO (150,80,140,90,60,90,140,80,150),NGO
C
C CHAR TO CHAR
C
C CASE 1) - CONTINUE TYPE 2 ENTRY.
C
   60      IF (NCHRTS .EQ. MNCSTR) GO TO 160
           NCHRTS = NCHRTS + 1
           IP(L) = NCHRTS
           IPC(L)(NCHRTS:NCHRTS) = ICR
           GO TO 160
C
C BLANK OR SOLID TO CHAR
C
C CASE 2) - START STRING ENTRY.  LGBSTR POINTS TO THE GAP WHICH
C           WILL CONTAIN THE STRING.
C
   80      LGBSTR = MIN(L+1,NP)
           L = MIN(LGBSTR+1,NP)
           IPFLAG(L) = 0
           NCHRTS    = 1
           IP(L)     = 1
           IPC(L)(NCHRTS:NCHRTS) = ICR
           GO TO 160
C
C CHAR TO SOLID OR GAP
C
C CASE 3) - END STRING ENTRY.  ICR IS A $ OR '.
C
   90      CONTINUE
           IP(LGBSTR) = CHARW*(REAL(NCHRTS) + .5)
           IPFLAG(LGBSTR) = -1
           IF (IGP .EQ. 0) IPFLAG(LGBSTR) = 1
C
C BLANK TO SOLID OR SOLID TO BLANK
C
C CASE 4) - START TYPE 1 ENTRY.
C
  140       L = MIN(L+1,NP)
            IP(L) = 0
C
C ADD TO A BLANK OR SOLID LINE
C
C CASE 5) - CONTINUE TYPE 1 ENTRY.  ICR IS A $ OR '.
C ADD ICRT UNITS TO THE PLOTTER ADDRESS UNITS IN IP(L).
C NMODE INDICATES IF IT IS A GAP OR A SOLID.
C
  150       IP(L) = IP(L) + ICRT
            IPFLAG(L) = NMODE
  160    CONTINUE
C
C IF LAST ICR PROCESSED WAS A LABEL CHARACTER, MUST END STRING
C ENTRY.
C
      IF (NGO.NE.2 .AND. NGO.NE.5 .AND. NGO.NE.8) GO TO 220
      IP(LGBSTR) = CHARW*(REAL(NCHRTS)+.5)
      IPFLAG(LGBSTR) = -1
      IF (IGP .EQ. 0) IPFLAG(LGBSTR) = 1
C
C IF IP ARRAY HAS ONLY ONE TYPE 1 ENTRY, SET ISL FLAG.
C
  220 IF (L .GT. 1) RETURN
      IBIG = ISHIFT(1,MAX(LXSAVE,LYSAVE))
      IF (IP(L) .GE. IBIG) GO TO 230
      IF (IPFLAG(L)) 240,240,230
  230 ISL = 1
      RETURN
  240 ISL = -1
      RETURN
      END

C     SUBROUTINE CFFTB(N,C,WSAVE)
C
C     SUBROUTINE CFFTB COMPUTES THE BACKWARD COMPLEX DISCRETE FOURIER
C     TRANSFORM (THE FOURIER SYNTHESIS). EQUIVALENTLY , CFFTB COMPUTES
C     A COMPLEX PERIODIC SEQUENCE FROM ITS FOURIER COEFFICIENTS.
C     THE TRANSFORM IS DEFINED BELOW AT OUTPUT PARAMETER C.
C
C     A CALL OF CFFTF FOLLOWED BY A CALL OF CFFTB WILL MULTIPLY THE
C     SEQUENCE BY N.
C
C     THE ARRAY WSAVE WHICH IS USED BY SUBROUTINE CFFTB MUST BE
C     INITIALIZED BY CALLING SUBROUTINE CFFTI(N,WSAVE).
C
C     INPUT PARAMETERS
C
C
C     N      THE LENGTH OF THE COMPLEX SEQUENCE C. THE METHOD IS
C            MORE EFFICIENT WHEN N IS THE PRODUCT OF SMALL PRIMES.
C
C     C      A COMPLEX ARRAY OF LENGTH N WHICH CONTAINS THE SEQUENCE
C
C     WSAVE   A REAL WORK ARRAY WHICH MUST BE DIMENSIONED AT LEAST 4N+15
C             IN THE PROGRAM THAT CALLS CFFTB. THE WSAVE ARRAY MUST BE
C             INITIALIZED BY CALLING SUBROUTINE CFFTI(N,WSAVE) AND A
C             DIFFERENT WSAVE ARRAY MUST BE USED FOR EACH DIFFERENT
C             VALUE OF N. THIS INITIALIZATION DOES NOT HAVE TO BE
C             REPEATED SO LONG AS N REMAINS UNCHANGED THUS SUBSEQUENT
C             TRANSFORMS CAN BE OBTAINED FASTER THAN THE FIRST.
C             THE SAME WSAVE ARRAY CAN BE USED BY CFFTF AND CFFTB.
C
C     OUTPUT PARAMETERS
C
C     C      FOR J=1,...,N
C
C                C(J)=THE SUM FROM K=1,...,N OF
C
C                      C(K)*EXP(I*(J-1)*(K-1)*2*PI/N)
C
C                            WHERE I=SQRT(-1)
C
C     WSAVE   CONTAINS INITIALIZATION CALCULATIONS WHICH MUST NOT BE
C             DESTROYED BETWEEN CALLS OF SUBROUTINE CFFTF OR CFFTB
C
      SUBROUTINE CFFTB(N,C,WSAVE)
      DOUBLE PRECISION C
      DOUBLE PRECISION WSAVE
      DIMENSION C(*),WSAVE(*)
C
      IF (N.EQ.1) RETURN
      IW1 = N + N + 1
      IW2 = IW1 + N + N
      CALL CFFTB1(N,C,WSAVE,WSAVE(IW1),WSAVE(IW2))
      RETURN
      END

      SUBROUTINE SLAPLL( N, X, INCX, Y, INCY, SSMIN )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     March 31, 1993
*
*     .. Scalar Arguments ..
      INTEGER            INCX, INCY, N
      REAL               SSMIN
*     ..
*     .. Array Arguments ..
      REAL               X( * ), Y( * )
*     ..
*
*  Purpose
*  =======
*
*  Given two column vectors X and Y, let
*
*                       A = ( X Y ).
*
*  The subroutine first computes the QR factorization of A = Q*R,
*  and then computes the SVD of the 2-by-2 upper triangular matrix R.
*  The smaller singular value of R is returned in SSMIN, which is used
*  as the measurement of the linear dependency of the vectors X and Y.
*
*  Arguments
*  =========
*
*  N       (input) INTEGER
*          The length of the vectors X and Y.
*
*  X       (input/output) REAL array,
*                         dimension (1+(N-1)*INCX)
*          On entry, X contains the N-vector X.
*          On exit, X is overwritten.
*
*  INCX    (input) INTEGER
*          The increment between successive elements of X. INCX > 0.
*
*  Y       (input/output) REAL array,
*                         dimension (1+(N-1)*INCY)
*          On entry, Y contains the N-vector Y.
*          On exit, Y is overwritten.
*
*  INCY    (input) INTEGER
*          The increment between successive elements of Y. INCY > 0.
*
*  SSMIN   (output) REAL
*          The smallest singular value of the N-by-2 matrix A = ( X Y ).
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ZERO, ONE
      PARAMETER          ( ZERO = 0.0E+0, ONE = 1.0E+0 )
*     ..
*     .. Local Scalars ..
      REAL               A11, A12, A22, C, SSMAX, TAU
*     ..
*     .. External Functions ..
      REAL               SDOT
      EXTERNAL           SDOT
*     ..
*     .. External Subroutines ..
      EXTERNAL           SAXPY, SLARFG, SLAS2
*     ..
*     .. Executable Statements ..
*
*     Quick return if possible
*
      IF( N.LE.1 ) THEN
         SSMIN = ZERO
         RETURN
      END IF
*
*     Compute the QR factorization of the N-by-2 matrix ( X Y )
*
      CALL SLARFG( N, X( 1 ), X( 1+INCX ), INCX, TAU )
      A11 = X( 1 )
      X( 1 ) = ONE
*
      C = -TAU*SDOT( N, X, INCX, Y, INCY )
      CALL SAXPY( N, C, X, INCX, Y, INCY )
*
      CALL SLARFG( N-1, Y( 1+INCY ), Y( 1+2*INCY ), INCY, TAU )
*
      A12 = Y( 1 )
      A22 = Y( 1+INCY )
*
*     Compute the SVD of 2-by-2 Upper triangular matrix.
*
      CALL SLAS2( A11, A12, A22, SSMIN, SSMAX )
*
      RETURN
*
*     End of SLAPLL
*
      END

C
C $Id: mdqini.f,v 1.6 2008-09-18 00:42:18 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MDQINI
C
C This routine is called to save all the variables that are needed for
C MDQTRA, MDQTRI, and MDQTRN to carry out the transformation that is in
C effect at the time MDQINI is called.  These routines are intended to
C make it possible to use EZMAP to do two different transformations at
C the same time.
C
C What motivates this is the desire to display a geo-referenced PNG as
C a background on a map.  Given a pixel at a particular X/Y position on
C the map, we use one set of projection parameters to find its lat/lon
C coordinates; then, using those coordinates, we use a different set of
C projection parameters to find out what pixel of the PNG (if any) is
C associated with that lat/lon position, which gives us a color for the
C pixel on the map.
C
C WARNING: The two transformations may not both be USGS transformations!
C This is because I do not, for the moment, wish to duplicate the entire
C USGS package or to put in logic to re-initialize it as necessary.  If
C this becomes an issue, I'll revisit the question later.
C
C Declare required common blocks.  See MAPBDX for descriptions of these
C common blocks and the variables in them.
C
        COMMON /MAPCM0/  COS1,DTOR,DTRH,OOPI,PI,PIOF,PIOT,RTDD,RTOD,
     +                   SROT,SIN1,TOPI,TSRT
        DOUBLE PRECISION COS1,DTOR,DTRH,OOPI,PI,PIOF,PIOT,RTDD,RTOD,
     +                   SROT,SIN1,TOPI,TSRT
        SAVE   /MAPCM0/
C
        COMMON /MAPCM1/  COSO,COSR,SINO,SINR,IPRJ,IROD
        DOUBLE PRECISION COSO,COSR,SINO,SINR
        INTEGER          IPRJ,IROD
        SAVE   /MAPCM1/
C
        COMMON /MAPCM2/  BLAM,BLOM,PEPS,SLAM,SLOM,UCEN,UMAX,UMIN,UOFF,
     +                   URNG,VCEN,VMAX,VMIN,VOFF,VRNG,ISSL
        DOUBLE PRECISION BLAM,BLOM,PEPS,SLAM,SLOM,UCEN,UMAX,UMIN,UOFF,
     +                   URNG,VCEN,VMAX,VMIN,VOFF,VRNG
        INTEGER          ISSL
        SAVE   /MAPCM2/
C
        COMMON /MAPCM4/  GRDR,GRID,GRLA,GRLO,GRPO,OTOL,PDRE,PLA1,PLA2,
     +                   PLA3,PLA4,PLB1,PLB2,PLB3,PLB4,PLNO,PLTO,ROTA,
     +                   SRCH,XLOW,XROW,YBOW,YTOW,IDOT,IDSH,IDTL,ILCW,
     +                   ILTS,JPRJ,ELPF,INTF,LBLF,PRMF
        DOUBLE PRECISION GRDR,GRID,GRLA,GRLO,GRPO,OTOL,PDRE,PLA1,PLA2,
     +                   PLA3,PLA4,PLB1,PLB2,PLB3,PLB4,PLNO,PLTO,ROTA,
     +                   SRCH,XLOW,XROW,YBOW,YTOW
        INTEGER          IDOT,IDSH,IDTL,ILCW,ILTS,JPRJ
        LOGICAL          ELPF,INTF,LBLF,PRMF
        SAVE   /MAPCM4/
C
        COMMON /MAPCM6/  UCNM,UMNM,UMXM,URNM,VCNM,VMNM,VMXM,VRNM,ELPM
        DOUBLE PRECISION UCNM,UMNM,UMXM,URNM,VCNM,VMNM,VMXM,VRNM
        LOGICAL ELPM
        SAVE   /MAPCM6/
C
        COMMON /MAPCM8/  P,Q,R
        DOUBLE PRECISION P,Q,R
        SAVE   /MAPCM8/
C
        COMMON /MAPCMW/  CSLS,CSLT,SLTD,ISLT
        DOUBLE PRECISION CSLS,CSLT,SLTD
        INTEGER ISLT
        SAVE   /MAPCMW/
C
        COMMON /MAPSAT/  ALFA,BETA,DCSA,DCSB,DSNA,DSNB,SALT,SSMO,SRSS
        DOUBLE PRECISION ALFA,BETA,DCSA,DCSB,DSNA,DSNB,SALT,SSMO,SRSS
        SAVE   /MAPSAT/
C
        COMMON /USGSC1/  UTPA(15),UUMN,UUMX,UVMN,UVMX,IPRF
        DOUBLE PRECISION UTPA,UUMN,UUMX,UVMN,UVMX
        INTEGER          IPRF
        SAVE   /USGSC1/
C
C Check for an uncleared prior error.
C
        IF (ICFELL('MDQINI - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C If EZMAP needs initialization, do it.
C
        IF (INTF) THEN
          CALL MDPINT
          IF (ICFELL('MDQINI',2).NE.0) RETURN
        END IF
C
C Call MDQIN2 to transfer variables from the common blocks above to a
C special common block used only by the transformation routines with
C names of the form M[AD]QTR[AIN].
C
        CALL MDQIN2 (ALFA,COSO,COSR,CSLS,CSLT,DCSA,DCSB,DSNA,DSNB,
     +               DTOR,DTRH,OOPI,PLNO,  PI,PIOT,ROTA,RTDD,RTOD,
     +               SALT,SINO,SINR,SRSS,SSMO,TOPI,UCNM,UMNM,UMXM,
     +               UOFF,URNM,VCNM,VMNM,VMXM,VOFF,VRNM,UTPA,IPRF,
     +               IPRJ,IROD,ELPM)
C
C Done.
C
        RETURN
C
      END

        PROGRAM CBEX01
C
C LATEST REVISION        September, 1989
C
C PURPOSE                To provide a simple demonstration of the
C                        use of BIVAR and CONPACK together as a
C                        temporary replacement for CONRAN.
C
C PRECISION              Single.
C
C REQUIRED LIBRARY       BIVAR, CONPACK.
C FILES
C
C LANGUAGE               FORTRAN.
C
C HISTORY                Written September, 1989, by Dave Kennison.
C
C ALGORITHM              At each of nine points scattered "at random"
C                        in a portion of the x/y plane, a mathematical
C                        function is evaluated to obtain a value of z.
C                        The resulting triplets approximately describe
C                        the surface which is defined exactly by the
C                        function.  The routine BIVAR is then called to
C                        obtain an array of interpolated values of z on
C                        a regular grid, approximating the same surface,
C                        and this data is used as input to CONPACK to
C                        draw two different contour plots.
C
C                        On the first plot, contours are shown in a
C                        rectangular area containing the x/y positions
C                        of the original nine data points and those
C                        positions are marked on the plot.
C
C                        On the second plot, capabilities of CONPACK
C                        and AREAS are used to limit the drawing of
C                        contours to the convex hull of the original
C                        nine x/y positions.
C
C PORTABILITY            ANSI standard.
C
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
        PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Define arrays to be used below.  XRAN, YRAN, and ZRAN are used for
C the "random data".  XCNV and YCNV are used to define the convex hull
C of the x/y positions of this data.  XDAT, YDAT, and ZDAT are used for
C the regular grid of data returned by BIVAR.  IWRK and RWRK are used
C as integer and real workspace arrays, both in calls to BIVAR and in
C calls to CONPACK.
C
        DIMENSION XRAN(9),YRAN(9),ZRAN(9),XCNV(7),YCNV(7)
        DIMENSION XDAT(11),YDAT(12),ZDAT(11,12)
        DIMENSION IWRK(1000),RWRK(1000)
C
C Define, in a labelled common block, quantities which must be available
C to the routines CPCHHL and CPCHLL.  The flag ICLL is used to turn
C on and off the culling of labels which these routines do (it is off
C while drawing the first plot and on while drawing the second).  The
C array IAMA is the area map array.
C
        COMMON /AMAPRA/ ICLL,IAMA(10000)
C
C Define a temporary character variable for use below.
C
        CHARACTER*1 ICHR
C
C Declare the routine which will draw contour lines, avoiding labels.
C
        EXTERNAL CPDRPL
C
C Specify the X and Y input data values.
C
        DATA XRAN / 0.4, 2.0, 2.8, 5.0, 4.8, 8.8, 5.1, 6.2, 9.1 /
        DATA YRAN / 5.4, 1.1, 3.7, 6.8, 9.5, 9.8, 0.7, 2.7, 3.0 /
C
C Specify the Z input data values.
C
        DO 101 I=1,9
C         ZRAN(I)=0.2+0.4*XRAN(I)*XRAN(I)+.6*YRAN(I)*YRAN(I)
          ZRAN(I)=EXP(-(XRAN(I)-3.)**2/9.-(YRAN(I)-5.)**2/25.)-
     +            EXP(-(XRAN(I)-6.)**2/9.-(YRAN(I)-5.)**2/25.)
  101   CONTINUE
C
C Specify the points defining the convex hull.
C
        XCNV(1)=XRAN(1)
        YCNV(1)=YRAN(1)
        XCNV(2)=XRAN(2)
        YCNV(2)=YRAN(2)
        XCNV(3)=XRAN(7)
        YCNV(3)=YRAN(7)
        XCNV(4)=XRAN(9)
        YCNV(4)=YRAN(9)
        XCNV(5)=XRAN(6)
        YCNV(5)=YRAN(6)
        XCNV(6)=XRAN(5)
        YCNV(6)=YRAN(5)
        XCNV(7)=XRAN(1)
        YCNV(7)=YRAN(1)
C
C Specify the X and Y coordinates of the points on the regular grid.
C
        DO 102 I=1,11
          XDAT(I)=REAL(I-1)
  102   CONTINUE
C
        DO 103 J=1,12
          YDAT(J)=REAL(J-1)
  103   CONTINUE
C
C Call IDSFFT to obtain a regular grid of values on the fitted surface.
C
        CALL IDSFFT (1,9,XRAN,YRAN,ZRAN,11,12,11,XDAT,YDAT,ZDAT,IWRK,
     +                                                          RWRK)
C
C Open GKS.
C
        CALL GOPKS (IERRF, ISZDM)
        CALL GOPWK (IWKID, LUNIT, IWTYPE)
        CALL GACWK (IWKID)
C
C Turn off clipping.
C
        CALL GSCLIP (0)
C
C Define a set of colors to use.
C
        CALL DFCLRS(IWKID)
C
C Tell CONPACK to position labels using the "regular" scheme.
C
        CALL CPSETI ('LLP - LINE LABEL POSITIONING',2)
C
C Tell CONPACK to put the informational label in a different place.
C
        CALL CPSETI ('ILP - INFORMATIONAL LABEL POSITIONING',-2)
        CALL CPSETR ('ILX - INFORMATIONAL LABEL X COORDINATE',.98)
        CALL CPSETR ('ILY - INFORMATIONAL LABEL Y COORDINATE',.02)
C
C Provide a little more room below the viewport; otherwise, the labels
C on AUTOGRAPH's X axis get squashed.
C
        CALL CPSETR ('VPB - VIEWPORT BOTTOM EDGE',.08)
C
C Tell CONPACK in what ranges to generate X and Y coordinates.
C
        CALL CPSETR ('XC1 - X COORDINATE AT I=1',0.)
        CALL CPSETR ('XCM - X COORDINATE AT I=M',10.)
        CALL CPSETR ('YC1 - Y COORDINATE AT J=1',0.)
        CALL CPSETR ('YCN - Y COORDINATE AT J=N',11.)
C
C Turn off the culling of labels by CPCHHL and CPCHLL.
C
        ICLL=0
C
C Dump the polyline buffer and change the polyline color to white.
C Change the text color to orange.  CONPACK will use these colors.
C
        CALL PLOTIF (0.,0.,2)
        CALL GSPLCI (1)
        CALL GSTXCI (12)
C
C Initialize the drawing of the first contour plot.
C
        CALL CPRECT (ZDAT,11,11,12,RWRK,1000,IWRK,1000)
C
C Initialize the area map which will be used to keep contour lines from
C passing through labels.
C
        CALL ARINAM (IAMA,10000)
C
C Put label boxes in the area map.
C
        CALL CPLBAM (ZDAT,RWRK,IWRK,IAMA)
C
C Draw the contour lines, masked by the area map.
C
        CALL CPCLDM (ZDAT,RWRK,IWRK,IAMA,CPDRPL)
C
C Draw all the labels.
C
        CALL CPLBDR (ZDAT,RWRK,IWRK)
C
C Dump the polyline buffer and change the polyline color to orange.
C Change the text color to orange, too, so that the AUTOGRAPH background
C will come out entirely in that color.
C
        CALL PLOTIF (0.,0.,2)
        CALL GSPLCI (12)
        CALL GSTXCI (12)
C
C Use AUTOGRAPH to produce a background for the contour plot, forcing
C it to pick up appropriate values from CONPACK's SET call.
C
        CALL AGSETI ('SET.',4)
        CALL AGSTUP (DUMI,1,1,1,1,DUMI,1,1,1,1)
        CALL AGBACK
C
C Dump the polyline buffer and change the polyline color to green.
C
        CALL PLOTIF (0.,0.,2)
        CALL GSPLCI (9)
C
C Change the aspect ratio of the characters drawn by PLCHMQ to make
C them approximately square.
C
        CALL PCSETR ('HW',1.)
C
C At each of the "random" data positions, put the index of the point
C and a starburst to set it off.
C
        DO 104 I=1,9
          ICHR=CHAR(ICHAR('0')+I)
          CALL PLCHMQ (XRAN(I),YRAN(I),ICHR,.0175,0.,0.)
          CALL LINE (CFUX(CUFX(XRAN(I))-.02),CFUY(CUFY(YRAN(I))-.02),
     +               CFUX(CUFX(XRAN(I))-.01),CFUY(CUFY(YRAN(I))-.01))
          CALL LINE (CFUX(CUFX(XRAN(I))+.01),CFUY(CUFY(YRAN(I))+.01),
     +               CFUX(CUFX(XRAN(I))+.02),CFUY(CUFY(YRAN(I))+.02))
          CALL LINE (CFUX(CUFX(XRAN(I))-.02),CFUY(CUFY(YRAN(I))+.02),
     +               CFUX(CUFX(XRAN(I))-.01),CFUY(CUFY(YRAN(I))+.01))
          CALL LINE (CFUX(CUFX(XRAN(I))+.01),CFUY(CUFY(YRAN(I))-.01),
     +               CFUX(CUFX(XRAN(I))+.02),CFUY(CUFY(YRAN(I))-.02))
          CALL LINE (CFUX(CUFX(XRAN(I))-.02828),CFUY(CUFY(YRAN(I))),
     +               CFUX(CUFX(XRAN(I))-.01414),CFUY(CUFY(YRAN(I))))
          CALL LINE (CFUX(CUFX(XRAN(I))+.01414),CFUY(CUFY(YRAN(I))),
     +               CFUX(CUFX(XRAN(I))+.02828),CFUY(CUFY(YRAN(I))))
          CALL LINE (CFUX(CUFX(XRAN(I))),CFUY(CUFY(YRAN(I))-.02828),
     +               CFUX(CUFX(XRAN(I))),CFUY(CUFY(YRAN(I))-.01414))
          CALL LINE (CFUX(CUFX(XRAN(I))),CFUY(CUFY(YRAN(I))+.01414),
     +               CFUX(CUFX(XRAN(I))),CFUY(CUFY(YRAN(I))+.02828))
  104   CONTINUE
C
C Dump the polyline buffer and switch the polyline color to yellow.
C
        CALL PLOTIF (0.,0.,2)
        CALL GSPLCI (11)
C
C Put a label at the top of the plot.
C
        CALL SET (0.,1.,0.,1.,0.,1.,0.,1.,1)
        CALL PLCHHQ (.5,.975,
     +               'DEMONSTRATING THE USE OF BIVAR AND CONPACK',
     +               .012,0.,0.)
C
C Advance the frame.
C
        CALL FRAME
C
C Do another frame.  First, turn on the culling of labels by the
C routines CPCHHL and CPCHLL (which see, below).
C
        ICLL=1
C
C Dump the polyline buffer and switch the polyline color back to white.
C Force the text color index to orange.
C
        CALL PLOTIF (0.,0.,2)
        CALL GSPLCI (1)
        CALL GSTXCI (12)
C
C Initialize the drawing of the second contour plot.
C
        CALL CPRECT (ZDAT,11,11,12,RWRK,1000,IWRK,1000)
C
C Initialize the area map.
C
        CALL ARINAM (IAMA,10000)
C
C Put the convex hull of the "random" data in the area map, using group
C identifier 4, an area identifier of 0 inside the hull, and an area
C identifier of -1 outside the hull.
C
        CALL AREDAM (IAMA,XCNV,YCNV,7,4,0,-1)
C
C Put label boxes in the area map.
C
        CALL CPLBAM (ZDAT,RWRK,IWRK,IAMA)
C
C Draw contour lines, masked by the area map.

        CALL CPCLDM (ZDAT,RWRK,IWRK,IAMA,CPDRPL)
C
C Draw labels.
C
        CALL CPLBDR (ZDAT,RWRK,IWRK)
C
C Dump the polyline buffer and switch the polyline color to orange.
C
        CALL PLOTIF (0.,0.,2)
        CALL GSPLCI (12)
C
C Use AUTOGRAPH to draw a background.
C
        CALL AGSETI ('SET.',4)
        CALL AGSTUP (DUMI,1,1,1,1,DUMI,1,1,1,1)
        CALL AGBACK
C
C Dump the polyline buffer and switch the polyline color to yellow.
C
        CALL PLOTIF (0.,0.,2)
        CALL GSPLCI (11)
C
C Draw a label at the top of the plot.
C
        CALL SET (0.,1.,0.,1.,0.,1.,0.,1.,1)
        CALL PLCHHQ (.5,.975,
     +               'DEMONSTRATING THE USE OF BIVAR AND CONPACK',
     +               .012,0.,0.)
C
C Advance the frame.
C
        CALL FRAME
C
C Close GKS.
C
        CALL GDAWK (IWKID)
        CALL GCLWK (IWKID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END
      SUBROUTINE DFCLRS(IWKID)
C
C Define a set of RGB color triples for colors 1 through 15 on
C workstation 1.
C
        DIMENSION RGBV(3,15)
C
C Define the RGB color triples needed below.
C
        DATA RGBV / 1.00 , 1.00 , 1.00 ,
     +              0.70 , 0.70 , 0.70 ,
     +              0.75 , 0.50 , 1.00 ,
     +              0.50 , 0.00 , 1.00 ,
     +              0.00 , 0.00 , 1.00 ,
     +              0.00 , 0.50 , 1.00 ,
     +              0.00 , 1.00 , 1.00 ,
     +              0.00 , 1.00 , 0.60 ,
     +              0.00 , 1.00 , 0.00 ,
     +              0.70 , 1.00 , 0.00 ,
     +              1.00 , 1.00 , 0.00 ,
     +              1.00 , 0.75 , 0.00 ,
     +              1.00 , 0.38 , 0.38 ,
     +              1.00 , 0.00 , 0.38 ,
     +              1.00 , 0.00 , 0.00 /
C
C Define 16 different color indices, for indices 0 through 15.  The
C color corresponding to index 0 is black and the color corresponding
C to index 1 is white.
C
        CALL GSCR (IWKID,0,0.,0.,0.)
C
        DO 101 I=1,15
          CALL GSCR (IWKID,I,RGBV(1,I),RGBV(2,I),RGBV(3,I))
  101   CONTINUE
C
C Done.
C
        RETURN
C
      END
      SUBROUTINE CPCHHL (IFLG)
C
C This version of CPCHHL, if and only if ICLL is non-zero, examines a
C high/low label which is about to be drawn.  If that label would fall
C in an area outside the convex hull defined by edge group 4, the text
C of the label is changed to a blank, so that the label is effectively
C deleted.
C
        COMMON /AMAPRA/ ICLL,IAMA(10000)
        DIMENSION IAAI(10),IAGI(10)
        IF (ICLL.EQ.0) RETURN
        IF ((IFLG.GE.2.AND.IFLG.LE.4).OR.
     +      (IFLG.GE.6.AND.IFLG.LE.8)) THEN
          CALL CPGETR ('LBX',XPOS)
          CALL CPGETR ('LBY',YPOS)
          CALL ARGTAI (IAMA,XPOS,YPOS,IAAI,IAGI,10,NAIR,1)
          IVIS=1
          DO 101 I=1,NAIR
            IF (IAGI(I).EQ.4.AND.IAAI(I).LT.0) IVIS=0
  101     CONTINUE
          IF (IVIS.EQ.0) THEN
            CALL CPSETC ('CTM',' ')
          END IF
        END IF
        RETURN
      END
      SUBROUTINE CPCHLL (IFLG)
C
C This version of CPCHLL, if and only if ICLL is non-zero, examines a
C contour-line label which is about to be drawn.  If that label would
C fall in an area outside the convex hull defined by edge group 4, the
C text of the label is changed to a blank, so that it is effectively
C deleted.
C
        COMMON /AMAPRA/ ICLL,IAMA(10000)
        DIMENSION IAAI(10),IAGI(10)
        IF (ICLL.EQ.0) RETURN
        IF (IFLG.GE.2.AND.IFLG.LE.4) THEN
          CALL CPGETR ('LBX',XPOS)
          CALL CPGETR ('LBY',YPOS)
          CALL ARGTAI (IAMA,XPOS,YPOS,IAAI,IAGI,10,NAIR,1)
          IVIS=1
          DO 101 I=1,NAIR
            IF (IAGI(I).EQ.4.AND.IAAI(I).LT.0) IVIS=0
  101     CONTINUE
          IF (IVIS.EQ.0) THEN
            CALL CPSETC ('CTM',' ')
          END IF
        END IF
        RETURN
      END

      SUBROUTINE DGEGS( JOBVSL, JOBVSR, N, A, LDA, B, LDB, ALPHAR,
     $                  ALPHAI, BETA, VSL, LDVSL, VSR, LDVSR, WORK,
     $                  LWORK, INFO )
*
*  -- LAPACK driver routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          JOBVSL, JOBVSR
      INTEGER            INFO, LDA, LDB, LDVSL, LDVSR, LWORK, N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), ALPHAI( * ), ALPHAR( * ),
     $                   B( LDB, * ), BETA( * ), VSL( LDVSL, * ),
     $                   VSR( LDVSR, * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  This routine is deprecated and has been replaced by routine DGGES.
*
*  DGEGS computes for a pair of N-by-N real nonsymmetric matrices A, B:
*  the generalized eigenvalues (alphar +/- alphai*i, beta), the real
*  Schur form (A, B), and optionally left and/or right Schur vectors
*  (VSL and VSR).
*
*  (If only the generalized eigenvalues are needed, use the driver DGEGV
*  instead.)
*
*  A generalized eigenvalue for a pair of matrices (A,B) is, roughly
*  speaking, a scalar w or a ratio  alpha/beta = w, such that  A - w*B
*  is singular.  It is usually represented as the pair (alpha,beta),
*  as there is a reasonable interpretation for beta=0, and even for
*  both being zero.  A good beginning reference is the book, "Matrix
*  Computations", by G. Golub & C. van Loan (Johns Hopkins U. Press)
*
*  The (generalized) Schur form of a pair of matrices is the result of
*  multiplying both matrices on the left by one orthogonal matrix and
*  both on the right by another orthogonal matrix, these two orthogonal
*  matrices being chosen so as to bring the pair of matrices into
*  (real) Schur form.
*
*  A pair of matrices A, B is in generalized real Schur form if B is
*  upper triangular with non-negative diagonal and A is block upper
*  triangular with 1-by-1 and 2-by-2 blocks.  1-by-1 blocks correspond
*  to real generalized eigenvalues, while 2-by-2 blocks of A will be
*  "standardized" by making the corresponding elements of B have the
*  form:
*          [  a  0  ]
*          [  0  b  ]
*
*  and the pair of corresponding 2-by-2 blocks in A and B will
*  have a complex conjugate pair of generalized eigenvalues.
*
*  The left and right Schur vectors are the columns of VSL and VSR,
*  respectively, where VSL and VSR are the orthogonal matrices
*  which reduce A and B to Schur form:
*
*  Schur form of (A,B) = ( (VSL)**T A (VSR), (VSL)**T B (VSR) )
*
*  Arguments
*  =========
*
*  JOBVSL  (input) CHARACTER*1
*          = 'N':  do not compute the left Schur vectors;
*          = 'V':  compute the left Schur vectors.
*
*  JOBVSR  (input) CHARACTER*1
*          = 'N':  do not compute the right Schur vectors;
*          = 'V':  compute the right Schur vectors.
*
*  N       (input) INTEGER
*          The order of the matrices A, B, VSL, and VSR.  N >= 0.
*
*  A       (input/output) DOUBLE PRECISION array, dimension (LDA, N)
*          On entry, the first of the pair of matrices whose generalized
*          eigenvalues and (optionally) Schur vectors are to be
*          computed.
*          On exit, the generalized Schur form of A.
*          Note: to avoid overflow, the Frobenius norm of the matrix
*          A should be less than the overflow threshold.
*
*  LDA     (input) INTEGER
*          The leading dimension of A.  LDA >= max(1,N).
*
*  B       (input/output) DOUBLE PRECISION array, dimension (LDB, N)
*          On entry, the second of the pair of matrices whose
*          generalized eigenvalues and (optionally) Schur vectors are
*          to be computed.
*          On exit, the generalized Schur form of B.
*          Note: to avoid overflow, the Frobenius norm of the matrix
*          B should be less than the overflow threshold.
*
*  LDB     (input) INTEGER
*          The leading dimension of B.  LDB >= max(1,N).
*
*  ALPHAR  (output) DOUBLE PRECISION array, dimension (N)
*  ALPHAI  (output) DOUBLE PRECISION array, dimension (N)
*  BETA    (output) DOUBLE PRECISION array, dimension (N)
*          On exit, (ALPHAR(j) + ALPHAI(j)*i)/BETA(j), j=1,...,N, will
*          be the generalized eigenvalues.  ALPHAR(j) + ALPHAI(j)*i,
*          j=1,...,N  and  BETA(j),j=1,...,N  are the diagonals of the
*          complex Schur form (A,B) that would result if the 2-by-2
*          diagonal blocks of the real Schur form of (A,B) were further
*          reduced to triangular form using 2-by-2 complex unitary
*          transformations.  If ALPHAI(j) is zero, then the j-th
*          eigenvalue is real; if positive, then the j-th and (j+1)-st
*          eigenvalues are a complex conjugate pair, with ALPHAI(j+1)
*          negative.
*
*          Note: the quotients ALPHAR(j)/BETA(j) and ALPHAI(j)/BETA(j)
*          may easily over- or underflow, and BETA(j) may even be zero.
*          Thus, the user should avoid naively computing the ratio
*          alpha/beta.  However, ALPHAR and ALPHAI will be always less
*          than and usually comparable with norm(A) in magnitude, and
*          BETA always less than and usually comparable with norm(B).
*
*  VSL     (output) DOUBLE PRECISION array, dimension (LDVSL,N)
*          If JOBVSL = 'V', VSL will contain the left Schur vectors.
*          (See "Purpose", above.)
*          Not referenced if JOBVSL = 'N'.
*
*  LDVSL   (input) INTEGER
*          The leading dimension of the matrix VSL. LDVSL >=1, and
*          if JOBVSL = 'V', LDVSL >= N.
*
*  VSR     (output) DOUBLE PRECISION array, dimension (LDVSR,N)
*          If JOBVSR = 'V', VSR will contain the right Schur vectors.
*          (See "Purpose", above.)
*          Not referenced if JOBVSR = 'N'.
*
*  LDVSR   (input) INTEGER
*          The leading dimension of the matrix VSR. LDVSR >= 1, and
*          if JOBVSR = 'V', LDVSR >= N.
*
*  WORK    (workspace/output) DOUBLE PRECISION array, dimension (LWORK)
*          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*
*  LWORK   (input) INTEGER
*          The dimension of the array WORK.  LWORK >= max(1,4*N).
*          For good performance, LWORK must generally be larger.
*          To compute the optimal value of LWORK, call ILAENV to get
*          blocksizes (for DGEQRF, DORMQR, and DORGQR.)  Then compute:
*          NB  -- MAX of the blocksizes for DGEQRF, DORMQR, and DORGQR
*          The optimal LWORK is  2*N + N*(NB+1).
*
*          If LWORK = -1, then a workspace query is assumed; the routine
*          only calculates the optimal size of the WORK array, returns
*          this value as the first entry of the WORK array, and no error
*          message related to LWORK is issued by XERBLA.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value.
*          = 1,...,N:
*                The QZ iteration failed.  (A,B) are not in Schur
*                form, but ALPHAR(j), ALPHAI(j), and BETA(j) should
*                be correct for j=INFO+1,...,N.
*          > N:  errors that usually indicate LAPACK problems:
*                =N+1: error return from DGGBAL
*                =N+2: error return from DGEQRF
*                =N+3: error return from DORMQR
*                =N+4: error return from DORGQR
*                =N+5: error return from DGGHRD
*                =N+6: error return from DHGEQZ (other than failed
*                                                iteration)
*                =N+7: error return from DGGBAK (computing VSL)
*                =N+8: error return from DGGBAK (computing VSR)
*                =N+9: error return from DLASCL (various places)
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO, ONE
      PARAMETER          ( ZERO = 0.0D0, ONE = 1.0D0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            ILASCL, ILBSCL, ILVSL, ILVSR, LQUERY
      INTEGER            ICOLS, IHI, IINFO, IJOBVL, IJOBVR, ILEFT, ILO,
     $                   IRIGHT, IROWS, ITAU, IWORK, LOPT, LWKMIN,
     $                   LWKOPT, NB, NB1, NB2, NB3
      DOUBLE PRECISION   ANRM, ANRMTO, BIGNUM, BNRM, BNRMTO, EPS,
     $                   SAFMIN, SMLNUM
*     ..
*     .. External Subroutines ..
      EXTERNAL           DGEQRF, DGGBAK, DGGBAL, DGGHRD, DHGEQZ, DLACPY,
     $                   DLASCL, DLASET, DORGQR, DORMQR, XERBLA
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            ILAENV
      DOUBLE PRECISION   DLAMCH, DLANGE
      EXTERNAL           LSAME, ILAENV, DLAMCH, DLANGE
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          INT, MAX
*     ..
*     .. Executable Statements ..
*
*     Decode the input arguments
*
      IF( LSAME( JOBVSL, 'N' ) ) THEN
         IJOBVL = 1
         ILVSL = .FALSE.
      ELSE IF( LSAME( JOBVSL, 'V' ) ) THEN
         IJOBVL = 2
         ILVSL = .TRUE.
      ELSE
         IJOBVL = -1
         ILVSL = .FALSE.
      END IF
*
      IF( LSAME( JOBVSR, 'N' ) ) THEN
         IJOBVR = 1
         ILVSR = .FALSE.
      ELSE IF( LSAME( JOBVSR, 'V' ) ) THEN
         IJOBVR = 2
         ILVSR = .TRUE.
      ELSE
         IJOBVR = -1
         ILVSR = .FALSE.
      END IF
*
*     Test the input arguments
*
      LWKMIN = MAX( 4*N, 1 )
      LWKOPT = LWKMIN
      WORK( 1 ) = LWKOPT
      LQUERY = ( LWORK.EQ.-1 )
      INFO = 0
      IF( IJOBVL.LE.0 ) THEN
         INFO = -1
      ELSE IF( IJOBVR.LE.0 ) THEN
         INFO = -2
      ELSE IF( N.LT.0 ) THEN
         INFO = -3
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -5
      ELSE IF( LDB.LT.MAX( 1, N ) ) THEN
         INFO = -7
      ELSE IF( LDVSL.LT.1 .OR. ( ILVSL .AND. LDVSL.LT.N ) ) THEN
         INFO = -12
      ELSE IF( LDVSR.LT.1 .OR. ( ILVSR .AND. LDVSR.LT.N ) ) THEN
         INFO = -14
      ELSE IF( LWORK.LT.LWKMIN .AND. .NOT.LQUERY ) THEN
         INFO = -16
      END IF
*
      IF( INFO.EQ.0 ) THEN
         NB1 = ILAENV( 1, 'DGEQRF', ' ', N, N, -1, -1 )
         NB2 = ILAENV( 1, 'DORMQR', ' ', N, N, N, -1 )
         NB3 = ILAENV( 1, 'DORGQR', ' ', N, N, N, -1 )
         NB = MAX( NB1, NB2, NB3 )
         LOPT = 2*N + N*( NB+1 )
         WORK( 1 ) = LOPT
      END IF
*
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DGEGS ', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
*
*     Get machine constants
*
      EPS = DLAMCH( 'E' )*DLAMCH( 'B' )
      SAFMIN = DLAMCH( 'S' )
      SMLNUM = N*SAFMIN / EPS
      BIGNUM = ONE / SMLNUM
*
*     Scale A if max element outside range [SMLNUM,BIGNUM]
*
      ANRM = DLANGE( 'M', N, N, A, LDA, WORK )
      ILASCL = .FALSE.
      IF( ANRM.GT.ZERO .AND. ANRM.LT.SMLNUM ) THEN
         ANRMTO = SMLNUM
         ILASCL = .TRUE.
      ELSE IF( ANRM.GT.BIGNUM ) THEN
         ANRMTO = BIGNUM
         ILASCL = .TRUE.
      END IF
*
      IF( ILASCL ) THEN
         CALL DLASCL( 'G', -1, -1, ANRM, ANRMTO, N, N, A, LDA, IINFO )
         IF( IINFO.NE.0 ) THEN
            INFO = N + 9
            RETURN
         END IF
      END IF
*
*     Scale B if max element outside range [SMLNUM,BIGNUM]
*
      BNRM = DLANGE( 'M', N, N, B, LDB, WORK )
      ILBSCL = .FALSE.
      IF( BNRM.GT.ZERO .AND. BNRM.LT.SMLNUM ) THEN
         BNRMTO = SMLNUM
         ILBSCL = .TRUE.
      ELSE IF( BNRM.GT.BIGNUM ) THEN
         BNRMTO = BIGNUM
         ILBSCL = .TRUE.
      END IF
*
      IF( ILBSCL ) THEN
         CALL DLASCL( 'G', -1, -1, BNRM, BNRMTO, N, N, B, LDB, IINFO )
         IF( IINFO.NE.0 ) THEN
            INFO = N + 9
            RETURN
         END IF
      END IF
*
*     Permute the matrix to make it more nearly triangular
*     Workspace layout:  (2*N words -- "work..." not actually used)
*        left_permutation, right_permutation, work...
*
      ILEFT = 1
      IRIGHT = N + 1
      IWORK = IRIGHT + N
      CALL DGGBAL( 'P', N, A, LDA, B, LDB, ILO, IHI, WORK( ILEFT ),
     $             WORK( IRIGHT ), WORK( IWORK ), IINFO )
      IF( IINFO.NE.0 ) THEN
         INFO = N + 1
         GO TO 10
      END IF
*
*     Reduce B to triangular form, and initialize VSL and/or VSR
*     Workspace layout:  ("work..." must have at least N words)
*        left_permutation, right_permutation, tau, work...
*
      IROWS = IHI + 1 - ILO
      ICOLS = N + 1 - ILO
      ITAU = IWORK
      IWORK = ITAU + IROWS
      CALL DGEQRF( IROWS, ICOLS, B( ILO, ILO ), LDB, WORK( ITAU ),
     $             WORK( IWORK ), LWORK+1-IWORK, IINFO )
      IF( IINFO.GE.0 )
     $   LWKOPT = MAX( LWKOPT, INT( WORK( IWORK ) )+IWORK-1 )
      IF( IINFO.NE.0 ) THEN
         INFO = N + 2
         GO TO 10
      END IF
*
      CALL DORMQR( 'L', 'T', IROWS, ICOLS, IROWS, B( ILO, ILO ), LDB,
     $             WORK( ITAU ), A( ILO, ILO ), LDA, WORK( IWORK ),
     $             LWORK+1-IWORK, IINFO )
      IF( IINFO.GE.0 )
     $   LWKOPT = MAX( LWKOPT, INT( WORK( IWORK ) )+IWORK-1 )
      IF( IINFO.NE.0 ) THEN
         INFO = N + 3
         GO TO 10
      END IF
*
      IF( ILVSL ) THEN
         CALL DLASET( 'Full', N, N, ZERO, ONE, VSL, LDVSL )
         CALL DLACPY( 'L', IROWS-1, IROWS-1, B( ILO+1, ILO ), LDB,
     $                VSL( ILO+1, ILO ), LDVSL )
         CALL DORGQR( IROWS, IROWS, IROWS, VSL( ILO, ILO ), LDVSL,
     $                WORK( ITAU ), WORK( IWORK ), LWORK+1-IWORK,
     $                IINFO )
         IF( IINFO.GE.0 )
     $      LWKOPT = MAX( LWKOPT, INT( WORK( IWORK ) )+IWORK-1 )
         IF( IINFO.NE.0 ) THEN
            INFO = N + 4
            GO TO 10
         END IF
      END IF
*
      IF( ILVSR )
     $   CALL DLASET( 'Full', N, N, ZERO, ONE, VSR, LDVSR )
*
*     Reduce to generalized Hessenberg form
*
      CALL DGGHRD( JOBVSL, JOBVSR, N, ILO, IHI, A, LDA, B, LDB, VSL,
     $             LDVSL, VSR, LDVSR, IINFO )
      IF( IINFO.NE.0 ) THEN
         INFO = N + 5
         GO TO 10
      END IF
*
*     Perform QZ algorithm, computing Schur vectors if desired
*     Workspace layout:  ("work..." must have at least 1 word)
*        left_permutation, right_permutation, work...
*
      IWORK = ITAU
      CALL DHGEQZ( 'S', JOBVSL, JOBVSR, N, ILO, IHI, A, LDA, B, LDB,
     $             ALPHAR, ALPHAI, BETA, VSL, LDVSL, VSR, LDVSR,
     $             WORK( IWORK ), LWORK+1-IWORK, IINFO )
      IF( IINFO.GE.0 )
     $   LWKOPT = MAX( LWKOPT, INT( WORK( IWORK ) )+IWORK-1 )
      IF( IINFO.NE.0 ) THEN
         IF( IINFO.GT.0 .AND. IINFO.LE.N ) THEN
            INFO = IINFO
         ELSE IF( IINFO.GT.N .AND. IINFO.LE.2*N ) THEN
            INFO = IINFO - N
         ELSE
            INFO = N + 6
         END IF
         GO TO 10
      END IF
*
*     Apply permutation to VSL and VSR
*
      IF( ILVSL ) THEN
         CALL DGGBAK( 'P', 'L', N, ILO, IHI, WORK( ILEFT ),
     $                WORK( IRIGHT ), N, VSL, LDVSL, IINFO )
         IF( IINFO.NE.0 ) THEN
            INFO = N + 7
            GO TO 10
         END IF
      END IF
      IF( ILVSR ) THEN
         CALL DGGBAK( 'P', 'R', N, ILO, IHI, WORK( ILEFT ),
     $                WORK( IRIGHT ), N, VSR, LDVSR, IINFO )
         IF( IINFO.NE.0 ) THEN
            INFO = N + 8
            GO TO 10
         END IF
      END IF
*
*     Undo scaling
*
      IF( ILASCL ) THEN
         CALL DLASCL( 'H', -1, -1, ANRMTO, ANRM, N, N, A, LDA, IINFO )
         IF( IINFO.NE.0 ) THEN
            INFO = N + 9
            RETURN
         END IF
         CALL DLASCL( 'G', -1, -1, ANRMTO, ANRM, N, 1, ALPHAR, N,
     $                IINFO )
         IF( IINFO.NE.0 ) THEN
            INFO = N + 9
            RETURN
         END IF
         CALL DLASCL( 'G', -1, -1, ANRMTO, ANRM, N, 1, ALPHAI, N,
     $                IINFO )
         IF( IINFO.NE.0 ) THEN
            INFO = N + 9
            RETURN
         END IF
      END IF
*
      IF( ILBSCL ) THEN
         CALL DLASCL( 'U', -1, -1, BNRMTO, BNRM, N, N, B, LDB, IINFO )
         IF( IINFO.NE.0 ) THEN
            INFO = N + 9
            RETURN
         END IF
         CALL DLASCL( 'G', -1, -1, BNRMTO, BNRM, N, 1, BETA, N, IINFO )
         IF( IINFO.NE.0 ) THEN
            INFO = N + 9
            RETURN
         END IF
      END IF
*
   10 CONTINUE
      WORK( 1 ) = LWKOPT
*
      RETURN
*
*     End of DGEGS
*
      END

C
C	$Id: intmsk.f,v 1.4 2008-07-27 00:23:04 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE INTMSK(MASK,MASK3)
C
C     THIS SUBROUTINE INITIALIZES THE MASKS USED BY THE MODEL PICTURE
C
      DIMENSION MASK(*),MASK3(*)
      SAVE
C
C     GET NUMBER OF BITS PER WORD
C
      NBPW = I1MACH(5)
C
C     FILL MASKS
C
      IP1 = 1
      IP2 = 7
      MASK(1)  = 1
      MASK3(1) = 3
C
      DO  5 I=2,64
      MASK(I)  = 0
      MASK3(I) = 0
    5 CONTINUE
C
      DO 10 I=2,NBPW-1
      MASK(I)=ISHIFT(IP1,I-1)
      MASK3(I)=ISHIFT(IP2,I-2)
   10 CONTINUE
      MASK(NBPW)=ISHIFT(IP1,NBPW-1)
      MASK3(NBPW)=ISHIFT(MASK3(1),NBPW-2)
      RETURN
      END

C
C $Id: mplndm.f,v 1.14 2008-07-27 00:17:07 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MPLNDM (FLNM,ILVL,IAMA,XCRA,YCRA,MCRA,IAAI,IAGI,MNOG,
     +                                                           ULPR)
        CHARACTER*(*) FLNM
        INTEGER       ILVL,IAMA(*)
        REAL          XCRA(MCRA),YCRA(MCRA)
        INTEGER       MCRA,IAAI(MNOG),IAGI(MNOG),MNOG
        IF (ICFELL('MPLNDM - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
        CALL MDLNDM (FLNM,ILVL,IAMA,XCRA,YCRA,MCRA,IAAI,IAGI,MNOG,ULPR)
        IF (ICFELL('MPLNDM',2).NE.0) RETURN
        RETURN
      END

C
C $Id: PLOTMANAGERF.f,v 1.1 2001-10-09 00:18:35 haley Exp $
C
C****************************************************************
C                                                               *
C                       Copyright (C)  1994                     *
C       University Corporation for Atmospheric Research         *
C                       All Rights Reserved                     *
C                                                               *
C****************************************************************
C
C      File:            OVERLAY.f
C
C      Author:          Jeff W. Boote
C                       National Center for Atmospheric Research
C                       PO 3000, Boulder, Colorado
C
C      Date:            Fri Apr 15 16:53:27 MDT 1994
C
C      Description:     
C
      subroutine nhlfaddoverlay(id_base,id_plot,id_after,ierr)
        call nhlfpaddoverlay(id_base,id_plot,id_after,ierr)
      end
C
      subroutine nhlfremoveoverlay(id_base,id_plot,irestore,ierr)
        call nhlfpremoveoverlay(id_base,id_plot,irestore,ierr)
      end
C
      subroutine nhlfaddannotation(plot_id,view_id,anno_manager_id)
        call nhlfpaddannotation(plot_id,view_id,anno_manager_id)
      end
C
      subroutine nhlfremoveannotation(plot_id,anno_manager_id,ierr)
        call nhlfpremoveannotation(plot_id,anno_manager_id,ierr)
      end
C

C
C	$Id: gnpart.f,v 1.4 2008-07-27 00:20:58 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GNPART(IOS,STATUS)
C
C  Get next partitiion of an instruction.
C
      include 'trpars.h'
      include 'trinst.h'
      include 'trbufr.h'
C
      INTEGER IOS,STATUS
      INTEGER CONVAL
C
      STATUS = 0
C
C  Parse the partition.
C
      METBIT = MOPRST
C
C  Make sure that the instruction starts on a 16 bit boundry.
C
      TEMP = MOD(METBIT,16)
      IF (TEMP .NE. 0) METBIT = METBIT + (16-TEMP)
C
C  First test if there is enough room in the buffer.
C
      IF (MRECLN .LT. (METBIT+MCOLEN+MLOLEN)) THEN
C
C  Read in a new record.
C
        CALL GSEGRD (IOS,STATUS)
        IF (STATUS .NE. 0) RETURN
      END IF
C
C  Get the continue flag value.
C
      CALL GBYTES(MBUFER,CONVAL,METBIT,MCOLEN,0,1) 
      METBIT = METBIT + MCOLEN
      IF (CONVAL .EQ. CONFLG) THEN
        CNTINU = .TRUE.
      ELSE
        CNTINU = .FALSE.
      END IF
C
C  Get the long operand 8 bit byte count field.
C
      CALL GBYTES(MBUFER,LEN,METBIT,MLOLEN,0,1)
      METBIT = METBIT + MLOLEN
C
      MOPRST = METBIT
      METBIT = METBIT + (LEN*BYTSIZ)
C
      RETURN
      END

C
C      $Id: cn16f.f,v 1.5 2010-03-15 22:49:23 haley Exp $
C
C***********************************************************************
C                                                                      *
C                Copyright (C)  1997                                   *
C        University Corporation for Atmospheric Research               *
C     The use of this Software is governed by a License Agreement      *
C                                                                      *
C***********************************************************************
C
C  File:       cn16f.f
C
C   Author:     Bob Lackman
C               National Center for Atmospheric Research
C               PO 3000, Boulder, Colorado
C
C   Date:       Wed Mar 19, 1996
C
C   Description:    Combines a vector fill contour plot, a raster
C                   contour plot, and a map plot on a single frame.
C
      external NhlFAppClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFCairoWindowWorkstationClass
      external NhlFScalarFieldClass
      external NhlFContourPlotClass
      external NhlFMapPlotClass
      parameter(NLAT=91, NLON=181)
C
C Declare variables for the HLU routine calls.
C
      integer appid, wid, cn, ice, mp, srlist, sst
C
C Declare variables for contour plot fills.
C
      integer fillcolors(17)
      data fillcolors/2,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1/
C
C Declare variables for Tick Mark values.
C
      real xbvalues(13),ylvalues(7)
      character*4 xblabels(13)
      character*3 yllabels(7)
      data xbvalues/30,60,90,120,150,180,210,240,270,300,330,360,390/
      data xblabels/'30E','60E','90E','120E','150E','180','150W',
     +     '120W','90W','60W','30W','0','30E'/
      data ylvalues/-90, -60,-30,0,30,60,90/
      data yllabels/'90S','60S','30S','0','30N','60N','90N'/
C
C Define data variables.
C
      real sstjan(NLON,NLAT), sstshft(NLON,NLAT)
C
C Declare variables for getting information from netCDF file.
C
      integer  ncid, lon_id, lat_id, stid
      real lat(NLAT)
      integer start(3), count(3), lonlen, latlen
      character*256 filename
      character*50 recname
      character*7  wks_type
C
C Default is to create an X11 window.
C
      wks_type = "x11"

C
C Initialize the HLU library and set up resource template.
C A resource file is not used in this example, but if you did
C want one, it would be called "cn16.res".
C
      call NhlFInitialize
      call NhlFRLCreate(srlist,'setrl')
      call NhlFRLClear(srlist)
      call NhlFRLSetString(srlist,'appDefaultParent','True',ierr)
      call NhlFRLSetString(srlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'cn16',NhlFAppClass,0,srlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkMetaName','./cn16f.ncgm',ierr)
         call NhlFCreate(wid,'cn16Work',
     +        NhlFNcgmWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an XWorkstation object.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkPause','True',ierr)
         call NhlFCreate(wid,'cn16Work',
     +        NhlFCairoWindowWorkstationClass,
     +        0,srlist,ierr)
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PostScript workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkPSFileName','./cn16f.ps',ierr)
         call NhlFCreate(wid,'cn16Work',
     +        NhlFPSWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkPDFFileName','./cn16f.pdf',ierr)
         call NhlFCreate(wid,'cn16Work',
     +        NhlFPDFWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkFileName','./cn16f',ierr)
         call NhlFRLSetString(srlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(wid,'cn16Work',
     +        NhlFCairoPSPDFWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkFileName','./cn16f',ierr)
         call NhlFRLSetString(srlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(wid,'cn16Work',
     +        NhlFCairoImageWorkstationClass,0,srlist,ierr)
      endif
C
C Read NCL created NetCDF file containing U and V wind components.
C
      call gngpat(filename,'data',ierr)
      do 10 i=1,256
         if( filename(i:i).eq.char(0) ) then
            filename(i:i+21)='/cdf/sstdata_netcdf.nc'
            goto 15
         endif
 10   continue
C      
C The second argument to 'ncopn' should be NCNOWRIT, but since we
C can't include 'netcdf.inc', we are using the value '0' instead.
C
 15   ncid = ncopn(filename,0,ierr)
C
C Get the lat/lon dimensions.
C
      lat_id = ncdid(ncid,'latitude',ierr)
      lon_id = ncdid(ncid,'longitude',ierr)
      call ncdinq(ncid,lat_id,recname,latlen,ierr)
      call ncdinq(ncid,lon_id,recname,lonlen,ierr)
C
C Read in lat values from netCDF file.
C
      start(1) = 1
      lat_id = ncvid(ncid,'lat',ierr)
      count(1) = latlen
      call ncvgt(ncid,lat_id,start,count,lat,ierr)
C
C Read in sstdata netCDF file.
C
      stid = ncvid(ncid,'sst',ierr)
      start(1) = 1
      start(2) = 1
      start(3) = 1
      count(1) = lonlen
      count(2) = latlen
      count(3) = 1
      call ncvgt(ncid,stid,start,count,sstjan,ierr)
C
C Close the netCDF file.
C
      call ncclos(ncid,ierr)
C
C The input sea surface temperature array of 0 to 360 longitude is
C shifted to 30E to 390 (30E) by array index manipulation.
C
      do j=1,NLAT
         do i=15,180
            sstshft(i-14,j) = sstjan(i+1,j)
         end do
         do i=165,180
            sstshft(i+1,j) = sstjan(i-164,j)
         end do
      end do
C
C Create an sst ScalarField data object.
C
      count(1) = NLON
      count(2) = NLAT
      call NhlFRLClear(srlist)
      call NhlFRLSetMDFloatArray(srlist,'sfDataArray',sstshft,2,count,
     +     ierr)
      call NhlFRLSetFloat(srlist,'sfXCStartV',30.,ierr)
      call NhlFRLSetFloat(srlist,'sfXCEndV',390.,ierr)
      call NhlFRLSetFloat(srlist,'sfYCStartV',lat(1),ierr)
      call NhlFRLSetFloat(srlist,'sfYCEndV',lat(latlen),ierr)
      call NhlFCreate(sst,'sf',NhlFscalarFieldClass,appid,srlist,
     +     ierr)
C
C Create a ContourPlot object.
C
      call NhlFRLClear(srlist)
      call NhlFRLSetInteger(srlist,'cnScalarFieldData',sst,ierr)
      call NhlFRLSetFloat(srlist,'vpXF',.10,ierr)
      call NhlFRLSetFloat(srlist,'vpYF',.80,ierr)
      call NhlFRLSetFloat(srlist,'vpWidthF',.80,ierr)
      call NhlFRLSetFloat(srlist,'vpHeightF',.40,ierr)
      call NhlFRLSetString(srlist,'cnInfoLabelOn','False',ierr)
      call NhlFRLSetString(srlist,'cnHighLabelsOn','False',ierr)
      call NhlFRLSetString(srlist,'cnLowLabelsOn','False',ierr)
      call NhlFRLSetString(srlist,'cnMonoLineColor','False',ierr)
      call NhlFRLSetString(srlist,'cnLineDrawOrder','predraw',ierr)
      call NhlFRLSetString(srlist,'cnFillDrawOrder','predraw',ierr)
      call NhlFRLSetString(srlist,'cnLabelDrawOrder','predraw',ierr)
      call NhlFRLSetInteger(srlist,'cnLineLabelInterval',2,ierr)
      call NhlFRLSetString(srlist,'cnLineLabelPlacementMode','computed',
     +     ierr)
      call NhlFRLSetString(srlist,'tiMainOn','True',ierr)
      call NhlFRLSetString(srlist,'tiMainString',
     +     'STR:: JANUARY SST CLIMATOLOGY',ierr)
      call NhlFRLSetFloat(srlist,'tiMainFontHeightF',.020,ierr)
      call NhlFRLSetInteger(srlist,'tiMainFont',25,ierr)
      call NhlFRLSetString(srlist,'tmXBMode','EXPLICIT',ierr)
      call NhlFRLSetString(srlist,'tmYLMode','EXPLICIT',ierr)
      call NhlFRLSetFloatArray(srlist,'tmXBValues',xbvalues,13,ierr)
      call NhlFRLSetStringArray(srlist,'tmXBLabels',xblabels,13,ierr)
      call NhlFRLSetFloatArray(srlist,'tmYLValues',ylvalues,7,ierr)
      call NhlFRLSetStringArray(srlist,'tmYLLabels',yllabels,7,ierr)
      call NhlFRLSetString(srlist,'tmXTLabelsOn','True',ierr)
      call NhlFRLSetString(srlist,'tmYRLabelsOn','True',ierr)
      call NhlFRLSetFloat(srlist,'tmXBLabelFontHeightF',.015,ierr)
      call NhlFRLSetFloat(srlist,'tmYLLabelFontHeightF',.015,ierr)
      call NhlFRLSetFloat(srlist,'tmXBMajorOutwardLengthF',.006,ierr)
      call NhlFRLSetFloat(srlist,'tmXBMajorLengthF',.006,ierr)
      call NhlFRLSetFloat(srlist,'tmYLMajorOutwardLengthF',.006,ierr)
      call NhlFRLSetFloat(srlist,'tmYLMajorLengthF',.006,ierr)
      call NhlFRLSetString(srlist,'tmXBMinorOn','False',ierr)
      call NhlFRLSetString(srlist,'tmXTMinorOn','False',ierr)
      call NhlFRLSetString(srlist,'tmYLMinorOn','False',ierr)
      call NhlFRLSetString(srlist,'tmYRMinorOn','False',ierr)
      call NhlFCreate(cn,'cn',NhlFcontourPlotClass,wid,srlist,ierr)
C
C The ice field is added as a raster contour.  Areas without ice
C are colored transparent.
C
      cellsize = .8/360.
      call NhlFRLClear(srlist)
      call NhlFRLSetInteger(srlist,'cnScalarFieldData',sst,ierr)
      call NhlFRLSetFloat(srlist,'vpXF',.10,ierr)
      call NhlFRLSetFloat(srlist,'vpYF',.80,ierr)
      call NhlFRLSetFloat(srlist,'vpWidthF',.80,ierr)
      call NhlFRLSetFloat(srlist,'vpHeightF',.40,ierr)
      call NhlFRLSetString(srlist,'tmXBOn','False',ierr)
      call NhlFRLSetString(srlist,'tmYLOn','False',ierr)
      call NhlFRLSetString(srlist,'tmXBMinorOn','False',ierr)
      call NhlFRLSetString(srlist,'tmYLMinorOn','False',ierr)
      call NhlFRLSetString(srlist,'tmXBLabelsOn','False',ierr)
      call NhlFRLSetString(srlist,'tmYLLabelsOn','False',ierr)
      call NhlFRLSetString(srlist,'tiMainOn','False',ierr)
      call NhlFRLSetFloat(srlist,'tmXBMajorLengthF',0.,ierr)
      call NhlFRLSetFloat(srlist,'tmYLMajorLengthF',0.,ierr)
      call NhlFRLSetString(srlist,'cnFillOn','True',ierr)
      call NhlFRLSetString(srlist,'cnFillMode','RasterFill',ierr)
      call NhlFRLSetFloat(srlist,'cnRasterCellSizeF',cellsize,ierr)
      call NhlFRLSetFloat(srlist,'cnMinLevelValF',-2.0,ierr)
      call NhlFRLSetIntegerArray(srlist,'cnFillColors',fillcolors,17,
     +     ierr)
      call NhlFRLSetString(srlist,'cnLineLabelsOn','False',ierr)
      call NhlFRLSetString(srlist,'cnLinesOn','False',ierr)
      call NhlFRLSetString(srlist,'cnMonoFillColor','False',ierr)
      call NhlFRLSetString(srlist,'cnInfoLabelOn','False',ierr)
      call NhlFRLSetString(srlist,'cnHighLabelsOn','False',ierr)
      call NhlFCreate(ice,'ice',nhlfcontourplotclass,wid,srlist,ierr)
C
C Create a MapPlot object.
C
      call NhlFRLClear(srlist)
      call NhlFRLSetFloat(srlist,'vpXF',.10,ierr)
      call NhlFRLSetFloat(srlist,'vpYF',.80,ierr)
      call NhlFRLSetFloat(srlist,'vpWidthF',.80,ierr)
      call NhlFRLSetFloat(srlist,'vpHeightF',.40,ierr)
      call NhlFRLSetString(srlist,'mpFillOn','True',ierr)
      call NhlFRLSetString(srlist,'mpLabelsOn','False',ierr)
      call NhlFRLSetInteger(srlist,'mpDefaultFillColor',11,ierr)
      call NhlFRLSetInteger(srlist,'mpLandFillColor',11,ierr)
      call NhlFRLSetString(srlist,'mpOutlineOn','False',ierr)
      call NhlFRLSetString(srlist,'mpAreaMaskingOn','True',ierr)
      call NhlFRLSetString(srlist,'mpMaskAreaSpecifiers','Oceans',ierr)
      call NhlFRLSetString(srlist,'mpGridAndLimbOn','False',ierr)
      call NhlFRLSetString(srlist,'mpLimitMode','latlon',ierr)
      call NhlFRLSetFloat(srlist,'mpMinLonF',30.,ierr)
      call NhlFRLSetFloat(srlist,'mpMaxLonF',390.,ierr)
      call NhlFRLSetFloat(srlist,'mpCenterLonF',210.,ierr)
      call NhlFCreate(mp,'mp',nhlfmapplotclass,wid,srlist,ierr)
C
C Draw everything and clean up.
C
      call NhlFDraw(ice,ierr)
      call NhlFDraw(cn,ierr)
      call NhlFDraw(mp,ierr)
      call NhlFFrame(wid,ierr)
      call NhlFDestroy(wid,ierr)
      call NhlFClose
      stop
      end

C
C       $Id: gerlog.f,v 1.9 2008-07-27 00:20:57 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GERLOG(ERRNR,FCTID,ERRFIL)
C
C  ERROR LOGGING
C
      include 'gkscom.h'
C
      INTEGER ERRNR,FCTID,ERRFIL
      CHARACTER*210 REMSG
      CHARACTER*6  IFMT
C
      SAVE
C
C  Write the first line of the GKS error message to the error file.
C
      WRITE(ERRFIL,700) ERRNR,GNAM(FCTID+1)
  700 FORMAT(' GKS ERROR NUMBER',I5,' ISSUED FROM SUBROUTINE ',A6,':')
C
C  Retrieve the error message string.
C
      CALL GZGTE2(ERRNR,REMSG)
C
C  Get the length of the error message.
C
      DO 30 J=210,1,-1
        IF (REMSG(J:J) .NE. ' ') THEN
          LENMSG = J
          GO TO 40
        ENDIF
   30 CONTINUE
      LENMSG = 1
   40 CONTINUE
C
C  Write out the error message.
C
      WRITE(IFMT,500) LENMSG
  500 FORMAT('(A',I3,')')
      WRITE(ERRFIL,IFMT) REMSG(1:LENMSG)
C
      RETURN
      END

C NCLFORTSTART
      subroutine wksmooth121 (vv,vn,nn,spv,dum)
      implicit none
      integer nn,vn
      double precision vv(vn), spv, dum(vn)
C NCLEND

c Smooths vv by passing it through a 1-2-1 filter.
c The first and last points are given 3-1 (1st) or 1-3 (last)
c weightings (Note that this conserves the total sum).
c The routine also skips-over missing data (spv)
c There are 'nn' pieces of useful information, which may be less
c than or equal to 'vn'.
  
      integer i

      i = 0
 10   continue
      i = i+1
      if (vv(i).eq.spv) then
          dum(i) = spv
      elseif(i.eq.1) then
          if(vv(i+1).ne.spv) then
             dum(i) = (3.0d0*vv(i)+vv(i+1))/4.0d0
          else
             dum(i) = vv(i)
          end if
      elseif(vv(i-1).eq.spv) then
          if(vv(i+1).ne.spv) then
             dum(i) = (3.0d0*vv(i)+vv(i+1))/4.0d0
          else
             dum(i) = vv(i)
          end if
      elseif(i.eq.nn.or.vv(i+1).eq.spv) then
          if(vv(i-1).ne.spv) then
             dum(i) = (vv(i-1)+3.0d0*vv(i))/4.0d0
          else
             dum(i) = vv(i)
          end if
      else
           dum(i) = (1.0d0*vv(i-1)+2.0d0*vv(i)+1.0d0*vv(i+1))/4.0d0
      end if
      if (i.ne.nn) go to 10

      do i = 1,nn
         vv(i) = dum(i)
      enddo
      end

C NCLFORTSTART
       subroutine wktapertozero(ts,N,nmi,nn,tp)
       implicit none
       integer  N, nmi, nn, tp
       double precision ts(N)
C NCLEND


c "taper" the first and last 'tp' members of 'ts' by multiplication by
c a segment of the cosine curve so that the ends of the series
c taper toward zero. This satisfies the
c periodic requirement of the FFT.
c Only the data from nmi to nmi+nn-1 is deemed useful, and
c the rest is set to zero. (There are nn points of useful data)
       integer i,j
       double precision Pi
c c c  parameter (Pi = 3.1415926)   !tp is number to taper on each end.

       Pi = 4.0d0*atan(1.0d0)

       if (N.lt.25.or.nn.lt.25) then
        print*,'wktapertozero: No tapering if less than 25 values!'
c c c   STOP
        return
       end if
       if (nmi+nn-1.gt.N) then
        print*,'wktapertozero: ERROR as nmi+nn-1 > N'
        STOP
       end if

       do i = 1,N
        j = i-nmi+1
        if (j.le.0.or.j.gt.nn) then
         ts(i) = 0.0d0
        elseif (j.le.tp) then
         ts(i) =  ts(i)*0.5d0*(1.0d0-COS((j-1)*Pi/dble(tp)))
        elseif (j.gt.(nn-tp).and.j.le.nn) then
         ts(i) =  ts(i)*0.5d0*(1.0d0-COS((nn-j)*Pi/dble(tp)))
        else
         ts(i) =  ts(i)
        end if
       enddo

       return
       end

C NCLFORTSTART
       subroutine wkdetrend(X2,nx,vmi,nv)
       implicit none
       integer  nx, nv, vmi
       double precision X2(nx)
C NCLEND

c Removes the linear-squares best fit line for the series.
c Only the data from vmi to vmi+nv-1 is deemed useful, and
c the rest is zeroed. (There are nv points of useful data)
c The line of best fit is given by X2'  =  a + bX1.
c The X1s are assumed to be evenly spaced ( i.e. X1 = dble(i) )
c
c m1  =  mean of X1
c m2  =  mean of X2
c m3  =  mean of (X1*X2)
c m4  =  mean of (X1*X1)
c m5  =  mean of (X2*X2)

       integer i
       real m1,m2,m3,m4,m5,r,a,b

       if (vmi+nv-1.gt.nx) then
        print*,'wkdtrend:ERROR as vmi+nv-1 > nx'
        STOP
       end if

       m1 = 0.0d0
       m2 = 0.0d0
       m3 = 0.0d0
       m4 = 0.0d0
       m5 = 0.0d0

       do i = vmi,vmi+nv-1
        m1  =  m1+dble(i)/dble(nv)
        m2  =  m2+X2(i)/dble(nv)
        m3  =  m3+(dble(i)*X2(i))/dble(nv)
        m4  =  m4+(dble(i)*dble(i))/dble(nv)
        m5  =  m5+(X2(i)*X2(i))/dble(nv)
       end do   

       r = (m3-m1*m2)/(sqrt(m4-m1**2)*sqrt(m5-m2**2))
       b = (m3-m1*m2)/(m4-m1**2)
       a = m2-b*m1

       do i = vmi,vmi+nv-1
        X2(i)  =  X2(i) - (a + b*dble(i))
       end do
c      print*,'Trend line has a = ',a,' b = ',b

       if (vmi.gt.1) then
           do i = 1,vmi-1
              X2(i)  =  0.0d0
           end do   
       end if
       if (vmi+nv.le.nx) then
           do i = vmi+nv,nx
              X2(i) =  0.0d0
           end do 
       end if

       return
       end              

      PROGRAM CTISC2
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.  Use one
C of the following:
C
C       PARAMETER (IERF=6,LUNI=2,IWTY=1 ,IWID=1)  !  NCGM
C       PARAMETER (IERF=6,LUNI=2,IWTY=8 ,IWID=1)  !  X Windows
C       PARAMETER (IERF=6,LUNI=2,IWTY=20,IWID=1)  !  PostScript
C       PARAMETER (IERF=6,LUNI=2,IWTY=11,IWID=1)  !  PDF, Portrait
C       PARAMETER (IERF=6,LUNI=2,IWTY=12,IWID=1)  !  PDF, Landscape
C
        PARAMETER (IERF=6,LUNI=2,IWTYPE=1,IWTY=IWTYPE,IWID=1)
C
C The object of this program is to produce a set of plots illustrating
C the use of a triangular mesh to represent an ISCCP grid on the surface
C of the globe.  The original rectangular grid is of a different nature
C than others: each of 72 latitude bands of equal width is cut into just
C enough pieces so that each of the pieces will have about the same area
C on the globe.  The resulting 6596 little pieces, each of which is a
C rectangle in lat/lon space, form a sort of tiling of the sphere.  The
C triangular mesh is created by using the center points of the pieces as
C vertices and connecting adjacent vertices to form edges which form
C triangles.
C
C Selected frames are drawn for each of four different viewpoints.  If
C (CLAT,CLON) is the approximate position of the "center point" of the
C mesh (which is defined somewhat arbitrarily for this mesh), the four
C viewpoints used are as follows: (CLAT+45,CLON), (CLAT-45,CLON),
C (CLAT+45,CLON+180), and (CLAT-45,CLON+180).
C
C At each of the four viewpoints, up to five different frames are drawn:
C
C   1) A frame showing the original rectangular grid on the globe.
C      This frame is drawn only if the parameter IMSH = 1 or 3.
C
C   2) A frame showing the triangular mesh on the globe.  This frame
C      is drawn only if the parameter IMSH = 2 or 3.
C
C   3) A frame showing simple contours on the globe.  This frame is
C      drawn only if the parameter ICON is non-zero.
C
C   4) A frame showing color-filled contour bands on the globe, drawn
C      using filled areas.  This frame is drawn only if the parameter
C      ICOL is non-zero.
C
C   5) A frame showing color-filled contour bands on the globe, drawn
C      using a cell array.  This frame is drawn only if the parameter
C      ICAP is non-zero.
C
C Define the parameter that says which frames showing the rectangular
C grid and/or the triangular mesh are to be drawn (frames 1 and 2):
C
C       PARAMETER (IMSH=0)  !  neither grid nor mesh
C       PARAMETER (IMSH=1)  !  simple rectangular grid only
C       PARAMETER (IMSH=2)  !  triangular mesh only
C       PARAMETER (IMSH=3)  !  both
C
        PARAMETER (IMSH=3)
C
C Define the parameter that says whether or not to draw simple contours
C (frame 3):
C
C       PARAMETER (ICON=0)  !  contours not drawn
C       PARAMETER (ICON=1)  !  contours drawn
C
        PARAMETER (ICON=1)
C
C Define the parameter that says whether or not to draw color-filled
C contours (frame 4):
C
C       PARAMETER (ICOL=0)  !  no color fill done
C       PARAMETER (ICOL=1)  !  color fill done
C
        PARAMETER (ICOL=1)
C
C Define the parameter that says whether or not to draw a cell array
C plot (frame 5):
C
C       PARAMETER (ICAP=0)  !  cell array plot not drawn
C       PARAMETER (ICAP=1)  !  cell array plot drawn
C
        PARAMETER (ICAP=1)
C
C To represent the triangular mesh, we use three singly-dimensioned
C arrays: RPNT holds points, IEDG holds edges, and ITRI holds triangles.
C The elements of each array form "nodes" having lengths as follows:
C
        PARAMETER (LOPN=5)
C
C The five elements of a point node are
C
C   1. the X coordinate of the point;
C   2. the Y coordinate of the point;
C   3. the Z coordinate of the point;
C   4. the field value at the point;
C   5. any additional value desired by the user.
C
        PARAMETER (LOEN=5)
C
C The five elements of an edge node are
C
C   1. the base index, in RPNT, of point 1 of the edge;
C   2. the base index, in RPNT, of point 2 of the edge;
C   3. the index, in ITRI, of the pointer to the edge in the triangle to
C      the left of the edge (-1 if there is no triangle to the left);
C   4. the index, in ITRI, of the pointer to the edge in the triangle to
C      the right of the edge (-1 if there is no triangle to the right);
C   5. a utility flag for use by algorithms that scan the structure.
C
C The "left" and "right" sides of an edge are defined as they would be
C by an observer standing on the globe at point 1 of the edge, looking
C toward point 2 of the edge.  It is possible, if there are "holes" in
C the mesh, that there will be no triangle to the left or to the right
C of an edge, but there must be a triangle on one side or the other.
C
        PARAMETER (LOTN=4)
C
C The four elements of a triangle node are
C
C   1. the base index, in IEDG, of edge 1 of the triangle;
C   2. the base index, in IEDG, of edge 2 of the triangle;
C   3. the base index, in IEDG, of edge 3 of the triangle;
C   4. a flag set non-zero to block use of the triangle, effectively
C      removing it from the mesh.  Play with the setting of the
C      parameter ISCP (which see, below) to get examples of the use
C      of this feature.
C
C The "base index" of a point node, an edge node, or a triangle node is
C always a multiple of the length of the node, to which can be added an
C offset to get the index of a particular element of the node.  For
C example, if I is the base index of a triangle of interest, ITRI(I+1)
C is its first element (the base index of its first edge).  Similarly,
C IEDG(ITRI(I+1)+2) is the base index of the second point of the first
C edge of the triangle with base index I, and RPNT(IEDG(ITRI(I+1)+2)+3)
C is the third (Z) coordinate of the second point of the first edge of
C the triangle with base index I.
C
C It is the pointers from the edge nodes back to the triangle nodes that
C allow CONPACKT to navigate the mesh, moving from triangle to triangle
C as it follows a contour line, but these pointers are tricky to define:
C if IPTE is the base index of an edge node and IEDG(IPTE+3) is zero or
C more, saying that there is a triangle to the left of the edge, then
C IEDG(IPTE+3) is the actual index of that element of the triangle node
C that points to the edge node; i.e., ITRI(IEDG(IPTE+3))=IPTE.  The base
C index of the triangle node defining that triangle is IPTT, where
C IPTT=LOTN*((IEDG(IPTE+3)-1)/LOTN), and the index of the pointer to
C the edge within the triangle node is IPTI=IEDG(IPTE+3)-IPTT, so that
C ITRI(IPTT+IPTI)=IPTE.  Similar comments apply to element 4 of an edge
C node, which points into the triangle node defining the triangle to the
C right of the edge.
C
C The numbers of points, edges, and triangles in the triangular mesh
C are as follows (obtained from the print output of a run in which the
C numbers were set larger than this):
C
        PARAMETER (MNOP=6596)
        PARAMETER (MNOE=19782)
        PARAMETER (MNOT=13188)
C
C Once we know how many points, edges, and triangles we're going to use
C (at most), we can set parameters defining the space reserved for the
C triangular mesh:
C
        PARAMETER (MPNT=MNOP*LOPN)
        PARAMETER (MEDG=MNOE*LOEN)
        PARAMETER (MTRI=MNOT*LOTN)
C
C Declare the arrays to hold the point nodes, edge nodes, and triangle
C nodes defining the triangular mesh.
C
        DIMENSION RPNT(MPNT),IEDG(MEDG),ITRI(MTRI)
C
C Declare sort arrays to be used to keep track of where points and
C edges were put in the structure defining the triangular mesh.
C
        DIMENSION IPPP(2,MNOP),IPPE(2,MNOE)
C
C Define a parameter specifying what data to use on the ISCCP grid.  A
C triangle is blocked if and only if more than "n" of its vertices are
C of the type blocked.  For example, when ISCP is 12, "n" is 0, so that
C a triangle is blocked if one or more of its vertices are over land.
C
C       PARAMETER (ISCP=  1) ! ISCCP, topo data, no blocking
C       PARAMETER (ISCP= 21) ! ISCCP, topo data, block ocean, n=0
C       PARAMETER (ISCP=121) ! ISCCP, topo data, block ocean, n=1
C       PARAMETER (ISCP=221) ! ISCCP, topo data, block ocean, n=2
C       PARAMETER (ISCP=  2) ! ISCCP, fractal data, no blocking
C       PARAMETER (ISCP= 12) ! ISCCP, fractal data, block land, n=0 *
C       PARAMETER (ISCP=112) ! ISCCP, fractal data, block land, n=1
C       PARAMETER (ISCP=212) ! ISCCP, fractal data, block land, n=2
C       PARAMETER (ISCP= 22) ! ISCCP, fractal data, block ocean, n=0
C       PARAMETER (ISCP=122) ! ISCCP, fractal data, block ocean, n=1
C       PARAMETER (ISCP=222) ! ISCCP, fractal data, block ocean, n=2 *
C
        PARAMETER (ISCP= 12)
C
C Declare real and integer workspaces needed by CONPACKT.
C
        PARAMETER (LRWK=10000,LIWK=1000)
C
        DIMENSION RWRK(LRWK),IWRK(LIWK)
C
C Declare the area map array needed to do solid fill.
C
        PARAMETER (LAMA=200000)
C
        DIMENSION IAMA(LAMA)
C
C Declare workspace arrays to be used in calls to ARSCAM.
C
        PARAMETER (NCRA=LAMA/10,NGPS=2)
C
        DIMENSION XCRA(NCRA),YCRA(NCRA),IAAI(NGPS),IAGI(NGPS)
C
C Declare arrays in which to generate a cell array picture of the
C data on the triangular mesh.
C
C       PARAMETER (ICAM=1024,ICAN=1024)
        PARAMETER (ICAM= 512,ICAN= 512)
C
        DIMENSION ICRA(ICAM,ICAN)
C
C Declare external the routine that draws masked contour lines.
C
        EXTERNAL DRWMCL
C
C Declare external the routine that does color fill of contour bands.
C
        EXTERNAL DCFOCB
C
C Define a common block in which to keep track of the maximum space used
C in the arrays XCRA and YCRA.
C
        COMMON /COMONA/ MAXN
C
C Define the out-of-range flag.
C
        DATA OORV / 1.E12 /
C
C Define the tension on the splines to be used in smoothing contours.
C
C       DATA T2DS / 0.0 /  !  smoothing off
C       DATA T2DS / 2.5 /  !  smoothing on
C
        DATA T2DS / 0.0 /
C
C Define the distance between points on smoothed contour lines.
C
        DATA RSSL / .002 /
C
C Define the amount of real workspace to be used in drawing contours.
C
        DATA IRWC / 500 /
C
C Define the label-positioning flag.
C
C       DATA ILLP / 0 /  !  no labels
C       DATA ILLP / 1 /  !  dash-package writes labels
C       DATA ILLP / 2 /  !  regular scheme
C       DATA ILLP / 3 /  !  penalty scheme
C
        DATA ILLP / 2 /
C
C Define the high/low search radius.
C
        DATA HLSR / .075 /
C
C Define the high/low label overlap flag.
C
        DATA IHLO / 11 /
C
C Define the hachuring flag, hachure length, and hachure spacing.
C
C       DATA IHCF,HCHL,HCHS /  0 , +.004 , .010 /  !  off
C       DATA IHCF,HCHL,HCHS / +1 , -.004 , .020 /  !  on, all, uphill
C
        DATA IHCF,HCHL,HCHS /  0 , +.004 , .010 /
C
C Define a constant to convert from radians to degrees.
C
        DATA RTOD / 57.2957795130823 /
C
C Read data and generate the required triangular mesh.
C
        PRINT * , ' '
        PRINT * , 'CREATING TRIANGULAR MESH:'
C
        CALL GTISC2 (RPNT,MPNT,NPNT,LOPN,
     +               IEDG,MEDG,NEDG,LOEN,
     +               ITRI,MTRI,NTRI,LOTN,
     +               IPPP,IPPE,ISCP,CLAT,CLON)
C
C Print the number of points, edges, and triangles.
C
        PRINT * , '  NUMBER OF POINTS:    ',NPNT/LOPN
        PRINT * , '  NUMBER OF EDGES:     ',NEDG/LOEN
        PRINT * , '  NUMBER OF TRIANGLES: ',NTRI/LOTN
C
C Write the contents of the point list, the edge list, and the triangle
C list to "fort.11" in a readable form.
C
c       WRITE (11,'(''P'',I8,5F10.4)')
c    +        (I,RPNT(I+1),RPNT(I+2),RPNT(I+3),RPNT(I+4),RPNT(I+5),
c    +                                               I=0,NPNT-LOPN,LOPN)
c       WRITE (11,'(''E'',I8,5I10)')
c    +        (I,IEDG(I+1),IEDG(I+2),IEDG(I+3),IEDG(I+4),IEDG(I+5),
c    +                                               I=0,NEDG-LOEN,LOEN)
c       WRITE (11,'(''T'',I8,4I10)')
c    +        (I,ITRI(I+1),ITRI(I+2),ITRI(I+3),ITRI(I+4),
c    +                                               I=0,NTRI-LOTN,LOTN)
C
C Open GKS.
C
        PRINT * , 'OPENING AND INITIALIZING GKS'
C
        CALL GOPKS (IERF,0)
        CALL GOPWK (IWID,LUNI,IWTY)
        CALL GACWK (IWID)
C
C Turn off the clipping indicator.
C
        CALL GSCLIP (0)
C
C Define a basic set of colors (0 = white, background; 1 = black,
C foreground; 2 = yellow; 3 = magenta; 4 = red; 5 = cyan; 6 = green;
C 7 = blue; 8 = darker light gray; 9 = lighter light gray; 10 = dark
C yellow; 11 = dark gray; 12 = medium gray; 13 = light red, for
C geographic lines; 14 = light blue, for lat/lon lines).
C
        CALL GSCR   (IWID, 0,1.,1.,1.)
        CALL GSCR   (IWID, 1,0.,0.,0.)
        CALL GSCR   (IWID, 2,1.,1.,0.)
        CALL GSCR   (IWID, 3,1.,0.,1.)
        CALL GSCR   (IWID, 4,1.,0.,0.)
        CALL GSCR   (IWID, 5,0.,1.,1.)
        CALL GSCR   (IWID, 6,0.,1.,0.)
        CALL GSCR   (IWID, 7,0.,0.,1.)
        CALL GSCR   (IWID, 8,.5,.5,.5)
        CALL GSCR   (IWID, 9,.8,.8,.8)
        CALL GSCR   (IWID,10,.3,.3,0.)
        CALL GSCR   (IWID,11,.3,.3,.3)
        CALL GSCR   (IWID,12,.5,.5,.5)
        CALL GSCR   (IWID,13,.8,.5,.5)
        CALL GSCR   (IWID,14,.5,.5,.8)
C
C Define 100 colors, associated with color indices 151 through 250, to
C be used for color-filled contour bands and in cell arrays, ranging
C from blue to red.
C
        CALL DFCLRS (IWID,151,250,0.,0.,1.,1.,0.,0.)
C
C Set parameters in the utilities.
C
        PRINT * , 'SETTING PARAMETERS IN CONPACKT, EZMAP, AND PLOTCHAR'
C
C Set the mapping flag.
C
        CALL CTSETI ('MAP - MAPPING FLAG',1)
C
C Set the out-of-range flag value.
C
        CALL CTSETR ('ORV - OUT-OF-RANGE VALUE',OORV)
C
C Turn on the drawing of the mesh edge and set the area identifier for
C areas outside the mesh.
C
        CALL CTSETI ('PAI - PARAMETER ARRAY INDEX',-1)
        CALL CTSETI ('CLU - CONTOUR LEVEL USE FLAG',1)
        CALL CTSETI ('AIA - AREA IDENTIFIER FOR AREA',1001)
C
C Set the area identifier for areas in "out-of-range" areas.
C
C       CALL CTSETI ('PAI',-2)
C       CALL CTSETI ('AIA - AREA IDENTIFIER FOR AREA',1002)
C
C Set the 2D smoother flag.
C
        CALL CTSETR ('T2D - TENSION ON 2D SPLINES',T2DS)
C
C Set the distance between points on smoothed lines.
C
        CALL CTSETR ('SSL - SMOOTHED SEGMENT LENGTH',RSSL)
C
C Set the amount of real workspace to be used in drawing contours.
C
        CALL CTSETI ('RWC - REAL WORKSPACE FOR CONTOURS',IRWC)
C
C Set the label-positioning flag.
C
        CALL CTSETI ('LLP - LINE LABEL POSITIONING FLAG',ILLP)
C
C Set the high/low search radius.
C
        CALL CTSETR ('HLR - HIGH/LOW SEARCH RADIUS',HLSR)
C
C Set the high/low label overlap flag.
C
        CALL CTSETI ('HLO - HIGH/LOW LABEL OVERLAP FLAG',IHLO)
C
C Set the hachuring flag, hachure length, and hachure spacing.
C
        CALL CTSETI ('HCF - HACHURING FLAG',IHCF)
        CALL CTSETR ('HCL - HACHURE LENGTH',HCHL)
        CALL CTSETR ('HCS - HACHURE SPACING',HCHS)
C
C Set the cell array flag.
C
        CALL CTSETI ('CAF - CELL ARRAY FLAG',-1)
C
C Tell CONPACKT not to do its own call to SET, since EZMAP will have
C done it.
C
        CALL CTSETI ('SET - DO-SET-CALL FLAG', 0)
C
C Move the informational label up a little.
C
        CALL CTSETR ('ILY - INFORMATIONAL LABEL Y POSITION',-.005)
C
C Tell EZMAP not to draw the perimeter.
C
        CALL MPSETI ('PE',0)
C
C Tell EZMAP to use solid lat/lon lines.
C
        CALL MPSETI ('DA',65535)
C
C Tell PLOTCHAR to use one of the filled fonts and to outline each
C character.
C
        CALL PCSETI ('FN',25)
        CALL PCSETI ('OF',1)
C
C Tell PLOTCHAR to expect a character other than a colon as the
C function-control signal character.
C
        CALL PCSETC ('FC','|')
C
C Loop through four different viewing angles.
C
        DO 104 IDIR=1,4
C
          PRINT * , ' '
          PRINT * , 'VIEW FROM DIRECTION NUMBER: ',IDIR
C
C Tell EZMAP what projection to use and what its limits are.
C
          IF      (IDIR.EQ.1) THEN
            CALL MAPROJ ('OR',CLAT+45.,CLON,      0.)
          ELSE IF (IDIR.EQ.2) THEN
            CALL MAPROJ ('OR',CLAT-45.,CLON,      0.)
          ELSE IF (IDIR.EQ.3) THEN
            CALL MAPROJ ('OR',CLAT+45.,CLON+180., 0.)
          ELSE IF (IDIR.EQ.4) THEN
            CALL MAPROJ ('OR',CLAT-45.,CLON+180., 0.)
          END IF
C
          CALL MAPSET ('MA',0.,0.,0.,0.)
C
C Initialize EZMAP.
C
          CALL MAPINT
C
C If the rectangular grid and/or the triangular mesh are to be drawn,
C do it.
C
          IF (IMSH.NE.0) THEN
C
            PRINT * , 'DRAWING MESHES'
C
C Simple rectangular grid:
C
            IF (MOD(IMSH,2).NE.0) THEN
C
              PRINT * , '  DRAWING SIMPLE RECTANGULAR GRID'
C
              CALL DSISC2
C
C Label the first frame.
C
              CALL PLCHHQ (CFUX(.03),CFUY(.946),'ISCCP GRID',
     +                                                      .024,0.,-1.)
C
              IF (     IDIR.EQ.1) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 1',
     +                                                      .012,0.,-1.)
              ELSE IF (IDIR.EQ.2) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 2',
     +                                                      .012,0.,-1.)
              ELSE IF (IDIR.EQ.3) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 3',
     +                                                      .012,0.,-1.)
              ELSE IF (IDIR.EQ.4) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 4',
     +                                                      .012,0.,-1.)
              END IF
C
              CALL PLCHHQ (CFUX(.97),CFUY(.950),'ORIGINAL RECTANGULAR GR
     +ID',.012,0.,1.)
C
              CALL PLCHHQ (CFUX(.97),CFUY(.928),
     +                     'Each of the 72 2.5-degree-wide strips',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.908),
     +                     'is cut into just enough pieces so',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.888),
     +                     'as to make all of the pieces',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.868),
     +                     'have approximately the',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.848),
     +                     'same surface area',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.828),
     +                     'on the globe.',
     +                                                       .010,0.,1.)
C
              CALL PLCHHQ (CFUX(.03),CFUY(.084),'Grid is gray.',
     +                                                      .012,0.,-1.)
              CALL PLCHHQ (CFUX(.03),CFUY(.060),'Shorelines are blue.',
     +                                                      .012,0.,-1.)
              CALL PLCHHQ (CFUX(.03),CFUY(.036),'Parallels/meridians are
     + red.',.012,0.,-1.)
C
C Advance the frame.
C
              CALL FRAME
C
            END IF
C
C Triangular mesh (with edges between blocked triangles somewhat fainter
C than the rest):
C
            IF (MOD(IMSH/2,2).NE.0) THEN
C
              PRINT * , '  DRAWING TRIANGULAR MESH'
C
              DO 101 IPTE=0,NEDG-LOEN,LOEN
C
                IFLL=0
C
                IF (IEDG(IPTE+3).GE.0) THEN
                  IF (ITRI(LOTN*((IEDG(IPTE+3)-1)/LOTN)+4).EQ.0) IFLL=1
                END IF
C
                IFLR=0
C
                IF (IEDG(IPTE+4).GE.0) THEN
                  IF (ITRI(LOTN*((IEDG(IPTE+4)-1)/LOTN)+4).EQ.0) IFLR=1
                END IF
C
                IF (IFLL.NE.0.OR.IFLR.NE.0) THEN
                  CALL PLOTIT (0,0,2)
                  CALL GSPLCI (8)
                ELSE
                  CALL PLOTIT (0,0,2)
                  CALL GSPLCI (9)
                END IF
C
                ALAT=RTOD*ASIN(RPNT(IEDG(IPTE+1)+3))
C
                IF (RPNT(IEDG(IPTE+1)+1).EQ.0..AND.
     +              RPNT(IEDG(IPTE+1)+2).EQ.0.) THEN
                  ALON=0.
                ELSE
                  ALON=RTOD*ATAN2(RPNT(IEDG(IPTE+1)+2),
     +                            RPNT(IEDG(IPTE+1)+1))
                END IF
C
                BLAT=RTOD*ASIN(RPNT(IEDG(IPTE+2)+3))
C
                IF (RPNT(IEDG(IPTE+2)+1).EQ.0..AND.
     +              RPNT(IEDG(IPTE+2)+2).EQ.0.) THEN
                  BLON=0.
                ELSE
                  BLON=RTOD*ATAN2(RPNT(IEDG(IPTE+2)+2),
     +                            RPNT(IEDG(IPTE+2)+1))
                END IF
C
                CALL DRSGCR (ALAT,ALON,BLAT,BLON)
C
  101         CONTINUE
C
              CALL PLOTIT (0,0,2)
              CALL GSPLCI (13)
              CALL MAPGRD
              CALL PLOTIT (0,0,2)
              CALL GSPLCI (14)
              CALL MAPLOT
C
C Label the second frame.
C
              CALL PLCHHQ (CFUX(.03),CFUY(.946),'ISCCP GRID',
     +                                                      .024,0.,-1.)
C
              IF (     IDIR.EQ.1) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 1',
     +                                                      .012,0.,-1.)
              ELSE IF (IDIR.EQ.2) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 2',
     +                                                      .012,0.,-1.)
              ELSE IF (IDIR.EQ.3) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 3',
     +                                                      .012,0.,-1.)
              ELSE IF (IDIR.EQ.4) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 4',
     +                                                      .012,0.,-1.)
              END IF
C
              CALL PLCHHQ (CFUX(.97),CFUY(.950),'DERIVED TRIANGULAR MESH
     +',.012,0.,1.)
C
              CALL PLCHHQ (CFUX(.97),CFUY(.928),
     +                     'Vertices are at centers of rectangles.',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.908),
     +                     'Land portions of the mesh are',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.888),
     +                     '"blocked" and are shown',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.868),
     +                     'in very light gray.',
     +                                                       .010,0.,1.)
C
              CALL PLCHHQ (CFUX(.03),CFUY(.084),'Mesh is gray.',
     +                                                      .012,0.,-1.)
              CALL PLCHHQ (CFUX(.03),CFUY(.060),'Shorelines are blue.',
     +                                                      .012,0.,-1.)
              CALL PLCHHQ (CFUX(.03),CFUY(.036),'Parallels/meridians are
     + red.',.012,0.,-1.)
C
C Advance the frame.
C
              CALL FRAME
C
            END IF
C
          END IF
C
C If a frame showing simple contours is to be drawn, do it next (adding
C an overlay of lat/lon lines and continental outlines in light gray).
C
          IF (ICON.NE.0) THEN
C
            PRINT * , 'DRAWING PLOT SHOWING SIMPLE CONTOURS'
C
C Initialize CONPACKT.
C
            PRINT * , 'CALLING CTMESH'
C
            CALL CTMESH (RPNT,NPNT,LOPN,
     +                   IEDG,NEDG,LOEN,
     +                   ITRI,NTRI,LOTN,
     +                   RWRK,LRWK,
     +                   IWRK,LIWK)
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (1)
C
C Proceed as implied by the setting of the label-positioning flag.
C
            IF (ABS(ILLP).EQ.1) THEN
C
C Draw the contour lines with labels generated by the dash package.
C
              PRINT * , 'CALLING CTCLDR'
              CALL CTCLDR (RPNT,IEDG,ITRI,RWRK,IWRK)
C
C Add the informational and high/low labels.
C
              PRINT * , 'CALLING CTLBDR'
              CALL CTLBDR (RPNT,IEDG,ITRI,RWRK,IWRK)
C
            ELSE IF (ABS(ILLP).GT.1) THEN
C
C Create an area map for masking of labels.
C
              MAXN=0
C
              PRINT * , 'CALLING ARINAM'
              CALL ARINAM (IAMA,LAMA)
C
              PRINT * , 'CALLING CTLBAM'
              CALL CTLBAM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA)
C
C Draw the contour lines masked by the area map.
C
              PRINT * , 'CALLING CTCLDM'
              CALL CTCLDM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA,DRWMCL)
C
              PRINT * , '  AREA MAP SPACE REQUIRED:         ',
     +                                         IAMA(1)-IAMA(6)+IAMA(5)+1
C
              PRINT * , '  NUMBER OF POINTS IN LONGEST LINE:',MAXN
C
C Draw all the labels.
C
              PRINT * , 'CALLING CTLBDR'
              CALL CTLBDR (RPNT,IEDG,ITRI,RWRK,IWRK)
C
            END IF
C
            CALL CTGETI ('IWU - INTEGER WORKSPACE USED',IIWU)
            PRINT * , '  INTEGER WORKSPACE REQUIRED:      ',IIWU
C
            CALL CTGETI ('RWU -    REAL WORKSPACE USED',IRWU)
            PRINT * , '  REAL WORKSPACE REQUIRED:         ',IRWU
C
C Add lat/lon lines and continental outlines.
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (13)
            CALL MAPGRD
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (14)
            CALL MAPLOT
C
C Label the third frame.
C
            CALL PLCHHQ (CFUX(.03),CFUY(.946),'ISCCP GRID',.024,0.,-1.)
C
            IF (     IDIR.EQ.1) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 1',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.2) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 2',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.3) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 3',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.4) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 4',
     +                                                      .012,0.,-1.)
            END IF
C
            CALL PLCHHQ (CFUX(.97),CFUY(.950),'SIMPLE CONTOURS ON',
     +                                                       .012,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.926),'TRIANGULAR MESH',
     +                                                       .012,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.904),'Dummy data are used.',
     +                                                       .010,0.,1.)
C
            CALL PLCHHQ (CFUX(.03),CFUY(.060),'Shorelines are blue.',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.036),'Parallels/meridians are r
     +ed.',.012,0.,-1.)
C
C Advance the frame.
C
            CALL FRAME
C
          END IF
C
C If a frame showing color-filled contours is to be drawn, do it next.
C
          IF (ICOL.NE.0) THEN
C
            PRINT * , 'DRAWING PLOT SHOWING COLOR-FILLED CONTOURS'
C
            PRINT * , 'CALLING CTMESH'
C
            CALL CTMESH (RPNT,NPNT,LOPN,
     +                   IEDG,NEDG,LOEN,
     +                   ITRI,NTRI,LOTN,
     +                   RWRK,LRWK,
     +                   IWRK,LIWK)
C
            MAXN=0
C
            PRINT * , 'CALLING CTPKCL'
            CALL CTPKCL (RPNT,IEDG,ITRI,RWRK,IWRK)
C
            PRINT * , 'CALLING ARINAM'
            CALL ARINAM (IAMA,LAMA)
C
            PRINT * , 'CALLING CTCLAM'
            CALL CTCLAM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA)
C
C           PRINT * , 'CALLING CTLBAM'
C           CALL CTLBAM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA)
C
            PRINT * , 'CALLING ARSCAM'
            CALL ARSCAM (IAMA,XCRA,YCRA,NCRA,IAAI,IAGI,NGPS,DCFOCB)
C
            PRINT * , '  SPACE REQUIRED IN AREA MAP:      ',
     +                                         IAMA(1)-IAMA(6)+IAMA(5)+1
C
            PRINT * , '  NUMBER OF POINTS IN LARGEST AREA:',MAXN
C
            CALL CTGETI ('IWU - INTEGER WORKSPACE USED',IIWU)
            PRINT * , '  INTEGER WORKSPACE REQUIRED:      ',IIWU
C
            CALL CTGETI ('RWU -    REAL WORKSPACE USED',IRWU)
            PRINT * , '  REAL WORKSPACE REQUIRED:         ',IRWU
C
            CALL GSFACI (1)
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (13)
            CALL MAPGRD
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (14)
            CALL MAPLOT
C
C Label the fourth frame.
C
            CALL PLCHHQ (CFUX(.03),CFUY(.946),'ISCCP GRID',.024,0.,-1.)
C
            IF (     IDIR.EQ.1) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 1',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.2) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 2',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.3) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 3',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.4) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 4',
     +                                                      .012,0.,-1.)
            END IF
C
            CALL PLCHHQ (CFUX(.97),CFUY(.950),'COLORED CONTOUR BANDS ON'
     +,.012,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.926),'TRIANGULAR MESH',
     +                                                       .012,0.,1.)
C
            CALL PLCHHQ (CFUX(.97),CFUY(.904),'Dummy data are used.',
     +                                                       .010,0.,1.)
C
            CALL PLCHHQ (CFUX(.03),CFUY(.132),'Off-mesh',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.108),'areas of the',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.084),'globe are yellow.',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.060),'Shorelines are blue.',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.036),'Parallels/meridians are r
     +ed.',.012,0.,-1.)
C
C Advance the frame.
C
            CALL FRAME
C
          END IF
C
C If the flag for it is set, do a cell array plot.
C
          IF (ICAP.NE.0) THEN
C
            PRINT * , 'DRAWING CELL-ARRAY PLOT OF DATA VALUES'
C
            PRINT * , 'CALLING CTMESH'
C
            CALL CTMESH (RPNT,NPNT,LOPN,
     +                   IEDG,NEDG,LOEN,
     +                   ITRI,NTRI,LOTN,
     +                   RWRK,LRWK,
     +                   IWRK,LIWK)
C
            CALL GETSET (XVPL,XVPR,YVPB,YVPT,XWDL,XWDR,YWDB,YWDT,LNLG)
C
            PRINT * , 'CALLING CTCICA'
            CALL CTCICA (RPNT,IEDG,ITRI,RWRK,IWRK,ICRA,ICAM,ICAM,ICAN,
     +                                            XVPL,YVPB,XVPR,YVPT)
C
            PRINT * , 'CALLING GCA'
            CALL GCA (XWDL,YWDB,XWDR,YWDT,ICAM,ICAN,1,1,ICAM,ICAN,ICRA)
C
            CALL CTGETI ('IWU - INTEGER WORKSPACE USED',IIWU)
            PRINT * , '  INTEGER WORKSPACE REQUIRED:      ',IIWU
C
            CALL CTGETI ('RWU -    REAL WORKSPACE USED',IRWU)
            PRINT * , '  REAL WORKSPACE REQUIRED:         ',IRWU
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (13)
            CALL MAPGRD
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (14)
            CALL MAPLOT
C
C Label the fifth frame.
C
            CALL PLCHHQ (CFUX(.03),CFUY(.946),'ISCCP GRID',.024,0.,-1.)
C
            IF (     IDIR.EQ.1) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 1',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.2) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 2',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.3) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 3',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.4) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 4',
     +                                                      .012,0.,-1.)
            END IF
C
            CALL PLCHHQ (CFUX(.97),CFUY(.950),'CELL ARRAY DERIVED FROM',
     +                                                       .012,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.926),'TRIANGULAR MESH',
     +                                                       .012,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.904),'Dummy data are used.',
     +                                                       .010,0.,1.)
C
            CALL PLCHHQ (CFUX(.03),CFUY(.132),'Off-mesh',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.108),'areas of the',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.084),'globe are yellow.',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.060),'Shorelines are blue.',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.036),'Parallels/meridians are r
     +ed.',.012,0.,-1.)
C
C Advance the frame.
C
            CALL FRAME
C
          END IF
C
  104   CONTINUE
C
C Close GKS.
C
        CALL GDAWK (IWID)
        CALL GCLWK (IWID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END


      SUBROUTINE DFCLRS (IWID,IOFC,IOLC,REDF,GRNF,BLUF,REDL,GRNL,BLUL)
C
C This routine defines color indices IOFC through IOLC on workstation
C IWID by interpolating values from REDF/GRNF/BLUF to REDL/GRNL/BLUL.
C
        DO 101 I=IOFC,IOLC
          P=REAL(IOLC-I)/REAL(IOLC-IOFC)
          Q=REAL(I-IOFC)/REAL(IOLC-IOFC)
          CALL GSCR (IWID,I,P*REDF+Q*REDL,P*GRNF+Q*GRNL,P*BLUF+Q*BLUL)
  101   CONTINUE
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE DRWMCL (XCRA,YCRA,NCRA,IAAI,IAGI,NGPS)
C
        DIMENSION XCRA(*),YCRA(*),IAAI(*),IAGI(*)
C
C This routine draws the curve defined by the points (XCRA(I),YCRA(I)),
C for I = 1 to NCRA, if and only if none of the area identifiers for the
C area containing the polyline are negative.  It calls either CURVE or
C CURVED to do the drawing, depending on the value of the internal
C parameter 'DPU'.
C
C It keeps track of the maximum value used for NCRA in a common block.
C
        COMMON /COMONA/ MAXN
C
        MAXN=MAX(MAXN,NCRA)
C
C Retrieve the value of the internal parameter 'DPU'.
C
        CALL CTGETI ('DPU - DASH PACKAGE USED',IDUF)
C
C Turn on drawing.
C
        IDRW=1
C
C If any area identifier is negative, turn off drawing.
C
        DO 101 I=1,NGPS
          IF (IAAI(I).LT.0) IDRW=0
  101   CONTINUE
C
C If drawing is turned on, draw the polyline.
C
        IF (IDRW.NE.0) THEN
          IF (IDUF.EQ.0) THEN
            CALL CURVE  (XCRA,YCRA,NCRA)
          ELSE IF (IDUF.LT.0) THEN
            CALL DPCURV (XCRA,YCRA,NCRA)
          ELSE
            CALL CURVED (XCRA,YCRA,NCRA)
          END IF
        END IF
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE DCFOCB (XCRA,YCRA,NCRA,IAAI,IAGI,NGPS)
C
C This routine fills the area defined by the points (XCRA(I),YCRA(I)),
C for I = 1 to NCRA, if and only if none of the area identifiers for
C the area are negative.  The color used is determined from the area
C identifier of the area relative to group 3; it is assumed that 100
C colors are defined having color indices 151 through 250.
C
        DIMENSION XCRA(*),YCRA(*),IAAI(*),IAGI(*)
C
C It keeps track of the maximum value used for NCRA in a common block.
C
        COMMON /COMONA/ MAXN
C
        MAXN=MAX(MAXN,NCRA)
C
C Retrieve the number of contour levels being used.
C
        CALL CTGETI ('NCL - NUMBER OF CONTOUR LEVELS',NOCL)
C
C If the number of contour levels is non-zero and the area has more
C than two points, fill it.
C
        IF (NOCL.NE.0.AND.NCRA.GT.2) THEN
C
          IAI3=-1
C
          DO 101 I=1,NGPS
            IF (IAGI(I).EQ.3) IAI3=IAAI(I)
  101     CONTINUE
C
          IF (IAI3.GE.1.AND.IAI3.LE.NOCL+1) THEN
            CALL GSFACI (151+INT(((REAL(IAI3)-.5)/REAL(NOCL+1))*100.))
            CALL GFA    (NCRA,XCRA,YCRA)
          ELSE IF (IAI3.EQ.1001) THEN
            CALL GSFACI (2)
            CALL GFA    (NCRA,XCRA,YCRA)
          ELSE IF (IAI3.EQ.1002) THEN
            CALL GSFACI (3)
            CALL GFA    (NCRA,XCRA,YCRA)
          END IF
C
        END IF
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE GTISC2 (RPNT,MPNT,NPNT,LOPN,
     +                   IEDG,MEDG,NEDG,LOEN,
     +                   ITRI,MTRI,NTRI,LOTN,
     +                   IPPP,IPPE,IDAT,XLAT,XLON)
C
        DIMENSION RPNT(MPNT),IEDG(MEDG),ITRI(MTRI),IPPP(2,*),IPPE(2,*)
C
C The ISCCP grid is an array of rectangles covering the cylindrical
C equidistant projection of the earth, at each center point of which
C we have latitude and longitude.  At each of the center points, we
C have available a topographic elevation, in meters above sea level.
C We can either use that data or generate dummy data at each of the
C specified center points.
C
C Declare variables to be used to read the ISCCP data.  The variable
C LINE just receives each of 6596 lines of data from the input file.
C
        CHARACTER*64 LINE
C
C Each line of data contains information about one of 6596 rectangular
C boxes on a cylindrical equidistant projection of the globe.  For each
C I from 1 to 6596, ILAT(I) is an integer between 1 and 72, specifying
C which of 72 rows box I is a part of and ILON(I) is an integer greater
C than 1 saying which of the boxes on that row box I is.  VLAT(I) and
C VLON(I) are the latitude and longitude, in degrees, of the center
C point of the box.  ZDAT(I) is a field value that we generate to use
C for test purposes.  ITOP(I) is the topographic height of the box, in
C meters.  For each IROW from 1 to 72, IIOR(IROW) is the index (between
C 1 and 6596) of the first box of the row IROW; NBIR(IROW) is the number
C of boxes on that row.
C
        COMMON /CISCCP/ ILAT(6596),ILON(6596),VLAT(6596),VLON(6596),
     +                  ZDAT(6596),ITOP(6596),IIOR(72),NBIR(72)
C
C For each I from 1 to 6596, XCOV(I), YCOV(I), and ZCOV(I) are the
C computed Cartesian coordinates of vertex I.
C
        DIMENSION XCOV(6596),YCOV(6596),ZCOV(6596)
C
C For each I from 1 to 6596 and for each J from to 1 to NOCP(I),
C CLAT(J,I) and CLON(J,I) are the computed latitude and longitude of
C one of the corner points of the polygonal cell centered at the vertex
C I and IADJ(I,J) is the index of one of the adjoining polygonal cells.
C ISRT is an index array allowing us to order the vertices in such a
C way as to permit efficient searches for adjoining cells.
C
        PARAMETER (MNCP=7)
C
        DIMENSION NOCP(6596),CLAT(MNCP,6596),CLON(MNCP,6596)
        DIMENSION ISRT(6596),IADJ(6596,MNCP)
C
C We make use of a routine (CTTMTL) that allows one to easily create an
C arbitrary triangular mesh.  The "tree-sorts" used by the method are
C very inefficient for objects that are partially ordered, so, as the
C triangles of the mesh are generated, they are stored in a triangle
C buffer from which they can be dumped in random order by calls to the
C routine CTTMTL.  The following declarations create an array to use
C as the buffer for the triangles.  Up to a point, making this buffer
C larger will result in more randomization of the triangles and speed
C up the process.  MBUF is the number of triangles that will fit in the
C buffer at once, and KBUF is the number of those to be dumped whenever
C the buffer is found to be full.  Because the call and loop set-up
C time for CTTMTL are non-trivial, it's better to dump a significant
C number of triangles while you're there, but I'm not sure what value
C might work best.  Use MBUF > KBUF > 1 and play with the values a bit
C to see what causes improvement.  (I tend to use numbers that are
C relatively prime, but I'm not sure if that makes any difference.)
C
        PARAMETER (MBUF=5021,KBUF=173)
C
        DIMENSION TBUF(12,MBUF)
C
C Define needed conversion constants.
C
        DATA DTOR / .017453292519943 /
        DATA RTOD / 57.2957795130823 /
C
C Set a tolerance value used in the code that generates the polygonal
C patches.
C
        DATA EPSI / 1.E-2 /
C
C Initialize the arrays that keep track of the initial index and the
C number of boxes in each of the rows of the ISCCP data.
C
        DO 101 I=1,72
          IIOR(I)=0
          NBIR(I)=0
  101   CONTINUE
C
C Read the data from the ASCII file "ctiscp.dat", adding field data
C values to be associated with the center points of the rectangles.
C
        OPEN (11,FILE='ctiscp.dat',STATUS='OLD',FORM='FORMATTED')
C
C Initialize the dummy-data generator.
C
        IF (MOD(IDAT,10).NE.1) CALL GGDINI (-1.,1.,1234,.4)
C
C Skip the first two lines of the file.
C
        PRINT * , '  READING DATA FILE'
C
        READ (11,'(A64)') LINE
        READ (11,'(A64)') LINE
C
C Read through the rest of the file, saving certain pieces of data.
C For reference, the data look like this:
C
C  GRD LAT LON SQ1 SQ2     LAT      LON      BOX    %   TOPOG  VEG
C  BOX IND IND IND IND   CENTER   CENTER    AREA  LAND HEIGHT TYPE
C    1   1   1   1  48     1.25    60.00   80949   100   2895   8
C    2   1   2  49  96     1.25   180.00   80949   100   2865   8
C    3   1   3  97 144     1.25   300.00   80949   100   2621   8
C    4   2   1   1  16     3.75    20.00   80862   100   2834   8
C    .   .   .   .   .        .        .       .     .      .   .
C    .   .   .   .   .        .        .       .     .      .   .
C    .   .   .   .   .        .        .       .     .      .   .
C
C 6593  71   9 129 144   176.25   340.00   80862     0      0   0
C 6594  72   1   1  48   178.75    60.00   80949     0      0   0
C 6595  72   2  49  96   178.75   180.00   80949     0      0   0
C 6596  72   3  97 144   178.75   300.00   80949     0      0   0
C
        DO 102 I=1,6596
          READ (11,'(A64)') LINE
          READ (LINE,'(3I4,8X,2E9.0,14X,I7)')
     +                         J,ILAT(I),ILON(I),VLAT(I),VLON(I),ITOP(I)
          VLAT(I)=VLAT(I)-90.
          XCOV(I)=COS(DTOR*VLAT(I))*COS(DTOR*VLON(I))
          YCOV(I)=COS(DTOR*VLAT(I))*SIN(DTOR*VLON(I))
          ZCOV(I)=SIN(DTOR*VLAT(I))
          IF (J.NE.I) THEN
            PRINT * , '  GTISC2 - STOP - DATA FILE CORRUPTED?'
            STOP
          END IF
          IF (MOD(IDAT,10).EQ.1) THEN
            ZDAT(I)=REAL(ITOP(I))
          ELSE
            ZDAT(I)=GGDPNT(VLAT(I),VLON(I))
          END IF
          IF (IIOR(ILAT(I)).EQ.0) IIOR(ILAT(I))=I
          NBIR(ILAT(I))=NBIR(ILAT(I))+1
  102   CONTINUE
C
        CLOSE (11)
C
C Recompute the longitudes of the box centers.
C
        PRINT * , '  RECOMPUTING LONGITUDES'
C
        DO 103 I=1,6596
          VLON(I)=360.*(REAL(ILON(I))-.5)/REAL(NBIR(ILAT(I)))
  103   CONTINUE
C
C Define the polygonal patches surrounding each of the vertices.
C
        PRINT * , '  DEFINING POLYGONAL PATCHES'
C
        DO 106 I=1,6596
          SLCR=VLON(I)-180./REAL(NBIR(ILAT(I)))
          ELCR=VLON(I)+180./REAL(NBIR(ILAT(I)))
          NOCP(I)=0
          IF (ILAT(I).GT.1) THEN
            IF (NOCP(I).GE.MNCP) GO TO 901
            NOCP(I)=NOCP(I)+1
            CLAT(NOCP(I),I)=VLAT(I)-1.25
            CLON(NOCP(I),I)=SLCR
            DO 104 J=IIOR(ILAT(I)-1),
     +               IIOR(ILAT(I)-1)+NBIR(ILAT(I)-1)-1,
     +               1
              SLLR=VLON(J)-180./REAL(NBIR(ILAT(I)-1))
              ELLR=VLON(J)+180./REAL(NBIR(ILAT(I)-1))
              IF (SLLR.GT.SLCR-EPSI.AND.SLLR.LT.ELCR-EPSI) THEN
                IF (NOCP(I).GE.MNCP) GO TO 901
                NOCP(I)=NOCP(I)+1
                CLAT(NOCP(I),I)=VLAT(I)-1.25
                CLON(NOCP(I),I)=MAX(SLCR,MIN(ELCR,SLLR))
              END IF
  104       CONTINUE
          END IF
          IF (NOCP(I).GE.MNCP) GO TO 901
          NOCP(I)=NOCP(I)+1
          CLAT(NOCP(I),I)=VLAT(I)-1.25
          CLON(NOCP(I),I)=ELCR
          IF (ABS(CLAT(NOCP(I),I)+ 90.).LT.EPSI) CLON(NOCP(I),I)=0.
          IF (ABS(CLON(NOCP(I),I)-360.).LT.EPSI) CLON(NOCP(I),I)=0.
          IF (NOCP(I).GE.MNCP) GO TO 901
          NOCP(I)=NOCP(I)+1
          CLAT(NOCP(I),I)=VLAT(I)+1.25
          CLON(NOCP(I),I)=ELCR
          IF (ABS(CLAT(NOCP(I),I)- 90.).LT.EPSI) CLON(NOCP(I),I)=0.
          IF (ABS(CLON(NOCP(I),I)-360.).LT.EPSI) CLON(NOCP(I),I)=0.
          IF (ILAT(I).LT.72) THEN
            DO 105 J=IIOR(ILAT(I)+1)+NBIR(ILAT(I)+1)-1,
     +               IIOR(ILAT(I)+1),
     +               -1
              SLNR=VLON(J)-180./REAL(NBIR(ILAT(I)+1))
              ELNR=VLON(J)+180./REAL(NBIR(ILAT(I)+1))
              IF (ELNR.GT.SLCR+EPSI.AND.ELNR.LT.ELCR+EPSI) THEN
                IF (NOCP(I).GE.MNCP) GO TO 901
                NOCP(I)=NOCP(I)+1
                CLAT(NOCP(I),I)=VLAT(I)+1.25
                CLON(NOCP(I),I)=MAX(SLCR,MIN(ELCR,ELNR))
                IF (CLON(NOCP(I),I).GT.360.-EPSI) CLON(NOCP(I),I)=0.
              END IF
  105       CONTINUE
            IF (NOCP(I).GE.MNCP) GO TO 901
            NOCP(I)=NOCP(I)+1
            CLAT(NOCP(I),I)=VLAT(I)+1.25
            CLON(NOCP(I),I)=SLCR
          END IF
  106   CONTINUE
C
C Write some debug stuff for "Debug1.f" to read.
C
c       WRITE (11,*) NOCP
c       WRITE (11,*) CLAT
c       WRITE (11,*) CLON
C
c       PRINT * , '  DEBUG INFO WRITTEN'
C
C Set up the adjacency index array.  We order the polygonal patches by
C latitude, making it possible to look for matching edges in nearby
C polygonal patches first.  (If we're trying to find a match for a
C side of the Ith polygonal patch (sorted order), we look at polygonal
C patches for IC = I+1, I-1, I+2, I-2, and so on, until we find the one
C we want.  If IC becomes less than 1 or greater than 6596, we just
C finish out the rest of the list by stepping through the remaining
C elements on the opposite end of it; IM implements the logic to manage
C this.
C
        PRINT * , '  GETTING SORTED INDEX ARRAY'
C
        CALL CTSORT (VLAT,6596,ISRT)
C
        PRINT * , '  SETTING UP ADJACENCY ARRAY'
C
        NOZP=0
C
        DO 110 I=1,6596
          DO 109 J=1,NOCP(ISRT(I))
            JM1=MOD(J+NOCP(ISRT(I))-2,NOCP(ISRT(I)))+1
            IC=I
            IM=0
            DO 108 K=1,6595
              IF (IM.EQ.0) THEN
                IF (MOD(K,2).EQ.0) THEN
                  IC=IC-K
                  IF (IC.LT.1) THEN
                    IC=IC+K+1
                    IM=+1
                  END IF
                ELSE
                  IC=IC+K
                  IF (IC.GT.6596) THEN
                    IC=IC-K-1
                    IM=-1
                  END IF
                END IF
              ELSE
                IC=IC+IM
              END IF
              DO 107 L=1,NOCP(ISRT(IC))
                LP1=MOD(L,NOCP(ISRT(IC)))+1
                IF (ABS(CLAT(J  ,ISRT(I ))-
     +                  CLAT(L  ,ISRT(IC))).LT.EPSI.AND.
     +              ABS(CLON(J  ,ISRT(I ))-
     +                  CLON(L  ,ISRT(IC))).LT.EPSI.AND.
     +              ABS(CLAT(JM1,ISRT(I ))-
     +                  CLAT(LP1,ISRT(IC))).LT.EPSI.AND.
     +              ABS(CLON(JM1,ISRT(I ))-
     +                  CLON(LP1,ISRT(IC))).LT.EPSI) THEN
                  IADJ(ISRT(I),J)=ISRT(IC)
                  GO TO 109
                END IF
  107         CONTINUE
  108       CONTINUE
            IADJ(ISRT(I),J)=0
            NOZP=NOZP+1
  109     CONTINUE
  110   CONTINUE
C
        IF (NOZP.NE.0) PRINT * , '  NUMBER OF ZERO POINTERS IS ',NOZP
C
C Write some debug stuff for "Debug2.f" to read.
C
c       WRITE (11,*) NOCP
c       WRITE (11,*) VLAT
c       WRITE (11,*) VLON
c       WRITE (11,*) IADJ
C
c       PRINT * , '  DEBUG INFO WRITTEN'
C
C Write some debug stuff for "Debug3.f" to read.
C
c       WRITE (11,*) VLAT
c       WRITE (11,*) VLON
c       WRITE (11,*) NOCP
c       WRITE (11,*) CLAT
c       WRITE (11,*) CLON
c       WRITE (11,*) IADJ
C
c       PRINT * , '  DEBUG INFO WRITTEN'
C
C Build structures forming the triangular mesh.  First, initialize the
C variables used to keep track of items in the sort arrays for points
C and edges, in the triangle buffer, and in the triangle list.
C
        PRINT * , '  BUILDING THE TRIANGULAR MESH'
C
        MPPP=MPNT/LOPN
        NPPP=0
C
        MPPE=MEDG/LOEN
        NPPE=0
C
        NBUF=0
C
        NTRI=0
C
C Loop through the vertices of the grid.
C
        DO 112 I=1,6596
C
C Set the index of vertex 1 of the triangle.
C
          IOV1=I
C
C Examine all of the triangles meeting at vertex IOV1, taking into
C account that the vertices are given in counterclockwise order.
C
          DO 111 J=1,NOCP(I)
C
            JP1=MOD(J,NOCP(I))+1
C
C Set the indices of vertices 2 and 3 of the triangle.
C
            IOV2=IADJ(I,J)
            IOV3=IADJ(I,JP1)
            if (iov2.eq.0.or.iov3.eq.0) go to 111
C
C Process a triangle only if the index of the 1st vertex is less than
C the indices of the other two vertices.  This will ensure that each
C triangle is processed only once, even though we see it three times.
C
            IF (IOV1.LT.IOV2.AND.IOV1.LT.IOV3) THEN
C
C If the triangle buffer is full, dump a few randomly-chosen triangles
C from it to make room for the new one.
C
              IF (NBUF.EQ.MBUF) THEN
                CALL CTTMTL (KBUF,TBUF,MBUF,NBUF,
     +                       IPPP,MPPP,NPPP,
     +                       IPPE,MPPE,NPPE,
     +                       RPNT,MPNT,NPNT,LOPN,
     +                       IEDG,MEDG,NEDG,LOEN,
     +                       ITRI,MTRI,NTRI,LOTN)
              END IF
C
C Put the new triangle in the triangle buffer.  For the "data", use the
C real equivalent of an index that will later allow us to fill in the
C appropriate data values and determine which triangles are blocked.
C
              NBUF=NBUF+1
C
              TBUF( 1,NBUF)=XCOV(IOV1)
              TBUF( 2,NBUF)=YCOV(IOV1)
              TBUF( 3,NBUF)=ZCOV(IOV1)
              TBUF( 4,NBUF)=REAL(IOV1)
C
              TBUF( 5,NBUF)=XCOV(IOV2)
              TBUF( 6,NBUF)=YCOV(IOV2)
              TBUF( 7,NBUF)=ZCOV(IOV2)
              TBUF( 8,NBUF)=REAL(IOV2)
C
              TBUF( 9,NBUF)=XCOV(IOV3)
              TBUF(10,NBUF)=YCOV(IOV3)
              TBUF(11,NBUF)=ZCOV(IOV3)
              TBUF(12,NBUF)=REAL(IOV3)
C
            END IF
C
  111     CONTINUE
C
  112   CONTINUE
C
C Output all triangles remaining in the buffer.
C
        IF (NBUF.NE.0) THEN
          CALL CTTMTL (NBUF,TBUF,MBUF,NBUF,
     +                 IPPP,MPPP,NPPP,
     +                 IPPE,MPPE,NPPE,
     +                 RPNT,MPNT,NPNT,LOPN,
     +                 IEDG,MEDG,NEDG,LOEN,
     +                 ITRI,MTRI,NTRI,LOTN)
        END IF
C
C Set the pointers that tell the caller how many points and edges were
C created.
C
        NPNT=NPPP*LOPN
        NEDG=NPPE*LOEN
C
C Determine which triangles should be blocked and block them.
C
        DO 113 I=0,NTRI-LOTN,LOTN
C
C IOP1 is the base index of the point common to edges 1 and 2.
C
          IF (IEDG(ITRI(I+1)+1).EQ.IEDG(ITRI(I+2)+1).OR.
     +        IEDG(ITRI(I+1)+1).EQ.IEDG(ITRI(I+2)+2)) THEN
            IOP1=IEDG(ITRI(I+1)+1)
          ELSE
            IOP1=IEDG(ITRI(I+1)+2)
          END IF
C
C IOP1 is the base index of the point common to edges 2 and 3.
C
          IF (IEDG(ITRI(I+2)+1).EQ.IEDG(ITRI(I+3)+1).OR.
     +        IEDG(ITRI(I+2)+1).EQ.IEDG(ITRI(I+3)+2)) THEN
            IOP2=IEDG(ITRI(I+2)+1)
          ELSE
            IOP2=IEDG(ITRI(I+2)+2)
          END IF
C
C IOP3 is the base index of the point common to edges 3 and 1.
C
          IF (IEDG(ITRI(I+3)+1).EQ.IEDG(ITRI(I+1)+1).OR.
     +        IEDG(ITRI(I+3)+1).EQ.IEDG(ITRI(I+1)+2)) THEN
            IOP3=IEDG(ITRI(I+3)+1)
          ELSE
            IOP3=IEDG(ITRI(I+3)+2)
          END IF
C
C Block the triangle if so directed by the value of IDAT.
C
          IF      (MOD(IDAT/10,10).EQ.1) THEN
C
C Land is blocked.
C
            NOBV=0
            IF (ITOP(INT(RPNT(IOP1+4))).NE.0) NOBV=NOBV+1
            IF (ITOP(INT(RPNT(IOP2+4))).NE.0) NOBV=NOBV+1
            IF (ITOP(INT(RPNT(IOP3+4))).NE.0) NOBV=NOBV+1
            IF (NOBV.GT.IDAT/100) ITRI(I+4)=1
C
          ELSE IF (MOD(IDAT/10,10).EQ.2) THEN
C
C Ocean is blocked.
C
            NOBV=0
            IF (ITOP(INT(RPNT(IOP1+4))).EQ.0) NOBV=NOBV+1
            IF (ITOP(INT(RPNT(IOP2+4))).EQ.0) NOBV=NOBV+1
            IF (ITOP(INT(RPNT(IOP3+4))).EQ.0) NOBV=NOBV+1
            IF (NOBV.GT.IDAT/100) ITRI(I+4)=1
C
          END IF
C
  113   CONTINUE
C
C Now that we don't need the pointers that were stored as "data", swap
C in the proper data values.  Save each pointer in the extra cell in
C the point definition.
C
        DO 114 I=0,NPNT-LOPN,LOPN
          RPNT(I+5)=RPNT(I+4)
          RPNT(I+4)=ZDAT(INT(RPNT(I+4)))
  114   CONTINUE
C
C Return the latitude and longitude of the approximate center point of
C the mesh on the globe.
C
        XLAT=0.
        XLON=0.
C
C Done.
C
        RETURN
C
C Error exit.
C
  901   PRINT * , '  GTISC2 - STOP - TOO MANY ADJOINING PATCHES FOUND'
        STOP
C
      END


      SUBROUTINE DSISC2
C
C Draw the original ISCCP grid, using data passed in a common block.
C
        COMMON /CISCCP/ ILAT(6596),ILON(6596),VLAT(6596),VLON(6596),
     +                  ZDAT(6596),ITOP(6596),IIOR(72),NBIR(72)
C
        CALL PLOTIT (0,0,2)
        CALL GSPLCI (8)
C
        DO 101 I=1,6596
          SLAT=VLAT(I)-1.25
          ELAT=VLAT(I)+1.25
          SLON=VLON(I)-180./REAL(NBIR(ILAT(I)))
          ELON=VLON(I)+180./REAL(NBIR(ILAT(I)))
          IF (ILAT(I).NE.1) CALL DLOCLA (SLAT,SLON,SLAT,ELON)
          CALL DLOCLO (SLAT,SLON,ELAT,SLON)
  101   CONTINUE
C
C Draw the continental outlines and lat/lon grid.
C
        CALL PLOTIT (0,0,2)
        CALL GSPLCI (13)
        CALL MAPGRD
        CALL PLOTIT (0,0,2)
        CALL GSPLCI (14)
        CALL MAPLOT
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE DRSGCR (ALAT,ALON,BLAT,BLON)
C
C (DRSGCR = DRaw Shortest Great Circle Route)
C
C This routine draws the shortest great circle route joining two points
C on the globe.  Note that MPTS = INT(180./SIZE) + 1.
C
        PARAMETER (MPTS=181,SIZE=1.)
C
        DIMENSION QLAT(MPTS),QLON(MPTS)
C
        NPTS=MAX(1,MIN(MPTS,INT(ADSGCR(ALAT,ALON,BLAT,BLON)/SIZE)))
C
        CALL MAPGCI (ALAT,ALON,BLAT,BLON,NPTS,QLAT,QLON)
C
        CALL MAPIT (ALAT,ALON,0)
C
        DO 101 I=1,NPTS
          CALL MAPIT (QLAT(I),QLON(I),1)
  101   CONTINUE
C
        CALL MAPIT (BLAT,BLON,2)
C
        CALL MAPIQ
C
        RETURN
C
      END


      FUNCTION ADSGCR (ALAT,ALON,BLAT,BLON)
C
C (ADSGCR = Angle in Degrees along Shortest Great Circle Route)
C
C This function returns the shortest great circle distance, in degrees,
C between two points, A and B, on the surface of the globe.
C
        DATA DTOR / .017453292519943 /
        DATA RTOD / 57.2957795130823 /
C
        XCOA=COS(DTOR*ALAT)*COS(DTOR*ALON)
        YCOA=COS(DTOR*ALAT)*SIN(DTOR*ALON)
        ZCOA=SIN(DTOR*ALAT)
C
        XCOB=COS(DTOR*BLAT)*COS(DTOR*BLON)
        YCOB=COS(DTOR*BLAT)*SIN(DTOR*BLON)
        ZCOB=SIN(DTOR*BLAT)
C
        ADSGCR=2.*RTOD*ASIN(SQRT((XCOA-XCOB)**2+
     +                           (YCOA-YCOB)**2+
     +                           (ZCOA-ZCOB)**2)/2.)
C
        RETURN
C
      END


      SUBROUTINE DLOCLA (ALAT,ALON,BLAT,BLON)
C
C (DLOCLA = Draw Line Of Constant LAtitude)
C
C This routine draws a line of constant latitude joining two points on
C the globe.
C
        PARAMETER (MPTS=181,SIZE=1.,DTOR=.017453292519943)
C
        NPTS=MAX(0,MIN(MPTS,INT(COS(DTOR*ALAT)*ABS(BLON-ALON)/SIZE)))
C
        CALL MAPIT (ALAT,ALON,0)
C
        DO 101 I=1,NPTS
          CALL MAPIT (ALAT,ALON+(REAL(I)/REAL(NPTS+1))*(BLON-ALON),1)
  101   CONTINUE
C
        CALL MAPIT (BLAT,BLON,2)
C
        CALL MAPIQ
C
        RETURN
C
      END


      SUBROUTINE DLOCLO (ALAT,ALON,BLAT,BLON)
C
C (DLOCLO = Draw Line Of Constant LOngitude)
C
C This routine draws a line of constant longitude joining two points on
C the globe.
C
        PARAMETER (MPTS=181,SIZE=1.)
C
        NPTS=MAX(0,MIN(MPTS,INT(ABS(BLAT-ALAT)/SIZE)))
C
        CALL MAPIT (ALAT,ALON,0)
C
        DO 101 I=1,NPTS
          CALL MAPIT (ALAT+(REAL(I)/REAL(NPTS+1))*(BLAT-ALAT),ALON,1)
  101   CONTINUE
C
        CALL MAPIT (BLAT,BLON,2)
C
        CALL MAPIQ
C
        RETURN
C
      END


      SUBROUTINE GGDINI (DLOW,DHGH,NRND,FRCT)
C
C The routines GGDINI and GGDPNT are used to generate test data on the
C globe, using a method which is essentially fractal and is based on
C successive elaborations of an icosahedron.
C
C To initialize the generation of a particular data field, execute the
C statement
C
C      CALL GGDINI (DLOW,DHGH,NRND,FRCT)
C
C DLOW is the desired minimum value and DHGH the desired maximum value.
C NRND is the number of random numbers (from the function FRAN) to be
C discarded before beginning to generate the field.  FRCT is a fraction
C between -1. and 1. which affects the "roughness" of the generated
C data; values near 0. will give smoother values than values further
C from 0.
C
C After a call to GGDINI, the function GGDPNT returns the value of the
C generated data field at the point (RLAT,RLON); the angles RLAT and
C RLON are given in radians.
C
C Parameters determine how many elaboration steps will be used (NELA)
C and therefore how many faces, edges, and vertices will be used (MFCE,
C MEDG, and MVTX, respectively).  Choose values from the table which
C follows:
C
C     NELA      MFCE      MEDG      MVTX
C     ----      ----      ----      ----
C        0        20        30        12
C        1       100       150        42
C        2       420       630       162
C        3      1700      2550       642
C        4      6820     10230      2562
C        5     27300     40950     10242
C        6    109220    163830     40962
C
C       PARAMETER(NELA=5,MFCE= 27300,MEDG= 40950,MVTX=10242,NELP=NELA+1)
        PARAMETER(NELA=6,MFCE=109220,MEDG=163830,MVTX=40962,NELP=NELA+1)
C
C NOTE:  A COPY OF THE ABOVE PARAMETER STATEMENT MUST BE PLACED IN THE
C FUNCTION GGDPNT, AS WELL.
C
C Information about the structure of the elaborated icosahedron is
C stored in variables in the labelled common block GGDCMN.  Each of
C NFCE entries in IFCE defines a triangular face; it consists of three
C pointers to elements of IEDG plus another element which, if non-zero,
C points to the faces into which that face was broken by the next
C elaboration step.  Each of NEDG entries in IEDG defines an edge;
C the first two elements are pointers to elements of VRTX, and the
C second two elements, if non-zero, are pointers back into IEDG, to
C the two edges into which the edge was broken by the next elaboration
C step.  Each of NVTX entries in VRTX defines a vertex, including the
C position and the data value associated with it.
C
C The arrays LFCE, LEDG, and LVTX point to the beginning and ending of
C the faces, edges, and vertices, respectively, added by the step whose
C number is given by the second index.
C
C RLOW and RHGH are just copies of the user's DLOW and DHGH; RMIN and
C RMAX are the actual minimum and maximum value of the data values
C stored in the array VRTX.
C
        COMMON /GGDCMN/ NFCE,IFCE(4,MFCE),NEDG,IEDG(4,MEDG),
     +                  NVTX,VRTX(4,MVTX),
     +                  LFCE(2,NELP),LEDG(2,NELP),LVTX(2,NELP),
     +                  RLOW,RHGH,RMIN,RMAX
        SAVE   /GGDCMN/
C
C Declare local arrays which are used for initialization.
C
        DIMENSION JFCE(3,20),JEDG(2,30),XCVI(12),YCVI(12),ZCVI(12)
C
C Define the twenty faces of an icosahedron (pointers to edges).
C
        DATA JFCE(1, 1),JFCE(2, 1),JFCE(3, 1) /  1,11, 2 /
        DATA JFCE(1, 2),JFCE(2, 2),JFCE(3, 2) /  2,19, 3 /
        DATA JFCE(1, 3),JFCE(2, 3),JFCE(3, 3) /  3,25, 4 /
        DATA JFCE(1, 4),JFCE(2, 4),JFCE(3, 4) /  4,29, 5 /
        DATA JFCE(1, 5),JFCE(2, 5),JFCE(3, 5) /  1,14, 5 /
        DATA JFCE(1, 6),JFCE(2, 6),JFCE(3, 6) / 12,28,14 /
        DATA JFCE(1, 7),JFCE(2, 7),JFCE(3, 7) / 12,27,13 /
        DATA JFCE(1, 8),JFCE(2, 8),JFCE(3, 8) / 11,20,13 /
        DATA JFCE(1, 9),JFCE(2, 9),JFCE(3, 9) / 20,30,21 /
        DATA JFCE(1,10),JFCE(2,10),JFCE(3,10) / 19,26,21 /
        DATA JFCE(1,11),JFCE(2,11),JFCE(3,11) / 16,18,26 /
        DATA JFCE(1,12),JFCE(2,12),JFCE(3,12) / 16,25,17 /
        DATA JFCE(1,13),JFCE(2,13),JFCE(3,13) / 15,23,17 /
        DATA JFCE(1,14),JFCE(2,14),JFCE(3,14) / 23,29,24 /
        DATA JFCE(1,15),JFCE(2,15),JFCE(3,15) / 22,28,24 /
        DATA JFCE(1,16),JFCE(2,16),JFCE(3,16) /  7, 8,22 /
        DATA JFCE(1,17),JFCE(2,17),JFCE(3,17) /  6,15, 7 /
        DATA JFCE(1,18),JFCE(2,18),JFCE(3,18) /  6,18,10 /
        DATA JFCE(1,19),JFCE(2,19),JFCE(3,19) /  9,30,10 /
        DATA JFCE(1,20),JFCE(2,20),JFCE(3,20) /  8,27, 9 /
C
C Define the thirty edges of the icosahedron (pointers to vertices).
C
        DATA JEDG(1, 1),JEDG(2, 1) /  1, 3 /
        DATA JEDG(1, 2),JEDG(2, 2) /  1, 5 /
        DATA JEDG(1, 3),JEDG(2, 3) /  1, 7 /
        DATA JEDG(1, 4),JEDG(2, 4) /  1, 9 /
        DATA JEDG(1, 5),JEDG(2, 5) /  1,11 /
        DATA JEDG(1, 6),JEDG(2, 6) /  2, 4 /
        DATA JEDG(1, 7),JEDG(2, 7) /  2, 6 /
        DATA JEDG(1, 8),JEDG(2, 8) /  2, 8 /
        DATA JEDG(1, 9),JEDG(2, 9) /  2,10 /
        DATA JEDG(1,10),JEDG(2,10) /  2,12 /
        DATA JEDG(1,11),JEDG(2,11) /  3, 5 /
        DATA JEDG(1,12),JEDG(2,12) /  3, 8 /
        DATA JEDG(1,13),JEDG(2,13) /  3,10 /
        DATA JEDG(1,14),JEDG(2,14) /  3,11 /
        DATA JEDG(1,15),JEDG(2,15) /  4, 6 /
        DATA JEDG(1,16),JEDG(2,16) /  4, 7 /
        DATA JEDG(1,17),JEDG(2,17) /  4, 9 /
        DATA JEDG(1,18),JEDG(2,18) /  4,12 /
        DATA JEDG(1,19),JEDG(2,19) /  5, 7 /
        DATA JEDG(1,20),JEDG(2,20) /  5,10 /
        DATA JEDG(1,21),JEDG(2,21) /  5,12 /
        DATA JEDG(1,22),JEDG(2,22) /  6, 8 /
        DATA JEDG(1,23),JEDG(2,23) /  6, 9 /
        DATA JEDG(1,24),JEDG(2,24) /  6,11 /
        DATA JEDG(1,25),JEDG(2,25) /  7, 9 /
        DATA JEDG(1,26),JEDG(2,26) /  7,12 /
        DATA JEDG(1,27),JEDG(2,27) /  8,10 /
        DATA JEDG(1,28),JEDG(2,28) /  8,11 /
        DATA JEDG(1,29),JEDG(2,29) /  9,11 /
        DATA JEDG(1,30),JEDG(2,30) / 10,12 /
C
C Define the vertices of the icosahedron (note radius less than one).
C
        DATA XCVI / .9510565162952 , -.9510565162951 ,  .4253254041760 ,
     +             -.4253254041760 ,  .4253254041760 , -.4253254041760 ,
     +              .4253254041760 , -.4253254041760 ,  .4253254041760 ,
     +             -.4253254041760 ,  .4253254041760 , -.4253254041760 /
        DATA YCVI / .0000000000000 ,  .0000000000000 ,  .8506508083520 ,
     +             -.8506508083520 ,  .2628655560596 , -.2628655560596 ,
     +             -.6881909602356 ,  .6881909602356 , -.6881909602356 ,
     +              .6881909602356 ,  .2628655560595 , -.2628655560596 /
        DATA ZCVI / .0000000000000 ,  .0000000000000 ,  .0000000000000 ,
     +              .0000000000000 ,  .8090169943749 , -.8090169943749 ,
     +              .5000000000000 , -.5000000000000 , -.5000000000000 ,
     +              .5000000000000 , -.8090169943749 ,  .8090169943749 /
C
C Define constants for converting from degrees to radians and back.
C
        DATA DTOR / .017453292519943 /
        DATA RTOD / 57.2957795130823 /
C
C Spin up the random number generator.
C
        DO 101 I=1,NRND
          TEMP=FRAN()
  101   CONTINUE
C
C Initialize the list of faces.
C
        NFCE=20
C
        DO 102 I=1,NFCE
          IFCE(1,I)=JFCE(1,I)
          IFCE(2,I)=JFCE(2,I)
          IFCE(3,I)=JFCE(3,I)
          IFCE(4,I)=0
  102   CONTINUE
C
C Initialize the list of edges.
C
        NEDG=30
C
        DO 103 I=1,NEDG
          IEDG(1,I)=JEDG(1,I)
          IEDG(2,I)=JEDG(2,I)
          IEDG(3,I)=0
          IEDG(4,I)=0
  103   CONTINUE
C
C Initialize the list of vertices.
C
        NVTX=12
C
        DO 104 I=1,NVTX
          TEMP=SQRT(XCVI(I)**2+YCVI(I)**2+ZCVI(I)**2)
          VRTX(1,I)=XCVI(I)/TEMP
          VRTX(2,I)=YCVI(I)/TEMP
          VRTX(3,I)=ZCVI(I)/TEMP
          VRTX(4,I)=FRAN()
  104   CONTINUE
C
C Define pointers to the existing faces, edges, and vertices.
C
        LFCE(1,1)=1
        LFCE(2,1)=NFCE
C
        LEDG(1,1)=1
        LEDG(2,1)=NEDG
C
        LVTX(1,1)=1
        LVTX(2,1)=NVTX
C
C Define the initial multiplier for the random number generator.
C
        RMUL=1.
C
C Do a number of successive elaboration steps.
C
        DO 108 IELA=2,NELP
C
C Update pointers which will tell us what faces, edges, and vertices
C were added during this step.
C
          LFCE(1,IELA)=NFCE+1
          LEDG(1,IELA)=NEDG+1
          LVTX(1,IELA)=NVTX+1
C
C Change the multiplier for the random number generator.
C
          RMUL=FRCT*RMUL
C
C Add a vertex at the midpoint of each edge added during the last step.
C
          DO 105 I=LEDG(1,IELA-1),LEDG(2,IELA-1)
            NVTX=NVTX+1
            IF (NVTX.GT.MVTX) GO TO 901
            VRTX(1,NVTX)=.5*(VRTX(1,IEDG(1,I))+VRTX(1,IEDG(2,I)))
            VRTX(2,NVTX)=.5*(VRTX(2,IEDG(1,I))+VRTX(2,IEDG(2,I)))
            VRTX(3,NVTX)=.5*(VRTX(3,IEDG(1,I))+VRTX(3,IEDG(2,I)))
            VRTX(4,NVTX)=.5*(VRTX(4,IEDG(1,I))+VRTX(4,IEDG(2,I)))
            TEMP=SQRT(VRTX(1,NVTX)**2+VRTX(2,NVTX)**2+VRTX(3,NVTX)**2)
            VRTX(1,NVTX)=VRTX(1,NVTX)/TEMP
            VRTX(2,NVTX)=VRTX(2,NVTX)/TEMP
            VRTX(3,NVTX)=VRTX(3,NVTX)/TEMP
            NEDG=NEDG+2
            IF (NEDG.GT.MEDG) GO TO 902
            IEDG(3,I)=NEDG-1
            IEDG(4,I)=NEDG
            IEDG(1,NEDG-1)=IEDG(1,I)
            IEDG(2,NEDG-1)=NVTX
            IEDG(3,NEDG-1)=0
            IEDG(4,NEDG-1)=0
            IEDG(1,NEDG  )=NVTX
            IEDG(2,NEDG  )=IEDG(2,I)
            IEDG(3,NEDG  )=0
            IEDG(4,NEDG  )=0
  105     CONTINUE
C
C Modify the data values at each of the vertices of the new object.
C
          DO 106 I=1,NVTX
            VRTX(4,I)=VRTX(4,I)+RMUL*FRAN()
  106     CONTINUE
C
C Break each face from the last step into four new ones and add them
C back into the list.
C
          DO 107 I=LFCE(1,IELA-1),LFCE(2,IELA-1)
            IFCE(4,I)=NFCE+1
            NEDG=NEDG+3
            IF (NEDG.GT.MEDG) GO TO 902
            IEDG(1,NEDG-2)=IEDG(2,IEDG(3,IFCE(1,I)))
            IEDG(2,NEDG-2)=IEDG(2,IEDG(3,IFCE(2,I)))
            IEDG(3,NEDG-2)=0
            IEDG(4,NEDG-2)=0
            IEDG(1,NEDG-1)=IEDG(2,IEDG(3,IFCE(2,I)))
            IEDG(2,NEDG-1)=IEDG(2,IEDG(3,IFCE(3,I)))
            IEDG(3,NEDG-1)=0
            IEDG(4,NEDG-1)=0
            IEDG(1,NEDG  )=IEDG(2,IEDG(3,IFCE(3,I)))
            IEDG(2,NEDG  )=IEDG(2,IEDG(3,IFCE(1,I)))
            IEDG(3,NEDG  )=0
            IEDG(4,NEDG  )=0
            NFCE=NFCE+4
            IF (NFCE.GT.MFCE) GO TO 903
            IF (IEDG(1,IFCE(1,I)).EQ.IEDG(1,IFCE(2,I))) THEN
              IF (IEDG(2,IFCE(1,I)).EQ.IEDG(1,IFCE(3,I))) THEN
                IFCE(1,NFCE-3)=IEDG(3,IFCE(1,I))
                IFCE(2,NFCE-3)=IEDG(3,IFCE(2,I))
                IFCE(3,NFCE-3)=NEDG-2
                IFCE(4,NFCE-3)=0
                IFCE(1,NFCE-2)=IEDG(4,IFCE(2,I))
                IFCE(2,NFCE-2)=IEDG(4,IFCE(3,I))
                IFCE(3,NFCE-2)=NEDG-1
                IFCE(4,NFCE-2)=0
                IFCE(1,NFCE-1)=IEDG(3,IFCE(3,I))
                IFCE(2,NFCE-1)=IEDG(4,IFCE(1,I))
                IFCE(3,NFCE-1)=NEDG
                IFCE(4,NFCE-1)=0
              ELSE
                IFCE(1,NFCE-3)=IEDG(3,IFCE(1,I))
                IFCE(2,NFCE-3)=IEDG(3,IFCE(2,I))
                IFCE(3,NFCE-3)=NEDG-2
                IFCE(4,NFCE-3)=0
                IFCE(1,NFCE-2)=IEDG(3,IFCE(3,I))
                IFCE(2,NFCE-2)=IEDG(4,IFCE(2,I))
                IFCE(3,NFCE-2)=NEDG-1
                IFCE(4,NFCE-2)=0
                IFCE(1,NFCE-1)=IEDG(4,IFCE(1,I))
                IFCE(2,NFCE-1)=IEDG(4,IFCE(3,I))
                IFCE(3,NFCE-1)=NEDG
                IFCE(4,NFCE-1)=0
              END IF
            ELSE IF (IEDG(1,IFCE(1,I)).EQ.IEDG(2,IFCE(2,I))) THEN
              IF (IEDG(2,IFCE(1,I)).EQ.IEDG(1,IFCE(3,I))) THEN
                IFCE(1,NFCE-3)=IEDG(3,IFCE(1,I))
                IFCE(2,NFCE-3)=IEDG(4,IFCE(2,I))
                IFCE(3,NFCE-3)=NEDG-2
                IFCE(4,NFCE-3)=0
                IFCE(1,NFCE-2)=IEDG(3,IFCE(2,I))
                IFCE(2,NFCE-2)=IEDG(4,IFCE(3,I))
                IFCE(3,NFCE-2)=NEDG-1
                IFCE(4,NFCE-2)=0
                IFCE(1,NFCE-1)=IEDG(3,IFCE(3,I))
                IFCE(2,NFCE-1)=IEDG(4,IFCE(1,I))
                IFCE(3,NFCE-1)=NEDG
                IFCE(4,NFCE-1)=0
              ELSE
                IFCE(1,NFCE-3)=IEDG(3,IFCE(1,I))
                IFCE(2,NFCE-3)=IEDG(4,IFCE(2,I))
                IFCE(3,NFCE-3)=NEDG-2
                IFCE(4,NFCE-3)=0
                IFCE(1,NFCE-2)=IEDG(3,IFCE(2,I))
                IFCE(2,NFCE-2)=IEDG(3,IFCE(3,I))
                IFCE(3,NFCE-2)=NEDG-1
                IFCE(4,NFCE-2)=0
                IFCE(1,NFCE-1)=IEDG(4,IFCE(1,I))
                IFCE(2,NFCE-1)=IEDG(4,IFCE(3,I))
                IFCE(3,NFCE-1)=NEDG
                IFCE(4,NFCE-1)=0
              END IF
            ELSE IF (IEDG(1,IFCE(1,I)).EQ.IEDG(1,IFCE(3,I))) THEN
              IF (IEDG(2,IFCE(1,I)).EQ.IEDG(1,IFCE(2,I))) THEN
                IFCE(1,NFCE-3)=IEDG(3,IFCE(2,I))
                IFCE(2,NFCE-3)=IEDG(4,IFCE(1,I))
                IFCE(3,NFCE-3)=NEDG-2
                IFCE(4,NFCE-3)=0
                IFCE(1,NFCE-2)=IEDG(4,IFCE(2,I))
                IFCE(2,NFCE-2)=IEDG(4,IFCE(3,I))
                IFCE(3,NFCE-2)=NEDG-1
                IFCE(4,NFCE-2)=0
                IFCE(1,NFCE-1)=IEDG(3,IFCE(1,I))
                IFCE(2,NFCE-1)=IEDG(3,IFCE(3,I))
                IFCE(3,NFCE-1)=NEDG
                IFCE(4,NFCE-1)=0
              ELSE
                IFCE(1,NFCE-3)=IEDG(4,IFCE(1,I))
                IFCE(2,NFCE-3)=IEDG(4,IFCE(2,I))
                IFCE(3,NFCE-3)=NEDG-2
                IFCE(4,NFCE-3)=0
                IFCE(1,NFCE-2)=IEDG(3,IFCE(2,I))
                IFCE(2,NFCE-2)=IEDG(4,IFCE(3,I))
                IFCE(3,NFCE-2)=NEDG-1
                IFCE(4,NFCE-2)=0
                IFCE(1,NFCE-1)=IEDG(3,IFCE(1,I))
                IFCE(2,NFCE-1)=IEDG(3,IFCE(3,I))
                IFCE(3,NFCE-1)=NEDG
                IFCE(4,NFCE-1)=0
              END IF
            ELSE
              IF (IEDG(2,IFCE(1,I)).EQ.IEDG(1,IFCE(2,I))) THEN
                IFCE(1,NFCE-3)=IEDG(3,IFCE(2,I))
                IFCE(2,NFCE-3)=IEDG(4,IFCE(1,I))
                IFCE(3,NFCE-3)=NEDG-2
                IFCE(4,NFCE-3)=0
                IFCE(1,NFCE-2)=IEDG(3,IFCE(3,I))
                IFCE(2,NFCE-2)=IEDG(4,IFCE(2,I))
                IFCE(3,NFCE-2)=NEDG-1
                IFCE(4,NFCE-2)=0
                IFCE(1,NFCE-1)=IEDG(3,IFCE(1,I))
                IFCE(2,NFCE-1)=IEDG(4,IFCE(3,I))
                IFCE(3,NFCE-1)=NEDG
                IFCE(4,NFCE-1)=0
              ELSE
                IFCE(1,NFCE-3)=IEDG(4,IFCE(1,I))
                IFCE(2,NFCE-3)=IEDG(4,IFCE(2,I))
                IFCE(3,NFCE-3)=NEDG-2
                IFCE(4,NFCE-3)=0
                IFCE(1,NFCE-2)=IEDG(3,IFCE(2,I))
                IFCE(2,NFCE-2)=IEDG(3,IFCE(3,I))
                IFCE(3,NFCE-2)=NEDG-1
                IFCE(4,NFCE-2)=0
                IFCE(1,NFCE-1)=IEDG(3,IFCE(1,I))
                IFCE(2,NFCE-1)=IEDG(4,IFCE(3,I))
                IFCE(3,NFCE-1)=NEDG
                IFCE(4,NFCE-1)=0
              END IF
            END IF
            IFCE(1,NFCE  )=NEDG-2
            IFCE(2,NFCE  )=NEDG-1
            IFCE(3,NFCE  )=NEDG
            IFCE(4,NFCE  )=0
  107     CONTINUE
C
C Update pointers which will tell us what faces, edges, and vertices
C were added during this step.
C
          LFCE(2,IELA)=NFCE
          LEDG(2,IELA)=NEDG
          LVTX(2,IELA)=NVTX
C
C End of elaboration step.
C
  108   CONTINUE
C
C Copy the desired lowest and highest values to COMMON.
C
        RLOW=DLOW
        RHGH=DHGH
C
C Compute the minimum and maximum value in the data.
C
        RMIN=+1.E36
        RMAX=-1.E36
C
        DO 109 I=1,NVTX
          RMIN=MIN(RMIN,VRTX(4,I))
          RMAX=MAX(RMAX,VRTX(4,I))
  109   CONTINUE
C
C Done.
C
        RETURN
C
C Error exits.
C
  901   PRINT * , 'STOP - GGDINI - TOO MANY VERTICES'
        STOP
C
  902   PRINT * , 'STOP - GGDINI - TOO MANY EDGES'
        STOP
C
  903   PRINT * , 'STOP - GGDINI - TOO MANY FACES'
        STOP
C
      END


      FUNCTION GGDPNT (RLAT,RLON)
C
C Following is a copy of the PARAMETER statement from GGDINI.
C
        PARAMETER(NELA=6,MFCE=109220,MEDG=163830,MVTX=40962,NELP=NELA+1)
C
C Define the common block for the package.
C
        COMMON /GGDCMN/ NFCE,IFCE(4,MFCE),NEDG,IEDG(4,MEDG),
     +                  NVTX,VRTX(4,MVTX),
     +                  LFCE(2,NELP),LEDG(2,NELP),LVTX(2,NELP),
     +                  RLOW,RHGH,RMIN,RMAX
        SAVE   /GGDCMN/
C
C Define constants for converting from degrees to radians and back.
C
        DATA DTOR / .017453292519943 /
        DATA RTOD / 57.2957795130823 /
C
C Compute the position of the point on the surface of the unit sphere.
C
        X0=COS(DTOR*RLAT)*COS(DTOR*RLON)
        Y0=COS(DTOR*RLAT)*SIN(DTOR*RLON)
        Z0=SIN(DTOR*RLAT)
C
C Find out what face that point falls above.
C
        IFST=1
        NUMB=20
        ITRY=1
C
  101   CONTINUE
          IPOS=IFST
  102     CONTINUE
            X1=VRTX(1,IEDG(1,IFCE(1,IPOS)))
            Y1=VRTX(2,IEDG(1,IFCE(1,IPOS)))
            Z1=VRTX(3,IEDG(1,IFCE(1,IPOS)))
            W1=VRTX(4,IEDG(1,IFCE(1,IPOS)))
            X2=VRTX(1,IEDG(2,IFCE(1,IPOS)))
            Y2=VRTX(2,IEDG(2,IFCE(1,IPOS)))
            Z2=VRTX(3,IEDG(2,IFCE(1,IPOS)))
            W2=VRTX(4,IEDG(2,IFCE(1,IPOS)))
            IF (IEDG(1,IFCE(2,IPOS)).NE.IEDG(1,IFCE(1,IPOS)).AND.
     +          IEDG(1,IFCE(2,IPOS)).NE.IEDG(2,IFCE(1,IPOS))) THEN
              X3=VRTX(1,IEDG(1,IFCE(2,IPOS)))
              Y3=VRTX(2,IEDG(1,IFCE(2,IPOS)))
              Z3=VRTX(3,IEDG(1,IFCE(2,IPOS)))
              W3=VRTX(4,IEDG(1,IFCE(2,IPOS)))
            ELSE
              X3=VRTX(1,IEDG(2,IFCE(2,IPOS)))
              Y3=VRTX(2,IEDG(2,IFCE(2,IPOS)))
              Z3=VRTX(3,IEDG(2,IFCE(2,IPOS)))
              W3=VRTX(4,IEDG(2,IFCE(2,IPOS)))
            END IF
            A1=Y3*Z2-Y2*Z3
            B1=X2*Z3-X3*Z2
            C1=X3*Y2-X2*Y3
            A2=Y1*Z3-Y3*Z1
            B2=X3*Z1-X1*Z3
            C2=X1*Y3-X3*Y1
            A3=Y2*Z1-Y1*Z2
            B3=X1*Z2-X2*Z1
            C3=X2*Y1-X1*Y2
            IF (ITRY.EQ.1) THEN
              XM=(X1+X2+X3)/3.
              YM=(Y1+Y2+Y3)/3.
              ZM=(Z1+Z2+Z3)/3.
              S1=SIGN(1.,A1*XM+B1*YM+C1*ZM)
              S2=SIGN(1.,A2*XM+B2*YM+C2*ZM)
              S3=SIGN(1.,A3*XM+B3*YM+C3*ZM)
              T1=SIGN(1.,A1*X0+B1*Y0+C1*Z0)
              T2=SIGN(1.,A2*X0+B2*Y0+C2*Z0)
              T3=SIGN(1.,A3*X0+B3*Y0+C3*Z0)
              IF (S1.EQ.T1.AND.S2.EQ.T2.AND.S3.EQ.T3) GO TO 103
            ELSE
              T1=2.*((X0-X2)*(X3-X2)+(Y0-Y2)*(Y3-Y2)+(Z0-Z2)*(Z3-Z2))/
     +              ((X3-X2)*(X3-X2)+(Y3-Y2)*(Y3-Y2)+(Z3-Z2)*(Z3-Z2))
              T1=MAX(0.,MIN(1.,T1))
              D1=(X2-X0+(X3-X2)*T1)**2+(Y2-Y0+(Y3-Y2)*T1)**2+
     +                                 (Z2-Z0+(Z3-Z2)*T1)**2
              T2=2.*((X0-X3)*(X1-X3)+(Y0-Y3)*(Y1-Y3)+(Z0-Z3)*(Z1-Z3))/
     +              ((X1-X3)*(X1-X3)+(Y1-Y3)*(Y1-Y3)+(Z1-Z3)*(Z1-Z3))
              T2=MAX(0.,MIN(1.,T2))
              D2=(X3-X0+(X1-X3)*T2)**2+(Y3-Y0+(Y1-Y3)*T2)**2+
     +                                 (Z3-Z0+(Z1-Z3)*T2)**2
              T3=2.*((X0-X1)*(X2-X1)+(Y0-Y1)*(Y2-Y1)+(Z0-Z1)*(Z2-Z1))/
     +              ((X2-X1)*(X2-X1)+(Y2-Y1)*(Y2-Y1)+(Z2-Z1)*(Z2-Z1))
              T3=MAX(0.,MIN(1.,T3))
              D3=(X1-X0+(X2-X1)*T3)**2+(Y1-Y0+(Y2-Y1)*T3)**2+
     +                                 (Z1-Z0+(Z2-Z1)*T3)**2
              DIST=MIN(D1,D2,D3)
              IF (IBST.EQ.0.OR.DIST.LT.DBST) THEN
                IBST=IPOS
                DBST=DIST
              END IF
            END IF
            IF (IPOS.EQ.IFST+NUMB-1) THEN
              IF (ITRY.EQ.1) THEN
                IPOS=IFST-1
                ITRY=2
                IBST=0
                DBST=0.
              ELSE
                IPOS=IBST
                X1=VRTX(1,IEDG(1,IFCE(1,IPOS)))
                Y1=VRTX(2,IEDG(1,IFCE(1,IPOS)))
                Z1=VRTX(3,IEDG(1,IFCE(1,IPOS)))
                W1=VRTX(4,IEDG(1,IFCE(1,IPOS)))
                X2=VRTX(1,IEDG(2,IFCE(1,IPOS)))
                Y2=VRTX(2,IEDG(2,IFCE(1,IPOS)))
                Z2=VRTX(3,IEDG(2,IFCE(1,IPOS)))
                W2=VRTX(4,IEDG(2,IFCE(1,IPOS)))
                IF (IEDG(1,IFCE(2,IPOS)).NE.IEDG(1,IFCE(1,IPOS)).AND.
     +              IEDG(1,IFCE(2,IPOS)).NE.IEDG(2,IFCE(1,IPOS))) THEN
                  X3=VRTX(1,IEDG(1,IFCE(2,IPOS)))
                  Y3=VRTX(2,IEDG(1,IFCE(2,IPOS)))
                  Z3=VRTX(3,IEDG(1,IFCE(2,IPOS)))
                  W3=VRTX(4,IEDG(1,IFCE(2,IPOS)))
                ELSE
                  X3=VRTX(1,IEDG(2,IFCE(2,IPOS)))
                  Y3=VRTX(2,IEDG(2,IFCE(2,IPOS)))
                  Z3=VRTX(3,IEDG(2,IFCE(2,IPOS)))
                  W3=VRTX(4,IEDG(2,IFCE(2,IPOS)))
                END IF
                GO TO 103
              END IF
            END IF
            IPOS=IPOS+1
          GO TO 102
  103     CONTINUE
          IFST=IFCE(4,IPOS)
          NUMB=4
          ITRY=1
        IF (IFST.NE.0) GO TO 101
C
C Compute a data value at the point.
C
        IF ((X1-X0)**2+(Y1-Y0)**2+(Z1-Z0)**2.LT..000001) THEN
          RVAL=W1
        ELSE
          AP=Y1*(Z3-Z2)+Y2*(Z1-Z3)+Y3*(Z2-Z1)
          BP=X1*(Z2-Z3)+X2*(Z3-Z1)+X3*(Z1-Z2)
          CP=X1*(Y3-Y2)+X2*(Y1-Y3)+X3*(Y2-Y1)
          DP=X1*Y2*Z3-X1*Y3*Z2-X2*Y1*Z3+X3*Y1*Z2+X2*Y3*Z1-X3*Y2*Z1
          TP=-DP/(AP*X0+BP*Y0+CP*Z0)
          X4=TP*X0
          Y4=TP*Y0
          Z4=TP*Z0
          A1=Y3*Z2-Y2*Z3
          B1=X2*Z3-X3*Z2
          C1=X3*Y2-X2*Y3
          TP=-(A1*X1+B1*Y1+C1*Z1)/(A1*(X4-X1)+B1*(Y4-Y1)+C1*(Z4-Z1))
          X5=X1+TP*(X4-X1)
          Y5=Y1+TP*(Y4-Y1)
          Z5=Z1+TP*(Z4-Z1)
          W5=W2+(W3-W2)*SQRT(((X5-X2)**2+(Y5-Y2)**2+(Z5-Z2)**2)/
     +                       ((X3-X2)**2+(Y3-Y2)**2+(Z3-Z2)**2))
          RVAL=W1+(W5-W1)*SQRT(((X4-X1)**2+(Y4-Y1)**2+(Z4-Z1)**2)/
     +                         ((X5-X1)**2+(Y5-Y1)**2+(Z5-Z1)**2))
        END IF
C
C Adjust the value to the desired range.
C
        GGDPNT=RLOW+(RHGH-RLOW)*(RVAL-RMIN)/(RMAX-RMIN)
C
C Done.
C
        RETURN
C
      END


      FUNCTION FRAN ()
C
C Pseudo-random-number generator.
C
        DOUBLE PRECISION X
        SAVE X
C
        DATA X / 2.718281828459045D0 /
C
        X=MOD(9821.D0*X+.211327D0,1.D0)
        FRAN=REAL(X)
C
        RETURN
C
      END


      SUBROUTINE CTSCAE (ICRA,ICA1,ICAM,ICAN,XCPF,YCPF,XCQF,YCQF,
     +                                       IND1,IND2,ICAF,IAID)
        DIMENSION ICRA(ICA1,*)
C
C This routine is called by CTCICA when the internal parameter 'CAF' is
C given a negative value.  Each call is intended to create a particular
C element in the user's cell array.  The arguments are as follows:
C
C ICRA is the user's cell array.
C
C ICA1 is the first dimension of the FORTRAN array ICRA.
C
C ICAM and ICAN are the first and second dimensions of the cell array
C stored in ICRA.
C
C (XCPF,YCPF) is the point at that corner of the rectangular area
C into which the cell array maps that corresponds to the cell (1,1).
C The coordinates are given in the fractional coordinate system (unlike
C what is required in a call to GCA, in which the coordinates of the
C point P are in the world coordinate system).
C
C (XCQF,YCQF) is the point at that corner of the rectangular area into
C which the cell array maps that corresponds to the cell (ICAM,ICAN).
C The coordinates are given in the fractional coordinate system (unlike
C what is required in a call to GCA, in which the coordinates of the
C point Q are in the world coordinate system).
C
C IND1 is the 1st index of the cell that is to be updated.
C
C IND2 is the 2nd index of the cell that is to be updated.
C
C ICAF is the current value of the internal parameter 'CAF'.  This
C value will always be an integer which is less than zero (because
C when 'CAF' is zero or greater, this routine is not called).
C
C IAID is the area identifier associated with the cell.  It will have
C been given one of the values from the internal parameter array 'AIA'
C (the one for 'PAI' = -2 if the cell lies in an out-of-range area, the
C one for 'PAI' = -1 if the cell lies off the data grid, or the one for
C some value of 'PAI' between 1 and 'NCL' if the cell lies on the data
C grid).  The value zero may occur if the cell falls in an out-of-range
C area and the value of 'AIA' for 'PAI' = -2 is 0 or if the cell lies
C off the data grid and the value of 'AIA' for 'PAI' = -1 is 0, or if
C the cell falls on the data grid, but no contour level below the cell
C has a non-zero 'AIA' and no contour level above the cell has a
C non-zero 'AIB'.  Note that, if the values of 'AIA' for 'PAI' = -1
C and -2 are given non-zero values, IAID can only be given a zero
C value in one way.
C
C The default behavior of CTSCAE is as follows:  If the area identifier
C is non-negative, it is treated as a color index, to be stored in the
C appropriate cell in the cell array; but if the area identifier is
C negative, a zero is stored for the color index.  The user may supply
C a version of CTSCAE that does something different; it may simply map
C the area identifiers into color indices or it may somehow modify the
C existing cell array element to incorporate the information provided
C by the area identifier.
C
C       ICRA(IND1,IND2)=MAX(0,IAID)
C
C What follows is not the default behavior; instead, it is the behavior
C expected by many of the example programs for CONPACKT.
C
        CALL CTGETI ('NCL - NUMBER OF CONTOUR LEVELS',NOCL)
C
        IF (IAID.GE.1.AND.IAID.LE.NOCL+1) THEN
          ICRA(IND1,IND2)=151+INT(((REAL(IAID)-.5)/REAL(NOCL+1))*100.)
        ELSE IF (IAID.EQ.1001) THEN
          ICRA(IND1,IND2)=2
        ELSE IF (IAID.EQ.1002) THEN
          ICRA(IND1,IND2)=3
        END IF
C
        RETURN
C
      END

C
C $Id: mdrgol.f,v 1.12 2008-09-18 00:42:18 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MDRGOL (IRGL,RWRK,LRWK)
C
        INTEGER IRGL,LRWK
        REAL RWRK(LRWK)
C
C This routine is called to draw RANGS/GSHHS outlines in the current
C EZMAP window.  The argument IRGL specifies the level of resolution
C to be used, from 0 (highest resolution) to 4 (lowest resolution).
C
C Declare required common blocks.  See MAPBDX for descriptions of these
C common blocks and the variables in them.
C
        COMMON /MAPCM2/  BLAM,BLOM,PEPS,SLAM,SLOM,UCEN,UMAX,UMIN,UOFF,
     +                   URNG,VCEN,VMAX,VMIN,VOFF,VRNG,ISSL
        DOUBLE PRECISION BLAM,BLOM,PEPS,SLAM,SLOM,UCEN,UMAX,UMIN,UOFF,
     +                   URNG,VCEN,VMAX,VMIN,VOFF,VRNG
        INTEGER          ISSL
        SAVE   /MAPCM2/
C
        COMMON /MAPCM4/  GRDR,GRID,GRLA,GRLO,GRPO,OTOL,PDRE,PLA1,PLA2,
     +                   PLA3,PLA4,PLB1,PLB2,PLB3,PLB4,PLNO,PLTO,ROTA,
     +                   SRCH,XLOW,XROW,YBOW,YTOW,IDOT,IDSH,IDTL,ILCW,
     +                   ILTS,JPRJ,ELPF,INTF,LBLF,PRMF
        DOUBLE PRECISION GRDR,GRID,GRLA,GRLO,GRPO,OTOL,PDRE,PLA1,PLA2,
     +                   PLA3,PLA4,PLB1,PLB2,PLB3,PLB4,PLNO,PLTO,ROTA,
     +                   SRCH,XLOW,XROW,YBOW,YTOW
        INTEGER          IDOT,IDSH,IDTL,ILCW,ILTS,JPRJ
        LOGICAL          ELPF,INTF,LBLF,PRMF
        SAVE   /MAPCM4/
C
        COMMON /MAPRGD/  ICOL(5),ICSF(5),IDPF,LCRA,NILN,NILT,OLAT,OLON
        INTEGER          ICOL,ICSF,IDPF,LCRA,NILN,NILT
        REAL             OLAT,OLON
        SAVE   /MAPRGD/
C
C Declare local variables.
C
        DOUBLE PRECISION P,Q,RLAT,RLON,UPRJ,VPRJ
        INTEGER          I,J,ICAT,ICEL,IERR,IGCF,ILAT,ILON,IPLC,IRIM,
     +                   IWGF,NPTS
        REAL             DUMI(4)
C
C Declare a local, dummy, area-map array to hand off to MDRGSX, which
C doesn't need a real one just to draw outlines.
C
        INTEGER          IAMA(1)
C
C Check for an uncleared prior error.
C
        IF (ICFELL('MDRGOL - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C If EZMAP needs initialization, do it.
C
        IF (INTF) THEN
          CALL MDPINT
          IF (ICFELL('MDRGOL',2).NE.0) RETURN
        END IF
C
C Open the RANGS/GSHHS files.
C
        CALL MDRGOF (MAX(0,MIN(4,IRGL)),ICAT,ICEL,IRIM)
        IF (ICFELL('MDRGOL',3).NE.0) RETURN
C
C Save the current state of the GKS clipping flag and turn clipping on.
C (Note that the call to GTX to write a blank is a work-around that has
C no visible effect on the picture but causes GKS to send the clipping
C flag and clipping rectangle to a workstation even if nothing else had
C previously been sent to it, so don't take it out unless you know that
C the behavior of GKS in this regard has been changed.)
C
        CALL GQCLIP (IERR,IGCF,DUMI)
C
        IF (IERR.NE.0) THEN
          CALL SETER ('MDRGOL - ERROR EXIT FROM GQCLIP',4,1)
          RETURN
        END IF
C
        CALL GTX    (CFUX(.5),CFUY(.5),' ')
C
        CALL GSCLIP (1)
C
C Save the current polyline color.
C
        CALL GQPLCI (IERR,IPLC)
C
        IF (IERR.NE.0) THEN
          CALL SETER ('MDRGOL - ERROR EXIT FROM GQPLCI',5,1)
          RETURN
        END IF
C
C Look for 1-degree lat/lon "squares" that are visible and plot
C polylines in them.
C
        NPTS=7
C
C Set the flag IWGF to say whether or not the whole globe is shown by
C the current projection.  If so (IWGF=1), there's no need to waste the
C time required to check each 1-degree square for intersection with
C the window.
C
        IWGF=0
        IF (BLAM-SLAM.GT.179.D0.AND.BLOM-SLOM.GT.359.D0) IWGF=1
C
C Loop through all the 1-degree lat/lon squares; for each one, do a
C quick test to see if the square is entirely invisible and, if not,
C do more exhaustive tests to see if part of it is visible.
C
        DO 105 ILON=0,359
          IF (IWGF.EQ.0.AND.
     +        (DBLE(ILON   ).GT.BLOM.OR.
     +         DBLE(ILON+1 ).LT.SLOM).AND.
     +        (DBLE(ILON-360).GT.BLOM.OR.
     +         DBLE(ILON-359).LT.SLOM).AND.
     +        (DBLE(ILON+360).GT.BLOM.OR.
     +         DBLE(ILON+361).LT.SLOM))                        GO TO 105
          DO 104 ILAT = -90,89
            IF (IWGF.EQ.0.AND.
     +          (DBLE(ILAT).GT.BLAM.OR.DBLE(ILAT+1).LT.SLAM))  GO TO 104
            DO 102 I=1,NPTS
              P=DBLE(I-1)/DBLE(NPTS-1)
              DO 101 J=1,NPTS
                Q=DBLE(J-1)/DBLE(NPTS-1)
                CALL MDPTRA (DBLE(ILAT)+P,DBLE(ILON)+Q,UPRJ,VPRJ)
                IF (UPRJ.NE.1.D12)                             GO TO 103
                CALL MDPTRI (UMIN+P*(UMAX-UMIN),VMIN+Q*(VMAX-VMIN),
     +                                                   RLAT,RLON)
                IF (RLON.LT.DBLE(ILON)) RLON=RLON+360.D0
                IF (RLON.GT.DBLE(ILON+360)) RLON=RLON-360.D0
                IF (RLAT.GE.DBLE(ILAT).AND.RLAT.LE.DBLE(ILAT+1).AND.
     +              RLON.GE.DBLE(ILON).AND.RLON.LE.DBLE(ILON+1))
     +                                                         GO TO 103
  101         CONTINUE
  102       CONTINUE
                                                               GO TO 104
  103       IF (IDPF.EQ.0) THEN
              CALL MDRGSQ (ICAT,ICEL,IRIM,ILAT,ILON,0,
     +                                       RWRK,RWRK(LRWK/2+1),LRWK/2)
            ELSE
              CALL MDRGSX (ICAT,ICEL,IRIM,ILAT,ILON,0,IRGL,
     +                                IAMA,1,RWRK,RWRK(LRWK/2+1),LRWK/2)
            END IF
            IF (ICFELL('MDRGOL',6).NE.0)                       GO TO 106
  104     CONTINUE
  105   CONTINUE
C
C Restore the polyline color to its original value.
C
  106   CALL GSPLCI (IPLC)
C
C Reset the clipping flag.
C
        CALL GSCLIP (IGCF)
C
C Close all RANGS/GSHHS files.
C
        CALL NGCLFI (ICAT)
        CALL NGCLFI (ICEL)
        CALL NGCLFI (IRIM)
C
C Done.
C
        RETURN
C
      END

c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by UCAR                 .
c  .                                                             .
c  .       University Corporation for Atmospheric Research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                         SPHEREPACK                          .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c
c
c ... file islapgc.f
c
c     this file includes documentation and code for
c     subroutine islapgc         i
c
c ... files which must be loaded with islapgc.f
c
c     sphcom.f, hrfft.f, shagc.f, shsgc.f
c
c     subroutine islapgc(nlat,nlon,isym,nt,xlmbda,sf,ids,jds,a,b,
c    +mdab,ndab,wshsgc,lshsgc,work,lwork,pertrb,ierror)
c
c     islapgc inverts the laplace or helmholz operator on a Gaussian
c     grid using o(n**2) storage. given the
c     spherical harmonic coefficients a(m,n) and b(m,n) of the right
c     hand side slap(i,j), islapgc computes a solution sf(i,j) to
c     the following helmhotz equation :
c
c           2                2
c     [d(sf(i,j))/dlambda /sint + d(sint*d(sf(i,j))/dtheta)/dtheta]/sint
c
c                   - xlmbda * sf(i,j) = slap(i,j)
c
C*PL*ERROR* Comment line too long
c      where sf(i,j) is computed at the Gaussian colatitude point theta(i)
c      (see nlat as an input argument) and longitude
c
c                 lambda(j) = (j-1)*2*pi/nlon
c
c            for i=1,...,nlat and j=1,...,nlon.
c
c
c     input parameters
c
c     nlat   the number of points in the gaussian colatitude grid on the
C*PL*ERROR* Comment line too long
c            full sphere. these lie in the interval (0,pi) and are computed
C*PL*ERROR* Comment line too long
c            in radians in theta(1) <...< theta(nlat) by subroutine gaqd.
C*PL*ERROR* Comment line too long
c            if nlat is odd the equator will be included as the grid point
c            theta((nlat+1)/2).  if nlat is even the equator will be
c            excluded as a grid point and will lie half way between
c            theta(nlat/2) and theta(nlat/2+1). nlat must be at least 3.
c            note: on the half sphere, the number of grid points in the
c            colatitudinal direction is nlat/2 if nlat is even or
c            (nlat+1)/2 if nlat is odd.
c
c     nlon   the number of distinct longitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater
c            than zero. the axisymmetric case corresponds to nlon=1.
c            the efficiency of the computation is improved when nlon
c            is a product of small prime numbers.
c
C*PL*ERROR* Comment line too long
c     isym   this parameter should have the same value input to subroutine
C*PL*ERROR* Comment line too long
c            shagc to compute the coefficients a and b for the scalar field
c            slap.  isym is set as follows:
c
c            = 0  no symmetries exist in slap about the equator. scalar
c                 synthesis is used to compute sf on the entire sphere.
c                 i.e., in the array sf(i,j) for i=1,...,nlat and
c                 j=1,...,nlon.
c
c           = 1  sf and slap are antisymmetric about the equator. the
c                synthesis used to compute sf is performed on the
c                northern hemisphere only.  if nlat is odd, sf(i,j) is
c                computed for i=1,...,(nlat+1)/2 and j=1,...,nlon.  if
c                nlat is even, sf(i,j) is computed for i=1,...,nlat/2
c                and j=1,...,nlon.
c
c
c           = 2  sf and slap are symmetric about the equator. the
c                synthesis used to compute sf is performed on the
c                northern hemisphere only.  if nlat is odd, sf(i,j) is
c                computed for i=1,...,(nlat+1)/2 and j=1,...,nlon.  if
c                nlat is even, sf(i,j) is computed for i=1,...,nlat/2
c                and j=1,...,nlon.
c
c
c   nt       the number of solutions. in the program that calls islapgc
c            the arrays sf,a, and b can be three dimensional in which
c            case multiple solutions are computed. the third index
c            is the solution index with values k=1,...,nt.
c            for a single solution set nt=1. the description of the
c            remaining parameters is simplified by assuming that nt=1
c            and sf,a,b are two dimensional.
c
c   xlmbda   a one dimensional array with nt elements. if xlmbda is
c            is identically zero islapgc solves poisson's equation.
c            if xlmbda > 0.0 islapgc solves the helmholtz equation.
c            if xlmbda < 0.0 the nonfatal error flag ierror=-1 is
c            returned. negative xlambda could result in a division
c            by zero.
c
c   ids      the first dimension of the array sf as it appears in the
C*PL*ERROR* Comment line too long
c            program that calls islapgc.  if isym = 0 then ids must be at
c            least nlat.  if isym > 0 and nlat is even then ids must be
c            at least nlat/2. if isym > 0 and nlat is odd then ids must
c            be at least (nlat+1)/2.
c
c   jds      the second dimension of the array sf as it appears in the
c            program that calls islapgc. jds must be at least nlon.
c
c
c   a,b      two or three dimensional arrays (see input parameter nt)
c            that contain scalar spherical harmonic coefficients
c            of the scalar field slap. a,b must be computed by shagc
c            prior to calling islapgc.
c
c
c   mdab     the first dimension of the arrays a and b as it appears
c            in the program that calls islapgc.  mdab must be at
c            least min0(nlat,(nlon+2)/2) if nlon is even or at least
c            min0(nlat,(nlon+1)/2) if nlon is odd.
c
c   ndab     the second dimension of the arrays a and b as it appears
c            in the program that calls islapgc. ndbc must be at least
c            least nlat.
c
c            mdab,ndab should have the same values input to shagc to
c            compute the coefficients a and b.
c
c     wshsgc an array which must be initialized by subroutine shsgci
c            once initialized, wshsgc can be used repeatedly by islapgc
c            as long as nlon and nlat remain unchanged.  wshsgc must
c            not be altered between calls of islapgc.
c
c
c    lshsgc  the dimension of the array wshsgc as it appears in the
c            program that calls islapgc.  let
c
c               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            then lshsgc must be at least
c
c               nlat*(2*l2+3*l1-2)+3*l1*(1-l1)/2+nlon+15
c
c     work   a work array that does not have to be saved.
c
c     lwork  the dimension of the array work as it appears in the
c            program that calls islapgc. define
c
c               l2 = nlat/2                    if nlat is even or
c               l2 = (nlat+1)/2                if nlat is odd
c               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            if isym = 0 let
c
c               lwkmin = nlat*(2*nt*nlon+max0(6*l2,nlon)+2*nt*l1+1).
c
c            if isym > 0 let
c
C*PL*ERROR* Comment line too long
c               lwkmin = l2*(2*nt*nlon+max0(6*nlat,nlon))+nlat*(2*nt*l1+1)
c
c
c     then lwork must be greater than or equal to lwkmin (see ierror=10)
c
c     **************************************************************
c
c     output parameters
c
c
C*PL*ERROR* Comment line too long
c    sf      a two or three dimensional arrays (see input parameter nt) that
c            inverts the scalar laplacian in slap.  sf(i,j) is given at
c            the colatitude
c
c                 theta(i) = (i-1)*pi/(nlat-1)
c
c            and longitude
c
c                 lambda(j) = (j-1)*2*pi/nlon
c
c            for i=1,...,nlat and j=1,...,nlon.
c
c   pertrb  a one dimensional array with nt elements (see input
c           parameter nt). in the discription that follows we assume
c           that nt=1. if xlmbda > 0.0 then pertrb=0.0 is always
c           returned because the helmholtz operator is invertible.
c           if xlmbda = 0.0 then a solution exists only if a(1,1)
c           is zero. islapgc sets a(1,1) to zero. the resulting
c           solution sf(i,j) solves poisson's equation with
c           pertrb = a(1,1)/(2.*sqrt(2.)) subtracted from the
c           right side slap(i,j).
c
C*PL*ERROR* Comment line too long
c  ierror    a parameter which flags errors in input parameters as follows:
c
c            = 0  no errors detected
c
c            = 1  error in the specification of nlat
c
c            = 2  error in the specification of nlon
c
c            = 3  error in the specification of ityp
c
c            = 4  error in the specification of nt
c
c            = 5  error in the specification of ids
c
c            = 6  error in the specification of jds
c
c            = 7  error in the specification of mdbc
c
c            = 8  error in the specification of ndbc
c
c            = 9  error in the specification of lshsgc
c
c            = 10 error in the specification of lwork
c
c
c **********************************************************************
c
c     end of documentation for islapgc
c
c **********************************************************************
c
      SUBROUTINE DISLAPGC(NLAT,NLON,ISYM,NT,XLMBDA,SF,IDS,JDS,A,B,MDAB,
     +                   NDAB,WSHSGC,LSHSGC,WORK,LWORK,PERTRB,IERROR)
      DOUBLE PRECISION XLMBDA
      DOUBLE PRECISION SF
      DOUBLE PRECISION A
      DOUBLE PRECISION B
      DOUBLE PRECISION WSHSGC
      DOUBLE PRECISION WORK
      DOUBLE PRECISION PERTRB
      DIMENSION SF(IDS,JDS,NT),A(MDAB,NDAB,NT),B(MDAB,NDAB,NT)
      DIMENSION WSHSGC(LSHSGC),WORK(LWORK),XLMBDA(NT),PERTRB(NT)
c
c     check input parameters
c
      IERROR = 1
      IF (NLAT.LT.3) RETURN
      IERROR = 2
      IF (NLON.LT.4) RETURN
      IERROR = 3
      IF (ISYM.LT.0 .OR. ISYM.GT.2) RETURN
      IERROR = 4
      IF (NT.LT.0) RETURN
      IERROR = 5
      IMID = (NLAT+1)/2
      IF ((ISYM.EQ.0.AND.IDS.LT.NLAT) .OR.
     +    (ISYM.GT.0.AND.IDS.LT.IMID)) RETURN
      IERROR = 6
      IF (JDS.LT.NLON) RETURN
      IERROR = 7
      MMAX = MIN0(NLAT,NLON/2+1)
      IF (MDAB.LT.MMAX) RETURN
      IERROR = 8
      IF (NDAB.LT.NLAT) RETURN
      IERROR = 9
c
c     set and verify saved work space length
c
c
      L1 = MIN0(NLAT, (NLON+2)/2)
      L2 = (NLAT+1)/2
      LWMIN = NLAT* (2*L2+3*L1-2) + 3*L1* (1-L1)/2 + NLON + 15
      IF (LSHSGC.LT.LWMIN) RETURN
      IERROR = 10
c
c     set and verify unsaved work space length
c
      LS = NLAT
      IF (ISYM.GT.0) LS = IMID
      NLN = NT*LS*NLON
      MN = MMAX*NLAT*NT
c     lwmin = nln+ls*nlon+2*mn+nlat
c     if (lwork .lt. lwmin) return
      IF (ISYM.EQ.0) THEN
          LWMIN = NLAT* (2*NT*NLON+MAX0(6*L2,NLON)+2*L1*NT+1)
      ELSE
          LWMIN = L2* (2*NT*NLON+MAX0(6*NLAT,NLON)) + NLAT* (2*L1*NT+1)
      END IF
      IF (LWORK.LT.LWMIN) RETURN
      IERROR = 0
c
c     check sign of xlmbda
c
      DO K = 1,NT
          IF (XLMBDA(K).LT.0.0D0) THEN
              IERROR = -1
          END IF
      END DO
c
c     set work space pointers
c
      IA = 1
      IB = IA + MN
      IFN = IB + MN
      IWK = IFN + NLAT
      LWK = LWORK - 2*MN - NLAT
      CALL DISLPGC1(NLAT,NLON,ISYM,NT,XLMBDA,SF,IDS,JDS,A,B,MDAB,NDAB,
     +             WORK(IA),WORK(IB),MMAX,WORK(IFN),WSHSGC,LSHSGC,
     +             WORK(IWK),LWK,PERTRB,IERROR)
      RETURN
      END

      SUBROUTINE DISLPGC1(NLAT,NLON,ISYM,NT,XLMBDA,SF,IDS,JDS,A,B,MDAB,
     +                   NDAB,AS,BS,MMAX,FNN,WSAV,LSAV,WK,LWK,PERTRB,
     +                   IERROR)
      DOUBLE PRECISION XLMBDA
      DOUBLE PRECISION SF
      DOUBLE PRECISION A
      DOUBLE PRECISION B
      DOUBLE PRECISION AS
      DOUBLE PRECISION BS
      DOUBLE PRECISION FNN
      DOUBLE PRECISION WSAV
      DOUBLE PRECISION WK
      DOUBLE PRECISION PERTRB
      DOUBLE PRECISION FN
      DIMENSION SF(IDS,JDS,NT),A(MDAB,NDAB,NT),B(MDAB,NDAB,NT)
      DIMENSION AS(MMAX,NLAT,NT),BS(MMAX,NLAT,NT),FNN(NLAT)
      DIMENSION WSAV(LSAV),WK(LWK),XLMBDA(NT),PERTRB(NT)
c
c     set multipliers and preset synthesis coefficients to zero
c
      DO N = 1,NLAT
          FN = DBLE(N-1)
          FNN(N) = FN* (FN+1.0D0)
          DO M = 1,MMAX
              DO K = 1,NT
                  AS(M,N,K) = 0.0D0
                  BS(M,N,K) = 0.0D0
              END DO
          END DO
      END DO

      DO K = 1,NT
c
c     compute synthesis coefficients for xlmbda zero or nonzero
c
          IF (XLMBDA(K).EQ.0.0D0) THEN
              DO N = 2,NLAT
                  AS(1,N,K) = -A(1,N,K)/FNN(N)
                  BS(1,N,K) = -B(1,N,K)/FNN(N)
              END DO
              DO M = 2,MMAX
                  DO N = M,NLAT
                      AS(M,N,K) = -A(M,N,K)/FNN(N)
                      BS(M,N,K) = -B(M,N,K)/FNN(N)
                  END DO
              END DO
          ELSE
c
c     xlmbda nonzero so operator invertible unless
c     -n*(n-1) = xlmbda(k) < 0.0  for some n
c
              PERTRB(K) = 0.0D0
              DO N = 1,NLAT
                  AS(1,N,K) = -A(1,N,K)/ (FNN(N)+XLMBDA(K))
                  BS(1,N,K) = -B(1,N,K)/ (FNN(N)+XLMBDA(K))
              END DO
              DO M = 2,MMAX
                  DO N = M,NLAT
                      AS(M,N,K) = -A(M,N,K)/ (FNN(N)+XLMBDA(K))
                      BS(M,N,K) = -B(M,N,K)/ (FNN(N)+XLMBDA(K))
                  END DO
              END DO
          END IF
      END DO
c
c     synthesize as,bs into sf
c
      CALL DSHSGC(NLAT,NLON,ISYM,NT,SF,IDS,JDS,AS,BS,MMAX,NLAT,WSAV,
     +            LSAV,WK,LWK,IERROR)
      RETURN
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C   FFTPACK 5.0
C   Copyright (C) 1995-2004, Scientific Computing Division,
C   University Corporation for Atmospheric Research
C   Licensed under the GNU General Public License (GPL)
C
C   Authors:  Paul N. Swarztrauber and Richard A. Valent
C
C   $Id: c1fgkb.f,v 1.2 2006-11-21 01:10:15 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      SUBROUTINE DC1FGKB(IDO,IP,L1,LID,NA,CC,CC1,IN1,CH,CH1,IN2,WA)
      DOUBLE PRECISION WAR
      DOUBLE PRECISION WAI
      DOUBLE PRECISION CHOLD1
      DOUBLE PRECISION CHOLD2
      DOUBLE PRECISION CH(IN2,L1,IDO,IP),CC(IN1,L1,IP,IDO),
     +                 CC1(IN1,LID,IP),CH1(IN2,LID,IP),WA(IDO,IP-1,2)
C
C FFTPACK 5.0 auxiliary routine
C
      IPP2 = IP + 2
      IPPH = (IP+1)/2
      DO 110 KI = 1,LID
          CH1(1,KI,1) = CC1(1,KI,1)
          CH1(2,KI,1) = CC1(2,KI,1)
  110 CONTINUE
      DO 111 J = 2,IPPH
          JC = IPP2 - J
          DO 112 KI = 1,LID
              CH1(1,KI,J) = CC1(1,KI,J) + CC1(1,KI,JC)
              CH1(1,KI,JC) = CC1(1,KI,J) - CC1(1,KI,JC)
              CH1(2,KI,J) = CC1(2,KI,J) + CC1(2,KI,JC)
              CH1(2,KI,JC) = CC1(2,KI,J) - CC1(2,KI,JC)
  112     CONTINUE
  111 CONTINUE
      DO 118 J = 2,IPPH
          DO 117 KI = 1,LID
              CC1(1,KI,1) = CC1(1,KI,1) + CH1(1,KI,J)
              CC1(2,KI,1) = CC1(2,KI,1) + CH1(2,KI,J)
  117     CONTINUE
  118 CONTINUE
      DO 116 L = 2,IPPH
          LC = IPP2 - L
          DO 113 KI = 1,LID
              CC1(1,KI,L) = CH1(1,KI,1) + WA(1,L-1,1)*CH1(1,KI,2)
              CC1(1,KI,LC) = WA(1,L-1,2)*CH1(1,KI,IP)
              CC1(2,KI,L) = CH1(2,KI,1) + WA(1,L-1,1)*CH1(2,KI,2)
              CC1(2,KI,LC) = WA(1,L-1,2)*CH1(2,KI,IP)
  113     CONTINUE
          DO 115 J = 3,IPPH
              JC = IPP2 - J
              IDLJ = MOD((L-1)* (J-1),IP)
              WAR = WA(1,IDLJ,1)
              WAI = WA(1,IDLJ,2)
              DO 114 KI = 1,LID
                  CC1(1,KI,L) = CC1(1,KI,L) + WAR*CH1(1,KI,J)
                  CC1(1,KI,LC) = CC1(1,KI,LC) + WAI*CH1(1,KI,JC)
                  CC1(2,KI,L) = CC1(2,KI,L) + WAR*CH1(2,KI,J)
                  CC1(2,KI,LC) = CC1(2,KI,LC) + WAI*CH1(2,KI,JC)
  114         CONTINUE
  115     CONTINUE
  116 CONTINUE
      IF (IDO.GT.1 .OR. NA.EQ.1) GO TO 136
      DO 120 J = 2,IPPH
          JC = IPP2 - J
          DO 119 KI = 1,LID
              CHOLD1 = CC1(1,KI,J) - CC1(2,KI,JC)
              CHOLD2 = CC1(1,KI,J) + CC1(2,KI,JC)
              CC1(1,KI,J) = CHOLD1
              CC1(2,KI,JC) = CC1(2,KI,J) - CC1(1,KI,JC)
              CC1(2,KI,J) = CC1(2,KI,J) + CC1(1,KI,JC)
              CC1(1,KI,JC) = CHOLD2
  119     CONTINUE
  120 CONTINUE
      RETURN
  136 DO 137 KI = 1,LID
          CH1(1,KI,1) = CC1(1,KI,1)
          CH1(2,KI,1) = CC1(2,KI,1)
  137 CONTINUE
      DO 135 J = 2,IPPH
          JC = IPP2 - J
          DO 134 KI = 1,LID
              CH1(1,KI,J) = CC1(1,KI,J) - CC1(2,KI,JC)
              CH1(1,KI,JC) = CC1(1,KI,J) + CC1(2,KI,JC)
              CH1(2,KI,JC) = CC1(2,KI,J) - CC1(1,KI,JC)
              CH1(2,KI,J) = CC1(2,KI,J) + CC1(1,KI,JC)
  134     CONTINUE
  135 CONTINUE
      IF (IDO.EQ.1) RETURN
      DO 131 I = 1,IDO
          DO 130 K = 1,L1
              CC(1,K,1,I) = CH(1,K,I,1)
              CC(2,K,1,I) = CH(2,K,I,1)
  130     CONTINUE
  131 CONTINUE
      DO 123 J = 2,IP
          DO 122 K = 1,L1
              CC(1,K,J,1) = CH(1,K,1,J)
              CC(2,K,J,1) = CH(2,K,1,J)
  122     CONTINUE
  123 CONTINUE
      DO 126 J = 2,IP
          DO 125 I = 2,IDO
              DO 124 K = 1,L1
                  CC(1,K,J,I) = WA(I,J-1,1)*CH(1,K,I,J) -
     +                          WA(I,J-1,2)*CH(2,K,I,J)
                  CC(2,K,J,I) = WA(I,J-1,1)*CH(2,K,I,J) +
     +                          WA(I,J-1,2)*CH(1,K,I,J)
  124         CONTINUE
  125     CONTINUE
  126 CONTINUE
      RETURN
      END

C NCLFORTSTART                                                                    
      subroutine cloudfrac(pres,rh,lowc,midc,highc,nz,ns,ew)

      implicit none
      integer  nz,ns,ew
      double precision pres(ew,ns,nz),rh(ew,ns,nz)
      double precision lowc(ew,ns),midc(ew,ns),highc(ew,ns)
C NCLEND

      integer i,j,k
      integer kchi,kcmi,kclo 

      kclo = 0
      kcmi = 0
      kchi = 0

      DO j = 1,ns
      DO i = 1,ew
         DO k = 1,nz-1

c          if((pres(i,j,k) .ge. 45000. ) .and.
c     &        (pres(i,j,k) .lt. 80000.))  then
c              kchi = k             

c          else if((pres(i,j,k) .ge. 80000.) .and.
c     &        (pres(i,j,k) .lt. 97000.)) then
c              kcmi = k

c         else if (pres(i,j,k) .ge. 97000.) then 
c              kclo = k
c         end if
          IF ( pres(i,j,k) .gt. 97000.d0 ) kclo=k
          IF ( pres(i,j,k) .gt. 80000.d0 ) kcmi=k
          IF ( pres(i,j,k) .gt. 45000.d0 ) kchi=k
   
        end do

        DO k = 1,nz-1
          IF ( k .ge. kclo .AND. k .lt. kcmi ) then          
               lowc(i,j) = AMAX1(rh(i,j,k),lowc(i,j))
          else IF ( k .ge. kcmi .AND. k .lt. kchi ) then              !! mid cloud
              midc(i,j) = AMAX1(rh(i,j,k),midc(i,j))
          else if ( k .ge. kchi )  then                               !! high cloud
              highc(i,j) = AMAX1(rh(i,j,k),highc(i,j)) 
          end if
        END DO


        lowc(i,j)  = 4.d0 * lowc(i,j)/100.d0-3.d0
        midc(i,j)  = 4.d0 * midc(i,j)/100.d0-3.d0
        highc(i,j) = 2.5d0 * highc(i,j)/100.d0-1.5d0

       lowc(i,j)  = amin1(lowc(i,j),1.d0)
       lowc(i,j)  = amax1(lowc(i,j),0.d0)
       midc(i,j)  = amin1(midc(i,j),1.d0)
       midc(i,j)  = amax1(midc(i,j),0.d0)
       highc(i,j) = amin1(highc(i,j),1.d0)
       highc(i,j) = amax1(highc(i,j),0.d0)

       END DO
       END DO
       return
       end

      SUBROUTINE DFO2F(GOFF,ILON,JLAT,GREG,JLAT1,WORK,LWORK,WSAVE,
     +                 LSAVEX,IOFF,IER)

      INTEGER ILON,JLAT,JLAT1,IOFF
      DOUBLE PRECISION GOFF(ILON,JLAT)
      INTEGER IER
      DOUBLE PRECISION GREG(ILON,JLAT1)


      DOUBLE PRECISION WORK(LWORK)
      DOUBLE PRECISION WSAVE(LSAVEX)
      INTEGER LWORK,LSAVEX
      INTEGER LSAVE

      IER = 0
      IF (ILON.LT.4 .OR. JLAT.LT.3) IER = 10
      IF ((JLAT1-JLAT).NE.1) IER = IER + 100
      IF (IER.NE.0) RETURN

      LSAVE = 2* (2*JLAT1+ILON+16)
      LSAVE = (10*LSAVE)/9
      CALL DSSHIFTI(IOFF,ILON,JLAT,LSAVE,WSAVE,IER)
      CALL DSSHIFTE(IOFF,ILON,JLAT,GOFF,GREG,WSAVE,LSAVE,WORK,LWORK,IER)

      RETURN
      END

C
C	$Id: gqcf.f,v 1.6 2008-07-27 00:20:58 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GQCF(WTYPE,ERRIND,NCOLI,COLA,NPCI)
C
C  INQUIRE COLOUR FACILITIES
C
      include 'gkscom.h'
C
      INTEGER WTYPE,ERRIND,NCOLI,COLA,NPCI
C
C  Check if GKS is in proper state.
C
      CALL GZCKST(8,-1,ERRIND)
      IF (ERRIND .NE. 0) GOTO 100
C
C  Check if the workstation type is valid.
C
      CALL GZCKWK(22,-1,IDUM,WTYPE,ERRIND)
      IF (ERRIND .NE. 0) GO TO 100
C
C  Check if the workstation category is OUTPUT or OUTIN.
C
      CALL GQWKCA(WTYPE,ERRIND,ICAT)
      IF (ICAT.NE.GOUTPT .AND. ICAT.NE.GOUTIN) THEN
        ERRIND = 39
        GO TO 100
      ENDIF
C
      IF (ERRIND .NE. 0) GO TO 100
      ERRIND = 0
      IF (WTYPE.EQ.GXWC .OR. WTYPE.EQ.GXWE .OR. WTYPE.EQ.GDMP .OR.
     +    WTYPE.EQ.GPIX) THEN
        NCOLI  = 256
        COLA   = 1
        NPCI   = 4
      ELSE
        GO TO 100
      ENDIF
      RETURN
C
  100 CONTINUE
      NCOLI = -1
      COLA  = -1
      NPCI  = -1
C
      RETURN
      END

      PROGRAM FFEX02
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C This program requires the input data file 'ffex02.dat'
C It reads the data from standard input, e.g.: ffex02 < ffex02.dat
C
      PARAMETER (MSIZE=36, NSIZE=33, NCLRS=14)
C
      DIMENSION U(MSIZE,NSIZE), V(MSIZE,NSIZE), P(MSIZE,NSIZE)
C
C Define a set of RGB color triples
C
      DIMENSION RGBV(3,NCLRS)
C
      DATA RGBV / 
     +     0.0,1.0,1.0,
     +     0.0745098,0.92549,0.92549,
     +     0.152941,0.847059,0.847059,
     +     0.231373,0.768627,0.768627,
     +     0.305882,0.694118,0.694118,
     +     0.384314,0.615686,0.615686,
     +     0.462745,0.537255,0.537255,
     +     0.537255,0.462745,0.462745,
     +     0.615686,0.384314,0.384314,
     +     0.694118,0.305882,0.305882,
     +     0.768627,0.231373,0.23137,
     +     0.847059,0.152941,0.152941,
     +     0.92549,0.0745098,0.074509,
     +     1.0,0.0,0.0 /
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Read the input array data
C
      CALL RDDATA(U,V,P,MSIZE,NSIZE)
C
C Set up the EZMAP projection
C
      CALL MAPSET('CO',60.0,-120.0,23.0,-60.0)
      CALL MAPROJ('LC',0.0,-75.0,45.0)
      CALL MAPINT
C
C Tell Vectors to use the mapping established by EZMAP
C
      CALL VVSETI('MAP -- Mapping Flag', 1)
      CALL VVSETI('SET -- Set Call Flag', 0)
C
C Set up data coordinate boundaries and special value processing 
C appropriately for the dataset 
C
      CALL VVSETR('XC1 -- Lower X Bound', -140.0)
      CALL VVSETR('XCM -- Upper X Bound', -52.5)
      CALL VVSETR('YC1 -- Lower X Bound', 20.0)
      CALL VVSETR('YCN -- Upper Y Bound', 60.0)
C
      CALL VVSETI('SVF -- Special Values Flag', 3)
      CALL VVSETR('USV -- U Special Value', -9999.0)
      CALL VVSETR('VSV -- V Special Value', -9999.0)
      CALL VVSETR('PSV - P Special Value', -9999.0)
      CALL VVSETI('SPC - P Special Color', 1)
C
C Turn on statistics reporting
C
      CALL VVSETI('VST -- Vector Statistics', 1)
C
      DO 1000 IFRMNO = 1,4
C
C Draw the map with a grid
C
         CALL MAPLOT
         CALL MAPGRD
C
C Set up color processing
C
         IF (IFRMNO .EQ. 4) THEN
            CALL VVSETI('CTV -- Color Thresholds Value', 2)
            CALL VVSETI('NLV -- Number Of Levels', NCLRS)
            DO 100 I=1,NCLRS,1
               ICLRIX=2+(I-1)*200/NCLRS
               CALL GSCR(IWKID,ICLRIX,RGBV(1,I),RGBV(2,I),RGBV(3,I))
               CALL VVSETI('PAI -- Parameter Array Index', I)
               CALL VVSETI('CLR -- GKS Color Index', ICLRIX)
 100        CONTINUE
         END IF
C
C Initialize Vectors
C
         IF (IFRMNO .GT. 1) THEN
            CALL VVINIT (U,MSIZE,V,MSIZE,P,MSIZE,MSIZE,NSIZE,IDM,IDM)
         END IF
C
C Adjust vector rendering options
C
         IF (IFRMNO .EQ. 3) THEN
            CALL VVSETR('AMN -- Arrow Minimum Size',0.007)
            CALL VVSETR('LWD -- Vector Line Width',1.75)
            CALL VVGETR('VMN -- Minimum Vector',VMN)
            CALL VVGETR('VMX -- Maximum Vector',VMX)
            CALL VVSETR('VLC -- Vector Low Cutoff',VMN+0.125*(VMX-VMN))
            CALL VVGETR('DMX -- Device Maximum Vector Length',DMX)
            CALL GETSET(VL,VR,VB,VT,UL,UR,UB,UT,LL)
            CALL VVSETR('VRL - Vector Realized Length',1.8*DMX/(VR-VL))
            CALL VVSETR('VFR -- Vector Fractional Minimum',0.33)
         END IF
C
C Draw the vector field plot
C
         IF (IFRMNO .GT. 1) THEN
            CALL VVECTR (U,V,P,IDM,IDM,IDM)
         END IF
C
C Draw a perimeter boundary and eject the frame
C
         CALL PERIM(1,0,1,0)
         CALL FRAME
C
 1000 CONTINUE
C
C     Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      STOP
      END
C
      SUBROUTINE RDDATA(U,V,P,M,N)
C
C Read the data arrays from the standard input 
C
      DIMENSION U(M,N), V(M,N), P(M,N)
C     
      READ (*,*) U
      READ (*,*) V
      READ (*,*) P
C
      RETURN
      END

C
C $Id: phi4sp.f,v 1.5 2008-07-27 00:17:10 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE PHI4SP (ECCNTS,E0,E1,E2,E3,A,B,C,PHI)
C
C SUBROUTINE TO COMPUTE LATITUDE ANGLE (PHI-4).
C
      IMPLICIT REAL (A-Z)
      INTEGER II,NIT
      COMMON /ERRMZ0/ IERR
        INTEGER IERR
      SAVE   /ERRMZ0/
      COMMON /PRINZ0/ IPEMSG,IPELUN,IPPARM,IPPLUN
        INTEGER IPEMSG,IPELUN,IPPARM,IPPLUN
      SAVE   /PRINZ0/
      DATA ONE,TWO,FOUR,SIX /1.0E0,2.0E0,4.0E0,6.0E0/
      DATA TOL,NIT /1.0E-10,15/
C
      PHI = A
      DO 020 II = 1,NIT
      SINPHI = SIN (PHI)
      TANPHI = TAN (PHI)
      C = TANPHI * SQRT (ONE - ECCNTS * SINPHI * SINPHI)
      SIN2PH = SIN (TWO * PHI)
      ML = E0 * PHI - E1 * SIN2PH + E2 * SIN (FOUR * PHI)
     .      - E3 * SIN (SIX * PHI)
      MLP = E0 - TWO * E1 * COS (TWO * PHI) + FOUR * E2 *
     .      COS (FOUR * PHI) - SIX * E3 * COS (SIX * PHI)
      CON1 = TWO * ML + C * (ML * ML + B) - TWO * A *
     .       (C * ML + ONE)
      CON2 = ECCNTS * SIN2PH * (ML * ML + B - TWO * A * ML) / (TWO * C)
      CON3 = TWO * (A - ML) * (C * MLP - TWO / SIN2PH) - TWO * MLP
      DPHI = CON1 / (CON2 + CON3)
      PHI = PHI + DPHI
      IF (ABS(DPHI) .GT. TOL) GO TO 020
      RETURN
  020 CONTINUE
C
      IF (IPEMSG .EQ. 0) WRITE (IPELUN,2000) NIT,E0,E1,E2,E3,A,B,C,
     . ECCNTS
 2000 FORMAT (/' ERROR PHI4SP' /
     .         ' LATITUDE FAILED TO CONVERGE AFTER',I3,' ITERATIONS'/
     .         ' E0 =',E25.16,'   E1 =',E25.16/
     .         ' E2 =',E25.16,'   E3 =',E25.16/
     .         ' A  =',E25.16,'   B  =',E25.16/
     .         ' C  =',E25.16/
     .         ' ECCENTRICITY SQUARE =',E25.16)
      IERR = 004
      RETURN
C
      END

C
C $Id: mdplmb.f,v 1.12 2008-09-18 00:42:17 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MDPLMB
C
C The routine MDPLMB is called by MDPGRD and/or MDPLOT to draw the limb
C lines.
C
C Declare required common blocks.  See MAPBDX for descriptions of these
C common blocks and the variables in them.
C
        COMMON /MAPCM0/  COS1,DTOR,DTRH,OOPI,PI,PIOF,PIOT,RTDD,RTOD,
     +                   SROT,SIN1,TOPI,TSRT
        DOUBLE PRECISION COS1,DTOR,DTRH,OOPI,PI,PIOF,PIOT,RTDD,RTOD,
     +                   SROT,SIN1,TOPI,TSRT
        SAVE   /MAPCM0/
C
        COMMON /MAPCM1/  COSO,COSR,SINO,SINR,IPRJ,IROD
        DOUBLE PRECISION COSO,COSR,SINO,SINR
        INTEGER          IPRJ,IROD
        SAVE   /MAPCM1/
C
        COMMON /MAPCM2/  BLAM,BLOM,PEPS,SLAM,SLOM,UCEN,UMAX,UMIN,UOFF,
     +                   URNG,VCEN,VMAX,VMIN,VOFF,VRNG,ISSL
        DOUBLE PRECISION BLAM,BLOM,PEPS,SLAM,SLOM,UCEN,UMAX,UMIN,UOFF,
     +                   URNG,VCEN,VMAX,VMIN,VOFF,VRNG
        INTEGER          ISSL
        SAVE   /MAPCM2/
C
        COMMON /MAPCM4/  GRDR,GRID,GRLA,GRLO,GRPO,OTOL,PDRE,PLA1,PLA2,
     +                   PLA3,PLA4,PLB1,PLB2,PLB3,PLB4,PLNO,PLTO,ROTA,
     +                   SRCH,XLOW,XROW,YBOW,YTOW,IDOT,IDSH,IDTL,ILCW,
     +                   ILTS,JPRJ,ELPF,INTF,LBLF,PRMF
        DOUBLE PRECISION GRDR,GRID,GRLA,GRLO,GRPO,OTOL,PDRE,PLA1,PLA2,
     +                   PLA3,PLA4,PLB1,PLB2,PLB3,PLB4,PLNO,PLTO,ROTA,
     +                   SRCH,XLOW,XROW,YBOW,YTOW
        INTEGER          IDOT,IDSH,IDTL,ILCW,ILTS,JPRJ
        LOGICAL          ELPF,INTF,LBLF,PRMF
        SAVE   /MAPCM4/
C
        COMMON /MAPCMA/  DATL,DBTD,DDTS,DPLT,DPSQ,DSCA,DSSQ
        DOUBLE PRECISION DATL,DBTD,DDTS,DPLT,DPSQ,DSCA,DSSQ
        SAVE   /MAPCMA/
C
        COMMON /MAPCMW/  CSLS,CSLT,SLTD,ISLT
        DOUBLE PRECISION CSLS,CSLT,SLTD
        INTEGER ISLT
        SAVE   /MAPCMW/
C
        COMMON /MAPSAT/  ALFA,BETA,DCSA,DCSB,DSNA,DSNB,SALT,SSMO,SRSS
        DOUBLE PRECISION ALFA,BETA,DCSA,DCSB,DSNA,DSNB,SALT,SSMO,SRSS
        SAVE   /MAPSAT/
C
        COMMON /MAPWNC/  WXMN,WXMX,WYMN,WYMX
        DOUBLE PRECISION WXMN,WXMX,WYMN,WYMX
        SAVE   /MAPWNC/
C
        COMMON /USGSC1/  UTPA(15),UUMN,UUMX,UVMN,UVMX,IPRF
        DOUBLE PRECISION UTPA,UUMN,UUMX,UVMN,UVMX
        INTEGER          IPRF
        SAVE   /USGSC1/
C
C Declare local variables.
C
        INTEGER          I,IPEN,IVIS,J,K
C
        DOUBLE PRECISION ALPH,CLAT,CLON,CRAD,DEPS,DIST,DLAT,DLON,COSA,
     +                   COSB,COSL,COSP,RLAT,RLON,SINA,SINB,SINL,SINP,
     +                   RVTU,SSLT,TLAT(361),TLON(361),U,UCIR,UEDG,UNS1,
     +                   UOLD,URAD,UTMP,V,VCIR,VEDG,VNS1,VOLD,VTMP,X,
     +                   XANP,XAS1,XAS2,YANP,YAS1,YAS2
C
C Declare arithmetic statement functions.
C
        DOUBLE PRECISION CEIL,FLOR
C
C Declare external functions.
C
        DOUBLE PRECISION RBGDFE,RBGLEN
C
C The arithmetic statement functions FLOR and CEIL give, respectively,
C the "floor" of X - the largest integer less than or equal to X - and
C the "ceiling" of X - the smallest integer greater than or equal to X.
C
        FLOR(X)=DINT(X+1.D4)-1.D4
        CEIL(X)=-FLOR(-X)
C
C Check for an uncleared prior error.
C
        IF (ICFELL('MDPLMB - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C If EZMAP needs initialization, do it.
C
        IF (INTF) THEN
          CALL MDPINT
          IF (ICFELL('MDPLMB',2).NE.0) RETURN
        END IF
C
C Reset the color index, dotting, and dash pattern for limb lines.
C
        CALL MDPCHI (4,0,IOR(ISHIFT(32767,1),1))
        IF (ICFELL('MDPLMB',3).NE.0) RETURN
C
C Draw limb lines, the nature of which depends on the projection.
C
C Projection:   US  LC  ST  OR  LE  GN  AE
C                   CE  ME  MT  RO  EA  AI  HA  MO  WT  (arbitrary)
C                   CE  ME  MT  RO  EA  AI  HA  MO  WT  (fast-path)
C                       RM
C
        GO TO (100,101,110,104,105,110,106,
     +             112,112,107,112,112,114,115,115,112,
     +             112,112,107,112,112,114,115,115,112,
     +                 112                            ) , IPRJ+1
C
C USGS transformations.
C
  100   IF (IPRF.EQ. 3.OR.IPRF.EQ. 4.OR.IPRF.EQ. 5.OR.IPRF.EQ. 7.OR.
     +      IPRF.EQ. 8.OR.IPRF.EQ.16.OR.IPRF.EQ.17.OR.IPRF.EQ.18.OR.
     +      IPRF.EQ.19.OR.IPRF.EQ.21) THEN
          IF (IPRF.EQ.3.OR.IPRF.EQ.8.OR.IPRF.EQ.17.OR.IPRF.EQ.18.OR.
     +        IPRF.EQ.21) THEN
            DLON=GRDR
            RLAT=-89.998D0
            K=CEIL(360.D0/DLON)
            DO 202 I=1,2
              RLON=UTPA(5)-180.D0
              CALL MDPIT (RLAT,RLON,0)
              IF (ICFELL('MDPLMB',4).NE.0) RETURN
              DO 201 J=1,K-1
                RLON=RLON+DLON
                CALL MDPIT (RLAT,RLON,1)
                IF (ICFELL('MDPLMB',5).NE.0) RETURN
  201         CONTINUE
              RLON=UTPA(5)+180.D0
              CALL MDPIT (RLAT,RLON,2)
              IF (ICFELL('MDPLMB',6).NE.0) RETURN
              CALL MDPIQ
              IF (ICFELL('MDPLMB',7).NE.0) RETURN
              RLAT=89.998D0
  202       CONTINUE
          END IF
          IF (IPRF.EQ.7) THEN
            DLON= 89.999999D0
          ELSE
            DLON=179.999999D0
          END IF
          DLAT=GRDR
          RLON=UTPA(5)+DLON
          K=CEIL(180.D0/DLAT)
          DO 204 I=1,2
            RLAT=-90.D0
            CALL MDPIT (RLAT,RLON,0)
            IF (ICFELL('MDPLMB',8).NE.0) RETURN
            DO 203 J=1,K-1
              RLAT=RLAT+DLAT
              CALL MDPIT (RLAT,RLON,1)
              IF (ICFELL('MDPLMB',9).NE.0) RETURN
  203       CONTINUE
            RLAT=90.D0
            CALL MDPIT (RLAT,RLON,2)
            IF (ICFELL('MDPLMB',10).NE.0) RETURN
            CALL MDPIQ
            IF (ICFELL('MDPLMB',11).NE.0) RETURN
            RLON=UTPA(5)-DLON
  204     CONTINUE
          GO TO 110
        ELSE IF (IPRF.EQ.9) THEN
          DLON=GRDR
          RLAT=-.001D0
          K=CEIL(180.D0/DLON)
          DO 206 I=1,2
            RLON=UTPA(5)+90.D0
            CALL MDPIT (RLAT,RLON,0)
            IF (ICFELL('MDPLMB',12).NE.0) RETURN
            DO 205 J=1,K-1
              RLON=RLON+DLON
              CALL MDPIT (RLAT,RLON,1)
              IF (ICFELL('MDPLMB',13).NE.0) RETURN
  205       CONTINUE
            RLON=UTPA(5)+270.D0
            CALL MDPIT (RLAT,RLON,2)
            IF (ICFELL('MDPLMB',14).NE.0) RETURN
            CALL MDPIQ
            IF (ICFELL('MDPLMB',15).NE.0) RETURN
            RLAT=.001D0
  206     CONTINUE
          GO TO 110
        ELSE IF (IPRF.EQ.11.OR.IPRF.EQ.12.OR.IPRF.EQ.14.OR.
     +                         IPRF.EQ.15.OR.IPRF.EQ.23) THEN
          IF (IPRF.EQ.11.OR.IPRF.EQ.12) THEN
            CLAT=UTPA(6)
            CLON=UTPA(5)
            CRAD=179.95D0
          ELSE IF (IPRF.EQ.14) THEN
            CLAT=UTPA(6)
            CLON=UTPA(5)
            CRAD=89.999D0
          ELSE IF (IPRF.EQ.15) THEN
            CLAT=UTPA(6)
            CLON=UTPA(5)
            CRAD=RTOD*ACOS(UTPA(1)/(UTPA(1)+UTPA(3)))-.001D0
          ELSE IF (IPRF.EQ.23) THEN
            CLAT=  64.D0
            CLON=-152.D0
            CRAD=  29.999D0
          END IF
          CALL MDGCOG (CLAT,CLON,CRAD,TLAT,TLON,361)
          CALL MDPIT (TLAT(1),TLON(1),0)
          IF (ICFELL('MDPLMB',16).NE.0) RETURN
          DO 207 I=2,360
            CALL MDPIT (TLAT(I),TLON(I),1)
            IF (ICFELL('MDPLMB',17).NE.0) RETURN
  207     CONTINUE
          CALL MDPIT (TLAT(361),TLON(361),2)
          IF (ICFELL('MDPLMB',18).NE.0) RETURN
          CALL MDPIQ
          IF (ICFELL('MDPLMB',19).NE.0) RETURN
          GO TO 110
        ELSE IF (IPRF.EQ.20) THEN
          ALPH=DTOR*(180.D0-UTPA(4))
          CALL MDPTRN (+90.D0,0.D0,XANP,YANP)
          IF (ICFELL('MDPLMB',20).NE.0) RETURN
          CALL MDPTRN (-90.D0,0.D0,XAS1,YAS1)
          IF (ICFELL('MDPLMB',21).NE.0) RETURN
          UNS1=(XAS1-XANP)*COS(ALPH)+(YAS1-YANP)*SIN(ALPH)
          VNS1=(YAS1-YANP)*COS(ALPH)-(XAS1-XANP)*SIN(ALPH)
          XAS2=XANP+VNS1*SIN(ALPH)+UNS1*COS(ALPH)
          YAS2=YANP+UNS1*SIN(ALPH)-VNS1*COS(ALPH)
          DIST=SQRT((XAS2-XAS1)*(XAS2-XAS1)+(YAS2-YAS1)*(YAS2-YAS1))
          IF (VNS1.LT.0.D0) THEN
            DEPS=-.001D0*DIST
          ELSE
            DEPS=+.001D0*DIST
          END IF
          DIST=2.D0*DIST
          WXMN=UMIN
          WXMX=UMAX
          WYMN=VMIN
          WYMX=VMAX
          CALL MDPWND (XAS1-DIST*COS(ALPH)+DEPS*SIN(ALPH),
     +                 YAS1-DIST*SIN(ALPH)-DEPS*COS(ALPH),0)
          IF (ICFELL('MDPLMB',22).NE.0) RETURN
          CALL MDPWND (XAS1+DIST*COS(ALPH)+DEPS*SIN(ALPH),
     +                 YAS1+DIST*SIN(ALPH)-DEPS*COS(ALPH),1)
          IF (ICFELL('MDPLMB',23).NE.0) RETURN
          CALL MDPWND (XAS2-DIST*COS(ALPH)-DEPS*SIN(ALPH),
     +                 YAS2-DIST*SIN(ALPH)+DEPS*COS(ALPH),0)
          IF (ICFELL('MDPLMB',24).NE.0) RETURN
          CALL MDPWND (XAS2+DIST*COS(ALPH)-DEPS*SIN(ALPH),
     +                 YAS2+DIST*SIN(ALPH)+DEPS*COS(ALPH),1)
          IF (ICFELL('MDPLMB',25).NE.0) RETURN
          GO TO 110
        ELSE
          GO TO 110
        END IF
C
C Lambert conformal conic with two standard parallels.
C
  101   DLAT=GRDR
        RLON=PLNO+179.999999D0
        K=CEIL(180.D0/DLAT)
        DO 103 I=1,2
          RLAT=-90.D0
          CALL MDPIT (RLAT,RLON,0)
          IF (ICFELL('MDPLMB',26).NE.0) RETURN
          DO 102 J=1,K-1
            RLAT=RLAT+DLAT
            CALL MDPIT (RLAT,RLON,1)
            IF (ICFELL('MDPLMB',27).NE.0) RETURN
  102     CONTINUE
          RLAT=90.D0
          CALL MDPIT (RLAT,RLON,2)
          IF (ICFELL('MDPLMB',28).NE.0) RETURN
          CALL MDPIQ
          IF (ICFELL('MDPLMB',29).NE.0) RETURN
          RLON=PLNO-179.999999D0
  103   CONTINUE
        GO TO 110
C
C Orthographic (or satellite-view).
C
  104   IF (ABS(SALT).LE.1.D0.OR.ALFA.EQ.0.D0) THEN
          URAD=1.D0
          RVTU=1.D0
          GO TO 108
        ELSE
          SSLT=SALT
          SALT=-ABS(SALT)
          IPEN=0
          COSA=1.D0/ABS(SALT)
          SINA=SQRT(1.D0-COSA*COSA)
          DO 111 I=1,361
            COSB=COS(DTOR*DBLE(I-1))
            SINB=SIN(DTOR*DBLE(I-1))
            SINL=SINA*SINB
            COSL=COSA*COSO-SINA*SINO*COSB
            COSP=SQRT(SINL*SINL+COSL*COSL)
            IF (COSP.NE.0.D0) THEN
              SINL=SINL/COSP
              COSL=COSL/COSP
            END IF
            IF (ABS(SINO).GT..000001D0) THEN
              SINP=(COSA-COSP*COSL*COSO)/SINO
            ELSE
              SINP=SINA*COSB
            END IF
            RLAT=RTOD*ATAN2(SINP,COSP)
            RLON=PLNO+RTOD*ATAN2(SINA*SINB,
     +                           COSA*COSO-SINA*SINO*COSB)
            IF (ABS(RLON).GT.180.D0) RLON=RLON-SIGN(360.D0,RLON)
            CALL MDPIT (RLAT,RLON,IPEN)
            IF (ICFELL('MDPLMB',30).NE.0) RETURN
            IPEN=1
  111     CONTINUE
          CALL MDPIQ
          IF (ICFELL('MDPLMB',31).NE.0) RETURN
          SALT=SSLT
          GO TO 110
        END IF
C
C Lambert equal-area.
C
  105   URAD=2.D0
        RVTU=1.D0
        GO TO 108
C
C Azimuthal equidistant.
C
  106   URAD=PI
        RVTU=1.D0
        GO TO 108
C
C Mollweide-type.
C
  107   URAD=2.D0
        RVTU=0.5D0
        GO TO 108
C
C Aitoff.
C
  114   URAD=PI
        RVTU=.5D0
        GO TO 108
C
C Hammer and true Mollweide.
C
  115   URAD=TSRT
        RVTU=.5D0
        GO TO 108
C
C Limb is a ellipse.  URAD is half the length of the horizontal axis
C and RVTU is the ratio of V to U.
C
  108   UCIR=URAD
        VCIR=0.D0
        IVIS=-1
        DO 109 I=1,361
          U=UCIR-UOFF
          V=RVTU*VCIR-VOFF
          IF (.NOT.ELPF.AND.
     +        (U.LT.UMIN.OR.U.GT.UMAX.OR.V.LT.VMIN.OR.V.GT.VMAX)) THEN
            IF (IVIS.EQ.1) THEN
              CALL MDPTRP (UOLD,VOLD,U,V,UEDG,VEDG)
              CALL MDPVP  (UOLD,VOLD,UEDG,VEDG)
              IF (ICFELL('MDPLMB',32).NE.0) RETURN
            END IF
            IVIS=0
          ELSE IF (ELPF.AND.
     +             (((U-UCEN)/URNG)**2+((V-VCEN)/VRNG)**2.GT.1.D0)) THEN
            IF (IVIS.EQ.1) THEN
              CALL MDPTRE (UOLD,VOLD,U,V,UEDG,VEDG)
              CALL MDPVP  (UOLD,VOLD,UEDG,VEDG)
              IF (ICFELL('MDPLMB',33).NE.0) RETURN
            END IF
            IVIS=0
          ELSE
            IF (IVIS.LT.0) THEN
              IF (IDTL.EQ.0) THEN
                CALL FRSTD (REAL(U),REAL(V))
                IF (ICFELL('MDPLMB',34).NE.0) RETURN
              ELSE
                DATL=0.D0
              END IF
              IVIS=1
            ELSE
              IF (IVIS.EQ.0) THEN
                IF (.NOT.ELPF) CALL MDPTRP (U,V,UOLD,VOLD,UOLD,VOLD)
                IF (     ELPF) CALL MDPTRE (U,V,UOLD,VOLD,UOLD,VOLD)
                IF (IDTL.EQ.0) THEN
                  CALL FRSTD (REAL(UOLD),REAL(VOLD))
                  IF (ICFELL('MDPLMB',35).NE.0) RETURN
                ELSE
                  DATL=0.D0
                END IF
                IVIS=1
              END IF
              CALL MDPVP (UOLD,VOLD,U,V)
              IF (ICFELL('MDPLMB',36).NE.0) RETURN
            END IF
          END IF
          UOLD=U
          VOLD=V
          UTMP=UCIR
          VTMP=VCIR
          UCIR=UTMP*COS1-VTMP*SIN1
          VCIR=UTMP*SIN1+VTMP*COS1
  109   CONTINUE
C
        GO TO 110
C
C Cylindrical equidistant, Mercator, Robinson, cylindrical equal-area,
C Winkel tripel.
C
  112   RLAT=-90.D0
        RLON=-180.D0
        IVIS=-1
C
        DO 113 I=1,361
          IF (IPRJ.EQ.7.OR.IPRJ.EQ.16) THEN
            U=RLON-UOFF
            V=RLAT/CSLT-VOFF
          ELSE IF (IPRJ.EQ.8.OR.IPRJ.EQ.17.OR.IPRJ.EQ.25) THEN
            U=DTOR*RLON-UOFF
            V=LOG(TAN((MAX(-89.999999D0,
     +                 MIN(+89.999999D0,RLAT))+90.D0)*DTRH))-VOFF
            IF (IPRJ.EQ.25) THEN
              UTMP=U*COSR+V*SINR
              VTMP=V*COSR-U*SINR
              U=UTMP
              V=VTMP
            END IF
          ELSE IF (IPRJ.EQ.11.OR.IPRJ.EQ.20) THEN
            U=DTOR*RLON-UOFF
            V=SIN(DTOR*RLAT)/CSLS-VOFF
          ELSE IF (IPRJ.EQ.15.OR.IPRJ.EQ.24) THEN
            CALL WTPROJ (DTOR*RLAT,DTOR*RLON,U,V,CSLT)
            U=U-UOFF
            V=V-VOFF
          ELSE
            U=(RLON/180.D0)*RBGLEN(RLAT)-UOFF
            V=RBGDFE(RLAT)-VOFF
          END IF
          IF (I.LE.90) THEN
            RLON=RLON+4.D0
          ELSE IF (I.LE.180) THEN
            RLAT=RLAT+2.D0
          ELSE IF (I.LE.270) THEN
            RLON=RLON-4.D0
          ELSE IF (I.LE.360) THEN
            RLAT=RLAT-2.D0
          END IF
          IF (.NOT.ELPF.AND.
     +        (U.LT.UMIN.OR.U.GT.UMAX.OR.V.LT.VMIN.OR.V.GT.VMAX)) THEN
            IF (IVIS.EQ.1) THEN
              CALL MDPTRP (UOLD,VOLD,U,V,UEDG,VEDG)
              CALL MDPVP  (UOLD,VOLD,UEDG,VEDG)
              IF (ICFELL('MDPLMB',37).NE.0) RETURN
            END IF
            IVIS=0
          ELSE IF (ELPF.AND.
     +             (((U-UCEN)/URNG)**2+((V-VCEN)/VRNG)**2.GT.1.D0)) THEN
            IF (IVIS.EQ.1) THEN
              CALL MDPTRE (UOLD,VOLD,U,V,UEDG,VEDG)
              CALL MDPVP  (UOLD,VOLD,UEDG,VEDG)
              IF (ICFELL('MDPLMB',38).NE.0) RETURN
            END IF
            IVIS=0
          ELSE
            IF (IVIS.LT.0) THEN
              IF (IDTL.EQ.0) THEN
                CALL FRSTD (REAL(U),REAL(V))
                IF (ICFELL('MDPLMB',39).NE.0) RETURN
              ELSE
                DATL=0.D0
              END IF
              IVIS=1
            ELSE
              IF (IVIS.EQ.0) THEN
                IF (.NOT.ELPF) CALL MDPTRP (U,V,UOLD,VOLD,UOLD,VOLD)
                IF (     ELPF) CALL MDPTRE (U,V,UOLD,VOLD,UOLD,VOLD)
                IF (IDTL.EQ.0) THEN
                  CALL FRSTD (REAL(UOLD),REAL(VOLD))
                  IF (ICFELL('MDPLMB',40).NE.0) RETURN
                ELSE
                  DATL=0.D0
                END IF
                IVIS=1
              END IF
              CALL MDPVP (UOLD,VOLD,U,V)
              IF (ICFELL('MDPLMB',41).NE.0) RETURN
            END IF
          END IF
          UOLD=U
          VOLD=V
  113   CONTINUE
C
C Restore the color index, dotting, and dash pattern.
C
  110   CALL MDPCHI (-4,0,0)
        IF (ICFELL('MDPLMB',42).NE.0) RETURN
C
C Done.
C
        RETURN
C
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C   FFTPACK 5.0
C   Copyright (C) 1995-2004, Scientific Computing Division,
C   University Corporation for Atmospheric Research
C   Licensed under the GNU General Public License (GPL)
C
C   Authors:  Paul N. Swarztrauber and Richard A. Valent
C
C   $Id: cfft2b.f,v 1.2 2006-11-21 01:10:16 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      SUBROUTINE DCFFT2B(LDIM,L,M,C,WSAVE,LENSAV,WORK,LENWRK,IER)
      INTEGER L,M,LDIM,LENSAV,LENWRK,IER
      DOUBLE COMPLEX C(LDIM,M)
      DOUBLE PRECISION WSAVE(LENSAV),WORK(LENWRK)
C
C Initialize error return
C
      IER = 0
C
      IF (L.GT.LDIM) THEN
          IER = 5
          CALL DXERFFT('CFFT2B',-2)
          GO TO 100
      ELSE IF (LENSAV.LT.2*L+INT(LOG(DBLE(L)))+2*M+INT(LOG(DBLE(M)))+
     +         8) THEN
          IER = 2
          CALL DXERFFT('CFFT2B',6)
          GO TO 100
      ELSE IF (LENWRK.LT.2*L*M) THEN
          IER = 3
          CALL DXERFFT('CFFT2B',8)
          GO TO 100
      END IF
C
C Transform X lines of C array
      IW = 2*L + INT(LOG(DBLE(L))*LOG(2.D0)) + 3
      CALL DCFFTMB(L,1,M,LDIM,C, (L-1)+LDIM* (M-1)+1,WSAVE(IW),
     +            2*M+INT(LOG(DBLE(M)))+4,WORK,2*L*M,IER1)
      IF (IER1.NE.0) THEN
          IER = 20
          CALL DXERFFT('CFFT2B',-5)
          GO TO 100
      END IF
C
C Transform Y lines of C array
      IW = 1
      CALL DCFFTMB(M,LDIM,L,1,C, (M-1)*LDIM+L,WSAVE(IW),
     +            2*L+INT(LOG(DBLE(L)))+4,WORK,2*M*L,IER1)
      IF (IER1.NE.0) THEN
          IER = 20
          CALL DXERFFT('CFFT2B',-5)
      END IF
C
  100 CONTINUE
      RETURN
      END

      PROGRAM TSTRML
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C OPEN GKS, OPEN WORKSTATION OF TYPE 1, ACTIVATE WORKSTATION
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C INVOKE DEMO DRIVER
C
      CALL STRML(IERR)
C
C DEACTIVATE AND CLOSE WORKSTATION, CLOSE GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END
C
      SUBROUTINE STRML (IERROR)
C
C PURPOSE                To provide a simple demonstration of STRMLN.
C
C USAGE                  CALL STRML (IERROR)
C
C ARGUMENTS
C
C ON OUTPUT              IERROR
C                          An integer variable
C                          = 0, if the test was successful,
C                          = 1, the test was not successful.
C
C I/O                    If the test is successful, the message
C
C               STRMLN TEST EXECUTED--SEE PLOT TO CERTIFY
C
C                        is printed on unit 6.  In addition, 1
C                        frame is produced on the machine graphics
C                        device.  In order to determine if the test
C                        was successful, it is necessary to examine
C                        the plot.
C
C PRECISION              Single
C
C LANGUAGE               FORTRAN 77
C
C REQUIRED ROUTINES      STRMLN
C
C REQUIRED GKS LEVEL     0A
C
C ALGORITHM              Routine TSTRML calls routine STRMLN to
C                        produce a plot which depicts the flow and
C                        magnitude of a vector field.
C
      REAL            U(21,25)   ,V(21,25)   ,WRK(1050)
C
C Specify coordinates for plot titles.  The values TX and TY
C define the center of the title string in a 0. to 1. range.
C
      DATA TX/.5/,TY/.9765/
C
C Set the grid dimensions.
C
      DATA NH,NV/21,25/
C
C Initialize the error parameter.
C
      IERROR = 1
C
C Specify horizontal and vertical vector components U and V on
C the rectangular grid.
C
      TPIMX = 2.*3.14/REAL(NH)
      TPJMX = 2.*3.14/REAL(NV)
      DO  20 J=1,NV
         DO  10 I=1,NH
         U(I,J) = SIN(TPIMX*(REAL(I)-1.))
         V(I,J) = SIN(TPJMX*(REAL(J)-1.))
   10    CONTINUE
   20 CONTINUE
C
C Select normalization transformation 0.
C
      CALL GSELNT (0)
C
C Call PLCHLQ to write the plot title.
C
      CALL PLCHLQ (TX,TY,'DEMONSTRATION PLOT FOR ROUTINE STRMLN',16.,
     1            0.,0.)
C
C Define normalization transformation 1, and set up log scaling.
C
      CALL SET(0.1, 0.9, 0.1, 0.9,1.0, 21., 1.0, 25.,1)
C
C Draw the plot perimeter.
C
      CALL PERIM(1,0,1,0)
C
C Call STRMLN for vector field streamlines plot.
C
      CALL STRMLN (U,V,WRK,NH,NH,NV,1,IER)
C
      CALL FRAME
C
      IERROR = 0
      WRITE (6,1001)
      RETURN
C
 1001 FORMAT (' STRMLN TEST EXECUTED--SEE PLOT TO CERTIFY')
C
      END

C NCLFORTSTART
      subroutine cremapbin(plev   ,plato   ,plono   ,plat    ,plon ,
     1                     xx     ,yy      ,clat    ,clon    ,clato,
     2                     clono  ,nlat    ,nlato   ,bin_factor    ,
     3                     xxmsg                                   )
c
c--------1---------2---------3---------4---------5---------6---------7--
c
c Grid-Box Binning
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
      integer plev      ! vertical dimension of input/output field
      integer plato     ! latitude dimension of output field
      integer plono     ! longitude dimension of output field
      integer plat      ! latitude dimension of input field
      integer plon      ! longitude dimension of input field
c
      double precision xx(plon ,plat ,plev) ! input analysis field
      double precision yy(plono,plato,plev) ! horizontally interpolated
c                                           ! (output) field
      double precision clat (plat )         ! Input latitude in degrees
c                                           ! oriented S->N
      double precision clon (plon )         ! Input longitude in degrees
c                                           ! oriented W->E
      double precision clato(plato)         ! Output latitude in degrees
c                                           ! oriented S->N
      double precision clono(plono)         ! Output longitude in degrees
c                                           ! oriented W->E
      integer nlat                          ! Number of Global Gaussian latitudes (input)
      integer nlato                         ! Number of Global Gaussian latitudes (output)
      double precision bin_factor           ! bin-box area expansion/contraction factor
c                                           ! relative to output grid-box area.
      double precision xxmsg
c
c-----------------------------------------------------------------------
c
C NCLEND
c
c---------------------------Local workspace-----------------------------
c
c                                               ! Max # of box segments
      integer max_segs
      parameter (max_segs = 100000 )
c                                               
      integer i, j, ii, jj, k, jfirst, jfirsto ! Indices
      integer nx, ny, nx_max, ny_max          

      integer plon2, plonhalf
      integer i_in(max_segs),i_out(max_segs)
      integer j_in(max_segs),j_out(max_segs)
      integer grid_flag, grido_flag ! grid flags: 0=Regular, 1=Gaussian
      double precision xx_loc(plon*2, plat, plev)
      double precision pi, pio180, pio2, factor
      double precision flat  (plat)   ,flon  (plon*2  )
      double precision flato (plato  ),flono (plono   )
      double precision flati (plat+1), floni (plon*2+1)
      double precision flatoi(plato+1),flonoi(plono+1  )
      double precision tmps, tmpn, tmp(plono,plato)
      double precision edge_w (plon*2), edge_e (plon*2), edge_s (plat ),
     &                                         edge_n (plat )
      double precision edgeo_w(plono ), edgeo_e(plono ), edgeo_s(plato),
     &                                         edgeo_n(plato)
      double precision sin_s (plat ),sin_n (plat )
      double precision sino_s(plato),sino_n(plato)
      double precision dx(max_segs), dy(max_segs)
      double precision distmin, dist, zero, three
      double precision dlat, dlato, eps
c
c - the following are only relevant for grids that are Gaussian
c
      double precision, allocatable :: flat_glob (:)  ! Global Gaussian latitudes (based on input  grid resolution)
c                                                     ! (radians)
      double precision, allocatable :: flato_glob(:)  ! Global Gaussian latitudes (based on output grid resolution)
c                                                     ! (radians)
      double precision, allocatable :: gw_glob   (:)  ! Global Gaussian weights   (based on input  grid resolution)
      double precision, allocatable :: gwo_glob  (:)  ! Global Gaussian weights   (based on output grid resolution)
      integer ierror
c
c-----------------------------------------------------------------------
c
      zero     = 0.d0
      three    = 3.d0
      plon2    = plon*2
      plonhalf = plon/2
      pi       = 4.d0*atan(1.d0)
      pio180   = pi/180.d0
      pio2     = pi/2.d0
      eps      = 1.d-5
c
c Sanity checks
c
c djs if(bin_factor .lt. 0.05d0) then
      if(bin_factor .lt. 1.00d0) then
         write(6,*) 'ERROR ("CREMAPBIN"): binning factor out of range'
         write(6,*) 'bin_factor = ', bin_factor
         call abort
      end if
      if(clat(3) - clat(2) .lt. zero) then
         write(6,*) 'ERROR ("CREMAPBIN"): Input latitudes oriented'
         write(6,*) '                     N->S. Should be S->N'
         call abort
      end if
      if(clato(3) - clato(2) .lt. zero) then
         write(6,*) 'ERROR ("CREMAPBIN"):  Output latitudes oriented'
         write(6,*) '                      N->S. Should be S->N'
         call abort
      end if
      if(clon(3) - clon(2) .lt. zero) then
         write(6,*) 'ERROR ("CREMAPBIN"): Input longitudes oriented'
         write(6,*) '                     E->W. Should be W->E'
         call abort
      end if
      if(clono(3) - clono(2) .lt. zero) then
         write(6,*) 'ERROR ("CREMAPBIN"): Output longitudes oriented'
         write(6,*) '                     E->W. Should be W->E'
         call abort
      end if
c
c Determine if input/output grids are Regular or Gaussian
c
      dlat  = ( clat (plat ) - clat (1) ) /(plat -1)
      dlato = ( clato(plato) - clato(1) ) /(plato-1)
      grid_flag  = 0
      grido_flag = 0
      do j = 1,plat-1
         if( abs (clat (j+1) - clat (j) - dlat ) .gt. eps) grid_flag = 1
      end do
      do j = 1,plato-1
         if( abs (clato(j+1) - clato(j) - dlato) .gt. eps) grido_flag =1
      end do
c
c Get global lats/weights for those grids that are Gaussian
c
      allocate( flat_glob(nlat) )
      allocate( gw_glob  (nlat) )
      if(grid_flag .eq. 1) then
         if(nlat .lt. plat) then
            write(6,*) 'ERROR ("CREMAPBIN"): number of latitudes for '
            write(6,*) 'the input grid cannot be greater than the  '
            write(6,*) 'global number of latitudes for that grid   '
            write(6,*) 'resolution'
            write(6,*) 'nlat, plat = ', nlat, plat
            call abort
         end if
         call binning_get_global_lats_wgts(nlat, flat_glob, gw_glob)
      end if
c
      allocate( flato_glob(nlato) )
      allocate( gwo_glob  (nlato) )
      if(grido_flag .eq. 1) then
         if(nlato .lt. plato) then
            write(6,*) 'ERROR ("CREMAPBIN"): number of latitudes for '
            write(6,*) 'the output grid cannot be greater than the '
            write(6,*) 'global number of latitudes for that grid   '
            write(6,*) 'resolution'
            write(6,*) 'nlato, plato = ', nlato, plato
            call abort
         end if
         call binning_get_global_lats_wgts(nlato, flato_glob, gwo_glob)
      end if
c
c Copy input data to wrap-around array (wrap half-way around globe 
c at each end of x-direction)
c

c$omp parallel do default(shared) private(i,j,k,ii)
      do k = 1,plev
         do j = 1,plat
            ii = plonhalf
            do i = 1,plon2
               ii = ii + 1
               if(ii .gt. plon) ii = 1
               xx_loc(i,j,k) = xx(ii,j,k)
            end do
         end do
      end do
c
c Convert input/output grid coordinates to radians (wrap half-way around
c globe at each end of x-direction of input grid)
c
      ii   = plonhalf
      do i = 1,plon2
         ii = ii + 1
         if(ii .gt. plon    )      ii = 1
         if(i  .le. plonhalf)      flon(i) = clon(ii)*pio180-4*pio2
         if(i  .gt. plonhalf+plon) flon(i) = clon(ii)*pio180+4*pio2
         if(i  .gt. plonhalf .and. i .le. plonhalf+plon) 
     &                             flon(i) = clon(ii)*pio180
      end do

c$omp parallel do default(shared) private(j)
      do j = 1,plat
         flat (j) = clat (j)*pio180
      end do

c$omp parallel do default(shared) private(i)
      do i = 1,plono
         flono(i) = clono(i)*pio180
      end do

c$omp parallel do default(shared) private(j)
      do j = 1,plato
         flato(j) = clato(j)*pio180
      end do
c
c Map "regional" latitudes into global latitude arrays for input/output grids
c
      if(grid_flag .eq. 1) then
         call binning_map_lats(nlat , plat , flat , flat_glob , jfirst )
      end if
      if(grido_flag .eq. 1) then
         call binning_map_lats(nlato, plato, flato, flato_glob, jfirsto)
      end if
c
c Compute box edges for input and output grids
c
      call binning_map_edges(plat      , plon2 , nlat      , jfirst  ,
     1                       flon      , flat  , gw_glob   , 
     2                       grid_flag , floni , flati     )
      call binning_map_edges(plato     , plono , nlato     , jfirsto ,
     1                       flono     , flato , gwo_glob  , 
     2                       grido_flag, flonoi, flatoi    )
c
c Copy grid interfaces to "edge" arrays
c
c$omp parallel do default(shared) private(i)
      do i = 1,plon*2
        edge_w(i) = floni(i  )
        edge_e(i) = floni(i+1)
      end do

c$omp parallel do default(shared) private(j)
      do j = 1,plat
        edge_s(j) = flati(j  )
        edge_n(j) = flati(j+1)
        sin_s (j) = sin(edge_s(j))
        sin_n (j) = sin(edge_n(j))
      end do
c
c Expand/contract bin box area for each output grid box by "bin_factor"
c
      factor = sqrt(bin_factor)

c$omp parallel do default(shared) private(i)
      do i = 1,plono
        edgeo_w(i) = flono(i) - ( flono (i  ) - flonoi(i) )*factor
        edgeo_e(i) = flono(i) + ( flonoi(i+1) - flono (i) )*factor
      end do

c$omp parallel do default(shared) private(j)
      do j = 1,plato
        tmps       = flato(j) - ( flato (j  ) - flatoi(j) )*factor
        tmpn       = flato(j) + ( flatoi(j+1) - flato (j) )*factor
        edgeo_s(j) = max( tmps, -pio2) - max( ( tmpn - pio2), zero)
        edgeo_n(j) = min( tmpn,  pio2) + max( (-pio2 - tmps), zero)
        sino_s (j) = sin(edgeo_s(j))
        sino_n (j) = sin(edgeo_n(j))
      end do
c
c Make vector of box segments in x-direction
c
      nx = 0
      do i = 1,plono
         do ii = 1,plon*2
            if(edge_e (ii) .gt. edgeo_w( i) .and.
     &         edgeo_e( i) .gt. edge_w (ii) ) then
               nx = nx + 1
               if(nx .gt. max_segs) then
                  write(6,*) 'ERROR  ("CREMAPBIN"):  number of box'
                  write(6,*) 'segments greater than "max_segs"'
                  call abort
               end if
               i_in (nx) = ii
               i_out(nx) = i
               dx   (nx) = min(min(min(edge_e(ii)-edge_w(ii),
     &                                 edgeo_e(i)-edgeo_w(i) ),
     &                                 edge_e(ii)-edgeo_w(i) ),
     &                                 edgeo_e(i)-edge_w(ii) )
            end if
            if(edge_w (ii) .ge. edgeo_e( i)) exit
         end do
      end do
c
c Make vector of box segments in y-direction
c
      ny = 0
      do j = 1,plato
         do jj = 1,plat
            if(edge_n (jj) .gt. edgeo_s( j) .and. 
     &         edgeo_n( j) .gt. edge_s (jj) ) then
               ny = ny + 1
               if(ny .gt. max_segs) then
                  write(6,*) 'ERROR  ("CREMAPBIN"):  number of box'
                  write(6,*) 'segments greater than "max_segs"'
                  call abort
               end if
               j_in (ny) = jj
               j_out(ny) = j
               distmin   = edge_n(jj)-edge_s(jj)
               dy(ny)    = sin_n (jj)-sin_s (jj)
               dist      = edgeo_n(j)-edgeo_s(j)
               if(dist .lt. distmin) then
                  distmin = dist
                  dy(ny)  = sino_n(j)-sino_s(j)
               end if
               dist      = edge_n(jj)-edgeo_s(j)
               if(dist .lt. distmin) then
                  distmin = dist
                  dy(ny)  = sin_n(jj)-sino_s(j)
               end if
               dist      = edgeo_n(j)-edge_s(jj)
               if(dist .lt. distmin) then
                  distmin = dist
                  dy(ny)  = sino_n(j)-sin_s(jj)
               end if
            end if
            if(edge_s (jj) .ge. edgeo_n( j)) exit
         end do
      end do

      nx_max = nx
      ny_max = ny
c
c Begin weighted binning
c
c$omp parallel do default(shared) private(i,j,k)
      do k = 1,plev
         do j = 1,plato
            do i = 1,plono
               yy(i,j,k) = 0.
            end do
         end do
      end do

c$omp parallel do default(shared) private(i,j,k,ii,jj,nx,ny)
      do k = 1,plev
         do ny = 1,ny_max
            j  = j_out(ny)
            jj = j_in (ny)
            do nx = 1,nx_max
               i  = i_out(nx)
               ii = i_in (nx)
               yy(i,j,k) = yy(i,j,k) + xx_loc(ii,jj,k)*dx(nx)*dy(ny)
            end do
         end do
      end do
c
c Normalize
c
c$omp parallel do default(shared) private(i,j)
      do j = 1,plato
         do i = 1,plono
            tmp(i,j) = (edgeo_e(i) - edgeo_w(i))*(sino_n(j) - sino_s(j))
         end do
      end do

c$omp parallel do default(shared) private(i,j,k)
      do k = 1,plev
         do j = 1,plato
            do i = 1,plono
               yy(i,j,k) = yy(i,j,k)/tmp(i,j)
            end do
         end do
      end do
c
      deallocate( flat_glob  )
      deallocate( gw_glob    )
      deallocate( flato_glob )
      deallocate( gwo_glob   )
c
c CRUDE .... 
c .   At any level where the input "xx" has a missing value
c .   set the corresponding "yy" level to missing.
c
      do k = 1,plev

         do j = 1,plat
            do i = 1,plon 
               if (xx(i,j,k).eq.xxmsg) then
                   do jj = 1,plato
                      do ii = 1,plono
                         yy(ii,jj,k) = xxmsg
                      end do
                   end do
                   go to 100
               end if
            end do
         end do

  100    continue
      end do
    
      return
      end
c
c-----------------------------------------------------------------------
c-----------------------------------------------------------------------
c
      subroutine binning_get_global_lats_wgts(nlat, lat_glob, gw_glob)
c
c--------1---------2---------3---------4---------5---------6---------7--
c
c Compute Global Gaussian latitudes/weights based upon # of latitudes
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
      integer nlat                      ! Number of Global Gaussian latitudes
      double precision lat_glob (nlat)  ! Global Gaussian latitudes (radians)
      double precision gw_glob  (nlat)  ! Global Gaussian weights
c
c---------------------------Local workspace-----------------------------
c
      integer ierror, lwork
      double precision pio2
      double precision, allocatable :: work(:) ! Work array
c
c-----------------------------------------------------------------------
c
      pio2 = 2.d0*atan(1.d0)
c
      if(nlat .le. 2) then
        write(6,*) 'Error in "cremapbin": Not enough Gaussian latitudes'
        write(6,*) 'nlat = ', nlat
        call abort
      end if
c
      lwork = 4*nlat*(nlat+1)+2
      allocate( work(lwork) )
      call gaqdncl(nlat,lat_glob,gw_glob,work,lwork,ierror)
      deallocate( work )

      if(ierror .ne. 0) then
         write(6,*)
         write(6,*) 'Error: in call to routine "gaqdncl", ierror = ',
     &                                                           ierror
         if(ierror .eq. 1) then
            write(6,*) "Not enough work space declared for number of"
            write(6,*) "Gaussian latitudes" 
            write(6,*) 'lwork, nlat     = ', lwork,nlat
            write(6,*) 'lwork should be = ', 4*nlat*(nlat+1)+2
         end if
         call abort
      end if
c
      lat_glob(:) = lat_glob(:) - pio2
c
      return
      end
c
c-----------------------------------------------------------------------
c-----------------------------------------------------------------------
c
      subroutine binning_map_lats(nlat, plat, flat, flat_glob, jfirst)
c
c--------1---------2---------3---------4---------5---------6---------7--
c
c Map "regional" latitudes into global latitude arrays for input/output grids
c and check that the grid latitudes are an identical subset of the global array
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
      integer nlat                      ! Number of Global Gaussian latitudes
      integer plat                      ! Number of grid   Gaussian latitudes
      integer jfirst                    ! index of Global lat array that maps
c                                       ! into the first grid lat array
      double precision flat_glob(nlat)  ! Global Gaussian latitudes (radians)
      double precision flat     (plat)  ! grid Gaussian latitudes (radians)
c
c---------------------------Local workspace-----------------------------
c
      integer j, jj
      double precision eps
      logical found
c
c-----------------------------------------------------------------------
c
      eps = 1.d-5
c
c Find latitude in Global array that corresponds to the first latitude
c of the grid array.
c
      found  = .false.
      jfirst = 0
      do j = 1,nlat
         if( abs(flat_glob(j) - flat(1)) .lt. eps ) then
            found  = .true.
            jfirst = j
            exit
         end if
      end do
c
      if(.not. found) then
         write(6,*) 'Error in "cremapbin":'
         write(6,*) "Could not map global lat array into grid array"
         call abort
      end if
c
      if(plat+jfirst-1 .gt. nlat) then
         write(6,*) 'Error in "cremapbin":'
         write(6,*) "Stepping out of bounds of the global lat array"
         call abort
      end if
c
c Test that subsequent grid lats all match the global lat array
c
      do j = 2,plat
         if( abs(flat_glob(j+jfirst-1) - flat(j)) .gt. eps ) then
            write(6,*) 'Error in "cremapbin":'
            write(6,*) "Gaussian latitudes in grid array do not"
            write(6,*) "match those in the global array"
            call abort
         end if
      end do
c
      return
      end
c
c-----------------------------------------------------------------------
c-----------------------------------------------------------------------
c
      subroutine binning_map_edges(plat     , plon , nlat     , jfirst ,
     1                             flon     , flat , gw_glob  ,
     2                             grid_flag, floni, flati    )
c
c--------1---------2---------3---------4---------5---------6---------7--
c
c Based on input grid, compute grid-box edges for either Gaussian or
C Regular (evenly-spaced) grids.
c
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c
      integer plat                       ! latitude  dimension of input field
      integer plon                       ! longitude dimension of input field
      integer nlat                       ! Number of Global Gaussian latitudes
      integer jfirst                     ! Index of global Gaussian lat array mapped into the first grid lat array
c
      double precision flon     (plon)   ! longitudes in radians oriented W->E
      double precision flat     (plat)   ! latitudes  in radians oriented S->N
      double precision gw_glob  (nlat)   ! Global Gaussian weights
      integer grid_flag                  ! grid flags: 0=Regular, 1=Gaussian
      double precision floni    (plon+1) ! longitudes of box edges in radians oriented W->E
      double precision flati    (plat+1) ! latitudes  of box edges in radians oriented S->N
c
c---------------------------Local workspace-----------------------------
c
      integer i, j, platp1               ! Indices
      double precision sum
      double precision pi, pio2, half, one, two, three
c
c-----------------------------------------------------------------------
c
      platp1   = plat + 1
      half     = 0.5d0
      one      = 1.d0
      two      = 2.d0
      three    = 3.d0
      pi       = 4.d0*atan(one)
      pio2     = pi/two
c
c Compute longitudes of box edges
c
      floni(     1) = ( three*flon(   1) - flon(     2) )*half
      floni(plon+1) = ( three*flon(plon) - flon(plon-1) )*half
      do i = 2,plon
         floni(i) = half*(flon(i-1) + flon(i))
      end do
c
c If Regular grid, use algebraic mean to determine latitudes of box edges (extrapolation for endpoints)
c Else, if Gaussian grid, use partial sums of Gaussian weights.
c
      if(grid_flag .eq. 0) then
         flati(1     ) = ( three*flat(1) - flat(2) )*half
         flati(1     ) = max( flati(1), -pio2)
         flati(platp1) = ( three*flat(plat) - flat(plat-1) )*half
         flati(platp1) = min( flati(platp1),  pio2)
         do j = 1,plat-1
            flati(j+1) = half*(flat(j) + flat(j+1))
         end do
      else
c
c Sum Gaussian weights up to first latitude of data grid to get first box edge
c
         sum = 0.d0
         if(jfirst .le. 1) then
            flati(1) = -pio2
         else
            do j = 1,jfirst-1
               sum = sum + gw_glob(j)
            end do
            flati(1) = asin( sum-one )
         end if
c
c Determine subsequent box edges
c
         do j = 1,plat
            sum = sum + gw_glob(jfirst+j-1)
            flati(j+1) = asin( min (one,(sum-one) ) )
         end do
      end if
c
      return
      end
c
c-----------------------------------------------------------------------
c

C
C $Id: dmapgci.f,v 1.3 2008-07-27 03:40:25 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE DMAPGCI(ALAT,ALON,BLAT,BLON,NOPI,RLTI,RLNI)
      IMPLICIT NONE
      DOUBLE PRECISION ALAT,ALON,BLAT,BLON,RLTI,RLNI
      DOUBLE PRECISION UCPD,VCPD,WCPD,UCPF,VCPF,UCPQ,VCPQ,WCPQ
      DOUBLE PRECISION UCPP,VCPP,WCPP,UCPO,VCPO,WCPO,UCPH,VCPH,WCPH
      DOUBLE PRECISION BETA,GAMA,UCPG,VCPG,WCPG,RTOD,WCPF,ALPH,CALP,SALP
      DOUBLE PRECISION WCPA,UCPB,VCPB,WCPB,CBLN,SBLN,UCPA,VCPA,SALN,
     +                 CBLT,SBLT
      DOUBLE PRECISION CALT,DTOR,SALT,CALN
      INTEGER IOPI,NOPI,ICFELL
C
      DIMENSION RLTI(*),RLNI(*)
C
C This routine, given the latitudes and longitudes of two points A and
C B on the surface of the globe, interpolates NOPI points along the
C great circle route joining A to B and returns the latitudes and
C longitudes of the interpolated points in the arrays RLTI and RLNI.
C
C Rotations about a given axis are used extensively below.  Assume a
C right-handed system with U, V, and W axes.  Rotating by an angle "a"
C about the U axis maps the point (u,v,w) into the point (u',v',w'),
C where
C
C       u' = u
C       v' = v cos(a) - w sin(a)
C       w' = w cos(a) + v sin(a)
C
C A positive value of "a" represents rotation in the direction from the
C V axis to the W axis.
C
C Similarly, rotating by an angle "a" about the V axis maps the point
C (u,v,w) into the point (u',v',w'), where
C
C       u' = u cos(a) + w sin(a)
C       v' = v
C       w' = w cos(a) - u sin(a)
C
C A positive value of "a" represents rotation in the direction from the
C W axis to the U axis.
C
C Rotating by an angle "a" about the W axis maps the point (u,v,w) into
C the point (u',v',w'), where
C
C       u' = u cos(a) - v sin(a)
C       v' = v cos(a) + u sin(a)
C       w' = w
C
C A positive value of "a" represents rotation in the direction from the
C U axis to the V axis.
C
C
C Define the constants used to convert from degrees to radians and
C vice-versa.
C
      DATA DTOR/.017453292519943D0/
      DATA RTOD/57.2957795130823D0/
C
C Check for an uncleared prior error.
C
      IF (ICFELL('MAPGCI - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C Compute the U, V, and W coordinates (on a unit sphere) of the points
C A and B.
C
      CALT = COS(ALAT*DTOR)
      SALT = SIN(ALAT*DTOR)
      CALN = COS(ALON*DTOR)
      SALN = SIN(ALON*DTOR)
C
      CBLT = COS(BLAT*DTOR)
      SBLT = SIN(BLAT*DTOR)
      CBLN = COS(BLON*DTOR)
      SBLN = SIN(BLON*DTOR)
C
      UCPA = CALT*CALN
      VCPA = CALT*SALN
      WCPA = SALT
C
      UCPB = CBLT*CBLN
      VCPB = CBLT*SBLN
      WCPB = SBLT
C
C Rotating the points about the W axis by the angle -ALON carries point
C A into point C, in the UW plane.  It carries point B into point D.
C
C       CDLN=COS((BLON-ALON)*DTOR)
C       SDLN=SIN((BLON-ALON)*DTOR)
C
C       UCPC=CALT
C       VCPC=0.
C       WCPC=SALT
C
      UCPD = UCPB*CALN + VCPB*SALN
      VCPD = VCPB*CALN - UCPB*SALN
      WCPD = WCPB
C
C       UCPD=CBLT*CDLN
C       VCPD=CBLT*SDLN
C       WCPD=SBLT
C
C Rotating the points about the V axis by the angle ALAT carries point
C C into point E, on the U axis.  It carries point D into point F.
C
C       UCPE=1.
C       VCPE=0.
C       WCPE=0.
C
      UCPF = UCPD*CALT + WCPD*SALT
      VCPF = VCPD
      WCPF = WCPD*CALT - UCPD*SALT
C
C       UCPF=CALT*CBLT*CDLN-SALT*SBLT
C       VCPF=CBLT*SDLN
C       WCPF=CALT*SBLT+SALT*CBLT*CDLN
C
C Rotating the points about the U axis by the angle -ATAN(WCPF/VCPF)
C leaves the position of point E unchanged, but carries point F into
C point G, in the UV plane.
C
      IF (WCPF.NE.0.D0 .OR. VCPF.NE.0.D0) THEN
          ALPH = ATAN2(WCPF,VCPF)
      ELSE
          ALPH = 0.D0
      END IF
C
      CALP = COS(ALPH)
      SALP = SIN(ALPH)
C
      UCPG = UCPF
      VCPG = VCPF*CALP + WCPF*SALP
      WCPG = WCPF*CALP - VCPF*SALP
C
C       UCPG=CALT*CBLT*CDLN-SALT*SBLT
C       VCPG=CBLT*SDLN*CALP-CALT*SBLT*SALP-SALT*CBLT*CDLN*SALP
C       WCPG=CALT*SBLT*CALP+SALT*CBLT*CDLN*CALP+CBLT*SDLN*SALP
C
C The angle from E to G (which is the same as the angle from A to B)
C may now be computed easily.
C
      IF (VCPG.NE.0.D0 .OR. UCPG.NE.0.D0) THEN
          BETA = ATAN2(VCPG,UCPG)
      ELSE
          BETA = 0.D0
      END IF
C
C Interpolate points between the points E and G and map them back to
C the great circle route between A and B.
C
      DO 101 IOPI = 1,NOPI
          GAMA = (DBLE(IOPI)/DBLE(NOPI+1))*BETA
          UCPH = COS(GAMA)
          VCPH = SIN(GAMA)
          WCPH = 0.D0
          UCPO = UCPH
          VCPO = VCPH*CALP - WCPH*SALP
          WCPO = WCPH*CALP + VCPH*SALP
          UCPP = UCPO*CALT - WCPO*SALT
          VCPP = VCPO
          WCPP = WCPO*CALT + UCPO*SALT
          UCPQ = UCPP*CALN - VCPP*SALN
          VCPQ = VCPP*CALN + UCPP*SALN
          WCPQ = WCPP
          RLTI(IOPI) = RTOD*ATAN2(WCPQ,SQRT(UCPQ*UCPQ+VCPQ*VCPQ))
          IF (VCPQ.NE.0.D0 .OR. UCPQ.NE.0.D0) THEN
              RLNI(IOPI) = RTOD*ATAN2(VCPQ,UCPQ)
          ELSE
              RLNI(IOPI) = 0.D0
          END IF
  101 CONTINUE
C
C Done.
C
      RETURN
C
      END

      DOUBLE PRECISION FUNCTION DGCDIST(RLAT1,RLON1,RLAT2,RLON2,IU)
      IMPLICIT NONE
c
c calculate the great circle distance between two points
c
c usage: dist = gcdist (rlat1,rlon1,rlat2,rlon2,iu)
c
c nomenclature :
c .   rlat1,rlon1 - latitude and longtitude of the first point
c .   rlat2,rlon2 - latitude and longtitude of the second point
c .   iu          - code for the type units gcdist is to return
c .               = 1 : gcdist returned in radians
c .               = 2 : gcdist returned in degrees
c .               = 3 : gcdist returned in meters
c .               = 4 : gcdist returned in kilometers
c .               = 5 : gcdist returned in *not used*
c
c input
      INTEGER IU
c input types
      DOUBLE PRECISION RLAT1,RLON1,RLAT2,RLON2

c local stuff
      DOUBLE PRECISION UNITS(5),RAD,DLONR,RLAT1R,RLAT2R
      DATA UNITS/1.0D0,57.29577995691645D0,6371220.D0,6371.2200D0,0.D0/
c change as required
      DATA RAD/0.01745329238474369D0/

c special test if RLAT1=RLAT2 and RLON1=RLON2
      IF(RLAT1.EQ.RLAT2.AND.RLON1.EQ.RLON2) THEN
         DGCDIST = 0.D0
         RETURN
      END IF
      RLAT1R = RLAT1*RAD
      RLAT2R = RLAT2*RAD
      DLONR = DMIN1(ABS(RLON1-RLON2),ABS(360.D0-RLON1+RLON2),
     +        ABS(360.D0-RLON2+RLON1))*RAD

      DGCDIST = ATAN2(SQRT((COS(RLAT2R) * SIN(DLONR)) ** 2 +
     +                     (COS(RLAT1R) * SIN(RLAT2R) -
     +                      SIN(RLAT1R) * COS(RLAT2R) * COS(DLONR)) ** 2
     +                    ),
     +                SIN(RLAT1R)*SIN(RLAT2R)+
     +                COS(RLAT1R)*COS(RLAT2R)*COS(DLONR)
     +               ) * UNITS(IU)

      RETURN
      END

C
C $Id: galbex.f,v 1.7 2008-07-27 00:17:13 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GALBEX (LABL,MLBL,NLBL)
C
        CHARACTER*(*) LABL
C
C Given a character string LABL, of arbitrary length, find the index of
C the first non-blank character in it (MLBL) and the index of the last
C non-blank character following that (NLBL).
C
        LLBL=LEN(LABL)
C
        DO 101 I=1,LLBL
          IF (LABL(I:I).NE.' ') THEN
            MLBL=I
            GO TO 102
          END IF
  101   CONTINUE
        MLBL=1
C
  102   DO 103 I=MLBL,LLBL-1
          IF (LABL(I+1:I+1).EQ.' ') THEN
            NLBL=I
            GO TO 104
          END IF
  103   CONTINUE
        NLBL=LLBL
C
C Done.
C
  104   RETURN
C
      END

C
C     $Id: xy14f.f,v 1.6 2010-03-15 22:49:25 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C           Copyright (C)  1995                                        C
C   University Corporation for Atmospheric Research                    C
C           All Rights Reserved                                        C
C                                                                      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C      File:            xy14f.f
C
C      Author:          Fred Clare (converted to Fortran by Mary Haley)
C                       National Center for Atmospheric Research
C                       PO 3000, Boulder, Colorado
C
C      Date:            Tue Oct 17 10:00:12 MDT 1995
C
C Description:  This example demonstrates the data manipulation
C               capabilities of the HLUS in conjunction with XyPlot.
C
C               This example is really meant to show the data
C               manipulation capabilities of NCL, since it does some
C               array arithmetic that you can't do in C or Fortran 77.
C
      external NhlFAppClass
      external NhlFCairoWindowWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFNcgmWorkstationClass
      external NhlFXyPlotClass
      external NhlFCoordArraysClass
C
C Define temperature/rainfall data for a 25-hour period in
C an NCL variable.  In a real-world NCL script these values
C would probably be read in, either directly or as part of
C a data file like a netCDF or HDF file.
C
C The temperature data is hourly data in degrees Celsius and
C the rainfall data is hourly data in millimeters.
C
      real tr_data(25,2)
      data tr_data/ 9.00, 8.30, 7.40, 6.20, 5.60, 3.40, 2.70, 1.20,
     +              3.70, 5.80, 5.90, 4.50, 7.40,11.60,10.40, 9.20,
     +              7.80,10.20,12.10,11.40, 9.00, 8.90, 8.50, 7.40,
     +              6.60, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00,
     +              0.00, 0.00, 0.00, 0.25, 0.63, 0.10, 0.00, 0.53,
     +              3.75, 3.10, 0.52, 0.00, 0.00, 0.00, 0.00, 0.00,
     +              0.00,0.00/

      real yvalues(5)
      data yvalues/2.,1.,0.,-1.,-2./
      character*9 ylabels(5)
      data ylabels/'2~F33~s','~F33~s','~F22~MEAN','-~F33~s','-2~F33~s'/

      parameter(NHOURS=25)
      integer srlist
      real x_array(NHOURS), y_array(NHOURS)
      real x_array2(5), y_array2(5)
      real t_mean, std_dev, mm2inch
      data mm2inch/0.03937/
      integer appid, xworkid, plotid, dataid
      CHARACTER*7  wks_type
C
C Define the workstation type
C
      wks_type = "x11"
C
C
C Initialize the HLU library.
C
      call NhlFInitialize
      call NhlFRLCreate(srlist,'setrl')
C
C Create Application object.
C
      call NhlFRLClear(srlist)
      call NhlFRLSetString(srlist,'appDefaultParent','True',ierr)
      call NhlFRLSetString(srlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'xy14',NhlFAppClass,0,srlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkMetaName','./xy14f.ncgm',ierr)
         call NhlFCreate(xworkid,'xy14Work',
     +        NhlFNcgmWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X11 workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkPause','True',ierr)
         call NhlFCreate(xworkid,'xy14Work',
     +        NhlFCairoWindowWorkstationClass,
     +        0,srlist,ierr)
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PS workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkPSFileName','./xy14f.ps',ierr)
         call NhlFCreate(xworkid,'xy14Work',
     +        NhlFPSWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkPDFFileName','./xy14f.pdf',ierr)
         call NhlFCreate(xworkid,'xy14Work',
     +        NhlFPDFWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a PS/PDF cairo workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkFileName','./xy14f',ierr)
         call NhlFRLSetString(srlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(xworkid,'xy14Work',
     +        NhlFCairoPSPDFWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a PNG cairo workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkFileName','./xy14f',ierr)
         call NhlFRLSetString(srlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(xworkid,'xy14Work',
     +        NhlFCairoImageWorkstationClass,0,srlist,ierr)
      endif
C
C Create X-axis values and convert data to Fahrenheit.
C
      do 10 i = 1,NHOURS
         x_array(i) = real(i-1)
         y_array(i) = (9./5.)*tr_data(i,1)+32.
 10   continue
C
C Picture 1:
C
C Convert the temperatures to degrees Fahrenheit and plot as an XyPlot
C object in the X11 window.  Note the usage of NCL algebraic operators
C and array selection capabilities.
C
      call NhlFRLClear(srlist)
      call NhlFRLSetFloatArray(srlist,'caXArray',x_array,NHOURS,ierr)
      call NhlFRLSetFloatArray(srlist,'caYArray',y_array,NHOURS,ierr)
      call NhlFCreate(dataid,'xyData',NhlFCoordArraysClass,appid,
     +     srlist,ierr)

      call NhlFRLClear(srlist)
      call NhlFRLSetInteger(srlist,'xyCoordData',dataid,ierr)
C
C X-axis resources
C
      call NhlFRLSetString(srlist,'tmXBMode','MANUAL',ierr)
      call NhlFRLSetFloat(srlist,'tmXBTickStartF',0.,ierr)
      call NhlFRLSetFloat(srlist,'tmXBTickEndF',24.,ierr)
      call NhlFRLSetFloat(srlist,'tmXBTickSpacingF',4.,ierr)
      call NhlFRLSetInteger(srlist,'tmXBLabelFont',22,ierr)
      call NhlFRLSetFloat(srlist,'tmXBLabelFontHeightF',0.024,ierr)
C
C Y-axis resources.  The title precision is changed to '2' so that
C integer values will be used (the temperatures are in a range
C requiring only two digits).
C
      call NhlFRLSetString(srlist,'tmYLMode','MANUAL',ierr)
      call NhlFRLSetFloat(srlist,'tmYLTickStartF',30.,ierr)
      call NhlFRLSetFloat(srlist,'tmYLTickEndF',60.,ierr)
      call NhlFRLSetFloat(srlist,'tmYLTickSpacingF',5.,ierr)
      call NhlFRLSetString(srlist,'tmYLAutoPrecision','False',ierr)
      call NhlFRLSetInteger(srlist,'tmYLPrecision',2,ierr)
      call NhlFRLSetInteger(srlist,'tmYLLabelFont',22,ierr)
      call NhlFRLSetFloat(srlist,'tmYLLabelFontHeightF',0.024,ierr)
      call NhlFRLSetInteger(srlist,'tmYLMinorPerMajor',4,ierr)
C
C Specify the Y-axis range precisely.
C
      call NhlFRLSetFloat(srlist,'trYMinF',30.,ierr)
      call NhlFRLSetFloat(srlist,'trYMaxF',60.,ierr)
C
C Supply titles
C
      call NhlFRLSetInteger(srlist,'tiMainFont',26,ierr)
      call NhlFRLSetFloat(srlist,'tiMainFontHeightF',.03,ierr)
      call NhlFRLSetString(srlist,'tiMainString','Hourly Temperatures',
     +     ierr)
      call NhlFRLSetInteger(srlist,'tiXAxisFont',22,ierr)
      call NhlFRLSetString(srlist,'tiXAxisString',
     +     'Hours Since Midnight',ierr)
      call NhlFRLSetInteger(srlist,'tiYAxisFont',22,ierr)
      call NhlFRLSetString(srlist,'tiYAxisString',
     +     'Temperature (degrees F)',ierr)
      call NhlFCreate(plotid,'XyPlot',NhlFXyPlotClass,xworkid,
     +     srlist,ierr)
      call NhlFDraw(plotid,ierr)
      call NhlFFrame(xworkid,ierr)
C
C Picture 2:
C
C Convert the rainfall data to inches and plot in the X11 window. 
C (In NCL, note how easy it is to select the rainfall data from the
C original two-dimensional data array.
C
      do 20 i = 1,NHOURS
         y_array(i) = mm2inch*tr_data(i,2)
 20   continue
      call NhlFRLClear(srlist)
      call NhlFRLSetFloatArray(srlist,'caXArray',x_array,NHOURS,ierr)
      call NhlFRLSetFloatArray(srlist,'caYArray',y_array,NHOURS,ierr)
      call NhlFCreate(dataid,'xyData',NhlFCoordArraysClass,appid,
     +     srlist,ierr)

      call NhlFRLClear(srlist)
      call NhlFRLSetInteger(srlist,'xyCoordData',dataid,ierr)
C
C X-axis resources
C
      call NhlFRLSetString(srlist,'tmXBMode','MANUAL',ierr)
      call NhlFRLSetFloat(srlist,'tmXBTickStartF',0.,ierr)
      call NhlFRLSetFloat(srlist,'tmXBTickEndF',24.,ierr)
      call NhlFRLSetFloat(srlist,'tmXBTickSpacingF',4.,ierr)
      call NhlFRLSetInteger(srlist,'tmXBLabelFont',22,ierr)
      call NhlFRLSetFloat(srlist,'tmXBLabelFontHeightF',0.024,ierr)
C
C Y-axis resources.
C
      call NhlFRLSetString(srlist,'tmYLMode','MANUAL',ierr)
      call NhlFRLSetFloat(srlist,'tmYLTickStartF',0.,ierr)
      call NhlFRLSetFloat(srlist,'tmYLTickEndF',0.15,ierr)
      call NhlFRLSetFloat(srlist,'tmYLTickSpacingF',0.03,ierr)
      call NhlFRLSetString(srlist,'tmYLAutoPrecision','False',ierr)
      call NhlFRLSetInteger(srlist,'tmYLPrecision',2,ierr)
      call NhlFRLSetInteger(srlist,'tmYLLabelFont',22,ierr)
      call NhlFRLSetFloat(srlist,'tmYLLabelFontHeightF',0.024,ierr)
      call NhlFRLSetInteger(srlist,'tmYLMinorPerMajor',4,ierr)
C
C Specify the Y-axis range precisely.
C
      call NhlFRLSetFloat(srlist,'trYMinF',0.,ierr)
      call NhlFRLSetFloat(srlist,'trYMaxF',0.15,ierr)
C
C Supply titles
C
      call NhlFRLSetInteger(srlist,'tiMainFont',26,ierr)
      call NhlFRLSetFloat(srlist,'tiMainFontHeightF',.03,ierr)
      call NhlFRLSetString(srlist,'tiMainString','Hourly Rainfall',ierr)
      call NhlFRLSetInteger(srlist,'tiXAxisFont',22,ierr)
      call NhlFRLSetString(srlist,'tiXAxisString',
     +     'Hours Since Midnight',ierr)
      call NhlFRLSetInteger(srlist,'tiYAxisFont',22,ierr)
      call NhlFRLSetString(srlist,'tiYAxisString','Rainfall in Inches',
     +     ierr)
      call NhlFCreate(plotid,'XyPlot',NhlFXyPlotClass,xworkid,
     +     srlist,ierr)
      call NhlFDraw(plotid,ierr)
      call NhlFFrame(xworkid,ierr)
C
C Picture 3:
C
C For each hourly temperature reading, plot the number of standard
C deviations from the mean the reading represents.  (In NCL, note the
C use of the NCL exponentiation operator (^) and the sqrt function.)
C
      t_mean = 0.
      do 30 i = 1,NHOURS
         t_mean = t_mean+(9./5.)*tr_data(i,1)+32.
 30   continue
      t_mean = t_mean/NHOURS
      std_dev = 0.
      do 40 i=1,NHOURS
         std_dev = std_dev+(((9./5.)*tr_data(i,1)+32.) - t_mean)**2.
 40   continue
      std_dev = sqrt(std_dev/(NHOURS-1))
      do 50 i = 1,NHOURS
         y_array(i) = ((9./5.)*tr_data(i,1)+32. - t_mean)/std_dev
 50   continue
      call NhlFRLClear(srlist)
      call NhlFRLSetFloatArray(srlist,'caXArray',x_array,NHOURS,ierr)
      call NhlFRLSetFloatArray(srlist,'caYArray',y_array,NHOURS,ierr)
      call NhlFCreate(dataid,'xyData',NhlFcoordArraysClass,appid,srlist,
     +     ierr)
      
      call NhlFRLClear(srlist)
C
C X-axis resources
C
      call NhlFRLSetString(srlist,'tmXBMode','MANUAL',ierr)
      call NhlFRLSetFloat(srlist,'tmXBTickStartF',0.,ierr)
      call NhlFRLSetFloat(srlist,'tmXBTickEndF',24.,ierr)
      call NhlFRLSetFloat(srlist,'tmXBTickSpacingF',4.,ierr)
      call NhlFRLSetInteger(srlist,'tmXBLabelFont',22,ierr)
      call NhlFRLSetFloat(srlist,'tmXBLabelFontHeightF',0.024,ierr)
C
C Y-axis resources.
C
      call NhlFRLSetString(srlist,'tmYLMode','EXPLICIT',ierr)
      call NhlFRLSetFloatArray(srlist,'tmYLValues',yvalues,5,ierr)
      call NhlFRLSetStringArray(srlist,'tmYLLabels',ylabels,5,ierr)
      call NhlFRLSetFloat(srlist,'tmYLTickSpacingF',1.,ierr)
      call NhlFRLSetInteger(srlist,'tmYLLabelFont',22,ierr)
      call NhlFRLSetFloat(srlist,'tmYLLabelFontHeightF',0.024,ierr)
      call NhlFRLSetString(srlist,'tmYMajorGrid','True',ierr)
      call NhlFRLSetString(srlist,'tmYLMinorOn','False',ierr)
      call NhlFRLSetString(srlist,'tmYRMinorOn','False',ierr)
C
C Specify the Y-axis range precisely.
C
      call NhlFRLSetFloat(srlist,'trYMinF',-2.5,ierr)
      call NhlFRLSetFloat(srlist,'trYMaxF',2.5,ierr)
C
C Supply titles
C
      call NhlFRLSetInteger(srlist,'tiMainFont',26,ierr)
      call NhlFRLSetFloat(srlist,'tiMainFontHeightF',.03,ierr)
      call NhlFRLSetString(srlist,'tiMainString',
     +     'Temperature Deviations From Mean',ierr)
      call NhlFRLSetInteger(srlist,'tiXAxisFont',22,ierr)
      call NhlFRLSetString(srlist,'tiXAxisString',
     +     'Hours Since Midnight',ierr)
      call NhlFRLSetString(srlist,'tiYAxisString','Deviations',ierr)
      call NhlFRLSetInteger(srlist,'tiYAxisFont',22,ierr)
      call NhlFCreate(plotid,'XyPlot',NhlFxyPlotClass,xworkid,srlist,
     +     ierr)
C
C Specify the use of filled circle markers.
C
      call NhlFAddData(plotid,'xyCoordData',dataid,dataspec)

      call NhlFRLClear(srlist)
      call NhlFRLSetString(srlist,'xyMarkLineMode','MARKERS',ierr)
      call NhlFRLSetString(srlist,'xyMonoMarkLineMode','True',ierr)
      call NhlFRLSetInteger(srlist,'xyMarker',16,ierr)
      call NhlFRLSetString(srlist,'xyMonoMarkerSize','True',ierr)
      call NhlFRLSetFloat(srlist,'xyMarkerSizeF',.02,ierr)
      call NhlFSetValues(dataspec,srlist,ierr)
      call NhlFDraw(plotid,ierr)
      call NhlFFrame(xworkid,ierr)
C
C Picture 4:
C (In Ncl, this section illustrate the use of being able to easily pick
C out subsections of data arrays.
C
      j = 1
      do 60 i = 3,NHOURS,6
         x_array2(j) = x_array(i)
         y_array2(j) = (9./5.)*tr_data(i,1)+32.
         j = j+1
 60   continue
      call NhlFRLClear(srlist)
      call NhlFRLSetFloatArray(srlist,'caXArray',x_array2,j-1,ierr)
      call NhlFRLSetFloatArray(srlist,'caYArray',y_array2,j-1,ierr)
      call NhlFCreate(dataid,'xyData',NhlFcoordArraysClass,appid,srlist,
     +     ierr)
      call NhlFRLClear(srlist)
      call NhlFRLSetInteger(srlist,'xyCoordData',dataid,ierr)
C
C X-axis resources 
C
      call NhlFRLSetString(srlist,'tmXBMode','MANUAL',ierr)
      call NhlFRLSetFloat(srlist,'tmXBTickStartF',2.,ierr)
      call NhlFRLSetFloat(srlist,'tmXBTickEndF',22.,ierr)
      call NhlFRLSetFloat(srlist,'tmXBTickSpacingF',6.,ierr)
      call NhlFRLSetInteger(srlist,'tmXBLabelFont',22,ierr)
      call NhlFRLSetFloat(srlist,'tmXBLabelFontHeightF',0.024,ierr)
      call NhlFRLSetInteger(srlist,'tmXBMinorPerMajor',0,ierr)
C
C Y-axis resources.
C
      call NhlFRLSetString(srlist,'tmYLMode','MANUAL',ierr)
      call NhlFRLSetFloat(srlist,'tmYLTickStartF',30.,ierr)
      call NhlFRLSetFloat(srlist,'tmYLTickEndF',60.,ierr)
      call NhlFRLSetFloat(srlist,'tmYLTickSpacingF',5.,ierr)
      call NhlFRLSetString(srlist,'tmYLAutoPrecision','False',ierr)
      call NhlFRLSetInteger(srlist,'tmYLPrecision',2,ierr)
      call NhlFRLSetInteger(srlist,'tmYLLabelFont',22,ierr)
      call NhlFRLSetFloat(srlist,'tmYLLabelFontHeightF',0.024,ierr)
      call NhlFRLSetInteger(srlist,'tmYLMinorPerMajor',4,ierr)
C
C Specify the Y-axis range precisely.
C
      call NhlFRLSetFloat(srlist,'trYMinF',30.,ierr)
      call NhlFRLSetFloat(srlist,'trYMaxF',60.,ierr)
C
C Supply titles
C
      call NhlFRLSetInteger(srlist,'tiMainFont',26,ierr)
      call NhlFRLSetString(srlist,'tiMainString',
     +     'Temperatures at Six Hour Intervals',ierr)
      call NhlFRLSetFloat(srlist,'tiMainFontHeightF',.03,ierr)
      call NhlFRLSetInteger(srlist,'tiXAxisFont',22,ierr)
      call NhlFRLSetString(srlist,'tiXAxisString',
     +     'Hours Since Midnight',ierr)
      call NhlFRLSetInteger(srlist,'tiYAxisFont',22,ierr)
      call NhlFRLSetString(srlist,'tiYAxisString',
     +     'Temperature (degrees F)',ierr)
      call NhlFCreate(plotid,'XyPlot',NhlFxyPlotClass,xworkid,srlist,
     +     ierr)

      call NhlFDraw(plotid,ierr)
      call NhlFFrame(xworkid,ierr)
C
C NhlDestroy destroys the given id and all of its children.
C
      call NhlFDestroy(appid,ierr)
      call NhlFRLDestroy(srlist)
C
C Restores state.
C
      call NhlFClose

      end

C
C $Id: tdmrka.f,v 1.4 2008-07-27 00:17:32 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE TDMRKA (IMRK,UMRK,VMRK,WMRK,SMRK,RTRI,MTRI,NTRI,IRST)
C
        DIMENSION RTRI(10,MTRI)
C
C This routine is called to put a marker of type IMRK at the point with
C coordinates (UMRK,VMRK,WMRK) and with radius SMRK.  This is done by
C adding triangles to the triangle list in the array RTRI.  MTRI is the
C maximum number of triangles that can be put in the list and NTRI is
C the number of triangles currently in the list.  IRST is the index of
C the rendering style to be used for the marker.
C
C IMRK may have a value from 1 to 5, inclusive, to select a tetrahedron,
C an octahedron, a cube, an icosahedron, or an elaborated icosahedron
C (effectively, a sphere), respectively.
C
C Declare the labelled common block containing the definitions of the
C triangles making up the various markers.
C
        COMMON /TDCOM5/ TMK1(36),TMK2(72),TMK3(108),TMK4(180),TMK5(720)
        SAVE   /TDCOM5/
C
C Get the real equivalent of the rendering style index.
C
        RRST=REAL(IRST)
C
C Depending on what kind of mark is requested, construct and put into
C the triangle array the proper set of triangles to create that mark.
C
        IF (IMRK.EQ.1) THEN
C
C A tetrahedron.
C
          DO 101 I=1,4
            IF (NTRI.LT.MTRI) THEN
              NTRI=NTRI+1
              RTRI(1,NTRI)=UMRK+SMRK*TMK1(9*I-8)
              RTRI(2,NTRI)=VMRK+SMRK*TMK1(9*I-7)
              RTRI(3,NTRI)=WMRK+SMRK*TMK1(9*I-6)
              RTRI(4,NTRI)=UMRK+SMRK*TMK1(9*I-5)
              RTRI(5,NTRI)=VMRK+SMRK*TMK1(9*I-4)
              RTRI(6,NTRI)=WMRK+SMRK*TMK1(9*I-3)
              RTRI(7,NTRI)=UMRK+SMRK*TMK1(9*I-2)
              RTRI(8,NTRI)=VMRK+SMRK*TMK1(9*I-1)
              RTRI(9,NTRI)=WMRK+SMRK*TMK1(9*I  )
              RTRI(10,NTRI)=RRST
            END IF
  101     CONTINUE
C
        ELSE IF (IMRK.EQ.2) THEN
C
C An octahedron.
C
          DO 102 I=1,8
            IF (NTRI.LT.MTRI) THEN
              NTRI=NTRI+1
              RTRI(1,NTRI)=UMRK+SMRK*TMK2(9*I-8)
              RTRI(2,NTRI)=VMRK+SMRK*TMK2(9*I-7)
              RTRI(3,NTRI)=WMRK+SMRK*TMK2(9*I-6)
              RTRI(4,NTRI)=UMRK+SMRK*TMK2(9*I-5)
              RTRI(5,NTRI)=VMRK+SMRK*TMK2(9*I-4)
              RTRI(6,NTRI)=WMRK+SMRK*TMK2(9*I-3)
              RTRI(7,NTRI)=UMRK+SMRK*TMK2(9*I-2)
              RTRI(8,NTRI)=VMRK+SMRK*TMK2(9*I-1)
              RTRI(9,NTRI)=WMRK+SMRK*TMK2(9*I  )
              RTRI(10,NTRI)=RRST
            END IF
  102     CONTINUE
C
        ELSE IF (IMRK.EQ.3) THEN
C
C A twelve-triangle cube.
C
          DO 103 I=1,12
            IF (NTRI.LT.MTRI) THEN
              NTRI=NTRI+1
              RTRI(1,NTRI)=UMRK+SMRK*TMK3(9*I-8)
              RTRI(2,NTRI)=VMRK+SMRK*TMK3(9*I-7)
              RTRI(3,NTRI)=WMRK+SMRK*TMK3(9*I-6)
              RTRI(4,NTRI)=UMRK+SMRK*TMK3(9*I-5)
              RTRI(5,NTRI)=VMRK+SMRK*TMK3(9*I-4)
              RTRI(6,NTRI)=WMRK+SMRK*TMK3(9*I-3)
              RTRI(7,NTRI)=UMRK+SMRK*TMK3(9*I-2)
              RTRI(8,NTRI)=VMRK+SMRK*TMK3(9*I-1)
              RTRI(9,NTRI)=WMRK+SMRK*TMK3(9*I  )
              RTRI(10,NTRI)=RRST
            END IF
  103     CONTINUE
C
        ELSE IF (IMRK.EQ.4) THEN
C
C An icosahedron.
C
          DO 104 I=1,20
            IF (NTRI.LT.MTRI) THEN
              NTRI=NTRI+1
              RTRI(1,NTRI)=UMRK+SMRK*TMK4(9*I-8)
              RTRI(2,NTRI)=VMRK+SMRK*TMK4(9*I-7)
              RTRI(3,NTRI)=WMRK+SMRK*TMK4(9*I-6)
              RTRI(4,NTRI)=UMRK+SMRK*TMK4(9*I-5)
              RTRI(5,NTRI)=VMRK+SMRK*TMK4(9*I-4)
              RTRI(6,NTRI)=WMRK+SMRK*TMK4(9*I-3)
              RTRI(7,NTRI)=UMRK+SMRK*TMK4(9*I-2)
              RTRI(8,NTRI)=VMRK+SMRK*TMK4(9*I-1)
              RTRI(9,NTRI)=WMRK+SMRK*TMK4(9*I  )
              RTRI(10,NTRI)=RRST
            END IF
  104     CONTINUE
C
        ELSE IF (IMRK.EQ.5) THEN
C
C An elaborated icosahedron.
C
          DO 105 I=1,80
            IF (NTRI.LT.MTRI) THEN
              NTRI=NTRI+1
              RTRI(1,NTRI)=UMRK+SMRK*TMK5(9*I-8)
              RTRI(2,NTRI)=VMRK+SMRK*TMK5(9*I-7)
              RTRI(3,NTRI)=WMRK+SMRK*TMK5(9*I-6)
              RTRI(4,NTRI)=UMRK+SMRK*TMK5(9*I-5)
              RTRI(5,NTRI)=VMRK+SMRK*TMK5(9*I-4)
              RTRI(6,NTRI)=WMRK+SMRK*TMK5(9*I-3)
              RTRI(7,NTRI)=UMRK+SMRK*TMK5(9*I-2)
              RTRI(8,NTRI)=VMRK+SMRK*TMK5(9*I-1)
              RTRI(9,NTRI)=WMRK+SMRK*TMK5(9*I  )
              RTRI(10,NTRI)=RRST
            END IF
  105     CONTINUE
C
        END IF
C
C Done.
C
        RETURN
C
      END

C
C	$Id: wmdrft.f,v 1.16 2008-07-27 00:17:36 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE WMDRFT(N,X,Y)
C
C  This subroutine draws a front along the line determined by the
C  world coordinates  (X(I),Y(I)) for I=1,N.  A spline curve is
C  fit to the points, so only a few points need be supplied.
C
      include 'wmcomn.h'
C
      DIMENSION X(N),Y(N),OLDWN(4),OLDVP(4),OCLIP(4)
      DIMENSION IPOSIT(200)
C
      NPO = N
C
C  Check error status.
C
      IF (ICFELL('WMDRFT - Uncleared prior error',1) .NE. 0) RETURN
      IF (NPO .LE. 1) THEN
        CALL SETER ('WMDRFT - input line must have at least two points',       
     +              1, 1)
        RETURN
      ENDIF
C
C  If the original line has more than NPTS points, filter out NPTS
C  points from it.  Otherwise, keep the original points.
C
      IF (NPO .GT. NPTS) THEN
        NPO = NPTS
        CALL WMFPTS(N,X,Y,NPTS,XO,YO)
      ELSE
        DO 100 I=1,N
          XO(I) = X(I)
          YO(I) = Y(I)
  100   CONTINUE
      ENDIF
C
C  Cull out any duplicate points.
C
      NTOT = NPO
      I = 2
  120 CONTINUE
      CALL WMSQDP(XO,YO,NTOT,I,IFLG)
      IF (IFLG .EQ. 1) THEN
        NTOT = NTOT-1
        IF(I .LE. NTOT) GO TO 120
      ELSE
        I = I+1
        IF (I .GT. NTOT) THEN
          GO TO 110
        ELSE
          GO TO 120
        ENDIF
      ENDIF
  110 CONTINUE
      NPO = NTOT 
C
C  Construct a spline curve having NPTS points in it that represents
C  the curve in (X,Y).  We use Alan Cline's spline package for this.
C
      IF (TNSION .EQ. -1.) THEN
        TNSION = 1.
      ENDIF
C
C  Interpolate if ISMOTH=0; use a smoothing spline otherwise.
C
      IF (ISMOTH .EQ. 0) THEN
C
C  S is a common variable of maximal dimension of NPTS.
C
        CALL MSKRV1(NPO,XO,YO,SLOPE1,SLOPE2,XS,YS,TEMP,S,TNSION,ISLFLG)
        DO 10 I=1,NPTS
          T = REAL(I-1)/REAL(NPTS-1)
          IF (I .EQ. 1) THEN
            CALL MSKRV2(T,XOUT(I),YOUT(I),NPO,XO,YO,XS,YS,S,TNSION,1,
     +                  SLOPEL)
          ELSE IF (I .EQ. NPTS) THEN
            CALL MSKRV2(T,XOUT(I),YOUT(I),NPO,XO,YO,XS,YS,S,TNSION,0,
     +                  SLP)
          ELSE
            CALL MSKRV2(T,XOUT(I),YOUT(I),NPO,XO,YO,XS,YS,S,TNSION,1,
     +                  SLOPER)
          ENDIF
   10   CONTINUE
      ELSE
        TEPS = SQRT(2./REAL(NPO))
        IOBSET = 1
        IF (OBSERR .EQ. -1.) THEN
          IOBSET = 0
          XOMAX = WMCMAX(NPO,XO)
          YOMAX = WMCMAX(NPO,YO)
          OBSERR = 0.025*MAX(XOMAX,YOMAX)
          OBSRET = OBSERR
        ENDIF
        IRSSET = 1
        IF (RSMOTH .EQ. -1.) THEN
          IRSSET = 0
          RSMOTH = REAL(NPO)
          RSMRET = RSMOTH
        ENDIF 
        CALL CURVS1(NPO,XO,YO,OBSERR,1,RSMOTH,TEPS,TEMP(1,1),
     +              XS,YS,XSS,YSS,TNSION,TEMP(1,2),IER)
        DO 11 I=1,NPTS
          T = REAL(I-1)/REAL(NPTS-1)
          CALL CURVS2(T,N,TEMP(1,1),XS,YS,XSS,YSS,TNSION,XOUT(I),
     +                YOUT(I))
   11   CONTINUE
      ENDIF
C
C  Restore flags for unset values.
C
      IF(IOBSET .EQ. 0) OBSERR = -1.
      IF(IRSSET .EQ. 0) RSMOTH = -1.
C
C  Convert to NDC space.
C
      CALL WMW2NX(NPTS,XOUT,XS)
      CALL WMW2NY(NPTS,YOUT,YS)
      DO 20 I=1,NPTS
        XOUT(I) = XS(I)
        YOUT(I) = YS(I)
   20 CONTINUE
C
C  Save normalization transformation number 1 along with its
C  window and viewport and define a new transformation 1
C  that has as its window and viewport the current clip
C  rectangle.
C
      CALL GQCNTN(IER,NTRO)
      CALL GQCLIP(IER,ICLIP,OCLIP)
      CALL GQNT(1,IER,OLDWN,OLDVP)
C     
      CALL GSWN(1,OCLIP(1),OCLIP(2),OCLIP(3),OCLIP(4))
      CALL GSVP(1,OCLIP(1),OCLIP(2),OCLIP(3),OCLIP(4))
      CALL GSELNT(1)
C
C  Save the current value for fill area interior style, and set
C  interior style according to that needed.
C
      CALL GQFAIS(IER,INSTYO)
      CALL GSFAIS(1)
C
C  Save the current value for linewidth scale, and set to the current
C  value of RLINWD.
C
      CALL GQLWSC(IER,RLNSCO)
      CALL GSLWSC(RLINWD)
C
C  Save the current line and fill colors and set them to ICOLOR.
C
      CALL GQFACI(IER,IFCLRO)
      CALL GQPLCI(IER,ILCLRO)
      CALL GSFACI(ICOLOR)
      CALL GSPLCI(ICOLOR)
C
C  Calculate the distances along the curve.
C
      ALEN(1) = 0.
      DO 30 I=2,NPTS
        ALEN(I) = ALEN(I-1) +
     +              SQRT((XOUT(I)-XOUT(I-1))**2+(YOUT(I)-YOUT(I-1))**2)      
   30 CONTINUE
C
C  Just draw line if squall or tropical front.
C
      IF (IFRONT.EQ.5 .OR. IFRONT.EQ.6) THEN
        CALL WMLGPL(NPTS,XOUT,YOUT)
        GO TO 80
      ENDIF
C
C  Calculate the number of symbols along the curve.
C
      DSTBTW = BETDST
      CRVLEN = ALEN(NPTS)
      IF (NUMSYO .GE. 0) THEN
        NUMSYM = MIN(NUMSYO,MAXSYM)
      ELSE
        NUMSYM = 1
        DO 40 I=1,MAXSYM
          IF (REAL(I+1)*SYMWID+BEGDST+ENDDST+REAL(I)*DSTBTW .LE.
     +        CRVLEN) THEN
            NUMSYM = I+1
            IF (NUMSYM .EQ. MAXSYM) GO TO 50
            GO TO 40
          ELSE
            GO TO 50
          ENDIF
   40   CONTINUE
      ENDIF
   50 CONTINUE
C
C  Calculate distance between symbols for even spacing.
C
      IF (NUMSYM .EQ. 1) THEN
C
C  If NUMSYM is "1", and the front is occluded or stationary, see
C  if we can adjust the spacing between symbols so that two symbols
C  can be put out.  If not, issue a warning.
C
        IF (IFRONT.EQ.3. OR. IFRONT.EQ.4) THEN
          IF (BEGDST+ENDDST+2.*SYMWID .LT. CRVLEN) THEN
            NUMSYM = 2
            DSTBTW = CRVLEN-BEGDST-ENDDST-NUMSYM*SYMWID
          ELSE
            IF (IFRONT .EQ. 3) THEN
              PRINT *,    'WMDRFT - Warning: not enough space along the 
     +input curve to draw two symbols for a stationary front'
              NUMSYM = 0
C
C  For a stationary front, draw the line and return.  First find
C  the index that marks the midpoint of the line.
C
              HLFLEN = 0.5*ALEN(NPTS)
              IHLF = 2
              DO 90 I=1,NPTS
                IF (ALEN(I) .GE. HLFLEN) THEN
                  IHLF = I
                  GO TO 91
                ENDIF 
   90         CONTINUE
   91         CONTINUE
              ICOLOR = ICOLDC
              CALL WMLGPL(IHLF,XOUT,YOUT)
              ICOLOR = IWARMC
              IR = NPTS-IHLF+1
              CALL WMLGPL(IR,XOUT(IHLF),YOUT(IHLF))
              GO TO 80
            ELSE
              PRINT *,    'WMDRFT - Warning: not enough space along the 
     +input curve to draw two symbols for an occluded front'
              NUMSYM = 0
C
C  For an occluded front, draw the line and return.  First find
C  the index that marks the midpoint of the line.
C
              HLFLEN = 0.5*ALEN(NPTS)
              IHLF = 2
              DO 92 I=1,NPTS
                IF (ALEN(I) .GE. HLFLEN) THEN
                  IHLF = I
                  GO TO 93
                ENDIF 
   92         CONTINUE
   93         CONTINUE
              ICOLOR = ICOLDC
              CALL WMLGPL(IHLF,XOUT,YOUT)
              ICOLOR = IWARMC
              IR = NPTS-IHLF+1
              CALL WMLGPL(IR,XOUT(IHLF),YOUT(IHLF))
              GO TO 80
            ENDIF
          ENDIF
        ENDIF
      ELSE
        DSTBTW = (CRVLEN-BEGDST-ENDDST-NUMSYM*SYMWID)/(NUMSYM-1) 
      ENDIF
C
C  Draw the symbols along the front.
C
      IF (NUMSYM .GT. 0) THEN
        CALL WMDRSM(NUMSYM,DSTBTW,NPTS,XOUT,YOUT,ALEN,XS,YS,IPOSIT)
      ENDIF
C
   60 CONTINUE
C
C  Draw the spline curve if it is long enough.
C 
      IF (ALEN(NPTS) .GT. BEGDST+SYMWID+ENDDST) THEN
        CALL GQPLCI(IER,ICOLD)
        IF (NUMSYM .LE. 1) THEN
          IF (ABS(ISTYPE(1)) .EQ. 1) THEN
            ICOLOR = ICOLDC
          ELSE IF (ABS(ISTYPE(1)) .EQ. 2) THEN
            ICOLOR = IWARMC
          ENDIF
          CALL WMLGPL(NPTS,XOUT,YOUT)
        ELSE
C
C  Since the spline curve will be drawn in segments (so that 
C  the proper colors can be applied) we need to guard against 
C  possible notches in thick curves by drawing the entire spline
C  first.
C 
          IF (IFRONT.GE.1 .AND. IFRONT.LE.4) THEN
            ICOLOR = IWARMC
            IF (IFRONT .EQ. 1) THEN
              ICOLOR = ICOLDC
            ELSE
              ICOLOR = IWARMC
            ENDIF
            CALL WMLGPL(NPTS,XOUT,YOUT)
          ENDIF
C
C  Now draw the segments.
C
          IBL = 1
          DO 70 J=1,NUMSYM-1
            IF (ABS(ISTYPE(J)) .EQ. 1) THEN
              ICOLOR = ICOLDC
            ELSE IF (ABS(ISTYPE(J)) .EQ. 2) THEN
              ICOLOR = IWARMC
            ENDIF
            IBR = (IPOSIT(J+1)+IPOSIT(J))/2
            IF (IBR-IBL .GE. 1) THEN
              CALL WMLGPL(IBR-IBL+1,XOUT(IBL),YOUT(IBL))
            ENDIF
            IBL = IBR
   70     CONTINUE 
          IF (ABS(ISTYPE(NUMSYM)) .EQ. 1) THEN
            ICOLOR = ICOLDC
          ELSE IF (ABS(ISTYPE(NUMSYM)) .EQ. 2) THEN
            ICOLOR = IWARMC
          ENDIF
          IBR = NPTS
          CALL WMLGPL(IBR-IBL+1,XOUT(IBL),YOUT(IBL))
        ENDIF
        ICOLOR = ICOLD
      ENDIF
C
C  Restore normalization transformation 1, interior style,
C  linewidth, fill color, line color.
C
  80  CONTINUE
      CALL GSWN(1,OLDWN(1),OLDWN(2),OLDWN(3),OLDWN(4))
      CALL GSVP(1,OLDVP(1),OLDVP(2),OLDVP(3),OLDVP(4))
      CALL GSELNT(NTRO)
      CALL GSFAIS(INSTYO)
      CALL GSLWSC(RLNSCO)
      CALL GSFACI(IFCLRO)
      CALL GSPLCI(ILCLRO)
C
      RETURN
      END
      SUBROUTINE WMSQDP(X,Y,NTOT,I,IFLG)
C
C  If (X(I),Y(I)) equals some (X(J),Y(J)) for J .LT. I,
C  then squeeze (X(I),Y(I)) out of X and Y and set IFLG = 1.
C
      DIMENSION X(NTOT),Y(NTOT)
C
      DO 10 J=1,I-1
        IF (X(I).EQ.X(J) .AND. Y(I).EQ.Y(J)) THEN
          IF (I .EQ. NTOT) THEN
            IFLG = 1
            RETURN
          ENDIF
          DO 20 K=I,NTOT-1
            X(K) = X(K+1)
            Y(K) = Y(K+1)
            IFLG = 1
   20     CONTINUE
          RETURN
        ENDIF
   10 CONTINUE
C
      IFLG = 0
      RETURN
      END

C NCLFORTSTART
      SUBROUTINE DWGTVOLRMSE(T,Q,WGTZ,WGTY,WGTX,MX,NY,KZ,TMSG,QMSG,
     +                       IFLAG,RMSE)
      IMPLICIT NONE
      INTEGER MX,NY,KZ,IFLAG
      DOUBLE PRECISION T(MX,NY,KZ),Q(MX,NY,KZ)
      DOUBLE PRECISION WGTX(MX),WGTY(NY),WGTZ(KZ)
      DOUBLE PRECISION TMSG,QMSG
      DOUBLE PRECISION RMSE
C NCLEND

C NCL: rmsqTQ = wgtVolRmse (T,Q,wgtz,wgty,wgtx,flag)
C compute the weighted root-mean-square-difference [rmse]
c .   This could have been programmed more efficiently.

      INTEGER NL,ML,KL,KMSG
      DOUBLE PRECISION SUMD,SUMW,WGTXY,SUMTQ,SUMWZ,VARTQ

C Nomenclature:
C INPUT:
C t      - 3D array
C q      - 3D array
C wgtz   - 1D array of length "kz"
C wgty   - 1D array of length "ny"
C wgtx   - 1D array of length "mx"
C mx     - 1st [fastest varying] dimension of "t" [eg, longitude]
C ny     - 2nd                   dimension of "t" [eg, latitude ]
C kz     - 3rd [slowest varying] dimension of "t" [eg, latitude ]
c tmsg   - msg value
c qmsg   - msg value
C iflag  - flag
C          =0 compute  rmse ignoring msg values
C          =1 if any msg data is encountered return as msg

C OUTPUT:
C rmse   - volume root-mean-square-difference [weighted]

      SUMD = 0.0D0
      SUMW = 0.0D0
      RMSE = TMSG
      KMSG = 0

      DO NL = 1,NY
          DO ML = 1,MX
              SUMTQ = 0
              SUMWZ = 0.0D0
c                                     sum wgted vertical differences
c                                     at each lat/lon point
              DO KL = 1,KZ
                  IF (T(ML,NL,KL).NE.TMSG .AND.
     +                Q(ML,NL,KL).NE.QMSG) THEN
                      SUMTQ = SUMTQ + WGTZ(KL)*
     +                        (T(ML,NL,KL)-Q(ML,NL,KL))**2
                      SUMWZ = SUMWZ + WGTZ(KL)
                  ELSE
                      KMSG = KMSG + 1
                  END IF
              END DO
c                                      return if user desired
              IF (IFLAG.EQ.1 .AND. KMSG.NE.0) RETURN
c                            wgt vertical mean square difference
c                            by areal wgts x/lon and y/lat
              IF (SUMWZ.GT.0.0D0) THEN
                  VARTQ = (SUMTQ/SUMWZ)**2
                  WGTXY = WGTX(ML)*WGTY(NL)
                  SUMD  = SUMD + WGTXY*VARTQ
                  SUMW = SUMW + WGTXY
              END IF

          END DO
      END DO
c                          compute wgted rmse
      IF (SUMW.GT.0.0D0) THEN
          RMSE = SQRT(SUMD/SUMW)
      END IF

      RETURN
      END

C NCLFORTSTART
      SUBROUTINE DWGTVOLRMSECCM(T,Q,DPT,DPQ,WGTY,WGTX,MX,NY,KZ,TMSG,
     +                         QMSG,IFLAG,RMSE)
      IMPLICIT NONE
      INTEGER MX,NY,KZ,IFLAG
      DOUBLE PRECISION T(MX,NY,KZ),Q(MX,NY,KZ)
      DOUBLE PRECISION WGTX(MX),WGTY(NY)
      DOUBLE PRECISION DPT(MX,NY,KZ),DPQ(MX,NY,KZ)
      DOUBLE PRECISION TMSG,QMSG
      DOUBLE PRECISION RMSE
C NCLEND

C NCL: rmsqTQ = wgtVolRmse_ccm (T,Q,dpT,dpQ,wgty,wgtx,flag)
C compute the weighted root-mean-square-difference [rmse]
c .   This could have been programmed more efficiently.

      INTEGER NL,ML,KL,KMSG
      DOUBLE PRECISION SUMD,SUMW,WGTXY,SUMTQ,SUMDP,WGTDP,VARTQ

C Nomenclature:
C INPUT:
C t      - 3D array
C q      - 3D array
C dpt    - 3D array same size as "t" and "q"
C dpq    - 3D array same size as "t" and "q"
C wgty   - 1D array of length "ny"
C wgtx   - 1D array of length "mx"
C mx     - 1st [faster varying] dimension of "t" [eg, longitude]
C ny     - 2nd [slower varying] dimension of "t" [eg, latitude ]
C kz     - 3rd [slower varying] dimension of "t" [eg, latitude ]
c tmsg   - msg value
c qmsg   - msg value
C iflag  - flag
C          =0 compute  rmse ignoring msg values
C          =1 if any msg data is encountered return as msg

C OUTPUT:
C rmse   - volume root-mean-square-difference [weighted]
C          Dave Williamson suggested the use of the mean "dp"

      SUMD = 0.0D0
      SUMW = 0.0D0
      RMSE = TMSG
      KMSG = 0

      DO NL = 1,NY
          DO ML = 1,MX
              SUMTQ = 0.0D0
              SUMDP = 0.0D0
c                                     sum wgted vertical differences
c                                     at each lat/lon point
              DO KL = 1,KZ
                  IF (T(ML,NL,KL).NE.TMSG .AND.
     +                Q(ML,NL,KL).NE.QMSG) THEN
                      WGTDP = 0.5D0* (DPT(ML,NL,KL)+DPQ(ML,NL,KL))
                      SUMTQ = SUMTQ + WGTDP*(T(ML,NL,KL)-Q(ML,NL,KL))**2
                      SUMDP = SUMDP + WGTDP
                  ELSE
                      KMSG = KMSG + 1
                  END IF
              END DO
c                                      return if user desired
              IF (IFLAG.EQ.1 .AND. KMSG.NE.0) RETURN
c                        wgt vertical mean square difference
c                        by areal wgts x/lon and y/lat
              IF (SUMDP.GT.0.0D0) THEN
                  VARTQ = SUMTQ/SUMDP
                  WGTXY = WGTX(ML)*WGTY(NL)
                  SUMD  = SUMD + WGTXY*VARTQ
                  SUMW  = SUMW + WGTXY
              END IF

          END DO
      END DO
c                          compute wgted rmse
      IF (SUMW.GT.0.0D0) THEN
          RMSE = SQRT(SUMD/SUMW)
      END IF

      RETURN
      END

C NCLFORTSTART
      SUBROUTINE DWMRQ (P,TD,PMSG,TDMSG,NMAX,WMR,WMRMSG,ISWIT)
      IMPLICIT NONE
      INTEGER  NMAX, ISWIT
      DOUBLE PRECISION P(NMAX), TD(NMAX),PMSG,TDMSG
      DOUBLE PRECISION WMR(NMAX),WMRMSG
C NCLEND    
      DOUBLE PRECISION DWMRSKEWT 
      EXTERNAL DWMRSKEWT

C ncl:   q = mixhum_ptd (p,td,option)   [ q=g/kg ]
c                        p  - PA
c                        td - K
C local
      INTEGER  N  
      DOUBLE PRECISION T0, PA2MB
      DATA     T0    /273.15d0/
      DATA     PA2MB /0.01d0  /

C mixing ratio (kg/kg)
c the function wants hPA (mb) and degrees centigrade
      
      DO N=1,NMAX
         IF (TD(N).EQ.TDMSG.or.P(N).EQ.PMSG) then
             WMR(N) = WMRMSG
         ELSE
             WMR(N) = DWMRSKEWT(P(N)*PA2MB,(TD(N)-T0))*0.001d0  
         END IF
      END DO

c if ISWIT=2 calculate specific humidity (kg/kg)
      
      IF (ABS(ISWIT).EQ.2) THEN
          DO N=1,NMAX
             IF (WMR(N).NE.WMRMSG) THEN
                 WMR(N) = (WMR(N)/(WMR(N)+1.d0))
             END IF 
         END DO
      END IF

c if ISWIT < 0 then return g/kg
      
      IF (ISWIT.LT.0) THEN
          DO N=1,NMAX
             IF (WMR(N).NE.WMRMSG) THEN
                 WMR(N) = WMR(N)*1000.d0
             END IF 
         END DO
      END IF
      
      RETURN
      END

      PROGRAM CMPUSR
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Open GKS, and turn off clipping.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
      CALL GSCLIP (0)
C
C Call the mapping routine CMPUSR
C
      CALL TCMPUSR
C
C Close GKS and quit.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS

      STOP
      END

      SUBROUTINE TCMPUSR
C
C Set up Satellite-view.
C
      CALL MAPROJ ('SV',40.,10.,0.)
      CALL MAPSTR ('SA - SATELLITE DISTANCE',5.)
C
C Use country outline set
C
      CALL MAPSTC ('OU - OUTLINE DATASET SELECTOR','PO')
C
C Set Dot Distance to be 1
C
      CALL MAPSTR ('DD - DISTANCE BETWEEN DOTS',8.)
C
      CALL MAPDRW
      
      CALL FRAME
      
      RETURN
      END
      
      SUBROUTINE MAPUSR (IPRT)
C
C MAPUSR is used to change the appearance of various parts of a map.
C It is called just before and just after each portion of a map is
C drawn.  The default version does nothing.  This version chooses a
C different dash line pattern for each portion of the map in a different
C dash pattern.
C
C IPRT addresses each portion of the map as follows:
C   1 - Perimeter
C   2 - Grid
C   3 - Labels
C   4 - Limb lines
C   5 - Continental outlines
C   6 - US state outlines
C   7 - International outlines
C
C 1110000011100000
C
      IF (IPRT .EQ. 1) CALL DASHDB(57568)
C
C 1111111100000000 
C
      IF (IPRT .EQ. 2) CALL DASHDB(65280)
C
C 1111111111111111
C
      IF (IPRT .EQ. 3) CALL DASHDB(65535)
C
C 0100110001110000
C
      IF (IPRT .EQ. 4) CALL DASHDB(19568)
C
C 1111000011110000 
C
      IF (IPRT .EQ. 5) CALL DASHDB(61680)
C
C 1110010011100100
C
      IF (IPRT .EQ. 6) CALL DASHDB(58596)
C
C 010101010101010101
C
      IF (IPRT .EQ. 7) CALL DASHDB(21845)

      RETURN
      END

C
C $Id: pj07sp.f,v 1.5 2008-07-27 00:17:10 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE PJ07SP (COORD,CRDIO,INDIC)
C
C -- P O L Y C O N I C
C
      IMPLICIT REAL (A-Z)
      INTEGER INDIC
      DIMENSION GEOG(2),PROJ(2),COORD(2),CRDIO(2)
C **** PARAMETERS **** A,E,ES,LON0,LAT0,X0,Y0,E0,E1,E2,ML0 *************
      COMMON /ERRMZ0/ IERR
        INTEGER IERR
      SAVE   /ERRMZ0/
      COMMON /PRINZ0/ IPEMSG,IPELUN,IPPARM,IPPLUN
        INTEGER IPEMSG,IPELUN,IPPARM,IPPLUN
      SAVE   /PRINZ0/
      COMMON /PC07SP/ A,LON0,X0,Y0,E,E0,E1,E2,E3,ES,ML0
      DATA TOL /1.0E-7/
      DATA ZERO,ONE /0.0E0,1.0E0/
C
C -- F O R W A R D   . . .
C
      IF (INDIC .EQ. 0) THEN
C
         GEOG(1) = COORD(1)
         GEOG(2) = COORD(2)
         IERR = 0
         CON = ADJLSP (GEOG(1) - LON0)
         IF (ABS(GEOG(2)) .GT. TOL) GO TO 240
         PROJ(1) = X0 + A * CON
         PROJ(2) = Y0 - A * ML0
         CRDIO(1) = PROJ(1)
         CRDIO(2) = PROJ(2)
         RETURN
  240    SINPHI = SIN (GEOG(2))
         COSPHI = COS (GEOG(2))
         ML = MLFNSP (E0,E1,E2,E3,GEOG(2))
         MS = MSFNSP (E,SINPHI,COSPHI)
         CON = CON * SINPHI
         PROJ(1) = X0 + A * MS * SIN (CON) / SINPHI
         PROJ(2) = Y0 + A * (ML - ML0 + MS * (ONE - COS(CON)) / SINPHI)
         CRDIO(1) = PROJ(1)
         CRDIO(2) = PROJ(2)
         RETURN
      END IF
C
C -- I N V E R S E   . . .
C
      IF (INDIC .EQ. 1) THEN
C
         PROJ(1) = COORD(1)
         PROJ(2) = COORD(2)
         IERR = 0
         X = PROJ(1) - X0
         Y = PROJ(2) - Y0
         AL = ML0 + Y / A
         IF (ABS (AL) .GT. TOL) GO TO 340
         GEOG(1) = X / A + LON0
         GEOG(2) = ZERO
         CRDIO(1) = GEOG(1)
         CRDIO(2) = GEOG(2)
         RETURN
  340    B = AL * AL + (X / A) ** 2
         CALL PHI4SP (ES,E0,E1,E2,E3,AL,B,C,GEOG(2))
         IF (IERR .EQ. 0) GO TO 360
         IERR = 074
         RETURN
  360    GEOG(1) = ADJLSP (ASINSP (X * C / A) / SIN (GEOG(2)) + LON0)
         CRDIO(1) = GEOG(1)
         CRDIO(2) = GEOG(2)
         RETURN
      END IF
C
      END

c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by UCAR                 .
c  .                                                             .
c  .       University Corporation for Atmospheric Research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                         SPHEREPACK                          .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c
      SUBROUTINE DIHGEOD(M,IDP,JDP,X,Y,Z)
      DOUBLE PRECISION X
      DOUBLE PRECISION Y
      DOUBLE PRECISION Z
      DOUBLE PRECISION PI
      DOUBLE PRECISION DPHI
      DOUBLE PRECISION BETA
      DOUBLE PRECISION THETA1
      DOUBLE PRECISION THETA2
      DOUBLE PRECISION HDPHI
      DOUBLE PRECISION TDPHI
      DOUBLE PRECISION PHI
      DOUBLE PRECISION X1
      DOUBLE PRECISION Y1
      DOUBLE PRECISION Z1
      DOUBLE PRECISION X2
      DOUBLE PRECISION Y2
      DOUBLE PRECISION Z2
      DOUBLE PRECISION X3
      DOUBLE PRECISION Y3
      DOUBLE PRECISION Z3
      DOUBLE PRECISION DXI
      DOUBLE PRECISION DYI
      DOUBLE PRECISION DZI
      DOUBLE PRECISION DXJ
      DOUBLE PRECISION DYJ
      DOUBLE PRECISION DZJ
      DOUBLE PRECISION XS
      DOUBLE PRECISION YS
      DOUBLE PRECISION ZS
      DOUBLE PRECISION X4
      DOUBLE PRECISION Y4
      DOUBLE PRECISION Z4
      DOUBLE PRECISION X5
      DOUBLE PRECISION Y5
      DOUBLE PRECISION Z5
      DOUBLE PRECISION X6
      DOUBLE PRECISION Y6
      DOUBLE PRECISION Z6
      DOUBLE PRECISION RAD
      DOUBLE PRECISION THETA
      DIMENSION X(IDP,JDP,5),Y(IDP,JDP,5),Z(IDP,JDP,5)
c
c     m         is the number of points on the edge of a
c               single geodesic triangle
c
c     x,y,z     the coordinates of the geodesic points on
c               the sphere are x(i,j,k), y(i,j,k), z(i,j,k)
c               where i=1,...,m+m-1; j=1,...,m; and k=1,...,5.
c               the indices are defined on the unfolded
c               icosahedron as follows for the case m=3
c
c                north pole
c
c                 (5,1)          0      l
c        i     (4,1) (5,2)              a    (repeated for
c           (3,1) (4,2) (5,3)  theta1   t    k=2,3,4,5 in
c        (2,1) (3,2) (4,3)              i        -->
c     (1,1) (2,2) (3,3)        theta2   t    the longitudinal
c        (1,2) (2,3)                    u    direction)
c           (1,3)                pi     d
c      j                                e
c         south pole
c
c                total number of points is 10*(m-1)**2+2
c                total number of triangles is 20*(m-1)**2
c                total number of edges is 30*(m-1)**2
c
      PI = 4.D0*ATAN(1.D0)
      DPHI = .4D0*PI
      BETA = COS(DPHI)
      THETA1 = ACOS(BETA/ (1.D0-BETA))
      THETA2 = PI - THETA1
      HDPHI = DPHI/2.D0
      TDPHI = 3.D0*HDPHI
      DO K = 1,5
          PHI = (K-1)*DPHI
          CALL DSTOC(1.D0,THETA2,PHI,X1,Y1,Z1)
          CALL DSTOC(1.D0,PI,PHI+HDPHI,X2,Y2,Z2)
          CALL DSTOC(1.D0,THETA2,PHI+DPHI,X3,Y3,Z3)
          DXI = (X2-X1)/ (M-1)
          DYI = (Y2-Y1)/ (M-1)
          DZI = (Z2-Z1)/ (M-1)
          DXJ = (X3-X2)/ (M-1)
          DYJ = (Y3-Y2)/ (M-1)
          DZJ = (Z3-Z2)/ (M-1)
          DO I = 1,M
              XS = X1 + (I-1)*DXI
              YS = Y1 + (I-1)*DYI
              ZS = Z1 + (I-1)*DZI
              DO J = 1,I
                  X(J,I,K) = XS + (J-1)*DXJ
                  Y(J,I,K) = YS + (J-1)*DYJ
                  Z(J,I,K) = ZS + (J-1)*DZJ
              END DO
          END DO
          CALL DSTOC(1.D0,THETA1,PHI+HDPHI,X4,Y4,Z4)
          DXI = (X3-X4)/ (M-1)
          DYI = (Y3-Y4)/ (M-1)
          DZI = (Z3-Z4)/ (M-1)
          DXJ = (X4-X1)/ (M-1)
          DYJ = (Y4-Y1)/ (M-1)
          DZJ = (Z4-Z1)/ (M-1)
          DO J = 1,M
              XS = X1 + (J-1)*DXJ
              YS = Y1 + (J-1)*DYJ
              ZS = Z1 + (J-1)*DZJ
              DO I = 1,J
                  X(J,I,K) = XS + (I-1)*DXI
                  Y(J,I,K) = YS + (I-1)*DYI
                  Z(J,I,K) = ZS + (I-1)*DZI
              END DO
          END DO
          CALL DSTOC(1.D0,THETA1,PHI+TDPHI,X5,Y5,Z5)
          DXJ = (X5-X3)/ (M-1)
          DYJ = (Y5-Y3)/ (M-1)
          DZJ = (Z5-Z3)/ (M-1)
          DO I = 1,M
              XS = X4 + (I-1)*DXI
              YS = Y4 + (I-1)*DYI
              ZS = Z4 + (I-1)*DZI
              DO J = 1,I
                  X(J+M-1,I,K) = XS + (J-1)*DXJ
                  Y(J+M-1,I,K) = YS + (J-1)*DYJ
                  Z(J+M-1,I,K) = ZS + (J-1)*DZJ
              END DO
          END DO
          CALL DSTOC(1.D0,0.D0,PHI+DPHI,X6,Y6,Z6)
          DXI = (X5-X6)/ (M-1)
          DYI = (Y5-Y6)/ (M-1)
          DZI = (Z5-Z6)/ (M-1)
          DXJ = (X6-X4)/ (M-1)
          DYJ = (Y6-Y4)/ (M-1)
          DZJ = (Z6-Z4)/ (M-1)
          DO J = 1,M
              XS = X4 + (J-1)*DXJ
              YS = Y4 + (J-1)*DYJ
              ZS = Z4 + (J-1)*DZJ
              DO I = 1,J
                  X(J+M-1,I,K) = XS + (I-1)*DXI
                  Y(J+M-1,I,K) = YS + (I-1)*DYI
                  Z(J+M-1,I,K) = ZS + (I-1)*DZI
              END DO
          END DO
      END DO
      DO K = 1,5
          DO J = 1,M + M - 1
              DO I = 1,M
                  CALL DCTOS(X(J,I,K),Y(J,I,K),Z(J,I,K),RAD,THETA,PHI)
                  CALL DSTOC(1.D0,THETA,PHI,X(J,I,K),Y(J,I,K),Z(J,I,K))
              END DO
          END DO
      END DO
      RETURN
      END
      SUBROUTINE DCTOS(X,Y,Z,R,THETA,PHI)
      DOUBLE PRECISION X
      DOUBLE PRECISION Y
      DOUBLE PRECISION Z
      DOUBLE PRECISION R
      DOUBLE PRECISION THETA
      DOUBLE PRECISION PHI
      DOUBLE PRECISION R1

      R1 = X*X + Y*Y
      IF (R1.NE.0.D0) GO TO 10
      PHI = 0.D0
      THETA = 0.D0
      IF (Z.LT.0.D0) THETA = 4.D0*ATAN(1.D0)
      RETURN
   10 R = SQRT(R1+Z*Z)
      R1 = SQRT(R1)
      PHI = ATAN2(Y,X)
      THETA = ATAN2(R1,Z)
      RETURN
      END
      SUBROUTINE DSTOC(R,THETA,PHI,X,Y,Z)
      DOUBLE PRECISION R
      DOUBLE PRECISION THETA
      DOUBLE PRECISION PHI
      DOUBLE PRECISION X
      DOUBLE PRECISION Y
      DOUBLE PRECISION Z
      DOUBLE PRECISION ST

      ST = SIN(THETA)
      X = R*ST*COS(PHI)
      Y = R*ST*SIN(PHI)
      Z = R*COS(THETA)
      RETURN
      END

      SUBROUTINE DSPEVD( JOBZ, UPLO, N, AP, W, Z, LDZ, WORK, LWORK,
     $                   IWORK, LIWORK, INFO )
*
*  -- LAPACK driver routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          JOBZ, UPLO
      INTEGER            INFO, LDZ, LIWORK, LWORK, N
*     ..
*     .. Array Arguments ..
      INTEGER            IWORK( * )
      DOUBLE PRECISION   AP( * ), W( * ), WORK( * ), Z( LDZ, * )
*     ..
*
*  Purpose
*  =======
*
*  DSPEVD computes all the eigenvalues and, optionally, eigenvectors
*  of a real symmetric matrix A in packed storage. If eigenvectors are
*  desired, it uses a divide and conquer algorithm.
*
*  The divide and conquer algorithm makes very mild assumptions about
*  floating point arithmetic. It will work on machines with a guard
*  digit in add/subtract, or on those binary machines without guard
*  digits which subtract like the Cray X-MP, Cray Y-MP, Cray C-90, or
*  Cray-2. It could conceivably fail on hexadecimal or decimal machines
*  without guard digits, but we know of none.
*
*  Arguments
*  =========
*
*  JOBZ    (input) CHARACTER*1
*          = 'N':  Compute eigenvalues only;
*          = 'V':  Compute eigenvalues and eigenvectors.
*
*  UPLO    (input) CHARACTER*1
*          = 'U':  Upper triangle of A is stored;
*          = 'L':  Lower triangle of A is stored.
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  AP      (input/output) DOUBLE PRECISION array, dimension (N*(N+1)/2)
*          On entry, the upper or lower triangle of the symmetric matrix
*          A, packed columnwise in a linear array.  The j-th column of A
*          is stored in the array AP as follows:
*          if UPLO = 'U', AP(i + (j-1)*j/2) = A(i,j) for 1<=i<=j;
*          if UPLO = 'L', AP(i + (j-1)*(2*n-j)/2) = A(i,j) for j<=i<=n.
*
*          On exit, AP is overwritten by values generated during the
*          reduction to tridiagonal form.  If UPLO = 'U', the diagonal
*          and first superdiagonal of the tridiagonal matrix T overwrite
*          the corresponding elements of A, and if UPLO = 'L', the
*          diagonal and first subdiagonal of T overwrite the
*          corresponding elements of A.
*
*  W       (output) DOUBLE PRECISION array, dimension (N)
*          If INFO = 0, the eigenvalues in ascending order.
*
*  Z       (output) DOUBLE PRECISION array, dimension (LDZ, N)
*          If JOBZ = 'V', then if INFO = 0, Z contains the orthonormal
*          eigenvectors of the matrix A, with the i-th column of Z
*          holding the eigenvector associated with W(i).
*          If JOBZ = 'N', then Z is not referenced.
*
*  LDZ     (input) INTEGER
*          The leading dimension of the array Z.  LDZ >= 1, and if
*          JOBZ = 'V', LDZ >= max(1,N).
*
*  WORK    (workspace/output) DOUBLE PRECISION array,
*                                         dimension (LWORK)
*          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*
*  LWORK   (input) INTEGER
*          The dimension of the array WORK.
*          If N <= 1,               LWORK must be at least 1.
*          If JOBZ = 'N' and N > 1, LWORK must be at least 2*N.
*          If JOBZ = 'V' and N > 1, LWORK must be at least
*                                                 1 + 6*N + N**2.
*
*          If LWORK = -1, then a workspace query is assumed; the routine
*          only calculates the optimal size of the WORK array, returns
*          this value as the first entry of the WORK array, and no error
*          message related to LWORK is issued by XERBLA.
*
*  IWORK   (workspace/output) INTEGER array, dimension (LIWORK)
*          On exit, if INFO = 0, IWORK(1) returns the optimal LIWORK.
*
*  LIWORK  (input) INTEGER
*          The dimension of the array IWORK.
*          If JOBZ  = 'N' or N <= 1, LIWORK must be at least 1.
*          If JOBZ  = 'V' and N > 1, LIWORK must be at least 3 + 5*N.
*
*          If LIWORK = -1, then a workspace query is assumed; the
*          routine only calculates the optimal size of the IWORK array,
*          returns this value as the first entry of the IWORK array, and
*          no error message related to LIWORK is issued by XERBLA.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value.
*          > 0:  if INFO = i, the algorithm failed to converge; i
*                off-diagonal elements of an intermediate tridiagonal
*                form did not converge to zero.
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO, ONE
      PARAMETER          ( ZERO = 0.0D+0, ONE = 1.0D+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            LQUERY, WANTZ
      INTEGER            IINFO, INDE, INDTAU, INDWRK, ISCALE, LIWMIN,
     $                   LLWORK, LWMIN
      DOUBLE PRECISION   ANRM, BIGNUM, EPS, RMAX, RMIN, SAFMIN, SIGMA,
     $                   SMLNUM
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      DOUBLE PRECISION   DLAMCH, DLANSP
      EXTERNAL           LSAME, DLAMCH, DLANSP
*     ..
*     .. External Subroutines ..
      EXTERNAL           DOPMTR, DSCAL, DSPTRD, DSTEDC, DSTERF, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          SQRT
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      WANTZ = LSAME( JOBZ, 'V' )
      LQUERY = ( LWORK.EQ.-1 .OR. LIWORK.EQ.-1 )
*
      INFO = 0
      IF( N.LE.1 ) THEN
         LIWMIN = 1
         LWMIN = 1
      ELSE
         IF( WANTZ ) THEN
            LIWMIN = 3 + 5*N
            LWMIN = 1 + 6*N + N**2
         ELSE
            LIWMIN = 1
            LWMIN = 2*N
         END IF
      END IF
      IF( .NOT.( WANTZ .OR. LSAME( JOBZ, 'N' ) ) ) THEN
         INFO = -1
      ELSE IF( .NOT.( LSAME( UPLO, 'U' ) .OR. LSAME( UPLO, 'L' ) ) )
     $          THEN
         INFO = -2
      ELSE IF( N.LT.0 ) THEN
         INFO = -3
      ELSE IF( LDZ.LT.1 .OR. ( WANTZ .AND. LDZ.LT.N ) ) THEN
         INFO = -7
      ELSE IF( LWORK.LT.LWMIN .AND. .NOT.LQUERY ) THEN
         INFO = -9
      ELSE IF( LIWORK.LT.LIWMIN .AND. .NOT.LQUERY ) THEN
         INFO = -11
      END IF
*
      IF( INFO.EQ.0 ) THEN
         WORK( 1 ) = LWMIN
         IWORK( 1 ) = LIWMIN
      END IF
*
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DSPEVD', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
*
      IF( N.EQ.1 ) THEN
         W( 1 ) = AP( 1 )
         IF( WANTZ )
     $      Z( 1, 1 ) = ONE
         RETURN
      END IF
*
*     Get machine constants.
*
      SAFMIN = DLAMCH( 'Safe minimum' )
      EPS = DLAMCH( 'Precision' )
      SMLNUM = SAFMIN / EPS
      BIGNUM = ONE / SMLNUM
      RMIN = SQRT( SMLNUM )
      RMAX = SQRT( BIGNUM )
*
*     Scale matrix to allowable range, if necessary.
*
      ANRM = DLANSP( 'M', UPLO, N, AP, WORK )
      ISCALE = 0
      IF( ANRM.GT.ZERO .AND. ANRM.LT.RMIN ) THEN
         ISCALE = 1
         SIGMA = RMIN / ANRM
      ELSE IF( ANRM.GT.RMAX ) THEN
         ISCALE = 1
         SIGMA = RMAX / ANRM
      END IF
      IF( ISCALE.EQ.1 ) THEN
         CALL DSCAL( ( N*( N+1 ) ) / 2, SIGMA, AP, 1 )
      END IF
*
*     Call DSPTRD to reduce symmetric packed matrix to tridiagonal form.
*
      INDE = 1
      INDTAU = INDE + N
      CALL DSPTRD( UPLO, N, AP, W, WORK( INDE ), WORK( INDTAU ), IINFO )
*
*     For eigenvalues only, call DSTERF.  For eigenvectors, first call
*     DSTEDC to generate the eigenvector matrix, WORK(INDWRK), of the
*     tridiagonal matrix, then call DOPMTR to multiply it by the
*     Householder transformations represented in AP.
*
      IF( .NOT.WANTZ ) THEN
         CALL DSTERF( N, W, WORK( INDE ), INFO )
      ELSE
         INDWRK = INDTAU + N
         LLWORK = LWORK - INDWRK + 1
         CALL DSTEDC( 'I', N, W, WORK( INDE ), Z, LDZ, WORK( INDWRK ),
     $                LLWORK, IWORK, LIWORK, INFO )
         CALL DOPMTR( 'L', UPLO, 'N', N, N, AP, WORK( INDTAU ), Z, LDZ,
     $                WORK( INDWRK ), IINFO )
      END IF
*
*     If matrix was scaled, then rescale eigenvalues appropriately.
*
      IF( ISCALE.EQ.1 )
     $   CALL DSCAL( N, ONE / SIGMA, W, 1 )
*
      WORK( 1 ) = LWMIN
      IWORK( 1 ) = LIWMIN
      RETURN
*
*     End of DSPEVD
*
      END

C
C	$Id: dashbd1024.f,v 1.6 2008-07-27 00:23:03 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE DASHBD
C
C Calling this do-nothing subroutine forces "ld" to load the following
C block data routine (but only if they are in the same ".f" file).
C
        RETURN
C
      END
CNOSPLIT
      BLOCKDATA DASHBDX
C
C DASHBDX IS USED TO INITIALIZE VARIABLES IN NAMED COMMON.
C
      COMMON /DASHD1/  ISL,  L,  ISIZE,  IP(100),  NWDSM1,  IPFLAG(100)
     1                 ,MNCSTR, IGP
C
      COMMON /FDFLAG/ IFLAG
C
      COMMON /DFFLAG/ IFSTF2
C
      COMMON /DDFLAG/ IFCFLG
C
      COMMON /DCFLAG/ IFSTFL
C
      COMMON /CFFLAG/ IVCTFG
C
      COMMON /DSAVE3/ IXSTOR,IYSTOR
C
      COMMON /DSAVE4/ IX1,IY1,IX2,IY2
C
      COMMON /DSAVE5/ XSAVE(70), YSAVE(70), XSVN, YSVN, XSV1, YSV1,
     1                SLP1, SLPN, SSLP1, SSLPN, N, NSEG
C
      COMMON /SMFLAG/ IOFFS
C
      COMMON /DSUP1/ ISKIP
C
C
      COMMON/INTPR/IPAU,FPART,TENSN,NP,SMALL,L1,ADDLR,ADDTB,MLLINE,
     1    ICLOSE
C
      COMMON /BLGASO/ IBLK,IGAP,ISOL
      CHARACTER*1     IBLK,IGAP,ISOL
C
      SAVE
C **********************************************************************
C
C CONSTANT DEPENDING ON THE IMPLEMENTATION OF THE MODEL PICTURE
C
C     LET NXSIZE BE DEFINED JUST AS IN SUBROUTINE REMOVE, NAMELY
C     SUCH THAT  2**NXSIZE = NUMBER OF MODEL PICTURE POINTS IN X- AND
C     Y- DIRECTION. (NXSIZE IS THE RESOLUTION OF THE MODEL PICTURE. THE
C     MODEL PICTURE IS ASSUMED TO BE QUADRATIC.)
C     THEN ISKIP IS DEFINED AS
C         ISKIP = 2**(15-NXSIZE)
C
C     ISKIP IS USED TO SPEED UP THE MARKING OF POINTS IN THE MODEL
C     PICTURE. THE FACT IS USED THAT 1 POINT IN THE MODEL PICTURE
C     REPRESENTS ISKIP*ISKIP METACODE ADDRESS UNITS.
C
C     DATA ISKIP /0/
C     E.G. FOR A 1024 BY 1024 MODEL PICTURE
      DATA ISKIP /32/
C
C **********************************************************************
C
C
C
C
C IFSTFL CONTROLS THAT FRSTD IS CALLED BEFORE VECTD IS CALLED (IN CFVLD)
C WHENEVER DASHDB OR DASHDC HAS BEEN CALLED.
C
      DATA IFSTFL /1/
C
C IVCTFG INDICATES IF VECTD IS BEING CALLED OR LASTD (IN CFVLD)
C
      DATA IVCTFG /1/
C
C IX1,IY1,IX2 AND IY2 ARE USED TO STORE THE NEXT LINE SEGMENT TO BE
C MARKED.
C
      DATA IX1,IY1,IX2,IY2 /0,0,0,0/
C
C ISL IS A FLAG FOR AN ALL SOLID PATTERN (+1) OR AN ALL GAP PATTERN (-1)
C
      DATA ISL /1/
C
C IGP IS AN INTERNAL PARAMETER. IT IS DESCRIBED IN THE DOCUMENTATION
C TO THE DASHED LINE PACKAGE.
C
      DATA IGP /9/
C
C MNCSTR IS THE MAXIMUM NUMBER OF CHARACTERS ALLOWED IN A HOLLERITH
C STRING PASSED TO DASHDB OR DASHDC.
C
      DATA MNCSTR /15/
C
C IOFFS IS AN INTERNAL PARAMETER.
C IOFFS IS USED IN FDVDLD AND DRAWPV.
C
      DATA IOFFS /0/
C
C
C  INTERNAL PARAMETERS
C
      DATA IPAU/3/
      DATA FPART/1./
      DATA TENSN/2.5/
      DATA NP/150/
      DATA SMALL/128./
      DATA L1/70/
      DATA ADDLR/2./
      DATA ADDTB/2./
      DATA MLLINE/384/
      DATA ICLOSE/6/
C
C IFSTF2 IS A FLAG TO CONTROL THAT FRSTD IS CALLED BEFORE VECTD IS
C CALLED (IN SUBROUTINE FDVDLD), WHENEVER DASHDB OR DASHDC
C HAS BEEN CALLED.
C
      DATA IFSTF2 /1/
C
C IFLAG CONTROLS IF LASTD CAN BE CALLED DIRECTLY OR IF IT WAS JUST
C CALLED FROM BY VECTD SO THAT THIS CALL CAN BE IGNORED.
C
      DATA IFLAG /1/
C
C IFCFLG IS THE FIRST CALL FLAG FOR SUBROUTINE DASHDB AND DASHDC.
C  1 = FIRST CALL TO DASHDB OR DASHDC.
C  2 = DASHDB OR DASHDC HAS BEEN CALLED BEFORE.
C
      DATA IFCFLG /1/
C
C IXSTOR AND IYSTOR CONTAIN THE CURRENT PEN POSITION. THEY ARE
C INITIALIZED TO AN IMPOSSIBLE VALUE.
C
      DATA IXSTOR,IYSTOR /-9999,-9999/
C
C SLP1 AND SLPN ARE INITIALIZED TO AVOID THAT THEY ARE PASSED AS ACTUAL
C PARAMETERS FROM FDVDLD TO MSKRV1 WITHOUT BEING DEFINED.
C
      DATA SLP1,SLPN /-9999.,-9999./
C
C Define characters representing a blank, a gap, and a solid.
C
      DATA IBLK,IGAP,ISOL / ' ' , '''' , '$' /
C
      END

C
C $Id: maqini.f,v 1.6 2008-09-18 00:42:16 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MAQINI
        IF (ICFELL('MAQINI - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
        CALL MDQINI
        RETURN
      END

C NCLFORTSTART
      subroutine wgt_area_smooth (field,area,field_ret,
     &                              nx,ny,no,fill_value,icyclic)
      double precision field(nx,ny,no), area(nx,ny)
      double precision field_ret(nx,ny,no), fill_value
      integer icyclic
C NCLEND
C
C      write(*,*) nx,ny,no,fill_value
C     
      do i = 1,nx
         do n = 1, no
            field_ret(i,1,n) = fill_value
            field_ret(i,ny,n) = fill_value
         end do
      end do   
C
      if (icyclic .eq. 1) then
         ibeg = 1
         iend = nx
      else
         ibeg = 2
         iend = nx - 1
         do j = 2, ny - 1
            do n = 1, no
               field_ret(1,j,n) = fill_value
               field_ret(nx,j,n) = fill_value
            end do
         end do
      end if
C
      do j = 2, ny-1
          do i = ibeg, iend
              im1 = i-1
              ip1 = i+1
              if ( i .eq. 1    ) then  
                  im1 = nx
              end if
              if ( i .eq. nx ) then
                  ip1 = 1
              end if
C
              cc = area(i  ,j  )
              ce = area(ip1,j  )
              cw = area(im1,j  )
              cn = area(i  ,j+1)
              cs = area(i  ,j-1)
              sum = cc + ce + cw + cn + cs
C
              cc = cc / sum
              ce = ce / sum
              cw = cw / sum
              cn = cn / sum
              cs = cs / sum
              do n = 1, no
                 field_ret(i,j,n) = fill_value
              end do
              if ( field(i,j,1) .ne. fill_value ) then
                 if ( field(ip1,j,1) .eq. fill_value ) then
                     cc = cc + ce
                     ce = 0.
                 end if
                 if ( field(im1,j,1) .eq. fill_value ) then
                    cc = cc + cw
                    cw = 0.
                 end if
                 if ( field(i ,j+1,1) .eq. fill_value ) then
                    cc = cc + cn
                    cn = 0.
                 end if
                 if ( field(i  ,j-1,1) .eq. fill_value ) then
                    cc = cc + cs
                    cs = 0.
                 end if
C              
                 do n = 1, no
                    field_ret(i,j,n) =  cc * field(i ,j,n) 
     &                   + ce * field(ip1,j,  n) 
     &                   + cw * field(im1,j,  n) 
     &                   + cn * field(i,  j+1,n) 
     &                   + cs * field(i,  j-1,n)
                 end do
              end if
           end do
        end do          
C
      return 
      end
C
C NCLFORTSTART
      subroutine mixed_layer_depth(field,kmt,ht,depth,field_ret,
     &               nx,ny,nz,offset,fill_value)
      integer kmt(nx,ny)
      double precision field(nx,ny,nz)
      double precision field_ret(nx,ny), fill_value
      double precision offset
      double precision depth(nz)
      double precision  ht(nx,ny)
C NCLEND
C
      do j=1,ny
         do i=1,nx

            k_max = kmt(i,j)

            if ( k_max .eq. 0 ) then

               field_ret(i,j) = fill_value

            else

               field_ret(i,j) = ht(i,j) 

               target_density = field(i,j,1) + offset
               do  k=1, k_max-1

                  if ((target_density .gt. field(i,j,k)) 
     &                 .and.
     &                 (target_density .le. field(i,j,k+1))) then
C     
                     field_ret(i,j) = depth(k) 
     &                    + (target_density - field(i,j,k)) 
     &                    * ((depth(k+1) - depth(k))
     &                    / (field(i,j,k+1) - field(i,j,k)))

                     go to 100
                  end if

               end do

 100           continue

            end if
         end do
      end do

      return
      end

C
C $Id: mplnri.f,v 1.9 2008-07-27 00:17:08 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MPLNRI (FLNM)
        CHARACTER*(*) FLNM
        IF (ICFELL('MPLNRI - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
        CALL MDLNRI (FLNM)
        IF (ICFELL('MPLNRI',2).NE.0) RETURN
        RETURN
      END

      SUBROUTINE SLARRB( N, D, L, LD, LLD, IFIRST, ILAST, SIGMA, RELTOL,
     $                   W, WGAP, WERR, WORK, IWORK, INFO )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      INTEGER            IFIRST, ILAST, INFO, N
      REAL               RELTOL, SIGMA
*     ..
*     .. Array Arguments ..
      INTEGER            IWORK( * )
      REAL               D( * ), L( * ), LD( * ), LLD( * ), W( * ),
     $                   WERR( * ), WGAP( * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  Given the relatively robust representation(RRR) L D L^T, SLARRB
*  does ``limited'' bisection to locate the eigenvalues of L D L^T,
*  W( IFIRST ) thru' W( ILAST ), to more accuracy. Intervals
*  [left, right] are maintained by storing their mid-points and
*  semi-widths in the arrays W and WERR respectively.
*
*  Arguments
*  =========
*
*  N       (input) INTEGER
*          The order of the matrix.
*
*  D       (input) REAL array, dimension (N)
*          The n diagonal elements of the diagonal matrix D.
*
*  L       (input) REAL array, dimension (N-1)
*          The n-1 subdiagonal elements of the unit bidiagonal matrix L.
*
*  LD      (input) REAL array, dimension (N-1)
*          The n-1 elements L(i)*D(i).
*
*  LLD     (input) REAL array, dimension (N-1)
*          The n-1 elements L(i)*L(i)*D(i).
*
*  IFIRST  (input) INTEGER
*          The index of the first eigenvalue in the cluster.
*
*  ILAST   (input) INTEGER
*          The index of the last eigenvalue in the cluster.
*
*  SIGMA   (input) REAL
*          The shift used to form L D L^T (see SLARRF).
*
*  RELTOL  (input) REAL
*          The relative tolerance.
*
*  W       (input/output) REAL array, dimension (N)
*          On input, W( IFIRST ) thru' W( ILAST ) are estimates of the
*          corresponding eigenvalues of L D L^T.
*          On output, these estimates are ``refined''.
*
*  WGAP    (input/output) REAL array, dimension (N)
*          The gaps between the eigenvalues of L D L^T. Very small
*          gaps are changed on output.
*
*  WERR    (input/output) REAL array, dimension (N)
*          On input, WERR( IFIRST ) thru' WERR( ILAST ) are the errors
*          in the estimates W( IFIRST ) thru' W( ILAST ).
*          On output, these are the ``refined'' errors.
*
*****Reminder to Inder --- WORK is never used in this subroutine *****
*  WORK    (input) REAL array, dimension (???)
*          Workspace.
*
*  IWORK   (input) INTEGER array, dimension (2*N)
*          Workspace.
*
*****Reminder to Inder --- INFO is never set in this subroutine ******
*  INFO    (output) INTEGER
*          Error flag.
*
*  Further Details
*  ===============
*
*  Based on contributions by
*     Inderjit Dhillon, IBM Almaden, USA
*     Osni Marques, LBNL/NERSC, USA
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ZERO, TWO, HALF
      PARAMETER          ( ZERO = 0.0E0, TWO = 2.0E0, HALF = 0.5E0 )
*     ..
*     .. Local Scalars ..
      INTEGER            CNT, I, I1, I2, INITI1, INITI2, J, K, NCNVRG,
     $                   NEIG, NINT, NRIGHT, OLNINT
      REAL               DELTA, EPS, GAP, LEFT, MID, PERT, RIGHT, S,
     $                   THRESH, TMP, WIDTH
*     ..
*     .. External Functions ..
      REAL               SLAMCH
      EXTERNAL           SLAMCH
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, MAX, MIN
*     ..
*     .. Executable Statements ..
*
      EPS = SLAMCH( 'Precision' )
      I1 = IFIRST
      I2 = IFIRST
      NEIG = ILAST - IFIRST + 1
      NCNVRG = 0
      THRESH = RELTOL
      DO 10 I = IFIRST, ILAST
         IWORK( I ) = 0
         PERT = EPS*( ABS( SIGMA )+ABS( W( I ) ) )
         WERR( I ) = WERR( I ) + PERT
         IF( WGAP( I ).LT.PERT )
     $      WGAP( I ) = PERT
   10 CONTINUE
      DO 20 I = I1, ILAST
         IF( I.EQ.1 ) THEN
            GAP = WGAP( I )
         ELSE IF( I.EQ.N ) THEN
            GAP = WGAP( I-1 )
         ELSE
            GAP = MIN( WGAP( I-1 ), WGAP( I ) )
         END IF
         IF( WERR( I ).LT.THRESH*GAP ) THEN
            NCNVRG = NCNVRG + 1
            IWORK( I ) = 1
            IF( I1.EQ.I )
     $         I1 = I1 + 1
         ELSE
            I2 = I
         END IF
   20 CONTINUE
*
*     Initialize the unconverged intervals.
*
      I = I1
      NINT = 0
      RIGHT = ZERO
   30 CONTINUE
      IF( I.LE.I2 ) THEN
         IF( IWORK( I ).EQ.0 ) THEN
            DELTA = EPS
            LEFT = W( I ) - WERR( I )
*
*           Do while( CNT(LEFT).GT.I-1 )
*
   40       CONTINUE
            IF( I.GT.I1 .AND. LEFT.LE.RIGHT ) THEN
               LEFT = RIGHT
               CNT = I - 1
            ELSE
               S = -LEFT
               CNT = 0
               DO 50 J = 1, N - 1
                  TMP = D( J ) + S
                  S = S*( LD( J ) / TMP )*L( J ) - LEFT
                  IF( TMP.LT.ZERO )
     $               CNT = CNT + 1
   50          CONTINUE
               TMP = D( N ) + S
               IF( TMP.LT.ZERO )
     $            CNT = CNT + 1
               IF( CNT.GT.I-1 ) THEN
                  DELTA = TWO*DELTA
                  LEFT = LEFT - ( ABS( SIGMA )+ABS( LEFT ) )*DELTA
                  GO TO 40
               END IF
            END IF
            DELTA = EPS
            RIGHT = W( I ) + WERR( I )
*
*           Do while( CNT(RIGHT).LT.I )
*
   60       CONTINUE
            S = -RIGHT
            CNT = 0
            DO 70 J = 1, N - 1
               TMP = D( J ) + S
               S = S*( LD( J ) / TMP )*L( J ) - RIGHT
               IF( TMP.LT.ZERO )
     $            CNT = CNT + 1
   70       CONTINUE
            TMP = D( N ) + S
            IF( TMP.LT.ZERO )
     $         CNT = CNT + 1
            IF( CNT.LT.I ) THEN
               DELTA = TWO*DELTA
               RIGHT = RIGHT + ( ABS( SIGMA )+ABS( RIGHT ) )*DELTA
               GO TO 60
            END IF
            WERR( I ) = LEFT
            W( I ) = RIGHT
            IWORK( N+I ) = CNT
            NINT = NINT + 1
            I = CNT + 1
         ELSE
            I = I + 1
         END IF
         GO TO 30
      END IF
*
*     While( NCNVRG.LT.NEIG )
*
      INITI1 = I1
      INITI2 = I2
   80 CONTINUE
      IF( NCNVRG.LT.NEIG ) THEN
         OLNINT = NINT
         I = I1
         DO 100 K = 1, OLNINT
            NRIGHT = IWORK( N+I )
            IF( IWORK( I ).EQ.0 ) THEN
               MID = HALF*( WERR( I )+W( I ) )
               S = -MID
               CNT = 0
               DO 90 J = 1, N - 1
                  TMP = D( J ) + S
                  S = S*( LD( J ) / TMP )*L( J ) - MID
                  IF( TMP.LT.ZERO )
     $               CNT = CNT + 1
   90          CONTINUE
               TMP = D( N ) + S
               IF( TMP.LT.ZERO )
     $            CNT = CNT + 1
               CNT = MAX( I-1, MIN( NRIGHT, CNT ) )
               IF( I.EQ.NRIGHT ) THEN
                  IF( I.EQ.IFIRST ) THEN
                     GAP = WERR( I+1 ) - W( I )
                  ELSE IF( I.EQ.ILAST ) THEN
                     GAP = WERR( I ) - W( I-1 )
                  ELSE
                     GAP = MIN( WERR( I+1 )-W( I ), WERR( I )-W( I-1 ) )
                  END IF
                  WIDTH = W( I ) - MID
                  IF( WIDTH.LT.THRESH*GAP ) THEN
                     NCNVRG = NCNVRG + 1
                     IWORK( I ) = 1
                     IF( I1.EQ.I ) THEN
                        I1 = I1 + 1
                        NINT = NINT - 1
                     END IF
                  END IF
               END IF
               IF( IWORK( I ).EQ.0 )
     $            I2 = K
               IF( CNT.EQ.I-1 ) THEN
                  WERR( I ) = MID
               ELSE IF( CNT.EQ.NRIGHT ) THEN
                  W( I ) = MID
               ELSE
                  IWORK( N+I ) = CNT
                  NINT = NINT + 1
                  WERR( CNT+1 ) = MID
                  W( CNT+1 ) = W( I )
                  W( I ) = MID
                  I = CNT + 1
                  IWORK( N+I ) = NRIGHT
               END IF
            END IF
            I = NRIGHT + 1
  100    CONTINUE
         NINT = NINT - OLNINT + I2
         GO TO 80
      END IF
      DO 110 I = INITI1, INITI2
         W( I ) = HALF*( WERR( I )+W( I ) )
         WERR( I ) = W( I ) - WERR( I )
  110 CONTINUE
*
      RETURN
*
*     End of SLARRB
*
      END

C
C $Id: mdpiq.f,v 1.9 2008-09-18 00:42:17 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MDPIQ
C
C Declare required common blocks.  See MAPBDX for descriptions of these
C common blocks and the variables in them.
C
        COMMON /MAPCMP/  NPTB,XPTB(50),YPTB(50)
        INTEGER          NPTB
        REAL             XPTB,YPTB
        SAVE   /MAPCMP/
C
C Check for an uncleared prior error.
C
        IF (ICFELL('MDPIQ - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C Flush the points buffer.
C
        IF (NPTB.GT.0) THEN
          CALL POINTS (XPTB,YPTB,NPTB,0,0)
          IF (ICFELL('MDPIQ',2).NE.0) RETURN
          NPTB=0
        END IF
C
C Flush PLOTIT's buffer, too.
C
        CALL PLOTIF (0.,0.,2)
        IF (ICFELL('MDPIQ',3).NE.0) RETURN
C
C Done.
C
        RETURN
C
      END

      SUBROUTINE PASSB4(IDO,L1,CC,CH,WA1,WA2,WA3)
      DOUBLE PRECISION CC
      DOUBLE PRECISION CH
      DOUBLE PRECISION WA1
      DOUBLE PRECISION WA2
      DOUBLE PRECISION WA3
      DOUBLE PRECISION TI1
      DOUBLE PRECISION TI2
      DOUBLE PRECISION TR4
      DOUBLE PRECISION TI3
      DOUBLE PRECISION TR1
      DOUBLE PRECISION TR2
      DOUBLE PRECISION TI4
      DOUBLE PRECISION TR3
      DOUBLE PRECISION CR3
      DOUBLE PRECISION CI3
      DOUBLE PRECISION CR2
      DOUBLE PRECISION CR4
      DOUBLE PRECISION CI2
      DOUBLE PRECISION CI4
      DIMENSION CC(IDO,4,L1),CH(IDO,L1,4),WA1(*),WA2(*),WA3(*)

      IF (IDO.NE.2) GO TO 102
      DO 101 K = 1,L1
          TI1 = CC(2,1,K) - CC(2,3,K)
          TI2 = CC(2,1,K) + CC(2,3,K)
          TR4 = CC(2,4,K) - CC(2,2,K)
          TI3 = CC(2,2,K) + CC(2,4,K)
          TR1 = CC(1,1,K) - CC(1,3,K)
          TR2 = CC(1,1,K) + CC(1,3,K)
          TI4 = CC(1,2,K) - CC(1,4,K)
          TR3 = CC(1,2,K) + CC(1,4,K)
          CH(1,K,1) = TR2 + TR3
          CH(1,K,3) = TR2 - TR3
          CH(2,K,1) = TI2 + TI3
          CH(2,K,3) = TI2 - TI3
          CH(1,K,2) = TR1 + TR4
          CH(1,K,4) = TR1 - TR4
          CH(2,K,2) = TI1 + TI4
          CH(2,K,4) = TI1 - TI4
  101 CONTINUE
      RETURN
  102 DO 104 K = 1,L1
          DO 103 I = 2,IDO,2
              TI1 = CC(I,1,K) - CC(I,3,K)
              TI2 = CC(I,1,K) + CC(I,3,K)
              TI3 = CC(I,2,K) + CC(I,4,K)
              TR4 = CC(I,4,K) - CC(I,2,K)
              TR1 = CC(I-1,1,K) - CC(I-1,3,K)
              TR2 = CC(I-1,1,K) + CC(I-1,3,K)
              TI4 = CC(I-1,2,K) - CC(I-1,4,K)
              TR3 = CC(I-1,2,K) + CC(I-1,4,K)
              CH(I-1,K,1) = TR2 + TR3
              CR3 = TR2 - TR3
              CH(I,K,1) = TI2 + TI3
              CI3 = TI2 - TI3
              CR2 = TR1 + TR4
              CR4 = TR1 - TR4
              CI2 = TI1 + TI4
              CI4 = TI1 - TI4
              CH(I-1,K,2) = WA1(I-1)*CR2 - WA1(I)*CI2
              CH(I,K,2) = WA1(I-1)*CI2 + WA1(I)*CR2
              CH(I-1,K,3) = WA2(I-1)*CR3 - WA2(I)*CI3
              CH(I,K,3) = WA2(I-1)*CI3 + WA2(I)*CR3
              CH(I-1,K,4) = WA3(I-1)*CR4 - WA3(I)*CI4
              CH(I,K,4) = WA3(I-1)*CI4 + WA3(I)*CR4
  103     CONTINUE
  104 CONTINUE
      RETURN
      END

C
C	$Id: wmrgwt.f,v 1.9 2008-07-27 00:17:37 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE WMRGWT(N,X,Y,IFNT,NASC)
C
C  Fill the region given by coordinates (X(I),Y(I),I=1,N) with
C  character ICHR (an ASCII decimal equivalent) from font IFNT.
C
      include 'wmcomn.h'
C
C  The value of IDRFLG control how the clipped symbols are drawn.
C  The area is filled and then a representative line is drawn so
C  that the symbols do not disappear on low-resolution devices.
C
      COMMON /WMLGCM/IDRFLG
C
C  Parameters for apportioning work space.
C
      PARAMETER (MDGU=7000,MDGUH=MDGU/2,MDGUP1=MDGU+1,
     +           MDGUP=MDGU+MDGUH+1,MDGU2=2*MDGU,MDGU2P=MDGU2+1)
      DIMENSION X(N),Y(N)
      EXTERNAL WMLGFA
C
C  Check error status.
C
      IF (ICFELL('WMRGWT - Uncleared prior error',1) .NE. 0) RETURN
C
C  Find the extent of the specified region.
C
      XRL = X(1)
      XRR = X(1)
      YRB = Y(1)
      YRT = Y(1)
      DO 10 I=2,N
        XRL = MIN(XRL,X(I))
        YRB = MIN(YRB,Y(I))
        XRR = MAX(XRR,X(I))
        YRT = MAX(YRT,Y(I))
   10 CONTINUE
C
C  Get the digitization of the character.
C
      IPSS = 2
      IBNU = 3
      CALL PCCFFF (IPSS,IBNU,IFNT,NASC,WSIZER,WSIZER,RWORK,MDGU,NDGU)
C
C  Set up character width and height, depending on the character
C  being drawn.  IOFFLG flags whether the characters should be
C  offset from row-to-row, and ROFFLG specifies how much to offset.
C
      IF (IFNT.EQ.37 .AND. NASC.EQ.101) THEN
C
C    Showers.
        WIDSCL = 1.20
        CHRWID = WIDSCL*(RWORK(2)-RWORK(1))
        CHRHIT = 1.60*WSIZER
        IDRFLG = 1
        IOFFLG = 0
        ROFFLG = 0.
        SSCALE = 1.
      ELSE IF (IFNT.EQ.37 .AND. NASC.EQ.102) THEN
C
C    T-storms.
        WIDSCL = 1.90
        CHRWID = WIDSCL*(RWORK(2)-RWORK(1))
        CHRHIT = 1.60*WSIZER
        IDRFLG = 2
        IOFFLG = 0
        ROFFLG = 0.
        SSCALE = 1.
      ELSE IF (IFNT.EQ.37 .AND. NASC.EQ.103) THEN
C
C    Rain
        WIDSCL = 2.25
        CHRWID = WIDSCL*(RWORK(2)-RWORK(1))
        CHRHIT = 1.00*WSIZER
        IDRFLG = 3
        IOFFLG = 1
        ROFFLG = 0.5
        SSCALE = 1.
      ELSE IF (IFNT.EQ.37 .AND. NASC.EQ.106) THEN
C
C    Flurries.
        WIDSCL = 2.00
        CHRWID = WIDSCL*(RWORK(2)-RWORK(1))
        CHRHIT = 1.10*WSIZER
        IDRFLG = 3
        IOFFLG = 1
        ROFFLG = 0.4
        SSCALE = 1.
      ELSE IF (IFNT.EQ.37 .AND. NASC.EQ.104) THEN
C
C    Snow.
        WIDSCL = 2.20
        CHRWID = WIDSCL*(RWORK(2)-RWORK(1))
        CHRHIT = 1.37*WSIZER
        IDRFLG = 3
        IOFFLG = 1
        ROFFLG = 0.5
        SSCALE = 1.33
      ELSE IF (IFNT.EQ.37 .AND. NASC.EQ.105) THEN
C
C    Ice.
        WIDSCL = 1.40
        CHRWID = WIDSCL*(RWORK(2)-RWORK(1))
        CHRHIT = 0.7*WSIZER
        IDRFLG = 4
        IOFFLG = 1
        ROFFLG = 0.35
        SSCALE = 1.33
C
      ELSE
        WIDSCL = 1.00
        CHRWID = RWORK(2)-RWORK(1)
        CHRHIT = WSIZER
        IDRFLG = 3
        IOFFLG = 0
        ROFFLG = 0.
        SSCALE = 1.0
      ENDIF
C
C  Sweep across the region from top to bottom.  Set the value for 
C  IDRFLG so that outlines are drawn to prevent small filled areas 
C  from dropping out on low-resolution screens.
C
      SEEDX = XRL+0.5*CHRWID/WIDSCL
      SEEDY = YRT-0.5*CHRHIT
      LXEXT = ((XRR-XRL)/CHRWID)+2
      LYEXT = ((YRT-YRB)/CHRHIT)+2
      DO 20 J=1,LYEXT
        YP = SEEDY-(J-1)*CHRHIT
        DO 30 I=1,LXEXT
          XP = SEEDX+(I-1)*CHRWID-
     +           REAL(MOD(J-1,2))*REAL(IOFFLG)*ROFFLG*CHRWID
          L = 1
            K = 0
   60       CONTINUE
            L = L+2
            IF (L .GT. NDGU) GO TO 70
              K = K+1
              IF (RWORK(L).EQ.-2047.) THEN 
                CALL PPINPO(X,Y,N,RWORK(MDGUP1),RWORK(MDGUP),
     +                      K-1,RWORK(MDGU2P),IWORK(MDGU2P),
     +                      NWRK-MDGU2,WMLGFA,IER)
C
C  Ignore degenerate areas.
C
                IF (IER.NE.0 .AND. IER.NE.2) THEN
                  CALL SETER (
     +              'WMRGWT - error calculating area intersection',
     +               1, 1)
                  RETURN
                ENDIF
                K = 0
              ELSE IF (RWORK(L).EQ.-2048.) THEN
C
C  Install a line clipper in here when it becomes available.
C
                IDRFLG = -1
                CALL PPINPO(X,Y,N,RWORK(MDGUP1),RWORK(MDGUP),
     +                      K-1,RWORK(MDGU2P),IWORK(MDGU2P),
     +                      NWRK-MDGU2,WMLGFA,IER)
C
C  Ignore degenerate areas.
C
                IF (IER.NE.0 .AND. IER.NE.2) THEN
                  CALL SETER (
     +              'WMRGWT - error calculating area intersection',
     +               1, 1)
                  RETURN
                ENDIF
                K = 0
              ELSE
                RWORK(K+MDGU)       = XP+SSCALE*RWORK(L)
                RWORK(K+MDGU+MDGUH) = YP+SSCALE*RWORK(L+1)
              ENDIF
            GO TO 60
   70     CONTINUE
   30   CONTINUE
   20 CONTINUE
C
      RETURN
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C   FFTPACK 5.0
C   Copyright (C) 1995-2004, Scientific Computing Division,
C   University Corporation for Atmospheric Research
C   Licensed under the GNU General Public License (GPL)
C
C   Authors:  Paul N. Swarztrauber and Richard A. Valent
C
C   $Id: c1fm1b.f,v 1.2 2006-11-21 01:10:15 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      SUBROUTINE DC1FM1B(N,INC,C,CH,WA,FNF,FAC)
      DOUBLE PRECISION FNF
      DOUBLE COMPLEX C(*)
      DOUBLE PRECISION CH(*),WA(*),FAC(*)
C
C FFTPACK 5.0 auxiliary routine
C
      INC2 = INC + INC
      NF = FNF
      NA = 0
      L1 = 1
      IW = 1
      DO 125 K1 = 1,NF
          IP = FAC(K1)
          L2 = IP*L1
          IDO = N/L2
          LID = L1*IDO
          NBR = 1 + NA + 2*MIN(IP-2,4)
          GO TO (52,62,53,63,54,64,55,65,56,66) NBR
   52     CALL DC1F2KB(IDO,L1,NA,C,INC2,CH,2,WA(IW))
          GO TO 120
   62     CALL DC1F2KB(IDO,L1,NA,CH,2,C,INC2,WA(IW))
          GO TO 120
   53     CALL DC1F3KB(IDO,L1,NA,C,INC2,CH,2,WA(IW))
          GO TO 120
   63     CALL DC1F3KB(IDO,L1,NA,CH,2,C,INC2,WA(IW))
          GO TO 120
   54     CALL DC1F4KB(IDO,L1,NA,C,INC2,CH,2,WA(IW))
          GO TO 120
   64     CALL DC1F4KB(IDO,L1,NA,CH,2,C,INC2,WA(IW))
          GO TO 120
   55     CALL DC1F5KB(IDO,L1,NA,C,INC2,CH,2,WA(IW))
          GO TO 120
   65     CALL DC1F5KB(IDO,L1,NA,CH,2,C,INC2,WA(IW))
          GO TO 120
   56     CALL DC1FGKB(IDO,IP,L1,LID,NA,C,C,INC2,CH,CH,2,WA(IW))
          GO TO 120
   66     CALL DC1FGKB(IDO,IP,L1,LID,NA,CH,CH,2,C,C,INC2,WA(IW))
  120     L1 = L2
          IW = IW + (IP-1)* (IDO+IDO)
          IF (IP.LE.5) NA = 1 - NA
  125 CONTINUE
      RETURN
      END

C
C	$Id: reset.f,v 1.4 2008-07-27 00:23:03 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE RESET
C
C  THIS USER ENTRY POINT IS HERE ONLY FOR COMPATIBILITY WITH USE IN
C  THE CONREC FAMILY WHICH CALL RESET WHEN USED WITH DASHSUPR.
C
      RETURN
      END

      SUBROUTINE STREVC( SIDE, HOWMNY, SELECT, N, T, LDT, VL, LDVL, VR,
     $                   LDVR, MM, M, WORK, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          HOWMNY, SIDE
      INTEGER            INFO, LDT, LDVL, LDVR, M, MM, N
*     ..
*     .. Array Arguments ..
      LOGICAL            SELECT( * )
      REAL               T( LDT, * ), VL( LDVL, * ), VR( LDVR, * ),
     $                   WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  STREVC computes some or all of the right and/or left eigenvectors of
*  a real upper quasi-triangular matrix T.
*
*  The right eigenvector x and the left eigenvector y of T corresponding
*  to an eigenvalue w are defined by:
*
*               T*x = w*x,     y'*T = w*y'
*
*  where y' denotes the conjugate transpose of the vector y.
*
*  If all eigenvectors are requested, the routine may either return the
*  matrices X and/or Y of right or left eigenvectors of T, or the
*  products Q*X and/or Q*Y, where Q is an input orthogonal
*  matrix. If T was obtained from the real-Schur factorization of an
*  original matrix A = Q*T*Q', then Q*X and Q*Y are the matrices of
*  right or left eigenvectors of A.
*
*  T must be in Schur canonical form (as returned by SHSEQR), that is,
*  block upper triangular with 1-by-1 and 2-by-2 diagonal blocks; each
*  2-by-2 diagonal block has its diagonal elements equal and its
*  off-diagonal elements of opposite sign.  Corresponding to each 2-by-2
*  diagonal block is a complex conjugate pair of eigenvalues and
*  eigenvectors; only one eigenvector of the pair is computed, namely
*  the one corresponding to the eigenvalue with positive imaginary part.
*
*  Arguments
*  =========
*
*  SIDE    (input) CHARACTER*1
*          = 'R':  compute right eigenvectors only;
*          = 'L':  compute left eigenvectors only;
*          = 'B':  compute both right and left eigenvectors.
*
*  HOWMNY  (input) CHARACTER*1
*          = 'A':  compute all right and/or left eigenvectors;
*          = 'B':  compute all right and/or left eigenvectors,
*                  and backtransform them using the input matrices
*                  supplied in VR and/or VL;
*          = 'S':  compute selected right and/or left eigenvectors,
*                  specified by the logical array SELECT.
*
*  SELECT  (input/output) LOGICAL array, dimension (N)
*          If HOWMNY = 'S', SELECT specifies the eigenvectors to be
*          computed.
*          If HOWMNY = 'A' or 'B', SELECT is not referenced.
*          To select the real eigenvector corresponding to a real
*          eigenvalue w(j), SELECT(j) must be set to .TRUE..  To select
*          the complex eigenvector corresponding to a complex conjugate
*          pair w(j) and w(j+1), either SELECT(j) or SELECT(j+1) must be
*          set to .TRUE.; then on exit SELECT(j) is .TRUE. and
*          SELECT(j+1) is .FALSE..
*
*  N       (input) INTEGER
*          The order of the matrix T. N >= 0.
*
*  T       (input) REAL array, dimension (LDT,N)
*          The upper quasi-triangular matrix T in Schur canonical form.
*
*  LDT     (input) INTEGER
*          The leading dimension of the array T. LDT >= max(1,N).
*
*  VL      (input/output) REAL array, dimension (LDVL,MM)
*          On entry, if SIDE = 'L' or 'B' and HOWMNY = 'B', VL must
*          contain an N-by-N matrix Q (usually the orthogonal matrix Q
*          of Schur vectors returned by SHSEQR).
*          On exit, if SIDE = 'L' or 'B', VL contains:
*          if HOWMNY = 'A', the matrix Y of left eigenvectors of T;
*                           VL has the same quasi-lower triangular form
*                           as T'. If T(i,i) is a real eigenvalue, then
*                           the i-th column VL(i) of VL  is its
*                           corresponding eigenvector. If T(i:i+1,i:i+1)
*                           is a 2-by-2 block whose eigenvalues are
*                           complex-conjugate eigenvalues of T, then
*                           VL(i)+sqrt(-1)*VL(i+1) is the complex
*                           eigenvector corresponding to the eigenvalue
*                           with positive real part.
*          if HOWMNY = 'B', the matrix Q*Y;
*          if HOWMNY = 'S', the left eigenvectors of T specified by
*                           SELECT, stored consecutively in the columns
*                           of VL, in the same order as their
*                           eigenvalues.
*          A complex eigenvector corresponding to a complex eigenvalue
*          is stored in two consecutive columns, the first holding the
*          real part, and the second the imaginary part.
*          If SIDE = 'R', VL is not referenced.
*
*  LDVL    (input) INTEGER
*          The leading dimension of the array VL.  LDVL >= max(1,N) if
*          SIDE = 'L' or 'B'; LDVL >= 1 otherwise.
*
*  VR      (input/output) REAL array, dimension (LDVR,MM)
*          On entry, if SIDE = 'R' or 'B' and HOWMNY = 'B', VR must
*          contain an N-by-N matrix Q (usually the orthogonal matrix Q
*          of Schur vectors returned by SHSEQR).
*          On exit, if SIDE = 'R' or 'B', VR contains:
*          if HOWMNY = 'A', the matrix X of right eigenvectors of T;
*                           VR has the same quasi-upper triangular form
*                           as T. If T(i,i) is a real eigenvalue, then
*                           the i-th column VR(i) of VR  is its
*                           corresponding eigenvector. If T(i:i+1,i:i+1)
*                           is a 2-by-2 block whose eigenvalues are
*                           complex-conjugate eigenvalues of T, then
*                           VR(i)+sqrt(-1)*VR(i+1) is the complex
*                           eigenvector corresponding to the eigenvalue
*                           with positive real part.
*          if HOWMNY = 'B', the matrix Q*X;
*          if HOWMNY = 'S', the right eigenvectors of T specified by
*                           SELECT, stored consecutively in the columns
*                           of VR, in the same order as their
*                           eigenvalues.
*          A complex eigenvector corresponding to a complex eigenvalue
*          is stored in two consecutive columns, the first holding the
*          real part and the second the imaginary part.
*          If SIDE = 'L', VR is not referenced.
*
*  LDVR    (input) INTEGER
*          The leading dimension of the array VR.  LDVR >= max(1,N) if
*          SIDE = 'R' or 'B'; LDVR >= 1 otherwise.
*
*  MM      (input) INTEGER
*          The number of columns in the arrays VL and/or VR. MM >= M.
*
*  M       (output) INTEGER
*          The number of columns in the arrays VL and/or VR actually
*          used to store the eigenvectors.
*          If HOWMNY = 'A' or 'B', M is set to N.
*          Each selected real eigenvector occupies one column and each
*          selected complex eigenvector occupies two columns.
*
*  WORK    (workspace) REAL array, dimension (3*N)
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*
*  Further Details
*  ===============
*
*  The algorithm used in this program is basically backward (forward)
*  substitution, with scaling to make the the code robust against
*  possible overflow.
*
*  Each eigenvector is normalized so that the element of largest
*  magnitude has magnitude 1; here the magnitude of a complex number
*  (x,y) is taken to be |x| + |y|.
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ZERO, ONE
      PARAMETER          ( ZERO = 0.0E+0, ONE = 1.0E+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            ALLV, BOTHV, LEFTV, OVER, PAIR, RIGHTV, SOMEV
      INTEGER            I, IERR, II, IP, IS, J, J1, J2, JNXT, K, KI, N2
      REAL               BETA, BIGNUM, EMAX, OVFL, REC, REMAX, SCALE,
     $                   SMIN, SMLNUM, ULP, UNFL, VCRIT, VMAX, WI, WR,
     $                   XNORM
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            ISAMAX
      REAL               SDOT, SLAMCH
      EXTERNAL           LSAME, ISAMAX, SDOT, SLAMCH
*     ..
*     .. External Subroutines ..
      EXTERNAL           SAXPY, SCOPY, SGEMV, SLABAD, SLALN2, SSCAL,
     $                   XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, MAX, SQRT
*     ..
*     .. Local Arrays ..
      REAL               X( 2, 2 )
*     ..
*     .. Executable Statements ..
*
*     Decode and test the input parameters
*
      BOTHV = LSAME( SIDE, 'B' )
      RIGHTV = LSAME( SIDE, 'R' ) .OR. BOTHV
      LEFTV = LSAME( SIDE, 'L' ) .OR. BOTHV
*
      ALLV = LSAME( HOWMNY, 'A' )
      OVER = LSAME( HOWMNY, 'B' )
      SOMEV = LSAME( HOWMNY, 'S' )
*
      INFO = 0
      IF( .NOT.RIGHTV .AND. .NOT.LEFTV ) THEN
         INFO = -1
      ELSE IF( .NOT.ALLV .AND. .NOT.OVER .AND. .NOT.SOMEV ) THEN
         INFO = -2
      ELSE IF( N.LT.0 ) THEN
         INFO = -4
      ELSE IF( LDT.LT.MAX( 1, N ) ) THEN
         INFO = -6
      ELSE IF( LDVL.LT.1 .OR. ( LEFTV .AND. LDVL.LT.N ) ) THEN
         INFO = -8
      ELSE IF( LDVR.LT.1 .OR. ( RIGHTV .AND. LDVR.LT.N ) ) THEN
         INFO = -10
      ELSE
*
*        Set M to the number of columns required to store the selected
*        eigenvectors, standardize the array SELECT if necessary, and
*        test MM.
*
         IF( SOMEV ) THEN
            M = 0
            PAIR = .FALSE.
            DO 10 J = 1, N
               IF( PAIR ) THEN
                  PAIR = .FALSE.
                  SELECT( J ) = .FALSE.
               ELSE
                  IF( J.LT.N ) THEN
                     IF( T( J+1, J ).EQ.ZERO ) THEN
                        IF( SELECT( J ) )
     $                     M = M + 1
                     ELSE
                        PAIR = .TRUE.
                        IF( SELECT( J ) .OR. SELECT( J+1 ) ) THEN
                           SELECT( J ) = .TRUE.
                           M = M + 2
                        END IF
                     END IF
                  ELSE
                     IF( SELECT( N ) )
     $                  M = M + 1
                  END IF
               END IF
   10       CONTINUE
         ELSE
            M = N
         END IF
*
         IF( MM.LT.M ) THEN
            INFO = -11
         END IF
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'STREVC', -INFO )
         RETURN
      END IF
*
*     Quick return if possible.
*
      IF( N.EQ.0 )
     $   RETURN
*
*     Set the constants to control overflow.
*
      UNFL = SLAMCH( 'Safe minimum' )
      OVFL = ONE / UNFL
      CALL SLABAD( UNFL, OVFL )
      ULP = SLAMCH( 'Precision' )
      SMLNUM = UNFL*( N / ULP )
      BIGNUM = ( ONE-ULP ) / SMLNUM
*
*     Compute 1-norm of each column of strictly upper triangular
*     part of T to control overflow in triangular solver.
*
      WORK( 1 ) = ZERO
      DO 30 J = 2, N
         WORK( J ) = ZERO
         DO 20 I = 1, J - 1
            WORK( J ) = WORK( J ) + ABS( T( I, J ) )
   20    CONTINUE
   30 CONTINUE
*
*     Index IP is used to specify the real or complex eigenvalue:
*       IP = 0, real eigenvalue,
*            1, first of conjugate complex pair: (wr,wi)
*           -1, second of conjugate complex pair: (wr,wi)
*
      N2 = 2*N
*
      IF( RIGHTV ) THEN
*
*        Compute right eigenvectors.
*
         IP = 0
         IS = M
         DO 140 KI = N, 1, -1
*
            IF( IP.EQ.1 )
     $         GO TO 130
            IF( KI.EQ.1 )
     $         GO TO 40
            IF( T( KI, KI-1 ).EQ.ZERO )
     $         GO TO 40
            IP = -1
*
   40       CONTINUE
            IF( SOMEV ) THEN
               IF( IP.EQ.0 ) THEN
                  IF( .NOT.SELECT( KI ) )
     $               GO TO 130
               ELSE
                  IF( .NOT.SELECT( KI-1 ) )
     $               GO TO 130
               END IF
            END IF
*
*           Compute the KI-th eigenvalue (WR,WI).
*
            WR = T( KI, KI )
            WI = ZERO
            IF( IP.NE.0 )
     $         WI = SQRT( ABS( T( KI, KI-1 ) ) )*
     $              SQRT( ABS( T( KI-1, KI ) ) )
            SMIN = MAX( ULP*( ABS( WR )+ABS( WI ) ), SMLNUM )
*
            IF( IP.EQ.0 ) THEN
*
*              Real right eigenvector
*
               WORK( KI+N ) = ONE
*
*              Form right-hand side
*
               DO 50 K = 1, KI - 1
                  WORK( K+N ) = -T( K, KI )
   50          CONTINUE
*
*              Solve the upper quasi-triangular system:
*                 (T(1:KI-1,1:KI-1) - WR)*X = SCALE*WORK.
*
               JNXT = KI - 1
               DO 60 J = KI - 1, 1, -1
                  IF( J.GT.JNXT )
     $               GO TO 60
                  J1 = J
                  J2 = J
                  JNXT = J - 1
                  IF( J.GT.1 ) THEN
                     IF( T( J, J-1 ).NE.ZERO ) THEN
                        J1 = J - 1
                        JNXT = J - 2
                     END IF
                  END IF
*
                  IF( J1.EQ.J2 ) THEN
*
*                    1-by-1 diagonal block
*
                     CALL SLALN2( .FALSE., 1, 1, SMIN, ONE, T( J, J ),
     $                            LDT, ONE, ONE, WORK( J+N ), N, WR,
     $                            ZERO, X, 2, SCALE, XNORM, IERR )
*
*                    Scale X(1,1) to avoid overflow when updating
*                    the right-hand side.
*
                     IF( XNORM.GT.ONE ) THEN
                        IF( WORK( J ).GT.BIGNUM / XNORM ) THEN
                           X( 1, 1 ) = X( 1, 1 ) / XNORM
                           SCALE = SCALE / XNORM
                        END IF
                     END IF
*
*                    Scale if necessary
*
                     IF( SCALE.NE.ONE )
     $                  CALL SSCAL( KI, SCALE, WORK( 1+N ), 1 )
                     WORK( J+N ) = X( 1, 1 )
*
*                    Update right-hand side
*
                     CALL SAXPY( J-1, -X( 1, 1 ), T( 1, J ), 1,
     $                           WORK( 1+N ), 1 )
*
                  ELSE
*
*                    2-by-2 diagonal block
*
                     CALL SLALN2( .FALSE., 2, 1, SMIN, ONE,
     $                            T( J-1, J-1 ), LDT, ONE, ONE,
     $                            WORK( J-1+N ), N, WR, ZERO, X, 2,
     $                            SCALE, XNORM, IERR )
*
*                    Scale X(1,1) and X(2,1) to avoid overflow when
*                    updating the right-hand side.
*
                     IF( XNORM.GT.ONE ) THEN
                        BETA = MAX( WORK( J-1 ), WORK( J ) )
                        IF( BETA.GT.BIGNUM / XNORM ) THEN
                           X( 1, 1 ) = X( 1, 1 ) / XNORM
                           X( 2, 1 ) = X( 2, 1 ) / XNORM
                           SCALE = SCALE / XNORM
                        END IF
                     END IF
*
*                    Scale if necessary
*
                     IF( SCALE.NE.ONE )
     $                  CALL SSCAL( KI, SCALE, WORK( 1+N ), 1 )
                     WORK( J-1+N ) = X( 1, 1 )
                     WORK( J+N ) = X( 2, 1 )
*
*                    Update right-hand side
*
                     CALL SAXPY( J-2, -X( 1, 1 ), T( 1, J-1 ), 1,
     $                           WORK( 1+N ), 1 )
                     CALL SAXPY( J-2, -X( 2, 1 ), T( 1, J ), 1,
     $                           WORK( 1+N ), 1 )
                  END IF
   60          CONTINUE
*
*              Copy the vector x or Q*x to VR and normalize.
*
               IF( .NOT.OVER ) THEN
                  CALL SCOPY( KI, WORK( 1+N ), 1, VR( 1, IS ), 1 )
*
                  II = ISAMAX( KI, VR( 1, IS ), 1 )
                  REMAX = ONE / ABS( VR( II, IS ) )
                  CALL SSCAL( KI, REMAX, VR( 1, IS ), 1 )
*
                  DO 70 K = KI + 1, N
                     VR( K, IS ) = ZERO
   70             CONTINUE
               ELSE
                  IF( KI.GT.1 )
     $               CALL SGEMV( 'N', N, KI-1, ONE, VR, LDVR,
     $                           WORK( 1+N ), 1, WORK( KI+N ),
     $                           VR( 1, KI ), 1 )
*
                  II = ISAMAX( N, VR( 1, KI ), 1 )
                  REMAX = ONE / ABS( VR( II, KI ) )
                  CALL SSCAL( N, REMAX, VR( 1, KI ), 1 )
               END IF
*
            ELSE
*
*              Complex right eigenvector.
*
*              Initial solve
*                [ (T(KI-1,KI-1) T(KI-1,KI) ) - (WR + I* WI)]*X = 0.
*                [ (T(KI,KI-1)   T(KI,KI)   )               ]
*
               IF( ABS( T( KI-1, KI ) ).GE.ABS( T( KI, KI-1 ) ) ) THEN
                  WORK( KI-1+N ) = ONE
                  WORK( KI+N2 ) = WI / T( KI-1, KI )
               ELSE
                  WORK( KI-1+N ) = -WI / T( KI, KI-1 )
                  WORK( KI+N2 ) = ONE
               END IF
               WORK( KI+N ) = ZERO
               WORK( KI-1+N2 ) = ZERO
*
*              Form right-hand side
*
               DO 80 K = 1, KI - 2
                  WORK( K+N ) = -WORK( KI-1+N )*T( K, KI-1 )
                  WORK( K+N2 ) = -WORK( KI+N2 )*T( K, KI )
   80          CONTINUE
*
*              Solve upper quasi-triangular system:
*              (T(1:KI-2,1:KI-2) - (WR+i*WI))*X = SCALE*(WORK+i*WORK2)
*
               JNXT = KI - 2
               DO 90 J = KI - 2, 1, -1
                  IF( J.GT.JNXT )
     $               GO TO 90
                  J1 = J
                  J2 = J
                  JNXT = J - 1
                  IF( J.GT.1 ) THEN
                     IF( T( J, J-1 ).NE.ZERO ) THEN
                        J1 = J - 1
                        JNXT = J - 2
                     END IF
                  END IF
*
                  IF( J1.EQ.J2 ) THEN
*
*                    1-by-1 diagonal block
*
                     CALL SLALN2( .FALSE., 1, 2, SMIN, ONE, T( J, J ),
     $                            LDT, ONE, ONE, WORK( J+N ), N, WR, WI,
     $                            X, 2, SCALE, XNORM, IERR )
*
*                    Scale X(1,1) and X(1,2) to avoid overflow when
*                    updating the right-hand side.
*
                     IF( XNORM.GT.ONE ) THEN
                        IF( WORK( J ).GT.BIGNUM / XNORM ) THEN
                           X( 1, 1 ) = X( 1, 1 ) / XNORM
                           X( 1, 2 ) = X( 1, 2 ) / XNORM
                           SCALE = SCALE / XNORM
                        END IF
                     END IF
*
*                    Scale if necessary
*
                     IF( SCALE.NE.ONE ) THEN
                        CALL SSCAL( KI, SCALE, WORK( 1+N ), 1 )
                        CALL SSCAL( KI, SCALE, WORK( 1+N2 ), 1 )
                     END IF
                     WORK( J+N ) = X( 1, 1 )
                     WORK( J+N2 ) = X( 1, 2 )
*
*                    Update the right-hand side
*
                     CALL SAXPY( J-1, -X( 1, 1 ), T( 1, J ), 1,
     $                           WORK( 1+N ), 1 )
                     CALL SAXPY( J-1, -X( 1, 2 ), T( 1, J ), 1,
     $                           WORK( 1+N2 ), 1 )
*
                  ELSE
*
*                    2-by-2 diagonal block
*
                     CALL SLALN2( .FALSE., 2, 2, SMIN, ONE,
     $                            T( J-1, J-1 ), LDT, ONE, ONE,
     $                            WORK( J-1+N ), N, WR, WI, X, 2, SCALE,
     $                            XNORM, IERR )
*
*                    Scale X to avoid overflow when updating
*                    the right-hand side.
*
                     IF( XNORM.GT.ONE ) THEN
                        BETA = MAX( WORK( J-1 ), WORK( J ) )
                        IF( BETA.GT.BIGNUM / XNORM ) THEN
                           REC = ONE / XNORM
                           X( 1, 1 ) = X( 1, 1 )*REC
                           X( 1, 2 ) = X( 1, 2 )*REC
                           X( 2, 1 ) = X( 2, 1 )*REC
                           X( 2, 2 ) = X( 2, 2 )*REC
                           SCALE = SCALE*REC
                        END IF
                     END IF
*
*                    Scale if necessary
*
                     IF( SCALE.NE.ONE ) THEN
                        CALL SSCAL( KI, SCALE, WORK( 1+N ), 1 )
                        CALL SSCAL( KI, SCALE, WORK( 1+N2 ), 1 )
                     END IF
                     WORK( J-1+N ) = X( 1, 1 )
                     WORK( J+N ) = X( 2, 1 )
                     WORK( J-1+N2 ) = X( 1, 2 )
                     WORK( J+N2 ) = X( 2, 2 )
*
*                    Update the right-hand side
*
                     CALL SAXPY( J-2, -X( 1, 1 ), T( 1, J-1 ), 1,
     $                           WORK( 1+N ), 1 )
                     CALL SAXPY( J-2, -X( 2, 1 ), T( 1, J ), 1,
     $                           WORK( 1+N ), 1 )
                     CALL SAXPY( J-2, -X( 1, 2 ), T( 1, J-1 ), 1,
     $                           WORK( 1+N2 ), 1 )
                     CALL SAXPY( J-2, -X( 2, 2 ), T( 1, J ), 1,
     $                           WORK( 1+N2 ), 1 )
                  END IF
   90          CONTINUE
*
*              Copy the vector x or Q*x to VR and normalize.
*
               IF( .NOT.OVER ) THEN
                  CALL SCOPY( KI, WORK( 1+N ), 1, VR( 1, IS-1 ), 1 )
                  CALL SCOPY( KI, WORK( 1+N2 ), 1, VR( 1, IS ), 1 )
*
                  EMAX = ZERO
                  DO 100 K = 1, KI
                     EMAX = MAX( EMAX, ABS( VR( K, IS-1 ) )+
     $                      ABS( VR( K, IS ) ) )
  100             CONTINUE
*
                  REMAX = ONE / EMAX
                  CALL SSCAL( KI, REMAX, VR( 1, IS-1 ), 1 )
                  CALL SSCAL( KI, REMAX, VR( 1, IS ), 1 )
*
                  DO 110 K = KI + 1, N
                     VR( K, IS-1 ) = ZERO
                     VR( K, IS ) = ZERO
  110             CONTINUE
*
               ELSE
*
                  IF( KI.GT.2 ) THEN
                     CALL SGEMV( 'N', N, KI-2, ONE, VR, LDVR,
     $                           WORK( 1+N ), 1, WORK( KI-1+N ),
     $                           VR( 1, KI-1 ), 1 )
                     CALL SGEMV( 'N', N, KI-2, ONE, VR, LDVR,
     $                           WORK( 1+N2 ), 1, WORK( KI+N2 ),
     $                           VR( 1, KI ), 1 )
                  ELSE
                     CALL SSCAL( N, WORK( KI-1+N ), VR( 1, KI-1 ), 1 )
                     CALL SSCAL( N, WORK( KI+N2 ), VR( 1, KI ), 1 )
                  END IF
*
                  EMAX = ZERO
                  DO 120 K = 1, N
                     EMAX = MAX( EMAX, ABS( VR( K, KI-1 ) )+
     $                      ABS( VR( K, KI ) ) )
  120             CONTINUE
                  REMAX = ONE / EMAX
                  CALL SSCAL( N, REMAX, VR( 1, KI-1 ), 1 )
                  CALL SSCAL( N, REMAX, VR( 1, KI ), 1 )
               END IF
            END IF
*
            IS = IS - 1
            IF( IP.NE.0 )
     $         IS = IS - 1
  130       CONTINUE
            IF( IP.EQ.1 )
     $         IP = 0
            IF( IP.EQ.-1 )
     $         IP = 1
  140    CONTINUE
      END IF
*
      IF( LEFTV ) THEN
*
*        Compute left eigenvectors.
*
         IP = 0
         IS = 1
         DO 260 KI = 1, N
*
            IF( IP.EQ.-1 )
     $         GO TO 250
            IF( KI.EQ.N )
     $         GO TO 150
            IF( T( KI+1, KI ).EQ.ZERO )
     $         GO TO 150
            IP = 1
*
  150       CONTINUE
            IF( SOMEV ) THEN
               IF( .NOT.SELECT( KI ) )
     $            GO TO 250
            END IF
*
*           Compute the KI-th eigenvalue (WR,WI).
*
            WR = T( KI, KI )
            WI = ZERO
            IF( IP.NE.0 )
     $         WI = SQRT( ABS( T( KI, KI+1 ) ) )*
     $              SQRT( ABS( T( KI+1, KI ) ) )
            SMIN = MAX( ULP*( ABS( WR )+ABS( WI ) ), SMLNUM )
*
            IF( IP.EQ.0 ) THEN
*
*              Real left eigenvector.
*
               WORK( KI+N ) = ONE
*
*              Form right-hand side
*
               DO 160 K = KI + 1, N
                  WORK( K+N ) = -T( KI, K )
  160          CONTINUE
*
*              Solve the quasi-triangular system:
*                 (T(KI+1:N,KI+1:N) - WR)'*X = SCALE*WORK
*
               VMAX = ONE
               VCRIT = BIGNUM
*
               JNXT = KI + 1
               DO 170 J = KI + 1, N
                  IF( J.LT.JNXT )
     $               GO TO 170
                  J1 = J
                  J2 = J
                  JNXT = J + 1
                  IF( J.LT.N ) THEN
                     IF( T( J+1, J ).NE.ZERO ) THEN
                        J2 = J + 1
                        JNXT = J + 2
                     END IF
                  END IF
*
                  IF( J1.EQ.J2 ) THEN
*
*                    1-by-1 diagonal block
*
*                    Scale if necessary to avoid overflow when forming
*                    the right-hand side.
*
                     IF( WORK( J ).GT.VCRIT ) THEN
                        REC = ONE / VMAX
                        CALL SSCAL( N-KI+1, REC, WORK( KI+N ), 1 )
                        VMAX = ONE
                        VCRIT = BIGNUM
                     END IF
*
                     WORK( J+N ) = WORK( J+N ) -
     $                             SDOT( J-KI-1, T( KI+1, J ), 1,
     $                             WORK( KI+1+N ), 1 )
*
*                    Solve (T(J,J)-WR)'*X = WORK
*
                     CALL SLALN2( .FALSE., 1, 1, SMIN, ONE, T( J, J ),
     $                            LDT, ONE, ONE, WORK( J+N ), N, WR,
     $                            ZERO, X, 2, SCALE, XNORM, IERR )
*
*                    Scale if necessary
*
                     IF( SCALE.NE.ONE )
     $                  CALL SSCAL( N-KI+1, SCALE, WORK( KI+N ), 1 )
                     WORK( J+N ) = X( 1, 1 )
                     VMAX = MAX( ABS( WORK( J+N ) ), VMAX )
                     VCRIT = BIGNUM / VMAX
*
                  ELSE
*
*                    2-by-2 diagonal block
*
*                    Scale if necessary to avoid overflow when forming
*                    the right-hand side.
*
                     BETA = MAX( WORK( J ), WORK( J+1 ) )
                     IF( BETA.GT.VCRIT ) THEN
                        REC = ONE / VMAX
                        CALL SSCAL( N-KI+1, REC, WORK( KI+N ), 1 )
                        VMAX = ONE
                        VCRIT = BIGNUM
                     END IF
*
                     WORK( J+N ) = WORK( J+N ) -
     $                             SDOT( J-KI-1, T( KI+1, J ), 1,
     $                             WORK( KI+1+N ), 1 )
*
                     WORK( J+1+N ) = WORK( J+1+N ) -
     $                               SDOT( J-KI-1, T( KI+1, J+1 ), 1,
     $                               WORK( KI+1+N ), 1 )
*
*                    Solve
*                      [T(J,J)-WR   T(J,J+1)     ]'* X = SCALE*( WORK1 )
*                      [T(J+1,J)    T(J+1,J+1)-WR]             ( WORK2 )
*
                     CALL SLALN2( .TRUE., 2, 1, SMIN, ONE, T( J, J ),
     $                            LDT, ONE, ONE, WORK( J+N ), N, WR,
     $                            ZERO, X, 2, SCALE, XNORM, IERR )
*
*                    Scale if necessary
*
                     IF( SCALE.NE.ONE )
     $                  CALL SSCAL( N-KI+1, SCALE, WORK( KI+N ), 1 )
                     WORK( J+N ) = X( 1, 1 )
                     WORK( J+1+N ) = X( 2, 1 )
*
                     VMAX = MAX( ABS( WORK( J+N ) ),
     $                      ABS( WORK( J+1+N ) ), VMAX )
                     VCRIT = BIGNUM / VMAX
*
                  END IF
  170          CONTINUE
*
*              Copy the vector x or Q*x to VL and normalize.
*
               IF( .NOT.OVER ) THEN
                  CALL SCOPY( N-KI+1, WORK( KI+N ), 1, VL( KI, IS ), 1 )
*
                  II = ISAMAX( N-KI+1, VL( KI, IS ), 1 ) + KI - 1
                  REMAX = ONE / ABS( VL( II, IS ) )
                  CALL SSCAL( N-KI+1, REMAX, VL( KI, IS ), 1 )
*
                  DO 180 K = 1, KI - 1
                     VL( K, IS ) = ZERO
  180             CONTINUE
*
               ELSE
*
                  IF( KI.LT.N )
     $               CALL SGEMV( 'N', N, N-KI, ONE, VL( 1, KI+1 ), LDVL,
     $                           WORK( KI+1+N ), 1, WORK( KI+N ),
     $                           VL( 1, KI ), 1 )
*
                  II = ISAMAX( N, VL( 1, KI ), 1 )
                  REMAX = ONE / ABS( VL( II, KI ) )
                  CALL SSCAL( N, REMAX, VL( 1, KI ), 1 )
*
               END IF
*
            ELSE
*
*              Complex left eigenvector.
*
*               Initial solve:
*                 ((T(KI,KI)    T(KI,KI+1) )' - (WR - I* WI))*X = 0.
*                 ((T(KI+1,KI) T(KI+1,KI+1))                )
*
               IF( ABS( T( KI, KI+1 ) ).GE.ABS( T( KI+1, KI ) ) ) THEN
                  WORK( KI+N ) = WI / T( KI, KI+1 )
                  WORK( KI+1+N2 ) = ONE
               ELSE
                  WORK( KI+N ) = ONE
                  WORK( KI+1+N2 ) = -WI / T( KI+1, KI )
               END IF
               WORK( KI+1+N ) = ZERO
               WORK( KI+N2 ) = ZERO
*
*              Form right-hand side
*
               DO 190 K = KI + 2, N
                  WORK( K+N ) = -WORK( KI+N )*T( KI, K )
                  WORK( K+N2 ) = -WORK( KI+1+N2 )*T( KI+1, K )
  190          CONTINUE
*
*              Solve complex quasi-triangular system:
*              ( T(KI+2,N:KI+2,N) - (WR-i*WI) )*X = WORK1+i*WORK2
*
               VMAX = ONE
               VCRIT = BIGNUM
*
               JNXT = KI + 2
               DO 200 J = KI + 2, N
                  IF( J.LT.JNXT )
     $               GO TO 200
                  J1 = J
                  J2 = J
                  JNXT = J + 1
                  IF( J.LT.N ) THEN
                     IF( T( J+1, J ).NE.ZERO ) THEN
                        J2 = J + 1
                        JNXT = J + 2
                     END IF
                  END IF
*
                  IF( J1.EQ.J2 ) THEN
*
*                    1-by-1 diagonal block
*
*                    Scale if necessary to avoid overflow when
*                    forming the right-hand side elements.
*
                     IF( WORK( J ).GT.VCRIT ) THEN
                        REC = ONE / VMAX
                        CALL SSCAL( N-KI+1, REC, WORK( KI+N ), 1 )
                        CALL SSCAL( N-KI+1, REC, WORK( KI+N2 ), 1 )
                        VMAX = ONE
                        VCRIT = BIGNUM
                     END IF
*
                     WORK( J+N ) = WORK( J+N ) -
     $                             SDOT( J-KI-2, T( KI+2, J ), 1,
     $                             WORK( KI+2+N ), 1 )
                     WORK( J+N2 ) = WORK( J+N2 ) -
     $                              SDOT( J-KI-2, T( KI+2, J ), 1,
     $                              WORK( KI+2+N2 ), 1 )
*
*                    Solve (T(J,J)-(WR-i*WI))*(X11+i*X12)= WK+I*WK2
*
                     CALL SLALN2( .FALSE., 1, 2, SMIN, ONE, T( J, J ),
     $                            LDT, ONE, ONE, WORK( J+N ), N, WR,
     $                            -WI, X, 2, SCALE, XNORM, IERR )
*
*                    Scale if necessary
*
                     IF( SCALE.NE.ONE ) THEN
                        CALL SSCAL( N-KI+1, SCALE, WORK( KI+N ), 1 )
                        CALL SSCAL( N-KI+1, SCALE, WORK( KI+N2 ), 1 )
                     END IF
                     WORK( J+N ) = X( 1, 1 )
                     WORK( J+N2 ) = X( 1, 2 )
                     VMAX = MAX( ABS( WORK( J+N ) ),
     $                      ABS( WORK( J+N2 ) ), VMAX )
                     VCRIT = BIGNUM / VMAX
*
                  ELSE
*
*                    2-by-2 diagonal block
*
*                    Scale if necessary to avoid overflow when forming
*                    the right-hand side elements.
*
                     BETA = MAX( WORK( J ), WORK( J+1 ) )
                     IF( BETA.GT.VCRIT ) THEN
                        REC = ONE / VMAX
                        CALL SSCAL( N-KI+1, REC, WORK( KI+N ), 1 )
                        CALL SSCAL( N-KI+1, REC, WORK( KI+N2 ), 1 )
                        VMAX = ONE
                        VCRIT = BIGNUM
                     END IF
*
                     WORK( J+N ) = WORK( J+N ) -
     $                             SDOT( J-KI-2, T( KI+2, J ), 1,
     $                             WORK( KI+2+N ), 1 )
*
                     WORK( J+N2 ) = WORK( J+N2 ) -
     $                              SDOT( J-KI-2, T( KI+2, J ), 1,
     $                              WORK( KI+2+N2 ), 1 )
*
                     WORK( J+1+N ) = WORK( J+1+N ) -
     $                               SDOT( J-KI-2, T( KI+2, J+1 ), 1,
     $                               WORK( KI+2+N ), 1 )
*
                     WORK( J+1+N2 ) = WORK( J+1+N2 ) -
     $                                SDOT( J-KI-2, T( KI+2, J+1 ), 1,
     $                                WORK( KI+2+N2 ), 1 )
*
*                    Solve 2-by-2 complex linear equation
*                      ([T(j,j)   T(j,j+1)  ]'-(wr-i*wi)*I)*X = SCALE*B
*                      ([T(j+1,j) T(j+1,j+1)]             )
*
                     CALL SLALN2( .TRUE., 2, 2, SMIN, ONE, T( J, J ),
     $                            LDT, ONE, ONE, WORK( J+N ), N, WR,
     $                            -WI, X, 2, SCALE, XNORM, IERR )
*
*                    Scale if necessary
*
                     IF( SCALE.NE.ONE ) THEN
                        CALL SSCAL( N-KI+1, SCALE, WORK( KI+N ), 1 )
                        CALL SSCAL( N-KI+1, SCALE, WORK( KI+N2 ), 1 )
                     END IF
                     WORK( J+N ) = X( 1, 1 )
                     WORK( J+N2 ) = X( 1, 2 )
                     WORK( J+1+N ) = X( 2, 1 )
                     WORK( J+1+N2 ) = X( 2, 2 )
                     VMAX = MAX( ABS( X( 1, 1 ) ), ABS( X( 1, 2 ) ),
     $                      ABS( X( 2, 1 ) ), ABS( X( 2, 2 ) ), VMAX )
                     VCRIT = BIGNUM / VMAX
*
                  END IF
  200          CONTINUE
*
*              Copy the vector x or Q*x to VL and normalize.
*
  210          CONTINUE
               IF( .NOT.OVER ) THEN
                  CALL SCOPY( N-KI+1, WORK( KI+N ), 1, VL( KI, IS ), 1 )
                  CALL SCOPY( N-KI+1, WORK( KI+N2 ), 1, VL( KI, IS+1 ),
     $                        1 )
*
                  EMAX = ZERO
                  DO 220 K = KI, N
                     EMAX = MAX( EMAX, ABS( VL( K, IS ) )+
     $                      ABS( VL( K, IS+1 ) ) )
  220             CONTINUE
                  REMAX = ONE / EMAX
                  CALL SSCAL( N-KI+1, REMAX, VL( KI, IS ), 1 )
                  CALL SSCAL( N-KI+1, REMAX, VL( KI, IS+1 ), 1 )
*
                  DO 230 K = 1, KI - 1
                     VL( K, IS ) = ZERO
                     VL( K, IS+1 ) = ZERO
  230             CONTINUE
               ELSE
                  IF( KI.LT.N-1 ) THEN
                     CALL SGEMV( 'N', N, N-KI-1, ONE, VL( 1, KI+2 ),
     $                           LDVL, WORK( KI+2+N ), 1, WORK( KI+N ),
     $                           VL( 1, KI ), 1 )
                     CALL SGEMV( 'N', N, N-KI-1, ONE, VL( 1, KI+2 ),
     $                           LDVL, WORK( KI+2+N2 ), 1,
     $                           WORK( KI+1+N2 ), VL( 1, KI+1 ), 1 )
                  ELSE
                     CALL SSCAL( N, WORK( KI+N ), VL( 1, KI ), 1 )
                     CALL SSCAL( N, WORK( KI+1+N2 ), VL( 1, KI+1 ), 1 )
                  END IF
*
                  EMAX = ZERO
                  DO 240 K = 1, N
                     EMAX = MAX( EMAX, ABS( VL( K, KI ) )+
     $                      ABS( VL( K, KI+1 ) ) )
  240             CONTINUE
                  REMAX = ONE / EMAX
                  CALL SSCAL( N, REMAX, VL( 1, KI ), 1 )
                  CALL SSCAL( N, REMAX, VL( 1, KI+1 ), 1 )
*
               END IF
*
            END IF
*
            IS = IS + 1
            IF( IP.NE.0 )
     $         IS = IS + 1
  250       CONTINUE
            IF( IP.EQ.-1 )
     $         IP = 0
            IF( IP.EQ.1 )
     $         IP = -1
*
  260    CONTINUE
*
      END IF
*
      RETURN
*
*     End of STREVC
*
      END

C ---------------------------------------------------------
C NCLFORTSTART
      SUBROUTINE DWGTRUNAVE(X,NPTS,WGT,NWGT,KOPT,XMSG,WORK,LWORK,IER)

C NCL function: x = wgtrunwgt (x,wgt,kopt)

      INTEGER NPTS,NWGT,KOPT,IER
      DOUBLE PRECISION X(NPTS),WGT(NWGT),XMSG
C NCLEND
      INTEGER LWORK
      DOUBLE PRECISION WORK(LWORK)

      NHALF = NWGT/2
      LWORK = NPTS + 2*NHALF

      CALL DWRUNAVX77(X,NPTS,WGT,NWGT,KOPT,XMSG,WORK,LWORK,IER)

C NCL return (wrunwgt[x])
      RETURN
      END
c ---------------------------------------------------------
      SUBROUTINE DWRUNAVX77(X,NPTS,WGT,NWGT,KOPT,XMSG,WORK,LW,IER)
      DOUBLE PRECISION XMSG
      DOUBLE PRECISION WSUM
      DOUBLE PRECISION SUM

c same as wrunavx: slightly faster but slightly larger memory for work

c this routine will perform a weighted  running average on x
c .   the end points may be treated in three different ways

c nomenclature:
c .   x         - on input the series to be smoothed
c .               on output the smoothed series
c .   npts      - no of pts in x
c .   wgt       - vector containing weights [length=nwgt]
c .   nwgt      - no. of pts to be utilized in the wgted running average
c .   kopt      - end-point option [prefer an odd number]
c .               kopt < 0 : utilize cyclic conditions
C*PL*ERROR* Comment line too long
c .                          e.g.,  nwgt=3 at n=1 and n=npts and wsum=SUM{wgt}
c .                          x(1)    = w(1)*x(npts)+w(2)*x(1)+w(3)*x(2)
C*PL*ERROR* Comment line too long
c .                          x(npts) = w(1)*x(npts-1)+w(2)*x(npts)+w(3)*x(1)
c .                          e.g.,  nwgt=4 at n=1 and n=npts
C*PL*ERROR* Comment line too long
c .                          x(1)    = w(1)*x(npts-1)+w(2)*x(npts)+w(3)*x(1)+w(4)*x(2)
c .                          x(npts) = w(1)*x(npts-2)+w(2)*x(npts-1)
c .                                   +w(3)*x(npts)  +w(4)*x(1)
C*PL*ERROR* Comment line too long
c .               kopt = 0 : set unsmoothed beginning and end pts to xmsg
C*PL*ERROR* Comment line too long
c .                          e.g.,  nwgt=3 , x(1) = xmsg and x(npts) = xmsg
C*PL*ERROR* Comment line too long
c .                                        , x(2) = w(1)*x(1)+w(2)*x(2)+w(3)*x(3)
c .                          e.g.,  nwgt=4 , x(1) = xmsg and x(2) = xmsg
c .                                        , x(3) = w(1)*x(1)+w(2)*x(2)
c .                                                +w(3)*x(3)+w(4)*x(4)
c .                                     x(npts-1) = xmsg, x(npts) = xmsg
c .               kopt > 0 : utilize reflective (symmetric) conditions
c .                          e.g.,  nwgt=3 at n=1 and n=npts
c .                          x(1)    = w(1)*x(2)+w(2)*x(1)+w(3)*x(2)
C*PL*ERROR* Comment line too long
c .                          x(npts) = w(1)*x(npts-1)+w(2)*x(npts)+w(3)*x(npts-1)
c .                          e.g.,  nwgt=4 at n=1 and n=npts
C*PL*ERROR* Comment line too long
c .                          x(1)    = w(1)*x(3)+w(2)*x(2)+w(3)*x(1)+w(4)*x(2)
c .                          x(npts) = w(1)*x(npts-2)+w(2)*x(npts-1)
c .                                   +w(3)*x(npts)  +w(4)*x(npts-1)
c .   xmsg      - missing/special value
c .               also; if kopt=0 set end points to this special value
c .   work      - work vector
c .   lw        - length of work (=npts+2*N where N=nwgt/2)
c .   ier       - error flag
c .               ier = 0 : no errors
c .               ier = -11 : npts @ 0
c .               ier = -12 : npts < nwgt
c .               ier = -13 : nwgt is not odd

      DOUBLE PRECISION X(1:NPTS),WORK(LW),WGT(NWGT)

      IER = 0
      IF (NPTS.LT.1) IER = -11
      IF (NWGT.GT.NPTS) IER = -12
      IF (IER.LT.0) RETURN

      IF (NWGT.LE.1) THEN
          DO N = 1,NPTS
C historical reasons
              WORK(N) = X(N)
          END DO
          RETURN
      END IF

      NAV = NWGT
      NAV2 = NAV/2
      LWORK = NPTS + 2*NAV2
      NOE = 0
      IF (MOD(NWGT,2).EQ.0) NOE = 1

      DO N = 1,LWORK
C preset to xmsg
          WORK(N) = XMSG
      END DO

      DO N = 1,NPTS
C stuff x into middle of work
          WORK(NAV2+N) = X(N)
      END DO

      WSUM = 0.0D0
      DO N = 1,NWGT
          WSUM = WSUM + WGT(N)
      END DO
      IF (WSUM.GT.1.0D0) THEN
          WSUM = 1.D0/WSUM
      ELSE
C This is a "do nothing" op
          WSUM = 1.0D0
      END IF
C pad work with appropriate values

      IF (KOPT.GT.0) THEN
          DO N = 1,NAV2
              WORK(NAV2+1-N) = X(N+1)
              WORK(NPTS+NAV2+N) = X(NPTS-N)
          END DO
      ELSE IF (KOPT.LT.0) THEN
          DO N = 1,NAV2
              WORK(NAV2+1-N) = X(NPTS+1-N)
              WORK(NPTS+NAV2+N) = X(N)
          END DO
      END IF

      DO N = 1,NPTS
          KMSG = 0
          SUM = 0.D0
          NMID = N + NAV2 + NOE
          MSTRT = NMID - NAV2
          MLAST = MSTRT + NAV - 1
          DO M = MSTRT,MLAST
              IF (WORK(M).NE.XMSG) THEN
                  SUM = SUM + WORK(M)*WGT(M-MSTRT+1)
              ELSE
                  KMSG = KMSG + 1
              END IF
          END DO

          IF (KMSG.EQ.0) THEN
C all values
              X(N) = SUM*WSUM
          ELSE
C msg values encountered
              X(N) = XMSG
          END IF
      END DO

      RETURN
      END

      SUBROUTINE DSVDLAP(X,Y,LDXY,MRT,NCX,NCY,NSV,IFLAG,XYMSG,IPRNT,W,
     +                   LWK,PCVAR,HOMLFT,HOMRGT,HETLFT,HETRGT,
     +                   AK,BK,LAB,IER)

c perform a singular value decomposition on the data
c .   as described by Bretherton, Smith and Wallace.
c .   ------------ fortran 77 version --------------
c .   This uses the LAPACK routine "SGESVD"

c Nomenclature:

c .   x,y      - input data arrays (see "iflag" argument)
c .   ldxy     - leading dimensions of x/y in the calling program
C*PL*ERROR* Comment line too long
c .   mrt      - actual number of rows used. This refers to the time dimension
c .              mrt <= ldxy
c .   ncx,ncy  - number of columns for each array. This refers to the
c .              number of grid points or stations being used.
c .   nsv      - desired number of singular values or modes
c .              generally: nsv <= 3; must be nsv <= min(ncx,ncy)
c .   iflag    - flag to indicate if the data should be standardized
c .              if iflag=1 the input data arrays will be REPLACED with
c .              the standardized data.
c .   xymsg    - missing code
c .   iprnt    - print out many of the steps (for debugging)
c .   w        - work array. This array will be partitioned via
c .              pointers.
c .              upon return the first 4 elements of this array
c .              will contain information
c .              (fnorm, condition number, calculated rank, LAPACK error
c .               code)
c .   lwk      - length of work (let nsvmx = min(ncx,ncy) then   lwk >=
c .              ncx*ncy + nsvmx*ncx + nsvmx*ncy + mrt*ncx + mrt*ncy + nsvmx
c .            + max(3*nsvmx+max(ncx,ncy) , 5*nsvmx)
c .   pcvar    - percent variance explained by the modes (dimensioned
c .              nsv)
c .   ak(lab)  - output: expansion coeff
c .   bk(lab)  - output: expansion coeff
c .   homlft   - left  homogeneous array
c .   homrgt   - right homogeneous array
c .   hetlft   - left  heterogeneous array
c .   hetrgt   - right heterogeneous array
c .   ier      - error code

c Note: in many cases ldxy=mrt (Max Rows allocated for Time dimension)

      INTEGER LDXY,MRT,NCX,NCY,NSVMX,IFLAG,IPRNT,LWK,IER

      DOUBLE PRECISION X(LDXY,NCX),Y(LDXY,NCY),W(LWK,*),XYMSG

      DOUBLE PRECISION HOMLFT(NCX,NSV),HETLFT(NCX,NSV),HOMRGT(NCY,NSV),
     +                 HETRGT(NCY,NSV),PCVAR(NSV),AK(LAB),BK(LAB)

      IER = 0
      IF (MRT.GT.LDXY) IER = IER + 1
      IF (NCX.LT.1 .OR. NCY.LT.1 .OR. MRT.LT.1) IER = IER + 10

      NSVMX = MIN(NCX,NCY)

      LW = NCX*NCY + NSVMX*NCX + NSVMX*NCY + MRT*NCX + MRT*NCY + NSVMX +
     +     MAX(3*NSVMX+MAX(NCX,NCY),5*NSVMX)
      IF (LW.GT.LWK) IER = IER + 100
      IF (IER.NE.0) RETURN

c partition the work array. pointers to initial array location

      IPT1 = 1
      IPT2 = IPT1 + NCX*NCY
      IPT3 = IPT2 + NCX*NSVMX
      IPT4 = IPT3 + NSVMX*NCY
      IPT5 = IPT4 + NSVMX
      IPT6 = IPT5 + MRT*NCX
      IPT7 = IPT6 + MRT*NCY

      CALL DSVDLAPACK1(X,Y,LDXY,MRT,NCX,NCY,IFLAG,XYMSG,IPRNT,PCVAR,
     +                HOMLFT,HOMRGT,HETLFT,HETRGT,NSVMX,NSV,W(IPT1,1),
     +                W(IPT2,1),W(IPT3,1),W(IPT4,1),W(IPT5,1),W(IPT6,1),
     +                W(IPT7,1))
      W(1,1) = W(IPT7,1)
      W(2,1) = W(IPT7+1,1)
      W(3,1) = W(IPT7+2,1)
      W(4,1) = W(IPT7+3,1)
      IER = W(4,1)

C This returns the expansion coefficients.

      K  = 0
      K5 = IPT5-1 
      K6 = IPT6-1 
      DO N=1,NSV
         DO M=1,MRT
            K     = K + 1
            AK(K) = W(K5+K,1)
            BK(K) = W(K6+K,1)
         END DO
      END DO
      RETURN
      END
c -------------------------------------------------------------
      SUBROUTINE DSVDLAPACK1(X,Y,LDXY,MRT,NCX,NCY,IFLAG,XYMSG,IPRNT,
     +                      PCVAR,HOMLFT,HOMRGT,HETLFT,HETRGT,NSVMX,NSV,
     +                      CRV,U,VT,SV,AK,BK,WORK)
      DOUBLE PRECISION XBAR
      DOUBLE PRECISION XVAR
      DOUBLE PRECISION XDEV
      DOUBLE PRECISION YBAR
      DOUBLE PRECISION YVAR
      DOUBLE PRECISION YDEV
      DOUBLE PRECISION T
      DOUBLE PRECISION TOL
      DOUBLE PRECISION DEPSMACH
      DOUBLE PRECISION FNORM
      DOUBLE PRECISION CONDN
      DOUBLE PRECISION AMEAN
      DOUBLE PRECISION ASD
      DOUBLE PRECISION XMEAN
      DOUBLE PRECISION XSD
      DOUBLE PRECISION CCV
      DOUBLE PRECISION BMEAN
      DOUBLE PRECISION BSD
      DOUBLE PRECISION YMEAN
      DOUBLE PRECISION YSD

c see description of SVDLAPACK for a description

c nomenclature for new variables:
c .   crv      - cross covariance matrix between the standardized
c .              x and y data arrays.
c .   u        - left singular vector
c .   vt       - transpose right singular vector
c .   sv       - singular values
c .   ak, bk   - expansion coef
c .   work     - required by the lapack routine

      INTEGER LDXY,MRT,NCX,NCY,IFLAG,IPRNT,NSVMX,NSV

      DOUBLE PRECISION X(LDXY,NCX),Y(LDXY,NCY),XYMSG

      DOUBLE PRECISION HOMLFT(NCX,NSV),HETLFT(NCX,NSV),HOMRGT(NCY,NSV),
     +                 HETRGT(NCY,NSV),PCVAR(NSV)
      DOUBLE PRECISION U(NCX,NSVMX),VT(NSVMX,NCY),CRV(NCX,NCY),
     +                 SV(NSVMX),AK(MRT,NSVMX),BK(MRT,NSVMX),WORK(*)

      CHARACTER LABEL*80

c check for any columns (stations/grid points) that
c .   contain all missing data.

c if (iflag.eq.1) standardize the data
c .   1) compute time mean and st dev at each location (grid pt)
c .   2) subtract mean from each observation
c .   3) divide by the st dev

      DO NC = 1,NCX
          CALL DSTAT2(X(1,NC),MRT,XYMSG,XBAR,XVAR,XDEV,NXUSE,IER)
          IF (XDEV.EQ.XYMSG .OR. XDEV.EQ.0.D0) THEN
              WRITE (*,FMT=
     +'(''SVD: Warning all X values ''
     +  ''in column are missing or are constant'')')
          ELSE
              IF (IFLAG.EQ.1) THEN
                  DO MR = 1,MRT
                      IF (X(MR,NC).NE.XYMSG) THEN
                          X(MR,NC) = (X(MR,NC)-XBAR)/XDEV
                      END IF
                  END DO
              END IF
          END IF
      END DO

      DO NC = 1,NCY
          CALL DSTAT2(Y(1,NC),MRT,XYMSG,YBAR,YVAR,YDEV,NYUSE,IER)
          IF (YDEV.EQ.XYMSG .OR. YDEV.EQ.0.D0) THEN
              WRITE (*,FMT=
     +'(''SVD: Warning all Y values ''
     +  ''in column are missing or are constant'')')
          ELSE
              IF (IFLAG.EQ.1) THEN
                  DO MR = 1,MRT
                      IF (Y(MR,NC).NE.XYMSG) THEN
                          Y(MR,NC) = (Y(MR,NC)-YBAR)/YDEV
                      END IF
                  END DO
              END IF
          END IF
      END DO

      IF (IPRNT.EQ.1) THEN
          LABEL = '$'
          IF (IFLAG.EQ.1) LABEL = 'after standardization$'

          LLAB = INDEX(LABEL,'$')
          CALL DSVDPAR(X,LDXY,MRT,NCX,'SVDLAPACK: X '//LABEL(1:LLAB))
          CALL DSVDPAR(Y,LDXY,MRT,NCY,'SVD_PACK: Y '//LABEL(1:LLAB))
      END IF

c cross-covariance [xt]*[y]/T    [ dimension (ncx,ncy)]
c .   note the subscripts of "x" have been reversed
c .   to "simulate" the transpose

      T = DBLE(MRT)
      DO MR = 1,NCX
          DO NC = 1,NCY
              KNT = 0
              CRV(MR,NC) = 0.0D0
              DO MN = 1,MRT
                  IF (X(MN,MR).NE.XYMSG .AND. Y(MN,NC).NE.XYMSG) THEN
                      CRV(MR,NC) = CRV(MR,NC) + X(MN,MR)*Y(MN,NC)
                      KNT = KNT + 1
                  END IF
              END DO
              IF (KNT.GT.0) THEN
                  CRV(MR,NC) = CRV(MR,NC)/DBLE(KNT)
              END IF
          END DO
      END DO

      IF (IPRNT.EQ.1) CALL DSVDPAR(CRV,NCX,NCX,NCY,'SVDLAPACK: CRV$')

c lapack svd

      LWORK = MAX(3*NSVMX+MAX(NCX,NCY),5*MIN(NCX,NCY))

      CALL DGESVD('S','S',NCX,NCY,CRV,NCX,SV,U,NCX,VT,NSVMX,WORK,LWORK,
     +            MERR)

      TOL = 10.D0*DEPSMACH(0)
      CALL DSVDINFO(SV,NSVMX,NSV,TOL,FNORM,IRANK,CONDN,PCVAR)
      WORK(1) = FNORM
      WORK(2) = CONDN
      WORK(3) = IRANK
      WORK(4) = MERR

      IF (IPRNT.EQ.1) THEN
          NSVX = MIN(IRANK,NCY,NCX)
          WRITE (*,FMT='(/,''SVDLAPACK:  NSVMX,NSV,NSVX='',3i7)') NSVMX,
     +      NSV,NSVX
          WRITE (*,FMT=
     +'(/,''SVDLAPACK:  FNORM,CONDN,IRANK,NSV,MERR=''
     +     , 2f15.3,4i8)') FNORM,CONDN,IRANK,NSV,MERR
          CALL DSVDPVC(SV,NSV,'SVDLAPACK: Singular values$')
          CALL DSVDPVC(PCVAR,NSV,'SVDLAPACK: Percent Var Explained$')
          CALL DSVDPAR(U,NCX,NCX,NSVX,'SVDLAPACK: Left  SV [U]$')
          CALL DSVDPAR(VT,NSVX,NSVX,NCY,'SVDLAPACK: Right SV [VT]$')
      END IF

c calculate the expansion coef
c .   switch the subscripts to simulate the tranpose

      DO MR = 1,MRT
          DO K = 1,NSVMX
              AK(MR,K) = 0.0D0
              DO NC = 1,NCX
                  IF (X(MR,NC).NE.XYMSG) THEN
                      AK(MR,K) = AK(MR,K) + X(MR,NC)*U(NC,K)
                  END IF
              END DO
          END DO
      END DO

      DO MR = 1,MRT
          DO K = 1,NSVMX
              BK(MR,K) = 0.0D0
              DO NC = 1,NCY
                  IF (Y(MR,NC).NE.XYMSG) THEN
                      BK(MR,K) = BK(MR,K) + Y(MR,NC)*VT(K,NC)
                  END IF
              END DO
          END DO
      END DO
      IF (IPRNT.EQ.1) THEN
          CALL DSVDPAR(AK,MRT,MRT,NSV,'SVDLAPACK: Exp Coef: [AK]$')
          CALL DSVDPAR(BK,MRT,MRT,NSV,'SVDLAPACK: Exp Coef: [BK]$')
      END IF

c left and right homogeneous and heterogeneous correlations
c .   this could be done sleeker/faster but this is clear
c .   e.g., calculate the mean of ak, bk, x, y, then enter loops

      DO K = 1,NSV
          DO NC = 1,NCX
              AMEAN = XYMSG
              ASD = XYMSG
              XMEAN = XYMSG
              XSD = XYMSG
              CALL DESCROS(AK(1,K),X(1,NC),MRT,XYMSG,XYMSG,AMEAN,XMEAN,
     +                    ASD,XSD,0,CCV,HOMLFT(NC,K),IER)
              BMEAN = XYMSG
              BSD = XYMSG
              CALL DESCROS(BK(1,K),X(1,NC),MRT,XYMSG,XYMSG,BMEAN,XMEAN,
     +                    BSD,XSD,0,CCV,HETLFT(NC,K),IER)
          END DO

          DO NC = 1,NCY
              AMEAN = XYMSG
              ASD = XYMSG
              YMEAN = XYMSG
              YSD = XYMSG
              CALL DESCROS(AK(1,K),Y(1,NC),MRT,XYMSG,XYMSG,AMEAN,YMEAN,
     +                    ASD,YSD,0,CCV,HETRGT(NC,K),IER)
              BMEAN = XYMSG
              BSD = XYMSG
              CALL DESCROS(BK(1,K),Y(1,NC),MRT,XYMSG,XYMSG,BMEAN,YMEAN,
     +                    BSD,YSD,0,CCV,HOMRGT(NC,K),IER)
          END DO
      END DO

      IF (IPRNT.EQ.1) THEN
          CALL DSVDPAR(HOMLFT,NCX,NCX,NSV,'SVDLAPACK: [HOMLFT]$')
          CALL DSVDPAR(HETLFT,NCX,NCX,NSV,'SVDLAPACK: [HETLFT]$')
          CALL DSVDPAR(HOMRGT,NCY,NCY,NSV,'SVDLAPACK: [HOMRGT]$')
          CALL DSVDPAR(HETRGT,NCY,NCY,NSV,'SVDLAPACK: [HETRGT]$')
      END IF

      RETURN
      END

      SUBROUTINE DSVDSV(X,Y,LDXY,MRT,NCX,NCY,NSV,IFLAG,XYMSG,IPRNT,SVL,
     +                  SVR,PCVAR,CRV,U,VT,SV,NSVMX,WORK,LWORK,IER)
      INTEGER LDXY,MRT,NCX,NCY,NSVMX,IFLAG,IPRNT,LWORK,IER
      DOUBLE PRECISION CRV(NCX,NCY)
      DOUBLE PRECISION U(NCX,NSVMX)
      DOUBLE PRECISION VT(NSVMX,NCY)
      DOUBLE PRECISION WORK(LWORK)
      DOUBLE PRECISION SV(NSVMX)


C NCL: svl = new ( (/nsvd,ncy/), float)   ; left  sing vactor
C NCL: svr = new ( (/nsvd,ncx/), float)   ; right sing vector
C NCL: pcv = svdcov (x,y,nsvd,svl,svr)

c perform a singular value decomposition on the data
c .   return the left and right singular vectors

c Nomenclature:

c .   x,y      - input data arrays (see "iflag" argument)
c .   ldxy     - leading dimensions of x/y in the calling program
C*PL*ERROR* Comment line too long
c .   mrt      - actual number of rows used. This refers to the time dimension
c .              mrt <= ldxy
c .   ncx,ncy  - number of columns for each array. This refers to the
c .              number of grid points or stations being used.
c .   nsv      - desired number of singular values or modes
c .              generally: nsv <= 3; must be nsv <= min(ncx,ncy)
c .   iflag    - flag to indicate if the data should be standardized
c .              if iflag=1 the input data arrays will be REPLACED with
c .              the standardized data.
c .   xymsg    - missing code
c .   iprnt    - print out many of the steps (for debugging)
c .   svl/r    - left and right singular vectors
C*PL*ERROR* Comment line too long
c .   pcvar    - percent variance explained by the modes (dimensioned nsv)
c .   ier      - error code

c Note: in many cases ldxy=mrt (Max Rows allocated for Time dimension)


      DOUBLE PRECISION X(LDXY,NCX),Y(LDXY,NCY),XYMSG

      DOUBLE PRECISION SVL(NCX,NSV),SVR(NCY,NSV),PCVAR(NSV)
C NCLEND

      IER = 0
      IF (MRT.GT.LDXY) IER = IER + 1
      IF (NCX.LT.1 .OR. NCY.LT.1 .OR. MRT.LT.1) IER = IER + 10

      CALL DSVDLAPSV(X,Y,LDXY,MRT,NCX,NCY,IFLAG,XYMSG,IPRNT,PCVAR,NSVMX,
     +               NSV,CRV,U,VT,SV,WORK)

      DO NS = 1,NSV
c          PRINT *,' LOOP: ns=',NS
          DO NC = 1,NCX
c              PRINT *,' SVL LOOP: nc=',NC
              SVL(NC,NS) = U(NC,NS)
          END DO
c          PRINT *,'AFTER  dsvdlapsv: SVL'

          DO NC = 1,NCY
c              PRINT *,' SVR LOOP: nc=',NC
              SVR(NC,NS) = VT(NS,NC)
          END DO
c          PRINT *,'AFTER  dsvdlapsv: SVR'

      END DO

      RETURN
      END
c -------------------------------------------------------------
      SUBROUTINE DSVDLAPSV(X,Y,LDXY,MRT,NCX,NCY,IFLAG,XYMSG,IPRNT,PCVAR,
     +                     NSVMX,NSV,CRV,U,VT,SV,WORK)
      DOUBLE PRECISION XBAR
      DOUBLE PRECISION XVAR
      DOUBLE PRECISION XDEV
      DOUBLE PRECISION YBAR
      DOUBLE PRECISION YVAR
      DOUBLE PRECISION YDEV
      DOUBLE PRECISION T
      DOUBLE PRECISION TOL
      DOUBLE PRECISION DEPSMACH
      DOUBLE PRECISION FNORM
      DOUBLE PRECISION CONDN

c see description of SVD_LAPACK for a description

c nomenclature for new variables:
c .   crv      - cross covariance matrix between the standardized
c .              x and y data arrays.
c .   u        - left singular vector
c .   vt       - transpose right singular vector
c .   sv       - singular values
c .   work     - required by the lapack routine

      INTEGER LDXY,MRT,NCX,NCY,IFLAG,IPRNT,NSVMX,NSV

      DOUBLE PRECISION X(LDXY,NCX),Y(LDXY,NCY),XYMSG

      DOUBLE PRECISION PCVAR(NSV)

      DOUBLE PRECISION U(NCX,NSVMX),VT(NSVMX,NCY),CRV(NCX,NCY),
     +                 SV(NSVMX),WORK(*)

      CHARACTER LABEL*80

c check for any columns (stations/grid points) that
c .   contain all missing data.

c if (iflag.eq.1) standardize the data
c .   1) compute time mean and st dev at each location (grid pt)
c .   2) subtract mean from each observation
c .   3) divide by the st dev

      DO NC = 1,NCX
          CALL DSTAT2(X(1,NC),MRT,XYMSG,XBAR,XVAR,XDEV,NXUSE,IER)
          IF (XDEV.EQ.XYMSG .OR. XDEV.EQ.0.D0) THEN
              WRITE (*,FMT=
     +'(''SVD: Warning all X values ''
     +  ''in column are missing or are constant'')')
          ELSE
              IF (IFLAG.EQ.1) THEN
                  DO MR = 1,MRT
                      IF (X(MR,NC).NE.XYMSG) THEN
                          X(MR,NC) = (X(MR,NC)-XBAR)/XDEV
                      END IF
                  END DO
              END IF
          END IF
      END DO

      DO NC = 1,NCY
          CALL DSTAT2(Y(1,NC),MRT,XYMSG,YBAR,YVAR,YDEV,NYUSE,IER)
          IF (YDEV.EQ.XYMSG .OR. YDEV.EQ.0.D0) THEN
              WRITE (*,FMT=
     +'(''SVD: Warning all Y values ''
     +  ''in column are missing or are constant'')')
          ELSE
              IF (IFLAG.EQ.1) THEN
                  DO MR = 1,MRT
                      IF (Y(MR,NC).NE.XYMSG) THEN
                          Y(MR,NC) = (Y(MR,NC)-YBAR)/YDEV
                      END IF
                  END DO
              END IF
          END IF
      END DO

      IF (IPRNT.GT.1) THEN
          LABEL = '$'
          IF (IFLAG.EQ.1) LABEL = 'after standardization$'

          LLAB = INDEX(LABEL,'$')
          CALL DSVDPAR(X,LDXY,MRT,NCX,'SVD_LAPACK: X '//LABEL(1:LLAB))
          CALL DSVDPAR(Y,LDXY,MRT,NCY,'SVD_PACK: Y '//LABEL(1:LLAB))
      END IF

c cross-covariance [xt]*[y]/T    [ dimension (ncx,ncy)]
c .   note the subscripts of "x" have been reversed
c .   to "simulate" the transpose

      T = DBLE(MRT)
      DO MR = 1,NCX
          DO NC = 1,NCY
              KNT = 0
              CRV(MR,NC) = 0.0D0
              DO MN = 1,MRT
                  IF (X(MN,MR).NE.XYMSG .AND. Y(MN,NC).NE.XYMSG) THEN
                      CRV(MR,NC) = CRV(MR,NC) + X(MN,MR)*Y(MN,NC)
                      KNT = KNT + 1
                  END IF
              END DO
              IF (KNT.GT.0) THEN
                  CRV(MR,NC) = CRV(MR,NC)/DBLE(KNT)
              END IF
          END DO
      END DO

      IF (IPRNT.GT.1) CALL DSVDPAR(CRV,NCX,NCX,NCY,'SVD_LAPACK: CRV$')

c lapack svd

      LWORK = MAX(3*NSVMX+MAX(NCX,NCY),5*MIN(NCX,NCY))

      CALL DGESVD('S','S',NCX,NCY,CRV,NCX,SV,U,NCX,VT,NSVMX,WORK,LWORK,
     +            MERR)

      TOL = 10.D0*DEPSMACH(0)
      CALL DSVDINFO(SV,NSVMX,NSV,TOL,FNORM,IRANK,CONDN,PCVAR)
      WORK(1) = FNORM
      WORK(2) = CONDN
      WORK(3) = IRANK
      WORK(4) = MERR

      IF (IPRNT.EQ.1) THEN
          NSVX = MIN(IRANK,NCY,NCX)
          WRITE (*,FMT='(/,''SVD_LAPACK_SV:  NSVMX,NSV,NSVX='',3i7)')
     +      NSVMX,NSV,NSVX
          WRITE (*,FMT=
     +'(/,''SVD_LAPACK_SV:  FNORM,CONDN,IRANK,NSV,MERR=''
     +     , 2(1x,e15.7),3i8)') FNORM,CONDN,IRANK,NSV,MERR
          CALL DSVDPVC(SV,NSV,'SVD_LAPACK_SV: Singular values$')
          CALL DSVDPVC(PCVAR,NSV,'SVD_LAPACK_SV: PercentVar Explained$ '
     +                 )
c         call dsvdpar (u ,ncx,ncx,nsvx,'SVD_LAPACK_SV: Left  SV [U]$')
C*PL*ERROR* Comment line too long
c         call dsvdpar (vt,nsvx,nsvx,ncy,'SVD_LAPACK_SV: Right SV [VT]$')
      END IF

      RETURN
      END

C
C $Id: naskln.f,v 1.4 2008-07-27 03:11:53 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE NASKLN(IUNIT,LINE)
C
C  Return the next non-comment line on IUNIT in LINE.
C
      CHARACTER*80 LINE
C
    5 CONTINUE
      READ(IUNIT,100,END=200) LINE
  100 FORMAT(A80)
      IF (LINE(1:2) .EQ. '/*') GO TO 5
C
      RETURN
  200 CONTINUE
      WRITE(6,500)
  500 FORMAT(' Unexpected end of file on input')
      STOP
C
      END

      PROGRAM CTORCA
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.  Use one
C of the following:
C
C       PARAMETER (IERF=6,LUNI=2,IWTY=1 ,IWID=1)  !  NCGM
C       PARAMETER (IERF=6,LUNI=2,IWTY=8 ,IWID=1)  !  X Windows
C       PARAMETER (IERF=6,LUNI=2,IWTY=20,IWID=1)  !  PostScript
C       PARAMETER (IERF=6,LUNI=2,IWTY=11,IWID=1)  !  PDF, Portrait
C       PARAMETER (IERF=6,LUNI=2,IWTY=12,IWID=1)  !  PDF, Landscape
C
        PARAMETER (IERF=6,LUNI=2,IWTYPE=1,IWTY=IWTYPE,IWID=1)
C
C The object of this program is to produce a set of plots illustrating
C the use of a triangular mesh to represent an ORCA grid on the surface
C of the globe.  The triangular mesh is created from the rectangular
C grid by calling the CONPACKT routine CTTMRG.
C
C Selected frames are drawn for each of four different viewpoints.  If
C (CLAT,CLON) is the approximate position of the "center point" of the
C mesh (which is defined somewhat arbitrarily for certain meshes), the
C four viewpoints used are as follows: (CLAT+45,CLON), (CLAT-45,CLON),
C (CLAT+45,CLON+180), and (CLAT-45,CLON+180).
C
C At each of the four viewpoints, up to six different frames are drawn:
C
C   1) A frame that attempts to show how the original rectangular
C      grid is mapped onto the globe.  A little reference image of
C      the rectangular grid appears in the lower left corner of the
C      frame and a large image of the grid wrapped around the globe
C      appears in the middle of the frame.  Each image is colored using
C      a 10x10 rectangular array of different colors and, on each, the
C      corner points, the midpoints of the edges and the midpoint of
C      the whole grid are marked.  This frame is drawn only if the
C      parameter IMSH = 1, 3, 5, or 7.
C
C   2) A frame showing the original rectangular grid on the globe.
C      This frame is drawn only if the parameter IMSH = 2, 3, 6, or 7.
C
C   3) A frame showing the triangular mesh on the globe.  This frame
C      is drawn only if the parameter IMSH = 4, 5, 6, or 7.
C
C   4) A frame showing simple contours on the globe.  This frame is
C      drawn only if the parameter ICON is non-zero.
C
C   5) A frame showing color-filled contour bands on the globe, drawn
C      using filled areas.  This frame is drawn only if the parameter
C      ICOL is non-zero.
C
C   6) A frame showing color-filled contour bands on the globe, drawn
C      using a cell array.  This frame is drawn only if the parameter
C      ICAP is non-zero.
C
C Define the parameter that says which frames showing the rectangular
C grid and/or the triangular mesh are to be drawn (frames 1 through 3):
C
C       PARAMETER (IMSH=0)  !  none of the three
C       PARAMETER (IMSH=1)  !  colored rectangular grid only
C       PARAMETER (IMSH=2)  !  simple rectangular grid only
C       PARAMETER (IMSH=3)  !  colored and simple rectangular grids
C       PARAMETER (IMSH=4)  !  triangular only
C       PARAMETER (IMSH=5)  !  colored rectangular and triangular
C       PARAMETER (IMSH=6)  !  simple rectangular and triangular
C       PARAMETER (IMSH=7)  !  all three
C
        PARAMETER (IMSH=7)
C
C Define the parameter that says whether or not to draw simple contours
C (frame 4):
C
C       PARAMETER (ICON=0)  !  contours not drawn
C       PARAMETER (ICON=1)  !  contours drawn
C
        PARAMETER (ICON=1)
C
C Define the parameter that says whether or not to draw color-filled
C contours (frame 5):
C
C       PARAMETER (ICOL=0)  !  no color fill done
C       PARAMETER (ICOL=1)  !  color fill done
C
        PARAMETER (ICOL=1)
C
C Define the parameter that says whether or not to draw a cell array
C plot (frame 6):
C
C       PARAMETER (ICAP=0)  !  cell array plot not drawn
C       PARAMETER (ICAP=1)  !  cell array plot drawn
C
        PARAMETER (ICAP=1)
C
C To represent the triangular mesh, we use three singly-dimensioned
C arrays: RPNT holds points, IEDG holds edges, and ITRI holds triangles.
C The elements of each array form "nodes" having lengths as follows:
C
        PARAMETER (LOPN=5)
C
C The five elements of a point node are
C
C   1. the X coordinate of the point;
C   2. the Y coordinate of the point;
C   3. the Z coordinate of the point;
C   4. the field value at the point;
C   5. any additional value desired by the user.
C
        PARAMETER (LOEN=5)
C
C The five elements of an edge node are
C
C   1. the base index, in RPNT, of point 1 of the edge;
C   2. the base index, in RPNT, of point 2 of the edge;
C   3. the index, in ITRI, of the pointer to the edge in the triangle to
C      the left of the edge (-1 if there is no triangle to the left);
C   4. the index, in ITRI, of the pointer to the edge in the triangle to
C      the right of the edge (-1 if there is no triangle to the right);
C   5. a utility flag for use by algorithms that scan the structure.
C
C The "left" and "right" sides of an edge are defined as they would be
C by an observer standing on the globe at point 1 of the edge, looking
C toward point 2 of the edge.  It is possible, if there are "holes" in
C the mesh, that there will be no triangle to the left or to the right
C of an edge, but there must be a triangle on one side or the other.
C
        PARAMETER (LOTN=4)
C
C The four elements of a triangle node are
C
C   1. the base index, in IEDG, of edge 1 of the triangle;
C   2. the base index, in IEDG, of edge 2 of the triangle;
C   3. the base index, in IEDG, of edge 3 of the triangle;
C   4. a flag set non-zero to block use of the triangle, effectively
C      removing it from the mesh.
C
C The "base index" of a point node, an edge node, or a triangle node is
C always a multiple of the length of the node, to which can be added an
C offset to get the index of a particular element of the node.  For
C example, if I is the base index of a triangle of interest, ITRI(I+1)
C is its first element (the base index of its first edge).  Similarly,
C IEDG(ITRI(I+1)+2) is the base index of the second point of the first
C edge of the triangle with base index I, and RPNT(IEDG(ITRI(I+1)+2)+3)
C is the third (Z) coordinate of the second point of the first edge of
C the triangle with base index I.
C
C It is the pointers from the edge nodes back to the triangle nodes that
C allow CONPACKT to navigate the mesh, moving from triangle to triangle
C as it follows a contour line, but these pointers are tricky to define:
C if IPTE is the base index of an edge node and IEDG(IPTE+3) is zero or
C more, saying that there is a triangle to the left of the edge, then
C IEDG(IPTE+3) is the actual index of that element of the triangle node
C that points to the edge node; i.e., ITRI(IEDG(IPTE+3))=IPTE.  The base
C index of the triangle node defining that triangle is IPTT, where
C IPTT=LOTN*((IEDG(IPTE+3)-1)/LOTN), and the index of the pointer to
C the edge within the triangle node is IPTI=IEDG(IPTE+3)-IPTT, so that
C ITRI(IPTT+IPTI)=IPTE.  Similar comments apply to element 4 of an edge
C node, which points into the triangle node defining the triangle to the
C right of the edge.
C
C The maximum numbers of points, edges, and triangles in a triangular
C mesh can be computed in the following manner:  Since the triangular
C mesh is created from a rectangular one by splitting each rectangular
C cell in half, we can declare the largest values we expect to use for
C the dimensions of that mesh:
C
        PARAMETER (IDIM=181,JDIM=148,IDM1=IDIM-1,JDM1=JDIM-1)
C
C and then compute from those values the maximum number of points,
C edges, and triangles that the triangular mesh arrays will need to
C hold.  The computed values will be exactly as required if no points
C or edges of the rectangular grid are repeated in it; if there are
C repeating points or edges, space for slightly fewer points and edges
C will be needed:
C
        PARAMETER (MNOP=IDIM*JDIM)
        PARAMETER (MNOE=3*IDM1*JDM1+IDM1+JDM1)
        PARAMETER (MNOT=2*IDM1*JDM1)
C
C Once we know how many points, edges, and triangles we're going to use
C (at most), we can set parameters defining the space reserved for the
C triangular mesh:
C
        PARAMETER (MPNT=MNOP*LOPN)
        PARAMETER (MEDG=MNOE*LOEN)
        PARAMETER (MTRI=MNOT*LOTN)
C
C Declare the arrays to hold the point nodes, edge nodes, and triangle
C nodes defining the triangular mesh.
C
        DIMENSION RPNT(MPNT),IEDG(MEDG),ITRI(MTRI)
C
C Declare real and integer workspaces needed by CONPACKT.
C
        PARAMETER (LRWK=10000,LIWK=1000)
C
        DIMENSION RWRK(LRWK),IWRK(LIWK)
C
C Declare the area map array needed to do solid fill.
C
        PARAMETER (LAMA=200000)
C
        DIMENSION IAMA(LAMA)
C
C Declare workspace arrays to be used in calls to ARSCAM.
C
        PARAMETER (NCRA=LAMA/10,NGPS=2)
C
        DIMENSION XCRA(NCRA),YCRA(NCRA),IAAI(NGPS),IAGI(NGPS)
C
C Declare arrays in which to generate a cell array picture of the
C data on the triangular mesh.
C
C       PARAMETER (ICAM=1024,ICAN=1024)
        PARAMETER (ICAM= 512,ICAN= 512)
C
        DIMENSION ICRA(ICAM,ICAN)
C
C Declare arrays to hold color components for colors to be used at the
C four corners of an illustrative drawing of the rectangular grid.
C
        DIMENSION CCLL(3),CCLR(3),CCUL(3),CCUR(3)
C
C Declare external the routine that draws masked contour lines.
C
        EXTERNAL DRWMCL
C
C Declare external the routine that does color fill of contour bands.
C
        EXTERNAL DCFOCB
C
C Define a common block in which to keep track of the maximum space used
C in the arrays XCRA and YCRA.
C
        COMMON /COMONA/ MAXN
C
C Define the out-of-range flag.
C
        DATA OORV / 1.E12 /
C
C Define the tension on the splines to be used in smoothing contours.
C
C       DATA T2DS / 0.0 /  !  smoothing off
C       DATA T2DS / 2.5 /  !  smoothing on
C
        DATA T2DS / 0.0 /
C
C Define the distance between points on smoothed contour lines.
C
        DATA RSSL / .002 /
C
C Define the amount of real workspace to be used in drawing contours.
C
        DATA IRWC / 500 /
C
C Define the label-positioning flag.
C
C       DATA ILLP / 0 /  !  no labels
C       DATA ILLP / 1 /  !  dash-package writes labels
C       DATA ILLP / 2 /  !  regular scheme
C       DATA ILLP / 3 /  !  penalty scheme
C
        DATA ILLP / 2 /
C
C Define the high/low search radius.
C
        DATA HLSR / .075 /
C
C Define the high/low label overlap flag.
C
        DATA IHLO / 11 /
C
C Define the hachuring flag, hachure length, and hachure spacing.
C
C       DATA IHCF,HCHL,HCHS /  0 , +.004 , .010 /  !  off
C       DATA IHCF,HCHL,HCHS / +1 , -.004 , .020 /  !  on, all, uphill
C
        DATA IHCF,HCHL,HCHS /  0 , +.004 , .010 /
C
C Define the colors to be used in the lower left, lower right, upper
C left, and upper right corners of the rectangular grid when a drawing
C of it is made for the purpose of illustrating how it is wrapped around
C the globe.
C
        DATA CCLL / 0.2 , 0.2 , 0.2 /
        DATA CCLR / 1.0 , 0.0 , 1.0 /
        DATA CCUL / 0.0 , 1.0 , 1.0 /
        DATA CCUR / 1.0 , 1.0 , 0.0 /
C
C Define a constant to convert from radians to degrees.
C
        DATA RTOD / 57.2957795130823 /
C
C Read data and generate the required triangular mesh.
C
        PRINT * , ' '
        PRINT * , 'CREATING TRIANGULAR MESH:'
C
        CALL GTORCA (RPNT,MPNT,NPNT,LOPN,
     +               IEDG,MEDG,NEDG,LOEN,
     +               ITRI,MTRI,NTRI,LOTN,
     +               CLAT,CLON)
C
C Print the number of points, edges, and triangles.
C
        PRINT * , '  NUMBER OF POINTS:    ',NPNT/LOPN
        PRINT * , '  NUMBER OF EDGES:     ',NEDG/LOEN
        PRINT * , '  NUMBER OF TRIANGLES: ',NTRI/LOTN
C
C Write the contents of the point list, the edge list, and the triangle
C list to "fort.11" in a readable form.
C
c       WRITE (11,'(''P'',I8,5F10.4)')
c    +        (I,RPNT(I+1),RPNT(I+2),RPNT(I+3),RPNT(I+4),RPNT(I+5),
c    +                                               I=0,NPNT-LOPN,LOPN)
c       WRITE (11,'(''E'',I8,5I10)')
c    +        (I,IEDG(I+1),IEDG(I+2),IEDG(I+3),IEDG(I+4),IEDG(I+5),
c    +                                               I=0,NEDG-LOEN,LOEN)
c       WRITE (11,'(''T'',I8,4I10)')
c    +        (I,ITRI(I+1),ITRI(I+2),ITRI(I+3),ITRI(I+4),
c    +                                               I=0,NTRI-LOTN,LOTN)
C
C Open GKS.
C
        PRINT * , 'OPENING AND INITIALIZING GKS'
C
        CALL GOPKS (IERF,0)
        CALL GOPWK (IWID,LUNI,IWTY)
        CALL GACWK (IWID)
C
C Turn off the clipping indicator.
C
        CALL GSCLIP (0)
C
C Define a basic set of colors (0 = white, background; 1 = black,
C foreground; 2 = yellow; 3 = magenta; 4 = red; 5 = cyan; 6 = green;
C 7 = blue; 8 = darker light gray; 9 = lighter light gray; 10 = dark
C yellow; 11 = dark gray; 12 = medium gray; 13 = light red, for
C geographic lines; 14 = light blue, for lat/lon lines).
C
        CALL GSCR   (IWID, 0,1.,1.,1.)
        CALL GSCR   (IWID, 1,0.,0.,0.)
        CALL GSCR   (IWID, 2,1.,1.,0.)
        CALL GSCR   (IWID, 3,1.,0.,1.)
        CALL GSCR   (IWID, 4,1.,0.,0.)
        CALL GSCR   (IWID, 5,0.,1.,1.)
        CALL GSCR   (IWID, 6,0.,1.,0.)
        CALL GSCR   (IWID, 7,0.,0.,1.)
        CALL GSCR   (IWID, 8,.5,.5,.5)
        CALL GSCR   (IWID, 9,.8,.8,.8)
        CALL GSCR   (IWID,10,.3,.3,0.)
        CALL GSCR   (IWID,11,.3,.3,.3)
        CALL GSCR   (IWID,12,.5,.5,.5)
        CALL GSCR   (IWID,13,.8,.5,.5)
        CALL GSCR   (IWID,14,.5,.5,.8)
C
C Define 100 colors, associated with color indices 51 through 150, to
C be used in making an illustrative drawing of the rectangular grid.
C
        CALL DCFGRD (IWID,51,10,10,CCLL,CCLR,CCUL,CCUR)
C
C Define 100 colors, associated with color indices 151 through 250, to
C be used for color-filled contour bands and in cell arrays, ranging
C from blue to red.
C
        CALL DFCLRS (IWID,151,250,0.,0.,1.,1.,0.,0.)
C
C Set parameters in the utilities.
C
        PRINT * , 'SETTING PARAMETERS IN CONPACKT, EZMAP, AND PLOTCHAR'
C
C Set the mapping flag.
C
        CALL CTSETI ('MAP - MAPPING FLAG',1)
C
C Set the out-of-range flag value.
C
        CALL CTSETR ('ORV - OUT-OF-RANGE VALUE',OORV)
C
C Turn on the drawing of the mesh edge and set the area identifier for
C areas outside the mesh.
C
        CALL CTSETI ('PAI - PARAMETER ARRAY INDEX',-1)
        CALL CTSETI ('CLU - CONTOUR LEVEL USE FLAG',1)
        CALL CTSETI ('AIA - AREA IDENTIFIER FOR AREA',1001)
C
C Set the area identifier for areas in "out-of-range" areas.
C
C       CALL CTSETI ('PAI',-2)
C       CALL CTSETI ('AIA - AREA IDENTIFIER FOR AREA',1002)
C
C Set the 2D smoother flag.
C
        CALL CTSETR ('T2D - TENSION ON 2D SPLINES',T2DS)
C
C Set the distance between points on smoothed lines.
C
        CALL CTSETR ('SSL - SMOOTHED SEGMENT LENGTH',RSSL)
C
C Set the amount of real workspace to be used in drawing contours.
C
        CALL CTSETI ('RWC - REAL WORKSPACE FOR CONTOURS',IRWC)
C
C Set the label-positioning flag.
C
        CALL CTSETI ('LLP - LINE LABEL POSITIONING FLAG',ILLP)
C
C Set the high/low search radius.
C
        CALL CTSETR ('HLR - HIGH/LOW SEARCH RADIUS',HLSR)
C
C Set the high/low label overlap flag.
C
        CALL CTSETI ('HLO - HIGH/LOW LABEL OVERLAP FLAG',IHLO)
C
C Set the hachuring flag, hachure length, and hachure spacing.
C
        CALL CTSETI ('HCF - HACHURING FLAG',IHCF)
        CALL CTSETR ('HCL - HACHURE LENGTH',HCHL)
        CALL CTSETR ('HCS - HACHURE SPACING',HCHS)
C
C Set the cell array flag.
C
        CALL CTSETI ('CAF - CELL ARRAY FLAG',-1)
C
C Tell CONPACKT not to do its own call to SET, since EZMAP will have
C done it.
C
        CALL CTSETI ('SET - DO-SET-CALL FLAG', 0)
C
C Move the informational label up a little.
C
        CALL CTSETR ('ILY - INFORMATIONAL LABEL Y POSITION',-.005)
C
C Tell EZMAP not to draw the perimeter.
C
        CALL MPSETI ('PE',0)
C
C Tell EZMAP to use solid lat/lon lines.
C
        CALL MPSETI ('DA',65535)
C
C Tell PLOTCHAR to use one of the filled fonts and to outline each
C character.
C
        CALL PCSETI ('FN',25)
        CALL PCSETI ('OF',1)
C
C Tell PLOTCHAR to expect a character other than a colon as the
C function-control signal character.
C
        CALL PCSETC ('FC','|')
C
C Loop through four different viewing angles.
C
        DO 104 IDIR=1,4
C
          PRINT * , ' '
          PRINT * , 'VIEW FROM DIRECTION NUMBER: ',IDIR
C
C Tell EZMAP what projection to use and what its limits are.
C
          IF      (IDIR.EQ.1) THEN
            CALL MAPROJ ('OR',CLAT+45.,CLON,      0.)
          ELSE IF (IDIR.EQ.2) THEN
            CALL MAPROJ ('OR',CLAT-45.,CLON,      0.)
          ELSE IF (IDIR.EQ.3) THEN
            CALL MAPROJ ('OR',CLAT+45.,CLON+180., 0.)
          ELSE IF (IDIR.EQ.4) THEN
            CALL MAPROJ ('OR',CLAT-45.,CLON+180., 0.)
          END IF
C
          CALL MAPSET ('MA',0.,0.,0.,0.)
C
C Initialize EZMAP.
C
          CALL MAPINT
C
C If the rectangular grid and/or the triangular mesh are to be drawn,
C do it.
C
          IF (IMSH.NE.0) THEN
C
            PRINT * , 'DRAWING MESHES'
C
C Colored rectangular grid:
C
            IF (MOD(IMSH,2).NE.0) THEN
C
              PRINT * , 'DRAWING COLORED RECTANGULAR GRID'
C
              CALL DCORCA
C
C Label the first frame.
C
              CALL PLCHHQ (CFUX(.03),CFUY(.946),'ORCA GRID',.024,0.,-1.)
C
              IF      (IDIR.EQ.1) THEN
                CALL PLCHHQ (CFUX(.47),CFUY(.82),
     +                       'The top edge of the grid maps to a',
     +                                                       .010,0.,1.)
                CALL PLCHHQ (CFUX(.47),CFUY(.80),
     +                       'line passing through the North Pole.',
     +                                                       .010,0.,1.)
                CALL PLCHHQ (CFUX(.64),CFUY(.75),
     +                       'Portions of the grid over Asia and',
     +                                                      .010,0.,-1.)
                CALL PLCHHQ (CFUX(.64),CFUY(.73),
     +                       'Africa are shifted to provide better',
     +                                                      .010,0.,-1.)
                CALL PLCHHQ (CFUX(.64),CFUY(.71),
     +                       'coverage of various bodies of water.',
     +                                                      .010,0.,-1.)
                CALL PLCHHQ (CFUX(.64),CFUY(.69),
     +                       '(See viewpoint 3 for a better view.)',
     +                                                      .010,0.,-1.)
              ELSE IF (IDIR.EQ.2) THEN
                CALL PLCHHQ (CFUX(.53),CFUY(.30),
     +                       'The bottom edge of the grid maps',
     +                                                      .010,0.,-1.)
                CALL PLCHHQ (CFUX(.53),CFUY(.28),
     +                       'to a circle around the South Pole.',
     +                                                      .010,0.,-1.)
              ELSE IF (IDIR.EQ.3) THEN
                CALL PLCHHQ (CFUX(.53),CFUY(.77),
     +                       'The top edge of the grid maps to a',
     +                                                      .010,0.,-1.)
                CALL PLCHHQ (CFUX(.53),CFUY(.75),
     +                       'line passing through the North Pole.',
     +                                                      .010,0.,-1.)
                CALL PLCHHQ (CFUX(.40),CFUY(.45),
     +                       'Portions of the grid over Asia and',
     +                                                      .010,0.,-1.)
                CALL PLCHHQ (CFUX(.40),CFUY(.43),
     +                       'Africa are shifted to provide better',
     +                                                      .010,0.,-1.)
                CALL PLCHHQ (CFUX(.40),CFUY(.41),
     +                       'coverage of various bodies of water.',
     +                                                      .010,0.,-1.)
                CALL PLCHHQ (CFUX(.53),CFUY(.27),
     +                       'Left and right edges of',
     +                                                      .010,0.,-1.)
                CALL PLCHHQ (CFUX(.53),CFUY(.25),
     +                       'the grid map to a "seam"',
     +                                                      .010,0.,-1.)
                CALL PLCHHQ (CFUX(.53),CFUY(.23),
     +                       'on one of the meridians.',
     +                                                      .010,0.,-1.)
              ELSE IF (IDIR.EQ.4) THEN
                CALL PLCHHQ (CFUX(.40),CFUY(.82),
     +                       'Portions of the grid over Asia and',
     +                                                       .010,0.,1.)
                CALL PLCHHQ (CFUX(.40),CFUY(.80),
     +                       'Africa are shifted to provide better',
     +                                                       .010,0.,1.)
                CALL PLCHHQ (CFUX(.40),CFUY(.78),
     +                       'coverage of various bodies of water.',
     +                                                       .010,0.,1.)
                CALL PLCHHQ (CFUX(.40),CFUY(.76),
     +                       '(See viewpoint 3 for a better view.)',
     +                                                       .010,0.,1.)
                CALL PLCHHQ (CFUX(.47),CFUY(.37),
     +                       'The bottom edge of the grid maps',
     +                                                       .010,0.,1.)
                CALL PLCHHQ (CFUX(.47),CFUY(.35),
     +                       'to a circle around the South Pole.',
     +                                                       .010,0.,1.)
                CALL PLCHHQ (CFUX(.53),CFUY(.62),
     +                       'Left and right edges of',
     +                                                      .010,0.,-1.)
                CALL PLCHHQ (CFUX(.53),CFUY(.60),
     +                       'the grid map to a "seam"',
     +                                                      .010,0.,-1.)
                CALL PLCHHQ (CFUX(.53),CFUY(.58),
     +                       'on one of the meridians.',
     +                                                      .010,0.,-1.)
              END IF
C
              IF      (IDIR.EQ.1) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 1',
     +                                                      .012,0.,-1.)
              ELSE IF (IDIR.EQ.2) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 2',
     +                                                      .012,0.,-1.)
              ELSE IF (IDIR.EQ.3) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 3',
     +                                                      .012,0.,-1.)
              ELSE IF (IDIR.EQ.4) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 4',
     +                                                      .012,0.,-1.)
              END IF
C
              CALL PLCHHQ (CFUX(.97),CFUY(.950),'MAPPING OF THE GRID',
     +                                                       .012,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.926),'ONTO THE GLOBE',
     +                                                       .012,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.904),'(Color swatches, bold'
     +                                                      ,.010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.884),'edges, and big dots',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.864),'are all intended',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.844),'to clarify the',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.824),'mapping.)',
     +                                                       .010,0.,1.)
C
              CALL PLCHHQ (CFUX(.97),CFUY(.060),'Shorelines are blue.',
     +                                                       .012,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.036),'Parallels/meridians are
     + red.',.012,0.,1.)
C
C Advance the frame.
C
              CALL FRAME
C
            END IF
C
C Simple rectangular grid:
C
            IF (MOD(IMSH/2,2).NE.0) THEN
C
              PRINT * , 'DRAWING SIMPLE RECTANGULAR GRID'
C
              CALL DSORCA
C
C Label the second frame.
C
              CALL PLCHHQ (CFUX(.03),CFUY(.946),'ORCA GRID',.024,0.,-1.)
C
              IF (     IDIR.EQ.1) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 1',
     +                                                      .012,0.,-1.)
              ELSE IF (IDIR.EQ.2) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 2',
     +                                                      .012,0.,-1.)
              ELSE IF (IDIR.EQ.3) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 3',
     +                                                      .012,0.,-1.)
              ELSE IF (IDIR.EQ.4) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 4',
     +                                                      .012,0.,-1.)
              END IF
C
              CALL PLCHHQ (CFUX(.97),CFUY(.950),'ORIGINAL RECTANGULAR GR
     +ID',.012,0.,1.)
C
              CALL PLCHHQ (CFUX(.97),CFUY(.928),
     +                     'Portions of the grid with missing data',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.908),
     +                     '(over land areas) are drawn',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.888),
     +                     'in a lighter gray.',
     +                                                       .010,0.,1.)
C
              CALL PLCHHQ (CFUX(.03),CFUY(.084),'Grid is gray.',
     +                                                      .012,0.,-1.)
              CALL PLCHHQ (CFUX(.03),CFUY(.060),'Shorelines are blue.',
     +                                                      .012,0.,-1.)
              CALL PLCHHQ (CFUX(.03),CFUY(.036),'Parallels/meridians are
     + red.',.012,0.,-1.)
C
C Advance the frame.
C
              CALL FRAME
C
            END IF
C
C Triangular mesh (with edges between blocked triangles somewhat fainter
C than the rest):
C
            IF (MOD(IMSH/4,2).NE.0) THEN
C
              PRINT * , 'DRAWING TRIANGULAR MESH'
C
              DO 101 IPTE=0,NEDG-LOEN,LOEN
C
                IFLL=0
C
                IF (IEDG(IPTE+3).GE.0) THEN
                  IF (ITRI(LOTN*((IEDG(IPTE+3)-1)/LOTN)+4).EQ.0) IFLL=1
                END IF
C
                IFLR=0
C
                IF (IEDG(IPTE+4).GE.0) THEN
                  IF (ITRI(LOTN*((IEDG(IPTE+4)-1)/LOTN)+4).EQ.0) IFLR=1
                END IF
C
                IF (IFLL.NE.0.OR.IFLR.NE.0) THEN
                  CALL PLOTIT (0,0,2)
                  CALL GSPLCI (8)
                ELSE
                  CALL PLOTIT (0,0,2)
                  CALL GSPLCI (9)
                END IF
C
                ALAT=RTOD*ASIN(RPNT(IEDG(IPTE+1)+3))
C
                IF (RPNT(IEDG(IPTE+1)+1).EQ.0..AND.
     +              RPNT(IEDG(IPTE+1)+2).EQ.0.) THEN
                  ALON=0.
                ELSE
                  ALON=RTOD*ATAN2(RPNT(IEDG(IPTE+1)+2),
     +                            RPNT(IEDG(IPTE+1)+1))
                END IF
C
                BLAT=RTOD*ASIN(RPNT(IEDG(IPTE+2)+3))
C
                IF (RPNT(IEDG(IPTE+2)+1).EQ.0..AND.
     +              RPNT(IEDG(IPTE+2)+2).EQ.0.) THEN
                  BLON=0.
                ELSE
                  BLON=RTOD*ATAN2(RPNT(IEDG(IPTE+2)+2),
     +                            RPNT(IEDG(IPTE+2)+1))
                END IF
C
                CALL DRSGCR (ALAT,ALON,BLAT,BLON)
C
  101         CONTINUE
C
              CALL PLOTIT (0,0,2)
              CALL GSPLCI (13)
              CALL MAPGRD
              CALL PLOTIT (0,0,2)
              CALL GSPLCI (14)
              CALL MAPLOT
C
C Label the third frame.
C
              CALL PLCHHQ (CFUX(.03),CFUY(.946),'ORCA GRID',.024,0.,-1.)
C
              IF (     IDIR.EQ.1) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 1',
     +                                                      .012,0.,-1.)
              ELSE IF (IDIR.EQ.2) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 2',
     +                                                      .012,0.,-1.)
              ELSE IF (IDIR.EQ.3) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 3',
     +                                                      .012,0.,-1.)
              ELSE IF (IDIR.EQ.4) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 4',
     +                                                      .012,0.,-1.)
              END IF
C
              CALL PLCHHQ (CFUX(.97),CFUY(.950),'DERIVED TRIANGULAR MESH
     +',.012,0.,1.)
C
              CALL PLCHHQ (CFUX(.97),CFUY(.928),
     +                     'Triangles from rectangles over',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.908),
     +                     'land have been omitted.',
     +                                                       .010,0.,1.)
C
              CALL PLCHHQ (CFUX(.03),CFUY(.084),'Mesh is gray.',
     +                                                      .012,0.,-1.)
              CALL PLCHHQ (CFUX(.03),CFUY(.060),'Shorelines are blue.',
     +                                                      .012,0.,-1.)
              CALL PLCHHQ (CFUX(.03),CFUY(.036),'Parallels/meridians are
     + red.',.012,0.,-1.)
C
C Advance the frame.
C
              CALL FRAME
C
            END IF
C
          END IF
C
C If a frame showing simple contours is to be drawn, do it next (adding
C an overlay of lat/lon lines and continental outlines in light gray).
C
          IF (ICON.NE.0) THEN
C
            PRINT * , 'DRAWING PLOT SHOWING SIMPLE CONTOURS'
C
C Initialize CONPACKT.
C
            PRINT * , 'CALLING CTMESH'
C
            CALL CTMESH (RPNT,NPNT,LOPN,
     +                   IEDG,NEDG,LOEN,
     +                   ITRI,NTRI,LOTN,
     +                   RWRK,LRWK,
     +                   IWRK,LIWK)
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (1)
C
C Proceed as implied by the setting of the label-positioning flag.
C
            IF (ABS(ILLP).EQ.1) THEN
C
C Draw the contour lines with labels generated by the dash package.
C
              PRINT * , 'CALLING CTCLDR'
              CALL CTCLDR (RPNT,IEDG,ITRI,RWRK,IWRK)
C
C Add the informational and high/low labels.
C
              PRINT * , 'CALLING CTLBDR'
              CALL CTLBDR (RPNT,IEDG,ITRI,RWRK,IWRK)
C
            ELSE IF (ABS(ILLP).GT.1) THEN
C
C Create an area map for masking of labels.
C
              MAXN=0
C
              PRINT * , 'CALLING ARINAM'
              CALL ARINAM (IAMA,LAMA)
C
              PRINT * , 'CALLING CTLBAM'
              CALL CTLBAM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA)
C
C Draw the contour lines masked by the area map.
C
              PRINT * , 'CALLING CTCLDM'
              CALL CTCLDM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA,DRWMCL)
C
              PRINT * , 'AREA MAP SPACE REQUIRED:         ',
     +                                         IAMA(1)-IAMA(6)+IAMA(5)+1
C
              PRINT * , 'NUMBER OF POINTS IN LONGEST LINE:',MAXN
C
C Draw all the labels.
C
              PRINT * , 'CALLING CTLBDR'
              CALL CTLBDR (RPNT,IEDG,ITRI,RWRK,IWRK)
C
            END IF
C
            CALL CTGETI ('IWU - INTEGER WORKSPACE USED',IIWU)
            PRINT * , 'INTEGER WORKSPACE REQUIRED:      ',IIWU
C
            CALL CTGETI ('RWU -    REAL WORKSPACE USED',IRWU)
            PRINT * , 'REAL WORKSPACE REQUIRED:         ',IRWU
C
C Add lat/lon lines and continental outlines.
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (13)
            CALL MAPGRD
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (14)
            CALL MAPLOT
C
C Label the fourth frame.
C
            CALL PLCHHQ (CFUX(.03),CFUY(.946),'ORCA GRID',.024,0.,-1.)
C
            IF (     IDIR.EQ.1) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 1',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.2) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 2',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.3) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 3',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.4) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 4',
     +                                                      .012,0.,-1.)
            END IF
C
            CALL PLCHHQ (CFUX(.97),CFUY(.950),'SIMPLE CONTOURS ON',
     +                                                       .012,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.926),'TRIANGULAR MESH',
     +                                                       .012,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.904),
     +                   'Actual temperature',
     +                                                       .010,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.884),
     +                   'data are used.',
     +                                                       .010,0.,1.)
C
            CALL PLCHHQ (CFUX(.03),CFUY(.060),'Shorelines are blue.',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.036),'Parallels/meridians are r
     +ed.',.012,0.,-1.)
C
C Advance the frame.
C
            CALL FRAME
C
          END IF
C
C If a frame showing color-filled contours is to be drawn, do it next.
C
          IF (ICOL.NE.0) THEN
C
            PRINT * , 'DRAWING PLOT SHOWING COLOR-FILLED CONTOURS'
C
            PRINT * , 'CALLING CTMESH'
C
            CALL CTMESH (RPNT,NPNT,LOPN,
     +                   IEDG,NEDG,LOEN,
     +                   ITRI,NTRI,LOTN,
     +                   RWRK,LRWK,
     +                   IWRK,LIWK)
C
            MAXN=0
C
            PRINT * , 'CALLING CTPKCL'
            CALL CTPKCL (RPNT,IEDG,ITRI,RWRK,IWRK)
C
            PRINT * , 'CALLING ARINAM'
            CALL ARINAM (IAMA,LAMA)
C
            PRINT * , 'CALLING CTCLAM'
            CALL CTCLAM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA)
C
C           PRINT * , 'CALLING CTLBAM'
C           CALL CTLBAM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA)
C
            PRINT * , 'CALLING ARSCAM'
            CALL ARSCAM (IAMA,XCRA,YCRA,NCRA,IAAI,IAGI,NGPS,DCFOCB)
C
            PRINT * , 'SPACE REQUIRED IN AREA MAP:      ',
     +                                         IAMA(1)-IAMA(6)+IAMA(5)+1
C
            PRINT * , 'NUMBER OF POINTS IN LARGEST AREA:',MAXN
C
            CALL CTGETI ('IWU - INTEGER WORKSPACE USED',IIWU)
            PRINT * , 'INTEGER WORKSPACE REQUIRED:      ',IIWU
C
            CALL CTGETI ('RWU -    REAL WORKSPACE USED',IRWU)
            PRINT * , 'REAL WORKSPACE REQUIRED:         ',IRWU
C
            CALL GSFACI (1)
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (13)
            CALL MAPGRD
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (14)
            CALL MAPLOT
C
C Label the fifth frame.
C
            CALL PLCHHQ (CFUX(.03),CFUY(.946),'ORCA GRID',
     +                                                      .024,0.,-1.)
C
            IF (     IDIR.EQ.1) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 1',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.2) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 2',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.3) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 3',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.4) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 4',
     +                                                      .012,0.,-1.)
            END IF
C
            CALL PLCHHQ (CFUX(.97),CFUY(.950),'COLORED CONTOUR BANDS ON'
     +,.012,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.926),'TRIANGULAR MESH',
     +                                                       .012,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.904),
     +                   'Actual temperature',
     +                                                       .010,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.884),
     +                   'data are used.',
     +                                                       .010,0.,1.)
C
            CALL PLCHHQ (CFUX(.03),CFUY(.132),'Off-mesh',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.108),'areas of the',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.084),'globe are yellow.',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.060),'Shorelines are blue.',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.036),'Parallels/meridians are r
     +ed.',.012,0.,-1.)
C
C Advance the frame.
C
            CALL FRAME
C
          END IF
C
C If the flag for it is set, do a cell array plot.
C
          IF (ICAP.NE.0) THEN
C
            PRINT * , 'DRAWING CELL-ARRAY PLOT OF DATA VALUES'
            CALL GETSET (XVPL,XVPR,YVPB,YVPT,XWDL,XWDR,YWDB,YWDT,LNLG)
C
            PRINT * , 'CALLING CTCICA'
            CALL CTCICA (RPNT,IEDG,ITRI,RWRK,IWRK,ICRA,ICAM,ICAM,ICAN,
     +                                            XVPL,YVPB,XVPR,YVPT)
C
            PRINT * , 'CALLING GCA'
            CALL GCA (XWDL,YWDB,XWDR,YWDT,ICAM,ICAN,1,1,ICAM,ICAN,ICRA)
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (13)
            CALL MAPGRD
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (14)
            CALL MAPLOT
C
C Label the sixth frame.
C
            CALL PLCHHQ (CFUX(.03),CFUY(.946),'ORCA GRID',.024,0.,-1.)
C
            IF (     IDIR.EQ.1) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 1',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.2) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 2',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.3) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 3',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.4) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 4',
     +                                                      .012,0.,-1.)
            END IF
C
            CALL PLCHHQ (CFUX(.97),CFUY(.950),'CELL ARRAY DERIVED FROM',
     +.012,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.926),'TRIANGULAR MESH',
     +                                                       .012,0.,1.)
C
            CALL PLCHHQ (CFUX(.97),CFUY(.904),
     +                   'Actual temperature',
     +                                                       .010,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.884),
     +                   'data are used.',
     +                                                       .010,0.,1.)
C
            CALL PLCHHQ (CFUX(.03),CFUY(.132),'Off-mesh',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.108),'areas of the',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.084),'globe are yellow.',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.060),'Shorelines are blue.',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.036),'Parallels/meridians are r
     +ed.',.012,0.,-1.)
C
C Advance the frame.
C
            CALL FRAME
C
          END IF
C
  104   CONTINUE
C
C Close GKS.
C
        CALL GDAWK (IWID)
        CALL GCLWK (IWID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END


      SUBROUTINE DFCLRS (IWID,IOFC,IOLC,REDF,GRNF,BLUF,REDL,GRNL,BLUL)
C
C This routine defines color indices IOFC through IOLC on workstation
C IWID by interpolating values from REDF/GRNF/BLUF to REDL/GRNL/BLUL.
C
        DO 101 I=IOFC,IOLC
          P=REAL(IOLC-I)/REAL(IOLC-IOFC)
          Q=REAL(I-IOFC)/REAL(IOLC-IOFC)
          CALL GSCR (IWID,I,P*REDF+Q*REDL,P*GRNF+Q*GRNL,P*BLUF+Q*BLUL)
  101   CONTINUE
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE DRWMCL (XCRA,YCRA,NCRA,IAAI,IAGI,NGPS)
C
        DIMENSION XCRA(*),YCRA(*),IAAI(*),IAGI(*)
C
C This routine draws the curve defined by the points (XCRA(I),YCRA(I)),
C for I = 1 to NCRA, if and only if none of the area identifiers for the
C area containing the polyline are negative.  It calls either CURVE or
C CURVED to do the drawing, depending on the value of the internal
C parameter 'DPU'.
C
C It keeps track of the maximum value used for NCRA in a common block.
C
        COMMON /COMONA/ MAXN
C
        MAXN=MAX(MAXN,NCRA)
C
C Retrieve the value of the internal parameter 'DPU'.
C
        CALL CTGETI ('DPU - DASH PACKAGE USED',IDUF)
C
C Turn on drawing.
C
        IDRW=1
C
C If any area identifier is negative, turn off drawing.
C
        DO 101 I=1,NGPS
          IF (IAAI(I).LT.0) IDRW=0
  101   CONTINUE
C
C If drawing is turned on, draw the polyline.
C
        IF (IDRW.NE.0) THEN
          IF (IDUF.EQ.0) THEN
            CALL CURVE  (XCRA,YCRA,NCRA)
          ELSE IF (IDUF.LT.0) THEN
            CALL DPCURV (XCRA,YCRA,NCRA)
          ELSE
            CALL CURVED (XCRA,YCRA,NCRA)
          END IF
        END IF
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE DCFOCB (XCRA,YCRA,NCRA,IAAI,IAGI,NGPS)
C
C This routine fills the area defined by the points (XCRA(I),YCRA(I)),
C for I = 1 to NCRA, if and only if none of the area identifiers for
C the area are negative.  The color used is determined from the area
C identifier of the area relative to group 3; it is assumed that 100
C colors are defined having color indices 151 through 250.
C
        DIMENSION XCRA(*),YCRA(*),IAAI(*),IAGI(*)
C
C It keeps track of the maximum value used for NCRA in a common block.
C
        COMMON /COMONA/ MAXN
C
        MAXN=MAX(MAXN,NCRA)
C
C Retrieve the number of contour levels being used.
C
        CALL CTGETI ('NCL - NUMBER OF CONTOUR LEVELS',NOCL)
C
C If the number of contour levels is non-zero and the area has more
C than two points, fill it.
C
        IF (NOCL.NE.0.AND.NCRA.GT.2) THEN
C
          IAI3=-1
C
          DO 101 I=1,NGPS
            IF (IAGI(I).EQ.3) IAI3=IAAI(I)
  101     CONTINUE
C
          IF (IAI3.GE.1.AND.IAI3.LE.NOCL+1) THEN
            CALL GSFACI (151+INT(((REAL(IAI3)-.5)/REAL(NOCL+1))*100.))
            CALL GFA    (NCRA,XCRA,YCRA)
          ELSE IF (IAI3.EQ.1001) THEN
            CALL GSFACI (2)
            CALL GFA    (NCRA,XCRA,YCRA)
          ELSE IF (IAI3.EQ.1002) THEN
            CALL GSFACI (3)
            CALL GFA    (NCRA,XCRA,YCRA)
          END IF
C
        END IF
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE GTORCA (RPNT,MPNT,NPNT,LOPN,
     +                   IEDG,MEDG,NEDG,LOEN,
     +                   ITRI,MTRI,NTRI,LOTN,
     +                             CLAT,CLON)
C
        DIMENSION RPNT(MPNT),IEDG(MEDG),ITRI(MTRI)
C
C Include definitions that "NetCDF" needs (now commented out, because
C the data are being read from an ASCII file, instead).
C
C       include 'netcdf.inc'
C
C The ORCA grid is rectangular; at each point, we have a latitude, a
C longitude, and a data value.  From this, we construct a triangular
C mesh.
C
C Define some dimensions.
C
        PARAMETER (IDIM=181,JDIM=148)
        PARAMETER (IDM1=IDIM-1,JDM1=JDIM-1)
        PARAMETER (IDP1=IDIM+1,JDP1=JDIM+1)
C
C Dimension arrays to receive the original data from the NetCDF file.
C RLAT is an array of latitudes, RLON an array of longitudes, and
C DVAL an array of data.  Each of these arrays has two points of
C overlap in the first dimension: for each value of J from 1 to JDP1,
C the grid points indexed [1,J] and [2,J] are the same as the ones
C indexed [IDIM,J] and [IDP1,J], respectively.  There are also some
C points of overlap in the second dimension: the grid points with
C indices [I,JDP1], for I from 1 to IDIM, trace out a long narrow
C ellipse near the North Pole which is a duplicate of one traced out
C by the grid points with indices [I,JDM1], for I from 1 to IDIM, but
C in reversed order; the grid points with indices [I,JDIM], for I from
C 1 to IDIM, trace out a degenerate ellipse with a minor axis of zero
C (a line traced from beginning to end and back again).
C
        DIMENSION RLAT(IDP1,JDP1),RLON(IDP1,JDP1),DVAL(IDP1,JDP1,5)
C
C Declare arrays to receive a subset of the ORCA grid data.  XLAT is the
C array of latitudes, XLON is the array of longitudes, and ZDAT is an
C array of data.  One "horizontal" line (for J=IDP1) and one "vertical"
C line (for I=IDP1) of the original ORCA grid data are discarded in
C the copy to these arrays, but each of them still has one point of
C overlap in the first dimension: for each value of J from 1 to JDIM,
C the grid point indexed [1,J] is the same as the one indexed [IDIM,J].
C
        COMMON /CMORCA/ XLAT(IDIM,JDIM),XLON(IDIM,JDIM),ZDAT(IDIM,JDIM)
        SAVE   /CMORCA/
C
C Each cell of the rectangular grid for which data is available at all
C four corners is split in half along one of its diagonals; resulting
C triangles form the triangular mesh.  As we create the triangular mesh,
C we have to keep track of where the points and edges of the rectangular
C grid were put (so as to avoid the problem of duplicating points and
C edges in the structure).  The array ISCR is used for this.
C
        DIMENSION ISCR(4,IDIM,JDIM)
C
C Declare external a routine to tell CTTMRG about points of overlap on
C the ORCA grid.
C
        EXTERNAL MIORCA
C
C Define the value that indicates a missing datum in the ORCA grid.
C
        DATA SVAL / 1.E20 /
C
C The data for this example were originally read from a user's "NetCDF"
C file.  The code used for the purpose follows, but has been commented
C out, as the data are now read from an ASCII file.  This gets around
C certain procedural problems in running the example from "ncargex".
C
C Open the "NetCDF" file.
C
C       ISTA=NF_OPEN('ctorca.nc',0,NCID)
C
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'ERROR RETURN FROM NF_OPEN: ',ISTA
C         STOP
C       END IF
C
C Read the array of latitudes.
C
C       ISTA=NF_INQ_VARID(NCID,'nav_lat',IVID)
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'ERROR RETURN FROM NF_INQ_VARID: ',ISTA
C         STOP
C       END IF
C       ISTA=NF_GET_VAR_REAL(NCID,IVID,RLAT)
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'ERROR RETURN FROM NF_GET_VAR_REAL: ',ISTA
C         STOP
C       END IF
C
C Read the array of longitudes.
C
C       ISTA=NF_INQ_VARID(NCID,'nav_lon',IVID)
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'ERROR RETURN FROM NF_INQ_VARID: ',ISTA
C         STOP
C       END IF
C       ISTA=NF_GET_VAR_REAL(NCID,IVID,RLON)
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'ERROR RETURN FROM NF_GET_VAR_REAL: ',ISTA
C         STOP
C       END IF
C
C Read the array of data.
C
C       ISTA=NF_INQ_VARID(NCID,'sosstsst',IVID)
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'ERROR RETURN FROM NF_INQ_VARID: ',ISTA
C         STOP
C       END IF
C       ISTA=NF_GET_VAR_REAL(NCID,IVID,DVAL)
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'ERROR RETURN FROM NF_GET_VAR_REAL: ',ISTA
C         STOP
C       END IF
C
C Close the "NetCDF" file.
C
C       ISTA=NF_CLOSE(NCID)
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'ERROR RETURN FROM NF_CLOSE: ',ISTA
C         STOP
C       END IF
C
C Write the data to unit 11.  (These statements are commented out; they
C were used to create a "fort.11" which was then renamed "ctorca.dat".)
C
C       WRITE (11,'(5E16.8)') RLAT
C       WRITE (11,'(5E16.8)') RLON
C       WRITE (11,'(5E16.8)') DVAL
C
C Read the required data from the ASCII file "ctorca.dat".
C
        OPEN (11,FILE='ctorca.dat',STATUS='OLD',FORM='FORMATTED')
C
        READ (11,'(5E16.8)') RLAT
        READ (11,'(5E16.8)') RLON
        READ (11,'(5E16.8)') DVAL
C
        CLOSE (11)
C
C Copy the data from the original arrays to the subset arrays.
C
        DO 102 I=1,IDIM
          DO 101 J=1,JDIM
            XLAT(I,J)=RLAT(I+1,J)
            XLON(I,J)=RLON(I+1,J)
            ZDAT(I,J)=DVAL(I+1,J,1)
  101     CONTINUE
  102   CONTINUE
C
C Call a general-purpose subroutine that accepts a rectangular grid
C mapped onto the surface of the globe and returns a triangular mesh
C equivalent to it.
C
        CALL CTTMRG (IDIM,JDIM,XLAT,XLON,ZDAT,ISCR,SVAL,MIORCA,
     +               RPNT,MPNT,NPNT,LOPN,
     +               IEDG,MEDG,NEDG,LOEN,
     +               ITRI,MTRI,NTRI,LOTN)
C
C Return the latitude and longitude of the approximate center point of
C the mesh on the globe.
C
        CLAT=XLAT(IDIM/2,JDIM/2)
        CLON=XLON(IDIM/2,JDIM/2)
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE MIORCA (IDIM,JDIM,IINI,JINI,IINO,JINO)
C
C Given the dimensions, IDIM and JDIM, of a lat/lon grid on the globe,
C and the indices, IINI and JINI, of a point on the grid, this routine
C returns the indices, IINO and JINO, of that coincident point on the
C grid which is to be used to represent it.  This version assumes that
C the first and last rows of the grid each map into a single point
C (perhaps the south pole and the north pole, respectively) and that
C the right and left edges of the grid lie on top of each other.
C
        IF      (JINI.EQ.JDIM) THEN
          IINO=MIN(IINI,IDIM+1-IINI)
          JINO=JDIM
        ELSE IF (IINI.EQ.IDIM) THEN
          IINO=1
          JINO=JINI
        ELSE
          IINO=IINI
          JINO=JINI
        END IF
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE DSORCA
C
C Draw the original ORCA grid, using data passed in a common block.
C
        PARAMETER (IDIM=181,JDIM=148,IDM1=IDIM-1,JDM1=JDIM-1)
C
        COMMON /CMORCA/ XLAT(IDIM,JDIM),XLON(IDIM,JDIM),ZDAT(IDIM,JDIM)
        SAVE   /CMORCA/
C
C Define the value that indicates a missing datum in the ORCA grid.
C
        DATA SVAL / 1.E20 /
C
C Draw the grid box by box, skipping any box with a side longer than
C 2.5 degrees and any box in the list embedded in the function KILLIT.
C
        CALL PLOTIT (0,0,2)
        CALL GSPLCI (8)
C
        DO 102 I=1,IDM1
          DO 101 J=1,JDM1
            IF (ADSGCR(XLAT(I  ,J  ),XLON(I  ,J  ),
     +                 XLAT(I+1,J  ),XLON(I+1,J  )).GT.2.5) GO TO 101
            IF (ADSGCR(XLAT(I+1,J  ),XLON(I+1,J  ),
     +                 XLAT(I+1,J+1),XLON(I+1,J+1)).GT.2.5) GO TO 101
            IF (ADSGCR(XLAT(I+1,J+1),XLON(I+1,J+1),
     +                 XLAT(I  ,J+1),XLON(I  ,J+1)).GT.2.5) GO TO 101
            IF (ADSGCR(XLAT(I  ,J+1),XLON(I  ,J+1),
     +                 XLAT(I  ,J  ),XLON(I  ,J  )).GT.2.5) GO TO 101
            IF (KILLIT(I,J).NE.0) GO TO 101
            IF (ZDAT(I  ,J  ).NE.SVAL.AND.ZDAT(I  ,J+1).NE.SVAL) THEN
              CALL PLOTIT (0,0,2)
              CALL GSPLCI (8)
            ELSE
              CALL PLOTIT (0,0,2)
              CALL GSPLCI (9)
            END IF
            CALL DRSGCR (XLAT(I  ,J  ),XLON(I  ,J  ),
     +                   XLAT(I  ,J+1),XLON(I  ,J+1))
            IF (ZDAT(I  ,J+1).NE.SVAL.AND.ZDAT(I+1,J+1).NE.SVAL) THEN
              CALL PLOTIT (0,0,2)
              CALL GSPLCI (8)
            ELSE
              CALL PLOTIT (0,0,2)
              CALL GSPLCI (9)
            END IF
            CALL DRSGCR (XLAT(I  ,J+1),XLON(I  ,J+1),
     +                   XLAT(I+1,J+1),XLON(I+1,J+1))
            IF (ZDAT(I+1,J+1).NE.SVAL.AND.ZDAT(I+1,J  ).NE.SVAL) THEN
              CALL PLOTIT (0,0,2)
              CALL GSPLCI (8)
            ELSE
              CALL PLOTIT (0,0,2)
              CALL GSPLCI (9)
            END IF
            CALL DRSGCR (XLAT(I+1,J+1),XLON(I+1,J+1),
     +                   XLAT(I+1,J  ),XLON(I+1,J  ))
            IF (ZDAT(I+1,J  ).NE.SVAL.AND.ZDAT(I  ,J  ).NE.SVAL) THEN
              CALL PLOTIT (0,0,2)
              CALL GSPLCI (8)
            ELSE
              CALL PLOTIT (0,0,2)
              CALL GSPLCI (9)
            END IF
            CALL DRSGCR (XLAT(I+1,J  ),XLON(I+1,J  ),
     +                   XLAT(I  ,J  ),XLON(I  ,J  ))
  101     CONTINUE
  102   CONTINUE
C
C Draw the continental outlines and lat/lon grid.
C
        CALL PLOTIT (0,0,2)
        CALL GSPLCI (13)
        CALL MAPGRD
        CALL PLOTIT (0,0,2)
        CALL GSPLCI (14)
        CALL MAPLOT
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE DCORCA
C
C Draw the original ORCA grid, using data passed in a common block.
C
        PARAMETER (IDIM=181,JDIM=148,IDM1=IDIM-1,JDM1=JDIM-1)
C
        COMMON /CMORCA/ XLAT(IDIM,JDIM),XLON(IDIM,JDIM),ZDAT(IDIM,JDIM)
        SAVE   /CMORCA/
C
        COMMON /CMGRID/ IWID,IFCI,MCOL,NCOL
        SAVE   /CMGRID/
C
C Declare arrays to use for solid fill.
C
        DIMENSION XBOX(4),YBOX(4)
C
C Define the major and minor axes of the ellipses that mark selected
C points on the grid.
C
        DATA RADA,RADB / .010,.010 /
C
C Define a constant to convert from degrees to radians.
C
        DATA DTOR / .017453292519943 /
C
C Fill the grid box by box, skipping any box with a side longer than
C 2.5 degrees and any box in the list embedded in the function KILLIT.
C
        DO 102 I=1,IDM1
          ICOL=INT(10.*REAL(I-1)/REAL(IDM1))
          DO 101 J=1,JDM1
            JCOL=INT(10.*REAL(J-1)/REAL(JDM1))
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (51+10*ICOL+JCOL)
            CALL GSFACI (51+10*ICOL+JCOL)
            IF (ADSGCR(XLAT(I  ,J  ),XLON(I  ,J  ),
     +                 XLAT(I+1,J  ),XLON(I+1,J  )).GT.2.5) GO TO 101
            IF (ADSGCR(XLAT(I+1,J  ),XLON(I+1,J  ),
     +                 XLAT(I+1,J+1),XLON(I+1,J+1)).GT.2.5) GO TO 101
            IF (ADSGCR(XLAT(I+1,J+1),XLON(I+1,J+1),
     +                 XLAT(I  ,J+1),XLON(I  ,J+1)).GT.2.5) GO TO 101
            IF (ADSGCR(XLAT(I  ,J+1),XLON(I  ,J+1),
     +                 XLAT(I  ,J  ),XLON(I  ,J  )).GT.2.5) GO TO 101
            IF (KILLIT(I,J).NE.0) GO TO 101
            XCOA=COS(DTOR*XLAT(I  ,J  ))*COS(DTOR*XLON(I  ,J  ))
            YCOA=COS(DTOR*XLAT(I  ,J  ))*SIN(DTOR*XLON(I  ,J  ))
            ZCOA=SIN(DTOR*XLAT(I  ,J  ))
            CALL CTMXYZ (1,XCOA,YCOA,ZCOA,XBOX(1),YBOX(1))
            IF (XBOX(1).EQ.1.E12.OR.YBOX(1).EQ.1.E12) GO TO 101
            XCOA=COS(DTOR*XLAT(I+1,J  ))*COS(DTOR*XLON(I+1,J  ))
            YCOA=COS(DTOR*XLAT(I+1,J  ))*SIN(DTOR*XLON(I+1,J  ))
            ZCOA=SIN(DTOR*XLAT(I+1,J  ))
            CALL CTMXYZ (1,XCOA,YCOA,ZCOA,XBOX(2),YBOX(2))
            IF (XBOX(2).EQ.1.E12.OR.YBOX(2).EQ.1.E12) GO TO 101
            XCOA=COS(DTOR*XLAT(I+1,J+1))*COS(DTOR*XLON(I+1,J+1))
            YCOA=COS(DTOR*XLAT(I+1,J+1))*SIN(DTOR*XLON(I+1,J+1))
            ZCOA=SIN(DTOR*XLAT(I+1,J+1))
            CALL CTMXYZ (1,XCOA,YCOA,ZCOA,XBOX(3),YBOX(3))
            IF (XBOX(3).EQ.1.E12.OR.YBOX(3).EQ.1.E12) GO TO 101
            XCOA=COS(DTOR*XLAT(I  ,J+1))*COS(DTOR*XLON(I  ,J+1))
            YCOA=COS(DTOR*XLAT(I  ,J+1))*SIN(DTOR*XLON(I  ,J+1))
            ZCOA=SIN(DTOR*XLAT(I  ,J+1))
            CALL CTMXYZ (1,XCOA,YCOA,ZCOA,XBOX(4),YBOX(4))
            IF (XBOX(4).EQ.1.E12.OR.YBOX(4).EQ.1.E12) GO TO 101
            CALL GFA (4,XBOX,YBOX)
  101     CONTINUE
  102   CONTINUE
C
C Draw the continental outlines and lat/lon grid.
C
        CALL PLOTIT (0,0,2)
        CALL GSPLCI (13)
        CALL MAPGRD
        CALL PLOTIT (0,0,2)
        CALL GSPLCI (14)
        CALL MAPLOT
C
C In gray, draw those interior lines of the grid that separate boxes of
C different colors.
C
        CALL PLOTIT (0,0,2)
        CALL GSPLCI (11)
C
        DO 104 I=2,IDM1
          DO 103 J=1,JDM1
            IF (ADSGCR(XLAT(I,J  ),XLON(I,J  ),
     +                 XLAT(I,J+1),XLON(I,J+1)).GT.2.5) GO TO 103
            IF (INT(10.*REAL(I-1)/REAL(IDM1)).EQ.
     +          INT(10.*REAL(I-2)/REAL(IDM1))) GO TO 103
            CALL DRSGCR (XLAT(I,J),XLON(I,J),XLAT(I,J+1),XLON(I,J+1))
  103     CONTINUE
  104   CONTINUE
C
        DO 106 J=2,JDM1
          DO 105 I=1,IDM1
            IF (ADSGCR(XLAT(I  ,J),XLON(I  ,J),
     +                 XLAT(I+1,J),XLON(I+1,J)).GT.2.5) GO TO 105
            IF (INT(10.*REAL(J-1)/REAL(JDM1)).EQ.
     +          INT(10.*REAL(J-2)/REAL(JDM1))) GO TO 105
            CALL DRSGCR (XLAT(I,J),XLON(I,J),XLAT(I+1,J),XLON(I+1,J))
  105     CONTINUE
  106   CONTINUE
C
C In the foreground color, outline the grid (using a thickened line).
C
        CALL PLOTIT (0,0,2)
        CALL GSPLCI (1)
        CALL GSLWSC (2.)
C
        DO 108 I=1,IDIM,IDIM-1
          DO 107 J=1,JDM1
            IF (ADSGCR(XLAT(I,J  ),XLON(I,J  ),
     +                 XLAT(I,J+1),XLON(I,J+1)).GT.2.5) GO TO 107
            CALL DRSGCR (XLAT(I,J),XLON(I,J),XLAT(I,J+1),XLON(I,J+1))
  107     CONTINUE
  108   CONTINUE
C
        DO 110 J=1,JDIM,JDIM-1
          DO 109 I=1,IDM1
            IF (ADSGCR(XLAT(I  ,J),XLON(I  ,J),
     +                 XLAT(I+1,J),XLON(I+1,J)).GT.2.5) GO TO 109
            CALL DRSGCR (XLAT(I,J),XLON(I,J),XLAT(I+1,J),XLON(I+1,J))
  109     CONTINUE
  110   CONTINUE
C
        CALL PLOTIT (0,0,2)
        CALL GSLWSC (1.)
C
C Mark nine reference points on the grid.
C
        CALL PLOTIT (0,0,2)
        CALL GSPLCI (1)
        CALL GSFACI (1)
C
        CALL MAPTRA (XLAT(1,JDIM),XLON(1,JDIM),XVAL,YVAL)
        IF (XVAL.NE.1.E12.AND.YVAL.NE.1.E12) THEN
          CALL ELLIPS (CUFX(XVAL),CUFY(YVAL),RADA,RADB,0.,4.)
        END IF
C
        CALL MAPTRA (XLAT(IDIM,JDIM),XLON(IDIM,JDIM),XVAL,YVAL)
        IF (XVAL.NE.1.E12.AND.YVAL.NE.1.E12) THEN
          CALL ELLIPS (CUFX(XVAL),CUFY(YVAL),RADA,RADB,0.,4.)
        END IF
C
        CALL MAPTRA (XLAT(1,1),XLON(1,1),XVAL,YVAL)
        IF (XVAL.NE.1.E12.AND.YVAL.NE.1.E12) THEN
          CALL ELLIPS (CUFX(XVAL),CUFY(YVAL),RADA,RADB,0.,4.)
        END IF
C
        CALL MAPTRA (XLAT(IDIM,1),XLON(IDIM,1),XVAL,YVAL)
        IF (XVAL.NE.1.E12.AND.YVAL.NE.1.E12) THEN
          CALL ELLIPS (CUFX(XVAL),CUFY(YVAL),RADA,RADB,0.,4.)
        END IF
C
        CALL PLOTIT (0,0,2)
        CALL GSPLCI (1)
        CALL GSFACI (0)
C
        IF (MOD(IDIM,2).EQ.0) THEN
          CALL FPSGCR (XLAT(IDIM/2  ,JDIM),XLON(IDIM/2  ,JDIM),
     +                 XLAT(IDIM/2+1,JDIM),XLON(IDIM/2+1,JDIM),
     +                                                     .5,CLAT,CLON)
        ELSE
          CLAT=XLAT(IDIM/2+1,JDIM)
          CLON=XLON(IDIM/2+1,JDIM)
        END IF
        CALL MAPTRA (CLAT,CLON,XVAL,YVAL)
        IF (XVAL.NE.1.E12.AND.YVAL.NE.1.E12) THEN
          CALL ELLIPS (CUFX(XVAL),CUFY(YVAL),RADA,RADB,0.,4.)
        END IF
C
        IF (MOD(JDIM,2).EQ.0) THEN
          CALL FPSGCR (XLAT(1,JDIM/2  ),XLON(1,JDIM/2  ),
     +                 XLAT(1,JDIM/2+1),XLON(1,JDIM/2+1),
     +                                                     .5,CLAT,CLON)
        ELSE
          CLAT=XLAT(1,JDIM/2+1)
          CLON=XLON(1,JDIM/2+1)
        END IF
        CALL MAPTRA (CLAT,CLON,XVAL,YVAL)
        IF (XVAL.NE.1.E12.AND.YVAL.NE.1.E12) THEN
          CALL ELLIPS (CUFX(XVAL),CUFY(YVAL),RADA,RADB,0.,4.)
        END IF
C
        IF (MOD(JDIM,2).EQ.0) THEN
          CALL FPSGCR (XLAT(IDIM,JDIM/2  ),XLON(IDIM,JDIM/2  ),
     +                 XLAT(IDIM,JDIM/2+1),XLON(IDIM,JDIM/2+1),
     +                                                     .5,CLAT,CLON)
        ELSE
          CLAT=XLAT(IDIM,JDIM/2+1)
          CLON=XLON(IDIM,JDIM/2+1)
        END IF
        CALL MAPTRA (CLAT,CLON,XVAL,YVAL)
        IF (XVAL.NE.1.E12.AND.YVAL.NE.1.E12) THEN
          CALL ELLIPS (CUFX(XVAL),CUFY(YVAL),RADA,RADB,0.,4.)
        END IF
C
        IF (MOD(IDIM,2).EQ.0) THEN
          CALL FPSGCR (XLAT(IDIM/2  ,1),XLON(IDIM/2  ,1),
     +                 XLAT(IDIM/2+1,1),XLON(IDIM/2+1,1),
     +                                                     .5,CLAT,CLON)
        ELSE
          CLAT=XLAT(IDIM/2+1,1)
          CLON=XLON(IDIM/2+1,1)
        END IF
        CALL MAPTRA (CLAT,CLON,XVAL,YVAL)
        IF (XVAL.NE.1.E12.AND.YVAL.NE.1.E12) THEN
          CALL ELLIPS (CUFX(XVAL),CUFY(YVAL),RADA,RADB,0.,4.)
        END IF
C
        CALL PLOTIT (0,0,2)
        CALL GSPLCI (1)
        CALL GSFACI (4)
C
        IF (MOD(IDIM,2).EQ.0) THEN
          IF (MOD(JDIM,2).EQ.0) THEN
            CALL IPIQOS(XLAT(IDIM/2  ,JDIM/2  ),XLON(IDIM/2  ,JDIM/2  ),
     +                  XLAT(IDIM/2+1,JDIM/2  ),XLON(IDIM/2+1,JDIM/2  ),
     +                  XLAT(IDIM/2  ,JDIM/2+1),XLON(IDIM/2  ,JDIM/2+1),
     +                  XLAT(IDIM/2+1,JDIM/2+1),XLON(IDIM/2+1,JDIM/2+1),
     +                                                  .5,.5,CLAT,CLON)
          ELSE
            CALL FPSGCR(XLAT(IDIM/2  ,JDIM/2+1),XLON(IDIM/2  ,JDIM/2+1),
     +                  XLAT(IDIM/2+1,JDIM/2+1),XLON(IDIM/2+1,JDIM/2+1),
     +                                                     .5,CLAT,CLON)
          END IF
        ELSE
          IF (MOD(JDIM,2).EQ.0) THEN
            CALL FPSGCR(XLAT(IDIM/2+1,JDIM/2  ),XLON(IDIM/2+1,JDIM/2  ),
     +                  XLAT(IDIM/2+1,JDIM/2+1),XLON(IDIM/2+1,JDIM/2+1),
     +                                                    .5,CLAT,CLON)
          ELSE
           CLAT=XLAT(IDIM/2+1,JDIM/2+1)
           CLON=XLON(IDIM/2+1,JDIM/2+1)
          END IF
        END IF
        CALL MAPTRA (CLAT,CLON,XVAL,YVAL)
        IF (XVAL.NE.1.E12.AND.YVAL.NE.1.E12) THEN
          CALL ELLIPS (CUFX(XVAL),CUFY(YVAL),RADA,RADB,0.,4.)
        END IF
C
C Draw a shaded reference grid in the lower left corner of the frame.
C
        CALL SHDGRD (.03,.33,.03,.27,IDM1,JDM1,3,7)
C
C Done.
C
        RETURN
C
      END


      FUNCTION KILLIT (I,J)
C
C This function has a non-zero value if and only if the ORCA grid cell
C whose lower left corner has indices I and J should be deleted.
C
        IF ( (I.GE.  7.AND.I.LE.  7.AND.J.GE. 96.AND.J.LE.112).OR.
     +       (I.GE.139.AND.I.LE.139.AND.J.GE.103.AND.J.LE.103).OR.
     +       (I.GE.138.AND.I.LE.139.AND.J.GE. 98.AND.J.LE. 99).OR.
     +       (I.GE.139.AND.I.LE.139.AND.J.GE.104.AND.J.LE.104).OR.
     +       (I.GE.141.AND.I.LE.142.AND.J.GE.106.AND.J.LE.111).OR.
     +       (I.GE.143.AND.I.LE.144.AND.J.GE.109.AND.J.LE.110).OR.
     +       (I.GE.143.AND.I.LE.143.AND.J.GE.105.AND.J.LE.105).OR.
     +       (I.GE.163.AND.I.LE.165.AND.J.GE. 85.AND.J.LE. 85)) THEN
          KILLIT=1
        ELSE
          KILLIT=0
        END IF
C
        RETURN
C
      END


      SUBROUTINE DRSGCR (ALAT,ALON,BLAT,BLON)
C
C (DRSGCR = DRaw Shortest Great Circle Route)
C
C This routine draws the shortest great circle route joining two points
C on the globe.  Note that MPTS = INT(180./SIZE) + 1.
C
        PARAMETER (MPTS=181,SIZE=1.)
C
        DIMENSION QLAT(MPTS),QLON(MPTS)
C
        NPTS=MAX(1,MIN(MPTS,INT(ADSGCR(ALAT,ALON,BLAT,BLON)/SIZE)))
C
        CALL MAPGCI (ALAT,ALON,BLAT,BLON,NPTS,QLAT,QLON)
C
        CALL MAPIT (ALAT,ALON,0)
C
        DO 101 I=1,NPTS
          CALL MAPIT (QLAT(I),QLON(I),1)
  101   CONTINUE
C
        CALL MAPIT (BLAT,BLON,2)
C
        CALL MAPIQ
C
        RETURN
C
      END


      FUNCTION ADSGCR (ALAT,ALON,BLAT,BLON)
C
C (ADSGCR = Angle in Degrees along Shortest Great Circle Route)
C
C This function returns the shortest great circle distance, in degrees,
C between two points, A and B, on the surface of the globe.
C
        DATA DTOR / .017453292519943 /
        DATA RTOD / 57.2957795130823 /
C
        XCOA=COS(DTOR*ALAT)*COS(DTOR*ALON)
        YCOA=COS(DTOR*ALAT)*SIN(DTOR*ALON)
        ZCOA=SIN(DTOR*ALAT)
C
        XCOB=COS(DTOR*BLAT)*COS(DTOR*BLON)
        YCOB=COS(DTOR*BLAT)*SIN(DTOR*BLON)
        ZCOB=SIN(DTOR*BLAT)
C
        ADSGCR=2.*RTOD*ASIN(SQRT((XCOA-XCOB)**2+
     +                           (YCOA-YCOB)**2+
     +                           (ZCOA-ZCOB)**2)/2.)
C
        RETURN
C
      END


      SUBROUTINE DCFGRD (IAR1,IAR2,IAR3,IAR4,CCLL,CCLR,CCUL,CCUR)
C
        DIMENSION CCLL(3),CCLR(3),CCUL(3),CCUR(3),CCGC(3)
C
C This routine defines the colors to be used by SHDGRD.  CCLL, CCLR,
C CCUL, and CCUR define the RGB color components for the lower-left
C corner, the lower-right corner, the upper-left corner, and the
C upper-right corner, respectively, of the grid.  Other colors to be
C used are defined by interpolation.
C
        COMMON /CMGRID/ IWID,IFCI,MCOL,NCOL
        SAVE   /CMGRID/
C
C Transfer first four arguments to common block shared with SHDGRD.
C
        IWID=IAR1
        IFCI=IAR2
        MCOL=IAR3
        NCOL=IAR4
C
        DO 103 I=0,MCOL-1
          P=REAL(I)/REAL(MCOL-1)
          DO 102 J=0,NCOL-1
            Q=REAL(J)/REAL(NCOL-1)
            DO 101 K=1,3
              CCGC(K)=(1.-P)*((1.-Q)*CCLL(K)+Q*CCUL(K))+
     +                    P *((1.-Q)*CCLR(K)+Q*CCUR(K))
  101       CONTINUE
            CALL GSCR (IWID,IFCI+NCOL*I+J,
     +                 MAX(0.,MIN(1.,CCGC(1))),
     +                 MAX(0.,MIN(1.,CCGC(2))),
     +                 MAX(0.,MIN(1.,CCGC(3))))
  102     CONTINUE
  103   CONTINUE
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE SHDGRD (XVPL,XVPR,YVPB,YVPT,IMAX,JMAX,ITYP,IMRK)
C
C This routine draws a representation of a grid of IMAX by JMAX boxes
C (having IMAX+1 vertical lines and JMAX+1 horizontal lines) in the part
C of the plotter frame specified by XVPL, XVPR, YVPB, and YVPT.  Colors
C used are those specified by a superimposed grid of MCOL by NCOL colors
C with indices IFCI through IFCI+MCOL*NCOL-1.  If ITYP is 0, the grid
C is drawn, but not filled.  If ITYP is 1, the grid is filled.  If ITYP
C is 2, the grid is filled and then outlined in the foreground color.
C If ITYP is 3, the grid is filled, some of the interior grid lines (the
C ones between boxes of different colors) are drawn in gray, and then
C the grid is outlined in the foreground color.  If ITYP is 4, the grid
C is filled, all of the interior grid lines are drawn in gray, and then
C the grid is outlined in the foreground color.  If IMRK is 0, no points
C of the grid are marked with filled circles; if IMRK is 1, the corner
C points are marked with black-filled circles; if IMRK is 2, the edge
C points are marked with white-filled black circles; if IMRK is 4, the
C center point is marked with a red-filled black circle; sums of these
C values can be used to get combinations of behaviors.
C
        COMMON /CMGRID/ IWID,IFCI,MCOL,NCOL
        SAVE   /CMGRID/
C
        DIMENSION XBOX(5),YBOX(5)
C
C Define the major and minor axes of the ellipses that mark selected
C points on the grid.
C
        DATA RADA,RADB / .005,.005 /
C
C Save the current SET call.
C
        CALL GETSET (EVPL,EVPR,EVPB,EVPT,EWDL,EWDR,EWDB,EWDT,LNLG)
C
C Compute the coordinates of the center of the viewport in which the
C grid is to be drawn, its half-height, and its half-width.
C
        XVPC=(XVPR+XVPL)/2.
        YVPC=(YVPB+YVPT)/2.
        HVPW=(XVPR-XVPL)/2.
        HVPH=(YVPT-YVPB)/2.
C
C Compute values defining the exact viewport in which the grid is to
C be drawn and redo the set call appropriately.
C
        IF (REAL(IMAX)/REAL(JMAX).LE.(XVPR-XVPL)/(YVPT-YVPB)) THEN
          SVPL=XVPC-HVPH*(REAL(IMAX)/REAL(JMAX))
          SVPR=XVPC+HVPH*(REAL(IMAX)/REAL(JMAX))
          SVPB=YVPB
          SVPT=YVPT
        ELSE
          SVPL=XVPL
          SVPR=XVPR
          SVPB=YVPC-HVPW*(REAL(JMAX)/REAL(IMAX))
          SVPT=YVPC+HVPW*(REAL(JMAX)/REAL(IMAX))
        END IF
C
        CALL SET (SVPL,SVPR,SVPB,SVPT,0.,REAL(IMAX),0.,REAL(JMAX),1)
C
C If the lines are to be drawn in different colors ...
C
        IF (ITYP.EQ.0) THEN
C
C ... do it.
C
          DO 102 I=0,IMAX-1
            ICOL=INT(REAL(MCOL)*REAL(I)/REAL(IMAX))
            DO 101 J=0,JMAX-1
              JCOL=INT(REAL(NCOL)*REAL(J)/REAL(JMAX))
              CALL PLOTIT (0,0,2)
              CALL GSPLCI (IFCI+NCOL*ICOL+JCOL)
              XBOX(1)=REAL(I)
              XBOX(2)=REAL(I+1)
              XBOX(3)=REAL(I+1)
              XBOX(4)=REAL(I)
              XBOX(5)=REAL(I)
              YBOX(1)=REAL(J)
              YBOX(2)=REAL(J)
              YBOX(3)=REAL(J+1)
              YBOX(4)=REAL(J+1)
              YBOX(5)=REAL(J)
              CALL GPL (5,XBOX,YBOX)
  101       CONTINUE
  102     CONTINUE
C
C Otherwise, the boxes are to be filled in different colors, so ...
C
        ELSE
C
C ... do it.
C
          DO 104 I=0,IMAX-1
            ICOL=INT(REAL(MCOL)*REAL(I)/REAL(IMAX))
            DO 103 J=0,JMAX-1
              JCOL=INT(REAL(NCOL)*REAL(J)/REAL(JMAX))
              CALL GSFACI (IFCI+NCOL*ICOL+JCOL)
              XBOX(1)=REAL(I)
              XBOX(2)=REAL(I+1)
              XBOX(3)=REAL(I+1)
              XBOX(4)=REAL(I)
              YBOX(1)=REAL(J)
              YBOX(2)=REAL(J)
              YBOX(3)=REAL(J+1)
              YBOX(4)=REAL(J+1)
              CALL GFA (4,XBOX,YBOX)
  103       CONTINUE
  104     CONTINUE
C
C In addition, if specified, draw lines on the grid ...
C
          IF (ITYP.GT.1) THEN
C
C ... either just the border ...
C
            IF (ITYP.GT.2) THEN
C
C ... or all the lines ...
C
              CALL PLOTIT (0,0,2)
              CALL GSPLCI (11)
C
              DO 105 I=1,IMAX-1
                IF (ITYP.GT.3.OR.
     +              INT(REAL(MCOL)*REAL(I-1)/REAL(IMAX)).NE.
     +              INT(REAL(MCOL)*REAL(I  )/REAL(IMAX)))
     +            CALL LINE (REAL(I),0.,REAL(I),REAL(JMAX))
  105         CONTINUE
C
              DO 106 J=1,JMAX-1
                IF (ITYP.GT.3.OR.
     +              INT(REAL(NCOL)*REAL(J-1)/REAL(JMAX)).NE.
     +              INT(REAL(NCOL)*REAL(J  )/REAL(JMAX)))
     +          CALL LINE (0.,REAL(J),REAL(IMAX),REAL(J))
  106         CONTINUE
C
            END IF
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (1)
            CALL GSLWSC (2.)
C
            CALL LINE (        0.,        0.,REAL(IMAX),        0.)
            CALL LINE (REAL(IMAX),        0.,REAL(IMAX),REAL(JMAX))
            CALL LINE (REAL(IMAX),REAL(JMAX),        0.,REAL(JMAX))
            CALL LINE (        0.,REAL(JMAX),        0.,        0.)
C
            CALL PLOTIT (0,0,2)
            CALL GSLWSC (1.)
C
          END IF
C
        END IF
C
C If specified, mark a selected subset of nine different points of
C reference on the grid.
C
        IF (MOD(IMRK,2).NE.0) THEN
C
          CALL PLOTIT (0,0,2)
          CALL GSPLCI (1)
          CALL GSFACI (1)
C
          CALL ELLIPS (SVPL,SVPT,RADA,RADB,0.,4.)
          CALL ELLIPS (SVPR,SVPT,RADA,RADB,0.,4.)
          CALL ELLIPS (SVPL,SVPB,RADA,RADB,0.,4.)
          CALL ELLIPS (SVPR,SVPB,RADA,RADB,0.,4.)
C
        END IF
C
        IF (MOD(IMRK/2,2).NE.0) THEN
C
          CALL PLOTIT (0,0,2)
          CALL GSPLCI (1)
          CALL GSFACI (0)
C
          CALL ELLIPS (.5*(SVPL+SVPR),SVPT,RADA,RADB,0.,4.)
          CALL ELLIPS (SVPL,.5*(SVPB+SVPT),RADA,RADB,0.,4.)
          CALL ELLIPS (SVPR,.5*(SVPB+SVPT),RADA,RADB,0.,4.)
          CALL ELLIPS (.5*(SVPL+SVPR),SVPB,RADA,RADB,0.,4.)
C
        END IF
C
        IF (MOD(IMRK/4,2).NE.0) THEN
C
          CALL PLOTIT (0,0,2)
          CALL GSPLCI (1)
          CALL GSFACI (4)
C
          CALL ELLIPS (.5*(SVPL+SVPR),.5*(SVPB+SVPT),RADA,RADB,0.,4.)
C
        END IF
C
        CALL GSFACI (1)
C
C Label the bottom of the grid.
C
        CALL PLCHHQ (CFUX(.5*(SVPL+SVPR)),CFUY(SVPB-.018),
     +                                                'I-->',.012,0.,0.)
C
C Label the left edge of the grid.
C
        CALL PLCHHQ (CFUX(SVPL-.018),CFUY(.5*(SVPB+SVPT)),
     +                                               'J-->',.012,90.,0.)
C
C Restore the original SET call.
C
        CALL SET (EVPL,EVPR,EVPB,EVPT,EWDL,EWDR,EWDB,EWDT,LNLG)
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE ELLIPS (XCFR,YCFR,RADA,RADB,ROTD,DSTP)
C
C This routine fills an ellipse.  The arguments are as follows:
C
C   XCFR and YCFR are the coordinates of the center of the ellipse, in
C   the fractional coordinate system.
C
C   RADA is the length of the semimajor axis of the ellipse (i.e., the
C   distance from the center of the ellipse to one of the two points on
C   the ellipse which are furthest from the center).  This is a distance
C   in the fractional coordinate system.
C
C   RADB is the length of the semiminor axis of the ellipse (i.e., the
C   distance from the center of the ellipse to one of the two points on
C   the ellipse which are nearest to the center).  This is a distance in
C   the fractional coordinate system.
C
C   ROTD is a rotation angle, in degrees.  If ROTD is 0, the major axis
C   of the ellipse is horizontal.  If ROTD is 90, the major axis is
C   vertical.
C
C   DSTP is the step size, in degrees, between any two consecutive
C   points used to draw the ellipse.  The actual value used will be
C   limited to the range from .1 degrees (3600 points used to draw
C   the ellipse) to 90 degrees (4 points used to draw the ellipse).
C
C Declare work arrays to hold the coordinates.
C
        DIMENSION XCRA(3601),YCRA(3601)
C
C DTOR is pi over 180, used to convert an angle from degrees to radians.
C
        DATA DTOR / .017453292519943 /
C
C Get the rotation angle in radians.
C
        ROTR=DTOR*ROTD
C
C Compute the number of steps to be used to draw the ellipse and the
C actual number of degrees for each step.
C
        NSTP=MAX(4,MIN(3600,INT(360./MAX(.1,MIN(90.,DSTP)))))
        RSTP=360./NSTP
C
C Compute coordinates for the ellipse (just some trigonometry).
C
        DO 101 ISTP=0,NSTP
          ANGL=DTOR*REAL(ISTP)*RSTP
          XTMP=RADA*COS(ANGL)
          YTMP=RADB*SIN(ANGL)
          XCRA(ISTP+1)=CFUX(XCFR+XTMP*COS(ROTR)-YTMP*SIN(ROTR))
          YCRA(ISTP+1)=CFUY(YCFR+XTMP*SIN(ROTR)+YTMP*COS(ROTR))
  101   CONTINUE
C
C Fill it.
C
        CALL GFA (NSTP+1,XCRA,YCRA)
C
C Draw it.
C
        CALL GPL (NSTP+1,XCRA,YCRA)
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE IPIQOS (ALAT,ALON,BLAT,BLON,CLAT,CLON,DLAT,DLON,
     +                                       XFRA,YFRA,ELAT,ELON)
C
C (IPIQOS = Interpolate Point In Quadrilateral on Sphere)
C
C This routine, given the latitudes and longitudes of four points (A, B,
C C, and D) forming a "quadrilateral" on the globe and two interpolation
C fractions (XFRA and YFRA, each between 0 and 1, inclusive), finds the
C point E defined by the following diagram and returns its latitude and
C longitude.
C
C                              C------Q----D
C                              |      |    |
C                              |      E    |
C                              |      |    |
C                              |      |    |
C                              A------P----B
C
C P and Q are positioned such that AP/AB = CQ/CD = XFRA and then E is
C positioned such that PE/PQ = YFRA (where "XY" is interpreted to mean
C "the shortest great circle distance from X to Y").
C
C It is assumed that the "quadrilateral" ABDC is "convex" (a working
C definition of which might be that none of the four great circles
C defined by its edges - the ones through A and B, B and D, D and C,
C and C and A - cross it anywhere.  However, this is not verified.
C
C The code is easy:
C
        CALL FPSGCR (ALAT,ALON,BLAT,BLON,XFRA,PLAT,PLON)
        CALL FPSGCR (CLAT,CLON,DLAT,DLON,XFRA,QLAT,QLON)
        CALL FPSGCR (PLAT,PLON,QLAT,QLON,YFRA,ELAT,ELON)
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE FPSGCR (ALAT,ALON,BLAT,BLON,FRCT,FLAT,FLON)
C
C (FPSGCR = Find Point on Shortest Great Circle Route)
C
        REAL    ALAT,ALON,BLAT,BLON,FRCT,FLAT,FLON
C
C This routine, given the latitudes and longitudes of two points A and
C B on the surface of the globe and a fraction FRCT, between 0. and 1.,
C interpolates a point F along the shortest great circle route joining
C A to B such that the distance from A to F, divided by the distance
C from A to B, is equal to FRCT, and returns its latitude and longitude
C in FLAT and FLON.
C
C Define the constants used to convert from degrees to radians and
C vice-versa.
C
        DATA DTOR / .017453292519943 /
        DATA RTOD / 57.2957795130823 /
C
C Compute the X, Y, and Z coordinates (on a unit sphere) of the point B.
C
        CALL LLPXYZ (BLAT,BLON,XCPB,YCPB,ZCPB)
C
C Rotating about the Z axis by the angle -ALON would carry A into the XZ
C plane.
C
        CALL ROTXYZ (3,-ALON,XCPB,YCPB,ZCPB)
C
C Then, rotating about the Y axis by the angle ALAT would carry A into
C the point on the X axis with coordinates (1,0,0).
C
        CALL ROTXYZ (2,ALAT,XCPB,YCPB,ZCPB)
C
C Then, rotating about the X axis by the angle ALPH = -ATAN(ZCPB/YCPB)
C would leave the position of A unchanged but carry B into a point in
C the XY plane.
C
        IF (ZCPB.NE.0..OR.YCPB.NE.0.) THEN
          ALPH=-RTOD*ATAN2(ZCPB,YCPB)
        ELSE
          ALPH=0.
        END IF
C
        CALL ROTXYZ (1,ALPH,XCPB,YCPB,ZCPB)
C
C The angle BETA from A to B can now be computed easily.
C
        IF (XCPB.NE.0..OR.YCPB.NE.0.) THEN
          BETA=ATAN2(YCPB,XCPB)
        ELSE
          BETA=0.
        END IF
C
C Interpolate a point at the desired position between the points A and
C B, map it back to its original position on the great circle route from
C A to B, and get its latitude and longitude to return to the caller.
C
        GAMA=FRCT*BETA
C
        XCPF=COS(GAMA)
        YCPF=SIN(GAMA)
        ZCPF=0.
C
        CALL ROTXYZ (1,-ALPH,XCPF,YCPF,ZCPF)
        CALL ROTXYZ (2,-ALAT,XCPF,YCPF,ZCPF)
        CALL ROTXYZ (3, ALON,XCPF,YCPF,ZCPF)
C
        CALL XYZLLP (XCPF,YCPF,ZCPF,FLAT,FLON)
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE LLPXYZ (RLAT,RLON,RVOX,RVOY,RVOZ)
C
C (LLPXYZ = Lat/Lon Position to XYZ coordinates)
C
C Given the latitude and longitude of a point on the globe, return its
C X, Y, and Z coordinates.
C
        DATA DTOR / .017453292519943 /
C
        RVOX=COS(DTOR*RLAT)*COS(DTOR*RLON)
        RVOY=COS(DTOR*RLAT)*SIN(DTOR*RLON)
        RVOZ=SIN(DTOR*RLAT)
C
        RETURN
C
      END


      SUBROUTINE XYZLLP (RVOX,RVOY,RVOZ,RLAT,RLON)
C
C (XYZLLP = XYZ coordinates to Lat/Lon Position)
C
C Given the X, Y, and Z coordinates of a point on the globe, return its
C latitude and longitude.
C
        DATA RTOD / 57.2957795130823 /
C
        RLAT=RTOD*ASIN(RVOZ)
C
        IF (RVOX.NE.0.OR.RVOY.NE.0.) THEN
          RLON=RTOD*ATAN2(RVOY,RVOX)
        ELSE
          RLON=0.
        END IF
C
        RETURN
C
      END


      SUBROUTINE ROTXYZ (IAXS,ANGL,XCRD,YCRD,ZCRD)
C
C (ROTXYZ = ROTate a point defined by its X, Y, and Z coordinates)
C
C This is a modified version of a routine in the NCAR Graphics package,
C which is used in some of the examples.  It rotates the point having
C coordinates (XCRD,YCRD,ZCRD) by an angle ANGL about the axis specified
C by IAXS (1 for the X axis, 2 for the Y axis, 3 for the Z axis).
C
C One assumes a right-handed system with X, Y, and Z axes.  Rotating by
C an angle "a" about the X axis maps the point (x,y,z) into the point
C (x',y',z'), where
C
C       x' = x
C       y' = y cos(a) - z sin(a)
C       z' = z cos(a) + y sin(a)
C
C A positive value of "a" represents rotation in the direction from the
C Y axis to the Z axis.
C
C Similarly, rotating by an angle "a" about the Y axis maps the point
C (x,y,z) into the point (x',y',z'), where
C
C       x' = x cos(a) + z sin(a)
C       y' = y
C       z' = z cos(a) - x sin(a)
C
C A positive value of "a" represents rotation in the direction from the
C Z axis to the X axis.
C
C Rotating by an angle "a" about the Z axis maps the point (x,y,z) into
C the point (x',y',z'), where
C
C       x' = x cos(a) - y sin(a)
C       y' = y cos(a) + x sin(a)
C       y' = y
C
C A positive value of "a" represents rotation in the direction from the
C X axis to the Y axis.
C
C Define a multiplicative constant to convert from degrees to radians.
C
        DATA DTOR / .017453292519943 /
C
C Trigonometry.
C
        SINA=SIN(DTOR*ANGL)
        COSA=COS(DTOR*ANGL)
C
        XTMP=XCRD
        YTMP=YCRD
        ZTMP=ZCRD
C
        IF (IAXS.EQ.1) THEN
          YCRD=YTMP*COSA-ZTMP*SINA
          ZCRD=ZTMP*COSA+YTMP*SINA
        ELSE IF (IAXS.EQ.2) THEN
          XCRD=XTMP*COSA+ZTMP*SINA
          ZCRD=ZTMP*COSA-XTMP*SINA
        ELSE
          XCRD=XTMP*COSA-YTMP*SINA
          YCRD=YTMP*COSA+XTMP*SINA
        END IF
C
        RETURN
C
      END


      SUBROUTINE CTSCAE (ICRA,ICA1,ICAM,ICAN,XCPF,YCPF,XCQF,YCQF,
     +                                       IND1,IND2,ICAF,IAID)
        DIMENSION ICRA(ICA1,*)
C
C This routine is called by CTCICA when the internal parameter 'CAF' is
C given a negative value.  Each call is intended to create a particular
C element in the user's cell array.  The arguments are as follows:
C
C ICRA is the user's cell array.
C
C ICA1 is the first dimension of the FORTRAN array ICRA.
C
C ICAM and ICAN are the first and second dimensions of the cell array
C stored in ICRA.
C
C (XCPF,YCPF) is the point at that corner of the rectangular area
C into which the cell array maps that corresponds to the cell (1,1).
C The coordinates are given in the fractional coordinate system (unlike
C what is required in a call to GCA, in which the coordinates of the
C point P are in the world coordinate system).
C
C (XCQF,YCQF) is the point at that corner of the rectangular area into
C which the cell array maps that corresponds to the cell (ICAM,ICAN).
C The coordinates are given in the fractional coordinate system (unlike
C what is required in a call to GCA, in which the coordinates of the
C point Q are in the world coordinate system).
C
C IND1 is the 1st index of the cell that is to be updated.
C
C IND2 is the 2nd index of the cell that is to be updated.
C
C ICAF is the current value of the internal parameter 'CAF'.  This
C value will always be an integer which is less than zero (because
C when 'CAF' is zero or greater, this routine is not called).
C
C IAID is the area identifier associated with the cell.  It will have
C been given one of the values from the internal parameter array 'AIA'
C (the one for 'PAI' = -2 if the cell lies in an out-of-range area, the
C one for 'PAI' = -1 if the cell lies off the data grid, or the one for
C some value of 'PAI' between 1 and 'NCL' if the cell lies on the data
C grid).  The value zero may occur if the cell falls in an out-of-range
C area and the value of 'AIA' for 'PAI' = -2 is 0 or if the cell lies
C off the data grid and the value of 'AIA' for 'PAI' = -1 is 0, or if
C the cell falls on the data grid, but no contour level below the cell
C has a non-zero 'AIA' and no contour level above the cell has a
C non-zero 'AIB'.  Note that, if the values of 'AIA' for 'PAI' = -1
C and -2 are given non-zero values, IAID can only be given a zero
C value in one way.
C
C The default behavior of CTSCAE is as follows:  If the area identifier
C is non-negative, it is treated as a color index, to be stored in the
C appropriate cell in the cell array; but if the area identifier is
C negative, a zero is stored for the color index.  The user may supply
C a version of CTSCAE that does something different; it may simply map
C the area identifiers into color indices or it may somehow modify the
C existing cell array element to incorporate the information provided
C by the area identifier.
C
C       ICRA(IND1,IND2)=MAX(0,IAID)
C
C What follows is not the default behavior; instead, it is the behavior
C expected by many of the example programs for CONPACKT.
C
        CALL CTGETI ('NCL - NUMBER OF CONTOUR LEVELS',NOCL)
C
        IF (IAID.GE.1.AND.IAID.LE.NOCL+1) THEN
          ICRA(IND1,IND2)=151+INT(((REAL(IAID)-.5)/REAL(NOCL+1))*100.)
        ELSE IF (IAID.EQ.1001) THEN
          ICRA(IND1,IND2)=2
        ELSE IF (IAID.EQ.1002) THEN
          ICRA(IND1,IND2)=3
        END IF
C
        RETURN
C
      END

C
C	$Id: cfvld.f,v 1.5 2008-07-27 00:23:02 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CFVLD (IENTRY,IIX,IIY)
C
C CFVLD CONNECTS POINTS WHOSE COORDINATES ARE SUPPLIED IN THE ARGUMENTS,
C ACCORDING TO THE DASH PATTERN WHICH IS PASSED FROM ROUTINE DASHDB IN
C THE ARRAY IP IN COMMON DSHD.
C
C
      COMMON /DSHD/   ISL        ,L          ,IP(16)
      COMMON /DSHDA/  IFSTFL
      COMMON /DSHDB/ X,Y,X2,Y2,M,BTI,IB,IX,IY
      COMMON/INTPR/IPAU,FPART,TENSN,NP,SMALL,L1,ADDLR,ADDTB,MLLINE,
     1    ICLOSE
      SAVE
C
C CMN IS USED TO DETERMINE WHEN TO STOP DRAWING A LINE SEGMENT
C
      DATA CMN/1.5/
C
C IMPOS IS USED AS AN IMPOSSIBLE PEN POSITION.
C
      DATA IMPOS /-9999/
C
C
C  ISL= -1  ALL BLANK  ) FLAG TO AVOID MOST CALCULATIONS
C        0  DASHED     )   IF PATTERN IS ALL SOLID OR
C        1  ALL SOLID  )   ALL BLANK
C
C     X,IX,Y,IY    CURRENT POSITION
C     X1,Y1        START OF A USER LINE SEGMENT
C     X2,Y2        END OF A USER LINE SEGMENT
C
C  SEGMENT TYPES ARE RECOGNIZED AS FOLLOWS
C     SOLID - WORD IN IP-ARRAY CONTAINS POSITIVE INTEGER LESS THAN
C              16*IPAU*2**(15-10)
C     GAP - WORD IN IP-ARRAY CONTAINS NEGATIVE INTEGER, ABSOLUTE VALUE
C              OF WHICH IS LESS THAN 16*IPAU*2**(15-10)
C     THE IP ARRAY IS COMPOSED OF L ELEMENTS.
C
C     BTI - BITS THIS INCREMENT
C     BPBX,BPBY BITS PER BIT X(Y)
C
C
C BRANCH DEPENDING ON FUNCTION TO BE PERFORMED.
C
      GO TO (330,305,350),IENTRY
C
C INITIALIZE VARIABLES (ENTRY FRSTD ONLY)
C
   30 CONTINUE
      X = IX
      Y = IY
      X2 = X
      Y2 = Y
      M = 1
      MX = ABS(IP(1))
      BTI = MX
      IB = SIGN(1,IP(1))
      GO TO 300
C
C MAIN LOOP START
C
   50 CONTINUE
         X1 = X2
         Y1 = Y2
         MX = IIX
         MY = IIY
         X2 = MX
         Y2 = MY
         DX = X2-X1
         DY = Y2-Y1
         D = SQRT(DX*DX+DY*DY)
         IF (D .LT. CMN) GO TO 190
         BPBX = DX/D
         BPBY = DY/D
         CALL DRAWPV (IX,IY,0)
   70    BTI = BTI-D
         IF (BTI) 100,100,80
C
C LINE SEGMENT WILL FIT IN CURRENT PATTERN ELEMENT
C
   80    X = X2
         Y = Y2
         IX = X2
         IY = Y2
         IF (IB) 200,300,90
   90    CALL DRAWPV (IX,IY,1)
         GO TO 200
C
C LINE SEGMENT WONT FIT IN CURRENT PATTERN ELEMENT
C DO IT TO END OF ELEMENT, SAVE HOW MUCH OF SEGMENT LEFT TO DO (D)
C
  100    BTI = BTI+D
         D = D-BTI
         X = X+BPBX*BTI
         Y = Y+BPBY*BTI
         IX = X+.5
         IY = Y+.5
         IF (IB) 110,300,120
  110    CALL DRAWPV (IX,IY,0)
         GO TO 130
  120    CALL DRAWPV (IX,IY,1)
C
C GET THE NEXT PATTERN ELEMENT
C
  130    M = MOD(M,L)+1
         MX = ABS(IP(M))
         BTI = MX
         IB = SIGN(1,IP(M))
         GO TO 70
  190    X2 = X1
         Y2 = Y1
  200 CONTINUE
  300 RETURN
C
C *************************************
C
C ENTRY VECTD (XX,YY)
C
  305 CONTINUE
C
C TEST FOR PREVIOUS CALL TO FRSTD.
C
      IF (IFSTFL .EQ. 2) GO TO 310
C
C INFORM USER - NO PREVIOUS CALL TO FRSTD. TREAT CALL AS FRSTD CALL.
C
      CALL SETER('CFVLD - VECTD CALL OCCURS BEFORE A CALL TO FRSTD',
     -           2,2)
      GO TO 330
  310 CONTINUE
      IF (ISL) 300,50,320
  320 IX = IIX
      IY = IIY
      CALL DRAWPV (IX,IY,1)
      GO TO 300
C
C *************************************
C
C     ENTRY FRSTD (FLDX,FLDY)
C
  330 IX = IIX
      IY = IIY
      IFSTFL = 2
C AVOID UNEXPECTED PEN POSITION IF CALLS TO SYSTEM PLOT PACKAGE
C ROUTINES WERE MADE.
      CALL DRAWPV (IMPOS,IMPOS,2)
      IF (ISL) 300,30,340
  340 CALL DRAWPV (IX,IY,0)
      GO TO 300
C
C *************************************
C
C     ENTRY LASTD
C
  350 CONTINUE
C
C     THIS ENTRY JUST FOR UPWARD COMPATIBILITY
C
      GO TO 300
      END

C
C $Id: plchhq.f,v 1.27 2008-07-27 00:17:20 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE PLCHHQ (XPOS,YPOS,CHRS,SIZE,ANGD,CNTR)
C
C This is the high-quality character-drawing routine.
C
C
C D E C L A R A T I O N S
C
C
      CHARACTER CHRS*(*)
C
C PARAMETER statements.  The value of MDGU declared here depends on the
C maximum number of elements that can ever be returned in the array RDGU
C by the routine PCCFFF.  One should use here whatever that value is,
C plus a fudge factor to compensate for the fact that, when mapping is
C turned on, PLCHHQ interpolates X/Y coordinates along long straight
C portions of character boundaries that were originally defined by just
C two points at the ends.  If the value of MDGU is changed, the common
C block PCSVEM must be modified in all routines in which it is declared;
C the PARAMETER statement only occurs in this one.
C
      PARAMETER (MDGU=7000,MCRA=MDGU/2,MPCS=32,NCSO=256)
C
C COMMON block declarations.  PCPRMS holds user-accessible internal
C parameters that do not affect the routine PLCHMQ.  PCSVEM holds other
C variables that are either used in more than one routine or that need
C to be saved from one call to the next.  PCPFLQ holds the values of
C internal parameters that affect routines besides PLCHHQ.
C
C Note that the sizes of IDDA and INDA may be reduced to match the
C values of IDDL and INDL computed below.
C
      COMMON /PCPRMS/ ADDS,CONS,DSTB,DSTL,DSTR,DSTT,HPIC(3),IBNU,
     +                IBXC(3),IBXF,ICEN,IORD,IOUC,IOUF,IPCC,IQUF,
     +                ISHC,ISHF,ITEF,JCOD,LSCI(16),NFCC,NODF,RBXL,
     +                RBXM,RBXX,RBXY,ROLW,RPLW,RSLW,SHDX,SHDY,SIZA,
     +                SSIC,SSPR,SUBS,VPIC(3),WPIC(3),XBEG,XCEN,XEND,
     +                XMUL(3),YBEG,YCEN,YEND,YMUL(3),ZINX,ZINY,ZINZ
      SAVE   /PCPRMS/
C
      COMMON /PCSVEM/ ICOD,IDDA(8625),IDDL,RDGU(MDGU),IDPC(256),IERU,
     +                INDA(789),INDL,INIT,IVCO,IVDU,NBPW,NPPW
      SAVE   /PCSVEM/
C
      COMMON /PCPFLQ/ IMAP,OORV,RHTW
      SAVE   /PCPFLQ/
C
C Define X and Y coordinate arrays to be used in calls to GPL and GFA.
C
      DIMENSION XCRA(MCRA),YCRA(MCRA)
C
C Declare some arrays in which to put pointers to pieces of a character
C that lies partly inside and partly outside the area visible under a
C given mapping.  We also have to save the X and Y coordinates at the
C beginning and end of each visible chunk of the character, so as to
C be able to interpolate points along the visible/invisible boundary
C between the visible chunks.
C
      DIMENSION IPCB(MPCS),IPCE(MPCS)
      DIMENSION XPCB(MPCS),YPCB(MPCS)
      DIMENSION XPCE(MPCS),YPCE(MPCS)
C
C Define arrays in which to put multipliers representing the combined
C effects of changing 'PH', 'PW', 'IH', 'IW', 'CH', 'CW', and the
C zoom factor.
C
      DIMENSION XMZM(3),YMZM(3)
C
C Define arrays implementing the subscript/superscript stack.
C
      DIMENSION NLEV(5),XCNO(5),YCNO(5),XRGO(5),YRGO(5),ICSO(5),ISZO(5),
     +          CSTO(5),SNTO(5)
C
C Define an array to hold the codes associated with 19 "special" ASCII
C characters which might occur in CHRS and for which we will attempt
C to provide a proper response.
C
      DIMENSION ISPC(19)
C
C Define a character array in which to define the characters to be
C associated with values of NDPC from 1 to 96.  DPC was the set of
C six-bit character codes used on the CDC 7600 (the machine on which
C PWRITX, the predecessor of PLCHHQ, was first implemented) and the
C digitization arrays of the PWRITX database are arranged in DPC order.
C For NDPC = 1 to 47, CDPC(NDPC) is the character that the DPC codes
C associated with that index value.  For NDPC = 48 to 73, CDPC(NDPC)
C is a lower-case letter.  For NDPC = 74 to 95, CDPC(NDPC) is an ASCII
C character which may be used in the input character string and for
C which we wish to select a meaningful character from the PWRITX
C database.  CDPC(96) is a blank; NDPC = 96 is used only as a signal
C that an octal function code has been found in the input character
C string, selecting a particular character from the PWRITX database.
C
      CHARACTER*1 CDPC(96)
C
C Define an array in which to define the ASCII decimal equivalents of
C the characters in CDPC.
C
      DIMENSION IASC(96)
C
C Declare an array in which to put some standard character heights,
C for use in calls to PCCFFF.
C
      DIMENSION SPIC(3)
C
C Define arrays in which to save the information required to draw the
C characters resulting from a single string.  These arrays allow us to
C easily do the separate passes needed for shadows and outlines and to
C do each of the passes either from left to right or from right to left
C in the character string.
C
      DIMENSION XCSV(NCSO),YCSV(NCSO),XMSV(NCSO),YMSV(NCSO),NFSV(NCSO),
     +          NDSV(NCSO),INSV(NCSO),NASV(NCSO),IPSV(NCSO)
C
      CHARACTER*(NCSO) CHSV
C
C Define arrays in which to save the definitions of the window and
C the viewport of the current normalization transformation.
C
      DIMENSION WNTC(4),VNTC(4)
C
C Declare an array in which to save text extent information for specific
C characters from specific fonts.
C
      DIMENSION STEI(6,95,37)
      SAVE STEI
C
C Define the characters to be associated with values of NDPC from 1
C to 96.
C
      DATA CDPC / 'A','B','C','D','E','F','G','H','I','J',
     +            'K','L','M','N','O','P','Q','R','S','T',
     +            'U','V','W','X','Y','Z','0','1','2','3',
     +            '4','5','6','7','8','9','+','-','*','/',
     +            '(',')','$','=',' ',',','.','a','b','c',
     +            'd','e','f','g','h','i','j','k','l','m',
     +            'n','o','p','q','r','s','t','u','v','w',
     +            'x','y','z','!','"','#','%','&',':',';',
     +            '<','>','?','@','[','\\',']','{','|','}',
     +            '~','''','^','_','`',' '               /
C
C Define the ASCII decimal equivalents of the characters in CDPC.
C
      DATA IASC /  65, 66, 67, 68, 69, 70, 71, 72, 73, 74,
     +             75, 76, 77, 78, 79, 80, 81, 82, 83, 84,
     +             85, 86, 87, 88, 89, 90, 48, 49, 50, 51,
     +             52, 53, 54, 55, 56, 57, 43, 45, 42, 47,
     +             40, 41, 36, 61, 32, 44, 46, 97, 98, 99,
     +            100,101,102,103,104,105,106,107,108,109,
     +            110,111,112,113,114,115,116,117,118,119,
     +            120,121,122, 33, 34, 35, 37, 38, 58, 59,
     +             60, 62, 63, 64, 91, 92, 93,123,124,125,
     +            126, 39, 94, 95, 96, 32                /
C
C Define the number of card images used to represent the contents of
C the arrays INDA and IDDA.  These are used to compute the number of
C binary words to be read into these arrays.
C
      DATA ICND,ICDD / 49,575 /
C
C Define indices for font, size, and case definitions.  These indices
C are used as displacements into the array INDA.  The sum of a font
C index (Roman or Greek), a size index (principal, indexical, or
C cartographic), a case index (upper or lower), and the DPC code for
C a particular character uniquely defines the index of an entry in
C INDA pointing to the proper digitization in the array IDDA.
C
      DATA IFRO,IFGR      / 0,384     /
      DATA ISZP,ISZI,ISZC / 0,128,256 /
      DATA ICSU,ICSL      / 0, 64     /
C
C Define the codes associated with 19 "special" ASCII characters which
C might possibly appear in CHRS.
C
      DATA ISPC / 93,484,485,111,421,91,92,99,100,94,321,105,337,106,
     +            745,336,746,431,483 /
C
C Define the standard character heights for principal, indexical, and
C cartographic sizes, for use in calls to PCCFFF.
C
      DATA SPIC / 21. , 13. , 9. /
C
C Initialize the array of text-extent information.
C
      DATA STEI / 21090*0. /
C
C
C I N I T I A L I Z A T I O N
C
C
C Do calls forcing BLOCKDATAs to be loaded from a binary library.
C
      CALL PCBLDA
      CALL PCBDFF
C
C Check for an uncleared prior error.
C
      IF (ICFELL('PLCHHQ - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C If it hasn't already been done, do that part of the initialization
C which is done only once per loading of the routine.
C
      IF (INIT.EQ.0) THEN
C
        INIT=1
C
C NBPW is the number of bits per word and NPPW is the number of 15-bit
C parcels per word.  INDL and IDDL are the number of words to be read
C into the arrays INDA and IDDA, respectively.
C
        NBPW=I1MACH(5)
        NPPW=NBPW/15
        INDL=(ICND*16-1)/NPPW+1
        IDDL=(ICDD*16*15-1)/NBPW+1
C
C Define the error file logical unit number.
C
        IERU=I1MACH(4)
C
C If it hasn't already been done, initialize the numeric equivalent of
C the function code character.
C
        IF (NFCC.LT.0) NFCC=ICHAR(':')
C
C Initialize the table IDPC.  For a given character "c", IDPC(ICHAR(c))
C is the integer value of the equivalent of "c" in an augmented DPC
C character set.  DPC was the set of six-bit character codes used on
C the CDC 7600 (the machine on which the predecessor of PLCHHQ was
C first implemented) and the digitization arrays are arranged in DPC
C order.  First, all undefined entries are zeroed.
C
        DO 101 I=1,256
          IDPC(I)=0
  101   CONTINUE
C
C Then, the entries are defined, one at a time.
C
        DO 102 NDPC=1,95
          NCOL=ICHAR(CDPC(NDPC))
          IF (NCOL.GE.1.AND.NCOL.LE.256) THEN
            IF (IDPC(NCOL).EQ.0) IDPC(NCOL)=NDPC
          END IF
  102   CONTINUE
C
C Set the flag ICOD to force loading of the dataset implied by the
C user-set or default value of JCOD.
C
        ICOD=-1
C
      END IF
C
C Get the coordinates of the string position.  These are in the
C fractional system if mapping is turned off; otherwise, they are
C in an arbitrary X/Y system.
C
      IF (IMAP.LE.0) THEN
        XFRA=CUFX(XPOS)
        IF (ICFELL('PLCHHQ',2).NE.0) RETURN
        YFRA=CUFY(YPOS)
        IF (ICFELL('PLCHHQ',3).NE.0) RETURN
      ELSE
        XFRA=XPOS
        YFRA=YPOS
      END IF
C
C Determine the resolution of the plotter, as declared by default or
C by the user.
C
      CALL GETUSV ('XF',IRSX)
      IF (ICFELL('PLCHHQ',4).NE.0) RETURN
      RSLN=2.**IRSX-1.
C
C Determine a multiplier for the digitized size which will make the
C characters have the size requested by the user.
C
      IF (IMAP.LE.0) THEN
        IF (SIZE.LE.0.) THEN
          SIZM=ABS(SIZE)/1023.
        ELSE IF (SIZE.LT.1.) THEN
          SIZM=SIZE/WPIC(1)
        ELSE
          SIZM=(SIZE/RSLN)/WPIC(1)
        END IF
      ELSE
        SIZM=SIZE/WPIC(1)
      END IF
C
C If high-quality characters are being used, multiply by a fudge factor
C whose default value of 8/9 makes characters produced by PLCHHQ have
C the same height as those produced by PLCHMQ.  (By setting the value
C of this fudge factor to 1, a user can make things work more or less
C the way they used to.)
C
      IF (IQUF.EQ.0) SIZM=SIZA*SIZM
C
C If high-quality characters are to be used, load the high-quality
C character dataset.
C
      IF (IQUF.EQ.0) THEN
C
C If no dataset has been read, or if the user has requested the other
C one of the two, read the proper one.  The first time a given dataset
C is read, verify that it has been done correctly.
C
        IF (ICOD.NE.JCOD) THEN
C
          IBNS=IBNU
          CALL PCFOPN (IBNU,0)
          IF (ICFELL('PLCHHQ',5).NE.0) RETURN
C
          IF (JCOD.NE.0) THEN
            CALL PCFRED (IBNU,0,INDA,INDL)
            IF (ICFELL('PLCHHQ',6).NE.0) RETURN
            CALL PCFRED (IBNU,0,IDDA,IDDL)
            IF (ICFELL('PLCHHQ',7).NE.0) RETURN
          END IF
C
          CALL PCFRED (IBNU,0,INDA,INDL)
          IF (ICFELL('PLCHHQ',8).NE.0) RETURN
          CALL PCFRED (IBNU,0,IDDA,IDDL)
          IF (ICFELL('PLCHHQ',9).NE.0) RETURN
C
          CALL PCFCLS (IBNU,0)
          IF (ICFELL('PLCHHQ',10).NE.0) RETURN
          IBNU=IBNS
C
          IERR=0
          IF (JCOD.EQ.0.AND.IVCO.EQ.0) THEN
            CALL PCCCHK (IERR)
            IVCO=1
          END IF
          IF (JCOD.NE.0.AND.IVDU.EQ.0) THEN
            CALL PCDCHK (IERR)
            IVDU=1
          END IF
          IF (IERR.NE.0) THEN
            CALL SETER ('PLCHHQ - DATASET NOT LOADED CORRECTLY',IERR,1)
            RETURN
          END IF
C
          ICOD=JCOD
C
        END IF
C
C If lower-quality characters are to be used, save the PLCHMQ parameter
C specifying the ratio of character height to character width.
C
      ELSE
C
        RHWO=RHTW
C
      END IF
C
C Set the orientation angle, in radians, and determine the components
C of various vectors in the direction of the string and at right angles
C to it.
C
      ANGR=.017453292519943*ANGD
C
      SINO=SIN(ANGR)
      COSO=COS(ANGR)
      STSO=SIZM*SINO
      STCO=SIZM*COSO
      SINM=SIN(ANGR-1.57079632679489)
      COSM=COS(ANGR-1.57079632679489)
      SINP=SIN(ANGR+1.57079632679489)
      COSP=COS(ANGR+1.57079632679489)
C
C Find the number of characters in the user's input string.
C
      NCHR=LEN(CHRS)
C
C Initialize the number of the last generated character saved for the
C drawing passes.  (If there are fewer than NCSO characters, they can
C all be saved at once; otherwise, we have to make more than one pass
C through the input string.)
C
      ILCS=0
C
C Initialize the number of the last character generated during the
C first pass.  (When more than NCSO characters are defined by the
C input string, it is necessary to return to this point and repeat
C this pass, saving another batch of characters.)
C
  103 ILCG=0
C
C Zero the count of characters for which information has been saved.
C
      NCSV=0
C
C During this pass, we use an arbitrary starting position, run through
C the character string without drawing anything, and see what the final
C position is.  Then, during the drawing passes, we use this information
C to properly position the characters drawn.
C
      XBEG=XFRA
      YBEG=YFRA
C
C Set the current font number to the appropriate default.
C
      NFNT=NODF
C
C Make three copies of the starting position for various purposes.
C (XBOL,YBOL) is the point at the beginning of the current line.
C (XCEN,YCEN) is the point at the center of the last character.
C (XRGT,YRGT) is the point at the right end of the last character.
C
      XBOL=XBEG
      YBOL=YBEG
      XCEN=XBEG
      YCEN=YBEG
      XRGT=XBEG
      YRGT=YBEG
C
C Set the index of the last character examined in the input.
C
      ICHR=0
C
C Initialize the index offsets for font, size, and case to Roman,
C principal, and upper, respectively.
C
      IFNT=IFRO
      ISZE=ISZP
      ICSE=ICSU
C
C Initialize the index that says what size the current character is.
C
      IPIC=1
C
C Zero the character counts for "writing down" and for case change.
C
      NDWN=0
      NCSE=0
C
C Zero the variable defining the vertical space used by the previous
C character, which is used for vertical spacing when "writing down".
C
      VEPC=0.
C
C Zero variables which affect the spacing between characters.
C
      ADDP=0.
      SUBP=0.
C
C Set the current subscript/superscript level.
C
      NSSL=0
C
C Set the flag to indicate that we're not currently processing function
C codes.
C
      IPFC=0
C
C Initialize the multipliers representing the combined effects of
C changing 'PH', 'PW', 'IH', 'IW', 'CH', 'CW', and the zoom factor.
C
      XMZM(1)=ZINX*ZINZ*XMUL(1)
      XMZM(2)=ZINX*ZINZ*XMUL(2)
      XMZM(3)=ZINX*ZINZ*XMUL(3)
      YMZM(1)=ZINY*ZINZ*YMUL(1)
      YMZM(2)=ZINY*ZINZ*YMUL(2)
      YMZM(3)=ZINY*ZINZ*YMUL(3)
C
C If text extent quantities are to be computed, initialize the needed
C quantities.
C
      IF (ITEF.EQ.0.AND.ICEN.EQ.0.AND.IBXF.EQ.0) THEN
        IPSS=1
      ELSE
        IPSS=2
        DSTL=-1.E6
        DSTR=-1.E6
        DSTB=-1.E6
        DSTT=-1.E6
      END IF
C
C
C P R O C E S S   T H E   N E X T   C H A R A C T E R
C
C
C If there are no more characters in the string, jump to end-of-string
C processor.
C
  104 IF (ICHR.GE.NCHR) GO TO 108
C
C Get the next character from the string.  NCOL is the number of the
C character in the character collating sequence on the machine on
C which PLCHHQ is being run.
C
      ICHR=ICHR+1
      NCOL=ICHAR(CHRS(ICHR:ICHR))
C
C If the function-code signal character is encountered, flip the value
C of the function-code processing flag and go get the next character.
C Two function-code signal characters in a row are treated as a single
C occurrence of the character itself, selecting a character to be drawn.
C
      IF (NCOL.EQ.NFCC) THEN
        IF (IPFC.EQ.0.AND.ICHR.LT.NCHR) THEN
          NNXT=ICHAR(CHRS(ICHR+1:ICHR+1))
        ELSE
          NNXT=-1
        END IF
        IF (NNXT.EQ.NFCC) THEN
          ICHR=ICHR+1
        ELSE
          IPFC=1-IPFC
          GO TO 104
        END IF
      END IF
C
C NDPC is the number of the character in the DPC collating sequence.
C
      NDPC=IDPC(NCOL)
C
C If function codes are being processed, jump to the function code
C processor.
C
      IF (IPFC.NE.0) GO TO 128
C
C If the character is not one of the "standard" ones, take special
C action.  Lower-case alphabetic characters behave like upper-case
C alphabetic characters, but force the case to "lower".  "Special"
C characters yield a particular index into the PWRITX database or, in
C three cases, a blank.  As a last resort, a star is used.
C
      IF (NDPC.LT.1.OR.NDPC.GT.47) THEN
        IF (NDPC.GE.48.AND.NDPC.LE.73) THEN
          INDP=IFNT+ISZE+ICSL+NDPC-47
        ELSE IF (NDPC.GE.74.AND.NDPC.LE.92) THEN
          INDP=ISPC(NDPC-73)
        ELSE IF (NDPC.GE.93.AND.NDPC.LE.95) THEN
          INDP=45
        ELSE
          INDP=358
        END IF
        GO TO 105
      END IF
C
C Compute the index of the entry in INDA which points to the proper
C digitization in IDDA.
C
      INDP=IFNT+ISZE+ICSE+NDPC
C
C If high-quality characters are being used, get the digitization of
C the character in the array RDGU; if no digitization is found, try a
C star instead; if that can't be found, there's a more serious error.
C In any case, define the distances from the center of the character to
C its left and right ends.  Note: I have some doubts about the setting
C of CHFS to .1 in the following code (though it seems to have worked
C okay for a very long time).
C
  105 IF (IQUF.EQ.0) THEN
        IF (NFNT.EQ.0.OR.NDPC.LT.1.OR.NDPC.GT.95.OR.INDP.EQ.95) THEN
          CALL PCEXCD (INDP,IPSS,NDGU)
        ELSE
          IF (ICSE.NE.ICSL.OR.NDPC.LT.1.OR.NDPC.GT.26) THEN
            KDPC=NDPC
          ELSE
            KDPC=NDPC+47
          END IF
          NASC=IASC(KDPC)
          MFNT=MOD(NFNT,100)
          IF (ITEF.NE.0.AND.ANGD.EQ.360..AND.
     +        STEI(1,KDPC,MFNT).NE.0.) THEN
            RDGU(1)=SPIC(IPIC)*STEI(1,KDPC,MFNT)
            RDGU(2)=SPIC(IPIC)*STEI(2,KDPC,MFNT)
            RDGU(3)=SPIC(IPIC)*STEI(3,KDPC,MFNT)
            RDGU(4)=SPIC(IPIC)*STEI(4,KDPC,MFNT)
            RDGU(5)=SPIC(IPIC)*STEI(5,KDPC,MFNT)
            RDGU(6)=SPIC(IPIC)*STEI(6,KDPC,MFNT)
            NDGU=6
          ELSE
            IF (NFNT.GE.1.AND.NFNT.LE.20) THEN
              CALL PCCFFC (IPSS,IBNU,NFNT,NASC,SPIC(IPIC),
     +                                     RDGU,MDGU,NDGU)
              IF (ICFELL('PLCHHQ',11).NE.0) RETURN
            ELSE
              IF (IMAP.LE.0) THEN
                CHFS=SIZM*HPIC(IPIC)
              ELSE
                CHFS=.1
              END IF
              CALL PCCFFF (IPSS,IBNU,NFNT,NASC,SPIC(IPIC),CHFS,
     +                                          RDGU,MDGU,NDGU)
              IF (ICFELL('PLCHHQ',12).NE.0) RETURN
            END IF
            IF (NDGU.EQ.0) THEN
              CALL PCCFFC (IPSS,IBNU,1,NASC,SPIC(IPIC),RDGU,MDGU,NDGU)
              IF (ICFELL('PLCHHQ',13).NE.0) RETURN
              IF (NDGU.EQ.0) CALL PCEXCD (INDP,IPSS,NDGU)
            END IF
            IF (NDGU.GT.2.AND.STEI(1,KDPC,MFNT).EQ.0.) THEN
              STEI(1,KDPC,MFNT)=RDGU(1)/SPIC(IPIC)
              STEI(2,KDPC,MFNT)=RDGU(2)/SPIC(IPIC)
              STEI(3,KDPC,MFNT)=0.
              STEI(4,KDPC,MFNT)=0.
              STEI(5,KDPC,MFNT)=0.
              STEI(6,KDPC,MFNT)=0.
              DO 106 I=3,NDGU-1,2
                IF (RDGU(I).GT.-2047.) THEN
                  STEI(3,KDPC,MFNT)=MIN(STEI(3,KDPC,MFNT),
     +                                  RDGU(I  )/SPIC(IPIC))
                  STEI(4,KDPC,MFNT)=MIN(STEI(4,KDPC,MFNT),
     +                                  RDGU(I+1)/SPIC(IPIC))
                  STEI(5,KDPC,MFNT)=MAX(STEI(5,KDPC,MFNT),
     +                                  RDGU(I  )/SPIC(IPIC))
                  STEI(6,KDPC,MFNT)=MAX(STEI(6,KDPC,MFNT),
     +                                  RDGU(I+1)/SPIC(IPIC))
                END IF
  106         CONTINUE
            END IF
          END IF
        END IF
        IF (NDGU.EQ.0) THEN
          CALL PCEXCD (358,IPSS,NDGU)
          IF (NDGU.EQ.0) THEN
            CALL SETER ('PLCHHQ - INTERNAL LOGIC ERROR (NDGU = 0) - SEE
     +CONSULTANT',14,1)
            RETURN
          END IF
        END IF
        IF (CONS.EQ.0.) THEN
          DTLE=-XMZM(IPIC)*RDGU(1)
          DTRE= XMZM(IPIC)*RDGU(2)
        ELSE IF (CONS.LT.0.) THEN
          DTLE=-CONS
          DTRE=-CONS
        ELSE
          DTLE=CONS*WPIC(IPIC)
          DTRE=CONS*WPIC(IPIC)
        END IF
      ELSE
        DTLE=.5*WPIC(IPIC)
        DTRE=.5*WPIC(IPIC)
      END IF
C
C If this character is to be "written down" (that is to say, beneath
C the previous character), arrange for that.  Otherwise, just zero the
C "last character written down" flag.  Note that, while subscripting
C or superscripting is in progress, "writing down" is suspended.
C
      IF (NDWN.GT.0.AND.NSSL.EQ.0) THEN
        LCWD=1
        XCEN=XCEN+.5*SIZM*(VEPC+VPIC(IPIC))*COSM
        YCEN=YCEN+.5*SIZM*(VEPC+VPIC(IPIC))*SINM
        IF (ADDP.NE.0.) THEN
          IF (ADDS.LT.0.) THEN
            XCEN=XCEN+SIZM*ADDP*COSM
            YCEN=YCEN+SIZM*ADDP*SINM
          ELSE
            XCEN=XCEN+SIZM*.5*(ADDP+ADDS*WPIC(IPIC))*COSM
            YCEN=YCEN+SIZM*.5*(ADDP+ADDS*WPIC(IPIC))*SINM
          END IF
        END IF
        IF (SUBP.NE.0.) THEN
          IF (SUBS.LT.0.) THEN
            XCEN=XCEN-SIZM*SUBP*COSM
            YCEN=YCEN-SIZM*SUBP*SINM
          ELSE
            XCEN=XCEN-SIZM*.5*(SUBP+SUBS*WPIC(IPIC))*COSM
            YCEN=YCEN-SIZM*.5*(SUBP+SUBS*WPIC(IPIC))*SINM
          END IF
        END IF
        NDWN=NDWN-1
      ELSE
        LCWD=0
      END IF
C
C Find the coordinates of the center and the right end of the new
C character.
C
      IF (LCWD.EQ.0) THEN
        XCEN=XRGT+DTLE*STCO
        YCEN=YRGT+DTLE*STSO
        IF (ADDP.NE.0.) THEN
          IF (ADDS.LT.0.) THEN
            XCEN=XCEN+ADDP*STCO
            YCEN=YCEN+ADDP*STSO
          ELSE
            XCEN=XCEN+.5*(ADDP+ADDS*WPIC(IPIC))*STCO
            YCEN=YCEN+.5*(ADDP+ADDS*WPIC(IPIC))*STSO
          END IF
        END IF
        IF (SUBP.NE.0.) THEN
          IF (SUBS.LT.0.) THEN
            XCEN=XCEN-SUBP*STCO
            YCEN=YCEN-SUBP*STSO
          ELSE
            XCEN=XCEN-.5*(SUBP+SUBS*WPIC(IPIC))*STCO
            YCEN=YCEN-.5*(SUBP+SUBS*WPIC(IPIC))*STSO
          END IF
        END IF
      END IF
C
      XRGT=XCEN+DTRE*STCO
      YRGT=YCEN+DTRE*STSO
C
C If information about the current character is to be saved for the
C drawing passes, do it.
C
      ILCG=ILCG+1
      IF (ILCG.GE.ILCS+1.AND.ILCG.LE.ILCS+NCSO) THEN
        NCSV=NCSV+1
        XCSV(NCSV)=XCEN
        YCSV(NCSV)=YCEN
        IPSV(NCSV)=IPIC
        XMSV(NCSV)=XMZM(IPIC)
        YMSV(NCSV)=YMZM(IPIC)
        NFSV(NCSV)=NFNT
        NDSV(NCSV)=NDPC
        INSV(NCSV)=INDP
        NASV(NCSV)=NASC
        IF (INDP.EQ.95) THEN
          CHSV(NCSV:NCSV)='x'
        ELSE IF (INDP.EQ.358) THEN
          CHSV(NCSV:NCSV)=' '
        ELSE IF (ICSE.EQ.ICSL.AND.NDPC.GE.1.AND.NDPC.LE.26) THEN
          CHSV(NCSV:NCSV)=CDPC(NDPC+47)
        ELSE
          CHSV(NCSV:NCSV)=CDPC(NDPC)
        END IF
      END IF
C
C If appropriate, update the quantities from which the magnitudes of
C the text-extent vectors will be computed.
C
      IF (ITEF.NE.0.OR.ICEN.NE.0.OR.IBXF.NE.0) THEN
C
        UCEN=+(XCEN-XFRA)*COSO+(YCEN-YFRA)*SINO
        VCEN=-(XCEN-XFRA)*SINO+(YCEN-YFRA)*COSO
C
        IF (IQUF.EQ.0) THEN
C
          DO 107 I=3,NDGU-1,2
            IF (RDGU(I).GT.-2047.) THEN
              DSTL=MAX(DSTL,-UCEN-SIZM*XMZM(IPIC)*RDGU(I  ))
              DSTR=MAX(DSTR,+UCEN+SIZM*XMZM(IPIC)*RDGU(I  ))
              DSTB=MAX(DSTB,-VCEN-SIZM*YMZM(IPIC)*RDGU(I+1))
              DSTT=MAX(DSTT,+VCEN+SIZM*YMZM(IPIC)*RDGU(I+1))
            END IF
  107     CONTINUE
C
        ELSE
C
          IF (RHTW.GE.0.) RHTW=1.75*YMZM(IPIC)/XMZM(IPIC)
C
          DSTL=MAX(DSTL,-UCEN-SIZM*WPIC(IPIC)/3.,
     +                  -UCEN+SIZM*WPIC(IPIC)/3.)
          DSTR=MAX(DSTR,+UCEN-SIZM*WPIC(IPIC)/3.,
     +                  +UCEN+SIZM*WPIC(IPIC)/3.)
          DSTB=MAX(DSTB,-VCEN-SIZM*ABS(RHTW)*WPIC(IPIC)/3.,
     +                  -VCEN+SIZM*ABS(RHTW)*WPIC(IPIC)/3.)
          DSTT=MAX(DSTT,+VCEN-SIZM*ABS(RHTW)*WPIC(IPIC)/3.,
     +                  +VCEN+SIZM*ABS(RHTW)*WPIC(IPIC)/3.)
C
        END IF
C
      END IF
C
C Save the vertical space occupied by the current character as that of
C the previous character.
C
      VEPC=VPIC(IPIC)
C
C Set variables affecting the amount of space between characters.
C
      IF (ADDS.LT.0.) THEN
        ADDP=-ADDS
      ELSE IF (ADDS.GT.0.) THEN
        ADDP=ADDS*WPIC(IPIC)
      END IF
C
      IF (SUBS.LT.0.) THEN
        SUBP=-SUBS
      ELSE IF (SUBS.GT.0.) THEN
        SUBP=SUBS*WPIC(IPIC)
      END IF
C
C If case was set for a specified number of characters, see if all of
C them have been done and, if so, reset the case index.
C
      IF (NCSE.GT.0) THEN
        NCSE=NCSE-1
        IF (NCSE.EQ.0) ICSE=ICSP
      END IF
C
C If we are subscripting or superscripting for a specified number of
C characters, see if all of them have been done and, if so, reset all
C of the required variables.
C
      IF (NSSL.NE.0) THEN
        IF (NLEV(NSSL).GT.0) THEN
          NLEV(NSSL)=NLEV(NSSL)-1
          IF (NLEV(NSSL).EQ.0) THEN
            XCEN=XCNO(NSSL)
            YCEN=YCNO(NSSL)
            XRGT=XRGO(NSSL)
            YRGT=YRGO(NSSL)
            ICSE=ICSO(NSSL)
            ISZE=ISZO(NSSL)
            IPIC=ISZE/128+1
            NSSL=NSSL-1
          END IF
        END IF
      END IF
C
C Go get the next character from the input string.
C
      GO TO 104
C
C
C E N D   O F   S T R I N G   E N C O U N T E R E D
C
C
C Figure out where the end of the character string fell.  This depends
C on whether the last character was "written down" or "written across".
C In the former case, the bottom of the character box is used; in the
C latter case, the center of the right edge of the character is used.
C
  108 IF (LCWD.NE.0) THEN
        XEND=XCEN+.5*VEPC*STSO
        YEND=YCEN-.5*VEPC*STCO
      ELSE
        XEND=XRGT
        YEND=YRGT
      END IF
C
C Compute the adjustment required to achieve the desired centering.
C
      IF (ICEN.EQ.0) THEN
        XADJ=-.5*(CNTR+1.)*(XEND-XBEG)
        YADJ=-.5*(CNTR+1.)*(YEND-YBEG)
      ELSE
        XADJ=-.5*(DSTR-DSTL)*COSO+.5*(DSTT-DSTB)*SINO
        YADJ=-.5*(DSTR-DSTL)*SINO-.5*(DSTT-DSTB)*COSO
      END IF
C
C Adjust the values of XBEG, YBEG, XEND, and YEND as required by a
C user call to retrieve them.
C
      XBEG=XBEG+XADJ
      YBEG=YBEG+YADJ
C
      XEND=XEND+XADJ
      YEND=YEND+YADJ
C
C If text extents were computed, adjust them to be measured from
C the point relative to which the string is being centered.
C
      IF (ITEF.NE.0.OR.ICEN.NE.0.OR.IBXF.NE.0) THEN
        DSTL=DSTL-XADJ*COSO-YADJ*SINO
        DSTR=DSTR+XADJ*COSO+YADJ*SINO
        DSTB=DSTB+XADJ*SINO-YADJ*COSO
        DSTT=DSTT-XADJ*SINO+YADJ*COSO
      END IF
C
C If the object of the call was just to compute text extents, quit.
C
      IF (ITEF.NE.0.AND.ANGD.EQ.360.) GO TO 127
C
C
C D R A W   T H E   C H A R A C T E R S
C
C
C Save information about the current normalization transformation.
C
      CALL GQCNTN (IERR,INTC)
C
      IF (IERR.NE.0) THEN
        CALL SETER ('PLCHHQ - ERROR EXIT FROM GQCNTN',16,1)
        RETURN
      END IF
C
      CALL GQNT (INTC,IERR,WNTC,VNTC)
C
      IF (IERR.NE.0) THEN
        CALL SETER ('PLCHHQ - ERROR EXIT FROM GQNT',17,1)
        RETURN
      END IF
C
C Then, save the values of the initial polyline, fill area, and text
C color indices, the initial line width, and the initial fill area
C interior style.
C
      CALL GQPLCI (IERR,IPLC)
C
      IF (IERR.NE.0) THEN
        CALL SETER ('PLCHHQ - ERROR EXIT FROM GQPLCI',18,1)
        RETURN
      END IF
C
      CALL GQFACI (IERR,IFAC)
C
      IF (IERR.NE.0) THEN
        CALL SETER ('PLCHHQ - ERROR EXIT FROM GQFACI',19,1)
        RETURN
      END IF
C
      CALL GQTXCI (IERR,ITXC)
C
      IF (IERR.NE.0) THEN
        CALL SETER ('PLCHHQ - ERROR EXIT FROM GQTXCI',20,1)
        RETURN
      END IF
C
      CALL GQLWSC (IERR,RILW)
C
      IF (IERR.NE.0) THEN
        CALL SETER ('PLCHHQ - ERROR EXIT FROM GQLWSC',21,1)
        RETURN
      END IF
C
      CALL GQFAIS (IERR,IIIS)
C
      IF (IERR.NE.0) THEN
        CALL SETER ('PLCHHQ - ERROR EXIT FROM GQFAIS',22,1)
        RETURN
      END IF
C
C Set up variables in which to keep track of the current color index,
C the current line width, and the current fill area interior style.
C
      ICCI=-1
      RCLW=RILW
      ICIS=IIIS
C
C What we want to do now is to draw a box (if there is to be one) around
C the characters and then the characters themselves.  For I = 1, we fill
C the box shadow; for I = 2, we fill the box; for I = 3, we draw the box
C outline.  For I = 4 through 3+3*NCSV, we draw either a character
C shadow, the principal part of the character, or a character outline.
C The internal parameter IORD determines the order in which all the
C pieces of the characters are done.
C
      DO 126 I=1,3+3*NCSV
C
C Set things up to draw a part of the box ...
C
        IF (I.LE.3) THEN
C
          IF (ILCS.NE.0) GO TO 126
C
          IF      (I.EQ.1) THEN
            IDRF=MOD(IBXF/4,2)
            IDRC=IBXC(3)
            RDLW=RBXL
          ELSE IF (I.EQ.2) THEN
            IDRF=MOD(IBXF/2,2)
            IDRC=IBXC(2)
            RDLW=RBXL
          ELSE
            IDRF=MOD(IBXF  ,2)
            IDRC=IBXC(1)
            RDLW=RBXL
          END IF
C
          IF (IDRF.EQ.0) GO TO 126
C
          XCEN=XFRA
          YCEN=YFRA
          IPIC=1
          XMZM(IPIC)=1.
          YMZM(IPIC)=1.
          NDGU=14
          WBXM=RBXM*SIZM*HPIC(1)
          RDGU( 1)=-(DSTL+WBXM)/SIZM
          RDGU( 2)=+(DSTR+WBXM)/SIZM
          RDGU( 3)=-(DSTL+WBXM)/SIZM
          RDGU( 4)=-(DSTB+WBXM)/SIZM
          RDGU( 5)=+(DSTR+WBXM)/SIZM
          RDGU( 6)=-(DSTB+WBXM)/SIZM
          RDGU( 7)=+(DSTR+WBXM)/SIZM
          RDGU( 8)=+(DSTT+WBXM)/SIZM
          RDGU( 9)=-(DSTL+WBXM)/SIZM
          RDGU(10)=+(DSTT+WBXM)/SIZM
          RDGU(11)=-(DSTL+WBXM)/SIZM
          RDGU(12)=-(DSTB+WBXM)/SIZM
          RDGU(13)=-2048.
          RDGU(14)=0.
C
          IF      (I.EQ.1) THEN
            RDGU(13)=-2047.
            XCEN=XCEN+RBXX*HPIC(1)*STCO-RBXY*HPIC(1)*STSO
            YCEN=YCEN+RBXX*HPIC(1)*STSO+RBXY*HPIC(1)*STCO
          ELSE IF (I.EQ.2) THEN
            RDGU(13)=-2047.
          END IF
C
C ... or a part of a character.
C
        ELSE
C
          IF (ABS(IORD).LE.1) THEN
            IDRW=1+(I-4)/NCSV
            ICSV=1+MOD(I-4,NCSV)
          ELSE
            ICSV=1+(I-4)/3
            IDRW=1+MOD(I-4,3)
          END IF
C
          IF (IORD.LT.0) ICSV=NCSV+1-ICSV
C
          IF (IDRW.EQ.1) THEN
            IDRF=ISHF
            IDRC=ISHC
            RDLW=RSLW
          ELSE IF (IDRW.EQ.2) THEN
            IDRF=1
            IDRC=IPCC
            RDLW=RPLW
          ELSE IF (IDRW.EQ.3) THEN
            IDRF=IOUF
            IDRC=IOUC
            RDLW=ROLW
          END IF
C
          IF (IDRF.EQ.0) GO TO 126
C
          XCEN=XCSV(ICSV)+XADJ
          YCEN=YCSV(ICSV)+YADJ
          IPIC=IPSV(ICSV)
          XMZM(IPIC)=XMSV(ICSV)
          YMZM(IPIC)=YMSV(ICSV)
          NFNT=NFSV(ICSV)
          NDPC=NDSV(ICSV)
          INDP=INSV(ICSV)
          NASC=NASV(ICSV)
C
          IF      (IDRW.EQ.1) THEN
            XCEN=XCEN+SHDX*HPIC(1)*STCO-SHDY*HPIC(1)*STSO
            YCEN=YCEN+SHDX*HPIC(1)*STSO+SHDY*HPIC(1)*STCO
          ELSE IF (IDRW.EQ.3) THEN
            IF (NFNT.GE.21.AND.NFNT.LE.99) NFNT=NFNT+100
          END IF
C
C Get the digitization of the desired character.  Note: I have some
C doubts about the setting of CHFS to .1 in the following code (though
C it seems to have worked okay for a very long time).
C
          IF (IQUF.EQ.0) THEN
            IF (NFNT.EQ.0.OR.NDPC.LT. 1.OR.
     +                       NDPC.GT.95.OR.INDP.EQ.95) THEN
              CALL PCEXCD (INDP,2,NDGU)
            ELSE
              IF (NFNT.GE.1.AND.NFNT.LE.20) THEN
                CALL PCCFFC (2,IBNU,NFNT,NASC,SPIC(IPIC),RDGU,MDGU,NDGU)
                IF (ICFELL('PLCHHQ',23).NE.0) RETURN
              ELSE
                IF (IMAP.LE.0) THEN
                  CHFS=SIZM*HPIC(IPIC)
                ELSE
                  CHFS=.1
                END IF
                CALL PCCFFF (2,IBNU,NFNT,NASC,SPIC(IPIC),CHFS,
     +                                         RDGU,MDGU,NDGU)
                IF (ICFELL('PLCHHQ',24).NE.0) RETURN
                IF (NASC.EQ.32) RDGU(3)=-2048.
              END IF
              IF (NDGU.EQ.0) THEN
                CALL PCCFFC (2,IBNU,1,NASC,SPIC(IPIC),RDGU,MDGU,NDGU)
                IF (ICFELL('PLCHHQ',25).NE.0) RETURN
                IF (NDGU.EQ.0) CALL PCEXCD (INDP,2,NDGU)
              END IF
            END IF
C
            IF (NDGU.EQ.0) THEN
              CALL PCEXCD (358,2,NDGU)
              IF (NDGU.EQ.0) THEN
                CALL SETER ('PLCHHQ - INTERNAL LOGIC ERROR (NDGU = 0) -
     +SEE CONSULTANT',26,1)
                RETURN
              END IF
            END IF
C
          END IF
C
        END IF
C
C Digitization defined.  Set up the requested drawing color ...
C
        IF (IDRC.GE.0) THEN
          IF (IDRC.NE.ICCI) THEN
            ICCI=IDRC
            IF (ICFELL(' ',0).NE.0) RETURN
            CALL PLOTIF (0.,0.,2)
            IF (ICFELL('PLCHHQ',27).NE.0) RETURN
            CALL GSPLCI (IDRC)
            CALL GSFACI (IDRC)
            CALL GSTXCI (IDRC)
          END IF
        ELSE IF (ICCI.GE.0) THEN
          ICCI=-1
          IF (ICFELL(' ',0).NE.0) RETURN
          CALL PLOTIF (0.,0.,2)
          IF (ICFELL('PLCHHQ',28).NE.0) RETURN
          CALL GSPLCI (IPLC)
          CALL GSFACI (IFAC)
          CALL GSTXCI (ITXC)
        END IF
C
C ... and line width.
C
        IF (RDLW.LE.0.) RDLW=RILW
C
        IF (RDLW.NE.RCLW) THEN
          RCLW=RDLW
          IF (ICFELL(' ',0).NE.0) RETURN
          CALL PLOTIF (0.,0.,2)
          IF (ICFELL('PLCHHQ',29).NE.0) RETURN
          CALL GSLWSC (RDLW)
        END IF
C
C If the box or a high-quality character is being drawn, ...
C
        IF (I.LE.3.OR.IQUF.EQ.0) THEN
C
C ... if mapping is turned on, pre-process the digitized character to
C interpolate points along long straight portions of it and make sure
C that any fill areas defined are properly closed.  This avoids
C problems that otherwise occur.
C
          IF (IMAP.GT.0) THEN
C
            NCRA=0
C
            KTMP=1
C
            DO 110 K=3,NDGU-1,2
              IF (K.EQ.3.OR.RDGU(K-2).LE.-2047.
     +                  .OR.RDGU(K  ).LE.-2047.) THEN
                IF (RDGU(K).LE.-2047.) THEN
                  IF (RDGU(K).EQ.-2047.) THEN
                    IF (XCRA(NCRA).NE.RDGU(KTMP+2).OR.
     +                  YCRA(NCRA).NE.RDGU(KTMP+3)) THEN
                      IF (NCRA+1.LE.MCRA) THEN
                        NCRA=NCRA+1
                        XCRA(NCRA)=RDGU(KTMP+2)
                        YCRA(NCRA)=RDGU(KTMP+3)
                      ELSE
                        CALL SETER ('PLCHHQ - INTERNAL LOGIC ERROR (XCRA
     +/YCRA TOO SMALL) - SEE CONSULTANT',30,1)
                        RETURN
                      END IF
                    END IF
                  END IF
                  KTMP=K
                END IF
                IF (NCRA+1.LE.MCRA) THEN
                  NCRA=NCRA+1
                  XCRA(NCRA)=RDGU(K  )
                  YCRA(NCRA)=RDGU(K+1)
                ELSE
                  CALL SETER ('PLCHHQ - INTERNAL LOGIC ERROR (XCRA/YCRA
     +TOO SMALL) - SEE CONSULTANT',31,1)
                  RETURN
                END IF
              ELSE
                NINT=MAX(1,INT(ABS(RDGU(K  )-RDGU(K-2))/2.1),
     +                     INT(ABS(RDGU(K+1)-RDGU(K-1))/2.1))
                IF (NCRA+NINT.LE.MCRA) THEN
                  DO 109 IINT=1,NINT
                    P=REAL(NINT-IINT)/REAL(NINT)
                    NCRA=NCRA+1
                    XCRA(NCRA)=P*RDGU(K-2)+(1.-P)*RDGU(K  )
                    YCRA(NCRA)=P*RDGU(K-1)+(1.-P)*RDGU(K+1)
  109             CONTINUE
                ELSE
                  CALL SETER ('PLCHHQ - INTERNAL LOGIC ERROR (XCRA/YCRA
     +TOO SMALL) - SEE CONSULTANT',32,1)
                  RETURN
                END IF
              END IF
  110       CONTINUE
C
            NDGU=2+2*NCRA
C
            DO 111 K=3,NDGU-1,2
              RDGU(K  )=XCRA(K/2)
              RDGU(K+1)=YCRA(K/2)
  111       CONTINUE
C
          END IF
C
C Initialize NCRA, which is a count of the number of X/Y coordinate
C pairs in the arrays XCRA and YCRA, and IORF, which is a count of
C the number of those that were found to be "out of range" (invisible
C under the current mapping).
C
          NCRA=0
          IORF=0
C
C Examine the X/Y coordinate pairs of the digitization [an X from
C RDGU(K) and a Y from RDGU(K+1)], one by one.  If the X coordinate
C is greater than -2047, the X/Y pair is just added to what's in
C XCRA and YCRA.  If the X coordinate equals -2048, it says that
C what has been saved up in XCRA and YCRA is a polyline to be drawn.
C If the X coordinate equals -2047, it says that what has been saved
C up is a polygon to be filled.
C
          DO 125 K=3,NDGU-1,2
C
C If the X/Y pair is to be saved in XCRA and YCRA, increment NCRA ...
C
            IF (RDGU(K).GT.-2047.) THEN
C
              NCRA=NCRA+1
C
C ... and then check the mapping flag.  If it's turned off, ...
C
              IF (IMAP.LE.0) THEN
C
C ... just save the X and Y coordinates, transformed to the fractional
C coordinate system; ...
C
                XCRA(NCRA)=XCEN+XMZM(IPIC)*RDGU(K  )*STCO
     +                         -YMZM(IPIC)*RDGU(K+1)*STSO
                YCRA(NCRA)=YCEN+XMZM(IPIC)*RDGU(K  )*STSO
     +                         +YMZM(IPIC)*RDGU(K+1)*STCO
C
C ... otherwise, ...
C
              ELSE
C
C ... map the X/Y coordinates by calling PCMPXY ...
C
                XINP=XCEN+(XMZM(IPIC)*(RDGU(K  )*STCO)
     +                    -YMZM(IPIC)*(RDGU(K+1)*STSO))
                YINP=YCEN+(XMZM(IPIC)*(RDGU(K  )*STSO)
     +                    +YMZM(IPIC)*(RDGU(K+1)*STCO))
C
                CALL PCMPXY (IMAP,XINP,YINP,XTMP,YTMP)
                IF (ICFELL('PLCHHQ',33).NE.0) RETURN
C
C ... and check for an out-of-range point (one that's invisible under
C the current mapping).  If the out-of-range flag is turned off or
C if the X coordinate coming back is not equal to it ...
C
                IF (OORV.EQ.0..OR.XTMP.NE.OORV) THEN
C
C ... transform the point into the fractional system and save it; ...
C
                  XCRA(NCRA)=CUFX(XTMP)
                  IF (ICFELL('PLCHHQ',34).NE.0) RETURN
                  YCRA(NCRA)=CUFY(YTMP)
                  IF (ICFELL('PLCHHQ',35).NE.0) RETURN
C
C ... otherwise, set the X coordinate to the out-of-range flag and
C save a pointer into the digitization array as the value of the Y
C coordinate.
C
                ELSE
C
                  IORF=IORF+1
                  XCRA(NCRA)=OORV
                  YCRA(NCRA)=REAL(K)
C
                END IF
C
              END IF
C
C If RDGU(K) is either -2048 or -2047, and there are saved coordinates
C in XCRA and YCRA, ...
C
            ELSE IF (NCRA.GT.0) THEN
C
C ... if none of them are out-of-range, the entire collection of points
C can be treated as a one-piece polyline or polygon to be filled, ...
C
              IF (IORF.EQ.0) THEN
C
                NPCS=1
                IPCB(1)=1
                IPCE(1)=NCRA
C
C ... and if all of them are out-of-range, ...
C
              ELSE IF (IORF.EQ.NCRA) THEN
C
C ... there are no pieces of polyline or polygon to be dealt with; ...
C
                NPCS=0
C
C ... otherwise, ...
C
              ELSE
C
C ... we have to do something about the fact that the edge of the
C character lies partly in areas invisible under the mapping ...
C
C First, we have to find out exactly where each line segment with
C an invisible end-point appears or disappears and add those points
C to the ends of the visible pieces.  When we are done, NPCS says
C how many pieces there are; for each value of "i" between 1 and
C NPCS, IPCB(i) is the index, in the arrays XCRA and YCRA, of the
C first point of the piece and IPCE(i) is the index of the last point
C of the piece.  XPCB(i) and YPCB(i) are the X and Y coordinates that
C mapped into the first point of the piece and XPCE(i) and YPCE(i) are
C the X and Y coordinates that mapped into the last point of the piece.
C XPCB(1), YPCB(1), XPCE(NPCS), and YPCE(NPCS) are sometimes given
C dummy values; this is only done in cases where we know that those
C values will not be needed for anything.
C
C Initialization of the loop through the X and Y coordinates in XCRA
C and YCRA differs depending on whether the first point is out-of-range
C or not.  ISTA is a "state" flag that says whether the last point we
C looked at was out-of-range (ISTA=0) or not (ISTA=1).
C
                IF (XCRA(1).EQ.OORV) THEN
                  NPCS=0
                  ISTA=0
                ELSE
                  NPCS=1
                  IPCB(1)=1
                  XPCB(1)=OORV
                  YPCB(1)=OORV
                  ISTA=1
                END IF
C
C Start the loop through the X and Y coordinates with element 2.
C
                ICRA=2
C
C The loop through the X and Y coordinates is implemented using IF's,
C rather than a DO, because we may very occasionally need to add an
C element in the middle of the arrays that we are looking at, which
C changes the value of NCRA.  Control returns here to examine element
C number ICRA of XCRA and YCRA.
C
  112           IF (ICRA.GT.NCRA) GO TO 118
C
C If the last point looked at was out-of-range and this one is not,
C interpolate, using a binary halving process, to find a point at the
C very edge of visibility, and fill the out-of-range slot with the
C X and Y coordinates of that point.
C
                  IF (ISTA.EQ.0.AND.XCRA(ICRA).NE.OORV) THEN
C
                    KTMP=INT(YCRA(ICRA-1))
C
                    XINV=XCEN+(XMZM(IPIC)*(RDGU(KTMP  )*STCO)
     +                        -YMZM(IPIC)*(RDGU(KTMP+1)*STSO))
                    YINV=YCEN+(XMZM(IPIC)*(RDGU(KTMP  )*STSO)
     +                        +YMZM(IPIC)*(RDGU(KTMP+1)*STCO))
C
                    XVIS=XCEN+(XMZM(IPIC)*(RDGU(KTMP+2)*STCO)
     +                        -YMZM(IPIC)*(RDGU(KTMP+3)*STSO))
                    YVIS=YCEN+(XMZM(IPIC)*(RDGU(KTMP+2)*STSO)
     +                        +YMZM(IPIC)*(RDGU(KTMP+3)*STCO))
C
                    DO 113 IHLF=1,64
C
                      XHLF=.5*(XINV+XVIS)
                      YHLF=.5*(YINV+YVIS)
C
                      CALL PCMPXY (IMAP,XHLF,YHLF,XTMP,YTMP)
                      IF (ICFELL('PLCHHQ',36).NE.0) RETURN
C
                      IF (XTMP.EQ.OORV) THEN
                        IF (XHLF.EQ.XINV.AND.YHLF.EQ.YINV) GO TO 114
                        XINV=XHLF
                        YINV=YHLF
                      ELSE
                        IF (XHLF.EQ.XVIS.AND.YHLF.EQ.YVIS) GO TO 114
                        XVIS=XHLF
                        YVIS=YHLF
                      END IF
C
  113               CONTINUE
C
  114               IF (NPCS.GE.MPCS) THEN
                      CALL SETER ('PLCHHQ - INTERNAL LOGIC ERROR (NPCS T
     +OO BIG) - SEE CONSULTANT',37,1)
                      RETURN
                    END IF
C
                    NPCS=NPCS+1
                    IPCB(NPCS)=ICRA-1
                    XPCB(NPCS)=XVIS
                    YPCB(NPCS)=YVIS
                    CALL PCMPXY (IMAP,XVIS,YVIS,XTMP,YTMP)
                    IF (ICFELL('PLCHHQ',38).NE.0) RETURN
                    XCRA(ICRA-1)=CUFX(XTMP)
                    IF (ICFELL('PLCHHQ',39).NE.0) RETURN
                    YCRA(ICRA-1)=CUFY(YTMP)
                    IF (ICFELL('PLCHHQ',40).NE.0) RETURN
                    ISTA=1
C
C Similarly, if the last point looked at was not out-of-range and this
C one is, interpolate, using a binary halving process, to find a point
C at the very edge of visibility, and fill the out-of-range slot with
C the X and Y coordinates of that point.  In this case, though, if
C there is a next point, and it is not out-of-range, we have to insert
C a copy of the current point to serve as the starting point of the
C next piece of the polyline.
C
                  ELSE IF (ISTA.NE.0.AND.XCRA(ICRA).EQ.OORV) THEN
C
                    IF (ICRA.NE.NCRA) THEN
C
                      IF (XCRA(ICRA+1).NE.OORV) THEN
C
                        IF (NCRA.GE.MCRA) THEN
                          CALL SETER ('PLCHHQ - INTERNAL LOGIC ERROR (NC
     +RA TOO BIG) - SEE CONSULTANT',41,1)
                          RETURN
                        END IF
C
                        DO 115 L=NCRA,ICRA,-1
                          XCRA(L+1)=XCRA(L)
                          YCRA(L+1)=YCRA(L)
  115                   CONTINUE
C
                        NCRA=NCRA+1
C
                      END IF
C
                    END IF
C
                    KTMP=INT(YCRA(ICRA))
C
                    XINV=XCEN+(XMZM(IPIC)*(RDGU(KTMP  )*STCO)
     +                        -YMZM(IPIC)*(RDGU(KTMP+1)*STSO))
                    YINV=YCEN+(XMZM(IPIC)*(RDGU(KTMP  )*STSO)
     +                        +YMZM(IPIC)*(RDGU(KTMP+1)*STCO))
C
                    XVIS=XCEN+(XMZM(IPIC)*(RDGU(KTMP-2)*STCO)
     +                        -YMZM(IPIC)*(RDGU(KTMP-1)*STSO))
                    YVIS=YCEN+(XMZM(IPIC)*(RDGU(KTMP-2)*STSO)
     +                        +YMZM(IPIC)*(RDGU(KTMP-1)*STCO))
C
                    DO 116 IHLF=1,64
C
                      XHLF=.5*(XINV+XVIS)
                      YHLF=.5*(YINV+YVIS)
C
                      CALL PCMPXY (IMAP,XHLF,YHLF,XTMP,YTMP)
                      IF (ICFELL('PLCHHQ',42).NE.0) RETURN
C
                      IF (XTMP.EQ.OORV) THEN
                        IF (XHLF.EQ.XINV.AND.YHLF.EQ.YINV) GO TO 117
                        XINV=XHLF
                        YINV=YHLF
                      ELSE
                        IF (XHLF.EQ.XVIS.AND.YHLF.EQ.YVIS) GO TO 117
                        XVIS=XHLF
                        YVIS=YHLF
                      END IF
C
  116               CONTINUE
  117               IPCE(NPCS)=ICRA
                    XPCE(NPCS)=XVIS
                    YPCE(NPCS)=YVIS
                    CALL PCMPXY (IMAP,XVIS,YVIS,XTMP,YTMP)
                    IF (ICFELL('PLCHHQ',43).NE.0) RETURN
                    XCRA(ICRA)=CUFX(XTMP)
                    IF (ICFELL('PLCHHQ',44).NE.0) RETURN
                    YCRA(ICRA)=CUFY(YTMP)
                    IF (ICFELL('PLCHHQ',45).NE.0) RETURN
                    ISTA=0
C
                  END IF
C
C Increment to the next elements of XCRA and YCRA ...
C
                  ICRA=ICRA+1
C
C ... and return to the beginning of the loop.
C
                  GO TO 112
C
C Finish storing information about the last piece, if any.
C
  118           IF (ISTA.NE.0) THEN
                  IPCE(NPCS)=NCRA
                  XPCE(NPCS)=OORV
                  YPCE(NPCS)=OORV
                END IF
C
C If the polyline defined is a polygon to be filled ...
C
                IF (RDGU(K).EQ.-2047.) THEN
C
C ... interpolate points from the end of each visible piece to the
C beginning of the next.  A heuristic algorithm is used to ensure
C that these points will lie along the line separating areas which
C are visible under the current mapping from those which are not.
C
C Loop through the visible pieces of the polygon.
C
                  DO 123 L=1,NPCS
C
C Compute MBEG and MEND, which point to the beginning and end of a
C portion of the arrays XCRA and YCRA which mapped to an out-of-range
C (invisible) area.
C
                    LPL1=MOD(L,NPCS)+1
C
                    MBEG=IPCE(L)+1
                    IF (MBEG.GT.NCRA) MBEG=MBEG-NCRA
C
                    MEND=IPCB(LPL1)-1
                    IF (MEND.LT.MBEG-1) MEND=MEND+NCRA
C
C If there are one or more invisible points, replace them.
C
                    IF (MBEG.LE.MEND) THEN
C
C (XCP1,YCP1) and (XCP2,YCP2) are endpoints X1 and X2 of a line segment
C on the visible/invisible boundary between which we wish to interpolate
C other points.
C
                      XCP1=XPCE(L)
                      YCP1=YPCE(L)
                      XCP2=XPCB(LPL1)
                      YCP2=YPCB(LPL1)
C
C If either X1 or X2 is an out-of-range value, something has happened
C that should not have been possible, so take an error exit.
C
                      IF (XCP1.EQ.OORV.OR.XCP2.EQ.OORV) THEN
                        CALL SETER ('PLCHHQ - INTERNAL LOGIC ERROR (XCP1
     + OR XCP2 = OORV) - SEE CONSULTANT',46,1)
                        RETURN
                      END IF
C
C XDIF and YDIF are components of the vector from X1 to X2.
C
                      XDIF=XCP2-XCP1
                      YDIF=YCP2-YCP1
C
C Loop through the elements of XCRA and YCRA to be replaced.
C
                      DO 122 M=MBEG,MEND
C
C When the points being replaced include a section at the end of the
C arrays, followed by a section at the beginning, M may range past
C NCRA; MSTR is the appropriate index between 1 and NCRA.
C
                        MSTR=MOD(M-1,NCRA)+1
C
C (XTM0,YTM0) is a point X0 along the straight line from X1 to X2.
C
                        P=REAL(M-MBEG+1)/REAL(MEND-MBEG+2)
C
                        XTM0=(1.-P)*XCP1+P*XCP2
                        YTM0=(1.-P)*YCP1+P*YCP2
C
C XSTP and YSTP are the components of a "step vector" that is at right
C angles to the line from X1 to X2 and 1/32 of its length.
C
                        XSTP=+YDIF/32.
                        YSTP=-XDIF/32.
C
C Loop on step size, looking at the ends of the two step vectors
C emanating from X0, one pointing in one direction and the other
C pointing in the opposite direction.  What we are hoping for is
C that one such endpoint will be visible and the other invisible.
C
                        DO 121 ISTP=1,6
C
                          XTM1=XTM0+XSTP
                          YTM1=YTM0+YSTP
                          XTM2=XTM0-XSTP
                          YTM2=YTM0-YSTP
C
                          CALL PCMPXY (IMAP,XTM1,YTM1,XMP1,YMP1)
                          IF (ICFELL('PLCHHQ',47).NE.0) RETURN
                          CALL PCMPXY (IMAP,XTM2,YTM2,XMP2,YMP2)
                          IF (ICFELL('PLCHHQ',48).NE.0) RETURN
C
                          IF      (XMP1.EQ.OORV.AND.XMP2.NE.OORV) THEN
                            XINV=XTM1
                            YINV=YTM1
                            XVIS=XTM2
                            YVIS=YTM2
                          ELSE IF (XMP1.NE.OORV.AND.XMP2.EQ.OORV) THEN
                            XVIS=XTM1
                            YVIS=YTM1
                            XINV=XTM2
                            YINV=YTM2
                          ELSE
                            XSTP=XSTP+XSTP
                            YSTP=YSTP+YSTP
                            GO TO 121
                          END IF
C
C At this point, we have found two such points.  Use a binary halving
C process to find the point where the line between them intersects the
C visible/invisible boundary and use that point to generate the values
C to be put in the arrays XCRA and YCRA.
C
                          DO 119 IHLF=1,64
                            XHLF=.5*(XINV+XVIS)
                            YHLF=.5*(YINV+YVIS)
                            CALL PCMPXY (IMAP,XHLF,YHLF,XTMP,YTMP)
                            IF (ICFELL('PLCHHQ',49).NE.0) RETURN
                            IF (XTMP.EQ.OORV) THEN
                              IF (XHLF.EQ.XINV.AND.
     +                            YHLF.EQ.YINV) GO TO 120
                              XINV=XHLF
                              YINV=YHLF
                            ELSE
                              IF (XHLF.EQ.XVIS.AND.
     +                            YHLF.EQ.YVIS) GO TO 120
                              XVIS=XHLF
                              YVIS=YHLF
                            END IF
  119                     CONTINUE
C
C Replace the original point with one on the visible/invisible edge.
C
  120                     CALL PCMPXY (IMAP,XVIS,YVIS,XTMP,YTMP)
                          IF (ICFELL('PLCHHQ',50).NE.0) RETURN
C
                          XCRA(MSTR)=CUFX(XTMP)
                          IF (ICFELL('PLCHHQ',51).NE.0) RETURN
                          YCRA(MSTR)=CUFY(YTMP)
                          IF (ICFELL('PLCHHQ',52).NE.0) RETURN
C
                          GO TO 122
C
C End of loop on step size.
C
  121                   CONTINUE
C
C If control drops through the end of the loop, supply a point that
C we at least know is visible.
C
                        XCRA(MSTR)=XCRA(IPCE(L))
                        YCRA(MSTR)=YCRA(IPCE(L))
C
C End of loop replacing elements of XCRA and YCRA.
C
  122                 CONTINUE
C
C End of invisible-point replacement.
C
                    END IF
C
C End of loop through visible pieces of the polygon.
C
  123             CONTINUE
C
                END IF
C
C End of partly-invisible case.
C
              END IF
C
C Now, if there are visible pieces of the polyline/polygon, ...
C
              IF (NPCS.NE.0) THEN
C
C ... redefine the current normalization transformation, if possible,
C so that we can use fractional coordinates and yet have the same
C viewport as before ...
C
                IF (INTC.NE.0) THEN
                  CALL GSWN (1,VNTC(1),VNTC(2),VNTC(3),VNTC(4))
                END IF
C
C ... change color (during pass 2) if so directed by information from
C the fontcap, ...
C
                ICCS=-2
C
                IF (IDRW.EQ.2.AND.RDGU(K+1).GT.0.) THEN
C
                  ITMP=INT(RDGU(K+1))
C
                  IF (ITMP.GE.1.AND.ITMP.LE.16) THEN
C
                    IDRC=LSCI(ITMP)
C
                    IF (IDRC.GE.0) THEN
C
                      IF (IDRC.NE.ICCI) THEN
                        ICCS=ICCI
                        ICCI=IDRC
                        IF (ICFELL(' ',0).NE.0) RETURN
                        CALL PLOTIF (0.,0.,2)
                        IF (ICFELL('PLCHHQ',53).NE.0) RETURN
                        CALL GSPLCI (ICCI)
                        CALL GSFACI (ICCI)
                        CALL GSTXCI (ICCI)
                      END IF
C
                    END IF
C
                  END IF
C
                END IF
C
C ... draw the pieces of the polyline, ...
C
                IF (RDGU(K).EQ.-2048.) THEN
C
                  DO 124 L=1,NPCS
                    IF (IPCE(L)-IPCB(L)+1.GT.1)
     +              CALL GPL (IPCE(L)-IPCB(L)+1,XCRA(IPCB(L)),
     +                                          YCRA(IPCB(L)))
  124             CONTINUE
C
C ... or fill the polygon, ...
C
                ELSE
C
                  IF (NCRA.GT.2) THEN
C ... Jira1667: use new SOLID_TEXT_FILL (4), rather than SOLID_FILL (1)
                    IF (ICIS.NE.4) THEN
                      CALL GSFAIS (4)
                      ICIS=4
                    END IF
                    CALL GFA (NCRA,XCRA,YCRA)
                  END IF
C
                END IF
C
C ... restore the current normalization transformation (if it was
C changed above) ...
C
                IF (INTC.NE.0) THEN
                  CALL GSWN (1,WNTC(1),WNTC(2),WNTC(3),WNTC(4))
                END IF
C
C ... and, if the color was just overridden above, set it back to what
C it was.
C
                IF (ICCS.GE.-1) THEN
C
                  ICCI=ICCS
C
                  IF (ICFELL(' ',0).NE.0) RETURN
                  CALL PLOTIF (0.,0.,2)
                  IF (ICFELL('PLCHHQ',54).NE.0) RETURN
C
                  IF (ICCI.GE.0) THEN
                    CALL GSPLCI (ICCI)
                    CALL GSFACI (ICCI)
                    CALL GSTXCI (ICCI)
                  ELSE
                    CALL GSPLCI (IPLC)
                    CALL GSFACI (IFAC)
                    CALL GSTXCI (ITXC)
                  END IF
C
                END IF
C
              END IF
C
C Then, zero NCRA and IORF to say that we are done with that part of
C the digitization ...
C
              NCRA=0
              IORF=0
C
C End of processing of visible pieces.
C
            END IF
C
C End of loop through the digitization array.
C
  125     CONTINUE
C
C Otherwise, the quality flag indicates that PLCHMQ or PLCHLQ should be
C called to draw the character, so arrange for that.
C
        ELSE
C
          IF (IQUF.EQ.1.AND.RHTW.GE.0.) RHTW=1.75*YMZM(IPIC)/XMZM(IPIC)
C
          IF (IMAP.LE.0) THEN
            XTMP=CFUX(XCEN)
            IF (ICFELL('PLCHHQ',55).NE.0) RETURN
            YTMP=CFUY(YCEN)
            IF (ICFELL('PLCHHQ',56).NE.0) RETURN
          ELSE
            XTMP=XCEN
            YTMP=YCEN
          END IF
C
          CALL PCMQLQ (XTMP,YTMP,CHSV(ICSV:ICSV),
     +                   SIZM*WPIC(IPIC),ANGD,0.)
          IF (ICFELL('PLCHHQ',57).NE.0) RETURN
C
        END IF
C
  126 CONTINUE
C
C Restore, as necessary, all the current color indices, the current line
C width scale factor, and the fill area interior style.
C
      IF (ICCI.GE.0) THEN
        IF (ICFELL(' ',0).NE.0) RETURN
        CALL PLOTIF (0.,0.,2)
        IF (ICFELL('PLCHHQ',58).NE.0) RETURN
        CALL GSPLCI (IPLC)
        CALL GSFACI (IFAC)
        CALL GSTXCI (ITXC)
      END IF
C
      IF (RCLW.NE.RILW) THEN
        IF (ICFELL(' ',0).NE.0) RETURN
        CALL PLOTIF (0.,0.,2)
        IF (ICFELL('PLCHHQ',59).NE.0) RETURN
        CALL GSLWSC (RILW)
      END IF
C
      IF (ICIS.NE.IIIS) CALL GSFAIS (IIIS)
C
C If not all the characters have been drawn yet, go back for more.
C
      IF (ILCG-ILCS.GT.NCSO) THEN
        ILCS=ILCS+NCSO
        GO TO 103
      END IF
C
C
C D O N E   -   R E T U R N   T O   C A L L E R
C
C
C Restore the PLCHMQ parameter specifying the ratio of character height
C to width.
C
  127 IF (IQUF.NE.0) RHTW=RHWO
C
C Done.
C
      RETURN
C
C
C F U N C T I O N   C O D E   P R O C E S S I N G
C
C
C If the current character is invalid, issue an error message and go
C back for the next one.
C
  128 IF (NDPC.LE.0.OR.(NDPC.GE.35.AND.NDPC.NE.45.AND.NDPC.NE.46)) THEN
        WRITE (IERU,1001) ICHR,CHRS(ICHR:ICHR)
        GO TO 104
      END IF
C
C If the character is an octal digit, retrieve an octal number in INDP
C and jump back to process the character it points to.  NDPC is set to
C the value signalling that a particular character from the PWRITX
C database has been selected.
C
      IF (NDPC.GE.27.AND.NDPC.LE.34) THEN
        CALL PCGTPI (CHRS,NCHR,ICHR,8,INDP)
        ICHR=ICHR-1
        NDPC=96
        GO TO 105
      END IF
C
C Blanks and commas are just separators; ignore them.
C
      IF (NDPC.EQ.45.OR.NDPC.EQ.46) GO TO 104
C
C Jump to the appropriate section to process an alphabetic character.
C
C             A,  B,  C,  D,  E,  F,  G,  H,  I,  J,  K,  L,  M,
C             N,  O,  P,  Q,  R,  S,  T,  U,  V,  W,  X,  Y,  Z
C
      GO TO (143,137,144,142,140,147,131,145,133,129,134,136,129,
     +       141,129,132,104,130,138,129,135,146,129,148,149,150) , NDPC
C
C Log an error if it's not one of the legal ones.
C
  129 WRITE (IERU,1001) ICHR,CHRS(ICHR:ICHR)
      GO TO 104
C
C FONT DEFINITION
C ---------------
C
C Define index offset into INDA.
C
C R is for Roman font.
C
  130 IFNT=IFRO
      GO TO 104
C
C G is for Greek font.
C
  131 IFNT=IFGR
      GO TO 104
C
C SIZE DEFINITION
C ---------------
C
C Define index offset into INDA and set current character height and
C width.
C
C P is for Principal size.
C
  132 ISZE=ISZP
      IPIC=1
      GO TO 104
C
C I is for Indexical size.
C
  133 ISZE=ISZI
      IPIC=2
      GO TO 104
C
C K is for Cartographic size.
C
  134 ISZE=ISZC
      IPIC=3
      GO TO 104
C
C CASE DEFINITION
C ---------------
C
C Set old and current index offsets into INDA and look for character
C count.
C
C  U is for Upper case.
C
  135 ICSP=ICSL
      ICSE=ICSU
      CALL PCGTDI (CHRS,NCHR,ICHR,NCSE)
      GO TO 104
C
C L is for Lower case.
C
  136 ICSP=ICSU
      ICSE=ICSL
      CALL PCGTDI (CHRS,NCHR,ICHR,NCSE)
      GO TO 104
C
C LEVEL DEFINITION
C ----------------
C
C B is for suBscript.  Set the sine and cosine of the offset angle and
C jump to join the superscript code.
C
  137 SINT=SINM
      COST=COSM
      GO TO 139
C
C S is for Superscript.  Set the sine and cosine of the offset angle.
C
  138 SINT=SINP
      COST=COSP
C
C Increment the subscript/superscript level, but to no more than five.
C
  139 NSSL=MIN(NSSL+1,5)
C
C Retrieve the character count, if any, following the B or S.
C
      CALL PCGTDI (CHRS,NCHR,ICHR,NLEV(NSSL))
C
C Compute the size of the offset to the superscript or subscript and
C use that to modify the sine and cosine factors.
C
      OFFS=SSPR*SIZM
      IF (ISZE.NE.ISZP) OFFS=SSIC*SIZM
      COST=OFFS*COST
      SINT=OFFS*SINT
C
C Save all the variables which will be needed to undo the offset on a
C stack.
C
      XCNO(NSSL)=XCEN
      YCNO(NSSL)=YCEN
      XRGO(NSSL)=XRGT
      YRGO(NSSL)=YRGT
      ICSO(NSSL)=ICSE
      ISZO(NSSL)=ISZE
      SNTO(NSSL)=SINT
      CSTO(NSSL)=COST
C
C Reset the coordinates of the right end of the last character.
C
      XRGT=XRGT+COST
      YRGT=YRGT+SINT
C
C Reset the character case and size to values appropriate for subscripts
C and superscripts.
C
      IF (ISZE.EQ.ISZP) THEN
        ISZE=ISZI
        IPIC=2
      ELSE
        ISZE=ISZC
        IPIC=3
        ICSE=ICSU
      END IF
C
        GO TO 104
C
C E is for End of subscripting or superscripting, which is ignored if
C we're not in that mode.
C
  140 IF (NSSL.EQ.0) GO TO 104
C
C Return everything to what it was after drawing the base character.
C
      XCEN=XCNO(NSSL)
      YCEN=YCNO(NSSL)
      XRGT=XRGO(NSSL)
      YRGT=YRGO(NSSL)
      ICSE=ICSO(NSSL)
      ISZE=ISZO(NSSL)
      IPIC=ISZE/128+1
      NSSL=NSSL-1
C
      GO TO 104
C
C N is for Normal, which is ignored if we're not subscripting or
C superscripting.
C
  141 IF (NSSL.EQ.0) GO TO 104
C
C Return everything to what it was after drawing the base character
C except the position of the right edge, in which we just reverse the
C original offset.
C
      XCEN=XCNO(NSSL)
      YCEN=YCNO(NSSL)
      XRGT=XRGT-CSTO(NSSL)
      YRGT=YRGT-SNTO(NSSL)
      ICSE=ICSO(NSSL)
      ISZE=ISZO(NSSL)
      IPIC=ISZE/128+1
      NSSL=NSSL-1
C
      GO TO 104
C
C DIRECTION DEFINITION
C --------------------
C
C D is for Down.  Set the character count to the following decimal
C integer, if there is one, or to a number exceeding the number of
C characters left in the string, otherwise.  Set the flag indicating
C that the last character was "written down".
C
  142 CALL PCGTDI (CHRS,NCHR,ICHR,NDWN)
      IF (NDWN.LE.0) NDWN=NCHR
      LCWD=1
      GO TO 104
C
C A is for Across.  Clear the "down" flags.
C
  143 NDWN=0
      LCWD=0
      GO TO 104
C
C COORDINATE DEFINITION
C ---------------------
C
C C is for Carriage return.  Reset the beginning-of-line position and
C the positions of the center and right edge of the last character.
C Suppress spacing manipulations at the beginning of the new line.
C
  144 XBOL=XBOL+SIZM*VPIC(IPIC)*COSM
      YBOL=YBOL+SIZM*VPIC(IPIC)*SINM
      XCEN=XBOL
      YCEN=YBOL
      XRGT=XBOL
      YRGT=YBOL
      ADDP=0.
      SUBP=0.
      GO TO 104
C
C H is for Horizontal.
C
C Retrieve the integer which follows the H and use it to modify all of
C the current character-position variables.
C
  145 CALL PCGTDI (CHRS,NCHR,ICHR,NUPA)
      DELX=REAL(NUPA)
      IF (ICHR.LT.NCHR) THEN
        IF (CHRS(ICHR+1:ICHR+1).EQ.'Q') THEN
          ICHR=ICHR+1
          IF (NUPA.EQ.0) NUPA=1
          DELX=REAL(NUPA)*WPIC(IPIC)
        END IF
      END IF
      XCEN=XCEN+DELX*STCO
      YCEN=YCEN+DELX*STSO
      XRGT=XRGT+DELX*STCO
      YRGT=YRGT+DELX*STSO
      GO TO 104
C
C V is for Vertical.
C
C Retrieve the integer which follows the V and use it to modify all of
C the current character-position variables.
C
  146 CALL PCGTDI (CHRS,NCHR,ICHR,NUPA)
      DELY=REAL(NUPA)
      IF (ICHR.LT.NCHR) THEN
        IF (CHRS(ICHR+1:ICHR+1).EQ.'Q') THEN
          ICHR=ICHR+1
          IF (NUPA.EQ.0) NUPA=1
          DELY=REAL(NUPA)*VPIC(IPIC)
        END IF
      END IF
      XCEN=XCEN-DELY*STSO
      YCEN=YCEN+DELY*STCO
      XRGT=XRGT-DELY*STSO
      YRGT=YRGT+DELY*STCO
      GO TO 104
C
C FONT CHANGE REQUEST
C -------------------
C
C F is for Font.  The intent is to request use of one of the Hershey
C fonts which are defined by fontcaps, stroking out the characters,
C rather than leaving it to be done by the translator.
C
C Retrieve the integer that follows the F; it determines which font to
C use.  If there is no such integer, go back to the font that was in
C use when PLCHHQ was called.
C
  147 ICHS=ICHR
      CALL PCGTDI (CHRS,NCHR,ICHR,NFNT)
      IF (ICHR.EQ.ICHS) THEN
        NFNT=NODF
        GO TO 104
      END IF
C
C If the font number was given, force it to be positive and check the
C value given.  In place of illegal values, use a 1.  When a new font
C is made available, the block IF must be updated and a copy of it must
C be put in the routine PCSETR.
C
      IF (NFNT.LT.0) NFNT=-NFNT
C
      IF ((NFNT.GE. 23.AND.NFNT.LE. 24).OR.
     +    (NFNT.GE. 27.AND.NFNT.LE. 28).OR.
     +    (NFNT.GE. 31.AND.NFNT.LE. 32).OR.
     +    (NFNT.GE. 38.AND.NFNT.LE.120).OR.
     +    (NFNT.GE.123.AND.NFNT.LE.124).OR.
     +    (NFNT.GE.127.AND.NFNT.LE.128).OR.
     +    (NFNT.GE.131.AND.NFNT.LE.132).OR.NFNT.GE.138) NFNT=1
C
      GO TO 104
C
C ZOOM REQUEST
C ------------
C
C X is for X zoom, Y is for Y zoom, and Z is for Zoom.  The intent is
C to temporarily change the width, the height, or both dimensions, of
C the characters to a given percentage of normal.
C
C The integer which follows the X, Y, or Z determines the percent
C of normal to be used.  If a "Q" follows the number, it requests a
C vertical adjustment of the current center and right positions to
C make the characters look as if they were all written on the same
C base line.  This has no meaning for "X" and is just ignored.
C
C Process an "X".
C
  148 CALL PCGTDI (CHRS,NCHR,ICHR,ITMP)
      ZOOM=REAL(ITMP/100.)
      IF (ZOOM.EQ.0.) ZOOM=1.
      XMZM(1)=ZOOM*XMUL(1)
      XMZM(2)=ZOOM*XMUL(2)
      XMZM(3)=ZOOM*XMUL(3)
      IF (ICHR.LT.NCHR) THEN
        IF (CHRS(ICHR+1:ICHR+1).EQ.'Q') ICHR=ICHR+1
      END IF
      GO TO 104
C
C Process a "Y".
C
  149 CALL PCGTDI (CHRS,NCHR,ICHR,ITMP)
      ZOLD=YMZM(1)/YMUL(1)
      ZOOM=REAL(ITMP/100.)
      IF (ZOOM.EQ.0.) ZOOM=1.
      YMZM(1)=ZOOM*YMUL(1)
      YMZM(2)=ZOOM*YMUL(2)
      YMZM(3)=ZOOM*YMUL(3)
      IF (ICHR.LT.NCHR) THEN
        IF (IQUF.EQ.0.AND.CHRS(ICHR+1:ICHR+1).EQ.'Q') THEN
          ICHR=ICHR+1
          DELY=.5*HPIC(IPIC)*(ZOOM-ZOLD)
          XCEN=XCEN-DELY*STSO
          YCEN=YCEN+DELY*STCO
          XRGT=XRGT-DELY*STSO
          YRGT=YRGT+DELY*STCO
        END IF
      END IF
      GO TO 104
C
C Process a "Z".
C
  150 CALL PCGTDI (CHRS,NCHR,ICHR,ITMP)
      ZOLD=YMZM(1)/YMUL(1)
      ZOOM=REAL(ITMP/100.)
      IF (ZOOM.EQ.0.) ZOOM=1.
      XMZM(1)=ZOOM*XMUL(1)
      XMZM(2)=ZOOM*XMUL(2)
      XMZM(3)=ZOOM*XMUL(3)
      YMZM(1)=ZOOM*YMUL(1)
      YMZM(2)=ZOOM*YMUL(2)
      YMZM(3)=ZOOM*YMUL(3)
      IF (ICHR.LT.NCHR) THEN
        IF (IQUF.EQ.0.AND.CHRS(ICHR+1:ICHR+1).EQ.'Q') THEN
          ICHR=ICHR+1
          DELY=.5*HPIC(IPIC)*(ZOOM-ZOLD)
          XCEN=XCEN-DELY*STSO
          YCEN=YCEN+DELY*STCO
          XRGT=XRGT-DELY*STSO
          YRGT=YRGT+DELY*STCO
        END IF
      END IF
      GO TO 104
C
C Formats.
C
 1001 FORMAT(' PLCHHQ - CHARACTER NUMBER',I3,' (',A1,') IS NOT A',
     +       ' LEGAL FUNCTION CODE')
C
      END

C
C
C  $Id: trip.f,v 1.1 1994-08-11 23:17:37 boote Exp $
C
C This subprogram is used by subroutine COEFF1 in library 
C ncarm.  It is lower-level, i.e. not called by users.
C *******************************************************
      SUBROUTINE TRIP (N,A,B,C,Y,Z,INT)
      DIMENSION       A(1)       ,B(1)       ,C(1)       ,Y(1)       ,
     1                Z(1)
      SAVE
C
C ARITHMETIC STATEMENT FUNCTION USED TO LOCATE ENTRIES IN ARRAY Z.
C
      II(INDEX)=(INDEX-1)*INT+1
C
C GAUSSIAN ELIMINATION
C
      BN = B(N)
      YN = Y(N)
      V = C(N)
      Y(1) = Y(1)/B(1)
      A(1) = A(1)/B(1)
      B(1) = C(1)/B(1)
      NM2 = N-2
      DO 101 J=2,NM2
         DEN = B(J)-A(J)*B(J-1)
         B(J) = C(J)/DEN
         Y(J) = (Y(J)-A(J)*Y(J-1))/DEN
         A(J) = -A(J)*A(J-1)/DEN
         BN = BN-V*A(J-1)
         YN = YN-V*Y(J-1)
         V = -V*B(J-1)
  101 CONTINUE
      DEN = B(N-1)-A(N-1)*B(N-2)
      B(N-1) = (C(N-1)-A(N-1)*A(N-2))/DEN
      Y(N-1) = (Y(N-1)-A(N-1)*Y(N-2))/DEN
      BN = BN-V*A(N-2)
      YN = YN-V*Y(N-2)
      V = A(N)-V*B(N-2)
C BACK SUBSTITUTION
      IIN = II(N)
      Z(IIN) = (YN-V*Y(N-1))/(BN-V*B(N-1))
      IIN2 = II(N-1)
      Z(IIN2) = Y(N-1)-B(N-1)*Z(IIN)
      NM1 = N-1
      IN = II(N)
      DO 102 J=2,NM1
         K = N-J
         IK = II(K)
      IKT = IK+INT
  102 Z(IK) = Y(K)-B(K)*Z(IKT)-A(K)*Z(IN)
      RETURN
      END

      REAL             FUNCTION CLANSY( NORM, UPLO, N, A, LDA, WORK )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     October 31, 1992
*
*     .. Scalar Arguments ..
      CHARACTER          NORM, UPLO
      INTEGER            LDA, N
*     ..
*     .. Array Arguments ..
      REAL               WORK( * )
      COMPLEX            A( LDA, * )
*     ..
*
*  Purpose
*  =======
*
*  CLANSY  returns the value of the one norm,  or the Frobenius norm, or
*  the  infinity norm,  or the  element of  largest absolute value  of a
*  complex symmetric matrix A.
*
*  Description
*  ===========
*
*  CLANSY returns the value
*
*     CLANSY = ( max(abs(A(i,j))), NORM = 'M' or 'm'
*              (
*              ( norm1(A),         NORM = '1', 'O' or 'o'
*              (
*              ( normI(A),         NORM = 'I' or 'i'
*              (
*              ( normF(A),         NORM = 'F', 'f', 'E' or 'e'
*
*  where  norm1  denotes the  one norm of a matrix (maximum column sum),
*  normI  denotes the  infinity norm  of a matrix  (maximum row sum) and
*  normF  denotes the  Frobenius norm of a matrix (square root of sum of
*  squares).  Note that  max(abs(A(i,j)))  is not a  matrix norm.
*
*  Arguments
*  =========
*
*  NORM    (input) CHARACTER*1
*          Specifies the value to be returned in CLANSY as described
*          above.
*
*  UPLO    (input) CHARACTER*1
*          Specifies whether the upper or lower triangular part of the
*          symmetric matrix A is to be referenced.
*          = 'U':  Upper triangular part of A is referenced
*          = 'L':  Lower triangular part of A is referenced
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.  When N = 0, CLANSY is
*          set to zero.
*
*  A       (input) COMPLEX array, dimension (LDA,N)
*          The symmetric matrix A.  If UPLO = 'U', the leading n by n
*          upper triangular part of A contains the upper triangular part
*          of the matrix A, and the strictly lower triangular part of A
*          is not referenced.  If UPLO = 'L', the leading n by n lower
*          triangular part of A contains the lower triangular part of
*          the matrix A, and the strictly upper triangular part of A is
*          not referenced.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(N,1).
*
*  WORK    (workspace) REAL array, dimension (LWORK),
*          where LWORK >= N when NORM = 'I' or '1' or 'O'; otherwise,
*          WORK is not referenced.
*
* =====================================================================
*
*     .. Parameters ..
      REAL               ONE, ZERO
      PARAMETER          ( ONE = 1.0E+0, ZERO = 0.0E+0 )
*     ..
*     .. Local Scalars ..
      INTEGER            I, J
      REAL               ABSA, SCALE, SUM, VALUE
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           CLASSQ
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, MAX, SQRT
*     ..
*     .. Executable Statements ..
*
      IF( N.EQ.0 ) THEN
         VALUE = ZERO
      ELSE IF( LSAME( NORM, 'M' ) ) THEN
*
*        Find max(abs(A(i,j))).
*
         VALUE = ZERO
         IF( LSAME( UPLO, 'U' ) ) THEN
            DO 20 J = 1, N
               DO 10 I = 1, J
                  VALUE = MAX( VALUE, ABS( A( I, J ) ) )
   10          CONTINUE
   20       CONTINUE
         ELSE
            DO 40 J = 1, N
               DO 30 I = J, N
                  VALUE = MAX( VALUE, ABS( A( I, J ) ) )
   30          CONTINUE
   40       CONTINUE
         END IF
      ELSE IF( ( LSAME( NORM, 'I' ) ) .OR. ( LSAME( NORM, 'O' ) ) .OR.
     $         ( NORM.EQ.'1' ) ) THEN
*
*        Find normI(A) ( = norm1(A), since A is symmetric).
*
         VALUE = ZERO
         IF( LSAME( UPLO, 'U' ) ) THEN
            DO 60 J = 1, N
               SUM = ZERO
               DO 50 I = 1, J - 1
                  ABSA = ABS( A( I, J ) )
                  SUM = SUM + ABSA
                  WORK( I ) = WORK( I ) + ABSA
   50          CONTINUE
               WORK( J ) = SUM + ABS( A( J, J ) )
   60       CONTINUE
            DO 70 I = 1, N
               VALUE = MAX( VALUE, WORK( I ) )
   70       CONTINUE
         ELSE
            DO 80 I = 1, N
               WORK( I ) = ZERO
   80       CONTINUE
            DO 100 J = 1, N
               SUM = WORK( J ) + ABS( A( J, J ) )
               DO 90 I = J + 1, N
                  ABSA = ABS( A( I, J ) )
                  SUM = SUM + ABSA
                  WORK( I ) = WORK( I ) + ABSA
   90          CONTINUE
               VALUE = MAX( VALUE, SUM )
  100       CONTINUE
         END IF
      ELSE IF( ( LSAME( NORM, 'F' ) ) .OR. ( LSAME( NORM, 'E' ) ) ) THEN
*
*        Find normF(A).
*
         SCALE = ZERO
         SUM = ONE
         IF( LSAME( UPLO, 'U' ) ) THEN
            DO 110 J = 2, N
               CALL CLASSQ( J-1, A( 1, J ), 1, SCALE, SUM )
  110       CONTINUE
         ELSE
            DO 120 J = 1, N - 1
               CALL CLASSQ( N-J, A( J+1, J ), 1, SCALE, SUM )
  120       CONTINUE
         END IF
         SUM = 2*SUM
         CALL CLASSQ( N, A, LDA+1, SCALE, SUM )
         VALUE = SCALE*SQRT( SUM )
      END IF
*
      CLANSY = VALUE
      RETURN
*
*     End of CLANSY
*
      END

C NCLFORTSTART
      SUBROUTINE GRID2TRIPLE(X,Y,Z,MX,NY,D,LDMAX,LD,ZMSG,IER)
      IMPLICIT NONE
c NCL:   d = grid2triple (x,y,z)     ;
c                                               input
      INTEGER MX,NY,LDMAX
      DOUBLE PRECISION X(MX),Y(NY),Z(MX,NY),ZMSG
c                                               output
      INTEGER LD,IER
      DOUBLE PRECISION D(LDMAX,3)
C NCLEND

c nomenclature
c .   x,y   - 1D coord variables dimensioned (mx and ny)
c .   z     - 2D grid containing functional values z(x,y)
c .   mx,ny - length of x and y; dimensions of z(mx,ny)
c .   d     - 2D vector of size (ldmax,3)
c .   ldmax - mx*ny
c .   ld    - actual number of non-missing values
c .   zmsg  - missing value code for z
c .           if no missing values set to some number which
c .           can not be encountered
c .   ier   - eeor flag
c                                               local
      INTEGER M,N

      IER = 0
      LD = 0

      DO N = 1,NY
          DO M = 1,MX
              IF (Z(M,N).NE.ZMSG) THEN
                  LD = LD + 1
                  D(LD,1) = X(M)
                  D(LD,2) = Y(N)
                  D(LD,3) = Z(M,N)
              END IF
          END DO
      END DO

      IF (LD.EQ.0) THEN
          IER = -10
C          PRINT *,'grid2triple: ld=0: all values missing'
      END IF
      RETURN
      END

C
C $Id: mdgetl.f,v 1.9 2008-09-18 00:42:17 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MDGETL (WHCH,LVAL)
C
        CHARACTER*(*) WHCH
        LOGICAL       LVAL
C
C Declare required common blocks.  See MAPBDX for descriptions of these
C common blocks and the variables in them.
C
        COMMON /MAPCM4/  GRDR,GRID,GRLA,GRLO,GRPO,OTOL,PDRE,PLA1,PLA2,
     +                   PLA3,PLA4,PLB1,PLB2,PLB3,PLB4,PLNO,PLTO,ROTA,
     +                   SRCH,XLOW,XROW,YBOW,YTOW,IDOT,IDSH,IDTL,ILCW,
     +                   ILTS,JPRJ,ELPF,INTF,LBLF,PRMF
        DOUBLE PRECISION GRDR,GRID,GRLA,GRLO,GRPO,OTOL,PDRE,PLA1,PLA2,
     +                   PLA3,PLA4,PLB1,PLB2,PLB3,PLB4,PLNO,PLTO,ROTA,
     +                   SRCH,XLOW,XROW,YBOW,YTOW
        INTEGER          IDOT,IDSH,IDTL,ILCW,ILTS,JPRJ
        LOGICAL          ELPF,INTF,LBLF,PRMF
        SAVE   /MAPCM4/
C
        IF (ICFELL('MDGETL - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
        IF      (WHCH(1:2).EQ.'DL'.OR.WHCH(1:2).EQ.'dl') THEN
          LVAL=IDTL.NE.0
        ELSE IF (WHCH(1:2).EQ.'DO'.OR.WHCH(1:2).EQ.'do') THEN
          LVAL=IDOT.NE.0
        ELSE IF (WHCH(1:2).EQ.'EL'.OR.WHCH(1:2).EQ.'el') THEN
          LVAL=ELPF
        ELSE IF (WHCH(1:2).EQ.'IN'.OR.WHCH(1:2).EQ.'in') THEN
          LVAL=INTF
        ELSE IF (WHCH(1:2).EQ.'LA'.OR.WHCH(1:2).EQ.'la') THEN
          LVAL=LBLF
        ELSE IF (WHCH(1:2).EQ.'PE'.OR.WHCH(1:2).EQ.'pe') THEN
          LVAL=PRMF
        ELSE
          GO TO 901
        END IF
C
C Done.
C
        RETURN
C
C Error exits.
C
  901   CALL MDPCEM ('MDGETL - UNKNOWN PARAMETER NAME ',WHCH,2,1)
        LVAL=.FALSE.
        RETURN
C
      END

C       ....................SSP...........................................
C
C          SUBROUTINE KOLM2
C
C          PURPOSE
C
C             TESTS THE DIFFERENCE BETWEEN TWO SAMPLE DISTRIBUTION
C             FUNCTIONS USING THE KOLMOGOROV-SMIRNOV TEST
C
C          USAGE
C             CALL KOLM2(X,Y,N,M,Z,PROB)
C             CALL KOLM2(X,Y,N,M,Z,PROB,D) <== NCL
C
C          DESCRIPTION OF PARAMETERS
C             X    - INPUT VECTOR OF N INDEPENDENT OBSERVATIONS.  ON
C                    RETURN FROM KOLM2, X HAS BEEN SORTED INTO A
C                    MONOTONIC NON-DECREASING SEQUENCE.
C             Y    - INPUT VECTOR OF M INDEPENDENT OBSERVATIONS.  ON
C                    RETURN FROM KOLM2, Y HAS BEEN SORTED INTO A
C                    MONOTONIC NON-DECREASING SEQUENCE.
C             N    - NUMBER OF OBSERVATIONS IN X
C             M    - NUMBER OF OBSERVATIONS IN Y
C             Z    - OUTPUT VARIABLE CONTAINING THE GREATEST VALUE WITH
C                    RESPECT TO THE SPECTRUM OF X AND Y OF
C                    SQRT((M*N)/(M+N))*ABS(FN(X)-GM(Y)) WHERE
C                    FN(X) IS THE EMPIRICAL DISTRIBUTION FUNCTION OF THE
C                    SET (X) AND GM(Y) IS THE EMPIRICAL DISTRIBUTION
C                    FUNCTION OF THE SET (Y).
C             PROB - OUTPUT VARIABLE CONTAINING THE PROBABILITY OF
C                    THE STATISTIC BEING GREATER THAN OR EQUAL TO Z IF
C                    THE HYPOTHESIS THAT X AND Y ARE FROM THE SAME PDF IS
C                    TRUE.  E.G., PROB= 0.05 IMPLIES THAT ONE CAN REJECT
C                    THE NULL HYPOTHESIS THAT THE SETS X AND Y ARE FROM
C                    THE SAME DENSITY WITH 5 PER CENT PROBABILITY OF BEING
C                    INCORRECT.  PROB = 1. - SMIRN(Z).
C
C          REMARKS
C             N AND M SHOULD BE GREATER THAN OR EQUAL TO 100.  (SEE THE
C             MATHEMATICAL DESCRIPTION FOR THIS SUBROUTINE AND FOR THE
C             SUBROUTINE SMIRN, CONCERNING ASYMPTOTIC FORMULAE).
C
C             DOUBLE PRECISION USAGE---IT IS DOUBTFUL THAT THE USER WILL
C             WISH TO PERFORM THIS TEST USING DOUBLE PRECISION ACCURACY.
C             IF ONE WISHES TO COMMUNICATE WITH KOLM2 IN A DOUBLE
C             PRECISION PROGRAM, HE SHOULD CALL THE FORTRAN SUPPLIED
C             PROGRAM SNGL(X) PRIOR TO CALLING KOLM2, AND CALL THE
C             FORTRAN SUPPLIED PROGRAM DBLE(X) AFTER EXITING FROM KOLM2.
C             (NOTE THAT SUBROUTINE SMIRN DOES HAVE DOUBLE PRECISION
C             CAPABILITY AS SUPPLIED BY THIS PACKAGE.)
C
C
C          SUBROUTINES AND FUNCTION SUBPROGRAMS REQUIRED
C             SMIRN
C
C          METHOD
C             FOR REFERENCE, SEE (1) W. FELLER--ON THE KOLMOGOROV-SMIRNOV
C             LIMIT THEOREMS FOR EMPIRICAL DISTRIBUTIONS--
C             ANNALS OF MATH. STAT., 19, 1948.  177-189,
C             (2) N. SMIRNOV--TABLE FOR ESTIMATING THE GOODNESS OF FIT
C             OF EMPIRICAL DISTRIBUTIONS--ANNALS OF MATH. STAT., 19,
C             1948.  279-281.
C             (3) R. VON MISES--MATHEMATICAL THEORY OF PROBABILITY AND
C             STATISTICS--ACADEMIC PRESS, NEW YORK, 1964.  490-493,
C             (4) B.V. GNEDENKO--THE THEORY OF PROBABILITY--CHELSEA
C             PUBLISHING COMPANY, NEW YORK, 1962.  384-401.
C
C       ..................................................................
C
C C C   SUBOUTINE KOLM2(X,Y,N,M,Z,PROB,D)
C NCLFORTSTART
        SUBROUTINE KOLM2(X,Y,N,M,IFLAG,Z,PROB,D)
C                                            INPUT
        INTEGER N,M, IFLAG
        DOUBLE PRECISION X(N),Y(M)
C                                            OUTPUT
        DOUBLE PRECISION Z, PROB, D
C NCLEND
        DOUBLE PRECISION TEMP, XN, XN1, XM, XM1

        IF (IFLAG.EQ.0) THEN
C
C          SORT X INTO ASCENDING SEQUENCE
C
        DO 5 I=2,N
        IF(X(I)-X(I-1))1,5,5
1       TEMP=X(I)
        IM=I-1
        DO 3 J=1,IM
        L=I-J
        IF(TEMP-X(L))2,4,4
2       X(L+1)=X(L)
3       CONTINUE
        X(1)=TEMP
        GO TO 5
4       X(L+1)=TEMP
5       CONTINUE

C
C          SORT Y INTO ASCENDING SEQUENCE
C
        DO 10 I=2,M
        IF(Y(I)-Y(I-1))6,10,10
6       TEMP=Y(I)
        IM=I-1
        DO 8  J=1,IM
        L=I-J
        IF(TEMP-Y(L))7,9,9
7       Y(L+1)=Y(L)
8       CONTINUE
        Y(1)=TEMP
        GO TO 10
9       Y(L+1)=TEMP
10      CONTINUE

        END IF
C
C          CALCULATE D = ABS(FN-GM) OVER THE SPECTRUM OF X AND Y
C
        XN =DBLE(N)
        XN1=1.0D0/XN
        XM =DBLE(M)
        XM1=1.0D0/XM
        D=0.0D0
        I=0
        J=0
        K=0
        L=0
11      IF(X(I+1)-Y(J+1))12,13,18
12      K=1
        GO TO 14
13      K=0
14      I=I+1
        IF(I-N)15,21,21
15      IF(X(I+1)-X(I))14,14,16
16      IF(K)17,18,17
C
C          CHOOSE THE MAXIMUM DIFFERENCE, D
C
17      D=AMAX1(D,ABS(DBLE(I)*XN1-DBLE(J)*XM1))
        IF(L)22,11,22
18      J=J+1
        IF(J-M)19,20,20
19      IF(Y(J+1)-Y(J))18,18,17
20      L=1
        GO TO 17
21      L=1
        GO TO 16
C
C          CALCULATE THE STATISTIC Z
C
22      Z=D*SQRT((XN*XM)/(XN+XM))
C
C          CALCULATE THE PROBABILITY ASSOCIATED WITH Z
C
        CALL SMIRN(Z,PROB)
        PROB = 1.0D0-PROB
        
        RETURN
        END
C---
      SUBROUTINE SMIRN(X,Y)
      DOUBLE PRECISION X, Y 
      DOUBLE PRECISION Q1, Q2, Q4, Q8

      IF(X-0.27D0)1,1,2
    1 Y=0.0D0
      GO TO 9
    2 IF(X-1.0D0)3,6,6
    3 Q1=EXP(-1.233701D0/X**2)
      Q2=Q1*Q1
      Q4=Q2*Q2
      Q8=Q4*Q4
      IF(Q8-1D-25)4,5,5
    4 Q8=0.0D0
    5 Y=(2.506628D0/X)*Q1*(1.0D0+Q8*(1.0D0+Q8*Q8))
      GO TO 9
    6 IF(X-3.1D0)8,7,7
    7 Y=1.0D0
      GO TO 9
    8 Q1=EXP(-2.0D0*X*X)
      Q2=Q1*Q1
      Q4=Q2*Q2
      Q8=Q4*Q4
      Y=1.0D0-2.0D0*(Q1-Q4+Q8*(Q1-Q8))
    9 RETURN
      END

      PROGRAM CCPSET
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER (K=40,N=40,LRWK=1000,LIWK=1000)
      REAL Z(K,N), RWRK(LRWK)
      INTEGER M, IWRK(LIWK)

      CALL GETDAT (Z, K, M, N) 
C
C Open GKS
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Draw a perimeter around the whole frame to show off SET call
C
      CALL SET (0.,1.,0.,1.,0.,1.,0.,1.,1)
      CALL PERIM(0,0,0,0)
C
C Force Data to be drawn in a rectangle twice as long as it is wide
C and only draw in the lower right hand corner of the screen
C
      CALL SET (0.5,0.98,0.125,0.375,0.,2.,0.,1.,1)
      CALL CPSETI('SET - DO-SET-CALL FLAG',0)
      CALL CPSETR('XC1 - X COORDINATE AT INDEX 1',0.)
      CALL CPSETR('XCM - X COORDINATE AT INDEX M',2.)
      CALL CPSETR('YC1 - Y COORDINATE AT INDEX 1',0.)
      CALL CPSETR('YCN - Y COORDINATE AT INDEX N',1.)
C
C Initialize Conpack
C
      CALL CPRECT(Z,K,M,N,RWRK,LRWK,IWRK,LIWK)
C
C Draw perimeter
C
      CALL CPBACK(Z, RWRK, IWRK)
C
C Draw Contours
C
      CALL CPCLDR(Z,RWRK,IWRK)
C
C Close frame and close GKS
C
      CALL FRAME
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS

      STOP
      END
      
      SUBROUTINE GETDAT (Z, K, M, N)
      INTEGER I,J,K,M,N
      REAL Z(K,N)
      
      M=K
      DO 10, I=1,M
         DO 20, J=1,N
            Z(I,J)= 10.E-5*(-16.*REAL(I**2*J) +
     +           34*REAL(I*J**2) - REAL(6*I) + 93.)
 20      CONTINUE
 10   CONTINUE
      
      RETURN
      END

c ---------------------------------------------------------
      SUBROUTINE DDRVEOF(X,NROW,NCOL,NOBS,MSTA,XMSG,NEVAL,EVAL,EVEC,
     +                  PCVAR,TRACE,IOPT,JOPT,CSSM,LCSSM,WORK,LWORK,
     +                  WEVAL,IWORK,LIWORK,IFAIL,LIFAIL,IER)
      DOUBLE PRECISION XMSG
      DOUBLE PRECISION TRACE
      DOUBLE PRECISION TOL
      DOUBLE PRECISION DEPSMACH
      DOUBLE PRECISION VLOW
      DOUBLE PRECISION VUP

c driver to calculate :
C*PL*ERROR* Comment line too long
c .   the principal components (eignvalues and corresponding eigenvectors)
c .       of the data array x. x may contain missing observations.
c .       if it has msg data, this will calculate a var-cov matrix
c .       but it may not be positive definite.

c .       USES LAPACK/BLAS ROUTINES

c nomenclature :
C*PL*ERROR* Comment line too long
c .   x         - matrix containing the data.  it contains n observations
c .               for each of m stations or grid pts.
C*PL*ERROR* Comment line too long
c .   nrow,ncol - exact row (observation) and column (station) dimensions
c .               of x in the calling routine.
c .   nobs      - actual number of observations (nobs <= nrow)
c .   msta      - actual number of stations     (msta <= ncol)
c .   xmsg      - missing code (if no obs are missing set to some
c .               number which will not be encountered)
c .   neval     - no. of eigenvalues and eigen vectors to be computed.
C*PL*ERROR* Comment line too long
c .               neval <= msta , if not msta eigenvalues and eigenvectors
c .               will be computed and ier = -2.
c .   eval      - vector containing the eigenvalues in DESCENDING order.
c .               eval must be at least neval in length.
c .   evec      - an array which will contains the eigenvector info.
c .               this must be dimensioned at least (ncol,neval) in the
c .               calling routine. There is some normalization done
c .               but I am not sure waht it is.
C*PL*ERROR* Comment line too long
c .   pcvar     - contains the % variance associated with each eigenvalue.
c .               this must be dimensioned at least neval in length.
c .   trace     - trace of the variance - covariance matrix.in the
c .               case of a var-covar matrix , the trace should
c .               equal the sum of all possible eigenvalues.
c .   iopt      - not used; kept for compatibility with old routine
c .   jopt      - =  0 : use var-covar matrix in prncmp
c .                  1 : use correlation matrix in prncmp
c .   cssm      - real vector to hold the covariance/correlation matrix
c .   lcssm     - length of cssm =msta*(msta+1)/2
c .   work      - real vector
c .   weval     - = msta
c .   lwork     - = 8*msta
c .   iwork     - integer vector
c .   liwork    - = 5*msta
c .   ifail     - integer vector
c .   lifail    - = msta
c .   ier       - error code

c NOTE: upon return if one want to get loadings,
c       something like this should be tried.
c
c           to calculate the coef or amplitude vector
c           associated with the n th eigenvector
c           mult the anomaly matrix (datam) times the
c           transpose of the eigenvector
c               meval = neval
c               do n=1,meval
c                  evwrk(n) = 0.
c                 do nyr=1,nyrs
c                    evyran(nyr,n) = 0.0
c                    evyrpv(nyr,n) = 0.0
c                   do m=1,msta
c                      if (datam(nyr,m).ne.xmsg) then
c                          temp = evec(m,n)*datam(nyr,m)
c                          evyran(nyr,n) = evyran(nyr,n) + temp
c                          evyrpv(nyr,n) = evyrpv(nyr,n) + temp*temp
c                          evwrk(n) = evwrk(n) + temp*temp
c                      endif
c                   enddo
c                 enddo
c               .
c               enddo


      DOUBLE PRECISION X(1:NROW,1:NCOL),EVAL(*),EVEC(1:NCOL,*)
      REAL PCVAR(*)
      INTEGER*8 LCSSM
      DOUBLE PRECISION CSSM(LCSSM),WORK(LWORK),WEVAL(LIFAIL)
      INTEGER IWORK(LIWORK),IFAIL(LIFAIL)

      CHARACTER*16 LABEL
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION TEMP

      DATA IPR/6/
      DATA IPRFLG/1/
c calculate covariance or correlation matrix in symmetric storage mode

      IER = 0
      IF (JOPT.EQ.0) THEN
          CALL DVCMSSM(X,NROW,NCOL,NOBS,MSTA,XMSG,CSSM,LSSM,IER)
      ELSE
          CALL DCRMSSM(X,NROW,NCOL,NOBS,MSTA,XMSG,CSSM,LSSM,IER)
      END IF
      IF (IER.NE.0) THEN
          WRITE (IPR,FMT=
     +'(//'' sub drveof: ier,jopt= '',2i3
     +   ,'' returned from vcmssm/crmssm'')') IER,JOPT
          IF (IER.GT.0) RETURN
      END IF

c activate if print of cov/cor matrix [work] is desired

      IF (IPRFLG.EQ.2) THEN
          IF (JOPT.EQ.0) THEN
              LABEL(1:15) = 'covar matrix:  '
          ELSE
              LABEL(1:15) = 'correl matrix: '
          END IF
          WRITE (IPR,FMT='(//,a15,''sym storage mode'')') LABEL(1:15)
          CALL DSSMIOX(CSSM,MSTA)
      END IF

c calculate the trace  before it is destroyed by sspevx

      NA = 0
C*PT*WARNING* Already double-precision (DBLE)
      TEMP = DBLE(0.D0)
      DO NN = 1,MSTA
          NA = NA + NN
C*PT*WARNING* Already double-precision (DBLE)
          TEMP = TEMP + DBLE(CSSM(NA))
      END DO
C*PT*WARNING* Already double-precision (DBLE)
      IF (TEMP.EQ.DBLE(0.D0)) THEN
          IER = -88
          WRITE (IPR,FMT=
     +'(//'' sub drveof: ier,jopt= '',2i3
     +   ,'' trace=0.0'')') IER,JOPT
          RETURN
      END IF
      TRACE = TEMP

c calculate the specified number of eigenvalues and the corresponding
c .   eigenvectors.

      MEVAL = MIN(NEVAL,MSTA)

      TOL = 10.D0*DEPSMACH(IPR)
      VLOW = 0.0D0
      VUP = 0.0D0
      ILOW = MAX(MSTA-MEVAL+1,1)
      IUP = MSTA
      CALL DSPEVX('V','I','U',MSTA,CSSM,VLOW,VUP,ILOW,IUP,TOL,MEVOUT,
     +            WEVAL,EVEC,NCOL,WORK,IWORK,IFAIL,INFO)

      IF (INFO.NE.0) THEN
          IER = IER + INFO
          WRITE (IPR,FMT=
     +'(//,'' sub drveof: sspevx error: info=''
     +      ,   i9)') INFO
          WRITE (IPR,FMT=
     +'(   '' sub drveof: sspevx error: ifail=''
     +      ,   20i5)') (IFAIL(I),I=1,MIN(20,MSTA))
      END IF

c reverse the order of things from "sspevx" so
c .   largest eigenvalues/vectors are first.

      DO N = 1,MEVAL
          WORK(N) = WEVAL(N)
      END DO
      DO N = 1,MEVAL
          EVAL(N) = WORK(NEVAL+1-N)
      END DO

      DO N = 1,MSTA
          DO NN = 1,NEVAL
              WORK(NN) = EVEC(N,NN)
          END DO
          DO NN = 1,NEVAL
              EVEC(N,NN) = WORK(NEVAL+1-NN)
          END DO
      END DO
C
C Convert EVEC and EVAL to single precision real
C
      DO N = 1,MEVAL
          PCVAR(N) = REAL(EVAL(N)/TRACE)*100.
      END DO

      RETURN
      END

      SUBROUTINE DNCLDRV(XX,X,NROW,NCOL,NOBS,NSTA,XMSG,NEVAL,EVAL,EVEC,
     +                 PCVAR,TRACE,IOPT,JOPT,PCRIT,EVECX,CSSM,LCSSM,
     +                 WORK,LWORK,WEVAL,IWORK,LIWORK,IFAIL,LIFAIL,IER)
      DOUBLE PRECISION PCRITX

      INTEGER NROW,NCOL,NOBS,NSTA,NEVAL,IOPT,JOPT,IER
      INTEGER*8 LCSSM
      INTEGER LWORK,LIWORK,LIFAIL
      DOUBLE PRECISION XX(NROW,NCOL),EVAL(NEVAL),EVEC(NCOL,NEVAL),
     +                 PCRIT,XMSG,TRACE,X(NROW,NCOL),
     +                 EVECX(NCOL,NEVAL)
      DOUBLE PRECISION CSSM(LCSSM),WORK(LWORK),WEVAL(LIFAIL)
      REAL PCVAR(NEVAL)
      INTEGER IWORK(LIWORK),IFAIL(LIFAIL)

      DATA IPR/6/
      DATA IPRFLG/1/

      PCRITX = PCRIT*0.01D0
c                                   ! counts the total number of
c                                   ! locations with > pcrit non=msg
      MSTA = 0
      DO NC = 1,NSTA
c                                   ! counter for this location
          KNT = 0
          DO NR = 1,NOBS
              IF (XX(NR,NC).NE.XMSG) THEN
                  KNT = KNT + 1
              END IF
          END DO
          IF (DBLE(KNT)/DBLE(NOBS).GE.PCRITX) THEN
              MSTA = MSTA + 1
              DO IROW = 1,NROW
                  X(IROW,MSTA) = XX(IROW,NC)
              END DO
          END IF
      END DO

c      write (*,'(//'' sub dncldrv: nrow,ncol,nobs,msta= ''
c     1              ,4i3)') nrow,ncol,nobs,msta
      CALL DDRVEOF(X,NROW,NCOL,NOBS,MSTA,XMSG,NEVAL,EVAL,EVECX,PCVAR,
     +             TRACE,IOPT,JOPT,CSSM,LCSSM,WORK,LWORK,WEVAL,IWORK,
     +             LIWORK,IFAIL,LIFAIL,IER)

c before returning put the evecs in the correct location

C preset the return array to msg
      DO NE = 1,NEVAL
          DO NC = 1,NCOL
              EVEC(NC,NE) = XMSG
          END DO
      END DO
c                                   ! counts the total number of
c                                   ! locations with > pcrit non=msg
      MSTA = 0
      DO NC = 1,NSTA
c counter for this location
          KNT = 0
          DO NR = 1,NOBS
              IF (XX(NR,NC).NE.XMSG) THEN
                  KNT = KNT + 1
              END IF
          END DO
          IF (DBLE(KNT)/DBLE(NOBS).GE.PCRITX) THEN
              MSTA = MSTA + 1
              DO IEVAL = 1,NEVAL
                  EVEC(NC,IEVAL) = EVECX(MSTA,IEVAL)
              END DO
          END IF
      END DO

      RETURN
      END

C
C       $Id: stgetr.f,v 1.11 2008-07-27 00:17:28 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
C
C-----------------------------------------------------------------------
C
      SUBROUTINE STGETR (CNM,RVL)
C
      CHARACTER*(*) CNM
C
C This subroutine is called to retrieve the real value of a specified
C parameter.
C
C CNM is the name of the parameter whose value is to be retrieved.
C
C RVL is a real variable in which the desired value is to be returned
C by STGETR.
C
C ---------------------------------------------------------------------
C
C NOTE:
C Since implicit typing is used for all real and integer variables
C a consistent length convention has been adopted to help clarify the
C significance of the variables encountered in the code for this 
C utility. All local variable and subroutine parameter identifiers 
C are limited to 1,2,or 3 characters. Four character names identify  
C members of common blocks. Five and 6 character variable names 
C denote PARAMETER constants or subroutine or function names.
C
C Declare the ST common blocks.
C
      PARAMETER (IPLVLS = 256)
C
C Integer and real common block variables
C
C
      COMMON / STPAR /
     +                IUD1       ,IVD1       ,IPD1       ,
     +                IXD1       ,IXDM       ,IYD1       ,IYDN       ,
     +                IXM1       ,IYM1       ,IXM2       ,IYM2       ,
     +                IWKD       ,IWKU       ,ISET       ,IERR       ,
     +                IXIN       ,IYIN       ,IMSK       ,ICPM       ,
     +                NLVL       ,IPAI       ,ICTV       ,WDLV       ,
     +                UVMN       ,UVMX       ,PMIN       ,PMAX       ,
     +                IPLR       ,ISST       ,
     +                ICLR(IPLVLS)           ,TVLU(IPLVLS)
C
      COMMON / STTRAN /
     +                UVPS       ,
     +                UVPL       ,UVPR       ,UVPB       ,UVPT       ,
     +                UWDL       ,UWDR       ,UWDB       ,UWDT       ,
     +                UXC1       ,UXCM       ,UYC1       ,UYCN 
C
C Stream algorithm parameters
C
      COMMON / STSTRM /
     +                ISGD       ,IAGD       ,RARL       ,ICKP       ,
     +                ICKX       ,ITRP       ,ICYK       ,RVNL       ,
     +                ISVF       ,RUSV       ,RVSV       ,RNDA       ,
     +                ISPC       ,RPSV       ,RCDS       ,RSSP       ,
     +                RDFM       ,RSMD       ,RAMD       ,IGBS       ,
     +                ISTM       ,RVRL       ,RVFR       ,RVRM       ,
     +                IVPO       ,RAFR       ,RDMX       ,RDMN
C
C Text related parameters
C Note: graphical text output is not yet implemented for the
C       Streamline utility.
C
      COMMON / STTXP /
     +                FCWM    ,ICSZ    ,
     +                FMNS    ,FMNX    ,FMNY    ,IMNP    ,IMNC  ,
     +                FMXS    ,FMXX    ,FMXY    ,IMXP    ,IMXC  ,
     +                FZFS    ,FZFX    ,FZFY    ,IZFP    ,IZFC  ,
     +                FILS    ,FILX    ,FILY    ,IILP    ,IILC 
C
C Character variable declartions
C
      CHARACTER*160 CSTR
      PARAMETER (IPCHSZ=80)
      CHARACTER*(IPCHSZ)  CMNT,CMXT,CZFT,CILT
C
C Text string parameters
C
      COMMON / STCHAR / CSTR,CMNT,CMXT,CZFT,CILT
C
      SAVE /STPAR/, /STTRAN/, /STSTRM/, /STTXP/, /STCHAR/
C
C Internal buffer lengths
C
C IPNPTS - Number of points in the point buffer -- not less than 3
C IPLSTL - Streamline-crossover-check circular list length
C IPGRCT - Number of groups supported for area masking
C
      PARAMETER (IPNPTS = 256, IPLSTL = 750, IPGRCT = 64)
C
C --------------------------------------------------------------------
C
C The mapping common block: made available to user mapping routines
C
      COMMON /STMAP/
     +                IMAP       ,LNLG       ,INVX       ,INVY       ,
     +                XLOV       ,XHIV       ,YLOV       ,YHIV       ,
     +                WXMN       ,WXMX       ,WYMN       ,WYMX       ,
     +                XVPL       ,XVPR       ,YVPB       ,YVPT       ,
     +                XGDS       ,YGDS       ,NXCT       ,NYCT       ,
     +                ITRT       ,FW2W       ,FH2H       ,
     +                DFMG       ,VNML       ,RBIG       ,IBIG
C
      SAVE /STMAP/
C
C Math constants
C
      PARAMETER (PDTOR  = 0.017453292519943,
     +           PRTOD  = 57.2957795130823,
     +           P1XPI  = 3.14159265358979,
     +           P2XPI  = 6.28318530717959,
     +           P1D2PI = 1.57079632679489,
     +           P5D2PI = 7.85398163397448) 
C
C ---------------------------------------------------------------------
C
C Check for a parameter name that is too short.
C
      IF (LEN(CNM).LT.3) THEN
        CSTR(1:46)='STGETI OR STGETR - PARAMETER NAME TOO SHORT - '
        CSTR(47:46+LEN(CNM))=CNM
        CALL SETER (CSTR(1:46+LEN(CNM)),1,1)
        RETURN
      END IF
C
C Check for incorrect use of the index parameter.
C
      IF (CNM(1:3).EQ.'CLR'.OR.CNM(1:3).EQ.'clr'
     +    .OR.CNM(1:3).EQ.'TVL'.OR.CNM(1:3).EQ.'tvl') THEN
         IF (IPAI.LT.1.OR.IPAI.GT.NLVL) THEN
            CSTR(1:46)='STGETI OR STGETR - GETTING XXX - PAI INCORRECT'
            CSTR(28:30)=CNM(1:3)
            CALL SETER (CSTR(1:46),2,1)
            RETURN
         END IF
      END IF
C
C Get the appropriate parameter value.
C
C ---------------------------------------------------------------------
C
C Values in STPAR
C
      IF (CNM(1:3).EQ.'UD1'.OR. CNM(1:3).EQ.'ud1') THEN
         RVL=REAL(IUD1)
      ELSE IF (CNM(1:3).EQ.'VD1'.OR. CNM(1:3).EQ.'vd1') THEN
         RVL=REAL(IVD1)
      ELSE IF (CNM(1:3).EQ.'PD1'.OR. CNM(1:3).EQ.'pd1') THEN
         RVL=REAL(IPD1)
      ELSE IF (CNM(1:3).EQ.'XD1'.OR. CNM(1:3).EQ.'xd1') THEN
         RVL=REAL(IXD1)
      ELSE IF (CNM(1:3).EQ.'XDM'.OR. CNM(1:3).EQ.'xdm') THEN
         RVL=REAL(IXDM)
      ELSE IF (CNM(1:3).EQ.'YD1'.OR. CNM(1:3).EQ.'yd1') THEN
         RVL=REAL(IYD1)
      ELSE IF (CNM(1:3).EQ.'YDN'.OR. CNM(1:3).EQ.'ydn') THEN
         RVL=REAL(IYDN)
      ELSE IF (CNM(1:3).EQ.'WKD'.OR.CNM(1:3).EQ.'wkd') THEN
        RVL=REAL(IWKD)
      ELSE IF (CNM(1:3).EQ.'WKU'.OR.CNM(1:3).EQ.'wku') THEN
        RVL=REAL(IWKU)
      ELSE IF (CNM(1:3).EQ.'SET'.OR. CNM(1:3).EQ.'set') THEN
         RVL=REAL(ISET)
      ELSE IF (CNM(1:3).EQ.'ERR'.OR. CNM(1:3).EQ.'err') THEN
         RVL=REAL(IERR)
      ELSE IF (CNM(1:3).EQ.'XIN'.OR.CNM(1:3).EQ.'xin') THEN
        RVL=IXIN
      ELSE IF (CNM(1:3).EQ.'YIN'.OR.CNM(1:3).EQ.'yin') THEN
        RVL=IYIN
      ELSE IF (CNM(1:3).EQ.'MSK'.OR. CNM(1:3).EQ.'msk') THEN
         RVL=REAL(IMSK)
      ELSE IF (CNM(1:3).EQ.'CPM'.OR. CNM(1:3).EQ.'cpm') THEN
         RVL=REAL(ICPM)
      ELSE IF (CNM(1:3).EQ.'NLV'.OR.CNM(1:3).EQ.'nlv') THEN
        RVL=REAL(NLVL)
      ELSE IF (CNM(1:3).EQ.'PAI'.OR.CNM(1:3).EQ.'pai') THEN
        RVL=REAL(IPAI)
      ELSE IF (CNM(1:3).EQ.'CTV'.OR.CNM(1:3).EQ.'ctv') THEN
        RVL=REAL(ICTV)
      ELSE IF (CNM(1:3).EQ.'LWD'.OR.CNM(1:3).EQ.'lwd') THEN
        RVL=WDLV
      ELSE IF (CNM(1:3).EQ.'VMN'.OR.CNM(1:3).EQ.'vmn') THEN
        RVL=UVMN
      ELSE IF (CNM(1:3).EQ.'VMX'.OR.CNM(1:3).EQ.'vmx') THEN
        RVL=UVMX
      ELSE IF (CNM(1:3).EQ.'PMN'.OR.CNM(1:3).EQ.'pmn') THEN
        RVL=PMIN
      ELSE IF (CNM(1:3).EQ.'PMX'.OR.CNM(1:3).EQ.'pmx') THEN
        RVL=PMAX
      ELSE IF (CNM(1:3).EQ.'THN'.OR. CNM(1:3).EQ.'thn') THEN
         RVL=REAL(ITHN)
      ELSE IF (CNM(1:3).EQ.'PLR'.OR. CNM(1:3).EQ.'plr') THEN
         RVL=REAL(IPLR)
      ELSE IF (CNM(1:3).EQ.'SST'.OR. CNM(1:3).EQ.'sst') THEN
         RVL=REAL(ISST)
      ELSE IF (CNM(1:3).EQ.'CLR'.OR.CNM(1:3).EQ.'clr') THEN
         RVL=REAL(ICLR(IPAI))
      ELSE IF (CNM(1:3).EQ.'TVL'.OR.CNM(1:3).EQ.'tvl') THEN
         RVL=TVLU(IPAI)
C
C ---------------------------------------------------------------------
C
C Values in STTRAN
C
      ELSE IF (CNM(1:3).EQ.'VPS'.OR. CNM(1:3).EQ.'vps') THEN
         RVL=REAL(UVPS)
      ELSE IF (CNM(1:3).EQ.'VPL'.OR.CNM(1:3).EQ.'vpl') THEN
         RVL=UVPL
      ELSE IF (CNM(1:3).EQ.'VPR'.OR.CNM(1:3).EQ.'vpr') THEN
         RVL=UVPR
      ELSE IF (CNM(1:3).EQ.'VPB'.OR.CNM(1:3).EQ.'vpb') THEN
         RVL=UVPB
      ELSE IF (CNM(1:3).EQ.'VPT'.OR.CNM(1:3).EQ.'vpt') THEN
         RVL=UVPT
      ELSE IF (CNM(1:3).EQ.'WDL'.OR.CNM(1:3).EQ.'wdl') THEN
         RVL=UWDL
      ELSE IF (CNM(1:3).EQ.'WDR'.OR.CNM(1:3).EQ.'wdr') THEN
         RVL=UWDR
      ELSE IF (CNM(1:3).EQ.'WDB'.OR.CNM(1:3).EQ.'wdb') THEN
         RVL=UWDB
      ELSE IF (CNM(1:3).EQ.'WDT'.OR.CNM(1:3).EQ.'wdt') THEN
         RVL=UWDT
      ELSE IF (CNM(1:3).EQ.'XC1'.OR.CNM(1:3).EQ.'xc1') THEN
         RVL=UXC1
      ELSE IF (CNM(1:3).EQ.'XCM'.OR.CNM(1:3).EQ.'xcm') THEN
         RVL=UXCM
      ELSE IF (CNM(1:3).EQ.'YC1'.OR.CNM(1:3).EQ.'yc1') THEN
         RVL=UYC1
      ELSE IF (CNM(1:3).EQ.'YCN'.OR.CNM(1:3).EQ.'ycn') THEN
         RVL=UYCN
C
C ---------------------------------------------------------------------
C
C Values in STSTRM
C
      ELSE IF (CNM(1:3).EQ.'SGD'.OR. CNM(1:3).EQ.'sgd') THEN
         RVL=REAL(ISGD)
      ELSE IF (CNM(1:3).EQ.'AGD'.OR. CNM(1:3).EQ.'agd') THEN
         RVL=REAL(IAGD)
      ELSE IF (CNM(1:3).EQ.'ARL'.OR. CNM(1:3).EQ.'arl') THEN
         RVL=RARL
      ELSE IF (CNM(1:3).EQ.'CKP'.OR. CNM(1:3).EQ.'ckp') THEN
         RVL=REAL(ICKP)
      ELSE IF (CNM(1:3).EQ.'CKX'.OR. CNM(1:3).EQ.'ckx') THEN
         RVL=REAL(ICKX)
      ELSE IF (CNM(1:3).EQ.'TRP'.OR. CNM(1:3).EQ.'trp') THEN
         RVL=REAL(ITRP)
      ELSE IF (CNM(1:3).EQ.'CYK'.OR. CNM(1:3).EQ.'cyk') THEN
         RVL=REAL(ICYK)
      ELSE IF (CNM(1:3).EQ.'VNL'.OR. CNM(1:3).EQ.'vnl') THEN
         RVL=RVNL
      ELSE IF (CNM(1:3).EQ.'SVF'.OR. CNM(1:3).EQ.'svf') THEN
         RVL=REAL(ISVF)
      ELSE IF (CNM(1:3).EQ.'USV'.OR. CNM(1:3).EQ.'usv') THEN
         RVL=RUSV
      ELSE IF (CNM(1:3).EQ.'VSV'.OR. CNM(1:3).EQ.'vsv') THEN
         RVL=RVSV
      ELSE IF (CNM(1:3).EQ.'PSV'.OR. CNM(1:3).EQ.'psv') THEN
         RVL=RPSV
      ELSE IF (CNM(1:3).EQ.'SPC'.OR. CNM(1:3).EQ.'spc') THEN
         RVL=REAL(ISPC)
      ELSE IF (CNM(1:3).EQ.'CDS'.OR. CNM(1:3).EQ.'cds') THEN
         RVL=RCDS
      ELSE IF (CNM(1:3).EQ.'SSP'.OR. CNM(1:3).EQ.'ssp') THEN
         RVL=RSSP
      ELSE IF (CNM(1:3).EQ.'DFM'.OR. CNM(1:3).EQ.'dfm') THEN
         RVL=RDFM
      ELSE IF (CNM(1:3).EQ.'SMD'.OR. CNM(1:3).EQ.'smd') THEN
         RVL=RSMD
      ELSE IF (CNM(1:3).EQ.'AMD'.OR. CNM(1:3).EQ.'amd') THEN
         RVL=RAMD
      ELSE IF (CNM(1:3).EQ.'GBS'.OR. CNM(1:3).EQ.'gbs') THEN
         RVL=REAL(IGBS)
      ELSE IF (CNM(1:3).EQ.'STM'.OR. CNM(1:3).EQ.'stm') THEN
         RVL=REAL(ISTM)
      ELSE IF (CNM(1:3).EQ.'VRL'.OR. CNM(1:3).EQ.'vrl') THEN
         RVL=REAL(RVRL)
      ELSE IF (CNM(1:3).EQ.'VFR'.OR. CNM(1:3).EQ.'vfr') THEN
         RVL=REAL(RVFR)
      ELSE IF (CNM(1:3).EQ.'VRM'.OR. CNM(1:3).EQ.'vrm') THEN
         RVL=REAL(RVRM)
      ELSE IF (CNM(1:3).EQ.'VPO'.OR. CNM(1:3).EQ.'vpo') THEN
         RVL=REAL(IVPO)
      ELSE IF (CNM(1:3).EQ.'AFR'.OR. CNM(1:3).EQ.'afr') THEN
         RVL=REAL(RAFR)
      ELSE IF (CNM(1:3).EQ.'DMX'.OR. CNM(1:3).EQ.'dmx') THEN
         RVL=REAL(RDMX)
      ELSE IF (CNM(1:3).EQ.'DMN'.OR. CNM(1:3).EQ.'dmn') THEN
         RVL=REAL(RDMN)
C
C ---------------------------------------------------------------------
C
C Values in STTXP
C
C character attributes
C
C
      ELSE IF (CNM(1:3).EQ.'ZFS'.OR.CNM(1:3).EQ.'zfs') THEN
         RVL=FZFS
      ELSE IF (CNM(1:3).EQ.'ZFX'.OR.CNM(1:3).EQ.'zfx') THEN
         RVL=FZFX
      ELSE IF (CNM(1:3).EQ.'ZFY'.OR.CNM(1:3).EQ.'zfy') THEN
         RVL=FZFY
      ELSE IF (CNM(1:3).EQ.'ZFP'.OR. CNM(1:3).EQ.'zfp') THEN
         RVL=REAL(IZFP)
      ELSE IF (CNM(1:3).EQ.'ZFC'.OR. CNM(1:3).EQ.'zfc') THEN
         RVL=REAL(IZFC)
C
C ---------------------------------------------------------------------
C
C Values in STMAP
C
      ELSE IF (CNM(1:3).EQ.'MAP'.OR. CNM(1:3).EQ.'map') THEN
         RVL=REAL(IMAP)
      ELSE IF (CNM(1:3).EQ.'TRT'.OR. CNM(1:3).EQ.'trt') THEN
         RVL=REAL(ITRT)
      ELSE IF (CNM(1:3).EQ.'VPL'.OR.CNM(1:3).EQ.'vpl') THEN
         RVL=XVPL
      ELSE IF (CNM(1:3).EQ.'VPR'.OR.CNM(1:3).EQ.'vpr') THEN
         RVL=XVPR
      ELSE IF (CNM(1:3).EQ.'VPB'.OR.CNM(1:3).EQ.'vpb') THEN
         RVL=YVPB
      ELSE IF (CNM(1:3).EQ.'VPT'.OR.CNM(1:3).EQ.'vpt') THEN
         RVL=YVPT
      ELSE IF (CNM(1:3).EQ.'XMN'.OR.CNM(1:3).EQ.'xmn') THEN
         RVL=WXMN
      ELSE IF (CNM(1:3).EQ.'XMX'.OR.CNM(1:3).EQ.'xmx') THEN
         RVL=WXMX
      ELSE IF (CNM(1:3).EQ.'YMN'.OR.CNM(1:3).EQ.'ymn') THEN
         RVL=WYMN
      ELSE IF (CNM(1:3).EQ.'YMX'.OR.CNM(1:3).EQ.'ymx') THEN
         RVL=WYMX
      ELSE IF (CNM(1:3).EQ.'XLV'.OR.CNM(1:3).EQ.'xlv') THEN
         RVL=XLOV
      ELSE IF (CNM(1:3).EQ.'XHV'.OR.CNM(1:3).EQ.'xhv') THEN
         RVL=XHIV
      ELSE IF (CNM(1:3).EQ.'YLV'.OR.CNM(1:3).EQ.'ylv') THEN
         RVL=YLOV
      ELSE IF (CNM(1:3).EQ.'YHV'.OR.CNM(1:3).EQ.'yhv') THEN
         RVL=YHIV
      ELSE IF (CNM(1:3).EQ.'NXC'.OR. CNM(1:3).EQ.'nxc') THEN
         RVL=REAL(NXCT)
      ELSE IF (CNM(1:3).EQ.'NYC'.OR. CNM(1:3).EQ.'nyc') THEN
         RVL=REAL(NYCT)
      ELSE IF (CNM(1:3).EQ.'LLG'.OR. CNM(1:3).EQ.'llg') THEN
         RVL=REAL(LNLG)
      ELSE IF (CNM(1:3).EQ.'IVX'.OR. CNM(1:3).EQ.'ivx') THEN
         RVL=REAL(INVX)
      ELSE IF (CNM(1:3).EQ.'IVY'.OR. CNM(1:3).EQ.'ivy') THEN
         RVL=REAL(INVY)
      ELSE IF (CNM(1:3).EQ.'RBG'.OR. CNM(1:3).EQ.'rbg') THEN
         RVL=REAL(RBIG)
      ELSE IF (CNM(1:3).EQ.'IBG'.OR. CNM(1:3).EQ.'ibg') THEN
         RVL=REAL(IBIG)
C
C ---------------------------------------------------------------------
C
      ELSE
         CSTR(1:46)='STGETI OR STGETR - PARAMETER NAME NOT KNOWN - '
         CSTR(47:49)=CNM(1:3)
         CALL SETER (CSTR(1:49),3,1)
         RETURN
      END IF
C
C Done.
C
      RETURN
C
      END

c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by UCAR                 .
c  .                                                             .
c  .       University Corporation for Atmospheric Research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                         SPHEREPACK                          .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c                            August 2003
c
c ... file shpe.f
c
c     this file contains code and documentation for subroutines
c     shpei and shpe.
c
c ... files which must be loaded with shpe.f
c
c     hrfft.f
c
c     subroutine shpei initializes arrays wshp and iwshp for
c     subsequent repeated use by subroutine shpe, which
c     performs the harmonic projection equivalent to a
c     harmonic analysis followed by harmonic synthesis
c     but faster and with less memory. (see description of
c     subroutine shpe below)
c
c     subroutine shpei(nlat,nlon,isym,mtrunc,wshp,lwshp,iwshp,
c    1 liwshp,work,lwork,ierror)
c
c     shpei initializes arrays wshp and iwshp for repeated use
c     by subroutine shpe ....
c
c     input parameters
c
c     nlat   the number of colatitudes on the full sphere including the
c            poles. for example, nlat = 37 for a five degree grid.
c            nlat determines the grid increment in colatitude as
c            pi/(nlat-1).  if nlat is odd the equator is located at
c            grid point i=(nlat+1)/2. if nlat is even the equator is
c            located half way between points i=nlat/2 and i=nlat/2+1.
c            nlat must be at least 3.
c
c     nlon   the number of distinct londitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater
c            than or equal to 4. the efficiency of the computation is
c            improved when nlon is a product of small prime numbers.
c            nlon must beat least 4.
c
c     isym   currently not used.
c
c     mtrunc the highest longitudinal wave number retained in the
c            projection. It must be less than or equal to
c            the minimum of nlat-1 and nlon/2. The first wave
c            number is zero. For example, if wave numbers 0 and
c            1 are desired then mtrunc = 1.
c
c     lwshp  the dimension of the array wshp as it appears in the
c            program that calls shpei. It must be at least
c            2*(nlat+1)**2+nlon+log2(nlon)
c
c     liwshp the dimension of the array iwshp as it appears in the
c            program that calls shpei. It must be at least
c            4*(nlat+1).
c
c     lwork  the dimension of the array work as it appears in the
c            program that calls shpei. It must be at least
c            1.25*(nlat+1)**2+7*nlat+8.
c
c     **************************************************************
c
c     output parameters
c
c     wshp   a single precision array that must be saved for
c            repeated use by subroutine shpe.
c
c     iwshp  an integer array that must be saved for repeated
c            use by subroutine shpe.
c
c     work   a double precision work array that does
c            not have to be saved.
c
c     ierror = 0  no errors
c            = 1  error in the specification of nlat
c            = 2  error in the specification of nlon
c            = 3  error in the specification of isym
c            = 4  error in the specification of mtrunc
c            = 5  error in the specification of lwshp
c            = 6  error in the specification of liwshp
c            = 7  error in the specification of lwork
c
      SUBROUTINE DSHPEI(NLAT,NLON,ISYM,MTRUNC,WSHP,LWSHP,IWSHP,LIWSHP,
     +                 WORK,LWORK,IERROR)
      DOUBLE PRECISION WSHP
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION WORK(*)
      DIMENSION WSHP(*),IWSHP(*)
c
      IERROR = 1
      IF (NLAT.LT.3) RETURN
      IERROR = 2
      IF (NLON.LT.4) RETURN
c      ierror = 3
c      if(isym.lt.0 .or. isym.gt.2) return
      IERROR = 4
      MMAX = MIN(NLAT-1,NLON/2)
      IF (MTRUNC.LT.0 .OR. MTRUNC.GT.MMAX) RETURN
      IERROR = 5
      LW1 = 2* (NLAT+1)**2
      LOG2N = LOG(DBLE(NLON))/LOG(2.0D0)
      IF (LWSHP.LT.LW1+NLON+LOG2N) RETURN
      IERROR = 6
      IF (LIWSHP.LT.4* (NLAT+1)) RETURN
      IERROR = 7
      MLWK = 1.25D0* (NLAT+1)**2 + 7*NLAT + 8
      IF (LWORK.LT.MLWK) RETURN
      IERROR = 0
c
      CALL DHRFFTI(NLON,WSHP(LW1+1))
c
      NTE = (NLAT+1)/2
      NLOC1 = 2*NTE*NTE
      NLOC2 = NLAT + 1
      IW1 = 1
      IW2 = IW1 + NLOC1
      IW3 = IW2 + NLOC1
      IW4 = IW3 + NLOC1
      JW1 = 1
      JW2 = JW1 + NLOC2
      JW3 = JW2 + NLOC2
      JW4 = JW3 + NLOC2
      KW1 = 1
      KW2 = KW1 + NTE
      KW3 = KW2 + NTE
      KW4 = KW3 + NTE
      KW5 = KW4 + NTE + 1
      KW6 = KW5 + NTE
      KW7 = KW6 + NTE
      KW8 = KW7 + NTE
      KW9 = KW8 + NTE
      KW10 = KW9 + NLOC2 + NLOC2
      KW11 = KW10 + NLOC2

      KW12 = KW11 + NLOC1
      KW13 = KW12 + NLOC1
c
      CALL DSHPEI1(NLAT,NLON,ISYM,MTRUNC,NTE,IERROR,WSHP(IW1),WSHP(IW2),
     +            WSHP(IW3),WSHP(IW4),IWSHP(JW1),IWSHP(JW2),IWSHP(JW3),
     +            IWSHP(JW4),WORK(KW1),WORK(KW2),WORK(KW3),WORK(KW4),
     +            WORK(KW5),WORK(KW6),WORK(KW7),WORK(KW8),WORK(KW9),
     +            WORK(KW10),WORK(KW11),WORK(KW12),WORK(KW11),
     +            WORK(KW12),WORK(KW13))
      RETURN
      END
      SUBROUTINE DSHPEI1(NLAT,NLON,ISYM,MTRUNC,IDP,IERROR,PE,PO,ZE,ZO,
     +                  IPSE,JZSE,IPSO,JZSO,CP,WORK,WX,S,E,THET,XX,Z,A,
     +                  B,WE,PED,WO,POD,U)
      DOUBLE PRECISION PE
      DOUBLE PRECISION PO
      DOUBLE PRECISION ZE
      DOUBLE PRECISION ZO
      DOUBLE PRECISION TUSL
      DOUBLE PRECISION TOE
      DOUBLE PRECISION DFN
      DOUBLE PRECISION RAND
C*PT*WARNING* Already double-precision
c
      DOUBLE PRECISION SUM,EPS,PI,DTHET,V,A1,B1,C1
C*PT*WARNING* Constant already double-precision
      PARAMETER (EPS=5.0d-8)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION CP(IDP),WORK(IDP),WX(IDP),S(IDP+1),E(IDP),
     +                 THET(IDP),XX(IDP),Z(IDP),U(IDP,IDP),
     +                 WE(IDP,IDP,2),PED(IDP,IDP,2),A(4*IDP),B(2*IDP),
     +                 WO(IDP,IDP,2),POD(IDP,IDP,2)
c
      DIMENSION PE(IDP,IDP,2),PO(IDP,IDP,2),ZE(IDP,IDP,2),ZO(IDP,IDP,2),
     +          IPSE(IDP,2),JZSE(IDP,2),IPSO(IDP,2),JZSO(IDP,2),NSHE(2),
     +          NSHO(2)
c
      NS2 = NLAT/2
      MODN = NLAT - NS2 - NS2
      NTE = (NLAT+1)/2
      NTO = NLAT - NTE
      TUSL = 0.D0
      TOE = 0.D0
C*PT*WARNING* Constant already double-precision
C*PT*WARNING* Constant already double-precision
c
c     compute grid distribution
c
      PI = 4.d0*DATAN(1.0d0)
      DTHET = PI/ (NLAT-1)
      DO I = 1,NTE
          THET(I) = (I-1)*DTHET
      END DO
c
c     compute weight matrices for even functions
c
      DO 40 MP1 = 1,2
          M = MP1 - 1
          MRANK = NLAT - M - M
          NEM = (MRANK+1)/2
          DO J = 1,NEM
              N = J + J + M - 2
              CALL DDLFKP(M,N,CP)
              DO I = 1,NTE
                  CALL DDLFTP(M,N,THET(I),CP,PED(I,J,MP1))
              END DO
C*PT*WARNING* Constant already double-precision
              IF (M.GT.0) PED(1,J,MP1) = 0.0d0
          END DO
          CALL DDSVDC(PED(M+1,1,MP1),IDP,NEM,NEM,S,E,U,IDP,V,IDP,WORK,
     +               10,INFO)
c
          DO J = 1,NEM
C*PT*WARNING* Constant already double-precision
              S(J) = 1.0d0/ (S(J)*S(J))
          END DO
c
c     compute weight matrix as u  s sup -2 u transpose
c
          DO J = 1,NTE
              DO I = 1,NTE
C*PT*WARNING* Constant already double-precision
                  WE(I,J,MP1) = 0.0d0
              END DO
          END DO
          DO I = 1,NEM
              DO J = 1,NEM
                  SUM = 0.D0
                  DO K = 1,NEM
                      SUM = SUM + S(K)*U(I,K)*U(J,K)
                  END DO
                  WE(I+M,J+M,MP1) = SUM
              END DO
          END DO
   40 CONTINUE
C*PT*WARNING* Constant already double-precision
      WE(1,1,2) = 1.0d0
c
c     compute n**2 basis (even functions)
c
      DO N = 1,NLAT + NLAT - 2
          DFN = N
C*PT*WARNING* Constant already double-precision
          A(N) = DSQRT(DFN* (DFN+1.0d0))
      END DO
      DO N = 1,NLAT - 1
          DFN = N
C*PT*WARNING* Constant already double-precision
C*PT*WARNING* Constant already double-precision
          B(N) = DSQRT((DFN+DFN+3.0d0)/ (DFN+DFN-1.0d0))
      END DO
c
      MXTR = MIN(NLAT-1,NLON/2,MTRUNC)
      IP = 2
      DO 200 MP1 = 1,MXTR + 1
          M = MP1 - 1
          IP = 3 - IP
          MS2 = MP1/2
          NRANK = MS2 + MS2
          MRANK = NLAT - NRANK
          NEM = (MRANK+1)/2
c
c     compute associated legendre functions
c
          IF (M.LE.1) THEN
              DO 205 J = 1,NEM
                  N = J + J + M - 2
                  CALL DDLFKP(M,N,CP)
                  DO I = 1,NTE
                      CALL DDLFTP(M,N,THET(I),CP,PED(I,J+MS2,IP))
                  END DO
C*PT*WARNING* Constant already double-precision
  202             IF (M.GT.0) PED(1,J+MS2,IP) = 0.0d0
  205         CONTINUE
c
          ELSE
c
              DO 207 J = 1,NEM
                  N = J + J + M - 2
                  IF (M.GT.1 .AND. N.GT.MXTR) THEN
                      DO I = 1,NTE
                          U(I,J+MS2) = PED(I,J+MS2,IP)
                      END DO
                      GO TO 207
                  END IF
                  A1 = B(N-1)*A(N+M-3)/A(N+M-1)
                  B1 = A(N-M+1)/A(N+M-1)
                  IF (N-M.LE.1) THEN
                      DO I = 1,NTE
                          U(I,J+MS2) = A1*PED(I,J+MS2-1,IP) -
     +                                 B1*PED(I,J+MS2,IP)
                      END DO
                  ELSE
                      C1 = B(N-1)*A(N-M-1)/A(N+M-1)
                      DO I = 1,NTE
                          U(I,J+MS2) = A1*PED(I,J+MS2-1,IP) -
     +                                 B1*PED(I,J+MS2,IP) +
     +                                 C1*U(I,J+MS2-1)
                      END DO
                  END IF
  207         CONTINUE
              DO J = 1,NEM
                  DO I = 1,NTE
                      PED(I,J+MS2,IP) = U(I,J+MS2)
                  END DO
              END DO
          END IF
c
          IF (MS2.LE.0 .OR. MS2.GE.NTE) GO TO 200
          DO I = 1,NTE
              XX(I) = RAND()
          END DO
          IT = 0
  201     DO I = 1,NTE
C*PT*WARNING* Constant already double-precision
              Z(I) = 0.0d0
C*PT*WARNING* Constant already double-precision
              WX(I) = 0.0d0
              DO J = 1,NTE
                  WX(I) = WX(I) + WE(I,J,IP)*XX(J)
              END DO
          END DO
          DO 220 J = 1,NTE
              IF (J.EQ.MS2) GO TO 220
              CALL DGS(NTE,WX,PED(1,J,IP),Z)
  220     CONTINUE
c
          DO I = 1,NTE
              XX(I) = XX(I) - Z(I)
          END DO
          CALL DNORMAL(NTE,XX,IDP,WE(1,1,IP))
          IT = IT + 1
          IF (IT.LE.2) GO TO 201
          DO I = 1,NTE
              PED(I,MS2,IP) = XX(I)
          END DO
  200 CONTINUE
c
c     reorder if mtrunc is less than nlat-1
c         case of even functions
c
      IF (MODN.EQ.0) THEN
          NSHE(1) = (NLAT-MTRUNC-1)/2
          NSHE(2) = (NLAT-MTRUNC-2)/2
      ELSE
          NSHE(1) = (NLAT-MTRUNC)/2
          NSHE(2) = (NLAT-MTRUNC-1)/2
      END IF
c
      DO 210 MP1 = 1,2
          DO J = 1,NTE
              JS = J + NSHE(MP1)
              IF (JS.GT.NTE) JS = JS - NTE
              DO I = 1,NTE
                  U(I,JS) = PED(I,J,MP1)
              END DO
          END DO
          DO J = 1,NTE
              DO I = 1,NTE
                  PED(I,J,MP1) = U(I,J)
              END DO
          END DO
  210 CONTINUE
c
      CALL DTRUNC(0,NTE,IDP,PED(1,1,1),NTE,IPSE(1,1))
      CALL DTRUNC(0,NTE,IDP,PED(1,1,2),NTE,IPSE(1,2))
c
c     compute the analysis matrices
c
      DO 250 IP = 1,2
          DO I = 1,NTE
              LOCK = 0
              DO J = 1,NTE
C*PT*WARNING* Constant already double-precision
                  SUM = 0.0d0
                  DO K = 1,NTE
                      SUM = SUM + PED(K,I,IP)*WE(K,J,IP)
                  END DO
                  PE(I,J,IP) = PED(I,J,IP)
                  ZE(J,I,IP) = SUM
                  IF (DABS(SUM).GT.EPS .AND. LOCK.EQ.0) THEN
                      LOCK = 1
                      JZSE(I,IP) = J
                  END IF
              END DO
          END DO
  250 CONTINUE
c
c     compute weight matrices for odd functions
c
      DO 50 MP1 = 1,2
          M = MP1 - 1
          MRANK = NLAT - M - M
          NEM = (MRANK+1)/2
          NOM = MRANK - NEM
          DO J = 1,NOM
              N = J + J + M - 1
              CALL DDLFKP(M,N,CP)
              DO I = 1,NTE
                  CALL DDLFTP(M,N,THET(I),CP,POD(I,J,MP1))
              END DO
C*PT*WARNING* Constant already double-precision
              IF (MODN.EQ.1) POD(NTE,J,MP1) = 0.0d0
          END DO
          CALL DDSVDC(POD(M+1,1,MP1),IDP,NOM,NOM,S,E,U,IDP,V,IDP,WORK,
     +                10,INFO)
c
          DO J = 1,NOM
C*PT*WARNING* Constant already double-precision
              S(J) = 1.0d0/ (S(J)*S(J))
          END DO
c
c     compute weight matrix as u  s sup -2 u transpose
c
          DO J = 1,NTE
              DO I = 1,NTE
C*PT*WARNING* Constant already double-precision
                  WO(I,J,MP1) = 0.0d0
              END DO
          END DO
          DO I = 1,NOM
              DO J = 1,NOM
                  SUM = 0.D0
                  DO K = 1,NOM
                      SUM = SUM + S(K)*U(I,K)*U(J,K)
                  END DO
                  WO(I+M,J+M,MP1) = SUM
              END DO
          END DO
   50 CONTINUE
C*PT*WARNING* Constant already double-precision
      WO(1,1,2) = 1.0d0
      IF (MODN.EQ.1) THEN
C*PT*WARNING* Constant already double-precision
          WO(NTE,NTE,1) = 1.0d0
C*PT*WARNING* Constant already double-precision
          WO(NTE,NTE,2) = 1.0d0
      END IF
c
c     compute n**2 basis (odd functions)
c
      IP = 2
      DO 300 MP1 = 1,MXTR + 1
          IP = 3 - IP
          M = MP1 - 1
          MS2 = MP1/2
          NRANK = MS2 + MS2
          MRANK = NLAT - NRANK
          NEM = (MRANK+1)/2
          NOM = MRANK - NEM
c
c     compute associated legendre functions
c
          IF (M.LE.1) THEN
              DO 305 J = 1,NOM
                  N = J + J + M - 1
                  CALL DDLFKP(M,N,CP)
                  DO I = 1,NTE
                      CALL DDLFTP(M,N,THET(I),CP,POD(I,J+MS2,IP))
                  END DO
C*PT*WARNING* Constant already double-precision
  302             IF (MODN.EQ.1) POD(NTE,J+MS2,IP) = 0.0d0
C*PT*WARNING* Constant already double-precision
                  IF (M.GT.0) POD(1,J+MS2,IP) = 0.0d0
  305         CONTINUE
c
          ELSE
c
              DO 307 J = 1,NOM
                  N = J + J + M - 1
                  IF (M.GT.1 .AND. N.GT.MXTR) THEN
                      DO I = 1,NTE
                          U(I,J+MS2) = POD(I,J+MS2,IP)
                      END DO
                      GO TO 304
                  END IF
                  A1 = B(N-1)*A(N+M-3)/A(N+M-1)
                  B1 = A(N-M+1)/A(N+M-1)
                  IF (N-M.LE.1) THEN
                      DO I = 1,NTE
                          U(I,J+MS2) = A1*POD(I,J+MS2-1,IP) -
     +                                 B1*POD(I,J+MS2,IP)
                      END DO
                  ELSE
                      C1 = B(N-1)*A(N-M-1)/A(N+M-1)
                      DO I = 1,NTE
                          U(I,J+MS2) = A1*POD(I,J+MS2-1,IP) -
     +                                 B1*POD(I,J+MS2,IP) +
     +                                 C1*U(I,J+MS2-1)
                      END DO
                  END IF
C*PT*WARNING* Constant already double-precision
  304             IF (MODN.EQ.1) U(NTE,J+MS2) = 0.0d0
  307         CONTINUE
              DO J = 1,NOM
                  DO I = 1,NTE
                      POD(I,J+MS2,IP) = U(I,J+MS2)
                  END DO
              END DO
          END IF
c
          IF (MS2.LE.0 .OR. MS2.GE.NTO) GO TO 300
          DO I = 1,NTE
              XX(I) = RAND()
          END DO
C*PT*WARNING* Constant already double-precision
          IF (MODN.EQ.1) XX(NTE) = 0.0d0
          IT = 0
  306     DO I = 1,NTE
              Z(I) = 0.D0
              WX(I) = 0.D0
              DO J = 1,NTO
                  WX(I) = WX(I) + WO(I,J,IP)*XX(J)
              END DO
          END DO
          DO 330 J = 1,NTO
              IF (J.EQ.MS2) GO TO 330
              CALL DGS(NTE,WX,POD(1,J,IP),Z(1))
  330     CONTINUE
c
          DO I = 1,NTE
              XX(I) = XX(I) - Z(I)
          END DO
          CALL DNORMAL(NTE,XX,IDP,WO(1,1,IP))
          IT = IT + 1
          IF (IT.LE.2) GO TO 306
          DO I = 1,NTE
              POD(I,MS2,IP) = XX(I)
          END DO
C*PT*WARNING* Constant already double-precision
          IF (MODN.EQ.1) POD(NTE,MS2,IP) = 0.0d0
  300 CONTINUE
c
c     reorder if mtrunc is less than nlat-1
c        case of odd functions
c
      IF (MODN.EQ.0) THEN
          NSHO(1) = (NLAT-MTRUNC)/2
          NSHO(2) = (NLAT-MTRUNC-1)/2
      ELSE
          NSHO(1) = (NLAT-MTRUNC-1)/2
          NSHO(2) = (NLAT-MTRUNC-2)/2
      END IF
c
      DO 310 MP1 = 1,2
          DO J = 1,NTO
              JS = J + NSHO(MP1)
              IF (JS.GT.NTO) JS = JS - NTO
              DO I = 1,NTE
                  U(I,JS) = POD(I,J,MP1)
              END DO
          END DO
          DO J = 1,NTO
              DO I = 1,NTE
                  POD(I,J,MP1) = U(I,J)
              END DO
          END DO
  310 CONTINUE
c
      CALL DTRUNC(0,NTE,IDP,POD(1,1,1),NTO,IPSO(1,1))
      CALL DTRUNC(0,NTE,IDP,POD(1,1,2),NTO,IPSO(1,2))
c
c     compute the analysis matrices (odd functions)
c
      DO IP = 1,2
          DO I = 1,NTO
              LOCK = 0
              DO J = 1,NTO
C*PT*WARNING* Constant already double-precision
                  SUM = 0.0d0
                  DO K = 1,NTE
                      SUM = SUM + POD(K,I,IP)*WO(K,J,IP)
                  END DO
                  PO(I,J,IP) = POD(I,J,IP)
                  ZO(J,I,IP) = SUM
                  IF (DABS(SUM).GT.EPS .AND. LOCK.EQ.0) THEN
                      LOCK = 1
                      JZSO(I,IP) = J
                  END IF
              END DO
          END DO
      END DO
      RETURN
      END
c
c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by UCAR                 .
c  .                                                             .
c  .       University Corporation for Atmospheric Research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                         SPHEREPACK3.0                       .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c ... file shpe.f
c
c ... files which must be loaded with shpe.f
c
c     sphcom.f, hrfft.f
c
c     the n**2 projection with complement, odd/even
c     factorization and zero truncation on an
c     equally spaced grid as defined in the JCP paper
c     "Generalized discrete spherical harmonic transforms"
c     by Paul N. Swarztrauber and William F. Spotz
c     It is equivalent to a harmonic analysis followed
c     by a synthesis except faster and requires less memory.
c
c     subroutine shpe(nlat,nlon,isym,mtrunc,x,y,idxy,
c    1        wshp,lwshp,iwshp,liwshp,work,lwork,ierror)
c
c     shpe projects the array x onto the set of functions represented
c     by a discrete set of spherical harmonics.
c
c     input parameters
c
c     nlat   the number of colatitudes on the full sphere including the
c            poles. for example, nlat = 37 for a five degree grid.
c            nlat determines the grid increment in colatitude as
c            pi/(nlat-1).  if nlat is odd the equator is located at
c            grid point i=(nlat+1)/2. if nlat is even the equator is
c            located half way between points i=nlat/2 and i=nlat/2+1.
c            nlat must be at least 3.
c
c     nlon   the number of distinct londitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater
c            than or equal to 4. the efficiency of the computation is
c            improved when nlon is a product of small prime numbers.
c            nlon must beat least 4.
c
c     isym   currently not used.
c
c     mtrunc the highest longitudinal wave number retained in the
c            projection. It must be less than or equal to
c            the minimum of nlat-1 and nlon/2. The first wave
c            number is zero. For example, if wave numbers 0 and
c            1 are desired then mtrunc = 1.

c            zero.
c
c     x      a two dimensional array that contains the the nlat
c            by nlon array x(i,j) defined at the colatitude point
c            theta(i) = (i-1)*pi/(nlat-1) and longitude point phi(j) =
c            (j-1)*2*pi/nlon.
c
c     idxy   the first dimension of the arrays x and y as they
c            appear in the program that calls shpe. It must be
c            at least nlat.
c
c     wshp   a single precision array that must be saved for
c            repeated use by subroutine shpe.
c
c     lwshp  the dimension of the array wshp as it appears in the
c            program that calls shpei. It must be at least
c            2*(nlat+1)**2+nlon+log2(nlon)
c
c     iwshp  an integer array that must be saved for repeated
c            use by subroutine shpe.
c
c
c     liwshp the dimension of the array iwshp as it appears in the
c            program that calls shpei. It must be at least
c            4*(nlat+1).
c
c     work   a single precision work array that does
c            not have to be saved.
c
c     lwork  the dimension of the array work as it appears in the
c            program that calls shpe. It must be at least
c            max(nlat*nlon,4*(nlat+1)).
c
c     **************************************************************
c
c     output parameters
c
c     y      an nlat by nlon single precision array that contains
c            the projection of x onto the set of functions that
c            can be represented by the discrete set of spherical
c            harmonics. The arrays x(i,j) and y(i,j) are located
c            at colatitude point theta(i) = (i-1)*pi/(nlat-1) and
c            longitude point phi(j) = (j-1)*2*pi/nlon.
c
c     ierror = 0  no errors
c            = 1  error in the specification of nlat
c            = 2  error in the specification of nlon
c            = 3  error in the specification of isym
c            = 4  error in the specification of mtrunc
c            = 5  error in the specification of lwshp
c            = 6  error in the specification of liwshp
c            = 7  error in the specification of lwork
c
      SUBROUTINE DSHPE(NLAT,NLON,ISYM,MTRUNC,X,Y,IDXY,WSHP,LWSHP,IWSHP,
     +                LIWSHP,WORK,LWORK,IERROR)
      DOUBLE PRECISION X
      DOUBLE PRECISION Y
      DOUBLE PRECISION WSHP
      DOUBLE PRECISION WORK
      DOUBLE PRECISION SN
c
      DIMENSION WSHP(*),IWSHP(*),WORK(*),X(IDXY,NLON),Y(IDXY,NLON)
c
      IERROR = 1
      IF (NLAT.LT.3) RETURN
      IERROR = 2
      IF (NLON.LT.4) RETURN
c      ierror = 3
c      if(isym.lt.0 .or. isym.gt.2) return
      IERROR = 4
      MMAX = MIN(NLAT-1,NLON/2)
      IF (MTRUNC.LT.0 .OR. MTRUNC.GT.MMAX) RETURN
      IERROR = 5
      LOG2N = LOG(DBLE(NLON))/LOG(2.0D0)
      LW1 = 2* (NLAT+1)**2
      IF (LWSHP.LT.LW1+NLON+LOG2N) RETURN
      IERROR = 6
      IF (LIWSHP.LT.4* (NLAT+1)) RETURN
      IERROR = 7
      MWRK = MAX(NLAT*NLON,4* (NLAT+1))
      IF (LWORK.LT.MWRK) RETURN
      IERROR = 0
c
      DO J = 1,NLON
          DO I = 1,NLAT
              Y(I,J) = X(I,J)
          END DO
      END DO
      CALL DHRFFTF(NLAT,NLON,Y,IDXY,WSHP(LW1+1),WORK)
c
      NTE = (NLAT+1)/2
      NLOC1 = 2*NTE*NTE
      NLOC2 = NLAT + 1
      IW1 = 1
      IW2 = IW1 + NLOC1
      IW3 = IW2 + NLOC1
      IW4 = IW3 + NLOC1
      JW1 = 1
      JW2 = JW1 + NLOC2
      JW3 = JW2 + NLOC2
      JW4 = JW3 + NLOC2
c
      CALL DSHPE1(NLAT,NLON,ISYM,MTRUNC,Y,Y,IDXY,IERROR,NTE,WSHP(IW1),
     +           WSHP(IW2),WSHP(IW3),WSHP(IW4),IWSHP(JW1),IWSHP(JW2),
     +           IWSHP(JW3),IWSHP(JW4),WORK(JW1),WORK(JW2),WORK(JW3),
     +           WORK(JW4))
c
      CALL DHRFFTB(NLAT,NLON,Y,IDXY,WSHP(LW1+1),WORK)
c
      SN = 1.0D0/NLON
      DO J = 1,NLON
          DO I = 1,NLAT
              Y(I,J) = SN*Y(I,J)
          END DO
      END DO
      RETURN
      END
      SUBROUTINE DSHPE1(NLAT,NLON,ISYM,MTRUNC,SX,SY,IDXY,IERROR,IDP,PE,
     +                 PO,ZE,ZO,IPSE,JZSE,IPSO,JZSO,XE,XO,YE,YO)
      DOUBLE PRECISION SX
      DOUBLE PRECISION SY
      DOUBLE PRECISION PE
      DOUBLE PRECISION PO
      DOUBLE PRECISION ZE
      DOUBLE PRECISION ZO
      DOUBLE PRECISION XE
      DOUBLE PRECISION XO
      DOUBLE PRECISION YE
      DOUBLE PRECISION YO
c
      DIMENSION SX(IDXY,NLON),SY(IDXY,NLON),NSHE(2),NSHO(2),
     +          PE(IDP,IDP,2),PO(IDP,IDP,2),ZE(IDP,IDP,2),ZO(IDP,IDP,2),
     +          IPSE(IDP,2),JZSE(IDP,2),IPSO(IDP,2),JZSO(IDP,2),
     +          XE(IDP,2),XO(IDP,2),YE(IDP,2),YO(IDP,2)
c
      NS2 = NLAT/2
      MODN = NLAT - NS2 - NS2
      NTE = (NLAT+1)/2
      NTO = NLAT - NTE
c
      IF (MODN.EQ.0) THEN
          NSHE(1) = (NLAT-MTRUNC-1)/2
          NSHE(2) = (NLAT-MTRUNC-2)/2
          NSHO(1) = (NLAT-MTRUNC)/2
          NSHO(2) = (NLAT-MTRUNC-1)/2
      ELSE
          NSHE(1) = (NLAT-MTRUNC)/2
          NSHE(2) = (NLAT-MTRUNC-1)/2
          NSHO(1) = (NLAT-MTRUNC-1)/2
          NSHO(2) = (NLAT-MTRUNC-2)/2
      END IF
      MXTR = MIN(NLAT-1,NLON/2,MTRUNC)
      IP = 2
      DO 100 MP1 = 1,MXTR + 1
          IP = 3 - IP
          IF (MXTR.EQ.NLAT-1 .AND. MP1.LE.2) THEN
              DO I = 1,NLAT
                  SY(I,MP1) = SX(I,MP1)
              END DO
              IF (MP1.EQ.2) THEN
                  SY(1,2) = 0.D0
                  SY(NLAT,2) = 0.D0
              END IF
              IF (NLON.GE.3) THEN
                  SY(1,3) = 0.D0
                  SY(NLAT,3) = 0.D0
                  DO I = 2,NLAT - 1
                      SY(I,3) = SX(I,3)
                  END DO
              END IF
              GO TO 100
          END IF
          M = MP1 - 1
          MPM = MAX(1,M+M)
          MS2 = MP1/2
          MRANK = MIN(NLAT-M,NLAT-MS2-MS2)
c      mrank = mxtr+1-ms2-ms2
          NRANK = NLAT - MRANK
          NEM = (MRANK+1)/2 - NSHE(IP)
          NOM = MRANK - (MRANK+1)/2 - NSHO(IP)
          NEC = NTE - NEM
          NOC = NTO - NOM
c
          DO I = 1,NTE
              XE(I,1) = .5D0* (SX(I,MPM)+SX(NLAT+1-I,MPM))
              XO(I,1) = .5D0* (SX(I,MPM)-SX(NLAT+1-I,MPM))
          END DO
          IF (MPM.LT.NLON) THEN
              DO I = 1,NTE
                  XE(I,2) = .5D0* (SX(I,MPM+1)+SX(NLAT+1-I,MPM+1))
                  XO(I,2) = .5D0* (SX(I,MPM+1)-SX(NLAT+1-I,MPM+1))
              END DO
          END IF
          IF (3*NEC.LT.2*NEM .OR. NEM.EQ.0) THEN
              CALL DTMXMX(NTE,NEC,IDP,PE(1,1,IP),NTE,IDP,ZE(1,1,IP),XE,
     +                   YE,IPSE(1,IP),JZSE(1,IP))
              DO I = 1,NTE
                  YE(I,1) = XE(I,1) - YE(I,1)
              END DO
              IF (MPM.LT.NLON .AND. M.NE.0) THEN
                  DO I = 1,NTE
                      YE(I,2) = XE(I,2) - YE(I,2)
                  END DO
              END IF
          ELSE
              CALL DTMXMX(NTE,NEM,IDP,PE(1,NEC+1,IP),NTE,IDP,
     +                   ZE(1,NEC+1,IP),XE,YE,IPSE(NEC+1,IP),
     +                   JZSE(NEC+1,IP))
          END IF
          IF (3*NOC.LT.2*NOM .OR. NOM.EQ.0) THEN
              CALL DTMXMX(NTO,NOC,IDP,PO(1,1,IP),NTO,IDP,ZO(1,1,IP),XO,
     +                   YO,IPSO(1,IP),JZSO(1,IP))
              DO I = 1,NTE
                  YO(I,1) = XO(I,1) - YO(I,1)
              END DO
              IF (MPM.LT.NLON .AND. M.NE.0) THEN
                  DO I = 1,NTE
                      YO(I,2) = XO(I,2) - YO(I,2)
                  END DO
              END IF
          ELSE
              CALL DTMXMX(NTO,NOM,IDP,PO(1,NOC+1,IP),NTO,IDP,
     +                   ZO(1,NOC+1,IP),XO,YO,IPSO(NOC+1,IP),
     +                   JZSO(NOC+1,IP))
          END IF
          DO I = 1,NTE
              SY(I,MPM) = YE(I,1) + YO(I,1)
              SY(NLAT+1-I,MPM) = YE(I,1) - YO(I,1)
          END DO
          IF (MPM.LT.NLON .AND. M.NE.0) THEN
              DO I = 1,NTE
                  SY(I,MPM+1) = YE(I,2) + YO(I,2)
                  SY(NLAT+1-I,MPM+1) = YE(I,2) - YO(I,2)
              END DO
          END IF
  100 CONTINUE
      JS = MXTR + MXTR + 2
      DO J = JS,NLON
          DO I = 1,NLAT
              SY(I,J) = 0.D0
          END DO
      END DO
      RETURN
      END
      SUBROUTINE DMXM(LR,LC,LD,A,MC,MD,B,ND,C)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION A(LD,*),B(MD,*),C(ND,*)

      DO I = 1,LR
          DO J = 1,MC
              C(I,J) = 0.D0
              DO K = 1,LC
                  C(I,J) = C(I,J) + A(I,K)*B(K,J)
              END DO
          END DO
      END DO
      RETURN
      END
      SUBROUTINE DSMXM(LR,LC,LD,A,MC,MD,B,ND,C)
      DOUBLE PRECISION A
      DOUBLE PRECISION B
      DOUBLE PRECISION C
      DIMENSION A(LD,*),B(MD,*),C(ND,*)

      DO I = 1,LR
          DO J = 1,MC
              C(I,J) = 0.D0
              DO K = 1,LC
                  C(I,J) = C(I,J) + A(I,K)*B(K,J)
              END DO
          END DO
      END DO
      RETURN
      END
      SUBROUTINE DMXMX(LR,LC,LD,A,MC,MD,B,X,Y)
      DOUBLE PRECISION A
      DOUBLE PRECISION B
      DOUBLE PRECISION X
      DOUBLE PRECISION Y
      DOUBLE PRECISION SUM1
      DOUBLE PRECISION SUM2
      DIMENSION A(LD,*),B(MD,*),X(LD,2),Y(LD,2)

      DO K = 1,LR
          Y(K,1) = 0.D0
          Y(K,2) = 0.D0
      END DO
c
      IF (LC.LE.0) RETURN
      DO I = 1,LC
          SUM1 = 0.D0
          SUM2 = 0.D0
          DO J = 1,MC
              SUM1 = SUM1 + B(I,J)*X(J,1)
              SUM2 = SUM2 + B(I,J)*X(J,2)
          END DO
          DO K = 1,LR
              Y(K,1) = Y(K,1) + SUM1*A(K,I)
              Y(K,2) = Y(K,2) + SUM2*A(K,I)
          END DO
      END DO
      RETURN
      END
      SUBROUTINE DDMXMX(LR,LC,LD,A,MC,MD,B,X,Y)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION A(LD,*),B(MD,*),X(LD,2),Y(LD,2),SUM1,SUM2

      DO K = 1,LR
          Y(K,1) = 0.D0
          Y(K,2) = 0.D0
      END DO
c
      IF (LC.LE.0) RETURN
      DO I = 1,LC
          SUM1 = 0.D0
          SUM2 = 0.D0
          DO J = 1,MC
              SUM1 = SUM1 + B(I,J)*X(J,1)
              SUM2 = SUM2 + B(I,J)*X(J,2)
          END DO
          DO K = 1,LR
              Y(K,1) = Y(K,1) + SUM1*A(K,I)
              Y(K,2) = Y(K,2) + SUM2*A(K,I)
          END DO
      END DO
      RETURN
      END
      SUBROUTINE DTMXMX(LR,LC,LD,A,MC,MD,B,X,Y,IS,JS)
      DOUBLE PRECISION A
      DOUBLE PRECISION B
      DOUBLE PRECISION X
      DOUBLE PRECISION Y
      DOUBLE PRECISION SUM1
      DOUBLE PRECISION SUM2
      DIMENSION A(LD,*),B(MD,*),X(LD,2),Y(LD,2),IS(*),JS(*)
c
      KMX = MIN(LR+1,LD)
      DO K = 1,KMX
          Y(K,1) = 0.D0
          Y(K,2) = 0.D0
      END DO
      IF (LC.LE.0) RETURN
c
      DO I = 1,LC
          SUM1 = 0.D0
          SUM2 = 0.D0
          DO J = JS(I),MC
              SUM1 = SUM1 + B(J,I)*X(J,1)
              SUM2 = SUM2 + B(J,I)*X(J,2)
          END DO
          DO K = IS(I),LR
              Y(K,1) = Y(K,1) + SUM1*A(K,I)
              Y(K,2) = Y(K,2) + SUM2*A(K,I)
          END DO
      END DO
      RETURN
      END
      SUBROUTINE DTRUNC(IRC,N,IDP,A,NRC,IJS)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION A,EPS
C*PT*WARNING* Constant already double-precision
      PARAMETER (EPS=5.d-8)
      DIMENSION A(IDP,*),IJS(N)
c
c     irc = 0 for columns , or irc = 1 for rows
c
      IF (IRC.NE.0) GO TO 30
      DO 20 J = 1,NRC
          DO I = 1,N
              IJS(J) = I
              IF (DABS(A(I,J)).GT.EPS) GO TO 20
          END DO
   20 CONTINUE
      RETURN
   30 DO 50 I = 1,NRC
          DO J = 1,N
              IJS(I) = J
              IF (ABS(A(I,J)).GT.EPS) GO TO 50
          END DO
   50 CONTINUE
      RETURN
      END
      SUBROUTINE DGS(N,X,Y,Z)
      DIMENSION X(N),Y(N),Z(N)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION X,Y,Z,SUM
c
c     accumulate innerproducts of x with respect to y.
c
      SUM = 0.D0
      DO I = 1,N
          SUM = SUM + X(I)*Y(I)
      END DO
      DO I = 1,N
          Z(I) = Z(I) + SUM*Y(I)
      END DO
      RETURN
      END
      SUBROUTINE DNORMAL(N,X,ID,Q)
      DIMENSION X(N),Q(ID,N)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION X,Q,SUM,SQS
c
c     normalize x
c
      SQS = 0.D0
      DO I = 1,N
          SUM = 0.D0
          DO J = 1,N
              SUM = SUM + Q(I,J)*X(J)
          END DO
          SQS = SQS + SUM*X(I)
      END DO
c
      SQS = DSQRT(SQS)
      DO I = 1,N
          X(I) = X(I)/SQS
      END DO
      RETURN
      END
      SUBROUTINE DCOE(MOE,N,X,DMAX)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION X(N),DMAX

      NH = (N+1)/2
      DMAX = 0.D0
      IF (MOE.NE.0) GO TO 1
      DO I = 1,NH
          DMAX = MAX(DMAX,DABS(X(I)-X(N-I+1)))
          X(I) = .5D0* (X(I)+X(N-I+1))
          X(N-I+1) = X(I)
      END DO
      RETURN
    1 DO I = 1,NH
          DMAX = MAX(DMAX,DABS(X(I)+X(N-I+1)))
          X(I) = .5D0* (X(I)-X(N-I+1))
          X(N-I+1) = -X(I)
      END DO
      IF (MOD(N,2).NE.0) X(NH) = 0.D0
      RETURN
      END
c     subroutine dlfkp(m,n,cp)
c
c     subroutine dlfkp computes the coefficients in the trigonometric
c     expansion of the normalized associated legendre functions:
c
c     pbar(m,n,theta) = sqrt((2*n+1)*factorial(n-m)/(2*factorial(n+m)))
c                        *sin(theta)**m/(2**n*factorial(n)) times the
c                        (n+m)th derivative of (x**2-1)**n with respect
c                        to x=cos(theta)
c
c     where theta is colatitude.
c
c     subroutine dlfkp computes the coefficients cp(k) in the
c     following trigonometric expansion of pbar(m,n,theta).
c
c            1) for n even and m even, pbar(m,n,theta) =
c               .5*cp(1) plus the sum from k=1 to k=n/2
c               of cp(k)*cos(2*k*th)
c
c            2) for n even and m odd, pbar(m,n,theta) =
c               the sum from k=1 to k=n/2 of
c               cp(k)*sin(2*k*th)
c
c            3) for n odd and m even, pbar(m,n,theta) =
c               the sum from k=1 to k=(n+1)/2 of
c               cp(k)*cos((2*k-1)*th)
c
c            4) for n odd and m odd,  pbar(m,n,theta) =
c               the sum from k=1 to k=(n+1)/2 of
c               cp(k)*sin((2*k-1)*th)
c
c     input parameters
c
c     m      is the order of pbar(n,m,theta). m can be any integer
c            however pbar(n,m,theta) = 0  if abs(m) is greater than
c            n and pbar(n,m,theta) = (-1)**m*pbar(n,-m,theta) for
c            negative m.
c
c     n      nonnegative integer specifying the degree of
c            pbar(n,m,theta)
c
c     output parameters
c
c     cp     a double precision array that contains the fourier
c            coefficients for pbar(m,n,theta). the length of the
c            array depends on the parity of m and n
c
c                  parity            length of cp
c
c               n even m even           n/2+1
c               n even m odd             n/2
c               n odd  m even          (n+1)/2
c               n odd  m odd           (n+1)/2
c
c
c ****************************************************************
      SUBROUTINE DDLFKP(M,N,CP)
C*PT*WARNING* Already double-precision
c
      DOUBLE PRECISION CP,FNUM,FDEN,FNMH,A1,B1,C1,CP2,FNNP1,FNMSQ,FK,T1,
     +                 T2,PM1,SC10,SC20,SC40
      DIMENSION CP(1)
C*PT*WARNING* Constant already double-precision
      PARAMETER (SC10=1024.d0)
      PARAMETER (SC20=SC10*SC10)
      PARAMETER (SC40=SC20*SC20)
c
      CP(1) = 0.D0
      MA = IABS(M)
      IF (MA.GT.N) RETURN
      IF (N-1) 2,3,5
C*PT*WARNING* Constant already double-precision
    2 CP(1) = DSQRT(2.d0)
      RETURN
    3 IF (MA.NE.0) GO TO 4
C*PT*WARNING* Constant already double-precision
      CP(1) = DSQRT(1.5d0)
      RETURN
C*PT*WARNING* Constant already double-precision
    4 CP(1) = DSQRT(.75d0)
      IF (M.EQ.-1) CP(1) = -CP(1)
      RETURN
    5 IF (MOD(N+MA,2).NE.0) GO TO 10
      NMMS2 = (N-MA)/2
      FNUM = N + MA + 1
      FNMH = N - MA + 1
C*PT*WARNING* Constant already double-precision
      PM1 = 1.d0
      GO TO 15
   10 NMMS2 = (N-MA-1)/2
      FNUM = N + MA + 2
      FNMH = N - MA + 2
C*PT*WARNING* Constant already double-precision
      PM1 = -1.d0
C*PT*WARNING* Constant already double-precision
c      t1 = 1.
c      t1 = 2.d0**(n-1)
c      t1 = 1.d0/t1
   15 T1 = 1.d0/SC20
      NEX = 20
C*PT*WARNING* Constant already double-precision
      FDEN = 2.d0
      IF (NMMS2.LT.1) GO TO 20
      DO 18 I = 1,NMMS2
          T1 = FNUM*T1/FDEN
          IF (T1.GT.SC20) THEN
              T1 = T1/SC40
              NEX = NEX + 40
          END IF
          FNUM = FNUM + 2.D0
          FDEN = FDEN + 2.D0
   18 CONTINUE
C*PT*WARNING* Constant already double-precision
   20 T1 = T1/2.d0** (N-1-NEX)
      IF (MOD(MA/2,2).NE.0) T1 = -T1
      T2 = 1.D0
      IF (MA.EQ.0) GO TO 26
      DO 25 I = 1,MA
          T2 = FNMH*T2/ (FNMH+PM1)
          FNMH = FNMH + 2.D0
   25 CONTINUE
C*PT*WARNING* Constant already double-precision
   26 CP2 = T1*DSQRT((N+.5d0)*T2)
      FNNP1 = N* (N+1)
C*PT*WARNING* Constant already double-precision
      FNMSQ = FNNP1 - 2.d0*MA*MA
      L = (N+1)/2
      IF (MOD(N,2).EQ.0 .AND. MOD(MA,2).EQ.0) L = L + 1
      CP(L) = CP2
      IF (M.GE.0) GO TO 29
      IF (MOD(MA,2).NE.0) CP(L) = -CP(L)
   29 IF (L.LE.1) RETURN
      FK = N
      A1 = (FK-2.D0)* (FK-1.D0) - FNNP1
      B1 = 2.D0* (FK*FK-FNMSQ)
      CP(L-1) = B1*CP(L)/A1
   30 L = L - 1
      IF (L.LE.1) RETURN
      FK = FK - 2.D0
      A1 = (FK-2.D0)* (FK-1.D0) - FNNP1
      B1 = -2.D0* (FK*FK-FNMSQ)
      C1 = (FK+1.D0)* (FK+2.D0) - FNNP1
      CP(L-1) = - (B1*CP(L)+C1*CP(L+1))/A1
      GO TO 30
      END
      SUBROUTINE DDLFTP(M,N,THETA,CP,PB)
      DIMENSION CP(1)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION CP,PB,THETA,CDT,SDT,CTH,STH,CHH

      CDT = DCOS(THETA+THETA)
      SDT = DSIN(THETA+THETA)
      NMOD = MOD(N,2)
      MMOD = MOD(ABS(M),2)
      IF (NMOD) 1,1,2
    1 IF (MMOD) 3,3,4
c
c     n even, m even
c
    3 KDO = N/2
      PB = .5D0*CP(1)
      IF (N.EQ.0) RETURN
      CTH = CDT
      STH = SDT
      DO 170 K = 1,KDO
c     pb = pb+cp(k+1)*dcos(2*k*theta)
          PB = PB + CP(K+1)*CTH
          CHH = CDT*CTH - SDT*STH
          STH = SDT*CTH + CDT*STH
          CTH = CHH
  170 CONTINUE
      RETURN
c
c     n even, m odd
c
    4 KDO = N/2
      PB = 0.D0
      CTH = CDT
      STH = SDT
      DO 180 K = 1,KDO
c     pb = pb+cp(k)*dsin(2*k*theta)
          PB = PB + CP(K)*STH
          CHH = CDT*CTH - SDT*STH
          STH = SDT*CTH + CDT*STH
          CTH = CHH
  180 CONTINUE
      RETURN
    2 IF (MMOD) 13,13,14
c
c     n odd, m even
c
   13 KDO = (N+1)/2
      PB = 0.D0
      CTH = DCOS(THETA)
      STH = DSIN(THETA)
      DO 190 K = 1,KDO
c     pb = pb+cp(k)*dcos((2*k-1)*theta)
          PB = PB + CP(K)*CTH
          CHH = CDT*CTH - SDT*STH
          STH = SDT*CTH + CDT*STH
          CTH = CHH
  190 CONTINUE
      RETURN
c
c     n odd, m odd
c
   14 KDO = (N+1)/2
      PB = 0.D0
      CTH = DCOS(THETA)
      STH = DSIN(THETA)
      DO 200 K = 1,KDO
c     pb = pb+cp(k)*dsin((2*k-1)*theta)
          PB = PB + CP(K)*STH
          CHH = CDT*CTH - SDT*STH
          STH = SDT*CTH + CDT*STH
          CTH = CHH
  200 CONTINUE
      RETURN
      END
c
      SUBROUTINE DDSVDC(X,LDX,N,P,S,E,U,LDU,V,LDV,WORK,JOB,INFO)
      INTEGER LDX,N,P,LDU,LDV,JOB,INFO
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION X(LDX,1),S(1),E(1),U(LDU,1),V(LDV,1),WORK(1)
c
c
c     dsvdc is a subroutine to reduce a double precision nxp matrix x
c     by orthogonal transformations u and v to diagonal form.  the
c     diagonal elements s(i) are the singular values of x.  the
c     columns of u are the corresponding left singular vectors,
c     and the columns of v the right singular vectors.
c
c     on entry
c
c         x         double precision(ldx,p), where ldx.ge.n.
c                   x contains the matrix whose singular value
c                   decomposition is to be computed.  x is
c                   destroyed by dsvdc.
c
c         ldx       integer.
c                   ldx is the leading dimension of the array x.
c
c         n         integer.
c                   n is the number of rows of the matrix x.
c
c         p         integer.
c                   p is the number of columns of the matrix x.
c
c         ldu       integer.
c                   ldu is the leading dimension of the array u.
c                   (see below).
c
c         ldv       integer.
c                   ldv is the leading dimension of the array v.
c                   (see below).
c
c         work      double precision(n).
c                   work is a scratch array.
c
c         job       integer.
c                   job controls the computation of the singular
c                   vectors.  it has the decimal expansion ab
c                   with the following meaning
c
c                        a.eq.0    do not compute the left singular
c                                  vectors.
c                        a.eq.1    return the n left singular vectors
c                                  in u.
c                        a.ge.2    return the first min(n,p) singular
c                                  vectors in u.
c                        b.eq.0    do not compute the right singular
c                                  vectors.
c                        b.eq.1    return the right singular vectors
c                                  in v.
c
c     on return
c
c         s         double precision(mm), where mm=min(n+1,p).
c                   the first min(n,p) entries of s contain the
c                   singular values of x arranged in descending
c                   order of magnitude.
c
c         e         double precision(p),
c                   e ordinarily contains zeros.  however see the
c                   discussion of info for exceptions.
c
c         u         double precision(ldu,k), where ldu.ge.n.  if
c                                   joba.eq.1 then k.eq.n, if joba.ge.2
c                                   then k.eq.min(n,p).
c                   u contains the matrix of left singular vectors.
c                   u is not referenced if joba.eq.0.  if n.le.p
c                   or if joba.eq.2, then u may be identified with x
c                   in the subroutine call.
c
c         v         double precision(ldv,p), where ldv.ge.p.
c                   v contains the matrix of right singular vectors.
c                   v is not referenced if job.eq.0.  if p.le.n,
c                   then v may be identified with x in the
c                   subroutine call.
c
c         info      integer.
c                   the singular values (and their corresponding
c                   singular vectors) s(info+1),s(info+2),...,s(m)
c                   are correct (here m=min(n,p)).  thus if
c                   info.eq.0, all the singular values and their
c                   vectors are correct.  in any event, the matrix
c                   b = trans(u)*x*v is the bidiagonal matrix
c                   with the elements of s on its diagonal and the
c                   elements of e on its super-diagonal (trans(u)
c                   is the transpose of u).  thus the singular
c                   values of x and b are the same.
c
c     linpack. this version dated 08/14/78 .
c              correction made to shift 2/84.
c     g.w. stewart, university of maryland, argonne national lab.
c
c     dsvdc uses the following functions and subprograms.
c
c     external drot
c     blas daxpy,dddot,dscal,dswap,ddnrm2,drotg
c     fortran dabs,dmax1,max0,min0,mod,dsqrt
c
c     internal variables
c
      INTEGER I,ITER,J,JOBU,K,KASE,KK,L,LL,LLS,LM1,LP1,LS,LU,M,MAXIT,MM,
     +        MM1,MP1,NCT,NCTP1,NCU,NRT,NRTP1
C*PT*WARNING* Already double-precision
c      double precision dddot,t,r
      DOUBLE PRECISION DDDOT,T
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION B,C,CS,EL,EMM1,F,G,DDNRM2,SCALE,SHIFT,SL,SM,SN,
     +                 SMM1,T1,TEST,ZTEST
      LOGICAL WANTU,WANTV
c
c
c     set the maximum number of iterations.
c
      MAXIT = 30
c
c     determine what is to be computed.
c
      WANTU = .false.
      WANTV = .false.
      JOBU = MOD(JOB,100)/10
      NCU = N
      IF (JOBU.GT.1) NCU = MIN0(N,P)
      IF (JOBU.NE.0) WANTU = .true.
      IF (MOD(JOB,10).NE.0) WANTV = .true.
c
c     reduce x to bidiagonal form, storing the diagonal elements
c     in s and the super-diagonal elements in e.
c
      INFO = 0
      NCT = MIN0(N-1,P)
      NRT = MAX0(0,MIN0(P-2,N))
      LU = MAX0(NCT,NRT)
      IF (LU.LT.1) GO TO 170
      DO 160 L = 1,LU
          LP1 = L + 1
          IF (L.GT.NCT) GO TO 20
c
c           compute the transformation for the l-th column and
c           place the l-th diagonal in s(l).
c
          S(L) = DDNRM2(N-L+1,X(L,L),1)
C*PT*WARNING* Constant already double-precision
          IF (S(L).EQ.0.0d0) GO TO 10
C*PT*WARNING* Constant already double-precision
          IF (X(L,L).NE.0.0d0) S(L) = DSIGN(S(L),X(L,L))
C*PT*WARNING* Constant already double-precision
          CALL DDSCAL(N-L+1,1.0d0/S(L),X(L,L),1)
C*PT*WARNING* Constant already double-precision
          X(L,L) = 1.0d0 + X(L,L)
   10     CONTINUE
          S(L) = -S(L)
   20     CONTINUE
          IF (P.LT.LP1) GO TO 50
          DO 40 J = LP1,P
              IF (L.GT.NCT) GO TO 30
C*PT*WARNING* Constant already double-precision
              IF (S(L).EQ.0.0d0) GO TO 30
c
c              apply the transformation.
c
              T = -DDDOT(N-L+1,X(L,L),1,X(L,J),1)/X(L,L)
              CALL DDAXPY(N-L+1,T,X(L,L),1,X(L,J),1)
   30         CONTINUE
c
c           place the l-th row of x into  e for the
c           subsequent calculation of the row transformation.
c
              E(J) = X(L,J)
   40     CONTINUE
   50     CONTINUE
          IF (.NOT.WANTU .OR. L.GT.NCT) GO TO 70
c
c           place the transformation in u for subsequent back
c           multiplication.
c
          DO 60 I = L,N
              U(I,L) = X(I,L)
   60     CONTINUE
   70     CONTINUE
          IF (L.GT.NRT) GO TO 150
c
c           compute the l-th row transformation and place the
c           l-th super-diagonal in e(l).
c
          E(L) = DDNRM2(P-L,E(LP1),1)
C*PT*WARNING* Constant already double-precision
          IF (E(L).EQ.0.0d0) GO TO 80
C*PT*WARNING* Constant already double-precision
          IF (E(LP1).NE.0.0d0) E(L) = DSIGN(E(L),E(LP1))
C*PT*WARNING* Constant already double-precision
          CALL DDSCAL(P-L,1.0d0/E(L),E(LP1),1)
C*PT*WARNING* Constant already double-precision
          E(LP1) = 1.0d0 + E(LP1)
   80     CONTINUE
          E(L) = -E(L)
C*PT*WARNING* Constant already double-precision
          IF (LP1.GT.N .OR. E(L).EQ.0.0d0) GO TO 120
c
c              apply the transformation.
c
          DO 90 I = LP1,N
C*PT*WARNING* Constant already double-precision
              WORK(I) = 0.0d0
   90     CONTINUE
          DO 100 J = LP1,P
              CALL DDAXPY(N-L,E(J),X(LP1,J),1,WORK(LP1),1)
  100     CONTINUE
          DO 110 J = LP1,P
              CALL DDAXPY(N-L,-E(J)/E(LP1),WORK(LP1),1,X(LP1,J),1)
  110     CONTINUE
  120     CONTINUE
          IF (.NOT.WANTV) GO TO 140
c
c              place the transformation in v for subsequent
c              back multiplication.
c
          DO 130 I = LP1,P
              V(I,L) = E(I)
  130     CONTINUE
  140     CONTINUE
  150     CONTINUE
  160 CONTINUE
  170 CONTINUE
c
c     set up the final bidiagonal matrix or order m.
c
      M = MIN0(P,N+1)
      NCTP1 = NCT + 1
      NRTP1 = NRT + 1
      IF (NCT.LT.P) S(NCTP1) = X(NCTP1,NCTP1)
C*PT*WARNING* Constant already double-precision
      IF (N.LT.M) S(M) = 0.0d0
      IF (NRTP1.LT.M) E(NRTP1) = X(NRTP1,M)
C*PT*WARNING* Constant already double-precision
      E(M) = 0.0d0
c
c     if required, generate u.
c
      IF (.NOT.WANTU) GO TO 300
      IF (NCU.LT.NCTP1) GO TO 200
      DO 190 J = NCTP1,NCU
          DO 180 I = 1,N
C*PT*WARNING* Constant already double-precision
              U(I,J) = 0.0d0
  180     CONTINUE
C*PT*WARNING* Constant already double-precision
          U(J,J) = 1.0d0
  190 CONTINUE
  200 CONTINUE
      IF (NCT.LT.1) GO TO 290
      DO 280 LL = 1,NCT
          L = NCT - LL + 1
C*PT*WARNING* Constant already double-precision
          IF (S(L).EQ.0.0d0) GO TO 250
          LP1 = L + 1
          IF (NCU.LT.LP1) GO TO 220
          DO 210 J = LP1,NCU
              T = -DDDOT(N-L+1,U(L,L),1,U(L,J),1)/U(L,L)
              CALL DDAXPY(N-L+1,T,U(L,L),1,U(L,J),1)
  210     CONTINUE
  220     CONTINUE
C*PT*WARNING* Constant already double-precision
          CALL DDSCAL(N-L+1,-1.0d0,U(L,L),1)
C*PT*WARNING* Constant already double-precision
          U(L,L) = 1.0d0 + U(L,L)
          LM1 = L - 1
          IF (LM1.LT.1) GO TO 240
          DO 230 I = 1,LM1
C*PT*WARNING* Constant already double-precision
              U(I,L) = 0.0d0
  230     CONTINUE
  240     CONTINUE
          GO TO 270
  250     CONTINUE
          DO 260 I = 1,N
C*PT*WARNING* Constant already double-precision
              U(I,L) = 0.0d0
  260     CONTINUE
C*PT*WARNING* Constant already double-precision
          U(L,L) = 1.0d0
  270     CONTINUE
  280 CONTINUE
  290 CONTINUE
  300 CONTINUE
c
c     if it is required, generate v.
c
      IF (.NOT.WANTV) GO TO 350
      DO 340 LL = 1,P
          L = P - LL + 1
          LP1 = L + 1
          IF (L.GT.NRT) GO TO 320
C*PT*WARNING* Constant already double-precision
          IF (E(L).EQ.0.0d0) GO TO 320
          DO 310 J = LP1,P
              T = -DDDOT(P-L,V(LP1,L),1,V(LP1,J),1)/V(LP1,L)
              CALL DDAXPY(P-L,T,V(LP1,L),1,V(LP1,J),1)
  310     CONTINUE
  320     CONTINUE
          DO 330 I = 1,P
C*PT*WARNING* Constant already double-precision
              V(I,L) = 0.0d0
  330     CONTINUE
C*PT*WARNING* Constant already double-precision
          V(L,L) = 1.0d0
  340 CONTINUE
  350 CONTINUE
c
c     main iteration loop for the singular values.
c
      MM = M
      ITER = 0
  360 CONTINUE
c
c        quit if all the singular values have been found.
c
c     ...exit
      IF (M.EQ.0) GO TO 620
c
c        if too many iterations have been performed, set
c        flag and return.
c
      IF (ITER.LT.MAXIT) GO TO 370
      INFO = M
c     ......exit
      GO TO 620
  370 CONTINUE
c
c        this section of the program inspects for
c        negligible elements in the s and e arrays.  on
c        completion the variables kase and l are set as follows.
c
c           kase = 1     if s(m) and e(l-1) are negligible and l.lt.m
c           kase = 2     if s(l) is negligible and l.lt.m
c           kase = 3     if e(l-1) is negligible, l.lt.m, and
c                        s(l), ..., s(m) are not negligible (qr step).
c           kase = 4     if e(m-1) is negligible (convergence).
c
      DO 390 LL = 1,M
          L = M - LL
c        ...exit
          IF (L.EQ.0) GO TO 400
          TEST = DABS(S(L)) + DABS(S(L+1))
          ZTEST = TEST + DABS(E(L))
          IF (ZTEST.NE.TEST) GO TO 380
C*PT*WARNING* Constant already double-precision
          E(L) = 0.0d0
c        ......exit
          GO TO 400
  380     CONTINUE
  390 CONTINUE
  400 CONTINUE
      IF (L.NE.M-1) GO TO 410
      KASE = 4
      GO TO 480
  410 CONTINUE
      LP1 = L + 1
      MP1 = M + 1
      DO 430 LLS = LP1,MP1
          LS = M - LLS + LP1
c           ...exit
          IF (LS.EQ.L) GO TO 440
C*PT*WARNING* Constant already double-precision
          TEST = 0.0d0
          IF (LS.NE.M) TEST = TEST + DABS(E(LS))
          IF (LS.NE.L+1) TEST = TEST + DABS(E(LS-1))
          ZTEST = TEST + DABS(S(LS))
          IF (ZTEST.NE.TEST) GO TO 420
C*PT*WARNING* Constant already double-precision
          S(LS) = 0.0d0
c           ......exit
          GO TO 440
  420     CONTINUE
  430 CONTINUE
  440 CONTINUE
      IF (LS.NE.L) GO TO 450
      KASE = 3
      GO TO 470
  450 CONTINUE
      IF (LS.NE.M) GO TO 460
      KASE = 1
      GO TO 470
  460 CONTINUE
      KASE = 2
      L = LS
  470 CONTINUE
  480 CONTINUE
      L = L + 1
c
c        perform the task indicated by kase.
c
      GO TO (490,520,540,570) KASE
c
c        deflate negligible s(m).
c
  490 CONTINUE
      MM1 = M - 1
      F = E(M-1)
C*PT*WARNING* Constant already double-precision
      E(M-1) = 0.0d0
      DO 510 KK = L,MM1
          K = MM1 - KK + L
          T1 = S(K)
          CALL DDROTG(T1,F,CS,SN)
          S(K) = T1
          IF (K.EQ.L) GO TO 500
          F = -SN*E(K-1)
          E(K-1) = CS*E(K-1)
  500     CONTINUE
          IF (WANTV) CALL DDROT(P,V(1,K),1,V(1,M),1,CS,SN)
  510 CONTINUE
      GO TO 610
c
c        split at negligible s(l).
c
  520 CONTINUE
      F = E(L-1)
C*PT*WARNING* Constant already double-precision
      E(L-1) = 0.0d0
      DO 530 K = L,M
          T1 = S(K)
          CALL DDROTG(T1,F,CS,SN)
          S(K) = T1
          F = -SN*E(K)
          E(K) = CS*E(K)
          IF (WANTU) CALL DDROT(N,U(1,K),1,U(1,L-1),1,CS,SN)
  530 CONTINUE
      GO TO 610
c
c        perform one qr step.
c
  540 CONTINUE
c
c           calculate the shift.
c
      SCALE = DMAX1(DABS(S(M)),DABS(S(M-1)),DABS(E(M-1)),DABS(S(L)),
     +        DABS(E(L)))
      SM = S(M)/SCALE
      SMM1 = S(M-1)/SCALE
      EMM1 = E(M-1)/SCALE
      SL = S(L)/SCALE
      EL = E(L)/SCALE
C*PT*WARNING* Constant already double-precision
      B = ((SMM1+SM)* (SMM1-SM)+EMM1**2)/2.0d0
      C = (SM*EMM1)**2
C*PT*WARNING* Constant already double-precision
      SHIFT = 0.0d0
C*PT*WARNING* Constant already double-precision
C*PT*WARNING* Constant already double-precision
      IF (B.EQ.0.0d0 .AND. C.EQ.0.0d0) GO TO 550
      SHIFT = DSQRT(B**2+C)
C*PT*WARNING* Constant already double-precision
      IF (B.LT.0.0d0) SHIFT = -SHIFT
      SHIFT = C/ (B+SHIFT)
  550 CONTINUE
      F = (SL+SM)* (SL-SM) + SHIFT
      G = SL*EL
c
c           chase zeros.
c
      MM1 = M - 1
      DO 560 K = L,MM1
          CALL DDROTG(F,G,CS,SN)
          IF (K.NE.L) E(K-1) = F
          F = CS*S(K) + SN*E(K)
          E(K) = CS*E(K) - SN*S(K)
          G = SN*S(K+1)
          S(K+1) = CS*S(K+1)
          IF (WANTV) CALL DDROT(P,V(1,K),1,V(1,K+1),1,CS,SN)
          CALL DDROTG(F,G,CS,SN)
          S(K) = F
          F = CS*E(K) + SN*S(K+1)
          S(K+1) = -SN*E(K) + CS*S(K+1)
          G = SN*E(K+1)
          E(K+1) = CS*E(K+1)
          IF (WANTU .AND. K.LT.N) CALL DDROT(N,U(1,K),1,U(1,K+1),1,CS,
     +                                       SN)
  560 CONTINUE
      E(M-1) = F
      ITER = ITER + 1
      GO TO 610
c
c        convergence.
c
  570 CONTINUE
C*PT*WARNING* Constant already double-precision
c
c           make the singular value  positive.
c
      IF (S(L).GE.0.0d0) GO TO 580
      S(L) = -S(L)
C*PT*WARNING* Constant already double-precision
      IF (WANTV) CALL DDSCAL(P,-1.0d0,V(1,L),1)
  580 CONTINUE
c
c           order the singular value.
c
  590 IF (L.EQ.MM) GO TO 600
c           ...exit
      IF (S(L).GE.S(L+1)) GO TO 600
      T = S(L)
      S(L) = S(L+1)
      S(L+1) = T
      IF (WANTV .AND. L.LT.P) CALL DDSWAP(P,V(1,L),1,V(1,L+1),1)
      IF (WANTU .AND. L.LT.N) CALL DDSWAP(N,U(1,L),1,U(1,L+1),1)
      L = L + 1
      GO TO 590
  600 CONTINUE
      ITER = 0
      M = M - 1
  610 CONTINUE
      GO TO 360
  620 CONTINUE
      RETURN
      END
      SUBROUTINE DDAXPY(N,DA,DX,INCX,DY,INCY)
C*PT*WARNING* Already double-precision
c
c     constant times a vector plus a vector.
c     uses unrolled loops for increments equal to one.
c     jack dongarra, linpack, 3/11/78.
c     modified 12/3/93, array(1) declarations changed to array(*)
c
      DOUBLE PRECISION DX(*),DY(*),DA
      INTEGER I,INCX,INCY,IX,IY,M,MP1,N
c
      IF (N.LE.0) RETURN
C*PT*WARNING* Constant already double-precision
      IF (DA.EQ.0.0d0) RETURN
      IF (INCX.EQ.1 .AND. INCY.EQ.1) GO TO 20
c
c        code for unequal increments or equal increments
c          not equal to 1
c
      IX = 1
      IY = 1
      IF (INCX.LT.0) IX = (-N+1)*INCX + 1
      IF (INCY.LT.0) IY = (-N+1)*INCY + 1
      DO 10 I = 1,N
          DY(IY) = DY(IY) + DA*DX(IX)
          IX = IX + INCX
          IY = IY + INCY
   10 CONTINUE
      RETURN
c
c        code for both increments equal to 1
c
c
c        clean-up loop
c
   20 M = MOD(N,4)
      IF (M.EQ.0) GO TO 40
      DO 30 I = 1,M
          DY(I) = DY(I) + DA*DX(I)
   30 CONTINUE
      IF (N.LT.4) RETURN
   40 MP1 = M + 1
      DO 50 I = MP1,N,4
          DY(I) = DY(I) + DA*DX(I)
          DY(I+1) = DY(I+1) + DA*DX(I+1)
          DY(I+2) = DY(I+2) + DA*DX(I+2)
          DY(I+3) = DY(I+3) + DA*DX(I+3)
   50 CONTINUE
      RETURN
      END
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION FUNCTION DDDOT(N,DX,INCX,DY,INCY)
C*PT*WARNING* Already double-precision
c
c     forms the dot product of two vectors.
c     uses unrolled loops for increments equal to one.
c     jack dongarra, linpack, 3/11/78.
c     modified 12/3/93, array(1) declarations changed to array(*)
c
      DOUBLE PRECISION DX(*),DY(*),DTEMP
      INTEGER I,INCX,INCY,IX,IY,M,MP1,N
C*PT*WARNING* Constant already double-precision
c
      DDDOT = 0.0d0
C*PT*WARNING* Constant already double-precision
      DTEMP = 0.0d0
      IF (N.LE.0) RETURN
      IF (INCX.EQ.1 .AND. INCY.EQ.1) GO TO 20
c
c        code for unequal increments or equal increments
c          not equal to 1
c
      IX = 1
      IY = 1
      IF (INCX.LT.0) IX = (-N+1)*INCX + 1
      IF (INCY.LT.0) IY = (-N+1)*INCY + 1
      DO 10 I = 1,N
          DTEMP = DTEMP + DX(IX)*DY(IY)
          IX = IX + INCX
          IY = IY + INCY
   10 CONTINUE
      DDDOT = DTEMP
      RETURN
c
c        code for both increments equal to 1
c
c
c        clean-up loop
c
   20 M = MOD(N,5)
      IF (M.EQ.0) GO TO 40
      DO 30 I = 1,M
          DTEMP = DTEMP + DX(I)*DY(I)
   30 CONTINUE
      IF (N.LT.5) GO TO 60
   40 MP1 = M + 1
      DO 50 I = MP1,N,5
          DTEMP = DTEMP + DX(I)*DY(I) + DX(I+1)*DY(I+1) +
     +            DX(I+2)*DY(I+2) + DX(I+3)*DY(I+3) + DX(I+4)*DY(I+4)
   50 CONTINUE
   60 DDDOT = DTEMP
      RETURN
      END
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION FUNCTION DDNRM2(N,X,INCX)
*     .. Scalar Arguments ..
      INTEGER INCX,N
C*PT*WARNING* Already double-precision
*     .. Array Arguments ..
      DOUBLE PRECISION X(*)
C*PT*WARNING* Already double-precision
*     ..
*
*  DDNRM2 returns the euclidean norm of a vector via the function
*  name, so that
*
*     DDNRM2 := sqrt( x'*x )
*
*
*
*  -- This version written on 25-October-1982.
*     Modified on 14-October-1993 to inline the call to DLASSQ.
*     Sven Hammarling, Nag Ltd.
*
*
*     .. Parameters ..
      DOUBLE PRECISION ONE,ZERO
C*PT*WARNING* Constant already double-precision
C*PT*WARNING* Constant already double-precision
      PARAMETER (ONE=1.0D+0,ZERO=0.0D+0)
*     .. Local Scalars ..
      INTEGER IX
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION ABSXI,NORM,SCALE,SSQ
*     .. Intrinsic Functions ..
      INTRINSIC ABS,SQRT
*     ..
*     .. Executable Statements ..
      IF (N.LT.1 .OR. INCX.LT.1) THEN
          NORM = ZERO
      ELSE IF (N.EQ.1) THEN
          NORM = ABS(X(1))
      ELSE
          SCALE = ZERO
          SSQ = ONE
*        The following loop is equivalent to this call to the LAPACK
*        auxiliary routine:
*        CALL DLASSQ( N, X, INCX, SCALE, SSQ )
*
          DO 10 IX = 1,1 + (N-1)*INCX,INCX
              IF (X(IX).NE.ZERO) THEN
                  ABSXI = ABS(X(IX))
                  IF (SCALE.LT.ABSXI) THEN
                      SSQ = ONE + SSQ* (SCALE/ABSXI)**2
                      SCALE = ABSXI
                  ELSE
                      SSQ = SSQ + (ABSXI/SCALE)**2
                  END IF
              END IF
   10     CONTINUE
          NORM = SCALE*SQRT(SSQ)
      END IF
*
      DDNRM2 = NORM
      RETURN
*
*     End of DDNRM2.
*
      END
      SUBROUTINE DDROT(N,DX,INCX,DY,INCY,C,S)
C*PT*WARNING* Already double-precision
c
c     applies a plane rotation.
c     jack dongarra, linpack, 3/11/78.
c     modified 12/3/93, array(1) declarations changed to array(*)
c
      DOUBLE PRECISION DX(*),DY(*),DTEMP,C,S
      INTEGER I,INCX,INCY,IX,IY,N
c
      IF (N.LE.0) RETURN
      IF (INCX.EQ.1 .AND. INCY.EQ.1) GO TO 20
c
c       code for unequal increments or equal increments not equal
c         to 1
c
      IX = 1
      IY = 1
      IF (INCX.LT.0) IX = (-N+1)*INCX + 1
      IF (INCY.LT.0) IY = (-N+1)*INCY + 1
      DO 10 I = 1,N
          DTEMP = C*DX(IX) + S*DY(IY)
          DY(IY) = C*DY(IY) - S*DX(IX)
          DX(IX) = DTEMP
          IX = IX + INCX
          IY = IY + INCY
   10 CONTINUE
      RETURN
c
c       code for both increments equal to 1
c
   20 DO 30 I = 1,N
          DTEMP = C*DX(I) + S*DY(I)
          DY(I) = C*DY(I) - S*DX(I)
          DX(I) = DTEMP
   30 CONTINUE
      RETURN
      END
      SUBROUTINE DDROTG(DA,DB,C,S)
C*PT*WARNING* Already double-precision
c
c     construct givens plane rotation.
c     jack dongarra, linpack, 3/11/78.
c
      DOUBLE PRECISION DA,DB,C,S,ROE,SCALE,R,Z
c
      ROE = DB
      IF (DABS(DA).GT.DABS(DB)) ROE = DA
      SCALE = DABS(DA) + DABS(DB)
C*PT*WARNING* Constant already double-precision
      IF (SCALE.NE.0.0d0) GO TO 10
C*PT*WARNING* Constant already double-precision
      C = 1.0d0
C*PT*WARNING* Constant already double-precision
      S = 0.0d0
C*PT*WARNING* Constant already double-precision
      R = 0.0d0
C*PT*WARNING* Constant already double-precision
      Z = 0.0d0
      GO TO 20
   10 R = SCALE*DSQRT((DA/SCALE)**2+ (DB/SCALE)**2)
C*PT*WARNING* Constant already double-precision
      R = DSIGN(1.0d0,ROE)*R
      C = DA/R
      S = DB/R
C*PT*WARNING* Constant already double-precision
      Z = 1.0d0
      IF (DABS(DA).GT.DABS(DB)) Z = S
C*PT*WARNING* Constant already double-precision
C*PT*WARNING* Constant already double-precision
      IF (DABS(DB).GE.DABS(DA) .AND. C.NE.0.0d0) Z = 1.0d0/C
   20 DA = R
      DB = Z
      RETURN
      END
      SUBROUTINE DDSCAL(N,DA,DX,INCX)
C*PT*WARNING* Already double-precision
c
c     scales a vector by a constant.
c     uses unrolled loops for increment equal to one.
c     jack dongarra, linpack, 3/11/78.
c     modified 3/93 to return if incx .le. 0.
c     modified 12/3/93, array(1) declarations changed to array(*)
c
      DOUBLE PRECISION DA,DX(*)
      INTEGER I,INCX,M,MP1,N,NINCX
c
      IF (N.LE.0 .OR. INCX.LE.0) RETURN
      IF (INCX.EQ.1) GO TO 20
c
c        code for increment not equal to 1
c
      NINCX = N*INCX
      DO 10 I = 1,NINCX,INCX
          DX(I) = DA*DX(I)
   10 CONTINUE
      RETURN
c
c        code for increment equal to 1
c
c
c        clean-up loop
c
   20 M = MOD(N,5)
      IF (M.EQ.0) GO TO 40
      DO 30 I = 1,M
          DX(I) = DA*DX(I)
   30 CONTINUE
      IF (N.LT.5) RETURN
   40 MP1 = M + 1
      DO 50 I = MP1,N,5
          DX(I) = DA*DX(I)
          DX(I+1) = DA*DX(I+1)
          DX(I+2) = DA*DX(I+2)
          DX(I+3) = DA*DX(I+3)
          DX(I+4) = DA*DX(I+4)
   50 CONTINUE
      RETURN
      END
      SUBROUTINE DDSWAP(N,DX,INCX,DY,INCY)
C*PT*WARNING* Already double-precision
c
c     interchanges two vectors.
c     uses unrolled loops for increments equal one.
c     jack dongarra, linpack, 3/11/78.
c     modified 12/3/93, array(1) declarations changed to array(*)
c
      DOUBLE PRECISION DX(*),DY(*),DTEMP
      INTEGER I,INCX,INCY,IX,IY,M,MP1,N
c
      IF (N.LE.0) RETURN
      IF (INCX.EQ.1 .AND. INCY.EQ.1) GO TO 20
c
c       code for unequal increments or equal increments not equal
c         to 1
c
      IX = 1
      IY = 1
      IF (INCX.LT.0) IX = (-N+1)*INCX + 1
      IF (INCY.LT.0) IY = (-N+1)*INCY + 1
      DO 10 I = 1,N
          DTEMP = DX(IX)
          DX(IX) = DY(IY)
          DY(IY) = DTEMP
          IX = IX + INCX
          IY = IY + INCY
   10 CONTINUE
      RETURN
c
c       code for both increments equal to 1
c
c
c       clean-up loop
c
   20 M = MOD(N,3)
      IF (M.EQ.0) GO TO 40
      DO 30 I = 1,M
          DTEMP = DX(I)
          DX(I) = DY(I)
          DY(I) = DTEMP
   30 CONTINUE
      IF (N.LT.3) RETURN
   40 MP1 = M + 1
      DO 50 I = MP1,N,3
          DTEMP = DX(I)
          DX(I) = DY(I)
          DY(I) = DTEMP
          DTEMP = DX(I+1)
          DX(I+1) = DY(I+1)
          DY(I+1) = DTEMP
          DTEMP = DX(I+2)
          DX(I+2) = DY(I+2)
          DY(I+2) = DTEMP
   50 CONTINUE
      RETURN
      END

C
C $Id: istrcl.f,v 1.5 2008-07-27 00:17:16 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE ISTRCL (ZDAT,IZD1,IZDM,IZDN,CLVL)
C
      DIMENSION ZDAT(IZD1,*)
C
C Given the data slice in ((ZDAT(I,J),I=1,IZDM),J=1,IZDN), the routine
C ISTRCL finds the beginning of each contour line at the level CLVL and
C traces it.  The generated contour lines are mapped to the projection
C plane, smoothed if the tension parameter indicates that they should
C be, and then passed on, one point at a time, to the routine ISPLTF.
C
C This routine is a modified version of CPTRCL, from CONPACK.
C
      COMMON /ISCOMN/ BIG,BIGD,DBPI,IDONE,IFILL,IFLIP,IONES,IHSS(1000),
     +                IREF,ISCA(16,256),ISCALE,ISCR(16,256),ISLBT,ISDR,
     +                LHSS,LX,NFPW,NINU,NINV,NINW,NX,NY,R0,RNX,RNY,
     +                SMALL,SVAL,TENSN,U,V,W,XMAX,XMIN,YMAX,YMIN,XVPL,
     +                XVPR,YVPB,YVPT
      SAVE   /ISCOMN/
C
C XSVE and YSVE are arrays in which to save for smoothing the X and Y
C coordinates of points along contour lines.  They must be dimensioned
C the same as the arrays needed by the smoother, in ISSMTH.
C
      DIMENSION XSVE(100),YSVE(100)
C
C INCX and INCY define the x and y components of the eight possible
C directions the contour-line-following vector can assume.
C
      DIMENSION INCX(8),INCY(8)
C
      DATA INCX / -1 , -1 ,  0 ,  1 ,  1 ,  1 ,  0 , -1 /
      DATA INCY /  0 ,  1 ,  1 ,  1 ,  0 , -1 , -1 , -1 /
C
C Define an interpolation function.
C
      FRCT(ZDT1,ZDT2)=(CLVL-ZDT1)/(ZDT2-ZDT1)
C
C Set the flag which indicates fill is unnecessary; it gets turned back
C on by ISPLTF whenever bits get set in the screen model (which makes
C fill necessary).
C
        IFILL=0
C
C Zero the count of horizontal segments seen so far.
C
        NHSS=0
C
C Search the interior of the grid for contour lines to trace.  (Because
C of the way ISOSRF works, there are no contour lines intersecting the
C edge of the grid, so we only look for ones in the interior.)
C
        DO 105 INDY=2,IZDN-1
C
          DO 104 INDX=2,IZDM
C
C Look for horizontal segments with a value less than CLVL at the left
C end and a value greater than or equal to CLVL at the right end.
C
            IF (ZDAT(INDX-1,INDY).LT.CLVL.AND.
     +          ZDAT(INDX  ,INDY).GE.CLVL) THEN
C
C Pack the indices of the segment's right end into a single integer.
C
              IPXY=IZDN*INDX+INDY
C
C Skip if the contour line through this segment has been traced before.
C
              DO 101 I=1,NHSS
                IF (IPXY.EQ.IHSS(I)) GO TO 104
  101         CONTINUE
C
C It hasn't.  Add the packed indices to the list.  (Or, if the list is
C full, quit.)
C
              IF (NHSS.GE.LHSS) RETURN
              NHSS=NHSS+1
              IHSS(NHSS)=IPXY
C
C Initialize the line-following vector to have its basepoint at
C (INDX,INDY) and point to the left.
C
              IVBX=INDX
              IVBY=INDY
              INCI=1
C
C Line-following algorithm.  Loop, moving the line-following vector
C (defined by the base point (IVBX,IVBY) and the components INCX(INCI)
C and INCY(INCI)) along a contour line.  The points defining the contour
C line are thereby determined.  The process stops when the starting
C position is encountered.  Save the parameters defining that position.
C
              MVBX=IVBX
              MVBY=IVBY
              MNCI=INCI
C
C Set parameters defining the position of the end of the vector.
C
              IVEX=IVBX+INCX(INCI)
              IVEY=IVBY+INCY(INCI)
C
C Compute the coordinates, in the data-index coordinate system, of the
C starting position of the contour line.
C
              IF (IVEX.NE.IVBX) THEN
                XCND=REAL(IVBX)+REAL(IVEX-IVBX)*FRCT(ZDAT(IVBX,IVBY),
     +                                               ZDAT(IVEX,IVEY))
                YCND=REAL(IVBY)
              ELSE
                XCND=REAL(IVBX)
                YCND=REAL(IVBY)+REAL(IVEY-IVBY)*FRCT(ZDAT(IVBX,IVBY),
     +                                               ZDAT(IVEX,IVEY))
              END IF
C
C Map the data-index coordinates XCND and YCND into user coordinates and
C send them to the routine ISPLTF.  If the smoother is turned on, save
C the coordinates for the smoother.
C
              CALL ISGFXY (XCND,YCND,XCNU,YCNU)
              CALL ISPLTF (XCNU,YCNU,1)
C
              IF (TENSN.NE.0.) THEN
                NSVE=1
                XSVE(1)=XCNU
                YSVE(1)=YCNU
              END IF
C
C Initialize the flag that indicates we're working on the first segment.
C
              IFSF=1
C
C Loop, moving the line-following vector as dictated by the positions
C of its end points.  We know that the base of the line-following vector
C is on the high side of the contour and that the end of it is on the
C other side.  Move the vector clockwise and see what happens.
C
  102         INCI=INCI+1
              IF (INCI.GT.8) INCI=INCI-8
              IVEX=IVBX+INCX(INCI)
              IVEY=IVBY+INCY(INCI)
C
C Exit the loop if we've hit the edge.  (This should not be possible,
C but what the hey...)
C
              IF (IVEX.LT.1.OR.IVEX.GT.IZDM.OR.
     +            IVEY.LT.1.OR.IVEY.GT.IZDN) GO TO 103
C
C If the end of the line-following vector is now on the same side of
C the contour line as its base ...
C
              IF (ZDAT(IVEX,IVEY).GE.CLVL) THEN
C
C flip it end-for-end and continue the loop.
C
                IVBX=IVEX
                IVBY=IVEY
                INCI=INCI+4
C
C Otherwise, if the line-following vector is currently horizontal or
C vertical, we have another point to add to the contour line ...
C
              ELSE IF ((INCI/2)*2.NE.INCI) THEN
C
C so compute the coordinates of the new point and either pass them on
C to ISPLTF or save them for the smoother.
C
                IF (IVEX.NE.IVBX) THEN
                  XCND=REAL(IVBX)+REAL(IVEX-IVBX)*FRCT(ZDAT(IVBX,IVBY),
     +                                                 ZDAT(IVEX,IVEY))
                  YCND=REAL(IVBY)
                ELSE
                  XCND=REAL(IVBX)
                  YCND=REAL(IVBY)+REAL(IVEY-IVBY)*FRCT(ZDAT(IVBX,IVBY),
     +                                                 ZDAT(IVEX,IVEY))
                END IF
C
                  CALL ISGFXY (XCND,YCND,XCNU,YCNU)
C
                  IF (TENSN.EQ.0.) THEN
                    CALL ISPLTF (XCNU,YCNU,2)
                  ELSE
                    IF (ABS(XCNU-XSVE(NSVE)).GT.SMALL.OR.
     +                  ABS(YCNU-YSVE(NSVE)).GT.SMALL) THEN
                      NSVE=NSVE+1
                      XSVE(NSVE)=XCNU
                      YSVE(NSVE)=YCNU
                      IF (NSVE.EQ.100) THEN
                        CALL ISSMTH (XSVE,YSVE,NSVE,IFSF)
                        XSVE(1)=XSVE(NSVE)
                        YSVE(1)=YSVE(NSVE)
                        NSVE=1
                        IFSF=0
                        CALL ISPLTF (XCNU,YCNU,2)
                      END IF
                    END IF
                  END IF
C
C If we just crossed a horizontal grid line in the upwards direction,
C save that information.
C
                IF (INCI.EQ.1) THEN
                  IF (NHSS.GE.LHSS) RETURN
                  NHSS=NHSS+1
                  IHSS(NHSS)=IZDN*IVBX+IVBY
                END IF
C
C If we just arrived at our starting point, quit the loop.
C
                IF (IVBX.EQ.MVBX.AND.IVBY.EQ.MVBY.AND.INCI.EQ.MNCI)
     +                                                         GO TO 103
C
              END IF
C
C Loop back.
C
              GO TO 102
C
C Exit from loop.  Process any remaining portion of the contour line
C which was saved for smoothing.
C
  103         IF (TENSN.NE.0..AND.NSVE.GT.1) THEN
                CALL ISSMTH (XSVE,YSVE,NSVE,IFSF)
                CALL ISPLTF (XCNU,YCNU,2)
              END IF
C
            END IF
C
C End of loops on IVBX and IVBY.
C
  104     CONTINUE
C
  105   CONTINUE
C
C Done.
C
      RETURN
C
      END

C
C	$Id: gziqwk.f,v 1.10 2009-04-08 23:18:21 fred Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GZIQWK(WTYPE,WKID)
C
C  This subroutine is used to handle inquiry functions which
C  involve a particular workstation.
C
C  WTYPE should always be a valid workstation type, but WKID
C  need be supplied only when necessary.  If WKID is negative,
C  then it should not be necessary.   
C
      include 'gkscom.h'
C
      INTEGER XID,WTYPE,WKID,IDUM(1)
C
C  Invoke workstation driver for all inquiry functions.
C
      IF (WTYPE .EQ. GCGM) THEN
        CALL G01WDR(WKID,' ')
        RETURN
      ELSE IF (WTYPE.EQ.GXWC  .OR. WTYPE.EQ.GDMP  .OR.
     +         WTYPE.EQ.GXWE  .OR. WTYPE.EQ.GPIX  .OR.
     +        (WTYPE.GE.GPSMIN .AND. WTYPE.LE.GPSMAX) .OR.
     +        (WTYPE.EQ.GPDFP .OR. WTYPE.EQ.GPDFL) .OR.
     +        (WTYPE.GE.GCROMIN .AND. WTYPE.LE.GCROMAX) ) THEN
        CALL GZXID(WKID,XID,RERR)
        IF (RERR .NE. 0) RETURN
        IL1 = 0
        IL2 = 0
        IC1 = 1
        IC2 = 1
        IC(1) = ID(2)
        CALL GGKWDR(XID,FCODE,CONT,IL1,IL2,ID,IC1,IC2,IC,
     +              RL1,RL2,RX,RY,STRL1,STRL2,IDUM,RERR,XERMSG) 
        IF (RERR .NE. 0) THEN
          ERS = 1
          CALL GERHND(RERR,0,ERF)
          ERS = 0
          RERR = 0
        ENDIF
        RETURN
      ELSE IF (WTYPE.NE.GXWC) THEN
        RERR = 22
        RETURN
      ELSE
        RERR = -109
        RETURN
      ENDIF  
C
      END

C
C	$Id: csgradl.f,v 1.5 2008-07-27 03:10:06 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CSGRADL (N,K,X,Y,Z,W,LIST,LPTR,LEND, G,IER)
      INTEGER N, K, LIST(*), LPTR(*), LEND(N), IER
      DOUBLE PRECISION X(N), Y(N), Z(N), W(N), G(3)
C
C***********************************************************
C
C                                              From SSRFPACK
C                                            Robert J. Renka
C                                  Dept. of Computer Science
C                                       Univ. of North Texas
C                                           renka@cs.unt.edu
C                                                   07/24/96
C
C   Given a triangulation of a set of nodes on the unit
C sphere with their associated data values W, this routine
C estimates a gradient vector at node K as follows:  the
C coordinate system is rotated so that K becomes the north
C pole, node K and a set of nearby nodes are projected
C orthogonally onto the X-Y plane (in the new coordinate
C system), a quadratic is fitted in a weighted least squares
C sense to the data values at the projected nodes such that
C the value (associated with K) at (0,0) is interpolated, X
C and Y-partial derivative estimates DX and DY are computed
C by differentiating the quadratic at (0,0), and the esti-
C mated gradient G is obtained by rotating (DX,DY,0) back to
C the original coordinate system.  Note that G lies in the
C plane tangent to the sphere at node K, i.e., G is orthogo-
C nal to the unit vector represented by node K.  A Marquardt
C stabilization factor is used if necessary to ensure a
C well-conditioned least squares system, and a unique solu-
C tion exists unless the nodes are collinear.
C
C On input:
C
C       N = Number of nodes in the triangulation.  N .GE. 7.
C
C       K = Node at which the gradient is sought.  1 .LE. K
C           .LE. N.
C
C       X,Y,Z = Arrays containing the Cartesian coordinates
C               of the nodes.
C
C       W = Array containing the data values at the nodes.
C           W(I) is associated with (X(I),Y(I),Z(I)) for
C           I = 1,...,N.
C
C       LIST,LPTR,LEND = Data structure defining the trian-
C                        gulation.  Refer to STRIPACK
C                        Subroutine CSTRMESH.
C
C Input parameters are not altered by this routine.
C
C On output:
C
C       G = X, Y, and Z components (in that order) of the
C           estimated gradient at node K unless IER < 0.
C
C       IER = Error indicator:
C             IER .GE. 6 if no errors were encountered.
C                        IER contains the number of nodes
C                        (including K) used in the least
C                        squares fit.
C             IER = -1 if N or K is outside its valid range.
C             IER = -2 if the least squares system has no
C                      unique solution due to duplicate or
C                      collinear nodes.
C
C STRIPACK module required by CSGRADL:  CSGETNP
C
C SSRFPACK modules required by CSGRADL:  CSAPLYR, CSAPLYRT,
C                                        CSCONSTR, CSGIVENS,
C                                        CSROTATE, CSSETUP
C
C Intrinsic functions called by CSGRADL:  ABS, MIN, DBLE, SQRT
C
C***********************************************************
C
      INTEGER   LMN, LMX
      PARAMETER (LMN=10,  LMX=30)
      INTEGER I, IERR, IM1, IP1, J, JP1, KK, L, LM1, LMAX,
     .        LMIN, LNP, NN, NP, NPTS(LMX)
      DOUBLE PRECISION A(6,6), AV, AVSQ, C, CX, CY, DF,
     .                 DMIN, DTOL, DX, DY, RF, RIN, RTOL, S,
     .                 SF, SUM, SX, SY, WK, WT, XP, YP, ZP
C
      DATA    RTOL/1.D-6/, DTOL/.01D0/, SF/1.D0/
C
C Local parameters:
C
C A =         Transpose of the (upper triangle of the) aug-
C               mented regression matrix
C AV =        Root-mean-square distance (in the rotated
C               coordinate system) between the origin and
C               the nodes (other than K) in the least
C               squares fit.  The first 3 columns of A**T
C               are scaled by 1/AVSQ, the next 2 by 1/AV.
C AVSQ =      AV*AV:  accumulated in SUM
C C,S =       Components of the plane rotation used to
C               triangularize the regression matrix
C CX,SX =     Components of a plane rotation about the X-
C               axis which, together with CY and SY, define
C               a mapping from node K to the north pole
C               (0,0,1)
C CY,SY =     Components of a plane rotation about the Y-
C               axis
C DF =        Negative Z component (in the rotated coordi-
C               nate system) of an element NP of NPTS --
C               increasing function of the angular distance
C               between K and NP.  DF lies in the interval
C               (-1,1).
C DMIN =      Minimum of the magnitudes of the diagonal
C               elements of the triangularized regression
C               matrix
C DTOL =      Tolerance for detecting an ill-conditioned
C               system (DMIN is required to be at least
C               DTOL)
C DX,DY =     X and Y components of the estimated gradient
C               in the rotated coordinate system
C I,J =       Loop indexes
C IERR =      Error flag for calls to CSGETNP (not checked)
C IM1,IP1 =   I-1, I+1
C JP1 =       J+1
C KK =        Local copy of K
C L =         Number of columns of A**T to which a rotation
C               is applied
C LM1 =       LMIN-1
C LMIN,LMAX = Min(LMN,N), Min(LMX,N)
C LMN,LMX =   Minimum and maximum values of LNP for N
C               sufficiently large.  In most cases LMN-1
C               nodes are used in the fit.  7 .LE. LMN .LE.
C               LMX.
C LNP =       Length of NPTS or LMAX+1
C NN =        Local copy of N
C NP =        Element of NPTS to be added to the system
C NPTS =      Array containing the indexes of a sequence of
C               nodes ordered by angular distance from K.
C               NPTS(1)=K and the first LNP-1 elements of
C               NPTS are used in the least squares fit.
C               unless LNP = LMAX+1, NPTS(LNP) determines R
C               (see RIN).
C RF =        Value of DF associated with NPTS(LNP) unless
C               LNP = LMAX+1 (see RIN)
C RIN =       Inverse of a radius of influence R which
C               enters into WT:  R = 1+RF unless all ele-
C               ments of NPTS are used in the fit (LNP =
C               LMAX+1), in which case R is the distance
C               function associated with some point more
C               distant from K than NPTS(LMAX)
C RTOL =      Tolerance for determining LNP (and hence R):
C               if the increase in DF between two successive
C               elements of NPTS is less than RTOL, they are
C               treated as being the same distance from node
C               K and an additional node is added
C SF =        Marquardt stabilization factor used to damp
C               out the first 3 solution components (second
C               partials of the quadratic) when the system
C               is ill-conditioned.  Increasing SF results
C               in more damping (a more nearly linear fit).
C SUM =       Sum of squared Euclidean distances (in the
C               rotated coordinate system) between the
C               origin and the nodes used in the least
C               squares fit
C WK =        W(K) -- data value at node K
C WT =        Weight for the equation coreesponding to NP:
C               WT = (R-D)/(R*D) = 1/D - RIN, where D = 1-ZP
C               is associated with NP
C XP,YP,ZP =  Coordinates of NP in the rotated coordinate
C               system unless ZP < 0, in which case
C               (XP,YP,0) lies on the equator
C
      NN = N
      KK = K
      WK = W(KK)
C
C Check for errors and initialize LMIN, LMAX.
C
      IF (NN .LT. 7  .OR.  KK .LT. 1  .OR.  KK .GT. NN)
     .   GO TO 13
      LMIN = MIN(LMN,NN)
      LMAX = MIN(LMX,NN)
C
C Compute NPTS, LNP, AVSQ, AV, and R.
C   Set NPTS to the closest LMIN-1 nodes to K.  DF contains
C   the negative Z component (in the rotated coordinate
C   system) of the new node on return from CSGETNP.
C
      SUM = 0.
      NPTS(1) = KK
      LM1 = LMIN - 1
      DO 1 LNP = 2,LM1
        CALL CSGETNP (X,Y,Z,LIST,LPTR,LEND,LNP, NPTS, DF,IERR)
        SUM = SUM + 1. - DF*DF
    1   CONTINUE
C
C   Add additional nodes to NPTS until the increase in
C     R = 1+RF is at least RTOL.
C
      DO 2 LNP = LMIN,LMAX
        CALL CSGETNP (X,Y,Z,LIST,LPTR,LEND,LNP, NPTS, RF,IERR)
        IF (RF-DF .GE. RTOL) GO TO 3
        SUM = SUM + 1. - RF*RF
    2   CONTINUE
C
C   Use all LMAX nodes in the least squares fit.  R is
C     arbitrarily increased by 5 percent.
C
      RF = 1.05*RF + .05
      LNP = LMAX + 1
C
C   There are LNP-2 equations corresponding to nodes
C     NPTS(2),...,NPTS(LNP-1).
C
    3 AVSQ = SUM/DBLE(LNP-2)
      AV = SQRT(AVSQ)
      RIN = 1./(1.+RF)
C
C Construct the rotation.
C
      CALL CSCONSTR (X(KK),Y(KK),Z(KK), CX,SX,CY,SY)
C
C Set up the first 5 equations of the augmented regression
C   matrix (transposed) as the columns of A, and zero out
C   the lower triangle (upper triangle of A) with Givens
C   rotations.
C
      DO 5 I = 1,5
        NP = NPTS(I+1)
        CALL CSAPLYR (X(NP),Y(NP),Z(NP),CX,SX,CY,SY, XP,YP,ZP)
        WT = 1./(1.-ZP) - RIN
        CALL CSSETUP (XP,YP,W(NP),WK,AV,AVSQ,WT, A(1,I))
        IF (I .EQ. 1) GO TO 5
        IM1 = I - 1
        DO 4 J = 1,IM1
          JP1 = J + 1
          L = 6 - J
          CALL CSGIVENS ( A(J,J),A(J,I), C,S)
          CALL CSROTATE (L,C,S, A(JP1,J),A(JP1,I) )
    4     CONTINUE
    5   CONTINUE
C
C Add the additional equations to the system using
C   the last column of A.  I .LE. LNP.
C
      I = 7
    6   IF (I .EQ. LNP) GO TO 8
        NP = NPTS(I)
        CALL CSAPLYR (X(NP),Y(NP),Z(NP),CX,SX,CY,SY, XP,YP,ZP)
        WT = 1./(1.-ZP) - RIN
        CALL CSSETUP (XP,YP,W(NP),WK,AV,AVSQ,WT, A(1,6))
        DO 7 J = 1,5
          JP1 = J + 1
          L = 6 - J
          CALL CSGIVENS ( A(J,J),A(J,6), C,S)
          CALL CSROTATE (L,C,S, A(JP1,J),A(JP1,6) )
    7     CONTINUE
        I = I + 1
        GO TO 6
C
C Test the system for ill-conditioning.
C
    8 DMIN = MIN( ABS(A(1,1)),ABS(A(2,2)),ABS(A(3,3)),
     .            ABS(A(4,4)),ABS(A(5,5)) )
      IF (DMIN .GE. DTOL) GO TO 12
      IF (LNP .LE. LMAX) THEN
C
C Add another node to the system and increase R.
C   I = LNP.
C
        LNP = LNP + 1
        IF (LNP .LE. LMAX) CALL CSGETNP (X,Y,Z,LIST,LPTR,LEND,
     .                                 LNP,NPTS, RF,IERR)
        RIN = 1./(1.05*(1.+RF))
        GO TO 6
      ENDIF
C
C Stabilize the system by damping second partials.  Add
C   multiples of the first three unit vectors to the first
C   three equations.
C
      DO 11 I = 1,3
        A(I,6) = SF
        IP1 = I + 1
        DO 9 J = IP1,6
          A(J,6) = 0.
    9     CONTINUE
        DO 10 J = I,5
          JP1 = J + 1
          L = 6 - J
          CALL CSGIVENS ( A(J,J),A(J,6), C,S)
          CALL CSROTATE (L,C,S, A(JP1,J),A(JP1,6) )
   10     CONTINUE
   11   CONTINUE
C
C Test the linear portion of the stabilized system for
C   ill-conditioning.
C
      DMIN = MIN( ABS(A(4,4)),ABS(A(5,5)) )
      IF (DMIN .LT. DTOL) GO TO 14
C
C Solve the 2 by 2 triangular system for the estimated
C   partial derivatives.
C
   12 DY = A(6,5)/A(5,5)
      DX = (A(6,4) - A(5,4)*DY)/A(4,4)/AV
      DY = DY/AV
C
C Rotate the gradient (DX,DY,0) back into the original
C   coordinate system.
C
      CALL CSAPLYRT (DX,DY,CX,SX,CY,SY, G)
      IER = LNP - 1
      RETURN
C
C N or K is outside its valid range.
C
   13 IER = -1
      RETURN
C
C No unique solution due to collinear nodes.
C
   14 IER = -2
      RETURN
      END

C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE BASCMPD(X,NDERIV,XMIN,NODES,ICOL,BASM)
      DOUBLE PRECISION X
      DOUBLE PRECISION XMIN
      DOUBLE PRECISION BASM
      DOUBLE PRECISION DX
      DOUBLE PRECISION DXIN
      DOUBLE PRECISION XB
      DOUBLE PRECISION BAS1
      DOUBLE PRECISION Z
      DOUBLE PRECISION FACT
      DOUBLE PRECISION Z1
C
C  This routine does basis function computations for natural
C  splines.  This routine is called by routines SPLCW and SPLDE
C  to compute ICOL and BASM, which are defined as follows:
C
C     The MDIM indices in IB (defined through common) determine
C     a specific node in the node grid (see routine SPLCC for a
C     description of the node grid).  Every node is associated
C     with an MDIM-dimensional basis function and a corresponding
C     column in the least squares matrix (or element of the
C     coefficient vector).  The column index (which may be thought
C     of as a linear address for the MDIM-dimensional node grid)
C     corresponding to the specified node is computed as ICOL.  The
C     associated basis function evaluated at X (an MDIM-vector) is
C     computed as BASM (a scalar).
C
C  In case NDERIV is not all zero, BASM will not be the value of
C  the basis function but rather a partial derivative of that
C  function as follows:
C
C     The order of the partial derivative in the direction of the
C     IDIM coordinate is NDERIV(IDIM) (for IDIM .LE. MDIM).  This
C     routine will compute incorrect values if NDERIV(IDIM) is not
C     in the range 0 to 2.
C
C
      DIMENSION X(4),NDERIV(4),XMIN(4),NODES(4)
C
C  The technique of this routine is to transform the independent
C  variable in each dimension such that the nodes fall on
C  suitably chosen integers.  On this transformed space, the
C  1-dimensional basis functions and their derivatives have a
C  particularly simple form.  The desired MDIM-dimensional basis
C  function (or any of its partial derivatives) is computed as
C  a product of such 1-dimensional functions (tensor product
C  method of defining multi-dimensional splines).  The values
C  which determine the location of the nodes, and hence the
C  above transform, are passed through common and the argument
C  list.
C
      COMMON /SPLCOMD/DX(4),DXIN(4),MDIM,IB(4),IBMN(4),IBMX(4)
      SAVE
C
C  ICOL will be a linear address corresponding to the indices in IB.
C
      ICOL = 0
C
C  BASM will be M-dimensional basis function evaluated at X.
C
      BASM = 1.D0
      DO 121 IDIM = 1,MDIM
C
C  Compute ICOL by Horner's method.
C
          MDMID = MDIM + 1 - IDIM
          ICOL = NODES(MDMID)*ICOL + IB(MDMID)
C
C  NGO depends upon function type and NDERIV.
C
          NTYP = 1
C
C  Function type 1 (left linear) for IB = 0 or 1.
C
          IF (IB(IDIM).LE.1) GO TO 101
          NTYP = 2
C
C  Function type 2 (chapeau function) for 2 LT IB LT NODES-2.
C
          IF (IB(IDIM).LT.NODES(IDIM)-2) GO TO 101
          NTYP = 3
C
C  Function type 3 (right linear) for IB = NODES-2 or NODES-1.
C
  101     NGO = 3*NTYP + NDERIV(IDIM) - 2
C
C  XB is X value of node IB (center of basis function).
C
          XB = XMIN(IDIM) + DBLE(IB(IDIM))*DX(IDIM)
C
C  BAS1 will be the 1-dimensional basis function evaluated at X.
C
          BAS1 = 0.D0
          GO TO (102,103,104,105,106,108,110,113,117) NGO
C
C  Function type 1 (left linear) is mirror image of function type 3.
C
C  Transform so that XB is at 2 and the other nodes are at the integers
C  (with ordering reversed to form a mirror image).
C
  102     Z = DXIN(IDIM)* (XB-X(IDIM)) + 2.D0
          GO TO 111
C
C  1st derivative.
C
  103     FACT = -DXIN(IDIM)
          GO TO 114
C
C  2nd derivative.
C
  104     FACT = -DXIN(IDIM)
          GO TO 118
C
C  Function type 2 (chapeau function).
C
C  Transform so that XB is at the origin and the other nodes are at
C  the integers.
C
  105     Z = ABS(DXIN(IDIM)* (X(IDIM)-XB)) - 2.D0
C
C  This chapeau function is then that unique cubic spline which is
C  identically zero for ABS(Z) GE 2 and is 1 at the origin.  This
C  function is the general interior node basis function.
C
          IF (Z.GE.0.D0) GO TO 120
          BAS1 = -.25D0*Z**3
          Z = Z + 1.D0
          IF (Z.GE.0.D0) GO TO 120
          BAS1 = BAS1 + Z**3
          GO TO 120
C
C  1st derivative.
C
  106     Z = X(IDIM) - XB
          FACT = DXIN(IDIM)
          IF (Z.LT.0.D0) FACT = -FACT
          Z = FACT*Z - 2.D0
          IF (Z.GE.0.D0) GO TO 120
          BAS1 = -.75D0*Z**2
          Z = Z + 1.D0
          IF (Z.GE.0.D0) GO TO 107
          BAS1 = BAS1 + 3.D0*Z**2
  107     BAS1 = FACT*BAS1
          GO TO 120
C
C  2nd derivative.
C
  108     FACT = DXIN(IDIM)
          Z = FACT*ABS(X(IDIM)-XB) - 2.D0
          IF (Z.GE.0.D0) GO TO 120
          BAS1 = -1.5D0*Z
          Z = Z + 1.D0
          IF (Z.GE.0.D0) GO TO 109
          BAS1 = BAS1 + 6.D0*Z
  109     BAS1 = (FACT**2)*BAS1
          GO TO 120
C
C  Function type 3 (right linear).
C
C  Transform so that XB is at 2 and the other nodes are at the integers.
C
  110     Z = DXIN(IDIM)* (X(IDIM)-XB) + 2.D0
C
C  This right linear function is defined to be that unique cubic spline
C  which is identically zero for Z .LE. 0 and is 3*Z-3 for Z GE 2.
C  This function (obviously having zero 2nd derivative for
C  Z GE 2) is used for the two nodes nearest an edge in order
C  to generate natural splines, which must by definition have
C  zero 2nd derivative at the boundary.
C
C  Note that this method of generating natural splines also provides
C  a linear extrapolation which has 2nd order continuity with
C  the interior splines at the boundary.
C
  111     IF (Z.LE.0.D0) GO TO 120
          IF (Z.GE.2.D0) GO TO 112
          BAS1 = .5D0*Z**3
          Z = Z - 1.D0
          IF (Z.LE.0.D0) GO TO 120
          BAS1 = BAS1 - Z**3
          GO TO 120
  112     BAS1 = 3.D0*Z - 3.D0
          GO TO 120
C
C  1st derivative.
C
  113     FACT = DXIN(IDIM)
  114     Z = FACT* (X(IDIM)-XB) + 2.D0
          IF (Z.LE.0.D0) GO TO 120
          IF (Z.GE.2.D0) GO TO 116
          BAS1 = 1.5D0*Z**2
          Z = Z - 1.D0
          IF (Z.LE.0.D0) GO TO 115
          BAS1 = BAS1 - 3.D0*Z**2
  115     BAS1 = FACT*BAS1
          GO TO 120
  116     BAS1 = 3.D0*FACT
          GO TO 120
C
C  2nd derivative.
C
  117     FACT = DXIN(IDIM)
  118     Z = FACT* (X(IDIM)-XB) + 2.D0
          Z1 = Z - 1.D0
          IF (ABS(Z1).GE.1.D0) GO TO 120
          BAS1 = 3.D0*Z
          IF (Z1.LE.0.D0) GO TO 119
          BAS1 = BAS1 - 6.D0*Z1
  119     BAS1 = (FACT**2)*BAS1
  120     BASM = BASM*BAS1
  121 CONTINUE
      ICOL = ICOL + 1
      RETURN
      END

C NCLFORTSTART
      SUBROUTINE DTTEST(AVE1,VAR1,S1,AVE2,VAR2,S2,IFLAG,ALPHA,TVAL,IER)
c      implicit none

C NCL: prob = ttest (ave1,var1,s1,ave2,var2,s2,iflag,tval_opt)

c calculate student t-statistic + prob

c nomenclature:

c input  ave1,var1,s1 - average, variance and size (sample 1)
c .      ave2,var2,s2 - average, variance and size (sample 2)
c .                     Ideally, s1 and s2 >=30
c output alpha        - level of significance
c .                     probability that a random variable
c .                     following the students t distribution
c .                     will exceed tval in absolute value.
c .      tval         - t-value

c .                     e.g.,if df=14. and tval=1.761 then alpha=0.10.
c .                          for a 2 tailed test alpha=0.10 (or 10%)
c .                          means that the critical region has 5%
c .                          in each tail. note: some users set
c .                                  prob = 1.-alpha
c .                          upon return to the calling program.
c .      iflag        - set to False if population variances are equal
c .                     set to True if population variances are unequal
c .      ier          - error code

      DOUBLE PRECISION AVE1,VAR1,S1,AVE2,VAR2,S2,TVAL,ALPHA
      INTEGER IER
C NCLEND
      INTEGER IFLAG
      DOUBLE PRECISION DF,VARP
      DOUBLE PRECISION DBETAISLATEC

      IER = 0
C
C These following tests are done in the NCL C wrapper.
C
C      IF (S1.LT.2.0D0 .OR. S2.LT.2.0D0) IER = 1
C      IF (VAR1.LE.0.0D0 .OR. VAR2.LE.0.0D0) IER = IER + 10
C      IF (IER.NE.0) RETURN

      IF (IFLAG.EQ.0) THEN
          DF = S1 + S2 - 2.D0
          VARP = ((S1-1.D0)*VAR1+ (S2-1.D0)*VAR2)/DF
          TVAL = (AVE1-AVE2)/SQRT(VARP* (1.D0/S1+1.D0/S2))
      ELSE
          DF = (VAR1/S1+VAR2/S2)**2/ ((VAR1/S1)**2/ (S1-1.D0)+
     +         (VAR2/S2)**2/ (S2-1.D0))
          TVAL = (AVE1-AVE2)/SQRT(VAR1/S1+VAR2/S2)
C
C This following test is done in the NCL C wrapper.
C      ELSE
C          IER = -999
      END IF

      ALPHA = DBETAISLATEC(DF/ (DF+TVAL**2),0.5D0*DF,0.5D0)

      RETURN
      END

C NCLFORTSTART
      SUBROUTINE DFTEST(VAR1,VAR2,S1,S2,ALPHA,IER)
c c c implicit none

C NCL: prob = ftest (var1,var2,s1,s2)

c calculate student t-statistic + prob

c nomenclature:

c input  var1,s1      - variance and size (sample 1)
c .      var2,s2      - variance and size (sample 2)
c output alpha        - level of significance;
c .                     probability that a random variable
c .                     following the students t distribution
c .                     will exceed tval in absolute value.
c .      ier          - error code
c .                     ier.ne.0 then alpha=errval

      DOUBLE PRECISION VAR1,S1,VAR2,S2,ALPHA
      INTEGER IER
C NCLEND
      DOUBLE PRECISION DF1,DF2,FRAT
      DOUBLE PRECISION DBETAISLATEC

      IER = 0
      IF (S1.LT.2.0D0 .OR. S2.LT.2.0D0) IER = 1
      IF (VAR1.LE.0.0D0 .OR. VAR2.LE.0.0D0) IER = IER + 10
      IF (IER.NE.0) RETURN

      IF (VAR1.GT.VAR2) THEN
          FRAT = VAR1/VAR2
          DF1 = S1 - 1.D0
          DF2 = S2 - 1.D0
      ELSE
          FRAT = VAR2/VAR1
          DF1 = S2 - 1.D0
          DF2 = S1 - 1.D0
      END IF

      ALPHA = DBETAISLATEC(DF2/ (DF2+DF1*FRAT),0.5D0*DF2,0.5D0*DF1) +
     +        (1.D0-DBETAISLATEC(DF1/ (DF1+DF2/FRAT),0.5D0*DF1,
     +        0.5D0*DF2))

      RETURN
      END

C NCLFORTSTART
      SUBROUTINE DRTEST(R,N,PROB)
      IMPLICIT NONE
C Input
      INTEGER N
      DOUBLE PRECISION R
C Output
      DOUBLE PRECISION PROB
C NCLEND

C NCL: prob = rtest (r, n)

c nomenclature:
c Input
c .   r     - linear correlation coef
c .   n     - number of points used to calculate "r"
c Output
c .   prob  - calculated significance [0. < prob < 1.]

c Local variables

c c c real     betai
      DOUBLE PRECISION DBETAISLATEC
      DOUBLE PRECISION DF,TVAL

c calculate the significance level
c .   [see Numerical Recipies: Linear Correlation]
c .   [also: Climatic Change, WMO Tech Note 79, p66
c .          says "tval" formula is good for xn>=8]

      DF = N - 2.D0
      TVAL = R*SQRT(DF/ (1.D0-DMIN1(R*R,0.999D0)))
c c c prob  = betai ( 0.5*df, 0.5, df/(df+tval**2) )
      PROB = DBETAISLATEC(DF/ (DF+TVAL**2),0.5D0*DF,0.5D0)

      RETURN
      END

C NCLFORTSTART
      SUBROUTINE DEQVSIZ(X,NPTS,XMSG,SIGLVL,NEQV)
      IMPLICIT NONE
C Input
      INTEGER NPTS
      DOUBLE PRECISION X(NPTS),XMSG,SIGLVL
C Output
      INTEGER NEQV
C NCLEND

C NCL: neqv = eqv_sample_size (x,siglvl)
c      Only eqv size returned in NCL

C This assumes a red-noise process [r1>0.]

c nomenclature:
c Input
c .   x      - series
c .   npts   - number of pts
c .   xmsg   - missing code
c .   siglvl - significance level (eg: 0.05) at which the lag-1
c .            autocorrelation is to be tested.
c Output
c .   neqv   - Number of independent samples

c Local variables

c c c real     betai
      DOUBLE PRECISION DBETAISLATEC
      DOUBLE PRECISION XMEAN,XVAR,XSD,XCOV,XN,DF,SUM,TVAL,ALPHA,R1
      INTEGER N,LAG,JER,NPTUSED

      NEQV = -999

c compute 1st two moments

      CALL DSTAT2(X,NPTS,XMSG,XMEAN,XVAR,XSD,NPTUSED,JER)
      IF (NPTUSED.LE.0) THEN
          RETURN
      ELSEIF (NPTUSED.EQ.1 .OR. XVAR.EQ.0.D0) THEN
          NEQV = 1
          RETURN
      END IF

c compute lag-1 autocorrelation coef

      LAG  = 1
      XCOV = 0.D0
      XN   = 0.D0
      DO N = 2,NPTS
          IF (X(N).NE.XMSG .AND. X(N-LAG).NE.XMSG) THEN
              XCOV = XCOV + ((X(N)-XMEAN)* (X(N-LAG)-XMEAN))
              XN = XN + 1.D0
          END IF
      END DO

      IF (XN.GE.2.D0 .AND. XVAR.GT.0.D0) THEN
          R1 = (XCOV/ (XN-1.D0))/XVAR
      ELSE
          R1   = XMSG
          NEQV = -999
          RETURN
      END IF

c the approach below does not work when R1<0.

      IF (R1.LE.0.0D0) THEN
          NEQV = NPTUSED
          RETURN
      END IF

c calculate the significance level
c .   [see Numerical Recipies: Linear Correlation]
c .   [also: Climatic Change, WMO Tech Note 79, p66
c .          says "tval" formula is good for xn>=8]

      DF = NPTUSED - 2.D0
      TVAL = R1*SQRT(DF/ (1.D0-DMIN1(R1*R1,0.999D0)))
c c c alpha = betai ( 0.5*df, 0.5, df/(df+tval**2) )
      ALPHA = DBETAISLATEC(DF/ (DF+TVAL**2),0.5D0*DF,0.5D0)

c test r1 to see if it is sig different from zero at user
c specified level.

      NEQV = NPTUSED
      IF (ALPHA.LE.SIGLVL) THEN
          IF (XN.GE.50.D0 .AND. ABS(R1).NE.1.D0) THEN
              NEQV = XN* (1.D0-R1)/ (1.D0+R1)
          ELSE
              SUM = 1.0D0
              DO N = 1,NPTS
                  IF (X(N).NE.XMSG) THEN
                      SUM = SUM + 2.D0* (1.D0-N/XN)*R1**N
                  END IF
              END DO
              NEQV = XN/SUM
          END IF
          NEQV = MIN(NEQV,NPTUSED)
      END IF

      RETURN
      END

C
C $Id: mdrgdr.f,v 1.8 2008-09-18 00:42:18 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MDRGDR (XCRA,YCRA,NCRA,ITYP)
C
        DIMENSION XCRA(NCRA),YCRA(NCRA)
C
C The object of this routine is to break a polygon being drawn into
C pieces that lie along the edges of the unit square and pieces that lie
C strictly within the interior of the unit square.  Only the latter are
C actually drawn.
C
C IBEG is the index of the first point of the current interior piece of
C the polygon being traced, zero if no interior piece is being traced.
C
        IBEG=0
C
C ICRA is the index of the current polygon point being examined.
C
        ICRA=1
C
C Loop through the points of the polygon.
C
  101   IF (ICRA.LT.NCRA) THEN
C
C Advance ICRA to point to the next point.
C
          ICRA=ICRA+1
C
C Test whether the segment from point ICRA-1 to point ICRA is on the
C boundary of the unit square or not.
C
          IF ((XCRA(ICRA-1).EQ.0..AND.XCRA(ICRA).EQ.0.).OR.
     +        (XCRA(ICRA-1).EQ.1..AND.XCRA(ICRA).EQ.1.).OR.
     +        (YCRA(ICRA-1).EQ.0..AND.YCRA(ICRA).EQ.0.).OR.
     +        (YCRA(ICRA-1).EQ.1..AND.YCRA(ICRA).EQ.1.)) THEN
C
C It's on the boundary.  If an interior piece was being traced, draw
C it and resume searching for the beginning of another interior piece.
C
            IF (IBEG.NE.0) THEN
              CALL MDRGDP (XCRA(IBEG),YCRA(IBEG),ICRA-IBEG,ITYP)
              IBEG=0
            END IF
C
          ELSE
C
C It's in the interior.  If no interior piece is currently being
C traced, set the pointer to begin tracing a new such piece.
C
            IF (IBEG.EQ.0) IBEG=ICRA-1
C
          END IF
C
C Loop back for the next point of the polygon.
C
          GO TO 101
C
        END IF
C
C All segments of the polygon have been examined.  If the trace of an
C interior piece was in progress, draw it.
C
        IF (IBEG.NE.0) THEN
          CALL MDRGDP (XCRA(IBEG),YCRA(IBEG),ICRA-IBEG+1,ITYP)
        END IF
C
C Done.
C
        RETURN
C
      END

      PROGRAM CSSEX03
C
C  Do a comparison of CSSGRID with NATGRIDS for interpolation on
C  a sphere, using an analytic function.  This program produces
C  four plots:
C
C     1.)  Contour plot of the analytic function.
C     2.)  Contour plot of the interpolated function using NATGRIDS
C          with no periodic points.
C     3.)  Contour plot of the interpolated function using NATGRIDS
C          with periodic points added to the longitudes.
C     4.)  Contour plot of the interpolated function using CSSGRID.
C
C  External for Conpack calls.
C
      EXTERNAL DRAWCL
C
C  NUMORG - Number of points in the original dataset.
C  NMAX   - Number of points in the dataset with periodic points added.
C  NUMXOUT - Number of latitudes in the interpolated dataset.
C  NUMYOUT - Number of longitudes in the interpolated dataset.
C
      PARAMETER(NUMORG=750, NMAX = 1111, NUMXOUT = 71, NUMYOUT = 145,
     +          IDIM=2*NUMXOUT*NUMYOUT)
C
C  Conversion factors and constants.
C
      PARAMETER(D2R=0.017453293, R2D=57.29578)
      PARAMETER( PI=3.1415927, PIH= 1.5707963)
C
C  Specify GKS output data.
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1, IWKID=2)
C
C  Sizes of work arrays for plotting.
C
      PARAMETER (IRWRK=5200, IIWRK=11250, IAMASZ=20000)
      DIMENSION RWRK(IRWRK), IWRK(IIWRK), IAMA(IAMASZ)
C
C  Arrays for original data.
C
      REAL X(NMAX), Y(NMAX), FVAL(NMAX)
C
C  Arrays for output data.
C
      REAL RLAT(NMAX), RLON(NMAX)
      REAL XI(NUMXOUT), YI(NUMYOUT), ZDAT(NUMYOUT,NUMXOUT)
      REAL XR(NUMXOUT), YR(NUMYOUT)
      REAL FF(NUMXOUT,NUMYOUT), FFN(NUMXOUT,NUMYOUT)
      REAL FFS(NUMXOUT,NUMYOUT)
C
C  Work arrays for CSSGRID interpolation.
C
      PARAMETER (NIWKC=27*NMAX, NRWKC=13*NMAX)
      INTEGER IWKC(NIWKC)    
      DOUBLE PRECISION RWKC(NRWKC)    
C
C  Array to store the values of the analytic function.
C
      REAL FF_ANA(NUMXOUT,NUMYOUT)
C
C  Generate a random dataset on the unit sphere.
C
      N = NUMORG
      CALL GENSS(N,RLAT,RLON)
C
C  Generate functional values at the input nodes.
C
      CALL CRGENI(5,10,-200.,500.)
      DO 10 I=1,N
        FVAL(I) = CRGENPNT(RLAT(I),RLON(I))
   10 CONTINUE
C
C  Convert to radians for NATGRIDS calls.
C
      DO 2 K = 1,N
        X(K) = D2R*RLAT(K)
        Y(K) = D2R*RLON(K)
    2 CONTINUE
C
C  Create the output grid.
C
      DO 20 I=1,NUMXOUT
        XI(I) = -87.5+(I-1)*2.5
        XR(I) = D2R*XI(I)
   20 CONTINUE
      DO 30 J=1,NUMYOUT
        YI(J) = -180.+(J-1)*2.5
        YR(J) = D2R*YI(J)
   30 CONTINUE
C
C  Store analytic function values.
C
      DO 600 I=1,NUMXOUT
        DO 610 J=1,NUMYOUT
          FF_ANA(I,J) = CRGENPNT(XI(I),YI(J))
  610   CONTINUE
  600 CONTINUE
C
C  Use Natgrid to interpolate, without using any periodic points
C  in longitude.  There are significant problems along the zero 
C  longitude.
C
      CALL NATGRIDS(N,X,Y,FVAL,NUMXOUT,NUMYOUT,XR,YR,FFN,IER)
C
C  Add in periodic points in longitude for the Natgrid call.
C
      IJ = NUMORG
      DO 299 I=1,N
        IF(Y(I).GT.PIH .AND. Y(I).LE.PI) THEN
          IJ = IJ+1
          X(IJ) = X(I)
          Y(IJ) = Y(I)-2.0*PI
          FVAL(IJ) = FVAL(I)
        ELSE IF(Y(I).GE.-PI .AND. Y(I).LT.-PIH) THEN
          IJ = IJ+1
          X(IJ) = X(I)
          Y(IJ) = Y(I)+2.0*PI
          FVAL(IJ) = FVAL(I)
        ENDIF
  299 CONTINUE
C
C  Use Natgrid to interpolate, using the additional periodic points.
C  
      N = NMAX
      CALL NATGRIDS(N,X,Y,FVAL,NUMXOUT,NUMYOUT,XR,YR,FF,IER)
C
C  Use Cssgrid to interpolate on the sphere.
C
      N = NUMORG
      CALL CSSGRID(N,RLAT,RLON,FVAL,NUMXOUT,NUMYOUT,XI,YI,FFS,
     +             IWKC,RWKC,IER)
C
C  Plot the results.
C
C
C  Open GKS.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C  Color table.
C
      CALL GSCR(IWKID,0,1.,1.,1.)
      CALL GSCR(IWKID,1,0.,0.,0.)
      CALL GSCR(IWKID,2,1.,0.,0.)
      CALL GSCR(IWKID,3,0.,0.,1.)
C
C  Draw a contour map of the analytic function.
C
      CALL GSPLCI(3)
      CALL GSTXCI(3)
      CALL GSTXFP(-13,2)
C
C  Use a satellite projection and view the globe looking at the
C  north pole.
C
      CALL MAPSTR ('SA - SATELLITE HEIGHT',4.)
      CALL MAPROJ ('SV - SATELLITE-VIEW',90.,0.,0.)
      CALL MAPSET ('MA - MAXIMAL AREA',0.,0.,0.,0.)
      CALL MAPPOS (0.06, 0.94, 0.02, 0.90)
C
      CALL MAPSTI ('PE - PERIMETER',0)
      CALL MAPSTI ('GR - GRID',0)
      CALL MAPSTC ('OU - OUTLINE DATASET','PS')
      CALL MAPSTI ('DO - DOTTING OF OUTLINES',1)
      CALL MAPDRW
C
      CALL CPSETI ('SET - DO SET-CALL FLAG',0)
      CALL CPSETR ('DPS - LINE LABEL SIZE',0.02)
      CALL CPSETR ('T2D - TENSION ON THE 2D SPLINES',1.)
      CALL CPSETI ('CLS - CONTOUR LEVEL SELECTION FLAG',16)
      CALL CPSETC ('HLT - TURN OFF HIGH/LOW LABELS',' ')
      CALL CPSETC ('ILT - TURN OFF INFORMATIONAL LABEL',' ')
C
      CALL CPSETR ('XC1 - X COORDINATE AT I = 1',-180.)
      CALL CPSETR ('XCM - X COORDINATE AT I = M', 180.)
      CALL CPSETR ('YC1 - Y COORDINATE AT J = 1', -90.)
      CALL CPSETR ('YCN - Y COORDINATE AT J = N',  90.)
      CALL CPSETI ('MAP - MAPPING FLAG',1)
      CALL CPSETR ('ORV - OUT-OF-RANGE VALUE',1.E12)
C
C  Reverse the indices, since Conpack wants longitude as
C  the first dimension.
C
      DO 450 I=1,NUMXOUT
        DO 460 J=1,NUMYOUT
          ZDAT(J,I) = FF_ANA(I,J)
  460     CONTINUE
  450 CONTINUE
C
      CALL CPRECT (ZDAT,NUMYOUT,NUMYOUT,NUMXOUT,RWRK,IRWRK,IWRK,IIWRK)       
      CALL ARINAM (IAMA,IAMASZ)
      CALL CPLBAM (ZDAT,RWRK,IWRK,IAMA)
      CALL CPCLDM (ZDAT,RWRK,IWRK,IAMA,DRAWCL)
C
C  Plot the picture title.
C
      CALL SET(0.,1.,0.,1.,0.,1.,0.,1.,1)
      CALL PLCHHQ(0.50,0.95,':F26:Analytic function',
     +            0.025,0.,0.)
C
      CALL FRAME
C
C  Plot the results from Natgrid without periodic points.
C
      CALL MAPPOS (0.06, 0.94, 0.02, 0.90)
      CALL MAPDRW
C
C  Reverse the indices, since Conpack wants longitude as
C  the first dimension.
C
      DO 451 I=1,NUMXOUT
        DO 461 J=1,NUMYOUT
          ZDAT(J,I) = FFN(I,J)
  461     CONTINUE
  451 CONTINUE
C
      CALL CPRECT (ZDAT,NUMYOUT,NUMYOUT,NUMXOUT,RWRK,IRWRK,IWRK,IIWRK)       
      CALL ARINAM (IAMA,IAMASZ)
      CALL CPLBAM (ZDAT,RWRK,IWRK,IAMA)
      CALL CPCLDM (ZDAT,RWRK,IWRK,IAMA,DRAWCL)
C
C  Plot the picture title.
C
      CALL SET(0.,1.,0.,1.,0.,1.,0.,1.,1)
      CALL PLCHHQ(0.50,0.95,':F26:Natgrid without periodic points', 
     +            0.025,0.,0.)
C
      CALL FRAME
C
C  Plot the results from Natgrid with periodic points.
C
      CALL MAPPOS (0.06, 0.94, 0.02, 0.90)
      CALL MAPDRW
C
C  Reverse the indices, since Conpack wants longitude as
C  the first dimension.
C
      DO 452 I=1,NUMXOUT
        DO 462 J=1,NUMYOUT
          ZDAT(J,I) = FF(I,J)
  462     CONTINUE
  452 CONTINUE
C
      CALL CPRECT (ZDAT,NUMYOUT,NUMYOUT,NUMXOUT,RWRK,IRWRK,IWRK,IIWRK)       
      CALL ARINAM (IAMA,IAMASZ)
      CALL CPLBAM (ZDAT,RWRK,IWRK,IAMA)
      CALL CPCLDM (ZDAT,RWRK,IWRK,IAMA,DRAWCL)
C
C  Plot the picture title.
C
      CALL SET(0.,1.,0.,1.,0.,1.,0.,1.,1)
      CALL PLCHHQ(0.50,0.95,':F26:Natgrid with periodic points', 
     +            0.025,0.,0.)
C
      CALL FRAME
C
C  Plot the results from Cssgrid.
C
      CALL MAPPOS (0.06, 0.94, 0.02, 0.90)
      CALL MAPDRW
C
C  Reverse the indices, since Conpack wants longitude as
C  the first dimension.
C
      DO 453 I=1,NUMXOUT
        DO 463 J=1,NUMYOUT
          ZDAT(J,I) = FFS(I,J)
  463     CONTINUE
  453 CONTINUE
C
      CALL CPRECT (ZDAT,NUMYOUT,NUMYOUT,NUMXOUT,RWRK,IRWRK,IWRK,IIWRK)       
      CALL ARINAM (IAMA,IAMASZ)
      CALL CPLBAM (ZDAT,RWRK,IWRK,IAMA)
      CALL CPCLDM (ZDAT,RWRK,IWRK,IAMA,DRAWCL)
C
C  Plot the picture title.
C
      CALL SET(0.,1.,0.,1.,0.,1.,0.,1.,1)
      CALL PLCHHQ(0.50,0.95,':F26:Cssgrid',0.025,0.,0.)
C
      CALL FRAME
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C 
      STOP
C
      END
      SUBROUTINE GENSS(N,RLAT,RLON)
C
C  Generate random positions on a sphere in latitudes and longitudes
C  (latitude values between -90. and 90. and longitude values
C  between -180. and 180.
C
C  First select a random longitude, and then select a random value
C  on the Z axis -R to R (-1 to 1 in the case of the unit sphere).
C  From the random Z value, calculate the latitude.
C
      DIMENSION RLAT(N),RLON(N)
      PARAMETER (R=1., R2D=57.29578)
C
      DO 10 I=1,N
        RLON(I) = -180.+360.*CRRAND()
        RZ = R*(2.*CRRAND()-1.)
        RLAT(I) = R2D*ASIN(RZ)
   10 CONTINUE
C
      RETURN
      END
      REAL FUNCTION CRRAND()
C
C  Portable random number generator.
C
      PARAMETER (MPLIER=16807,MODLUS=2147483647,MOBYMP=127773,
     +           MOMDMP=2836)
C
      INTEGER HVLUE, LVLUE, TESTV, NEXTN
      SAVE    NEXTN
      DATA JSEED,IFRST/9,0/
C
      IF (IFRST .EQ. 0) THEN
        NEXTN = JSEED
        IFRST = 1
      ENDIF
C
      HVLUE = NEXTN / MOBYMP
      LVLUE = MOD(NEXTN, MOBYMP)
      TESTV = MPLIER*LVLUE - MOMDMP*HVLUE
      IF (TESTV .GT. 0) THEN
        NEXTN = TESTV
      ELSE
        NEXTN = TESTV + MODLUS
      ENDIF
      CRRAND = REAL(NEXTN)/REAL(MODLUS)
C
      RETURN
      END
      SUBROUTINE DRAWCL (XCS,YCS,NCS,IAI,IAG,NAI)
      DIMENSION XCS(*),YCS(*),IAI(*),IAG(*)
C
      IDR=1
      DO 101 I=1,NAI
        IF (IAI(I) .LT. 0) IDR = 0
  101 CONTINUE
      IF (IDR .NE. 0) CALL CURVED (XCS,YCS,NCS)
C
      RETURN
      END
      SUBROUTINE CRGENI (MLOW,MHGH,DLOW,DHGH)
C
C  The routines CRGENI and CSGENPT are used to generate test 
C  data on the globe.  The data generated will have approximately 
C  "MLOW" lows and "MHGH" highs within each of the twenty areas 
C  defined by an inscribed icosahedron, a minimum value of 
C  approximately "DLOW" and a maximum value of approximately 
C  "DHGH".  CRGENI is called to initialize the process and the 
C  function CRGENPNT returns a computed functional value at the 
C  point (RLAT,RLON).
C
C  The function used is a sum of exponentials.
C  
C  This code was originally written by David Kennison at NCAR.
C
      COMMON /CSSBD1/R0,R1,R2
      COMMON /CSSCMN/ CMUL(160),NCNT,NLOW,NHGH,RLOW,RHGH,RMIN,RMAX,
     +                XCOC(160),YCOC(160),ZCOC(160)
C
C Define the vertices and faces of an icosahedron.
C
      DIMENSION XCVI(12),YCVI(12),ZCVI(12),IVOF(3,20)
      DIMENSION R0(220),R1(220),R2(220)
      DATA XCVI / .9510565162952 , -.9510565162951 ,  .4253254041760 ,
     +           -.4253254041760 ,  .4253254041760 , -.4253254041760 ,
     +            .4253254041760 , -.4253254041760 ,  .4253254041760 ,
     +           -.4253254041760 ,  .4253254041760 , -.4253254041760 /
      DATA YCVI / .0000000000000 ,  .0000000000000 ,  .8506508083520 ,
     +           -.8506508083520 ,  .2628655560596 , -.2628655560596 ,
     +           -.6881909602356 ,  .6881909602356 , -.6881909602356 ,
     +            .6881909602356 ,  .2628655560595 , -.2628655560596 /
      DATA ZCVI / .0000000000000 ,  .0000000000000 ,  .0000000000000 ,
     +            .0000000000000 ,  .8090169943749 , -.8090169943749 ,
     +            .5000000000000 , -.5000000000000 , -.5000000000000 ,
     +            .5000000000000 , -.8090169943749 ,  .8090169943749 /
      DATA IVOF / 1, 3, 5  , 1, 5, 7  , 1, 7, 9  ,
     +            1, 9,11  , 1, 3,11  , 3, 8,11  ,
     +            3, 8,10  , 3, 5,10  , 5,10,12  ,
     +            5, 7,12  , 7, 4,12  , 4, 7, 9  ,
     +            4, 6, 9  , 6, 9,11  , 6, 8,11  ,
     +            6, 2, 8  , 2, 4, 6  , 2, 4,12  ,
     +            2,10,12  , 2, 8,10  /
      DATA DTOR / .017453292519943 /
      DATA RTOD / 57.2957795130823 /
C
      NLOW = MAX(0,MIN(4,MLOW))
      NHGH = MAX(0,MIN(4,MHGH))
      IF (NLOW+NHGH.GE.12 .AND. NLOW.GE.6) NLOW = NLOW-1
      IF (NLOW+NHGH.GE.12 .AND. NHGH.GE.6) NHGH = NHGH-1
      NCNT = 20*(NLOW+NHGH)
C
C  Compute the center positions for the exponentials which are 
C  summed to create the function.
C
      DO 100 K=1,NCNT
        INDX = MOD(K-1,20)+1
        ILOH = (K+19)/20
        WGT1 = R0(K)
        WGT2 = R1(K)
        WGT3 = R2(K)
        WSUM = WGT1+WGT2+WGT3
        WGT1 = WGT1/WSUM
        WGT2 = WGT2/WSUM
        WGT3 = WGT3/WSUM
        XTMP = WGT1*XCVI(IVOF(1,INDX))+
     +         WGT2*XCVI(IVOF(2,INDX))+
     +         WGT3*XCVI(IVOF(3,INDX))
        YTMP = WGT1*YCVI(IVOF(1,INDX))+
     +         WGT2*YCVI(IVOF(2,INDX))+
     +         WGT3*YCVI(IVOF(3,INDX))
        ZTMP = WGT1*ZCVI(IVOF(1,INDX))+
     +         WGT2*ZCVI(IVOF(2,INDX))+
     +         WGT3*ZCVI(IVOF(3,INDX))
        TEMP = SQRT(XTMP*XTMP+YTMP*YTMP+ZTMP*ZTMP)
        XCOC(K) = XTMP/TEMP
        YCOC(K) = YTMP/TEMP
        ZCOC(K) = ZTMP/TEMP
        IF (.NOT.(ILOH .LE. NLOW)) GO TO 110
        CMUL(K) = -1.
        GO TO 120
  110   CONTINUE
        CMUL(K) = +1.
  120   CONTINUE
  100 CONTINUE
C
      RLOW = DLOW
      RHGH = DHGH
      RMIN = +1.E36
      RMAX = -1.E36
      DO 130 I=-180,175,5
        RLON = DTOR*REAL(I)
        CRLN = COS(RLON)
        SRLN = SIN(RLON)
        DO 140 J=-85,85,5
          RLAT = DTOR*REAL(J)
          CRLT = COS(RLAT)
          SRLT = SIN(RLAT)
          RVAL = 0.5*(RLOW+RHGH)
          DO 150 K=1,NCNT
            DIST = SQRT((CRLT*CRLN-XCOC(K))**2
     +                 +(CRLT*SRLN-YCOC(K))**2
     +                 +(SRLT     -ZCOC(K))**2)
            ANGL = 2.*RTOD*ASIN(DIST/2.)
            DIST = ANGL/18.
            RVAL = RVAL+.5*(RHGH-RLOW)*CMUL(K)*EXP(-DIST*DIST)
     +                              *(2.-SIN(6.283*DIST)/2.)
  150     CONTINUE
          RMIN = MIN(RMIN,RVAL)
          RMAX = MAX(RMAX,RVAL)
  140   CONTINUE
  130 CONTINUE
        RETURN
      END
      FUNCTION CRGENPNT (RLAT,RLON)
      COMMON /CSSCMN/ CMUL(160),NCNT,NLOW,NHGH,RLOW,RHGH,RMIN,RMAX,
     +                XCOC(160),YCOC(160),ZCOC(160)
      DATA DTOR / .017453292519943 /
      DATA RTOD / 57.2957795130823 /
      DATA PI   /  3.1415926/
C
      TLAT = DTOR*RLAT
      TLON = DTOR*RLON
      CRLT=COS(TLAT)
      CRLN=COS(TLON)
      SRLT=SIN(TLAT)
      SRLN=SIN(TLON)
      RVAL=.5*(RLOW+RHGH)
      DO 100 K=1,NCNT
        DIST = SQRT((CRLT*CRLN-XCOC(K))**2
     +             +(CRLT*SRLN-YCOC(K))**2
     +             +(SRLT     -ZCOC(K))**2)
        ANGL = 2.*RTOD*ASIN(DIST/2.)
        DIST = ANGL/18.
        RVAL = RVAL+.5*(RHGH-RLOW)*CMUL(K)*EXP(-DIST*DIST)
     +                          *(2.-SIN(6.283*DIST)/2.)
  100 CONTINUE
      CRGENPNT = RLOW+(RHGH-RLOW)*(RVAL-RMIN)/(RMAX-RMIN)
C
      RETURN
      END
      BLOCKDATA CSSCCBD
C
      COMMON /CSSBD1/R0,R1,R2
      DIMENSION R0(220),R1(220),R2(220)
C
      DATA R0/
     + .968,.067,.478,.910,.352,.933,.654,.021,.512,.202,.940,.204,
     + .379,.793,.288,.267,.357,.128,.703,.737,.803,.915,.511,.762,
     + .456,.471,.300,.613,.073,.498,.220,.041,.565,.698,.951,.917,
     + .630,.605,.938,.143,.807,.878,.347,.186,.671,.635,.453,.028,
     + .763,.157,.765,.566,.072,.276,.328,.528,.747,.627,.141,.821,
     + .126,.360,.862,.690,.058,.813,.607,.689,.419,.545,.831,.226,
     + .422,.178,.412,.093,.813,.866,.121,.576,.023,.886,.142,.095,
     + .162,.470,.623,.910,.097,.764,.730,.223,.124,.593,.913,.183,
     + .406,.520,.871,.825,.065,.703,.051,.488,.881,.463,.581,.694,
     + .329,.702,.270,.352,.587,.412,.446,.750,.882,.069,.659,.979,
     + .833,.390,.202,.957,.982,.115,.140,.389,.635,.011,.213,.701,
     + .714,.264,.188,.594,.727,.769,.288,.056,.471,.558,.408,.058,
     + .970,.854,.808,.851,.923,.467,.830,.756,.857,.032,.713,.839,
     + .147,.852,.228,.783,.863,.441,.483,.577,.705,.671,.171,.432,
     + .441,.459,.489,.911,.017,.897,.969,.987,.751,.777,.838,.674,
     + .244,.669,.430,.101,.701,.143,.940,.848,.995,.168,.631,.858,
     + .608,.114,.435,.313,.785,.606,.746,.226,.065,.234,.137,.082,
     + .131,.106,.069,.882,.883,.907,.556,.127,.576,.986,.228,.276,
     + .128,.168,.124,.123/
C
      DATA R1/
     + .023,.003,.880,.088,.237,.017,.170,.368,.123,.239,.250,.006,
     + .146,.806,.134,.722,.791,.361,.998,.920,.529,.122,.043,.864,
     + .877,.025,.808,.746,.442,.065,.400,.464,.068,.280,.552,.305,
     + .297,.722,.673,.420,.961,.923,.426,.107,.729,.560,.829,.520,
     + .921,.827,.440,.451,.950,.483,.315,.827,.508,.123,.573,.949,
     + .188,.973,.414,.256,.253,.966,.561,.550,.689,.234,.970,.650,
     + .157,.396,.757,.885,.956,.587,.405,.877,.414,.845,.328,.363,
     + .328,.643,.190,.836,.766,.763,.786,.954,.737,.199,.211,.990,
     + .165,.772,.540,.854,.006,.510,.504,.163,.906,.261,.048,.862,
     + .848,.454,.740,.262,.299,.068,.625,.627,.711,.815,.464,.477,
     + .579,.249,.431,.315,.449,.642,.305,.614,.414,.845,.468,.420,
     + .355,.972,.582,.261,.234,.631,.123,.082,.084,.863,.343,.383,
     + .930,.968,.011,.641,.784,.474,.118,.362,.723,.549,.678,.172,
     + .191,.983,.786,.605,.828,.254,.024,.183,.226,.607,.444,.460,
     + .237,.567,.541,.322,.430,.885,.705,.361,.853,.715,.002,.637,
     + .190,.119,.999,.913,.668,.677,.085,.859,.660,.871,.464,.488,
     + .124,.489,.671,.350,.095,.115,.810,.333,.683,.351,.654,.113,
     + .236,.359,.473,.089,.075,.475,.726,.264,.594,.725,.177,.263,
     + .402,.262,.122,.062/
C  
      DATA R2/
     + .337,.417,.503,.020,.769,.158,.133,.005,.517,.606,.094,.591,
     + .081,.820,.855,.675,.545,.033,.938,.947,.294,.060,.009,.427,
     + .646,.559,.684,.721,.781,.291,.892,.118,.708,.395,.138,.476,
     + .552,.270,.481,.069,.877,.575,.660,.957,.395,.516,.633,.939,
     + .548,.570,.886,.843,.630,.895,.270,.276,.455,.953,.998,.236,
     + .244,.889,.354,.952,.284,.492,.428,.837,.762,.909,.906,.639,
     + .484,.566,.596,.879,.082,.229,.818,.631,.799,.704,.473,.430,
     + .600,.743,.706,.055,.696,.704,.291,.940,.593,.645,.892,.877,
     + .137,.321,.714,.899,.230,.620,.538,.714,.186,.134,.593,.268,
     + .364,.411,.899,.163,.116,.372,.593,.716,.115,.298,.770,.812,
     + .002,.061,.752,.595,.706,.645,.472,.843,.965,.186,.742,.195,
     + .806,.280,.910,.992,.414,.503,.260,.778,.915,.159,.941,.030,
     + .531,.533,.746,.647,.832,.516,.458,.834,.577,.211,.429,.283,
     + .855,.901,.126,.821,.087,.868,.016,.893,.148,.926,.885,.562,
     + .429,.145,.340,.343,.304,.281,.374,.835,.814,.120,.482,.646,
     + .636,.940,.479,.213,.151,.908,.497,.006,.809,.623,.827,.895,
     + .490,.843,.788,.638,.769,.673,.200,.198,.817,.540,.541,.121,
     + .821,.915,.956,.635,.035,.438,.280,.671,.377,.760,.884,.528,
     + .668,.381,.534,.477/
C
      END  

C NCLFORTSTART
      SUBROUTINE DZPSIDRV(MLON,NLAT,KLEV,V,LAT,P,PS,VMSG,ZMPSI)
      IMPLICIT NONE

c NCL:  zmpsi = zon_mpsi(v,lat,p,ps)
c                                                        INPUT
      INTEGER MLON,NLAT,KLEV
      DOUBLE PRECISION V(MLON,NLAT,KLEV),LAT(NLAT),P(KLEV),
     +                 PS(MLON,NLAT),VMSG
c                                                        OUTPUT
      DOUBLE PRECISION ZMPSI(NLAT,KLEV)
C NCLEND
c                                                        LOCAL
      DOUBLE PRECISION PTMP(2*KLEV+1),DP(2*KLEV+1),VVPROF(2*KLEV+1)
      DOUBLE PRECISION VBAR(NLAT,KLEV),VTMP(MLON,NLAT,KLEV)

      CALL DZONMPSI(MLON,NLAT,KLEV,V,LAT,P,PS,VMSG,ZMPSI,PTMP,DP,VTMP,
     +              VBAR,VVPROF)

      RETURN
      END
c --
      SUBROUTINE DZONMPSI(MLON,NLAT,KLEV,V,LAT,P,PS,VMSG,ZMPSI,PTMP,DP,
     +                    VTMP,VBAR,VVPROF)
      IMPLICIT NONE

      INTEGER MLON,NLAT,KLEV
      DOUBLE PRECISION V(MLON,NLAT,KLEV),LAT(NLAT),P(KLEV),
     +                 PS(MLON,NLAT),VMSG
c                                                        output
      DOUBLE PRECISION ZMPSI(NLAT,KLEV)
c                                             temporary / local
      DOUBLE PRECISION PTMP(0:2*KLEV),DP(0:2*KLEV),VVPROF(0:2*KLEV)
      DOUBLE PRECISION VTMP(MLON,NLAT,KLEV),VBAR(NLAT,KLEV)

      DOUBLE PRECISION PI,G,A,C,RAD,CON,PTOP,PBOT
      INTEGER ML,NL,KL,KNT,KFLAG

      G   = 9.80616D0
      A   = 6.37122D6
      PI  = 4.D0*ATAN(1.D0)
      RAD = PI/180.D0
      CON = 2.D0*PI*A/G

      PTOP = 500.D0
      PBOT = 100500.D0

c calculate press at all levels [even half levels]

      KNT = 0
      DO KL = 1,2*KLEV - 1,2
          KNT = KNT + 1
          PTMP(KL) = P(KNT)
      END DO

      DO KL = 2,2*KLEV - 2,2
          PTMP(KL) = (PTMP(KL+1)+PTMP(KL-1))*0.5D0
      END DO

      PTMP(0) = PTOP
      PTMP(2*KLEV) = PBOT

c dp at all levels

      DP(0) = 0.D0
      DO KL = 1,2*KLEV - 1
          DP(KL) = PTMP(KL+1) - PTMP(KL-1)
      END DO
      DP(2*KLEV) = 0.D0

c make copy; set any p > ps to msg

      KNT = 0
      DO ML = 1,MLON
          DO NL = 1,NLAT
              DO KL = 1,KLEV
                  IF (P(KL).GT.PS(ML,NL)) THEN
                      KNT = KNT + 1
                      VTMP(ML,NL,KL) = VMSG
                  ELSE
                      VTMP(ML,NL,KL) = V(ML,NL,KL)
                  END IF
              END DO
          END DO
      END DO

c compute zonal mean v using the vtmp variable

      DO NL = 1,NLAT
          DO KL = 1,KLEV
              KNT = 0
              VBAR(NL,KL) = 0.0D0
              DO ML = 1,MLON
                  IF (VTMP(ML,NL,KL).NE.VMSG) THEN
                      KNT = KNT + 1
                      VBAR(NL,KL) = VBAR(NL,KL) + VTMP(ML,NL,KL)
                  END IF
              END DO
              IF (KNT.GT.0) THEN
                  VBAR(NL,KL) = VBAR(NL,KL)/DBLE(KNT)
              ELSE
                  VBAR(NL,KL) = VMSG
              END IF
          END DO
      END DO

c compute mpsi at each latitude [reuse ptmp]

      DO NL = 1,NLAT
          C = CON*COS(LAT(NL)*RAD)

          PTMP(0) = 0.0D0
          DO KL = 1,2*KLEV
              PTMP(KL) = VMSG
          END DO

          DO KL = 0,2*KLEV,2
              VVPROF(KL) = 0.0D0
          END DO

          KNT = 0
          DO KL = 1,2*KLEV - 1,2
              KNT = KNT + 1
              VVPROF(KL) = VBAR(NL,KNT)
          END DO

c integrate from top of atmosphere down for each level where vbar
c is not missing

          DO KL = 1,2*KLEV - 1,2
              KFLAG = KL
              IF (VVPROF(KL).EQ.VMSG) GO TO 10
              PTMP(KL+1) = PTMP(KL-1) - C*VVPROF(KL)*DP(KL)
          END DO
   10     CONTINUE

c impose lower boundary condition to ensure the zmpsi is 0
c at the bottom boundary

          PTMP(KFLAG+1) = -PTMP(KFLAG-1)

c streamfunction is obtained as average from its' values
c at the intermediate half levels. The minus sign before
c PTMP in the last loop is to conform to a CSM convention.

          DO KL = 1,KFLAG,2
              PTMP(KL) = (PTMP(KL+1)+PTMP(KL-1))*0.5D0
          END DO

          KNT = 0
          DO KL = 1,2*KLEV - 1,2
              KNT = KNT + 1
              IF(PTMP(KL).NE.VMSG) THEN
                 ZMPSI(NL,KNT) = -PTMP(KL)
              ELSE
                 ZMPSI(NL,KNT) = PTMP(KL)
              END IF
          END DO
      END DO

      RETURN
      END

C
C $Id: pcgetr.f,v 1.16 2008-07-27 00:17:19 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE PCGETR (WHCH,RVAL)
C
      CHARACTER*(*) WHCH
C
C The subroutine PCGETR may be used to get PLCHHQ parameters which have
C values of type REAL.
C
C COMMON block declarations.
C
      COMMON /PCPRMS/ ADDS,CONS,DSTB,DSTL,DSTR,DSTT,HPIC(3),IBNU,
     +                IBXC(3),IBXF,ICEN,IORD,IOUC,IOUF,IPCC,IQUF,
     +                ISHC,ISHF,ITEF,JCOD,LSCI(16),NFCC,NODF,RBXL,
     +                RBXM,RBXX,RBXY,ROLW,RPLW,RSLW,SHDX,SHDY,SIZA,
     +                SSIC,SSPR,SUBS,VPIC(3),WPIC(3),XBEG,XCEN,XEND,
     +                XMUL(3),YBEG,YCEN,YEND,YMUL(3),ZINX,ZINY,ZINZ
      SAVE   /PCPRMS/
C
      COMMON /PCPFLQ/ IMAP,OORV,RHTW
      SAVE   /PCPFLQ/
C
C Do a call forcing a BLOCKDATA to be loaded from a binary library.
C
      CALL PCBLDA
C
C Check for an uncleared prior error.
C
      IF (ICFELL('PCGETR - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C Get the selected parameter.
C
      IF      (WHCH(1:2).EQ.'AS'.OR.WHCH(1:2).EQ.'as') THEN
        RVAL=ADDS
      ELSE IF (WHCH(1:2).EQ.'BC'.OR.WHCH(1:2).EQ.'bc') THEN
        CALL PCGPAI (WHCH,3,IPAI)
        IF (IPAI.EQ.0) THEN
          RVAL=REAL(IBXC(1))
        ELSE IF (IPAI.GE.1.AND.IPAI.LE.3) THEN
          RVAL=REAL(IBXC(IPAI))
        ELSE
          CALL SETER ('PCGETR - BOX COLOR ARRAY INDEX IS OUT OF RANGE',
     +                                                             2,1)
          RETURN
        END IF
      ELSE IF (WHCH(1:2).EQ.'BF'.OR.WHCH(1:2).EQ.'bf') THEN
        RVAL=REAL(IBXF)
      ELSE IF (WHCH(1:2).EQ.'BL'.OR.WHCH(1:2).EQ.'bl') THEN
        RVAL=RBXL
      ELSE IF (WHCH(1:2).EQ.'BM'.OR.WHCH(1:2).EQ.'bm') THEN
        RVAL=RBXM
      ELSE IF (WHCH(1:2).EQ.'BX'.OR.WHCH(1:2).EQ.'bx') THEN
        RVAL=RBXX
      ELSE IF (WHCH(1:2).EQ.'BY'.OR.WHCH(1:2).EQ.'by') THEN
        RVAL=RBXY
      ELSE IF (WHCH(1:2).EQ.'CC'.OR.WHCH(1:2).EQ.'cc') THEN
        CALL PCGPAI (WHCH,3,IPAI)
        IF (IPAI.EQ.0) THEN
          RVAL=REAL(IPCC)
        ELSE IF (IPAI.GE.1.AND.IPAI.LE.16) THEN
          RVAL=REAL(LSCI(IPAI))
        ELSE
          CALL SETER ('PCGETR - COLOR ARRAY INDEX IS OUT OF RANGE',3,1)
          RETURN
        END IF
      ELSE IF (WHCH(1:2).EQ.'CD'.OR.WHCH(1:2).EQ.'cd') THEN
        RVAL=REAL(JCOD)
      ELSE IF (WHCH(1:2).EQ.'CE'.OR.WHCH(1:2).EQ.'ce') THEN
        RVAL=REAL(ICEN)
      ELSE IF (WHCH(1:2).EQ.'CH'.OR.WHCH(1:2).EQ.'ch') THEN
        RVAL=HPIC(3)
      ELSE IF (WHCH(1:2).EQ.'CL'.OR.WHCH(1:2).EQ.'cl') THEN
        RVAL=RPLW
      ELSE IF (WHCH(1:2).EQ.'CS'.OR.WHCH(1:2).EQ.'cs') THEN
        RVAL=2.*CONS
      ELSE IF (WHCH(1:2).EQ.'CV'.OR.WHCH(1:2).EQ.'cv') THEN
        RVAL=VPIC(3)
      ELSE IF (WHCH(1:2).EQ.'CW'.OR.WHCH(1:2).EQ.'cw') THEN
        RVAL=WPIC(3)
      ELSE IF (WHCH(1:2).EQ.'DB'.OR.WHCH(1:2).EQ.'db') THEN
        RVAL=DSTB
      ELSE IF (WHCH(1:2).EQ.'DL'.OR.WHCH(1:2).EQ.'dl') THEN
        RVAL=DSTL
      ELSE IF (WHCH(1:2).EQ.'DO'.OR.WHCH(1:2).EQ.'do') THEN
        RVAL=REAL(IORD)
      ELSE IF (WHCH(1:2).EQ.'DR'.OR.WHCH(1:2).EQ.'dr') THEN
        RVAL=DSTR
      ELSE IF (WHCH(1:2).EQ.'DT'.OR.WHCH(1:2).EQ.'dt') THEN
        RVAL=DSTT
      ELSE IF (WHCH(1:2).EQ.'FB'.OR.WHCH(1:2).EQ.'fb') THEN
        CALL BCGETR ('FTL',RVAL)
      ELSE IF (WHCH(1:2).EQ.'FN'.OR.WHCH(1:2).EQ.'fn') THEN
        RVAL=REAL(NODF)
      ELSE IF (WHCH(1:2).EQ.'HW'.OR.WHCH(1:2).EQ.'hw') THEN
        RVAL=RHTW
      ELSE IF (WHCH(1:2).EQ.'IH'.OR.WHCH(1:2).EQ.'ih') THEN
        RVAL=HPIC(2)
      ELSE IF (WHCH(1:2).EQ.'IS'.OR.WHCH(1:2).EQ.'is') THEN
        RVAL=SSIC
      ELSE IF (WHCH(1:2).EQ.'IV'.OR.WHCH(1:2).EQ.'iv') THEN
        RVAL=VPIC(2)
      ELSE IF (WHCH(1:2).EQ.'IW'.OR.WHCH(1:2).EQ.'iw') THEN
        RVAL=WPIC(2)
      ELSE IF (WHCH(1:2).EQ.'MA'.OR.WHCH(1:2).EQ.'ma') THEN
        RVAL=REAL(IMAP)
      ELSE IF (WHCH(1:2).EQ.'OC'.OR.WHCH(1:2).EQ.'oc') THEN
        RVAL=REAL(IOUC)
      ELSE IF (WHCH(1:2).EQ.'OF'.OR.WHCH(1:2).EQ.'of') THEN
        RVAL=REAL(IOUF)
      ELSE IF (WHCH(1:2).EQ.'OL'.OR.WHCH(1:2).EQ.'ol') THEN
        RVAL=ROLW
      ELSE IF (WHCH(1:2).EQ.'OR'.OR.WHCH(1:2).EQ.'or') THEN
        RVAL=OORV
      ELSE IF (WHCH(1:2).EQ.'PH'.OR.WHCH(1:2).EQ.'ph') THEN
        RVAL=HPIC(1)
      ELSE IF (WHCH(1:2).EQ.'PS'.OR.WHCH(1:2).EQ.'ps') THEN
        RVAL=SSPR
      ELSE IF (WHCH(1:2).EQ.'PV'.OR.WHCH(1:2).EQ.'pv') THEN
        RVAL=VPIC(1)
      ELSE IF (WHCH(1:2).EQ.'PW'.OR.WHCH(1:2).EQ.'pw') THEN
        RVAL=WPIC(1)
      ELSE IF (WHCH(1:2).EQ.'QU'.OR.WHCH(1:2).EQ.'qu') THEN
        RVAL=REAL(IQUF)
      ELSE IF (WHCH(1:2).EQ.'SA'.OR.WHCH(1:2).EQ.'sa') THEN
        RVAL=SIZA
      ELSE IF (WHCH(1:2).EQ.'SC'.OR.WHCH(1:2).EQ.'sc') THEN
        RVAL=REAL(ISHC)
      ELSE IF (WHCH(1:2).EQ.'SF'.OR.WHCH(1:2).EQ.'sf') THEN
        RVAL=REAL(ISHF)
      ELSE IF (WHCH(1:2).EQ.'SL'.OR.WHCH(1:2).EQ.'sl') THEN
        RVAL=RSLW
      ELSE IF (WHCH(1:2).EQ.'SS'.OR.WHCH(1:2).EQ.'ss') THEN
        RVAL=SUBS
      ELSE IF (WHCH(1:2).EQ.'SX'.OR.WHCH(1:2).EQ.'sx') THEN
        RVAL=SHDX
      ELSE IF (WHCH(1:2).EQ.'SY'.OR.WHCH(1:2).EQ.'sy') THEN
        RVAL=SHDY
      ELSE IF (WHCH(1:2).EQ.'TE'.OR.WHCH(1:2).EQ.'te') THEN
        RVAL=REAL(ITEF)
      ELSE IF (WHCH(1:2).EQ.'UN'.OR.WHCH(1:2).EQ.'un') THEN
        RVAL=REAL(IBNU)
      ELSE IF (WHCH(1:2).EQ.'XB'.OR.WHCH(1:2).EQ.'xb') THEN
        RVAL=XBEG
      ELSE IF (WHCH(1:2).EQ.'XC'.OR.WHCH(1:2).EQ.'xc') THEN
        RVAL=XCEN
      ELSE IF (WHCH(1:2).EQ.'XE'.OR.WHCH(1:2).EQ.'xe') THEN
        RVAL=XEND
      ELSE IF (WHCH(1:2).EQ.'YB'.OR.WHCH(1:2).EQ.'yb') THEN
        RVAL=YBEG
      ELSE IF (WHCH(1:2).EQ.'YC'.OR.WHCH(1:2).EQ.'yc') THEN
        RVAL=YCEN
      ELSE IF (WHCH(1:2).EQ.'YE'.OR.WHCH(1:2).EQ.'ye') THEN
        RVAL=YEND
      ELSE IF (WHCH(1:2).EQ.'ZX'.OR.WHCH(1:2).EQ.'zx') THEN
        RVAL=ZINX
      ELSE IF (WHCH(1:2).EQ.'ZY'.OR.WHCH(1:2).EQ.'zy') THEN
        RVAL=ZINY
      ELSE IF (WHCH(1:2).EQ.'ZZ'.OR.WHCH(1:2).EQ.'zz') THEN
        RVAL=ZINZ
      ELSE
        CALL SETER ('PCGETR - UNRECOGNIZED PARAMETER NAME',4,1)
        RETURN
      END IF
C
C Done.
C
      RETURN
C
      END

c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by UCAR                 .
c  .                                                             .
c  .       University Corporation for Atmospheric Research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                         SPHEREPACK                          .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c
c
C*PL*ERROR* Comment line too long
c ... file vshifte.f contains code and documentation for subroutine vshifte
c     and its initialization subroutine vshifti
c
c ... required files
c
c     hrfft.f
c
c     subroutine vshifte(ioff,nlon,nlat,uoff,voff,ureg,vreg,
c    +                   wsave,lsave,work,lwork,ierror)
c
c *** purpose
c
c     subroutine vshifte does a highly accurate 1/2 grid increment shift
C*PL*ERROR* Comment line too long
c     in both longitude and latitude of equally spaced vector data on the
c     sphere. data is transferred between the nlon by nlat "offset grid"
C*PL*ERROR* Comment line too long
c     in (uoff,voff) (which excludes poles) and the nlon by nlat+1 "regular
C*PL*ERROR* Comment line too long
c     grid" in (ureg,vreg) (which includes poles).  the transfer can go from
C*PL*ERROR* Comment line too long
c     (uoff,voff) to (ureg,vreg) or vice versa (see ioff).  the grids which
C*PL*ERROR* Comment line too long
c     underly the vector fields are described below.  the north and south
C*PL*ERROR* Comment line too long
c     pole are at 0.5*pi and-0.5*pi radians respectively (pi=4.*atan(1.)).
C*PL*ERROR* Comment line too long
c     uoff and ureg are the east longitudinal vector data components.  voff
c     and vreg are the latitudinal vector data components.
c
c     subroutine sshifte can be used to shift scalar data on the sphere.
C*PL*ERROR* Comment line too long
c     notice that scalar and vector quantities are fundamentally different
C*PL*ERROR* Comment line too long
c     on the sphere.  for example, vectors are discontinuous and multiple
C*PL*ERROR* Comment line too long
c     valued at the poles.  scalars are continuous and single valued at the
C*PL*ERROR* Comment line too long
c     poles. erroneous results would be produced if one attempted to shift
c     vector fields with subroutine sshifte applied to each component of
c     of the vector.
c
c *** grid descriptions
c
c     let dlon = (pi+pi)/nlon and dlat = pi/nlat be the uniform grid
c     increments in longitude and latitude
c
c     offset grid
c
C*PL*ERROR* Comment line too long
c     the "1/2 increment offset" grid (long(j),lat(i)) on which uoff(j,i)
c     and voff(j,i) are given (ioff=0) or generated (ioff=1) is
c
c          long(j) =0.5*dlon + (j-1)*dlon  (j=1,...,nlon)
c
c     and
c
c          lat(i) = -0.5*pi + 0.5*dlat + (i-1)*dlat (i=1,...,nlat)
c
C*PL*ERROR* Comment line too long
c     the data in (uoff,voff) is "shifted" one half a grid increment in both
C*PL*ERROR* Comment line too long
c     longitude and latitude and excludes the poles.  each uoff(j,1),voff(j,1)
c     is given at latitude -pi/2+dlat/2.  uoff(j,nlat),voff(j,nlat) is
c     given at pi/2-dlat/2 (1/2 a grid increment away from the poles).
C*PL*ERROR* Comment line too long
c     uoff(1,i),voff(1,i) is given at longitude dlon/2.  each uoff(nlon,i),
c     voff(nlon,i) is given at longitude 2*pi-dlon/2.
c
c     regular grid
c
c     let dlat,dlon be as above.  then the nlon by nlat+1 grid on which
c     ureg(j,i),vreg(j,i) are generated (ioff=0) or given (ioff=1) is
c
c          lone(j) = (j-1)*dlon (j=1,...,nlon)
c
c      and
c
c          late(i) = -0.5*pi + (i-1)*dlat (i=1,...,nlat+1)
c
c     values in ureg,vreg include the poles and start at zero degrees
c     longitude and at the south pole this is the "usual" equally spaced
c     grid in geophysical coordinates.
c
c *** remark
c
C*PL*ERROR* Comment line too long
c     subroutine vshifte can be used in conjunction with subroutine trvsph
C*PL*ERROR* Comment line too long
c     when transferring vector data from an equally spaced "1/2 increment
C*PL*ERROR* Comment line too long
c     offset" grid to a gaussian or equally spaced grid (which includes poles)
C*PL*ERROR* Comment line too long
c     of any resolution.  this problem (personal communication with dennis
c     shea) is encountered in geophysical modeling and data analysis.
c
c *** method
c
c     fast fourier transform software from spherepack2 and trigonometric
c     identities are used to accurately "shift" periodic vectors half a
c     grid increment in latitude and longitude.  latitudinal shifts are
C*PL*ERROR* Comment line too long
c     accomplished by setting periodic 2*nlat vectors over the pole for each
c     longitude.  vector values must be negated on one side of the pole
c     to maintain periodicity prior to the 2*nlat shift over the poles.
C*PL*ERROR* Comment line too long
c     when nlon is odd, the 2*nlat latitudinal shift requires an additional
C*PL*ERROR* Comment line too long
c     longitude shift to obtain symmetry necessary for full circle shifts
c     over the poles.  finally longitudinal shifts are executed for each
c     shifted latitude.
c
c *** argument description
c
c ... ioff
c
c     ioff = 0 if values on the offset grid in (uoff,voff) are given and
C*PL*ERROR* Comment line too long
c              values on the regular grid in (ureg,vreg) are to be generated.
c
C*PL*ERROR* Comment line too long
c     ioff = 1 if values on the regular grid in (ureg,vreg) are given and
C*PL*ERROR* Comment line too long
c              values on the offset grid in (uoff,voff) are to be generated.
c
c ... nlon
c
c     the number of longitude points on both the "offset" and "regular"
c     uniform grid in longitude (see "grid description" above).  nlon
C*PL*ERROR* Comment line too long
c     is also the first dimension of uoff,voff,ureg,vreg.  nlon determines
C*PL*ERROR* Comment line too long
c     the grid increment in longitude as dlon = 2.*pi/nlon.  for example,
C*PL*ERROR* Comment line too long
c     nlon = 144 for a 2.5 degree grid.  nlon can be even or odd and must
c     be greater than or equal to 4.  the efficiency of the computation
c     is improved when nlon is a product of small primes.
c
c ... nlat
c
C*PL*ERROR* Comment line too long
c     the number of latitude points on the "offset" uniform grid.  nlat+1
C*PL*ERROR* Comment line too long
c     is the number of latitude points on the "regular" uniform grid (see
C*PL*ERROR* Comment line too long
c     "grid description" above).  nlat is the second dimension of uoff,voff.
c     nlat+1 must be the second dimension of ureg,vreg in the program
c     calling vshifte.  nlat determines the grid in latitude as pi/nlat.
C*PL*ERROR* Comment line too long
c     for example, nlat = 36 for a five degree grid.  nlat must be at least 3.
c
c ... uoff
c
c     a nlon by nlat array that contains the east longitudinal vector
c     data component on the offset grid described above.  uoff is a
c     given input argument if ioff=0.  uoff is a generated output
c     argument if ioff=1.
c
c ... voff
c
c     a nlon by nlat array that contains the latitudinal vector data
c     component on the offset grid described above.  voff is a given
c     input argument if ioff=0.  voff is a generated output argument
c     if ioff=1.
c
c ... ureg
c
c     a nlon by nlat+1 array that contains the east longitudinal vector
C*PL*ERROR* Comment line too long
c     data component on the regular grid described above.  ureg is a given
c     input argument if ioff=1.  ureg is a generated output argument
c     if ioff=0.
c
c ... vreg
c
c     a nlon by nlat+1 array that contains the latitudinal vector data
c     component on the regular grid described above.  vreg is a given
c     input argument if ioff=1.  vreg is a generated output argument
c     if ioff=0.
c
c ... wsav
c
c     a real saved work space array that must be initialized by calling
C*PL*ERROR* Comment line too long
c     subroutine vshifti(ioff,nlon,nlat,wsav,ier) before calling vshifte.
c     wsav can then be used repeatedly by vshifte as long as ioff, nlon,
c     and nlat do not change.  this bypasses redundant computations and
c     saves time.  undetectable errors will result if vshifte is called
c     without initializing wsav whenever ioff, nlon, or nlat change.
c
c ... lsav
c
C*PL*ERROR* Comment line too long
c     the length of the saved work space wsav in the routine calling vshifte
C*PL*ERROR* Comment line too long
c     and sshifti.  lsave must be greater than or equal to 2*(2*nlat+nlon+16).
c
c ... work
c
c     a real unsaved work space
c
c ... lwork
c
C*PL*ERROR* Comment line too long
c     the length of the unsaved work space in the routine calling vshifte
c     if nlon is even then lwork must be greater than or equal to
c
c          2*nlon*(nlat+1)
c
c     if nlon is odd then lwork must be greater than or equal to
c
c          nlon*(5*nlat+1)
c
c ... ier
c
c     indicates errors in input parameters
c
c     = 0 if no errors are detected
c
c     = 1 if ioff is not equal to 0 or 1
c
c     = 2 if nlon < 4
c
c     = 3 if nlat < 3
c
c     = 4 if lsave < 2*(nlon+2*nlat)+32
c
c     = 5 if lwork < 2*nlon*(nlat+1) for nlon even or
c            lwork < nlon*(5*nlat+1) for nlon odd
c
c *** end of vshifte documentation
c
c     subroutine vshifti(ioff,nlon,nlat,lsav,wsav,ier)
c
c     subroutine vshifti initializes the saved work space wsav
c     for ioff and nlon and nlat (see documentation for vshifte).
c     vshifti must be called before vshifte whenever ioff or nlon
c     or nlat change.
c
c ... ier
c
c     = 0 if no errors with input arguments
c
c     = 1 if ioff is not 0 or 1
c
c     = 2 if nlon < 4
c
c     = 3 if nlat < 3
c
c     = 4 if lsav < 2*(2*nlat+nlon+16)
c
c *** end of vshifti documentation
c
      SUBROUTINE DVSHIFTE(IOFF,NLON,NLAT,UOFF,VOFF,UREG,VREG,WSAV,LSAV,
     +                   WRK,LWRK,IER)
      IMPLICIT NONE
      INTEGER IOFF,NLON,NLAT,N2,NR,NLAT2,NLATP1,LSAV,LWRK,IER
      INTEGER I1,I2,I3
      DOUBLE PRECISION UOFF(NLON,NLAT),VOFF(NLON,NLAT)
      DOUBLE PRECISION UREG(NLON,*),VREG(NLON,*)
      DOUBLE PRECISION WSAV(LSAV),WRK(LWRK)
c
c     check input parameters
c
      IER = 1
      IF (IOFF* (IOFF-1).NE.0) RETURN
      IER = 2
      IF (NLON.LT.4) RETURN
      IER = 3
      IF (NLAT.LT.3) RETURN
      IER = 4
      IF (LSAV.LT.2* (2*NLAT+NLON+16)) RETURN
      NLAT2 = NLAT + NLAT
      NLATP1 = NLAT + 1
      N2 = (NLON+1)/2
      IER = 5
      IF (2*N2.EQ.NLON) THEN
          IF (LWRK.LT.2*NLON* (NLAT+1)) RETURN
          NR = N2
          I1 = 1
          I2 = 1
          I3 = I2 + NLON*NLATP1
      ELSE
          IF (LWRK.LT.NLON* (5*NLAT+1)) RETURN
          NR = NLON
          I1 = 1
          I2 = I1 + NLAT2*NLON
          I3 = I2 + NLATP1*NLON
      END IF
      IER = 0
      IF (IOFF.EQ.0) THEN
c
c     shift (uoff,voff) to (ureg,vreg)
c
          CALL DVHFTOFF(NLON,NLAT,UOFF,UREG,WSAV,NR,NLAT2,NLATP1,
     +                  WRK(I1),WRK(I2),WRK(I2),WRK(I3))
          CALL DVHFTOFF(NLON,NLAT,VOFF,VREG,WSAV,NR,NLAT2,NLATP1,
     +                  WRK(I1),WRK(I2),WRK(I2),WRK(I3))
      ELSE
c
c     shift (ureg,vreg) to (uoff,voff)
c
          CALL DVHFTREG(NLON,NLAT,UOFF,UREG,WSAV,NR,NLAT2,NLATP1,
     +                  WRK(I1),WRK(I2),WRK(I2),WRK(I3))
          CALL DVHFTREG(NLON,NLAT,VOFF,VREG,WSAV,NR,NLAT2,NLATP1,
     +                  WRK(I1),WRK(I2),WRK(I2),WRK(I3))
      END IF
      END

      SUBROUTINE DVHFTOFF(NLON,NLAT,UOFF,UREG,WSAV,NR,NLAT2,NLATP1,
     +                   RLATU,RLONU,RLOU,WRK)
c
c     generate ureg from uoff (a vector component!)
c
      IMPLICIT NONE
      INTEGER NLON,NLAT,NLAT2,NLATP1,N2,NR,J,I,JS,ISAV
      DOUBLE PRECISION UOFF(NLON,NLAT),UREG(NLON,NLATP1)
      DOUBLE PRECISION RLATU(NR,NLAT2),RLONU(NLATP1,NLON),
     +                 RLOU(NLAT,NLON)
      DOUBLE PRECISION WSAV(*),WRK(*)

      ISAV = 4*NLAT + 17
      N2 = (NLON+1)/2
c
c     execute full circle latitude shifts for nlon odd or even
c
      IF (2*N2.GT.NLON) THEN
c
c     odd number of longitudes
c
          DO I = 1,NLAT
              DO J = 1,NLON
                  RLOU(I,J) = UOFF(J,I)
              END DO
          END DO
c
c       half shift in longitude
c
          CALL DVHIFTH(NLAT,NLON,RLOU,WSAV(ISAV),WRK)
c
c       set full 2*nlat circles in rlatu using shifted values in rlonu
c
          DO J = 1,N2 - 1
              JS = J + N2
              DO I = 1,NLAT
                  RLATU(J,I) = UOFF(J,I)
                  RLATU(J,NLAT+I) = -RLOU(NLAT+1-I,JS)
              END DO
          END DO
          DO J = N2,NLON
              JS = J - N2 + 1
              DO I = 1,NLAT
                  RLATU(J,I) = UOFF(J,I)
                  RLATU(J,NLAT+I) = -RLOU(NLAT+1-I,JS)
              END DO
          END DO
c
c       shift the nlon rlat vectors one half latitude grid
c
          CALL DVHIFTH(NLON,NLAT2,RLATU,WSAV,WRK)
c
c       set in ureg
c
          DO J = 1,NLON
              DO I = 1,NLAT + 1
                  UREG(J,I) = RLATU(J,I)
              END DO
          END DO
      ELSE
c
c     even number of longitudes (no initial longitude shift necessary)
C*PL*ERROR* Comment line too long
c     set full 2*nlat circles (over poles) for each longitude pair (j,js)
c     negating js vector side for periodicity
c
          DO J = 1,N2
              JS = N2 + J
              DO I = 1,NLAT
                  RLATU(J,I) = UOFF(J,I)
                  RLATU(J,NLAT+I) = -UOFF(JS,NLATP1-I)
              END DO
          END DO
c
c       shift the n2=(nlon+1)/2 rlat vectors one half latitude grid
c
          CALL DVHIFTH(N2,NLAT2,RLATU,WSAV,WRK)
c
c       set ureg,vreg shifted in latitude
c
          DO J = 1,N2
              JS = N2 + J
              UREG(J,1) = RLATU(J,1)
              UREG(JS,1) = -RLATU(J,1)
              DO I = 2,NLATP1
                  UREG(J,I) = RLATU(J,I)
                  UREG(JS,I) = -RLATU(J,NLAT2-I+2)
              END DO
          END DO
      END IF
c
c     execute full circle longitude shift
c
      DO J = 1,NLON
          DO I = 1,NLATP1
              RLONU(I,J) = UREG(J,I)
          END DO
      END DO
      CALL DVHIFTH(NLATP1,NLON,RLONU,WSAV(ISAV),WRK)
      DO J = 1,NLON
          DO I = 1,NLATP1
              UREG(J,I) = RLONU(I,J)
          END DO
      END DO
      END

      SUBROUTINE DVHFTREG(NLON,NLAT,UOFF,UREG,WSAV,NR,NLAT2,NLATP1,
     +                   RLATU,RLONU,RLOU,WRK)
c
c     generate uoff vector component from ureg
c
      IMPLICIT NONE
      INTEGER NLON,NLAT,NLAT2,NLATP1,N2,NR,J,I,JS,ISAV
      DOUBLE PRECISION UOFF(NLON,NLAT),UREG(NLON,NLATP1)
      DOUBLE PRECISION RLATU(NR,NLAT2),RLONU(NLATP1,NLON),
     +                 RLOU(NLAT,NLON)
      DOUBLE PRECISION WSAV(*),WRK(*)

      ISAV = 4*NLAT + 17
      N2 = (NLON+1)/2
c
c     execute full circle latitude shifts for nlon odd or even
c
      IF (2*N2.GT.NLON) THEN
c
c     odd number of longitudes
c
          DO I = 1,NLATP1
              DO J = 1,NLON
                  RLONU(I,J) = UREG(J,I)
              END DO
          END DO
c
c       half shift in longitude in rlon
c
          CALL DVHIFTH(NLATP1,NLON,RLONU,WSAV(ISAV),WRK)
c
c       set full 2*nlat circles in rlat using shifted values in rlon
c
          DO J = 1,N2
              JS = J + N2 - 1
              RLATU(J,1) = UREG(J,1)
              DO I = 2,NLAT
                  RLATU(J,I) = UREG(J,I)
                  RLATU(J,NLAT+I) = -RLONU(NLAT+2-I,JS)
              END DO
              RLATU(J,NLAT+1) = UREG(J,NLAT+1)
          END DO
          DO J = N2 + 1,NLON
              JS = J - N2
              RLATU(J,1) = UREG(J,1)
              DO I = 2,NLAT
                  RLATU(J,I) = UREG(J,I)
                  RLATU(J,NLAT+I) = -RLONU(NLAT+2-I,JS)
              END DO
              RLATU(J,NLAT+1) = UREG(J,NLAT+1)
          END DO
c
c       shift the nlon rlat vectors one halflatitude grid
c
          CALL DVHIFTH(NLON,NLAT2,RLATU,WSAV,WRK)
c
c       set values in uoff
c
          DO J = 1,NLON
              DO I = 1,NLAT
                  UOFF(J,I) = RLATU(J,I)
              END DO
          END DO
      ELSE
c
c     even number of longitudes (no initial longitude shift necessary)
C*PL*ERROR* Comment line too long
c     set full 2*nlat circles (over poles) for each longitude pair (j,js)
c
          DO J = 1,N2
              JS = N2 + J
              RLATU(J,1) = UREG(J,1)
              DO I = 2,NLAT
                  RLATU(J,I) = UREG(J,I)
                  RLATU(J,NLAT+I) = -UREG(JS,NLAT+2-I)
              END DO
              RLATU(J,NLAT+1) = UREG(J,NLAT+1)
          END DO
c
c       shift the n2=(nlon+1)/2 rlat vectors one half latitude grid
c
          CALL DVHIFTH(N2,NLAT2,RLATU,WSAV,WRK)
c
c       set values in uoff
c
          DO J = 1,N2
              JS = N2 + J
              DO I = 1,NLAT
                  UOFF(J,I) = RLATU(J,I)
                  UOFF(JS,I) = -RLATU(J,NLAT2+1-I)
              END DO
          END DO
      END IF
c
c     execute full circle longitude shift for all latitude circles
c
      DO J = 1,NLON
          DO I = 1,NLAT
              RLOU(I,J) = UOFF(J,I)
          END DO
      END DO
      CALL DVHIFTH(NLAT,NLON,RLOU,WSAV(ISAV),WRK)
      DO J = 1,NLON
          DO I = 1,NLAT
              UOFF(J,I) = RLOU(I,J)
          END DO
      END DO
      END

      SUBROUTINE DVSHIFTI(IOFF,NLON,NLAT,LSAV,WSAV,IER)
c
c     initialize wsav for vshifte
c
      INTEGER IOFF,NLAT,NLON,NLAT2,ISAV,IER
      DOUBLE PRECISION WSAV(LSAV)
      DOUBLE PRECISION PI,DLAT,DLON,DP

      IER = 1
      IF (IOFF* (IOFF-1).NE.0) RETURN
      IER = 2
      IF (NLON.LT.4) RETURN
      IER = 3
      IF (NLAT.LT.3) RETURN
      IER = 4
      IF (LSAV.LT.2* (2*NLAT+NLON+16)) RETURN
      IER = 0
      PI = 4.0D0*ATAN(1.0D0)
c
c     set lat,long increments
c
      DLAT = PI/NLAT
      DLON = (PI+PI)/NLON
c
c     set left or right latitude shifts
c
      IF (IOFF.EQ.0) THEN
          DP = -0.5D0*DLAT
      ELSE
          DP = 0.5D0*DLAT
      END IF
      NLAT2 = NLAT + NLAT
      CALL DVHIFTHI(NLAT2,DP,WSAV)
c
c     set left or right longitude shifts
c
      IF (IOFF.EQ.0) THEN
          DP = -0.5D0*DLON
      ELSE
          DP = 0.5D0*DLON
      END IF
      ISAV = 4*NLAT + 17
      CALL DVHIFTHI(NLON,DP,WSAV(ISAV))
      RETURN
      END

      SUBROUTINE DVHIFTH(M,N,R,WSAV,WORK)
      IMPLICIT NONE
      INTEGER M,N,N2,K,L
      DOUBLE PRECISION R(M,N),WSAV(*),WORK(*),R2KM2,R2KM1

      N2 = (N+1)/2
c
c     compute fourier coefficients for r on shifted grid
c
      CALL DHRFFTF(M,N,R,M,WSAV(N+2),WORK)
      DO L = 1,M
          DO K = 2,N2
              R2KM2 = R(L,K+K-2)
              R2KM1 = R(L,K+K-1)
              R(L,K+K-2) = R2KM2*WSAV(N2+K) - R2KM1*WSAV(K)
              R(L,K+K-1) = R2KM2*WSAV(K) + R2KM1*WSAV(N2+K)
          END DO
      END DO
c
c     shift r with fourier synthesis and normalization
c
      CALL DHRFFTB(M,N,R,M,WSAV(N+2),WORK)
      DO L = 1,M
          DO K = 1,N
              R(L,K) = R(L,K)/N
          END DO
      END DO
      RETURN
      END

      SUBROUTINE DVHIFTHI(N,DP,WSAV)
c
c     initialize wsav for subroutine vhifth
c
      IMPLICIT NONE
      INTEGER N,N2,K
      DOUBLE PRECISION WSAV(*),DP

      N2 = (N+1)/2
      DO K = 2,N2
          WSAV(K) = SIN((K-1)*DP)
          WSAV(K+N2) = COS((K-1)*DP)
      END DO
      CALL DHRFFTI(N,WSAV(N+2))
      RETURN
      END

c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by UCAR                 .
c  .                                                             .
c  .       University Corporation for Atmospheric Research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                         SPHEREPACK                          .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c
c
c ... file isfvpgs.f
c
c     this file includes documentation and code for
c     subroutine isfvpgs          i
c
c ... files which must be loaded with isfvpgs.f
c
c     sphcom.f, hrfft.f, vhsgs.f, shags.f, gaqd.f
c
c
c     subroutine isfvpgs(nlat,nlon,isym,nt,sf,vp,idv,jdv,as,bs,av,bv,
c    +                   mdb,ndb,wvhsgs,lvhsgs,work,lwork,ierror)
c
c     given the scalar spherical harmonic coefficients as,bs precomputed
C*PL*ERROR* Comment line too long
c     by shags for the scalar stream function sf and av,bv precomputed by
C*PL*ERROR* Comment line too long
c     shags for the scalar velocity potenital vp, subroutine isfvpgs computes
c     the vector field (v,w) corresponding to sf and vp.  w is the east
C*PL*ERROR* Comment line too long
c     longitudinal and v is the colatitudinal component of the vector field.
C*PL*ERROR* Comment line too long
c     (v,w) is expressed in terms of sf,vp by the helmholtz relations (in
c     mathematical spherical coordinates):
c
c          v = -1/sin(theta)*d(vp)/dlambda + d(st)/dtheta
c
c          w =  1/sin(theta)*d(st)/dlambda + d(vp)/dtheta
c
c     required legendre functions are stored rather than recomputed as
c     they are in subroutine isfvpgc.  v(i,j) and w(i,j) are given at
c     the i(th) gaussian colatitude point (see gaqd) theta(i) and east
c     longitude lambda(j) = (j-1)*2.*pi/nlon on the sphere.
c
c     input parameters
c
c     nlat   the number of points in the gaussian colatitude grid on the
C*PL*ERROR* Comment line too long
c            full sphere. these lie in the interval (0,pi) and are computed
C*PL*ERROR* Comment line too long
c            in radians in theta(1) <...< theta(nlat) by subroutine gaqd.
C*PL*ERROR* Comment line too long
c            if nlat is odd the equator will be included as the grid point
c            theta((nlat+1)/2).  if nlat is even the equator will be
c            excluded as a grid point and will lie half way between
c            theta(nlat/2) and theta(nlat/2+1). nlat must be at least 3.
c            note: on the half sphere, the number of grid points in the
c            colatitudinal direction is nlat/2 if nlat is even or
c            (nlat+1)/2 if nlat is odd.
c
c     nlon   the number of distinct londitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater than
c            3.  the efficiency of the computation is improved when nlon
c            is a product of small prime numbers.
c
c
c     isym   a parameter which determines whether the vector field is
c            computed on the full or half sphere as follows:
c
c      = 0
c
c            the symmetries/antsymmetries described in isym=1,2 below
c            do not exist in sf,vp about the equator.  in this case v
c            and w are not necessarily symmetric or antisymmetric about
c            equator.  v and w are computed on the entire sphere.
c            i.e., in arrays sf(i,j),vp(i,j) for i=1,...,nlat and
c            j=1,...,nlon.
c
c      = 1
c
c            vp is antisymmetric and sf is symmetric about the equator.
c            in this case v is symmetric and w antisymmetric about
c            the equator and are computed for the northern hemisphere
c            only.  i.e., if nlat is odd the v(i,j),w(i,j) are computed
c            for i=1,...,(nlat+1)/2 and for j=1,...,nlon.  if nlat is
c            even then v(i,j),w(i,j) are computed for i=1,...,nlat/2
c            and j=1,...,nlon.
c
c      = 2
c
c            vp is symmetric and sf is antisymmetric about the equator.
c            in this case v is antisymmetric and w symmetric about
c            the equator and are computed for the northern hemisphere
c            only.  i.e., if nlat is odd the v(i,j),w(i,j) are computed
c            for i=1,...,(nlat+1)/2 and for j=1,...,nlon.  if nlat is
c            even then v(i,j),w(i,j) are computed for i=1,...,nlat/2
c            and j=1,...,nlon.
c
c     nt     nt is the number of scalar and vector fields.  some
C*PL*ERROR* Comment line too long
c            computational efficiency is obtained for multiple fields. arrays
C*PL*ERROR* Comment line too long
c            can be three dimensional corresponding to an indexed multiple
c            vector field.  in this case multiple vector synthesis will
c            be performed to compute (v,w) for each field.  the
c            third index is the synthesis index which assumes the values
c            k=1,...,nt.  for a single synthesis set nt = 1.  the
c            description of the remaining parameters is simplified by
C*PL*ERROR* Comment line too long
c            assuming that nt=1 or that all the arrays are two dimensional.
c
c     idv    the first dimension of the arrays v,w as it appears in
c            the program that calls isfvpgs. if isym = 0 then idv
c            must be at least nlat.  if isym = 1 or 2 and nlat is
c            even then idv must be at least nlat/2. if isym = 1 or 2
c            and nlat is odd then idv must be at least (nlat+1)/2.
c
c     jdv    the second dimension of the arrays v,w as it appears in
c            the program that calls isfvpgs. jdv must be at least nlon.
c
c     as,bs  two or three dimensional arrays (see input parameter nt)
c            that contain the spherical harmonic coefficients of
c            the scalar field sf as computed by subroutine shags.
c
c     av,bv  two or three dimensional arrays (see input parameter nt)
c            that contain the spherical harmonic coefficients of
c            the scalar field vp as computed by subroutine shags.
c
c     mdb    the first dimension of the arrays as,bs,av,bv as it
c            appears in the program that calls isfvpgs. mdb must be at
c            least min0(nlat,nlon/2) if nlon is even or at least
c            min0(nlat,(nlon+1)/2) if nlon is odd.
c
c     ndb    the second dimension of the arrays as,bs,av,bv as it
c            appears in the program that calls isfvpgs. ndb must be at
c            least nlat.
c
c     wvhsgs an array which must be initialized by subroutine vhsgsi.
c            once initialized, wvhsgs can be used repeatedly by isfvpgs
c            as long as nlon and nlat remain unchanged.  wvhsgs must
c            not bel altered between calls of isfvpgs.
c
c
c     lvhsgs the dimension of the array wvhsgs as it appears in the
c            program that calls isfvpgs. define
c
c               l1 = min0(nlat,nlon/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            then lvhsgs must be at least
c
c                 l1*l2*(nlat+nlat-l1+1)+nlon+15+2*nlat
c
c
c     work   a work array that does not have to be saved.
c
c     lwork  the dimension of the array work as it appears in the
c            program that calls isfvpgs. define
c
c               l1 = min0(nlat,nlon/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2                    if nlat is even or
c               l2 = (nlat+1)/2                if nlat is odd
c
c            if isym = 0 then lwork must be at least
c
c               nlat*((2*nt+1)*nlon + 4*l1*nt + 1)
c
c            if isym = 1 or 2 then lwork must be at least
c
c               (2*nt+1)*l2*nlon + nlat*(4*l1*nt+1)
c
c     **************************************************************
c
c     output parameters
c
c    v,w    two or three dimensional arrays (see input parameter nt)
c           that contains the vector field corresponding to the stream
c           function sf and velocity potential vp whose coefficients,
c           as,bs (for sf) and av,bv (for vp), were precomputed by
c           subroutine shags.  v(i,j) and w(i,j) are given at the
c           i(th) gaussian colatitude point theta(i) and east longitude
c           point lambda(j) = (j-1)*2*pi/nlon.  the index ranges are
c           defined above at the input parameter isym.
c
c
c    ierror = 0  no errors
c           = 1  error in the specification of nlat
c           = 2  error in the specification of nlon
c           = 3  error in the specification of isym
c           = 4  error in the specification of nt
c           = 5  error in the specification of idv
c           = 6  error in the specification of jdv
c           = 7  error in the specification of mdb
c           = 8  error in the specification of ndb
c           = 9  error in the specification of lvhsgs
c           = 10 error in the specification of lwork
c **********************************************************************
c
      SUBROUTINE DISFVPGS(NLAT,NLON,ISYM,NT,V,W,IDV,JDV,AS,BS,AV,BV,MDB,
     +                   NDB,WVHSGS,LVHSGS,WORK,LWORK,IERROR)
      IMPLICIT NONE
      INTEGER NLAT,NLON,ISYM,NT,IDV,JDV,MDB,NDB,LVHSGS,LWORK,IERROR
      DOUBLE PRECISION V(IDV,JDV,NT),W(IDV,JDV,NT)
      DOUBLE PRECISION AS(MDB,NDB,NT),BS(MDB,NDB,NT)
      DOUBLE PRECISION AV(MDB,NDB,NT),BV(MDB,NDB,NT)
      DOUBLE PRECISION WVHSGS(LVHSGS),WORK(LWORK)
      INTEGER L1,L2,MN,IS,LWK,IWK,LWMIN
      INTEGER IBR,IBI,ICR,ICI
c
c     check input parameters
c
      IERROR = 1
      IF (NLAT.LT.3) RETURN
      IERROR = 2
      IF (NLON.LT.4) RETURN
      IERROR = 3
      IF (ISYM.LT.0 .OR. ISYM.GT.2) RETURN
      IERROR = 4
      IF (NT.LT.0) RETURN
      IERROR = 5
      L2 = (NLAT+1)/2
      IF ((ISYM.EQ.0.AND.IDV.LT.NLAT) .OR.
     +    (ISYM.GT.0.AND.IDV.LT.L2)) RETURN
      IERROR = 6
      IF (JDV.LT.NLON) RETURN
      IERROR = 7
      L1 = MIN0(NLAT, (NLON+1)/2)
      IF (MDB.LT.MIN0(NLAT, (NLON+2)/2)) RETURN
      IERROR = 8
      IF (NDB.LT.NLAT) RETURN
      IERROR = 9
      LWMIN = L1*L2* (NLAT+NLAT-L1+1) + NLON + 15 + 2*NLAT
      IF (LVHSGS.LT.LWMIN) RETURN
      IERROR = 10
      IF (ISYM.EQ.0) THEN
          LWMIN = NLAT* ((2*NT+1)*NLON+4*L1*NT+1)
      ELSE
          LWMIN = (2*NT+1)*L2*NLON + NLAT* (4*L1*NT+1)
      END IF
      IF (LWORK.LT.LWMIN) RETURN
c
c     set first dimension for br,bi,cr,ci (as requried by vhsgs)
c
      MN = L1*NLAT*NT
      IERROR = 0
c
c     set work space pointers
c
      IBR = 1
      IBI = IBR + MN
      ICR = IBI + MN
      ICI = ICR + MN
      IS = ICI + MN
      IWK = IS + NLAT
      LWK = LWORK - 4*MN - NLAT
      CALL DISFVPGS1(NLAT,NLON,ISYM,NT,V,W,IDV,JDV,AS,BS,AV,BV,MDB,NDB,
     +              WORK(IBR),WORK(IBI),WORK(ICR),WORK(ICI),L1,WORK(IS),
     +              WVHSGS,LVHSGS,WORK(IWK),LWK,IERROR)
      RETURN
      END

      SUBROUTINE DISFVPGS1(NLAT,NLON,ISYM,NT,V,W,IDV,JDV,AS,BS,AV,BV,
     +                     MDB,NDB,BR,BI,CR,CI,MAB,FNN,WVHSGS,LVHSGS,
     +                     WK,LWK,IERROR)
      IMPLICIT NONE
      INTEGER NLAT,NLON,ISYM,NT,IDV,JDV,MDB,NDB,MAB,LVHSGS,LWK,IERROR
      DOUBLE PRECISION V(IDV,JDV,NT),W(IDV,JDV,NT)
      DOUBLE PRECISION AS(MDB,NDB,NT),BS(MDB,NDB,NT)
      DOUBLE PRECISION AV(MDB,NDB,NT),BV(MDB,NDB,NT)
      DOUBLE PRECISION BR(MAB,NLAT,NT),BI(MAB,NLAT,NT)
      DOUBLE PRECISION CR(MAB,NLAT,NT),CI(MAB,NLAT,NT)
      DOUBLE PRECISION WVHSGS(LVHSGS),WK(LWK),FNN(NLAT)
      INTEGER N,M,MMAX,K,ITYP
c
c     set coefficient multiplyers
c
      DO N = 2,NLAT
          FNN(N) = -SQRT(DBLE(N* (N-1)))
      END DO
      MMAX = MIN0(NLAT, (NLON+1)/2)
c
c     compute (v,w) coefficients from as,bs,av,bv
c
      DO K = 1,NT
          DO N = 1,NLAT
              DO M = 1,MAB
                  BR(M,N,K) = 0.0D0
                  BI(M,N,K) = 0.0D0
                  CR(M,N,K) = 0.0D0
                  CI(M,N,K) = 0.0D0
              END DO
          END DO
c
c     compute m=0 coefficients
c
          DO N = 2,NLAT
              BR(1,N,K) = -FNN(N)*AV(1,N,K)
              BI(1,N,K) = -FNN(N)*BV(1,N,K)
              CR(1,N,K) = FNN(N)*AS(1,N,K)
              CI(1,N,K) = FNN(N)*BS(1,N,K)
          END DO
c
c     compute m>0 coefficients using vector spherepack value for mmax
c
          DO M = 2,MMAX
              DO N = M,NLAT
                  BR(M,N,K) = -FNN(N)*AV(M,N,K)
                  BI(M,N,K) = -FNN(N)*BV(M,N,K)
                  CR(M,N,K) = FNN(N)*AS(M,N,K)
                  CI(M,N,K) = FNN(N)*BS(M,N,K)
              END DO
          END DO
      END DO
c
c     synthesize br,bi,cr,ci into (v,w)
c
      IF (ISYM.EQ.0) THEN
          ITYP = 0
      ELSE IF (ISYM.EQ.1) THEN
          ITYP = 3
      ELSE IF (ISYM.EQ.2) THEN
          ITYP = 6
      END IF
      CALL DVHSGS(NLAT,NLON,ITYP,NT,V,W,IDV,JDV,BR,BI,CR,CI,MAB,NLAT,
     +           WVHSGS,LVHSGS,WK,LWK,IERROR)
      RETURN
      END

C
C $Id: itrovr.f,v 1.5 2008-07-27 00:17:31 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      FUNCTION ITROVR (XCP1,YCP1,XCP2,YCP2,XCP3,YCP3,
     +                 XCQ1,YCQ1,XCQ2,YCQ2,XCQ3,YCQ3)
C     FUNCTION ITROVR (XCA1,YCA1,XCA2,YCA2,XCA3,YCA3,
C    +                 XCB1,YCB1,XCB2,YCB2,XCB3,YCB3)
C
C This function has a non-zero value if and only if the 2D triangles
C defined by its arguments actually overlap.  (If they just touch each
C other, this version of ITROVR reports that they don't overlap.)
C
C Declare an arithmetic statement function that has one sign if point
C 3 is to the left of the line from point 1 to point 2 and a different
C sign if point 3 is to the right of that line.
C
        SIDE(X1,Y1,X2,Y2,X3,Y3)=(X1-X3)*(Y2-Y3)-(Y1-Y3)*(X2-X3)
C
        XCA1=.999*XCP1+.001*(XCP1+XCP2+XCP3)/3.
        YCA1=.999*YCP1+.001*(YCP1+YCP2+YCP3)/3.
        XCA2=.999*XCP2+.001*(XCP1+XCP2+XCP3)/3.
        YCA2=.999*YCP2+.001*(YCP1+YCP2+YCP3)/3.
        XCA3=.999*XCP3+.001*(XCP1+XCP2+XCP3)/3.
        YCA3=.999*YCP3+.001*(YCP1+YCP2+YCP3)/3.
        XCB1=.999*XCQ1+.001*(XCQ1+XCQ2+XCQ3)/3.
        YCB1=.999*YCQ1+.001*(YCQ1+YCQ2+YCQ3)/3.
        XCB2=.999*XCQ2+.001*(XCQ1+XCQ2+XCQ3)/3.
        YCB2=.999*YCQ2+.001*(YCQ1+YCQ2+YCQ3)/3.
        XCB3=.999*XCQ3+.001*(XCQ1+XCQ2+XCQ3)/3.
        YCB3=.999*YCQ3+.001*(YCQ1+YCQ2+YCQ3)/3.
C
C Initialize the value of the function to say that the triangles don't
C overlap.
C
        ITROVR=0
C
C If the X extents of the triangles don't overlap, then the triangles
C don't either.
C
        IF (MAX(XCA1,XCA2,XCA3).LE.MIN(XCB1,XCB2,XCB3)) RETURN
        IF (MIN(XCA1,XCA2,XCA3).GE.MAX(XCB1,XCB2,XCB3)) RETURN
C
C If the Y extents of the triangles don't overlap, then the triangles
C don't either.
C
        IF (MAX(YCA1,YCA2,YCA3).LE.MIN(YCB1,YCB2,YCB3)) RETURN
        IF (MIN(YCA1,YCA2,YCA3).GE.MAX(YCB1,YCB2,YCB3)) RETURN
C
C Re-initialize the value of the function to say that the triangles
C do overlap.
C
        ITROVR=1
C
C If any vertex of triangle B is inside triangle A, then the triangles
C overlap.  (Observe that a point is inside a triangle if and only if
C it is on the same side of all three edges of the triangle.)
C
        TMP1=SIDE(XCA1,YCA1,XCA2,YCA2,XCB1,YCB1)
        TMP2=SIDE(XCA2,YCA2,XCA3,YCA3,XCB1,YCB1)
        TMP3=SIDE(XCA3,YCA3,XCA1,YCA1,XCB1,YCB1)
C
        IF ((TMP1.LT.0..AND.TMP2.LT.0..AND.TMP3.LT.0.).OR.
     +      (TMP1.GT.0..AND.TMP2.GT.0..AND.TMP3.GT.0.)) RETURN
C
        TMP1=SIDE(XCA1,YCA1,XCA2,YCA2,XCB2,YCB2)
        TMP2=SIDE(XCA2,YCA2,XCA3,YCA3,XCB2,YCB2)
        TMP3=SIDE(XCA3,YCA3,XCA1,YCA1,XCB2,YCB2)
C
        IF ((TMP1.LT.0..AND.TMP2.LT.0..AND.TMP3.LT.0.).OR.
     +      (TMP1.GT.0..AND.TMP2.GT.0..AND.TMP3.GT.0.)) RETURN
C
        TMP1=SIDE(XCA1,YCA1,XCA2,YCA2,XCB3,YCB3)
        TMP2=SIDE(XCA2,YCA2,XCA3,YCA3,XCB3,YCB3)
        TMP3=SIDE(XCA3,YCA3,XCA1,YCA1,XCB3,YCB3)
C
        IF ((TMP1.LT.0..AND.TMP2.LT.0..AND.TMP3.LT.0.).OR.
     +      (TMP1.GT.0..AND.TMP2.GT.0..AND.TMP3.GT.0.)) RETURN
C
C Similarly, if any vertex of triangle A is inside triangle B, then the
C triangles overlap.
C
        TMP1=SIDE(XCB1,YCB1,XCB2,YCB2,XCA1,YCA1)
        TMP2=SIDE(XCB2,YCB2,XCB3,YCB3,XCA1,YCA1)
        TMP3=SIDE(XCB3,YCB3,XCB1,YCB1,XCA1,YCA1)
C
        IF ((TMP1.LT.0..AND.TMP2.LT.0..AND.TMP3.LT.0.).OR.
     +      (TMP1.GT.0..AND.TMP2.GT.0..AND.TMP3.GT.0.)) RETURN
C
        TMP1=SIDE(XCB1,YCB1,XCB2,YCB2,XCA2,YCA2)
        TMP2=SIDE(XCB2,YCB2,XCB3,YCB3,XCA2,YCA2)
        TMP3=SIDE(XCB3,YCB3,XCB1,YCB1,XCA2,YCA2)
C
        IF ((TMP1.LT.0..AND.TMP2.LT.0..AND.TMP3.LT.0.).OR.
     +      (TMP1.GT.0..AND.TMP2.GT.0..AND.TMP3.GT.0.)) RETURN
C
        TMP1=SIDE(XCB1,YCB1,XCB2,YCB2,XCA3,YCA3)
        TMP2=SIDE(XCB2,YCB2,XCB3,YCB3,XCA3,YCA3)
        TMP3=SIDE(XCB3,YCB3,XCB1,YCB1,XCA3,YCA3)
C
        IF ((TMP1.LT.0..AND.TMP2.LT.0..AND.TMP3.LT.0.).OR.
     +      (TMP1.GT.0..AND.TMP2.GT.0..AND.TMP3.GT.0.)) RETURN
C
C If the center point of either triangle is inside the other, then the
C triangles overlap.  (This takes care of a case in which one triangle
C is inside the other, but each of its vertices is on a side of the
C outer triangle.)
C
        TMP1=SIDE(XCA1,YCA1,XCA2,YCA2,(XCB1+XCB2+XCB3)/3.,
     +                                (YCB1+YCB2+YCB3)/3.)
        TMP2=SIDE(XCA2,YCA2,XCA3,YCA3,(XCB1+XCB2+XCB3)/3.,
     +                                (YCB1+YCB2+YCB3)/3.)
        TMP3=SIDE(XCA3,YCA3,XCA1,YCA1,(XCB1+XCB2+XCB3)/3.,
     +                                (YCB1+YCB2+YCB3)/3.)
C
        IF ((TMP1.LT.0..AND.TMP2.LT.0..AND.TMP3.LT.0.).OR.
     +      (TMP1.GT.0..AND.TMP2.GT.0..AND.TMP3.GT.0.)) RETURN
C
        TMP1=SIDE(XCB1,YCB1,XCB2,YCB2,(XCA1+XCA2+XCA3)/3.,
     +                                (YCA1+YCA2+YCA3)/3.)
        TMP2=SIDE(XCB2,YCB2,XCB3,YCB3,(XCA1+XCA2+XCA3)/3.,
     +                                (YCA1+YCA2+YCA3)/3.)
        TMP3=SIDE(XCB3,YCB3,XCB1,YCB1,(XCA1+XCA2+XCA3)/3.,
     +                                (YCA1+YCA2+YCA3)/3.)
C
        IF ((TMP1.LT.0..AND.TMP2.LT.0..AND.TMP3.LT.0.).OR.
     +      (TMP1.GT.0..AND.TMP2.GT.0..AND.TMP3.GT.0.)) RETURN
C
C At this point, we have eliminated many possible cases.  A careful
C examination of the remaining cases indicates that it is sufficient
C to check for intersections of the edges of A with the edges of B.
C If any such intersection is found, the triangles overlap.
C
         IF (ILSINT (XCA1,YCA1,XCA2,YCA2,XCB1,YCB1,XCB2,YCB2).NE.0)
     +                                                       RETURN
         IF (ILSINT (XCA1,YCA1,XCA2,YCA2,XCB2,YCB2,XCB3,YCB3).NE.0)
     +                                                       RETURN
         IF (ILSINT (XCA1,YCA1,XCA2,YCA2,XCB3,YCB3,XCB1,YCB1).NE.0)
     +                                                       RETURN
         IF (ILSINT (XCA2,YCA2,XCA3,YCA3,XCB1,YCB1,XCB2,YCB2).NE.0)
     +                                                       RETURN
         IF (ILSINT (XCA2,YCA2,XCA3,YCA3,XCB2,YCB2,XCB3,YCB3).NE.0)
     +                                                       RETURN
         IF (ILSINT (XCA2,YCA2,XCA3,YCA3,XCB3,YCB3,XCB1,YCB1).NE.0)
     +                                                       RETURN
         IF (ILSINT (XCA3,YCA3,XCA1,YCA1,XCB1,YCB1,XCB2,YCB2).NE.0)
     +                                                       RETURN
         IF (ILSINT (XCA3,YCA3,XCA1,YCA1,XCB2,YCB2,XCB3,YCB3).NE.0)
     +                                                       RETURN
         IF (ILSINT (XCA3,YCA3,XCA1,YCA1,XCB3,YCB3,XCB1,YCB1).NE.0)
     +                                                       RETURN
C
C No overlap is possible; set the function value appropriately to
C indicate this.
C
        ITROVR=0
C
C Done.
C
        RETURN
C
      END

      PROGRAM FGKE01
C
C  Define error file, Fortran unit number, and workstation type,
C  and workstation ID.
C
      PARAMETER (IERRF=6, LUNIT=2, IWKID=1) 
      PARAMETER (IWKID2=2)
C
C  Simple example illustrating opening GKS, opening and activating
C  a CGM workstation and an X11 workstation.
C
      CALL GOPKS (IERRF, ISZDM)
C
C  Specify text alignment of (center, half) and set character height.
C
      CALL GSTXAL(2,3)
      CALL GSCHH(.05)
C
C  Open a CGM workstation with workstation ID of IWKID.
C
      CALL GOPWK (IWKID, LUNIT, 1)
C
C  Open an X11 workstation with workstation ID of IWKID2.
C
      CALL GOPWK(IWKID2,0,8)
C
C  Activate the workstations.
C
      CALL GACWK(IWKID)
      CALL GACWK(IWKID2)
C
C  Draw a text string.
C
      CALL GTX(.5,.5,'Text')
      CALL FRAME
C
C  Close things down.
C
      CALL GDAWK(IWKID)
      CALL GDAWK(IWKID2)
      CALL GCLWK(IWKID)
      CALL GCLWK(IWKID2)
      CALL GCLKS
C
      STOP
      END

C
C      $Id: st02f.f,v 1.6 2010-03-15 22:49:24 haley Exp $
C
C***********************************************************************
C                                                                      *
C                Copyright (C)  1993                                   *
C        University Corporation for Atmospheric Research               *
C                All Rights Reserved                                   *
C                                                                      *
C***********************************************************************
C
C  File:       st02f.f
C
C  Author:     David Brown
C              National Center for Atmospheric Research
C              PO 3000, Boulder, Colorado
C
C  Date:       Wed Apr  3 17:00:55 MST 1996
C
C   Description:   Given a simple mathematically generated data set,
C           demonstrates line-drawn streamline arrows and the use
C                  of some basic StreamlinePlot resources
C
      external NhlFAppClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFCairoWindowWorkstationClass
      external NhlFVectorFieldClass
      external NhlFStreamlinePlotClass

      parameter(N=30,M=25)
      parameter(PI=3.14159)

      character*7  wks_type
      integer appid,wid,stid,vfid
      integer rlist,grlist
      integer len_dims(2)
      real U(M,N),V(M,N)
      real igrid, jgrid
      real stepsize,arrowlength,spacing
      integer i,j

C
C Define the workstation type
C
      wks_type = "x11"

C
C Generate vector data arrays
C
      igrid = 2.0 * PI / real(M)
      jgrid = 2.0 * PI / real(N)
      do 20 j = 1,N
         do 10 i=1,M
            U(i,j) = 10.0 * cos(jgrid * real(j-1))
            V(i,j) = 10.0 * cos(igrid * real(i-1))
 10      continue
 20   continue
C
C Initialize the high level utility library
C
      call NhlFInitialize
C
C Create an application context. Set the app dir to the current
C directory so the application looks for a resource file in the working
C directory. 
C
      call NhlFRLCreate(rlist,'SETRL')
      call NhlFRLCreate(grlist,'GETRL')
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'st02',NhlFappClass,0,rlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkMetaName','./st02f.ncgm',ierr)
         call NhlFCreate(wid,'st02Work',NhlFNcgmWorkstationClass,
     1     0,rlist,ierr)
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPause','True',ierr)
         call NhlFCreate(wid,'st02Work',
     1        NhlFCairoWindowWorkstationClass,
     1        0,rlist,ierr) 
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PostScript workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPSFileName','./st02f.ps',ierr)
         call NhlFCreate(wid,'st02Work',NhlFPSWorkstationClass,
     1        0,rlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPDFFileName','./st02f.pdf',ierr)
         call NhlFCreate(wid,'st02Work',NhlFPDFWorkstationClass,
     1        0,rlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF object.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetstring(rlist,'wkFileName','./st02f',ierr)
         call NhlFCreate(wid,'st02Work',
     1        NhlFCairoPSPDFWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG object.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetstring(rlist,'wkFileName','./st02f',ierr)
         call NhlFCreate(wid,'st02Work',
     1        NhlFCairoImageWorkstationClass,0,rlist,ierr)
      endif
C
C Create a VectorField data object using the data set defined above.
C By default the array bounds will define the data boundaries
C (zero-based, as in C language conventions)
C
      len_dims(1) = M
      len_dims(2) = N
      call NhlFRLClear(rlist)
      call NhlFRLSetMDFloatArray(rlist,'vfUDataArray',U,2,len_dims,ierr)
      call NhlFRLSetMDFloatArray(rlist,'vfVDataArray',V,2,len_dims,ierr)
      call NhlFCreate(vfid,'vectorfield',NhlFVectorFieldClass,appid,
     1     rlist,ierr)
C
C Create a StreamlinePlot object, supplying the VectorField object as data
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'tiMainString',
     1     'Modifying StreamlinePlot resources',ierr)
      call NhlFRLSetInteger(rlist,'stVectorFieldData',vfid,ierr)
      call NhlFCreate(stid,'streamlineplot',NhlFStreamlinePlotClass,wid,
     1     rlist,ierr)

      call NhlFDraw(stid,ierr)
      call NhlFFrame(wid,ierr)
C
C Get the values of several resources that are set dynamically based
C on the assumed NDC size of a grid cell. Each of this will be separately
C modified in the course of this example to illustrate their effect.
C
      call NhlFRLClear(grlist)
      call NhlFRLGetFloat(grlist,'stStepSizeF',stepsize,ierr)
      call NhlFRLGetFloat(grlist,'stArrowLengthF',arrowlength,ierr)
      call NhlFRLGetFloat(grlist,'stMinLineSpacingF',spacing,ierr)
      call NhlFGetValues(stid,grlist,ierr)
C
C Increase the step size 
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'tiMainString','Larger Step Size',ierr)
      call NhlFRLSetFloat(rlist,'stStepSizeF',stepsize * 4.0,ierr)
      call NhlFSetValues(stid,rlist,ierr)

      call NhlFDraw(stid,ierr)
      call NhlFFrame(wid,ierr)
C
C Decrease the step size 
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'tiMainString','Smaller Step Size',
     1                     ierr)
      call NhlFRLSetFloat(rlist,'stStepSizeF',stepsize * 0.25,ierr)
      call NhlFSetValues(stid,rlist,ierr)

      call NhlFDraw(stid,ierr)
      call NhlFFrame(wid,ierr)
C
C Increase the minimum line spacing 
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'tiMainString',
     1     'Larger Minimum Line Spacing',ierr)
      call NhlFRLSetFloat(rlist,'stStepSizeF',stepsize,ierr)
      call NhlFRLSetFloat(rlist,'stMinLineSpacingF', spacing * 4.0,ierr)
      call NhlFSetValues(stid,rlist,ierr)

      call NhlFDraw(stid,ierr)
      call NhlFFrame(wid,ierr)
C
C Decrease the minimum line spacing
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'tiMainString',
     1     'Smaller Minimum Line Spacing',ierr)
      call NhlFRLSetFloat(rlist,'stMinLineSpacingF',spacing * 0.25,ierr)
      call NhlFSetValues(stid,rlist,ierr)

      call NhlFDraw(stid,ierr)
      call NhlFFrame(wid,ierr)
C
C Increase the line starting grid stride 
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'tiMainString',
     1     'Larger Line Starting Grid Stride',ierr)
      call NhlFRLSetFloat(rlist,'stMinLineSpacingF',spacing,ierr)
      call NhlFRLSetInteger(rlist,'stLineStartStride',3,ierr)
      call NhlFSetValues(stid,rlist,ierr)

      call NhlFDraw(stid,ierr)
      call NhlFFrame(wid,ierr)
C
C Decrease the line starting grid stride
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'tiMainString',
     1     'Smaller Line Starting Grid Stride',ierr)
      call NhlFRLSetInteger(rlist,'stLineStartStride',1,ierr)
      call NhlFSetValues(stid,rlist,ierr)

      call NhlFDraw(stid,ierr)
      call NhlFFrame(wid,ierr)
C
C Increase the arrow size
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'tiMainString','Larger Arrows',ierr)
      call NhlFRLSetInteger(rlist,'stLineStartStride',2,ierr)
      call NhlFRLSetFloat(rlist,'stArrowLengthF',arrowlength*2.0,ierr)
      call NhlFSetValues(stid,rlist,ierr)

      callNhlFDraw(stid,ierr)
      call NhlFFrame(wid,ierr)
C
C Destroy the objects created, close the HLU library and exit.
C
      call NhlFDestroy(appid,ierr)
      call NhlFClose
      stop
      end

      SUBROUTINE DGERQ2( M, N, A, LDA, TAU, WORK, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     February 29, 1992
*
*     .. Scalar Arguments ..
      INTEGER            INFO, LDA, M, N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), TAU( * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  DGERQ2 computes an RQ factorization of a real m by n matrix A:
*  A = R * Q.
*
*  Arguments
*  =========
*
*  M       (input) INTEGER
*          The number of rows of the matrix A.  M >= 0.
*
*  N       (input) INTEGER
*          The number of columns of the matrix A.  N >= 0.
*
*  A       (input/output) DOUBLE PRECISION array, dimension (LDA,N)
*          On entry, the m by n matrix A.
*          On exit, if m <= n, the upper triangle of the subarray
*          A(1:m,n-m+1:n) contains the m by m upper triangular matrix R;
*          if m >= n, the elements on and above the (m-n)-th subdiagonal
*          contain the m by n upper trapezoidal matrix R; the remaining
*          elements, with the array TAU, represent the orthogonal matrix
*          Q as a product of elementary reflectors (see Further
*          Details).
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(1,M).
*
*  TAU     (output) DOUBLE PRECISION array, dimension (min(M,N))
*          The scalar factors of the elementary reflectors (see Further
*          Details).
*
*  WORK    (workspace) DOUBLE PRECISION array, dimension (M)
*
*  INFO    (output) INTEGER
*          = 0: successful exit
*          < 0: if INFO = -i, the i-th argument had an illegal value
*
*  Further Details
*  ===============
*
*  The matrix Q is represented as a product of elementary reflectors
*
*     Q = H(1) H(2) . . . H(k), where k = min(m,n).
*
*  Each H(i) has the form
*
*     H(i) = I - tau * v * v'
*
*  where tau is a real scalar, and v is a real vector with
*  v(n-k+i+1:n) = 0 and v(n-k+i) = 1; v(1:n-k+i-1) is stored on exit in
*  A(m-k+i,1:n-k+i-1), and tau in TAU(i).
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ONE
      PARAMETER          ( ONE = 1.0D+0 )
*     ..
*     .. Local Scalars ..
      INTEGER            I, K
      DOUBLE PRECISION   AII
*     ..
*     .. External Subroutines ..
      EXTERNAL           DLARF, DLARFG, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN
*     ..
*     .. Executable Statements ..
*
*     Test the input arguments
*
      INFO = 0
      IF( M.LT.0 ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( LDA.LT.MAX( 1, M ) ) THEN
         INFO = -4
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DGERQ2', -INFO )
         RETURN
      END IF
*
      K = MIN( M, N )
*
      DO 10 I = K, 1, -1
*
*        Generate elementary reflector H(i) to annihilate
*        A(m-k+i,1:n-k+i-1)
*
         CALL DLARFG( N-K+I, A( M-K+I, N-K+I ), A( M-K+I, 1 ), LDA,
     $                TAU( I ) )
*
*        Apply H(i) to A(1:m-k+i-1,1:n-k+i) from the right
*
         AII = A( M-K+I, N-K+I )
         A( M-K+I, N-K+I ) = ONE
         CALL DLARF( 'Right', M-K+I-1, N-K+I, A( M-K+I, 1 ), LDA,
     $               TAU( I ), A, LDA, WORK )
         A( M-K+I, N-K+I ) = AII
   10 CONTINUE
      RETURN
*
*     End of DGERQ2
*
      END

C
C	$Id: gfa.f,v 1.10 2008-07-27 00:20:57 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GFA(N,PX,PY)
C
C  FILL AREA
C
      INTEGER EFA
      PARAMETER (EFA=15)
C
C  Specify the maximum sized polygon that will be clipped to the NDC
C  viewport.
C
      PARAMETER (MAXCLP=250)
C
      include 'gkscom.h'
C
      REAL PX(N),PY(N)
C
C  Set up integer and real workspaces for the clipping call.
C
      DIMENSION IWKSP(IWDIM)
      DIMENSION WCLIPX(4),WCLIPY(4)
C
C  Check if GKS is in the proper state.
C
      CALL GZCKST(5,EFA,IER)
      IF (IER .NE. 0) RETURN
C
C  Check that the number of points is valid.
C
      IF (.NOT.(N.GE.3)) THEN
        ERS = 1
        CALL GERHND(100,EFA,ERF)
        ERS = 0
        RETURN
      ENDIF
C
C  Set function code and put out the real arrays across the
C  workstation interface.  Flag conversion to NDC space.
C
      FCODE = 14
      CALL GZROI(0)
C
C  Set up clip rectangle for clipping world coordinates to the
C  NDC viewport if the polygons are small enough and clipping is on.
C
      IF (N .LE. MAXCLP .AND. GKSCLP.NE.0) THEN
        ICNT = CNT+1
        CALL GZN2WX(1,0.,WCLIPX(1))
        CALL GZN2WX(1,1.,WCLIPX(2))
        WCLIPX(3) = WCLIPX(2)
        WCLIPX(4) = WCLIPX(1)
        CALL GZN2WY(1,0.,WCLIPY(1))
        WCLIPY(2) = WCLIPY(1)
        CALL GZN2WY(1,1.,WCLIPY(3))
        WCLIPY(4) = WCLIPY(3)
        CALL GZCLPO (WCLIPX,WCLIPY,4,PX,PY,N,RWKSP,IWKSP,IWDIM,IERR)
        IF (IERR .NE. 0) GO TO 10
        RERR = 0
        RETURN
      ENDIF
C
C  Polygon is larger than the clip limit, or clip algorithm error
C  encountered, or clipping is off.
C
   10 CONTINUE
      NPTOT = N
      CALL GZPUTR(NPTOT,N,PX,PY,1,IER)
      RERR = IER
      IF (RERR.NE.0) THEN
        ERS = 1
        CALL GERHND(RERR,EFA,ERF)
        ERS = 0
      ENDIF
C
      RETURN
      END

C
C $Id: dpcurv.f,v 1.6 2008-07-27 00:16:58 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE DPCURV (XCPU,YCPU,NPTS)
C
C The routine DPCURV, given the user-system coordinates of NPTS points
C in the arrays XCPU and YCPU, draws the curve from point 1 to point 2
C to point 3 ... to point NPTS.
C
        DIMENSION XCPU(NPTS),YCPU(NPTS)
C
C Declare the real/integer common block.
C
        COMMON /DPCMRI/ ANGF,DBPI,EPSI,IDPI,IDPS,ILTL,INDP,IPCF,ISBF,
     +                  ISCF,LCDP,RLS1,RLS2,RMFS,TENS,WCHR,WGAP,WSLD
        SAVE   /DPCMRI/
C
C Check for an uncleared prior error.
C
        IF (ICFELL('DPCURV - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C Draw a curve.  The coordinates of the points defining the curve are
C transformed into the fractional system and then passed either to
C DPDRAW (if smoothing is turned off) or to DPSMTH (if smoothing is
C turned on).
C
        DO 101 I=1,NPTS
C
          XTMP=CUFX(XCPU(I))
          IF (ICFELL('DPCURV',2).NE.0) RETURN
C
          YTMP=CUFY(YCPU(I))
          IF (ICFELL('DPCURV',3).NE.0) RETURN
C
          IF (TENS.LT.0.) THEN
            CALL DPDRAW (XTMP,YTMP,MIN(1,I-1))
            IF (ICFELL('DPCURV',4).NE.0) RETURN
          ELSE
            CALL DPSMTH (XTMP,YTMP,MIN(1,I-1))
            IF (ICFELL('DPCURV',5).NE.0) RETURN
          END IF
C
  101   CONTINUE
C
        IF (TENS.LT.0.) THEN
          CALL DPDRAW (0.,0.,2)
          IF (ICFELL('DPCURV',6).NE.0) RETURN
        ELSE
          CALL DPSMTH (0.,0.,2)
          IF (ICFELL('DPCURV',7).NE.0) RETURN
        END IF
C
C Done.
C
        RETURN
C
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C   FFTPACK 5.0
C   Copyright (C) 1995-2004, Scientific Computing Division,
C   University Corporation for Atmospheric Research
C   Licensed under the GNU General Public License (GPL)
C
C   Authors:  Paul N. Swarztrauber and Richard A. Valent
C
C   $Id: costb1.f,v 1.2 2006-11-21 01:10:17 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      SUBROUTINE DCOSTB1(N,INC,X,WSAVE,WORK,IER)
      DOUBLE PRECISION WORK
      DOUBLE PRECISION X1H
      DOUBLE PRECISION X1P3
      DOUBLE PRECISION X2
      DOUBLE PRECISION T1
      DOUBLE PRECISION T2
      DOUBLE PRECISION FNM1S2
      DOUBLE PRECISION FNM1S4
      DOUBLE PRECISION XI
      DOUBLE PRECISION X(INC,*),WSAVE(*)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION DSUM

      IER = 0
      NM1 = N - 1
      NP1 = N + 1
      NS2 = N/2
      IF (N-2) 106,101,102
  101 X1H = X(1,1) + X(1,2)
      X(1,2) = X(1,1) - X(1,2)
      X(1,1) = X1H
      RETURN
  102 IF (N.GT.3) GO TO 103
      X1P3 = X(1,1) + X(1,3)
      X2 = X(1,2)
      X(1,2) = X(1,1) - X(1,3)
      X(1,1) = X1P3 + X2
      X(1,3) = X1P3 - X2
      RETURN
  103 X(1,1) = X(1,1) + X(1,1)
      X(1,N) = X(1,N) + X(1,N)
      DSUM = X(1,1) - X(1,N)
      X(1,1) = X(1,1) + X(1,N)
      DO 104 K = 2,NS2
          KC = NP1 - K
          T1 = X(1,K) + X(1,KC)
          T2 = X(1,K) - X(1,KC)
          DSUM = DSUM + WSAVE(KC)*T2
          T2 = WSAVE(K)*T2
          X(1,K) = T1 - T2
          X(1,KC) = T1 + T2
  104 CONTINUE
      MODN = MOD(N,2)
      IF (MODN.EQ.0) GO TO 124
      X(1,NS2+1) = X(1,NS2+1) + X(1,NS2+1)
  124 LENX = INC* (NM1-1) + 1
      LNSV = NM1 + INT(LOG(DBLE(NM1))) + 4
      LNWK = NM1
C
      CALL DRFFT1F(NM1,INC,X,LENX,WSAVE(N+1),LNSV,WORK,LNWK,IER1)
      IF (IER1.NE.0) THEN
          IER = 20
          CALL DXERFFT('COSTB1',-5)
          RETURN
      END IF
C
      FNM1S2 = DBLE(NM1)/2.D0
      DSUM = .5D0*DSUM
      X(1,1) = FNM1S2*X(1,1)
      IF (MOD(NM1,2).NE.0) GO TO 30
      X(1,NM1) = X(1,NM1) + X(1,NM1)
   30 FNM1S4 = DBLE(NM1)/4.D0
      DO 105 I = 3,N,2
          XI = FNM1S4*X(1,I)
          X(1,I) = FNM1S4*X(1,I-1)
          X(1,I-1) = DSUM
          DSUM = DSUM + XI
  105 CONTINUE
      IF (MODN.NE.0) RETURN
      X(1,N) = DSUM
  106 RETURN
      END

C
C	$Id: csgivens.f,v 1.5 2008-07-27 03:10:06 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CSGIVENS ( A,B, C,S)
      DOUBLE PRECISION A, B, C, S
C
C***********************************************************
C
C                                              From SSRFPACK
C                                            Robert J. Renka
C                                  Dept. of Computer Science
C                                       Univ. of North Texas
C                                           renka@cs.unt.edu
C                                                   05/09/92
C
C   This subroutine constructs the Givens plane rotation,
C
C           ( C  S)
C       G = (     ) , where C*C + S*S = 1,
C           (-S  C)
C
C which zeros the second component of the vector (A,B)**T
C (transposed).  Subroutine CSROTATE may be called to apply
C the transformation to a 2 by N matrix.
C
C   This routine is identical to Subroutine SROTG from the
C LINPACK BLAS (Basic Linear Algebra Subroutines).
C
C On input:
C
C       A,B = Components of the vector defining the rota-
C             tion.  These are overwritten by values R
C             and Z (described below) which define C and S.
C
C On output:
C
C       A = Signed Euclidean norm R of the input vector:
C           R = +/-SQRT(A*A + B*B)
C
C       B = Value Z such that:
C             C = SQRT(1-Z*Z) and S=Z if ABS(Z) .LE. 1, and
C             C = 1/Z and S = SQRT(1-C*C) if ABS(Z) > 1.
C
C       C = +/-(A/R) or 1 if R = 0.
C
C       S = +/-(B/R) or 0 if R = 0.
C
C Modules required by CSGIVENS:  None
C
C Intrinsic functions called by CSGIVENS:  ABS, SQRT
C
C***********************************************************
C
      DOUBLE PRECISION AA, BB, R, U, V
C
C Local parameters:
C
C AA,BB = Local copies of A and B
C R =     C*A + S*B = +/-SQRT(A*A+B*B)
C U,V =   Variables used to scale A and B for computing R
C
      AA = A
      BB = B
      IF (ABS(AA) .GT. ABS(BB)) THEN
C
C ABS(A) > ABS(B).
C
        U = AA + AA
        V = BB/U
        R = SQRT(.25 + V*V) * U
        C = AA/R
        S = V * (C + C)
C
C Note that R has the sign of A, C > 0, and S has
C   SIGN(A)*SIGN(B).
C
        B = S
        A = R
      ELSEIF (BB .NE. 0.) THEN
C
C ABS(A) .LE. ABS(B).
C
        U = BB + BB
        V = AA/U
C
C Store R in A.
C
        A = SQRT(.25 + V*V) * U
        S = BB/A
        C = V * (S + S)
C
C Note that R has the sign of B, S > 0, and C has
C   SIGN(A)*SIGN(B).
C
        B = 1.
        IF (C .NE. 0.) B = 1./C
      ELSE
C
C A = B = 0.
C
        C = 1.
        S = 0.
      ENDIF
      RETURN
      END

      PROGRAM PGKEX16
C
C  Illustrate the fill algorithm determining what is inside
C  a polygon.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER (ID=11, IDM1=ID-1)
      DIMENSION XS(ID),YS(ID),XD(ID),YD(ID),XP(IDM1),YP(IDM1)
C
C  Coordinate data defining 10 points for a five-pointed star.
C  The ten points specify the tips of the star as well as the
C  points toward the center between the tips.  The first point
C  is set equal to the last point for the purposes of drawing
C  the outline of the points.
C
      DATA XS/ 0.00000, -0.22451, -0.95105, -0.36327, -0.58780,
     -         0.00000,  0.58776,  0.36327,  0.95107,  0.22453,
     -         0.00000                                         /
      DATA YS/ 1.00000,  0.30902,  0.30903, -0.11803, -0.80900,
     -        -0.38197, -0.80903, -0.11805,  0.30898,  0.30901,
     -         1.00000                                         /
C
C  Coordinates for labelling the stars.
C
      DATA XP/ .243,.180,.025,.138,.098,.243,.385,.345,.457,.320 /
      DATA YP/ .690,.540,.513,.415,.285,.340,.285,.415,.513,.540 /
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF,IDUM)
      CALL GOPWK (IWKID,LUNIT,IWTYPE)
      CALL GACWK (IWKID)
C
C  Define colors.
C
      CALL GSCR(IWKID, 0, 1.0, 1.0, 1.0)
      CALL GSCR(IWKID, 1, 0.0, 0.0, 1.0)
      CALL GSCR(IWKID, 2, 0.4, 0.0, 0.4)
      CALL GSCR(IWKID, 3, 1.0, 0.0, 0.0)
C
C  Draw the star with interior style solid;
C  use ten points in the fill area call.
C
      X = .25
      Y = .45
      SCL = .2
      DO 10 I=1,ID
        XD(I) = X+SCL*XS(I)
        YD(I) = Y+SCL*YS(I)
   10 CONTINUE
C
      CALL GSFAIS(1)
      CALL GSFACI(1)
      CALL GFA(10,XD,YD)
C
C  Label the points.
C
      DO 30 I=1,10
        CALL PLTNUM (XP(I),YP(I),I)
   30 CONTINUE
C
C  Draw lines connecting the coordinate points.
C
      CALL GSPLCI(3)
      CALL GSLWSC(4.)
      CALL GPL(ID,XD,YD)
C
C  Draw the star with interior style solid;
C  use only the five tips of the star as coordinates.
C
      X = .75
      Y = .45
      SCL = .2
      XD(1) = X+SCL*XS(1)
      YD(1) = Y+SCL*YS(1)
      XD(2) = X+SCL*XS(5)
      YD(2) = Y+SCL*YS(5)
      XD(3) = X+SCL*XS(9)
      YD(3) = Y+SCL*YS(9)
      XD(4) = X+SCL*XS(3)
      YD(4) = Y+SCL*YS(3)
      XD(5) = X+SCL*XS(7)
      YD(5) = Y+SCL*YS(7)
      CALL GFA(5,XD,YD)
C
C  Draw lines connecting the coordinate points.
C
      XD(6) = XD(1)
      YD(6) = YD(1)
      CALL GPL(6,XD,YD)
C
C  Label the points.
C
      CALL PLTNUM (XP(1)+.5,YP(1),1)
      CALL PLTNUM (XP(3)+.5,YP(3),4)
      CALL PLTNUM (XP(5)+.5,YP(5),2)
      CALL PLTNUM (XP(7)+.5,YP(7),5)
      CALL PLTNUM (XP(9)+.5,YP(9),3)
C
C  Label the plot using Plotchar.
C
      CALL PCSETI('FN',25)
      CALL PCSETI('CC',2)
      CALL PLCHHQ(.5,.91,'Filled areas',.035,0.,0.)
      CALL PLCHHQ(.5,.84,'What''s inside, what''s outside?',.035,0.,0.)
C
C  Close picture, deactivate and close the workstation, close GKS.
C
      CALL FRAME
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      STOP
      END
      SUBROUTINE PLTNUM(X,Y,NUM)
C
C  Plot the value of the integer NUM at coordinate location (X,Y)
C
      CHARACTER*2 LABEL
C
      WRITE(LABEL,100) NUM
  100 FORMAT(I2)
C
      CALL PCSETI('FN',22)
      CALL PCSETI('CC',2)
      CALL PLCHHQ(X,Y,LABEL,.023,0.,0.)
C
      RETURN
      END

C
C	$Id: gwid2s.f,v 1.4 2008-07-27 00:21:07 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GWID2S
C
C  Copy "DEFAULT" attribute context to "SET" context.
C
      include 'gwiast.h'
      include 'gwiadf.h'
C
      INTEGER  I
C
      SAVE
C
C  Polyline attributes.
C
      MSPLIX = MDPLIX
      MSLTYP = MDLTYP
      ASLWSC = ADLWSC
      MSPLCI = MDPLCI
C
C  Polymarker attributes.
C
      MSPMIX = MDPMIX
      MSMTYP = MDMTYP
      ASMSZS = ADMSZS
      MSPMCI = MDPMCI
C
C  Text attributes.
C
      MSTXIX    = MDTXIX
      MSTXP     = MDTXP
      MSTXAL(1) = MDTXAL(1)
      MSTXAL(2) = MDTXAL(2)
      MSCHH     = MDCHH
      DO 10 I=1,4
        MSCHOV(I) = MDCHOV(I)
   10 CONTINUE
      MSTXFO = MDTXFO
      MSTXPR = MDTXPR
      ASCHXP = ADCHXP
      ASCHSP = ADCHSP
      MSTXCI = MDTXCI
C
C  Fill area attributes.
C
      MSFAIX    = MDFAIX
      MSPASZ(1) = MDPASZ(1)
      MSPASZ(2) = MDPASZ(2)
      MSPASZ(3) = MDPASZ(3)
      MSPASZ(4) = MDPASZ(4)
      MSPARF(1) = MDPARF(1)
      MSPARF(2) = MDPARF(2)
      MSFAIS    = MDFAIS
      MSFASI    = MDFASI
      MSFACI    = MDFACI
C
C  Aspect source flags.
C
      DO 20 I=1,13
        MSASF(I) = MDASF(I)
   20 CONTINUE
C
      RETURN
      END

      SUBROUTINE SPPTRI( UPLO, N, AP, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     March 31, 1993 
*
*     .. Scalar Arguments ..
      CHARACTER          UPLO
      INTEGER            INFO, N
*     ..
*     .. Array Arguments ..
      REAL               AP( * )
*     ..
*
*  Purpose
*  =======
*
*  SPPTRI computes the inverse of a real symmetric positive definite
*  matrix A using the Cholesky factorization A = U**T*U or A = L*L**T
*  computed by SPPTRF.
*
*  Arguments
*  =========
*
*  UPLO    (input) CHARACTER*1
*          = 'U':  Upper triangular factor is stored in AP;
*          = 'L':  Lower triangular factor is stored in AP.
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  AP      (input/output) REAL array, dimension (N*(N+1)/2)
*          On entry, the triangular factor U or L from the Cholesky
*          factorization A = U**T*U or A = L*L**T, packed columnwise as
*          a linear array.  The j-th column of U or L is stored in the
*          array AP as follows:
*          if UPLO = 'U', AP(i + (j-1)*j/2) = U(i,j) for 1<=i<=j;
*          if UPLO = 'L', AP(i + (j-1)*(2n-j)/2) = L(i,j) for j<=i<=n.
*
*          On exit, the upper or lower triangle of the (symmetric)
*          inverse of A, overwriting the input factor U or L.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*          > 0:  if INFO = i, the (i,i) element of the factor U or L is
*                zero, and the inverse could not be computed.
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ONE
      PARAMETER          ( ONE = 1.0E+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            UPPER
      INTEGER            J, JC, JJ, JJN
      REAL               AJJ
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      REAL               SDOT
      EXTERNAL           LSAME, SDOT
*     ..
*     .. External Subroutines ..
      EXTERNAL           SSCAL, SSPR, STPMV, STPTRI, XERBLA
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      UPPER = LSAME( UPLO, 'U' )
      IF( .NOT.UPPER .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'SPPTRI', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
*
*     Invert the triangular Cholesky factor U or L.
*
      CALL STPTRI( UPLO, 'Non-unit', N, AP, INFO )
      IF( INFO.GT.0 )
     $   RETURN
*
      IF( UPPER ) THEN
*
*        Compute the product inv(U) * inv(U)'.
*
         JJ = 0
         DO 10 J = 1, N
            JC = JJ + 1
            JJ = JJ + J
            IF( J.GT.1 )
     $         CALL SSPR( 'Upper', J-1, ONE, AP( JC ), 1, AP )
            AJJ = AP( JJ )
            CALL SSCAL( J, AJJ, AP( JC ), 1 )
   10    CONTINUE
*
      ELSE
*
*        Compute the product inv(L)' * inv(L).
*
         JJ = 1
         DO 20 J = 1, N
            JJN = JJ + N - J + 1
            AP( JJ ) = SDOT( N-J+1, AP( JJ ), 1, AP( JJ ), 1 )
            IF( J.LT.N )
     $         CALL STPMV( 'Lower', 'Transpose', 'Non-unit', N-J,
     $                     AP( JJN ), AP( JJ+1 ), 1 )
            JJ = JJN
   20    CONTINUE
      END IF
*
      RETURN
*
*     End of SPPTRI
*
      END

      SUBROUTINE ZROT( N, CX, INCX, CY, INCY, C, S )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     October 31, 1992
*
*     .. Scalar Arguments ..
      INTEGER            INCX, INCY, N
      DOUBLE PRECISION   C
      COMPLEX*16         S
*     ..
*     .. Array Arguments ..
      COMPLEX*16         CX( * ), CY( * )
*     ..
*
*  Purpose
*  =======
*
*  ZROT   applies a plane rotation, where the cos (C) is real and the
*  sin (S) is complex, and the vectors CX and CY are complex.
*
*  Arguments
*  =========
*
*  N       (input) INTEGER
*          The number of elements in the vectors CX and CY.
*
*  CX      (input/output) COMPLEX*16 array, dimension (N)
*          On input, the vector X.
*          On output, CX is overwritten with C*X + S*Y.
*
*  INCX    (input) INTEGER
*          The increment between successive values of CY.  INCX <> 0.
*
*  CY      (input/output) COMPLEX*16 array, dimension (N)
*          On input, the vector Y.
*          On output, CY is overwritten with -CONJG(S)*X + C*Y.
*
*  INCY    (input) INTEGER
*          The increment between successive values of CY.  INCX <> 0.
*
*  C       (input) DOUBLE PRECISION
*  S       (input) COMPLEX*16
*          C and S define a rotation
*             [  C          S  ]
*             [ -conjg(S)   C  ]
*          where C*C + S*CONJG(S) = 1.0.
*
* =====================================================================
*
*     .. Local Scalars ..
      INTEGER            I, IX, IY
      COMPLEX*16         STEMP
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          DCONJG
*     ..
*     .. Executable Statements ..
*
      IF( N.LE.0 )
     $   RETURN
      IF( INCX.EQ.1 .AND. INCY.EQ.1 )
     $   GO TO 20
*
*     Code for unequal increments or equal increments not equal to 1
*
      IX = 1
      IY = 1
      IF( INCX.LT.0 )
     $   IX = ( -N+1 )*INCX + 1
      IF( INCY.LT.0 )
     $   IY = ( -N+1 )*INCY + 1
      DO 10 I = 1, N
         STEMP = C*CX( IX ) + S*CY( IY )
         CY( IY ) = C*CY( IY ) - DCONJG( S )*CX( IX )
         CX( IX ) = STEMP
         IX = IX + INCX
         IY = IY + INCY
   10 CONTINUE
      RETURN
*
*     Code for both increments equal to 1
*
   20 CONTINUE
      DO 30 I = 1, N
         STEMP = C*CX( I ) + S*CY( I )
         CY( I ) = C*CY( I ) - DCONJG( S )*CX( I )
         CX( I ) = STEMP
   30 CONTINUE
      RETURN
      END

      PROGRAM FGKGPL
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C INVOKE DEMO DRIVER
C
      CALL GPLXPL (IWKID)
C
C     DEACTIVATE AND CLOSE WORKSTATION, CLOSE GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      STOP
      END
C
C
      SUBROUTINE GPLXPL (IWKID)
C
C PURPOSE                To provide a simple demonstration of the
C                        GKS line drawing techniques.
C
C USAGE                  CALL GPLXPL (IWKID)
C
C Coordinate arrays
C
      REAL    XCD(1500), YCD(1500)
C
C Declare the constant for converting from degrees to radians.
C
      DATA DTR / .017453292519943 /
C
C Set up a color table
C
C White background
C
      CALL GSCR (IWKID,0,1.,1.,1.)
C
C Black foreground
C
      CALL GSCR (IWKID,1,0.,0.,0.)
C
C Red
C
      CALL GSCR (IWKID,2,1.,0.,0.)
C
C Green
C
      CALL GSCR (IWKID,3,0.,1.,0.)
C
C Blue
C
      CALL GSCR (IWKID,4,0.,0.,1.)
C
C Draw a world map
C
C Position the map on the plotter frame
C
      CALL MAPPOS(.01,.99,.01,.99)
C
C Define a map projection
C
      CALL MAPROJ('CE',0., -150., 0.)
C
C Choose map limits 
C
      CALL MAPSET('CO', 60., 30., -60., -30.)
C
C Choose continental outlines
C
      CALL MAPSTC ('OU', 'CO')
C
C Turn off grid lines
C
      CALL MAPSTR ('GR',0.)      
C
C Draw it
C
      CALL MAPDRW
C
C Create a spiral curve
C
C  Set the line color to red
C
      CALL GSPLCI (2)
      DO 40 ING=1,1500
         RAD=REAL(ING)/1000.
         ANG=DTR*REAL(ING-1)
         XCD(ING)=.25+.5*RAD*COS(ANG)
         YCD(ING)=.25+.5*RAD*SIN(ANG)
 40   CONTINUE
C
C Draw 3 spirals on the map over areas of high hurricane
C probability.  Draw 2 additional spirals at the bottom
C of the plot to use as a key.  Dashed spirals indicate
C relatively low areas of hurricane probability, while solid
C spirals indicate higher probability.
C
C Set the line type to solid (the default)
C
      CALL GSLN(1)
C
C Set the position of the spiral
C
      CALL SET (.24,.37,.48,.61,-1.,1.,-1.,1.,1)
C
C Draw the line
C
      CALL GPL(1500, XCD, YCD)
C
C Set the position of the spiral
C
      CALL SET (.03,.10,.43,.50,-1.,1.,-1.,1.,1)
C
C  Draw the line
C
      CALL GPL(1500, XCD, YCD)
C
C Set the position of the spiral
C
      CALL SET (.62,.75,.47,.60,-1.,1.,-1.,1.,1)
C
C Draw the line
C
 	CALL GPL(1500, XCD, YCD)
C
C Set the position of the spiral
C
      CALL SET (.25,.38,.10,.23,-1.,1.,-1.,1.,1)
C
C Draw the line
C
      CALL GPL(1500, XCD, YCD)
C
C Set the position of the spiral
C
      CALL SET (.65,.72,.10,.17,-1.,1.,-1.,1.,1)
C
C Draw the line
C
      CALL GPL(1500, XCD, YCD)
C
C Reset the plot window
C
      CALL SET(0.,1.,0.,1.,0.,1.,0.,1.,1)
C
C Set the line color to black
C
      CALL GSPLCI (1)
C
C  Create a background perimeter 
C
      CALL FRSTPT( 0.0, 0.0)
      CALL VECTOR( 1.0, 0.0)
      CALL VECTOR( 1.0, 1.0)
      CALL VECTOR( 0.0, 1.0)
      CALL VECTOR( 0.0, 0.0)
C
C  Label the plot
C
      CALL PLCHLQ(0.5,0.80,'Areas of High Hurricane Probability'
     +     ,25.,0.,0.)

      CALL PLCHLQ(0.5,0.25,'Average number of tropical cyclones per 5 de
     +gree square per year',15.,0.,0.)

      CALL PLCHLQ(0.33,0.10,'> 3',15.,0.,0.)

      CALL PLCHLQ(0.70,0.10,'2<n<3',15.,0.,0.)

      CALL FRAME

      END

C
C $Id: iszero.f,v 1.5 2008-07-27 00:17:16 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE ISZERO
C
C This routine zeroes both screen models.
C
      COMMON /ISCOMN/ BIG,BIGD,DBPI,IDONE,IFILL,IFLIP,IONES,IHSS(1000),
     +                IREF,ISCA(16,256),ISCALE,ISCR(16,256),ISLBT,ISDR,
     +                LHSS,LX,NFPW,NINU,NINV,NINW,NX,NY,R0,RNX,RNY,
     +                SMALL,SVAL,TENSN,U,V,W,XMAX,XMIN,YMAX,YMIN,XVPL,
     +                XVPR,YVPB,YVPT
      SAVE   /ISCOMN/
C
      DO  20 I=1,LX
        DO  10 J=1,NY
          ISCR(I,J) = 0
          ISCA(I,J) = 0
   10   CONTINUE
   20 CONTINUE
      RETURN
      END

C NCLFORTSTART
      SUBROUTINE DRCM2RGRID(NGRD,NYI,NXI,YI,XI,FI,NYO,YO,NXO,XO,FO
     +                      ,XMSG,NCRIT,OPT,IER)
      IMPLICIT NONE
      INTEGER          NGRD,NXI,NYI,NXO,NYO,NCRIT,OPT,IER
      DOUBLE PRECISION XI(NXI,NYI),YI(NXI,NYI),FI(NXI,NYI,NGRD)
      DOUBLE PRECISION XO(NXO),YO(NYO),FO(NXO,NYO,NGRD),XMSG
C NCLEND

C This is written  with GNU f77 acceptable extensions
c .   This could be improved considerably with f90

c NCL:  fo = rcm2rgrid (lat2d,lon2d,fi, lat, lon iopt)
c                        yi    xi   fi  yo   xo
c
c            fo is the same size xo, yo and same type as "fi"
c            xmsg = fi@_FillValue
c            opt unused option
c
c            The NCL wrapper should allow for multiple datasets
c            so the user need only make one call to the function.

c perform 2D interpolation allowing for missing data:  nothing fancy

c nomenclature:
c .   nxi,nyi - lengths of xi,yi and dimensions of fi (must be >= 2)
c .   xi      - coordinates of fi (eg, lon [2D] )
c .   yi      - coordinates of fi (eg, lat [2D] )
c .   fi      - functional input values [2D]
c .   nxo,nyo - lengths of xo,yo and dimensions of fo (must be >= 1)
c .   xo      - coordinates of fo (eg, lon [1D])
c .             must be monotonically increasing
c .   yo      - coordinates of fo (eg, lat [1D])
c .             must be monotonically increasing
c .   fo      - functional output values [interpolated]
c .   xmsg    - missing code
c .   opt     - unused
c .   ier     - error code
c .             =0;   no error
c .             =1;   not enough points in input/output array
c .             =2/3; xi or yi are not monotonically increasing
c .             =4/5; xo or yo are not monotonically increasing
c
c                              local
      INTEGER          NG, NX,NY,NEXACT,IX,IY,M,N,NW,NER,K,NCRT
      INTEGER          MFLAG, MPTCRT, MKNT
      DOUBLE PRECISION FW(2,2),W(2,2),SUMF,SUMW,CHKLAT(NYI),CHKLON(NXI)
      DOUBLE PRECISION EPS
      DOUBLE PRECISION DGCDIST
c                              error checking
      IER = 0
      IF (NXI.LE.1 .OR. NYI.LE.1 .OR. NXO.LE.1 .OR. NYO.LE.1) THEN
          IER = 1
          RETURN
      END IF
      IF (IER.NE.0) RETURN

      CALL DMONOINC(YO,NYO,IER,NER)
      IF (IER.NE.0) RETURN
      CALL DMONOINC(XO,NXO,IER,NER)
      IF (IER.NE.0) RETURN

      DO NY = 1,NYI
         CHKLAT(NY) = YI(1,NY)
c c c    print *,"chklat: ny=",ny,"  chklat=",chklat(ny)
      END DO
      CALL DMONOINC(CHKLAT,NYI,IER,NER)
      IF (IER.NE.0) RETURN

      DO NX = 1,NXI
         CHKLON(NX) = XI(NX,1)
c c c    print *,"chklon: nx=",nx,"  chklon=",chklon(nx)
      END DO
      CALL DMONOINC(CHKLAT,NYI,IER,NER)
      IF (IER.NE.0) RETURN

      K = 2
c c c k = opt

      IF (NCRIT.LE.1) THEN
          NCRT = 1
      ELSE
          NCRT = MIN(4,NCRIT)
      END IF
c                              initialize to xmsg
      DO NG=1,NGRD      
         DO NY = 1,NYO
            DO NX = 1,NXO
               FO(NX,NY,NG) = XMSG
            END DO
         END DO
      END DO
c                              main loop [exact matches]
c                              people want bit-for-bit match
      EPS    = 1.D-04
      NEXACT = 0

      DO NY = 1,NYO
        DO NX = 1,NXO
           DO IY = 1,NYI
              DO IX = 1,NXI
                 IF (XO(NX).GE.(XI(IX,IY)-EPS) .AND.
     +                XO(NX).LE.(XI(IX,IY)+EPS) .AND.
     +                YO(NY).GE.(YI(IX,IY)-EPS) .AND.
     +                YO(NY).LE.(YI(IX,IY)+EPS) ) THEN
                    
                    DO NG=1,NGRD
                       FO(NX,NY,NG) = FI(IX,IY,NG)
                       NEXACT = NEXACT + 1
                    END DO
                    GO TO 10
                 END IF
              END DO
           END DO
           
 10        CONTINUE
        END DO
      END DO

c c c print *, "nexact=",nexact
c                              main loop [interpolation]
      DO NY = 1,NYO
        DO NX = 1,NXO

               DO IY = 1,NYI-K
                 DO IX = 1,NXI-K
                    IF (XO(NX).GE.XI(IX,IY) .AND.
     +                  XO(NX).LE.XI(IX+K,IY) .AND.
     +                  YO(NY).GE.YI(IX,IY) .AND.
     +                  YO(NY).LE.YI(IX,IY+K)) THEN


                        W(1,1) = (1.D0/DGCDIST(YO(NY),XO(NX),
     +                            YI(IX,IY),XI(IX,IY),2))**2
                        W(2,1) = (1.D0/DGCDIST(YO(NY),XO(NX),
     +                            YI(IX+K,IY),XI(IX+K,IY),2))**2
                        W(1,2) = (1.D0/DGCDIST(YO(NY),XO(NX),
     +                            YI(IX,IY+K),XI(IX,IY+K),2))**2
                        W(2,2) = (1.D0/DGCDIST(YO(NY),XO(NX),
     +                            YI(IX+K,IY+K),XI(IX+K,IY+K),2))**2
                      DO NG=1,NGRD
                        IF (FO(NX,NY,NG).EQ.XMSG) THEN
                            FW(1,1) = FI(IX,IY,NG)
                            FW(2,1) = FI(IX+K,IY,NG)
                            FW(1,2) = FI(IX,IY+K,NG)
                            FW(2,2) = FI(IX+K,IY+K,NG)

                            NW   = 0
                            SUMF = 0.0D0
                            SUMW = 0.0D0
                            DO N = 1,2
                              DO M = 1,2
                                 IF (FW(M,N).NE.XMSG) THEN
                                     SUMF = SUMF + FW(M,N)*W(M,N)
                                     SUMW = SUMW + W(M,N)
                                     NW   = NW + 1
                                 END IF
                              END DO
                            END DO
c                                             nw >=3 arbitrary
c c c                       IF (NW.GE.3 .AND. SUMW.GT.0.D0) THEN
c                                             nw =1 nearest neighbor
                            IF (NW.GE.NCRT .AND. SUMW.GT.0.D0) THEN
                                FO(NX,NY,NG) = SUMF/SUMW
                            END IF
                        END IF
                      END DO
                      GO TO 20
                   END IF
                 END DO
               END DO
   20          CONTINUE
       END DO
      END DO

C Since the RCM grid is curvilinear the above algorithm may not work 
C .   for all of the locations on regular grid. Fill via linear interp.

      MKNT   =  0
      MFLAG  =  0
      MPTCRT =  2
      DO NG=1,NGRD
        DO NY=1,NYO
          DO NX=1,NXO
             IF (FO(NX,NY,NG).EQ.XMSG) THEN
                 CALL DLINMSG(FO(1,NY,NG),NXO,XMSG,MFLAG,MPTCRT)
                 MKNT = MKNT + 1
             END IF
          END DO
        END DO
      END DO

C C C PRINT *,"MKNT=",MKNT

      RETURN
      END
c -----------------------------------------------------------
C NCLFORTSTART
      SUBROUTINE DRGRID2RCM(NGRD,NYI,NXI,YI,XI,FI,NYO,NXO,YO,XO,FO
     +                     ,XMSG,NCRIT,OPT,IER)
      IMPLICIT NONE
      INTEGER          NGRD,NXI,NYI,NXO,NYO,OPT,NCRIT,IER
      DOUBLE PRECISION XI(NXI),YI(NYI),FI(NXI,NYI,NGRD)
      DOUBLE PRECISION XO(NXO,NYO),YO(NXO,NYO),FO(NXO,NYO,NGRD),XMSG
C NCLEND

C This is written  with GNU f77 acceptable extensions
c .   This could be improved considerably with f90

c            fo is the same size xo, yo and same type as "fi"
c            xmsg = fi@_FillValue
c            opt unused option
c
c            The NCL wrapper should allow for multiple datasets
c            so the user need only make one call to the function.

c perform 2D interpolation allowing for missing data:  nothing fancy

c nomenclature:
c .   nxi,nyi - lengths of xi,yi and dimensions of fi (must be >= 2)
c .   xi      - coordinates of fi (eg, lon [1D])
c .   yi      - coordinates of fi (eg, lat [1D])
c .   fi      - functional input values [2D]
c .   nxo,nyo - lengths of xo,yo and dimensions of fo (must be >= 1)
c .   xo      - coordinates of fo (eg, lon [2D])
c .             must be monotonically increasing
c .   yo      - coordinates of fo (eg, lat [2D])
c .             must be monotonically increasing
c .   fo      - functional output values [interpolated]
c .   xmsg    - missing code
c .   opt     - unused
c .   ier     - error code
c .             =0;   no error
c .             =1;   not enough points in input/output array
c .             =2/3; xi or yi are not monotonically increasing
c .             =4/5; xo or yo are not monotonically increasing
c
c                              local
      INTEGER          NG,NX,NY,NEXACT,IX,IY,M,N,NW,NER,K
      DOUBLE PRECISION FW(2,2),W(2,2),SUMF,SUMW,EPS
      DOUBLE PRECISION DGCDIST

c                              in-line functions (bilinear interp)
      DOUBLE PRECISION Z1,Z2,Z3,Z4,SLOPE,SLPX,SLPY,FLI,FBLI

      FLI(Z1,Z2,SLOPE) = Z1 + SLOPE* (Z2-Z1)
      FBLI(Z1,Z2,Z3,Z4,SLPX,SLPY) = FLI(Z1,Z2,SLPX) +
     +                              SLPY* (FLI(Z3,Z4,SLPX)-
     +                              FLI(Z1,Z2,SLPX))

c                              error checking
      IER = 0
      IF (NXI.LE.1 .OR. NYI.LE.1 .OR. NXO.LE.1 .OR. NYO.LE.1) THEN
          IER = 1
          RETURN
      END IF
      IF (IER.NE.0) RETURN

      CALL DMONOINC(YI,NYI,IER,NER)
      IF (IER.NE.0) RETURN
      CALL DMONOINC(XI,NXI,IER,NER)
      IF (IER.NE.0) RETURN
c                              Init to missing
      DO NG = 1,NGRD
        DO NY = 1,NYO
          DO NX = 1,NXO
             FO(NX,NY,NG) = XMSG
          END DO
        END DO
      END DO
c                              main loop [exact matches]
      EPS    = 1.D-03
      NEXACT = 0

      DO NY = 1,NYO
        DO NX = 1,NXO

          DO IY = 1,NYI
            DO IX = 1,NXI
               IF (XO(NX,NY).GE.(XI(IX)-EPS) .AND.
     +             XO(NX,NY).LE.(XI(IX)+EPS) .AND.
     +             YO(NX,NY).GE.(YI(IY)-EPS) .AND.
     +             YO(NX,NY).LE.(YI(IY)+EPS) ) THEN

                   DO NG=1,NGRD
                      FO(NX,NY,NG) = FI(IX,IY,NG)
                      NEXACT = NEXACT + 1
                   END DO
                   GO TO 10
                END IF
            END DO
          END DO

   10      CONTINUE
          END DO
        END DO


c c c print *, "nexact=",nexact

      K = 1
c c c k = opt

c                              main loop [interpolation]
      DO NY = 1,NYO
        DO NX = 1,NXO

          DO IY = 1,NYI - K
            DO IX = 1,NXI - K
               IF (XO(NX,NY).GE.XI(IX) .AND.
     +             XO(NX,NY).LT.XI(IX+K) .AND.
     +             YO(NX,NY).GE.YI(IY) .AND.
     +             YO(NX,NY).LT.YI(IY+K)) THEN

               DO NG = 1,NGRD
                 IF (FO(NX,NY,NG).EQ.XMSG) THEN
                   IF (FI(IX,IY,NG).NE.XMSG .AND.
     +                 FI(IX+K,IY,NG).NE.XMSG .AND.
     +                 FI(IX,IY+K,NG).NE.XMSG .AND.
     +                 FI(IX+K,IY+K,NG).NE.XMSG) THEN

                       FO(NX,NY,NG) =FBLI(FI(IX,IY,NG),FI(IX+K,IY,NG),
     +                                  FI(IX,IY+K,NG),FI(IX+K,IY+K,NG),
     +                                  (XO(NX,NY)-XI(IX))/
     +                                  (XI(IX+K)-XI(IX)),
     +                                  (YO(NX,NY)-YI(IY))/
     +                                  (YI(IY+K)-YI(IY)))

                   ELSE
c                                            OVERKILL
                       FW(1,1) = FI(IX,IY,NG)
                       FW(2,1) = FI(IX+K,IY,NG)
                       FW(1,2) = FI(IX,IY+K,NG)
                       FW(2,2) = FI(IX+K,IY+K,NG)

                       W(1,1) = (1.D0/DGCDIST(YO(NX,NY),XO(NX,NY)
     +                          ,YI(IY),XI(IX),2))**2
                       W(2,1) = (1.D0/DGCDIST(YO(NX,NY),XO(NX,NY)
     +                          ,YI(IY),XI(IX+K),2))**2
                       W(1,2) = (1.D0/DGCDIST(YO(NX,NY),XO(NX,NY)
     +                          ,YI(IY+K),XI(IX),2))**2
                       W(2,2) = (1.D0/DGCDIST(YO(NX,NY),XO(NX,NY)
     +                          ,YI(IY+K),XI(IX+K),2))**2

                       NW = 0
                       SUMF = 0.0D0
                       SUMW = 0.0D0
                       DO N = 1,2
                         DO M = 1,2
                            IF (FW(M,N).NE.XMSG) THEN
                                SUMF = SUMF + FW(M,N)*W(M,N)
                                SUMW = SUMW + W(M,N)
                                NW = NW + 1
                            END IF
                         END DO
                       END DO
c                                             nw >=3 arbitrary
c c c                  IF (NCRIT.GE.3 .AND. SUMW.GT.0.D0) THEN
c                                             nw  =1 nearest neighbor
                       IF (NCRIT.GE.1 .AND. SUMW.GT.0.D0) THEN
                           FO(NX,NY,NG) = SUMF/SUMW
                       END IF
                   END IF
                 END IF
               END DO   
               GO TO 20
             END IF
            END DO   
          END DO    

   20         CONTINUE
        END DO  
      END DO   

      RETURN
      END

      SUBROUTINE DLABAD( SMALL, LARGE )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     October 31, 1992
*
*     .. Scalar Arguments ..
      DOUBLE PRECISION   LARGE, SMALL
*     ..
*
*  Purpose
*  =======
*
*  DLABAD takes as input the values computed by DLAMCH for underflow and
*  overflow, and returns the square root of each of these values if the
*  log of LARGE is sufficiently large.  This subroutine is intended to
*  identify machines with a large exponent range, such as the Crays, and
*  redefine the underflow and overflow limits to be the square roots of
*  the values computed by DLAMCH.  This subroutine is needed because
*  DLAMCH does not compensate for poor arithmetic in the upper half of
*  the exponent range, as is found on a Cray.
*
*  Arguments
*  =========
*
*  SMALL   (input/output) DOUBLE PRECISION
*          On entry, the underflow threshold as computed by DLAMCH.
*          On exit, if LOG10(LARGE) is sufficiently large, the square
*          root of SMALL, otherwise unchanged.
*
*  LARGE   (input/output) DOUBLE PRECISION
*          On entry, the overflow threshold as computed by DLAMCH.
*          On exit, if LOG10(LARGE) is sufficiently large, the square
*          root of LARGE, otherwise unchanged.
*
*  =====================================================================
*
*     .. Intrinsic Functions ..
      INTRINSIC          LOG10, SQRT
*     ..
*     .. Executable Statements ..
*
*     If it looks like we're on a Cray, take the square root of
*     SMALL and LARGE to avoid overflow and underflow problems.
*
      IF( LOG10( LARGE ).GT.2000.D0 ) THEN
         SMALL = SQRT( SMALL )
         LARGE = SQRT( LARGE )
      END IF
*
      RETURN
*
*     End of DLABAD
*
      END

C
C	$Id: gqwkc.f,v 1.10 2009-04-08 23:18:21 fred Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GQWKC(WKID,ERRIND,CONID,WTYPE)
C
C  INQUIRE WORKSTATION CONNECTION AND TYPE.
C
      include 'gkscom.h'
C
      INTEGER WKID,ERRIND,CONID,WTYPE
C
C  Check if GKS is in proper state.
C
      CALL GZCKST(7,-1,ERRIND)
      IF (ERRIND .NE. 0) GOTO 100
C
C  Check that the workstation identifier is valid.
C
      CALL GZCKWK(20,-1,WKID,IDUM,ERRIND)
      IF (ERRIND .NE. 0) GO TO 100
C
C  Check if the specified workstation is open.
C
      CALL GZCKWK(25,-1,WKID,IDUM,ERRIND)
      IF (ERRIND .NE. 0) GO TO 100
C
C  Determine type.
C
      DO 200 I=1,NOPWK
        IF (SOPWK(I) .EQ. WKID) THEN
          WTYPE = SWKTP(I)
          GO TO 10
        ENDIF
  200 CONTINUE
      GO TO 100
   10 CONTINUE
      IF (WTYPE .EQ. GWSS) THEN
        CONID = WCONID
C
C  Connection ID is not used for C drivers.
C
      ELSE IF (WTYPE.EQ.GXWC  .OR. WTYPE.EQ.GDMP  .OR.
     +         WTYPE.EQ.GXWE  .OR. WTYPE.EQ.GPIX  .OR.
     +        (WTYPE.GE.GPSMIN .AND. WTYPE.LE.GPSMAX) .OR.
     +        (WTYPE.EQ.GPDFP .OR. WTYPE.EQ.GPDFL) .OR.
     +        (WTYPE.GE.GCROMIN .AND. WTYPE.LE.GCROMAX)) THEN
        CONID = -1
      ELSE 
C
C  Invoke interface.
C
        FCODE = -226
        CONT  = 0
        CALL GZROI(0)
        IL1   = 1
        IL2   = 1
        ID(1) = WKID
        CALL GZIQWK(WTYPE,WKID)
        IF (RERR.NE.0) THEN
          ERRIND = RERR
          GOTO 100
        ENDIF
        CONID = ID(2)
        WTYPE = ID(3)
      ENDIF
      RETURN
C
  100 CONTINUE
      CONID = -1
      WTYPE = -1
      RETURN
      END

C
C $Id: stgetc.f,v 1.5 2008-07-27 00:17:28 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
C-----------------------------------------------------------------------
C
      SUBROUTINE STGETC (CNM,CVL)
C
      CHARACTER*(*) CNM,CVL
C
C This subroutine is called to retrieve the character value of a
C specified parameter.
C
C CNM is the name of the parameter whose value is to be retrieved.
C
C CVL is a character variable in which the desired value is to be
C returned by STGETC.
C
C ---------------------------------------------------------------------
C
C NOTE:
C Since implicit typing is used for all real and integer variables
C a consistent length convention has been adopted to help clarify the
C significance of the variables encountered in the code for this 
C utility. All local variable and subroutine parameter identifiers 
C are limited to 1,2,or 3 characters. Four character names identify  
C members of common blocks. Five and 6 character variable names 
C denote PARAMETER constants or subroutine or function names.
C
C Declare the ST common blocks.
C
      PARAMETER (IPLVLS = 256)
C
C Integer and real common block variables
C
C
      COMMON / STPAR /
     +                IUD1       ,IVD1       ,IPD1       ,
     +                IXD1       ,IXDM       ,IYD1       ,IYDN       ,
     +                IXM1       ,IYM1       ,IXM2       ,IYM2       ,
     +                IWKD       ,IWKU       ,ISET       ,IERR       ,
     +                IXIN       ,IYIN       ,IMSK       ,ICPM       ,
     +                NLVL       ,IPAI       ,ICTV       ,WDLV       ,
     +                UVMN       ,UVMX       ,PMIN       ,PMAX       ,
     +                IPLR       ,ISST       ,
     +                ICLR(IPLVLS)           ,TVLU(IPLVLS)
C
      COMMON / STTRAN /
     +                UVPS       ,
     +                UVPL       ,UVPR       ,UVPB       ,UVPT       ,
     +                UWDL       ,UWDR       ,UWDB       ,UWDT       ,
     +                UXC1       ,UXCM       ,UYC1       ,UYCN 
C
C Stream algorithm parameters
C
      COMMON / STSTRM /
     +                ISGD       ,IAGD       ,RARL       ,ICKP       ,
     +                ICKX       ,ITRP       ,ICYK       ,RVNL       ,
     +                ISVF       ,RUSV       ,RVSV       ,RNDA       ,
     +                ISPC       ,RPSV       ,RCDS       ,RSSP       ,
     +                RDFM       ,RSMD       ,RAMD       ,IGBS       ,
     +                ISTM       ,RVRL       ,RVFR       ,RVRM       ,
     +                IVPO       ,RAFR       ,RDMX       ,RDMN
C
C Text related parameters
C Note: graphical text output is not yet implemented for the
C       Streamline utility.
C
      COMMON / STTXP /
     +                FCWM    ,ICSZ    ,
     +                FMNS    ,FMNX    ,FMNY    ,IMNP    ,IMNC  ,
     +                FMXS    ,FMXX    ,FMXY    ,IMXP    ,IMXC  ,
     +                FZFS    ,FZFX    ,FZFY    ,IZFP    ,IZFC  ,
     +                FILS    ,FILX    ,FILY    ,IILP    ,IILC 
C
C Character variable declartions
C
      CHARACTER*160 CSTR
      PARAMETER (IPCHSZ=80)
      CHARACTER*(IPCHSZ)  CMNT,CMXT,CZFT,CILT
C
C Text string parameters
C
      COMMON / STCHAR / CSTR,CMNT,CMXT,CZFT,CILT
C
      SAVE /STPAR/, /STTRAN/, /STSTRM/, /STTXP/, /STCHAR/
C
C Internal buffer lengths
C
C IPNPTS - Number of points in the point buffer -- not less than 3
C IPLSTL - Streamline-crossover-check circular list length
C IPGRCT - Number of groups supported for area masking
C
      PARAMETER (IPNPTS = 256, IPLSTL = 750, IPGRCT = 64)
C
C --------------------------------------------------------------------
C
C The mapping common block: made available to user mapping routines
C
      COMMON /STMAP/
     +                IMAP       ,LNLG       ,INVX       ,INVY       ,
     +                XLOV       ,XHIV       ,YLOV       ,YHIV       ,
     +                WXMN       ,WXMX       ,WYMN       ,WYMX       ,
     +                XVPL       ,XVPR       ,YVPB       ,YVPT       ,
     +                XGDS       ,YGDS       ,NXCT       ,NYCT       ,
     +                ITRT       ,FW2W       ,FH2H       ,
     +                DFMG       ,VNML       ,RBIG       ,IBIG
C
      SAVE /STMAP/
C
C Math constants
C
      PARAMETER (PDTOR  = 0.017453292519943,
     +           PRTOD  = 57.2957795130823,
     +           P1XPI  = 3.14159265358979,
     +           P2XPI  = 6.28318530717959,
     +           P1D2PI = 1.57079632679489,
     +           P5D2PI = 7.85398163397448) 
C
C ---------------------------------------------------------------------
C
C Check for a parameter name that is too short.
C
      IF (LEN(CNM).LT.3) THEN
        CSTR(1:36)='STGETC - PARAMETER NAME TOO SHORT - '
        CSTR(37:36+LEN(CNM))=CNM
        CALL SETER (CSTR(1:36+LEN(CNM)),1,1)
        RETURN
      END IF
C
C Get the proper parameter.
C
      IF (CNM(1:3).EQ.'ZFT'.OR.CNM(1:3).EQ.'zft') THEN
         CALL VVTXLN(CZFT,IPCHSZ,IB,IE)
         CVL=CZFT(IB:IE)
      ELSE
C
         CSTR(1:36)='STGETC - PARAMETER NAME NOT KNOWN - '
         CSTR(37:39)=CNM(1:3)
         CALL SETER (CSTR(1:39),3,1)
         RETURN
C
      END IF
C
C
C Done.
C
      RETURN
C
      END

C
C $Id: pakrsp.f,v 1.5 2008-07-27 00:17:10 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      REAL FUNCTION PAKRSP (ANG)
C
C Function to convert DMS packed angle into radians.
C
      IMPLICIT REAL (A-Z)
      DATA SECRAD /0.4848136811095359E-5/
C
C Convert angle to seconds of arc.
C
      SEC = PAKSSP (ANG)
C
C Convert angle to radians.
C
      PAKRSP = SEC * SECRAD
C
      RETURN
      END

      PROGRAM DSEX05
C
      PARAMETER (NUM=5000, NX=21, NY=21)
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
      REAL XI(NUM), YI(NUM), ZI(NUM)
      REAL XO(NX),  YO(NY),  OUTPUT(NX,NY)
      DATA XMININ,YMININ,XMAXIN,YMAXIN/  0.00,  0.00, 1.00, 1.00/
      DATA XMINOT,YMINOT,XMAXOT,YMAXOT/ -0.21, -0.21, 1.21, 1.21/
      DATA RHO, THETA, PHI/3., -70., 40./
C
C  Create random data in two-space and define a function.
C  To get this to work on your system, you may have to insert
C  the correct random number generator for your compiler.
C
      DO 10 I=1,NUM
        XI(I) = XMININ+(XMAXIN-XMININ)*DSRND5()
        YI(I) = YMININ+(YMAXIN-YMININ)*DSRND5()
        ZI(I) = (XI(I)-0.25)**2 + (YI(I)-0.50)**2
   10 CONTINUE
C
C  Create the output grid.
C
      DO 102 I=1,NX
        XO(I) = XMINOT+(REAL(I-1)/REAL(NX-1))*(XMAXOT-XMINOT)
  102 CONTINUE
      DO 103 J =1,NY
        YO(J)= YMINOT+(REAL(J-1)/REAL(NY-1))*(YMAXOT-YMINOT)
  103 CONTINUE
C
C  Interpolate.
C
      CALL DSGRID2S(NUM, XI, YI, ZI, NX, NY, XO, YO, OUTPUT, IER)
      IF (IER .NE. 0) THEN
        WRITE(6,520) IER
  520   FORMAT(' Error ',I3,' returned from DSGRID2S') 
        STOP
      ENDIF
C
C  Plot a surface.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
      CALL TDEZ2D(NX, NY, XO, YO, OUTPUT, RHO, THETA, PHI, 6)
      CALL FRAME()
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END
      REAL FUNCTION DSRND5()
C
C  Portable random number generator.
C
      PARAMETER (MPLIER=16807,MODLUS=2147483647,MOBYMP=127773,
     +           MOMDMP=2836)
C
      INTEGER HVLUE, LVLUE, TESTV, NEXTN
      SAVE    NEXTN
      DATA JSEED,IFRST/123456789,0/
C
      IF (IFRST .EQ. 0) THEN
        NEXTN = JSEED
        IFRST = 1
      ENDIF
C
      HVLUE = NEXTN / MOBYMP
      LVLUE = MOD(NEXTN, MOBYMP)
      TESTV = MPLIER*LVLUE - MOMDMP*HVLUE
      IF (TESTV .GT. 0) THEN
        NEXTN = TESTV
      ELSE
        NEXTN = TESTV + MODLUS
      ENDIF
      DSRND5 = REAL(NEXTN)/REAL(MODLUS)
C
      RETURN
      END

c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by UCAR                 .
c  .                                                             .
c  .       University Corporation for Atmospheric Research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                         SPHEREPACK                       .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c
c
c ... file shses.f
c
c     this file contains code and documentation for subroutines
c     shses and shsesi
c
c ... files which must be loaded with shses.f
c
c     sphcom.f, hrfft.f
c
c     subroutine shses(nlat,nlon,isym,nt,g,idg,jdg,a,b,mdab,ndab,
c    +                 wshses,lshses,work,lwork,ierror)
c
c     subroutine shses performs the spherical harmonic synthesis
c     on the arrays a and b and stores the result in the array g.
c     the synthesis is performed on an equally spaced grid.  the
c     associated legendre functions are stored rather than recomputed
c     as they are in subroutine shsec.  the synthesis is described
c     below at output parameter g.
c
c *** required files from spherepack2
c
c     sphcom.f, hrfft.f
c
c
c     input parameters
c
c     nlat   the number of colatitudes on the full sphere including the
c            poles. for example, nlat = 37 for a five degree grid.
c            nlat determines the grid increment in colatitude as
c            pi/(nlat-1).  if nlat is odd the equator is located at
c            grid point i=(nlat+1)/2. if nlat is even the equator is
c            located half way between points i=nlat/2 and i=nlat/2+1.
c            nlat must be at least 3. note: on the half sphere, the
c            number of grid points in the colatitudinal direction is
c            nlat/2 if nlat is even or (nlat+1)/2 if nlat is odd.
c
c     nlon   the number of distinct londitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater
c            than or equal to 4. the efficiency of the computation is
c            improved when nlon is a product of small prime numbers.
c
c     isym   = 0  no symmetries exist about the equator. the synthesis
c                 is performed on the entire sphere.  i.e. on the
c                 array g(i,j) for i=1,...,nlat and j=1,...,nlon.
c                 (see description of g below)
c
c            = 1  g is antisymmetric about the equator. the synthesis
c                 is performed on the northern hemisphere only.  i.e.
c                 if nlat is odd the synthesis is performed on the
c                 array g(i,j) for i=1,...,(nlat+1)/2 and j=1,...,nlon.
c                 if nlat is even the synthesis is performed on the
c                 array g(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
c
c
c            = 2  g is symmetric about the equator. the synthesis is
c                 performed on the northern hemisphere only.  i.e.
c                 if nlat is odd the synthesis is performed on the
c                 array g(i,j) for i=1,...,(nlat+1)/2 and j=1,...,nlon.
c                 if nlat is even the synthesis is performed on the
c                 array g(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
c
c     nt     the number of syntheses.  in the program that calls shses,
c            the arrays g,a and b can be three dimensional in which
c            case multiple syntheses will be performed.  the third
c            index is the synthesis index which assumes the values
c            k=1,...,nt.  for a single synthesis set nt=1. the
c            discription of the remaining parameters is simplified
c            by assuming that nt=1 or that the arrays g,a and b
c            have only two dimensions.
c
c     idg    the first dimension of the array g as it appears in the
c            program that calls shses.  if isym equals zero then idg
c            must be at least nlat.  if isym is nonzero then idg
c            must be at least nlat/2 if nlat is even or at least
c            (nlat+1)/2 if nlat is odd.
c
c     jdg    the second dimension of the array g as it appears in the
c            program that calls shses.  jdg must be at least nlon.
c
c     a,b    two or three dimensional arrays (see the input parameter
c            nt) that contain the coefficients in the spherical harmonic
c            expansion of g(i,j) given below at the definition of the
c            output parameter g.  a(m,n) and b(m,n) are defined for
c            indices m=1,...,mmax and n=m,...,nlat where mmax is the
c            maximum (plus one) longitudinal wave number given by
c            mmax = min0(nlat,(nlon+2)/2) if nlon is even or
c            mmax = min0(nlat,(nlon+1)/2) if nlon is odd.
c
c     mdab   the first dimension of the arrays a and b as it appears
c            in the program that calls shses. mdab must be at least
c            min0(nlat,(nlon+2)/2) if nlon is even or at least
c            min0(nlat,(nlon+1)/2) if nlon is odd.
c
c     ndab   the second dimension of the arrays a and b as it appears
c            in the program that calls shses. ndab must be at least nlat
c
c     wshses an array which must be initialized by subroutine shsesi.
c            once initialized, wshses can be used repeatedly by shses
c            as long as nlon and nlat remain unchanged.  wshses must
c            not be altered between calls of shses.
c
c     lshses the dimension of the array wshses as it appears in the
c            program that calls shses. define
c
c               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            then lshses must be at least
c
c               (l1*l2*(nlat+nlat-l1+1))/2+nlon+15
c
c     work   a work array that does not have to be saved.
c
c     lwork  the dimension of the array work as it appears in the
c            program that calls shses.  define
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            if isym is zero then lwork must be at least
c
c               (nt+1)*nlat*nlon
c
c            if isym is nonzero lwork must be at least
c
c               (nt+1)*l2*nlon.
c
c     **************************************************************
c
c     output parameters
c
c     g      a two or three dimensional array (see input parameter
c            nt) that contains the spherical harmonic synthesis of
c            the arrays a and b at the colatitude point theta(i) =
c            (i-1)*pi/(nlat-1) and longitude point phi(j) =
c            (j-1)*2*pi/nlon. the index ranges are defined above at
c            at the input parameter isym.  for isym=0, g(i,j) is
c            given by the the equations listed below.  symmetric
c            versions are used when isym is greater than zero.
c
c     the normalized associated legendre functions are given by
c
c     pbar(m,n,theta) = sqrt((2*n+1)*factorial(n-m)/(2*factorial(n+m)))
c                       *sin(theta)**m/(2**n*factorial(n)) times the
c                       (n+m)th derivative of (x**2-1)**n with respect
c                       to x=cos(theta)
c
c     define the maximum (plus one) longitudinal wave number
c     as   mmax = min0(nlat,(nlon+2)/2) if nlon is even or
c          mmax = min0(nlat,(nlon+1)/2) if nlon is odd.
c
c     then g(i,j) = the sum from n=0 to n=nlat-1 of
c
c                   .5*pbar(0,n,theta(i))*a(1,n+1)
c
c              plus the sum from m=1 to m=mmax-1 of
c
c                   the sum from n=m to n=nlat-1 of
c
c              pbar(m,n,theta(i))*(a(m+1,n+1)*cos(m*phi(j))
c                                    -b(m+1,n+1)*sin(m*phi(j)))
c
c
c     ierror = 0  no errors
c            = 1  error in the specification of nlat
c            = 2  error in the specification of nlon
c            = 3  error in the specification of isym
c            = 4  error in the specification of nt
c            = 5  error in the specification of idg
c            = 6  error in the specification of jdg
c            = 7  error in the specification of mdab
c            = 8  error in the specification of ndab
c            = 9  error in the specification of lshses
c            = 10 error in the specification of lwork
c
c
c ****************************************************************
c     subroutine shsesi(nlat,nlon,wshses,lshses,work,lwork,dwork,
c    +                  ldwork,ierror)
c
c     subroutine shsesi initializes the array wshses which can then
c     be used repeatedly by subroutine shses.
c
c     input parameters
c
c     nlat   the number of colatitudes on the full sphere including the
c            poles. for example, nlat = 37 for a five degree grid.
c            nlat determines the grid increment in colatitude as
c            pi/(nlat-1).  if nlat is odd the equator is located at
c            grid point i=(nlat+1)/2. if nlat is even the equator is
c            located half way between points i=nlat/2 and i=nlat/2+1.
c            nlat must be at least 3. note: on the half sphere, the
c            number of grid points in the colatitudinal direction is
c            nlat/2 if nlat is even or (nlat+1)/2 if nlat is odd.
c
c     nlon   the number of distinct londitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater
c            than or equal to 4. the efficiency of the computation is
c            improved when nlon is a product of small prime numbers.
c
c     lshses the dimension of the array wshses as it appears in the
c            program that calls shsesi. define
c
c               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            then lshses must be at least
c
c               (l1*l2*(nlat+nlat-l1+1))/2+nlon+15
c
c     work   a real   work array that does not have to be saved.
c
c     lwork  the dimension of the array work as it appears in
c            the program that calls shsesi.  define
c
c               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            then lwork must be at least
c
c               5*nlat*l2+3*((l1-2)*(nlat+nlat-l1-1))/2
c
c
C*PL*ERROR* Comment line too long
c     dwork  a double precision work array that does not have to be saved.
c
c     ldwork the dimension of the array dwork as it appears in the
c            program that calls shsesi.  ldwork must be at least nlat+1
c
c
c     output parameters
c
c     wshses an array which is initialized for use by subroutine shses.
c            once initialized, wshses can be used repeatedly by shses
c            as long as nlon and nlat remain unchanged.  wshses must
c            not be altered between calls of shses.
c
c     ierror = 0  no errors
c            = 1  error in the specification of nlat
c            = 2  error in the specification of nlon
c            = 3  error in the specification of lshses
c            = 4  error in the specification of lwork
c            = 5  error in the specification of ldwork
c
c ****************************************************************
      SUBROUTINE DSHSES(NLAT,NLON,ISYM,NT,G,IDG,JDG,A,B,MDAB,NDAB,
     +                  WSHSES,LSHSES,WORK,LWORK,IERROR)
      DOUBLE PRECISION G
      DOUBLE PRECISION A
      DOUBLE PRECISION B
      DOUBLE PRECISION WSHSES
      DOUBLE PRECISION WORK
      DIMENSION G(IDG,JDG,1),A(MDAB,NDAB,1),B(MDAB,NDAB,1),WSHSES(1),
     +          WORK(1)

      IERROR = 1
      IF (NLAT.LT.3) RETURN
      IERROR = 2
      IF (NLON.LT.4) RETURN
      IERROR = 3
      IF (ISYM.LT.0 .OR. ISYM.GT.2) RETURN
      IERROR = 4
      IF (NT.LT.0) RETURN
      IERROR = 5
      IF ((ISYM.EQ.0.AND.IDG.LT.NLAT) .OR.
     +    (ISYM.NE.0.AND.IDG.LT. (NLAT+1)/2)) RETURN
      IERROR = 6
      IF (JDG.LT.NLON) RETURN
      IERROR = 7
      MMAX = MIN0(NLAT,NLON/2+1)
      IF (MDAB.LT.MMAX) RETURN
      IERROR = 8
      IF (NDAB.LT.NLAT) RETURN
      IERROR = 9
      IMID = (NLAT+1)/2
      LPIMN = (IMID*MMAX* (NLAT+NLAT-MMAX+1))/2
      IF (LSHSES.LT.LPIMN+NLON+15) RETURN
      IERROR = 10
      LS = NLAT
      IF (ISYM.GT.0) LS = IMID
      NLN = NT*LS*NLON
      IF (LWORK.LT.NLN+LS*NLON) RETURN
      IERROR = 0
      IST = 0
      IF (ISYM.EQ.0) IST = IMID
      CALL DSHSES1(NLAT,ISYM,NT,G,IDG,JDG,A,B,MDAB,NDAB,WSHSES,IMID,LS,
     +            NLON,WORK,WORK(IST+1),WORK(NLN+1),WSHSES(LPIMN+1))
      RETURN
      END
      SUBROUTINE DSHSES1(NLAT,ISYM,NT,G,IDGS,JDGS,A,B,MDAB,NDAB,P,IMID,
     +                  IDG,JDG,GE,GO,WORK,WHRFFT)
      DOUBLE PRECISION G
      DOUBLE PRECISION A
      DOUBLE PRECISION B
      DOUBLE PRECISION P
      DOUBLE PRECISION GE
      DOUBLE PRECISION GO
      DOUBLE PRECISION WORK
      DOUBLE PRECISION WHRFFT
      DIMENSION G(IDGS,JDGS,1),A(MDAB,NDAB,1),B(MDAB,NDAB,1),P(IMID,1),
     +          GE(IDG,JDG,1),GO(IDG,JDG,1),WORK(1),WHRFFT(1)

      LS = IDG
      NLON = JDG
      MMAX = MIN0(NLAT,NLON/2+1)
      MDO = MMAX
      IF (MDO+MDO-1.GT.NLON) MDO = MMAX - 1
      NLP1 = NLAT + 1
      MODL = MOD(NLAT,2)
      IMM1 = IMID
      IF (MODL.NE.0) IMM1 = IMID - 1
      DO 80 K = 1,NT
          DO 80 J = 1,NLON
              DO 80 I = 1,LS
                  GE(I,J,K) = 0.D0
 8000             CONTINUE
  800             CONTINUE
   80 CONTINUE
      IF (ISYM.EQ.1) GO TO 125
      DO 100 K = 1,NT
          DO 100 NP1 = 1,NLAT,2
              DO 100 I = 1,IMID
                  GE(I,1,K) = GE(I,1,K) + A(1,NP1,K)*P(I,NP1)
  100 CONTINUE
      NDO = NLAT
      IF (MOD(NLAT,2).EQ.0) NDO = NLAT - 1
      DO 110 MP1 = 2,MDO
          M = MP1 - 1
          MB = M* (NLAT-1) - (M* (M-1))/2
          DO 110 NP1 = MP1,NDO,2
              MN = MB + NP1
              DO 110 K = 1,NT
                  DO 110 I = 1,IMID
                      GE(I,2*MP1-2,K) = GE(I,2*MP1-2,K) +
     +                                  A(MP1,NP1,K)*P(I,MN)
                      GE(I,2*MP1-1,K) = GE(I,2*MP1-1,K) +
     +                                  B(MP1,NP1,K)*P(I,MN)
  110 CONTINUE
      IF (MDO.EQ.MMAX .OR. MMAX.GT.NDO) GO TO 122
      MB = MDO* (NLAT-1) - (MDO* (MDO-1))/2
      DO 120 NP1 = MMAX,NDO,2
          MN = MB + NP1
          DO 120 K = 1,NT
              DO 120 I = 1,IMID
                  GE(I,2*MMAX-2,K) = GE(I,2*MMAX-2,K) +
     +                               A(MMAX,NP1,K)*P(I,MN)
  120 CONTINUE
  122 IF (ISYM.EQ.2) GO TO 155
  125 DO 140 K = 1,NT
          DO 140 NP1 = 2,NLAT,2
              DO 140 I = 1,IMM1
                  GO(I,1,K) = GO(I,1,K) + A(1,NP1,K)*P(I,NP1)
  140 CONTINUE
      NDO = NLAT
      IF (MOD(NLAT,2).NE.0) NDO = NLAT - 1
      DO 150 MP1 = 2,MDO
          MP2 = MP1 + 1
          M = MP1 - 1
          MB = M* (NLAT-1) - (M* (M-1))/2
          DO 150 NP1 = MP2,NDO,2
              MN = MB + NP1
              DO 150 K = 1,NT
                  DO 150 I = 1,IMM1
                      GO(I,2*MP1-2,K) = GO(I,2*MP1-2,K) +
     +                                  A(MP1,NP1,K)*P(I,MN)
                      GO(I,2*MP1-1,K) = GO(I,2*MP1-1,K) +
     +                                  B(MP1,NP1,K)*P(I,MN)
  150 CONTINUE
      MP2 = MMAX + 1
      IF (MDO.EQ.MMAX .OR. MP2.GT.NDO) GO TO 155
      MB = MDO* (NLAT-1) - (MDO* (MDO-1))/2
      DO 152 NP1 = MP2,NDO,2
          MN = MB + NP1
          DO 152 K = 1,NT
              DO 152 I = 1,IMM1
                  GO(I,2*MMAX-2,K) = GO(I,2*MMAX-2,K) +
     +                               A(MMAX,NP1,K)*P(I,MN)
  152 CONTINUE
  155 DO 160 K = 1,NT
          IF (MOD(NLON,2).NE.0) GO TO 157
          DO 156 I = 1,LS
              GE(I,NLON,K) = 2.D0*GE(I,NLON,K)
  156     CONTINUE
  157     CALL DHRFFTB(LS,NLON,GE(1,1,K),LS,WHRFFT,WORK)
  160 CONTINUE
      IF (ISYM.NE.0) GO TO 180
      DO 170 K = 1,NT
          DO 170 J = 1,NLON
              DO 175 I = 1,IMM1
                  G(I,J,K) = .5D0* (GE(I,J,K)+GO(I,J,K))
                  G(NLP1-I,J,K) = .5D0* (GE(I,J,K)-GO(I,J,K))
  175         CONTINUE
              IF (MODL.EQ.0) GO TO 170
              G(IMID,J,K) = .5D0*GE(IMID,J,K)
  170 CONTINUE
      RETURN
  180 DO 185 K = 1,NT
          DO 185 I = 1,IMID
              DO 185 J = 1,NLON
                  G(I,J,K) = .5D0*GE(I,J,K)
  185 CONTINUE
      RETURN
      END

      SUBROUTINE DSHSESI(NLAT,NLON,WSHSES,LSHSES,WORK,LWORK,DWORK,
     +                   LDWORK,IERROR)
      DOUBLE PRECISION WSHSES
      DOUBLE PRECISION WORK
      DIMENSION WSHSES(*),WORK(*)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION DWORK(*)

      IERROR = 1
      IF (NLAT.LT.3) RETURN
      IERROR = 2
      IF (NLON.LT.4) RETURN
      IERROR = 3
      MMAX = MIN0(NLAT,NLON/2+1)
      IMID = (NLAT+1)/2
      LPIMN = (IMID*MMAX* (NLAT+NLAT-MMAX+1))/2
      IF (LSHSES.LT.LPIMN+NLON+15) RETURN
      IERROR = 4
      LABC = 3* ((MMAX-2)* (NLAT+NLAT-MMAX-1))/2
      IF (LWORK.LT.5*NLAT*IMID+LABC) RETURN
      IERROR = 5
      IF (LDWORK.LT.NLAT+1) RETURN
      IERROR = 0
      IW1 = 3*NLAT*IMID + 1
      CALL DSES1(NLAT,NLON,IMID,WSHSES,WORK,WORK(IW1),DWORK)
      CALL DHRFFTI(NLON,WSHSES(LPIMN+1))
      RETURN
      END

C
C $Id: wtproj.f,v 1.4 2008-09-18 00:42:18 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE WTPROJ (DLAT,DLON,UVAL,VVAL,CSLT)
C
        DOUBLE PRECISION DLAT,DLON,UVAL,VVAL,CSLT
C
C The subroutine WTPROJ implements a closed form of the Winkel tripel
C projection, using formulas identical to those given on various Web
C sites (for example, Wikipedia), using the rather odd function SINC(X),
C the value of which is SIN(X)/X, when X is not zero, and 1, otherwise.
C For efficiency, this function is incorporated into the local code.
C
C DLAT and DLON are input values of latitude and longitude, in radians.
C UVAL and VVAL are output values of U and V, in the projection plane.
C CSLT is the cosine of the standard parallel of the Winkel tripel, for
C which Winkel used ACOS(2/PI); in EZMAP, though, it is allowed to vary.
C
C Local variable.
C
        DOUBLE PRECISION TVAL
C
        TVAL=ACOS(COS(DLAT)*COS(.5D0*DLON))
C
        IF (ABS(TVAL).GT.1.D-6) THEN
          TVAL=SIN(TVAL)/TVAL
        ELSE
          TVAL=1.D0
        END IF
C
        UVAL=2.D0*COS(DLAT)*SIN(.5D0*DLON)/TVAL
        VVAL=SIN(DLAT)/TVAL
C
        UVAL=.5D0*(DLON*CSLT+UVAL)
        VVAL=.5D0*(DLAT+VVAL)
C
        RETURN
C
      END

      PROGRAM MPEX06
C
C This program produces a single frame showing satellite views
C of the globe, each rotated by a different angle.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
        PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Define the label for the top of the map.
C
      CHARACTER*27 PLBL
C
      DATA PLBL / 'THE EARTH IS SPINNING, TOTO' /
C
C Open GKS.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Set the outline-dataset parameter.
C
      CALL MAPSTC ('OU','PS')
C
C Use a satellite-view projection.
C
      CALL MAPSTR ('SA',1.25)
C
C Aim the camera 15 degrees away from straight down.
C
      CALL MAPSTI ('S1',15)
C
C Turn off the perimeter and reduce the number of grid lines.
C
      CALL MAPSTI ('PE',0)
      CALL MAPSTI ('GR',15)
C
C Center the first map over Kansas.  Rotate by 0 degrees and look
C to the upper left.
C
      CALL MAPPOS (.05,.475,.525,.95)
      CALL MAPROJ ('SV',38.,-98.,0.)
      CALL MAPSTI ('S2',135)
      CALL MAPDRW
C
C Repeat, but rotate by 90 degrees and look to the upper right.
C
      CALL MAPPOS (.525,.95,.525,.95)
      CALL MAPROJ ('SV',38.,-98.,90.)
      CALL MAPSTI ('S2',45)
      CALL MAPDRW
C
C Repeat, but rotate by 180 degrees and look to the lower left.
C
      CALL MAPPOS (.05,.475,.05,.475)
      CALL MAPROJ ('SV',38.,-98.,180.)
      CALL MAPSTI ('S2',-135)
      CALL MAPDRW
C
C Repeat, but rotate by 270 degrees and look to the lower right.
C
      CALL MAPPOS (.525,.95,.05,.475)
      CALL MAPROJ ('SV',38.,-98.,270.)
      CALL MAPSTI ('S2',-45)
      CALL MAPDRW
C
C Put the label at the top of the plot ...
C
      CALL SET (0.,1.,0.,1.,0.,1.,0.,1.,1)
      CALL PWRIT (.5,.975,PLBL,27,2,0,0)
C
C and the ones below each sub-plot.
C
      CALL PWRIT (.2625,.5,'ROTA = 0',8,1,0,0)
      CALL PWRIT (.7375,.5,'ROTA = 90',9,1,0,0)
      CALL PWRIT (.2625,.025,'ROTA = 180',10,1,0,0)
      CALL PWRIT (.7375,.025,'ROTA = 270',10,1,0,0)
C
C Draw a boundary around the edge of the plotter frame.
C
      CALL BNDARY
C
C Advance the frame.
C
      CALL FRAME
C
C Close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
C Done.
C
      STOP
C
      END

C
C $Id: drawt.f,v 1.6 2008-07-27 00:17:33 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE DRAWT (IXA,IYA,IXB,IYB)
      CALL PLOTIT(32*IXA,32*IYA,0)
      IIX = 32*IXB
      IIY = 32*IYB
      CALL PLOTIT(IIX,IIY,1)
C
C FLUSH PLOTIT BUFFER
C
      CALL PLOTIT(0,0,0)
      RETURN
      END

C
C $Id: adjlsp.f,v 1.5 2008-07-27 00:17:08 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      REAL FUNCTION ADJLSP (LON)
C
C This function adjusts a longitude angle modulo 180 degrees.
C
      IMPLICIT REAL (A-Z)
      DATA TWO,PI /2.0E0,3.14159265358979323846E0/
C
   20 ADJLSP = LON
      IF (ABS(LON) .LE. PI) RETURN
      TWOPI = TWO * PI
      LON = LON - SIGN (TWOPI,LON)
      GO TO 20
C
      END

C
C $Id: idgeti.f,v 1.4 2008-07-27 00:17:30 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE IDGETI (PNAM,IVAL)
C
C Get in IVAL the integer value of the BIVAR parameter named PNAM.
C
        CHARACTER*(*) PNAM
C
C Check for an uncleared prior error.
C
        IF (ICFELL('IDGETI (BIVAR) - UNCLEARED PRIOR ERROR',1).NE.0)
     +                                                        RETURN
C
C Call IDGETR to obtain the real value of the parameter and then
C return the integer portion of that.
C
        CALL IDGETR (PNAM,RVAL)
        IF (ICFELL('IDGETI',2).NE.0) RETURN
        IVAL=INT(RVAL)
C
C Done.
C
        RETURN
C
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C   FFTPACK 5.0
C   Copyright (C) 1995-2004, Scientific Computing Division,
C   University Corporation for Atmospheric Research
C   Licensed under the GNU General Public License (GPL)
C
C   Authors:  Paul N. Swarztrauber and Richard A. Valent
C
C   $Id: c1f3kf.f,v 1.2 2006-11-21 01:10:15 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      SUBROUTINE DC1F3KF(IDO,L1,NA,CC,IN1,CH,IN2,WA)
      DOUBLE PRECISION TAUR
      DOUBLE PRECISION TAUI
      DOUBLE PRECISION SN
      DOUBLE PRECISION TR2
      DOUBLE PRECISION CR2
      DOUBLE PRECISION TI2
      DOUBLE PRECISION CI2
      DOUBLE PRECISION CR3
      DOUBLE PRECISION CI3
      DOUBLE PRECISION DR2
      DOUBLE PRECISION DR3
      DOUBLE PRECISION DI2
      DOUBLE PRECISION DI3
      DOUBLE PRECISION CC(IN1,L1,IDO,3),CH(IN2,L1,3,IDO),WA(IDO,2,2)
      DATA TAUR,TAUI/-.5D0,-.866025403784439D0/
C
      IF (IDO.GT.1) GO TO 102
      SN = 1.D0/DBLE(3*L1)
      IF (NA.EQ.1) GO TO 106
      DO 101 K = 1,L1
          TR2 = CC(1,K,1,2) + CC(1,K,1,3)
          CR2 = CC(1,K,1,1) + TAUR*TR2
          CC(1,K,1,1) = SN* (CC(1,K,1,1)+TR2)
          TI2 = CC(2,K,1,2) + CC(2,K,1,3)
          CI2 = CC(2,K,1,1) + TAUR*TI2
          CC(2,K,1,1) = SN* (CC(2,K,1,1)+TI2)
          CR3 = TAUI* (CC(1,K,1,2)-CC(1,K,1,3))
          CI3 = TAUI* (CC(2,K,1,2)-CC(2,K,1,3))
          CC(1,K,1,2) = SN* (CR2-CI3)
          CC(1,K,1,3) = SN* (CR2+CI3)
          CC(2,K,1,2) = SN* (CI2+CR3)
          CC(2,K,1,3) = SN* (CI2-CR3)
  101 CONTINUE
      RETURN
  106 DO 107 K = 1,L1
          TR2 = CC(1,K,1,2) + CC(1,K,1,3)
          CR2 = CC(1,K,1,1) + TAUR*TR2
          CH(1,K,1,1) = SN* (CC(1,K,1,1)+TR2)
          TI2 = CC(2,K,1,2) + CC(2,K,1,3)
          CI2 = CC(2,K,1,1) + TAUR*TI2
          CH(2,K,1,1) = SN* (CC(2,K,1,1)+TI2)
          CR3 = TAUI* (CC(1,K,1,2)-CC(1,K,1,3))
          CI3 = TAUI* (CC(2,K,1,2)-CC(2,K,1,3))
          CH(1,K,2,1) = SN* (CR2-CI3)
          CH(1,K,3,1) = SN* (CR2+CI3)
          CH(2,K,2,1) = SN* (CI2+CR3)
          CH(2,K,3,1) = SN* (CI2-CR3)
  107 CONTINUE
      RETURN
  102 DO 103 K = 1,L1
          TR2 = CC(1,K,1,2) + CC(1,K,1,3)
          CR2 = CC(1,K,1,1) + TAUR*TR2
          CH(1,K,1,1) = CC(1,K,1,1) + TR2
          TI2 = CC(2,K,1,2) + CC(2,K,1,3)
          CI2 = CC(2,K,1,1) + TAUR*TI2
          CH(2,K,1,1) = CC(2,K,1,1) + TI2
          CR3 = TAUI* (CC(1,K,1,2)-CC(1,K,1,3))
          CI3 = TAUI* (CC(2,K,1,2)-CC(2,K,1,3))
          CH(1,K,2,1) = CR2 - CI3
          CH(1,K,3,1) = CR2 + CI3
          CH(2,K,2,1) = CI2 + CR3
          CH(2,K,3,1) = CI2 - CR3
  103 CONTINUE
      DO 105 I = 2,IDO
          DO 104 K = 1,L1
              TR2 = CC(1,K,I,2) + CC(1,K,I,3)
              CR2 = CC(1,K,I,1) + TAUR*TR2
              CH(1,K,1,I) = CC(1,K,I,1) + TR2
              TI2 = CC(2,K,I,2) + CC(2,K,I,3)
              CI2 = CC(2,K,I,1) + TAUR*TI2
              CH(2,K,1,I) = CC(2,K,I,1) + TI2
              CR3 = TAUI* (CC(1,K,I,2)-CC(1,K,I,3))
              CI3 = TAUI* (CC(2,K,I,2)-CC(2,K,I,3))
              DR2 = CR2 - CI3
              DR3 = CR2 + CI3
              DI2 = CI2 + CR3
              DI3 = CI2 - CR3
              CH(2,K,2,I) = WA(I,1,1)*DI2 - WA(I,1,2)*DR2
              CH(1,K,2,I) = WA(I,1,1)*DR2 + WA(I,1,2)*DI2
              CH(2,K,3,I) = WA(I,2,1)*DI3 - WA(I,2,2)*DR3
              CH(1,K,3,I) = WA(I,2,1)*DR3 + WA(I,2,2)*DI3
  104     CONTINUE
  105 CONTINUE
      RETURN
      END

C
C	$Id: devmap.f,v 1.4 2008-07-27 12:23:43 haley Exp $
C                                                                      
C			     Copyright (C)  1997
C	     University Corporation for Atmospheric Research
C			     All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C

      SUBROUTINE DEVMAP(WHICH, IOS, STATUS)
C
C  Process the DEVICE_MAP keywords.
C
C
C  INPUT
C       WHICH   --  the encoded path flags.
C
C  OUTPUT
C       IOS     --  I/O status flag.  This flag is valid only
C                   if STATUS indicates an error.
C       STATUS  --  The error status as defined in COMMON CAPERR.
C
C
      COMMON /CAPDEV/ DGISTR, DGISIZ, DGESTR, DGESIZ, DTISTR,
     1                DTISIZ, DCDLLX, DCDLLY, DCDURX, DCDURY,
     3                DCOAVL, CORFMT, CORFIN, BATCH , DHCSIZ,
     4                DHCSTR, CORXOF, CORYOF, DASBIT, CORXSC,
     5                CORYSC, VDWLLX, VDWLLY, VDWURX, VDWURY
      INTEGER         DGIMAX, DGEMAX, DTIMAX, DCFTMX, DHCMAX
      PARAMETER   (DGIMAX=300, DGEMAX=150, DTIMAX=100)
      PARAMETER   (DCFTMX=30 , DHCMAX=50)
      INTEGER         DGISTR(DGIMAX), DGISIZ, DGESTR(DGEMAX),
     1                DGESIZ, DTISTR(DTIMAX), DTISIZ, DCDLLX,
     2                DCDLLY, DCDURX, DCDURY, CORFMT(DCFTMX,4),
     3                CORFIN(8)     , DHCSIZ, DHCSTR(DHCMAX),
     4                CORXOF, CORYOF, DASBIT, VDWLLX, VDWLLY,
     5                VDWURX, VDWURY
      REAL            CORXSC, CORYSC, CORRIN(8)
      LOGICAL         DCOAVL, BATCH
C  Size of the COMMON
      INTEGER         LENDEV
      PARAMETER   (LENDEV=DGIMAX+1+DGEMAX+1+DTIMAX+1+4+1+4*DCFTMX+
     1                  8+2+DHCMAX+9)
      EQUIVALENCE (CORFIN,CORRIN)
      COMMON /CAPCOL/ COLINT, COLIDX, IDXCUR, VDMINT, DMPAVL, COLFMT
     1               ,COLFIN, IDXMAX, MSTSTR, MSTSIZ, MTRSTR, DMPMDL
     2               ,MTRSIZ, DMPIDV, DMPFIN, DMPFMT
      INTEGER         MAPMAX, COLMAX, MSTMAX, MTRMAX, DMPMAX
      PARAMETER   (MAPMAX=256, COLMAX=15, MSTMAX=50, MTRMAX=20)
      PARAMETER   (DMPMAX=50)
      INTEGER         COLINT(MAPMAX*3)      , COLIDX(MAPMAX), IDXCUR,
     1                VDMINT, COLFMT(COLMAX,4)      , COLFIN(8)     ,
     2                IDXMAX, MSTSTR(MSTMAX), MSTSIZ, MTRSTR(MTRMAX),
     3                DMPMDL, MTRSIZ, DMPFIN(8)     , DMPFMT(DMPMAX,4)
      LOGICAL         DMPAVL, DMPIDV
      REAL            COLRIN(8),DMPRIN(8)
      INTEGER LENCOL
      PARAMETER   (LENCOL=MAPMAX*3+MAPMAX+1+1+1+COLMAX*4+8+1+MSTMAX+
     1                    1+MTRMAX+1+1+1+8+DMPMAX*4)
      EQUIVALENCE (COLFIN,COLRIN),(DMPFIN,DMPRIN)
      COMMON /CAPERR/ ALLOK, EOFFL, INTERR, MAXINT, PLBERR, PMBERR,
     1                FABERR, TXBERR, FLTERR, MAXFLT, NOTINT, SIZERR,
     2                UNDASC, DEVERR, DOCERR, TBLERR , STSZER, ENTERR,
     3                TABERR, TABSER, PRSFIL
      INTEGER ALLOK, EOFFL, INTERR, MAXINT, PLBERR, PMBERR,
     1        FABERR, TXBERR, FLTERR, MAXFLT, NOTINT, SIZERR, UNDASC,
     2        DEVERR, DOCERR, STSZER, ENTERR, TABERR, TABSER, TBLERR,
     3        PRSFIL
      COMMON /PARTB1/ PART1, KEYSEP, KEYTER, FRMCOM
      COMMON /PARTB2/ PART2, PART3, PART4, PART5, CTSTR, CTLOC
C
C  THE NUMBER OF WORDS IN THE SEARCH PATH MUST BE BIG ENOUGH TO HOLD
C       THE NUMBER OF BITS PER PATH TIMES THE NUMBER OF LEVELS
C
      INTEGER WHSIZE
      PARAMETER (WHSIZE=20)
C
      INTEGER PARTSZ, OTHSZ, NTABLE
      PARAMETER(PARTSZ=3000, OTHSZ=150, NTABLE=50)
      CHARACTER*1 KEYSEP,KEYTER
      CHARACTER*1 FRMCOM(2)
      INTEGER PART2(OTHSZ), PART3(OTHSZ), PART4(NTABLE), PART5(NTABLE*2)
      CHARACTER*1 PART1(PARTSZ)
      INTEGER CTSTR, CTLOC
C
      INTEGER IOS, STATUS, WHICH(WHSIZE)
      INTEGER ROW3, ROW4, DUMMY, II, JJ, HOLDER(DMPMAX*4)
C
C  Get levels 3 and 4 of the parse path.
C
      ROW3 = WHICH(3)
      ROW4 = WHICH(4)
C
C  Branch to proper keyword processing.
C
C       ROW3    ROW4    Keyword
C       ----    ----    ---------------------------------------
C       1               DEVICE_MAP_AVAILABLE
C       2       1       DEVICE_MAP_INDEX_RANGE_MAX
C       2       2       DEVICE_MAP_INDEX_RANGE_DEFINED
C       3       1       DEVICE_MAP_INTENSITY_FORMAT
C       3       2       DEVICE_MAP_INTENSITY_ENCODING
C       3       3       DEVICE_MAP_INTENSITY_FLOATING_INFO
C       4               DEVICE_MAP_INDIVIDUAL
C       5       1       DEVICE_MAP_INSTRUCTION_START
C       5       2       DEVICE_MAP_INSTRUCTION_TERMINATOR
C       6               DEVCIE_MAP_INIT
C       7               DEVICE_MAP_MODEL
C
      IF (ROW3.EQ.1) THEN
        CALL GTLOG(DMPAVL, 1, DUMMY, IOS, STATUS)
      ELSE IF (ROW3.EQ.2) THEN
        IF (ROW4.EQ.1) THEN
                CALL GTINT(IDXMAX, 1, DUMMY, IOS, STATUS)
        ELSE IF (ROW4.EQ.2) THEN
                CALL GTINT(IDXCUR, 1, DUMMY, IOS, STATUS)
C
C  Set the index user map up through IDXCUR.
C
                DO 100 II = 1, IDXCUR
                        COLIDX(II) = II-1
 100            CONTINUE
C
C  If the map maximum index is not set, set it to the current size.
C
                IF (IDXMAX .EQ. 0) IDXMAX = IDXCUR
        END IF
      ELSE IF (ROW3.EQ.3) THEN
        IF (ROW4 .EQ. 1) THEN
                CALL GTINT(HOLDER, DMPMAX*4, DUMMY, IOS, STATUS)
                IF (DUMMY .NE. 0) THEN
                        DMPFIN(2) = DUMMY/4
                        DO 10 II = 1,DMPFIN(2)
                        DO 10 JJ = 1,4
                                DMPFMT(II,JJ) = HOLDER((II-1)*4+JJ)
 10                     CONTINUE
                END IF
        ELSE IF (ROW4.EQ.2) THEN
                CALL GTINT(DMPFIN(1), 1, DUMMY, IOS, STATUS)
        ELSE IF (ROW4.EQ.3) THEN
                CALL GTFLT(DMPRIN(5), 4, DUMMY, IOS, STATUS)
        END IF
      ELSE IF (ROW3 .EQ. 4) THEN
                CALL GTLOG(DMPIDV, 1, DUMMY, IOS, STATUS)
      ELSE IF (ROW3.EQ.5 .AND. ROW4.EQ.1) THEN
                CALL GTSTR(MSTSTR, MSTMAX, MSTSIZ, IOS, STATUS)
      ELSE IF (ROW3.EQ.5 .AND. ROW4.EQ.2) THEN
                CALL GTSTR(MTRSTR, MTRMAX, MTRSIZ, IOS, STATUS)
      ELSE IF (ROW3 .EQ. 6) THEN
                CALL GTINT(COLINT, MAPMAX*3, DUMMY, IOS, STATUS)
      ELSE IF (ROW3 .EQ. 7) THEN
                CALL GTINT(DMPMDL, 1, DUMMY, IOS, STATUS)
      END IF
C
      RETURN
      END

C
C $Id: e2fndp.f,v 1.5 2008-07-27 00:17:08 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      DOUBLE PRECISION FUNCTION E2FNDP (ECCNTS)
C
C This function computes the constant E2.
C
      IMPLICIT DOUBLE PRECISION (A-Z)
      DATA CON1,CON2 /0.05859375D0,0.75D0/
      DATA ONE /1.0D0/
C
      E2FNDP = CON1 * ECCNTS * ECCNTS * (ONE + CON2 * ECCNTS)
C
      RETURN
      END

c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by UCAR                 .
c  .                                                             .
c  .       University Corporation for Atmospheric Research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                         SPHEREPACK                          .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c
c
c ... file shsgs.f
c
c     this file contains code and documentation for subroutines
c     shsgs and shsgsi
c
c ... files which must be loaded with shsgs.f
c
c     sphcom.f, hrfft.f, gaqd.f
c
c     subroutine shsgs(nlat,nlon,isym,nt,g,idg,jdg,a,b,mdab,ndab,
c    1                    wshsgs,lshsgs,work,lwork,ierror)
c
c     subroutine shsgs performs the spherical harmonic synthesis
c     on the arrays a and b and stores the result in the array g.
c     the synthesis is performed on an equally spaced longitude grid
c     and a gaussian colatitude grid.  the associated legendre functions
c     are stored rather than recomputed as they are in subroutine
c     shsgc.  the synthesis is described below at output parameter
c     g.
c
c
c     input parameters
c
c     nlat   the number of points in the gaussian colatitude grid on the
c            full sphere. these lie in the interval (0,pi) and are compu
c            in radians in theta(1),...,theta(nlat) by subroutine gaqd.
c            if nlat is odd the equator will be included as the grid poi
c            theta((nlat+1)/2).  if nlat is even the equator will be
c            excluded as a grid point and will lie half way between
c            theta(nlat/2) and theta(nlat/2+1). nlat must be at least 3.
c            note: on the half sphere, the number of grid points in the
c            colatitudinal direction is nlat/2 if nlat is even or
c            (nlat+1)/2 if nlat is odd.
c
c     nlon   the number of distinct londitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater
c            than or equal to 4. the efficiency of the computation is
c            improved when nlon is a product of small prime numbers.
c
c     isym   = 0  no symmetries exist about the equator. the synthesis
c                 is performed on the entire sphere.  i.e. on the
c                 array g(i,j) for i=1,...,nlat and j=1,...,nlon.
c                 (see description of g below)
c
c            = 1  g is antisymmetric about the equator. the synthesis
c                 is performed on the northern hemisphere only.  i.e.
c                 if nlat is odd the synthesis is performed on the
c                 array g(i,j) for i=1,...,(nlat+1)/2 and j=1,...,nlon.
c                 if nlat is even the synthesis is performed on the
c                 array g(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
c
c
c            = 2  g is symmetric about the equator. the synthesis is
c                 performed on the northern hemisphere only.  i.e.
c                 if nlat is odd the synthesis is performed on the
c                 array g(i,j) for i=1,...,(nlat+1)/2 and j=1,...,nlon.
c                 if nlat is even the synthesis is performed on the
c                 array g(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
c
c     nt     the number of syntheses.  in the program that calls shsgs,
c            the arrays g,a and b can be three dimensional in which
c            case multiple synthesis will be performed.  the third
c            index is the synthesis index which assumes the values
c            k=1,...,nt.  for a single synthesis set nt=1. the
c            discription of the remaining parameters is simplified
c            by assuming that nt=1 or that the arrays g,a and b
c            have only two dimensions.
c
c     idg    the first dimension of the array g as it appears in the
c            program that calls shagc. if isym equals zero then idg
c            must be at least nlat.  if isym is nonzero then idg must
c            be at least nlat/2 if nlat is even or at least (nlat+1)/2
c            if nlat is odd.
c
c     jdg    the second dimension of the array g as it appears in the
c            program that calls shagc. jdg must be at least nlon.
c
c     a,b    two or three dimensional arrays (see the input parameter
c            nt) that contain the coefficients in the spherical harmonic
c            expansion of g(i,j) given below at the definition of the
c            output parameter g.  a(m,n) and b(m,n) are defined for
c            indices m=1,...,mmax and n=m,...,nlat where mmax is the
c            maximum (plus one) longitudinal wave number given by
c            mmax = min0(nlat,(nlon+2)/2) if nlon is even or
c            mmax = min0(nlat,(nlon+1)/2) if nlon is odd.
c
c     mdab   the first dimension of the arrays a and b as it appears
c            in the program that calls shsgs. mdab must be at least
c            min0((nlon+2)/2,nlat) if nlon is even or at least
c            min0((nlon+1)/2,nlat) if nlon is odd.
c
c     ndab   the second dimension of the arrays a and b as it appears
c            in the program that calls shsgs. ndab must be at least nlat
c
c     wshsgs an array which must be initialized by subroutine shsgsi.
c            once initialized, wshsgs can be used repeatedly by shsgs
c            as long as nlat and nlon remain unchanged.  wshsgs must
c            not be altered between calls of shsgs.
c
c     lshsgs the dimension of the array wshsgs as it appears in the
c            program that calls shsgs. define
c
c               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            then lshsgs must be at least
c
c            nlat*(3*(l1+l2)-2)+(l1-1)*(l2*(2*nlat-l1)-3*l1)/2+nlon+15
c
c
c     lwork  the dimension of the array work as it appears in the
c            program that calls shsgs. define
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c
c            if isym is zero then lwork must be at least
c
c                  nlat*nlon*(nt+1)
c
c            if isym is nonzero then lwork must be at least
c
c                  l2*nlon*(nt+1)
c
c
c     **************************************************************
c
c     output parameters
c
c     g      a two or three dimensional array (see input parameter nt)
c            that contains the discrete function which is synthesized.
c            g(i,j) contains the value of the function at the gaussian
c            colatitude point theta(i) and longitude point
c            phi(j) = (j-1)*2*pi/nlon. the index ranges are defined
c            above at the input parameter isym.  for isym=0, g(i,j)
c            is given by the the equations listed below.  symmetric
c            versions are used when isym is greater than zero.
c
c     the normalized associated legendre functions are given by
c
c     pbar(m,n,theta) = sqrt((2*n+1)*factorial(n-m)/(2*factorial(n+m)))
c                       *sin(theta)**m/(2**n*factorial(n)) times the
c                       (n+m)th derivative of (x**2-1)**n with respect
c                       to x=cos(theta)
c
c     define the maximum (plus one) longitudinal wave number
c     as   mmax = min0(nlat,(nlon+2)/2) if nlon is even or
c          mmax = min0(nlat,(nlon+1)/2) if nlon is odd.
c
c     then g(i,j) = the sum from n=0 to n=nlat-1 of
c
c                   .5*pbar(0,n,theta(i))*a(1,n+1)
c
c              plus the sum from m=1 to m=mmax-1 of
c
c                   the sum from n=m to n=nlat-1 of
c
c              pbar(m,n,theta(i))*(a(m+1,n+1)*cos(m*phi(j))
c                                    -b(m+1,n+1)*sin(m*phi(j)))
c
c
c     ierror = 0  no errors
c            = 1  error in the specification of nlat
c            = 2  error in the specification of nlon
c            = 3  error in the specification of isym
c            = 4  error in the specification of nt
c            = 5  error in the specification of idg
c            = 6  error in the specification of jdg
c            = 7  error in the specification of mdab
c            = 8  error in the specification of ndab
c            = 9  error in the specification of lshsgs
c            = 10 error in the specification of lwork
c
c
c ****************************************************************
c
c     subroutine shsgsi(nlat,nlon,wshsgs,lshsgs,work,lwork,dwork,ldwork,
c    +                  ierror)
c
c     subroutine shsgsi initializes the array wshsgs which can then
c     be used repeatedly by subroutines shsgs. it precomputes
c     and stores in wshsgs quantities such as gaussian weights,
c     legendre polynomial coefficients, and fft trigonometric tables.
c
c     input parameters
c
c     nlat   the number of points in the gaussian colatitude grid on the
c            full sphere. these lie in the interval (0,pi) and are compu
c            in radians in theta(1),...,theta(nlat) by subroutine gaqd.
c            if nlat is odd the equator will be included as the grid poi
c            theta((nlat+1)/2).  if nlat is even the equator will be
c            excluded as a grid point and will lie half way between
c            theta(nlat/2) and theta(nlat/2+1). nlat must be at least 3.
c            note: on the half sphere, the number of grid points in the
c            colatitudinal direction is nlat/2 if nlat is even or
c            (nlat+1)/2 if nlat is odd.
c
c     nlon   the number of distinct londitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater
c            than or equal to 4. the efficiency of the computation is
c            improved when nlon is a product of small prime numbers.
c
c     wshsgs an array which must be initialized by subroutine shsgsi.
c            once initialized, wshsgs can be used repeatedly by shsgs
c            as long as nlat and nlon remain unchanged.  wshsgs must
c            not be altered between calls of shsgs.
c
c     lshsgs the dimension of the array wshsgs as it appears in the
c            program that calls shsgs. define
c
c               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            then lshsgs must be at least
c
c            nlat*(3*(l1+l2)-2)+(l1-1)*(l2*(2*nlat-l1)-3*l1)/2+nlon+15
c
c     work   a real work space which need not be saved
c
c     lwork  the dimension of the array work as it appears in the
c            program that calls shsgsi. lwork must be at least
c            4*nlat*(nlat+2)+2 in the routine calling shsgsi
c
C*PL*ERROR* Comment line too long
c     dwork   a double precision work array that does not have to be saved.
c
c     ldwork  the length of dwork in the calling routine.  ldwork must
c             be at least nlat*(nlat+4)
c
c     output parameter
c
c     wshsgs an array which must be initialized before calling shsgs or
c            once initialized, wshsgs can be used repeatedly by shsgs or
c            as long as nlat and nlon remain unchanged.  wshsgs must not
c            altered between calls of shsgs.
c
c     ierror = 0  no errors
c            = 1  error in the specification of nlat
c            = 2  error in the specification of nlon
c            = 3  error in the specification of lshsgs
c            = 4  error in the specification of lwork
c            = 5  error in the specification of ldwork
c            = 5  failure in gaqd to compute gaussian points
c                 (due to failure in eigenvalue routine)
c
c
      SUBROUTINE DSHSGS(NLAT,NLON,MODE,NT,G,IDG,JDG,A,B,MDAB,NDAB,
     +                  WSHSGS,LSHSGS,WORK,LWORK,IERROR)
      DOUBLE PRECISION G
      DOUBLE PRECISION A
      DOUBLE PRECISION B
      DOUBLE PRECISION WSHSGS
      DOUBLE PRECISION WORK
      DIMENSION G(IDG,JDG,1),A(MDAB,NDAB,1),B(MDAB,NDAB,1),
     +          WSHSGS(LSHSGS),WORK(LWORK)
c     check input parameters
      IERROR = 1
      IF (NLAT.LT.3) RETURN
      IERROR = 2
      IF (NLON.LT.4) RETURN
      IERROR = 3
      IF (MODE.LT.0 .OR. MODE.GT.2) RETURN
      IERROR = 4
      IF (NT.LT.1) RETURN
c     set limit on m subscript
      L = MIN0((NLON+2)/2,NLAT)
c     set gaussian point nearest equator pointer
      LATE = (NLAT+MOD(NLAT,2))/2
c     set number of grid points for analysis/synthesis
      LAT = NLAT
      IF (MODE.NE.0) LAT = LATE
      IERROR = 5
      IF (IDG.LT.LAT) RETURN
      IERROR = 6
      IF (JDG.LT.NLON) RETURN
      IERROR = 7
      IF (MDAB.LT.L) RETURN
      IERROR = 8
      IF (NDAB.LT.NLAT) RETURN
      L1 = L
      L2 = LATE
      IERROR = 9
c     check permanent work space length
      LP = NLAT* (3* (L1+L2)-2) + (L1-1)* (L2* (2*NLAT-L1)-3*L1)/2 +
     +     NLON + 15
      IF (LSHSGS.LT.LP) RETURN
c     check temporary work space length
      IERROR = 10
      IF (MODE.EQ.0 .AND. LWORK.LT.NLAT*NLON* (NT+1)) RETURN
      IF (MODE.NE.0 .AND. LWORK.LT.L2*NLON* (NT+1)) RETURN
      IERROR = 0
c     starting address for fft values and legendre polys in wshsgs
      IFFT = NLAT + 2*NLAT*LATE + 3* (L* (L-1)/2+ (NLAT-L)* (L-1)) + 1
      IPMN = IFFT + NLON + 15
c     set pointer for internal storage of g
      IW = LAT*NLON*NT + 1
      CALL DSHSGS1(NLAT,NLON,L,LAT,MODE,G,IDG,JDG,NT,A,B,MDAB,NDAB,
     +             WSHSGS(IFFT),WSHSGS(IPMN),LATE,WORK,WORK(IW))
      RETURN
      END

      SUBROUTINE DSHSGS1(NLAT,NLON,L,LAT,MODE,GS,IDG,JDG,NT,A,B,MDAB,
     +                   NDAB,WFFT,PMN,LATE,G,WORK)
      DOUBLE PRECISION GS
      DOUBLE PRECISION A
      DOUBLE PRECISION B
      DOUBLE PRECISION WFFT
      DOUBLE PRECISION PMN
      DOUBLE PRECISION G
      DOUBLE PRECISION WORK
      DOUBLE PRECISION T1
      DOUBLE PRECISION T3
      DOUBLE PRECISION T2
      DOUBLE PRECISION T4
      DIMENSION GS(IDG,JDG,NT),A(MDAB,NDAB,NT),B(MDAB,NDAB,NT)
      DIMENSION WFFT(1),PMN(LATE,1),G(LAT,NLON,NT),WORK(1)

c     reconstruct fourier coefficients in g on gaussian grid
c     using coefficients in a,b

c     initialize to zero
      DO 100 K = 1,NT
          DO 100 J = 1,NLON
              DO 100 I = 1,LAT
                  G(I,J,K) = 0.0D0
  100 CONTINUE

      LM1 = L
      IF (NLON.EQ.L+L-2) LM1 = L - 1
      IF (MODE.EQ.0) THEN
c     set first column in g
          M = 0
          MML1 = M* (2*NLAT-M-1)/2
          DO 101 K = 1,NT
c     n even
              DO 102 NP1 = 1,NLAT,2
                  MN = MML1 + NP1
                  DO 102 I = 1,LATE
                      G(I,1,K) = G(I,1,K) + A(1,NP1,K)*PMN(I,MN)
  102         CONTINUE
c     n odd
              NL2 = NLAT/2
              DO 103 NP1 = 2,NLAT,2
                  MN = MML1 + NP1
                  DO 103 I = 1,NL2
                      IS = NLAT - I + 1
                      G(IS,1,K) = G(IS,1,K) + A(1,NP1,K)*PMN(I,MN)
  103         CONTINUE
  101     CONTINUE

c     restore m=0 coefficients from odd/even
          DO 112 K = 1,NT
              DO 112 I = 1,NL2
                  IS = NLAT - I + 1
                  T1 = G(I,1,K)
                  T3 = G(IS,1,K)
                  G(I,1,K) = T1 + T3
                  G(IS,1,K) = T1 - T3
  112     CONTINUE

c     sweep interior columns of g
          DO 104 MP1 = 2,LM1
              M = MP1 - 1
              MML1 = M* (2*NLAT-M-1)/2
              MP2 = M + 2
              DO 105 K = 1,NT
C*PL*ERROR* Comment line too long
c     for n-m even store (g(i,p,k)+g(nlat-i+1,p,k))/2 in g(i,p,k) p=2*m,2*m+1
c     for i=1,...,late
                  DO 106 NP1 = MP1,NLAT,2
                      MN = MML1 + NP1
                      DO 107 I = 1,LATE
                          G(I,2*M,K) = G(I,2*M,K) +
     +                                 A(MP1,NP1,K)*PMN(I,MN)
                          G(I,2*M+1,K) = G(I,2*M+1,K) +
     +                                   B(MP1,NP1,K)*PMN(I,MN)
  107                 CONTINUE
  106             CONTINUE

c     for n-m odd store g(i,p,k)-g(nlat-i+1,p,k) in g(nlat-i+1,p,k)
c     for i=1,...,nlat/2 (p=2*m,p=2*m+1)
                  DO 108 NP1 = MP2,NLAT,2
                      MN = MML1 + NP1
                      DO 109 I = 1,NL2
                          IS = NLAT - I + 1
                          G(IS,2*M,K) = G(IS,2*M,K) +
     +                                  A(MP1,NP1,K)*PMN(I,MN)
                          G(IS,2*M+1,K) = G(IS,2*M+1,K) +
     +                                    B(MP1,NP1,K)*PMN(I,MN)
  109                 CONTINUE
  108             CONTINUE

c     now set fourier coefficients using even-odd reduction above
                  DO 110 I = 1,NL2
                      IS = NLAT - I + 1
                      T1 = G(I,2*M,K)
                      T2 = G(I,2*M+1,K)
                      T3 = G(IS,2*M,K)
                      T4 = G(IS,2*M+1,K)
                      G(I,2*M,K) = T1 + T3
                      G(I,2*M+1,K) = T2 + T4
                      G(IS,2*M,K) = T1 - T3
                      G(IS,2*M+1,K) = T2 - T4
  110             CONTINUE

  105         CONTINUE
  104     CONTINUE

c     set last column (using a only) if necessary
          IF (NLON.EQ.L+L-2) THEN
              M = L - 1
              MML1 = M* (2*NLAT-M-1)/2
              DO 111 K = 1,NT
c     n-m even
                  DO 131 NP1 = L,NLAT,2
                      MN = MML1 + NP1
                      DO 131 I = 1,LATE
                          G(I,NLON,K) = G(I,NLON,K) +
     +                                  2.0D0*A(L,NP1,K)*PMN(I,MN)

  131             CONTINUE
                  LP1 = L + 1
c     n-m odd
                  DO 132 NP1 = LP1,NLAT,2
                      MN = MML1 + NP1
                      DO 132 I = 1,NL2
                          IS = NLAT - I + 1
                          G(IS,NLON,K) = G(IS,NLON,K) +
     +                                   2.0D0*A(L,NP1,K)*PMN(I,MN)
  132             CONTINUE
                  DO 133 I = 1,NL2
                      IS = NLAT - I + 1
                      T1 = G(I,NLON,K)
                      T3 = G(IS,NLON,K)
                      G(I,NLON,K) = T1 + T3
                      G(IS,NLON,K) = T1 - T3
  133             CONTINUE
  111         CONTINUE
          END IF

      ELSE
c     half sphere (mode.ne.0)
c     set first column in g
          M = 0
          MML1 = M* (2*NLAT-M-1)/2
          MEO = 1
          IF (MODE.EQ.1) MEO = 2
          MS = M + MEO
          DO 113 K = 1,NT
              DO 113 NP1 = MS,NLAT,2
                  MN = MML1 + NP1
                  DO 113 I = 1,LATE
                      G(I,1,K) = G(I,1,K) + A(1,NP1,K)*PMN(I,MN)
  113     CONTINUE

c     sweep interior columns of g

          DO 114 MP1 = 2,LM1
              M = MP1 - 1
              MML1 = M* (2*NLAT-M-1)/2
              MS = M + MEO
              DO 115 K = 1,NT
                  DO 115 NP1 = MS,NLAT,2
                      MN = MML1 + NP1
                      DO 115 I = 1,LATE
                          G(I,2*M,K) = G(I,2*M,K) +
     +                                 A(MP1,NP1,K)*PMN(I,MN)
                          G(I,2*M+1,K) = G(I,2*M+1,K) +
     +                                   B(MP1,NP1,K)*PMN(I,MN)
  115         CONTINUE
  114     CONTINUE

          IF (NLON.EQ.L+L-2) THEN
c     set last column
              M = L - 1
              MML1 = M* (2*NLAT-M-1)/2
              NS = L
              IF (MODE.EQ.1) NS = L + 1
              DO 116 K = 1,NT
                  DO 116 NP1 = NS,NLAT,2
                      MN = MML1 + NP1
                      DO 116 I = 1,LATE
                          G(I,NLON,K) = G(I,NLON,K) +
     +                                  2.0D0*A(L,NP1,K)*PMN(I,MN)
  116         CONTINUE
          END IF

      END IF


c     do inverse fourier transform
      DO 120 K = 1,NT
          CALL DHRFFTB(LAT,NLON,G(1,1,K),LAT,WFFT,WORK)
  120 CONTINUE
c     scale output in gs
      DO 122 K = 1,NT
          DO 122 J = 1,NLON
              DO 122 I = 1,LAT
                  GS(I,J,K) = 0.5D0*G(I,J,K)
  122 CONTINUE

      RETURN
      END
      SUBROUTINE DSHSGSI(NLAT,NLON,WSHSGS,LSHSGS,WORK,LWORK,DWORK,
     +                   LDWORK,IERROR)
      DOUBLE PRECISION WSHSGS
      DOUBLE PRECISION WORK
c
c     this subroutine must be called before calling shags or shsgs with
c     fixed nlat,nlon. it precomputes the gaussian weights, points
c     and all necessary legendre polys and stores them in wshsgs.
c     these quantities must be preserved when calling shsgs
c     repeatedly with fixed nlat,nlon.
c
      DIMENSION WSHSGS(LSHSGS),WORK(LWORK)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION DWORK(LDWORK)

      IERROR = 1
      IF (NLAT.LT.3) RETURN
      IERROR = 2
      IF (NLON.LT.4) RETURN
c     set triangular truncation limit for spherical harmonic basis
      L = MIN0((NLON+2)/2,NLAT)
c     set equator or nearest point (if excluded) pointer
      LATE = (NLAT+1)/2
      L1 = L
      L2 = LATE
c     check permanent work space length
      IERROR = 3
      LP = NLAT* (3* (L1+L2)-2) + (L1-1)* (L2* (2*NLAT-L1)-3*L1)/2 +
     +     NLON + 15
      IF (LSHSGS.LT.LP) RETURN
      IERROR = 4
c     check temporary work space
      IF (LWORK.LT.4*NLAT* (NLAT+2)+2) RETURN
      IERROR = 5
      IF (LDWORK.LT.NLAT* (NLAT+4)) RETURN
      IERROR = 0
C*PL*ERROR* Comment line too long
c     set preliminary quantites needed to compute and store legendre polys
      LDW = NLAT* (NLAT+4)
      CALL DSHSGSP(NLAT,NLON,WSHSGS,LSHSGS,DWORK,LDWORK,IERROR)
      IF (IERROR.NE.0) RETURN
c     set legendre poly pointer in wshsgs
      IPMNF = NLAT + 2*NLAT*LATE + 3* (L* (L-1)/2+ (NLAT-L)* (L-1)) +
     +        NLON + 16
      CALL DSHSGSS1(NLAT,L,LATE,WSHSGS,WORK,WSHSGS(IPMNF))
      RETURN
      END
      SUBROUTINE DSHSGSS1(NLAT,L,LATE,W,PMN,PMNF)
      DOUBLE PRECISION W
      DOUBLE PRECISION PMN
      DOUBLE PRECISION PMNF
      DIMENSION W(1),PMN(NLAT,LATE,3),PMNF(LATE,1)
c     compute and store legendre polys for i=1,...,late,m=0,...,l-1
c     and n=m,...,l-1
      DO I = 1,NLAT
          DO J = 1,LATE
              DO K = 1,3
                  PMN(I,J,K) = 0.0D0
              END DO
          END DO
      END DO
      DO 100 MP1 = 1,L
          M = MP1 - 1
          MML1 = M* (2*NLAT-M-1)/2
c     compute pmn for n=m,...,nlat-1 and i=1,...,(l+1)/2
          MODE = 0
          CALL DLEGIN(MODE,L,NLAT,M,W,PMN,KM)
c     store above in pmnf
          DO 101 NP1 = MP1,NLAT
              MN = MML1 + NP1
              DO 102 I = 1,LATE
                  PMNF(I,MN) = PMN(NP1,I,KM)
  102         CONTINUE
  101     CONTINUE
  100 CONTINUE
      RETURN
      END
      SUBROUTINE DSHSGSP(NLAT,NLON,WSHSGS,LSHSGS,DWORK,LDWORK,IERROR)
      DOUBLE PRECISION WSHSGS
      DIMENSION WSHSGS(LSHSGS)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION DWORK(LDWORK)

      IERROR = 1
      IF (NLAT.LT.3) RETURN
      IERROR = 2
      IF (NLON.LT.4) RETURN
c     set triangular truncation limit for spherical harmonic basis
      L = MIN0((NLON+2)/2,NLAT)
c     set equator or nearest point (if excluded) pointer
      LATE = (NLAT+MOD(NLAT,2))/2
      L1 = L
      L2 = LATE
      IERROR = 3
c     check permanent work space length
      IF (LSHSGS.LT.NLAT* (2*L2+3*L1-2)+3*L1* (1-L1)/2+NLON+15) RETURN
      IERROR = 4
c     if (lwork.lt.4*nlat*(nlat+2)+2) return
      IF (LDWORK.LT.NLAT* (NLAT+4)) RETURN
      IERROR = 0
c     set pointers
      I1 = 1
      I2 = I1 + NLAT
      I3 = I2 + NLAT*LATE
      I4 = I3 + NLAT*LATE
      I5 = I4 + L* (L-1)/2 + (NLAT-L)* (L-1)
      I6 = I5 + L* (L-1)/2 + (NLAT-L)* (L-1)
      I7 = I6 + L* (L-1)/2 + (NLAT-L)* (L-1)
c     set indices in temp work for double precision gaussian wts and pts
      IDTH = 1
c     idwts = idth+2*nlat
c     iw = idwts+2*nlat
      IDWTS = IDTH + NLAT
      IW = IDWTS + NLAT
      CALL DSHSGSP1(NLAT,NLON,L,LATE,WSHSGS(I1),WSHSGS(I2),WSHSGS(I3),
     +              WSHSGS(I4),WSHSGS(I5),WSHSGS(I6),WSHSGS(I7),
     +              DWORK(IDTH),DWORK(IDWTS),DWORK(IW),IERROR)
      IF (IERROR.NE.0) IERROR = 6
      RETURN
      END
      SUBROUTINE DSHSGSP1(NLAT,NLON,L,LATE,WTS,P0N,P1N,ABEL,BBEL,CBEL,
     +                    WFFT,DTHETA,DWTS,WORK,IER)
      DOUBLE PRECISION WTS
      DOUBLE PRECISION P0N
      DOUBLE PRECISION P1N
      DOUBLE PRECISION ABEL
      DOUBLE PRECISION BBEL
      DOUBLE PRECISION CBEL
      DOUBLE PRECISION WFFT
      DOUBLE PRECISION FN
      DOUBLE PRECISION FM
      DIMENSION WTS(NLAT),P0N(NLAT,LATE),P1N(NLAT,LATE),ABEL(1),BBEL(1),
     +          CBEL(1),WFFT(1),DTHETA(NLAT),DWTS(NLAT)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION PB,DTHETA,DWTS,WORK(*)

      INDX(M,N) = (N-1)* (N-2)/2 + M - 1
      IMNDX(M,N) = L* (L-1)/2 + (N-L-1)* (L-1) + M - 1
      CALL DHRFFTI(NLON,WFFT)
c
c     compute double precision gaussian points and weights
c
      LW = NLAT* (NLAT+2)
      CALL DGAQD(NLAT,DTHETA,DWTS,WORK,LW,IER)
      IF (IER.NE.0) RETURN

c     store gaussian weights single precision to save computation
c     in inner loops in analysis
      DO 100 I = 1,NLAT
          WTS(I) = DWTS(I)
  100 CONTINUE

c     initialize p0n,p1n using double precision dnlfk,dnlft
      DO 101 NP1 = 1,NLAT
          DO 101 I = 1,LATE
              P0N(NP1,I) = 0.0D0
              P1N(NP1,I) = 0.0D0
  101 CONTINUE
c     compute m=n=0 legendre polynomials for all theta(i)
      NP1 = 1
      N = 0
      M = 0
      CALL DDNLFK(M,N,WORK)
      DO 103 I = 1,LATE
          CALL DDNLFT(M,N,DTHETA(I),WORK,PB)
          P0N(1,I) = PB
  103 CONTINUE
c     compute p0n,p1n for all theta(i) when n.gt.0
      DO 104 NP1 = 2,NLAT
          N = NP1 - 1
          M = 0
          CALL DDNLFK(M,N,WORK)
          DO 105 I = 1,LATE
              CALL DDNLFT(M,N,DTHETA(I),WORK,PB)
              P0N(NP1,I) = PB
  105     CONTINUE
c     compute m=1 legendre polynomials for all n and theta(i)
          M = 1
          CALL DDNLFK(M,N,WORK)
          DO 106 I = 1,LATE
              CALL DDNLFT(M,N,DTHETA(I),WORK,PB)
              P1N(NP1,I) = PB
  106     CONTINUE
  104 CONTINUE
c
c     compute and store swarztrauber recursion coefficients
c     for 2.le.m.le.n and 2.le.n.le.nlat in abel,bbel,cbel
      DO 107 N = 2,NLAT
          FN = DBLE(N)
          MLIM = MIN0(N,L)
          DO 107 M = 2,MLIM
              FM = DBLE(M)
              IMN = INDX(M,N)
              IF (N.GE.L) IMN = IMNDX(M,N)
              ABEL(IMN) = SQRT(((2*FN+1)* (FM+FN-2)* (FM+FN-3))/
     +                    (((2*FN-3)* (FM+FN-1)* (FM+FN))))
              BBEL(IMN) = SQRT(((2*FN+1)* (FN-FM-1)* (FN-FM))/
     +                    (((2*FN-3)* (FM+FN-1)* (FM+FN))))
              CBEL(IMN) = SQRT(((FN-FM+1)* (FN-FM+2))/
     +                    (((FN+FM-1)* (FN+FM))))
  107 CONTINUE
      RETURN
      END

C
C	$Id: conbd.f,v 1.6 2008-07-27 00:23:01 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CONBD
C
C Calling this do-nothing subroutine forces "ld" to load the following
C block data routine (but only if they are in the same ".f" file).
C
        RETURN
C
      END
CNOSPLIT
      BLOCKDATA CONBDX
      COMMON /CONRE1/ IOFFP      ,SPVAL
      COMMON /CONRE4/ ISIZEL     ,ISIZEM     ,ISIZEP     ,NREP       ,
     1                NCRT       ,ILAB       ,NULBLL     ,IOFFD      ,
     2                EXT        ,IOFFM      ,ISOLID     ,NLA        ,
     3                NLM        ,XLT        ,YBT        ,SIDE
      DATA IOFFP,SPVAL/0,0.0/
      DATA ISIZEM,ISIZEP,NLA,NLM,XLT,YBT,SIDE,ISOLID/
     1        2,     1,   16, 40,.05,.05,   .9, 1023/
      DATA ISIZEL,NREP,NCRT/
     1       1,    6,   4 /
      DATA EXT,IOFFD,NULBLL,IOFFM,ILAB/.25,0,3,0,1/
C
C REVISION HISTORY---
C
C JANUARY 1978     DELETED REFERENCES TO THE  *COSY  CARDS AND
C                  ADDED REVISION HISTORY
C FEBURARY 1979    MADE CODE CONFORM TO FORTRAN 66 STANDARDS
C JANUARY 1980     CHANGED LIBRARY NAME FROM NSSL TO
C                  PORTLIB FOR MOVE TO PORTLIB
C MAY 1980         CONRECQCK ON PORTLIB WAS DISCOVERED TO BE ESSENTIALLY
C                  THE WRONG VERSION.  EXTENSIVE MODIFICATIONS TO CLGEN,
C                  MAXMIN, CONREC TO MAKE IT PORTABLE (INVOLVED REMOVAL
C                  OF PWRT CALLS, ENCODE STATEMENTS, INAPPROPRIATE CON-
C                  STANTS, ETC.).
C JUNE 1984        UPDATED TO FORTRAN 77 AND TO GKS
C MARCH 1990       CORRECTED THE USE OF SET CALLS
C-----------------------------------------------------------------------
C
      END

C
C	$Id: wmgetr.f,v 1.10 2008-07-27 00:17:36 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE WMGETR (CNP,RVP)
C
      SAVE
C
      CHARACTER*(*) CNP
C
C  This subroutine is called to retrieve the real value of a specified
C  parameter.
C
C  CNP is the name of the parameter whose value is to be retrieved.
C
C  RVP is a real variable in which the desired value is to be returned
C  by WMGETR.
C
C  Declare a local character variable in which to form an error message.
C
      CHARACTER*80 CTM
C
      include 'wmcomn.h'
C
C  Do a call forcing a BLOCKDATA to be loaded from a binary library.
C
      CALL WMBLDA
C
C  Check for an uncleared prior error.
C
      IF (ICFELL('WMGETR - Uncleared prior error',1) .NE. 0) RETURN
C
C Check for a parameter name that is too short.
C
      IF (LEN(CNP) .LT. 2) THEN
        CTM(1:36)='WMGETR - Parameter name too short - '
        CTM(37:36+LEN(CNP)) = CNP
        CALL SETER (CTM(1:36+LEN(CNP)), 1, 1)
        GO TO 110
      ENDIF
C
C Get the appropriate parameter value.
C
      IF (CNP(1:3).EQ.'SWI' .OR. CNP(1:3).EQ.'swi' .OR. 
     +    CNP(1:3).EQ.'Swi') THEN
        RVP = SYMWID
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'BLW' .OR. CNP(1:3).EQ.'blw' .OR. 
     +    CNP(1:3).EQ.'Blw') THEN
        RVP = BRBLWD
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'BEG' .OR. CNP(1:3).EQ.'beg' .OR. 
     +    CNP(1:3).EQ.'Beg') THEN
        RVP = BEGDST
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'END' .OR. CNP(1:3).EQ.'end' .OR. 
     +    CNP(1:3).EQ.'End') THEN
        RVP = ENDDST
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'BET' .OR. CNP(1:3).EQ.'bet' .OR. 
     +    CNP(1:3).EQ.'Bet') THEN
        RVP = BETDST
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'LIN' .OR. CNP(1:3).EQ.'lin' .OR. 
     +    CNP(1:3).EQ.'Lin') THEN
        RVP = RLINWD
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'DWD' .OR. CNP(1:3).EQ.'dwd' .OR. 
     +    CNP(1:3).EQ.'Dwd') THEN
        RVP = DLINWD
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'LWD' .OR. CNP(1:3).EQ.'lwd' .OR. 
     +    CNP(1:3).EQ.'Lwd') THEN
        RVP = SLINWD
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'ARC' .OR. CNP(1:3).EQ.'arc' .OR. 
     +    CNP(1:3).EQ.'Arc') THEN
        RVP = CRVLEN
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'WHT' .OR. CNP(1:3).EQ.'wht' .OR. 
     +    CNP(1:3).EQ.'Wht') THEN
        RVP = WSIZEW
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'CHT' .OR. CNP(1:3).EQ.'cht' .OR. 
     +    CNP(1:3).EQ.'Cht') THEN
        RVP = WSIZEC
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'THT' .OR. CNP(1:3).EQ.'tht' .OR. 
     +    CNP(1:3).EQ.'Tht') THEN
        RVP = WSIZET
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'RHT' .OR. CNP(1:3).EQ.'rht' .OR. 
     +    CNP(1:3).EQ.'Rht') THEN
        RVP = WSIZER
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'SIG' .OR. CNP(1:3).EQ.'sig' .OR. 
     +    CNP(1:3).EQ.'Sig') THEN
        IF (TNSION .EQ. -1.) THEN
          RVP = 0.001
        ELSE
          RVP = TNSION
        ENDIF
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'SMT' .OR. CNP(1:3).EQ.'SMT' .OR. 
     +    CNP(1:3).EQ.'Smt') THEN
        IF (RSMOTH .EQ. -1.) THEN
          RVP = RSMRET
        ELSE
          RVP = RSMOTH
        ENDIF
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'OER' .OR. CNP(1:3).EQ.'oer' .OR. 
     +    CNP(1:3).EQ.'Oer') THEN
        IF (OBSERR .EQ. -1.) THEN
          RVP = OBSRET
        ELSE
          RVP = OBSERR
        ENDIF
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'SHT' .OR. CNP(1:3).EQ.'sht' .OR. 
     +    CNP(1:3).EQ.'Sht') THEN
        RVP = WSIZES
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'SL1' .OR. CNP(1:3).EQ.'sl1' .OR. 
     +    CNP(1:3).EQ.'Sl1') THEN
        RVP = SLOPE1
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'SL2' .OR. CNP(1:3).EQ.'sl2' .OR. 
     +    CNP(1:3).EQ.'Sl2') THEN
        RVP = SLOPE2
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'CS1' .OR. CNP(1:3).EQ.'cs1' .OR. 
     +    CNP(1:3).EQ.'Cs1') THEN
        RVP = SLOPEL
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'CS2' .OR. CNP(1:3).EQ.'cs2' .OR. 
     +    CNP(1:3).EQ.'Cs2') THEN
        RVP = SLOPER
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'ARS' .OR. CNP(1:3).EQ.'ars' .OR. 
     +    CNP(1:3).EQ.'Ars') THEN
        RVP = ARWSIZ
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'ARL' .OR. CNP(1:3).EQ.'arl' .OR. 
     +    CNP(1:3).EQ.'Arl') THEN
        RVP = ARWLEN
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'ARD' .OR. CNP(1:3).EQ.'ard' .OR. 
     +    CNP(1:3).EQ.'Ard') THEN
        RVP = ARWDIR
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'CMG' .OR. CNP(1:3).EQ.'cmg' .OR. 
     +    CNP(1:3).EQ.'Cmg') THEN
        RVP = CTYMRG
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'RMG' .OR. CNP(1:3).EQ.'rmg' .OR. 
     +    CNP(1:3).EQ.'Rmg') THEN
        RVP = TMPMRG
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'WBS' .OR. CNP(1:3).EQ.'wbs' .OR. 
     +    CNP(1:3).EQ.'Wbs') THEN
        RVP = WBSHFT
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'WBT' .OR. CNP(1:3).EQ.'wbt' .OR. 
     +    CNP(1:3).EQ.'Wbt') THEN
        RVP = WBFTIC
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'WBD' .OR. CNP(1:3).EQ.'wbd' .OR. 
     +    CNP(1:3).EQ.'Wbd') THEN
        RVP = WBDIST
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'WBR' .OR. CNP(1:3).EQ.'wbr' .OR. 
     +    CNP(1:3).EQ.'Wbr') THEN
        RVP = WBCLMR
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'WBA' .OR. CNP(1:3).EQ.'wba' .OR. 
     +    CNP(1:3).EQ.'Wba') THEN
        RVP = WBBANG
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'WBC' .OR. CNP(1:3).EQ.'wbc' .OR. 
     +    CNP(1:3).EQ.'Wbc') THEN
        RVP = WBBASE
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'WXL' .OR. CNP(1:3).EQ.'wxl' .OR. 
     +    CNP(1:3).EQ.'Wxl') THEN
        RVP = WBXL
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'WXR' .OR. CNP(1:3).EQ.'wxr' .OR. 
     +    CNP(1:3).EQ.'Wxr') THEN
        RVP = WBXR
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'WYB' .OR. CNP(1:3).EQ.'wyb' .OR. 
     +    CNP(1:3).EQ.'Wyb') THEN
        RVP = WBYB
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'WYT' .OR. CNP(1:3).EQ.'wyt' .OR. 
     +    CNP(1:3).EQ.'Wyt') THEN
        RVP = WBYT
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'DTS' .OR. CNP(1:3).EQ.'dts' .OR. 
     +    CNP(1:3).EQ.'Dts') THEN
        RVP = CDOTSZ
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'WBL' .OR. CNP(1:3).EQ.'wbl' .OR. 
     +    CNP(1:3).EQ.'Wbl') THEN
        RVP = WBLSIZ
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'VRS' .OR. CNP(1:3).EQ.'vrs' .OR. 
     +    CNP(1:3).EQ.'Vrs') THEN
        RVP = VCUREF
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'VRN' .OR. CNP(1:3).EQ.'vrn' .OR. 
     +    CNP(1:3).EQ.'Vrn') THEN
        RVP = VCNREF
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'VCH' .OR. CNP(1:3).EQ.'vch' .OR. 
     +    CNP(1:3).EQ.'Vch') THEN
        RVP = VCHSIZ
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'VCD' .OR. CNP(1:3).EQ.'vcd' .OR. 
     +    CNP(1:3).EQ.'Vcd') THEN
        RVP = VCWDIR
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'VCW' .OR. CNP(1:3).EQ.'vcw' .OR. 
     +    CNP(1:3).EQ.'Vcw') THEN
        RVP = VCLWID
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'VCS' .OR. CNP(1:3).EQ.'vcs' .OR. 
     +    CNP(1:3).EQ.'Vcs') THEN
        RVP = VCSIZE
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'VVA' .OR. CNP(1:3).EQ.'vva' .OR. 
     +    CNP(1:3).EQ.'Vva') THEN
        RVP = VHDANG
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'VBX' .OR. CNP(1:3).EQ.'vbx' .OR. 
     +    CNP(1:3).EQ.'Vbx') THEN
        RVP = VRFBXX
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'VBY' .OR. CNP(1:3).EQ.'vby' .OR. 
     +    CNP(1:3).EQ.'Vby') THEN
        RVP = VRFBXY
        GO TO 110
      ELSE
        CTM(1:36) = 'WMGETR - Parameter name not known - '
        CTM(37:39) = CNP(1:3)
        CALL SETER (CTM(1:39), 2, 1)
        GO TO 110
      ENDIF
C
  110 CONTINUE
      RETURN
      END

      PROGRAM SPLOGY
C
C  This test program is an example of logarithmic axis scaling
C  in the NCAR Graphics User Coordinate System.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C       Dimension a line of 100 points
C
      DIMENSION X(100),Y(100)

C
C       Open GKS
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C       Turn clipping off
C
      CALL GSCLIP(0)
C
C       Generate a straight line of 100 points.
C
      DO 1 I=1,100
      X(I) = I
      Y(I) = 10.*I
  1   CONTINUE
C
C       Select axes of linear in X, logarithmic in Y,
C        in NCAR Graphics user coordinates.
C
      CALL SET(.05,.95,.20,.95,1.,100.,10.,1000.,2)
C
C       Set attributes for output
C        Assign yellow to color index 2
C
      CALL GSCR(IWKID,0,0.,0.,0.)
      CALL GSCR(IWKID,1,1.,1.,1.)
      CALL GSCR(IWKID,2,1.,1.,0.)
C
C       Generate output (GKS, SPPS, or NCAR utilities)
C
C         Set polyline color index to yellow
C
      CALL GSPLCI(2)
C
C         Initialize the AUTOGRAPH entry EZXY so that
C         the frame is not advanced and the Y axis is logarithmic.
C
      CALL DISPLA(2,0,2)
C
C         Output the polyline (X,Y) using EZXY.
C
      CALL EZXY(X,Y,100,' ')
C
C       Add a yellow title.
C
C        PLOTCHAR uses stroked characters; thus, the yellow polyline
C        color index previously set will still apply.
C
C       Return the window to fractional coordinates for the title.
C       Also, return scaling to linear, linear.
C
      CALL SET(0.,1.,0.,1.,0.,1.,0.,1.,1)
      CALL PLCHHQ(0.5,.05,'Example 5.1.  Log Scaling with SPPS',
     1 .019,0.,0.)
C
C       Advance the frame to ensure all output is plotted
C
      CALL FRAME
C
C       Close GKS
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END

C
C $Id: pj22dp.f,v 1.5 2008-07-27 00:17:12 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE PJ22DP (COORD,CRDIO,INDIC)
C
C -- S P A C E   O B L I Q U E   M E R C A T O R
C
      IMPLICIT DOUBLE PRECISION (A-Z)
      INTEGER PATH,LAND,NN,L
      INTEGER INDIC
      DIMENSION GEOG(2),PROJ(2),COORD(2),CRDIO(2)
C **** PARAMETERS **** A,E,ES,LON0,LATC,X0,Y0,MCS,TCS,FAC,IND **********
      COMMON /ERRMZ0/ IERR
        INTEGER IERR
      SAVE   /ERRMZ0/
      COMMON /PRINZ0/ IPEMSG,IPELUN,IPPARM,IPPLUN
        INTEGER IPEMSG,IPELUN,IPPARM,IPPLUN
      SAVE   /PRINZ0/
      COMMON /NORMDP/ Q,T,U,W,ES,P22,SA,CA,XJ
      COMMON /PC22DP/ A,X0,Y0,A2,A4,B,C1,C3,LAND,PATH
      DATA TOL /1.0D-7/
      DATA DG1 /0.01745329252D0/
      DATA PI /3.14159265358979323846D0/
      DATA ZERO,ONE,TWO /0.0D0,1.0D0,2.0D0/
C
C -- F O R W A R D   . . .
C
      IF (INDIC .EQ. 0) THEN
C
         GEOG(1) = COORD(1)
         GEOG(2) = COORD(2)
         IERR = 0
         IF (LAND.GE.4) GO TO 225
         LON=GEOG(1)-128.87D0*DG1+PI*TWO/251.D0*PATH
         GO TO 230
  225    LON=GEOG(1)-129.30D0*DG1+PI*TWO/233.D0*PATH
  230    LAT=GEOG(2)
C
C        TEST FOR LAT. AND LONG. APPROACHING 90 DEGREES.
C
         IF (LAT.GT.1.570796D0) LAT=1.570796D0
         IF (LAT.LT.-1.570796D0) LAT =-1.570796D0
         IF (LAT.GE.0) LAMPP=PI/TWO
         IF (LAT.LT.0) LAMPP=1.5D0*PI
         NN=0
  231    SAV=LAMPP
         L=0
         LAMTP=LON+P22*LAMPP
         CL=COS(LAMTP)
         IF (ABS(CL).LT.TOL) LAMTP=LAMTP-TOL
         FAC=LAMPP-(SIGN(ONE,CL))*SIN(LAMPP)*PI/TWO
  232    LAMT=LON+P22*SAV
         C=COS(LAMT)
         IF (ABS(C).LT.TOL) THEN
            LAMDP = SAV
            GO TO 233
         END IF
         XLAM=((ONE-ES)*TAN(LAT)*SA+SIN(LAMT)*CA)/C
         LAMDP=ATAN(XLAM)
         LAMDP=LAMDP+FAC
         DIF=ABS(SAV)-ABS(LAMDP)
         IF (ABS(DIF).LT.TOL) GO TO 233
         SAV=LAMDP
         L=L+1
         IF (L.GT.50) GO TO 234
         GO TO 232
C
C        ADJUST FOR LANDSAT ORIGIN.
C
  233    RLM=PI*(16.D0/31.D0+ONE/248.D0)
         RLM2=RLM+TWO*PI
         NN=NN+1
         IF (NN.GE.3) GO TO 236
         IF (LAMDP.GT.RLM.AND.LAMDP.LT.RLM2) GO TO 236
         IF (LAMDP.LE.RLM) LAMPP=2.5D0*PI
         IF (LAMDP.GE.RLM2) LAMPP=PI/TWO
         GO TO 231
  234    IF (IPEMSG .EQ. 0) WRITE (IPELUN,235)
  235    FORMAT (/' ERROR PJ22DP'/
     .            ' 50 ITERATIONS WITHOUT CONVERGENCE.')
         IERR = 223
  236    CONTINUE
C
C        LAMDP COMPUTED.  NOW COMPUTE PHIDP.
C
         SP=SIN(LAT)
         PHIDP=ASINDP(((ONE-ES)*CA*SP-SA*COS(LAT)*SIN(LAMT))/SQRT(ONE
     .     -ES*SP*SP))
C
C        COMPUTE X AND Y
C
         TANPH=LOG(TAN(PI/4.0D0+PHIDP/TWO))
         SD=SIN(LAMDP)
         SDSQ=SD*SD
         S=P22*SA*COS(LAMDP)*SQRT((ONE+T*SDSQ)/((ONE+W*SDSQ)*(ONE
     .     +Q*SDSQ)))
         D=SQRT(XJ*XJ+S*S)
         X=B*LAMDP+A2*SIN(TWO*LAMDP)+A4*SIN(4.0D0*LAMDP)-TANPH*S/D
         X=A*X
         Y=C1*SD+C3*SIN(3.0D0*LAMDP)+TANPH*XJ/D
         Y=A*Y
         PROJ(1)=X+X0
         PROJ(2)=Y+Y0
         CRDIO(1) = PROJ(1)
         CRDIO(2) = PROJ(2)
         RETURN
      END IF
C
C -- I N V E R S E   . . .
C
      IF (INDIC .EQ. 1) THEN
C
         PROJ(1) = COORD(1)
         PROJ(2) = COORD(2)
         IERR = 0
         X = PROJ(1) -X0
         Y = PROJ(2) -Y0
C
C        COMPUTE TRANSFORMED LAT/LONG AND GEODETIC LAT/LONG, GIVEN X,Y.
C
C        BEGIN INVERSE COMPUTATION WITH APPROXIMATION FOR LAMDP.  SOLVE
C        FOR TRANSFORMED LONG.
C
         LAMDP=X/A/B
         NN=0
  325    SAV=LAMDP
         SD=SIN(LAMDP)
         SDSQ=SD*SD
         S=P22*SA*COS(LAMDP)*SQRT((ONE+T*SDSQ)/((ONE+W*SDSQ)*(ONE+Q
     .     *SDSQ)))
         LAMDP=X/A+Y/A*S/XJ-A2*SIN(TWO*LAMDP)-A4*SIN(4.0D0*LAMDP)
     .     -(S/XJ)*(C1*SIN(LAMDP)+C3*SIN(3.0D0*LAMDP))
         LAMDP=LAMDP/B
         DIF=LAMDP-SAV
         IF (ABS(DIF).LT.TOL) GO TO 330
         NN=NN+1
         IF (NN.EQ.50) GO TO 330
         GO TO 325
C
C        COMPUTE TRANSFORMED LAT.
C
  330    SL=SIN(LAMDP)
         FAC=EXP(SQRT(ONE+S*S/XJ/XJ)*(Y/A-C1*SL-C3*SIN(3.0D0*LAMDP)))
         ACTAN=ATAN(FAC)
         PHIDP=TWO*(ACTAN-PI/4.0D0)
C
C        COMPUTE GEODETIC LATITUDE.
C
         DD=SL*SL
         IF (ABS(COS(LAMDP)).LT.TOL) LAMDP=LAMDP-TOL
         SPP=SIN(PHIDP)
         SPPSQ=SPP*SPP
         LAMT=ATAN(((ONE-SPPSQ/(ONE-ES))*TAN(LAMDP)*CA-SPP*SA*SQRT((
     .   ONE+Q*DD)*(ONE-SPPSQ)-SPPSQ*U)/COS(LAMDP))/(ONE-SPPSQ*(ONE+U))
     .   )
C
C        CORRECT INVERSE QUADRANT.
C
         IF (LAMT.GE.0) SL=ONE
         IF (LAMT.LT.0) SL=-ONE
         IF (COS(LAMDP).GE.0) SCL=ONE
         IF (COS(LAMDP).LT.0) SCL=-ONE
         LAMT=LAMT-PI/TWO*(ONE-SCL)*SL
         LON=LAMT-P22*LAMDP
C
C        COMPUTE GEODETIC LATITUDE.
C
         IF (ABS(SA).LT.TOL) LAT=ASINDP(SPP/SQRT((ONE-ES)*(ONE-ES)
     .      +ES*SPPSQ))
         IF (ABS(SA).LT.TOL) GO TO 335
         LAT=ATAN((TAN(LAMDP)*COS(LAMT)-CA*SIN(LAMT))/((ONE-ES)*SA))
  335    CONTINUE
         IF (LAND.GE.4) GO TO 370
         GEOG(1)=LON+128.87D0*DG1-PI*TWO/251.D0*PATH
         GO TO 380
  370    GEOG(1)=LON+129.30D0*DG1-PI*TWO/233.D0*PATH
  380    GEOG(2)=LAT
         CRDIO(1) = GEOG(1)
         CRDIO(2) = GEOG(2)
         RETURN
      END IF
C
      END

C      $Id: nm05f.f,v 1.6 2010-03-15 22:49:24 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                       C
C                Copyright (C)  1997                                    C
C        University Corporation for Atmospheric Research                C
C                All Rights Reserved                                    C
C                                                                       C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C  File:         nm05f.f
C
C  Author:       Mary Haley (taken from one of Fred Clare's examples)
C                National Center for Atmospheric Research
C                PO 3000, Boulder, Colorado
C
C  Date:         Mon Dec 22 13:53:37 MST 1997
C
C  Description: How to vary the exponent of the distances in a
C               2D interpolation.
C
      external NhlFAppClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFCairoWindowWorkstationClass

      parameter(NUM=6,NX=61,NY=61)

      real xi(NUM), yi(NUM), zi(NUM)
      real xo(NX), yo(NY), output(NX,NY)
      real xinc, yinc
C
C  Input data points and values.
C
      data xi/0.00, 1.00, 0.00, 1.00, 0.40, 0.75/
      data yi/0.00, 0.00, 1.00, 1.00, 0.20, 0.65/
      data zi/0.00, 0.00, 0.00, 0.00, 1.25, 0.80/
      data rho, theta, phi/3., -45., 55./
      integer ier
      integer appid,wid,gkswid
      integer srlist, grlist
      integer i
      character*7  wks_type
C
C Default is to display output to an NCGM workstation.
C
      wks_type = "ncgm"
C
C Initialize the high level utility library
C
      call NhlFInitialize
C
C Create an application context. Set the app dir to the current directory
C so the application looks for a resource file in the working directory.
C In this example the resource file supplies the plot title only.
C
      call NhlFRLCreate(srlist,'setrl')
      call NhlFRLCreate(grlist,'getrl')

      call NhlFRLClear(srlist)
      call NhlFRLSetString(srlist,'appDefaultParent','True',ierr)
      call NhlFRLSetString(srlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'nm05',NhlFAppClass,0,srlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkMetaName','./nm05f.ncgm',ierr)
         call NhlFCreate(wid,'nm05Work',
     +        NhlFNcgmWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X11 workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkPause','True',ierr)
         call NhlFCreate(wid,'nm05Work',
     +        NhlFCairoWindowWorkstationClass,
     +        0,srlist,ierr)
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PostScript workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkPSFileName','./nm05f.ps',ierr)
         call NhlFCreate(wid,'nm05Work',
     +        NhlFPSWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkPDFFileName','./nm05f.pdf',ierr)
         call NhlFCreate(wid,'nm05Work',
     +        NhlFPDFWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkFileName','./nm05f',ierr)
         call NhlFRLSetString(srlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(wid,'nm05Work',
     +        NhlFCairoPSPDFWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkFileName','./nm05f',ierr)
         call NhlFRLSetString(srlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(wid,'nm05Work',
     +        NhlFCairoImageWorkstationClass,0,srlist,ierr)
      endif

C
C  Specify the output grid.
C
      xinc = 1./real(nx-1)
      yinc = 1./real(ny-1)
      do 30 i=1,nx
         xo(i) = real((i-1)*xinc)
 30   continue
      do 40 j=1,ny
         yo(j) = real((j-1)*yinc)
 40   continue
C
C  Exponent equals 0.5
C
      call dssetr('EXP',0.5)
      call dsgrid2s(num, xi, yi, zi, nx, ny, xo, yo, output, ier)
C
C Get Workstation ID.
C
      call NhlFRLClear(grlist)
      call NhlFRLGetInteger(grlist,'wkGksWorkId',gkswid,ierr)
      call NhlFGetValues(wid,grlist,ierr)
C
C There's no HLU object for surface plots yet, so we need to call the
C LLUs to get a surface plot.
C
      call gacwk (gkswid)
      call tdez2d(NX,NY,xo,yo,output,rho,theta,phi,6)
      call gdawk (gkswid)
      call NhlFFrame(wid,ierr)
C
C  Exponent equals 1.0
C
      call dssetr('EXP',1.0)
      call dsgrid2s(num, xi, yi, zi, nx, ny, xo, yo, output, ier)
      call gacwk (gkswid)
      call tdez2d(NX,NY,xo,yo,output,rho,theta,phi,6)
      call gdawk (gkswid)
      call NhlFFrame(wid,ierr)
C
C  Exponent equals 5.0
C
      call dssetr('EXP',5.0)
      call dsgrid2s(num, xi, yi, zi, nx, ny, xo, yo, output, ier)
      call gacwk (gkswid)
      call tdez2d(NX,NY,xo,yo,output,rho,theta,phi,6)
      call gdawk (gkswid)
      call NhlFFrame(wid,ierr)
C
C NhlDestroy destroys the given id and all of its children.
C
      call NhlFDestroy(wid,ierr)
C
C Restores state.
C
      call NhlFClose
      stop
      end

C
C	$Id: gqfais.f,v 1.5 2008-07-27 00:20:59 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GQFAIS(ERRIND,INTS)
C
C  INQUIRE FILL AREA INTERIOR STYLE
C
      include 'gkscom.h'
C
      INTEGER ERRIND,INTS
C
C  Check if GKS is in the proper state.
C
      CALL GZCKST(8,-1,ERRIND)
      IF (ERRIND.EQ.0) THEN
       INTS = CFAIS
      ELSE
       INTS = -1
      ENDIF
C
      RETURN
      END

      SUBROUTINE STGEX2( WANTQ, WANTZ, N, A, LDA, B, LDB, Q, LDQ, Z,
     $                   LDZ, J1, N1, N2, WORK, LWORK, INFO )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      LOGICAL            WANTQ, WANTZ
      INTEGER            INFO, J1, LDA, LDB, LDQ, LDZ, LWORK, N, N1, N2
*     ..
*     .. Array Arguments ..
      REAL               A( LDA, * ), B( LDB, * ), Q( LDQ, * ),
     $                   WORK( * ), Z( LDZ, * )
*     ..
*
*  Purpose
*  =======
*
*  STGEX2 swaps adjacent diagonal blocks (A11, B11) and (A22, B22)
*  of size 1-by-1 or 2-by-2 in an upper (quasi) triangular matrix pair
*  (A, B) by an orthogonal equivalence transformation.
*
*  (A, B) must be in generalized real Schur canonical form (as returned
*  by SGGES), i.e. A is block upper triangular with 1-by-1 and 2-by-2
*  diagonal blocks. B is upper triangular.
*
*  Optionally, the matrices Q and Z of generalized Schur vectors are
*  updated.
*
*         Q(in) * A(in) * Z(in)' = Q(out) * A(out) * Z(out)'
*         Q(in) * B(in) * Z(in)' = Q(out) * B(out) * Z(out)'
*
*
*  Arguments
*  =========
*
*  WANTQ   (input) LOGICAL
*          .TRUE. : update the left transformation matrix Q;
*          .FALSE.: do not update Q.
*
*  WANTZ   (input) LOGICAL
*          .TRUE. : update the right transformation matrix Z;
*          .FALSE.: do not update Z.
*
*  N       (input) INTEGER
*          The order of the matrices A and B. N >= 0.
*
*  A      (input/output) REAL arrays, dimensions (LDA,N)
*          On entry, the matrix A in the pair (A, B).
*          On exit, the updated matrix A.
*
*  LDA     (input)  INTEGER
*          The leading dimension of the array A. LDA >= max(1,N).
*
*  B      (input/output) REAL arrays, dimensions (LDB,N)
*          On entry, the matrix B in the pair (A, B).
*          On exit, the updated matrix B.
*
*  LDB     (input)  INTEGER
*          The leading dimension of the array B. LDB >= max(1,N).
*
*  Q       (input/output) REAL array, dimension (LDZ,N)
*          On entry, if WANTQ = .TRUE., the orthogonal matrix Q.
*          On exit, the updated matrix Q.
*          Not referenced if WANTQ = .FALSE..
*
*  LDQ     (input) INTEGER
*          The leading dimension of the array Q. LDQ >= 1.
*          If WANTQ = .TRUE., LDQ >= N.
*
*  Z       (input/output) REAL array, dimension (LDZ,N)
*          On entry, if WANTZ =.TRUE., the orthogonal matrix Z.
*          On exit, the updated matrix Z.
*          Not referenced if WANTZ = .FALSE..
*
*  LDZ     (input) INTEGER
*          The leading dimension of the array Z. LDZ >= 1.
*          If WANTZ = .TRUE., LDZ >= N.
*
*  J1      (input) INTEGER
*          The index to the first block (A11, B11). 1 <= J1 <= N.
*
*  N1      (input) INTEGER
*          The order of the first block (A11, B11). N1 = 0, 1 or 2.
*
*  N2      (input) INTEGER
*          The order of the second block (A22, B22). N2 = 0, 1 or 2.
*
*  WORK    (workspace) REAL array, dimension (LWORK).
*
*  LWORK   (input) INTEGER
*          The dimension of the array WORK.
*          LWORK >=  MAX( N*(N2+N1), (N2+N1)*(N2+N1)*2 )
*
*  INFO    (output) INTEGER
*            =0: Successful exit
*            >0: If INFO = 1, the transformed matrix (A, B) would be
*                too far from generalized Schur form; the blocks are
*                not swapped and (A, B) and (Q, Z) are unchanged.
*                The problem of swapping is too ill-conditioned.
*            <0: If INFO = -16: LWORK is too small. Appropriate value
*                for LWORK is returned in WORK(1).
*
*  Further Details
*  ===============
*
*  Based on contributions by
*     Bo Kagstrom and Peter Poromaa, Department of Computing Science,
*     Umea University, S-901 87 Umea, Sweden.
*
*  In the current code both weak and strong stability tests are
*  performed. The user can omit the strong stability test by changing
*  the internal logical parameter WANDS to .FALSE.. See ref. [2] for
*  details.
*
*  [1] B. Kagstrom; A Direct Method for Reordering Eigenvalues in the
*      Generalized Real Schur Form of a Regular Matrix Pair (A, B), in
*      M.S. Moonen et al (eds), Linear Algebra for Large Scale and
*      Real-Time Applications, Kluwer Academic Publ. 1993, pp 195-218.
*
*  [2] B. Kagstrom and P. Poromaa; Computing Eigenspaces with Specified
*      Eigenvalues of a Regular Matrix Pair (A, B) and Condition
*      Estimation: Theory, Algorithms and Software,
*      Report UMINF - 94.04, Department of Computing Science, Umea
*      University, S-901 87 Umea, Sweden, 1994. Also as LAPACK Working
*      Note 87. To appear in Numerical Algorithms, 1996.
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ZERO, ONE
      PARAMETER          ( ZERO = 0.0E+0, ONE = 1.0E+0 )
      REAL               TEN
      PARAMETER          ( TEN = 1.0E+01 )
      INTEGER            LDST
      PARAMETER          ( LDST = 4 )
      LOGICAL            WANDS
      PARAMETER          ( WANDS = .TRUE. )
*     ..
*     .. Local Scalars ..
      LOGICAL            STRONG, WEAK
      INTEGER            I, IDUM, LINFO, M
      REAL               BQRA21, BRQA21, DDUM, DNORM, DSCALE, DSUM, EPS,
     $                   F, G, SA, SB, SCALE, SMLNUM, SS, THRESH, WS
*     ..
*     .. Local Arrays ..
      INTEGER            IWORK( LDST )
      REAL               AI( 2 ), AR( 2 ), BE( 2 ), IR( LDST, LDST ),
     $                   IRCOP( LDST, LDST ), LI( LDST, LDST ),
     $                   LICOP( LDST, LDST ), S( LDST, LDST ),
     $                   SCPY( LDST, LDST ), T( LDST, LDST ),
     $                   TAUL( LDST ), TAUR( LDST ), TCPY( LDST, LDST )
*     ..
*     .. External Functions ..
      REAL               SLAMCH
      EXTERNAL           SLAMCH
*     ..
*     .. External Subroutines ..
      EXTERNAL           SCOPY, SGEMM, SGEQR2, SGERQ2, SLACPY, SLAGV2,
     $                   SLARTG, SLASSQ, SORG2R, SORGR2, SORM2R, SORMR2,
     $                   SROT, SSCAL, STGSY2
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, MAX, SQRT
*     ..
*     .. Executable Statements ..
*
      INFO = 0
*
*     Quick return if possible
*
      IF( N.LE.1 .OR. N1.LE.0 .OR. N2.LE.0 )
     $   RETURN
      IF( N1.GT.N .OR. ( J1+N1 ).GT.N )
     $   RETURN
      M = N1 + N2
      IF( LWORK.LT.MAX( N*M, M*M*2 ) ) THEN
         INFO = -16
         WORK( 1 ) = MAX( N*M, M*M*2 )
         RETURN
      END IF
*
      WEAK = .FALSE.
      STRONG = .FALSE.
*
*     Make a local copy of selected block
*
      CALL SCOPY( LDST*LDST, ZERO, 0, LI, 1 )
      CALL SCOPY( LDST*LDST, ZERO, 0, IR, 1 )
      CALL SLACPY( 'Full', M, M, A( J1, J1 ), LDA, S, LDST )
      CALL SLACPY( 'Full', M, M, B( J1, J1 ), LDB, T, LDST )
*
*     Compute threshold for testing acceptance of swapping.
*
      EPS = SLAMCH( 'P' )
      SMLNUM = SLAMCH( 'S' ) / EPS
      DSCALE = ZERO
      DSUM = ONE
      CALL SLACPY( 'Full', M, M, S, LDST, WORK, M )
      CALL SLASSQ( M*M, WORK, 1, DSCALE, DSUM )
      CALL SLACPY( 'Full', M, M, T, LDST, WORK, M )
      CALL SLASSQ( M*M, WORK, 1, DSCALE, DSUM )
      DNORM = DSCALE*SQRT( DSUM )
      THRESH = MAX( TEN*EPS*DNORM, SMLNUM )
*
      IF( M.EQ.2 ) THEN
*
*        CASE 1: Swap 1-by-1 and 1-by-1 blocks.
*
*        Compute orthogonal QL and RQ that swap 1-by-1 and 1-by-1 blocks
*        using Givens rotations and perform the swap tentatively.
*
         F = S( 2, 2 )*T( 1, 1 ) - T( 2, 2 )*S( 1, 1 )
         G = S( 2, 2 )*T( 1, 2 ) - T( 2, 2 )*S( 1, 2 )
         SB = ABS( T( 2, 2 ) )
         SA = ABS( S( 2, 2 ) )
         CALL SLARTG( F, G, IR( 1, 2 ), IR( 1, 1 ), DDUM )
         IR( 2, 1 ) = -IR( 1, 2 )
         IR( 2, 2 ) = IR( 1, 1 )
         CALL SROT( 2, S( 1, 1 ), 1, S( 1, 2 ), 1, IR( 1, 1 ),
     $              IR( 2, 1 ) )
         CALL SROT( 2, T( 1, 1 ), 1, T( 1, 2 ), 1, IR( 1, 1 ),
     $              IR( 2, 1 ) )
         IF( SA.GE.SB ) THEN
            CALL SLARTG( S( 1, 1 ), S( 2, 1 ), LI( 1, 1 ), LI( 2, 1 ),
     $                   DDUM )
         ELSE
            CALL SLARTG( T( 1, 1 ), T( 2, 1 ), LI( 1, 1 ), LI( 2, 1 ),
     $                   DDUM )
         END IF
         CALL SROT( 2, S( 1, 1 ), LDST, S( 2, 1 ), LDST, LI( 1, 1 ),
     $              LI( 2, 1 ) )
         CALL SROT( 2, T( 1, 1 ), LDST, T( 2, 1 ), LDST, LI( 1, 1 ),
     $              LI( 2, 1 ) )
         LI( 2, 2 ) = LI( 1, 1 )
         LI( 1, 2 ) = -LI( 2, 1 )
*
*        Weak stability test:
*           |S21| + |T21| <= O(EPS * F-norm((S, T)))
*
         WS = ABS( S( 2, 1 ) ) + ABS( T( 2, 1 ) )
         WEAK = WS.LE.THRESH
         IF( .NOT.WEAK )
     $      GO TO 70
*
         IF( WANDS ) THEN
*
*           Strong stability test:
*             F-norm((A-QL'*S*QR, B-QL'*T*QR)) <= O(EPS*F-norm((A,B)))
*
            CALL SLACPY( 'Full', M, M, A( J1, J1 ), LDA, WORK( M*M+1 ),
     $                   M )
            CALL SGEMM( 'N', 'N', M, M, M, ONE, LI, LDST, S, LDST, ZERO,
     $                  WORK, M )
            CALL SGEMM( 'N', 'T', M, M, M, -ONE, WORK, M, IR, LDST, ONE,
     $                  WORK( M*M+1 ), M )
            DSCALE = ZERO
            DSUM = ONE
            CALL SLASSQ( M*M, WORK( M*M+1 ), 1, DSCALE, DSUM )
*
            CALL SLACPY( 'Full', M, M, B( J1, J1 ), LDB, WORK( M*M+1 ),
     $                   M )
            CALL SGEMM( 'N', 'N', M, M, M, ONE, LI, LDST, T, LDST, ZERO,
     $                  WORK, M )
            CALL SGEMM( 'N', 'T', M, M, M, -ONE, WORK, M, IR, LDST, ONE,
     $                  WORK( M*M+1 ), M )
            CALL SLASSQ( M*M, WORK( M*M+1 ), 1, DSCALE, DSUM )
            SS = DSCALE*SQRT( DSUM )
            STRONG = SS.LE.THRESH
            IF( .NOT.STRONG )
     $         GO TO 70
         END IF
*
*        Update (A(J1:J1+M-1, M+J1:N), B(J1:J1+M-1, M+J1:N)) and
*               (A(1:J1-1, J1:J1+M), B(1:J1-1, J1:J1+M)).
*
         CALL SROT( J1+1, A( 1, J1 ), 1, A( 1, J1+1 ), 1, IR( 1, 1 ),
     $              IR( 2, 1 ) )
         CALL SROT( J1+1, B( 1, J1 ), 1, B( 1, J1+1 ), 1, IR( 1, 1 ),
     $              IR( 2, 1 ) )
         CALL SROT( N-J1+1, A( J1, J1 ), LDA, A( J1+1, J1 ), LDA,
     $              LI( 1, 1 ), LI( 2, 1 ) )
         CALL SROT( N-J1+1, B( J1, J1 ), LDB, B( J1+1, J1 ), LDB,
     $              LI( 1, 1 ), LI( 2, 1 ) )
*
*        Set  N1-by-N2 (2,1) - blocks to ZERO.
*
         A( J1+1, J1 ) = ZERO
         B( J1+1, J1 ) = ZERO
*
*        Accumulate transformations into Q and Z if requested.
*
         IF( WANTZ )
     $      CALL SROT( N, Z( 1, J1 ), 1, Z( 1, J1+1 ), 1, IR( 1, 1 ),
     $                 IR( 2, 1 ) )
         IF( WANTQ )
     $      CALL SROT( N, Q( 1, J1 ), 1, Q( 1, J1+1 ), 1, LI( 1, 1 ),
     $                 LI( 2, 1 ) )
*
*        Exit with INFO = 0 if swap was successfully performed.
*
         RETURN
*
      ELSE
*
*        CASE 2: Swap 1-by-1 and 2-by-2 blocks, or 2-by-2
*                and 2-by-2 blocks.
*
*        Solve the generalized Sylvester equation
*                 S11 * R - L * S22 = SCALE * S12
*                 T11 * R - L * T22 = SCALE * T12
*        for R and L. Solutions in LI and IR.
*
         CALL SLACPY( 'Full', N1, N2, T( 1, N1+1 ), LDST, LI, LDST )
         CALL SLACPY( 'Full', N1, N2, S( 1, N1+1 ), LDST,
     $                IR( N2+1, N1+1 ), LDST )
         CALL STGSY2( 'N', 0, N1, N2, S, LDST, S( N1+1, N1+1 ), LDST,
     $                IR( N2+1, N1+1 ), LDST, T, LDST, T( N1+1, N1+1 ),
     $                LDST, LI, LDST, SCALE, DSUM, DSCALE, IWORK, IDUM,
     $                LINFO )
*
*        Compute orthogonal matrix QL:
*
*                    QL' * LI = [ TL ]
*                               [ 0  ]
*        where
*                    LI =  [      -L              ]
*                          [ SCALE * identity(N2) ]
*
         DO 10 I = 1, N2
            CALL SSCAL( N1, -ONE, LI( 1, I ), 1 )
            LI( N1+I, I ) = SCALE
   10    CONTINUE
         CALL SGEQR2( M, N2, LI, LDST, TAUL, WORK, LINFO )
         IF( LINFO.NE.0 )
     $      GO TO 70
         CALL SORG2R( M, M, N2, LI, LDST, TAUL, WORK, LINFO )
         IF( LINFO.NE.0 )
     $      GO TO 70
*
*        Compute orthogonal matrix RQ:
*
*                    IR * RQ' =   [ 0  TR],
*
*         where IR = [ SCALE * identity(N1), R ]
*
         DO 20 I = 1, N1
            IR( N2+I, I ) = SCALE
   20    CONTINUE
         CALL SGERQ2( N1, M, IR( N2+1, 1 ), LDST, TAUR, WORK, LINFO )
         IF( LINFO.NE.0 )
     $      GO TO 70
         CALL SORGR2( M, M, N1, IR, LDST, TAUR, WORK, LINFO )
         IF( LINFO.NE.0 )
     $      GO TO 70
*
*        Perform the swapping tentatively:
*
         CALL SGEMM( 'T', 'N', M, M, M, ONE, LI, LDST, S, LDST, ZERO,
     $               WORK, M )
         CALL SGEMM( 'N', 'T', M, M, M, ONE, WORK, M, IR, LDST, ZERO, S,
     $               LDST )
         CALL SGEMM( 'T', 'N', M, M, M, ONE, LI, LDST, T, LDST, ZERO,
     $               WORK, M )
         CALL SGEMM( 'N', 'T', M, M, M, ONE, WORK, M, IR, LDST, ZERO, T,
     $               LDST )
         CALL SLACPY( 'F', M, M, S, LDST, SCPY, LDST )
         CALL SLACPY( 'F', M, M, T, LDST, TCPY, LDST )
         CALL SLACPY( 'F', M, M, IR, LDST, IRCOP, LDST )
         CALL SLACPY( 'F', M, M, LI, LDST, LICOP, LDST )
*
*        Triangularize the B-part by an RQ factorization.
*        Apply transformation (from left) to A-part, giving S.
*
         CALL SGERQ2( M, M, T, LDST, TAUR, WORK, LINFO )
         IF( LINFO.NE.0 )
     $      GO TO 70
         CALL SORMR2( 'R', 'T', M, M, M, T, LDST, TAUR, S, LDST, WORK,
     $                LINFO )
         IF( LINFO.NE.0 )
     $      GO TO 70
         CALL SORMR2( 'L', 'N', M, M, M, T, LDST, TAUR, IR, LDST, WORK,
     $                LINFO )
         IF( LINFO.NE.0 )
     $      GO TO 70
*
*        Compute F-norm(S21) in BRQA21. (T21 is 0.)
*
         DSCALE = ZERO
         DSUM = ONE
         DO 30 I = 1, N2
            CALL SLASSQ( N1, S( N2+1, I ), 1, DSCALE, DSUM )
   30    CONTINUE
         BRQA21 = DSCALE*SQRT( DSUM )
*
*        Triangularize the B-part by a QR factorization.
*        Apply transformation (from right) to A-part, giving S.
*
         CALL SGEQR2( M, M, TCPY, LDST, TAUL, WORK, LINFO )
         IF( LINFO.NE.0 )
     $      GO TO 70
         CALL SORM2R( 'L', 'T', M, M, M, TCPY, LDST, TAUL, SCPY, LDST,
     $                WORK, INFO )
         CALL SORM2R( 'R', 'N', M, M, M, TCPY, LDST, TAUL, LICOP, LDST,
     $                WORK, INFO )
         IF( LINFO.NE.0 )
     $      GO TO 70
*
*        Compute F-norm(S21) in BQRA21. (T21 is 0.)
*
         DSCALE = ZERO
         DSUM = ONE
         DO 40 I = 1, N2
            CALL SLASSQ( N1, SCPY( N2+1, I ), 1, DSCALE, DSUM )
   40    CONTINUE
         BQRA21 = DSCALE*SQRT( DSUM )
*
*        Decide which method to use.
*          Weak stability test:
*             F-norm(S21) <= O(EPS * F-norm((S, T)))
*
         IF( BQRA21.LE.BRQA21 .AND. BQRA21.LE.THRESH ) THEN
            CALL SLACPY( 'F', M, M, SCPY, LDST, S, LDST )
            CALL SLACPY( 'F', M, M, TCPY, LDST, T, LDST )
            CALL SLACPY( 'F', M, M, IRCOP, LDST, IR, LDST )
            CALL SLACPY( 'F', M, M, LICOP, LDST, LI, LDST )
         ELSE IF( BRQA21.GE.THRESH ) THEN
            GO TO 70
         END IF
*
*        Set lower triangle of B-part to zero
*
         DO 50 I = 2, M
            CALL SCOPY( M-I+1, ZERO, 0, T( I, I-1 ), 1 )
   50    CONTINUE
*
         IF( WANDS ) THEN
*
*           Strong stability test:
*              F-norm((A-QL*S*QR', B-QL*T*QR')) <= O(EPS*F-norm((A,B)))
*
            CALL SLACPY( 'Full', M, M, A( J1, J1 ), LDA, WORK( M*M+1 ),
     $                   M )
            CALL SGEMM( 'N', 'N', M, M, M, ONE, LI, LDST, S, LDST, ZERO,
     $                  WORK, M )
            CALL SGEMM( 'N', 'N', M, M, M, -ONE, WORK, M, IR, LDST, ONE,
     $                  WORK( M*M+1 ), M )
            DSCALE = ZERO
            DSUM = ONE
            CALL SLASSQ( M*M, WORK( M*M+1 ), 1, DSCALE, DSUM )
*
            CALL SLACPY( 'Full', M, M, B( J1, J1 ), LDB, WORK( M*M+1 ),
     $                   M )
            CALL SGEMM( 'N', 'N', M, M, M, ONE, LI, LDST, T, LDST, ZERO,
     $                  WORK, M )
            CALL SGEMM( 'N', 'N', M, M, M, -ONE, WORK, M, IR, LDST, ONE,
     $                  WORK( M*M+1 ), M )
            CALL SLASSQ( M*M, WORK( M*M+1 ), 1, DSCALE, DSUM )
            SS = DSCALE*SQRT( DSUM )
            STRONG = ( SS.LE.THRESH )
            IF( .NOT.STRONG )
     $         GO TO 70
*
         END IF
*
*        If the swap is accepted ("weakly" and "strongly"), apply the
*        transformations and set N1-by-N2 (2,1)-block to zero.
*
         DO 60 I = 1, N2
            CALL SCOPY( N1, ZERO, 0, S( N2+1, I ), 1 )
   60    CONTINUE
*
*        copy back M-by-M diagonal block starting at index J1 of (A, B)
*
         CALL SLACPY( 'F', M, M, S, LDST, A( J1, J1 ), LDA )
         CALL SLACPY( 'F', M, M, T, LDST, B( J1, J1 ), LDB )
         CALL SCOPY( LDST*LDST, ZERO, 0, T, 1 )
*
*        Standardize existing 2-by-2 blocks.
*
         CALL SCOPY( M*M, ZERO, 0, WORK, 1 )
         WORK( 1 ) = ONE
         T( 1, 1 ) = ONE
         IDUM = LWORK - M*M - 2
         IF( N2.GT.1 ) THEN
            CALL SLAGV2( A( J1, J1 ), LDA, B( J1, J1 ), LDB, AR, AI, BE,
     $                   WORK( 1 ), WORK( 2 ), T( 1, 1 ), T( 2, 1 ) )
            WORK( M+1 ) = -WORK( 2 )
            WORK( M+2 ) = WORK( 1 )
            T( N2, N2 ) = T( 1, 1 )
            T( 1, 2 ) = -T( 2, 1 )
         END IF
         WORK( M*M ) = ONE
         T( M, M ) = ONE
*
         IF( N1.GT.1 ) THEN
            CALL SLAGV2( A( J1+N2, J1+N2 ), LDA, B( J1+N2, J1+N2 ), LDB,
     $                   TAUR, TAUL, WORK( M*M+1 ), WORK( N2*M+N2+1 ),
     $                   WORK( N2*M+N2+2 ), T( N2+1, N2+1 ),
     $                   T( M, M-1 ) )
            WORK( M*M ) = WORK( N2*M+N2+1 )
            WORK( M*M-1 ) = -WORK( N2*M+N2+2 )
            T( M, M ) = T( N2+1, N2+1 )
            T( M-1, M ) = -T( M, M-1 )
         END IF
         CALL SGEMM( 'T', 'N', N2, N1, N2, ONE, WORK, M, A( J1, J1+N2 ),
     $               LDA, ZERO, WORK( M*M+1 ), N2 )
         CALL SLACPY( 'Full', N2, N1, WORK( M*M+1 ), N2, A( J1, J1+N2 ),
     $                LDA )
         CALL SGEMM( 'T', 'N', N2, N1, N2, ONE, WORK, M, B( J1, J1+N2 ),
     $               LDB, ZERO, WORK( M*M+1 ), N2 )
         CALL SLACPY( 'Full', N2, N1, WORK( M*M+1 ), N2, B( J1, J1+N2 ),
     $                LDB )
         CALL SGEMM( 'N', 'N', M, M, M, ONE, LI, LDST, WORK, M, ZERO,
     $               WORK( M*M+1 ), M )
         CALL SLACPY( 'Full', M, M, WORK( M*M+1 ), M, LI, LDST )
         CALL SGEMM( 'N', 'N', N2, N1, N1, ONE, A( J1, J1+N2 ), LDA,
     $               T( N2+1, N2+1 ), LDST, ZERO, WORK, N2 )
         CALL SLACPY( 'Full', N2, N1, WORK, N2, A( J1, J1+N2 ), LDA )
         CALL SGEMM( 'N', 'N', N2, N1, N1, ONE, B( J1, J1+N2 ), LDA,
     $               T( N2+1, N2+1 ), LDST, ZERO, WORK, N2 )
         CALL SLACPY( 'Full', N2, N1, WORK, N2, B( J1, J1+N2 ), LDB )
         CALL SGEMM( 'T', 'N', M, M, M, ONE, IR, LDST, T, LDST, ZERO,
     $               WORK, M )
         CALL SLACPY( 'Full', M, M, WORK, M, IR, LDST )
*
*        Accumulate transformations into Q and Z if requested.
*
         IF( WANTQ ) THEN
            CALL SGEMM( 'N', 'N', N, M, M, ONE, Q( 1, J1 ), LDQ, LI,
     $                  LDST, ZERO, WORK, N )
            CALL SLACPY( 'Full', N, M, WORK, N, Q( 1, J1 ), LDQ )
*
         END IF
*
         IF( WANTZ ) THEN
            CALL SGEMM( 'N', 'N', N, M, M, ONE, Z( 1, J1 ), LDZ, IR,
     $                  LDST, ZERO, WORK, N )
            CALL SLACPY( 'Full', N, M, WORK, N, Z( 1, J1 ), LDZ )
*
         END IF
*
*        Update (A(J1:J1+M-1, M+J1:N), B(J1:J1+M-1, M+J1:N)) and
*                (A(1:J1-1, J1:J1+M), B(1:J1-1, J1:J1+M)).
*
         I = J1 + M
         IF( I.LE.N ) THEN
            CALL SGEMM( 'T', 'N', M, N-I+1, M, ONE, LI, LDST,
     $                  A( J1, I ), LDA, ZERO, WORK, M )
            CALL SLACPY( 'Full', M, N-I+1, WORK, M, A( J1, I ), LDA )
            CALL SGEMM( 'T', 'N', M, N-I+1, M, ONE, LI, LDST,
     $                  B( J1, I ), LDA, ZERO, WORK, M )
            CALL SLACPY( 'Full', M, N-I+1, WORK, M, B( J1, I ), LDA )
         END IF
         I = J1 - 1
         IF( I.GT.0 ) THEN
            CALL SGEMM( 'N', 'N', I, M, M, ONE, A( 1, J1 ), LDA, IR,
     $                  LDST, ZERO, WORK, I )
            CALL SLACPY( 'Full', I, M, WORK, I, A( 1, J1 ), LDA )
            CALL SGEMM( 'N', 'N', I, M, M, ONE, B( 1, J1 ), LDB, IR,
     $                  LDST, ZERO, WORK, I )
            CALL SLACPY( 'Full', I, M, WORK, I, B( 1, J1 ), LDB )
         END IF
*
*        Exit with INFO = 0 if swap was successfully performed.
*
         RETURN
*
      END IF
*
*     Exit with INFO = 1 if swap was rejected.
*
   70 CONTINUE
*
      INFO = 1
      RETURN
*
*     End of STGEX2
*
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C                Copyright (C)  1995                                   C
C        University Corporation for Atmospheric Research               C
C                all rights reserved                                   C
C                                                                      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C      File:           tx08f.f
C
C      Author:         Jeff Boote
C          National Center for Atmospheric Research
C          PO 3000, Boulder, Colorado
C
C      Date:           Fri Jun  9 11:57:32 MDT 1995
C
C      Description:    Simple annotation example.
C
      integer list

      external NhlFAppClass
      external NhlFCairoWindowWorkstationClass
      external NhlFNCGMWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFXyPlotClass
      external NhlFTextItemClass
      character*7  wks_type
C
C Default is output to an X11 window.
C
      wks_type = "x11"
C
C Create application.
C
      call NhlFOpen
      call NhlFRLCreate(list,'setrl')
      call NhlFRLClear(list)
      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLSetString(list,'wkMetaName','./tx08f.ncgm',ierr)
         call NhlFCreate(ixwk,'tx08Work',NhlFNcgmWorkstationClass,0,
     1        list,ierr)
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X workstation.
C
         call NhlFCreate(ixwk,'tx08Work',
     +        NhlFCairoWindowWorkstationClass,
     +        0,list,ier)
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PS workstation.
C
         call NhlFRLSetString(list,'wkPSFileName','./tx08f.ps',ierr)
         call NhlFCreate(ixwk,'tx08Work',NhlFPSWorkstationClass,0,
     1        list,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLSetString(list,'wkPDFFileName','./tx08f.pdf',ierr)
         call NhlFCreate(ixwk,'tx08Work',NhlFPDFWorkstationClass,0,
     1        list,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF workstation.
C
         call NhlFRLSetString(list,'wkFormat',wks_type,ierr)
         call NhlFRLSetString(list,'wkFileName','./tx08f',ierr)
         call NhlFCreate(ixwk,'tx08Work',
     1        NhlFCairoPSPDFWorkstationClass,0,list,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG workstation.
C
         call NhlFRLSetString(list,'wkFormat',wks_type,ierr)
         call NhlFRLSetString(list,'wkFileName','./tx08f',ierr)
         call NhlFCreate(ixwk,'tx08Work',
     1        NhlFCairoImageWorkstationClass,0,list,ierr)
      endif
C
C Create Plot object - no data, just illustration annotations.
C
      call NhlFRLClear(list)
      call NhlFRLSetFloat(list,'vpXF',0.2,ier)
      call NhlFRLSetFloat(list,'vpYF',.7,ier)
      call NhlFRLSetFloat(list,'vpWidthF',.3,ier)
      call NhlFRLSetFloat(list,'vpHeightF',.3,ier)
      call NhlFCreate(ixyplot,'xyPlot',NhlFXyPlotClass,ixwk,
     +  list,ier)

      call NhlFRLClear(list)
      call NhlFRLSetString(list,'txString','Second Line',ier)
      call NhlFCreate(itx,'txItem',NhlFTextItemClass,ixwk,
     +  list,ier)
C
C There is currently a bug in the HLU library - you have to specify
C ier - it should be returned in ianno if there is an error, but
C this is what you currently have to use.
C
      call NhlFAddAnnotation(ixyplot,itx,ianno,ier)
C
C Just set the "zone" to something fairly large, so it is outside
C of all "PlotManager" defined annotations.
C Set the "side" to top - 'amJust' defaults to centercenter - but
C setting 'amSide' to top makes that effectively bottomcenter.  So,
C the textitem would be drawn so its bottomcenter is placed at the
C top of the viewport of the plot, on the left side.  To get the
C text centered over the plot - set 'amParallelPosF' to .5 to move
C the textitem over .5 the width of the plot.
C Set 'amOrthogonalPosF' to .1 to give a little bit of spacing
C in the y direction from the plot (the previous zone).
C
      call NhlFRLClear(list)
      call NhlFRLSetInteger(list,'amZone',10,ier)
      call NhlFRLSetString(list,'amSide','top',ier)
      call NhlFRLSetString(list,'amJust','bottomcenter',ier)
      call NhlFRLSetFloat(list,'amParallelPosF',0.5,ier)
      call NhlFRLSetFloat(list,'amOrthogonalPosF',0.1,ier)
      call NhlFSetValues(ianno,list,ier)

      call NhlFRLClear(list)
      call NhlFRLSetString(list,'txString','First Line',ier)
      call NhlFCreate(itx,'txItem',NhlFTextItemClass,ixwk,
     +  list,ier)

      call NhlFAddAnnotation(ixyplot,itx,ianno,ier)
C
C Add this textitem as an annotation with the same charactoristics
C as the first one, but make the zone one higher - so it is just
C outside of the first annotation.  (With a .1 distance away due
C to the 'amOrthogonalPosF'.
C
      call NhlFRLClear(list)
      call NhlFRLSetInteger(list,'amZone',11,ier)
      call NhlFRLSetString(list,'amSide','top',ier)
      call NhlFRLSetString(list,'amJust','bottomcenter',ier)
      call NhlFRLSetFloat(list,'amParallelPosF',0.5,ier)
      call NhlFRLSetFloat(list,'amOrthogonalPosF',0.1,ier)
      call NhlFSetValues(ianno,list,ier)
C
C Draw and advance frame.
C   Notice that drawing the main plot automatically draw's the textitem
C   since it is now a "member plot" of the xyplot.  In fact, you can
C   no-longer draw the textitem indepentently.
C
      call NhlFDraw(ixyplot,ier)
      call NhlFFrame(ixwk,ier)
C
C Now, if we move the base plot, the annoation stays with the plot.
C It is drawn in its relative position to the xyplot.
C
      call NhlFRLClear(list)
      call NhlFRLSetFloat(list,'vpXF',0.5,ier)
      call NhlFRLSetFloat(list,'vpYF',.4,ier)
      call NhlFSetValues(ixyplot,list,ier)

      call NhlFDraw(ixyplot,ier)
      call NhlFFrame(ixwk,ier)
C
C Close automatically destroys all hlu objects that currently exist,
C and destroys all "res-list's" that currently exist as well.
C It is really only important to explicitly destroy those things
C for long running applications, so memory use doesn't grow too
C large.
C
      call NhlFClose
      stop
      end

      SUBROUTINE DTREXC( COMPQ, N, T, LDT, Q, LDQ, IFST, ILST, WORK,
     $                   INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     March 31, 1993
*
*     .. Scalar Arguments ..
      CHARACTER          COMPQ
      INTEGER            IFST, ILST, INFO, LDQ, LDT, N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   Q( LDQ, * ), T( LDT, * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  DTREXC reorders the real Schur factorization of a real matrix
*  A = Q*T*Q**T, so that the diagonal block of T with row index IFST is
*  moved to row ILST.
*
*  The real Schur form T is reordered by an orthogonal similarity
*  transformation Z**T*T*Z, and optionally the matrix Q of Schur vectors
*  is updated by postmultiplying it with Z.
*
*  T must be in Schur canonical form (as returned by DHSEQR), that is,
*  block upper triangular with 1-by-1 and 2-by-2 diagonal blocks; each
*  2-by-2 diagonal block has its diagonal elements equal and its
*  off-diagonal elements of opposite sign.
*
*  Arguments
*  =========
*
*  COMPQ   (input) CHARACTER*1
*          = 'V':  update the matrix Q of Schur vectors;
*          = 'N':  do not update Q.
*
*  N       (input) INTEGER
*          The order of the matrix T. N >= 0.
*
*  T       (input/output) DOUBLE PRECISION array, dimension (LDT,N)
*          On entry, the upper quasi-triangular matrix T, in Schur
*          Schur canonical form.
*          On exit, the reordered upper quasi-triangular matrix, again
*          in Schur canonical form.
*
*  LDT     (input) INTEGER
*          The leading dimension of the array T. LDT >= max(1,N).
*
*  Q       (input/output) DOUBLE PRECISION array, dimension (LDQ,N)
*          On entry, if COMPQ = 'V', the matrix Q of Schur vectors.
*          On exit, if COMPQ = 'V', Q has been postmultiplied by the
*          orthogonal transformation matrix Z which reorders T.
*          If COMPQ = 'N', Q is not referenced.
*
*  LDQ     (input) INTEGER
*          The leading dimension of the array Q.  LDQ >= max(1,N).
*
*  IFST    (input/output) INTEGER
*  ILST    (input/output) INTEGER
*          Specify the reordering of the diagonal blocks of T.
*          The block with row index IFST is moved to row ILST, by a
*          sequence of transpositions between adjacent blocks.
*          On exit, if IFST pointed on entry to the second row of a
*          2-by-2 block, it is changed to point to the first row; ILST
*          always points to the first row of the block in its final
*          position (which may differ from its input value by +1 or -1).
*          1 <= IFST <= N; 1 <= ILST <= N.
*
*  WORK    (workspace) DOUBLE PRECISION array, dimension (N)
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*          = 1:  two adjacent blocks were too close to swap (the problem
*                is very ill-conditioned); T may have been partially
*                reordered, and ILST points to the first row of the
*                current position of the block being moved.
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO
      PARAMETER          ( ZERO = 0.0D+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            WANTQ
      INTEGER            HERE, NBF, NBL, NBNEXT
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           DLAEXC, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX
*     ..
*     .. Executable Statements ..
*
*     Decode and test the input arguments.
*
      INFO = 0
      WANTQ = LSAME( COMPQ, 'V' )
      IF( .NOT.WANTQ .AND. .NOT.LSAME( COMPQ, 'N' ) ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( LDT.LT.MAX( 1, N ) ) THEN
         INFO = -4
      ELSE IF( LDQ.LT.1 .OR. ( WANTQ .AND. LDQ.LT.MAX( 1, N ) ) ) THEN
         INFO = -6
      ELSE IF( IFST.LT.1 .OR. IFST.GT.N ) THEN
         INFO = -7
      ELSE IF( ILST.LT.1 .OR. ILST.GT.N ) THEN
         INFO = -8
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DTREXC', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.LE.1 )
     $   RETURN
*
*     Determine the first row of specified block
*     and find out it is 1 by 1 or 2 by 2.
*
      IF( IFST.GT.1 ) THEN
         IF( T( IFST, IFST-1 ).NE.ZERO )
     $      IFST = IFST - 1
      END IF
      NBF = 1
      IF( IFST.LT.N ) THEN
         IF( T( IFST+1, IFST ).NE.ZERO )
     $      NBF = 2
      END IF
*
*     Determine the first row of the final block
*     and find out it is 1 by 1 or 2 by 2.
*
      IF( ILST.GT.1 ) THEN
         IF( T( ILST, ILST-1 ).NE.ZERO )
     $      ILST = ILST - 1
      END IF
      NBL = 1
      IF( ILST.LT.N ) THEN
         IF( T( ILST+1, ILST ).NE.ZERO )
     $      NBL = 2
      END IF
*
      IF( IFST.EQ.ILST )
     $   RETURN
*
      IF( IFST.LT.ILST ) THEN
*
*        Update ILST
*
         IF( NBF.EQ.2 .AND. NBL.EQ.1 )
     $      ILST = ILST - 1
         IF( NBF.EQ.1 .AND. NBL.EQ.2 )
     $      ILST = ILST + 1
*
         HERE = IFST
*
   10    CONTINUE
*
*        Swap block with next one below
*
         IF( NBF.EQ.1 .OR. NBF.EQ.2 ) THEN
*
*           Current block either 1 by 1 or 2 by 2
*
            NBNEXT = 1
            IF( HERE+NBF+1.LE.N ) THEN
               IF( T( HERE+NBF+1, HERE+NBF ).NE.ZERO )
     $            NBNEXT = 2
            END IF
            CALL DLAEXC( WANTQ, N, T, LDT, Q, LDQ, HERE, NBF, NBNEXT,
     $                   WORK, INFO )
            IF( INFO.NE.0 ) THEN
               ILST = HERE
               RETURN
            END IF
            HERE = HERE + NBNEXT
*
*           Test if 2 by 2 block breaks into two 1 by 1 blocks
*
            IF( NBF.EQ.2 ) THEN
               IF( T( HERE+1, HERE ).EQ.ZERO )
     $            NBF = 3
            END IF
*
         ELSE
*
*           Current block consists of two 1 by 1 blocks each of which
*           must be swapped individually
*
            NBNEXT = 1
            IF( HERE+3.LE.N ) THEN
               IF( T( HERE+3, HERE+2 ).NE.ZERO )
     $            NBNEXT = 2
            END IF
            CALL DLAEXC( WANTQ, N, T, LDT, Q, LDQ, HERE+1, 1, NBNEXT,
     $                   WORK, INFO )
            IF( INFO.NE.0 ) THEN
               ILST = HERE
               RETURN
            END IF
            IF( NBNEXT.EQ.1 ) THEN
*
*              Swap two 1 by 1 blocks, no problems possible
*
               CALL DLAEXC( WANTQ, N, T, LDT, Q, LDQ, HERE, 1, NBNEXT,
     $                      WORK, INFO )
               HERE = HERE + 1
            ELSE
*
*              Recompute NBNEXT in case 2 by 2 split
*
               IF( T( HERE+2, HERE+1 ).EQ.ZERO )
     $            NBNEXT = 1
               IF( NBNEXT.EQ.2 ) THEN
*
*                 2 by 2 Block did not split
*
                  CALL DLAEXC( WANTQ, N, T, LDT, Q, LDQ, HERE, 1,
     $                         NBNEXT, WORK, INFO )
                  IF( INFO.NE.0 ) THEN
                     ILST = HERE
                     RETURN
                  END IF
                  HERE = HERE + 2
               ELSE
*
*                 2 by 2 Block did split
*
                  CALL DLAEXC( WANTQ, N, T, LDT, Q, LDQ, HERE, 1, 1,
     $                         WORK, INFO )
                  CALL DLAEXC( WANTQ, N, T, LDT, Q, LDQ, HERE+1, 1, 1,
     $                         WORK, INFO )
                  HERE = HERE + 2
               END IF
            END IF
         END IF
         IF( HERE.LT.ILST )
     $      GO TO 10
*
      ELSE
*
         HERE = IFST
   20    CONTINUE
*
*        Swap block with next one above
*
         IF( NBF.EQ.1 .OR. NBF.EQ.2 ) THEN
*
*           Current block either 1 by 1 or 2 by 2
*
            NBNEXT = 1
            IF( HERE.GE.3 ) THEN
               IF( T( HERE-1, HERE-2 ).NE.ZERO )
     $            NBNEXT = 2
            END IF
            CALL DLAEXC( WANTQ, N, T, LDT, Q, LDQ, HERE-NBNEXT, NBNEXT,
     $                   NBF, WORK, INFO )
            IF( INFO.NE.0 ) THEN
               ILST = HERE
               RETURN
            END IF
            HERE = HERE - NBNEXT
*
*           Test if 2 by 2 block breaks into two 1 by 1 blocks
*
            IF( NBF.EQ.2 ) THEN
               IF( T( HERE+1, HERE ).EQ.ZERO )
     $            NBF = 3
            END IF
*
         ELSE
*
*           Current block consists of two 1 by 1 blocks each of which
*           must be swapped individually
*
            NBNEXT = 1
            IF( HERE.GE.3 ) THEN
               IF( T( HERE-1, HERE-2 ).NE.ZERO )
     $            NBNEXT = 2
            END IF
            CALL DLAEXC( WANTQ, N, T, LDT, Q, LDQ, HERE-NBNEXT, NBNEXT,
     $                   1, WORK, INFO )
            IF( INFO.NE.0 ) THEN
               ILST = HERE
               RETURN
            END IF
            IF( NBNEXT.EQ.1 ) THEN
*
*              Swap two 1 by 1 blocks, no problems possible
*
               CALL DLAEXC( WANTQ, N, T, LDT, Q, LDQ, HERE, NBNEXT, 1,
     $                      WORK, INFO )
               HERE = HERE - 1
            ELSE
*
*              Recompute NBNEXT in case 2 by 2 split
*
               IF( T( HERE, HERE-1 ).EQ.ZERO )
     $            NBNEXT = 1
               IF( NBNEXT.EQ.2 ) THEN
*
*                 2 by 2 Block did not split
*
                  CALL DLAEXC( WANTQ, N, T, LDT, Q, LDQ, HERE-1, 2, 1,
     $                         WORK, INFO )
                  IF( INFO.NE.0 ) THEN
                     ILST = HERE
                     RETURN
                  END IF
                  HERE = HERE - 2
               ELSE
*
*                 2 by 2 Block did split
*
                  CALL DLAEXC( WANTQ, N, T, LDT, Q, LDQ, HERE, 1, 1,
     $                         WORK, INFO )
                  CALL DLAEXC( WANTQ, N, T, LDT, Q, LDQ, HERE-1, 1, 1,
     $                         WORK, INFO )
                  HERE = HERE - 2
               END IF
            END IF
         END IF
         IF( HERE.GT.ILST )
     $      GO TO 20
      END IF
      ILST = HERE
*
      RETURN
*
*     End of DTREXC
*
      END

C
C $Id: lbgeti.f,v 1.5 2008-07-27 00:17:17 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE LBGETI (WHCH,IVAL)
C
        CHARACTER*(*) WHCH
C
C This subroutine is called to retrieve the integer value of a specified
C parameter.
C
C WHCH is the name of the parameter whose value is to be retrieved.
C
C IVAL is an integer variable in which the desired value is to be
C returned by LBGETI.
C
C
C Check for an uncleared prior error.
C
        IF (ICFELL('LBGETI - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C Use LBGETR to retrieve the real value, fix it, and return it to the
C user.
C
        CALL LBGETR (WHCH,RVAL)
        IF (ICFELL('LBGETI',2).NE.0) RETURN
        IVAL=INT(RVAL)
C
C Done.
C
        RETURN
C
      END

C
C	$Id: sffndc.f,v 1.4 2008-07-27 12:23:42 haley Exp $
C
C			     Copyright (C)  1997
C	     University Corporation for Atmospheric Research
C			     All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C

      LOGICAL FUNCTION SFFNDC (CHAR)
C
C  Test the current position in LINE for the presence of CHAR.
C  If a match, then set SFFNDC to .TRUE. .  If no match, then set
C  SFFNDC to .FALSE. .
C
C  This routine assumes that no reloading of the line is necessary.
C
C  Note that a match is found if CHAR is BLANK and at END-OF-LINE.
C
C  OUTPUT
C	SFFNDC - Logical value indicating the presence of CHAR
C
C  COMMON variable IPTR -  If CHAR is found, then IPTR will point to
C                          the next position in the line;  if CHAR
C                          is not found,  then IPTR is unchanged.
C
      include 'fntcom.h'
      include 'fnttab.h'
C
      CHARACTER*1 CHAR
C
      CHARACTER*1 BLANK
      DATA BLANK/' '/
C
C  If END-OF-LINE and CHAR is BLANK, then set match.
C
      IF (IPTR.GT.LSIZE .AND. CHAR.EQ.BLANK) THEN
	SFFNDC = .TRUE.
        IPTR = IPTR + 1
        RETURN
      END IF
C
C  Check for a match.
C
      IF (LINE(IPTR:IPTR) .EQ. CHAR) THEN
	SFFNDC = .TRUE.
	IPTR = IPTR + 1
	RETURN
      END IF
C
C  Failure, so set SFFNDC to .FALSE. .
C
      SFFNDC = .FALSE.
      RETURN
      END

      SUBROUTINE GZCLPO (XCCP,YCCP,NCCP,XCSP,YCSP,NCSP,
     +                        RWRK,IWRK,NWRK,IERR)
C
      DIMENSION XCCP(NCCP),YCCP(NCCP)
      DIMENSION XCSP(NCSP),YCSP(NCSP)
      DIMENSION RWRK(NWRK),IWRK(NWRK)
C
C The subroutine GZCLPO, given X/Y coordinates defining the vertices
C of a "clip polygon" in (XCCP(I),I=1,NCCP) and (YCCP(I),I=1,NCCP),
C X/Y coordinates defining the vertices of a "subject polygon" in
C (XCSP(I),I=1,NCSP) and (YCSP(I),I=1,NCSP), and the real and integer
C workspaces RWRK and IWRK, each of which is of length NWRK, generates
C the set of polygons representing pieces of the subject polygon lying
C inside the clip polygon and delivers each of them to be plotted
C with GZPUTR.  Errors, in general, result in an immediate RETURN
C with IERR non-zero; on a normal return, IERR
C is zero.
C
C For most efficient use of memory, IWRK and RWRK should be EQUIVALENCEd
C to each other.
C
C The algorithm used is that described by Bala R. Vatti in the article
C "A Generic Solution to Polygon Clipping", which was published in the
C July, 1992, issue of "Communications of the ACM" (Vol. 35, No. 7).
C
C This code was produced from an iftran master coded by David Kennison
C at NCAR in 1994.
C
C
C Define RBIG to be a large real number.
C
      DATA RBIG / 1.E36 /
C
C Zero error flag.
C
      IERR=0
C
C Decide what the real lengths of the polygons are (depending on whether
C the first point is repeated at the end or not).
C
      LCCP=NCCP
      IF (XCCP(NCCP).EQ.XCCP(1).AND.YCCP(NCCP).EQ.YCCP(1)) LCCP=NCCP-1
C
      LCSP=NCSP
      IF (XCSP(NCSP).EQ.XCSP(1).AND.YCSP(NCSP).EQ.YCSP(1)) LCSP=NCSP-1
C
C Do some simple checks for degenerate cases.
C
      IF (.NOT.(LCCP.LT.3)) GO TO 10001
        GO TO 10003
10001 CONTINUE
C
      IF (.NOT.(LCSP.LT.3)) GO TO 10004
        GO TO 10006
10004 CONTINUE
C
C Check to see if the input polygon is entirely within the clipping
C rectangle and treat that case specially.
C
      XCSPMN = XCSP(1)
      XCSPMX = XCSP(1)
      YCSPMN = YCSP(1)
      YCSPMX = YCSP(1)
      DO 100 I=1,LCSP
        XCSPMN = MIN(XCSPMN,XCSP(I))
        XCSPMX = MAX(XCSPMX,XCSP(I))
        YCSPMN = MIN(YCSPMN,YCSP(I))
        YCSPMX = MAX(YCSPMX,YCSP(I))
  100 CONTINUE
      IF (XCSPMN.GE.XCCP(1) .AND. XCSPMX.LE.XCCP(2) .AND.
     +    YCSPMN.GE.YCCP(2) .AND. YCSPMX.LE.YCCP(3)) THEN
        CALL GZPUTR(NCSP,NCSP,XCSP,YCSP,1,IERR)
        RETURN
      ENDIF
C
C If the subject polygon is entirely outside the clip rectangle
C return with no error.
C
      XCCMN = MIN(XCCP(1),XCCP(2),XCCP(3),XCCP(4))
      YCCMN = MIN(YCCP(1),YCCP(2),YCCP(3),YCCP(4))
      XCCMX = MAX(XCCP(1),XCCP(2),XCCP(3),XCCP(4))
      YCCMX = MAX(YCCP(1),YCCP(2),YCCP(3),YCCP(4))
      IF (XCSPMN.GT.XCCMX .OR. XCSPMX.LT.XCCMN .OR.
     +    YCSPMN.GT.YCCMX .OR. YCSPMX.LT.YCCMN) THEN
        RERR = 0
        RETURN
      ENDIF
C
C Initialize the garbage lists, onto which released 3-word and 10-word
C nodes are put for possible re-use.
C
      IG03=0
      IG10=0
C
C Initialize pointers to the last-used elements at the beginning and
C end of the available workspace.  Initially, the whole thing is
C available:
C
      IPWL=0
      IPWU=NWRK+1
C
C Build the "LMT" ("Local Minimum Table").  Initially, it is empty:
C
      ILMT=0
C
C Search for local minima of the clip polygon.  First, find a starting
C place where the Y coordinate changes one way or the other.
C
      INXT=0
C
      DO 10007 I=1,LCCP-1
        IF (.NOT.(YCCP(I).NE.YCCP(I+1))) GO TO 10008
          INXT=I
          YNXT=YCCP(INXT)
          GO TO 101
10008   CONTINUE
10007 CONTINUE
C
C If there is no such starting place, take an error exit.
C
      GO TO 10003
C
C Otherwise, go through the entire polygon from the starting position,
C finding all those places where the Y value increases after having
C decreased.  Each such place constitutes one of the local minima in
C the LMT.
C
  101 IDIR=0
C
      DO 10010 I=0,LCCP
        ILST=INXT
        YLST=YNXT
        INXT=INXT+1
        IF (INXT.GT.LCCP) INXT=INXT-LCCP
        YNXT=YCCP(INXT)
        IF (.NOT.(YNXT.LT.YLST)) GO TO 10011
          IDIR=-1
        GO TO 10012
10011   CONTINUE
        IF (.NOT.(YNXT.GT.YLST)) GO TO 10013
          IF (.NOT.(IDIR.LT.0)) GO TO 10014
            ILMN=IPWL+1
            IPWL=IPWL+3
            IF (.NOT.(IPWL.GE.IPWU)) GO TO 10015
              GO TO 10017
10015       CONTINUE
            RWRK(ILMN)=YLST
            IWRK(ILMN+1)=ILST
            ITM1=0
            ITM2=ILMT
10018       CONTINUE
              IF (ITM2.EQ.0) GO TO 10019
              IF (RWRK(ILMN).LE.RWRK(ITM2)) GO TO 10019
              ITM1=ITM2
              ITM2=IWRK(ITM2+2)
            GO TO 10018
10019       CONTINUE
            IF (.NOT.(ITM1.EQ.0)) GO TO 10020
              ILMT=ILMN
            GO TO 10021
10020       CONTINUE
              IWRK(ITM1+2)=ILMN
10021       CONTINUE
            IWRK(ILMN+2)=ITM2
10014     CONTINUE
          IDIR=+1
10012   CONTINUE
10013   CONTINUE
10010 CONTINUE
C
C In the same way, search for local minima of the subject polygon.
C
      INXT=0
C
      DO 10022 I=1,LCSP-1
        IF (.NOT.(YCSP(I).NE.YCSP(I+1))) GO TO 10023
          INXT=I
          YNXT=YCSP(INXT)
          GO TO 102
10023   CONTINUE
10022 CONTINUE
C
      GO TO 10006
C
  102 IDIR=0
C
      DO 10025 I=0,LCSP
        ILST=INXT
        YLST=YNXT
        INXT=INXT+1
        IF (INXT.GT.LCSP) INXT=INXT-LCSP
        YNXT=YCSP(INXT)
        IF (.NOT.(YNXT.LT.YLST)) GO TO 10026
          IDIR=-1
        GO TO 10027
10026   CONTINUE
        IF (.NOT.(YNXT.GT.YLST)) GO TO 10028
          IF (.NOT.(IDIR.LT.0)) GO TO 10029
            ILMN=IPWL+1
            IPWL=IPWL+3
            IF (.NOT.(IPWL.GE.IPWU)) GO TO 10030
              GO TO 10017
10030       CONTINUE
            RWRK(ILMN)=YLST
            IWRK(ILMN+1)=LCCP+ILST
            ITM1=0
            ITM2=ILMT
10032       CONTINUE
              IF (ITM2.EQ.0) GO TO 10033
              IF (RWRK(ILMN).LE.RWRK(ITM2)) GO TO 10033
              ITM1=ITM2
              ITM2=IWRK(ITM2+2)
            GO TO 10032
10033       CONTINUE
            IF (.NOT.(ITM1.EQ.0)) GO TO 10034
              ILMT=ILMN
            GO TO 10035
10034       CONTINUE
              IWRK(ITM1+2)=ILMN
10035       CONTINUE
            IWRK(ILMN+2)=ITM2
10029     CONTINUE
          IDIR=+1
10027   CONTINUE
10028   CONTINUE
10025 CONTINUE
C
C Initialize the output polygon list pointer to indicate that no
C polygons have been generated yet:
C
      IPPL=0
C
C Initialize the "AET" ("Active Edge Table") to be empty:
C
      IAET=0
C
C Initialize the variable that normally keeps track of the Y coordinate
C at the top of the current "scanbeam"; the value will be used as the Y
C coordinate at the bottom of the first one.
C
      YTOS=RWRK(ILMT)
C
C Loop through the "scanbeams".
C
10036 CONTINUE
C
C YBOS is the Y coordinate of the bottom of the new scanbeam.
C
        YBOS=YTOS
C
C Loop through those local minima in the LMT having Y coordinate
C YBOS; for each, add to the AET the pair of edges that start at
C that local minimum.
C
10037   CONTINUE
C
C Quit if the end of the LMT has been reached.
C
          IF (ILMT.EQ.0) GO TO 10038
C
C Quit if the Y coordinate of the next local minimum is too large.
C
          IF (RWRK(ILMT).GT.YBOS) GO TO 10038
C
C Retrieve in IMIN the index of the coordinates of the local minimum.
C
          IMIN=IWRK(ILMT+1)
C
C Set ICOS to indicate whether the local minimum comes from the clip
C polygon or the subject polygon.  XMIN and YMIN are the X and Y
C coordinates of the local minimum.  ILST indexes the coordinates of
C the last point along the polygon; the coordinates are XLST and YLST.
C Similarly, INXT indexes the coordinates of the next point along
C the polygon; the coordinates are XNXT and YNXT.
C
          IF (.NOT.(IMIN.LE.LCCP)) GO TO 10039
            ICOS=0
            XMIN=XCCP(IMIN)
            YMIN=YCCP(IMIN)
            ILST=IMIN-1
            IF (ILST.LT.1) ILST=ILST+LCCP
            XLST=XCCP(ILST)
            YLST=YCCP(ILST)
            INXT=IMIN+1
            IF (INXT.GT.LCCP) INXT=INXT-LCCP
            XNXT=XCCP(INXT)
            YNXT=YCCP(INXT)
          GO TO 10040
10039     CONTINUE
            ICOS=1
            IMIN=IMIN-LCCP
            XMIN=XCSP(IMIN)
            YMIN=YCSP(IMIN)
            ILST=IMIN-1
            IF (ILST.LT.1) ILST=ILST+LCSP
            XLST=XCSP(ILST)
            YLST=YCSP(ILST)
            INXT=IMIN+1
            IF (INXT.GT.LCSP) INXT=INXT-LCSP
            XNXT=XCSP(INXT)
            YNXT=YCSP(INXT)
10040     CONTINUE
C
C Now we must scan the AET to determine where to put the new edges.
C After executing the loop below, ITM1 will point to the node after
C which they will be inserted (zero if at beginning) and ITM2 will
C point to the node before which they will be inserted (zero if at
C end).  The variable IOCP will be updated to indicate whether the
C local minimum is inside (1) or outside (0) the clip polygon.
C Similarly, IOSP will be updated to indicate whether the local
C minimum is inside (1) or outside (0) the subject polygon.
C
          ITM1=0
          ITM2=IAET
C
          IOCP=0
          IOSP=0
C
10041     CONTINUE
C
C Exit if the end of the AET has been reached.
C
            IF (ITM2.EQ.0) GO TO 10042
C
C Exit if the new local minimum fits between elements ITM1 and ITM2 of
C the AET.
C
            IF (XMIN.LE.RWRK(ITM2)) GO TO 10042
C
C Advance to the next position in the AET.
C
            ITM1=ITM2
            ITM2=IWRK(ITM2+6)
C
C Update the flags that say where we are relative to the clip and
C subject polygons.
C
            IF (.NOT.(IWRK(ITM1+4).EQ.0)) GO TO 10043
              IOCP=1-IOCP
            GO TO 10044
10043       CONTINUE
              IOSP=1-IOSP
10044       CONTINUE
C
C End of loop through the AET.
C
          GO TO 10041
10042     CONTINUE
C
C Create two new nodes in the AET.  Either re-use 10-word nodes from the
C garbage list or create new ones.
C
          IF (.NOT.(IG10.NE.0)) GO TO 10045
            IPNL=IG10
            IG10=IWRK(IG10)
          GO TO 10046
10045     CONTINUE
            IPNL=IPWL+1
            IPWL=IPWL+10
            IF (.NOT.(IPWL.GE.IPWU)) GO TO 10047
              GO TO 10017
10047       CONTINUE
10046     CONTINUE
C
          IF (.NOT.(IG10.NE.0)) GO TO 10049
            IPNN=IG10
            IG10=IWRK(IG10)
          GO TO 10050
10049     CONTINUE
            IPNN=IPWL+1
            IPWL=IPWL+10
            IF (.NOT.(IPWL.GE.IPWU)) GO TO 10051
              GO TO 10017
10051       CONTINUE
10050     CONTINUE
C
C Fill in the information about the two new edges:
C
          RWRK(IPNL)=XMIN
          RWRK(IPNN)=XMIN
C
          RWRK(IPNL+1)=XLST
          RWRK(IPNN+1)=XNXT
C
          RWRK(IPNL+2)=YLST
          RWRK(IPNN+2)=YNXT
C
          IF (.NOT.(YLST.NE.YMIN)) GO TO 10053
            RWRK(IPNL+3)=(XLST-XMIN)/(YLST-YMIN)
          GO TO 10054
10053     CONTINUE
            RWRK(IPNL+3)=SIGN(RBIG,XLST-XMIN)
10054     CONTINUE
C
          IF (.NOT.(YNXT.NE.YMIN)) GO TO 10055
            RWRK(IPNN+3)=(XNXT-XMIN)/(YNXT-YMIN)
          GO TO 10056
10055     CONTINUE
            RWRK(IPNN+3)=SIGN(RBIG,XNXT-XMIN)
10056     CONTINUE
C
          IWRK(IPNL+4)=ICOS
          IWRK(IPNN+4)=ICOS
C
          IF (.NOT.(ICOS.EQ.0)) GO TO 10057
            IOPO=IOCP
          GO TO 10058
10057     CONTINUE
            IOPO=IOSP
10058     CONTINUE
C
          IF (.NOT.(RWRK(IPNL+3).LT.RWRK(IPNN+3))) GO TO 10059
C
            IPE1=IPNL
            IPE2=IPNN
C
          GO TO 10060
10059     CONTINUE
C
            IPE1=IPNN
            IPE2=IPNL
C
10060     CONTINUE
C
          IWRK(IPE1+5)=IOPO
          IWRK(IPE2+5)=1-IOPO
C
          IF (.NOT.(ITM1.EQ.0)) GO TO 10061
            IAET=IPE1
          GO TO 10062
10061     CONTINUE
            IWRK(ITM1+6)=IPE1
10062     CONTINUE
C
          IWRK(IPE1+6)=IPE2
          IWRK(IPE2+6)=ITM2
          IF (ITM2.NE.0) IWRK(ITM2+7)=IPE2
          IWRK(IPE2+7)=IPE1
          IWRK(IPE1+7)=ITM1
C
          IWRK(IPNL+8)=-ILST
          IWRK(IPNN+8)=+INXT
C
C If the edges are "contributing", create an output polygon for them
C to "contribute" to and put the initial point in it; otherwise, zero
C the output-polygon pointers.
C
          IF (.NOT.((IOCP.NE.0.AND.IOSP.NE.0).OR.(IOCP.EQ.0.AND.IOSP.NE.
     +0.AND.ICOS.EQ.0).OR.(IOCP.NE.0.AND.IOSP.EQ.0.AND.ICOS.NE.0)))
     +    GO TO 10063
C
            IF (.NOT.(IG03.NE.0)) GO TO 10064
              IPSN=IG03
              IG03=IWRK(IG03)
            GO TO 10065
10064       CONTINUE
              IPWU=IPWU-3
              IF (.NOT.(IPWU.LE.IPWL)) GO TO 10066
                GO TO 10017
10066         CONTINUE
              IPSN=IPWU
10065       CONTINUE
C
            RWRK(IPSN  )=XMIN
            RWRK(IPSN+1)=YMIN
            IWRK(IPSN+2)=0
C
            IF (.NOT.(IG03.NE.0)) GO TO 10068
              IPPN=IG03
              IG03=IWRK(IG03)
            GO TO 10069
10068       CONTINUE
              IPWU=IPWU-3
              IF (.NOT.(IPWU.LE.IPWL)) GO TO 10070
                GO TO 10017
10070         CONTINUE
              IPPN=IPWU
10069       CONTINUE
C
            IWRK(IPPN  )=IPSN
            IWRK(IPPN+1)=IPSN
            IWRK(IPPN+2)=IPPL
C
            IPPL=IPPN
            IWRK(IPNL+9)=IPPN
            IWRK(IPNN+9)=IPPN
C
          GO TO 10072
10063     CONTINUE
C
            IWRK(IPNL+9)=0
            IWRK(IPNN+9)=0
C
10072     CONTINUE
C
C Put the current LMT node on the appropriate garbage list for re-use.
C
          IWRK(ILMT)=IG03
          IG03=ILMT
C
C Advance to the next element of the LMT.
C
          ILMT=IWRK(ILMT+2)
C
C End of the loop through the LMT.
C
        GO TO 10037
10038   CONTINUE
C
C At this point, if the AET is empty, the scanbeam loop is exited.
C
  103 CONTINUE
        IF (IAET.EQ.0) GO TO 10073
C
C Scan the AET to compute the value of the Y coordinate at the top of
C the scanbeam (YTOS) and to look for horizontal edges in the list.
C
        ITMP=IAET
C
        YTOS=RWRK(ITMP+2)
C
        IF (ILMT.NE.0) YTOS=MIN(YTOS,RWRK(ILMT))
C
10074   CONTINUE
C
C Check for a horizontal section.
C
          IF (.NOT.(YTOS.EQ.YBOS)) GO TO 10075
C
C Step through points in the user's arrays until the end of the
C horizontal section is reached, updating the X coordinate and the
C index of the successor edge as we go.
C
            INNP=ABS(IWRK(ITMP+8))
C
10076       CONTINUE
C
              IF (.NOT.(IWRK(ITMP+4).EQ.0)) GO TO 10077
                IF (.NOT.(INNP.LT.1)) GO TO 10078
                  INNP=INNP+LCCP
                GO TO 10079
10078           CONTINUE
                IF (.NOT.(INNP.GT.LCCP)) GO TO 10080
                  INNP=INNP-LCCP
10079           CONTINUE
10080           CONTINUE
                IF (YCCP(INNP).NE.YBOS) GO TO 10081
                RWRK(ITMP)=XCCP(INNP)
              GO TO 10082
10077         CONTINUE
                IF (.NOT.(INNP.LT.1)) GO TO 10083
                  INNP=INNP+LCSP
                GO TO 10084
10083           CONTINUE
                IF (.NOT.(INNP.GT.LCSP)) GO TO 10085
                  INNP=INNP-LCSP
10084           CONTINUE
10085           CONTINUE
                IF (YCSP(INNP).NE.YBOS) GO TO 10081
                RWRK(ITMP)=XCSP(INNP)
10082         CONTINUE
C
              RWRK(ITMP+1)=RWRK(ITMP)
C
              IWRK(ITMP+8)=SIGN(INNP,IWRK(ITMP+8))
              INNP=INNP+SIGN(1,IWRK(ITMP+8))
C
            GO TO 10076
10081       CONTINUE
C
C Compute a quantity that will be used to recognize the successor of
C the horizontal edge.
C
            INNL=ABS(IWRK(ITMP+8))-SIGN(1,IWRK(ITMP+8))
            IF (.NOT.(IWRK(ITMP+4).EQ.0)) GO TO 10086
              IF (.NOT.(INNL.LT.1)) GO TO 10087
                INNL=INNL+LCCP
              GO TO 10088
10087         CONTINUE
              IF (.NOT.(INNL.GT.LCCP)) GO TO 10089
                INNL=INNL-LCCP
10088         CONTINUE
10089         CONTINUE
            GO TO 10090
10086       CONTINUE
              IF (.NOT.(INNL.LT.1)) GO TO 10091
                INNL=INNL+LCSP
              GO TO 10092
10091         CONTINUE
              IF (.NOT.(INNL.GT.LCSP)) GO TO 10093
                INNL=INNL-LCSP
10092         CONTINUE
10093         CONTINUE
10090       CONTINUE
            INNL=-SIGN(INNL,IWRK(ITMP+8))
C
C Zero the pointer to the list of intersection points.
C
            IINT=0
C
C Save the current value of the pointer to the last word currently used
C in the lower end of the workspace, so that the space occupied by the
C list of intersection points can easily be reclaimed.
C
            ISWL=IPWL
C
C Initialize pointers used below.  The horizontal edge is considered
C to intersect edges that it actually passes over.  If there are edges
C in the AET with X coordinates equal to the X coordinate of the end of
C the horizontal edge, it only intersects them if that is necessary in
C order to make it and its successor be next to each other in the AET.
C
            IINN=-1
            IINQ=0
C
C Generate the list of intersection points, either to the left ...
C
            IF (.NOT.(IWRK(ITMP+7).NE.0)) GO TO 10094
C
              IDUM=IWRK(ITMP+7)
C
10095         CONTINUE
C
                IF (RWRK(IDUM).LT.RWRK(ITMP)) GO TO 10096
C
                IF (.NOT.(IWRK(IDUM+4).EQ.IWRK(ITMP+4).AND.IWRK(IDUM+8).
     +EQ.INNL)) GO TO 10097
                  IINQ=IINN
                  GO TO 10096
10097           CONTINUE
C
                IF (.NOT.(IINT.EQ.0)) GO TO 10098
                  IINT=IPWL+1
                GO TO 10099
10098           CONTINUE
                  IWRK(IINN+4)=IPWL+1
10099           CONTINUE
C
                IINN=IPWL+1
                IPWL=IPWL+5
C
                IF (.NOT.(IPWL.GE.IPWU)) GO TO 10100
                  GO TO 10017
10100           CONTINUE
C
                RWRK(IINN)=RWRK(IDUM)
                RWRK(IINN+1)=YBOS
                IWRK(IINN+2)=IDUM
                IWRK(IINN+3)=ITMP
                IWRK(IINN+4)=0
C
                IF (RWRK(IDUM).GT.RWRK(ITMP)) IINQ=IINN
C
                IDUM=IWRK(IDUM+7)
C
                IF (IDUM.EQ.0) GO TO 10096
C
              GO TO 10095
10096         CONTINUE
C
10094       CONTINUE
C
C ... or to the right.
C
            IF (.NOT.(IINQ.EQ.0)) GO TO 10102
C
              IINT=0
              IPWL=ISWL
              IINN=-1
C
              IF (.NOT.(IWRK(ITMP+6).NE.0)) GO TO 10103
C
                IDUM=IWRK(ITMP+6)
C
10104           CONTINUE
C
                  IF (RWRK(IDUM).GT.RWRK(ITMP)) GO TO 10105
C
                  IF (.NOT.(IWRK(IDUM+4).EQ.IWRK(ITMP+4).AND.IWRK(IDUM+8
     +).EQ.INNL)) GO TO 10106
                    IINQ=IINN
                    GO TO 10105
10106             CONTINUE
C
                  IF (.NOT.(IINT.EQ.0)) GO TO 10107
                    IINT=IPWL+1
                  GO TO 10108
10107             CONTINUE
                    IWRK(IINN+4)=IPWL+1
10108             CONTINUE
C
                  IINN=IPWL+1
                  IPWL=IPWL+5
C
                  IF (.NOT.(IPWL.GE.IPWU)) GO TO 10109
                    GO TO 10017
10109             CONTINUE
C
                  RWRK(IINN)=RWRK(IDUM)
                  RWRK(IINN+1)=YBOS
                  IWRK(IINN+2)=ITMP
                  IWRK(IINN+3)=IDUM
                  IWRK(IINN+4)=0
C
                  IF (RWRK(IDUM).LT.RWRK(ITMP)) IINQ=IINN
C
                  IDUM=IWRK(IDUM+6)
C
                  IF (IDUM.EQ.0) GO TO 10105
C
                GO TO 10104
10105           CONTINUE
C
10103         CONTINUE
C
10102       CONTINUE
C
C Clear entries at the end of the intersection list that don't need to
C be considered to be intersections.  (This may clear the whole list.)
C
            IF (.NOT.(IINQ.EQ.0)) GO TO 10111
              IINT=0
              IPWL=ISWL
            GO TO 10112
10111       CONTINUE
            IF (.NOT.(IINQ.GT.0)) GO TO 10113
              IWRK(IINQ+4)=0
10112       CONTINUE
10113       CONTINUE
C
C If any intersection points were found, process them and then reclaim
C the space used for the list.
C
            IF (.NOT.(IINT.NE.0)) GO TO 10114
              L10116=    1
              GO TO 10116
10115         CONTINUE
              IPWL=ISWL
10114       CONTINUE
C
C The horizontal edge is terminating at this point, so handle that.
C
            L10118=    1
            GO TO 10118
10117       CONTINUE
C
C Go back to see if the AET is empty now and, if not, to rescan it for
C more horizontal segments.
C
            GO TO 103
C
10075     CONTINUE
C
C Move to the next node in the AET.
C
          ITMP=IWRK(ITMP+6)
C
C Quit if there are none.
C
          IF (ITMP.EQ.0) GO TO 10119
C
C Update the variable that says where the top of the scanbeam is.
C
          YTOS=MIN(YTOS,RWRK(ITMP+2))
C
        GO TO 10074
10119   CONTINUE
C
C Create a table of all intersections of edges in the AET, sorted in
C order of increasing Y coordinate.  To do this, we also create a table
C of the current edges in the AET, sorted in the opposite order in which
C they intersect the top of the scanbeam.  Initially, the intersection
C table is empty:
C
        IINT=0
C
C The intersection table and the sorted edge table are formed in the
C lower part of the workspace array.  The value of the pointer to the
C last word currently used in that part of the workspace is saved so
C that, when we are done using the INT and the SET, the space used for
C them can be reclaimed by just restoring the value of this pointer:
C
        ISWL=IPWL
C
C Initialize the "Sorted Edge Table" to contain just the first edge
C from the AET.
C
        ISET=IPWL+1
C
        IPWL=IPWL+3
C
        IF (.NOT.(IPWL.GE.IPWU)) GO TO 10120
          GO TO 10017
10120   CONTINUE
C
        RWRK(ISET)=RWRK(IAET+1)+(YTOS-RWRK(IAET+2))*RWRK(IAET+3)
        IWRK(ISET+1)=IAET
        IWRK(ISET+2)=0
C
C Examine each of the remaining edges in the AET, one at a time,
C looking for intersections with edges that have already gone into
C the SET; for each one found, generate an entry in the INT.  Special
C care is taken to ensure that edges which are each other's successors
C end up adjacent to each other in the AET.
C
        ITMP=IWRK(IAET+6)
C
10122   CONTINUE
C
          IF (ITMP.EQ.0) GO TO 10123
C
          XTMP=RWRK(ITMP+1)+(YTOS-RWRK(ITMP+2))*RWRK(ITMP+3)
C
          IST1=0
          IST2=ISET
C
10124     CONTINUE
C
            IF (IST2.EQ.0) GO TO 10125
            IF (XTMP.GT.RWRK(IST2)) GO TO 10125
C
            IF (.NOT.(XTMP.EQ.RWRK(IST2))) GO TO 10126
C
              IST3=IWRK(IST2+2)
              IST4=0
C
10127         CONTINUE
C
                IF (IST3.EQ.0) GO TO 10128
                IF (XTMP.NE.RWRK(IST3)) GO TO 10128
C
                IF (.NOT.(IWRK(IWRK(IST3+1)+4).EQ.IWRK(ITMP+4).AND.IWRK(
     +IWRK(IST3+1)+8).EQ.-IWRK(ITMP+8))) GO TO 10129
                  IST4=1
                  GO TO 10128
10129           CONTINUE
C
                IST3=IWRK(IST3+2)
C
              GO TO 10127
10128         CONTINUE
C
              IF (IST4.EQ.0) GO TO 10125
C
              XINT=XTMP
              YINT=YTOS
C
            GO TO 10130
10126       CONTINUE
C
              IF (.NOT.(ABS(RWRK(ITMP+3)-RWRK(IWRK(IST2+1)+3)).GT.1.E-6)
     +)       GO TO 10131
                YINT=YBOS-(RWRK(ITMP  )-RWRK(IWRK(IST2+1)  ))/
     +                    (RWRK(ITMP+3)-RWRK(IWRK(IST2+1)+3))
              GO TO 10132
10131         CONTINUE
                YINT=.5*(YBOS+YTOS)
10132         CONTINUE
C
              IF (.NOT.(ABS(RWRK(ITMP+3)).LT.ABS(RWRK(IWRK(IST2+1)+3))))
     +        GO TO 10133
                XINT=RWRK(ITMP+1)+(YINT-RWRK(ITMP+2))*RWRK(ITMP+3)
              GO TO 10134
10133         CONTINUE
                XINT=RWRK(IWRK(IST2+1)+1)+(YINT-RWRK(IWRK(IST2+1)+2))*
     +               RWRK(IWRK(IST2+1)+3)
10134         CONTINUE
C
10130       CONTINUE
C
            IINN=IPWL+1
            IPWL=IPWL+5
C
            IF (.NOT.(IPWL.GE.IPWU)) GO TO 10135
              GO TO 10017
10135       CONTINUE
C
            RWRK(IINN)=XINT
            RWRK(IINN+1)=YINT
            IWRK(IINN+2)=IWRK(IST2+1)
            IWRK(IINN+3)=ITMP
C
            IIN1=0
            IIN2=IINT
C
10137       CONTINUE
              IF (IIN2.EQ.0) GO TO 10138
              IF (RWRK(IINN+1).LE.RWRK(IIN2+1)) GO TO 10138
              IIN1=IIN2
              IIN2=IWRK(IIN2+4)
            GO TO 10137
10138       CONTINUE
C
            IF (.NOT.(IIN1.EQ.0)) GO TO 10139
              IINT=IINN
            GO TO 10140
10139       CONTINUE
              IWRK(IIN1+4)=IINN
10140       CONTINUE
C
            IWRK(IINN+4)=IIN2
C
            IST1=IST2
            IST2=IWRK(IST2+2)
C
          GO TO 10124
10125     CONTINUE
C
          ISTN=IPWL+1
          IPWL=IPWL+3
C
          IF (.NOT.(IPWL.GE.IPWU)) GO TO 10141
            GO TO 10017
10141     CONTINUE
C
          IF (.NOT.(IST1.EQ.0)) GO TO 10143
            ISET=ISTN
          GO TO 10144
10143     CONTINUE
            IWRK(IST1+2)=ISTN
10144     CONTINUE
C
          RWRK(ISTN)=XTMP
          IWRK(ISTN+1)=ITMP
          IWRK(ISTN+2)=IST2
C
          ITMP=IWRK(ITMP+6)
C
        GO TO 10122
10123   CONTINUE
C
C If intersections have been found, process them.
C
        IF (.NOT.(IINT.NE.0)) GO TO 10145
          L10116=    2
          GO TO 10116
10146     CONTINUE
10145   CONTINUE
C
C Discard the intersection table and the sorted edge table.
C
        IPWL=ISWL
C
C Loop through all the edges in the AET, updating the X coordinates and
C further processing those that terminate at the top of the scanbeam.
C
        ITMP=IAET
C
10147   CONTINUE
C
C Exit if all the edges have been done.
C
          IF (ITMP.EQ.0) GO TO 10148
C
C Update the X coordinate to its position at the top of the scanbeam.
C
          RWRK(ITMP)=RWRK(ITMP+1)+(YTOS-RWRK(ITMP+2))*RWRK(ITMP+3)
C
C If the edge terminates at the top of this scanbeam, process it.
C
          IF (.NOT.(RWRK(ITMP+2).EQ.YTOS)) GO TO 10149
            L10118=    2
            GO TO 10118
10150       CONTINUE
10149     CONTINUE
C
C Advance to the next edge in the AET.
C
          ITMP=IWRK(ITMP+6)
C
C End of loop on edges in the AET.
C
        GO TO 10147
10148   CONTINUE
C
C End of scanbeam loop.
C
      GO TO 10036
10073 CONTINUE
C
C Dump out all the polygons that have been formed.
C
C THE FOLLOWING CODE HAS BEEN REPLACED BY CODE THAT CULLS OUT DUPLICATE
C ADJACENT POINTS.  SINCE THE REPLACEMENT CODE IS SLOWER, IT WOULD BE
C ADVANTAGEOUS TO FIGURE OUT (ABOVE) HOW TO PREVENT THE DUPLICATES FROM
C SNEAKING IN.  ONCE THAT HAS BEEN DONE, THE FOLLOWING CODE CAN BE PUT
C BACK IN:
C
C       MXYC=(IPWU-1-IPWL)/2
C       IPXC=IPWL
C       IPYC=IPWL+MXYC
C       WHILE (IPPL.NE.0)
C         NXYC=0
C         ITMP=IWRK(IPPL)
C         WHILE (ITMP.NE.0)
C           NXYC=NXYC+1
C           IF (NXYC.GE.MXYC)
C             INVOKE (WORKSPACE-TOO-SMALL,NR)
C           END IF
C           RWRK(IPXC+NXYC)=RWRK(ITMP)
C           RWRK(IPYC+NXYC)=RWRK(ITMP+1)
C           ITMP=IWRK(ITMP+2)
C         END WHILE
C         NXYC=NXYC+1
C         RWRK(IPXC+NXYC)=RWRK(IWRK(IPPL))
C         RWRK(IPYC+NXYC)=RWRK(IWRK(IPPL)+1)
C         CALL URPP (RWRK(IPXC+1),RWRK(IPYC+1),NXYC)
C         IPPL=IWRK(IPPL+2)
C       END WHILE
C
      MXYC=(IPWU-1-IPWL)/2
      IF (.NOT.(MXYC.LT.1)) GO TO 10151
        GO TO 10017
10151 CONTINUE
      IPXC=IPWL
      IPYC=IPWL+MXYC
10153 CONTINUE
      IF (.NOT.(IPPL.NE.0)) GO TO 10154
        NXYC=1
        ITMP=IWRK(IPPL)
        RWRK(IPXC+1)=RWRK(ITMP  )
        RWRK(IPYC+1)=RWRK(ITMP+1)
        ITMP=IWRK(ITMP+2)
10155   CONTINUE
        IF (.NOT.(ITMP.NE.0)) GO TO 10156
          IF (.NOT.(RWRK(ITMP).NE.RWRK(IPXC+NXYC).OR.RWRK(ITMP+1).NE.RWR
     +K(IPYC+NXYC))) GO TO 10157
            NXYC=NXYC+1
            IF (.NOT.(NXYC.GE.MXYC)) GO TO 10158
              GO TO 10017
10158       CONTINUE
            RWRK(IPXC+NXYC)=RWRK(ITMP)
            RWRK(IPYC+NXYC)=RWRK(ITMP+1)
10157     CONTINUE
          ITMP=IWRK(ITMP+2)
        GO TO 10155
10156   CONTINUE
        IF (.NOT.(RWRK(IPXC+NXYC).NE.RWRK(IPXC+1).OR.RWRK(IPYC+NXYC).NE.
     +RWRK(IPYC+1))) GO TO 10160
          NXYC=NXYC+1
          RWRK(IPXC+NXYC)=RWRK(IPXC+1)
          RWRK(IPYC+NXYC)=RWRK(IPYC+1)
10160   CONTINUE
        IF (NXYC.GE.4)
     +        CALL GZPUTR(NXYC,NXYC,RWRK(IPXC+1),RWRK(IPYC+1),1,IERR)
        IPPL=IWRK(IPPL+2)
      GO TO 10153
10154 CONTINUE
C
C Normal exit.
C
      RETURN
C
C The following internal procedure processes the list of intersection
C points that IINT points to.  On entry, it may be assumed that IINT
C has been verified to be non-zero.
C
10116 CONTINUE
C
C Loop through all the points of intersection.
C
10161   CONTINUE
C
C Extract the coordinates of the point of intersection and the indices
C of the two AET nodes describing the edges that intersected.
C
  201     CONTINUE
C
          XINT=RWRK(IINT)
          YINT=RWRK(IINT+1)
C
          IPE1=IWRK(IINT+2)
          IPE2=IWRK(IINT+3)
C
C If the two edges are not adjacent in the AET, there's a problem.  We
C look for the next intersection of adjacent edges and move it to the
C beginning of the list.
C
          IF (.NOT.(IWRK(IPE1+6).NE.IPE2)) GO TO 10162
C
            IIN1=IINT
            IIN2=IWRK(IINT+4)
C
10163       CONTINUE
C
              IF (.NOT.(IIN2.EQ.0)) GO TO 10164
                IERR=1
                GO TO 10166
10164         CONTINUE
C
              IF (IWRK(IWRK(IIN2+2)+6).EQ.IWRK(IIN2+3)) GO TO 10167
C
              IIN1=IIN2
              IIN2=IWRK(IIN2+4)
C
            GO TO 10163
10167       CONTINUE
C
            IWRK(IIN1+4)=IWRK(IIN2+4)
            IWRK(IIN2+4)=IINT
            IINT=IIN2
C
            GO TO 201
C
10162     CONTINUE
C
C Check whether or not both edges are from the same input polygon.
C
          IF (.NOT.(IWRK(IPE1+4).EQ.IWRK(IPE2+4))) GO TO 10168
C
C Both edges are from the clip polygon or both are from the subject
C polygon.  If edge 1 is contributing to an output polygon, then edge
C 2 should be also, in which case we add the point of intersection to
C the left side of one polygon and to the right side of the other
C polygon.  In either case, we must swap the left/right flags in the
C two edges.
C
            IF (.NOT.(IWRK(IPE1+9).NE.0.OR.IWRK(IPE2+9).NE.0)) GO TO 101
     +69
C
              IF (.NOT.(IWRK(IPE1+9).EQ.0.OR.IWRK(IPE2+9).EQ.0)) GO TO 1
     +0170
                IERR=2
                GO TO 10166
10170         CONTINUE
C
              IF (.NOT.(IG03.NE.0)) GO TO 10172
                IPSN=IG03
                IG03=IWRK(IG03)
              GO TO 10173
10172         CONTINUE
                IPWU=IPWU-3
                IF (.NOT.(IPWU.LE.IPWL)) GO TO 10174
                  GO TO 10017
10174           CONTINUE
                IPSN=IPWU
10173         CONTINUE
C
              RWRK(IPSN  )=XINT
              RWRK(IPSN+1)=YINT
C
              IF (.NOT.(IWRK(IPE1+5).EQ.0)) GO TO 10176
                IWRK(IPSN+2)=IWRK(IWRK(IPE1+9))
                IWRK(IWRK(IPE1+9))=IPSN
              GO TO 10177
10176         CONTINUE
                IWRK(IPSN+2)=0
                IWRK(IWRK(IWRK(IPE1+9)+1)+2)=IPSN
                IWRK(IWRK(IPE1+9)+1)=IPSN
10177         CONTINUE
C
              IF (.NOT.(IG03.NE.0)) GO TO 10178
                IPSN=IG03
                IG03=IWRK(IG03)
              GO TO 10179
10178         CONTINUE
                IPWU=IPWU-3
                IF (.NOT.(IPWU.LE.IPWL)) GO TO 10180
                  GO TO 10017
10180           CONTINUE
                IPSN=IPWU
10179         CONTINUE
C
              RWRK(IPSN  )=XINT
              RWRK(IPSN+1)=YINT
C
              IF (.NOT.(IWRK(IPE2+5).EQ.0)) GO TO 10182
                IWRK(IPSN+2)=IWRK(IWRK(IPE2+9))
                IWRK(IWRK(IPE2+9))=IPSN
              GO TO 10183
10182         CONTINUE
                IWRK(IPSN+2)=0
                IWRK(IWRK(IWRK(IPE2+9)+1)+2)=IPSN
                IWRK(IWRK(IPE2+9)+1)=IPSN
10183         CONTINUE
C
10169       CONTINUE
C
            IDUM=IWRK(IPE1+5)
            IWRK(IPE1+5)=IWRK(IPE2+5)
            IWRK(IPE2+5)=IDUM
C
C One edge is from the clip polygon and the other is from the
C subject polygon.  Check for a local minimum.
C
          GO TO 10184
10168     CONTINUE
          IF (.NOT.((IWRK(IPE1+4).EQ.1.AND.IWRK(IPE1+5).EQ.1.AND.IWRK(IP
     +E2+4).EQ.0.AND.IWRK(IPE2+5).EQ.0).OR.(IWRK(IPE1+4).EQ.0.AND.IWRK(I
     +PE1+5).EQ.1.AND.IWRK(IPE2+4).EQ.1.AND.IWRK(IPE2+5).EQ.0))) GO TO 1
     +0185
C
C Process a local minimum.
C
            IF (.NOT.(IWRK(IPE1+9).NE.0.OR.IWRK(IPE2+9).NE.0)) GO TO 101
     +86
              IERR=3
              GO TO 10166
10186       CONTINUE
C
            IF (.NOT.(IG03.NE.0)) GO TO 10188
              IPSN=IG03
              IG03=IWRK(IG03)
            GO TO 10189
10188       CONTINUE
              IPWU=IPWU-3
              IF (.NOT.(IPWU.LE.IPWL)) GO TO 10190
                GO TO 10017
10190         CONTINUE
              IPSN=IPWU
10189       CONTINUE
C
            RWRK(IPSN  )=XINT
            RWRK(IPSN+1)=YINT
            IWRK(IPSN+2)=0
C
            IF (.NOT.(IG03.NE.0)) GO TO 10192
              IPPN=IG03
              IG03=IWRK(IG03)
            GO TO 10193
10192       CONTINUE
              IPWU=IPWU-3
              IF (.NOT.(IPWU.LE.IPWL)) GO TO 10194
                GO TO 10017
10194         CONTINUE
              IPPN=IPWU
10193       CONTINUE
C
            IWRK(IPPN  )=IPSN
            IWRK(IPPN+1)=IPSN
            IWRK(IPPN+2)=IPPL
            IPPL=IPPN
C
            IWRK(IPE1+9)=IPPN
            IWRK(IPE2+9)=IPPN
C
C Check for a left intersection.
C
          GO TO 10184
10185     CONTINUE
          IF (.NOT.((IWRK(IPE1+4).EQ.0.AND.IWRK(IPE1+5).EQ.0.AND.IWRK(IP
     +E2+4).EQ.1.AND.IWRK(IPE2+5).EQ.0).OR.(IWRK(IPE1+4).EQ.1.AND.IWRK(I
     +PE1+5).EQ.0.AND.IWRK(IPE2+4).EQ.0.AND.IWRK(IPE2+5).EQ.0))) GO TO 1
     +0196
C
C Process a left intersection.
C
            IF (.NOT.(IWRK(IPE2+9).EQ.0)) GO TO 10197
              IERR=4
              GO TO 10166
10197       CONTINUE
C
            IF (.NOT.(IG03.NE.0)) GO TO 10199
              IPSN=IG03
              IG03=IWRK(IG03)
            GO TO 10200
10199       CONTINUE
              IPWU=IPWU-3
              IF (.NOT.(IPWU.LE.IPWL)) GO TO 10201
                GO TO 10017
10201         CONTINUE
              IPSN=IPWU
10200       CONTINUE
C
            RWRK(IPSN  )=XINT
            RWRK(IPSN+1)=YINT
C
            IWRK(IPSN+2)=IWRK(IWRK(IPE2+9))
            IWRK(IWRK(IPE2+9))=IPSN
C
C Check for a right intersection.
C
          GO TO 10184
10196     CONTINUE
          IF (.NOT.((IWRK(IPE1+4).EQ.0.AND.IWRK(IPE1+5).EQ.1.AND.IWRK(IP
     +E2+4).EQ.1.AND.IWRK(IPE2+5).EQ.1).OR.(IWRK(IPE1+4).EQ.1.AND.IWRK(I
     +PE1+5).EQ.1.AND.IWRK(IPE2+4).EQ.0.AND.IWRK(IPE2+5).EQ.1))) GO TO 1
     +0203
C
C Process a right intersection.
C
            IF (.NOT.(IWRK(IPE1+9).EQ.0)) GO TO 10204
              IERR=5
              GO TO 10166
10204       CONTINUE
C
            IF (.NOT.(IG03.NE.0)) GO TO 10206
              IPSN=IG03
              IG03=IWRK(IG03)
            GO TO 10207
10206       CONTINUE
              IPWU=IPWU-3
              IF (.NOT.(IPWU.LE.IPWL)) GO TO 10208
                GO TO 10017
10208         CONTINUE
              IPSN=IPWU
10207       CONTINUE
C
            RWRK(IPSN  )=XINT
            RWRK(IPSN+1)=YINT
C
            IWRK(IPSN+2)=0
            IWRK(IWRK(IWRK(IPE1+9)+1)+2)=IPSN
            IWRK(IWRK(IPE1+9)+1)=IPSN
C
C Check for a local maximum.
C
          GO TO 10184
10203     CONTINUE
          IF (.NOT.((IWRK(IPE1+4).EQ.1.AND.IWRK(IPE1+5).EQ.0.AND.IWRK(IP
     +E2+4).EQ.0.AND.IWRK(IPE2+5).EQ.1).OR.(IWRK(IPE1+4).EQ.0.AND.IWRK(I
     +PE1+5).EQ.0.AND.IWRK(IPE2+4).EQ.1.AND.IWRK(IPE2+5).EQ.1))) GO TO 1
     +0210
C
C Process a local maximum.
C
            IF (.NOT.(IWRK(IPE1+9).EQ.0.OR.IWRK(IPE2+9).EQ.0)) GO TO 102
     +11
              IERR=6
              GO TO 10166
10211       CONTINUE
C
            IPP1=IWRK(IPE1+9)
            IPP2=IWRK(IPE2+9)
C
            IWRK(IPE1+9)=0
            IWRK(IPE2+9)=0
C
            IF (.NOT.(IG03.NE.0)) GO TO 10213
              IPSN=IG03
              IG03=IWRK(IG03)
            GO TO 10214
10213       CONTINUE
              IPWU=IPWU-3
              IF (.NOT.(IPWU.LE.IPWL)) GO TO 10215
                GO TO 10017
10215         CONTINUE
              IPSN=IPWU
10214       CONTINUE
C
            RWRK(IPSN  )=XINT
            RWRK(IPSN+1)=YINT
C
            IWRK(IPSN+2)=IWRK(IPP1)
            IWRK(IPP1)=IPSN
C
C See if the meeting edges are contributing to the same polygon.
C
            IF (.NOT.(IPP1.NE.IPP2)) GO TO 10217
C
C They aren't.  Append the subsidiary nodes of one polygon to the other.
C
              IWRK(IWRK(IPP2+1)+2)=IPSN
              IWRK(IPP2+1)=IWRK(IPP1+1)
C
C Remove from the polygon list the polygon whose subsidiary nodes have
C become part of the other polygon and put its principal node on the
C garbage list for 3-word nodes, so that it can be re-used.
C
              IF (.NOT.(IPPL.EQ.IPP1)) GO TO 10218
                IPPL=IWRK(IPP1+2)
              GO TO 10219
10218         CONTINUE
                ISPL=IPPL
10220           CONTINUE
                  IF (.NOT.(IWRK(ISPL+2).EQ.IPP1)) GO TO 10221
                    IWRK(ISPL+2)=IWRK(IPP1+2)
                    GO TO 10222
10221             CONTINUE
                  ISPL=IWRK(ISPL+2)
                GO TO 10220
10222           CONTINUE
10219         CONTINUE
C
              IWRK(IPP1)=IG03
              IG03=IPP1
C
C Any AET node that referenced IPP1 must now reference IPP2 instead.
C
              IDUM=IAET
C
10223         CONTINUE
              IF (.NOT.(IDUM.NE.0)) GO TO 10224
                IF (IWRK(IDUM+9).EQ.IPP1) IWRK(IDUM+9)=IPP2
                IDUM=IWRK(IDUM+6)
              GO TO 10223
10224         CONTINUE
C
10217       CONTINUE
C
10184     CONTINUE
10210     CONTINUE
C
C Swap the positions of edge 1 and edge 2 in the AET.
C
          IF (IWRK(IPE1+7).NE.0) IWRK(IWRK(IPE1+7)+6)=IPE2
          IF (IWRK(IPE2+6).NE.0) IWRK(IWRK(IPE2+6)+7)=IPE1
          IWRK(IPE1+6)=IWRK(IPE2+6)
          IWRK(IPE2+7)=IWRK(IPE1+7)
          IWRK(IPE1+7)=IPE2
          IWRK(IPE2+6)=IPE1
C
C If the AET started with edge 1, it now starts with edge 2.
C
          IF (IAET.EQ.IPE1) IAET=IPE2
C
C Exchange the polygon pointers of edges 1 and 2.
C
          IDUM=IWRK(IPE1+9)
          IWRK(IPE1+9)=IWRK(IPE2+9)
          IWRK(IPE2+9)=IDUM
C
C Advance to the next point of intersection in the list.
C
          IINT=IWRK(IINT+4)
C
C Quit if there are no more points of intersection to process.
C
          IF (IINT.EQ.0) GO TO 10225
C
C End of loop on points of intersection.
C
        GO TO 10161
10225   CONTINUE
C
C End of internal procedure to process a list of intersections.
C
      GO TO (10115,10146) , L10116
C
C The following internal procedure processes an edge in the AET that is
C terminating at the top of the current scanbeam.  The variable ITMP
C points to the edge that is to be processed.  If the edge is removed
C from the AET (which can happen), the procedure must adjust the value
C of ITMP so that the next-node pointer in the AET node that ITMP
C points at properly specifies the next AET node to be examined.
C
10118 CONTINUE
C
C Find the index, in the user's arrays, of the end point of the
C successor edge.
C
        INNP=ABS(IWRK(ITMP+8))+SIGN(1,IWRK(ITMP+8))
C
C Extract the X and Y coordinates of the end point of the successor
C edge.
C
        IF (.NOT.(IWRK(ITMP+4).EQ.0)) GO TO 10226
          IF (.NOT.(INNP.LT.1)) GO TO 10227
            INNP=INNP+LCCP
          GO TO 10228
10227     CONTINUE
          IF (.NOT.(INNP.GT.LCCP)) GO TO 10229
            INNP=INNP-LCCP
10228     CONTINUE
10229     CONTINUE
          XCNP=XCCP(INNP)
          YCNP=YCCP(INNP)
        GO TO 10230
10226   CONTINUE
          IF (.NOT.(INNP.LT.1)) GO TO 10231
            INNP=INNP+LCSP
          GO TO 10232
10231     CONTINUE
          IF (.NOT.(INNP.GT.LCSP)) GO TO 10233
            INNP=INNP-LCSP
10232     CONTINUE
10233     CONTINUE
          XCNP=XCSP(INNP)
          YCNP=YCSP(INNP)
10230   CONTINUE
C
C Check the vertical position of the end point of the successor edge.
C
        IF (.NOT.(YCNP.GE.YTOS)) GO TO 10234
C
C The end point of the successor edge is above the top of the scanbeam.
C
C Check whether the edge is contributing to a polygon.
C
          IF (.NOT.(IWRK(ITMP+9).NE.0)) GO TO 10235
C
C The edge is contributing to a polygon.  Form a subsidiary polygon
C node to add to that polygon.
C
            IF (.NOT.(IG03.NE.0)) GO TO 10236
              IPSN=IG03
              IG03=IWRK(IG03)
            GO TO 10237
10236       CONTINUE
              IPWU=IPWU-3
              IF (.NOT.(IPWU.LE.IPWL)) GO TO 10238
                GO TO 10017
10238         CONTINUE
              IPSN=IPWU
10237       CONTINUE
C
            RWRK(IPSN  )=RWRK(ITMP)
            RWRK(IPSN+1)=YTOS
C
C Add the end point of the current edge to either the left end or the
C right end of the polygon to which the edge is contributing, whichever
C is appropriate.
C
            IF (.NOT.(IWRK(ITMP+5).EQ.0)) GO TO 10240
              IWRK(IPSN+2)=IWRK(IWRK(ITMP+9))
              IWRK(IWRK(ITMP+9))=IPSN
            GO TO 10241
10240       CONTINUE
              IWRK(IPSN+2)=0
              IWRK(IWRK(IWRK(ITMP+9)+1)+2)=IPSN
              IWRK(IWRK(ITMP+9)+1)=IPSN
10241       CONTINUE
C
10235     CONTINUE
C
C Update the node to represent its successor edge.
C
          RWRK(ITMP+1)=XCNP
          RWRK(ITMP+2)=YCNP
C
          IF (.NOT.(YCNP.NE.YTOS)) GO TO 10242
            RWRK(ITMP+3)=(XCNP-RWRK(ITMP))/(YCNP-YTOS)
          GO TO 10243
10242     CONTINUE
            RWRK(ITMP+3)=SIGN(RBIG,XCNP-RWRK(ITMP))
10243     CONTINUE
C
          IWRK(ITMP+8)=SIGN(INNP,IWRK(ITMP+8))
C
        GO TO 10244
10234   CONTINUE
C
C The end point of the successor edge is below the top of the scanbeam.
C We have arrived at a local maximum, so handle that case.
C
          IF (.NOT.(IWRK(ITMP+6).EQ.0)) GO TO 10245
            IERR=7
            GO TO 10166
10245     CONTINUE
C
          IPP1=IWRK(ITMP+9)
          IPP2=IWRK(IWRK(ITMP+6)+9)
C
          IF (.NOT.(IPP1.NE.0.OR.IPP2.NE.0)) GO TO 10247
C
            IF (.NOT.(IPP1.EQ.0.OR.IPP2.EQ.0)) GO TO 10248
              IERR=8
              GO TO 10166
10248       CONTINUE
C
            IF (.NOT.(IG03.NE.0)) GO TO 10250
              IPSN=IG03
              IG03=IWRK(IG03)
            GO TO 10251
10250       CONTINUE
              IPWU=IPWU-3
              IF (.NOT.(IPWU.LE.IPWL)) GO TO 10252
                GO TO 10017
10252         CONTINUE
              IPSN=IPWU
10251       CONTINUE
C
            RWRK(IPSN  )=RWRK(ITMP)
            RWRK(IPSN+1)=YTOS
C
            IF (.NOT.(IWRK(ITMP+5).EQ.0)) GO TO 10254
              IWRK(IPSN+2)=IWRK(IPP1)
              IWRK(IPP1)=IPSN
            GO TO 10255
10254       CONTINUE
              IWRK(IPSN+2)=0
              IWRK(IWRK(IPP1+1)+2)=IPSN
              IWRK(IPP1+1)=IPSN
10255       CONTINUE
C
C See if the meeting edges are contributing to the same polygon.
C
            IF (.NOT.(IPP1.NE.IPP2)) GO TO 10256
C
C They aren't.  Append the subsidiary nodes of one polygon to the other.
C
              IF (.NOT.(IWRK(ITMP+5).EQ.0)) GO TO 10257
                IWRK(IWRK(IPP2+1)+2)=IWRK(IPP1)
                IWRK(IPP2+1)=IWRK(IPP1+1)
              GO TO 10258
10257         CONTINUE
                IWRK(IWRK(IPP1+1)+2)=IWRK(IPP2)
                IWRK(IPP2)=IWRK(IPP1)
10258         CONTINUE
C
C Remove from the polygon list the polygon whose subsidiary nodes have
C become part of the other polygon and put its principal node on the
C garbage list for 3-word nodes, so that it can be re-used.
C
              IF (.NOT.(IPPL.EQ.IPP1)) GO TO 10259
                IPPL=IWRK(IPP1+2)
              GO TO 10260
10259         CONTINUE
                ISPL=IPPL
10261           CONTINUE
                  IF (.NOT.(IWRK(ISPL+2).EQ.IPP1)) GO TO 10262
                    IWRK(ISPL+2)=IWRK(IPP1+2)
                    GO TO 10263
10262             CONTINUE
                  ISPL=IWRK(ISPL+2)
                GO TO 10261
10263           CONTINUE
10260         CONTINUE
C
              IWRK(IPP1)=IG03
              IG03=IPP1
C
C Any AET node that referenced IPP1 must now reference IPP2 instead.
C
              IDUM=IAET
C
10264         CONTINUE
              IF (.NOT.(IDUM.NE.0)) GO TO 10265
                IF (IWRK(IDUM+9).EQ.IPP1) IWRK(IDUM+9)=IPP2
                IDUM=IWRK(IDUM+6)
              GO TO 10264
10265         CONTINUE
C
10256       CONTINUE
C
10247     CONTINUE
C
C Delete from the AET the edge ITMP and the edge that follows it.  The
C nodes go back on the garbage list for 10-word nodes.
C
          ITM1=IWRK(ITMP+7)
          ITM2=IWRK(IWRK(ITMP+6)+6)
C
          IF (.NOT.(ITM1.EQ.0)) GO TO 10266
            IAET=ITM2
          GO TO 10267
10266     CONTINUE
            IWRK(ITM1+6)=ITM2
10267     CONTINUE
C
          IF (ITM2.NE.0) IWRK(ITM2+7)=ITM1
C
          IWRK(ITMP)=IWRK(ITMP+6)
          IWRK(IWRK(ITMP))=IG10
          IG10=ITMP
C
C Adjust the pointer into the AET so as to continue looping properly.
C
          ITMP=IWRK(ITMP+6)
C
10244   CONTINUE
C
      GO TO (10117,10150) , L10118
C
C Error exits.
C
10003 CONTINUE
        IERR=1
        RETURN
C
10006 CONTINUE
        IERR=2
        RETURN
C
10017 CONTINUE
        IERR=3
        RETURN
C
10166 CONTINUE
        IERR=3+IERR
        RETURN
C
      END

C
C	$Id: tgbyte.f,v 1.4 2008-07-27 00:59:03 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
       SUBROUTINE TGBYTE(MASK0,MSK0DM,MASK1,MSK1DM,ISCR,ISCRDM,
     +                   WRDLNG,INTLNG,IERAND,IERSHF,IOUT,IER)
       INTEGER WRDLNG
       DIMENSION MASK0(MSK0DM),MASK1(MSK1DM),ISCR(ISCRDM)
C
C Determine whether test can be executed.
C
       IER=-1
       WRITE(IOUT,6)
       IF(WRDLNG.LT.4) THEN
          WRITE(IOUT,7)
          RETURN
       END IF
       IF(IERSHF.NE.0 .OR. IERAND.NE.0) THEN
           WRITE(IOUT,8)
           RETURN
       END IF
C
C Start of test proper.
C
       IER=1
C
C Test one : get the I-th bit from MASK0(I) where I ranges
C            from 1 to WRDLNG.
C
       NBITS = 1
       ITER = 1
       NSKIP = 0
       DO 1 I =1,WRDLNG
          IBIT = WRDLNG - I
          CALL GBYTES(MASK0(I),ITEST,IBIT,NBITS,NSKIP,ITER)
          IF ( ITEST.NE.1) THEN
             WRITE(IOUT,101) I
             RETURN
          END IF
 1     CONTINUE
C
C Test two : get the last INTLNG bits in each of the 1st INTLNG words
C            of MASK0.
C
       IBIT = WRDLNG - INTLNG
       NBITS = INTLNG
       NSKIP = IBIT
       ITER = INTLNG
       CALL GBYTES(MASK0,ISCR,IBIT,NBITS,NSKIP,ITER)
       DO 2 I =1,INTLNG
          IF (ISCR(I).NE.MASK0(I)) THEN
             WRITE(IOUT,102) I
             RETURN
             END  IF
 2     CONTINUE
C
C Test three : Get the 1st two bits from ISCR(I) and the last two bits
C              from ISCR(I+1). Test of retrieval of bits crossing word
C              boundary.
C
       DO 3 I =1,ISCRDM
 3     ISCR(I) = 0
       DO 4 I = 1,16
          ISCR(2*I-1) = ISHIFT(I-1,-2)
          ISCR(2*I) = ISHIFT(IAND(I-1,MASK1(3)),WRDLNG-2)
 4     CONTINUE
       IBIT = WRDLNG-2
       NBITS = 4
       NSKIP = 2*WRDLNG-4
       ITER = 16
       CALL GBYTES(ISCR,ISCR(33),IBIT,NBITS,NSKIP,ITER)
       DO 5 I = 1,16
          IF(ISCR(I+32).NE.I-1) THEN
             WRITE(IOUT,103)
             RETURN
          END IF
 5     CONTINUE
       IER = 0
       WRITE(IOUT,104)
       RETURN
C
 6     FORMAT('1NOW TESTING GBYTES.')
 7     FORMAT('0ERROR IN TEST PACKAGE DETECTED IN TGBYTE. THE WORD ',
     1        'LENGTH MUST BE AT',/,
     2        ' LEAST 4.')
 8     FORMAT('0THE ROUTINES IAND AND ISHIFT, WHICH ARE REQUIRED TO ',
     1        'TEST GBYTES HAVE NOT BEEN',/,
     2        ' VERIFIED. BECAUSE OF THIS, GBYTES CAN NOT BE TESTED.')
 101   FORMAT('0GBYTES DID NOT SUCCESSFULLY GET THE ITH BIT OF ',
     1        'MASK0(I) WHEN I WAS EQUAL TO ',I16,'.')
 102   FORMAT('0GBYTES DID NOT SUCCESSFULLY GET THE LAST INTLNG ',
     1        'BITS IN THE ITH WORD',/,
     2        ' OF MASK0 WHEN I WAS EQUAL TO ',I16,'.')
 103   FORMAT('0GBYTES DID NOT SUCCESSFULLY GET A BIT CHUNK ',
     1        'OF LENGTH 4 WHICH',/,
     2        ' CROSSED A WORD BOUNDARY.')
 104   FORMAT('0FINISHED TESTING GBYTES.  GBYTES APPARENTLY WORKS.')
       END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C   FFTPACK 5.0
C   Copyright (C) 1995-2004, Scientific Computing Division,
C   University Corporation for Atmospheric Research
C   Licensed under the GNU General Public License (GPL)
C
C   Authors:  Paul N. Swarztrauber and Richard A. Valent
C
C   $Id: rfft2f.f,v 1.2 2006-11-21 01:10:19 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      SUBROUTINE DRFFT2F(LDIM,L,M,R,WSAVE,LENSAV,WORK,LENWRK,IER)
      INTEGER LDIM,L,M,LENSAV,LENWRK,IER
      DOUBLE PRECISION R(LDIM,M),WSAVE(LENSAV),WORK(LENWRK)
C
C
C Initialize IER
C
      IER = 0
C
C Verify LENSAV
C
      LWSAV = L + INT(LOG(DBLE(L))) + 4
      MWSAV = 2*M + INT(LOG(DBLE(M))) + 4
      IF (LENSAV.LT.LWSAV+MWSAV) THEN
          IER = 2
          CALL DXERFFT('RFFT2F',6)
          GO TO 100
      END IF
C
C Verify LENWRK
C
      IF (LENWRK.LT.2* (L/2+1)*M) THEN
          IER = 3
          CALL DXERFFT('RFFT2F',8)
          GO TO 100
      END IF
C
C Verify LDIM is as big as L
C
      IF (LDIM.LT.2* (L/2+1)) THEN
          IER = 5
          CALL DXERFFT('RFFT2F',-6)
          GO TO 100
      END IF
C
C Transform first dimension of array
C
      CALL DRFFTMF(M,LDIM,L,1,R,M*LDIM,WSAVE(1),L+INT(LOG(DBLE(L)))+4,
     +            WORK,2* (L/2+1)*M,IER1)
      IF (IER1.NE.0) THEN
          IER = 20
          CALL DXERFFT('RFFT2F',-5)
          GO TO 100
      END IF
C
C reshuffle to add in nyquist imaginary components
C
      DO J = 1,M
          IF (MOD(L,2).EQ.0) R(L+2,J) = 0.0D0
          DO I = L,2,-1
              R(I+1,J) = R(I,J)
          END DO
          R(2,J) = 0.0D0
      END DO
C
C transform second dimension of array
C
      CALL DCFFTMF(L/2+1,1,M,LDIM/2,R,M*LDIM/2,
     +            WSAVE(L+INT(LOG(DBLE(L)))+5),2*M+INT(LOG(DBLE(M)))+4,
     +            WORK,2* (L/2+1)*M,IER1)
      IF (IER1.NE.0) THEN
          IER = 20
          CALL DXERFFT('RFFT2F',-5)
          GO TO 100
      END IF
C
  100 CONTINUE
C
      RETURN
      END

      PROGRAM PGKEX05
C
C  Illustrate clipping.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER (ILD=121)
      DIMENSION PLX(ILD),PLY(ILD)
      DIMENSION XC(2),YC(2),CX(2,2),CY(2,2),AX(5),AY(5)
      DATA  RADC/.0174532/
C
C  Center positions for spirals.
C
      DATA XC / .31007, .67052 /
      DATA YC / .62000, .20000 /
C
C  Clipping rectangles.
C
      DATA CX / .20, .77, .20, .77 /
      DATA CY / .50, .76, .08, .34 /
C
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C  Define indices, color index 0 defines the background color.
C
      CALL GSCR(IWKID,0, 1.0, 1.0, 1.0)
      CALL GSCR(IWKID,1, 0.0, 0.0, 0.0)
      CALL GSCR(IWKID,2, 0.4, 0.0, 0.4)
      CALL GSCR(IWKID,3, 0.0, 0.0, 1.0)
C
C  Set the line width to 2 times the nominal width.  This setting
C  may not be honored by all hardware devices.
C
      CALL GSLWSC(2.0)
      DO 30 K=1,2
C
C  Define the clipping rectangle.
C
        CALL GSWN(1,CX(1,K),CX(2,K),CY(1,K),CY(2,K))
        CALL GSVP(1,CX(1,K),CX(2,K),CY(1,K),CY(2,K))
        CALL GSELNT(1)
C
C  Clipping is on for the second curve only.
C
        CALL GSCLIP(K-1)
C
C  Draw a boundary around the clipping rectangle.
C
        AX(1) = CX(1,K)
        AY(1) = CY(1,K)
        AX(2) = CX(2,K)
        AY(2) = AY(1)
        AX(3) = AX(2)
        AY(3) = CY(2,K)
        AX(4) = AX(1)
        AY(4) = AY(3)
        AX(5) = AX(1)
        AY(5) = AY(1)
        CALL GSPLCI(1)
        CALL GPL(5,AX,AY)
C
C  Draw the spirals.
C
        CALL GSPLCI(3)
        J = 0
        DO 10 I=0,720,6
          SCALE = REAL(I)/4000.
          J = J+1
          PLX(J) = XC(1)+SCALE*COS(REAL(I-1)*RADC)
          PLY(J) = YC(K)+SCALE*SIN(REAL(I-1)*RADC)
   10   CONTINUE
C
        CALL GPL(121,PLX,PLY)
C
        J = 0
        DO 20 I=2,722,6
          SCALE = REAL(I)/4000.
          J = J+1
          PLX(J) = XC(2)-SCALE*COS(REAL(I-1)*RADC)
          PLY(J) = YC(K)-SCALE*SIN(REAL(I-1)*RADC)
   20   CONTINUE
C
        CALL GPL(121,PLX,PLY)
   30 CONTINUE
C
C  Turn clipping back off.
C
      CALL GSCLIP(0)
C
C  Label the plot using Plotchar.
C
      CALL PCSETI('FN',25)
      CALL PCSETI('CC',2)
      CALL PLCHHQ(.5,.9,'Clipping',.035,0.,0.)
      CALL PCSETI('FN',21)
      CALL PCSETI('CC',2)
      CALL PLCHHQ(.2,.80,'Clipping off',.022,0.,-1.)
      CALL PLCHHQ(.2,.38,'Clipping on' ,.022,0.,-1.)
      CALL FRAME
C
C  Deactivate and close the workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END

C NCLFORTSTART
      SUBROUTINE DWGTVOLAVE(T,WGTZ,WGTY,WGTX,MX,NY,KZ,TMSG,IFLAG,AVE)
      IMPLICIT NONE
      INTEGER MX,NY,KZ,IFLAG
      DOUBLE PRECISION T(MX,NY,KZ)
      DOUBLE PRECISION WGTX(MX),WGTY(NY),WGTZ(KZ)
      DOUBLE PRECISION TMSG
      DOUBLE PRECISION AVE
C NCLEND

C NCL: volT = wgtVolAve (T,wgtz,wgty,wgtx,flag)
C compute the weighted volume average
c .   This could have been programmed more efficiently.

      INTEGER NL,ML,KL,KMSG
      DOUBLE PRECISION SUMT,SUMW,WGTXY,SUMTZ,SUMWZ,TAVEZ

C Nomenclature:
C INPUT:
C t      - 3D array
C wgtz   - 1D array of length "kz"
C wgty   - 1D array of length "ny"
C wgtx   - 1D array of length "mx"
C mx     - 1st [fastest varying] dimension of "t" [eg, longitude]
C ny     - 2nd [slower  varying] dimension of "t" [eg, latitude ]
C kz     - 3rd [slowest varying] dimension of "t" [eg, level ]
c tmsg   - msg value
C iflag  - flag
C          =0 compute  average ignoring msg values
C          =1 if any msg data is encountered return as msg

C OUTPUT:
C ave    - volume average [returned]

c Note: I could do this in one loop but I did it this way for
c .     consistency with some other subroutines.

      SUMT = 0.0D0
      SUMW = 0.0D0
      KMSG = 0
      AVE = TMSG

      DO NL = 1,NY
          DO ML = 1,MX
              SUMTZ = 0.0D0
              SUMWZ = 0.0D0

              DO KL = 1,KZ
                  IF (T(ML,NL,KL).NE.TMSG) THEN
                      SUMTZ = SUMTZ + T(ML,NL,KL)*WGTZ(KL)
                      SUMWZ = SUMWZ + WGTZ(KL)
                  ELSE
                      KMSG = KMSG + 1
                  END IF
              END DO
c                                      return if user desired
              IF (IFLAG.EQ.1 .AND. KMSG.NE.0) RETURN
c                                      wgt vertical average
c                                      by areal wgts x/lon and y/lat
              IF (SUMWZ.GT.0.0D0) THEN
                  TAVEZ = SUMTZ/SUMWZ
                  WGTXY = WGTX(ML)*WGTY(NL)
                  SUMT = SUMT + WGTXY*TAVEZ
                  SUMW = SUMW + WGTXY
              END IF

          END DO
      END DO
c                          compute wgted average
      IF (SUMW.GT.0.0D0) THEN
          AVE = SUMT/SUMW
      END IF

      RETURN
      END

C NCLFORTSTART
      SUBROUTINE DWGTVOLAVECCM(T,WGTZ,WGTY,WGTX,MX,NY,KZ,TMSG,IFLAG,AVE)
      IMPLICIT NONE
      INTEGER MX,NY,KZ,IFLAG
      DOUBLE PRECISION T(MX,NY,KZ)
      DOUBLE PRECISION WGTX(MX),WGTY(NY),WGTZ(MX,NY,KZ)
      DOUBLE PRECISION TMSG
      DOUBLE PRECISION AVE
C NCLEND

C NCL: volT = wgtVolAveCcm (T,wgtz,wgty,wgtx,flag)
C compute the weighted volume average
c .   This could have been programmed more efficiently.

      INTEGER NL,ML,KL,KMSG
      DOUBLE PRECISION SUMT,SUMW,WGTXY,SUMTZ,SUMWZ,TAVEZ

C Nomenclature:
C INPUT:
C t      - 3D array
C wgtz   - 3D array [same size as "t"]
c .        This is really designed for "delta p"
C wgty   - 1D array of length "ny"
C wgtx   - 1D array of length "mx"
C mx     - 1st [fastest varying] dimension of "t" [eg, longitude]
C ny     - 2nd [slower  varying] dimension of "t" [eg, latitude ]
C kz     - 3rd [slowest varying] dimension of "t" [eg, level ]
c tmsg   - msg value
C iflag  - flag
C          =0 compute  average ignoring msg values
C          =1 if any msg data is encountered return as msg

C OUTPUT:
C ave    - volume average [returned]

      SUMT = 0.0D0
      SUMW = 0.0D0
      KMSG = 0
      AVE = TMSG

      DO NL = 1,NY
          DO ML = 1,MX
              SUMTZ = 0.0D0
              SUMWZ = 0.0D0

              DO KL = 1,KZ
                  IF (T(ML,NL,KL).NE.TMSG) THEN
                      SUMTZ = SUMTZ + T(ML,NL,KL)*WGTZ(ML,NL,KL)
                      SUMWZ = SUMWZ + WGTZ(ML,NL,KL)
                  ELSE
                      KMSG = KMSG + 1
                  END IF
              END DO
c                                      return if user desired
              IF (IFLAG.EQ.1 .AND. KMSG.NE.0) RETURN
c                                      wgt vertical average
c                                      by areal wgts x/lon and y/lat
              IF (SUMWZ.GT.0.0D0) THEN
                  TAVEZ = SUMTZ/SUMWZ
                  WGTXY = WGTX(ML)*WGTY(NL)
                  SUMT = SUMT + WGTXY*TAVEZ
                  SUMW = SUMW + WGTXY
              END IF

          END DO
      END DO
c                          compute wgted average
      IF (SUMW.GT.0.0D0) THEN
          AVE = SUMT/SUMW
      END IF

      RETURN
      END

C
C $Id: pakssp.f,v 1.5 2008-07-27 00:17:10 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      REAL FUNCTION PAKSSP (ANG)
C
C FUNCTION TO CONVERT DMS PACKED ANGLE INTO SECONDS OF ARC.
C
      IMPLICIT REAL (A-Z)
      INTEGER I
      DIMENSION CODE(2)
      COMMON /ERRMZ0/ IERR
        INTEGER IERR
      SAVE   /ERRMZ0/
      COMMON /PRINZ0/ IPEMSG,IPELUN,IPPARM,IPPLUN
        INTEGER IPEMSG,IPELUN,IPPARM,IPPLUN
      SAVE   /PRINZ0/
      DATA CODE /1000000.0E0,1000.0E0/
      DATA ZERO,ONE /0.0E0,1.0E0/
      DATA C1,C2 /3600.0E0,60.0E0/
      DATA TOL /1.0E-4/
C
C SEPARATE DEGREE FIELD.
C
      FACTOR = ONE
      IF (ANG .LT. ZERO) FACTOR = - ONE
      SEC = ABS(ANG)
      TMP = CODE(1)
      I = INT ((SEC / TMP) + TOL)
      IF (I .GT. 360) GO TO 020
      DEG = I
C
C SEPARATE MINUTES FIELD.
C
      SEC = SEC - DEG * TMP
      TMP = CODE(2)
      I = INT ((SEC / TMP) + TOL)
      IF (I .GT. 60) GO TO 020
      MIN = I
C
C SEPARATE SECONDS FIELD.
C
      SEC = SEC - MIN * TMP
      IF (SEC .GT. C2) GO TO 020
      SEC = FACTOR * (DEG * C1 + MIN * C2 + SEC)
      GO TO 040
C
C ERROR DETECTED IN DMS FORM.
C
  020 WRITE (IPELUN,2000) ANG
 2000 FORMAT (/' ERROR PAKSSP'/
     .         ' ILLEGAL DMS FIELD =',F15.3)
      STOP 16
C
  040 PAKSSP = SEC
C
      RETURN
      END

      SUBROUTINE DSYEV( JOBZ, UPLO, N, A, LDA, W, WORK, LWORK, INFO )
*
*  -- LAPACK driver routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          JOBZ, UPLO
      INTEGER            INFO, LDA, LWORK, N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), W( * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  DSYEV computes all eigenvalues and, optionally, eigenvectors of a
*  real symmetric matrix A.
*
*  Arguments
*  =========
*
*  JOBZ    (input) CHARACTER*1
*          = 'N':  Compute eigenvalues only;
*          = 'V':  Compute eigenvalues and eigenvectors.
*
*  UPLO    (input) CHARACTER*1
*          = 'U':  Upper triangle of A is stored;
*          = 'L':  Lower triangle of A is stored.
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  A       (input/output) DOUBLE PRECISION array, dimension (LDA, N)
*          On entry, the symmetric matrix A.  If UPLO = 'U', the
*          leading N-by-N upper triangular part of A contains the
*          upper triangular part of the matrix A.  If UPLO = 'L',
*          the leading N-by-N lower triangular part of A contains
*          the lower triangular part of the matrix A.
*          On exit, if JOBZ = 'V', then if INFO = 0, A contains the
*          orthonormal eigenvectors of the matrix A.
*          If JOBZ = 'N', then on exit the lower triangle (if UPLO='L')
*          or the upper triangle (if UPLO='U') of A, including the
*          diagonal, is destroyed.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(1,N).
*
*  W       (output) DOUBLE PRECISION array, dimension (N)
*          If INFO = 0, the eigenvalues in ascending order.
*
*  WORK    (workspace/output) DOUBLE PRECISION array, dimension (LWORK)
*          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*
*  LWORK   (input) INTEGER
*          The length of the array WORK.  LWORK >= max(1,3*N-1).
*          For optimal efficiency, LWORK >= (NB+2)*N,
*          where NB is the blocksize for DSYTRD returned by ILAENV.
*
*          If LWORK = -1, then a workspace query is assumed; the routine
*          only calculates the optimal size of the WORK array, returns
*          this value as the first entry of the WORK array, and no error
*          message related to LWORK is issued by XERBLA.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*          > 0:  if INFO = i, the algorithm failed to converge; i
*                off-diagonal elements of an intermediate tridiagonal
*                form did not converge to zero.
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO, ONE
      PARAMETER          ( ZERO = 0.0D0, ONE = 1.0D0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            LOWER, LQUERY, WANTZ
      INTEGER            IINFO, IMAX, INDE, INDTAU, INDWRK, ISCALE,
     $                   LLWORK, LOPT, LWKOPT, NB
      DOUBLE PRECISION   ANRM, BIGNUM, EPS, RMAX, RMIN, SAFMIN, SIGMA,
     $                   SMLNUM
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            ILAENV
      DOUBLE PRECISION   DLAMCH, DLANSY
      EXTERNAL           LSAME, ILAENV, DLAMCH, DLANSY
*     ..
*     .. External Subroutines ..
      EXTERNAL           DLASCL, DORGTR, DSCAL, DSTEQR, DSTERF, DSYTRD,
     $                   XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, SQRT
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      WANTZ = LSAME( JOBZ, 'V' )
      LOWER = LSAME( UPLO, 'L' )
      LQUERY = ( LWORK.EQ.-1 )
*
      INFO = 0
      IF( .NOT.( WANTZ .OR. LSAME( JOBZ, 'N' ) ) ) THEN
         INFO = -1
      ELSE IF( .NOT.( LOWER .OR. LSAME( UPLO, 'U' ) ) ) THEN
         INFO = -2
      ELSE IF( N.LT.0 ) THEN
         INFO = -3
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -5
      ELSE IF( LWORK.LT.MAX( 1, 3*N-1 ) .AND. .NOT.LQUERY ) THEN
         INFO = -8
      END IF
*
      IF( INFO.EQ.0 ) THEN
         NB = ILAENV( 1, 'DSYTRD', UPLO, N, -1, -1, -1 )
         LWKOPT = MAX( 1, ( NB+2 )*N )
         WORK( 1 ) = LWKOPT
      END IF
*
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DSYEV ', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 ) THEN
         WORK( 1 ) = 1
         RETURN
      END IF
*
      IF( N.EQ.1 ) THEN
         W( 1 ) = A( 1, 1 )
         WORK( 1 ) = 3
         IF( WANTZ )
     $      A( 1, 1 ) = ONE
         RETURN
      END IF
*
*     Get machine constants.
*
      SAFMIN = DLAMCH( 'Safe minimum' )
      EPS = DLAMCH( 'Precision' )
      SMLNUM = SAFMIN / EPS
      BIGNUM = ONE / SMLNUM
      RMIN = SQRT( SMLNUM )
      RMAX = SQRT( BIGNUM )
*
*     Scale matrix to allowable range, if necessary.
*
      ANRM = DLANSY( 'M', UPLO, N, A, LDA, WORK )
      ISCALE = 0
      IF( ANRM.GT.ZERO .AND. ANRM.LT.RMIN ) THEN
         ISCALE = 1
         SIGMA = RMIN / ANRM
      ELSE IF( ANRM.GT.RMAX ) THEN
         ISCALE = 1
         SIGMA = RMAX / ANRM
      END IF
      IF( ISCALE.EQ.1 )
     $   CALL DLASCL( UPLO, 0, 0, ONE, SIGMA, N, N, A, LDA, INFO )
*
*     Call DSYTRD to reduce symmetric matrix to tridiagonal form.
*
      INDE = 1
      INDTAU = INDE + N
      INDWRK = INDTAU + N
      LLWORK = LWORK - INDWRK + 1
      CALL DSYTRD( UPLO, N, A, LDA, W, WORK( INDE ), WORK( INDTAU ),
     $             WORK( INDWRK ), LLWORK, IINFO )
      LOPT = 2*N + WORK( INDWRK )
*
*     For eigenvalues only, call DSTERF.  For eigenvectors, first call
*     DORGTR to generate the orthogonal matrix, then call DSTEQR.
*
      IF( .NOT.WANTZ ) THEN
         CALL DSTERF( N, W, WORK( INDE ), INFO )
      ELSE
         CALL DORGTR( UPLO, N, A, LDA, WORK( INDTAU ), WORK( INDWRK ),
     $                LLWORK, IINFO )
         CALL DSTEQR( JOBZ, N, W, WORK( INDE ), A, LDA, WORK( INDTAU ),
     $                INFO )
      END IF
*
*     If matrix was scaled, then rescale eigenvalues appropriately.
*
      IF( ISCALE.EQ.1 ) THEN
         IF( INFO.EQ.0 ) THEN
            IMAX = N
         ELSE
            IMAX = INFO - 1
         END IF
         CALL DSCAL( IMAX, ONE / SIGMA, W, 1 )
      END IF
*
*     Set WORK(1) to optimal workspace size.
*
      WORK( 1 ) = LWKOPT
*
      RETURN
*
*     End of DSYEV
*
      END

      PROGRAM COEX03
C
C Create color wheels in HSV space.  Each wheel is produced with
C a different value of V (the value parameter in HSV space).  Each
C wheel is composed of 16 wedges.  The value for the hue remains
C the same within each wedge, and the value for the saturation
C varies linearly from the center to the outer rim within each wedge.
C The hues vary from 0. to 360. around the color wheel starting
C at pure red, and returning to pure red.
C
C This program requires PLOTCHAR for drawing its characters.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C  Define the number of values, the number of hues, the number
C  of saturations, and the number of points bounding a color box.
C
      PARAMETER(NW=3, NCOL=16, NSAT=4, NPTS = 4)
      DIMENSION X(NPTS),Y(NPTS)
      DIMENSION IASF(13)
      DIMENSION VAL(NW),ST(NSAT)
      CHARACTER*80 TITLE
C
      DATA IASF / 13*1 /
      DATA PI   /  3.14159265/
C
C  Define the values to be used.
C
      DATA VAL  / 0.60, 0.80, 1.00 /
C
C  Y-coordinates for the saturation labels.
C
      DATA ST(1),ST(2),ST(3),ST(4)/-.1, -.375, -.625, -.850/
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
      CALL GSCLIP(0)
      CALL GSASF(IASF)
      CALL GSFAIS(1)
C
C  Background and foreground colors.
C
      CALL GSCR(IWKID,0,0.0,0.0,0.0)
      CALL GSCR(IWKID,1,1.0,1.0,1.0)
C
C  Loop on the values.
C
      DO 30 IL = 1,NW
        INDEX = 2
        CALL SET(.1,.9,.1,.9,-1.2,1.2,-1.2,1.2,1)
        RINC = 2 * PI / REAL(NCOL)
        HINC = 360.0  / REAL(NCOL)
        SINC =  1.00  / REAL(NSAT - 1)
C
C  Loop on the hues.
C
        DO 20 IHUE = 0,NCOL - 1
          HUE    =  REAL(IHUE)      * HINC
          THETA1 = (REAL(IHUE) -.5) * RINC
          THETA2 = (REAL(IHUE) +.5) * RINC
          X(1) = 0.0
          X(4) = 0.0
          Y(1) = 0.0
          Y(4) = 0.0
C
C  Loop on the saturations
C
          DO 10 ISAT = 1,NSAT
            SAT = (REAL(ISAT - 1) * SINC)
            CALL HSVRGB(HUE,SAT,VAL(IL),R,G,B)
            CALL GSCR(IWKID,INDEX,R,G,B)
            CALL GSFACI(INDEX)
            RLEN = REAL(ISAT) / REAL(NSAT)
            X(2) = COS(THETA1) * RLEN
            Y(2) = SIN(THETA1) * RLEN
            X(3) = COS(THETA2) * RLEN
            Y(3) = SIN(THETA2) * RLEN
            CALL GFA(4,X,Y)
            X(1) = X(2)
            X(4) = X(3)
            Y(1) = Y(2)
            Y(4) = Y(3)
            INDEX = INDEX+1
 10       CONTINUE
 20     CONTINUE
C
C  Label the plots.
C
        CALL PCSETI('QU  - QUALITY FLAG',0)
        CALL PCSETI('CD  - SELECT DUPLEX DATA SET',1)
        WRITE(TITLE,700) VAL(IL)
        CALL GSPLCI(1)
        CALL PLCHHQ(0.0,1.25,TITLE(1:12),21.0,0.0,0.0)
        DO 40 L=2,NSAT
          SAT = (REAL(L-1)*SINC)
          WRITE(TITLE,710) SAT
          CALL PLCHHQ(0.0,ST(L),TITLE(1:6),15.0,0.0,0.0)
   40   CONTINUE
        CALL PLOTIF(0.,0.,2)
        CALL GSPLCI(1)
        CALL LINE(.98,0.,1.03,0.)
        CALL PLCHHQ(1.08,0.,'Hue=0.',15.0,0.0,-1.0)
        CALL LINE( .700,.700, .750,.740)
        CALL PLCHHQ( .80,.740,'Hue=45.',15.0,0.0,-1.0)
        CALL LINE(-.700,.700,-.750,.740)
        CALL PLCHHQ(-.80,.740,'Hue=135.',15.0,0.0,1.0)
        CALL LINE(-.700,-.700,-.750,-.740)
        CALL PLCHHQ(-.80,-.740,'Hue=225.',15.0,0.0,1.0)
        CALL LINE( .700,-.700, .750,-.740)
        CALL PLCHHQ( .80,-.740,'Hue=315.',15.0,0.0,-1.0)
        CALL FRAME
 30   CONTINUE
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
 700  FORMAT('VALUE = ',F4.2)
 710  FORMAT('S=',F4.2)
C
      END

      SUBROUTINE CHETRF( UPLO, N, A, LDA, IPIV, WORK, LWORK, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          UPLO
      INTEGER            INFO, LDA, LWORK, N
*     ..
*     .. Array Arguments ..
      INTEGER            IPIV( * )
      COMPLEX            A( LDA, * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  CHETRF computes the factorization of a complex Hermitian matrix A
*  using the Bunch-Kaufman diagonal pivoting method.  The form of the
*  factorization is
*
*     A = U*D*U**H  or  A = L*D*L**H
*
*  where U (or L) is a product of permutation and unit upper (lower)
*  triangular matrices, and D is Hermitian and block diagonal with 
*  1-by-1 and 2-by-2 diagonal blocks.
*
*  This is the blocked version of the algorithm, calling Level 3 BLAS.
*
*  Arguments
*  =========
*
*  UPLO    (input) CHARACTER*1
*          = 'U':  Upper triangle of A is stored;
*          = 'L':  Lower triangle of A is stored.
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  A       (input/output) COMPLEX array, dimension (LDA,N)
*          On entry, the Hermitian matrix A.  If UPLO = 'U', the leading
*          N-by-N upper triangular part of A contains the upper
*          triangular part of the matrix A, and the strictly lower
*          triangular part of A is not referenced.  If UPLO = 'L', the
*          leading N-by-N lower triangular part of A contains the lower
*          triangular part of the matrix A, and the strictly upper
*          triangular part of A is not referenced.
*
*          On exit, the block diagonal matrix D and the multipliers used
*          to obtain the factor U or L (see below for further details).
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(1,N).
*
*  IPIV    (output) INTEGER array, dimension (N)
*          Details of the interchanges and the block structure of D.
*          If IPIV(k) > 0, then rows and columns k and IPIV(k) were
*          interchanged and D(k,k) is a 1-by-1 diagonal block.
*          If UPLO = 'U' and IPIV(k) = IPIV(k-1) < 0, then rows and
*          columns k-1 and -IPIV(k) were interchanged and D(k-1:k,k-1:k)
*          is a 2-by-2 diagonal block.  If UPLO = 'L' and IPIV(k) =
*          IPIV(k+1) < 0, then rows and columns k+1 and -IPIV(k) were
*          interchanged and D(k:k+1,k:k+1) is a 2-by-2 diagonal block.
*
*  WORK    (workspace/output) COMPLEX array, dimension (LWORK)
*          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*
*  LWORK   (input) INTEGER
*          The length of WORK.  LWORK >=1.  For best performance
*          LWORK >= N*NB, where NB is the block size returned by ILAENV.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*          > 0:  if INFO = i, D(i,i) is exactly zero.  The factorization
*                has been completed, but the block diagonal matrix D is
*                exactly singular, and division by zero will occur if it
*                is used to solve a system of equations.
*
*  Further Details
*  ===============
*
*  If UPLO = 'U', then A = U*D*U', where
*     U = P(n)*U(n)* ... *P(k)U(k)* ...,
*  i.e., U is a product of terms P(k)*U(k), where k decreases from n to
*  1 in steps of 1 or 2, and D is a block diagonal matrix with 1-by-1
*  and 2-by-2 diagonal blocks D(k).  P(k) is a permutation matrix as
*  defined by IPIV(k), and U(k) is a unit upper triangular matrix, such
*  that if the diagonal block D(k) is of order s (s = 1 or 2), then
*
*             (   I    v    0   )   k-s
*     U(k) =  (   0    I    0   )   s
*             (   0    0    I   )   n-k
*                k-s   s   n-k
*
*  If s = 1, D(k) overwrites A(k,k), and v overwrites A(1:k-1,k).
*  If s = 2, the upper triangle of D(k) overwrites A(k-1,k-1), A(k-1,k),
*  and A(k,k), and v overwrites A(1:k-2,k-1:k).
*
*  If UPLO = 'L', then A = L*D*L', where
*     L = P(1)*L(1)* ... *P(k)*L(k)* ...,
*  i.e., L is a product of terms P(k)*L(k), where k increases from 1 to
*  n in steps of 1 or 2, and D is a block diagonal matrix with 1-by-1
*  and 2-by-2 diagonal blocks D(k).  P(k) is a permutation matrix as
*  defined by IPIV(k), and L(k) is a unit lower triangular matrix, such
*  that if the diagonal block D(k) is of order s (s = 1 or 2), then
*
*             (   I    0     0   )  k-1
*     L(k) =  (   0    I     0   )  s
*             (   0    v     I   )  n-k-s+1
*                k-1   s  n-k-s+1
*
*  If s = 1, D(k) overwrites A(k,k), and v overwrites A(k+1:n,k).
*  If s = 2, the lower triangle of D(k) overwrites A(k,k), A(k+1,k),
*  and A(k+1,k+1), and v overwrites A(k+2:n,k:k+1).
*
*  =====================================================================
*
*     .. Local Scalars ..
      LOGICAL            LQUERY, UPPER
      INTEGER            IINFO, IWS, J, K, KB, LDWORK, LWKOPT, NB, NBMIN
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            ILAENV
      EXTERNAL           LSAME, ILAENV
*     ..
*     .. External Subroutines ..
      EXTERNAL           CHETF2, CLAHEF, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      UPPER = LSAME( UPLO, 'U' )
      LQUERY = ( LWORK.EQ.-1 )
      IF( .NOT.UPPER .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -4
      ELSE IF( LWORK.LT.1 .AND. .NOT.LQUERY ) THEN
         INFO = -7
      END IF
*
      IF( INFO.EQ.0 ) THEN
*
*        Determine the block size
*
         NB = ILAENV( 1, 'CHETRF', UPLO, N, -1, -1, -1 )
         LWKOPT = N*NB
         WORK( 1 ) = LWKOPT
      END IF
*
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'CHETRF', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         RETURN
      END IF
*
      NBMIN = 2
      LDWORK = N
      IF( NB.GT.1 .AND. NB.LT.N ) THEN
         IWS = LDWORK*NB
         IF( LWORK.LT.IWS ) THEN
            NB = MAX( LWORK / LDWORK, 1 )
            NBMIN = MAX( 2, ILAENV( 2, 'CHETRF', UPLO, N, -1, -1, -1 ) )
         END IF
      ELSE
         IWS = 1
      END IF
      IF( NB.LT.NBMIN )
     $   NB = N
*
      IF( UPPER ) THEN
*
*        Factorize A as U*D*U' using the upper triangle of A
*
*        K is the main loop index, decreasing from N to 1 in steps of
*        KB, where KB is the number of columns factorized by CLAHEF;
*        KB is either NB or NB-1, or K for the last block
*
         K = N
   10    CONTINUE
*
*        If K < 1, exit from loop
*
         IF( K.LT.1 )
     $      GO TO 40
*
         IF( K.GT.NB ) THEN
*
*           Factorize columns k-kb+1:k of A and use blocked code to
*           update columns 1:k-kb
*
            CALL CLAHEF( UPLO, K, NB, KB, A, LDA, IPIV, WORK, N, IINFO )
         ELSE
*
*           Use unblocked code to factorize columns 1:k of A
*
            CALL CHETF2( UPLO, K, A, LDA, IPIV, IINFO )
            KB = K
         END IF
*
*        Set INFO on the first occurrence of a zero pivot
*
         IF( INFO.EQ.0 .AND. IINFO.GT.0 )
     $      INFO = IINFO
*
*        Decrease K and return to the start of the main loop
*
         K = K - KB
         GO TO 10
*
      ELSE
*
*        Factorize A as L*D*L' using the lower triangle of A
*
*        K is the main loop index, increasing from 1 to N in steps of
*        KB, where KB is the number of columns factorized by CLAHEF;
*        KB is either NB or NB-1, or N-K+1 for the last block
*
         K = 1
   20    CONTINUE
*
*        If K > N, exit from loop
*
         IF( K.GT.N )
     $      GO TO 40
*
         IF( K.LE.N-NB ) THEN
*
*           Factorize columns k:k+kb-1 of A and use blocked code to
*           update columns k+kb:n
*
            CALL CLAHEF( UPLO, N-K+1, NB, KB, A( K, K ), LDA, IPIV( K ),
     $                   WORK, N, IINFO )
         ELSE
*
*           Use unblocked code to factorize columns k:n of A
*
            CALL CHETF2( UPLO, N-K+1, A( K, K ), LDA, IPIV( K ), IINFO )
            KB = N - K + 1
         END IF
*
*        Set INFO on the first occurrence of a zero pivot
*
         IF( INFO.EQ.0 .AND. IINFO.GT.0 )
     $      INFO = IINFO + K - 1
*
*        Adjust IPIV
*
         DO 30 J = K, K + KB - 1
            IF( IPIV( J ).GT.0 ) THEN
               IPIV( J ) = IPIV( J ) + K - 1
            ELSE
               IPIV( J ) = IPIV( J ) - K + 1
            END IF
   30    CONTINUE
*
*        Increase K and return to the start of the main loop
*
         K = K + KB
         GO TO 20
*
      END IF
*
   40 CONTINUE
      WORK( 1 ) = LWKOPT
      RETURN
*
*     End of CHETRF
*
      END

C
C	$Id: csleft.f,v 1.5 2008-07-27 03:10:07 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      LOGICAL FUNCTION CSLEFT (X1,Y1,Z1,X2,Y2,Z2,X0,Y0,Z0)
      DOUBLE PRECISION X1, Y1, Z1, X2, Y2, Z2, X0, Y0, Z0
C
C***********************************************************
C
C                                              From STRIPACK
C                                            Robert J. Renka
C                                  Dept. of Computer Science
C                                       Univ. of North Texas
C                                           renka@cs.unt.edu
C                                                   07/15/96
C
C   This function determines whether node N0 is in the
C (closed) left hemisphere defined by the plane containing
C N1, N2, and the origin, where left is defined relative to
C an observer at N1 facing N2.
C
C
C On input:
C
C       X1,Y1,Z1 = Coordinates of N1.
C
C       X2,Y2,Z2 = Coordinates of N2.
C
C       X0,Y0,Z0 = Coordinates of N0.
C
C Input parameters are not altered by this function.
C
C On output:
C
C       CSLEFT = TRUE if and only if N0 is in the closed
C              left hemisphere.
C
C Modules required by CSLEFT:  None
C
C***********************************************************
C
C CSLEFT = TRUE iff <N0,N1 X N2> = det(N0,N1,N2) .GE. 0.
C
      CSLEFT = X0*(Y1*Z2-Y2*Z1) - Y0*(X1*Z2-X2*Z1) +
     .       Z0*(X1*Y2-X2*Y1) .GE. 0.D0
      RETURN
      END

C
C $Id: icfell.f,v 1.7 2008-07-27 00:17:29 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      FUNCTION ICFELL (MESSG,NERRF)
C
        CHARACTER*(*) MESSG
C
C ICFELL (which stands for "I Check For Errors on Lower Level") is used
C to check for the occurrence of a recoverable error in a lower-level
C routine and (perhaps) to update the current error flag and message.
C
C The old value of the current error flag is returned as the value of
C the function ICFELL.  If that value is zero, nothing else has been
C done.  If the value of ICFELL is non-zero, the following actions have
C been taken:
C
C   If MESSG is blank, the current error message has not been changed.
C
C   If MESSG is non-blank and its length is 6 or less, it should be the
C   name of the routine referencing ICFELL; the current error message
C   has been altered by prepending first a slash and then the value of
C   MESSG.  (Note that, if an error occurs several levels deep, the
C   effect of using ICFELL at each level is, effectively, to generate
C   traceback information in the error message.)
C
C   If MESSG is non-blank and its length is 7 or greater, its value
C   has become the new value of the current error message and the
C   previous error message has been printed.  This is used at the
C   beginning of an NCAR Graphics routine to check for an outstanding
C   error that the user has not recovered from and to ensure that the
C   message for the outstanding error gets printed.
C
C   If the expression NERRF has the value zero, the current error
C   flag has not been changed.
C
C   If the expression NERRF has a non-zero value, the value of the
C   current error flag has been made equal to that value.
C
C An example:  Assume that the routine "A" calls the routine "B" and
C that "B" detects an error and calls SETER with error number "32" and
C error message "B - ERROR HAS OCCURRED".  If recovery mode is not in
C effect, SETER prints the error message and STOPs, but, if recovery
C mode is in effect, control returns from "SETER" to "B" and thence to
C "A".  At that point, the statement
C
C   IF (ICFELL('A',13).NE.0) RETURN
C
C detects the fact that an error has occurred in "B" and results in a
C return from "A" to whatever routine called it.  It also changes the
C current error message to read "A/B - ERROR HAS OCCURRED" and changes
C the error number from "32" to "13".
C
C Another example:  Assume that the NCAR Graphics routine "A" is called
C when recovery mode is set and that it detects an error, calls SETER,
C and RETURNs to the user.  If the user neglects to check the error
C state and calls the routine "B" next, the statement
C
C   IF (ICFELL('B - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C ensures that the error message from routine "A" will be printed, that
C it will be replaced by "B - UNCLEARED PRIOR ERROR", and that "B" will
C not attempt to execute.
C
C
C The common blocks SECOMI and SECOMC are used to hold shared variables
C of types INTEGER and CHARACTER, respectively, for the routine SETER
C and associated routines.  For descriptions of these variables and for
C default values of them, see the block data routine SEBLDAX.
C
        COMMON /SECOMI/ IERRU,IERRF,IRECF,LOMSG
        SAVE   /SECOMI/
C
        COMMON /SECOMC/ ERMSG
          CHARACTER*256 ERMSG
        SAVE   /SECOMC/
C
C Define a character temporary to use.
C
        CHARACTER*256 CTEMP
C
C Set the value of the function to the current value of the error flag.
C
        ICFELL=IERRF
C
C If the current error flag is non-zero, update its value and the value
C of the error message as directed by the values of the arguments of
C ICFELL.
C
        IF (IERRF.NE.0) THEN
C
          IF (MESSG.NE.' ') THEN
C
            LENMSG=ICLOEM(MESSG)
C
            IF (LENMSG.LE.6) THEN
              CTEMP=ERMSG
              ERMSG=MESSG(1:LENMSG)//'/'//CTEMP
            ELSE
              CALL EPRIN
              ERMSG=MESSG
            END IF
C
            LOMSG=ICLOEM(ERMSG)
C
          END IF
C
          IF (NERRF.NE.0) IERRF=NERRF
C
        END IF
C
C Done.
C
        RETURN
C
      END

C
C	$Id: csconstr.f,v 1.5 2008-07-27 03:10:06 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CSCONSTR (XK,YK,ZK, CX,SX,CY,SY)
      DOUBLE PRECISION XK, YK, ZK, CX, SX, CY, SY
C
C***********************************************************
C
C                                              From SSRFPACK
C                                            Robert J. Renka
C                                  Dept. of Computer Science
C                                       Univ. of North Texas
C                                           renka@cs.unt.edu
C                                                   05/09/92
C
C   This subroutine constructs the elements of a 3 by 3
C orthogonal matrix R which rotates a point (XK,YK,ZK) on
C the unit sphere to the north pole, i.e.,
C
C      (XK)     (CY  0 -SY)   (1   0   0)   (XK)     (0)
C  R * (YK)  =  ( 0  1   0) * (0  CX -SX) * (YK)  =  (0)
C      (ZK)     (SY  0  CY)   (0  SX  CX)   (ZK)     (1)
C
C On input:
C
C       XK,YK,ZK = Components of a unit vector to be
C                  rotated to (0,0,1).
C
C Input parameters are not altered by this routine.
C
C On output:
C
C       CX,SX,CY,SY = Elements of R:  CX,SX define a rota-
C                     tion about the X-axis and CY,SY define
C                     a rotation about the Y-axis.
C
C Modules required by CSCONSTR:  None
C
C Intrinsic function called by CSCONSTR:  SQRT
C
C***********************************************************
C
      CY = SQRT(YK*YK + ZK*ZK)
      SY = XK
      IF (CY .NE. 0.) THEN
        CX = ZK/CY
        SX = YK/CY
      ELSE
C
C (XK,YK,ZK) lies on the X-axis.
C
        CX = 1.
        SX = 0.
      ENDIF
      RETURN
      END

      PROGRAM NNEX01
C
C  Simple example of natural neighbor linear interpolation.
C
      PARAMETER(ISLIM = 6, NUMXOUT = 21, NUMYOUT = 21)
C
C  Dimension for the work space for the NCAR Graphics call to
C  SRFACE to plot the interpolated grid.
C
      PARAMETER(IDIM=2*NUMXOUT*NUMYOUT)
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C  Input data arrays.
C
      REAL X(ISLIM), Y(ISLIM), Z(ISLIM)
C
C  Output grid arrays.
C
      REAL XI(NUMXOUT), YI(NUMYOUT), ZI(NUMXOUT,NUMYOUT)
C
C  Define the input data arrays.
C
      DATA X/0.00, 1.00, 0.00, 1.00, 0.40, 0.75 /
      DATA Y/0.00, 0.00, 1.00, 1.00, 0.20, 0.65 /
      DATA Z/0.00, 0.00, 0.00, 0.00, 1.25, 0.80 /
C
      DIMENSION IWORK(IDIM)
C
C  Define the output grid.
C
      XMIN = 0.
      XMAX = 1.
      XINC = (XMAX-XMIN)/(NUMXOUT-1.) 
      DO 20 I=1,NUMXOUT
        XI(I) = XMIN+REAL(I-1) * XINC
   20 CONTINUE
C
      YMAX =  1.
      YMIN =  0.
      YINC = (YMAX-YMIN)/(NUMYOUT-1.)
      DO 30 J=1,NUMYOUT
        YI(J) = YMIN+REAL(J-1) * YINC
   30 CONTINUE 
C
C  Do the gridding.
C
      CALL NATGRIDS(ISLIM,X,Y,Z,NUMXOUT,NUMYOUT,XI,YI,ZI,IER)
      IF (IER .NE. 0) THEN
        WRITE (6,510) IER
  510   FORMAT('Error return from NATGRIDS = ',I3)
      ENDIF
C
C  Draw a plot of the interpolated surface.
C
C
C Open GKS and define the foreground and background color.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
      CALL GSCR(IWKID, 0, 1.00, 1.00, 1.00)
      CALL GSCR(IWKID, 1, 0.00, 0.00, 0.00)
C
      CALL DRWSRF (NUMXOUT,NUMYOUT,XI,YI,ZI,15.,-25.,90.,IWORK)
C
C Close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C 
      STOP
      END

      SUBROUTINE ZGTSVX( FACT, TRANS, N, NRHS, DL, D, DU, DLF, DF, DUF,
     $                   DU2, IPIV, B, LDB, X, LDX, RCOND, FERR, BERR,
     $                   WORK, RWORK, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          FACT, TRANS
      INTEGER            INFO, LDB, LDX, N, NRHS
      DOUBLE PRECISION   RCOND
*     ..
*     .. Array Arguments ..
      INTEGER            IPIV( * )
      DOUBLE PRECISION   BERR( * ), FERR( * ), RWORK( * )
      COMPLEX*16         B( LDB, * ), D( * ), DF( * ), DL( * ),
     $                   DLF( * ), DU( * ), DU2( * ), DUF( * ),
     $                   WORK( * ), X( LDX, * )
*     ..
*
*  Purpose
*  =======
*
*  ZGTSVX uses the LU factorization to compute the solution to a complex
*  system of linear equations A * X = B, A**T * X = B, or A**H * X = B,
*  where A is a tridiagonal matrix of order N and X and B are N-by-NRHS
*  matrices.
*
*  Error bounds on the solution and a condition estimate are also
*  provided.
*
*  Description
*  ===========
*
*  The following steps are performed:
*
*  1. If FACT = 'N', the LU decomposition is used to factor the matrix A
*     as A = L * U, where L is a product of permutation and unit lower
*     bidiagonal matrices and U is upper triangular with nonzeros in
*     only the main diagonal and first two superdiagonals.
*
*  2. If some U(i,i)=0, so that U is exactly singular, then the routine
*     returns with INFO = i. Otherwise, the factored form of A is used
*     to estimate the condition number of the matrix A.  If the
*     reciprocal of the condition number is less than machine precision,
*     INFO = N+1 is returned as a warning, but the routine still goes on
*     to solve for X and compute error bounds as described below.
*
*  3. The system of equations is solved for X using the factored form
*     of A.
*
*  4. Iterative refinement is applied to improve the computed solution
*     matrix and calculate error bounds and backward error estimates
*     for it.
*
*  Arguments
*  =========
*
*  FACT    (input) CHARACTER*1
*          Specifies whether or not the factored form of A has been
*          supplied on entry.
*          = 'F':  DLF, DF, DUF, DU2, and IPIV contain the factored form
*                  of A; DL, D, DU, DLF, DF, DUF, DU2 and IPIV will not
*                  be modified.
*          = 'N':  The matrix will be copied to DLF, DF, and DUF
*                  and factored.
*
*  TRANS   (input) CHARACTER*1
*          Specifies the form of the system of equations:
*          = 'N':  A * X = B     (No transpose)
*          = 'T':  A**T * X = B  (Transpose)
*          = 'C':  A**H * X = B  (Conjugate transpose)
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  NRHS    (input) INTEGER
*          The number of right hand sides, i.e., the number of columns
*          of the matrix B.  NRHS >= 0.
*
*  DL      (input) COMPLEX*16 array, dimension (N-1)
*          The (n-1) subdiagonal elements of A.
*
*  D       (input) COMPLEX*16 array, dimension (N)
*          The n diagonal elements of A.
*
*  DU      (input) COMPLEX*16 array, dimension (N-1)
*          The (n-1) superdiagonal elements of A.
*
*  DLF     (input or output) COMPLEX*16 array, dimension (N-1)
*          If FACT = 'F', then DLF is an input argument and on entry
*          contains the (n-1) multipliers that define the matrix L from
*          the LU factorization of A as computed by ZGTTRF.
*
*          If FACT = 'N', then DLF is an output argument and on exit
*          contains the (n-1) multipliers that define the matrix L from
*          the LU factorization of A.
*
*  DF      (input or output) COMPLEX*16 array, dimension (N)
*          If FACT = 'F', then DF is an input argument and on entry
*          contains the n diagonal elements of the upper triangular
*          matrix U from the LU factorization of A.
*
*          If FACT = 'N', then DF is an output argument and on exit
*          contains the n diagonal elements of the upper triangular
*          matrix U from the LU factorization of A.
*
*  DUF     (input or output) COMPLEX*16 array, dimension (N-1)
*          If FACT = 'F', then DUF is an input argument and on entry
*          contains the (n-1) elements of the first superdiagonal of U.
*
*          If FACT = 'N', then DUF is an output argument and on exit
*          contains the (n-1) elements of the first superdiagonal of U.
*
*  DU2     (input or output) COMPLEX*16 array, dimension (N-2)
*          If FACT = 'F', then DU2 is an input argument and on entry
*          contains the (n-2) elements of the second superdiagonal of
*          U.
*
*          If FACT = 'N', then DU2 is an output argument and on exit
*          contains the (n-2) elements of the second superdiagonal of
*          U.
*
*  IPIV    (input or output) INTEGER array, dimension (N)
*          If FACT = 'F', then IPIV is an input argument and on entry
*          contains the pivot indices from the LU factorization of A as
*          computed by ZGTTRF.
*
*          If FACT = 'N', then IPIV is an output argument and on exit
*          contains the pivot indices from the LU factorization of A;
*          row i of the matrix was interchanged with row IPIV(i).
*          IPIV(i) will always be either i or i+1; IPIV(i) = i indicates
*          a row interchange was not required.
*
*  B       (input) COMPLEX*16 array, dimension (LDB,NRHS)
*          The N-by-NRHS right hand side matrix B.
*
*  LDB     (input) INTEGER
*          The leading dimension of the array B.  LDB >= max(1,N).
*
*  X       (output) COMPLEX*16 array, dimension (LDX,NRHS)
*          If INFO = 0 or INFO = N+1, the N-by-NRHS solution matrix X.
*
*  LDX     (input) INTEGER
*          The leading dimension of the array X.  LDX >= max(1,N).
*
*  RCOND   (output) DOUBLE PRECISION
*          The estimate of the reciprocal condition number of the matrix
*          A.  If RCOND is less than the machine precision (in
*          particular, if RCOND = 0), the matrix is singular to working
*          precision.  This condition is indicated by a return code of
*          INFO > 0.
*
*  FERR    (output) DOUBLE PRECISION array, dimension (NRHS)
*          The estimated forward error bound for each solution vector
*          X(j) (the j-th column of the solution matrix X).
*          If XTRUE is the true solution corresponding to X(j), FERR(j)
*          is an estimated upper bound for the magnitude of the largest
*          element in (X(j) - XTRUE) divided by the magnitude of the
*          largest element in X(j).  The estimate is as reliable as
*          the estimate for RCOND, and is almost always a slight
*          overestimate of the true error.
*
*  BERR    (output) DOUBLE PRECISION array, dimension (NRHS)
*          The componentwise relative backward error of each solution
*          vector X(j) (i.e., the smallest relative change in
*          any element of A or B that makes X(j) an exact solution).
*
*  WORK    (workspace) COMPLEX*16 array, dimension (2*N)
*
*  RWORK   (workspace) DOUBLE PRECISION array, dimension (N)
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*          > 0:  if INFO = i, and i is
*                <= N:  U(i,i) is exactly zero.  The factorization
*                       has not been completed unless i = N, but the
*                       factor U is exactly singular, so the solution
*                       and error bounds could not be computed.
*                       RCOND = 0 is returned.
*                = N+1: U is nonsingular, but RCOND is less than machine
*                       precision, meaning that the matrix is singular
*                       to working precision.  Nevertheless, the
*                       solution and error bounds are computed because
*                       there are a number of situations where the
*                       computed solution can be more accurate than the
*                       value of RCOND would suggest.
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO
      PARAMETER          ( ZERO = 0.0D+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            NOFACT, NOTRAN
      CHARACTER          NORM
      DOUBLE PRECISION   ANORM
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      DOUBLE PRECISION   DLAMCH, ZLANGT
      EXTERNAL           LSAME, DLAMCH, ZLANGT
*     ..
*     .. External Subroutines ..
      EXTERNAL           XERBLA, ZCOPY, ZGTCON, ZGTRFS, ZGTTRF, ZGTTRS,
     $                   ZLACPY
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX
*     ..
*     .. Executable Statements ..
*
      INFO = 0
      NOFACT = LSAME( FACT, 'N' )
      NOTRAN = LSAME( TRANS, 'N' )
      IF( .NOT.NOFACT .AND. .NOT.LSAME( FACT, 'F' ) ) THEN
         INFO = -1
      ELSE IF( .NOT.NOTRAN .AND. .NOT.LSAME( TRANS, 'T' ) .AND. .NOT.
     $         LSAME( TRANS, 'C' ) ) THEN
         INFO = -2
      ELSE IF( N.LT.0 ) THEN
         INFO = -3
      ELSE IF( NRHS.LT.0 ) THEN
         INFO = -4
      ELSE IF( LDB.LT.MAX( 1, N ) ) THEN
         INFO = -14
      ELSE IF( LDX.LT.MAX( 1, N ) ) THEN
         INFO = -16
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'ZGTSVX', -INFO )
         RETURN
      END IF
*
      IF( NOFACT ) THEN
*
*        Compute the LU factorization of A.
*
         CALL ZCOPY( N, D, 1, DF, 1 )
         IF( N.GT.1 ) THEN
            CALL ZCOPY( N-1, DL, 1, DLF, 1 )
            CALL ZCOPY( N-1, DU, 1, DUF, 1 )
         END IF
         CALL ZGTTRF( N, DLF, DF, DUF, DU2, IPIV, INFO )
*
*        Return if INFO is non-zero.
*
         IF( INFO.NE.0 ) THEN
            IF( INFO.GT.0 )
     $         RCOND = ZERO
            RETURN
         END IF
      END IF
*
*     Compute the norm of the matrix A.
*
      IF( NOTRAN ) THEN
         NORM = '1'
      ELSE
         NORM = 'I'
      END IF
      ANORM = ZLANGT( NORM, N, DL, D, DU )
*
*     Compute the reciprocal of the condition number of A.
*
      CALL ZGTCON( NORM, N, DLF, DF, DUF, DU2, IPIV, ANORM, RCOND, WORK,
     $             INFO )
*
*     Set INFO = N+1 if the matrix is singular to working precision.
*
      IF( RCOND.LT.DLAMCH( 'Epsilon' ) )
     $   INFO = N + 1
*
*     Compute the solution vectors X.
*
      CALL ZLACPY( 'Full', N, NRHS, B, LDB, X, LDX )
      CALL ZGTTRS( TRANS, N, NRHS, DLF, DF, DUF, DU2, IPIV, X, LDX,
     $             INFO )
*
*     Use iterative refinement to improve the computed solutions and
*     compute error bounds and backward error estimates for them.
*
      CALL ZGTRFS( TRANS, N, NRHS, DL, D, DU, DLF, DF, DUF, DU2, IPIV,
     $             B, LDB, X, LDX, FERR, BERR, WORK, RWORK, INFO )
*
      RETURN
*
*     End of ZGTSVX
*
      END

C
C	$Id: csintrsc.f,v 1.5 2008-07-27 03:10:07 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CSINTRSC (P1,P2,CN, P,IER)
      INTEGER IER
      DOUBLE PRECISION P1(3), P2(3), CN(3), P(3)
C
C***********************************************************
C
C                                              From STRIPACK
C                                            Robert J. Renka
C                                  Dept. of Computer Science
C                                       Univ. of North Texas
C                                           renka@cs.unt.edu
C                                                   07/19/90
C
C   Given a great circle C and points P1 and P2 defining an
C arc A on the surface of the unit sphere, where A is the
C shorter of the two portions of the great circle C12 assoc-
C iated with P1 and P2, this subroutine returns the point
C of intersection P between C and C12 that is closer to A.
C Thus, if P1 and P2 lie in opposite hemispheres defined by
C C, P is the point of intersection of C with A.
C
C
C On input:
C
C       P1,P2 = Arrays of length 3 containing the Cartesian
C               coordinates of unit vectors.
C
C       CN = Array of length 3 containing the Cartesian
C            coordinates of a nonzero vector which defines C
C            as the intersection of the plane whose normal
C            is CN with the unit sphere.  Thus, if C is to
C            be the great circle defined by P and Q, CN
C            should be P X Q.
C
C The above parameters are not altered by this routine.
C
C       P = Array of length 3.
C
C On output:
C
C       P = Point of intersection defined above unless IER
C           .NE. 0, in which case P is not altered.
C
C       IER = Error indicator.
C             IER = 0 if no errors were encountered.
C             IER = 1 if <CN,P1> = <CN,P2>.  This occurs
C                     iff P1 = P2 or CN = 0 or there are
C                     two intersection points at the same
C                     distance from A.
C             IER = 2 if P2 = -P1 and the definition of A is
C                     therefore ambiguous.
C
C Modules required by CSINTRSC:  None
C
C Intrinsic function called by CSINTRSC:  SQRT
C
C***********************************************************
C
      INTEGER I
      DOUBLE PRECISION D1, D2, PP(3), PPN, T
C
C Local parameters:
C
C D1 =  <CN,P1>
C D2 =  <CN,P2>
C I =   DO-loop index
C PP =  P1 + T*(P2-P1) = Parametric representation of the
C         line defined by P1 and P2
C PPN = Norm of PP
C T =   D1/(D1-D2) = Parameter value chosen so that PP lies
C         in the plane of C
C
      D1 = CN(1)*P1(1) + CN(2)*P1(2) + CN(3)*P1(3)
      D2 = CN(1)*P2(1) + CN(2)*P2(2) + CN(3)*P2(3)
C
      IF (D1 .EQ. D2) THEN
        IER = 1
        RETURN
      ENDIF
C
C Solve for T such that <PP,CN> = 0 and compute PP and PPN.
C
      T = D1/(D1-D2)
      PPN = 0.D0
      DO 1 I = 1,3
        PP(I) = P1(I) + T*(P2(I)-P1(I))
        PPN = PPN + PP(I)*PP(I)
    1   CONTINUE
C
C PPN = 0 iff PP = 0 iff P2 = -P1 (and T = .5).
C
      IF (PPN .EQ. 0.D0) THEN
        IER = 2
        RETURN
      ENDIF
      PPN = SQRT(PPN)
C
C Compute P = PP/PPN.
C
      DO 2 I = 1,3
        P(I) = PP(I)/PPN
    2   CONTINUE
      IER = 0
      RETURN
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C                Copyright (C)  1995                                   C
C        University Corporation for Atmospheric Research               C
C                all rights reserved                                   C
C                                                                      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C      File:           tx02f.f
C
C      Author:         Bob Lackman (converted by Ed Stautler)
C          National Center for Atmospheric Research
C          PO 3000, Boulder, Colorado
C
C      Date:           Fri Jan 06 18:31:18 mdt 1995
C
C      Description:    Demonstrates the textitem object
C                      writing "NCAR Graphics" in a filled
C                      colored font.  Turn on the bounding box.
C
      external NhlFAppClass
      external NhlFCairoWindowWorkstationClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFTextItemClass
        
      integer appid, wid, pid
      integer rlist, ierr
      character*7  wks_type
C
C Default is to create an X workstation.
C
      wks_type = "x11"
C
C Initialize the high level utility library
C
      call NhlFInitialize
C
C Create an application context. Set the app dir to the current
C directory so the application looks for a resource file in the
C working directory. In this example the resource file supplies the
C plot title only.
C
      call NhlFRLCreate(rlist,'setrl')
      call NhlFRLClear(rlist)
      call NhlFRLSetstring(rlist,'appDefaultParent','True',ierr)
      call NhlFRLSetstring(rlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'tx02',NhlFAppClass,0,rlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkMetaName','./tx02f.ncgm',ierr)
         call NhlFCreate(wid,'tx02Work',NhlFNcgmWorkstationClass,0,
     $        rlist,ierr)
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X11 workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPause','True',ierr)
         call NhlFCreate(wid,'tx02Work',
     $        NhlFCairoWindowWorkstationClass,
     $        0,rlist,ierr)
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PostScript workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPSFileName','./tx02f.ps',ierr)
         call NhlFCreate(wid,'tx02Work',NhlFPSWorkstationClass,0,
     $        rlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPDFFileName','./tx02f.pdf',ierr)
         call NhlFCreate(wid,'tx02Work',NhlFPDFWorkstationClass,0,
     $        rlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF object.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetstring(rlist,'wkFileName','./tx02f',ierr)
         call NhlFCreate(wid,'tx02Work',
     $        NhlFCairoPSPDFWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG object.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetstring(rlist,'wkFileName','./tx02f',ierr)
         call NhlFCreate(wid,'tx02Work',
     $        NhlFCairoImageWorkstationClass,0,rlist,ierr)
      endif
C
C Create a TextItem object.
C
      call NhlFCreate(pid,'TextItems',NhlFTextItemClass,wid,0,ierr)

      call NhlFDraw(pid,ierr)
      call NhlFFrame(wid,ierr)
      call NhlFDestroy(pid,ierr)
      call NhlFDestroy(wid,ierr)
      call NhlFDestroy(appid,ierr)
      call NhlFClose

      stop
      end

      PROGRAM PGKEX23
C
C  Illustrate changing spacing between hatch pattern lines.
C
C  Define error file, Fortran unit number, and workstation type,
C  and workstation ID.
C
      PARAMETER (IERRF=6, LUNIT=2, IWKID=1, IDIM=12)
C
      CHARACTER*15 LAB
      DIMENSION XL(4),XR(4),YB(4),YT(4),IHATCH(4),RSPACE(4)
      DATA XL/ 0.05, 0.55, 0.05, 0.55/
      DATA XR/ 0.45, 0.95, 0.45, 0.95/
      DATA YT/ 0.90, 0.90, 0.40, 0.40/
      DATA YB/ 0.50, 0.50, 0.00, 0.00/
      DATA IHATCH/ 1, 1, 3, 6/
      DATA RSPACE/ 0.01, 0.02, 0.03, 0.05/
C
C  Open GKS.
C
      CALL GOPKS (IERRF, IDUM)
C
C  Open and activate a color PostScript workstation.
C
      CALL GOPWK (IWKID, 2, NGPSWK('PS','PORT','COLOR'))
      CALL GACWK (IWKID)
C
C  Set up color table.
C
      CALL GSCR(IWKID,0,1.,1.,1.)
      CALL GSCR(IWKID,1,0.,0.,0.)
      CALL GSCR(IWKID,2,0.,0.,1.)
C
      CALL GSFAIS(3)
      CALL NGSETI('Workstation ID',IWKID)
      CALL PCSETI('FN',25)
      CALL PCSETI('CC',1)
      DO 10 I=1,4
        CALL GSFAIS(3)
        CALL GSFASI(IHATCH(I))
        CALL NGSETR('Hatch spacing',RSPACE(I))
        CALL ZIGZAG(XL(I),XR(I),YB(I),YT(I))
        CALL GSFAIS(1)
        WRITE(LAB,500) IHATCH(I)
  500   FORMAT('Style index = ',I1)
        CALL PLCHHQ(XL(I)+0.21,YT(I)-0.02,LAB,0.022,0.,0.)
        WRITE(LAB,510) RSPACE(I)
  510   FORMAT('Spacing = ',F4.2,' ')
        CALL PLCHHQ(XL(I)+0.32,YT(I)-0.09,LAB,0.022,0.,0.)
   10 CONTINUE
C
      CALL PLCHHQ(.5,.98,'Hatch line spacings',0.035,0.,0.)
C
      CALL FRAME
      CALL GDAWK(IWKID)
      CALL GCLWK(IWKID)
      CALL GCLKS
C
      STOP
      END
      SUBROUTINE ZIGZAG(XLEFT,XRIGHT,YBOT,YTOP)
C
C  Draw a zigzag figure within the specified limits for a rectangle.
C
      PARAMETER (IDIM=10)
      DIMENSION X(IDIM),Y(IDIM)
C
      DX = (XRIGHT-XLEFT)/8.
      DY = (YTOP-YBOT)/10.
C
      DO 10 I=1,IDIM-1
        X(I) = XLEFT+(I-1)*DX
   10 CONTINUE
      X(IDIM) = X(1)
C
      Y(1) = YTOP-2.*DY
      Y(2) = YTOP
      Y(3) = YBOT
      Y(4) = YTOP-2.0*DY
      Y(5) = YBOT
      Y(6) = YTOP-4.0*DY
      Y(7) = YBOT
      Y(8) = YTOP-6.0*DY
      Y(9) = YTOP-8.5*DY
      Y(10) = Y(1)
C
      CALL GSFACI(2)
      CALL GFA(IDIM,X,Y)
      CALL GSPLCI(1)
      CALL GPL(IDIM,X,Y)
C
      RETURN
      END

C
C $Id: curvp1.f,v 1.5 2008-07-27 03:10:10 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
C NOTE: If you make any changes to this software, please remember to
C make the same changes to the corresponding double precision routine.
C
      subroutine curvp1 (n,x,y,p,yp,temp,sigma,ierr)
c
      integer n,ierr
      real x(n),y(n),p,yp(n),temp(1),sigma
c
c                                 coded by alan kaylor cline
c                           from fitpack -- january 26, 1987
c                        a curve and surface fitting package
c                      a product of pleasant valley software
c                  8603 altus cove, austin, texas 78759, usa
c
c this subroutine determines the parameters necessary to
c compute a periodic interpolatory spline under tension
c through a sequence of functional values. for actual ends
c of the curve may be specified or omitted.  for actual
c computation of points on the curve it is necessary to call
c the function curvp2.
c
c on input--
c
c   n is the number of values to be interpolated (n.ge.2).
c
c   x is an array of the n increasing abscissae of the
c   functional values.
c
c   y is an array of the n ordinates of the values, (i. e.
c   y(k) is the functional value corresponding to x(k) ).
c
c   p is the period (p .gt. x(n)-x(1)).
c
c   yp is an array of length at least n.
c
c   temp is an array of length at least 2*n which is used
c   for scratch storage.
c
c and
c
c   sigma contains the tension factor.  this value indicates
c   the curviness desired. if abs(sigma) is nearly zero
c   (e.g. .001) the resulting curve is approximately a
c   cubic spline. if abs(sigma) is large (e.g. 50.) the
c   resulting curve is nearly a polygonal line. if sigma
c   equals zero a cubic spline results.  a standard value
c   for sigma is approximately 1. in absolute value.
c
c on output--
c
c   yp contains the values of the second derivative of the
c   curve at the given nodes.
c
c   ierr contains an error flag,
c        = 0 for normal return,
c        = 1 if n is less than 2,
c        = 2 if p is less than or equal to x(n)-x(1),
c        = 3 if x-values are not strictly increasing.
c
c and
c
c  n, x, y, and sigma are unaltered.
c
c this subroutine references package modules terms and
c snhcsh.
c
c-----------------------------------------------------------
c
      nm1 = n-1
      np1 = n+1
      ierr = 0
      if (n .le. 1) go to 6
      if (p .le. x(n)-x(1) .or. p .le. 0.) go to 7
c
c denormalize tension factor
c
      sigmap = abs(sigma)*float(n)/p
c
c set up right hand side and tridiagonal system for yp and
c perform forward elimination
c
      delx1 = p-(x(n)-x(1))
      dx1 = (y(1)-y(n))/delx1
      call terms (diag1,sdiag1,sigmap,delx1)
      delx2 = x(2)-x(1)
      if (delx2 .le. 0.) go to 8
      dx2 = (y(2)-y(1))/delx2
      call terms (diag2,sdiag2,sigmap,delx2)
      diag = diag1+diag2
      yp(1) = (dx2-dx1)/diag
      temp(np1) = -sdiag1/diag
      temp(1) = sdiag2/diag
      dx1 = dx2
      diag1 = diag2
      sdiag1 = sdiag2
      if (n .eq. 2) go to 2
      do 1 i = 2,nm1
        npi = n+i
        delx2 = x(i+1)-x(i)
        if (delx2 .le. 0.) go to 8
        dx2 = (y(i+1)-y(i))/delx2
        call terms (diag2,sdiag2,sigmap,delx2)
        diag = diag1+diag2-sdiag1*temp(i-1)
        yp(i) = (dx2-dx1-sdiag1*yp(i-1))/diag
        temp(npi) = -temp(npi-1)*sdiag1/diag
        temp(i) = sdiag2/diag
        dx1 = dx2
        diag1 = diag2
    1   sdiag1 = sdiag2
    2 delx2 = p-(x(n)-x(1))
      dx2 = (y(1)-y(n))/delx2
      call terms (diag2,sdiag2,sigmap,delx2)
      yp(n) = dx2-dx1
      temp(nm1) = temp(2*n-1)-temp(nm1)
      if (n .eq. 2) go to 4
c
c perform first step of back substitution
c
      do 3 i = 3,n
        ibak = np1-i
        npibak =n+ibak
        yp(ibak) = yp(ibak)-temp(ibak)*yp(ibak+1)
    3   temp(ibak) =temp(npibak)-temp(ibak)*temp(ibak+1)
    4 yp(n) = (yp(n)-sdiag2*yp(1)-sdiag1*yp(nm1))/
     *        (diag1+diag2+sdiag2*temp(1)+sdiag1*temp(nm1))
c
c perform second step of back substitution
c
      ypn =   yp(n)
      do 5 i = 1,nm1
    5    yp(i) = yp(i)+temp(i)*ypn
      return
c
c too few points
c
    6 ierr = 1
      return
c
c period too small
c
    7 ierr = 2
      return
c
c x-values not strictly increasing
c
    8 ierr = 3
      return
      end

C
C       $Id: crdrln.f,v 1.7 2008-07-27 00:23:02 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CRDRLN (Z,L,MM,NN)
      SAVE
      DIMENSION       Z(L,NN)
C
C THIS ROUTINE TRACES A CONTOUR LINE WHEN GIVEN THE BEGINNING BY STLINE.
C TRANSFORMATIONS CAN BE ADDED BY DELETING THE STATEMENT FUNCTIONS FOR
C FX AND FY IN CRDRLN AND MINMAX AND ADDING EXTERNAL FUNCTIONS.
C X=1. AT Z(1,J), X=REAL(M) AT Z(M,J). X TAKES ON NON-INTEGER VALUES.
C Y=1. AT Z(I,1), Y=REAL(N) AT Z(I,N). Y TAKES ON NON-INTEGER VALUES.
C
      COMMON /CONRE2/ IX         ,IY         ,IDX        ,IDY        ,
     1                IS         ,ISS        ,NP         ,CV         ,
     2                INX(8)     ,INY(8)     ,IR(2000)   ,NR
      COMMON /CONRE1/ IOFFP      ,SPVAL      ,IHILO
      COMMON /CONRE3/ IXBITS     ,IYBITS
      LOGICAL         IPEN       ,IPENO
      DATA IPEN,IPENO/.TRUE.,.TRUE./
C
C     FX(X,Y) = X
C     FY(X,Y) = Y
      IXYPAK(IXX,IYY) = ISHIFT(IXX,IYBITS)+IYY
      CFCN(P1,P2) = (P1-CV)/(P1-P2)
C
      M = MM
      N = NN
      IF (IOFFP .EQ. 0) GO TO 101
      JUMP = 1
      GO TO 102
  101 JUMP = 2
  102 IX0 = IX
      IY0 = IY
      IS0 = IS
      IF (IOFFP .EQ. 0) GO TO 103
      IX2 = IX+INX(IS)
      IY2 = IY+INY(IS)
      IPEN = Z(IX,IY).NE.SPVAL .AND. Z(IX2,IY2).NE.SPVAL
      IPENO = IPEN
  103 IF (IDX .EQ. 0) GO TO 104
      Y = IY
      ISUB = IX+IDX
      X = CFCN(Z(IX,IY),Z(ISUB,IY))*REAL(IDX)+REAL(IX)
      GO TO 105
  104 X = IX
      ISUB = IY+IDY
      Y = CFCN(Z(IX,IY),Z(IX,ISUB))*REAL(IDY)+REAL(IY)
  105 CALL FRSTD (FX(X,Y),FY(X,Y))
  106 IS = IS+1
      IF (IS .GT. 8) IS = IS-8
      IDX = INX(IS)
      IDY = INY(IS)
      IX2 = IX+IDX
      IY2 = IY+IDY
      IF (ISS .NE. 0) GO TO 107
      IF (IX2.GT.M .OR. IY2.GT.N .OR. IX2.LT.1 .OR. IY2.LT.1) GO TO 119
  107 IF (CV-Z(IX2,IY2)) 108,108,109
  108 IS = IS+4
      IX = IX2
      IY = IY2
      GO TO 106
  109 IF (IS/2*2 .EQ. IS) GO TO 106
      GO TO (110,112) , JUMP
  110 ISBIG = IS+(8-IS)/6*8
      IX3 = IX+INX(ISBIG-1)
      IY3 = IY+INY(ISBIG-1)
      IX4 = IX+INX(ISBIG-2)
      IY4 = IY+INY(ISBIG-2)
      IPENO = IPEN
      IF (ISS .NE. 0) GO TO 111
      IF (IX3.GT.M .OR. IY3.GT.N .OR. IX3.LT.1 .OR. IY3.LT.1) GO TO 119
      IF (IX4.GT.M .OR. IY4.GT.N .OR. IX4.LT.1 .OR. IY4.LT.1) GO TO 119
  111 IPEN = Z(IX,IY).NE.SPVAL .AND. Z(IX2,IY2).NE.SPVAL .AND.
     1       Z(IX3,IY3).NE.SPVAL .AND. Z(IX4,IY4).NE.SPVAL
  112 IF (IDX .EQ. 0) GO TO 113
      Y = IY
      ISUB = IX+IDX
      X = CFCN(Z(IX,IY),Z(ISUB,IY))*REAL(IDX)+REAL(IX)
      GO TO 114
  113 X = IX
      ISUB = IY+IDY
      Y = CFCN(Z(IX,IY),Z(IX,ISUB))*REAL(IDY)+REAL(IY)
  114 GO TO (115,116) , JUMP
  115 IF (.NOT.IPEN) GO TO 117
      IF (IPENO) GO TO 1151
C
C END OF LINE SEGMENT
C
      CALL LASTD
      CALL FRSTD (FX(XOLD,YOLD),FY(XOLD,YOLD))
C
C CONTINUE LINE SEGMENT
 1151 CONTINUE
  116 CALL VECTD (FX(X,Y),FY(X,Y))
  117 XOLD = X
      YOLD = Y
      IF (IS .NE. 1) GO TO 118
      NP = NP+1
      IF (NP .GT. NR) GO TO 119
      IR(NP) = IXYPAK(IX,IY)
  118 IF (ISS .EQ. 0) GO TO 106
      IF (IX.NE.IX0 .OR. IY.NE.IY0 .OR. IS.NE.IS0) GO TO 106
C
C END OF LINE
C
  119 CALL LASTD
      RETURN
      END

      PROGRAM THAFTO
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C OPEN GKS, OPEN WORKSTATION OF TYPE 1, ACTIVATE WORKSTATION
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C INVOKE DEMO DRIVER
C
      CALL HAFTO(IERR)
C
C DEACTIVATE AND CLOSE WORKSTATION, CLOSE GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END
C
      SUBROUTINE HAFTO (IERROR)
C
C PURPOSE                Provides a simple demonstration of HAFTON
C
C USAGE                  CALL HAFTO (IERROR)
C
C ARGUMENTS
C ON OUTPUT              IERROR
C                          An integer variable
C                          = 0, if the test was successful,
C                          = 1, the test was not successful.
C
C I/O                    If the test is successful, the message
C               HAFTON TEST EXECUTED--SEE PLOTS TO CERTIFY
C
C                        is printed on unit 6.  In addition, 2 half-tone
C                        frames are produced on the machine graphics
C                        device.  In order to determine if the test
C                        was successful, it is necessary to examine
C                        the plots.
C
C PRECISION              Single
C
C LANGUAGE               FORTRAN 77
C
C REQUIRED ROUTINES      HAFTON
C
C REQUIRED GKS LEVEL     0A
C
C ALGORITHM              The function
C                          Z(X,Y) = X + Y + 1./((X-.1)**2+Y**2+.09)
C                                   -1./((X+.1)**2+Y**2+.09)
C                        for X = -1. TO +1. in increments of .1, and
C                            Y = -1.2 TO +1.2 in increments of .1,
C                        is computed.  Then, entries EZHFTN and HAFTON
C                        are called to generate 2 half-tone plots of Z.
C
C Z contains the values to be plotted.
C
      REAL            Z(21,25)
      SAVE
C
C Specify coordinates for plot titles.  The values TX and TY
C define the center of the title string in a 0. to 1. range.
C
      DATA TX/0.0762/, TY/0.9769/
C
C Specify low (FLO) and high (FHI) contour values, and NLEV
C unique contour levels.  NOPT determines how Z maps onto the
C intensities, and the directness of the mapping.
C
      DATA FLO/-4.0/, FHI/4.0/, NLEV/8/, NOPT/-3/
C
C Initialize the error indicator
C
      IERROR = 0
C
C Fill the 2 dimensional array to be plotted
C
      DO  20 I=1,21
         X = .1*REAL(I-11)
         DO  10 J=1,25
            Y = .1*REAL(J-13)
            Z(I,J) = X+Y+1./((X-.10)**2+Y**2+.09)-
     1               1./((X+.10)**2+Y**2+.09)
   10    CONTINUE
   20 CONTINUE
C
C Select normalization trans 0 for plotting title.
C
      CALL GSELNT (0)
C
C
C     Frame 1 -- The EZHFTN entry with default parameters.
C
C Call PLCHLQ to write the plot title.
C
      CALL PLCHLQ (TX,TY,
     1      'DEMONSTRATION PLOT FOR ENTRY EZHFTN OF HAFTON',16.,0.,-1.)
C
C Entry EZHFTN requires only the array and its dimensions.
C
      CALL EZHFTN (Z,21,25)
C
C
C     Frame 2 -- The HAFTON entry with user selectable parameters.
C
C   Add a plot title.
C
      CALL PLCHLQ (TX,TY,
     1      'DEMONSTRATION PLOT FOR ENTRY HAFTON OF HAFTON',16.,0.,-1.)
C
C Entry HAFTON allows user specification of plot parameters.
C
      CALL HAFTON (Z,21,21,25,FLO,FHI,NLEV,NOPT,0,0,0.)
      CALL FRAME
C
      WRITE (6,1001)
      RETURN
C
 1001 FORMAT (' HAFTON TEST EXECUTED--SEE PLOTS TO CERTIFY')
C
      END

C
C	$Id: conpms.f,v 1.5 2008-07-27 00:23:01 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CONPMS (SCRARR)
C
C THIS ROUTINE FINDS RELATIVE MINIMUMS AND MAXIMUMS.  A RELATIVE MINIMUM
C (OR MAXIMUM) IS DEFINED TO BE THE LOWEST (OR HIGHEST) POINT WITHIN
C A CERTAIN NEIGHBORHOOD OF THE POINT.  THE NEIGHBORHOOD USED HERE
C IS + OR - IXRG IN THE X DIRECTION AND + OR - IYRG IN THE Y DIRECTION.
C
C
C
      COMMON /CONRA1/ CL(30)     ,NCL        ,OLDZ       ,PV(210)    ,
     1                FINC       ,HI         ,FLO
      COMMON /CONRA2/ REPEAT     ,EXTRAP     ,PER        ,MESS       ,
     1                ISCALE     ,LOOK       ,PLDVLS     ,GRD        ,
     2                CINC       ,CHILO      ,CON        ,LABON      ,
     3                PMIMX      ,SCALE      ,FRADV      ,EXTRI      ,
     4                BPSIZ      ,LISTOP
      COMMON /CONRA3/ IREC
      COMMON /CONRA4/ NCP        ,NCPSZ
      COMMON /CONRA5/ NIT        ,ITIPV
      COMMON /CONRA6/ XST        ,YST        ,XED        ,YED        ,
     1                STPSZ      ,IGRAD      ,IG         ,XRG        ,
     2                YRG        ,BORD       ,PXST       ,PYST       ,
     3                PXED       ,PYED       ,ITICK
      COMMON /CONR18/ TITLE      ,ICNT   ,ITLSIZ
      COMMON /CONR19/ IHIGH      ,INMAJ      ,INLAB      ,INDAT      ,
     1              LEN      ,IFMT       ,LEND       ,
     2                IFMTD      ,ISIZEP     ,INMIN
      COMMON /CONRA9/ ICOORD(500),NP         ,MXXY       ,TR         ,
     1                BR         ,TL         ,BL         ,CONV       ,
     2                XN         ,YN         ,ITLL       ,IBLL       ,
     3                ITRL       ,IBRL       ,XC         ,YC         ,
     4                ITLOC(210) ,JX         ,JY         ,ILOC       ,
     5                ISHFCT     ,XO         ,YO         ,IOC        ,NC
      COMMON /CONR10/ NT         ,NL         ,NTNL       ,JWIPT      ,
     1                JWIWL      ,JWIWP      ,JWIPL      ,IPR        ,
     2                ITPV
      COMMON /CONR20/ NREP       ,NCRT       ,ISIZEL     ,
     1                MINGAP     ,ISIZEM         ,
     2                TENS
      COMMON /CONR12/ IXMAX      ,IYMAX      ,XMAX       ,YMAX
      LOGICAL         REPEAT     ,EXTRAP     ,PER        ,MESS       ,
     1                LOOK       ,PLDVLS     ,GRD        ,LABON      ,
     2                PMIMX      ,FRADV      ,EXTRI      ,CINC       ,
     3                TITLE      ,LISTOP     ,CHILO      ,CON
      COMMON /CONR15/ ISTRNG
        CHARACTER*64 ISTRNG
        COMMON /CONR16/ FORM
        CHARACTER*10 FORM
        COMMON /CONR17/ NDASH, IDASH, EDASH
        CHARACTER*10 NDASH, IDASH, EDASH
C
C
C
      DIMENSION SCRARR(*)
        CHARACTER*10    IA
C
        SAVE
C
C  CONVERT FROM 0-32767 TO 1-1024
C
        DATA ICONV/32/
C
C  ACCESSING FUNCTION INTO SCRARR
C
      SCRTCH(IXX,IYY) = SCRARR(IYY+(IXX-1)*IYMAX)
C
C  GRAPHICS MAPPING FUNCTIONS
C
C     FX(XXX,YYY) = XXX
C     FY(XXX,YYY) = YYY
C
C  MAPPING FROM INTEGER TO USER INPUT FLOATING POINT
C
      CONVX(IXX) = XST + REAL(IXX-1)*STPSZ
      CONVY(IYY) = YST + REAL(IYY-1)*STPSZ
C
C  SET INTENSITY TO HIGH
C
      IF (INDAT .NE. 1 ) THEN
            CALL GSTXCI(INDAT)
        ELSE
            CALL GSTXCI (IRASTX)
        ENDIF
C
C  COMPUTE THE SEARCH RANGE FOR MIN AND MAX DETERMINATION
C
      IXRG = MIN(15,MAX(2,INT(REAL(IXMAX)/8.)))
      IYRG = MIN(15,MAX(2,INT(REAL(IYMAX)/8.)))
C
C  LOOP THROUGH ALL ROWS OF THE DATA SEARCHING FOR AN IMMEDIATE MIN OR
C  MAX.
C
      IX = 1
C
C  SCAN A ROW
C
C  IF EXTRAPOLATING DONT LIMIT ROW SCANS
C
   10 IF (.NOT.EXTRAP) GO TO    20
      IYST = 1
      IYED = IYMAX
      IY = 1
      GO TO    30
C
C  NOT EXTRAPOLATING STAY IN HULL BOUNDRIES
C
   20 IYST = ITLOC(IX*2-1)
      IYED = ITLOC(IX*2)
      IF (IYST.EQ.0) GO TO   240
      IY = IYST
   30 VAL = SCRTCH(IX,IY)
C
C  SEARCH FOR A MIN
C
C
C  BRANCH IF NOT FIRST ON A ROW
C
      IF (IY.NE.IYST) GO TO    40
      IF (VAL.GE.SCRTCH(IX,IY+1)) GO TO   130
      IF (VAL.GE.SCRTCH(IX,IY+2)) GO TO   130
      GO TO    60
C
C  BRANCH IF NOT LAST ON ROW
C
   40 IF (IY.NE.IYED) GO TO    50
      IF (VAL.GE.SCRTCH(IX,IY-1)) GO TO   140
      IF (VAL.GE.SCRTCH(IX,IY-2)) GO TO   140
      GO TO    60
C
C  IN MIDDLE OF ROW
C
   50 IF (VAL.GE.SCRTCH(IX,IY+1)) GO TO   150
      IF (VAL.GE.SCRTCH(IX,IY-1)) GO TO   150
C
C  POSSIBLE MIN FOUND SEARCH NEIGHBORHOOD
C
   60 IXST = MAX(1,IX-IXRG)
      IXSTOP = MIN(IXMAX,IX+IXRG)
C
C IF NOT EXTRAPOLATING BRANCH
C
   70 IF (.NOT.EXTRAP) GO TO    80
      IYSRS = 1
      IYSRE = IYMAX
      GO TO    90
C
C  NOT EXTRAPOLATING STAY IN CONVEX HULL
C
   80 IYSRS = ITLOC(IXST*2-1)
      IYSRE = ITLOC(IXST*2)
      IF (IYSRS.EQ.0) GO TO   120
C
   90 IYSRS = MAX(IYSRS,IY-IYRG)
      IYSRE = MIN(IYSRE,IY+IYRG)
C
  100 CUR = SCRTCH(IXST,IYSRS)
      IF (VAL.LT.CUR) GO TO   110
      IF (VAL.GT.CUR) GO TO   230
      IF (IX.EQ.IXST .AND. IY.EQ.IYSRS) GO TO   110
      GO TO   230
C
C  SUCCESS SO FAR TRY NEXT SPACE
C
  110 IYSRS = IYSRS+1
      IF (IYSRS.LE.IYSRE) GO TO   100
  120 IXST = IXST+1
      IF (IXST.LE.IXSTOP) GO TO    70
C
C  SUCCESS, WE HAVE FOUND A RELATIVE MIN
C
      X = CONVX(IX)
      Y = CONVY(IY)
      X1 = FX(X,Y)
      CALL FL2INT (X1,FY(X,Y),MX,MY)
      MX = MX/ICONV
      MY = MY/ICONV
C
C  POSITION STRINGS PROPERLY IF COORDS ARE IN PAU'S
C
C
C
      XC = CPUX(MX)
      YC = CPUY(MY)
      CALL PWRTM(XC,YC,'L',ISIZEM,0,0)
C
C
      CALL CONECD (VAL,IA,NC)
      MY = MY - 2*ISIZEM
C
C  POSITION STRINGS PROPERLY IF COORDS ARE IN PAU'S
C
C
C
      YC = CPUY(MY)
      CALL PWRTM(XC,YC,IA(1:NC),ISIZEM,0,0)
C
C
      GO TO   230
C
C  SEARCH FOR A LOCAL MAXIMUM
C
C  IF FIRST LOC ON A ROW
C
  130 IF (VAL.LE.SCRTCH(IX,IY+1)) GO TO   230
      IF (VAL.LE.SCRTCH(IX,IY+2)) GO TO   230
      GO TO   160
C
C  IF LAST ON ROW
C
  140 IF (VAL.LE.SCRTCH(IX,IY-1)) GO TO   230
      IF (VAL.LE.SCRTCH(IX,IY-2)) GO TO   230
      GO TO   160
C
C  IN MIDDLE OF ROW
C
  150 IF (VAL.LE.SCRTCH(IX,IY+1)) GO TO   230
      IF (VAL.LE.SCRTCH(IX,IY-1)) GO TO   230
C
C  POSSIBLE MIN FOUND SEARCH NEIGHBORHOOD
C
  160 IXST = MAX(1,IX-IXRG)
      IXSTOP = MIN(IXMAX,IX+IXRG)
  170 IF (.NOT.EXTRAP) GO TO   180
      IYSRS = 1
      IYSRE = IYMAX
      GO TO   190
C
C  NOT EXTRAPOLATING STAY IN CONVEX HULL
C
  180 IYSRS = ITLOC(IXST*2-1)
      IYSRE = ITLOC(IXST*2)
      IF (IYSRS.EQ.0) GO TO   220
C
  190 IYSRS = MAX(IYSRS,IY-IYRG)
      IYSRE = MIN(IYSRE,IY+IYRG)
C
  200 CUR = SCRTCH(IXST,IYSRS)
      IF (VAL.GT.CUR) GO TO   210
      IF (VAL.LT.CUR) GO TO   230
      IF (IX.EQ.IXST .AND. IY.EQ.IYSRS) GO TO   210
      GO TO   230
C
C  SUCCESS SO FAR TRY NEXT SPACE
C
  210 IYSRS = IYSRS+1
      IF (IYSRS.LE.IYSRE) GO TO   200
  220 IXST = IXST+1
      IF (IXST.LE.IXSTOP) GO TO   170
C
C  SUCCESS WE HAVE A MAXIMUM
C
      X = CONVX(IX)
      Y = CONVY(IY)
      X1 = FX(X,Y)
      CALL FL2INT (X1,FY(X,Y),MX,MY)
      MX = MX/ICONV
      MY = MY/ICONV
C
C  POSITION STRINGS PROPERLY IF COORDS ARE IN PAU'S
C
C
C
      XC = CPUX(MX)
      YC = CPUY(MY)
      CALL PWRTM(XC,YC,'H',ISIZEM,0,0)
C
C
      CALL CONECD (VAL,IA,NC)
      MY = MY - 2*ISIZEM
C
C  POSITION STRINGS PROPERLY IF COORDS ARE IN PAU'S
C
C
C
      YC = CPUY(MY)
      CALL PWRTM(XC,YC,IA(1:NC),ISIZEM,0,0)
C
C
C  END OF SEARCH AT THIS LOCATION TRY NEXT
C
  230 IY = IY+1
      IF (IY.LE.IYED) GO TO    30
  240 IX = IX+1
      IF (IX.LE.IXMAX) GO TO    10
C
C
      RETURN
C
C******************************************************************
C*                                                                *
C*                   REVISION HISTORY                             *
C*                                                                *
C*  JUNE 1980   ADDED CONRAN TO ULIB                              *
C*  AUGUST 1980 CHANGED ACCESS CARD DOCUMENTATION                 *
C*  DECEMBER 1980 MODIFIED COMMENT CARD DOCUMENTATION             *
C*  MARCH 1983  ADDED ASPECT RATIO ERROR                          *
C*  JULY 1983  ADDED SHIELDING AND LINEAR INTERPOLATION           *
C*             REMOVED 7600 ACCESS CARDS                          *
C*  JULY 1984  CONVERTED TO STANDARD FORTRAN77 AND GKS        *
C*  JUNE 1988   CHANGED THREE COMMON BLOCK NAMES TO GET RID OF    *
C*              WARNING MESSAGES FROM SEGLDR ON THE CRAY          *
C*  MARCH 1990  CORRECTED USE OF SET CALLS                        *
C*                                                                *
C******************************************************************
C
      END

C
C	$Id: gzdawk.f,v 1.4 2008-07-27 00:21:03 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GZDAWK(WKID)
C
C  DEACTIVATE WORKSTATION
C
      INTEGER EDAWK
      PARAMETER (EDAWK=5)
C
      include 'gkscom.h'
C
      INTEGER WKID
C
C  Check that GKS is in the proper state.
C
      CALL GZCKST(3,EDAWK,IER)
      IF (IER .NE. 0) RETURN
C
C  Check if the workstation identifier is valid.
C
      CALL GZCKWK(20,EDAWK,WKID,IDUM,IER)
      IF (IER .NE. 0) RETURN
C
C  Check if the workstation is currently active.
C
      CALL GZCKWK(30,EDAWK,WKID,IDUM,IER)
      IF (IER .NE. 0) RETURN
C
C  Invoke the workstation interface so that the workstation
C  can be marked inactive in the workstation state list.
C
C  Set the flag CUFLAG to indicate that the interface call should go
C  only to the specifically designated workstation.
C
      CUFLAG = WKID
      FCODE = -1
      CONT  = 0
      CALL GZROI(0)
      IL1 = 1
      IL2 = 1
      ID(1) = WKID
      CALL GZTOWK
      IF (RERR.NE.0) THEN
        ERS = 1
        CALL GERHND(RERR,EDAWK,ERF)
        ERS = 0
      ENDIF
      CUFLAG = -1
C
C  Delete the workstation ID from the set of active workstations.
C
      IF (NACWK .EQ. 1) THEN
        SACWK(1) = -1
        NACWK = 0
      ELSE
        DO 201 I=1,NACWK
          IF (SACWK(I) .EQ. WKID) THEN
            IF (I .EQ. NACWK) THEN
              SACWK(NACWK) = -1
              NACWK = NACWK-1
            ELSE
              NM1 = NACWK-1
              DO 202 J=I,NM1
                SACWK(J) = SACWK(J+1)
  202         CONTINUE
              SACWK(NACWK) = -1
              NACWK = NACWK-1
            ENDIF
          ENDIF
  201   CONTINUE
      ENDIF
C
C
C  Set the GKS operating state to workstation open if there are
C  no active workstations.
C
      IF (NACWK .EQ. 0) THEN
        OPS = GWSOP
      ENDIF
C
      RETURN
      END

C
C	$Id: csstrid.f,v 1.5 2008-07-27 03:10:08 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CSSTRID(N,RLATI,RLONI,NT,NTRI,IWK,WK,IER)
      DOUBLE PRECISION RLATI(N),RLONI(N)
      DOUBLE PRECISION WK(*)
C
      DOUBLE PRECISION UN
      INTEGER N,NT,NTRI(3,*),IWK(*),IER
C
C  Parameters for random number usage.
C
      INTEGER CSJRAND
      PARAMETER (EPSILON=0.00001D0,IRMAX=32767)
      PARAMETER (D2R=0.017453293D0)
      DATA IX,IY,IZ/1,2,3/

C
C***********************************************************
C
C                              Simplified STRIPACK interface
C                                                 Fred Clare
C                                                       NCAR
C                                                   12/10/99
C
C   This subroutine provides a simplified interface to
C STRIPACK triangulation, at the expense of requiring a
C little extra storage.
C
C On input:
C
C       N = Number of nodes in the triangulation.  N .GE. 3.
C
C    RLATI,RLONI = Arrays containing lat/lon coordinates of the nodes,
C                  in degrees.  The first three nodes must not be col-
C                  linear (lie on a common great circle).
C
C       NTRI =  A two-dimensional integer array dimensioned
C               for 3 x NT where NT is the number of triangles
C               in the triangulation (NT is at most 2*N).
C
C       IWK  =  An integer workspace of length 27*N.
C
C       WK   =  A *double precision* workspace of length 13*N.
C
C On output:
C
C       NT   = Number of triangles in the triangulation unless
C              IER .NE. 0, in which case NT = 0.  NT = 2N-NB-2
C              if NB .GE. 3 or 2N-4 if NB = 0, where NB is the
C              number of boundary nodes.
C
C       NTRI = The nodes for the triangles in the triangulation.
C              The nodes for the Jth triangle are NTRI(1,J),
C              NTRI(2,J) and NTRI(3,J) where node I references
C              the coordinate (X(I),Y(I),Z(I)).
C
C       IER = Error indicator:
C                =  0 - no error.
C                =  1 - invalid number of input points (must be
C                       greater than 3).
C                =  4 - first three nodes are collinear.
C                =  6 - internal algorithm error - please report this.
C                = 10 - insufficient space for the triangulation
C                       (must be >= number of boundary nodes minus 2).
C                = 11 - degenerate triangle (two vertices lie on
C                       same geodesic).
C                = -L - coordinates L and M coincide for some
C                       M  > L >= 1 (coordinate numbering
C                       starting at 1).
C
C Modules required by CSSTRI:  CSTRMESH, CSTRLIST
C
C***********************************************************
C
C  Do a call forcing a BLOCKDATA to be loaded from a binary library.
C
      CALL CSBLDA
C
      IF (N .LT. 4) THEN
          IER = 1
          GO TO 200
      ENDIF
C
C  Convert RLATI and RLONI to radians.
C
      DO 7 I=1,N
        WK(4*N+I) = D2R*RLATI(I)
        WK(5*N+I) = D2R*RLONI(I)
    7 CONTINUE
C
C  Then convert to Cartesian coordinates.
C
      CALL CSTRANSD(N,WK(4*N+1),WK(5*N+1),WK(N+1),WK(2*N+1),WK(3*N+1))
C
C  Introduce a random perturbation in the 5th decimal place
C  to avoid duplicate input points.  The original input points
C  are copied into the real workspace so that they will not be
C  tampered with.
C
      DO 300 I = 1,N
          WK(  N+I) = DBLE(WK(  N+I) + EPSILON* (0.5-
     +                DBLE(CSJRAND(IRMAX,IX,IY,IZ)/DBLE(IRMAX))))
          WK(2*N+I) = DBLE(WK(2*N+I) + EPSILON* (0.5-
     +                DBLE(CSJRAND(IRMAX,IX,IY,IZ)/DBLE(IRMAX))))
          WK(3*N+I) = DBLE(WK(3*N+I) + EPSILON* (0.5-
     +                DBLE(CSJRAND(IRMAX,IX,IY,IZ)/DBLE(IRMAX))))
C
C  Renormalize the vector so that it is still a unit vector.
C
          UN = WK(N+I)**2
          UN = UN + WK(2*N+I)**2
          UN = UN + WK(3*N+I)**2
          UN = SQRT(UN)
          WK(N+I) = 0.99999D0*WK(N+I)/UN
          WK(2*N+I) = 0.99999D0*WK(2*N+I)/UN
          WK(3*N+I) = 0.99999D0*WK(3*N+I)/UN
  300 CONTINUE
C
C  Triangulate.
C
      CALL CSTRMESH(N,WK(N+1),WK(2*N+1),WK(3*N+1),IWK(1),IWK(6*N+1),
     +              IWK(12*N+1),LNEW,IWK(13*N+1),IWK(14*N+1),WK(1),IER)       
      IF (IER.EQ.0) THEN
          GO TO 210
      ELSE IF (IER.EQ.-1) THEN
          IER = 1
          GO TO 200
      ELSE IF (IER.EQ.-2) THEN
          IER = 4
          GO TO 200
      ELSE IF (IER.EQ.-3) THEN
          IER = 6
          GO TO 200
      ELSE IF (IER.GT.0) THEN
          IER = -IER
          GO TO 200
      ELSE
          IER = 6
          GO TO 200
      END IF
C
  210 CONTINUE
C
C  Determine the triangle nodes.
C
      CALL CSTRLIST(N,IWK(1),IWK(6*N+1),IWK(12*N+1),6,NT,IWK(15*N+1),
     +              IER)
      IF (IER.NE.0) THEN
          NT = 0
          IER = 6
          GO TO 200
      END IF
C
C  Copy off the triangle nodes and return.
C
      DO 10 J = 1,NT
          NTRI(1,J) = IWK(15*N+6* (J-1)+1)
          NTRI(2,J) = IWK(15*N+6* (J-1)+2)
          NTRI(3,J) = IWK(15*N+6* (J-1)+3)
   10 CONTINUE
C
      RETURN
C
  200 CONTINUE
      CALL CSSERR('CSSTRID',IER)
      NT = 0
      RETURN
C
      END

C
C	$Id: ezcntr.f,v 1.4 2008-07-27 00:23:01 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE EZCNTR (Z,M,N)
      SAVE
      DIMENSION       Z(M,N)
C
C CONTOURING VIA SHORTEST POSSIBLE ARGUMENT LIST
C ASSUMPTIONS --
C     ALL OF THE ARRAY IS TO BE CONTOURED,
C     CONTOUR LEVELS ARE PICKED INTERNALLY,
C     CONTOURING ROUTINE PICKS SCALE FACTORS,
C     HIGHS AND LOWS ARE MARKED,
C     ALL LINES ARE DRAWN WITH A SOLID DASH-LINE PATTERN.
C     EZCNTR CALLS FRAME AFTER DRAWING THE CONTOUR MAP.
C IF THESE ASSUMPTIONS ARE NOT MET, USE CONREC.
C
C ARGUMENTS
C     Z   ARRAY TO BE CONTOURED
C     M   FIRST DIMENSION OF Z
C     N   SECOND DIMENSION OF Z
C***CRAYLIB HAS THIS BLANK COMMENT
C
      DATA NSET,NHI,NDASH/0,0,0/
C
C***CRAYLIB HAS THIS BLANK COMMENT
C THE FOLLOWING CALL IS FOR GATHERING STATISTICS ON LIBRARY USE AT NCAR
C
      CALL Q8QST4 ('GRAPHX','CONRECQCK','EZCNTR','VERSION 01')
C
C***CRAYLIB HAS THIS BLANK COMMENT
C
      CALL CONREC (Z,M,M,N,0.,0.,0.,NSET,NHI,NDASH)
      CALL FRAME
      RETURN
      END

      PROGRAM CCPCIT
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER (K=40,N=40,LRWK=1000,LIWK=1000)
      REAL Z(K,N), RWRK(LRWK)
      INTEGER M, IWRK(LIWK)
      DIMENSION CIT(10),LIT(10)
      
      DATA CIT /1.,2.,3.,4.,5.,6.,7.,8.,9.,0./
      DATA LIT /2, 2, 2, 2, 2, 2, 2, 2, 2, 0 /
      
      CALL GETDAT (Z, K, M, N) 
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Change nice values to be steps of 1/3. (1/3, 2/3, 3/3...)
C     Draw labels at every 5th contour level no matter which contour
C level interval is chosen.
C
      DO 101 I=1,10
         CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',I)
         CALL CPSETR ('CIT - CONTOUR INTERVAL TABLE',CIT(I))
         CALL CPSETI ('LIT - LABEL INTERVAL TABLE',LIT(I))
 101  CONTINUE
C
C Initialize Conpack
C
      CALL CPRECT(Z,K,M,N,RWRK,LRWK,IWRK,LIWK)
C
C Draw perimeter
C
      CALL CPBACK(Z, RWRK, IWRK)
C
C Draw Contours
C
      CALL CPCLDR(Z,RWRK,IWRK)
C
C Close frame
C
      CALL FRAME
C
C Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      
      STOP
      END
      
      SUBROUTINE GETDAT (Z, K, M, N)
      INTEGER I,J,K,M,N
      REAL Z(K,N)
      
      M=K
      DO 10, I=1,M
         DO 20, J=1,N
            Z(I,J)= 10.E-5*(-16.*REAL(I**2*J) +
     1           34*REAL(I*J**2) - REAL(6*I) + 93.)
 20      CONTINUE
 10   CONTINUE
      
      RETURN
      END

        PROGRAM PPEX01
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
        PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Declare arrays in which to define the clip polygon and the subject
C polygon.
C
        DIMENSION XCCP(5),YCCP(5),XCSP(11),YCSP(11)
C
C Declare the required work arrays.
C
        PARAMETER (NWRK=999)
C
        DIMENSION RWRK(NWRK),IWRK(NWRK)
C 
C The EQUIVALENCE line is commented out below. If memory storage is an
C issue for you, *and* RWRK is not a DOUBLE PRECISION variable, then you
C can uncomment this line.
C
C        EQUIVALENCE (RWRK(1),IWRK(1))
C
C Tell the compiler that the fill and merge routines for polygons and
C the fill routine for trapezoids are EXTERNALs, not REALs.
C
        EXTERNAL FILLPO,MERGPO,FILLTR
C
C Merge polygons are formed in the common block MERGCM:
C
        COMMON /MERGCM/ XCMP(999),YCMP(999),NCMP
        SAVE   /MERGCM/
C
C Define the clip polygon to be a small square.
C
        DATA NCCP / 5 /
C
        DATA XCCP( 1),YCCP( 1) / -5. , -5. /
        DATA XCCP( 2),YCCP( 2) /  5. , -5. /
        DATA XCCP( 3),YCCP( 3) /  5. ,  5. /
        DATA XCCP( 4),YCCP( 4) / -5. ,  5. /
        DATA XCCP( 5),YCCP( 5) / -5. , -5. /
C
C Define the subject polygon to be a diamond with a hole in it.
C
        DATA NCSP / 11 /
C
        DATA XCSP( 1),YCSP( 1) /  0. ,  9. /
        DATA XCSP( 2),YCSP( 2) /  0. ,  6. /
        DATA XCSP( 3),YCSP( 3) /  6. ,  0. /
        DATA XCSP( 4),YCSP( 4) /  0. , -6. /
        DATA XCSP( 5),YCSP( 5) / -6. ,  0. /
        DATA XCSP( 6),YCSP( 6) /  0. ,  6. /
        DATA XCSP( 7),YCSP( 7) /  0. ,  9. /
        DATA XCSP( 8),YCSP( 8) / -9. ,  0. /
        DATA XCSP( 9),YCSP( 9) /  0. , -9. /
        DATA XCSP(10),YCSP(10) /  9. ,  0. /
        DATA XCSP(11),YCSP(11) /  0. ,  9. /
C
C Open GKS.
C
        CALL GOPKS (IERRF, ISZDM)
        CALL GOPWK (IWKID, LUNIT, IWTYPE)
        CALL GACWK (IWKID)
C
C Enable solid fill instead of the default hollow fill.
C
        CALL GSFAIS (1)
C
C Turn off clipping by GKS.
C
        CALL GSCLIP (0)
C
C Tell GKS to use a doubled line width.
C
        CALL GSLWSC (2.)
C
C Define some colors to use for various purposes.
C
        CALL GSCR   (IWKID,0,0.,0.,0.)
        CALL GSCR   (IWKID,1,1.,1.,1.)
        CALL GSCR   (IWKID,2,1.,0.,0.)
        CALL GSCR   (IWKID,3,0.,1.,0.)
        CALL GSCR   (IWKID,4,0.,0.,1.)
        CALL GSCR   (IWKID,5,1.,0.,1.)
C
C Define the mapping from the user system to the fractional system.
C
        CALL SET (.05,.95,.05,.95,-10.,10.,-10.,10.,1)
C
C Tell PLOTCHAR to use filled characters from font 25.
C
        CALL PCSETI ('FN - FONT NUMBER',25)
C
C Fill the polygons representing the difference of the clip polygon
C and the subject polygon.
C
        CALL PLCHHQ (CFUX(.5),CFUY(.96),
     +               'POLYPACK EXAMPLE - FRAME 1',.018,0.,0.)
C
        CALL PLCHHQ (CFUX(.5),CFUY(.93),
     +  'Difference polygon formed using routines PPDIPO and FILLPO.',
     +                                                      .0175,0.,0.)
C
        CALL PLCHHQ (CFUX(.5),CFUY(.07),'The subject polygon S is outlin
     +ed in green and the clip polygon C in red.',
     +                                                      .0148,0.,0.)
C
        CALL PLCHHQ (CFUX(.5),CFUY(.04),'The difference S-C is filled in
     + white.',
     +                                                      .0148,0.,0.)
C
        CALL PPDIPO (XCCP,YCCP,NCCP,XCSP,YCSP,NCSP,
     +                  RWRK,IWRK,NWRK,FILLPO,IERR)
C
        IF (IERR.NE.0) PRINT * , 'PPDIPO RETURNS IERR = ',IERR
C
        CALL GSPLCI (3)
        CALL GPL    (NCSP,XCSP,YCSP)
        CALL GSPLCI (2)
        CALL GPL    (NCCP,XCCP,YCCP)
        CALL GSPLCI (1)
C
        CALL FRAME
C
C Fill the polygons representing the intersection of the clip polygon
C and the subject polygon.
C
        CALL PLCHHQ (CFUX(.5),CFUY(.96),
     +               'POLYPACK EXAMPLE - FRAME 2',.018,0.,0.)
C
        CALL PLCHHQ (CFUX(.5),CFUY(.93),
     +  'Intersection polygon formed using routines PPINPO and FILLPO.',
     +                                                      .0175,0.,0.)
C
        CALL PLCHHQ (CFUX(.5),CFUY(.07),'The subject polygon S is outlin
     +ed in green and the clip polygon C in red.',
     +                                                      .0148,0.,0.)
C
        CALL PLCHHQ (CFUX(.5),CFUY(.04),'The intersection S:F34:G:F:C is
     + filled in white.',
     +                                                      .0148,0.,0.)
C
        CALL PPINPO (XCCP,YCCP,NCCP,XCSP,YCSP,NCSP,
     +                  RWRK,IWRK,NWRK,FILLPO,IERR)
C
        IF (IERR.NE.0) PRINT * , 'PPINPO RETURNS IERR = ',IERR
C
        CALL GSPLCI (3)
        CALL GPL    (NCSP,XCSP,YCSP)
        CALL GSPLCI (2)
        CALL GPL    (NCCP,XCCP,YCCP)
        CALL GSPLCI (1)
C
        CALL FRAME
C
C Fill the polygons representing the union of the clip polygon
C and the subject polygon.
C
        CALL PLCHHQ (CFUX(.5),CFUY(.96),
     +               'POLYPACK EXAMPLE - FRAME 3',.018,0.,0.)
C
        CALL PLCHHQ (CFUX(.5),CFUY(.93),
     +  'Union polygon formed using routines PPUNPO and FILLPO.',
     +                                                      .0175,0.,0.)
C
        CALL PLCHHQ (CFUX(.5),CFUY(.07),'The subject polygon S is outlin
     +ed in green and the clip polygon C in red.',
     +                                                      .0148,0.,0.)
C
        CALL PLCHHQ (CFUX(.5),CFUY(.04),'The union S:F34:H:F:C is filled
     + in white.  Using FILLPO results in three errors; compare with fra
     +me 6.',
     +                                                      .0148,0.,0.)
C
        CALL PPUNPO (XCCP,YCCP,NCCP,XCSP,YCSP,NCSP,
     +                  RWRK,IWRK,NWRK,FILLPO,IERR)
C
        IF (IERR.NE.0) PRINT * , 'PPUNPO RETURNS IERR = ',IERR
C
        CALL GSPLCI (3)
        CALL GPL    (NCSP,XCSP,YCSP)
        CALL GSPLCI (2)
        CALL GPL    (NCCP,XCCP,YCCP)
        CALL GSPLCI (1)
C
        CALL FRAME
C
C Merge the polygons representing the difference of the clip polygon
C and the subject polygon and fill the result.
C
        CALL PLCHHQ (CFUX(.5),CFUY(.96),
     +               'POLYPACK EXAMPLE - FRAME 4',.018,0.,0.)
C
        CALL PLCHHQ (CFUX(.5),CFUY(.93),
     +  'Difference polygon formed using routines PPDIPO and MERGPO.',
     +                                                      .0175,0.,0.)
C
        CALL PLCHHQ (CFUX(.5),CFUY(.07),'The subject polygon S is outlin
     +ed in green and the clip polygon C in red.',
     +                                                      .0148,0.,0.)
C
        CALL PLCHHQ (CFUX(.5),CFUY(.04),'The difference S-C is filled in
     + white.',
     +                                                      .0148,0.,0.)
C
        NCMP=0
C
        CALL PPDIPO (XCCP,YCCP,NCCP,XCSP,YCSP,NCSP,
     +                  RWRK,IWRK,NWRK,MERGPO,IERR)
C
        IF (IERR.NE.0) PRINT * , 'PPDIPO RETURNS IERR = ',IERR
C
        IF (NCMP.EQ.0) THEN
          PRINT * , 'MERGE POLYGON IS NULL'
        ELSE IF (NCMP.EQ.1000) THEN
          PRINT * , 'MERGE POLYGON WAS TOO BIG TO HANDLE'
        ELSE
          CALL GFA (NCMP-1,XCMP,YCMP)
        END IF
C
        CALL GSPLCI (3)
        CALL GPL    (NCSP,XCSP,YCSP)
        CALL GSPLCI (2)
        CALL GPL    (NCCP,XCCP,YCCP)
        CALL GSPLCI (1)
C
        CALL FRAME
C
C Merge the polygons representing the intersection of the clip polygon
C and the subject polygon and fill the result.
C
        CALL PLCHHQ (CFUX(.5),CFUY(.96),
     +               'POLYPACK EXAMPLE - FRAME 5',.018,0.,0.)
C
        CALL PLCHHQ (CFUX(.5),CFUY(.93),
     +  'Intersection polygon formed using routines PPINPO and MERGPO.',
     +                                                      .0175,0.,0.)
C
        CALL PLCHHQ (CFUX(.5),CFUY(.07),'The subject polygon S is outlin
     +ed in green and the clip polygon C in red.',
     +                                                      .0148,0.,0.)
C
        CALL PLCHHQ (CFUX(.5),CFUY(.04),'The intersection S:F34:G:F:C is
     + filled in white.',
     +                                                      .0148,0.,0.)
C
        NCMP=0
C
        CALL PPINPO (XCCP,YCCP,NCCP,XCSP,YCSP,NCSP,
     +                  RWRK,IWRK,NWRK,MERGPO,IERR)
C
        IF (IERR.NE.0) PRINT * , 'PPINPO RETURNS IERR = ',IERR
C
        IF (NCMP.EQ.0) THEN
          PRINT * , 'MERGE POLYGON IS NULL'
        ELSE IF (NCMP.EQ.1000) THEN
          PRINT * , 'MERGE POLYGON WAS TOO BIG TO HANDLE'
        ELSE
          CALL GFA (NCMP-1,XCMP,YCMP)
        END IF
C
        CALL GSPLCI (3)
        CALL GPL    (NCSP,XCSP,YCSP)
        CALL GSPLCI (2)
        CALL GPL    (NCCP,XCCP,YCCP)
        CALL GSPLCI (1)
C
        CALL FRAME
C
C Merge the polygons representing the union of the clip polygon
C and the subject polygon and fill the result.
C
        CALL PLCHHQ (CFUX(.5),CFUY(.96),
     +               'POLYPACK EXAMPLE - FRAME 6',.018,0.,0.)
C
        CALL PLCHHQ (CFUX(.5),CFUY(.93),
     +  'Union polygon formed using routines PPUNPO and MERGPO.',
     +                                                      .0175,0.,0.)
C
        CALL PLCHHQ (CFUX(.5),CFUY(.07),'The subject polygon S is outlin
     +ed in green and the clip polygon C in red.',
     +                                                      .0148,0.,0.)
C
        CALL PLCHHQ (CFUX(.5),CFUY(.04),'The union S:F34:H:F:C is filled
     + in white; using MERGPO fixes the errors seen on frame 3.',
     +                                                      .0148,0.,0.)
C
        NCMP=0
C
        CALL PPUNPO (XCCP,YCCP,NCCP,XCSP,YCSP,NCSP,
     +                  RWRK,IWRK,NWRK,MERGPO,IERR)
C
        IF (IERR.NE.0) PRINT * , 'PPUNPO RETURNS IERR = ',IERR
C
        IF (NCMP.EQ.0) THEN
          PRINT * , 'MERGE POLYGON IS NULL'
        ELSE IF (NCMP.EQ.1000) THEN
          PRINT * , 'MERGE POLYGON WAS TOO BIG TO HANDLE'
        ELSE
          CALL GFA (NCMP-1,XCMP,YCMP)
        END IF
C
        CALL GSPLCI (3)
        CALL GPL    (NCSP,XCSP,YCSP)
        CALL GSPLCI (2)
        CALL GPL    (NCCP,XCCP,YCCP)
        CALL GSPLCI (1)
C
        CALL FRAME
C
C Fill the trapezoids representing the difference of the clip polygon
C and the subject polygon.
C
        CALL PLCHHQ (CFUX(.5),CFUY(.96),
     +               'POLYPACK EXAMPLE - FRAME 7',.018,0.,0.)
C
        CALL PLCHHQ (CFUX(.5),CFUY(.93),
     +  'Difference polygon formed using routines PPDITR and FILLTR.',
     +                                                      .0175,0.,0.)
C
        CALL PLCHHQ (CFUX(.5),CFUY(.07),'The subject polygon S is outlin
     +ed in green, the clip polygon C in red, trapezoid edges in blue.',
     +                                                      .0148,0.,0.)
C
        CALL PLCHHQ (CFUX(.5),CFUY(.04),'The trapezoids comprising the d
     +ifference S-C are filled in white.',
     +                                                      .0148,0.,0.)
C
        CALL GSPLCI (4)
        CALL PPDITR (XCCP,YCCP,NCCP,XCSP,YCSP,NCSP,
     +                  RWRK,IWRK,NWRK,FILLTR,IERR)
C
        IF (IERR.NE.0) PRINT * , 'PPDITR RETURNS IERR = ',IERR
C
        CALL GSPLCI (3)
        CALL GPL    (NCSP,XCSP,YCSP)
        CALL GSPLCI (2)
        CALL GPL    (NCCP,XCCP,YCCP)
        CALL GSPLCI (1)
C
        CALL FRAME
C
C Fill the trapezoids representing the intersection of the clip polygon
C and the subject polygon.
C
        CALL PLCHHQ (CFUX(.5),CFUY(.96),
     +               'POLYPACK EXAMPLE - FRAME 8',.018,0.,0.)
C
        CALL PLCHHQ (CFUX(.5),CFUY(.93),
     +  'Intersection polygon formed using routines PPINTR and FILLTR.',
     +                                                      .0175,0.,0.)
C
        CALL PLCHHQ (CFUX(.5),CFUY(.07),'The subject polygon S is outlin
     +ed in green, the clip polygon C in red, trapezoid edges in blue.',
     +                                                      .0148,0.,0.)
C
        CALL PLCHHQ (CFUX(.5),CFUY(.04),'The trapezoids comprising the i
     +ntersection S:F34:G:F:C are filled in white.',
     +                                                      .0148,0.,0.)
C
        CALL GSPLCI (4)
        CALL PPINTR (XCCP,YCCP,NCCP,XCSP,YCSP,NCSP,
     +                  RWRK,IWRK,NWRK,FILLTR,IERR)
C
        IF (IERR.NE.0) PRINT * , 'PPINTR RETURNS IERR = ',IERR
C
        CALL GSPLCI (3)
        CALL GPL    (NCSP,XCSP,YCSP)
        CALL GSPLCI (2)
        CALL GPL    (NCCP,XCCP,YCCP)
        CALL GSPLCI (1)
C
        CALL FRAME
C
C Fill the trapezoids representing the union of the clip polygon
C and the subject polygon.
C
        CALL PLCHHQ (CFUX(.5),CFUY(.96),
     +               'POLYPACK EXAMPLE - FRAME 9',.018,0.,0.)
C
        CALL PLCHHQ (CFUX(.5),CFUY(.93),
     +  'Union polygon formed using routines PPUNTR and FILLTR.',
     +                                                      .0175,0.,0.)
C
        CALL PLCHHQ (CFUX(.5),CFUY(.07),'The subject polygon S is outlin
     +ed in green, the clip polygon C in red, trapezoid edges in blue.',
     +                                                      .0148,0.,0.)
C
        CALL PLCHHQ (CFUX(.5),CFUY(.04),'The trapezoids comprising the u
     +nion S:F34:H:F:C are filled in white.',
     +                                                      .0148,0.,0.)
C
        CALL GSPLCI (4)
        CALL PPUNTR (XCCP,YCCP,NCCP,XCSP,YCSP,NCSP,
     +                  RWRK,IWRK,NWRK,FILLTR,IERR)
C
        IF (IERR.NE.0) PRINT * , 'PPUNTR RETURNS IERR = ',IERR
C
        CALL GSPLCI (3)
        CALL GPL    (NCSP,XCSP,YCSP)
        CALL GSPLCI (2)
        CALL GPL    (NCCP,XCCP,YCCP)
        CALL GSPLCI (1)
C
        CALL FRAME
C
C Do one more test, of polyline clipping.
C
        CALL TSTCLP
C
C Close GKS.
C
        CALL GDAWK (IWKID)
        CALL GCLWK (IWKID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END



      SUBROUTINE TSTCLP
C
C Define the size of the polyline this subroutine is to generate.
C
        PARAMETER (NCRA=100)
C
C The parameter LWRK specifies the length of the workspace to be used
C by the polyline package.
C
        PARAMETER (LWRK=100)
C
C Define some arrays in which to put the coordinates of lines.
C
        DIMENSION XCRA(NCRA),YCRA(NCRA)
C
C The array RWRK is a workspace array required by the polyline clipper.
C
        DIMENSION RWRK(LWRK)
C
C The routine DRAWEM is called by the polyline clipping routine.
C
        EXTERNAL DRAWEM
C
C Initialize the polyline color index and the line width scale factor.
C
        CALL GSPLCI (1)
        CALL GSLWSC (1.)
C
C Call SET in such a way that we can use fractional coordinates.
C
        CALL SET (0.,1.,0.,1.,-.15,1.15,-.15,1.15,1)
C
C Create a random polyline.
C
        DO 101 J=1,NCRA
          XCRA(J)=PPFRAN()
          YCRA(J)=PPFRAN()
  101   CONTINUE
C
C Draw the polyline twice, once directly and once using the clipper, a
C different color, and a greater line width.
C
        CALL PLCHHQ (CFUX(.5),CFUY(.96),
     +               'POLYPACK EXAMPLE - FRAME 10',.018,0.,0.)
C
        CALL PLCHHQ (CFUX(.5),CFUY(.93),
     +  'Demonstrating the use of PPPLCL for clipping polylines.',
     +                                                      .0175,0.,0.)
C
        CALL PLCHHQ (CFUX(.5),CFUY(.07),'The clipping rectangle is outli
     +ned in magenta.',
     +                                                      .0148,0.,0.)
C
        CALL PLCHHQ (CFUX(.5),CFUY(.04), 'The polyline is first drawn in
     + white and then again in red using PPPLCL.',
     +                                                      .0148,0.,0.)
C
        FRCT=.25
        XWDL=FRCT
        XWDR=1.-FRCT
        YWDB=FRCT
        YWDT=1.-FRCT
C
        CALL GSPLCI (1)
        CALL GSLWSC (2.)
        CALL CURVE  (XCRA,YCRA,NCRA)
C
        CALL GSPLCI (2)
        CALL GSLWSC (4.)
        CALL PPPLCL (XWDL,XWDR,YWDB,YWDT,XCRA,YCRA,NCRA,RWRK,LWRK,
     +                                                DRAWEM,IERR)
C
        IF (IERR.NE.0) THEN
          PRINT *, 'ERROR IN PPPLCL, IERR = ', IERR
        ENDIF
C
        CALL GSPLCI (5)
        CALL GSLWSC (2.)
        CALL LINE   (XWDL,YWDB,XWDR,YWDB)
        CALL LINE   (XWDR,YWDB,XWDR,YWDT)
        CALL LINE   (XWDR,YWDT,XWDL,YWDT)
        CALL LINE   (XWDL,YWDT,XWDL,YWDB)
C
C Advance the frame.
C
        CALL FRAME
C
C Done.
C
        RETURN
C
      END



      SUBROUTINE FILLPO (XCRA,YCRA,NCRA)
C
        DIMENSION XCRA(NCRA),YCRA(NCRA)
C
C This routine processes polygons generated by the routines PPDIPO,
C PPINPO, and PPUNPO.
C
C Fill the polygon.
C
        CALL GFA (NCRA-1,XCRA,YCRA)
C
C Done.
C
        RETURN
C
      END



      SUBROUTINE MERGPO (XCRA,YCRA,NCRA)
C
        DIMENSION XCRA(NCRA),YCRA(NCRA)
C
C This routine merges the polygons generated by one of the routines
C PPDIPO, PPINPO, and PPUNPO into a single polygon with holes.
C
C Merge polygons are formed in the common block MERGCM:
C
        COMMON /MERGCM/ XCMP(999),YCMP(999),NCMP
        SAVE   /MERGCM/
C
C Copy the coordinates of the latest polygon into the merge polygon
C coordinate arrays and, if the polygon is not the first of the group,
C repeat the first point of the first polygon.  (Actually, the code
C below does something a little more complicated: if necessary, it
C interpolates points to ensure that the connecting lines between
C polygons consist of horizontal and/or vertical steps; this tends
C to prevent problems caused by deficiencies in the fill algorithms
C on some devices.)
C
        NTMP=NCMP
C
        IF (NTMP+NCRA+4.LE.999) THEN
          IF (NCMP.NE.0) THEN
            IF (XCMP(NTMP).NE.XCRA(1).AND.YCMP(NTMP).NE.YCRA(1)) THEN
              IF (YCMP(NTMP).LT.YCRA(1)) THEN
                NTMP=NTMP+1
                XCMP(NTMP)=XCRA(1)
                YCMP(NTMP)=YCMP(NTMP-1)
              ELSE
                NTMP=NTMP+1
                XCMP(NTMP)=XCMP(NTMP-1)
                YCMP(NTMP)=YCRA(1)
              END IF
            END IF
            NTMP=NTMP+1
            XCMP(NTMP)=XCRA(1)
            YCMP(NTMP)=YCRA(1)
          END IF
          DO 101 ICRA=1,NCRA
            XCMP(NTMP+ICRA)=XCRA(ICRA)
            YCMP(NTMP+ICRA)=YCRA(ICRA)
  101     CONTINUE
          NTMP=NTMP+NCRA
          IF (NCMP.NE.0) THEN
            IF (XCMP(NTMP).NE.XCMP(1).AND.YCMP(NTMP).NE.YCMP(1)) THEN
              IF (YCMP(NTMP).LT.YCMP(1)) THEN
                NTMP=NTMP+1
                XCMP(NTMP)=XCMP(1)
                YCMP(NTMP)=YCMP(NTMP-1)
              ELSE
                NTMP=NTMP+1
                XCMP(NTMP)=XCMP(NTMP-1)
                YCMP(NTMP)=YCMP(1)
              END IF
            END IF
            NTMP=NTMP+1
            XCMP(NTMP)=XCMP(1)
            YCMP(NTMP)=YCMP(1)
          END IF
        ELSE
          NTMP=1000
        END IF
C
        NCMP=NTMP
C
C Done.
C
        RETURN
C
      END



      SUBROUTINE FILLTR (XCBL,XCBR,YCOB,DXLE,DXRE,YCOT)
C
        DIMENSION XCRA(5),YCRA(5)
C
C This routine fills trapezoids generated by the routines PPDITR,
C PPINTR, and PPUNTR.
C
C If the trapezoid is not degenerate, fill it and outline it.
C
        IF (YCOT.GT.YCOB) THEN
          XCRA(1)=XCBL
          YCRA(1)=YCOB
          XCRA(2)=XCBR
          YCRA(2)=YCOB
          XCRA(3)=XCBR+DXRE*(YCOT-YCOB)
          YCRA(3)=YCOT
          XCRA(4)=XCBL+DXLE*(YCOT-YCOB)
          YCRA(4)=YCOT
          XCRA(5)=XCBL
          YCRA(5)=YCOB
          CALL GFA (4,XCRA,YCRA)
          CALL GPL (5,XCRA,YCRA)
        END IF
C
C Done.
C
        RETURN
C
      END



      FUNCTION PPFRAN()
        DOUBLE PRECISION X
        SAVE X
        DATA X / 2.718281828459045D0 /
        X=MOD(9821.D0*X+.211327D0,1.D0)
        PPFRAN=REAL(X)
        RETURN
      END



      SUBROUTINE DRAWEM (XCRA,YCRA,NCRA)
C
C Draw the polyline fragment defined by the arguments.
C
        DIMENSION XCRA(NCRA),YCRA(NCRA)
C
        CALL CURVE (XCRA,YCRA,NCRA)
C
        RETURN
C
      END

C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      FUNCTION SPLFE (NDIM,X,COEF,XMIN,XMAX,NODES,IERROR)
      DIMENSION       X(NDIM)    ,COEF(*)    ,XMIN(NDIM) ,XMAX(NDIM) ,
     1                NODES(NDIM)
      DIMENSION       NDERIV(4)
      SAVE
C
      DATA NDERIV(1),NDERIV(2),NDERIV(3),NDERIV(4)/0,0,0,0/
C
C  The restriction for NDIM to be .LE. 4 can be eliminated by 
C  increasing the above dimension and those in SPLDE.
C
      SPLFE = SPLDE(NDIM,X,NDERIV,COEF,XMIN,XMAX,NODES,IERROR)
C
      RETURN
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C   FFTPACK 5.0
C   Copyright (C) 1995-2004, Scientific Computing Division,
C   University Corporation for Atmospheric Research
C   Licensed under the GNU General Public License (GPL)
C
C   Authors:  Paul N. Swarztrauber and Richard A. Valent
C
C   $Id: sintmi.f,v 1.2 2006-11-21 01:10:20 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      SUBROUTINE DSINTMI(N,WSAVE,LENSAV,IER)
      DOUBLE PRECISION PI
      DOUBLE PRECISION DT
      INTEGER N,LENSAV,IER
      DOUBLE PRECISION WSAVE(LENSAV)
C
      IER = 0
C
      IF (LENSAV.LT.N/2+N+INT(LOG(DBLE(N)))+4) THEN
          IER = 2
          CALL DXERFFT('SINTMI',3)
          GO TO 300
      END IF
C
      PI = 4.D0*ATAN(1.D0)
      IF (N.LE.1) RETURN
      NS2 = N/2
      NP1 = N + 1
      DT = PI/DBLE(NP1)
      DO 101 K = 1,NS2
          WSAVE(K) = 2.D0*SIN(K*DT)
  101 CONTINUE
      LNSV = NP1 + INT(LOG(DBLE(NP1))) + 4
      CALL DRFFTMI(NP1,WSAVE(NS2+1),LNSV,IER1)
      IF (IER1.NE.0) THEN
          IER = 20
          CALL DXERFFT('SINTMI',-5)
      END IF
C
  300 CONTINUE
      RETURN
      END

      SUBROUTINE STGEXC( WANTQ, WANTZ, N, A, LDA, B, LDB, Q, LDQ, Z,
     $                   LDZ, IFST, ILST, WORK, LWORK, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      LOGICAL            WANTQ, WANTZ
      INTEGER            IFST, ILST, INFO, LDA, LDB, LDQ, LDZ, LWORK, N
*     ..
*     .. Array Arguments ..
      REAL               A( LDA, * ), B( LDB, * ), Q( LDQ, * ),
     $                   WORK( * ), Z( LDZ, * )
*     ..
*
*  Purpose
*  =======
*
*  STGEXC reorders the generalized real Schur decomposition of a real
*  matrix pair (A,B) using an orthogonal equivalence transformation
*
*                 (A, B) = Q * (A, B) * Z',
*
*  so that the diagonal block of (A, B) with row index IFST is moved
*  to row ILST.
*
*  (A, B) must be in generalized real Schur canonical form (as returned
*  by SGGES), i.e. A is block upper triangular with 1-by-1 and 2-by-2
*  diagonal blocks. B is upper triangular.
*
*  Optionally, the matrices Q and Z of generalized Schur vectors are
*  updated.
*
*         Q(in) * A(in) * Z(in)' = Q(out) * A(out) * Z(out)'
*         Q(in) * B(in) * Z(in)' = Q(out) * B(out) * Z(out)'
*
*
*  Arguments
*  =========
*
*  WANTQ   (input) LOGICAL
*          .TRUE. : update the left transformation matrix Q;
*          .FALSE.: do not update Q.
*
*  WANTZ   (input) LOGICAL
*          .TRUE. : update the right transformation matrix Z;
*          .FALSE.: do not update Z.
*
*  N       (input) INTEGER
*          The order of the matrices A and B. N >= 0.
*
*  A       (input/output) REAL array, dimension (LDA,N)
*          On entry, the matrix A in generalized real Schur canonical
*          form.
*          On exit, the updated matrix A, again in generalized
*          real Schur canonical form.
*
*  LDA     (input)  INTEGER
*          The leading dimension of the array A. LDA >= max(1,N).
*
*  B       (input/output) REAL array, dimension (LDB,N)
*          On entry, the matrix B in generalized real Schur canonical
*          form (A,B).
*          On exit, the updated matrix B, again in generalized
*          real Schur canonical form (A,B).
*
*  LDB     (input)  INTEGER
*          The leading dimension of the array B. LDB >= max(1,N).
*
*  Q       (input/output) REAL array, dimension (LDZ,N)
*          On entry, if WANTQ = .TRUE., the orthogonal matrix Q.
*          On exit, the updated matrix Q.
*          If WANTQ = .FALSE., Q is not referenced.
*
*  LDQ     (input) INTEGER
*          The leading dimension of the array Q. LDQ >= 1.
*          If WANTQ = .TRUE., LDQ >= N.
*
*  Z       (input/output) REAL array, dimension (LDZ,N)
*          On entry, if WANTZ = .TRUE., the orthogonal matrix Z.
*          On exit, the updated matrix Z.
*          If WANTZ = .FALSE., Z is not referenced.
*
*  LDZ     (input) INTEGER
*          The leading dimension of the array Z. LDZ >= 1.
*          If WANTZ = .TRUE., LDZ >= N.
*
*  IFST    (input/output) INTEGER
*  ILST    (input/output) INTEGER
*          Specify the reordering of the diagonal blocks of (A, B).
*          The block with row index IFST is moved to row ILST, by a
*          sequence of swapping between adjacent blocks.
*          On exit, if IFST pointed on entry to the second row of
*          a 2-by-2 block, it is changed to point to the first row;
*          ILST always points to the first row of the block in its
*          final position (which may differ from its input value by
*          +1 or -1). 1 <= IFST, ILST <= N.
*
*  WORK    (workspace/output) REAL array, dimension (LWORK)
*          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*
*  LWORK   (input) INTEGER
*          The dimension of the array WORK. LWORK >= 4*N + 16.
*
*          If LWORK = -1, then a workspace query is assumed; the routine
*          only calculates the optimal size of the WORK array, returns
*          this value as the first entry of the WORK array, and no error
*          message related to LWORK is issued by XERBLA.
*
*  INFO    (output) INTEGER
*           =0:  successful exit.
*           <0:  if INFO = -i, the i-th argument had an illegal value.
*           =1:  The transformed matrix pair (A, B) would be too far
*                from generalized Schur form; the problem is ill-
*                conditioned. (A, B) may have been partially reordered,
*                and ILST points to the first row of the current
*                position of the block being moved.
*
*  Further Details
*  ===============
*
*  Based on contributions by
*     Bo Kagstrom and Peter Poromaa, Department of Computing Science,
*     Umea University, S-901 87 Umea, Sweden.
*
*  [1] B. Kagstrom; A Direct Method for Reordering Eigenvalues in the
*      Generalized Real Schur Form of a Regular Matrix Pair (A, B), in
*      M.S. Moonen et al (eds), Linear Algebra for Large Scale and
*      Real-Time Applications, Kluwer Academic Publ. 1993, pp 195-218.
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ZERO
      PARAMETER          ( ZERO = 0.0E+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            LQUERY
      INTEGER            HERE, LWMIN, NBF, NBL, NBNEXT
*     ..
*     .. External Subroutines ..
      EXTERNAL           STGEX2, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX
*     ..
*     .. Executable Statements ..
*
*     Decode and test input arguments.
*
      INFO = 0
      LWMIN = MAX( 1, 4*N+16 )
      LQUERY = ( LWORK.EQ.-1 )
      IF( N.LT.0 ) THEN
         INFO = -3
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -5
      ELSE IF( LDB.LT.MAX( 1, N ) ) THEN
         INFO = -7
      ELSE IF( LDQ.LT.1 .OR. WANTQ .AND. ( LDQ.LT.MAX( 1, N ) ) ) THEN
         INFO = -9
      ELSE IF( LDZ.LT.1 .OR. WANTZ .AND. ( LDZ.LT.MAX( 1, N ) ) ) THEN
         INFO = -11
      ELSE IF( IFST.LT.1 .OR. IFST.GT.N ) THEN
         INFO = -12
      ELSE IF( ILST.LT.1 .OR. ILST.GT.N ) THEN
         INFO = -13
      ELSE IF( LWORK.LT.LWMIN .AND. .NOT.LQUERY ) THEN
         INFO = -15
      END IF
*
      IF( INFO.EQ.0 ) THEN
         WORK( 1 ) = LWMIN
      END IF
*
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'STGEXC', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.LE.1 )
     $   RETURN
*
*     Determine the first row of the specified block and find out
*     if it is 1-by-1 or 2-by-2.
*
      IF( IFST.GT.1 ) THEN
         IF( A( IFST, IFST-1 ).NE.ZERO )
     $      IFST = IFST - 1
      END IF
      NBF = 1
      IF( IFST.LT.N ) THEN
         IF( A( IFST+1, IFST ).NE.ZERO )
     $      NBF = 2
      END IF
*
*     Determine the first row of the final block
*     and find out if it is 1-by-1 or 2-by-2.
*
      IF( ILST.GT.1 ) THEN
         IF( A( ILST, ILST-1 ).NE.ZERO )
     $      ILST = ILST - 1
      END IF
      NBL = 1
      IF( ILST.LT.N ) THEN
         IF( A( ILST+1, ILST ).NE.ZERO )
     $      NBL = 2
      END IF
      IF( IFST.EQ.ILST )
     $   RETURN
*
      IF( IFST.LT.ILST ) THEN
*
*        Update ILST.
*
         IF( NBF.EQ.2 .AND. NBL.EQ.1 )
     $      ILST = ILST - 1
         IF( NBF.EQ.1 .AND. NBL.EQ.2 )
     $      ILST = ILST + 1
*
         HERE = IFST
*
   10    CONTINUE
*
*        Swap with next one below.
*
         IF( NBF.EQ.1 .OR. NBF.EQ.2 ) THEN
*
*           Current block either 1-by-1 or 2-by-2.
*
            NBNEXT = 1
            IF( HERE+NBF+1.LE.N ) THEN
               IF( A( HERE+NBF+1, HERE+NBF ).NE.ZERO )
     $            NBNEXT = 2
            END IF
            CALL STGEX2( WANTQ, WANTZ, N, A, LDA, B, LDB, Q, LDQ, Z,
     $                   LDZ, HERE, NBF, NBNEXT, WORK, LWORK, INFO )
            IF( INFO.NE.0 ) THEN
               ILST = HERE
               RETURN
            END IF
            HERE = HERE + NBNEXT
*
*           Test if 2-by-2 block breaks into two 1-by-1 blocks.
*
            IF( NBF.EQ.2 ) THEN
               IF( A( HERE+1, HERE ).EQ.ZERO )
     $            NBF = 3
            END IF
*
         ELSE
*
*           Current block consists of two 1-by-1 blocks, each of which
*           must be swapped individually.
*
            NBNEXT = 1
            IF( HERE+3.LE.N ) THEN
               IF( A( HERE+3, HERE+2 ).NE.ZERO )
     $            NBNEXT = 2
            END IF
            CALL STGEX2( WANTQ, WANTZ, N, A, LDA, B, LDB, Q, LDQ, Z,
     $                   LDZ, HERE+1, 1, NBNEXT, WORK, LWORK, INFO )
            IF( INFO.NE.0 ) THEN
               ILST = HERE
               RETURN
            END IF
            IF( NBNEXT.EQ.1 ) THEN
*
*              Swap two 1-by-1 blocks.
*
               CALL STGEX2( WANTQ, WANTZ, N, A, LDA, B, LDB, Q, LDQ, Z,
     $                      LDZ, HERE, 1, 1, WORK, LWORK, INFO )
               IF( INFO.NE.0 ) THEN
                  ILST = HERE
                  RETURN
               END IF
               HERE = HERE + 1
*
            ELSE
*
*              Recompute NBNEXT in case of 2-by-2 split.
*
               IF( A( HERE+2, HERE+1 ).EQ.ZERO )
     $            NBNEXT = 1
               IF( NBNEXT.EQ.2 ) THEN
*
*                 2-by-2 block did not split.
*
                  CALL STGEX2( WANTQ, WANTZ, N, A, LDA, B, LDB, Q, LDQ,
     $                         Z, LDZ, HERE, 1, NBNEXT, WORK, LWORK,
     $                         INFO )
                  IF( INFO.NE.0 ) THEN
                     ILST = HERE
                     RETURN
                  END IF
                  HERE = HERE + 2
               ELSE
*
*                 2-by-2 block did split.
*
                  CALL STGEX2( WANTQ, WANTZ, N, A, LDA, B, LDB, Q, LDQ,
     $                         Z, LDZ, HERE, 1, 1, WORK, LWORK, INFO )
                  IF( INFO.NE.0 ) THEN
                     ILST = HERE
                     RETURN
                  END IF
                  HERE = HERE + 1
                  CALL STGEX2( WANTQ, WANTZ, N, A, LDA, B, LDB, Q, LDQ,
     $                         Z, LDZ, HERE, 1, 1, WORK, LWORK, INFO )
                  IF( INFO.NE.0 ) THEN
                     ILST = HERE
                     RETURN
                  END IF
                  HERE = HERE + 1
               END IF
*
            END IF
         END IF
         IF( HERE.LT.ILST )
     $      GO TO 10
      ELSE
         HERE = IFST
*
   20    CONTINUE
*
*        Swap with next one below.
*
         IF( NBF.EQ.1 .OR. NBF.EQ.2 ) THEN
*
*           Current block either 1-by-1 or 2-by-2.
*
            NBNEXT = 1
            IF( HERE.GE.3 ) THEN
               IF( A( HERE-1, HERE-2 ).NE.ZERO )
     $            NBNEXT = 2
            END IF
            CALL STGEX2( WANTQ, WANTZ, N, A, LDA, B, LDB, Q, LDQ, Z,
     $                   LDZ, HERE-NBNEXT, NBNEXT, NBF, WORK, LWORK,
     $                   INFO )
            IF( INFO.NE.0 ) THEN
               ILST = HERE
               RETURN
            END IF
            HERE = HERE - NBNEXT
*
*           Test if 2-by-2 block breaks into two 1-by-1 blocks.
*
            IF( NBF.EQ.2 ) THEN
               IF( A( HERE+1, HERE ).EQ.ZERO )
     $            NBF = 3
            END IF
*
         ELSE
*
*           Current block consists of two 1-by-1 blocks, each of which
*           must be swapped individually.
*
            NBNEXT = 1
            IF( HERE.GE.3 ) THEN
               IF( A( HERE-1, HERE-2 ).NE.ZERO )
     $            NBNEXT = 2
            END IF
            CALL STGEX2( WANTQ, WANTZ, N, A, LDA, B, LDB, Q, LDQ, Z,
     $                   LDZ, HERE-NBNEXT, NBNEXT, 1, WORK, LWORK,
     $                   INFO )
            IF( INFO.NE.0 ) THEN
               ILST = HERE
               RETURN
            END IF
            IF( NBNEXT.EQ.1 ) THEN
*
*              Swap two 1-by-1 blocks.
*
               CALL STGEX2( WANTQ, WANTZ, N, A, LDA, B, LDB, Q, LDQ, Z,
     $                      LDZ, HERE, NBNEXT, 1, WORK, LWORK, INFO )
               IF( INFO.NE.0 ) THEN
                  ILST = HERE
                  RETURN
               END IF
               HERE = HERE - 1
            ELSE
*
*             Recompute NBNEXT in case of 2-by-2 split.
*
               IF( A( HERE, HERE-1 ).EQ.ZERO )
     $            NBNEXT = 1
               IF( NBNEXT.EQ.2 ) THEN
*
*                 2-by-2 block did not split.
*
                  CALL STGEX2( WANTQ, WANTZ, N, A, LDA, B, LDB, Q, LDQ,
     $                         Z, LDZ, HERE-1, 2, 1, WORK, LWORK, INFO )
                  IF( INFO.NE.0 ) THEN
                     ILST = HERE
                     RETURN
                  END IF
                  HERE = HERE - 2
               ELSE
*
*                 2-by-2 block did split.
*
                  CALL STGEX2( WANTQ, WANTZ, N, A, LDA, B, LDB, Q, LDQ,
     $                         Z, LDZ, HERE, 1, 1, WORK, LWORK, INFO )
                  IF( INFO.NE.0 ) THEN
                     ILST = HERE
                     RETURN
                  END IF
                  HERE = HERE - 1
                  CALL STGEX2( WANTQ, WANTZ, N, A, LDA, B, LDB, Q, LDQ,
     $                         Z, LDZ, HERE, 1, 1, WORK, LWORK, INFO )
                  IF( INFO.NE.0 ) THEN
                     ILST = HERE
                     RETURN
                  END IF
                  HERE = HERE - 1
               END IF
            END IF
         END IF
         IF( HERE.GT.ILST )
     $      GO TO 20
      END IF
      ILST = HERE
      WORK( 1 ) = LWMIN
      RETURN
*
*     End of STGEXC
*
      END

      PROGRAM PGKEX06
C
C  Illustrate polylines with different colors, widths, and types.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      CHARACTER LABEL1*8, LABEL2*11
      PARAMETER (ILD=121)
      DIMENSION PLX(ILD),PLY(ILD),DLX(ILD),DLY(ILD)
      DATA  RADC/.0174532/
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C  Define color indices, color index 0 defines the background color.
C
      CALL GSCR(IWKID,0, 1.0, 1.0, 1.0)
      CALL GSCR(IWKID,1, 0.0, 0.0, 0.0)
      CALL GSCR(IWKID,2, 1.0, 0.0, 0.0)
      CALL GSCR(IWKID,3, 0.0, 0.0, 1.0)
      CALL GSCR(IWKID,4, 0.0, 1.0, 0.0)
      CALL GSCR(IWKID,5, 0.4, 0.0, 0.4)
C
C  Generate data for a spiral.
C
      J = 0
      DO 10 I=0,720,6
        SCALE = REAL(I)/4500.
        J = J+1
        PLX(J) = SCALE*COS(REAL(I-1)*RADC)
        PLY(J) = SCALE*SIN(REAL(I-1)*RADC)
   10 CONTINUE
C
C  Draw spirals with different linetypes, colors, and widths.
C
      DO 20 I=1,4
        X = .28+.42*REAL(MOD(I,2))
        Y = .25+.41*REAL(INT((I-1)/2))
        CALL GSPLCI(I)
        WDTH = 2.*REAL(I-1)+1.
        CALL GSLWSC(WDTH)
        CALL GSLN(I)
        DO 30 J=1,ILD
          DLX(J) = X+PLX(J)
          DLY(J) = Y+PLY(J)
   30   CONTINUE
        CALL GPL(ILD,DLX,DLY)
C
C  Label the lines.
C
        WRITE(LABEL1,100) I
  100   FORMAT('Type = ',I1)
        WRITE(LABEL2,110) WDTH
  110   FORMAT('Width = ',F3.1)
        CALL GSTXAL(2,3)
        CALL GSCHH(.022)
        CALL GSTXFP(-12,2)
        CALL GSTXCI(5)
        CALL GTX(X,Y+.18,LABEL1)
        CALL GTX(X,Y+.14,LABEL2)
   20 CONTINUE
C
C  Label the plot using Plotchar.
C
      CALL GSLN(1)
C     
      CALL PCSETI('FN',25)
      CALL PCSETI('CC',5)
      CALL PLCHHQ(.5,.93,'Polylines',.035,0.,0.)
C
      CALL FRAME
C
C  Deactivate and close the workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C   FFTPACK 5.0
C   Copyright (C) 1995-2004, Scientific Computing Division,
C   University Corporation for Atmospheric Research
C   Licensed under the GNU General Public License (GPL)
C
C   Authors:  Paul N. Swarztrauber and Richard A. Valent
C
C   $Id: rfft1i.f,v 1.2 2006-11-21 01:10:19 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      SUBROUTINE DRFFT1I(N,WSAVE,LENSAV,IER)
      INTEGER N,LENSAV,IER
      DOUBLE PRECISION WSAVE(LENSAV)
C
      IER = 0
C
      IF (LENSAV.LT.N+INT(LOG(DBLE(N)))+4) THEN
          IER = 2
          CALL DXERFFT('RFFT1I ',3)
      END IF
C
      IF (N.EQ.1) RETURN
C
      CALL DRFFTI1(N,WSAVE(1),WSAVE(N+1))
      RETURN
      END

C
C     $Id: cn11f.f,v 1.4 2010-03-15 22:49:23 haley Exp $
C
C***********************************************************************
C                                                                      *
C                            Copyright (C)  1995                       *
C                 University Corporation for Atmospheric Research      *
C                            All Rights Reserved                       *
C                                                                      *
C***********************************************************************
C
C      File:            cn11f.f
C
C      Author:          Ethan Alpert 
C                                (converted to Fortran by Ed Stautler)
C                       National Center for Atmospheric Research
C                       PO 3000, Boulder, Colorado
C
C      Date:            Tue Jan 24 09:34:22 MST 1995
C
C      Description:     Demonstrates how to mix NCARG3.2 calls and
C                       HLU calls.
C
      external NhlFAppClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFCairoWindowWorkstationClass
      external NhlFTickmarkclass
      external NhlFTitleClass
C  
C  define label strings for explicit mode tick mark placement
C  
      parameter(M=73, N=10)
      character*14 labels(7)
      data labels / '90:S:o:N:S', '60:S:o:N:S', '30:S:o:N:S', 
     1      'EQ        ', '30:S:o:N:N', '60:S:o:N:N', 
     2      '90:S:o:N:N' /
C  
C  specify data locations for above labels
C  
      real labellocs(7)
      data labellocs / -90.0, -60.0, -30.0, 0.0, 30.0, 60.0, 90.0 /
      
      integer appid, wid, pid, pid1, gkswid, ierr
      integer i,j,rlist,grlist
      integer iwrk(1000)
      
      real top,bottom,left,right
      
      real rwrk(5000)
      
      real level(N)
      real t(M,N)
      data level / 1000.0, 850.0, 700.0, 500.0, 400.0, 300.0, 
     1      250.0, 200.0, 150.0, 100.0 /
      character*7  wks_type
C
C data file name
C
      character*12 filenm
      filenm = 'cn11f.asc'
C
C Define the workstation type
C
      wks_type = "x11"
C
C read data
C     
      open(unit=10,file=filenm,status='old',form='formatted',err=104)
      do 10 j=1,N
         read (10,1001)(t(i,j),i=1,M)
 10   continue
 1001 format(1x,15F13.8)
C  
C  initialize the high level utility library
C  
      call NhlFInitialize
C  
C  Create an application context. set the app dir to the current 
C  directory so the application looks for a resource file in the 
C  working directory. In this example the resource file supplies 
C  the plot title only.
C  
      call NhlFRLCreate(rlist,'setrl')
      call NhlFRLClear(rlist)
      call NhlFRLSetstring(rlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'cn11',NhlFAppClass,
     1      0,rlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkMetaName','./cn11f.ncgm',ierr)
         call NhlFCreate(wid,'cn11Work',
     1        NhlFNcgmWorkstationClass,0,rlist,ierr) 
      else  if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPause','True',ierr)
         call NhlFCreate(wid,'cn11Work',
     +        NhlFCairoWindowWorkstationClass,
     1        0,rlist,ierr) 
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PS workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPSFileName','./cn11f.ps',ierr)
         call NhlFCreate(wid,'cn11Work',
     1        NhlFPSWorkstationClass,0,rlist,ierr) 
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPDFFileName','./cn11f.pdf',ierr)
         call NhlFCreate(wid,'cn11Work',
     1        NhlFPDFWorkstationClass,0,rlist,ierr) 
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkFileName','./cn11f',ierr)
         call NhlFRLSetstring(rlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(wid,'cn11Work',
     1        NhlFCairoPSPDFWorkstationClass,0,rlist,ierr) 
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkFileName','./cn11f',ierr)
         call NhlFRLSetstring(rlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(wid,'cn11Work',
     1        NhlFCairoImageWorkstationClass,0,rlist,ierr) 
      endif
C  
C  retrieve gks workstation id from the workstation object
C  
      call NhlFRLCreate(grlist,'getrl')
      call NhlFRLClear(rlist)
      call NhlFRLGetinteger(grlist,'wkGksWorkId',gkswid,ierr)
      call NhlFGetValues(wid,grlist,ierr)
C     
C  The following are calls to the low level ncar graphics library to
C  draw labeled contour lines
C  
      call gacwk(gkswid)
      call cpseti('set',0)
      call cpsetr('xc1',-90.0)
      call cpsetr('xcm',90.0)
      call cpsetr('yc1',0.0)
      call cpsetr('ycn',9.0)
      call cpsetr('cis',5.0)
      call cpsetr('dps',.02)
      call cpseti('lis',2)
C  
C  Note that y axis user coordinates are set to grid coordinates 
C  rather than data coordinates. this is done because the input 
C  data is irregularly spaced in the y direction. Basicly this 
C  'tricks' Conpack into thinking the grid points are evenly spaced.
C  
      call set(0.2,0.8,0.2,0.8,-90.0,90.0,0.0,9.0,1)
      call cprect(t,73,73,10,rwrk,5000,iwrk,1000)
      call cpcldr(t,rwrk,iwrk)
      call gdawk(gkswid)
C  
C  End of ncar graphics section. Note deactivation of gks workstation
C  
      call NhlFRLClear(rlist)
      call NhlFRLSetfloat(rlist,'vpXF',.2,ierr)
      call NhlFRLSetfloat(rlist,'vpYF',.8,ierr)
      call NhlFRLSetfloat(rlist,'vpWidthF',.6,ierr)
      call NhlFRLSetfloat(rlist,'vpHeightF',.6,ierr)
      call NhlFRLSetfloat(rlist,'tmYLDataTopF',100.0,ierr)
      call NhlFRLSetfloat(rlist,'tmYLDataBottomF',1000.0,ierr)
      call NhlFRLSetfloat(rlist,'tmXBDataRightF',90.0,ierr)
      call NhlFRLSetfloat(rlist,'tmXBDataLeftF',-90.0,ierr)
      call NhlFRLSetstring(rlist,'tmYLStyle','irregular',ierr)
      call NhlFRLSetstring(rlist,'tmXBMode','explicit',ierr)
      call NhlFRLSetstring(rlist,'tmXBMinorOn','false',ierr)
      call NhlFRLSetfloatarray(rlist,'tmXBValues',
     1      labellocs,7,ierr)
C  
C  Array 'level' contains original grid point data locations in 
C  y direction. Providing the grid points to the tickmark object as 
C  the control points for the irregular style transformation, means 
C  that these points will be evenly spaced along the y axis. Since 
C  this is how conpack thinks the points are spaced, the tick marks 
C  will correctly correspond with the data coordinates. See the hlu 
C  user's guide prototype document for a complete discussion of 
C  irregular style transformations.
C  
      call NhlFRLSetstringarray(rlist,'tmXBLabels',
     1      labels,7,ierr)
      call NhlFRLSetfloatarray(rlist,'tmYLIrregularPoints',
     1      level,10,ierr)
      call NhlFCreate(pid,'TickMarksForContour',
     1      nhlftickmarkclass,wid,rlist,ierr)
C  
C  Retrieves bounding box information from tick mark object so 
C  title object can be correctly configured.
C  
      call NhlFGetBB(pid,top,bottom,left,right,ierr)
      call NhlFRLClear(rlist)
      call NhlFRLSetfloat(rlist,'vpXF',left,ierr)
      call NhlFRLSetfloat(rlist,'vpYF',top,ierr)
      call NhlFRLSetfloat(rlist,'vpWidthF',right-left,ierr)
      call NhlFRLSetfloat(rlist,'vpHeightF',top-bottom,ierr)
C  
C  These offsets are computed in order to center the labels around 
C  the plot viewport rather than the bounding box of the TickMark 
C  object.
C
      call NhlFRLSetfloat(rlist,'tiMainOffsetXF',
     1      (.2 - left)/2.0,ierr)
      call NhlFRLSetfloat(rlist,'tiXAxisOffsetXF',
     1      (.2 - left)/2.0,ierr)
      call NhlFRLSetfloat(rlist,'tiYAxisOffsetYF',
     1      (.2 - bottom)/2.0,ierr)
      
      call NhlFCreate(pid1,'TitlesForContour',NhlFTitleClass,
     1      wid,rlist,ierr)
      
      call NhlFDraw(pid,ierr)
      call NhlFDraw(pid1,ierr)
      call NhlFFrame(wid,ierr)
      call NhlFDestroy(pid,ierr)
      call NhlFDestroy(pid1,ierr)
      call NhlFClose
      
      stop
 104  write (6,*) 'error in opening file: ',filenm
      
      end

      PROGRAM FCOORD1
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C INVOKE DEMO DRIVER
C
      CALL COORD1(IERR)
C
C     DEACTIVATE AND CLOSE WORKSTATION, CLOSE GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      STOP
      END
      SUBROUTINE COORD1 (IERROR)
C
C  This example shows the mapping from GKS world coordinates to
C   GKS normalized device coordinates.
C
      DIMENSION XCRA(101),YCRA(101)
      DATA DSL,DSR,DSB,DST / .59,.99,.40,.70 /
      DATA PFL,PFR,PFB,PFT / .71,.98,.42,.69 /
      CALL GSCLIP (0)
      CALL GSLWSC (2.)
C
C Employ the new high quality filled fonts in PLOTCHAR
C
      CALL PCSETC('FN','times-roman')
      CALL PCSETC('FC','%')
C
      CALL SET    (0.,1.,0.,1.,0.,1.,0.,1.,1)
C
      CALL PLCHHQ (.50,.97,
     +     'Mapping from a window in the world coordinate system',
     +     .02,0.,0.)
      CALL PLCHHQ (.50,.93,
     +     'to a viewport in the normalized device coordinate system',
     +     .02,0.,0.)
      CALL PCSETI('FN',21)
      CALL PLCHHQ (.50,.89,
     +'(Used in calls to GKS routines like GCA, GFA, GPL, GPM, and GTX)'
     +,.016,0.,0.)
      CALL PCSETI('FN',29)
      CALL PLCHHQ (.50,.19,
     +     'The window is:  100., 1000., 100., 1000.',
     +     .015,0.,0.)
      CALL PLCHHQ (.50,.15,
     +     'The viewport is:  .15, .95, .10, .90',
     +     .015,0.,0.)
      CALL SET    (.01,.55,.29,.83,0.,1100.,0.,1100.,1)
      CALL PCSETI('FN',22)
      CALL LINE   (   0.,   0.,1100.,   0.)
      CALL LINE   (1100.,   0.,1050.,  25.)
      CALL LINE   (1100.,   0.,1050., -25.)
      CALL PLCHHQ (CFUX(CUFX(1100.)+.015),0.,'X',.015,0.,0.)
      CALL LINE   (   0.,   0.,   0.,1100.)
      CALL LINE   (   0.,1100.,  25.,1050.)
      CALL LINE   (   0.,1100., -25.,1050.)
      CALL PLCHHQ (0.,CFUY(CUFY(1100.)+.015),'Y',.015,0.,0.)
      CALL LINE   ( 100., 100.,1000., 100.)
      CALL LINE   (1000., 100.,1000.,1000.)
      CALL LINE   (1000.,1000., 100.,1000.)
      CALL LINE   ( 100.,1000., 100., 100.)
      CALL PLCHHQ (CFUX(CUFX(100.)+.005),CFUY(CUFY(1000.)-.02),
     +     'WINDOW',.01,0.,-1.)
      CALL PLCHHQ (100.,CFUY(CUFY(100.)-.01),'100',.009,0.,0.)
      CALL PLCHHQ (1000.,CFUY(CUFY(100.)-.01),'1000',.009,0.,0.)
      CALL PLCHHQ (CFUX(CUFX(100.)-.005),100.,'100',.009,0.,1.)
      CALL PLCHHQ (CFUX(CUFX(100.)-.005),1000.,'1000',.009,0.,1.)
      DO 101 I=1,101
         XCRA(I)=200.+7.*REAL(I-1)
         YCRA(I)=550.+425.*SIN(EXP((XCRA(I)-200.)/300.)-1.)
 101  CONTINUE
      CALL CURVE  (XCRA,YCRA,101)
      XCLW=CUFX(100.)
      XCRW=CUFX(1000.)
      YCBW=CUFY(100.)
      YCTW=CUFY(1000.)
      CALL SET    (DSL,DSR,DSB,DST,0.,1.,0.,1.,1)
      CALL LINE   (0.,0.,1.,0.)
      CALL LINE   (1.,0.,1.,1.)
      CALL LINE   (1.,1.,0.,1.)
      CALL LINE   (0.,1.,0.,0.)
      CALL PLCHHQ (CFUX(CUFX(0.)+.005),CFUY(CUFY(1.)-.01),
     +     'DEVICE',.01,0.,-1.)
      CALL SET    (PFL,PFR,PFB,PFT,0.,1.,0.,1.,1)
      CALL LINE   (0.,0.,1.,0.)
      CALL LINE   (1.,0.,1.,1.)
      CALL LINE   (1.,1.,0.,1.)
      CALL LINE   (0.,1.,0.,0.)
      CALL PLCHHQ (CFUX(CUFX(0.)+.005),CFUY(CUFY(1.)-.01),
     +     'PLOTTER FRAME',.01,0.,-1.)
      CALL PLCHHQ (0.,CFUY(CUFY(0.)-.01),'0',.008,0.,0.)
      CALL PLCHHQ (1.,CFUY(CUFY(0.)-.01),'1',.008,0.,0.)
      CALL PLCHHQ (CFUX(CUFX(0.)-.005),0.,'0',.008,0.,1.)
      CALL PLCHHQ (CFUX(CUFX(0.)-.005),1.,'1',.008,0.,1.)
      VPL=PFL+.15*(PFR-PFL)
      VPR=PFL+.95*(PFR-PFL)
      VPB=PFB+.10*(PFT-PFB)
      VPT=PFB+.90*(PFT-PFB)
      CALL SET    (VPL,VPR,VPB,VPT, 100.,1000., 100.,1000.,1)
      CALL LINE   ( 100., 100.,1000., 100.)
      CALL LINE   (1000., 100.,1000.,1000.)
      CALL LINE   (1000.,1000., 100.,1000.)
      CALL LINE   ( 100.,1000., 100., 100.)
      CALL PLCHHQ (CFUX(CUFX(100.)+.005),CFUY(CUFY(1000.)-.01),
     +     'VIEWPORT',.01,0.,-1.)
      CALL PLCHHQ (100.,CFUY(CUFY(100.)-.01),'.15',.008,0.,0.)
      CALL PLCHHQ (1000.,CFUY(CUFY(100.)-.01),'.95',.008,0.,0.)
      CALL PLCHHQ (CFUX(CUFX(100.)-.005),100.,'.10',.008,0.,1.)
      CALL PLCHHQ (CFUX(CUFX(100.)-.005),1000.,'.90',.008,0.,1.)
      CALL CURVE  (XCRA,YCRA,101)
      XCLV=CUFX(100.)
      XCRV=CUFX(1000.)
      YCBV=CUFY(100.)
      YCTV=CUFY(1000.)
      CALL SET    (0.,1.,0.,1.,0.,1.,0.,1.,1)
      CALL PLOTIT (0,0,0)
      CALL DASHDC ('$''',3,1)
      CALL LINED  (XCLW,YCBW,XCLV,YCBV)
      CALL LINED  (XCRW,YCBW,XCRV,YCBV)
      CALL LINED  (XCRW,YCTW,XCRV,YCTV)
      CALL LINED  (XCLW,YCTW,XCLV,YCTV)
      CALL FRAME
      WRITE (6,1001)
      RETURN
C
 1001 FORMAT ('     COORD1 TEST SUCCESSFUL',24X,
     1     'SEE PLOTS TO VERIFY PERFORMANCE')
C
      END

C
C       $Id: hlustmpxy.f,v 1.5 2008-07-27 00:17:27 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
C These routine stand between Streamline and the user call-back routines
C in stmpxy.f  When HLUs are not in use, this version of the routine
C gets loaded, so that STMPXY, STIMXY, and STMPTA get called. 
C When the HLUs are in use, they load another version; it either does 
C the appropriate thing for the purposes of the HLUs or calls STMPXY,
C STIMXY, and STMPTA as needed.
C
      SUBROUTINE HLUSTMPXY(XDA,YDA,XUS,YUS,IST)
C
      CALL STMPXY(XDA,YDA,XUS,YUS,IST)
C
      RETURN
C
      END
C
C -------------------------------------------------------------
C
      SUBROUTINE HLUSTIMXY(XUS,YUS,XDA,YDA,IST)
C
      CALL STIMXY(XUS,YUS,XDA,YDA,IST)
C
      RETURN
C
      END
C
C -------------------------------------------------------------
C
      SUBROUTINE HLUSTMPTA(XDA,YDA,XUS,YUS,XND,YND,DU,DV,TA,IST)
C
      CALL STMPTA(XDA,YDA,XUS,YUS,XND,YND,DU,DV,TA,IST)
C
      RETURN
C
      END

C
C	$Id: remove.f,v 1.4 2008-07-27 00:23:04 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE REMOVE (MX,MY,HIDDEN,IND)
C
C SUBROUTINE REMOVE CONTAINS THE DATA STRUCTURES FOR THE MODEL PICTURE
C WHICH IS USED TO DETERMINE IF A LINE WILL BE DRAWN OR REMOVED.
C ALL MANIPULATIONS ON THESE DATA STRUCTURES ARE DONE EXCLUSIVLY IN
C SUBROUTINE REMOVE.
C
C
C INPUT-OUTPUT-SPECIFICATIONS:
C
C  INPUT:
C   MX,MY: X- AND Y-COOORDINATES OF A POINT IN THE PLOTTING AREA.
C          MX AND MY RANGE FROM 0 TO 2**15-1.
C          NOTE: MX AND MY MAY BE LESS THAN 0 OR GREATER THAN 2**15-1
C                IN SOME SPECIAL CASES.
C   IND =1: REMOVE CALLED FROM RESET.
C          SET ALL ELEMENTS IN THE MODEL PICTURE TO NONMARKED.
C        =2: MARK THE POINT (MX,MY) AND THE POINTS NEXT TO IT.
C        =3: CHECK IF THE POINT (MX,MY) IS ALREADY MARKED. RETURN RESULT
C           IN HIDDEN.
C  OUTPUT:
C   MX, MY, AND IND ARE UNCHANGED.
C   HIDDEN: LOGICAL, ONLY RELEVANT IF IND=3.
C          RETURNS .TRUE. IF THE POINT WITH COORDINATES (MX,MY) IS
C          ALREADY MARKED, OTHERWISE .FALSE.
C  COMMON-BLOCKS:
C   ARRAY ISCREN IS CHANGED AS DEFINED ABOVE IF IND IS 1 OR 2.
C
C
C NOTE
C   THE IMPLEMENTATION OF THE MODEL PICTURE MAY BE CHANGED NOT HOWEVER
C   THE INPUT-OUTPUT SPECIFICATIONS STATED ABOVE.
C
C
C ALGORITHM
C THIS IMPLEMENTATION OF A MODEL PICTURE USES A BIT MAP. EACH PLOTTER
C ADDRESS (POINT) IS REPRESENTED BY A BIT IN THE ARRAY ISCREN. INITIALLY
C EACH BIT IS SET TO 0 BY A CALL TO THE SUBROUTINE RESET. WHEN A LINE
C IS DRAWN ALL BITS REPRESENTING POINTS ON THE LINE ARE SET TO 1. BEFORE
C A LINE IS DRAWN THE MODEL PICTURE IS CHECKED. IF THE BITS IN THE
C MODEL PICTURE REPRESENTING THE POINTS ON THE LINE ARE ALREADY 1 THEN
C THE LINE IS NOT DRAWN, OTHERWISE THE LINE IS DRAWN AND THE
C CORRESPONDING BITS ARE SET TO 1.
C
C
C
C
      LOGICAL HIDDEN
      SAVE
C
      DIMENSION MASK(64),MASK3(64)
C
C
C *********************************************************************
C
C MACHINE AND MODEL DEPENDENT DECLARATIONS AND CONSTANT DEFINITIONS
C
C
C CHOOSE NOW THE SIZE OF YOUR MODEL PICTURE AS NX BY NY.
C ONLY SIZES WITH NX EQUAL TO NY HAVE BEEN TESTED SO FAR.
C ALSO ONLY SIZES WITH NX AND NY POWERS OF 2 ARE POSSIBLE.
C MODEL PICTURES IN SIZE EQUAL TO OR CLOSE TO YOUR PLOTTER ADDRESS SPACE
C ARE RECOMMENDED.
C ASSUME THE MODEL PICTURE IS OF SIZE NX BY NY. THEN ARRAY ISCREN NEEDS
C NY COLUMNS AND NX/NBWD+1 ROWS WHERE NBWD IS THE NUMBER OF BITS PER
C INTEGER STORAGE UNIT.
      DIMENSION ISCREN(1,1)
C E.G. FOR A 1024 BY 1024 MODEL PICTURE ON A 60 BIT MACHINE
C     DIMENSION ISCREN(18,1024)
C
C NX AND NY ARE THE LENGTHS OF THE MODEL PICTURE IN X AND Y DIRECTION.
C LX AND NY ARE THE DIMENSIONS OF THE ARRAY ISCREN WHICH IS USED TO
C REPRESENT THE MODEL PICTURE.
C FOR ANY SIZE OF A MODEL PICTURE THE NUMBER OF COLUMNS IN ISCREN IS
C ALWAYS EQUAL TO THE LENGTH OF THE MODEL PICTURE IN Y DIRECTION.
C
      DATA NX,NY,LX /0,0,0/
C E.G. FOR A 1024 BY 1024 MODEL PICTURE ON A 60 BIT MACHINE
C     DATA NX,NY,LX /1024,1024,18/
C
C NXSIZE IS AN INTEGER SUCH THAT 2**NXSIZE = NX
C NYSIZE IS AN INTEGER SUCH THAT 2**NYSIZE = NY
C
      DATA NXSIZE,NYSIZE /1,1/
C E. G. FOR A 1024 BY 1024 MODEL PICTURE
C     DATA NXSIZE,NYSIZE /10,10/
C
C
C END OF MACHINE AND MODEL DEPENDENT DECLARATIONS AND CONSTANT
C DEFINITIONS
C
C **********************************************************************
C
C ARRAY MASK CONTAINS SINGLE BIT MASKS FOR EACH BIT IN THE WORD.
C ENTRY I IN ARRAY MASK CONTAINS A WORD WITH THE I-TH BIT FROM THE RIGHT
C A 1 AND ALL OTHER BITS 0.
C THESE MASKS ARE USED TO CHECK IF A GIVEN POINT IN THE MODEL PICTURE
C HAS ALREADY BEEN MARKED.
C
C ARRAY MASK3 ALSO CONTAINS A MASK FOR EACH BIT IN THE WORD, BUT THE
C BIT TO THE LEFT AND THE BIT TO THE RIGHT ARE NOW SET AS WELL (EXCEPT
C AT THE EDGES). ENTRY I IN THE ARRAY MASK3 CONTAINS A WORD WITH THE
C (I-1)-TH,I-TH, AND(I+1)-TH BITS FROM THE RIGHT 1'S AND ALL OTHER BITS
C ZEROES.
C THESE MASKS ARE USED TO MARK 3 POINTS IN THE MODEL PICTURE AT THE SAME
C TIME.
C
C     FLAG FOR FIRST CALL (USED TO DETERMINE IF MASKS SHOULD
C     BE DEFINED BY CALLING INTMSK)
C
      DATA IFSTC/0/
C
C     DEFINE MASKS IF THIS IS THE FIRST CALL TO REMOVE
C
      IF (IFSTC .GT. 0) GO TO 5
C
C     CHECK IF THE IMPLEMENTATION-DEPENDENT CONSTANTS HAVE BEEN SET
C
      IF (NX .EQ. 0) THEN
        WRITE(6,500)
        STOP
      ENDIF
  500 FORMAT('     IN SUBROUTINE REMOVE OF DASHSUPR:',/
     -'       IMPLEMENTATION-DEPENDENT CONSTANTS NOT SET--',/
     -'       SEE INSTRUCTIONS AFTER INITIAL COMMENT CARDS.')
      CALL INTMSK(MASK,MASK3)
      IFSTC = 1
    5 CONTINUE
C
C IF COORDINATES ARE OUT OF RANGE, QUIT.  (DJK, 04/27/88)
C
      IF (MX.LT.0.OR.MX.GT.32767.OR.MY.LT.0.OR.MY.GT.32767) THEN
        IF (IND.EQ.3) HIDDEN=.TRUE.
        RETURN
      END IF
C
C RETRIEVE THE NUMBER OF BITS PER INTEGER STORAGE UNIT.
C
      NBPW = I1MACH(5)
C
C TRANSFORM THE INPUT COORDINATES INTO MODEL PICTURE COORDINATES.
C
      IX = ISHIFT (MX,NXSIZE-15)
      IY = ISHIFT (MY,NYSIZE-15) + 1
C
C FIND THE ELEMENT IN THE ISCREN ARRAY REPRESENTING THE POINT (MX,MY).
C
      IBIT = MOD(IX,NBPW)+1
      IX = IX/NBPW+1
C
C BRANCH DEPENDING ON FUNCTION TO BE PERFORMED
C
      GOTO (1,2,3) , IND
C
C ***********************************************
C
C CHECK IF THE POINT (MX,MY) IS ALREADY MARKED
C
    3 CONTINUE
      HIDDEN = .TRUE.
      ITEMP = IAND(ISCREN(IX,IY),MASK(IBIT))
      IF (ITEMP .EQ. 0) HIDDEN = .FALSE.
      RETURN
C
C ***********************************************
C
C MARK THE POINT (MX,MY) AND THE POINTS NEXT TO IT
C
    2 CONTINUE
C
C MARK THE POINTS (MX,MY) , (MX,MY+1) AND (MX,MY-1) IF THEY ARE IN
C THE PLOTTING AREA.
C MARK ALSO 3 POINTS FOR MX+1 AND MX-1 IN MOST CASES.
C
      ISCREN(IX,IY) = IOR(ISCREN(IX,IY),MASK3(IBIT))
      IF (IY .LT. NY) ISCREN(IX,IY+1) = IOR(ISCREN(IX,IY+1),MASK3(IBIT))
      IF (IY .GT. 1) ISCREN(IX,IY-1) = IOR(ISCREN(IX,IY-1),MASK3(IBIT))
      IF (IBIT .EQ. 1) GO TO 10
      IF (IBIT .EQ. NBPW) GO TO 20
      RETURN
C RETURN IF THE LEFT EDGE OF THE PLOTTING AREA IS REACHED.
   10 IF (IX .EQ. 1) RETURN
C
C MARK 3 POINTS TO THE LEFT OF (MX,MY)
C
      ISCREN(IX-1,IY) = IOR(ISCREN(IX-1,IY),MASK(NBPW))
      IF (IY .GT. 1) ISCREN(IX-1,IY-1) = IOR(ISCREN(IX-1,IY-1),
     1                                       MASK(NBPW))
      IF (IY .LT. NY)
     1    ISCREN(IX-1,IY+1) = IOR(ISCREN(IX-1,IY+1),MASK(NBPW))
      RETURN
C RETURN IF THE RIGHT EDGE OF THE PLOTTING AREA IS REACHED.
   20 IF (IX .EQ. LX) RETURN
C
C MARK 3 POINTS TO THE RIGHT OF (MX,MY).
C
      ISCREN(IX+1,IY) = IOR(ISCREN(IX+1,IY),MASK(1))
      IF (IY .GT. 1) ISCREN(IX+1,IY-1) =  IOR(ISCREN(IX+1,IY-1),MASK(1))
      IF (IY .LT. NY) ISCREN(IX+1,IY+1) = IOR(ISCREN(IX+1,IY+1),MASK(1))
      RETURN
C
C ***********************************************
C
C ENTRY RESET . SET ALL THE ELEMENTS IN THE ARRAY ISCREN TO 0.
C
    1 CONTINUE
      DO 40 J = 1,NY
      DO 30 I = 1,LX
         ISCREN(I,J) = 0
   30 CONTINUE
   40 CONTINUE
      RETURN
C
      END

C
C $Id: e0fndp.f,v 1.5 2008-07-27 00:17:08 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      DOUBLE PRECISION FUNCTION E0FNDP (ECCNTS)
C
C This function computes the constant E0.
C
      IMPLICIT DOUBLE PRECISION (A-Z)
      DATA QUART,ONE,ONEQ,THREE,SIXT /0.25D0,1.0D0,1.25D0,3.0D0,16.0D0/
C
      E0FNDP = ONE - QUART * ECCNTS * (ONE + ECCNTS / SIXT *
     .         (THREE + ONEQ * ECCNTS))
C
      RETURN
      END

C
C	$Id: wmgeti.f,v 1.18 2010-01-05 03:52:14 fred Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE WMGETI (CNP,IVP)
C
      SAVE
C
      CHARACTER*(*) CNP
C
C  This subroutine is called to retrieve the integer value of a specified
C  parameter.
C
C  CNP is the name of the parameter whose value is to be retrieved.
C
C  IVP is an integer variable in which the desired value is to be
C  returned by WMGETI.
C
C
C  Declare a local character variable in which to form an error message.
C
      CHARACTER*80 CTM
C
      include 'wmcomn.h'
C
C  Do a call forcing a BLOCKDATA to be loaded from a binary library.
C
      CALL WMBLDA
C
C  Check for an uncleared prior error.
C
      IF (ICFELL('WMGETI - Uncleared prior error',1).NE.0) RETURN
C
C Check for a parameter name that is too short.
C
      IF (LEN(CNP) .LT. 3) THEN
        CTM(1:36)='WMGETI - Parameter name too short - '
        CTM(37:36+LEN(CNP)) = CNP
        CALL SETER (CTM(1:36+LEN(CNP)), 1, 1)
        GO TO 110
      ENDIF
C
C Get the appropriate parameter value.
C
      IF (CNP(1:3).EQ.'MXS' .OR. CNP(1:3).EQ.'mxs' .OR. 
     +    CNP(1:3).EQ.'Mxs') THEN
        IVP = MAXSYM
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'NMS' .OR. CNP(1:3).EQ.'nms' .OR. 
     +    CNP(1:3).EQ.'Nms') THEN
        IVP = NUMSYO
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'PAI' .OR. CNP(1:3).EQ.'pai' .OR. 
     +    CNP(1:3).EQ.'Pai') THEN
        IVP = IARNDX
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'SLF' .OR. CNP(1:3).EQ.'slf' .OR. 
     +    CNP(1:3).EQ.'Slf') THEN
        IVP = ISLFLG
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'WTY' .OR. CNP(1:3).EQ.'wty' .OR. 
     +    CNP(1:3).EQ.'Wty') THEN
        IVP = IWDTYP
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'COL' .OR. CNP(1:3).EQ.'col' .OR. 
     +    CNP(1:3).EQ.'Col') THEN
        IVP = ICOLOR
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'CBC' .OR. CNP(1:3).EQ.'cbc' .OR. 
     +    CNP(1:3).EQ.'Cbc') THEN
        IVP = IBGCTY
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'RFC' .OR. CNP(1:3).EQ.'rfc' .OR. 
     +    CNP(1:3).EQ.'Rfc') THEN
        IVP = IFGTRG
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'RLS' .OR. CNP(1:3).EQ.'rls' .OR. 
     +    CNP(1:3).EQ.'Rls') THEN
        IVP = IRLLSC
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'EZF' .OR. CNP(1:3).EQ.'ezf' .OR. 
     +    CNP(1:3).EQ.'Ezf') THEN
        IVP = IEZFLG
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'ROS' .OR. CNP(1:3).EQ.'ros' .OR. 
     +    CNP(1:3).EQ.'Ros') THEN
        IVP = IRLOUC
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'RBS' .OR. CNP(1:3).EQ.'rbs' .OR. 
     +    CNP(1:3).EQ.'Rbs') THEN
        IVP = IRLBKC
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'DTC' .OR. CNP(1:3).EQ.'dtc' .OR. 
     +    CNP(1:3).EQ.'Dtc') THEN
        IVP = IDOTCO
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'DBC' .OR. CNP(1:3).EQ.'dbc' .OR. 
     +    CNP(1:3).EQ.'Dbc') THEN
        IVP = IDOTBG
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'NBZ' .OR. CNP(1:3).EQ.'nbz' .OR. 
     +    CNP(1:3).EQ.'Nbz') THEN
        IVP = NPTSBZ
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'ALO' .OR. CNP(1:3).EQ.'alo' .OR. 
     +    CNP(1:3).EQ.'Alo') THEN
        IVP = IALOFT
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'WBF' .OR. CNP(1:3).EQ.'wbf' .OR. 
     +    CNP(1:3).EQ.'Wbf') THEN
        IVP = IALOFT
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'SC1' .OR. CNP(1:3).EQ.'sc1' .OR. 
     +    CNP(1:3).EQ.'Sc1') THEN
        IVP = ISUNC1
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'SC2' .OR. CNP(1:3).EQ.'sc2' .OR. 
     +    CNP(1:3).EQ.'Sc2') THEN
        IVP = ISUNC2
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'SC3' .OR. CNP(1:3).EQ.'sc3' .OR. 
     +    CNP(1:3).EQ.'Sc3') THEN
        IVP = ISUNC3
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'SC4' .OR. CNP(1:3).EQ.'sc4' .OR. 
     +    CNP(1:3).EQ.'Sc4') THEN
        IVP = ISUNC4
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'CC1' .OR. CNP(1:3).EQ.'cc1' .OR. 
     +    CNP(1:3).EQ.'Cc1') THEN
        IVP = ICLDC1
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'CC2' .OR. CNP(1:3).EQ.'cc2' .OR. 
     +    CNP(1:3).EQ.'Cc2') THEN
        IVP = ICLDC2
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'CC3' .OR. CNP(1:3).EQ.'cc3' .OR. 
     +    CNP(1:3).EQ.'Cc3') THEN
        IVP = ICLDC3
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'LC1' .OR. CNP(1:3).EQ.'lc1' .OR. 
     +    CNP(1:3).EQ.'Lc1') THEN
        IVP = ILTNC1
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'LC2' .OR. CNP(1:3).EQ.'lc2' .OR. 
     +    CNP(1:3).EQ.'Lc2') THEN
        IVP = ILTNC2
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'LC3' .OR. CNP(1:3).EQ.'lc3' .OR. 
     +    CNP(1:3).EQ.'Lc3') THEN
        IVP = ILTNC3
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'WFC' .OR. CNP(1:3).EQ.'wfc' .OR. 
     +    CNP(1:3).EQ.'Wfc') THEN
        IVP = IWARMC
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'CFC' .OR. CNP(1:3).EQ.'cfc' .OR. 
     +    CNP(1:3).EQ.'Cfc') THEN
        IVP = ICOLDC
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'T1C' .OR. CNP(1:3).EQ.'t1c' .OR. 
     +    CNP(1:3).EQ.'T1c') THEN
        IVP = ITRO1C
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'T2C' .OR. CNP(1:3).EQ.'t2c' .OR. 
     +    CNP(1:3).EQ.'T2c') THEN
        IVP = ITRO2C
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'RC1' .OR. CNP(1:3).EQ.'rc1' .OR. 
     +    CNP(1:3).EQ.'Rc1') THEN
        IVP = IRGLC1
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'RC2' .OR. CNP(1:3).EQ.'rc2' .OR. 
     +    CNP(1:3).EQ.'Rc2') THEN
        IVP = IRGLC2
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'RC3' .OR. CNP(1:3).EQ.'rc3' .OR. 
     +    CNP(1:3).EQ.'Rc3') THEN
        IVP = IRGLC3
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'RC4' .OR. CNP(1:3).EQ.'rc4' .OR. 
     +    CNP(1:3).EQ.'Rc4') THEN
        IVP = IRGLC4
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'RC5' .OR. CNP(1:3).EQ.'rc5' .OR. 
     +    CNP(1:3).EQ.'Rc5') THEN
        IVP = IRGLC5
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'AWC' .OR. CNP(1:3).EQ.'awc' .OR. 
     +    CNP(1:3).EQ.'Awc') THEN
        IVP = IAROWC
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'SMF' .OR. CNP(1:3).EQ.'smf' .OR. 
     +    CNP(1:3).EQ.'Smf') THEN
        IVP = ISMOTH
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'ASC' .OR. CNP(1:3).EQ.'asc' .OR. 
     +    CNP(1:3).EQ.'Asc') THEN
        IVP = IARSHC
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'AOC' .OR. CNP(1:3).EQ.'aoc' .OR. 
     +    CNP(1:3).EQ.'Aoc') THEN
        IVP = IAROUC
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'HIS' .OR. CNP(1:3).EQ.'his' .OR. 
     +    CNP(1:3).EQ.'His') THEN
        IVP = IHIGC1
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'HIF' .OR. CNP(1:3).EQ.'hif' .OR. 
     +    CNP(1:3).EQ.'Hif') THEN
        IVP = IHIGC3
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'HIB' .OR. CNP(1:3).EQ.'hib' .OR. 
     +    CNP(1:3).EQ.'Hib') THEN
        IVP = IHIGC2
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'HIC' .OR. CNP(1:3).EQ.'hic' .OR. 
     +    CNP(1:3).EQ.'Hic') THEN
        IVP = IHIGC4
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'LOS' .OR. CNP(1:3).EQ.'los' .OR. 
     +    CNP(1:3).EQ.'Los') THEN
        IVP = ILOWC1
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'LOF' .OR. CNP(1:3).EQ.'lof' .OR. 
     +    CNP(1:3).EQ.'Lof') THEN
        IVP = ILOWC3
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'LOB' .OR. CNP(1:3).EQ.'lob' .OR. 
     +    CNP(1:3).EQ.'Lob') THEN
        IVP = ILOWC2
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'LOC' .OR. CNP(1:3).EQ.'loc' .OR. 
     +    CNP(1:3).EQ.'Loc') THEN
        IVP = ILOWC4
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'WBF' .OR. CNP(1:3).EQ.'wbf' .OR. 
     +    CNP(1:3).EQ.'Wbf') THEN
        IVP = IWBBAS
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'WDF' .OR. CNP(1:3).EQ.'wdf' .OR. 
     +    CNP(1:3).EQ.'Wdf') THEN
        IVP = IWBDIR
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'UNT' .OR. CNP(1:3).EQ.'unt' .OR. 
     +    CNP(1:3).EQ.'Unt') THEN
        IVP = IUNITS
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'VCC' .OR. CNP(1:3).EQ.'vcc' .OR. 
     +    CNP(1:3).EQ.'Vcc') THEN
        IVP = VCCOLR
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'VLF' .OR. CNP(1:3).EQ.'vlf' .OR.
     +         CNP(1:3).EQ.'Vlf') THEN
        IVP = VLBLFC
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'VLB' .OR. CNP(1:3).EQ.'vlb' .OR.
     +         CNP(1:3).EQ.'Vlb') THEN
        IVP = VLBLBC
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'VVC' .OR. CNP(1:3).EQ.'vvc' .OR.
     +         CNP(1:3).EQ.'Vvc') THEN
        IVP = IVVCOD
        GO TO 110
      ELSE
        CTM(1:36) = 'WMGETI - Parameter name not known - '
        CTM(37:39) = CNP(1:3)
        CALL SETER (CTM(1:39), 2, 1)
        GO TO 110
      ENDIF
C
  110 CONTINUE
      RETURN
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C   FFTPACK 5.0
C   Copyright (C) 1995-2004, Scientific Computing Division,
C   University Corporation for Atmospheric Research
C   Licensed under the GNU General Public License (GPL)
C
C   Authors:  Paul N. Swarztrauber and Richard A. Valent
C
C   $Id: rfft1b.f,v 1.2 2006-11-21 01:10:19 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      SUBROUTINE DRFFT1B(N,INC,R,LENR,WSAVE,LENSAV,WORK,LENWRK,IER)
      INTEGER N,INC,LENR,LENSAV,LENWRK,IER
      DOUBLE PRECISION R(LENR),WSAVE(LENSAV),WORK(LENWRK)
C
      IER = 0
C
      IF (LENR.LT.INC* (N-1)+1) THEN
          IER = 1
          CALL DXERFFT('RFFT1B ',6)
      ELSE IF (LENSAV.LT.N+INT(LOG(DBLE(N)))+4) THEN
          IER = 2
          CALL DXERFFT('RFFT1B ',8)
      ELSE IF (LENWRK.LT.N) THEN
          IER = 3
          CALL DXERFFT('RFFT1B ',10)
      END IF
C
      IF (N.EQ.1) RETURN
C
      CALL DRFFTB1(N,INC,R,WORK,WSAVE,WSAVE(N+1))
      RETURN
      END

      PROGRAM FDLSMTH
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C INVOKE DEMO DRIVER
C
      CALL EXLINE (IWKID)
C
C Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      STOP
      END

      SUBROUTINE EXLINE (IWKID) 
C
C PURPOSE                To provide a simple demonstration of the
C                        smoothing and crowded line removal techniques.
C
C USAGE                  CALL EXLINE (IWKID)
C
C ARGUMENTS
C
C ON INPUT               IWKID
C                          Workstation id
C
C LANGUAGE               FORTRAN
C
C PORTABILITY            FORTRAN 77
C
C NOTE                   The call to GOPWK will have to be modified
C                        when using a non-NCAR GKS package.  The third
C                        argument must be the workstation type for WISS.
C
C
      REAL XCOORD(10), YCOORD(10)
C
C Establish the viewport and window.
C
      CALL SET(.01,.99,0.01,.99,0.,1.,0.,1.,1)
C
C Initialize the crowded line removal buffer
C
      CALL RESET
C
C Set up a color table
C
C     White background
C
      CALL GSCR (IWKID,0,1.,1.,1.)
C
C Black foreground
C
      CALL GSCR (IWKID,1,0.,0.,0.)
C
C Red
C
      CALL GSCR (IWKID,2,1.,0.,0.)
C
C Green
C
      CALL GSCR (IWKID,3,0.,1.,0.)
C
C Blue
C
      CALL GSCR (IWKID,4,0.,0.,1.)
C
C Set line color
C
      CALL GSPLCI(4)
C
C Set line width
C
      CALL GSLWSC(1.)
        
      DO 10 I=1,50
C
C Get the coordinates for a circle in the center of the frame
C
         CALL GNCRCL(REAL(I)/50.,.5,.333,10,XCOORD, YCOORD)
C
C Draw it
C
         CALL CURVED(XCOORD,YCOORD,10)
 10   CONTINUE
C
C Draw a label in the center
C
      CALL PLCHLQ(.5,.95,'Smoothing and Crowded Line Removal',.02,0.,0.)
C
C Advance the Frame
C
      CALL FRAME
C
      END

      SUBROUTINE GNCRCL(XCNTR, YCNTR, RAD, NPTS, XCOORD, YCOORD)
      INTEGER NPTS
      REAL XCNTR, YCNTR, RAD, XCOORD(NPTS), YCOORD(NPTS)

C
C This function generates the coordinates for a circle with
C center at XCNTR, YCNTR, and a radius of RAD.  There are
C NPTS in the circle and the coordinates are returned in the
C arrays XCOORD and YCOORD.
C
C Compute number of radians per degree
C
      RADPDG = 2.*3.14159/360.
C
C Initialize the angle
C
       ANGLE = 0.
C
C Calculate the change in angle (360./number of points in circle)
C
       DELTA = 360./(NPTS-1)
C
C Convert to radians
C
       DELTA = DELTA * RADPDG
C
C Calculate each coordinate
C
       DO 10 I=1,NPTS
          XCOORD(I) = RAD * (COS(ANGLE)) + XCNTR
          YCOORD(I) = RAD * (SIN(ANGLE)) + YCNTR
          ANGLE = ANGLE + DELTA
  10   CONTINUE

       RETURN
       END

C
C	$Id: mstrms.f,v 1.4 2008-07-27 00:17:31 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MSTRMS (DIAG,SDIAG,SIGMA,DEL)
C
C ---------------------------------------------------------------------
C Note:  This routine comes from a proprietary package called FITPACK.
C It is used in the NCAR graphics package by permission of the author,
C Alan Cline.
C ---------------------------------------------------------------------
C
C                                            CODED BY ALAN KAYLOR CLINE
C                                         FROM FITPACK -- JUNE 22, 1986
C                                   A CURVE AND SURFACE FITTING PACKAGE
C                                 A PRODUCT OF PLEASANT VALLEY SOFTWARE
C                             8603 ALTUS COVE, AUSTIN, TEXAS 78759, USA
C
C ---------------------------------------------------------------------
C
C THIS SUBROUTINE COMPUTES THE DIAGONAL AND SUPERDIAGONAL
C TERMS OF THE TRIDIAGONAL LINEAR SYSTEM ASSOCIATED WITH
C SPLINE UNDER TENSION INTERPOLATION.
C
C ON INPUT--
C
C   SIGMA CONTAINS THE TENSION FACTOR.
C
C   DEL CONTAINS THE STEP SIZE.
C
C ON OUTPUT--
C
C                SIGMA*DEL*COSH(SIGMA*DEL) - SINH(SIGMA*DEL)
C   DIAG = DEL*--------------------------------------------.
C                     (SIGMA*DEL)**2 * SINH(SIGMA*DEL)
C
C                   SINH(SIGMA*DEL) - SIGMA*DEL
C   SDIAG = DEL*----------------------------------.
C                (SIGMA*DEL)**2 * SINH(SIGMA*DEL)
C
C   SIGMA AND DEL ARE UNALTERED.
C
C THIS SUBROUTINE REFERENCES PACKAGE MODULE MSSHCH.
C
C-----------------------------------------------------------
C
      IF (SIGMA .NE. 0.) GO TO 1
      DIAG = DEL/3.
      SDIAG = DEL/6.
      RETURN
    1 SIGDEL = SIGMA*DEL
      CALL MSSHCH (SINHM,COSHM,SIGDEL,0)
      DENOM = SIGMA*SIGDEL*(1.+SINHM)
      DIAG = (COSHM-SINHM)/DENOM
      SDIAG = SINHM/DENOM
      RETURN
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                     C
C                          Copyright (C)  1995                        C
C               University Corporation for Atmospheric Research       C
C                          All Rights Reserved                        C
C                                                                     C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C     File:         ap01f.f
C
C     Author:       Jeff W. Boote 
C                   (translated to Fortran by David Younghans)
C
C     Date:         Tue September 26, 1995
C
C     Description:  This very simple Fortran program illustrates the
C                   steps involved in creating an HLU.
C
C

      program ap01f
      implicit none
      external NhlFAppClass
      external NhlFNcgmWorkstationClass
      external NhlFCairoWindowWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFTextItemClass

      integer appid,workid,textid
      integer rlist,ierr
      CHARACTER*7  wks_type
C
C Define the workstation type
C
      wks_type = "x11"

C
C Initialize the HLU library.
C
      call NhlFInitialize

C
C Create a ResList. The ResList is a list of the resources 
C and values being explicitly set during the "NhlFCreate" call.
C
      call NhlFRLCreate(rlist,'SETRL')

C
C Create an App object so we can have an application specific
C resource file for this example. Since the App object is the
C one that readsin the application specific resource files,
C these resources must be set prgrammatically. (They could
C be set in the $(NCARG_SYSRESFILE) or $(NCARG_USRRESFILE), but
C these thing are pretty specific to this example, so I am
C setting them programmatically.)
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'appDefaultParent','True',ierr)
      call NhlFRLSetString(rlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'ap01',NhlFAppClass,0,rlist,ierr)

C
C Create the Workstation to manage the output device.
C Since the appDefaultParent resource was set to True for
C 'ap01', we can use either 0 or appid as the Parent id.
C They mean the same thing.
C
      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create a metafile workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkMetaName','./ap01f.ncgm',ierr)
         call NhlFCreate(workid,'x',
     &        NhlFNcgmWorkstationClass,0,rlist,ierr)

      elseif (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X11 workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPause','True',ierr)
         call NhlFCreate(workid,'x',
     &        NhlFCairoWindowWorkstationClass,0,rlist,ierr)

      elseif (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PS workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPSFileName','./ap01f.ps',ierr)
         call NhlFCreate(workid,'x',
     &        NhlFPSWorkstationClass,0,rlist,ierr)
      elseif (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPDFFileName','./ap01f.pdf',ierr)
         call NhlFCreate(workid,'x',
     &        NhlFPDFWorkstationClass,0,rlist,ierr)
      elseif (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     &        wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS or PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFileName','./ap01f',ierr)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(workid,'x',
     &        NhlFCairoPSPDFWorkstationClass,0,rlist,ierr)
      elseif (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFileName','./ap01f',ierr)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(workid,'x',
     &        NhlFcairoImageWorkstationClass,0,rlist,ierr)
      endif

C
C Destroy the ResList.
C Since I am not setting any more resources programmatically, I
C don't need the ResList anymore.
C
      call NhlFRLDestroy(rlist,ierr)

C
C Create a TextItem. I am not programmatically setting any of
C the TextItem resources, so the Resource Database made up from
C the resource file read-in by the 'ap01' App object is specifying
C all the attributes to the TextItem.
C
      call NhlFcreate(textid,'tx1',NhlFTextItemClass,workid,0,ierr)

C
C Call draw on the Workstation Object. This will cause all of the
C Workstation's children to Draw. In this case, this is only
C 'tx1', so draw could have been called on it just as easily.
C
      call NhlFDraw(workid,ierr)

C
C Call frame on the Workstation Object. This is functionally
C equivalent to calling NhlFUpdateWorkstation, and then
C NhlFClearWorkstation.
C
      call NhlFFrame(workid,ierr)

C
C Destroying an object also destroys its children, so by destroying
C 'ap01', all of the objects get destroyed.
C
      call NhlFDestroy(appid,ierr)

C
C Close the HLU library.
C
      call NhlFClose

      stop

      end

      PROGRAM VVEX03
C
C
C This example illustrates use of the user-modifiable routine
C VVUMXY to create user-defined mappings of vector data.
C The first frame demonstrates a method of plotting data contained
C  in an irregularly spaced rectangular grid. 
C The second frame plots scattered (non-gridded) data.
C The third frame maps scattered data through an EZMAP projection.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Open GKS, open workstation of type 1, activate workstation
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Draw an irregularly gridded vector plot.
C
      CALL IRREX
C
C Draw a scattered vector plot.
C
      CALL SCTREX
C
C Draw a plot of scattered vectors mapped through an Ezmap projection.
C
      CALL SCEZEX
C
C     Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      STOP
      END
C
C =============================================================
C
      SUBROUTINE IRREX
C
C     
      PARAMETER (M=10,N=10)
      DIMENSION U(M,N), V(M,N)
C
C User-defined common block containing irregular grid coordinates.
C
      PARAMETER (PI=3.14159)
      PARAMETER (MAXDIM = 100)
      COMMON /VVUSER/ XCOORD(MAXDIM),YCOORD(MAXDIM)
      SAVE /VVUSER/
C
C Local arrays to hold the coordinate data.
C
      DIMENSION XCLOC(M), YCLOC(N)
C
      DATA XGRID / 100.0 /
      DATA YGRID / 100.0 /
      DATA XCLOC / 0.0,7.5,20.0,40.0,45.0,65.0,70.0,77.0,90.0,95.0 /
      DATA YCLOC / 12.5,22.5,30.0,35.0,52.0,58.0,70.0,75.0,85.0,90.0 /
C
C
C Specify the NDC coordinates for a plot title.
C
        DATA FX / 0.5 /, FY / 0.975 /
C
C Set up a functionally defined vector field
C
      GXSIZE = PI/XGRID
      GYSIZE = PI/YGRID
      DO  20 I=1,M
         DO  10 J=1,N
            U(I,J) = COS(GXSIZE*(XCLOC(I)))
            V(I,J) = SIN(GYSIZE*(YCLOC(J)))
   10    CONTINUE
   20 CONTINUE
C
C Copy coordinate values into the VVUSER common block arrays, in
C order to make the data accessible to VVUMXY.
C
      DO 30 I=1,M
         XCOORD(I) = XCLOC(I)
 30   CONTINUE
C
      DO 40 I=1,N
         YCOORD(I) = YCLOC(I)
 40   CONTINUE
C
C Set the user space (arguments 5,6,7, and 8 of the SET call) to contain 
C the extremes of the values assigned to the coordinate arrays; then
C tell Vectors not to do a SET call.
C 
         CALL SET(0.05,0.95,0.05,0.95,0.0,100.0,0.0,100.0,1)
         CALL VVSETI('SET - Do-SET-Call Flag', 0)
C
C Set the data coordinate boundaries equal to the grid coordinate
C boundaries (i.e. the range of the array indexes). This is actually
C the default condition for Vectors, but is included for emphasis here.
C
         CALL VVSETR('XC1 -- Lower X Bound', 1.0)
         CALL VVSETR('XCM -- Upper X Bound', REAL(M))
         CALL VVSETR('YC1 -- Lower Y Bound', 1.0)
         CALL VVSETR('YCN -- Upper Y Bound', REAL(N))
C
C Set the MAP parameter to a value indicating a user-defined mapping
C (anything other than 0, 1, or 2). The routine VVUMXY must be modified
C to recognize this value for MAP.
C
         CALL VVSETI('MAP - user-defined mapping', 3) 
         IDM=0
         RDM=0.0
         CALL VVINIT(U,M,V,M,RDM,IDM,M,N,RDM,IDM)
C
C For an irregular grid the default vector sizes may not be appropriate.
C The following (admittedly cumbersome) code adjusts the size relative 
C to the default size chosen by Vectors. It must follow VVINIT.
C
         VSZADJ = 0.75
         CALL VVGETR('DMX - NDC Maximum Vector Size', DMX)
         CALL GETSET(VL,VR,VB,VT,UL,UR,UB,UT,LL)
         VRL = VSZADJ * DMX / (VR - VL)
         CALL VVSETR('VRL - Vector Realized Length', VRL)
C
         CALL VVECTR(U,V,RDM,IDM,IDM,RDM)
         CALL PERIM(1,0,1,0)
C
C Save the current normalization transformation then set it to 0.
C
         CALL GQCNTN(IERR,ICN)
         CALL GSELNT(0)
         X = CFUX(FX)
         Y = CFUY(FY)
C
C Call PLCHLQ to write the plot title.
C
         CALL PLCHLQ (X,Y,
     1           'Irregularly gridded vector data',
     2           16.,0.,0.)
C
C Restore the normalization transformation.
C
         CALL GSELNT(ICN)
         CALL FRAME
C
 100  CONTINUE
C
      RETURN
C
      END
C
C ==================================================================
C
      SUBROUTINE SCTREX
C
C In this routine the U and V arrays are treated as single-dimensioned
C entities. The location of the vector with components U(I),V(I) is
C specified by XCLOC(I),YCLOC(I). The coordinate locations are copied
C to the common block VVUSER in order to make them accessible to the
C the user-defined mapping routine, VVUMXY.
C
C Since Vectors expects 2-D arrays for U and V, the input parameters
C M and N multiplied together should equal the total number of elements 
C in each of the 1-D data arrays.
C  
      PARAMETER (M=10,N=1)
      DIMENSION U(M*N), V(M*N)
C
C User-defined common block containing X and Y locations of each 
C vector.
C
      PARAMETER (MAXDIM = 100)
      COMMON /VVUSER/ XCOORD(MAXDIM),YCOORD(MAXDIM)
      SAVE /VVUSER/
C
C All data lies within a 100 x 100 square (origin 0.0 at lower left).
C
      DIMENSION XCLOC(M*N), YCLOC(M*N)
C
      DATA XCLOC / 40.0,7.5,20.0,35.0,45.0,65.0,75.0,80.0,90.0,95.0 /
      DATA YCLOC / 50.0,80.0,20.0,60.0,15.0,80.0,20.0,45.0,60.0,50.0 /
      DATA U / .3,.6,.8,.2,.9,.8,-.4,-.3,.1,.2 /
      DATA V / -.2,.1,.7,.6,.3,-.4,-.6,-.8,-.9,-.5 /
C
C
C Specify the NDC coordinates for a plot title.
C
        DATA FX / 0.5 /, FY / 0.975 /
C
C Copy coordinate values into the VVUSER common block arrays.
C
      DO 30 I=1,M*N
         XCOORD(I) = XCLOC(I)
 30   CONTINUE
C
      DO 40 I=1,M*N
         YCOORD(I) = YCLOC(I)
 40   CONTINUE
C
C Set the user space (arguments 5,6,7, and 8 of the SET call) to contain 
C the extremes of the values assigned to the coordinate arrays; then
C tell Vectors not to do a SET call.
C 
         CALL SET(0.075,0.925,0.1,0.95,0.0,100.0,0.0,100.0,1)
         CALL VVSETI('SET - Do-SET-Call Flag', 0)
C
C Set the data coordinate boundaries equal to the grid coordinate
C boundaries (i.e. the range of the array indexes). This is actually
C the default condition for Vectors, but is included for emphasis here.
C
         CALL VVSETR('XC1 -- Lower X Bound', 1.0)
         CALL VVSETR('XCM -- Upper X Bound', REAL(M))
         CALL VVSETR('YC1 -- Lower Y Bound', 1.0)
         CALL VVSETR('YCN -- Upper Y Bound', REAL(N))
C
C Set the MAP parameter to a value indicating a user-defined mapping
C (anything other than 0, 1, or 2). The routine VVUMXY must be modified
C to recognize this value for MAP.
C
         CALL VVSETI('MAP - user-defined mapping', 4) 
         IDM=0
         RDM=0.0
         CALL VVINIT(U,M,V,M,RDM,IDM,M,N,RDM,IDM)
C
C For an scattered grid the default vector sizes may not be appropriate.
C The following (admittedly cumbersome) code adjusts the size relative 
C to the default size chosen by Vectors. It must follow VVINIT.
C
         VSZADJ = 0.1
         CALL VVGETR('DMX - NDC Maximum Vector Size', DMX)
         CALL GETSET(VL,VR,VB,VT,UL,UR,UB,UT,LL)
         VRL = VSZADJ * DMX / (VR - VL)
         CALL VVSETR('VRL - Vector Realized Length', VRL)
C
         CALL VVECTR(U,V,RDM,IDM,IDM,RDM)
         CALL PERIM(1,0,1,0)
C
C
C Save the current normalization transformation then set it to 0.
C
         CALL GQCNTN(IERR,ICN)
         CALL GSELNT(0)
         X = CFUX(FX)
         Y = CFUY(FY)
C
C Call PLCHLQ to write the plot title.
C
         CALL PLCHLQ (X,Y,
     1           'Scattered vector data',
     2           16.,0.,0.)
C
C Restore the normalization transformation.
C
         CALL GSELNT(ICN)
         CALL FRAME
C
 100  CONTINUE
C
      RETURN
C
      END
C
C =================================================================
C
      SUBROUTINE SCEZEX
C
C This routine maps geographically scattered vector data
C through an Ezmap projection. In order to make the effect of the 
C projection more obvious the vectors are given uniform direction 
C and magnitude.
C  
      PARAMETER (M=20,N=1)
      DIMENSION U(M*N), V(M*N)
C
C User-defined common block containing X and Y locations of each 
C vector.
C
      PARAMETER (MAXDIM = 100)
      COMMON /VVUSER/ XCOORD(MAXDIM),YCOORD(MAXDIM)
      SAVE /VVUSER/
C
C All data lies within the region latitude 0.0,90.0 and 
C and longitude 0.0,100.0.
C
      DIMENSION XCLOC(M*N), YCLOC(M*N)
C
      DATA XCLOC / 40.0,7.5,20.0,35.0,40.0,65.0,75.0,80.0,90.0,95.0, 
     +     50.0,80.0,20.0,60.0,15.0,80.0,20.0,45.0,60.0,50.0 /
      DATA YCLOC / 50.0,80.0,20.0,60.0,15.0,80.0,20.0,45.0,60.0,50.0, 
     +     40.0,7.5,20.0,35.0,45.0,65.0,75.0,13.0,24.0,32.0 /
      DATA U / 20 * 1.0 /
      DATA V / 20 * 1.0 /
C
C
C Specify the NDC coordinates for a plot title.
C
        DATA FX / 0.5 /, FY / 0.975 /
C
C Copy coordinate values into the VVUSER common block arrays.
C
      DO 30 I=1,M*N
         XCOORD(I) = XCLOC(I)
 30   CONTINUE
C
      DO 40 I=1,M*N
         YCOORD(I) = YCLOC(I)
 40   CONTINUE
C
C Set up a Satellite view EZMAP projection. Draw the map grid only.
C
      CALL MAPSET('MA',0.0,0.0,0.0,0.0)
      CALL MAPROJ('SV',45.0,50.0,0.0)
      CALL MAPINT
      CALL MAPGRD
C
C Don't let Vectors do a SET call
C
      CALL VVSETI('SET - Do-SET-Call Flag', 0)
C
C Set the data coordinate boundaries equal to the grid coordinate
C boundaries (i.e. the range of the array indexes). This is actually
C the default condition for Vectors, but is included for emphasis here.
C
      CALL VVSETR('XC1 -- Lower X Bound', 1.0)
      CALL VVSETR('XCM -- Upper X Bound', REAL(M))
      CALL VVSETR('YC1 -- Lower Y Bound', 1.0)
      CALL VVSETR('YCN -- Upper Y Bound', REAL(N))
C
C Set the MAP parameter to a value indicating a user-defined mapping
C (anything other than 0, 1, or 2). The routine VVUMXY must be modified
C to recognize this value for MAP.
C
      CALL VVSETI('MAP - user-defined mapping', 5) 
      CALL VVSETR('LWD - vector linewidth', 2.0) 
      IDM=0
      RDM=0.0
      CALL VVINIT(U,M,V,M,RDM,IDM,M,N,RDM,IDM)
C
C Adjust vector sizes.
C
      VSZADJ = 0.1
      CALL VVGETR('DMX - NDC Maximum Vector Size', DMX)
      CALL GETSET(VL,VR,VB,VT,UL,UR,UB,UT,LL)
      VRL = VSZADJ * DMX / (VR - VL)
      CALL VVSETR('VRL - Vector Realized Length', VRL)
C
      CALL VVECTR(U,V,RDM,IDM,IDM,RDM)
      CALL PERIM(1,0,1,0)
C
C
C Save the current normalization transformation then set it to 0.
C
      CALL GQCNTN(IERR,ICN)
      CALL GSELNT(0)
      X = CFUX(FX)
      Y = CFUY(FY)
C
C Call PLCHLQ to write the plot title.
C
      CALL PLCHLQ (X,Y,
     1     'Scattered vector data mapped through an Ezmap projection',
     2     16.,0.,0.)
C
C Restore the normalization transformation.
C
      CALL GSELNT(ICN)
      CALL FRAME
C
 100  CONTINUE
C
      RETURN
C
      END
C
C =================================================================
C
C Modified version of VVUMXY that implements mapping for the 
C following values of the Vectors 'MAP' internal parameter:
C 
C 3 - irregular rectangular grid mapping
C 4 - scattered data mapping
C 5 - scattered data mapped through an Ezmap projection.
C
      SUBROUTINE VVUMXY (X,Y,U,V,UVM,XB,YB,XE,YE,IST)
C
C This is a user modifiable routine that allows custom projections of
C the vector space. X and Y give the vector position within the domain
C of the data space. By default, this space is coincident with the
C grid space (i.e. 1 through dimension lengths of the U and V arrays).
C The vector endpoints are output in fractional coordinates (NDC space).
C Note that this is different from the old MXF and MYF routines, which
C output in 'plotter coordinate' space. It also differs from the 
C Conpack routine CPMPXY, which returns values in user space. 
C 
C VVUMXY (Velocity Vector -- User Map X,Y) is called whenever 
C the internal parameter MAP is set to a value other than 0, 1, or 2.
C
C Based on the magnitude and direction of the vector the start and 
C ending points of the vector are returned in NDC space.
C
C Input parameters:
C
C X,Y   -- vector position in the user coordinate system
C U,V   -- vector components from the U,V arrays for this position
C UVM   -- magnitude of the U,V components (supplied for convenience
C          and efficiency - but note that many mappings do not need 
C          this value)
C
C Output parameters:
C
C XB,YB -- starting point of the vector in fractional coordinates
C          (NDC space)
C XE,YE -- ending point of the vector in fractional coordinates
C          (NDC space)
C IST   -- status results of the mapping: 0 indicates success -- any
C          non-zero value causes VVECTR to discard the vector at this
C          location
C
C The mapping common block: made available to user mapping routines.
C NOTE: all these variables should be considered read-only by VVUMXY.
C
      COMMON /VVMAP/
     +                IMAP       ,
     +                XVPL       ,XVPR       ,YVPB       ,YVPT       ,
     +                WXMN       ,WXMX       ,WYMN       ,WYMX       ,
     +                XLOV       ,XHIV       ,YLOV       ,YHIV       ,
     +                SXDC       ,SYDC       ,NXCT       ,NYCT       ,
     +                RLEN       ,LNLG       ,INVX       ,INVY       ,
     +                ITRT       ,IWCT       ,FW2W       ,FH2H       ,
     +                DVMN       ,DVMX       ,RBIG       ,IBIG
C
      SAVE /VVMAP/
C
C Description of VVMAP contents:
C
C IMAP                - value of the internal parameter 'MAP'
C XVPL,XVPR,YVPB,YVPT - the currently set viewport values. (GETSET
C                       arguments 1, 2, 3, and 4)
C WXMN,WXMX,WYMN,WYMX - the min and max boundaries of user coordinate
C                       space, (usually but not always equivalent to
C                       window coordinates). WXMN and WYMN are true
C                       minimum values even one or both axes is 
C                       inverted. (i.e. they are equivalent to GETSET
C                       arguments 5,6,7, and 8 sorted numerically)
C XLOV,XHIV,YLOV,YHIV - min and max boundaries of the data space, by
C                       default equivalent to the array grid space.
C                       XLOV and YLOV are not necessarily less than 
C                       XHIV and YHIV.
C SXDC,SYDC           - Scaling factors for converting vector component
C                       values into lengths in NDC space.
C NXCT,NYCT           - Length of each dimension of the U and V 
C                       component arrays.
C RLEN                - Length of the maximum vector in user 
C                       coordinates.
C LNLG                - The linear/log mode (GETSET argument 9)
C INVX,INVY           - User coordinates inversion flags: 
C                       0 - not inverted, 1 - inverted
C ITRT                - value of the internal parameter TRT
C IWCT                - not currently used
C FW2W,FH2H           - scale factors for converting from fraction of
C                       viewport width/height to NDC width/height 
C DVMN,DVMX           - min/max vector lengths in NDC
C RBIG,IBIG           - machine dependent maximum REAL/INTEGER values
C
C Math constants:
C
      PARAMETER (PDTOR  = 0.017453292519943,
     +           PRTOD  = 57.2957795130823,
     +           P1XPI  = 3.14159265358979,
     +           P2XPI  = 6.28318530717959,
     +           P1D2PI = 1.57079632679489,
     +           P5D2PI = 7.85398163397448) 
C
C --------------------------------------------------------------------
C User-defined common block:
C
      PARAMETER (MAXDIM = 100)
C
      COMMON /VVUSER/ XCOORD(MAXDIM), YCOORD(MAXDIM)
      SAVE /VVUSER/
C --------------------------------------------------------------------
C Local parameters (used for the Ezmap projection only):
C
C PRCFAC - Precision factor used to resolve float equality within
C            the precision of a 4 byte REAL
C PVFRAC - Initial fraction of the vector magnitude used to
C            determine the differential increment
C PFOVFL - Floating point overflow value
C IPMXCT - Number of times to allow the differential to increase
C PDUVML - Multiplier when the differential is increased
C PCSTST - Test value for closeness to 90 degree latitude
C
      PARAMETER (PRCFAC=1E5,
     +           PVFRAC=0.001,
     +           PFOVFL=1E12,
     +           IPMXCT=40,
     +           PDUVML=2.0,
     +           IPCTST=PRCFAC*90)
C
C ---------------------------------------------------------------------
C
      IF (IMAP .EQ. 3) THEN
C
C Mapping for irregular rectangular gridded vector data.
C 
C Since the array grid and input data space are coincident in this
C case, X and Y converted to integers serve as the index into the 
C coordinate arrays that define the vector location in the user
C coordinate system. 
C This code includes more tests that may be necessary in
C production environments: it does so partly to illustrate how to use
C some of the contents of the VVMAP common block.
C
         I = NINT(X)
         J = NINT(Y)
C
C NXCT and NYCT contain the number of elements along each coordinate
C axis. Therefore the following test ensures that I and J are within
C the domain of the array dimensions.
C
         IF (I.LT.1 .OR. I.GT.NXCT .OR. J.LT.1 .OR. J.GT.NYCT) THEN
            IST = -1
            RETURN
         END IF
         XC = XCOORD(I)
         YC = YCOORD(J)
C
C WXMN, WXMX, WYMN, and WYMX contain the minimum and maximum values of
C the user coordinate space. The following test ensures that the 
C coordinate values in the array are within the current boundaries
C of the user space.
C
         IF (XC.LT.WXMN .OR. XC.GT.WXMX .OR. 
     +        YC.LT.WYMN .OR. YC.GT.WYMX) THEN
            IST = -1
            RETURN
         END IF
         XB=CUFX(XC)
         YB=CUFY(YC)
         XE=XB+U*SXDC
         YE=YB+V*SYDC
C
C ---------------------------------------------------------------------
C
      ELSE IF (IMAP .EQ. 4) THEN
C
C Mapping for scattered vector data.
C 
         I = NINT(X)
         J = NINT(Y)
C
         IF (I.LT.1 .OR. I.GT.NXCT .OR. J.LT.1 .OR. J.GT.NYCT) THEN
            IST = -1
            RETURN
         END IF
C
C Since XCOORD and YCOORD are actually single dimensional arrays,
C convert the 2-d indexes supplied to VVUMXY into their 1-d equivalent 
C to index into the coordinate arrays.
C
         XC = XCOORD(NXCT*(J-1)+I)
         YC = YCOORD(NXCT*(J-1)+I)
C
         IF (XC.LT.WXMN .OR. XC.GT.WXMX .OR. 
     +        YC.LT.WYMN .OR. YC.GT.WYMX) THEN
            IST = -1
            RETURN
         END IF
         XB=CUFX(XC)
         YB=CUFY(YC)
         XE=XB+U*SXDC
         YE=YB+V*SYDC
C
C ---------------------------------------------------------------------
C
      ELSE IF (IMAP .EQ. 5) THEN
C
C Mapping for scattered vector data projected through Ezmap. XCOORD and
C YCOORD contain the Longitude and Latitude respectively of each vector
C datum. 
C  
C 
         I = NINT(X)
         J = NINT(Y)
C
         IF (I.LT.1 .OR. I.GT.NXCT .OR. J.LT.1 .OR. J.GT.NYCT) THEN
            IST = -1
            RETURN
         END IF
C
C Since XCOORD and YCOORD are actually single dimensional arrays,
C convert the 2-d indexes supplied to VVUMXY into their 1-d equivalent 
C to index into the coordinate arrays.
C
         XC = XCOORD(NXCT*(J-1)+I)
         YC = YCOORD(NXCT*(J-1)+I)
C
C The following code is adapted from the Ezmap projection code in 
C VVMPXY. An iterative technique is used that handles most vectors 
C arbitrarily close to the projection limb.
C XC is longitude, YC is latitude.
C
C Test for 90 degree latitude.
C
         IF (INT(ABS(YC)*PRCFAC+0.5).EQ.IPCTST) THEN
            IST=-1
            RETURN
         END IF
C
C Project the starting value: bail out if outside the window
C
         CALL MAPTRA (YC,XC,XB,YB)
         IF (XB .LT. WXMN .OR. XB .GT. WXMX .OR.
     +       YB .LT. WYMN .OR. YB .GT. WYMX) THEN
            IST=-5
            RETURN
         END IF
C
C Check the vector magnitude
C
         IF (INT(UVM*PRCFAC+0.5) .EQ. 0) THEN
            IST=-2
            RETURN
         END IF
C
C The incremental distance is proportional to a small fraction
C of the vector magnitude
C
         DUV=PVFRAC/UVM
         CLT=COS(YC*PDTOR)
C
C Project the incremental distance. If the positive difference doesn't
C work, try the negative difference. If the difference results in a
C zero length vector, try a number of progressively larger increments.
C
         ICT=0
         SGN=1.0
 20      CONTINUE
C
         CALL MAPTRA(YC+SGN*V*DUV,XC+SGN*U*DUV/CLT,XT,YT)
C
         DV1=SQRT((XT-XB)*(XT-XB)+(YT-YB)*(YT-YB))
         IF (DV1 .GT. RLEN) THEN
            IF (SGN .EQ. -1.0) THEN
               IST=-4
               RETURN
            ELSE
               SGN=-1.0
               GO TO 20
            END IF
         END IF
C
         IF (INT(DV1*PRCFAC) .EQ. 0) THEN
            IF (ICT .LT. IPMXCT) THEN
               ICT = ICT + 1
               DUV=DUV*PDUVML
               GO TO 20
            ELSE
               IST=-3
               RETURN
            END IF
         END IF
C
         IF (ABS(XT) .GE. PFOVFL .OR. ABS(YT) .GE. PFOVFL) THEN
            IST=-6
            RETURN
         END IF
C
         T=SGN*((XT-XB)/DV1)*UVM
         XB=CUFX(XB)
         XE=XB+T*SXDC
         T=SGN*((YT-YB)/DV1)*UVM
         YB=CUFY(YB)
         YE=YB+T*SYDC
C
C ---------------------------------------------------------------------
C
      ELSE
C
C Default mapping:
C
C WXMN, WXMX, WYMN, and WYMX contain the minimum and maximum values of
C the user coordinate space. Somewhat inaccurately, the mmenomic 'W'
C implies window coordinate space, which is usually (but not always)
C the same as user coordinate space. But note that even when 
C the coordinates are reversed, you are guaranteed that WXMN .LT. WXMX
C and WYMN .LT. WYMX. This eliminates the need to invoke MIN and MAX.
C
         IF (X.LT.WXMN .OR. X.GT.WXMX .OR. 
     +        Y.LT.WYMN .OR. Y.GT.WYMX) THEN
            IST = -1
            RETURN
         END IF
         XB=CUFX(X)
         YB=CUFY(Y)
         XE=XB+U*SXDC
         YE=YB+V*SYDC

      END IF
C
C Done.
C
      RETURN
C
      END

C
C	$Id: srface.f,v 1.5 2008-07-27 00:17:26 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE SRFACE (X,Y,Z,M,MX,NX,NY,S,STEREO)
C
C DIMENSION OF           X(NX),Y(NY),Z(MX,NY),M(2,NX,NY),S(6)
C ARGUMENTS
C
C PURPOSE                SRFACE draws a perspective picture of a
C                        function of two variables with hidden lines
C                        removed.  The function is approximated by a
C                        two-dimensional array of heights.
C
C USAGE                  If the following assumptions are met, use
C
C                             CALL EZSRFC (Z,M,N,ANGH,ANGV,WORK)
C
C                          assumptions:
C                              .the entire array is to be drawn,
C                              .the data are equally spaced (in the
C                               X-Y plane),
C                              .no stereo pairs,
C                              .scaling is chosen internally.
C
C                        If these assumptions are not met use
C
C                             CALL SRFACE (X,Y,Z,M,MX,NX,NY,S,
C                                          STEREO)
C
C ARGUMENTS
C
C ON INPUT               Z
C FOR EZSRFC               The M by N array to be drawn.
C
C                        M
C                          The first dimension of Z.
C
C                        N
C                          The second dimension of Z.
C
C                        ANGH
C                          Angle in degrees in the X-Y plane to the
C                          line of sight (counter-clockwise from
C                          the plus-X axis).
C
C                        ANGV
C                          Angle in degrees from the X-Y plane to
C                          the line of sight (positive angles are
C                          above the middle Z, negative below).
C
C                        WORK
C                          A scratch storage dimensioned at least
C                          2*M*N+M+N.
C
C ON OUTPUT              Z, M, N, ANGH, ANGV are unchanged.  WORK
C FOR EZSRFC             has been written in.
C
C
C ARGUMENTS
C
C ON INPUT               X
C FOR SRFACE               A linear array NX long containing the X
C                          coordinates of the points in the surface
C                          approximation, in increasing numerical order.
C                          See note, below.
C
C                        Y
C                          A linear array NY long containing the Y
C                          coordinates of the points in the surface
C                          approximation, in increasing numerical order.
C                          See note, below.
C
C                        Z
C                          An array MX by NY containing the surface
C                          to be drawn in NX by NY cells.
C                          Z(I,J) = F(X(I),Y(J)).  See note, below.
C
C                        M
C                          Scratch array at least 2*NX*NY words
C                          long.
C
C                        MX
C                          First dimension of Z.
C
C                        NX
C                          Number of data values in the X direction
C                          (the first subscript direction) in Z.
C                          to be plotted. When plotting an entire
C                          array, MX=NX.
C
C                        NY
C                          Number of data values in the Y direction
C                          (the second subscript direction) to be
C                          plotted.
C
C                        S
C                          S defines the line of sight.  The viewer's
C                          eye is at (S(1), S(2), S(3)) and the
C                          point looked at is at (S(4), S(5), S(6)).
C                          The eye should be outside the block with
C                          opposite corners (X(1), Y(1), ZMIN) and
C                          (X(NX), Y(NY), ZMAX) and the point looked
C                          at should be inside it.  For a nice
C                          perspective effect, the distance between
C                          the eye and the point looked at should be
C                          5 to 10 times the size of the block.  See
C                          note, below.
C
C                        STEREO
C                          Flag to indicate if stereo pairs are to
C                          be drawn.  0.0 means no stereo pair (one
C                          picture).  Non-zero means put out two
C                          pictures.  The value of STEREO is the
C                          relative angle between the eyes.  A value
C                          of 1.0 produces standard separation.
C                          Negative STEREO reverses the left and
C                          right figures.  See the documentation below
C                          for internal variable ISTP for additional
C                          information.
C
C ON OUTPUT              X, Y, Z, MX, NX, NY, S, STEREO are
C FOR SRFACE             unchanged.  M has been written in.
C
C NOTES                  . The range of Z compared with the range
C                          of X and Y determines the shape of the
C                          picture.  They are assumed to be in the
C                          same units and not wildly different in
C                          magnitude.  S is assumed to be in the
C                          same units as X, Y, and Z.
C                        . Picture size can be made relative to
C                          distance.  See comments in SETR.
C                        . TRN32S can be used to translate from 3
C                          space to 2 space.  See comments there.
C                        . Data with extreme discontinuities may
C                          cause visibility errors.  If this problem
C                          occurs, use a distant eye position
C                          away from the +Z axis.
C                        . The default line color is set to
C                          color index 1.  If the user wishes to
C                          change the line color, he can do so by
C                          defining color index 1 before calling
C                          SRFACE, or by putting the common block
C                          SRFINT in his calling program and
C                          defining and using color index ISRFMJ
C                          (defaulted to 1 in BLOCKDATA.)
C
C ENTRY POINTS           SRFACE, SRFGK, EZSRFC, SETR, DRAWS, TRN32S,
C                        CLSET, CTCELL, SRFABD
C
C COMMON BLOCKS          SRFACE, SRFINT, SRFBLK, PWRZIS, SRFIP1
C
C REQUIRED LIBRARY       The SPPS.
C ROUTINES
C
C REQUIRED GKS LEVEL     0A
C
C I/O                    Plots
C
C PRECISION              Single
C
C LANGUAGE               FORTRAN
C
C HISTORY                Converted to FORTRAN 77 and GKS in March 1984.
C
C                        Prepared for SIGGRAPH, August 1976.
C
C                        Standardized in January 1973.
C
C                        Written in December 1971.  Replaced K.S.+G.
C                        algorithm called SOLIDS at NCAR.
C
C
C ALGORITHM              The data are processed from the near side of
C                        of the surface to the far side.  Visibility
C                        information is stored (see reference.)
C                        Highest so far is visible from above.
C
C REFERENCE              Wright, T.J., A Two Space Solution to the
C                        Hidden Line Problem for Plotting a Function
C                        of Two Variables.  IEEE Trans. Comp.,
C                        pp 28-33, January 1973.
C
C ACCURACY               If the ends of a line segment are visible,
C                        the middle is assumed visible.
C
C TIMING                 Proportional to NX*NY.
C
C
C INTERNAL PARAMETERS    name   default  function
C                        ----   -------  --------
C                        IFR        1    -1  Call FRAME first.
C                                         0  Do not call FRAME.
C                                        +1  Call FRAME when done.
C
C                        ISTP       0    STEREO type if STEREO
C                                        non-zero.
C                                        -1  Alternating frames,
C                                            slightly offset (for
C                                            movies,  IROTS = 0).
C                                         0  Blank frame between
C                                            for stereo slide.
C                                            IROTS = 1).
C                                        +1  Both on same frame.
C                                            (left picture to left
C                                            side.  IROTS = 0).
C
C                        IROTS      0     0  +Z in vertical plotting
C                                            direction (CINE mode).
C                                        +1  +Z in horizontal
C                                            plotting direction
C                                            (COMIC mode).
C
C                        IDRX       1    +1  Draw lines of constant
C                                            X.
C                                         0  Do not.
C
C                        IDRY       1    +1  Draw lines of constant
C                                            Y.
C                                         0  Do not.
C
C                        IDRZ       0    +1  Draw lines of constant
C                                            Z (contour lines).
C                                         0  Do not.
C
C                        IUPPER     0    +1  Draw upper side of
C                                            surface.
C                                         0  Draw both sides.
C                                        -1  Draw lower side.
C
C                        ISKIRT     0    +1  Draw a skirt around the
C                                            surface.
C                                            BOTTOM = HSKIRT.
C                                         0  Do not.
C
C                        NCLA       6    Approximate number of
C                                        levels of constant Z that
C                                        are drawn if levels are not
C                                        specified.  40 levels
C                                        maximum.
C
C                        THETA    .02    Angle, in radians, between
C                                        eyes for stereo pairs.
C
C                        HSKIRT    0.    Height of skirt
C                                            (if ISKIRT = 1).
C
C                        CHI       0.    Highest level of constant
C                                        Z.
C
C                        CLO       0.    Lowest level of constant Z.
C
C                        CINC      0.    Increment between levels.
C
C                          [If CHI, CLO, or CINC is zero, a nice
C                           value is generated automatically.]
C
C                        IOFFP     0     Flag to control use of special
C                                        value feature.  Do not have
C                                        both IOFFP=1 and ISKIRT=1.
C                                         0 Feature not in use
C                                        +1  Feature in use.  No lines
C                                            drawn to data points in Z
C                                            that are equal to SPVAL.
C
C                        SPVAL     0.    Special value used to mark un-
C                                        known data when IOFFP=1.
C
C
C
      DIMENSION       X(NX)      ,Y(NY)      ,Z(MX,NY)   ,M(2,NX,NY) ,
     1                S(6)
      DIMENSION       WIND(4)    ,VIEW(4)    ,LASF(13)
      COMMON /SRFINT/ ISRFMJ     ,ISRFMN     ,ISRFTX
C
C  Do a call forcing a BLOCKDATA to be loaded from a binary library.
C
      CALL SRFABD
C
      CALL Q8QST4 ('GRAPHX','SRFACE','SRFACE','VERSION 01')
C
C     THIS DRIVER SAVES THE CURRENT NORMALIZATION TRANSFORMATION
C     INFORMATION, DEFINES THE NORMALIZATION TRANSFORMATION
C     APPROPRIATE FOR SRFGK, CALLS SRFGK, AND RESTORES THE ORIGINAL
C     NORMALIZATION TRANSFORMATION.
C
C     Save current SET parameters.
C
      CALL GETSET (VIEW(1),VIEW(2),VIEW(3),VIEW(4),
     +             WIND(1),WIND(2),WIND(3),WIND(4),IOLLS)
C
C
C
C
C
C     SET WINDOW AND VIEWPORT FOR SRFGK
C
      CALL SET(0.,1.,0.,1.,1.,1024.,1.,1024.,1)
C
C     SET LINE COLOR TO INDIVIDUAL (SAVE CURRENT SETTING)
C
      CALL GQASF (IER,LASF)
      LASFSV  = LASF(3)
      LASF(3) = 1
      CALL GSASF(LASF)
C
C     SET LINE COLOR INDEX TO COMMON VARIABLE ISRFMJ (SAVE
C     CURRENT SETTING)
C
      CALL GQPLCI (IER,LCISV)
      CALL GSPLCI (ISRFMJ)
C
C     DRAW PLOT
C
      CALL SRFGK (X,Y,Z,M,MX,NX,NY,S,STEREO)
C
C     RESTORE INITIAL LINE COLOR SETTINGS
C
      LASF(3) = LASFSV
      CALL GSASF(LASF)
      CALL GSPLCI (LCISV)
C
C     RESTORE ORIGINAL NORMALIZATION TRANSFORMATION
C
      CALL SET(VIEW(1),VIEW(2),VIEW(3),VIEW(4),
     +         WIND(1),WIND(2),WIND(3),WIND(4),IOLLS)
C
C
      RETURN
      END

C
C $Id: asindp.f,v 1.5 2008-07-27 00:17:08 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      DOUBLE PRECISION FUNCTION ASINDP (CON)
C
C This function adjusts for round-off errors in computing the arcsine.
C
      IMPLICIT DOUBLE PRECISION (A-Z)
      DATA ONE /1.0D0/
C
      IF (ABS(CON) .GT. ONE) THEN
         CON = SIGN (ONE,CON)
      ENDIF
C
      ASINDP = ASIN (CON)
C
      RETURN
C
      END

      SUBROUTINE CFFTB1(N,C,CH,WA,IFAC)
      DOUBLE PRECISION C
      DOUBLE PRECISION CH
      DOUBLE PRECISION WA
      DIMENSION CH(*),C(*),WA(*),IFAC(*)

      NF = IFAC(2)
      NA = 0
      L1 = 1
      IW = 1
      DO 116 K1 = 1,NF
          IP = IFAC(K1+2)
          L2 = IP*L1
          IDO = N/L2
          IDOT = IDO + IDO
          IDL1 = IDOT*L1
          IF (IP.NE.4) GO TO 103
          IX2 = IW + IDOT
          IX3 = IX2 + IDOT
          IF (NA.NE.0) GO TO 101
          CALL PASSB4(IDOT,L1,C,CH,WA(IW),WA(IX2),WA(IX3))
          GO TO 102
  101     CALL PASSB4(IDOT,L1,CH,C,WA(IW),WA(IX2),WA(IX3))
  102     NA = 1 - NA
          GO TO 115
  103     IF (IP.NE.2) GO TO 106
          IF (NA.NE.0) GO TO 104
          CALL PASSB2(IDOT,L1,C,CH,WA(IW))
          GO TO 105
  104     CALL PASSB2(IDOT,L1,CH,C,WA(IW))
  105     NA = 1 - NA
          GO TO 115
  106     IF (IP.NE.3) GO TO 109
          IX2 = IW + IDOT
          IF (NA.NE.0) GO TO 107
          CALL PASSB3(IDOT,L1,C,CH,WA(IW),WA(IX2))
          GO TO 108
  107     CALL PASSB3(IDOT,L1,CH,C,WA(IW),WA(IX2))
  108     NA = 1 - NA
          GO TO 115
  109     IF (IP.NE.5) GO TO 112
          IX2 = IW + IDOT
          IX3 = IX2 + IDOT
          IX4 = IX3 + IDOT
          IF (NA.NE.0) GO TO 110
          CALL PASSB5(IDOT,L1,C,CH,WA(IW),WA(IX2),WA(IX3),WA(IX4))
          GO TO 111
  110     CALL PASSB5(IDOT,L1,CH,C,WA(IW),WA(IX2),WA(IX3),WA(IX4))
  111     NA = 1 - NA
          GO TO 115
  112     IF (NA.NE.0) GO TO 113
          CALL PASSB(NAC,IDOT,IP,L1,IDL1,C,C,C,CH,CH,WA(IW))
          GO TO 114
  113     CALL PASSB(NAC,IDOT,IP,L1,IDL1,CH,CH,CH,C,C,WA(IW))
  114     IF (NAC.NE.0) NA = 1 - NA
  115     L1 = L2
          IW = IW + (IP-1)*IDOT
  116 CONTINUE
      IF (NA.EQ.0) RETURN
      N2 = N + N
      DO 117 I = 1,N2
          C(I) = CH(I)
  117 CONTINUE
      RETURN
      END

c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by UCAR                 .
c  .                                                             .
c  .       University Corporation for Atmospheric Research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                         SPHEREPACK                          .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c ... file visgau.f
c
c     contains documentation and code for subroutine visgau
c
      SUBROUTINE DVISGAU(NLAT,NLON,H,LEN,EYER,EYELAT,EYELON,THETA,WK,
     +                  LWK,IWK,LIWK,IERROR)
      DOUBLE PRECISION H
      DOUBLE PRECISION EYER
      DOUBLE PRECISION EYELAT
      DOUBLE PRECISION EYELON
      DOUBLE PRECISION WK
      DOUBLE PRECISION PI
      DOUBLE PRECISION DTR
      DOUBLE PRECISION XEYE
      DOUBLE PRECISION YEYE
      DOUBLE PRECISION ZEYE
c
c     subroutine visgau produces a three dimensional visible rendering
c     of the function h(i,j) which is tabulated on a gauss distributed
c     colatitude grid.
c
c     requires  setgau alfk lfpt gaqd drst dintql dpytha
c               visgau embed intrpg sptcg diag stride
c               trigau vsurf vsurf1 prjct box icvmg projct
c
c     tvisgau uses the ncar graphics package.
c     compile with: ncargf77 (all programs above)
c
c     execute with:  a.out
c
c     on screen display with:  ctrans -d x11 gmeta
c
c     print with:  ctrans -d ps.color gmeta > gmeta.ps
c                  lpr -p(your printer) gmeta.ps
c
c     input parameters
c
c     nlat   the number of gauss colatitudes.
c            if nlat is odd the equator is located at
c            grid point i=(nlat+1)/2. if nlat is even the equator is
c            located half way between points i=nlat/2 and i=nlat/2+1.
c            nlat must be at least 3. note: on the half sphere, the
c            number of grid points in the colatitudinal direction is
c            nlat/2 if nlat is even or (nlat+1)/2 if nlat is odd.
c
c     nlon   the number of distinct londitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater
c            than or equal to 4. the efficiency of the computation is
c            improved when nlon is a product of small prime numbers.
c
c
c     h      a two dimensional array that contains the discrete
c            function to be displayed. h(i,j) is the distance from the
c            center of the sphere to the surface at gauss colatitude
c            point theta(i) and longitude point
c            phi(j) = (j-1)*2*pi/nlon.
c
c     len    the first dimension of the array h as it appears in the
c            program that calls sphere.
c
c     eyer   the distance from the center of the sphere to the eye.
c
c     eyelat the colatitudinal coordinate of the eye (in degrees).
c
c     eyelon the longitudinal  coordinate of the eye (in degrees).
c
c     theta  a double precision  array with nlat gauss colatitudes
c            computed by subroutine gaqd
c
c     wk     a real work array
c
c     lwk    the dimension of the array wk as it appears in the
c            program that calls visgau. lwk must be at least
c                       46*(nlat+2)*(nlon+1).
c
c     iwk    an integer work array
c
c     liwk   the dimension of the array iwk as it appears in the
c            program that calls visgau. liwk must be at least
c                       14*(nlat+2)*(nlon+1).
c
c     ierror = 0    no error
c            = 1    the eye is positioned inside the sphere
c            = 2    lwk  is less than 46*(nlat+2)*(nlon+1)
c            = 3    liwk is less than 14*(nlat+2)*(nlon+1)
c
c
      DIMENSION H(LEN,NLON),WK(*)
      INTEGER IWK(*)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION THETA(NLAT)

      N = NLAT + 2
      M = NLON + 1
      MN = M*N
      IERROR = 2
      IF (LWK.LT.46*MN) RETURN
      IERROR = 3
      IF (LIWK.LT.14*MN) RETURN
      IERROR = 1
      DO 10 J = 1,NLON
          DO 10 I = 1,NLAT
              IF (EYER.LE.H(I,J)) RETURN
   10 CONTINUE
      IERROR = 0
c     ****     set up pointers to sub work arrays in wk
      NTRI = MN + MN
      NW1 = 1
      NW2 = NW1 + MN
      NCLAT = 1
      NSLAT = NCLAT + N
      NXP = 1
      NYP = NXP + MN
      NX1 = 1
      NY1 = NX1 + NTRI
      NZ1 = NY1 + NTRI
      NX2 = NZ1 + NTRI
      NY2 = NX2 + NTRI
      NZ2 = NY2 + NTRI
      NX3 = NZ2 + NTRI
      NY3 = NX3 + NTRI
      NZ3 = NY3 + NTRI
      NX = NZ3 + NTRI
      NY = NX + MN
      NZ = NY + MN
      NWRK = NX
      NITYPE = 1
      NIFLAG = NTRI + 1
      NMST = NIFLAG + MN
      NMFAC = NMST + N
c     **** embed h in a larger array
      CALL DEMBED(NLAT,NLON,H,LEN,WK(NZ1))
c     ****     mid-cell interpolation
      CALL DINTRPG(WK(NZ1),M,N,WK(NW1),WK(NW2),IWK(NIFLAG))
c     ****     transform grid points to cartesian coordinates
      CALL DSPTCG(WK(NZ1),M,N,THETA,WK(NCLAT),WK(NSLAT),WK(NX),WK(NY),
     +           WK(NZ))
c     ****     transform eye position to cartesian coordinates
      PI = 4.D0*ATAN(1.D0)
      DTR = PI/180.D0
      XEYE = EYER*SIN(DTR*EYELAT)
      YEYE = XEYE*SIN(DTR*EYELON)
      XEYE = XEYE*COS(DTR*EYELON)
      ZEYE = EYER*COS(DTR*EYELAT)
c     ****     project grid points
      CALL DPROJCT(M,N,XEYE,YEYE,ZEYE,WK(NX),WK(NY),WK(NZ),WK(NXP),
     +            WK(NYP))
c     ****     check for visibility of cell boundaries
      CALL DDIAG(M,N,WK(NXP),WK(NYP),IWK(NIFLAG))
c     ****     compute longitude stride as a function of latitude
      CALL DSTRIDE(M,N,IWK(NMST),IWK(NMFAC))
c     ****     perform triangulation
      CALL DTRIGAU(M,N,WK(NX),WK(NY),WK(NZ),ITRI,WK(NX1),WK(NY1),
     +             WK(NZ1),WK(NX2),WK(NY2),WK(NZ2),WK(NX3),WK(NY3),
     +             WK(NZ3),IWK(NITYPE),IWK(NIFLAG),IWK(NMST))
c     ****     call surface plotting routine
      CALL DVSURF(XEYE,YEYE,ZEYE,ITRI,WK(NX1),WK(NY1),WK(NZ1),WK(NX2),
     +           WK(NY2),WK(NZ2),WK(NX3),WK(NY3),WK(NZ3),IWK(NITYPE),
     +           WK(NWRK),IWK(NIFLAG))
      RETURN
      END
      SUBROUTINE DEMBED(NLAT,NLON,H,LEN,HG)
      DOUBLE PRECISION H
      DOUBLE PRECISION HG
      DOUBLE PRECISION SUMN
      DOUBLE PRECISION SUMS
      DIMENSION H(LEN,NLON),HG(NLAT+2,NLON+1)

      DO 10 I = 1,NLAT
          DO 10 J = 1,NLON
              HG(I+1,J) = H(I,J)
   10 CONTINUE
      SUMN = 0.D0
      SUMS = 0.D0
      DO 15 J = 1,NLON
          SUMN = SUMN + H(1,J)
          SUMS = SUMS + H(NLAT,J)
   15 CONTINUE
      SUMN = SUMN/NLON
      SUMS = SUMS/NLON
      DO 20 J = 1,NLON
          HG(1,J) = SUMN
          HG(NLAT+2,J) = SUMS
   20 CONTINUE
      DO 25 I = 1,NLAT + 2
          HG(I,NLON+1) = HG(I,1)
   25 CONTINUE
      RETURN
      END
      SUBROUTINE DINTRPG(H,M,N,W1,W2,IFLAG)
      DOUBLE PRECISION H
      DOUBLE PRECISION W1
      DOUBLE PRECISION W2
      DOUBLE PRECISION STEN
c     ****     interpolates to mid points of grid cells using second
c     ****     order formula
      DIMENSION H(N,M),W1(N,M),W2(N,M+2),IFLAG(N,M),STEN(4,4)
      DATA STEN/.015625D0,2*-.078125D0,.015625D0,-.078125D0,2*.390625D0,
     +     2*-.078125D0,2*.390625D0,-.078125D0,.015625D0,2*-.078125D0,
     +     .015625D0/
c     ****     copy h to w2
      MM1 = M - 1
      DO 1 I = 1,MM1
          DO 1 J = 1,N
              W2(J,I+1) = H(J,I)
    1 CONTINUE
c     ****     add periodic points
      DO 2 J = 1,N
          W2(J,1) = W2(J,M)
          W2(J,M+1) = W2(J,2)
          W2(J,M+2) = W2(J,3)
    2 CONTINUE
c     ****     perform interpolation
c     ****     set w1 to zero
      DO 7 I = 1,M
          DO 7 J = 1,N
              W1(J,I) = 0.D0
    7 CONTINUE
c     ****     interpolate
      DO 8 K = 1,4
          DO 8 L = 1,4
              DO 8 I = 1,M - 1
                  DO 8 J = 2,N - 2
                      W1(J,I) = W1(J,I) + W2(J+L-2,I+K-1)*STEN(K,L)
    8 CONTINUE
c     ****     set up iflag array
c     ****     iflag(j,i)=0  if diagonal is (j,i) to (j+1,i+1)
c     ****     iflag(j,i)=16 if diagonal is (j+1,i), (j,i+1)
      DO 9 I = 1,M - 1
          DO 9 J = 2,N - 2
              IFLAG(J,I) = ICVMG(16,0,ABS(.5D0* (W2(J,I+1)+W2(J+1,
     +                     I+2))-W1(J,I))-ABS(.5D0* (W2(J,I+2)+W2(J+1,
     +                     I+1))-W1(J,I)))
    9 CONTINUE
      RETURN
      END
      SUBROUTINE DSPTCG(R,M,N,THETA,CLAT,SLAT,X,Y,Z)
      DOUBLE PRECISION R
      DOUBLE PRECISION CLAT
      DOUBLE PRECISION SLAT
      DOUBLE PRECISION X
      DOUBLE PRECISION Y
      DOUBLE PRECISION Z
      DOUBLE PRECISION PI
      DOUBLE PRECISION DP
      DOUBLE PRECISION THET
      DOUBLE PRECISION CLON
      DOUBLE PRECISION SLON
c     ****     transforms from spherical to cartesian coordinates
      DIMENSION R(N,M),CLAT(N),SLAT(N),X(N,M),Y(N,M),Z(N,M)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION THETA(*)

      PI = 4.D0*ATAN(1.D0)
      DP = (PI+PI)/ (M-1)
      CLAT(1) = 1.D0
      SLAT(1) = 0.D0
      DO 10 J = 2,N - 1
          THET = THETA(J-1)
          CLAT(J) = COS(THET)
          SLAT(J) = SIN(THET)
   10 CONTINUE
      CLAT(N) = -1.D0
      SLAT(N) = 0.D0
      DO 20 I = 1,M - 1
          CLON = COS((I-1)*DP)
          SLON = SIN((I-1)*DP)
          DO 20 J = 1,N
              X(J,I) = R(J,I)*SLAT(J)
              Y(J,I) = X(J,I)*SLON
              X(J,I) = X(J,I)*CLON
              Z(J,I) = R(J,I)*CLAT(J)
   20 CONTINUE
      DO 30 J = 1,N
          X(J,M) = X(J,1)
          Y(J,M) = Y(J,1)
          Z(J,M) = Z(J,1)
   30 CONTINUE
      RETURN
      END
      SUBROUTINE DDIAG(M,N,XP,YP,IFLAG)
      DOUBLE PRECISION XP
      DOUBLE PRECISION YP
      DOUBLE PRECISION CP
c
c     ****     label visibility of cell sides
c
c     north side corresponds to j
c     south side corresponds to j+1
c     west  side corresponds to i
c     east  side corresponds to i+1
c
c     let iflag = b4 b3 b2 b1 b0 (in binary) then b0 through b3 are
c     either o or 1 depeending on whether the east, south, north
c     or west side is either invisible or visible, respectively.
c
c     b4 is o if the diagonal is from (i,j) to (i+1,j+1) and 1 if
c     the diagonal is from (i,j+1) to (i+1,j).
c
      DIMENSION XP(N,M),YP(N,M),IFLAG(N,M)
c     ****     arithmetic statement function
      CP(J1,I1,J2,I2,J3,I3) = ((XP(J1,I1)-XP(J2,I2))*
     +                        (YP(J3,I3)-YP(J2,I2))-
     +                        (XP(J3,I3)-XP(J2,I2))*
     +                        (YP(J1,I1)-YP(J2,I2)))
      DO 100 J = 2,N - 2
          DO 100 I = 1,M - 1
              IF (IFLAG(J,I).GE.16) GO TO 20
              IF (CP(J+1,I+1,J+1,I,J,I).LE.0) GO TO 10
c     west and south are visible
              IFLAG(J,I) = IFLAG(J,I) + 10
   10         IF (CP(J,I,J,I+1,J+1,I+1).LE.0) GO TO 100
c     east and north are visible
              IFLAG(J,I) = IFLAG(J,I) + 5
              GO TO 100
   20         IF (CP(J+1,I,J,I,J,I+1).LE.0) GO TO 30
c     west and north are visible
              IFLAG(J,I) = IFLAG(J,I) + 12
   30         IF (CP(J,I+1,J+1,I+1,J+1,I).LE.0) GO TO 100
c     east and south are visible
              IFLAG(J,I) = IFLAG(J,I) + 3
  100 CONTINUE
c
c     classify the poles
c
      DO 200 I = 1,M - 1
          IFLAG(1,I) = 0
          IF (CP(2,I+1,2,I,1,I).GT.0) IFLAG(1,I) = 15
          IFLAG(N-1,I) = 0
          IF (CP(N,I,N-1,I,N-1,I+1).GT.0) IFLAG(N-1,I) = 31
  200 CONTINUE
      DO 250 J = 1,N - 1
          IFLAG(J,M) = IFLAG(J,1)
  250 CONTINUE
      RETURN
      END
      SUBROUTINE DSTRIDE(M,N,MST,MFAC)
      DOUBLE PRECISION TPHI
      DOUBLE PRECISION PI
      DOUBLE PRECISION DT
      DOUBLE PRECISION THETA
      DOUBLE PRECISION ST
      DIMENSION MFAC(*),MTRYH(3),MST(N),ICL(8)
      DATA MTRYH(1),MTRYH(2),MTRYH(3)/2,3,5/
      DATA ICL(1),ICL(2),ICL(3),ICL(4),ICL(5),ICL(6),ICL(7),ICL(8)/0,1,
     +     2,12,3,13,23,123/
c
c     find prime factors of m-1
c
      ML = M - 1
      NF = 0
      J = 0
  101 J = J + 1
      IF (J-3) 102,102,103
  102 MTRY = MTRYH(J)
      GO TO 104
  103 MTRY = MTRY + 2
  104 MQ = ML/MTRY
      MR = ML - MTRY*MQ
      IF (MR) 101,105,101
  105 NF = NF + 1
      MFAC(NF) = MTRY
      ML = MQ
      IF (ML.NE.1) GO TO 104
      IF (MFAC(NF).GT.2) GO TO 106
      NF = NF - 1
      MFAC(NF) = 4
  106 TPHI = .707D0/DBLE(M-1)
      NS2 = N/2
      MF1 = MFAC(NF)
      MST(1) = (M-1)/MF1
      PI = 4.D0*ATAN(1.D0)
      DT = PI/DBLE(N-1)
      JF = NF - 1
      DO 110 JDO = 2,NS2
          J = JDO
          THETA = (J-1)*DT
          ST = SIN(THETA)
          MF2 = MF1*MFAC(JF)
          IF (ABS(ST/MF1-TPHI).GT.ABS(ST/MF2-TPHI)) GO TO 115
          MST(J) = MST(J-1)
          GO TO 110
  115     MST(J) = (M-1)/MF2
          MF1 = MF2
          JF = JF - 1
          IF (JF.EQ.0) GO TO 120
  110 CONTINUE
  120 DO 125 JDO = J,NS2
          MST(JDO) = 1
  125 CONTINUE
      DO 130 JDO = 1,NS2
          MST(N-JDO) = MST(JDO)
  130 CONTINUE
c      write (6,135) (mst(j),j=1,n)
  135 FORMAT (' colatitude strides',/, (15i5))
c
      RETURN
      END
      SUBROUTINE DTRIGAU(M,N,X,Y,Z,ITRI,X1,Y1,Z1,X2,Y2,Z2,X3,Y3,Z3,
     +                   ITYP,IFLAG,MST)
      DOUBLE PRECISION X
      DOUBLE PRECISION Y
      DOUBLE PRECISION Z
      DOUBLE PRECISION X1
      DOUBLE PRECISION Y1
      DOUBLE PRECISION Z1
      DOUBLE PRECISION X2
      DOUBLE PRECISION Y2
      DOUBLE PRECISION Z2
      DOUBLE PRECISION X3
      DOUBLE PRECISION Y3
      DOUBLE PRECISION Z3
c     ****     performs triangulation
      DIMENSION X(N,M),Y(N,M),Z(N,M),X1(1),Y1(1),Z1(1),X2(1),Y2(1),
     +          Z2(1),X3(1),Y3(1),Z3(1),ITYP(1),IFLAG(N,M),MST(N),ICL(8)
      DATA ICL(1),ICL(2),ICL(3),ICL(4),ICL(5),ICL(6),ICL(7),ICL(8)/0,1,
     +     2,12,3,13,23,123/

      ITRI = 0
      N1 = 2
      N2 = N - 2
      DO 100 J = N1,N2
          DO 100 I = 1,M - 1
              IF (IFLAG(J,I).GE.16) GO TO 50
              IF (MOD(IFLAG(J,I),16).LT.8) GO TO 70
              ITRI = ITRI + 1
              X1(ITRI) = X(J,I)
              Y1(ITRI) = Y(J,I)
              Z1(ITRI) = Z(J,I)
              X2(ITRI) = X(J+1,I)
              Y2(ITRI) = Y(J+1,I)
              Z2(ITRI) = Z(J+1,I)
              X3(ITRI) = X(J+1,I+1)
              Y3(ITRI) = Y(J+1,I+1)
              Z3(ITRI) = Z(J+1,I+1)
              ITYPH = 3
              IF (MOD(I-1,MST(J)).EQ.0) GO TO 60
              IF (MOD(IFLAG(J,I-1),2).EQ.0) GO TO 60
              ITYPH = ITYPH - 1
   60         IF (MOD(IFLAG(J,I),2).EQ.0) ITYPH = ITYPH + 4
              ITYP(ITRI) = ICL(ITYPH+1)
   70         IF (MOD(IFLAG(J,I),2).EQ.0) GO TO 100
              ITRI = ITRI + 1
              X1(ITRI) = X(J,I)
              Y1(ITRI) = Y(J,I)
              Z1(ITRI) = Z(J,I)
              X2(ITRI) = X(J+1,I+1)
              Y2(ITRI) = Y(J+1,I+1)
              Z2(ITRI) = Z(J+1,I+1)
              X3(ITRI) = X(J,I+1)
              Y3(ITRI) = Y(J,I+1)
              Z3(ITRI) = Z(J,I+1)
              ITYPH = 0
              IF (MOD(IFLAG(J,I),16).LT.8) ITYPH = ITYPH + 1
              IF (MOD(IFLAG(J,I+1),16).LT.8) ITYPH = ITYPH + 2
              IF (MOD(IFLAG(J-1,I),4).LT.2) ITYPH = ITYPH + 4
              ITYP(ITRI) = ICL(ITYPH+1)
              GO TO 100
   50         IF (MOD(IFLAG(J,I),16).LT.8) GO TO 20
              ITRI = ITRI + 1
              X1(ITRI) = X(J,I)
              Y1(ITRI) = Y(J,I)
              Z1(ITRI) = Z(J,I)
              X2(ITRI) = X(J+1,I)
              Y2(ITRI) = Y(J+1,I)
              Z2(ITRI) = Z(J+1,I)
              X3(ITRI) = X(J,I+1)
              Y3(ITRI) = Y(J,I+1)
              Z3(ITRI) = Z(J,I+1)
              ITYPH = 1
              IF (MOD(I-1,MST(J)).EQ.0) GO TO 10
              IF (MOD(IFLAG(J,I-1),2).EQ.0) GO TO 10
              ITYPH = 0
   10         IF (MOD(IFLAG(J,I),2).EQ.0) ITYPH = ITYPH + 2
              IF (MOD(IFLAG(J-1,I),4).LT.2) ITYPH = ITYPH + 4
              ITYP(ITRI) = ICL(ITYPH+1)
   20         IF (MOD(IFLAG(J,I),2).EQ.0) GO TO 100
              ITRI = ITRI + 1
              X1(ITRI) = X(J+1,I)
              Y1(ITRI) = Y(J+1,I)
              Z1(ITRI) = Z(J+1,I)
              X2(ITRI) = X(J+1,I+1)
              Y2(ITRI) = Y(J+1,I+1)
              Z2(ITRI) = Z(J+1,I+1)
              X3(ITRI) = X(J,I+1)
              Y3(ITRI) = Y(J,I+1)
              Z3(ITRI) = Z(J,I+1)
              ITYPH = 1
              IF (MOD(IFLAG(J,I+1),16).LT.8) ITYPH = ITYPH + 2
              IF (MOD(IFLAG(J,I),16).LT.8) ITYPH = ITYPH + 4
              ITYP(ITRI) = ICL(ITYPH+1)
  100 CONTINUE
c
c     ****     triangles around north and south poles
c
      DO 200 I = 1,M - 1
          IF (MOD(IFLAG(1,I),16).LT.8) GO TO 250
          ITRI = ITRI + 1
          X1(ITRI) = X(1,I)
          Y1(ITRI) = Y(1,I)
          Z1(ITRI) = Z(1,I)
          X2(ITRI) = X(2,I)
          Y2(ITRI) = Y(2,I)
          Z2(ITRI) = Z(2,I)
          X3(ITRI) = X(2,I+1)
          Y3(ITRI) = Y(2,I+1)
          Z3(ITRI) = Z(2,I+1)
          ITYP(ITRI) = ICL(3)
  250     IF (MOD(IFLAG(N-1,I),16).LT.8) GO TO 200
          ITRI = ITRI + 1
          X1(ITRI) = X(N-1,I)
          Y1(ITRI) = Y(N-1,I)
          Z1(ITRI) = Z(N-1,I)
          X2(ITRI) = X(N,I)
          Y2(ITRI) = Y(N,I)
          Z2(ITRI) = Z(N,I)
          X3(ITRI) = X(N-1,I+1)
          Y3(ITRI) = Y(N-1,I+1)
          Z3(ITRI) = Z(N-1,I+1)
          ITYP(ITRI) = ICL(1)
  200 CONTINUE
      RETURN
      END
      SUBROUTINE DVSURF(XEYE,YEYE,ZEYE,NTRI,X1,Y1,Z1,X2,Y2,Z2,X3,Y3,Z3,
     +                 ITYPE,WORK,IWORK)
      DOUBLE PRECISION XEYE
      DOUBLE PRECISION YEYE
      DOUBLE PRECISION ZEYE
      DOUBLE PRECISION X1
      DOUBLE PRECISION Y1
      DOUBLE PRECISION Z1
      DOUBLE PRECISION X2
      DOUBLE PRECISION Y2
      DOUBLE PRECISION Z2
      DOUBLE PRECISION X3
      DOUBLE PRECISION Y3
      DOUBLE PRECISION Z3
      DOUBLE PRECISION WORK
c
c    subroutine vsurf is like subroutine hidel except the triangles
c    are categorized. vsurf is also like solid except triangles rather
c    than lines are covered.
c
c     written by paul n. swarztrauber, national center for atmospheric
c     research, p.o. box 3000, boulder, colorado, 80307
c
c    this program plots visible lines for the surface defined
c    by the input 3-d triangles with corners at (x1,y1,z1), (x2,y2,z2)
c    and (x3,y3,z3). the sides of these these triangles may or
c    may not be plotted depending on itype. if itype is 1 then the
c    side between points (x1,y1,z1) and (x2,y2,z2) is plotted if it
c    is visible. if itype is 2 then the side between (x2,y2,z2)
c    and (x3,y3,z3) is plotted. if itype is 3 then the visible portion
c    of the side between (x3,y3,z3) and (x1,y1,z1) is plotted.
c    any combination is possible by specifying itype to be one
c    of the following values: 0,1,2,3,12,13,23,123.
c
c    the length of real    array  work must be at least 14*ntri
c
c    the length of integer array iwork must be at least  6*ntri
c
c
c    the vertices of the triangles are renumbered by vsurf so that
c    their projections are orientated counterclockwise. the user need
c    only be aware that the vertices may be renumbered by vsurf.
c
      DIMENSION X1(NTRI),Y1(NTRI),Z1(NTRI),X2(NTRI),Y2(NTRI),Z2(NTRI),
     +          X3(NTRI),Y3(NTRI),Z3(NTRI),ITYPE(NTRI),WORK(14*NTRI)
      INTEGER IWORK(6*NTRI)
c
      CALL DVSURF1(XEYE,YEYE,ZEYE,NTRI,X1,Y1,Z1,X2,Y2,Z2,X3,Y3,Z3,
     +             ITYPE,WORK,WORK(NTRI+1),WORK(2*NTRI+1),
     +             WORK(3*NTRI+1),WORK(4*NTRI+1),WORK(5*NTRI+1),
     +             WORK(6*NTRI+1),WORK(7*NTRI+1),WORK(8*NTRI+1),
     +             WORK(9*NTRI+1),WORK(10*NTRI+1),WORK(11*NTRI+1),
     +             WORK(12*NTRI+1),WORK(13*NTRI+1),IWORK,
     +             IWORK(NTRI+1),IWORK(2*NTRI+1),IWORK(4*NTRI+1))
      RETURN
      END
      SUBROUTINE DVSURF1(XEYE,YEYE,ZEYE,NTRI,X1,Y1,Z1,X2,Y2,Z2,X3,Y3,
     +                   Z3,ITYPE,PX1,PY1,PX2,PY2,PX3,PY3,VX1,VY1,VX2,
     +                   VY2,VX3,VY3,TL,TR,KH,NEXT,ISTART,IFINAL)
      DOUBLE PRECISION XEYE
      DOUBLE PRECISION YEYE
      DOUBLE PRECISION ZEYE
      DOUBLE PRECISION X1
      DOUBLE PRECISION Y1
      DOUBLE PRECISION Z1
      DOUBLE PRECISION X2
      DOUBLE PRECISION Y2
      DOUBLE PRECISION Z2
      DOUBLE PRECISION X3
      DOUBLE PRECISION Y3
      DOUBLE PRECISION Z3
      DOUBLE PRECISION PX1
      DOUBLE PRECISION PY1
      DOUBLE PRECISION PX2
      DOUBLE PRECISION PY2
      DOUBLE PRECISION PX3
      DOUBLE PRECISION PY3
      DOUBLE PRECISION VX1
      DOUBLE PRECISION VY1
      DOUBLE PRECISION VX2
      DOUBLE PRECISION VY2
      DOUBLE PRECISION VX3
      DOUBLE PRECISION VY3
      DOUBLE PRECISION TL
      DOUBLE PRECISION TR
      DOUBLE PRECISION FNTRI
      DOUBLE PRECISION X
      DOUBLE PRECISION Y
      DOUBLE PRECISION Z
      DOUBLE PRECISION DUM1
      DOUBLE PRECISION DUM2
      DOUBLE PRECISION CPROD
      DOUBLE PRECISION PX1H
      DOUBLE PRECISION PY1H
      DOUBLE PRECISION X1HOLD
      DOUBLE PRECISION Y1HOLD
      DOUBLE PRECISION Z1HOLD
      DOUBLE PRECISION PMAX
      DOUBLE PRECISION PMIN
      DOUBLE PRECISION XMIN
      DOUBLE PRECISION XMAX
      DOUBLE PRECISION YMIN
      DOUBLE PRECISION YMAX
      DOUBLE PRECISION DMX
      DOUBLE PRECISION DMY
      DOUBLE PRECISION C
      DOUBLE PRECISION D
      DOUBLE PRECISION XMID
      DOUBLE PRECISION HDY
      DOUBLE PRECISION A
      DOUBLE PRECISION B
      DOUBLE PRECISION YMID
      DOUBLE PRECISION HDX
      DOUBLE PRECISION HGR
      DOUBLE PRECISION DXT
      DOUBLE PRECISION HR
      DOUBLE PRECISION TL1
      DOUBLE PRECISION TL2
      DOUBLE PRECISION PX4
      DOUBLE PRECISION PY4
      DOUBLE PRECISION PX5
      DOUBLE PRECISION PY5
      DOUBLE PRECISION X4
      DOUBLE PRECISION Y4
      DOUBLE PRECISION Z4
      DOUBLE PRECISION X5
      DOUBLE PRECISION Y5
      DOUBLE PRECISION Z5
      DOUBLE PRECISION X54
      DOUBLE PRECISION Y54
      DOUBLE PRECISION C17
      DOUBLE PRECISION C27
      DOUBLE PRECISION C37
      DOUBLE PRECISION C14
      DOUBLE PRECISION C25
      DOUBLE PRECISION C36
      DOUBLE PRECISION TMIN
      DOUBLE PRECISION TMAX
      DOUBLE PRECISION XPL
      DOUBLE PRECISION YPL
      DOUBLE PRECISION ZPL
      DOUBLE PRECISION XPR
      DOUBLE PRECISION YPR
      DOUBLE PRECISION ZPR
      DOUBLE PRECISION VX1T
      DOUBLE PRECISION VY1T
      DOUBLE PRECISION VZ1T
      DOUBLE PRECISION VX2T
      DOUBLE PRECISION VY2T
      DOUBLE PRECISION VZ2T
      DOUBLE PRECISION APL
      DOUBLE PRECISION BPL
      DOUBLE PRECISION CPL
      DOUBLE PRECISION DPL
      DOUBLE PRECISION VX3T
      DOUBLE PRECISION VY3T
      DOUBLE PRECISION VZ3T
      DOUBLE PRECISION DEN
      DOUBLE PRECISION TIL
      DOUBLE PRECISION TIR
      DOUBLE PRECISION TIM
      DOUBLE PRECISION THOLD
      DOUBLE PRECISION TLH
      DOUBLE PRECISION TRH
      DOUBLE PRECISION XA
      DOUBLE PRECISION YA
      DOUBLE PRECISION XB
      DOUBLE PRECISION YB
c
      DIMENSION X1(NTRI),Y1(NTRI),Z1(NTRI),X2(NTRI),Y2(NTRI),Z2(NTRI),
     +          X3(NTRI),Y3(NTRI),Z3(NTRI),ITYPE(NTRI),PX1(NTRI),
     +          PY1(NTRI),PX2(NTRI),PY2(NTRI),PX3(NTRI),PY3(NTRI),
     +          VX1(NTRI),VY1(NTRI),VX2(NTRI),VY2(NTRI),VX3(NTRI),
     +          VY3(NTRI),TL(NTRI),TR(NTRI),NEXT(NTRI),KH(NTRI),
     +          ISTART(2*NTRI),IFINAL(2*NTRI),LTP(3),IRD(11),IP2(11),
     +          NCT(11),NCV(11),LAST(11)
c
      DOUBLE PRECISION L2E
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION LE2
C*PT*WARNING* Constant already double-precision
c
c     compute projections of 3-d points
c
      LE2 = .6931471805599453094172321d0
C*PT*WARNING* Constant already double-precision
      L2E = 1.d0/LE2
      FNTRI = NTRI
      IRMAX = .5D0*L2E*LOG(FNTRI)
      IRMAX = MIN(IRMAX,10)
      IRMP1 = IRMAX + 1
      DO 4 ICV = 1,11
          NCV(ICV) = 0
    4 CONTINUE
      NCT(1) = 0
      IP2(1) = 1
      IRD(1) = 0
      ISIZE = 4
      DO 7 IRP1 = 2,IRMP1
          IR = IRP1 - 1
          NCT(IRP1) = 0
          IP2(IRP1) = 2**IR
          IRD(IRP1) = IRD(IR) + ISIZE
          ISIZE = (IP2(IRP1)+1)**2
    7 CONTINUE
      ISXM = IRD(IRMP1) + ISIZE + 1
      DO 8 ISX = 1,ISXM
          ISTART(ISX) = 0
          IFINAL(ISX) = 0
    8 CONTINUE
      DO 6 I = 1,NTRI
          NEXT(I) = 0
    6 CONTINUE
      CALL DPRJCT(0,XEYE,YEYE,ZEYE,X,Y,Z,DUM1,DUM2)
c      write(6,127) ntri
  127 FORMAT (' ntri in hidel',i5)
      DO 86 K = 1,NTRI
          CALL DPRJCT(1,XEYE,YEYE,ZEYE,X1(K),Y1(K),Z1(K),PX1(K),PY1(K))
          CALL DPRJCT(1,XEYE,YEYE,ZEYE,X2(K),Y2(K),Z2(K),PX2(K),PY2(K))
          CALL DPRJCT(1,XEYE,YEYE,ZEYE,X3(K),Y3(K),Z3(K),PX3(K),PY3(K))
          IF (K.LT.3) THEN
c          write(6,333) xeye,yeye,zeye,x1(k),y1(k),z1(k),px1(k),py1(k)
  333         FORMAT (' xeye, etc.',8D8.1)
          END IF
   86 CONTINUE
c
c     orientate triangles counter clockwise
c
      DO 70 K = 1,NTRI
          CPROD = (PX2(K)-PX1(K))* (PY3(K)-PY1(K)) -
     +            (PY2(K)-PY1(K))* (PX3(K)-PX1(K))
c      if(cprod.eq.0.) write(6,79) k,px1(k),px2(k),px3(k),
c     -                              py1(k),py2(k),py3(k)
   79     FORMAT ('  cprod=0 at k=',i5,6D9.2)
          IF (CPROD.GE.0.D0) GO TO 70
          PX1H = PX1(K)
          PY1H = PY1(K)
          PX1(K) = PX2(K)
          PY1(K) = PY2(K)
          PX2(K) = PX1H
          PY2(K) = PY1H
          X1HOLD = X1(K)
          Y1HOLD = Y1(K)
          Z1HOLD = Z1(K)
          X1(K) = X2(K)
          Y1(K) = Y2(K)
          Z1(K) = Z2(K)
          X2(K) = X1HOLD
          Y2(K) = Y1HOLD
          Z2(K) = Z1HOLD
          ITYP = ITYPE(K)
          IF (ITYP.EQ.2) ITYPE(K) = 3
          IF (ITYP.EQ.3) ITYPE(K) = 2
          IF (ITYP.EQ.12) ITYPE(K) = 13
          IF (ITYP.EQ.13) ITYPE(K) = 12
   70 CONTINUE
c
c     set screen limits
c
      PMAX = PX1(1)
      PMIN = PX1(1)
      DO 87 K = 1,NTRI
          PMIN = DMIN1(PMIN,PX1(K),PY1(K),PX2(K),PY2(K),PX3(K),PY3(K))
          PMAX = DMAX1(PMAX,PX1(K),PY1(K),PX2(K),PY2(K),PX3(K),PY3(K))
   87 CONTINUE
      PMIN = 1.1D0*PMIN
      PMAX = 1.1D0*PMAX
      CALL SET(0.D0,1.D0,0.D0,1.D0,PMIN,PMAX,PMIN,PMAX,1)
      XMIN = DMIN1(PX1(1),PX2(1),PX3(1))
      XMAX = DMAX1(PX1(1),PX2(1),PX3(1))
      YMIN = DMIN1(PY1(1),PY2(1),PY3(1))
      YMAX = DMAX1(PY1(1),PY2(1),PY3(1))
      DO 1 I = 2,NTRI
          XMIN = DMIN1(XMIN,PX1(I),PX2(I),PX3(I))
          XMAX = DMAX1(XMAX,PX1(I),PX2(I),PX3(I))
          YMIN = DMIN1(YMIN,PY1(I),PY2(I),PY3(I))
          YMAX = DMAX1(YMAX,PY1(I),PY2(I),PY3(I))
    1 CONTINUE
      DMX = XMAX - XMIN
      DMY = YMAX - YMIN
      IF (DMX.GT.DMY) GO TO 2
      C = YMIN
      D = YMAX
      XMID = .5D0* (XMIN+XMAX)
      HDY = .5D0*DMY
      A = XMID - HDY
      B = XMID + HDY
      GO TO 3
    2 A = XMIN
      B = XMAX
      YMID = .5D0* (YMIN+YMAX)
      HDX = .5D0*DMX
      C = YMID - HDX
      D = YMID + HDX
    3 HGR = B - A
c
c     categorize triangles
c
      DO 100 I = 1,NTRI
          XMIN = DMIN1(PX1(I),PX2(I),PX3(I))
          XMAX = DMAX1(PX1(I),PX2(I),PX3(I))
          YMIN = DMIN1(PY1(I),PY2(I),PY3(I))
          YMAX = DMAX1(PY1(I),PY2(I),PY3(I))
          DXT = DMAX1(XMAX-XMIN,YMAX-YMIN)
          IF (DXT.GT.0.D0) GO TO 10
          IR = IRMAX
          GO TO 20
   10     IR = L2E*LOG(HGR/DXT)
          IR = MIN(IR,IRMAX)
   20     IRP1 = IR + 1
          NCT(IRP1) = NCT(IRP1) + 1
          HR = HGR/IP2(IRP1)
          XMID = .5D0* (XMIN+XMAX)
          ID = (XMID-A)/HR + 1.5D0
          YMID = .5D0* (YMIN+YMAX)
          JD = (YMID-C)/HR + 1.5D0
          IJD = IP2(IRP1) + 1
          ISX = ID + (JD-1)*IJD + IRD(IRP1)
          IFX = IFINAL(ISX)
          IF (IFX.GT.0) GO TO 50
          ISTART(ISX) = I
          GO TO 60
   50     NEXT(IFX) = I
   60     IFINAL(ISX) = I
  100 CONTINUE
c      write(6,106) tcat,(irp1,nct(irp1),irp1=1,irmp1)
  106 FORMAT (' time to categorize   ',D15.6,/, (' ir+1',i3,' ntri',i7))
c
c     sort triangles into boxes
c
      L = 0
      DO 30 IRP1 = 1,IRMP1
          IF (NCT(IRP1).EQ.0) GO TO 30
          IST = IRD(IRP1) + 1
          ISD = IP2(IRP1) + 1
          CALL DBOX(ISD,ISTART(IST),NEXT,L,IFINAL)
          LAST(IRP1) = L + 1
   30 CONTINUE
      DO 35 IRP1 = 1,IRMP1
          IL = IRD(IRP1) + (IP2(IRP1)+1)**2 + 1
          IF (ISTART(IL).EQ.0) ISTART(IL) = LAST(IRP1)
   35 CONTINUE
c      write(6,31) tsort,l,ntri
   31 FORMAT (' time to sort  ',D15.6,'   l',i8,'   ntri',i8)
      DO 90 K = 1,NTRI
          VX1(K) = PX2(K) - PX1(K)
          VY1(K) = PY2(K) - PY1(K)
          VX2(K) = PX3(K) - PX2(K)
          VY2(K) = PY3(K) - PY2(K)
          VX3(K) = PX1(K) - PX3(K)
          VY3(K) = PY1(K) - PY3(K)
   90 CONTINUE
      TL1 = 0.D0
      TL2 = 0.D0
      MAXS = 0
      DO 500 IR2 = 1,IRMP1
          IF (NCT(IR2).EQ.0) GO TO 500
          IST = IRD(IR2)
          ISD = IP2(IR2) + 1
          DO 490 J2 = 1,ISD
              DO 480 I2 = 1,ISD
                  IST = IST + 1
                  LS = ISTART(IST)
                  LF = ISTART(IST+1) - 1
                  IF (LF.LT.LS) GO TO 480
c
c     define coverings
c
                  KCV = 0
                  I2M = I2 - 1
                  J2M = J2 - 1
                  DO 300 IR1 = 1,IRMP1
                      IF (NCT(IR1).EQ.0) GO TO 300
                      IF (IR1.GE.IR2) GO TO 260
                      IRDP = 2** (IR2-IR1)
                      I1S = (I2M-1)/IRDP
                      I1F = (I2M+1)/IRDP
                      IF = I2M + 1 - I1F*IRDP
                      IF (IF.GT.0) I1F = I1F + 1
                      J1S = (J2M-1)/IRDP
                      J1F = (J2M+1)/IRDP
                      JF = J2M + 1 - J1F*IRDP
                      IF (JF.GT.0) J1F = J1F + 1
                      GO TO 270
  260                 IRDP = 2** (IR1-IR2)
                      I1S = IRDP* (I2M-1)
                      I1F = IRDP* (I2M+1)
                      J1S = IRDP* (J2M-1)
                      J1F = IRDP* (J2M+1)
  270                 IJD = IP2(IR1) + 1
                      I1S = MAX(I1S+1,1)
                      I1F = MIN(I1F+1,IJD)
                      J1S = MAX(J1S+1,1)
                      J1F = MIN(J1F+1,IJD)
                      IXH = (J1S-2)*IJD + IRD(IR1)
                      IXS = I1S + IXH
                      IXF = I1F + IXH
                      DO 290 J1 = J1S,J1F
                          IXS = IXS + IJD
                          KDS = ISTART(IXS)
                          IXF = IXF + IJD
                          KDF = ISTART(IXF+1) - 1
                          IF (KDF.LT.KDS) GO TO 290
                          DO 280 KD = KDS,KDF
                              KCV = KCV + 1
                              KH(KCV) = IFINAL(KD)
  280                     CONTINUE
  290                 CONTINUE
  300             CONTINUE
                  DO 310 ICV = 1,10
                      IF (KCV.LE.NCV(ICV)) GO TO 310
                      NCV(ICV) = KCV
                      GO TO 320
  310             CONTINUE
c
c
  320             DO 470 LDO = LS,LF
                      L = IFINAL(LDO)
                      ITH = ITYPE(L)
                      IF (ITH.EQ.0) GO TO 470
                      LTP(1) = 0
                      LTP(2) = 0
                      LTP(3) = 0
                      ID1 = ITH/100
                      ITH = ITH - 100*ID1
                      ID2 = ITH/10
                      ID3 = ITH - 10*ID2
                      IF (ID1.NE.0) LTP(ID1) = 1
                      IF (ID2.NE.0) LTP(ID2) = 1
                      IF (ID3.NE.0) LTP(ID3) = 1
c     if((ith.eq.123) .or. (ith.eq.12) .or.(ith.eq.13)) ltp(1) = 1
c     if((ith.eq.123) .or. (ith.eq.23) .or.(ith.eq.12)) ltp(2) = 1
c     if((ith.eq.123) .or. (ith.eq.13) .or.(ith.eq.23)) ltp(3) = 1
                      DO 460 NS = 1,3
                          GO TO (101,102,103) NS
  101                     IF (LTP(NS).EQ.0) GO TO 460
                          PX4 = PX1(L)
                          PY4 = PY1(L)
                          PX5 = PX2(L)
                          PY5 = PY2(L)
                          X4 = X1(L)
                          Y4 = Y1(L)
                          Z4 = Z1(L)
                          X5 = X2(L)
                          Y5 = Y2(L)
                          Z5 = Z2(L)
                          GO TO 105
  102                     IF (LTP(NS).EQ.0) GO TO 460
                          PX4 = PX2(L)
                          PY4 = PY2(L)
                          PX5 = PX3(L)
                          PY5 = PY3(L)
                          X4 = X2(L)
                          Y4 = Y2(L)
                          Z4 = Z2(L)
                          X5 = X3(L)
                          Y5 = Y3(L)
                          Z5 = Z3(L)
                          GO TO 105
  103                     IF (LTP(NS).EQ.0) GO TO 460
                          PX4 = PX1(L)
                          PY4 = PY1(L)
                          PX5 = PX3(L)
                          PY5 = PY3(L)
                          X4 = X1(L)
                          Y4 = Y1(L)
                          Z4 = Z1(L)
                          X5 = X3(L)
                          Y5 = Y3(L)
                          Z5 = Z3(L)
  105                     X54 = PX5 - PX4
                          Y54 = PY5 - PY4
                          NSEG = 0
                          DO 440 KD = 1,KCV
                              K = KH(KD)
                              C17 = VX1(K)*Y54 - VY1(K)*X54
                              C27 = VX2(K)*Y54 - VY2(K)*X54
                              C37 = VX3(K)*Y54 - VY3(K)*X54
                              C14 = VY1(K)* (PX4-PX1(K)) -
     +                              VX1(K)* (PY4-PY1(K))
                              C25 = VY2(K)* (PX4-PX2(K)) -
     +                              VX2(K)* (PY4-PY2(K))
                              C36 = VY3(K)* (PX4-PX3(K)) -
     +                              VX3(K)* (PY4-PY3(K))
                              TMIN = 0.D0
                              TMAX = 1.D0
                              IF (C17) 151,152,153
  151                         TMAX = DMIN1(C14/C17,TMAX)
                              GO TO 154
  152                         IF (C14) 154,440,440
  153                         TMIN = DMAX1(C14/C17,TMIN)
  154                         IF (C27) 155,156,157
  155                         TMAX = DMIN1(C25/C27,TMAX)
                              GO TO 158
  156                         IF (C25) 158,440,440
  157                         TMIN = DMAX1(C25/C27,TMIN)
  158                         IF (C37) 159,160,161
  159                         TMAX = DMIN1(C36/C37,TMAX)
                              GO TO 162
  160                         IF (C36) 162,440,440
  161                         TMIN = DMAX1(C36/C37,TMIN)
  162                         IF (TMAX-TMIN.LT..00001D0) GO TO 440
                              XPL = X4 + TMIN* (X5-X4)
                              YPL = Y4 + TMIN* (Y5-Y4)
                              ZPL = Z4 + TMIN* (Z5-Z4)
                              XPR = X4 + TMAX* (X5-X4)
                              YPR = Y4 + TMAX* (Y5-Y4)
                              ZPR = Z4 + TMAX* (Z5-Z4)
c
c     the projections of line and plane intersect
c     now determine if plane covers line
c
                              VX1T = X2(K) - X1(K)
                              VY1T = Y2(K) - Y1(K)
                              VZ1T = Z2(K) - Z1(K)
                              VX2T = X3(K) - X1(K)
                              VY2T = Y3(K) - Y1(K)
                              VZ2T = Z3(K) - Z1(K)
                              APL = VY1T*VZ2T - VY2T*VZ1T
                              BPL = VX2T*VZ1T - VX1T*VZ2T
                              CPL = VX1T*VY2T - VX2T*VY1T
                              DPL = APL*X1(K) + BPL*Y1(K) + CPL*Z1(K)
                              VX3T = XPL - XEYE
                              VY3T = YPL - YEYE
                              VZ3T = ZPL - ZEYE
                              DEN = APL*VX3T + BPL*VY3T + CPL*VZ3T
                              TIL = 0.D0
                              IF (DEN.EQ.0.D0) GO TO 410
                              TIL = (DPL-APL*XEYE-BPL*YEYE-CPL*ZEYE)/DEN
  410                         VX3T = XPR - XEYE
                              VY3T = YPR - YEYE
                              VZ3T = ZPR - ZEYE
                              DEN = APL*VX3T + BPL*VY3T + CPL*VZ3T
                              TIR = 0.D0
                              IF (DEN.EQ.0.D0) GO TO 412
                              TIR = (DPL-APL*XEYE-BPL*YEYE-CPL*ZEYE)/DEN
  412                         IF (TIL.GE..99999D0 .AND.
     +                            TIR.GE..99999D0) GO TO 440
                              IF (TIL.LT.1.D0 .AND.
     +                            TIR.LT.1.D0) GO TO 164
                              VX3T = XPR - XPL
                              VY3T = YPR - YPL
                              VZ3T = ZPR - ZPL
                              DEN = APL*VX3T + BPL*VY3T + CPL*VZ3T
                              TIM = 0.D0
                              IF (DEN.EQ.0.D0) GO TO 414
                              TIM = (DPL-APL*XPL-BPL*YPL-CPL*ZPL)/DEN
  414                         THOLD = TMIN + TIM* (TMAX-TMIN)
                              IF (TIL.GE.1.D0) GO TO 163
                              TMAX = THOLD
                              GO TO 164
  163                         TMIN = THOLD
  164                         NSEG = NSEG + 1
                              TL(NSEG) = TMIN
                              TR(NSEG) = TMAX
  440                     CONTINUE
                          MAXS = MAX0(MAXS,NSEG)
                          IF (NSEG-1) 171,180,172
  171                     CALL LINE(PX4,PY4,PX5,PY5)
                          GO TO 460
c
c     order the segments according to left end point tl(k)
c
  172                     DO 173 K = 2,NSEG
                              DO 173 I = K,NSEG
                                  IF (TL(K-1).LE.TL(I)) GO TO 173
                                  TLH = TL(K-1)
                                  TRH = TR(K-1)
                                  TL(K-1) = TL(I)
                                  TR(K-1) = TR(I)
                                  TL(I) = TLH
                                  TR(I) = TRH
  173                     CONTINUE
c
c     eliminate segment overlap
c
                          K1 = 1
                          K2 = 1
  174                     K2 = K2 + 1
                          IF (K2.GT.NSEG) GO TO 176
                          IF (TR(K1).LT.TL(K2)) GO TO 175
                          TR(K1) = DMAX1(TR(K1),TR(K2))
                          GO TO 174
  175                     K1 = K1 + 1
                          TL(K1) = TL(K2)
                          TR(K1) = TR(K2)
                          GO TO 174
  176                     NSEG = K1
c
c     plot all segments of the line
c
  180                     DO 181 KS = 1,NSEG
                              KB = NSEG - KS + 1
                              TL(KB+1) = TR(KB)
                              TR(KB) = TL(KB)
  181                     CONTINUE
                          TL(1) = 0.D0
                          TR(NSEG+1) = 1.D0
                          NSEGP = NSEG + 1
                          DO 450 K = 1,NSEGP
                              IF (ABS(TR(K)-TL(K)).LT.
     +                            .000001D0) GO TO 450
                              XA = PX4 + TL(K)* (PX5-PX4)
                              YA = PY4 + TL(K)* (PY5-PY4)
                              XB = PX4 + TR(K)* (PX5-PX4)
                              YB = PY4 + TR(K)* (PY5-PY4)
                              CALL LINE(XA,YA,XB,YB)
  450                     CONTINUE
  460                 CONTINUE
  470             CONTINUE
  480         CONTINUE
  490     CONTINUE
  500 CONTINUE
c      write(6,903) tl1,tl2
  903 FORMAT (' time to cover',D15.6,/,' time to test ',D15.6)
c      write(6,904) maxs
  904 FORMAT (' maximum number of segments',i5)
c      write(6,250) (ncv(icv),icv=1,10)
  250 FORMAT ('  the ten largest coverings',/, (10i5))
      CALL FRAME
      END
      SUBROUTINE DPRJCT(INIT,XEYE,YEYE,ZEYE,X,Y,Z,PX,PY)
      DOUBLE PRECISION XEYE
      DOUBLE PRECISION YEYE
      DOUBLE PRECISION ZEYE
      DOUBLE PRECISION X
      DOUBLE PRECISION Y
      DOUBLE PRECISION Z
      DOUBLE PRECISION PX
      DOUBLE PRECISION PY
      DOUBLE PRECISION RADS1
      DOUBLE PRECISION RADS2
      DOUBLE PRECISION D1
      DOUBLE PRECISION D2
      DOUBLE PRECISION CX1
      DOUBLE PRECISION CY1
      DOUBLE PRECISION CX2
      DOUBLE PRECISION CY2
      DOUBLE PRECISION CZ2
      DOUBLE PRECISION CX3
      DOUBLE PRECISION CY3
      DOUBLE PRECISION CZ3
      DOUBLE PRECISION X1
      DOUBLE PRECISION Y1
      DOUBLE PRECISION Z1
      DOUBLE PRECISION RATIO
c
c     subroutine prjct projects the point x,y,z onto a plane through
c     the origin that is perpendicular to a line between the origin
c     and the eye. the projection is along the line between the eye
c     and the point x,y,z. px and py are the coordinates of the
c     projection in the plane.
c     (version 2 , 12-10-82)
c
      SAVE

      IF (INIT.NE.0) GO TO 1
      RADS1 = XEYE**2 + YEYE**2
      RADS2 = RADS1 + ZEYE**2
      D1 = SQRT(RADS1)
      D2 = SQRT(RADS2)
      CX1 = -YEYE/D1
      CY1 = XEYE/D1
      CX2 = -XEYE*ZEYE/ (D1*D2)
      CY2 = -YEYE*ZEYE/ (D1*D2)
      CZ2 = D1/D2
      CX3 = XEYE/D2
      CY3 = YEYE/D2
      CZ3 = ZEYE/D2
      RETURN
    1 X1 = CX1*X + CY1*Y
      Y1 = CX2*X + CY2*Y + CZ2*Z
      Z1 = CX3*X + CY3*Y + CZ3*Z
      RATIO = D2/ (D2-Z1)
      PX = RATIO*X1
      PY = RATIO*Y1
      RETURN
      END
      SUBROUTINE DBOX(ISD,ISTART,NEXT,L,LIST)
      DIMENSION ISTART(ISD,ISD),NEXT(1),LIST(1)

      DO 30 JD = 1,ISD
          DO 10 ID = 1,ISD
              IDX = ISTART(ID,JD)
              ISTART(ID,JD) = L + 1
              IF (IDX.EQ.0) GO TO 10
   20         L = L + 1
              LIST(L) = IDX
              IF (NEXT(IDX).EQ.0) GO TO 10
              IDX = NEXT(IDX)
              GO TO 20
   10     CONTINUE
   30 CONTINUE
      RETURN
      END
      INTEGER FUNCTION ICVMG(I1,I2,R)
      INTEGER I1,I2
      DOUBLE PRECISION R
c
c     returns i1 if i3.ge.0 and returns i2 if i3.lt.0 .
c
      ICVMG = I1
      IF (R.LT.0.D0) ICVMG = I2
      RETURN
      END
      SUBROUTINE DPROJCT(M,N,XEYE,YEYE,ZEYE,X,Y,Z,PX,PY)
      DOUBLE PRECISION XEYE
      DOUBLE PRECISION YEYE
      DOUBLE PRECISION ZEYE
      DOUBLE PRECISION X
      DOUBLE PRECISION Y
      DOUBLE PRECISION Z
      DOUBLE PRECISION PX
      DOUBLE PRECISION PY
      DOUBLE PRECISION RDUM1
      DOUBLE PRECISION RDUM2
      DOUBLE PRECISION RDUM3
      DOUBLE PRECISION RDUM4
      DOUBLE PRECISION RDUM5
c     ****     projects point (x,y,z) onto plane thru origin and perp
c     ****     to line joining origin and eye
      DIMENSION X(N,M),Y(N,M),Z(N,M),PX(N,M),PY(N,M)

      CALL DPRJCT(0,XEYE,YEYE,ZEYE,RDUM1,RDUM2,RDUM3,RDUM4,RDUM5)
      DO 100 I = 1,M
          DO 100 J = 1,N
              CALL DPRJCT(1,XEYE,YEYE,ZEYE,X(J,I),Y(J,I),Z(J,I),
     +                    PX(J,I),PY(J,I))
  100 CONTINUE
      RETURN
      END

C
C $Id: idsetr.f,v 1.5 2008-07-27 00:17:30 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE IDSETR (PNAM,RVAL)
C
C Set the real value of the BIVAR parameter named PNAM from RVAL.
C
        CHARACTER*(*) PNAM
C
C The common block IDCOMN holds all of the internal parameters of
C the package BIVAR.
C
        COMMON /IDCOMN/ INTY,ITTY,ALSP,BLSP,CLSP,XAVG,YAVG
        SAVE   /IDCOMN/
C
C Define a temporary variable in which to put the first three characters
C of PNAM.
C
        CHARACTER*3 CTMP
C
C Define a character variable in which messages may be formed.
C
        CHARACTER*37 CMSG
C
C Do a call forcing a BLOCKDATA to be loaded from a binary library.
C
        CALL IDBLDA
C
C Check for an uncleared prior error.
C
        IF (ICFELL('IDSETR (BIVAR) - UNCLEARED PRIOR ERROR',1).NE.0)
     +                                                        RETURN
C
C Extract the first three characters of the parameter name.
C
        CTMP=PNAM
C
C If the parameter name has less than three characters, log an error.
C
        IF (LEN(PNAM).LT.3) GO TO 901
C
C See what the parameter name is ...
C
C ... the flag specifying the interpolation type, ...
C
        IF      (CTMP.EQ.'ITY'.OR.CTMP.EQ.'ity') THEN
C
          INTY=MAX(0,MIN(1,INT(RVAL)))
C
C ... or the flag specifying the triangulation type.
C
        ELSE IF (CTMP.EQ.'TTY'.OR.CTMP.EQ.'tty') THEN
C
          ITTY=MAX(0,MIN(1,INT(RVAL)))
C
        ELSE
C
C Otherwise, the parameter name is not recognized.
C
          GO TO 901
C
        END IF
C
        RETURN
C
C Error exit.
C
  901   CMSG(1:37)='IDSETR (BIVAR) - INVALID KEYWORD: '//CTMP
        CALL SETER (CMSG(1:37),8,1)
        RETURN
C
      END

      PROGRAM FSPCURVE
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C This program demonstrates how to use the SPPS CURVE routine and
C the GKS GPL routine.  Both routine are given the same set of
C coordinates to draw, however, because of the SET call the x axis
C is reversed.  GPL ignores this, and CURVE obeys it.
C
      REAL XCOORD(10), YCOORD(10)
      REAL X2(2), X3(2)
      REAL Y2(2), Y3(2)
C
C Coordinates for plot key
C
      DATA X2/.2, .3/
      DATA Y2/.1, .1/
      DATA X3/.7, .8/
      DATA Y3/.1, .1/
C
C Coordinates for line (used by both GPL and CURVE)
C
      DATA XCOORD/1.,2.,3.,5.,7.,9.,13.,16.,19.,23./
      DATA YCOORD/1.,3.,5.,6.,7.,10.,13.,16.,14.,17./
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Map the plotter frame to user coordinates.  Notice that
C we have reversed the X axis here.
C
      CALL SET (0.,1., 0., 1., 25., 0., 0., 20., 1)
C
C Set the line type to dashed.
C
      CALL GSLN(2)
C
C Draw the line with GPL. It will ignore the axis reversal.
C
      CALL GPL(10,XCOORD,YCOORD)
C
C Set the line type to solid
C
      CALL GSLN(1)
C
C Draw the line with CURVE.  It will observe the axis reversal
C
      CALL CURVE(XCOORD,YCOORD,10)
C
C Reset the plotter to user coordinate mapping to make it easier
C to plot the text and key.  (Axis reversal is turned off)
C
      CALL SET (0.,1., 0., 1., 0., 1., 0., 1., 1)
C
C Draw the text
C
      CALL PLCHLQ(.25, .15, 'GKS GPL Routine', 15., 0., 0.)
C
C Set line type to dashed.
C
      CALL GSLN(2)
C
C Draw a dashed line under the previous text
C
      CALL GPL(2,X2,Y2)
C
C Draw more text
C
      CALL PLCHLQ(.75, .15, 'SPPS CURVE Routine', 15., 0., 0.)
C
C Set line type to solid.
C
      CALL GSLN(1)
C
C Draw a solid line under the previous text
C
      CALL GPL(2,X3,Y3)
C
C Draw a main title
C
      CALL PLCHLQ(.5, .9, 'Drawing lines with GPL and CURVE', 20., 
     +     0., 0.)
C
C Draw a border around the plot
C
      CALL LINE(0.,0.,1.,0.)
      CALL LINE(1.,0.,1.,1.)
      CALL LINE(1.,1.,0.,1.)
      CALL LINE(0.,1.,0.,0.)
C
C Advance the frame 
C
      CALL FRAME
C
C Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS

      STOP
      END

      PROGRAM CTNCCL
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.  Use one
C of the following:
C
C       PARAMETER (IERF=6,LUNI=2,IWTY=1 ,IWID=1)  !  NCGM
C       PARAMETER (IERF=6,LUNI=2,IWTY=8 ,IWID=1)  !  X Windows
C       PARAMETER (IERF=6,LUNI=2,IWTY=20,IWID=1)  !  PostScript
C       PARAMETER (IERF=6,LUNI=2,IWTY=11,IWID=1)  !  PDF, Portrait
C       PARAMETER (IERF=6,LUNI=2,IWTY=12,IWID=1)  !  PDF, Landscape
C
        PARAMETER (IERF=6,LUNI=2,IWTYPE=1,IWTY=IWTYPE,IWID=1)
C
C The object of this program is to produce a set of plots illustrating
C the use of a triangular mesh derived from a grid on the surface of
C the globe that covers a portion of the North Carolina coastline (sent
C to us by Brett D. Estrade, of the Naval Research Laboratory).
C
C Up to four frames are drawn at each selected viewpoint:
C
C   1) A frame showing the triangular mesh on the globe.  This frame
C      is drawn only if the parameter IMSH is non-zero.
C
C   2) A frame showing simple contours on the globe.  This frame is
C      drawn only if the parameter ICON is non-zero.
C
C   3) A frame showing color-filled contour bands on the globe, drawn
C      using filled areas.  This frame is drawn only if the parameter
C      ICOL is non-zero.
C
C   4) A frame showing color-filled contour bands on the globe, drawn
C      using a cell array.  This frame is drawn only if the parameter
C      ICAP is non-zero.
C
C Define the parameter that says whether or not the triangular mesh is
C to be drawn (frame 1):
C
C       PARAMETER (IMSH=0)  !  triangular mesh not drawn
C       PARAMETER (IMSH=1)  !  triangular mesh drawn
C
        PARAMETER (IMSH=1)
C
C Define the parameter that says whether or not to draw simple contours
C (frame 2):
C
C       PARAMETER (ICON=0)  !  contours not drawn
C       PARAMETER (ICON=1)  !  contours drawn
C
        PARAMETER (ICON=1)
C
C Define the parameter that says whether or not to draw color-filled
C contours (frame 3):
C
C       PARAMETER (ICOL=0)  !  no color fill done
C       PARAMETER (ICOL=1)  !  color fill done
C
        PARAMETER (ICOL=1)
C
C Define the parameter that says whether or not to draw a cell array
C plot (frame 4):
C
C       PARAMETER (ICAP=0)  !  cell array plot not drawn
C       PARAMETER (ICAP=1)  !  cell array plot drawn
C
        PARAMETER (ICAP=1)
C
C To represent the triangular mesh, we use three singly-dimensioned
C arrays: RPNT holds points, IEDG holds edges, and ITRI holds triangles.
C The elements of each array form "nodes" having lengths as follows:
C
        PARAMETER (LOPN=5)
C
C The five elements of a point node are
C
C   1. the X coordinate of the point;
C   2. the Y coordinate of the point;
C   3. the Z coordinate of the point;
C   4. the field value at the point;
C   5. any additional value desired by the user.
C
        PARAMETER (LOEN=5)
C
C The five elements of an edge node are
C
C   1. the base index, in RPNT, of point 1 of the edge;
C   2. the base index, in RPNT, of point 2 of the edge;
C   3. the index, in ITRI, of the pointer to the edge in the triangle to
C      the left of the edge (-1 if there is no triangle to the left);
C   4. the index, in ITRI, of the pointer to the edge in the triangle to
C      the right of the edge (-1 if there is no triangle to the right);
C   5. a utility flag for use by algorithms that scan the structure.
C
C The "left" and "right" sides of an edge are defined as they would be
C by an observer standing on the globe at point 1 of the edge, looking
C toward point 2 of the edge.  It is possible, if there are "holes" in
C the mesh, that there will be no triangle to the left or to the right
C of an edge, but there must be a triangle on one side or the other.
C
        PARAMETER (LOTN=4)
C
C The four elements of a triangle node are
C
C   1. the base index, in IEDG, of edge 1 of the triangle;
C   2. the base index, in IEDG, of edge 2 of the triangle;
C   3. the base index, in IEDG, of edge 3 of the triangle;
C   4. a flag set non-zero to block use of the triangle, effectively
C      removing it from the mesh.
C
C The "base index" of a point node, an edge node, or a triangle node is
C always a multiple of the length of the node, to which can be added an
C offset to get the index of a particular element of the node.  For
C example, if I is the base index of a triangle of interest, ITRI(I+1)
C is its first element (the base index of its first edge).  Similarly,
C IEDG(ITRI(I+1)+2) is the base index of the second point of the first
C edge of the triangle with base index I, and RPNT(IEDG(ITRI(I+1)+2)+3)
C is the third (Z) coordinate of the second point of the first edge of
C the triangle with base index I.
C
C It is the pointers from the edge nodes back to the triangle nodes that
C allow CONPACKT to navigate the mesh, moving from triangle to triangle
C as it follows a contour line, but these pointers are tricky to define:
C if IPTE is the base index of an edge node and IEDG(IPTE+3) is zero or
C more, saying that there is a triangle to the left of the edge, then
C IEDG(IPTE+3) is the actual index of that element of the triangle node
C that points to the edge node; i.e., ITRI(IEDG(IPTE+3))=IPTE.  The base
C index of the triangle node defining that triangle is IPTT, where
C IPTT=LOTN*((IEDG(IPTE+3)-1)/LOTN), and the index of the pointer to
C the edge within the triangle node is IPTI=IEDG(IPTE+3)-IPTT, so that
C ITRI(IPTT+IPTI)=IPTE.  Similar comments apply to element 4 of an edge
C node, which points into the triangle node defining the triangle to the
C right of the edge.
C
C The numbers of points, edges, and triangles in the triangular mesh are
C approximately as follows (obtained from a run in which the numbers
C were set larger than this):
C
        PARAMETER (MNOP=33000)
        PARAMETER (MNOE=91000)
        PARAMETER (MNOT=59000)
C
C Once we know how many points, edges, and triangles we're going to use
C (at most), we can set parameters defining the space reserved for the
C triangular mesh:
C
        PARAMETER (MPNT=MNOP*LOPN)
        PARAMETER (MEDG=MNOE*LOEN)
        PARAMETER (MTRI=MNOT*LOTN)
C
C Declare the arrays to hold the point nodes, edge nodes, and triangle
C nodes defining the triangular mesh.
C
        DIMENSION RPNT(MPNT),IEDG(MEDG),ITRI(MTRI)
C
C Declare sort arrays to be used in GTNCCL to keep track of where points
C and edges were put in the structure defining the triangular mesh.
C
        DIMENSION IPPP(2,MNOP),IPPE(2,MNOE)
C
C Declare real and integer workspaces needed by CONPACKT.
C
        PARAMETER (LRWK=10000,LIWK=1000)
C
        DIMENSION RWRK(LRWK),IWRK(LIWK)
C
C Declare the area map array needed to do solid fill.
C
        PARAMETER (LAMA=1000000)
C
        DIMENSION IAMA(LAMA)
C
C Declare workspace arrays to be used in calls to ARSCAM.
C
        PARAMETER (NCRA=LAMA/10,NGPS=2)
C
        DIMENSION XCRA(NCRA),YCRA(NCRA),IAAI(NGPS),IAGI(NGPS)
C
C Declare arrays in which to generate a cell array picture of the
C data on the triangular mesh.
C
C       PARAMETER (ICAM=1024,ICAN=1024)
        PARAMETER (ICAM= 512,ICAN= 512)
C
        DIMENSION ICRA(ICAM,ICAN)
C
C Declare external the routine that draws masked contour lines.
C
        EXTERNAL DRWMCL
C
C Declare external the routine that does color fill of contour bands.
C
        EXTERNAL DCFOCB
C
C Define a common block in which to keep track of the maximum space used
C in the arrays XCRA and YCRA.
C
        COMMON /COMONA/ MAXN
C
C Define the contour levels to be used and the associated values that say
C what is to be drawn for each level (1 => draw it, 3 => draw it and label
C it).
C
        PARAMETER (NOCL=44)
C
        DIMENSION CLEV(NOCL),ICLU(NOCL)
C
        DATA CLEV( 1),ICLU( 1) /    1. , 1 /
        DATA CLEV( 2),ICLU( 2) /    2. , 1 /
        DATA CLEV( 3),ICLU( 3) /    3. , 1 /
        DATA CLEV( 4),ICLU( 4) /    4. , 1 /
        DATA CLEV( 5),ICLU( 5) /    5. , 1 /
        DATA CLEV( 6),ICLU( 6) /    6. , 1 /
        DATA CLEV( 7),ICLU( 7) /    7. , 1 /
        DATA CLEV( 8),ICLU( 8) /    8. , 1 /
        DATA CLEV( 9),ICLU( 9) /    9. , 1 /
        DATA CLEV(10),ICLU(10) /   10. , 3 /
        DATA CLEV(11),ICLU(11) /   15. , 1 /
        DATA CLEV(12),ICLU(12) /   20. , 3 /
        DATA CLEV(13),ICLU(13) /   25. , 1 /
        DATA CLEV(14),ICLU(14) /   30. , 3 /
        DATA CLEV(15),ICLU(15) /   35. , 1 /
        DATA CLEV(16),ICLU(16) /   40. , 3 /
        DATA CLEV(17),ICLU(17) /   45. , 1 /
        DATA CLEV(18),ICLU(18) /   50. , 3 /
        DATA CLEV(19),ICLU(19) /  100. , 3 /
        DATA CLEV(20),ICLU(20) /  200. , 1 /
        DATA CLEV(21),ICLU(21) /  300. , 1 /
        DATA CLEV(22),ICLU(22) /  400. , 1 /
        DATA CLEV(23),ICLU(23) /  500. , 3 /
        DATA CLEV(24),ICLU(24) /  600. , 1 /
        DATA CLEV(25),ICLU(25) /  700. , 1 /
        DATA CLEV(26),ICLU(26) /  800. , 1 /
        DATA CLEV(27),ICLU(27) /  900. , 1 /
        DATA CLEV(28),ICLU(28) / 1000. , 3 /
        DATA CLEV(29),ICLU(29) / 1250. , 1 /
        DATA CLEV(30),ICLU(30) / 1500. , 1 /
        DATA CLEV(31),ICLU(31) / 1750. , 1 /
        DATA CLEV(32),ICLU(32) / 2000. , 3 /
        DATA CLEV(33),ICLU(33) / 2250. , 1 /
        DATA CLEV(34),ICLU(34) / 2500. , 1 /
        DATA CLEV(35),ICLU(35) / 2750. , 1 /
        DATA CLEV(36),ICLU(36) / 3000. , 3 /
        DATA CLEV(37),ICLU(37) / 3250. , 1 /
        DATA CLEV(38),ICLU(38) / 3500. , 1 /
        DATA CLEV(39),ICLU(39) / 3750. , 1 /
        DATA CLEV(40),ICLU(40) / 4000. , 3 /
        DATA CLEV(41),ICLU(41) / 4250. , 1 /
        DATA CLEV(42),ICLU(42) / 4500. , 1 /
        DATA CLEV(43),ICLU(43) / 4750. , 1 /
        DATA CLEV(44),ICLU(44) / 5000. , 3 /

C
C Define the out-of-range flag.
C
        DATA OORV / 1.E12 /
C
C Define the amount of real workspace to be used in drawing contours.
C
        DATA IRWC / 500 /
C
C Define the high/low search radius.
C
        DATA HLSR / .075 /
C
C Define the high/low label overlap flag.
C
        DATA IHLO / 11 /
C
C Define a constant to convert from radians to degrees.
C
        DATA RTOD / 57.2957795130823 /
C
C Read data and generate the required triangular mesh.
C
        PRINT * , ' '
        PRINT * , 'CREATING TRIANGULAR MESH:'
C
        CALL GTNCCL (RPNT,MPNT,NPNT,LOPN,
     +               IEDG,MEDG,NEDG,LOEN,
     +               ITRI,MTRI,NTRI,LOTN,
     +               IPPP,IPPE,CLAT,CLON)
C
C Print the number of points, edges, and triangles.
C
        PRINT * , '  NUMBER OF POINTS:    ',NPNT/LOPN
        PRINT * , '  NUMBER OF EDGES:     ',NEDG/LOEN
        PRINT * , '  NUMBER OF TRIANGLES: ',NTRI/LOTN
C
C Write the contents of the point list, the edge list, and the triangle
C list to "fort.11" in a readable form.
C
C       WRITE (11,'(''P'',I8,5F10.4)')
C    +        (I,RPNT(I+1),RPNT(I+2),RPNT(I+3),RPNT(I+4),RPNT(I+5),
C    +                                               I=0,NPNT-LOPN,LOPN)
C       WRITE (11,'(''E'',I8,5I10)')
C    +        (I,IEDG(I+1),IEDG(I+2),IEDG(I+3),IEDG(I+4),IEDG(I+5),
C    +                                               I=0,NEDG-LOEN,LOEN)
C       WRITE (11,'(''T'',I8,4I10)')
C    +        (I,ITRI(I+1),ITRI(I+2),ITRI(I+3),ITRI(I+4),
C    +                                               I=0,NTRI-LOTN,LOTN)
C
C Open GKS.
C
        PRINT * , 'OPENING AND INITIALIZING GKS'
C
        CALL GOPKS (IERF,0)
        CALL GOPWK (IWID,LUNI,IWTY)
        CALL GACWK (IWID)
C
C Turn off the clipping indicator.
C
        CALL GSCLIP (0)
C
C Define a basic set of colors (0 = white, background; 1 = black,
C foreground; 2 = gray, outside-mesh area; 3 = magenta; 4 = red;
C 5 = cyan; 6 = green; 7 = blue; 8 = darker light gray; 9 = lighter
C light gray; 10 = dark yellow; 11 = dark gray; 12 = medium gray;
C 13 = light red, for geographic lines; 14 = light blue, for lat/lon
C lines).
C
        CALL GSCR   (IWID, 0,1.,1.,1.)
        CALL GSCR   (IWID, 1,0.,0.,0.)
        CALL GSCR   (IWID, 2,.8,.8,.8)
        CALL GSCR   (IWID, 3,1.,0.,1.)
        CALL GSCR   (IWID, 4,1.,0.,0.)
        CALL GSCR   (IWID, 5,0.,1.,1.)
        CALL GSCR   (IWID, 6,0.,1.,0.)
        CALL GSCR   (IWID, 7,0.,0.,1.)
        CALL GSCR   (IWID, 8,.5,.5,.5)
        CALL GSCR   (IWID, 9,.8,.8,.8)
        CALL GSCR   (IWID,10,.3,.3,0.)
        CALL GSCR   (IWID,11,.3,.3,.3)
        CALL GSCR   (IWID,12,.5,.5,.5)
        CALL GSCR   (IWID,13,.8,.5,.5)
        CALL GSCR   (IWID,14,.5,.5,.8)
C
C Define 100 colors, associated with color indices 151 through 250, to
C be used for color-filled contour bands and in cell arrays, ranging
C from green to blue.
C
        CALL DFCLRS (IWID,151,250,0.,1.,0.,0.,0.,1.)
C
C Set parameters in the utilities.
C
        PRINT * , 'SETTING PARAMETERS IN CONPACKT, EZMAP, AND PLOTCHAR'
C
C Set the mapping flag.
C
        CALL CTSETI ('MAP - MAPPING FLAG',1)
C
C Set the out-of-range flag value.
C
        CALL CTSETR ('ORV - OUT-OF-RANGE VALUE',OORV)
C
C Turn on the drawing of the mesh edge and set the area identifier for
C areas outside the mesh.
C
        CALL CTSETI ('PAI - PARAMETER ARRAY INDEX',-1)
        CALL CTSETI ('CLU - CONTOUR LEVEL USE FLAG',1)
        CALL CTSETI ('AIA - AREA IDENTIFIER FOR AREA',1001)
C
C Set the amount of real workspace to be used in drawing contours.
C
        CALL CTSETI ('RWC - REAL WORKSPACE FOR CONTOURS',IRWC)
C
C Set the dash pattern use flag to tell CONPACKT to use DASHPACK and to
C use only one repetition of it between labels.
C
        CALL CTSETI ('DPU - DASH PATTERN USE FLAG',-1)
C
C Tell CONPACKT to tell DASHPACK to use smaller characters than usual.
C
        CALL CTSETR ('DPS - DASH PATTERN (CHARACTER) SIZE',.008)
C
C Set the high/low search radius.
C
        CALL CTSETR ('HLR - HIGH/LOW SEARCH RADIUS',HLSR)
C
C Set the high/low label overlap flag.
C
        CALL CTSETI ('HLO - HIGH/LOW LABEL OVERLAP FLAG',IHLO)
C
C Change the informational label.
C
        CALL CTSETC ('ILT - INFORMATIONAL LABEL TEXT',
     +                             'CONTOUR LEVELS FROM $CMN$ TO $CMX$')
C
C Set the cell array flag.
C
        CALL CTSETI ('CAF - CELL ARRAY FLAG',-1)
C
C Tell CONPACKT not to do its own call to SET, since EZMAP will have
C done it.
C
        CALL CTSETI ('SET - DO-SET-CALL FLAG', 0)
C
C Move the informational label up a little.
C
        CALL CTSETR ('ILY - INFORMATIONAL LABEL Y POSITION',-.005)
C
C Tell CONPACKT not to choose contour levels.
C
        CALL CTSETI ('CLS - CONTOUR LEVEL SELECTION',0)
C
C Tell CONPACKT exactly which contour levels to use.
C
        CALL CTSETI ('NCL - NUMBER OF CONTOUR LEVELS',NOCL)
C
        DO 101 I=1,NOCL
          CALL CTSETI ('PAI - PARAMETER ARRAY INDEX',I)
          CALL CTSETR ('CLV - CONTOUR LEVEL VALUE',CLEV(I))
          CALL CTSETI ('CLU - CONTOUR LEVEL USE FLAG',ICLU(I))
          IF (ICLU(I).EQ.1) THEN
            CALL CTSETI ('CLC - CONTOUR LEVEL COLOR',9)
          ELSE
            CALL CTSETI ('CLC - CONTOUR LEVEL COLOR',1)
          END IF
  101   CONTINUE
C
C Tell EZMAP not to draw the perimeter.
C
        CALL MPSETI ('PE',0)
C
C Put lat/lon lines at 1-degree intervals.
C
        CALL MPSETI ('GR',1)
C
C Tell PLOTCHAR to use one of the filled fonts and to outline each
C character.
C
        CALL PCSETI ('FN',25)
        CALL PCSETI ('OF',1)
C
C Tell PLOTCHAR to expect a character other than a colon as the
C function-control signal character.
C
        CALL PCSETC ('FC','|')
C
C Loop through the desired viewing angles.
C
        DO 103 IDIR=1,1
C
          PRINT * , ' '
          PRINT * , 'VIEW FROM DIRECTION NUMBER: ',IDIR
C
C Tell EZMAP what projection to use and what its limits are.
C
          IF      (IDIR.EQ.1) THEN
            CALL MAPROJ ('OR',CLAT,CLON,0.)
          END IF
C
C These numbers are tuned to give us a map just covering the area of the
C mesh.
C
          CALL MAPSET ('AN',2.7,2.7,2.0,2.0)
C
C Initialize EZMAP.
C
          CALL MAPINT
C
C If the triangular mesh is to be drawn, do it.
C
          IF (IMSH.NE.0) THEN
C
            PRINT * , 'DRAWING TRIANGULAR MESH'
C
C Triangular mesh (with edges between blocked triangles somewhat fainter
C than the rest):
C
            DO 102 IPTE=0,NEDG-LOEN,LOEN
C
              IFLL=0
C
              IF (IEDG(IPTE+3).GE.0) THEN
                IF (ITRI(LOTN*((IEDG(IPTE+3)-1)/LOTN)+4).EQ.0) IFLL=1
              END IF
C
              IFLR=0
C
              IF (IEDG(IPTE+4).GE.0) THEN
                IF (ITRI(LOTN*((IEDG(IPTE+4)-1)/LOTN)+4).EQ.0) IFLR=1
              END IF
C
              IF (IFLL.NE.0.OR.IFLR.NE.0) THEN
                CALL PLOTIT (0,0,2)
                CALL GSPLCI (8)
              ELSE
                CALL PLOTIT (0,0,2)
                CALL GSPLCI (9)
              END IF
C
              ALAT=RTOD*ASIN(RPNT(IEDG(IPTE+1)+3))
C
              IF (RPNT(IEDG(IPTE+1)+1).EQ.0..AND.
     +            RPNT(IEDG(IPTE+1)+2).EQ.0.) THEN
                ALON=0.
              ELSE
                ALON=RTOD*ATAN2(RPNT(IEDG(IPTE+1)+2),
     +                          RPNT(IEDG(IPTE+1)+1))
              END IF
C
              BLAT=RTOD*ASIN(RPNT(IEDG(IPTE+2)+3))
C
              IF (RPNT(IEDG(IPTE+2)+1).EQ.0..AND.
     +            RPNT(IEDG(IPTE+2)+2).EQ.0.) THEN
                BLON=0.
              ELSE
                BLON=RTOD*ATAN2(RPNT(IEDG(IPTE+2)+2),
     +                          RPNT(IEDG(IPTE+2)+1))
              END IF
C
              CALL DRSGCR (ALAT,ALON,BLAT,BLON)
C
  102       CONTINUE
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (13)
            CALL MAPGRD
C
C Label the first frame.
C
            CALL PLCHHQ (CFUX(.03),CFUY(.946),'North Carolina Coast',
     +                                                      .024,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.904),'Finite Element Mesh',
     +                                                      .018,0.,-1.)
C
            CALL PLCHHQ (CFUX(.97),CFUY(.950),'TRIANGULAR MESH',
     +                                                       .012,0.,1.)
C
C Advance the frame.
C
            CALL FRAME
C
          END IF
C
C If a frame showing simple contours is to be drawn, do it next (adding
C an overlay of lat/lon lines in light red).
C
          IF (ICON.NE.0) THEN
C
            PRINT * , 'DRAWING PLOT SHOWING SIMPLE CONTOURS'
C
C Initialize CONPACKT.
C
            PRINT * , 'CALLING CTMESH'
C
            CALL CTMESH (RPNT,NPNT,LOPN,
     +                   IEDG,NEDG,LOEN,
     +                   ITRI,NTRI,LOTN,
     +                   RWRK,LRWK,
     +                   IWRK,LIWK)
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (1)
C
C Draw the contour lines with labels generated by the dash package.
C
            PRINT * , 'CALLING CTCLDR'
            CALL CTCLDR (RPNT,IEDG,ITRI,RWRK,IWRK)
C
            CALL CTGETI ('IWU - INTEGER WORKSPACE USED',IIWU)
            PRINT * , 'INTEGER WORKSPACE REQUIRED:      ',IIWU
C
            CALL CTGETI ('RWU -    REAL WORKSPACE USED',IRWU)
            PRINT * , 'REAL WORKSPACE REQUIRED:         ',IRWU
C
C Add lat/lon lines.
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (13)
            CALL MAPGRD
C
C Label the second frame.
C
            CALL PLCHHQ (CFUX(.03),CFUY(.946),'North Carolina Coast',
     +                                                      .024,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.904),'Finite Element Mesh',
     +                                                      .018,0.,-1.)
C
            CALL PLCHHQ (CFUX(.97),CFUY(.950),'SIMPLE CONTOURS ON',
     +                                                       .012,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.926),'TRIANGULAR MESH',
     +                                                       .012,0.,1.)
C
            CALL PLCHHQ (CFUX(.97),CFUY(.904),'Data: ocean depth (m)',
     +                                                       .010,0.,1.)
C
C Advance the frame.
C
            CALL FRAME
C
          END IF
C
C If a frame showing color-filled contours is to be drawn, do it next.
C
          IF (ICOL.NE.0) THEN
C
            PRINT * , 'DRAWING PLOT SHOWING COLOR-FILLED CONTOURS'
C
            PRINT * , 'CALLING CTMESH'
C
            CALL CTMESH (RPNT,NPNT,LOPN,
     +                   IEDG,NEDG,LOEN,
     +                   ITRI,NTRI,LOTN,
     +                   RWRK,LRWK,
     +                   IWRK,LIWK)
C
            MAXN=0
C
            PRINT * , 'CALLING ARINAM'
            CALL ARINAM (IAMA,LAMA)
C
            PRINT * , 'CALLING CTCLAM'
            CALL CTCLAM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA)
C
C           PRINT * , 'CALLING CTLBAM'
C           CALL CTLBAM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA)
C
            PRINT * , 'CALLING ARSCAM'
            CALL ARSCAM (IAMA,XCRA,YCRA,NCRA,IAAI,IAGI,NGPS,DCFOCB)
C
            PRINT * , 'SPACE REQUIRED IN AREA MAP:      ',
     +                                         IAMA(1)-IAMA(6)+IAMA(5)+1
C
            PRINT * , 'NUMBER OF POINTS IN LARGEST AREA:',MAXN
C
            CALL CTGETI ('IWU - INTEGER WORKSPACE USED',IIWU)
            PRINT * , 'INTEGER WORKSPACE REQUIRED:      ',IIWU
C
            CALL CTGETI ('RWU -    REAL WORKSPACE USED',IRWU)
            PRINT * , 'REAL WORKSPACE REQUIRED:         ',IRWU
C
            CALL GSFACI (1)
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (13)
            CALL MAPGRD
C
C Label the third frame.
C
            CALL PLCHHQ (CFUX(.03),CFUY(.946),'North Carolina Coast',
     +                                                      .024,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.904),'Finite Element Mesh',
     +                                                      .018,0.,-1.)
C
            CALL PLCHHQ (CFUX(.97),CFUY(.950),'COLORED CONTOUR BANDS ON'
     +,.012,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.926),'TRIANGULAR MESH',
     +                                                       .012,0.,1.)
C
            CALL PLCHHQ (CFUX(.97),CFUY(.904),'Data: ocean depth (m)',
     +                                                       .010,0.,1.)
C
C Advance the frame.
C
            CALL FRAME
C
          END IF
C
C If the flag for it is set, do a cell array plot.
C
          IF (ICAP.NE.0) THEN
C
            PRINT * , 'DRAWING CELL-ARRAY PLOT OF DATA VALUES'
C
            PRINT * , 'CALLING CTMESH'
C
            CALL CTMESH (RPNT,NPNT,LOPN,
     +                   IEDG,NEDG,LOEN,
     +                   ITRI,NTRI,LOTN,
     +                   RWRK,LRWK,
     +                   IWRK,LIWK)
C
            CALL GETSET (XVPL,XVPR,YVPB,YVPT,XWDL,XWDR,YWDB,YWDT,LNLG)
C
            PRINT * , 'CALLING CTCICA'
            CALL CTCICA (RPNT,IEDG,ITRI,RWRK,IWRK,ICRA,ICAM,ICAM,ICAN,
     +                                            XVPL,YVPB,XVPR,YVPT)
C
            PRINT * , 'CALLING GCA'
            CALL GCA (XWDL,YWDB,XWDR,YWDT,ICAM,ICAN,1,1,ICAM,ICAN,ICRA)
C
            CALL CTGETI ('IWU - INTEGER WORKSPACE USED',IIWU)
            PRINT * , 'INTEGER WORKSPACE REQUIRED:      ',IIWU
C
            CALL CTGETI ('RWU -    REAL WORKSPACE USED',IRWU)
            PRINT * , 'REAL WORKSPACE REQUIRED:         ',IRWU
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (13)
            CALL MAPGRD
C
C Label the fourth frame.
C
            CALL PLCHHQ (CFUX(.03),CFUY(.946),'North Carolina Coast',
     +                                                      .024,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.904),'Finite Element Mesh',
     +                                                      .018,0.,-1.)
C
            CALL PLCHHQ (CFUX(.97),CFUY(.950),'CELL ARRAY DERIVED FROM',
     +.012,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.926),'TRIANGULAR MESH',
     +                                                       .012,0.,1.)
C
            CALL PLCHHQ (CFUX(.97),CFUY(.904),'Data: ocean depth (m)',
     +                                                       .010,0.,1.)
C
C Advance the frame.
C
            CALL FRAME
C
          END IF
C
  103   CONTINUE
C
C Close GKS.
C
        CALL GDAWK (IWID)
        CALL GCLWK (IWID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END


      SUBROUTINE DFCLRS (IWID,IOFC,IOLC,REDF,GRNF,BLUF,REDL,GRNL,BLUL)
C
C This routine defines color indices IOFC through IOLC on workstation
C IWID by interpolating values from REDF/GRNF/BLUF to REDL/GRNL/BLUL.
C
        DO 101 I=IOFC,IOLC
          P=REAL(IOLC-I)/REAL(IOLC-IOFC)
          Q=REAL(I-IOFC)/REAL(IOLC-IOFC)
          CALL GSCR (IWID,I,P*REDF+Q*REDL,P*GRNF+Q*GRNL,P*BLUF+Q*BLUL)
  101   CONTINUE
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE DRWMCL (XCRA,YCRA,NCRA,IAAI,IAGI,NGPS)
C
        DIMENSION XCRA(*),YCRA(*),IAAI(*),IAGI(*)
C
C This routine draws the curve defined by the points (XCRA(I),YCRA(I)),
C for I = 1 to NCRA, if and only if none of the area identifiers for the
C area containing the polyline are negative.  It calls either CURVE or
C CURVED to do the drawing, depending on the value of the internal
C parameter 'DPU'.
C
C It keeps track of the maximum value used for NCRA in a common block.
C
        COMMON /COMONA/ MAXN
C
        MAXN=MAX(MAXN,NCRA)
C
C Retrieve the value of the internal parameter 'DPU'.
C
        CALL CTGETI ('DPU - DASH PACKAGE USED',IDUF)
C
C Turn on drawing.
C
        IDRW=1
C
C If any area identifier is negative, turn off drawing.
C
        DO 101 I=1,NGPS
          IF (IAAI(I).LT.0) IDRW=0
  101   CONTINUE
C
C If drawing is turned on, draw the polyline.
C
        IF (IDRW.NE.0) THEN
          IF (IDUF.EQ.0) THEN
            CALL CURVE  (XCRA,YCRA,NCRA)
          ELSE IF (IDUF.LT.0) THEN
            CALL DPCURV (XCRA,YCRA,NCRA)
          ELSE
            CALL CURVED (XCRA,YCRA,NCRA)
          END IF
        END IF
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE DCFOCB (XCRA,YCRA,NCRA,IAAI,IAGI,NGPS)
C
C This routine fills the area defined by the points (XCRA(I),YCRA(I)),
C for I = 1 to NCRA, if and only if none of the area identifiers for
C the area are negative.  The color used is determined from the area
C identifier of the area relative to group 3; it is assumed that 100
C colors are defined having color indices 151 through 250.
C
        DIMENSION XCRA(*),YCRA(*),IAAI(*),IAGI(*)
C
C It keeps track of the maximum value used for NCRA in a common block.
C
        COMMON /COMONA/ MAXN
C
        MAXN=MAX(MAXN,NCRA)
C
C Retrieve the number of contour levels being used.
C
        CALL CTGETI ('NCL - NUMBER OF CONTOUR LEVELS',NOCL)
C
C If the number of contour levels is non-zero and the area has more
C than two points, fill it.
C
        IF (NOCL.NE.0.AND.NCRA.GT.2) THEN
C
          IAI3=-1
C
          DO 101 I=1,NGPS
            IF (IAGI(I).EQ.3) IAI3=IAAI(I)
  101     CONTINUE
C
          IF (IAI3.GE.1.AND.IAI3.LE.NOCL+1) THEN
            CALL GSFACI (151+INT(((REAL(IAI3)-.5)/REAL(NOCL+1))*100.))
            CALL GFA    (NCRA,XCRA,YCRA)
          ELSE IF (IAI3.EQ.1001) THEN
            CALL GSFACI (2)
            CALL GFA    (NCRA,XCRA,YCRA)
          ELSE IF (IAI3.EQ.1002) THEN
            CALL GSFACI (3)
            CALL GFA    (NCRA,XCRA,YCRA)
          END IF
C
        END IF
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE GTNCCL (RPNT,MPNT,NPNT,LOPN,
     +                   IEDG,MEDG,NEDG,LOEN,
     +                   ITRI,MTRI,NTRI,LOTN,
     +                   IPPP,IPPE,CLAT,CLON)
C
        DIMENSION RPNT(MPNT),IEDG(MEDG),ITRI(MTRI),IPPP(2,*),IPPE(2,*)
C
C Construct a triangular mesh using data from Brett Estrade, using a
C routine (CTTMTL) that makes it easy to create an arbitrary triangular
C mesh.  The "tree-sorts" used by this method are very inefficient for
C objects that are partially ordered, so, as the triangles of the mesh
C are generated, they are stored in a triangle buffer from which they
C can be dumped in random order by calls to the routine CTTMTL.
C
C Declare the array to use as the buffer for the triangles, so that the
C order in which they are processed can be somewhat randomized.  Up to
C a point, making this buffer larger will result in more randomization
C of the triangles and speed up the process.  MBUF is the number of
C triangles that will fit in the buffer at once, and KBUF is the number
C of those that are dumped whenever the buffer is found to be full; it
C turns out that it's better to dump more than 1 at a time (I suppose
C because the call and loop set-up time for CTTMTL are non-trivial, so
C it's better to dump a few triangles while you're there).  So ... use
C MBUF > KBUF > 1.
C
        PARAMETER (MBUF=5021,KBUF=173,DTOR=.017453292519943)
C
        DIMENSION TBUF(12,MBUF)
C
C Provide a variable into which a file name may be read.
C
        CHARACTER*64 FLNM
C
C Declare arrays to receive lat/lon coordinate data, contour field data,
C and triangle vertex indices from the ASCII file made from Brett's data.
C
        DIMENSION TLAT(32218),TLON(32218),TDAT(32218),IELE(3,58641)
C
C Read the required data from the ASCII file "ctnccl.dat".
C
        OPEN (11,FILE='ctnccl.dat',STATUS='OLD',FORM='FORMATTED')
C
        READ (11,'(A64)') FLNM
C
        READ (11,*) NTIM,NPIM
C
        TLNS=+1000.
        TLNL=-1000.
        TLTS=+1000.
        TLTL=-1000.
        TDTS=+1000.
        TDTL=-1000.
C
        DO 101 I=1,NPIM
          READ (11,*) IREC,TLON(I),TLAT(I),TDAT(I)
          IF (IREC.NE.I) THEN
            PRINT * , 'Read error in point data - stop ...'
            STOP
          END IF
          IF (TLON(I).LT.TLNS) TLNS=TLON(I)
          IF (TLON(I).GT.TLNL) TLNL=TLON(I)
          IF (TLAT(I).LT.TLTS) TLTS=TLAT(I)
          IF (TLAT(I).GT.TLTL) TLTL=TLAT(I)
          IF (TDAT(I).LT.TDTS) TDTS=TDAT(I)
          IF (TDAT(I).GT.TDTL) TDTL=TDAT(I)
  101   CONTINUE
C
        DO 102 I=1,NTIM
          READ (11,*) IREC,NOVS,IELE(1,I),IELE(2,I),IELE(3,I)
          IF (IREC.NE.I) THEN
            PRINT * , 'Read error in triangle data - stop ...'
            STOP
          END IF
          IF (NOVS.NE.3) THEN
            PRINT * , 'Non-triangle in triangle data - stop ...'
            STOP
          END IF
  102   CONTINUE
C
        CLOSE (11)
C
C Build structures forming the triangular mesh.  First, initialize the
C variables used to keep track of items in the sort arrays for points
C and edges, in the triangle buffer, and in the triangle list.
C
        MPPP=MPNT/LOPN
        NPPP=0
C
        MPPE=MEDG/LOEN
        NPPE=0
C
        NBUF=0
C
        NTRI=0
C
C Loop through the triangles of the grid.
C
        DO 103 I=1,58641
C
C If the triangle buffer is almost full, dump a few randomly-chosen
C triangles from it to make room for two new ones.
C
          IF (NBUF.GE.MBUF) THEN
            CALL CTTMTL (KBUF,TBUF,MBUF,NBUF,
     +                   IPPP,MPPP,NPPP,
     +                   IPPE,MPPE,NPPE,
     +                   RPNT,MPNT,NPNT,LOPN,
     +                   IEDG,MEDG,NEDG,LOEN,
     +                   ITRI,MTRI,NTRI,LOTN)
          END IF
C
C Put a new triangle in the triangle buffer.
C
          NBUF=NBUF+1
C
          TBUF( 1,NBUF)=COS(DTOR*TLAT(IELE(1,I)))*
     +                  COS(DTOR*TLON(IELE(1,I)))
          TBUF( 2,NBUF)=COS(DTOR*TLAT(IELE(1,I)))*
     +                  SIN(DTOR*TLON(IELE(1,I)))
          TBUF( 3,NBUF)=SIN(DTOR*TLAT(IELE(1,I)))
          TBUF( 4,NBUF)=TDAT(IELE(1,I))
C
          TBUF( 5,NBUF)=COS(DTOR*TLAT(IELE(2,I)))*
     +                  COS(DTOR*TLON(IELE(2,I)))
          TBUF( 6,NBUF)=COS(DTOR*TLAT(IELE(2,I)))*
     +                  SIN(DTOR*TLON(IELE(2,I)))
          TBUF( 7,NBUF)=SIN(DTOR*TLAT(IELE(2,I)))
          TBUF( 8,NBUF)=TDAT(IELE(2,I))
C
          TBUF( 9,NBUF)=COS(DTOR*TLAT(IELE(3,I)))*
     +                  COS(DTOR*TLON(IELE(3,I)))
          TBUF(10,NBUF)=COS(DTOR*TLAT(IELE(3,I)))*
     +                  SIN(DTOR*TLON(IELE(3,I)))
          TBUF(11,NBUF)=SIN(DTOR*TLAT(IELE(3,I)))
          TBUF(12,NBUF)=TDAT(IELE(3,I))
C
  103   CONTINUE
C
C Output all triangles remaining in the buffer.
C
        IF (NBUF.NE.0) THEN
          CALL CTTMTL (NBUF,TBUF,MBUF,NBUF,
     +                 IPPP,MPPP,NPPP,
     +                 IPPE,MPPE,NPPE,
     +                 RPNT,MPNT,NPNT,LOPN,
     +                 IEDG,MEDG,NEDG,LOEN,
     +                 ITRI,MTRI,NTRI,LOTN)
        END IF
C
C Set values telling the caller how many points and edges were created.
C
        NPNT=NPPP*LOPN
        NEDG=NPPE*LOEN
C
C Return the latitude and longitude of the approximate center point of
C the mesh on the globe.
C
        CLAT=.5*(TLTS+TLTL)
        CLON=.5*(TLNS+TLNL)
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE DRSGCR (ALAT,ALON,BLAT,BLON)
C
C (DRSGCR = DRaw Shortest Great Circle Route)
C
C This routine draws the shortest great circle route joining two points
C on the globe.  Note that MPTS = INT(180./SIZE) + 1.
C
        PARAMETER (MPTS=181,SIZE=1.)
C
        DIMENSION QLAT(MPTS),QLON(MPTS)
C
        NPTS=MAX(1,MIN(MPTS,INT(ADSGCR(ALAT,ALON,BLAT,BLON)/SIZE)))
C
        CALL MAPGCI (ALAT,ALON,BLAT,BLON,NPTS,QLAT,QLON)
C
        CALL MAPIT (ALAT,ALON,0)
C
        DO 101 I=1,NPTS
          CALL MAPIT (QLAT(I),QLON(I),1)
  101   CONTINUE
C
        CALL MAPIT (BLAT,BLON,2)
C
        CALL MAPIQ
C
        RETURN
C
      END


      FUNCTION ADSGCR (ALAT,ALON,BLAT,BLON)
C
C (ADSGCR = Angle in Degrees along Shortest Great Circle Route)
C
C This function returns the shortest great circle distance, in degrees,
C between two points, A and B, on the surface of the globe.
C
        DATA DTOR / .017453292519943 /
        DATA RTOD / 57.2957795130823 /
C
        XCOA=COS(DTOR*ALAT)*COS(DTOR*ALON)
        YCOA=COS(DTOR*ALAT)*SIN(DTOR*ALON)
        ZCOA=SIN(DTOR*ALAT)
C
        XCOB=COS(DTOR*BLAT)*COS(DTOR*BLON)
        YCOB=COS(DTOR*BLAT)*SIN(DTOR*BLON)
        ZCOB=SIN(DTOR*BLAT)
C
        ADSGCR=2.*RTOD*ASIN(SQRT((XCOA-XCOB)**2+
     +                           (YCOA-YCOB)**2+
     +                           (ZCOA-ZCOB)**2)/2.)
C
        RETURN
C
      END


      SUBROUTINE CTSCAE (ICRA,ICA1,ICAM,ICAN,XCPF,YCPF,XCQF,YCQF,
     +                                       IND1,IND2,ICAF,IAID)
        DIMENSION ICRA(ICA1,*)
C
C This routine is called by CTCICA when the internal parameter 'CAF' is
C given a negative value.  Each call is intended to create a particular
C element in the user's cell array.  The arguments are as follows:
C
C ICRA is the user's cell array.
C
C ICA1 is the first dimension of the FORTRAN array ICRA.
C
C ICAM and ICAN are the first and second dimensions of the cell array
C stored in ICRA.
C
C (XCPF,YCPF) is the point at that corner of the rectangular area
C into which the cell array maps that corresponds to the cell (1,1).
C The coordinates are given in the fractional coordinate system (unlike
C what is required in a call to GCA, in which the coordinates of the
C point P are in the world coordinate system).
C
C (XCQF,YCQF) is the point at that corner of the rectangular area into
C which the cell array maps that corresponds to the cell (ICAM,ICAN).
C The coordinates are given in the fractional coordinate system (unlike
C what is required in a call to GCA, in which the coordinates of the
C point Q are in the world coordinate system).
C
C IND1 is the 1st index of the cell that is to be updated.
C
C IND2 is the 2nd index of the cell that is to be updated.
C
C ICAF is the current value of the internal parameter 'CAF'.  This
C value will always be an integer which is less than zero (because
C when 'CAF' is zero or greater, this routine is not called).
C
C IAID is the area identifier associated with the cell.  It will have
C been given one of the values from the internal parameter array 'AIA'
C (the one for 'PAI' = -2 if the cell lies in an out-of-range area, the
C one for 'PAI' = -1 if the cell lies off the data grid, or the one for
C some value of 'PAI' between 1 and 'NCL' if the cell lies on the data
C grid).  The value zero may occur if the cell falls in an out-of-range
C area and the value of 'AIA' for 'PAI' = -2 is 0 or if the cell lies
C off the data grid and the value of 'AIA' for 'PAI' = -1 is 0, or if
C the cell falls on the data grid, but no contour level below the cell
C has a non-zero 'AIA' and no contour level above the cell has a
C non-zero 'AIB'.  Note that, if the values of 'AIA' for 'PAI' = -1
C and -2 are given non-zero values, IAID can only be given a zero
C value in one way.
C
C The default behavior of CTSCAE is as follows:  If the area identifier
C is non-negative, it is treated as a color index, to be stored in the
C appropriate cell in the cell array; but if the area identifier is
C negative, a zero is stored for the color index.  The user may supply
C a version of CTSCAE that does something different; it may simply map
C the area identifiers into color indices or it may somehow modify the
C existing cell array element to incorporate the information provided
C by the area identifier.
C
C       ICRA(IND1,IND2)=MAX(0,IAID)
C
C What follows is not the default behavior; instead, it is the behavior
C expected by many of the example programs for CONPACKT.
C
        CALL CTGETI ('NCL - NUMBER OF CONTOUR LEVELS',NOCL)
C
        IF (IAID.GE.1.AND.IAID.LE.NOCL+1) THEN
          ICRA(IND1,IND2)=151+INT(((REAL(IAID)-.5)/REAL(NOCL+1))*100.)
        ELSE IF (IAID.EQ.1001) THEN
          ICRA(IND1,IND2)=2
        ELSE IF (IAID.EQ.1002) THEN
          ICRA(IND1,IND2)=3
        END IF
C
        RETURN
C
      END

C
C       $Id: vvsetc.f,v 1.15 2008-07-27 00:17:35 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
C
C-----------------------------------------------------------------------
C
      SUBROUTINE VVSETC (CNM,CVL)
C
      CHARACTER*(*) CNM,CVL
C
C This subroutine is called to give a specified character value to a
C specified parameter.
C
C CNM is the name of the parameter whose value is to be set.
C
C CVL is a character variable containing the new value of the
C parameter.
C
C ---------------------------------------------------------------------
C
C NOTE:
C Since implicit typing is used for all real and integer variables
C a consistent length convention has been adopted to help clarify the
C significance of the variables encountered in the code for this 
C utility. All local variable and subroutine parameter identifiers 
C are limited to 1,2,or 3 characters. Four character names identify  
C members of common blocks. Five and 6 character variable names 
C denote PARAMETER constants or subroutine or function names.
C
C Declare the VV common blocks.
C
C IPLVLS - Maximum number of color threshold level values
C IPAGMX - Maximum number of area groups allowed in the area map
C
      PARAMETER (IPLVLS = 256, IPAGMX = 64)
C
C Integer and real common block variables
C
C
      COMMON /VVCOM/
     +                IUD1       ,IVD1       ,IPD1       ,IXDM       ,
     +                IYDN       ,VLOM       ,VHIM       ,ISET       ,
     +                VRMG       ,VRLN       ,VFRC       ,IXIN       ,
     +                IYIN       ,ISVF       ,UUSV       ,UVSV       ,
     +                UPSV       ,IMSK       ,ICPM       ,UVPS       ,
     +                UVPL       ,UVPR       ,UVPB       ,UVPT       ,
     +                UWDL       ,UWDR       ,UWDB       ,UWDT       ,
     +                UXC1       ,UXCM       ,UYC1       ,UYCN       ,
     +                NLVL       ,IPAI       ,ICTV       ,WDLV       ,
     +                UVMN       ,UVMX       ,PMIN       ,PMAX       ,
     +                RVMN       ,RVMX       ,RDMN       ,RDMX       ,
     +                ISPC       ,RVMD       ,IPLR       ,IVST       ,
     +                IVPO       ,ILBL       ,IDPF       ,IMSG       ,
     +                ICLR(IPLVLS)           ,TVLU(IPLVLS)
C
C Arrow size/shape parameters
C
        COMMON / VVARO /
     +                HDSZ       ,HINF       ,HANG       ,IAST       ,
     +                HSIN       ,HCOS       ,FAMN       ,FAMX       ,
     +                UVMG       ,FAIR       ,FAWR       ,FAWF       ,
     +                FAXR       ,FAXF       ,FAYR       ,FAYF       ,
     +                AROX(8)    ,AROY(8)    ,FXSZ       ,FYSZ       ,
     +                FXRF       ,FXMN       ,FYRF       ,FYMN       ,
     +                FWRF       ,FWMN       ,FIRF       ,FIMN       ,
     +                AXMN       ,AXMX       ,AYMN       ,AYMX       ,
     +                IACM       ,IAFO       ,WBAD       ,WBTF       ,
     +                WBCF       ,WBDF       ,WBSC
C
C
C Text related parameters
C
        COMMON /VVTXP /
     +                FCWM    ,ICSZ    ,
     +                FMNS    ,FMNX    ,FMNY    ,IMNP    ,IMNC  ,
     +                FMXS    ,FMXX    ,FMXY    ,IMXP    ,IMXC  ,
     +                FZFS    ,FZFX    ,FZFY    ,IZFP    ,IZFC  ,
     +                FILS    ,FILX    ,FILY    ,IILP    ,IILC  ,
     +                FLBS    ,ILBC

C
C Character variable declartions
C
      CHARACTER*160 CSTR
      PARAMETER (IPCHSZ=36)
      CHARACTER*(IPCHSZ)  CMNT,CMXT,CZFT,CLBT,CILT
C
C Text string parameters
C
      COMMON /VVCHAR/ CSTR,CMNT,CMXT,CZFT,CLBT,CILT
C
      SAVE /VVCOM/, /VVARO/, /VVTXP/, /VVCHAR/
C
C The mapping common block: made available to user mapping routines
C
      COMMON /VVMAP/
     +                IMAP       ,
     +                XVPL       ,XVPR       ,YVPB       ,YVPT       ,
     +                WXMN       ,WXMX       ,WYMN       ,WYMX       ,
     +                XLOV       ,XHIV       ,YLOV       ,YHIV       ,
     +                SXDC       ,SYDC       ,NXCT       ,NYCT       ,
     +                RLEN       ,LNLG       ,INVX       ,INVY       ,
     +                ITRT       ,IWCT       ,FW2W       ,FH2H       ,
     +                DVMN       ,DVMX       ,RBIG       ,IBIG
C
      SAVE /VVMAP/
C
C Math constants
C
      PARAMETER (PDTOR  = 0.017453292519943,
     +           PRTOD  = 57.2957795130823,
     +           P1XPI  = 3.14159265358979,
     +           P2XPI  = 6.28318530717959,
     +           P1D2PI = 1.57079632679489,
     +           P5D2PI = 7.85398163397448) 
C
C --------------------------------------------------------------------
C
C Check for a parameter name that is too short.
C
      IF (LEN(CNM).LT.3) THEN
        CSTR(1:36)='VVSETC - PARAMETER NAME TOO SHORT - '
        CSTR(37:36+LEN(CNM))=CNM
        CALL SETER (CSTR(1:36+LEN(CNM)),1,1)
        RETURN
      END IF
C
C Set the proper parameter.
C
      IF (CNM(1:3).EQ.'MNT'.OR.CNM(1:3).EQ.'mnt') THEN
         CMNT=CVL
      ELSE IF (CNM(1:3).EQ.'MXT'.OR.CNM(1:3).EQ.'mxt') THEN
         CMXT=CVL
      ELSE IF (CNM(1:3).EQ.'ZFT'.OR.CNM(1:3).EQ.'zft') THEN
         CZFT=CVL
      ELSE IF (CNM(1:3).EQ.'ILT'.OR.CNM(1:3).EQ.'ilt') THEN
         CILT=CVL
      ELSE
C
         CSTR(1:36)='VVSETC - PARAMETER NAME NOT KNOWN - '
         CSTR(37:39)=CNM(1:3)
         CALL SETER (CSTR(1:39),2,1)
         RETURN
C
      END IF
C
C Done.
C
      RETURN
C
      END

C
C	$Id: conlcm.f,v 1.4 2008-07-27 00:16:55 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      FUNCTION CONLCM(X,Y,XD,YD,ZD,NDP,WK,IWK,LOC)
C
C  COMPUTE A Z VALUE FOR A GIVEN X,Y VALUE
C  NOTE THAT X,Y MUST BE INSIDE THE CONVEX HULL OF THE INPUT DATA
C  INORDER FOR THIS FUNCTION TO WORK.
C
C  INPUT
C       X-X COORDINATE OF REQUESTED POINT
C       Y-Y COORDINATE OF REQUESTED POINT
C       WK-LIST OF COEFICENTS FOR LINEAR INTERPOLATION  FUNCTIONS
C             LOCATED BY A = WK((TRI-1)*3+1)
C                        B = WK((TRI-2)*3+1)
C                        C = WK((TRI-3)*3+1)
C
C  OUTPUT
C       LOC-TRIANGLE NUMBER OF REQUESTED POINT
C       Z VALUE AS FUNCTION RESULT
C
      DIMENSION WK(1),IWK(1),XD(1),YD(1),ZD(1)
C
      COMMON /CONR10/ NT         ,NL         ,NTNL       ,JWIPT      ,
     1                JWIWL      ,JWIWP      ,JWIPL      ,IPR        ,
     2                ITPV
C
        SAVE
C
C  LOCATE THE TRIANGLE
C
      CALL CONLOC(NDP,XD,YD,NT,IWK(JWIPT),NL,IWK(JWIPL),X,Y,LOC,
     1            IWK(JWIWL),WK)
C
C  IF OUTSIDE CONVEX HULL THEN DON'T COMPUTE A VALUE
C
      IF (LOC.GT.NT) RETURN
C
C  GET THE VECTOR 1 VALUES FOR THE TRIANGLE
C
      IVEC = (LOC-1)*3 + JWIPT
      IV = IWK(IVEC)
      X1 = X - XD(IV)
      Y1 = Y - YD(IV)
      Z1 = ZD(IV)
C
C  COMPUT THE Z VALUE
C
      IPOINT = (LOC-1)*3 + IPR
C
      Z = (WK(IPOINT)*X1+WK(IPOINT+1)*Y1)/WK(IPOINT+2) + Z1
C
      CONLCM = Z
C
      RETURN
      END

      SUBROUTINE DHSEQR( JOB, COMPZ, N, ILO, IHI, H, LDH, WR, WI, Z,
     $                   LDZ, WORK, LWORK, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          COMPZ, JOB
      INTEGER            IHI, ILO, INFO, LDH, LDZ, LWORK, N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   H( LDH, * ), WI( * ), WORK( * ), WR( * ),
     $                   Z( LDZ, * )
*     ..
*
*  Purpose
*  =======
*
*  DHSEQR computes the eigenvalues of a real upper Hessenberg matrix H
*  and, optionally, the matrices T and Z from the Schur decomposition
*  H = Z T Z**T, where T is an upper quasi-triangular matrix (the Schur
*  form), and Z is the orthogonal matrix of Schur vectors.
*
*  Optionally Z may be postmultiplied into an input orthogonal matrix Q,
*  so that this routine can give the Schur factorization of a matrix A
*  which has been reduced to the Hessenberg form H by the orthogonal
*  matrix Q:  A = Q*H*Q**T = (QZ)*T*(QZ)**T.
*
*  Arguments
*  =========
*
*  JOB     (input) CHARACTER*1
*          = 'E':  compute eigenvalues only;
*          = 'S':  compute eigenvalues and the Schur form T.
*
*  COMPZ   (input) CHARACTER*1
*          = 'N':  no Schur vectors are computed;
*          = 'I':  Z is initialized to the unit matrix and the matrix Z
*                  of Schur vectors of H is returned;
*          = 'V':  Z must contain an orthogonal matrix Q on entry, and
*                  the product Q*Z is returned.
*
*  N       (input) INTEGER
*          The order of the matrix H.  N >= 0.
*
*  ILO     (input) INTEGER
*  IHI     (input) INTEGER
*          It is assumed that H is already upper triangular in rows
*          and columns 1:ILO-1 and IHI+1:N. ILO and IHI are normally
*          set by a previous call to DGEBAL, and then passed to SGEHRD
*          when the matrix output by DGEBAL is reduced to Hessenberg
*          form. Otherwise ILO and IHI should be set to 1 and N
*          respectively.
*          1 <= ILO <= IHI <= N, if N > 0; ILO=1 and IHI=0, if N=0.
*
*  H       (input/output) DOUBLE PRECISION array, dimension (LDH,N)
*          On entry, the upper Hessenberg matrix H.
*          On exit, if JOB = 'S', H contains the upper quasi-triangular
*          matrix T from the Schur decomposition (the Schur form);
*          2-by-2 diagonal blocks (corresponding to complex conjugate
*          pairs of eigenvalues) are returned in standard form, with
*          H(i,i) = H(i+1,i+1) and H(i+1,i)*H(i,i+1) < 0. If JOB = 'E',
*          the contents of H are unspecified on exit.
*
*  LDH     (input) INTEGER
*          The leading dimension of the array H. LDH >= max(1,N).
*
*  WR      (output) DOUBLE PRECISION array, dimension (N)
*  WI      (output) DOUBLE PRECISION array, dimension (N)
*          The real and imaginary parts, respectively, of the computed
*          eigenvalues. If two eigenvalues are computed as a complex
*          conjugate pair, they are stored in consecutive elements of
*          WR and WI, say the i-th and (i+1)th, with WI(i) > 0 and
*          WI(i+1) < 0. If JOB = 'S', the eigenvalues are stored in the
*          same order as on the diagonal of the Schur form returned in
*          H, with WR(i) = H(i,i) and, if H(i:i+1,i:i+1) is a 2-by-2
*          diagonal block, WI(i) = sqrt(H(i+1,i)*H(i,i+1)) and
*          WI(i+1) = -WI(i).
*
*  Z       (input/output) DOUBLE PRECISION array, dimension (LDZ,N)
*          If COMPZ = 'N': Z is not referenced.
*          If COMPZ = 'I': on entry, Z need not be set, and on exit, Z
*          contains the orthogonal matrix Z of the Schur vectors of H.
*          If COMPZ = 'V': on entry Z must contain an N-by-N matrix Q,
*          which is assumed to be equal to the unit matrix except for
*          the submatrix Z(ILO:IHI,ILO:IHI); on exit Z contains Q*Z.
*          Normally Q is the orthogonal matrix generated by DORGHR after
*          the call to DGEHRD which formed the Hessenberg matrix H.
*
*  LDZ     (input) INTEGER
*          The leading dimension of the array Z.
*          LDZ >= max(1,N) if COMPZ = 'I' or 'V'; LDZ >= 1 otherwise.
*
*  WORK    (workspace/output) DOUBLE PRECISION array, dimension (LWORK)
*          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*
*  LWORK   (input) INTEGER
*          The dimension of the array WORK.  LWORK >= max(1,N).
*
*          If LWORK = -1, then a workspace query is assumed; the routine
*          only calculates the optimal size of the WORK array, returns
*          this value as the first entry of the WORK array, and no error
*          message related to LWORK is issued by XERBLA.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*          > 0:  if INFO = i, DHSEQR failed to compute all of the
*                eigenvalues in a total of 30*(IHI-ILO+1) iterations;
*                elements 1:ilo-1 and i+1:n of WR and WI contain those
*                eigenvalues which have been successfully computed.
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO, ONE, TWO
      PARAMETER          ( ZERO = 0.0D+0, ONE = 1.0D+0, TWO = 2.0D+0 )
      DOUBLE PRECISION   CONST
      PARAMETER          ( CONST = 1.5D+0 )
      INTEGER            NSMAX, LDS
      PARAMETER          ( NSMAX = 15, LDS = NSMAX )
*     ..
*     .. Local Scalars ..
      LOGICAL            INITZ, LQUERY, WANTT, WANTZ
      INTEGER            I, I1, I2, IERR, II, ITEMP, ITN, ITS, J, K, L,
     $                   MAXB, NH, NR, NS, NV
      DOUBLE PRECISION   ABSW, OVFL, SMLNUM, TAU, TEMP, TST1, ULP, UNFL
*     ..
*     .. Local Arrays ..
      DOUBLE PRECISION   S( LDS, NSMAX ), V( NSMAX+1 ), VV( NSMAX+1 )
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            IDAMAX, ILAENV
      DOUBLE PRECISION   DLAMCH, DLANHS, DLAPY2
      EXTERNAL           LSAME, IDAMAX, ILAENV, DLAMCH, DLANHS, DLAPY2
*     ..
*     .. External Subroutines ..
      EXTERNAL           DCOPY, DGEMV, DLACPY, DLAHQR, DLARFG, DLARFX,
     $                   DLASET, DSCAL, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, MAX, MIN
*     ..
*     .. Executable Statements ..
*
*     Decode and test the input parameters
*
      WANTT = LSAME( JOB, 'S' )
      INITZ = LSAME( COMPZ, 'I' )
      WANTZ = INITZ .OR. LSAME( COMPZ, 'V' )
*
      INFO = 0
      WORK( 1 ) = MAX( 1, N )
      LQUERY = ( LWORK.EQ.-1 )
      IF( .NOT.LSAME( JOB, 'E' ) .AND. .NOT.WANTT ) THEN
         INFO = -1
      ELSE IF( .NOT.LSAME( COMPZ, 'N' ) .AND. .NOT.WANTZ ) THEN
         INFO = -2
      ELSE IF( N.LT.0 ) THEN
         INFO = -3
      ELSE IF( ILO.LT.1 .OR. ILO.GT.MAX( 1, N ) ) THEN
         INFO = -4
      ELSE IF( IHI.LT.MIN( ILO, N ) .OR. IHI.GT.N ) THEN
         INFO = -5
      ELSE IF( LDH.LT.MAX( 1, N ) ) THEN
         INFO = -7
      ELSE IF( LDZ.LT.1 .OR. WANTZ .AND. LDZ.LT.MAX( 1, N ) ) THEN
         INFO = -11
      ELSE IF( LWORK.LT.MAX( 1, N ) .AND. .NOT.LQUERY ) THEN
         INFO = -13
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DHSEQR', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         RETURN
      END IF
*
*     Initialize Z, if necessary
*
      IF( INITZ )
     $   CALL DLASET( 'Full', N, N, ZERO, ONE, Z, LDZ )
*
*     Store the eigenvalues isolated by DGEBAL.
*
      DO 10 I = 1, ILO - 1
         WR( I ) = H( I, I )
         WI( I ) = ZERO
   10 CONTINUE
      DO 20 I = IHI + 1, N
         WR( I ) = H( I, I )
         WI( I ) = ZERO
   20 CONTINUE
*
*     Quick return if possible.
*
      IF( N.EQ.0 )
     $   RETURN
      IF( ILO.EQ.IHI ) THEN
         WR( ILO ) = H( ILO, ILO )
         WI( ILO ) = ZERO
         RETURN
      END IF
*
*     Set rows and columns ILO to IHI to zero below the first
*     subdiagonal.
*
      DO 40 J = ILO, IHI - 2
         DO 30 I = J + 2, N
            H( I, J ) = ZERO
   30    CONTINUE
   40 CONTINUE
      NH = IHI - ILO + 1
*
*     Determine the order of the multi-shift QR algorithm to be used.
*
      NS = ILAENV( 4, 'DHSEQR', JOB // COMPZ, N, ILO, IHI, -1 )
      MAXB = ILAENV( 8, 'DHSEQR', JOB // COMPZ, N, ILO, IHI, -1 )
      IF( NS.LE.2 .OR. NS.GT.NH .OR. MAXB.GE.NH ) THEN
*
*        Use the standard double-shift algorithm
*
         CALL DLAHQR( WANTT, WANTZ, N, ILO, IHI, H, LDH, WR, WI, ILO,
     $                IHI, Z, LDZ, INFO )
         RETURN
      END IF
      MAXB = MAX( 3, MAXB )
      NS = MIN( NS, MAXB, NSMAX )
*
*     Now 2 < NS <= MAXB < NH.
*
*     Set machine-dependent constants for the stopping criterion.
*     If norm(H) <= sqrt(OVFL), overflow should not occur.
*
      UNFL = DLAMCH( 'Safe minimum' )
      OVFL = ONE / UNFL
      CALL DLABAD( UNFL, OVFL )
      ULP = DLAMCH( 'Precision' )
      SMLNUM = UNFL*( NH / ULP )
*
*     I1 and I2 are the indices of the first row and last column of H
*     to which transformations must be applied. If eigenvalues only are
*     being computed, I1 and I2 are set inside the main loop.
*
      IF( WANTT ) THEN
         I1 = 1
         I2 = N
      END IF
*
*     ITN is the total number of multiple-shift QR iterations allowed.
*
      ITN = 30*NH
*
*     The main loop begins here. I is the loop index and decreases from
*     IHI to ILO in steps of at most MAXB. Each iteration of the loop
*     works with the active submatrix in rows and columns L to I.
*     Eigenvalues I+1 to IHI have already converged. Either L = ILO or
*     H(L,L-1) is negligible so that the matrix splits.
*
      I = IHI
   50 CONTINUE
      L = ILO
      IF( I.LT.ILO )
     $   GO TO 170
*
*     Perform multiple-shift QR iterations on rows and columns ILO to I
*     until a submatrix of order at most MAXB splits off at the bottom
*     because a subdiagonal element has become negligible.
*
      DO 150 ITS = 0, ITN
*
*        Look for a single small subdiagonal element.
*
         DO 60 K = I, L + 1, -1
            TST1 = ABS( H( K-1, K-1 ) ) + ABS( H( K, K ) )
            IF( TST1.EQ.ZERO )
     $         TST1 = DLANHS( '1', I-L+1, H( L, L ), LDH, WORK )
            IF( ABS( H( K, K-1 ) ).LE.MAX( ULP*TST1, SMLNUM ) )
     $         GO TO 70
   60    CONTINUE
   70    CONTINUE
         L = K
         IF( L.GT.ILO ) THEN
*
*           H(L,L-1) is negligible.
*
            H( L, L-1 ) = ZERO
         END IF
*
*        Exit from loop if a submatrix of order <= MAXB has split off.
*
         IF( L.GE.I-MAXB+1 )
     $      GO TO 160
*
*        Now the active submatrix is in rows and columns L to I. If
*        eigenvalues only are being computed, only the active submatrix
*        need be transformed.
*
         IF( .NOT.WANTT ) THEN
            I1 = L
            I2 = I
         END IF
*
         IF( ITS.EQ.20 .OR. ITS.EQ.30 ) THEN
*
*           Exceptional shifts.
*
            DO 80 II = I - NS + 1, I
               WR( II ) = CONST*( ABS( H( II, II-1 ) )+
     $                    ABS( H( II, II ) ) )
               WI( II ) = ZERO
   80       CONTINUE
         ELSE
*
*           Use eigenvalues of trailing submatrix of order NS as shifts.
*
            CALL DLACPY( 'Full', NS, NS, H( I-NS+1, I-NS+1 ), LDH, S,
     $                   LDS )
            CALL DLAHQR( .FALSE., .FALSE., NS, 1, NS, S, LDS,
     $                   WR( I-NS+1 ), WI( I-NS+1 ), 1, NS, Z, LDZ,
     $                   IERR )
            IF( IERR.GT.0 ) THEN
*
*              If DLAHQR failed to compute all NS eigenvalues, use the
*              unconverged diagonal elements as the remaining shifts.
*
               DO 90 II = 1, IERR
                  WR( I-NS+II ) = S( II, II )
                  WI( I-NS+II ) = ZERO
   90          CONTINUE
            END IF
         END IF
*
*        Form the first column of (G-w(1)) (G-w(2)) . . . (G-w(ns))
*        where G is the Hessenberg submatrix H(L:I,L:I) and w is
*        the vector of shifts (stored in WR and WI). The result is
*        stored in the local array V.
*
         V( 1 ) = ONE
         DO 100 II = 2, NS + 1
            V( II ) = ZERO
  100    CONTINUE
         NV = 1
         DO 120 J = I - NS + 1, I
            IF( WI( J ).GE.ZERO ) THEN
               IF( WI( J ).EQ.ZERO ) THEN
*
*                 real shift
*
                  CALL DCOPY( NV+1, V, 1, VV, 1 )
                  CALL DGEMV( 'No transpose', NV+1, NV, ONE, H( L, L ),
     $                        LDH, VV, 1, -WR( J ), V, 1 )
                  NV = NV + 1
               ELSE IF( WI( J ).GT.ZERO ) THEN
*
*                 complex conjugate pair of shifts
*
                  CALL DCOPY( NV+1, V, 1, VV, 1 )
                  CALL DGEMV( 'No transpose', NV+1, NV, ONE, H( L, L ),
     $                        LDH, V, 1, -TWO*WR( J ), VV, 1 )
                  ITEMP = IDAMAX( NV+1, VV, 1 )
                  TEMP = ONE / MAX( ABS( VV( ITEMP ) ), SMLNUM )
                  CALL DSCAL( NV+1, TEMP, VV, 1 )
                  ABSW = DLAPY2( WR( J ), WI( J ) )
                  TEMP = ( TEMP*ABSW )*ABSW
                  CALL DGEMV( 'No transpose', NV+2, NV+1, ONE,
     $                        H( L, L ), LDH, VV, 1, TEMP, V, 1 )
                  NV = NV + 2
               END IF
*
*              Scale V(1:NV) so that max(abs(V(i))) = 1. If V is zero,
*              reset it to the unit vector.
*
               ITEMP = IDAMAX( NV, V, 1 )
               TEMP = ABS( V( ITEMP ) )
               IF( TEMP.EQ.ZERO ) THEN
                  V( 1 ) = ONE
                  DO 110 II = 2, NV
                     V( II ) = ZERO
  110             CONTINUE
               ELSE
                  TEMP = MAX( TEMP, SMLNUM )
                  CALL DSCAL( NV, ONE / TEMP, V, 1 )
               END IF
            END IF
  120    CONTINUE
*
*        Multiple-shift QR step
*
         DO 140 K = L, I - 1
*
*           The first iteration of this loop determines a reflection G
*           from the vector V and applies it from left and right to H,
*           thus creating a nonzero bulge below the subdiagonal.
*
*           Each subsequent iteration determines a reflection G to
*           restore the Hessenberg form in the (K-1)th column, and thus
*           chases the bulge one step toward the bottom of the active
*           submatrix. NR is the order of G.
*
            NR = MIN( NS+1, I-K+1 )
            IF( K.GT.L )
     $         CALL DCOPY( NR, H( K, K-1 ), 1, V, 1 )
            CALL DLARFG( NR, V( 1 ), V( 2 ), 1, TAU )
            IF( K.GT.L ) THEN
               H( K, K-1 ) = V( 1 )
               DO 130 II = K + 1, I
                  H( II, K-1 ) = ZERO
  130          CONTINUE
            END IF
            V( 1 ) = ONE
*
*           Apply G from the left to transform the rows of the matrix in
*           columns K to I2.
*
            CALL DLARFX( 'Left', NR, I2-K+1, V, TAU, H( K, K ), LDH,
     $                   WORK )
*
*           Apply G from the right to transform the columns of the
*           matrix in rows I1 to min(K+NR,I).
*
            CALL DLARFX( 'Right', MIN( K+NR, I )-I1+1, NR, V, TAU,
     $                   H( I1, K ), LDH, WORK )
*
            IF( WANTZ ) THEN
*
*              Accumulate transformations in the matrix Z
*
               CALL DLARFX( 'Right', NH, NR, V, TAU, Z( ILO, K ), LDZ,
     $                      WORK )
            END IF
  140    CONTINUE
*
  150 CONTINUE
*
*     Failure to converge in remaining number of iterations
*
      INFO = I
      RETURN
*
  160 CONTINUE
*
*     A submatrix of order <= MAXB in rows and columns L to I has split
*     off. Use the double-shift QR algorithm to handle it.
*
      CALL DLAHQR( WANTT, WANTZ, N, L, I, H, LDH, WR, WI, ILO, IHI, Z,
     $             LDZ, INFO )
      IF( INFO.GT.0 )
     $   RETURN
*
*     Decrement number of remaining iterations, and return to start of
*     the main loop with a new value of I.
*
      ITN = ITN - ITS
      I = L - 1
      GO TO 50
*
  170 CONTINUE
      WORK( 1 ) = MAX( 1, N )
      RETURN
*
*     End of DHSEQR
*
      END

      PROGRAM PGKEX14
C
C  Illustrate character height and up vector.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      DATA DTR / .017453292519943 /
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF,IDUM)
      CALL GOPWK (IWKID,LUNIT,IWTYPE)
      CALL GACWK (IWKID)
C
C  Define colors.
C
      CALL GSCR(IWKID,0,1.,1.,1.)
      CALL GSCR(IWKID,1,0.,0.,1.)
      CALL GSCR(IWKID,2,.4,.0,.4)
C
      CALL GSTXFP(-4,2)
C
C  Alignment = [center, center]
C
      CALL GSTXAL(2,3)
C
C  Loop through angles from 1 degree to 135 degrees on a circular arc
C  in increments proportional to character heights.  Position text
C  strings centered on a circular arc with up vectors being tangents
C  to the arc.
C
      IANG = 1
  110 CONTINUE
      ANG=DTR*REAL(IANG)
      XOFF = .3
      YOFF = .2
C
C  Calculate an (X,Y) coordinate on the arc.
C
      XCD=XOFF+.4*COS(ANG)
      YCD=YOFF+.4*SIN(ANG)
C
C  The up vector is tangent to the circular arc.
C
      CHUX = -(YCD-YOFF)
      CHUY =   XCD-XOFF
      CALL GSCHUP(CHUX,CHUY)
C
C  Scale the character heights depending on the angle and plot the text.
C
      CHH = .0004*(136-IANG)
      CALL GSCHH(CHH)
      CALL GTX(XCD,YCD,'NCAR')
C
C  Increment the angle by an amount proportional to the character heights.
C
      IANG = REAL(IANG)+MAX(210.*CHH,1.)
      IF (IANG .LE. 135) GO TO 110
C
C  Plot a character string with the up vector being down.
C
      CALL GSCHUP(0.,-1.)
      CALL GSCHH(.03)
      CALL GTX(.25,.34,'NCAR')
      CALL GSCHUP(0.,1.)
      CALL GSTXCI(2)
      CALL GSCHH(.025)
      CALL GTX(.25,.40,'Vect.=(0.,-1.)')
C
C  Plot a character string with up vector at an angle to the right.
C
      CALL GSCHUP(1.6,2.)
      CALL GSCHH(.03)
      CALL GSTXCI(1)
      CALL GTX(.65,.65,'NCAR')
      CALL GSCHUP(0.,1.)
      CALL GSTXCI(2)
      CALL GSCHH(.025)
      CALL GTX(.8,.7,'Vect.=(1.6,2.)')
C
C  Label the plot using Plotchar.
C
      CALL PCSETI('FN',25)
      CALL PCSETI('CC',2)
      CALL PLCHHQ(.1,.89,'Character heights &',.035,0.,-1.)
      CALL PLCHHQ(.1,.82,'Character up vectors',.035,0.,-1.)
C
      CALL FRAME
C
C  Deactivate and close the workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END

      SUBROUTINE DORGBR( VECT, M, N, K, A, LDA, TAU, WORK, LWORK, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          VECT
      INTEGER            INFO, K, LDA, LWORK, M, N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), TAU( * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  DORGBR generates one of the real orthogonal matrices Q or P**T
*  determined by DGEBRD when reducing a real matrix A to bidiagonal
*  form: A = Q * B * P**T.  Q and P**T are defined as products of
*  elementary reflectors H(i) or G(i) respectively.
*
*  If VECT = 'Q', A is assumed to have been an M-by-K matrix, and Q
*  is of order M:
*  if m >= k, Q = H(1) H(2) . . . H(k) and DORGBR returns the first n
*  columns of Q, where m >= n >= k;
*  if m < k, Q = H(1) H(2) . . . H(m-1) and DORGBR returns Q as an
*  M-by-M matrix.
*
*  If VECT = 'P', A is assumed to have been a K-by-N matrix, and P**T
*  is of order N:
*  if k < n, P**T = G(k) . . . G(2) G(1) and DORGBR returns the first m
*  rows of P**T, where n >= m >= k;
*  if k >= n, P**T = G(n-1) . . . G(2) G(1) and DORGBR returns P**T as
*  an N-by-N matrix.
*
*  Arguments
*  =========
*
*  VECT    (input) CHARACTER*1
*          Specifies whether the matrix Q or the matrix P**T is
*          required, as defined in the transformation applied by DGEBRD:
*          = 'Q':  generate Q;
*          = 'P':  generate P**T.
*
*  M       (input) INTEGER
*          The number of rows of the matrix Q or P**T to be returned.
*          M >= 0.
*
*  N       (input) INTEGER
*          The number of columns of the matrix Q or P**T to be returned.
*          N >= 0.
*          If VECT = 'Q', M >= N >= min(M,K);
*          if VECT = 'P', N >= M >= min(N,K).
*
*  K       (input) INTEGER
*          If VECT = 'Q', the number of columns in the original M-by-K
*          matrix reduced by DGEBRD.
*          If VECT = 'P', the number of rows in the original K-by-N
*          matrix reduced by DGEBRD.
*          K >= 0.
*
*  A       (input/output) DOUBLE PRECISION array, dimension (LDA,N)
*          On entry, the vectors which define the elementary reflectors,
*          as returned by DGEBRD.
*          On exit, the M-by-N matrix Q or P**T.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A. LDA >= max(1,M).
*
*  TAU     (input) DOUBLE PRECISION array, dimension
*                                (min(M,K)) if VECT = 'Q'
*                                (min(N,K)) if VECT = 'P'
*          TAU(i) must contain the scalar factor of the elementary
*          reflector H(i) or G(i), which determines Q or P**T, as
*          returned by DGEBRD in its array argument TAUQ or TAUP.
*
*  WORK    (workspace/output) DOUBLE PRECISION array, dimension (LWORK)
*          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*
*  LWORK   (input) INTEGER
*          The dimension of the array WORK. LWORK >= max(1,min(M,N)).
*          For optimum performance LWORK >= min(M,N)*NB, where NB
*          is the optimal blocksize.
*
*          If LWORK = -1, then a workspace query is assumed; the routine
*          only calculates the optimal size of the WORK array, returns
*          this value as the first entry of the WORK array, and no error
*          message related to LWORK is issued by XERBLA.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO, ONE
      PARAMETER          ( ZERO = 0.0D+0, ONE = 1.0D+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            LQUERY, WANTQ
      INTEGER            I, IINFO, J, LWKOPT, MN, NB
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            ILAENV
      EXTERNAL           LSAME, ILAENV
*     ..
*     .. External Subroutines ..
      EXTERNAL           DORGLQ, DORGQR, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN
*     ..
*     .. Executable Statements ..
*
*     Test the input arguments
*
      INFO = 0
      WANTQ = LSAME( VECT, 'Q' )
      MN = MIN( M, N )
      LQUERY = ( LWORK.EQ.-1 )
      IF( .NOT.WANTQ .AND. .NOT.LSAME( VECT, 'P' ) ) THEN
         INFO = -1
      ELSE IF( M.LT.0 ) THEN
         INFO = -2
      ELSE IF( N.LT.0 .OR. ( WANTQ .AND. ( N.GT.M .OR. N.LT.MIN( M,
     $         K ) ) ) .OR. ( .NOT.WANTQ .AND. ( M.GT.N .OR. M.LT.
     $         MIN( N, K ) ) ) ) THEN
         INFO = -3
      ELSE IF( K.LT.0 ) THEN
         INFO = -4
      ELSE IF( LDA.LT.MAX( 1, M ) ) THEN
         INFO = -6
      ELSE IF( LWORK.LT.MAX( 1, MN ) .AND. .NOT.LQUERY ) THEN
         INFO = -9
      END IF
*
      IF( INFO.EQ.0 ) THEN
         IF( WANTQ ) THEN
            NB = ILAENV( 1, 'DORGQR', ' ', M, N, K, -1 )
         ELSE
            NB = ILAENV( 1, 'DORGLQ', ' ', M, N, K, -1 )
         END IF
         LWKOPT = MAX( 1, MN )*NB
         WORK( 1 ) = LWKOPT
      END IF
*
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DORGBR', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( M.EQ.0 .OR. N.EQ.0 ) THEN
         WORK( 1 ) = 1
         RETURN
      END IF
*
      IF( WANTQ ) THEN
*
*        Form Q, determined by a call to DGEBRD to reduce an m-by-k
*        matrix
*
         IF( M.GE.K ) THEN
*
*           If m >= k, assume m >= n >= k
*
            CALL DORGQR( M, N, K, A, LDA, TAU, WORK, LWORK, IINFO )
*
         ELSE
*
*           If m < k, assume m = n
*
*           Shift the vectors which define the elementary reflectors one
*           column to the right, and set the first row and column of Q
*           to those of the unit matrix
*
            DO 20 J = M, 2, -1
               A( 1, J ) = ZERO
               DO 10 I = J + 1, M
                  A( I, J ) = A( I, J-1 )
   10          CONTINUE
   20       CONTINUE
            A( 1, 1 ) = ONE
            DO 30 I = 2, M
               A( I, 1 ) = ZERO
   30       CONTINUE
            IF( M.GT.1 ) THEN
*
*              Form Q(2:m,2:m)
*
               CALL DORGQR( M-1, M-1, M-1, A( 2, 2 ), LDA, TAU, WORK,
     $                      LWORK, IINFO )
            END IF
         END IF
      ELSE
*
*        Form P', determined by a call to DGEBRD to reduce a k-by-n
*        matrix
*
         IF( K.LT.N ) THEN
*
*           If k < n, assume k <= m <= n
*
            CALL DORGLQ( M, N, K, A, LDA, TAU, WORK, LWORK, IINFO )
*
         ELSE
*
*           If k >= n, assume m = n
*
*           Shift the vectors which define the elementary reflectors one
*           row downward, and set the first row and column of P' to
*           those of the unit matrix
*
            A( 1, 1 ) = ONE
            DO 40 I = 2, N
               A( I, 1 ) = ZERO
   40       CONTINUE
            DO 60 J = 2, N
               DO 50 I = J - 1, 2, -1
                  A( I, J ) = A( I-1, J )
   50          CONTINUE
               A( 1, J ) = ZERO
   60       CONTINUE
            IF( N.GT.1 ) THEN
*
*              Form P'(2:n,2:n)
*
               CALL DORGLQ( N-1, N-1, N-1, A( 2, 2 ), LDA, TAU, WORK,
     $                      LWORK, IINFO )
            END IF
         END IF
      END IF
      WORK( 1 ) = LWKOPT
      RETURN
*
*     End of DORGBR
*
      END

      SUBROUTINE ZGBEQU( M, N, KL, KU, AB, LDAB, R, C, ROWCND, COLCND,
     $                   AMAX, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1992
*
*     .. Scalar Arguments ..
      INTEGER            INFO, KL, KU, LDAB, M, N
      DOUBLE PRECISION   AMAX, COLCND, ROWCND
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   C( * ), R( * )
      COMPLEX*16         AB( LDAB, * )
*     ..
*
*  Purpose
*  =======
*
*  ZGBEQU computes row and column scalings intended to equilibrate an
*  M-by-N band matrix A and reduce its condition number.  R returns the
*  row scale factors and C the column scale factors, chosen to try to
*  make the largest element in each row and column of the matrix B with
*  elements B(i,j)=R(i)*A(i,j)*C(j) have absolute value 1.
*
*  R(i) and C(j) are restricted to be between SMLNUM = smallest safe
*  number and BIGNUM = largest safe number.  Use of these scaling
*  factors is not guaranteed to reduce the condition number of A but
*  works well in practice.
*
*  Arguments
*  =========
*
*  M       (input) INTEGER
*          The number of rows of the matrix A.  M >= 0.
*
*  N       (input) INTEGER
*          The number of columns of the matrix A.  N >= 0.
*
*  KL      (input) INTEGER
*          The number of subdiagonals within the band of A.  KL >= 0.
*
*  KU      (input) INTEGER
*          The number of superdiagonals within the band of A.  KU >= 0.
*
*  AB      (input) COMPLEX*16 array, dimension (LDAB,N)
*          The band matrix A, stored in rows 1 to KL+KU+1.  The j-th
*          column of A is stored in the j-th column of the array AB as
*          follows:
*          AB(ku+1+i-j,j) = A(i,j) for max(1,j-ku)<=i<=min(m,j+kl).
*
*  LDAB    (input) INTEGER
*          The leading dimension of the array AB.  LDAB >= KL+KU+1.
*
*  R       (output) DOUBLE PRECISION array, dimension (M)
*          If INFO = 0, or INFO > M, R contains the row scale factors
*          for A.
*
*  C       (output) DOUBLE PRECISION array, dimension (N)
*          If INFO = 0, C contains the column scale factors for A.
*
*  ROWCND  (output) DOUBLE PRECISION
*          If INFO = 0 or INFO > M, ROWCND contains the ratio of the
*          smallest R(i) to the largest R(i).  If ROWCND >= 0.1 and
*          AMAX is neither too large nor too small, it is not worth
*          scaling by R.
*
*  COLCND  (output) DOUBLE PRECISION
*          If INFO = 0, COLCND contains the ratio of the smallest
*          C(i) to the largest C(i).  If COLCND >= 0.1, it is not
*          worth scaling by C.
*
*  AMAX    (output) DOUBLE PRECISION
*          Absolute value of largest matrix element.  If AMAX is very
*          close to overflow or very close to underflow, the matrix
*          should be scaled.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*          > 0:  if INFO = i, and i is
*                <= M:  the i-th row of A is exactly zero
*                >  M:  the (i-M)-th column of A is exactly zero
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ONE, ZERO
      PARAMETER          ( ONE = 1.0D+0, ZERO = 0.0D+0 )
*     ..
*     .. Local Scalars ..
      INTEGER            I, J, KD
      DOUBLE PRECISION   BIGNUM, RCMAX, RCMIN, SMLNUM
      COMPLEX*16         ZDUM
*     ..
*     .. External Functions ..
      DOUBLE PRECISION   DLAMCH
      EXTERNAL           DLAMCH
*     ..
*     .. External Subroutines ..
      EXTERNAL           XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, DBLE, DIMAG, MAX, MIN
*     ..
*     .. Statement Functions ..
      DOUBLE PRECISION   CABS1
*     ..
*     .. Statement Function definitions ..
      CABS1( ZDUM ) = ABS( DBLE( ZDUM ) ) + ABS( DIMAG( ZDUM ) )
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters
*
      INFO = 0
      IF( M.LT.0 ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( KL.LT.0 ) THEN
         INFO = -3
      ELSE IF( KU.LT.0 ) THEN
         INFO = -4
      ELSE IF( LDAB.LT.KL+KU+1 ) THEN
         INFO = -6
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'ZGBEQU', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( M.EQ.0 .OR. N.EQ.0 ) THEN
         ROWCND = ONE
         COLCND = ONE
         AMAX = ZERO
         RETURN
      END IF
*
*     Get machine constants.
*
      SMLNUM = DLAMCH( 'S' )
      BIGNUM = ONE / SMLNUM
*
*     Compute row scale factors.
*
      DO 10 I = 1, M
         R( I ) = ZERO
   10 CONTINUE
*
*     Find the maximum element in each row.
*
      KD = KU + 1
      DO 30 J = 1, N
         DO 20 I = MAX( J-KU, 1 ), MIN( J+KL, M )
            R( I ) = MAX( R( I ), CABS1( AB( KD+I-J, J ) ) )
   20    CONTINUE
   30 CONTINUE
*
*     Find the maximum and minimum scale factors.
*
      RCMIN = BIGNUM
      RCMAX = ZERO
      DO 40 I = 1, M
         RCMAX = MAX( RCMAX, R( I ) )
         RCMIN = MIN( RCMIN, R( I ) )
   40 CONTINUE
      AMAX = RCMAX
*
      IF( RCMIN.EQ.ZERO ) THEN
*
*        Find the first zero scale factor and return an error code.
*
         DO 50 I = 1, M
            IF( R( I ).EQ.ZERO ) THEN
               INFO = I
               RETURN
            END IF
   50    CONTINUE
      ELSE
*
*        Invert the scale factors.
*
         DO 60 I = 1, M
            R( I ) = ONE / MIN( MAX( R( I ), SMLNUM ), BIGNUM )
   60    CONTINUE
*
*        Compute ROWCND = min(R(I)) / max(R(I))
*
         ROWCND = MAX( RCMIN, SMLNUM ) / MIN( RCMAX, BIGNUM )
      END IF
*
*     Compute column scale factors
*
      DO 70 J = 1, N
         C( J ) = ZERO
   70 CONTINUE
*
*     Find the maximum element in each column,
*     assuming the row scaling computed above.
*
      KD = KU + 1
      DO 90 J = 1, N
         DO 80 I = MAX( J-KU, 1 ), MIN( J+KL, M )
            C( J ) = MAX( C( J ), CABS1( AB( KD+I-J, J ) )*R( I ) )
   80    CONTINUE
   90 CONTINUE
*
*     Find the maximum and minimum scale factors.
*
      RCMIN = BIGNUM
      RCMAX = ZERO
      DO 100 J = 1, N
         RCMIN = MIN( RCMIN, C( J ) )
         RCMAX = MAX( RCMAX, C( J ) )
  100 CONTINUE
*
      IF( RCMIN.EQ.ZERO ) THEN
*
*        Find the first zero scale factor and return an error code.
*
         DO 110 J = 1, N
            IF( C( J ).EQ.ZERO ) THEN
               INFO = M + J
               RETURN
            END IF
  110    CONTINUE
      ELSE
*
*        Invert the scale factors.
*
         DO 120 J = 1, N
            C( J ) = ONE / MIN( MAX( C( J ), SMLNUM ), BIGNUM )
  120    CONTINUE
*
*        Compute COLCND = min(C(J)) / max(C(J))
*
         COLCND = MAX( RCMIN, SMLNUM ) / MIN( RCMAX, BIGNUM )
      END IF
*
      RETURN
*
*     End of ZGBEQU
*
      END

      SUBROUTINE ZHPGVX( ITYPE, JOBZ, RANGE, UPLO, N, AP, BP, VL, VU,
     $                   IL, IU, ABSTOL, M, W, Z, LDZ, WORK, RWORK,
     $                   IWORK, IFAIL, INFO )
*
*  -- LAPACK driver routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          JOBZ, RANGE, UPLO
      INTEGER            IL, INFO, ITYPE, IU, LDZ, M, N
      DOUBLE PRECISION   ABSTOL, VL, VU
*     ..
*     .. Array Arguments ..
      INTEGER            IFAIL( * ), IWORK( * )
      DOUBLE PRECISION   RWORK( * ), W( * )
      COMPLEX*16         AP( * ), BP( * ), WORK( * ), Z( LDZ, * )
*     ..
*
*  Purpose
*  =======
*
*  ZHPGVX computes selected eigenvalues and, optionally, eigenvectors
*  of a complex generalized Hermitian-definite eigenproblem, of the form
*  A*x=(lambda)*B*x,  A*Bx=(lambda)*x,  or B*A*x=(lambda)*x.  Here A and
*  B are assumed to be Hermitian, stored in packed format, and B is also
*  positive definite.  Eigenvalues and eigenvectors can be selected by
*  specifying either a range of values or a range of indices for the
*  desired eigenvalues.
*
*  Arguments
*  =========
*
*  ITYPE   (input) INTEGER
*          Specifies the problem type to be solved:
*          = 1:  A*x = (lambda)*B*x
*          = 2:  A*B*x = (lambda)*x
*          = 3:  B*A*x = (lambda)*x
*
*  JOBZ    (input) CHARACTER*1
*          = 'N':  Compute eigenvalues only;
*          = 'V':  Compute eigenvalues and eigenvectors.
*
*  RANGE   (input) CHARACTER*1
*          = 'A': all eigenvalues will be found;
*          = 'V': all eigenvalues in the half-open interval (VL,VU]
*                 will be found;
*          = 'I': the IL-th through IU-th eigenvalues will be found.
*
*  UPLO    (input) CHARACTER*1
*          = 'U':  Upper triangles of A and B are stored;
*          = 'L':  Lower triangles of A and B are stored.
*
*  N       (input) INTEGER
*          The order of the matrices A and B.  N >= 0.
*
*  AP      (input/output) COMPLEX*16 array, dimension (N*(N+1)/2)
*          On entry, the upper or lower triangle of the Hermitian matrix
*          A, packed columnwise in a linear array.  The j-th column of A
*          is stored in the array AP as follows:
*          if UPLO = 'U', AP(i + (j-1)*j/2) = A(i,j) for 1<=i<=j;
*          if UPLO = 'L', AP(i + (j-1)*(2*n-j)/2) = A(i,j) for j<=i<=n.
*
*          On exit, the contents of AP are destroyed.
*
*  BP      (input/output) COMPLEX*16 array, dimension (N*(N+1)/2)
*          On entry, the upper or lower triangle of the Hermitian matrix
*          B, packed columnwise in a linear array.  The j-th column of B
*          is stored in the array BP as follows:
*          if UPLO = 'U', BP(i + (j-1)*j/2) = B(i,j) for 1<=i<=j;
*          if UPLO = 'L', BP(i + (j-1)*(2*n-j)/2) = B(i,j) for j<=i<=n.
*
*          On exit, the triangular factor U or L from the Cholesky
*          factorization B = U**H*U or B = L*L**H, in the same storage
*          format as B.
*
*  VL      (input) DOUBLE PRECISION
*  VU      (input) DOUBLE PRECISION
*          If RANGE='V', the lower and upper bounds of the interval to
*          be searched for eigenvalues. VL < VU.
*          Not referenced if RANGE = 'A' or 'I'.
*
*  IL      (input) INTEGER
*  IU      (input) INTEGER
*          If RANGE='I', the indices (in ascending order) of the
*          smallest and largest eigenvalues to be returned.
*          1 <= IL <= IU <= N, if N > 0; IL = 1 and IU = 0 if N = 0.
*          Not referenced if RANGE = 'A' or 'V'.
*
*  ABSTOL  (input) DOUBLE PRECISION
*          The absolute error tolerance for the eigenvalues.
*          An approximate eigenvalue is accepted as converged
*          when it is determined to lie in an interval [a,b]
*          of width less than or equal to
*
*                  ABSTOL + EPS *   max( |a|,|b| ) ,
*
*          where EPS is the machine precision.  If ABSTOL is less than
*          or equal to zero, then  EPS*|T|  will be used in its place,
*          where |T| is the 1-norm of the tridiagonal matrix obtained
*          by reducing AP to tridiagonal form.
*
*          Eigenvalues will be computed most accurately when ABSTOL is
*          set to twice the underflow threshold 2*DLAMCH('S'), not zero.
*          If this routine returns with INFO>0, indicating that some
*          eigenvectors did not converge, try setting ABSTOL to
*          2*DLAMCH('S').
*
*  M       (output) INTEGER
*          The total number of eigenvalues found.  0 <= M <= N.
*          If RANGE = 'A', M = N, and if RANGE = 'I', M = IU-IL+1.
*
*  W       (output) DOUBLE PRECISION array, dimension (N)
*          On normal exit, the first M elements contain the selected
*          eigenvalues in ascending order.
*
*  Z       (output) COMPLEX*16 array, dimension (LDZ, N)
*          If JOBZ = 'N', then Z is not referenced.
*          If JOBZ = 'V', then if INFO = 0, the first M columns of Z
*          contain the orthonormal eigenvectors of the matrix A
*          corresponding to the selected eigenvalues, with the i-th
*          column of Z holding the eigenvector associated with W(i).
*          The eigenvectors are normalized as follows:
*          if ITYPE = 1 or 2, Z**H*B*Z = I;
*          if ITYPE = 3, Z**H*inv(B)*Z = I.
*
*          If an eigenvector fails to converge, then that column of Z
*          contains the latest approximation to the eigenvector, and the
*          index of the eigenvector is returned in IFAIL.
*          Note: the user must ensure that at least max(1,M) columns are
*          supplied in the array Z; if RANGE = 'V', the exact value of M
*          is not known in advance and an upper bound must be used.
*
*  LDZ     (input) INTEGER
*          The leading dimension of the array Z.  LDZ >= 1, and if
*          JOBZ = 'V', LDZ >= max(1,N).
*
*  WORK    (workspace) COMPLEX*16 array, dimension (2*N)
*
*  RWORK   (workspace) DOUBLE PRECISION array, dimension (7*N)
*
*  IWORK   (workspace) INTEGER array, dimension (5*N)
*
*  IFAIL   (output) INTEGER array, dimension (N)
*          If JOBZ = 'V', then if INFO = 0, the first M elements of
*          IFAIL are zero.  If INFO > 0, then IFAIL contains the
*          indices of the eigenvectors that failed to converge.
*          If JOBZ = 'N', then IFAIL is not referenced.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*          > 0:  ZPPTRF or ZHPEVX returned an error code:
*             <= N:  if INFO = i, ZHPEVX failed to converge;
*                    i eigenvectors failed to converge.  Their indices
*                    are stored in array IFAIL.
*             > N:   if INFO = N + i, for 1 <= i <= n, then the leading
*                    minor of order i of B is not positive definite.
*                    The factorization of B could not be completed and
*                    no eigenvalues or eigenvectors were computed.
*
*  Further Details
*  ===============
*
*  Based on contributions by
*     Mark Fahey, Department of Mathematics, Univ. of Kentucky, USA
*
*  =====================================================================
*
*     .. Local Scalars ..
      LOGICAL            ALLEIG, INDEIG, UPPER, VALEIG, WANTZ
      CHARACTER          TRANS
      INTEGER            J
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           XERBLA, ZHPEVX, ZHPGST, ZPPTRF, ZTPMV, ZTPSV
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MIN
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      WANTZ = LSAME( JOBZ, 'V' )
      UPPER = LSAME( UPLO, 'U' )
      ALLEIG = LSAME( RANGE, 'A' )
      VALEIG = LSAME( RANGE, 'V' )
      INDEIG = LSAME( RANGE, 'I' )
*
      INFO = 0
      IF( ITYPE.LT.0 .OR. ITYPE.GT.3 ) THEN
         INFO = -1
      ELSE IF( .NOT.( WANTZ .OR. LSAME( JOBZ, 'N' ) ) ) THEN
         INFO = -2
      ELSE IF( .NOT.( ALLEIG .OR. VALEIG .OR. INDEIG ) ) THEN
         INFO = -3
      ELSE IF( .NOT.( UPPER .OR. LSAME( UPLO, 'L' ) ) ) THEN
         INFO = -4
      ELSE IF( N.LT.0 ) THEN
         INFO = -5
      ELSE IF( VALEIG .AND. N.GT.0 .AND. VU.LE.VL ) THEN
         INFO = -9
      ELSE IF( INDEIG .AND. IL.LT.1 ) THEN
         INFO = -10
      ELSE IF( INDEIG .AND. ( IU.LT.MIN( N, IL ) .OR. IU.GT.N ) ) THEN
         INFO = -11
      ELSE IF( LDZ.LT.1 .OR. ( WANTZ .AND. LDZ.LT.N ) ) THEN
         INFO = -16
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'ZHPGVX', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
*
*     Form a Cholesky factorization of B.
*
      CALL ZPPTRF( UPLO, N, BP, INFO )
      IF( INFO.NE.0 ) THEN
         INFO = N + INFO
         RETURN
      END IF
*
*     Transform problem to standard eigenvalue problem and solve.
*
      CALL ZHPGST( ITYPE, UPLO, N, AP, BP, INFO )
      CALL ZHPEVX( JOBZ, RANGE, UPLO, N, AP, VL, VU, IL, IU, ABSTOL, M,
     $             W, Z, LDZ, WORK, RWORK, IWORK, IFAIL, INFO )
*
      IF( WANTZ ) THEN
*
*        Backtransform eigenvectors to the original problem.
*
         IF( INFO.GT.0 )
     $      M = INFO - 1
         IF( ITYPE.EQ.1 .OR. ITYPE.EQ.2 ) THEN
*
*           For A*x=(lambda)*B*x and A*B*x=(lambda)*x;
*           backtransform eigenvectors: x = inv(L)'*y or inv(U)*y
*
            IF( UPPER ) THEN
               TRANS = 'N'
            ELSE
               TRANS = 'C'
            END IF
*
            DO 10 J = 1, M
               CALL ZTPSV( UPLO, TRANS, 'Non-unit', N, BP, Z( 1, J ),
     $                     1 )
   10       CONTINUE
*
         ELSE IF( ITYPE.EQ.3 ) THEN
*
*           For B*A*x=(lambda)*x;
*           backtransform eigenvectors: x = L*y or U'*y
*
            IF( UPPER ) THEN
               TRANS = 'C'
            ELSE
               TRANS = 'N'
            END IF
*
            DO 20 J = 1, M
               CALL ZTPMV( UPLO, TRANS, 'Non-unit', N, BP, Z( 1, J ),
     $                     1 )
   20       CONTINUE
         END IF
      END IF
*
      RETURN
*
*     End of ZHPGVX
*
      END

      SUBROUTINE SLATDF( IJOB, N, Z, LDZ, RHS, RDSUM, RDSCAL, IPIV,
     $                   JPIV )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      INTEGER            IJOB, LDZ, N
      REAL               RDSCAL, RDSUM
*     ..
*     .. Array Arguments ..
      INTEGER            IPIV( * ), JPIV( * )
      REAL               RHS( * ), Z( LDZ, * )
*     ..
*
*  Purpose
*  =======
*
*  SLATDF uses the LU factorization of the n-by-n matrix Z computed by
*  SGETC2 and computes a contribution to the reciprocal Dif-estimate
*  by solving Z * x = b for x, and choosing the r.h.s. b such that
*  the norm of x is as large as possible. On entry RHS = b holds the
*  contribution from earlier solved sub-systems, and on return RHS = x.
*
*  The factorization of Z returned by SGETC2 has the form Z = P*L*U*Q,
*  where P and Q are permutation matrices. L is lower triangular with
*  unit diagonal elements and U is upper triangular.
*
*  Arguments
*  =========
*
*  IJOB    (input) INTEGER
*          IJOB = 2: First compute an approximative null-vector e
*              of Z using SGECON, e is normalized and solve for
*              Zx = +-e - f with the sign giving the greater value
*              of 2-norm(x). About 5 times as expensive as Default.
*          IJOB .ne. 2: Local look ahead strategy where all entries of
*              the r.h.s. b is choosen as either +1 or -1 (Default).
*
*  N       (input) INTEGER
*          The number of columns of the matrix Z.
*
*  Z       (input) REAL array, dimension (LDZ, N)
*          On entry, the LU part of the factorization of the n-by-n
*          matrix Z computed by SGETC2:  Z = P * L * U * Q
*
*  LDZ     (input) INTEGER
*          The leading dimension of the array Z.  LDA >= max(1, N).
*
*  RHS     (input/output) REAL array, dimension N.
*          On entry, RHS contains contributions from other subsystems.
*          On exit, RHS contains the solution of the subsystem with
*          entries acoording to the value of IJOB (see above).
*
*  RDSUM   (input/output) REAL
*          On entry, the sum of squares of computed contributions to
*          the Dif-estimate under computation by STGSYL, where the
*          scaling factor RDSCAL (see below) has been factored out.
*          On exit, the corresponding sum of squares updated with the
*          contributions from the current sub-system.
*          If TRANS = 'T' RDSUM is not touched.
*          NOTE: RDSUM only makes sense when STGSY2 is called by STGSYL.
*
*  RDSCAL  (input/output) REAL
*          On entry, scaling factor used to prevent overflow in RDSUM.
*          On exit, RDSCAL is updated w.r.t. the current contributions
*          in RDSUM.
*          If TRANS = 'T', RDSCAL is not touched.
*          NOTE: RDSCAL only makes sense when STGSY2 is called by
*                STGSYL.
*
*  IPIV    (input) INTEGER array, dimension (N).
*          The pivot indices; for 1 <= i <= N, row i of the
*          matrix has been interchanged with row IPIV(i).
*
*  JPIV    (input) INTEGER array, dimension (N).
*          The pivot indices; for 1 <= j <= N, column j of the
*          matrix has been interchanged with column JPIV(j).
*
*  Further Details
*  ===============
*
*  Based on contributions by
*     Bo Kagstrom and Peter Poromaa, Department of Computing Science,
*     Umea University, S-901 87 Umea, Sweden.
*
*  This routine is a further developed implementation of algorithm
*  BSOLVE in [1] using complete pivoting in the LU factorization.
*
*  [1] Bo Kagstrom and Lars Westin,
*      Generalized Schur Methods with Condition Estimators for
*      Solving the Generalized Sylvester Equation, IEEE Transactions
*      on Automatic Control, Vol. 34, No. 7, July 1989, pp 745-751.
*
*  [2] Peter Poromaa,
*      On Efficient and Robust Estimators for the Separation
*      between two Regular Matrix Pairs with Applications in
*      Condition Estimation. Report IMINF-95.05, Departement of
*      Computing Science, Umea University, S-901 87 Umea, Sweden, 1995.
*
*  =====================================================================
*
*     .. Parameters ..
      INTEGER            MAXDIM
      PARAMETER          ( MAXDIM = 8 )
      REAL               ZERO, ONE
      PARAMETER          ( ZERO = 0.0E+0, ONE = 1.0E+0 )
*     ..
*     .. Local Scalars ..
      INTEGER            I, INFO, J, K
      REAL               BM, BP, PMONE, SMINU, SPLUS, TEMP
*     ..
*     .. Local Arrays ..
      INTEGER            IWORK( MAXDIM )
      REAL               WORK( 4*MAXDIM ), XM( MAXDIM ), XP( MAXDIM )
*     ..
*     .. External Subroutines ..
      EXTERNAL           SAXPY, SCOPY, SGECON, SGESC2, SLASSQ, SLASWP,
     $                   SSCAL
*     ..
*     .. External Functions ..
      REAL               SASUM, SDOT
      EXTERNAL           SASUM, SDOT
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, SQRT
*     ..
*     .. Executable Statements ..
*
      IF( IJOB.NE.2 ) THEN
*
*        Apply permutations IPIV to RHS
*
         CALL SLASWP( 1, RHS, LDZ, 1, N-1, IPIV, 1 )
*
*        Solve for L-part choosing RHS either to +1 or -1.
*
         PMONE = -ONE
*
         DO 10 J = 1, N - 1
            BP = RHS( J ) + ONE
            BM = RHS( J ) - ONE
            SPLUS = ONE
*
*           Look-ahead for L-part RHS(1:N-1) = + or -1, SPLUS and
*           SMIN computed more efficiently than in BSOLVE [1].
*
            SPLUS = SPLUS + SDOT( N-J, Z( J+1, J ), 1, Z( J+1, J ), 1 )
            SMINU = SDOT( N-J, Z( J+1, J ), 1, RHS( J+1 ), 1 )
            SPLUS = SPLUS*RHS( J )
            IF( SPLUS.GT.SMINU ) THEN
               RHS( J ) = BP
            ELSE IF( SMINU.GT.SPLUS ) THEN
               RHS( J ) = BM
            ELSE
*
*              In this case the updating sums are equal and we can
*              choose RHS(J) +1 or -1. The first time this happens
*              we choose -1, thereafter +1. This is a simple way to
*              get good estimates of matrices like Byers well-known
*              example (see [1]). (Not done in BSOLVE.)
*
               RHS( J ) = RHS( J ) + PMONE
               PMONE = ONE
            END IF
*
*           Compute the remaining r.h.s.
*
            TEMP = -RHS( J )
            CALL SAXPY( N-J, TEMP, Z( J+1, J ), 1, RHS( J+1 ), 1 )
*
   10    CONTINUE
*
*        Solve for U-part, look-ahead for RHS(N) = +-1. This is not done
*        in BSOLVE and will hopefully give us a better estimate because
*        any ill-conditioning of the original matrix is transfered to U
*        and not to L. U(N, N) is an approximation to sigma_min(LU).
*
         CALL SCOPY( N-1, RHS, 1, XP, 1 )
         XP( N ) = RHS( N ) + ONE
         RHS( N ) = RHS( N ) - ONE
         SPLUS = ZERO
         SMINU = ZERO
         DO 30 I = N, 1, -1
            TEMP = ONE / Z( I, I )
            XP( I ) = XP( I )*TEMP
            RHS( I ) = RHS( I )*TEMP
            DO 20 K = I + 1, N
               XP( I ) = XP( I ) - XP( K )*( Z( I, K )*TEMP )
               RHS( I ) = RHS( I ) - RHS( K )*( Z( I, K )*TEMP )
   20       CONTINUE
            SPLUS = SPLUS + ABS( XP( I ) )
            SMINU = SMINU + ABS( RHS( I ) )
   30    CONTINUE
         IF( SPLUS.GT.SMINU )
     $      CALL SCOPY( N, XP, 1, RHS, 1 )
*
*        Apply the permutations JPIV to the computed solution (RHS)
*
         CALL SLASWP( 1, RHS, LDZ, 1, N-1, JPIV, -1 )
*
*        Compute the sum of squares
*
         CALL SLASSQ( N, RHS, 1, RDSCAL, RDSUM )
*
      ELSE
*
*        IJOB = 2, Compute approximate nullvector XM of Z
*
         CALL SGECON( 'I', N, Z, LDZ, ONE, TEMP, WORK, IWORK, INFO )
         CALL SCOPY( N, WORK( N+1 ), 1, XM, 1 )
*
*        Compute RHS
*
         CALL SLASWP( 1, XM, LDZ, 1, N-1, IPIV, -1 )
         TEMP = ONE / SQRT( SDOT( N, XM, 1, XM, 1 ) )
         CALL SSCAL( N, TEMP, XM, 1 )
         CALL SCOPY( N, XM, 1, XP, 1 )
         CALL SAXPY( N, ONE, RHS, 1, XP, 1 )
         CALL SAXPY( N, -ONE, XM, 1, RHS, 1 )
         CALL SGESC2( N, Z, LDZ, RHS, IPIV, JPIV, TEMP )
         CALL SGESC2( N, Z, LDZ, XP, IPIV, JPIV, TEMP )
         IF( SASUM( N, XP, 1 ).GT.SASUM( N, RHS, 1 ) )
     $      CALL SCOPY( N, XP, 1, RHS, 1 )
*
*        Compute the sum of squares
*
         CALL SLASSQ( N, RHS, 1, RDSCAL, RDSUM )
*
      END IF
*
      RETURN
*
*     End of SLATDF
*
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C                Copyright (C)  1995                                   C
C        University Corporation for Atmospheric Research               C
C                All Rights Reserved                                   C
C                                                                      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C      File:           tm03f.f
C
C      Author:         Bob Lackman (converted by Ed Stautler)
C          National Center for Atmospheric Research
C          PO 3000, Boulder, Colorado
C
C      Date:           Fri Jan 06 18:31:18 MDT 1995
C
C      Description:    Demonstrates the TickMark Object
C                      with reversed and log y axis.
C
      external NhlFAppClass
      external NhlFTickMarkClass
      external NhlFCairoWindowWorkstationClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass

      real level(10)
      data level / 1000, 850, 700, 500, 400, 300, 250, 200, 150, 100 / 
C
C Define label strings for EXPLICIT mode tick mark placement
C
      character*10 labels(7)
      data labels /'90:S:o:N:S', '60:S:o:N:S', '30:S:o:N:S', 'EQ', 
     $     '30:S:o:N:N', '60:S:o:N:N', '90:S:o:N:N' /
C
C Specify data locations for above labels
C
      real labellocs(7)
      data labellocs / -90.0, -60.0, -30.0, 0.0, 30.0, 60.0, 90.0 /
        
      integer appid, wid, pid
      integer rlist, ierr

      character*7  wks_type
C
C Default is to create an X workstation.
C
      wks_type = "x11"
C
C Initialize the high level utility library
C
      call NhlFInitialize

C
C Create an application context. Set the app dir to the current
C directory so the application looks for a resource file in the
C working directory. In this example the resource file supplies the
C plot title only.
C
      call NhlFRLCreate(rlist,'SETRL')
      call NhlFRLClear(rlist)
      call NhlFRLSetstring(rlist,'appUsrDir','./',ierr)
      call NhlFRLSetstring(rlist,'appDefaultParent','True',ierr)
      call NhlFCreate(appid,'tm03',NhlFAppClass,0,rlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation object.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkMetaName','./tm03f.ncgm',ierr)
         call NhlFCreate(wid,'tm03Work',NhlFNcgmWorkstationClass,0,
     $        rlist,ierr)
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an XWorkstation object.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPause','True',ierr)
         call NhlFCreate(wid,'tm03Work',
     +        NhlFCairoWindowWorkstationClass,0,
     $        rlist,ierr)
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PostScript workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPSFileName','./tm03f.ps',ierr)
         call NhlFCreate(wid,'tm03Work',NhlFPSWorkstationClass,0,
     $        rlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPDFFileName','./tm03f.pdf',ierr)
         call NhlFCreate(wid,'tm03Work',NhlFPDFWorkstationClass,0,
     $        rlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF object.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetstring(rlist,'wkFileName','./tm03f',ierr)
         call NhlFCreate(wid,'tm03Work',
     $        NhlFCairoPSPDFWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG object.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetstring(rlist,'wkFileName','./tm03f',ierr)
         call NhlFCreate(wid,'tm03Work',
     $        NhlFCairoImageWorkstationClass,0,rlist,ierr)
      endif
C
C Specify the viewport extent of the object.
C
      call NhlFRLClear(rlist)

      call NhlFRLSetfloat(rlist,'vpYF',.8,ierr)
      call NhlFRLSetfloat(rlist,'vpWidthF',.6,ierr)
      call NhlFRLSetfloat(rlist,'vpHeightF',.6,ierr)
      call NhlFRLSetfloat(rlist,'tmYLDataTopF',100.0,ierr)
      call NhlFRLSetfloat(rlist,'tmYLDataBottomF',1000.0,ierr)
      call NhlFRLSetfloat(rlist,'tmXBDataRightF',90.0,ierr)
      call NhlFRLSetfloat(rlist,'tmXBDataLeftF',-90.0,ierr)
      call NhlFRLSetstring(rlist,'tmYLStyle','Irregular',ierr)
      call NhlFRLSetstring(rlist,'tmXBMode','Explicit',ierr)
      call NhlFRLSetstring(rlist,'tmXBMinorOn','False',ierr)
      call NhlFRLSetfloatarray(rlist,'tmXBValues',labellocs,
     $     7,ierr)

C
C Array 'level' contains original grid point data locations in Y
C direction. Providing the grid points to the TickMark object as the
C control points for the IRREGULAR style transformation, means that
C these points will be evenly spaced along the Y axis. Since this is
C how CONPACK thinks the points are spaced, the tick marks will
C correctly correspond with the  data coordinates. See the HLU User's
C Guide for a complete discussion of IRREGULAR style transformations.
C
      call NhlFRLSetstringarray(rlist,'tmXBLabels',labels,
     $     7,ierr)
      call NhlFRLSetfloatarray(rlist,'tmYLIrregularPoints',level,
     $     10,ierr)
      call NhlFCreate(pid,'TickMarks',NhlFTickMarkClass,wid,
     $     rlist,ierr)

      call NhlFDraw(pid,ierr)
      call NhlFFrame(wid,ierr)
      call NhlFDestroy(pid,ierr)
      call NhlFDestroy(wid,ierr)
      call NhlFDestroy(appid,ierr)
      call NhlFClose

      stop
      end

C
C $Id: srfgk.f,v 1.5 2008-07-27 00:17:26 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE SRFGK (X,Y,Z,M,MX,NX,NY,S,STEREO)
C
      DIMENSION       X(NX)      ,Y(NY)      ,Z(MX,NY)   ,M(2,NX,NY) ,
     1                S(6)
      DIMENSION       MXS(2)     ,MXF(2)     ,MXJ(2)     ,MYS(2)     ,
     1                MYF(2)     ,MYJ(2)
      COMMON /SRFBLK/ LIMU(1024) ,LIML(1024) ,CL(41)     ,NCL        ,
     1                LL         ,FACT       ,IROT       ,NDRZ       ,
     2                NUPPER     ,NRSWT      ,BIGD       ,UMIN       ,
     3                UMAX       ,VMIN       ,VMAX       ,RZERO      ,
     4                IOFFP      ,NSPVAL     ,SPVAL      ,BIGEST
      COMMON /PWRZ1S/ XXMIN      ,XXMAX      ,YYMIN      ,YYMAX      ,
     1                ZZMIN      ,ZZMAX      ,DELCRT     ,EYEX       ,
     2                EYEY       ,EYEZ
      COMMON /SRFIP1/ IFR        ,ISTP       ,IROTS      ,IDRX       ,
     1                IDRY       ,IDRZ       ,IUPPER     ,ISKIRT     ,
     2                NCLA       ,THETA      ,HSKIRT     ,CHI        ,
     3                CLO        ,CINC       ,ISPVAL
      DATA JF,IF,LY,LX,ICNST/1,1,2,2,0/
      CALL Q8QST4 ('GRAPHX','SRFACE','SRFGK','VERSION 01')
      BIGEST = R1MACH(2)
      MMXX = MX
      NNXX = NX
      NNYY = NY
      STER = STEREO
      NXP1 = NNXX+1
      NYP1 = NNYY+1
      NLA = NCLA
      NSPVAL = ISPVAL
      NDRZ = IDRZ
      IF (IDRZ .NE. 0)
     1    CALL CLSET (Z,MMXX,NNXX,NNYY,CHI,CLO,CINC,NLA,40,CL,NCL,
     2                ICNST,IOFFP,SPVAL,BIGEST)
      IF (IDRZ .NE. 0) NDRZ = 1-ICNST
      STHETA = SIN(STER*THETA)
      CTHETA = COS(STER*THETA)
      RX = S(1)-S(4)
      RY = S(2)-S(5)
      RZ = S(3)-S(6)
      D1 = SQRT(RX*RX+RY*RY+RZ*RZ)
      D2 = SQRT(RX*RX+RY*RY)
      DX = 0.
      DY = 0.
      IF (STEREO .EQ. 0.) GO TO  20
      D1 = D1*STEREO*THETA
      IF (D2 .GT. 0.) GO TO  10
      DX = D1
      GO TO  20
   10 AGL = ATAN2(RX,-RY)
      DX = D1*COS(AGL)
      DY = D1*SIN(AGL)
   20 IROT = IROTS
      NPIC = 1
      IF (STER .NE. 0.) NPIC = 2
      FACT = 1.
      IF (NRSWT .NE. 0) FACT = RZERO/D1
      IF (ISTP.EQ.0 .AND. STER.NE.0.) IROT = 1
      DO 570 IPIC=1,NPIC
         NUPPER = IUPPER
         IF (IFR .LT. 0) CALL FRAME
C
C SET UP MAPPING FROM FLOATING POINT 3-SPACE TO CRT SPACE.
C
         SIGN1 = IPIC*2-3
         EYEX = S(1)+SIGN1*DX
         POIX = S(4)+SIGN1*DX
         EYEY = S(2)+SIGN1*DY
         POIY = S(5)+SIGN1*DY
         EYEZ = S(3)
         POIZ = S(6)
         LL = 0
         XEYE = EYEX
         YEYE = EYEY
         ZEYE = EYEZ
         CALL TRN32S (POIX,POIY,POIZ,XEYE,YEYE,ZEYE,0)
         LL = IPIC+2*ISTP+3
         IF (STER .EQ. 0.) LL = 1
         IF (NRSWT .NE. 0) GO TO 100
         XXMIN = X(1)
         XXMAX = X(NNXX)
         YYMIN = Y(1)
         YYMAX = Y(NNYY)
         UMIN = BIGEST
         VMIN = BIGEST
         ZZMIN = BIGEST
         UMAX = -UMIN
         VMAX = -VMIN
         ZZMAX = -ZZMIN
         DO  40 J=1,NNYY
            DO  30 I=1,NNXX
               ZZ = Z(I,J)
               IF (IOFFP.EQ.1 .AND. ZZ.EQ.SPVAL) GO TO  30
               ZZMAX = MAX(ZZMAX,ZZ)
               ZZMIN = MIN(ZZMIN,ZZ)
               CALL TRN32S (X(I),Y(J),Z(I,J),UT,VT,DUMMY,1)
               UMAX = MAX(UMAX,UT)
               UMIN = MIN(UMIN,UT)
               VMAX = MAX(VMAX,VT)
               VMIN = MIN(VMIN,VT)
   30       CONTINUE
   40    CONTINUE
         IF (ISKIRT .NE. 1) GO TO  70
         NXSTP = NNXX-1
         NYSTP = NNYY-1
         DO  60 J=1,NNYY,NYSTP
            DO  50 I=1,NNXX,NXSTP
               CALL TRN32S (X(I),Y(J),HSKIRT,UT,VT,DUMMY,1)
               UMAX = MAX(UMAX,UT)
               UMIN = MIN(UMIN,UT)
               VMAX = MAX(VMAX,VT)
               VMIN = MIN(VMIN,VT)
   50       CONTINUE
   60    CONTINUE
   70    CONTINUE
         WIDTH = UMAX-UMIN
         HIGHT = VMAX-VMIN
         DIF = .5*(WIDTH-HIGHT)
         IF (DIF)  80,100, 90
   80    UMIN = UMIN+DIF
         UMAX = UMAX-DIF
         GO TO 100
   90    VMIN = VMIN-DIF
         VMAX = VMAX+DIF
  100    XEYE = EYEX
         YEYE = EYEY
         ZEYE = EYEZ
         CALL TRN32S (POIX,POIY,POIZ,XEYE,YEYE,ZEYE,0)
         DO 120 J=1,NNYY
            DO 110 I=1,NNXX
               CALL TRN32S (X(I),Y(J),Z(I,J),UT,VT,DUMMY,1)
               M(1,I,J) = UT
               M(2,I,J) = VT
  110       CONTINUE
  120    CONTINUE
C
C INITIALIZE UPPER AND LOWER VISIBILITY ARRAYS
C
         DO 130 K=1,1024
            LIMU(K) = 0
            LIML(K) = 1024
  130    CONTINUE
C
C FIND ORDER TO DRAW LINES
C
         NXPASS = 1
         IF (S(1) .GE. X(NNXX)) GO TO 160
         IF (S(1) .LE. X(1)) GO TO 170
         DO 140 I=2,NNXX
            LX = I
            IF (S(1) .LE. X(I)) GO TO 150
  140    CONTINUE
  150    MXS(1) = LX-1
         MXJ(1) = -1
         MXF(1) = 1
         MXS(2) = LX
         MXJ(2) = 1
         MXF(2) = NNXX
         NXPASS = 2
         GO TO 180
  160    MXS(1) = NNXX
         MXJ(1) = -1
         MXF(1) = 1
         GO TO 180
  170    MXS(1) = 1
         MXJ(1) = 1
         MXF(1) = NNXX
  180    NYPASS = 1
         IF (S(2) .GE. Y(NNYY)) GO TO 210
         IF (S(2) .LE. Y(1)) GO TO 220
         DO 190 J=2,NNYY
            LY = J
            IF (S(2) .LE. Y(J)) GO TO 200
  190    CONTINUE
  200    MYS(1) = LY-1
         MYJ(1) = -1
         MYF(1) = 1
         MYS(2) = LY
         MYJ(2) = 1
         MYF(2) = NNYY
         NYPASS = 2
         GO TO 230
  210    MYS(1) = NNYY
         MYJ(1) = -1
         MYF(1) = 1
         GO TO 230
  220    MYS(1) = 1
         MYJ(1) = 1
         MYF(1) = NNYY
C
C PUT ON SKIRT ON FRONT SIDE IF WANTED
C
  230    IF (NXPASS.EQ.2 .AND. NYPASS.EQ.2) GO TO 490
         IF (ISKIRT .EQ. 0) GO TO 290
         IN = MXS(1)
         IF = MXF(1)
         JN = MYS(1)
         JF = MYF(1)
         IF (NYPASS .NE. 1) GO TO 260
         CALL TRN32S (X(1),Y(JN),HSKIRT,UX1,VX1,DUMMY,1)
         CALL TRN32S (X(NNXX),Y(JN),HSKIRT,UX2,VX2,DUMMY,1)
         QU = (UX2-UX1)/(X(NNXX)-X(1))
         QV = (VX2-VX1)/(X(NNXX)-X(1))
         YNOW = Y(JN)
         DO 240 I=1,NNXX
            CALL TRN32S (X(I),YNOW,HSKIRT,RU,RV,DUMMY,1)
            CALL DRAWS (INT(RU),INT(RV),M(1,I,JN),M(2,I,JN),1,1)
  240    CONTINUE
         CALL DRAWS (INT(UX1),INT(VX1),INT(UX2),INT(VX2),1,1)
         IF (IDRY .NE. 0) GO TO 260
         DO 250 I=2,NNXX
            CALL DRAWS (M(1,I-1,JN),M(2,I-1,JN),M(1,I,JN),M(2,I,JN),1,1)
  250    CONTINUE
  260    IF (NXPASS .NE. 1) GO TO 290
         CALL TRN32S (X(IN),Y(1),HSKIRT,UY1,VY1,DUMMY,1)
         CALL TRN32S (X(IN),Y(NNYY),HSKIRT,UY2,VY2,DUMMY,1)
         QU = (UY2-UY1)/(Y(NNYY)-Y(1))
         QV = (VY2-VY1)/(Y(NNYY)-Y(1))
         XNOW = X(IN)
         DO 270 J=1,NNYY
            CALL TRN32S (XNOW,Y(J),HSKIRT,RU,RV,DUMMY,1)
            CALL DRAWS (INT(RU),INT(RV),M(1,IN,J),M(2,IN,J),1,1)
  270    CONTINUE
         CALL DRAWS (INT(UY1),INT(VY1),INT(UY2),INT(VY2),1,1)
         IF (IDRX .NE. 0) GO TO 290
         DO 280 J=2,NNYY
            CALL DRAWS (M(1,IN,J-1),M(2,IN,J-1),M(1,IN,J),M(2,IN,J),1,1)
  280    CONTINUE
C
C PICK PROPER ALGORITHM
C
  290    LI = MXJ(1)
         MI = MXS(1)-LI
         NI = ABS(MI-MXF(1))
         LJ = MYJ(1)
         MJ = MYS(1)-LJ
         NJ = ABS(MJ-MYF(1))
C
C IF NXPASS IS 1, PUT THE I LOOP OUTERMOST.  OTHERWISE, PUT THE J LOOP
C OUTERMOST.
C
         IF (NXPASS.EQ.2) GO TO 360
         IF (ISKIRT.NE.0 .OR. NYPASS.NE.1) GO TO 310
         I = MXS(1)
         DO 300 J=2,NNYY
            CALL DRAWS (M(1,I,J-1),M(2,I,J-1),M(1,I,J),M(2,I,J),0,1)
  300    CONTINUE
  310    DO 350 II=1,NNXX
            I = MI+II*LI
            IPLI = I+LI
            IF (NYPASS .EQ. 1) GO TO 320
            K = MYS(1)
            L = MYS(2)
            IF (IDRX .NE. 0)
     1          CALL DRAWS (M(1,I,K),M(2,I,K),M(1,I,L),M(2,I,L),1,1)
            IF (NDRZ.NE.0 .AND. II.NE.NI)
     1          CALL CTCELL (Z,MMXX,NNXX,NNYY,M,MIN(I,I+LI),K)
  320       DO 340 JPASS=1,NYPASS
               LJ = MYJ(JPASS)
               MJ = MYS(JPASS)-LJ
               NJ = ABS(MJ-MYF(JPASS))
               DO 330 JJ=1,NJ
                  J = MJ+JJ*LJ
                  JPLJ = J+LJ
                  IF (IDRX.NE.0 .AND. JJ.NE.NJ)
     1                CALL DRAWS (M(1,I,J),M(2,I,J),M(1,I,JPLJ),
     2                            M(2,I,JPLJ),1,1)
                  IF (I.NE.MXF(1) .AND. IDRY.NE.0)
     1                CALL DRAWS (M(1,IPLI,J),M(2,IPLI,J),M(1,I,J),
     2                            M(2,I,J),1,1)
                  IF (NDRZ.NE.0 .AND. JJ.NE.NJ .AND. II.NE.NNXX)
     1                CALL CTCELL (Z,MMXX,NNXX,NNYY,M,MIN(I,I+LI),
     2                             MIN(J,J+LJ))
  330          CONTINUE
  340       CONTINUE
  350    CONTINUE
         GO TO 430
  360    IF (ISKIRT.NE.0 .OR. NXPASS.NE.1) GO TO 380
         J = MYS(1)
         DO 370 I=2,NNXX
            CALL DRAWS (M(1,I-1,J),M(2,I-1,J),M(1,I,J),M(2,I,J),0,1)
  370    CONTINUE
  380    DO 420 JJ=1,NNYY
            J = MJ+JJ*LJ
            JPLJ = J+LJ
            IF (NXPASS .EQ. 1) GO TO 390
            K = MXS(1)
            L = MXS(2)
            IF (IDRY .NE. 0)
     1          CALL DRAWS (M(1,K,J),M(2,K,J),M(1,L,J),M(2,L,J),1,1)
            IF (NDRZ.NE.0 .AND. JJ.NE.NJ)
     1          CALL CTCELL (Z,MMXX,NNXX,NNYY,M,K,MIN(J,J+LJ))
  390       DO 410 IPASS=1,NXPASS
               LI = MXJ(IPASS)
               MI = MXS(IPASS)-LI
               NI = ABS(MI-MXF(IPASS))
               DO 400 II=1,NI
                  I = MI+II*LI
                  IPLI = I+LI
                  IF (IDRY.NE.0 .AND. II.NE.NI)
     1                CALL DRAWS (M(1,I,J),M(2,I,J),M(1,IPLI,J),
     2                            M(2,IPLI,J),1,1)
                  IF (J.NE.MYF(1) .AND. IDRX.NE.0)
     1                CALL DRAWS (M(1,I,JPLJ),M(2,I,JPLJ),M(1,I,J),
     2                            M(2,I,J),1,1)
                  IF (NDRZ.NE.0 .AND. II.NE.NI .AND. JJ.NE.NNYY)
     1                CALL CTCELL (Z,MMXX,NNXX,NNYY,M,MIN(I,I+LI),
     2                             MIN(J,J+LJ))
  400          CONTINUE
  410       CONTINUE
  420    CONTINUE
  430    IF (ISKIRT .EQ. 0) GO TO 520
C
C FIX UP IF SKIRT IS USED WITH LINES ONE WAY.
C
         IF (IDRX .NE. 0) GO TO 460
         DO 450 IPASS=1,NXPASS
            IF (NXPASS .EQ. 2) IF = 1+(IPASS-1)*(NNXX-1)
            DO 440 J=2,NNYY
               CALL DRAWS (M(1,IF,J-1),M(2,IF,J-1),M(1,IF,J),M(2,IF,J),
     1                     1,0)
  440       CONTINUE
  450    CONTINUE
  460    IF (IDRY .NE. 0) GO TO 520
         DO 480 JPASS=1,NYPASS
            IF (NYPASS .EQ. 2) JF = 1+(JPASS-1)*(NNYY-1)
            DO 470 I=2,NNXX
               CALL DRAWS (M(1,I-1,JF),M(2,I-1,JF),M(1,I,JF),M(2,I,JF),
     1                     1,0)
  470       CONTINUE
  480    CONTINUE
         GO TO 520
C
C ALL VISIBLE IF VIEWED FROM DIRECTLY ABOVE OR BELOW.
C
  490    IF (NUPPER.GT.0 .AND. S(3).LT.S(6)) GO TO 520
         IF (NUPPER.LT.0 .AND. S(3).GT.S(6)) GO TO 520
         NUPPER = 1
         IF (S(3) .LT. S(6)) NUPPER = -1
         DO 510 I=1,NNXX
            DO 500 J=1,NNYY
               IF (IDRX.NE.0 .AND. J.NE.NNYY)
     1             CALL DRAWS (M(1,I,J),M(2,I,J),M(1,I,J+1),M(2,I,J+1),
     2                         1,0)
               IF (IDRY.NE.0 .AND. I.NE.NNXX)
     1             CALL DRAWS (M(1,I,J),M(2,I,J),M(1,I+1,J),M(2,I+1,J),
     2                         1,0)
               IF (IDRZ.NE.0 .AND. I.NE.NNXX .AND. J.NE.NNYY)
     1             CALL CTCELL (Z,MMXX,NNXX,NNYY,M,I,J)
  500       CONTINUE
  510    CONTINUE
  520    IF (STER .EQ. 0.) GO TO 560
         IF (ISTP) 540,530,550
  530    CALL FRAME
  540    CALL FRAME
         GO TO 570
  550    IF (IPIC .NE. 2) GO TO 570
  560    IF (IFR .GT. 0) CALL FRAME
  570 CONTINUE
      RETURN
      END

      DOUBLE PRECISION FUNCTION DLANGT( NORM, N, DL, D, DU )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     February 29, 1992
*
*     .. Scalar Arguments ..
      CHARACTER          NORM
      INTEGER            N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   D( * ), DL( * ), DU( * )
*     ..
*
*  Purpose
*  =======
*
*  DLANGT  returns the value of the one norm,  or the Frobenius norm, or
*  the  infinity norm,  or the  element of  largest absolute value  of a
*  real tridiagonal matrix A.
*
*  Description
*  ===========
*
*  DLANGT returns the value
*
*     DLANGT = ( max(abs(A(i,j))), NORM = 'M' or 'm'
*              (
*              ( norm1(A),         NORM = '1', 'O' or 'o'
*              (
*              ( normI(A),         NORM = 'I' or 'i'
*              (
*              ( normF(A),         NORM = 'F', 'f', 'E' or 'e'
*
*  where  norm1  denotes the  one norm of a matrix (maximum column sum),
*  normI  denotes the  infinity norm  of a matrix  (maximum row sum) and
*  normF  denotes the  Frobenius norm of a matrix (square root of sum of
*  squares).  Note that  max(abs(A(i,j)))  is not a  matrix norm.
*
*  Arguments
*  =========
*
*  NORM    (input) CHARACTER*1
*          Specifies the value to be returned in DLANGT as described
*          above.
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.  When N = 0, DLANGT is
*          set to zero.
*
*  DL      (input) DOUBLE PRECISION array, dimension (N-1)
*          The (n-1) sub-diagonal elements of A.
*
*  D       (input) DOUBLE PRECISION array, dimension (N)
*          The diagonal elements of A.
*
*  DU      (input) DOUBLE PRECISION array, dimension (N-1)
*          The (n-1) super-diagonal elements of A.
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ONE, ZERO
      PARAMETER          ( ONE = 1.0D+0, ZERO = 0.0D+0 )
*     ..
*     .. Local Scalars ..
      INTEGER            I
      DOUBLE PRECISION   ANORM, SCALE, SUM
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           DLASSQ
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, MAX, SQRT
*     ..
*     .. Executable Statements ..
*
      IF( N.LE.0 ) THEN
         ANORM = ZERO
      ELSE IF( LSAME( NORM, 'M' ) ) THEN
*
*        Find max(abs(A(i,j))).
*
         ANORM = ABS( D( N ) )
         DO 10 I = 1, N - 1
            ANORM = MAX( ANORM, ABS( DL( I ) ) )
            ANORM = MAX( ANORM, ABS( D( I ) ) )
            ANORM = MAX( ANORM, ABS( DU( I ) ) )
   10    CONTINUE
      ELSE IF( LSAME( NORM, 'O' ) .OR. NORM.EQ.'1' ) THEN
*
*        Find norm1(A).
*
         IF( N.EQ.1 ) THEN
            ANORM = ABS( D( 1 ) )
         ELSE
            ANORM = MAX( ABS( D( 1 ) )+ABS( DL( 1 ) ),
     $              ABS( D( N ) )+ABS( DU( N-1 ) ) )
            DO 20 I = 2, N - 1
               ANORM = MAX( ANORM, ABS( D( I ) )+ABS( DL( I ) )+
     $                 ABS( DU( I-1 ) ) )
   20       CONTINUE
         END IF
      ELSE IF( LSAME( NORM, 'I' ) ) THEN
*
*        Find normI(A).
*
         IF( N.EQ.1 ) THEN
            ANORM = ABS( D( 1 ) )
         ELSE
            ANORM = MAX( ABS( D( 1 ) )+ABS( DU( 1 ) ),
     $              ABS( D( N ) )+ABS( DL( N-1 ) ) )
            DO 30 I = 2, N - 1
               ANORM = MAX( ANORM, ABS( D( I ) )+ABS( DU( I ) )+
     $                 ABS( DL( I-1 ) ) )
   30       CONTINUE
         END IF
      ELSE IF( ( LSAME( NORM, 'F' ) ) .OR. ( LSAME( NORM, 'E' ) ) ) THEN
*
*        Find normF(A).
*
         SCALE = ZERO
         SUM = ONE
         CALL DLASSQ( N, D, 1, SCALE, SUM )
         IF( N.GT.1 ) THEN
            CALL DLASSQ( N-1, DL, 1, SCALE, SUM )
            CALL DLASSQ( N-1, DU, 1, SCALE, SUM )
         END IF
         ANORM = SCALE*SQRT( SUM )
      END IF
*
      DLANGT = ANORM
      RETURN
*
*     End of DLANGT
*
      END

C
C $Id: mapset.f,v 1.21 2008-09-18 00:42:16 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MAPSET (ARG1,ARG2,ARG3,ARG4,ARG5)
        CHARACTER*(*) ARG1
        REAL          ARG2(2),ARG3(2),ARG4(2),ARG5(2)
        DOUBLE PRECISION DRG2(2),DRG3(2),DRG4(2),DRG5(2)
        DRG2(1)=DBLE(ARG2(1))
        DRG2(2)=DBLE(ARG2(2))
        DRG3(1)=DBLE(ARG3(1))
        DRG3(2)=DBLE(ARG3(2))
        DRG4(1)=DBLE(ARG4(1))
        DRG4(2)=DBLE(ARG4(2))
        DRG5(1)=DBLE(ARG5(1))
        DRG5(2)=DBLE(ARG5(2))
        CALL MDPSET (ARG1,DRG2,DRG3,DRG4,DRG5)
        IF (ICFELL('MAPSET',2).NE.0) RETURN
        RETURN
      END

c ----------------------------------------------------------------------
      SUBROUTINE DVIBETA(P,X,NLEV,XMSG,LINLOG,PSFC,XSFC,PBOT,PTOP,
     +                   PLVCRT,VINT,IER)
      IMPLICIT NONE
c
c NCL: vint = vibeta (p,x,linlog,psfc,pbot,ptop)
c NCL:        plvcrt = p(nlev)  do internally
c NCL:        xsfc   = x(1)     do internally
c
c vertical integral using ket/as:
c .   "diagnostic studies using global analyses"

c .   the approach here is somewhat crude 'n lude.
c .   i did it to preserve a one-to-one correspondence
c .   between subscripts in the above paper and the
c .   program below.

c .   also, this is *far* more complicated then is
c .   generally needed. It was wriiten to handle
c .   real raob data which have missing values in
c .   the middle of a sounding

c nomenclature:
c .   p      - pressure levels
c .   x      - quantity to be integrated
c .   nlev   - number of levels
c .   xmsg   - missing data code
c .   linlog - linear (=1) or log (=2) interpolation
c .   psfc   - surface pressure
c .   xsfc   - value of quantity to be integrated at the surface
c .   pbot   - lower limit of integration
c .   ptop   - upper limit of integration
c .   plvcrt - minimum pressure level which sounding must
c .            reach for integration to proceed (plvcrt.le.ptop)
c .   vint   - result
c .   ier    - error code

      INTEGER NLEV,LINLOG,IER
      DOUBLE PRECISION P(NLEV),X(NLEV),PSFC,XSFC,PBOT,PTOP,PLVCRT,XMSG,
     +                 VINT

c local vectors and variables

      INTEGER KLVL,NL1,NL,NLL,NLMAX,NLTOP,NLSAV,NL2,NLX
      DOUBLE PRECISION ZERO,PZERO,XZERO,SLOPE,PA,PC,PSFCX
      LOGICAL VDBG,PFLAG

      PARAMETER (KLVL=300)
      DOUBLE PRECISION PP(KLVL),XX(KLVL),PI(0:KLVL),XI(0:KLVL),
     +                 BETA(0:KLVL),DELP(0:KLVL)

      DATA ZERO/0.D0/
      DATA PZERO/0.D0/
      DATA XZERO/0.D0/

c error checking

      IER = 0
      IF (NLEV.LT.3) IER = IER + 1
C make klvl larger
      IF (KLVL.LT.2*NLEV) IER = IER + 10
      IF (PSFC.EQ.XMSG) IER = IER + 100
C
C Dennis wanted this to be commented out. See email exchange
C on November 14, 2003.
C
C      IF (PLVCRT.LT.PTOP) IER = IER + 1000
      IF (PTOP.GE.PBOT) IER = IER + 10000

      IF (IER.NE.0) THEN
          VINT = XMSG
          RETURN
      END IF

c collapse the sounding to eliminate msg data
c .   this is for raobs which have data missing in the
c .   middle of a sounding

C total number of levels with data
      NLL = 0
C last lvl with data
      NLX = 0
      PFLAG = .false.
C initilize to msg code
      CALL DINITVC(PP,KLVL,XMSG,IER)
C =0. means not included in integral
      CALL DINITVC(XX,KLVL,ZERO,IER)
      DO NL = 1,NLEV
          IF (P(NL).NE.XMSG .AND. X(NL).NE.XMSG .AND.
     +        P(NL).LT.PSFC) THEN
              NLX = NL
              NLL = NLL + 1
              PP(NLL) = P(NL)
              XX(NLL) = X(NL)
              IF (AINT(PP(NLL)).EQ.AINT(PTOP)) PFLAG = .true.
          END IF
      END DO
C no. levels with data above sfc
      NLMAX = NLL

c make sure there are at least several levels.

      IF (NLMAX.LE.3) THEN
          IER = -999
          VINT = XMSG
          RETURN
      END IF

c explicitly fill the top levels with zeros

      IF (NLMAX.LT.NLEV) THEN
          DO NL = NLX + 1,NLEV
              NLL = NLL + 1
              PP(NLL+1) = P(NL)
C contribute nothing to the integral
              XX(NLL+1) = 0.0D0
          END DO
      END IF

c explicitly add a ptop  level if neccessary. [remember the daily
c .   raob data may not have all levels.]
c .   Generally, this if block is not executed.

      IF (PP(NLMAX).GT.PTOP) THEN
C add level at ptop
          NLMAX = NLMAX + 1
C assume p=0, x=0 is next level above.
          PP(NLMAX) = PTOP
          IF (LINLOG.EQ.1) THEN
              SLOPE = (XX(NLMAX-1)-XZERO)/ (PP(NLMAX-1)-PZERO)
              XX(NLMAX) = XZERO + (PP(NLMAX)-PZERO)*SLOPE
          ELSE IF (LINLOG.EQ.2) THEN
              SLOPE = XX(NLMAX-1)/DLOG(PP(NLMAX-1))
              XX(NLMAX) = XZERO + DLOG(PP(NLMAX))*SLOPE
          END IF

      ELSE IF (.NOT.PFLAG) THEN
C beta=temporary storage
          CALL DCOPYVC(PP(1),BETA(1),NLMAX,IER)
C delp=temporary storage
          CALL DCOPYVC(XX(1),DELP(1),NLMAX,IER)
C determine where
          DO NL = 1,NLMAX - 1
C ptop should be inserted
              IF (AINT(PP(NL)).GT.PTOP .AND.
     +            AINT(PP(NL+1)).LT.PTOP) THEN
C subscript location for ptop
                  NLTOP = NL + 1
                  NLSAV = NLTOP
                  GO TO 25
              END IF
          END DO
          IER  = 1000000
          VINT = XMSG
C C C     WRITE (*,FMT='(/,'' sub vibeta: problem: ier='',i9)')
          RETURN

   25     NL1 = NLTOP
          NL2 = NLTOP - 1
          IF (LINLOG.EQ.1) THEN
              SLOPE = (XX(NL2)-XX(NL1))/ (PP(NL2)-PP(NL1))
              XX(NLTOP) = XX(NL1) + (PTOP-PP(NL1))*SLOPE
          ELSE IF (LINLOG.EQ.2) THEN
              PA = DLOG(PP(NL2))
              PC = DLOG(PP(NL1))
              SLOPE = (XX(NL2)-XX(NL1))/ (PA-PC)
              XX(NLTOP) = XX(NL1) + (DLOG(PTOP)-PC)*SLOPE
          END IF

          PP(NLTOP) = PTOP

C push all levels up one subscript
          DO NL = NLSAV,NLMAX
              XX(NL+1) = DELP(NL)
              PP(NL+1) = BETA(NL)
          END DO
          NLMAX = NLMAX + 1
      END IF

c the pp and xx vectors now hold "good" data.
c .   pi and xi will be the vectors used by the integration routine.
c .   the levels associated with pi and xi correspond to
c .   the levels in fig 1 of trenberth (jc, 1991, p708)

      CALL DINITVC(PI(0), (KLVL+1),ZERO,IER)
      CALL DINITVC(XI(0), (KLVL+1),ZERO,IER)

      PI(0) = PBOT
      DO NL = 1,NLMAX - 1
C odd : levels with data
          PI(2*NL-1) = PP(NL)
C even: intermediate levels
          PI(2*NL) = (PP(NL)+PP(NL+1))*0.5D0
      END DO
      PI(2*NLMAX-1) = PP(NLMAX)
      PI(2*NLMAX) = (PP(NLMAX)+ZERO)*0.5D0

c determine the subscript of the pi vector which corresponds to ptop
c .   over ride the last two pi levels if (2*nlmax-1).ne.nltop

      NLTOP = 0
      DO NL = 1,2*NLMAX - 1
C will be odd level
          IF (AINT(PI(NL)).EQ.AINT(PTOP)) NLTOP = NL
      END DO
      IF (NLTOP.EQ.0 .OR. MOD(NLTOP,2).EQ.0) THEN
          WRITE (*,FMT='(/,'' sub viket: nltop problem='',i5)') NLTOP
          STOP
      END IF
      PI(2*NLTOP-1) = PTOP
      PI(2*NLTOP) = (PTOP+ZERO)*0.5D0

c interpolate "xi" at intermediate levels using
c .   linear (linlog=1) or log (linlog=2) interpolation.
c .   do not use the sfc pressure [pp(0)].

      IF (PSFC.NE.XMSG) THEN
          PSFCX = PSFC
      ELSE
          PSFCX = PP(1)
      END IF

c c c if (xsfc.ne.xmsg) then
c c c     xi(0) = xsfc
c c c else
c c c     xi(0) = xx(1)
c c c endif
      CALL DINT2P2(PP(1),XX(1),NLMAX,PI(1),XI(1),NLTOP,LINLOG,XMSG,IER)

c determine beta and delp
c .   odd levels correspond to actual raob data

      CALL DINITVC(DELP(0), (KLVL+1),ZERO,IER)
      CALL DINITVC(BETA(0), (KLVL+1),ZERO,IER)

      DO NL = 1,NLTOP
          DELP(NL) = PI(NL-1) - PI(NL+1)
      END DO

      DO NL = 1,NLTOP
          IF (PI(NL-1).GE.PSFCX .AND. PI(NL+1).LT.PSFCX) THEN
              BETA(NL) = (PSFCX-PI(NL+1))/ (PI(NL-1)-PI(NL+1))
          ELSE IF (PI(NL-1).GT.PTOP .AND. PI(NL+1).LT.PTOP) THEN
              BETA(NL) = (PI(NL-1)-PTOP)/ (PI(NL-1)-PI(NL+1))
          ELSE IF (PI(NL).LT.PBOT .AND. PI(NL).GE.PTOP) THEN
              BETA(NL) = 1.0D0
          END IF
      END DO

c calculate the integral (odd levels only)

      VINT = 0.0D0
      DO NL = 1,NLTOP,2
          VINT = VINT + BETA(NL)*XI(NL)*DELP(NL)
      END DO

c optional print

      VDBG = .false.
      IF (VDBG) THEN
          WRITE (*,FMT=
     +      '(/,'' sub vibeta: vint='',3i5,2(1x,f10.2),2f8.1,/)') NLMAX,
     +      2*NLMAX - 1,NLTOP,VINT,XSFC,PSFC,PSFCX
          WRITE (*,FMT='(3x,''nl'',8x,''pp'',8x,''xx from viket'')')
c c c     do nl=1,nlmax
c c c     if (pp(nl).ge.ptop) then
c c c         write (*,'(i5,1x,f9.3,1x,f9.6 )')
c c c*                  nl, pp(nl),xx(nl)
c c c     endif
c c c     enddo

          WRITE (*,FMT=
     +'(//,3x,''nl'',8x,''pi'',8x,''xi''
     +    ,6x,''delp'',6x,''beta from vibeta'')')
          DO NL = 0,NLTOP
c c c     if (pi(nl).ge.ptop) then
              WRITE (*,FMT='(i5,1x,f9.3,1x,f9.6,2(1x,f9.3) )') NL,
     +          PI(NL),XI(NL),DELP(NL),BETA(NL)
c c c     endif
          END DO
      END IF

      RETURN
      END
c ------------------------------------------------------
      SUBROUTINE DINT2P2(PIN,XIN,NPIN,POUT,XOUT,NPOUT,IFLAG,XMSG,IER)
      IMPLICIT NONE

c routine to interpolate from one set of pressure levels
c .   to another set  using linear or ln(p) interpolation

c CAUTION: THIS ROUTINE HAS NOT BEEN EXTENSIVELY TESTED

c nomenclature:

c .   pin    - input pressure levels. The pin should
c .            be in decending order (e.g., 1000,900,825,..)
c .            pin(1)>pin(2)>...>pin(npin)
c .   xin    - data at input pressure levels
c .   npin   - number of input pressure levels
c .   pout   - output pressure levels (input by user)
c .            decending order required.
c .   xout   - data at output pressure levels
c .   npout  - number of output pressure levels
c .   iflag  - if iflag=1 user linear interp in pressure
c .            if iflag=2 user linear interp in ln(pressure)
c .   xmsg   - missing data code. if none, set to some number
c .            which will not be encountered (e.g., 1.e+36)
c .   ier    - error code

C input types
      INTEGER NPIN,NPOUT,IFLAG,IER
      DOUBLE PRECISION PIN(NPIN),XIN(NPIN),XMSG,POUT(NPOUT),XOUT(NPOUT)

      INTEGER NPLVL,NP,NL,NIN,NLMAX
C local vector space
      PARAMETER (NPLVL=200)
      DOUBLE PRECISION P(NPLVL),X(NPLVL)
      DOUBLE PRECISION SLOPE,PA,PB,PC

c error check

      IER = 0
      IF (NPIN.LT.1 .OR. NPOUT.LT.1) IER = IER + 1
      IF (IFLAG.LT.1 .OR. IFLAG.GT.2) IER = IER + 10
C increase vector size
      IF (NPIN.GT.NPLVL) IER = IER + 100
      IF (IER.NE.0) THEN
          IF (NPOUT.GT.0) THEN
              DO NP = 1,NPOUT
                  XOUT(NP) = XMSG
              END DO
          END IF
          RETURN
      END IF

c eliminate levels with missing data. This can easily
c .   happen with observational data.

      NL = 0
      DO NIN = 1,NPIN
          IF (XIN(NIN).NE.XMSG .AND. PIN(NIN).NE.XMSG) THEN
              NL = NL + 1
              P(NL) = PIN(NIN)
              X(NL) = XIN(NIN)
          END IF
      END DO
      NLMAX = NL
      IF (NLMAX.EQ.0) THEN
C all missing data
          IER = IER + 1000
          RETURN
      END IF

c perform the interpolation
c                                                      ( p ,x)
c ------------------------- p(nl+1), x(nl+1)   example (200,5)
c .
c ------------------------- pout(np), xout(np)         (250,?)
c .
c ------------------------- p(nl)  , x(nl)             (300,10)

      DO NP = 1,NPOUT
          XOUT(NP) = XMSG
          DO NL = 1,NLMAX
              IF (POUT(NP).EQ.P(NL)) THEN
                  XOUT(NP) = X(NL)
              ELSE IF (NL.LT.NLMAX) THEN
                  IF (POUT(NP).LT.P(NL) .AND. POUT(NP).GT.P(NL+1)) THEN
                      IF (IFLAG.EQ.1) THEN
                          SLOPE = (X(NL)-X(NL+1))/ (P(NL)-P(NL+1))
                          XOUT(NP) = X(NL+1) + SLOPE* (POUT(NP)-P(NL+1))
                      ELSE
                          PA = DLOG(P(NL))
                          PB = DLOG(POUT(NP))
                          PC = DLOG(P(NL+1))
                          SLOPE = (X(NL)-X(NL+1))/ (PA-PC)
                          XOUT(NP) = X(NL+1) + SLOPE* (PB-PC)
                      END IF
                  END IF
              END IF
          END DO
      END DO

      RETURN
      END
c ------------------------------------------------
      SUBROUTINE DINITVC(X,NPTS,VALUE,IER)
      IMPLICIT NONE

c set all elements of a vector to a value

c arguments :
c .   x        - vector to be set to the value
c .   npts     - number of points to be set
c .   value    - value that each element of x is to be set to
c .   ier      - if (ier.ne.0) an error has occured

      INTEGER NPTS,IER
      DOUBLE PRECISION X(1:NPTS),VALUE

C local
      INTEGER N

      IER = 0
      IF (NPTS.LT.1) THEN
          IER = 1
          RETURN
      END IF

      DO N = 1,NPTS
          X(N) = VALUE
      END DO

      RETURN
      END
c -----------------------------------------------
      SUBROUTINE DCOPYVC(X,Y,NPTS,IER)
      IMPLICIT NONE
c establish a duplicate vector
c arguments :
c .   x        - input vector
c .   y        - output vector (same as x)
c .   npts     - number of points
c .   ier      - if (ier.ne.0) an error has occurred
      INTEGER NPTS,IER
      DOUBLE PRECISION X(1:NPTS),Y(1:NPTS)
      INTEGER N

      IER = 0
      IF (NPTS.LT.1) THEN
          IER = 1
          RETURN
      END IF

      DO N = 1,NPTS
          Y(N) = X(N)
      END DO
      RETURN
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C   FFTPACK 5.0
C   Copyright (C) 1995-2004, Scientific Computing Division,
C   University Corporation for Atmospheric Research
C   Licensed under the GNU General Public License (GPL)
C
C   Authors:  Paul N. Swarztrauber and Richard A. Valent
C
C   $Id: cmf2kb.f,v 1.2 2006-11-21 01:10:16 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      SUBROUTINE DCMF2KB(LOT,IDO,L1,NA,CC,IM1,IN1,CH,IM2,IN2,WA)
      DOUBLE PRECISION CHOLD1
      DOUBLE PRECISION CHOLD2
      DOUBLE PRECISION TR2
      DOUBLE PRECISION TI2
      DOUBLE PRECISION CC(2,IN1,L1,IDO,2),CH(2,IN2,L1,2,IDO),WA(IDO,1,2)
C
      M1D = (LOT-1)*IM1 + 1
      M2S = 1 - IM2
      IF (IDO.GT.1 .OR. NA.EQ.1) GO TO 102
      DO 101 K = 1,L1
          DO 101 M1 = 1,M1D,IM1
              CHOLD1 = CC(1,M1,K,1,1) + CC(1,M1,K,1,2)
              CC(1,M1,K,1,2) = CC(1,M1,K,1,1) - CC(1,M1,K,1,2)
              CC(1,M1,K,1,1) = CHOLD1
              CHOLD2 = CC(2,M1,K,1,1) + CC(2,M1,K,1,2)
              CC(2,M1,K,1,2) = CC(2,M1,K,1,1) - CC(2,M1,K,1,2)
              CC(2,M1,K,1,1) = CHOLD2
  101 CONTINUE
      RETURN
  102 DO 103 K = 1,L1
          M2 = M2S
          DO 103 M1 = 1,M1D,IM1
              M2 = M2 + IM2
              CH(1,M2,K,1,1) = CC(1,M1,K,1,1) + CC(1,M1,K,1,2)
              CH(1,M2,K,2,1) = CC(1,M1,K,1,1) - CC(1,M1,K,1,2)
              CH(2,M2,K,1,1) = CC(2,M1,K,1,1) + CC(2,M1,K,1,2)
              CH(2,M2,K,2,1) = CC(2,M1,K,1,1) - CC(2,M1,K,1,2)
  103 CONTINUE
      IF (IDO.EQ.1) RETURN
      DO 105 I = 2,IDO
          DO 104 K = 1,L1
              M2 = M2S
              DO 104 M1 = 1,M1D,IM1
                  M2 = M2 + IM2
                  CH(1,M2,K,1,I) = CC(1,M1,K,I,1) + CC(1,M1,K,I,2)
                  TR2 = CC(1,M1,K,I,1) - CC(1,M1,K,I,2)
                  CH(2,M2,K,1,I) = CC(2,M1,K,I,1) + CC(2,M1,K,I,2)
                  TI2 = CC(2,M1,K,I,1) - CC(2,M1,K,I,2)
                  CH(2,M2,K,2,I) = WA(I,1,1)*TI2 + WA(I,1,2)*TR2
                  CH(1,M2,K,2,I) = WA(I,1,1)*TR2 - WA(I,1,2)*TI2
  104     CONTINUE
  105 CONTINUE
      RETURN
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C   FFTPACK 5.0
C   Copyright (C) 1995-2004, Scientific Computing Division,
C   University Corporation for Atmospheric Research
C   Licensed under the GNU General Public License (GPL)
C
C   Authors:  Paul N. Swarztrauber and Richard A. Valent
C
C   $Id: cosqmf.f,v 1.2 2006-11-21 01:10:17 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      SUBROUTINE DCOSQMF(LOT,JUMP,N,INC,X,LENX,WSAVE,LENSAV,WORK,
     +                   LENWRK,IER)
      DOUBLE PRECISION SSQRT2
      DOUBLE PRECISION TSQX
      INTEGER LOT,JUMP,N,INC,LENX,LENSAV,LENWRK,IER
      DOUBLE PRECISION X(INC,*),WSAVE(LENSAV),WORK(LENWRK)
      LOGICAL DXERCON
C
      IER = 0
C
      IF (LENX.LT. (LOT-1)*JUMP+INC* (N-1)+1) THEN
          IER = 1
          CALL DXERFFT('COSQMF',6)
          GO TO 300
      ELSE IF (LENSAV.LT.2*N+INT(LOG(DBLE(N)))+4) THEN
          IER = 2
          CALL DXERFFT('COSQMF',8)
          GO TO 300
      ELSE IF (LENWRK.LT.LOT*N) THEN
          IER = 3
          CALL DXERFFT('COSQMF',10)
          GO TO 300
      ELSE IF (.NOT.DXERCON(INC,JUMP,N,LOT)) THEN
          IER = 4
          CALL DXERFFT('COSQMF',-1)
          GO TO 300
      END IF
C
      LJ = (LOT-1)*JUMP + 1
      IF (N-2) 102,101,103
  101 SSQRT2 = 1.D0/SQRT(2.D0)
      DO 201 M = 1,LJ,JUMP
          TSQX = SSQRT2*X(M,2)
          X(M,2) = .5D0*X(M,1) - TSQX
          X(M,1) = .5D0*X(M,1) + TSQX
  201 CONTINUE
  102 RETURN
  103 CALL DMCSQF1(LOT,JUMP,N,INC,X,WSAVE,WORK,IER1)
      IF (IER1.NE.0) THEN
          IER = 20
          CALL DXERFFT('COSQMF',-5)
      END IF
C
  300 CONTINUE
      RETURN
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                       C
C                Copyright (C)  1995                                    C
C        University Corporation for Atmospheric Research                C
C                All Rights Reserved                                    C
C                                                                       C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C   File:         basic06f.f
C
C   Author:       Fred Clare
C                 National Center for Atmospheric Research
C                 PO 3000, Boulder, Colorado
C
C
C   Date:         Wed May 24 12:54:47 MDT 1995
C
C   Description:  This Fortran program demonstrates how to position 
C                 objects on an output device and how to change 
C                 their sizes.  A simple color table is also defined 
C                 and used for changing the color of a curve in an 
C                 XyPlot.  The script begins with two procedures - 
C                 one for drawing plot objects and one for drawing 
C                 text objects.
C
      program basic06
      implicit none

      external NhlFAppClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFCairoWindowWorkstationClass
      external NhlFXyPlotClass
      external NhlFCoordArraysClass
      external NhlFTickMarkClass
      external NhlFTextItemClass

      integer appid,rlist
      integer xwork_id,text_id,box_id,data_id
      integer dataspec
      CHARACTER*7  wks_type
      integer i,ierr

      character*5 text
      data text /'Box  '/

      real xdra(9),ydra(9)
      real xpos,ypos

      data xdra / 0.0, 0.1, 0.5, 0.9, 1.0, 0.9, 0.5, 0.1, 0.0 /
      data ydra / 0.5, 0.9, 1.0, 0.9, 0.5, 0.1, 0.0, 0.1, 0.5 /
C
C Define a simple color map (index 0 defines the background color).
C
      real cmap(3,4)
      data cmap / 1.0, 1.0, 1.0,
     1      0.0, 0.0, 1.0,
     2      0.0, 1.0, 0.0,
     3      1.0, 0.0, 0.0 /

      integer dims(2) 
      data dims / 3,4 /
C
C Define the workstation type
C
      wks_type = "x11"
C
C Initialize the high level utility library and create application.
C
      call NhlFInitialize
      call NhlFRLCreate(rlist,'SETRL')

      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'basic06',NhlFappClass,0,rlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create a meta file workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkMetaName',
     1         './basic06f.ncgm',ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',
     1         cmap,2,dims,ierr)
         call NhlFCreate(xwork_id,'simple',
     1         NhlFncgmWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then

C
C Create an X workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPause','True',ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',
     1         cmap,2,dims,ierr)
         call NhlFCreate(xwork_id,'simple',
     1         NhlFCairoWindowWorkstationClass,
     1         0,rlist,ierr)
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PostScript workstation.
C
        call NhlFRLClear(rlist)

        call NhlFRLSetstring(rlist,'wkPSFileName','./basic06f.ps',ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',
     1         cmap,2,dims,ierr)

        call NhlFCreate(xwork_id,'simple',
     1        NhlFPSWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
        call NhlFRLClear(rlist)

        call NhlFRLSetstring(rlist,'wkPDFFileName','./basic06f.pdf',
     1        ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',
     1         cmap,2,dims,ierr)

        call NhlFCreate(xwork_id,'simple',
     1        NhlFPDFWorkstationClass,0,rlist,ierr)
      endif
      if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     &    wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFileName',
     &        './basic06f',ierr)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',
     1         cmap,2,dims,ierr)
         call NhlFCreate(xwork_id,'simple',
     &        NhlFCairoPSPDFWorkstationClass,0,rlist,ierr)
      endif
      if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFileName',
     &        './basic06f',ierr)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',
     1         cmap,2,dims,ierr)
         call NhlFCreate(xwork_id,'simple',
     &        NhlFCairoImageWorkstationClass,0,rlist,ierr)
      endif
C
C Create data object for an XyPlot
C
      call NhlFRLClear(rlist)
      call NhlFRLSetFloatArray(rlist,'caXArray',xdra,
     1      9,ierr)
      call NhlFRLSetFloatArray(rlist,'caYArray',ydra,
     1      9,ierr)
      call NhlFCreate(data_id,'xyData',NhlFcoordArraysClass,
     1      0,rlist,ierr)
C
C Create a simple XyPlot object with no labels or borders.  The
C parent for this object is xwork_id, hence it will be sent to
C the workstation identified by xwork_id when the draw procedure
C is invoked on it.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'tmXBBorderOn','False',ierr)
      call NhlFRLSetString(rlist,'tmXTBorderOn','False',ierr)
      call NhlFRLSetString(rlist,'tmYLBorderOn','False',ierr)
      call NhlFRLSetString(rlist,'tmYRBorderOn','False',ierr)
      call NhlFRLSetString(rlist,'tmXBOn','False',ierr)
      call NhlFRLSetString(rlist,'tmXTOn','False',ierr)
      call NhlFRLSetString(rlist,'tmYLOn','False',ierr)
      call NhlFRLSetString(rlist,'tmYROn','False',ierr)
      call NhlFRLSetFloat(rlist,'vpXF',0.0,ierr)
      call NhlFRLSetFloat(rlist,'vpYF',1.0,ierr)
      call NhlFRLSetFloat(rlist,'vpWidthF',1.0,ierr)
      call NhlFRLSetFloat(rlist,'vpHeightF',1.0,ierr)
      call NhlFCreate(box_id,'Box',NhlFxyPlotClass,xwork_id,
     1    rlist,ierr)
C
C Create a TextItem object.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetFloat(rlist,'txPosXF',0.5,ierr)
      call NhlFRLSetFloat(rlist,'txPosYF',0.5,ierr)
      call NhlFRLSetInteger(rlist,'txFont',26,ierr)
      call NhlFCreate(text_id,'Text',NhlFtextItemClass,xwork_id,
     1      rlist,ierr)
C
C Add the data identified by data_id to the XyPlot.
C
      call NhlFAddData(box_id,'xyCoordData',data_id,dataspec)
C
C Draw three labeled boxes at different sizes and in different positions
C and with different colors.
C
      do 10 i=1,3
         xpos = -0.05*i*i + 0.5*i - 0.20
         ypos = 1.0-xpos
         text(5:5) = char(ichar('1')+i-1)
C
C Specify a text string and its color.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'txString',text,ierr)
         call NhlFRLSetInteger(rlist,'txFontColor',4-i,ierr)
         call NhlFSetValues(text_id,rlist,ierr)
C
C Set the XyPlot curve color.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'xyMonoLineColor','True',ierr)
         call NhlFRLSetInteger(rlist,'xyLineColor',i,ierr)
         call NhlFSetValues(dataspec,rlist,ierr)
C
C Draw box and text.
C
         call draw_plot(box_id, xpos, ypos, 0.36-0.09*(i-1),ierr)
         call draw_text(text_id, xpos, ypos, 0.08-0.02*(i-1),ierr)
 10   continue

      call NhlFFrame(xwork_id,ierr)

      call NhlFDestroy(xwork_id,ierr)
      call NhlFClose

      stop
      end

      subroutine draw_plot(id,x,y,scale,ierr)
C
C This procedure takes the plot object with identifier 'id' and 
C draws it centered at coordinate (x,y) and scaled by 'scale'.  
C The original plot object is returned unchanged.
C
      integer id
      real x,y,scale

      integer rlist,grlist,ierr
      real x_ref,y_ref,width_ref,height_ref

      call NhlFRLCreate(rlist,'SETRL')
      call NhlFRLCreate(grlist,'GETRL')

      call NhlFRLClear(grlist)
      call NhlFRLGetFloat(grlist,'vpXF',x_ref,ierr)
      call NhlFRLGetFloat(grlist,'vpYF',y_ref,ierr)
      call NhlFRLGetFloat(grlist,'vpWidthF',width_ref,ierr)
      call NhlFRLGetFloat(grlist,'vpHeightF',height_ref,ierr)
      call NhlFGetValues(id,grlist,ierr)

      call NhlFRLClear(rlist)
      call NhlFRLSetFloat(rlist,'vpXF',x - 0.5*width_ref*scale,ierr)
      call NhlFRLSetFloat(rlist,'vpYF',y + 0.5*height_ref*scale,ierr)
      call NhlFRLSetFloat(rlist,'vpWidthF',width_ref*scale,ierr)
      call NhlFRLSetFloat(rlist,'vpHeightF',height_ref*scale,ierr)
      call NhlFSetValues(id,rlist,ierr)

      call NhlFDraw(id,ierr)

      call NhlFRLClear(rlist)
      call NhlFRLSetFloat(rlist,'vpXF',x_ref,ierr)
      call NhlFRLSetFloat(rlist,'vpYF',y_ref,ierr)
      call NhlFRLSetFloat(rlist,'vpWidthF',width_ref,ierr)
      call NhlFRLSetFloat(rlist,'vpHeightF',height_ref,ierr)
      call NhlFSetValues(id,rlist,ierr)

      return
      end

      subroutine draw_text(id,x,y,height,ierr)
C
C This procedure takes the text string in the object identified by 'id'
C and draws it centered at coordinate (x,y) with a height of 'height'.
C
      integer id
      real x,y,height

      integer rlist,grlist,ierr
      real xpos,ypos,fheight

      call NhlFRLCreate(rlist,'SETRL')
      call NhlFRLCreate(grlist,'GETRL')

      call NhlFRLClear(grlist)
      call NhlFRLGetFloat(grlist,'txPosXF',xpos,ierr)
      call NhlFRLGetFloat(grlist,'txPosYF',ypos,ierr)
      call NhlFRLGetFloat(grlist,'txFontHeightF',fheight,ierr)
      call NhlFGetValues(id,grlist,ierr)

      call NhlFRLClear(rlist)
      call NhlFRLSetFloat(rlist,'txPosXF',x,ierr)
      call NhlFRLSetFloat(rlist,'txPosYF',y,ierr)
      call NhlFRLSetFloat(rlist,'txFontHeightF',height,ierr)
      call NhlFSetValues(id,rlist,ierr)

      call NhlFDraw(id,ierr)

      call NhlFRLClear(rlist)
      call NhlFRLSetFloat(rlist,'txPosXF',xpos,ierr)
      call NhlFRLSetFloat(rlist,'txPosYF',ypos,ierr)
      call NhlFRLSetFloat(rlist,'txFontHeightF',fheight,ierr)
      call NhlFSetValues(id,rlist,ierr)

      return 
      end

      PROGRAM CSSEX01
C
C  Example of Delaunay triangulation and Voronoi diagram
C  on the surface of a sphere.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C  Input dataset on the globe (latitudes and longitudes in degrees).
C  These data points do not cover the globe, but rather are confined
C  to the nothern hemisphere and are enclosed by a boundary.
C
      PARAMETER (NMAX=7)
      DIMENSION RLAT(NMAX),RLON(NMAX)
      DATA RLAT/  70.,  70., 70., 85., 60., 60., 65./
      DATA RLON/-160., -70.,  0., 20., 50., 80.,140./
C
C  Dimension the arrays for holding the points for drawing 
C  circular arcs.
C
      PARAMETER (NARC=50)
      DIMENSION ARCLAT(NARC),ARCLON(NARC)
      DIMENSION ARCUAR(NARC),ARCVAR(NARC)
C
C  Storage for the triangulation, work space, and Voronoi vertices.
C
      PARAMETER (NTMX=2*NMAX, NT6=6*NMAX, LWK=27*NMAX)
      INTEGER LTRI(3,NTMX), IWK(LWK), NV(NMAX)
C
C  Real workspace.
C
      DOUBLE PRECISION    RWK(13*NMAX)
C
C  Storage for circumcenters and circum radii.
C
      REAL    PLAT(NTMX),    PLON(NTMX),   RC(NTMX)
C
      N = NMAX
C
C  Create the triangulation, storing the vertices in LTRI.
C
      CALL CSSTRI (N,RLAT,RLON, NT,LTRI, IWK,RWK,IER)
C
C  Plot the Delaunay triangulation, the circumcircles, and
C  the Voronoi polygons on a sphere.
C
C  Open GKS.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C  Color table.
C
      CALL GSCR(IWKID,0,0.,0.,0.)
      CALL GSCR(IWKID,1,1.,1.,1.)
      CALL GSCR(IWKID,2,0.,1.,1.)
      CALL GSCR(IWKID,3,1.,1.,0.)
      CALL GSCR(IWKID,4,1.,0.,0.)
      CALL GSCR(IWKID,5,0.,1.,0.)
      CALL GSCR(IWKID,6,0.,.8,0.)
C
C Draw a map of the North Atlantic, as seen by a satellite.
C
      CALL GSPLCI(6)
      CALL MAPSTR ('SA',4.)
      CALL MAPPOS(0.175, 0.975, 0.025, 0.825)
      CALL SUPMAP (7,72.5,127.5,0.,0.,0.,0.,0.,1,-1000,5,0,IERR)
C
C  Get the circumcenters of the Delaunay triangles.
C
      CALL CSVORO(N,RLAT,RLON,1,1,IWK,RWK,NTMX,PLAT,PLON,RC,
     +            NCA,NUMV,NV,IER)
C
C  Plot the circumcircles whose circumcenters lie in one of
C  the Delaunay triangles composed of original data points
C  (exclude the pseudo points added to complete the
C  triangulation on the whole sphere).
C
      CALL GSLWSC(2.0)
      CALL GSPLCI(4)
      DO 940 I=5,10
C
        CALL NGGCOG(PLAT(I),PLON(I),RC(I),ARCLAT,ARCLON,NARC)
        CALL MAPIT(ARCLAT(1),ARCLON(1),0)
        DO 930 J=2,NARC-1
          CALL MAPIT(ARCLAT(J),ARCLON(J),1)
  930   CONTINUE
        CALL MAPIT(ARCLAT(NARC),ARCLON(NARC),1)
        CALL MAPIQ
  940 CONTINUE
C
C  Draw the Voronoi polygons.
C
      DO 150 I=1,N
C
C  Get the polygon containing the original data point
C  (X(I),Y(I),Z(I)).  
C
        CALL CSVORO(N,RLAT,RLON,I,0,IWK,RWK,NTMX,PLAT,PLON,RC,
     +              NCA,NUMV,NV,IER)
        DO 855 NN=2,NUMV
C
C  Get a polygonal segment.
C
          RLAT1 = PLAT(NV(NN-1))
          RLON1 = PLON(NV(NN-1))
          RLAT2 = PLAT(NV(NN))
          RLON2 = PLON(NV(NN))
C
C  Plot it.
C
          CALL GSPLCI(3)
          CALL MAPGCI(RLAT1,RLON1,RLAT2,RLON2,NARC,ARCLAT,ARCLON)
          CALL MAPIT(RLAT1,RLON1,0)
          DO 920 J=1,NARC
            CALL MAPIT(ARCLAT(J),ARCLON(J),1)
  920     CONTINUE
          CALL MAPIT(RLAT2,RLON2,1)
          CALL MAPIQ
  855   CONTINUE
  150 CONTINUE
C
C  Draw the Delaunay triangles.
C
      CALL GSPLCI(2)
      DO 130 NP=1,NT
        DO 140 NS=1,3
          CALL MAPGCI(RLAT(LTRI(NS,NP)),RLON(LTRI(NS,NP)),
     +                RLAT(LTRI(MOD(NS,3)+1,NP)),
     +                RLON(LTRI(MOD(NS,3)+1,NP)),
     +                NARC,ARCLAT,ARCLON)
          CALL MAPIT(RLAT(LTRI(NS,NP)),RLON(LTRI(NS,NP)),0)
          DO 120 I=1,NARC
            CALL MAPIT(ARCLAT(I),ARCLON(I),1)
  120     CONTINUE
          CALL MAPIT(RLAT(LTRI(MOD(NS,3)+1,NP)),
     +               RLON(LTRI(MOD(NS,3)+1,NP)),1)
  140   CONTINUE
  130 CONTINUE
      CALL MAPIQ
C
C  Mark the original data points.
C
      CALL GSFACI(3)
      DO 400 I=1,N
        CALL NGGCOG(RLAT(I),RLON(I),1.2,ARCLAT,ARCLON,NARC)
        DO 410 L=1,NARC
          CALL MAPTRN(ARCLAT(L),ARCLON(L),ARCUAR(L),ARCVAR(L))
  410   CONTINUE
        CALL GFA(NARC,ARCUAR,ARCVAR)
  400 CONTINUE
C
C  Mark the circumcenters.
C
      CALL GSFACI(5)
      DO 440 I=5,10
        CALL NGGCOG(PLAT(I),PLON(I),0.6,ARCLAT,ARCLON,NARC)
        DO 420 L=1,NARC
          CALL MAPTRN(ARCLAT(L),ARCLON(L),ARCUAR(L),ARCVAR(L))
  420   CONTINUE
        CALL GFA(NARC,ARCUAR,ARCVAR)
  440 CONTINUE
C
C  Put out a legend.
C
      CALL SET(0.0, 1.0, 0.0, 1.0, 0.0, 1.0, 0.0, 1.0, 1)
C
      CALL CSDRBX(0.02, 0.945, 0.12, 0.955, 2)
      CALL PCSETI('CC',1)
      CALL PLCHHQ(0.14, 0.95, ':F22:Delaunay triangles', 
     +            0.025, 0.0, -1.0)     
C
      CALL CSDRBX(0.02, 0.895, 0.12, 0.905, 3)
      CALL PLCHHQ(0.14, 0.90, ':F22:Voronoi polygons', 0.025, 0.0, -1.0)       
C
      CALL CSDRBX(0.02, 0.845, 0.12, 0.855, 4)
      CALL PLCHHQ(0.14, 0.85, ':F22:Circumcircles', 0.025, 0.0, -1.0)
C
      CALL FRAME
C
C  Close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END
      SUBROUTINE CSDRBX(XLL,YLL,XUR,YUR,ICNDX)
C
C  Draw a filled rectangle with the specified corner points 
C  using color index ICNDX.
C
      DIMENSION X(5),Y(5)
C
      CALL GQFACI(IER,ICOLD)
C
      X(1) = XLL
      Y(1) = YLL
      X(2) = XUR
      Y(2) = YLL
      X(3) = XUR
      Y(3) = YUR
      X(4) = XLL
      Y(4) = YUR
      X(5) = XLL
      Y(5) = YLL
C 
      CALL GSFACI(ICNDX)
      CALL GFA(5,X,Y)
      CALL GSFACI(ICOLD)
C
      RETURN
      END

C
C	$Id: gxopdf.f,v 1.4 2008-07-27 00:21:03 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GXOPDF
C
C  This routine sets the default operand sizes before any processing.
C
      include 'trpars.h'
C
C  SET THE DEFAULT OPERAND SIZES
C
      MOPLEN = MOPDLN
      MCICPR = MCIDPR
      MFLCPR = MFLDPR
      MIXCPR = MIXDPR
      MWHCPR = MWHDPR
      MENCPR = MENDPR
C
      RETURN
      END

C
C $Id: mdipar.f,v 1.3 2008-07-27 00:17:07 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      INTEGER FUNCTION MDIPAR (IAIN)
C
        INTEGER IAIN
C
        PARAMETER (MNAI=8000)
C
C The value of MDIPAR(IAIN) is the area identifier of the parent of the
C area whose area identifier is IAIN.  The parent of an an area is the
C area of which it is a part.  For example, the area named "Honshu" is
C a part of the area named "Japan", which is its parent.
C
        COMMON /MAPCMX/  IATY(MNAI),ISCI(MNAI),IPAR(MNAI)
        INTEGER          IATY,ISCI,IPAR
        SAVE   /MAPCMX/
C
        MDIPAR=0
C
        IF (IAIN.GE.1.AND.IAIN.LE.MNAI) THEN
          IF (IATY(IAIN).NE.0) THEN
            MDIPAR=IPAR(IAIN)
          END IF
        END IF
C
        RETURN
C
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C   FFTPACK 5.0
C   Copyright (C) 1995-2004, Scientific Computing Division,
C   University Corporation for Atmospheric Research
C   Licensed under the GNU General Public License (GPL)
C
C   Authors:  Paul N. Swarztrauber and Richard A. Valent
C
C   $Id: cmfm1f.f,v 1.2 2006-11-21 01:10:16 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      SUBROUTINE DCMFM1F(LOT,JUMP,N,INC,C,CH,WA,FNF,FAC)
      DOUBLE PRECISION FNF
      DOUBLE COMPLEX C(*)
      DOUBLE PRECISION CH(*),WA(*),FAC(*)
C
C FFTPACK 5.0 auxiliary routine
C
      NF = FNF
      NA = 0
      L1 = 1
      IW = 1
      DO 125 K1 = 1,NF
          IP = FAC(K1)
          L2 = IP*L1
          IDO = N/L2
          LID = L1*IDO
          NBR = 1 + NA + 2*MIN(IP-2,4)
          GO TO (52,62,53,63,54,64,55,65,56,66) NBR
   52     CALL DCMF2KF(LOT,IDO,L1,NA,C,JUMP,INC,CH,1,LOT,WA(IW))
          GO TO 120
   62     CALL DCMF2KF(LOT,IDO,L1,NA,CH,1,LOT,C,JUMP,INC,WA(IW))
          GO TO 120
   53     CALL DCMF3KF(LOT,IDO,L1,NA,C,JUMP,INC,CH,1,LOT,WA(IW))
          GO TO 120
   63     CALL DCMF3KF(LOT,IDO,L1,NA,CH,1,LOT,C,JUMP,INC,WA(IW))
          GO TO 120
   54     CALL DCMF4KF(LOT,IDO,L1,NA,C,JUMP,INC,CH,1,LOT,WA(IW))
          GO TO 120
   64     CALL DCMF4KF(LOT,IDO,L1,NA,CH,1,LOT,C,JUMP,INC,WA(IW))
          GO TO 120
   55     CALL DCMF5KF(LOT,IDO,L1,NA,C,JUMP,INC,CH,1,LOT,WA(IW))
          GO TO 120
   65     CALL DCMF5KF(LOT,IDO,L1,NA,CH,1,LOT,C,JUMP,INC,WA(IW))
          GO TO 120
   56     CALL DCMFGKF(LOT,IDO,IP,L1,LID,NA,C,C,JUMP,INC,CH,CH,1,LOT,
     +                WA(IW))
          GO TO 120
   66     CALL DCMFGKF(LOT,IDO,IP,L1,LID,NA,CH,CH,1,LOT,C,C,JUMP,INC,
     +                WA(IW))
  120     L1 = L2
          IW = IW + (IP-1)* (IDO+IDO)
          IF (IP.LE.5) NA = 1 - NA
  125 CONTINUE
      RETURN
      END

      SUBROUTINE ZGEGS( JOBVSL, JOBVSR, N, A, LDA, B, LDB, ALPHA, BETA,
     $                  VSL, LDVSL, VSR, LDVSR, WORK, LWORK, RWORK,
     $                  INFO )
*
*  -- LAPACK driver routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          JOBVSL, JOBVSR
      INTEGER            INFO, LDA, LDB, LDVSL, LDVSR, LWORK, N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   RWORK( * )
      COMPLEX*16         A( LDA, * ), ALPHA( * ), B( LDB, * ),
     $                   BETA( * ), VSL( LDVSL, * ), VSR( LDVSR, * ),
     $                   WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  This routine is deprecated and has been replaced by routine ZGGES.
*
*  ZGEGS computes for a pair of N-by-N complex nonsymmetric matrices A,
*  B:  the generalized eigenvalues (alpha, beta), the complex Schur
*  form (A, B), and optionally left and/or right Schur vectors
*  (VSL and VSR).
*
*  (If only the generalized eigenvalues are needed, use the driver ZGEGV
*  instead.)
*
*  A generalized eigenvalue for a pair of matrices (A,B) is, roughly
*  speaking, a scalar w or a ratio  alpha/beta = w, such that  A - w*B
*  is singular.  It is usually represented as the pair (alpha,beta),
*  as there is a reasonable interpretation for beta=0, and even for
*  both being zero.  A good beginning reference is the book, "Matrix
*  Computations", by G. Golub & C. van Loan (Johns Hopkins U. Press)
*
*  The (generalized) Schur form of a pair of matrices is the result of
*  multiplying both matrices on the left by one unitary matrix and
*  both on the right by another unitary matrix, these two unitary
*  matrices being chosen so as to bring the pair of matrices into
*  upper triangular form with the diagonal elements of B being
*  non-negative real numbers (this is also called complex Schur form.)
*
*  The left and right Schur vectors are the columns of VSL and VSR,
*  respectively, where VSL and VSR are the unitary matrices
*  which reduce A and B to Schur form:
*
*  Schur form of (A,B) = ( (VSL)**H A (VSR), (VSL)**H B (VSR) )
*
*  Arguments
*  =========
*
*  JOBVSL   (input) CHARACTER*1
*          = 'N':  do not compute the left Schur vectors;
*          = 'V':  compute the left Schur vectors.
*
*  JOBVSR   (input) CHARACTER*1
*          = 'N':  do not compute the right Schur vectors;
*          = 'V':  compute the right Schur vectors.
*
*  N       (input) INTEGER
*          The order of the matrices A, B, VSL, and VSR.  N >= 0.
*
*  A       (input/output) COMPLEX*16 array, dimension (LDA, N)
*          On entry, the first of the pair of matrices whose generalized
*          eigenvalues and (optionally) Schur vectors are to be
*          computed.
*          On exit, the generalized Schur form of A.
*
*  LDA     (input) INTEGER
*          The leading dimension of A.  LDA >= max(1,N).
*
*  B       (input/output) COMPLEX*16 array, dimension (LDB, N)
*          On entry, the second of the pair of matrices whose
*          generalized eigenvalues and (optionally) Schur vectors are
*          to be computed.
*          On exit, the generalized Schur form of B.
*
*  LDB     (input) INTEGER
*          The leading dimension of B.  LDB >= max(1,N).
*
*  ALPHA   (output) COMPLEX*16 array, dimension (N)
*  BETA    (output) COMPLEX*16 array, dimension (N)
*          On exit,  ALPHA(j)/BETA(j), j=1,...,N, will be the
*          generalized eigenvalues.  ALPHA(j), j=1,...,N  and  BETA(j),
*          j=1,...,N  are the diagonals of the complex Schur form (A,B)
*          output by ZGEGS.  The  BETA(j) will be non-negative real.
*
*          Note: the quotients ALPHA(j)/BETA(j) may easily over- or
*          underflow, and BETA(j) may even be zero.  Thus, the user
*          should avoid naively computing the ratio alpha/beta.
*          However, ALPHA will be always less than and usually
*          comparable with norm(A) in magnitude, and BETA always less
*          than and usually comparable with norm(B).
*
*  VSL     (output) COMPLEX*16 array, dimension (LDVSL,N)
*          If JOBVSL = 'V', VSL will contain the left Schur vectors.
*          (See "Purpose", above.)
*          Not referenced if JOBVSL = 'N'.
*
*  LDVSL   (input) INTEGER
*          The leading dimension of the matrix VSL. LDVSL >= 1, and
*          if JOBVSL = 'V', LDVSL >= N.
*
*  VSR     (output) COMPLEX*16 array, dimension (LDVSR,N)
*          If JOBVSR = 'V', VSR will contain the right Schur vectors.
*          (See "Purpose", above.)
*          Not referenced if JOBVSR = 'N'.
*
*  LDVSR   (input) INTEGER
*          The leading dimension of the matrix VSR. LDVSR >= 1, and
*          if JOBVSR = 'V', LDVSR >= N.
*
*  WORK    (workspace/output) COMPLEX*16 array, dimension (LWORK)
*          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*
*  LWORK   (input) INTEGER
*          The dimension of the array WORK.  LWORK >= max(1,2*N).
*          For good performance, LWORK must generally be larger.
*          To compute the optimal value of LWORK, call ILAENV to get
*          blocksizes (for ZGEQRF, ZUNMQR, and CUNGQR.)  Then compute:
*          NB  -- MAX of the blocksizes for ZGEQRF, ZUNMQR, and CUNGQR;
*          the optimal LWORK is N*(NB+1).
*
*          If LWORK = -1, then a workspace query is assumed; the routine
*          only calculates the optimal size of the WORK array, returns
*          this value as the first entry of the WORK array, and no error
*          message related to LWORK is issued by XERBLA.
*
*  RWORK   (workspace) DOUBLE PRECISION array, dimension (3*N)
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value.
*          =1,...,N:
*                The QZ iteration failed.  (A,B) are not in Schur
*                form, but ALPHA(j) and BETA(j) should be correct for
*                j=INFO+1,...,N.
*          > N:  errors that usually indicate LAPACK problems:
*                =N+1: error return from ZGGBAL
*                =N+2: error return from ZGEQRF
*                =N+3: error return from ZUNMQR
*                =N+4: error return from ZUNGQR
*                =N+5: error return from ZGGHRD
*                =N+6: error return from ZHGEQZ (other than failed
*                                               iteration)
*                =N+7: error return from ZGGBAK (computing VSL)
*                =N+8: error return from ZGGBAK (computing VSR)
*                =N+9: error return from ZLASCL (various places)
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO, ONE
      PARAMETER          ( ZERO = 0.0D0, ONE = 1.0D0 )
      COMPLEX*16         CZERO, CONE
      PARAMETER          ( CZERO = ( 0.0D0, 0.0D0 ),
     $                   CONE = ( 1.0D0, 0.0D0 ) )
*     ..
*     .. Local Scalars ..
      LOGICAL            ILASCL, ILBSCL, ILVSL, ILVSR, LQUERY
      INTEGER            ICOLS, IHI, IINFO, IJOBVL, IJOBVR, ILEFT, ILO,
     $                   IRIGHT, IROWS, IRWORK, ITAU, IWORK, LOPT,
     $                   LWKMIN, LWKOPT, NB, NB1, NB2, NB3
      DOUBLE PRECISION   ANRM, ANRMTO, BIGNUM, BNRM, BNRMTO, EPS,
     $                   SAFMIN, SMLNUM
*     ..
*     .. External Subroutines ..
      EXTERNAL           XERBLA, ZGEQRF, ZGGBAK, ZGGBAL, ZGGHRD, ZHGEQZ,
     $                   ZLACPY, ZLASCL, ZLASET, ZUNGQR, ZUNMQR
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            ILAENV
      DOUBLE PRECISION   DLAMCH, ZLANGE
      EXTERNAL           LSAME, ILAENV, DLAMCH, ZLANGE
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          INT, MAX
*     ..
*     .. Executable Statements ..
*
*     Decode the input arguments
*
      IF( LSAME( JOBVSL, 'N' ) ) THEN
         IJOBVL = 1
         ILVSL = .FALSE.
      ELSE IF( LSAME( JOBVSL, 'V' ) ) THEN
         IJOBVL = 2
         ILVSL = .TRUE.
      ELSE
         IJOBVL = -1
         ILVSL = .FALSE.
      END IF
*
      IF( LSAME( JOBVSR, 'N' ) ) THEN
         IJOBVR = 1
         ILVSR = .FALSE.
      ELSE IF( LSAME( JOBVSR, 'V' ) ) THEN
         IJOBVR = 2
         ILVSR = .TRUE.
      ELSE
         IJOBVR = -1
         ILVSR = .FALSE.
      END IF
*
*     Test the input arguments
*
      LWKMIN = MAX( 2*N, 1 )
      LWKOPT = LWKMIN
      WORK( 1 ) = LWKOPT
      LQUERY = ( LWORK.EQ.-1 )
      INFO = 0
      IF( IJOBVL.LE.0 ) THEN
         INFO = -1
      ELSE IF( IJOBVR.LE.0 ) THEN
         INFO = -2
      ELSE IF( N.LT.0 ) THEN
         INFO = -3
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -5
      ELSE IF( LDB.LT.MAX( 1, N ) ) THEN
         INFO = -7
      ELSE IF( LDVSL.LT.1 .OR. ( ILVSL .AND. LDVSL.LT.N ) ) THEN
         INFO = -11
      ELSE IF( LDVSR.LT.1 .OR. ( ILVSR .AND. LDVSR.LT.N ) ) THEN
         INFO = -13
      ELSE IF( LWORK.LT.LWKMIN .AND. .NOT.LQUERY ) THEN
         INFO = -15
      END IF
*
      IF( INFO.EQ.0 ) THEN
         NB1 = ILAENV( 1, 'ZGEQRF', ' ', N, N, -1, -1 )
         NB2 = ILAENV( 1, 'ZUNMQR', ' ', N, N, N, -1 )
         NB3 = ILAENV( 1, 'ZUNGQR', ' ', N, N, N, -1 )
         NB = MAX( NB1, NB2, NB3 )
         LOPT = N*( NB+1 )
         WORK( 1 ) = LOPT
      END IF
*
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'ZGEGS ', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
*
*     Get machine constants
*
      EPS = DLAMCH( 'E' )*DLAMCH( 'B' )
      SAFMIN = DLAMCH( 'S' )
      SMLNUM = N*SAFMIN / EPS
      BIGNUM = ONE / SMLNUM
*
*     Scale A if max element outside range [SMLNUM,BIGNUM]
*
      ANRM = ZLANGE( 'M', N, N, A, LDA, RWORK )
      ILASCL = .FALSE.
      IF( ANRM.GT.ZERO .AND. ANRM.LT.SMLNUM ) THEN
         ANRMTO = SMLNUM
         ILASCL = .TRUE.
      ELSE IF( ANRM.GT.BIGNUM ) THEN
         ANRMTO = BIGNUM
         ILASCL = .TRUE.
      END IF
*
      IF( ILASCL ) THEN
         CALL ZLASCL( 'G', -1, -1, ANRM, ANRMTO, N, N, A, LDA, IINFO )
         IF( IINFO.NE.0 ) THEN
            INFO = N + 9
            RETURN
         END IF
      END IF
*
*     Scale B if max element outside range [SMLNUM,BIGNUM]
*
      BNRM = ZLANGE( 'M', N, N, B, LDB, RWORK )
      ILBSCL = .FALSE.
      IF( BNRM.GT.ZERO .AND. BNRM.LT.SMLNUM ) THEN
         BNRMTO = SMLNUM
         ILBSCL = .TRUE.
      ELSE IF( BNRM.GT.BIGNUM ) THEN
         BNRMTO = BIGNUM
         ILBSCL = .TRUE.
      END IF
*
      IF( ILBSCL ) THEN
         CALL ZLASCL( 'G', -1, -1, BNRM, BNRMTO, N, N, B, LDB, IINFO )
         IF( IINFO.NE.0 ) THEN
            INFO = N + 9
            RETURN
         END IF
      END IF
*
*     Permute the matrix to make it more nearly triangular
*
      ILEFT = 1
      IRIGHT = N + 1
      IRWORK = IRIGHT + N
      IWORK = 1
      CALL ZGGBAL( 'P', N, A, LDA, B, LDB, ILO, IHI, RWORK( ILEFT ),
     $             RWORK( IRIGHT ), RWORK( IRWORK ), IINFO )
      IF( IINFO.NE.0 ) THEN
         INFO = N + 1
         GO TO 10
      END IF
*
*     Reduce B to triangular form, and initialize VSL and/or VSR
*
      IROWS = IHI + 1 - ILO
      ICOLS = N + 1 - ILO
      ITAU = IWORK
      IWORK = ITAU + IROWS
      CALL ZGEQRF( IROWS, ICOLS, B( ILO, ILO ), LDB, WORK( ITAU ),
     $             WORK( IWORK ), LWORK+1-IWORK, IINFO )
      IF( IINFO.GE.0 )
     $   LWKOPT = MAX( LWKOPT, INT( WORK( IWORK ) )+IWORK-1 )
      IF( IINFO.NE.0 ) THEN
         INFO = N + 2
         GO TO 10
      END IF
*
      CALL ZUNMQR( 'L', 'C', IROWS, ICOLS, IROWS, B( ILO, ILO ), LDB,
     $             WORK( ITAU ), A( ILO, ILO ), LDA, WORK( IWORK ),
     $             LWORK+1-IWORK, IINFO )
      IF( IINFO.GE.0 )
     $   LWKOPT = MAX( LWKOPT, INT( WORK( IWORK ) )+IWORK-1 )
      IF( IINFO.NE.0 ) THEN
         INFO = N + 3
         GO TO 10
      END IF
*
      IF( ILVSL ) THEN
         CALL ZLASET( 'Full', N, N, CZERO, CONE, VSL, LDVSL )
         CALL ZLACPY( 'L', IROWS-1, IROWS-1, B( ILO+1, ILO ), LDB,
     $                VSL( ILO+1, ILO ), LDVSL )
         CALL ZUNGQR( IROWS, IROWS, IROWS, VSL( ILO, ILO ), LDVSL,
     $                WORK( ITAU ), WORK( IWORK ), LWORK+1-IWORK,
     $                IINFO )
         IF( IINFO.GE.0 )
     $      LWKOPT = MAX( LWKOPT, INT( WORK( IWORK ) )+IWORK-1 )
         IF( IINFO.NE.0 ) THEN
            INFO = N + 4
            GO TO 10
         END IF
      END IF
*
      IF( ILVSR )
     $   CALL ZLASET( 'Full', N, N, CZERO, CONE, VSR, LDVSR )
*
*     Reduce to generalized Hessenberg form
*
      CALL ZGGHRD( JOBVSL, JOBVSR, N, ILO, IHI, A, LDA, B, LDB, VSL,
     $             LDVSL, VSR, LDVSR, IINFO )
      IF( IINFO.NE.0 ) THEN
         INFO = N + 5
         GO TO 10
      END IF
*
*     Perform QZ algorithm, computing Schur vectors if desired
*
      IWORK = ITAU
      CALL ZHGEQZ( 'S', JOBVSL, JOBVSR, N, ILO, IHI, A, LDA, B, LDB,
     $             ALPHA, BETA, VSL, LDVSL, VSR, LDVSR, WORK( IWORK ),
     $             LWORK+1-IWORK, RWORK( IRWORK ), IINFO )
      IF( IINFO.GE.0 )
     $   LWKOPT = MAX( LWKOPT, INT( WORK( IWORK ) )+IWORK-1 )
      IF( IINFO.NE.0 ) THEN
         IF( IINFO.GT.0 .AND. IINFO.LE.N ) THEN
            INFO = IINFO
         ELSE IF( IINFO.GT.N .AND. IINFO.LE.2*N ) THEN
            INFO = IINFO - N
         ELSE
            INFO = N + 6
         END IF
         GO TO 10
      END IF
*
*     Apply permutation to VSL and VSR
*
      IF( ILVSL ) THEN
         CALL ZGGBAK( 'P', 'L', N, ILO, IHI, RWORK( ILEFT ),
     $                RWORK( IRIGHT ), N, VSL, LDVSL, IINFO )
         IF( IINFO.NE.0 ) THEN
            INFO = N + 7
            GO TO 10
         END IF
      END IF
      IF( ILVSR ) THEN
         CALL ZGGBAK( 'P', 'R', N, ILO, IHI, RWORK( ILEFT ),
     $                RWORK( IRIGHT ), N, VSR, LDVSR, IINFO )
         IF( IINFO.NE.0 ) THEN
            INFO = N + 8
            GO TO 10
         END IF
      END IF
*
*     Undo scaling
*
      IF( ILASCL ) THEN
         CALL ZLASCL( 'U', -1, -1, ANRMTO, ANRM, N, N, A, LDA, IINFO )
         IF( IINFO.NE.0 ) THEN
            INFO = N + 9
            RETURN
         END IF
         CALL ZLASCL( 'G', -1, -1, ANRMTO, ANRM, N, 1, ALPHA, N, IINFO )
         IF( IINFO.NE.0 ) THEN
            INFO = N + 9
            RETURN
         END IF
      END IF
*
      IF( ILBSCL ) THEN
         CALL ZLASCL( 'U', -1, -1, BNRMTO, BNRM, N, N, B, LDB, IINFO )
         IF( IINFO.NE.0 ) THEN
            INFO = N + 9
            RETURN
         END IF
         CALL ZLASCL( 'G', -1, -1, BNRMTO, BNRM, N, 1, BETA, N, IINFO )
         IF( IINFO.NE.0 ) THEN
            INFO = N + 9
            RETURN
         END IF
      END IF
*
   10 CONTINUE
      WORK( 1 ) = LWKOPT
*
      RETURN
*
*     End of ZGEGS
*
      END

c
c $Id: termsdp.f,v 1.3 2008-07-27 03:10:12 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
C NOTE: If you make any changes to this software, please remember to
C make the same changes to the corresponding single precision routine.
C
      SUBROUTINE TERMSDP(DIAG,SDIAG,SIGMA,DEL)
      DOUBLE PRECISION SIGDEL
      DOUBLE PRECISION SINHM
      DOUBLE PRECISION COSHM
      DOUBLE PRECISION DENOM
c
      DOUBLE PRECISION DIAG,SDIAG,SIGMA,DEL
c
c                                 coded by alan kaylor cline
c                           from fitpack -- january 26, 1987
c                        a curve and surface fitting package
c                      a product of pleasant valley software
c                  8603 altus cove, austin, texas 78759, usa
c
c this subroutine computes the diagonal and superdiagonal
c terms of the tridiagonal linear system associated with
c spline under tension interpolation.
c
c on input--
c
c   sigma contains the tension factor.
c
c and
c
c   del contains the step size.
c
c on output--
c
c                sigma*del*cosh(sigma*del) - sinh(sigma*del)
c   diag = del*--------------------------------------------.
c                     (sigma*del)**2 * sinh(sigma*del)
c
c                   sinh(sigma*del) - sigma*del
c   sdiag = del*----------------------------------.
c                (sigma*del)**2 * sinh(sigma*del)
c
c and
c
c   sigma and del are unaltered.
c
c this subroutine references package module snhcsh.
c
c-----------------------------------------------------------
c
      IF (SIGMA.NE.0.D0) GO TO 1
      DIAG = DEL/3.D0
      SDIAG = DEL/6.D0
      RETURN
    1 SIGDEL = SIGMA*DEL
      CALL SNHCSHDP(SINHM,COSHM,SIGDEL,0)
      DENOM = SIGMA*SIGDEL* (1.D0+SINHM)
      DIAG = (COSHM-SINHM)/DENOM
      SDIAG = SINHM/DENOM
      RETURN
      END

C
C	$Id: gwitm.f,v 1.5 2008-07-27 00:21:03 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GWITM (WKID,TYPE,LDR,DATREC)
C
C  WRITE ITEM TO GKSM
C
      INTEGER EWITM
      PARAMETER (EWITM=101)
C
      include 'gkscom.h'
C
      INTEGER WKID,TYPE,LDR
      CHARACTER*80 DATREC(LDR)
C
C  Check if GKS is in the proper state.
C
      CALL GZCKST(5,EWITM,IER)
      IF (IER .NE. 0) RETURN
C
C  Check if workstation ID is valid.
C
      CALL GZCKWK(20,EWITM,WKID,IDUM,IER)
      IF (IER .NE. 0) RETURN
C
C  Check if item type is valid (GKS interpretable items are illegal).
C
      IF (TYPE .LE. 100) THEN
        ERS = 1
        CALL GERHND(160,EWITM,ERF)
        ERS = 0
        RETURN
      ENDIF
C
C  Check if item length is valid.
C
      IF (LDR .LT. 1) THEN
        ERS = 1
        CALL GERHND(161,EWITM,ERF)
        ERS = 0
        RETURN
      ENDIF
C
C  Check if the workstation is currently active.
C
      CALL GZCKWK(30,EWITM,WKID,IDUM,IER)
      IF (IER .NE. 0) RETURN
C
C  Set function code and put out WKID, TYPE, LDR, and the data
C  record in STR.
C
C  Set the flag CUFLAG to indicate that the interface call should go
C  only to the specifically designated workstation.
C
      CUFLAG = WKID
      FCODE = 101
      CALL GZROI(0)
      IL1 = 3
      IL2 = 3
      ID(1) = WKID
      ID(2) = TYPE
      ID(3) = LDR
C
C  Send over the data record if there is one (recall that the
C  string length of STR is divisible by 80).
C
      IF (LDR .GE. 1) THEN
        IF (LDR .EQ. 1) THEN
          CONT = 0
          STRL1 = 80
          STRL2 = 80
          STR(1:80) = DATREC(1)
          CALL GZTOWK
          CUFLAG = -1
          IF (RERR .NE. 0) THEN
            ERS = 1
            CALL GERHND(RERR,EWITM,ERF)
            ERS = 0
            RETURN
          ENDIF
        ELSE
C
C  Send over the data record 80 characters at a time.
C
          CONT = 1
          STRL1 = 80*LDR
          STRL2 = 80
          LDRM1 = LDR-1
          DO 200 I=1,LDRM1
            IF (I .GT. 1) IL2 = 0
            STR(1:80) = DATREC(I)
            CALL GZTOWK
            CUFLAG = -1
            IF (RERR .NE. 0) THEN
              ERS = 1
              CALL GERHND(RERR,EWITM,ERF)
              ERS = 0
              RETURN
            ENDIF
  200     CONTINUE
          CONT = 0
          STR(1:80) = DATREC(LDR)
          CALL GZTOWK
          CUFLAG = -1
          IF (RERR .NE. 0) THEN
            ERS = 1
            CALL GERHND(RERR,EWITM,ERF)
            ERS = 0
            RETURN
          ENDIF
        ENDIF
      ELSE
        CALL GZTOWK
        CUFLAG = -1
        IF (RERR .NE. 0) THEN
          ERS = 1
          CALL GERHND(RERR,EWITM,ERF)
          ERS = 0
          RETURN
        ENDIF
      ENDIF
C
      RETURN
      END

      PROGRAM COLCON
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER (MREG=50,NREG=50)
      REAL ZREG(MREG,NREG)
C     
      EXTERNAL COLOR
C
C Get data array.
C
        CALL GENDAT(ZREG,MREG,MREG,NREG,15,13,13.,18.)
C
C Open GKS, and turn clipping off.
C
        CALL GOPKS (IERRF, ISZDM)
        CALL GOPWK (IWKID, LUNIT, IWTYPE)
        CALL GACWK (IWKID)
        CALL GSCLIP(0)
C
C Call Conpack color fill routine.
C
        CALL TCOLCON(ZREG,MREG,NREG,-15,COLOR,
     +       'CE',-90.,90.,-180.,180.,0.,0.,IWKID)
C
C Close frame and close GKS.
C
        CALL FRAME
        CALL GDAWK (IWKID)
        CALL GCLWK (IWKID)
        CALL GCLKS
C
        STOP
C
        END

      SUBROUTINE TCOLCON(ZREG,MREG,NREG,NCL,COLOR,
     +     PROJ,RLATMN,RLATMX,RLONMN,RLONMX,PLAT,PLON,IWKID)

      PARAMETER (LRWK=5000,LIWK=5000,LMAP=200000,NWRK=15000,NOGRPS=5)
      INTEGER MREG,NREG,IWRK(LIWK), LFIN(35)
      REAL ZREG(MREG,NREG),RWRK(LRWK), XWRK(NWRK), YWRK(NWRK)
      INTEGER MAP(LMAP),IAREA(NOGRPS),IGRP(NOGRPS)
      CHARACTER*4 PROJ
      CHARACTER*10 LBLS(35)

      EXTERNAL FILL
      EXTERNAL MASK
      EXTERNAL COLOR
C
C Set color fill to solid.
C
      CALL GSFAIS (1)
C
C Initialize Areas.
C
      CALL ARINAM(MAP, LMAP)
C
C Initialize Ezmap and add to area map.
C
      CALL MAPSTR ('GR',0.)
      CALL MAPSTC ('OU','CO')
      CALL MAPROJ(PROJ,PLAT,PLON,0.0)
      IF (PROJ.EQ.'SV') CALL MAPSTR ('SA',10.)
      CALL MAPSET('CO',RLATMN,RLONMN,RLATMX,RLONMX)
      CALL MAPINT
      CALL MAPBLA(MAP)
C
C Initialize Conpack and add to area map.
C
      CALL CPSETI('SET - DO-SET-CALL FLAG',0)
      CALL CPSETI('MAP - MAPPING FLAG',1)
      CALL CPSETR('ORV - OUT OF RANGE FLAG',1.E12)
      CALL CPSETR('XC1 - X COORDINATE AT INDEX 1',RLONMN)
      CALL CPSETR('XCM - X COORDINATE AT INDEX M',RLONMX)
      CALL CPSETR('YC1 - Y COORDINATE AT INDEX 1',RLATMN)
      CALL CPSETR('YCN - Y COORDINATE AT INDEX N',RLATMX)
      CALL CPSETI('LLP - LINE LABEL POSITIONING FLAG',0)
      CALL CPSETI('HLB - HIGH/LOW LABEL BOX FLAG',2)
      CALL CPSETI('HLC - HIGH/LOW LABEL COLOR INDEX',1)
      CALL CPRECT(ZREG, MREG, MREG, NREG, RWRK, LRWK, IWRK, LIWK)
      CALL CPCLAM(ZREG, RWRK, IWRK, MAP)
      CALL CPLBAM(ZREG, RWRK, IWRK, MAP)
C
C Choose a color for every contour level.
C
      CALL CPGETI('NCL',NCLL)
      CALL COLOR (NCLL+1,IWKID)
C
C Fill contours and areas over land.
C
      CALL ARSCAM(MAP, XWRK, YWRK, NWRK, IAREA, IGRP, NOGRPS, FILL)
C
C Draw continental outlines, labels, and masked contours.
C
      CALL MAPLOT
      CALL CPLBDR(ZREG,RWRK,IWRK)
      CALL CPCLDM(ZREG,RWRK,IWRK,MAP,MASK)
C
C Draw and fill a label bar.
C
      CALL GETSET(XMIN,XMAX,YMIN,YMAX,DUM1,DUM2,DUM3,DUM4,IDUM)
      YBOT = YMIN/3.0
      YTOP = YMIN - YMIN/3.0 
      CALL CPGETR('ZMN - Z DATA ARRAY DIMENSION N',ZMN)
      WRITE (LBLS(1), '(F8.3)') ZMN
      DO 10, I=1,NCLL
         LFIN(I)=I+2
         CALL CPSETI('PAI - PARAMETER ARRAY INDEX',I)
         CALL CPGETR('CLV - CONTOUR LEVEL VALUES',CLV)
         WRITE (LBLS(I+1), '(F8.3)') CLV
 10   CONTINUE
      LFIN(NCLL+1)=NCLL+3
      WRITE (LBLS(NCLL+2),'(A4)') 'LAND'
      LFIN(NCLL+2)=2
      CALL LBLBAR(0,XMIN,XMAX,YBOT,YTOP,NCLL+2,1.,.5,LFIN,1,LBLS,
     +     NCLL+2,1)
      
C
      RETURN
C
      END



      SUBROUTINE FILL (XWRK,YWRK,NWRK,IAREA,IGRP,NGRPS)
C
      DIMENSION XWRK(*),YWRK(*),IAREA(*),IGRP(*)

      IDMAP=-1
      IDCONT=-1

      DO 10, I=1,NGRPS
         IF (IGRP(I).EQ.1) IDMAP=IAREA(I)
         IF (IGRP(I).EQ.3) IDCONT=IAREA(I)
 10   CONTINUE
C
C If the area is defined by 2 or fewer points, return to ARSCAM.
C
      IF (NWRK .LE. 3) RETURN
C
C Check if the area is over the map 
C
      IF ((IDMAP .GT. 0) .AND. (IDCONT .GT. 0)) THEN
C
C If the area is over water, fill the contours with colors depending
C on their level.
C
         IF (MAPACI(IDMAP).EQ.1) THEN
            CALL GSFACI(IDCONT+2)
            CALL GFA(NWRK-1,XWRK,YWRK)
C
C If the area is over land, fill with gray.
C
         ELSE 
            CALL GSFACI(2)
            CALL GFA(NWRK-1,XWRK,YWRK)
         ENDIF
      ENDIF        
C
      RETURN
C
      END

      SUBROUTINE MASK(XWRK,YWRK,NWRK,IAREA,IGRP,NGRPS)
C
      INTEGER IAREA(NGRPS),IGRP(NGRPS)
      REAL XWRK(NWRK),YWRK(NWRK)
C
      IDMAP=-1
      IDCONT=-1
C
      DO 10, I=1,NGRPS
         IF (IGRP(I).EQ.1) IDMAP=IAREA(I)
         IF (IGRP(I).EQ.3) IDCONT=IAREA(I)
 10   CONTINUE
C
C If the line is defined by 1 or fewer points, return to CPCLDM
C
      IF (NWRK .LT. 2) RETURN
C
C Draw the line if the area is over the map, and not over a label, or
C over land.
C
      IF ((IDMAP.GT.0).AND.(IDCONT.GT.0).AND.(MAPACI(IDMAP).EQ.1))
     +     THEN
         CALL CURVE(XWRK,YWRK,NWRK)
      ENDIF
C
      RETURN
C
      END

      SUBROUTINE GENDAT (DATA,IDIM,M,N,MLOW,MHGH,DLOW,DHGH)
C
C This is a routine to generate test data for two-dimensional graphics
C routines.  Given an array "DATA", dimensioned "IDIM x 1", it fills
C the sub-array ((DATA(I,J),I=1,M),J=1,N) with a two-dimensional field
C of data having approximately "MLOW" lows and "MHGH" highs, a minimum
C value of exactly "DLOW" and a maximum value of exactly "DHGH".
C
C "MLOW" and "MHGH" are each forced to be greater than or equal to 1
C and less than or equal to 25.
C
C The function used is a sum of exponentials.
C
C This version has been modified to make the data more nearly simulate
C global data.  All values in the top row (which maps to the North Pole)
C are the same.  All values in the bottom row (which maps to the South
C Pole) are the same.  Each value in the last column of a row matches
C the value in the first column of the row.
C
      DIMENSION DATA(IDIM,1),CCNT(3,50)
C
      FOVM=9./REAL(M)
      FOVN=9./REAL(N)
C
      NLOW=MAX(1,MIN(25,MLOW))
      NHGH=MAX(1,MIN(25,MHGH))
      NCNT=NLOW+NHGH
C
      DO 101 K=1,NCNT
         CCNT(1,K)=1.+(REAL(M)-1.)*FRAN()
         CCNT(2,K)=1.+(REAL(N)-1.)*FRAN()
         IF (K.LE.NLOW) THEN
            CCNT(3,K)=-1.
         ELSE
            CCNT(3,K)=+1.
         END IF
 101  CONTINUE
C
      AABR=0.
      AATR=0.
C
      DO 104 I=1,M
         DO 103 J=1,N
            DATA(I,J)=.5*(DLOW+DHGH)
            DO 102 K=1,NCNT
               TEMP=-((FOVM*(REAL(I)-CCNT(1,K)))**2+
     +              (FOVN*(REAL(J)-CCNT(2,K)))**2)
               IF (TEMP.GE.-20.) DATA(I,J)=DATA(I,J)+
     +              .5*(DHGH-DLOW)*CCNT(3,K)*EXP(TEMP)
 102        CONTINUE
 103     CONTINUE
         AABR=AABR+DATA(I,1)
         AATR=AATR+DATA(I,N)
 104  CONTINUE
C
      AABR=AABR/REAL(M)
      AATR=AATR/REAL(M)
C
      DO 108 J=1,N
         IF (J.LE.N/5) THEN
            P=REAL(J-1)/REAL(N/5-1)
            DO 105 I=1,M/2
               Q=1.-MAX(0.,.5-.5*REAL(I-1)/REAL(M/5-1))
               DATL=DATA(    I,J)
               DATR=DATA(M+1-I,J)
               DATA(    I,J)=P*(Q*DATL+(1.-Q)*DATR)+(1.-P)*AABR
               DATA(M+1-I,J)=P*(Q*DATR+(1.-Q)*DATL)+(1.-P)*AABR
 105        CONTINUE
         ELSE IF (J.GE.N+1-N/5) THEN
            P=REAL(N-J)/REAL(N/5-1)
            DO 106 I=1,M/2
               Q=1.-MAX(0.,.5-.5*REAL(I-1)/REAL(M/5-1))
               DATL=DATA(    I,J)
               DATR=DATA(M+1-I,J)
               DATA(    I,J)=P*(Q*DATL+(1.-Q)*DATR)+(1.-P)*AATR
               DATA(M+1-I,J)=P*(Q*DATR+(1.-Q)*DATL)+(1.-P)*AATR
 106        CONTINUE
         ELSE
            DO 107 I=1,M/2
               Q=1.-MAX(0.,.5-.5*REAL(I-1)/REAL(M/5-1))
               DATL=DATA(    I,J)
               DATR=DATA(M+1-I,J)
               DATA(    I,J)=Q*DATL+(1.-Q)*DATR
               DATA(M+1-I,J)=Q*DATR+(1.-Q)*DATL
 107        CONTINUE
         END IF
 108  CONTINUE
C
      DMIN=+1.E36
      DMAX=-1.E36
C
      DO 110 J=1,N
         DO 109 I=1,M
            DMIN=MIN(DMIN,DATA(I,J))
            DMAX=MAX(DMAX,DATA(I,J))
 109     CONTINUE
 110  CONTINUE
C
      DO 112 J=1,N
         DO 111 I=1,M
            DATA(I,J)=(DATA(I,J)-DMIN)/(DMAX-DMIN)*(DHGH-DLOW)+DLOW
 111     CONTINUE
 112  CONTINUE
C
      RETURN
C
      END

      FUNCTION FRAN ()
      DIMENSION RSEQ (100)
      SAVE ISEQ
      DATA RSEQ / .749,.973,.666,.804,.081,.483,.919,.903,.951,.960 ,
     +     .039,.269,.270,.756,.222,.478,.621,.063,.550,.798 ,
     +     .027,.569,.149,.697,.451,.738,.508,.041,.266,.249 ,
     +     .019,.191,.266,.625,.492,.940,.508,.406,.972,.311 ,
     +     .757,.378,.299,.536,.619,.844,.342,.295,.447,.499 ,
     +     .688,.193,.225,.520,.954,.749,.997,.693,.217,.273 ,
     +     .961,.948,.902,.104,.495,.257,.524,.100,.492,.347 ,
     +     .981,.019,.225,.806,.678,.710,.235,.600,.994,.758 ,
     +     .682,.373,.009,.469,.203,.730,.588,.603,.213,.495 ,
     +     .884,.032,.185,.127,.010,.180,.689,.354,.372,.429 /
      DATA ISEQ / 0 /
      ISEQ=MOD(ISEQ,100)+1
      FRAN=RSEQ(ISEQ)
      RETURN
      END

      SUBROUTINE COLOR (N,IWKID)
C
C The background color is black.
C
      CALL GSCR(IWKID,0,0.,0.,0.)
C
C The first foreground color is white.
C
      CALL GSCR(IWKID,1,1.,1.,1.)
C
C The second foreground color is gray.
C
      CALL GSCR(IWKID,2,.75,.75,.75)
C
C Choose other foreground colors spaced equally around the spectrum.
C
      ICNT=0
      HUES=360./N
C
C REDLN is intended to be the line between red and violet values.
C
      REDLN=36.0
      LAP=INT(REDLN/HUES)
      DO 10, I=1,N
         XHUE=I*HUES
         CALL HLSRGB(XHUE,60.,75.,RED,GREEN,BLUE)
C
C Sort colors so that the reddest is first, and the most violet is last.
C
         IF (XHUE.LE.REDLN) THEN
            CALL GSCR(IWKID,(N+2)-(LAP-I),RED,GREEN,BLUE)
            ICNT=ICNT+1
         ELSE
            CALL GSCR(IWKID,I-ICNT+2,RED,GREEN,BLUE)
         ENDIF
 10   CONTINUE
C
      RETURN
C
      END

c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by UCAR                 .
c  .                                                             .
c  .       University Corporation for Atmospheric Research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                         SPHEREPACK                          .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c
      SUBROUTINE DVSURF(XEYE,YEYE,ZEYE,NTRI,X1,Y1,Z1,X2,Y2,Z2,X3,Y3,Z3,
     +                 ITYPE,WORK,IWORK)
      DOUBLE PRECISION XEYE
      DOUBLE PRECISION YEYE
      DOUBLE PRECISION ZEYE
      DOUBLE PRECISION X1
      DOUBLE PRECISION Y1
      DOUBLE PRECISION Z1
      DOUBLE PRECISION X2
      DOUBLE PRECISION Y2
      DOUBLE PRECISION Z2
      DOUBLE PRECISION X3
      DOUBLE PRECISION Y3
      DOUBLE PRECISION Z3
      DOUBLE PRECISION WORK
c
c    subroutine vsurf is like subroutine hidel except the triangles
c    are categorized. vsurf is also like solid except triangles rather
c    than lines are covered.
c
c     written by paul n. swarztrauber, national center for atmospheric
c     research, p.o. box 3000, boulder, colorado, 80307
c
c    this program plots visible lines for the surface defined
c    by the input 3-d triangles with corners at (x1,y1,z1), (x2,y2,z2)
c    and (x3,y3,z3). the sides of these these triangles may or
c    may not be plotted depending on itype. if itype is 1 then the
c    side between points (x1,y1,z1) and (x2,y2,z2) is plotted if it
c    is visible. if itype is 2 then the side between (x2,y2,z2)
c    and (x3,y3,z3) is plotted. if itype is 3 then the visible portion
c    of the side between (x3,y3,z3) and (x1,y1,z1) is plotted.
c    any combination is possible by specifying itype to be one
c    of the following values: 0,1,2,3,12,13,23,123.
c
c    the length of real    array  work must be at least 19*ntri
c
c    the length of integer array iwork must be at least 19*ntri
c
c
c    the vertices of the triangles are renumbered by vsurf so that
c    their projections are orientated counterclockwise. the user need
c    only be aware that the vertices may be renumbered by vsurf.
c
      DIMENSION X1(NTRI),Y1(NTRI),Z1(NTRI),X2(NTRI),Y2(NTRI),Z2(NTRI),
     +          X3(NTRI),Y3(NTRI),Z3(NTRI),ITYPE(NTRI),WORK(19*NTRI)
      INTEGER IWORK(19*NTRI)
c
      CALL DVSURF1(XEYE,YEYE,ZEYE,NTRI,X1,Y1,Z1,X2,Y2,Z2,X3,Y3,Z3,
     +             ITYPE,WORK,WORK(NTRI+1),WORK(2*NTRI+1),
     +             WORK(3*NTRI+1),WORK(4*NTRI+1),WORK(5*NTRI+1),
     +             WORK(6*NTRI+1),WORK(7*NTRI+1),WORK(8*NTRI+1),
     +             WORK(9*NTRI+1),WORK(10*NTRI+1),WORK(11*NTRI+1),
     +             WORK(12*NTRI+1),WORK(13*NTRI+1),IWORK(14*NTRI+1),
     +             IWORK(6*NTRI+1),IWORK(15*NTRI+1),IWORK(17*NTRI+1))
      RETURN
      END

      SUBROUTINE ZSPR( UPLO, N, ALPHA, X, INCX, AP )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     October 31, 1992
*
*     .. Scalar Arguments ..
      CHARACTER          UPLO
      INTEGER            INCX, N
      COMPLEX*16         ALPHA
*     ..
*     .. Array Arguments ..
      COMPLEX*16         AP( * ), X( * )
*     ..
*
*  Purpose
*  =======
*
*  ZSPR    performs the symmetric rank 1 operation
*
*     A := alpha*x*conjg( x' ) + A,
*
*  where alpha is a complex scalar, x is an n element vector and A is an
*  n by n symmetric matrix, supplied in packed form.
*
*  Arguments
*  ==========
*
*  UPLO   - CHARACTER*1
*           On entry, UPLO specifies whether the upper or lower
*           triangular part of the matrix A is supplied in the packed
*           array AP as follows:
*
*              UPLO = 'U' or 'u'   The upper triangular part of A is
*                                  supplied in AP.
*
*              UPLO = 'L' or 'l'   The lower triangular part of A is
*                                  supplied in AP.
*
*           Unchanged on exit.
*
*  N      - INTEGER
*           On entry, N specifies the order of the matrix A.
*           N must be at least zero.
*           Unchanged on exit.
*
*  ALPHA  - COMPLEX*16
*           On entry, ALPHA specifies the scalar alpha.
*           Unchanged on exit.
*
*  X      - COMPLEX*16 array, dimension at least
*           ( 1 + ( N - 1 )*abs( INCX ) ).
*           Before entry, the incremented array X must contain the N-
*           element vector x.
*           Unchanged on exit.
*
*  INCX   - INTEGER
*           On entry, INCX specifies the increment for the elements of
*           X. INCX must not be zero.
*           Unchanged on exit.
*
*  AP     - COMPLEX*16 array, dimension at least
*           ( ( N*( N + 1 ) )/2 ).
*           Before entry, with  UPLO = 'U' or 'u', the array AP must
*           contain the upper triangular part of the symmetric matrix
*           packed sequentially, column by column, so that AP( 1 )
*           contains a( 1, 1 ), AP( 2 ) and AP( 3 ) contain a( 1, 2 )
*           and a( 2, 2 ) respectively, and so on. On exit, the array
*           AP is overwritten by the upper triangular part of the
*           updated matrix.
*           Before entry, with UPLO = 'L' or 'l', the array AP must
*           contain the lower triangular part of the symmetric matrix
*           packed sequentially, column by column, so that AP( 1 )
*           contains a( 1, 1 ), AP( 2 ) and AP( 3 ) contain a( 2, 1 )
*           and a( 3, 1 ) respectively, and so on. On exit, the array
*           AP is overwritten by the lower triangular part of the
*           updated matrix.
*           Note that the imaginary parts of the diagonal elements need
*           not be set, they are assumed to be zero, and on exit they
*           are set to zero.
*
* =====================================================================
*
*     .. Parameters ..
      COMPLEX*16         ZERO
      PARAMETER          ( ZERO = ( 0.0D+0, 0.0D+0 ) )
*     ..
*     .. Local Scalars ..
      INTEGER            I, INFO, IX, J, JX, K, KK, KX
      COMPLEX*16         TEMP
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           XERBLA
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      IF( .NOT.LSAME( UPLO, 'U' ) .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = 1
      ELSE IF( N.LT.0 ) THEN
         INFO = 2
      ELSE IF( INCX.EQ.0 ) THEN
         INFO = 5
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'ZSPR  ', INFO )
         RETURN
      END IF
*
*     Quick return if possible.
*
      IF( ( N.EQ.0 ) .OR. ( ALPHA.EQ.ZERO ) )
     $   RETURN
*
*     Set the start point in X if the increment is not unity.
*
      IF( INCX.LE.0 ) THEN
         KX = 1 - ( N-1 )*INCX
      ELSE IF( INCX.NE.1 ) THEN
         KX = 1
      END IF
*
*     Start the operations. In this version the elements of the array AP
*     are accessed sequentially with one pass through AP.
*
      KK = 1
      IF( LSAME( UPLO, 'U' ) ) THEN
*
*        Form  A  when upper triangle is stored in AP.
*
         IF( INCX.EQ.1 ) THEN
            DO 20 J = 1, N
               IF( X( J ).NE.ZERO ) THEN
                  TEMP = ALPHA*X( J )
                  K = KK
                  DO 10 I = 1, J - 1
                     AP( K ) = AP( K ) + X( I )*TEMP
                     K = K + 1
   10             CONTINUE
                  AP( KK+J-1 ) = AP( KK+J-1 ) + X( J )*TEMP
               ELSE
                  AP( KK+J-1 ) = AP( KK+J-1 )
               END IF
               KK = KK + J
   20       CONTINUE
         ELSE
            JX = KX
            DO 40 J = 1, N
               IF( X( JX ).NE.ZERO ) THEN
                  TEMP = ALPHA*X( JX )
                  IX = KX
                  DO 30 K = KK, KK + J - 2
                     AP( K ) = AP( K ) + X( IX )*TEMP
                     IX = IX + INCX
   30             CONTINUE
                  AP( KK+J-1 ) = AP( KK+J-1 ) + X( JX )*TEMP
               ELSE
                  AP( KK+J-1 ) = AP( KK+J-1 )
               END IF
               JX = JX + INCX
               KK = KK + J
   40       CONTINUE
         END IF
      ELSE
*
*        Form  A  when lower triangle is stored in AP.
*
         IF( INCX.EQ.1 ) THEN
            DO 60 J = 1, N
               IF( X( J ).NE.ZERO ) THEN
                  TEMP = ALPHA*X( J )
                  AP( KK ) = AP( KK ) + TEMP*X( J )
                  K = KK + 1
                  DO 50 I = J + 1, N
                     AP( K ) = AP( K ) + X( I )*TEMP
                     K = K + 1
   50             CONTINUE
               ELSE
                  AP( KK ) = AP( KK )
               END IF
               KK = KK + N - J + 1
   60       CONTINUE
         ELSE
            JX = KX
            DO 80 J = 1, N
               IF( X( JX ).NE.ZERO ) THEN
                  TEMP = ALPHA*X( JX )
                  AP( KK ) = AP( KK ) + TEMP*X( JX )
                  IX = JX
                  DO 70 K = KK + 1, KK + N - J
                     IX = IX + INCX
                     AP( K ) = AP( K ) + X( IX )*TEMP
   70             CONTINUE
               ELSE
                  AP( KK ) = AP( KK )
               END IF
               JX = JX + INCX
               KK = KK + N - J + 1
   80       CONTINUE
         END IF
      END IF
*
      RETURN
*
*     End of ZSPR
*
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C   FFTPACK 5.0
C   Copyright (C) 1995-2004, Scientific Computing Division,
C   University Corporation for Atmospheric Research
C   Licensed under the GNU General Public License (GPL)
C
C   Authors:  Paul N. Swarztrauber and Richard A. Valent
C
C   $Id: cfft2i.f,v 1.2 2006-11-21 01:10:16 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      SUBROUTINE DCFFT2I(L,M,WSAVE,LENSAV,IER)
      INTEGER L,M,IER
      DOUBLE PRECISION WSAVE(LENSAV)
C
C Initialize error return
C
      IER = 0
C
      IF (LENSAV.LT.2*L+INT(LOG(DBLE(L)))+2*M+INT(LOG(DBLE(M)))+8) THEN
          IER = 2
          CALL DXERFFT('CFFT2I',4)
          GO TO 100
      END IF
C
      CALL DCFFTMI(L,WSAVE(1),2*L+INT(LOG(DBLE(L)))+4,IER1)
      IF (IER1.NE.0) THEN
          IER = 20
          CALL DXERFFT('CFFT2I',-5)
          GO TO 100
      END IF
      CALL DCFFTMI(M,WSAVE(2*L+INT(LOG(DBLE(L))*LOG(2.D0))+3),
     +            2*M+INT(LOG(DBLE(M)))+4,IER1)
      IF (IER1.NE.0) THEN
          IER = 20
          CALL DXERFFT('CFFT2I',-5)
      END IF
C
  100 CONTINUE
      RETURN
      END

      PROGRAM CPEX16
C
C This program reads user data defining a global field of temperatures
C on what is called a POP grid and draws any or all of the following
C five plots: 1) the POP grid; 2) temperature contours; 3) color-filled
C temperature contour bands, drawn using AREAS; 4) the same contour
C bands, drawn using a cell array; and 5) the POP grid cells, filled
C in the colors chosen by CONPACK for the contour bands.  The values
C of the flags that determine which of these plots are drawn are set
C in DATA statements below.
C
C Of principal interest is the version of CPMPXY included, which solves
C the difficult problem of doing the inverse transformation (to find,
C given a position on the map, that point on the POP grid which maps
C into that position).
C
C Include definitions that "NetCDF" needs (now commented out, because
C the data are being read from an ASCII file, instead).
C
C       include 'netcdf.inc'
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
        PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C The parameters MCRA and NCRA declare the dimensions of the cell array,
C ICRA, to be used.  Using larger values of MCRA and NCRA gives a better
C picture, but also increases execution time and metafile size.  Using
C smaller values gives smaller execution times and smaller metafiles.
C The user must determine whether the picture given by a particular
C pair of values is acceptable or not.
C
C       PARAMETER (MCRA=  25,NCRA=  25)
C       PARAMETER (MCRA=  50,NCRA=  50)
C       PARAMETER (MCRA= 100,NCRA= 100)
C       PARAMETER (MCRA= 200,NCRA= 200)
C       PARAMETER (MCRA= 400,NCRA= 400)
C       PARAMETER (MCRA= 512,NCRA= 512)
        PARAMETER (MCRA= 800,NCRA= 800)
C       PARAMETER (MCRA=1000,NCRA=1000)
C       PARAMETER (MCRA=1024,NCRA=1024)
C       PARAMETER (MCRA=2048,NCRA=2048)
C
C Declare the lengths of workspace arrays to be passed to CONPACK, the
C area-map array to be used, and workspace arrays for ARSCAM.
C
        PARAMETER (LRWK=2000,LIWK=1000,LAMA=400000,NCRD=5000)
C
C Dimension arrays to receive the data we want to look at.  TLAT and
C TLON specify the positions of the centers of the POP grid boxes; the
C values in these arrays, as read from the source file, are in error
C near the North Pole, so this program recomputes some of the values.
C ULAT and ULON specify the positions of the corners of the POP grid
C boxes.  TEMP specifies temperatures at the centers of the POP grid
C boxes.
C
        DIMENSION TLAT(100,116),TLON(100,116)
        DIMENSION ULAT(100,116),ULON(100,116)
        DIMENSION TEMP(100,116)
C
C Declare arrays to hold information derived from ULAT and ULON, for
C use in calling IPIQSP or IPIQDP.  For each I and J, (UQSP(K,I,J),
C K=1,4) is a vector containing the single-precision cosine and sine
C of ULAT(I,J) and the single-precision cosine and sine of ULON(I,J),
C in that order.  UQDP is similar, but holds double-precision values.
C (The routines that do spherical geometry are given cosines and sines
C of latitudes and longitudes, instead of the latitudes and longitudes
C themselves, because this makes them run a lot faster.)
C
        DIMENSION        UQSP(4,100,116)
        DOUBLE PRECISION UQDP(4,100,116)
C
C Declare arrays that will define the positions of the center points
C of the grid on the globe and the data values associated with them.
C These arrays have one point of overlap in the first dimension.
C
        DIMENSION XLAT(101,116),XLON(101,116),ZDAT(101,116)
C
C Declare stuff that has to be passed to the mapping routine CPMPXY,
C including the arrays XQSP and XQDP, which are similar to UQDP and
C hold the cosines and sines of the latitudes and longitudes of the
C center points of the grid; a flag, ISOD, that says whether to use
C single- or double-precision arithmetic; and indices IBEG, IEND, JBEG,
C and JEND, that specify the grid box in which CPMPXY determined that
C the last point to be inverse-transformed lay.
C
        COMMON /TESTCM/ XQSP(4,101,116),XQDP(4,101,116),ISOD,
     +                  IBEG,IEND,JBEG,JEND
          DOUBLE PRECISION XQDP
        SAVE   /TESTCM/
C
C The arrays RWRK and IWRK are workspace arrays for CONPACK.
C
        DIMENSION RWRK(LRWK),IWRK(LIWK)
C
C The array ICRA is the cell array.
C
        DIMENSION ICRA(MCRA,NCRA)
C
C The array IAMA is an area-map array.
C
        DIMENSION IAMA(LAMA)
C
C Declare arrays for ARSCAM to use in calling COLRAM - two for X and
C Y coordinate information and two for area-identifier information.
C
        DIMENSION XCRD(NCRD),YCRD(NCRD)
        DIMENSION IAIA(2),IGIA(2)
C
C Declare the routine that will be called by ARSCAM to color areas.
C
        EXTERNAL COLRAM
C
C Define a character temporary for index labels.
C
        CHARACTER*6 CTMP
C
C Declare double-precision multiplicative constants to convert from
C degrees to radians and vice-versa.
C
        DOUBLE PRECISION DRDP,RDDP
C
C Declare an array to use in timing calls.
C
C       DIMENSION TIME(2)
C
C Declare arrays into which to retrieve contour-level information and
C associated area identifiers.
C
        DIMENSION CLEV(256),KAIA(256),KAIB(256)
C
C Define flags that say whether or not to do timing calls and prints,
C whether or not to plot the POP grid, whether or not to label each grid
C cell center point on the POP grid, whether or not to do the plot of
C temperature contours, whether or not to do the fill area plot, whether
C or not to do the cell array plot, and whether or not to do a plot by
C filling POP grid cells directly.
C
C       DATA ITIM,IPOP,ILBL,ICON,IFIL,ICEL,IPGC /
C    +          1,   1,   0,   1,   1,   1,   1 /
        DATA      IPOP,ILBL,ICON,IFIL,ICEL,IPGC /
     +               1,   0,   1,   1,   1,   1 /
C
C Define single-precision and double-precision multiplicative constants
C to convert from degrees to radians and vice-versa.
C
        DATA DRSP / .017453292519943 /
        DATA RDSP / 57.2957795130823 /
C
        DATA DRDP / .017453292519943D0 /
        DATA RDDP / 57.2957795130823D0 /
C
C Print elapsed time at start.
C
C       IF (ITIM.NE.0) THEN
C         PRINT * , 'INITIALLY:'
C         IF (DTIME(TIME).GE.0.) THEN
C           PRINT * , '  USER TIME:  ',TIME(1)
C           PRINT * , '  SYSTEM TIME:',TIME(2)
C         ELSE
C           PRINT * , '  ERROR IN DTIME'
C         END IF
C       END IF
C
C R E A D   T H E   D A T A
C - - - -   - - -   - - - -
C
C The data for this example were originally read from a user's "NetCDF"
C file.  The code used for the purpose follows, but has been commented
C out, as the data are now read from an ASCII file.  This gets around
C certain procedural problems in running the example from "ncargex".
C
C Open the "NetCDF" file.
C
C       ISTA=NF_OPEN('cpex16.dat.nc',0,NCID)
C
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'ERROR RETURN FROM NF_OPEN: ',ISTA
C         STOP
C       END IF
C
C Read the array of latitudes of cell centers.
C
C       ISTA=NF_INQ_VARID(NCID,'TLAT',IVID)
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'ERROR RETURN FROM NF_INQ_VARID: ',ISTA
C         STOP
C       END IF
C
C       ISTA=NF_GET_VAR_REAL(NCID,IVID,TLAT)
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'ERROR RETURN FROM NF_GET_VAR_REAL: ',ISTA
C         STOP
C       END IF
C
C Read the array of longitudes of cell centers.
C
C       ISTA=NF_INQ_VARID(NCID,'TLONG',IVID)
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'ERROR RETURN FROM NF_INQ_VARID: ',ISTA
C         STOP
C       END IF
C
C       ISTA=NF_GET_VAR_REAL(NCID,IVID,TLON)
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'ERROR RETURN FROM NF_GET_VAR_REAL: ',ISTA
C         STOP
C       END IF
C
C Read the array of latitudes of cell corner points.
C
C       ISTA=NF_INQ_VARID(NCID,'ULAT',IVID)
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'ERROR RETURN FROM NF_INQ_VARID: ',ISTA
C         STOP
C       END IF
C
C       ISTA=NF_GET_VAR_REAL(NCID,IVID,ULAT)
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'ERROR RETURN FROM NF_GET_VAR_REAL: ',ISTA
C         STOP
C       END IF
C
C Read the array of longitudes of cell corner points.
C
C       ISTA=NF_INQ_VARID(NCID,'ULONG',IVID)
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'ERROR RETURN FROM NF_INQ_VARID: ',ISTA
C         STOP
C       END IF
C
C       ISTA=NF_GET_VAR_REAL(NCID,IVID,ULON)
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'ERROR RETURN FROM NF_GET_VAR_REAL: ',ISTA
C         STOP
C       END IF
C
C Read the array of temperature values.
C
C       ISTA=NF_INQ_VARID(NCID,'TEMP',IVID)
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'ERROR RETURN FROM NF_INQ_VARID: ',ISTA
C         STOP
C       END IF
C
C       ISTA=NF_GET_VAR_REAL(NCID,IVID,TEMP)
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'ERROR RETURN FROM NF_GET_VAR_REAL: ',ISTA
C         STOP
C       END IF
C
C Close the "NetCDF" file.
C
C       ISTA=NF_CLOSE(NCID)
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'ERROR RETURN FROM NF_CLOSE: ',ISTA
C         STOP
C       END IF
C
C Write the data to unit 11.  (These statements are commented out; they
C were used to create a "fort.11" which was then renamed "cpex16.dat".)
C
C       WRITE (11,'(5E16.8)') TLAT
C       WRITE (11,'(5E16.8)') TLON
C       WRITE (11,'(5E16.8)') ULAT
C       WRITE (11,'(5E16.8)') ULON
C       WRITE (11,'(5E16.8)') TEMP
C
C Read the required data from the ASCII file "cpex16.dat".
C
        OPEN (11,FILE='cpex16.dat',STATUS='OLD',FORM='FORMATTED')
C
        READ (11,'(5E16.8)') TLAT
        READ (11,'(5E16.8)') TLON
        READ (11,'(5E16.8)') ULAT
        READ (11,'(5E16.8)') ULON
        READ (11,'(5E16.8)') TEMP
C
        CLOSE (11)
C
C Set ISWP = 0 to leave the data alone, or = 1 to flip it end-for-end in
C the second subscript.
C
        ISWP=0
C
        IF (ISWP.NE.0) THEN
          DO 902 I=1,100
            DO 901 J=1,58
              WORK=TLAT(I,J)
              TLAT(I,J)=TLAT(I,117-J)
              TLAT(I,117-J)=WORK
              WORK=TLON(I,J)
              TLON(I,J)=TLON(I,117-J)
              TLON(I,117-J)=WORK
              WORK=ULAT(I,J)
              ULAT(I,J)=ULAT(I,117-J)
              ULAT(I,117-J)=WORK
              WORK=ULON(I,J)
              ULON(I,J)=ULON(I,117-J)
              ULON(I,117-J)=WORK
              WORK=TEMP(I,J)
              TEMP(I,J)=TEMP(I,117-J)
              TEMP(I,117-J)=WORK
  901       CONTINUE
  902     CONTINUE
        END IF
C
C Print elapsed time.
C
C       IF (ITIM.NE.0) THEN
C         PRINT * , 'AFTER READING INPUT DATA:'
C         IF (DTIME(TIME).GE.0.) THEN
C           PRINT * , '  USER TIME:  ',TIME(1)
C           PRINT * , '  SYSTEM TIME:',TIME(2)
C         ELSE
C           PRINT * , '  ERROR IN DTIME'
C         END IF
C       END IF
C
C C O M P U T E   O T H E R   Q U A N T I T I E S   N E E D E D
C - - - - - - -   - - - - -   - - - - - - - - - -   - - - - - -
C
C Set the flag ISOD, which says whether to use single-precision or
C double-precision arithmetic, by calling a subroutine to generate and
C return the three real numbers 1, 1+1E-10, and 1+2E-10.  If all three
C numbers appear to be different, single-precision arithmetic suffices
C and we set ISOD = 0; otherwise, we need double-precision arithmetic
C and we set ISOD = 1.  (The subroutine call is necessary to fool some
C compilers into storing TST1, TST2, and TST3; otherwise, we might use
C single precision on machines on which double precision should be.)
C
        CALL GETTRN (TST1,TST2,TST3)
C
        IF (TST1.NE.TST2.AND.TST2.NE.TST3) THEN
          ISOD=0
        ELSE
          ISOD=1
        END IF
C
C Define the contents of one of the arrays UQSP (if ISOD=0) or UQDP (if
C ISOD=1).
C
        IF (ISOD.EQ.0) THEN
          DO 102 I=1,100
            DO 101 J=1,116
              UQSP(1,I,J)=COS(DRSP*ULAT(I,J))
              UQSP(2,I,J)=SIN(DRSP*ULAT(I,J))
              UQSP(3,I,J)=COS(DRSP*ULON(I,J))
              UQSP(4,I,J)=SIN(DRSP*ULON(I,J))
  101       CONTINUE
  102     CONTINUE
        ELSE
          DO 104 I=1,100
            DO 103 J=1,116
              UQDP(1,I,J)=COS(DRDP*DBLE(ULAT(I,J)))
              UQDP(2,I,J)=SIN(DRDP*DBLE(ULAT(I,J)))
              UQDP(3,I,J)=COS(DRDP*DBLE(ULON(I,J)))
              UQDP(4,I,J)=SIN(DRDP*DBLE(ULON(I,J)))
  103       CONTINUE
  104     CONTINUE
        END IF
C
C Define the contents of the arrays XLAT, XLON, XQSP or XQDP, and ZDAT,
C using one point of overlap in the "I" subscript.  Note that we use
C center-point positions of POP grid cells as corner-point positions
C of the grid to be contoured by CONPACK.  Note also that, instead of
C using all the center-point positions from the NetCDF file, we compute
C those for J .GT. 100 ourselves, thus fixing a problem caused by the
C fact that SCRIP was used to compute them in a manner which failed
C badly near the North Pole.
C
        DO 106 I=1,101
          III=MOD(I+99,100)+1
          IM1=MOD(I+98,100)+1
          DO 105 J=1,116
            IF (J.LE.100) THEN
              XLAT(I,J)=TLAT(III,J)
              XLON(I,J)=TLON(III,J)
              IF (ISOD.EQ.0) THEN
                XQSP(1,I,J)=COS(DRSP*XLAT(I,J))
                XQSP(2,I,J)=SIN(DRSP*XLAT(I,J))
                XQSP(3,I,J)=COS(DRSP*XLON(I,J))
                XQSP(4,I,J)=SIN(DRSP*XLON(I,J))
              ELSE
                XQDP(1,I,J)=COS(DRDP*DBLE(XLAT(I,J)))
                XQDP(2,I,J)=SIN(DRDP*DBLE(XLAT(I,J)))
                XQDP(3,I,J)=COS(DRDP*DBLE(XLON(I,J)))
                XQDP(4,I,J)=SIN(DRDP*DBLE(XLON(I,J)))
              END IF
            ELSE
              IF (ISOD.EQ.0) THEN
                CALL IPIQSP (UQSP(1,IM1,J-1),UQSP(1,III,J-1),
     +                       UQSP(1,IM1,J  ),UQSP(1,III,J  ),
     +                                     .5,.5,XQSP(1,I,J))
                XLAT(I,J)=RDSP*ASIN(XQSP(2,I,J))
                IF (XQSP(3,I,J).NE.0..OR.XQSP(4,I,J).NE.0.) THEN
                  XLON(I,J)=RDSP*ATAN2(XQSP(4,I,J),XQSP(3,I,J))
                ELSE
                  XLON(I,J)=0.
                END IF
              ELSE
                CALL IPIQDP (UQDP(1,IM1,J-1),UQDP(1,III,J-1),
     +                       UQDP(1,IM1,J  ),UQDP(1,III,J  ),
     +                                 .5D0,.5D0,XQDP(1,I,J))
                XLAT(I,J)=REAL(RDDP*ASIN(XQDP(2,I,J)))
                IF (XQDP(3,I,J).NE.0.D0.OR.XQDP(4,I,J).NE.0.D0) THEN
                  XLON(I,J)=REAL(RDDP*ATAN2(XQDP(4,I,J),XQDP(3,I,J)))
                ELSE
                  XLON(I,J)=0.
                END IF
              END IF
            END IF
            ZDAT(I,J)=TEMP(III,J)
  105     CONTINUE
  106   CONTINUE
C
C Initialize the values of the indices saying in which box of the grid
C a desired point was found by the last call to CPMPXY with IMAP = -3.
C
        IBEG=0
        IEND=0
        JBEG=0
        JEND=0
C
C Print elapsed time.
C
C       IF (ITIM.NE.0) THEN
C         PRINT * , 'AFTER SET-UP COMPUTATIONS:'
C         IF (DTIME(TIME).GE.0.) THEN
C           PRINT * , '  USER TIME:  ',TIME(1)
C           PRINT * , '  SYSTEM TIME:',TIME(2)
C         ELSE
C           PRINT * , '  ERROR IN DTIME'
C         END IF
C       END IF
C
C I N I T I A L I Z E   G K S
C - - - - - - - - - -   - - -
C
C Open GKS.
C
        CALL GOPKS (IERRF,0)
        CALL GOPWK (IWKID,LUNIT,IWTYPE)
        CALL GACWK (IWKID)
C
C Turn GKS clipping off.
C
        CALL GSCLIP (0)
C
C Define some basic colors to use.
C
        CALL GSCR   (IWKID,2,.7,.7,.7)
        CALL GSCR   (IWKID,3,0.,1.,0.)
        CALL GSCR   (IWKID,4,1.,0.,0.)
        CALL GSCR   (IWKID,5,1.,1.,0.)
        CALL GSCR   (IWKID,6,0.,.7,.7)
        CALL GSCR   (IWKID,7,0.,0.,1.)
        CALL GSCR   (IWKID,8,.8,.5,.5)
        CALL GSCR   (IWKID,9,.5,.8,.5)
C
C I N I T I A L I Z E   V A R I O U S   U T I L I T I E S
C - - - - - - - - - -   - - - - - - -   - - - - - - - - -
C
C Tell PLOTCHAR to use font number 25 (a filled font), to outline each
C character, and what colors to use.
C
        CALL PCSETI ('FN - FONT NUMBER',25)
        CALL PCSETI ('OF - OUTLINE FLAG',1)
        CALL PCSETI ('CC - CHARACTER COLOR',8)
        CALL PCSETI ('OC - OUTLINE COLOR',1)
C
C Tell PLOTCHAR to tell the Bezier package to reproduce the curves
C outlining the characters with a little less fidelity.  This cuts
C down on the size of the metafile.
C
        CALL PCSETR ('FB - FIDELITY OF BEZIER CURVES',.00015)
C
C Tell EZMAP what projection to use (choices given include cylindrical
C equidistant; orthographic, including the North Pole; orthographic,
C opposite side of globe from the second choice; orthographic, from
C above the North Pole; and polar stereographic).
C
C       CALL MAPROJ ('CE',  0.,  0.,0.)
        CALL MAPROJ ('OR',+40.,-20.,0.)
C       CALL MAPROJ ('OR',-40.,160.,0.)
C       CALL MAPROJ ('OR', 90.,  0.,0.)
C       CALL MAPROJ ('ST', 90.,  0.,0.)
C
C Tell EZMAP what part of the projection to draw (choices given specify
C a maximal useful view; a 30-degree field of view; and a 60-degree
C field of view).
C
        CALL MAPSET ('MA', 0., 0., 0., 0.)
C       CALL MAPSET ('AN',15.,15.,15.,15.)
C       CALL MAPSET ('AN',60.,60.,60.,60.)
C
C Initialize EZMAP (to make it call SET).
C
        CALL MAPINT
C
C Print elapsed time.
C
C       IF (ITIM.NE.0) THEN
C         PRINT * , 'AFTER INITIALIZING GKS AND VARIOUS UTILITIES:'
C         IF (DTIME(TIME).GE.0.) THEN
C           PRINT * , '  USER TIME:  ',TIME(1)
C           PRINT * , '  SYSTEM TIME:',TIME(2)
C         ELSE
C           PRINT * , '  ERROR IN DTIME'
C         END IF
C       END IF
C
C P L O T   T H E   P O P   G R I D
C - - - -   - - -   - - -   - - - -
C
C Plot the POP grid, but only if a flag is set.
C
        IF (IPOP.NE.0) THEN
C
C Draw a basic map.
C
          CALL MAPDRW
C
C Draw the corner-point grid in gray.
C
          CALL SFLUSH
          CALL GSPLCI (2)
C
          DO 108 I=1,100
            DO 107 J=1,116
              IF (J.EQ.1) THEN
                IPEN=0
              ELSE IF (J.NE.116) THEN
                IPEN=1
              ELSE
                IPEN=2
              END IF
              CALL MAPIT (ULAT(I,J),ULON(I,J),IPEN)
  107       CONTINUE
            CALL MAPIQ
  108     CONTINUE
C
          DO 110 J=1,116
            DO 109 I=1,100
              K=MOD(I-1,100)+1
              IF (I.EQ.1) THEN
                IPEN=0
              ELSE IF (I.NE.100) THEN
                IPEN=1
              ELSE
                IPEN=2 
              END IF
              CALL MAPIT (ULAT(K,J),ULON(K,J),IPEN)
  109       CONTINUE
            CALL MAPIQ
  110     CONTINUE
C
C Draw the original center-point grid in a reddish-gray.
C
          CALL SFLUSH
          CALL GSPLCI (8)
C
          DO 112 I=1,100
            DO 111 J=1,116
              IF (J.EQ.1) THEN
                IPEN=0
              ELSE IF (J.NE.116) THEN
                IPEN=1
              ELSE
                IPEN=2 
              END IF
              CALL MAPIT (TLAT(I,J),TLON(I,J),IPEN)
  111       CONTINUE
            CALL MAPIQ
  112     CONTINUE
C
          DO 114 J=1,116
            DO 113 I=1,101
              K=MOD(I-1,100)+1
              IF (I.EQ.1) THEN
                IPEN=0
              ELSE IF (I.NE.101) THEN
                IPEN=1
              ELSE
                IPEN=2
              END IF
              CALL MAPIT (TLAT(K,J),TLON(K,J),IPEN)
  113       CONTINUE
            CALL MAPIQ
  114     CONTINUE
C
C Mark the original center points in red.
C
          CALL SFLUSH
          CALL GSPLCI (4)
C
          DO 116 I=1,100
            DO 115 J=1,116
              CALL MAPTRA (TLAT(I,J),TLON(I,J),X,Y)
              IF (X.NE.1.E12) CALL POINT (X,Y)
  115       CONTINUE
  116     CONTINUE
C
C Draw the recomputed center-point grid in a greenish-gray.
C
          CALL SFLUSH
          CALL GSPLCI (9)
C
          DO 118 I=1,101
            DO 117 J=1,116
              IF (J.EQ.1) THEN
                IPEN=0
              ELSE IF (J.NE.116) THEN
                IPEN=1
              ELSE
                IPEN=2
              END IF
              CALL MAPIT (XLAT(I,J),XLON(I,J),IPEN)
  117       CONTINUE
            CALL MAPIQ
  118     CONTINUE
C
          DO 120 J=1,116
            DO 119 I=1,101
              IF (I.EQ.1) THEN
                IPEN=0
              ELSE IF (I.NE.101) THEN
                IPEN=1
              ELSE
                IPEN=2
              END IF
              CALL MAPIT (XLAT(I,J),XLON(I,J),IPEN)
  119       CONTINUE
            CALL MAPIQ
  120     CONTINUE
C
C Mark the recomputed center points in green.
C
          CALL SFLUSH
          CALL GSPLCI (3)
C
          DO 122 I=1,100
            DO 121 J=1,116
              CALL MAPTRA (XLAT(I,J),XLON(I,J),X,Y)
              IF (X.NE.1.E12) CALL POINT (X,Y)
  121       CONTINUE
  122     CONTINUE
C
C Draw the edges of the corner-point grid in yellow.
C
          CALL SFLUSH
          CALL GSPLCI (5)
C
          DO 124 I=1,100,99
            DO 123 J=1,116
              IF (J.EQ.1) THEN
                IPEN=0
              ELSE IF (J.NE.116) THEN
                IPEN=1
              ELSE
                IPEN=2
              END IF
              CALL MAPIT (ULAT(I,J),ULON(I,J),IPEN)
  123       CONTINUE
            CALL MAPIQ
  124     CONTINUE
C
          DO 126 J=1,116,115
            DO 125 I=1,100
              IF (I.EQ.1) THEN
                IPEN=0
              ELSE IF (I.NE.100) THEN
                IPEN=1
              ELSE
                IPEN=2
              END IF
              CALL MAPIT (ULAT(I,J),ULON(I,J),IPEN)
  125       CONTINUE
            CALL MAPIQ
  126     CONTINUE
C
C If requested, label the original center points in dark cyan, using
C very small letters.
C
          IF (ILBL.NE.0) THEN
C
            CALL SFLUSH
            CALL GSPLCI (6)
C
            DO 129 I=1,100
              DO 128 J=1,116
                CALL MAPTRN (TLAT(I,J),TLON(I,J),X,Y)
                IF (X.NE.1.E12) THEN
                  WRITE (CTMP,'(2I3)') I,J
                  DO 127 K=1,6
                    IF (CTMP(K:K).EQ.' ') CTMP(K:K)='0'
  127             CONTINUE
                  CALL PLCHMQ (X,Y,CTMP,.0005,0.,0.)
                END IF
  128         CONTINUE
  129       CONTINUE
C
          END IF
C
C Label the plot.
C
          CALL PLCHHQ (CFUX(.5),CFUY(.975),'THE POP GRID',.018,0.,0.)
C
          CALL PLCHHQ (CFUX(.5),CFUY(.035),'Corner-point grid in gray (i
     +nterior) and yellow (edge), center-point grid in pink (original) a
     +nd green (re-computed).',.01,0.,0.)
C
          CALL PLCHHQ (CFUX(.5),CFUY(.015),'Try zooming in on the actual
     + North Pole (using "idt") to see problem area.',.01,0.,0.)
C
C Advance the frame.
C
          CALL FRAME
C
C Print elapsed time.
C
C         IF (ITIM.NE.0) THEN
C           PRINT * , 'AFTER PLOTTING POP GRID:'
C           IF (DTIME(TIME).GE.0.) THEN
C             PRINT * , '  USER TIME:  ',TIME(1)
C             PRINT * , '  SYSTEM TIME:',TIME(2)
C           ELSE
C             PRINT * , '  ERROR IN DTIME'
C           END IF
C         END IF
C
        END IF
C
C I N I T I A L I Z E   C O N P A C K
C - - - - - - - - - -   - - - - - - -
C
C Initialize CONPACK for the contour plot, the fill area plot, the cell
C array plot, and/or the POP-grid-cell-fill plot.
C
        IF (ICON.NE.0.OR.IFIL.NE.0.OR.ICEL.NE.0.OR.IPGC.NE.0) THEN
C
C Tell CONPACK not to do its own call to SET.
C
          CALL CPSETI ('SET - DO-SET-CALL FLAG',0)
C
C Tell CONPACK which mapping to use and what the "out-of-range" value
C is for that mapping.
C
          CALL CPSETI ('MAP - MAPPING FLAG',3)
          CALL CPSETR ('ORV - OUT-OF-RANGE VALUE',1.E12)
C
C Tell CONPACK to use DASHPACK.
C
          CALL CPSETI ('DPU - DASH PATTERN USE FLAG',-3)
C
C Tell CONPACK to use about 40 contour levels.
C
          CALL CPSETI ('CLS - CONTOUR LEVEL SELECTION',40)
C
C Tell CONPACK what real number to consider the "special value".
C
          CALL CPSETR ('SPV',-99.)
C
C Tell CONPACK to draw the boundary of the grid, in blue.
C
          CALL CPSETI ('PAI',-1)
          CALL CPSETI ('CLU',1)
          CALL CPSETI ('CLC',7)
C
C Tell CONPACK to draw the boundary of "special value" areas, in red.
C
          CALL CPSETI ('PAI',-2)
          CALL CPSETI ('CLU',1)
          CALL CPSETI ('CLC',4)
C
C Initialize CONPACK, telling it where the data array and the two work
C arrays are.
C
          CALL CPRECT (ZDAT,101,101,116,RWRK,LRWK,IWRK,LIWK)
C
C Force CONPACK to pick a set of contour values.
C
          CALL CPPKCL (ZDAT,RWRK,IWRK)
C
C Print elapsed time.
C
C         IF (ITIM.NE.0) THEN
C           PRINT * , 'AFTER CONPACK INITIALIZATION:'
C           IF (DTIME(TIME).GE.0.) THEN
C             PRINT * , '  USER TIME:  ',TIME(1)
C             PRINT * , '  SYSTEM TIME:',TIME(2)
C           ELSE
C             PRINT * , '  ERROR IN DTIME'
C           END IF
C         END IF
C
        END IF
C
C P L O T   T E M P E R A T U R E   C O N T O U R S
C - - - -   - - - - - - - - - - -   - - - - - - - -
C
C Plot contours, but only if a flag is set.
C
        IF (ICON.NE.0) THEN
C
C Reset the polyline color index to white.
C
          CALL SFLUSH
          CALL GSPLCI (1)
C
C Draw the simple EZMAP background again.
C
          CALL SFLUSH
          CALL GSPLCI (1)
C
          CALL MAPDRW
C
C Reset the polyline color index to yellow.
C
          CALL SFLUSH
          CALL GSPLCI (5)
C
C Draw the contour lines.
C
          CALL CPCLDR (ZDAT,RWRK,IWRK)
C
C Label the plot.
C
          CALL PLCHHQ (CFUX(.5),CFUY(.975),'TEMPERATURE CONTOURS',
     +                                                       .018,0.,0.)
C
          CALL PLCHHQ (CFUX(.5),CFUY(.025),'Contours are yellow, the edg
     +e of the grid is blue, and the edges of special-value areas are re
     +d.',.01,0.,0.)
C
C Advance the frame.
C
          CALL FRAME
C
C Print elapsed time.
C
C         IF (ITIM.NE.0) THEN
C           PRINT * , 'AFTER CONTOUR PLOT:'
C           IF (DTIME(TIME).GE.0.) THEN
C             PRINT * , '  USER TIME:  ',TIME(1)
C             PRINT * , '  SYSTEM TIME:',TIME(2)
C           ELSE
C             PRINT * , '  ERROR IN DTIME'
C           END IF
C         END IF
C
        END IF
C
C D O   F U R T H E R   C O N P A C K   I N I T I A L I Z A T I O N
C - -   - - - - - - -   - - - - - - -   - - - - - - - - - - - - - -
C
C Do initialization required for the fill area and/or cell array and/or
C POP-grid-cell-fill plots.
C
        IF (IFIL.NE.0.OR.ICEL.NE.0.OR.IPGC.NE.0) THEN
C
C Find out how many contour levels CONPACK chose to use, which tells us
C how many color indices need to be defined for a color-filled contour
C plot.
C
          CALL CPGETI ('NCL - NUMBER OF CONTOUR LEVELS',NOCL)
C
C Tell CONPACK what color index to use for areas outside the grid.
C
          CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',-1)
          CALL CPSETI ('AIA - AREA IDENTIFIER ABOVE',NOCL+2)
C
C Tell CONPACK what color index to use for special-value areas.
C
          CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',-2)
          CALL CPSETI ('AIA - AREA IDENTIFIER ABOVE',NOCL+3)
C
C Tell CONPACK what color index to use for "out-of-range" areas.
C
          CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',-3)
          CALL CPSETI ('AIA - AREA IDENTIFIER ABOVE',NOCL+4)
C
C Tell CONPACK the bias to use for color indices in the cell array.
C
          CALL CPSETI ('CAF - CELL ARRAY FLAG',101)
C
C Define the color indices.
C
          DO 130 ICIN=101,101+NOCL+4
            IF      (ICIN.EQ.101) THEN
C             color for ambiguously-specified areas:
              CALL GSCR (IWKID,ICIN,0.,1.,1.)
            ELSE IF (ICIN.LE.101+NOCL+1) THEN
              RR=REAL(ICIN-102)/REAL(NOCL)
              GG=0.
              BB=1.-RR
C             colors for bands 1 to NOCL+1:
              CALL GSCR (IWKID,ICIN,RR,GG,BB)
            ELSE IF (ICIN.EQ.101+NOCL+2) THEN
C             color for areas outside the bounds of the grid:
              CALL GSCR (IWKID,ICIN,.2,.5,.2)
            ELSE IF (ICIN.EQ.101+NOCL+3) THEN
C             color for special-value areas:
              CALL GSCR (IWKID,ICIN,.5,.5,.5)
            ELSE IF (ICIN.EQ.101+NOCL+4) THEN
C             color for out-of-range areas:
              CALL GSCR (IWKID,ICIN,.2,.2,.2)
            END IF
  130     CONTINUE
C
C Print elapsed time.
C
C         IF (ITIM.NE.0) THEN
C           PRINT * , 'AFTER FURTHER CONPACK INITIALIZATION:'
C           IF (DTIME(TIME).GE.0.) THEN
C             PRINT * , '  USER TIME:  ',TIME(1)
C             PRINT * , '  SYSTEM TIME:',TIME(2)
C           ELSE
C             PRINT * , '  ERROR IN DTIME'
C           END IF
C         END IF
C
        END IF
C
C D O   C O N T O U R   B A N D S   U S I N G   F I L L   A R E A S
C - -   - - - - - - -   - - - - -   - - - - -   - - - -   - - - - -
C
C Do the fill area plot, but only if a flag is set.
C
        IF (IFIL.NE.0) THEN
C
C Turn on debug plots from AREAS and tweak the appearance a little.
C
C         CALL ARSETI ('DB',   -1)
C
C         CALL ARSETI ('DC',  200)
C
C         CALL ARSETR ('AL',.0020)
C         CALL ARSETR ('AW',.0005)
C         CALL ARSETR ('ID',.0010)
C         CALL ARSETR ('IS',.0005)
C
C Initialize the area map.
C
          CALL ARINAM (IAMA,LAMA)
C
C Put contour lines into the area map.
C
          CALL CPCLAM (ZDAT,RWRK,IWRK,IAMA)
C
C Write the contents of the area map to unit 11.
C
C         CALL ARDAMN (IAMA,11)
C
C Color the map.
C
          CALL ARSCAM (IAMA,XCRD,YCRD,NCRD,IAIA,IGIA,2,COLRAM)
C
C Draw the EZMAP map on top of the filled area map.
C
          CALL MAPDRW
C
C Label the plot.
C
          CALL PLCHHQ (CFUX(.5),CFUY(.975),
     +                   'TEMPERATURE BANDS (USING FILL AREAS)',
     +                                                       .018,0.,0.)
C
C Advance the frame.
C
          CALL FRAME
C
C Print elapsed time.
C
C         IF (ITIM.NE.0) THEN
C           PRINT * , 'AFTER FILL AREA PLOT:'
C           IF (DTIME(TIME).GE.0.) THEN
C             PRINT * , '  USER TIME:  ',TIME(1)
C             PRINT * , '  SYSTEM TIME:',TIME(2)
C           ELSE
C             PRINT * , '  ERROR IN DTIME'
C           END IF
C           PRINT * , '  AREA MAP SPACE: ',IAMA(1)-(IAMA(6)-IAMA(5)-1)
C         END IF
C
        END IF
C
C D O   C O N T O U R   B A N D S   U S I N G   A   C E L L   A R R A Y
C - -   - - - - - - -   - - - - -   - - - - -   -   - - - -   - - - - -
C
C Do the cell array plot, but only if a flag is set.
C
        IF (ICEL.NE.0) THEN
C
C Generate a cell array.
C
          FCCL=.05
          FCCR=.95
          FCCB=.05
          FCCT=.95
C
          CALL CPCICA (ZDAT,RWRK,IWRK,ICRA,MCRA,MCRA,NCRA,
     +                                              FCCL,FCCB,FCCR,FCCT)
C
C Display the cell array.
C
          CALL GCA (CFUX(FCCL),CFUY(FCCB),CFUX(FCCR),CFUY(FCCT),
     +                                     MCRA,NCRA,1,1,MCRA,NCRA,ICRA)
C
C Draw the EZMAP map on top of the cell array.
C
          CALL MAPDRW
C
C Label the plot.
C
          CALL PLCHHQ (CFUX(.5),CFUY(.975),
     +                   'TEMPERATURE BANDS (USING A CELL ARRAY)',
     +                                                       .018,0.,0.)
C
C Advance the frame.
C
          CALL FRAME
C
C Print elapsed time.
C
C         IF (ITIM.NE.0) THEN
C           PRINT * , 'AFTER CELL ARRAY PLOT:'
C           IF (DTIME(TIME).GE.0.) THEN
C             PRINT * , '  USER TIME:  ',TIME(1)
C             PRINT * , '  SYSTEM TIME:',TIME(2)
C           ELSE
C             PRINT * , '  ERROR IN DTIME'
C           END IF
C         END IF
C
        END IF
C
C F I L L   P O P   G R I D   C E L L S
C - - - -   - - -   - - - -   - - - - -
C
C Do the POP-grid-cell-fill plot, but only if a flag is set.
C
        IF (IPGC.NE.0) THEN
C
C Retrieve contour levels and associated area identifiers.
C
        DO 131 I=1,NOCL
          CALL CPSETI ('PAI',I)
          CALL CPGETR ('CLV',CLEV(I))
          CALL CPGETI ('AIA',KAIA(I))
          CALL CPGETI ('AIB',KAIB(I))
  131   CONTINUE
C
C Step through the cells defined by the corner-point positions of the
C POP grid, filling each one in the color implied by the temperature
C at the center of the cell.
C
        DO 133 I=1,100
          IP1=MOD(I,100)+1
          DO 132 J=1,115
            NPTS=0
            CALL MAPTRA (ULAT(I,J),ULON(I,J),XVAL,YVAL)
            IF (XVAL.NE.1.E12) THEN
              NPTS=NPTS+1
              XCRD(NPTS)=XVAL
              YCRD(NPTS)=YVAL
            END IF
            CALL MAPTRA (ULAT(IP1,J),ULON(IP1,J),XVAL,YVAL)
            IF (XVAL.NE.1.E12) THEN
              NPTS=NPTS+1
              XCRD(NPTS)=XVAL
              YCRD(NPTS)=YVAL
            END IF
            CALL MAPTRA (ULAT(IP1,J+1),ULON(IP1,J+1),XVAL,YVAL)
            IF (XVAL.NE.1.E12) THEN
              NPTS=NPTS+1
              XCRD(NPTS)=XVAL
              YCRD(NPTS)=YVAL
            END IF
            CALL MAPTRA (ULAT(I,J+1),ULON(I,J+1),XVAL,YVAL)
            IF (XVAL.NE.1.E12) THEN
              NPTS=NPTS+1
              XCRD(NPTS)=XVAL
              YCRD(NPTS)=YVAL
            END IF
            IF (NPTS.GT.2) THEN
              IF (TEMP(IP1,J+1).NE.-99.) THEN
                CALL GETAID (TEMP(IP1,J+1),IAID,NOCL,CLEV,KAIA,KAIB)
              ELSE
                IAID=NOCL+3
              END IF
              CALL GSFACI (101+IAID)
              CALL GFA    (NPTS,XCRD,YCRD)
            END IF
  132     CONTINUE
  133   CONTINUE
C
C Draw the EZMAP map on top of the plot.
C
          CALL MAPDRW
C
C Label the plot.
C
          CALL PLCHHQ (CFUX(.5),CFUY(.975),
     +                   'FILLED POP GRID CELLS',.018,0.,0.)
C
C Advance the frame.
C
          CALL FRAME
C
C Print elapsed time.
C
C         IF (ITIM.NE.0) THEN
C           PRINT * , 'AFTER FILLING POP GRID CELLS:'
C           IF (DTIME(TIME).GE.0.) THEN
C             PRINT * , '  USER TIME:  ',TIME(1)
C             PRINT * , '  SYSTEM TIME:',TIME(2)
C           ELSE
C             PRINT * , '  ERROR IN DTIME'
C           END IF
C         END IF
C
        END IF
C
C C L O S E   G K S   A N D   Q U I T
C - - - - -   - - -   - - -   - - - -
C
C Close GKS.
C
        CALL GDAWK (IWKID)
        CALL GCLWK (IWKID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END


      SUBROUTINE GETTRN (TST1,TST2,TST3)
C
C This subroutine generates and returns the three real numbers 1,
C 1+1E-10, and 1+2E-10.  On a machine with 64-bit arithmetic, all
C three of these numbers will be different from each other, while,
C on machines with 32-bit arithmetic, two or more of them will be
C equal.  Thus, we can use these numbers to determine whether we
C should use single-precision or double-precision arithmetic.
C
        TST1=1.
        TST2=TST1+1.E-10
        TST3=TST2+1.E-10
C
        RETURN
C
      END


      SUBROUTINE CPMPXY (IMAP,XINP,YINP,XOUT,YOUT)
C
C This version of CPMPXY implements what has sometimes, in the past,
C been called a "parameterized distortion", but it does it on the
C surface of the globe and then maps the globe as determined by the
C current state of EZMAP.  If IMAP has the value 3, then, for given
C input values of XINP and YINP, where XINP lies in the interval
C [1,IDIM] and YINP lies in the interval [1,JDIM], CPMPXY generates
C output values of XOUT and YOUT, representing the transformed position
C of a point on an IDIMxJDIM grid on the surface of the globe.  If IMAP
C has the value -3, CPMPXY performs the inverse transformation.
C
C For each (I,J), where 1.LE.I.LE.IDIM, and 1.LE.J.LE.JDIM, one of the
C vectors (XQSP(K,I,J),K=1,4) and (XQDP(K,I,J),K=1,4) is a 4-element
C vector containing the cosine of the latitude, the sine of the
C latitude, the cosine of the longitude, and the sine of the longitude
C of a point of the grid.  If ISOD is 0, the calling program must have
C set the values in XQSP; otherwise, it must have set the values in
C XQDP.  IBEG, IEND, JBEG, and JEND keep track of which box the last
C point inverse-transformed turned out to be in.  The calling routine
C is responsible for initializing all these values properly.
C
        PARAMETER (IDIM=101,JDIM=116,IDM1=IDIM-1,JDM1=JDIM-1)
C
        COMMON /TESTCM/ XQSP(4,IDIM,JDIM),XQDP(4,IDIM,JDIM),ISOD,
     +                  IBEG,IEND,JBEG,JEND
          DOUBLE PRECISION XQDP
        SAVE   /TESTCM/
C
C Declare arrays needed to pass information to the routines ICEGSP and
C ICEGDP.
C
        DIMENSION        RQSP(4)
        DOUBLE PRECISION RQDP(4)
C
C Declare some other double-precision variables needed.
C
        DOUBLE PRECISION DRDP,RDDP,DLAT,DLON,XODP,YODP,XFDP,YFDP
C
C Define single-precision and double-precision multiplicative constants
C to convert from degrees to radians and vice-versa.
C
        DATA DRSP / .017453292519943 /
        DATA RDSP / 57.2957795130823 /
C
        DATA DRDP / .017453292519943D0 /
        DATA RDDP / 57.2957795130823D0 /
C
C Do it.  If IMAP = 0, the caller wants information about the mapping
C specified by INT(XINP).  Returning YINP = 3 says that both forward
C and inverse mappings are implemented, while returning YINP = 0 says
C that neither is, and returning YINP = 1 says that only the forward
C mapping is implemented.
C
        IF (IMAP.EQ.0) THEN
C
          IF (INT(XINP).EQ.3) THEN
            YINP=3.
          ELSE
            YINP=0.
          END IF
C
C If IMAP = 3, a forward "parameterized distortion" is requested.  The
C input value XINP is expected to be in the range [1,101] and the input
C value YINP is expected to be in the range [1,116].  The values of XOUT
C and YOUT returned are coordinates of a point on a map of the globe, as
C defined by the current state of EZMAP.
C
        ELSE IF (IMAP.EQ.3) THEN
C
C IGRD and JGRD are the indices of the lower left corner of the grid
C box in which the input point falls.
C
          IGRD=MAX(1,MIN(IDM1,INT(XINP)))
          JGRD=MAX(1,MIN(JDM1,INT(YINP)))
C
C Interpolate in the grid box to find the desired point, get its
C latitude and longitude, and call the EZMAP transformation routine
C to project the point to the U/V plane.
C
          IF (ISOD.EQ.0) THEN
C
            CALL IPIQSP (XQSP(1,IGRD  ,JGRD  ),XQSP(1,IGRD+1,JGRD  ),
     +                   XQSP(1,IGRD  ,JGRD+1),XQSP(1,IGRD+1,JGRD+1),
     +                   XINP-REAL(IGRD),YINP-REAL(JGRD),RQSP)
C
            RLAT=RDSP*ASIN(RQSP(2))
C
            IF (RQSP(3).NE.0..OR.RQSP(4).NE.0.) THEN
              RLON=RDSP*ATAN2(RQSP(4),RQSP(3))
            ELSE
              RLON=0.
            END IF
C
            CALL MAPTRA (RLAT,RLON,XOUT,YOUT)
C
          ELSE
C
            CALL IPIQDP (XQDP(1,IGRD  ,JGRD  ),XQDP(1,IGRD+1,JGRD  ),
     +                   XQDP(1,IGRD  ,JGRD+1),XQDP(1,IGRD+1,JGRD+1),
     +                   DBLE(XINP)-DBLE(IGRD),DBLE(YINP)-DBLE(JGRD),
     +                                                          RQDP)
C
            DLAT=RDDP*ASIN(RQDP(2))
C
            IF (RQDP(3).NE.0.D0.OR.RQDP(4).NE.0.D0) THEN
              DLON=RDDP*ATAN2(RQDP(4),RQDP(3))
            ELSE
              DLON=0.D0
            END IF
C
            CALL MDPTRA (DLAT,DLON,XODP,YODP)
C
            IF (XODP.NE.1.D12) THEN
              XOUT=REAL(XODP)
              YOUT=REAL(YODP)
            ELSE
              XOUT=1.E12
              YOUT=1.E12
            END IF
C
          END IF
C
C If IMAP = -3, the inverse of a "parameterized distortion" is desired,
C which is rather more difficult.  XINP and YINP are the coordinates of
C a point on the map and the values of XOUT and YOUT returned are the
C coordinates of a point on the grid.
C
        ELSE IF (IMAP.EQ.-3) THEN
C
C Use either single-precision or double-precision code.
C
          IF (ISOD.EQ.0) THEN
C
C First, call EZMAP to get the latitude and longitude of the inverse of
C the specified point.
C
            CALL MAPTRI (XINP,YINP,RLAT,RLON)
C
C If the area is not in a defined area of the EZMAP projection, return
C the "out-of-range" value.
C
            IF (RLAT.EQ.1.E12) THEN
C
              XOUT=1.E12
              YOUT=1.E12
C
C Otherwise ...
C
            ELSE
C
C ... compute quantities needed for tests below.
C
              RQSP(1)=COS(DRSP*RLAT)
              RQSP(2)=SIN(DRSP*RLAT)
              RQSP(3)=COS(DRSP*RLON)
              RQSP(4)=SIN(DRSP*RLON)
C
C Check a little area around the last box used (in hopes of quickly
C finding the correct box often enough so as to speed the process up).
C
              IF (IEND-IBEG.EQ.1.AND.JEND-JBEG.EQ.1) THEN
C
C Jump if in same box:
C
                ICSP=ICEGSP(RQSP,XQSP,IDIM,JDIM,IBEG,IEND,JBEG,JEND)
                IF (ICSP.EQ.0) GO TO 103
C
C Jump if in adjacent box:
C
                IBEG=MAX(   1,IBEG-1)
                IEND=MIN(IDIM,IEND+1)
                JBEG=MAX(   1,JBEG-1)
                JEND=MIN(JDIM,JEND+1)
                ICSP=ICEGSP(RQSP,XQSP,IDIM,JDIM,IBEG,IEND,JBEG,JEND)
                IF (ICSP.EQ.0) GO TO 103
C
C Jump if in near-by box:
C
                IBEG=MAX(   1,IBEG-1)
                IEND=MIN(IDIM,IEND+1)
                JBEG=MAX(   1,JBEG-1)
                JEND=MIN(JDIM,JEND+1)
                ICSP=ICEGSP(RQSP,XQSP,IDIM,JDIM,IBEG,IEND,JBEG,JEND)
                IF (ICSP.EQ.0) GO TO 103
C
              END IF
C
C If that didn't work, look for a smaller piece of the grid containing
C the point we want.  (Starting with the entire grid is problematical
C because of the way ICEGSP works.)
C
              IEND=1
C
              DO 102 I=1,3
                IBEG=IEND
                IEND=I*IDIM/3
                JEND=1
                DO 101 J=1,3
                  JBEG=JEND
                  JEND=J*JDIM/3
                  ICSP=ICEGSP(RQSP,XQSP,IDIM,JDIM,IBEG,IEND,JBEG,JEND)
                  IF (ICSP.EQ.0) GO TO 103
  101           CONTINUE
  102         CONTINUE
C
C Point was not in any piece of the grid, so treat it as outside the
C grid.
C
              XOUT=0.
              YOUT=0.
C
              GO TO 107
C
C Now, find out what particular grid cell contains the point.
C
  103         IF (IEND-IBEG.GE.JEND-JBEG) THEN
                IF (IEND-IBEG.EQ.1) THEN
                  CALL FPIQSP (XQSP(1,IBEG,JBEG),XQSP(1,IEND,JBEG),
     +                         XQSP(1,IBEG,JEND),XQSP(1,IEND,JEND),
     +                         RQSP,XFSP,YFSP)
                  IF (XFSP.LT.0.) THEN
                    XOUT=0.
                    YOUT=0.
                  ELSE
                    XOUT=REAL(IBEG)+XFSP
                    YOUT=REAL(JBEG)+YFSP
                  END IF
                  GO TO 107
                END IF
                IMID=(IBEG+IEND)/2
                ICSP=ICEGSP(RQSP,XQSP,IDIM,JDIM,IBEG,IMID,JBEG,JEND)
                IF (ICSP.NE.0) THEN
                  IBEG=IMID
                ELSE
                  IEND=IMID
                END IF
              ELSE
                JMID=(JBEG+JEND)/2
                ICSP=ICEGSP(RQSP,XQSP,IDIM,JDIM,IBEG,IEND,JBEG,JMID)
                IF (ICSP.NE.0) THEN
                  JBEG=JMID
                ELSE
                  JEND=JMID
                END IF
              END IF
C
C The following code may be uncommented to check for the following
C pathological situation: A point is found to be in a particular
C portion of the grid, but not in either "half" of that portion.
C (I have not yet seen this happen with this version of the code,
C that deals with the globe, but I did see it happen with a version
C in the plane.)
C
C*            ICSP=ICEGSP(RQSP,XQSP,IDIM,JDIM,IBEG,IEND,JBEG,JEND)
C*            IF (ICSP.NE.0) THEN
C*              PRINT * , 'ALGORITHM FAILURE'
C*              PRINT * , 'IBEG,IEND,JBEG,JEND,ICSP = ',
C*   +                     IBEG,IEND,JBEG,JEND,ICSP
C*              XOUT=0.
C*              YOUT=0.
C*              GO TO 107
C*            END IF
C
              GO TO 103
C
            END IF
C
          ELSE
C
C First, call EZMAP to get the latitude and longitude of the inverse of
C the specified point.
C
            CALL MDPTRI (DBLE(XINP),DBLE(YINP),DLAT,DLON)
C
C If the area is not in a defined area of the EZMAP projection, return
C the "out-of-range" value.
C
            IF (DLAT.EQ.1.D12) THEN
C
              XOUT=1.E12
              YOUT=1.E12
C
C Otherwise ...
C
            ELSE
C
C ... compute quantities needed for tests below.
C
              RQDP(1)=COS(DRDP*DLAT)
              RQDP(2)=SIN(DRDP*DLAT)
              RQDP(3)=COS(DRDP*DLON)
              RQDP(4)=SIN(DRDP*DLON)
C
C Check a little area around the last box used (in hopes of quickly
C finding the correct box often enough so as to speed the process up).
C
              IF (IEND-IBEG.EQ.1.AND.JEND-JBEG.EQ.1) THEN
                ICDP=ICEGDP(RQDP,XQDP,IDIM,JDIM,IBEG,IEND,JBEG,JEND)
                IF (ICDP.EQ.0) GO TO 106  !  Same box.
                IBEG=MAX(   1,IBEG-1)
                IEND=MIN(IDIM,IEND+1)
                JBEG=MAX(   1,JBEG-1)
                JEND=MIN(JDIM,JEND+1)
                ICDP=ICEGDP(RQDP,XQDP,IDIM,JDIM,IBEG,IEND,JBEG,JEND)
                IF (ICDP.EQ.0) GO TO 106  !  Adjacent box.
                IBEG=MAX(   1,IBEG-1)
                IEND=MIN(IDIM,IEND+1)
                JBEG=MAX(   1,JBEG-1)
                JEND=MIN(JDIM,JEND+1)
                ICDP=ICEGDP(RQDP,XQDP,IDIM,JDIM,IBEG,IEND,JBEG,JEND)
                IF (ICDP.EQ.0) GO TO 106  !  Near-by box.
              END IF
C
C If that didn't work, look for a smaller piece of the grid containing
C the point we want.  (Starting with the entire grid is problematical
C because of the way ICEGDP works.)
C
              IEND=1
C
              DO 105 I=1,3
                IBEG=IEND
                IEND=I*IDIM/3
                JEND=1
                DO 104 J=1,3
                  JBEG=JEND
                  JEND=J*JDIM/3
                  ICDP=ICEGDP(RQDP,XQDP,IDIM,JDIM,IBEG,IEND,JBEG,JEND)
                  IF (ICDP.EQ.0) GO TO 106  !  Box (I,J).
  104           CONTINUE
  105         CONTINUE
C
C Point was not in any piece of the grid, so treat it as outside the
C grid.
C
              XOUT=0.
              YOUT=0.
C
              GO TO 107
C
C Now, find out what particular grid cell contains the point.
C
  106         IF (IEND-IBEG.GE.JEND-JBEG) THEN
                IF (IEND-IBEG.EQ.1) THEN
                  CALL FPIQDP (XQDP(1,IBEG,JBEG),XQDP(1,IEND,JBEG),
     +                         XQDP(1,IBEG,JEND),XQDP(1,IEND,JEND),
     +                         RQDP,XFDP,YFDP)
                  IF (XFDP.LT.0.D0) THEN
                    XOUT=0.
                    YOUT=0.
                  ELSE
                    XOUT=REAL(IBEG)+REAL(XFDP)
                    YOUT=REAL(JBEG)+REAL(YFDP)
                  END IF
                  GO TO 107
                END IF
                IMID=(IBEG+IEND)/2
                ICDP=ICEGDP(RQDP,XQDP,IDIM,JDIM,IBEG,IMID,JBEG,JEND)
                IF (ICDP.NE.0) THEN
                  IBEG=IMID
                ELSE
                  IEND=IMID
                END IF
              ELSE
                JMID=(JBEG+JEND)/2
                ICDP=ICEGDP(RQDP,XQDP,IDIM,JDIM,IBEG,IEND,JBEG,JMID)
                IF (ICDP.NE.0) THEN
                  JBEG=JMID
                ELSE
                  JEND=JMID
                END IF
              END IF
C
C The following code may be uncommented to check for the following
C pathological situation: A point is found to be in a particular
C portion of the grid, but not in either "half" of that portion.
C (I have not yet seen this happen with this version of the code,
C that deals with the globe, but I did see it happen with a version
C in the plane.)
C
C*            ICDP=ICEGDP(RQDP,XQDP,IDIM,JDIM,IBEG,IEND,JBEG,JEND)
C*            IF (ICDP.NE.0) THEN
C*              PRINT * , 'ALGORITHM FAILURE'
C*              PRINT * , 'IBEG,IEND,JBEG,JEND,ICDP = ',
C*   +                     IBEG,IEND,JBEG,JEND,ICDP
C*              XOUT=0.
C*              YOUT=0.
C*              GO TO 107
C*            END IF
C
              GO TO 106
C
            END IF
          END IF
C
C If IMAP is anything else, log an error.  If error recovery is on,
C control returns to the caller; otherwise, SETER terminates execution.
C
        ELSE
C
          CALL SETER ('CPMPXY - UNKNOWN MAPPING',5,1)
C
        END IF
C
C Done.
C
  107   RETURN
C
      END


      SUBROUTINE IPIQSP (AQSP,BQSP,CQSP,DQSP,XFRA,YFRA,EQSP)
C
C (IPIQSP = Interpolate Point In Quadrilateral, Single Precision)
C
        DIMENSION AQSP(4),BQSP(4),CQSP(4),DQSP(4),EQSP(4)
C
C This routine, given four points on the sphere (A, B, C, and D) forming
C a "quadrilateral" and two interpolation fractions (XFRA and YFRA, each
C between 0 and 1, inclusive), finds a point E defined by the following
C diagram and returns it.
C
C                              C------Q----D
C                              |      |    |
C                              |      E    |
C                              |      |    |
C                              |      |    |
C                              A------P----B
C
C P and Q are positioned such that AP/AB = CQ/CD = XFRA and then E is
C positioned such that PE/PQ = YFRA (where "XY" is interpreted to mean
C "the shortest great circle distance from X to Y").
C
C It is assumed that the "quadrilateral" ABDC is "convex" (a working
C definition of which might be that none of the four great circles
C defined by its edges - the ones through A and B, B and D, D and C,
C and C and A - cross it anywhere.  However, this is not verified.
C
C All variables with names of the form XQSP are four-element arrays
C containing the cosine and sine of the latitude and the cosine and
C sine of the longitude, in that order, of the point X.  Describing
C the point positions in this way makes this routine execute faster
C than if the latitudes and longitudes themselves are used.
C
        DIMENSION PQSP(4),QQSP(4)
C
C The code is easy:
C
        CALL IPGCSP (AQSP,BQSP,XFRA,PQSP)
        CALL IPGCSP (CQSP,DQSP,XFRA,QQSP)
        CALL IPGCSP (PQSP,QQSP,YFRA,EQSP)
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE FPIQSP (AQSP,BQSP,CQSP,DQSP,EQSP,XFRA,YFRA)
C
C (FPIQSP = Find Point In Quadrilateral, Single Precision)
C
        DIMENSION AQSP(4),BQSP(4),CQSP(4),DQSP(4),EQSP(4)
C
C This routine, given four points (A, B, C, and D) that form a
C "quadrilateral" on the surface of the globe, and a surface point
C (E) in its interior, returns the two interpolation fractions that
C one would use in a call to IPIQSP to get the point E.  See comments
C in IPIQSP; here's a duplicate of the diagram from that routine:
C
C                              C------Q----D
C                              |      |    |
C                              |      E    |
C                              |      |    |
C                              |      |    |
C                              A------P----B
C
C P and Q are positioned such that AP/AB = CQ/CD = XFRA and then E is
C positioned such that PE/PQ = YFRA (where "XY" is interpreted to mean
C "the shortest great circle distance from X to Y").
C
C All variables with names of the form XQSP are four-element arrays
C containing the cosine and sine of the latitude and the cosine and
C sine of the longitude, in that order, of the point X.  Describing
C the point positions in this way makes this routine execute faster
C than if the latitudes and longitudes themselves are used.
C
        DIMENSION PQSP(4),QQSP(4)
C
C We use a fast iterative technique to find XFRA.
C
        XFR1=0.
        DST1=DPGCSP(AQSP,CQSP,EQSP)
        XFR2=1.
        DST2=DPGCSP(BQSP,DQSP,EQSP)
        IF (DST1*DST2.GE.0.) THEN
          IF (ABS(DST1).LT.ABS(DST2)) THEN
            XFRA=0.
          ELSE
            XFRA=1.
          END IF
          CALL IPGCSP (AQSP,BQSP,XFRA,PQSP)
          CALL IPGCSP (CQSP,DQSP,XFRA,QQSP)
        ELSE
  101     XFRA=(DST2*XFR1-DST1*XFR2)/(DST2-DST1)
          CALL IPGCSP (AQSP,BQSP,XFRA,PQSP)
          CALL IPGCSP (CQSP,DQSP,XFRA,QQSP)
          IF (XFRA.LE.XFR1.OR.XFRA.GE.XFR2) GO TO 104
          DSTA=DPGCSP(PQSP,QQSP,EQSP)
          IF (DSTA.EQ.0.) GO TO 104
          IF (DST1*DSTA.GT.0.) THEN
            XFR1=XFRA
            DST1=DSTA
          ELSE
            XFR2=XFRA
            DST2=DSTA
          END IF
          IF (XFR2-XFR1.GT.1.E-6) GO TO 101
        END IF
C
C Computing YFRA is easier:
C
  104   TMP1=ADGCSP(PQSP,EQSP)
        TMP2=ADGCSP(PQSP,QQSP)
        IF (TMP2.NE.0.) THEN
          YFRA=TMP1/TMP2
        ELSE
          YFRA=0.
        END IF
C
C Normal exit.
C
        RETURN
C
      END


      SUBROUTINE IPGCSP (AQSP,BQSP,FRAC,CQSP)
C
C (IPGCSP = Interpolate Point on Great Circle, Single Precision)
C
        DIMENSION AQSP(4),BQSP(4),CQSP(4)
C
C This routine, given two points A and B on the surface of the globe and
C a fraction FRAC, between 0. and 1., interpolates a point C along the
C shortest great circle route joining A to B such that the distance from
C A to C, divided by the distance from A to B, is equal to FRAC.
C
C All variables with names of the form XQSP are four-element arrays
C containing the cosine and sine of the latitude and the cosine and
C sine of the longitude, in that order, of the point X.  Describing
C the point positions in this way makes this routine execute faster
C than if the latitudes and longitudes themselves are used.
C
C Code that is commented out either produces unneeded results or is
C superseded by code that executes faster.
C
C Get XYZ coordinates for B, rotate them by -ALON about the Z axis (which
C would put A on the prime meridian), and then rotate them by ALAT about
C the Y axis (which would put A on the equator).
C
C       XCB1=BQSP(1)*BQSP(3)
C       YCB1=BQSP(1)*BQSP(4)
C       ZCB1=BQSP(2)
C
C       XCB2=XCB1*AQSP(3)+YCB1*AQSP(4)
C       YCB2=YCB1*AQSP(3)-XCB1*AQSP(4)
C       ZCB2=ZCB1
C
        XCB2=BQSP(1)*BQSP(3)*AQSP(3)+BQSP(1)*BQSP(4)*AQSP(4)
        YCB2=BQSP(1)*BQSP(4)*AQSP(3)-BQSP(1)*BQSP(3)*AQSP(4)
        ZCB2=BQSP(2)
C
        XCB3=XCB2*AQSP(1)+ZCB2*AQSP(2)
        YCB3=YCB2
        ZCB3=ZCB2*AQSP(1)-XCB2*AQSP(2)
C
C Now, rotate about the X axis by the angle ALPH = -ATAN(ZCB3/YCB3),
C which leaves the position of A unchanged but carries B into a point
C in the XY plane.
C
        IF (YCB3.NE.0..OR.ZCB3.NE.0.) THEN
          DNOM=SQRT(YCB3*YCB3+ZCB3*ZCB3)
          CALP=YCB3/DNOM
          SALP=ZCB3/DNOM
        ELSE
          CALP=1.
          SALP=0.
        END IF
C
        XCB4=XCB3
        YCB4=YCB3*CALP+ZCB3*SALP
C       ZCB4=ZCB3*CALP-YCB3*SALP
C
C The angle BETA from A to B can now be computed easily.
C
        IF (XCB4.NE.0..OR.YCB4.NE.0.) THEN
          BETA=ATAN2(YCB4,XCB4)
        ELSE
          BETA=0.
        END IF
C
C Interpolate a point C at the desired position between the points A and
C B and map it back to its original position on the great circle route
C from A to B.
C
C       GAMA=FRAC*BETA
C
C       XCC1=COS(GAMA)
C       YCC1=SIN(GAMA)
C       ZCC1=0.
C
C       XCC2=XCC1
C       YCC2=YCC1*CALP-ZCC1*SALP
C       ZCC2=ZCC1*CALP+YCC1*SALP
C
        XCC2=COS(FRAC*BETA)
        YCC2=SIN(FRAC*BETA)*CALP
        ZCC2=SIN(FRAC*BETA)*SALP
C
        XCC3=XCC2*AQSP(1)-ZCC2*AQSP(2)
        YCC3=YCC2
        ZCC3=ZCC2*AQSP(1)+XCC2*AQSP(2)
C
        XCC4=XCC3*AQSP(3)-YCC3*AQSP(4)
        YCC4=YCC3*AQSP(3)+XCC3*AQSP(4)
        ZCC4=ZCC3
C
        CQSP(1)=SQRT(XCC4*XCC4+YCC4*YCC4)
        CQSP(2)=ZCC4
        CQSP(3)=XCC4/CQSP(1)
        CQSP(4)=YCC4/CQSP(1)
C
C Done.
C
        RETURN
C
      END


      FUNCTION ACEGSP (PQSP,QQSP,IDIM,JDIM,IBEG,IEND,JBEG,JEND)
C
C (ACEGSP = Angular Change along Edge of Grid, Single Precision)
C
        DIMENSION PQSP(4),QQSP(4,IDIM,JDIM)
C
C The value of this function is the total angle swept out by a vector
C tangent to the sphere at the point P and pointing in the direction of
C the shortest great circle route to a point tracing Q, the outer edge
C of a "grid" defined by the points (QQSP(I,J)), for I from IBEG to IEND
C and J from JBEG to JEND.  (The edge of the grid is formed of shortest
C great circle routes from point to point.)
C
C The outer edge of the grid divides the surface of the sphere into two
C areas - one to the left, and one to the right, of Q.  Let P' denote
C the point opposite P on the sphere.  Note that P' = (-PLAT,PLON+180).
C In theory (ignoring computational inaccuracies), the function can only
C have three possible values: +360, if P is to the left of Q and P' is
C to the right of Q; -360, if P is to the right of Q and P' is to the
C left of Q; and zero, if both P and P' are on the same side of Q (left
C or right, but we don't know which).
C
C All variables with names of the form XQSP are four-element arrays
C containing the cosine and sine of the latitude and the cosine and
C sine of the longitude, in that order, of the point X.  Describing
C the point positions in this way makes this routine execute faster
C than if the latitudes and longitudes themselves are used.
C
        ANCH=0.
C
C "Bottom" edge:
C
        DO 101 I=IBEG,IEND-1
          ANCH=ANCH+ABGCSP(PQSP,QQSP(1,I,JBEG),QQSP(1,I+1,JBEG))
  101   CONTINUE
C
C "Right" edge:
C
        DO 102 J=JBEG,JEND-1
          ANCH=ANCH+ABGCSP(PQSP,QQSP(1,IEND,J),QQSP(1,IEND,J+1))
  102   CONTINUE
C
C "Top" edge:
C
        DO 103 I=IEND,IBEG+1,-1
          ANCH=ANCH+ABGCSP(PQSP,QQSP(1,I,JEND),QQSP(1,I-1,JEND))
  103   CONTINUE
C
C "Left" edge:
C
        DO 104 J=JEND,JBEG+1,-1
          ANCH=ANCH+ABGCSP(PQSP,QQSP(1,IBEG,J),QQSP(1,IBEG,J-1))
  104   CONTINUE
C
C Set the function value.
C
        ACEGSP=ANCH
C
C Done.
C
        RETURN
C
      END


      FUNCTION ABGCSP (AQSP,BQSP,CQSP)
C
C (ABGCSP = Angle Between Great Circles, Single Precision)
C
        DIMENSION AQSP(4),BQSP(4),CQSP(4)
C
C This function, given information about the points A, B, and C on the
C sphere, returns the angle, in degrees, from the great circle through
C A and B to the great circle through A and C, positive if the point C
C is in the hemisphere to the "left" of the great circle through A and
C B, negative otherwise.
C
C All variables with names of the form XQSP are four-element arrays
C containing the cosine and sine of the latitude and the cosine and
C sine of the longitude, in that order, of the point X.  Describing
C the point positions in this way makes this routine execute faster
C than if the latitudes and longitudes themselves are used.
C
C Code that is commented out either produces unneeded results or is
C superseded by code that executes faster.
C
C Define a multiplicative constant to convert from radians to degrees.
C
        DATA RTOD / 57.2957795130823 /
C
C Get XYZ coordinates for B, rotate them by -ALON about the Z axis (which
C would put A on the prime meridian), and then rotate them by ALAT about
C the Y axis (which would put A on the equator).
C
C       XCB1=BQSP(1)*BQSP(3)
C       YCB1=BQSP(1)*BQSP(4)
C       ZCB1=BQSP(2)
C
C       XCB2=XCB1*AQSP(3)+YCB1*AQSP(4)
C       YCB2=YCB1*AQSP(3)-XCB1*AQSP(4)
C       ZCB2=ZCB1
C
        XCB2=BQSP(1)*BQSP(3)*AQSP(3)+BQSP(1)*BQSP(4)*AQSP(4)
        YCB2=BQSP(1)*BQSP(4)*AQSP(3)-BQSP(1)*BQSP(3)*AQSP(4)
        ZCB2=BQSP(2)
C
C       XCB3=XCB2*AQSP(1)+ZCB2*AQSP(2)
        YCB3=YCB2
        ZCB3=ZCB2*AQSP(1)-XCB2*AQSP(2)
C
C Do the same for the point C.
C
C       XCC1=CQSP(1)*CQSP(3)
C       YCC1=CQSP(1)*CQSP(4)
C       ZCC1=CQSP(2)
C
C       XCC2=XCC1*AQSP(3)+YCC1*AQSP(4)
C       YCC2=YCC1*AQSP(3)-XCC1*AQSP(4)
C       ZCC2=ZCC1
C
        XCC2=CQSP(1)*CQSP(3)*AQSP(3)+CQSP(1)*CQSP(4)*AQSP(4)
        YCC2=CQSP(1)*CQSP(4)*AQSP(3)-CQSP(1)*CQSP(3)*AQSP(4)
        ZCC2=CQSP(2)
C
C       XCC3=XCC2*AQSP(1)+ZCC2*AQSP(2)
        YCC3=YCC2
        ZCC3=ZCC2*AQSP(1)-XCC2*AQSP(2)
C
C Now, rotate C about the X axis by an amount which would put B on the
C equator.
C
        IF (YCB3.NE.0.OR.ZCB3.NE.0.) THEN
          DNOM=SQRT(YCB3*YCB3+ZCB3*ZCB3)
          CANG=YCB3/DNOM
          SANG=ZCB3/DNOM
        ELSE
          CANG=1.
          SANG=0.
        END IF
C
C       XCC4=XCC3
        YCC4=YCC3*CANG+ZCC3*SANG
        ZCC4=ZCC3*CANG-YCC3*SANG
C
C The angle between the great circles is now easily computed.
C
        IF (YCC4.NE.0..OR.ZCC4.NE.0.) THEN
          ABGCSP=RTOD*ATAN2(ZCC4,YCC4)
        ELSE
          ABGCSP=0.
        END IF
C
C Done.
C
        RETURN
C
      END


      FUNCTION DPGCSP (AQSP,BQSP,CQSP)
C
C (DPGCSP = Distance of Point from Great Circle, Single Precision)
C
        DIMENSION AQSP(4),BQSP(4),CQSP(4)
C
C This function, given points A, B, and C on the globe, returns the
C directed distance, in degrees of arc, from the great circle through
C A and B to the point C, positive if the point C is in the hemisphere
C to the "left" of the great circle and negative otherwise.
C
C All variables with names of the form XQSP are four-element arrays
C containing the cosine and sine of the latitude and the cosine and
C sine of the longitude, in that order, of the point X.  Describing
C the point positions in this way makes this routine execute faster
C than if the latitudes and longitudes themselves are used.
C
C Code that is commented out either produces unneeded results or is
C superseded by code that executes faster.
C
C Define a multiplicative constant to convert from radians to degrees.
C
        DATA RTOD / 57.2957795130823 /
C
C Get XYZ coordinates for B, rotate them by -ALON about the Z axis (which
C would put A on the prime meridian), and then rotate them by ALAT about
C the Y axis (which would put A on the equator).
C
C       XCB1=BQSP(1)*BQSP(3)
C       YCB1=BQSP(1)*BQSP(4)
C       ZCB1=BQSP(2)
C
C       XCB2=XCB1*AQSP(3)+YCB1*AQSP(4)
C       YCB2=YCB1*AQSP(3)-XCB1*AQSP(4)
C       ZCB2=ZCB1
C
        XCB2=BQSP(1)*BQSP(3)*AQSP(3)+BQSP(1)*BQSP(4)*AQSP(4)
        YCB2=BQSP(1)*BQSP(4)*AQSP(3)-BQSP(1)*BQSP(3)*AQSP(4)
        ZCB2=BQSP(2)
C
C       XCB3=XCB2*AQSP(1)+ZCB2*AQSP(2)
        YCB3=YCB2
        ZCB3=ZCB2*AQSP(1)-XCB2*AQSP(2)
C
C Do the same for C.
C
C       XCC1=CQSP(1)*CQSP(3)
C       YCC1=CQSP(1)*CQSP(4)
C       ZCC1=CQSP(2)
C
C       XCC2=XCC1*AQSP(3)+YCC1*AQSP(4)
C       YCC2=YCC1*AQSP(3)-XCC1*AQSP(4)
C       ZCC2=ZCC1
C
        XCC2=CQSP(1)*CQSP(3)*AQSP(3)+CQSP(1)*CQSP(4)*AQSP(4)
        YCC2=CQSP(1)*CQSP(4)*AQSP(3)-CQSP(1)*CQSP(3)*AQSP(4)
        ZCC2=CQSP(2)
C
C       XCC3=XCC2*AQSP(1)+ZCC2*AQSP(2)
        YCC3=YCC2
        ZCC3=ZCC2*AQSP(1)-XCC2*AQSP(2)
C
C Rotate C about the X axis by the angle ALPH required to put B on the
C equator.
C
C       IF (YCB3.NE.0..OR.ZCB3.NE.0.) THEN
C         DNOM=SQRT(YCB3*YCB3+ZCB3*ZCB3)
C         CALP=YCB3/DNOM
C         SALP=ZCB3/DNOM
C       ELSE
C         CALP=1.
C         SALP=0.
C       END IF
C
C       XCC4=XCC3
C       YCC4=YCC3*CALP+ZCC3*SALP
C       ZCC4=ZCC3*CALP-YCC3*SALP
C
C Return the latitude of the point C as the value of the function.
C
C       DPGCSP=RTOD*ASIN(ZCC3*CALP-YCC3*SALP)
C
C The following code should be a little faster in the normal case and
C it returns the distance from A to C in the degenerate case when A
C and B are the same point.
C
        IF (YCB3.NE.0..OR.ZCB3.NE.0.) THEN
          DNOM=SQRT(YCB3*YCB3+ZCB3*ZCB3)
          DPGCSP=RTOD*ASIN((ZCC3*YCB3-YCC3*ZCB3)/DNOM)
        ELSE
          DPGCSP=ADGCSP(AQSP,CQSP)
        END IF
C
C Done.
C
        RETURN
C
      END


      FUNCTION ADGCSP (AQSP,BQSP)
C
C (ADGCSP = Angle in Degrees along Great Circle, Single Precision)
C
        DIMENSION AQSP(4),BQSP(4)
C
C This function returns the shortest great circle distance, in degrees,
C between two points, A and B, on the surface of the globe.
C
C All variables with names of the form XQSP are four-element arrays
C containing the cosine and sine of the latitude and the cosine and
C sine of the longitude, in that order, of the point X.  Describing
C the point positions in this way makes this routine execute faster
C than if the latitudes and longitudes themselves are used.
C
C Define a multiplicative constant to convert from radians to degrees
C and multiply by two.
C
        DATA RDTT / 114.5915590261646 /
C
        ADGCSP=RDTT*
     +         ASIN(SQRT((AQSP(1)*AQSP(3)-BQSP(1)*BQSP(3))**2+
     +                   (AQSP(1)*AQSP(4)-BQSP(1)*BQSP(4))**2+
     +                   (AQSP(2)        -BQSP(2)        )**2)/2.)
C
        RETURN
C
      END


      FUNCTION ICEGSP(PQSP,QQSP,IDIM,JDIM,IBEG,IEND,JBEG,JEND)
C
C (ICEGSP = Integer Check along Edge of Grid, Single Precision)
C
        DIMENSION PQSP(4),QQSP(4,IDIM,JDIM)
C
C The value of this function is zero if and only if the point P is
C inside the smaller of the two portions of the sphere formed by the
C boundary Q, which is the outer edge of a "grid" defined by the points
C (QQSP(I,J)), for I from IBEG to IEND and J from JBEG to JEND.  (The
C edge of the grid is formed of shortest great circle routes from point
C to point.)
C
C All variables with names of the form XQSP are four-element arrays
C containing the cosine and sine of the latitude and the cosine and
C sine of the longitude, in that order, of the point X.  Describing
C the point positions in this way makes this routine execute faster
C than if the latitudes and longitudes themselves are used.
C
C If the total angle swept out by a vector tangent to the sphere at the
C point P and pointing in the direction of the shortest great circle
C route to a point tracing Q is near zero, then both the point P and its
C antipodal point P' are in the same area, which must therefore be the
C larger of the two areas created by Q.
C
        IF (ABS(ACEGSP(PQSP,QQSP,IDIM,JDIM,IBEG,IEND,JBEG,JEND)).LT.
     +                                                        180.) THEN
          ICEGSP=1
          RETURN
        END IF
C
C Otherwise, P is in one of the two areas and P' is in the other, so
C we perform a somewhat heuristic test to see if P is in the smaller
C of the two areas: we compute the average distance from P to Q and
C see if it is less than 90 degrees or more than 90 degrees.
C
        ADST=0.
C
C "Bottom" edge:
C
        DO 101 I=IBEG,IEND-1
          ADST=ADST+ADGCSP(PQSP,QQSP(1,I,JBEG))
  101   CONTINUE
C
C "Right" edge:
C
        DO 102 J=JBEG,JEND-1
          ADST=ADST+ADGCSP(PQSP,QQSP(1,IEND,J))
  102   CONTINUE
C
C "Top" edge:
C
        DO 103 I=IEND,IBEG+1,-1
          ADST=ADST+ADGCSP(PQSP,QQSP(1,I,JEND))
  103   CONTINUE
C
C "Left" edge:
C
        DO 104 J=JEND,JBEG+1,-1
          ADST=ADST+ADGCSP(PQSP,QQSP(1,IBEG,J))
  104   CONTINUE
C
C Set the function value.
C
        ADST=ADST/REAL(IEND-IBEG+JEND-JBEG)/2.
C
        IF (ADST.LT.90.) THEN
          ICEGSP=0
        ELSE
          ICEGSP=1
        END IF
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE IPIQDP (AQDP,BQDP,CQDP,DQDP,XFRA,YFRA,EQDP)
C
C (IPIQDP = Interpolate Point In Quadrilateral, Double Precision)
C
        DOUBLE PRECISION AQDP(4),BQDP(4),CQDP(4),DQDP(4),EQDP(4)
        DOUBLE PRECISION XFRA,YFRA
C
C This routine, given four points on the sphere (A, B, C, and D) forming
C a "quadrilateral" and two interpolation fractions (XFRA and YFRA, each
C between 0 and 1, inclusive), finds a point E defined by the following
C diagram and returns it.
C
C                              C------Q----D
C                              |      |    |
C                              |      E    |
C                              |      |    |
C                              |      |    |
C                              A------P----B
C
C P and Q are positioned such that AP/AB = CQ/CD = XFRA and then E is
C positioned such that PE/PQ = YFRA (where "XY" is interpreted to mean
C "the shortest great circle distance from X to Y").
C
C It is assumed that the "quadrilateral" ABDC is "convex" (a working
C definition of which might be that none of the four great circles
C defined by its edges - the ones through A and B, B and D, D and C,
C and C and A - cross it anywhere.  However, this is not verified.
C
C All variables with names of the form XQDP are four-element arrays
C containing the cosine and sine of the latitude and the cosine and
C sine of the longitude, in that order, of the point X.  Describing
C the point positions in this way makes this routine execute faster
C than if the latitudes and longitudes themselves are used.
C
        DOUBLE PRECISION PQDP(4),QQDP(4)
C
C The code is easy:
C
        CALL IPGCDP (AQDP,BQDP,XFRA,PQDP)
        CALL IPGCDP (CQDP,DQDP,XFRA,QQDP)
        CALL IPGCDP (PQDP,QQDP,YFRA,EQDP)
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE FPIQDP (AQDP,BQDP,CQDP,DQDP,EQDP,XFRA,YFRA)
C
C (FPIQDP = Find Point In Quadrilateral, Double Precision)
C
        DOUBLE PRECISION AQDP(4),BQDP(4),CQDP(4),DQDP(4),EQDP(4)
        DOUBLE PRECISION XFRA,YFRA
C
C This routine, given four points (A, B, C, and D) that form a
C "quadrilateral" on the surface of the globe, and a surface point
C (E) in its interior, returns the two interpolation fractions that
C one would use in a call to IPIQSP to get the point E.  See comments
C in IPIQSP; here's a duplicate of the diagram from that routine:
C
C                              C------Q----D
C                              |      |    |
C                              |      E    |
C                              |      |    |
C                              |      |    |
C                              A------P----B
C
C P and Q are positioned such that AP/AB = CQ/CD = XFRA and then E is
C positioned such that PE/PQ = YFRA (where "XY" is interpreted to mean
C "the shortest great circle distance from X to Y").
C
C All variables with names of the form XQDP are four-element arrays
C containing the cosine and sine of the latitude and the cosine and
C sine of the longitude, in that order, of the point X.  Describing
C the point positions in this way makes this routine execute faster
C than if the latitudes and longitudes themselves are used.
C
        DOUBLE PRECISION PQDP(4),QQDP(4),XFR1,XFR2,DST1,DST2,DSTA,TMP1,
     +                   TMP2,DPGCDP,ADGCDP
C
C We use a fast iterative technique to find XFRA.
C
        XFR1=0.D0
        DST1=DPGCDP(AQDP,CQDP,EQDP)
        XFR2=1.D0
        DST2=DPGCDP(BQDP,DQDP,EQDP)
        IF (DST1*DST2.GE.0.D0) THEN
          IF (ABS(DST1).LT.ABS(DST2)) THEN
            XFRA=0.D0
          ELSE
            XFRA=1.D0
          END IF
          CALL IPGCDP (AQDP,BQDP,XFRA,PQDP)
          CALL IPGCDP (CQDP,DQDP,XFRA,QQDP)
        ELSE
  101     XFRA=(DST2*XFR1-DST1*XFR2)/(DST2-DST1)
          CALL IPGCDP (AQDP,BQDP,XFRA,PQDP)
          CALL IPGCDP (CQDP,DQDP,XFRA,QQDP)
          IF (XFRA.LE.XFR1.OR.XFRA.GE.XFR2) GO TO 104
          DSTA=DPGCDP(PQDP,QQDP,EQDP)
          IF (DSTA.EQ.0.D0) GO TO 104
          IF (DST1*DSTA.GT.0.D0) THEN
            XFR1=XFRA
            DST1=DSTA
          ELSE
            XFR2=XFRA
            DST2=DSTA
          END IF
          IF (XFR2-XFR1.GT.1.D-12) GO TO 101
        END IF
C
C Computing YFRA is easier:
C
  104   TMP1=ADGCDP(PQDP,EQDP)
        TMP2=ADGCDP(PQDP,QQDP)
        IF (TMP2.NE.0.D0) THEN
          YFRA=TMP1/TMP2
        ELSE
          YFRA=0.D0
        END IF
C
C Normal exit.
C
        RETURN
C
      END


      SUBROUTINE IPGCDP (AQDP,BQDP,FRAC,CQDP)
C
C (IPGCDP = Interpolate Point on Great Circle, Double Precision)
C
        DOUBLE PRECISION AQDP(4),BQDP(4),CQDP(4),FRAC
C
C This routine, given two points A and B on the surface of the globe and
C a fraction FRAC, between 0. and 1., interpolates a point C along the
C shortest great circle route joining A to B such that the distance from
C A to C, divided by the distance from A to B, is equal to FRAC.
C
C All variables with names of the form XQDP are four-element arrays
C containing the cosine and sine of the latitude and the cosine and
C sine of the longitude, in that order, of the point X.  Describing
C the point positions in this way makes this routine execute faster
C than if the latitudes and longitudes themselves are used.
C
C Code that is commented out either produces unneeded results or is
C superseded by code that executes faster.
C
C       DOUBLE PRECISION XCB1,YCB1,ZCB1
        DOUBLE PRECISION XCB2,YCB2,ZCB2
        DOUBLE PRECISION XCB3,YCB3,ZCB3
        DOUBLE PRECISION XCB4,YCB4
        DOUBLE PRECISION XCC2,YCC2,ZCC2
        DOUBLE PRECISION XCC3,YCC3,ZCC3
        DOUBLE PRECISION XCC4,YCC4,ZCC4
        DOUBLE PRECISION DNOM,CALP,SALP,BETA
C
C Get XYZ coordinates for B, rotate them by -ALON about the Z axis (which
C would put A on the prime meridian), and then rotate them by ALAT about
C the Y axis (which would put A on the equator).
C
C       XCB1=BQDP(1)*BQDP(3)
C       YCB1=BQDP(1)*BQDP(4)
C       ZCB1=BQDP(2)
C
C       XCB2=XCB1*AQDP(3)+YCB1*AQDP(4)
C       YCB2=YCB1*AQDP(3)-XCB1*AQDP(4)
C       ZCB2=ZCB1
C
        XCB2=BQDP(1)*BQDP(3)*AQDP(3)+BQDP(1)*BQDP(4)*AQDP(4)
        YCB2=BQDP(1)*BQDP(4)*AQDP(3)-BQDP(1)*BQDP(3)*AQDP(4)
        ZCB2=BQDP(2)
C
        XCB3=XCB2*AQDP(1)+ZCB2*AQDP(2)
        YCB3=YCB2
        ZCB3=ZCB2*AQDP(1)-XCB2*AQDP(2)
C
C Now, rotate about the X axis by the angle ALPH = -ATAN(ZCB3/YCB3),
C which leaves the position of A unchanged but carries B into a point
C in the XY plane.
C
        IF (YCB3.NE.0.D0.OR.ZCB3.NE.0.D0) THEN
          DNOM=SQRT(YCB3*YCB3+ZCB3*ZCB3)
          CALP=YCB3/DNOM
          SALP=ZCB3/DNOM
        ELSE
          CALP=1.D0
          SALP=0.D0
        END IF
C
        XCB4=XCB3
        YCB4=YCB3*CALP+ZCB3*SALP
C       ZCB4=ZCB3*CALP-YCB3*SALP
C
C The angle BETA from A to B can now be computed easily.
C
        IF (XCB4.NE.0.D0.OR.YCB4.NE.0.D0) THEN
          BETA=ATAN2(YCB4,XCB4)
        ELSE
          BETA=0.D0
        END IF
C
C Interpolate a point C at the desired position between the points A and
C B and map it back to its original position on the great circle route
C from A to B.
C
C       GAMA=FRAC*BETA
C
C       XCC1=COS(GAMA)
C       YCC1=SIN(GAMA)
C       ZCC1=0.
C
C       XCC2=XCC1
C       YCC2=YCC1*CALP-ZCC1*SALP
C       ZCC2=ZCC1*CALP+YCC1*SALP
C
        XCC2=COS(FRAC*BETA)
        YCC2=SIN(FRAC*BETA)*CALP
        ZCC2=SIN(FRAC*BETA)*SALP
C
        XCC3=XCC2*AQDP(1)-ZCC2*AQDP(2)
        YCC3=YCC2
        ZCC3=ZCC2*AQDP(1)+XCC2*AQDP(2)
C
        XCC4=XCC3*AQDP(3)-YCC3*AQDP(4)
        YCC4=YCC3*AQDP(3)+XCC3*AQDP(4)
        ZCC4=ZCC3
C
        CQDP(1)=SQRT(XCC4*XCC4+YCC4*YCC4)
        CQDP(2)=ZCC4
        CQDP(3)=XCC4/CQDP(1)
        CQDP(4)=YCC4/CQDP(1)
C
C Done.
C
        RETURN
C
      END


      DOUBLE PRECISION FUNCTION ACEGDP (PQDP,QQDP,IDIM,JDIM,
     +                                  IBEG,IEND,JBEG,JEND)
C
C (ACEGDP = Angular Change along Edge of Grid, Double Precision)
C
        DOUBLE PRECISION PQDP(4),QQDP(4,IDIM,JDIM)
C
C The value of this function is the total angle swept out by a vector
C tangent to the sphere at the point P and pointing in the direction of
C the shortest great circle route to a point tracing Q, the outer edge
C of a "grid" defined by the points (QQDP(I,J)), for I from IBEG to IEND
C and J from JBEG to JEND.  (The edge of the grid is formed of shortest
C great circle routes from point to point.)
C
C The outer edge of the grid divides the surface of the sphere into two
C areas - one to the left, and one to the right, of Q.  Let P' denote
C the point opposite P on the sphere.  Note that P' = (-PLAT,PLON+180).
C In theory (ignoring computational inaccuracies), the function can only
C have three possible values: +360, if P is to the left of Q and P' is
C to the right of Q; -360, if P is to the right of Q and P' is to the
C left of Q; and zero, if both P and P' are on the same side of Q (left
C or right, but we don't know which).
C
C All variables with names of the form XQDP are four-element arrays
C containing the cosine and sine of the latitude and the cosine and
C sine of the longitude, in that order, of the point X.  Describing
C the point positions in this way makes this routine execute faster
C than if the latitudes and longitudes themselves are used.
C
        DOUBLE PRECISION ANCH,ABGCDP
C
        ANCH=0.D0
C
C "Bottom" edge:
C
        DO 101 I=IBEG,IEND-1
          ANCH=ANCH+ABGCDP(PQDP,QQDP(1,I,JBEG),QQDP(1,I+1,JBEG))
  101   CONTINUE
C
C "Right" edge:
C
        DO 102 J=JBEG,JEND-1
          ANCH=ANCH+ABGCDP(PQDP,QQDP(1,IEND,J),QQDP(1,IEND,J+1))
  102   CONTINUE
C
C "Top" edge:
C
        DO 103 I=IEND,IBEG+1,-1
          ANCH=ANCH+ABGCDP(PQDP,QQDP(1,I,JEND),QQDP(1,I-1,JEND))
  103   CONTINUE
C
C "Left" edge:
C
        DO 104 J=JEND,JBEG+1,-1
          ANCH=ANCH+ABGCDP(PQDP,QQDP(1,IBEG,J),QQDP(1,IBEG,J-1))
  104   CONTINUE
C
C Set the function value.
C
        ACEGDP=ANCH
C
C Done.
C
        RETURN
C
      END


      DOUBLE PRECISION FUNCTION ABGCDP (AQDP,BQDP,CQDP)
C
C (ABGCDP = Angle Between Great Circles, Double Precision)
C
        DOUBLE PRECISION AQDP(4),BQDP(4),CQDP(4)
C
C This function, given information about the points A, B, and C on the
C sphere, returns the angle, in degrees, from the great circle through
C A and B to the great circle through A and C, positive if the point C
C is in the hemisphere to the "left" of the great circle through A and
C B, negative otherwise.
C
C All variables with names of the form XQDP are four-element arrays
C containing the cosine and sine of the latitude and the cosine and
C sine of the longitude, in that order, of the point X.  Describing
C the point positions in this way makes this routine execute faster
C than if the latitudes and longitudes themselves are used.
C
C Code that is commented out either produces unneeded results or is
C superseded by code that executes faster.
C
        DOUBLE PRECISION RTOD
C       DOUBLE PRECISION XCB1,YCB1,ZCB1
        DOUBLE PRECISION XCB2,YCB2,ZCB2
        DOUBLE PRECISION      YCB3,ZCB3
C       DOUBLE PRECISION XCC1,YCC1,ZCC1
        DOUBLE PRECISION XCC2,YCC2,ZCC2
        DOUBLE PRECISION      YCC3,ZCC3
        DOUBLE PRECISION      YCC4,ZCC4
        DOUBLE PRECISION DNOM,CANG,SANG
C
C Define a multiplicative constant to convert from radians to degrees.
C
        DATA RTOD / 57.2957795130823D0 /
C
C Get XYZ coordinates for B, rotate them by -ALON about the Z axis (which
C would put A on the prime meridian), and then rotate them by ALAT about
C the Y axis (which would put A on the equator).
C
C       XCB1=BQDP(1)*BQDP(3)
C       YCB1=BQDP(1)*BQDP(4)
C       ZCB1=BQDP(2)
C
C       XCB2=XCB1*AQDP(3)+YCB1*AQDP(4)
C       YCB2=YCB1*AQDP(3)-XCB1*AQDP(4)
C       ZCB2=ZCB1
C
        XCB2=BQDP(1)*BQDP(3)*AQDP(3)+BQDP(1)*BQDP(4)*AQDP(4)
        YCB2=BQDP(1)*BQDP(4)*AQDP(3)-BQDP(1)*BQDP(3)*AQDP(4)
        ZCB2=BQDP(2)
C
C       XCB3=XCB2*AQDP(1)+ZCB2*AQDP(2)
        YCB3=YCB2
        ZCB3=ZCB2*AQDP(1)-XCB2*AQDP(2)
C
C Do the same for the point C.
C
C       XCC1=CQDP(1)*CQDP(3)
C       YCC1=CQDP(1)*CQDP(4)
C       ZCC1=CQDP(2)
C
C       XCC2=XCC1*AQDP(3)+YCC1*AQDP(4)
C       YCC2=YCC1*AQDP(3)-XCC1*AQDP(4)
C       ZCC2=ZCC1
C
        XCC2=CQDP(1)*CQDP(3)*AQDP(3)+CQDP(1)*CQDP(4)*AQDP(4)
        YCC2=CQDP(1)*CQDP(4)*AQDP(3)-CQDP(1)*CQDP(3)*AQDP(4)
        ZCC2=CQDP(2)
C
C       XCC3=XCC2*AQDP(1)+ZCC2*AQDP(2)
        YCC3=YCC2
        ZCC3=ZCC2*AQDP(1)-XCC2*AQDP(2)
C
C Now, rotate C about the X axis by an amount which would put B on the
C equator.
C
        IF (YCB3.NE.0D0.OR.ZCB3.NE.0.D0) THEN
          DNOM=SQRT(YCB3*YCB3+ZCB3*ZCB3)
          CANG=YCB3/DNOM
          SANG=ZCB3/DNOM
        ELSE
          CANG=1.D0
          SANG=0.D0
        END IF
C
C       XCC4=XCC3
        YCC4=YCC3*CANG+ZCC3*SANG
        ZCC4=ZCC3*CANG-YCC3*SANG
C
C The angle between the great circles is now easily computed.
C
        IF (YCC4.NE.0.D0.OR.ZCC4.NE.0.D0) THEN
          ABGCDP=RTOD*ATAN2(ZCC4,YCC4)
        ELSE
          ABGCDP=0.D0
        END IF
C
C Done.
C
        RETURN
C
      END


      DOUBLE PRECISION FUNCTION DPGCDP (AQDP,BQDP,CQDP)
C
C (DPGCDP = Distance of Point from Great Circle, Double Precision)
C
        DOUBLE PRECISION AQDP(4),BQDP(4),CQDP(4)
C
C This function, given points A, B, and C on the globe, returns the
C directed distance, in degrees of arc, from the great circle through
C A and B to the point C, positive if the point C is in the hemisphere
C to the "left" of the great circle and negative otherwise.
C
C All variables with names of the form XQDP are four-element arrays
C containing the cosine and sine of the latitude and the cosine and
C sine of the longitude, in that order, of the point X.  Describing
C the point positions in this way makes this routine execute faster
C than if the latitudes and longitudes themselves are used.
C
C Code that is commented out either produces unneeded results or is
C superseded by code that executes faster.
C
        DOUBLE PRECISION RTOD
C       DOUBLE PRECISION XCB1,YCB1,ZCB1
        DOUBLE PRECISION XCB2,YCB2,ZCB2
        DOUBLE PRECISION      YCB3,ZCB3
C       DOUBLE PRECISION XCC1,YCC1,ZCC1
        DOUBLE PRECISION XCC2,YCC2,ZCC2
        DOUBLE PRECISION      YCC3,ZCC3
        DOUBLE PRECISION DNOM
C
        DOUBLE PRECISION ADGCDP
C
C Define a multiplicative constant to convert from radians to degrees.
C
        DATA RTOD / 57.2957795130823D0 /
C
C Get XYZ coordinates for B, rotate them by -ALON about the Z axis (which
C would put A on the prime meridian), and then rotate them by ALAT about
C the Y axis (which would put A on the equator).
C
C       XCB1=BQDP(1)*BQDP(3)
C       YCB1=BQDP(1)*BQDP(4)
C       ZCB1=BQDP(2)
C
C       XCB2=XCB1*AQDP(3)+YCB1*AQDP(4)
C       YCB2=YCB1*AQDP(3)-XCB1*AQDP(4)
C       ZCB2=ZCB1
C
        XCB2=BQDP(1)*BQDP(3)*AQDP(3)+BQDP(1)*BQDP(4)*AQDP(4)
        YCB2=BQDP(1)*BQDP(4)*AQDP(3)-BQDP(1)*BQDP(3)*AQDP(4)
        ZCB2=BQDP(2)
C
C       XCB3=XCB2*AQDP(1)+ZCB2*AQDP(2)
        YCB3=YCB2
        ZCB3=ZCB2*AQDP(1)-XCB2*AQDP(2)
C
C Do the same for C.
C
C       XCC1=CQDP(1)*CQDP(3)
C       YCC1=CQDP(1)*CQDP(4)
C       ZCC1=CQDP(2)
C
C       XCC2=XCC1*AQDP(3)+YCC1*AQDP(4)
C       YCC2=YCC1*AQDP(3)-XCC1*AQDP(4)
C       ZCC2=ZCC1
C
        XCC2=CQDP(1)*CQDP(3)*AQDP(3)+CQDP(1)*CQDP(4)*AQDP(4)
        YCC2=CQDP(1)*CQDP(4)*AQDP(3)-CQDP(1)*CQDP(3)*AQDP(4)
        ZCC2=CQDP(2)
C
C       XCC3=XCC2*AQDP(1)+ZCC2*AQDP(2)
        YCC3=YCC2
        ZCC3=ZCC2*AQDP(1)-XCC2*AQDP(2)
C
C Rotate C about the X axis by the angle ALPH required to put B on the
C equator.
C
C       IF (YCB3.NE.0.D0.OR.ZCB3.NE.0.D0) THEN
C         DNOM=SQRT(YCB3*YCB3+ZCB3*ZCB3)
C         CALP=YCB3/DNOM
C         SALP=ZCB3/DNOM
C       ELSE
C         CALP=1.D0
C         SALP=0.D0
C       END IF
C
C       XCC4=XCC3
C       YCC4=YCC3*CALP+ZCC3*SALP
C       ZCC4=ZCC3*CALP-YCC3*SALP
C
C Return the latitude of the point C as the value of the function.
C
C       DPGCDP=RTOD*ASIN(ZCC3*CALP-YCC3*SALP)
C
C The following code should be a little faster in the normal case and
C it returns the distance from A to C in the degenerate case when A
C and B are the same point.
C
        IF (YCB3.NE.0.D0.OR.ZCB3.NE.0.D0) THEN
          DNOM=SQRT(YCB3*YCB3+ZCB3*ZCB3)
          DPGCDP=RTOD*ASIN((ZCC3*YCB3-YCC3*ZCB3)/DNOM)
        ELSE
          DPGCDP=ADGCDP(AQDP,CQDP)
        END IF
C
C Done.
C
        RETURN
C
      END


      DOUBLE PRECISION FUNCTION ADGCDP (AQDP,BQDP)
C
C (ADGCDP = Angle in Degrees along Great Circle, Double Precision)
C
        DOUBLE PRECISION AQDP(4),BQDP(4)
C
C This function returns the shortest great circle distance, in degrees,
C between two points, A and B, on the surface of the globe.
C
C All variables with names of the form XQDP are four-element arrays
C containing the cosine and sine of the latitude and the cosine and
C sine of the longitude, in that order, of the point X.  Describing
C the point positions in this way makes this routine execute faster
C than if the latitudes and longitudes themselves are used.
C
        DOUBLE PRECISION RDTT
C
C Define a multiplicative constant to convert from radians to degrees
C and multiply by two.
C
        DATA RDTT / 114.5915590261646D0 /
C
        ADGCDP=RDTT*
     +         ASIN(SQRT((AQDP(1)*AQDP(3)-BQDP(1)*BQDP(3))**2+
     +                   (AQDP(1)*AQDP(4)-BQDP(1)*BQDP(4))**2+
     +                   (AQDP(2)        -BQDP(2)        )**2)/2.D0)
C
        RETURN
C
      END


      FUNCTION ICEGDP(PQDP,QQDP,IDIM,JDIM,IBEG,IEND,JBEG,JEND)
C
C (ICEGDP = Integer Check along Edge of Grid, Double Precision)
C
        DOUBLE PRECISION PQDP(4),QQDP(4,IDIM,JDIM)
C
C The value of this function is zero if and only if the point P is
C inside the smaller of the two portions of the sphere formed by the
C boundary Q, which is the outer edge of a "grid" defined by the points
C (QQDP(I,J)), for I from IBEG to IEND and J from JBEG to JEND.  (The
C edge of the grid is formed of shortest great circle routes from point
C to point.)
C
C All variables with names of the form XQDP are four-element arrays
C containing the cosine and sine of the latitude and the cosine and
C sine of the longitude, in that order, of the point X.  Describing
C the point positions in this way makes this routine execute faster
C than if the latitudes and longitudes themselves are used.
C
        DOUBLE PRECISION ACEGDP,ADGCDP,ADST
C
C If the total angle swept out by a vector tangent to the sphere at the
C point P and pointing in the direction of the shortest great circle
C route to a point tracing Q is near zero, then both the point P and its
C antipodal point P' are in the same area, which must therefore be the
C larger of the two areas created by Q.
C
        IF (ABS(ACEGDP(PQDP,QQDP,IDIM,JDIM,IBEG,IEND,JBEG,JEND)).LT.
     +                                                      180.D0) THEN
          ICEGDP=1
          RETURN
        END IF
C
C Otherwise, P is in one of the two areas and P' is in the other, so
C we perform a somewhat heuristic test to see if P is in the smaller
C of the two areas: we compute the average distance from P to Q and
C see if it is less than 90 degrees or more than 90 degrees.
C
        ADST=0.D0
C
C "Bottom" edge:
C
        DO 101 I=IBEG,IEND-1
          ADST=ADST+ADGCDP(PQDP,QQDP(1,I,JBEG))
  101   CONTINUE
C
C "Right" edge:
C
        DO 102 J=JBEG,JEND-1
          ADST=ADST+ADGCDP(PQDP,QQDP(1,IEND,J))
  102   CONTINUE
C
C "Top" edge:
C
        DO 103 I=IEND,IBEG+1,-1
          ADST=ADST+ADGCDP(PQDP,QQDP(1,I,JEND))
  103   CONTINUE
C
C "Left" edge:
C
        DO 104 J=JEND,JBEG+1,-1
          ADST=ADST+ADGCDP(PQDP,QQDP(1,IBEG,J))
  104   CONTINUE
C
C Set the function value.
C
        ADST=ADST/DBLE(IEND-IBEG+JEND-JBEG)/2.D0
C
        IF (ADST.LT.90.D0) THEN
          ICEGDP=0
        ELSE
          ICEGDP=1
        END IF
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE COLRAM (XCRA,YCRA,NCRA,IAIA,IGIA,NAIA)
C
        DIMENSION XCRA(*),YCRA(*),IAIA(*),IGIA(*)
C
C The arrays XCRA and YCRA, for indices 1 to NCRA, contain the X and Y
C coordinates of points defining a polygon.  The area identifiers in
C the array IAIA, each with an associated group identifier in the array
C IGIA, tell us whether the polygon is to be color-filled or not.
C
C Assume the polygon will be filled until we find otherwise.
C
        IFLL=1
C
C If any of the area identifiers is negative, don't fill the polygon.
C
        DO 101 I=1,NAIA
          IF (IAIA(I).LT.0) IFLL=0
  101   CONTINUE
C
C Otherwise, fill the polygon in the color implied by its area
C identifier relative to edge group 3 (the contour-line group).
C
        IF (IFLL.NE.0) THEN
          IFLL=0
          DO 102 I=1,NAIA
            IF (IGIA(I).EQ.3) IFLL=IAIA(I)
  102     CONTINUE
          IF (IFLL.GE.0) THEN
            CALL GSFACI (101+IFLL)
            CALL GFA (NCRA-1,XCRA,YCRA)
          END IF
        END IF
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE GETAID (ZVAL,IAID,NCLV,CLEV,IAIA,IAIB)
C
        DIMENSION CLEV(NCLV),IAIA(NCLV),IAIB(NCLV)
C
C Given a field value ZVAL, GETAID searches the current contour list to
C determine the area identifier IAID to be associated with that value.
C
C NCLV is the number of contour levels CONPACK is using, CLEV is a list
C of the levels, in ascending order, and IAIA and IAIB contain the area
C identifiers above and below the specified contour levels.
C
C Zero will be returned if nothing better turns up.
C
        IAID=0
C
C First, search forward for a value in the parameter array 'AIB'.  This
C search is complicated by the latitude the user is given in the way he
C or she defines the area identifiers to be associated with the contour
C bands.
C
        JCLV=0
C
        DO 101 KCLV=1,NCLV
          IF (ZVAL.LE.CLEV(KCLV)) THEN
            IF (JCLV.NE.0) THEN
              IF (CLEV(KCLV).NE.CLEV(JCLV)) GO TO 102
            END IF
            IF (IAIB(KCLV).NE.0) THEN
              IAID=IAIB(KCLV)
              GO TO 104
            ELSE IF (IAIA(KCLV).NE.0) THEN
              JCLV=KCLV
            END IF
          END IF
  101   CONTINUE
C
C If necessary, search backward, in the same way, for a value in the
C parameter array 'AIA'.
C
  102  JCLV=0
C
        DO 103 KCLV=NCLV,1,-1
          IF (ZVAL.GE.CLEV(KCLV)) THEN
            IF (JCLV.NE.0) THEN
              IF (CLEV(KCLV).NE.CLEV(JCLV)) GO TO 104
            END IF
            IF (IAIA(KCLV).NE.0) THEN
              IAID=IAIA(KCLV)
              GO TO 104
            ELSE IF (IAIB(KCLV).NE.0) THEN
              JCLV=KCLV
            END IF
          END IF
  103   CONTINUE
C
C Done.
C
  104   RETURN
C
      END


      SUBROUTINE ARDAMN (IAMA,IFLN)
        DIMENSION IAMA(*)
        WRITE (IFLN,'(2I10)') (I,IAMA(I),I=1,IAMA(5))
        WRITE (IFLN,'(2I10)') (I,IAMA(I),I=IAMA(6),IAMA(1))
        RETURN
      END

      PROGRAM FFEX03
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C This program requires the input data file 'ffex02.dat'
C It reads the data from standard input, e.g.: ffex03 < ffex02.dat
C
      PARAMETER (MSIZE=36, NSIZE=33)
      PARAMETER (ISTWKL=2*MSIZE*NSIZE)
C
      DIMENSION U(MSIZE,NSIZE), V(MSIZE,NSIZE), P(MSIZE,NSIZE)
      DIMENSION WRK(ISTWKL)      
C
C Conpack work space and Areas area map
C
      PARAMETER (ICPIWL=1000, ICPRWL=5000, IAREAL=20000)
      DIMENSION RWRK(ICPRWL),IWRK(ICPIWL)
      DIMENSION IAM(IAREAL)
C
C Arrays for drawing masked grids
C
      PARAMETER (MCRA=64, NOGI=64)
      DIMENSION XCRA(MCRA),YCRA(MCRA),IAAI(NOGI),IAGI(NOGI)
C
C External subroutine declarations
C
      EXTERNAL DRAWCL
      EXTERNAL STUMSL
C
C Define a set of RGB color triples
C
      PARAMETER (NCLRS=3)
      COMMON ICLR(NCLRS)
C
      DIMENSION RGBV(3,NCLRS)
C
      DATA RGBV / 
     +     1.0,0.0,0.0,
     +     0.0,0.0,1.0,
     +     0.5,0.5,0.5 /
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Read the input array data
C
      CALL RDDATA(U,V,P,MSIZE,NSIZE)
C
C Set up colors for fixed table grayscale and color workstations
C Colors allocated as follows: 1, map outline; 2, contour lines;
C  3, grid lines; (streamlines and labels use default black or white.
C
      DO 100 I=1,NCLRS,1
         ICLRIX=64+(I-1)*196/NCLRS
         CALL GSCR(IWKID,ICLRIX,RGBV(1,I),RGBV(2,I),RGBV(3,I))
         ICLR(I) = ICLRIX
 100  CONTINUE
C
C Set up the EZMAP transformation
C
      CALL MAPSET('CO',60.0,-120.0,23.0,-60.0)
      CALL MAPROJ('LC',0.0,-75.0,45.0)
      CALL MAPINT
      CALL MAPSTI('C5 - Continental Outline Color',ICLR(1))
C
C Tell Streamlines to use the mapping established by EZMAP
C
      CALL STSETI('MAP -- Mapping Flag', 1)
      CALL STSETI('SET -- Set Call Flag', 0)
C
C Set up data coordinate boundaries and special value processing 
C appropriately for the dataset 
C
      CALL STSETR('XC1 -- Lower X Bound', -140.0)
      CALL STSETR('XCM -- Upper X Bound', -52.5)
      CALL STSETR('YC1 -- Lower X Bound', 20.0)   
      CALL STSETR('YCN -- Upper Y Bound', 60.0)
C
      CALL STSETI('SVF -- Special Values Flag', 1)
      CALL STSETR('USV -- U Special Value', -9999.0)
      CALL STSETR('VSV -- V Special Value', -9999.0)
C
C Do the equivalent Conpack setup; note that the special value
C parameter works a bit differently, and also Conpack requires
C an Out of Range value to be set whenever the data grid extends
C outside the map boundaries. The standard value for the default
C version of CPMPXY is 1.0E12
C
      CALL CPSETI('MAP -- Mapping Flag', 1)
      CALL CPSETI('SET -- Set Call Flag', 0)
      CALL CPSETR('XC1 -- Lower X Bound', -140.0)
      CALL CPSETR('XCM -- Upper X Bound', -52.5)
      CALL CPSETR('YC1 -- Lower X Bound', 20.0)   
      CALL CPSETR('YCN -- Upper Y Bound', 60.0)
      CALL CPSETR('SPV -- Special Value',-9999.0)
      CALL CPSETR('ORV -- Out of Range Value',1.0E12)
C
C Set Conpack graphics text parameters
C
      CALL SETCGT
C
C Draw the continental outline using a wide line
C
      CALL GSLWSC(4.0)
      CALL MAPLOT
      CALL GSLWSC(1.0)
C
C Initialize the drawing of the contour plot, and tell Conpack
C to pick contour levels.
C
      CALL CPRECT (P,MSIZE,MSIZE,NSIZE,RWRK,ICPRWL,IWRK,ICPIWL)
      CALL CPPKCL (P,RWRK,IWRK)
C
C Set up contour line attributes
C
      CALL CPGETI('NCL - Number Of Contour Levels',NCLV)
      CALL SETCLA(NCLV)
C
C Initialize the area map, add the Conpack labels to the area map,
C then draw the labels, draw masked contour lines, and finally
C draw the masked map grids. Note that there is currently no way
C to draw a masked continental outline.
C
      CALL ARINAM (IAM,IAREAL)
      CALL CPLBAM (P,RWRK,IWRK,IAM)
      CALL CPLBDR (P,RWRK,IWRK)
      CALL CPCLDM (P,RWRK,IWRK,IAM,DRAWCL)
      CALL MAPSTI('C2 - Grid',ICLR(3))
      CALL GSPLCI(ICLR(3))
      CALL MAPGRM (IAM,XCRA,YCRA,MCRA,IAAI,IAGI,NOGI,DRAWCL)
      CALL GSPLCI(1)
C
C Adjust streamline rendering options and turn on statistics
C
      CALL STSETR('LWD -- Streamline Line Width',1.75)
      CALL STSETI('MSK -- Streamline Masking',1)
      CALL STSETR('SSP -- Stream Spacing', 0.012)
      CALL STSETR('DFM -- Differential Magnitude', 0.012)
      CALL STSETI('SST -- Streamline Statistics', 1)
C
C Initialize Streamlines
C
      CALL STINIT (U,MSIZE,V,MSIZE,IDM,IDM,MSIZE,NSIZE,WRK,ISTWKL)
C
C Draw the streamline field plot
C
      CALL STREAM (U,V,IDM,IAM,STUMSL,WRK)
C
C Draw a perimeter boundary and eject the frame
C
      CALL PERIM(1,0,1,0)
      CALL FRAME
C
C     Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END
C
C =====================================================================
C
      SUBROUTINE RDDATA(U,V,P,M,N)
C
C Read the data arrays from the standard input 
C
      DIMENSION U(M,N), V(M,N), P(M,N)
C     
      READ (*,*) U
      READ (*,*) V
      READ (*,*) P
C
      RETURN
      END
C
C =====================================================================
C
      SUBROUTINE DRAWCL (XCS,YCS,NCS,IAI,IAG,NAI)
C
C Routine for masked drawing of contour and grid lines
C
C This version of DRAWCL draws the polyline defined by the points
C ((XCS(I),YCS(I)),I=1,NCS) if and only if none of the area identifiers
C for the area containing the polyline are negative.  The dash package
C routine CURVED is called to do the drawing.
C
      DIMENSION XCS(*),YCS(*),IAI(*),IAG(*)
C
C Turn on drawing.
C
      IDR=1
C
C If any area identifier is negative, turn off drawing.
C
      DO 101 I=1,NAI
         IF (IAI(I).LT.0) IDR=0
 101  CONTINUE
C
C If drawing is turned on, draw the polyline.
C
      IF (IDR.NE.0) CALL CURVED (XCS,YCS,NCS)
C
C Done.
C
      RETURN
C
      END
C
C =====================================================================
C
      SUBROUTINE SETCGT
C
C Sets Conpack Graphics Text Parameters
C
      CALL CPSETI ('LLP - LINE LABEL POSITIONING',3)
      CALL CPSETI ('RWC - REAL WORKSPACE FOR CONTOURS',200)
      CALL CPSETI ('HLB - HIGH/LOW LABEL BOX FLAG',1)
      CALL CPSETI ('LLB - HIGH/LOW LABEL BOX FLAG',0)
      CALL CPSETC ('ILT - INFORMATION LABEL TEXT',' ')
      CALL CPSETI ('HLO - HIGH/LOW LABEL OVERLAP FLAG',11)
      CALL CPSETR ('CWM - CHARACTER WIDTH MULTIPLIER',1.25)
C
      RETURN
      END
C
C =====================================================================
C
      SUBROUTINE SETCLA (NCLV)
C
C Sets Contour Line Attributes
C
      PARAMETER (NCLRS=3)
      COMMON ICLR(NCLRS)
C
      DO 100 ICLV=1,NCLV
C
         CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',ICLV)
         CALL CPGETI ('CLU - CONTOUR LEVEL USE FLAG',ICLU)
         CALL CPSETI ('CLL - CONTOUR-LINE LINE WIDTH',3)
         CALL CPSETI ('CLC - CONTOUR-LINE COLOR', ICLR(2))
         IF (ICLU.EQ.3) THEN
            CALL CPSETI ('CLL - CONTOUR-LINE LINE WIDTH',6)
         END IF
C
 100  CONTINUE
C
C 'Special' contour lines - grid, special values, and out of range
C boundaries
C
      CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',-1)
      CALL CPSETI ('CLU - CONTOUR LEVEL USE FLAG',1)
      CALL CPSETR ('CLL - CONTOUR LEVEL LINE WIDTH',2.)
      CALL CPSETI ('CLC - CONTOUR LEVEL LINE COLOR',ICLR(3))
C
      CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',-2)
      CALL CPSETI ('CLU - CONTOUR LEVEL USE FLAG',1)
      CALL CPSETR ('CLL - CONTOUR LEVEL LINE WIDTH',2.)
      CALL CPSETI ('CLC - CONTOUR LEVEL LINE COLOR',ICLR(3))
C
      CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',-3)
      CALL CPSETI ('CLU - CONTOUR LEVEL USE FLAG',1)
      CALL CPSETR ('CLL - CONTOUR LEVEL LINE WIDTH',2.)
      CALL CPSETI ('CLC - CONTOUR LEVEL LINE COLOR',ICLR(3))
C
      RETURN
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C   FFTPACK 5.0
C   Copyright (C) 1995-2004, Scientific Computing Division,
C   University Corporation for Atmospheric Research
C   Licensed under the GNU General Public License (GPL)
C
C   Authors:  Paul N. Swarztrauber and Richard A. Valent
C
C   $Id: mradb3.f,v 1.2 2006-11-21 01:10:17 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      SUBROUTINE DMRADB3(M,IDO,L1,CC,IM1,IN1,CH,IM2,IN2,WA1,WA2)
      DOUBLE PRECISION ARG
      DOUBLE PRECISION TAUR
      DOUBLE PRECISION TAUI
      DOUBLE PRECISION CC(IN1,IDO,3,L1),CH(IN2,IDO,L1,3),WA1(IDO),
     +                 WA2(IDO)
C
      M1D = (M-1)*IM1 + 1
      M2S = 1 - IM2
      ARG = 2.D0*4.D0*ATAN(1.0D0)/3.D0
      TAUR = COS(ARG)
      TAUI = SIN(ARG)
      DO 101 K = 1,L1
          M2 = M2S
          DO 1001 M1 = 1,M1D,IM1
              M2 = M2 + IM2
              CH(M2,1,K,1) = CC(M1,1,1,K) + 2.D0*CC(M1,IDO,2,K)
              CH(M2,1,K,2) = CC(M1,1,1,K) + (2.D0*TAUR)*CC(M1,IDO,2,K) -
     +                       (2.D0*TAUI)*CC(M1,1,3,K)
              CH(M2,1,K,3) = CC(M1,1,1,K) + (2.D0*TAUR)*CC(M1,IDO,2,K) +
     +                       2.D0*TAUI*CC(M1,1,3,K)
 1001     CONTINUE
  101 CONTINUE
      IF (IDO.EQ.1) RETURN
      IDP2 = IDO + 2
      DO 103 K = 1,L1
          DO 102 I = 3,IDO,2
              IC = IDP2 - I
              M2 = M2S
              DO 1002 M1 = 1,M1D,IM1
                  M2 = M2 + IM2
                  CH(M2,I-1,K,1) = CC(M1,I-1,1,K) +
     +                             (CC(M1,I-1,3,K)+CC(M1,IC-1,2,K))
                  CH(M2,I,K,1) = CC(M1,I,1,K) +
     +                           (CC(M1,I,3,K)-CC(M1,IC,2,K))
                  CH(M2,I-1,K,2) = WA1(I-2)*
     +                             ((CC(M1,I-1,1,K)+TAUR* (CC(M1,I-1,3,
     +                             K)+CC(M1,IC-1,2,K)))-
     +                             (TAUI* (CC(M1,I,3,K)+CC(M1,IC,2,K))))
     +                             - WA1(I-1)* ((CC(M1,I,1,
     +                             K)+TAUR* (CC(M1,I,3,K)-CC(M1,IC,2,
     +                             K)))+ (TAUI* (CC(M1,I-1,3,K)-CC(M1,
     +                             IC-1,2,K))))
                  CH(M2,I,K,2) = WA1(I-2)* ((CC(M1,I,1,K)+TAUR* (CC(M1,
     +                           I,3,K)-CC(M1,IC,2,K)))+
     +                           (TAUI* (CC(M1,I-1,3,K)-CC(M1,IC-1,2,
     +                           K)))) + WA1(I-1)* ((CC(M1,I-1,1,
     +                           K)+TAUR* (CC(M1,I-1,3,K)+CC(M1,IC-1,2,
     +                           K)))- (TAUI* (CC(M1,I,3,K)+CC(M1,IC,2,
     +                           K))))
                  CH(M2,I-1,K,3) = WA2(I-2)*
     +                             ((CC(M1,I-1,1,K)+TAUR* (CC(M1,I-1,3,
     +                             K)+CC(M1,IC-1,2,K)))+
     +                             (TAUI* (CC(M1,I,3,K)+CC(M1,IC,2,K))))
     +                             - WA2(I-1)* ((CC(M1,I,1,
     +                             K)+TAUR* (CC(M1,I,3,K)-CC(M1,IC,2,
     +                             K)))- (TAUI* (CC(M1,I-1,3,K)-CC(M1,
     +                             IC-1,2,K))))
                  CH(M2,I,K,3) = WA2(I-2)* ((CC(M1,I,1,K)+TAUR* (CC(M1,
     +                           I,3,K)-CC(M1,IC,2,K)))-
     +                           (TAUI* (CC(M1,I-1,3,K)-CC(M1,IC-1,2,
     +                           K)))) + WA2(I-1)* ((CC(M1,I-1,1,
     +                           K)+TAUR* (CC(M1,I-1,3,K)+CC(M1,IC-1,2,
     +                           K)))+ (TAUI* (CC(M1,I,3,K)+CC(M1,IC,2,
     +                           K))))
 1002         CONTINUE
  102     CONTINUE
  103 CONTINUE
      RETURN
      END

C NCLFORTSTART                                                        
      subroutine wrfcttcalc(prs,tk,qci,qcw,qvp,ght,ter,ctt,
     &                      haveqci,nz,ns,ew)

      implicit none
      integer nz,ns,ew,haveqci 
      double precision    ght(ew,ns,nz)
      double precision    prs(ew,ns,nz),tk(ew,ns,nz)
      double precision    qci(ew,ns,nz),qcw(ew,ns,nz)
      double precision    qvp(ew,ns,nz)
      double precision    ctt(ew,ns),ter(ew,ns)
c      double precision    znfac(nz)
C NCLEND
c
c
      integer i,j,k,mjx,miy,mkzh,ripk,wrfout
      double precision    vt,rgas,grav,opdepthu,opdepthd,dp
      double precision    ratmix,eps,arg1,arg2,agl_hgt,ussalr
      double precision    abscoefi,abscoef,fac,prsctt,celkel
c      double precision    ght(ew,ns,nz),stuff(ew,ns)
      double precision    pf(ns,ew,nz),p1,p2
c
c
       mjx      =   ew 
       miy      =   ns 
       mkzh     =   nz 
       eps      = 0.622d0
       ussalr   = .0065d0      ! deg C per m
       rgas     = 287.04d0     !J/K/kg
       grav     = 9.81d0
       abscoefi = .272d0  ! cloud ice absorption coefficient in m^2/g
       abscoef  =.145d0   ! cloud water absorption coefficient in m^2/g
       celkel   = 273.15d0 
       wrfout = 1


cCalculate the surface pressure 
       do j=1,ew
       do i=1,ns
           ratmix     = .001d0*qvp(j,i,1)
           arg1       = eps + ratmix
           arg2       = eps*(1.+ratmix)
           vt         =  tk(j,i,1) * arg1/arg2 !Virtual temperature
           agl_hgt    = ght(j,i,nz) - ter(j,i)
           arg1       = -grav/(rgas*ussalr)
           pf(i,j,nz) = prs(j,i,1)*
     &                        (vt/(vt+ussalr*(agl_hgt)))**(arg1)
       enddo
       enddo


c
       do j=1,ew
       do i=1,ns
          do k=1,nz-1
            ripk = nz-k+1
            pf(i,j,k)=.5d0*(prs(j,i,ripk)+prs(j,i,ripk-1))
          enddo
      enddo
      enddo

      do 190 j=1,ew
      do 190 i=1,ns
         opdepthd=0.d0
         k=0

c
c      Integrate downward from model top, calculating path at full
c      model vertical levels.
c
   20    opdepthu=opdepthd
         k=k+1
         ripk = nz-k+1

         if (k.eq.1) then
            dp=200.d0*(pf(i,j,1)-prs(j,i,nz))  ! should be in Pa
         else
            dp=100.d0*(pf(i,j,k)-pf(i,j,k-1))  ! should be in Pa
         endif 
         if (haveqci .eq. 0) then
            if (tk(i,j,k).lt.celkel) then
c             Note: abscoefi is m**2/g, qcw is g/kg,
c                   so no convrsion needed
               opdepthd=opdepthu+abscoefi*qcw(j,i,k)*dp/grav
            else
               opdepthd=opdepthu+abscoef*qcw(j,i,k)*dp/grav
            endif
         else
            opdepthd=opdepthd+(abscoef*qcw(j,i,ripk)+
     &                         abscoefi*qci(j,i,ripk))*dp/grav
         endif
         
          if (opdepthd.lt.1..and.k.lt.nz) then
            goto 20
         elseif (opdepthd.lt.1..and.k.eq.nz) then
            prsctt=prs(j,i,1)
         else
            fac=(1.-opdepthu)/(opdepthd-opdepthu)
            prsctt=pf(i,j,k-1)+fac*(pf(i,j,k)-pf(i,j,k-1))
            prsctt=min(prs(j,i,1),max(prs(j,i,nz),prsctt))
         endif

         do 30 k=2,nz
            ripk = nz-k+1
            p1   = prs(j,i,ripk+1)
            p2   = prs(j,i,ripk)
            if (prsctt .ge. p1 .and. prsctt .le .p2) then
               fac=(prsctt-p1)/(p2-p1)
               arg1 = fac*(tk(j,i,ripk)-tk(j,i,ripk+1))-celkel
               ctt(j,i) = tk(j,i,ripk+1)+ arg1
               goto 40
            endif
   30    continue 
   40    continue
 190  continue
      return
      end

      SUBROUTINE CTGSNA( JOB, HOWMNY, SELECT, N, A, LDA, B, LDB, VL,
     $                   LDVL, VR, LDVR, S, DIF, MM, M, WORK, LWORK,
     $                   IWORK, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          HOWMNY, JOB
      INTEGER            INFO, LDA, LDB, LDVL, LDVR, LWORK, M, MM, N
*     ..
*     .. Array Arguments ..
      LOGICAL            SELECT( * )
      INTEGER            IWORK( * )
      REAL               DIF( * ), S( * )
      COMPLEX            A( LDA, * ), B( LDB, * ), VL( LDVL, * ),
     $                   VR( LDVR, * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  CTGSNA estimates reciprocal condition numbers for specified
*  eigenvalues and/or eigenvectors of a matrix pair (A, B).
*
*  (A, B) must be in generalized Schur canonical form, that is, A and
*  B are both upper triangular.
*
*  Arguments
*  =========
*
*  JOB     (input) CHARACTER*1
*          Specifies whether condition numbers are required for
*          eigenvalues (S) or eigenvectors (DIF):
*          = 'E': for eigenvalues only (S);
*          = 'V': for eigenvectors only (DIF);
*          = 'B': for both eigenvalues and eigenvectors (S and DIF).
*
*  HOWMNY  (input) CHARACTER*1
*          = 'A': compute condition numbers for all eigenpairs;
*          = 'S': compute condition numbers for selected eigenpairs
*                 specified by the array SELECT.
*
*  SELECT  (input) LOGICAL array, dimension (N)
*          If HOWMNY = 'S', SELECT specifies the eigenpairs for which
*          condition numbers are required. To select condition numbers
*          for the corresponding j-th eigenvalue and/or eigenvector,
*          SELECT(j) must be set to .TRUE..
*          If HOWMNY = 'A', SELECT is not referenced.
*
*  N       (input) INTEGER
*          The order of the square matrix pair (A, B). N >= 0.
*
*  A       (input) COMPLEX array, dimension (LDA,N)
*          The upper triangular matrix A in the pair (A,B).
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A. LDA >= max(1,N).
*
*  B       (input) COMPLEX array, dimension (LDB,N)
*          The upper triangular matrix B in the pair (A, B).
*
*  LDB     (input) INTEGER
*          The leading dimension of the array B. LDB >= max(1,N).
*
*  VL      (input) COMPLEX array, dimension (LDVL,M)
*          IF JOB = 'E' or 'B', VL must contain left eigenvectors of
*          (A, B), corresponding to the eigenpairs specified by HOWMNY
*          and SELECT.  The eigenvectors must be stored in consecutive
*          columns of VL, as returned by CTGEVC.
*          If JOB = 'V', VL is not referenced.
*
*  LDVL    (input) INTEGER
*          The leading dimension of the array VL. LDVL >= 1; and
*          If JOB = 'E' or 'B', LDVL >= N.
*
*  VR      (input) COMPLEX array, dimension (LDVR,M)
*          IF JOB = 'E' or 'B', VR must contain right eigenvectors of
*          (A, B), corresponding to the eigenpairs specified by HOWMNY
*          and SELECT.  The eigenvectors must be stored in consecutive
*          columns of VR, as returned by CTGEVC.
*          If JOB = 'V', VR is not referenced.
*
*  LDVR    (input) INTEGER
*          The leading dimension of the array VR. LDVR >= 1;
*          If JOB = 'E' or 'B', LDVR >= N.
*
*  S       (output) REAL array, dimension (MM)
*          If JOB = 'E' or 'B', the reciprocal condition numbers of the
*          selected eigenvalues, stored in consecutive elements of the
*          array.
*          If JOB = 'V', S is not referenced.
*
*  DIF     (output) REAL array, dimension (MM)
*          If JOB = 'V' or 'B', the estimated reciprocal condition
*          numbers of the selected eigenvectors, stored in consecutive
*          elements of the array.
*          If the eigenvalues cannot be reordered to compute DIF(j),
*          DIF(j) is set to 0; this can only occur when the true value
*          would be very small anyway.
*          For each eigenvalue/vector specified by SELECT, DIF stores
*          a Frobenius norm-based estimate of Difl.
*          If JOB = 'E', DIF is not referenced.
*
*  MM      (input) INTEGER
*          The number of elements in the arrays S and DIF. MM >= M.
*
*  M       (output) INTEGER
*          The number of elements of the arrays S and DIF used to store
*          the specified condition numbers; for each selected eigenvalue
*          one element is used. If HOWMNY = 'A', M is set to N.
*
*  WORK    (workspace/output) COMPLEX array, dimension (LWORK)
*          If JOB = 'E', WORK is not referenced.  Otherwise,
*          on exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*
*  LWORK  (input) INTEGER
*          The dimension of the array WORK. LWORK >= 1.
*          If JOB = 'V' or 'B', LWORK >= 2*N*N.
*
*  IWORK   (workspace) INTEGER array, dimension (N+2)
*          If JOB = 'E', IWORK is not referenced.
*
*  INFO    (output) INTEGER
*          = 0: Successful exit
*          < 0: If INFO = -i, the i-th argument had an illegal value
*
*  Further Details
*  ===============
*
*  The reciprocal of the condition number of the i-th generalized
*  eigenvalue w = (a, b) is defined as
*
*          S(I) = (|v'Au|**2 + |v'Bu|**2)**(1/2) / (norm(u)*norm(v))
*
*  where u and v are the right and left eigenvectors of (A, B)
*  corresponding to w; |z| denotes the absolute value of the complex
*  number, and norm(u) denotes the 2-norm of the vector u. The pair
*  (a, b) corresponds to an eigenvalue w = a/b (= v'Au/v'Bu) of the
*  matrix pair (A, B). If both a and b equal zero, then (A,B) is
*  singular and S(I) = -1 is returned.
*
*  An approximate error bound on the chordal distance between the i-th
*  computed generalized eigenvalue w and the corresponding exact
*  eigenvalue lambda is
*
*          chord(w, lambda) <=   EPS * norm(A, B) / S(I),
*
*  where EPS is the machine precision.
*
*  The reciprocal of the condition number of the right eigenvector u
*  and left eigenvector v corresponding to the generalized eigenvalue w
*  is defined as follows. Suppose
*
*                   (A, B) = ( a   *  ) ( b  *  )  1
*                            ( 0  A22 ),( 0 B22 )  n-1
*                              1  n-1     1 n-1
*
*  Then the reciprocal condition number DIF(I) is
*
*          Difl[(a, b), (A22, B22)]  = sigma-min( Zl )
*
*  where sigma-min(Zl) denotes the smallest singular value of
*
*         Zl = [ kron(a, In-1) -kron(1, A22) ]
*              [ kron(b, In-1) -kron(1, B22) ].
*
*  Here In-1 is the identity matrix of size n-1 and X' is the conjugate
*  transpose of X. kron(X, Y) is the Kronecker product between the
*  matrices X and Y.
*
*  We approximate the smallest singular value of Zl with an upper
*  bound. This is done by CLATDF.
*
*  An approximate error bound for a computed eigenvector VL(i) or
*  VR(i) is given by
*
*                      EPS * norm(A, B) / DIF(i).
*
*  See ref. [2-3] for more details and further references.
*
*  Based on contributions by
*     Bo Kagstrom and Peter Poromaa, Department of Computing Science,
*     Umea University, S-901 87 Umea, Sweden.
*
*  References
*  ==========
*
*  [1] B. Kagstrom; A Direct Method for Reordering Eigenvalues in the
*      Generalized Real Schur Form of a Regular Matrix Pair (A, B), in
*      M.S. Moonen et al (eds), Linear Algebra for Large Scale and
*      Real-Time Applications, Kluwer Academic Publ. 1993, pp 195-218.
*
*  [2] B. Kagstrom and P. Poromaa; Computing Eigenspaces with Specified
*      Eigenvalues of a Regular Matrix Pair (A, B) and Condition
*      Estimation: Theory, Algorithms and Software, Report
*      UMINF - 94.04, Department of Computing Science, Umea University,
*      S-901 87 Umea, Sweden, 1994. Also as LAPACK Working Note 87.
*      To appear in Numerical Algorithms, 1996.
*
*  [3] B. Kagstrom and P. Poromaa, LAPACK-Style Algorithms and Software
*      for Solving the Generalized Sylvester Equation and Estimating the
*      Separation between Regular Matrix Pairs, Report UMINF - 93.23,
*      Department of Computing Science, Umea University, S-901 87 Umea,
*      Sweden, December 1993, Revised April 1994, Also as LAPACK Working
*      Note 75.
*      To appear in ACM Trans. on Math. Software, Vol 22, No 1, 1996.
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ZERO, ONE
      INTEGER            IDIFJB
      PARAMETER          ( ZERO = 0.0E+0, ONE = 1.0E+0, IDIFJB = 3 )
*     ..
*     .. Local Scalars ..
      LOGICAL            LQUERY, SOMCON, WANTBH, WANTDF, WANTS
      INTEGER            I, IERR, IFST, ILST, K, KS, LLWRK, LWMIN,
     $                   N1, N2
      REAL               BIGNUM, COND, EPS, LNRM, RNRM, SCALE, SMLNUM
      COMPLEX            YHAX, YHBX
*     ..
*     .. Local Arrays ..
      COMPLEX            DUMMY( 1 ), DUMMY1( 1 )
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      REAL               SCNRM2, SLAMCH, SLAPY2
      COMPLEX            CDOTC
      EXTERNAL           LSAME, SCNRM2, SLAMCH, SLAPY2, CDOTC
*     ..
*     .. External Subroutines ..
      EXTERNAL           CGEMV, CLACPY, CTGEXC, CTGSYL, SLABAD, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, CMPLX, MAX
*     ..
*     .. Executable Statements ..
*
*     Decode and test the input parameters
*
      WANTBH = LSAME( JOB, 'B' )
      WANTS = LSAME( JOB, 'E' ) .OR. WANTBH
      WANTDF = LSAME( JOB, 'V' ) .OR. WANTBH
*
      SOMCON = LSAME( HOWMNY, 'S' )
*
      INFO = 0
      LQUERY = ( LWORK.EQ.-1 )
*
      IF( LSAME( JOB, 'V' ) .OR. LSAME( JOB, 'B' ) ) THEN
         LWMIN = MAX( 1, 2*N*N )
      ELSE
         LWMIN = 1
      END IF
*
      IF( .NOT.WANTS .AND. .NOT.WANTDF ) THEN
         INFO = -1
      ELSE IF( .NOT.LSAME( HOWMNY, 'A' ) .AND. .NOT.SOMCON ) THEN
         INFO = -2
      ELSE IF( N.LT.0 ) THEN
         INFO = -4
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -6
      ELSE IF( LDB.LT.MAX( 1, N ) ) THEN
         INFO = -8
      ELSE IF( WANTS .AND. LDVL.LT.N ) THEN
         INFO = -10
      ELSE IF( WANTS .AND. LDVR.LT.N ) THEN
         INFO = -12
      ELSE
*
*        Set M to the number of eigenpairs for which condition numbers
*        are required, and test MM.
*
         IF( SOMCON ) THEN
            M = 0
            DO 10 K = 1, N
               IF( SELECT( K ) )
     $            M = M + 1
   10       CONTINUE
         ELSE
            M = N
         END IF
*
         IF( MM.LT.M ) THEN
            INFO = -15
         ELSE IF( LWORK.LT.LWMIN .AND. .NOT.LQUERY ) THEN
            INFO = -18
         END IF
      END IF
*
      IF( INFO.EQ.0 ) THEN
         WORK( 1 ) = LWMIN
      END IF
*
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'CTGSNA', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
*
*     Get machine constants
*
      EPS = SLAMCH( 'P' )
      SMLNUM = SLAMCH( 'S' ) / EPS
      BIGNUM = ONE / SMLNUM
      CALL SLABAD( SMLNUM, BIGNUM )
      LLWRK = LWORK - 2*N*N
      KS = 0
      DO 20 K = 1, N
*
*        Determine whether condition numbers are required for the k-th
*        eigenpair.
*
         IF( SOMCON ) THEN
            IF( .NOT.SELECT( K ) )
     $         GO TO 20
         END IF
*
         KS = KS + 1
*
         IF( WANTS ) THEN
*
*           Compute the reciprocal condition number of the k-th
*           eigenvalue.
*
            RNRM = SCNRM2( N, VR( 1, KS ), 1 )
            LNRM = SCNRM2( N, VL( 1, KS ), 1 )
            CALL CGEMV( 'N', N, N, CMPLX( ONE, ZERO ), A, LDA,
     $                  VR( 1, KS ), 1, CMPLX( ZERO, ZERO ), WORK, 1 )
            YHAX = CDOTC( N, WORK, 1, VL( 1, KS ), 1 )
            CALL CGEMV( 'N', N, N, CMPLX( ONE, ZERO ), B, LDB,
     $                  VR( 1, KS ), 1, CMPLX( ZERO, ZERO ), WORK, 1 )
            YHBX = CDOTC( N, WORK, 1, VL( 1, KS ), 1 )
            COND = SLAPY2( ABS( YHAX ), ABS( YHBX ) )
            IF( COND.EQ.ZERO ) THEN
               S( KS ) = -ONE
            ELSE
               S( KS ) = COND / ( RNRM*LNRM )
            END IF
         END IF
*
         IF( WANTDF ) THEN
            IF( N.EQ.1 ) THEN
               DIF( KS ) = SLAPY2( ABS( A( 1, 1 ) ), ABS( B( 1, 1 ) ) )
               GO TO 20
            END IF
*
*           Estimate the reciprocal condition number of the k-th
*           eigenvectors.
*
*           Copy the matrix (A, B) to the array WORK and move the
*           (k,k)th pair to the (1,1) position.
*
            CALL CLACPY( 'Full', N, N, A, LDA, WORK, N )
            CALL CLACPY( 'Full', N, N, B, LDB, WORK( N*N+1 ), N )
            IFST = K
            ILST = 1
*
            CALL CTGEXC( .FALSE., .FALSE., N, WORK, N, WORK( N*N+1 ), N,
     $                   DUMMY, 1, DUMMY1, 1, IFST, ILST, IERR )
*
            IF( IERR.GT.0 ) THEN
*
*              Ill-conditioned problem - swap rejected.
*
               DIF( KS ) = ZERO
            ELSE
*
*              Reordering successful, solve generalized Sylvester
*              equation for R and L,
*                         A22 * R - L * A11 = A12
*                         B22 * R - L * B11 = B12,
*              and compute estimate of Difl[(A11,B11), (A22, B22)].
*
               N1 = 1
               N2 = N - N1
               I = N*N + 1
               CALL CTGSYL( 'N', IDIFJB, N2, N1, WORK( N*N1+N1+1 ), N,
     $                      WORK, N, WORK( N1+1 ), N, WORK( N*N1+N1+I ),
     $                      N, WORK( I ), N, WORK( N1+I ), N, SCALE,
     $                      DIF( KS ), WORK( N*N*2+1 ), LLWRK, IWORK,
     $                      IERR )
            END IF
         END IF
*
   20 CONTINUE
      WORK( 1 ) = LWMIN
      RETURN
*
*     End of CTGSNA
*
      END

C
C	$Id: wmintv.f,v 1.4 2008-07-27 00:17:36 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE WMINTV(X0,X,N,NDX)
C
C  Given a value X0 and an array X (of length N) of monotone
C  increasing values, this subroutine returns the index NDX
C  such that:
C
C    NDX = 1    if  X0 .LT. X(2)
C    NDX = N-1  if  X(N-1) .LT. X0
C    NDX = I    if  X(I) .LE. X0  and  X0 .LE. X(I+1)
C
      DIMENSION X(N)
C
      XX = X0
C
C  Handle extremes.
C
      IF (XX .LE. X(2)) THEN
        NDX = 1
        RETURN
      ELSE IF (XX .GE. X(N-1)) THEN
        NDX = N-1
        RETURN
      END IF
C
C  Binary search.
C
      IL = 2
      IH = N-1
   10 CONTINUE
      I = (IL+IH)/2
      IF (XX .LT. X(I)) THEN
         IH = I
      ELSE IF (XX .GT. X(I+1)) THEN
         IL = I+1
      ELSE
         NDX = I
         RETURN
      END IF
      GO TO 10
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C   FFTPACK 5.0
C   Copyright (C) 1995-2004, Scientific Computing Division,
C   University Corporation for Atmospheric Research
C   Licensed under the GNU General Public License (GPL)
C
C   Authors:  Paul N. Swarztrauber and Richard A. Valent
C
C   $Id: costmf.f,v 1.2 2006-11-21 01:10:17 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      SUBROUTINE DCOSTMF(LOT,JUMP,N,INC,X,LENX,WSAVE,LENSAV,WORK,
     +                   LENWRK,IER)
      INTEGER LOT,JUMP,N,INC,LENX,LENSAV,LENWRK,IER
      DOUBLE PRECISION X(INC,*),WSAVE(LENSAV),WORK(LENWRK)
      LOGICAL DXERCON
C
      IER = 0
C
      IF (LENX.LT. (LOT-1)*JUMP+INC* (N-1)+1) THEN
          IER = 1
          CALL DXERFFT('COSTMF',6)
          GO TO 100
      ELSE IF (LENSAV.LT.2*N+INT(LOG(DBLE(N)))+4) THEN
          IER = 2
          CALL DXERFFT('COSTMF',8)
          GO TO 100
      ELSE IF (LENWRK.LT.LOT* (N+1)) THEN
          IER = 3
          CALL DXERFFT('COSTMF',10)
          GO TO 100
      ELSE IF (.NOT.DXERCON(INC,JUMP,N,LOT)) THEN
          IER = 4
          CALL DXERFFT('COSTMF',-1)
          GO TO 100
      END IF
C
      IW1 = LOT + LOT + 1
      CALL DMCSTF1(LOT,JUMP,N,INC,X,WSAVE,WORK,WORK(IW1),IER1)
      IF (IER1.NE.0) THEN
          IER = 20
          CALL DXERFFT('COSTMF',-5)
      END IF
C
  100 CONTINUE
      RETURN
      END

      PROGRAM TISOHR
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C OPEN GKS, OPEN WORKSTATION OF TYPE 1, ACTIVATE WORKSTATION
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C INVOKE DEMO DRIVER
C
      CALL ISOSCR()
      CALL ISOHR(IERR)
C
C DEACTIVATE AND CLOSE WORKSTATION, CLOSE GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END
C
      SUBROUTINE ISOHR (IERROR)
C
C PURPOSE                To provide a simple demonstration of ISOSRFHR.
C
C USAGE                  CALL ISOHR (IERROR)
C
C ARGUMENTS
C
C ON OUTPUT              IERROR
C                          An integer variable
C                          = 0, if the test was successful,
C                          = 1, the test was not successful.
C
C I/O                    A scratch file must be assigned to unit IUNIT.
C                        Common block UNITS should be inserted in the
C                        calling program.  Then, set IUNIT in the
C                        calling program.
C
C                        If the test is successful, the message
C
C               ISOSRFHR TEST EXECUTED--SEE PLOT TO CERTIFY
C
C                        is printed on unit 6.  In addition, 1
C                        frame is produced on the machine graphics
C                        device.  In order to determine if the test
C                        was successful, it is necessary to examine
C                        the plot.
C
C PRECISION              Single
C
C LANGUAGE               FORTRAN 77
C
C REQUIRED ROUTINES      ISOSRFHR
C
C REQUIRED GKS LEVEL     0A
C
C ALGORITHM              This test program draws a perspective view
C                        of 2 interlocking doughnuts.
C
      DIMENSION       EYE(3)     ,S(4)       ,IS2(4,200) ,
     1                ST1(81,51,2)           ,IOBJS(81,51)
      COMMON /UNITS/  IUNIT
      SAVE
C
C Specify coordinates for plot titles on a square grid of integer
C coordinates that range from 1 to 1024.  IX and IY define the center
C of the title string.
C
      DATA IX/448/, IY/990/
C
C
C Define the eye position.
C
      DATA            EYE(1), EYE(2), EYE(3) / 200., 250., 250. /
C
C Define the overall dimensions of the box containing the objects.
C
      DATA            NU, NV, NW /  51, 81, 51 /
C
C Specify the dimensions of the model of the image plane.
C
      DATA            LX, NX, NY / 4, 180, 180 /
C
C Specify the user viewport in a 1 to 1024 range.
C
      DATA            S(1),S(2),S(3),S(4)/ 10.,1010.,10.,1010./
      DATA            MV / 81 /
C
C Specify the large and small radii for the individual doughnuts.
C
      DATA            RBIG1,RBIG2,RSML1,RSML2/ 20., 20., 6., 6. /
C
C
C Call the initialization routine.
C
      CALL INIT3D (EYE,NU,NV,NW,ST1,LX,NY,IS2,IUNIT,S)
C
C Initialize the error indicator
C
      IERROR = 1
C
C Create and plot the interlocking doughnuts.
C
      JCENT1 = REAL(NV)*.5-RBIG1*.5
      JCENT2 = REAL(NV)*.5+RBIG2*.5
      DO  70 IBKWDS=1,NU
         I = NU+1-IBKWDS
C
C Create the i-th cross section in the U direction of the 3-D array
C and store in IOBJS as zeros and ones.
C
         FIMID = I-NU/2
         DO  20 J=1,NV
            FJMID1 = J-JCENT1
            FJMID2 = J-JCENT2
            DO  10 K=1,NW
               FKMID = K-NW/2
               F1 = SQRT(RBIG1*RBIG1/(FJMID1*FJMID1+FKMID*FKMID+.1))
               F2 = SQRT(RBIG2*RBIG2/(FIMID*FIMID+FJMID2*FJMID2+.1))
               FIP1 = (1.-F1)*FIMID
               FIP2 = (1.-F2)*FIMID
               FJP1 = (1.-F1)*FJMID1
               FJP2 = (1.-F2)*FJMID2
               FKP1 = (1.-F1)*FKMID
               FKP2 = (1.-F2)*FKMID
               TEMP = MIN(FIMID**2+FJP1**2+FKP1**2-RSML1**2,
     1                                FKMID**2+FIP2**2+FJP2**2-RSML2**2)
               IF (TEMP .LE. 0.) IOBJS(J,K) = 1
               IF (TEMP .GT. 0.) IOBJS(J,K) = 0
   10       CONTINUE
   20    CONTINUE
C
C Set proper words to 1 for drawing axes.
C
         IF (I .NE. 1) GO TO  50
         DO  30 K=1,NW
            IOBJS(1,K) = 1
   30    CONTINUE
         DO  40 J=1,NV
            IOBJS(J,1) = 1
   40    CONTINUE
         GO TO  60
   50    CONTINUE
         IOBJS(1,1) = 1
   60    CONTINUE
C
C Call the draw and remember routine for this slab.
C
      CALL DANDR (NV,NW,ST1,LX,NX,NY,IS2,IUNIT,S,IOBJS,MV)
   70 CONTINUE
C
      CALL GQCNTN(IER,ICN)
C
C Select normalization transformation 0.
C
      CALL GSELNT(0)
C
C Call PLCHLQ to write the plot title.
C
      XC = CPUX(IX)
      YC = CPUY(IY)
      CALL PLCHLQ(XC,YC,'DEMONSTRATION PLOT FOR ISOSRFHR',16.,0.,0.)
      CALL GSELNT(ICN)
C
C Advance the frame.
C
      CALL FRAME
C
      IERROR = 0
      WRITE (6,1001)
      RETURN
C
 1001 FORMAT (' ISOSRFHR TEST EXECUTED--SEE PLOT TO CERTIFY')
C
      END

      PROGRAM CARDB2
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER (LMAP=150000, NMAP=43, NPTS=50, NCNTR=5)
      
      INTEGER MAP(LMAP)
      REAL XGEO(NMAP), YGEO(NMAP), X(12), Y(12)
      REAL XCNTR(NPTS), YCNTR1(NPTS), YCNTR2(NPTS), YCNTR3(NPTS)
      REAL YCNTR4(NPTS), YCNTR5(NPTS), XPERIM(5), YPERIM(5)
      
      DATA XGEO / .63, .12, .05, .07, .10, .04, .19, .31, .31, .41,
     1      .39, .47, .64, .63, .70, .66, .67, .69, .76, .92,
     2      .95, .69, .64, .53, .53, .60, .63, .63, .72, .74,
     3      .79, .75, .75, .80, .75, .70, .68, .64, .63, .55,
     4      .55, .63, .63/
      DATA YGEO / .94, .95, .92, .85, .83, .78, .84, .75, .69, .58,
     1      .64, .55, .47, .37, .30, .05, .03, .05, .13, .26,
     2      .38, .52, .50, .57, .63, .63, .59, .64, .72, .71,
     3      .75, .75, .77, .78, .85, .83, .86, .86, .77, .80,
     4      .86, .90, .94/
      DATA XPERIM /0.0, 1.0, 1.0, 0.0, 0.0/
      DATA YPERIM /0.0, 0.0, 1.0, 1.0, 0.0/
      DATA X /.10, .22, .25, .25, .25, .50,
     1      .30, .47, .50, .77, .75, .68/
      DATA Y /.98, .70, .55, .38, .18, .18,
     1      .90, .85, .70, .35, .18, .05/
      
      XCNTR(1) = 0.0
      YCNTR1(1) = 0.27
      YCNTR2(1) = 0.22
      YCNTR3(1) = 0.60
      YCNTR4(1) = 0.80
      YCNTR5(1) = 0.95
      DO 10 J=2,NPTS
         DIST = REAL(J)/REAL(NPTS)
         XCNTR(J) = DIST
         YCNTR1(J) = .1*COS(REAL(4*3.14*DIST))+.15
         YCNTR2(J) = .1*SIN(REAL(4*3.14*DIST-.78))+.30
         YCNTR3(J) = .1*COS(REAL(4*3.14*DIST))+.50
         YCNTR4(J) = .1*COS(REAL(4*3.14*DIST))+.70
         YCNTR5(J) = .1*COS(REAL(4*3.14*DIST))+.85
 10   CONTINUE
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Define color table
C
      CALL COLOR(IWKID)
C
C Label the first plot.
C
      CALL GSTXCI (7)
      CALL PLCHLQ (CFUX(.5),CFUY(.98),
     +             'Crossing contours over the "Americas"',.015,0.,0.)
C
C Outline continents in red
C
      CALL GSPLCI (1)
      CALL CURVE (XGEO,YGEO,NMAP)
C
C Outline contours and perimeter in green
C
      CALL GSPLCI (2)
      CALL CURVE (XCNTR,YCNTR1,NPTS)
      CALL CURVE (XCNTR,YCNTR2,NPTS)
      CALL CURVE (XCNTR,YCNTR3,NPTS)
      CALL CURVE (XCNTR,YCNTR4,NPTS)
      CALL CURVE (XCNTR,YCNTR5,NPTS)
      CALL CURVE (XPERIM,YPERIM,5)
C
C Advance the frame.
C
      CALL FRAME
C
C Initialize Areas
C
      CALL ARINAM (MAP,LMAP)
C
C Add continents to area map in group 1.
C
      CALL AREDAM (MAP, XGEO, YGEO, NMAP, 1, 2, 1)
C
C Add contours and perimeter to area map in group 3.
C
      CALL AREDAM (MAP, XCNTR, YCNTR1, NPTS, 3, 2, 1)
      CALL AREDAM (MAP, XCNTR, YCNTR2, NPTS, 3, 3, 2)
      CALL AREDAM (MAP, XCNTR, YCNTR3, NPTS, 3, 4, 3)
      CALL AREDAM (MAP, XCNTR, YCNTR4, NPTS, 3, 5, 4)
      CALL AREDAM (MAP, XCNTR, YCNTR5, NPTS, 3, 6, 5)
C
C Run debugging subroutine on group 1
C
      CALL ARDBPA (MAP,1,'ARDBPA output - group 1 - "Americas"')
C
C Run debugging subroutine on group 3
C
      CALL ARDBPA (MAP,3,'ARDBPA output - group 3 - Crossing Contours')
C
C Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
 11   FORMAT ('A(',I1,')=',I1,' G(',I1,')=',I1)
      STOP
      END

      SUBROUTINE COLOR(IWKID)
C
C Define color table
C
      CALL GSCR(IWKID,0,0.,0.,0.)
      CALL GSCR(IWKID,1,1.,0.,0.)
      CALL GSCR(IWKID,2,0.,1.,0.)
      CALL GSCR(IWKID,3,1.,1.,0.)
      CALL GSCR(IWKID,4,0.,0.,1.)
      CALL GSCR(IWKID,5,1.,0.,1.)
      CALL GSCR(IWKID,6,0.,1.,1.)
      CALL GSCR(IWKID,7,1.,1.,1.)
      
      RETURN
      END

C
C       $Id: vvdrwb.f,v 1.8 2008-07-27 00:17:35 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE VVDRWB (XB,YB,XE,YE,VLN,LBL,NC,IAM,VVUDMV,IDA)
C
      DIMENSION IAM(*)
C
      EXTERNAL VVUDMV
C
C This routine is called to draw a single wind barb. Its 
C arguments are the same as the line-based arrow drawing routine 
C VVDRAW. However it uses other parameters from the VVARO common block
C
C XB,YB    -  Coordinate of arrow base, fractional coordinate
C XE,YE    -  Coordinate of arrow head, fractional coordinate
C VLN      -  Length of the vector (arrow)
C          -  (if negative does not draw the vector, but just 
C          -  calculates the vector's height and width)
C LBL      -  Character label to be put above arrow.
C NC       -  Number of characters in label.
C IAM      -  Area map (optional) for masking vectors
C VVUDMV   -  User-supplied function for drawing masked vectors
C IDA      -  Do area masking flag
C
C ---------------------------------------------------------------------
C
C NOTE:
C Since implicit typing is used for all real and integer variables
C a consistent length convention has been adopted to help clarify the
C significance of the variables encountered in the code for this 
C utility. All local variable and subroutine parameter identifiers 
C are limited to 1,2,or 3 characters. Four character names identify  
C members of common blocks. Five and 6 character variable names 
C denote PARAMETER constants or subroutine or function names.
C
C Declare the VV common blocks.
C
C IPLVLS - Maximum number of color threshold level values
C IPAGMX - Maximum number of area groups allowed in the area map
C
      PARAMETER (IPLVLS = 256, IPAGMX = 64)
C
C Integer and real common block variables
C
C
      COMMON /VVCOM/
     +                IUD1       ,IVD1       ,IPD1       ,IXDM       ,
     +                IYDN       ,VLOM       ,VHIM       ,ISET       ,
     +                VRMG       ,VRLN       ,VFRC       ,IXIN       ,
     +                IYIN       ,ISVF       ,UUSV       ,UVSV       ,
     +                UPSV       ,IMSK       ,ICPM       ,UVPS       ,
     +                UVPL       ,UVPR       ,UVPB       ,UVPT       ,
     +                UWDL       ,UWDR       ,UWDB       ,UWDT       ,
     +                UXC1       ,UXCM       ,UYC1       ,UYCN       ,
     +                NLVL       ,IPAI       ,ICTV       ,WDLV       ,
     +                UVMN       ,UVMX       ,PMIN       ,PMAX       ,
     +                RVMN       ,RVMX       ,RDMN       ,RDMX       ,
     +                ISPC       ,RVMD       ,IPLR       ,IVST       ,
     +                IVPO       ,ILBL       ,IDPF       ,IMSG       ,
     +                ICLR(IPLVLS)           ,TVLU(IPLVLS)
C
C Arrow size/shape parameters
C
        COMMON / VVARO /
     +                HDSZ       ,HINF       ,HANG       ,IAST       ,
     +                HSIN       ,HCOS       ,FAMN       ,FAMX       ,
     +                UVMG       ,FAIR       ,FAWR       ,FAWF       ,
     +                FAXR       ,FAXF       ,FAYR       ,FAYF       ,
     +                AROX(8)    ,AROY(8)    ,FXSZ       ,FYSZ       ,
     +                FXRF       ,FXMN       ,FYRF       ,FYMN       ,
     +                FWRF       ,FWMN       ,FIRF       ,FIMN       ,
     +                AXMN       ,AXMX       ,AYMN       ,AYMX       ,
     +                IACM       ,IAFO       ,WBAD       ,WBTF       ,
     +                WBCF       ,WBDF       ,WBSC
C
C
C Text related parameters
C
        COMMON /VVTXP /
     +                FCWM    ,ICSZ    ,
     +                FMNS    ,FMNX    ,FMNY    ,IMNP    ,IMNC  ,
     +                FMXS    ,FMXX    ,FMXY    ,IMXP    ,IMXC  ,
     +                FZFS    ,FZFX    ,FZFY    ,IZFP    ,IZFC  ,
     +                FILS    ,FILX    ,FILY    ,IILP    ,IILC  ,
     +                FLBS    ,ILBC

C
C Character variable declartions
C
      CHARACTER*160 CSTR
      PARAMETER (IPCHSZ=36)
      CHARACTER*(IPCHSZ)  CMNT,CMXT,CZFT,CLBT,CILT
C
C Text string parameters
C
      COMMON /VVCHAR/ CSTR,CMNT,CMXT,CZFT,CLBT,CILT
C
      SAVE /VVCOM/, /VVARO/, /VVTXP/, /VVCHAR/
C
C The mapping common block: made available to user mapping routines
C
      COMMON /VVMAP/
     +                IMAP       ,
     +                XVPL       ,XVPR       ,YVPB       ,YVPT       ,
     +                WXMN       ,WXMX       ,WYMN       ,WYMX       ,
     +                XLOV       ,XHIV       ,YLOV       ,YHIV       ,
     +                SXDC       ,SYDC       ,NXCT       ,NYCT       ,
     +                RLEN       ,LNLG       ,INVX       ,INVY       ,
     +                ITRT       ,IWCT       ,FW2W       ,FH2H       ,
     +                DVMN       ,DVMX       ,RBIG       ,IBIG
C
      SAVE /VVMAP/
C
C Math constants
C
      PARAMETER (PDTOR  = 0.017453292519943,
     +           PRTOD  = 57.2957795130823,
     +           P1XPI  = 3.14159265358979,
     +           P2XPI  = 6.28318530717959,
     +           P1D2PI = 1.57079632679489,
     +           P5D2PI = 7.85398163397448) 
C
C --------------------------------------------------------------------
C
C Local parameters
C
C  PENINC - Increment for which triangles are drawn.
C  BRBINC - Increment for which a full tic is drawn.
C
      PARAMETER (IADIM=6,PENINC=50.0,BRBINC=10.0)
      DIMENSION XO(IADIM),YO(IADIM)
      DIMENSION WIN(4),VPT(4)
C
      CHARACTER*10 LBL
C
      CALL GQCNTN(IER,NTR)
      CALL GQNT(NTR,IER,WIN,VPT)
      CALL GSWN(NTR,VPT(1),VPT(2),VPT(3),VPT(4))
C
C ABS(VLN) is constant and equal to DVMX for wind barbs.
C
      IF (VLN.LT.0.0) THEN
         ISZ=1
         VLL=-VLN
      ELSE
         ISZ=0
         VLL=VLN
      END IF
C
      SPD = UVMG * WBSC
C
C If low speed just draw a circle
C
      ICR = 0
      IF (SPD .LT. 0.5) THEN
         CALL GQPLCI(IER,IC)
         IF (ISZ .EQ. 0) THEN
            CALL NGDOTS(XB,YB,1,WBCF*VLL,IC)
         ELSE
            AXMN = XB - 0.5 * WBCF*VLL
            AXMX = XB + 0.5 * WBCF*VLL
            AYMN = YB - 0.5 * WBCF*VLL
            AYMX = YB + 0.5 * WBCF*VLL
         END IF
         ICR = 1
         GO TO 999
      END IF
C
C X and Y components of the vector.
C Note that direction is XB to XE. The barbs go at the XB end.
C
      DX=XE-XB
      DY=YE-YB
C
C Determinc sine and cosine of the shaft angle, and scaled speed
C
      CSA = DX / VLL
      SNA = DY / VLL
C
C Figure out how many pennants are required.
C If speed great enough to require a pennant then determine pennant 
C extent along shaft and extend shaft length to accommodate top
C pennant.
C
      NPN = INT((SPD + 2.5) / PENINC)
      XPI=-AROX(1)*CSA
      YPI=-AROX(1)*SNA
      IF (NPN .EQ. 0) THEN
         AXE = XE - XPI 
         AYE = YE - YPI
         DX=AXE-XB
         DY=AYE-YB
      END IF
C
C Adjust the coordinates of the vector endpoints as implied by the
C vector positioning option.
C
      IF (IVPO .LT. 0) THEN
         AXB = XB - DX
         AYB = YB - DY
         AXE = XB
         AYE = YB
      ELSE IF (IVPO .EQ. 0) THEN
         AXB = XB - 0.5*DX
         AYB = YB - 0.5*DY
         AXE = XB + 0.5*DX
         AYE = YB + 0.5*DY
      ELSE
         AXB = XB
         AYB = YB
         AXE = XB + DX
         AYE = YB + DY
      END IF
C
C Initial position and distance between barbs 
C
      XPS = AXB
      YPS = AYB
      XIN = WBDF*DVMX*CSA
      YIN = WBDF*DVMX*SNA
C
C Draw the shaft
C
      XO(1) = AXB
      XO(2) = AXE
      YO(1) = AYB
      YO(2) = AYE
C
      IF (ISZ .EQ. 0) THEN
         CALL GPL(2,XO,YO)
      ELSE
         AXMN = MIN(XO(1),XO(2))
         AXMX = MAX(XO(1),XO(2))
         AYMN = MIN(YO(1),YO(2))
         AYMX = MAX(YO(1),YO(2))
      END IF
C 
C For speed between 0.5 and 2.5 the shaft is unadorned
C
      IF (SPD .LT. 2.5) THEN
         GO TO 999
      END IF
C
C If speed is less than 7.5 then draw a half barb one increment down
C
      IF (SPD .LT. 7.5) THEN
         XO(1) = XPS+XIN
         YO(1) = YPS+YIN
         XO(2) = XO(1) + AROX(5)*CSA-AROY(5)*SNA
         YO(2) = YO(1) + AROX(5)*SNA+AROY(5)*CSA
         IF (ISZ .EQ. 0) THEN
            CALL GPL(2,XO,YO)
         ELSE
            AXMN = MIN(AXMN,XO(2))
            AXMX = MAX(AXMX,XO(2))
            AYMN = MIN(AYMN,YO(2))
            AYMX = MAX(AYMX,YO(2))
         END IF
         GO TO 999
      END IF
C
C Now draw the pennants if any
C     
      DO 10 I = 1,NPN
         XO(1) = XPS + XPI
         YO(1) = YPS + YPI
         XO(2) = XO(1) + AROX(2)*CSA-AROY(2)*SNA
         YO(2) = YO(1) + AROX(2)*SNA+AROY(2)*CSA
         XO(3) = XPS
         YO(3) = YPS
         XO(4) = XO(1)
         YO(4) = YO(1)
         IF (ISZ .EQ. 0) THEN
            CALL GFA(4,XO,YO)
         ELSE
            AXMN = MIN(AXMN,XO(2))
            AXMX = MAX(AXMX,XO(2))
            AYMN = MIN(AYMN,YO(2))
            AYMX = MAX(AYMX,YO(2))
         END IF
         IF (I.EQ.NPN) THEN
            XPS = XO(1) + XIN
            YPS = YO(1) + YIN
         ELSE
            XPS = XO(1)+0.5*XIN
            YPS = YO(1)+0.5*YIN
         END IF
 10   CONTINUE
C
      SPD = SPD - NPN * PENINC
      NBR = INT((SPD + 2.5) / BRBINC)
C
C Draw the barbs
C
      DO 20 I = 1, NBR
         XO(1) = XPS
         YO(1) = YPS
         XO(2) = XO(1) + AROX(2)*CSA-AROY(2)*SNA
         YO(2) = YO(1) + AROX(2)*SNA+AROY(2)*CSA
         IF (ISZ .EQ. 0) THEN
            CALL GPL(2,XO,YO)
         ELSE
            AXMN = MIN(AXMN,XO(2))
            AXMX = MAX(AXMX,XO(2))
            AYMN = MIN(AYMN,YO(2))
            AYMX = MAX(AYMX,YO(2))
         END IF
         XPS = XPS + XIN
         YPS = YPS + YIN
 20   CONTINUE
C
C Draw a half barb if required
C
      IF (SPD - NBR * BRBINC .GT. 2.5) THEN
         XO(1) = XPS
         YO(1) = YPS
         XO(2) = XO(1) + AROX(5)*CSA-AROY(5)*SNA
         YO(2) = YO(1) + AROX(5)*SNA+AROY(5)*CSA
         IF (ISZ .EQ. 0) THEN
            CALL GPL(2,XO,YO)
         ELSE
            AXMN = MIN(AXMN,XO(2))
            AXMX = MAX(AXMX,XO(2))
            AYMN = MIN(AYMN,YO(2))
            AYMX = MAX(AYMX,YO(2))
         END IF
      END IF
      
 999  CONTINUE

      FXSZ = AXMX-AXMN
      FYSZ = AYMX-AYMN
C
C If requested, put the vector magnitude above the arrow.
C
      IF (NC .GT. 0 .AND. ISZ .EQ. 0) THEN
C
C Figure circle location differently
C
         IF (ICR .EQ. 1) THEN
            RMG = 0.5 * WBCF*VLL
            PHI = 0.0
            IF (NC .EQ. 1) THEN
               XC = XB
            ELSE
               XC = XB - FLBS*FW2W
            END IF
            YC = YB - RMG - 1.25*FLBS*FW2W
         ELSE
            RMG = 0.001
            PHI = ATAN2(DY,DX)
            ISN = -1
            IF (MOD(PHI+P5D2PI,P2XPI) .GT. P1XPI) THEN
               PHI = PHI+P1XPI
               ISN = 1
            END IF
            IF (WBAD .LT. 0.0) THEN
               ISN = -ISN
            END IF
            XC = AXB+0.33*(AXE-AXB) + ISN *
     +           (1.25*FLBS*FW2W+RMG)*COS(PHI+P1D2PI)
            YC = AYB+0.33*(AYE-AYB) + ISN *
     +           (1.25*FLBS*FW2W+RMG)*SIN(PHI+P1D2PI)
         END IF
C
         CALL PLCHLQ(XC,YC,LBL(1:NC),FLBS*FW2W,PRTOD*PHI,0.0)
C
      END IF
C
C Restore original transformation
C
      CALL GSWN(NTR,WIN(1),WIN(2),WIN(3),WIN(4))
C
      RETURN
      END
C
      SUBROUTINE VVINWB (IHM)
C
C IHM      -  Hemisphere (1 - North, -1 - South)
C
C Initializes wind barb specific common block values.
C
C ---------------------------------------------------------------------
C
C NOTE:
C Since implicit typing is used for all real and integer variables
C a consistent length convention has been adopted to help clarify the
C significance of the variables encountered in the code for this 
C utility. All local variable and subroutine parameter identifiers 
C are limited to 1,2,or 3 characters. Four character names identify  
C members of common blocks. Five and 6 character variable names 
C denote PARAMETER constants or subroutine or function names.
C
C Declare the VV common blocks.
C
C IPLVLS - Maximum number of color threshold level values
C IPAGMX - Maximum number of area groups allowed in the area map
C
      PARAMETER (IPLVLS = 256, IPAGMX = 64)
C
C Integer and real common block variables
C
C
      COMMON /VVCOM/
     +                IUD1       ,IVD1       ,IPD1       ,IXDM       ,
     +                IYDN       ,VLOM       ,VHIM       ,ISET       ,
     +                VRMG       ,VRLN       ,VFRC       ,IXIN       ,
     +                IYIN       ,ISVF       ,UUSV       ,UVSV       ,
     +                UPSV       ,IMSK       ,ICPM       ,UVPS       ,
     +                UVPL       ,UVPR       ,UVPB       ,UVPT       ,
     +                UWDL       ,UWDR       ,UWDB       ,UWDT       ,
     +                UXC1       ,UXCM       ,UYC1       ,UYCN       ,
     +                NLVL       ,IPAI       ,ICTV       ,WDLV       ,
     +                UVMN       ,UVMX       ,PMIN       ,PMAX       ,
     +                RVMN       ,RVMX       ,RDMN       ,RDMX       ,
     +                ISPC       ,RVMD       ,IPLR       ,IVST       ,
     +                IVPO       ,ILBL       ,IDPF       ,IMSG       ,
     +                ICLR(IPLVLS)           ,TVLU(IPLVLS)
C
C Arrow size/shape parameters
C
        COMMON / VVARO /
     +                HDSZ       ,HINF       ,HANG       ,IAST       ,
     +                HSIN       ,HCOS       ,FAMN       ,FAMX       ,
     +                UVMG       ,FAIR       ,FAWR       ,FAWF       ,
     +                FAXR       ,FAXF       ,FAYR       ,FAYF       ,
     +                AROX(8)    ,AROY(8)    ,FXSZ       ,FYSZ       ,
     +                FXRF       ,FXMN       ,FYRF       ,FYMN       ,
     +                FWRF       ,FWMN       ,FIRF       ,FIMN       ,
     +                AXMN       ,AXMX       ,AYMN       ,AYMX       ,
     +                IACM       ,IAFO       ,WBAD       ,WBTF       ,
     +                WBCF       ,WBDF       ,WBSC
C
C
C Text related parameters
C
        COMMON /VVTXP /
     +                FCWM    ,ICSZ    ,
     +                FMNS    ,FMNX    ,FMNY    ,IMNP    ,IMNC  ,
     +                FMXS    ,FMXX    ,FMXY    ,IMXP    ,IMXC  ,
     +                FZFS    ,FZFX    ,FZFY    ,IZFP    ,IZFC  ,
     +                FILS    ,FILX    ,FILY    ,IILP    ,IILC  ,
     +                FLBS    ,ILBC

C
C Character variable declartions
C
      CHARACTER*160 CSTR
      PARAMETER (IPCHSZ=36)
      CHARACTER*(IPCHSZ)  CMNT,CMXT,CZFT,CLBT,CILT
C
C Text string parameters
C
      COMMON /VVCHAR/ CSTR,CMNT,CMXT,CZFT,CLBT,CILT
C
      SAVE /VVCOM/, /VVARO/, /VVTXP/, /VVCHAR/
C
C The mapping common block: made available to user mapping routines
C
      COMMON /VVMAP/
     +                IMAP       ,
     +                XVPL       ,XVPR       ,YVPB       ,YVPT       ,
     +                WXMN       ,WXMX       ,WYMN       ,WYMX       ,
     +                XLOV       ,XHIV       ,YLOV       ,YHIV       ,
     +                SXDC       ,SYDC       ,NXCT       ,NYCT       ,
     +                RLEN       ,LNLG       ,INVX       ,INVY       ,
     +                ITRT       ,IWCT       ,FW2W       ,FH2H       ,
     +                DVMN       ,DVMX       ,RBIG       ,IBIG
C
      SAVE /VVMAP/
C
C Math constants
C
      PARAMETER (PDTOR  = 0.017453292519943,
     +           PRTOD  = 57.2957795130823,
     +           P1XPI  = 3.14159265358979,
     +           P2XPI  = 6.28318530717959,
     +           P1D2PI = 1.57079632679489,
     +           P5D2PI = 7.85398163397448) 
C
C --------------------------------------------------------------------
      PARAMETER (D2RAD=.017453293)
C
C
C Fill in the reference arrow data
C
c$$$C     parameter WBA wind barb angle
c$$$      WBAD = 62.0
c$$$C     parameter WBS wind barb tic size (fraction of barb length)
c$$$      WBTF = 0.33 
c$$$C     parameter WBR wind barb radius (fraction of bl)
c$$$      WBCF = 0.25
c$$$C     parameter WBD wind barb distance between ticks (fraction of bl)
c$$$      WBDF = 0.1
c$$$C     parameter WBC wind barb scale factor 
c$$$      WBSC = 1.0
C
C Make sure this does nothing if the style is not wind barb.
C
      IF (IAST .LT. 2) THEN
         RETURN
      END IF
         
      RAG = IHM * WBAD * D2RAD
C
C Use the first four elements of the fill arrow array to store the 
C pennant triangle. Elements 2 and 3 work for the barb line.
C Four and five are used for the half barb line.
C
      AROX(1) = -COS(RAG) * WBTF * DVMX
      AROY(1) = 0.0
      AROX(2) = AROX(1)
      AROY(2) = SIN(RAG) * WBTF * DVMX
      AROX(3) = 0.0
      AROY(3) = 0.0
      AROX(4) = 0.0
      AROY(4) = AROX(1)
      AROX(5) = -0.5 * COS(RAG) * WBTF * DVMX
      AROY(5) = 0.5 * SIN(RAG) * WBTF * DVMX
      AROX(6) = 0.0
      AROY(6) = 0.0
C
      RETURN
      END

C
C $Id: ngdots.f,v 1.14 2008-07-27 00:17:17 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE NGDOTS(X,Y,NUM,SIZE,ICOLOR)
C
C  Draws filled dots at positions (X(I),Y(I),I=1,NUM) at size 
C  SIZE with color given by the color index ICOLOR.  Size is 
C  the diameter of the dot in world coordinates along the vertical
C  axis.
C  
C  The dots are scaled appropriately so that they will be circular
C  when the normalization transformation does not preserve aspect
C  ratio.
C
C  The algorithm is to construct a single circle and then translate
C  it to the various coordinate positions.  The original circle is
C  computed by using trig functions to get points in the first
C  octant, and then using symmetries to get the rest of the points
C  on the circle.
C
C  The number of points used for the circle is adjusted depending
C  on the relative size of the circle.  The maximum number of points
C  is 512 and the minimum is 8.
C
      SAVE
C
      include 'ngcomn.h'
C
      DIMENSION X(NUM),Y(NUM),TWIN(4),TVPT(4)
      DIMENSION CIRCX(513),CIRCY(513),CIRCXX(513),CIRCYY(513)
      INTEGER   OLDASF(13),NEWASF(13)
C
C  PI and number of points per unit of arc length.
C
      DATA PI,NPU/3.1415927,1200/
C
C  Size below which markers are drawn in addition to the filled dots
C  to insure that the dots do not disappear by falling between pixels.
C
      DATA DM/.05/
C
C  Size cutoff for increasing the number of points at smaller sizes
C  so that the dots look round.
C
      DATA PC/.03/
C
C  Minimum dot size.  Below this tolerance, only dot markers are drawn.
C
      DATA SM/.001/
C
      DATA IFIRST/0/
C
C  If log scaling or mirror imaging has been requested, issue a
C  warning that only GKS world coordinates are accepted.
C
      CALL GETUSV('LS',LSV)
      CALL GETUSV('MI',MIV)
      IF ((LSV.NE.1 .OR. MIV.NE.1) .AND. IFIRST.EQ.0) THEN
        PRINT *, 'NGDOTS -- **Warning**'
        PRINT *, '          Log scaling or mirror-imaging have been requ
     +ested via a SET call;'
        PRINT *, '          NGDOTS accepts only GKS world coordinates.'
        IFIRST = 1
      ENDIF
C
C  Calculate the number of points to use in calculating the points
C  in the first octant of the circle.
C
      CALL GQCNTN(IER,NTNR)
      CALL GQNT(NTNR,IER,TWIN,TVPT)
C
C  Normalize the size.
C
      SD = SIZE*(TVPT(4)-TVPT(3))/(TWIN(4)-TWIN(3))
C
C  Set a minimum dot size.
C
      IF (SD .LT. SM) THEN
        SD = SM
        TSIZE = SD*(TWIN(4)-TWIN(3))/(TVPT(4)-TVPT(3))
      ELSE
        TSIZE = SIZE
      ENDIF
C
C  Calculate the number of points on the curve.
C
      NP = INT(NPU*PI*SD)
C
C  Increase the number of points for smaller circles.
C
      IF (SD .LE. PC) NP = NP*2
      NP = NP/8
      NP = NP+1
      NP = MAX(NP,2)
      NP = MIN(NP,64)    
C
C  Center the dot at (0.,0.) and translate it to the (X,Y) 
C  coordinates later.
C
C  Calculate the points in the first octant.
C
      AINC = .25*PI/REAL(NP)
      R = .5*TSIZE
      DO 10 I=1,NP
        T = REAL(I-1)*AINC
        CIRCX(I) = R*COS(T)
        CIRCY(I) = R*SIN(T)
   10 CONTINUE
C 
C  Use symmetries to get the other points on the circle.
C
      NP2 = 2*NP
      DO 30 I=NP+1,NP2-1
        CIRCX(I) = CIRCY(NP2-I)
        CIRCY(I) = CIRCX(NP2-I)
   30 CONTINUE
      NP = NP2-1
      NP2 = 2*NP
      DO 40 I=NP+1,NP2-1
        CIRCX(I) = -CIRCX(NP2-I)
        CIRCY(I) =  CIRCY(NP2-I)
   40 CONTINUE
      NP = NP2-1
      NP2 = 2*NP
      DO 50 I=NP+1,NP2-1
        CIRCX(I) =  CIRCX(NP2-I)
        CIRCY(I) = -CIRCY(NP2-I)
   50 CONTINUE
      NP = NP2-1
C
C  Scale factor for non-square aspect ratios.
C
      WSCALE = (TWIN(2)-TWIN(1))/(TWIN(4)-TWIN(3))
      VSCALE = (TVPT(4)-TVPT(3))/(TVPT(2)-TVPT(1))
      DO 20 I=1,NP
        CIRCX(I) = WSCALE*VSCALE*CIRCX(I)
   20 CONTINUE
C
C  Draw filled dots if the size is large enough.
C
      IF (SD .GE. SM) THEN
C
C  Save the fill color index and interior style.
C
        CALL GQFACI(IER,ICOLRO)
        CALL GQFAIS(IER,ISTYLO)
C
C  Set the fill style to solid and the fill collor to ICOLOR.
C
        CALL GSFAIS(1)
        CALL GSFACI(ICOLOR)
C
C  Draw the dots or circles, depending on ICDFLG.
C
        DO 60 I=1,NUM
          DO 70 J=1,NP
            CIRCXX(J) = X(I) + CIRCX(J)
            CIRCYY(J) = Y(I) + CIRCY(J)
   70     CONTINUE
          IF (ICDFLG .EQ. 0) THEN
            CALL GFA(NP,CIRCXX,CIRCYY)
          ELSE
            CALL GQPLCI(IER,IPLCO)
            CALL GSPLCI(ICOLOR)
            CALL GPL(NP,CIRCXX,CIRCYY)
            CALL GSPLCI(IPLCO)
          ENDIF
   60   CONTINUE
C
C  Restore the fill color and style.
C
        CALL GSFACI(ICOLRO)
        CALL GSFAIS(ISTYLO)
      ENDIF
C
C  Draw polymarkers if the size is small enough (note that there is
C  an overlap where both dots and markers are drawn).  The polymarkers
C  are drawn only when filled dots are requested and not when circles
C  are requested.
C
      IF (SD.LT.DM .AND. ICDFLG.EQ.0) THEN
C
C  Save current GKS attributes.
C
        CALL GQASF(IER,OLDASF)
        CALL GQMK (IER,MTYPEO)
        CALL GQMKSC(IER,SZSFO)
        CALL GQPMCI(IER,IMCOLO)
C
C  Set attributes for polymarkers and draw them.
C
        DO 80 I=1,13
          NEWASF(I) = OLDASF(I)
   80   CONTINUE
        NEWASF(4) = 1
        NEWASF(5) = 1
        NEWASF(6) = 1
        CALL GSASF(NEWASF)
        CALL GSMK(1)
        CALL GSMKSC(1.0)
        CALL GSPMCI(ICOLOR)
        CALL GPM(NUM,X,Y)
C
C  Restore original attributes.
C
        CALL GSASF(OLDASF)
        CALL GSMK(MTYPEO)
        CALL GSMKSC(SZSFO)
        CALL GSPMCI(IMCOLO)
      ENDIF
C
      RETURN
      END

      SUBROUTINE CGBTRS( TRANS, N, KL, KU, NRHS, AB, LDAB, IPIV, B, LDB,
     $                   INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER          TRANS
      INTEGER            INFO, KL, KU, LDAB, LDB, N, NRHS
*     ..
*     .. Array Arguments ..
      INTEGER            IPIV( * )
      COMPLEX            AB( LDAB, * ), B( LDB, * )
*     ..
*
*  Purpose
*  =======
*
*  CGBTRS solves a system of linear equations
*     A * X = B,  A**T * X = B,  or  A**H * X = B
*  with a general band matrix A using the LU factorization computed
*  by CGBTRF.
*
*  Arguments
*  =========
*
*  TRANS   (input) CHARACTER*1
*          Specifies the form of the system of equations.
*          = 'N':  A * X = B     (No transpose)
*          = 'T':  A**T * X = B  (Transpose)
*          = 'C':  A**H * X = B  (Conjugate transpose)
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  KL      (input) INTEGER
*          The number of subdiagonals within the band of A.  KL >= 0.
*
*  KU      (input) INTEGER
*          The number of superdiagonals within the band of A.  KU >= 0.
*
*  NRHS    (input) INTEGER
*          The number of right hand sides, i.e., the number of columns
*          of the matrix B.  NRHS >= 0.
*
*  AB      (input) COMPLEX array, dimension (LDAB,N)
*          Details of the LU factorization of the band matrix A, as
*          computed by CGBTRF.  U is stored as an upper triangular band
*          matrix with KL+KU superdiagonals in rows 1 to KL+KU+1, and
*          the multipliers used during the factorization are stored in
*          rows KL+KU+2 to 2*KL+KU+1.
*
*  LDAB    (input) INTEGER
*          The leading dimension of the array AB.  LDAB >= 2*KL+KU+1.
*
*  IPIV    (input) INTEGER array, dimension (N)
*          The pivot indices; for 1 <= i <= N, row i of the matrix was
*          interchanged with row IPIV(i).
*
*  B       (input/output) COMPLEX array, dimension (LDB,NRHS)
*          On entry, the right hand side matrix B.
*          On exit, the solution matrix X.
*
*  LDB     (input) INTEGER
*          The leading dimension of the array B.  LDB >= max(1,N).
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*
*  =====================================================================
*
*     .. Parameters ..
      COMPLEX            ONE
      PARAMETER          ( ONE = ( 1.0E+0, 0.0E+0 ) )
*     ..
*     .. Local Scalars ..
      LOGICAL            LNOTI, NOTRAN
      INTEGER            I, J, KD, L, LM
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           CGEMV, CGERU, CLACGV, CSWAP, CTBSV, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      NOTRAN = LSAME( TRANS, 'N' )
      IF( .NOT.NOTRAN .AND. .NOT.LSAME( TRANS, 'T' ) .AND. .NOT.
     $    LSAME( TRANS, 'C' ) ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( KL.LT.0 ) THEN
         INFO = -3
      ELSE IF( KU.LT.0 ) THEN
         INFO = -4
      ELSE IF( NRHS.LT.0 ) THEN
         INFO = -5
      ELSE IF( LDAB.LT.( 2*KL+KU+1 ) ) THEN
         INFO = -7
      ELSE IF( LDB.LT.MAX( 1, N ) ) THEN
         INFO = -10
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'CGBTRS', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 .OR. NRHS.EQ.0 )
     $   RETURN
*
      KD = KU + KL + 1
      LNOTI = KL.GT.0
*
      IF( NOTRAN ) THEN
*
*        Solve  A*X = B.
*
*        Solve L*X = B, overwriting B with X.
*
*        L is represented as a product of permutations and unit lower
*        triangular matrices L = P(1) * L(1) * ... * P(n-1) * L(n-1),
*        where each transformation L(i) is a rank-one modification of
*        the identity matrix.
*
         IF( LNOTI ) THEN
            DO 10 J = 1, N - 1
               LM = MIN( KL, N-J )
               L = IPIV( J )
               IF( L.NE.J )
     $            CALL CSWAP( NRHS, B( L, 1 ), LDB, B( J, 1 ), LDB )
               CALL CGERU( LM, NRHS, -ONE, AB( KD+1, J ), 1, B( J, 1 ),
     $                     LDB, B( J+1, 1 ), LDB )
   10       CONTINUE
         END IF
*
         DO 20 I = 1, NRHS
*
*           Solve U*X = B, overwriting B with X.
*
            CALL CTBSV( 'Upper', 'No transpose', 'Non-unit', N, KL+KU,
     $                  AB, LDAB, B( 1, I ), 1 )
   20    CONTINUE
*
      ELSE IF( LSAME( TRANS, 'T' ) ) THEN
*
*        Solve A**T * X = B.
*
         DO 30 I = 1, NRHS
*
*           Solve U**T * X = B, overwriting B with X.
*
            CALL CTBSV( 'Upper', 'Transpose', 'Non-unit', N, KL+KU, AB,
     $                  LDAB, B( 1, I ), 1 )
   30    CONTINUE
*
*        Solve L**T * X = B, overwriting B with X.
*
         IF( LNOTI ) THEN
            DO 40 J = N - 1, 1, -1
               LM = MIN( KL, N-J )
               CALL CGEMV( 'Transpose', LM, NRHS, -ONE, B( J+1, 1 ),
     $                     LDB, AB( KD+1, J ), 1, ONE, B( J, 1 ), LDB )
               L = IPIV( J )
               IF( L.NE.J )
     $            CALL CSWAP( NRHS, B( L, 1 ), LDB, B( J, 1 ), LDB )
   40       CONTINUE
         END IF
*
      ELSE
*
*        Solve A**H * X = B.
*
         DO 50 I = 1, NRHS
*
*           Solve U**H * X = B, overwriting B with X.
*
            CALL CTBSV( 'Upper', 'Conjugate transpose', 'Non-unit', N,
     $                  KL+KU, AB, LDAB, B( 1, I ), 1 )
   50    CONTINUE
*
*        Solve L**H * X = B, overwriting B with X.
*
         IF( LNOTI ) THEN
            DO 60 J = N - 1, 1, -1
               LM = MIN( KL, N-J )
               CALL CLACGV( NRHS, B( J, 1 ), LDB )
               CALL CGEMV( 'Conjugate transpose', LM, NRHS, -ONE,
     $                     B( J+1, 1 ), LDB, AB( KD+1, J ), 1, ONE,
     $                     B( J, 1 ), LDB )
               CALL CLACGV( NRHS, B( J, 1 ), LDB )
               L = IPIV( J )
               IF( L.NE.J )
     $            CALL CSWAP( NRHS, B( L, 1 ), LDB, B( J, 1 ), LDB )
   60       CONTINUE
         END IF
      END IF
      RETURN
*
*     End of CGBTRS
*
      END

C
C $Id: mdlltd.f,v 1.6 2008-09-18 00:42:17 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MDLLTD (XCOP,YCOP,XCOQ,YCOQ,OFFX,OFFY,SIZE,ANGL,CENT)
C
        REAL XCOP,YCOP,XCOQ,YCOQ,OFFX,OFFY,SIZE,ANGL,CENT
C
        DOUBLE PRECISION PLAT,PLON,QLAT,QLON,DNCE,RLAT,UCOR,VCOR
C
C This routine attempts to put tick marks and latitude labels along an
C arbitrary line on a map drawn by EZMAP.  XCOP, YCOP, XCOQ, and YCOQ
C are the X and Y coordinates, in the fractional system, of two points,
C P and Q.  The latitude labels will be placed at positions between P
C and Q where the latitude is a multiple of some "nice" value.  OFFX
C and OFFY specify fractional-system X and Y components of an offset
C vector from a point to be labeled to a point relative to which the
C label will be positioned.  SIZE is the desired character width, in
C the fractional system.  ANGL is the angle, in degrees, at which the
C label is to be written.  CENT specifies what part of the label is to
C be placed on the end of the offset vector; CENT = -1. means the center
C of the left end of the label, CENT = 0. means the center of the whole
C label, and CENT = +1. means the center of the right end of the label.
C
C Care should be taken to choose points P and Q such that the value of
C latitude is monotonically increasing or decreasing along the line
C from P to Q.
C
        CHARACTER*128 CHRS
C
C Declare other local variables.
C
        INTEGER       I,IPLT,IQLT,NCHR
C
C Get the latitude and longitude of P.
C
        CALL MDPTRI (DBLE(CFUX(XCOP)),DBLE(CFUY(YCOP)),PLAT,PLON)
        IF (PLAT.EQ.1.D12) RETURN
C
C Get the latitude and longitude of Q.
C
        CALL MDPTRI (DBLE(CFUX(XCOQ)),DBLE(CFUY(YCOQ)),QLAT,QLON)
        IF (QLAT.EQ.1.D12) RETURN
C
C Compute a "nice" latitude interval to use.
C
        CALL MDGNID (ABS(QLAT-PLAT)/4.D0,DNCE,NOFD)
        IF (DNCE.EQ.0.D0) RETURN
C
C Compute limits to be used in the labeling loop.
C
        IPLT=INT((PLAT+90.D0)/DNCE)
        IQLT=INT((QLAT+90.D0)/DNCE)
C
C Loop to generate the labels.
C
        DO 101 I=MIN(IPLT,IQLT)-1,MAX(IPLT,IQLT)+1
          RLAT=DBLE(I)*DNCE-90.D0
          IF (RLAT.GT.MIN(PLAT,QLAT)-DNCE/100.D0.AND.
     +        RLAT.LT.MAX(PLAT,QLAT)+DNCE/100.D0) THEN
            CALL MDILAT (PLAT,PLON,DBLE(CFUX(XCOP)),DBLE(CFUY(YCOP)),
     +                   QLAT,QLON,DBLE(CFUX(XCOQ)),DBLE(CFUY(YCOQ)),
     +                   RLAT,UCOR,VCOR)
            CALL MDLACD (RLAT,CHRS,NCHR,NOFD)
            CALL PLCHHQ (CFUX(CUFX(REAL(UCOR))+OFFX),
     +                   CFUY(CUFY(REAL(VCOR))+OFFY),
     +                   CHRS(1:NCHR),SIZE,ANGL,CENT)
          END IF
  101   CONTINUE
C
C Done.
C
        RETURN
C
      END

C
C	$Id: gqpcr.f,v 1.5 2008-07-27 00:21:00 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GQPCR(WTYPE,PCI,ERRIND,RED,GREEN,BLUE)
C
C  INQUIRE PREDEFINED COLOUR REPRESENTATION
C
      include 'gkscom.h'
C
      INTEGER WTYPE,PCI,ERRIND
      REAL    RED,GREEN,BLUE
C
C  Check if GKS is in the proper state.
C
      CALL GZCKST(8,-1,ERRIND)
      IF (ERRIND .NE. 0) GOTO 100
C
C  Check that the workstation type is valid.
C
      CALL GZCKWK(22,-1,IDUM,WTYPE,ERRIND)
      IF (ERRIND .NE. 0) GO TO 100
C
C  Check if the workstation category is OUTPUT or OUTIN.
C
      CALL GQWKCA(WTYPE,ERRIND,ICAT)
      IF (ICAT.NE.GOUTPT .AND. ICAT.NE.GOUTIN) THEN
        ERRIND = 39
        GO TO 100
      ENDIF
C
C  Check if color index is valid.
C
      IF (PCI .LT. 0) THEN
        ERRIND = 93
        GO TO 100
      ENDIF
C
C  Invoke interface
C
      FCODE = -116
      CONT  = 0
      CALL GZROI(0)
      IL1   = 2
      IL2   = 2
      ID(1) = WTYPE
      ID(2) = PCI
      IWK   = -1
      CALL GZIQWK(WTYPE,IWK)
      IF (RERR .NE. 0) THEN
        ERRIND = RERR
        GOTO 100
      ENDIF
      RED   = RX(1)
      GREEN = RX(2)
      BLUE  = RX(3)
      RETURN
C
  100 CONTINUE
      RED   = -1.
      GREEN = -1.
      BLUE  = -1.
      RETURN
      END

      SUBROUTINE ZHPSVX( FACT, UPLO, N, NRHS, AP, AFP, IPIV, B, LDB, X,
     $                   LDX, RCOND, FERR, BERR, WORK, RWORK, INFO )
*
*  -- LAPACK driver routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          FACT, UPLO
      INTEGER            INFO, LDB, LDX, N, NRHS
      DOUBLE PRECISION   RCOND
*     ..
*     .. Array Arguments ..
      INTEGER            IPIV( * )
      DOUBLE PRECISION   BERR( * ), FERR( * ), RWORK( * )
      COMPLEX*16         AFP( * ), AP( * ), B( LDB, * ), WORK( * ),
     $                   X( LDX, * )
*     ..
*
*  Purpose
*  =======
*
*  ZHPSVX uses the diagonal pivoting factorization A = U*D*U**H or
*  A = L*D*L**H to compute the solution to a complex system of linear
*  equations A * X = B, where A is an N-by-N Hermitian matrix stored
*  in packed format and X and B are N-by-NRHS matrices.
*
*  Error bounds on the solution and a condition estimate are also
*  provided.
*
*  Description
*  ===========
*
*  The following steps are performed:
*
*  1. If FACT = 'N', the diagonal pivoting method is used to factor A as
*        A = U * D * U**H,  if UPLO = 'U', or
*        A = L * D * L**H,  if UPLO = 'L',
*     where U (or L) is a product of permutation and unit upper (lower)
*     triangular matrices and D is Hermitian and block diagonal with
*     1-by-1 and 2-by-2 diagonal blocks.
*
*  2. If some D(i,i)=0, so that D is exactly singular, then the routine
*     returns with INFO = i. Otherwise, the factored form of A is used
*     to estimate the condition number of the matrix A.  If the
*     reciprocal of the condition number is less than machine precision,
*     INFO = N+1 is returned as a warning, but the routine still goes on
*     to solve for X and compute error bounds as described below.
*
*  3. The system of equations is solved for X using the factored form
*     of A.
*
*  4. Iterative refinement is applied to improve the computed solution
*     matrix and calculate error bounds and backward error estimates
*     for it.
*
*  Arguments
*  =========
*
*  FACT    (input) CHARACTER*1
*          Specifies whether or not the factored form of A has been
*          supplied on entry.
*          = 'F':  On entry, AFP and IPIV contain the factored form of
*                  A.  AFP and IPIV will not be modified.
*          = 'N':  The matrix A will be copied to AFP and factored.
*
*  UPLO    (input) CHARACTER*1
*          = 'U':  Upper triangle of A is stored;
*          = 'L':  Lower triangle of A is stored.
*
*  N       (input) INTEGER
*          The number of linear equations, i.e., the order of the
*          matrix A.  N >= 0.
*
*  NRHS    (input) INTEGER
*          The number of right hand sides, i.e., the number of columns
*          of the matrices B and X.  NRHS >= 0.
*
*  AP      (input) COMPLEX*16 array, dimension (N*(N+1)/2)
*          The upper or lower triangle of the Hermitian matrix A, packed
*          columnwise in a linear array.  The j-th column of A is stored
*          in the array AP as follows:
*          if UPLO = 'U', AP(i + (j-1)*j/2) = A(i,j) for 1<=i<=j;
*          if UPLO = 'L', AP(i + (j-1)*(2*n-j)/2) = A(i,j) for j<=i<=n.
*          See below for further details.
*
*  AFP     (input or output) COMPLEX*16 array, dimension (N*(N+1)/2)
*          If FACT = 'F', then AFP is an input argument and on entry
*          contains the block diagonal matrix D and the multipliers used
*          to obtain the factor U or L from the factorization
*          A = U*D*U**H or A = L*D*L**H as computed by ZHPTRF, stored as
*          a packed triangular matrix in the same storage format as A.
*
*          If FACT = 'N', then AFP is an output argument and on exit
*          contains the block diagonal matrix D and the multipliers used
*          to obtain the factor U or L from the factorization
*          A = U*D*U**H or A = L*D*L**H as computed by ZHPTRF, stored as
*          a packed triangular matrix in the same storage format as A.
*
*  IPIV    (input or output) INTEGER array, dimension (N)
*          If FACT = 'F', then IPIV is an input argument and on entry
*          contains details of the interchanges and the block structure
*          of D, as determined by ZHPTRF.
*          If IPIV(k) > 0, then rows and columns k and IPIV(k) were
*          interchanged and D(k,k) is a 1-by-1 diagonal block.
*          If UPLO = 'U' and IPIV(k) = IPIV(k-1) < 0, then rows and
*          columns k-1 and -IPIV(k) were interchanged and D(k-1:k,k-1:k)
*          is a 2-by-2 diagonal block.  If UPLO = 'L' and IPIV(k) =
*          IPIV(k+1) < 0, then rows and columns k+1 and -IPIV(k) were
*          interchanged and D(k:k+1,k:k+1) is a 2-by-2 diagonal block.
*
*          If FACT = 'N', then IPIV is an output argument and on exit
*          contains details of the interchanges and the block structure
*          of D, as determined by ZHPTRF.
*
*  B       (input) COMPLEX*16 array, dimension (LDB,NRHS)
*          The N-by-NRHS right hand side matrix B.
*
*  LDB     (input) INTEGER
*          The leading dimension of the array B.  LDB >= max(1,N).
*
*  X       (output) COMPLEX*16 array, dimension (LDX,NRHS)
*          If INFO = 0 or INFO = N+1, the N-by-NRHS solution matrix X.
*
*  LDX     (input) INTEGER
*          The leading dimension of the array X.  LDX >= max(1,N).
*
*  RCOND   (output) DOUBLE PRECISION
*          The estimate of the reciprocal condition number of the matrix
*          A.  If RCOND is less than the machine precision (in
*          particular, if RCOND = 0), the matrix is singular to working
*          precision.  This condition is indicated by a return code of
*          INFO > 0.
*
*  FERR    (output) DOUBLE PRECISION array, dimension (NRHS)
*          The estimated forward error bound for each solution vector
*          X(j) (the j-th column of the solution matrix X).
*          If XTRUE is the true solution corresponding to X(j), FERR(j)
*          is an estimated upper bound for the magnitude of the largest
*          element in (X(j) - XTRUE) divided by the magnitude of the
*          largest element in X(j).  The estimate is as reliable as
*          the estimate for RCOND, and is almost always a slight
*          overestimate of the true error.
*
*  BERR    (output) DOUBLE PRECISION array, dimension (NRHS)
*          The componentwise relative backward error of each solution
*          vector X(j) (i.e., the smallest relative change in
*          any element of A or B that makes X(j) an exact solution).
*
*  WORK    (workspace) COMPLEX*16 array, dimension (2*N)
*
*  RWORK   (workspace) DOUBLE PRECISION array, dimension (N)
*
*  INFO    (output) INTEGER
*          = 0: successful exit
*          < 0: if INFO = -i, the i-th argument had an illegal value
*          > 0:  if INFO = i, and i is
*                <= N:  D(i,i) is exactly zero.  The factorization
*                       has been completed but the factor D is exactly
*                       singular, so the solution and error bounds could
*                       not be computed. RCOND = 0 is returned.
*                = N+1: D is nonsingular, but RCOND is less than machine
*                       precision, meaning that the matrix is singular
*                       to working precision.  Nevertheless, the
*                       solution and error bounds are computed because
*                       there are a number of situations where the
*                       computed solution can be more accurate than the
*                       value of RCOND would suggest.
*
*  Further Details
*  ===============
*
*  The packed storage scheme is illustrated by the following example
*  when N = 4, UPLO = 'U':
*
*  Two-dimensional storage of the Hermitian matrix A:
*
*     a11 a12 a13 a14
*         a22 a23 a24
*             a33 a34     (aij = conjg(aji))
*                 a44
*
*  Packed storage of the upper triangle of A:
*
*  AP = [ a11, a12, a22, a13, a23, a33, a14, a24, a34, a44 ]
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO
      PARAMETER          ( ZERO = 0.0D+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            NOFACT
      DOUBLE PRECISION   ANORM
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      DOUBLE PRECISION   DLAMCH, ZLANHP
      EXTERNAL           LSAME, DLAMCH, ZLANHP
*     ..
*     .. External Subroutines ..
      EXTERNAL           XERBLA, ZCOPY, ZHPCON, ZHPRFS, ZHPTRF, ZHPTRS,
     $                   ZLACPY
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      NOFACT = LSAME( FACT, 'N' )
      IF( .NOT.NOFACT .AND. .NOT.LSAME( FACT, 'F' ) ) THEN
         INFO = -1
      ELSE IF( .NOT.LSAME( UPLO, 'U' ) .AND. .NOT.LSAME( UPLO, 'L' ) )
     $          THEN
         INFO = -2
      ELSE IF( N.LT.0 ) THEN
         INFO = -3
      ELSE IF( NRHS.LT.0 ) THEN
         INFO = -4
      ELSE IF( LDB.LT.MAX( 1, N ) ) THEN
         INFO = -9
      ELSE IF( LDX.LT.MAX( 1, N ) ) THEN
         INFO = -11
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'ZHPSVX', -INFO )
         RETURN
      END IF
*
      IF( NOFACT ) THEN
*
*        Compute the factorization A = U*D*U' or A = L*D*L'.
*
         CALL ZCOPY( N*( N+1 ) / 2, AP, 1, AFP, 1 )
         CALL ZHPTRF( UPLO, N, AFP, IPIV, INFO )
*
*        Return if INFO is non-zero.
*
         IF( INFO.NE.0 ) THEN
            IF( INFO.GT.0 )
     $         RCOND = ZERO
            RETURN
         END IF
      END IF
*
*     Compute the norm of the matrix A.
*
      ANORM = ZLANHP( 'I', UPLO, N, AP, RWORK )
*
*     Compute the reciprocal of the condition number of A.
*
      CALL ZHPCON( UPLO, N, AFP, IPIV, ANORM, RCOND, WORK, INFO )
*
*     Set INFO = N+1 if the matrix is singular to working precision.
*
      IF( RCOND.LT.DLAMCH( 'Epsilon' ) )
     $   INFO = N + 1
*
*     Compute the solution vectors X.
*
      CALL ZLACPY( 'Full', N, NRHS, B, LDB, X, LDX )
      CALL ZHPTRS( UPLO, N, NRHS, AFP, IPIV, X, LDX, INFO )
*
*     Use iterative refinement to improve the computed solutions and
*     compute error bounds and backward error estimates for them.
*
      CALL ZHPRFS( UPLO, N, NRHS, AP, AFP, IPIV, B, LDB, X, LDX, FERR,
     $             BERR, WORK, RWORK, INFO )
*
      RETURN
*
*     End of ZHPSVX
*
      END

C
C $Id: rbidfe.f,v 1.12 2008-09-18 00:42:18 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      DOUBLE PRECISION FUNCTION RBIDFE (QDFE)
C
        DOUBLE PRECISION QDFE
C
C The value of RBIDFE(QDFE) is the latitude for which the distance of
C the parallel of the Robinson projection from the equator is QDFE.
C
C Declare local variables.
C
        DOUBLE PRECISION PDFE(19),XDFE
C
        INTEGER          ITST,IBEG,IEND
C
C Define the contents of PDFE per the definition of the Robinson
C projection.  The values are associated with values of latitude from
C 0 North to 90 North at five-degree intervals.
C
C
        DATA PDFE( 1) / 0.0000D0 /
        DATA PDFE( 2) / 0.0620D0 /
        DATA PDFE( 3) / 0.1240D0 /
        DATA PDFE( 4) / 0.1860D0 /
        DATA PDFE( 5) / 0.2480D0 /
        DATA PDFE( 6) / 0.3100D0 /
        DATA PDFE( 7) / 0.3720D0 /
        DATA PDFE( 8) / 0.4340D0 /
        DATA PDFE( 9) / 0.4958D0 /
        DATA PDFE(10) / 0.5571D0 /
        DATA PDFE(11) / 0.6176D0 /
        DATA PDFE(12) / 0.6769D0 /
        DATA PDFE(13) / 0.7346D0 /
        DATA PDFE(14) / 0.7903D0 /
        DATA PDFE(15) / 0.8435D0 /
        DATA PDFE(16) / 0.8936D0 /
        DATA PDFE(17) / 0.9394D0 /
        DATA PDFE(18) / 0.9761D0 /
        DATA PDFE(19) / 1.0000D0 /
C
C XDFE is the magnitude of QDFE, limited to the range of values in the
C table.
C
        XDFE=MAX(0.D0,MIN(1.D0,ABS(QDFE)/.5072D0))
C
C Find the indices of the values in the table between which XDFE lies.
C
        IBEG=1
        IEND=19
C
  101   ITST=(IBEG+IEND)/2
C
        IF (PDFE(ITST).LE.XDFE) THEN
          IBEG=ITST
        ELSE
          IEND=ITST
        END IF
C
        IF (IEND-IBEG.GT.1) GO TO 101
C
C Now, just interpolate to find the desired latitude.
C
        RBIDFE=SIGN(5.D0*(DBLE(IBEG-1)+(      XDFE-PDFE(IBEG))/
     +                                 (PDFE(IEND)-PDFE(IBEG))),QDFE)
C
C Done.
C
        RETURN
C
      END

      SUBROUTINE SLADIV( A, B, C, D, P, Q )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     October 31, 1992
*
*     .. Scalar Arguments ..
      REAL               A, B, C, D, P, Q
*     ..
*
*  Purpose
*  =======
*
*  SLADIV performs complex division in  real arithmetic
*
*                        a + i*b
*             p + i*q = ---------
*                        c + i*d
*
*  The algorithm is due to Robert L. Smith and can be found
*  in D. Knuth, The art of Computer Programming, Vol.2, p.195
*
*  Arguments
*  =========
*
*  A       (input) REAL
*  B       (input) REAL
*  C       (input) REAL
*  D       (input) REAL
*          The scalars a, b, c, and d in the above expression.
*
*  P       (output) REAL
*  Q       (output) REAL
*          The scalars p and q in the above expression.
*
*  =====================================================================
*
*     .. Local Scalars ..
      REAL               E, F
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS
*     ..
*     .. Executable Statements ..
*
      IF( ABS( D ).LT.ABS( C ) ) THEN
         E = D / C
         F = C + D*E
         P = ( A+B*E ) / F
         Q = ( B-A*E ) / F
      ELSE
         E = C / D
         F = D + C*E
         P = ( B+A*E ) / F
         Q = ( -A+B*E ) / F
      END IF
*
      RETURN
*
*     End of SLADIV
*
      END

C
C $Id: tdotri.f,v 1.4 2008-07-27 00:17:33 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE TDOTRI (RTRI,MTRI,NTRI,RTWK,ITWK,IORD)
C
        PARAMETER (EPSI=.0002,OMEP=1.-EPSI)
C
        DIMENSION RTRI(10,MTRI),RTWK(MTRI,2),ITWK(MTRI)
C
C This routine, given a list of NTRI triangles in the array RTRI and
C a real scratch array RTWK of length at least MTRI x 2 , determines
C the order in which those triangles ought to be rendered and returns
C a permutation of the integers from 1 to NTRI in the array ITWK to
C define that permutation.  Note that the value of NTRI may increase
C as a result of calling TDOTRI; it is sometimes necessary to break
C one or more triangles into pieces and then re-insert those pieces
C in the triangle list.  Arguments of TDOTRI are as follows:
C
C   RTRI is a real array containing a list of triangles; it is
C   dimensioned 10 x MTRI.  Each 10-word entry in the list consists
C   of the U, V, and W coordinates of each of three points, followed
C   by a rendering style index.
C
C   MTRI is an input integer specifying the second dimension of the
C   array RTRI: the maximum number of triangles the list will hold.
C
C   NTRI is an input/output integer specifying the number of triangles
C   currently in the array RTRI.
C
C   RTWK is a real workspace array, dimensioned MTRI x 2.
C
C   ITWK is an integer output array in which a sorted permutation of
C   the integers from 1 to NTRI is returned.
C
C   IORD is a flag that says how the triangles are to be ordered.  The
C   value 0 implies ordering by decreasing distance of the triangle
C   midpoints from the eye, -1 implies ordering by decreasing distance
C   of the triangle farpoints from the eye, and +1 implies ordering by
C   decreasing distance of the triangle farpoints from the eye, with
C   adjustments made by running an algorithm from Foley and Van Dam.
C
C Declare required TDPACK common blocks.
C
        COMMON /TDCOM1/ IH,IT,XM,YM,ZM,XO,YO,ZO,XT,YT,ZT,OE,XE,YE,ZE
        COMMON /TDCOM1/ A1,B1,C1,D1,E1,A2,B2,C2,D2,E2,A3,B3,C3,D3,E3
        COMMON /TDCOM1/ IS,FV,VL,VR,VB,VT,WL,WR,WB,WT
        SAVE   /TDCOM1/
C
C The following arithmetic statement functions are used to see whether
C a given point is on one side or the other of the planes defined by
C the 3-space triangles P and Q.
C
        PLNP(X,Y,Z)=ACPP*X+BCPP*Y+CCPP*Z+DCPP
        PLNQ(X,Y,Z)=ACPQ*X+BCPQ*Y+CCPQ*Z+DCPQ
C
C Create the initial ordering of the triangles by sorting on either the
C squares of the distances of the midpoints of the triangles or on the
C squares of the distances of the farpoints of the triangles (from the
C observer's eye), as implied by the value of IORD.  The order of the
C triangles is not actually changed in the triangle list; instead, a
C permutation of the integers from 1 to NTRI is returned in ITWK, such
C that RTWK(ITWK(1),1) <= RTWK(ITWK(2),1) <= RTWK(ITWK(3),1) <= ...
C RTWK(ITWK(NTRI),1).
C
        IF (IORD.EQ.0) THEN
C
          DO 101 I=1,NTRI
            RTWK(I,1)=(XE-((RTRI(1,I)+
     +                      RTRI(4,I)+
     +                      RTRI(7,I))/3.))**2+
     +                (YE-((RTRI(2,I)+
     +                      RTRI(5,I)+
     +                      RTRI(8,I))/3.))**2+
     +                (ZE-((RTRI(3,I)+
     +                      RTRI(6,I)+
     +                      RTRI(9,I))/3.))**2
  101     CONTINUE
C
        ELSE
C
          DO 102 I=1,NTRI
            DSQ1=(XE-RTRI(1,I))**2+(YE-RTRI(2,I))**2+(ZE-RTRI(3,I))**2
            DSQ2=(XE-RTRI(4,I))**2+(YE-RTRI(5,I))**2+(ZE-RTRI(6,I))**2
            DSQ3=(XE-RTRI(7,I))**2+(YE-RTRI(8,I))**2+(ZE-RTRI(9,I))**2
            RTWK(I,1)=MAX(DSQ1,DSQ2,DSQ3)
            RTWK(I,2)=MIN(DSQ1,DSQ2,DSQ3)
  102     CONTINUE
C
        END IF
C
        CALL TDSORT (RTWK,NTRI,1,ITWK)
C
C Quit if the ordering flag says not to check for ordering problems in
C the list.  Otherwise, the algorithm from Foley and Van Dam will be
C used to check for such problems.
C
        IF (IORD.LE.0) RETURN
C
C Compute a tolerance to use below.
C
        ETST=EPSI*(WR-WL)
C
C Multiply the rendering style selectors by 10 to provide room for an
C array of loop-detection flags required by the algorithm.
C
        DO 103 I=1,NTRI
          RTRI(10,I)=REAL(10*INT(ABS(RTRI(10,I))))
  103   CONTINUE
C
C Look through the triangle list for pairs of triangles whose order is
C not the order in which the triangles ought to be rendered.  The index
C ITRP steps through the entire list of triangles, save the last.
C
        ITRP=0
C
  104   ITRP=ITRP+1
C
        IF (ITRP.LT.NTRI) THEN
C
          ITWP=ITWK(ITRP)
C
C Get the X and Y coordinates of the vertices of the projection of
C triangle P in the projection plane.
C
          CALL TDPRPT (RTRI(1,ITWP),RTRI(2,ITWP),RTRI(3,ITWP),
     +                                              XCP1,YCP1)
          CALL TDPRPT (RTRI(4,ITWP),RTRI(5,ITWP),RTRI(6,ITWP),
     +                                              XCP2,YCP2)
          CALL TDPRPT (RTRI(7,ITWP),RTRI(8,ITWP),RTRI(9,ITWP),
     +                                              XCP3,YCP3)
C
C The index ITRQ steps from the position of ITRP through all the
C triangles whose range of distances from the viewpoint indicates
C a possible overlap of the projections of the triangles P and Q.
C
          ITRQ=ITRP
C
  105     ITRQ=ITRQ+1
C
          IF (ITRQ.LE.NTRI) THEN
C
            ITWQ=ITWK(ITRQ)
C
            IF (RTWK(ITWQ,1).LE.RTWK(ITWP,2)) THEN
C
              IF (MOD(INT(RTRI(10,ITWQ)),10).NE.0) GO TO 105
C
              GO TO 104
C
            ELSE
C
C Get the X and Y coordinates of the vertices of the projection of
C triangle Q in the projection plane.
C
              CALL TDPRPT (RTRI(1,ITWQ),RTRI(2,ITWQ),RTRI(3,ITWQ),
     +                                                  XCQ1,YCQ1)
              CALL TDPRPT (RTRI(4,ITWQ),RTRI(5,ITWQ),RTRI(6,ITWQ),
     +                                                  XCQ2,YCQ2)
              CALL TDPRPT (RTRI(7,ITWQ),RTRI(8,ITWQ),RTRI(9,ITWQ),
     +                                                  XCQ3,YCQ3)
C
C Jump if the X-coordinate ranges of the projected triangles don't
C overlap; such a pair of triangles can be rendered in either order.
C
              IF (MAX(XCP1,XCP2,XCP3).LE.MIN(XCQ1,XCQ2,XCQ3).OR.
     +            MIN(XCP1,XCP2,XCP3).GE.MAX(XCQ1,XCQ2,XCQ3)) GO TO 105
C
C Similarly, jump if the Y-coordinate ranges of the projected triangles
C don't overlap.
C
              IF (MAX(YCP1,YCP2,YCP3).LE.MIN(YCQ1,YCQ2,YCQ3).OR.
     +            MIN(YCP1,YCP2,YCP3).GE.MAX(YCQ1,YCQ2,YCQ3)) GO TO 105
C
C Compute the coefficients A, B, C, and D in the equation defining the
C plane of triangle Q.
C
              ACPQ=(RTRI(5,ITWQ)-RTRI(2,ITWQ))*
     +             (RTRI(9,ITWQ)-RTRI(3,ITWQ))-
     +             (RTRI(8,ITWQ)-RTRI(2,ITWQ))*
     +             (RTRI(6,ITWQ)-RTRI(3,ITWQ))
C
              BCPQ=(RTRI(6,ITWQ)-RTRI(3,ITWQ))*
     +             (RTRI(7,ITWQ)-RTRI(1,ITWQ))-
     +             (RTRI(9,ITWQ)-RTRI(3,ITWQ))*
     +             (RTRI(4,ITWQ)-RTRI(1,ITWQ))
C
              CCPQ=(RTRI(4,ITWQ)-RTRI(1,ITWQ))*
     +             (RTRI(8,ITWQ)-RTRI(2,ITWQ))-
     +             (RTRI(7,ITWQ)-RTRI(1,ITWQ))*
     +             (RTRI(5,ITWQ)-RTRI(2,ITWQ))
C
              DCPQ=-(ACPQ*RTRI(1,ITWQ)+
     +               BCPQ*RTRI(2,ITWQ)+
     +               CCPQ*RTRI(3,ITWQ))
C
C Compute quantities proportional to the directed distances from the
C plane of triangle Q to the viewpoint (the eye) and to each vertex
C of the triangle P.  ("PQVP" stands for "Position, relative to Q's
C plane, of ViewPoint" and "PQPn" stands for "Position, relative to
C Q's plane, of point Pn".)
C
              PQVP=PLNQ(XE,YE,ZE)
C
              PQP1=PLNQ(RTRI(1,ITWP),RTRI(2,ITWP),RTRI(3,ITWP))
              PQP2=PLNQ(RTRI(4,ITWP),RTRI(5,ITWP),RTRI(6,ITWP))
              PQP3=PLNQ(RTRI(7,ITWP),RTRI(8,ITWP),RTRI(9,ITWP))
C
              PMIN=MIN(PQP1,PQP2,PQP3)
              PMAX=MAX(PQP1,PQP2,PQP3)
C
              PTST=SQRT(ACPQ*ACPQ+BCPQ*BCPQ+CCPQ*CCPQ)*ETST
C
C If triangle P is on the opposite side of triangle Q's plane from the
C viewpoint, then P cannot obscure Q, so jump.
C
              IF ((PQVP.LE.0..AND.PMIN.GE.-PTST).OR.
     +            (PQVP.GE.0..AND.PMAX.LE. PTST)    ) GO TO 105
C
C Compute the coefficients A, B, C, and D in the equation defining the
C plane of triangle P.
C
              ACPP=(RTRI(5,ITWP)-RTRI(2,ITWP))*
     +             (RTRI(9,ITWP)-RTRI(3,ITWP))-
     +             (RTRI(8,ITWP)-RTRI(2,ITWP))*
     +             (RTRI(6,ITWP)-RTRI(3,ITWP))
C
              BCPP=(RTRI(6,ITWP)-RTRI(3,ITWP))*
     +             (RTRI(7,ITWP)-RTRI(1,ITWP))-
     +             (RTRI(9,ITWP)-RTRI(3,ITWP))*
     +             (RTRI(4,ITWP)-RTRI(1,ITWP))
C
              CCPP=(RTRI(4,ITWP)-RTRI(1,ITWP))*
     +             (RTRI(8,ITWP)-RTRI(2,ITWP))-
     +             (RTRI(7,ITWP)-RTRI(1,ITWP))*
     +             (RTRI(5,ITWP)-RTRI(2,ITWP))
C
              DCPP=-(ACPP*RTRI(1,ITWP)+
     +               BCPP*RTRI(2,ITWP)+
     +               CCPP*RTRI(3,ITWP))
C
C Compute quantities proportional to the directed distances from the
C plane of triangle P to the viewpoint (the eye) and to each vertex
C of the triangle Q.  ("PPVP" stands for "Position, relative to P's
C plane, of ViewPoint" and "PPQn" stands for "Position, relative to
C P's plane, of point Qn".)
C
              PPVP=PLNP(XE,YE,ZE)
C
              PPQ1=PLNP(RTRI(1,ITWQ),RTRI(2,ITWQ),RTRI(3,ITWQ))
              PPQ2=PLNP(RTRI(4,ITWQ),RTRI(5,ITWQ),RTRI(6,ITWQ))
              PPQ3=PLNP(RTRI(7,ITWQ),RTRI(8,ITWQ),RTRI(9,ITWQ))
C
              QMIN=MIN(PPQ1,PPQ2,PPQ3)
              QMAX=MAX(PPQ1,PPQ2,PPQ3)
C
              QTST=SQRT(ACPP*ACPP+BCPP*BCPP+CCPP*CCPP)*ETST
C
C If triangle Q is on the same side of triangle P's plane from the
C viewpoint, then P cannot obscure Q, so jump.
C
              IF ((PPVP.LE.0..AND.QMAX.LE. QTST).OR.
     +            (PPVP.GE.0..AND.QMIN.GE.-QTST)    ) GO TO 105
C
C If the projections of P and Q in the projection plane don't overlap
C at all, then P cannot obscure Q, so jump.
C
              IF (ITROVR(XCP1,YCP1,XCP2,YCP2,XCP3,YCP3,
     +                   XCQ1,YCQ1,XCQ2,YCQ2,XCQ3,YCQ3).EQ.0) GO TO 105
C
C Otherwise, the situation is in doubt: we have not established that P
C cannot obscure Q.  Unless Q has previously been moved to the start
C of the list (indicating an "infinite" loop), check for the possibility
C that it cannot obscure P; if so, move Q to precede P in the list and
C make it the new P.
C
              IF (MOD(INT(RTRI(10,ITWQ)),10).EQ.0) THEN
                IF ((PPVP.LE.0..AND.QMIN.GE.-QTST).OR.
     +              (PPVP.GE.0..AND.QMAX.LE. QTST).OR.
     +              (PQVP.LE.0..AND.PMAX.LE. PTST).OR.
     +              (PQVP.GE.0..AND.PMIN.GE.-PTST)    ) THEN
                  DO 106 I=ITRQ,ITRP+1,-1
                    ITWK(I)=ITWK(I-1)
  106             CONTINUE
                  ITWK(ITRP)=ITWQ
                  RTRI(10,ITWQ)=RTRI(10,ITWQ)+1.
                  ITRP=ITRP-1
                  GO TO 104
                END IF
              END IF
C
C Otherwise, the situation is still in doubt.  There is no satisfactory
C order in which to process P and Q, so we split either P or Q into
C three pieces, put those pieces back in the proper positions in the
C triangle list, and resume the scan.  First, try to split Q.
C
              IF (QMIN.LT.0..AND.QMAX.GT.0.) THEN
                IF      (SIGN(1.,PPQ1).EQ.SIGN(1.,PPQ2)) THEN
                  ITQ1=1
                  ITQ2=4
                  ITQ3=7
                  TATA=ABS(PPQ3)/(ABS(PPQ3)+ABS(PPQ1))
                  TATB=ABS(PPQ2)/(ABS(PPQ2)+ABS(PPQ3))
                ELSE IF (SIGN(1.,PPQ2).EQ.SIGN(1.,PPQ3)) THEN
                  ITQ1=4
                  ITQ2=7
                  ITQ3=1
                  TATA=ABS(PPQ1)/(ABS(PPQ1)+ABS(PPQ2))
                  TATB=ABS(PPQ3)/(ABS(PPQ3)+ABS(PPQ1))
                ELSE
                  ITQ1=7
                  ITQ2=1
                  ITQ3=4
                  TATA=ABS(PPQ2)/(ABS(PPQ2)+ABS(PPQ3))
                  TATB=ABS(PPQ1)/(ABS(PPQ1)+ABS(PPQ2))
                END IF
              ELSE
                GO TO 110
              END IF
C
              IF (TATA.LE.EPSI.OR.TATB.GE.OMEP.OR.
     +           (TATA.GE.OMEP.AND.TATB.LE.EPSI)) GO TO 110
C
              XCPA=(1.-TATA)*RTRI(ITQ3  ,ITWQ)+TATA*RTRI(ITQ1  ,ITWQ)
              YCPA=(1.-TATA)*RTRI(ITQ3+1,ITWQ)+TATA*RTRI(ITQ1+1,ITWQ)
              ZCPA=(1.-TATA)*RTRI(ITQ3+2,ITWQ)+TATA*RTRI(ITQ1+2,ITWQ)
C
              XCPB=(1.-TATB)*RTRI(ITQ2  ,ITWQ)+TATB*RTRI(ITQ3  ,ITWQ)
              YCPB=(1.-TATB)*RTRI(ITQ2+1,ITWQ)+TATB*RTRI(ITQ3+1,ITWQ)
              ZCPB=(1.-TATB)*RTRI(ITQ2+2,ITWQ)+TATB*RTRI(ITQ3+2,ITWQ)
C
              NTRS=NTRI
C
              IF (TATA.GE.OMEP.OR.TATB.LE.EPSI) THEN
                IF (NTRI.GE.MTRI) GO TO 116
                NTRI=NTRI+1
                IF (TATB.LE.EPSI) THEN
                  RTRI(1,NTRI)=RTRI(ITQ1  ,ITWQ)
                  RTRI(2,NTRI)=RTRI(ITQ1+1,ITWQ)
                  RTRI(3,NTRI)=RTRI(ITQ1+2,ITWQ)
                  RTRI(4,NTRI)=RTRI(ITQ2  ,ITWQ)
                  RTRI(5,NTRI)=RTRI(ITQ2+1,ITWQ)
                  RTRI(6,NTRI)=RTRI(ITQ2+2,ITWQ)
                  RTRI(7,NTRI)=XCPA
                  RTRI(8,NTRI)=YCPA
                  RTRI(9,NTRI)=ZCPA
                  RTRI(ITQ1  ,ITWQ)=XCPA
                  RTRI(ITQ1+1,ITWQ)=YCPA
                  RTRI(ITQ1+2,ITWQ)=ZCPA
                ELSE
                  RTRI(1,NTRI)=RTRI(ITQ1  ,ITWQ)
                  RTRI(2,NTRI)=RTRI(ITQ1+1,ITWQ)
                  RTRI(3,NTRI)=RTRI(ITQ1+2,ITWQ)
                  RTRI(4,NTRI)=RTRI(ITQ2  ,ITWQ)
                  RTRI(5,NTRI)=RTRI(ITQ2+1,ITWQ)
                  RTRI(6,NTRI)=RTRI(ITQ2+2,ITWQ)
                  RTRI(7,NTRI)=XCPB
                  RTRI(8,NTRI)=YCPB
                  RTRI(9,NTRI)=ZCPB
                  RTRI(ITQ2  ,ITWQ)=XCPB
                  RTRI(ITQ2+1,ITWQ)=YCPB
                  RTRI(ITQ2+2,ITWQ)=ZCPB
                END IF
                RTRI(10,NTRI)=REAL(10*(INT(RTRI(10,ITWQ))/10))
                ITWK(NTRI)=NTRI
              ELSE
                IF (NTRI.GE.MTRI) GO TO 116
                NTRI=NTRI+1
                RTRI(1,NTRI)=RTRI(ITQ1  ,ITWQ)
                RTRI(2,NTRI)=RTRI(ITQ1+1,ITWQ)
                RTRI(3,NTRI)=RTRI(ITQ1+2,ITWQ)
                RTRI(4,NTRI)=RTRI(ITQ2  ,ITWQ)
                RTRI(5,NTRI)=RTRI(ITQ2+1,ITWQ)
                RTRI(6,NTRI)=RTRI(ITQ2+2,ITWQ)
                RTRI(7,NTRI)=XCPA
                RTRI(8,NTRI)=YCPA
                RTRI(9,NTRI)=ZCPA
                RTRI(10,NTRI)=REAL(10*(INT(RTRI(10,ITWQ))/10))
                ITWK(NTRI)=NTRI
                IF (NTRI.GE.MTRI) GO TO 116
                NTRI=NTRI+1
                RTRI(1,NTRI)=RTRI(ITQ2  ,ITWQ)
                RTRI(2,NTRI)=RTRI(ITQ2+1,ITWQ)
                RTRI(3,NTRI)=RTRI(ITQ2+2,ITWQ)
                RTRI(4,NTRI)=XCPB
                RTRI(5,NTRI)=YCPB
                RTRI(6,NTRI)=ZCPB
                RTRI(7,NTRI)=XCPA
                RTRI(8,NTRI)=YCPA
                RTRI(9,NTRI)=ZCPA
                RTRI(10,NTRI)=REAL(10*(INT(RTRI(10,ITWQ))/10))
                ITWK(NTRI)=NTRI
                RTRI(ITQ1  ,ITWQ)=XCPA
                RTRI(ITQ1+1,ITWQ)=YCPA
                RTRI(ITQ1+2,ITWQ)=ZCPA
                RTRI(ITQ2  ,ITWQ)=XCPB
                RTRI(ITQ2+1,ITWQ)=YCPB
                RTRI(ITQ2+2,ITWQ)=ZCPB
              END IF
C
              DSQ1=(XE-RTRI(1,ITWQ))**2+
     +             (YE-RTRI(2,ITWQ))**2+
     +             (ZE-RTRI(3,ITWQ))**2
              DSQ2=(XE-RTRI(4,ITWQ))**2+
     +             (YE-RTRI(5,ITWQ))**2+
     +             (ZE-RTRI(6,ITWQ))**2
              DSQ3=(XE-RTRI(7,ITWQ))**2+
     +             (YE-RTRI(8,ITWQ))**2+
     +             (ZE-RTRI(9,ITWQ))**2
              RTWK(ITWQ,1)=MAX(DSQ1,DSQ2,DSQ3)
              RTWK(ITWQ,2)=MIN(DSQ1,DSQ2,DSQ3)
C
              RTRI(10,ITWQ)=REAL(10*(INT(RTRI(10,ITWQ))/10))
C
              ITRT=ITRQ
C
  107         IF (ITRT.LT.NTRS) THEN
                IF (MOD(INT(RTRI(10,ITWK(ITRT+1))),10).NE.0.OR.
     +              RTWK(ITWQ,1).LT.RTWK(ITWK(ITRT+1),1)) THEN
                  ITWK(ITRT)=ITWK(ITRT+1)
                  ITWK(ITRT+1)=ITWQ
                  ITRT=ITRT+1
                  GO TO 107
                END IF
              END IF
C
              DO 109 I=NTRS+1,NTRI
                DSQ1=(XE-RTRI(1,I))**2+
     +               (YE-RTRI(2,I))**2+
     +               (ZE-RTRI(3,I))**2
                DSQ2=(XE-RTRI(4,I))**2+
     +               (YE-RTRI(5,I))**2+
     +               (ZE-RTRI(6,I))**2
                DSQ3=(XE-RTRI(7,I))**2+
     +               (YE-RTRI(8,I))**2+
     +               (ZE-RTRI(9,I))**2
                RTWK(I,1)=MAX(DSQ1,DSQ2,DSQ3)
                RTWK(I,2)=MIN(DSQ1,DSQ2,DSQ3)
                ITRT=I
  108           IF (ITRT.GT.ITRP+1) THEN
                  IF (MOD(INT(RTRI(10,ITWK(ITRT-1))),10).EQ.0.AND.
     +                RTWK(I,1).GT.RTWK(ITWK(ITRT-1),1)) THEN
                    ITWK(ITRT)=ITWK(ITRT-1)
                    ITWK(ITRT-1)=I
                    ITRT=ITRT-1
                    GO TO 108
                  END IF
                END IF
  109         CONTINUE
C
              ITRQ=ITRQ-1
C
              GO TO 105
C
C For one reason or another, Q could not be split.  Try to split P.
C
  110         IF (PMIN.LT.0..AND.PMAX.GT.0.) THEN
                IF      (SIGN(1.,PQP1).EQ.SIGN(1.,PQP2)) THEN
                  ITP1=1
                  ITP2=4
                  ITP3=7
                  TATA=ABS(PQP3)/(ABS(PQP3)+ABS(PQP1))
                  TATB=ABS(PQP2)/(ABS(PQP2)+ABS(PQP3))
                ELSE IF (SIGN(1.,PQP2).EQ.SIGN(1.,PQP3)) THEN
                  ITP1=4
                  ITP2=7
                  ITP3=1
                  TATA=ABS(PQP1)/(ABS(PQP1)+ABS(PQP2))
                  TATB=ABS(PQP3)/(ABS(PQP3)+ABS(PQP1))
                ELSE
                  ITP1=7
                  ITP2=1
                  ITP3=4
                  TATA=ABS(PQP2)/(ABS(PQP2)+ABS(PQP3))
                  TATB=ABS(PQP1)/(ABS(PQP1)+ABS(PQP2))
                END IF
              ELSE
                GO TO 114
              END IF
C
              IF (TATA.LE.EPSI.OR.TATB.GE.OMEP.OR.
     +           (TATA.GE.OMEP.AND.TATB.LE.EPSI)) GO TO 114
C
              XCPA=(1.-TATA)*RTRI(ITP3  ,ITWP)+TATA*RTRI(ITP1  ,ITWP)
              YCPA=(1.-TATA)*RTRI(ITP3+1,ITWP)+TATA*RTRI(ITP1+1,ITWP)
              ZCPA=(1.-TATA)*RTRI(ITP3+2,ITWP)+TATA*RTRI(ITP1+2,ITWP)
C
              XCPB=(1.-TATB)*RTRI(ITP2  ,ITWP)+TATB*RTRI(ITP3  ,ITWP)
              YCPB=(1.-TATB)*RTRI(ITP2+1,ITWP)+TATB*RTRI(ITP3+1,ITWP)
              ZCPB=(1.-TATB)*RTRI(ITP2+2,ITWP)+TATB*RTRI(ITP3+2,ITWP)
C
              NTRS=NTRI
C
              IF (TATA.GE.OMEP.OR.TATB.LE.EPSI) THEN
                IF (NTRI.GE.MTRI) GO TO 116
                NTRI=NTRI+1
                IF (TATB.LE.EPSI) THEN
                  RTRI(1,NTRI)=RTRI(ITP1  ,ITWP)
                  RTRI(2,NTRI)=RTRI(ITP1+1,ITWP)
                  RTRI(3,NTRI)=RTRI(ITP1+2,ITWP)
                  RTRI(4,NTRI)=RTRI(ITP2  ,ITWP)
                  RTRI(5,NTRI)=RTRI(ITP2+1,ITWP)
                  RTRI(6,NTRI)=RTRI(ITP2+2,ITWP)
                  RTRI(7,NTRI)=XCPA
                  RTRI(8,NTRI)=YCPA
                  RTRI(9,NTRI)=ZCPA
                  RTRI(ITP1  ,ITWP)=XCPA
                  RTRI(ITP1+1,ITWP)=YCPA
                  RTRI(ITP1+2,ITWP)=ZCPA
                ELSE
                  RTRI(1,NTRI)=RTRI(ITP1  ,ITWP)
                  RTRI(2,NTRI)=RTRI(ITP1+1,ITWP)
                  RTRI(3,NTRI)=RTRI(ITP1+2,ITWP)
                  RTRI(4,NTRI)=RTRI(ITP2  ,ITWP)
                  RTRI(5,NTRI)=RTRI(ITP2+1,ITWP)
                  RTRI(6,NTRI)=RTRI(ITP2+2,ITWP)
                  RTRI(7,NTRI)=XCPB
                  RTRI(8,NTRI)=YCPB
                  RTRI(9,NTRI)=ZCPB
                  RTRI(ITP2  ,ITWP)=XCPB
                  RTRI(ITP2+1,ITWP)=YCPB
                  RTRI(ITP2+2,ITWP)=ZCPB
                END IF
                RTRI(10,NTRI)=REAL(10*(INT(RTRI(10,ITWP))/10))
                ITWK(NTRI)=NTRI
              ELSE
                IF (NTRI.GE.MTRI) GO TO 116
                NTRI=NTRI+1
                RTRI(1,NTRI)=RTRI(ITP1  ,ITWP)
                RTRI(2,NTRI)=RTRI(ITP1+1,ITWP)
                RTRI(3,NTRI)=RTRI(ITP1+2,ITWP)
                RTRI(4,NTRI)=RTRI(ITP2  ,ITWP)
                RTRI(5,NTRI)=RTRI(ITP2+1,ITWP)
                RTRI(6,NTRI)=RTRI(ITP2+2,ITWP)
                RTRI(7,NTRI)=XCPA
                RTRI(8,NTRI)=YCPA
                RTRI(9,NTRI)=ZCPA
                RTRI(10,NTRI)=REAL(10*(INT(RTRI(10,ITWP))/10))
                ITWK(NTRI)=NTRI
                IF (NTRI.GE.MTRI) GO TO 116
                NTRI=NTRI+1
                RTRI(1,NTRI)=RTRI(ITP2  ,ITWP)
                RTRI(2,NTRI)=RTRI(ITP2+1,ITWP)
                RTRI(3,NTRI)=RTRI(ITP2+2,ITWP)
                RTRI(4,NTRI)=XCPB
                RTRI(5,NTRI)=YCPB
                RTRI(6,NTRI)=ZCPB
                RTRI(7,NTRI)=XCPA
                RTRI(8,NTRI)=YCPA
                RTRI(9,NTRI)=ZCPA
                RTRI(10,NTRI)=REAL(10*(INT(RTRI(10,ITWP))/10))
                ITWK(NTRI)=NTRI
                RTRI(ITP1  ,ITWP)=XCPA
                RTRI(ITP1+1,ITWP)=YCPA
                RTRI(ITP1+2,ITWP)=ZCPA
                RTRI(ITP2  ,ITWP)=XCPB
                RTRI(ITP2+1,ITWP)=YCPB
                RTRI(ITP2+2,ITWP)=ZCPB
              END IF
C
              DSQ1=(XE-RTRI(1,ITWP))**2+
     +             (YE-RTRI(2,ITWP))**2+
     +             (ZE-RTRI(3,ITWP))**2
              DSQ2=(XE-RTRI(4,ITWP))**2+
     +             (YE-RTRI(5,ITWP))**2+
     +             (ZE-RTRI(6,ITWP))**2
              DSQ3=(XE-RTRI(7,ITWP))**2+
     +             (YE-RTRI(8,ITWP))**2+
     +             (ZE-RTRI(9,ITWP))**2
              RTWK(ITWP,1)=MAX(DSQ1,DSQ2,DSQ3)
              RTWK(ITWP,2)=MIN(DSQ1,DSQ2,DSQ3)
C
              RTRI(10,ITWP)=REAL(10*(INT(RTRI(10,ITWP))/10))
C
              ITRT=ITRP
C
  111         IF (ITRT.LT.NTRS) THEN
                IF (MOD(INT(RTRI(10,ITWK(ITRT+1))),10).NE.0.OR.
     +              RTWK(ITWP,1).LT.RTWK(ITWK(ITRT+1),1)) THEN
                  ITWK(ITRT)=ITWK(ITRT+1)
                  ITWK(ITRT+1)=ITWP
                  ITRT=ITRT+1
                  GO TO 111
                END IF
              END IF
C
              DO 113 I=NTRS+1,NTRI
                DSQ1=(XE-RTRI(1,I))**2+
     +               (YE-RTRI(2,I))**2+
     +               (ZE-RTRI(3,I))**2
                DSQ2=(XE-RTRI(4,I))**2+
     +               (YE-RTRI(5,I))**2+
     +               (ZE-RTRI(6,I))**2
                DSQ3=(XE-RTRI(7,I))**2+
     +               (YE-RTRI(8,I))**2+
     +               (ZE-RTRI(9,I))**2
                RTWK(I,1)=MAX(DSQ1,DSQ2,DSQ3)
                RTWK(I,2)=MIN(DSQ1,DSQ2,DSQ3)
                ITRT=I
  112           IF (ITRT.GT.ITRP) THEN
                  IF (MOD(INT(RTRI(10,ITWK(ITRT-1))),10).EQ.0.AND.
     +                RTWK(I,1).GT.RTWK(ITWK(ITRT-1),1)) THEN
                    ITWK(ITRT)=ITWK(ITRT-1)
                    ITWK(ITRT-1)=I
                    ITRT=ITRT-1
                    GO TO 112
                  END IF
                END IF
  113         CONTINUE
C
              ITRP=ITRP-1
C
              GO TO 104
C
C If neither Q nor P can be split, move Q to precede P anyway, checking
C first for an infinite loop.
C
  114         IF (MOD(INT(RTRI(10,ITWQ)),10).GT.8) GO TO 105
C
              IF ((PPVP.LE.0..AND.QMIN.GE.-QTST).OR.
     +            (PPVP.GE.0..AND.QMAX.LE. QTST).OR.
     +            (PQVP.LE.0..AND.PMAX.LE. PTST).OR.
     +            (PQVP.GE.0..AND.PMIN.GE.-PTST)    ) THEN
C
                DO 115 I=ITRQ,ITRP+1,-1
                  ITWK(I)=ITWK(I-1)
  115           CONTINUE
C
                ITWK(ITRP)=ITWQ
C
                RTRI(10,ITWQ)=RTRI(10,ITWQ)+1.
C
                ITRP=ITRP-1
C
                GO TO 104
C
              ELSE
C
                GO TO 105
C
              END IF
C
            END IF
C
C           GO TO 105
C
          END IF
C
          GO TO 104
C
        END IF
C
C Force all the returned indices to be in the correct range.
C
  116   DO 117 I=1,NTRI
          RTRI(10,I)=REAL(INT(RTRI(10,I))/10)
  117   CONTINUE
C
C Done.
C
        RETURN
C
      END

C
C $Id: agmaxi.f,v 1.6 2008-07-27 00:14:35 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      FUNCTION AGMAXI (SVAL,ZHGH,ZDRA,NVIZ,IIVZ,NEVZ,IIEZ)
C
      DIMENSION ZDRA(1)
C
C The routine AGMAXI returns the maximum value of the elements in ZDRA
C specified by NVIZ, IIVZ, NEVZ, and IIEZ, skipping elements having the
C special value SVAL (or more than ZHGH, if ZHGH is not equal to SVAL).
C
C -- NVIZ is the number of vectors of data stored in ZDRA.
C
C -- IIVZ is the index increment from one data vector to the next.
C
C -- NEVZ is the number of elements per vector to be examined.
C
C -- IIEZ is the index increment from one vector element to the next.
C    If IIEZ is 0, the array is ignored and NEVZ is returned.
C
      AGMAXI=REAL(NEVZ)
      IF (IIEZ.EQ.0) RETURN
C
      AGMAXI=SVAL
      INDZ=1-IIEZ
C
      DO 103 I=1,NVIZ
        IF (ZHGH.EQ.SVAL) THEN
          DO 101 J=1,NEVZ
            INDZ=INDZ+IIEZ
            IF (ZDRA(INDZ).EQ.SVAL) GO TO 101
            IF (AGMAXI.EQ.SVAL) AGMAXI=ZDRA(INDZ)
            AGMAXI=MAX(AGMAXI,ZDRA(INDZ))
  101     CONTINUE
        ELSE
          DO 102 J=1,NEVZ
            INDZ=INDZ+IIEZ
            IF (ZDRA(INDZ).EQ.SVAL.OR.ZDRA(INDZ).GT.ZHGH) GO TO 102
            IF (AGMAXI.EQ.SVAL) AGMAXI=ZDRA(INDZ)
            AGMAXI=MAX(AGMAXI,ZDRA(INDZ))
  102     CONTINUE
        END IF
        INDZ=INDZ-NEVZ*IIEZ+IIVZ
  103 CONTINUE
C
      RETURN
C
      END

C
C $Id: pj14sp.f,v 1.5 2008-07-27 00:17:11 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE PJ14SP (COORD,CRDIO,INDIC)
C
C -- O R T H O G R A P H I C
C
      IMPLICIT REAL (A-Z)
      INTEGER INDIC
      DIMENSION GEOG(2),PROJ(2),COORD(2),CRDIO(2)
C **** PARAMETERS **** A,LON0,LAT0,X0,Y0,SINPH0,COSPH0 *****************
      COMMON /ERRMZ0/ IERR
        INTEGER IERR
      SAVE   /ERRMZ0/
      COMMON /PRINZ0/ IPEMSG,IPELUN,IPPARM,IPPLUN
        INTEGER IPEMSG,IPELUN,IPPARM,IPPLUN
      SAVE   /PRINZ0/
      COMMON /PC14SP/ A,LON0,X0,Y0,COSPH0,LAT0,SINPH0
      DATA HALFPI /1.5707963267948966E0/
      DATA EPSLN /1.0E-10/
      DATA ZERO,ONE /0.0E0,1.0E0/
C
C -- F O R W A R D   . . .
C
      IF (INDIC .EQ. 0) THEN
C
         GEOG(1) = COORD(1)
         GEOG(2) = COORD(2)
         IERR = 0
         LON = ADJLSP (GEOG(1) - LON0)
         SINPHI = SIN (GEOG(2))
         COSPHI = COS (GEOG(2))
         COSLON = COS (LON)
         G = SINPH0 * SINPHI + COSPH0 * COSPHI * COSLON
         KSP = ONE
         IF (G.GT.ZERO .OR. ABS(G).LE.EPSLN) GO TO 140
         IF (IPEMSG .EQ. 0) WRITE (IPELUN,2020)
 2020    FORMAT (' POINT CANNOT BE PROJECTED')
         IERR = 143
         RETURN
  140    PROJ(1) = X0 + A * KSP * COSPHI * SIN (LON)
         PROJ(2) = Y0 + A * KSP * (COSPH0 * SINPHI - SINPH0 * COSPHI *
     .             COSLON)
         CRDIO(1) = PROJ(1)
         CRDIO(2) = PROJ(2)
         RETURN
      END IF
C
C -- I N V E R S E   . . .
C
      IF (INDIC .EQ. 1) THEN
C
         PROJ(1) = COORD(1)
         PROJ(2) = COORD(2)
         IERR = 0
         X = PROJ(1) - X0
         Y = PROJ(2) - Y0
         RH = SQRT (X * X + Y * Y)
         IF (RH .LE. A) GO TO 230
         IF (IPEMSG .EQ. 0) WRITE (IPELUN,2030)
 2030    FORMAT (/' ERROR PJ14SP'/
     .            ' INPUT DATA ERROR')
         IERR = 145
         RETURN
  230    Z = ASINSP (RH / A)
         SINZ = SIN (Z)
         COSZ = COS (Z)
         GEOG(1) = LON0
         IF (ABS(RH) .GT. EPSLN) GO TO 240
         GEOG(2) = LAT0
         CRDIO(1) = GEOG(1)
         CRDIO(2) = GEOG(2)
         RETURN
  240    GEOG(2) = ASINSP (COSZ * SINPH0 + Y * SINZ * COSPH0 / RH)
         CON = ABS (LAT0) - HALFPI
         IF (ABS (CON) .GT. EPSLN) GO TO 260
         IF (LAT0 .LT. ZERO) GO TO 250
         GEOG(1) = ADJLSP (LON0 + ATAN2 (X , -Y))
         CRDIO(1) = GEOG(1)
         CRDIO(2) = GEOG(2)
         RETURN
  250    GEOG(1) = ADJLSP (LON0 - ATAN2 (-X , Y))
         CRDIO(1) = GEOG(1)
         CRDIO(2) = GEOG(2)
         RETURN
  260    CON = COSZ - SINPH0 * SIN (GEOG(2))
         IF (ABS(CON).LT.EPSLN.AND.ABS(X).LT.EPSLN) RETURN
         GEOG(1) = ADJLSP (LON0 + ATAN2 ((X*SINZ*COSPH0) , (CON*RH)))
         CRDIO(1) = GEOG(1)
         CRDIO(2) = GEOG(2)
         RETURN
      END IF
C
      END

C
C       $Id: drwstr.f,v 1.6 2008-07-27 00:17:27 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE DRWSTR  (U,V,UX,VY,IMAX,JPTSY)
C
      PARAMETER (NCHK=750)
C
C THIS ROUTINE DRAWS THE STREAMLINES.
C .   THE XCHK AND YCHK ARRAYS SERVE AS A CIRCULAR LIST. THEY
C .   ARE USED TO PREVENT LINES FROM CROSSING ONE ANOTHER.
C
C THE WORK ARRAY HAS BEEN BROKEN UP INTO TWO ARRAYS FOR CLARITY.  THE
C .   TOP HALF OF WORK (CALLED UX) WILL HAVE THE NORMALIZED (AND
C .   POSSIBLY TRANSFORMED) U COMPONENTS AND WILL BE USED FOR BOOK
C .   KEEPING.  THE LOWER HALF OF THE WORK ARRAY (CALLED VY) WILL
C .   CONTAIN THE NORMALIZED (AND POSSIBLY TRANSFORMED) V COMPONENTS.
C
      DIMENSION       U(IMAX,JPTSY)         ,V(IMAX,JPTSY)
     1             ,  UX(IMAX,JPTSY)        ,VY(IMAX,JPTSY)
      COMMON /STR01/  IS         ,IEND      ,JS        ,JEND
     1             ,  IEND1      ,JEND1     ,I         ,J
     2             ,  X          ,Y         ,DELX      ,DELY
     3             ,  ICYC1      ,IMSG1     ,IGFL1
      COMMON /STR03/  INITA , INITB , AROWL , ITERP , ITERC , IGFLG
     1             ,  IMSG , UVMSG , ICYC , DISPL , DISPC , CSTOP
      COMMON /STR04/  XCHK(NCHK) ,YCHK(NCHK) , NUMCHK , UXSML
C
C
        SAVE
C
C STATEMENT FUNCTIONS FOR SPATIAL AND VELOCITY TRANSFORMATIONS.
C .   (IF THE USER WISHES OTHER TRANSFORMATIONS  REPLACE THESE STATEMENT
C .   FUNCTIONS WITH THE APPROPRIATE NEW ONES, OR , IF THE TRANSFORMA-
C .   TIONS ARE COMPLICATED DELETE THESE STATEMENT FUNCTIONS
C .   AND ADD EXTERNAL ROUTINES WITH THE SAME NAMES TO DO THE TRANS-
C .   FORMING.)
C
C     FX(X,Y) = X
C     FY(X,Y) = Y
      FU(X,Y) = X
      FV(X,Y) = Y
C
C INITIALIZE
C
      ISKIP    = I1MACH(5) - 2
      ISKIP1   = ISKIP + 1
      UXSML    = R1MACH(3) * DISPL
C
C
      NUMCHK   = NCHK
      LCHK = 1
      ICHK = 1
      XCHK(1) = 0.
      YCHK(1) = 0.
      KFLAG = 0
      IZERO = 0
      IONE = 1
      ITWO = 2
C
C
C COMPUTE THE X AND Y NORMALIZED (AND POSSIBLY TRANSFORMED)
C .   DISPLACEMENT COMPONENTS (UX AND VY).
C
      DO  40 J=JS,JEND
      DO  30 I=IS,IEND
      UX(I,J) = FU(U(I,J),V(I,J))
      VY(I,J) = FV(U(I,J),V(I,J))
      IF (UX(I,J).NE.0. .OR. VY(I,J).NE.0.) THEN
        CON = DISPL/SQRT(UX(I,J)*UX(I,J) + VY(I,J)*VY(I,J))
        UX(I,J) = CON*UX(I,J)
        VY(I,J) = CON*VY(I,J)
      END IF
C
C BOOKKEEPING IS DONE IN THE LEAST SIGNIFICANT BITS OF THE UX ARRAY.
C .   WHEN UX(I,J) IS EXACTLY ZERO THIS CAN PRESENT SOME PROBLEMS.
C .   TO GET AROUND THIS PROBLEM, SET IT TO A RELATIVELY SMALL NUMBER.
C
      IF(UX(I,J) .EQ. 0.) UX(I,J) = UXSML
C
C MASK OUT THE LEAST SIGNIFICANT TWO BITS AS FLAGS FOR EACH GRID BOX
C .   A GRID BOX IS ANY REGION SURROUNDED BY FOUR GRID POINTS.
C .   FLAG 1 INDICATES WHETHER ANY STREAMLINE HAS PREVIOUSLY PASSED
C .          THROUGH THIS BOX.
C .   FLAG 2 INDICATES WHETHER ANY DIRECTIONAL ARROW HAS ALREADY
C .          APPEARED IN THIS BOX.
C .   JUDICIOUS USE OF THESE FLAGS PREVENTS OVERCROWDING OF
C .   STREAMLINES AND DIRECTIONAL ARROWS.
C
      CALL SBYTES( UX(I,J) , IZERO , ISKIP , 2 , 0 , 1 )
C
      IF (MOD(I,INITA).NE.0 .OR. MOD(J,INITA).NE.0)
     1    CALL SBYTES( UX(I,J) , IONE , ISKIP1, 1 , 0 , 1 )
      IF (MOD(I,INITB).NE.0 .OR. MOD(J,INITB).NE.0)
     1    CALL SBYTES( UX(I,J) , IONE , ISKIP , 1 , 0 , 1 )
C
   30 CONTINUE
   40 CONTINUE
C
   50 CONTINUE
C
C START A STREAMLINE. EXPERIENCE HAS SHOWN THAT A PLEASING PICTURE
C .   WILL BE PRODUCED IF NEW STREAMLINES ARE STARTED ONLY IN GRID
C .   BOXES THAT PREVIOUSLY HAVE NOT HAD OTHER STREAMLINES PASS THROUGH
C .   THEM. AS LONG AS A REASONABLY DENSE PATTERN OF AVAILABLE BOXES
C .   IS INITIALLY PRESCRIBED, THE ORDER OF SCANNING THE GRID PTS. FOR
C .   AVAILABLE BOXES IS IMMATERIAL
C
C FIND AN AVAILABLE BOX FOR STARTING A STREAMLINE
C
      IF (KFLAG.NE.0) GO TO  90
      DO  70 J=JS,JEND1
      DO  60 I=IS,IEND1
      CALL GBYTES( UX(I,J) , IUX , ISKIP , 2 , 0 , 1 )
      IF ( IAND( IUX , IONE ) .EQ. IZERO ) GO TO 80
   60 CONTINUE
   70 CONTINUE
C
C MUST BE NO AVAILABLE BOXES FOR STARTING A STREAMLINE
C
      GO TO 190
   80 CONTINUE
C
C INITILIZE PARAMETERS FOR STARTING A STREAMLINE
C .   TURN THE BOX OFF FOR STARTING A STREAMLINE
C .   CHECK TO SEE IF THIS BOX HAS MISSING DATA (IMSG.NE.0). IF SO ,
C .      FIND A NEW STARTING BOX
C
      CALL SBYTES( UX(I,J) , IONE , ISKIP1 , 1 , 0 , 1 )
      IF ( IMSG.EQ.0) GO TO 85
      IF (U(I,J).EQ.UVMSG .OR. U(I,J+1).EQ.UVMSG .OR.
     1    U(I+1,J).EQ.UVMSG .OR. U(I+1,J+1).EQ.UVMSG) GO TO 50
C
   85 ISAV = I
      JSAV = J
      KFLAG = 1
      PLMN1 = +1.
      GO TO 100
   90 CONTINUE
C
C COME TO HERE TO DRAW IN THE OPPOSITE DIRECTION
C
      KFLAG = 0
      PLMN1 = -1.
      I = ISAV
      J = JSAV
  100 CONTINUE
C
C INITIATE THE DRAWING SEQUENCE
C .   START ALL STREAMLINES IN THE CENTER OF A BOX
C
      NBOX = 0
      ITER = 0
      IF (KFLAG.NE.0) ICHKB = ICHK+1
      IF (ICHKB.GT.NUMCHK) ICHKB = 1
      X = REAL(I)+0.5
      Y = REAL(J)+0.5
      XBASE = X
      YBASE = Y
      CALL FL2INT (FX(X,Y),FY(X,Y),IFX,IFY)
      CALL PLOTIT (IFX,IFY,0)
      CALL GBYTES( UX(I,J) , IUX , ISKIP , 2 , 0 , 1 )
      IF ( (KFLAG.EQ.0) .OR. (IAND( IUX , ITWO ) .NE. 0 ) ) GO TO 110
C
C GRID BOX MUST BE ELIGIBLE FOR A DIRECTIONAL ARROW
C
      CALL GNEWPT (UX,VY,IMAX,JPTSY)
      MFLAG = 1
      GO TO 160
C
  110 CONTINUE
C
C PLOT LOOP
C .   CHECK TO SEE IF THE STREAMLINE HAS ENTERED A NEW GRID BOX
C
      IF (I.NE.INT(X) .OR. J.NE.INT(Y)) GO TO 120
C
C MUST BE IN SAME BOX CALCULATE THE DISPLACEMENT COMPONENTS
C
      CALL GNEWPT (UX,VY,IMAX,JPTSY)
C
C UPDATE THE POSITION AND DRAW THE VECTOR
C
      X = X+PLMN1*DELX
      Y = Y+PLMN1*DELY
      CALL FL2INT (FX(X,Y),FY(X,Y),IFX,IFY)
      CALL PLOTIT (IFX,IFY,1)
      ITER = ITER+1
C
C CHECK STREAMLINE PROGRESS EVERY 'ITERP' OR SO ITERATIONS
C
      IF (MOD(ITER,ITERP).NE.0) GO TO 115
      IF (ABS(X-XBASE).LT.DISPC  .AND. ABS(Y-YBASE).LT.DISPC ) GO TO  50
      XBASE = X
      YBASE = Y
      GO TO 110
  115 CONTINUE
C
C SHOULD THE CIRCULAR LISTS BE CHECKED FOR STREAMLINE CROSSOVER
C
      IF ( (ITERC.LT.0) .OR. (MOD(ITER,ITERC).NE.0) ) GO TO 110
C
C MUST WANT THE CIRCULAR LIST CHECKED
C
      GO TO 130
  120 CONTINUE
C
C MUST HAVE ENTERED A NEW GRID BOX  CHECK FOR THE FOLLOWING :
C .   (1) ARE THE NEW POINTS ON THE GRID
C .   (2) CHECK FOR MISSING DATA IF MSG  DATA FLAG (IMSG) HAS BEEN SET.
C .   (3) IS THIS BOX ELIGIBLE FOR A DIRECTIONAL ARROW
C .   (4) LOCATION OF THIS ENTRY VERSUS OTHER STREAMLINE ENTRIES
C
      NBOX = NBOX+1
C
C CHECK (1)
C
      IF (INT(X).LT.IS .OR. INT(X).GT.IEND1) GO TO  50
      IF (INT(Y).LT.JS .OR. INT(Y).GT.JEND1) GO TO  50
C
C CHECK (2)
C
      IF ( IMSG.EQ.0) GO TO 125
      II = INT(X)
      JJ = INT(Y)
      IF (U(II,JJ).EQ.UVMSG .OR. U(II,JJ+1).EQ.UVMSG .OR.
     1    U(II+1,JJ).EQ.UVMSG .OR. U(II+1,JJ+1).EQ.UVMSG) GO TO 50
  125 CONTINUE
C
C CHECK (3)
C
      CALL GBYTES( UX(I,J) , IUX , ISKIP , 2 , 0 , 1 )
      IF ( IAND( IUX , ITWO )  .NE. 0) GO TO 130
      MFLAG = 2
      GO TO 160
  130 CONTINUE
C
C CHECK (4)
C
      DO 140 LOC=1,LCHK
      IF (ABS( X-XCHK(LOC) ).GT.CSTOP .OR.
     1    ABS( Y-YCHK(LOC) ).GT.CSTOP) GO TO 140
      LFLAG = 1
      IF (ICHKB.LE.ICHK .AND. LOC.GE.ICHKB .AND. LOC.LE.ICHK) LFLAG = 2
      IF (ICHKB.GE.ICHK .AND. (LOC.GE.ICHKB .OR. LOC.LE.ICHK)) LFLAG = 2
      IF (LFLAG.EQ.1) GO TO  50
  140 CONTINUE
      LCHK = MIN(LCHK+1,NUMCHK)
      ICHK = ICHK+1
      IF (ICHK.GT.NUMCHK) ICHK = 1
      XCHK(ICHK) = X
      YCHK(ICHK) = Y
      I = INT(X)
      J = INT(Y)
      CALL SBYTES( UX(I,J) , IONE , ISKIP1 , 1 , 0 , 1 )
      IF (NBOX.LT.5) GO TO 150
      ICHKB = ICHKB+1
      IF (ICHKB.GT.NUMCHK) ICHKB = 1
  150 CONTINUE
      GO TO 110
C
  160 CONTINUE
C
C THIS SECTION DRAWS A DIRECTIONAL ARROW BASED ON THE MOST RECENT DIS-
C .   PLACEMENT COMPONENTS ,DELX AND DELY, RETURNED BY GNEWPT. IN EARLIE
C .   VERSIONS THIS WAS A SEPARATE SUBROUTINE (CALLED DRWDAR). IN THAT
C .   CASE ,HOWEVER, FX AND FY WERE DEFINED EXTERNAL SINCE THESE
C .   FUNCTIONS WERE USED BY BOTH DRWSTR AND DRWDAR. IN ORDER TO
C .   MAKE ALL DEFAULT TRANSFORMATIONS STATEMENT FUNCTIONS I HAVE
C .   PUT DRWDAR  HERE AND I WILL USE MFLAG TO RETURN  TO THE CORRECT
C .   LOCATION IN THE CODE.
C
      IF ( (DELX.EQ.0.) .AND. (DELY.EQ.0.) ) GO TO 50
C
      CALL SBYTES( UX(I,J) ,IONE , ISKIP , 1 ,0 , 1 )
      D = ATAN2(-DELX,DELY)
      D30 = D+0.5
  170 YY = -AROWL*COS(D30)+Y
      XX = +AROWL*SIN(D30)+X
      CALL FL2INT (FX(XX,YY),FY(XX,YY),IFXX,IFYY)
      CALL PLOTIT (IFXX,IFYY,1)
      CALL FL2INT (FX(X,Y),FY(X,Y),IFX,IFY)
      CALL PLOTIT (IFX,IFY,0)
      IF (D30.LT.D) GO TO 180
      D30 = D-0.5
      GO TO 170
  180 IF (MFLAG.EQ.1) GO TO 110
      IF (MFLAG.EQ.2) GO TO 130
C
  190 CONTINUE
C
C     FLUSH PLOTIT BUFFER
C
      CALL PLOTIT(0,0,0)
      RETURN
      END

C
C	$Id: gxlate.f,v 1.4 2008-07-27 00:21:03 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GXLATE(WKID,IOS,STATUS)
C
C  This subroutine is the driver for the translation of segments
C  stored as CGM elements to GKS calls.
C
C  Error messages for unexpected EOF or invalid opcode are flagged.
C
      include 'trinst.h'
C
      INTEGER IOS, STATUS, WKID
C
C  Loop until end of file.
C
 10   CONTINUE
C
      CALL GNINST(IOS,STATUS) 
C
C  Test if valid instruction found.
C
      IF (STATUS .NE. 0) RETURN
C
C  Jump to proper element processor.
C
      IF (OPCL .LE. 2) THEN
        STATUS = 302
        RETURN
      END IF
C
      GO TO (1300,1400,1500,1600,1700),(OPCL-2)
C
 1300 CONTINUE
C
C  Class code 3 control element codes.
C
      CALL GCELCD(WKID,IOS,STATUS)
      GO TO 9999
C
 1400 CONTINUE
C
C  Class code 4 graphical primitive elements.
C
      CALL GELMS(IOS,STATUS)
      GO TO 9999
C
 1500 CONTINUE
C
C  Class code 5 attribute elements.
C
      CALL GATELM(IOS,STATUS)
      GO TO 9999
C
 1600 CONTINUE
C
C  Class code 6 escape functions.
C
      CALL GESCFN(IOS,STATUS)
      GO TO 9999
C
 1700 CONTINUE
C
C  Class code 7 external elements (ignore for now).
C
      GO TO 9999
C
 9999 CONTINUE
      IF (STATUS .EQ. 0) GO TO 10
C
      RETURN
      END

      PROGRAM DSEX01
C
      PARAMETER (NUM=1000, NX=21, NY=21, NZ=21)
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
      REAL XI(NUM), YI(NUM), ZI(NUM), U(NUM)
      REAL XO(NX),  YO(NY),  ZO(NZ),  OUTPUT(NX,NY,NZ)
      INTEGER I, J, K, IER
      DATA XMIN,YMIN,ZMIN,XMAX,YMAX,ZMAX / -2., -2., -2., 2., 2., 2./
C
      DO 10 I=1,NUM
        XI(I) = XMIN+(XMAX-XMIN)*DSRND1()
        YI(I) = YMIN+(YMAX-YMIN)*DSRND1()
        ZI(I) = ZMIN+(ZMAX-ZMIN)*DSRND1()
         U(I) = XI(I)**2 + YI(I)**2 + ZI(I)**2
   10 CONTINUE
C
C  Create the output grid.
C
      DO 102 I=1,NX
        XO(I) = XMIN+(REAL(I-1)/REAL(NX-1))*(XMAX-XMIN)
  102 CONTINUE
C
      DO 103 J =1,NY
        YO(J)= YMIN+(REAL(J-1)/REAL(NY-1))*(YMAX-YMIN)
  103 CONTINUE
C
      DO 104 K=1,NZ
        ZO(K) = ZMIN+(REAL(K-1)/REAL(NZ-1))*(ZMAX-ZMIN)
  104 CONTINUE
C
C  Interpolate.
C
      CALL DSGRID3S(NUM,XI,YI,ZI,U,NX,NY,NZ,XO,YO,ZO,OUTPUT,IER)
      IF (IER .NE. 0) THEN
        WRITE(6,520) IER
  520   FORMAT(' Error ',I3,' returned from DSGRID3S') 
        STOP
      ENDIF
C
C  Plot an isosurface.
C
C
C Open GKS and define the foreground and background color.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
      CALL TDEZ3D(NX, NY, NZ, XO, YO, ZO, OUTPUT, 3.0,
     +            2., -35., 65., 6)
      CALL FRAME()
C
C Close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END
      REAL FUNCTION DSRND1()
C
C  Portable random number generator.
C
      PARAMETER (MPLIER=16807,MODLUS=2147483647,MOBYMP=127773,
     +           MOMDMP=2836)
C
      INTEGER HVLUE, LVLUE, TESTV, NEXTN
      SAVE    NEXTN
      DATA JSEED,IFRST/123456789,0/
C
      IF (IFRST .EQ. 0) THEN
        NEXTN = JSEED
        IFRST = 1
      ENDIF
C
      HVLUE = NEXTN / MOBYMP
      LVLUE = MOD(NEXTN, MOBYMP)
      TESTV = MPLIER*LVLUE - MOMDMP*HVLUE
      IF (TESTV .GT. 0) THEN
        NEXTN = TESTV
      ELSE
        NEXTN = TESTV + MODLUS
      ENDIF
      DSRND1 = REAL(NEXTN)/REAL(MODLUS)
C
      RETURN
      END

      SUBROUTINE ZLARTG( F, G, CS, SN, R )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      DOUBLE PRECISION   CS
      COMPLEX*16         F, G, R, SN
*     ..
*
*  Purpose
*  =======
*
*  ZLARTG generates a plane rotation so that
*
*     [  CS  SN  ]     [ F ]     [ R ]
*     [  __      ]  .  [   ]  =  [   ]   where CS**2 + |SN|**2 = 1.
*     [ -SN  CS  ]     [ G ]     [ 0 ]
*
*  This is a faster version of the BLAS1 routine ZROTG, except for
*  the following differences:
*     F and G are unchanged on return.
*     If G=0, then CS=1 and SN=0.
*     If F=0, then CS=0 and SN is chosen so that R is real.
*
*  Arguments
*  =========
*
*  F       (input) COMPLEX*16
*          The first component of vector to be rotated.
*
*  G       (input) COMPLEX*16
*          The second component of vector to be rotated.
*
*  CS      (output) DOUBLE PRECISION
*          The cosine of the rotation.
*
*  SN      (output) COMPLEX*16
*          The sine of the rotation.
*
*  R       (output) COMPLEX*16
*          The nonzero component of the rotated vector.
*
*  Further Details
*  ======= =======
*
*  3-5-96 - Modified with a new algorithm by W. Kahan and J. Demmel
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   TWO, ONE, ZERO
      PARAMETER          ( TWO = 2.0D+0, ONE = 1.0D+0, ZERO = 0.0D+0 )
      COMPLEX*16         CZERO
      PARAMETER          ( CZERO = ( 0.0D+0, 0.0D+0 ) )
*     ..
*     .. Local Scalars ..
      LOGICAL            FIRST
      INTEGER            COUNT, I
      DOUBLE PRECISION   D, DI, DR, EPS, F2, F2S, G2, G2S, SAFMIN,
     $                   SAFMN2, SAFMX2, SCALE
      COMPLEX*16         FF, FS, GS
*     ..
*     .. External Functions ..
      DOUBLE PRECISION   DLAMCH, DLAPY2
      EXTERNAL           DLAMCH, DLAPY2
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, DBLE, DCMPLX, DCONJG, DIMAG, INT, LOG,
     $                   MAX, SQRT
*     ..
*     .. Statement Functions ..
      DOUBLE PRECISION   ABS1, ABSSQ
*     ..
*     .. Save statement ..
      SAVE               FIRST, SAFMX2, SAFMIN, SAFMN2
*     ..
*     .. Data statements ..
      DATA               FIRST / .TRUE. /
*     ..
*     .. Statement Function definitions ..
      ABS1( FF ) = MAX( ABS( DBLE( FF ) ), ABS( DIMAG( FF ) ) )
      ABSSQ( FF ) = DBLE( FF )**2 + DIMAG( FF )**2
*     ..
*     .. Executable Statements ..
*
      IF( FIRST ) THEN
         FIRST = .FALSE.
         SAFMIN = DLAMCH( 'S' )
         EPS = DLAMCH( 'E' )
         SAFMN2 = DLAMCH( 'B' )**INT( LOG( SAFMIN / EPS ) /
     $            LOG( DLAMCH( 'B' ) ) / TWO )
         SAFMX2 = ONE / SAFMN2
      END IF
      SCALE = MAX( ABS1( F ), ABS1( G ) )
      FS = F
      GS = G
      COUNT = 0
      IF( SCALE.GE.SAFMX2 ) THEN
   10    CONTINUE
         COUNT = COUNT + 1
         FS = FS*SAFMN2
         GS = GS*SAFMN2
         SCALE = SCALE*SAFMN2
         IF( SCALE.GE.SAFMX2 )
     $      GO TO 10
      ELSE IF( SCALE.LE.SAFMN2 ) THEN
         IF( G.EQ.CZERO ) THEN
            CS = ONE
            SN = CZERO
            R = F
            RETURN
         END IF
   20    CONTINUE
         COUNT = COUNT - 1
         FS = FS*SAFMX2
         GS = GS*SAFMX2
         SCALE = SCALE*SAFMX2
         IF( SCALE.LE.SAFMN2 )
     $      GO TO 20
      END IF
      F2 = ABSSQ( FS )
      G2 = ABSSQ( GS )
      IF( F2.LE.MAX( G2, ONE )*SAFMIN ) THEN
*
*        This is a rare case: F is very small.
*
         IF( F.EQ.CZERO ) THEN
            CS = ZERO
            R = DLAPY2( DBLE( G ), DIMAG( G ) )
*           Do complex/real division explicitly with two real divisions
            D = DLAPY2( DBLE( GS ), DIMAG( GS ) )
            SN = DCMPLX( DBLE( GS ) / D, -DIMAG( GS ) / D )
            RETURN
         END IF
         F2S = DLAPY2( DBLE( FS ), DIMAG( FS ) )
*        G2 and G2S are accurate
*        G2 is at least SAFMIN, and G2S is at least SAFMN2
         G2S = SQRT( G2 )
*        Error in CS from underflow in F2S is at most
*        UNFL / SAFMN2 .lt. sqrt(UNFL*EPS) .lt. EPS
*        If MAX(G2,ONE)=G2, then F2 .lt. G2*SAFMIN,
*        and so CS .lt. sqrt(SAFMIN)
*        If MAX(G2,ONE)=ONE, then F2 .lt. SAFMIN
*        and so CS .lt. sqrt(SAFMIN)/SAFMN2 = sqrt(EPS)
*        Therefore, CS = F2S/G2S / sqrt( 1 + (F2S/G2S)**2 ) = F2S/G2S
         CS = F2S / G2S
*        Make sure abs(FF) = 1
*        Do complex/real division explicitly with 2 real divisions
         IF( ABS1( F ).GT.ONE ) THEN
            D = DLAPY2( DBLE( F ), DIMAG( F ) )
            FF = DCMPLX( DBLE( F ) / D, DIMAG( F ) / D )
         ELSE
            DR = SAFMX2*DBLE( F )
            DI = SAFMX2*DIMAG( F )
            D = DLAPY2( DR, DI )
            FF = DCMPLX( DR / D, DI / D )
         END IF
         SN = FF*DCMPLX( DBLE( GS ) / G2S, -DIMAG( GS ) / G2S )
         R = CS*F + SN*G
      ELSE
*
*        This is the most common case.
*        Neither F2 nor F2/G2 are less than SAFMIN
*        F2S cannot overflow, and it is accurate
*
         F2S = SQRT( ONE+G2 / F2 )
*        Do the F2S(real)*FS(complex) multiply with two real multiplies
         R = DCMPLX( F2S*DBLE( FS ), F2S*DIMAG( FS ) )
         CS = ONE / F2S
         D = F2 + G2
*        Do complex/real division explicitly with two real divisions
         SN = DCMPLX( DBLE( R ) / D, DIMAG( R ) / D )
         SN = SN*DCONJG( GS )
         IF( COUNT.NE.0 ) THEN
            IF( COUNT.GT.0 ) THEN
               DO 30 I = 1, COUNT
                  R = R*SAFMX2
   30          CONTINUE
            ELSE
               DO 40 I = 1, -COUNT
                  R = R*SAFMN2
   40          CONTINUE
            END IF
         END IF
      END IF
      RETURN
*
*     End of ZLARTG
*
      END

      PROGRAM THSTGR
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C OPEN GKS, OPEN WORKSTATION OF TYPE 1, ACTIVATE WORKSTATION
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C INVOKE DEMO DRIVER
C
      CALL HSTGR(IERR,IWKID)
C
C DEACTIVATE AND CLOSE WORKSTATION, CLOSE GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END
C
      SUBROUTINE HSTGR (IERROR,IWKID)
C
C PURPOSE                To provide a demonstration of the HISTGR
C                        utility and to test each of the four IFLAG
C                        options.
C
C USAGE                  CALL HSTGR (IERROR,IWKID)
C
C ARGUMENTS
C
C ON OUTPUT              IERROR
C                          An error flag
C                          = 0, If the test is successful,
C                          = 1, otherwise.
C
C I/O                    If the test is successful, the message
C
C                          HISTGR TEST SUCCESSFUL  . . .  SEE PLOT
C                          TO VERIFY PERFORMANCE
C
C                        is written on unit 6.
C
C                        In addition, three (3) labeled frames are
C                        produced.  To determine if the test was
C                        successful examine these plots.
C
C PRECISION              Single
C
C REQUIRED LIBRARY       HISTGR
C FILES
C
C REQUIRED GKS LEVEL     0A
C
C LANGUAGE               FORTRAN 77
C
C HISTORY                Originally written May, 1985; revised
C                        August, 1987
C
C ALGORITHM              THSTGR computes data and calls HISTGR
C                        5 times, exercising different options.
C
C
C  Array DAT1 is filled with values to be used as input for HISTGR
C
      PARAMETER ( NDIM=320, NCLS=17, NWRK=374 )
C
C  NWRK = NDIM + 3*(NCLS+1)
C
      CHARACTER*1 IFC
      CHARACTER*55 MON
      REAL  DAT1(NDIM,2), X, ARR7(7), WORK(NWRK)
      REAL  RGB(3,15), CLASS(NCLS+1)
      REAL  SPAC(2)
      INTEGER  COLORS(15)
C
C  Define the RGB triples needed below.
C
      DATA RGB / 0.70, 0.70, 0.70,
     -           0.75, 0.00, 1.00,
     -           0.30, 0.10, 1.00,
     -           0.10, 0.50, 1.00,
     -           0.00, 0.70, 1.00,
     -           0.00, 1.00, 1.00,
     -           0.00, 1.00, 0.70,
     -           0.00, 1.00, 0.00,
     -           0.70, 0.00, 0.70,
     -           1.00, 1.00, 0.00,
     -           1.00, 0.75, 0.00,
     -           1.00, 0.48, 0.00,
     -           1.00, 0.00, 0.48,
     -           1.00, 0.00, 0.00,
     -           1.00, 1.00, 1.00 /
C
      DATA TX /.5/, TY/.9765/
C
C  Define 15 color indices, 14 spaced throughout the color
C  spectrum, and the last one being white.
C
      CALL GSCR(IWKID,0,0.,0.,0.)
      DO 100 I = 1,15
      CALL GSCR(IWKID,I,RGB(1,I),RGB(2,I),RGB(3,I))
  100 CONTINUE
C
C  Call ENTSR (from PORT library) to recover from warnings
C
      CALL ENTSR(IDUM, 1)
C
C Change the Plotchar special character code from a : to a @
C
      IFC(1:1) = '@'
      CALL PCSETC('FC',IFC)
C
C
C  Frame 1:  Demonstrate the default version of HISTGR, IFLAG = 0.
C
      IFLAG = 0
      NCLASS = 11
      NPTS = 320
C
      DO 105 I=1,NPTS
        DO 105 J=1,2
          DAT1(I,J)=0.
  105 CONTINUE
      DO  110 I=1,NPTS
        X = REAL(I)
        DAT1(I,1) = 10. * ALOG10(0.1*X+1.)
  110 CONTINUE
C
C  (First call HSTOPL('DEF=ON') to activate all default options.)
C
      CALL HSTOPL('DE=ON')
C
C  Flush PLOTIT's buffers.
C
      CALL PLOTIT(0,0,0)
C
C  Set text and polyline color indices to 15 (white).
C
      CALL GSTXCI(15)
      CALL GSPLCI(15)
C
      CALL PLCHLQ (TX,TY,
     +'DEMONSTRATION PLOT FOR DEFAULT VERSION OF HISTGR',16.,0.,0.)
      CALL HISTGR(DAT1, NDIM, NPTS, IFLAG, CLASS, NCLASS, WORK, NWRK)
C
C  Frame 2:  Demonstrate the comparison of two previously determined
C            histograms, IFLAG = 3.
C
      IFLAG = 3
      NCLASS = 6
      NPTS2 = 6
       DO 200 I=1,NPTS2
        DAT1(I,1)=2*SIN(REAL(I))
        DAT1(I,2)=2.5*COS(REAL(I)/.5)
        CLASS(I)=REAL(I)
  200  CONTINUE
C
C  (First call HSTOPL('DEF=ON') to activate all default options.)
C
      CALL HSTOPL('DE=ON')
C
C  Turn on color, title, perimeter, frequency, format, character,
C  label, and spacing options.
C
         COLORS(1) = 8
         COLORS(2) = 3
         COLORS(3) = 14
         COLORS(4) = 11
         COLORS(5) = 6
         COLORS(6) = 13
         COLORS(7) = 14
         COLORS(8) = 5
      CALL HSTOPI('COL=ON',3,0,COLORS,8)
C
C  Choose large, horizontal alphanumeric labels for class labels.
C
      CALL HSTOPC('TI=ON',
     +'OPTIONS CHANGED: PRM,TIT,CHA,LAB,FOR,COL,FQN and SPA',7,3)
      CALL HSTOPL('PR=ON')
      CALL HSTOPC('FQ=ON','MONTHLY PRECIPITATION',7,3)
      CALL HSTOPC('FO=ON','(F3.0)',9,3)
      MON='JANFEBMARAPRMAYJUNJULAUGSEPOCTNOVDEC'
      CALL HSTOPC('CH=ON',MON,12,3)
      CALL HSTOPC('LA=ON','COMPARE TWO DATASETS',7,3)
      SPAC(1) = 2.0
      SPAC(2) = -1.5
      CALL HSTOPR('SP=ON',SPAC,2)
C
C  The second argument must be the actual dimension size of DAT1.
C
      CALL HISTGR(DAT1, NDIM, NPTS2, IFLAG, CLASS, NCLASS, WORK, NWRK)
C
C  Frame 3:  Put four plots on 1 frame by setting FRAME = OFF for the
C            first 3 plots and FRAME = ON for the last plot.
C
C     Plot 1:   IFLAG = 0, automatic sorting of the input data into
C               NCLASS = 17 bins.
C
      IFLAG = 0
      NCLASS = 17
      NPTS = 320
      DO  210 I=1,NPTS
        X = REAL(I)
        DAT1(I,1) = 10. * ALOG10(0.1*X+1.)
  210 CONTINUE
C
C  (First call HSTOPL('DEF=ON') to activate all default options.)
C
      CALL HSTOPL('DE=ON')
C
C  Turn on horizontal bars, title, median, window, color,
C  and spacing options.
C
C  Choose large horizontal class labels.
C
      CALL HSTOPC('TI=ON',
     +'OPTIONS: HOR, WIN, FRA, MED, COL, SPA, & TIT',9,3)
      CALL HSTOPL('HO=ON')
      CALL HSTOPL('ME=ON')
C
C  Plot 1 goes into the top left quadrant of the frame.
C
C       ARR7 coordinates are XMIN, XMAX, YMIN, YMAX.
C
      ARR7(1) = 0.
      ARR7(2) = .5
      ARR7(3) = .5
      ARR7(4) = 1.
      CALL HSTOPR('WI=ON',ARR7,4)
C
         COLORS(1) = 8
         COLORS(2) = 2
         COLORS(3) = 10
         COLORS(4) = 4
         COLORS(5) = 5
         COLORS(6) = 6
         COLORS(7) = 7
         COLORS(8) = 8
      CALL HSTOPI('COL=ON',2,0,COLORS,8)
      SPAC(1) = 3.0
      SPAC(2) = 0.0
      CALL HSTOPR('SP=ON',SPAC,2)
C
C  Turn off the frame advance.
C
      CALL HSTOPL('FR=OF')
      CALL HISTGR(DAT1, NDIM, NPTS, IFLAG, CLASS, NCLASS, WORK, NWRK)
C
C     Plot 2:   IFLAG = 2, one set of 11 histogram classes and their
C               associated values are plotted.
C
      IFLAG = 2
      NCLASS = 11
      NPTS2 = 11
      DO 650 I = 1, NPTS2
        CLASS(I)=REAL(2*I)
        DAT1(I,1)=(REAL(2*I))**0.5
  650 CONTINUE
C
C  (First call HSTOPL('DEF=ON') to activate all default options.)
C
      CALL HSTOPL('DE=ON')
C
C  Turn on title, label, frequency, format, and window options.
C
C  Choose medium sized, horizontal labels for class labels
C
      CALL HSTOPC('TI=ON',
     +'OPTIONS CHANGED: LAB,FQN,TIT,FOR,FRA AND WIN',11,3)
      CALL HSTOPC('LA=ON','Y VALUES ASSIGNED TO X VALUES',11,3)
      CALL HSTOPC('FQ=ON','SQUARE ROOT OF CLASS MID-VALUES',
     &12,3)
      CALL HSTOPC('FO=ON','(I3)',11,3)
C
C  Plot 2 goes into the top right quadrant of the frame.
C
      ARR7(1) = .5
      ARR7(2) = 1.
      ARR7(3) = .5
      ARR7(4) = 1.
      CALL HSTOPR('WIN=ON',ARR7,4)
C
C  Turn off color and frame advance options.
C
      CALL HSTOPI('COL=OF',2,0,COLORS,8)
      CALL HSTOPL('FR=OFF')
      CALL HISTGR(DAT1, NDIM, NPTS2, IFLAG, CLASS, NCLASS, WORK, NWRK)
C
C     Plot 3:   IFLAG = 1, input values are sorted into a defined set of
C               8 classes.
C
      IFLAG = 1
      NCLASS = 8
      NPTS = 320
      X = 0.
      DO 500 I = 1,NPTS
        DAT1(I,1) = SIN(X)
        X = X + .02
  500 CONTINUE
C
      CLASS(1) = -0.6
      DO 550 I = 1,NCLASS
        CLASS(I+1) = CLASS(I) + 0.20
550   CONTINUE
C
C  (First call HSTOPL('DEF=ON') to activate all default options.)
C
      CALL HSTOPL('DE=ON')
C
C  Turn on class, draw line, format, title, and label options.
C
      CALL HSTOPI('CL=ON',2,30,COLORS,8)
      CALL HSTOPL('DR=ON')
      CALL HSTOPC('FOR=ON','(F6.2)',9,3)
      CALL HSTOPC('TI=ON',
     +'OPTIONS CHANGED: CLA,DRL,FOR,TIT,LAB,MID,WIN,SHA and FRA',9,3)
      CALL HSTOPC('LA=ON','CLASS VALUES CHOSEN FROM -0.6 to 1.0',
     &9,3)
C
C  Plot 3 goes into the lower left quadrant of the frame.
C
      ARR7(1) = 0.
      ARR7(2) = .5
      ARR7(3) = 0.
      ARR7(4) = .5
      CALL HSTOPR('WI=ON',ARR7,4)
C
C  Turn off color, midvalues, frame advance and shading options.
C
C  Write the class labels at a 30 deg angle.
C
      CALL HSTOPI('CO=OF',2,30,COLORS,8)
      CALL HSTOPL('MI=OFF')
      CALL HSTOPL('FR=OFF')
      CALL HSTOPL('SH=OFF')
      CALL HISTGR(DAT1, NDIM, NPTS, IFLAG, CLASS, NCLASS, WORK, NWRK)
C
C     Plot 4:   IFLAG = 0, input values are sorted into 11 equally sized
C               bins over the range of the input values.
C
      IFLAG = 0
      NCLASS = 11
      NPTS = 320
      X = 0.
      DO 310 I = 1,NPTS
        DAT1(I,1) = SIN(X)
        X = X + .02
  310 CONTINUE
C
C  (First call HSTOPL('DEF=ON') to activate all default options.)
C
      CALL HSTOPL('DE=ON')
C
C  Turn on class, frequency, format, title, window, and label options.
C
C  Choose medium sized vertical class value labels.
C
      CALL HSTOPI('CL=ON',2,90,COLORS,8)
      CALL HSTOPC('FQN=ON','NUMBER OF OCCURENCES IN EACH CLASS',9,3)
      CALL HSTOPC('FOR=ON','(F6.2)',9,3)
      CALL HSTOPC('TI=ON',
     +'OPTIONS CHANGED: CLA,LAB,FQN,TIT,SPA,PER,FOR AND WIN',9,3)
C
C  Plot 4 goes into the lower right quadrant of the frame.
C
      ARR7(1) = .5
      ARR7(2) = 1.
      ARR7(3) = 0.
      ARR7(4) = .5
      CALL HSTOPR('WIN=ON',ARR7,4)
      CALL HSTOPC('LAB=ON','CLASS VALUES COMPUTED WITHIN HISTGR',
     &9,3)
C
C  Turn off color, spacing and percent axis options.
C
      CALL HSTOPI('CO=OF',2,90,COLORS,8)
      CALL HSTOPR('SP=OF',SPAC,2)
      CALL HSTOPL('PER=OFF')
C
      CALL HISTGR(DAT1, NDIM, NPTS, IFLAG, CLASS, NCLASS, WORK, NWRK)
C
C
      IERROR = 0
      WRITE (6,1001)
C
      RETURN
C
 1001 FORMAT ('  HISTGR TEST SUCCESSFUL',24X,
     1        'SEE PLOT TO VERIFY PERFORMANCE')
      END

C
C	$Id: gwptni.f,v 1.4 2008-07-27 00:21:08 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GWPTNI(OPCL, OPID, NBYTES, GKSERR)
C
C  This routine sets up the next instruction to be placed in the 
C  segment.      
C
C  After this call the GPUTPR or GPUTPS routines are called to 
C  load the operand list.
C
C
C  INPUT
C    OPCL   -- The opcode class of the instruction
C    OPID   -- the opcode id of the instruction
C    NBYTES -- the number of bytes in the operand list
C
C  OUTPUT
C    GKSERR -- The error status defined by common
C
C  All data is type intege unless otherwise indicated.
C
      IMPLICIT INTEGER (A-Z)
C
C  COMMON FOR COMMUNICATION OF INSTRUCTION AND LENGTH
C
      include 'gwiins.h'
C
      SAVE
C
C  Set the CGM data element partition size.
C  The partition size should be a multiple of 256 in order to
C  make the arithmetic in other parts of the code come out right.
C
      DATA PARSIZ/32256/
C
C  Load the current opcode class and id into common.
C
      MCOPCL = OPCL
      MCOPID = OPID
C
C  Set the current partition byte count and the remainder byte count.
C
      IF (NBYTES .GT. PARSIZ) THEN
        MCCBYT = PARSIZ
        MCNBYT = NBYTES - PARSIZ
      ELSE
        MCCBYT = NBYTES
        MCNBYT = 0
      END IF
C
C  Ready the current partition for the operand list.
C
      CALL GWELOD(GKSERR)
C
      RETURN
      END

C NCLFORTSTART
      SUBROUTINE DAAMOM1(U,DP,LAT,WGT,MLON,NLAT,KLVL,UMSG,AAM)
      IMPLICIT NONE

c NCL:   aam = angmom_atm (u,dp,lat,wgt)

c                                        INPUT
      INTEGER MLON,NLAT,KLVL
      DOUBLE PRECISION U(MLON,NLAT,KLVL),LAT(NLAT),WGT(NLAT),UMSG,
     +                 DP(KLVL)
c                                        OUTPUT
      DOUBLE PRECISION AAM
C NCLEND

c Compute the atmosphere's relative angular momentum

c nomenclature:
c .   u       - zonal wind component (m/s)
c .   dp      - pressure thickness   (Pa)
c.              a 1D array
c .   lat     - latitudes
c .   wgt     - wgts associated with each latitude
c .             These could be gaussian weights or cos(lat)*dlat
c .             where "dlat" is the latitudinal spacing in radians
c .   mlon    - number of longitudes
c .   nlat    - number of latitudes
c .   klvl    - number of levels
c .   umsg    - missing code for "u"
c .   aam     - atmospheric angular momentum [relative]
c .             units: kg*m2/s

c                                        LOCAL
      INTEGER ML,NL,KL
      DOUBLE PRECISION PI,TWOPI,RAD,RE,RE3,G,DLAT,UDP

      PI = 4.0D0*ATAN(1.0D0)
      RAD = PI/180.D0
      TWOPI = 2.0D0*PI

      RE = 6.37122D06
      RE3 = RE**3
      G = 9.81D0
      AAM = 0.0D0

      DO NL = 1,NLAT
c                                     at each latitude
c                                     sum u*dp over all longitudes
          UDP = 0.0D0
          DO ML = 1,MLON
              DO KL = 1,KLVL
                  IF (U(ML,NL,KL).NE.UMSG) THEN
                      UDP = UDP + U(ML,NL,KL)*DP(KL)
                  END IF
              END DO
          END DO
c                                     'zonal average' udp
          UDP = UDP/MLON
c                                     latitudinal contribution to aam
          AAM = AAM + UDP*COS(LAT(NL)*RAD)*WGT(NL)*TWOPI
      END DO

      AAM = (RE3/G)*AAM

      RETURN
      END
c ---------------------------------------------------------
c The ONLY difference between the aamom1 and aamom3 is that
c in the the former "dp" is 1D while in the latter it is 3D
c ---------------------------------------------------------
C NCLFORTSTART
      SUBROUTINE DAAMOM3(U,DP,LAT,WGT,MLON,NLAT,KLVL,UMSG,AAM)
      IMPLICIT NONE

c NCL:   aam = angmom_atm (u,dp,lat,wgt)

c                                        INPUT
      INTEGER MLON,NLAT,KLVL
      DOUBLE PRECISION U(MLON,NLAT,KLVL),LAT(NLAT),WGT(NLAT),UMSG,
     +                 DP(MLON,NLAT,KLVL)
c                                        OUTPUT
      DOUBLE PRECISION AAM
C NCLEND

c nomenclature: [same as above BUT
c .   dp      - pressure thickness   (Pa)
c.              a 3D array

c                                        LOCAL
      INTEGER ML,NL,KL
      DOUBLE PRECISION PI,TWOPI,RAD,RE,RE3,G,DLAT,UDP

      PI = 4.0D0*ATAN(1.0D0)
      RAD = PI/180.D0
      TWOPI = 2.0D0*PI

      RE = 6.37122D06
      RE3 = RE**3
      G = 9.81D0
      AAM = 0.0D0
c                                     latitude
      DO NL = 1,NLAT
c                                     at each latitude
c                                     sum u*dp over all longitudes
          UDP = 0.0D0
          DO ML = 1,MLON
              DO KL = 1,KLVL
                  IF (U(ML,NL,KL).NE.UMSG) THEN
                      UDP = UDP + U(ML,NL,KL)*DP(ML,NL,KL)
                  END IF
              END DO
          END DO
c                                     'zonal average' udp
          UDP = UDP/MLON
c                                     point contribution to aam
          AAM = AAM + UDP*COS(LAT(NL)*RAD)*WGT(NL)*TWOPI
      END DO

      AAM = (RE3/G)*AAM

      RETURN
      END
c -----------------------------------------------------------
c if a scalar "wgt" is passed from NCL to the angmom_atm
c .   function, it means that the interface will calculate
c .   the weights. This assumes constant latitudinal spacing.
c .                cos(theta)*dlambda
c -----------------------------------------------------------
      SUBROUTINE DCOSWEIGHT(LAT,NLAT,WGT)
      IMPLICIT NONE
c                                     INPUT
      INTEGER NLAT
      DOUBLE PRECISION LAT(NLAT)
c                                     OUTPUT
      DOUBLE PRECISION WGT(NLAT)
c                                     LOCAL
      DOUBLE PRECISION RAD,DLATR
      INTEGER NL

      RAD = 4.0D0*ATAN(1.0D0)/180.D0
c                                     latitudinal spacing (radians)
      DLATR = ABS(LAT(2)-LAT(1))*RAD
c                                     assume constant lat spacing
c                                     want exact zero at poles
      DO NL = 1,NLAT
          IF (ABS(LAT(NL)).EQ.90.D0) THEN
              WGT(NL) = 0.0D0
          ELSE
              WGT(NL) = COS(LAT(NL)*RAD)*DLATR
          END IF
      END DO

      RETURN
      END

C
C $Id: curvssdp.f,v 1.3 2008-07-27 03:10:11 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
C NOTE: If you make any changes to this software, please remember to
C make the same changes to the corresponding single precision routine.
C
      subroutine curvssdp (n,x,y,d,isw,s,eps,ys,ysp,sigma,td,
     *                     tsd1,hd,hsd1,hsd2,rd,rsd1,rsd2,v,
     *                     ierr)
c
      integer n,isw,ierr
      double precision x(n),y(n),d(n),s,eps,ys(n),ysp(n),sigma,td(n),       
     *                 tsd1(n),hd(n),hsd1(n),hsd2(n),rd(n),rsd1(n),
     *                 rsd2(n),v(n)
      double precision p,rdim1,yspim2,sigmap,delxi1,delyi1,dim1,
     *                 delxi,delyi,di,sl,su,betapp,betap,alphap,
     *                 alpha,beta,hsd1p,hdim1,hdi,rsd2i,rsd1I,
     *                 sum,f,g,wim2,wim1,tui,wi,h,step,sumx,sumy,
     *                 dinvsq,xbar,ybar,fac,slp

c
c                                 coded by alan kaylor cline
c                              from fitpack -- april 8, 1991
c                        a curve and surface fitting package
c                      a product of pleasant valley software
c                  8603 altus cove, austin, texas 78759, usa
c
c this subroutine determines the parameters necessary to
c compute a smoothing spline under tension. for a given
c increasing sequence of abscissae (x(i)), i = 1,..., n and
c associated ordinates (y(i)), i = 1,..., n, the function
c determined minimizes the summation from i = 1 to n-1 of
c the square of the second derivative of f plus sigma
c squared times the difference of the first derivative of f
c and (f(x(i+1))-f(x(i)))/(x(i+1)-x(i)) squared, over all
c functions f with two continuous derivatives such that the
c summation of the square of (f(x(i))-y(i))/d(i) is less
c than or equal to a given constant s, where (d(i)), i = 1,
c ..., n are a given set of observation weights. the
c function determined is a spline under tension with third
c derivative discontinuities at (x(i)), i = 2,..., n-1. for
c actual computation of points on the curve it is necessary
c to call the function curv2dp.
c
c on input--
c
c   n is the number of values to be smoothed (n.ge.2).
c
c   x is an array of the n increasing abscissae of the
c   values to be smoothed.
c
c   y is an array of the n ordinates of the values to be
c   smoothed, (i. e. y(k) is the functional value
c   corresponding to x(k) ).
c
c   d is a parameter containing the observation weights.
c   this may either be an array of length n or a scalar
c   (interpreted as a constant). the value of d
c   corresponding to the observation (x(k),y(k)) should
c   be an approximation to the standard deviation of error.
c
c   isw contains a switch indicating whether the parameter
c   d is to be considered a vector or a scalar,
c          = 0 if d is an array of length n,
c          = 1 if d is a scalar.
c
c   s contains the value controlling the smoothing. this
c   must be non-negative. for s equal to zero, the
c   subroutine does interpolation, larger values lead to
c   smoother funtions. if parameter d contains standard
c   deviation estimates, a reasonable value for s is
c   dble(n).
c
c   eps contains a tolerance on the relative precision to
c   which s is to be interpreted. this must be greater than
c   or equal to zero and less than equal or equal to one. a
c   reasonable value for eps is sqrt(2./dble(n)).
c
c   ys is an array of length at least n.
c
c   ysp is an array of length at least n.
c
c   sigma contains the tension factor. this value indicates
c   the degree to which the first derivative part of the
c   smoothing functional is emphasized. if sigma is nearly
c   zero (e. g. .001) the resulting curve is approximately a
c   cubic spline. if sigma is large (e. g. 50.) the
c   resulting curve is nearly a polygonal line. if sigma
c   equals zero a cubic spline results. a standard value for
c   sigma is approximately 1.
c
c and
c
c   td, tsd1, hd, hsd1, hsd2, rd, rsd1, rsd2, and v are
c   arrays of length at least n which are used for scratch
c   storage.
c
c on output--
c
c   ys contains the smoothed ordinate values.
c
c   ysp contains the values of the second derivative of the
c   smoothed curve at the given nodes.
c
c   ierr contains an error flag,
c        = 0 for normal return,
c        = 1 if n is less than 2,
c        = 2 if s is negative,
c        = 3 if eps is negative or greater than one,
c        = 4 if x-values are not strictly increasing,
c        = 5 if a d-value is non-positive.
c
c and
c
c   n, x, y, d, isw, s, eps, and sigma are unaltered.
c
c this subroutine references package modules ftstoredp, termsdp,
c and snhcshdp.
c
c-----------------------------------------------------------
c
      if (n .lt. 2) go to 24
      if (s .lt. 0.d0) go to 25
      if (eps .lt. 0.d0 .or. eps .gt. 1.d0) go to 26
      ierr = 0
      p = 0.d0
      v(1) = 0.d0
      v(n) = 0.d0
      ysp(1) = 0.d0
      ysp(n) = 0.d0
      if (n .eq. 2) go to 14
      rsd1(1) = 0.d0
      rd(1) = 0.d0
      rsd2(n) = 0.d0
      rdim1 = 0.d0
      yspim2 = 0.d0
c
c denormalize tension factor
c
      sigmap = abs(sigma)*dble(n-1)/(x(n)-x(1))
c
c form t matrix and second differences of y into ys
c
      nm1 = n-1
      nm3 = n-3
      delxi1 = 1.d0
      delyi1 = 0.d0
      dim1 = 0.d0
      do 1 i = 1,nm1
        delxi = x(i+1)-x(i)
        if (delxi .le. 0.d0) go to 27
        delyi = (y(i+1)-y(i))/delxi
        ys(i) = delyi-delyi1
        call termsdp (di,tsd1(i+1),sigmap,delxi)
        td(i) = di+dim1
        hd(i) = -(1.d0/delxi+1.d0/delxi1)
        hsd1(i+1) = 1.d0/delxi
        delxi1 = delxi
        delyi1 = delyi
    1   dim1 = di
c
c calculate lower and upper tolerances
c
      sl = s*(1.d0-eps)
      su = s*(1.d0+eps)
      if (isw .eq. 1) go to 3
c
c form h matrix - d array
c
      if (d(1) .le. 0.d0 .or. d(2) .le. 0.d0) go to 28
      betapp = 0.d0
      betap = 0.d0
      alphap = 0.d0
      do 2 i = 2,nm1
        alpha = hd(i)*d(i)*d(i)
        if (d(i+1) .le. 0.d0) go to 28
        beta = hsd1(i+1)*d(i+1)*d(i+1)
        hd(i) = (hsd1(i)*d(i-1))**2+alpha*hd(i)
     *                             +beta*hsd1(i+1)
        hsd2(i) = hsd1(i)*betapp
        hsd1(i) = hsd1(i)*(alpha+alphap)
        alphap = alpha
        betapp = betap
    2   betap = beta
      go to 5
c
c form h matrix - d constant
c
    3 if (d(1) .le. 0.d0) go to 28
      sl = d(1)*d(1)*sl
      su = d(1)*d(1)*su
      hsd1p = 0.d0
      hdim1 = 0.d0
      do 4 i = 2,nm1
        hdi = hd(i)
        hd(i) = hsd1(i)*hsd1(i)+hdi*hdi+hsd1(i+1)*hsd1(i+1)
        hsd2(i) = hsd1(i)*hsd1p
        hsd1p = hsd1(i)
        hsd1(i) = hsd1p*(hdi+hdim1)
    4   hdim1 = hdi
c
c top of iteration
c cholesky factorization of p*t+h into r
c
    5 do 6 i = 2,nm1
        rsd2i = hsd2(i)
        rsd1i = p*tsd1(i)+hsd1(i)-rsd2i*rsd1(i-1)
        rsd2(i) = rsd2i*rdim1
        rdim1 = rd(i-1)
        rsd1(i) = rsd1i*rdim1
        rd(i) = 1.d0/(p*td(i)+hd(i)-rsd1i*rsd1(i)
     *                           -rsd2i*rsd2(i))
        ysp(i) = ys(i)-rsd1(i)*ysp(i-1)-rsd2(i)*yspim2
    6   yspim2 = ysp(i-1)
c
c back solve of r(transpose)* r * ysp = ys
c
      ysp(nm1) = rd(nm1)*ysp(nm1)
      if (n .eq. 3) go to 8
      do 7 ibak = 1,nm3
        i = nm1-ibak
    7   ysp(i) = rd(i)*ysp(i)-rsd1(i+1)*ysp(i+1)
     *                       -rsd2(i+2)*ysp(i+2)
    8 sum = 0.d0
      delyi1 = 0.d0
      if (isw .eq. 1) go to 10
c
c calculation of residual norm
c  - d array
c
      do 9 i = 1,nm1
        delyi = (ysp(i+1)-ysp(i))/(x(i+1)-x(i))
        v(i) = (delyi-delyi1)*d(i)*d(i)
        sum = sum+v(i)*(delyi-delyi1)
    9   delyi1 = delyi
      v(n) = -delyi1*d(n)*d(n)
      go to 12
c
c calculation of residual norm
c  - d constant
c
   10 do 11 i = 1,nm1
        delyi = (ysp(i+1)-ysp(i))/(x(i+1)-x(i))
        v(i) = delyi-delyi1
        sum = sum+v(i)*(delyi-delyi1)
   11   delyi1 = delyi
      v(n) = -delyi1
   12 sum = sum-v(n)*delyi1
c
c test for convergence
c
      if (sum .le. su) go to 14
c
c calculation of newton correction
c
      f = 0.d0
      g = 0.d0
      wim2 = 0.d0
      wim1 = 0.d0
      do 13 i = 2,nm1
        tui = tsd1(i)*ysp(i-1)+td(i)*ysp(i)
     *                        +tsd1(i+1)*ysp(i+1)
        wi = tui-rsd1(i)*wim1-rsd2(i)*wim2
        f = f+tui*ysp(i)
        g = g+wi*wi*rd(i)
        wim2 = wim1
   13   wim1 = wi
      h = f-p*g
      if (h .le. 0.d0) go to 14
c
c update p - newton step
c
      step = (sum-sqrt(sum*sl))/h
      if (sl .ne. 0.d0) step = step*sqrt(sum/sl)
      if (ftstoredp(p+step) .eq. p) go to 14
      p = p+step
      go to 5
c
c store smoothed y-values and second derivatives
c
   14 if (p .eq. 0.d0) go to 16
      do 15 i = 1,n
        ys(i) = y(i)-v(i)
   15   ysp(i) = p*ysp(i)
      return
c
c straight line is acceptable
c
   16 sumx = 0.d0
      sumy = 0.d0
      if (isw .eq. 1) go to 19
      sum = 0.d0
c
c compute straight line coefficients
c   d - vector
c
      do 17 i = 1, n
        dinvsq = 1.d0/(d(i)*d(i))
        sum = sum+dinvsq
        sumx = sumx+x(i)*dinvsq
   17   sumy = sumy+y(i)*dinvsq
      xbar = sumx/sum
      ybar = sumy/sum
      sumx = 0.d0
      sumy = 0.d0
      do 18 i = 1, n
        fac = (x(i)-xbar)/(d(i)*d(i))
        sumx = sumx+(x(i)-xbar)*fac
   18   sumy = sumy+(y(i)-ybar)*fac
      go to 22
c
c compute straight line coefficients
c   d - constant
c
   19 sum = dble(n)*dinvsq
      do 20 i = 1, n
        sumx = sumx+x(i)
   20   sumy = sumy+y(i)
      xbar = sumx/dble(n)
      ybar = sumy/dble(n)
      sumx = 0.d0
      sumy = 0.d0
      do 21 i = 1, n
        sumx = sumx+(x(i)-xbar)*(x(i)-xbar)
   21   sumy = sumy+(y(i)-ybar)*(x(i)-xbar)
c
c store straight line values
c
   22 slp = sumy/sumx
      do 23 i = 1, n
        ys(i) = ybar+slp*(x(i)-xbar)
   23   ysp(i) = 0.d0
      return
c
c n less than 2
c
   24 ierr = 1
      return
c
c s negative
c
   25 ierr = 2
      return
c
c eps negative or greater than 1
c
   26 ierr = 3
      return
c
c x-values not strictly increasing
c
   27 ierr = 4
      return
c
c weight non-positive
c
   28 ierr = 5
      return
      end

C
C $Id: mdiaty.f,v 1.3 2008-07-27 00:17:06 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      INTEGER FUNCTION MDIATY (IAIN)
C
        INTEGER IAIN
C
        PARAMETER (MNAI=8000)
C
C The value of MDIATY(IAIN) is the area type for the area whose area
C identifier is IAIN.
C
        COMMON /MAPCMX/  IATY(MNAI),ISCI(MNAI),IPAR(MNAI)
        INTEGER          IATY,ISCI,IPAR
        SAVE   /MAPCMX/
C
        MDIATY=0
        IF (IAIN.GE.1.AND.IAIN.LE.MNAI) THEN
          MDIATY=IATY(IAIN)
        END IF
        RETURN
      END

C
C	$Id: wmcext.f,v 1.4 2008-07-27 00:17:36 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE WMCEXT(ISN,NF,X,Y,STR,SIZ,EXTBOX)
C
C  Use Plotchar to determine a text extent box for the station
C  model label numbered ISN from font number NF with the characters
C  in STR, at size SIZ, at position (X,Y).  The extent box is returned
C  in EXTBOX in the order XLL,YLL,XUR,YUR.
C
      CHARACTER*(*) STR
      INTEGER WMGTLN
      DIMENSION EXTBOX(4)
C
      CALL PCGETI('TE',ITEOLD)
      CALL PCGETI('FN',NFOLD)
      CALL PCSETI('TE',1)
      CALL PCSETI('FN',NF)
      IF (ISN.EQ.1 .OR. ISN.EQ.2 .OR. ISN.EQ.6 .OR. ISN.EQ.10) THEN
        ASIZ = 1.5*SIZ
      ELSE
        ASIZ = SIZ
      ENDIF
      LL = WMGTLN(STR,LEN(STR),0)
      CALL PLCHHQ(X,Y,STR(1:LL),ASIZ,360.,0.)       
      CALL PCGETR ('DL',XL)
      CALL PCGETR ('DR',XR)
      CALL PCGETR ('DB',YB)
      CALL PCGETR ('DT',YT)
      EXTBOX(1) = X-XL
      EXTBOX(2) = Y-YB
      EXTBOX(3) = X+XR
      EXTBOX(4) = Y+YT
C
      CALL PCSETI('TE',ITEOLD)
      CALL PCSETI('FN',NFOLD)
C
      RETURN
      END

C
C $Id: pj17dp.f,v 1.5 2008-07-27 00:17:11 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE PJ17DP (COORD,CRDIO,INDIC)
C
C -- E Q U I R E C T A N G U L A R
C
      IMPLICIT DOUBLE PRECISION (A-Z)
      INTEGER INDIC
      DIMENSION GEOG(2),PROJ(2),COORD(2),CRDIO(2)
C **** PARAMETERS **** A,LON0,X0,Y0,LAT1 *******************************
      COMMON /ERRMZ0/ IERR
        INTEGER IERR
      SAVE   /ERRMZ0/
      COMMON /PRINZ0/ IPEMSG,IPELUN,IPPARM,IPPLUN
        INTEGER IPEMSG,IPELUN,IPPARM,IPPLUN
      SAVE   /PRINZ0/
      COMMON /PC17DP/ A,LON0,X0,Y0,LAT1
      DATA HALFPI /1.5707963267948966D0/
C
C -- F O R W A R D   . . .
C
      IF (INDIC .EQ. 0) THEN
C
         GEOG(1) = COORD(1)
         GEOG(2) = COORD(2)
         IERR = 0
         LON = ADJLDP (GEOG(1) - LON0)
         PROJ(1) = X0 + A * LON * COS(LAT1)
         PROJ(2) = Y0 + A * GEOG(2)
         CRDIO(1) = PROJ(1)
         CRDIO(2) = PROJ(2)
         RETURN
      END IF
C
C -- I N V E R S E   . . .
C
      IF (INDIC .EQ. 1) THEN
C
         PROJ(1) = COORD(1)
         PROJ(2) = COORD(2)
         IERR = 0
         X = PROJ(1) - X0
         Y = PROJ(2) - Y0
         GEOG(2) = Y / A
         IF (ABS(GEOG(2)) .LE. HALFPI) GO TO 240
         IF (IPEMSG .EQ. 0) WRITE (IPELUN,2020)
 2020    FORMAT (/' ERROR PJ17DP'/
     .            ' INPUT DATA ERROR')
         IERR = 174
         RETURN
  240    GEOG(1) = ADJLDP (LON0 + X / (A * COS(LAT1) ))
         CRDIO(1) = GEOG(1)
         CRDIO(2) = GEOG(2)
         RETURN
      END IF
C
      END

c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by UCAR                 .
c  .                                                             .
c  .       University Corporation for Atmospheric Research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                         SPHEREPACK                          .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c
c
c ... file vtsec.f
c
c     this file includes documentation and code for
c     subroutines vtsec and vtseci
c
c ... files which must be loaded with vtsec.f
c
c     sphcom.f, hrfft.f, vhaec.f, vhsec.f
c
c     subroutine vtsec(nlat,nlon,ityp,nt,vt,wt,idvw,jdvw,br,bi,cr,ci,
c    +                 mdab,ndab,wvts,lwvts,work,lwork,ierror)
c
c     given the vector harmonic analysis br,bi,cr, and ci (computed
c     by subroutine vhaec) of some vector function (v,w), this
c     subroutine computes the vector function (vt,wt) which is
c     the derivative of (v,w) with respect to colatitude theta. vtsec
c     is similar to vhsec except the vector harmonics are replaced by
c     their derivative with respect to colatitude with the result that
c     (vt,wt) is computed instead of (v,w). vt(i,j) is the derivative
c     of the colatitudinal component v(i,j) at the point theta(i) =
c     (i-1)*pi/(nlat-1) and longitude phi(j) = (j-1)*2*pi/nlon. the
c     spectral representation of (vt,wt) is given below at output
c     parameters vt,wt.
c
c     input parameters
c
c     nlat   the number of colatitudes on the full sphere including the
c            poles. for example, nlat = 37 for a five degree grid.
c            nlat determines the grid increment in colatitude as
c            pi/(nlat-1).  if nlat is odd the equator is located at
c            grid point i=(nlat+1)/2. if nlat is even the equator is
c            located half way between points i=nlat/2 and i=nlat/2+1.
c            nlat must be at least 3. note: on the half sphere, the
c            number of grid points in the colatitudinal direction is
c            nlat/2 if nlat is even or (nlat+1)/2 if nlat is odd.
c
c     nlon   the number of distinct londitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater
c            than zero. the axisymmetric case corresponds to nlon=1.
c            the efficiency of the computation is improved when nlon
c            is a product of small prime numbers.
c
c     ityp   = 0  no symmetries exist about the equator. the synthesis
c                 is performed on the entire sphere. i.e. the arrays
c                 vt(i,j),wt(i,j) are computed for i=1,...,nlat and
c                 j=1,...,nlon.
c
c            = 1  no symmetries exist about the equator however the
c                 the coefficients cr and ci are zero. the synthesis
c                 is performed on the entire sphere.  i.e. the arrays
c                 vt(i,j),wt(i,j) are computed for i=1,...,nlat and
c                 j=1,...,nlon.
c
c            = 2  no symmetries exist about the equator however the
c                 the coefficients br and bi are zero. the synthesis
c                 is performed on the entire sphere.  i.e. the arrays
c                 vt(i,j),wt(i,j) are computed for i=1,...,nlat and
c                 j=1,...,nlon.
c
c            = 3  vt is odd and wt is even about the equator. the
c                 synthesis is performed on the northern hemisphere
c                 only.  i.e., if nlat is odd the arrays vt(i,j),wt(i,j)
c                 are computed for i=1,...,(nlat+1)/2 and j=1,...,nlon.
C*PL*ERROR* Comment line too long
c                 if nlat is even the arrays vt(i,j),wt(i,j) are computed
c                 for i=1,...,nlat/2 and j=1,...,nlon.
c
c            = 4  vt is odd and wt is even about the equator and the
c                 coefficients cr and ci are zero. the synthesis is
c                 performed on the northern hemisphere only. i.e. if
c                 nlat is odd the arrays vt(i,j),wt(i,j) are computed
c                 for i=1,...,(nlat+1)/2 and j=1,...,nlon. if nlat is
c                 even the arrays vt(i,j),wt(i,j) are computed for
c                 i=1,...,nlat/2 and j=1,...,nlon.
c
c            = 5  vt is odd and wt is even about the equator and the
c                 coefficients br and bi are zero. the synthesis is
c                 performed on the northern hemisphere only. i.e. if
c                 nlat is odd the arrays vt(i,j),wt(i,j) are computed
c                 for i=1,...,(nlat+1)/2 and j=1,...,nlon. if nlat is
c                 even the arrays vt(i,j),wt(i,j) are computed for
c                 i=1,...,nlat/2 and j=1,...,nlon.
c
c            = 6  vt is even and wt is odd about the equator. the
c                 synthesis is performed on the northern hemisphere
c                 only.  i.e., if nlat is odd the arrays vt(i,j),wt(i,j)
c                 are computed for i=1,...,(nlat+1)/2 and j=1,...,nlon.
C*PL*ERROR* Comment line too long
c                 if nlat is even the arrays vt(i,j),wt(i,j) are computed
c                 for i=1,...,nlat/2 and j=1,...,nlon.
c
c            = 7  vt is even and wt is odd about the equator and the
c                 coefficients cr and ci are zero. the synthesis is
c                 performed on the northern hemisphere only. i.e. if
c                 nlat is odd the arrays vt(i,j),wt(i,j) are computed
c                 for i=1,...,(nlat+1)/2 and j=1,...,nlon. if nlat is
c                 even the arrays vt(i,j),wt(i,j) are computed for
c                 i=1,...,nlat/2 and j=1,...,nlon.
c
c            = 8  vt is even and wt is odd about the equator and the
c                 coefficients br and bi are zero. the synthesis is
c                 performed on the northern hemisphere only. i.e. if
c                 nlat is odd the arrays vt(i,j),wt(i,j) are computed
c                 for i=1,...,(nlat+1)/2 and j=1,...,nlon. if nlat is
c                 even the arrays vt(i,j),wt(i,j) are computed for
c                 i=1,...,nlat/2 and j=1,...,nlon.
c
c     nt     the number of syntheses.  in the program that calls vtsec,
c            the arrays vt,wt,br,bi,cr, and ci can be three dimensional
c            in which case multiple syntheses will be performed.
c            the third index is the synthesis index which assumes the
c            values k=1,...,nt.  for a single synthesis set nt=1. the
c            discription of the remaining parameters is simplified
c            by assuming that nt=1 or that all the arrays are two
c            dimensional.
c
c     idvw   the first dimension of the arrays vt,wt as it appears in
c            the program that calls vtsec. if ityp .le. 2 then idvw
c            must be at least nlat.  if ityp .gt. 2 and nlat is
c            even then idvw must be at least nlat/2. if ityp .gt. 2
c            and nlat is odd then idvw must be at least (nlat+1)/2.
c
c     jdvw   the second dimension of the arrays vt,wt as it appears in
c            the program that calls vtsec. jdvw must be at least nlon.
c
c     br,bi  two or three dimensional arrays (see input parameter nt)
c     cr,ci  that contain the vector spherical harmonic coefficients
c            of (v,w) as computed by subroutine vhaec.
c
c     mdab   the first dimension of the arrays br,bi,cr, and ci as it
c            appears in the program that calls vtsec. mdab must be at
c            least min0(nlat,nlon/2) if nlon is even or at least
c            min0(nlat,(nlon+1)/2) if nlon is odd.
c
c     ndab   the second dimension of the arrays br,bi,cr, and ci as it
c            appears in the program that calls vtsec. ndab must be at
c            least nlat.
c
c     wvts   an array which must be initialized by subroutine vtseci.
c            once initialized, wvts can be used repeatedly by vtsec
c            as long as nlon and nlat remain unchanged.  wvts must
c            not be altered between calls of vtsec.
c
c     lwvts  the dimension of the array wvts as it appears in the
c            program that calls vtsec. define
c
c               l1 = min0(nlat,nlon/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            then lwvts must be at least
c
c            4*nlat*l2+3*max0(l1-2,0)*(nlat+nlat-l1-1)+nlon+15
c
c
c     work   a work array that does not have to be saved.
c
c     lwork  the dimension of the array work as it appears in the
c            program that calls vtsec. define
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            if ityp .le. 2 then lwork must be at least
c
c                    nlat*(2*nt*nlon+max0(6*l2,nlon))
c
c            if ityp .gt. 2 then lwork must be at least
c
c                    l2*(2*nt*nlon+max0(6*nlat,nlon))
c
c     **************************************************************
c
c     output parameters
c
c     vt,wt  two or three dimensional arrays (see input parameter nt)
c            in which the derivative of (v,w) with respect to
c            colatitude theta is stored. vt(i,j),wt(i,j) contain the
c            derivatives at colatitude theta(i) = (i-1)*pi/(nlat-1)
c            and longitude phi(j) = (j-1)*2*pi/nlon. the index ranges
c            are defined above at the input parameter ityp. vt and wt
c            are computed from the formulas for v and w given in
c            subroutine vhsec but with vbar and wbar replaced with
c            their derivatives with respect to colatitude. these
c            derivatives are denoted by vtbar and wtbar.
c
c   in terms of real variables this expansion takes the form
c
c             for i=1,...,nlat and  j=1,...,nlon
c
c     vt(i,j) = the sum from n=1 to n=nlat-1 of
c
c               .5*br(1,n+1)*vtbar(0,n,theta(i))
c
c     plus the sum from m=1 to m=mmax-1 of the sum from n=m to
c     n=nlat-1 of the real part of
c
c       (br(m+1,n+1)*vtbar(m,n,theta(i))
c                   -ci(m+1,n+1)*wtbar(m,n,theta(i)))*cos(m*phi(j))
c      -(bi(m+1,n+1)*vtbar(m,n,theta(i))
c                   +cr(m+1,n+1)*wtbar(m,n,theta(i)))*sin(m*phi(j))
c
c    and for i=1,...,nlat and  j=1,...,nlon
c
c     wt(i,j) = the sum from n=1 to n=nlat-1 of
c
c              -.5*cr(1,n+1)*vtbar(0,n,theta(i))
c
c     plus the sum from m=1 to m=mmax-1 of the sum from n=m to
c     n=nlat-1 of the real part of
c
c      -(cr(m+1,n+1)*vtbar(m,n,theta(i))
c                   +bi(m+1,n+1)*wtbar(m,n,theta(i)))*cos(m*phi(j))
c      +(ci(m+1,n+1)*vtbar(m,n,theta(i))
c                   -br(m+1,n+1)*wtbar(m,n,theta(i)))*sin(m*phi(j))
c
c
c      br(m+1,nlat),bi(m+1,nlat),cr(m+1,nlat), and ci(m+1,nlat) are
c      assumed zero for m even.
c
c
c     ierror = 0  no errors
c            = 1  error in the specification of nlat
c            = 2  error in the specification of nlon
c            = 3  error in the specification of ityp
c            = 4  error in the specification of nt
c            = 5  error in the specification of idvw
c            = 6  error in the specification of jdvw
c            = 7  error in the specification of mdab
c            = 8  error in the specification of ndab
c            = 9  error in the specification of lwvts
c            = 10 error in the specification of lwork
c
c
c *******************************************************************
c
c     subroutine vtseci(nlat,nlon,wvts,lwvts,dwork,ldwork,ierror)
c
c     subroutine vtseci initializes the array wvts which can then be
c     used repeatedly by subroutine vtsec until nlat or nlon is changed.
c
c     input parameters
c
c     nlat   the number of colatitudes on the full sphere including the
c            poles. for example, nlat = 37 for a five degree grid.
c            nlat determines the grid increment in colatitude as
c            pi/(nlat-1).  if nlat is odd the equator is located at
c            grid point i=(nlat+1)/2. if nlat is even the equator is
c            located half way between points i=nlat/2 and i=nlat/2+1.
c            nlat must be at least 3. note: on the half sphere, the
c            number of grid points in the colatitudinal direction is
c            nlat/2 if nlat is even or (nlat+1)/2 if nlat is odd.
c
c     nlon   the number of distinct londitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater
c            than zero. the axisymmetric case corresponds to nlon=1.
c            the efficiency of the computation is improved when nlon
c            is a product of small prime numbers.
c
c     lwvts  the dimension of the array wvts as it appears in the
c            program that calls vtsec. define
c
c               l1 = min0(nlat,nlon/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            then lwvts must be at least
c
c            4*nlat*l2+3*max0(l1-2,0)*(nlat+nlat-l1-1)+nlon+15
c
c
C*PL*ERROR* Comment line too long
c     dwork  a double precision work array that does not have to be saved.
c
c     ldwork the dimension of the array work as it appears in the
c            program that calls vtsec. lwork must be at least
c            2*(nlat+1)
c
c     **************************************************************
c
c     output parameters
c
c     wvts   an array which is initialized for use by subroutine vtsec.
c            once initialized, wvts can be used repeatedly by vtsec
c            as long as nlat or nlon remain unchanged.  wvts must not
c            be altered between calls of vtsec.
c
c
c     ierror = 0  no errors
c            = 1  error in the specification of nlat
c            = 2  error in the specification of nlon
c            = 3  error in the specification of lwvts
c            = 4  error in the specification of ldwork
c
c **********************************************************************
c
      SUBROUTINE DVTSEC(NLAT,NLON,ITYP,NT,VT,WT,IDVW,JDVW,BR,BI,CR,CI,
     +                 MDAB,NDAB,WVTS,LWVTS,WORK,LWORK,IERROR)
      DOUBLE PRECISION VT
      DOUBLE PRECISION WT
      DOUBLE PRECISION BR
      DOUBLE PRECISION BI
      DOUBLE PRECISION CR
      DOUBLE PRECISION CI
      DOUBLE PRECISION WVTS
      DOUBLE PRECISION WORK
c
      DIMENSION VT(IDVW,JDVW,1),WT(IDVW,JDVW,1),BR(MDAB,NDAB,1),
     +          BI(MDAB,NDAB,1),CR(MDAB,NDAB,1),CI(MDAB,NDAB,1),WORK(1),
     +          WVTS(1)

      IERROR = 1
      IF (NLAT.LT.3) RETURN
      IERROR = 2
      IF (NLON.LT.1) RETURN
      IERROR = 3
      IF (ITYP.LT.0 .OR. ITYP.GT.8) RETURN
      IERROR = 4
      IF (NT.LT.0) RETURN
      IERROR = 5
      IMID = (NLAT+1)/2
      IF ((ITYP.LE.2.AND.IDVW.LT.NLAT) .OR.
     +    (ITYP.GT.2.AND.IDVW.LT.IMID)) RETURN
      IERROR = 6
      IF (JDVW.LT.NLON) RETURN
      IERROR = 7
      MMAX = MIN0(NLAT, (NLON+1)/2)
      IF (MDAB.LT.MMAX) RETURN
      IERROR = 8
      IF (NDAB.LT.NLAT) RETURN
      IERROR = 9
      LZZ1 = 2*NLAT*IMID
      LABC = 3* (MAX0(MMAX-2,0)* (NLAT+NLAT-MMAX-1))/2
      IF (LWVTS.LT.2* (LZZ1+LABC)+NLON+15) RETURN
      IERROR = 10
      IF (ITYP.LE.2 .AND. LWORK.LT.NLAT*
     +    (2*NT*NLON+MAX0(6*IMID,NLON))) RETURN
      IF (ITYP.GT.2 .AND. LWORK.LT.IMID*
     +    (2*NT*NLON+MAX0(6*NLAT,NLON))) RETURN
      IERROR = 0
      IDV = NLAT
      IF (ITYP.GT.2) IDV = IMID
      LNL = NT*IDV*NLON
      IST = 0
      IF (ITYP.LE.2) IST = IMID
      IW1 = IST + 1
      IW2 = LNL + 1
      IW3 = IW2 + IST
      IW4 = IW2 + LNL
      IW5 = IW4 + 3*IMID*NLAT
      LZZ1 = 2*NLAT*IMID
      LABC = 3* (MAX0(MMAX-2,0)* (NLAT+NLAT-MMAX-1))/2
      LWZVIN = LZZ1 + LABC
      JW1 = LWZVIN + 1
      JW2 = JW1 + LWZVIN
      CALL DVTSEC1(NLAT,NLON,ITYP,NT,IMID,IDVW,JDVW,VT,WT,MDAB,NDAB,BR,
     +            BI,CR,CI,IDV,WORK,WORK(IW1),WORK(IW2),WORK(IW3),
     +            WORK(IW4),WORK(IW5),WVTS,WVTS(JW1),WVTS(JW2))
      RETURN
      END
      SUBROUTINE DVTSEC1(NLAT,NLON,ITYP,NT,IMID,IDVW,JDVW,VT,WT,MDAB,
     +                  NDAB,BR,BI,CR,CI,IDV,VTE,VTO,WTE,WTO,VB,WB,
     +                  WVBIN,WWBIN,WRFFT)
      DOUBLE PRECISION VT
      DOUBLE PRECISION WT
      DOUBLE PRECISION BR
      DOUBLE PRECISION BI
      DOUBLE PRECISION CR
      DOUBLE PRECISION CI
      DOUBLE PRECISION VTE
      DOUBLE PRECISION VTO
      DOUBLE PRECISION WTE
      DOUBLE PRECISION WTO
      DOUBLE PRECISION VB
      DOUBLE PRECISION WB
      DOUBLE PRECISION WVBIN
      DOUBLE PRECISION WWBIN
      DOUBLE PRECISION WRFFT
      DIMENSION VT(IDVW,JDVW,1),WT(IDVW,JDVW,1),BR(MDAB,NDAB,1),
     +          BI(MDAB,NDAB,1),CR(MDAB,NDAB,1),CI(MDAB,NDAB,1),
     +          VTE(IDV,NLON,1),VTO(IDV,NLON,1),WTE(IDV,NLON,1),
     +          WTO(IDV,NLON,1),WVBIN(1),WWBIN(1),WRFFT(1),
     +          VB(IMID,NLAT,3),WB(IMID,NLAT,3)

      NLP1 = NLAT + 1
      MLAT = MOD(NLAT,2)
      MLON = MOD(NLON,2)
      MMAX = MIN0(NLAT, (NLON+1)/2)
      IMM1 = IMID
      IF (MLAT.NE.0) IMM1 = IMID - 1
      DO 10 K = 1,NT
          DO 10 J = 1,NLON
              DO 10 I = 1,IDV
                  VTE(I,J,K) = 0.D0
                  WTE(I,J,K) = 0.D0
   10 CONTINUE
      NDO1 = NLAT
      NDO2 = NLAT
      IF (MLAT.NE.0) NDO1 = NLAT - 1
      IF (MLAT.EQ.0) NDO2 = NLAT - 1
   18 ITYPP = ITYP + 1
      GO TO (1,100,200,300,400,500,600,700,800) ITYPP
c
c     case ityp=0   no symmetries
c
    1 CALL DVBIN(0,NLAT,NLON,0,VB,IV,WVBIN)
c
c     case m = 0
c
      DO 15 K = 1,NT
          DO 15 NP1 = 2,NDO2,2
              DO 15 I = 1,IMM1
                  VTO(I,1,K) = VTO(I,1,K) + BR(1,NP1,K)*VB(I,NP1,IV)
                  WTO(I,1,K) = WTO(I,1,K) - CR(1,NP1,K)*VB(I,NP1,IV)
   15 CONTINUE
      DO 16 K = 1,NT
          DO 16 NP1 = 3,NDO1,2
              DO 16 I = 1,IMID
                  VTE(I,1,K) = VTE(I,1,K) + BR(1,NP1,K)*VB(I,NP1,IV)
                  WTE(I,1,K) = WTE(I,1,K) - CR(1,NP1,K)*VB(I,NP1,IV)
   16 CONTINUE
c
c     case m = 1 through nlat-1
c
      IF (MMAX.LT.2) GO TO 950
      DO 30 MP1 = 2,MMAX
          M = MP1 - 1
          MP2 = MP1 + 1
          CALL DVBIN(0,NLAT,NLON,M,VB,IV,WVBIN)
          CALL DWBIN(0,NLAT,NLON,M,WB,IW,WWBIN)
          IF (MP1.GT.NDO1) GO TO 26
          DO 25 K = 1,NT
              DO 24 NP1 = MP1,NDO1,2
                  DO 23 I = 1,IMM1
                      VTE(I,2*MP1-2,K) = VTE(I,2*MP1-2,K) +
     +                                   BR(MP1,NP1,K)*VB(I,NP1,IV)
                      VTO(I,2*MP1-2,K) = VTO(I,2*MP1-2,K) -
     +                                   CI(MP1,NP1,K)*WB(I,NP1,IW)
                      VTE(I,2*MP1-1,K) = VTE(I,2*MP1-1,K) +
     +                                   BI(MP1,NP1,K)*VB(I,NP1,IV)
                      VTO(I,2*MP1-1,K) = VTO(I,2*MP1-1,K) +
     +                                   CR(MP1,NP1,K)*WB(I,NP1,IW)
                      WTE(I,2*MP1-2,K) = WTE(I,2*MP1-2,K) -
     +                                   CR(MP1,NP1,K)*VB(I,NP1,IV)
                      WTO(I,2*MP1-2,K) = WTO(I,2*MP1-2,K) -
     +                                   BI(MP1,NP1,K)*WB(I,NP1,IW)
                      WTE(I,2*MP1-1,K) = WTE(I,2*MP1-1,K) -
     +                                   CI(MP1,NP1,K)*VB(I,NP1,IV)
                      WTO(I,2*MP1-1,K) = WTO(I,2*MP1-1,K) +
     +                                   BR(MP1,NP1,K)*WB(I,NP1,IW)
   23             CONTINUE
                  IF (MLAT.EQ.0) GO TO 24
                  VTE(IMID,2*MP1-2,K) = VTE(IMID,2*MP1-2,K) +
     +                                  BR(MP1,NP1,K)*VB(IMID,NP1,IV)
                  VTE(IMID,2*MP1-1,K) = VTE(IMID,2*MP1-1,K) +
     +                                  BI(MP1,NP1,K)*VB(IMID,NP1,IV)
                  WTE(IMID,2*MP1-2,K) = WTE(IMID,2*MP1-2,K) -
     +                                  CR(MP1,NP1,K)*VB(IMID,NP1,IV)
                  WTE(IMID,2*MP1-1,K) = WTE(IMID,2*MP1-1,K) -
     +                                  CI(MP1,NP1,K)*VB(IMID,NP1,IV)
   24         CONTINUE
   25     CONTINUE
   26     IF (MP2.GT.NDO2) GO TO 30
          DO 29 K = 1,NT
              DO 28 NP1 = MP2,NDO2,2
                  DO 27 I = 1,IMM1
                      VTO(I,2*MP1-2,K) = VTO(I,2*MP1-2,K) +
     +                                   BR(MP1,NP1,K)*VB(I,NP1,IV)
                      VTE(I,2*MP1-2,K) = VTE(I,2*MP1-2,K) -
     +                                   CI(MP1,NP1,K)*WB(I,NP1,IW)
                      VTO(I,2*MP1-1,K) = VTO(I,2*MP1-1,K) +
     +                                   BI(MP1,NP1,K)*VB(I,NP1,IV)
                      VTE(I,2*MP1-1,K) = VTE(I,2*MP1-1,K) +
     +                                   CR(MP1,NP1,K)*WB(I,NP1,IW)
                      WTO(I,2*MP1-2,K) = WTO(I,2*MP1-2,K) -
     +                                   CR(MP1,NP1,K)*VB(I,NP1,IV)
                      WTE(I,2*MP1-2,K) = WTE(I,2*MP1-2,K) -
     +                                   BI(MP1,NP1,K)*WB(I,NP1,IW)
                      WTO(I,2*MP1-1,K) = WTO(I,2*MP1-1,K) -
     +                                   CI(MP1,NP1,K)*VB(I,NP1,IV)
                      WTE(I,2*MP1-1,K) = WTE(I,2*MP1-1,K) +
     +                                   BR(MP1,NP1,K)*WB(I,NP1,IW)
   27             CONTINUE
                  IF (MLAT.EQ.0) GO TO 28
                  VTE(IMID,2*MP1-2,K) = VTE(IMID,2*MP1-2,K) -
     +                                  CI(MP1,NP1,K)*WB(IMID,NP1,IW)
                  VTE(IMID,2*MP1-1,K) = VTE(IMID,2*MP1-1,K) +
     +                                  CR(MP1,NP1,K)*WB(IMID,NP1,IW)
                  WTE(IMID,2*MP1-2,K) = WTE(IMID,2*MP1-2,K) -
     +                                  BI(MP1,NP1,K)*WB(IMID,NP1,IW)
                  WTE(IMID,2*MP1-1,K) = WTE(IMID,2*MP1-1,K) +
     +                                  BR(MP1,NP1,K)*WB(IMID,NP1,IW)
   28         CONTINUE
   29     CONTINUE
   30 CONTINUE
      GO TO 950
c
c     case ityp=1   no symmetries,  cr and ci equal zero
c
  100 CALL DVBIN(0,NLAT,NLON,0,VB,IV,WVBIN)
c
c     case m = 0
c
      DO 115 K = 1,NT
          DO 115 NP1 = 2,NDO2,2
              DO 115 I = 1,IMM1
                  VTO(I,1,K) = VTO(I,1,K) + BR(1,NP1,K)*VB(I,NP1,IV)
  115 CONTINUE
      DO 116 K = 1,NT
          DO 116 NP1 = 3,NDO1,2
              DO 116 I = 1,IMID
                  VTE(I,1,K) = VTE(I,1,K) + BR(1,NP1,K)*VB(I,NP1,IV)
  116 CONTINUE
c
c     case m = 1 through nlat-1
c
      IF (MMAX.LT.2) GO TO 950
      DO 130 MP1 = 2,MMAX
          M = MP1 - 1
          MP2 = MP1 + 1
          CALL DVBIN(0,NLAT,NLON,M,VB,IV,WVBIN)
          CALL DWBIN(0,NLAT,NLON,M,WB,IW,WWBIN)
          IF (MP1.GT.NDO1) GO TO 126
          DO 125 K = 1,NT
              DO 124 NP1 = MP1,NDO1,2
                  DO 123 I = 1,IMM1
                      VTE(I,2*MP1-2,K) = VTE(I,2*MP1-2,K) +
     +                                   BR(MP1,NP1,K)*VB(I,NP1,IV)
                      VTE(I,2*MP1-1,K) = VTE(I,2*MP1-1,K) +
     +                                   BI(MP1,NP1,K)*VB(I,NP1,IV)
                      WTO(I,2*MP1-2,K) = WTO(I,2*MP1-2,K) -
     +                                   BI(MP1,NP1,K)*WB(I,NP1,IW)
                      WTO(I,2*MP1-1,K) = WTO(I,2*MP1-1,K) +
     +                                   BR(MP1,NP1,K)*WB(I,NP1,IW)
  123             CONTINUE
                  IF (MLAT.EQ.0) GO TO 124
                  VTE(IMID,2*MP1-2,K) = VTE(IMID,2*MP1-2,K) +
     +                                  BR(MP1,NP1,K)*VB(IMID,NP1,IV)
                  VTE(IMID,2*MP1-1,K) = VTE(IMID,2*MP1-1,K) +
     +                                  BI(MP1,NP1,K)*VB(IMID,NP1,IV)
  124         CONTINUE
  125     CONTINUE
  126     IF (MP2.GT.NDO2) GO TO 130
          DO 129 K = 1,NT
              DO 128 NP1 = MP2,NDO2,2
                  DO 127 I = 1,IMM1
                      VTO(I,2*MP1-2,K) = VTO(I,2*MP1-2,K) +
     +                                   BR(MP1,NP1,K)*VB(I,NP1,IV)
                      VTO(I,2*MP1-1,K) = VTO(I,2*MP1-1,K) +
     +                                   BI(MP1,NP1,K)*VB(I,NP1,IV)
                      WTE(I,2*MP1-2,K) = WTE(I,2*MP1-2,K) -
     +                                   BI(MP1,NP1,K)*WB(I,NP1,IW)
                      WTE(I,2*MP1-1,K) = WTE(I,2*MP1-1,K) +
     +                                   BR(MP1,NP1,K)*WB(I,NP1,IW)
  127             CONTINUE
                  IF (MLAT.EQ.0) GO TO 128
                  WTE(IMID,2*MP1-2,K) = WTE(IMID,2*MP1-2,K) -
     +                                  BI(MP1,NP1,K)*WB(IMID,NP1,IW)
                  WTE(IMID,2*MP1-1,K) = WTE(IMID,2*MP1-1,K) +
     +                                  BR(MP1,NP1,K)*WB(IMID,NP1,IW)
  128         CONTINUE
  129     CONTINUE
  130 CONTINUE
      GO TO 950
c
c     case ityp=2   no symmetries,  br and bi are equal to zero
c
  200 CALL DVBIN(0,NLAT,NLON,0,VB,IV,WVBIN)
c
c     case m = 0
c
      DO 215 K = 1,NT
          DO 215 NP1 = 2,NDO2,2
              DO 215 I = 1,IMM1
                  WTO(I,1,K) = WTO(I,1,K) - CR(1,NP1,K)*VB(I,NP1,IV)
  215 CONTINUE
      DO 216 K = 1,NT
          DO 216 NP1 = 3,NDO1,2
              DO 216 I = 1,IMID
                  WTE(I,1,K) = WTE(I,1,K) - CR(1,NP1,K)*VB(I,NP1,IV)
  216 CONTINUE
c
c     case m = 1 through nlat-1
c
      IF (MMAX.LT.2) GO TO 950
      DO 230 MP1 = 2,MMAX
          M = MP1 - 1
          MP2 = MP1 + 1
          CALL DVBIN(0,NLAT,NLON,M,VB,IV,WVBIN)
          CALL DWBIN(0,NLAT,NLON,M,WB,IW,WWBIN)
          IF (MP1.GT.NDO1) GO TO 226
          DO 225 K = 1,NT
              DO 224 NP1 = MP1,NDO1,2
                  DO 223 I = 1,IMM1
                      VTO(I,2*MP1-2,K) = VTO(I,2*MP1-2,K) -
     +                                   CI(MP1,NP1,K)*WB(I,NP1,IW)
                      VTO(I,2*MP1-1,K) = VTO(I,2*MP1-1,K) +
     +                                   CR(MP1,NP1,K)*WB(I,NP1,IW)
                      WTE(I,2*MP1-2,K) = WTE(I,2*MP1-2,K) -
     +                                   CR(MP1,NP1,K)*VB(I,NP1,IV)
                      WTE(I,2*MP1-1,K) = WTE(I,2*MP1-1,K) -
     +                                   CI(MP1,NP1,K)*VB(I,NP1,IV)
  223             CONTINUE
                  IF (MLAT.EQ.0) GO TO 224
                  WTE(IMID,2*MP1-2,K) = WTE(IMID,2*MP1-2,K) -
     +                                  CR(MP1,NP1,K)*VB(IMID,NP1,IV)
                  WTE(IMID,2*MP1-1,K) = WTE(IMID,2*MP1-1,K) -
     +                                  CI(MP1,NP1,K)*VB(IMID,NP1,IV)
  224         CONTINUE
  225     CONTINUE
  226     IF (MP2.GT.NDO2) GO TO 230
          DO 229 K = 1,NT
              DO 228 NP1 = MP2,NDO2,2
                  DO 227 I = 1,IMM1
                      VTE(I,2*MP1-2,K) = VTE(I,2*MP1-2,K) -
     +                                   CI(MP1,NP1,K)*WB(I,NP1,IW)
                      VTE(I,2*MP1-1,K) = VTE(I,2*MP1-1,K) +
     +                                   CR(MP1,NP1,K)*WB(I,NP1,IW)
                      WTO(I,2*MP1-2,K) = WTO(I,2*MP1-2,K) -
     +                                   CR(MP1,NP1,K)*VB(I,NP1,IV)
                      WTO(I,2*MP1-1,K) = WTO(I,2*MP1-1,K) -
     +                                   CI(MP1,NP1,K)*VB(I,NP1,IV)
  227             CONTINUE
                  IF (MLAT.EQ.0) GO TO 228
                  VTE(IMID,2*MP1-2,K) = VTE(IMID,2*MP1-2,K) -
     +                                  CI(MP1,NP1,K)*WB(IMID,NP1,IW)
                  VTE(IMID,2*MP1-1,K) = VTE(IMID,2*MP1-1,K) +
     +                                  CR(MP1,NP1,K)*WB(IMID,NP1,IW)
  228         CONTINUE
  229     CONTINUE
  230 CONTINUE
      GO TO 950
c
c     case ityp=3   v odd,  w even
c
  300 CALL DVBIN(0,NLAT,NLON,0,VB,IV,WVBIN)
c
c     case m = 0
c
      DO 315 K = 1,NT
          DO 315 NP1 = 2,NDO2,2
              DO 315 I = 1,IMM1
                  VTO(I,1,K) = VTO(I,1,K) + BR(1,NP1,K)*VB(I,NP1,IV)
  315 CONTINUE
      DO 316 K = 1,NT
          DO 316 NP1 = 3,NDO1,2
              DO 316 I = 1,IMID
                  WTE(I,1,K) = WTE(I,1,K) - CR(1,NP1,K)*VB(I,NP1,IV)
  316 CONTINUE
c
c     case m = 1 through nlat-1
c
      IF (MMAX.LT.2) GO TO 950
      DO 330 MP1 = 2,MMAX
          M = MP1 - 1
          MP2 = MP1 + 1
          CALL DVBIN(0,NLAT,NLON,M,VB,IV,WVBIN)
          CALL DWBIN(0,NLAT,NLON,M,WB,IW,WWBIN)
          IF (MP1.GT.NDO1) GO TO 326
          DO 325 K = 1,NT
              DO 324 NP1 = MP1,NDO1,2
                  DO 323 I = 1,IMM1
                      VTO(I,2*MP1-2,K) = VTO(I,2*MP1-2,K) -
     +                                   CI(MP1,NP1,K)*WB(I,NP1,IW)
                      VTO(I,2*MP1-1,K) = VTO(I,2*MP1-1,K) +
     +                                   CR(MP1,NP1,K)*WB(I,NP1,IW)
                      WTE(I,2*MP1-2,K) = WTE(I,2*MP1-2,K) -
     +                                   CR(MP1,NP1,K)*VB(I,NP1,IV)
                      WTE(I,2*MP1-1,K) = WTE(I,2*MP1-1,K) -
     +                                   CI(MP1,NP1,K)*VB(I,NP1,IV)
  323             CONTINUE
                  IF (MLAT.EQ.0) GO TO 324
                  WTE(IMID,2*MP1-2,K) = WTE(IMID,2*MP1-2,K) -
     +                                  CR(MP1,NP1,K)*VB(IMID,NP1,IV)
                  WTE(IMID,2*MP1-1,K) = WTE(IMID,2*MP1-1,K) -
     +                                  CI(MP1,NP1,K)*VB(IMID,NP1,IV)
  324         CONTINUE
  325     CONTINUE
  326     IF (MP2.GT.NDO2) GO TO 330
          DO 329 K = 1,NT
              DO 328 NP1 = MP2,NDO2,2
                  DO 327 I = 1,IMM1
                      VTO(I,2*MP1-2,K) = VTO(I,2*MP1-2,K) +
     +                                   BR(MP1,NP1,K)*VB(I,NP1,IV)
                      VTO(I,2*MP1-1,K) = VTO(I,2*MP1-1,K) +
     +                                   BI(MP1,NP1,K)*VB(I,NP1,IV)
                      WTE(I,2*MP1-2,K) = WTE(I,2*MP1-2,K) -
     +                                   BI(MP1,NP1,K)*WB(I,NP1,IW)
                      WTE(I,2*MP1-1,K) = WTE(I,2*MP1-1,K) +
     +                                   BR(MP1,NP1,K)*WB(I,NP1,IW)
  327             CONTINUE
                  IF (MLAT.EQ.0) GO TO 328
                  WTE(IMID,2*MP1-2,K) = WTE(IMID,2*MP1-2,K) -
     +                                  BI(MP1,NP1,K)*WB(IMID,NP1,IW)
                  WTE(IMID,2*MP1-1,K) = WTE(IMID,2*MP1-1,K) +
     +                                  BR(MP1,NP1,K)*WB(IMID,NP1,IW)
  328         CONTINUE
  329     CONTINUE
  330 CONTINUE
      GO TO 950
c
c     case ityp=4   v odd,  w even, and both cr and ci equal zero
c
  400 CALL DVBIN(1,NLAT,NLON,0,VB,IV,WVBIN)
c
c     case m = 0
c
      DO 415 K = 1,NT
          DO 415 NP1 = 2,NDO2,2
              DO 415 I = 1,IMM1
                  VTO(I,1,K) = VTO(I,1,K) + BR(1,NP1,K)*VB(I,NP1,IV)
  415 CONTINUE
c
c     case m = 1 through nlat-1
c
      IF (MMAX.LT.2) GO TO 950
      DO 430 MP1 = 2,MMAX
          M = MP1 - 1
          MP2 = MP1 + 1
          CALL DVBIN(1,NLAT,NLON,M,VB,IV,WVBIN)
          CALL DWBIN(1,NLAT,NLON,M,WB,IW,WWBIN)
          IF (MP2.GT.NDO2) GO TO 430
          DO 429 K = 1,NT
              DO 428 NP1 = MP2,NDO2,2
                  DO 427 I = 1,IMM1
                      VTO(I,2*MP1-2,K) = VTO(I,2*MP1-2,K) +
     +                                   BR(MP1,NP1,K)*VB(I,NP1,IV)
                      VTO(I,2*MP1-1,K) = VTO(I,2*MP1-1,K) +
     +                                   BI(MP1,NP1,K)*VB(I,NP1,IV)
                      WTE(I,2*MP1-2,K) = WTE(I,2*MP1-2,K) -
     +                                   BI(MP1,NP1,K)*WB(I,NP1,IW)
                      WTE(I,2*MP1-1,K) = WTE(I,2*MP1-1,K) +
     +                                   BR(MP1,NP1,K)*WB(I,NP1,IW)
  427             CONTINUE
                  IF (MLAT.EQ.0) GO TO 428
                  WTE(IMID,2*MP1-2,K) = WTE(IMID,2*MP1-2,K) -
     +                                  BI(MP1,NP1,K)*WB(IMID,NP1,IW)
                  WTE(IMID,2*MP1-1,K) = WTE(IMID,2*MP1-1,K) +
     +                                  BR(MP1,NP1,K)*WB(IMID,NP1,IW)
  428         CONTINUE
  429     CONTINUE
  430 CONTINUE
      GO TO 950
c
c     case ityp=5   v odd,  w even,     br and bi equal zero
c
  500 CALL DVBIN(2,NLAT,NLON,0,VB,IV,WVBIN)
c
c     case m = 0
c
      DO 516 K = 1,NT
          DO 516 NP1 = 3,NDO1,2
              DO 516 I = 1,IMID
                  WTE(I,1,K) = WTE(I,1,K) - CR(1,NP1,K)*VB(I,NP1,IV)
  516 CONTINUE
c
c     case m = 1 through nlat-1
c
      IF (MMAX.LT.2) GO TO 950
      DO 530 MP1 = 2,MMAX
          M = MP1 - 1
          MP2 = MP1 + 1
          CALL DVBIN(2,NLAT,NLON,M,VB,IV,WVBIN)
          CALL DWBIN(2,NLAT,NLON,M,WB,IW,WWBIN)
          IF (MP1.GT.NDO1) GO TO 530
          DO 525 K = 1,NT
              DO 524 NP1 = MP1,NDO1,2
                  DO 523 I = 1,IMM1
                      VTO(I,2*MP1-2,K) = VTO(I,2*MP1-2,K) -
     +                                   CI(MP1,NP1,K)*WB(I,NP1,IW)
                      VTO(I,2*MP1-1,K) = VTO(I,2*MP1-1,K) +
     +                                   CR(MP1,NP1,K)*WB(I,NP1,IW)
                      WTE(I,2*MP1-2,K) = WTE(I,2*MP1-2,K) -
     +                                   CR(MP1,NP1,K)*VB(I,NP1,IV)
                      WTE(I,2*MP1-1,K) = WTE(I,2*MP1-1,K) -
     +                                   CI(MP1,NP1,K)*VB(I,NP1,IV)
  523             CONTINUE
                  IF (MLAT.EQ.0) GO TO 524
                  WTE(IMID,2*MP1-2,K) = WTE(IMID,2*MP1-2,K) -
     +                                  CR(MP1,NP1,K)*VB(IMID,NP1,IV)
                  WTE(IMID,2*MP1-1,K) = WTE(IMID,2*MP1-1,K) -
     +                                  CI(MP1,NP1,K)*VB(IMID,NP1,IV)
  524         CONTINUE
  525     CONTINUE
  530 CONTINUE
      GO TO 950
c
c     case ityp=6   v even  ,  w odd
c
  600 CALL DVBIN(0,NLAT,NLON,0,VB,IV,WVBIN)
c
c     case m = 0
c
      DO 615 K = 1,NT
          DO 615 NP1 = 2,NDO2,2
              DO 615 I = 1,IMM1
                  WTO(I,1,K) = WTO(I,1,K) - CR(1,NP1,K)*VB(I,NP1,IV)
  615 CONTINUE
      DO 616 K = 1,NT
          DO 616 NP1 = 3,NDO1,2
              DO 616 I = 1,IMID
                  VTE(I,1,K) = VTE(I,1,K) + BR(1,NP1,K)*VB(I,NP1,IV)
  616 CONTINUE
c
c     case m = 1 through nlat-1
c
      IF (MMAX.LT.2) GO TO 950
      DO 630 MP1 = 2,MMAX
          M = MP1 - 1
          MP2 = MP1 + 1
          CALL DVBIN(0,NLAT,NLON,M,VB,IV,WVBIN)
          CALL DWBIN(0,NLAT,NLON,M,WB,IW,WWBIN)
          IF (MP1.GT.NDO1) GO TO 626
          DO 625 K = 1,NT
              DO 624 NP1 = MP1,NDO1,2
                  DO 623 I = 1,IMM1
                      VTE(I,2*MP1-2,K) = VTE(I,2*MP1-2,K) +
     +                                   BR(MP1,NP1,K)*VB(I,NP1,IV)
                      VTE(I,2*MP1-1,K) = VTE(I,2*MP1-1,K) +
     +                                   BI(MP1,NP1,K)*VB(I,NP1,IV)
                      WTO(I,2*MP1-2,K) = WTO(I,2*MP1-2,K) -
     +                                   BI(MP1,NP1,K)*WB(I,NP1,IW)
                      WTO(I,2*MP1-1,K) = WTO(I,2*MP1-1,K) +
     +                                   BR(MP1,NP1,K)*WB(I,NP1,IW)
  623             CONTINUE
                  IF (MLAT.EQ.0) GO TO 624
                  VTE(IMID,2*MP1-2,K) = VTE(IMID,2*MP1-2,K) +
     +                                  BR(MP1,NP1,K)*VB(IMID,NP1,IV)
                  VTE(IMID,2*MP1-1,K) = VTE(IMID,2*MP1-1,K) +
     +                                  BI(MP1,NP1,K)*VB(IMID,NP1,IV)
  624         CONTINUE
  625     CONTINUE
  626     IF (MP2.GT.NDO2) GO TO 630
          DO 629 K = 1,NT
              DO 628 NP1 = MP2,NDO2,2
                  DO 627 I = 1,IMM1
                      VTE(I,2*MP1-2,K) = VTE(I,2*MP1-2,K) -
     +                                   CI(MP1,NP1,K)*WB(I,NP1,IW)
                      VTE(I,2*MP1-1,K) = VTE(I,2*MP1-1,K) +
     +                                   CR(MP1,NP1,K)*WB(I,NP1,IW)
                      WTO(I,2*MP1-2,K) = WTO(I,2*MP1-2,K) -
     +                                   CR(MP1,NP1,K)*VB(I,NP1,IV)
                      WTO(I,2*MP1-1,K) = WTO(I,2*MP1-1,K) -
     +                                   CI(MP1,NP1,K)*VB(I,NP1,IV)
  627             CONTINUE
                  IF (MLAT.EQ.0) GO TO 628
                  VTE(IMID,2*MP1-2,K) = VTE(IMID,2*MP1-2,K) -
     +                                  CI(MP1,NP1,K)*WB(IMID,NP1,IW)
                  VTE(IMID,2*MP1-1,K) = VTE(IMID,2*MP1-1,K) +
     +                                  CR(MP1,NP1,K)*WB(IMID,NP1,IW)
  628         CONTINUE
  629     CONTINUE
  630 CONTINUE
      GO TO 950
c
c     case ityp=7   v even, w odd   cr and ci equal zero
c
  700 CALL DVBIN(2,NLAT,NLON,0,VB,IV,WVBIN)
c
c     case m = 0
c
      DO 716 K = 1,NT
          DO 716 NP1 = 3,NDO1,2
              DO 716 I = 1,IMID
                  VTE(I,1,K) = VTE(I,1,K) + BR(1,NP1,K)*VB(I,NP1,IV)
  716 CONTINUE
c
c     case m = 1 through nlat-1
c
      IF (MMAX.LT.2) GO TO 950
      DO 730 MP1 = 2,MMAX
          M = MP1 - 1
          MP2 = MP1 + 1
          CALL DVBIN(2,NLAT,NLON,M,VB,IV,WVBIN)
          CALL DWBIN(2,NLAT,NLON,M,WB,IW,WWBIN)
          IF (MP1.GT.NDO1) GO TO 730
          DO 725 K = 1,NT
              DO 724 NP1 = MP1,NDO1,2
                  DO 723 I = 1,IMM1
                      VTE(I,2*MP1-2,K) = VTE(I,2*MP1-2,K) +
     +                                   BR(MP1,NP1,K)*VB(I,NP1,IV)
                      VTE(I,2*MP1-1,K) = VTE(I,2*MP1-1,K) +
     +                                   BI(MP1,NP1,K)*VB(I,NP1,IV)
                      WTO(I,2*MP1-2,K) = WTO(I,2*MP1-2,K) -
     +                                   BI(MP1,NP1,K)*WB(I,NP1,IW)
                      WTO(I,2*MP1-1,K) = WTO(I,2*MP1-1,K) +
     +                                   BR(MP1,NP1,K)*WB(I,NP1,IW)
  723             CONTINUE
                  IF (MLAT.EQ.0) GO TO 724
                  VTE(IMID,2*MP1-2,K) = VTE(IMID,2*MP1-2,K) +
     +                                  BR(MP1,NP1,K)*VB(IMID,NP1,IV)
                  VTE(IMID,2*MP1-1,K) = VTE(IMID,2*MP1-1,K) +
     +                                  BI(MP1,NP1,K)*VB(IMID,NP1,IV)
  724         CONTINUE
  725     CONTINUE
  730 CONTINUE
      GO TO 950
c
c     case ityp=8   v even,  w odd   br and bi equal zero
c
  800 CALL DVBIN(1,NLAT,NLON,0,VB,IV,WVBIN)
c
c     case m = 0
c
      DO 815 K = 1,NT
          DO 815 NP1 = 2,NDO2,2
              DO 815 I = 1,IMM1
                  WTO(I,1,K) = WTO(I,1,K) - CR(1,NP1,K)*VB(I,NP1,IV)
  815 CONTINUE
c
c     case m = 1 through nlat-1
c
      IF (MMAX.LT.2) GO TO 950
      DO 830 MP1 = 2,MMAX
          M = MP1 - 1
          MP2 = MP1 + 1
          CALL DVBIN(1,NLAT,NLON,M,VB,IV,WVBIN)
          CALL DWBIN(1,NLAT,NLON,M,WB,IW,WWBIN)
          IF (MP2.GT.NDO2) GO TO 830
          DO 829 K = 1,NT
              DO 828 NP1 = MP2,NDO2,2
                  DO 827 I = 1,IMM1
                      VTE(I,2*MP1-2,K) = VTE(I,2*MP1-2,K) -
     +                                   CI(MP1,NP1,K)*WB(I,NP1,IW)
                      VTE(I,2*MP1-1,K) = VTE(I,2*MP1-1,K) +
     +                                   CR(MP1,NP1,K)*WB(I,NP1,IW)
                      WTO(I,2*MP1-2,K) = WTO(I,2*MP1-2,K) -
     +                                   CR(MP1,NP1,K)*VB(I,NP1,IV)
                      WTO(I,2*MP1-1,K) = WTO(I,2*MP1-1,K) -
     +                                   CI(MP1,NP1,K)*VB(I,NP1,IV)
  827             CONTINUE
                  IF (MLAT.EQ.0) GO TO 828
                  VTE(IMID,2*MP1-2,K) = VTE(IMID,2*MP1-2,K) -
     +                                  CI(MP1,NP1,K)*WB(IMID,NP1,IW)
                  VTE(IMID,2*MP1-1,K) = VTE(IMID,2*MP1-1,K) +
     +                                  CR(MP1,NP1,K)*WB(IMID,NP1,IW)
  828         CONTINUE
  829     CONTINUE
  830 CONTINUE
  950 DO 14 K = 1,NT
          CALL DHRFFTB(IDV,NLON,VTE(1,1,K),IDV,WRFFT,VB)
          CALL DHRFFTB(IDV,NLON,WTE(1,1,K),IDV,WRFFT,VB)
   14 CONTINUE
      IF (ITYP.GT.2) GO TO 12
      DO 60 K = 1,NT
          DO 60 J = 1,NLON
              DO 60 I = 1,IMM1
                  VT(I,J,K) = .5D0* (VTE(I,J,K)+VTO(I,J,K))
                  WT(I,J,K) = .5D0* (WTE(I,J,K)+WTO(I,J,K))
                  VT(NLP1-I,J,K) = .5D0* (VTE(I,J,K)-VTO(I,J,K))
                  WT(NLP1-I,J,K) = .5D0* (WTE(I,J,K)-WTO(I,J,K))
   60 CONTINUE
      GO TO 13
   12 DO 11 K = 1,NT
          DO 11 J = 1,NLON
              DO 11 I = 1,IMM1
                  VT(I,J,K) = .5D0*VTE(I,J,K)
                  WT(I,J,K) = .5D0*WTE(I,J,K)
   11 CONTINUE
   13 IF (MLAT.EQ.0) RETURN
      DO 65 K = 1,NT
          DO 65 J = 1,NLON
              VT(IMID,J,K) = .5D0*VTE(IMID,J,K)
              WT(IMID,J,K) = .5D0*WTE(IMID,J,K)
   65 CONTINUE
      RETURN
      END
      SUBROUTINE DVTSECI(NLAT,NLON,WVTS,LWVTS,DWORK,LDWORK,IERROR)
      DOUBLE PRECISION WVTS
c
      DIMENSION WVTS(LWVTS)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION DWORK(LDWORK)

      IERROR = 1
      IF (NLAT.LT.3) RETURN
      IERROR = 2
      IF (NLON.LT.1) RETURN
      IERROR = 3
      IMID = (NLAT+1)/2
      LZZ1 = 2*NLAT*IMID
      MMAX = MIN0(NLAT, (NLON+1)/2)
      LABC = 3* (MAX0(MMAX-2,0)* (NLAT+NLAT-MMAX-1))/2
      IF (LWVTS.LT.2* (LZZ1+LABC)+NLON+15) RETURN
      IERROR = 4
      IF (LDWORK.LT.2*NLAT+2) RETURN
      IERROR = 0
      CALL DVTINIT(NLAT,NLON,WVTS,DWORK)
      LWVBIN = LZZ1 + LABC
      IW1 = LWVBIN + 1
      CALL DWTINIT(NLAT,NLON,WVTS(IW1),DWORK)
      IW2 = IW1 + LWVBIN
      CALL DHRFFTI(NLON,WVTS(IW2))
      RETURN
      END

C
C       $Id: sh3val.f,v 1.5 2008-07-27 03:10:13 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      FUNCTION SH3VAL (PX,PY,PZ,N,X,Y,Z,F,NR,LCELL,LNEXT,
     +                 XYZMIN,XYZDEL,RMAX,RSQ,A)
      INTEGER N, NR, LCELL(NR,NR,NR), LNEXT(N)
      REAL    PX, PY, PZ, X(N), Y(N), Z(N), F(N), XYZMIN(3),
     +        XYZDEL(3), RMAX, RSQ(N), A(9,N)
C
C***********************************************************
C
C                                               ROBERT RENKA
C                                       UNIV. OF NORTH TEXAS
C                                             (817) 565-2767
C                                                   10/28/87
C
C  This function returns the value Q(PX,PY,PZ) where Q is
C  the weighted sum of quadratic nodal functions defined in
C  subroutine SHQSHEP.  SH3GRD may be called to compute a
C  gradient of Q along with the value, and/or to test for
C  errors.
C
C  ON INPUT --
C
C    PX,PY,PZ = Cartesian coordinates of the point P at
C               which Q is to be evaluated.
C
C    N = Number of nodes and data values defining Q.
C        N .GE. 10.
C
C    X,Y,Z,F = Arrays of length N containing the nodes
C              and data values interpolated by Q.
C
C    NR = Number of rows, columns, and planes in the cell
C         grid.  Refer to SHSTORE3.  NR .GE. 1.
C
C    LCELL = NR by NR by NR array of nodal indices associated
C            with cells.  Refer to SHSTORE3.
C
C    LNEXT = Array of length N containing next-node indices
C            Refer to SHSTORE3.
C
C    XYZMIN,XYZDEL = Arrays of length 3 containing minimum
C                    nodal coordinates and cell dimensions
C                    respectively.  XYZDEL elements must be 
C                    positive.  Refer to SHSTORE3.
C
C    RMAX = Square root of the largest element in RSQ --
C           maximum radius.
C
C    RSQ = Array of length N containing the squared radii
C          which enter into the weights defining Q.
C
C    A = 9 by N array containing the coefficients for the
C        nodal functions defining Q.
C
C  Input parameters are not altered by this function.  The
C  parameters other than PX, PY and PZ should be input unaltered
C  from their values on output from SHQSHEP.  This function
C  should not be called if a nonzero error flag was returned by 
C  SHQSHEP.
C
C  ON OUTPUT --
C
C    SH3VAL = function value Q(PX,PY,PZ) unless N, NR,
C             XYZDEL, or RMAX is invalid, in which case
C             no value is returned.
C
C  MODULES REQUIRED BY SH3VAL -- NONE
C
C  INTRINSIC FUNCTIONS CALLED BY SH3VAL -- IFIX, SQRT
C
C***********************************************************
C
      XP = PX
      YP = PY
      ZP = PZ
      XMIN = XYZMIN(1)
      YMIN = XYZMIN(2)
      ZMIN = XYZMIN(3)
      DX = XYZDEL(1)
      DY = XYZDEL(2)
      DZ = XYZDEL(3)
      IF (N .LT. 10) THEN
        GO TO 30
      ELSEIF (NR .LT. 1) THEN
        GO TO 31
      ELSEIF (DX .LE. 0.) THEN
        GO TO 32
      ELSEIF (DY .LE. 0.) THEN
        GO TO 33
      ELSEIF (DZ .LE. 0.) THEN
        GO TO 34
      ELSEIF (RMAX .LT. 0.) THEN
        GO TO 35
      ENDIF
C
C  Set IMIN, IMAX, JMIN, JMAX, KMIN, and KMAX to cell indices
C  defining the range of the search for nodes whose radii
C  include P.  The cells which must be searched are those
C  intersected by (or contained in) a sphere of radius RMAX
C  centered at P.
C
      IMIN = IFIX((XP-XMIN-RMAX)/DX) + 1
      IMAX = IFIX((XP-XMIN+RMAX)/DX) + 1
      IF (IMIN .LT. 1) IMIN = 1
      IF (IMAX .GT. NR) IMAX = NR
      JMIN = IFIX((YP-YMIN-RMAX)/DY) + 1
      JMAX = IFIX((YP-YMIN+RMAX)/DY) + 1
      IF (JMIN .LT. 1) JMIN = 1
      IF (JMAX .GT. NR) JMAX = NR
      KMIN = IFIX((ZP-ZMIN-RMAX)/DZ) + 1
      KMAX = IFIX((ZP-ZMIN+RMAX)/DZ) + 1
      IF (KMIN .LT. 1) KMIN = 1
      IF (KMAX .GT. NR) KMAX = NR
C
C  The following is a test for no cells within the sphere
C  of radius RMAX.
C
      IF (IMIN .GT. IMAX  .OR.  JMIN .GT. JMAX  .OR.
     .    KMIN .GT. KMAX) GO TO 5
C
C  Accumulate weight values in SW and weighted nodal function
C  values in SWQ.  The weights are W(L) = ((R-D)+/(R*D))**2
C  for R**2 = RSQ(L) and D = distance between P and node L.
C
      SW = 0.
      SWQ = 0.
C
C  Outer loop on cells (I,J,K).
C
      DO 3 K = KMIN,KMAX
        DO 3 J = JMIN,JMAX
          DO 3 I = IMIN,IMAX
            L = LCELL(I,J,K)
            IF (L .EQ. 0) GO TO 3
C
C  Inner loop on nodes L.
C
    1       DELX = XP - X(L)
            DELY = YP - Y(L)
            DELZ = ZP - Z(L)
            DXSQ = DELX*DELX
            DYSQ = DELY*DELY
            DZSQ = DELZ*DELZ
            DS = DXSQ + DYSQ + DZSQ
            RS = RSQ(L)
            IF (DS .GE. RS) GO TO 2
            IF (DS .EQ. 0.) GO TO 4
            RDS = RS*DS
            RD = SQRT(RDS)
            W = (RS+DS-RD-RD)/RDS
            SW = SW + W
            SWQ = SWQ + W*( A(1,L)*DXSQ + A(2,L)*DELX*DELY +
     +                      A(3,L)*DYSQ + A(4,L)*DELX*DELZ +
     +                      A(5,L)*DELY*DELZ + A(6,L)*DZSQ +
     +                      A(7,L)*DELX + A(8,L)*DELY +
     +                      A(9,L)*DELZ + F(L) )
C
C  Bottom of loop on nodes in cell (I,J,K).
C
    2       LP = L
            L = LNEXT(LP)
            IF (L .NE. LP) GO TO 1
    3       CONTINUE
C
C  SW = 0 iff P is not within the radius R(L) for any node L.
C
      IF (SW .EQ. 0.) GO TO 5
      SH3VAL = SWQ/SW
      RETURN
C
C  (PX,PY,PZ) = (X(L),Y(L),Z(L))
C
    4 SH3VAL = F(L)
      RETURN
C
C  All weights are 0 at P.
C
    5 SH3VAL = 0.
      RETURN
C
C  Invalid input parameter.
C
   30 CONTINUE
      CALL SHERR (1,'SH3VAL - number of input data must be > 9',41)
      SH3VAL = 0.
      RETURN
   31 CONTINUE
      CALL SHERR (7,'SH3VAL - cell grid dimensions must be positive',
     +            46)
      SH3VAL = 0.
      RETURN
   32 CONTINUE
      CALL SHERR (10,'SH3VAL - at least two points must have different X
     + coordinates',62)
      SH3VAL = 0.
      RETURN
   33 CONTINUE
      CALL SHERR (11,'SH3VAL - at least two points must have different Y
     + coordinates',62)
      SH3VAL = 0.
      RETURN
   34 CONTINUE
      CALL SHERR (12,'SH3VAL - at least two points must have different Z
     + coordinates',62)
      SH3VAL = 0.
      RETURN
   35 CONTINUE
      CALL SHERR (14,
     +'SH3GRD - negative search radius in calculating least squares fit'
     +           ,64)
      SH3VAL = 0.
      RETURN
      END

c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by UCAR                 .
c  .                                                             .
c  .       University Corporation for Atmospheric Research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                         SPHEREPACK                       .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c
c ... file sphcom.f
c
c     this file must be loaded with all driver level files
c     in spherepack3.0.  it includes undocumented subroutines
c     called by some or all of the drivers
c
      SUBROUTINE DDNLFK(M,N,CP)
C*PT*WARNING* Already double-precision
c
c     cp requires n/2+1 double precision locations
c
      DOUBLE PRECISION CP,FNUM,FDEN,FNMH,A1,B1,C1,CP2,FNNP1,FNMSQ,FK,T1,
     +                 T2,PM1,SC10,SC20,SC40
      DIMENSION CP(1)
C*PT*WARNING* Constant already double-precision
      PARAMETER (SC10=1024.d0)
      PARAMETER (SC20=SC10*SC10)
      PARAMETER (SC40=SC20*SC20)
c
      CP(1) = 0.D0
      MA = IABS(M)
      IF (MA.GT.N) RETURN
      IF (N-1) 2,3,5
C*PT*WARNING* Constant already double-precision
    2 CP(1) = DSQRT(2.d0)
      RETURN
    3 IF (MA.NE.0) GO TO 4
C*PT*WARNING* Constant already double-precision
      CP(1) = DSQRT(1.5d0)
      RETURN
C*PT*WARNING* Constant already double-precision
    4 CP(1) = DSQRT(.75d0)
      IF (M.EQ.-1) CP(1) = -CP(1)
      RETURN
    5 IF (MOD(N+MA,2).NE.0) GO TO 10
      NMMS2 = (N-MA)/2
      FNUM = N + MA + 1
      FNMH = N - MA + 1
C*PT*WARNING* Constant already double-precision
      PM1 = 1.d0
      GO TO 15
   10 NMMS2 = (N-MA-1)/2
      FNUM = N + MA + 2
      FNMH = N - MA + 2
C*PT*WARNING* Constant already double-precision
      PM1 = -1.d0
C*PT*WARNING* Constant already double-precision
c      t1 = 1.
c      t1 = 2.d0**(n-1)
c      t1 = 1.d0/t1
   15 T1 = 1.d0/SC20
      NEX = 20
C*PT*WARNING* Constant already double-precision
      FDEN = 2.d0
      IF (NMMS2.LT.1) GO TO 20
      DO 18 I = 1,NMMS2
          T1 = FNUM*T1/FDEN
          IF (T1.GT.SC20) THEN
              T1 = T1/SC40
              NEX = NEX + 40
          END IF
          FNUM = FNUM + 2.D0
          FDEN = FDEN + 2.D0
   18 CONTINUE
C*PT*WARNING* Constant already double-precision
   20 T1 = T1/2.d0** (N-1-NEX)
      IF (MOD(MA/2,2).NE.0) T1 = -T1
      T2 = 1.D0
      IF (MA.EQ.0) GO TO 26
      DO 25 I = 1,MA
          T2 = FNMH*T2/ (FNMH+PM1)
          FNMH = FNMH + 2.D0
   25 CONTINUE
C*PT*WARNING* Constant already double-precision
   26 CP2 = T1*DSQRT((N+.5d0)*T2)
      FNNP1 = N* (N+1)
C*PT*WARNING* Constant already double-precision
      FNMSQ = FNNP1 - 2.d0*MA*MA
      L = (N+1)/2
      IF (MOD(N,2).EQ.0 .AND. MOD(MA,2).EQ.0) L = L + 1
      CP(L) = CP2
      IF (M.GE.0) GO TO 29
      IF (MOD(MA,2).NE.0) CP(L) = -CP(L)
   29 IF (L.LE.1) RETURN
      FK = N
      A1 = (FK-2.D0)* (FK-1.D0) - FNNP1
      B1 = 2.D0* (FK*FK-FNMSQ)
      CP(L-1) = B1*CP(L)/A1
   30 L = L - 1
      IF (L.LE.1) RETURN
      FK = FK - 2.D0
      A1 = (FK-2.D0)* (FK-1.D0) - FNNP1
      B1 = -2.D0* (FK*FK-FNMSQ)
      C1 = (FK+1.D0)* (FK+2.D0) - FNNP1
      CP(L-1) = - (B1*CP(L)+C1*CP(L+1))/A1
      GO TO 30
      END
      SUBROUTINE DDNLFT(M,N,THETA,CP,PB)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION CP(*),PB,THETA,CDT,SDT,CTH,STH,CHH

      CDT = DCOS(THETA+THETA)
      SDT = DSIN(THETA+THETA)
      NMOD = MOD(N,2)
      MMOD = MOD(M,2)
      IF (NMOD) 1,1,2
    1 IF (MMOD) 3,3,4
c
c     n even, m even
c
    3 KDO = N/2
      PB = .5D0*CP(1)
      IF (N.EQ.0) RETURN
      CTH = CDT
      STH = SDT
      DO 170 K = 1,KDO
c     pb = pb+cp(k+1)*dcos(2*k*theta)
          PB = PB + CP(K+1)*CTH
          CHH = CDT*CTH - SDT*STH
          STH = SDT*CTH + CDT*STH
          CTH = CHH
  170 CONTINUE
      RETURN
c
c     n even, m odd
c
    4 KDO = N/2
      PB = 0.D0
      CTH = CDT
      STH = SDT
      DO 180 K = 1,KDO
c     pb = pb+cp(k)*dsin(2*k*theta)
          PB = PB + CP(K)*STH
          CHH = CDT*CTH - SDT*STH
          STH = SDT*CTH + CDT*STH
          CTH = CHH
  180 CONTINUE
      RETURN
    2 IF (MMOD) 13,13,14
c
c     n odd, m even
c
   13 KDO = (N+1)/2
      PB = 0.D0
      CTH = DCOS(THETA)
      STH = DSIN(THETA)
      DO 190 K = 1,KDO
c     pb = pb+cp(k)*dcos((2*k-1)*theta)
          PB = PB + CP(K)*CTH
          CHH = CDT*CTH - SDT*STH
          STH = SDT*CTH + CDT*STH
          CTH = CHH
  190 CONTINUE
      RETURN
c
c     n odd, m odd
c
   14 KDO = (N+1)/2
      PB = 0.D0
      CTH = DCOS(THETA)
      STH = DSIN(THETA)
      DO 200 K = 1,KDO
c     pb = pb+cp(k)*dsin((2*k-1)*theta)
          PB = PB + CP(K)*STH
          CHH = CDT*CTH - SDT*STH
          STH = SDT*CTH + CDT*STH
          CTH = CHH
  200 CONTINUE
      RETURN
      END
      SUBROUTINE DNLFTD(M,N,THETA,CP,PB)
c
c     computes the derivative of pmn(theta) with respect to theta
c
      DIMENSION CP(1)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION CP,PB,THETA,CDT,SDT,CTH,STH,CHH

      CDT = DCOS(THETA+THETA)
      SDT = DSIN(THETA+THETA)
      NMOD = MOD(N,2)
      MMOD = MOD(ABS(M),2)
      IF (NMOD) 1,1,2
    1 IF (MMOD) 3,3,4
c
c     n even, m even
c
    3 KDO = N/2
C*PT*WARNING* Constant already double-precision
      PB = 0.d0
      IF (N.EQ.0) RETURN
      CTH = CDT
      STH = SDT
      DO 170 K = 1,KDO
C*PT*WARNING* Constant already double-precision
c     pb = pb+cp(k+1)*dcos(2*k*theta)
          PB = PB - 2.d0*K*CP(K+1)*STH
          CHH = CDT*CTH - SDT*STH
          STH = SDT*CTH + CDT*STH
          CTH = CHH
  170 CONTINUE
      RETURN
c
c     n even, m odd
c
    4 KDO = N/2
      PB = 0.D0
      CTH = CDT
      STH = SDT
      DO 180 K = 1,KDO
C*PT*WARNING* Constant already double-precision
c     pb = pb+cp(k)*dsin(2*k*theta)
          PB = PB + 2.d0*K*CP(K)*CTH
          CHH = CDT*CTH - SDT*STH
          STH = SDT*CTH + CDT*STH
          CTH = CHH
  180 CONTINUE
      RETURN
    2 IF (MMOD) 13,13,14
c
c     n odd, m even
c
   13 KDO = (N+1)/2
      PB = 0.D0
      CTH = DCOS(THETA)
      STH = DSIN(THETA)
      DO 190 K = 1,KDO
C*PT*WARNING* Constant already double-precision
c     pb = pb+cp(k)*dcos((2*k-1)*theta)
          PB = PB - (2.d0*K-1)*CP(K)*STH
          CHH = CDT*CTH - SDT*STH
          STH = SDT*CTH + CDT*STH
          CTH = CHH
  190 CONTINUE
      RETURN
c
c     n odd, m odd
c
   14 KDO = (N+1)/2
      PB = 0.D0
      CTH = DCOS(THETA)
      STH = DSIN(THETA)
      DO 200 K = 1,KDO
C*PT*WARNING* Constant already double-precision
c     pb = pb+cp(k)*dsin((2*k-1)*theta)
          PB = PB + (2.d0*K-1)*CP(K)*CTH
          CHH = CDT*CTH - SDT*STH
          STH = SDT*CTH + CDT*STH
          CTH = CHH
  200 CONTINUE
      RETURN
      END
      SUBROUTINE DLEGIN(MODE,L,NLAT,M,W,PMN,KM)
      DOUBLE PRECISION W
      DOUBLE PRECISION PMN
c     this subroutine computes legendre polynomials for n=m,...,l-1
c     and  i=1,...,late (late=((nlat+mod(nlat,2))/2)gaussian grid
c     in pmn(n+1,i,km) using swarztrauber's recursion formula.
c     the vector w contains quantities precomputed in shigc.
c     legin must be called in the order m=0,1,...,l-1
c     (e.g., if m=10 is sought it must be preceded by calls with
c     m=0,1,2,...,9 in that order)
      DIMENSION W(1),PMN(1)
c     set size of pole to equator gaussian grid
      LATE = (NLAT+MOD(NLAT,2))/2
c     partition w (set pointers for p0n,p1n,abel,bbel,cbel,pmn)
      I1 = 1 + NLAT
      I2 = I1 + NLAT*LATE
      I3 = I2 + NLAT*LATE
      I4 = I3 + (2*NLAT-L)* (L-1)/2
      I5 = I4 + (2*NLAT-L)* (L-1)/2
      CALL DLEGIN1(MODE,L,NLAT,LATE,M,W(I1),W(I2),W(I3),W(I4),W(I5),PMN,
     +            KM)
      RETURN
      END
      SUBROUTINE DLEGIN1(MODE,L,NLAT,LATE,M,P0N,P1N,ABEL,BBEL,CBEL,PMN,
     +                  KM)
      DOUBLE PRECISION P0N
      DOUBLE PRECISION P1N
      DOUBLE PRECISION ABEL
      DOUBLE PRECISION BBEL
      DOUBLE PRECISION CBEL
      DOUBLE PRECISION PMN
      DIMENSION P0N(NLAT,LATE),P1N(NLAT,LATE)
      DIMENSION ABEL(1),BBEL(1),CBEL(1),PMN(NLAT,LATE,3)
      DATA KM0,KM1,KM2/1,2,3/
      SAVE KM0,KM1,KM2
c     define index function used in storing triangular
c     arrays for recursion coefficients (functions of (m,n))
c     for 2.le.m.le.n-1 and 2.le.n.le.l-1
      INDX(M,N) = (N-1)* (N-2)/2 + M - 1
c     for l.le.n.le.nlat and 2.le.m.le.l
      IMNDX(M,N) = L* (L-1)/2 + (N-L-1)* (L-1) + M - 1

c     set do loop indices for full or half sphere
      MS = M + 1
      NINC = 1
      IF (MODE.EQ.1) THEN
c     only compute pmn for n-m odd
          MS = M + 2
          NINC = 2
      ELSE IF (MODE.EQ.2) THEN
c     only compute pmn for n-m even
          MS = M + 1
          NINC = 2
      END IF


      IF (M.GT.1) THEN
          DO 100 NP1 = MS,NLAT,NINC
              N = NP1 - 1
              IMN = INDX(M,N)
              IF (N.GE.L) IMN = IMNDX(M,N)
              DO 100 I = 1,LATE
                  PMN(NP1,I,KM0) = ABEL(IMN)*PMN(N-1,I,KM2) +
     +                             BBEL(IMN)*PMN(N-1,I,KM0) -
     +                             CBEL(IMN)*PMN(NP1,I,KM2)
  100     CONTINUE

      ELSE IF (M.EQ.0) THEN
          DO 101 NP1 = MS,NLAT,NINC
              DO 101 I = 1,LATE
                  PMN(NP1,I,KM0) = P0N(NP1,I)
  101     CONTINUE

      ELSE IF (M.EQ.1) THEN
          DO 102 NP1 = MS,NLAT,NINC
              DO 102 I = 1,LATE
                  PMN(NP1,I,KM0) = P1N(NP1,I)
  102     CONTINUE
      END IF

c     permute column indices
c     km0,km1,km2 store m,m-1,m-2 columns
      KMT = KM0
      KM0 = KM2
      KM2 = KM1
      KM1 = KMT
c     set current m index in output param km
      KM = KMT
      RETURN
      END


      SUBROUTINE DZFIN(ISYM,NLAT,NLON,M,Z,I3,WZFIN)
      DOUBLE PRECISION Z
      DOUBLE PRECISION WZFIN
      DIMENSION Z(1),WZFIN(1)

      IMID = (NLAT+1)/2
      LIM = NLAT*IMID
      MMAX = MIN0(NLAT,NLON/2+1)
      LABC = ((MMAX-2)* (NLAT+NLAT-MMAX-1))/2
      IW1 = LIM + 1
      IW2 = IW1 + LIM
      IW3 = IW2 + LABC
      IW4 = IW3 + LABC
c
c     the length of wzfin is 2*lim+3*labc
c
      CALL DZFIN1(ISYM,NLAT,M,Z,IMID,I3,WZFIN,WZFIN(IW1),WZFIN(IW2),
     +           WZFIN(IW3),WZFIN(IW4))
      RETURN
      END
      SUBROUTINE DZFIN1(ISYM,NLAT,M,Z,IMID,I3,ZZ,Z1,A,B,C)
      DOUBLE PRECISION Z
      DOUBLE PRECISION ZZ
      DOUBLE PRECISION Z1
      DOUBLE PRECISION A
      DOUBLE PRECISION B
      DOUBLE PRECISION C
      DIMENSION Z(IMID,NLAT,3),ZZ(IMID,1),Z1(IMID,1),A(1),B(1),C(1)
      SAVE I1,I2

      IHOLD = I1
      I1 = I2
      I2 = I3
      I3 = IHOLD
      IF (M-1) 25,30,35
   25 I1 = 1
      I2 = 2
      I3 = 3
      DO 45 NP1 = 1,NLAT
          DO 45 I = 1,IMID
              Z(I,NP1,I3) = ZZ(I,NP1)
   45 CONTINUE
      RETURN
   30 DO 50 NP1 = 2,NLAT
          DO 50 I = 1,IMID
              Z(I,NP1,I3) = Z1(I,NP1)
   50 CONTINUE
      RETURN
   35 NS = ((M-2)* (NLAT+NLAT-M-1))/2 + 1
      IF (ISYM.EQ.1) GO TO 36
      DO 85 I = 1,IMID
          Z(I,M+1,I3) = A(NS)*Z(I,M-1,I1) - C(NS)*Z(I,M+1,I1)
   85 CONTINUE
   36 IF (M.EQ.NLAT-1) RETURN
      IF (ISYM.EQ.2) GO TO 71
      NS = NS + 1
      DO 70 I = 1,IMID
          Z(I,M+2,I3) = A(NS)*Z(I,M,I1) - C(NS)*Z(I,M+2,I1)
   70 CONTINUE
   71 NSTRT = M + 3
      IF (ISYM.EQ.1) NSTRT = M + 4
      IF (NSTRT.GT.NLAT) GO TO 80
      NSTP = 2
      IF (ISYM.EQ.0) NSTP = 1
      DO 75 NP1 = NSTRT,NLAT,NSTP
          NS = NS + NSTP
          DO 75 I = 1,IMID
              Z(I,NP1,I3) = A(NS)*Z(I,NP1-2,I1) + B(NS)*Z(I,NP1-2,I3) -
     +                      C(NS)*Z(I,NP1,I1)
   75 CONTINUE
   80 RETURN
      END
      SUBROUTINE DZFINIT(NLAT,NLON,WZFIN,DWORK)
      DOUBLE PRECISION WZFIN
      DIMENSION WZFIN(*)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION DWORK(*)

      IMID = (NLAT+1)/2
      IW1 = 2*NLAT*IMID + 1
c
c     the length of wzfin is 3*((l-3)*l+2)/2 + 2*l*imid
c     the length of dwork is nlat+2
c
      CALL DZFINI1(NLAT,NLON,IMID,WZFIN,WZFIN(IW1),DWORK,
     +             DWORK(NLAT/2+1))
      RETURN
      END
      SUBROUTINE DZFINI1(NLAT,NLON,IMID,Z,ABC,CZ,WORK)
      DOUBLE PRECISION Z
      DOUBLE PRECISION ABC
c
c     abc must have 3*((mmax-2)*(nlat+nlat-mmax-1))/2 locations
c     where mmax = min0(nlat,nlon/2+1)
c     cz and work must each have nlat+1 locations
c
      DIMENSION Z(IMID,NLAT,2),ABC(1)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION PI,DT,TH,ZH,CZ(*),WORK(*)
C*PT*WARNING* Constant already double-precision
      PI = 4.D0*DATAN(1.d0)
      DT = PI/ (NLAT-1)
      DO 160 MP1 = 1,2
          M = MP1 - 1
          DO 160 NP1 = MP1,NLAT
              N = NP1 - 1
              CALL DDNZFK(NLAT,M,N,CZ,WORK)
              DO 165 I = 1,IMID
                  TH = (I-1)*DT
                  CALL DDNZFT(NLAT,M,N,TH,CZ,ZH)
                  Z(I,NP1,MP1) = ZH
  165         CONTINUE
              Z(1,NP1,MP1) = .5D0*Z(1,NP1,MP1)
  160 CONTINUE
      CALL DRABCP(NLAT,NLON,ABC)
      RETURN
      END
      SUBROUTINE DDNZFK(NLAT,M,N,CZ,WORK)
c
c     dnzfk computes the coefficients in the trigonometric
c     expansion of the z functions that are used in spherical
c     harmonic analysis.
c
      DIMENSION CZ(1),WORK(1)
C*PT*WARNING* Already double-precision
c
c     cz and work must both have nlat/2+1 locations
c
      DOUBLE PRECISION SUM,SC1,T1,T2,WORK,CZ

      LC = (NLAT+1)/2
C*PT*WARNING* Constant already double-precision
      SC1 = 2.d0/DBLE(NLAT-1)
      CALL DDNLFK(M,N,WORK)
      NMOD = MOD(N,2)
      MMOD = MOD(M,2)
      IF (NMOD) 1,1,2
    1 IF (MMOD) 3,3,4
c
c     n even, m even
c
    3 KDO = N/2 + 1
      DO 5 IDX = 1,LC
          I = IDX + IDX - 2
C*PT*WARNING* Constant already double-precision
          SUM = WORK(1)/ (1.d0-I*I)
          IF (KDO.LT.2) GO TO 29
          DO 6 KP1 = 2,KDO
              K = KP1 - 1
C*PT*WARNING* Constant already double-precision
              T1 = 1.d0 - (K+K+I)**2
C*PT*WARNING* Constant already double-precision
              T2 = 1.d0 - (K+K-I)**2
    8         SUM = SUM + WORK(KP1)* (T1+T2)/ (T1*T2)
    6     CONTINUE
   29     CZ(IDX) = SC1*SUM
    5 CONTINUE
      RETURN
c
c     n even, m odd
c
    4 KDO = N/2
      DO 9 IDX = 1,LC
          I = IDX + IDX - 2
          SUM = 0.D0
          DO 101 K = 1,KDO
C*PT*WARNING* Constant already double-precision
              T1 = 1.d0 - (K+K+I)**2
C*PT*WARNING* Constant already double-precision
              T2 = 1.d0 - (K+K-I)**2
   12         SUM = SUM + WORK(K)* (T1-T2)/ (T1*T2)
  101     CONTINUE
          CZ(IDX) = SC1*SUM
    9 CONTINUE
      RETURN
    2 IF (MMOD) 13,13,14
c
c     n odd, m even
c
   13 KDO = (N+1)/2
      DO 15 IDX = 1,LC
          I = IDX + IDX - 1
          SUM = 0.D0
          DO 16 K = 1,KDO
C*PT*WARNING* Constant already double-precision
              T1 = 1.d0 - (K+K-1+I)**2
C*PT*WARNING* Constant already double-precision
              T2 = 1.d0 - (K+K-1-I)**2
   18         SUM = SUM + WORK(K)* (T1+T2)/ (T1*T2)
   16     CONTINUE
          CZ(IDX) = SC1*SUM
   15 CONTINUE
      RETURN
c
c     n odd, m odd
c
   14 KDO = (N+1)/2
      DO 19 IDX = 1,LC
          I = IDX + IDX - 3
          SUM = 0.D0
          DO 20 K = 1,KDO
C*PT*WARNING* Constant already double-precision
              T1 = 1.d0 - (K+K-1+I)**2
C*PT*WARNING* Constant already double-precision
              T2 = 1.d0 - (K+K-1-I)**2
   22         SUM = SUM + WORK(K)* (T1-T2)/ (T1*T2)
   20     CONTINUE
          CZ(IDX) = SC1*SUM
   19 CONTINUE
      RETURN
      END
      SUBROUTINE DDNZFT(NLAT,M,N,TH,CZ,ZH)
      DIMENSION CZ(1)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION CZ,ZH,TH,CDT,SDT,CTH,STH,CHH

      ZH = 0.D0
      CDT = DCOS(TH+TH)
      SDT = DSIN(TH+TH)
      LMOD = MOD(NLAT,2)
      MMOD = MOD(M,2)
      NMOD = MOD(N,2)
      IF (LMOD) 20,20,10
   10 LC = (NLAT+1)/2
      LQ = LC - 1
      LS = LC - 2
      IF (NMOD) 1,1,2
    1 IF (MMOD) 3,3,4
c
c     nlat odd n even m even
c
    3 ZH = .5D0* (CZ(1)+CZ(LC)*DCOS(2*LQ*TH))
      CTH = CDT
      STH = SDT
      DO 201 K = 2,LQ
c     zh = zh+cz(k)*dcos(2*(k-1)*th)
          ZH = ZH + CZ(K)*CTH
          CHH = CDT*CTH - SDT*STH
          STH = SDT*CTH + CDT*STH
          CTH = CHH
  201 CONTINUE
      RETURN
c
c     nlat odd n even m odd
c
    4 CTH = CDT
      STH = SDT
      DO 202 K = 1,LS
c     zh = zh+cz(k+1)*dsin(2*k*th)
          ZH = ZH + CZ(K+1)*STH
          CHH = CDT*CTH - SDT*STH
          STH = SDT*CTH + CDT*STH
          CTH = CHH
  202 CONTINUE
      RETURN
c
c     nlat odd n odd, m even
c
    2 IF (MMOD) 5,5,6
    5 CTH = DCOS(TH)
      STH = DSIN(TH)
      DO 203 K = 1,LQ
c     zh = zh+cz(k)*dcos((2*k-1)*th)
          ZH = ZH + CZ(K)*CTH
          CHH = CDT*CTH - SDT*STH
          STH = SDT*CTH + CDT*STH
          CTH = CHH
  203 CONTINUE
      RETURN
c
c     nlat odd n odd m odd
c
    6 CTH = DCOS(TH)
      STH = DSIN(TH)
      DO 204 K = 1,LQ
c     zh = zh+cz(k+1)*dsin((2*k-1)*th)
          ZH = ZH + CZ(K+1)*STH
          CHH = CDT*CTH - SDT*STH
          STH = SDT*CTH + CDT*STH
          CTH = CHH
  204 CONTINUE
      RETURN
   20 LC = NLAT/2
      LQ = LC - 1
      IF (NMOD) 30,30,80
   30 IF (MMOD) 40,40,60
c
c     nlat even n even m even
c
   40 ZH = .5D0*CZ(1)
      CTH = CDT
      STH = SDT
      DO 50 K = 2,LC
c     zh = zh+cz(k)*dcos(2*(k-1)*th)
          ZH = ZH + CZ(K)*CTH
          CHH = CDT*CTH - SDT*STH
          STH = SDT*CTH + CDT*STH
          CTH = CHH
   50 CONTINUE
      RETURN
c
c     nlat even n even m odd
c
   60 CTH = CDT
      STH = SDT
      DO 70 K = 1,LQ
c     zh = zh+cz(k+1)*dsin(2*k*th)
          ZH = ZH + CZ(K+1)*STH
          CHH = CDT*CTH - SDT*STH
          STH = SDT*CTH + CDT*STH
          CTH = CHH
   70 CONTINUE
      RETURN
c
c     nlat even n odd m even
c
   80 IF (MMOD) 90,90,110
   90 ZH = .5D0*CZ(LC)*DCOS((NLAT-1)*TH)
      CTH = DCOS(TH)
      STH = DSIN(TH)
      DO 100 K = 1,LQ
c     zh = zh+cz(k)*dcos((2*k-1)*th)
          ZH = ZH + CZ(K)*CTH
          CHH = CDT*CTH - SDT*STH
          STH = SDT*CTH + CDT*STH
          CTH = CHH
  100 CONTINUE
      RETURN
c
c     nlat even n odd m odd
c
  110 CTH = DCOS(TH)
      STH = DSIN(TH)
      DO 120 K = 1,LQ
c     zh = zh+cz(k+1)*dsin((2*k-1)*th)
          ZH = ZH + CZ(K+1)*STH
          CHH = CDT*CTH - SDT*STH
          STH = SDT*CTH + CDT*STH
          CTH = CHH
  120 CONTINUE
      RETURN
      END
      SUBROUTINE DALIN(ISYM,NLAT,NLON,M,P,I3,WALIN)
      DOUBLE PRECISION P
      DOUBLE PRECISION WALIN
      DIMENSION P(1),WALIN(1)

      IMID = (NLAT+1)/2
      LIM = NLAT*IMID
      MMAX = MIN0(NLAT,NLON/2+1)
      LABC = ((MMAX-2)* (NLAT+NLAT-MMAX-1))/2
      IW1 = LIM + 1
      IW2 = IW1 + LIM
      IW3 = IW2 + LABC
      IW4 = IW3 + LABC
c
c     the length of walin is ((5*l-7)*l+6)/2
c
      CALL DALIN1(ISYM,NLAT,M,P,IMID,I3,WALIN,WALIN(IW1),WALIN(IW2),
     +           WALIN(IW3),WALIN(IW4))
      RETURN
      END
      SUBROUTINE DALIN1(ISYM,NLAT,M,P,IMID,I3,PZ,P1,A,B,C)
      DOUBLE PRECISION P
      DOUBLE PRECISION PZ
      DOUBLE PRECISION P1
      DOUBLE PRECISION A
      DOUBLE PRECISION B
      DOUBLE PRECISION C
      DIMENSION P(IMID,NLAT,3),PZ(IMID,1),P1(IMID,1),A(1),B(1),C(1)
      SAVE I1,I2

      IHOLD = I1
      I1 = I2
      I2 = I3
      I3 = IHOLD
      IF (M-1) 25,30,35
   25 I1 = 1
      I2 = 2
      I3 = 3
      DO 45 NP1 = 1,NLAT
          DO 45 I = 1,IMID
              P(I,NP1,I3) = PZ(I,NP1)
   45 CONTINUE
      RETURN
   30 DO 50 NP1 = 2,NLAT
          DO 50 I = 1,IMID
              P(I,NP1,I3) = P1(I,NP1)
   50 CONTINUE
      RETURN
   35 NS = ((M-2)* (NLAT+NLAT-M-1))/2 + 1
      IF (ISYM.EQ.1) GO TO 36
      DO 85 I = 1,IMID
          P(I,M+1,I3) = A(NS)*P(I,M-1,I1) - C(NS)*P(I,M+1,I1)
   85 CONTINUE
   36 IF (M.EQ.NLAT-1) RETURN
      IF (ISYM.EQ.2) GO TO 71
      NS = NS + 1
      DO 70 I = 1,IMID
          P(I,M+2,I3) = A(NS)*P(I,M,I1) - C(NS)*P(I,M+2,I1)
   70 CONTINUE
   71 NSTRT = M + 3
      IF (ISYM.EQ.1) NSTRT = M + 4
      IF (NSTRT.GT.NLAT) GO TO 80
      NSTP = 2
      IF (ISYM.EQ.0) NSTP = 1
      DO 75 NP1 = NSTRT,NLAT,NSTP
          NS = NS + NSTP
          DO 75 I = 1,IMID
              P(I,NP1,I3) = A(NS)*P(I,NP1-2,I1) + B(NS)*P(I,NP1-2,I3) -
     +                      C(NS)*P(I,NP1,I1)
   75 CONTINUE
   80 RETURN
      END
      SUBROUTINE DALINIT(NLAT,NLON,WALIN,DWORK)
      DOUBLE PRECISION WALIN
      DIMENSION WALIN(*)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION DWORK(*)

      IMID = (NLAT+1)/2
      IW1 = 2*NLAT*IMID + 1
c
c     the length of walin is 3*((l-3)*l+2)/2 + 2*l*imid
c     the length of work is nlat+1
c
      CALL DALINI1(NLAT,NLON,IMID,WALIN,WALIN(IW1),DWORK)
      RETURN
      END
      SUBROUTINE DALINI1(NLAT,NLON,IMID,P,ABC,CP)
      DOUBLE PRECISION P
      DOUBLE PRECISION ABC
      DIMENSION P(IMID,NLAT,2),ABC(1),CP(1)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION PI,DT,TH,CP,PH
C*PT*WARNING* Constant already double-precision
      PI = 4.D0*DATAN(1.d0)
      DT = PI/ (NLAT-1)
      DO 160 MP1 = 1,2
          M = MP1 - 1
          DO 160 NP1 = MP1,NLAT
              N = NP1 - 1
              CALL DDNLFK(M,N,CP)
              DO 160 I = 1,IMID
                  TH = (I-1)*DT
                  CALL DDNLFT(M,N,TH,CP,PH)
                  P(I,NP1,MP1) = PH
  160 CONTINUE
      CALL DRABCP(NLAT,NLON,ABC)
      RETURN
      END
      SUBROUTINE DRABCP(NLAT,NLON,ABC)
      DOUBLE PRECISION ABC
c
c     subroutine rabcp computes the coefficients in the recurrence
c     relation for the associated legendre fuctions. array abc
c     must have 3*((mmax-2)*(nlat+nlat-mmax-1))/2 locations.
c
      DIMENSION ABC(1)

      MMAX = MIN0(NLAT,NLON/2+1)
      LABC = ((MMAX-2)* (NLAT+NLAT-MMAX-1))/2
      IW1 = LABC + 1
      IW2 = IW1 + LABC
      CALL DRABCP1(NLAT,NLON,ABC,ABC(IW1),ABC(IW2))
      RETURN
      END
      SUBROUTINE DRABCP1(NLAT,NLON,A,B,C)
      DOUBLE PRECISION A
      DOUBLE PRECISION B
      DOUBLE PRECISION C
      DOUBLE PRECISION FM
      DOUBLE PRECISION TM
      DOUBLE PRECISION TEMP
      DOUBLE PRECISION FN
      DOUBLE PRECISION TN
      DOUBLE PRECISION CN
      DOUBLE PRECISION FNPM
      DOUBLE PRECISION FNMM
c
c     coefficients a, b, and c for computing pbar(m,n,theta) are
c     stored in location ((m-2)*(nlat+nlat-m-1))/2+n+1
c
      DIMENSION A(1),B(1),C(1)

      MMAX = MIN0(NLAT,NLON/2+1)
      DO 215 MP1 = 3,MMAX
          M = MP1 - 1
          NS = ((M-2)* (NLAT+NLAT-M-1))/2 + 1
          FM = DBLE(M)
          TM = FM + FM
          TEMP = TM* (TM-1.D0)
          A(NS) = SQRT((TM+1.D0)* (TM-2.D0)/TEMP)
          C(NS) = SQRT(2.D0/TEMP)
          IF (M.EQ.NLAT-1) GO TO 215
          NS = NS + 1
          TEMP = TM* (TM+1.D0)
          A(NS) = SQRT((TM+3.D0)* (TM-2.D0)/TEMP)
          C(NS) = SQRT(6.D0/TEMP)
          MP3 = M + 3
          IF (MP3.GT.NLAT) GO TO 215
          DO 210 NP1 = MP3,NLAT
              N = NP1 - 1
              NS = NS + 1
              FN = DBLE(N)
              TN = FN + FN
              CN = (TN+1.D0)/ (TN-3.D0)
              FNPM = FN + FM
              FNMM = FN - FM
              TEMP = FNPM* (FNPM-1.D0)
              A(NS) = SQRT(CN* (FNPM-3.D0)* (FNPM-2.D0)/TEMP)
              B(NS) = SQRT(CN*FNMM* (FNMM-1.D0)/TEMP)
              C(NS) = SQRT((FNMM+1.D0)* (FNMM+2.D0)/TEMP)
  210     CONTINUE
  215 CONTINUE
      RETURN
      END
      SUBROUTINE DSEA1(NLAT,NLON,IMID,Z,IDZ,ZIN,WZFIN,DWORK)
      DOUBLE PRECISION Z
      DOUBLE PRECISION ZIN
      DOUBLE PRECISION WZFIN
      DIMENSION Z(IDZ,*),ZIN(IMID,NLAT,3),WZFIN(*)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION DWORK(*)

      CALL DZFINIT(NLAT,NLON,WZFIN,DWORK)
      MMAX = MIN0(NLAT,NLON/2+1)
      DO 33 MP1 = 1,MMAX
          M = MP1 - 1
          CALL DZFIN(0,NLAT,NLON,M,ZIN,I3,WZFIN)
          DO 33 NP1 = MP1,NLAT
              MN = M* (NLAT-1) - (M* (M-1))/2 + NP1
              DO 33 I = 1,IMID
                  Z(MN,I) = ZIN(I,NP1,I3)
   33 CONTINUE
      RETURN
      END
      SUBROUTINE DSES1(NLAT,NLON,IMID,P,PIN,WALIN,DWORK)
      DOUBLE PRECISION P
      DOUBLE PRECISION PIN
      DOUBLE PRECISION WALIN
      DIMENSION P(IMID,*),PIN(IMID,NLAT,3),WALIN(*)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION DWORK(*)

      CALL DALINIT(NLAT,NLON,WALIN,DWORK)
      MMAX = MIN0(NLAT,NLON/2+1)
      DO 10 MP1 = 1,MMAX
          M = MP1 - 1
          CALL DALIN(0,NLAT,NLON,M,PIN,I3,WALIN)
          DO 10 NP1 = MP1,NLAT
              MN = M* (NLAT-1) - (M* (M-1))/2 + NP1
              DO 10 I = 1,IMID
                  P(I,MN) = PIN(I,NP1,I3)
   10 CONTINUE
      RETURN
      END
      SUBROUTINE DZVINIT(NLAT,NLON,WZVIN,DWORK)
      DOUBLE PRECISION WZVIN
      DIMENSION WZVIN(1)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION DWORK(*)

      IMID = (NLAT+1)/2
      IW1 = 2*NLAT*IMID + 1
c
c     the length of wzvin is
c         2*nlat*imid +3*(max0(mmax-2,0)*(nlat+nlat-mmax-1))/2
c     the length of dwork is nlat+2
c
      CALL DZVINI1(NLAT,NLON,IMID,WZVIN,WZVIN(IW1),DWORK,
     +             DWORK(NLAT/2+2))
      RETURN
      END
      SUBROUTINE DZVINI1(NLAT,NLON,IMID,ZV,ABC,CZV,WORK)
      DOUBLE PRECISION ZV
      DOUBLE PRECISION ABC
c
c     abc must have 3*(max0(mmax-2,0)*(nlat+nlat-mmax-1))/2
c     locations where mmax = min0(nlat,(nlon+1)/2)
c     czv and work must each have nlat/2+1  locations
c
      DIMENSION ZV(IMID,NLAT,2),ABC(1)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION PI,DT,CZV(1),ZVH,TH,WORK(1)
C*PT*WARNING* Constant already double-precision
      PI = 4.D0*DATAN(1.d0)
      DT = PI/ (NLAT-1)
      MDO = MIN0(2,NLAT, (NLON+1)/2)
      DO 160 MP1 = 1,MDO
          M = MP1 - 1
          DO 160 NP1 = MP1,NLAT
              N = NP1 - 1
              CALL DDZVK(NLAT,M,N,CZV,WORK)
              DO 165 I = 1,IMID
                  TH = (I-1)*DT
                  CALL DDZVT(NLAT,M,N,TH,CZV,ZVH)
                  ZV(I,NP1,MP1) = ZVH
  165         CONTINUE
              ZV(1,NP1,MP1) = .5D0*ZV(1,NP1,MP1)
  160 CONTINUE
      CALL DRABCV(NLAT,NLON,ABC)
      RETURN
      END
      SUBROUTINE DZWINIT(NLAT,NLON,WZWIN,DWORK)
      DOUBLE PRECISION WZWIN
      DIMENSION WZWIN(1)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION DWORK(*)

      IMID = (NLAT+1)/2
      IW1 = 2*NLAT*IMID + 1
c
c     the length of wzvin is 2*nlat*imid+3*((nlat-3)*nlat+2)/2
c     the length of dwork is nlat+2
c
      CALL DZWINI1(NLAT,NLON,IMID,WZWIN,WZWIN(IW1),DWORK,
     +             DWORK(NLAT/2+2))
      RETURN
      END
      SUBROUTINE DZWINI1(NLAT,NLON,IMID,ZW,ABC,CZW,WORK)
      DOUBLE PRECISION ZW
      DOUBLE PRECISION ABC
c
c     abc must have 3*(max0(mmax-2,0)*(nlat+nlat-mmax-1))/2
c     locations where mmax = min0(nlat,(nlon+1)/2)
c     czw and work must each have nlat+1 locations
c
      DIMENSION ZW(IMID,NLAT,2),ABC(1)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION PI,DT,CZW(1),ZWH,TH,WORK(1)
C*PT*WARNING* Constant already double-precision
      PI = 4.D0*DATAN(1.d0)
      DT = PI/ (NLAT-1)
      MDO = MIN0(3,NLAT, (NLON+1)/2)
      IF (MDO.LT.2) RETURN
      DO 160 MP1 = 2,MDO
          M = MP1 - 1
          DO 160 NP1 = MP1,NLAT
              N = NP1 - 1
              CALL DDZWK(NLAT,M,N,CZW,WORK)
              DO 165 I = 1,IMID
                  TH = (I-1)*DT
                  CALL DDZWT(NLAT,M,N,TH,CZW,ZWH)
                  ZW(I,NP1,M) = ZWH
  165         CONTINUE
              ZW(1,NP1,M) = .5D0*ZW(1,NP1,M)
  160 CONTINUE
      CALL DRABCW(NLAT,NLON,ABC)
      RETURN
      END
      SUBROUTINE DZVIN(ITYP,NLAT,NLON,M,ZV,I3,WZVIN)
      DOUBLE PRECISION ZV
      DOUBLE PRECISION WZVIN
      DIMENSION ZV(1),WZVIN(1)

      IMID = (NLAT+1)/2
      LIM = NLAT*IMID
      MMAX = MIN0(NLAT, (NLON+1)/2)
      LABC = (MAX0(MMAX-2,0)* (NLAT+NLAT-MMAX-1))/2
      IW1 = LIM + 1
      IW2 = IW1 + LIM
      IW3 = IW2 + LABC
      IW4 = IW3 + LABC
c
c     the length of wzvin is 2*lim+3*labc
c
      CALL DZVIN1(ITYP,NLAT,M,ZV,IMID,I3,WZVIN,WZVIN(IW1),WZVIN(IW2),
     +           WZVIN(IW3),WZVIN(IW4))
      RETURN
      END
      SUBROUTINE DZVIN1(ITYP,NLAT,M,ZV,IMID,I3,ZVZ,ZV1,A,B,C)
      DOUBLE PRECISION ZV
      DOUBLE PRECISION ZVZ
      DOUBLE PRECISION ZV1
      DOUBLE PRECISION A
      DOUBLE PRECISION B
      DOUBLE PRECISION C
      DIMENSION ZV(IMID,NLAT,3),ZVZ(IMID,1),ZV1(IMID,1),A(1),B(1),C(1)
      SAVE I1,I2

      IHOLD = I1
      I1 = I2
      I2 = I3
      I3 = IHOLD
      IF (M-1) 25,30,35
   25 I1 = 1
      I2 = 2
      I3 = 3
      DO 45 NP1 = 1,NLAT
          DO 45 I = 1,IMID
              ZV(I,NP1,I3) = ZVZ(I,NP1)
   45 CONTINUE
      RETURN
   30 DO 50 NP1 = 2,NLAT
          DO 50 I = 1,IMID
              ZV(I,NP1,I3) = ZV1(I,NP1)
   50 CONTINUE
      RETURN
   35 NS = ((M-2)* (NLAT+NLAT-M-1))/2 + 1
      IF (ITYP.EQ.1) GO TO 36
      DO 85 I = 1,IMID
          ZV(I,M+1,I3) = A(NS)*ZV(I,M-1,I1) - C(NS)*ZV(I,M+1,I1)
   85 CONTINUE
   36 IF (M.EQ.NLAT-1) RETURN
      IF (ITYP.EQ.2) GO TO 71
      NS = NS + 1
      DO 70 I = 1,IMID
          ZV(I,M+2,I3) = A(NS)*ZV(I,M,I1) - C(NS)*ZV(I,M+2,I1)
   70 CONTINUE
   71 NSTRT = M + 3
      IF (ITYP.EQ.1) NSTRT = M + 4
      IF (NSTRT.GT.NLAT) GO TO 80
      NSTP = 2
      IF (ITYP.EQ.0) NSTP = 1
      DO 75 NP1 = NSTRT,NLAT,NSTP
          NS = NS + NSTP
          DO 75 I = 1,IMID
              ZV(I,NP1,I3) = A(NS)*ZV(I,NP1-2,I1) +
     +                       B(NS)*ZV(I,NP1-2,I3) - C(NS)*ZV(I,NP1,I1)
   75 CONTINUE
   80 RETURN
      END
      SUBROUTINE DZWIN(ITYP,NLAT,NLON,M,ZW,I3,WZWIN)
      DOUBLE PRECISION ZW
      DOUBLE PRECISION WZWIN
      DIMENSION ZW(1),WZWIN(1)

      IMID = (NLAT+1)/2
      LIM = NLAT*IMID
      MMAX = MIN0(NLAT, (NLON+1)/2)
      LABC = (MAX0(MMAX-2,0)* (NLAT+NLAT-MMAX-1))/2
      IW1 = LIM + 1
      IW2 = IW1 + LIM
      IW3 = IW2 + LABC
      IW4 = IW3 + LABC
c
c     the length of wzwin is 2*lim+3*labc
c
      CALL DZWIN1(ITYP,NLAT,M,ZW,IMID,I3,WZWIN,WZWIN(IW1),WZWIN(IW2),
     +           WZWIN(IW3),WZWIN(IW4))
      RETURN
      END
      SUBROUTINE DZWIN1(ITYP,NLAT,M,ZW,IMID,I3,ZW1,ZW2,A,B,C)
      DOUBLE PRECISION ZW
      DOUBLE PRECISION ZW1
      DOUBLE PRECISION ZW2
      DOUBLE PRECISION A
      DOUBLE PRECISION B
      DOUBLE PRECISION C
      DIMENSION ZW(IMID,NLAT,3),ZW1(IMID,1),ZW2(IMID,1),A(1),B(1),C(1)
      SAVE I1,I2

      IHOLD = I1
      I1 = I2
      I2 = I3
      I3 = IHOLD
      IF (M-2) 25,30,35
   25 I1 = 1
      I2 = 2
      I3 = 3
      DO 45 NP1 = 2,NLAT
          DO 45 I = 1,IMID
              ZW(I,NP1,I3) = ZW1(I,NP1)
   45 CONTINUE
      RETURN
   30 DO 50 NP1 = 3,NLAT
          DO 50 I = 1,IMID
              ZW(I,NP1,I3) = ZW2(I,NP1)
   50 CONTINUE
      RETURN
   35 NS = ((M-2)* (NLAT+NLAT-M-1))/2 + 1
      IF (ITYP.EQ.1) GO TO 36
      DO 85 I = 1,IMID
          ZW(I,M+1,I3) = A(NS)*ZW(I,M-1,I1) - C(NS)*ZW(I,M+1,I1)
   85 CONTINUE
   36 IF (M.EQ.NLAT-1) RETURN
      IF (ITYP.EQ.2) GO TO 71
      NS = NS + 1
      DO 70 I = 1,IMID
          ZW(I,M+2,I3) = A(NS)*ZW(I,M,I1) - C(NS)*ZW(I,M+2,I1)
   70 CONTINUE
   71 NSTRT = M + 3
      IF (ITYP.EQ.1) NSTRT = M + 4
      IF (NSTRT.GT.NLAT) GO TO 80
      NSTP = 2
      IF (ITYP.EQ.0) NSTP = 1
      DO 75 NP1 = NSTRT,NLAT,NSTP
          NS = NS + NSTP
          DO 75 I = 1,IMID
              ZW(I,NP1,I3) = A(NS)*ZW(I,NP1-2,I1) +
     +                       B(NS)*ZW(I,NP1-2,I3) - C(NS)*ZW(I,NP1,I1)
   75 CONTINUE
   80 RETURN
      END
      SUBROUTINE DVBINIT(NLAT,NLON,WVBIN,DWORK)
      DOUBLE PRECISION WVBIN
      DIMENSION WVBIN(1)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION DWORK(*)

      IMID = (NLAT+1)/2
      IW1 = 2*NLAT*IMID + 1
c
c     the length of wvbin is 2*nlat*imid+3*((nlat-3)*nlat+2)/2
c     the length of dwork is nlat+2
c
      CALL DVBINI1(NLAT,NLON,IMID,WVBIN,WVBIN(IW1),DWORK,
     +             DWORK(NLAT/2+2))
      RETURN
      END
      SUBROUTINE DVBINI1(NLAT,NLON,IMID,VB,ABC,CVB,WORK)
      DOUBLE PRECISION VB
      DOUBLE PRECISION ABC
c
c     abc must have 3*(max0(mmax-2,0)*(nlat+nlat-mmax-1))/2
c     locations where mmax = min0(nlat,(nlon+1)/2)
c     cvb and work must each have nlat+1 locations
c
      DIMENSION VB(IMID,NLAT,2),ABC(1)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION PI,DT,CVB(1),TH,VBH,WORK(1)
C*PT*WARNING* Constant already double-precision
      PI = 4.D0*DATAN(1.d0)
      DT = PI/ (NLAT-1)
      MDO = MIN0(2,NLAT, (NLON+1)/2)
      DO 160 MP1 = 1,MDO
          M = MP1 - 1
          DO 160 NP1 = MP1,NLAT
              N = NP1 - 1
              CALL DDVBK(M,N,CVB,WORK)
              DO 165 I = 1,IMID
                  TH = (I-1)*DT
                  CALL DDVBT(M,N,TH,CVB,VBH)
                  VB(I,NP1,MP1) = VBH
  165         CONTINUE
  160 CONTINUE
      CALL DRABCV(NLAT,NLON,ABC)
      RETURN
      END
      SUBROUTINE DWBINIT(NLAT,NLON,WWBIN,DWORK)
      DOUBLE PRECISION WWBIN
      DIMENSION WWBIN(1)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION DWORK(*)

      IMID = (NLAT+1)/2
      IW1 = 2*NLAT*IMID + 1
c
c     the length of wwbin is 2*nlat*imid+3*((nlat-3)*nlat+2)/2
c     the length of dwork is nlat+2
c
      CALL DWBINI1(NLAT,NLON,IMID,WWBIN,WWBIN(IW1),DWORK,
     +             DWORK(NLAT/2+2))
      RETURN
      END
      SUBROUTINE DWBINI1(NLAT,NLON,IMID,WB,ABC,CWB,WORK)
      DOUBLE PRECISION WB
      DOUBLE PRECISION ABC
c
c     abc must have 3*(max0(mmax-2,0)*(nlat+nlat-mmax-1))/2
c     locations where mmax = min0(nlat,(nlon+1)/2)
c     cwb and work must each have nlat/2+1 locations
c
      DIMENSION WB(IMID,NLAT,2),ABC(1)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION PI,DT,CWB(1),WBH,TH,WORK(1)
C*PT*WARNING* Constant already double-precision
      PI = 4.D0*DATAN(1.d0)
      DT = PI/ (NLAT-1)
      MDO = MIN0(3,NLAT, (NLON+1)/2)
      IF (MDO.LT.2) RETURN
      DO 160 MP1 = 2,MDO
          M = MP1 - 1
          DO 160 NP1 = MP1,NLAT
              N = NP1 - 1
              CALL DDWBK(M,N,CWB,WORK)
              DO 165 I = 1,IMID
                  TH = (I-1)*DT
                  CALL DDWBT(M,N,TH,CWB,WBH)
                  WB(I,NP1,M) = WBH
  165         CONTINUE
  160 CONTINUE
      CALL DRABCW(NLAT,NLON,ABC)
      RETURN
      END
      SUBROUTINE DVBIN(ITYP,NLAT,NLON,M,VB,I3,WVBIN)
      DOUBLE PRECISION VB
      DOUBLE PRECISION WVBIN
      DIMENSION VB(1),WVBIN(1)

      IMID = (NLAT+1)/2
      LIM = NLAT*IMID
      MMAX = MIN0(NLAT, (NLON+1)/2)
      LABC = (MAX0(MMAX-2,0)* (NLAT+NLAT-MMAX-1))/2
      IW1 = LIM + 1
      IW2 = IW1 + LIM
      IW3 = IW2 + LABC
      IW4 = IW3 + LABC
c
c     the length of wvbin is 2*lim+3*labc
c
      CALL DVBIN1(ITYP,NLAT,M,VB,IMID,I3,WVBIN,WVBIN(IW1),WVBIN(IW2),
     +           WVBIN(IW3),WVBIN(IW4))
      RETURN
      END
      SUBROUTINE DVBIN1(ITYP,NLAT,M,VB,IMID,I3,VBZ,VB1,A,B,C)
      DOUBLE PRECISION VB
      DOUBLE PRECISION VBZ
      DOUBLE PRECISION VB1
      DOUBLE PRECISION A
      DOUBLE PRECISION B
      DOUBLE PRECISION C
      DIMENSION VB(IMID,NLAT,3),VBZ(IMID,1),VB1(IMID,1),A(1),B(1),C(1)
      SAVE I1,I2

      IHOLD = I1
      I1 = I2
      I2 = I3
      I3 = IHOLD
      IF (M-1) 25,30,35
   25 I1 = 1
      I2 = 2
      I3 = 3
      DO 45 NP1 = 1,NLAT
          DO 45 I = 1,IMID
              VB(I,NP1,I3) = VBZ(I,NP1)
   45 CONTINUE
      RETURN
   30 DO 50 NP1 = 2,NLAT
          DO 50 I = 1,IMID
              VB(I,NP1,I3) = VB1(I,NP1)
   50 CONTINUE
      RETURN
   35 NS = ((M-2)* (NLAT+NLAT-M-1))/2 + 1
      IF (ITYP.EQ.1) GO TO 36
      DO 85 I = 1,IMID
          VB(I,M+1,I3) = A(NS)*VB(I,M-1,I1) - C(NS)*VB(I,M+1,I1)
   85 CONTINUE
   36 IF (M.EQ.NLAT-1) RETURN
      IF (ITYP.EQ.2) GO TO 71
      NS = NS + 1
      DO 70 I = 1,IMID
          VB(I,M+2,I3) = A(NS)*VB(I,M,I1) - C(NS)*VB(I,M+2,I1)
   70 CONTINUE
   71 NSTRT = M + 3
      IF (ITYP.EQ.1) NSTRT = M + 4
      IF (NSTRT.GT.NLAT) GO TO 80
      NSTP = 2
      IF (ITYP.EQ.0) NSTP = 1
      DO 75 NP1 = NSTRT,NLAT,NSTP
          NS = NS + NSTP
          DO 75 I = 1,IMID
              VB(I,NP1,I3) = A(NS)*VB(I,NP1-2,I1) +
     +                       B(NS)*VB(I,NP1-2,I3) - C(NS)*VB(I,NP1,I1)
   75 CONTINUE
   80 RETURN
      END
      SUBROUTINE DWBIN(ITYP,NLAT,NLON,M,WB,I3,WWBIN)
      DOUBLE PRECISION WB
      DOUBLE PRECISION WWBIN
      DIMENSION WB(1),WWBIN(1)

      IMID = (NLAT+1)/2
      LIM = NLAT*IMID
      MMAX = MIN0(NLAT, (NLON+1)/2)
      LABC = (MAX0(MMAX-2,0)* (NLAT+NLAT-MMAX-1))/2
      IW1 = LIM + 1
      IW2 = IW1 + LIM
      IW3 = IW2 + LABC
      IW4 = IW3 + LABC
c
c     the length of wwbin is 2*lim+3*labc
c
      CALL DWBIN1(ITYP,NLAT,M,WB,IMID,I3,WWBIN,WWBIN(IW1),WWBIN(IW2),
     +           WWBIN(IW3),WWBIN(IW4))
      RETURN
      END
      SUBROUTINE DWBIN1(ITYP,NLAT,M,WB,IMID,I3,WB1,WB2,A,B,C)
      DOUBLE PRECISION WB
      DOUBLE PRECISION WB1
      DOUBLE PRECISION WB2
      DOUBLE PRECISION A
      DOUBLE PRECISION B
      DOUBLE PRECISION C
      DIMENSION WB(IMID,NLAT,3),WB1(IMID,1),WB2(IMID,1),A(1),B(1),C(1)
      SAVE I1,I2

      IHOLD = I1
      I1 = I2
      I2 = I3
      I3 = IHOLD
      IF (M-2) 25,30,35
   25 I1 = 1
      I2 = 2
      I3 = 3
      DO 45 NP1 = 2,NLAT
          DO 45 I = 1,IMID
              WB(I,NP1,I3) = WB1(I,NP1)
   45 CONTINUE
      RETURN
   30 DO 50 NP1 = 3,NLAT
          DO 50 I = 1,IMID
              WB(I,NP1,I3) = WB2(I,NP1)
   50 CONTINUE
      RETURN
   35 NS = ((M-2)* (NLAT+NLAT-M-1))/2 + 1
      IF (ITYP.EQ.1) GO TO 36
      DO 85 I = 1,IMID
          WB(I,M+1,I3) = A(NS)*WB(I,M-1,I1) - C(NS)*WB(I,M+1,I1)
   85 CONTINUE
   36 IF (M.EQ.NLAT-1) RETURN
      IF (ITYP.EQ.2) GO TO 71
      NS = NS + 1
      DO 70 I = 1,IMID
          WB(I,M+2,I3) = A(NS)*WB(I,M,I1) - C(NS)*WB(I,M+2,I1)
   70 CONTINUE
   71 NSTRT = M + 3
      IF (ITYP.EQ.1) NSTRT = M + 4
      IF (NSTRT.GT.NLAT) GO TO 80
      NSTP = 2
      IF (ITYP.EQ.0) NSTP = 1
      DO 75 NP1 = NSTRT,NLAT,NSTP
          NS = NS + NSTP
          DO 75 I = 1,IMID
              WB(I,NP1,I3) = A(NS)*WB(I,NP1-2,I1) +
     +                       B(NS)*WB(I,NP1-2,I3) - C(NS)*WB(I,NP1,I1)
   75 CONTINUE
   80 RETURN
      END
      SUBROUTINE DDZVK(NLAT,M,N,CZV,WORK)
c
c     subroutine dzvk computes the coefficients in the trigonometric
c     expansion of the quadrature function zvbar(n,m,theta)
c
c     input parameters
c
c     nlat      the number of colatitudes including the poles.
c
c     n      the degree (subscript) of wbarv(n,m,theta)
c
c     m      the order (superscript) of wbarv(n,m,theta)
c
c     work   a work array with at least nlat/2+1 locations
c
c     output parameter
c
c     czv     the fourier coefficients of zvbar(n,m,theta).
c
      DIMENSION CZV(1),WORK(1)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION CZV,SC1,SUM,WORK,T1,T2

      IF (N.LE.0) RETURN
      LC = (NLAT+1)/2
C*PT*WARNING* Constant already double-precision
      SC1 = 2.d0/DBLE(NLAT-1)
      CALL DDVBK(M,N,WORK,CZV)
      NMOD = MOD(N,2)
      MMOD = MOD(M,2)
      IF (NMOD.NE.0) GO TO 1
      IF (MMOD.NE.0) GO TO 2
c
c     n even, m even
c
      KDO = N/2
      DO 9 ID = 1,LC
          I = ID + ID - 2
          SUM = 0.D0
          DO 10 K = 1,KDO
C*PT*WARNING* Constant already double-precision
              T1 = 1.d0 - (K+K+I)**2
C*PT*WARNING* Constant already double-precision
              T2 = 1.d0 - (K+K-I)**2
              SUM = SUM + WORK(K)* (T1-T2)/ (T1*T2)
   10     CONTINUE
          CZV(ID) = SC1*SUM
    9 CONTINUE
      RETURN
c
c     n even, m odd
c
    2 KDO = N/2
      DO 5 ID = 1,LC
          I = ID + ID - 2
          SUM = 0.D0
          DO 6 K = 1,KDO
C*PT*WARNING* Constant already double-precision
              T1 = 1.d0 - (K+K+I)**2
C*PT*WARNING* Constant already double-precision
              T2 = 1.d0 - (K+K-I)**2
              SUM = SUM + WORK(K)* (T1+T2)/ (T1*T2)
    6     CONTINUE
          CZV(ID) = SC1*SUM
    5 CONTINUE
      RETURN
    1 IF (MMOD.NE.0) GO TO 3
c
c     n odd, m even
c
      KDO = (N+1)/2
      DO 19 ID = 1,LC
          I = ID + ID - 3
          SUM = 0.D0
          DO 20 K = 1,KDO
C*PT*WARNING* Constant already double-precision
              T1 = 1.d0 - (K+K-1+I)**2
C*PT*WARNING* Constant already double-precision
              T2 = 1.d0 - (K+K-1-I)**2
              SUM = SUM + WORK(K)* (T1-T2)/ (T1*T2)
   20     CONTINUE
          CZV(ID) = SC1*SUM
   19 CONTINUE
      RETURN
c
c     n odd, m odd
c
    3 KDO = (N+1)/2
      DO 15 ID = 1,LC
          I = ID + ID - 1
          SUM = 0.D0
          DO 16 K = 1,KDO
C*PT*WARNING* Constant already double-precision
              T1 = 1.d0 - (K+K-1+I)**2
C*PT*WARNING* Constant already double-precision
              T2 = 1.d0 - (K+K-1-I)**2
              SUM = SUM + WORK(K)* (T1+T2)/ (T1*T2)
   16     CONTINUE
          CZV(ID) = SC1*SUM
   15 CONTINUE
      RETURN
      END
      SUBROUTINE DDZVT(NLAT,M,N,TH,CZV,ZVH)
c
c     subroutine dzvt tabulates the function zvbar(n,m,theta)
c     at theta = th in double precision
c
c     input parameters
c
c     nlat      the number of colatitudes including the poles.
c
c     n      the degree (subscript) of zvbar(n,m,theta)
c
c     m      the order (superscript) of zvbar(n,m,theta)
c
c     czv     the fourier coefficients of zvbar(n,m,theta)
c             as computed by subroutine zwk.
c
c     output parameter
c
c     zvh     zvbar(m,n,theta) evaluated at theta = th
c
      DIMENSION CZV(1)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION TH,CZV,ZVH,CTH,STH,CDT,SDT,CHH

      ZVH = 0.D0
      IF (N.LE.0) RETURN
      LC = (NLAT+1)/2
      LQ = LC - 1
      LS = LC - 2
      CTH = DCOS(TH)
      STH = DSIN(TH)
      CDT = CTH*CTH - STH*STH
      SDT = 2.D0*STH*CTH
      LMOD = MOD(NLAT,2)
      MMOD = MOD(M,2)
      NMOD = MOD(N,2)
      IF (LMOD.EQ.0) GO TO 50
      IF (NMOD.NE.0) GO TO 1
      CTH = CDT
      STH = SDT
      IF (MMOD.NE.0) GO TO 2
c
c     nlat odd  n even  m even
c
      DO 10 K = 1,LS
          ZVH = ZVH + CZV(K+1)*STH
          CHH = CDT*CTH - SDT*STH
          STH = SDT*CTH + CDT*STH
          CTH = CHH
   10 CONTINUE
      RETURN
c
c     nlat odd  n even  m odd
c
    2 ZVH = .5D0*CZV(1)
      DO 20 K = 2,LQ
          ZVH = ZVH + CZV(K)*CTH
          CHH = CDT*CTH - SDT*STH
          STH = SDT*CTH + CDT*STH
          CTH = CHH
   20 CONTINUE
      ZVH = ZVH + .5D0*CZV(LC)*DCOS((NLAT-1)*TH)
      RETURN
    1 IF (MMOD.NE.0) GO TO 3
c
c     nlat odd  n odd  m even
c
      DO 30 K = 1,LQ
          ZVH = ZVH + CZV(K+1)*STH
          CHH = CDT*CTH - SDT*STH
          STH = SDT*CTH + CDT*STH
          CTH = CHH
   30 CONTINUE
      RETURN
c
c     nlat odd  n odd  m odd
c
    3 DO 40 K = 1,LQ
          ZVH = ZVH + CZV(K)*CTH
          CHH = CDT*CTH - SDT*STH
          STH = SDT*CTH + CDT*STH
          CTH = CHH
   40 CONTINUE
      RETURN
   50 IF (NMOD.NE.0) GO TO 51
      CTH = CDT
      STH = SDT
      IF (MMOD.NE.0) GO TO 52
c
c     nlat even  n even  m even
c
      DO 55 K = 1,LQ
          ZVH = ZVH + CZV(K+1)*STH
          CHH = CDT*CTH - SDT*STH
          STH = SDT*CTH + CDT*STH
          CTH = CHH
   55 CONTINUE
      RETURN
c
c     nlat even  n even  m odd
c
   52 ZVH = .5D0*CZV(1)
      DO 57 K = 2,LC
          ZVH = ZVH + CZV(K)*CTH
          CHH = CDT*CTH - SDT*STH
          STH = SDT*CTH + CDT*STH
          CTH = CHH
   57 CONTINUE
      RETURN
   51 IF (MMOD.NE.0) GO TO 53
c
c     nlat even  n odd  m even
c
      DO 58 K = 1,LQ
          ZVH = ZVH + CZV(K+1)*STH
          CHH = CDT*CTH - SDT*STH
          STH = SDT*CTH + CDT*STH
          CTH = CHH
   58 CONTINUE
      RETURN
c
c     nlat even  n odd  m odd
c
   53 ZVH = .5D0*CZV(LC)*DCOS((NLAT-1)*TH)
      DO 60 K = 1,LQ
          ZVH = ZVH + CZV(K)*CTH
          CHH = CDT*CTH - SDT*STH
          STH = SDT*CTH + CDT*STH
          CTH = CHH
   60 CONTINUE
      RETURN
      END
      SUBROUTINE DDZWK(NLAT,M,N,CZW,WORK)
c
c     subroutine dzwk computes the coefficients in the trigonometric
c     expansion of the quadrature function zwbar(n,m,theta)
c
c     input parameters
c
c     nlat      the number of colatitudes including the poles.
c
c     n      the degree (subscript) of zwbar(n,m,theta)
c
c     m      the order (superscript) of zwbar(n,m,theta)
c
c     work   a work array with at least nlat/2+1 locations
c
c     output parameter
c
c     czw     the fourier coefficients of zwbar(n,m,theta).
c
      DIMENSION CZW(1),WORK(1)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION CZW,WORK,SC1,SUM,T1,T2

      IF (N.LE.0) RETURN
      LC = (NLAT+1)/2
C*PT*WARNING* Constant already double-precision
      SC1 = 2.d0/DBLE(NLAT-1)
      CALL DDWBK(M,N,WORK,CZW)
      NMOD = MOD(N,2)
      MMOD = MOD(M,2)
      IF (NMOD.NE.0) GO TO 1
      IF (MMOD.NE.0) GO TO 2
c
c     n even, m even
c
      KDO = N/2
      DO 19 ID = 1,LC
          I = ID + ID - 3
          SUM = 0.D0
          DO 20 K = 1,KDO
C*PT*WARNING* Constant already double-precision
              T1 = 1.d0 - (K+K-1+I)**2
C*PT*WARNING* Constant already double-precision
              T2 = 1.d0 - (K+K-1-I)**2
              SUM = SUM + WORK(K)* (T1-T2)/ (T1*T2)
   20     CONTINUE
          CZW(ID) = SC1*SUM
   19 CONTINUE
      RETURN
c
c     n even, m odd
c
    2 KDO = N/2
      DO 15 ID = 1,LC
          I = ID + ID - 1
          SUM = 0.D0
          DO 16 K = 1,KDO
C*PT*WARNING* Constant already double-precision
              T1 = 1.d0 - (K+K-1+I)**2
C*PT*WARNING* Constant already double-precision
              T2 = 1.d0 - (K+K-1-I)**2
              SUM = SUM + WORK(K)* (T1+T2)/ (T1*T2)
   16     CONTINUE
          CZW(ID) = SC1*SUM
   15 CONTINUE
      RETURN
    1 IF (MMOD.NE.0) GO TO 3
c
c     n odd, m even
c
      KDO = (N-1)/2
      DO 9 ID = 1,LC
          I = ID + ID - 2
          SUM = 0.D0
          DO 10 K = 1,KDO
C*PT*WARNING* Constant already double-precision
              T1 = 1.d0 - (K+K+I)**2
C*PT*WARNING* Constant already double-precision
              T2 = 1.d0 - (K+K-I)**2
              SUM = SUM + WORK(K)* (T1-T2)/ (T1*T2)
   10     CONTINUE
          CZW(ID) = SC1*SUM
    9 CONTINUE
      RETURN
c
c     n odd, m odd
c
    3 KDO = (N+1)/2
      DO 5 ID = 1,LC
          I = ID + ID - 2
C*PT*WARNING* Constant already double-precision
          SUM = WORK(1)/ (1.d0-I*I)
          IF (KDO.LT.2) GO TO 29
          DO 6 KP1 = 2,KDO
              K = KP1 - 1
C*PT*WARNING* Constant already double-precision
              T1 = 1.d0 - (K+K+I)**2
C*PT*WARNING* Constant already double-precision
              T2 = 1.d0 - (K+K-I)**2
              SUM = SUM + WORK(KP1)* (T1+T2)/ (T1*T2)
    6     CONTINUE
   29     CZW(ID) = SC1*SUM
    5 CONTINUE
      RETURN
      END
      SUBROUTINE DDZWT(NLAT,M,N,TH,CZW,ZWH)
c
c     subroutine dzwt tabulates the function zwbar(n,m,theta)
c     at theta = th in double precision
c
c     input parameters
c
c     nlat      the number of colatitudes including the poles.
c            nlat must be an odd integer
c
c     n      the degree (subscript) of zwbar(n,m,theta)
c
c     m      the order (superscript) of zwbar(n,m,theta)
c
c     czw     the fourier coefficients of zwbar(n,m,theta)
c             as computed by subroutine zwk.
c
c     output parameter
c
c     zwh     zwbar(m,n,theta) evaluated at theta = th
c
      DIMENSION CZW(1)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION CZW,ZWH,TH,CTH,STH,CDT,SDT,CHH

      ZWH = 0.D0
      IF (N.LE.0) RETURN
      LC = (NLAT+1)/2
      LQ = LC - 1
      LS = LC - 2
      CTH = DCOS(TH)
      STH = DSIN(TH)
      CDT = CTH*CTH - STH*STH
      SDT = 2.D0*STH*CTH
      LMOD = MOD(NLAT,2)
      MMOD = MOD(M,2)
      NMOD = MOD(N,2)
      IF (LMOD.EQ.0) GO TO 50
      IF (NMOD.NE.0) GO TO 1
      IF (MMOD.NE.0) GO TO 2
c
c     nlat odd  n even  m even
c
      DO 30 K = 1,LQ
          ZWH = ZWH + CZW(K+1)*STH
          CHH = CDT*CTH - SDT*STH
          STH = SDT*CTH + CDT*STH
          CTH = CHH
   30 CONTINUE
      RETURN
c
c     nlat odd  n even  m odd
c
    2 DO 40 K = 1,LQ
          ZWH = ZWH + CZW(K)*CTH
          CHH = CDT*CTH - SDT*STH
          STH = SDT*CTH + CDT*STH
          CTH = CHH
   40 CONTINUE
      RETURN
    1 CTH = CDT
      STH = SDT
      IF (MMOD.NE.0) GO TO 3
c
c     nlat odd  n odd  m even
c
      DO 10 K = 1,LS
          ZWH = ZWH + CZW(K+1)*STH
          CHH = CDT*CTH - SDT*STH
          STH = SDT*CTH + CDT*STH
          CTH = CHH
   10 CONTINUE
      RETURN
c
c     nlat odd  n odd  m odd
c
    3 ZWH = .5D0*CZW(1)
      DO 20 K = 2,LQ
          ZWH = ZWH + CZW(K)*CTH
          CHH = CDT*CTH - SDT*STH
          STH = SDT*CTH + CDT*STH
          CTH = CHH
   20 CONTINUE
      ZWH = ZWH + .5D0*CZW(LC)*DCOS((NLAT-1)*TH)
      RETURN
   50 IF (NMOD.NE.0) GO TO 51
      IF (MMOD.NE.0) GO TO 52
c
c     nlat even  n even  m even
c
      DO 55 K = 1,LQ
          ZWH = ZWH + CZW(K+1)*STH
          CHH = CDT*CTH - SDT*STH
          STH = SDT*CTH + CDT*STH
          CTH = CHH
   55 CONTINUE
      RETURN
c
c     nlat even  n even  m odd
c
   52 ZWH = .5D0*CZW(LC)*DCOS((NLAT-1)*TH)
      DO 60 K = 1,LQ
          ZWH = ZWH + CZW(K)*CTH
          CHH = CDT*CTH - SDT*STH
          STH = SDT*CTH + CDT*STH
          CTH = CHH
   60 CONTINUE
      RETURN
   51 CTH = CDT
      STH = SDT
      IF (MMOD.NE.0) GO TO 53
c
c     nlat even  n odd  m even
c
      DO 65 K = 1,LQ
          ZWH = ZWH + CZW(K+1)*STH
          CHH = CDT*CTH - SDT*STH
          STH = SDT*CTH + CDT*STH
          CTH = CHH
   65 CONTINUE
      RETURN
c
c     nlat even  n odd  m odd
c
   53 ZWH = .5D0*CZW(1)
      DO 70 K = 2,LC
          ZWH = ZWH + CZW(K)*CTH
          CHH = CDT*CTH - SDT*STH
          STH = SDT*CTH + CDT*STH
          CTH = CHH
   70 CONTINUE
      RETURN
      END
      SUBROUTINE DDVBK(M,N,CV,WORK)
      DOUBLE PRECISION SRNP1
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION CV(1),WORK(1),FN,FK,CF

      CV(1) = 0.D0
      IF (N.LE.0) RETURN
      FN = N
      SRNP1 = DSQRT(FN* (FN+1.D0))
      CF = 2.D0*M/SRNP1
      MODN = MOD(N,2)
      MODM = MOD(M,2)
      CALL DDNLFK(M,N,WORK)
      IF (MODN.NE.0) GO TO 70
      NCV = N/2
      IF (NCV.EQ.0) RETURN
      FK = 0.D0
      IF (MODM.NE.0) GO TO 60
c
c     n even m even
c
      DO 55 L = 1,NCV
          FK = FK + 2.D0
          CV(L) = -FK*WORK(L+1)/SRNP1
   55 CONTINUE
      RETURN
c
c     n even m odd
c
   60 DO 65 L = 1,NCV
          FK = FK + 2.D0
          CV(L) = FK*WORK(L)/SRNP1
   65 CONTINUE
      RETURN
   70 NCV = (N+1)/2
      FK = -1.D0
      IF (MODM.NE.0) GO TO 80
c
c     n odd m even
c
      DO 75 L = 1,NCV
          FK = FK + 2.D0
          CV(L) = -FK*WORK(L)/SRNP1
   75 CONTINUE
      RETURN
c
c     n odd m odd
c
   80 DO 85 L = 1,NCV
          FK = FK + 2.D0
          CV(L) = FK*WORK(L)/SRNP1
   85 CONTINUE
      RETURN
      END
      SUBROUTINE DDWBK(M,N,CW,WORK)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION CW(1),WORK(1),FN,CF,SRNP1

      CW(1) = 0.D0
      IF (N.LE.0 .OR. M.LE.0) RETURN
      FN = N
      SRNP1 = DSQRT(FN* (FN+1.D0))
      CF = 2.D0*M/SRNP1
      MODN = MOD(N,2)
      MODM = MOD(M,2)
      CALL DDNLFK(M,N,WORK)
      IF (M.EQ.0) GO TO 50
      IF (MODN.NE.0) GO TO 30
      L = N/2
      IF (L.EQ.0) GO TO 50
      IF (MODM.NE.0) GO TO 20
c
c     n even m even
c
      CW(L) = -CF*WORK(L+1)
   10 L = L - 1
      IF (L.LE.0) GO TO 50
      CW(L) = CW(L+1) - CF*WORK(L+1)
      GO TO 10
c
c     n even m odd
c
   20 CW(L) = CF*WORK(L)
   25 L = L - 1
      IF (L.LE.0) GO TO 50
      CW(L) = CW(L+1) + CF*WORK(L)
      GO TO 25
   30 IF (MODM.NE.0) GO TO 40
      L = (N-1)/2
      IF (L.EQ.0) GO TO 50
c
c     n odd m even
c
      CW(L) = -CF*WORK(L+1)
   35 L = L - 1
      IF (L.LE.0) GO TO 50
      CW(L) = CW(L+1) - CF*WORK(L+1)
      GO TO 35
c
c     n odd m odd
c
   40 L = (N+1)/2
      CW(L) = CF*WORK(L)
   45 L = L - 1
      IF (L.LE.0) GO TO 50
      CW(L) = CW(L+1) + CF*WORK(L)
      GO TO 45
   50 RETURN
      END
      SUBROUTINE DDVBT(M,N,THETA,CV,VH)
      DIMENSION CV(1)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION CV,VH,THETA,CTH,STH,CDT,SDT,CHH

      VH = 0.D0
      IF (N.EQ.0) RETURN
      CTH = DCOS(THETA)
      STH = DSIN(THETA)
      CDT = CTH*CTH - STH*STH
      SDT = 2.D0*STH*CTH
      MMOD = MOD(M,2)
      NMOD = MOD(N,2)
      IF (NMOD.NE.0) GO TO 1
      CTH = CDT
      STH = SDT
      IF (MMOD.NE.0) GO TO 2
c
c     n even  m even
c
      NCV = N/2
      DO 10 K = 1,NCV
          VH = VH + CV(K)*STH
          CHH = CDT*CTH - SDT*STH
          STH = SDT*CTH + CDT*STH
          CTH = CHH
   10 CONTINUE
      RETURN
c
c     n even  m odd
c
    2 NCV = N/2
      DO 15 K = 1,NCV
          VH = VH + CV(K)*CTH
          CHH = CDT*CTH - SDT*STH
          STH = SDT*CTH + CDT*STH
          CTH = CHH
   15 CONTINUE
      RETURN
    1 IF (MMOD.NE.0) GO TO 3
c
c     n odd m even
c
      NCV = (N+1)/2
      DO 20 K = 1,NCV
          VH = VH + CV(K)*STH
          CHH = CDT*CTH - SDT*STH
          STH = SDT*CTH + CDT*STH
          CTH = CHH
   20 CONTINUE
      RETURN
c
c case m odd and n odd
c
    3 NCV = (N+1)/2
      DO 25 K = 1,NCV
          VH = VH + CV(K)*CTH
          CHH = CDT*CTH - SDT*STH
          STH = SDT*CTH + CDT*STH
          CTH = CHH
   25 CONTINUE
      RETURN
      END
      SUBROUTINE DDWBT(M,N,THETA,CW,WH)
      DIMENSION CW(1)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION THETA,CW,WH,CTH,STH,CDT,SDT,CHH

      WH = 0.D0
      IF (N.LE.0 .OR. M.LE.0) RETURN
      CTH = DCOS(THETA)
      STH = DSIN(THETA)
      CDT = CTH*CTH - STH*STH
      SDT = 2.D0*STH*CTH
      MMOD = MOD(M,2)
      NMOD = MOD(N,2)
      IF (NMOD.NE.0) GO TO 1
      IF (MMOD.NE.0) GO TO 2
c
c     n even  m even
c
      NCW = N/2
      DO 10 K = 1,NCW
          WH = WH + CW(K)*STH
          CHH = CDT*CTH - SDT*STH
          STH = SDT*CTH + CDT*STH
          CTH = CHH
   10 CONTINUE
      RETURN
c
c     n even  m odd
c
    2 NCW = N/2
      DO 8 K = 1,NCW
          WH = WH + CW(K)*CTH
          CHH = CDT*CTH - SDT*STH
          STH = SDT*CTH + CDT*STH
          CTH = CHH
    8 CONTINUE
      RETURN
    1 CTH = CDT
      STH = SDT
      IF (MMOD.NE.0) GO TO 3
c
c     n odd m even
c
      NCW = (N-1)/2
      DO 20 K = 1,NCW
          WH = WH + CW(K)*STH
          CHH = CDT*CTH - SDT*STH
          STH = SDT*CTH + CDT*STH
          CTH = CHH
   20 CONTINUE
      RETURN
c
c case m odd and n odd
c
    3 NCW = (N+1)/2
      WH = .5D0*CW(1)
      IF (NCW.LT.2) RETURN
      DO 25 K = 2,NCW
          WH = WH + CW(K)*CTH
          CHH = CDT*CTH - SDT*STH
          STH = SDT*CTH + CDT*STH
          CTH = CHH
   25 CONTINUE
      RETURN
      END
      SUBROUTINE DRABCV(NLAT,NLON,ABC)
      DOUBLE PRECISION ABC
c
c     subroutine rabcp computes the coefficients in the recurrence
c     relation for the functions vbar(m,n,theta). array abc
c     must have 3*(max0(mmax-2,0)*(nlat+nlat-mmax-1))/2 locations.
c
      DIMENSION ABC(1)

      MMAX = MIN0(NLAT, (NLON+1)/2)
      LABC = (MAX0(MMAX-2,0)* (NLAT+NLAT-MMAX-1))/2
      IW1 = LABC + 1
      IW2 = IW1 + LABC
      CALL DRABCV1(NLAT,NLON,ABC,ABC(IW1),ABC(IW2))
      RETURN
      END
      SUBROUTINE DRABCV1(NLAT,NLON,A,B,C)
      DOUBLE PRECISION A
      DOUBLE PRECISION B
      DOUBLE PRECISION C
      DOUBLE PRECISION FM
      DOUBLE PRECISION TM
      DOUBLE PRECISION TEMP
      DOUBLE PRECISION TPN
      DOUBLE PRECISION FN
      DOUBLE PRECISION TN
      DOUBLE PRECISION CN
      DOUBLE PRECISION FNPM
      DOUBLE PRECISION FNMM
c
c     coefficients a, b, and c for computing vbar(m,n,theta) are
c     stored in location ((m-2)*(nlat+nlat-m-1))/2+n+1
c
      DIMENSION A(1),B(1),C(1)

      MMAX = MIN0(NLAT, (NLON+1)/2)
      IF (MMAX.LT.3) RETURN
      DO 215 MP1 = 3,MMAX
          M = MP1 - 1
          NS = ((M-2)* (NLAT+NLAT-M-1))/2 + 1
          FM = DBLE(M)
          TM = FM + FM
          TEMP = TM* (TM-1.D0)
          TPN = (FM-2.D0)* (FM-1.D0)/ (FM* (FM+1.D0))
          A(NS) = SQRT(TPN* (TM+1.D0)* (TM-2.D0)/TEMP)
          C(NS) = SQRT(2.D0/TEMP)
          IF (M.EQ.NLAT-1) GO TO 215
          NS = NS + 1
          TEMP = TM* (TM+1.D0)
          TPN = (FM-1.D0)*FM/ ((FM+1.D0)* (FM+2.D0))
          A(NS) = SQRT(TPN* (TM+3.D0)* (TM-2.D0)/TEMP)
          C(NS) = SQRT(6.D0/TEMP)
          MP3 = M + 3
          IF (MP3.GT.NLAT) GO TO 215
          DO 210 NP1 = MP3,NLAT
              N = NP1 - 1
              NS = NS + 1
              FN = DBLE(N)
              TN = FN + FN
              CN = (TN+1.D0)/ (TN-3.D0)
              TPN = (FN-2.D0)* (FN-1.D0)/ (FN* (FN+1.D0))
              FNPM = FN + FM
              FNMM = FN - FM
              TEMP = FNPM* (FNPM-1.D0)
              A(NS) = SQRT(TPN*CN* (FNPM-3.D0)* (FNPM-2.D0)/TEMP)
              B(NS) = SQRT(TPN*CN*FNMM* (FNMM-1.D0)/TEMP)
              C(NS) = SQRT((FNMM+1.D0)* (FNMM+2.D0)/TEMP)
  210     CONTINUE
  215 CONTINUE
      RETURN
      END
      SUBROUTINE DRABCW(NLAT,NLON,ABC)
      DOUBLE PRECISION ABC
c
c     subroutine rabcw computes the coefficients in the recurrence
c     relation for the functions wbar(m,n,theta). array abc
c     must have 3*(max0(mmax-2,0)*(nlat+nlat-mmax-1))/2 locations.
c
      DIMENSION ABC(1)

      MMAX = MIN0(NLAT, (NLON+1)/2)
      LABC = (MAX0(MMAX-2,0)* (NLAT+NLAT-MMAX-1))/2
      IW1 = LABC + 1
      IW2 = IW1 + LABC
      CALL DRABCW1(NLAT,NLON,ABC,ABC(IW1),ABC(IW2))
      RETURN
      END
      SUBROUTINE DRABCW1(NLAT,NLON,A,B,C)
      DOUBLE PRECISION A
      DOUBLE PRECISION B
      DOUBLE PRECISION C
      DOUBLE PRECISION FM
      DOUBLE PRECISION TM
      DOUBLE PRECISION TEMP
      DOUBLE PRECISION TPN
      DOUBLE PRECISION TPH
      DOUBLE PRECISION FN
      DOUBLE PRECISION TN
      DOUBLE PRECISION CN
      DOUBLE PRECISION FNPM
      DOUBLE PRECISION FNMM
c
c     coefficients a, b, and c for computing wbar(m,n,theta) are
c     stored in location ((m-2)*(nlat+nlat-m-1))/2+n+1
c
      DIMENSION A(1),B(1),C(1)

      MMAX = MIN0(NLAT, (NLON+1)/2)
      IF (MMAX.LT.4) RETURN
      DO 215 MP1 = 4,MMAX
          M = MP1 - 1
          NS = ((M-2)* (NLAT+NLAT-M-1))/2 + 1
          FM = DBLE(M)
          TM = FM + FM
          TEMP = TM* (TM-1.D0)
          TPN = (FM-2.D0)* (FM-1.D0)/ (FM* (FM+1.D0))
          TPH = FM/ (FM-2.D0)
          A(NS) = TPH*SQRT(TPN* (TM+1.D0)* (TM-2.D0)/TEMP)
          C(NS) = TPH*SQRT(2.D0/TEMP)
          IF (M.EQ.NLAT-1) GO TO 215
          NS = NS + 1
          TEMP = TM* (TM+1.D0)
          TPN = (FM-1.D0)*FM/ ((FM+1.D0)* (FM+2.D0))
          TPH = FM/ (FM-2.D0)
          A(NS) = TPH*SQRT(TPN* (TM+3.D0)* (TM-2.D0)/TEMP)
          C(NS) = TPH*SQRT(6.D0/TEMP)
          MP3 = M + 3
          IF (MP3.GT.NLAT) GO TO 215
          DO 210 NP1 = MP3,NLAT
              N = NP1 - 1
              NS = NS + 1
              FN = DBLE(N)
              TN = FN + FN
              CN = (TN+1.D0)/ (TN-3.D0)
              FNPM = FN + FM
              FNMM = FN - FM
              TEMP = FNPM* (FNPM-1.D0)
              TPN = (FN-2.D0)* (FN-1.D0)/ (FN* (FN+1.D0))
              TPH = FM/ (FM-2.D0)
              A(NS) = TPH*SQRT(TPN*CN* (FNPM-3.D0)* (FNPM-2.D0)/TEMP)
              B(NS) = SQRT(TPN*CN*FNMM* (FNMM-1.D0)/TEMP)
              C(NS) = TPH*SQRT((FNMM+1.D0)* (FNMM+2.D0)/TEMP)
  210     CONTINUE
  215 CONTINUE
      RETURN
      END
      SUBROUTINE DVTINIT(NLAT,NLON,WVBIN,DWORK)
      DOUBLE PRECISION WVBIN
      DIMENSION WVBIN(*)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION DWORK(*)

      IMID = (NLAT+1)/2
      IW1 = 2*NLAT*IMID + 1
c
c     the length of wvbin is 2*nlat*imid+3*((nlat-3)*nlat+2)/2
c     the length of dwork is nlat+2
c
      CALL DVTINI1(NLAT,NLON,IMID,WVBIN,WVBIN(IW1),DWORK,
     +             DWORK(NLAT/2+2))
      RETURN
      END
      SUBROUTINE DVTINI1(NLAT,NLON,IMID,VB,ABC,CVB,WORK)
      DOUBLE PRECISION VB
      DOUBLE PRECISION ABC
c
c     abc must have 3*(max0(mmax-2,0)*(nlat+nlat-mmax-1))/2
c     locations where mmax = min0(nlat,(nlon+1)/2)
c     cvb and work must each have nlat/2+1 locations
c
      DIMENSION VB(IMID,NLAT,2),ABC(1),CVB(1)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION PI,DT,CVB,TH,VBH,WORK(*)
C*PT*WARNING* Constant already double-precision
      PI = 4.D0*DATAN(1.d0)
      DT = PI/ (NLAT-1)
      MDO = MIN0(2,NLAT, (NLON+1)/2)
      DO 160 MP1 = 1,MDO
          M = MP1 - 1
          DO 160 NP1 = MP1,NLAT
              N = NP1 - 1
              CALL DDVTK(M,N,CVB,WORK)
              DO 165 I = 1,IMID
                  TH = (I-1)*DT
                  CALL DDVTT(M,N,TH,CVB,VBH)
                  VB(I,NP1,MP1) = VBH
  165         CONTINUE
  160 CONTINUE
      CALL DRABCV(NLAT,NLON,ABC)
      RETURN
      END
      SUBROUTINE DWTINIT(NLAT,NLON,WWBIN,DWORK)
      DOUBLE PRECISION WWBIN
      DIMENSION WWBIN(1)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION DWORK(*)

      IMID = (NLAT+1)/2
      IW1 = 2*NLAT*IMID + 1
c
c     the length of wwbin is 2*nlat*imid+3*((nlat-3)*nlat+2)/2
c     the length of dwork is nlat+2
c
      CALL DWTINI1(NLAT,NLON,IMID,WWBIN,WWBIN(IW1),DWORK,
     +             DWORK(NLAT/2+2))
      RETURN
      END
      SUBROUTINE DWTINI1(NLAT,NLON,IMID,WB,ABC,CWB,WORK)
      DOUBLE PRECISION WB
      DOUBLE PRECISION ABC
c
c     abc must have 3*(max0(mmax-2,0)*(nlat+nlat-mmax-1))/2
c     locations where mmax = min0(nlat,(nlon+1)/2)
c     cwb and work must each have nlat/2+1 locations
c
      DIMENSION WB(IMID,NLAT,2),ABC(1)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION PI,DT,CWB(*),WBH,TH,WORK(*)
C*PT*WARNING* Constant already double-precision
      PI = 4.D0*DATAN(1.d0)
      DT = PI/ (NLAT-1)
      MDO = MIN0(3,NLAT, (NLON+1)/2)
      IF (MDO.LT.2) RETURN
      DO 160 MP1 = 2,MDO
          M = MP1 - 1
          DO 160 NP1 = MP1,NLAT
              N = NP1 - 1
              CALL DDWTK(M,N,CWB,WORK)
              DO 165 I = 1,IMID
                  TH = (I-1)*DT
                  CALL DDWTT(M,N,TH,CWB,WBH)
                  WB(I,NP1,M) = WBH
  165         CONTINUE
  160 CONTINUE
      CALL DRABCW(NLAT,NLON,ABC)
      RETURN
      END
      SUBROUTINE DVTGINT(NLAT,NLON,THETA,WVBIN,WORK)
      DOUBLE PRECISION WVBIN
      DIMENSION WVBIN(*)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION THETA(*),WORK(*)

      IMID = (NLAT+1)/2
      IW1 = 2*NLAT*IMID + 1
c
c     theta is a double precision array with (nlat+1)/2 locations
c     nlat is the maximum value of n+1
c     the length of wvbin is 2*nlat*imid+3*((nlat-3)*nlat+2)/2
c     the length of work is nlat+2
c
      CALL DVTGIT1(NLAT,NLON,IMID,THETA,WVBIN,WVBIN(IW1),WORK,
     +            WORK(NLAT/2+2))
      RETURN
      END
      SUBROUTINE DVTGIT1(NLAT,NLON,IMID,THETA,VB,ABC,CVB,WORK)
      DOUBLE PRECISION VB
      DOUBLE PRECISION ABC
c
c     abc must have 3*(max0(mmax-2,0)*(nlat+nlat-mmax-1))/2
c     locations where mmax = min0(nlat,(nlon+1)/2)
c     cvb and work must each have nlat/2+1   locations
c
      DIMENSION VB(IMID,NLAT,2),ABC(*)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION THETA(*),CVB(*),WORK(*),VBH

      MDO = MIN0(2,NLAT, (NLON+1)/2)
      DO 160 MP1 = 1,MDO
          M = MP1 - 1
          DO 160 NP1 = MP1,NLAT
              N = NP1 - 1
              CALL DDVTK(M,N,CVB,WORK)
              DO 165 I = 1,IMID
                  CALL DDVTT(M,N,THETA(I),CVB,VBH)
                  VB(I,NP1,MP1) = VBH
  165         CONTINUE
  160 CONTINUE
      CALL DRABCV(NLAT,NLON,ABC)
      RETURN
      END
      SUBROUTINE DWTGINT(NLAT,NLON,THETA,WWBIN,WORK)
      DOUBLE PRECISION WWBIN
      DIMENSION WWBIN(*)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION THETA(*),WORK(*)

      IMID = (NLAT+1)/2
      IW1 = 2*NLAT*IMID + 1
c
c     theta is a double precision array with (nlat+1)/2 locations
c     nlat is the maximum value of n+1
c     the length of wwbin is 2*nlat*imid+3*((nlat-3)*nlat+2)/2
c     the length of work is nlat+2
c
      CALL DWTGIT1(NLAT,NLON,IMID,THETA,WWBIN,WWBIN(IW1),WORK,
     +            WORK(NLAT/2+2))
      RETURN
      END
      SUBROUTINE DWTGIT1(NLAT,NLON,IMID,THETA,WB,ABC,CWB,WORK)
      DOUBLE PRECISION WB
      DOUBLE PRECISION ABC
c
c     abc must have 3*((nlat-3)*nlat+2)/2 locations
c     cwb and work must each have nlat/2+1 locations
c
      DIMENSION WB(IMID,NLAT,2),ABC(1)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION THETA(*),CWB(*),WORK(*),WBH

      MDO = MIN0(3,NLAT, (NLON+1)/2)
      IF (MDO.LT.2) RETURN
      DO 160 MP1 = 2,MDO
          M = MP1 - 1
          DO 160 NP1 = MP1,NLAT
              N = NP1 - 1
              CALL DDWTK(M,N,CWB,WORK)
              DO 165 I = 1,IMID
                  CALL DDWTT(M,N,THETA(I),CWB,WBH)
                  WB(I,NP1,M) = WBH
  165         CONTINUE
  160 CONTINUE
      CALL DRABCW(NLAT,NLON,ABC)
      RETURN
      END
      SUBROUTINE DDVTK(M,N,CV,WORK)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION CV(*),WORK(*),FN,FK,CF,SRNP1

      CV(1) = 0.D0
      IF (N.LE.0) RETURN
      FN = N
      SRNP1 = DSQRT(FN* (FN+1.D0))
      CF = 2.D0*M/SRNP1
      MODN = MOD(N,2)
      MODM = MOD(M,2)
      CALL DDNLFK(M,N,WORK)
      IF (MODN.NE.0) GO TO 70
      NCV = N/2
      IF (NCV.EQ.0) RETURN
      FK = 0.D0
      IF (MODM.NE.0) GO TO 60
c
c     n even m even
c
      DO 55 L = 1,NCV
          FK = FK + 2.D0
          CV(L) = -FK*FK*WORK(L+1)/SRNP1
   55 CONTINUE
      RETURN
c
c     n even m odd
c
   60 DO 65 L = 1,NCV
          FK = FK + 2.D0
          CV(L) = -FK*FK*WORK(L)/SRNP1
   65 CONTINUE
      RETURN
   70 NCV = (N+1)/2
      FK = -1.D0
      IF (MODM.NE.0) GO TO 80
c
c     n odd m even
c
      DO 75 L = 1,NCV
          FK = FK + 2.D0
          CV(L) = -FK*FK*WORK(L)/SRNP1
   75 CONTINUE
      RETURN
c
c     n odd m odd
c
   80 DO 85 L = 1,NCV
          FK = FK + 2.D0
          CV(L) = -FK*FK*WORK(L)/SRNP1
   85 CONTINUE
      RETURN
      END
      SUBROUTINE DDWTK(M,N,CW,WORK)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION CW(*),WORK(*),FN,CF,SRNP1

      CW(1) = 0.D0
      IF (N.LE.0 .OR. M.LE.0) RETURN
      FN = N
      SRNP1 = DSQRT(FN* (FN+1.D0))
      CF = 2.D0*M/SRNP1
      MODN = MOD(N,2)
      MODM = MOD(M,2)
      CALL DDNLFK(M,N,WORK)
      IF (M.EQ.0) GO TO 50
      IF (MODN.NE.0) GO TO 30
      L = N/2
      IF (L.EQ.0) GO TO 50
      IF (MODM.NE.0) GO TO 20
c
c     n even m even
c
      CW(L) = -CF*WORK(L+1)
   10 L = L - 1
      IF (L.LE.0) GO TO 50
      CW(L) = CW(L+1) - CF*WORK(L+1)
      CW(L+1) = (L+L+1)*CW(L+1)
      GO TO 10
c
c     n even m odd
c
   20 CW(L) = CF*WORK(L)
   25 L = L - 1
      IF (L) 50,27,26
   26 CW(L) = CW(L+1) + CF*WORK(L)
   27 CW(L+1) = - (L+L+1)*CW(L+1)
      GO TO 25
   30 IF (MODM.NE.0) GO TO 40
      L = (N-1)/2
      IF (L.EQ.0) GO TO 50
c
c     n odd m even
c
      CW(L) = -CF*WORK(L+1)
   35 L = L - 1
      IF (L) 50,37,36
   36 CW(L) = CW(L+1) - CF*WORK(L+1)
   37 CW(L+1) = (L+L+2)*CW(L+1)
      GO TO 35
c
c     n odd m odd
c
   40 L = (N+1)/2
      CW(L) = CF*WORK(L)
   45 L = L - 1
      IF (L) 50,47,46
   46 CW(L) = CW(L+1) + CF*WORK(L)
   47 CW(L+1) = - (L+L)*CW(L+1)
      GO TO 45
   50 RETURN
      END
      SUBROUTINE DDVTT(M,N,THETA,CV,VH)
      DIMENSION CV(1)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION CV,VH,THETA,CTH,STH,CDT,SDT,CHH

      VH = 0.D0
      IF (N.EQ.0) RETURN
      CTH = DCOS(THETA)
      STH = DSIN(THETA)
      CDT = CTH*CTH - STH*STH
      SDT = 2.D0*STH*CTH
      MMOD = MOD(M,2)
      NMOD = MOD(N,2)
      IF (NMOD.NE.0) GO TO 1
      CTH = CDT
      STH = SDT
      IF (MMOD.NE.0) GO TO 2
c
c     n even  m even
c
      NCV = N/2
      DO 10 K = 1,NCV
          VH = VH + CV(K)*CTH
          CHH = CDT*CTH - SDT*STH
          STH = SDT*CTH + CDT*STH
          CTH = CHH
   10 CONTINUE
      RETURN
c
c     n even  m odd
c
    2 NCV = N/2
      DO 15 K = 1,NCV
          VH = VH + CV(K)*STH
          CHH = CDT*CTH - SDT*STH
          STH = SDT*CTH + CDT*STH
          CTH = CHH
   15 CONTINUE
      RETURN
    1 IF (MMOD.NE.0) GO TO 3
c
c     n odd m even
c
      NCV = (N+1)/2
      DO 20 K = 1,NCV
          VH = VH + CV(K)*CTH
          CHH = CDT*CTH - SDT*STH
          STH = SDT*CTH + CDT*STH
          CTH = CHH
   20 CONTINUE
      RETURN
c
c case m odd and n odd
c
    3 NCV = (N+1)/2
      DO 25 K = 1,NCV
          VH = VH + CV(K)*STH
          CHH = CDT*CTH - SDT*STH
          STH = SDT*CTH + CDT*STH
          CTH = CHH
   25 CONTINUE
      RETURN
      END
      SUBROUTINE DDWTT(M,N,THETA,CW,WH)
      DIMENSION CW(1)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION THETA,CW,WH,CTH,STH,CDT,SDT,CHH

      WH = 0.D0
      IF (N.LE.0 .OR. M.LE.0) RETURN
      CTH = DCOS(THETA)
      STH = DSIN(THETA)
      CDT = CTH*CTH - STH*STH
      SDT = 2.D0*STH*CTH
      MMOD = MOD(M,2)
      NMOD = MOD(N,2)
      IF (NMOD.NE.0) GO TO 1
      IF (MMOD.NE.0) GO TO 2
c
c     n even  m even
c
      NCW = N/2
      DO 10 K = 1,NCW
          WH = WH + CW(K)*CTH
          CHH = CDT*CTH - SDT*STH
          STH = SDT*CTH + CDT*STH
          CTH = CHH
   10 CONTINUE
      RETURN
c
c     n even  m odd
c
    2 NCW = N/2
      DO 8 K = 1,NCW
          WH = WH + CW(K)*STH
          CHH = CDT*CTH - SDT*STH
          STH = SDT*CTH + CDT*STH
          CTH = CHH
    8 CONTINUE
      RETURN
    1 CTH = CDT
      STH = SDT
      IF (MMOD.NE.0) GO TO 3
c
c     n odd m even
c
      NCW = (N-1)/2
      DO 20 K = 1,NCW
          WH = WH + CW(K)*CTH
          CHH = CDT*CTH - SDT*STH
          STH = SDT*CTH + CDT*STH
          CTH = CHH
   20 CONTINUE
      RETURN
c
c case m odd and n odd
c
    3 NCW = (N+1)/2
      WH = 0.D0
      IF (NCW.LT.2) RETURN
      DO 25 K = 2,NCW
          WH = WH + CW(K)*STH
          CHH = CDT*CTH - SDT*STH
          STH = SDT*CTH + CDT*STH
          CTH = CHH
   25 CONTINUE
      RETURN
      END
      SUBROUTINE DVBGINT(NLAT,NLON,THETA,WVBIN,WORK)
      DOUBLE PRECISION WVBIN
      DIMENSION WVBIN(1)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION THETA(*),WORK(*)

      IMID = (NLAT+1)/2
      IW1 = 2*NLAT*IMID + 1
c
c     theta is a double precision array with (nlat+1)/2 locations
c     nlat is the maximum value of n+1
c     the length of wvbin is 2*nlat*imid+3*((nlat-3)*nlat+2)/2
c     the length of work is nlat+2
c
      CALL DVBGIT1(NLAT,NLON,IMID,THETA,WVBIN,WVBIN(IW1),WORK,
     +            WORK(NLAT/2+2))
      RETURN
      END
      SUBROUTINE DVBGIT1(NLAT,NLON,IMID,THETA,VB,ABC,CVB,WORK)
      DOUBLE PRECISION VB
      DOUBLE PRECISION ABC
c
c     abc must have 3*(max0(mmax-2,0)*(nlat+nlat-mmax-1))/2
c     locations where mmax = min0(nlat,(nlon+1)/2)
c     cvb and work must each have nlat/2+1 locations
c
      DIMENSION VB(IMID,NLAT,2),ABC(1)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION CVB(1),THETA(1),VBH,WORK(1)

      MDO = MIN0(2,NLAT, (NLON+1)/2)
      DO 160 MP1 = 1,MDO
          M = MP1 - 1
          DO 160 NP1 = MP1,NLAT
              N = NP1 - 1
              CALL DDVBK(M,N,CVB,WORK)
              DO 165 I = 1,IMID
                  CALL DDVBT(M,N,THETA(I),CVB,VBH)
                  VB(I,NP1,MP1) = VBH
  165         CONTINUE
  160 CONTINUE
      CALL DRABCV(NLAT,NLON,ABC)
      RETURN
      END
      SUBROUTINE DWBGINT(NLAT,NLON,THETA,WWBIN,WORK)
      DOUBLE PRECISION WWBIN
      DIMENSION WWBIN(1)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION WORK(*),THETA(*)

      IMID = (NLAT+1)/2
      IW1 = 2*NLAT*IMID + 1
c
c     theta is a double precision array with (nlat+1)/2 locations
c     nlat is the maximum value of n+1
c     the length of wwbin is 2*nlat*imid+3*((nlat-3)*nlat+2)/2
c     the length of work is nlat+2
c
      CALL DWBGIT1(NLAT,NLON,IMID,THETA,WWBIN,WWBIN(IW1),WORK,
     +            WORK(NLAT/2+2))
      RETURN
      END
      SUBROUTINE DWBGIT1(NLAT,NLON,IMID,THETA,WB,ABC,CWB,WORK)
      DOUBLE PRECISION WB
      DOUBLE PRECISION ABC
c
c     abc must have 3*((nlat-3)*nlat+2)/2 locations
c     cwb and work must each have nlat/2+1 locations
c
      DIMENSION WB(IMID,NLAT,2),ABC(1)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION CWB(1),THETA(1),WBH,WORK(1)

      MDO = MIN0(3,NLAT, (NLON+1)/2)
      IF (MDO.LT.2) RETURN
      DO 160 MP1 = 2,MDO
          M = MP1 - 1
          DO 160 NP1 = MP1,NLAT
              N = NP1 - 1
              CALL DDWBK(M,N,CWB,WORK)
              DO 165 I = 1,IMID
                  CALL DDWBT(M,N,THETA(I),CWB,WBH)
                  WB(I,NP1,M) = WBH
  165         CONTINUE
  160 CONTINUE
      CALL DRABCW(NLAT,NLON,ABC)
      RETURN
      END

C
C $Id: trn32s.f,v 1.6 2008-07-27 00:17:26 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE TRN32S (X,Y,Z,XT,YT,ZT,IFLAG)
C
C THIS ROUTINE IMPLEMENTS THE 3-SPACE TO 2-SPACE TRANSFOR-
C MATION BY KUBER, SZABO AND GIULIERI, THE PERSPECTIVE
C REPRESENTATION OF FUNCTIONS OF TWO VARIABLES. J. ACM 15,
C 2, 193-204,1968.
C IFLAG=0 ARGUMENTS
C X,Y,Z    ARE THE 3-SPACE COORDINATES OF THE INTERSECTION
C          OF THE LINE OF SIGHT AND THE IMAGE PLANE.  THIS
C          POINT CAN BE THOUGHT OF AS THE POINT LOOKED AT.
C XT,YT,ZT ARE THE 3-SPACE COORDINATES OF THE EYE POSITION.
C
C IFLAG=1 ARGUMENTS
C X,Y,Z    ARE THE 3-SPACE COORDINATES OF A POINT TO BE
C          TRANSFORMED.
C XT,YT    THE RESULTS OF THE 3-SPACE TO 2-SPACE TRANSFOR-
C          MATION.
C          USE INT(XT) AND INT(YT) IN GPL CALLS.
C ZT       NOT USED.
C IF LL (IN COMMON) =0 XT AND YT ARE IN THE SAME SCALE AS X, Y, AND Z.
C
      COMMON /PWRZ1S/ XXMIN      ,XXMAX      ,YYMIN      ,YYMAX      ,
     1                ZZMIN      ,ZZMAX      ,DELCRT     ,EYEX       ,
     2                EYEY       ,EYEZ
      COMMON /SRFBLK/ LIMU(1024) ,LIML(1024) ,CL(41)     ,NCL        ,
     1                LL         ,FACT       ,IROT       ,NDRZ       ,
     2                NUPPER     ,NRSWT      ,BIGD       ,UMIN       ,
     3                UMAX       ,VMIN       ,VMAX       ,RZERO      ,
     4                IOFFP      ,NSPVAL     ,SPVAL      ,BIGEST
      DIMENSION       NLU(7)     ,NRU(7)     ,NBV(7)     ,NTV(7)
C
C SAVE INSERTED BY BEN DOMENICO 9/8/85 BECAUSE OF ASSUMPTION THAT
C   JUMP, JUMP2, AND JUMP3 ARE PRESERVED BETWEEN CALLS.
C   THERE MAY BE OTHER SUCH ASSUMPTIONS AS WELL.
C
      SAVE
C
C PICTURE CORNER COORDINATES FOR LL=1
C
      DATA NLU(1),NRU(1),NBV(1),NTV(1)/  10,1014,  10,1014/
C
C PICTURE CORNER COORDINATES FOR LL=2
C
      DATA NLU(2),NRU(2),NBV(2),NTV(2)/  10, 924,  50, 964/
C
C PICTURE CORNER COORDINATES FOR LL=3
C
      DATA NLU(3),NRU(3),NBV(3),NTV(3)/ 100,1014,  50, 964/
C
C PICTURE CORNER COORDINATES FOR LL=4
C
      DATA NLU(4),NRU(4),NBV(4),NTV(4)/  10,1014,  10,1014/
C
C PICTURE CORNER COORDINATES FOR LL=5
C
      DATA NLU(5),NRU(5),NBV(5),NTV(5)/  10,1014,  10,1014/
C
C PICTURE CORNER COORDINATES FOR LL=6
C
      DATA NLU(6),NRU(6),NBV(6),NTV(6)/  10, 512, 256, 758/
C
C PICTURE CORNER COORDINATES FOR LL=7
C
      DATA NLU(7),NRU(7),NBV(7),NTV(7)/ 512,1014, 256, 758/
C
C STORE THE PARAMETERS OF THE SET32 CALL FOR USE WHEN
C TRN32 IS CALLED.
C
      IF (IFLAG)  40, 10, 40
   10 CONTINUE
      JUMP3 = 1
      IF (IOFFP .EQ. 1) JUMP3 = 2
      AX = X
      AY = Y
      AZ = Z
      EX = XT
      EY = YT
      EZ = ZT
C
C AS MUCH COMPUTATION AS POSSIBLE IS DONE DURING EXECUTION
C THIS ROUTINE WHEN IFLAG=0 BECAUSE CALLS IN THAT MODE ARE INFREQUENT.
C
      DX = AX-EX
      DY = AY-EY
      DZ = AZ-EZ
      D = SQRT(DX*DX+DY*DY+DZ*DZ)
      COSAL = DX/D
      COSBE = DY/D
      COSGA = DZ/D
      SINGA = SQRT(1.-COSGA*COSGA)
      JUMP2 = 1
      IF (LL .EQ. 0) GO TO  20
      JUMP2 = 2
      DELCRT = NRU(LL)-NLU(LL)
      U0 = UMIN
      V0 = VMIN
      U1 = NLU(LL)
      V1 = NBV(LL)
      U2 = NRU(LL)-NLU(LL)
      V2 = NTV(LL)-NBV(LL)
      U3 = U2/(UMAX-UMIN)
      V3 = V2/(VMAX-VMIN)
      U4 = NRU(LL)
      V4 = NTV(LL)
      IF (NRSWT .EQ. 0) GO TO  20
      U0 = -BIGD
      V0 = -BIGD
      U3 = U2/(2.*BIGD)
      V3 = V2/(2.*BIGD)
C
C THE 3-SPACE POINT LOOKED AT IS TRANSFORMED INTO (0,0) OF
C THE 2-SPACE.  THE 3-SPACE Z AXIS IS TRANSFORMED INTO THE
C 2-SPACE Y AXIS.  IF THE LINE OF SIGHT IS CLOSE TO PARALLEL
C TO THE 3-SPACE Z AXIS, THE 3-SPACE Y AXIS IS CHOSEN (IN-
C STEAD OF THE 3-SPACE Z AXIS) TO BE TRANSFORMED INTO THE
C 2-SPACE Y AXIS.
C
   20 IF (SINGA .LT. 0.0001) GO TO  30
      R = 1./SINGA
      JUMP = 1
      RETURN
   30 SINBE = SQRT(1.-COSBE*COSBE)
      R = 1./SINBE
      JUMP = 2
      RETURN
   40 CONTINUE
      XX = X
      YY = Y
      ZZ = Z
      GO TO ( 60, 50) , JUMP3
   50 IF (ZZ .EQ. SPVAL) GO TO 110
   60 Q = D/((XX-EX)*COSAL+(YY-EY)*COSBE+(ZZ-EZ)*COSGA)
      GO TO (70,80), JUMP
   70 XX = ((EX+Q*(XX-EX)-AX)*COSBE-(EY+Q*(YY-EY)-AY)*COSAL)*R
      YY = (EZ+Q*(ZZ-EZ)-AZ)*R
      GO TO 90
   80 XX = ((EZ+Q*(ZZ-EZ)-AZ)*COSAL-(EX+Q*(XX-EX)-AX)*COSGA)*R
      YY = (EY+Q*(YY-EY)-AY)*R
   90 GO TO (120,100), JUMP2
  100 XX = MIN(U4,MAX(U1,U1+U3*(FACT*XX-U0)))
      YY = MIN(V4,MAX(V1,V1+V3*(FACT*YY-V0)))
      GO TO 120
  110 XX = NSPVAL
      YY = NSPVAL
C
  120 XT = XX
      YT = YY
      RETURN
      END

C
C $Id: histgr.f,v 1.10 2008-07-27 00:17:15 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE HISTGR( DAT1,NDIM,NPTS,IFLAG,CLASS,NCLASS,WRK,NWRK)
C
C PURPOSE       HISTGR plots a histogram with various options
C               including specification of class values,
C               spacing between histogram bars, shading of
C               bars, windowing (i.e. scaling), specification
C               of color, labels, titles, etc.  Data values
C               are partitioned into classes; histogram bars
C               represent either number of occurrences within
C               each class, or a Y-value associated with
C               that class (user choice).  Options are set
C               by calls to subroutines HSTOPL, HSTOPR, HSTOPC,
C               and HSTOPI before the call to HISTGR.
C
C USAGE         To draw a basic histogram (one utilizing
C               the default features):
C
C               CALL HISTGR (DAT1,NDIM,NPTS,IFLAG,CLASS,NCLASS,WRK,NWRK)
C
C               Error handling is performed by the ERPRT77
C               centralized error-handling package.  To
C               recover from a warning (recoverable error),
C               call ENTSR(IDUM,1) before calling HISTGR.
C               Otherwise an error message is printed and
C               the run is terminated.
C
C ARGUMENTS
C
C  ON INPUT     DAT1   Two dimensional real array containing data of one
C                      of two types, either values to be collected into
C                      class intervals before plotting, or values which
C                      have already been assigned to class intervals and
C                      only need to be displayed.  See argument IFLAG
C                      for a more complete description of HISTGR input
C                      data options.  DAT1 is dimensioned: DAT1(NDIM,2).
C
C               NDIM   The size of the first dimension of DAT1 as set
C                      in the dimension statement of the calling program.
C
C               NPTS   Number of values actually stored into DAT1 on this
C                      call.  NPTS must always be less than or equal to
C                      NDIM.
C
C               IFLAG  An integer flag which selects one of four options
C                      provided by the HISTGR utility.  The options are:
C
C                      IFLAG = 0;  A single array of length NPTS is loaded
C                                  into the DAT1 array.  HISTGR computes
C                                  NCLASS equally sized class intervals
C                                  that vary from the minimum value in
C                                  DAT1 to the maximum value in steps of
C                                  (MAX-MIN)/NCLASS.
C
C                                  All values of DAT1 that fall in each
C                                  class interval are separately accumulated
C                                  for that interval.  The final tabulations
C                                  are plotted as a histogram of NCLASS bars.
C                                  The bar height can be labeled with the
C                                  number of points that fall within this
C                                  particular class interval (bin size),
C                                  or it can be given as a percentage of
C                                  the number of values input, NPTS.
C
C                                  Note that under IFLAG = 0, the user
C                                  has no control over the range of the
C                                  class intervals.  They are internally
C                                  determined from the range of the data.
C
C                                  When missing values are present:
C
C                                  NPTS = Total input points
C                                  MISS = # of missing values
C                                  NMVA = NPTS - MISS
C
C                                  If MVA = ON, and NMV = OFF, the bin
C                                  percentages are computed relative to
C                                  NPTS.
C
C                                  If MVA = ON, and NMV = ON, the bin
C                                  percentages are computed relative to
C                                  NMVA.
C
C                                  If MVA = OFF, no checking is done for
C                                  missing values.
C
C                      IFLAG = 1   This option is similar to the IFLAG = 0
C                                  option except that the user can select
C                                  the range of the class intervals into
C                                  which the data are collected.  For
C                                  example, say the user wants to collect
C                                  the number of occurrences of the DAT1
C                                  values that fall within 5 equally spaced
C                                  intervals in the value range from 0. to
C                                  10.  The user would then input NCLASS+1
C                                  class interval end points into array
C                                  CLASS, namely 0., 2., 4., 6., 8., and
C                                  10.  These values need not be entered in
C                                  monotonically increasing order and need
C                                  not be equally spaced.
C
C                      IFLAG = 2   This option allows the user to enter
C                                  and display data which has already
C                                  been accumulated into class intervals,
C                                  i.e., already available histograms.
C                                  The data input to DAT1 thus have
C                                  percentage of total, or number of
C                                  occurrences values.  In this case the
C                                  number of points in DAT1, NPTS, is
C                                  equal to the number of class intervals
C                                  (histogram bars), NCLASS.  The NCLASS
C                                  class interval midpoints are loaded
C                                  into array CLASS.  They do not have to
C                                  be of equal width.
C
C                      IFLAG = 3   This option is the same as option
C                                  IFLAG = 2 except that two histograms
C                                  can be displayed for comparison purposes.
C                                  The first histogram is loaded into
C                                  DAT1(NPTS,1).  The second histogram is
C                                  loaded into DAT1(NPTS,2).  The first
C                                  histogram can partially shade or obscure
C                                  the second histogram by the appropriate
C                                  selection of the SPAC and OVERLP options.
C
C                      Note that NPTS = NCLASS when IFLAG = 2 or 3.
C
C               CLASS  Real array containing class values, dimensioned
C                      (NCLASS+1).  This array has the following IFLAG
C                      dependencies:
C                      IFLAG = 0   CLASS is not used.
C                      IFLAG = 1   NCLASS+1 class interval end points are
C                                  loaded into array CLASS.  They will be
C                                  sorted into a monotonically increasing
C                                  order, if not input in that order.  The
C                                  intervals need not be of equal width.
C                      IFLAG = 2   NCLASS midpoint intervals are loaded
C                                  into array CLASS.  They must be in
C                                  monotonically increasing order, but
C                                  need not be of equal widths.  The
C                                  histogram bars will however be displayed
C                                  with equal widths.
C                      IFLAG = 3   Same as for IFLAG = 2.
C
C               NCLASS Number of class intervals (histogram bars) specified.
C                      NCLASS must be .GE. 1.
C
C               WRK    Real scratch array, dimensioned by NWRK
C                      in the dimension statement of the calling program.
C
C               NWRK   The dimension size of array WRK determined from:
C                      NDIM + 3 * (NCLASS + 1)
C
C                Note: The frequency axis label values will be integers
C                      if the maximum Y-value (calculated within HISTGR)
C                      is an integer multiple of 4.  Otherwise, real
C                      values with format F11.1 are used.
C
C    ON OUTPUT  All arguments remain unchanged except the scratch
C               array WRK.
C
C ENTRY POINTS  HSTBKD, HSTEXP, HSTMED, HSTOPC, HSTOPL, HSTOPR,
C               HSTOPI, HSTSTR, HISTGR, HSTLST, NWTSTR, HSTBKDX
C
C COMMON BLOCKS HSTGC1, HSTGC2
C
C          I/O  Plots histograms using various options.
C
C    PRECISION  Single
C
C     REQUIRED  The ERPRT77 package and the SPPS.
C      LIBRARY
C        FILES
C
C REQUIRED GKS  0A
C        LEVEL
C
C     LANGUAGE  FORTRAN 77
C
C      HISTORY  First written in the fall of 1984.  Revised summer
C               of 1987.
C
C    ALGORITHM  Calculates occurrence of Y-values within classes, or
C               assigns Y-values to X-values (class mid-values),
C               depending on which flag is chosen by the user.
C               If Y-values are assigned to classes, class interval
C               boundaries are handled as follows.  Y-values which
C               fall on the left boundary of a class interval are
C               counted in that interval.  This accounts for all
C               Y-values at an interval boundary except for the right
C               boundary of the rightmost class interval.  Such
C               occurrences are added to the rightmost interval,
C               thus only this interval contains Y-values which
C               fall on either boundary.
C
C               Draws a histogram incorporating various user-defined
C               options.
C
C  PORTABILITY  FORTRAN 77
C
C
C A description of the option-setting entries of the package follows.
C
C-----------------------------------------------------------------------
C SUBROUTINE HSTOPL
C-----------------------------------------------------------------------
C
C   PURPOSE  To set various options for the package.
C
C     USAGE  CALL HSTOPL(STRING)
C
C ARGUMENTS  STRING      A character string (which may have up
C                        to seven characters) where the first
C                        2 or 3 characters are abbreviations for
C                        the option followed by '=', followed by
C                        'ON' or 'OFF'.  'OFF' may be abbreviated
C                        by 'OF'.   Imbedded spaces are not allowed.
C
C                        Example:  CALL HSTOPL('PER=OFF')
C
C             The following options are turned 'ON' or 'OFF' by this
C             routine (all defaults are listed at the end of the
C             package documentation):
C
C             HOR   Horizontal.
C                   The histogram bars are drawn horizontally if 'HOR=ON'.
C                   If 'HOR=OFF', they are drawn vertically.
C
C             PER   Percent axis.
C                   If 'PER=ON', a labeled percent axis is drawn on the
C                   right side of the histogram (or on top if
C                   horizontal.)  If 'PER=OFF', the percent axis is
C                   not drawn.
C
C             MID   Midvalues.
C                   If 'MID=ON', the class labels are put at the
C                   midpoint of each interval. If 'MID=OFF', the class
C                   interval end points are labeled.  MID defaults
C                   to ON if IFLAG = 2 or 3.
C
C             SHA   Shading.
C                   If 'SHA=ON', the histogram rectangles are shaded.
C                   If 'SHA=OFF', the bars are not shaded.  Laser printers
C                   may vary as to how they interpret shading;
C                   some will shade the bars black, others
C                   will only draw the outline, etc., depending
C                   on whether or not they support FILL AREA in
C                   hardware.  On color terminals, the shading
C                   will correspond to whatever the RGB color
C                   table assigns to color index 1, even when
C                   the color option, 'COL=OFF', (and all
C                   other portions of the histogram are white).
C                   Terminals which do not support FILL AREA or
C                   color will show the outline of the 'shaded'
C                   histogram bars in white (they will appear to
C                   be unshaded).
C
C             DRL   Draw lines.
C                   If 'DRL=ON', lines are drawn through the histogram
C                   rectangles where Y-axis tick marks would occur.
C                   When IFLAG = 3 (when comparing two datasets
C                   in one histogram), lines are drawn through
C                   the bars associated with the first dataset
C                   only.  If 'DRL=OFF', lines are not drawn.
C
C             MED   Median.
C                   If 'MED=ON', a line is drawn through the median
C                   of all points.  If 'MED=OFF', this line is not drawn.
C                   MED does not apply when assigning Y-values to
C                   X-values; it is valid only for IFLAG = 1 or 2.
C
C             NMV    Normalize minus missing values.
C                    If 'NMV=ON', histogram bar percentages will be
C                    calculated with respect to the number of input
C                    data values (NPTS) minus the number of detected
C                    missing values (MISS), or NMVA = NPTS - MISS.
C
C                    If 'NMV=OFF', histogram bar percentages will be
C                    normalized to NPTS.
C
C             PMV    Print missing value count.
C                    If 'PMV=ON', missing value counts will be written
C                    on the plot.  If 'NMV=OFF', they will not.
C
C             PRM   Perimeter.
C                   If 'PRM=ON', a perimeter is drawn around the
C                   histogram.  If 'PRM=OFF', no perimeter is drawn.
C
C             FRA   Frame advance.
C                   If 'FRA=ON', the frame is advanced automatically
C                   after the histogram is drawn.
C                   If 'FRA=OFF', the frame is not advanced, and the
C                   user must call FRAME.
C
C             LIS   List options.
C                   If 'LIS=ON', all the options along with their values
C                   are printed on the standard output.
C                   If 'LIS=OFF', nothing is printed on the standard output.
C
C             DEF   Global defaults.
C                   If 'DEF=ON', all the options are set to their default
C                   values;  see list of default values below.
C                   'DEF=OFF' has no effect.
C
C-----------------------------------------------------------------------
C SUBROUTINE HSTOPR
C-----------------------------------------------------------------------
C
C
C   PURPOSE  To specify various REAL arrays to be used by the
C            HISTGR package.
C
C     USAGE  CALL HSTOPR(STRING,ARRAY,LARR)
C
C            STRING  A character string specifying which
C                    option is to be set.  Valid options are:
C
C                    'WIN=ON', or 'WIN=OFF'
C                    'SPA=ON', or 'SPA=OFF'
C                    'MVA=ON', or 'MVA=OFF'
C
C                    WIN defines the portion of the frame which will
C                    receive the histogram.  SPA determines the spacing
C                    between histogram bars.
C
C             ARRAY  A real array of length LARR.
C
C              LARR  Dimension of ARRAY.
C
C       The following arrays may be defined by this routine:
C
C       Windowing:
C
C                 STRING is 'WIN=ON'
C                 LARR = 4
C                 ARRAY(1) = XMIN
C                 ARRAY(2) = XMAX
C                 ARRAY(3) = YMIN
C                 ARRAY(4) = YMAX
C
C                 Assumptions:  These coordinates define a rectangular
C                 region of the total frame where the current histogram
C                 is to be plotted.  The range of allowed values is:
C
C                    0. <= XMIM < XMAX <= 1.
C                    0. <= YMIM < YMAX <= 1.
C
C                 For example, XMIN=0., XMAX=0.5, YMIN=0.5, and YMAX=1.0
C                 would specify the upper left quadrant of the frame.
C
C                 If 'WIN=OFF', the default window for the histogram
C                 will be the entire frame.
C
C       EXAMPLE:  REAL WINDOW(4)
C                 DATA WINDOW /.3,.7,.3,.7/
C                 CALL HSTOPR('WIN=ON',WINDOW,4)
C
C       Spacing:
C
C                 STRING is 'SPA=ON'
C                 LARR = 2
C                 ARRAY(1) = SPAC
C                 ARRAY(2) = OVERLP
C
C       SPAC  Real value used to set spacing of histogram bars; valid
C             values are 0.0 (no spacing) to 4.0 (maximum spacing).
C             Default spacing is SPAC = 2.0.  If 'SPA=OFF', the result
C             is the same as if SPAC = 0.0, and the value supplied in
C             ARRAY(1) is ignored by HISTGR.  Lines will be drawn
C             around the histogram bars when 'SPA=OFF' by default.
C             These may not be visible if 'SHA=ON' and the first
C             color index is set to white in the color table; it is
C             a good idea to set color index 1 to gray if 'SPA=OFF',
C             and 'SHA=ON' (for terminals without color capabilty, this
C             does not apply; see notes on 'SHA' above). If IFLAG = 3,
C             there is a minimum amount of spacing supplied, even if
C             SPAC = 0.0, to allow room for the histogram bars of the
C             second dataset.
C
C     OVERLP  Real value used to set overlap of adjacent histogram
C             bars when comparing two datasets in one histogram;
C             valid values are -4.0 (maximum overlap) to 4.0 (little
C             or no overlap).  OVERLP applies only when IFLAG = 3.
C             Default overlap is OVERLP = 0.0.  If 'SPA=OFF',
C             OVERLP is ignored by HISTGR.  If no overlap is desired,
C             set OVERLP to 4.0, and SPAC to 3.0 or greater.
C
C       EXAMPLE:  REAL ARRAY(2)
C                 IFLAG = 3
C                 ARRAY(1) = 2.0
C                 ARRAY(2) = -1.5
C                 CALL HSTOPR('SPA=ON',ARRAY,2)
C
C             The above example would cause two sets of histograms
C             to have overlapping bars for comparison purposes.
C
C       Special value detection:
C
C             MVA   Special value flag. If MVA=ON
C                   ARRAY(1) = The special value to be ignored
C                              when it is observed in the input data.
C                   ARRAY(2) = The epsilon to use in comparing the
C                              input data to the special value.
C
C        EX:       ARRAY(1) = -9999.
C                  ARRAY(2) = 1.E-10
C                  CALL HSTOPR('MVA=ON',ARRAY,2)
C
C
C-----------------------------------------------------------------------
C SUBROUTINE HSTOPC
C-----------------------------------------------------------------------
C
C   PURPOSE  To specify various CHARACTER variables to be used by the
C            HISTGR package.
C
C     USAGE  CALL HSTOPC(STRING,STRNG2,NUMBER,ILCH)
C
C            STRING  A character string specifying which
C                    option is to be set.  Valid options are:
C
C                    'FOR=ON', or 'FOR=OFF'
C                    'TIT=ON', or 'TIT=OFF'
C                    'LAB=ON', or 'LAB=OFF'
C                    'FQN=ON', or 'FQN=OFF'
C                    'PTI=ON', or 'PTI=OFF'
C                    'CHR=ON', or 'CHR=OFF'
C
C                    By choosing the ON form for an option, the user
C                    can override the default setting of that option.
C                    A subsequent call to HSTOPC with the OFF form
C                    for an option returns the option to the default
C                    setting.  All defaults are listed below.
C
C            STRNG2  A character string up to 45 characters long.
C
C                    This argument depends upon the ON form being
C                    selected for an option.  For example, if 'TIT=ON',
C                    a main title is input through argument STRNG2.
C
C            NUMBER  An integer variable which only applies to the
C                    following three options:
C
C                    'FOR=ON'  The maximum number of class intervals
C                    (histogram bars) which will be labeled.
C
C                    'FOR=OFF'  Defaults to 9 labels for vertical bars
C                    and 15 labels for horizontal bars.
C
C                    'CHR=ON'  Must be set to NCLASS, an argument of
C                    the subsequent call to be made to HISTGR.
C
C                    NUMBER is not used under any other option setting.
C
C                    Calls to HSTOPC with both 'FOR=ON' and 'CHR=ON'
C                    may be performed in any order; the parameters set
C                    by NUMBER are mutually exclusive in either case.
C
C              ILCH  An integer variable specifying the number of
C                    characters in each label of a class interval
C                    (histogram bar).  This argument is only used with
C                    the 'CHR=ON' option.
C
C                    ILCH cannot be greater than 15.
C
C      The following options are defined by this subroutine:
C
C         FOR     Format for class labels.  The 'FOR=OFF' default
C                 format is '(G10.3)'.  Although class values
C                 are real numbers, integer formats are allowed,
C                 in which case HISTGR will convert from real to
C                 integer before plotting labels.
C
C         TIT     A main title.  The 'TIT=OFF' default is no title.
C                 It can be up to 96 characters.  If it is greater
C                 than 45 characters it will be written in multiple
C                 centered lines at no more than 45 characters per line.
C
C         LAB     A label for the class interval(histogram bar) axis.  The
C                 'LAB=OFF' default value is 'CLASS INTERVALS' when
C                 the HSTOPL option 'MID=OFF' is selected, and 'CLASS
C                 MIDVALUES' otherwise.
C
C                 In order to delete this axis label select 'LAB=ON'
C                 for STRING and 'NOLABEL' for STRNG2.
C
C         FQN     The frequency axis label.  The 'FQN=OFF' default value
C                 is 'FREQUENCY'.
C
C                 In order to delete this axis label select 'FQN=ON'
C                 for STRING and 'NOLABEL' for STRNG2.
C
C         PTI     The percent axis label.  The 'PTI=OFF' default value
C                 is 'PERCENT OCCURRENCE' when IFLAG = 0, or 1,
C                 'PERCENT of MAXIMUM' when IFLAG = 2, or 3.
C                 In order to delete this axis label select 'PTI=ON'
C                 for STRING and 'NOLABEL' for STRNG2.
C
C         CHR     Character labels.
C                 Use a character string containing ILCH*NUMBER
C                 characters to specify alphanumeric labels for the
C                 class intervals (histogram bars).  This is a packed
C                 sting of ILCH characters per class interval label.
C
C                 The character string must contain NUMBER(=NCLASS)
C                 class interval labels, even though all may not be
C                 used.  See the definition of argument NUMBER.
C
C    EXAMPLE:     PARAMETER (NCLASS=12, ILCH=3)
C                 CHARACTER*36 LABEL
C                 CALL HSTOPC ('TIT=ON','MONTHLY PRECIPITATION in 1987',12,3)
C                 LABEL = 'JANFEBMARAPRMAYJUNJULAUGSEPOCTNOVDEC'
C                 CALL HSTOPC ('CHR=ON',LABEL,12,3)
C                 CALL HSTOPC ('FOR=ON','(F3.0)',12,3)
C
C                 In the above example, there will be 12 alphanumeric
C                 class interval labels, each containing 3 characters
C                 to specify the months of the year.  The main title
C                 indicates that the histogram depicts monthly precipitation
C                 in 1987.
C
C                 The call to HSTOPC with 'FOR=ON' and NUMBER = 12
C                 overrides the default number (9) of labels which would
C                 be plotted.  Note that the '(F3.0)' format is ignored
C                 because 'CHR=ON'.
C
C-----------------------------------------------------------------------
C SUBROUTINE HSTOPI
C-----------------------------------------------------------------------
C
C   PURPOSE  To specify various INTEGER variables to be used by the
C            HISTGR package.
C
C     USAGE  CALL HSTOPI( STRING, PARAM1, PARAM2, ICOL, LCOL )
C
C ARGUMENTS
C
C            STRING  A character string specifying which
C                    option is to be set.  Valid options are:
C
C                    'COL=ON', or 'COL=OFF'
C                    'CLA=ON', or 'CLA=OFF'
C
C                    By choosing the ON form for an option, the user
C                    can override the default setting of that option.
C                    A subsequent call to HSTOPI with the OFF form
C                    for an option returns the option to the default
C                    setting.  All defaults are listed below.
C
C            PARAM1  Integer variable used to set character height of
C                    class labels when 'CLA=ON'; 1 = small, 2 = medium
C                    3 = large; default is 2 when 'CLA=OFF'.
C
C                    Not used when 'COL=ON', or 'COL=OFF'.
C
C            PARAM2  Integer variable used to set orientation of class
C                    labels, from 0 (horizontal) to 90 (vertical) degrees
C                    when 'CLA=ON'; default is 0 degrees when 'CLA=OFF'.
C
C                    Not used when 'COL=ON', or 'COL=OFF'.
C
C            ICOL    Integer array containing values defining color
C                    indices 1-8, for use with 'COL=ON'.
C
C                    The eight components of the plot for which color
C                    indicies can be set are:
C
C                    ICOL(1) = color index used for shading rectangles
C                    ICOL(2) = color index used for shading second set
C                          of rectangles (comparing two datasets
C                          when IFLAG=3).
C                    ICOL(3) = color index used for rectangle outlines
C                    ICOL(4) = color index used for drawing axes
C                    ICOL(5) = color index used for drawing median line
C                    ICOL(6) = color index used for text ouput (labels)
C                    ICOL(7) = color index used for title
C                    ICOL(8) = color index used for drawing perimeter
C
C                    The default color index is 1 for all (when 'COL=OFF').
C
C                    If 'COL=ON', the color indices and their associated
C                    colors are as follows (these may be changed by setting
C                    an RGB color table prior to your call to HSTOPI):
C
C                       0 = BLACK
C                       1 = WHITE
C                       2 = RED
C                       3 = GREEN
C                       4 = BLUE
C                       5 = CYAN
C                       6 = MAGENTA
C                       7 = YELLOW
C                       8 = ORANGE
C
C                    ICOL is not used when 'CLA=ON', or 'CLA=OFF'.
C
C            LCOL    Integer variable specifying length of array ICOL.
C                    LCOL must be set to 8.
C
C                    LCOL is not used when 'CLA=ON', or 'CLA=OFF'.
C
C-----------------------------------------------------------------------
C SUMMARY OF OPTION DEFAULTS:
C-----------------------------------------------------------------------
C
C     HSTOPL:
C         'HOR=OFF', histogram bars will be vertical.
C         'PER=ON',  a labeled percent axis is drawn on the right side
C                    of the histogram (or on top if horizontal.)
C         'MID=ON',  labels are placed at the midpoint of each histogram bar.
C         'SHA=ON',  the histogram rectangles are shaded.
C         'DRL=OFF', lines corresponding to plotted scale values are not
C                    drawn through the histogram bars.
C         'MED=OFF', a line denoting the median of all points is not
C                    drawn on the histogram.
C         'NMV=ON',  histogram bar percentages will be calculated
C                    with respect to (Input points - missing values.)
C         'PMV=ON',  missing value counts will be written on the plot.
C                       NMV and PMV will only occur if HSTOPR
C                       option MVA=ON.
C         'PRM=OFF', a perimeter around the histogram is not drawn.
C         'FRA=ON',  a frame advance will occur after the call to HISTGR.
C         'LIS=OFF', nothing is printed on the standard output unit.
C
C     HSTOPR:
C         'WIN=OFF', the histogram will be drawn within the maximum viewport
C                    of 0.0 to 1.0 in both the horizontal and vertical.
C         'SPA=ON',  default values: spacing = 2.0, overlap = -1.0
C                    This will yield spacing between bars on a single
C                    histogram and overlap of bars in the comparison
C                    of two histograms.
C         'MVA=OFF', No checking of data will be done for special values.
C
C     HSTOPC:
C         'TIT=OFF', no main title is drawn.
C         'FQN=OFF', a frequency axis title 'FREQUENCY' is drawn.
C         'PTI=OFF', a percent axis title 'PERCENT OCCURRENCE' is drawn
C                    when IFLAG = 0, or 1, 'PERCENT of MAXIMUM' when
C                    IFLAG = 2, or 3.
C         'LAB=OFF', class interval axis title defaults to 'CLASS INTERVALS'
C                    when 'MID=OFF' and 'CLASS MIDVALUES' when 'MID=ON'.
C         'FOR=OFF', class label format = '(G10.3)'.
C         'CHR=OFF', generate numeric (real or integer) class labels.
C
C     HSTOPI:
C         'COL=OFF', color index 1 is used for all output.
C         'CLA=ON',  default values: 2 = medium, 0 = horizontal labels.
C
C-----------------------------------------------------------------------
C
      COMMON /HSTGC1/ HORZNT, PERCNT, MIDVAL, SHADE, MEDIAN, PERIM,
     -       HFRAME, LISTOP, WINDOW, COLORS, HSTFOR, TITLE, LABEL,
     -       FREQNC, HWIND(4), COLSHA, COLREC, COLAXI, COLMED, COLTEX,
     -       COLTIT, COLPER, DRAWL, SPACE, LABMAX, CHARL, HEIGHT,
     -       ORIENT, COLSH2, SETSPA, SETSP2, MVALU, SETMVA, SETEPS,
     -       NMVAL, PMVAL, PERTIT
      LOGICAL HORZNT, PERCNT, MIDVAL, SHADE, MEDIAN, PERIM, HFRAME,
     -        LISTOP, WINDOW, COLORS, HSTFOR, TITLE, LABEL, FREQNC,
     -        DRAWL, SPACE, CHARL, MVALU, NMVAL, PMVAL, PERTIT
      COMMON /HSTGC2/ STRFOR, STRTIT, STRLAB, STRFRE, STRPER, LABTEX
      CHARACTER*96  STRTIT
      CHARACTER*55  STRFOR, STRLAB, STRFRE, STRPER
      CHARACTER*15 LABTEX(30), TEX, TESTCH, LTEX
      CHARACTER*1 BLANK
C
      INTEGER  NDIM, NPTS, NCLASS, NWRK
      INTEGER  COLSHA, COLREC, COLAXI, COLMED, COLTEX
      INTEGER  COLTIT, COLPER, HEIGHT, ORIENT, COLSH2
      INTEGER  FIRST, LAST, LASF(13)
      INTEGER  OLDALH, OLDALV
      INTEGER  OCOLI, OTEXCI
      REAL     DAT1(NDIM,2), HI, LOW, MED, CLASS(NCLASS+1)
      REAL     WRK(NWRK)
      REAL     PX(7), PY(7), NEXTX, YTICKS(4), TICINT, PER(4)
      REAL     OWIND(4), OVIEW(4), VUPORT(4)
      REAL     NEWWIN(4), LASTLB
      LOGICAL  DONE, COMPAR, SPEC, ASSIGN
      DATA BLANK /' '/
C
C Do a call forcing a BLOCKDATA to be loaded from a binary library.
C
      CALL HSTBKD
C
C  THE FOLLOWING IS FOR GATHERING STATISTICS ON LIBRARY USE AT NCAR
C
      CALL Q8QST4('GRAPHX','HISTGR','HISTGR','VERSION 01')
C
C  INTIALIZE ERROR COUNT
C
      NERR = 0
C
C  GET STANDARD ERROR MESSAGE UNIT
C
        IERUNT = I1MACH(4)
C
C  PERFORM ERROR CHECKING
C
      IF (NPTS .LT. 1) THEN
          NERR = NERR + 1
          CALL SETER(' HISTGR--NPTS LESS THAN 1',NERR,2)
      ENDIF
      IF (NCLASS .LT. 1) THEN
          NERR = NERR + 1
          CALL SETER(' HISTGR--NCLASS LESS THAN 1',NERR,2)
      ENDIF
      IF (NPTS .GT. NDIM) THEN
          NERR = NERR + 1
          CALL SETER(' HISTGR--NPTS .GT. NDIM',NERR,2)
      ENDIF
      IF (NWRK .LT. (NDIM+3*NCLASS+3)) THEN
          NERR = NERR + 1
          CALL SETER(' HISTGR--NWRK .LT. NDIM+3*NCLASS+3',NERR,2)
      ENDIF
      IF (IFLAG .EQ. 2 .AND. NPTS .NE. NCLASS) THEN
          NERR = NERR + 1
          CALL SETER(' HISTGR--NCLASS .NE. NPTS (IFLAG=2)',NERR,2)
      ENDIF
      IF (IFLAG .EQ. 3 .AND. NPTS .NE. NCLASS) THEN
          NERR = NERR + 1
          CALL SETER(' HISTGR--NCLASS .NE. NPTS (IFLAG=3)',NERR,2)
      ENDIF
C
C  IF LISTOP IS ON, LIST ALL OPTION VALUES
C
      IF (LISTOP) THEN
          CALL HSTLST
      ENDIF
C
C  SET POLYLINE COLOR ASF TO INDIVIDUAL
C
        CALL GQASF(IERR,LASF)
        OPLASF = LASF(3)
        LASF(3) = 1
        OTXASF = LASF(10)
        LASF(10) = 1
C
C  Set ASF parameters to 1 (individual)
C
      DO 100 I = 1,13
        LASF(I) = 1
  100 CONTINUE
        CALL GSASF(LASF)
C
C  INQUIRE CURRENT POLYLINE COLOR
C
        CALL GQPLCI(IERR,OCOLI)
C
C  INQUIRE CURRENT NORMALIZATION NUMBER
C
        CALL GQCNTN(IERR,ICNT)
C
C  INQUIRE CURRENT WINDOW AND VIEWPORT LIMITS
C
        CALL GQNT(ICNT,IERR,OWIND,OVIEW)
C
C  INQUIRE AND SAVE TEXT ATTRIBUTES
C
          CALL GQCHH(IERR,OLDCHH)
          CALL GQCHUP(IERR,CHUPX,CHUPY)
          CALL GQTXAL(IERR,OLDALH,OLDALV)
          CALL GQTXCI (IERR,OTEXCI)
C
C  SET TEXT COLOR
C
      IF (COLORS) CALL GSTXCI(COLTEX)
C
C  INITIALIZE VARIABLES
C
      IF (.NOT. HSTFOR) THEN
	IF (HORZNT) THEN
	  LABMAX = 15
        ELSE
	  LABMAX = 9
        ENDIF
      ENDIF
      DONE = .FALSE.
C
      LENWRK = NDIM+3*NCLASS+3
      INDY1 = NDIM + NCLASS + 1
      INDY2 = INDY1 + NCLASS + 1
C       PRINT *,' LENWRK INDY1 INDY2',LENWRK,INDY1,INDY2
       DO 110 I = 1,LENWRK
          WRK(I) = 0.
  110   CONTINUE
C
C  Check to see if CLASS values have been assigned
C
      SPEC = .FALSE.
      ASSIGN = .FALSE.
      COMPAR = .FALSE.
      IF (IFLAG .EQ. 1) THEN
        SPEC = .TRUE.
      ELSEIF (IFLAG .EQ. 2) THEN
        ASSIGN = .TRUE.
      ELSEIF (IFLAG .EQ. 3) THEN
        COMPAR = .TRUE.
      ELSEIF (IFLAG .NE. 0) THEN
        NERR = NERR + 1
        CALL SETER(' HISTGR--IFLAG NOT SPECIFIED OR INVALID',NERR,1)
        CALL ERROF
        WRITE(IERUNT,1001)
 1001 FORMAT(' HISTGR--IFLAG NOT SPECIFIED OR INVALID')
      ENDIF
C
  150 CONTINUE
      IF ((ASSIGN .OR. COMPAR) .AND. (NCLASS .NE. NPTS)) THEN
        NERR = NERR + 1
        CALL SETER(' HISTGR--NCLASS MUST EQUAL NPTS ',NERR,1)
        CALL ERROF
        WRITE(IERUNT,1002)
 1002 FORMAT(' HISTGR--NCLASS MUST EQUAL NPTS ')
      ENDIF
C
C  DO SHELL SORT, FIND MEDIAN OF ALL DATA POINTS
C
C  If IFLAG = 0, or 1, and MVALU .EQ. .TRUE.
C     reject missing values
C
      IF (IFLAG.LT.2) THEN
	IF (MVALU) THEN
	NMVA = 0
	MISS = 0
	DO 155 I = 1,NPTS
	NMVA = NMVA + 1
	WRK(NMVA) = DAT1(I,1)
	DIF = DAT1(I,1)-SETMVA
	 IF(ABS(DIF).LT.SETEPS) THEN
	 MISS = MISS + 1
C         IF(MISS.LE.5) THEN
C       PRINT *,' Special value detected at point ',I
C       PRINT *,'  DAT1(I,1) =',DAT1(I,1),' DIF =',DIF,' SETMVA =',
C    1  SETMVA,' SETEPS =',SETEPS
C         END IF
C
C  This is a special value.  Ignore it.
C
	 WRK(NMVA) = 0.
	 NMVA = NMVA - 1
	 END IF
  155 CONTINUE
	GO TO 157
	END IF
       END IF
C
	DO 156 I = 1,NPTS
        WRK(I)=DAT1(I,1)
        IF (ASSIGN .OR. COMPAR) WRK(I)=ABS(DAT1(I,1))
  156   CONTINUE
	NMVA = NPTS
C
  157   CONTINUE
C       PRINT *,' NMVA =',NMVA
C       PRINT *,' WRK =',WRK
C
      IF (NMVA .LT. 1) THEN
          NERR = NERR + 1
	  CALL SETER(' HISTGR--NMVA LESS THAN 1',NERR,2)
	  RETURN
      ENDIF
C
      CALL HSTMED(WRK,NMVA,WRK,MED)
C       PRINT *,' MEDIAN =',MED
C
C  Determine Upper and Lower Bounds of DAT1, and
C  sort values in CLASS, if supplied
C
      IF (SPEC) THEN
        CALL HSTMED(CLASS,NCLASS+1,WRK(NPTS+1),AMUD1)
        HI = WRK(NPTS+NCLASS+1)
        LOW = WRK(NPTS+1)
        DO 170 I = 1,NCLASS + 1
          CLASS(I) = WRK(NPTS+I)
  170   CONTINUE
      ELSEIF (ASSIGN .OR. COMPAR) THEN
        HI = CLASS(NPTS)
        LOW = CLASS(1)
      ELSE
	HI = WRK(NMVA)
        LOW =  WRK(1)
      ENDIF
C
C Compute X intervals
C
      IF (ASSIGN .OR. COMPAR) THEN
        XINT = (HI - LOW) / REAL(NCLASS-1)
        HAFINT = XINT / 2.
      ELSE
        XINT = (HI - LOW) / REAL(NCLASS)
        HAFINT = XINT / 2.
      ENDIF
C
C Set Extra Spacing if specified in HSTOPI
C
      SPAC1 = ABS(SETSPA*(XINT/10.))
      IF (COMPAR) SPAC1 = ABS(SETSPA*(XINT/16.))+XINT/8.
      SPAC2 = SETSP2*(XINT/16.)
C
C  DETERMINE XMIN,XMAX
C
      IF ( ASSIGN .OR. COMPAR ) THEN
        XMIN = LOW - XINT
        IF ( COMPAR ) XMIN = LOW - XINT/2 - SPAC1
      ELSE
        XMIN = LOW - HAFINT
      ENDIF
C
C  FILL IN X ARRAY, WRK(NPTS+1), FOR SHADING (LATER)
C
      XPOS = XMIN + XINT
      IF ( COMPAR ) XPOS = XMIN + XINT/2 + SPAC1
      DO 200 I = 1,NCLASS + 1
          WRK(NPTS+I) = XPOS
  200 XPOS = XPOS + XINT
      XMAX = WRK(NPTS+NCLASS + 1)
      IF ( COMPAR ) XMAX = MIN(WRK(NPTS+NCLASS+1) + SPAC2,
     1 WRK(NPTS+NCLASS+1))
      IF ( XMIN .EQ. XMAX ) THEN
        NERR = NERR + 1
        CALL SETER(' HISTGR--MIN. X-VALUE .EQ. MAX. X-VALUE',NERR,1)
        CALL ERROF
        WRITE(IERUNT,210)
  210 FORMAT(' HISTGR--MIN. X-VALUE .EQ. MAX. X-VALUE')
      ENDIF
C
C  COMPUTE NUMBER OF RECTANGLES TO BE LABELLED
C
      IF (MIDVAL .OR. (COMPAR .OR. ASSIGN)) THEN
          NUMLAB = NCLASS
      ELSE
          NUMLAB = NCLASS + 1
      ENDIF
C
C  Y ARRAY (DETERMINE FREQUENCY FOR EACH CLASS)
C
      DO 310 I = 1,NCLASS
        IF (.NOT. (ASSIGN .OR. COMPAR)) THEN
          IF ( SPEC ) THEN
            TM1 = CLASS(I)
            TM2 = CLASS(I+1)
          ELSE
            TM1 = WRK(NPTS+I) - HAFINT
            TM2 = WRK(NPTS+I) + HAFINT
          ENDIF
	  DO 300 J = 1,NMVA
	    TM3 = WRK(J)
            IF ((TM3 .GE. TM1) .AND. (TM3 .LT. TM2)) THEN
              WRK(INDY1+I) = WRK(INDY1+I) + 1.
            ELSE
C
C  The last histogram class interval receives DAT1 values which fall
C  on either the right or left bar boundary.  All others receive only
C  values that fall on the left boundary.
C
              IF (I .EQ. NCLASS .AND. TM3 .EQ. TM2) THEN
                WRK(INDY1+I) = WRK(INDY1+I) + 1.
              ENDIF
            ENDIF
  300     CONTINUE
        ELSE
          TM1 = WRK(NPTS+I) - HAFINT
          TM2 = WRK(NPTS+I) + HAFINT
          TM3 = CLASS(I)
          IF ((TM3 .GE. TM1) .AND. (TM3 .LT. TM2)) THEN
            WRK(INDY1+I) = ABS(DAT1(I,1))
            IF (COMPAR) WRK(INDY2+I) = ABS(DAT1(I,2))
          ENDIF
        ENDIF
  310 CONTINUE
C
C  FIND MAX Y AND ADJUST Y WINDOW LIMIT
C
      YBOUND = WRK(INDY1+1)
      DO 400  I = 1,NCLASS
          YBOUND = MAX(YBOUND,WRK(INDY1+I),WRK(INDY2+I))
 400  CONTINUE
      IF (YBOUND .EQ. 0.) THEN
        NERR = NERR + 1
        CALL SETER(' HISTGR--MAXIMUM Y-VALUE .EQ. 0.0',NERR,1)
        CALL ERROF
        WRITE(IERUNT,410)
  410 FORMAT(' HISTGR--MAXIMUM Y-VALUE .EQ. 0.0')
      ENDIF
      IF (YBOUND .LT. 1.) THEN
          YMAX = 0.02*INT(YBOUND/.02 + 1.)
      ELSEIF (YBOUND .LT. 10.) THEN
          YMAX = 0.2*INT(YBOUND/.2 + 1.)
      ELSEIF (YBOUND .LT. 100.) THEN
          YMAX = 2.*INT(YBOUND/2. + 1.)
      ELSEIF (YBOUND .LT. 1000.) THEN
          YMAX = 20.*INT(YBOUND/20. + 1.)
      ELSEIF (YBOUND .LT. 10000.) THEN
          YMAX = 200.*INT(YBOUND/200. + 1.)
      ELSEIF (YBOUND .LT. 100000.) THEN
          YMAX = 2000.*INT(YBOUND/2000. + 1.)
      ELSEIF (YBOUND .LT. 1000000.) THEN
          YMAX = 20000.*INT(YBOUND/20000. + 1.)
      ELSEIF (YBOUND .LT. 10000000.) THEN
          YMAX = 200000.*INT(YBOUND/20000. + 1.)
      ELSE
          YMAX = 100000000.
      ENDIF
C
C  DETERMINE Y-AXIS TICK SPACING AND EQUIVALENT PERCENTAGES
C
      TICINT = YMAX / 4.
      YTICKS(1) = TICINT
      YTICKS(2) = TICINT * 2.
      YTICKS(3) = TICINT * 3.
      YTICKS(4) = YMAX
      IF (PERCNT) THEN
	  DEN = REAL(NPTS)
	  IF(NMVAL) DEN = REAL(NMVA)
	  PERC = YMAX / DEN * 100.
          IF (ASSIGN .OR. COMPAR) PERC = (YMAX/YBOUND)*100.
          PER(1) = PERC / 4.
          PER(2) = PER(1) * 2.
          PER(3) = PER(1) * 3.
          PER(4) = PERC
      ENDIF
C
C  SET UP WINDOW COORDINATES
C
      IF (HORZNT) THEN
          CALL GSWN(1,0.,YMAX,XMIN,XMAX)
          VUPORT(1) = .20
          VUPORT(2) = .90
          VUPORT(3) = .1
          VUPORT(4) = .85
      ELSE
          CALL GSWN(1,XMIN,XMAX,0.,YMAX)
          VUPORT(1) = .15
          VUPORT(2) = .85
          VUPORT(3) = .15
          VUPORT(4) = .85
      ENDIF
      IF (WINDOW) THEN
          DO 500 I = 1,4
            IF (HWIND(I) .LT. 0. .OR. HWIND(I) .GT. 1.) THEN
              NERR = NERR + 1
            CALL SETER(' HISTGR--WINDOW OPTION ERROR, RANGE IS 0. - 1.',
     - NERR,1)
              CALL ERROF
              HWIND(1) = 0.
              HWIND(2) = 1.
              HWIND(3) = 0.
              HWIND(4) = 1.
              GOTO 510
            ENDIF
  500 CONTINUE
  510 CONTINUE
          WXRANG = HWIND(2) - HWIND(1)
          WYRANG = HWIND(4) - HWIND(3)
          VUPORT(1) = HWIND(1) + VUPORT(1)*WXRANG
          VUPORT(2) = HWIND(1) + VUPORT(2)*WXRANG
          VUPORT(3) = HWIND(3) + VUPORT(3)*WYRANG
          VUPORT(4) = HWIND(3) + VUPORT(4)*WYRANG
      ELSE
          HWIND(1) = 0.
          HWIND(2) = 1.
          HWIND(3) = 0.
          HWIND(4) = 1.
      ENDIF
      CALL GSVP(1,VUPORT(1),VUPORT(2),VUPORT(3),VUPORT(4))
      CALL GSELNT(1)
C
C  EXPAND WINDOW AND VEIWPORT FOR LABELING
C  DETERMINE CHARACTER HEIGHT AND TICK LENGTHS
C
      CALL HSTEXP(HWIND,NEWWIN)
      FRACT = 18./1024.
      YRANGE = ABS(NEWWIN(4) - NEWWIN(3))
      XRANGE = ABS(NEWWIN(2) - NEWWIN(1))
      IF (HORZNT) THEN
          XTIC = FRACT * XRANGE
          YTIC = FRACT * YRANGE
      ELSE
          XTIC = FRACT * YRANGE
          YTIC = FRACT * XRANGE
      ENDIF
      XDEC = .8 * XTIC
      YDEC = .8 * YTIC
      CHARH = 14.
      CALL GSCHH(CHARH)
C
C  DRAW FREQUENCY-AXIS
C
      IF (COLORS) CALL GSPLCI(COLAXI)
      PX(1) = XMIN
      PX(2) = XMIN
      PY(1) = 0.
      PY(2) = YMAX
C
C Draw the frequency axis.
C
      IF (HORZNT) THEN
          CALL GPL(2,PY,PX)
C                            CENTER,TOP
          CALL GSTXAL(2,1)
      ELSE
          CALL GPL(2,PX,PY)
C                            RIGHT,HALF
          CALL GSTXAL(3,3)
      ENDIF
C
C Compute tick marks on the frequency axis.
C
      PX(1) = XMIN
      PX(2) = XMIN + 0.6*HAFINT
      IF ( COMPAR ) PX(2) = XMIN + 0.3*HAFINT
      IF(HORZNT) THEN
	XPOS = XMIN - 1.5*YDEC
      ELSE
        XPOS = XMIN - 1.0*YDEC
      ENDIF
C
C Test to see if Frequency labels are all integers
C
      JJ = 0
      DO 520 I = 1,4
          PY(1) = YTICKS(I)
        IF (PY(1) .EQ. INT(PY(1))) JJ = JJ + 1
  520 CONTINUE
C
C Loop over the four tick marks and scales on the frequency axis.
C
      DO 530 I = 1,4
          PY(1) = YTICKS(I)
          PY(2) = PY(1)
          YPOS = PY(1)
          FNUM = PY(1)
          IFNUM = INT(PY(1))
C
C Choose integer format for axis labels
C
        IF (JJ .EQ. 4) THEN
	      IF (YMAX .GT. 199998.) THEN
		CHARH = 10.
                CALL GSCHH(CHARH)
              ENDIF
          WRITE(TEX,'(I11)')IFNUM
        ELSE
C
C Choose real format for axis labels
C
	      IF (YMAX .GT. 1998.) THEN
		CHARH = 10.
                CALL GSCHH(CHARH)
              ENDIF
          WRITE(TEX,'(F11.1)')FNUM
        ENDIF
C
C Draw tick marks and print scales on the frequency axis
C
          CALL HSTSTR(TEX,FIRST,LAST)
	  IF (HORZNT) THEN
              CALL GPL(2,PY,PX)
              CALL NWTSTR(YPOS,XPOS,TEX(FIRST:LAST))
          ELSE
              CALL GPL(2,PX,PY)
	      CALL GSTXAL(3,3)
	      CALL NWTSTR(XPOS,YPOS,TEX(FIRST:LAST))
          ENDIF
  530 CONTINUE
      CHARH = 14.
      CALL GSCHH(CHARH)
C
C  DRAW and SHADE RECTANGLES
C
      IF ( COLORS ) CALL GSPLCI(COLREC)
      CALL GSFACI(COLSHA)
      IF (SPACE .OR. COMPAR) THEN
C
C  DRAW SPACED RECTANGLES
C
        CURX = WRK(NPTS+1) - HAFINT
        NEXTX = CURX + XINT
        DO 540 I = 1,NCLASS
          PX(1) = CURX + SPAC1
          PX(2) = CURX + SPAC1
          PX(3) = NEXTX - SPAC1
          PX(4) = NEXTX - SPAC1
          PY(1) = 0.
          PY(2) = WRK(INDY1+I)
          PY(3) = WRK(INDY1+I)
          PY(4) = 0.
          IF (SHADE) THEN
            CALL GSFAIS(1)
          ELSE
            CALL GSFAIS(0)
          ENDIF
	  IF (HORZNT) THEN
              CALL GFA(4,PY,PX)
              CALL GPL(4,PY,PX)
          ELSE
              CALL GFA(4,PX,PY)
              CALL GPL(4,PX,PY)
          ENDIF
C
C  CALL PLOTIT TO FLUSH OUT BUFFER (FINISH DRAWING SHADE LINES)
C
          CALL PLOTIT(0,0,0)
C
C  DRAW LINE through Rectangle Where Frequency Tick would be
C
          IF (DRAWL) THEN
          DO 550 J = 1,3
            IF (WRK(INDY1+I) .GT. YTICKS(J)) THEN
              PY(1) = YTICKS(J)
              PY(2) = YTICKS(J)
              PX(1) = CURX + SPAC1
              PX(2) = NEXTX - SPAC1
	      IF (HORZNT) THEN
                CALL GPL(2,PY,PX)
              ELSE
                CALL GPL(2,PX,PY)
              ENDIF
            ENDIF
  550     CONTINUE
          ENDIF
          CURX = NEXTX
          NEXTX = NEXTX + XINT
  540   CONTINUE
C
        IF (COMPAR) THEN
C
C  DRAW SPACED, DOUBLE RECTANGLES
C
        CURX = WRK(NPTS+1) - XINT/2
        NEXTX = CURX + XINT
        DO 590 I = 1,NCLASS
          IF (WRK(INDY2+I) .GT. WRK(INDY1+I)) THEN
            PX(1) = CURX + XINT/2 + SPAC2
            PX(2) = CURX + XINT/2 + SPAC2
            PX(3) = MIN(NEXTX + XINT/2 + SPAC2 - 2*SPAC1,NEXTX+SPAC1)
            PX(4) = MIN(NEXTX + XINT/2 + SPAC2 - 2*SPAC1,NEXTX+SPAC1)
            PX(5) = MAX(NEXTX - SPAC1,CURX+XINT/2+SPAC2)
            PX(6) = MAX(NEXTX - SPAC1,CURX+XINT/2+SPAC2)
            PX(7) = CURX + XINT/2 + SPAC2
            IF (PX(3) .LE. NEXTX - SPAC1) THEN
              PX(3) = NEXTX - SPAC1 - SPAC2/8.
              PX(4) = NEXTX - SPAC1 - SPAC2/8.
              PX(5) = NEXTX - SPAC1
              PX(6) = NEXTX - SPAC1
            ENDIF
            IF (PX(1) .LE. CURX + SPAC1) THEN
              PX(1) = CURX + SPAC1 - SPAC2/8.
              PX(2) = CURX + SPAC1 - SPAC2/8.
              PX(7) = CURX + SPAC1 - SPAC2/8.
            ENDIF
            PY(1) = WRK(INDY1+I)
            PY(2) = WRK(INDY2+I)
            PY(3) = WRK(INDY2+I)
            PY(4) = 0.
            PY(5) = 0.
            PY(6) = WRK(INDY1+I)
            PY(7) = WRK(INDY1+I)
            CALL GSFACI (COLSH2)
            IF (SHADE) THEN
              CALL GSFAIS (1)
            ELSE
              CALL GSFAIS (0)
            ENDIF
	    IF (HORZNT) THEN
              CALL GFA(6,PY,PX)
              CALL GPL(7,PY,PX)
            ELSE
              CALL GFA(6,PX,PY)
              CALL GPL(7,PX,PY)
            ENDIF
          ELSE
            PX(1) = MAX(NEXTX - SPAC1,CURX+XINT/2+SPAC2)
            PX(2) = MAX(NEXTX - SPAC1,CURX+XINT/2+SPAC2)
            PX(3) = MIN(NEXTX + XINT/2 + SPAC2 - 2*SPAC1,NEXTX+SPAC1)
            PX(4) = MIN(NEXTX + XINT/2 + SPAC2 - 2*SPAC1,NEXTX+SPAC1)
            PY(1) = 0.
            PY(2) = WRK(INDY2+I)
            PY(3) = WRK(INDY2+I)
            PY(4) = 0.
            IF (PX(1) .LE. CURX + SPAC1) THEN
              PX(1) = CURX + SPAC1 - SPAC2/8.
              PX(2) = CURX + SPAC1 - SPAC2/8.
            ENDIF
            IF (PX(3) .LE. NEXTX - SPAC1) THEN
              PX(3) = NEXTX - SPAC1 - SPAC2/8.
              PX(4) = NEXTX - SPAC1 - SPAC2/8.
            ENDIF
            CALL GSFACI (COLSH2)
            IF (SHADE) THEN
              CALL GSFAIS (1)
            ELSE
              CALL GSFAIS (0)
            ENDIF
	    IF (HORZNT) THEN
              CALL GFA(4,PY,PX)
              CALL GPL(4,PY,PX)
            ELSE
              CALL GFA(4,PX,PY)
              CALL GPL(4,PX,PY)
            ENDIF
          ENDIF
C
C  CALL PLOTIT TO FLUSH OUT BUFFER (FINISH DRAWING SHADE LINES)
C
          CALL PLOTIT(0,0,0)
C
          CURX = NEXTX
          NEXTX = NEXTX + XINT
  590   CONTINUE
        ENDIF
      ELSE
C
C  DRAW UNSPACED RECTANGLES, ONE AT A TIME
C
        KK = 0
        DO 610 KK = 1,2
          CURX = WRK(NPTS+1) - HAFINT
          NEXTX = CURX + XINT
          NUM = 4
          PX(1) = CURX
          PX(2) = CURX
          PX(3) = NEXTX
          PX(4) = NEXTX
          PY(1) = 0.
          PY(2) = WRK(INDY1+1)
          PY(3) = WRK(INDY1+1)
          PY(4) = 0.
          IF ( SHADE ) CALL GSFAIS (1)
	  IF (HORZNT) THEN
            IF ( SHADE .AND. KK .EQ. 1 ) CALL GFA(NUM,PY,PX)
            IF ( KK .EQ. 2 ) CALL GPL(NUM,PY,PX)
          ELSE
            IF ( SHADE .AND. KK .EQ. 1 ) CALL GFA(NUM,PX,PY)
            IF ( KK .EQ. 2 ) CALL GPL(NUM,PX,PY)
          ENDIF
C
C Call PLOTIT To Flush out Buffer (Finish Drawing Shade Lines)
C
          CALL PLOTIT(0,0,0)
C
C
          DO 600 I = 2,NCLASS
            CURX = NEXTX
            NEXTX = NEXTX + XINT
C
C  NEXT RECTANGLE IS LOWER THEN LAST ONE
C
            IF (WRK(INDY1+I) .LT. WRK(INDY1+I-1)) THEN
              NUM = 3
              NUM2 = 4
              PX(1) = CURX
              PX(2) = NEXTX
              PX(3) = NEXTX
              PX(4) = CURX
              PY(1) = WRK(INDY1+I)
              PY(2) = WRK(INDY1+I)
              PY(3) = 0.
              PY(4) = 0.
C
C  NEXT RECTANGLE IS HIGHER THAN LAST ONE
C
            ELSE
              NUM = 4
              NUM2 = 5
              PX(1) = CURX
              PX(2) = CURX
              PX(3) = NEXTX
              PX(4) = NEXTX
              PX(5) = CURX
              PY(1) = WRK(INDY1+I-1)
              PY(2) = WRK(INDY1+I)
              PY(3) = WRK(INDY1+I)
              PY(4) = 0.
              PY(5) = 0.
            ENDIF
            CALL GSFAIS(1)
	    IF (HORZNT ) THEN
              IF ( SHADE .AND. KK .EQ. 1 ) CALL GFA(NUM2,PY,PX)
              IF ( KK .EQ. 2 ) CALL GPL(NUM,PY,PX)
            ELSE
              IF ( SHADE .AND. KK .EQ. 1 ) CALL GFA(NUM2,PX,PY)
              IF ( KK .EQ. 2 ) CALL GPL(NUM,PX,PY)
            ENDIF
C
C Call PLOTIT To Flush out Buffer (Finish Drawing Shade Lines)
C
            CALL PLOTIT(0,0,0)
C
  600     CONTINUE
  610   CONTINUE
C
C  DRAW LINE THROUGH RECTANGLE WHERE FREQUENCY TICK WOULD BE
C
        IF (DRAWL) THEN
          CURX = WRK(NPTS+1) - HAFINT
          NEXTX = CURX + XINT
          DO 650 I = 1,NCLASS
            DO 620 J = 1,3
              IF (WRK(INDY1+I) .GT. YTICKS(J)) THEN
                PY(1) = YTICKS(J)
                PY(2) = YTICKS(J)
                PX(1) = CURX
                PX(2) = NEXTX
		IF (HORZNT) THEN
                  CALL GPL(2,PY,PX)
                ELSE
                  CALL GPL(2,PX,PY)
                ENDIF
              ENDIF
  620       CONTINUE
            CURX = NEXTX
            NEXTX = NEXTX + XINT
  650     CONTINUE
         ENDIF
      ENDIF
C
C  DONE DRAWING RECTANGLES
C
C  SET UP VALUES FOR LABELING AND DRAWING TICKS ON X-AXIS
C
      IF (COLORS) CALL GSPLCI(COLAXI)
      IF (HEIGHT .EQ. 1) THEN
        CHGHT = .010
      ELSEIF (HEIGHT .EQ. 2) THEN
        CHGHT = .012
      ELSEIF (HEIGHT .EQ. 3) THEN
        CHGHT = .014
      ELSE
        CHGHT = .012
      ENDIF
      CHARH = CHGHT * 1000.
      CALL GSCHH(CHARH)
      PX(1) = XMIN
      PX(2) = XMAX
      PY(1) = 0.
      PY(2) = 0.
      IF (MIDVAL .OR. (COMPAR .OR. ASSIGN)) THEN
          XPOS = WRK(NPTS+1)
      ELSE
          XPOS = WRK(NPTS+1) - HAFINT
      ENDIF
      IF (HORZNT) THEN
          CALL GPL(2,PY,PX)
C ************************* RIGHT,HALF
          CALL GSTXAL(3,3)
      ELSE
          CALL GPL(2,PX,PY)
        IF (ORIENT .LT. 5) THEN
C ************************* CENTER,TOP
          CALL GSTXAL(2,1)
        ELSE
C ************************* RIGHT,TOP
          CALL GSTXAL(3,1)
        ENDIF
	RAD = (3.141592654/180.)*(90-ORIENT)
        ORNTY = SIN(RAD)
        ORNTX = -COS(RAD)
          CALL GSCHUP(ORNTX,ORNTY)
      ENDIF
      IF (ORIENT .LT. 5) THEN
	YPOS = 0. - 2.6 * XTIC
      ELSE
	YPOS = 0. - 1.3 * XTIC
      ENDIF
      PY(1) = 0.
      PY(2) = 0. - XTIC
      PX(1) = XPOS
      PX(2) = PX(1)
      DO 700 I = 1,NUMLAB
	  IF (HORZNT) THEN
	      CALL GPL(2,PY,PX)
          ELSE
              CALL GPL(2,PX,PY)
          ENDIF
          PX(1) = PX(1) + XINT
          PX(2) = PX(1)
  700 CONTINUE
C
C  IF MORE THAN LABMAX LABELS TO BE LABELED THEN
C  COMPUTE LABEL INTERVAL SO THAT THERE ARE NO MORE
C  THAN LABMAX LABELS
C
      IF (NUMLAB .GT. LABMAX) THEN
	  XDIV = REAL(NUMLAB)/REAL(LABMAX)
          IF ((REAL(INT(XDIV)) - XDIV) .EQ. 0.) THEN
            NDIV = INT(XDIV)
          ELSE
            NDIV = INT(XDIV + 1.)
          ENDIF
      ELSE
          NDIV = 1
      ENDIF
      IF (MIDVAL .OR. (COMPAR .OR. ASSIGN)) THEN
          LASTLB = WRK(NPTS+NCLASS)
          LASTL = NCLASS
      ELSE
          LASTL = NCLASS + 1
          LASTLB = WRK(NPTS+NCLASS) + HAFINT
      ENDIF
      I = 1
  710 CONTINUE
C
C  CHECK TO MAKE SURE CURRENT LABEL IS NOT TOO CLOSE TO
C  LAST LABEL ( WRK(NPTS+NCLASS) )
C
          XPOS = WRK(NPTS+I)
          IF (MIDVAL .OR. (COMPAR .OR. ASSIGN)) THEN
            IF (SPEC) XPOS2 = (CLASS(I+1) + CLASS(I))/2
          ELSE
            XPOS = XPOS - HAFINT
            IF (SPEC) XPOS2 = CLASS(I)
          ENDIF
          IF (I + NDIV .GT. LASTL) THEN
              DONE = .TRUE.
              XPOS = LASTLB
              IF (SPEC) XPOS2 = XPOS
C             I = NCLASS                 Bug fixed on 12/17/93
	      I = LASTL
          ENDIF
          TESTCH = 'I'
          IF ( STRFOR(2:2) .EQ. TESTCH ) THEN
            IXPOS = NINT(XPOS)
            IF ( SPEC ) IXPOS2 = NINT(XPOS2)
            IF ( SPEC ) THEN
              WRITE(TEX,STRFOR)IXPOS2
            ELSE
              WRITE(TEX,STRFOR)IXPOS
            ENDIF
          ELSE
            IF ( SPEC ) THEN
              WRITE(TEX,STRFOR)XPOS2
            ELSE
              WRITE(TEX,STRFOR)XPOS
            ENDIF
          ENDIF
          IF ( CHARL ) THEN
            CALL HSTSTR(LABTEX(I),FIRST,LAST)
	    IF ( HORZNT) THEN
              CALL NWTSTR(YPOS,XPOS,LABTEX(I)(FIRST:LAST))
            ELSE
              CALL NWTSTR(XPOS,YPOS,LABTEX(I)(FIRST:LAST))
            ENDIF
          ELSE
            CALL HSTSTR(TEX,FIRST,LAST)
	    IF (HORZNT) THEN
              CALL NWTSTR(YPOS,XPOS,TEX(FIRST:LAST))
            ELSE
              CALL NWTSTR(XPOS,YPOS,TEX(FIRST:LAST))
            ENDIF
          ENDIF
          IF (DONE) GOTO 720
          I = I + NDIV
          GOTO 710
  720 CONTINUE
      IF (.NOT. HORZNT) THEN
        CALL GSCHUP(0.,1.)
      ENDIF
      CHARH = 14.
      CALL GSCHH(CHARH)
C
C  DRAW PERCENT AXIS
C
      IF (COLORS) CALL GSPLCI(COLAXI)
      IF (PERCNT) THEN
          PX(1) = XMAX
          PX(2) = XMAX
          PY(1) = 0.
          PY(2) = YMAX
	  IF (HORZNT) THEN
C                             (CENTER,BOTTOM)
            CALL GSTXAL(2,4)
            CALL GPL(2,PY,PX)
          ELSE
C                             (LEFT,HALF)
            CALL GSTXAL(1,3)
            CALL GPL(2,PX,PY)
          ENDIF
C
C Compute tick marks and scales
C
          PX(1) = XMAX
          PX(2) = XMAX - 0.6*HAFINT
          IF ( COMPAR ) PX(2) = XMAX - 0.3*HAFINT
          XPOS = XMAX + YDEC
          DO 730 J = 1,4
              PY(1) = YTICKS(J)
              PY(2) = YTICKS(J)
              WRITE(TEX,'(F5.1)')PER(J)
              CALL HSTSTR(TEX,FIRST,LAST)
              YPOS = PY(1)
C
C Draw tick marks and print scales
C
	      IF (HORZNT) THEN
                  CALL GPL(2,PY,PX)
                  CALL NWTSTR(YPOS,XPOS,TEX(FIRST:LAST))
              ELSE
                  CALL GPL(2,PX,PY)
		  CALL GSTXAL(1,3)
		  CALL NWTSTR(XPOS,YPOS,TEX(FIRST:LAST))
              ENDIF
  730     CONTINUE
      ENDIF
C
C  DRAW MEDIAN
C
      IF (MEDIAN .AND. (.NOT. (COMPAR .OR. ASSIGN))) THEN
          IF (COLORS) CALL GSPLCI(COLMED)
          PX(1) = MED
          PX(2) = MED
          PY(1) = 0.
          PY(2) = YMAX
	  IF (HORZNT) THEN
              MED = (MED - NEWWIN(3))/YRANGE
              CALL GPL(2,PY,PX)
          ELSE
              MED = (MED - NEWWIN(1))/XRANGE
              CALL GPL(2,PX,PY)
          ENDIF
      ENDIF
C
C  DRAW PERIMETER
C
      IF (WINDOW) THEN
          CALL GSWN(1,0.,1.,0.,1.)
	  CALL GSVP(1,HWIND(1),HWIND(2),HWIND(3),HWIND(4))
          CALL GSELNT(1)
	  YRANGE = ABS(HWIND(4) - HWIND(3))
	  XRANGE = ABS(HWIND(2) - HWIND(1))
      ELSE
          CALL GSELNT(0)
	  YRANGE = 1.
	  XRANGE = 1.
      ENDIF
      IF (PERIM) THEN
          IF (COLORS) CALL GSPLCI(COLPER)
          PX(1)=0.
          PX(2)=0.
          PX(3)=1.
          PX(4)=1.
          PX(5)=0.
          PY(1)=0.
          PY(2)=1.
          PY(3)=1.
          PY(4)=0.
          PY(5)=0.
          CALL GPL(5,PX,PY)
      ENDIF
C
C  OUTPUT LABELS
C
      CHARH = 15.
      CALL GSCHH(CHARH)
C                       CENTER,HALF
      CALL GSTXAL(2,3)
      XPOS = .5
      YPOS = .04
      NCHAR = LEN(STRLAB)
      IF (.NOT. LABEL) THEN
          IF (MIDVAL .OR. (COMPAR .OR. ASSIGN)) THEN
              TEX = 'CLASS MIDVALUES'
          ELSE
              TEX = 'CLASS INTERVALS'
          ENDIF
          NCHAR = 15
	  IF (HORZNT) THEN
              CALL GSCHUP(-1.,0.)
              CALL NWTSTR(YPOS,XPOS,TEX(1:NCHAR))
          ELSE
              CALL NWTSTR(XPOS,YPOS,TEX(1:NCHAR))
          ENDIF
      ELSE
        IF (STRLAB .EQ. 'NOLABEL') Goto 740
          CALL HSTSTR(STRLAB,FIRST,LAST)
	  IF (HORZNT) THEN
              CALL GSCHUP(-1.,0.)
              CALL NWTSTR(YPOS,XPOS,STRLAB(FIRST:LAST))
          ELSE
              CALL NWTSTR(XPOS,YPOS,STRLAB(FIRST:LAST))
          ENDIF
      ENDIF
  740 CONTINUE
      IF (FREQNC) THEN
        IF (STRFRE .EQ. 'NOLABEL') Goto 750
          NCHAR = LEN(STRFRE)
          CALL HSTSTR(STRFRE,FIRST,LAST)
	  IF (HORZNT) THEN
              XPOS = .5
              CALL GSCHUP(0.,1.)
              CALL NWTSTR(XPOS,YPOS,STRFRE(FIRST:LAST))
          ELSE
              CALL GSCHUP(-1.,0.)
              CALL NWTSTR(YPOS,XPOS,STRFRE(FIRST:LAST))
          ENDIF
      ELSE
	  IF (HORZNT) THEN
              XPOS = .5
              CALL GSCHUP(0.,1.)
              CALL NWTSTR(XPOS,YPOS,'FREQUENCY')
          ELSE
              CALL GSCHUP(-1.,0.)
              CALL NWTSTR(YPOS,XPOS,'FREQUENCY')
          ENDIF
      ENDIF
  750 CONTINUE
C
C  LABEL PERCENT AXIS
C
      IF (PERCNT) THEN
      IF (PERTIT) THEN
	IF (STRPER .EQ. 'NOLABEL') Goto 760
	  NCHAR = LEN(STRPER)
	  CALL HSTSTR(STRPER,FIRST,LAST)
	  IF (HORZNT) THEN
              XPOS = .5
              CALL GSCHUP(0.,1.)
	      CALL NWTSTR(XPOS,YPOS,STRPER(FIRST:LAST))
          ELSE
              CALL GSCHUP(-1.,0.)
	      CALL NWTSTR(YPOS,XPOS,STRPER(FIRST:LAST))
          ENDIF
      ELSE
	  IF (HORZNT) THEN
            YPOS = .92
            XPOS = .5
            IF ( ASSIGN .OR. COMPAR) THEN
              CALL NWTSTR(XPOS,YPOS,'PERCENT of MAXIMUM')
            ELSE
              CALL NWTSTR(XPOS,YPOS,'PERCENT OCCURRENCE')
            ENDIF
          ELSE
            YPOS = .96
            XPOS = .5
            IF ( ASSIGN .OR. COMPAR) THEN
              CALL NWTSTR(YPOS,XPOS,'PERCENT of MAXIMUM')
            ELSE
              CALL NWTSTR(YPOS,XPOS,'PERCENT OCCURRENCE')
            ENDIF
          ENDIF
      ENDIF
      ENDIF
  760 CONTINUE
C
C  LABEL MEDIAN
C
      IF (MEDIAN .AND. (.NOT. (COMPAR .OR. ASSIGN))) THEN
        XPOS = MED - .018
        YPOS = .85
	IF (HORZNT) THEN
          CALL NWTSTR(YPOS,XPOS,'MEDIAN')
        ELSE
          YPOS = .81
          CALL NWTSTR(XPOS,YPOS,'MEDIAN')
        ENDIF
      ENDIF
C
C  OUTPUT TITLE
C
      IF (TITLE) THEN
          IF (COLORS) CALL GSTXCI(COLTIT)
	  CHGHT = .018
	  CHARH = CHGHT * 1000.
          CALL GSCHH(CHARH)
          CALL GSCHUP(0.,1.)
          CALL HSTSTR(STRTIT,FIRST,LAST)
	  YTIT = .995
  223     YTIT = YTIT -.03
C
C If the title is more than 45 characters, write it in multiple lines.
C
	  NUM = LAST-FIRST+1
	IF(NUM.GT.45) THEN
C
C Search for blanks as a place to break the lines
C
	  JST = 44 + FIRST
	  JND = FIRST
	  DO 222  JCH = JST,JND,-1
	    IF(STRTIT(JCH:JCH).EQ.BLANK) THEN
	      JLST = JCH - 1
	      IF(JLST.GT.FIRST) THEN
C
C Found a blank.  Print a line not including this blank.
C
		CALL NWTSTR(.5,YTIT,STRTIT(FIRST:JLST))
		FIRST = JCH + 1
		GO TO 223
	      ENDIF
	    ENDIF
  222     CONTINUE
C
C There was no logical place to split the title line which exceeded
C  45 characters so just split it at 45 characters.  On a 96 character
C  title it would create 3 lines.
C
	  L2 = FIRST + 44
	  CALL NWTSTR(.5,YTIT,STRTIT(FIRST:L2))
  224     YTIT = YTIT -.03
	  L1 = L2 + 1
	  L2 = L1 + 44
	  IF(L2.LT.LAST) THEN
	    CALL NWTSTR(.5,YTIT,STRTIT(L1:L2))
	    GO TO 224
	  ELSE
	    CALL NWTSTR(.5,YTIT,STRTIT(L1:LAST))
	  ENDIF
	ELSEIF (NUM.GT.0) THEN
C
C The title line is less than 46 characters.  Write it.
C
	  CALL NWTSTR(.5,YTIT,STRTIT(FIRST:LAST))
	ENDIF
      ENDIF
C
C  Print missing value count on request.
C
      IF(IFLAG.LT.2) THEN
	IF(MVALU) THEN
	  IF(PMVAL) THEN
	  CHARH = 10.
	  CALL GSCHH(CHARH)
	  CALL GSTXAL(2,3)
	  CALL GSCHUP(0.,1.)
C
C Write the number of input points, NPTS, and the number of
C  missing values, MISS, in the lower right corner of the plot.
C
	  XPOS = .92
	  YPOS = .04
	  LTEX(1:5)='NPTS='
	  WRITE(TEX,'(I10)')NPTS
	  CALL HSTSTR(TEX,FIRST,LAST)
	  NUM = LAST - FIRST + 6
	  LTEX(6:NUM)=TEX(FIRST:LAST)
	  CALL NWTSTR(XPOS,YPOS,LTEX(1:NUM))
C
	  YPOS = .02
	  LTEX(1:5)='MISS='
	  WRITE(TEX,'(I10)')MISS
	  CALL HSTSTR(TEX,FIRST,LAST)
	  NUM = LAST - FIRST + 6
	  LTEX(6:NUM)=TEX(FIRST:LAST)
	  CALL NWTSTR(XPOS,YPOS,LTEX(1:NUM))
	  END IF
	END IF
      END IF
C
C  CALL FRAME UNLESS .HFRAME. IS FALSE
C
      IF (HFRAME) CALL FRAME
C
C  RESET NORMALIZATION TRANSFORMATION TO WHAT IT WAS UPON ENTRY
C  TO HISTOGRAM
C
      IF (ICNT .NE. 0) THEN
          CALL GSWN(ICNT,OWIND(1),OWIND(2),OWIND(3),OWIND(4))
	  CALL GSVP(ICNT,OVIEW(1),OVIEW(2),OVIEW(3),OVIEW(4))
      ENDIF
      CALL GSELNT(ICNT)
C
C  RESTORE TEXT ATTRIBUTES
C
            CALL GSCHH(OLDCHH)
            CALL GSCHUP(CHUPX,CHUPY)
            CALL GSTXAL(OLDALH,OLDALV)
            CALL GSTXCI(OTEXCI)
C
C  RESTORE ORIGINAL COLOR
C
      CALL GSPLCI(OCOLI)
C
C  RESTORE POLYLINE COLOR ASF TO WHAT IT WAS ON ENTRY TO GRIDAL
C
        LASF(10) = OTXASF
        LASF(3) = OPLASF
        CALL GSASF(LASF)
C
      CALL PLOTIT(0,0,0)
      RETURN
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C   FFTPACK 5.0
C   Copyright (C) 1995-2004, Scientific Computing Division,
C   University Corporation for Atmospheric Research
C   Licensed under the GNU General Public License (GPL)
C
C   Authors:  Paul N. Swarztrauber and Richard A. Valent
C
C   $Id: cosqb1.f,v 1.2 2006-11-21 01:10:16 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      SUBROUTINE DCOSQB1(N,INC,X,WSAVE,WORK,IER)
      DOUBLE PRECISION X
      DOUBLE PRECISION WSAVE
      DOUBLE PRECISION WORK
      DOUBLE PRECISION XIM1
      DIMENSION X(INC,*),WSAVE(*),WORK(*)

      IER = 0
      NS2 = (N+1)/2
      NP2 = N + 2
      DO 101 I = 3,N,2
          XIM1 = X(1,I-1) + X(1,I)
          X(1,I) = .5D0* (X(1,I-1)-X(1,I))
          X(1,I-1) = .5D0*XIM1
  101 CONTINUE
      X(1,1) = .5D0*X(1,1)
      MODN = MOD(N,2)
      IF (MODN.NE.0) GO TO 302
      X(1,N) = .5D0*X(1,N)
  302 LENX = INC* (N-1) + 1
      LNSV = N + INT(LOG(DBLE(N))) + 4
      LNWK = N
C
      CALL DRFFT1B(N,INC,X,LENX,WSAVE(N+1),LNSV,WORK,LNWK,IER1)
      IF (IER1.NE.0) THEN
          IER = 20
          CALL DXERFFT('COSQB1',-5)
          GO TO 400
      END IF
C
      DO 102 K = 2,NS2
          KC = NP2 - K
          WORK(K) = WSAVE(K-1)*X(1,KC) + WSAVE(KC-1)*X(1,K)
          WORK(KC) = WSAVE(K-1)*X(1,K) - WSAVE(KC-1)*X(1,KC)
  102 CONTINUE
      IF (MODN.NE.0) GO TO 305
      X(1,NS2+1) = WSAVE(NS2)* (X(1,NS2+1)+X(1,NS2+1))
  305 DO 103 K = 2,NS2
          KC = NP2 - K
          X(1,K) = WORK(K) + WORK(KC)
          X(1,KC) = WORK(K) - WORK(KC)
  103 CONTINUE
      X(1,1) = X(1,1) + X(1,1)
  400 RETURN
      END

C
C	$Id: gfilat.f,v 1.4 2008-07-27 00:20:57 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
        SUBROUTINE GFILAT(IOS,STATUS)
C
C  Process FILL AREA attributes.
C
C  VALID ATTRIBUTES:
C    FILL AREA INDEX
C    INTERIOR STYLE
C    FILL COLOR
C    HATCH INDEX
C    PATTERN INDEX (Currently does not produce any CGM elements)
C    FILL REFERENCE POINT (Currently does not produce any CGM elements)
C    PATTERN TABLE (Currently does not produce any CGM elements)
C    PATTERN SIZE  (Currently does not produce any CGM elements)
C
      include 'trinst.h'
      include 'trstat.h'
      include 'trpars.h'
      include 'trcode.h'
C
      INTEGER IOS, STATUS
C
      IF (OPID.EQ.ATELFI) THEN
C
C  Set the fill area bundle index.
C
        CALL GOPDEC(FILIDX,MIXCPR,1,IOS,STATUS)
        CALL GSFAI(FILIDX)
      ELSE IF (OPID.EQ.ATELIS) THEN
C
C  Set the interior style.
C
        CALL GOPDEC(INTSTL,MIXCPR,1,IOS,STATUS)
        CALL GSFAIS(INTSTL)
      ELSE IF (OPID.EQ.ATELFC) THEN
C
C  Set the fill area color.
C
        CALL GOPDEC(FILCOL,MCICPR,1,IOS,STATUS)
        CALL GSFACI(FILCOL)
      ELSE IF (OPID.EQ.ATELHI) THEN
C
C  Set the hatch index.
C
        CALL GOPDEC(HATIDX,MIXCPR,1,IOS,STATUS)
        CALL GSFASI(HATIDX)
      ELSE IF (OPID.EQ.ATELPI) THEN
C
C  Set the pattern index.
C
        CALL GOPDEC(PATIDX,MIXCPR,1,IOS,STATUS)
        CALL GSFASI(PATIDX)
      ELSE IF (OPID.EQ.ATELFR) THEN
C
C  Set the fill area reference point.
C
        CALL GOPDEC(FILRPT,MOPLEN,2,IOS,STATUS)
        CALL GSPARF(REAL(FILRPT(1))/32767.,REAL(FILRPT(2))/32767.)
      ELSE IF (OPID .EQ. ATELPS) THEN
C
C  Pattern size.
C
        IVDCL = MOPLEN
        CALL GSKPOP(IVDCL,4,IOS,STATUS)
      ELSE IF (OPID .EQ. ATELPT) THEN
C
C  Pattern table.
C
        ISKP = LEN
        CALL GSKPOP(8,ISKP,IOS,STATUS)
      END IF
C
      RETURN
      END

        PROGRAM CPEX08
C
C This example shows a color-filled contour plot on the surface of the
C earth, in orthographic projection, with a color bar to show what the
C colors mean.  It is assumed that the field being contoured has meaning
C only over the African continent and, accordingly, contours are only
C shown there.  Lines of latitude and longitude are drawn only over the
C ocean areas.
C
C Note: As of 10/17/2005, this example has been modified to produce two
C frames.  The first makes use of the old EZMAP database 'CO' and the
C second makes use of the newer EZMAP database 'Earth..2'.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
        PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Declare a dummy data array.
C
        DIMENSION ZDAT(40,40)
C
C Declare workspace arrays for CONPACK.
C
        PARAMETER (LRWK=1000,LIWK=1000)
C
        DIMENSION RWRK(LRWK),IWRK(LIWK)
C
C Declare arrays needed to do color fill.
C
        PARAMETER (LAMA=1000000,NCRA=LAMA/10,NGPS=5)
C
        DIMENSION IAMA(LAMA)
        DIMENSION XCRA(NCRA),YCRA(NCRA)
        DIMENSION IAIA(NGPS),IGIA(NGPS)
C
C Declare arrays to hold the list of indices and the list of labels
C required by the label-bar routine.
C
        DIMENSION LIND(14)
        CHARACTER*10 LLBS(14)
C
C Declare routines to color the areas represented by the area map for
C frames 1 and 2.
C
        EXTERNAL COLRAM,COLRA2
C
C Declare routines to draw contour lines over land only for frames 1
C and 2.
C
        EXTERNAL COLRCL,COLRC2
C
C Declare routines to draw lat/lon lines over ocean only for frames 1
C and 2.
C
        EXTERNAL COLRLL,COLRL2
C
C Define the list of indices required by the label-bar routine.
C
        DATA LIND / 7,2,3,4,5,6,8,9,10,11,12,13,14,15 /
C
C Define the list of labels required by the label-bar routine.
C
        DATA LLBS / 'OCEAN  ' , 'LAND   ' , '< 0    ' , '0-10   '  ,
     +              '10-20  ' , '20-30  ' , '30-40  ' , '40-50  '  ,
     +              '50-60  ' , '60-70  ' , '70-80  ' , '80-90  '  ,
     +              '90-100 ' , '> 100  ' /
C
C Open GKS.
C
        CALL GOPKS (IERRF, ISZDM)
        CALL GOPWK (IWKID, LUNIT, IWTYPE)
        CALL GACWK (IWKID)
C
C Turn off the clipping indicator.
C
        CALL GSCLIP (0)
C
C Force solid fill.
C
        CALL GSFAIS (1)
C
C Define color indices.
C
        CALL DFCLRS(IWKID)
C
C Generate an array of test data.
C
        CALL GENDAT (ZDAT,40,40,40,15,15,-10.,110.)
C
C   F R A M E   1   -   O L D   E Z M A P   D A T A B A S E
C   - - - - -   -   -   - - -   - - - - -   - - - - - - - -
C
C Initialize the area map.
C
        CALL ARINAM (IAMA,LAMA)
C
C Use EZMAP and EZMAPA to create a background.
C
        CALL MAPPOS (.01,.74,.01,.99)
        CALL MAPROJ ('OR - ORTHOGRAPHIC PROJECTION',15.,15.,0.)
        CALL MAPSET ('MA - MAXIMAL AREA',0.,0.,0.,0.)
        CALL MAPSTI ('EL - ELLIPTICAL BOUNDARY',1)
        CALL MAPSTC ('OU - OUTLINE DATASET','CO')
        CALL MAPSTI ('VS - VERTICAL STRIPPING',0)
        CALL MAPINT
        CALL MAPBLA (IAMA)
C
C Add a line segment to the area map to separate Africa from Eurasia.
C Because this line segment is added last, it will determine the area
C identifier for all of Africa (223).  Also, add a line cutting
C Madagascar in two, with the same area identifier on both sides, so
C that it will be treated as a part of Africa.
C
        CALL MAPITA (26.0,35.0,0,IAMA,1,223,0)
        CALL MAPITA (28.8,33.0,1,IAMA,1,223,0)
        CALL MAPITA (33.0,30.0,1,IAMA,1,223,0)
        CALL MAPIQA (IAMA,1,223,0)
C
        CALL MAPITA (-20.0,42.5,0,IAMA,1,223,223)
        CALL MAPITA (-20.0,50.0,1,IAMA,1,223,223)
        CALL MAPIQA (IAMA,1,223,223)
C
C Tell CONPACK not to do the SET call (since it's already been done),
C to use mapping function 1 (EZMAP background), and what range of X and
C Y coordinates to send into the mapping function.  The X coordinates
C will be treated as latitudes and will range from 40 degrees west of
C Greenwich to 55 degrees east of Greenwich, and the Y coordinates will
C be treated as latitudes and will range from 45 degrees south of the
C equator to 45 degrees north of the equator.
C
        CALL CPSETI ('SET - DO-SET-CALL FLAG',0)
        CALL CPSETI ('MAP - MAPPING FLAG',1)
        CALL CPSETR ('XC1 - X COORDINATE AT I=1',-18.)
        CALL CPSETR ('XCM - X COORDINATE AT I=M',+52.)
        CALL CPSETR ('YC1 - Y COORDINATE AT J=1',-35.)
        CALL CPSETR ('YCN - Y COORDINATE AT J=N',+38.)
C
C Tell CONPACK exactly what contour levels to use.
C
        CALL CPSETI ('CLS - CONTOUR LEVEL SELECTOR',1)
        CALL CPSETR ('CMN - CONTOUR LEVEL MINIMUM',0.)
        CALL CPSETR ('CMX - CONTOUR LEVEL MAXIMUM',100.)
        CALL CPSETR ('CIS - CONTOUR INTERVAL SPECIFIER',10.)
C
C Tell CONPACK what value EZMAP uses to signal that a projected point
C has disappeared around the limb.  Strictly speaking, this call is
C not necessary here; it has been inserted for the benefit of users
C who modify the example to use global data.
C
        CALL CPSETR ('ORV - OUT-OF-RANGE VALUE',1.E12)
C
C Initialize the drawing of the contour plot.
C
        CALL CPRECT (ZDAT,40,40,40,RWRK,LRWK,IWRK,LIWK)
C
C Add contour lines to the area map.
C
        CALL CPCLAM (ZDAT,RWRK,IWRK,IAMA)
C
C Color the map.
C
        CALL ARSCAM (IAMA,XCRA,YCRA,NCRA,IAIA,IGIA,NGPS,COLRAM)
C
C Outline the continents in black, put black contour lines over the
C color map, and put gray lines of latitude and longitude over the
C ocean.
C
        CALL GSPLCI (0)
        CALL MAPLOT
        CALL CPCLDM (ZDAT,RWRK,IWRK,IAMA,COLRCL)
        CALL GSPLCI (2)
        CALL MAPGRM (IAMA,XCRA,YCRA,NCRA,IAIA,IGIA,NGPS,COLRLL)
        CALL GSPLCI (1)
C
C Draw a label bar for the plot, relating colors to values.
C
        CALL LBSETI ('CBL - COLOR OF BOX LINES',0)
        CALL LBLBAR (1,.76,.99,.13,.87,14,.5,1.,LIND,0,LLBS,14,1)
C
C Compute and print statistics for the plot, label it, and put a
C boundary line at the edge of the plotter frame.
C
        CALL CAPSAP ('EXAMPLE 8',IAMA,LAMA)
        CALL LABTOP ('EXAMPLE 8',.017)
        CALL BNDARY
C
C Advance the frame.
C
        CALL FRAME
C
C   F R A M E   2   -   N E W   E Z M A P   D A T A B A S E
C   - - - - -   -   -   - - -   - - - - -   - - - - - - - -
C
C Initialize the area map.
C
        CALL ARINAM (IAMA,LAMA)
C
C Use EZMAP and EZMAPB to create a background.  Note that I am using
C the database 'Earth..2' at level 3.  This is to make "Madagascar" a
C recognized area.  If I did not wish to show contours over Madagascar,
C I could use the database at level 2, saving a little space in the
C area map and in the metafile.
C
        CALL MAPPOS (.01,.74,.01,.99)
        CALL MAPROJ ('OR - ORTHOGRAPHIC PROJECTION',15.,15.,0.)
        CALL MAPSET ('MA - MAXIMAL AREA',0.,0.,0.,0.)
        CALL MAPSTI ('EL - ELLIPTICAL BOUNDARY',1)
        CALL MAPSTI ('VS - VERTICAL STRIPPING',0)
        CALL MAPINT
        CALL MDLNAM ('Earth..2',3,IAMA)
C
C Tell CONPACK not to do the SET call (since it's already been done),
C to use mapping function 1 (EZMAP background), and what range of X and
C Y coordinates to send into the mapping function.  The X coordinates
C will be treated as latitudes and will range from 40 degrees west of
C Greenwich to 55 degrees east of Greenwich, and the Y coordinates will
C be treated as latitudes and will range from 45 degrees south of the
C equator to 45 degrees north of the equator.
C
        CALL CPSETI ('SET - DO-SET-CALL FLAG',0)
        CALL CPSETI ('MAP - MAPPING FLAG',1)
        CALL CPSETR ('XC1 - X COORDINATE AT I=1',-18.)
        CALL CPSETR ('XCM - X COORDINATE AT I=M',+52.)
        CALL CPSETR ('YC1 - Y COORDINATE AT J=1',-35.)
        CALL CPSETR ('YCN - Y COORDINATE AT J=N',+38.)
C
C Tell CONPACK exactly what contour levels to use.
C
        CALL CPSETI ('CLS - CONTOUR LEVEL SELECTOR',1)
        CALL CPSETR ('CMN - CONTOUR LEVEL MINIMUM',0.)
        CALL CPSETR ('CMX - CONTOUR LEVEL MAXIMUM',100.)
        CALL CPSETR ('CIS - CONTOUR INTERVAL SPECIFIER',10.)
C
C Tell CONPACK what value EZMAP uses to signal that a projected point
C has disappeared around the limb.  Strictly speaking, this call is
C not necessary here; it has been inserted for the benefit of users
C who modify the example to use global data.
C
        CALL CPSETR ('ORV - OUT-OF-RANGE VALUE',1.E12)
C
C Initialize the drawing of the contour plot.
C
        CALL CPRECT (ZDAT,40,40,40,RWRK,LRWK,IWRK,LIWK)
C
C Add contour lines to the area map.
C
        CALL CPCLAM (ZDAT,RWRK,IWRK,IAMA)
C
C Color the map.
C
        CALL ARSCAM (IAMA,XCRA,YCRA,NCRA,IAIA,IGIA,NGPS,COLRA2)
C
C Outline the continents in black, put black contour lines over the
C color map, and put gray lines of latitude and longitude over the
C ocean.
C
        CALL GSPLCI (0)
        CALL MDLNDR ('Earth..2',2)
        CALL CPCLDM (ZDAT,RWRK,IWRK,IAMA,COLRC2)
        CALL GSPLCI (2)
        CALL MAPGRM (IAMA,XCRA,YCRA,NCRA,IAIA,IGIA,NGPS,COLRL2)
        CALL GSPLCI (1)
C
C Draw a label bar for the plot, relating colors to values.
C
        CALL LBSETI ('CBL - COLOR OF BOX LINES',0)
        CALL LBLBAR (1,.76,.99,.13,.87,14,.5,1.,LIND,0,LLBS,14,1)
C
C Compute and print statistics for the plot, label it, and put a
C boundary line at the edge of the plotter frame.
C
        CALL CAPSAP ('EXAMPLE 8',IAMA,LAMA)
        CALL LABTOP ('EXAMPLE 8',.017)
        CALL BNDARY
C
C Advance the frame.
C
        CALL FRAME
C
C Close GKS.
C
        CALL GDAWK (IWKID)
        CALL GCLWK (IWKID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END


      SUBROUTINE COLRAM (XCRA,YCRA,NCRA,IAIA,IGIA,NAGI)
C
        DIMENSION XCRA(*),YCRA(*),IAIA(*),IGIA(*),IOCI(12)
C
C This routine is called to color an area from an area map.  Its
C coordinates are given by the NCRA coordinates in the arrays XCRA and
C YCRA.  For each I from 1 to NAGI, IAIA(I) is the area identifier of
C the area relative to the group whose group identifier is IGIA(I).
C
C Define an array of color indices associated with area identifiers.
C
        DATA IOCI / 3,4,5,6,8,9,10,11,12,13,14,15 /
C
C Find the area identifier for the area relative to groups 1 and 3.
C The first of these tells us whether the area is over land or water,
C and the second tells us what contour band the area is in.
C
        IAI1=-1
        IAI3=-1
C
        DO 101 I=1,NAGI
          IF (IGIA(I).EQ.1) IAI1=IAIA(I)
          IF (IGIA(I).EQ.3) IAI3=IAIA(I)
  101   CONTINUE
C
C Color-fill the area, using blue for any area over water, gray for
C any area over land which is not over Africa (including Madagascar)
C or is outside the contour plot, and a color depending on the contour
C level elsewhere.
C
        IF (IAI1.GT.0) THEN
          IF (MAPACI(IAI1).EQ.1) THEN
            CALL GSFACI (7)
            CALL GFA (NCRA-1,XCRA,YCRA)
          ELSE
            IF (IAI1.NE.223.OR.IAI3.LE.0) THEN
              CALL GSFACI (2)
              CALL GFA (NCRA-1,XCRA,YCRA)
            ELSE
              CALL GSFACI (IOCI(IAI3))
              CALL GFA (NCRA-1,XCRA,YCRA)
            END IF
          END IF
        END IF
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE COLRCL (XCRA,YCRA,NCRA,IAIA,IGIA,NAGI)
C
        DIMENSION XCRA(*),YCRA(*),IAIA(*),IGIA(*)
C
C This routine is called to draw a portion of a contour line which is
C wholly contained in some area of an area map.  Its coordinates are
C given by the NCRA coordinates in the arrays XCRA and YCRA.  For each
C I from 1 to NAGI, IAIA(I) is the area identifier of the area relative
C to the group whose group identifier is IGIA(I).
C
C Find the area identifier for the area relative to groups 1 and 3.
C The first of these tells us whether the area is over land or water,
C and the second tells us what contour band the area is in.
C
        IAI1=-1
        IAI3=-1
C
        DO 101 I=1,NAGI
          IF (IGIA(I).EQ.1) IAI1=IAIA(I)
          IF (IGIA(I).EQ.3) IAI3=IAIA(I)
  101   CONTINUE
C
C Draw the line only if the area it is in is over Africa (including
C Madagascar) and within the boundary of the contour plot.
C
        IF (IAI1.EQ.223.AND.IAI3.GT.0) CALL GPL (NCRA,XCRA,YCRA)
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE COLRLL (XCRA,YCRA,NCRA,IAIA,IGIA,NAGI)
C
        DIMENSION XCRA(*),YCRA(*),IAIA(*),IGIA(*)
C
C This routine is called to draw a portion of a line of latitude or
C longitude which is wholly contained in some area of an area map.  Its
C coordinates are given by the NCRA coordinates in the arrays XCRA and
C YCRA.  For each I from 1 to NAGI, IAIA(I) is the area identifier of
C the area relative to the group whose group identifier is IGIA(I).
C
C Find the area identifier for the area relative to group 1, which will
C tell us whether the area is over land or water.
C
        IAI1=-1
C
        DO 101 I=1,NAGI
          IF (IGIA(I).EQ.1.AND.IAIA(I).GT.0) IAI1=IAIA(I)
  101   CONTINUE
C
C Draw the line only if it is over water.
C
        IF (IAI1.GT.0.AND.MAPACI(IAI1).EQ.1) CALL GPL (NCRA,XCRA,YCRA)
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE COLRA2 (XCRA,YCRA,NCRA,IAIA,IGIA,NAGI)
C
        DIMENSION XCRA(*),YCRA(*),IAIA(*),IGIA(*),IOCI(12)
C
C This routine is called to color an area from an area map.  Its
C coordinates are given by the NCRA coordinates in the arrays XCRA and
C YCRA.  For each I from 1 to NAGI, IAIA(I) is the area identifier of
C the area relative to the group whose group identifier is IGIA(I).
C
C Define an array of color indices associated with area identifiers.
C
        DATA IOCI / 3,4,5,6,8,9,10,11,12,13,14,15 /
C
C Find the area identifier for the area relative to groups 1 and 3.
C The first of these tells us whether the area is over land or water,
C and the second tells us what contour band the area is in.
C
        IAI1=-1
        IAI3=-1
C
        DO 101 I=1,NAGI
          IF (IGIA(I).EQ.1) IAI1=IAIA(I)
          IF (IGIA(I).EQ.3) IAI3=IAIA(I)
  101   CONTINUE
C
C Color-fill the area, using blue for any area over water, gray for any
C area over land which is not over Africa (including Madagascar) or is
C outside the contour plot, and a color depending on the contour level
C elsewhere.
C
        IF (IAI1.GT.0) THEN
          IF (MDIPAN(IAI1,'Water').NE.0) THEN
            CALL GSFACI (7)
            CALL GFA (NCRA-1,XCRA,YCRA)
          ELSE
            IF ((MDIPAN(IAI1,'Africa').EQ.0.AND.
     +           MDIPAN(IAI1,'Madagascar').EQ.0).OR.IAI3.LE.0) THEN
              CALL GSFACI (2)
              CALL GFA (NCRA-1,XCRA,YCRA)
            ELSE
              CALL GSFACI (IOCI(IAI3))
              CALL GFA (NCRA-1,XCRA,YCRA)
            END IF
          END IF
        END IF
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE COLRC2 (XCRA,YCRA,NCRA,IAIA,IGIA,NAGI)
C
        DIMENSION XCRA(*),YCRA(*),IAIA(*),IGIA(*)
C
C This routine is called to draw a portion of a contour line which is
C wholly contained in some area of an area map.  Its coordinates are
C given by the NCRA coordinates in the arrays XCRA and YCRA.  For each
C I from 1 to NAGI, IAIA(I) is the area identifier of the area relative
C to the group whose group identifier is IGIA(I).
C
C Find the area identifier for the area relative to groups 1 and 3.
C The first of these tells us whether the area is over land or water,
C and the second tells us what contour band the area is in.
C
        IAI1=-1
        IAI3=-1
C
        DO 101 I=1,NAGI
          IF (IGIA(I).EQ.1) IAI1=IAIA(I)
          IF (IGIA(I).EQ.3) IAI3=IAIA(I)
  101   CONTINUE
C
C Draw the line only if the area it is in is over Africa and within
C the boundary of the contour plot.
C
        IF (IAI1.GT.0.AND.
     +      (MDIPAN(IAI1,'Africa').NE.0.OR.
     +       MDIPAN(IAI1,'Madagascar').NE.0).AND.IAI3.GT.0) THEN
          CALL GPL (NCRA,XCRA,YCRA)
        END IF
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE COLRL2 (XCRA,YCRA,NCRA,IAIA,IGIA,NAGI)
C
        DIMENSION XCRA(*),YCRA(*),IAIA(*),IGIA(*)
C
C This routine is called to draw a portion of a line of latitude or
C longitude which is wholly contained in some area of an area map.  Its
C coordinates are given by the NCRA coordinates in the arrays XCRA and
C YCRA.  For each I from 1 to NAGI, IAIA(I) is the area identifier of
C the area relative to the group whose group identifier is IGIA(I).
C
C Find the area identifier for the area relative to group 1, which will
C tell us whether the area is over land or water.
C
        IAI1=-1
C
        DO 101 I=1,NAGI
          IF (IGIA(I).EQ.1.AND.IAIA(I).GT.0) IAI1=IAIA(I)
  101   CONTINUE
C
C Draw the line only if it is over water.
C
        IF (IAI1.GT.0.AND.MDIPAN(IAI1,'Water').NE.0) THEN
          CALL GPL (NCRA,XCRA,YCRA)
        END IF
C
C Done.
C
        RETURN
C
      END

      PROGRAM FTHEX04
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Declare an array in which to put an eye position for THREED.
C
        DIMENSION PEYE(3)
C
C Define a character variable in which to form numeric labels.
C
        CHARACTER*8 CHRS
C
C Declare arrays in which to put coordinates for a curve to be drawn.
C
        DIMENSION UCRV(361),VCRV(361),WCRV(361)
C
C Declare a function W(U,V) to be used in the example.
C
        WFUN(U,V)=.5+.25*SIN(5.*U)+.25*COS(5.*V)
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Make the tick marks drawn by PERIM3 twice as long as the default.
C
        CALL TICK43 (24,16,24,16,24,16)
C
C Define the boundaries of the box to be projected from 3-space to
C 2-space.
C
        UMIN=0.
        UMAX=1.
        VMIN=0.
        VMAX=1.
        WMIN=0.
        WMAX=1.
C
C Define the position of the eye.
C
        PEYE(1)=6.
        PEYE(2)=4.
        PEYE(3)=5.
C
C Initialize THREED.
C
        CALL SET3 (.1,.9,.1,.9,UMIN,UMAX,VMIN,VMAX,WMIN,WMAX,PEYE)
C
C Draw perimeters in each of the three coordinate planes.
C
        CALL PERIM3 (10,2,10,2,1,0.)
        CALL PERIM3 (10,2,10,2,2,0.)
        CALL PERIM3 (10,2,10,2,3,0.)
C
C Put some labels on the plot.  First, the U axis.
C
        CALL PWRZT (.5,0.,1.1,'U',1,3,-1,+3,0)
C
        DO 102 ILAB=1,10
          UPOS=REAL(ILAB)/10.
          WRITE (CHRS,'(F8.1)') UPOS
          IBEG=0
          DO 101 ICHR=1,8
            IF (CHRS(ICHR:ICHR).NE.' ') THEN
              IF (IBEG.EQ.0) THEN
                IBEG=ICHR
              END IF
              IEND=ICHR
            END IF
  101     CONTINUE
          IF (CHRS(IBEG:IBEG).EQ.'0') IBEG=MIN(IBEG+1,IEND)
          CALL PWRZT (UPOS,0.,1.05,CHRS(IBEG:IEND),IEND-IBEG+1,
     +                                               3,-1,+3,0)
  102   CONTINUE
C
C Next, the V axis.
C
        CALL PWRZT (0.,.5,1.1,'V',1,3,+2,+3,0)
C
        DO 104 ILAB=1,10
          VPOS=REAL(ILAB)/10.
          WRITE (CHRS,'(F8.1)') VPOS
          IBEG=0
          DO 103 ICHR=1,8
            IF (CHRS(ICHR:ICHR).NE.' ') THEN
              IF (IBEG.EQ.0) THEN
                IBEG=ICHR
              END IF
              IEND=ICHR
            END IF
  103     CONTINUE
          IF (CHRS(IBEG:IBEG).EQ.'0') IBEG=MIN(IBEG+1,IEND)
          CALL PWRZT (0.,VPOS,1.05,CHRS(IBEG:IEND),IEND-IBEG+1,
     +                                               3,+2,+3,0)
  104   CONTINUE
C
C Finally, the W axis.
C
        CALL PWRZT (1.2,0.,.5,'W',1,3,-1,+3,1)
C
        DO 106 ILAB=0,10
          WPOS=REAL(ILAB)/10.
          WRITE (CHRS,'(F8.1)') WPOS
          IBEG=0
          DO 105 ICHR=1,8
            IF (CHRS(ICHR:ICHR).NE.' ') THEN
              IF (IBEG.EQ.0) THEN
                IBEG=ICHR
              END IF
              IEND=ICHR
            END IF
  105     CONTINUE
          IF (CHRS(IBEG:IBEG).EQ.'0') IBEG=MIN(IBEG+1,IEND)
          CALL PWRZT (1.05,0.,WPOS,CHRS(IBEG:IEND),IEND-IBEG+1,
     +                                               3,-1,+3,1)
  106   CONTINUE
C
C Using POINT3, draw grids inside the perimeters drawn by PERIM3.
C
        DO 108 I=1,11
          PTMP=REAL(I-1)/10.
          DO 107 J=1,101
            QTMP=REAL(J-1)/100.
            CALL POINT3 (PTMP,QTMP,0.)
            CALL POINT3 (QTMP,PTMP,0.)
            CALL POINT3 (PTMP,0.,QTMP)
            CALL POINT3 (QTMP,0.,PTMP)
            CALL POINT3 (0.,PTMP,QTMP)
            CALL POINT3 (0.,QTMP,PTMP)
  107     CONTINUE
  108   CONTINUE
C
C Double the line width and draw a curve using FENCE3.
C
        CALL PLOTIF (0.,0.,2)
        CALL GSLWSC (2.)
C
        DO 109 I=1,361
          TEMP=5.*REAL(I-1)
          UCRV(I)=.5+TEMP/3600.*COS(.017453292519943*TEMP)
          VCRV(I)=.5+TEMP/3600.*SIN(.017453292519943*TEMP)
          WCRV(I)=WFUN(UCRV(I),VCRV(I))
  109   CONTINUE
C
        CALL FENCE3 (UCRV,VCRV,WCRV,361,3,0.)
C
C Advance the frame.
C
        CALL FRAME
C
C Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
C Done.
C
        STOP
C
      END

C
C $Id: opngks.f,v 1.8 2008-07-27 00:17:24 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE OPNGKS
C
C IU(6), in IUTLCM, is the current metacode unit number, negated if the
C unit is currently in use.
C
      COMMON /IUTLCM/ IU(100)
      SAVE /IUTLCM/
C
C  Do a call forcing a BLOCKDATA to be loaded from a binary library.
C
      CALL UTILBD
C
C Make sure that, if there is an uncleared prior error, the error
C message gets printed.  Go ahead and open GKS, though.
C
      IERR=ICFELL('OPNGKS - UNCLEARED PRIOR ERROR',1)
C
C Open GKS, define a workstation, and activate the workstation.
C
      IF (IU(6).GT.0) THEN
        CALL GOPKS (6,0)
        CALL GOPWK (1,IU(6),1)
        CALL GACWK (1)
        IU(6)=-ABS(IU(6))
      END IF
C
      RETURN
C
      END

C
C $Id: aggeti.f,v 1.7 2008-07-27 00:14:34 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE AGGETI (TPID,IUSR)
C
      CHARACTER*(*) TPID
      DIMENSION FURA(1)
C
C The routine AGGETI may be used to get the integer-equivalent value of
C any single AUTOGRAPH control parameter.
C
      CALL AGGETP (TPID,FURA,1)
      IUSR=IFIXMM(FURA(1))
      RETURN
C
      END

C
C	$Id: ginlod.f,v 1.6 2008-07-27 00:21:06 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GINLOD(GKSERR)
C
C  This routine loads the current CGM element into the metafile.
C  The current CGM element includes the opcode CLASS and ID,
C  and the size which may be short or long.
C
C  OUTPUT
C    GKSERR -- An error status flag.
C
C  All data is type integer unless otherwise indicated.
C
      IMPLICIT INTEGER (A-Z)
C
C  Common for communication of instruction and length.
C
      include 'g01ins.h'
      include 'g01io.h'
C
C  Define the ALLOK status and the opcode CLASS and ID lengths.
C
      DATA ALLOK,OPCLLN,OPIDLN/0,4,7/
C
C  Define the short format length, short format count, long format flag,
C  continue flag on, continue flag off, continue length, long format
C  length.
C
      DATA SHFMLN,SHTFMT,LFMFLG,CONON,CONOFF,CFMLNG,LFMLNG
     +          /5,30,31,1,0,1,15/
      DATA  SHORT/0/, LONG/1/
C
C  Initialize error status.
C
      GKSERR = ALLOK
C
C  Make sure the element starts on a 16 bit boundary.
C
      TEMP = MOD(MBFPOS,16)
      IF (TEMP .NE. 0) MBFPOS = MBFPOS + (16-TEMP)
C
C  Load the opcode CLASS and ID into the metafile.
C
      CALL GMFLOD(MCOPCL,OPCLLN,1,GKSERR)
      IF (GKSERR .NE. ALLOK) RETURN
      CALL GMFLOD(MCOPID,OPIDLN,1,GKSERR)
      IF (GKSERR .NE. ALLOK) RETURN
C
C  Determine if a long format or short format element.
C
      IF (MCCBYT .LE. SHTFMT) THEN
C
C  Short format.
C
        MSLFMT = SHORT
        CALL GMFLOD (MCCBYT,SHFMLN,1,GKSERR)
        IF (GKSERR .NE. ALLOK) RETURN
      ELSE
C
C  Long format.
C
        MSLFMT = LONG
        CALL GMFLOD (LFMFLG,SHFMLN,1,GKSERR)
        IF (GKSERR .NE. ALLOK) RETURN
C
C  Set the continue flag.
C
        IF (MCNBYT .NE. 0) THEN
C
C  There is another partition.
C
          CALL GMFLOD(CONON,CFMLNG,1,GKSERR)
        ELSE
C
C  Last partition.
C
          CALL GMFLOD(CONOFF,CFMLNG,1,GKSERR)
        END IF
C
        IF (GKSERR .NE. ALLOK) RETURN
C
C  Set the long format operand list size.
C
        CALL GMFLOD(MCCBYT,LFMLNG,1,GKSERR)
      END IF
C
      RETURN
      END

C
C $Id: pcwbin.f,v 1.4 2008-07-27 01:04:31 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C

      SUBROUTINE PCWBIN (INUN,IOUT,NOIN,ITMP,LTMP)
C
      DIMENSION ITMP(LTMP)
C
C This routine packs a set of 15-bit integers into an integer array and
C writes out the contents of that array.  The 15-bit integers are packed
C in such a way as to form a continuous bit stream; there are no unused
C bits, except perhaps in the last word of the array.
C
C On entry:
C
C   INUN is the unit number from which may be read NOIN card images.
C   Each card image contains 16 integers, in I5 format.  Each integer
C   represents a positive 15-bit value.
C
C   IOUT is the file descriptor of a file to which output is to be
C   written.  IOUT is assumed to be positioned correctly.
C
C   NOIN is the number of card images on unit INUN.
C
C   ITMP is an array of length LTMP.  Its elements may have any value.
C
C   LTMP must be (NOIN*15*16-1)/NBPW+1 or bigger, where NBPW is the
C   number of bits per word.
C
C On exit:
C
C   The values of INUN, IOUT, and NOIN are unchanged.  The unit INUN
C   has been rewound, but is otherwise unchanged.  ITMP contains the
C   packed integers from INUN.  A binary record has been written to
C   IOUT, consisting of the first (NOIN*15*16-1)/NBPW+1 words of the
C   array ITMP.
C
C COMMON block declarations.
C
      COMMON /PCCMN2/ NBPW,NPPW
C
C Define temporary storage for a card image.
C
      DIMENSION ICRD(16)
C
C Rewind the input unit.
C
      REWIND INUN
C
C Initialize NBIT and NWDS to say that the last position filled was the
C last fifteen bits in word 0, so that the next one to be filled will
C be the first fifteen bits in word 1.
C
      NBIT=NBPW-15
      NWDS=0
C
C Read integers from unit INUN and store them in the array ITMP.  The
C index I loops through the card images and the index J loops through
C the integers on each card image.
C
      DO 102 I=1,NOIN
        READ (INUN,'(16I5)') ICRD
        DO 101 J=1,16
          NBIT=NBIT+15
          IF (NBIT.GE.NBPW) THEN
            NBIT=NBIT-NBPW
            NWDS=NWDS+1
            IF (NBIT.EQ.0) ITMP(NWDS)=0
          END IF
          ITMP(NWDS)=IOR(ITMP(NWDS),
     +                   ISHIFT(IAND(ICRD(J),32767),NBPW-15-NBIT))
          IF (NBIT+15.GT.NBPW) THEN
            ITMP(NWDS+1)=ISHIFT(IAND(ICRD(J),ISHIFT(32767,NBIT-NBPW)),
     +                          2*NBPW-NBIT-15)
          END IF
  101   CONTINUE
  102 CONTINUE
C
C If ITMP(NWDS+1) has something in it, bump NWDS.
C
      IF (NBIT+15.GT.NBPW) NWDS=NWDS+1
C
C Write the integer array into the binary file.
C
      CALL NGWRIN (IOUT,ITMP,NWDS,ISTA)
C
      IF (ISTA.NE.NWDS) THEN
        PRINT * , 'IN PCWBIN, ERROR WRITING OUTPUT RECORD'
        STOP
      END IF
C
C Rewind the input unit.
C
      REWIND INUN
C
C Done.
C
      RETURN
C
      END

C
C $Id: agexax.f,v 1.9 2008-07-27 00:14:34 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE AGEXAX (IAXS,SVAL,UMIN,UMAX,NICE,QLUA,FUNS,QBTP,BASD,
     +                   BASE,QMJD,QMND,QMNT,QLTD,QLTP,QLED,QLEX,QLFD,
     +                   QLFL,QMIN,QMAX)
C
      DIMENSION SVAL(2)
C
C The routine AGEXAX is used by AGSTUP to examine the parameters which
C determine how a given axis is tick-marked and labelled and to provide
C default values for missing ones.  Its arguments are as follows:
C
C -- IAXS is the number of the axis being drawn - 1, 2, 3, or 4.
C
C -- SVAL is the array of special values.
C
C -- UMIN and UMAX are the minimum and maximum values along the axis, in
C    the user coordinate system.  Rounded values of UMIN and UMAX are
C    returned in QMIN and QMAX if the following argument (NICE) is zero.
C
C -- NICE is a flag indicating whether rounded values of UMIN and UMAX
C    are to be returned (NICE.EQ.0) or not (NICE.NE.0).
C
C -- LLUA and FUNS specify the user-system-to-label-system mapping along
C    the axis.  See the routine AGAXIS for a discussion of them.
C
C -- NBTP, BASD, BASE, and NMJD are used to determine the positioning of
C    major tick marks in the label coordinate system.  NBTP and BASE are
C    described in the routine AGNUMB.  BASD is the desired value of BASE
C    supplied by the user.  If BASD has a null value, BASE is computed
C    by AGEXAX.  NMJD is a user-supplied-or-defaulted parameter giving
C    the approximate number of major ticks (and therefore the number of
C    numeric labels) to be placed on the axis.
C
C -- NMND and NMNT are the desired and actual (to be determined) number
C    of minor ticks per major division.  See discussion in AGAXIS.
C
C -- NLTD, NLTP, NLED, NLEX, NLFD, and NLFL are desired and actual (to
C    be determined) values of the parameters describing the form to be
C    used for numeric labels.  See discussion in AGNUMB.
C
C -- QMIN and QMAX are rounded values of UMIN and UMAX, returned only if
C    NICE.EQ.0.
C
C The following common block contains AUTOGRAPH variables which are
C not control parameters.  The only one used here is SMRL, which is a
C (machine-dependent) small real which, when added to a number in the
C range (1,10), will round it upward without seriously affecting the
C leading significant digits.  The object of this is to get rid of
C strings of nines.
C
      COMMON /AGORIP/ SMRL , ISLD , MWCL,MWCM,MWCE,MDLA,MWCD,MWDQ ,
     +                INIF
      SAVE /AGORIP/
C
C The following common block contains the new variable SMLL, which is
C essentially the smallest positive real number X such that "1.+X" is
C different from "1.".  This is used for some purposes for which the
C variable SMRL was previously used.  (10/21/89)
C
      COMMON /AGORIQ/ SMLL
      SAVE /AGORIQ/
C
C The arrays BASP and NMNP specify possible default values for BASE and
C NMNT when NBTP.EQ.1.
C
      DIMENSION BASP(5),NMNP(5)
C
      DATA BASP(1) / 10. / , NMNP(1) / 1 / ,
     *     BASP(2) /  5. / , NMNP(2) / 4 / ,
     *     BASP(3) /  2. / , NMNP(3) / 1 / ,
     *     BASP(4) /  1. / , NMNP(4) / 1 / ,
     *     BASP(5) /  .5 / , NMNP(5) / 4 /
C
C If the parameter NBTP is zero, tick marks and labels are suppressed.
C
      NBTP=IFIXMM(QBTP)
      IF (NBTP.EQ.0) RETURN
C
C Unpack integer values from floating-point arguments.
C
      LLUA=IFIXMM(QLUA)
      NMJD=IFIXMM(QMJD)
      NMND=IFIXMM(QMND)
      NMNT=0
      NLTD=IFIXMM(QLTD)
      NLTP=0
      NLED=IFIXMM(QLED)
      NLEX=0
      NLFD=IFIXMM(QLFD)
      NLFL=0
C
C Compute label-coordinate-system values at the ends of the axis.
C
      CALL AGUTOL (IAXS,FUNS,1,UMIN,VMIN)
      CALL AGUTOL (IAXS,FUNS,1,UMAX,VMAX)
C
C Error if the label-coordinate-system values are equal.
C
      IF (VMIN.EQ.VMAX) GO TO 901
C
C If a special value is specified for the parameter BASD, AGEXAX must
C pick a value for the parameter BASE.
C
      IF (BASD.EQ.SVAL(1).OR.BASD.EQ.SVAL(2)) GO TO 101
C
C The user has specified a value for the parameter BASE.  If that value
C is less than or equal to zero, tick marks and labels are suppressed.
C
      BASE=MAX(0.,BASD)
      IF (BASE.EQ.0.) RETURN
      NMNT=0
      GO TO 108
C
C Pick a value for the parameter BASE, depending on the number type.
C
  101 GO TO (102,105,106) , NBTP
C
C Major ticks and labels are at numbers of the form (-) BASE * EXMU.
C
  102 NMJD=MAX(0,NMJD)
C
C Compute an approximate value for BASE.
C
      FTMP=ABS(VMAX-VMIN)/REAL(NMJD+1)
C
C Reduce the approximate value to the form FTMP * 10 ** ITMP.
C
      JMP1=1
      GO TO 200
C
C Pick a reasonable value for BASE (1., 2., OR 5. * 10**ITMP).
C
  103 DO 104 I=1,5
        IF (FTMP.LT.BASP(I)) GO TO 104
        BASE=REAL(DBLE(BASP(I))*10.D0**ITMP)
        NMNT=NMNP(I)
        GO TO 107
  104 CONTINUE
C
C Major ticks and labels are at numbers of the form (-) BASE * 10**EXMU.
C
  105 BASE=1.
      NMNT=8
      GO TO 107
C
C Major ticks and labels are at numbers of the form (-) BASE**EXMU.
C
  106 BASE=10.
      NMNT=8
C
  107 IF (BASD.EQ.SVAL(2)) BASD=BASE
C
  108 IF (QMND.NE.SVAL(1).AND.QMND.NE.SVAL(2)) NMNT=MAX(0,NMND)
      IF (QMND.EQ.SVAL(2)) QMND=REAL(NMNT)
C
C If the user wants nice values at the axis ends, reset UMIN and UMAX.
C
      IF (NICE.NE.0) GO TO 115
C
      LOOP=0
C
      WMIN=VMIN
      WMAX=VMAX
C
      GO TO (109,110,112) , NBTP
C
  109 EMIN=VMIN/BASE+.5+SIGN(.5,VMIN-VMAX)
      EMAX=VMAX/BASE+.5+SIGN(.5,VMAX-VMIN)
      EMIN=EMIN-.5+SIGN(.5,EMIN)-SIGN(SMRL*EMIN,VMIN-VMAX)
     +                                                +1.E-6*(EMAX-EMIN)
      EMAX=EMAX-.5+SIGN(.5,EMAX)-SIGN(SMRL*EMAX,VMAX-VMIN)
     +                                                -1.E-6*(EMAX-EMIN)
      WMIN=BASE*(EMIN-MOD(EMIN,1.))
      WMAX=BASE*(EMAX-MOD(EMAX,1.))
      GO TO 114
C
  110 IF ((VMIN.LT.0..AND.VMAX.LT.0.).OR.(VMIN.GT.0..AND.VMAX.GT.0.))
     +                                                              THEN
        EMIN=ALOG10(ABS(VMIN)/BASE)+.5+SIGN(.5,VMIN)*SIGN(1.,VMIN-VMAX)
        EMAX=ALOG10(ABS(VMAX)/BASE)+.5+SIGN(.5,VMAX)*SIGN(1.,VMAX-VMIN)
        EMIN=EMIN-.5+SIGN(.5,EMIN)
     +        -SIGN(SMRL*EMIN,VMIN)*SIGN(1.,VMIN-VMAX)+1.E-6*(EMAX-EMIN)
        EMAX=EMAX-.5+SIGN(.5,EMAX)
     +        -SIGN(SMRL*EMAX,VMAX)*SIGN(1.,VMAX-VMIN)-1.E-6*(EMAX-EMIN)
        WMIN=SIGN(BASE,VMIN)*10.**(EMIN-MOD(EMIN,1.))
        WMAX=SIGN(BASE,VMAX)*10.**(EMAX-MOD(EMAX,1.))
      ELSE
        IF (VMIN.NE.0.) THEN
          EMIN=ALOG10(ABS(VMIN)/BASE)+.5+SIGN(.5,VMIN)*
     +                                                SIGN(1.,VMIN-VMAX)
          EMIN=EMIN-.5+SIGN(.5,EMIN)-SIGN(SMRL*EMIN,VMIN)*
     +                                                SIGN(1.,VMIN-VMAX)
          WMIN=SIGN(BASE,VMIN)*10.**(EMIN-MOD(EMIN,1.))
        END IF
        IF (VMAX.NE.0.) THEN
          EMAX=ALOG10(ABS(VMAX)/BASE)+.5+SIGN(.5,VMAX)*
     +                                                SIGN(1.,VMAX-VMIN)
          EMAX=EMAX-.5+SIGN(.5,EMAX)-SIGN(SMRL*EMAX,VMAX)*
     +                                                SIGN(1.,VMAX-VMIN)
          WMAX=SIGN(BASE,VMAX)*10.**(EMAX-MOD(EMAX,1.))
        END IF
      END IF
      GO TO 114
C
  112 IF (BASE.EQ.1.) GO TO 115
      IF (VMIN*VMAX.GT.0.) THEN
        EMIN=ALOG10(ABS(VMIN))/ALOG10(BASE)+.5+SIGN(.5,VMIN)*
     +                                                SIGN(1.,VMIN-VMAX)
        EMAX=ALOG10(ABS(VMAX))/ALOG10(BASE)+.5+SIGN(.5,VMAX)*
     +                                                SIGN(1.,VMAX-VMIN)
        EMIN=EMIN-.5+SIGN(.5,EMIN)-SIGN(SMRL*EMIN,VMIN)*
     +                              SIGN(1.,VMIN-VMAX)+1.E-6*(EMAX-EMIN)
        EMAX=EMAX-.5+SIGN(.5,EMAX)-SIGN(SMRL*EMAX,VMAX)*
     +                              SIGN(1.,VMAX-VMIN)-1.E-6*(EMAX-EMIN)
        WMIN=SIGN(1.,VMIN)*BASE**(EMIN-MOD(EMIN,1.))
        WMAX=SIGN(1.,VMAX)*BASE**(EMAX-MOD(EMAX,1.))
      ELSE
        IF (VMIN.NE.0.) THEN
          EMIN=ALOG10(ABS(VMIN))/ALOG10(BASE)
     +                              +.5+SIGN(.5,VMIN)*SIGN(1.,VMIN-VMAX)
          EMIN=EMIN-.5+SIGN(.5,EMIN)-SIGN(SMRL*EMIN,VMIN)*
     +                                                SIGN(1.,VMIN-VMAX)
          WMIN=SIGN(1.,VMIN)*BASE**(EMIN-MOD(EMIN,1.))
        END IF
        IF (VMAX.NE.0.) THEN
          EMAX=ALOG10(ABS(VMAX))/ALOG10(BASE)
     +                              +.5+SIGN(.5,VMAX)*SIGN(1.,VMAX-VMIN)
          EMAX=EMAX-.5+SIGN(.5,EMAX)-SIGN(SMRL*EMAX,VMAX)*
     +                                                SIGN(1.,VMAX-VMIN)
          WMAX=SIGN(1.,VMAX)*BASE**(EMAX-MOD(EMAX,1.))
        END IF
      END IF
C
C Re-compute the user-coordinate-system minimum and maximum values.
C
  114 CALL AGUTOL (IAXS,FUNS,-1,WMIN,QMIN)
      CALL AGUTOL (IAXS,FUNS,-1,WMAX,QMAX)
C
C Test for problems with nice values chosen.
C
      IF (QMIN.LT.QMAX) GO TO 140
      IF (QMIN.GT.QMAX) GO TO 901
C
C We have a pathological case - user values are clustered very close to
C a label position.  See what can be done about it.
C
      LOOP=LOOP+1
      IF (LOOP.GT.1) GO TO 901
C
      GO TO (137,138,139) , NBTP
C
  137 VMIN=VMIN+SIGN(BASE,VMIN-VMAX)
      VMAX=VMAX+SIGN(BASE,VMAX-VMIN)
      GO TO 109
C
  138 VMIN=VMIN*10.**(SIGN(1.,VMIN)*SIGN(1.,VMIN-VMAX))
      VMAX=VMAX*10.**(SIGN(1.,VMAX)*SIGN(1.,VMAX-VMIN))
      GO TO 110
C
  139 VMIN=VMIN*BASE**(SIGN(1.,VMIN)*SIGN(1.,VMIN-VMAX))
      VMAX=VMAX*BASE**(SIGN(1.,VMAX)*SIGN(1.,VMAX-VMIN))
      GO TO 112
C
  140 VMIN=WMIN
      VMAX=WMAX
C
C Now we examine the parameters defining the appearance of the numeric
C labels.  If the numeric-label type is zero, there is no more to do.
C
  115 IF (QLTD.EQ.SVAL(1).OR.QLTD.EQ.SVAL(2)) GO TO 116
      NLTP=MAX(0,MIN(3,NLTD))
      IF (NLTP.EQ.0) GO TO 136
C
C The numeric-label type (NLTP) is specified.  If both the numeric-label
C exponent and numeric-label fraction-length are also specified, quit.
C
      NLEX=NLED
      NLFL=NLFD
      IF (QLED.NE.SVAL(1).AND.QLED.NE.SVAL(2).AND.
     +    QLFD.NE.SVAL(1).AND.QLFD.NE.SVAL(2)       ) GO TO 136
      GO TO 117
C
C We must pick a value for the numeric-label type.  Start with the dummy
C value 4 so as to jump to the proper piece of code.
C
  116 NLTP=4
C
C Reduce the value of BASE to the form RBSE * 10**KBSE, where RBSE is
C in the range (1,10) and KBSE is an integer.
C
  117 FTMP=BASE
      JMP1=2
      GO TO 200
C
  118 RBSE=FTMP
      KBSE=ITMP
C
C Compute LBSE = the number of significant digits in RBSE.
C
      GO TO 300
C
  119 LBSE=1+ITMP
C
C Jump depending on the value of the numeric-label type.
C
      GO TO (120,128,131,132) , NLTP
C
C Scientific notation is to be used.  Estimate the number of significant
C digits that are likely to be required, depending on the number type.
C
  120 GO TO (121,123,124) , NBTP
C
  121 FTMP=MAX(ABS(VMIN),ABS(VMAX))/BASE
      JMP1=3
      GO TO 200
C
  122 NSIG=MAX(1,ITMP+1+LBSE)
      GO TO 125
C
  123 NSIG=LBSE
      GO TO 125
C
  124 NSIG=10
C
C NLEX + NLFL should be equal to NSIG.  Make that the case.
C
  125 IF (QLED.NE.SVAL(1).AND.QLED.NE.SVAL(2)) GO TO 127
      IF (QLFD.EQ.SVAL(1).OR. QLFD.EQ.SVAL(2)) GO TO 126
      NLEX=NSIG-MAX(0,NLFL)
      GO TO 135
  126 NLEX=1
  127 NLFL=NSIG-NLEX
      IF (NLFL.LE.0) NLFL=-1
      GO TO 135
C
C Exponential notation is to be used.  Compute the exponent NEXP such
C that BASE / 10**NEXP is an integer.
C
  128 NEXP=KBSE-LBSE+1
C
C NLEX - NLFL should be equal to NEXP.  Make that the case.  (Note that,
C if NBTP is 3, NLEX is forced to zero.)
C
      IF (NBTP.EQ.3) NLEX=0
C
      IF (QLFD.NE.SVAL(1).AND.QLFD.NE.SVAL(2)) GO TO 129
      IF (QLED.NE.SVAL(1).AND.QLED.NE.SVAL(2)) GO TO 130
      NLFL=-1
  129 NLEX=MAX(0,NLFL)+NEXP
      GO TO 135
  130 NLFL=NLEX-NEXP
      IF (NLFL.LE.0) NLFL=-1
      GO TO 135
C
C No-exponent notation is to be used.  NLFL is the only parameter we
C need to worry about.  If it is already set, quit.
C
  131 IF (QLFD.NE.SVAL(1).AND.QLFD.NE.SVAL(2)) GO TO 136
C
C Set NLFL to the actual number of digits in the fractional portion of
C BASE.
C
      NLFL=LBSE-KBSE-1
      IF (NLFL.LE.0) NLFL=-1
      GO TO 135
C
C We must pick a value for the numeric-label type, depending on the
C number type.
C
  132 GO TO (133,134,134) , NBTP
C
C Nunbers are of the form (-) BASE * EXMU.  Use labels with no exponent
C unless the use of an exponent would result in shorter labels.
C
  133 IF (MAX(KBSE+1-LBSE,-KBSE-1).GT.4) GO TO 134
      NLTP=3
      NLFL=LBSE-KBSE-1
      IF (NLFL.LE.0) NLFL=-1
      GO TO 135
C
C Exponential notation is used.
C
  134 NLTP=2
      NLEX=KBSE-LBSE+1
      NLFL=-1
C
C Back-store the computed parameters, if requested, and return.
C
  135 IF (QLTD.EQ.SVAL(2)) QLTD=REAL(NLTP)
      IF (QLED.EQ.SVAL(2)) QLED=REAL(NLEX)
      IF (QLFD.EQ.SVAL(2)) QLFD=REAL(NLFL)
C
C Pack up integer values to floating-point arguments and return.
C
  136 QMNT=REAL(NMNT)
      QLTP=REAL(NLTP)
      QLEX=REAL(NLEX)
      QLFL=REAL(NLFL)
      RETURN
C
C *-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
C
C This internal procedure reduces the number (FTMP) to the range (1,10),
C returning (FTMP) and (ITMP) such that (FTMP) * 10**(ITMP) is equal to
C the original value of (FTMP).  (FTMP) must be positive.
C
  200 FTM1=ALOG10(FTMP+SMRL*FTMP)
      IF (FTM1.LT.0.) FTM1=FTM1-1.
      ITMP=INT(FTM1)
      FTMP=MAX(1.,FTMP*REAL(10.D0**(-ITMP)))
      GO TO (103,118,122) , JMP1
C
C *-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
C
C This internal procedure counts the number of digits in the fractional
C portion of (FTMP), returning the count as the value of (ITMP).
C
  300 FTM1=MOD(FTMP+SMRL*FTMP,1.)
      FTM2=10.*SMRL*FTMP
      ITMP=0
C
  301 IF (FTM1.LT.FTM2) GO TO 302
      ITMP=ITMP+1
      IF (ITMP.GE.10) GO TO 302
      FTM1=MOD(10.*FTM1,1.)
      FTM2=10.*FTM2
      GO TO 301
C
  302 GO TO 119
C
C *-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
C
C Error exit.
C
  901 WRITE (I1MACH(4),9001) IAXS
      CALL SETER ('AGEXAX (CALLED BY AGSTUP) - USER-SYSTEM-TO-LABEL-SYST
     +EM MAPPING IS NOT MONOTONIC',1,2)
C
C Formats.
C
 9001 FORMAT ('0PROBLEM WITH AXIS NUMBER',I2,
     +        ' (1, 2, 3, AND 4 IMPLY LEFT, RIGHT, BOTTOM, AND TOP)')
C
      END

C
C $Id: maqtri.f,v 1.6 2008-09-18 00:42:17 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MAQTRI (UVAL,VVAL,RLAT,RLON)
        REAL   UVAL,VVAL,RLAT,RLON
        DOUBLE PRECISION DLAT,DLON
        IF (ICFELL('MAQTRI - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
        CALL MDQTRI (DBLE(UVAL),DBLE(VVAL),DLAT,DLON)
        IF (ICFELL('MAQTRI',2).NE.0) RETURN
        IF (DLAT.NE.1.D12) THEN
          RLAT=REAL(DLAT)
          RLON=REAL(DLON)
        ELSE
          RLAT=1.E12
          RLON=1.E12
        END IF
        RETURN
      END

C
C $Id: aiprin.f,v 1.4 2008-09-18 00:42:16 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE AIPRIN (UVAL,VVAL,DLAT,DLON)
C
        DOUBLE PRECISION UVAL,VVAL,DLAT,DLON
C
C The subroutine AIPRIN implements the inverse of the Aitoff
C projection, using an iterative algorithm due to Cengizhan Ipbuker,
C of the Istanbul Technical University, in Istanbul, Turkey, and Oztug
C Bildirici, of Selcuk University, in Konya, Turkey.  Their paper is
C called "A General Algorithm for the Inverse Transformation of Map
C Projections Using Jacobian Matrices", and it was published in the
C proceedings of the Third International Symposium on Mathematical and
C Computational Applications, September 4-6, 2002 (pp. 175-182).
C
C UVAL and VVAL are input values of U and V, in the projection plane.
C DLAT and DLON are output values of latitude and longitude, in radians.
C
C The common block MAPCM0 contains mathematical constants.
C
        COMMON /MAPCM0/  COS1,DTOR,DTRH,OOPI,PI,PIOF,PIOT,RTDD,RTOD,
     +                   SROT,SIN1,TOPI,TSRT
        DOUBLE PRECISION COS1,DTOR,DTRH,OOPI,PI,PIOF,PIOT,RTDD,RTOD,
     +                   SROT,SIN1,TOPI,TSRT
        SAVE   /MAPCM0/
C
C Local variables.
C
        DOUBLE PRECISION CVAL,DLAP,DLOP,DNOM,DVAL,PULA,PULO,PVLA,PVLO,
     +                   TVAL,UDIF,VDIF,UMIN,UMAX,VMIN,VMAX
C
C First, we must check the point (UVAL,VVAL) to see if it lies in the
C ellipse occupied by the projection of the globe.  If not, we return
C the value "1.D12" to signal that fact.
C
        IF ((UVAL/PI)**2+(VVAL/PIOT)**2-1.D0.GT.1.D-12) THEN
          DLAT=1.D12
          DLON=1.D12
          RETURN
        END IF
C
C Ipbuker and Bildirici's algorithm makes use of partial derivatives
C of the forward projection functions, which are usually expressed
C using the SINC function, which is carefully defined so as not to
C cause problems when its argument is zero.  To facilitate the taking
C of partial derivatives, the SINC function was replaced by a more
C conventional expression, and it may be that which causes problems
C for the algorithm along the equator.  In any case, the following
C code takes care of the problem:
C
        IF (ABS(VVAL).LT.1.D-12) THEN
          DLAT=VVAL
          DLON=UVAL
          RETURN
        END IF
C
C Set up the iteration loop.  DLAP and DLOP hold values of latitude and
C longitude from the previous iteration; they are given initial values
C that represent a guess at the proper values.  I'm using the inverse
C of the Hammer projection for the purpose.
C
        CALL HAPRIN (.9999D0*TSRT*UVAL/PI,.9999D0*SROT*VVAL/PIOT,
     +                                                 DLAP,DLOP)
C
C NITR keeps track of the number of iterations performed, which is
C limited to 20.  (Actually, my tests indicate that a maximum of 7
C iterations suffice to give full double-precision accuracy.)
C
        NITR=1
C
C Iteration loop.  First, compute terms that occur frequently.
C
  103   TVAL=COS(DLAP)*COS(.5D0*DLOP)
C
        CVAL=1.D0-TVAL**2
        DVAL=ACOS(TVAL)
C
C To follow this code, refer to Ipbuker and Bildirici's paper.  UDIF
C and VDIF are functions of latitude and longitude expressing the
C difference between the projected values at a lat/lon position and
C the desired values.  Each of PULA, PULO, PVLA, and PVLO is a partial
C derivative of either U or V with respect to either latitude or
C longitude.
C
        TVAL=DVAL/SQRT(CVAL)
C
        UDIF=2.D0*TVAL*COS(DLAP)*SIN(.5D0*DLOP)-UVAL
        VDIF=TVAL*SIN(DLAP)-VVAL
C
        TVAL=TVAL/CVAL
C
        PULA=SIN(DLOP)*SIN(2.D0*DLAP)/(2.D0*CVAL)-
     +       2.D0*TVAL*SIN(DLAP)*SIN(.5D0*DLOP)
        PULO=COS(DLAP)**2*SIN(.5D0*DLOP)**2/CVAL+
     +       TVAL*COS(DLAP)*COS(.5D0*DLOP)*SIN(DLAP)**2
        PVLA=SIN(DLAP)**2*COS(.5D0*DLOP)/CVAL+
     +       TVAL*SIN(.5D0*DLOP)**2*COS(DLAP)
        PVLO=.25D0*(SIN(2.D0*DLAP)*SIN(.5D0*DLOP)/CVAL-
     +             TVAL*SIN(DLAP)*COS(DLAP)**2*SIN(DLOP))
C
        DNOM=PULA*PVLO-PVLA*PULO
C
C DLAT and DLON are improved values of latitude and longitude.
C
        DLAT=DLAP-(UDIF*PVLO-VDIF*PULO)/DNOM
        DLON=DLOP-(VDIF*PULA-UDIF*PVLA)/DNOM
C
C If the improved values are not sufficiently different from the
C previous values and fewer than 20 iterations have been performed,
C go back for another one.  Otherwise, just return DLAT and DLON.
C
        IF (ABS(DLAT-DLAP).GT.1.D-12.OR.ABS(DLON-DLOP).GT.1.D-12) THEN
          IF (NITR.LT.20) THEN
            DLAP=DLAT
            DLOP=DLON
            NITR=NITR+1
            GO TO 103
          END IF
        END IF
C
C Done.
C
        RETURN
C
      END

C
C       $Id: vvtext.f,v 1.15 2008-07-27 00:17:35 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
C This module contains four subroutines for text support of the
C VELVCT utility. 
C The first, VVARTX, is a relatively high level routine
C that outputs a horizontally aligned vector arrow, with a numerical
C string presumably specifying the vector magnitude above and an
C informational label below. It is designed to allow a message
C showing the maximum and/or minimum vector contained the plot
C to be displayed. If the vectors are colored by vector magnitude
C then the vector is drawn using its designated color.
C
C The other modules are lowel level support routines:
C
C VVTXLN determines the first and last non-blank characters of an
C        arbitrary text string
C
C VVTXIQ returns the height and width of piece of text intended for
C        output using the PLOTCHAR routine PLCHHQ. 
C
C VVTXPO allows for 9 way justification of a text string using a
C        position mode parameter compatible with the CONPACK text 
C        positioning method. Given the position mode, position,
C        width and height of the text in the fractional system,
C        a position in user coordinates is returned for use with
C        the PLCHHQ routine assuming the CNTR parameter is set to
C        0.0.
C 
C Note that these routines as yet have no support for non-horizontal
C text. 
C
C --------------------------------------------------------------------
C
      SUBROUTINE VVARTX(CTX,IPO,FWX,FWY,TSZ,ITC,VMG,ASZ)
C
      CHARACTER*(*) CTX
C
C Writes an informational label consisting of a horizontal vector
C with the size over it, and a text string describing the
C vector underneath
C
C Input parameters:
C
C CTX - the character string
C IPO - the positioning mode for the informational box as a whole
C FWX,FWY - the reference position as a fraction of the viewport
C TSZ - the text size as a fraction of the viewport
C ITC - the text color
C VMG - the vector magnitude 
C ASZ - the arrow size in the fractional system
C
C ---------------------------------------------------------------------
C
C NOTE:
C Since implicit typing is used for all real and integer variables
C a consistent length convention has been adopted to help clarify the
C significance of the variables encountered in the code for this 
C utility. All local variable and subroutine parameter identifiers 
C are limited to 1,2,or 3 characters. Four character names identify  
C members of common blocks. Five and 6 character variable names 
C denote PARAMETER constants or subroutine or function names.
C
C Declare the VV common blocks.
C
C IPLVLS - Maximum number of color threshold level values
C IPAGMX - Maximum number of area groups allowed in the area map
C
      PARAMETER (IPLVLS = 256, IPAGMX = 64)
C
C Integer and real common block variables
C
C
      COMMON /VVCOM/
     +                IUD1       ,IVD1       ,IPD1       ,IXDM       ,
     +                IYDN       ,VLOM       ,VHIM       ,ISET       ,
     +                VRMG       ,VRLN       ,VFRC       ,IXIN       ,
     +                IYIN       ,ISVF       ,UUSV       ,UVSV       ,
     +                UPSV       ,IMSK       ,ICPM       ,UVPS       ,
     +                UVPL       ,UVPR       ,UVPB       ,UVPT       ,
     +                UWDL       ,UWDR       ,UWDB       ,UWDT       ,
     +                UXC1       ,UXCM       ,UYC1       ,UYCN       ,
     +                NLVL       ,IPAI       ,ICTV       ,WDLV       ,
     +                UVMN       ,UVMX       ,PMIN       ,PMAX       ,
     +                RVMN       ,RVMX       ,RDMN       ,RDMX       ,
     +                ISPC       ,RVMD       ,IPLR       ,IVST       ,
     +                IVPO       ,ILBL       ,IDPF       ,IMSG       ,
     +                ICLR(IPLVLS)           ,TVLU(IPLVLS)
C
C Arrow size/shape parameters
C
        COMMON / VVARO /
     +                HDSZ       ,HINF       ,HANG       ,IAST       ,
     +                HSIN       ,HCOS       ,FAMN       ,FAMX       ,
     +                UVMG       ,FAIR       ,FAWR       ,FAWF       ,
     +                FAXR       ,FAXF       ,FAYR       ,FAYF       ,
     +                AROX(8)    ,AROY(8)    ,FXSZ       ,FYSZ       ,
     +                FXRF       ,FXMN       ,FYRF       ,FYMN       ,
     +                FWRF       ,FWMN       ,FIRF       ,FIMN       ,
     +                AXMN       ,AXMX       ,AYMN       ,AYMX       ,
     +                IACM       ,IAFO       ,WBAD       ,WBTF       ,
     +                WBCF       ,WBDF       ,WBSC
C
C
C Text related parameters
C
        COMMON /VVTXP /
     +                FCWM    ,ICSZ    ,
     +                FMNS    ,FMNX    ,FMNY    ,IMNP    ,IMNC  ,
     +                FMXS    ,FMXX    ,FMXY    ,IMXP    ,IMXC  ,
     +                FZFS    ,FZFX    ,FZFY    ,IZFP    ,IZFC  ,
     +                FILS    ,FILX    ,FILY    ,IILP    ,IILC  ,
     +                FLBS    ,ILBC

C
C Character variable declartions
C
      CHARACTER*160 CSTR
      PARAMETER (IPCHSZ=36)
      CHARACTER*(IPCHSZ)  CMNT,CMXT,CZFT,CLBT,CILT
C
C Text string parameters
C
      COMMON /VVCHAR/ CSTR,CMNT,CMXT,CZFT,CLBT,CILT
C
      SAVE /VVCOM/, /VVARO/, /VVTXP/, /VVCHAR/
C
C The mapping common block: made available to user mapping routines
C
      COMMON /VVMAP/
     +                IMAP       ,
     +                XVPL       ,XVPR       ,YVPB       ,YVPT       ,
     +                WXMN       ,WXMX       ,WYMN       ,WYMX       ,
     +                XLOV       ,XHIV       ,YLOV       ,YHIV       ,
     +                SXDC       ,SYDC       ,NXCT       ,NYCT       ,
     +                RLEN       ,LNLG       ,INVX       ,INVY       ,
     +                ITRT       ,IWCT       ,FW2W       ,FH2H       ,
     +                DVMN       ,DVMX       ,RBIG       ,IBIG
C
      SAVE /VVMAP/
C
C Math constants
C
      PARAMETER (PDTOR  = 0.017453292519943,
     +           PRTOD  = 57.2957795130823,
     +           P1XPI  = 3.14159265358979,
     +           P2XPI  = 6.28318530717959,
     +           P1D2PI = 1.57079632679489,
     +           P5D2PI = 7.85398163397448) 
C
C --------------------------------------------------------------------
C
      CHARACTER*10 LBL
      EXTERNAL VVDUMB
C
C Space height factors -- if the vector is large in comparison with
C the text the space is calculated as a fraction (PSPFC1) of the 
C text size.
C Otherwise, (and preferably, because the minimum and maximum labels
C will align properly), the space height is calculated as half the
C remainder when the vector height is subtracted from a multiple
C (PSPFC2) of the text height.
C
      PARAMETER (PSPFC1=0.5,PSPFC2=2.0)
      REAL IAR(4)
      DATA IDM / 0 /
C
C --------------------------------------------------------------------
C
C Turn off clipping because this label is likely to be outside
C the current viewport
C
      CALL GQCLIP(IER,ICL,IAR)
      CALL GSCLIP(0)
C
C Save and reset the SET transformation to an identity (for safety)
C     
      CALL GETSET(VPL,VPR,VPB,VPT,WDL,WDR,WDB,WDT,ILG)
      CALL SET(0.0,1.0,0.0,1.0,0.0,1.0,0.0,1.0,1)
C
C Convert fraction of viewport values into fractional system
C coordinates
C      
      XF = XVPL + FWX * FW2W
      YF = YVPB + FWY * FH2H
C
C Write out the label and compute its height and width
C
      WRITE(LBL,'(E10.3)')VMG
      CALL VVTXLN(LBL,10,LB,LE)
      CALL VVTXIQ(LBL(LB:LE),TSZ*FW2W,WL,HL)
C
C We know the width of the arrow, compute its height
C If less than or equal to 0.0 it will not be drawn unless using
C wind barbs
C
C Determine the height of the arrow by calling the drawing routine
C using a negative value of the vector len
C
      WA = ASZ
      UVMG = VMG
      IF (WA .GT. 0.0) THEN
         IF (IAST .EQ. 0) THEN
            CALL VVDRAW(0.5,0.5,0.5+WA,0.5,-WA,LBL,0,IDM,VVDUMB,0)
         ELSE IF (IAST .EQ. 1) THEN
            CALL VVDRFL(0.5,0.5,0.5+WA,0.5,-WA,LBL,0,IDM,VVDUMB,0)
         ELSE
            CALL VVDRWB(0.5,0.5,0.5+WA,0.5,-WA,LBL,0,IDM,VVDUMB,0)
         END IF
      END IF
      IF (WA .LE. 0.0) THEN
         HA = 0.0
         YAJ = 0.0
      ELSE
         HA = FYSZ
         YAJ = ((AYMX - 0.5) - (0.5 - AYMN)) / 2.0
      END IF
C
C Now get the size of the vector text string
C
      CALL VVTXLN(CTX,IPCHSZ,IB,IE)
      CALL VVTXIQ(CTX(IB:IE),TSZ*FW2W,WT,HT)
C
C Compute a space height based on the text height and arrow height
C
      HS = MAX(PSPFC1 * HT, (PSPFC2*HT - HA) / 2.0) 
C
C Compute the total size of the info label
C Two space heights are added
C
      WTT = MAX(WT,WA,WL)
      HTT = HL + HA + 2*HS + HT
C
C Adjust the input position so that we can effectively
C treat it as lower left.
C
      IF (IPO.LE.-4) THEN
         XFA=XF
         YFA=YF
      ELSE IF (IPO.EQ.-3) THEN
         XFA=XF-0.5*WTT
         YFA=YF
      ELSE IF (IPO.EQ.-2) THEN
         XFA=XF-WTT
         YFA=YF
      ELSE IF (IPO.EQ.-1) THEN
         XFA=XF
         YFA=YF-0.5*HTT
      ELSE IF (IPO.EQ.0) THEN
         XFA=XF-0.5*WTT
         YFA=YF-0.5*HTT
      ELSE IF (IPO.EQ.1) THEN
         XFA=XF-WTT
         YFA=YF-0.5*HTT
      ELSE IF (IPO.EQ.2) THEN
         XFA=XF
         YFA=YF-HTT
      ELSE IF (IPO.EQ.3) THEN
         XFA=XF-0.5*WTT
         YFA=YF-HTT
      ELSE IF (IPO.GE.4) THEN
         XFA=XF-WTT
         YFA=YF-HTT
      END IF
C
C Position each piece of output and draw it
C
      CXT = XFA + 0.5*WTT
      CYT = YFA + 0.5*HT
      CXA = CXT
      CYA = YFA + HT + HS + 0.5*HA - YAJ
      CXL = CXT
      CYL = YFA + HT + 2.0*HS + HA + 0.5*HL
C
C Save the current polyline and text colors
C
      CALL GQTXCI(IER,IOT)
      CALL GQPLCI(IER,IOC)
      CALL GQFAIS(IER,IOF)
      CALL GQFACI(IER,IOK)
      IF (IAST .EQ. 2) THEN
         CALL GSFACI(IOC)
      END IF
C
C If the vectors are colored by magnitude then find the correct color
C Set the text color too if required.
C
      IF (ABS(ICTV).EQ.1) THEN
         DO 100 K=1,NLVL,1
            IF (VMG .LE. TVLU(K) .OR. K.EQ.NLVL) THEN
               IF (IAST .EQ. 0) THEN
                  CALL GSPLCI(ICLR(K))
               ELSE IF (IAST .EQ. 1) THEN
                  IF (IACM .EQ. -1 .OR. IACM .GE. 1) THEN
                     CALL GSPLCI(ICLR(K))
                  END IF
                  IF (IACM .EQ. 0 .OR. ABS(IACM) .GE. 2) THEN
                     CALL GSFACI(ICLR(K))
                  END IF
               ELSE
                     CALL GSPLCI(ICLR(K))
                     CALL GSFACI(ICLR(K))
               END IF
C
               IF (ITC .EQ. -2) CALL GSTXCI(ICLR(K))
C
               GO TO 101
            END IF
 100     CONTINUE
C     
 101     CONTINUE
      END IF
C
C Adjust the colors depending on the text block setting
C
      IF (ITC .GE. 0) THEN
         CALL GSTXCI(ITC)
         CALL GSPLCI(ITC)
         IF (IAST.NE.0) CALL GSFACI(ITC)
      ELSE IF (ITC .LT. -2) THEN
         CALL  GSPLCI(IOT)
         IF (IAST.NE.0) CALL GSFACI(IOT)
      END IF
C
C Temporarily reset the vector positioning flag to ensure a 
C centered arrow; also set linewidth
C
      ISP=IVPO
      IVPO=0
      CALL GQLWSC(IER,ROW)
      CALL GSLWSC(WDLV)
      IF (WA .GT. 0.0) THEN
         IF (IAST .EQ. 0) THEN
            CALL VVDRAW(CXA,CYA,CXA+WA,CYA,WA,LBL,0,IDM,VVDUMB,0)
         ELSE IF (IAST .EQ. 1) THEN
            CALL VVDRFL(CXA,CYA,CXA+WA,CYA,WA,LBL,0,IDM,VVDUMB,0)
         ELSE
            CALL VVDRWB(CXA,CYA,CXA+WA,CYA,WA,LBL,0,IDM,VVDUMB,0)
         END IF
      END IF
C
C Restore linewidth and centering flag
C
      CALL GSLWSC(ROW)
      IVPO=ISP
      IF (ITC.EQ.-1) CALL GSPLCI(IOT)
C
      XW=CFUX(CXT)
      YW=CFUY(CYT)
      CALL PLCHHQ(XW,YW,CTX(IB:IE),TSZ*FW2W,0.0,0.0)
      CALL PLCHHQ(CFUX(CXL),CFUY(CYL),LBL(LB:LE),TSZ*FW2W,0.0,0.0)
C
      CALL GSTXCI(IOT)
      CALL GSPLCI(IOC)
      CALL GSFACI(IOK)
      CALL GSFAIS(IOF)
C
C Restore clipping and the set transformation.
C
      CALL GSCLIP(ICL)
      CALL SET(VPL,VPR,VPB,VPT,WDL,WDR,WDB,WDT,ILG)
C
C Done
C
      RETURN
      END
C
C --------------------------------------------------------------------
C
      SUBROUTINE VVTXLN(CTX,MXL,IB,IE)
C
      CHARACTER*(*) CTX
C
C Input parameters:
C
C CTX - the text string
C MXL - the maximum length of the text string
C
C Output parameters:
C
C IB,IE - integer position of the first and last non-blank
C         characters in the text string
C
C ------------------------------------------------------------------
C
C Given a text string, finds the first and last non-blank characters
C
      DO 10 I=1,MXL,1
         IF (CTX(I:I) .NE. ' ') GO TO 11
 10   CONTINUE
 11   CONTINUE
      IB=I
C
      DO 20 I=MXL,1,-1
         IF (CTX(I:I) .NE. ' ') GO TO 21
 20   CONTINUE
 21   CONTINUE
      IE=I
C
C Done
C
      RETURN
      END
C
C --------------------------------------------------------------------
C
      SUBROUTINE VVTXIQ(CTX,SIZ,W,H)
C
      CHARACTER*(*) CTX
C
C Find the height and width of a piece of text in fractional system.
C
C Input parameters:
C
C CTX - Text string
C SIZ - Text size in fractional coordinates
C
C Output parameters:
C
C H,W - height and width of text
C
C Local variables:
C
C VPL,VPR,VPB,VPT,WDL,WDR,WDB,WDT,ILG  - saved coordinate system state
C ITE                                  - saved text extent
C DL,DR,DB,DT                          - returned text metrics
C
C --------------------------------------------------------------------
C
C Temporarily reset the window so the window coordinates
C are guaranteed to be uniform
C
      CALL GETSET(VPL,VPR,VPB,VPT,WDL,WDR,WDB,WDT,ILG)
      CALL SET(0.0,1.0,0.0,1.0,0.0,1.0,0.0,1.0,1)
C
C Save then set the text extent inquiry PLOTCHAR parameter
C
      CALL PCGETI('TE - Text extent computation', ITE)
      CALL PCSETI('TE - Text extent computation', 1)
C
C Call PLCHHQ in inquiry mode
C
      CALL PLCHHQ(0.5,0.5,CTX,SIZ,360.0,0.0)
C
C Get the results
C
      CALL PCGETR('DL - left distance', DL)
      CALL PCGETR('DR - right distance', DR)
      CALL PCGETR('DB - bottom distance', DB)
      CALL PCGETR('DT - top distance', DT)
C
      W = DR+DL
      H = DT+DB
C
C Restore state
C
      CALL SET(VPL,VPR,VPB,VPT,WDL,WDR,WDB,WDT,ILG)
      CALL PCSETI('TE - Text extent computation', ITE)
C
C Done
C
      RETURN
      END
C
C --------------------------------------------------------------------
C
      SUBROUTINE VVTXPO(IPO,FXI,FYI,W,H,XW,YW)
C
C Given the a position mode, location, and width and height of a
C horizontally aligned text box in the fractional coordinate system 
C returns the center of the text box in window coordinates.
C Angles are not yet supported.
C
C Input parameters:
C
C IPO      - text positioning method a la CONPACK
C FXI, FYI - input position in the fractional system
C H,W      - height and width of text in the fractional system
C
C Output parameters:
C
C XW,YW  - position in window coordinates to use for a call 
C          to PLCHHQ, assuming CNTR is set to 0.0
C
C --------------------------------------------------------------------
C
C Calculate an adjusted position based on the positioning mode
C
      IF (IPO .LE. -4) THEN
         FXA=FXI+0.5*W
         FYA=FYI+0.5*H
      ELSE IF (IPO .EQ. -3) THEN
         FXA=FXI
         FYA=FYI+0.5*H
      ELSE IF (IPO .EQ. -2) THEN
         FXA=FXI-0.5*W
         FYA=FYI+0.5*H
      ELSE IF (IPO .EQ. -1) THEN
         FXA=FXI+0.5*W
         FYA=FYI
      ELSE IF (IPO .EQ. 0) THEN
         FXA=FXI
         FYA=FYI
      ELSE IF (IPO .EQ. 1) THEN
         FXA=FXI-0.5*W
         FYA=FYI
      ELSE IF (IPO .EQ. 2) THEN
         FXA=FXI+0.5*W
         FYA=FYI-0.5*H
      ELSE IF (IPO .EQ. 3) THEN
         FXA=FXI
         FYA=FYI-0.5*H
      ELSE IF (IPO .GE. 4) THEN
         FXA=FXI-0.5*W
         FYA=FYI-0.5*H
      END IF
C
      XW=CFUX(FXA)
      YW=CFUY(FYA)
C
C Done
C
      RETURN
      END
C
      SUBROUTINE VVDUMB()
      RETURN
      END

      REAL FUNCTION WMCMAX(N,X)
      DIMENSION X(N)
C
C  Calculates the maximum absolute value of an array.
C
      AMS = ABS(X(1))
      DO 10 I=2,N
        AMS = MAX(AMS,ABS(X(I)))
   10 CONTINUE
C
      WMCMAX = AMS
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C
      SUBROUTINE ROWINA3( P, KO, KI, PW, KCODE, PMSVAL, KRET,
     X                    OMISNG, OPERIO, OVEGGY)
C
C---->
C**** ROWINA3 - Interpolation of row of values.
C
C     Purpose.
C     --------
C
C     Interpolate a row of values.
C
C
C**   Interface.
C     ----------
C
C     CALL ROWINA3( P, KO, KI, PW, KCODE, PMSVAL, KRET, OMISNG, OPERIO)
C
C
C     Input Parameters.
C     -----------------
C
C     P      - Row of values to be interpolated.
C              Dimension must be at least KO.
C
C     KO     - Number of values required.
C
C     KI     - Number of values in P on input.
C
C     PW     - Working array.
C              Dimension must be at least (0:KO+2,3).
C
C     KCODE  - Interpolation required.
C              1 , linear.
C              3 , cubic.
C
C     PMSVAL - Value used for missing data indicator.
C
C     OMISNG - True if missing values are present in field.
C
C     OPERIO - True if input field is periodic.
C
C     OVEGGY     - True if 'nearest neighbour' processing must be used
C                  for interpolation
C
C     Output Parameters.
C     ------------------
C
C     P     - Now contains KO values.
C     KRET  - Return code
C             0, OK
C             Non-zero, error
C
C
C     Method.
C     -------
C
C     Linear or cubic interpolation performed as required.
C
C
C     Externals.
C     ----------
C
C     SCM0
C
C
C     Reference.
C     ----------
C
C     None.
C
C
C     Comments.
C     ---------
C
C     This is a version of ROWINA which allows for missing data
C     values and hence for bitmapped fields.
C
C
C     Author.
C     -------
C
C     J.D.Chambers    ECMWF     22.07.94
C
C
C     Modifications.
C     --------------
C
C     J.D.Chambers    ECMWF     13.09.94
C     Add return code KRET and remove calls to ABORT.
C
C     J. Clochard, Meteo France, for ECMWF - January 1998.
C     Addition of OMISNG and OPERIO arguments.
C
C
C     -----------------------------------------------------------------
C----<
C
C*******************************************************************
C     Section 0.  Declarations.
C*******************************************************************
C
      IMPLICIT NONE
C
C#include "grprs.h"
C
C     Subroutine arguments
      REAL P, PW, PMSVAL
      INTEGER KO,KI,KCODE, KRET
      DIMENSION P(KO),PW(0:KO+2,3)
C
C     Local variables
      INTEGER JL, IP
      REAL ZRDI, ZDO, ZPOS, ZWT, ZWT1
C
      LOGICAL OMISNG, OPERIO, OVEGGY
C
C*******************************************************************
C     Section 1.  Linear interpolation ..
C*******************************************************************
C
  100 CONTINUE
C
      KRET = 0
C
      IF( KCODE.EQ.1 ) THEN
C
C        Move input values to work array
         DO 110 JL = 1, KI
            PW(JL,1) = P(JL)
  110    CONTINUE
C
         IF (OPERIO) THEN
C
C        Arrange wrap-around value in work array
           PW(KI+1,1) = P(1)
C
C          Set up constants to be used to figure out weighting for
C          values in interpolation.
           ZRDI = REAL(KI)
           ZDO  = 1.0 / REAL(KO)
         ELSE
C
C        Repeat last value, to cope with "implicit truncation" below
           PW(KI+1,1) = P(KI)
C
C          Set up constants to be used to figure out weighting for
C          values in interpolation.
           ZRDI = REAL(KI-1)
           ZDO  = 1.0 / REAL(KO-1)
         ENDIF
C
C        Loop through the output points
         IF ( .NOT. OMISNG ) THEN
C
            DO 120 JL = 1, KO
C
C           Calculate weight from the start of row
            ZPOS = (JL-1) * ZDO
            ZWT  = ZPOS * ZRDI
C
C           Get the current array position(minus 1) from the weight -
C           note the implicit truncation.
            IP   = ZWT
C
C           Adjust the weight to range (0.0 to 1.0)
            ZWT  = ZWT - IP
C
C           If 'nearest neighbour' processing must be used
C
            IF( OVEGGY ) THEN
C
              IF( ZWT.LT.0.5 ) THEN
                P(JL) = PW(IP+1,1)
              ELSE
                P(JL) = PW(IP+2,1)
              ENDIF
            ELSE
C
C             Interpolate using the weighted values on either side
C             of the output point position
              P(JL) = (1.0-ZWT) * PW(IP+1,1) + ZWT * PW(IP+2,1)
C
            ENDIF
C
  120       CONTINUE
C
         ELSE
C
         DO 130 JL = 1, KO
C
C           Calculate weight from the start of row
            ZPOS = (JL-1) * ZDO
            ZWT  = ZPOS * ZRDI
C
C           If 'nearest neighbour' processing must be used
C
            IF( OVEGGY ) THEN
C
              IF( ZWT.LT.0.5 ) THEN
                P(JL) = PW(IP+1,1)
              ELSE
                P(JL) = PW(IP+2,1)
              ENDIF
            ELSE
C
C             Get the current array position(minus 1) from the weight -
C             note the implicit truncation.
              IP   = ZWT
C
C             If the left value is missing, use the right value
              IF ( PW(IP+1,1) .EQ. PMSVAL ) THEN
                 P(JL) = PW(IP+2,1)
C
C             If the right value is missing, use the left value
              ELSE IF ( PW(IP+2,1) .EQ. PMSVAL ) THEN
                 P(JL) = PW(IP+1,1)
C
C             If neither missing, interpolate ...
              ELSE
C
C               Adjust the weight to range (0.0 to 1.0)
                ZWT  = ZWT - IP
C
C               Interpolate using the weighted values on either side
C               of the output point position
                P(JL) = (1.0-ZWT) * PW(IP+1,1) + ZWT * PW(IP+2,1)
              ENDIF
C
            ENDIF
C
  130    CONTINUE
C
       ENDIF
C
C*******************************************************************
C     Section 2.  Cubic interpolation ..
C*******************************************************************
C
  200 CONTINUE
C
      ELSEIF(KCODE.EQ.3) THEN
C
         IF ( OMISNG ) THEN
C            WRITE(GRPRSM,*)
            WRITE(*,*)
     X        'ROWINA3: Cubic interpolation not supported'
C            WRITE(GRPRSM,*)
            WRITE(*,*)
     X        'ROWINA3: for fields containing missing data.'
C            WRITE(GRPRSM,*) ' Sorry!'
            WRITE(*,*)
            KRET = 1
            GOTO 900
         ENDIF
C
         DO 210 JL = 1,KI
            IF ( P(JL) .EQ. PMSVAL ) THEN
C              WRITE(GRPRSM,*) 
              WRITE(*,*)
     X          'ROWINA3: Cubic interpolation not supported'
C              WRITE(GRPRSM,*) 
              WRITE(*,*)
     X          'ROWINA3: for fields containing missing data.'
C              WRITE(GRPRSM,*) ' Sorry!'
              WRITE(*,*) ' Sorry!'
              KRET = 1
              GOTO 900
            ENDIF
            PW(JL,1) = P(JL)
  210    CONTINUE
         PW(0,1) = P(KI)
         PW(KI+1,1) = P(1)
         PW(KI+2,1) = P(2)
         DO 220 JL = 1,KI
            PW(JL,2) =  - PW(JL-1,1)/3.0 - 0.5*PW(JL,1)
     1             + PW(JL+1,1)    - PW(JL+2,1)/6.0
            PW(JL+1,3) =    PW(JL-1,1)/6.0 - PW(JL,1)
     1             + 0.5*PW(JL+1,1) + PW(JL+2,1)/3.0
  220    CONTINUE
         CALL SCM0(PW(1,2),PW(2,3),PW(1,1),PW(2,1),KI)
         ZRDI = REAL(KI)
         ZDO = 1.0/REAL(KO)
         DO 230 JL = 1,KO
            ZPOS = (JL-1)*ZDO
            ZWT = ZPOS*ZRDI
            IP = ZWT+1
            ZWT = ZWT+1.0-IP
            ZWT1  =  1.0 - ZWT
            P(JL) = ((3.0-2.0*ZWT1)*PW(IP,1) + ZWT*PW(IP,2))*ZWT1*ZWT1
     1       + ((3.0-2.0*ZWT) *PW(IP+1,1) - ZWT1*PW(IP+1,3))*ZWT*ZWT
  230    CONTINUE
C
      ELSE
C
C*******************************************************************
C     Section 3.  Invalid interpolation code ..
C*******************************************************************
C
  300   CONTINUE
C
C        WRITE(GRPRSM,9001) KCODE
        WRITE(*,9001) KCODE
        KRET = 2
      ENDIF
C
C*******************************************************************
C     Section 9.  Closedown.
C*******************************************************************
C
900   CONTINUE
      RETURN
C
 9001 FORMAT (1H ,'ROWINA3 : Invalid interpolation code = ',I4)
C
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C   FFTPACK 5.0
C   Copyright (C) 1995-2004, Scientific Computing Division,
C   University Corporation for Atmospheric Research
C   Licensed under the GNU General Public License (GPL)
C
C   Authors:  Paul N. Swarztrauber and Richard A. Valent
C
C   $Id: cmf3kf.f,v 1.2 2006-11-21 01:10:16 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      SUBROUTINE DCMF3KF(LOT,IDO,L1,NA,CC,IM1,IN1,CH,IM2,IN2,WA)
      DOUBLE PRECISION TAUR
      DOUBLE PRECISION TAUI
      DOUBLE PRECISION SN
      DOUBLE PRECISION TR2
      DOUBLE PRECISION CR2
      DOUBLE PRECISION TI2
      DOUBLE PRECISION CI2
      DOUBLE PRECISION CR3
      DOUBLE PRECISION CI3
      DOUBLE PRECISION DR2
      DOUBLE PRECISION DR3
      DOUBLE PRECISION DI2
      DOUBLE PRECISION DI3
      DOUBLE PRECISION CC(2,IN1,L1,IDO,3),CH(2,IN2,L1,3,IDO),WA(IDO,2,2)
      DATA TAUR,TAUI/-.5D0,-.866025403784439D0/
C
      M1D = (LOT-1)*IM1 + 1
      M2S = 1 - IM2
      IF (IDO.GT.1) GO TO 102
      SN = 1.D0/DBLE(3*L1)
      IF (NA.EQ.1) GO TO 106
      DO 101 K = 1,L1
          DO 101 M1 = 1,M1D,IM1
              TR2 = CC(1,M1,K,1,2) + CC(1,M1,K,1,3)
              CR2 = CC(1,M1,K,1,1) + TAUR*TR2
              CC(1,M1,K,1,1) = SN* (CC(1,M1,K,1,1)+TR2)
              TI2 = CC(2,M1,K,1,2) + CC(2,M1,K,1,3)
              CI2 = CC(2,M1,K,1,1) + TAUR*TI2
              CC(2,M1,K,1,1) = SN* (CC(2,M1,K,1,1)+TI2)
              CR3 = TAUI* (CC(1,M1,K,1,2)-CC(1,M1,K,1,3))
              CI3 = TAUI* (CC(2,M1,K,1,2)-CC(2,M1,K,1,3))
              CC(1,M1,K,1,2) = SN* (CR2-CI3)
              CC(1,M1,K,1,3) = SN* (CR2+CI3)
              CC(2,M1,K,1,2) = SN* (CI2+CR3)
              CC(2,M1,K,1,3) = SN* (CI2-CR3)
  101 CONTINUE
      RETURN
  106 DO 107 K = 1,L1
          M2 = M2S
          DO 107 M1 = 1,M1D,IM1
              M2 = M2 + IM2
              TR2 = CC(1,M1,K,1,2) + CC(1,M1,K,1,3)
              CR2 = CC(1,M1,K,1,1) + TAUR*TR2
              CH(1,M2,K,1,1) = SN* (CC(1,M1,K,1,1)+TR2)
              TI2 = CC(2,M1,K,1,2) + CC(2,M1,K,1,3)
              CI2 = CC(2,M1,K,1,1) + TAUR*TI2
              CH(2,M2,K,1,1) = SN* (CC(2,M1,K,1,1)+TI2)
              CR3 = TAUI* (CC(1,M1,K,1,2)-CC(1,M1,K,1,3))
              CI3 = TAUI* (CC(2,M1,K,1,2)-CC(2,M1,K,1,3))
              CH(1,M2,K,2,1) = SN* (CR2-CI3)
              CH(1,M2,K,3,1) = SN* (CR2+CI3)
              CH(2,M2,K,2,1) = SN* (CI2+CR3)
              CH(2,M2,K,3,1) = SN* (CI2-CR3)
  107 CONTINUE
      RETURN
  102 DO 103 K = 1,L1
          M2 = M2S
          DO 103 M1 = 1,M1D,IM1
              M2 = M2 + IM2
              TR2 = CC(1,M1,K,1,2) + CC(1,M1,K,1,3)
              CR2 = CC(1,M1,K,1,1) + TAUR*TR2
              CH(1,M2,K,1,1) = CC(1,M1,K,1,1) + TR2
              TI2 = CC(2,M1,K,1,2) + CC(2,M1,K,1,3)
              CI2 = CC(2,M1,K,1,1) + TAUR*TI2
              CH(2,M2,K,1,1) = CC(2,M1,K,1,1) + TI2
              CR3 = TAUI* (CC(1,M1,K,1,2)-CC(1,M1,K,1,3))
              CI3 = TAUI* (CC(2,M1,K,1,2)-CC(2,M1,K,1,3))
              CH(1,M2,K,2,1) = CR2 - CI3
              CH(1,M2,K,3,1) = CR2 + CI3
              CH(2,M2,K,2,1) = CI2 + CR3
              CH(2,M2,K,3,1) = CI2 - CR3
  103 CONTINUE
      DO 105 I = 2,IDO
          DO 104 K = 1,L1
              M2 = M2S
              DO 104 M1 = 1,M1D,IM1
                  M2 = M2 + IM2
                  TR2 = CC(1,M1,K,I,2) + CC(1,M1,K,I,3)
                  CR2 = CC(1,M1,K,I,1) + TAUR*TR2
                  CH(1,M2,K,1,I) = CC(1,M1,K,I,1) + TR2
                  TI2 = CC(2,M1,K,I,2) + CC(2,M1,K,I,3)
                  CI2 = CC(2,M1,K,I,1) + TAUR*TI2
                  CH(2,M2,K,1,I) = CC(2,M1,K,I,1) + TI2
                  CR3 = TAUI* (CC(1,M1,K,I,2)-CC(1,M1,K,I,3))
                  CI3 = TAUI* (CC(2,M1,K,I,2)-CC(2,M1,K,I,3))
                  DR2 = CR2 - CI3
                  DR3 = CR2 + CI3
                  DI2 = CI2 + CR3
                  DI3 = CI2 - CR3
                  CH(2,M2,K,2,I) = WA(I,1,1)*DI2 - WA(I,1,2)*DR2
                  CH(1,M2,K,2,I) = WA(I,1,1)*DR2 + WA(I,1,2)*DI2
                  CH(2,M2,K,3,I) = WA(I,2,1)*DI3 - WA(I,2,2)*DR3
                  CH(1,M2,K,3,I) = WA(I,2,1)*DR3 + WA(I,2,2)*DI3
  104     CONTINUE
  105 CONTINUE
      RETURN
      END

C
C	$Id: mssrf1.f,v 1.5 2008-07-27 00:17:31 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MSSRF1 (M,N,X,Y,Z,IZ,ZX1,ZXM,ZY1,ZYN,ZXY11,
     *                  ZXYM1,ZXY1N,ZXYMN,ISLPSW,ZP,TEMP,
     *                  SIGMA,IERR)
C
      INTEGER M,N,IZ,ISLPSW,IERR
      REAL X(M),Y(N),Z(IZ,N),ZX1(N),ZXM(N),ZY1(M),ZYN(M),
     *     ZXY11,ZXYM1,ZXY1N,ZXYMN,ZP(M,N,3),TEMP(1),SIGMA
C
C ---------------------------------------------------------------------
C Note:  This routine comes from a proprietary package called FITPACK.
C It is used in the NCAR graphics package by permission of the author,
C Alan Cline.
C ---------------------------------------------------------------------
C
C                                            CODED BY ALAN KAYLOR CLINE
C                                         FROM FITPACK -- JUNE 22, 1986
C                                   A CURVE AND SURFACE FITTING PACKAGE
C                                 A PRODUCT OF PLEASANT VALLEY SOFTWARE
C                             8603 ALTUS COVE, AUSTIN, TEXAS 78759, USA
C
C ---------------------------------------------------------------------
C
C THIS SUBROUTINE DETERMINES THE PARAMETERS NECESSARY TO
C COMPUTE AN INTERPOLATORY SURFACE PASSING THROUGH A RECT-
C ANGULAR GRID OF FUNCTIONAL VALUES. THE SURFACE DETERMINED
C CAN BE REPRESENTED AS THE TENSOR PRODUCT OF SPLINES UNDER
C TENSION. THE X- AND Y-PARTIAL DERIVATIVES AROUND THE
C BOUNDARY AND THE X-Y-PARTIAL DERIVATIVES AT THE FOUR
C CORNERS MAY BE SPECIFIED OR OMITTED. FOR ACTUAL MAPPING
C OF POINTS ONTO THE SURFACE IT IS NECESSARY TO CALL THE
C FUNCTION MSSRF2.
C
C ON INPUT--
C
C   M IS THE NUMBER OF GRID LINES IN THE X-DIRECTION, I. E.
C   LINES PARALLEL TO THE Y-AXIS (M .GE. 2).
C
C   N IS THE NUMBER OF GRID LINES IN THE Y-DIRECTION, I. E.
C   LINES PARALLEL TO THE X-AXIS (N .GE. 2).
C
C   X IS AN ARRAY OF THE M X-COORDINATES OF THE GRID LINES
C   IN THE X-DIRECTION. THESE SHOULD BE STRICTLY INCREASING.
C
C   Y IS AN ARRAY OF THE N Y-COORDINATES OF THE GRID LINES
C   IN THE Y-DIRECTION. THESE SHOULD BE STRICTLY INCREASING.
C
C   Z IS AN ARRAY OF THE M * N FUNCTIONAL VALUES AT THE GRID
C   POINTS, I. E. Z(I,J) CONTAINS THE FUNCTIONAL VALUE AT
C   (X(I),Y(J)) FOR I = 1,...,M AND J = 1,...,N.
C
C   IZ IS THE ROW DIMENSION OF THE MATRIX Z USED IN THE
C   CALLING PROGRAM (IZ .GE. M).
C
C   ZX1 AND ZXM ARE ARRAYS OF THE M X-PARTIAL DERIVATIVES
C   OF THE FUNCTION ALONG THE X(1) AND X(M) GRID LINES,
C   RESPECTIVELY. THUS ZX1(J) AND ZXM(J) CONTAIN THE X-PART-
C   IAL DERIVATIVES AT THE POINTS (X(1),Y(J)) AND
C   (X(M),Y(J)), RESPECTIVELY, FOR J = 1,...,N. EITHER OF
C   THESE PARAMETERS WILL BE IGNORED (AND APPROXIMATIONS
C   SUPPLIED INTERNALLY) IF ISLPSW SO INDICATES.
C
C   ZY1 AND ZYN ARE ARRAYS OF THE N Y-PARTIAL DERIVATIVES
C   OF THE FUNCTION ALONG THE Y(1) AND Y(N) GRID LINES,
C   RESPECTIVELY. THUS ZY1(I) AND ZYN(I) CONTAIN THE Y-PART-
C   IAL DERIVATIVES AT THE POINTS (X(I),Y(1)) AND
C   (X(I),Y(N)), RESPECTIVELY, FOR I = 1,...,M. EITHER OF
C   THESE PARAMETERS WILL BE IGNORED (AND ESTIMATIONS
C   SUPPLIED INTERNALLY) IF ISLPSW SO INDICATES.
C
C   ZXY11, ZXYM1, ZXY1N, AND ZXYMN ARE THE X-Y-PARTIAL
C   DERIVATIVES OF THE FUNCTION AT THE FOUR CORNERS,
C   (X(1),Y(1)), (X(M),Y(1)), (X(1),Y(N)), AND (X(M),Y(N)),
C   RESPECTIVELY. ANY OF THE PARAMETERS WILL BE IGNORED (AND
C   ESTIMATIONS SUPPLIED INTERNALLY) IF ISLPSW SO INDICATES.
C
C   ISLPSW CONTAINS A SWITCH INDICATING WHICH BOUNDARY
C   DERIVATIVE INFORMATION IS USER-SUPPLIED AND WHICH
C   SHOULD BE ESTIMATED BY THIS SUBROUTINE. TO DETERMINE
C   ISLPSW, LET
C        I1 = 0 IF ZX1 IS USER-SUPPLIED (AND = 1 OTHERWISE),
C        I2 = 0 IF ZXM IS USER-SUPPLIED (AND = 1 OTHERWISE),
C        I3 = 0 IF ZY1 IS USER-SUPPLIED (AND = 1 OTHERWISE),
C        I4 = 0 IF ZYN IS USER-SUPPLIED (AND = 1 OTHERWISE),
C        I5 = 0 IF ZXY11 IS USER-SUPPLIED
C                                       (AND = 1 OTHERWISE),
C        I6 = 0 IF ZXYM1 IS USER-SUPPLIED
C                                       (AND = 1 OTHERWISE),
C        I7 = 0 IF ZXY1N IS USER-SUPPLIED
C                                       (AND = 1 OTHERWISE),
C        I8 = 0 IF ZXYMN IS USER-SUPPLIED
C                                       (AND = 1 OTHERWISE),
C   THEN ISLPSW = I1 + 2*I2 + 4*I3 + 8*I4 + 16*I5 + 32*I6
C                   + 64*I7 + 128*I8
C   THUS ISLPSW = 0 INDICATES ALL DERIVATIVE INFORMATION IS
C   USER-SUPPLIED AND ISLPSW = 255 INDICATES NO DERIVATIVE
C   INFORMATION IS USER-SUPPLIED. ANY VALUE BETWEEN THESE
C   LIMITS IS VALID.
C
C   ZP IS AN ARRAY OF AT LEAST 3*M*N LOCATIONS.
C
C   TEMP IS AN ARRAY OF AT LEAST N+N+M LOCATIONS WHICH IS
C   USED FOR SCRATCH STORAGE.
C
C AND
C
C   SIGMA CONTAINS THE TENSION FACTOR. THIS VALUE INDICATES
C   THE CURVINESS DESIRED. IF ABS(SIGMA) IS NEARLY ZERO
C   (E. G. .001) THE RESULTING SURFACE IS APPROXIMATELY THE
C   TENSOR PRODUCT OF CUBIC SPLINES. IF ABS(SIGMA) IS LARGE
C   (E. G. 50.) THE RESULTING SURFACE IS APPROXIMATELY
C   BI-LINEAR. IF SIGMA EQUALS ZERO TENSOR PRODUCTS OF
C   CUBIC SPLINES RESULT. A STANDARD VALUE FOR SIGMA IS
C   APPROXIMATELY 1. IN ABSOLUTE VALUE.
C
C ON OUTPUT--
C
C   ZP CONTAINS THE VALUES OF THE XX-, YY-, AND XXYY-PARTIAL
C   DERIVATIVES OF THE SURFACE AT THE GIVEN NODES.
C
C   IERR CONTAINS AN ERROR FLAG,
C        = 0 FOR NORMAL RETURN,
C        = 1 IF N IS LESS THAN 2 OR M IS LESS THAN 2,
C        = 2 IF THE X-VALUES OR Y-VALUES ARE NOT STRICTLY
C            INCREASING.
C
C AND
C
C   M, N, X, Y, Z, IZ, ZX1, ZXM, ZY1, ZYN, ZXY11, ZXYM1,
C   ZXY1N, ZXYMN, ISLPSW, AND SIGMA ARE UNALTERED.
C
C THIS SUBROUTINE REFERENCES PACKAGE MODULES MSCEEZ, MSTRMS,
C AND MSSHCH.
C
C-----------------------------------------------------------
C
      MM1 = M-1
      MP1 = M+1
      NM1 = N-1
      NP1 = N+1
      NPM = N+M
      IERR = 0
      IF (N .LE. 1 .OR. M .LE. 1) GO TO 46
      IF (Y(N) .LE. Y(1)) GO TO 47
C
C DENORMALIZE TENSION FACTOR IN Y-DIRECTION
C
      SIGMAY = ABS(SIGMA)*REAL(N-1)/(Y(N)-Y(1))
C
C OBTAIN Y-PARTIAL DERIVATIVES ALONG Y = Y(1)
C
      IF ((ISLPSW/8)*2 .NE. (ISLPSW/4)) GO TO 2
      DO 1 I = 1,M
    1   ZP(I,1,1) = ZY1(I)
      GO TO 5
    2 DELY1 = Y(2)-Y(1)
      DELY2 = DELY1+DELY1
      IF (N .GT. 2) DELY2 = Y(3)-Y(1)
      IF (DELY1 .LE. 0. .OR. DELY2 .LE. DELY1) GO TO 47
      CALL MSCEEZ (DELY1,DELY2,SIGMAY,C1,C2,C3,N)
      DO 3 I = 1,M
    3   ZP(I,1,1) = C1*Z(I,1)+C2*Z(I,2)
      IF (N .EQ. 2) GO TO 5
      DO 4 I = 1,M
    4   ZP(I,1,1) = ZP(I,1,1)+C3*Z(I,3)
C
C OBTAIN Y-PARTIAL DERIVATIVES ALONG Y = Y(N)
C
    5 IF ((ISLPSW/16)*2 .NE. (ISLPSW/8)) GO TO 7
      DO 6 I = 1,M
        NPI = N+I
    6   TEMP(NPI) = ZYN(I)
      GO TO 10
    7 DELYN = Y(N)-Y(NM1)
      DELYNM = DELYN+DELYN
      IF (N .GT. 2) DELYNM = Y(N)-Y(N-2)
      IF (DELYN .LE. 0. .OR. DELYNM .LE. DELYN) GO TO 47
      CALL MSCEEZ (-DELYN,-DELYNM,SIGMAY,C1,C2,C3,N)
      DO 8 I = 1,M
        NPI = N+I
    8   TEMP(NPI) = C1*Z(I,N)+C2*Z(I,NM1)
      IF (N .EQ. 2) GO TO 10
      DO 9 I = 1,M
        NPI = N+I
    9   TEMP(NPI) = TEMP(NPI)+C3*Z(I,N-2)
   10 IF (X(M) .LE. X(1)) GO TO 47
C
C DENORMALIZE TENSION FACTOR IN X-DIRECTION
C
      SIGMAX = ABS(SIGMA)*REAL(M-1)/(X(M)-X(1))
C
C OBTAIN X-PARTIAL DERIVATIVES ALONG X = X(1)
C
      IF ((ISLPSW/2)*2 .NE. ISLPSW) GO TO 12
      DO 11 J = 1,N
   11   ZP(1,J,2) = ZX1(J)
      IF ((ISLPSW/32)*2 .EQ. (ISLPSW/16) .AND.
     *    (ISLPSW/128)*2  .EQ. (ISLPSW/64)) GO TO 15
   12 DELX1 = X(2)-X(1)
      DELX2 = DELX1+DELX1
      IF (M .GT. 2) DELX2 = X(3)-X(1)
      IF (DELX1 .LE. 0. .OR. DELX2 .LE. DELX1) GO TO 47
      CALL MSCEEZ (DELX1,DELX2,SIGMAX,C1,C2,C3,M)
      IF ((ISLPSW/2)*2 .EQ. ISLPSW) GO TO 15
      DO 13 J = 1,N
   13   ZP(1,J,2) = C1*Z(1,J)+C2*Z(2,J)
      IF (M .EQ. 2) GO TO 15
      DO 14 J = 1,N
   14   ZP(1,J,2) = ZP(1,J,2)+C3*Z(3,J)
C
C OBTAIN X-Y-PARTIAL DERIVATIVE AT (X(1),Y(1))
C
   15 IF ((ISLPSW/32)*2 .NE. (ISLPSW/16)) GO TO 16
      ZP(1,1,3) = ZXY11
      GO TO 17
   16 ZP(1,1,3) = C1*ZP(1,1,1)+C2*ZP(2,1,1)
      IF (M .GT. 2) ZP(1,1,3) = ZP(1,1,3)+C3*ZP(3,1,1)
C
C OBTAIN X-Y-PARTIAL DERIVATIVE AT (X(1),Y(N))
C
   17 IF ((ISLPSW/128)*2 .NE. (ISLPSW/64)) GO TO 18
      ZXY1NS = ZXY1N
      GO TO 19
   18 ZXY1NS = C1*TEMP(N+1)+C2*TEMP(N+2)
      IF (M .GT. 2) ZXY1NS = ZXY1NS+C3*TEMP(N+3)
C
C OBTAIN X-PARTIAL DERIVATIVE ALONG X = X(M)
C
   19 IF ((ISLPSW/4)*2 .NE. (ISLPSW/2)) GO TO 21
      DO 20 J = 1,N
        NPMPJ = NPM+J
   20   TEMP(NPMPJ) = ZXM(J)
      IF ((ISLPSW/64)*2 .EQ. (ISLPSW/32) .AND.
     *    (ISLPSW/256)*2 .EQ. (ISLPSW/128)) GO TO 24
   21 DELXM = X(M)-X(MM1)
      DELXMM = DELXM+DELXM
      IF (M .GT. 2) DELXMM = X(M)-X(M-2)
      IF (DELXM .LE. 0. .OR. DELXMM .LE. DELXM) GO TO 47
      CALL MSCEEZ (-DELXM,-DELXMM,SIGMAX,C1,C2,C3,M)
      IF ((ISLPSW/4)*2 .EQ. (ISLPSW/2)) GO TO 24
      DO 22 J = 1,N
        NPMPJ = NPM+J
   22   TEMP(NPMPJ) = C1*Z(M,J)+C2*Z(MM1,J)
      IF (M .EQ. 2) GO TO 24
      DO 23 J = 1,N
        NPMPJ = NPM+J
   23   TEMP(NPMPJ) = TEMP(NPMPJ)+C3*Z(M-2,J)
C
C OBTAIN X-Y-PARTIAL DERIVATIVE AT (X(M),Y(1))
C
   24 IF ((ISLPSW/64)*2 .NE. (ISLPSW/32)) GO TO 25
      ZP(M,1,3) = ZXYM1
      GO TO 26
   25 ZP(M,1,3) = C1*ZP(M,1,1)+C2*ZP(MM1,1,1)
      IF (M .GT. 2) ZP(M,1,3) = ZP(M,1,3)+C3*ZP(M-2,1,1)
C
C OBTAIN X-Y-PARTIAL DERIVATIVE AT (X(M),Y(N))
C
   26 IF ((ISLPSW/256)*2 .NE. (ISLPSW/128)) GO TO 27
      ZXYMNS = ZXYMN
      GO TO 28
   27 ZXYMNS = C1*TEMP(NPM)+C2*TEMP(NPM-1)
      IF (M .GT. 2) ZXYMNS = ZXYMNS+C3*TEMP(NPM-2)
C
C SET UP RIGHT HAND SIDES AND TRIDIAGONAL SYSTEM FOR Y-GRID
C PERFORM FORWARD ELIMINATION
C
   28 DEL1 = Y(2)-Y(1)
      IF (DEL1 .LE. 0.) GO TO 47
      DELI = 1./DEL1
      DO 29 I = 1,M
   29   ZP(I,2,1) = DELI*(Z(I,2)-Z(I,1))
      ZP(1,2,3) = DELI*(ZP(1,2,2)-ZP(1,1,2))
      ZP(M,2,3) = DELI*(TEMP(NPM+2)-TEMP(NPM+1))
      CALL MSTRMS (DIAG1,SDIAG1,SIGMAY,DEL1)
      DIAGI = 1./DIAG1
      DO 30 I = 1,M
   30   ZP(I,1,1) = DIAGI*(ZP(I,2,1)-ZP(I,1,1))
      ZP(1,1,3) = DIAGI*(ZP(1,2,3)-ZP(1,1,3))
      ZP(M,1,3) = DIAGI*(ZP(M,2,3)-ZP(M,1,3))
      TEMP(1) = DIAGI*SDIAG1
      IF (N .EQ. 2) GO TO 34
      DO 33 J = 2,NM1
        JM1 = J-1
        JP1 = J+1
        NPMPJ = NPM+J
        DEL2 = Y(JP1)-Y(J)
        IF (DEL2 .LE. 0.) GO TO 47
        DELI = 1./DEL2
        DO 31 I = 1,M
   31     ZP(I,JP1,1) = DELI*(Z(I,JP1)-Z(I,J))
        ZP(1,JP1,3) = DELI*(ZP(1,JP1,2)-ZP(1,J,2))
        ZP(M,JP1,3) = DELI*(TEMP(NPMPJ+1)-TEMP(NPMPJ))
        CALL MSTRMS (DIAG2,SDIAG2,SIGMAY,DEL2)
        DIAGIN = 1./(DIAG1+DIAG2-SDIAG1*TEMP(JM1))
        DO 32 I = 1,M
   32     ZP(I,J,1) = DIAGIN*(ZP(I,JP1,1)-ZP(I,J,1)-
     *                        SDIAG1*ZP(I,JM1,1))
        ZP(1,J,3) = DIAGIN*(ZP(1,JP1,3)-ZP(1,J,3)-
     *                      SDIAG1*ZP(1,JM1,3))
        ZP(M,J,3) = DIAGIN*(ZP(M,JP1,3)-ZP(M,J,3)-
     *                      SDIAG1*ZP(M,JM1,3))
        TEMP(J) = DIAGIN*SDIAG2
        DIAG1 = DIAG2
   33   SDIAG1 = SDIAG2
   34 DIAGIN = 1./(DIAG1-SDIAG1*TEMP(NM1))
      DO 35 I = 1,M
        NPI = N+I
   35   ZP(I,N,1) = DIAGIN*(TEMP(NPI)-ZP(I,N,1)-
     *                      SDIAG1*ZP(I,NM1,1))
      ZP(1,N,3) = DIAGIN*(ZXY1NS-ZP(1,N,3)-
     *                    SDIAG1*ZP(1,NM1,3))
      TEMP(N) = DIAGIN*(ZXYMNS-ZP(M,N,3)-
     *                  SDIAG1*ZP(M,NM1,3))
C
C PERFORM BACK SUBSTITUTION
C
      DO 37 J = 2,N
        JBAK = NP1-J
        JBAKP1 = JBAK+1
        T = TEMP(JBAK)
        DO 36 I = 1,M
   36     ZP(I,JBAK,1) = ZP(I,JBAK,1)-T*ZP(I,JBAKP1,1)
        ZP(1,JBAK,3) = ZP(1,JBAK,3)-T*ZP(1,JBAKP1,3)
   37   TEMP(JBAK) = ZP(M,JBAK,3)-T*TEMP(JBAKP1)
C
C SET UP RIGHT HAND SIDES AND TRIDIAGONAL SYSTEM FOR X-GRID
C PERFORM FORWARD ELIMINATION
C
      DEL1 = X(2)-X(1)
      IF (DEL1 .LE. 0.) GO TO 47
      DELI = 1./DEL1
      DO 38 J = 1,N
        ZP(2,J,2) = DELI*(Z(2,J)-Z(1,J))
   38   ZP(2,J,3) = DELI*(ZP(2,J,1)-ZP(1,J,1))
      CALL MSTRMS (DIAG1,SDIAG1,SIGMAX,DEL1)
      DIAGI = 1./DIAG1
      DO 39 J = 1,N
        ZP(1,J,2) = DIAGI*(ZP(2,J,2)-ZP(1,J,2))
   39   ZP(1,J,3) = DIAGI*(ZP(2,J,3)-ZP(1,J,3))
      TEMP(N+1) = DIAGI*SDIAG1
      IF (M  .EQ. 2) GO TO 43
      DO 42 I = 2,MM1
        IM1 = I-1
        IP1 = I+1
        NPI = N+I
        DEL2 = X(IP1)-X(I)
        IF (DEL2 .LE. 0.) GO TO 47
        DELI = 1./DEL2
        DO 40 J = 1,N
          ZP(IP1,J,2) = DELI*(Z(IP1,J)-Z(I,J))
   40     ZP(IP1,J,3) = DELI*(ZP(IP1,J,1)-ZP(I,J,1))
        CALL MSTRMS (DIAG2,SDIAG2,SIGMAX,DEL2)
        DIAGIN = 1./(DIAG1+DIAG2-SDIAG1*TEMP(NPI-1))
        DO 41 J = 1,N
          ZP(I,J,2) = DIAGIN*(ZP(IP1,J,2)-ZP(I,J,2)-
     *                        SDIAG1*ZP(IM1,J,2))
   41     ZP(I,J,3) = DIAGIN*(ZP(IP1,J,3)-ZP(I,J,3)-
     *                        SDIAG1*ZP(IM1,J,3))
        TEMP(NPI) = DIAGIN*SDIAG2
        DIAG1 = DIAG2
   42   SDIAG1 = SDIAG2
   43 DIAGIN = 1./(DIAG1-SDIAG1*TEMP(NPM-1))
      DO 44 J = 1,N
        NPMPJ = NPM+J
        ZP(M,J,2) = DIAGIN*(TEMP(NPMPJ)-ZP(M,J,2)-
     *                      SDIAG1*ZP(MM1,J,2))
   44   ZP(M,J,3) = DIAGIN*(TEMP(J)-ZP(M,J,3)-
     *                      SDIAG1*ZP(MM1,J,3))
C
C PERFORM BACK SUBSTITUTION
C
      DO 45 I = 2,M
        IBAK = MP1-I
        IBAKP1 = IBAK+1
        NPIBAK = N+IBAK
        T = TEMP(NPIBAK)
        DO 45 J = 1,N
          ZP(IBAK,J,2) = ZP(IBAK,J,2)-T*ZP(IBAKP1,J,2)
   45     ZP(IBAK,J,3) = ZP(IBAK,J,3)-T*ZP(IBAKP1,J,3)
      RETURN
C
C TOO FEW POINTS
C
   46 IERR = 1
      RETURN
C
C POINTS NOT STRICTLY INCREASING
C
   47 IERR = 2
      RETURN
      END

      PROGRAM FAGEZMY
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER (NPTS=200)
      PARAMETER (NCURVE=4)
      REAL YDRA(NPTS,NCURVE)

      DO 10 I=1,NPTS
      DO 10 J=1,NCURVE
            YDRA(I,J)=SIN(I*0.1+0.2*J)*EXP(-0.01*I*0.1*J**2)
  10  CONTINUE
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)

      CALL EZMY (YDRA,NPTS,NCURVE,NPTS,'EZMY$')
C
C  Deactivate and close the workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS

      STOP
      END

c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by UCAR                 .
c  .                                                             .
c  .       University Corporation for Atmospheric Research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                         SPHEREPACK                          .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c                           August 2003
c
c ... in file shpg.f
c
c     this file contains code and documentation for subroutines
c     shpgi and shpg.
c
c ... files which must be loaded with shpg.f
c
c     hrfft.f
c
c     shpgi initializes the arrays wshp and iwshp for subsequent
c     use in subroutine shpg, which performs the harmonic projection
c     which is equivalent to a harmonic analysis followed by
c     harmonic synthesis but faster and with less memory.
c     (see description of subroutine shpg below).
c
c     subroutine shpgi(nlat,nlon,isym,mtrunc,wshp,lwshp,iwshp,
c    1 liwshp,work,lwork,ierror)
c
c     shpgi initializes arrays wshp and iwshp for repeated use
c     by subroutine shpg ....
c
c     input parameters
c
c     nlat   the number of colatitudes on the full sphere including the
c            poles. for example, nlat = 37 for a five degree grid.
c            nlat determines the grid increment in colatitude as
c            pi/(nlat-1).  if nlat is odd the equator is located at
c            grid point i=(nlat+1)/2. if nlat is even the equator is
c            located half way between points i=nlat/2 and i=nlat/2+1.
c            nlat must be at least 3.
c
c     nlon   the number of distinct londitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater
c            than or equal to 4. the efficiency of the computation is
c            improved when nlon is a product of small prime numbers.
c            nlon must be at least 4.
c
c     isym   currently not used, no equatorial symmetries assumed,
c            only whole sphere computations.
c
c     mtrunc the highest longitudinal wave number retained in the
c            projection. It must be less than or equal to
c            the minimum of nlat-1 and nlon/2. The first wave
c            number is zero. For example, if wave numbers 0 and
c            1 are desired then mtrunc = 1.
c
c     lwshp  the dimension of the array wshp as it appears in the
c            program that calls shpgi. It must be at least
c            2*(nlat+1)**2+nlon+log2(nlon)
c
c     liwshp the dimension of the array iwshp as it appears in the
c            program that calls shpgi. It must be at least
c            4*(nlat+1).
c
c     lwork  the dimension of the array work as it appears in the
c            program that calls shpgi. It must be at least
c            1.25*(nlat+1)**2+7*nlat+8.
c
c     **************************************************************
c
c     output parameters
c
c     wshp   a single precision array that must be saved for
c            repeated use by subroutine shpg.
c
c     iwshp  an integer array that must be saved for repeated
c            use by subroutine shpg.
c
c     work   a double precision work array that does
c            not have to be saved.
c
c     ierror = 0  no errors
c            = 1  error in the specification of nlat
c            = 2  error in the specification of nlon
c            = 3  error in the specification of isym
c            = 4  error in the specification of mtrunc
c            = 5  error in the specification of lwshp
c            = 6  error in the specification of liwshp
c            = 7  error in the specification of lwork
c
      SUBROUTINE DSHPGI(NLAT,NLON,ISYM,MTRUNC,WSHP,LWSHP,IWSHP,LIWSHP,
     +                 WORK,LWORK,IERROR)
      DOUBLE PRECISION WSHP
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION WORK(*)
      DIMENSION WSHP(*),IWSHP(*)
c
      IERROR = 1
      IF (NLAT.LT.1) RETURN
      IERROR = 2
      IF (NLON.LT.1) RETURN
c      ierror = 3
c      if(isym.lt.0 .or. isym.gt.2) return
      IERROR = 4
      MMAX = MIN(NLAT-1,NLON/2)
      IF (MTRUNC.LT.0 .OR. MTRUNC.GT.MMAX) RETURN
      IERROR = 5
      LW1 = 2* (NLAT+1)**2
      LOG2N = LOG(DBLE(NLON))/LOG(2.0D0)
      IF (LWSHP.LT.LW1+NLON+LOG2N) RETURN
      IERROR = 6
      IF (LIWSHP.LT.4* (NLAT+1)) RETURN
      IERROR = 7
      MLWK = 1.25D0* (NLAT+1)**2 + 7*NLAT + 8
      IF (LWORK.LT.MLWK) RETURN
      IERROR = 0
c
      CALL DHRFFTI(NLON,WSHP(LW1+1))
c
      NTE = (NLAT+1)/2
      NLOC1 = 2*NTE*NTE
      NLOC2 = NLAT + 1
      IW1 = 1
      IW2 = IW1 + NLOC1
      IW3 = IW2 + NLOC1
      IW4 = IW3 + NLOC1
      JW1 = 1
      JW2 = JW1 + NLOC2
      JW3 = JW2 + NLOC2
      JW4 = JW3 + NLOC2
      KW1 = 1
      KW2 = KW1 + NTE
      KW3 = KW2 + NTE
      KW4 = KW3 + 2*NTE
      KW5 = KW4 + 2*NTE
      KW6 = KW5 + NTE
      KW7 = KW6 + NTE
      KW8 = KW7 + 4*NTE
      KW9 = KW8 + 2*NTE
      KW10 = KW9 + NLOC1
      KW11 = KW10 + NLOC1
      KTOT = KW11 + NTE*NTE
c
      CALL DSHPGI1(NLAT,NLON,ISYM,MTRUNC,NTE,IERROR,WSHP(IW1),WSHP(IW2),
     +            WSHP(IW3),WSHP(IW4),IWSHP(JW1),IWSHP(JW2),IWSHP(JW3),
     +            IWSHP(JW4),WORK(KW1),WORK(KW2),WORK(KW3),WORK(KW4),
     +            WORK(KW5),WORK(KW6),WORK(KW7),WORK(KW8),WORK(KW9),
     +            WORK(KW10),WORK(KW11))
      RETURN
      END
      SUBROUTINE DSHPGI1(NLAT,NLON,ISYM,MTRUNC,IDP,IERROR,PE,PO,ZE,ZO,
     +                  IPSE,JZSE,IPSO,JZSO,CP,WX,THET,GWTS,XX,Z,A,B,
     +                  PED,POD,U)
      DOUBLE PRECISION PE
      DOUBLE PRECISION PO
      DOUBLE PRECISION ZE
      DOUBLE PRECISION ZO
      DOUBLE PRECISION ZORT
      DOUBLE PRECISION TUSL
      DOUBLE PRECISION TOE
      DOUBLE PRECISION DFN
      DOUBLE PRECISION RAND
      DOUBLE PRECISION DMAX
      DOUBLE PRECISION SUM1
C*PT*WARNING* Already double-precision
c
      DOUBLE PRECISION SUM,EPS,A1,B1,C1,WORK
C*PT*WARNING* Constant already double-precision
      PARAMETER (EPS=5.0d-8)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION CP(IDP),WX(IDP),THET(NLAT),GWTS(NLAT),XX(IDP),
     +                 Z(IDP),A(4*IDP),B(2*IDP),PED(IDP,IDP,2),
     +                 POD(IDP,IDP,2),U(IDP,IDP)
c
      DIMENSION PE(IDP,IDP,2),PO(IDP,IDP,2),ZE(IDP,IDP,2),ZO(IDP,IDP,2),
     +          IPSE(IDP,2),JZSE(IDP,2),IPSO(IDP,2),JZSO(IDP,2),NSHE(2),
     +          NSHO(2)
      DIMENSION ZORT(64,64,2)
c
      NS2 = NLAT/2
      MODN = NLAT - NS2 - NS2
      NTE = (NLAT+1)/2
      NTO = NLAT - NTE
      TUSL = 0.D0
      TOE = 0.D0
c
c     compute gauss grid distribution
c
      LWORK = NLAT + 1
      CALL DGAQDP(NLAT,THET,GWTS,WORK,LWORK,IERR)
      IF (IERR.NE.0) WRITE (*,FMT=160) IERR
  160 FORMAT (' error in gaqd =',i5)
      DO I = 1,NTO
          GWTS(I) = GWTS(I) + GWTS(I)
      END DO
c
c     compute n**2 basis (even functions)
c
      DO N = 1,NLAT + NLAT - 2
          DFN = N
C*PT*WARNING* Constant already double-precision
          A(N) = DSQRT(DFN* (DFN+1.0d0))
      END DO
      DO N = 1,NLAT - 1
          DFN = N
C*PT*WARNING* Constant already double-precision
C*PT*WARNING* Constant already double-precision
          B(N) = DSQRT((DFN+DFN+3.0d0)/ (DFN+DFN-1.0d0))
      END DO
c
      MXTR = MIN(NLAT-1,NLON/2,MTRUNC)
      IP = 2
      DO 200 MP1 = 1,MXTR + 1
          M = MP1 - 1
          IP = 3 - IP
          MS2 = MP1/2
          NEM = (NLAT-M+1)/2
          NEC = NTE - NEM
c
c     compute associated legendre functions
c
          IF (M.LE.1) THEN
              DO 205 J = 1,NEM
                  N = J + J + M - 2
                  CALL DDLFKG(M,N,CP)
                  DO I = 1,NTE
                      CALL DDLFTG(M,N,THET(I),CP,PED(I,J+NEC,IP))
                  END DO
  205         CONTINUE
c
          ELSE
c
              DO 207 J = 1,NEM
                  N = J + J + M - 2
                  IF (M.GT.1 .AND. N.GT.MXTR) THEN
                      DO I = 1,NTE
                          U(I,J+NEC) = PED(I,J+NEC,IP)
                      END DO
                      GO TO 207
                  END IF
                  A1 = B(N-1)*A(N+M-3)/A(N+M-1)
                  B1 = A(N-M+1)/A(N+M-1)
                  IF (N-M.LE.1) THEN
                      DO I = 1,NTE
                          U(I,J+NEC) = A1*PED(I,J+NEC-1,IP) -
     +                                 B1*PED(I,J+NEC,IP)
                      END DO
                  ELSE
                      C1 = B(N-1)*A(N-M-1)/A(N+M-1)
                      DO I = 1,NTE
                          U(I,J+NEC) = A1*PED(I,J+NEC-1,IP) -
     +                                 B1*PED(I,J+NEC,IP) +
     +                                 C1*U(I,J+NEC-1)
                      END DO
                  END IF
  207         CONTINUE
              DO J = 1,NEM
                  DO I = 1,NTE
                      PED(I,J+NEC,IP) = U(I,J+NEC)
                  END DO
              END DO
          END IF
          IF (NEC.LE.0) GO TO 200
c
c     generate orthogonal vector
c
          DO I = 1,NTE
              XX(I) = RAND()
          END DO
c
          IT = 0
  201     DO I = 1,NTE
C*PT*WARNING* Constant already double-precision
              Z(I) = 0.0d0
              WX(I) = GWTS(I)*XX(I)
          END DO
          DO 220 J = 1,NTE
              IF (J.EQ.NEC) GO TO 220
              CALL DGS(NTE,WX,PED(1,J,IP),Z)
  220     CONTINUE
c
          DO I = 1,NTE
              XX(I) = XX(I) - Z(I)
          END DO
          CALL DNORMAL(NTE,XX,IDP,GWTS)
          IT = IT + 1
          IF (IT.LE.2) GO TO 201
          DO I = 1,NTE
              PED(I,NEC,IP) = XX(I)
          END DO
  200 CONTINUE
c
c     reorder if mtrunc is less than nlat-1
c         case of even functions
c
      NMX = NLAT - MXTR
      IF (MODN.EQ.1) THEN
          NSHE(1) = NMX/2
          NSHE(2) = (NMX-1)/2
      ELSE
          NSHE(1) = (NMX-1)/2
          NSHE(2) = NMX/2
      END IF
c
      DO 210 MP1 = 1,2
          DO J = 1,NTE
              JS = J + NSHE(MP1)
              IF (JS.GT.NTE) JS = JS - NTE
              DO I = 1,NTE
                  U(I,JS) = PED(I,J,MP1)
              END DO
          END DO
          DO J = 1,NTE
              DO I = 1,NTE
                  PED(I,J,MP1) = U(I,J)
              END DO
          END DO
  210 CONTINUE
c
      CALL DTRUNC(0,NTE,IDP,PED(1,1,1),NTE,IPSE(1,1))
      CALL DTRUNC(0,NTE,IDP,PED(1,1,2),NTE,IPSE(1,2))
c
c     compute the analysis matrices
c
      DO 250 IP = 1,2
          DO I = 1,NTE
              LOCK = 0
              DO J = 1,NTE
                  SUM = PED(J,I,IP)*GWTS(J)
                  ZE(J,I,IP) = SUM
                  PE(I,J,IP) = PED(I,J,IP)
                  IF (DABS(SUM).GT.EPS .AND. LOCK.EQ.0) THEN
                      LOCK = 1
                      JZSE(I,IP) = J
                  END IF
              END DO
          END DO
  250 CONTINUE
c
c     check orthogonality of pe(i,j,mp1)  mp1=1,2
c
      DO IP = 1,2
          DMAX = 0.D0
          DO I = 1,NTE
              DO J = 1,NTE
                  SUM1 = 0.D0
                  DO K = 1,NTE
                      SUM1 = SUM1 + ZE(K,I,IP)*PE(K,J,IP)
                  END DO
                  ZO(I,J,IP) = SUM1
                  IF (I.NE.J) THEN
                      DMAX = MAX(DMAX,ABS(SUM1))
                  ELSE
                      DMAX = MAX(DMAX,ABS(SUM1-1.0D0))
                  END IF
              END DO
          END DO
      END DO
c
c     compute n**2 basis (odd functions)
c
      IP = 2
      DO 300 MP1 = 1,MXTR + 1
          IP = 3 - IP
          M = MP1 - 1
          MS2 = MP1/2
          NEM = (NLAT-M+1)/2
          NOM = NLAT - M - NEM
          NOC = NTO - NOM
c
c     compute associated legendre functions
c
          IF (M.LE.1) THEN
              DO 305 J = 1,NOM
                  N = J + J + M - 1
                  CALL DDLFKG(M,N,CP)
                  DO I = 1,NTE
                      CALL DDLFTG(M,N,THET(I),CP,POD(I,J+NOC,IP))
                  END DO
C*PT*WARNING* Constant already double-precision
                  IF (MODN.GT.0) POD(NTE,J+NOC,IP) = 0.0d0
  305         CONTINUE
c
          ELSE
c
              DO 307 J = 1,NOM
                  N = J + J + M - 1
                  IF (M.GT.1 .AND. N.GT.MXTR) THEN
                      DO I = 1,NTE
                          U(I,J+NOC) = POD(I,J+NOC,IP)
                      END DO
                      GO TO 304
                  END IF
                  A1 = B(N-1)*A(N+M-3)/A(N+M-1)
                  B1 = A(N-M+1)/A(N+M-1)
                  IF (N-M.LE.1) THEN
                      DO I = 1,NTE
                          U(I,J+NOC) = A1*POD(I,J+NOC-1,IP) -
     +                                 B1*POD(I,J+NOC,IP)
                      END DO
                  ELSE
                      C1 = B(N-1)*A(N-M-1)/A(N+M-1)
                      DO I = 1,NTE
                          U(I,J+NOC) = A1*POD(I,J+NOC-1,IP) -
     +                                 B1*POD(I,J+NOC,IP) +
     +                                 C1*U(I,J+NOC-1)
                      END DO
                  END IF
C*PT*WARNING* Constant already double-precision
  304             IF (MODN.EQ.1) U(NTE,J+NOC) = 0.0d0
  307         CONTINUE
              DO J = 1,NOM
                  DO I = 1,NTE
                      POD(I,J+NOC,IP) = U(I,J+NOC)
                  END DO
              END DO
          END IF
c
          IF (NOC.LE.0) GO TO 300
          DO I = 1,NTE
              XX(I) = RAND()
          END DO
C*PT*WARNING* Constant already double-precision
          IF (MODN.EQ.1) XX(NTE) = 0.0d0
          IT = 0
  306     DO I = 1,NTE
              Z(I) = 0.D0
              WX(I) = GWTS(I)*XX(I)
          END DO
          DO 330 J = 1,NTO
              IF (J.EQ.NOC) GO TO 330
              CALL DGS(NTE,WX,POD(1,J,IP),Z(1))
  330     CONTINUE
c
          DO I = 1,NTE
              XX(I) = XX(I) - Z(I)
          END DO
          CALL DNORMAL(NTE,XX,IDP,GWTS)
          IT = IT + 1
          IF (IT.LE.2) GO TO 306
          DO I = 1,NTE
              POD(I,NOC,IP) = XX(I)
          END DO
C*PT*WARNING* Constant already double-precision
          IF (MODN.EQ.1) POD(NTE,NOC,IP) = 0.0d0
  300 CONTINUE
c
      NMX = NLAT - MXTR
      IF (MODN.EQ.1) THEN
          NSHO(1) = (NMX-1)/2
          NSHO(2) = NMX/2
      ELSE
          NSHO(1) = NMX/2
          NSHO(2) = (NMX-1)/2
      END IF
c
      DO 310 MP1 = 1,2
          DO J = 1,NTO
              JS = J + NSHO(MP1)
              IF (JS.GT.NTO) JS = JS - NTO
              DO I = 1,NTE
                  U(I,JS) = POD(I,J,MP1)
              END DO
          END DO
          DO J = 1,NTO
              DO I = 1,NTE
                  POD(I,J,MP1) = U(I,J)
              END DO
          END DO
  310 CONTINUE
c
      CALL DTRUNC(0,NTE,IDP,POD(1,1,1),NTO,IPSO(1,1))
      CALL DTRUNC(0,NTE,IDP,POD(1,1,2),NTO,IPSO(1,2))
c
c     compute the analysis matrices (odd functions)
c
      DO IP = 1,2
          DO I = 1,NTO
              LOCK = 0
              DO J = 1,NTO
                  SUM = POD(J,I,IP)*GWTS(J)
                  ZO(J,I,IP) = SUM
                  PO(I,J,IP) = POD(I,J,IP)
                  IF (DABS(SUM).GT.EPS .AND. LOCK.EQ.0) THEN
                      LOCK = 1
                      JZSO(I,IP) = J
                  END IF
              END DO
          END DO
      END DO
c
c     check orthogonality of po(i,j,mp1)  mp1=1,2
c
      DO IP = 1,2
          DMAX = 0.D0
          DO I = 1,NTO
              DO J = 1,NTO
                  SUM1 = 0.D0
                  DO K = 1,NTO
                      SUM1 = SUM1 + ZO(K,I,IP)*PO(K,J,IP)
                  END DO
                  ZORT(I,J,IP) = SUM1
                  IF (I.NE.J) THEN
                      DMAX = MAX(DMAX,ABS(SUM1))
                  ELSE
                      DMAX = MAX(DMAX,ABS(SUM1-1.0D0))
                  END IF
              END DO
          END DO
      END DO
      RETURN
      END
c
c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by UCAR                 .
c  .                                                             .
c  .       University Corporation for Atmospheric Research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                         SPHEREPACK3.0                       .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c ... file shpg.f
c
c ... files which must be loaded with shpg.f
c
c     hrfft.f
c
c     shpg computes the harmonic projection, which is
c     equivalent to a harmonic analysis (forward) followed
c     by a harmonic synthesis (backward transform).
c     shpg uses the n**2 projection or complement when appropriate
c     as well as  odd/even factorization and zero truncation on an
c     on a Gaussian distributed grid as defined in the JCP paper
c     "Generalized discrete spherical harmonic transforms"
c     by Paul N. Swarztrauber and William F. Spotz
c     J. Comp. Phys., 159(2000) pp. 213-230.
c
c     subroutine shpg(nlat,nlon,isym,mtrunc,x,y,idxy,
c    1        wshp,lwshp,iwshp,liwshp,work,lwork,ierror)
c
c     shpg projects the array x onto the set of functions represented
c     by a discrete set of spherical harmonics.
c
c     input parameters
c
c     nlat   the number of colatitudes on the full sphere including the
c            poles. for example, nlat = 37 for a five degree grid.
c            nlat determines the grid increment in colatitude as
c            pi/(nlat-1).  if nlat is odd the equator is located at
c            grid point i=(nlat+1)/2. if nlat is even the equator is
c            located half way between points i=nlat/2 and i=nlat/2+1.
c            nlat must be at least 3.
c
c     nlon   the number of distinct londitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater
c            than or equal to 4. the efficiency of the computation is
c            improved when nlon is a product of small prime numbers.
c            nlon must be at least 4.
c
c     isym   currently not used.
c
c     mtrunc the highest longitudinal wave number retained in the
c            projection. It must be less than or equal to
c            the minimum of nlat-1 and nlon/2. The first wave
c            number is zero. For example, if wave numbers 0 and
c            1 are desired then mtrunc = 1.

c            zero.
c
c     x      a two dimensional array that contains the the nlat
c            by nlon array x(i,j) defined at the colatitude point
c            theta(i) = (i-1)*pi/(nlat-1) and longitude point phi(j) =
c            (j-1)*2*pi/nlon.
c
c     idxy   the first dimension of the arrays x and y as they
c            appear in the program that calls shpg. It must be
c            at least nlat.
c
c     wshp   a single precision array that must be saved for
c            repeated use by subroutine shpg.
c
c     lwshp  the dimension of the array wshp as it appears in the
c            program that calls shpgi. It must be at least
c            2*(nlat+1)**2+nlon+log2(nlon)
c
c     iwshp  an integer array that must be saved for repeated
c            use by subroutine shpg.
c
c
c     liwshp the dimension of the array iwshp as it appears in the
c            program that calls shpgi. It must be at least
c            4*(nlat+1).
c
c     work   a single precision work array that does
c            not have to be saved.
c
c     lwork  the dimension of the array work as it appears in the
c            program that calls shpg. It must be at least
c            max(nlat*nlon,4*(nlat+1)).
c
c     **************************************************************
c
c     output parameters
c
c     y      an nlat by nlon single precision array that contains
c            the projection of x onto the set of functions that
c            can be represented by the discrete set of spherical
c            harmonics. The arrays x(i,j) and y(i,j) are located
c            at colatitude point theta(i) = (i-1)*pi/(nlat-1) and
c            longitude point phi(j) = (j-1)*2*pi/nlon.
c
c     ierror = 0  no errors
c            = 1  error in the specification of nlat
c            = 2  error in the specification of nlon
c            = 3  error in the specification of isym
c            = 4  error in the specification of mtrunc
c            = 5  error in the specification of lwshp
c            = 6  error in the specification of liwshp
c            = 7  error in the specification of lwork
c
      SUBROUTINE DSHPG(NLAT,NLON,ISYM,MTRUNC,X,Y,IDXY,WSHP,LWSHP,IWSHP,
     +                LIWSHP,WORK,LWORK,IERROR)
      DOUBLE PRECISION X
      DOUBLE PRECISION Y
      DOUBLE PRECISION WSHP
      DOUBLE PRECISION WORK
      DOUBLE PRECISION SN
c
      DIMENSION WSHP(*),IWSHP(*),WORK(*),X(IDXY,NLON),Y(IDXY,NLON)
c
      IERROR = 1
      IF (NLAT.LT.1) RETURN
      IERROR = 2
      IF (NLON.LT.1) RETURN
c      ierror = 3
c      if(isym.lt.0 .or. isym.gt.2) return
      IERROR = 4
      MMAX = MIN(NLAT-1,NLON/2)
      IF (MTRUNC.LT.0 .OR. MTRUNC.GT.MMAX) RETURN
      IERROR = 5
      LOG2N = LOG(DBLE(NLON))/LOG(2.0D0)
      LW1 = 2* (NLAT+1)**2
      IF (LWSHP.LT.LW1+NLON+LOG2N) RETURN
      IERROR = 6
      IF (LIWSHP.LT.4* (NLAT+1)) RETURN
      IERROR = 7
      MWRK = MAX(NLAT*NLON,4* (NLAT+1))
      IF (LWORK.LT.MWRK) RETURN
      IERROR = 0
c
      DO J = 1,NLON
          DO I = 1,NLAT
              Y(I,J) = X(I,J)
          END DO
      END DO
      CALL DHRFFTF(NLAT,NLON,Y,IDXY,WSHP(LW1+1),WORK)
c
      NTE = (NLAT+1)/2
      NLOC1 = 2*NTE*NTE
      NLOC2 = NLAT + 1
      IW1 = 1
      IW2 = IW1 + NLOC1
      IW3 = IW2 + NLOC1
      IW4 = IW3 + NLOC1
      JW1 = 1
      JW2 = JW1 + NLOC2
      JW3 = JW2 + NLOC2
      JW4 = JW3 + NLOC2
c
      CALL DSHPG1(NLAT,NLON,ISYM,MTRUNC,Y,Y,IDXY,IERROR,NTE,WSHP(IW1),
     +           WSHP(IW2),WSHP(IW3),WSHP(IW4),IWSHP(JW1),IWSHP(JW2),
     +           IWSHP(JW3),IWSHP(JW4),WORK(JW1),WORK(JW2),WORK(JW3),
     +           WORK(JW4))
c
      CALL DHRFFTB(NLAT,NLON,Y,IDXY,WSHP(LW1+1),WORK)
c
      SN = 1.0D0/NLON
      DO J = 1,NLON
          DO I = 1,NLAT
              Y(I,J) = SN*Y(I,J)
          END DO
      END DO
      RETURN
      END
      SUBROUTINE DSHPG1(NLAT,NLON,ISYM,MTRUNC,SX,SY,IDXY,IERROR,IDP,PE,
     +                 PO,ZE,ZO,IPSE,JZSE,IPSO,JZSO,XE,XO,YE,YO)
      DOUBLE PRECISION SX
      DOUBLE PRECISION SY
      DOUBLE PRECISION PE
      DOUBLE PRECISION PO
      DOUBLE PRECISION ZE
      DOUBLE PRECISION ZO
      DOUBLE PRECISION XE
      DOUBLE PRECISION XO
      DOUBLE PRECISION YE
      DOUBLE PRECISION YO
c
      DIMENSION SX(IDXY,NLON),SY(IDXY,NLON),NSHE(2),NSHO(2),
     +          PE(IDP,IDP,2),PO(IDP,IDP,2),ZE(IDP,IDP,2),ZO(IDP,IDP,2),
     +          IPSE(IDP,2),JZSE(IDP,2),IPSO(IDP,2),JZSO(IDP,2),
     +          XE(IDP,2),XO(IDP,2),YE(IDP,2),YO(IDP,2)
c
      NS2 = NLAT/2
      MODN = NLAT - NS2 - NS2
      NTE = (NLAT+1)/2
      NTO = NLAT - NTE
c
      MXTR = MIN(NLAT-1,NLON/2,MTRUNC)
      NMX = NLAT - MXTR
      IF (MODN.EQ.1) THEN
          NSHE(1) = NMX/2
          NSHE(2) = (NMX-1)/2
          NSHO(1) = (NMX-1)/2
          NSHO(2) = NMX/2
      ELSE
          NSHE(1) = (NMX-1)/2
          NSHE(2) = NMX/2
          NSHO(1) = NMX/2
          NSHO(2) = (NMX-1)/2
      END IF
c
      IP = 2
      DO 100 MP1 = 1,MXTR + 1
          IP = 3 - IP
          IF (MXTR.EQ.NLAT-1 .AND. MP1.EQ.1) THEN
              DO I = 1,NLAT
                  SY(I,MP1) = SX(I,MP1)
              END DO
c      if(mp1.eq.2) then
c      sy(1,2) = 0.
c      sy(nlat,2) = 0.
c      end if
c      if(nlon.ge.3) then
c      sy(1,3) = 0.
c      sy(nlat,3) = 0.
c      do i=2,nlat-1
c      sy(i,3) = sx(i,3)
c      end do
c      end if
              GO TO 100
          END IF
          M = MP1 - 1
          MPM = MAX(1,M+M)
          MS2 = MP1/2
c      mrank = min(nlat-m,nlat-ms2-ms2)
c      nrank = nlat-mrank
c      nem = (mrank+1)/2-nshe(ip)
c      nom = mrank-(mrank+1)/2-nsho(ip)
          NEM = (NLAT-M+1)/2 - NSHE(IP)
          NOM = (NLAT-M)/2 - NSHO(IP)
          NEC = NTE - NEM
          NOC = NTO - NOM
          DO I = 1,NTE
              XE(I,1) = .5D0* (SX(I,MPM)+SX(NLAT+1-I,MPM))
              XO(I,1) = .5D0* (SX(I,MPM)-SX(NLAT+1-I,MPM))
          END DO
c      if(modn.eq.1) then
c      xe(nte,1) = sx(nte,mpm)
c      xo(nte,1) = 0.
c      end if
          IF (MPM.LT.NLON) THEN
              DO I = 1,NTE
                  XE(I,2) = .5D0* (SX(I,MPM+1)+SX(NLAT+1-I,MPM+1))
                  XO(I,2) = .5D0* (SX(I,MPM+1)-SX(NLAT+1-I,MPM+1))
              END DO
c      if(modn.eq.1) then
c      xe(nte,2) = sx(nte,mpm+1)
c      xo(nte,2) = 0.
c      end if
          END IF
          LAG = 0
          IF (M.EQ.0 .OR. MPM.EQ.NLON) LAG = 1
          IF (3*NEC.LT.2*NEM .OR. NEM.EQ.0) THEN
              CALL DTMXMX(LAG,NTE,NEC,IDP,PE(1,1,IP),NTE,IDP,ZE(1,1,IP),
     +                   XE,YE,IPSE(1,IP),JZSE(1,IP))
              DO I = 1,NTE
                  YE(I,1) = XE(I,1) - YE(I,1)
              END DO
              IF (MPM.LT.NLON .AND. M.NE.0) THEN
                  DO I = 1,NTE
                      YE(I,2) = XE(I,2) - YE(I,2)
                  END DO
              END IF
          ELSE
              CALL DTMXMX(LAG,NTE,NEM,IDP,PE(1,NEC+1,IP),NTE,IDP,
     +                   ZE(1,NEC+1,IP),XE,YE,IPSE(NEC+1,IP),
     +                   JZSE(NEC+1,IP))
          END IF
          IF (3*NOC.LT.2*NOM .OR. NOM.EQ.0) THEN
              CALL DTMXMX(LAG,NTO,NOC,IDP,PO(1,1,IP),NTO,IDP,ZO(1,1,IP),
     +                   XO,YO,IPSO(1,IP),JZSO(1,IP))
              DO I = 1,NTO
                  YO(I,1) = XO(I,1) - YO(I,1)
              END DO
              IF (MPM.LT.NLON .AND. M.NE.0) THEN
                  DO I = 1,NTO
                      YO(I,2) = XO(I,2) - YO(I,2)
                  END DO
              END IF
          ELSE
              CALL DTMXMX(LAG,NTO,NOM,IDP,PO(1,NOC+1,IP),NTO,IDP,
     +                   ZO(1,NOC+1,IP),XO,YO,IPSO(NOC+1,IP),
     +                   JZSO(NOC+1,IP))
          END IF
          DO I = 1,NTO
              SY(I,MPM) = YE(I,1) + YO(I,1)
              SY(NLAT+1-I,MPM) = YE(I,1) - YO(I,1)
          END DO
          IF (NTE.GT.NTO) SY(NTE,MPM) = YE(NTE,1)
          IF (MPM.LT.NLON .AND. M.NE.0) THEN
              DO I = 1,NTO
                  SY(I,MPM+1) = YE(I,2) + YO(I,2)
                  SY(NLAT+1-I,MPM+1) = YE(I,2) - YO(I,2)
              END DO
              IF (NTE.GT.NTO) SY(NTE,MPM+1) = YE(NTE,2)
          END IF
  100 CONTINUE
c
      JS = MXTR + MXTR + 2
      DO J = JS,NLON
          DO I = 1,NLAT
              SY(I,J) = 0.D0
          END DO
      END DO
      RETURN
      END
      SUBROUTINE DMXM(LR,LC,LD,A,MC,MD,B,ND,C)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION A(LD,*),B(MD,*),C(ND,*)

      DO I = 1,LR
          DO J = 1,MC
              C(I,J) = 0.D0
              DO K = 1,LC
                  C(I,J) = C(I,J) + A(I,K)*B(K,J)
              END DO
          END DO
      END DO
      RETURN
      END
      SUBROUTINE DSMXM(LR,LC,LD,A,MC,MD,B,ND,C)
      DOUBLE PRECISION A
      DOUBLE PRECISION B
      DOUBLE PRECISION C
      DIMENSION A(LD,*),B(MD,*),C(ND,*)

      DO I = 1,LR
          DO J = 1,MC
              C(I,J) = 0.D0
              DO K = 1,LC
                  C(I,J) = C(I,J) + A(I,K)*B(K,J)
              END DO
          END DO
      END DO
      RETURN
      END
      SUBROUTINE DMXMX(LR,LC,LD,A,MC,MD,B,X,Y)
      DOUBLE PRECISION A
      DOUBLE PRECISION B
      DOUBLE PRECISION X
      DOUBLE PRECISION Y
      DOUBLE PRECISION SUM1
      DOUBLE PRECISION SUM2
      DIMENSION A(LD,*),B(MD,*),X(LD,2),Y(LD,2)

      DO K = 1,LR
          Y(K,1) = 0.D0
          Y(K,2) = 0.D0
      END DO
c
      IF (LC.LE.0) RETURN
      DO I = 1,LC
          SUM1 = 0.D0
          SUM2 = 0.D0
          DO J = 1,MC
              SUM1 = SUM1 + B(I,J)*X(J,1)
              SUM2 = SUM2 + B(I,J)*X(J,2)
          END DO
          DO K = 1,LR
              Y(K,1) = Y(K,1) + SUM1*A(K,I)
              Y(K,2) = Y(K,2) + SUM2*A(K,I)
          END DO
      END DO
      RETURN
      END
      SUBROUTINE DDMXMX(LR,LC,LD,A,MC,MD,B,X,Y)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION A(LD,*),B(MD,*),X(LD,2),Y(LD,2),SUM1,SUM2

      DO K = 1,LR
          Y(K,1) = 0.D0
          Y(K,2) = 0.D0
      END DO
c
      IF (LC.LE.0) RETURN
      DO I = 1,LC
          SUM1 = 0.D0
          SUM2 = 0.D0
          DO J = 1,MC
              SUM1 = SUM1 + B(I,J)*X(J,1)
              SUM2 = SUM2 + B(I,J)*X(J,2)
          END DO
          DO K = 1,LR
              Y(K,1) = Y(K,1) + SUM1*A(K,I)
              Y(K,2) = Y(K,2) + SUM2*A(K,I)
          END DO
      END DO
      RETURN
      END
      SUBROUTINE DTMXMX(LAG,LR,LC,LD,A,MC,MD,B,X,Y,IS,JS)
      DOUBLE PRECISION A
      DOUBLE PRECISION B
      DOUBLE PRECISION X
      DOUBLE PRECISION Y
      DOUBLE PRECISION SUM1
      DOUBLE PRECISION SUM2
      DIMENSION A(LD,*),B(MD,*),X(LD,2),Y(LD,2),IS(*),JS(*)
c
      KMX = MIN(LR+1,LD)
      IF (LAG.EQ.1) THEN
          DO K = 1,KMX
              Y(K,1) = 0.D0
          END DO
c      if(lc.eq.0) then
c      do k=1,lr
c      y(k,1) = x(k,1)
c      end do
c      return
c      end if
          IF (LC.LE.0) RETURN
          DO I = 1,LC
              SUM1 = 0.D0
              DO J = JS(I),MC
                  SUM1 = SUM1 + B(J,I)*X(J,1)
              END DO
              DO K = IS(I),LR
                  Y(K,1) = Y(K,1) + SUM1*A(K,I)
              END DO
          END DO
          RETURN
      END IF
      DO K = 1,KMX
          Y(K,1) = 0.D0
          Y(K,2) = 0.D0
      END DO
      IF (LC.LE.0) RETURN
c
      DO I = 1,LC
          SUM1 = 0.D0
          SUM2 = 0.D0
          DO J = JS(I),MC
              SUM1 = SUM1 + B(J,I)*X(J,1)
              SUM2 = SUM2 + B(J,I)*X(J,2)
          END DO
          DO K = IS(I),LR
              Y(K,1) = Y(K,1) + SUM1*A(K,I)
              Y(K,2) = Y(K,2) + SUM2*A(K,I)
          END DO
      END DO
      RETURN
      END
      SUBROUTINE DTRUNC(IRC,N,IDP,A,NRC,IJS)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION A,EPS
C*PT*WARNING* Constant already double-precision
      PARAMETER (EPS=5.d-8)
      DIMENSION A(IDP,*),IJS(N)
c
c     irc = 0 for columns , or irc = 1 for rows
c
      IF (IRC.NE.0) GO TO 30
      DO 20 J = 1,NRC
          DO I = 1,N
              IJS(J) = I
              IF (DABS(A(I,J)).GT.EPS) GO TO 20
          END DO
   20 CONTINUE
      RETURN
   30 DO 50 I = 1,NRC
          DO J = 1,N
              IJS(I) = J
              IF (ABS(A(I,J)).GT.EPS) GO TO 50
          END DO
   50 CONTINUE
      RETURN
      END
      SUBROUTINE DGS(N,X,Y,Z)
      DIMENSION X(N),Y(N),Z(N)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION X,Y,Z,SUM
c
c     accumulate innerproducts of x with respect to y.
c
      SUM = 0.D0
      DO I = 1,N
          SUM = SUM + X(I)*Y(I)
      END DO
      DO I = 1,N
          Z(I) = Z(I) + SUM*Y(I)
      END DO
      RETURN
      END
      SUBROUTINE DNORMAL(N,X,ID,Q)
      DIMENSION X(N),Q(N)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION X,Q,SQS
c
c     normalize x
c
      SQS = 0.D0
      DO I = 1,N
c      sum = 0.
c      do j=1,n
c      sum = sum+q(i,j)*x(j)
c      end do
c      sqs = sqs+sum*x(i)
          SQS = SQS + Q(I)*X(I)*X(I)
      END DO
c
      IF (SQS.NE.0) GO TO 4
      WRITE (*,FMT=3)
    3 FORMAT (' norm of z is zero in subroutine normal')
      RETURN
    4 SQS = DSQRT(SQS)
      DO I = 1,N
          X(I) = X(I)/SQS
      END DO
      RETURN
      END
      SUBROUTINE DCOE(MOE,N,X,DMAX)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION X(N),DMAX

      NH = (N+1)/2
      DMAX = 0.D0
      IF (MOE.NE.0) GO TO 1
      DO I = 1,NH
          DMAX = MAX(DMAX,DABS(X(I)-X(N-I+1)))
          X(I) = .5D0* (X(I)+X(N-I+1))
          X(N-I+1) = X(I)
      END DO
      RETURN
    1 DO I = 1,NH
          DMAX = MAX(DMAX,DABS(X(I)+X(N-I+1)))
          X(I) = .5D0* (X(I)-X(N-I+1))
          X(N-I+1) = -X(I)
      END DO
      IF (MOD(N,2).NE.0) X(NH) = 0.D0
      RETURN
      END
c     subroutine dlfkg(m,n,cp)
c
c     subroutine dlfkg computes the coefficients in the trigonometric
c     expansion of the normalized associated legendre functions:
c
c     pbar(m,n,theta) = sqrt((2*n+1)*factorial(n-m)/(2*factorial(n+m)))
c                        *sin(theta)**m/(2**n*factorial(n)) times the
c                        (n+m)th derivative of (x**2-1)**n with respect
c                        to x=cos(theta)
c
c     where theta is colatitude.
c
c     subroutine dlfkg computes the coefficients cp(k) in the
c     following trigonometric expansion of pbar(m,n,theta).
c
c            1) for n even and m even, pbar(m,n,theta) =
c               .5*cp(1) plus the sum from k=1 to k=n/2
c               of cp(k)*cos(2*k*th)
c
c            2) for n even and m odd, pbar(m,n,theta) =
c               the sum from k=1 to k=n/2 of
c               cp(k)*sin(2*k*th)
c
c            3) for n odd and m even, pbar(m,n,theta) =
c               the sum from k=1 to k=(n+1)/2 of
c               cp(k)*cos((2*k-1)*th)
c
c            4) for n odd and m odd,  pbar(m,n,theta) =
c               the sum from k=1 to k=(n+1)/2 of
c               cp(k)*sin((2*k-1)*th)
c
c     input parameters
c
c     m      is the order of pbar(n,m,theta). m can be any integer
c            however pbar(n,m,theta) = 0  if abs(m) is greater than
c            n and pbar(n,m,theta) = (-1)**m*pbar(n,-m,theta) for
c            negative m.
c
c     n      nonnegative integer specifying the degree of
c            pbar(n,m,theta)
c
c     output parameters
c
c     cp     a double precision array that contains the fourier
c            coefficients for pbar(m,n,theta). the length of the
c            array depends on the parity of m and n
c
c                  parity            length of cp
c
c               n even m even           n/2+1
c               n even m odd             n/2
c               n odd  m even          (n+1)/2
c               n odd  m odd           (n+1)/2
c
c
c ****************************************************************
      SUBROUTINE DDLFKG(M,N,CP)
C*PT*WARNING* Already double-precision
c
      DOUBLE PRECISION CP,FNUM,FDEN,FNMH,A1,B1,C1,CP2,FNNP1,FNMSQ,FK,T1,
     +                 T2,PM1,SC10,SC20,SC40
      DIMENSION CP(1)
C*PT*WARNING* Constant already double-precision
      PARAMETER (SC10=1024.d0)
      PARAMETER (SC20=SC10*SC10)
      PARAMETER (SC40=SC20*SC20)
c
      CP(1) = 0.D0
      MA = IABS(M)
      IF (MA.GT.N) RETURN
      IF (N-1) 2,3,5
C*PT*WARNING* Constant already double-precision
    2 CP(1) = DSQRT(2.d0)
      RETURN
    3 IF (MA.NE.0) GO TO 4
C*PT*WARNING* Constant already double-precision
      CP(1) = DSQRT(1.5d0)
      RETURN
C*PT*WARNING* Constant already double-precision
    4 CP(1) = DSQRT(.75d0)
      IF (M.EQ.-1) CP(1) = -CP(1)
      RETURN
    5 IF (MOD(N+MA,2).NE.0) GO TO 10
      NMMS2 = (N-MA)/2
      FNUM = N + MA + 1
      FNMH = N - MA + 1
C*PT*WARNING* Constant already double-precision
      PM1 = 1.d0
      GO TO 15
   10 NMMS2 = (N-MA-1)/2
      FNUM = N + MA + 2
      FNMH = N - MA + 2
C*PT*WARNING* Constant already double-precision
      PM1 = -1.d0
C*PT*WARNING* Constant already double-precision
   15 T1 = 1.d0/SC20
      NEX = 20
C*PT*WARNING* Constant already double-precision
      FDEN = 2.d0
      IF (NMMS2.LT.1) GO TO 20
      DO 18 I = 1,NMMS2
          T1 = FNUM*T1/FDEN
          IF (T1.GT.SC20) THEN
              T1 = T1/SC40
              NEX = NEX + 40
          END IF
          FNUM = FNUM + 2.D0
          FDEN = FDEN + 2.D0
   18 CONTINUE
C*PT*WARNING* Constant already double-precision
   20 T1 = T1/2.d0** (N-1-NEX)
      IF (MOD(MA/2,2).NE.0) T1 = -T1
      T2 = 1.D0
      IF (MA.EQ.0) GO TO 26
      DO 25 I = 1,MA
          T2 = FNMH*T2/ (FNMH+PM1)
          FNMH = FNMH + 2.D0
   25 CONTINUE
C*PT*WARNING* Constant already double-precision
   26 CP2 = T1*DSQRT((N+.5d0)*T2)
      FNNP1 = N* (N+1)
C*PT*WARNING* Constant already double-precision
      FNMSQ = FNNP1 - 2.d0*MA*MA
      L = (N+1)/2
      IF (MOD(N,2).EQ.0 .AND. MOD(MA,2).EQ.0) L = L + 1
      CP(L) = CP2
      IF (M.GE.0) GO TO 29
      IF (MOD(MA,2).NE.0) CP(L) = -CP(L)
   29 IF (L.LE.1) RETURN
      FK = N
      A1 = (FK-2.D0)* (FK-1.D0) - FNNP1
      B1 = 2.D0* (FK*FK-FNMSQ)
      CP(L-1) = B1*CP(L)/A1
   30 L = L - 1
      IF (L.LE.1) RETURN
      FK = FK - 2.D0
      A1 = (FK-2.D0)* (FK-1.D0) - FNNP1
      B1 = -2.D0* (FK*FK-FNMSQ)
      C1 = (FK+1.D0)* (FK+2.D0) - FNNP1
      CP(L-1) = - (B1*CP(L)+C1*CP(L+1))/A1
      GO TO 30
      END
      SUBROUTINE DDLFTG(M,N,THETA,CP,PB)
      DIMENSION CP(1)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION CP,PB,THETA,CDT,SDT,CTH,STH,CHH

      CDT = DCOS(THETA+THETA)
      SDT = DSIN(THETA+THETA)
      NMOD = MOD(N,2)
      MMOD = MOD(ABS(M),2)
      IF (NMOD) 1,1,2
    1 IF (MMOD) 3,3,4
c
c     n even, m even
c
    3 KDO = N/2
      PB = .5D0*CP(1)
      IF (N.EQ.0) RETURN
      CTH = CDT
      STH = SDT
      DO 170 K = 1,KDO
c     pb = pb+cp(k+1)*dcos(2*k*theta)
          PB = PB + CP(K+1)*CTH
          CHH = CDT*CTH - SDT*STH
          STH = SDT*CTH + CDT*STH
          CTH = CHH
  170 CONTINUE
      RETURN
c
c     n even, m odd
c
    4 KDO = N/2
      PB = 0.D0
      CTH = CDT
      STH = SDT
      DO 180 K = 1,KDO
c     pb = pb+cp(k)*dsin(2*k*theta)
          PB = PB + CP(K)*STH
          CHH = CDT*CTH - SDT*STH
          STH = SDT*CTH + CDT*STH
          CTH = CHH
  180 CONTINUE
      RETURN
    2 IF (MMOD) 13,13,14
c
c     n odd, m even
c
   13 KDO = (N+1)/2
      PB = 0.D0
      CTH = DCOS(THETA)
      STH = DSIN(THETA)
      DO 190 K = 1,KDO
c     pb = pb+cp(k)*dcos((2*k-1)*theta)
          PB = PB + CP(K)*CTH
          CHH = CDT*CTH - SDT*STH
          STH = SDT*CTH + CDT*STH
          CTH = CHH
  190 CONTINUE
      RETURN
c
c     n odd, m odd
c
   14 KDO = (N+1)/2
      PB = 0.D0
      CTH = DCOS(THETA)
      STH = DSIN(THETA)
      DO 200 K = 1,KDO
c     pb = pb+cp(k)*dsin((2*k-1)*theta)
          PB = PB + CP(K)*STH
          CHH = CDT*CTH - SDT*STH
          STH = SDT*CTH + CDT*STH
          CTH = CHH
  200 CONTINUE
      RETURN
      END
c
      SUBROUTINE DGAQDP(NLAT,THETA,WTS,W,LWORK,IERROR)
      DOUBLE PRECISION EPS
      DOUBLE PRECISION DDZEPP
      DOUBLE PRECISION SGND
C*PT*WARNING* Already double-precision
c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 2001 by ucar                 .
c  .                                                             .
c  .       university corporation for atmospheric research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c                             April 2002
c
c     gauss points and weights are computed using the fourier-newton
c     described in "on computing the points and weights for
c     gauss-legendre quadrature", paul n. swarztrauber, siam journal
c     on scientific computing that has been accepted for publication.
c     This routine is faster and more accurate than older program
c     with the same name.
c
C*PL*ERROR* Comment line too long
c     subroutine gaqdp computes the nlat gaussian colatitudes and weights
c     in double precision. the colatitudes are in radians and lie in the
c     in the interval (0,pi).
c
c     input parameters
c
c     nlat    the number of gaussian colatitudes in the interval (0,pi)
c             (between the two poles).  nlat must be greater than zero.
c
c     w       unused variable that permits a simple exchange with the
c             old routine with the same name in spherepack.
c
c     lwork   unused variable that permits a simple exchange with the
c             old routine with the same name in spherepack.
c
c     output parameters
c
c     theta   a double precision array with length nlat
c             containing the gaussian colatitudes in
c             increasing radians on the interval (0,pi).
c
c     wts     a double precision array with lenght nlat
c             containing the gaussian weights.
c
c     ierror = 0 no errors
c            = 1 if nlat.le.0
c
c  *****************************************************************
c
      DOUBLE PRECISION THETA(NLAT),WTS(NLAT),X,PI,PIS2,DTHETA,DTHALF,
     +                 CMAX,ZPREV,ZLAST,ZERO,ZHOLD,PB,DPB,DCOR,SUM,W,CZ
c
c     check work space length
c
      IERROR = 1
      IF (NLAT.LE.0) RETURN
      IERROR = 0
c
c     compute weights and points analytically when nlat=1,2
c
      IF (NLAT.EQ.1) THEN
C*PT*WARNING* Constant already double-precision
          THETA(1) = DACOS(0.0d0)
C*PT*WARNING* Constant already double-precision
          WTS(1) = 2.0d0
          RETURN
      END IF
      IF (NLAT.EQ.2) THEN
C*PT*WARNING* Constant already double-precision
C*PT*WARNING* Constant already double-precision
          X = DSQRT(1.0d0/3.0d0)
          THETA(1) = DACOS(X)
          THETA(2) = DACOS(-X)
C*PT*WARNING* Constant already double-precision
          WTS(1) = 1.0d0
C*PT*WARNING* Constant already double-precision
          WTS(2) = 1.0d0
          RETURN
      END IF
C*PT*WARNING* Constant already double-precision
      EPS = SQRT(DDZEPP(1.0d0))
      EPS = EPS*SQRT(EPS)
C*PT*WARNING* Constant already double-precision
C*PT*WARNING* Constant already double-precision
      PIS2 = 2.0d0*DATAN(1.0d0)
      PI = PIS2 + PIS2
      MNLAT = MOD(NLAT,2)
      NS2 = NLAT/2
      NHALF = (NLAT+1)/2
      IDX = NS2 + 2
c
      CALL DCPDP1(NLAT,CZ,THETA(NS2+1),WTS(NS2+1))
c
      DTHETA = PIS2/NHALF
C*PT*WARNING* Constant already double-precision
      DTHALF = DTHETA/2.0d0
C*PT*WARNING* Constant already double-precision
      CMAX = .2d0*DTHETA
c
c     estimate first point next to theta = pi/2
c
      IF (MNLAT.NE.0) THEN
          ZERO = PIS2 - DTHETA
          ZPREV = PIS2
          NIX = NHALF - 1
      ELSE
          ZERO = PIS2 - DTHALF
          NIX = NHALF
      END IF
    9 IT = 0
   10 IT = IT + 1
      ZLAST = ZERO
c
c     newton iterations
c
      CALL DTPDP1(NLAT,ZERO,CZ,THETA(NS2+1),WTS(NS2+1),PB,DPB)
      DCOR = PB/DPB
      SGND = 1.0D0
C*PT*WARNING* Constant already double-precision
      IF (DCOR.NE.0.0d0) SGND = DCOR/DABS(DCOR)
      DCOR = SGND*MIN(DABS(DCOR),CMAX)
      ZERO = ZERO - DCOR
      IF (DABS(ZERO-ZLAST).GT.EPS*DABS(ZERO)) GO TO 10
      THETA(NIX) = ZERO
      ZHOLD = ZERO
c      wts(nix) = (nlat+nlat+1)/(dpb*dpb)
c
c     yakimiw's formula permits using old pb and dpb
c
      WTS(NIX) = (NLAT+NLAT+1)/ (DPB+PB*DCOS(ZLAST)/DSIN(ZLAST))**2
      NIX = NIX - 1
      IF (NIX.EQ.0) GO TO 30
      IF (NIX.EQ.NHALF-1) ZERO = 3.0D0*ZERO - PI
      IF (NIX.LT.NHALF-1) ZERO = ZERO + ZERO - ZPREV
      ZPREV = ZHOLD
      GO TO 9
c
c     extend points and weights via symmetries
c
   30 IF (MNLAT.NE.0) THEN
          THETA(NHALF) = PIS2
          CALL DTPDP1(NLAT,PIS2,CZ,THETA(NS2+1),WTS(NS2+1),PB,DPB)
          WTS(NHALF) = (NLAT+NLAT+1)/ (DPB*DPB)
      END IF
      DO I = 1,NS2
          WTS(NLAT-I+1) = WTS(I)
          THETA(NLAT-I+1) = PI - THETA(I)
      END DO
C*PT*WARNING* Constant already double-precision
      SUM = 0.0d0
      DO I = 1,NLAT
          SUM = SUM + WTS(I)
      END DO
      DO I = 1,NLAT
C*PT*WARNING* Constant already double-precision
          WTS(I) = 2.0d0*WTS(I)/SUM
      END DO
      RETURN
      END
      SUBROUTINE DCPDP1(N,CZ,CP,DCP)
C*PT*WARNING* Already double-precision
c
c     computes the fourier coefficients of the legendre
c     polynomial p_n^0 and its derivative.
c     n is the degree and n/2 or (n+1)/2
c     coefficients are returned in cp depending on whether
c     n is even or odd. The same number of coefficients
c     are returned in dcp. For n even the constant
c     coefficient is returned in cz.
c
      DOUBLE PRECISION CP(N/2+1),DCP(N/2+1),T1,T2,T3,T4,CZ

      NCP = (N+1)/2
C*PT*WARNING* Constant already double-precision
      T1 = -1.0d0
C*PT*WARNING* Constant already double-precision
      T2 = N + 1.0d0
C*PT*WARNING* Constant already double-precision
      T3 = 0.0d0
C*PT*WARNING* Constant already double-precision
      T4 = N + N + 1.0d0
      IF (MOD(N,2).EQ.0) THEN
C*PT*WARNING* Constant already double-precision
          CP(NCP) = 1.0d0
          DO J = NCP,2,-1
C*PT*WARNING* Constant already double-precision
              T1 = T1 + 2.0d0
C*PT*WARNING* Constant already double-precision
              T2 = T2 - 1.0d0
C*PT*WARNING* Constant already double-precision
              T3 = T3 + 1.0d0
C*PT*WARNING* Constant already double-precision
              T4 = T4 - 2.0d0
              CP(J-1) = (T1*T2)/ (T3*T4)*CP(J)
          END DO
C*PT*WARNING* Constant already double-precision
          T1 = T1 + 2.0d0
C*PT*WARNING* Constant already double-precision
          T2 = T2 - 1.0d0
C*PT*WARNING* Constant already double-precision
          T3 = T3 + 1.0d0
C*PT*WARNING* Constant already double-precision
          T4 = T4 - 2.0d0
          CZ = (T1*T2)/ (T3*T4)*CP(1)
          DO J = 1,NCP
              DCP(J) = (J+J)*CP(J)
          END DO
      ELSE
C*PT*WARNING* Constant already double-precision
          CP(NCP) = 1.0d0
          DO J = NCP - 1,1,-1
C*PT*WARNING* Constant already double-precision
              T1 = T1 + 2.0d0
C*PT*WARNING* Constant already double-precision
              T2 = T2 - 1.0d0
C*PT*WARNING* Constant already double-precision
              T3 = T3 + 1.0d0
C*PT*WARNING* Constant already double-precision
              T4 = T4 - 2.0d0
              CP(J) = (T1*T2)/ (T3*T4)*CP(J+1)
          END DO
          DO J = 1,NCP
              DCP(J) = (J+J-1)*CP(J)
          END DO
      END IF
      RETURN
      END
      SUBROUTINE DTPDP1(N,THETA,CZ,CP,DCP,PB,DPB)
C*PT*WARNING* Already double-precision
c
c     computes pn(theta) and its derivative dpb(theta) with
c     respect to theta
c
      DOUBLE PRECISION CP(N/2+1),DCP(N/2+1),CZ,PB,DPB,FN,THETA,CDT,SDT,
     +                 CTH,STH,CHH
c
      FN = N
      CDT = DCOS(THETA+THETA)
      SDT = DSIN(THETA+THETA)
      IF (MOD(N,2).EQ.0) THEN
c
c     n even
c
          KDO = N/2
C*PT*WARNING* Constant already double-precision
          PB = .5d0*CZ
C*PT*WARNING* Constant already double-precision
          DPB = 0.0d0
          IF (N.GT.0) THEN
              CTH = CDT
              STH = SDT
              DO 170 K = 1,KDO
c      pb = pb+cp(k)*cos(2*k*theta)
                  PB = PB + CP(K)*CTH
c      dpb = dpb-(k+k)*cp(k)*sin(2*k*theta)
                  DPB = DPB - DCP(K)*STH
                  CHH = CDT*CTH - SDT*STH
                  STH = SDT*CTH + CDT*STH
                  CTH = CHH
  170         CONTINUE
          END IF
      ELSE
c
c     n odd
c
          KDO = (N+1)/2
C*PT*WARNING* Constant already double-precision
          PB = 0.0d0
C*PT*WARNING* Constant already double-precision
          DPB = 0.0d0
          CTH = DCOS(THETA)
          STH = DSIN(THETA)
          DO 190 K = 1,KDO
c      pb = pb+cp(k)*cos((2*k-1)*theta)
              PB = PB + CP(K)*CTH
c      dpb = dpb-(k+k-1)*cp(k)*sin((2*k-1)*theta)
              DPB = DPB - DCP(K)*STH
              CHH = CDT*CTH - SDT*STH
              STH = SDT*CTH + CDT*STH
              CTH = CHH
  190     CONTINUE
      END IF
      RETURN
      END
      DOUBLE PRECISION FUNCTION DDZEPP(X)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION X
C*PT*WARNING* Already double-precision
c
c     estimate unit roundoff in quantities of size x.
c
      DOUBLE PRECISION A,B,C,EPS
C*PT*WARNING* Constant already double-precision
C*PT*WARNING* Constant already double-precision
c
c     this program should function properly on all systems
c     satisfying the following two assumptions,
c        1.  the base used in representing floating point
c            numbers is not a power of three.
c        2.  the quantity  a  in statement 10 is represented to
c            the accuracy used in floating point variables
c            that are stored in memory.
c     the statement number 10 and the go to 10 are intended to
c     force optimizing compilers to generate code satisfying
c     assumption 2.
c     under these assumptions, it should be true that,
c            a  is not exactly equal to four-thirds,
c            b  has a zero for its last bit or digit,
c            c  is not exactly equal to one,
c            eps  measures the separation of 1.0 from
c                 the next larger floating point number.
c     the developers of eispack would appreciate being informed
c     about any systems where these assumptions do not hold.
c
c     this version dated 4/6/83.
c
      A = 4.0d0/3.0d0
C*PT*WARNING* Constant already double-precision
   10 B = A - 1.0d0
      C = B + B + B
C*PT*WARNING* Constant already double-precision
      EPS = ABS(C-1.0d0)
C*PT*WARNING* Constant already double-precision
      IF (EPS.EQ.0.0d0) GO TO 10
      DDZEPP = EPS*DABS(X)
      RETURN
      END

C
C	$Id: trndt2.f,v 1.5 2008-07-27 00:59:05 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE TRNDT2
C
C Calling this do-nothing subroutine forces "ld" to load the following
C block data routine (but only if they are in the same ".f" file).
C
        RETURN
C
      END
CNOSPLIT
      BLOCKDATA TRNDT2X
C
C  MAKE SURE THAT THESE COMMONS ARE DEFINED EVERYWHERE
C
      COMMON /CAPSCN/ SCSSTR, SCSSIZ, SCTSTR, SCTSIZ, SCNLLX,
     1                SCNLLY, SCNURX, SCNURY, SCNXOF, SCNYOF,
     2                SCNXSC, SCNYSC, SCNFMT, SCNFIN, SCVFMT,
     3                SCVFIN, SCNSIM
      INTEGER         SCSMAX, SCTMAX, SFMMAX, SFNMAX, SCVFMX,
     1                SCVFIX
      PARAMETER  (SCSMAX=50, SCTMAX=50, SFMMAX=10, SFNMAX=8)
      PARAMETER  (SCVFMX=10, SCVFIX=8)
      INTEGER         SCSSTR(SCSMAX), SCSSIZ, SCTSTR(SCTMAX), SCTSIZ,
     2                SCNLLX, SCNLLY, SCNURX, SCNURY, SCNXOF, SCNYOF,
     3                SCNFMT(SFMMAX,4)      , SCNFIN(SFNMAX),
     4                SCVFMT(SCVFMX,4)      , SCVFIN(SCVFIX)
      REAL            SCNXSC, SCNYSC, SCNRIN(SFNMAX), SCVRIN(SCVFIX)
      LOGICAL         SCNSIM
      INTEGER         LENSCN
      PARAMETER  (LENSCN=SCSMAX+1+SCTMAX+1+1+1+1+1+1+1+1+1+
     1                   (SFMMAX*4)+SFNMAX+(SCVFMX*4)+SCVFIX+1)
      EQUIVALENCE (SCNFIN,SCNRIN), (SCVFIN,SCVRIN)
C
C  INITIALIZE RASTER SCAN DATA
C
      DATA SCNXOF,SCNYOF,SCNXSC,SCNYSC,SCNSIM/0,0,1.,1.,.FALSE./
C
      END

c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by UCAR                 .
c  .                                                             .
c  .       University Corporation for Atmospheric Research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                          SPHEREPACK                         .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c
c
c ... geo2math.f
c
c     file geo2math.f contains subroutines for converting scalar and
c     vector fields between geophysical and mathematical spherical
c     coordinates.  The latter is required when using most spherepack
c     software.  The four main subroutines in geo2math.f are described
c     as follows:
c
c     (1) subroutine geo2maths(ig,nlon,nlat,sg,sm,work)
c
c         converts the nlon by nlat scalar field sg given in
c         geophysical coordinates to the nlat by nlon scalar
c         field sm given in mathematical coordinates. sg and sm
c         can be identical in the program calling geo2maths.
c
c     (2) subroutine math2geos(ig,nlat,nlon,sm,sg,work)
c
c         converts the nlat by nlon scalar field sm given in
c         mathematical coordinates to the nlon by nlat scalar
c         field sg given in geophysical coordinates.  sm and
c         sg can be identical in the program calling math2geos.
c
c     (3) subroutine geo2mathv(ig,nlon,nlat,ug,vg,vm,wm,work)
c
c         converts the nlon by nlat vector field (ug,vg) given
c         in geophysical coordinates to the nlat by nlon vector
c         field (vm,wm) in mathematical coordinates.  ug and wm
c         can be identical in the program calling geo2mathv.  vg
c         and vm can be identical in the program calling geo2mathv.
c
c     (4) subroutine math2geov(ig,nlat,nlon,vm,wm,ug,vg,work)
c
c         converts the nlat by nlon vector field (vm,wm) given
c         in mathematical coordinates to the nlon by nlat vector
c         field (ug,vg) in spherical coordinates.  vm and vg can
c         be identical in the program calling math2geov.  wm and
c         ug can be identical in the program calling math2geov.
c
c *** (1),(2),(3),(4) argument description.
c
c ... ig
c
c     = 0 if the latitude values in the geophysical arrays sg,ug,vg are
c         ordered south to north with increasing latitude subscript
c         i=1,2,...,nlat.
c
c     = 1 if the latitude values in the geophysical arrays sg,ug,vg are
c         ordered north to south with increasing latitude subscript
c         i=1,2,...,nlat.
c
c ... nlon
c
c     the number of distinct londitude points.  nlon determines
c     the grid increment in longitude as 2*pi/nlon. nlon is the first
c     dimension of the geophysical arrays sg,ug,vg and the second
c     dimension of the mathematical arrays sm,vm,wm.  The longitude
c     grid is given by phi(j) = (j-1)*2*pi/nlon j=1,...,nlon.
c
c ... nlat
c
c     the number of distinct latitude and colatitude points and the
c     first dimension of sm,vm,wm and second dimension of sg,ug,vg.
c     If the (co)latitude grid is equally spaced then the grid increment
C*PL*ERROR* Comment line too long
c     is dlat=pi/(nlat-1).  In this case the south to north latitude grid
c     underlying is
c
c        lat(i) = -0.5*pi + (i-1)*dlat (i=1,...,nlat)
c
c     and the north to south colatitude grid underlying sm,vm,wm is
c
c        colat(i) = (i-1)*dlat  (i=1,...,nlat)
c
C*PL*ERROR* Comment line too long
c     If the grid is Gaussian let thetag(i) be the north to south colatitude
c     grid (as computed by the spherepack routine gaqd).  In this case
c
c        colat(i) = thetag(i) (i=1,...,nlat)
c
c     and
c
c        lat(i) = -0.5*pi + thetag(i) (i=1,...,nlat)
c
c     In either case lat(i) = colat(nlat-i+1) for all i.
c     If nlat is odd the equator is located at the (nlat+1)/2
c     latitude or colatitude point.  If nlat is even the equator is
c     half way between the nlat/2 and nlat/2+1 latitude or colatitude
c     points.  The equally spaced (co)latitude grid includes the poles.
c     The Gaussian grid excludes the poles.
c
c ... sg,sm
c
c     In (1),(2) sg is a nlon by nlat array containing the scalar field
C*PL*ERROR* Comment line too long
c     in geophysical coordinates.  Latitude values in sg are ordered from
c     the southern to the northern hemisphere with increasing latitude
c     subscript if ig = 0 or ordered from the northern hemisphere to the
C*PL*ERROR* Comment line too long
c     southern hemisphere if ig = 1.  sm is a nlat by nlon array containing
C*PL*ERROR* Comment line too long
c     the scalar field in mathematical coordinates.  Colatitude values in sm
C*PL*ERROR* Comment line too long
c     are ordered from the north to the south hemisphere  with increasing
C*PL*ERROR* Comment line too long
c     colatitude subscript (i=1,...,nlat).  The (co)latitude grid for sg and
C*PL*ERROR* Comment line too long
c     sm can be equally spaced or Gaussian.  sg and sm can be equivalenced or
C*PL*ERROR* Comment line too long
c     be identical in the routine calling geo2maths or math2geos.  sg and
c     sm are related by
c
c          sm(nlat-i+1,j) = sg(j,i)    (if ig = 0)
c
c     or
c
c          sm(i,j) = sg(j,i)            (if ig = 1)
c
C*PL*ERROR* Comment line too long
c     for i=1,...,nlat and j=1,...,nlon. This formula is not used because
c     the two arrays can be equivalenced or identical arguments in the
c     program calling geo2maths or math2geos.
c
c ... ug,vg,vm,wm
c
c     In (3),(4) ug is a nlon by nlat array containing the longitudinal
c     vector component.  vg is a nlon by nlat array containing the
c     latitudinal vector component.  Values in (ug,vg) are ordered
c     from the southern to the northern hemisphere with increasing
c     latitude subscript if ig = 0 or from the northern to southern
c     hemisphere if ig = 1.  vm is a nlat by nlon array containing the
c     the colatitudinal vector component.  wm is a nlat by nlon array
c     containing the east longitudinal vector component.  Values in
c     (vm,wm) are ordered from the northern to the southern hemisphere
c     with increasing colatitude subscript.  The (co)latitude grid for
c     both vector fields can be equally spaced or Gaussian.  ug,wm and
c     vg,vm can be equivalenced or be identical in the program calling
c     geo2mathv or math2geov.  They are related by
c
c          ug(j,nlat-i+1) =  wm(i,j)
c                                      (ig = 0)
c          vg(j,nlat-i+1) = -vm(i,j)
c
c     or
c
c          ug(j,i) =  wm(i,j)
c                                      (ig = 1)
c          vg(j,i) = -vm(i,j)
c
c
c     for i=1,...,nlat and j=1,...,nlon.  These formulas are not
c     used because ug,wm and vg,vm can be equivalenced or identical
c     arguments in the program calling math2geov or geo2mathv.
c
c     Let ib = nlat-i+1 for i=1,...,nlat.  Summarizing:
c     sg(j,i) or ug(j,i),vg(j,i) are values at (phi(j),lat(i)) if ig = 0
C*PL*ERROR* Comment line too long
c     sg(j,i) or ug(j,i),vg(j,i) are values at (phi(j),lat(ib)) if ig = 1
c     sm(i,j) or vm(i,j),wm(i,j) are values at (colat(i),phi(j))
c
c ... work is an unsaved real work space of length at least nlon*nlat
C*PL*ERROR* Comment line too long
c     in the routine calling (1),(2),(3), or (4).  It is used to simplify
c     a nonsquare array transposition in case it is required.
c
c *** example (1)
c
C*PL*ERROR* Comment line too long
c     suppose you wish to compute the divergence of (ug,vg) on a Gaussian
C*PL*ERROR* Comment line too long
c     grid in geophysical coordinates using the stored Legendre polynomial
c     routines on SPHEREPACK 2.0.
c
c     (1) call geo2mathv to set vm,wm from ug,vg
c
C*PL*ERROR* Comment line too long
c     (2) call vhags to compute the vector harmonic coefficients of vm,wm
c
C*PL*ERROR* Comment line too long
c     (3) call divgs with the coefficients from (2) to compute the divergence
c         dv in mathematical spherical coordinates on the UNIT sphere.
c
c     (4) call math2geos to convert the scalar divergence dv back to
c         geophysical spherical coordinates.
c
c     (5) divide dv by R (the radius of the earth) to compute divergence
c         on the earth (scaling from unit sphere computation in (3)).
c
c *** example (2)
c
c     suppose you wish to compute a vector field (ug,vg) corresponding
c     to  a given divergence dvg and vorticity vtg (all in geophysical
c     coordinates) on an equally spaced (co)latitude grid using the
c     computed Legendre polynomial software.
c
c     (1) call geo2maths to set dvm from dvg
c
c     (2) call geo2maths to set vtm from vts
c
c     (3) call shaec to compute the scalar harmonic coefficients of dvm
c
c     (4) call shaec to compute the scalar harmonic coefficients of vtm
c
C*PL*ERROR* Comment line too long
c     (5) call idvtec to compute (vm,wm) using the coefficients from (3),(4).
c
c     (6) call math2geov to set (ug,vg) from (vm,wm)
c
c     (7) multiply (ug,vg) by the earth's radius R for scaling
c         from the unit sphere computation in (5)
c
c *** END OF DOCUMENTATION ... CODE FOLLOWS:
c
c
      SUBROUTINE DGEO2MATHS(IG,NLON,NLAT,SG,SM,WORK)
      IMPLICIT NONE
      INTEGER IG,NLON,NLAT,I,J,IJ
      DOUBLE PRECISION SG(NLON,NLAT),SM(NLAT,NLON),WORK(*)
c
c     transpose sg into sm and reverse colatitude subscript order
c     if necessary
c
      DO I = 1,NLAT
          DO J = 1,NLON
              IJ = (J-1)*NLAT + I
              WORK(IJ) = SG(J,I)
          END DO
      END DO
      IF (IG.EQ.0) THEN
          DO I = 1,NLAT
              DO J = 1,NLON
                  IJ = (J-1)*NLAT + I
                  SM(NLAT-I+1,J) = WORK(IJ)
              END DO
          END DO
      ELSE
          DO I = 1,NLAT
              DO J = 1,NLON
                  IJ = (J-1)*NLAT + I
                  SM(I,J) = WORK(IJ)
              END DO
          END DO
      END IF
      RETURN
      END

      SUBROUTINE DMATH2GEOS(IG,NLAT,NLON,SM,SG,WORK)
      IMPLICIT NONE
      INTEGER IG,NLON,NLAT,I,J,IJ
      DOUBLE PRECISION SM(NLAT,NLON),SG(NLON,NLAT),WORK(*)
c
c     transpose sm into sg and reverse colatitude subscript order
c     if necessary
c
      DO I = 1,NLAT
          DO J = 1,NLON
              IJ = (J-1)*NLAT + I
              WORK(IJ) = SM(I,J)
          END DO
      END DO
      IF (IG.EQ.0) THEN
          DO I = 1,NLAT
              DO J = 1,NLON
                  IJ = (J-1)*NLAT + I
                  SG(J,NLAT-I+1) = WORK(IJ)
              END DO
          END DO
      ELSE
          DO I = 1,NLAT
              DO J = 1,NLON
                  IJ = (J-1)*NLAT + I
                  SG(J,I) = WORK(IJ)
              END DO
          END DO
      END IF
      RETURN
      END

      SUBROUTINE DGEO2MATHV(IG,NLON,NLAT,UG,VG,VM,WM,WORK)
      IMPLICIT NONE
      INTEGER IG,NLON,NLAT,I,J,IJ
      DOUBLE PRECISION UG(NLON,NLAT),VG(NLON,NLAT),WORK(*)
      DOUBLE PRECISION VM(NLAT,NLON),WM(NLAT,NLON)
c
c     convert vg to vm, ug to wm
c
      IF (IG.EQ.0) THEN
          DO I = 1,NLAT
              DO J = 1,NLON
                  IJ = (J-1)*NLAT + I
                  WORK(IJ) = VG(J,I)
              END DO
          END DO
          DO I = 1,NLAT
              DO J = 1,NLON
                  IJ = (J-1)*NLAT + I
                  VM(NLAT-I+1,J) = -WORK(IJ)
              END DO
          END DO
          DO I = 1,NLAT
              DO J = 1,NLON
                  IJ = (J-1)*NLAT + I
                  WORK(IJ) = UG(J,I)
              END DO
          END DO
          DO I = 1,NLAT
              DO J = 1,NLON
                  IJ = (J-1)*NLAT + I
                  WM(NLAT-I+1,J) = WORK(IJ)
              END DO
          END DO
      ELSE
          DO I = 1,NLAT
              DO J = 1,NLON
                  IJ = (J-1)*NLAT + I
                  WORK(IJ) = VG(J,I)
              END DO
          END DO
          DO I = 1,NLAT
              DO J = 1,NLON
                  IJ = (J-1)*NLAT + I
                  VM(I,J) = -WORK(IJ)
              END DO
          END DO
          DO I = 1,NLAT
              DO J = 1,NLON
                  IJ = (J-1)*NLAT + I
                  WORK(IJ) = UG(J,I)
              END DO
          END DO
          DO I = 1,NLAT
              DO J = 1,NLON
                  IJ = (J-1)*NLAT + I
                  WM(I,J) = WORK(IJ)
              END DO
          END DO
      END IF
      RETURN
      END

      SUBROUTINE DMATH2GEOV(IG,NLAT,NLON,VM,WM,UG,VG,WORK)
      IMPLICIT NONE
      INTEGER IG,NLON,NLAT,I,J,IJ
      DOUBLE PRECISION VM(NLAT,NLON),WM(NLAT,NLON),WORK(*)
      DOUBLE PRECISION UG(NLON,NLAT),VG(NLON,NLAT)
c
c     convert vm to vg, wm to ug
c
      IF (IG.EQ.0) THEN
          DO I = 1,NLAT
              DO J = 1,NLON
                  IJ = (J-1)*NLAT + I
                  WORK(IJ) = VM(I,J)
              END DO
          END DO
          DO I = 1,NLAT
              DO J = 1,NLON
                  IJ = (J-1)*NLAT + I
                  VG(J,NLAT-I+1) = -WORK(IJ)
              END DO
          END DO
          DO I = 1,NLAT
              DO J = 1,NLON
                  IJ = (J-1)*NLAT + I
                  WORK(IJ) = WM(I,J)
              END DO
          END DO
          DO I = 1,NLAT
              DO J = 1,NLON
                  IJ = (J-1)*NLAT + I
                  UG(J,NLAT-I+1) = WORK(IJ)
              END DO
          END DO
      ELSE
          DO I = 1,NLAT
              DO J = 1,NLON
                  IJ = (J-1)*NLAT + I
                  WORK(IJ) = VM(I,J)
              END DO
          END DO
          DO I = 1,NLAT
              DO J = 1,NLON
                  IJ = (J-1)*NLAT + I
                  VG(J,I) = -WORK(IJ)
              END DO
          END DO
          DO I = 1,NLAT
              DO J = 1,NLON
                  IJ = (J-1)*NLAT + I
                  WORK(IJ) = WM(I,J)
              END DO
          END DO
          DO I = 1,NLAT
              DO J = 1,NLON
                  IJ = (J-1)*NLAT + I
                  UG(J,I) = WORK(IJ)
              END DO
          END DO
      END IF
      RETURN
      END

      SUBROUTINE DLAGTS( JOB, N, A, B, C, D, IN, Y, TOL, INFO )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     October 31, 1992
*
*     .. Scalar Arguments ..
      INTEGER            INFO, JOB, N
      DOUBLE PRECISION   TOL
*     ..
*     .. Array Arguments ..
      INTEGER            IN( * )
      DOUBLE PRECISION   A( * ), B( * ), C( * ), D( * ), Y( * )
*     ..
*
*  Purpose
*  =======
*
*  DLAGTS may be used to solve one of the systems of equations
*
*     (T - lambda*I)*x = y   or   (T - lambda*I)'*x = y,
*
*  where T is an n by n tridiagonal matrix, for x, following the
*  factorization of (T - lambda*I) as
*
*     (T - lambda*I) = P*L*U ,
*
*  by routine DLAGTF. The choice of equation to be solved is
*  controlled by the argument JOB, and in each case there is an option
*  to perturb zero or very small diagonal elements of U, this option
*  being intended for use in applications such as inverse iteration.
*
*  Arguments
*  =========
*
*  JOB     (input) INTEGER
*          Specifies the job to be performed by DLAGTS as follows:
*          =  1: The equations  (T - lambda*I)x = y  are to be solved,
*                but diagonal elements of U are not to be perturbed.
*          = -1: The equations  (T - lambda*I)x = y  are to be solved
*                and, if overflow would otherwise occur, the diagonal
*                elements of U are to be perturbed. See argument TOL
*                below.
*          =  2: The equations  (T - lambda*I)'x = y  are to be solved,
*                but diagonal elements of U are not to be perturbed.
*          = -2: The equations  (T - lambda*I)'x = y  are to be solved
*                and, if overflow would otherwise occur, the diagonal
*                elements of U are to be perturbed. See argument TOL
*                below.
*
*  N       (input) INTEGER
*          The order of the matrix T.
*
*  A       (input) DOUBLE PRECISION array, dimension (N)
*          On entry, A must contain the diagonal elements of U as
*          returned from DLAGTF.
*
*  B       (input) DOUBLE PRECISION array, dimension (N-1)
*          On entry, B must contain the first super-diagonal elements of
*          U as returned from DLAGTF.
*
*  C       (input) DOUBLE PRECISION array, dimension (N-1)
*          On entry, C must contain the sub-diagonal elements of L as
*          returned from DLAGTF.
*
*  D       (input) DOUBLE PRECISION array, dimension (N-2)
*          On entry, D must contain the second super-diagonal elements
*          of U as returned from DLAGTF.
*
*  IN      (input) INTEGER array, dimension (N)
*          On entry, IN must contain details of the matrix P as returned
*          from DLAGTF.
*
*  Y       (input/output) DOUBLE PRECISION array, dimension (N)
*          On entry, the right hand side vector y.
*          On exit, Y is overwritten by the solution vector x.
*
*  TOL     (input/output) DOUBLE PRECISION
*          On entry, with  JOB .lt. 0, TOL should be the minimum
*          perturbation to be made to very small diagonal elements of U.
*          TOL should normally be chosen as about eps*norm(U), where eps
*          is the relative machine precision, but if TOL is supplied as
*          non-positive, then it is reset to eps*max( abs( u(i,j) ) ).
*          If  JOB .gt. 0  then TOL is not referenced.
*
*          On exit, TOL is changed as described above, only if TOL is
*          non-positive on entry. Otherwise TOL is unchanged.
*
*  INFO    (output) INTEGER
*          = 0   : successful exit
*          .lt. 0: if INFO = -i, the i-th argument had an illegal value
*          .gt. 0: overflow would occur when computing the INFO(th)
*                  element of the solution vector x. This can only occur
*                  when JOB is supplied as positive and either means
*                  that a diagonal element of U is very small, or that
*                  the elements of the right-hand side vector y are very
*                  large.
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ONE, ZERO
      PARAMETER          ( ONE = 1.0D+0, ZERO = 0.0D+0 )
*     ..
*     .. Local Scalars ..
      INTEGER            K
      DOUBLE PRECISION   ABSAK, AK, BIGNUM, EPS, PERT, SFMIN, TEMP
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, MAX, SIGN
*     ..
*     .. External Functions ..
      DOUBLE PRECISION   DLAMCH
      EXTERNAL           DLAMCH
*     ..
*     .. External Subroutines ..
      EXTERNAL           XERBLA
*     ..
*     .. Executable Statements ..
*
      INFO = 0
      IF( ( ABS( JOB ).GT.2 ) .OR. ( JOB.EQ.0 ) ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DLAGTS', -INFO )
         RETURN
      END IF
*
      IF( N.EQ.0 )
     $   RETURN
*
      EPS = DLAMCH( 'Epsilon' )
      SFMIN = DLAMCH( 'Safe minimum' )
      BIGNUM = ONE / SFMIN
*
      IF( JOB.LT.0 ) THEN
         IF( TOL.LE.ZERO ) THEN
            TOL = ABS( A( 1 ) )
            IF( N.GT.1 )
     $         TOL = MAX( TOL, ABS( A( 2 ) ), ABS( B( 1 ) ) )
            DO 10 K = 3, N
               TOL = MAX( TOL, ABS( A( K ) ), ABS( B( K-1 ) ),
     $               ABS( D( K-2 ) ) )
   10       CONTINUE
            TOL = TOL*EPS
            IF( TOL.EQ.ZERO )
     $         TOL = EPS
         END IF
      END IF
*
      IF( ABS( JOB ).EQ.1 ) THEN
         DO 20 K = 2, N
            IF( IN( K-1 ).EQ.0 ) THEN
               Y( K ) = Y( K ) - C( K-1 )*Y( K-1 )
            ELSE
               TEMP = Y( K-1 )
               Y( K-1 ) = Y( K )
               Y( K ) = TEMP - C( K-1 )*Y( K )
            END IF
   20    CONTINUE
         IF( JOB.EQ.1 ) THEN
            DO 30 K = N, 1, -1
               IF( K.LE.N-2 ) THEN
                  TEMP = Y( K ) - B( K )*Y( K+1 ) - D( K )*Y( K+2 )
               ELSE IF( K.EQ.N-1 ) THEN
                  TEMP = Y( K ) - B( K )*Y( K+1 )
               ELSE
                  TEMP = Y( K )
               END IF
               AK = A( K )
               ABSAK = ABS( AK )
               IF( ABSAK.LT.ONE ) THEN
                  IF( ABSAK.LT.SFMIN ) THEN
                     IF( ABSAK.EQ.ZERO .OR. ABS( TEMP )*SFMIN.GT.ABSAK )
     $                    THEN
                        INFO = K
                        RETURN
                     ELSE
                        TEMP = TEMP*BIGNUM
                        AK = AK*BIGNUM
                     END IF
                  ELSE IF( ABS( TEMP ).GT.ABSAK*BIGNUM ) THEN
                     INFO = K
                     RETURN
                  END IF
               END IF
               Y( K ) = TEMP / AK
   30       CONTINUE
         ELSE
            DO 50 K = N, 1, -1
               IF( K.LE.N-2 ) THEN
                  TEMP = Y( K ) - B( K )*Y( K+1 ) - D( K )*Y( K+2 )
               ELSE IF( K.EQ.N-1 ) THEN
                  TEMP = Y( K ) - B( K )*Y( K+1 )
               ELSE
                  TEMP = Y( K )
               END IF
               AK = A( K )
               PERT = SIGN( TOL, AK )
   40          CONTINUE
               ABSAK = ABS( AK )
               IF( ABSAK.LT.ONE ) THEN
                  IF( ABSAK.LT.SFMIN ) THEN
                     IF( ABSAK.EQ.ZERO .OR. ABS( TEMP )*SFMIN.GT.ABSAK )
     $                    THEN
                        AK = AK + PERT
                        PERT = 2*PERT
                        GO TO 40
                     ELSE
                        TEMP = TEMP*BIGNUM
                        AK = AK*BIGNUM
                     END IF
                  ELSE IF( ABS( TEMP ).GT.ABSAK*BIGNUM ) THEN
                     AK = AK + PERT
                     PERT = 2*PERT
                     GO TO 40
                  END IF
               END IF
               Y( K ) = TEMP / AK
   50       CONTINUE
         END IF
      ELSE
*
*        Come to here if  JOB = 2 or -2
*
         IF( JOB.EQ.2 ) THEN
            DO 60 K = 1, N
               IF( K.GE.3 ) THEN
                  TEMP = Y( K ) - B( K-1 )*Y( K-1 ) - D( K-2 )*Y( K-2 )
               ELSE IF( K.EQ.2 ) THEN
                  TEMP = Y( K ) - B( K-1 )*Y( K-1 )
               ELSE
                  TEMP = Y( K )
               END IF
               AK = A( K )
               ABSAK = ABS( AK )
               IF( ABSAK.LT.ONE ) THEN
                  IF( ABSAK.LT.SFMIN ) THEN
                     IF( ABSAK.EQ.ZERO .OR. ABS( TEMP )*SFMIN.GT.ABSAK )
     $                    THEN
                        INFO = K
                        RETURN
                     ELSE
                        TEMP = TEMP*BIGNUM
                        AK = AK*BIGNUM
                     END IF
                  ELSE IF( ABS( TEMP ).GT.ABSAK*BIGNUM ) THEN
                     INFO = K
                     RETURN
                  END IF
               END IF
               Y( K ) = TEMP / AK
   60       CONTINUE
         ELSE
            DO 80 K = 1, N
               IF( K.GE.3 ) THEN
                  TEMP = Y( K ) - B( K-1 )*Y( K-1 ) - D( K-2 )*Y( K-2 )
               ELSE IF( K.EQ.2 ) THEN
                  TEMP = Y( K ) - B( K-1 )*Y( K-1 )
               ELSE
                  TEMP = Y( K )
               END IF
               AK = A( K )
               PERT = SIGN( TOL, AK )
   70          CONTINUE
               ABSAK = ABS( AK )
               IF( ABSAK.LT.ONE ) THEN
                  IF( ABSAK.LT.SFMIN ) THEN
                     IF( ABSAK.EQ.ZERO .OR. ABS( TEMP )*SFMIN.GT.ABSAK )
     $                    THEN
                        AK = AK + PERT
                        PERT = 2*PERT
                        GO TO 70
                     ELSE
                        TEMP = TEMP*BIGNUM
                        AK = AK*BIGNUM
                     END IF
                  ELSE IF( ABS( TEMP ).GT.ABSAK*BIGNUM ) THEN
                     AK = AK + PERT
                     PERT = 2*PERT
                     GO TO 70
                  END IF
               END IF
               Y( K ) = TEMP / AK
   80       CONTINUE
         END IF
*
         DO 90 K = N, 2, -1
            IF( IN( K-1 ).EQ.0 ) THEN
               Y( K-1 ) = Y( K-1 ) - C( K-1 )*Y( K )
            ELSE
               TEMP = Y( K-1 )
               Y( K-1 ) = Y( K )
               Y( K ) = TEMP - C( K-1 )*Y( K )
            END IF
   90    CONTINUE
      END IF
*
*     End of DLAGTS
*
      END

C
C	$Id: gschup.f,v 1.7 2009-04-08 23:18:21 fred Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GSCHUP (CHUX,CHUY)
C
C  SET CHARACTER UP VECTOR
C
      INTEGER ESCHUP
      PARAMETER (ESCHUP=32)
C
      include 'gkscom.h'
C
      REAL CHUX,CHUY
C
C  Check if GKS is in the proper state.
C
      CALL GZCKST(8,ESCHUP,IER)
      IF (IER .NE. 0) RETURN
C
C  Check that the vector is non-zero.
C
      IF (CHUX.EQ.0.AND.CHUY.EQ.0) THEN
        ERS = 1
        CALL GERHND(79,ESCHUP,ERF)
        ERS = 0
        RETURN
      ENDIF
C
C  Set the current character up vector in the GKS state list.
C  (This vector remains in world coordinates here).
C
      CCHUP(1) = CHUX
      CCHUP(2) = CHUY
C
C  Invoke the workstation interface.  Two real vectors are
C  passed through the interface.  The first vector is
C  passed via (RX(1),RY(1)) and is a vector parallel to the
C  current character up vector with length equal to the
C  recently defined character height (the character height
C  having been transformed to NDC space).  The second vector
C  is passed via (RX(2),RY(2)) and is a vector parallel to
C  the character base vector scaled in accordance with the
C  appropriate aspect ratio.
C
      FCODE = 34
      CONT  = 0
      CALL GZROI(0)
      RL1   = 2
      RL2   = 2
      SCL = 1./SQRT(CCHUP(1)*CCHUP(1)+CCHUP(2)*CCHUP(2))
C
C  Construct a vector (XP,YP) that is parallel to the up vector
C  and has height equal to the character height.
C
      XP = CCHH*SCL*CCHUP(1)
      YP = CCHH*SCL*CCHUP(2)
C
C  Construct a base vector perpendicular to the height vector.
C
      XB =  YP
      YB = -XP
 
C
C  Transform the height and base vectors using the current normalization
C  transformation.
C
      CALL GZW2NX(1,XP,XTMP)
      CALL GZW2NY(1,YP,YTMP)
      CALL GZW2NX(1,0.,ZXTMP)
      CALL GZW2NY(1,0.,ZYTMP)
      RX(1) = XTMP-ZXTMP 
      RY(1) = YTMP-ZYTMP 
C
C  If the character height transformed to NDC is large, reduce it
C  to avoid possible overflow.
C
      IF (ABS(RX(1)).GT.1000. .OR. ABS(RY(1)).GT.1000.) THEN
        AMX = MAX(ABS(RX(1)),ABS(RY(1)))
        RX(1) = 1.E5*RX(1)/AMX
        RY(1) = 1.E5*RY(1)/AMX
      ENDIF
      CALL GZW2NX(1,XB,XTMP)
      CALL GZW2NY(1,YB,YTMP)
      RX(2) = XTMP-ZXTMP 
      RY(2) = YTMP-ZYTMP 
      IF (ABS(RX(2)).GT.1000. .OR. ABS(RY(2)).GT.1000.) THEN
        AMX = MAX(ABS(RX(2)),ABS(RY(2)))
        RX(2) = 1.E5*RX(2)/AMX
        RY(2) = 1.E5*RY(2)/AMX
      ENDIF
C
      CALL GZTOWK
      IF (RERR.NE.0) THEN
        ERS = 1
        CALL GERHND(RERR,ESCHUP,ERF)
        ERS = 0
      ENDIF
C
      RETURN
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C   FFTPACK 5.0
C   Copyright (C) 1995-2004, Scientific Computing Division,
C   University Corporation for Atmospheric Research
C   Licensed under the GNU General Public License (GPL)
C
C   Authors:  Paul N. Swarztrauber and Richard A. Valent
C
C   $Id: cmf5kb.f,v 1.2 2006-11-21 01:10:16 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      SUBROUTINE DCMF5KB(LOT,IDO,L1,NA,CC,IM1,IN1,CH,IM2,IN2,WA)
      DOUBLE PRECISION TR11
      DOUBLE PRECISION TI11
      DOUBLE PRECISION TR12
      DOUBLE PRECISION TI12
      DOUBLE PRECISION TI5
      DOUBLE PRECISION TI2
      DOUBLE PRECISION TI4
      DOUBLE PRECISION TI3
      DOUBLE PRECISION TR5
      DOUBLE PRECISION TR2
      DOUBLE PRECISION TR4
      DOUBLE PRECISION TR3
      DOUBLE PRECISION CHOLD1
      DOUBLE PRECISION CHOLD2
      DOUBLE PRECISION CR2
      DOUBLE PRECISION CI2
      DOUBLE PRECISION CR3
      DOUBLE PRECISION CI3
      DOUBLE PRECISION CR5
      DOUBLE PRECISION CI5
      DOUBLE PRECISION CR4
      DOUBLE PRECISION CI4
      DOUBLE PRECISION DR3
      DOUBLE PRECISION DR4
      DOUBLE PRECISION DI3
      DOUBLE PRECISION DI4
      DOUBLE PRECISION DR5
      DOUBLE PRECISION DR2
      DOUBLE PRECISION DI5
      DOUBLE PRECISION DI2
      DOUBLE PRECISION CC(2,IN1,L1,IDO,5),CH(2,IN2,L1,5,IDO),WA(IDO,4,2)
      DATA TR11,TI11,TR12,TI12/.3090169943749474D0,.9510565162951536D0,
     +     -.8090169943749474D0,.5877852522924731D0/
C
C FFTPACK 5.0 auxiliary routine
C
      M1D = (LOT-1)*IM1 + 1
      M2S = 1 - IM2
      IF (IDO.GT.1 .OR. NA.EQ.1) GO TO 102
      DO 101 K = 1,L1
          DO 101 M1 = 1,M1D,IM1
              TI5 = CC(2,M1,K,1,2) - CC(2,M1,K,1,5)
              TI2 = CC(2,M1,K,1,2) + CC(2,M1,K,1,5)
              TI4 = CC(2,M1,K,1,3) - CC(2,M1,K,1,4)
              TI3 = CC(2,M1,K,1,3) + CC(2,M1,K,1,4)
              TR5 = CC(1,M1,K,1,2) - CC(1,M1,K,1,5)
              TR2 = CC(1,M1,K,1,2) + CC(1,M1,K,1,5)
              TR4 = CC(1,M1,K,1,3) - CC(1,M1,K,1,4)
              TR3 = CC(1,M1,K,1,3) + CC(1,M1,K,1,4)
              CHOLD1 = CC(1,M1,K,1,1) + TR2 + TR3
              CHOLD2 = CC(2,M1,K,1,1) + TI2 + TI3
              CR2 = CC(1,M1,K,1,1) + TR11*TR2 + TR12*TR3
              CI2 = CC(2,M1,K,1,1) + TR11*TI2 + TR12*TI3
              CR3 = CC(1,M1,K,1,1) + TR12*TR2 + TR11*TR3
              CI3 = CC(2,M1,K,1,1) + TR12*TI2 + TR11*TI3
              CC(1,M1,K,1,1) = CHOLD1
              CC(2,M1,K,1,1) = CHOLD2
              CR5 = TI11*TR5 + TI12*TR4
              CI5 = TI11*TI5 + TI12*TI4
              CR4 = TI12*TR5 - TI11*TR4
              CI4 = TI12*TI5 - TI11*TI4
              CC(1,M1,K,1,2) = CR2 - CI5
              CC(1,M1,K,1,5) = CR2 + CI5
              CC(2,M1,K,1,2) = CI2 + CR5
              CC(2,M1,K,1,3) = CI3 + CR4
              CC(1,M1,K,1,3) = CR3 - CI4
              CC(1,M1,K,1,4) = CR3 + CI4
              CC(2,M1,K,1,4) = CI3 - CR4
              CC(2,M1,K,1,5) = CI2 - CR5
  101 CONTINUE
      RETURN
  102 DO 103 K = 1,L1
          M2 = M2S
          DO 103 M1 = 1,M1D,IM1
              M2 = M2 + IM2
              TI5 = CC(2,M1,K,1,2) - CC(2,M1,K,1,5)
              TI2 = CC(2,M1,K,1,2) + CC(2,M1,K,1,5)
              TI4 = CC(2,M1,K,1,3) - CC(2,M1,K,1,4)
              TI3 = CC(2,M1,K,1,3) + CC(2,M1,K,1,4)
              TR5 = CC(1,M1,K,1,2) - CC(1,M1,K,1,5)
              TR2 = CC(1,M1,K,1,2) + CC(1,M1,K,1,5)
              TR4 = CC(1,M1,K,1,3) - CC(1,M1,K,1,4)
              TR3 = CC(1,M1,K,1,3) + CC(1,M1,K,1,4)
              CH(1,M2,K,1,1) = CC(1,M1,K,1,1) + TR2 + TR3
              CH(2,M2,K,1,1) = CC(2,M1,K,1,1) + TI2 + TI3
              CR2 = CC(1,M1,K,1,1) + TR11*TR2 + TR12*TR3
              CI2 = CC(2,M1,K,1,1) + TR11*TI2 + TR12*TI3
              CR3 = CC(1,M1,K,1,1) + TR12*TR2 + TR11*TR3
              CI3 = CC(2,M1,K,1,1) + TR12*TI2 + TR11*TI3
              CR5 = TI11*TR5 + TI12*TR4
              CI5 = TI11*TI5 + TI12*TI4
              CR4 = TI12*TR5 - TI11*TR4
              CI4 = TI12*TI5 - TI11*TI4
              CH(1,M2,K,2,1) = CR2 - CI5
              CH(1,M2,K,5,1) = CR2 + CI5
              CH(2,M2,K,2,1) = CI2 + CR5
              CH(2,M2,K,3,1) = CI3 + CR4
              CH(1,M2,K,3,1) = CR3 - CI4
              CH(1,M2,K,4,1) = CR3 + CI4
              CH(2,M2,K,4,1) = CI3 - CR4
              CH(2,M2,K,5,1) = CI2 - CR5
  103 CONTINUE
      IF (IDO.EQ.1) RETURN
      DO 105 I = 2,IDO
          DO 104 K = 1,L1
              M2 = M2S
              DO 104 M1 = 1,M1D,IM1
                  M2 = M2 + IM2
                  TI5 = CC(2,M1,K,I,2) - CC(2,M1,K,I,5)
                  TI2 = CC(2,M1,K,I,2) + CC(2,M1,K,I,5)
                  TI4 = CC(2,M1,K,I,3) - CC(2,M1,K,I,4)
                  TI3 = CC(2,M1,K,I,3) + CC(2,M1,K,I,4)
                  TR5 = CC(1,M1,K,I,2) - CC(1,M1,K,I,5)
                  TR2 = CC(1,M1,K,I,2) + CC(1,M1,K,I,5)
                  TR4 = CC(1,M1,K,I,3) - CC(1,M1,K,I,4)
                  TR3 = CC(1,M1,K,I,3) + CC(1,M1,K,I,4)
                  CH(1,M2,K,1,I) = CC(1,M1,K,I,1) + TR2 + TR3
                  CH(2,M2,K,1,I) = CC(2,M1,K,I,1) + TI2 + TI3
                  CR2 = CC(1,M1,K,I,1) + TR11*TR2 + TR12*TR3
                  CI2 = CC(2,M1,K,I,1) + TR11*TI2 + TR12*TI3
                  CR3 = CC(1,M1,K,I,1) + TR12*TR2 + TR11*TR3
                  CI3 = CC(2,M1,K,I,1) + TR12*TI2 + TR11*TI3
                  CR5 = TI11*TR5 + TI12*TR4
                  CI5 = TI11*TI5 + TI12*TI4
                  CR4 = TI12*TR5 - TI11*TR4
                  CI4 = TI12*TI5 - TI11*TI4
                  DR3 = CR3 - CI4
                  DR4 = CR3 + CI4
                  DI3 = CI3 + CR4
                  DI4 = CI3 - CR4
                  DR5 = CR2 + CI5
                  DR2 = CR2 - CI5
                  DI5 = CI2 - CR5
                  DI2 = CI2 + CR5
                  CH(1,M2,K,2,I) = WA(I,1,1)*DR2 - WA(I,1,2)*DI2
                  CH(2,M2,K,2,I) = WA(I,1,1)*DI2 + WA(I,1,2)*DR2
                  CH(1,M2,K,3,I) = WA(I,2,1)*DR3 - WA(I,2,2)*DI3
                  CH(2,M2,K,3,I) = WA(I,2,1)*DI3 + WA(I,2,2)*DR3
                  CH(1,M2,K,4,I) = WA(I,3,1)*DR4 - WA(I,3,2)*DI4
                  CH(2,M2,K,4,I) = WA(I,3,1)*DI4 + WA(I,3,2)*DR4
                  CH(1,M2,K,5,I) = WA(I,4,1)*DR5 - WA(I,4,2)*DI5
                  CH(2,M2,K,5,I) = WA(I,4,1)*DI5 + WA(I,4,2)*DR5
  104     CONTINUE
  105 CONTINUE
      RETURN
      END

      PROGRAM TAREAS
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C OPEN GKS, OPEN WORKSTATION OF TYPE 1, ACTIVATE WORKSTATION
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C INVOKE DEMO DRIVER
C
      CALL AREAS(IERR,IWKID)
C
C DEACTIVATE AND CLOSE WORKSTATION, CLOSE GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END
C
      SUBROUTINE AREAS (IERROR, IWKID)
C
C PURPOSE                To provide a simple demonstration of the use
C                        of AREAS.
C
C USAGE                  CALL AREAS (IERROR)
C
C ARGUMENTS
C
C ON OUTPUT              IERROR
C
C                          an error parameter
C                          = 0, if the test is successful,
C                          = 1, otherwise
C
C I/O                    If the test is successful, the message
C
C                          AREAS TEST EXECUTED--SEE PLOTS TO CERTIFY
C
C                        is written on unit 6.
C
C PRECISION              Single.
C
C REQUIRED LIBRARY       AREAS, SPPS
C FILES
C
C REQUIRED GKS LEVEL     0A
C
C LANGUAGE               FORTRAN
C
C HISTORY                Written in JUNE, 1987.
C
C ALGORITHM              TAREAS constructs and colors a very simple
C                        picture illustrating the use of all of the
C                        routines in the package.
C
C PORTABILITY            FORTRAN 77
C
C Define an array in which to construct the area map.
C
        DIMENSION IAM(5000)
C
C Define the arrays needed for edge-coordinate data.
C
        DIMENSION XCA(73),YCA(73)
C
C Dimension the arrays needed by ARSCAM and ARDRLN for X/Y coordinates.
C
        DIMENSION XCS(150),YCS(150)
C
C Dimension the arrays needed by ARSCAM and ARDRLN for area and group
C identifiers.
C
        DIMENSION IAI(2),IAG(2)
C
C Define the RGB color triples needed below.
C
        DIMENSION RGB(3,15)
C
C Define a set of indices to order the colors.
C
        DIMENSION IOC(15)
C
C Define an array for GKS aspect source flags.
C
        DIMENSION IF(13)
C
C Declare the routine which will color the areas.
C
        EXTERNAL COLRAM
C
C Declare the routine which will draw lines over the circle.
C
        EXTERNAL COLRLN
C
        DATA RGB / 0.70 , 0.70 , 0.70 ,
     +             0.75 , 0.50 , 1.00 ,
     +             0.50 , 0.00 , 1.00 ,
     +             0.00 , 0.00 , 1.00 ,
     +             0.00 , 0.50 , 1.00 ,
     +             0.00 , 1.00 , 1.00 ,
     +             0.00 , 1.00 , 0.60 ,
     +             0.00 , 1.00 , 0.00 ,
     +             0.70 , 1.00 , 0.00 ,
     +             1.00 , 1.00 , 0.00 ,
     +             1.00 , 0.75 , 0.00 ,
     +             1.00 , 0.38 , 0.38 ,
     +             1.00 , 0.00 , 0.38 ,
     +             1.00 , 0.00 , 0.00 ,
     +             1.00 , 1.00 , 1.00 /
        DATA IOC / 6,2,5,12,10,11,1,3,4,8,9,7,13,14,15 /
C
C Declare the constant for converting from degrees to radians.
C
        DATA DTR / .017453292519943 /
C
C Set the aspect source flags for FILL AREA INTERIOR STYLE and for
C FILL AREA STYLE INDEX to "individual".
C
        CALL GQASF (IE,IF)
        IF(11)=1
        IF(12)=1
        CALL GSASF (IF)
C
C Force solid fill.
C
        CALL GSFAIS (1)
C
C Define 15 different color indices.
C
        CALL GSCR(IWKID,0,0.,0.,0.)
        DO 101 J=1,15
          I=IOC(J)
          CALL GSCR(IWKID,J,RGB(1,I),RGB(2,I),RGB(3,I))
  101   CONTINUE
C
C Initialize the area map.
C
        CALL ARINAM (IAM,5000)
C
C Add edges to the area map.
C
        CALL SET (.01,.99,.01,.99,-1.,1.,-1.,1.,1)
C
C First, define a circle, using group 1 edges.  After this step, the
C area inside the circle has area identifier zero and the area outside
C has area identifier -1.
C
        DO 102 ING=1,73
        ANG=DTR*REAL(5*(ING-1))
        XCA(ING)=COS(ANG)
        YCA(ING)=SIN(ANG)
  102   CONTINUE
        CALL AREDAM (IAM,XCA,YCA,73,1,0,-1)
C
C Add lines splitting the circle into wedges.  The area identifiers
C for the wedges are added to the area map with this step.
C
        XCA(1)=0.
        YCA(1)=0.
        DO 103 ING=1,15
          ANG=DTR*REAL(24*(ING-1))
          XCA(2)=COS(ANG)
          YCA(2)=SIN(ANG)
          CALL AREDAM (IAM,XCA,YCA,2,1,ING,MOD(ING+13,15)+1)
  103   CONTINUE
C
C Now, put in another, smaller, off-center circle, using a group 2
C edge.  The interior of the circle has area identifier 1 and the
C exterior of the circle has group identifier 2.
C
        DO 104 ING=1,73
        ANG=DTR*REAL(5*(ING-1))
        XCA(ING)=.25+.5*COS(ANG)
        YCA(ING)=.25+.5*SIN(ANG)
  104   CONTINUE
        CALL AREDAM (IAM,XCA,YCA,73,2,1,2)
C
C Pre-process the area map.
C
        CALL ARPRAM (IAM,0,0,0)
C
C Compute and print the amount of space used in the area map.
C
        ISU=5000-(IAM(6)-IAM(5)-1)
        PRINT * , 'SPACE USED IN AREA MAP IS ',ISU
C
C Color the areas defined.
C
        CALL ARSCAM (IAM,XCS,YCS,150,IAI,IAG,2,COLRAM)
C
C In contrasting colors, draw three stars on the plot.
C
        DO 105 I=1,3
          IF (I.EQ.1) THEN
            XCN=-.5
            YCN=+.5
          ELSE IF (I.EQ.2) THEN
            XCN=-.5
            YCN=-.5
          ELSE IF (I.EQ.3) THEN
            XCN=+.5
            YCN=-.5
          END IF
          XCA(1)=XCN+.25*COS( 162.*DTR)
          YCA(1)=YCN+.25*SIN( 162.*DTR)
          XCA(2)=XCN+.25*COS(  18.*DTR)
          YCA(2)=YCN+.25*SIN(  18.*DTR)
          XCA(3)=XCN+.25*COS(-126.*DTR)
          YCA(3)=YCN+.25*SIN(-126.*DTR)
          XCA(4)=XCN+.25*COS(  90.*DTR)
          YCA(4)=YCN+.25*SIN(  90.*DTR)
          XCA(5)=XCN+.25*COS( -54.*DTR)
          YCA(5)=YCN+.25*SIN( -54.*DTR)
          XCA(6)=XCN+.25*COS( 162.*DTR)
          YCA(6)=YCN+.25*SIN( 162.*DTR)
          CALL ARDRLN (IAM,XCA,YCA,6,XCS,YCS,150,IAI,IAG,2,COLRLN)
  105   CONTINUE
C
C Draw a spiral of points in the blanked-out circle, using the colors
C from edge group 1.
C
        ICF=1
        DO 108 ING=1,1500
          RAD=REAL(ING)/1000.
          ANG=DTR*REAL(ING-1)
          XCD=.25+.5*RAD*COS(ANG)
          YCD=.25+.5*RAD*SIN(ANG)
          CALL ARGTAI (IAM,XCD,YCD,IAI,IAG,2,NAI,ICF)
          ITM=1
          DO 106 I=1,NAI
            IF (IAI(I).LT.0) ITM=0
  106     CONTINUE
          IF (ITM.NE.0) THEN
            IT1=0
            IT2=0
            DO 107 I=1,NAI
              IF (IAG(I).EQ.1) IT1=IAI(I)
              IF (IAG(I).EQ.2) IT2=IAI(I)
  107       CONTINUE
            IF (IT1.GT.0.AND.IT2.EQ.1) THEN
C
C Flush PLOTIT's buffers and set polyline color index.
C
              CALL PLOTIT(0,0,0)
              CALL GSPLCI(IT1)
C
              CALL POINT (XCD,YCD)
            END IF
          END IF
          ICF=0
  108   CONTINUE
C
C Advance the frame.
C
        CALL FRAME
C
C Done.
C
        IERROR=0
        WRITE (6,1001)
C
        RETURN
C
 1001   FORMAT ('  AREAS TEST EXECUTED--SEE PLOTS TO CERTIFY')
C
      END
      SUBROUTINE COLRAM (XCS,YCS,NCS,IAI,IAG,NAI)
        DIMENSION XCS(*),YCS(*),IAI(*),IAG(*)
        ITM=1
        DO 101 I=1,NAI
          IF (IAI(I).LT.0) ITM=0
  101   CONTINUE
        IF (ITM.NE.0) THEN
          IT1=0
          DO 102 I=1,NAI
            IF (IAG(I).EQ.1) IT1=IAI(I)
            IF (IAG(I).EQ.2) IT2=IAI(I)
  102     CONTINUE
          IF (IT1.GT.0.AND.IT2.NE.1) THEN
C
C Set fill area color index.
C
            CALL GSFACI(IT1)
C
            CALL GFA (NCS-1,XCS,YCS)
          END IF
        END IF
        RETURN
      END
      SUBROUTINE COLRLN (XCS,YCS,NCS,IAI,IAG,NAI)
        DIMENSION XCS(*),YCS(*),IAI(*),IAG(*)
        ITM=1
        DO 101 I=1,NAI
          IF (IAI(I).LT.0) ITM=0
  101   CONTINUE
        IF (ITM.NE.0) THEN
          IT1=0
          IT2=0
          DO 102 I=1,NAI
            IF (IAG(I).EQ.1) IT1=IAI(I)
            IF (IAG(I).EQ.2) IT2=IAI(I)
  102     CONTINUE
          IF (IT1.GT.0.AND.IT2.NE.1) THEN
C
C Flush PLOTIT's buffers and set polyline color index.
C
            CALL PLOTIT(0,0,0)
            CALL GSPLCI(MOD(IT1+3,15)+1)
C
            CALL GPL (NCS,XCS,YCS)
          END IF
        END IF
        RETURN
      END

      SUBROUTINE DLALSA( ICOMPQ, SMLSIZ, N, NRHS, B, LDB, BX, LDBX, U,
     $                   LDU, VT, K, DIFL, DIFR, Z, POLES, GIVPTR,
     $                   GIVCOL, LDGCOL, PERM, GIVNUM, C, S, WORK,
     $                   IWORK, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      INTEGER            ICOMPQ, INFO, LDB, LDBX, LDGCOL, LDU, N, NRHS,
     $                   SMLSIZ
*     ..
*     .. Array Arguments ..
      INTEGER            GIVCOL( LDGCOL, * ), GIVPTR( * ), IWORK( * ),
     $                   K( * ), PERM( LDGCOL, * )
      DOUBLE PRECISION   B( LDB, * ), BX( LDBX, * ), C( * ),
     $                   DIFL( LDU, * ), DIFR( LDU, * ),
     $                   GIVNUM( LDU, * ), POLES( LDU, * ), S( * ),
     $                   U( LDU, * ), VT( LDU, * ), WORK( * ),
     $                   Z( LDU, * )
*     ..
*
*  Purpose
*  =======
*
*  DLALSA is an itermediate step in solving the least squares problem
*  by computing the SVD of the coefficient matrix in compact form (The
*  singular vectors are computed as products of simple orthorgonal
*  matrices.).
*
*  If ICOMPQ = 0, DLALSA applies the inverse of the left singular vector
*  matrix of an upper bidiagonal matrix to the right hand side; and if
*  ICOMPQ = 1, DLALSA applies the right singular vector matrix to the
*  right hand side. The singular vector matrices were generated in
*  compact form by DLALSA.
*
*  Arguments
*  =========
*
*
*  ICOMPQ (input) INTEGER
*         Specifies whether the left or the right singular vector
*         matrix is involved.
*         = 0: Left singular vector matrix
*         = 1: Right singular vector matrix
*
*  SMLSIZ (input) INTEGER
*         The maximum size of the subproblems at the bottom of the
*         computation tree.
*
*  N      (input) INTEGER
*         The row and column dimensions of the upper bidiagonal matrix.
*
*  NRHS   (input) INTEGER
*         The number of columns of B and BX. NRHS must be at least 1.
*
*  B      (input) DOUBLE PRECISION array, dimension ( LDB, NRHS )
*         On input, B contains the right hand sides of the least
*         squares problem in rows 1 through M. On output, B contains
*         the solution X in rows 1 through N.
*
*  LDB    (input) INTEGER
*         The leading dimension of B in the calling subprogram.
*         LDB must be at least max(1,MAX( M, N ) ).
*
*  BX     (output) DOUBLE PRECISION array, dimension ( LDBX, NRHS )
*         On exit, the result of applying the left or right singular
*         vector matrix to B.
*
*  LDBX   (input) INTEGER
*         The leading dimension of BX.
*
*  U      (input) DOUBLE PRECISION array, dimension ( LDU, SMLSIZ ).
*         On entry, U contains the left singular vector matrices of all
*         subproblems at the bottom level.
*
*  LDU    (input) INTEGER, LDU = > N.
*         The leading dimension of arrays U, VT, DIFL, DIFR,
*         POLES, GIVNUM, and Z.
*
*  VT     (input) DOUBLE PRECISION array, dimension ( LDU, SMLSIZ+1 ).
*         On entry, VT' contains the right singular vector matrices of
*         all subproblems at the bottom level.
*
*  K      (input) INTEGER array, dimension ( N ).
*
*  DIFL   (input) DOUBLE PRECISION array, dimension ( LDU, NLVL ).
*         where NLVL = INT(log_2 (N/(SMLSIZ+1))) + 1.
*
*  DIFR   (input) DOUBLE PRECISION array, dimension ( LDU, 2 * NLVL ).
*         On entry, DIFL(*, I) and DIFR(*, 2 * I -1) record
*         distances between singular values on the I-th level and
*         singular values on the (I -1)-th level, and DIFR(*, 2 * I)
*         record the normalizing factors of the right singular vectors
*         matrices of subproblems on I-th level.
*
*  Z      (input) DOUBLE PRECISION array, dimension ( LDU, NLVL ).
*         On entry, Z(1, I) contains the components of the deflation-
*         adjusted updating row vector for subproblems on the I-th
*         level.
*
*  POLES  (input) DOUBLE PRECISION array, dimension ( LDU, 2 * NLVL ).
*         On entry, POLES(*, 2 * I -1: 2 * I) contains the new and old
*         singular values involved in the secular equations on the I-th
*         level.
*
*  GIVPTR (input) INTEGER array, dimension ( N ).
*         On entry, GIVPTR( I ) records the number of Givens
*         rotations performed on the I-th problem on the computation
*         tree.
*
*  GIVCOL (input) INTEGER array, dimension ( LDGCOL, 2 * NLVL ).
*         On entry, for each I, GIVCOL(*, 2 * I - 1: 2 * I) records the
*         locations of Givens rotations performed on the I-th level on
*         the computation tree.
*
*  LDGCOL (input) INTEGER, LDGCOL = > N.
*         The leading dimension of arrays GIVCOL and PERM.
*
*  PERM   (input) INTEGER array, dimension ( LDGCOL, NLVL ).
*         On entry, PERM(*, I) records permutations done on the I-th
*         level of the computation tree.
*
*  GIVNUM (input) DOUBLE PRECISION array, dimension ( LDU, 2 * NLVL ).
*         On entry, GIVNUM(*, 2 *I -1 : 2 * I) records the C- and S-
*         values of Givens rotations performed on the I-th level on the
*         computation tree.
*
*  C      (input) DOUBLE PRECISION array, dimension ( N ).
*         On entry, if the I-th subproblem is not square,
*         C( I ) contains the C-value of a Givens rotation related to
*         the right null space of the I-th subproblem.
*
*  S      (input) DOUBLE PRECISION array, dimension ( N ).
*         On entry, if the I-th subproblem is not square,
*         S( I ) contains the S-value of a Givens rotation related to
*         the right null space of the I-th subproblem.
*
*  WORK   (workspace) DOUBLE PRECISION array.
*         The dimension must be at least N.
*
*  IWORK  (workspace) INTEGER array.
*         The dimension must be at least 3 * N
*
*  INFO   (output) INTEGER
*          = 0:  successful exit.
*          < 0:  if INFO = -i, the i-th argument had an illegal value.
*
*  Further Details
*  ===============
*
*  Based on contributions by
*     Ming Gu and Ren-Cang Li, Computer Science Division, University of
*       California at Berkeley, USA
*     Osni Marques, LBNL/NERSC, USA
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO, ONE
      PARAMETER          ( ZERO = 0.0D0, ONE = 1.0D0 )
*     ..
*     .. Local Scalars ..
      INTEGER            I, I1, IC, IM1, INODE, J, LF, LL, LVL, LVL2,
     $                   ND, NDB1, NDIML, NDIMR, NL, NLF, NLP1, NLVL,
     $                   NR, NRF, NRP1, SQRE
*     ..
*     .. External Subroutines ..
      EXTERNAL           DCOPY, DGEMM, DLALS0, DLASDT, XERBLA
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
*
      IF( ( ICOMPQ.LT.0 ) .OR. ( ICOMPQ.GT.1 ) ) THEN
         INFO = -1
      ELSE IF( SMLSIZ.LT.3 ) THEN
         INFO = -2
      ELSE IF( N.LT.SMLSIZ ) THEN
         INFO = -3
      ELSE IF( NRHS.LT.1 ) THEN
         INFO = -4
      ELSE IF( LDB.LT.N ) THEN
         INFO = -6
      ELSE IF( LDBX.LT.N ) THEN
         INFO = -8
      ELSE IF( LDU.LT.N ) THEN
         INFO = -10
      ELSE IF( LDGCOL.LT.N ) THEN
         INFO = -19
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DLALSA', -INFO )
         RETURN
      END IF
*
*     Book-keeping and  setting up the computation tree.
*
      INODE = 1
      NDIML = INODE + N
      NDIMR = NDIML + N
*
      CALL DLASDT( N, NLVL, ND, IWORK( INODE ), IWORK( NDIML ),
     $             IWORK( NDIMR ), SMLSIZ )
*
*     The following code applies back the left singular vector factors.
*     For applying back the right singular vector factors, go to 50.
*
      IF( ICOMPQ.EQ.1 ) THEN
         GO TO 50
      END IF
*
*     The nodes on the bottom level of the tree were solved
*     by DLASDQ. The corresponding left and right singular vector
*     matrices are in explicit form. First apply back the left
*     singular vector matrices.
*
      NDB1 = ( ND+1 ) / 2
      DO 10 I = NDB1, ND
*
*        IC : center row of each node
*        NL : number of rows of left  subproblem
*        NR : number of rows of right subproblem
*        NLF: starting row of the left   subproblem
*        NRF: starting row of the right  subproblem
*
         I1 = I - 1
         IC = IWORK( INODE+I1 )
         NL = IWORK( NDIML+I1 )
         NR = IWORK( NDIMR+I1 )
         NLF = IC - NL
         NRF = IC + 1
         CALL DGEMM( 'T', 'N', NL, NRHS, NL, ONE, U( NLF, 1 ), LDU,
     $               B( NLF, 1 ), LDB, ZERO, BX( NLF, 1 ), LDBX )
         CALL DGEMM( 'T', 'N', NR, NRHS, NR, ONE, U( NRF, 1 ), LDU,
     $               B( NRF, 1 ), LDB, ZERO, BX( NRF, 1 ), LDBX )
   10 CONTINUE
*
*     Next copy the rows of B that correspond to unchanged rows
*     in the bidiagonal matrix to BX.
*
      DO 20 I = 1, ND
         IC = IWORK( INODE+I-1 )
         CALL DCOPY( NRHS, B( IC, 1 ), LDB, BX( IC, 1 ), LDBX )
   20 CONTINUE
*
*     Finally go through the left singular vector matrices of all
*     the other subproblems bottom-up on the tree.
*
      J = 2**NLVL
      SQRE = 0
*
      DO 40 LVL = NLVL, 1, -1
         LVL2 = 2*LVL - 1
*
*        find the first node LF and last node LL on
*        the current level LVL
*
         IF( LVL.EQ.1 ) THEN
            LF = 1
            LL = 1
         ELSE
            LF = 2**( LVL-1 )
            LL = 2*LF - 1
         END IF
         DO 30 I = LF, LL
            IM1 = I - 1
            IC = IWORK( INODE+IM1 )
            NL = IWORK( NDIML+IM1 )
            NR = IWORK( NDIMR+IM1 )
            NLF = IC - NL
            NRF = IC + 1
            J = J - 1
            CALL DLALS0( ICOMPQ, NL, NR, SQRE, NRHS, BX( NLF, 1 ), LDBX,
     $                   B( NLF, 1 ), LDB, PERM( NLF, LVL ),
     $                   GIVPTR( J ), GIVCOL( NLF, LVL2 ), LDGCOL,
     $                   GIVNUM( NLF, LVL2 ), LDU, POLES( NLF, LVL2 ),
     $                   DIFL( NLF, LVL ), DIFR( NLF, LVL2 ),
     $                   Z( NLF, LVL ), K( J ), C( J ), S( J ), WORK,
     $                   INFO )
   30    CONTINUE
   40 CONTINUE
      GO TO 90
*
*     ICOMPQ = 1: applying back the right singular vector factors.
*
   50 CONTINUE
*
*     First now go through the right singular vector matrices of all
*     the tree nodes top-down.
*
      J = 0
      DO 70 LVL = 1, NLVL
         LVL2 = 2*LVL - 1
*
*        Find the first node LF and last node LL on
*        the current level LVL.
*
         IF( LVL.EQ.1 ) THEN
            LF = 1
            LL = 1
         ELSE
            LF = 2**( LVL-1 )
            LL = 2*LF - 1
         END IF
         DO 60 I = LL, LF, -1
            IM1 = I - 1
            IC = IWORK( INODE+IM1 )
            NL = IWORK( NDIML+IM1 )
            NR = IWORK( NDIMR+IM1 )
            NLF = IC - NL
            NRF = IC + 1
            IF( I.EQ.LL ) THEN
               SQRE = 0
            ELSE
               SQRE = 1
            END IF
            J = J + 1
            CALL DLALS0( ICOMPQ, NL, NR, SQRE, NRHS, B( NLF, 1 ), LDB,
     $                   BX( NLF, 1 ), LDBX, PERM( NLF, LVL ),
     $                   GIVPTR( J ), GIVCOL( NLF, LVL2 ), LDGCOL,
     $                   GIVNUM( NLF, LVL2 ), LDU, POLES( NLF, LVL2 ),
     $                   DIFL( NLF, LVL ), DIFR( NLF, LVL2 ),
     $                   Z( NLF, LVL ), K( J ), C( J ), S( J ), WORK,
     $                   INFO )
   60    CONTINUE
   70 CONTINUE
*
*     The nodes on the bottom level of the tree were solved
*     by DLASDQ. The corresponding right singular vector
*     matrices are in explicit form. Apply them back.
*
      NDB1 = ( ND+1 ) / 2
      DO 80 I = NDB1, ND
         I1 = I - 1
         IC = IWORK( INODE+I1 )
         NL = IWORK( NDIML+I1 )
         NR = IWORK( NDIMR+I1 )
         NLP1 = NL + 1
         IF( I.EQ.ND ) THEN
            NRP1 = NR
         ELSE
            NRP1 = NR + 1
         END IF
         NLF = IC - NL
         NRF = IC + 1
         CALL DGEMM( 'T', 'N', NLP1, NRHS, NLP1, ONE, VT( NLF, 1 ), LDU,
     $               B( NLF, 1 ), LDB, ZERO, BX( NLF, 1 ), LDBX )
         CALL DGEMM( 'T', 'N', NRP1, NRHS, NRP1, ONE, VT( NRF, 1 ), LDU,
     $               B( NRF, 1 ), LDB, ZERO, BX( NRF, 1 ), LDBX )
   80 CONTINUE
*
   90 CONTINUE
*
      RETURN
*
*     End of DLALSA
*
      END

C
C	$Id: curved.f,v 1.4 2008-07-27 00:23:02 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CURVED (X,Y,N)
      DIMENSION X(N),Y(N)
      SAVE
C
      CALL FRSTD (X(1),Y(1))
      DO 10 I=2,N
         CALL VECTD (X(I),Y(I))
   10 CONTINUE
      CALL LASTD
C
      RETURN
      END

      SUBROUTINE CGEES( JOBVS, SORT, SELECT, N, A, LDA, SDIM, W, VS,
     $                  LDVS, WORK, LWORK, RWORK, BWORK, INFO )
*
*  -- LAPACK driver routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          JOBVS, SORT
      INTEGER            INFO, LDA, LDVS, LWORK, N, SDIM
*     ..
*     .. Array Arguments ..
      LOGICAL            BWORK( * )
      REAL               RWORK( * )
      COMPLEX            A( LDA, * ), VS( LDVS, * ), W( * ), WORK( * )
*     ..
*     .. Function Arguments ..
      LOGICAL            SELECT
      EXTERNAL           SELECT
*     ..
*
*  Purpose
*  =======
*
*  CGEES computes for an N-by-N complex nonsymmetric matrix A, the
*  eigenvalues, the Schur form T, and, optionally, the matrix of Schur
*  vectors Z.  This gives the Schur factorization A = Z*T*(Z**H).
*
*  Optionally, it also orders the eigenvalues on the diagonal of the
*  Schur form so that selected eigenvalues are at the top left.
*  The leading columns of Z then form an orthonormal basis for the
*  invariant subspace corresponding to the selected eigenvalues.

*  A complex matrix is in Schur form if it is upper triangular.
*
*  Arguments
*  =========
*
*  JOBVS   (input) CHARACTER*1
*          = 'N': Schur vectors are not computed;
*          = 'V': Schur vectors are computed.
*
*  SORT    (input) CHARACTER*1
*          Specifies whether or not to order the eigenvalues on the
*          diagonal of the Schur form.
*          = 'N': Eigenvalues are not ordered:
*          = 'S': Eigenvalues are ordered (see SELECT).
*
*  SELECT  (input) LOGICAL FUNCTION of one COMPLEX argument
*          SELECT must be declared EXTERNAL in the calling subroutine.
*          If SORT = 'S', SELECT is used to select eigenvalues to order
*          to the top left of the Schur form.
*          IF SORT = 'N', SELECT is not referenced.
*          The eigenvalue W(j) is selected if SELECT(W(j)) is true.
*
*  N       (input) INTEGER
*          The order of the matrix A. N >= 0.
*
*  A       (input/output) COMPLEX array, dimension (LDA,N)
*          On entry, the N-by-N matrix A.
*          On exit, A has been overwritten by its Schur form T.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(1,N).
*
*  SDIM    (output) INTEGER
*          If SORT = 'N', SDIM = 0.
*          If SORT = 'S', SDIM = number of eigenvalues for which
*                         SELECT is true.
*
*  W       (output) COMPLEX array, dimension (N)
*          W contains the computed eigenvalues, in the same order that
*          they appear on the diagonal of the output Schur form T.
*
*  VS      (output) COMPLEX array, dimension (LDVS,N)
*          If JOBVS = 'V', VS contains the unitary matrix Z of Schur
*          vectors.
*          If JOBVS = 'N', VS is not referenced.
*
*  LDVS    (input) INTEGER
*          The leading dimension of the array VS.  LDVS >= 1; if
*          JOBVS = 'V', LDVS >= N.
*
*  WORK    (workspace/output) COMPLEX array, dimension (LWORK)
*          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*
*  LWORK   (input) INTEGER
*          The dimension of the array WORK.  LWORK >= max(1,2*N).
*          For good performance, LWORK must generally be larger.
*
*          If LWORK = -1, then a workspace query is assumed; the routine
*          only calculates the optimal size of the WORK array, returns
*          this value as the first entry of the WORK array, and no error
*          message related to LWORK is issued by XERBLA.
*
*  RWORK   (workspace) REAL array, dimension (N)
*
*  BWORK   (workspace) LOGICAL array, dimension (N)
*          Not referenced if SORT = 'N'.
*
*  INFO    (output) INTEGER
*          = 0: successful exit
*          < 0: if INFO = -i, the i-th argument had an illegal value.
*          > 0: if INFO = i, and i is
*               <= N:  the QR algorithm failed to compute all the
*                      eigenvalues; elements 1:ILO-1 and i+1:N of W
*                      contain those eigenvalues which have converged;
*                      if JOBVS = 'V', VS contains the matrix which
*                      reduces A to its partially converged Schur form.
*               = N+1: the eigenvalues could not be reordered because
*                      some eigenvalues were too close to separate (the
*                      problem is very ill-conditioned);
*               = N+2: after reordering, roundoff changed values of
*                      some complex eigenvalues so that leading
*                      eigenvalues in the Schur form no longer satisfy
*                      SELECT = .TRUE..  This could also be caused by
*                      underflow due to scaling.
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ZERO, ONE
      PARAMETER          ( ZERO = 0.0E0, ONE = 1.0E0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            LQUERY, SCALEA, WANTST, WANTVS
      INTEGER            HSWORK, I, IBAL, ICOND, IERR, IEVAL, IHI, ILO,
     $                   ITAU, IWRK, K, MAXB, MAXWRK, MINWRK
      REAL               ANRM, BIGNUM, CSCALE, EPS, S, SEP, SMLNUM
*     ..
*     .. Local Arrays ..
      REAL               DUM( 1 )
*     ..
*     .. External Subroutines ..
      EXTERNAL           CCOPY, CGEBAK, CGEBAL, CGEHRD, CHSEQR, CLACPY,
     $                   CLASCL, CTRSEN, CUNGHR, SLABAD, XERBLA
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            ILAENV
      REAL               CLANGE, SLAMCH
      EXTERNAL           LSAME, ILAENV, CLANGE, SLAMCH
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN, SQRT
*     ..
*     .. Executable Statements ..
*
*     Test the input arguments
*
      INFO = 0
      LQUERY = ( LWORK.EQ.-1 )
      WANTVS = LSAME( JOBVS, 'V' )
      WANTST = LSAME( SORT, 'S' )
      IF( ( .NOT.WANTVS ) .AND. ( .NOT.LSAME( JOBVS, 'N' ) ) ) THEN
         INFO = -1
      ELSE IF( ( .NOT.WANTST ) .AND. ( .NOT.LSAME( SORT, 'N' ) ) ) THEN
         INFO = -2
      ELSE IF( N.LT.0 ) THEN
         INFO = -4
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -6
      ELSE IF( LDVS.LT.1 .OR. ( WANTVS .AND. LDVS.LT.N ) ) THEN
         INFO = -10
      END IF
*
*     Compute workspace
*      (Note: Comments in the code beginning "Workspace:" describe the
*       minimal amount of workspace needed at that point in the code,
*       as well as the preferred amount for good performance.
*       CWorkspace refers to complex workspace, and RWorkspace to real
*       workspace. NB refers to the optimal block size for the
*       immediately following subroutine, as returned by ILAENV.
*       HSWORK refers to the workspace preferred by CHSEQR, as
*       calculated below. HSWORK is computed assuming ILO=1 and IHI=N,
*       the worst case.)
*
      MINWRK = 1
      IF( INFO.EQ.0 .AND. ( LWORK.GE.1 .OR. LQUERY ) ) THEN
         MAXWRK = N + N*ILAENV( 1, 'CGEHRD', ' ', N, 1, N, 0 )
         MINWRK = MAX( 1, 2*N )
         IF( .NOT.WANTVS ) THEN
            MAXB = MAX( ILAENV( 8, 'CHSEQR', 'SN', N, 1, N, -1 ), 2 )
            K = MIN( MAXB, N, MAX( 2, ILAENV( 4, 'CHSEQR', 'SN', N, 1,
     $          N, -1 ) ) )
            HSWORK = MAX( K*( K+2 ), 2*N )
            MAXWRK = MAX( MAXWRK, HSWORK, 1 )
         ELSE
            MAXWRK = MAX( MAXWRK, N+( N-1 )*
     $               ILAENV( 1, 'CUNGHR', ' ', N, 1, N, -1 ) )
            MAXB = MAX( ILAENV( 8, 'CHSEQR', 'EN', N, 1, N, -1 ), 2 )
            K = MIN( MAXB, N, MAX( 2, ILAENV( 4, 'CHSEQR', 'EN', N, 1,
     $          N, -1 ) ) )
            HSWORK = MAX( K*( K+2 ), 2*N )
            MAXWRK = MAX( MAXWRK, HSWORK, 1 )
         END IF
         WORK( 1 ) = MAXWRK
      END IF
      IF( LWORK.LT.MINWRK .AND. .NOT.LQUERY ) THEN
         INFO = -12
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'CGEES ', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 ) THEN
         SDIM = 0
         RETURN
      END IF
*
*     Get machine constants
*
      EPS = SLAMCH( 'P' )
      SMLNUM = SLAMCH( 'S' )
      BIGNUM = ONE / SMLNUM
      CALL SLABAD( SMLNUM, BIGNUM )
      SMLNUM = SQRT( SMLNUM ) / EPS
      BIGNUM = ONE / SMLNUM
*
*     Scale A if max element outside range [SMLNUM,BIGNUM]
*
      ANRM = CLANGE( 'M', N, N, A, LDA, DUM )
      SCALEA = .FALSE.
      IF( ANRM.GT.ZERO .AND. ANRM.LT.SMLNUM ) THEN
         SCALEA = .TRUE.
         CSCALE = SMLNUM
      ELSE IF( ANRM.GT.BIGNUM ) THEN
         SCALEA = .TRUE.
         CSCALE = BIGNUM
      END IF
      IF( SCALEA )
     $   CALL CLASCL( 'G', 0, 0, ANRM, CSCALE, N, N, A, LDA, IERR )
*
*     Permute the matrix to make it more nearly triangular
*     (CWorkspace: none)
*     (RWorkspace: need N)
*
      IBAL = 1
      CALL CGEBAL( 'P', N, A, LDA, ILO, IHI, RWORK( IBAL ), IERR )
*
*     Reduce to upper Hessenberg form
*     (CWorkspace: need 2*N, prefer N+N*NB)
*     (RWorkspace: none)
*
      ITAU = 1
      IWRK = N + ITAU
      CALL CGEHRD( N, ILO, IHI, A, LDA, WORK( ITAU ), WORK( IWRK ),
     $             LWORK-IWRK+1, IERR )
*
      IF( WANTVS ) THEN
*
*        Copy Householder vectors to VS
*
         CALL CLACPY( 'L', N, N, A, LDA, VS, LDVS )
*
*        Generate unitary matrix in VS
*        (CWorkspace: need 2*N-1, prefer N+(N-1)*NB)
*        (RWorkspace: none)
*
         CALL CUNGHR( N, ILO, IHI, VS, LDVS, WORK( ITAU ), WORK( IWRK ),
     $                LWORK-IWRK+1, IERR )
      END IF
*
      SDIM = 0
*
*     Perform QR iteration, accumulating Schur vectors in VS if desired
*     (CWorkspace: need 1, prefer HSWORK (see comments) )
*     (RWorkspace: none)
*
      IWRK = ITAU
      CALL CHSEQR( 'S', JOBVS, N, ILO, IHI, A, LDA, W, VS, LDVS,
     $             WORK( IWRK ), LWORK-IWRK+1, IEVAL )
      IF( IEVAL.GT.0 )
     $   INFO = IEVAL
*
*     Sort eigenvalues if desired
*
      IF( WANTST .AND. INFO.EQ.0 ) THEN
         IF( SCALEA )
     $      CALL CLASCL( 'G', 0, 0, CSCALE, ANRM, N, 1, W, N, IERR )
         DO 10 I = 1, N
            BWORK( I ) = SELECT( W( I ) )
   10    CONTINUE
*
*        Reorder eigenvalues and transform Schur vectors
*        (CWorkspace: none)
*        (RWorkspace: none)
*
         CALL CTRSEN( 'N', JOBVS, BWORK, N, A, LDA, VS, LDVS, W, SDIM,
     $                S, SEP, WORK( IWRK ), LWORK-IWRK+1, ICOND )
      END IF
*
      IF( WANTVS ) THEN
*
*        Undo balancing
*        (CWorkspace: none)
*        (RWorkspace: need N)
*
         CALL CGEBAK( 'P', 'R', N, ILO, IHI, RWORK( IBAL ), N, VS, LDVS,
     $                IERR )
      END IF
*
      IF( SCALEA ) THEN
*
*        Undo scaling for the Schur form of A
*
         CALL CLASCL( 'U', 0, 0, CSCALE, ANRM, N, N, A, LDA, IERR )
         CALL CCOPY( N, A, LDA+1, W, 1 )
      END IF
*
      WORK( 1 ) = MAXWRK
      RETURN
*
*     End of CGEES
*
      END

C
C $Id: basic01f.f,v 1.14 2010-03-15 22:49:23 haley Exp $
C
C***********************************************************************
C                                                                      *
C                            Copyright (C)  1995                       *
C                 University Corporation for Atmospheric Research      *
C                            All Rights Reserved                       *
C                                                                      *
C***********************************************************************
C
C      File:            basic01f.f
C
C      Author:          Tim Scheitlin (converted by Ed Stautler)
C                       National Center for Atmospheric Research
C                       PO 3000, Boulder, Colorado
C
C      Date:            Mon Mar 20 10:43:42 MST 1995
C
C      Description:     This example demonstrates how to draw a contour
C                       plot using mostly defaults.  Note: no data is
C                       used in this example, so the output appears
C                       only as a bounding box with tickmarks.
C 
C                       The minimum set of steps needed for creating
C                       any plot involve the following:
C
C                       1. Initialize the graphics libraries
C                       2. Choose the type of output 
C                       3. Create a plot object
C                       4. Draw the plot
C                       5. Call frame
C                       6. Clean up memory
C
      program basic01f
      implicit none

      external NhlFAppClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFCairoWindowWorkstationClass
      external NhlFContourPlotClass

      integer appid,wks,con1,rlist,ierr

      character*7  wks_type
C
C Define the workstation type
C
      wks_type = "x11"
C
C ##########
C # STEP 1 #
C ##########
C Initialize the graphics libraries and create a resource list that
C is normally used to assign name/value pairs within objects.  Then
C clear (empty) this list, and create an application object.  This
C object manages multiple resource databases used by separate objects.  
C
C The first argument, appid, is a variable that identifies the object.
C The second argument, '"basic01"', sets the name of the object being
C created.
C The third argument, "NhlFAppClass", identifies the type or class 
C of the created object. 
C The fourth argument, "0", specifies the id of the objects parent.
C In this case, the object has no parent, so the value 0 is used. 
C The fifth argument, "rlist", is the resource list modifiers to be used
C when creating the object.  In this example, no modifications are made
C to default values.
C The sixth argument, "ierr", is used to return an error code.
C
      call NhlFInitialize
      call NhlFRLCreate(rlist,'SETRL')

      call NhlFRLClear(rlist)
      call NhlFCreate(appid,"basic01",NhlFAppClass,0,rlist,ierr)
C
C ##########
C # STEP 2 #
C ##########
C Choose the type of output you want to create.  You may write your
C output to an NCAR Computer Graphics Metafile (NCGM) and view it
C later using the NCAR Graphics utilities ctrans or idt.  You may also
C write your output directly into a window of a workstation running
C the X Window system (as demonstrated in this example), or you can
C write your ouput into  a PostScript or PDF file.  
C
C The first argument, wks, is a variable that identifies the object.
C The second argument, '"wks"', sets the name of the object being
C created. The third argument, "NhlFCairoWindowWorkstationClass",
C identifies the type  or class of the object to create.  In this case
C an X workstation. The fourth argument, "0", specifies the id of the
C objects parent. In this case, specifying "0" indicates that the
C default parent will be used.
C The fifth argument, "rlist", is the resource
C list modifiers to be used when creating the object.  In this
C example, no modifications are made to default values.
C The sixth argument, "ierr", is used to return an error code.
C

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkMetaName','./basic01f.ncgm',ierr)
         call NhlFCreate(wks,"wks",NhlFNcgmWorkstationClass,0,
     1        rlist,ierr)
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPause','True',ierr)
         call NhlFCreate(wks,"wks",NhlFCairoWindowWorkstationClass,0,
     1        rlist,ierr)
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PostScript workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPSFileName','./basic01f.ps',ierr)
         call NhlFCreate(wks,"wks",NhlFPSWorkstationClass,0,
     1        rlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPDFFileName','./basic01f.pdf',
     1        ierr)
         call NhlFCreate(wks,"wks",NhlFPDFWorkstationClass,0,
     1        rlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     1         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create cairo PS/PDF object.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkFileName','./basic01f',
     1        ierr)
         call NhlFRLSetstring(rlist,'wkFormat',wks_type,
     1        ierr)
         call NhlFCreate(wks,"wks",NhlFcairoPSPDFWorkstationClass,0,
     1        rlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create cairo PNG object.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkFileName','./basic01f',
     1        ierr)
         call NhlFRLSetstring(rlist,'wkFormat',wks_type,
     1        ierr)
         call NhlFCreate(wks,"wks",NhlFcairoImageWorkstationClass,0,
     1        rlist,ierr)
      endif

C
C ##########
C # STEP 3 #
C ##########
C Create a plot object.  In this example, we will create a contour plot,
C but we could have just as easily created any other type of plot such as
C an Xy plot, or a Map plot.
C
C The first argument, con1, is a variable that identifies the object.
C The second create call argument, '"con1"', sets the name of the object.
C This is an arbitrary name and does not have to match the variable
C object identifier used in the first parameter.
C The third argument, "NhlFContourPlotClass", identifies the type or
C class of the object to create.  In this case, the type is a contour
C plot.  The third argument, "wks", specifies the id of the object's
C parent.  By  specifying the id of the X workstation created earlier,
C the plot will be drawn into an X window.
C The fifth argument, "rlist", is the resource list modifiers to be used
C when creating the object.  In this example, no modifications are
C made to default values.
C The sixth argument, "ierr", is used to return an error code.
C
      call NhlFRLClear(rlist)
      call NhlFCreate(con1,"con1",NhlFContourPlotClass,wks,
     1      rlist,ierr)
C
C ##########
C # STEP 4 #
C ##########
C This step draws the plot into the X workstation window.  The first
C argument  to the draw function is the variable name of the object
C that you want to draw.  The second argument is for returning error
C codes.
C
C
      call NhlFDraw(con1,ierr)
C
C ##########
C # STEP 5 #
C ##########
C The frame call updates and then clears the workstation.
C
      call NhlFFrame(wks,ierr)
C
C ##########
C # STEP 6 #
C ##########
C This is the final step used for cleanup.  The NhlFDestroy
C function Destroys objects and frees memory.
C Destroying a parent object
C automatically destroys all of its children.  The NhlFClose function
C is used to tell the HLU library that the programmer is done 
C using it, and to free up any memory that it can. 
C
      call NhlFDestroy(con1,ierr)
      call NhlFClose

      stop
      end

C
C $Id: cpfx.f,v 1.7 2008-07-27 00:17:23 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      FUNCTION CPFX (IX)
C
C Given an X coordinate IX in the plotter system, CPFX(IX) is an X
C coordinate in the fractional system.
C
      COMMON /IUTLCM/ LL,MI,MX,MY,IU(96)
      SAVE /IUTLCM/
      CPFX=REAL(IX-1)/(2.**MX-1.)
      RETURN
      END

      PROGRAM CSEX04
C
C  Do a 2D approximation and find mixed second order partial derivatives.
C
C
C  The dimensionality of the problem.
C
      PARAMETER (NDIM=2)
C
C  The number of input data points.
C
      PARAMETER (NDATA=1000)
C
C  The number of output data points in the X coordinate direction.
C
      PARAMETER (NX=29)
C
C  The number of output data points in the Y coordinate direction.
C
      PARAMETER (NY=25)
C
C  Specifty the number of knots in the X direction.
C
      PARAMETER (N1=4)
C
C  Specifty the number of knots in the Y direction.
C
      PARAMETER (N2=4)
C
C  The size of the workspace.
C
      PARAMETER (NCF=N1*N2, NWRK=NCF*(NCF+3))
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C  Dimension the arrays.
C
      DIMENSION XDATA(NDIM,NDATA),YDATA(NDATA),KNOTS(NDIM),WORK(NWRK),
     +          NDERIV(2)
      DATA XMIN,YMIN,XMAX,YMAX / -1.0, -1.0, 1.0, 1.0/
      DATA NDERIV(1),NDERIV(2) / 0, 0/
      REAL XO(NX), YO(NY), FUNC(NX,NY),FUNCD(NX,NY)
C
C  Generate input data using the functiuon f(x,y) = y**2 - 0.5*y*x**2
C
      INDX = NDATA
      DO 10 I=1,INDX
        XDATA(1,I) = XMIN+(XMAX-XMIN)*DSRND1()
        XDATA(2,I) = YMIN+(YMAX-YMIN)*DSRND1()
        XX = XDATA(1,I)
        YY = XDATA(2,I)
        YDATA(I) = YY*YY - 0.5*YY*XX*XX
   10 CONTINUE
C
C  Create the output grid.
C
      DO 102 I=1,NX
        XO(I) = XMIN+(REAL(I-1)/REAL(NX-1))*(XMAX-XMIN)
  102 CONTINUE
      DO 103 J =1,NY
        YO(J)= YMIN+(REAL(J-1)/REAL(NY-1))*(YMAX-YMIN)
  103 CONTINUE
C
C  Specify the numbers of knots in each coordinate direction.
C
      KNOTS(1) = N1
      KNOTS(2) = N2
C
C  Calculate the approximated functuion values.
C
      CALL CSA2S (INDX,XDATA,YDATA,KNOTS,NX,NY,XO,YO,FUNC,NWRK,WORK,IER)
C
C  Calculate the second order mixed partial derivative.
C
      NDERIV(1) = 1
      NDERIV(2) = 1
      CALL CSA2XS (INDX,XDATA,YDATA,-1.,KNOTS,0.,NDERIV,NX,NY,
     +                  XO,YO,FUNCD,NWRK,WORK,IER)
C
C  Plot a surface.
C
C  Open GKS and define the foreground and background color.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C  Approximated function.
C
      CALL TDEZ2D(NX, NY, XO, YO, FUNC, 2.7, 45., 78., 6)
      CALL SET(0.,1.,0.,1.,0.,1.,0.,1.,1)
      CALL PLCHHQ(0.5,0.85,
     +   ':F25:z = f(x,y) = y:S:2:E:  - -:H-10::S:1:E::B::V-6:2:E:  y:V-
     +6:*:V+6:x:S:2:E:',0.04,0.,0.)
      CALL FRAME()
C
C  Mixed partial.
C
      CALL TDEZ2D(NX, NY, XO, YO, FUNCD, 2.7, 45., 78., 6)
      CALL SET(0.,1.,0.,1.,0.,1.,0.,1.,1)
      CALL PLCHHQ(0.5,0.88,
     + ':F25:z =  :F34::S::H8:6:F25::S:2:E::E::F34:>:B::F34::H-35::V-6:6
     +:F25:x:F34:6:F25:y:E:  f(x,y) = - x',0.04,0.,0.)
      CALL FRAME()
C
C Close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END
      REAL FUNCTION DSRND1()
C
C  Portable random number generator.
C
      PARAMETER (MPLIER=16807,MODLUS=2147483647,MOBYMP=127773,
     +           MOMDMP=2836)
C
      INTEGER HVLUE, LVLUE, TESTV, NEXTN
      SAVE    NEXTN
      DATA JSEED,IFRST/123456789,0/
C
      IF (IFRST .EQ. 0) THEN
        NEXTN = JSEED
        IFRST = 1
      ENDIF
C
      HVLUE = NEXTN / MOBYMP
      LVLUE = MOD(NEXTN, MOBYMP)
      TESTV = MPLIER*LVLUE - MOMDMP*HVLUE
      IF (TESTV .GT. 0) THEN
        NEXTN = TESTV
      ELSE
        NEXTN = TESTV + MODLUS
      ENDIF
      DSRND1 = REAL(NEXTN)/REAL(MODLUS)
C
      RETURN
      END

      SUBROUTINE SSTEGR( JOBZ, RANGE, N, D, E, VL, VU, IL, IU, ABSTOL,
     $                   M, W, Z, LDZ, ISUPPZ, WORK, LWORK, IWORK,
     $                   LIWORK, INFO )
*
*  -- LAPACK computational routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          JOBZ, RANGE
      INTEGER            IL, INFO, IU, LDZ, LIWORK, LWORK, M, N
      REAL               ABSTOL, VL, VU
*     ..
*     .. Array Arguments ..
      INTEGER            ISUPPZ( * ), IWORK( * )
      REAL               D( * ), E( * ), W( * ), WORK( * ), Z( LDZ, * )
*     ..
*
*  Purpose
*  =======
*
* SSTEGR computes selected eigenvalues and, optionally, eigenvectors
* of a real symmetric tridiagonal matrix T.  Eigenvalues and
* eigenvectors can be selected by specifying either a range of values
* or a range of indices for the desired eigenvalues. The eigenvalues
* are computed by the dqds algorithm, while orthogonal eigenvectors are
* computed from various ``good'' L D L^T representations (also known as
* Relatively Robust Representations). Gram-Schmidt orthogonalization is
* avoided as far as possible. More specifically, the various steps of
* the algorithm are as follows. For the i-th unreduced block of T,
*     (a) Compute T - sigma_i = L_i D_i L_i^T, such that L_i D_i L_i^T
*         is a relatively robust representation,
*     (b) Compute the eigenvalues, lambda_j, of L_i D_i L_i^T to high
*         relative accuracy by the dqds algorithm,
*     (c) If there is a cluster of close eigenvalues, "choose" sigma_i
*         close to the cluster, and go to step (a),
*     (d) Given the approximate eigenvalue lambda_j of L_i D_i L_i^T,
*         compute the corresponding eigenvector by forming a
*         rank-revealing twisted factorization.
*  The desired accuracy of the output can be specified by the input
*  parameter ABSTOL.
*
*  For more details, see "A new O(n^2) algorithm for the symmetric
*  tridiagonal eigenvalue/eigenvector problem", by Inderjit Dhillon,
*  Computer Science Division Technical Report No. UCB/CSD-97-971,
*  UC Berkeley, May 1997.
*
*  Note 1 : Currently SSTEGR is only set up to find ALL the n
*  eigenvalues and eigenvectors of T in O(n^2) time
*  Note 2 : Currently the routine SSTEIN is called when an appropriate
*  sigma_i cannot be chosen in step (c) above. SSTEIN invokes modified
*  Gram-Schmidt when eigenvalues are close.
*  Note 3 : SSTEGR works only on machines which follow ieee-754
*  floating-point standard in their handling of infinities and NaNs.
*  Normal execution of SSTEGR may create NaNs and infinities and hence
*  may abort due to a floating point exception in environments which
*  do not conform to the ieee standard.
*
*  Arguments
*  =========
*
*  JOBZ    (input) CHARACTER*1
*          = 'N':  Compute eigenvalues only;
*          = 'V':  Compute eigenvalues and eigenvectors.
*
*  RANGE   (input) CHARACTER*1
*          = 'A': all eigenvalues will be found.
*          = 'V': all eigenvalues in the half-open interval (VL,VU]
*                 will be found.
*          = 'I': the IL-th through IU-th eigenvalues will be found.
********** Only RANGE = 'A' is currently supported *********************
*
*  N       (input) INTEGER
*          The order of the matrix.  N >= 0.
*
*  D       (input/output) REAL array, dimension (N)
*          On entry, the n diagonal elements of the tridiagonal matrix
*          T. On exit, D is overwritten.
*
*  E       (input/output) REAL array, dimension (N)
*          On entry, the (n-1) subdiagonal elements of the tridiagonal
*          matrix T in elements 1 to N-1 of E; E(N) need not be set.
*          On exit, E is overwritten.
*
*  VL      (input) REAL
*  VU      (input) REAL
*          If RANGE='V', the lower and upper bounds of the interval to
*          be searched for eigenvalues. VL < VU.
*          Not referenced if RANGE = 'A' or 'I'.
*
*  IL      (input) INTEGER
*  IU      (input) INTEGER
*          If RANGE='I', the indices (in ascending order) of the
*          smallest and largest eigenvalues to be returned.
*          1 <= IL <= IU <= N, if N > 0; IL = 1 and IU = 0 if N = 0.
*          Not referenced if RANGE = 'A' or 'V'.
*
*  ABSTOL  (input) REAL
*          The absolute error tolerance for the
*          eigenvalues/eigenvectors. IF JOBZ = 'V', the eigenvalues and
*          eigenvectors output have residual norms bounded by ABSTOL,
*          and the dot products between different eigenvectors are
*          bounded by ABSTOL. If ABSTOL is less than N*EPS*|T|, then
*          N*EPS*|T| will be used in its place, where EPS is the
*          machine precision and |T| is the 1-norm of the tridiagonal
*          matrix. The eigenvalues are computed to an accuracy of
*          EPS*|T| irrespective of ABSTOL. If high relative accuracy
*          is important, set ABSTOL to DLAMCH( 'Safe minimum' ).
*          See Barlow and Demmel "Computing Accurate Eigensystems of
*          Scaled Diagonally Dominant Matrices", LAPACK Working Note #7
*          for a discussion of which matrices define their eigenvalues
*          to high relative accuracy.
*
*  M       (output) INTEGER
*          The total number of eigenvalues found.  0 <= M <= N.
*          If RANGE = 'A', M = N, and if RANGE = 'I', M = IU-IL+1.
*
*  W       (output) REAL array, dimension (N)
*          The first M elements contain the selected eigenvalues in
*          ascending order.
*
*  Z       (output) REAL array, dimension (LDZ, max(1,M) )
*          If JOBZ = 'V', then if INFO = 0, the first M columns of Z
*          contain the orthonormal eigenvectors of the matrix T
*          corresponding to the selected eigenvalues, with the i-th
*          column of Z holding the eigenvector associated with W(i).
*          If JOBZ = 'N', then Z is not referenced.
*          Note: the user must ensure that at least max(1,M) columns are
*          supplied in the array Z; if RANGE = 'V', the exact value of M
*          is not known in advance and an upper bound must be used.
*
*  LDZ     (input) INTEGER
*          The leading dimension of the array Z.  LDZ >= 1, and if
*          JOBZ = 'V', LDZ >= max(1,N).
*
*  ISUPPZ  (output) INTEGER ARRAY, dimension ( 2*max(1,M) )
*          The support of the eigenvectors in Z, i.e., the indices
*          indicating the nonzero elements in Z. The i-th eigenvector
*          is nonzero only in elements ISUPPZ( 2*i-1 ) through
*          ISUPPZ( 2*i ).
*
*  WORK    (workspace/output) REAL array, dimension (LWORK)
*          On exit, if INFO = 0, WORK(1) returns the optimal
*          (and minimal) LWORK.
*
*  LWORK   (input) INTEGER
*          The dimension of the array WORK.  LWORK >= max(1,18*N)
*
*          If LWORK = -1, then a workspace query is assumed; the routine
*          only calculates the optimal size of the WORK array, returns
*          this value as the first entry of the WORK array, and no error
*          message related to LWORK is issued by XERBLA.
*
*  IWORK   (workspace/output) INTEGER array, dimension (LIWORK)
*          On exit, if INFO = 0, IWORK(1) returns the optimal LIWORK.
*
*  LIWORK  (input) INTEGER
*          The dimension of the array IWORK.  LIWORK >= max(1,10*N)
*
*          If LIWORK = -1, then a workspace query is assumed; the
*          routine only calculates the optimal size of the IWORK array,
*          returns this value as the first entry of the IWORK array, and
*          no error message related to LIWORK is issued by XERBLA.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*          > 0:  if INFO = 1, internal error in SLARRE,
*                if INFO = 2, internal error in SLARRV.
*
*  Further Details
*  ===============
*
*  Based on contributions by
*     Inderjit Dhillon, IBM Almaden, USA
*     Osni Marques, LBNL/NERSC, USA
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ZERO, ONE
      PARAMETER          ( ZERO = 0.0E0, ONE = 1.0E0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            ALLEIG, INDEIG, LQUERY, VALEIG, WANTZ
      INTEGER            I, IBEGIN, IEND, IINDBL, IINDWK, IINFO, IINSPL, 
     $                   INDGRS, INDWOF, INDWRK, ITMP, J, JJ, LIWMIN, 
     $                   LWMIN, NSPLIT
      REAL               BIGNUM, EPS, RMAX, RMIN, SAFMIN, SCALE, SMLNUM,
     $                   THRESH, TMP, TNRM, TOL
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      REAL               SLAMCH, SLANST
      EXTERNAL           LSAME, SLAMCH, SLANST
*     ..
*     .. External Subroutines ..
      EXTERNAL           SLARRE, SLARRV, SLASET, SSCAL, SSWAP, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN, REAL, SQRT
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      WANTZ = LSAME( JOBZ, 'V' )
      ALLEIG = LSAME( RANGE, 'A' )
      VALEIG = LSAME( RANGE, 'V' )
      INDEIG = LSAME( RANGE, 'I' )
*
      LQUERY = ( ( LWORK.EQ.-1 ) .OR. ( LIWORK.EQ.-1 ) )
      LWMIN = 18*N
      LIWMIN = 10*N
*
      INFO = 0
      IF( .NOT.( WANTZ .OR. LSAME( JOBZ, 'N' ) ) ) THEN
         INFO = -1
      ELSE IF( .NOT.( ALLEIG .OR. VALEIG .OR. INDEIG ) ) THEN
         INFO = -2
*
*     The following two lines need to be removed once the 
*     RANGE = 'V' and RANGE = 'I' options are provided.
*
      ELSE IF( VALEIG .OR. INDEIG ) THEN
         INFO = -2
      ELSE IF( N.LT.0 ) THEN
         INFO = -3
      ELSE IF( VALEIG .AND. N.GT.0 .AND. VU.LE.VL ) THEN
         INFO = -7
      ELSE IF( INDEIG .AND. IL.LT.1 ) THEN
         INFO = -8
*     The following change should be made in DSTEVX also, otherwise
*     IL can be specified as N+1 and IU as N.
*     ELSE IF( INDEIG .AND. ( IU.LT.MIN( N, IL ) .OR. IU.GT.N ) ) THEN
      ELSE IF( INDEIG .AND. ( IU.LT.IL .OR. IU.GT.N ) ) THEN
         INFO = -9
      ELSE IF( LDZ.LT.1 .OR. ( WANTZ .AND. LDZ.LT.N ) ) THEN
         INFO = -14
      ELSE IF( LWORK.LT.LWMIN .AND. .NOT.LQUERY ) THEN
         INFO = -17
      ELSE IF( LIWORK.LT.LIWMIN .AND. .NOT.LQUERY ) THEN
         INFO = -19
      END IF
      IF( INFO.EQ.0 ) THEN
         WORK( 1 ) = LWMIN
         IWORK( 1 ) = LIWMIN
      END IF
*
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'SSTEGR', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         RETURN
      END IF
*
*     Quick return if possible
*
      M = 0
      IF( N.EQ.0 )
     $   RETURN
*
      IF( N.EQ.1 ) THEN
         IF( ALLEIG .OR. INDEIG ) THEN
            M = 1
            W( 1 ) = D( 1 )
         ELSE
            IF( VL.LT.D( 1 ) .AND. VU.GE.D( 1 ) ) THEN
               M = 1
               W( 1 ) = D( 1 )
            END IF
         END IF
         IF( WANTZ )
     $      Z( 1, 1 ) = ONE
         RETURN
      END IF
*
*     Get machine constants.
*
      SAFMIN = SLAMCH( 'Safe minimum' )
      EPS = SLAMCH( 'Precision' )
      SMLNUM = SAFMIN / EPS
      BIGNUM = ONE / SMLNUM
      RMIN = SQRT( SMLNUM )
      RMAX = MIN( SQRT( BIGNUM ), ONE / SQRT( SQRT( SAFMIN ) ) )
*
*     Scale matrix to allowable range, if necessary.
*
      SCALE = ONE
      TNRM = SLANST( 'M', N, D, E )
      IF( TNRM.GT.ZERO .AND. TNRM.LT.RMIN ) THEN
         SCALE = RMIN / TNRM
      ELSE IF( TNRM.GT.RMAX ) THEN
         SCALE = RMAX / TNRM
      END IF
      IF( SCALE.NE.ONE ) THEN
         CALL SSCAL( N, SCALE, D, 1 )
         CALL SSCAL( N-1, SCALE, E, 1 )
         TNRM = TNRM*SCALE
      END IF
      INDGRS = 1
      INDWOF = 2*N + 1
      INDWRK = 3*N + 1
*
      IINSPL = 1
      IINDBL = N + 1
      IINDWK = 2*N + 1
*
      CALL SLASET( 'Full', N, N, ZERO, ZERO, Z, LDZ )
*
*     Compute the desired eigenvalues of the tridiagonal after splitting
*     into smaller subblocks if the corresponding of-diagonal elements
*     are small
*
      THRESH = EPS*TNRM
      CALL SLARRE( N, D, E, THRESH, NSPLIT, IWORK( IINSPL ), M, W,
     $             WORK( INDWOF ), WORK( INDGRS ), WORK( INDWRK ),
     $             IINFO )
      IF( IINFO.NE.0 ) THEN
         INFO = 1
         RETURN
      END IF
*
      IF( WANTZ ) THEN
*
*        Compute the desired eigenvectors corresponding to the computed
*        eigenvalues
*
         TOL = MAX( ABSTOL, REAL( N )*THRESH )
         IBEGIN = 1
         DO 20 I = 1, NSPLIT
            IEND = IWORK( IINSPL+I-1 )
            DO 10 J = IBEGIN, IEND
               IWORK( IINDBL+J-1 ) = I
   10       CONTINUE
            IBEGIN = IEND + 1
   20    CONTINUE
*
         CALL SLARRV( N, D, E, IWORK( IINSPL ), M, W, IWORK( IINDBL ),
     $                WORK( INDGRS ), TOL, Z, LDZ, ISUPPZ,
     $                WORK( INDWRK ), IWORK( IINDWK ), IINFO )
         IF( IINFO.NE.0 ) THEN
            INFO = 2
            RETURN
         END IF
*
      END IF
*
      IBEGIN = 1
      DO 40 I = 1, NSPLIT
         IEND = IWORK( IINSPL+I-1 )
         DO 30 J = IBEGIN, IEND
            W( J ) = W( J ) + WORK( INDWOF+I-1 )
   30    CONTINUE
         IBEGIN = IEND + 1
   40 CONTINUE
*
*     If matrix was scaled, then rescale eigenvalues appropriately.
*
      IF( SCALE.NE.ONE ) THEN
         CALL SSCAL( M, ONE / SCALE, W, 1 )
      END IF
*
*     If eigenvalues are not in order, then sort them, along with
*     eigenvectors.
*
      IF( NSPLIT.GT.1 ) THEN
         DO 60 J = 1, M - 1
            I = 0
            TMP = W( J )
            DO 50 JJ = J + 1, M
               IF( W( JJ ).LT.TMP ) THEN
                  I = JJ
                  TMP = W( JJ )
               END IF
   50       CONTINUE
            IF( I.NE.0 ) THEN
               W( I ) = W( J )
               W( J ) = TMP
               IF( WANTZ ) THEN
                  CALL SSWAP( N, Z( 1, I ), 1, Z( 1, J ), 1 )
                  ITMP = ISUPPZ( 2*I-1 )
                  ISUPPZ( 2*I-1 ) = ISUPPZ( 2*J-1 )
                  ISUPPZ( 2*J-1 ) = ITMP
                  ITMP = ISUPPZ( 2*I )
                  ISUPPZ( 2*I ) = ISUPPZ( 2*J )
                  ISUPPZ( 2*J ) = ITMP
               END IF
            END IF
   60    CONTINUE
      END IF
*
      WORK( 1 ) = LWMIN
      IWORK( 1 ) = LIWMIN
      RETURN
*
*     End of SSTEGR
*
      END

C
C $Id: trn32i.f,v 1.6 2008-07-27 00:17:16 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE TRN32I (UT,VT,WT,XT,YT,ZT,IENT)
C
C This routine provides a temporary interface for ISTR32 until such
C time as all calls to TRN32I can be found and modified (which may
C be never, as there are likely to be some such calls in user code).
C
      COMMON /ISCOMN/ BIG,BIGD,DBPI,IDONE,IFILL,IFLIP,IONES,IHSS(1000),
     +                IREF,ISCA(16,256),ISCALE,ISCR(16,256),ISLBT,ISDR,
     +                LHSS,LX,NFPW,NINU,NINV,NINW,NX,NY,R0,RNX,RNY,
     +                SMALL,SVAL,TENSN,U,V,W,XMAX,XMIN,YMAX,YMIN,XVPL,
     +                XVPR,YVPB,YVPT
      SAVE   /ISCOMN/
C
C Pass the arguments on to ISTR32.
C
        CALL ISTR32 (UT,VT,WT,XT,YT,ZT,IENT)
C
C If necessary, convert the returned coordinates from the fractional
C system to the metacode system.
C
        IF (IENT.NE.1.AND.ISCALE.NE.0) THEN
          XT=32767.*XT
          YT=32767.*YT
        END IF
C
C Done.
C
        RETURN
C
      END

C
C $Id: agbnch.f,v 1.6 2008-07-27 00:14:33 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      CHARACTER*16 FUNCTION AGBNCH (IDSH)
C
C The value of this function is the character-dash-pattern equivalent of
C the integer dash pattern IDSH, a string of quotes and/or dollar signs.
C Note that the support routines IAND and ISHIFT are used.
C
      KDSH=IDSH
C
      DO 101 I=16,1,-1
        IF (IAND(KDSH,1).EQ.0) THEN
          AGBNCH(I:I)=''''
        ELSE
          AGBNCH(I:I)='$'
        END IF
        KDSH=ISHIFT(KDSH,-1)
  101 CONTINUE
C
      RETURN
C
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C   FFTPACK 5.0
C   Copyright (C) 1995-2004, Scientific Computing Division,
C   University Corporation for Atmospheric Research
C   Licensed under the GNU General Public License (GPL)
C
C   Authors:  Paul N. Swarztrauber and Richard A. Valent
C
C   $Id: mrftf1.f,v 1.2 2006-11-21 01:10:18 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      SUBROUTINE DMRFTF1(M,IM,N,IN,C,CH,WA,FAC)
      DOUBLE PRECISION SN
      DOUBLE PRECISION TSN
      DOUBLE PRECISION TSNM
      DOUBLE PRECISION CH(M,*),C(IN,*),WA(N),FAC(15)
C
      NF = FAC(2)
      NA = 1
      L2 = N
      IW = N
      DO 111 K1 = 1,NF
          KH = NF - K1
          IP = FAC(KH+3)
          L1 = L2/IP
          IDO = N/L2
          IDL1 = IDO*L1
          IW = IW - (IP-1)*IDO
          NA = 1 - NA
          IF (IP.NE.4) GO TO 102
          IX2 = IW + IDO
          IX3 = IX2 + IDO
          IF (NA.NE.0) GO TO 101
          CALL DMRADF4(M,IDO,L1,C,IM,IN,CH,1,M,WA(IW),WA(IX2),WA(IX3))
          GO TO 110
  101     CALL DMRADF4(M,IDO,L1,CH,1,M,C,IM,IN,WA(IW),WA(IX2),WA(IX3))
          GO TO 110
  102     IF (IP.NE.2) GO TO 104
          IF (NA.NE.0) GO TO 103
          CALL DMRADF2(M,IDO,L1,C,IM,IN,CH,1,M,WA(IW))
          GO TO 110
  103     CALL DMRADF2(M,IDO,L1,CH,1,M,C,IM,IN,WA(IW))
          GO TO 110
  104     IF (IP.NE.3) GO TO 106
          IX2 = IW + IDO
          IF (NA.NE.0) GO TO 105
          CALL DMRADF3(M,IDO,L1,C,IM,IN,CH,1,M,WA(IW),WA(IX2))
          GO TO 110
  105     CALL DMRADF3(M,IDO,L1,CH,1,M,C,IM,IN,WA(IW),WA(IX2))
          GO TO 110
  106     IF (IP.NE.5) GO TO 108
          IX2 = IW + IDO
          IX3 = IX2 + IDO
          IX4 = IX3 + IDO
          IF (NA.NE.0) GO TO 107
          CALL DMRADF5(M,IDO,L1,C,IM,IN,CH,1,M,WA(IW),WA(IX2),WA(IX3),
     +                WA(IX4))
          GO TO 110
  107     CALL DMRADF5(M,IDO,L1,CH,1,M,C,IM,IN,WA(IW),WA(IX2),WA(IX3),
     +                WA(IX4))
          GO TO 110
  108     IF (IDO.EQ.1) NA = 1 - NA
          IF (NA.NE.0) GO TO 109
          CALL DMRADFG(M,IDO,IP,L1,IDL1,C,C,C,IM,IN,CH,CH,1,M,WA(IW))
          NA = 1
          GO TO 110
  109     CALL DMRADFG(M,IDO,IP,L1,IDL1,CH,CH,CH,1,M,C,C,IM,IN,WA(IW))
          NA = 0
  110     L2 = L1
  111 CONTINUE
      SN = 1.D0/N
      TSN = 2.D0/N
      TSNM = -TSN
      MODN = MOD(N,2)
      NL = N - 2
      IF (MODN.NE.0) NL = N - 1
      IF (NA.NE.0) GO TO 120
      M2 = 1 - IM
      DO 117 I = 1,M
          M2 = M2 + IM
          C(M2,1) = SN*CH(I,1)
  117 CONTINUE
      DO 118 J = 2,NL,2
          M2 = 1 - IM
          DO 118 I = 1,M
              M2 = M2 + IM
              C(M2,J) = TSN*CH(I,J)
              C(M2,J+1) = TSNM*CH(I,J+1)
  118 CONTINUE
      IF (MODN.NE.0) RETURN
      M2 = 1 - IM
      DO 119 I = 1,M
          M2 = M2 + IM
          C(M2,N) = SN*CH(I,N)
  119 CONTINUE
      RETURN
  120 M2 = 1 - IM
      DO 121 I = 1,M
          M2 = M2 + IM
          C(M2,1) = SN*C(M2,1)
  121 CONTINUE
      DO 122 J = 2,NL,2
          M2 = 1 - IM
          DO 122 I = 1,M
              M2 = M2 + IM
              C(M2,J) = TSN*C(M2,J)
              C(M2,J+1) = TSNM*C(M2,J+1)
  122 CONTINUE
      IF (MODN.NE.0) RETURN
      M2 = 1 - IM
      DO 123 I = 1,M
          M2 = M2 + IM
          C(M2,N) = SN*C(M2,N)
  123 CONTINUE
      RETURN
      END

      SUBROUTINE ZGECON( NORM, N, A, LDA, ANORM, RCOND, WORK, RWORK,
     $                   INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     March 31, 1993
*
*     .. Scalar Arguments ..
      CHARACTER          NORM
      INTEGER            INFO, LDA, N
      DOUBLE PRECISION   ANORM, RCOND
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   RWORK( * )
      COMPLEX*16         A( LDA, * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  ZGECON estimates the reciprocal of the condition number of a general
*  complex matrix A, in either the 1-norm or the infinity-norm, using
*  the LU factorization computed by ZGETRF.
*
*  An estimate is obtained for norm(inv(A)), and the reciprocal of the
*  condition number is computed as
*     RCOND = 1 / ( norm(A) * norm(inv(A)) ).
*
*  Arguments
*  =========
*
*  NORM    (input) CHARACTER*1
*          Specifies whether the 1-norm condition number or the
*          infinity-norm condition number is required:
*          = '1' or 'O':  1-norm;
*          = 'I':         Infinity-norm.
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  A       (input) COMPLEX*16 array, dimension (LDA,N)
*          The factors L and U from the factorization A = P*L*U
*          as computed by ZGETRF.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(1,N).
*
*  ANORM   (input) DOUBLE PRECISION
*          If NORM = '1' or 'O', the 1-norm of the original matrix A.
*          If NORM = 'I', the infinity-norm of the original matrix A.
*
*  RCOND   (output) DOUBLE PRECISION
*          The reciprocal of the condition number of the matrix A,
*          computed as RCOND = 1/(norm(A) * norm(inv(A))).
*
*  WORK    (workspace) COMPLEX*16 array, dimension (2*N)
*
*  RWORK   (workspace) DOUBLE PRECISION array, dimension (2*N)
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ONE, ZERO
      PARAMETER          ( ONE = 1.0D+0, ZERO = 0.0D+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            ONENRM
      CHARACTER          NORMIN
      INTEGER            IX, KASE, KASE1
      DOUBLE PRECISION   AINVNM, SCALE, SL, SMLNUM, SU
      COMPLEX*16         ZDUM
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            IZAMAX
      DOUBLE PRECISION   DLAMCH
      EXTERNAL           LSAME, IZAMAX, DLAMCH
*     ..
*     .. External Subroutines ..
      EXTERNAL           XERBLA, ZDRSCL, ZLACON, ZLATRS
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, DBLE, DIMAG, MAX
*     ..
*     .. Statement Functions ..
      DOUBLE PRECISION   CABS1
*     ..
*     .. Statement Function definitions ..
      CABS1( ZDUM ) = ABS( DBLE( ZDUM ) ) + ABS( DIMAG( ZDUM ) )
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      ONENRM = NORM.EQ.'1' .OR. LSAME( NORM, 'O' )
      IF( .NOT.ONENRM .AND. .NOT.LSAME( NORM, 'I' ) ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -4
      ELSE IF( ANORM.LT.ZERO ) THEN
         INFO = -5
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'ZGECON', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      RCOND = ZERO
      IF( N.EQ.0 ) THEN
         RCOND = ONE
         RETURN
      ELSE IF( ANORM.EQ.ZERO ) THEN
         RETURN
      END IF
*
      SMLNUM = DLAMCH( 'Safe minimum' )
*
*     Estimate the norm of inv(A).
*
      AINVNM = ZERO
      NORMIN = 'N'
      IF( ONENRM ) THEN
         KASE1 = 1
      ELSE
         KASE1 = 2
      END IF
      KASE = 0
   10 CONTINUE
      CALL ZLACON( N, WORK( N+1 ), WORK, AINVNM, KASE )
      IF( KASE.NE.0 ) THEN
         IF( KASE.EQ.KASE1 ) THEN
*
*           Multiply by inv(L).
*
            CALL ZLATRS( 'Lower', 'No transpose', 'Unit', NORMIN, N, A,
     $                   LDA, WORK, SL, RWORK, INFO )
*
*           Multiply by inv(U).
*
            CALL ZLATRS( 'Upper', 'No transpose', 'Non-unit', NORMIN, N,
     $                   A, LDA, WORK, SU, RWORK( N+1 ), INFO )
         ELSE
*
*           Multiply by inv(U').
*
            CALL ZLATRS( 'Upper', 'Conjugate transpose', 'Non-unit',
     $                   NORMIN, N, A, LDA, WORK, SU, RWORK( N+1 ),
     $                   INFO )
*
*           Multiply by inv(L').
*
            CALL ZLATRS( 'Lower', 'Conjugate transpose', 'Unit', NORMIN,
     $                   N, A, LDA, WORK, SL, RWORK, INFO )
         END IF
*
*        Divide X by 1/(SL*SU) if doing so will not cause overflow.
*
         SCALE = SL*SU
         NORMIN = 'Y'
         IF( SCALE.NE.ONE ) THEN
            IX = IZAMAX( N, WORK, 1 )
            IF( SCALE.LT.CABS1( WORK( IX ) )*SMLNUM .OR. SCALE.EQ.ZERO )
     $         GO TO 20
            CALL ZDRSCL( N, SCALE, WORK, 1 )
         END IF
         GO TO 10
      END IF
*
*     Compute the estimate of the reciprocal condition number.
*
      IF( AINVNM.NE.ZERO )
     $   RCOND = ( ONE / AINVNM ) / ANORM
*
   20 CONTINUE
      RETURN
*
*     End of ZGECON
*
      END

C
C	$Id: csswap.f,v 1.5 2008-07-27 03:10:08 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CSSWAP (IN1,IN2,IO1,IO2, LIST,LPTR,
     .                 LEND, LP21)
      INTEGER IN1, IN2, IO1, IO2, LIST(*), LPTR(*), LEND(*),
     .        LP21
C
C***********************************************************
C
C                                              From STRIPACK
C                                            Robert J. Renka
C                                  Dept. of Computer Science
C                                       Univ. of North Texas
C                                           renka@cs.unt.edu
C                                                   06/22/98
C
C   Given a triangulation of a set of points on the unit
C sphere, this subroutine replaces a diagonal arc in a
C strictly convex quadrilateral (defined by a pair of adja-
C cent triangles) with the other diagonal.  Equivalently, a
C pair of adjacent triangles is replaced by another pair
C having the same union.
C
C
C On input:
C
C       IN1,IN2,IO1,IO2 = Nodal indexes of the vertices of
C                         the quadrilateral.  IO1-IO2 is re-
C                         placed by IN1-IN2.  (IO1,IO2,IN1)
C                         and (IO2,IO1,IN2) must be trian-
C                         gles on input.
C
C The above parameters are not altered by this routine.
C
C       LIST,LPTR,LEND = Data structure defining the trian-
C                        gulation.  Refer to Subroutine
C                        CSTRMESH.
C
C On output:
C
C       LIST,LPTR,LEND = Data structure updated with the
C                        swap -- triangles (IO1,IO2,IN1) and
C                        (IO2,IO1,IN2) are replaced by
C                        (IN1,IN2,IO2) and (IN2,IN1,IO1)
C                        unless LP21 = 0.
C
C       LP21 = Index of IN1 as a neighbor of IN2 after the
C              swap is performed unless IN1 and IN2 are
C              adjacent on input, in which case LP21 = 0.
C
C Module required by CSSWAP:  CSLSTPTR
C
C Intrinsic function called by CSSWAP:  ABS
C
C***********************************************************
C
      INTEGER CSLSTPTR
      INTEGER LP, LPH, LPSAV
C
C Local parameters:
C
C LP,LPH,LPSAV = LIST pointers
C
C
C Test for IN1 and IN2 adjacent.
C
      LP = CSLSTPTR(LEND(IN1),IN2,LIST,LPTR)
      IF (ABS(LIST(LP)) .EQ. IN2) THEN
        LP21 = 0
        RETURN
      ENDIF
C
C Delete IO2 as a neighbor of IO1.
C
      LP = CSLSTPTR(LEND(IO1),IN2,LIST,LPTR)
      LPH = LPTR(LP)
      LPTR(LP) = LPTR(LPH)
C
C If IO2 is the last neighbor of IO1, make IN2 the
C   last neighbor.
C
      IF (LEND(IO1) .EQ. LPH) LEND(IO1) = LP
C
C Insert IN2 as a neighbor of IN1 following IO1
C   using the hole created above.
C
      LP = CSLSTPTR(LEND(IN1),IO1,LIST,LPTR)
      LPSAV = LPTR(LP)
      LPTR(LP) = LPH
      LIST(LPH) = IN2
      LPTR(LPH) = LPSAV
C
C Delete IO1 as a neighbor of IO2.
C
      LP = CSLSTPTR(LEND(IO2),IN1,LIST,LPTR)
      LPH = LPTR(LP)
      LPTR(LP) = LPTR(LPH)
C
C If IO1 is the last neighbor of IO2, make IN1 the
C   last neighbor.
C
      IF (LEND(IO2) .EQ. LPH) LEND(IO2) = LP
C
C Insert IN1 as a neighbor of IN2 following IO2.
C
      LP = CSLSTPTR(LEND(IN2),IO2,LIST,LPTR)
      LPSAV = LPTR(LP)
      LPTR(LP) = LPH
      LIST(LPH) = IN1
      LPTR(LPH) = LPSAV
      LP21 = LPH
      RETURN
      END

      SUBROUTINE SLAGTF( N, A, LAMBDA, B, C, TOL, D, IN, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      INTEGER            INFO, N
      REAL               LAMBDA, TOL
*     ..
*     .. Array Arguments ..
      INTEGER            IN( * )
      REAL               A( * ), B( * ), C( * ), D( * )
*     ..
*
*  Purpose
*  =======
*
*  SLAGTF factorizes the matrix (T - lambda*I), where T is an n by n
*  tridiagonal matrix and lambda is a scalar, as
*
*     T - lambda*I = PLU,
*
*  where P is a permutation matrix, L is a unit lower tridiagonal matrix
*  with at most one non-zero sub-diagonal elements per column and U is
*  an upper triangular matrix with at most two non-zero super-diagonal
*  elements per column.
*
*  The factorization is obtained by Gaussian elimination with partial
*  pivoting and implicit row scaling.
*
*  The parameter LAMBDA is included in the routine so that SLAGTF may
*  be used, in conjunction with SLAGTS, to obtain eigenvectors of T by
*  inverse iteration.
*
*  Arguments
*  =========
*
*  N       (input) INTEGER
*          The order of the matrix T.
*
*  A       (input/output) REAL array, dimension (N)
*          On entry, A must contain the diagonal elements of T.
*
*          On exit, A is overwritten by the n diagonal elements of the
*          upper triangular matrix U of the factorization of T.
*
*  LAMBDA  (input) REAL
*          On entry, the scalar lambda.
*
*  B       (input/output) REAL array, dimension (N-1)
*          On entry, B must contain the (n-1) super-diagonal elements of
*          T.
*
*          On exit, B is overwritten by the (n-1) super-diagonal
*          elements of the matrix U of the factorization of T.
*
*  C       (input/output) REAL array, dimension (N-1)
*          On entry, C must contain the (n-1) sub-diagonal elements of
*          T.
*
*          On exit, C is overwritten by the (n-1) sub-diagonal elements
*          of the matrix L of the factorization of T.
*
*  TOL     (input) REAL
*          On entry, a relative tolerance used to indicate whether or
*          not the matrix (T - lambda*I) is nearly singular. TOL should
*          normally be chose as approximately the largest relative error
*          in the elements of T. For example, if the elements of T are
*          correct to about 4 significant figures, then TOL should be
*          set to about 5*10**(-4). If TOL is supplied as less than eps,
*          where eps is the relative machine precision, then the value
*          eps is used in place of TOL.
*
*  D       (output) REAL array, dimension (N-2)
*          On exit, D is overwritten by the (n-2) second super-diagonal
*          elements of the matrix U of the factorization of T.
*
*  IN      (output) INTEGER array, dimension (N)
*          On exit, IN contains details of the permutation matrix P. If
*          an interchange occurred at the kth step of the elimination,
*          then IN(k) = 1, otherwise IN(k) = 0. The element IN(n)
*          returns the smallest positive integer j such that
*
*             abs( u(j,j) ).le. norm( (T - lambda*I)(j) )*TOL,
*
*          where norm( A(j) ) denotes the sum of the absolute values of
*          the jth row of the matrix A. If no such j exists then IN(n)
*          is returned as zero. If IN(n) is returned as positive, then a
*          diagonal element of U is small, indicating that
*          (T - lambda*I) is singular or nearly singular,
*
*  INFO    (output) INTEGER
*          = 0   : successful exit
*          .lt. 0: if INFO = -k, the kth argument had an illegal value
*
* =====================================================================
*
*     .. Parameters ..
      REAL               ZERO
      PARAMETER          ( ZERO = 0.0E+0 )
*     ..
*     .. Local Scalars ..
      INTEGER            K
      REAL               EPS, MULT, PIV1, PIV2, SCALE1, SCALE2, TEMP, TL
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, MAX
*     ..
*     .. External Functions ..
      REAL               SLAMCH
      EXTERNAL           SLAMCH
*     ..
*     .. External Subroutines ..
      EXTERNAL           XERBLA
*     ..
*     .. Executable Statements ..
*
      INFO = 0
      IF( N.LT.0 ) THEN
         INFO = -1
         CALL XERBLA( 'SLAGTF', -INFO )
         RETURN
      END IF
*
      IF( N.EQ.0 )
     $   RETURN
*
      A( 1 ) = A( 1 ) - LAMBDA
      IN( N ) = 0
      IF( N.EQ.1 ) THEN
         IF( A( 1 ).EQ.ZERO )
     $      IN( 1 ) = 1
         RETURN
      END IF
*
      EPS = SLAMCH( 'Epsilon' )
*
      TL = MAX( TOL, EPS )
      SCALE1 = ABS( A( 1 ) ) + ABS( B( 1 ) )
      DO 10 K = 1, N - 1
         A( K+1 ) = A( K+1 ) - LAMBDA
         SCALE2 = ABS( C( K ) ) + ABS( A( K+1 ) )
         IF( K.LT.( N-1 ) )
     $      SCALE2 = SCALE2 + ABS( B( K+1 ) )
         IF( A( K ).EQ.ZERO ) THEN
            PIV1 = ZERO
         ELSE
            PIV1 = ABS( A( K ) ) / SCALE1
         END IF
         IF( C( K ).EQ.ZERO ) THEN
            IN( K ) = 0
            PIV2 = ZERO
            SCALE1 = SCALE2
            IF( K.LT.( N-1 ) )
     $         D( K ) = ZERO
         ELSE
            PIV2 = ABS( C( K ) ) / SCALE2
            IF( PIV2.LE.PIV1 ) THEN
               IN( K ) = 0
               SCALE1 = SCALE2
               C( K ) = C( K ) / A( K )
               A( K+1 ) = A( K+1 ) - C( K )*B( K )
               IF( K.LT.( N-1 ) )
     $            D( K ) = ZERO
            ELSE
               IN( K ) = 1
               MULT = A( K ) / C( K )
               A( K ) = C( K )
               TEMP = A( K+1 )
               A( K+1 ) = B( K ) - MULT*TEMP
               IF( K.LT.( N-1 ) ) THEN
                  D( K ) = B( K+1 )
                  B( K+1 ) = -MULT*D( K )
               END IF
               B( K ) = TEMP
               C( K ) = MULT
            END IF
         END IF
         IF( ( MAX( PIV1, PIV2 ).LE.TL ) .AND. ( IN( N ).EQ.0 ) )
     $      IN( N ) = K
   10 CONTINUE
      IF( ( ABS( A( N ) ).LE.SCALE1*TL ) .AND. ( IN( N ).EQ.0 ) )
     $   IN( N ) = N
*
      RETURN
*
*     End of SLAGTF
*
      END

C
C $Id: point3.f,v 1.6 2008-07-27 00:17:34 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE POINT3 (U,V,W)
      DIMENSION VIEW(4),WIND(4)
C
C Save the current SET parameters.
C
      CALL GETSET (VIEW(1),VIEW(2),VIEW(3),VIEW(4),
     +             WIND(1),WIND(2),WIND(3),WIND(4),IOLLS)
C
C DEFINE NORMALIZATION TRANS TO BE USED WITH POLYMARKER
C
      CALL SET(0.0, 1.0, 0.0, 1.0, 1.0, 1024.0, 1.0, 1024.0, 1)
C
C SET MARKER TYPE TO 1
C
      CALL GSMK (1)
      CALL TRN32T (U,V,W,X,Y,ZDUM,2)
      PX = X
      PY = Y
      CALL GPM (1,PX,PY)
C
C Restore original SET call.
C
      CALL SET(VIEW(1),VIEW(2),VIEW(3),VIEW(4),
     -         WIND(1),WIND(2),WIND(3),WIND(4),IOLLS)
C
      RETURN
      END

C
C	$Id: clgen.f,v 1.5 2008-07-27 00:23:01 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CLGEN (Z,MX,NX,NNY,CCLO,CHI,CINC,NLA,NLM,CL,NCL,ICNST)
      SAVE
      DIMENSION       CL(NLM)    ,Z(MX,NNY)
      COMMON /CONRE1/ IOFFP      ,SPVAL
C
C CLGEN PUTS THE VALUES OF THE CONTOUR LEVELS IN CL.
C VARIABLE NAMES MATCH THOSE IN CONREC, WITH THE FOLLOWING ADDITIONS.
C         NCL     -NUMBER OF CONTOUR LEVELS PUT IN CL.
C         ICNST   -FLAG TO TELL CONREC IF A CONSTANT FIELD WAS DETECTED.
C                 .ICNST=0 MEANS NON-CONSTANT FIELD.
C                 .ICNST NON-ZERO MEANS CONSTANT FIELD.
C
C TO PRODUCE NON-UNIFORM CONTOUR LEVEL SPACING, REPLACE THE CODE IN THIS
C SUBROUTINE WITH CODE TO PRODUCE WHATEVER SPACING IS DESIRED.
C
      ICNST = 0
      NY = NNY
      CLO = CCLO
      GLO = CLO
      HA = CHI
      FANC = CINC
      CRAT = NLA
      IF (HA-GLO) 101,102,111
  101 GLO = HA
      HA = CLO
      GO TO 111
  102 IF (GLO .NE. 0.) GO TO 120
      GLO = Z(1,1)
      HA = Z(1,1)
      IF (IOFFP .EQ. 0) GO TO 107
      DO 106 J=1,NY
         DO 105 I=1,NX
            IF (Z(I,J) .EQ. SPVAL) GO TO 105
            GLO = Z(I,J)
            HA = Z(I,J)
            DO 104 JJ=J,NY
               DO 103 II=1,NX
                  IF (Z(II,JJ) .EQ. SPVAL) GO TO 103
                  GLO = MIN(Z(II,JJ),GLO)
                  HA = MAX(Z(II,JJ),HA)
  103          CONTINUE
  104       CONTINUE
            GO TO 110
  105    CONTINUE
  106 CONTINUE
      GO TO 110
  107 DO 109 J=1,NY
         DO 108 I=1,NX
            GLO = MIN(Z(I,J),GLO)
            HA = MAX(Z(I,J),HA)
  108    CONTINUE
  109 CONTINUE
  110 IF (GLO .GE. HA) GO TO 119
  111 IF (FANC) 112,113,114
  112 CRAT = MAX(1.,-FANC)
  113 FANC = (HA-GLO)/CRAT
      P = 10.**(INT(ALOG10(FANC)+5000.)-5000)
      FANC = REAL(INT(FANC/P))*P
  114 IF (CHI-CLO) 116,115,116
  115 GLO = REAL(INT(GLO/FANC))*FANC
      HA = REAL(INT(HA/FANC))*FANC*(1.+SIGN(1.E-6,HA))
  116 DO 117 K=1,NLM
         CC = GLO+REAL(K-1)*FANC
         IF (CC .GT. HA) GO TO 118
         KK = K
         CL(K) = CC
  117 CONTINUE
  118 NCL = KK
      CCLO = CL(1)
      CHI = CL(NCL)
      CINC = FANC
      RETURN
  119 ICNST = 1
      NCL = 1
      CCLO = GLO
      RETURN
  120 CL(1) = GLO
      NCL = 1
      RETURN
      END

      PROGRAM FAGCUDSH
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER (NPTS=200)
      PARAMETER (NCURVE=4)
      REAL YDRA(NPTS,NCURVE),XDRA(NPTS)

      DO 10 I=1,NPTS
          XDRA(I  )=I*0.1
          DO 10 J=1,NCURVE
              YDRA(I,J)=SIN(XDRA(I)+0.2*J)*EXP(-0.01*XDRA(I)*J**2)
  10  CONTINUE
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)

      CALL AGSETF('DASH/SELECTOR.',-1.0)

      CALL EZMXY (XDRA,YDRA,NPTS,NCURVE,NPTS,'DASH PATTERNS$')
C
C  Deactivate and close the workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS

      STOP
      END

C
C	$Id: conrec.f,v 1.7 2008-07-27 00:23:02 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CONREC (Z,L,M,N,FLO,HI,FINC,NSET,NHI,NDOT)
C
C     DIMENSION OF           Z(L,N)
C     ARGUMENTS
C
C     PURPOSE                CONRECSUPR draws a contour map from data
C                            stored in a rectangular array, labeling
C                            the lines.  This is the so-called "super"
C                            version, which smooths contour lines and
C                            removes crowded lines.
C
C     USAGE                  If the following assumptions are met, use
C
C                              CALL EZCNTR (Z,M,N)
C
C                              ASSUMPTIONS:
C                                  --All of the array is to be contoured.
C                                  --Contour levels are picked
C                                    internally.
C                                  --Contouring routine picks scale
C                                    factors.
C                                  --Highs and lows are marked.
C                                  --Negative lines are drawn with a
C                                    dashed line pattern.
C                                  --EZCNTR calls FRAME after drawing the
C                                    contour map.
C
C                            If these assumptions are not met, use
C
C                              CALL CONREC (Z,L,M,N,FLO,HI,FINC,NSET,
C                                           NHI,NDOT)
C
C     ARGUMENTS
C
C     ON INPUT               Z
C     FOR EZCNTR               M by N array to be contoured.
C
C                            M
C                              First dimension of Z.
C
C                            N
C                              Second dimension of Z.
C
C     ON OUTPUT              All arguments are unchanged.
C     FOR EZCNTR
C
C     ON INPUT               Z
C     FOR CONREC               The (origin of the) array to be
C                              contoured.  Z is dimensioned L by N.
C
C                            L
C                              The first dimension of Z in the calling
C                              program.
C
C                            M
C                              The number of data values to be contoured
C                              in the X-direction (the first subscript
C                              direction).  When plotting an entire
C                              array, L = M.
C
C                            N
C                              The number of data values to be contoured
C                              in the Y-direction (the second subscript
C                              direction).
C
C                            FLO
C                              The value of the lowest contour level.
C                              If FLO = HI = 0., a value rounded up from
C                              the minimum Z is generated by CONREC.
C
C                            HI
C                              The value of the highest contour level.
C                              If HI = FLO = 0., a value rounded down
C                              from the maximum Z is generated by
C                              CONREC.
C
C                            FINC
C                              > 0  Increment between contour levels.
C                              = 0  A value, which produces between 10
C                                   and 30 contour levels at nice values,
C                                   is generated by CONREC.
C                              < 0  The number of levels generated by
C                                   CONREC is ABS(FINC).
C
C                            NSET
C                              Flag to control scaling.
C                              = 0  CONREC automatically sets the
C                                   window and viewport to properly
C                                   scale the frame to the standard
C                                   configuration.
C                                   The GRIDAL entry PERIM is
C                                   called and tick marks are placed
C                                   corresponding to the data points.
C                              > 0  CONREC assumes that the user
C                                   has set the window and viewport
C                                   in such a way as to properly
C                                   scale the plotting
C                                   instructions generated by CONREC.
C                                   PERIM is not called.
C                              < 0  CONREC generates coordinates so as
C                                   to place the (untransformed) contour
C                                   plot within the limits of the
C                                   user's current window and
C                                   viewport.  PERIM is not called.
C
C                            NHI
C                              Flag to control extra information on the
C                              contour plot.
C                              = 0  Highs and lows are marked with an H
C                                   or L as appropriate, and the value
C                                   of the high or low is plotted under
C                                   the symbol.
C                              > 0  The data values are plotted at
C                                   each Z point, with the center of
C                                   the string indicating the data
C                                   point location.
C                              < 0  Neither of the above.
C
C                            NDOT
C                              A 10-bit constant designating the desired
C                              dashed line pattern.
C                              If ABS(NDOT) = 0, 1, or 1023, solid lines
C                              are drawn.
C                              > 0 NDOT pattern is used for all lines.
C                              < 0 ABS(NDOT) pattern is used for nega-
C                                tive-valued contour lines, and solid is
C                                used for positive-valued contours.
C                                CONREC converts NDOT
C                                to a 16-bit pattern and DASHDB is used.
C                                See DASHDB comments in the DASHLINE
C                                documentation for details.
C
C
C
C     ON OUTPUT              All arguments are unchanged.
C     FOR CONREC
C
C
C     ENTRY POINTS           CONREC, CLGEN, REORD, STLINE, CRDRLN,
C                            MINMAX, PNTVAL, CALCNT, EZCNTR, CONBD,
C                            CONBDX
C
C     COMMON BLOCKS          INTPR, SPRINT, CONRE1, CONRE2, CONRE3,
C                            CONRE4,CONRE5
C
C     REQUIRED LIBRARY       GRIDAL, the ERPRT77 package and the SPPS.
C     ROUTINES               DASHSUPR is also needed.
C
C     REQUIRED GKS LEVEL     0A
C
C     NOTE FOR NCAR USERS    This routine is NOT part of the default
C                            libraries at NCAR.  CONRECSUPR must be
C                            be acquired, compiled and loaded to be
C                            used at NCAR.
C
C     I/O                    Plots contour map.
C
C     PRECISION              Single
C
C     LANGUAGE               FORTRAN 77
C
C     HISTORY
C
C     ALGORITHM              Each line is followed to completion.  Points
C                            along a line are found on boundaries of the
C                            (rectangular) cells. These points are
C                            connected by line segments using the
C                            software dashed line package, DASHSUPR.
C                            DASHSUPR is also used to label the
C                            lines.  In this version, a model of
C                            the plotting plane is maintained.  If a
C                            line to be drawn will overlap previously
C                            drawn lines, it is omitted.
C
C     NOTE                   To draw non-uniform contour levels, see
C                            the comments in CLGEN.  To make special
C                            modifications for specific needs see the
C                            explanation of the internal parameters
C                            below.
C
C     TIMING                 Varies widely with size and smoothness of
C                            Z.
C
C     INTERNAL PARAMETERS    NAME   DEFAULT         FUNCTION
C                            ----   -------         --------
C
C                            ISIZEL   1      Size of line labels,
C                                            as per the size definitions
C                                            given in the SPPS
C                                            documentation for WTSTR.
C
C                            ISIZEM   2      size of labels for minimums
C                                            and maximums as per the
C                                            size definitions given in
C                                            the SPPS documentation for
C                                            WTSTR.
C
C                            ISIZEP   0      Size of labels for data
C                                            point values as per the size
C                                            definitions given in the SPPS
C                                            documentation for WTSTR.
C
C                            NLA      16     Approximate number of
C                                            contour levels when
C                                            internally generated.
C
C                            NLM      40     Maximum number of contour
C                                            levels.  If this is to be
C                                            increased, the dimensions
C                                            of CL and RWORK in CONREC
C                                            must be increased by the
C                                            same amount.
C
C                            XLT      .05    Left hand edge of the plot
C                                            (0.0 is the left edge of
C                                            the frame and 1.0 is the
C                                            right edge of the frame.)
C
C                            YBT      .05    Bottom edge of the plot
C                                            (0.0 is the bottom of the
C                                            frame and 1.0 is the top
C                                            of the frame.)
C
C                            SIDE     0.9    Length of longer edge of
C                                            plot (see also EXT).
C
C                            NREP     6      Number of repetitions of
C                                            the dash pattern between
C                                            line labels.
C
C                            NCRT     4      Number of CRT units per
C                                            element (bit) in the dash
C                                            pattern.
C
C                            ILAB     1      Flag to control the drawing
C                                            of line labels.
C                                            . ILAB non-zero means label
C                                              the lines.
C                                            . ILAB = 0 means do not
C                                              label the lines.
C
C                            NULBLL   3      Number of unlabeled lines
C                                            between labeled lines.  For
C                                            example, when NULBLL = 3,
C                                            every fourth level is
C                                            labeled.
C
C                            IOFFD    0      Flag to control
C                                            normalization of label
C                                            numbers.
C                                            . IOFFD = 0 means include
C                                              decimal point when
C                                              possible (do not
C                                              normalize unless
C                                              required).
C                                            . IOFFD non-zero means
C                                              normalize all label
C                                              numbers and output a
C                                              scale factor in the
C                                              message below the graph.
C
C                            EXT      .25    Lengths of the sides of the
C                                            plot are proportional to M
C                                            and N (when CONREC sets
C                                            the window and viewport).
C                                            In extreme cases, when
C                                            MIN(M,N)/MAX(M,N) is less
C                                            than EXT, CONREC
C                                            produces a square plot.
C
C                            IOFFP      0    Flag to control special
C                                            value feature.
C                                            . IOFFP = 0 means special
C                                              value feature not in use.
C                                            . IOFFP non-zero means
C                                              special value feature in
C                                              use.  (SPVAL is set to the
C                                              special value.)  Contour
C                                              lines will then be
C                                              omitted from any cell
C                                              with any corner equal to
C                                              the special value.
C
C                            SPVAL    0.     Contains the special value
C                                            when IOFFP is non-zero.
C
C                            IOFFM    0      Flag to control the message
C                                            below the plot.
C                                            . IOFFM = 0  if the message
C                                              is to be plotted.
C                                            . IOFFM non-zero if the
C                                              message is to be omitted.
C
C                            ISOLID   1023   Dash pattern for
C                                            non-negative contour lines.
C
C                            IHILO    3      Flag to control labelling
C                                            of highs, lows, or both:
C                                            if NHI = 0 , then
C                                            . IHILO = 0 means do not
C                                              label highs nor lows
C                                            . IHILO = 1 means highs are
C                                              labelled, lows are not
C                                            . IHILO = 2 means lows are
C                                              labelled, highs are not
C                                            . IHILO = 3 means both
C                                              highs and lows are labelled
C
C
C
C
      SAVE
      CHARACTER*1     ISOL       ,IGAP       ,RCHAR
      CHARACTER       IWORK*126  ,ENCSCR*22
      DIMENSION       LNGTHS(5)  ,HOLD(5)
      DIMENSION       VIEW(4)    ,WIND(4)    ,LASF(13)    ,RECT(4)
      DIMENSION       Z(L,N)     ,CL(40)     ,RWORK(40)
      COMMON /INTPR/  IPD1       ,FPART      ,RPD1        ,IPD2       ,
     1                RPD2       ,IPD3       ,RPD3        ,RPD4       ,
     2                IPD4       ,IPD5
      COMMON /CONRE1/ IOFFP      ,SPVAL      ,IHILO
      COMMON /CONRE3/ IXBITS     ,IYBITS
      COMMON /CONRE5/ SCLY
      COMMON /SPRINT/ ISPRMJ     ,ISPRMN     ,ISPRTX
      DATA  LNGTHS /12,3,20,9,17/
      DATA ISIZEL,ISIZEM,ISIZEP,NLA,NLM,XLT,YBT,SIDE,ISOLID,NREP,NCRT/
     1       1,  2,   0, 16, 40,.05,.05,  .9,  1023,   6,   4/
      DATA EXT,IOFFD,NULBLL,IOFFM,ILAB/.25,0,3,0,1/
      DATA  ISOL, IGAP /'$', ''''/
C
C Do a call forcing a BLOCKDATA to be loaded from a binary library.
C
      CALL CONBD
C
C THE FOLLOWING CALL IS FOR GATHERING STATISTICS ON LIBRARY USE AT NCAR
C
      CALL Q8QST4 ( 'GRAPHX', 'CONRECSUPR', 'CONREC', 'VERSION 01')
C
C SUPER VERSION
C
      CALL RESET
      IXBITS = 0
      DO 101 I=1,24
         IF (M .LE. (2**I-1)) GO TO 102
         IXBITS = I+1
  101 CONTINUE
  102 IYBITS = 0
      DO 103 I=1,24
         IF (N .LE. (2**I-1)) GO TO 104
         IYBITS = I+1
  103 CONTINUE
  104 IF ((IXBITS*IYBITS).GT.0 .AND. (IXBITS+IYBITS).LE.24) GO TO 105
C
C REPORT ERROR NUMBER ONE
C
      IWORK =    'CONREC  - DIMENSION ERROR - M*N .GT. (2**IARTH) -  M =
     +            N = '
      WRITE (IWORK(56:62),'(I6)') M
      WRITE (IWORK(73:79),'(I6)') N
      CALL SETER (IWORK,1,1)
      RETURN
  105 CONTINUE
C
C INQUIRE CURRENT TEXT AND LINE COLOR INDEX
C
      CALL GQTXCI (IERR, ITXCI)
      CALL GQPLCI (IERR, IPLCI)
C
C SET LINE AND TEXT ASF TO INDIVIDUAL
C
      CALL GQASF (IERR, LASF)
      LSV3  = LASF(3)
      LSV10 = LASF(10)
      LASF(3)  = 1
      LASF(10) = 1
      CALL GSASF (LASF)
C
      GL = FLO
      HA = HI
      GP = FINC
      MX = L
      NX = M
      NY = N
      IDASH = NDOT
      NEGPOS = SIGN(1,IDASH)
      IDASH = ABS(IDASH)
      IF (IDASH.EQ.0 .OR. IDASH.EQ.1) IDASH = ISOLID
C
C SET CONTOUR LEVELS.
C
      CALL CLGEN (Z,MX,NX,NY,GL,HA,GP,NLA,NLM,CL,NCL,ICNST)
C
C FIND MAJOR AND MINOR LINES
C
      IF (ILAB .NE. 0) CALL REORD (CL,NCL,RWORK,NML,NULBLL+1)
      IF (ILAB .EQ. 0) NML = 0
C
C Save the current SET parameters.
C
      CALL GETSET (VIEW(1),VIEW(2),VIEW(3),VIEW(4),
     +             WIND(1),WIND(2),WIND(3),WIND(4),IOLLS)
C
C SET UP SCALING
C
      CALL GETUSV ('YF',IYVAL)
      SCLY = 1.0/ISHIFT(1,15-IYVAL)
C
      IF (NSET) 106,107,111
C
  106 X1 = VIEW(1)
      X2 = VIEW(2)
      Y1 = VIEW(3)
      Y2 = VIEW(4)
C
C
C
C
C
C DEFINE NORMALIZATION TRANS AND LOG SCALING
C
      CALL SET(X1,X2,Y1,Y2,1.0,REAL(NX),1.0,REAL(NY),1)
      GO TO 111
  107 X1 = XLT
      X2 = XLT+SIDE
      Y1 = YBT
      Y2 = YBT+SIDE
      X3 = NX
      Y3 = NY
      IF (MIN(X3,Y3)/MAX(X3,Y3) .LT. EXT) GO TO 110
      IF (NX-NY) 108,110,109
  108 X2 = SIDE*X3/Y3+XLT
      GO TO 110
  109 Y2 = SIDE*Y3/X3+YBT
C
C
C
C
C
C DEFINE NORMALIZATION TRANS 1 AND LOG SCALING
C
  110 CALL SET(X1,X2,Y1,Y2,1.0,X3,1.0,Y3,1)
C
C DRAW PERIMETER
C
      CALL PERIM (NX-1,1,NY-1,1)
  111 IF (ICNST .NE. 0) GO TO 124
C
C SET UP LABEL SCALING
C
      IOFFDT = IOFFD
      IF (GL.NE.0.0 .AND. (ABS(GL).LT.0.1 .OR. ABS(GL).GE.1.E5))
     1    IOFFDT = 1
      IF (HA.NE.0.0 .AND. (ABS(HA).LT.0.1 .OR. ABS(HA).GE.1.E5))
     1    IOFFDT = 1
      ASH = 10.**(3-INT(ALOG10(MAX(ABS(GL),ABS(HA),ABS(GP)))
     1                                                  -4999.999)-5000)
      IF (IOFFDT .EQ. 0) ASH = 1.
      IF (IOFFM .NE. 0) GO TO 115
      IWORK = 'CONTOUR FROM              TO              CONTOUR INTERVA
     +L OF              PT(3,3)=              LABELS SCALED BY'
  112 CONTINUE
      HOLD(1) = GL
      HOLD(2) = HA
      HOLD(3) = GP
      HOLD(4) = Z(3,3)
      HOLD(5) = ASH
      NCHAR = 0
      DO 114 I=1,5
         WRITE ( ENCSCR, '(G13.5)' ) HOLD(I)
         NCHAR = NCHAR+LNGTHS(I)
         DO 113 J=1,13
            NCHAR = NCHAR+1
            IWORK(NCHAR:NCHAR) = ENCSCR(J:J)
  113    CONTINUE
  114 CONTINUE
      IF (ASH .EQ. 1) NCHAR = NCHAR-13-LNGTHS(5)
C
C SET TEXT INTENSITY TO LOW, AND WRITE TITLE
C
      CALL GSTXCI (ISPRTX)
C
      CALL GQCLIP (IERR,ICLP,RECT)
      CALL GSCLIP (0)
      CALL WTSTR (CFUX(.5),CFUY(.015625),IWORK(1:NCHAR),0,0,0)
      CALL GSCLIP (ICLP)
C
C
C FIND RELATIVE MINIMUMS AND MAXIMUMS IF WANTED, AND MARK VALUES IF
C WANTED.
C
  115 IF (NHI .EQ. 0) CALL MINMAX (Z,MX,NX,NY,ISIZEM,ASH,IOFFDT)
      IF (NHI .GT. 0) CALL MINMAX (Z,MX,NX,NY,ISIZEP,-ASH,IOFFDT)
C
C PROCESS EACH LEVEL
C
      FPART = .5
      DO 123 I=1,NCL
         CONTR = CL(I)
         NDASH = IDASH
         IF (NEGPOS.LT.0 .AND. CONTR.GE.0.) NDASH = ISOLID
C
C CHANGE 10 BIT PATTERN TO 10 CHARACTER PATTERN.
C
         DO 116 J=1,10
            IBIT = IAND(ISHIFT(NDASH,(J-10)),1)
            RCHAR = IGAP
            IF (IBIT .NE. 0) RCHAR = ISOL
            IWORK(J:J) = RCHAR
  116    CONTINUE
         IF (I .GT. NML) GO TO 121
C
C SET UP MAJOR LINE (LABELED)
C
C
C NREP REPITITIONS OF PATTERN PER LABEL.
C
         NCHAR = 10
         IF (NREP .LT. 2) GO TO 119
         DO 118 J=1,10
            NCHAR = J
            RCHAR = IWORK(J:J)
            DO 117 K=2,NREP
               NCHAR = NCHAR+10
               IWORK(NCHAR:NCHAR) = RCHAR
  117       CONTINUE
  118    CONTINUE
  119    CONTINUE
C
C PUT IN LABEL.
C
         CALL ENCD (CONTR,ASH,ENCSCR,NCUSED,IOFFDT)
         DO 120 J=1,NCUSED
            NCHAR = NCHAR+1
            IWORK(NCHAR:NCHAR) = ENCSCR(J:J)
  120    CONTINUE
         GO TO 122
C
C SET UP MINOR LINE (UNLABELED).
C
  121    CONTINUE
C
C SET LINE INTENSITY TO LOW
C
         CALL GSPLCI (ISPRMN)
         NCHAR = 10
  122    CALL DASHDC (IWORK(1:NCHAR),NCRT,ISIZEL)
C
C
C DRAW ALL LINES AT THIS LEVEL.
C
         CALL STLINE (Z,MX,NX,NY,CONTR)
C
C SET LINE INTENSITY TO HIGH
C
         CALL GSPLCI (ISPRMJ)
C
C                       * * * * * * * * * *
C                       * * * * * * * * * *
C
C
  123 CONTINUE
      FPART = 1.
      GO TO 127
  124 CONTINUE
         IWORK = 'CONSTANT FIELD'
  125 CONTINUE
      WRITE ( ENCSCR, '(G22.14)' ) GL
      DO 126 I=1,22
         IWORK(I+14:I+14) = ENCSCR(I:I)
  126 CONTINUE
C
C WRITE TITLE
C
      CALL GQCLIP (IERR,ICLP,RECT)
      CALL GSCLIP (0)
      CALL WTSTR (CFUX(.09765),CFUY(.48825),IWORK(1:36),3,0,-1)
      CALL GSCLIP (ICLP)
  127 CONTINUE
C
C RESTORE NORMALIZATION TRANS 1, LINE AND TEXT INTENSITY TO ORIGINAL
C VALUES
C
      IF (NSET.LE.0)
     +    CALL SET(VIEW(1),VIEW(2),VIEW(3),VIEW(4),
     +             WIND(1),WIND(2),WIND(3),WIND(4),IOLLS)
C
      CALL GSTXCI (ITXCI)
      CALL GSPLCI (IPLCI)
C
C Restore the original aspect source flags.
C
C
      LASF(3)  = LSV3
      LASF(10) = LSV10
      CALL GSASF (LASF)
      RETURN
C
C
      END

C NCLFORTSTART
      SUBROUTINE DPOPREMAP(DST_ARRAY,MAP_WTS,DST_ADD,SRC_ADD,SRC_ARRAY,
     +                     NDST,NLINK,NW,NSRC,XMSG)

c written in f77 for the GNU f77 compiler for portability reasons

      IMPLICIT NONE
      INTEGER NLINK,NW,NDST,NSRC
      DOUBLE PRECISION MAP_WTS(NW,NLINK)
      DOUBLE PRECISION DST_ARRAY(NDST)
      DOUBLE PRECISION SRC_ARRAY(NSRC)
      INTEGER DST_ADD(NLINK)
      INTEGER SRC_ADD(NLINK)
      DOUBLE PRECISION XMSG
C NCLEND
      INTEGER N

      DO N = 1,NDST
c initialize
          DST_ARRAY(N) = XMSG
      END DO

      DO N = 1,NLINK
          IF (SRC_ARRAY(SRC_ADD(N)).NE.XMSG) THEN
              IF (DST_ARRAY(DST_ADD(N)).EQ.XMSG) THEN
                  DST_ARRAY(DST_ADD(N)) = SRC_ARRAY(SRC_ADD(N))*
     +                                    MAP_WTS(1,N)
              ELSE
                  DST_ARRAY(DST_ADD(N)) = DST_ARRAY(DST_ADD(N)) +
     +                                    SRC_ARRAY(SRC_ADD(N))*
     +                                    MAP_WTS(1,N)
              END IF
          END IF
      END DO

      RETURN
      END

c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by UCAR                 .
c  .                                                             .
c  .       University Corporation for Atmospheric Research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                         SPHEREPACK                       .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c
c
c ... file vhagc.f
c
c     this file contains code and documentation for subroutines
c     vhagc and vhagci
c
c ... files which must be loaded with vhagc.f
c
c     sphcom.f, hrfft.f, gaqd.f
c
c
c     subroutine vhagc(nlat,nlon,ityp,nt,v,w,idvw,jdvw,br,bi,cr,ci,
c    +                 mdab,ndab,wvhagc,lvhagc,work,lwork,ierror)
c
c     subroutine vhagc performs the vector spherical harmonic analysis
c     on the vector field (v,w) and stores the result in the arrays
c     br,bi,cr, and ci. v(i,j) and w(i,j) are the colatitudinal
c     (measured from the north pole) and east longitudinal components
c     respectively, located at the gaussian colatitude point theta(i)
c     and longitude phi(j) = (j-1)*2*pi/nlon. the spectral
c     representation of (v,w) is given at output parameters v,w in
c     subroutine vhsec.
c
c     input parameters
c
c     nlat   the number of points in the gaussian colatitude grid on the
C*PL*ERROR* Comment line too long
c            full sphere. these lie in the interval (0,pi) and are computed
C*PL*ERROR* Comment line too long
c            in radians in theta(1) <...< theta(nlat) by subroutine gaqd.
C*PL*ERROR* Comment line too long
c            if nlat is odd the equator will be included as the grid point
c            theta((nlat+1)/2).  if nlat is even the equator will be
c            excluded as a grid point and will lie half way between
c            theta(nlat/2) and theta(nlat/2+1). nlat must be at least 3.
c            note: on the half sphere, the number of grid points in the
c            colatitudinal direction is nlat/2 if nlat is even or
c            (nlat+1)/2 if nlat is odd.
c
c     nlon   the number of distinct londitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater
c            than zero. the axisymmetric case corresponds to nlon=1.
c            the efficiency of the computation is improved when nlon
c            is a product of small prime numbers.
c
c     ityp   = 0  no symmetries exist about the equator. the analysis
c                 is performed on the entire sphere.  i.e. on the
c                 arrays v(i,j),w(i,j) for i=1,...,nlat and
c                 j=1,...,nlon.
c
c            = 1  no symmetries exist about the equator. the analysis
c                 is performed on the entire sphere.  i.e. on the
c                 arrays v(i,j),w(i,j) for i=1,...,nlat and
c                 j=1,...,nlon. the curl of (v,w) is zero. that is,
c                 (d/dtheta (sin(theta) w) - dv/dphi)/sin(theta) = 0.
c                 the coefficients cr and ci are zero.
c
c            = 2  no symmetries exist about the equator. the analysis
c                 is performed on the entire sphere.  i.e. on the
c                 arrays v(i,j),w(i,j) for i=1,...,nlat and
c                 j=1,...,nlon. the divergence of (v,w) is zero. i.e.,
c                 (d/dtheta (sin(theta) v) + dw/dphi)/sin(theta) = 0.
c                 the coefficients br and bi are zero.
c
c            = 3  v is symmetric and w is antisymmetric about the
c                 equator. the analysis is performed on the northern
c                 hemisphere only.  i.e., if nlat is odd the analysis
c                 is performed on the arrays v(i,j),w(i,j) for
c                 i=1,...,(nlat+1)/2 and j=1,...,nlon. if nlat is
c                 even the analysis is performed on the the arrays
c                 v(i,j),w(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
c
c            = 4  v is symmetric and w is antisymmetric about the
c                 equator. the analysis is performed on the northern
c                 hemisphere only.  i.e., if nlat is odd the analysis
c                 is performed on the arrays v(i,j),w(i,j) for
c                 i=1,...,(nlat+1)/2 and j=1,...,nlon. if nlat is
c                 even the analysis is performed on the the arrays
c                 v(i,j),w(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
c                 the curl of (v,w) is zero. that is,
c                 (d/dtheta (sin(theta) w) - dv/dphi)/sin(theta) = 0.
c                 the coefficients cr and ci are zero.
c
c            = 5  v is symmetric and w is antisymmetric about the
c                 equator. the analysis is performed on the northern
c                 hemisphere only.  i.e., if nlat is odd the analysis
c                 is performed on the arrays v(i,j),w(i,j) for
c                 i=1,...,(nlat+1)/2 and j=1,...,nlon. if nlat is
c                 even the analysis is performed on the the arrays
c                 v(i,j),w(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
c                 the divergence of (v,w) is zero. i.e.,
c                 (d/dtheta (sin(theta) v) + dw/dphi)/sin(theta) = 0.
c                 the coefficients br and bi are zero.
c
c            = 6  v is antisymmetric and w is symmetric about the
c                 equator. the analysis is performed on the northern
c                 hemisphere only.  i.e., if nlat is odd the analysis
c                 is performed on the arrays v(i,j),w(i,j) for
c                 i=1,...,(nlat+1)/2 and j=1,...,nlon. if nlat is
c                 even the analysis is performed on the the arrays
c                 v(i,j),w(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
c
c            = 7  v is antisymmetric and w is symmetric about the
c                 equator. the analysis is performed on the northern
c                 hemisphere only.  i.e., if nlat is odd the analysis
c                 is performed on the arrays v(i,j),w(i,j) for
c                 i=1,...,(nlat+1)/2 and j=1,...,nlon. if nlat is
c                 even the analysis is performed on the the arrays
c                 v(i,j),w(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
c                 the curl of (v,w) is zero. that is,
c                 (d/dtheta (sin(theta) w) - dv/dphi)/sin(theta) = 0.
c                 the coefficients cr and ci are zero.
c
c            = 8  v is antisymmetric and w is symmetric about the
c                 equator. the analysis is performed on the northern
c                 hemisphere only.  i.e., if nlat is odd the analysis
c                 is performed on the arrays v(i,j),w(i,j) for
c                 i=1,...,(nlat+1)/2 and j=1,...,nlon. if nlat is
c                 even the analysis is performed on the the arrays
c                 v(i,j),w(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
c                 the divergence of (v,w) is zero. i.e.,
c                 (d/dtheta (sin(theta) v) + dw/dphi)/sin(theta) = 0.
c                 the coefficients br and bi are zero.
c
c
c     nt     the number of analyses.  in the program that calls vhagc,
c            the arrays v,w,br,bi,cr, and ci can be three dimensional
c            in which case multiple analyses will be performed.
c            the third index is the analysis index which assumes the
c            values k=1,...,nt.  for a single analysis set nt=1. the
c            discription of the remaining parameters is simplified
c            by assuming that nt=1 or that all the arrays are two
c            dimensional.
c
c     v,w    two or three dimensional arrays (see input parameter nt)
c            that contain the vector function to be analyzed.
c            v is the colatitudnal component and w is the east
c            longitudinal component. v(i,j),w(i,j) contain the
c            components at colatitude theta(i) = (i-1)*pi/(nlat-1)
c            and longitude phi(j) = (j-1)*2*pi/nlon. the index ranges
c            are defined above at the input parameter ityp.
c
c     idvw   the first dimension of the arrays v,w as it appears in
c            the program that calls vhagc. if ityp .le. 2 then idvw
c            must be at least nlat.  if ityp .gt. 2 and nlat is
c            even then idvw must be at least nlat/2. if ityp .gt. 2
c            and nlat is odd then idvw must be at least (nlat+1)/2.
c
c     jdvw   the second dimension of the arrays v,w as it appears in
c            the program that calls vhagc. jdvw must be at least nlon.
c
c     mdab   the first dimension of the arrays br,bi,cr, and ci as it
c            appears in the program that calls vhagc. mdab must be at
c            least min0(nlat,nlon/2) if nlon is even or at least
c            min0(nlat,(nlon+1)/2) if nlon is odd.
c
c     ndab   the second dimension of the arrays br,bi,cr, and ci as it
c            appears in the program that calls vhagc. ndab must be at
c            least nlat.
c
c     wvhagc an array which must be initialized by subroutine vhagci.
c            once initialized, wvhagc can be used repeatedly by vhagc
c            as long as nlon and nlat remain unchanged.  wvhagc must
c            not be altered between calls of vhagc.
c
c     lvhagc the dimension of the array wvhagc as it appears in the
c            program that calls vhagc. define
c
c               l1 = min0(nlat,nlon/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            then lvhagc must be at least
c
c               4*nlat*l2+3*max0(l1-2,0)*(2*nlat-l1-1)+nlon+l2+15
c
c
c     work   a work array that does not have to be saved.
c
c     lwork  the dimension of the array work as it appears in the
c            program that calls vhagc. define
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            if ityp .le. 2 then lwork must be at least
c
c               2*nlat*(2*nlon*nt+3*l2)
c
c            if ityp .gt. 2 then lwork must be at least
c
c               2*l2*(2*nlon*nt+3*nlat)
c
c
c
c     **************************************************************
c
c     output parameters
c
c     br,bi  two or three dimensional arrays (see input parameter nt)
c     cr,ci  that contain the vector spherical harmonic coefficients
c            in the spectral representation of v(i,j) and w(i,j) given
c            in the discription of subroutine vhsec. br(mp1,np1),
c            bi(mp1,np1),cr(mp1,np1), and ci(mp1,np1) are computed
c            for mp1=1,...,mmax and np1=mp1,...,nlat except for np1=nlat
c            and odd mp1. mmax=min0(nlat,nlon/2) if nlon is even or
c            mmax=min0(nlat,(nlon+1)/2) if nlon is odd.
c
c     ierror = 0  no errors
c            = 1  error in the specification of nlat
c            = 2  error in the specification of nlon
c            = 3  error in the specification of ityp
c            = 4  error in the specification of nt
c            = 5  error in the specification of idvw
c            = 6  error in the specification of jdvw
c            = 7  error in the specification of mdab
c            = 8  error in the specification of ndab
c            = 9  error in the specification of lvhagc
c            = 10 error in the specification of lwork
c
c ****************************************************************
c
c     subroutine vhagci(nlat,nlon,wvhagc,lvhagc,dwork,ldwork,ierror)
c
c     subroutine vhagci initializes the array wvhagc which can then be
c     used repeatedly by subroutine vhagc until nlat or nlon is changed.
c
c     input parameters
c
c     nlat   the number of points in the gaussian colatitude grid on the
C*PL*ERROR* Comment line too long
c            full sphere. these lie in the interval (0,pi) and are computed
C*PL*ERROR* Comment line too long
c            in radians in theta(1) <...< theta(nlat) by subroutine gaqd.
C*PL*ERROR* Comment line too long
c            if nlat is odd the equator will be included as the grid point
c            theta((nlat+1)/2).  if nlat is even the equator will be
c            excluded as a grid point and will lie half way between
c            theta(nlat/2) and theta(nlat/2+1). nlat must be at least 3.
c            note: on the half sphere, the number of grid points in the
c            colatitudinal direction is nlat/2 if nlat is even or
c            (nlat+1)/2 if nlat is odd.
c
c     nlon   the number of distinct londitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater
c            than zero. the axisymmetric case corresponds to nlon=1.
c            the efficiency of the computation is improved when nlon
c            is a product of small prime numbers.
c
c     lvhagc the dimension of the array wvhagc as it appears in the
c            program that calls vhagci.  define
c
c               l1 = min0(nlat,nlon/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            then lvhagc must be at least
c
c               4*nlat*l2+3*max0(l1-2,0)*(2*nlat-l1-1)+nlon+l2+15
c
c
C*PL*ERROR* Comment line too long
c     dwork  a double precision work array that does not need to be saved
c
c     ldwork the dimension of the array dwork as it appears in the
c            program that calls vhagci. ldwork must be at least
c
c               2*nlat*(nlat+1)+1
c
c
c     **************************************************************
c
c     output parameters
c
c     wvhagc an array which is initialized for use by subroutine vhagc.
c            once initialized, wvhagc can be used repeatedly by vhagc
c            as long as nlat and nlon remain unchanged.  wvhagc must not
c            be altered between calls of vhagc.
c
c
c     ierror = 0  no errors
c            = 1  error in the specification of nlat
c            = 2  error in the specification of nlon
c            = 3  error in the specification of lvhagc
c            = 4  error in the specification of lwork
c
      SUBROUTINE DVHAGC(NLAT,NLON,ITYP,NT,V,W,IDVW,JDVW,BR,BI,CR,CI,
     +                  MDAB,NDAB,WVHAGC,LVHAGC,WORK,LWORK,IERROR)
      DOUBLE PRECISION V
      DOUBLE PRECISION W
      DOUBLE PRECISION BR
      DOUBLE PRECISION BI
      DOUBLE PRECISION CR
      DOUBLE PRECISION CI
      DOUBLE PRECISION WVHAGC
      DOUBLE PRECISION WORK
      DIMENSION V(IDVW,JDVW,1),W(IDVW,JDVW,1),BR(MDAB,NDAB,1),
     +          BI(MDAB,NDAB,1),CR(MDAB,NDAB,1),CI(MDAB,NDAB,1),WORK(1),
     +          WVHAGC(1)

      IERROR = 1
      IF (NLAT.LT.3) RETURN
      IERROR = 2
      IF (NLON.LT.1) RETURN
      IERROR = 3
      IF (ITYP.LT.0 .OR. ITYP.GT.8) RETURN
      IERROR = 4
      IF (NT.LT.0) RETURN
      IERROR = 5
      IMID = (NLAT+1)/2
      IF ((ITYP.LE.2.AND.IDVW.LT.NLAT) .OR.
     +    (ITYP.GT.2.AND.IDVW.LT.IMID)) RETURN
      IERROR = 6
      IF (JDVW.LT.NLON) RETURN
      IERROR = 7
      MMAX = MIN0(NLAT, (NLON+1)/2)
      IF (MDAB.LT.MMAX) RETURN
      IERROR = 8
      IF (NDAB.LT.NLAT) RETURN
      IERROR = 9
      LZZ1 = 2*NLAT*IMID
      LABC = 3* (MAX0(MMAX-2,0)* (NLAT+NLAT-MMAX-1))/2
      IF (LVHAGC.LT.2* (LZZ1+LABC)+NLON+IMID+15) RETURN
      IERROR = 10
      IF (ITYP.LE.2 .AND. LWORK.LT.NLAT* (4*NLON*NT+6*IMID)) RETURN
      IF (ITYP.GT.2 .AND. LWORK.LT.IMID* (4*NLON*NT+6*NLAT)) RETURN
      IERROR = 0
      IDV = NLAT
      IF (ITYP.GT.2) IDV = IMID
      LNL = NT*IDV*NLON
      IST = 0
      IF (ITYP.LE.2) IST = IMID
      IW1 = IST + 1
      IW2 = LNL + 1
      IW3 = IW2 + IST
      IW4 = IW2 + LNL
      IW5 = IW4 + 3*IMID*NLAT
      LWZVIN = LZZ1 + LABC
      JW1 = (NLAT+1)/2 + 1
      JW2 = JW1 + LWZVIN
      JW3 = JW2 + LWZVIN
      CALL DVHAGC1(NLAT,NLON,ITYP,NT,IMID,IDVW,JDVW,V,W,MDAB,NDAB,BR,
     +             BI,CR,CI,IDV,WORK,WORK(IW1),WORK(IW2),WORK(IW3),
     +             WORK(IW4),WORK(IW5),WVHAGC,WVHAGC(JW1),WVHAGC(JW2),
     +             WVHAGC(JW3))
      RETURN
      END
      SUBROUTINE DVHAGC1(NLAT,NLON,ITYP,NT,IMID,IDVW,JDVW,V,W,MDAB,NDAB,
     +                  BR,BI,CR,CI,IDV,VE,VO,WE,WO,VB,WB,WTS,WVBIN,
     +                  WWBIN,WRFFT)
      DOUBLE PRECISION V
      DOUBLE PRECISION W
      DOUBLE PRECISION BR
      DOUBLE PRECISION BI
      DOUBLE PRECISION CR
      DOUBLE PRECISION CI
      DOUBLE PRECISION VE
      DOUBLE PRECISION VO
      DOUBLE PRECISION WE
      DOUBLE PRECISION WO
      DOUBLE PRECISION VB
      DOUBLE PRECISION WB
      DOUBLE PRECISION WTS
      DOUBLE PRECISION WVBIN
      DOUBLE PRECISION WWBIN
      DOUBLE PRECISION WRFFT
      DOUBLE PRECISION TSN
      DOUBLE PRECISION FSN
      DOUBLE PRECISION TV
      DOUBLE PRECISION TW
      DOUBLE PRECISION TVO1
      DOUBLE PRECISION TVO2
      DOUBLE PRECISION TVE1
      DOUBLE PRECISION TVE2
      DOUBLE PRECISION TWO1
      DOUBLE PRECISION TWO2
      DOUBLE PRECISION TWE1
      DOUBLE PRECISION TWE2
      DIMENSION V(IDVW,JDVW,1),W(IDVW,JDVW,1),BR(MDAB,NDAB,1),
     +          BI(MDAB,NDAB,1),CR(MDAB,NDAB,1),CI(MDAB,NDAB,1),
     +          VE(IDV,NLON,1),VO(IDV,NLON,1),WE(IDV,NLON,1),
     +          WO(IDV,NLON,1),WTS(*),WVBIN(1),WWBIN(1),WRFFT(1),
     +          VB(IMID,NLAT,3),WB(IMID,NLAT,3)

      NLP1 = NLAT + 1
      TSN = 2.D0/NLON
      FSN = 4.D0/NLON
      MLAT = MOD(NLAT,2)
      MLON = MOD(NLON,2)
      MMAX = MIN0(NLAT, (NLON+1)/2)
      IMM1 = IMID
      IF (MLAT.NE.0) IMM1 = IMID - 1
      IF (ITYP.GT.2) GO TO 3
      DO 5 K = 1,NT
          DO 5 I = 1,IMM1
              DO 5 J = 1,NLON
                  VE(I,J,K) = TSN* (V(I,J,K)+V(NLP1-I,J,K))
                  VO(I,J,K) = TSN* (V(I,J,K)-V(NLP1-I,J,K))
                  WE(I,J,K) = TSN* (W(I,J,K)+W(NLP1-I,J,K))
                  WO(I,J,K) = TSN* (W(I,J,K)-W(NLP1-I,J,K))
    5 CONTINUE
      GO TO 2
    3 DO 8 K = 1,NT
          DO 8 I = 1,IMM1
              DO 8 J = 1,NLON
                  VE(I,J,K) = FSN*V(I,J,K)
                  VO(I,J,K) = FSN*V(I,J,K)
                  WE(I,J,K) = FSN*W(I,J,K)
                  WO(I,J,K) = FSN*W(I,J,K)
    8 CONTINUE
    2 IF (MLAT.EQ.0) GO TO 7
      DO 6 K = 1,NT
          DO 6 J = 1,NLON
              VE(IMID,J,K) = TSN*V(IMID,J,K)
              WE(IMID,J,K) = TSN*W(IMID,J,K)
    6 CONTINUE
    7 DO 9 K = 1,NT
          CALL DHRFFTF(IDV,NLON,VE(1,1,K),IDV,WRFFT,VB)
          CALL DHRFFTF(IDV,NLON,WE(1,1,K),IDV,WRFFT,VB)
    9 CONTINUE
      NDO1 = NLAT
      NDO2 = NLAT
      IF (MLAT.NE.0) NDO1 = NLAT - 1
      IF (MLAT.EQ.0) NDO2 = NLAT - 1
      IF (ITYP.EQ.2 .OR. ITYP.EQ.5 .OR. ITYP.EQ.8) GO TO 11
      DO 10 K = 1,NT
          DO 10 MP1 = 1,MMAX
              DO 10 NP1 = MP1,NLAT
                  BR(MP1,NP1,K) = 0.D0
                  BI(MP1,NP1,K) = 0.D0
   10 CONTINUE
   11 IF (ITYP.EQ.1 .OR. ITYP.EQ.4 .OR. ITYP.EQ.7) GO TO 13
      DO 12 K = 1,NT
          DO 12 MP1 = 1,MMAX
              DO 12 NP1 = MP1,NLAT
                  CR(MP1,NP1,K) = 0.D0
                  CI(MP1,NP1,K) = 0.D0
   12 CONTINUE
   13 ITYPP = ITYP + 1
      GO TO (1,100,200,300,400,500,600,700,800) ITYPP
c
c     case ityp=0 ,  no symmetries
c
    1 CALL DVBIN(0,NLAT,NLON,0,VB,IV,WVBIN)
c
c     case m=0
c
      DO 15 K = 1,NT
          DO 1015 I = 1,IMID
              TV = VE(I,1,K)*WTS(I)
              TW = WE(I,1,K)*WTS(I)
              DO 10015 NP1 = 2,NDO2,2
                  BR(1,NP1,K) = BR(1,NP1,K) + VB(I,NP1,IV)*TV
                  CR(1,NP1,K) = CR(1,NP1,K) - VB(I,NP1,IV)*TW
10015         CONTINUE
 1015     CONTINUE
   15 CONTINUE
      DO 16 K = 1,NT
          DO 1016 I = 1,IMM1
              TV = VO(I,1,K)*WTS(I)
              TW = WO(I,1,K)*WTS(I)
              DO 10016 NP1 = 3,NDO1,2
                  BR(1,NP1,K) = BR(1,NP1,K) + VB(I,NP1,IV)*TV
                  CR(1,NP1,K) = CR(1,NP1,K) - VB(I,NP1,IV)*TW
10016         CONTINUE
 1016     CONTINUE
   16 CONTINUE
c
c     case m = 1 through nlat-1
c
      IF (MMAX.LT.2) RETURN
      DO 20 MP1 = 2,MMAX
          M = MP1 - 1
          MP2 = MP1 + 1
          CALL DVBIN(0,NLAT,NLON,M,VB,IV,WVBIN)
          CALL DWBIN(0,NLAT,NLON,M,WB,IW,WWBIN)
          IF (MP1.GT.NDO1) GO TO 17
          DO 23 K = 1,NT
              DO 1023 I = 1,IMM1
c
c     set temps to optimize quadrature
c
                  TVO1 = VO(I,2*MP1-1,K)*WTS(I)
                  TVO2 = VO(I,2*MP1-2,K)*WTS(I)
                  TVE1 = VE(I,2*MP1-1,K)*WTS(I)
                  TVE2 = VE(I,2*MP1-2,K)*WTS(I)
                  TWO1 = WO(I,2*MP1-1,K)*WTS(I)
                  TWO2 = WO(I,2*MP1-2,K)*WTS(I)
                  TWE1 = WE(I,2*MP1-1,K)*WTS(I)
                  TWE2 = WE(I,2*MP1-2,K)*WTS(I)
                  DO 10023 NP1 = MP1,NDO1,2
                      BR(MP1,NP1,K) = BR(MP1,NP1,K) +
     +                                VB(I,NP1,IV)*TVO2 +
     +                                WB(I,NP1,IW)*TWE1
                      BI(MP1,NP1,K) = BI(MP1,NP1,K) +
     +                                VB(I,NP1,IV)*TVO1 -
     +                                WB(I,NP1,IW)*TWE2
                      CR(MP1,NP1,K) = CR(MP1,NP1,K) -
     +                                VB(I,NP1,IV)*TWO2 +
     +                                WB(I,NP1,IW)*TVE1
                      CI(MP1,NP1,K) = CI(MP1,NP1,K) -
     +                                VB(I,NP1,IV)*TWO1 -
     +                                WB(I,NP1,IW)*TVE2
10023             CONTINUE
 1023         CONTINUE
   23     CONTINUE

          IF (MLAT.EQ.0) GO TO 17
          I = IMID
          DO 24 K = 1,NT
              DO 1024 NP1 = MP1,NDO1,2
                  BR(MP1,NP1,K) = BR(MP1,NP1,K) +
     +                            WB(I,NP1,IW)*WE(I,2*MP1-1,K)*WTS(I)
                  BI(MP1,NP1,K) = BI(MP1,NP1,K) -
     +                            WB(I,NP1,IW)*WE(I,2*MP1-2,K)*WTS(I)
                  CR(MP1,NP1,K) = CR(MP1,NP1,K) +
     +                            WB(I,NP1,IW)*VE(I,2*MP1-1,K)*WTS(I)
                  CI(MP1,NP1,K) = CI(MP1,NP1,K) -
     +                            WB(I,NP1,IW)*VE(I,2*MP1-2,K)*WTS(I)
 1024         CONTINUE
   24     CONTINUE
   17     IF (MP2.GT.NDO2) GO TO 20
          DO 21 K = 1,NT
              DO 1021 I = 1,IMM1
                  TVO1 = VO(I,2*MP1-1,K)*WTS(I)
                  TVO2 = VO(I,2*MP1-2,K)*WTS(I)
                  TVE1 = VE(I,2*MP1-1,K)*WTS(I)
                  TVE2 = VE(I,2*MP1-2,K)*WTS(I)
                  TWO1 = WO(I,2*MP1-1,K)*WTS(I)
                  TWO2 = WO(I,2*MP1-2,K)*WTS(I)
                  TWE1 = WE(I,2*MP1-1,K)*WTS(I)
                  TWE2 = WE(I,2*MP1-2,K)*WTS(I)
                  DO 10021 NP1 = MP2,NDO2,2
                      BR(MP1,NP1,K) = BR(MP1,NP1,K) +
     +                                VB(I,NP1,IV)*TVE2 +
     +                                WB(I,NP1,IW)*TWO1
                      BI(MP1,NP1,K) = BI(MP1,NP1,K) +
     +                                VB(I,NP1,IV)*TVE1 -
     +                                WB(I,NP1,IW)*TWO2
                      CR(MP1,NP1,K) = CR(MP1,NP1,K) -
     +                                VB(I,NP1,IV)*TWE2 +
     +                                WB(I,NP1,IW)*TVO1
                      CI(MP1,NP1,K) = CI(MP1,NP1,K) -
     +                                VB(I,NP1,IV)*TWE1 -
     +                                WB(I,NP1,IW)*TVO2
10021             CONTINUE
 1021         CONTINUE
   21     CONTINUE

          IF (MLAT.EQ.0) GO TO 20
          I = IMID
          DO 22 K = 1,NT
              DO 1022 NP1 = MP2,NDO2,2
                  BR(MP1,NP1,K) = BR(MP1,NP1,K) +
     +                            VB(I,NP1,IV)*VE(I,2*MP1-2,K)*WTS(I)
                  BI(MP1,NP1,K) = BI(MP1,NP1,K) +
     +                            VB(I,NP1,IV)*VE(I,2*MP1-1,K)*WTS(I)
                  CR(MP1,NP1,K) = CR(MP1,NP1,K) -
     +                            VB(I,NP1,IV)*WE(I,2*MP1-2,K)*WTS(I)
                  CI(MP1,NP1,K) = CI(MP1,NP1,K) -
     +                            VB(I,NP1,IV)*WE(I,2*MP1-1,K)*WTS(I)
 1022         CONTINUE
   22     CONTINUE
   20 CONTINUE
      RETURN
c
c     case ityp=1 ,  no symmetries but cr and ci equal zero
c
  100 CALL DVBIN(0,NLAT,NLON,0,VB,IV,WVBIN)
c
c     case m=0
c
      DO 115 K = 1,NT
          DO 115 I = 1,IMID
              TV = VE(I,1,K)*WTS(I)
              DO 115 NP1 = 2,NDO2,2
                  BR(1,NP1,K) = BR(1,NP1,K) + VB(I,NP1,IV)*TV
  115 CONTINUE
      DO 116 K = 1,NT
          DO 116 I = 1,IMM1
              TV = VO(I,1,K)*WTS(I)
              DO 116 NP1 = 3,NDO1,2
                  BR(1,NP1,K) = BR(1,NP1,K) + VB(I,NP1,IV)*TV
  116 CONTINUE
c
c     case m = 1 through nlat-1
c
      IF (MMAX.LT.2) RETURN
      DO 120 MP1 = 2,MMAX
          M = MP1 - 1
          MP2 = MP1 + 1
          CALL DVBIN(0,NLAT,NLON,M,VB,IV,WVBIN)
          CALL DWBIN(0,NLAT,NLON,M,WB,IW,WWBIN)
          IF (MP1.GT.NDO1) GO TO 117
          DO 123 K = 1,NT
              DO 123 I = 1,IMM1
                  TVO1 = VO(I,2*MP1-1,K)*WTS(I)
                  TVO2 = VO(I,2*MP1-2,K)*WTS(I)
                  TWE1 = WE(I,2*MP1-1,K)*WTS(I)
                  TWE2 = WE(I,2*MP1-2,K)*WTS(I)
                  DO 123 NP1 = MP1,NDO1,2
                      BR(MP1,NP1,K) = BR(MP1,NP1,K) +
     +                                VB(I,NP1,IV)*TVO2 +
     +                                WB(I,NP1,IW)*TWE1
                      BI(MP1,NP1,K) = BI(MP1,NP1,K) +
     +                                VB(I,NP1,IV)*TVO1 -
     +                                WB(I,NP1,IW)*TWE2
  123     CONTINUE
          IF (MLAT.EQ.0) GO TO 117
          I = IMID
          DO 124 K = 1,NT
              DO 124 NP1 = MP1,NDO1,2
                  BR(MP1,NP1,K) = BR(MP1,NP1,K) +
     +                            WB(I,NP1,IW)*WE(I,2*MP1-1,K)*WTS(I)
                  BI(MP1,NP1,K) = BI(MP1,NP1,K) -
     +                            WB(I,NP1,IW)*WE(I,2*MP1-2,K)*WTS(I)
  124     CONTINUE
  117     IF (MP2.GT.NDO2) GO TO 120
          DO 121 K = 1,NT
              DO 121 I = 1,IMM1
                  TVE1 = VE(I,2*MP1-1,K)*WTS(I)
                  TVE2 = VE(I,2*MP1-2,K)*WTS(I)
                  TWO1 = WO(I,2*MP1-1,K)*WTS(I)
                  TWO2 = WO(I,2*MP1-2,K)*WTS(I)
                  DO 121 NP1 = MP2,NDO2,2
                      BR(MP1,NP1,K) = BR(MP1,NP1,K) +
     +                                VB(I,NP1,IV)*TVE2 +
     +                                WB(I,NP1,IW)*TWO1
                      BI(MP1,NP1,K) = BI(MP1,NP1,K) +
     +                                VB(I,NP1,IV)*TVE1 -
     +                                WB(I,NP1,IW)*TWO2
  121     CONTINUE
          IF (MLAT.EQ.0) GO TO 120
          I = IMID
          DO 122 K = 1,NT
              DO 122 NP1 = MP2,NDO2,2
                  BR(MP1,NP1,K) = BR(MP1,NP1,K) +
     +                            VB(I,NP1,IV)*VE(I,2*MP1-2,K)*WTS(I)
                  BI(MP1,NP1,K) = BI(MP1,NP1,K) +
     +                            VB(I,NP1,IV)*VE(I,2*MP1-1,K)*WTS(I)
  122     CONTINUE
  120 CONTINUE
      RETURN
c
c     case ityp=2 ,  no symmetries but br and bi equal zero
c
  200 CALL DVBIN(0,NLAT,NLON,0,VB,IV,WVBIN)
c
c     case m=0
c
      DO 215 K = 1,NT
          DO 215 I = 1,IMID
              TW = WE(I,1,K)*WTS(I)
              DO 215 NP1 = 2,NDO2,2
                  CR(1,NP1,K) = CR(1,NP1,K) - VB(I,NP1,IV)*TW
  215 CONTINUE
      DO 216 K = 1,NT
          DO 216 I = 1,IMM1
              TW = WO(I,1,K)*WTS(I)
              DO 216 NP1 = 3,NDO1,2
                  CR(1,NP1,K) = CR(1,NP1,K) - VB(I,NP1,IV)*TW
  216 CONTINUE
c
c     case m = 1 through nlat-1
c
      IF (MMAX.LT.2) RETURN
      DO 220 MP1 = 2,MMAX
          M = MP1 - 1
          MP2 = MP1 + 1
          CALL DVBIN(0,NLAT,NLON,M,VB,IV,WVBIN)
          CALL DWBIN(0,NLAT,NLON,M,WB,IW,WWBIN)
          IF (MP1.GT.NDO1) GO TO 217
          DO 223 K = 1,NT
              DO 223 I = 1,IMM1
                  TVE1 = VE(I,2*MP1-1,K)*WTS(I)
                  TVE2 = VE(I,2*MP1-2,K)*WTS(I)
                  TWO1 = WO(I,2*MP1-1,K)*WTS(I)
                  TWO2 = WO(I,2*MP1-2,K)*WTS(I)
                  DO 223 NP1 = MP1,NDO1,2
                      CR(MP1,NP1,K) = CR(MP1,NP1,K) -
     +                                VB(I,NP1,IV)*TWO2 +
     +                                WB(I,NP1,IW)*TVE1
                      CI(MP1,NP1,K) = CI(MP1,NP1,K) -
     +                                VB(I,NP1,IV)*TWO1 -
     +                                WB(I,NP1,IW)*TVE2
  223     CONTINUE
          IF (MLAT.EQ.0) GO TO 217
          I = IMID
          DO 224 K = 1,NT
              DO 224 NP1 = MP1,NDO1,2
                  CR(MP1,NP1,K) = CR(MP1,NP1,K) +
     +                            WB(I,NP1,IW)*VE(I,2*MP1-1,K)*WTS(I)
                  CI(MP1,NP1,K) = CI(MP1,NP1,K) -
     +                            WB(I,NP1,IW)*VE(I,2*MP1-2,K)*WTS(I)
  224     CONTINUE
  217     IF (MP2.GT.NDO2) GO TO 220
          DO 221 K = 1,NT
              DO 221 I = 1,IMM1
                  TWE1 = WE(I,2*MP1-1,K)*WTS(I)
                  TWE2 = WE(I,2*MP1-2,K)*WTS(I)
                  TVO1 = VO(I,2*MP1-1,K)*WTS(I)
                  TVO2 = VO(I,2*MP1-2,K)*WTS(I)
                  DO 221 NP1 = MP2,NDO2,2
                      CR(MP1,NP1,K) = CR(MP1,NP1,K) -
     +                                VB(I,NP1,IV)*TWE2 +
     +                                WB(I,NP1,IW)*TVO1
                      CI(MP1,NP1,K) = CI(MP1,NP1,K) -
     +                                VB(I,NP1,IV)*TWE1 -
     +                                WB(I,NP1,IW)*TVO2
  221     CONTINUE
          IF (MLAT.EQ.0) GO TO 220
          I = IMID
          DO 222 K = 1,NT
              DO 222 NP1 = MP2,NDO2,2
                  CR(MP1,NP1,K) = CR(MP1,NP1,K) -
     +                            VB(I,NP1,IV)*WE(I,2*MP1-2,K)*WTS(I)
                  CI(MP1,NP1,K) = CI(MP1,NP1,K) -
     +                            VB(I,NP1,IV)*WE(I,2*MP1-1,K)*WTS(I)
  222     CONTINUE
  220 CONTINUE
      RETURN
c
c     case ityp=3 ,  v even , w odd
c
  300 CALL DVBIN(0,NLAT,NLON,0,VB,IV,WVBIN)
c
c     case m=0
c
      DO 315 K = 1,NT
          DO 315 I = 1,IMID
              TV = VE(I,1,K)*WTS(I)
              DO 315 NP1 = 2,NDO2,2
                  BR(1,NP1,K) = BR(1,NP1,K) + VB(I,NP1,IV)*TV
  315 CONTINUE
      DO 316 K = 1,NT
          DO 316 I = 1,IMM1
              TW = WO(I,1,K)*WTS(I)
              DO 316 NP1 = 3,NDO1,2
                  CR(1,NP1,K) = CR(1,NP1,K) - VB(I,NP1,IV)*TW
  316 CONTINUE
c
c     case m = 1 through nlat-1
c
      IF (MMAX.LT.2) RETURN
      DO 320 MP1 = 2,MMAX
          M = MP1 - 1
          MP2 = MP1 + 1
          CALL DVBIN(0,NLAT,NLON,M,VB,IV,WVBIN)
          CALL DWBIN(0,NLAT,NLON,M,WB,IW,WWBIN)
          IF (MP1.GT.NDO1) GO TO 317
          DO 323 K = 1,NT
              DO 323 I = 1,IMM1
                  TWO1 = WO(I,2*MP1-1,K)*WTS(I)
                  TWO2 = WO(I,2*MP1-2,K)*WTS(I)
                  TVE1 = VE(I,2*MP1-1,K)*WTS(I)
                  TVE2 = VE(I,2*MP1-2,K)*WTS(I)
                  DO 323 NP1 = MP1,NDO1,2
                      CR(MP1,NP1,K) = CR(MP1,NP1,K) -
     +                                VB(I,NP1,IV)*TWO2 +
     +                                WB(I,NP1,IW)*TVE1
                      CI(MP1,NP1,K) = CI(MP1,NP1,K) -
     +                                VB(I,NP1,IV)*TWO1 -
     +                                WB(I,NP1,IW)*TVE2
  323     CONTINUE
          IF (MLAT.EQ.0) GO TO 317
          I = IMID
          DO 324 K = 1,NT
              DO 324 NP1 = MP1,NDO1,2
                  CR(MP1,NP1,K) = CR(MP1,NP1,K) +
     +                            WB(I,NP1,IW)*VE(I,2*MP1-1,K)*WTS(I)
                  CI(MP1,NP1,K) = CI(MP1,NP1,K) -
     +                            WB(I,NP1,IW)*VE(I,2*MP1-2,K)*WTS(I)
  324     CONTINUE
  317     IF (MP2.GT.NDO2) GO TO 320
          DO 321 K = 1,NT
              DO 321 I = 1,IMM1
                  TWO1 = WO(I,2*MP1-1,K)*WTS(I)
                  TWO2 = WO(I,2*MP1-2,K)*WTS(I)
                  TVE1 = VE(I,2*MP1-1,K)*WTS(I)
                  TVE2 = VE(I,2*MP1-2,K)*WTS(I)
                  DO 321 NP1 = MP2,NDO2,2
                      BR(MP1,NP1,K) = BR(MP1,NP1,K) +
     +                                VB(I,NP1,IV)*TVE2 +
     +                                WB(I,NP1,IW)*TWO1
                      BI(MP1,NP1,K) = BI(MP1,NP1,K) +
     +                                VB(I,NP1,IV)*TVE1 -
     +                                WB(I,NP1,IW)*TWO2
  321     CONTINUE
          IF (MLAT.EQ.0) GO TO 320
          I = IMID
          DO 322 K = 1,NT
              DO 322 NP1 = MP2,NDO2,2
                  BR(MP1,NP1,K) = BR(MP1,NP1,K) +
     +                            VB(I,NP1,IV)*VE(I,2*MP1-2,K)*WTS(I)
                  BI(MP1,NP1,K) = BI(MP1,NP1,K) +
     +                            VB(I,NP1,IV)*VE(I,2*MP1-1,K)*WTS(I)
  322     CONTINUE
  320 CONTINUE
      RETURN
c
c     case ityp=4 ,  v even, w odd, and cr and ci equal 0.
c
  400 CALL DVBIN(1,NLAT,NLON,0,VB,IV,WVBIN)
c
c     case m=0
c
      DO 415 K = 1,NT
          DO 415 I = 1,IMID
              TV = VE(I,1,K)*WTS(I)
              DO 415 NP1 = 2,NDO2,2
                  BR(1,NP1,K) = BR(1,NP1,K) + VB(I,NP1,IV)*TV
  415 CONTINUE
c
c     case m = 1 through nlat-1
c
      IF (MMAX.LT.2) RETURN
      DO 420 MP1 = 2,MMAX
          M = MP1 - 1
          MP2 = MP1 + 1
          CALL DVBIN(1,NLAT,NLON,M,VB,IV,WVBIN)
          CALL DWBIN(1,NLAT,NLON,M,WB,IW,WWBIN)
          IF (MP2.GT.NDO2) GO TO 420
          DO 421 K = 1,NT
              DO 421 I = 1,IMM1
                  TWO1 = WO(I,2*MP1-1,K)*WTS(I)
                  TWO2 = WO(I,2*MP1-2,K)*WTS(I)
                  TVE1 = VE(I,2*MP1-1,K)*WTS(I)
                  TVE2 = VE(I,2*MP1-2,K)*WTS(I)
                  DO 421 NP1 = MP2,NDO2,2
                      BR(MP1,NP1,K) = BR(MP1,NP1,K) +
     +                                VB(I,NP1,IV)*TVE2 +
     +                                WB(I,NP1,IW)*TWO1
                      BI(MP1,NP1,K) = BI(MP1,NP1,K) +
     +                                VB(I,NP1,IV)*TVE1 -
     +                                WB(I,NP1,IW)*TWO2
  421     CONTINUE
          IF (MLAT.EQ.0) GO TO 420
          I = IMID
          DO 422 K = 1,NT
              DO 422 NP1 = MP2,NDO2,2
                  BR(MP1,NP1,K) = BR(MP1,NP1,K) +
     +                            VB(I,NP1,IV)*VE(I,2*MP1-2,K)*WTS(I)
                  BI(MP1,NP1,K) = BI(MP1,NP1,K) +
     +                            VB(I,NP1,IV)*VE(I,2*MP1-1,K)*WTS(I)
  422     CONTINUE
  420 CONTINUE
      RETURN
c
c     case ityp=5   v even, w odd, and br and bi equal zero
c
  500 CALL DVBIN(2,NLAT,NLON,0,VB,IV,WVBIN)
c
c     case m=0
c
      DO 516 K = 1,NT
          DO 516 I = 1,IMM1
              TW = WO(I,1,K)*WTS(I)
              DO 516 NP1 = 3,NDO1,2
                  CR(1,NP1,K) = CR(1,NP1,K) - VB(I,NP1,IV)*TW
  516 CONTINUE
c
c     case m = 1 through nlat-1
c
      IF (MMAX.LT.2) RETURN
      DO 520 MP1 = 2,MMAX
          M = MP1 - 1
          MP2 = MP1 + 1
          CALL DVBIN(2,NLAT,NLON,M,VB,IV,WVBIN)
          CALL DWBIN(2,NLAT,NLON,M,WB,IW,WWBIN)
          IF (MP1.GT.NDO1) GO TO 520
          DO 523 K = 1,NT
              DO 523 I = 1,IMM1
                  TWO1 = WO(I,2*MP1-1,K)*WTS(I)
                  TWO2 = WO(I,2*MP1-2,K)*WTS(I)
                  TVE1 = VE(I,2*MP1-1,K)*WTS(I)
                  TVE2 = VE(I,2*MP1-2,K)*WTS(I)
                  DO 523 NP1 = MP1,NDO1,2
                      CR(MP1,NP1,K) = CR(MP1,NP1,K) -
     +                                VB(I,NP1,IV)*TWO2 +
     +                                WB(I,NP1,IW)*TVE1
                      CI(MP1,NP1,K) = CI(MP1,NP1,K) -
     +                                VB(I,NP1,IV)*TWO1 -
     +                                WB(I,NP1,IW)*TVE2
  523     CONTINUE
          IF (MLAT.EQ.0) GO TO 520
          I = IMID
          DO 524 K = 1,NT
              DO 524 NP1 = MP1,NDO1,2
                  CR(MP1,NP1,K) = CR(MP1,NP1,K) +
     +                            WB(I,NP1,IW)*VE(I,2*MP1-1,K)*WTS(I)
                  CI(MP1,NP1,K) = CI(MP1,NP1,K) -
     +                            WB(I,NP1,IW)*VE(I,2*MP1-2,K)*WTS(I)
  524     CONTINUE
  520 CONTINUE
      RETURN
c
c     case ityp=6 ,  v odd , w even
c
  600 CALL DVBIN(0,NLAT,NLON,0,VB,IV,WVBIN)
c
c     case m=0
c
      DO 615 K = 1,NT
          DO 615 I = 1,IMID
              TW = WE(I,1,K)*WTS(I)
              DO 615 NP1 = 2,NDO2,2
                  CR(1,NP1,K) = CR(1,NP1,K) - VB(I,NP1,IV)*TW
  615 CONTINUE
      DO 616 K = 1,NT
          DO 616 I = 1,IMM1
              TV = VO(I,1,K)*WTS(I)
              DO 616 NP1 = 3,NDO1,2
                  BR(1,NP1,K) = BR(1,NP1,K) + VB(I,NP1,IV)*TV
  616 CONTINUE
c
c     case m = 1 through nlat-1
c
      IF (MMAX.LT.2) RETURN
      DO 620 MP1 = 2,MMAX
          M = MP1 - 1
          MP2 = MP1 + 1
          CALL DVBIN(0,NLAT,NLON,M,VB,IV,WVBIN)
          CALL DWBIN(0,NLAT,NLON,M,WB,IW,WWBIN)
          IF (MP1.GT.NDO1) GO TO 617
          DO 623 K = 1,NT
              DO 623 I = 1,IMM1
                  TWE1 = WE(I,2*MP1-1,K)*WTS(I)
                  TWE2 = WE(I,2*MP1-2,K)*WTS(I)
                  TVO1 = VO(I,2*MP1-1,K)*WTS(I)
                  TVO2 = VO(I,2*MP1-2,K)*WTS(I)
                  DO 623 NP1 = MP1,NDO1,2
                      BR(MP1,NP1,K) = BR(MP1,NP1,K) +
     +                                VB(I,NP1,IV)*TVO2 +
     +                                WB(I,NP1,IW)*TWE1
                      BI(MP1,NP1,K) = BI(MP1,NP1,K) +
     +                                VB(I,NP1,IV)*TVO1 -
     +                                WB(I,NP1,IW)*TWE2
  623     CONTINUE
          IF (MLAT.EQ.0) GO TO 617
          I = IMID
          DO 624 K = 1,NT
              DO 624 NP1 = MP1,NDO1,2
                  BR(MP1,NP1,K) = BR(MP1,NP1,K) +
     +                            WB(I,NP1,IW)*WE(I,2*MP1-1,K)*WTS(I)
                  BI(MP1,NP1,K) = BI(MP1,NP1,K) -
     +                            WB(I,NP1,IW)*WE(I,2*MP1-2,K)*WTS(I)
  624     CONTINUE
  617     IF (MP2.GT.NDO2) GO TO 620
          DO 621 K = 1,NT
              DO 621 I = 1,IMM1
                  TWE1 = WE(I,2*MP1-1,K)*WTS(I)
                  TWE2 = WE(I,2*MP1-2,K)*WTS(I)
                  TVO1 = VO(I,2*MP1-1,K)*WTS(I)
                  TVO2 = VO(I,2*MP1-2,K)*WTS(I)
                  DO 621 NP1 = MP2,NDO2,2
                      CR(MP1,NP1,K) = CR(MP1,NP1,K) -
     +                                VB(I,NP1,IV)*TWE2 +
     +                                WB(I,NP1,IW)*TVO1
                      CI(MP1,NP1,K) = CI(MP1,NP1,K) -
     +                                VB(I,NP1,IV)*TWE1 -
     +                                WB(I,NP1,IW)*TVO2
  621     CONTINUE
          IF (MLAT.EQ.0) GO TO 620
          I = IMID
          DO 622 K = 1,NT
              DO 622 NP1 = MP2,NDO2,2
                  CR(MP1,NP1,K) = CR(MP1,NP1,K) -
     +                            VB(I,NP1,IV)*WE(I,2*MP1-2,K)*WTS(I)
                  CI(MP1,NP1,K) = CI(MP1,NP1,K) -
     +                            VB(I,NP1,IV)*WE(I,2*MP1-1,K)*WTS(I)
  622     CONTINUE
  620 CONTINUE
      RETURN
c
c     case ityp=7   v odd, w even, and cr and ci equal zero
c
  700 CALL DVBIN(2,NLAT,NLON,0,VB,IV,WVBIN)
c
c     case m=0
c
      DO 716 K = 1,NT
          DO 716 I = 1,IMM1
              TV = VO(I,1,K)*WTS(I)
              DO 716 NP1 = 3,NDO1,2
                  BR(1,NP1,K) = BR(1,NP1,K) + VB(I,NP1,IV)*TV
  716 CONTINUE
c
c     case m = 1 through nlat-1
c
      IF (MMAX.LT.2) RETURN
      DO 720 MP1 = 2,MMAX
          M = MP1 - 1
          MP2 = MP1 + 1
          CALL DVBIN(2,NLAT,NLON,M,VB,IV,WVBIN)
          CALL DWBIN(2,NLAT,NLON,M,WB,IW,WWBIN)
          IF (MP1.GT.NDO1) GO TO 720
          DO 723 K = 1,NT
              DO 723 I = 1,IMM1
                  TWE1 = WE(I,2*MP1-1,K)*WTS(I)
                  TWE2 = WE(I,2*MP1-2,K)*WTS(I)
                  TVO1 = VO(I,2*MP1-1,K)*WTS(I)
                  TVO2 = VO(I,2*MP1-2,K)*WTS(I)
                  DO 723 NP1 = MP1,NDO1,2
                      BR(MP1,NP1,K) = BR(MP1,NP1,K) +
     +                                VB(I,NP1,IV)*TVO2 +
     +                                WB(I,NP1,IW)*TWE1
                      BI(MP1,NP1,K) = BI(MP1,NP1,K) +
     +                                VB(I,NP1,IV)*TVO1 -
     +                                WB(I,NP1,IW)*TWE2
  723     CONTINUE
          IF (MLAT.EQ.0) GO TO 720
          I = IMID
          DO 724 K = 1,NT
              DO 724 NP1 = MP1,NDO1,2
                  BR(MP1,NP1,K) = BR(MP1,NP1,K) +
     +                            WB(I,NP1,IW)*WE(I,2*MP1-1,K)*WTS(I)
                  BI(MP1,NP1,K) = BI(MP1,NP1,K) -
     +                            WB(I,NP1,IW)*WE(I,2*MP1-2,K)*WTS(I)
  724     CONTINUE
  720 CONTINUE
      RETURN
c
c     case ityp=8   v odd, w even, and both br and bi equal zero
c
  800 CALL DVBIN(1,NLAT,NLON,0,VB,IV,WVBIN)
c
c     case m=0
c
      DO 815 K = 1,NT
          DO 815 I = 1,IMID
              TW = WE(I,1,K)*WTS(I)
              DO 815 NP1 = 2,NDO2,2
                  CR(1,NP1,K) = CR(1,NP1,K) - VB(I,NP1,IV)*TW
  815 CONTINUE
c
c     case m = 1 through nlat-1
c
      IF (MMAX.LT.2) RETURN
      DO 820 MP1 = 2,MMAX
          M = MP1 - 1
          MP2 = MP1 + 1
          CALL DVBIN(1,NLAT,NLON,M,VB,IV,WVBIN)
          CALL DWBIN(1,NLAT,NLON,M,WB,IW,WWBIN)
          IF (MP2.GT.NDO2) GO TO 820
          DO 821 K = 1,NT
              DO 821 I = 1,IMM1
                  TWE1 = WE(I,2*MP1-1,K)*WTS(I)
                  TWE2 = WE(I,2*MP1-2,K)*WTS(I)
                  TVO1 = VO(I,2*MP1-1,K)*WTS(I)
                  TVO2 = VO(I,2*MP1-2,K)*WTS(I)
                  DO 821 NP1 = MP2,NDO2,2
                      CR(MP1,NP1,K) = CR(MP1,NP1,K) -
     +                                VB(I,NP1,IV)*TWE2 +
     +                                WB(I,NP1,IW)*TVO1
                      CI(MP1,NP1,K) = CI(MP1,NP1,K) -
     +                                VB(I,NP1,IV)*TWE1 -
     +                                WB(I,NP1,IW)*TVO2
  821     CONTINUE
          IF (MLAT.EQ.0) GO TO 820
          I = IMID
          DO 822 K = 1,NT
              DO 822 NP1 = MP2,NDO2,2
                  CR(MP1,NP1,K) = CR(MP1,NP1,K) -
     +                            VB(I,NP1,IV)*WE(I,2*MP1-2,K)*WTS(I)
                  CI(MP1,NP1,K) = CI(MP1,NP1,K) -
     +                            VB(I,NP1,IV)*WE(I,2*MP1-1,K)*WTS(I)
  822     CONTINUE
  820 CONTINUE
      RETURN
      END
      SUBROUTINE DVHAGCI(NLAT,NLON,WVHAGC,LVHAGC,DWORK,LDWORK,IERROR)
      DOUBLE PRECISION WVHAGC
      DIMENSION WVHAGC(1)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION DWORK(*)

      IERROR = 1
      IF (NLAT.LT.3) RETURN
      IERROR = 2
      IF (NLON.LT.1) RETURN
      IERROR = 3
      IMID = (NLAT+1)/2
      LZZ1 = 2*NLAT*IMID
      MMAX = MIN0(NLAT, (NLON+1)/2)
      LABC = 3* (MAX0(MMAX-2,0)* (NLAT+NLAT-MMAX-1))/2
      IMID = (NLAT+1)/2
      IF (LVHAGC.LT.2* (LZZ1+LABC)+NLON+IMID+15) RETURN
      IERROR = 4
      IF (LDWORK.LT.2*NLAT* (NLAT+1)+1) RETURN
      IERROR = 0
c
c     compute gaussian points in first nlat+1 words of dwork
c     double precision
c
      LWK = NLAT* (NLAT+2)

      JW1 = 1
c     jw2 = jw1+nlat+nlat
c     jw3 = jw2+nlat+nlat
      JW2 = JW1 + NLAT
      JW3 = JW2 + NLAT
      CALL DGAQD(NLAT,DWORK(JW1),DWORK(JW2),DWORK(JW3),LWK,IERROR)
      IMID = (NLAT+1)/2
c
c     set first imid words of double precision weights in dwork
c     as single precision in first imid words of wvhagc
c
      CALL DSETWTS(IMID,DWORK(NLAT+1),WVHAGC)
c
c     first nlat+1 words of dwork contain  double theta
c
c     iwrk = nlat+2
      IWRK = (NLAT+1)/2 + 1
      IW1 = IMID + 1
      CALL DVBGINT(NLAT,NLON,DWORK,WVHAGC(IW1),DWORK(IWRK))
      LWVBIN = LZZ1 + LABC
      IW2 = IW1 + LWVBIN
      CALL DWBGINT(NLAT,NLON,DWORK,WVHAGC(IW2),DWORK(IWRK))
      IW3 = IW2 + LWVBIN
      CALL DHRFFTI(NLON,WVHAGC(IW3))
      RETURN
      END
      SUBROUTINE DSETWTS(IMID,DWTS,WTS)
      DOUBLE PRECISION WTS
c
c     set first imid =(nlat+1)/2 of double precision weights in dwts
c     as single precision in wts
c
      DIMENSION DWTS(IMID),WTS(IMID)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION DWTS

      DO 1 I = 1,IMID
          WTS(I) = DWTS(I)
    1 CONTINUE
      RETURN
      END

      PROGRAM AGEX02
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Define the data arrays.
C
      REAL XDRA(4001),YDRA(4001)
C
C Initialize GKS.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Fill the data arrays.
C
      DO 101 I=1,4001
        THETA=.0015707963267949*REAL(I-1)
        RHO=SIN(2.*THETA)+.05*SIN(64.*THETA)
        XDRA(I)=RHO*COS(THETA)
        YDRA(I)=RHO*SIN(THETA)
  101 CONTINUE
C
C Draw a boundary around the edge of the plotter frame.
C
      CALL BNDARY
C
C Draw the graph, using EZXY.
C
      CALL EZXY (XDRA,YDRA,4001,'EXAMPLE 2 (EZXY)$')
C
C Close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
C
      END
      SUBROUTINE BNDARY
C
C Routine to draw the plotter-frame edge.
C
      CALL PLOTIT (    0,    0,0)
      CALL PLOTIT (32767,    0,1)
      CALL PLOTIT (32767,32767,1)
      CALL PLOTIT (    0,32767,1)
      CALL PLOTIT (    0,    0,1)
      RETURN
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C   FFTPACK 5.0
C   Copyright (C) 1995-2004, Scientific Computing Division,
C   University Corporation for Atmospheric Research
C   Licensed under the GNU General Public License (GPL)
C
C   Authors:  Paul N. Swarztrauber and Richard A. Valent
C
C   $Id: c1f2kf.f,v 1.2 2006-11-21 01:10:15 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      SUBROUTINE DC1F2KF(IDO,L1,NA,CC,IN1,CH,IN2,WA)
      DOUBLE PRECISION SN
      DOUBLE PRECISION CHOLD1
      DOUBLE PRECISION CHOLD2
      DOUBLE PRECISION TR2
      DOUBLE PRECISION TI2
      DOUBLE PRECISION CC(IN1,L1,IDO,2),CH(IN2,L1,2,IDO),WA(IDO,1,2)
C
      IF (IDO.GT.1) GO TO 102
      SN = 1.D0/DBLE(2*L1)
      IF (NA.EQ.1) GO TO 106
      DO 101 K = 1,L1
          CHOLD1 = SN* (CC(1,K,1,1)+CC(1,K,1,2))
          CC(1,K,1,2) = SN* (CC(1,K,1,1)-CC(1,K,1,2))
          CC(1,K,1,1) = CHOLD1
          CHOLD2 = SN* (CC(2,K,1,1)+CC(2,K,1,2))
          CC(2,K,1,2) = SN* (CC(2,K,1,1)-CC(2,K,1,2))
          CC(2,K,1,1) = CHOLD2
  101 CONTINUE
      RETURN
  106 DO 107 K = 1,L1
          CH(1,K,1,1) = SN* (CC(1,K,1,1)+CC(1,K,1,2))
          CH(1,K,2,1) = SN* (CC(1,K,1,1)-CC(1,K,1,2))
          CH(2,K,1,1) = SN* (CC(2,K,1,1)+CC(2,K,1,2))
          CH(2,K,2,1) = SN* (CC(2,K,1,1)-CC(2,K,1,2))
  107 CONTINUE
      RETURN
  102 DO 103 K = 1,L1
          CH(1,K,1,1) = CC(1,K,1,1) + CC(1,K,1,2)
          CH(1,K,2,1) = CC(1,K,1,1) - CC(1,K,1,2)
          CH(2,K,1,1) = CC(2,K,1,1) + CC(2,K,1,2)
          CH(2,K,2,1) = CC(2,K,1,1) - CC(2,K,1,2)
  103 CONTINUE
      DO 105 I = 2,IDO
          DO 104 K = 1,L1
              CH(1,K,1,I) = CC(1,K,I,1) + CC(1,K,I,2)
              TR2 = CC(1,K,I,1) - CC(1,K,I,2)
              CH(2,K,1,I) = CC(2,K,I,1) + CC(2,K,I,2)
              TI2 = CC(2,K,I,1) - CC(2,K,I,2)
              CH(2,K,2,I) = WA(I,1,1)*TI2 - WA(I,1,2)*TR2
              CH(1,K,2,I) = WA(I,1,1)*TR2 + WA(I,1,2)*TI2
  104     CONTINUE
  105 CONTINUE
      RETURN
      END

C
C	$Id: conbd.f,v 1.5 2008-07-27 00:23:02 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
C
C
      SUBROUTINE CONBD
C
C Calling this do-nothing subroutine forces "ld" to load the following
C block data routine (but only if they are in the same ".f" file).
C
        RETURN
C
      END
CNOSPLIT
      BLOCKDATA CONBDX
      COMMON /CONRE1/ IOFFP      ,SPVAL      ,IHILO
      COMMON /CONRE2/ IX         ,IY         ,IDX        ,IDY        ,
     1                IS         ,ISS        ,NP         ,CV         ,
     2                INX(8)     ,INY(8)     ,IR(2000)   ,NR
      COMMON /SPRINT/ ISPRMJ     ,ISPRMN     ,ISPRTX
      DATA IOFFP,SPVAL,IHILO/0,0.0,3/
      DATA INX(1),INX(2),INX(3),INX(4),INX(5),INX(6),INX(7),INX(8)/
     1        -1 ,   -1 ,    0 ,    1 ,    1 ,    1 ,    0 ,   -1 /
      DATA INY(1),INY(2),INY(3),INY(4),INY(5),INY(6),INY(7),INY(8)/
     1         0 ,    1 ,    1 ,    1 ,    0 ,   -1 ,   -1 ,   -1 /
      DATA NR/2000/
      DATA ISPRMJ,ISPRMN,ISPRTX/ 1 , 1 , 1 /
C
C
C-------------------------------------------------------------------------
C
C REVISION HISTORY
C
C JUNE 1984                          CONVERTED TO FORTRAN 77 AND GKS
C
C NOVEMBER 1989                      CHANGED THE LENGTH OF IR TO 2000.
C
C MARCH 1990                         CORRECTED USE OF SET CALLS.
C
C------------------------------------------------------------------------
      END

C
C	$Id: wmsetr.f,v 1.11 2008-07-27 00:17:37 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE WMSETR (CNP,RVP)
C
      SAVE
C
      CHARACTER*(*) CNP
C
C  This subroutine is called to give a real value to a specified
C  parameter.
C
C  CNP is the name of the parameter whose value is to be set.
C
C  RVP is a real variable containing the desired value.
C
C  Declare a local character variable in which to form an error message.       
C
      CHARACTER*80 CTM
C
      include 'wmcomn.h'
C
C  Do a call forcing a BLOCKDATA to be loaded from a binary library.
C
      CALL WMBLDA
C
C  Check for an uncleared prior error.
C
      IF (ICFELL('WMSETR - Uncleared prior error',1) .NE. 0) RETURN
C
C  Check for a parameter name that is too short.
C
      IF (LEN(CNP) .LT. 2) THEN
        CTM(1:36) = 'WMSETR - Parameter name too short - '
        CTM(37:36+LEN(CNP)) = CNP
        CALL SETER (CTM(1:36+LEN(CNP)), 1, 1)
        GO TO 120
      ENDIF
C
C  SWI - width of a front symbol, in NDC coordinates.
C
      IF (CNP(1:3).EQ.'SWI' .OR. CNP(1:3).EQ.'swi' .OR.
     +         CNP(1:3).EQ.'Swi') THEN
        SYMWID = RVP
        GO TO 120
C
C  BLW - line width scale factor for drawing wind barbs.
C
      ELSE IF (CNP(1:3).EQ.'BLW' .OR. CNP(1:3).EQ.'blw' .OR.
     +         CNP(1:3).EQ.'Blw') THEN
        BRBLWD = RVP
        GO TO 120
C
C  LIN - specify line widths as a fraction of the screen height.
C
      ELSE IF (CNP(1:3).EQ.'LIN' .OR. CNP(1:3).EQ.'lin' .OR.
     +         CNP(1:3).EQ.'Lin') THEN
        RLINWD = MAX(RVP,0.05)
        GO TO 120
C
C  DWD - specify line widths as a fraction of the screen height for
C        fronts with dashed lines.
C
      ELSE IF (CNP(1:3).EQ.'DWD' .OR. CNP(1:3).EQ.'dwd' .OR.
     +         CNP(1:3).EQ.'Dwd') THEN
        DLINWD = MAX(RVP,0.05)
        GO TO 120
C
C  LWD - linewidth to use when using the internal routine WMDRFL
C        to draw the lines.
C
      ELSE IF (CNP(1:3).EQ.'LWD' .OR. CNP(1:3).EQ.'lwd' .OR.
     +         CNP(1:3).EQ.'Lwd') THEN
        SLINWD = MAX(RVP,0.0001)
        GO TO 120
C
C  SIG - Tension factor for tension spline routines.
C
      ELSE IF (CNP(1:3).EQ.'SIG' .OR. CNP(1:3).EQ.'sig' .OR.
     +         CNP(1:3).EQ.'Sig') THEN
        TNSION = RVP
        GO TO 120
C
C  SMT - Smoothing parameter for the smoothing spline routines.
C
      ELSE IF (CNP(1:3).EQ.'SMT' .OR. CNP(1:3).EQ.'smt' .OR.
     +         CNP(1:3).EQ.'Smt') THEN
        RSMOTH = RVP
        GO TO 120
C
C  OER - Observational weights for data for smoothing spline routines.
C
      ELSE IF (CNP(1:3).EQ.'OER' .OR. CNP(1:3).EQ.'oer' .OR.
     +         CNP(1:3).EQ.'Oer') THEN
        OBSERR = RVP
        GO TO 120
C
C  SHT - Height of symbols plotted with WMLABS.
C
      ELSE IF (CNP(1:3).EQ.'SHT' .OR. CNP(1:3).EQ.'sht' .OR.
     +         CNP(1:3).EQ.'Sht') THEN
        WSIZES = RVP
        GO TO 120
C
C  THT - Height of the regional temperature labels plotted with WMLABT.
C
      ELSE IF (CNP(1:3).EQ.'THT' .OR. CNP(1:3).EQ.'tht' .OR.
     +         CNP(1:3).EQ.'Tht') THEN
        WSIZET = RVP
        GO TO 120
C
C  CHT - Height of the labels for city names and daily high/low temps.
C        plotted with WMLABC.
C
      ELSE IF (CNP(1:3).EQ.'CHT' .OR. CNP(1:3).EQ.'cht' .OR.
     +         CNP(1:3).EQ.'Cht') THEN
        WSIZEC = RVP
        GO TO 120
C
C  WHT - Height of the boxed weather type labels like "BREEZY", "NICE", 
C        etc. plotted with WMLABW.
C
      ELSE IF (CNP(1:3).EQ.'WHT' .OR. CNP(1:3).EQ.'wht' .OR.
     +         CNP(1:3).EQ.'Wht') THEN
        WSIZEW = RVP
        GO TO 120
C
C  RHT - Height of the little symbols used to indicate regional weather
C        patterns, like showers, snow, ice.
C
      ELSE IF (CNP(1:3).EQ.'RHT' .OR. CNP(1:3).EQ.'rht' .OR.
     +         CNP(1:3).EQ.'Rht') THEN
        WSIZER = RVP
        GO TO 120
C
C  BEG - Space to leave at the beginning of a front line before the
C        first symbol is drawn.
C
      ELSE IF (CNP(1:3).EQ.'BEG' .OR. CNP(1:3).EQ.'beg' .OR.
     +         CNP(1:3).EQ.'Beg') THEN
        BEGDST = RVP
        GO TO 120
C
C  END - Space to leave at the end of a front line after the final
C        symbol has been drawn.
C
      ELSE IF (CNP(1:3).EQ.'END' .OR. CNP(1:3).EQ.'end' .OR.
     +         CNP(1:3).EQ.'End') THEN
        ENDDST = RVP
        GO TO 120
C
C  BET - Space to leave along a front line between symbols.
C
      ELSE IF (CNP(1:3).EQ.'BET' .OR. CNP(1:3).EQ.'bet' .OR.
     +         CNP(1:3).EQ.'Bet') THEN
        BETDST = RVP
        GO TO 120
C
C  ARS - Size of arrows as a fraction of the maximum screen height.
C
      ELSE IF (CNP(1:3).EQ.'ARS' .OR. CNP(1:3).EQ.'ars' .OR.
     +         CNP(1:3).EQ.'Ars') THEN
        ARWSIZ = MAX(0.,RVP)
        GO TO 120
C
C  ARD - Direction of arrows, in degrees.
C
      ELSE IF (CNP(1:3).EQ.'ARD' .OR. CNP(1:3).EQ.'ard' .OR.
     +         CNP(1:3).EQ.'Ard') THEN
        ARWDIR = RVP
        GO TO 120
C
C  ARL - scale factor for the length of an arrow's tail, independent
C        of the arrow's size.
C
      ELSE IF (CNP(1:3).EQ.'ARL' .OR. CNP(1:3).EQ.'arl' .OR.
     +         CNP(1:3).EQ.'Arl') THEN
        ARWLEN = MAX(0.,RVP)
        GO TO 120
C
C  DTS - Size of dots used to mark city locations.
C
      ELSE IF (CNP(1:3).EQ.'DTS' .OR. CNP(1:3).EQ.'dts' .OR.
     +         CNP(1:3).EQ.'Dts') THEN
        CDOTSZ = MAX(0.,RVP)
        GO TO 120
C
C  CMG - Size of margins for the city and daily high/low labels.
C
      ELSE IF (CNP(1:3).EQ.'CMG' .OR. CNP(1:3).EQ.'cmg' .OR.
     +         CNP(1:3).EQ.'Cmg') THEN
        CTYMRG = MAX(0.,RVP)
        GO TO 120
C
C  RMG - Size of margins for the regional temperature labels.
C
      ELSE IF (CNP(1:3).EQ.'RMG' .OR. CNP(1:3).EQ.'rmg' .OR.
     +         CNP(1:3).EQ.'Rmg') THEN
        TMPMRG = MAX(0.,RVP)
        GO TO 120
C
C  SL1 - Slope for beginning of spline curve, used in conjunction
C        with SLF.
C
      ELSE IF (CNP(1:3).EQ.'SL1' .OR. CNP(1:3).EQ.'sl1' .OR.
     +         CNP(1:3).EQ.'Sl1') THEN
        SLOPE1 = RVP
        GO TO 120
C
C  SL2 - Slope for end of spline curve, used in conjunction
C        with SLF.
C
      ELSE IF (CNP(1:3).EQ.'SL2' .OR. CNP(1:3).EQ.'sl2' .OR.
     +         CNP(1:3).EQ.'Sl2') THEN
        SLOPE2 = RVP
        GO TO 120
C
C  WBA - Angle wind barb tics make with the wind barb shaft, in degrees.
C
      ELSE IF (CNP(1:3).EQ.'WBA' .OR. CNP(1:3).EQ.'wba' .OR.
     +    CNP(1:3).EQ.'Wba') THEN
        WBBANG = RVP
        GO TO 120
C
C  WBS - Length of wind barb shafts as a fraction of the maximum
C        screen width.
C
      ELSE IF (CNP(1:3).EQ.'WBS' .OR. CNP(1:3).EQ.'wbs' .OR.
     +         CNP(1:3).EQ.'Wbs') THEN
        WBSHFT = RVP
        GO TO 120
C
C  WBT - Length of wind barb full tic as a percentage of its shaft
C        length.
C
      ELSE IF (CNP(1:3).EQ.'WBT' .OR. CNP(1:3).EQ.'wbt' .OR.
     +         CNP(1:3).EQ.'Wbt') THEN
        WBFTIC = RVP
        GO TO 120
C
C  WBD - Distance between tics along a windbarb shaft.
C
      ELSE IF (CNP(1:3).EQ.'WBD' .OR. CNP(1:3).EQ.'wbd' .OR.
     +         CNP(1:3).EQ.'Wbd') THEN
        WBDIST = RVP
        GO TO 120
C
C  WBR - Radius of the larger circle drawn for calm, as a percentage
C        of the windbarb shaft length.
C
      ELSE IF (CNP(1:3).EQ.'WBR' .OR. CNP(1:3).EQ.'wbr' .OR.
     +         CNP(1:3).EQ.'Wbr') THEN
        WBCLMR = RVP
        GO TO 120
C
C  WBC - Diameter of sky cover circle at base of wind barb, expressed
C        as a percentage of the shaft length.
C
      ELSE IF (CNP(1:3).EQ.'WBC' .OR. CNP(1:3).EQ.'wbc' .OR.
     +         CNP(1:3).EQ.'Wbc') THEN
        WBBASE = ABS(RVP)
        GO TO 120
C
C  WBL - Size of the text labels in the station model display as a
C        percentage of the shaft length.
C
      ELSE IF (CNP(1:3).EQ.'WBL' .OR. CNP(1:3).EQ.'wbl' .OR.
     +         CNP(1:3).EQ.'Wbl') THEN
        WBLSIZ = ABS(RVP)
        GO TO 120
C
C  VRS - Size of the wind speed vector that will be scaled
C        to the NDC length specified by VRN.  All vectors
C        will be scaled in keeping with the settings of
C        VRS and VRN.
C
      ELSE IF (CNP(1:3).EQ.'VRS' .OR. CNP(1:3).EQ.'vrs' .OR.
     +         CNP(1:3).EQ.'Vrs') THEN
        VCUREF = ABS(RVP)
        GO TO 120
C
C  VRN - Size, in NDC coordinates, that a vector of length
C        specified by VRS is to scale to.  All vectors
C        will be scaled in keeping with the settings of
C        VRS and VRN.
C
      ELSE IF (CNP(1:3).EQ.'VRN' .OR. CNP(1:3).EQ.'vrn' .OR.
     +         CNP(1:3).EQ.'Vrn') THEN
        VCNREF = ABS(RVP)
        GO TO 120
C
C  VCH - Scale factor for the arrow heads of vectors.
C
      ELSE IF (CNP(1:3).EQ.'VCH' .OR. CNP(1:3).EQ.'vch' .OR.
     +         CNP(1:3).EQ.'Vch') THEN
        VCHSIZ = RVP
        GO TO 120
C
C  VCD - direction of vector (in degrees).
C
      ELSE IF (CNP(1:3).EQ.'VCD' .OR. CNP(1:3).EQ.'vcd' .OR.
     +         CNP(1:3).EQ.'Vcd') THEN
        VCWDIR = RVP
        GO TO 120
C
C  VCW - vector linewidth scale factor.
C
      ELSE IF (CNP(1:3).EQ.'VCW' .OR. CNP(1:3).EQ.'vcw' .OR.
     +         CNP(1:3).EQ.'Vcw') THEN
        VCLWID = ABS(RVP)
        GO TO 120
C
C  VCS - vector size.
C
      ELSE IF (CNP(1:3).EQ.'VCS' .OR. CNP(1:3).EQ.'vcs' .OR.
     +         CNP(1:3).EQ.'Vcs') THEN
        VCSIZE = ABS(RVP)
        GO TO 120
C
C  VVA - vector arrow head angle from tail.
C
      ELSE IF (CNP(1:3).EQ.'VVA' .OR. CNP(1:3).EQ.'vva' .OR.
     +         CNP(1:3).EQ.'Vva') THEN
        VHDANG = ABS(RVP)
        GO TO 120
C
      ELSE
        CTM(1:36) = 'WMSETR - Parameter name not known - '
        CTM(37:39) = CNP(1:3)
        CALL SETER (CTM(1:39), 8, 1)
        GO TO 120
      ENDIF
C
  120 CONTINUE
      RETURN
      END

      SUBROUTINE CSYR( UPLO, N, ALPHA, X, INCX, A, LDA )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     October 31, 1992
*
*     .. Scalar Arguments ..
      CHARACTER          UPLO
      INTEGER            INCX, LDA, N
      COMPLEX            ALPHA
*     ..
*     .. Array Arguments ..
      COMPLEX            A( LDA, * ), X( * )
*     ..
*
*  Purpose
*  =======
*
*  CSYR   performs the symmetric rank 1 operation
*
*     A := alpha*x*( x' ) + A,
*
*  where alpha is a complex scalar, x is an n element vector and A is an
*  n by n symmetric matrix.
*
*  Arguments
*  ==========
*
*  UPLO   - CHARACTER*1
*           On entry, UPLO specifies whether the upper or lower
*           triangular part of the array A is to be referenced as
*           follows:
*
*              UPLO = 'U' or 'u'   Only the upper triangular part of A
*                                  is to be referenced.
*
*              UPLO = 'L' or 'l'   Only the lower triangular part of A
*                                  is to be referenced.
*
*           Unchanged on exit.
*
*  N      - INTEGER
*           On entry, N specifies the order of the matrix A.
*           N must be at least zero.
*           Unchanged on exit.
*
*  ALPHA  - COMPLEX
*           On entry, ALPHA specifies the scalar alpha.
*           Unchanged on exit.
*
*  X      - COMPLEX array, dimension at least
*           ( 1 + ( N - 1 )*abs( INCX ) ).
*           Before entry, the incremented array X must contain the N-
*           element vector x.
*           Unchanged on exit.
*
*  INCX   - INTEGER
*           On entry, INCX specifies the increment for the elements of
*           X. INCX must not be zero.
*           Unchanged on exit.
*
*  A      - COMPLEX array, dimension ( LDA, N )
*           Before entry, with  UPLO = 'U' or 'u', the leading n by n
*           upper triangular part of the array A must contain the upper
*           triangular part of the symmetric matrix and the strictly
*           lower triangular part of A is not referenced. On exit, the
*           upper triangular part of the array A is overwritten by the
*           upper triangular part of the updated matrix.
*           Before entry, with UPLO = 'L' or 'l', the leading n by n
*           lower triangular part of the array A must contain the lower
*           triangular part of the symmetric matrix and the strictly
*           upper triangular part of A is not referenced. On exit, the
*           lower triangular part of the array A is overwritten by the
*           lower triangular part of the updated matrix.
*
*  LDA    - INTEGER
*           On entry, LDA specifies the first dimension of A as declared
*           in the calling (sub) program. LDA must be at least
*           max( 1, N ).
*           Unchanged on exit.
*
* =====================================================================
*
*     .. Parameters ..
      COMPLEX            ZERO
      PARAMETER          ( ZERO = ( 0.0E+0, 0.0E+0 ) )
*     ..
*     .. Local Scalars ..
      INTEGER            I, INFO, IX, J, JX, KX
      COMPLEX            TEMP
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      IF( .NOT.LSAME( UPLO, 'U' ) .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = 1
      ELSE IF( N.LT.0 ) THEN
         INFO = 2
      ELSE IF( INCX.EQ.0 ) THEN
         INFO = 5
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = 7
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'CSYR  ', INFO )
         RETURN
      END IF
*
*     Quick return if possible.
*
      IF( ( N.EQ.0 ) .OR. ( ALPHA.EQ.ZERO ) )
     $   RETURN
*
*     Set the start point in X if the increment is not unity.
*
      IF( INCX.LE.0 ) THEN
         KX = 1 - ( N-1 )*INCX
      ELSE IF( INCX.NE.1 ) THEN
         KX = 1
      END IF
*
*     Start the operations. In this version the elements of A are
*     accessed sequentially with one pass through the triangular part
*     of A.
*
      IF( LSAME( UPLO, 'U' ) ) THEN
*
*        Form  A  when A is stored in upper triangle.
*
         IF( INCX.EQ.1 ) THEN
            DO 20 J = 1, N
               IF( X( J ).NE.ZERO ) THEN
                  TEMP = ALPHA*X( J )
                  DO 10 I = 1, J
                     A( I, J ) = A( I, J ) + X( I )*TEMP
   10             CONTINUE
               END IF
   20       CONTINUE
         ELSE
            JX = KX
            DO 40 J = 1, N
               IF( X( JX ).NE.ZERO ) THEN
                  TEMP = ALPHA*X( JX )
                  IX = KX
                  DO 30 I = 1, J
                     A( I, J ) = A( I, J ) + X( IX )*TEMP
                     IX = IX + INCX
   30             CONTINUE
               END IF
               JX = JX + INCX
   40       CONTINUE
         END IF
      ELSE
*
*        Form  A  when A is stored in lower triangle.
*
         IF( INCX.EQ.1 ) THEN
            DO 60 J = 1, N
               IF( X( J ).NE.ZERO ) THEN
                  TEMP = ALPHA*X( J )
                  DO 50 I = J, N
                     A( I, J ) = A( I, J ) + X( I )*TEMP
   50             CONTINUE
               END IF
   60       CONTINUE
         ELSE
            JX = KX
            DO 80 J = 1, N
               IF( X( JX ).NE.ZERO ) THEN
                  TEMP = ALPHA*X( JX )
                  IX = JX
                  DO 70 I = J, N
                     A( I, J ) = A( I, J ) + X( IX )*TEMP
                     IX = IX + INCX
   70             CONTINUE
               END IF
               JX = JX + INCX
   80       CONTINUE
         END IF
      END IF
*
      RETURN
*
*     End of CSYR
*
      END

C
C $Id: pj23dp.f,v 1.5 2008-07-27 00:17:12 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE PJ23DP (COORD,CRDIO,INDIC)
C
C -- M O D I F I E D   S T E R E O G R A P H I C   -   A L A S K A
C
      IMPLICIT DOUBLE PRECISION (A-Z)
      INTEGER N,J,NN
      INTEGER INDIC
      DIMENSION GEOG(2),PROJ(2),COORD(2),CRDIO(2),
     . ACOEF(6),BCOEF(6)
C **** PARAMETERS **** A,E,ES,LON0,LAT0,X0,Y0,SINPH0,COSPH0 ************
      COMMON /ERRMZ0/ IERR
        INTEGER IERR
      SAVE   /ERRMZ0/
      COMMON /PRINZ0/ IPEMSG,IPELUN,IPPARM,IPPLUN
        INTEGER IPEMSG,IPELUN,IPPARM,IPPLUN
      SAVE   /PRINZ0/
      COMMON /PC23DP/ A,LON0,X0,Y0,ACOEF,BCOEF,EC,LAT0,CCHIO,SCHIO,N
      DATA HALFPI /1.5707963267948966D0/
      DATA EPSLN /1.0D-10/
      DATA ZERO,ONE,TWO /0.0D0,1.0D0,2.0D0/
C
C -- F O R W A R D   . . .
C
      IF (INDIC .EQ. 0) THEN
C
         GEOG(1) = COORD(1)
         GEOG(2) = COORD(2)
         IERR = 0
         IF (MDDADP(GEOG).GT.30.D0) THEN
           IF (IPEMSG.EQ.0) WRITE (IPELUN,2020)
 2020      FORMAT (/' ERROR PJ23DP'/
     .              ' POINT IS TOO FAR FROM CENTER OF PROJECTION')
           IERR = 233
           RETURN
         END IF
         LON = ADJLDP (GEOG(1) - LON0)
C
C     CALCULATE X-PRIME AND Y-PRIME FOR OBLIQUE STEREOGRAPHIC PROJ.
C          FROM LAT/LONG.
C
         SINLON = SIN (LON)
         COSLON = COS (LON)
         ESPHI = EC *SIN(GEOG(2))
         CHI=TWO*ATAN(TAN((HALFPI+GEOG(2))/TWO)*((ONE-ESPHI)/(ONE
     .      +ESPHI))**(EC/TWO)) - HALFPI
         SCHI=SIN(CHI)
         CCHI=COS(CHI)
         G=SCHIO*SCHI+CCHIO*CCHI*COSLON
         S=TWO/(ONE+G)
         XP=S*CCHI*SINLON
         YP=S*(CCHIO*SCHI-SCHIO*CCHI*COSLON)
C
C     USE KNUTH ALGORITHM FOR SUMMING COMPLEX TERMS, TO CONVERT
C     OBLIQUE STEREOGRAPHIC TO MODIFIED-STEREOGRAPHIC COORD.
C
         R=XP+XP
         S=XP*XP+YP*YP
         AR=ACOEF(N)
         AI=BCOEF(N)
         BR=ACOEF(N-1)
         BI=BCOEF(N-1)
         DO 140 J=2,N
         ARN=BR+R*AR
         AIN=BI+R*AI
         IF (J.EQ.N) GO TO 140
         BR=ACOEF(N-J)-S*AR
         BI=BCOEF(N-J)-S*AI
         AR=ARN
         AI=AIN
  140    CONTINUE
         BR=-S*AR
         BI=-S*AI
         AR=ARN
         AI=AIN
         X=XP*AR-YP*AI+BR
         Y=YP*AR+XP*AI+BI
         PROJ(1)=X*A+X0
         PROJ(2)=Y*A+Y0
         CRDIO(1) = PROJ(1)
         CRDIO(2) = PROJ(2)
         RETURN
      END IF
C
C -- I N V E R S E   . . .
C
      IF (INDIC .EQ. 1) THEN
C
         PROJ(1) = COORD(1)
         PROJ(2) = COORD(2)
         IERR = 0
         X = (PROJ(1) - X0)/A
         Y = (PROJ(2) - Y0)/A
         XP=X
         YP=Y
         NN=0
C
C     USE KNUTH ALGORITHM FOR SUMMING COMPLEX TERMS, TO CONVERT
C     MODIFIED-STEREOGRAPHIC CONFORMAL TO OBLIQUE STEREOGRAPHIC
C     COORDINATES (XP,YP).
C
  225    R=XP+XP
         S=XP*XP+YP*YP
         AR=ACOEF(N)
         AI=BCOEF(N)
         BR=ACOEF(N-1)
         BI=BCOEF(N-1)
         CR=N*AR
         CI=N*AI
         DR=(N-1)*BR
         DI=(N-1)*BI
         DO 230 J=2,N
         ARN=BR+R*AR
         AIN=BI+R*AI
         IF (J.EQ.N) GO TO 230
         BR=ACOEF(N-J)-S*AR
         BI=BCOEF(N-J)-S*AI
         AR=ARN
         AI=AIN
         CRN=DR+R*CR
         CIN=DI+R*CI
         DR=(N-J)*ACOEF(N-J)-S*CR
         DI=(N-J)*BCOEF(N-J)-S*CI
         CR=CRN
         CI=CIN
  230    CONTINUE
         BR=-S*AR
         BI=-S*AI
         AR=ARN
         AI=AIN
         FXYR=XP*AR-YP*AI+BR-X
         FXYI=YP*AR+XP*AI+BI-Y
         FPXYR=XP*CR-YP*CI+DR
         FPXYI=YP*CR+XP*CI+DI
         DEN=FPXYR*FPXYR+FPXYI*FPXYI
         DXP=-(FXYR*FPXYR+FXYI*FPXYI)/DEN
         DYP=-(FXYI*FPXYR-FXYR*FPXYI)/DEN
         XP=XP+DXP
         YP=YP+DYP
         DS=ABS(DXP)+ABS(DYP)
         NN=NN+1
         IF (NN.LE.20) GO TO 237
         IF (IPEMSG .EQ. 0) WRITE (IPELUN,235)
  235    FORMAT (/' ERROR PJ23DP'/
     .            ' TOO MANY ITERATIONS IN ITERATING INVERSE')
         IERR = 235
         GO TO 238
  237    IF (DS.GT.EPSLN) GO TO 225
C
C     CONVERT OBLIQUE STEREOGRAPHIC COORDINATES TO LAT/LONG.
C
  238    RH = SQRT (XP * XP + YP * YP)
         Z = TWO * ATAN (RH / TWO)
         SINZ = SIN (Z)
         COSZ = COS (Z)
         GEOG(1) = LON0
         IF (ABS(RH) .GT. EPSLN) GO TO 240
         GEOG(2) = LAT0
         CRDIO(1) = GEOG(1)
         CRDIO(2) = GEOG(2)
         RETURN
  240    CHI = ASINDP (COSZ * SCHIO + YP *SINZ * CCHIO / RH)
         NN=0
         PHI=CHI
  250    ESPHI=EC*SIN(PHI)
         DPHI=TWO*ATAN(TAN((HALFPI+CHI)/TWO)*((ONE+ESPHI)/(ONE-ESPHI))
     .      **(EC/TWO)) - HALFPI - PHI
         PHI = PHI + DPHI
         NN = NN + 1
         IF (NN.LE.20) GO TO 257
         IF (IPEMSG .EQ. 0) WRITE (IPELUN,255)
  255    FORMAT (/' ERROR PJ23DP'/
     .            ' TOO MANY ITERATIONS IN CALCULATING PHI FROM CHI')
         IERR = 236
         GO TO 260
  257    IF (ABS(DPHI).GT.EPSLN) GO TO 250
  260    GEOG(2)=PHI
         GEOG(1) = ADJLDP (LON0 + ATAN2(XP*SINZ, RH*CCHIO*COSZ-YP*SCHIO
     .     *SINZ))
         CRDIO(1) = GEOG(1)
         CRDIO(2) = GEOG(2)
         RETURN
      END IF
C
      END

C
C	$Id: wmlgpl.f,v 1.7 2008-07-27 00:17:37 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE WMLGPL(N,X,Y)
C
C  Draws polylines either using GPL (IWDTYP=0) or WMDRFL (IWDTYP=1).
C
      DIMENSION X(N),Y(N)
C
      include 'wmcomn.h'
C
C  Save the current line attributes and reset.
C
      CALL GQPLCI(IER,ICOLD)
      CALL GSPLCI(ICOLOR)
C
C  Handle the squall lines (IFRONT = 5), tropical fronts (IFRONT = 6), 
C  and convergence lines (IFRONT = 7) separately.
C
      IF (IFRONT .EQ. 5) THEN
        CALL GQLWSC(IER,OSCL)
        CALL GSLWSC(DLINWD)
        CALL DPGETI('DPS',IDPS)
        CALL DPGETR('WOG',OWOG)
        CALL DPGETR('WOS',OWOS)
        CALL DPGETR('LS1',OLS1)
C
        CALL DPSETR('WOG',.003)
        CALL DPSETR('WOS',.0035)
        CALL DPSETR('LS1',0.0)
        CALL DPSETC('DPT','___:F34X150Y150:7_:F34X150Y150:7___$$$$$$$$$$
     +$$$$$$')
        CALL DPCURV(X,Y,N)
C
        CALL GSLWSC(OSCL)
        CALL DPSETI('DPS',IDPS)
        CALL DPSETC('DPT',' ')
        CALL DPSETR('LS1',OLS1)
        CALL DPSETR('WOG',OWOG)
        CALL DPSETR('WOS',OWOS)
        RETURN
      ELSE IF (IFRONT .EQ. 6) THEN
        CALL GQLWSC(IER,OSCL)
        CALL GSLWSC(DLINWD)
        CALL DPGETI('DPS',IDPS)
        CALL DPGETI('DPT',IDPT)
        CALL DPGETR('WOG',OWOG)
        CALL DPGETR('WOS',OWOS)
C
        CALL DPSETI('DPS',-22)
        CALL DPSETR('WOG',.007)
        CALL DPSETR('WOS',.007)
        CALL DPSETI('DPT',4177920)
        CALL GSPLCI(ITRO1C)
        CALL DPCURV(X,Y,N)
        CALL DPSETI('DPT',2040)
        CALL GSPLCI(ITRO2C)
        CALL DPCURV(X,Y,N)
C
        CALL GSLWSC(OSCL)
        CALL DPSETI('DPS',IDPS)
        CALL DPSETI('DPT',IDPT)
        CALL DPSETR('WOG',OWOG)
        CALL DPSETR('WOS',OWOS)
        RETURN
      ELSE IF (IFRONT .EQ. 7) THEN
        CALL GQLWSC(IER,OSCL)
        CALL GSLWSC(DLINWD)
        CALL DPGETI('DPS',IDPS)
        CALL DPGETI('DPT',IDPT)
        CALL DPGETR('WOG',OWOG)
        CALL DPGETR('WOS',OWOS)
C
        CALL DPSETI('DPS',-5)
        CALL DPSETR('WOG',.0075)
        CALL DPSETR('WOS',.0075)
        CALL DPSETI('DPT',31)
        CALL DPCURV(X,Y,N)
C
        CALL GSLWSC(OSCL)
        CALL DPSETI('DPS',IDPS)
        CALL DPSETI('DPT',IDPT)
        CALL DPSETR('WOG',OWOG)
        CALL DPSETR('WOS',OWOS)
        RETURN
      ENDIF
C
      IF (IWDTYP .EQ. 1) THEN
        CALL WMDRFL(N,X,Y)
      ELSE
        CALL GPL(N,X,Y)
      ENDIF
C
C  Restore line attributes.
C
      CALL GSPLCI(ICOLD)
C
      RETURN
      END

c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by UCAR                 .
c  .                                                             .
c  .       University Corporation for Atmospheric Research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                         SPHEREPACK                       .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c
c
c ... file ivrtgc.f
c
c     this file includes documentation and code for
c     subroutine ivrtgc         i
c
c ... files which must be loaded with ivrtgc.f
c
c     sphcom.f, hrfft.f, vhsgc.f,shagc.f, gaqd.f
c
c
c     subroutine ivrtgc(nlat,nlon,isym,nt,v,w,idvw,jdvw,a,b,mdab,ndab,
c    +                  wvhsgc,lvhsgc,work,lwork,pertrb,ierror)
c
C*PL*ERROR* Comment line too long
c     given the scalar spherical harmonic coefficients a and b, precomputed
C*PL*ERROR* Comment line too long
c     by subroutine shagc for a scalar array vt, subroutine ivrtgc computes
C*PL*ERROR* Comment line too long
c     a divergence free vector field (v,w) whose vorticity is vt - pertrb.
C*PL*ERROR* Comment line too long
c     w is the east longitude component and v is the colatitudinal component.
c     pertrb is a constant which must be subtracted from vt for (v,w) to
C*PL*ERROR* Comment line too long
c     exist (see the description of pertrb below).  usually pertrb is zero
C*PL*ERROR* Comment line too long
c     or small relative to vort.  the divergence of (v,w), as computed by
c     ivrtgc, is the zero scalar field.  v(i,j) and w(i,j) are the
c     colatitudinal and east longitude velocity components at gaussian
c     colatitude theta(i) (see nlat as input parameter) and longitude
c     lambda(j) = (j-1)*2*pi/nlon.  the
c
c            vorticity(v(i,j),w(i,j))
c
c         =  [-dv/dlambda + d(sint*w)/dtheta]/sint
c
c         =  vort(i,j) - pertrb
c
c     and
c
c            divergence(v(i,j),w(i,j))
c
c         =  [d(sint*v)/dtheta + dw/dlambda]/sint
c
c         =  0.0
c
C*PL*ERROR* Comment line too long
c     where sint = sin(theta(i)).  required associated legendre polynomials
C*PL*ERROR* Comment line too long
c     are recomputed rather than stored as they are in subroutine ivrtgs.
c
c
c     input parameters
c
c     nlat   the number of points in the gaussian colatitude grid on the
C*PL*ERROR* Comment line too long
c            full sphere. these lie in the interval (0,pi) and are computed
C*PL*ERROR* Comment line too long
c            in radians in theta(1) <...< theta(nlat) by subroutine gaqd.
C*PL*ERROR* Comment line too long
c            if nlat is odd the equator will be included as the grid point
c            theta((nlat+1)/2).  if nlat is even the equator will be
c            excluded as a grid point and will lie half way between
c            theta(nlat/2) and theta(nlat/2+1). nlat must be at least 3.
c            note: on the half sphere, the number of grid points in the
c            colatitudinal direction is nlat/2 if nlat is even or
c            (nlat+1)/2 if nlat is odd.
c
c     nlon   the number of distinct londitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater
c            than 3. the axisymmetric case corresponds to nlon=1.
c            the efficiency of the computation is improved when nlon
c            is a product of small prime numbers.
c
c
c     isym   this has the same value as the isym that was input to
c            subroutine shagc to compute the arrays a and b.  isym
c            determines whether (v,w) are computed on the full or half
c            sphere as follows:
c
c      = 0
c            vt is not symmetric about the equator. in this case
c            the vector field (v,w) is computed on the entire sphere.
c            i.e., in the arrays  v(i,j),w(i,j) for i=1,...,nlat and
c            j=1,...,nlon.
c
c      = 1
c
c            vt is symmetric about the equator. in this case w is
c            antiymmetric and v is symmetric about the equator. v
c            and w are computed on the northern hemisphere only.  i.e.,
c            if nlat is odd they are computed for i=1,...,(nlat+1)/2
c            and j=1,...,nlon.  if nlat is even they are computed for
c            i=1,...,nlat/2 and j=1,...,nlon.
c
c       = 2
c
c            vt is antisymmetric about the equator. in this case w is
c            symmetric and v is antisymmetric about the equator. w
c            and v are computed on the northern hemisphere only.  i.e.,
c            if nlat is odd they are computed for i=1,...,(nlat+1)/2
c            and j=1,...,nlon.  if nlat is even they are computed for
c            i=1,...,nlat/2 and j=1,...,nlon.
c
c
C*PL*ERROR* Comment line too long
c     nt     in the program that calls ivrtgc, nt is the number of vorticity
C*PL*ERROR* Comment line too long
c            and vector fields.  some computational efficiency is obtained
c            for multiple fields.  the arrays a,b,v, and w can be three
c            dimensional and pertrb can be one dimensional corresponding
C*PL*ERROR* Comment line too long
c            to an indexed multiple array vort.  in this case, multiple vector
C*PL*ERROR* Comment line too long
c            synthesis will be performed to compute each vector field.  the
C*PL*ERROR* Comment line too long
c            third index for a,b,v,w and first for pertrb is the synthesis
c            index which assumes the values k=1,...,nt.  for a single
C*PL*ERROR* Comment line too long
c            synthesis set nt=1. the description of the remaining parameters
c            is simplified by assuming that nt=1 or that a,b,v,w are two
c            dimensional and pertrb is a constant.
c
c     idvw   the first dimension of the arrays v,w as it appears in
c            the program that calls ivrtgc. if isym = 0 then idvw
c            must be at least nlat.  if isym = 1 or 2 and nlat is
c            even then idvw must be at least nlat/2. if isym = 1 or 2
c            and nlat is odd then idvw must be at least (nlat+1)/2.
c
c     jdvw   the second dimension of the arrays v,w as it appears in
c            the program that calls ivrtgc. jdvw must be at least nlon.
c
c     a,b    two or three dimensional arrays (see input parameter nt)
c            that contain scalar spherical harmonic coefficients
c            of the vorticity array vt as computed by subroutine shagc.
c     ***    a,b must be computed by shagc prior to calling ivrtgc.
c
c     mdab   the first dimension of the arrays a and b as it appears in
c            the program that calls ivrtgcs (and shagc). mdab must be at
c            least min0(nlat,(nlon+2)/2) if nlon is even or at least
c            min0(nlat,(nlon+1)/2) if nlon is odd.
c
c     ndab   the second dimension of the arrays a and b as it appears in
c            the program that calls ivrtgc (and shagc). ndab must be at
c            least nlat.
c
c
c  wvhsgc    an array which must be initialized by subroutine vhsgci.
c            once initialized
c            wvhsgc can be used repeatedly by ivrtgc as long as nlon
c            and nlat remain unchanged.  wvhsgs must not be altered
c            between calls of ivrtgc.
c
c
c  lvhsgc    the dimension of the array wvhsgc as it appears in the
c            program that calls ivrtgc. define
c
c               l1 = min0(nlat,nlon/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            then lvhsgc be at least
c
c               4*nlat*l2+3*max0(l1-2,0)*(2*nlat-l1-1)+nlon+15
c
c
c     work   a work array that does not have to be saved.
c
c     lwork  the dimension of the array work as it appears in the
c            program that calls ivrtgc. define
c
c               l2 = nlat/2                    if nlat is even or
c               l2 = (nlat+1)/2                if nlat is odd
c               l1 = min0(nlat,nlon/2)         if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2)     if nlon is odd
c
c            if isym = 0 then lwork must be at least
c
c               nlat*(2*nt*nlon+max0(6*l2,nlon) + 2*nt*l1 + 1)
c
c            if isym = 1 or 2 then lwork must be at least
c
c               l2*(2*nt*nlon+max0(6*nlat,nlon)) + nlat*(2*nt*l1+1)
c
c     **************************************************************
c
c     output parameters
c
c
C*PL*ERROR* Comment line too long
c     v,w   two or three dimensional arrays (see input parameter nt) that
c           contain a divergence free vector field whose vorticity is
c           vt - pertrb at the gaussian colatitude point theta(i)
C*PL*ERROR* Comment line too long
c           and longitude point lambda(j)=(j-1)*2*pi/nlon.  w is the east
C*PL*ERROR* Comment line too long
c           longitude component and v is the colatitudinal component.  the
c           indices for v and w are defined at the input parameter isym.
c           the divergence of (v,w) is the zero scalar field.
c
C*PL*ERROR* Comment line too long
c   pertrb  a nt dimensional array (see input parameter nt and assume nt=1
c           for the description that follows).  vt - pertrb is a scalar
c           field which can be the vorticity of a vector field (v,w).
c           pertrb is related to the scalar harmonic coefficients a,b
c           of vt (computed by shagc) by the formula
c
c                pertrb = a(1,1)/(2.*sqrt(2.))
c
c           an unperturbed vt can be the vorticity of a vector field
c           only if a(1,1) is zero.  if a(1,1) is nonzero (flagged by
c           pertrb nonzero) then subtracting pertrb from vt yields a
c           scalar field for which a(1,1) is zero.
c
c    ierror = 0  no errors
c           = 1  error in the specification of nlat
c           = 2  error in the specification of nlon
c           = 3  error in the specification of isym
c           = 4  error in the specification of nt
c           = 5  error in the specification of idvw
c           = 6  error in the specification of jdvw
c           = 7  error in the specification of mdab
c           = 8  error in the specification of ndab
c           = 9  error in the specification of lvhsgc
c           = 10 error in the specification of lwork
c **********************************************************************
c
c
      SUBROUTINE DIVRTGC(NLAT,NLON,ISYM,NT,V,W,IDVW,JDVW,A,B,MDAB,NDAB,
     +                  WVHSGC,LVHSGC,WORK,LWORK,PERTRB,IERROR)
      DOUBLE PRECISION V
      DOUBLE PRECISION W
      DOUBLE PRECISION A
      DOUBLE PRECISION B
      DOUBLE PRECISION WVHSGC
      DOUBLE PRECISION WORK
      DOUBLE PRECISION PERTRB
      DIMENSION V(IDVW,JDVW,NT),W(IDVW,JDVW,NT),PERTRB(NT)
      DIMENSION A(MDAB,NDAB,NT),B(MDAB,NDAB,NT)
      DIMENSION WVHSGC(LVHSGC),WORK(LWORK)
c
c     check input parameters
c
      IERROR = 1
      IF (NLAT.LT.3) RETURN
      IERROR = 2
      IF (NLON.LT.4) RETURN
      IERROR = 3
      IF (ISYM.LT.0 .OR. ISYM.GT.2) RETURN
      IERROR = 4
      IF (NT.LT.0) RETURN
      IERROR = 5
      IMID = (NLAT+1)/2
      IF ((ISYM.EQ.0.AND.IDVW.LT.NLAT) .OR.
     +    (ISYM.NE.0.AND.IDVW.LT.IMID)) RETURN
      IERROR = 6
      IF (JDVW.LT.NLON) RETURN
      IERROR = 7
      MMAX = MIN0(NLAT, (NLON+1)/2)
      IF (MDAB.LT.MIN0(NLAT, (NLON+2)/2)) RETURN
      IERROR = 8
      IF (NDAB.LT.NLAT) RETURN
      IERROR = 9
      LZZ1 = 2*NLAT*IMID
      LABC = 3* (MAX0(MMAX-2,0)* (NLAT+NLAT-MMAX-1))/2
c
c     check save work space length
c
      L1 = MIN0(NLAT, (NLON+1)/2)
      L2 = (NLAT+1)/2
      LWMIN = 4*NLAT*L2 + 3*MAX0(L1-2,0)* (2*NLAT-L1-1) + NLON + 15
      IF (LVHSGC.LT.LWMIN) RETURN
c     if(lvhsgc .lt. 2*(lzz1+labc)+nlon+15) return
      IERROR = 10
c
c     verify unsaved work space length
c
      MN = MMAX*NLAT*NT
      IF (ISYM.NE.0 .AND. LWORK.LT.NLAT* (2*NT*NLON+MAX0(6*IMID,NLON))+
     +    2*MN+NLAT) RETURN
      IF (ISYM.EQ.0 .AND. LWORK.LT.IMID* (2*NT*NLON+MAX0(6*NLAT,NLON))+
     +    2*MN+NLAT) RETURN
      IERROR = 0
c
c     set work space pointers
c
      ICR = 1
      ICI = ICR + MN
      IS = ICI + MN
      IWK = IS + NLAT
      LIWK = LWORK - 2*MN - NLAT
      CALL DIVTGC1(NLAT,NLON,ISYM,NT,V,W,IDVW,JDVW,WORK(ICR),WORK(ICI),
     +            MMAX,WORK(IS),MDAB,NDAB,A,B,WVHSGC,LVHSGC,WORK(IWK),
     +            LIWK,PERTRB,IERROR)
      RETURN
      END

      SUBROUTINE DIVTGC1(NLAT,NLON,ISYM,NT,V,W,IDVW,JDVW,CR,CI,MMAX,
     +                   SQNN,MDAB,NDAB,A,B,WSAV,LSAV,WK,LWK,PERTRB,
     +                   IERROR)
      DOUBLE PRECISION V
      DOUBLE PRECISION W
      DOUBLE PRECISION CR
      DOUBLE PRECISION CI
      DOUBLE PRECISION SQNN
      DOUBLE PRECISION A
      DOUBLE PRECISION B
      DOUBLE PRECISION WSAV
      DOUBLE PRECISION WK
      DOUBLE PRECISION PERTRB
      DOUBLE PRECISION FN
      DOUBLE PRECISION BR
      DOUBLE PRECISION BI
      DIMENSION V(IDVW,JDVW,NT),W(IDVW,JDVW,NT),PERTRB(NT)
      DIMENSION CR(MMAX,NLAT,NT),CI(MMAX,NLAT,NT),SQNN(NLAT)
      DIMENSION A(MDAB,NDAB,NT),B(MDAB,NDAB,NT)
      DIMENSION WSAV(LSAV),WK(LWK)
c
c     preset coefficient multiplyers in vector
c
      DO 1 N = 2,NLAT
          FN = DBLE(N-1)
          SQNN(N) = SQRT(FN* (FN+1.D0))
    1 CONTINUE
c
c     compute multiple vector fields coefficients
c
      DO 2 K = 1,NT
c
c     set vorticity field perturbation adjustment
c
          PERTRB(K) = A(1,1,K)/ (2.D0*SQRT(2.D0))
c
c     preset br,bi to 0.0
c
          DO 3 N = 1,NLAT
              DO 4 M = 1,MMAX
                  CR(M,N,K) = 0.0D0
                  CI(M,N,K) = 0.0D0
    4         CONTINUE
    3     CONTINUE
c
c     compute m=0 coefficients
c
          DO 5 N = 2,NLAT
              CR(1,N,K) = A(1,N,K)/SQNN(N)
              CI(1,N,K) = B(1,N,K)/SQNN(N)
    5     CONTINUE
c
c     compute m>0 coefficients
c
          DO 6 M = 2,MMAX
              DO 7 N = M,NLAT
                  CR(M,N,K) = A(M,N,K)/SQNN(N)
                  CI(M,N,K) = B(M,N,K)/SQNN(N)
    7         CONTINUE
    6     CONTINUE
    2 CONTINUE
c
c     set ityp for vector synthesis with divergence=0
c
      IF (ISYM.EQ.0) THEN
          ITYP = 2
      ELSE IF (ISYM.EQ.1) THEN
          ITYP = 5
      ELSE IF (ISYM.EQ.2) THEN
          ITYP = 8
      END IF
c
c     vector sythesize cr,ci into divergence free vector field (v,w)
c
      CALL DVHSGC(NLAT,NLON,ITYP,NT,V,W,IDVW,JDVW,BR,BI,CR,CI,MMAX,NLAT,
     +           WSAV,LSAV,WK,LWK,IERROR)
      RETURN
      END

C NCLFORTSTART
      SUBROUTINE DFILTRQ(NWT,FCA,FCB,NSIGMA,IHP,WT,RESP,FREQ,IER)
      IMPLICIT NONE

c NCL:  wt = filwgts_lancos (nwt, ihp, fca,fcb,nsigma)
c       wt@freq = freq
c       wt@resp = resp

c routine to calculate filter wgts and the associated response function

c see an article by c. duchon (u. of oklahoma):
c                   j. applied meteorology;  august,1979; pp 1016-1022
c                   "lanczos filtering in one and two dimensions"

      INTEGER NWT,IHP,IER
      DOUBLE PRECISION FCA,FCB,NSIGMA
      DOUBLE PRECISION WT(NWT)
      DOUBLE PRECISION FREQ(2*NWT-1),RESP(2*NWT-1)
c c c real    freq(*), resp(*)
C NCLEND

c input parameters :
c
c     nwt     total number of weights (an odd number; nwt.ge.3)
c             the more wgts .... the better the filter but there
c             is a greater loss of data.
c
c     fca     the cut-off freq of the ideal high or
c             low-pass filter: [ 0.0 < fca < 0.5 ]
c
c     fcb     used only when a band-pass filter is desired,
c             in which case it is the cut-off freq for the
c             second low-pass filter:  [ fca < fcb < 0.5 ]
c
c     nsigma  the power of the sigma factor.  it is
c             greater than or equal to zero.
c             note: nsigma=1 to 3 is usually good enough.
c
c     ihp     if low-pass filter ihp = 0,
c             if high-pass ihp = 1,
c             if band-pass ihp = 2.
c
c     work    work array of length nwt
c
c output parameters :
c
c     wt      vector containing the computed wgts. its length is nwt.
c             the central weight is located at nwt/2+1.
c
c     resp    the array of responses at freq intvls
c             of 0.5/(2*nwt-2)  cycles/data intvl from the
c             origin to the nyquist.  its length is 2*nwt-1.
c
c     freq    the array of freqs at intvls of 0.5/(2*nwt-2)
c             cycles/data intvl at which the responses
c             are calculated.  its length is 2*nwt-1 .
c
c     ier     simple error code
c                                                   ! automatic
      DOUBLE PRECISION WORK(NWT)
      DOUBLE PRECISION PI,TWOPI,FNW,SUM,FRQINT
      INTEGER NW,N,NWP1,I,J,NF

      IER = 0
C      IF (NWT.LT.3) IER = 1
C      IF (IHP.LT.0 .OR. IHP.GT.2) IER = IER + 10
C      IF (FCA.LT.0.0D0 .OR. FCA.GT.0.5D0) IER = IER + 100
C      IF (IHP.EQ.2) THEN
C          IF (FCB.LT.0.0D0 .OR. FCB.GT.0.5D0) IER = IER + 1000
C          IF (FCB.LT.FCA) IER = IER + 10000
C      END IF

      IF (IER.NE.0) RETURN

      PI = 4.D0*ATAN(1.0D0)
      TWOPI = 2.D0*PI
      NW = (NWT-1)/2
      FNW = DBLE(NW)

c compute weights

      CALL DFILWTQ(WT,NWT,NW,FCA,PI,TWOPI,NSIGMA)
c                               ! alter weights to get high-pass filter.
      IF (IHP.EQ.1) THEN
          WT(1) = 1.0D0 - WT(1)
          DO I = 2,NW + 1
              WT(I) = -WT(I)
          END DO
      ELSE IF (IHP.EQ.2) THEN
c                               ! compute wgts of 2nd low-pass filt
c                               ! save 1st set of low pass filter wgts
          DO I = 1,NW + 1
              WORK(I) = WT(I)
          END DO
          CALL DFILWTQ(WT,NWT,NW,FCB,PI,TWOPI,NSIGMA)
c                               ! alter weights to get band-pass filter
          DO I = 1,NW + 1
              WT(I) = WT(I) - WORK(I)
          END DO
      END IF

c compute response fctn

      SUM = 0.0D0
      NF = 2*NWT - 1
      FREQ(1) = 0.0D0
      FRQINT = 0.5D0/DBLE(NF-1)
      DO J = 2,NW + 1
          SUM = SUM + 2.0D0*WT(J)
      END DO
      RESP(1) = SUM + WT(1)

      DO I = 2,NF
          SUM = 0.0D0
          FREQ(I) = DBLE(I-1)*FRQINT
          DO J = 2,NW + 1
              SUM = SUM + WT(J)*COS(TWOPI*FREQ(I)*DBLE(J-1))
          END DO
          RESP(I) = WT(1) + 2.0D0*SUM
      END DO

c make wt symmetric

      NWP1 = NW + 1
      DO N = 1,NW
          WORK(N) = WT(N+1)
      END DO
      WT(NWP1) = WT(1)
      DO N = 1,NW
          WT(N) = WORK(NWP1-N)
          WT(NWP1+N) = WORK(N)
      END DO

      RETURN
      END
c ----------------------------------------------------------
      SUBROUTINE DFILWTQ(WT,NWT,NW,FC,PI,TWOPI,NSIGMA)
      IMPLICIT NONE

c compute and normalize filter wgts

      INTEGER NWT,NW
      DOUBLE PRECISION WT(NWT),FC,PI,TWOPI,NSIGMA
c                                                ! local
      DOUBLE PRECISION ARG,FNW,SINX,SINY,SUM
      INTEGER I

      ARG = TWOPI*FC
      FNW = DBLE(NW)

      WT(1) = 2.0D0*FC
      DO I = 1,NW
          SINX = SIN(ARG*DBLE(I))/ (PI*DBLE(I))
          SINY = FNW*SIN(DBLE(I)*PI/FNW)/ (DBLE(I)*PI)
          WT(I+1) = SINX*SINY**NSIGMA
      END DO

c                                                ! normalize weights
      SUM = WT(1)
      DO I = 2,NW + 1
          SUM = SUM + 2.0D0*WT(I)
      END DO
      DO I = 1,NW + 1
          WT(I) = WT(I)/SUM
      END DO

      RETURN
      END

C NCLFORTSTART
      subroutine filwgtnormal (nwt, w, itype, sigma, ier)
      implicit none
      integer  nwt, itype, ier
      double precision     w(nwt), sigma
C NCLEND
c
c NCL: wgts = filwgts(nwt, sigma, itype)
c currently this only does gaussian (normal) weights
c
      double precision    pi, c1, c2, mean, delx, x, wsum
      integer n

      ier  = 0
      mean = 0.0d0

      pi   = 4.d0*atan(1.d0)
      c1   = 1.d0/(sigma*sqrt(2.d0*pi))
      c2   = -0.5d0/sigma**2

c                   delx = fspan(-1, 1, nwt)
      delx = 2.d0/(nwt-1)   

c c c if (itype.eq.0) then
          x    = -(1.d0+delx)
          wsum = 0.0d0
          do n=1,nwt
             x = x+delx
             w(n) = c1*exp(c2*(x-mean)**2)
             wsum = wsum+w(n)
          end do
c c c else
c c c     ier = 1
c c c     print ("filwgts: unsupported option")
c c c end if

      do n=1,nwt
         w(n) = w(n)/wsum
      end do

      return
      end

C
C $Id: nwtstr.f,v 1.8 2008-07-27 00:17:15 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
C *************************************************************
C
      SUBROUTINE NWTSTR (PX,PY,CH)
C
C *************************************************************
C
C This subroutine is a routine which converts calls to
C GTX to calls to PCHIQU.  Direct calls to GTX produce
C distortions in the characters due to the current
C normalization transformation.  PCHIQU avoids this
C problem by using a uniform transformation.
C
      CHARACTER*(*) CH
      REAL VP(4),WN(4)
C
C Determine the centering option.
C
      CALL GQCNTN(IER,INT)
      CALL GQNT(INT,IER,WN,VP)
      CALL GQTXAL(IER,IHZ,IDUM)
C
        ICENT = IHZ-2
	IF (IHZ .EQ. 0) ICENT = -1
	CNTR = REAL(ICENT)
C
C Determine character height.
C
      CALL GQCHH (IER,CHARH)
C
	 YPORT  = VP(4) - VP(3)
	SIZE = CHARH * YPORT
C
C Determine character orientation.
C
      CALL GQCHUP(IER,XV,YV)
      ANGD = 57.29634*ATAN2(-XV,YV)
      IANG = ANGD + .01
      IF (IANG.LT. 0) IANG = IANG+360
      ANGD = REAL(IANG)
C
C Invoke PCHIQU (formerly PLCHHQ) of the Plotchar utility.
C
      CALL PCHIQU (PX,PY,CH,SIZE,ANGD,CNTR)
C
      RETURN
      END

C
C $Id: curve3.f,v 1.6 2008-07-27 00:17:33 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CURVE3 (U,V,W,N)
      SAVE
      DIMENSION       U(N)       ,V(N)       ,W(N)
      CALL TRN32T (U(1),V(1),W(1),X,Y,ZDUM,2)
      CALL PLOTIT (32*INT(X),32*INT(Y),0)
      NN = N
      IF (NN .LT. 2) RETURN
      DO  10 I=2,NN
         UU = U(I)
         VV = V(I)
         WW = W(I)
         CALL TRN32T (UU,VV,WW,X,Y,ZDUM,2)
         CALL PLOTIT (32*INT(X),32*INT(Y),1)
   10 CONTINUE
C
C FLUSH PLOTIT BUFFER
C
      CALL PLOTIT(0,0,0)
      RETURN
      END

      SUBROUTINE DTGEX2( WANTQ, WANTZ, N, A, LDA, B, LDB, Q, LDQ, Z,
     $                   LDZ, J1, N1, N2, WORK, LWORK, INFO )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      LOGICAL            WANTQ, WANTZ
      INTEGER            INFO, J1, LDA, LDB, LDQ, LDZ, LWORK, N, N1, N2
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), B( LDB, * ), Q( LDQ, * ),
     $                   WORK( * ), Z( LDZ, * )
*     ..
*
*  Purpose
*  =======
*
*  DTGEX2 swaps adjacent diagonal blocks (A11, B11) and (A22, B22)
*  of size 1-by-1 or 2-by-2 in an upper (quasi) triangular matrix pair
*  (A, B) by an orthogonal equivalence transformation.
*
*  (A, B) must be in generalized real Schur canonical form (as returned
*  by DGGES), i.e. A is block upper triangular with 1-by-1 and 2-by-2
*  diagonal blocks. B is upper triangular.
*
*  Optionally, the matrices Q and Z of generalized Schur vectors are
*  updated.
*
*         Q(in) * A(in) * Z(in)' = Q(out) * A(out) * Z(out)'
*         Q(in) * B(in) * Z(in)' = Q(out) * B(out) * Z(out)'
*
*
*  Arguments
*  =========
*
*  WANTQ   (input) LOGICAL
*          .TRUE. : update the left transformation matrix Q;
*          .FALSE.: do not update Q.
*
*  WANTZ   (input) LOGICAL
*          .TRUE. : update the right transformation matrix Z;
*          .FALSE.: do not update Z.
*
*  N       (input) INTEGER
*          The order of the matrices A and B. N >= 0.
*
*  A      (input/output) DOUBLE PRECISION arrays, dimensions (LDA,N)
*          On entry, the matrix A in the pair (A, B).
*          On exit, the updated matrix A.
*
*  LDA     (input)  INTEGER
*          The leading dimension of the array A. LDA >= max(1,N).
*
*  B      (input/output) DOUBLE PRECISION arrays, dimensions (LDB,N)
*          On entry, the matrix B in the pair (A, B).
*          On exit, the updated matrix B.
*
*  LDB     (input)  INTEGER
*          The leading dimension of the array B. LDB >= max(1,N).
*
*  Q       (input/output) DOUBLE PRECISION array, dimension (LDZ,N)
*          On entry, if WANTQ = .TRUE., the orthogonal matrix Q.
*          On exit, the updated matrix Q.
*          Not referenced if WANTQ = .FALSE..
*
*  LDQ     (input) INTEGER
*          The leading dimension of the array Q. LDQ >= 1.
*          If WANTQ = .TRUE., LDQ >= N.
*
*  Z       (input/output) DOUBLE PRECISION array, dimension (LDZ,N)
*          On entry, if WANTZ =.TRUE., the orthogonal matrix Z.
*          On exit, the updated matrix Z.
*          Not referenced if WANTZ = .FALSE..
*
*  LDZ     (input) INTEGER
*          The leading dimension of the array Z. LDZ >= 1.
*          If WANTZ = .TRUE., LDZ >= N.
*
*  J1      (input) INTEGER
*          The index to the first block (A11, B11). 1 <= J1 <= N.
*
*  N1      (input) INTEGER
*          The order of the first block (A11, B11). N1 = 0, 1 or 2.
*
*  N2      (input) INTEGER
*          The order of the second block (A22, B22). N2 = 0, 1 or 2.
*
*  WORK    (workspace) DOUBLE PRECISION array, dimension (LWORK).
*
*  LWORK   (input) INTEGER
*          The dimension of the array WORK.
*          LWORK >=  MAX( N*(N2+N1), (N2+N1)*(N2+N1)*2 )
*
*  INFO    (output) INTEGER
*            =0: Successful exit
*            >0: If INFO = 1, the transformed matrix (A, B) would be
*                too far from generalized Schur form; the blocks are
*                not swapped and (A, B) and (Q, Z) are unchanged.
*                The problem of swapping is too ill-conditioned.
*            <0: If INFO = -16: LWORK is too small. Appropriate value
*                for LWORK is returned in WORK(1).
*
*  Further Details
*  ===============
*
*  Based on contributions by
*     Bo Kagstrom and Peter Poromaa, Department of Computing Science,
*     Umea University, S-901 87 Umea, Sweden.
*
*  In the current code both weak and strong stability tests are
*  performed. The user can omit the strong stability test by changing
*  the internal logical parameter WANDS to .FALSE.. See ref. [2] for
*  details.
*
*  [1] B. Kagstrom; A Direct Method for Reordering Eigenvalues in the
*      Generalized Real Schur Form of a Regular Matrix Pair (A, B), in
*      M.S. Moonen et al (eds), Linear Algebra for Large Scale and
*      Real-Time Applications, Kluwer Academic Publ. 1993, pp 195-218.
*
*  [2] B. Kagstrom and P. Poromaa; Computing Eigenspaces with Specified
*      Eigenvalues of a Regular Matrix Pair (A, B) and Condition
*      Estimation: Theory, Algorithms and Software,
*      Report UMINF - 94.04, Department of Computing Science, Umea
*      University, S-901 87 Umea, Sweden, 1994. Also as LAPACK Working
*      Note 87. To appear in Numerical Algorithms, 1996.
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO, ONE
      PARAMETER          ( ZERO = 0.0D+0, ONE = 1.0D+0 )
      DOUBLE PRECISION   TEN
      PARAMETER          ( TEN = 1.0D+01 )
      INTEGER            LDST
      PARAMETER          ( LDST = 4 )
      LOGICAL            WANDS
      PARAMETER          ( WANDS = .TRUE. )
*     ..
*     .. Local Scalars ..
      LOGICAL            DTRONG, WEAK
      INTEGER            I, IDUM, LINFO, M
      DOUBLE PRECISION   BQRA21, BRQA21, DDUM, DNORM, DSCALE, DSUM, EPS,
     $                   F, G, SA, SB, SCALE, SMLNUM, SS, THRESH, WS
*     ..
*     .. Local Arrays ..
      INTEGER            IWORK( LDST )
      DOUBLE PRECISION   AI( 2 ), AR( 2 ), BE( 2 ), IR( LDST, LDST ),
     $                   IRCOP( LDST, LDST ), LI( LDST, LDST ),
     $                   LICOP( LDST, LDST ), S( LDST, LDST ),
     $                   SCPY( LDST, LDST ), T( LDST, LDST ),
     $                   TAUL( LDST ), TAUR( LDST ), TCPY( LDST, LDST )
*     ..
*     .. External Functions ..
      DOUBLE PRECISION   DLAMCH
      EXTERNAL           DLAMCH
*     ..
*     .. External Subroutines ..
      EXTERNAL           DCOPY, DGEMM, DGEQR2, DGERQ2, DLACPY, DLAGV2,
     $                   DLARTG, DLASSQ, DORG2R, DORGR2, DORM2R, DORMR2,
     $                   DROT, DSCAL, DTGSY2
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, MAX, SQRT
*     ..
*     .. Executable Statements ..
*
      INFO = 0
*
*     Quick return if possible
*
      IF( N.LE.1 .OR. N1.LE.0 .OR. N2.LE.0 )
     $   RETURN
      IF( N1.GT.N .OR. ( J1+N1 ).GT.N )
     $   RETURN
      M = N1 + N2
      IF( LWORK.LT.MAX( N*M, M*M*2 ) ) THEN
         INFO = -16
         WORK( 1 ) = MAX( N*M, M*M*2 )
         RETURN
      END IF
*
      WEAK = .FALSE.
      DTRONG = .FALSE.
*
*     Make a local copy of selected block
*
      CALL DCOPY( LDST*LDST, ZERO, 0, LI, 1 )
      CALL DCOPY( LDST*LDST, ZERO, 0, IR, 1 )
      CALL DLACPY( 'Full', M, M, A( J1, J1 ), LDA, S, LDST )
      CALL DLACPY( 'Full', M, M, B( J1, J1 ), LDB, T, LDST )
*
*     Compute threshold for testing acceptance of swapping.
*
      EPS = DLAMCH( 'P' )
      SMLNUM = DLAMCH( 'S' ) / EPS
      DSCALE = ZERO
      DSUM = ONE
      CALL DLACPY( 'Full', M, M, S, LDST, WORK, M )
      CALL DLASSQ( M*M, WORK, 1, DSCALE, DSUM )
      CALL DLACPY( 'Full', M, M, T, LDST, WORK, M )
      CALL DLASSQ( M*M, WORK, 1, DSCALE, DSUM )
      DNORM = DSCALE*SQRT( DSUM )
      THRESH = MAX( TEN*EPS*DNORM, SMLNUM )
*
      IF( M.EQ.2 ) THEN
*
*        CASE 1: Swap 1-by-1 and 1-by-1 blocks.
*
*        Compute orthogonal QL and RQ that swap 1-by-1 and 1-by-1 blocks
*        using Givens rotations and perform the swap tentatively.
*
         F = S( 2, 2 )*T( 1, 1 ) - T( 2, 2 )*S( 1, 1 )
         G = S( 2, 2 )*T( 1, 2 ) - T( 2, 2 )*S( 1, 2 )
         SB = ABS( T( 2, 2 ) )
         SA = ABS( S( 2, 2 ) )
         CALL DLARTG( F, G, IR( 1, 2 ), IR( 1, 1 ), DDUM )
         IR( 2, 1 ) = -IR( 1, 2 )
         IR( 2, 2 ) = IR( 1, 1 )
         CALL DROT( 2, S( 1, 1 ), 1, S( 1, 2 ), 1, IR( 1, 1 ),
     $              IR( 2, 1 ) )
         CALL DROT( 2, T( 1, 1 ), 1, T( 1, 2 ), 1, IR( 1, 1 ),
     $              IR( 2, 1 ) )
         IF( SA.GE.SB ) THEN
            CALL DLARTG( S( 1, 1 ), S( 2, 1 ), LI( 1, 1 ), LI( 2, 1 ),
     $                   DDUM )
         ELSE
            CALL DLARTG( T( 1, 1 ), T( 2, 1 ), LI( 1, 1 ), LI( 2, 1 ),
     $                   DDUM )
         END IF
         CALL DROT( 2, S( 1, 1 ), LDST, S( 2, 1 ), LDST, LI( 1, 1 ),
     $              LI( 2, 1 ) )
         CALL DROT( 2, T( 1, 1 ), LDST, T( 2, 1 ), LDST, LI( 1, 1 ),
     $              LI( 2, 1 ) )
         LI( 2, 2 ) = LI( 1, 1 )
         LI( 1, 2 ) = -LI( 2, 1 )
*
*        Weak stability test:
*           |S21| + |T21| <= O(EPS * F-norm((S, T)))
*
         WS = ABS( S( 2, 1 ) ) + ABS( T( 2, 1 ) )
         WEAK = WS.LE.THRESH
         IF( .NOT.WEAK )
     $      GO TO 70
*
         IF( WANDS ) THEN
*
*           Strong stability test:
*             F-norm((A-QL'*S*QR, B-QL'*T*QR)) <= O(EPS*F-norm((A,B)))
*
            CALL DLACPY( 'Full', M, M, A( J1, J1 ), LDA, WORK( M*M+1 ),
     $                   M )
            CALL DGEMM( 'N', 'N', M, M, M, ONE, LI, LDST, S, LDST, ZERO,
     $                  WORK, M )
            CALL DGEMM( 'N', 'T', M, M, M, -ONE, WORK, M, IR, LDST, ONE,
     $                  WORK( M*M+1 ), M )
            DSCALE = ZERO
            DSUM = ONE
            CALL DLASSQ( M*M, WORK( M*M+1 ), 1, DSCALE, DSUM )
*
            CALL DLACPY( 'Full', M, M, B( J1, J1 ), LDB, WORK( M*M+1 ),
     $                   M )
            CALL DGEMM( 'N', 'N', M, M, M, ONE, LI, LDST, T, LDST, ZERO,
     $                  WORK, M )
            CALL DGEMM( 'N', 'T', M, M, M, -ONE, WORK, M, IR, LDST, ONE,
     $                  WORK( M*M+1 ), M )
            CALL DLASSQ( M*M, WORK( M*M+1 ), 1, DSCALE, DSUM )
            SS = DSCALE*SQRT( DSUM )
            DTRONG = SS.LE.THRESH
            IF( .NOT.DTRONG )
     $         GO TO 70
         END IF
*
*        Update (A(J1:J1+M-1, M+J1:N), B(J1:J1+M-1, M+J1:N)) and
*               (A(1:J1-1, J1:J1+M), B(1:J1-1, J1:J1+M)).
*
         CALL DROT( J1+1, A( 1, J1 ), 1, A( 1, J1+1 ), 1, IR( 1, 1 ),
     $              IR( 2, 1 ) )
         CALL DROT( J1+1, B( 1, J1 ), 1, B( 1, J1+1 ), 1, IR( 1, 1 ),
     $              IR( 2, 1 ) )
         CALL DROT( N-J1+1, A( J1, J1 ), LDA, A( J1+1, J1 ), LDA,
     $              LI( 1, 1 ), LI( 2, 1 ) )
         CALL DROT( N-J1+1, B( J1, J1 ), LDB, B( J1+1, J1 ), LDB,
     $              LI( 1, 1 ), LI( 2, 1 ) )
*
*        Set  N1-by-N2 (2,1) - blocks to ZERO.
*
         A( J1+1, J1 ) = ZERO
         B( J1+1, J1 ) = ZERO
*
*        Accumulate transformations into Q and Z if requested.
*
         IF( WANTZ )
     $      CALL DROT( N, Z( 1, J1 ), 1, Z( 1, J1+1 ), 1, IR( 1, 1 ),
     $                 IR( 2, 1 ) )
         IF( WANTQ )
     $      CALL DROT( N, Q( 1, J1 ), 1, Q( 1, J1+1 ), 1, LI( 1, 1 ),
     $                 LI( 2, 1 ) )
*
*        Exit with INFO = 0 if swap was successfully performed.
*
         RETURN
*
      ELSE
*
*        CASE 2: Swap 1-by-1 and 2-by-2 blocks, or 2-by-2
*                and 2-by-2 blocks.
*
*        Solve the generalized Sylvester equation
*                 S11 * R - L * S22 = SCALE * S12
*                 T11 * R - L * T22 = SCALE * T12
*        for R and L. Solutions in LI and IR.
*
         CALL DLACPY( 'Full', N1, N2, T( 1, N1+1 ), LDST, LI, LDST )
         CALL DLACPY( 'Full', N1, N2, S( 1, N1+1 ), LDST,
     $                IR( N2+1, N1+1 ), LDST )
         CALL DTGSY2( 'N', 0, N1, N2, S, LDST, S( N1+1, N1+1 ), LDST,
     $                IR( N2+1, N1+1 ), LDST, T, LDST, T( N1+1, N1+1 ),
     $                LDST, LI, LDST, SCALE, DSUM, DSCALE, IWORK, IDUM,
     $                LINFO )
*
*        Compute orthogonal matrix QL:
*
*                    QL' * LI = [ TL ]
*                               [ 0  ]
*        where
*                    LI =  [      -L              ]
*                          [ SCALE * identity(N2) ]
*
         DO 10 I = 1, N2
            CALL DSCAL( N1, -ONE, LI( 1, I ), 1 )
            LI( N1+I, I ) = SCALE
   10    CONTINUE
         CALL DGEQR2( M, N2, LI, LDST, TAUL, WORK, LINFO )
         IF( LINFO.NE.0 )
     $      GO TO 70
         CALL DORG2R( M, M, N2, LI, LDST, TAUL, WORK, LINFO )
         IF( LINFO.NE.0 )
     $      GO TO 70
*
*        Compute orthogonal matrix RQ:
*
*                    IR * RQ' =   [ 0  TR],
*
*         where IR = [ SCALE * identity(N1), R ]
*
         DO 20 I = 1, N1
            IR( N2+I, I ) = SCALE
   20    CONTINUE
         CALL DGERQ2( N1, M, IR( N2+1, 1 ), LDST, TAUR, WORK, LINFO )
         IF( LINFO.NE.0 )
     $      GO TO 70
         CALL DORGR2( M, M, N1, IR, LDST, TAUR, WORK, LINFO )
         IF( LINFO.NE.0 )
     $      GO TO 70
*
*        Perform the swapping tentatively:
*
         CALL DGEMM( 'T', 'N', M, M, M, ONE, LI, LDST, S, LDST, ZERO,
     $               WORK, M )
         CALL DGEMM( 'N', 'T', M, M, M, ONE, WORK, M, IR, LDST, ZERO, S,
     $               LDST )
         CALL DGEMM( 'T', 'N', M, M, M, ONE, LI, LDST, T, LDST, ZERO,
     $               WORK, M )
         CALL DGEMM( 'N', 'T', M, M, M, ONE, WORK, M, IR, LDST, ZERO, T,
     $               LDST )
         CALL DLACPY( 'F', M, M, S, LDST, SCPY, LDST )
         CALL DLACPY( 'F', M, M, T, LDST, TCPY, LDST )
         CALL DLACPY( 'F', M, M, IR, LDST, IRCOP, LDST )
         CALL DLACPY( 'F', M, M, LI, LDST, LICOP, LDST )
*
*        Triangularize the B-part by an RQ factorization.
*        Apply transformation (from left) to A-part, giving S.
*
         CALL DGERQ2( M, M, T, LDST, TAUR, WORK, LINFO )
         IF( LINFO.NE.0 )
     $      GO TO 70
         CALL DORMR2( 'R', 'T', M, M, M, T, LDST, TAUR, S, LDST, WORK,
     $                LINFO )
         IF( LINFO.NE.0 )
     $      GO TO 70
         CALL DORMR2( 'L', 'N', M, M, M, T, LDST, TAUR, IR, LDST, WORK,
     $                LINFO )
         IF( LINFO.NE.0 )
     $      GO TO 70
*
*        Compute F-norm(S21) in BRQA21. (T21 is 0.)
*
         DSCALE = ZERO
         DSUM = ONE
         DO 30 I = 1, N2
            CALL DLASSQ( N1, S( N2+1, I ), 1, DSCALE, DSUM )
   30    CONTINUE
         BRQA21 = DSCALE*SQRT( DSUM )
*
*        Triangularize the B-part by a QR factorization.
*        Apply transformation (from right) to A-part, giving S.
*
         CALL DGEQR2( M, M, TCPY, LDST, TAUL, WORK, LINFO )
         IF( LINFO.NE.0 )
     $      GO TO 70
         CALL DORM2R( 'L', 'T', M, M, M, TCPY, LDST, TAUL, SCPY, LDST,
     $                WORK, INFO )
         CALL DORM2R( 'R', 'N', M, M, M, TCPY, LDST, TAUL, LICOP, LDST,
     $                WORK, INFO )
         IF( LINFO.NE.0 )
     $      GO TO 70
*
*        Compute F-norm(S21) in BQRA21. (T21 is 0.)
*
         DSCALE = ZERO
         DSUM = ONE
         DO 40 I = 1, N2
            CALL DLASSQ( N1, SCPY( N2+1, I ), 1, DSCALE, DSUM )
   40    CONTINUE
         BQRA21 = DSCALE*SQRT( DSUM )
*
*        Decide which method to use.
*          Weak stability test:
*             F-norm(S21) <= O(EPS * F-norm((S, T)))
*
         IF( BQRA21.LE.BRQA21 .AND. BQRA21.LE.THRESH ) THEN
            CALL DLACPY( 'F', M, M, SCPY, LDST, S, LDST )
            CALL DLACPY( 'F', M, M, TCPY, LDST, T, LDST )
            CALL DLACPY( 'F', M, M, IRCOP, LDST, IR, LDST )
            CALL DLACPY( 'F', M, M, LICOP, LDST, LI, LDST )
         ELSE IF( BRQA21.GE.THRESH ) THEN
            GO TO 70
         END IF
*
*        Set lower triangle of B-part to zero
*
         DO 50 I = 2, M
            CALL DCOPY( M-I+1, ZERO, 0, T( I, I-1 ), 1 )
   50    CONTINUE
*
         IF( WANDS ) THEN
*
*           Strong stability test:
*              F-norm((A-QL*S*QR', B-QL*T*QR')) <= O(EPS*F-norm((A,B)))
*
            CALL DLACPY( 'Full', M, M, A( J1, J1 ), LDA, WORK( M*M+1 ),
     $                   M )
            CALL DGEMM( 'N', 'N', M, M, M, ONE, LI, LDST, S, LDST, ZERO,
     $                  WORK, M )
            CALL DGEMM( 'N', 'N', M, M, M, -ONE, WORK, M, IR, LDST, ONE,
     $                  WORK( M*M+1 ), M )
            DSCALE = ZERO
            DSUM = ONE
            CALL DLASSQ( M*M, WORK( M*M+1 ), 1, DSCALE, DSUM )
*
            CALL DLACPY( 'Full', M, M, B( J1, J1 ), LDB, WORK( M*M+1 ),
     $                   M )
            CALL DGEMM( 'N', 'N', M, M, M, ONE, LI, LDST, T, LDST, ZERO,
     $                  WORK, M )
            CALL DGEMM( 'N', 'N', M, M, M, -ONE, WORK, M, IR, LDST, ONE,
     $                  WORK( M*M+1 ), M )
            CALL DLASSQ( M*M, WORK( M*M+1 ), 1, DSCALE, DSUM )
            SS = DSCALE*SQRT( DSUM )
            DTRONG = ( SS.LE.THRESH )
            IF( .NOT.DTRONG )
     $         GO TO 70
*
         END IF
*
*        If the swap is accepted ("weakly" and "strongly"), apply the
*        transformations and set N1-by-N2 (2,1)-block to zero.
*
         DO 60 I = 1, N2
            CALL DCOPY( N1, ZERO, 0, S( N2+1, I ), 1 )
   60    CONTINUE
*
*        copy back M-by-M diagonal block starting at index J1 of (A, B)
*
         CALL DLACPY( 'F', M, M, S, LDST, A( J1, J1 ), LDA )
         CALL DLACPY( 'F', M, M, T, LDST, B( J1, J1 ), LDB )
         CALL DCOPY( LDST*LDST, ZERO, 0, T, 1 )
*
*        Standardize existing 2-by-2 blocks.
*
         CALL DCOPY( M*M, ZERO, 0, WORK, 1 )
         WORK( 1 ) = ONE
         T( 1, 1 ) = ONE
         IDUM = LWORK - M*M - 2
         IF( N2.GT.1 ) THEN
            CALL DLAGV2( A( J1, J1 ), LDA, B( J1, J1 ), LDB, AR, AI, BE,
     $                   WORK( 1 ), WORK( 2 ), T( 1, 1 ), T( 2, 1 ) )
            WORK( M+1 ) = -WORK( 2 )
            WORK( M+2 ) = WORK( 1 )
            T( N2, N2 ) = T( 1, 1 )
            T( 1, 2 ) = -T( 2, 1 )
         END IF
         WORK( M*M ) = ONE
         T( M, M ) = ONE
*
         IF( N1.GT.1 ) THEN
            CALL DLAGV2( A( J1+N2, J1+N2 ), LDA, B( J1+N2, J1+N2 ), LDB,
     $                   TAUR, TAUL, WORK( M*M+1 ), WORK( N2*M+N2+1 ),
     $                   WORK( N2*M+N2+2 ), T( N2+1, N2+1 ),
     $                   T( M, M-1 ) )
            WORK( M*M ) = WORK( N2*M+N2+1 )
            WORK( M*M-1 ) = -WORK( N2*M+N2+2 )
            T( M, M ) = T( N2+1, N2+1 )
            T( M-1, M ) = -T( M, M-1 )
         END IF
         CALL DGEMM( 'T', 'N', N2, N1, N2, ONE, WORK, M, A( J1, J1+N2 ),
     $               LDA, ZERO, WORK( M*M+1 ), N2 )
         CALL DLACPY( 'Full', N2, N1, WORK( M*M+1 ), N2, A( J1, J1+N2 ),
     $                LDA )
         CALL DGEMM( 'T', 'N', N2, N1, N2, ONE, WORK, M, B( J1, J1+N2 ),
     $               LDB, ZERO, WORK( M*M+1 ), N2 )
         CALL DLACPY( 'Full', N2, N1, WORK( M*M+1 ), N2, B( J1, J1+N2 ),
     $                LDB )
         CALL DGEMM( 'N', 'N', M, M, M, ONE, LI, LDST, WORK, M, ZERO,
     $               WORK( M*M+1 ), M )
         CALL DLACPY( 'Full', M, M, WORK( M*M+1 ), M, LI, LDST )
         CALL DGEMM( 'N', 'N', N2, N1, N1, ONE, A( J1, J1+N2 ), LDA,
     $               T( N2+1, N2+1 ), LDST, ZERO, WORK, N2 )
         CALL DLACPY( 'Full', N2, N1, WORK, N2, A( J1, J1+N2 ), LDA )
         CALL DGEMM( 'N', 'N', N2, N1, N1, ONE, B( J1, J1+N2 ), LDA,
     $               T( N2+1, N2+1 ), LDST, ZERO, WORK, N2 )
         CALL DLACPY( 'Full', N2, N1, WORK, N2, B( J1, J1+N2 ), LDB )
         CALL DGEMM( 'T', 'N', M, M, M, ONE, IR, LDST, T, LDST, ZERO,
     $               WORK, M )
         CALL DLACPY( 'Full', M, M, WORK, M, IR, LDST )
*
*        Accumulate transformations into Q and Z if requested.
*
         IF( WANTQ ) THEN
            CALL DGEMM( 'N', 'N', N, M, M, ONE, Q( 1, J1 ), LDQ, LI,
     $                  LDST, ZERO, WORK, N )
            CALL DLACPY( 'Full', N, M, WORK, N, Q( 1, J1 ), LDQ )
*
         END IF
*
         IF( WANTZ ) THEN
            CALL DGEMM( 'N', 'N', N, M, M, ONE, Z( 1, J1 ), LDZ, IR,
     $                  LDST, ZERO, WORK, N )
            CALL DLACPY( 'Full', N, M, WORK, N, Z( 1, J1 ), LDZ )
*
         END IF
*
*        Update (A(J1:J1+M-1, M+J1:N), B(J1:J1+M-1, M+J1:N)) and
*                (A(1:J1-1, J1:J1+M), B(1:J1-1, J1:J1+M)).
*
         I = J1 + M
         IF( I.LE.N ) THEN
            CALL DGEMM( 'T', 'N', M, N-I+1, M, ONE, LI, LDST,
     $                  A( J1, I ), LDA, ZERO, WORK, M )
            CALL DLACPY( 'Full', M, N-I+1, WORK, M, A( J1, I ), LDA )
            CALL DGEMM( 'T', 'N', M, N-I+1, M, ONE, LI, LDST,
     $                  B( J1, I ), LDA, ZERO, WORK, M )
            CALL DLACPY( 'Full', M, N-I+1, WORK, M, B( J1, I ), LDA )
         END IF
         I = J1 - 1
         IF( I.GT.0 ) THEN
            CALL DGEMM( 'N', 'N', I, M, M, ONE, A( 1, J1 ), LDA, IR,
     $                  LDST, ZERO, WORK, I )
            CALL DLACPY( 'Full', I, M, WORK, I, A( 1, J1 ), LDA )
            CALL DGEMM( 'N', 'N', I, M, M, ONE, B( 1, J1 ), LDB, IR,
     $                  LDST, ZERO, WORK, I )
            CALL DLACPY( 'Full', I, M, WORK, I, B( 1, J1 ), LDB )
         END IF
*
*        Exit with INFO = 0 if swap was successfully performed.
*
         RETURN
*
      END IF
*
*     Exit with INFO = 1 if swap was rejected.
*
   70 CONTINUE
*
      INFO = 1
      RETURN
*
*     End of DTGEX2
*
      END

      PROGRAM COEX02
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C  Number of squares in the X and Y directions.
C
      PARAMETER (NX=4, NY=4)
C
C  Size of each square; spacing between squares.
C
      PARAMETER (SZX=.235, SZY=.135, Y0=.10, Y1=.88)
      PARAMETER (SPX=(1.-NX*SZX)/(NX+1), SPY=(Y1-Y0-NY*SZY)/(NY-1) )
C
C  Arrays to store labels.
C
      CHARACTER*25 TLAB(NX,NY)
      CHARACTER*20 BLAB(NX,NY)
C
C  Color value array.
C
      DIMENSION RGB(3,NX,NY)
C
      DATA RGB(1,1,1),RGB(2,1,1),RGB(3,1,1)/ 0.86, 0.58, 0.44/
      DATA RGB(1,2,1),RGB(2,2,1),RGB(3,2,1)/ 0.65, 0.16, 0.16/
      DATA RGB(1,3,1),RGB(2,3,1),RGB(3,3,1)/ 1.00, 0.50, 0.00/
      DATA RGB(1,4,1),RGB(2,4,1),RGB(3,4,1)/ 1.00, 0.00, 0.00/
      DATA RGB(1,1,2),RGB(2,1,2),RGB(3,1,2)/ 1.00, 1.00, 0.00/
      DATA RGB(1,2,2),RGB(2,2,2),RGB(3,2,2)/ 0.00, 1.00, 0.00/
      DATA RGB(1,3,2),RGB(2,3,2),RGB(3,3,2)/ 0.14, 0.56, 0.14/
      DATA RGB(1,4,2),RGB(2,4,2),RGB(3,4,2)/ 0.00, 1.00, 1.00/
      DATA RGB(1,1,3),RGB(2,1,3),RGB(3,1,3)/ 0.20, 0.56, 0.80/
      DATA RGB(1,2,3),RGB(2,2,3),RGB(3,2,3)/ 0.00, 0.00, 1.00/
      DATA RGB(1,3,3),RGB(2,3,3),RGB(3,3,3)/ 0.50, 0.00, 1.00/
      DATA RGB(1,4,3),RGB(2,4,3),RGB(3,4,3)/ 1.00, 0.00, 1.00/
      DATA RGB(1,1,4),RGB(2,1,4),RGB(3,1,4)/ 1.00, 1.00, 1.00/
      DATA RGB(1,2,4),RGB(2,2,4),RGB(3,2,4)/ 0.66, 0.66, 0.66/
      DATA RGB(1,3,4),RGB(2,3,4),RGB(3,3,4)/ 0.40, 0.40, 0.40/
      DATA RGB(1,4,4),RGB(2,4,4),RGB(3,4,4)/ 0.00, 0.00, 0.00/
C
      DATA TLAB(1,1)/'Tan'/
      DATA TLAB(2,1)/'Brown'/
      DATA TLAB(3,1)/'Orange'/
      DATA TLAB(4,1)/'Red'/
      DATA TLAB(1,2)/'Yellow'/
      DATA TLAB(2,2)/'Green'/
      DATA TLAB(3,2)/'Forest Green'/
      DATA TLAB(4,2)/'Cyan'/
      DATA TLAB(1,3)/'Sky Blue'/
      DATA TLAB(2,3)/'Blue'/
      DATA TLAB(3,3)/'Blue Magenta'/
      DATA TLAB(4,3)/'Magenta'/
      DATA TLAB(1,4)/'White'/
      DATA TLAB(2,4)/'Light Gray'/
      DATA TLAB(3,4)/'Dark Gray'/
      DATA TLAB(4,4)/'Black'/
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C  Use the Duplex character set of PLOTCHAR.
C
      CALL PCSETI('CD',1)
C
C  Define color indices and RGB labels..
C
      CALL GSCR(IWKID,0,0.,0.,0.)
      CALL GSCR(IWKID,1,1.,1.,1.)
      DO 10 J=1,NY
      DO 20 I=1,NX
      CALL GSCR(IWKID,NX*(J-1)+I+1,RGB(1,I,J),RGB(2,I,J),RGB(3,I,J))
      WRITE(BLAB(I,J),500) RGB(1,I,J),RGB(2,I,J),RGB(3,I,J)
  500 FORMAT('R=',F4.2,' G=',F4.2,' B=',F4.2)
   20 CONTINUE
   10 CONTINUE
C
C  Draw the color squares and titles.
C
      DO 40 J=1,NY
      Y = Y0+(J-1)*(SPY+SZY)
      DO 30 I=1,NX
      X = SPX+(I-1)*(SPX+SZX)
      CALL DRBOX(X,Y,SZX,Y0,SZY,TLAB(I,J),BLAB(I,J),NX*(J-1)+I+1,IWKID)
   30 CONTINUE
   40 CONTINUE
C
C  Plot labels.
C
      CALL PLCHHQ(.5,.04,'The titles below each box indicate Red, Green
     1and Blue intensity values.',.012,0.,0.)
      CALL PCSETI('CD',1)
      CALL PLCHHQ(.5,.96,'Sixteen Sample Colors',
     1 .02,0.,0.)
C
      CALL FRAME
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END
      SUBROUTINE DRBOX (X,Y,SZX,Y0,SZY,TLAB,BLAB,INDX,IWKID)
C
C  Draw a color square with lower left corner (X,Y)
C
      CHARACTER*(*) TLAB,BLAB
      DIMENSION  A(5),B(5)
C
      CALL GSFACI(INDX)
      CALL GSFAIS(1)
      A(1) = X
      B(1) = Y
      A(2) = X+SZX
      B(2) = Y
      A(3) = A(2)
      B(3) = Y+SZY
      A(4) = X
      B(4) = B(3)
      A(5) = A(1)
      B(5) = B(1)
      CALL GFA(4,A,B)
C
C  If the color is black, draw a boundary.
C
      CALL GQCR(IWKID,INDX,0,IER,CR,CG,CB)
      IF (CR.EQ.0. .AND. CG.EQ.0. .AND. CB.EQ.0.) THEN
        CALL GSPLCI(1)
        CALL GPL(5,A,B)
      ENDIF
C
      ILEN = LEN(TLAB)
      DO 10 K=ILEN,1,-1
      IF (TLAB(K:K) .NE. ' ') THEN
        ITLEN = K
        GO TO 20
      ENDIF
   10 CONTINUE
   20 CONTINUE
C
      ILEN = LEN(BLAB)
      DO 30 K=ILEN,1,-1
      IF (BLAB(K:K) .NE. ' ') THEN
        IBLEN = K
        GO TO 40
      ENDIF
   30 CONTINUE
   40 CONTINUE
C
      CALL GSPLCI(1)
      CALL PLCHHQ(X+.5*SZX,Y-.015,BLAB(1:IBLEN),.0098,0.,0.)
      CALL PLCHHQ(X+.5*SZX,Y+SZY+.017,TLAB(1:ITLEN),.012,0.,0.)
C
      RETURN
      END

c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by UCAR                 .
c  .                                                             .
c  .       University Corporation for Atmospheric Research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                         SPHEREPACK                          .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c
c
c ... file shigc.f
c
c     this file contains code and documentation for subroutine shigc
c
c ... files which must be loaded with shigc.f
c
c     sphcom.f, hrfft.f, gaqd.f
c
c     3/6/98
c
c *** shigc is functionally the same as shagci or shsgci.  It
c     it included in spherepack3.0 because legacy codes, using
c     the older version of spherepack call shigc to initialize
c     the saved work space wshigc, for either shagc or shsgc
c
c     subroutine shigc(nlat,nlon,wshigc,lshigc,dwork,ldwork,ierror)
c
c     subroutine shigc initializes the array wshigc which can then
c     be used repeatedly by subroutines shsgc or shagc. it precomputes
c     and stores in wshigc quantities such as gaussian weights,
c     legendre polynomial coefficients, and fft trigonometric tables.
c
c     input parameters
c
c     nlat   the number of points in the gaussian colatitude grid on the
c            full sphere. these lie in the interval (0,pi) and are compu
c            in radians in theta(1),...,theta(nlat) by subroutine gaqd.
c            if nlat is odd the equator will be included as the grid poi
c            theta((nlat+1)/2).  if nlat is even the equator will be
c            excluded as a grid point and will lie half way between
c            theta(nlat/2) and theta(nlat/2+1). nlat must be at least 3.
c            note: on the half sphere, the number of grid points in the
c            colatitudinal direction is nlat/2 if nlat is even or
c            (nlat+1)/2 if nlat is odd.
c
c     nlon   the number of distinct londitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater
c            than or equal to 4. the efficiency of the computation is
c            improved when nlon is a product of small prime numbers.
c
c     wshigc an array which must be initialized by subroutine shigc.
c            once initialized, wshigc can be used repeatedly by shsgc
c            or shagc as long as nlat and nlon remain unchanged.  wshigc
c            must not be altered between calls of shsgc or shagc.
c
c     lshigc the dimension of the array wshigc as it appears in the
c            program that calls shsgc or shagc. define
c
c               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            then lshigc must be at least
c
c                  nlat*(2*l2+3*l1-2)+3*l1*(1-l1)/2+nlon+15
c
C*PL*ERROR* Comment line too long
c     dwork  a double precision work array that does not have to be saved.
c
c     ldwork the dimension of the array dwork as it appears in the
c            program that calls shigc. ldwork must be at least
c
c               nlat*(nlat+4)
c
c     output parameter
c
C*PL*ERROR* Comment line too long
c     wshigc an array which must be initialized before calling shsgc or shagc.
C*PL*ERROR* Comment line too long
c            once initialized, wshigc can be used repeatedly by shsgc or shagc
c            as long as nlat and nlon remain unchanged.  wshigc must not
c            altered between calls of shsgc or shagc
c
c     ierror = 0  no errors
c            = 1  error in the specification of nlat
c            = 2  error in the specification of nlon
c            = 3  error in the specification of lshigc
c            = 4  error in the specification of ldwork
c            = 5  failure in gaqd to compute gaussian points
c                 (due to failure in eigenvalue routine)
c
c
c ****************************************************************
      SUBROUTINE DSHIGC(NLAT,NLON,WSHIGC,LSHIGC,DWORK,LDWORK,IERROR)
      DOUBLE PRECISION WSHIGC
c     this subroutine must be called before calling shsgc/shagc with
c     fixed nlat,nlon. it precomputes quantites such as the gaussian
c     points and weights, m=0,m=1 legendre polynomials, recursion
c     recursion coefficients.
      DIMENSION WSHIGC(LSHIGC)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION DWORK(LDWORK)

      IERROR = 1
      IF (NLAT.LT.3) RETURN
      IERROR = 2
      IF (NLON.LT.4) RETURN
c     set triangular truncation limit for spherical harmonic basis
      L = MIN0((NLON+2)/2,NLAT)
c     set equator or nearest point (if excluded) pointer
      LATE = (NLAT+MOD(NLAT,2))/2
      L1 = L
      L2 = LATE
      IERROR = 3
c     check permanent work space length
      IF (LSHIGC.LT.NLAT* (2*L2+3*L1-2)+3*L1* (1-L1)/2+NLON+15) RETURN
      IERROR = 4
c     if (lwork.lt.4*nlat*(nlat+2)+2) return
      IF (LDWORK.LT.NLAT* (NLAT+4)) RETURN
      IERROR = 0
c     set pointers
      I1 = 1
      I2 = I1 + NLAT
      I3 = I2 + NLAT*LATE
      I4 = I3 + NLAT*LATE
      I5 = I4 + L* (L-1)/2 + (NLAT-L)* (L-1)
      I6 = I5 + L* (L-1)/2 + (NLAT-L)* (L-1)
      I7 = I6 + L* (L-1)/2 + (NLAT-L)* (L-1)
c     set indices in temp work for double precision gaussian wts and pts
      IDTH = 1
c     idwts = idth+2*nlat
c     iw = idwts+2*nlat
      IDWTS = IDTH + NLAT
      IW = IDWTS + NLAT
      CALL DSHIGC1(NLAT,NLON,L,LATE,WSHIGC(I1),WSHIGC(I2),WSHIGC(I3),
     +            WSHIGC(I4),WSHIGC(I5),WSHIGC(I6),WSHIGC(I7),
     +            DWORK(IDTH),DWORK(IDWTS),DWORK(IW),IERROR)
      IF (IERROR.NE.0) IERROR = 5
      RETURN
      END
      SUBROUTINE DSHIGC1(NLAT,NLON,L,LATE,WTS,P0N,P1N,ABEL,BBEL,CBEL,
     +                   WFFT,DTHETA,DWTS,WORK,IER)
      DOUBLE PRECISION WTS
      DOUBLE PRECISION P0N
      DOUBLE PRECISION P1N
      DOUBLE PRECISION ABEL
      DOUBLE PRECISION BBEL
      DOUBLE PRECISION CBEL
      DOUBLE PRECISION WFFT
      DOUBLE PRECISION FN
      DOUBLE PRECISION FM
      DIMENSION WTS(NLAT),P0N(NLAT,LATE),P1N(NLAT,LATE),ABEL(1),BBEL(1),
     +          CBEL(1),WFFT(1),DTHETA(NLAT),DWTS(NLAT)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION PB,DTHETA,DWTS,WORK(*)
c     compute the nlat  gaussian points and weights, the
c     m=0,1 legendre polys for gaussian points and all n,
c     and the legendre recursion coefficients
c     define index function used in storing
c     arrays for recursion coefficients (functions of (m,n))
c     the index function indx(m,n) is defined so that
c     the pairs (m,n) map to [1,2,...,indx(l-1,l-1)] with no
c     "holes" as m varies from 2 to n and n varies from 2 to l-1.
c     (m=0,1 are set from p0n,p1n for all n)
c     define for 2.le.n.le.l-1
      INDX(M,N) = (N-1)* (N-2)/2 + M - 1
c     define index function for l.le.n.le.nlat
      IMNDX(M,N) = L* (L-1)/2 + (N-L-1)* (L-1) + M - 1
c     preset quantites for fourier transform
      CALL DHRFFTI(NLON,WFFT)
c     compute double precision gaussian points and weights
c     lw = 4*nlat*(nlat+1)+2
      LW = NLAT* (NLAT+2)
      CALL DGAQD(NLAT,DTHETA,DWTS,WORK,LW,IER)
      IF (IER.NE.0) RETURN
c     store gaussian weights single precision to save computation
c     in inner loops in analysis
      DO 100 I = 1,NLAT
          WTS(I) = DWTS(I)
  100 CONTINUE
c     initialize p0n,p1n using double precision dnlfk,dnlft
      DO 101 NP1 = 1,NLAT
          DO 101 I = 1,LATE
              P0N(NP1,I) = 0.0D0
              P1N(NP1,I) = 0.0D0
  101 CONTINUE
c     compute m=n=0 legendre polynomials for all theta(i)
      NP1 = 1
      N = 0
      M = 0
      CALL DDNLFK(M,N,WORK)
      DO 103 I = 1,LATE
          CALL DDNLFT(M,N,DTHETA(I),WORK,PB)
          P0N(1,I) = PB
  103 CONTINUE
c     compute p0n,p1n for all theta(i) when n.gt.0
      DO 104 NP1 = 2,NLAT
          N = NP1 - 1
          M = 0
          CALL DDNLFK(M,N,WORK)
          DO 105 I = 1,LATE
              CALL DDNLFT(M,N,DTHETA(I),WORK,PB)
              P0N(NP1,I) = PB
  105     CONTINUE
c     compute m=1 legendre polynomials for all n and theta(i)
          M = 1
          CALL DDNLFK(M,N,WORK)
          DO 106 I = 1,LATE
              CALL DDNLFT(M,N,DTHETA(I),WORK,PB)
              P1N(NP1,I) = PB
  106     CONTINUE
  104 CONTINUE
c     compute and store swarztrauber recursion coefficients
c     for 2.le.m.le.n and 2.le.n.le.nlat in abel,bbel,cbel
      DO 107 N = 2,NLAT
          FN = DBLE(N)
          MLIM = MIN0(N,L)
          DO 107 M = 2,MLIM
              FM = DBLE(M)
              IMN = INDX(M,N)
              IF (N.GE.L) IMN = IMNDX(M,N)
              ABEL(IMN) = SQRT(((2*FN+1)* (FM+FN-2)* (FM+FN-3))/
     +                    (((2*FN-3)* (FM+FN-1)* (FM+FN))))
              BBEL(IMN) = SQRT(((2*FN+1)* (FN-FM-1)* (FN-FM))/
     +                    (((2*FN-3)* (FM+FN-1)* (FM+FN))))
              CBEL(IMN) = SQRT(((FN-FM+1)* (FN-FM+2))/
     +                    (((FN+FM-1)* (FN+FM))))
  107 CONTINUE
      RETURN
      END

      SUBROUTINE ZHPRFS( UPLO, N, NRHS, AP, AFP, IPIV, B, LDB, X, LDX,
     $                   FERR, BERR, WORK, RWORK, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER          UPLO
      INTEGER            INFO, LDB, LDX, N, NRHS
*     ..
*     .. Array Arguments ..
      INTEGER            IPIV( * )
      DOUBLE PRECISION   BERR( * ), FERR( * ), RWORK( * )
      COMPLEX*16         AFP( * ), AP( * ), B( LDB, * ), WORK( * ),
     $                   X( LDX, * )
*     ..
*
*  Purpose
*  =======
*
*  ZHPRFS improves the computed solution to a system of linear
*  equations when the coefficient matrix is Hermitian indefinite
*  and packed, and provides error bounds and backward error estimates
*  for the solution.
*
*  Arguments
*  =========
*
*  UPLO    (input) CHARACTER*1
*          = 'U':  Upper triangle of A is stored;
*          = 'L':  Lower triangle of A is stored.
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  NRHS    (input) INTEGER
*          The number of right hand sides, i.e., the number of columns
*          of the matrices B and X.  NRHS >= 0.
*
*  AP      (input) COMPLEX*16 array, dimension (N*(N+1)/2)
*          The upper or lower triangle of the Hermitian matrix A, packed
*          columnwise in a linear array.  The j-th column of A is stored
*          in the array AP as follows:
*          if UPLO = 'U', AP(i + (j-1)*j/2) = A(i,j) for 1<=i<=j;
*          if UPLO = 'L', AP(i + (j-1)*(2*n-j)/2) = A(i,j) for j<=i<=n.
*
*  AFP     (input) COMPLEX*16 array, dimension (N*(N+1)/2)
*          The factored form of the matrix A.  AFP contains the block
*          diagonal matrix D and the multipliers used to obtain the
*          factor U or L from the factorization A = U*D*U**H or
*          A = L*D*L**H as computed by ZHPTRF, stored as a packed
*          triangular matrix.
*
*  IPIV    (input) INTEGER array, dimension (N)
*          Details of the interchanges and the block structure of D
*          as determined by ZHPTRF.
*
*  B       (input) COMPLEX*16 array, dimension (LDB,NRHS)
*          The right hand side matrix B.
*
*  LDB     (input) INTEGER
*          The leading dimension of the array B.  LDB >= max(1,N).
*
*  X       (input/output) COMPLEX*16 array, dimension (LDX,NRHS)
*          On entry, the solution matrix X, as computed by ZHPTRS.
*          On exit, the improved solution matrix X.
*
*  LDX     (input) INTEGER
*          The leading dimension of the array X.  LDX >= max(1,N).
*
*  FERR    (output) DOUBLE PRECISION array, dimension (NRHS)
*          The estimated forward error bound for each solution vector
*          X(j) (the j-th column of the solution matrix X).
*          If XTRUE is the true solution corresponding to X(j), FERR(j)
*          is an estimated upper bound for the magnitude of the largest
*          element in (X(j) - XTRUE) divided by the magnitude of the
*          largest element in X(j).  The estimate is as reliable as
*          the estimate for RCOND, and is almost always a slight
*          overestimate of the true error.
*
*  BERR    (output) DOUBLE PRECISION array, dimension (NRHS)
*          The componentwise relative backward error of each solution
*          vector X(j) (i.e., the smallest relative change in
*          any element of A or B that makes X(j) an exact solution).
*
*  WORK    (workspace) COMPLEX*16 array, dimension (2*N)
*
*  RWORK   (workspace) DOUBLE PRECISION array, dimension (N)
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*
*  Internal Parameters
*  ===================
*
*  ITMAX is the maximum number of steps of iterative refinement.
*
*  =====================================================================
*
*     .. Parameters ..
      INTEGER            ITMAX
      PARAMETER          ( ITMAX = 5 )
      DOUBLE PRECISION   ZERO
      PARAMETER          ( ZERO = 0.0D+0 )
      COMPLEX*16         ONE
      PARAMETER          ( ONE = ( 1.0D+0, 0.0D+0 ) )
      DOUBLE PRECISION   TWO
      PARAMETER          ( TWO = 2.0D+0 )
      DOUBLE PRECISION   THREE
      PARAMETER          ( THREE = 3.0D+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            UPPER
      INTEGER            COUNT, I, IK, J, K, KASE, KK, NZ
      DOUBLE PRECISION   EPS, LSTRES, S, SAFE1, SAFE2, SAFMIN, XK
      COMPLEX*16         ZDUM
*     ..
*     .. External Subroutines ..
      EXTERNAL           XERBLA, ZAXPY, ZCOPY, ZHPMV, ZHPTRS, ZLACON
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, DBLE, DIMAG, MAX
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      DOUBLE PRECISION   DLAMCH
      EXTERNAL           LSAME, DLAMCH
*     ..
*     .. Statement Functions ..
      DOUBLE PRECISION   CABS1
*     ..
*     .. Statement Function definitions ..
      CABS1( ZDUM ) = ABS( DBLE( ZDUM ) ) + ABS( DIMAG( ZDUM ) )
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      UPPER = LSAME( UPLO, 'U' )
      IF( .NOT.UPPER .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( NRHS.LT.0 ) THEN
         INFO = -3
      ELSE IF( LDB.LT.MAX( 1, N ) ) THEN
         INFO = -8
      ELSE IF( LDX.LT.MAX( 1, N ) ) THEN
         INFO = -10
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'ZHPRFS', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 .OR. NRHS.EQ.0 ) THEN
         DO 10 J = 1, NRHS
            FERR( J ) = ZERO
            BERR( J ) = ZERO
   10    CONTINUE
         RETURN
      END IF
*
*     NZ = maximum number of nonzero elements in each row of A, plus 1
*
      NZ = N + 1
      EPS = DLAMCH( 'Epsilon' )
      SAFMIN = DLAMCH( 'Safe minimum' )
      SAFE1 = NZ*SAFMIN
      SAFE2 = SAFE1 / EPS
*
*     Do for each right hand side
*
      DO 140 J = 1, NRHS
*
         COUNT = 1
         LSTRES = THREE
   20    CONTINUE
*
*        Loop until stopping criterion is satisfied.
*
*        Compute residual R = B - A * X
*
         CALL ZCOPY( N, B( 1, J ), 1, WORK, 1 )
         CALL ZHPMV( UPLO, N, -ONE, AP, X( 1, J ), 1, ONE, WORK, 1 )
*
*        Compute componentwise relative backward error from formula
*
*        max(i) ( abs(R(i)) / ( abs(A)*abs(X) + abs(B) )(i) )
*
*        where abs(Z) is the componentwise absolute value of the matrix
*        or vector Z.  If the i-th component of the denominator is less
*        than SAFE2, then SAFE1 is added to the i-th components of the
*        numerator and denominator before dividing.
*
         DO 30 I = 1, N
            RWORK( I ) = CABS1( B( I, J ) )
   30    CONTINUE
*
*        Compute abs(A)*abs(X) + abs(B).
*
         KK = 1
         IF( UPPER ) THEN
            DO 50 K = 1, N
               S = ZERO
               XK = CABS1( X( K, J ) )
               IK = KK
               DO 40 I = 1, K - 1
                  RWORK( I ) = RWORK( I ) + CABS1( AP( IK ) )*XK
                  S = S + CABS1( AP( IK ) )*CABS1( X( I, J ) )
                  IK = IK + 1
   40          CONTINUE
               RWORK( K ) = RWORK( K ) + ABS( DBLE( AP( KK+K-1 ) ) )*
     $                      XK + S
               KK = KK + K
   50       CONTINUE
         ELSE
            DO 70 K = 1, N
               S = ZERO
               XK = CABS1( X( K, J ) )
               RWORK( K ) = RWORK( K ) + ABS( DBLE( AP( KK ) ) )*XK
               IK = KK + 1
               DO 60 I = K + 1, N
                  RWORK( I ) = RWORK( I ) + CABS1( AP( IK ) )*XK
                  S = S + CABS1( AP( IK ) )*CABS1( X( I, J ) )
                  IK = IK + 1
   60          CONTINUE
               RWORK( K ) = RWORK( K ) + S
               KK = KK + ( N-K+1 )
   70       CONTINUE
         END IF
         S = ZERO
         DO 80 I = 1, N
            IF( RWORK( I ).GT.SAFE2 ) THEN
               S = MAX( S, CABS1( WORK( I ) ) / RWORK( I ) )
            ELSE
               S = MAX( S, ( CABS1( WORK( I ) )+SAFE1 ) /
     $             ( RWORK( I )+SAFE1 ) )
            END IF
   80    CONTINUE
         BERR( J ) = S
*
*        Test stopping criterion. Continue iterating if
*           1) The residual BERR(J) is larger than machine epsilon, and
*           2) BERR(J) decreased by at least a factor of 2 during the
*              last iteration, and
*           3) At most ITMAX iterations tried.
*
         IF( BERR( J ).GT.EPS .AND. TWO*BERR( J ).LE.LSTRES .AND.
     $       COUNT.LE.ITMAX ) THEN
*
*           Update solution and try again.
*
            CALL ZHPTRS( UPLO, N, 1, AFP, IPIV, WORK, N, INFO )
            CALL ZAXPY( N, ONE, WORK, 1, X( 1, J ), 1 )
            LSTRES = BERR( J )
            COUNT = COUNT + 1
            GO TO 20
         END IF
*
*        Bound error from formula
*
*        norm(X - XTRUE) / norm(X) .le. FERR =
*        norm( abs(inv(A))*
*           ( abs(R) + NZ*EPS*( abs(A)*abs(X)+abs(B) ))) / norm(X)
*
*        where
*          norm(Z) is the magnitude of the largest component of Z
*          inv(A) is the inverse of A
*          abs(Z) is the componentwise absolute value of the matrix or
*             vector Z
*          NZ is the maximum number of nonzeros in any row of A, plus 1
*          EPS is machine epsilon
*
*        The i-th component of abs(R)+NZ*EPS*(abs(A)*abs(X)+abs(B))
*        is incremented by SAFE1 if the i-th component of
*        abs(A)*abs(X) + abs(B) is less than SAFE2.
*
*        Use ZLACON to estimate the infinity-norm of the matrix
*           inv(A) * diag(W),
*        where W = abs(R) + NZ*EPS*( abs(A)*abs(X)+abs(B) )))
*
         DO 90 I = 1, N
            IF( RWORK( I ).GT.SAFE2 ) THEN
               RWORK( I ) = CABS1( WORK( I ) ) + NZ*EPS*RWORK( I )
            ELSE
               RWORK( I ) = CABS1( WORK( I ) ) + NZ*EPS*RWORK( I ) +
     $                      SAFE1
            END IF
   90    CONTINUE
*
         KASE = 0
  100    CONTINUE
         CALL ZLACON( N, WORK( N+1 ), WORK, FERR( J ), KASE )
         IF( KASE.NE.0 ) THEN
            IF( KASE.EQ.1 ) THEN
*
*              Multiply by diag(W)*inv(A').
*
               CALL ZHPTRS( UPLO, N, 1, AFP, IPIV, WORK, N, INFO )
               DO 110 I = 1, N
                  WORK( I ) = RWORK( I )*WORK( I )
  110          CONTINUE
            ELSE IF( KASE.EQ.2 ) THEN
*
*              Multiply by inv(A)*diag(W).
*
               DO 120 I = 1, N
                  WORK( I ) = RWORK( I )*WORK( I )
  120          CONTINUE
               CALL ZHPTRS( UPLO, N, 1, AFP, IPIV, WORK, N, INFO )
            END IF
            GO TO 100
         END IF
*
*        Normalize error.
*
         LSTRES = ZERO
         DO 130 I = 1, N
            LSTRES = MAX( LSTRES, CABS1( X( I, J ) ) )
  130    CONTINUE
         IF( LSTRES.NE.ZERO )
     $      FERR( J ) = FERR( J ) / LSTRES
*
  140 CONTINUE
*
      RETURN
*
*     End of ZHPRFS
*
      END

      SUBROUTINE SLACPY( UPLO, M, N, A, LDA, B, LDB )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     February 29, 1992
*
*     .. Scalar Arguments ..
      CHARACTER          UPLO
      INTEGER            LDA, LDB, M, N
*     ..
*     .. Array Arguments ..
      REAL               A( LDA, * ), B( LDB, * )
*     ..
*
*  Purpose
*  =======
*
*  SLACPY copies all or part of a two-dimensional matrix A to another
*  matrix B.
*
*  Arguments
*  =========
*
*  UPLO    (input) CHARACTER*1
*          Specifies the part of the matrix A to be copied to B.
*          = 'U':      Upper triangular part
*          = 'L':      Lower triangular part
*          Otherwise:  All of the matrix A
*
*  M       (input) INTEGER
*          The number of rows of the matrix A.  M >= 0.
*
*  N       (input) INTEGER
*          The number of columns of the matrix A.  N >= 0.
*
*  A       (input) REAL array, dimension (LDA,N)
*          The m by n matrix A.  If UPLO = 'U', only the upper triangle
*          or trapezoid is accessed; if UPLO = 'L', only the lower
*          triangle or trapezoid is accessed.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(1,M).
*
*  B       (output) REAL array, dimension (LDB,N)
*          On exit, B = A in the locations specified by UPLO.
*
*  LDB     (input) INTEGER
*          The leading dimension of the array B.  LDB >= max(1,M).
*
*  =====================================================================
*
*     .. Local Scalars ..
      INTEGER            I, J
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MIN
*     ..
*     .. Executable Statements ..
*
      IF( LSAME( UPLO, 'U' ) ) THEN
         DO 20 J = 1, N
            DO 10 I = 1, MIN( J, M )
               B( I, J ) = A( I, J )
   10       CONTINUE
   20    CONTINUE
      ELSE IF( LSAME( UPLO, 'L' ) ) THEN
         DO 40 J = 1, N
            DO 30 I = J, M
               B( I, J ) = A( I, J )
   30       CONTINUE
   40    CONTINUE
      ELSE
         DO 60 J = 1, N
            DO 50 I = 1, M
               B( I, J ) = A( I, J )
   50       CONTINUE
   60    CONTINUE
      END IF
      RETURN
*
*     End of SLACPY
*
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C   FFTPACK 5.0
C   Copyright (C) 1995-2004, Scientific Computing Division,
C   University Corporation for Atmospheric Research
C   Licensed under the GNU General Public License (GPL)
C
C   Authors:  Paul N. Swarztrauber and Richard A. Valent
C
C   $Id: cost1b.f,v 1.2 2006-11-21 01:10:17 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      SUBROUTINE DCOST1B(N,INC,X,LENX,WSAVE,LENSAV,WORK,LENWRK,IER)
      INTEGER N,INC,LENX,LENSAV,LENWRK,IER
      DOUBLE PRECISION X(INC,*),WSAVE(LENSAV),WORK(LENWRK)
C
      IER = 0
      IF (LENX.LT.INC* (N-1)+1) THEN
          IER = 1
          CALL DXERFFT('COST1B',6)
          GO TO 100
      ELSE IF (LENSAV.LT.2*N+INT(LOG(DBLE(N)))+4) THEN
          IER = 2
          CALL DXERFFT('COST1B',8)
          GO TO 100
      ELSE IF (LENWRK.LT.N-1) THEN
          IER = 3
          CALL DXERFFT('COST1B',10)
          GO TO 100
      END IF
C
      CALL DCOSTB1(N,INC,X,WSAVE,WORK,IER1)
      IF (IER1.NE.0) THEN
          IER = 20
          CALL DXERFFT('COST1B',-5)
      END IF
C
  100 CONTINUE
      RETURN
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C   FFTPACK 5.0
C   Copyright (C) 1995-2004, Scientific Computing Division,
C   University Corporation for Atmospheric Research
C   Licensed under the GNU General Public License (GPL)
C
C   Authors:  Paul N. Swarztrauber and Richard A. Valent
C
C   $Id: mradfg.f,v 1.2 2006-11-21 01:10:18 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      SUBROUTINE DMRADFG(M,IDO,IP,L1,IDL1,CC,C1,C2,IM1,IN1,CH,CH2,IM2,
     +                   IN2,WA)
      DOUBLE PRECISION TPI
      DOUBLE PRECISION ARG
      DOUBLE PRECISION DCP
      DOUBLE PRECISION DSP
      DOUBLE PRECISION AR1
      DOUBLE PRECISION AI1
      DOUBLE PRECISION AR1H
      DOUBLE PRECISION DC2
      DOUBLE PRECISION DS2
      DOUBLE PRECISION AR2
      DOUBLE PRECISION AI2
      DOUBLE PRECISION AR2H
      DOUBLE PRECISION CH(IN2,IDO,L1,IP),CC(IN1,IDO,IP,L1),
     +                 C1(IN1,IDO,L1,IP),C2(IN1,IDL1,IP),
     +                 CH2(IN2,IDL1,IP),WA(IDO)
C
      M1D = (M-1)*IM1 + 1
      M2S = 1 - IM2
      TPI = 2.D0*4.D0*ATAN(1.0D0)
      ARG = TPI/DBLE(IP)
      DCP = COS(ARG)
      DSP = SIN(ARG)
      IPPH = (IP+1)/2
      IPP2 = IP + 2
      IDP2 = IDO + 2
      NBD = (IDO-1)/2
      IF (IDO.EQ.1) GO TO 119
      DO 101 IK = 1,IDL1
          M2 = M2S
          DO 1001 M1 = 1,M1D,IM1
              M2 = M2 + IM2
              CH2(M2,IK,1) = C2(M1,IK,1)
 1001     CONTINUE
  101 CONTINUE
      DO 103 J = 2,IP
          DO 102 K = 1,L1
              M2 = M2S
              DO 1002 M1 = 1,M1D,IM1
                  M2 = M2 + IM2
                  CH(M2,1,K,J) = C1(M1,1,K,J)
 1002         CONTINUE
  102     CONTINUE
  103 CONTINUE
      IF (NBD.GT.L1) GO TO 107
      IS = -IDO
      DO 106 J = 2,IP
          IS = IS + IDO
          IDIJ = IS
          DO 105 I = 3,IDO,2
              IDIJ = IDIJ + 2
              DO 104 K = 1,L1
                  M2 = M2S
                  DO 1004 M1 = 1,M1D,IM1
                      M2 = M2 + IM2
                      CH(M2,I-1,K,J) = WA(IDIJ-1)*C1(M1,I-1,K,J) +
     +                                 WA(IDIJ)*C1(M1,I,K,J)
                      CH(M2,I,K,J) = WA(IDIJ-1)*C1(M1,I,K,J) -
     +                               WA(IDIJ)*C1(M1,I-1,K,J)
 1004             CONTINUE
  104         CONTINUE
  105     CONTINUE
  106 CONTINUE
      GO TO 111
  107 IS = -IDO
      DO 110 J = 2,IP
          IS = IS + IDO
          DO 109 K = 1,L1
              IDIJ = IS
              DO 108 I = 3,IDO,2
                  IDIJ = IDIJ + 2
                  M2 = M2S
                  DO 1008 M1 = 1,M1D,IM1
                      M2 = M2 + IM2
                      CH(M2,I-1,K,J) = WA(IDIJ-1)*C1(M1,I-1,K,J) +
     +                                 WA(IDIJ)*C1(M1,I,K,J)
                      CH(M2,I,K,J) = WA(IDIJ-1)*C1(M1,I,K,J) -
     +                               WA(IDIJ)*C1(M1,I-1,K,J)
 1008             CONTINUE
  108         CONTINUE
  109     CONTINUE
  110 CONTINUE
  111 IF (NBD.LT.L1) GO TO 115
      DO 114 J = 2,IPPH
          JC = IPP2 - J
          DO 113 K = 1,L1
              DO 112 I = 3,IDO,2
                  M2 = M2S
                  DO 1012 M1 = 1,M1D,IM1
                      M2 = M2 + IM2
                      C1(M1,I-1,K,J) = CH(M2,I-1,K,J) + CH(M2,I-1,K,JC)
                      C1(M1,I-1,K,JC) = CH(M2,I,K,J) - CH(M2,I,K,JC)
                      C1(M1,I,K,J) = CH(M2,I,K,J) + CH(M2,I,K,JC)
                      C1(M1,I,K,JC) = CH(M2,I-1,K,JC) - CH(M2,I-1,K,J)
 1012             CONTINUE
  112         CONTINUE
  113     CONTINUE
  114 CONTINUE
      GO TO 121
  115 DO 118 J = 2,IPPH
          JC = IPP2 - J
          DO 117 I = 3,IDO,2
              DO 116 K = 1,L1
                  M2 = M2S
                  DO 1016 M1 = 1,M1D,IM1
                      M2 = M2 + IM2
                      C1(M1,I-1,K,J) = CH(M2,I-1,K,J) + CH(M2,I-1,K,JC)
                      C1(M1,I-1,K,JC) = CH(M2,I,K,J) - CH(M2,I,K,JC)
                      C1(M1,I,K,J) = CH(M2,I,K,J) + CH(M2,I,K,JC)
                      C1(M1,I,K,JC) = CH(M2,I-1,K,JC) - CH(M2,I-1,K,J)
 1016             CONTINUE
  116         CONTINUE
  117     CONTINUE
  118 CONTINUE
      GO TO 121
  119 DO 120 IK = 1,IDL1
          M2 = M2S
          DO 1020 M1 = 1,M1D,IM1
              M2 = M2 + IM2
              C2(M1,IK,1) = CH2(M2,IK,1)
 1020     CONTINUE
  120 CONTINUE
  121 DO 123 J = 2,IPPH
          JC = IPP2 - J
          DO 122 K = 1,L1
              M2 = M2S
              DO 1022 M1 = 1,M1D,IM1
                  M2 = M2 + IM2
                  C1(M1,1,K,J) = CH(M2,1,K,J) + CH(M2,1,K,JC)
                  C1(M1,1,K,JC) = CH(M2,1,K,JC) - CH(M2,1,K,J)
 1022         CONTINUE
  122     CONTINUE
  123 CONTINUE
C
      AR1 = 1.D0
      AI1 = 0.D0
      DO 127 L = 2,IPPH
          LC = IPP2 - L
          AR1H = DCP*AR1 - DSP*AI1
          AI1 = DCP*AI1 + DSP*AR1
          AR1 = AR1H
          DO 124 IK = 1,IDL1
              M2 = M2S
              DO 1024 M1 = 1,M1D,IM1
                  M2 = M2 + IM2
                  CH2(M2,IK,L) = C2(M1,IK,1) + AR1*C2(M1,IK,2)
                  CH2(M2,IK,LC) = AI1*C2(M1,IK,IP)
 1024         CONTINUE
  124     CONTINUE
          DC2 = AR1
          DS2 = AI1
          AR2 = AR1
          AI2 = AI1
          DO 126 J = 3,IPPH
              JC = IPP2 - J
              AR2H = DC2*AR2 - DS2*AI2
              AI2 = DC2*AI2 + DS2*AR2
              AR2 = AR2H
              DO 125 IK = 1,IDL1
                  M2 = M2S
                  DO 1025 M1 = 1,M1D,IM1
                      M2 = M2 + IM2
                      CH2(M2,IK,L) = CH2(M2,IK,L) + AR2*C2(M1,IK,J)
                      CH2(M2,IK,LC) = CH2(M2,IK,LC) + AI2*C2(M1,IK,JC)
 1025             CONTINUE
  125         CONTINUE
  126     CONTINUE
  127 CONTINUE
      DO 129 J = 2,IPPH
          DO 128 IK = 1,IDL1
              M2 = M2S
              DO 1028 M1 = 1,M1D,IM1
                  M2 = M2 + IM2
                  CH2(M2,IK,1) = CH2(M2,IK,1) + C2(M1,IK,J)
 1028         CONTINUE
  128     CONTINUE
  129 CONTINUE
C
      IF (IDO.LT.L1) GO TO 132
      DO 131 K = 1,L1
          DO 130 I = 1,IDO
              M2 = M2S
              DO 1030 M1 = 1,M1D,IM1
                  M2 = M2 + IM2
                  CC(M1,I,1,K) = CH(M2,I,K,1)
 1030         CONTINUE
  130     CONTINUE
  131 CONTINUE
      GO TO 135
  132 DO 134 I = 1,IDO
          DO 133 K = 1,L1
              M2 = M2S
              DO 1033 M1 = 1,M1D,IM1
                  M2 = M2 + IM2
                  CC(M1,I,1,K) = CH(M2,I,K,1)
 1033         CONTINUE
  133     CONTINUE
  134 CONTINUE
  135 DO 137 J = 2,IPPH
          JC = IPP2 - J
          J2 = J + J
          DO 136 K = 1,L1
              M2 = M2S
              DO 1036 M1 = 1,M1D,IM1
                  M2 = M2 + IM2
                  CC(M1,IDO,J2-2,K) = CH(M2,1,K,J)
                  CC(M1,1,J2-1,K) = CH(M2,1,K,JC)
 1036         CONTINUE
  136     CONTINUE
  137 CONTINUE
      IF (IDO.EQ.1) RETURN
      IF (NBD.LT.L1) GO TO 141
      DO 140 J = 2,IPPH
          JC = IPP2 - J
          J2 = J + J
          DO 139 K = 1,L1
              DO 138 I = 3,IDO,2
                  IC = IDP2 - I
                  M2 = M2S
                  DO 1038 M1 = 1,M1D,IM1
                      M2 = M2 + IM2
                      CC(M1,I-1,J2-1,K) = CH(M2,I-1,K,J) +
     +                                    CH(M2,I-1,K,JC)
                      CC(M1,IC-1,J2-2,K) = CH(M2,I-1,K,J) -
     +                                     CH(M2,I-1,K,JC)
                      CC(M1,I,J2-1,K) = CH(M2,I,K,J) + CH(M2,I,K,JC)
                      CC(M1,IC,J2-2,K) = CH(M2,I,K,JC) - CH(M2,I,K,J)
 1038             CONTINUE
  138         CONTINUE
  139     CONTINUE
  140 CONTINUE
      RETURN
  141 DO 144 J = 2,IPPH
          JC = IPP2 - J
          J2 = J + J
          DO 143 I = 3,IDO,2
              IC = IDP2 - I
              DO 142 K = 1,L1
                  M2 = M2S
                  DO 1042 M1 = 1,M1D,IM1
                      M2 = M2 + IM2
                      CC(M1,I-1,J2-1,K) = CH(M2,I-1,K,J) +
     +                                    CH(M2,I-1,K,JC)
                      CC(M1,IC-1,J2-2,K) = CH(M2,I-1,K,J) -
     +                                     CH(M2,I-1,K,JC)
                      CC(M1,I,J2-1,K) = CH(M2,I,K,J) + CH(M2,I,K,JC)
                      CC(M1,IC,J2-2,K) = CH(M2,I,K,JC) - CH(M2,I,K,J)
 1042             CONTINUE
  142         CONTINUE
  143     CONTINUE
  144 CONTINUE
      RETURN
      END

      SUBROUTINE SLAED4( N, I, D, Z, DELTA, RHO, DLAM, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Oak Ridge National Lab, Argonne National Lab,
*     Courant Institute, NAG Ltd., and Rice University
*     December 23, 1999
*
*     .. Scalar Arguments ..
      INTEGER            I, INFO, N
      REAL               DLAM, RHO
*     ..
*     .. Array Arguments ..
      REAL               D( * ), DELTA( * ), Z( * )
*     ..
*
*  Purpose
*  =======
*
*  This subroutine computes the I-th updated eigenvalue of a symmetric
*  rank-one modification to a diagonal matrix whose elements are
*  given in the array d, and that
*
*             D(i) < D(j)  for  i < j
*
*  and that RHO > 0.  This is arranged by the calling routine, and is
*  no loss in generality.  The rank-one modified system is thus
*
*             diag( D )  +  RHO *  Z * Z_transpose.
*
*  where we assume the Euclidean norm of Z is 1.
*
*  The method consists of approximating the rational functions in the
*  secular equation by simpler interpolating rational functions.
*
*  Arguments
*  =========
*
*  N      (input) INTEGER
*         The length of all arrays.
*
*  I      (input) INTEGER
*         The index of the eigenvalue to be computed.  1 <= I <= N.
*
*  D      (input) REAL array, dimension (N)
*         The original eigenvalues.  It is assumed that they are in
*         order, D(I) < D(J)  for I < J.
*
*  Z      (input) REAL array, dimension (N)
*         The components of the updating vector.
*
*  DELTA  (output) REAL array, dimension (N)
*         If N .ne. 1, DELTA contains (D(j) - lambda_I) in its  j-th
*         component.  If N = 1, then DELTA(1) = 1.  The vector DELTA
*         contains the information necessary to construct the
*         eigenvectors.
*
*  RHO    (input) REAL
*         The scalar in the symmetric updating formula.
*
*  DLAM   (output) REAL
*         The computed lambda_I, the I-th updated eigenvalue.
*
*  INFO   (output) INTEGER
*         = 0:  successful exit
*         > 0:  if INFO = 1, the updating process failed.
*
*  Internal Parameters
*  ===================
*
*  Logical variable ORGATI (origin-at-i?) is used for distinguishing
*  whether D(i) or D(i+1) is treated as the origin.
*
*            ORGATI = .true.    origin at i
*            ORGATI = .false.   origin at i+1
*
*   Logical variable SWTCH3 (switch-for-3-poles?) is for noting
*   if we are working with THREE poles!
*
*   MAXIT is the maximum number of iterations allowed for each
*   eigenvalue.
*
*  Further Details
*  ===============
*
*  Based on contributions by
*     Ren-Cang Li, Computer Science Division, University of California
*     at Berkeley, USA
*
*  =====================================================================
*
*     .. Parameters ..
      INTEGER            MAXIT
      PARAMETER          ( MAXIT = 30 )
      REAL               ZERO, ONE, TWO, THREE, FOUR, EIGHT, TEN
      PARAMETER          ( ZERO = 0.0E0, ONE = 1.0E0, TWO = 2.0E0,
     $                   THREE = 3.0E0, FOUR = 4.0E0, EIGHT = 8.0E0,
     $                   TEN = 10.0E0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            ORGATI, SWTCH, SWTCH3
      INTEGER            II, IIM1, IIP1, IP1, ITER, J, NITER
      REAL               A, B, C, DEL, DLTLB, DLTUB, DPHI, DPSI, DW,
     $                   EPS, ERRETM, ETA, MIDPT, PHI, PREW, PSI,
     $                   RHOINV, TAU, TEMP, TEMP1, W
*     ..
*     .. Local Arrays ..
      REAL               ZZ( 3 )
*     ..
*     .. External Functions ..
      REAL               SLAMCH
      EXTERNAL           SLAMCH
*     ..
*     .. External Subroutines ..
      EXTERNAL           SLAED5, SLAED6
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, MAX, MIN, SQRT
*     ..
*     .. Executable Statements ..
*
*     Since this routine is called in an inner loop, we do no argument
*     checking.
*
*     Quick return for N=1 and 2.
*
      INFO = 0
      IF( N.EQ.1 ) THEN
*
*         Presumably, I=1 upon entry
*
         DLAM = D( 1 ) + RHO*Z( 1 )*Z( 1 )
         DELTA( 1 ) = ONE
         RETURN
      END IF
      IF( N.EQ.2 ) THEN
         CALL SLAED5( I, D, Z, DELTA, RHO, DLAM )
         RETURN
      END IF
*
*     Compute machine epsilon
*
      EPS = SLAMCH( 'Epsilon' )
      RHOINV = ONE / RHO
*
*     The case I = N
*
      IF( I.EQ.N ) THEN
*
*        Initialize some basic variables
*
         II = N - 1
         NITER = 1
*
*        Calculate initial guess
*
         MIDPT = RHO / TWO
*
*        If ||Z||_2 is not one, then TEMP should be set to
*        RHO * ||Z||_2^2 / TWO
*
         DO 10 J = 1, N
            DELTA( J ) = ( D( J )-D( I ) ) - MIDPT
   10    CONTINUE
*
         PSI = ZERO
         DO 20 J = 1, N - 2
            PSI = PSI + Z( J )*Z( J ) / DELTA( J )
   20    CONTINUE
*
         C = RHOINV + PSI
         W = C + Z( II )*Z( II ) / DELTA( II ) +
     $       Z( N )*Z( N ) / DELTA( N )
*
         IF( W.LE.ZERO ) THEN
            TEMP = Z( N-1 )*Z( N-1 ) / ( D( N )-D( N-1 )+RHO ) +
     $             Z( N )*Z( N ) / RHO
            IF( C.LE.TEMP ) THEN
               TAU = RHO
            ELSE
               DEL = D( N ) - D( N-1 )
               A = -C*DEL + Z( N-1 )*Z( N-1 ) + Z( N )*Z( N )
               B = Z( N )*Z( N )*DEL
               IF( A.LT.ZERO ) THEN
                  TAU = TWO*B / ( SQRT( A*A+FOUR*B*C )-A )
               ELSE
                  TAU = ( A+SQRT( A*A+FOUR*B*C ) ) / ( TWO*C )
               END IF
            END IF
*
*           It can be proved that
*               D(N)+RHO/2 <= LAMBDA(N) < D(N)+TAU <= D(N)+RHO
*
            DLTLB = MIDPT
            DLTUB = RHO
         ELSE
            DEL = D( N ) - D( N-1 )
            A = -C*DEL + Z( N-1 )*Z( N-1 ) + Z( N )*Z( N )
            B = Z( N )*Z( N )*DEL
            IF( A.LT.ZERO ) THEN
               TAU = TWO*B / ( SQRT( A*A+FOUR*B*C )-A )
            ELSE
               TAU = ( A+SQRT( A*A+FOUR*B*C ) ) / ( TWO*C )
            END IF
*
*           It can be proved that
*               D(N) < D(N)+TAU < LAMBDA(N) < D(N)+RHO/2
*
            DLTLB = ZERO
            DLTUB = MIDPT
         END IF
*
         DO 30 J = 1, N
            DELTA( J ) = ( D( J )-D( I ) ) - TAU
   30    CONTINUE
*
*        Evaluate PSI and the derivative DPSI
*
         DPSI = ZERO
         PSI = ZERO
         ERRETM = ZERO
         DO 40 J = 1, II
            TEMP = Z( J ) / DELTA( J )
            PSI = PSI + Z( J )*TEMP
            DPSI = DPSI + TEMP*TEMP
            ERRETM = ERRETM + PSI
   40    CONTINUE
         ERRETM = ABS( ERRETM )
*
*        Evaluate PHI and the derivative DPHI
*
         TEMP = Z( N ) / DELTA( N )
         PHI = Z( N )*TEMP
         DPHI = TEMP*TEMP
         ERRETM = EIGHT*( -PHI-PSI ) + ERRETM - PHI + RHOINV +
     $            ABS( TAU )*( DPSI+DPHI )
*
         W = RHOINV + PHI + PSI
*
*        Test for convergence
*
         IF( ABS( W ).LE.EPS*ERRETM ) THEN
            DLAM = D( I ) + TAU
            GO TO 250
         END IF
*
         IF( W.LE.ZERO ) THEN
            DLTLB = MAX( DLTLB, TAU )
         ELSE
            DLTUB = MIN( DLTUB, TAU )
         END IF
*
*        Calculate the new step
*
         NITER = NITER + 1
         C = W - DELTA( N-1 )*DPSI - DELTA( N )*DPHI
         A = ( DELTA( N-1 )+DELTA( N ) )*W -
     $       DELTA( N-1 )*DELTA( N )*( DPSI+DPHI )
         B = DELTA( N-1 )*DELTA( N )*W
         IF( C.LT.ZERO )
     $      C = ABS( C )
         IF( C.EQ.ZERO ) THEN
*          ETA = B/A
*           ETA = RHO - TAU
            ETA = DLTUB - TAU
         ELSE IF( A.GE.ZERO ) THEN
            ETA = ( A+SQRT( ABS( A*A-FOUR*B*C ) ) ) / ( TWO*C )
         ELSE
            ETA = TWO*B / ( A-SQRT( ABS( A*A-FOUR*B*C ) ) )
         END IF
*
*        Note, eta should be positive if w is negative, and
*        eta should be negative otherwise. However,
*        if for some reason caused by roundoff, eta*w > 0,
*        we simply use one Newton step instead. This way
*        will guarantee eta*w < 0.
*
         IF( W*ETA.GT.ZERO )
     $      ETA = -W / ( DPSI+DPHI )
         TEMP = TAU + ETA
         IF( TEMP.GT.DLTUB .OR. TEMP.LT.DLTLB ) THEN
            IF( W.LT.ZERO ) THEN
               ETA = ( DLTUB-TAU ) / TWO
            ELSE
               ETA = ( DLTLB-TAU ) / TWO
            END IF
         END IF
         DO 50 J = 1, N
            DELTA( J ) = DELTA( J ) - ETA
   50    CONTINUE
*
         TAU = TAU + ETA
*
*        Evaluate PSI and the derivative DPSI
*
         DPSI = ZERO
         PSI = ZERO
         ERRETM = ZERO
         DO 60 J = 1, II
            TEMP = Z( J ) / DELTA( J )
            PSI = PSI + Z( J )*TEMP
            DPSI = DPSI + TEMP*TEMP
            ERRETM = ERRETM + PSI
   60    CONTINUE
         ERRETM = ABS( ERRETM )
*
*        Evaluate PHI and the derivative DPHI
*
         TEMP = Z( N ) / DELTA( N )
         PHI = Z( N )*TEMP
         DPHI = TEMP*TEMP
         ERRETM = EIGHT*( -PHI-PSI ) + ERRETM - PHI + RHOINV +
     $            ABS( TAU )*( DPSI+DPHI )
*
         W = RHOINV + PHI + PSI
*
*        Main loop to update the values of the array   DELTA
*
         ITER = NITER + 1
*
         DO 90 NITER = ITER, MAXIT
*
*           Test for convergence
*
            IF( ABS( W ).LE.EPS*ERRETM ) THEN
               DLAM = D( I ) + TAU
               GO TO 250
            END IF
*
            IF( W.LE.ZERO ) THEN
               DLTLB = MAX( DLTLB, TAU )
            ELSE
               DLTUB = MIN( DLTUB, TAU )
            END IF
*
*           Calculate the new step
*
            C = W - DELTA( N-1 )*DPSI - DELTA( N )*DPHI
            A = ( DELTA( N-1 )+DELTA( N ) )*W -
     $          DELTA( N-1 )*DELTA( N )*( DPSI+DPHI )
            B = DELTA( N-1 )*DELTA( N )*W
            IF( A.GE.ZERO ) THEN
               ETA = ( A+SQRT( ABS( A*A-FOUR*B*C ) ) ) / ( TWO*C )
            ELSE
               ETA = TWO*B / ( A-SQRT( ABS( A*A-FOUR*B*C ) ) )
            END IF
*
*           Note, eta should be positive if w is negative, and
*           eta should be negative otherwise. However,
*           if for some reason caused by roundoff, eta*w > 0,
*           we simply use one Newton step instead. This way
*           will guarantee eta*w < 0.
*
            IF( W*ETA.GT.ZERO )
     $         ETA = -W / ( DPSI+DPHI )
            TEMP = TAU + ETA
            IF( TEMP.GT.DLTUB .OR. TEMP.LT.DLTLB ) THEN
               IF( W.LT.ZERO ) THEN
                  ETA = ( DLTUB-TAU ) / TWO
               ELSE
                  ETA = ( DLTLB-TAU ) / TWO
               END IF
            END IF
            DO 70 J = 1, N
               DELTA( J ) = DELTA( J ) - ETA
   70       CONTINUE
*
            TAU = TAU + ETA
*
*           Evaluate PSI and the derivative DPSI
*
            DPSI = ZERO
            PSI = ZERO
            ERRETM = ZERO
            DO 80 J = 1, II
               TEMP = Z( J ) / DELTA( J )
               PSI = PSI + Z( J )*TEMP
               DPSI = DPSI + TEMP*TEMP
               ERRETM = ERRETM + PSI
   80       CONTINUE
            ERRETM = ABS( ERRETM )
*
*           Evaluate PHI and the derivative DPHI
*
            TEMP = Z( N ) / DELTA( N )
            PHI = Z( N )*TEMP
            DPHI = TEMP*TEMP
            ERRETM = EIGHT*( -PHI-PSI ) + ERRETM - PHI + RHOINV +
     $               ABS( TAU )*( DPSI+DPHI )
*
            W = RHOINV + PHI + PSI
   90    CONTINUE
*
*        Return with INFO = 1, NITER = MAXIT and not converged
*
         INFO = 1
         DLAM = D( I ) + TAU
         GO TO 250
*
*        End for the case I = N
*
      ELSE
*
*        The case for I < N
*
         NITER = 1
         IP1 = I + 1
*
*        Calculate initial guess
*
         DEL = D( IP1 ) - D( I )
         MIDPT = DEL / TWO
         DO 100 J = 1, N
            DELTA( J ) = ( D( J )-D( I ) ) - MIDPT
  100    CONTINUE
*
         PSI = ZERO
         DO 110 J = 1, I - 1
            PSI = PSI + Z( J )*Z( J ) / DELTA( J )
  110    CONTINUE
*
         PHI = ZERO
         DO 120 J = N, I + 2, -1
            PHI = PHI + Z( J )*Z( J ) / DELTA( J )
  120    CONTINUE
         C = RHOINV + PSI + PHI
         W = C + Z( I )*Z( I ) / DELTA( I ) +
     $       Z( IP1 )*Z( IP1 ) / DELTA( IP1 )
*
         IF( W.GT.ZERO ) THEN
*
*           d(i)< the ith eigenvalue < (d(i)+d(i+1))/2
*
*           We choose d(i) as origin.
*
            ORGATI = .TRUE.
            A = C*DEL + Z( I )*Z( I ) + Z( IP1 )*Z( IP1 )
            B = Z( I )*Z( I )*DEL
            IF( A.GT.ZERO ) THEN
               TAU = TWO*B / ( A+SQRT( ABS( A*A-FOUR*B*C ) ) )
            ELSE
               TAU = ( A-SQRT( ABS( A*A-FOUR*B*C ) ) ) / ( TWO*C )
            END IF
            DLTLB = ZERO
            DLTUB = MIDPT
         ELSE
*
*           (d(i)+d(i+1))/2 <= the ith eigenvalue < d(i+1)
*
*           We choose d(i+1) as origin.
*
            ORGATI = .FALSE.
            A = C*DEL - Z( I )*Z( I ) - Z( IP1 )*Z( IP1 )
            B = Z( IP1 )*Z( IP1 )*DEL
            IF( A.LT.ZERO ) THEN
               TAU = TWO*B / ( A-SQRT( ABS( A*A+FOUR*B*C ) ) )
            ELSE
               TAU = -( A+SQRT( ABS( A*A+FOUR*B*C ) ) ) / ( TWO*C )
            END IF
            DLTLB = -MIDPT
            DLTUB = ZERO
         END IF
*
         IF( ORGATI ) THEN
            DO 130 J = 1, N
               DELTA( J ) = ( D( J )-D( I ) ) - TAU
  130       CONTINUE
         ELSE
            DO 140 J = 1, N
               DELTA( J ) = ( D( J )-D( IP1 ) ) - TAU
  140       CONTINUE
         END IF
         IF( ORGATI ) THEN
            II = I
         ELSE
            II = I + 1
         END IF
         IIM1 = II - 1
         IIP1 = II + 1
*
*        Evaluate PSI and the derivative DPSI
*
         DPSI = ZERO
         PSI = ZERO
         ERRETM = ZERO
         DO 150 J = 1, IIM1
            TEMP = Z( J ) / DELTA( J )
            PSI = PSI + Z( J )*TEMP
            DPSI = DPSI + TEMP*TEMP
            ERRETM = ERRETM + PSI
  150    CONTINUE
         ERRETM = ABS( ERRETM )
*
*        Evaluate PHI and the derivative DPHI
*
         DPHI = ZERO
         PHI = ZERO
         DO 160 J = N, IIP1, -1
            TEMP = Z( J ) / DELTA( J )
            PHI = PHI + Z( J )*TEMP
            DPHI = DPHI + TEMP*TEMP
            ERRETM = ERRETM + PHI
  160    CONTINUE
*
         W = RHOINV + PHI + PSI
*
*        W is the value of the secular function with
*        its ii-th element removed.
*
         SWTCH3 = .FALSE.
         IF( ORGATI ) THEN
            IF( W.LT.ZERO )
     $         SWTCH3 = .TRUE.
         ELSE
            IF( W.GT.ZERO )
     $         SWTCH3 = .TRUE.
         END IF
         IF( II.EQ.1 .OR. II.EQ.N )
     $      SWTCH3 = .FALSE.
*
         TEMP = Z( II ) / DELTA( II )
         DW = DPSI + DPHI + TEMP*TEMP
         TEMP = Z( II )*TEMP
         W = W + TEMP
         ERRETM = EIGHT*( PHI-PSI ) + ERRETM + TWO*RHOINV +
     $            THREE*ABS( TEMP ) + ABS( TAU )*DW
*
*        Test for convergence
*
         IF( ABS( W ).LE.EPS*ERRETM ) THEN
            IF( ORGATI ) THEN
               DLAM = D( I ) + TAU
            ELSE
               DLAM = D( IP1 ) + TAU
            END IF
            GO TO 250
         END IF
*
         IF( W.LE.ZERO ) THEN
            DLTLB = MAX( DLTLB, TAU )
         ELSE
            DLTUB = MIN( DLTUB, TAU )
         END IF
*
*        Calculate the new step
*
         NITER = NITER + 1
         IF( .NOT.SWTCH3 ) THEN
            IF( ORGATI ) THEN
               C = W - DELTA( IP1 )*DW - ( D( I )-D( IP1 ) )*
     $             ( Z( I ) / DELTA( I ) )**2
            ELSE
               C = W - DELTA( I )*DW - ( D( IP1 )-D( I ) )*
     $             ( Z( IP1 ) / DELTA( IP1 ) )**2
            END IF
            A = ( DELTA( I )+DELTA( IP1 ) )*W -
     $          DELTA( I )*DELTA( IP1 )*DW
            B = DELTA( I )*DELTA( IP1 )*W
            IF( C.EQ.ZERO ) THEN
               IF( A.EQ.ZERO ) THEN
                  IF( ORGATI ) THEN
                     A = Z( I )*Z( I ) + DELTA( IP1 )*DELTA( IP1 )*
     $                   ( DPSI+DPHI )
                  ELSE
                     A = Z( IP1 )*Z( IP1 ) + DELTA( I )*DELTA( I )*
     $                   ( DPSI+DPHI )
                  END IF
               END IF
               ETA = B / A
            ELSE IF( A.LE.ZERO ) THEN
               ETA = ( A-SQRT( ABS( A*A-FOUR*B*C ) ) ) / ( TWO*C )
            ELSE
               ETA = TWO*B / ( A+SQRT( ABS( A*A-FOUR*B*C ) ) )
            END IF
         ELSE
*
*           Interpolation using THREE most relevant poles
*
            TEMP = RHOINV + PSI + PHI
            IF( ORGATI ) THEN
               TEMP1 = Z( IIM1 ) / DELTA( IIM1 )
               TEMP1 = TEMP1*TEMP1
               C = TEMP - DELTA( IIP1 )*( DPSI+DPHI ) -
     $             ( D( IIM1 )-D( IIP1 ) )*TEMP1
               ZZ( 1 ) = Z( IIM1 )*Z( IIM1 )
               ZZ( 3 ) = DELTA( IIP1 )*DELTA( IIP1 )*
     $                   ( ( DPSI-TEMP1 )+DPHI )
            ELSE
               TEMP1 = Z( IIP1 ) / DELTA( IIP1 )
               TEMP1 = TEMP1*TEMP1
               C = TEMP - DELTA( IIM1 )*( DPSI+DPHI ) -
     $             ( D( IIP1 )-D( IIM1 ) )*TEMP1
               ZZ( 1 ) = DELTA( IIM1 )*DELTA( IIM1 )*
     $                   ( DPSI+( DPHI-TEMP1 ) )
               ZZ( 3 ) = Z( IIP1 )*Z( IIP1 )
            END IF
            ZZ( 2 ) = Z( II )*Z( II )
            CALL SLAED6( NITER, ORGATI, C, DELTA( IIM1 ), ZZ, W, ETA,
     $                   INFO )
            IF( INFO.NE.0 )
     $         GO TO 250
         END IF
*
*        Note, eta should be positive if w is negative, and
*        eta should be negative otherwise. However,
*        if for some reason caused by roundoff, eta*w > 0,
*        we simply use one Newton step instead. This way
*        will guarantee eta*w < 0.
*
         IF( W*ETA.GE.ZERO )
     $      ETA = -W / DW
         TEMP = TAU + ETA
         IF( TEMP.GT.DLTUB .OR. TEMP.LT.DLTLB ) THEN
            IF( W.LT.ZERO ) THEN
               ETA = ( DLTUB-TAU ) / TWO
            ELSE
               ETA = ( DLTLB-TAU ) / TWO
            END IF
         END IF
*
         PREW = W
*
  170    CONTINUE
         DO 180 J = 1, N
            DELTA( J ) = DELTA( J ) - ETA
  180    CONTINUE
*
*        Evaluate PSI and the derivative DPSI
*
         DPSI = ZERO
         PSI = ZERO
         ERRETM = ZERO
         DO 190 J = 1, IIM1
            TEMP = Z( J ) / DELTA( J )
            PSI = PSI + Z( J )*TEMP
            DPSI = DPSI + TEMP*TEMP
            ERRETM = ERRETM + PSI
  190    CONTINUE
         ERRETM = ABS( ERRETM )
*
*        Evaluate PHI and the derivative DPHI
*
         DPHI = ZERO
         PHI = ZERO
         DO 200 J = N, IIP1, -1
            TEMP = Z( J ) / DELTA( J )
            PHI = PHI + Z( J )*TEMP
            DPHI = DPHI + TEMP*TEMP
            ERRETM = ERRETM + PHI
  200    CONTINUE
*
         TEMP = Z( II ) / DELTA( II )
         DW = DPSI + DPHI + TEMP*TEMP
         TEMP = Z( II )*TEMP
         W = RHOINV + PHI + PSI + TEMP
         ERRETM = EIGHT*( PHI-PSI ) + ERRETM + TWO*RHOINV +
     $            THREE*ABS( TEMP ) + ABS( TAU+ETA )*DW
*
         SWTCH = .FALSE.
         IF( ORGATI ) THEN
            IF( -W.GT.ABS( PREW ) / TEN )
     $         SWTCH = .TRUE.
         ELSE
            IF( W.GT.ABS( PREW ) / TEN )
     $         SWTCH = .TRUE.
         END IF
*
         TAU = TAU + ETA
*
*        Main loop to update the values of the array   DELTA
*
         ITER = NITER + 1
*
         DO 240 NITER = ITER, MAXIT
*
*           Test for convergence
*
            IF( ABS( W ).LE.EPS*ERRETM ) THEN
               IF( ORGATI ) THEN
                  DLAM = D( I ) + TAU
               ELSE
                  DLAM = D( IP1 ) + TAU
               END IF
               GO TO 250
            END IF
*
            IF( W.LE.ZERO ) THEN
               DLTLB = MAX( DLTLB, TAU )
            ELSE
               DLTUB = MIN( DLTUB, TAU )
            END IF
*
*           Calculate the new step
*
            IF( .NOT.SWTCH3 ) THEN
               IF( .NOT.SWTCH ) THEN
                  IF( ORGATI ) THEN
                     C = W - DELTA( IP1 )*DW -
     $                   ( D( I )-D( IP1 ) )*( Z( I ) / DELTA( I ) )**2
                  ELSE
                     C = W - DELTA( I )*DW - ( D( IP1 )-D( I ) )*
     $                   ( Z( IP1 ) / DELTA( IP1 ) )**2
                  END IF
               ELSE
                  TEMP = Z( II ) / DELTA( II )
                  IF( ORGATI ) THEN
                     DPSI = DPSI + TEMP*TEMP
                  ELSE
                     DPHI = DPHI + TEMP*TEMP
                  END IF
                  C = W - DELTA( I )*DPSI - DELTA( IP1 )*DPHI
               END IF
               A = ( DELTA( I )+DELTA( IP1 ) )*W -
     $             DELTA( I )*DELTA( IP1 )*DW
               B = DELTA( I )*DELTA( IP1 )*W
               IF( C.EQ.ZERO ) THEN
                  IF( A.EQ.ZERO ) THEN
                     IF( .NOT.SWTCH ) THEN
                        IF( ORGATI ) THEN
                           A = Z( I )*Z( I ) + DELTA( IP1 )*
     $                         DELTA( IP1 )*( DPSI+DPHI )
                        ELSE
                           A = Z( IP1 )*Z( IP1 ) +
     $                         DELTA( I )*DELTA( I )*( DPSI+DPHI )
                        END IF
                     ELSE
                        A = DELTA( I )*DELTA( I )*DPSI +
     $                      DELTA( IP1 )*DELTA( IP1 )*DPHI
                     END IF
                  END IF
                  ETA = B / A
               ELSE IF( A.LE.ZERO ) THEN
                  ETA = ( A-SQRT( ABS( A*A-FOUR*B*C ) ) ) / ( TWO*C )
               ELSE
                  ETA = TWO*B / ( A+SQRT( ABS( A*A-FOUR*B*C ) ) )
               END IF
            ELSE
*
*              Interpolation using THREE most relevant poles
*
               TEMP = RHOINV + PSI + PHI
               IF( SWTCH ) THEN
                  C = TEMP - DELTA( IIM1 )*DPSI - DELTA( IIP1 )*DPHI
                  ZZ( 1 ) = DELTA( IIM1 )*DELTA( IIM1 )*DPSI
                  ZZ( 3 ) = DELTA( IIP1 )*DELTA( IIP1 )*DPHI
               ELSE
                  IF( ORGATI ) THEN
                     TEMP1 = Z( IIM1 ) / DELTA( IIM1 )
                     TEMP1 = TEMP1*TEMP1
                     C = TEMP - DELTA( IIP1 )*( DPSI+DPHI ) -
     $                   ( D( IIM1 )-D( IIP1 ) )*TEMP1
                     ZZ( 1 ) = Z( IIM1 )*Z( IIM1 )
                     ZZ( 3 ) = DELTA( IIP1 )*DELTA( IIP1 )*
     $                         ( ( DPSI-TEMP1 )+DPHI )
                  ELSE
                     TEMP1 = Z( IIP1 ) / DELTA( IIP1 )
                     TEMP1 = TEMP1*TEMP1
                     C = TEMP - DELTA( IIM1 )*( DPSI+DPHI ) -
     $                   ( D( IIP1 )-D( IIM1 ) )*TEMP1
                     ZZ( 1 ) = DELTA( IIM1 )*DELTA( IIM1 )*
     $                         ( DPSI+( DPHI-TEMP1 ) )
                     ZZ( 3 ) = Z( IIP1 )*Z( IIP1 )
                  END IF
               END IF
               CALL SLAED6( NITER, ORGATI, C, DELTA( IIM1 ), ZZ, W, ETA,
     $                      INFO )
               IF( INFO.NE.0 )
     $            GO TO 250
            END IF
*
*           Note, eta should be positive if w is negative, and
*           eta should be negative otherwise. However,
*           if for some reason caused by roundoff, eta*w > 0,
*           we simply use one Newton step instead. This way
*           will guarantee eta*w < 0.
*
            IF( W*ETA.GE.ZERO )
     $         ETA = -W / DW
            TEMP = TAU + ETA
            IF( TEMP.GT.DLTUB .OR. TEMP.LT.DLTLB ) THEN
               IF( W.LT.ZERO ) THEN
                  ETA = ( DLTUB-TAU ) / TWO
               ELSE
                  ETA = ( DLTLB-TAU ) / TWO
               END IF
            END IF
*
            DO 210 J = 1, N
               DELTA( J ) = DELTA( J ) - ETA
  210       CONTINUE
*
            TAU = TAU + ETA
            PREW = W
*
*           Evaluate PSI and the derivative DPSI
*
            DPSI = ZERO
            PSI = ZERO
            ERRETM = ZERO
            DO 220 J = 1, IIM1
               TEMP = Z( J ) / DELTA( J )
               PSI = PSI + Z( J )*TEMP
               DPSI = DPSI + TEMP*TEMP
               ERRETM = ERRETM + PSI
  220       CONTINUE
            ERRETM = ABS( ERRETM )
*
*           Evaluate PHI and the derivative DPHI
*
            DPHI = ZERO
            PHI = ZERO
            DO 230 J = N, IIP1, -1
               TEMP = Z( J ) / DELTA( J )
               PHI = PHI + Z( J )*TEMP
               DPHI = DPHI + TEMP*TEMP
               ERRETM = ERRETM + PHI
  230       CONTINUE
*
            TEMP = Z( II ) / DELTA( II )
            DW = DPSI + DPHI + TEMP*TEMP
            TEMP = Z( II )*TEMP
            W = RHOINV + PHI + PSI + TEMP
            ERRETM = EIGHT*( PHI-PSI ) + ERRETM + TWO*RHOINV +
     $               THREE*ABS( TEMP ) + ABS( TAU )*DW
            IF( W*PREW.GT.ZERO .AND. ABS( W ).GT.ABS( PREW ) / TEN )
     $         SWTCH = .NOT.SWTCH
*
  240    CONTINUE
*
*        Return with INFO = 1, NITER = MAXIT and not converged
*
         INFO = 1
         IF( ORGATI ) THEN
            DLAM = D( I ) + TAU
         ELSE
            DLAM = D( IP1 ) + TAU
         END IF
*
      END IF
*
  250 CONTINUE
*
      RETURN
*
*     End of SLAED4
*
      END

C
C $Id: mdgnin.f,v 1.9 2008-09-18 00:42:17 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MDGNIN (DANG,DNCE)
C
        DOUBLE PRECISION DANG,DNCE
C
C This routine, given a particular angular "step" DANG, in degrees,
C returns the largest "nice" value which is smaller than or equal to
C that step (probably to be used as the interval between labels on
C a grid).
C
C Declare arrays in which to put "nice" values in degrees, minutes, and
C seconds, respectively.
C
        DOUBLE PRECISION TDEG(8),TMIN(7),TSEC(7)
C
C Declare other local variables.
C
        INTEGER       I
C
C Define the "nice" values.
C
        DATA TDEG / 90.D0,45.D0,30.D0,15.D0,10.D0, 5.D0, 2.D0,1.D0 /
        DATA TMIN / 30.D0,20.D0,15.D0,10.D0, 5.D0, 2.D0, 1.D0 /
        DATA TSEC / 30.D0,20.D0,15.D0,10.D0, 5.D0, 2.D0, 1.D0 /
C
C Look for a nice interval which is an integral number of degrees.
C
        DO 101 I=1,8
          IF (DANG.GE.TDEG(I)) THEN
            DNCE=TDEG(I)
            RETURN
          END IF
  101   CONTINUE
C
C Look for a nice interval which is an integral number of minutes.
C
        DO 102 I=1,7
          IF (60.D0*DANG.GE.TMIN(I)) THEN
            DNCE=TMIN(I)/60.D0
            RETURN
          END IF
  102   CONTINUE
C
C Look for a nice interval which is an integral number of seconds.
C
        DO 103 I=1,7
          IF (3600.D0*DANG.GE.TSEC(I)) THEN
            DNCE=TSEC(I)/3600.D0
            RETURN
          END IF
  103   CONTINUE
C
C Failed to find a nice interval; return a zero.
C
        DNCE=0.D0
C
C Done.
C
        RETURN
C
      END

C
C	$Id: cssgridd.f,v 1.8 2008-07-27 03:10:08 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CSSGRIDD(N,RLATI,RLONI,F,NI,NJ,RLATO,RLONO,FF,
     +                     IWK,WK,IER)
      DOUBLE PRECISION RLATD,RLOND,WK(*),TFVAL,DGMX,STOL,DSMX
      INTEGER N,NI,NJ,IWK(*),IER
      DOUBLE PRECISION RLATI(N),RLONI(N),F(N),RLATO(NI),
     +                 RLONO(NJ),FF(NI,NJ)
C
      include 'cscomn.h'
C
C***********************************************************
C
C                               Simplified entry to SSRFPACK
C                                                 Fred Clare
C                                                  NCAR, SCD
C                                                   12/10/99
C
C  This subroutine provides a simple interface to SSRFPACK.
C  This is a single precision version that is nothing more
C  than an interface to the double precision version.
C  It triangulates the input data and does interpolation at
C  the specified grid points.  Certain internal parameters are
C  assigned default values.
C
C  On input:
C
C    N = Number of nodes.  N .GE. 3.
C
C    RLATI,RLONI = Arrays containing lat/lon coordinates of the nodes,
C                  in degrees.
C
C    F     = Array containing data values.  F(I) is associated with
C            (X(I),Y(I),Z(I)) for I = 1 to N.
C
C    NI,NJ = Number of rows and columns in the uniform grid.
C            1 .LE. NI .LE. NROW and 1 .LE. NJ.
C
C    RLATO,RLONO = Arrays of length NI and NJ, respectively, containing
C                  the latitudes and longitudes of the grid lines, in
C                  degrees.
C
C    IWK  = An integer workspace of length 27*N.
C
C           The workspace is used as follows:
C
C             IWK(     1)-IWK( 6*N)  --  LIST.
C             IWK( 6*N+1)-IWK(12*N)  --  LPTR.
C             IWK(12*N+1)-IWK(13*N)  --  LEND.
C             IWK(13*N+1)-IWK(14*N)  --  NEAR.
C             IWK(14*N+1)-IWK(15*N)  --  NEXT.
C
C    WK   = A *double precision* workspace of length 13*N.
C           This workspace must be double precision since this
C           routine is simply a single precision interface to the
C           primary double precision code.
C
C           The workspace is used as follows:
C
C             WK(     1)-WK(   N)  --  Double precision version of F.
C             WK(   N+1)-WK( 2*N)  --  Double precision version of X,
C                                      where (X(I),Y(I),Z(I)) is the
C                                      Cartestian coordinate on the unit
C                                      sphere equivalent to (PLAT(I),PLON(I)).
C             WK( 2*N+1)-WK( 3*N)  --  Double precision version of Y.
C             WK( 3*N+1)-WK( 4*N)  --  Double precision version of Z.
C             WK( 4*N+1)-WK(10*N)  --  First used to store the radian
C                                      equivalent to RLATI, then used for
C                                      double precision version of SIGMA.
C             WK(10*N+1)-WK(13*N)  --  First used to store the radian
C                                      equivalent to RLONI, then used for
C                                      double precision version of GRAD.
C
C  On output:
C
C    FF   = Interpolated values at the grid points if IER .GE. 0 .
C           FF(I,J) = F(PLAT(I),PLON(J)) for I = 1,...,NI and
C           J = 1,...,NJ.
C
C    IER = Error indicator:
C             =  0 - no error.
C             =  1 - invalid number of input points (must be
C                    greater than 3).
C             =  4 - first three nodes are collinear.
C             =  6 - internal algorithm error - please report this.
C             = 10 - insufficient space for the triangulation
C                    (must be >= number of boundary nodes minus 2).
C             = 11 - degenerate triangle (two vertices lie on
C                    same geodesic).
C             = -L - coordinates L and M coincide for some
C                    M  > L >= 1 (coordinate numbering
C                    starting at 1).
C
C***********************************************************
C
C  Parameters for random number usage.
C
      PARAMETER (D2R=0.017453293D0,EPSILON=0.00001D0,IRMAX=32767)
C
C  Use pre-calculated estimated gradients.
C
      PARAMETER (IFLGG=1)
C
      INTEGER I,J,IERR,IST,NN,NST,NX,NY
      DATA IX,IY,IZ/1,2,3/
      DATA NST/1/
C
C Local parameters:
C
C I,J =   DO-loop indexes
C IERR =  Error flag for calls to CSGRADL and CSINTRC1
C IST =   Parameter for CSINTRC1
C NN =    Local copy of N
C NST =   Initial value for IST
C NX,NY = Local copies of NI and NJ
C
C  Do a call forcing a BLOCKDATA to be loaded from a binary library.
C
      CALL CSBLDA
C
C  Zero out the workspaces.
C
      DO 11 I=1,27*N
        IWK(I) = 0
   11 CONTINUE
      DO 12 I=1,13*N
        WK(I) = 0.D0
   12 CONTINUE
C
      IF (N .LT. 4) GO TO 110
      NN = N
      NNEW = N
      NX = NI
      NY = NJ
      IF (NN.LT.3) THEN
          GO TO 110
      ELSE IF (NX.LT.1) THEN
          GO TO 200
      ELSE IF (NY.LT.1) THEN
          GO TO 210
      END IF
C
C  Convert RLATI and RLONI to radians.
C
      DO 7 I=1,NN
        WK(4*N+I) = DBLE(D2R*RLATI(I))
        WK(5*N+I) = DBLE(D2R*RLONI(I))
    7 CONTINUE
C
C  Then convert to Cartesian coordinates.
C
      CALL CSTRANSD(NN,WK(4*N+1),WK(5*N+1),WK(N+1),WK(2*N+1),WK(3*N+1))        
C
      IST = NST
C
C  Do the triangulation.
C
      CALL CSTRMESH(NNEW,WK(N+1),WK(2*N+1),WK(3*N+1),IWK(1),IWK(6*NN+1),
     +              IWK(12*NN+1),LNEW,IWK(13*N+1),IWK(14*N+1),WK(1),IER)
      IF (IER.EQ.0) THEN
          GO TO 100
      ELSE IF (IER.EQ.-1) THEN
          GO TO 110
      ELSE IF (IER.EQ.-2) THEN
          GO TO 120
      ELSE IF (IER.EQ.-3) THEN
          GO TO 130
      ELSE IF (IER.GT.0) THEN
          NERR = -IER
          GO TO 140
      ELSE
          GO TO 130
      END IF
C
  100 CONTINUE
C
C  Copy the input values into a double precision array.
C
      DO 4 I=1,NN
        WK(I) = F(I)
    4 CONTINUE 
C
C  Set up the SIGMA array.
C
      IF (ICSIG .EQ. 0) THEN
        IFLGS = 1
C
C  Zero SIGMA array.
C
        DO 70 I=1,6*NN
          WK(4*NN+I) = 0.
   70   CONTINUE
      ELSE
C
C  Constant SIGMA.
C
        WK(4*N+1) = USSIG
        IFLGS = 0
      ENDIF
C
C  Zero GRAD array.
C
      DO 90 I = 1,3*NN
        WK(10*NN+I) = 0.
   90 CONTINUE
C
C  Iterate to get global gradient estimates.  The number of iterations
C  is chosen as a fixed number here.  If a constant SIGMA is
C  chosen, then no interation is done.  This loop could be changed to
C  exit when the difference between two successive gradient
C  estimates yields a maximum difference less than some tolerance,
C  like 0.01 .  This would require storing the estimated gradients
C  for the comparison.
C
      IF (ICSIG .NE. 0) THEN 
        ITERMAX = 1
      ELSE
        ITERMAX = 6
      ENDIF
C
      DO 80 ITER=1,ITERMAX
        NITG = NUMIT
        DGMX = TOLIC
        STOL = TOLSG 
C
C  Use local or global gradients depending on IGFLG.
C
        IF (IGFLG .EQ. 1) THEN
          CALL CSGRADG(NN,WK(N+1),WK(2*N+1),WK(3*N+1),WK(1),IWK(1),
     +                 IWK(6*N+1),IWK(12*N+1),IFLGS,WK(4*N+1),NITG,
     +                 DGMX,WK(10*N+1),IER)
          IF (IER .EQ. -1) THEN
            CALL CSSERR('CSGRADG',13)
            RETURN
          ELSE IF (IER .EQ. -2) THEN
            CALL CSSERR('CSGRADG',4)
            RETURN
          ELSE IF (IER .EQ. -3) THEN
            CALL CSSERR('CSGRADG',12)
            RETURN
          ELSE IF (IER .EQ. 1) THEN
            IER = 0
          ENDIF
        ELSE
          DO 8 K=1,NN
            CALL CSGRADL(NN,K,WK(N+1),WK(2*N+1),WK(3*N+1),WK(1),
     +                   IWK(1),IWK(6*N+1),IWK(12*N+1),
     +                   WK(10*N+3*(K-1)+1),IER)
            IF (IER .EQ. -1) THEN
              CALL CSSERR('CSGRADL',1)
              RETURN
            ELSE IF (IER .EQ. -2) THEN
              CALL CSSERR('CSGRADL',4)
              RETURN
            ELSE IF (IER .GE. 6) THEN
              IER = 0
            ENDIF
    8     CONTINUE
        ENDIF
C
C  Calculate SIGMAs if requested.
C
        IF (ICSIG .EQ. 0) THEN
          CALL CSGETSIG(NN,WK(N+1),WK(2*N+1),WK(3*N+1),WK(1),IWK(1),
     +                  IWK(6*N+1),IWK(12*N+1),WK(10*N+1),STOL,
     +                  WK(4*N+1),DSMX,IER)
          IF (IER .EQ. -1) THEN
            CALL CSSERR('CSGETSIG',1)
            RETURN
          ELSE IF (IER .EQ. -2) THEN
            CALL CSSERR('CSGETSIG',12)
            RETURN
          ELSE IF (IER .GE. 0) THEN
            IER = 0
          ENDIF
        ENDIF
   80 CONTINUE
C
C Compute uniform grid points and interpolated values.
C
      DO 3 J = 1,NY
        RLOND = D2R*RLONO(J)          
        DO 2 I = 1,NX
          RLATD = D2R*RLATO(I)          
          CALL CSINTRC1(NNEW,RLATD,RLOND,WK(N+1),WK(2*N+1),
     +                  WK(3*N+1),WK(1),IWK(1),IWK(6*NN+1),
     +                  IWK(12*NN+1),IFLGS,WK(4*N+1),IFLGG,WK(10*N+1),
     +                  IST,TFVAL,IERR)
          IF (IERR.EQ.0) THEN
              FF(I,J) = TFVAL
              GO TO 2
          ELSE IF (IERR.EQ.1) THEN
              GO TO 110
          ELSE IF (IERR.EQ.4) THEN
              GO TO 120
          ELSE IF (IERR.EQ.7) THEN
              GO TO 170
          ELSE IF (IERR.EQ.8) THEN
              GO TO 180
          ELSE IF (IERR.EQ.9) THEN
              GO TO 190
          ELSE
              GO TO 130
          END IF
    2   CONTINUE
    3 CONTINUE
      RETURN
C
  110 CONTINUE
      IER = 1
      CALL CSSERR('CSSGRIDD',IER)
      RETURN
C
  120 CONTINUE
      IER = 4
      CALL CSSERR('CSSGRIDD',IER)
      RETURN
C
  130 CONTINUE
      IER = 6
      CALL CSSERR('CSSGRIDD',IER)
      RETURN
C
  140 CONTINUE
      IER = NERR
      CALL CSSERR('CSSGRIDD',IER)
      RETURN
C
  150 CONTINUE
      IER = 10
      CALL CSSERR('CSSGRIDD',IER)
      RETURN
C
  160 CONTINUE
      IER = 11
      CALL CSSERR('CSSGRIDD',IER)
      RETURN
C
  170 CONTINUE
      IER = 7
      CALL CSSERR('CSSGRIDD',IER)
      RETURN
C
  180 CONTINUE
      IER = 8
      CALL CSSERR('CSSGRIDD',IER)
      RETURN
C
  190 CONTINUE
      IER = 9
      CALL CSSERR('CSSGRIDD',IER)
      RETURN
C
  200 CONTINUE
      IER = 2
      CALL CSSERR('CSSGRIDD',IER)
      RETURN
C
  210 CONTINUE
      IER = 3
      CALL CSSERR('CSSGRIDD',IER)
      RETURN
C
      END

C
C	$Id: wmvlbl.f,v 1.3 2008-07-27 00:17:37 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE WMVLBL(X,Y)
C
C  This subroutine plots an informational label box using the
C  current settings for vactor scaling "VRS" and "VRN".  The
C  (X,Y) coordinate specifies the lower right hand corner of
C  the box position.  The settings for "VLB" and "VLF" specify
C  the background and foreground colors for the box and "VSC"
C  specifies the scale factor.
C
      include 'wmcomn.h'
C
      PARAMETER (R2D=57.2957795131)
      DIMENSION XX(5),YY(5),CRECT(4)
      CHARACTER*8 CHRDIST
      INTEGER VCC,FN,CC
C
C  Save the current attributes.
C
      CALL GQPLCI(IER,ILCLRO)
      CALL GQFACI(IER,IFCLRO)
      CALL GQLWSC(IER,RLNWTH)
      CALL GQCNTN(IER,NTRO)
      CALL GQCLIP(IER,NCLIPO,CRECT)

      CALL GSLWSC(VCLWID)
      CALL GSELNT(0)
C
C  Draw boundary box.
C
      XX(1) = X
      YY(1) = Y
      XX(2) = XX(1)
      YY(2) = YY(1)+0.05
      XX(3) = XX(2)-0.10
      YY(3) = YY(2)
      XX(4) = XX(3)
      YY(4) = YY(1)
      XX(5) = XX(1)
      YY(5) = YY(1)

      CALL GSFACI(VLBLBC)
      CALL GFA(5,XX,YY)
      CALL GSLWSC(1.)
      CALL GSPLCI(VLBLFC)
      CALL GPL(5,XX,YY)
C
C  Draw a vector of NDC length 0.07 using the current settings
C  for vectors.
C
      CALL WMGETR('VRS',VRS)
      CALL WMGETR('VRN',VRN)
      CALL WMGETR('VCW',VCW)
      CALL WMGETR('VCH',VCH)
      CALL WMGETI('VCC',VCC)
C
      CALL WMSETR('VRS',0.07)
      CALL WMSETR('VRN',0.07)
      CALL WMSETR('VCW',2.)
      CALL WMSETR('VCH',0.02)
      CALL WMSETI('VCC',VLBLFC)
C
      CALL WMVECT(X-0.10+0.015,Y+0.015,0.07,0.)
      CALL WMSETR('VRS',VRS)
      CALL WMSETR('VRN',VRN)
      CALL WMSETR('VCW',VCW)
      CALL WMSETR('VCH',VCH)
      CALL WMSETI('VCC',VCC)

      REFDIST = 0.07*VCUREF/VCNREF
      WRITE(CHRDIST,501) REFDIST
  501 FORMAT(E8.2)

      CALL PCGETI('CC',CC)
      CALL PCGETI('FN',FN)

      CALL PCSETI('CC',VLBLFC)
      CALL PCSETI('FN',21)

      CALL PLCHHQ(X-0.10+0.05,Y+0.035,CHRDIST,0.01275,0.,0.)
      CALL PCSETI('CC',CC)
      CALL PCSETI('FN',FN)
C
C  Restore the original environment.
C
      CALL GSPLCI(ILCLRO)
      CALL GSFACI(IFCLRO)
      CALL GSELNT(NTRO)
      CALL GSLWSC(RLNWTH)
      CALL GSCLIP(NCLIPO)
C
      RETURN
      END

C
C	$Id: conop3.f,v 1.4 2008-07-27 00:16:57 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CONOP3 (IOPT,ARRAY,ISIZE)
C
C SET THE CONTRAN OPTIONS
C
C INPUT
C     IOPT-CHARACTER STRING OF OPTION VALUE
C     ARRAY-   REAL ARRAY OF DIMENSION ISIZE
C     ISIZE-   SIZE OF ARRAY
C
C  SET COMMON DATA EQUAL TO INPUT DATA
C
C
C
      COMMON /CONRA1/ CL(30)     ,NCL        ,OLDZ       ,PV(210)    ,
     1                FINC       ,HI         ,FLO
      COMMON /CONRA2/ REPEAT     ,EXTRAP     ,PER        ,MESS       ,
     1                ISCALE     ,LOOK       ,PLDVLS     ,GRD        ,
     2                CINC       ,CHILO      ,CON        ,LABON      ,
     3                PMIMX      ,SCALE      ,FRADV      ,EXTRI      ,
     4                BPSIZ      ,LISTOP
      COMMON /CONRA3/ IREC
      COMMON /CONRA4/ NCP        ,NCPSZ
      COMMON /CONRA5/ NIT        ,ITIPV
      COMMON /CONRA6/ XST        ,YST        ,XED        ,YED        ,
     1                STPSZ      ,IGRAD      ,IG         ,XRG        ,
     2                YRG        ,BORD       ,PXST       ,PYST       ,
     3                PXED       ,PYED       ,ITICK
      COMMON /CONR18/ TITLE      ,ICNT   ,ITLSIZ
      COMMON /CONR19/ IHIGH      ,INMAJ      ,INLAB      ,INDAT      ,
     1              LEN      ,IFMT       ,LEND       ,
     2                IFMTD      ,ISIZEP     ,INMIN
      COMMON /CONRA9/ ICOORD(500),NP         ,MXXY       ,TR         ,
     1                BR         ,TL         ,BL         ,CONV       ,
     2                XN         ,YN         ,ITLL       ,IBLL       ,
     3                ITRL       ,IBRL       ,XC         ,YC         ,
     4                ITLOC(210) ,JX         ,JY         ,ILOC       ,
     5                ISHFCT     ,XO         ,YO         ,IOC        ,NC
      COMMON /CONR10/ NT         ,NL         ,NTNL       ,JWIPT      ,
     1                JWIWL      ,JWIWP      ,JWIPL      ,IPR        ,
     2                ITPV
      COMMON /CONR20/ NREP       ,NCRT       ,ISIZEL     ,
     1                MINGAP     ,ISIZEM         ,
     2                TENS
      COMMON /CONR12/ IXMAX      ,IYMAX      ,XMAX       ,YMAX
      LOGICAL         REPEAT     ,EXTRAP     ,PER        ,MESS       ,
     1                LOOK       ,PLDVLS     ,GRD        ,LABON      ,
     2                PMIMX      ,FRADV      ,EXTRI      ,CINC       ,
     3                TITLE      ,LISTOP     ,CHILO      ,CON
      COMMON /CONR13/XVS(50),YVS(50),ICOUNT,SPVAL,SHIELD,
     1               SLDPLT
      LOGICAL SHIELD,SLDPLT
      COMMON /CONR14/LINEAR
      LOGICAL LINEAR
      COMMON /CONR15/ ISTRNG
        CHARACTER*64 ISTRNG
        COMMON /CONR16/ FORM
        CHARACTER*10 FORM
        COMMON /CONR17/ NDASH, IDASH, EDASH
        CHARACTER*10 NDASH, IDASH, EDASH
C
C
C
C  INTPR IS THE DASH PACKAGE COMMON BLOCK INTERFACE
C  NP11 IS NP IN ALL OTHER INTPR DEFINITIONS; NAME CHANGE BECAUSE OF
C  CONFLICT
C
      COMMON /INTPR/  IPAU       ,FPART      ,TENSN      ,NP11       ,
     1                SMALL      ,L1         ,ADDLR      ,ADDTB      ,
     2                MLLINE     ,ICLOSE
        DIMENSION ARRAY(ISIZE)
        CHARACTER*7  IOPT
        CHARACTER*2  TAG, OPT
C
C
        SAVE
C
C  DETERMINE THE OPTION DESIRED
C
      TAG = IOPT(1:2)
        IF (IOPT(3:3) .EQ. '=') THEN
            OPT = IOPT(4:5)
        ELSE
            OPT = IOPT(5:6)
        ENDIF
C
C  CON CONTOUR LEVELS  CHECK VALUE OF SWITCH
C
      IF (TAG .EQ. 'CO') THEN
C
C  SWITCH = ON SET CONTOUR LEVELS
C
          IF (OPT .EQ. 'ON') THEN
              IF (CHILO .OR. CINC) GOTO  140
C
C  TEST IF NUMBER OF CONTOURS IS ACCEPTABLE
C
              IF (ISIZE .GT. 30)
     1    CALL SETER (' CONOP3-NUMBER OF CONTOUR LEVELS EXCEEDS 30',
     2                 1,1)
      DO  200 I=1,ISIZE
       CL(I) = ARRAY(I)
  200 CONTINUE
      CON = .TRUE.
      NCL = ISIZE
      RETURN
C
C  SWITCH = OFF CLEAR CONTOUR LEVEL ARRAY (PROGRAM SELECTS)
C
            ELSEIF (OPT .EQ. 'OF') THEN
              CON = .FALSE.
              RETURN
            ELSE
                  GOTO 120
          ENDIF
C
C  CONTOUR HI LO OPTION FOUND GET VALUE OF SWITCH
C
      ELSEIF (TAG .EQ. 'CH') THEN
C
C  SWITCH ON SET HI AND FLO
C
            IF (OPT .EQ. 'ON') THEN
              IF (CON) GOTO  140
                  HI = ARRAY(1)
                  FLO = ARRAY(2)
                  CHILO = .TRUE.
                  RETURN
C
C  SWITCH OFF CLEAR FLAG
C
            ELSEIF (OPT .EQ. 'OF') THEN
                CHILO = .FALSE.
                RETURN
          ELSE
                  GOTO 120
            ENDIF
C
C  CONTOUR INCREMENT OPTION GET VALUE OF SWITCH
C
      ELSEIF (TAG .EQ. 'CI') THEN
C
C  SWITCH ON SET INCREMENT
C
          IF (OPT .EQ. 'ON') THEN
              IF (CON) GOTO  140
              CINC = .TRUE.
              FINC = ARRAY(1)
              RETURN
C
C  SWITCH OFF CLEAR FLAG
C
          ELSEIF (OPT .EQ. 'OF') THEN
              CINC = .FALSE.
              RETURN
        ELSE
                GOTO 120
          ENDIF
C
C  SCALE THE DATA PLOTTED ON THE CONTOURS AND MIN MAX POINTS
C
      ELSEIF (TAG .EQ. 'SD') THEN
C
C  SWTICH ON GET SCALE FACTOR
C
            IF (OPT .EQ. 'ON') THEN
                SCALE = ARRAY(1)
                RETURN
C
C  SWTICH OFF SET FOR NO SCALING
C
            ELSEIF (OPT .EQ. 'OF') THEN
                SCALE = 1.
                RETURN
          ELSE
                  GOTO 120
            ENDIF
C
C  SET THE TENSION VALUE FOR SMOOTHING
C
      ELSEIF (TAG .EQ. 'TE') THEN
C
C  SWTICH ON SET TENSION FACTOR
C
            IF (OPT .EQ. 'ON') THEN
                TENSN = ARRAY(1)
                RETURN
C
C  SWTICH OFF SET TO DEFAULT TENSION
C
            ELSEIF (OPT .EQ. 'OF') THEN
                TENSN = TENS
                RETURN
          ELSE
                  GOTO 120
            ENDIF
C
C  DASH PATTERN BREAK POINT SWITCH
C
      ELSEIF (TAG .EQ. 'DB') THEN
C
C  SWITCH ON GET USERS BREAKPOINT
C
            IF (OPT .EQ. 'ON') THEN
                BPSIZ = ARRAY(1)
                RETURN
C
C  SWITCH OFF SET TO DEFAULT
C
            ELSEIF (OPT .EQ. 'OF') THEN
                BPSIZ = 0.
                RETURN
          ELSE
                  GOTO 120
            ENDIF
C
C  SHIELD OPTION
C
        ELSEIF (TAG .EQ. 'SL') THEN
C
C  TURN SHIELDING ON AND SET THE SHIELD COORD POINTERS
C
            IF (OPT .EQ. 'ON') THEN
                  NISIZE = ISIZE/2
                  CALL CONSSD(ARRAY(1),ARRAY(NISIZE+1),NISIZE)
                  RETURN
C
C  DEACTIVATE SHIELDING
C
            ELSEIF (OPT .EQ. 'OF') THEN
                  ICOUNT = 0
                  SHIELD = .FALSE.
                  RETURN
            ELSE
                  GOTO 120
            ENDIF
        ELSE
            GOTO 120
        ENDIF
C
C  ERROR UNDEFINED OPTION DETECTED
C
  120 CALL SETER (' CONOP3-UNDEFINED OPTION',1,1)
      RETURN
C
C  ILLEGAL USE OF CON WITH CIL OR CHL
C
  140 CALL SETER
     1('CONOP3-ILLEGAL USE OF CON OPTION WITH CIL OR CHL OPTION',
     2 1,1)
      RETURN
        END

C
C $Id: line3w.f,v 1.5 2008-07-27 00:17:34 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE LINE3W (XA,YA,XB,YB)
      SAVE
      COMMON /PRM31/  Q          ,L
      GO TO ( 10, 30, 40),L
   10 UA = Q
      UB = Q
      VA = XA
      VB = XB
   20 WA = YA
      WB = YB
      GO TO  50
   30 UA = XA
      UB = XB
      VA = Q
      VB = Q
      GO TO  20
   40 UA = XA
      UB = XB
      VA = YA
      VB = YB
      WA = Q
      WB = Q
   50 CALL LINE3 (UA,VA,WA,UB,VB,WB)
      RETURN
      END

C
C       $Id: ngreop.f,v 1.4 2008-07-27 00:17:18 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE NGREOP(WKID,   CONID,  ITYPE, FNAME, IOPT, IAT, RAT,
     +                  NCOLRS, NSTART, CTAB)
C
C Reopen an existing NCAR Graphics metafile for appending.
C
C ARGUMENTS
C
C ON INPUT  
C    
C  WKID    INTEGER     The workstation identifier that the reopened 
C                      metafile will subsequently be known by.  This 
C                      does not have to be the same as the worksttion 
C                      identifier used to create the original metafile.
C
C  CONID   INTEGER     The connection identifier.
C
C  ITYPE   INTEGER     The workstation type.  Currently the only valid 
C                      value is "1".  This subroutine may be augmented 
C                      to accommodate PostScript files in the future.
C
C  FNAME   CHARACTER   The filename of the metafile being opened for
C                      appending.
C
C  IOPT    INTEGER     A flag indicating an action:
C                         = 0 - reestablish the color table only (using
C                               the color table in argument CTAB 
C                               described below).  The attributes of
C                               the reopened workstation will be set
C                               to default values and may well be out
C                               of sync with the current GKS attributes.
C                         = 1 - reestablish the color table and 
C                               GKS state (the GKS state as supplied
C                               in arguments IAT and RAT described
C                               below).  The state values will not be
C                               flushed to the metafile.
C                         = 2 - reestablish the color table and GKS state
C                               and flush the GKS state values to the 
C                               metafile.
C                         = 3 - reestablish the color table and flush 
C                               the current GKS state values to the 
C                               metafile (not the values in IAT and RAT).
C
C                      If IOPT equals 1 or 2, then IAT and RAT must be
C                      supplied, otherwise not.
C
C  IAT    INTEGER(14)  An array containing GKS integer state variables 
C                      as follows:
C
C                        IAT( 1) = Clip indicator
C                        IAT( 2) = Line type
C                        IAT( 3) = Polyline color index
C                        IAT( 4) = Marker type
C                        IAT( 5) = Polymarker color index
C                        IAT( 6) = Text font
C                        IAT( 7) = Text precision
C                        IAT( 8) = Text color index
C                        IAT( 9) = Text path
C                        IAT(10) = Text horizontal alignment
C                        IAT(11) = Text vertical alignment
C                        IAT(12) = Fill area interior style
C                        IAT(13) = Fill are style index
C                        IAT(14) = Fill area color index
C
C                      At any time the values of the above NCAR GKS 
C                      state variables can be saved and/or restored 
C                      using the NGSRAT function.
C                   
C  RAT    REAL(7)      A REAL array containing GKS floating-point
C                      state variables as follows:
C
C                        RAT( 1) = Linewidth scale factor
C                        RAT( 2) = Marker scale factor
C                        RAT( 3) = Character expansion factor
C                        RAT( 4) = Character spacing
C                        RAT( 5) = Character height in world coordinates
C                        RAT( 6) = Character up vector, X component in
C                                  world coordinates
C                        RAT( 7) = Character up vector, Y component in
C                                  world coordinates
C 
C                      At any time the values of the above NCAR GKS 
C                      state variables can be saved and/or restored 
C                      using the NGSRAT function.
C
C  NCOLRS INTEGER     The number of colors in the color table supplied
C                     in argument CTAB, described below.  NCOLRS can be
C                     0 .
C
C
C  NSTART INTEGER     The color index associated with the first color 
C                     in the color table CTAB (all other color indices 
C                     are filled in in sequence).  For example, if
C                     NCOLRS = 3 and NSTART = 4, then the color values
C                     defined in CTAB would be used to define color
C                     indices 4, 5, and 6.
C
C  CTAB   REAL(3,NCOLRS)  
C                     A color table used to initialize the reopened
C                     workstation.  This color table does not
C                     necessarily have to agree with the color table
C                     in effect when the original metafile was created.
C
C
CRLB: PARAMETER (LIDR=75)
      PARAMETER (LIDR=77)
      INTEGER WKID, CONID, ITYPE, IOPT, IAT(*), NCOLRS, NSTART 
      INTEGER IATE(31)     
      REAL    CTAB(3,*),RAT(*),RATE(19)
      CHARACTER*(*) FNAME
      CHARACTER*80 IDR(LIDR),ODR
C
C  Initialize character array to blanks.
C
      DO 10 I=1,LIDR
        IDR(I) = ' '
   10 CONTINUE
C
      IF (IOPT.EQ.1 .OR. IOPT.EQ.2) THEN
        IAFLG = 1
      ELSE
        IAFLG = 0
      ENDIF
C
C  Basic parameters.
C
      WRITE(IDR(1),502) WKID, CONID, ITYPE, IAFLG, NCOLRS, NSTART, IOPT
  502 FORMAT(7I5)
C
C  File name.
C
      NLEN = LEN(FNAME)
      NLRMD = MOD(NLEN,80)
      NLDIV = NLEN/80
      DO 20 I=1,NLDIV
        IL = 80*(I-1)+1
        IR = IL+79
        IDR(I+1) = FNAME(IL:IR)
   20 CONTINUE
      IF (NLRMD .NE. 0) THEN
        IL = 80*NLDIV+1
        IR = IL+NLRMD-1
        IDR(NLDIV+2)(1:NLRMD) = FNAME(IL:IR)
      ENDIF
C
C  Attributes (expand to full set for GESC call).
C

      IF (IAFLG .EQ. 1) THEN
        IATE( 1) = IAT(1)
        IATE( 2) = 1
        IATE( 3) = IAT(2)
        IATE( 4) = IAT(3)
        IATE( 5) = 1
        IATE( 6) = IAT(4)
        IATE( 7) = IAT(5)
        IATE( 8) = 1
        IATE( 9) = IAT(6)
        IATE(10) = IAT(7)
        IATE(11) = IAT(8)
        IATE(12) = IAT(9)
        IATE(13) = IAT(10)
        IATE(14) = IAT(11)
        IATE(15) = 1
        IATE(16) = IAT(12)
        IATE(17) = IAT(13)
        IATE(18) = IAT(14)
        IATE(19) = 1
        IATE(20) = 1
        IATE(21) = 1
        IATE(22) = 1
        IATE(23) = 1
        IATE(24) = 1
        IATE(25) = 1
        IATE(26) = 1
        IATE(27) = 1
        IATE(28) = 1
        IATE(29) = 1
        IATE(30) = 1
        IATE(31) = 1
C
        DO 155 I=1,7
          RATE(I) = RAT(I)
  155   CONTINUE
        RATE(8) = 1.
        RATE(9) = 1.
        RATE(10) = 0.
        RATE(11) = 0.
        CALL GQCLIP(IER,ICD,RATE(12))
        SCL = 1./SQRT(RAT(6)*RAT(6)+RAT(7)*RAT(7))
        XP = RAT(5)*SCL*RAT(6)
        YP = RAT(5)*SCL*RAT(7)
        XB =  YP
        YB = -XP
        CALL GZW2NX(1,XP,XTMP)
        CALL GZW2NY(1,YP,YTMP)
        CALL GZW2NX(1,0.,ZXTMP)
        CALL GZW2NY(1,0.,ZYTMP)
        RATE(16) = XTMP-ZXTMP
        RATE(17) = YTMP-ZYTMP
        CALL GZW2NX(1,XB,XTMP)
        CALL GZW2NY(1,YB,YTMP)
        RATE(18) = XTMP-ZXTMP
        RATE(19) = YTMP-ZYTMP
C --------------------------------------------------
C  Serializing these values was modified to support the presence of
C  32bit ARGB values, which are always *much* larger in magnitude
C  than the original I4 character fields.  Expanded to I10s; note
C  that 2 extra 80-character records are now required, so that
C  subsequent offsets into IDR have changed.     RLB 1/2012
C
C        WRITE(IDR( 6),503) (IATE(LL),LL= 1,20)
C        WRITE(IDR( 7),504) (IATE(LL),LL=21,31)
C        WRITE(IDR( 8),505) (RATE(LL),LL= 1, 5)
C        WRITE(IDR( 9),505) (RATE(LL),LL= 6,10)
C        WRITE(IDR(10),505) (RATE(LL),LL=11,15)
C        WRITE(IDR(11),506) (RATE(LL),LL=16,19)
C --------------------------------------------------        
        WRITE(IDR( 6),507) (IATE(LL),LL= 1, 8)
        WRITE(IDR( 7),507) (IATE(LL),LL= 9,16)
        WRITE(IDR( 8),507) (IATE(LL),LL=17,24)
        WRITE(IDR( 9),507) (IATE(LL),LL=25,31),0
        WRITE(IDR(10),505) (RATE(LL),LL= 1, 5)
        WRITE(IDR(11),505) (RATE(LL),LL= 6,10)
        WRITE(IDR(12),505) (RATE(LL),LL=11,15)
        WRITE(IDR(13),506) (RATE(LL),LL=16,19)
  503   FORMAT(20I4)
  504   FORMAT(11I4)
  505   FORMAT(5E16.7)
  506   FORMAT(4E16.7)
  507   FORMAT(8I10)
      ENDIF
C
C  Color table.
C
      
      IF (IAFLG .EQ. 1) THEN
C       IANDX = 12
        IANDX = 14
      ELSE
        IANDX = 6
      ENDIF
      ICRM = MOD(NCOLRS,4)
      ICDV = NCOLRS/4
      ICOLR = 0
      DO 50 I=1,ICDV
        DO 60 J=1,4
          ICOLR = ICOLR+1
          ID1 = 18*(J-1)+1
          ID2 = ID1+17
          WRITE(IDR(IANDX)(ID1:ID2),500) CTAB(1,ICOLR),
     +                          CTAB(2,ICOLR),CTAB(3,ICOLR)
  500     FORMAT(3F6.3)
   60   CONTINUE
        IANDX = IANDX+1
   50 CONTINUE
C
      DO 70 J=1,ICRM
        ICOLR = ICOLR+1
        ID1 = 18*(J-1)+1
        ID2 = ID1+17
        WRITE(IDR(IANDX)(ID1:ID2),500) CTAB(1,ICOLR),
     +                          CTAB(2,ICOLR),CTAB(3,ICOLR)
   70 CONTINUE
C
      CALL GESC(-1389,IANDX,IDR,1,1,ODR)
C
      RETURN
      END

C
C $Id: tdmtri.f,v 1.4 2008-07-27 00:17:33 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE TDMTRI (IMRK,UMRK,VMRK,WMRK,SMRK,RTRI,MTRI,NTRI,IRST,
     +                                  UMIN,VMIN,WMIN,UMAX,VMAX,WMAX)
C
        DIMENSION RTRI(10,MTRI)
C
C This routine is called to put a marker of type ABS(IMRK) at the point
C with coordinates (UMRK,VMRK,WMRK) and with radius SMRK.  This is done
C by adding triangles to the triangle list in the array RTRI.  MTRI is
C the maximum number of triangles that can be put in the list and NTRI
C is the number of triangles currently in the list.  IRST is the index
C of the rendering style to be used for the marker.
C
C IMRK may have an absolute value from 1 to 5, inclusive, to select a
C tetrahedron, an octahedron, a cube, an icosahedron, or an elaborated
C icosahedron (effectively, a sphere), respectively.  If IMRK is less
C than zero, the mark is not clipped at the faces of the box defined
C by the last six arguments; otherwise, it is.
C
        IF (IMRK.LT.0) THEN
          CALL TDMRKA (-IMRK,UMRK,VMRK,WMRK,SMRK,RTRI,MTRI,NTRI,IRST)
        ELSE
          CALL TDMRKB ( IMRK,UMRK,VMRK,WMRK,SMRK,RTRI,MTRI,NTRI,IRST,
     +                                 UMIN,VMIN,WMIN,UMAX,VMAX,WMAX)
        END IF
C
C Done.
C
        RETURN
C
      END

C
C     $Id: mp03f.f,v 1.10 2010-03-15 22:49:24 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C                Copyright (C)  1993                                   C
C        University Corporation for Atmospheric Research               C
C                All Rights Reserved                                   C
C                                                                      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C   File:       mp03f.f
C
C   Author:     David Brown (converted to Fortran by Mary)
C           National Center for Atmospheric Research
C           PO 3000, Boulder, Colorado
C
C   Date:       Tue Jan 24 10:08:50 MST 1995
C
C   Description:    Demonstrates MapPlot masking; loosely emulates the
C           LLU example 'colcon'
C
      external NhlFAppClass
      external NhlFNcgmWorkstationClass
      external NhlFCairoWindowWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFMapPlotClass
      external NhlFScalarFieldClass
      external NhlFContourPlotClass

      integer appid,wid,mapid,dataid,cnid
      integer rlist

      real z(50,50)
      integer M,N
      data M,N/50,50/
      integer mlow, mhigh
      data mlow,mhigh/13,18/
      real dlow, dhigh
      data dlow,dhigh/13.,18./
      integer len_dims(2)

      character*6 mask_specs(1)
      data mask_specs/'oceans'/
      character*7  wks_type
C
C Default is to display output to an X workstation
C
      wks_type = "x11"

C
C Initialize the high level utility library
C
      call NhlFInitialize
C
C Create an application context. Set the app dir to the current
C directory so the application looks for a resource file in the working
C directory. 
C
      call NhlFRLCreate(rlist,'SETRL')
      call NhlFRLClear(rlist)
      call NhlFRLSetstring(rlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'mp03',NhlFAppClass,0,rlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkMetaName','./mp03f.ncgm',ierr)
         call NhlFCreate(wid,'mp03Work',NhlFNcgmWorkstationClass,0,
     1        rlist,ierr)
      else  if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X Workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetinteger(rlist,'wkPause',1,ierr)
         call NhlFCreate(wid,'mp03Work',
     +        NhlFCairoWindowWorkstationClass,0,
     1        rlist,ierr)
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PostScript workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPSFileName','./mp03f.ps',ierr)
         call NhlFCreate(wid,'mp03Work',NhlFPSWorkstationClass,0,
     1        rlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPDFFileName','./mp03f.pdf',ierr)
         call NhlFCreate(wid,'mp03Work',NhlFPDFWorkstationClass,0,
     1        rlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF object.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetstring(rlist,'wkFileName','./mp03f',ierr)
         call NhlFCreate(wid,'mp03Work',
     1        NhlFCairoPSPDFWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG object.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetstring(rlist,'wkFileName','./mp03f',ierr)
         call NhlFCreate(wid,'mp03Work',
     1        NhlFCairoImageWorkstationClass,0,rlist,ierr)
      endif
C
C Call the routine 'gendat' to create the first array of contour
C data. Create a ScalarField data object and hand it the data created
C by 'gendat'. Define the extent of the data coordinates as the whole
C globe. 

      call NhlFRLClear(rlist)
      len_dims(1) = N
      len_dims(2) = M
      call gendat(z,M,M,N,mlow,mhigh,dlow,dhigh)
      call NhlFRLSetmdfloatarray(rlist,'sfDataArray',z,2,len_dims,ierr)
      call NhlFRLSetinteger(rlist,'sfXCStartV',-180,ierr)
      call NhlFRLSetinteger(rlist,'sfXCEndV',180,ierr)
      call NhlFRLSetinteger(rlist,'sfYCStartV',-90,ierr)
      call NhlFRLSetinteger(rlist,'sfYCEndV',90,ierr)
      call NhlFCreate(dataid,'Gendat',NhlFScalarFieldClass,appid,
     1     rlist,ierr)

C
C Create a ContourPlot object, supplying the ScalarField object as data,
C and setting the size of the viewport.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetinteger(rlist,'cnScalarFieldData',dataid,ierr)
      call NhlFRLSetstring(rlist,'cnLabelDrawOrder','postdraw',ierr)
      call NhlFCreate(cnid,'Contour1',NhlFContourPlotClass,
     1     wid,rlist,ierr)
C
C Create a MapPlot object, setting the fill to draw over the main draw,
C and masking out the oceans.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetfloat(rlist,'vpYF',0.775,ierr)
      call NhlFRLSetfloat(rlist,'vpHeightF',0.45,ierr)
      call NhlFRLSetstring(rlist,'mpFillOn','true',ierr)
      call NhlFRLSetstring(rlist,'pmTitleDisplayMode','always',ierr)
      call NhlFRLSetstring(rlist,'tiMainString','mp03f',ierr)
      call NhlFRLSetstring(rlist,'mpFillDrawOrder','postdraw',ierr)
      call NhlFRLSetstring(rlist,'mpAreaMaskingOn','true',ierr)
      call NhlFRLSetstringarray(rlist,'mpMaskAreaSpecifiers',mask_specs,
     1     1,ierr)
      call NhlFCreate(mapid,'Map1',NhlFMapPlotClass,wid,rlist,ierr)
C
C Overlay the ContourPlot on the MapPlot
C
      call NhlFAddOverlay(mapid,cnid,-1,ierr)
      call NhlFDraw(mapid,ierr)
      call NhlFFrame(wid,ierr)
C
C Destroy the objects created, close the HLU library and exit.
C

      call NhlFDestroy(mapid,ierr)
      call NhlFDestroy(wid,ierr)
      call NhlFClose

      stop
      end


      subroutine gendat (data,idim,m,n,mlow,mhgh,dlow,dhgh)
C
C This is a routine to generate test data for two-dimensional graphics
C routines.  Given an array 'DATA', dimensioned 'IDIM x 1', it fills
C the sub-array ((DATA(I,J),I=1,M),J=1,N) with a two-dimensional field
C of data having approximately 'MLOW' lows and 'MHGH' highs, a minimum
C value of exactly 'DLOW' and a maximum value of exactly 'DHGH'.
C
C 'MLOW' and 'MHGH' are each forced to be greater than or equal to 1
C and less than or equal to 25.
C
C The function used is a sum of exponentials.
C
        dimension data(idim,1),ccnt(3,50)

        fovm=9./float(m)
        fovn=9./float(n)

        nlow=max0(1,min0(25,mlow))
        nhgh=max0(1,min0(25,mhgh))
        ncnt=nlow+nhgh

        do 101 k=1,ncnt
          ccnt(1,k)=1.+(float(m)-1.)*fran()
          ccnt(2,k)=1.+(float(n)-1.)*fran()
          if (k.le.nlow) then
            ccnt(3,k)=-1.
          else
            ccnt(3,k)=+1.
          end if
  101   continue

        dmin=+1.e36
        dmax=-1.e36
        do 104 j=1,n
          do 103 i=1,m
            data(i,j)=.5*(dlow+dhgh)
            do 102 k=1,ncnt
              temp=-((fovm*(float(i)-ccnt(1,k)))**2+
     +               (fovn*(float(j)-ccnt(2,k)))**2)
              if (temp.ge.-20.) data(i,j)=data(i,j)+
     +            .5*(dhgh-dlow)*ccnt(3,k)*exp(temp)
  102       continue
            dmin=amin1(dmin,data(i,j))
            dmax=amax1(dmax,data(i,j))
  103     continue
  104   continue

        do 106 j=1,n
          do 105 i=1,m
            data(i,j)=(data(i,j)-dmin)/(dmax-dmin)*(dhgh-dlow)+dlow
  105     continue
  106   continue

        return

      end

      function fran ()
        dimension rseq (100)
        save iseq
        data rseq / .749,.973,.666,.804,.081,.483,.919,.903,.951,.960 ,
     +              .039,.269,.270,.756,.222,.478,.621,.063,.550,.798 ,
     +              .027,.569,.149,.697,.451,.738,.508,.041,.266,.249 ,
     +              .019,.191,.266,.625,.492,.940,.508,.406,.972,.311 ,
     +              .757,.378,.299,.536,.619,.844,.342,.295,.447,.499 ,
     +              .688,.193,.225,.520,.954,.749,.997,.693,.217,.273 ,
     +              .961,.948,.902,.104,.495,.257,.524,.100,.492,.347 ,
     +              .981,.019,.225,.806,.678,.710,.235,.600,.994,.758 ,
     +              .682,.373,.009,.469,.203,.730,.588,.603,.213,.495 ,
     +              .884,.032,.185,.127,.010,.180,.689,.354,.372,.429 /
        data iseq / 0 /
        iseq=mod(iseq,100)+1
        fran=rseq(iseq)
        return
      end

      PROGRAM CCPILT
C 
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER (M=40,N=40,LRWK=3500,LIWK=4000)
      REAL Z(M,N), RWRK(LRWK)
      INTEGER IWRK(LIWK)
      
      CALL GETDAT (Z, M, M, N)
C 
C Open GKS, open and activate a workstation.
C 
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
      CALL GSCLIP (0)
C
C Set up label options
C
      CALL CPSETC('ILT - INFORMATION LABEL TEXT',
     1'Modified Sine Function Contoured from $CMN$ to $CMX$ by $CIU$')
      CALL CPSETR('ILX - INFORMATION LABEL X COORDINATE',.5)
      CALL CPSETI('ILP - INFORMATION LABEL POSITION',0)
C
C Initialize Conpack
C
      CALL CPRECT(Z, M, M, N, RWRK, LRWK, IWRK, LIWK)
C
C Draw Perimeter
C
      CALL CPBACK(Z, RWRK, IWRK)
C
C Draw Contours
C
      CALL CPLBDR(Z,RWRK,IWRK)
      CALL CPCLDR(Z,RWRK,IWRK)
C 
C Close frame
C 
      CALL FRAME
C 
C Deactivate and close workstation, close GKS.
C 
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      
      STOP
      END
      
      SUBROUTINE GETDAT (Z, K, M, N)
      INTEGER I,J,K,M,N
      REAL Z(K,N)
      
      L=K
      DO 10, I=1,L
         READ (*,*) (Z(I,J),J=1,N)
 10   CONTINUE
      
      RETURN
      END

      SUBROUTINE DPBTRF( UPLO, N, KD, AB, LDAB, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     March 31, 1993
*
*     .. Scalar Arguments ..
      CHARACTER          UPLO
      INTEGER            INFO, KD, LDAB, N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   AB( LDAB, * )
*     ..
*
*  Purpose
*  =======
*
*  DPBTRF computes the Cholesky factorization of a real symmetric
*  positive definite band matrix A.
*
*  The factorization has the form
*     A = U**T * U,  if UPLO = 'U', or
*     A = L  * L**T,  if UPLO = 'L',
*  where U is an upper triangular matrix and L is lower triangular.
*
*  Arguments
*  =========
*
*  UPLO    (input) CHARACTER*1
*          = 'U':  Upper triangle of A is stored;
*          = 'L':  Lower triangle of A is stored.
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  KD      (input) INTEGER
*          The number of superdiagonals of the matrix A if UPLO = 'U',
*          or the number of subdiagonals if UPLO = 'L'.  KD >= 0.
*
*  AB      (input/output) DOUBLE PRECISION array, dimension (LDAB,N)
*          On entry, the upper or lower triangle of the symmetric band
*          matrix A, stored in the first KD+1 rows of the array.  The
*          j-th column of A is stored in the j-th column of the array AB
*          as follows:
*          if UPLO = 'U', AB(kd+1+i-j,j) = A(i,j) for max(1,j-kd)<=i<=j;
*          if UPLO = 'L', AB(1+i-j,j)    = A(i,j) for j<=i<=min(n,j+kd).
*
*          On exit, if INFO = 0, the triangular factor U or L from the
*          Cholesky factorization A = U**T*U or A = L*L**T of the band
*          matrix A, in the same storage format as A.
*
*  LDAB    (input) INTEGER
*          The leading dimension of the array AB.  LDAB >= KD+1.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*          > 0:  if INFO = i, the leading minor of order i is not
*                positive definite, and the factorization could not be
*                completed.
*
*  Further Details
*  ===============
*
*  The band storage scheme is illustrated by the following example, when
*  N = 6, KD = 2, and UPLO = 'U':
*
*  On entry:                       On exit:
*
*      *    *   a13  a24  a35  a46      *    *   u13  u24  u35  u46
*      *   a12  a23  a34  a45  a56      *   u12  u23  u34  u45  u56
*     a11  a22  a33  a44  a55  a66     u11  u22  u33  u44  u55  u66
*
*  Similarly, if UPLO = 'L' the format of A is as follows:
*
*  On entry:                       On exit:
*
*     a11  a22  a33  a44  a55  a66     l11  l22  l33  l44  l55  l66
*     a21  a32  a43  a54  a65   *      l21  l32  l43  l54  l65   *
*     a31  a42  a53  a64   *    *      l31  l42  l53  l64   *    *
*
*  Array elements marked * are not used by the routine.
*
*  Contributed by
*  Peter Mayes and Giuseppe Radicati, IBM ECSEC, Rome, March 23, 1989
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ONE, ZERO
      PARAMETER          ( ONE = 1.0D+0, ZERO = 0.0D+0 )
      INTEGER            NBMAX, LDWORK
      PARAMETER          ( NBMAX = 32, LDWORK = NBMAX+1 )
*     ..
*     .. Local Scalars ..
      INTEGER            I, I2, I3, IB, II, J, JJ, NB
*     ..
*     .. Local Arrays ..
      DOUBLE PRECISION   WORK( LDWORK, NBMAX )
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            ILAENV
      EXTERNAL           LSAME, ILAENV
*     ..
*     .. External Subroutines ..
      EXTERNAL           DGEMM, DPBTF2, DPOTF2, DSYRK, DTRSM, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MIN
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      IF( ( .NOT.LSAME( UPLO, 'U' ) ) .AND.
     $    ( .NOT.LSAME( UPLO, 'L' ) ) ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( KD.LT.0 ) THEN
         INFO = -3
      ELSE IF( LDAB.LT.KD+1 ) THEN
         INFO = -5
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DPBTRF', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
*
*     Determine the block size for this environment
*
      NB = ILAENV( 1, 'DPBTRF', UPLO, N, KD, -1, -1 )
*
*     The block size must not exceed the semi-bandwidth KD, and must not
*     exceed the limit set by the size of the local array WORK.
*
      NB = MIN( NB, NBMAX )
*
      IF( NB.LE.1 .OR. NB.GT.KD ) THEN
*
*        Use unblocked code
*
         CALL DPBTF2( UPLO, N, KD, AB, LDAB, INFO )
      ELSE
*
*        Use blocked code
*
         IF( LSAME( UPLO, 'U' ) ) THEN
*
*           Compute the Cholesky factorization of a symmetric band
*           matrix, given the upper triangle of the matrix in band
*           storage.
*
*           Zero the upper triangle of the work array.
*
            DO 20 J = 1, NB
               DO 10 I = 1, J - 1
                  WORK( I, J ) = ZERO
   10          CONTINUE
   20       CONTINUE
*
*           Process the band matrix one diagonal block at a time.
*
            DO 70 I = 1, N, NB
               IB = MIN( NB, N-I+1 )
*
*              Factorize the diagonal block
*
               CALL DPOTF2( UPLO, IB, AB( KD+1, I ), LDAB-1, II )
               IF( II.NE.0 ) THEN
                  INFO = I + II - 1
                  GO TO 150
               END IF
               IF( I+IB.LE.N ) THEN
*
*                 Update the relevant part of the trailing submatrix.
*                 If A11 denotes the diagonal block which has just been
*                 factorized, then we need to update the remaining
*                 blocks in the diagram:
*
*                    A11   A12   A13
*                          A22   A23
*                                A33
*
*                 The numbers of rows and columns in the partitioning
*                 are IB, I2, I3 respectively. The blocks A12, A22 and
*                 A23 are empty if IB = KD. The upper triangle of A13
*                 lies outside the band.
*
                  I2 = MIN( KD-IB, N-I-IB+1 )
                  I3 = MIN( IB, N-I-KD+1 )
*
                  IF( I2.GT.0 ) THEN
*
*                    Update A12
*
                     CALL DTRSM( 'Left', 'Upper', 'Transpose',
     $                           'Non-unit', IB, I2, ONE, AB( KD+1, I ),
     $                           LDAB-1, AB( KD+1-IB, I+IB ), LDAB-1 )
*
*                    Update A22
*
                     CALL DSYRK( 'Upper', 'Transpose', I2, IB, -ONE,
     $                           AB( KD+1-IB, I+IB ), LDAB-1, ONE,
     $                           AB( KD+1, I+IB ), LDAB-1 )
                  END IF
*
                  IF( I3.GT.0 ) THEN
*
*                    Copy the lower triangle of A13 into the work array.
*
                     DO 40 JJ = 1, I3
                        DO 30 II = JJ, IB
                           WORK( II, JJ ) = AB( II-JJ+1, JJ+I+KD-1 )
   30                   CONTINUE
   40                CONTINUE
*
*                    Update A13 (in the work array).
*
                     CALL DTRSM( 'Left', 'Upper', 'Transpose',
     $                           'Non-unit', IB, I3, ONE, AB( KD+1, I ),
     $                           LDAB-1, WORK, LDWORK )
*
*                    Update A23
*
                     IF( I2.GT.0 )
     $                  CALL DGEMM( 'Transpose', 'No Transpose', I2, I3,
     $                              IB, -ONE, AB( KD+1-IB, I+IB ),
     $                              LDAB-1, WORK, LDWORK, ONE,
     $                              AB( 1+IB, I+KD ), LDAB-1 )
*
*                    Update A33
*
                     CALL DSYRK( 'Upper', 'Transpose', I3, IB, -ONE,
     $                           WORK, LDWORK, ONE, AB( KD+1, I+KD ),
     $                           LDAB-1 )
*
*                    Copy the lower triangle of A13 back into place.
*
                     DO 60 JJ = 1, I3
                        DO 50 II = JJ, IB
                           AB( II-JJ+1, JJ+I+KD-1 ) = WORK( II, JJ )
   50                   CONTINUE
   60                CONTINUE
                  END IF
               END IF
   70       CONTINUE
         ELSE
*
*           Compute the Cholesky factorization of a symmetric band
*           matrix, given the lower triangle of the matrix in band
*           storage.
*
*           Zero the lower triangle of the work array.
*
            DO 90 J = 1, NB
               DO 80 I = J + 1, NB
                  WORK( I, J ) = ZERO
   80          CONTINUE
   90       CONTINUE
*
*           Process the band matrix one diagonal block at a time.
*
            DO 140 I = 1, N, NB
               IB = MIN( NB, N-I+1 )
*
*              Factorize the diagonal block
*
               CALL DPOTF2( UPLO, IB, AB( 1, I ), LDAB-1, II )
               IF( II.NE.0 ) THEN
                  INFO = I + II - 1
                  GO TO 150
               END IF
               IF( I+IB.LE.N ) THEN
*
*                 Update the relevant part of the trailing submatrix.
*                 If A11 denotes the diagonal block which has just been
*                 factorized, then we need to update the remaining
*                 blocks in the diagram:
*
*                    A11
*                    A21   A22
*                    A31   A32   A33
*
*                 The numbers of rows and columns in the partitioning
*                 are IB, I2, I3 respectively. The blocks A21, A22 and
*                 A32 are empty if IB = KD. The lower triangle of A31
*                 lies outside the band.
*
                  I2 = MIN( KD-IB, N-I-IB+1 )
                  I3 = MIN( IB, N-I-KD+1 )
*
                  IF( I2.GT.0 ) THEN
*
*                    Update A21
*
                     CALL DTRSM( 'Right', 'Lower', 'Transpose',
     $                           'Non-unit', I2, IB, ONE, AB( 1, I ),
     $                           LDAB-1, AB( 1+IB, I ), LDAB-1 )
*
*                    Update A22
*
                     CALL DSYRK( 'Lower', 'No Transpose', I2, IB, -ONE,
     $                           AB( 1+IB, I ), LDAB-1, ONE,
     $                           AB( 1, I+IB ), LDAB-1 )
                  END IF
*
                  IF( I3.GT.0 ) THEN
*
*                    Copy the upper triangle of A31 into the work array.
*
                     DO 110 JJ = 1, IB
                        DO 100 II = 1, MIN( JJ, I3 )
                           WORK( II, JJ ) = AB( KD+1-JJ+II, JJ+I-1 )
  100                   CONTINUE
  110                CONTINUE
*
*                    Update A31 (in the work array).
*
                     CALL DTRSM( 'Right', 'Lower', 'Transpose',
     $                           'Non-unit', I3, IB, ONE, AB( 1, I ),
     $                           LDAB-1, WORK, LDWORK )
*
*                    Update A32
*
                     IF( I2.GT.0 )
     $                  CALL DGEMM( 'No transpose', 'Transpose', I3, I2,
     $                              IB, -ONE, WORK, LDWORK,
     $                              AB( 1+IB, I ), LDAB-1, ONE,
     $                              AB( 1+KD-IB, I+IB ), LDAB-1 )
*
*                    Update A33
*
                     CALL DSYRK( 'Lower', 'No Transpose', I3, IB, -ONE,
     $                           WORK, LDWORK, ONE, AB( 1, I+KD ),
     $                           LDAB-1 )
*
*                    Copy the upper triangle of A31 back into place.
*
                     DO 130 JJ = 1, IB
                        DO 120 II = 1, MIN( JJ, I3 )
                           AB( KD+1-JJ+II, JJ+I-1 ) = WORK( II, JJ )
  120                   CONTINUE
  130                CONTINUE
                  END IF
               END IF
  140       CONTINUE
         END IF
      END IF
      RETURN
*
  150 CONTINUE
      RETURN
*
*     End of DPBTRF
*
      END

c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by UCAR                 .
c  .                                                             .
c  .       University Corporation for Atmospheric Research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                         SPHEREPACK                       .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c
c
c ... file sfvpgc.f
c
c     this file includes documentation and code for
c     subroutine sfvpgc          i
c
c ... files which must be loaded with sfvpgc.f
c
c     sphcom.f, hrfft.f, vhagc.f, shsgc.f, gaqd.f
c
c
c     subroutine sfvpgc(nlat,nlon,isym,nt,sf,vp,idv,jdv,br,bi,cr,ci,
c    +                   mdb,ndb,wshsgc,lshsgc,work,lwork,ierror)
c
c     given the vector spherical harmonic coefficients br,bi,cr,ci,
c     computed by subroutine vhagc for a vector field (v,w), sfvpgc
c     computes a scalar stream function sf and scalar velocity potential
c     vp for (v,w).  (v,w) is expressed in terms of sf and vp by the
c     helmholtz relations (in mathematical spherical coordinates):
c
c          v = -1/sint*d(vp)/dlambda + d(st)/dtheta
c
c          w =  1/sint*d(st)/dlambda + d(vp)/dtheta
c
c     where sint = sin(theta).  w is the east longitudinal and v
c     is the colatitudinal component of the vector field from which
c     br,bi,cr,ci were precomputed.  required associated legendre
c     polynomials are recomputed rather than stored as they are in
c     subroutine sfvpgs. sf(i,j) and vp(i,j) are given at the i(th)
c     gaussian colatitude point theta(i) (see nlat description below)
c     and east longitude lambda(j) = (j-1)*2*pi/nlon on the sphere.
c
c     input parameters
c
c     nlat   the number of points in the gaussian colatitude grid on the
C*PL*ERROR* Comment line too long
c            full sphere. these lie in the interval (0,pi) and are computed
C*PL*ERROR* Comment line too long
c            in radians in theta(1) <...< theta(nlat) by subroutine gaqd.
C*PL*ERROR* Comment line too long
c            if nlat is odd the equator will be included as the grid point
c            theta((nlat+1)/2).  if nlat is even the equator will be
c            excluded as a grid point and will lie half way between
c            theta(nlat/2) and theta(nlat/2+1). nlat must be at least 3.
c            note: on the half sphere, the number of grid points in the
c            colatitudinal direction is nlat/2 if nlat is even or
c            (nlat+1)/2 if nlat is odd.
c
c     nlon   the number of distinct londitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater than
c            3.  the efficiency of the computation is improved when nlon
c            is a product of small prime numbers.
c
c
C*PL*ERROR* Comment line too long
c     isym   a parameter which determines whether the stream function and
c            velocity potential are computed on the full or half sphere
c            as follows:
c
c      = 0
c
c            the symmetries/antsymmetries described in isym=1,2 below
c            do not exist in (v,w) about the equator.  in this case st
c            and vp are not necessarily symmetric or antisymmetric about
c            the equator.  sf and vp are computed on the entire sphere.
c            i.e., in arrays sf(i,j),vp(i,j) for i=1,...,nlat and
c            j=1,...,nlon.
c
c      = 1
c
c            w is antisymmetric and v is symmetric about the equator.
c            in this case sf is symmetric and vp antisymmetric about
c            the equator and are computed for the northern hemisphere
C*PL*ERROR* Comment line too long
c            only.  i.e., if nlat is odd the sf(i,j),vp(i,j) are computed
c            for i=1,...,(nlat+1)/2 and for j=1,...,nlon.  if nlat is
c            even then sf(i,j),vp(i,j) are computed for i=1,...,nlat/2
c            and j=1,...,nlon.
c
c      = 2
c
c            w is symmetric and v is antisymmetric about the equator.
c            in this case sf is antisymmetric and vp symmetric about
c            the equator and are computed for the northern hemisphere
C*PL*ERROR* Comment line too long
c            only.  i.e., if nlat is odd the sf(i,j),vp(i,j) are computed
c            for i=1,...,(nlat+1)/2 and for j=1,...,nlon.  if nlat is
c            even then sf(i,j),vp(i,j) are computed for i=1,...,nlat/2
c            and j=1,...,nlon.
c
c     nt     nt is the number of scalar and vector fields.  some
C*PL*ERROR* Comment line too long
c            computational efficiency is obtained for multiple fields. arrays
C*PL*ERROR* Comment line too long
c            can be three dimensional corresponding to an indexed multiple
c            vector field.  in this case multiple scalar synthesis will
c            be performed to compute sf,vp for each field.  the
c            third index is the synthesis index which assumes the values
c            k=1,...,nt.  for a single synthesis set nt = 1.  the
c            description of the remaining parameters is simplified by
C*PL*ERROR* Comment line too long
c            assuming that nt=1 or that all the arrays are two dimensional.
c
c     idv    the first dimension of the arrays sf,vp as it appears in
c            the program that calls sfvpgc. if isym = 0 then idv
c            must be at least nlat.  if isym = 1 or 2 and nlat is
c            even then idv must be at least nlat/2. if isym = 1 or 2
c            and nlat is odd then idv must be at least (nlat+1)/2.
c
c     jdv    the second dimension of the arrays sf,vp as it appears in
c            the program that calls sfvpgc. jdv must be at least nlon.
c
c     br,bi, two or three dimensional arrays (see input parameter nt)
c     cr,ci  that contain vector spherical harmonic coefficients
c            of the vector field (v,w) as computed by subroutine vhagc.
c
c     mdb    the first dimension of the arrays br,bi,cr,ci as it
c            appears in the program that calls sfvpgc. mdb must be at
c            least min0(nlat,nlon/2) if nlon is even or at least
c            min0(nlat,(nlon+1)/2) if nlon is odd.
c
c     ndb    the second dimension of the arrays br,bi,cr,ci as it
c            appears in the program that calls sfvpgc. ndb must be at
c            least nlat.
c
c     wshsgc an array which must be initialized by subroutine shsgci.
c            once initialized, wshsgc can be used repeatedly by sfvpgc
c            as long as nlon and nlat remain unchanged.  wshsgc must
c            not bel altered between calls of sfvpgc.
c
c
c     lshsgc the dimension of the array wshsgc as it appears in the
c            program that calls sfvpgc. define
c
c               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            then lshsgc must be at least
c
c               nlat*(2*l2+3*l1-2)+3*l1*(1-l1)/2+nlon+15
c
c
c     work   a work array that does not have to be saved.
c
c     lwork  the dimension of the array work as it appears in the
c            program that calls sfvpgc. define
c
c               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2                    if nlat is even or
c               l2 = (nlat+1)/2                if nlat is odd
c
c            if isym is zero then lwork must be at least
c
c                nlat*((nt*nlon+max0(3*l2,nlon)) + 2*l1*nt+1)
c
c            if isym is not zero then lwork must be at least
c
c                l2*(nt*nlon+max0(3*nlat,nlon)) + nlat*(2*l1*nt+1)
c
c     **************************************************************
c
c     output parameters
c
c    sf,vp  two or three dimensional arrays (see input parameter nt)
c           that contains the stream function and velocity potential
c           of the vector field (v,w) whose coefficients br,bi,cr,ci
c           where precomputed by subroutine vhagc.  sf(i,j),vp(i,j)
c           are given at the i(th) gaussian colatitude point theta(i)
c           and longitude point lambda(j) = (j-1)*2*pi/nlon.  the index
c           ranges are defined above at the input parameter isym.
c
c
c    ierror = 0  no errors
c           = 1  error in the specification of nlat
c           = 2  error in the specification of nlon
c           = 3  error in the specification of isym
c           = 4  error in the specification of nt
c           = 5  error in the specification of idv
c           = 6  error in the specification of jdv
c           = 7  error in the specification of mdb
c           = 8  error in the specification of ndb
c           = 9  error in the specification of lshsgc
c           = 10 error in the specification of lwork
c **********************************************************************
c
      SUBROUTINE DSFVPGC(NLAT,NLON,ISYM,NT,SF,VP,IDV,JDV,BR,BI,CR,CI,
     +                   MDB,NDB,WSHSGC,LSHSGC,WORK,LWORK,IERROR)
      IMPLICIT NONE
      INTEGER NLAT,NLON,ISYM,NT,IDV,JDV,MDB,NDB,LSHSGC,LWORK,IERROR
      DOUBLE PRECISION SF(IDV,JDV,NT),VP(IDV,JDV,NT)
      DOUBLE PRECISION BR(MDB,NDB,NT),BI(MDB,NDB,NT)
      DOUBLE PRECISION CR(MDB,NDB,NT),CI(MDB,NDB,NT)
      DOUBLE PRECISION WSHSGC(LSHSGC),WORK(LWORK)
      INTEGER IMID,MMAX,LZZ1,LABC,LS,NLN,MAB,MN,IA,IB,IS,LWK,IWK,LWMIN
      INTEGER L1,L2
c
c     check input parameters
c
      IERROR = 1
      IF (NLAT.LT.3) RETURN
      IERROR = 2
      IF (NLON.LT.4) RETURN
      IERROR = 3
      IF (ISYM.LT.0 .OR. ISYM.GT.2) RETURN
      IERROR = 4
      IF (NT.LT.0) RETURN
      IERROR = 5
      IMID = (NLAT+1)/2
      IF ((ISYM.EQ.0.AND.IDV.LT.NLAT) .OR.
     +    (ISYM.GT.0.AND.IDV.LT.IMID)) RETURN
      IERROR = 6
      IF (JDV.LT.NLON) RETURN
      IERROR = 7
      MMAX = MIN0(NLAT, (NLON+2)/2)
      IF (MDB.LT.MIN0(NLAT, (NLON+1)/2)) RETURN
      IERROR = 8
      IF (NDB.LT.NLAT) RETURN
      IERROR = 9
c
c     verify saved work space (same as shsgc)
c
      IMID = (NLAT+1)/2
      LZZ1 = 2*NLAT*IMID
      LABC = 3* (MAX0(MMAX-2,0)* (NLAT+NLAT-MMAX-1))/2
      LWMIN = LZZ1 + LABC + NLON + 15
      L2 = (NLAT+1)/2
      L1 = MIN0((NLON+2)/2,NLAT)
      IF (LSHSGC.LT.NLAT* (2*L2+3*L1-2)+3*L1* (1-L1)/2+NLON+15) RETURN
c
c     verify unsaved work space (add to what shsgc requires)
c
      IERROR = 10
      LS = NLAT
      IF (ISYM.GT.0) LS = IMID
      NLN = NT*LS*NLON
c
c     set first dimension for a,b (as requried by shsgc)
c
      MAB = MIN0(NLAT,NLON/2+1)
      MN = MAB*NLAT*NT
      IF (LWORK.LT.NLN+MAX0(LS*NLON,3*NLAT*IMID)+2*MN+NLAT) RETURN
      IERROR = 0
c
c     set work space pointers
c
      IA = 1
      IB = IA + MN
      IS = IB + MN
      IWK = IS + NLAT
      LWK = LWORK - 2*MN - NLAT
      CALL DSFVPGC1(NLAT,NLON,ISYM,NT,SF,VP,IDV,JDV,BR,BI,CR,CI,MDB,NDB,
     +             WORK(IA),WORK(IB),MAB,WORK(IS),WSHSGC,LSHSGC,
     +             WORK(IWK),LWK,IERROR)
      RETURN
      END

      SUBROUTINE DSFVPGC1(NLAT,NLON,ISYM,NT,SF,VP,IDV,JDV,BR,BI,CR,CI,
     +                   MDB,NDB,A,B,MAB,FNN,WSHSGC,LSHSGC,WK,LWK,
     +                   IERROR)
      IMPLICIT NONE
      INTEGER NLAT,NLON,ISYM,NT,IDV,JDV,MDB,NDB,MAB,LSHSGC,LWK,IERROR
      DOUBLE PRECISION SF(IDV,JDV,NT),VP(IDV,JDV,NT)
      DOUBLE PRECISION BR(MDB,NDB,NT),BI(MDB,NDB,NT),CR(MDB,NDB,NT),
     +                 CI(MDB,NDB,NT)
      DOUBLE PRECISION A(MAB,NLAT,NT),B(MAB,NLAT,NT)
      DOUBLE PRECISION WSHSGC(LSHSGC),WK(LWK),FNN(NLAT)
      INTEGER N,M,MMAX,K
c
c     set coefficient multiplyers
c
      DO N = 2,NLAT
          FNN(N) = 1.0D0/SQRT(DBLE(N* (N-1)))
      END DO
      MMAX = MIN0(NLAT, (NLON+1)/2)
c
c     compute sf scalar coefficients from cr,ci
c
      DO K = 1,NT
          DO N = 1,NLAT
              DO M = 1,MAB
                  A(M,N,K) = 0.0D0
                  B(M,N,K) = 0.0D0
              END DO
          END DO
c
c     compute m=0 coefficients
c
          DO N = 2,NLAT
              A(1,N,K) = -FNN(N)*CR(1,N,K)
              B(1,N,K) = -FNN(N)*CI(1,N,K)
          END DO
c
c     compute m>0 coefficients using vector spherepack value for mmax
c
          DO M = 2,MMAX
              DO N = M,NLAT
                  A(M,N,K) = -FNN(N)*CR(M,N,K)
                  B(M,N,K) = -FNN(N)*CI(M,N,K)
              END DO
          END DO
      END DO
c
c     synthesize a,b into st
c
      CALL DSHSGC(NLAT,NLON,ISYM,NT,SF,IDV,JDV,A,B,MAB,NLAT,WSHSGC,
     +           LSHSGC,WK,LWK,IERROR)
c
c    set coefficients for vp from br,bi
c
      DO K = 1,NT
          DO N = 1,NLAT
              DO M = 1,MAB
                  A(M,N,K) = 0.0D0
                  B(M,N,K) = 0.0D0
              END DO
          END DO
c
c     compute m=0 coefficients
c
          DO N = 2,NLAT
              A(1,N,K) = FNN(N)*BR(1,N,K)
              B(1,N,K) = FNN(N)*BI(1,N,K)
          END DO
c
c     compute m>0 coefficients using vector spherepack value for mmax
c
          MMAX = MIN0(NLAT, (NLON+1)/2)
          DO M = 2,MMAX
              DO N = M,NLAT
                  A(M,N,K) = FNN(N)*BR(M,N,K)
                  B(M,N,K) = FNN(N)*BI(M,N,K)
              END DO
          END DO
      END DO
c
c     synthesize a,b into vp
c
      CALL DSHSGC(NLAT,NLON,ISYM,NT,VP,IDV,JDV,A,B,MAB,NLAT,WSHSGC,
     +           LSHSGC,WK,LWK,IERROR)
      RETURN
      END

      SUBROUTINE ZTRMM ( SIDE, UPLO, TRANSA, DIAG, M, N, ALPHA, A, LDA,
     $                   B, LDB )
*     .. Scalar Arguments ..
      CHARACTER*1        SIDE, UPLO, TRANSA, DIAG
      INTEGER            M, N, LDA, LDB
      COMPLEX*16         ALPHA
*     .. Array Arguments ..
      COMPLEX*16         A( LDA, * ), B( LDB, * )
*     ..
*
*  Purpose
*  =======
*
*  ZTRMM  performs one of the matrix-matrix operations
*
*     B := alpha*op( A )*B,   or   B := alpha*B*op( A )
*
*  where  alpha  is a scalar,  B  is an m by n matrix,  A  is a unit, or
*  non-unit,  upper or lower triangular matrix  and  op( A )  is one  of
*
*     op( A ) = A   or   op( A ) = A'   or   op( A ) = conjg( A' ).
*
*  Parameters
*  ==========
*
*  SIDE   - CHARACTER*1.
*           On entry,  SIDE specifies whether  op( A ) multiplies B from
*           the left or right as follows:
*
*              SIDE = 'L' or 'l'   B := alpha*op( A )*B.
*
*              SIDE = 'R' or 'r'   B := alpha*B*op( A ).
*
*           Unchanged on exit.
*
*  UPLO   - CHARACTER*1.
*           On entry, UPLO specifies whether the matrix A is an upper or
*           lower triangular matrix as follows:
*
*              UPLO = 'U' or 'u'   A is an upper triangular matrix.
*
*              UPLO = 'L' or 'l'   A is a lower triangular matrix.
*
*           Unchanged on exit.
*
*  TRANSA - CHARACTER*1.
*           On entry, TRANSA specifies the form of op( A ) to be used in
*           the matrix multiplication as follows:
*
*              TRANSA = 'N' or 'n'   op( A ) = A.
*
*              TRANSA = 'T' or 't'   op( A ) = A'.
*
*              TRANSA = 'C' or 'c'   op( A ) = conjg( A' ).
*
*           Unchanged on exit.
*
*  DIAG   - CHARACTER*1.
*           On entry, DIAG specifies whether or not A is unit triangular
*           as follows:
*
*              DIAG = 'U' or 'u'   A is assumed to be unit triangular.
*
*              DIAG = 'N' or 'n'   A is not assumed to be unit
*                                  triangular.
*
*           Unchanged on exit.
*
*  M      - INTEGER.
*           On entry, M specifies the number of rows of B. M must be at
*           least zero.
*           Unchanged on exit.
*
*  N      - INTEGER.
*           On entry, N specifies the number of columns of B.  N must be
*           at least zero.
*           Unchanged on exit.
*
*  ALPHA  - COMPLEX*16      .
*           On entry,  ALPHA specifies the scalar  alpha. When  alpha is
*           zero then  A is not referenced and  B need not be set before
*           entry.
*           Unchanged on exit.
*
*  A      - COMPLEX*16       array of DIMENSION ( LDA, k ), where k is m
*           when  SIDE = 'L' or 'l'  and is  n  when  SIDE = 'R' or 'r'.
*           Before entry  with  UPLO = 'U' or 'u',  the  leading  k by k
*           upper triangular part of the array  A must contain the upper
*           triangular matrix  and the strictly lower triangular part of
*           A is not referenced.
*           Before entry  with  UPLO = 'L' or 'l',  the  leading  k by k
*           lower triangular part of the array  A must contain the lower
*           triangular matrix  and the strictly upper triangular part of
*           A is not referenced.
*           Note that when  DIAG = 'U' or 'u',  the diagonal elements of
*           A  are not referenced either,  but are assumed to be  unity.
*           Unchanged on exit.
*
*  LDA    - INTEGER.
*           On entry, LDA specifies the first dimension of A as declared
*           in the calling (sub) program.  When  SIDE = 'L' or 'l'  then
*           LDA  must be at least  max( 1, m ),  when  SIDE = 'R' or 'r'
*           then LDA must be at least max( 1, n ).
*           Unchanged on exit.
*
*  B      - COMPLEX*16       array of DIMENSION ( LDB, n ).
*           Before entry,  the leading  m by n part of the array  B must
*           contain the matrix  B,  and  on exit  is overwritten  by the
*           transformed matrix.
*
*  LDB    - INTEGER.
*           On entry, LDB specifies the first dimension of B as declared
*           in  the  calling  (sub)  program.   LDB  must  be  at  least
*           max( 1, m ).
*           Unchanged on exit.
*
*
*  Level 3 Blas routine.
*
*  -- Written on 8-February-1989.
*     Jack Dongarra, Argonne National Laboratory.
*     Iain Duff, AERE Harwell.
*     Jeremy Du Croz, Numerical Algorithms Group Ltd.
*     Sven Hammarling, Numerical Algorithms Group Ltd.
*
*
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     .. External Subroutines ..
      EXTERNAL           XERBLA
*     .. Intrinsic Functions ..
      INTRINSIC          DCONJG, MAX
*     .. Local Scalars ..
      LOGICAL            LSIDE, NOCONJ, NOUNIT, UPPER
      INTEGER            I, INFO, J, K, NROWA
      COMPLEX*16         TEMP
*     .. Parameters ..
      COMPLEX*16         ONE
      PARAMETER        ( ONE  = ( 1.0D+0, 0.0D+0 ) )
      COMPLEX*16         ZERO
      PARAMETER        ( ZERO = ( 0.0D+0, 0.0D+0 ) )
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      LSIDE  = LSAME( SIDE  , 'L' )
      IF( LSIDE )THEN
         NROWA = M
      ELSE
         NROWA = N
      END IF
      NOCONJ = LSAME( TRANSA, 'T' )
      NOUNIT = LSAME( DIAG  , 'N' )
      UPPER  = LSAME( UPLO  , 'U' )
*
      INFO   = 0
      IF(      ( .NOT.LSIDE                ).AND.
     $         ( .NOT.LSAME( SIDE  , 'R' ) )      )THEN
         INFO = 1
      ELSE IF( ( .NOT.UPPER                ).AND.
     $         ( .NOT.LSAME( UPLO  , 'L' ) )      )THEN
         INFO = 2
      ELSE IF( ( .NOT.LSAME( TRANSA, 'N' ) ).AND.
     $         ( .NOT.LSAME( TRANSA, 'T' ) ).AND.
     $         ( .NOT.LSAME( TRANSA, 'C' ) )      )THEN
         INFO = 3
      ELSE IF( ( .NOT.LSAME( DIAG  , 'U' ) ).AND.
     $         ( .NOT.LSAME( DIAG  , 'N' ) )      )THEN
         INFO = 4
      ELSE IF( M  .LT.0               )THEN
         INFO = 5
      ELSE IF( N  .LT.0               )THEN
         INFO = 6
      ELSE IF( LDA.LT.MAX( 1, NROWA ) )THEN
         INFO = 9
      ELSE IF( LDB.LT.MAX( 1, M     ) )THEN
         INFO = 11
      END IF
      IF( INFO.NE.0 )THEN
         CALL XERBLA( 'ZTRMM ', INFO )
         RETURN
      END IF
*
*     Quick return if possible.
*
      IF( N.EQ.0 )
     $   RETURN
*
*     And when  alpha.eq.zero.
*
      IF( ALPHA.EQ.ZERO )THEN
         DO 20, J = 1, N
            DO 10, I = 1, M
               B( I, J ) = ZERO
   10       CONTINUE
   20    CONTINUE
         RETURN
      END IF
*
*     Start the operations.
*
      IF( LSIDE )THEN
         IF( LSAME( TRANSA, 'N' ) )THEN
*
*           Form  B := alpha*A*B.
*
            IF( UPPER )THEN
               DO 50, J = 1, N
                  DO 40, K = 1, M
                     IF( B( K, J ).NE.ZERO )THEN
                        TEMP = ALPHA*B( K, J )
                        DO 30, I = 1, K - 1
                           B( I, J ) = B( I, J ) + TEMP*A( I, K )
   30                   CONTINUE
                        IF( NOUNIT )
     $                     TEMP = TEMP*A( K, K )
                        B( K, J ) = TEMP
                     END IF
   40             CONTINUE
   50          CONTINUE
            ELSE
               DO 80, J = 1, N
                  DO 70 K = M, 1, -1
                     IF( B( K, J ).NE.ZERO )THEN
                        TEMP      = ALPHA*B( K, J )
                        B( K, J ) = TEMP
                        IF( NOUNIT )
     $                     B( K, J ) = B( K, J )*A( K, K )
                        DO 60, I = K + 1, M
                           B( I, J ) = B( I, J ) + TEMP*A( I, K )
   60                   CONTINUE
                     END IF
   70             CONTINUE
   80          CONTINUE
            END IF
         ELSE
*
*           Form  B := alpha*A'*B   or   B := alpha*conjg( A' )*B.
*
            IF( UPPER )THEN
               DO 120, J = 1, N
                  DO 110, I = M, 1, -1
                     TEMP = B( I, J )
                     IF( NOCONJ )THEN
                        IF( NOUNIT )
     $                     TEMP = TEMP*A( I, I )
                        DO 90, K = 1, I - 1
                           TEMP = TEMP + A( K, I )*B( K, J )
   90                   CONTINUE
                     ELSE
                        IF( NOUNIT )
     $                     TEMP = TEMP*DCONJG( A( I, I ) )
                        DO 100, K = 1, I - 1
                           TEMP = TEMP + DCONJG( A( K, I ) )*B( K, J )
  100                   CONTINUE
                     END IF
                     B( I, J ) = ALPHA*TEMP
  110             CONTINUE
  120          CONTINUE
            ELSE
               DO 160, J = 1, N
                  DO 150, I = 1, M
                     TEMP = B( I, J )
                     IF( NOCONJ )THEN
                        IF( NOUNIT )
     $                     TEMP = TEMP*A( I, I )
                        DO 130, K = I + 1, M
                           TEMP = TEMP + A( K, I )*B( K, J )
  130                   CONTINUE
                     ELSE
                        IF( NOUNIT )
     $                     TEMP = TEMP*DCONJG( A( I, I ) )
                        DO 140, K = I + 1, M
                           TEMP = TEMP + DCONJG( A( K, I ) )*B( K, J )
  140                   CONTINUE
                     END IF
                     B( I, J ) = ALPHA*TEMP
  150             CONTINUE
  160          CONTINUE
            END IF
         END IF
      ELSE
         IF( LSAME( TRANSA, 'N' ) )THEN
*
*           Form  B := alpha*B*A.
*
            IF( UPPER )THEN
               DO 200, J = N, 1, -1
                  TEMP = ALPHA
                  IF( NOUNIT )
     $               TEMP = TEMP*A( J, J )
                  DO 170, I = 1, M
                     B( I, J ) = TEMP*B( I, J )
  170             CONTINUE
                  DO 190, K = 1, J - 1
                     IF( A( K, J ).NE.ZERO )THEN
                        TEMP = ALPHA*A( K, J )
                        DO 180, I = 1, M
                           B( I, J ) = B( I, J ) + TEMP*B( I, K )
  180                   CONTINUE
                     END IF
  190             CONTINUE
  200          CONTINUE
            ELSE
               DO 240, J = 1, N
                  TEMP = ALPHA
                  IF( NOUNIT )
     $               TEMP = TEMP*A( J, J )
                  DO 210, I = 1, M
                     B( I, J ) = TEMP*B( I, J )
  210             CONTINUE
                  DO 230, K = J + 1, N
                     IF( A( K, J ).NE.ZERO )THEN
                        TEMP = ALPHA*A( K, J )
                        DO 220, I = 1, M
                           B( I, J ) = B( I, J ) + TEMP*B( I, K )
  220                   CONTINUE
                     END IF
  230             CONTINUE
  240          CONTINUE
            END IF
         ELSE
*
*           Form  B := alpha*B*A'   or   B := alpha*B*conjg( A' ).
*
            IF( UPPER )THEN
               DO 280, K = 1, N
                  DO 260, J = 1, K - 1
                     IF( A( J, K ).NE.ZERO )THEN
                        IF( NOCONJ )THEN
                           TEMP = ALPHA*A( J, K )
                        ELSE
                           TEMP = ALPHA*DCONJG( A( J, K ) )
                        END IF
                        DO 250, I = 1, M
                           B( I, J ) = B( I, J ) + TEMP*B( I, K )
  250                   CONTINUE
                     END IF
  260             CONTINUE
                  TEMP = ALPHA
                  IF( NOUNIT )THEN
                     IF( NOCONJ )THEN
                        TEMP = TEMP*A( K, K )
                     ELSE
                        TEMP = TEMP*DCONJG( A( K, K ) )
                     END IF
                  END IF
                  IF( TEMP.NE.ONE )THEN
                     DO 270, I = 1, M
                        B( I, K ) = TEMP*B( I, K )
  270                CONTINUE
                  END IF
  280          CONTINUE
            ELSE
               DO 320, K = N, 1, -1
                  DO 300, J = K + 1, N
                     IF( A( J, K ).NE.ZERO )THEN
                        IF( NOCONJ )THEN
                           TEMP = ALPHA*A( J, K )
                        ELSE
                           TEMP = ALPHA*DCONJG( A( J, K ) )
                        END IF
                        DO 290, I = 1, M
                           B( I, J ) = B( I, J ) + TEMP*B( I, K )
  290                   CONTINUE
                     END IF
  300             CONTINUE
                  TEMP = ALPHA
                  IF( NOUNIT )THEN
                     IF( NOCONJ )THEN
                        TEMP = TEMP*A( K, K )
                     ELSE
                        TEMP = TEMP*DCONJG( A( K, K ) )
                     END IF
                  END IF
                  IF( TEMP.NE.ONE )THEN
                     DO 310, I = 1, M
                        B( I, K ) = TEMP*B( I, K )
  310                CONTINUE
                  END IF
  320          CONTINUE
            END IF
         END IF
      END IF
*
      RETURN
*
*     End of ZTRMM .
*
      END

C--------------------------------------------------------------
C All the routines in this file were updated on 9 Feb 2015 to 
C reverse the dimensions of "clcntr"/"c" (from "k x n" to 
C "n x k") so that the calling C routine could have the 
C dimensions be K x N.
C--------------------------------------------------------------
C NCLFORTSTART
      subroutine kmns136 (dat, m, n, clcntr, k,  ic1, nc
     +                   ,iter, iseed, wss, ier)
      implicit none
c                            ! INPUT
      integer m, n, k, iter, iseed
      double precision dat(m,n)
c                            ! INPUT/OUTPUT
      integer ic1(m), nc(k), ier
      double precision clcntr(n,k), wss(k)
C NCLEND
c                            ! LOCAL WORK ARRAYS
      integer          ic2(m), ncp(k), itran(k), live(k)
      double precision an1(k), an2(k), d(m)
      integer nv, kk, mm

c Currently: two methods to set the seed
c . iseed=1 pick 1st k elements of the dat array
c . iseed=2 'randomly' sample the dat array

      do kk=1,k
         if (iseed.eq.1) then
             mm = kk
         else
             mm = m/kk
         end if
        do nv=1,n
           clcntr(nv,kk) = dat(mm,nv)
c c c      print *,"mm=", mm," kk=",kk,"  nv=",nv," clc=",clcntr(kk,nv) 
        end do
      end do

      call kmns (dat,m,n,clcntr,k,ic1,ic2,nc,an1,an2,ncp,d
     &          ,itran,live,iter,wss,ier )

      return
      end

c*********************************************************************72
      subroutine kmns ( a, m, n, c, k, ic1, ic2, nc, an1, an2, ncp, d
     &                ,itran, live, iter, wss, ifault )
c
cc KMNS carries out the K-means algorithm.
c
c  Discussion:
c
c    This routine attempts to divide M points in N-dimensional space into
c    K clusters so that the within cluster sum of squares is minimized.
c
c  Modified:
c
c    13 February 2008
c
c  Author:
c
c    Original FORTRAN77 version by John Hartigan, Manchek Wong.
c    Modifications by John Burkardt.
c
c  Reference:
c
c    John Hartigan, Manchek Wong,
c    Algorithm AS 136:
c    A K-Means Clustering Algorithm,
c    Applied Statistics,
c    Volume 28, Number 1, 1979, pages 100-108.
c
c  Parameters:
c
c    Input, double precision A(M,N), the points.
c
c    Input, integer M, the number of points.
c
c    Input, integer N, the number of spatial dimensions (aka, variables).
c
c    Input/output, double precision C(N,K), the cluster centers.
c
c    Input, integer K, the number of clusters.
c
c    Output, integer IC1(M), the cluster to which each point is assigned.
c
c    Workspace, integer IC2(M), used to store the cluster which each point
c    is most likely to be transferred to at each step.
c
c    Output, integer NC(K), the number of points in each cluster.
c
c    Workspace, double precision AN1(K).
c
c    Workspace, double precision AN2(K).
c
c    Workspace, integer NCP(K).
c
c    Workspace, double precision D(M).
c
c    Workspace, integer ITRAN(K).
c
c    Workspace, integer LIVE(K).
c
c    Input, integer ITER, the maximum number of iterations allowed.
c
c    Output, double precision WSS(K), the within-cluster sum of squares
c    of each cluster.
c
c    Output, integer IFAULT, error indicator.
c    0, no error was detected.
c    1, at least one cluster is empty after the initial assignment.  
c       A better set of initial cluster centers is needed.
c    2, the allowed maximum number off iterations was exceeded.
c    3, K is less than or equal to 1, or greater than or equal to M.
c
      implicit none

      integer k
      integer m
      integer n

      double precision a(m,n)
      double precision aa
      double precision an1(k)
      double precision an2(k)
      double precision c(n,k)
      double precision d(m)
      double precision da
      double precision db
      double precision dc
      double precision dt(2)
      integer i
      integer ic1(m)
      integer ic2(m)
      integer ifault
      integer ii
      integer ij
      integer il
      integer indx
      integer iter
      integer itran(k)
      integer j
      integer l
      integer live(k)
      integer nc(k)
      integer ncp(k)
      double precision r8_huge
      double precision temp
      double precision wss(k)

      ifault = 0

      if ( k .le. 1 .or. m .le. k ) then
        ifault = 3
        return
      end if
c
c  For each point I, find its two closest centers, IC1(I) and
c  IC2(I).  Assign the point to IC1(I).
c
      do i = 1, m

        ic1(i) = 1
        ic2(i) = 2

        do il = 1, 2
          dt(il) = 0.0D+00
          do j = 1, n
            da = a(i,j) - c(j,il)
            dt(il) = dt(il) + da * da
          end do
        end do

        if ( dt(2) .lt. dt(1) ) then
          ic1(i) = 2
          ic2(i) = 1
          temp = dt(1)
          dt(1) = dt(2)
          dt(2) = temp
        end if

        do l = 3, k

          db = 0.0D+00

          do j = 1, n
            dc = a(i,j) - c(j,l)
            db = db + dc * dc
          end do

          if ( db .lt. dt(2) ) then

            if ( dt(1) .le. db ) then
              dt(2) = db
              ic2(i) = l
            else
              dt(2) = dt(1)
              ic2(i) = ic1(i)
              dt(1) = db
              ic1(i) = l
            end if

          end if

        end do

      end do
c
c  Update cluster centers to be the average of points contained within them.
c
      do l = 1, k
        nc(l) = 0
        do j = 1, n
          c(j,l) = 0.0D+00
        end do
      end do

      do i = 1, m
        l = ic1(i)
        nc(l) = nc(l) + 1
        do j = 1, n
          c(j,l) = c(j,l) + a(i,j)
        end do
      end do
c
c  Check to see if there is any empty cluster at this stage.
c
      ifault = 1

      do l = 1, k

        if ( nc(l) .eq. 0 ) then
          ifault = 1
          return
        end if

      end do

      ifault = 0

      do l = 1, k

        aa = dble ( nc(l) )

        do j = 1, n
          c(j,l) = c(j,l) / aa
        end do
c
c  Initialize AN1, AN2, ITRAN and NCP.
c
c  AN1(L) = NC(L) / (NC(L) - 1)
c  AN2(L) = NC(L) / (NC(L) + 1)
c  ITRAN(L) = 1 if cluster L is updated in the quick-transfer stage,
c           = 0 otherwise
c
c  In the optimal-transfer stage, NCP(L) stores the step at which
c  cluster L is last updated.
c
c  In the quick-transfer stage, NCP(L) stores the step at which
c  cluster L is last updated plus M.
c
        an2(l) = aa / ( aa + 1.0D+00 )

        if ( 1.0D+00 .lt. aa ) then
          an1(l) = aa / ( aa - 1.0D+00 )
        else
          an1(l) = r8_huge ( )
        end if

        itran(l) = 1
        ncp(l) = -1

      end do

      indx = 0
      ifault = 2

      do ij = 1, iter
c
c  In this stage, there is only one pass through the data.   Each
c  point is re-allocated, if necessary, to the cluster that will
c  induce the maximum reduction in within-cluster sum of squares.
c
        call optra ( a, m, n, c, k, ic1, ic2, nc, an1, an2, ncp, d,
     &    itran, live, indx )
c
c  Stop if no transfer took place in the last M optimal transfer steps.
c
        if ( indx .eq. m ) then
          ifault = 0
          go to 150
        end if
c
c  Each point is tested in turn to see if it should be re-allocated
c  to the cluster to which it is most likely to be transferred,
c  IC2(I), from its present cluster, IC1(I).   Loop through the
c  data until no further change is to take place.
c
        call qtran ( a, m, n, c, k, ic1, ic2, nc, an1, an2, ncp, d,
     &    itran, indx )
c
c  If there are only two clusters, there is no need to re-enter the
c  optimal transfer stage.
c
        if ( k .eq. 2 ) then
          ifault = 0
          go to 150
        end if
c
c  NCP has to be set to 0 before entering OPTRA.
c
        do l = 1, k
          ncp(l) = 0
        end do

      end do

  150 continue
c
c  If the maximum number of iterations was taken without convergence,
c  IFAULT is 2 now.  This may indicate unforeseen looping.
c
      if ( ifault == 2 ) then
        write ( *, '(a)' ) ' '
        write ( *, '(a)' ) 'KMNS - Warning!'
        write ( *, '(a)' ) '  Maximum number of iterations reached'
        write ( *, '(a)' ) '  without convergence.'
      end if
c
c  Compute the within-cluster sum of squares for each cluster.
c
      do l = 1, k
        wss(l) = 0.0D+00
        do j = 1, n
          c(j,l) = 0.0D+00
        end do
      end do

      do i = 1, m
        ii = ic1(i)
        do j = 1, n
          c(j,ii) = c(j,ii) + a(i,j)
        end do
      end do

      do j = 1, n
        do l = 1, k
          c(j,l) = c(j,l) / dble ( nc(l) )
        end do
        do i = 1, m
          ii = ic1(i)
          da = a(i,j) - c(j,ii)
          wss(ii) = wss(ii) + da * da
        end do
      end do

      return
      end
      subroutine optra ( a, m, n, c, k, ic1, ic2, nc, an1, an2, ncp,
     &  d, itran, live, indx )

c*********************************************************************72
c
cc OPTRA carries out the optimal transfer stage.
c
c  Discussion:
c
c    This is the optimal transfer stage.
c
c    Each point is re-allocated, if necessary, to the cluster that
c    will induce a maximum reduction in the within-cluster sum of
c    squares.
c
c  Modified:
c
c    15 February 2008
c
c  Author:
c
c    Original FORTRAN77 version by John Hartigan, Manchek Wong.
c    Modifications by John Burkardt.
c
c  Reference:
c
c    John Hartigan, Manchek Wong,
c    Algorithm AS 136:
c    A K-Means Clustering Algorithm,
c    Applied Statistics,
c    Volume 28, Number 1, 1979, pages 100-108.
c
c  Parameters:
c
c    Input, double precision A(M,N), the points.
c
c    Input, integer M, the number of points.
c
c    Input, integer N, the number of spatial dimensions.
c
c    Input/output, double precision C(N,K), the cluster centers.
c
c    Input, integer K, the number of clusters.
c
c    Input/output, integer IC1(M), the cluster to which each point is assigned.
c
c    Input/output, integer IC2(M), used to store the cluster which each point
c    is most likely to be transferred to at each step.
c
c    Input/output, integer NC(K), the number of points in each cluster.
c
c    Input/output, double precision AN1(K).
c
c    Input/output, double precision AN2(K).
c
c    Input/output, integer NCP(K).
c
c    Input/output, double precision D(M).
c
c    Input/output, integer ITRAN(K).
c
c    Input/output, integer LIVE(K).
c
c    Input/output, integer INDX, the number of steps since a transfer took place.
c
      implicit none

      integer k
      integer m
      integer n

      double precision a(m,n)
      double precision al1
      double precision al2
      double precision alt
      double precision alw
      double precision an1(k)
      double precision an2(k)
      double precision c(n,k)
      double precision d(m)
      double precision da
      double precision db
      double precision dc
      double precision dd
      double precision de
      double precision df
      integer i
      integer ic1(m)
      integer ic2(m)
      integer indx
      integer itran(k)
      integer j
      integer l
      integer l1
      integer l2
      integer live(k)
      integer ll
      integer nc(k)
      integer ncp(k)
      double precision r2
      double precision r8_huge
      double precision rr
c
c  If cluster L is updated in the last quick-transfer stage, it
c  belongs to the live set throughout this stage.   Otherwise, at
c  each step, it is not in the live set if it has not been updated
c  in the last M optimal transfer steps.
c
      do l = 1, k
        if ( itran(l) .eq. 1) then
          live(l) = m + 1
        end if
      end do

      do i = 1, m

        indx = indx + 1
        l1 = ic1(i)
        l2 = ic2(i)
        ll = l2
c
c  If point I is the only member of cluster L1, no transfer.
c
        if ( 1 .lt. nc(l1)  ) then
c
c  If L1 has not yet been updated in this stage, no need to
c  re-compute D(I).
c
          if ( ncp(l1) .ne. 0 ) then
            de = 0.0D+00
            do j = 1, n
              df = a(i,j) - c(j,l1)
              de = de + df * df
            end do
            d(i) = de * an1(l1)
          end if
c
c  Find the cluster with minimum R2.
c
         da = 0.0D+00
          do j = 1, n
            db = a(i,j) - c(j,l2)
            da = da + db * db
          end do
          r2 = da * an2(l2)

          do l = 1, k
c
c  If LIVE(L1) <= I, then L1 is not in the live set.   If this is
c  true, we only need to consider clusters that are in the live set
c  for possible transfer of point I.   Otherwise, we need to consider
c  all possible clusters.
c
            if ( ( i .lt. live(l1) .or. i .lt. live(l2) ) .and.
     &             l .ne. l1 .and. l .ne. ll ) then

              rr = r2 / an2(l)

              dc = 0.0D+00
              do j = 1, n
                dd = a(i,j) - c(j,l)
                dc = dc + dd * dd
              end do

              if ( dc .lt. rr ) then
                r2 = dc * an2(l)
                l2 = l
              end if

            end if

          end do
c
c  If no transfer is necessary, L2 is the new IC2(I).
c
          if ( d(i) .le. r2 ) then

            ic2(i) = l2
c
c  Update cluster centers, LIVE, NCP, AN1 and AN2 for clusters L1 and
c  L2, and update IC1(I) and IC2(I).
c
          else

            indx = 0
            live(l1) = m + i
            live(l2) = m + i
            ncp(l1) = i
            ncp(l2) = i
            al1 = nc(l1)
            alw = al1 - 1.0D+00
            al2 = nc(l2)
            alt = al2 + 1.0D+00
            do j = 1, n
              c(j,l1) = ( c(j,l1) * al1 - a(i,j) ) / alw
              c(j,l2) = ( c(j,l2) * al2 + a(i,j) ) / alt
            end do
            nc(l1) = nc(l1) - 1
            nc(l2) = nc(l2) + 1
            an2(l1) = alw / al1
            if ( 1.0D+00 .lt. alw ) then
              an1(l1) = alw / ( alw - 1.0D+00 )
            else
              an1(l1) = r8_huge ( )
            end if
            an1(l2) = alt / al2
            an2(l2) = alt / ( alt + 1.0D+00 )
            ic1(i) = l2
            ic2(i) = l1

          end if

        end if

        if ( indx .eq. m ) then
          return
        end if

      end do
c
c  ITRAN(L) = 0 before entering QTRAN.   Also, LIVE(L) has to be
c  decreased by M before re-entering OPTRA.
c
      do l = 1, k
        itran(l) = 0
        live(l) = live(l) - m
      end do

      return
      end
      subroutine qtran ( a, m, n, c, k, ic1, ic2, nc, an1, an2, ncp,
     &  d, itran, indx )

c*********************************************************************72
c
cc QTRAN carries out the quick transfer stage.
c
c  Discussion:
c
c    This is the quick transfer stage.
c
c    IC1(I) is the cluster which point I belongs to.
c    IC2(I) is the cluster which point I is most likely to be
c    transferred to.
c
c    For each point I, IC1(I) and IC2(I) are switched, if necessary, to
c    reduce within-cluster sum of squares.  The cluster centers are
c    updated after each step.
c
c  Modified:
c
c    15 February 2008
c
c  Author:
c
c    Original FORTRAN77 version by John Hartigan, Manchek Wong.
c    Modifications by John Burkardt.
c
c  Reference:
c
c    John Hartigan, Manchek Wong,
c    Algorithm AS 136:
c    A K-Means Clustering Algorithm,
c    Applied Statistics,
c    Volume 28, Number 1, 1979, pages 100-108.
c
c  Parameters:
c
c    Input, double precision A(M,N), the points.
c
c    Input, integer M, the number of points.
c
c    Input, integer N, the number of spatial dimensions.
c
c    Input/output, double precision C(N,K), the cluster centers.
c
c    Input, integer K, the number of clusters.
c
c    Input/output, integer IC1(M), the cluster to which each point is assigned.
c
c    Input/output, integer IC2(M), used to store the cluster which each point
c    is most likely to be transferred to at each step.
c
c    Input/output, integer NC(K), the number of points in each cluster.
c
c    Input/output, double precision AN1(K).
c
c    Input/output, double precision AN2(K).
c
c    Input/output, integer NCP(K).
c
c    Input/output, double precision D(M).
c
c    Input/output, integer ITRAN(K).
c
c    Input/output, integer INDX, counts the number of steps since the
c    last transfer.
c
      implicit none

      integer k
      integer m
      integer n

      double precision a(m,n)
      double precision al1
      double precision al2
      double precision alt
      double precision alw
      double precision an1(k)
      double precision an2(k)
      double precision c(n,k)
      double precision d(m)
      double precision da
      double precision db
      double precision dd
      double precision de
      integer i
      integer ic1(m)
      integer ic2(m)
      integer icoun
      integer indx
      integer istep
      integer itran(k)
      integer j
      integer l1
      integer l2
      integer nc(k)
      integer ncp(k)
      double precision r2
      double precision r8_huge
c
c  In the optimal transfer stage, NCP(L) indicates the step at which
c  cluster L is last updated.   In the quick transfer stage, NCP(L)
c  is equal to the step at which cluster L is last updated plus M.
c
      icoun = 0
      istep = 0

   10 continue

        do i = 1, m

          icoun = icoun + 1
          istep = istep + 1
          l1 = ic1(i)
          l2 = ic2(i)
c
c  If point I is the only member of cluster L1, no transfer.
c
          if ( 1 .lt. nc(l1) ) then
c
c  If NCP(L1) < ISTEP, no need to re-compute distance from point I to
c  cluster L1.   Note that if cluster L1 is last updated exactly M
c  steps ago, we still need to compute the distance from point I to
c  cluster L1.
c
            if ( istep .le. ncp(l1) ) then

              da = 0.0D+00
              do j = 1, n
                db = a(i,j) - c(j,l1)
                da = da + db * db
              end do

              d(i) = da * an1(l1)

            end if
c
c  If NCP(L1) <= ISTEP and NCP(L2) <= ISTEP, there will be no transfer of
c  point I at this step.
c
            if ( istep .lt. ncp(l1) .or. istep .lt. ncp(l2) ) then

              r2 = d(i) / an2(l2)

              dd = 0.0D+00
              do j = 1, n
                de = a(i,j) - c(j,l2)
                dd = dd + de * de
              end do
c
c  Update cluster centers, NCP, NC, ITRAN, AN1 and AN2 for clusters
c  L1 and L2.   Also update IC1(I) and IC2(I).   Note that if any
c  updating occurs in this stage, INDX is set back to 0.
c
              if ( dd .lt. r2 ) then

                icoun = 0
                indx = 0
                itran(l1) = 1
                itran(l2) = 1
                ncp(l1) = istep + m
                ncp(l2) = istep + m
                al1 = nc(l1)
                alw = al1 - 1.0D+00
                al2 = nc(l2)
                alt = al2 + 1.0D+00
                do j = 1, n
                  c(j,l1) = ( c(j,l1) * al1 - a(i,j) ) / alw
                  c(j,l2) = ( c(j,l2) * al2 + a(i,j) ) / alt
                end do
                nc(l1) = nc(l1) - 1
                nc(l2) = nc(l2) + 1
                an2(l1) = alw / al1
                if ( 1.0D+00 .lt. alw ) then
                  an1(l1) = alw / ( alw - 1.0D+00 )
                else
                  an1(l1) = r8_huge ( )
                end if
                an1(l2) = alt / al2
                an2(l2) = alt / ( alt + 1.0D+00 )
                ic1(i) = l2
                ic2(i) = l1

              end if

            end if

          end if
c
c  If no re-allocation took place in the last M steps, return.
c
          if ( icoun .eq. m ) then
            return
          end if

        end do

      go to 10
      end
      function r8_huge ( )

c*********************************************************************72
c
cc R8_HUGE returns a "huge" R8.
c
c  Modified:
c
c    13 April 2004
c
c  Author:
c
c    John Burkardt
c
c  Parameters:
c
c    Output, double precision R8_HUGE, a huge number.
c
      implicit none

      double precision r8_huge

      r8_huge = 1.0D+30

      return
      end

      PROGRAM CCPNCLS
C 
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER (M=40,N=40,LRWK=1000,LIWK=1000)
      REAL Z(M,N), RWRK(LRWK)
      INTEGER IWRK(LIWK)
      
      CALL GETDAT (Z, M, N) 
C
C Open GKS
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Make Conpack draw exactly 10 equally spaced contour levels
C
      CALL CPSETI ('CLS - CONTOUR LEVEL SELECTION FLAG',-10)
C
C Initialize Conpack
C
      CALL CPRECT (Z, M, M, N, RWRK, LRWK, IWRK, LIWK)
C
C Draw perimeter
C
      CALL CPBACK (Z, RWRK, IWRK)
C
C Draw Contours
C
      CALL CPCLDR (Z, RWRK, IWRK)
C
C Close frame and close GKS
C
      CALL FRAME
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      
      STOP
      END
      
      SUBROUTINE GETDAT (Z, M, N)
      INTEGER I,J,M,N
      REAL Z(M,N)
      
      DO 10, I=1,M
         DO 20, J=1,N
            Z(I,J)= 10E-5*(-16.*REAL(I**2*J) +
     +           34*REAL(I*J**2) - REAL(6*I) + 93.)
 20      CONTINUE
 10   CONTINUE
      
      RETURN
      END
      
      

C
C $Id: mappos.f,v 1.17 2008-09-18 00:42:16 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MAPPOS (ARG1,ARG2,ARG3,ARG4)
        REAL ARG1,ARG2,ARG3,ARG4
        IF (ICFELL('MAPPOS - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
        CALL MDPPOS (DBLE(ARG1),DBLE(ARG2),DBLE(ARG3),DBLE(ARG4))
        IF (ICFELL('MAPPOS',2).NE.0) RETURN
        RETURN
      END

      SUBROUTINE ZLAED0( QSIZ, N, D, E, Q, LDQ, QSTORE, LDQS, RWORK,
     $                   IWORK, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      INTEGER            INFO, LDQ, LDQS, N, QSIZ
*     ..
*     .. Array Arguments ..
      INTEGER            IWORK( * )
      DOUBLE PRECISION   D( * ), E( * ), RWORK( * )
      COMPLEX*16         Q( LDQ, * ), QSTORE( LDQS, * )
*     ..
*
*  Purpose
*  =======
*
*  Using the divide and conquer method, ZLAED0 computes all eigenvalues
*  of a symmetric tridiagonal matrix which is one diagonal block of
*  those from reducing a dense or band Hermitian matrix and
*  corresponding eigenvectors of the dense or band matrix.
*
*  Arguments
*  =========
*
*  QSIZ   (input) INTEGER
*         The dimension of the unitary matrix used to reduce
*         the full matrix to tridiagonal form.  QSIZ >= N if ICOMPQ = 1.
*
*  N      (input) INTEGER
*         The dimension of the symmetric tridiagonal matrix.  N >= 0.
*
*  D      (input/output) DOUBLE PRECISION array, dimension (N)
*         On entry, the diagonal elements of the tridiagonal matrix.
*         On exit, the eigenvalues in ascending order.
*
*  E      (input/output) DOUBLE PRECISION array, dimension (N-1)
*         On entry, the off-diagonal elements of the tridiagonal matrix.
*         On exit, E has been destroyed.
*
*  Q      (input/output) COMPLEX*16 array, dimension (LDQ,N)
*         On entry, Q must contain an QSIZ x N matrix whose columns
*         unitarily orthonormal. It is a part of the unitary matrix
*         that reduces the full dense Hermitian matrix to a
*         (reducible) symmetric tridiagonal matrix.
*
*  LDQ    (input) INTEGER
*         The leading dimension of the array Q.  LDQ >= max(1,N).
*
*  IWORK  (workspace) INTEGER array,
*         the dimension of IWORK must be at least
*                      6 + 6*N + 5*N*lg N
*                      ( lg( N ) = smallest integer k
*                                  such that 2^k >= N )
*
*  RWORK  (workspace) DOUBLE PRECISION array,
*                               dimension (1 + 3*N + 2*N*lg N + 3*N**2)
*                        ( lg( N ) = smallest integer k
*                                    such that 2^k >= N )
*
*  QSTORE (workspace) COMPLEX*16 array, dimension (LDQS, N)
*         Used to store parts of
*         the eigenvector matrix when the updating matrix multiplies
*         take place.
*
*  LDQS   (input) INTEGER
*         The leading dimension of the array QSTORE.
*         LDQS >= max(1,N).
*
*  INFO   (output) INTEGER
*          = 0:  successful exit.
*          < 0:  if INFO = -i, the i-th argument had an illegal value.
*          > 0:  The algorithm failed to compute an eigenvalue while
*                working on the submatrix lying in rows and columns
*                INFO/(N+1) through mod(INFO,N+1).
*
*  =====================================================================
*
*  Warning:      N could be as big as QSIZ!
*
*     .. Parameters ..
      DOUBLE PRECISION   TWO
      PARAMETER          ( TWO = 2.D+0 )
*     ..
*     .. Local Scalars ..
      INTEGER            CURLVL, CURPRB, CURR, I, IGIVCL, IGIVNM,
     $                   IGIVPT, INDXQ, IPERM, IPRMPT, IQ, IQPTR, IWREM,
     $                   J, K, LGN, LL, MATSIZ, MSD2, SMLSIZ, SMM1,
     $                   SPM1, SPM2, SUBMAT, SUBPBS, TLVLS
      DOUBLE PRECISION   TEMP
*     ..
*     .. External Subroutines ..
      EXTERNAL           DCOPY, DSTEQR, XERBLA, ZCOPY, ZLACRM, ZLAED7
*     ..
*     .. External Functions ..
      INTEGER            ILAENV
      EXTERNAL           ILAENV
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, DBLE, INT, LOG, MAX
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
*
*     IF( ICOMPQ .LT. 0 .OR. ICOMPQ .GT. 2 ) THEN
*        INFO = -1
*     ELSE IF( ( ICOMPQ .EQ. 1 ) .AND. ( QSIZ .LT. MAX( 0, N ) ) )
*    $        THEN
      IF( QSIZ.LT.MAX( 0, N ) ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( LDQ.LT.MAX( 1, N ) ) THEN
         INFO = -6
      ELSE IF( LDQS.LT.MAX( 1, N ) ) THEN
         INFO = -8
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'ZLAED0', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
*
      SMLSIZ = ILAENV( 9, 'ZLAED0', ' ', 0, 0, 0, 0 )
*
*     Determine the size and placement of the submatrices, and save in
*     the leading elements of IWORK.
*
      IWORK( 1 ) = N
      SUBPBS = 1
      TLVLS = 0
   10 CONTINUE
      IF( IWORK( SUBPBS ).GT.SMLSIZ ) THEN
         DO 20 J = SUBPBS, 1, -1
            IWORK( 2*J ) = ( IWORK( J )+1 ) / 2
            IWORK( 2*J-1 ) = IWORK( J ) / 2
   20    CONTINUE
         TLVLS = TLVLS + 1
         SUBPBS = 2*SUBPBS
         GO TO 10
      END IF
      DO 30 J = 2, SUBPBS
         IWORK( J ) = IWORK( J ) + IWORK( J-1 )
   30 CONTINUE
*
*     Divide the matrix into SUBPBS submatrices of size at most SMLSIZ+1
*     using rank-1 modifications (cuts).
*
      SPM1 = SUBPBS - 1
      DO 40 I = 1, SPM1
         SUBMAT = IWORK( I ) + 1
         SMM1 = SUBMAT - 1
         D( SMM1 ) = D( SMM1 ) - ABS( E( SMM1 ) )
         D( SUBMAT ) = D( SUBMAT ) - ABS( E( SMM1 ) )
   40 CONTINUE
*
      INDXQ = 4*N + 3
*
*     Set up workspaces for eigenvalues only/accumulate new vectors
*     routine
*
      TEMP = LOG( DBLE( N ) ) / LOG( TWO )
      LGN = INT( TEMP )
      IF( 2**LGN.LT.N )
     $   LGN = LGN + 1
      IF( 2**LGN.LT.N )
     $   LGN = LGN + 1
      IPRMPT = INDXQ + N + 1
      IPERM = IPRMPT + N*LGN
      IQPTR = IPERM + N*LGN
      IGIVPT = IQPTR + N + 2
      IGIVCL = IGIVPT + N*LGN
*
      IGIVNM = 1
      IQ = IGIVNM + 2*N*LGN
      IWREM = IQ + N**2 + 1
*     Initialize pointers
      DO 50 I = 0, SUBPBS
         IWORK( IPRMPT+I ) = 1
         IWORK( IGIVPT+I ) = 1
   50 CONTINUE
      IWORK( IQPTR ) = 1
*
*     Solve each submatrix eigenproblem at the bottom of the divide and
*     conquer tree.
*
      CURR = 0
      DO 70 I = 0, SPM1
         IF( I.EQ.0 ) THEN
            SUBMAT = 1
            MATSIZ = IWORK( 1 )
         ELSE
            SUBMAT = IWORK( I ) + 1
            MATSIZ = IWORK( I+1 ) - IWORK( I )
         END IF
         LL = IQ - 1 + IWORK( IQPTR+CURR )
         CALL DSTEQR( 'I', MATSIZ, D( SUBMAT ), E( SUBMAT ),
     $                RWORK( LL ), MATSIZ, RWORK, INFO )
         CALL ZLACRM( QSIZ, MATSIZ, Q( 1, SUBMAT ), LDQ, RWORK( LL ),
     $                MATSIZ, QSTORE( 1, SUBMAT ), LDQS,
     $                RWORK( IWREM ) )
         IWORK( IQPTR+CURR+1 ) = IWORK( IQPTR+CURR ) + MATSIZ**2
         CURR = CURR + 1
         IF( INFO.GT.0 ) THEN
            INFO = SUBMAT*( N+1 ) + SUBMAT + MATSIZ - 1
            RETURN
         END IF
         K = 1
         DO 60 J = SUBMAT, IWORK( I+1 )
            IWORK( INDXQ+J ) = K
            K = K + 1
   60    CONTINUE
   70 CONTINUE
*
*     Successively merge eigensystems of adjacent submatrices
*     into eigensystem for the corresponding larger matrix.
*
*     while ( SUBPBS > 1 )
*
      CURLVL = 1
   80 CONTINUE
      IF( SUBPBS.GT.1 ) THEN
         SPM2 = SUBPBS - 2
         DO 90 I = 0, SPM2, 2
            IF( I.EQ.0 ) THEN
               SUBMAT = 1
               MATSIZ = IWORK( 2 )
               MSD2 = IWORK( 1 )
               CURPRB = 0
            ELSE
               SUBMAT = IWORK( I ) + 1
               MATSIZ = IWORK( I+2 ) - IWORK( I )
               MSD2 = MATSIZ / 2
               CURPRB = CURPRB + 1
            END IF
*
*     Merge lower order eigensystems (of size MSD2 and MATSIZ - MSD2)
*     into an eigensystem of size MATSIZ.  ZLAED7 handles the case
*     when the eigenvectors of a full or band Hermitian matrix (which
*     was reduced to tridiagonal form) are desired.
*
*     I am free to use Q as a valuable working space until Loop 150.
*
            CALL ZLAED7( MATSIZ, MSD2, QSIZ, TLVLS, CURLVL, CURPRB,
     $                   D( SUBMAT ), QSTORE( 1, SUBMAT ), LDQS,
     $                   E( SUBMAT+MSD2-1 ), IWORK( INDXQ+SUBMAT ),
     $                   RWORK( IQ ), IWORK( IQPTR ), IWORK( IPRMPT ),
     $                   IWORK( IPERM ), IWORK( IGIVPT ),
     $                   IWORK( IGIVCL ), RWORK( IGIVNM ),
     $                   Q( 1, SUBMAT ), RWORK( IWREM ),
     $                   IWORK( SUBPBS+1 ), INFO )
            IF( INFO.GT.0 ) THEN
               INFO = SUBMAT*( N+1 ) + SUBMAT + MATSIZ - 1
               RETURN
            END IF
            IWORK( I / 2+1 ) = IWORK( I+2 )
   90    CONTINUE
         SUBPBS = SUBPBS / 2
         CURLVL = CURLVL + 1
         GO TO 80
      END IF
*
*     end while
*
*     Re-merge the eigenvalues/vectors which were deflated at the final
*     merge step.
*
      DO 100 I = 1, N
         J = IWORK( INDXQ+I )
         RWORK( I ) = D( J )
         CALL ZCOPY( QSIZ, QSTORE( 1, J ), 1, Q( 1, I ), 1 )
  100 CONTINUE
      CALL DCOPY( N, RWORK, 1, D, 1 )
*
      RETURN
*
*     End of ZLAED0
*
      END

      PROGRAM CMPSAT
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Open GKS.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Turn off the clipping indicator.
C
      CALL GSCLIP (0)
C
C International outlines
C
      CALL MAPSTC ('OU - OUTLINE DATASET SELECTOR','PO')
C
C Satellite-view.
C
      CALL MAPROJ ('SV',40.,10.,0.)
      CALL MAPSTR ('SA - SATELLITE DISTANCE',2.)
      CALL MAPSTR ('S1 - SATELLITE ANGLE 1',10.)
      CALL MAPSTR ('S2 - SATELLITE ANGLE 2',15.)
      CALL MAPDRW

      CALL FRAME
C
C Deactivate and close the workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      
      STOP
      END
      

c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by UCAR                 .
c  .                                                             .
c  .       University Corporation for Atmospheric Research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                         SPHEREPACK                          .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c
c ... file hrfft.f
c
c     this file contains a multiple fft package for spherepack3.0.
c     it includes code and documentation for performing fast fourier
c     transforms (see subroutines hrffti,hrfftf and hrfftb)
c
c **********************************************************************
c
c     subroutine hrffti(n,wsave)
c
c     subroutine hrffti initializes the array wsave which is used in
c     both hrfftf and hrfftb. the prime factorization of n together
c     with a tabulation of the trigonometric functions are computed and
c     stored in wsave.
c
c     input parameter
c
c     n       the length of the sequence to be transformed.
c
c     output parameter
c
c     wsave   a work array which must be dimensioned at least 2*n+15.
c             the same work array can be used for both hrfftf and
c             hrfftb as long as n remains unchanged. different wsave
c             arrays are required for different values of n. the
c             contents of wsave must not be changed between calls
c             of hrfftf or hrfftb.
c
c **********************************************************************
c
c     subroutine hrfftf(m,n,r,mdimr,wsave,work)
c
c     subroutine hrfftf computes the fourier coefficients of m real
c     perodic sequences (fourier analysis); i.e. hrfftf computes the
c     real fft of m sequences each with length n. the transform is
c     defined below at output parameter r.
c
c     input parameters
c
c     m       the number of sequences.
c
c     n       the length of all m sequences.  the method is most
c             efficient when n is a product of small primes. n may
c             change as long as different work arrays are provided
c
c     r       r(m,n) is a two dimensional real array that contains m
c             sequences each with length n.
c
c     mdimr   the first dimension of the r array as it appears
c             in the program that calls hrfftf. mdimr must be
c             greater than or equal to m.
c
c
c     wsave   a work array with at least least 2*n+15 locations
c             in the program that calls hrfftf. the wsave array must be
c             initialized by calling subroutine hrffti(n,wsave) and a
c             different wsave array must be used for each different
c             value of n. this initialization does not have to be
c             repeated so long as n remains unchanged thus subsequent
c             transforms can be obtained faster than the first.
c             the same wsave array can be used by hrfftf and hrfftb.
c
c     work    a real work array with m*n locations.
c
c
c     output parameters
c
c     r      for all j=1,...,m
c
c             r(j,1) = the sum from i=1 to i=n of r(j,i)
c
c             if n is even set l =n/2   , if n is odd set l = (n+1)/2
c
c               then for k = 2,...,l
c
c                  r(j,2*k-2) = the sum from i = 1 to i = n of
c
c                       r(j,i)*cos((k-1)*(i-1)*2*pi/n)
c
c                  r(j,2*k-1) = the sum from i = 1 to i = n of
c
c                      -r(j,i)*sin((k-1)*(i-1)*2*pi/n)
c
c             if n is even
c
c                  r(j,n) = the sum from i = 1 to i = n of
c
c                       (-1)**(i-1)*r(j,i)
c
c      *****  note
c                  this transform is unnormalized since a call of hrfftf
c                  followed by a call of hrfftb will multiply the input
c                  sequence by n.
c
c     wsave   contains results which must not be destroyed between
c             calls of hrfftf or hrfftb.
c
c     work    a real work array with m*n locations that does
c             not have to be saved.
c
c **********************************************************************
c
c     subroutine hrfftb(m,n,r,mdimr,wsave,work)
c
c     subroutine hrfftb computes the real perodic sequence of m
c     sequences from their fourier coefficients (fourier synthesis).
c     the transform is defined below at output parameter r.
c
c     input parameters
c
c     m       the number of sequences.
c
c     n       the length of all m sequences.  the method is most
c             efficient when n is a product of small primes. n may
c             change as long as different work arrays are provided
c
c     r       r(m,n) is a two dimensional real array that contains
c             the fourier coefficients of m sequences each with
c             length n.
c
c     mdimr   the first dimension of the r array as it appears
c             in the program that calls hrfftb. mdimr must be
c             greater than or equal to m.
c
c     wsave   a work array which must be dimensioned at least 2*n+15.
c             in the program that calls hrfftb. the wsave array must be
c             initialized by calling subroutine hrffti(n,wsave) and a
c             different wsave array must be used for each different
c             value of n. this initialization does not have to be
c             repeated so long as n remains unchanged thus subsequent
c             transforms can be obtained faster than the first.
c             the same wsave array can be used by hrfftf and hrfftb.
c
c     work    a real work array with m*n locations.
c
c
c     output parameters
c
c     r      for all j=1,...,m
c
c             for n even and for i = 1,...,n
c
c                  r(j,i) = r(j,1)+(-1)**(i-1)*r(j,n)
c
c                       plus the sum from k=2 to k=n/2 of
c
c                        2.*r(j,2*k-2)*cos((k-1)*(i-1)*2*pi/n)
c
c                       -2.*r(j,2*k-1)*sin((k-1)*(i-1)*2*pi/n)
c
c             for n odd and for i = 1,...,n
c
c                  r(j,i) = r(j,1) plus the sum from k=2 to k=(n+1)/2 of
c
c                       2.*r(j,2*k-2)*cos((k-1)*(i-1)*2*pi/n)
c
c                      -2.*r(j,2*k-1)*sin((k-1)*(i-1)*2*pi/n)
c
c      *****  note
c                  this transform is unnormalized since a call of hrfftf
c                  followed by a call of hrfftb will multiply the input
c                  sequence by n.
c
c     wsave   contains results which must not be destroyed between
c             calls of hrfftb or hrfftf.
c
c     work    a real work array with m*n locations that does not
c             have to be saved
c
c **********************************************************************
c
c
c
      SUBROUTINE DHRFFTI(N,WSAVE)
      DOUBLE PRECISION WSAVE
      DOUBLE PRECISION TFFT
      DIMENSION WSAVE(N+15)
      COMMON /HRF/TFFT

      TFFT = 0.D0
      IF (N.EQ.1) RETURN
      CALL DHRFTI1(N,WSAVE(1),WSAVE(N+1))
      RETURN
      END
      SUBROUTINE DHRFTI1(N,WA,FAC)
      DOUBLE PRECISION WA
      DOUBLE PRECISION FAC
      DOUBLE PRECISION FI
c
c     a multiple fft package for spherepack
c
      DIMENSION WA(N),FAC(15),NTRYH(4)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION TPI,ARGH,ARGLD,ARG
      DATA NTRYH(1),NTRYH(2),NTRYH(3),NTRYH(4)/4,2,3,5/

      NL = N
      NF = 0
      J = 0
  101 J = J + 1
      IF (J-4) 102,102,103
  102 NTRY = NTRYH(J)
      GO TO 104
  103 NTRY = NTRY + 2
  104 NQ = NL/NTRY
      NR = NL - NTRY*NQ
      IF (NR) 101,105,101
  105 NF = NF + 1
      FAC(NF+2) = NTRY
      NL = NQ
      IF (NTRY.NE.2) GO TO 107
      IF (NF.EQ.1) GO TO 107
      DO 106 I = 2,NF
          IB = NF - I + 2
          FAC(IB+2) = FAC(IB+1)
  106 CONTINUE
      FAC(3) = 2
  107 IF (NL.NE.1) GO TO 104
      FAC(1) = N
      FAC(2) = NF
C*PT*WARNING* Constant already double-precision
C*PT*WARNING* Constant already double-precision
      TPI = 8.d0*DATAN(1.d0)
      ARGH = TPI/DBLE(N)
      IS = 0
      NFM1 = NF - 1
      L1 = 1
      IF (NFM1.EQ.0) RETURN
      DO 110 K1 = 1,NFM1
          IP = FAC(K1+2)
          LD = 0
          L2 = L1*IP
          IDO = N/L2
          IPM = IP - 1
          DO 109 J = 1,IPM
              LD = LD + L1
              I = IS
              ARGLD = DBLE(LD)*ARGH
              FI = 0.D0
              DO 108 II = 3,IDO,2
                  I = I + 2
                  FI = FI + 1.D0
                  ARG = FI*ARGLD
                  WA(I-1) = DCOS(ARG)
                  WA(I) = DSIN(ARG)
  108         CONTINUE
              IS = IS + IDO
  109     CONTINUE
          L1 = L2
  110 CONTINUE
      RETURN
      END
      SUBROUTINE DHRFFTF(M,N,R,MDIMR,WHRFFT,WORK)
      DOUBLE PRECISION R
      DOUBLE PRECISION WHRFFT
      DOUBLE PRECISION WORK
      DOUBLE PRECISION TFFT
c
c     a multiple fft package for spherepack
c
      DIMENSION R(MDIMR,N),WORK(1),WHRFFT(N+15)
      COMMON /HRF/TFFT

      IF (N.EQ.1) RETURN
c     tstart = second(dum)
      CALL DHRFTF1(M,N,R,MDIMR,WORK,WHRFFT,WHRFFT(N+1))
c     tfft = tfft+second(dum)-tstart
      RETURN
      END
      SUBROUTINE DHRFTF1(M,N,C,MDIMC,CH,WA,FAC)
      DOUBLE PRECISION C
      DOUBLE PRECISION CH
      DOUBLE PRECISION WA
      DOUBLE PRECISION FAC
c
c     a multiple fft package for spherepack
c
      DIMENSION CH(M,N),C(MDIMC,N),WA(N),FAC(15)

      NF = FAC(2)
      NA = 1
      L2 = N
      IW = N
      DO 111 K1 = 1,NF
          KH = NF - K1
          IP = FAC(KH+3)
          L1 = L2/IP
          IDO = N/L2
          IDL1 = IDO*L1
          IW = IW - (IP-1)*IDO
          NA = 1 - NA
          IF (IP.NE.4) GO TO 102
          IX2 = IW + IDO
          IX3 = IX2 + IDO
          IF (NA.NE.0) GO TO 101
          CALL DHRADF4(M,IDO,L1,C,MDIMC,CH,M,WA(IW),WA(IX2),WA(IX3))
          GO TO 110
  101     CALL DHRADF4(M,IDO,L1,CH,M,C,MDIMC,WA(IW),WA(IX2),WA(IX3))
          GO TO 110
  102     IF (IP.NE.2) GO TO 104
          IF (NA.NE.0) GO TO 103
          CALL DHRADF2(M,IDO,L1,C,MDIMC,CH,M,WA(IW))
          GO TO 110
  103     CALL DHRADF2(M,IDO,L1,CH,M,C,MDIMC,WA(IW))
          GO TO 110
  104     IF (IP.NE.3) GO TO 106
          IX2 = IW + IDO
          IF (NA.NE.0) GO TO 105
          CALL DHRADF3(M,IDO,L1,C,MDIMC,CH,M,WA(IW),WA(IX2))
          GO TO 110
  105     CALL DHRADF3(M,IDO,L1,CH,M,C,MDIMC,WA(IW),WA(IX2))
          GO TO 110
  106     IF (IP.NE.5) GO TO 108
          IX2 = IW + IDO
          IX3 = IX2 + IDO
          IX4 = IX3 + IDO
          IF (NA.NE.0) GO TO 107
          CALL DHRADF5(M,IDO,L1,C,MDIMC,CH,M,WA(IW),WA(IX2),WA(IX3),
     +                WA(IX4))
          GO TO 110
  107     CALL DHRADF5(M,IDO,L1,CH,M,C,MDIMC,WA(IW),WA(IX2),WA(IX3),
     +                WA(IX4))
          GO TO 110
  108     IF (IDO.EQ.1) NA = 1 - NA
          IF (NA.NE.0) GO TO 109
          CALL DHRADFG(M,IDO,IP,L1,IDL1,C,C,C,MDIMC,CH,CH,M,WA(IW))
          NA = 1
          GO TO 110
  109     CALL DHRADFG(M,IDO,IP,L1,IDL1,CH,CH,CH,M,C,C,MDIMC,WA(IW))
          NA = 0
  110     L2 = L1
  111 CONTINUE
      IF (NA.EQ.1) RETURN
      DO 112 J = 1,N
          DO 112 I = 1,M
              C(I,J) = CH(I,J)
  112 CONTINUE
      RETURN
      END
      SUBROUTINE DHRADF4(MP,IDO,L1,CC,MDIMCC,CH,MDIMCH,WA1,WA2,WA3)
      DOUBLE PRECISION CC
      DOUBLE PRECISION CH
      DOUBLE PRECISION WA1
      DOUBLE PRECISION WA2
      DOUBLE PRECISION WA3
      DOUBLE PRECISION HSQT2
c
c     a multiple fft package for spherepack
c
      DIMENSION CC(MDIMCC,IDO,L1,4),CH(MDIMCH,IDO,4,L1),WA1(IDO),
     +          WA2(IDO),WA3(IDO)

      HSQT2 = SQRT(2.D0)/2.D0
      DO 101 K = 1,L1
          DO 1001 M = 1,MP
              CH(M,1,1,K) = (CC(M,1,K,2)+CC(M,1,K,4)) +
     +                      (CC(M,1,K,1)+CC(M,1,K,3))
              CH(M,IDO,4,K) = (CC(M,1,K,1)+CC(M,1,K,3)) -
     +                        (CC(M,1,K,2)+CC(M,1,K,4))
              CH(M,IDO,2,K) = CC(M,1,K,1) - CC(M,1,K,3)
              CH(M,1,3,K) = CC(M,1,K,4) - CC(M,1,K,2)
 1001     CONTINUE
  101 CONTINUE
      IF (IDO-2) 107,105,102
  102 IDP2 = IDO + 2
      DO 104 K = 1,L1
          DO 103 I = 3,IDO,2
              IC = IDP2 - I
              DO 1003 M = 1,MP
                  CH(M,I-1,1,K) = ((WA1(I-2)*CC(M,I-1,K,
     +                            2)+WA1(I-1)*CC(M,I,K,2))+
     +                            (WA3(I-2)*CC(M,I-1,K,4)+WA3(I-1)*CC(M,
     +                            I,K,4))) + (CC(M,I-1,K,1)+
     +                            (WA2(I-2)*CC(M,I-1,K,3)+WA2(I-1)*CC(M,
     +                            I,K,3)))
                  CH(M,IC-1,4,K) = (CC(M,I-1,K,1)+
     +                             (WA2(I-2)*CC(M,I-1,K,3)+WA2(I-
     +                             1)*CC(M,I,K,3))) -
     +                             ((WA1(I-2)*CC(M,I-1,K,
     +                             2)+WA1(I-1)*CC(M,I,K,2))+
     +                             (WA3(I-2)*CC(M,I-1,K,
     +                             4)+WA3(I-1)*CC(M,I,K,4)))
                  CH(M,I,1,K) = ((WA1(I-2)*CC(M,I,K,2)-WA1(I-1)*CC(M,
     +                          I-1,K,2))+ (WA3(I-2)*CC(M,I,K,
     +                          4)-WA3(I-1)*CC(M,I-1,K,4))) +
     +                          (CC(M,I,K,1)+ (WA2(I-2)*CC(M,I,K,
     +                          3)-WA2(I-1)*CC(M,I-1,K,3)))
                  CH(M,IC,4,K) = ((WA1(I-2)*CC(M,I,K,2)-WA1(I-1)*CC(M,
     +                           I-1,K,2))+ (WA3(I-2)*CC(M,I,K,
     +                           4)-WA3(I-1)*CC(M,I-1,K,4))) -
     +                           (CC(M,I,K,1)+ (WA2(I-2)*CC(M,I,K,
     +                           3)-WA2(I-1)*CC(M,I-1,K,3)))
                  CH(M,I-1,3,K) = ((WA1(I-2)*CC(M,I,K,2)-WA1(I-1)*CC(M,
     +                            I-1,K,2))- (WA3(I-2)*CC(M,I,K,
     +                            4)-WA3(I-1)*CC(M,I-1,K,4))) +
     +                            (CC(M,I-1,K,1)- (WA2(I-2)*CC(M,I-1,K,
     +                            3)+WA2(I-1)*CC(M,I,K,3)))
                  CH(M,IC-1,2,K) = (CC(M,I-1,K,1)-
     +                             (WA2(I-2)*CC(M,I-1,K,3)+WA2(I-
     +                             1)*CC(M,I,K,3))) -
     +                             ((WA1(I-2)*CC(M,I,K,2)-WA1(I-1)*CC(M,
     +                             I-1,K,2))- (WA3(I-2)*CC(M,I,K,
     +                             4)-WA3(I-1)*CC(M,I-1,K,4)))
                  CH(M,I,3,K) = ((WA3(I-2)*CC(M,I-1,K,4)+WA3(I-1)*CC(M,
     +                          I,K,4))- (WA1(I-2)*CC(M,I-1,K,
     +                          2)+WA1(I-1)*CC(M,I,K,2))) +
     +                          (CC(M,I,K,1)- (WA2(I-2)*CC(M,I,K,
     +                          3)-WA2(I-1)*CC(M,I-1,K,3)))
                  CH(M,IC,2,K) = ((WA3(I-2)*CC(M,I-1,K,4)+WA3(I-1)*CC(M,
     +                           I,K,4))- (WA1(I-2)*CC(M,I-1,K,
     +                           2)+WA1(I-1)*CC(M,I,K,2))) -
     +                           (CC(M,I,K,1)- (WA2(I-2)*CC(M,I,K,
     +                           3)-WA2(I-1)*CC(M,I-1,K,3)))
 1003         CONTINUE
  103     CONTINUE
  104 CONTINUE
      IF (MOD(IDO,2).EQ.1) RETURN
  105 CONTINUE
      DO 106 K = 1,L1
          DO 1006 M = 1,MP
              CH(M,IDO,1,K) = (HSQT2* (CC(M,IDO,K,2)-CC(M,IDO,K,4))) +
     +                        CC(M,IDO,K,1)
              CH(M,IDO,3,K) = CC(M,IDO,K,1) -
     +                        (HSQT2* (CC(M,IDO,K,2)-CC(M,IDO,K,4)))
              CH(M,1,2,K) = (-HSQT2* (CC(M,IDO,K,2)+CC(M,IDO,K,4))) -
     +                      CC(M,IDO,K,3)
              CH(M,1,4,K) = (-HSQT2* (CC(M,IDO,K,2)+CC(M,IDO,K,4))) +
     +                      CC(M,IDO,K,3)
 1006     CONTINUE
  106 CONTINUE
  107 RETURN
      END
      SUBROUTINE DHRADF2(MP,IDO,L1,CC,MDIMCC,CH,MDIMCH,WA1)
      DOUBLE PRECISION CC
      DOUBLE PRECISION CH
      DOUBLE PRECISION WA1
c
c     a multiple fft package for spherepack
c
      DIMENSION CH(MDIMCH,IDO,2,L1),CC(MDIMCC,IDO,L1,2),WA1(IDO)

      DO 101 K = 1,L1
          DO 1001 M = 1,MP
              CH(M,1,1,K) = CC(M,1,K,1) + CC(M,1,K,2)
              CH(M,IDO,2,K) = CC(M,1,K,1) - CC(M,1,K,2)
 1001     CONTINUE
  101 CONTINUE
      IF (IDO-2) 107,105,102
  102 IDP2 = IDO + 2
      DO 104 K = 1,L1
          DO 103 I = 3,IDO,2
              IC = IDP2 - I
              DO 1003 M = 1,MP
                  CH(M,I,1,K) = CC(M,I,K,1) +
     +                          (WA1(I-2)*CC(M,I,K,2)-WA1(I-1)*
     +                          CC(M,I-1,K,2))
                  CH(M,IC,2,K) = (WA1(I-2)*CC(M,I,K,2)-
     +                           WA1(I-1)*CC(M,I-1,K,2)) - CC(M,I,K,1)
                  CH(M,I-1,1,K) = CC(M,I-1,K,1) +
     +                            (WA1(I-2)*CC(M,I-1,K,2)+
     +                            WA1(I-1)*CC(M,I,K,2))
                  CH(M,IC-1,2,K) = CC(M,I-1,K,1) -
     +                             (WA1(I-2)*CC(M,I-1,K,2)+
     +                             WA1(I-1)*CC(M,I,K,2))
 1003         CONTINUE
  103     CONTINUE
  104 CONTINUE
      IF (MOD(IDO,2).EQ.1) RETURN
  105 DO 106 K = 1,L1
          DO 1006 M = 1,MP
              CH(M,1,2,K) = -CC(M,IDO,K,2)
              CH(M,IDO,1,K) = CC(M,IDO,K,1)
 1006     CONTINUE
  106 CONTINUE
  107 RETURN
      END
      SUBROUTINE DHRADF3(MP,IDO,L1,CC,MDIMCC,CH,MDIMCH,WA1,WA2)
      DOUBLE PRECISION CC
      DOUBLE PRECISION CH
      DOUBLE PRECISION WA1
      DOUBLE PRECISION WA2
      DOUBLE PRECISION ARG
      DOUBLE PRECISION DPIMACH
      DOUBLE PRECISION TAUR
      DOUBLE PRECISION TAUI
c
c     a multiple fft package for spherepack
c
      DIMENSION CH(MDIMCH,IDO,3,L1),CC(MDIMCC,IDO,L1,3),WA1(IDO),
     +          WA2(IDO)

      ARG = 2.D0*DPIMACH()/3.D0
      TAUR = COS(ARG)
      TAUI = SIN(ARG)
      DO 101 K = 1,L1
          DO 1001 M = 1,MP
              CH(M,1,1,K) = CC(M,1,K,1) + (CC(M,1,K,2)+CC(M,1,K,3))
              CH(M,1,3,K) = TAUI* (CC(M,1,K,3)-CC(M,1,K,2))
              CH(M,IDO,2,K) = CC(M,1,K,1) +
     +                        TAUR* (CC(M,1,K,2)+CC(M,1,K,3))
 1001     CONTINUE
  101 CONTINUE
      IF (IDO.EQ.1) RETURN
      IDP2 = IDO + 2
      DO 103 K = 1,L1
          DO 102 I = 3,IDO,2
              IC = IDP2 - I
              DO 1002 M = 1,MP
                  CH(M,I-1,1,K) = CC(M,I-1,K,1) +
     +                            ((WA1(I-2)*CC(M,I-1,K,2)+WA1(I-
     +                            1)*CC(M,I,K,2))+ (WA2(I-2)*CC(M,I-1,K,
     +                            3)+WA2(I-1)*CC(M,I,K,3)))
                  CH(M,I,1,K) = CC(M,I,K,1) +
     +                          ((WA1(I-2)*CC(M,I,K,2)-WA1(I-1)*CC(M,
     +                          I-1,K,2))+ (WA2(I-2)*CC(M,I,K,
     +                          3)-WA2(I-1)*CC(M,I-1,K,3)))
                  CH(M,I-1,3,K) = (CC(M,I-1,K,1)+
     +                            TAUR* ((WA1(I-2)*CC(M,I-1,K,
     +                            2)+WA1(I-1)*CC(M,I,K,
     +                            2))+ (WA2(I-2)*CC(M,I-1,K,
     +                            3)+WA2(I-1)*CC(M,I,K,3)))) +
     +                            (TAUI* ((WA1(I-2)*CC(M,I,K,
     +                            2)-WA1(I-1)*CC(M,I-1,K,
     +                            2))- (WA2(I-2)*CC(M,I,K,
     +                            3)-WA2(I-1)*CC(M,I-1,K,3))))
                  CH(M,IC-1,2,K) = (CC(M,I-1,K,1)+
     +                             TAUR* ((WA1(I-2)*CC(M,I-1,K,
     +                             2)+WA1(I-1)*CC(M,I,K,
     +                             2))+ (WA2(I-2)*CC(M,I-1,K,
     +                             3)+WA2(I-1)*CC(M,I,K,3)))) -
     +                             (TAUI* ((WA1(I-2)*CC(M,I,K,
     +                             2)-WA1(I-1)*CC(M,I-1,K,
     +                             2))- (WA2(I-2)*CC(M,I,K,
     +                             3)-WA2(I-1)*CC(M,I-1,K,3))))
                  CH(M,I,3,K) = (CC(M,I,K,1)+
     +                          TAUR* ((WA1(I-2)*CC(M,I,K,2)-WA1(I-
     +                          1)*CC(M,I-1,K,2))+ (WA2(I-2)*CC(M,I,K,
     +                          3)-WA2(I-1)*CC(M,I-1,K,3)))) +
     +                          (TAUI* ((WA2(I-2)*CC(M,I-1,K,
     +                          3)+WA2(I-1)*CC(M,I,K,
     +                          3))- (WA1(I-2)*CC(M,I-1,K,
     +                          2)+WA1(I-1)*CC(M,I,K,2))))
                  CH(M,IC,2,K) = (TAUI* ((WA2(I-2)*CC(M,I-1,K,
     +                           3)+WA2(I-1)*CC(M,I,K,
     +                           3))- (WA1(I-2)*CC(M,I-1,K,
     +                           2)+WA1(I-1)*CC(M,I,K,2)))) -
     +                           (CC(M,I,K,1)+TAUR* ((WA1(I-2)*CC(M,I,K,
     +                           2)-WA1(I-1)*CC(M,I-1,K,
     +                           2))+ (WA2(I-2)*CC(M,I,K,
     +                           3)-WA2(I-1)*CC(M,I-1,K,3))))
 1002         CONTINUE
  102     CONTINUE
  103 CONTINUE
      RETURN
      END
      SUBROUTINE DHRADF5(MP,IDO,L1,CC,MDIMCC,CH,MDIMCH,WA1,WA2,WA3,WA4)
      DOUBLE PRECISION CC
      DOUBLE PRECISION CH
      DOUBLE PRECISION WA1
      DOUBLE PRECISION WA2
      DOUBLE PRECISION WA3
      DOUBLE PRECISION WA4
      DOUBLE PRECISION ARG
      DOUBLE PRECISION DPIMACH
      DOUBLE PRECISION TR11
      DOUBLE PRECISION TI11
      DOUBLE PRECISION TR12
      DOUBLE PRECISION TI12
c
c     a multiple fft package for spherepack
c
      DIMENSION CC(MDIMCC,IDO,L1,5),CH(MDIMCH,IDO,5,L1),WA1(IDO),
     +          WA2(IDO),WA3(IDO),WA4(IDO)

      ARG = 2.D0*DPIMACH()/5.D0
      TR11 = COS(ARG)
      TI11 = SIN(ARG)
      TR12 = COS(2.D0*ARG)
      TI12 = SIN(2.D0*ARG)
      DO 101 K = 1,L1
          DO 1001 M = 1,MP
              CH(M,1,1,K) = CC(M,1,K,1) + (CC(M,1,K,5)+CC(M,1,K,2)) +
     +                      (CC(M,1,K,4)+CC(M,1,K,3))
              CH(M,IDO,2,K) = CC(M,1,K,1) +
     +                        TR11* (CC(M,1,K,5)+CC(M,1,K,2)) +
     +                        TR12* (CC(M,1,K,4)+CC(M,1,K,3))
              CH(M,1,3,K) = TI11* (CC(M,1,K,5)-CC(M,1,K,2)) +
     +                      TI12* (CC(M,1,K,4)-CC(M,1,K,3))
              CH(M,IDO,4,K) = CC(M,1,K,1) +
     +                        TR12* (CC(M,1,K,5)+CC(M,1,K,2)) +
     +                        TR11* (CC(M,1,K,4)+CC(M,1,K,3))
              CH(M,1,5,K) = TI12* (CC(M,1,K,5)-CC(M,1,K,2)) -
     +                      TI11* (CC(M,1,K,4)-CC(M,1,K,3))
 1001     CONTINUE
  101 CONTINUE
      IF (IDO.EQ.1) RETURN
      IDP2 = IDO + 2
      DO 103 K = 1,L1
          DO 102 I = 3,IDO,2
              IC = IDP2 - I
              DO 1002 M = 1,MP
                  CH(M,I-1,1,K) = CC(M,I-1,K,1) +
     +                            ((WA1(I-2)*CC(M,I-1,K,2)+WA1(I-
     +                            1)*CC(M,I,K,2))+ (WA4(I-2)*CC(M,I-1,K,
     +                            5)+WA4(I-1)*CC(M,I,K,5))) +
     +                            ((WA2(I-2)*CC(M,I-1,K,
     +                            3)+WA2(I-1)*CC(M,I,K,3))+
     +                            (WA3(I-2)*CC(M,I-1,K,4)+WA3(I-1)*CC(M,
     +                            I,K,4)))
                  CH(M,I,1,K) = CC(M,I,K,1) +
     +                          ((WA1(I-2)*CC(M,I,K,2)-WA1(I-1)*CC(M,
     +                          I-1,K,2))+ (WA4(I-2)*CC(M,I,K,
     +                          5)-WA4(I-1)*CC(M,I-1,K,5))) +
     +                          ((WA2(I-2)*CC(M,I,K,3)-WA2(I-1)*CC(M,
     +                          I-1,K,3))+ (WA3(I-2)*CC(M,I,K,
     +                          4)-WA3(I-1)*CC(M,I-1,K,4)))
                  CH(M,I-1,3,K) = CC(M,I-1,K,1) +
     +                            TR11* (WA1(I-2)*CC(M,I-1,K,2)+
     +                            WA1(I-1)*CC(M,I,K,2)+
     +                            WA4(I-2)*CC(M,I-1,K,5)+
     +                            WA4(I-1)*CC(M,I,K,5)) +
     +                            TR12* (WA2(I-2)*CC(M,I-1,K,3)+
     +                            WA2(I-1)*CC(M,I,K,3)+
     +                            WA3(I-2)*CC(M,I-1,K,4)+
     +                            WA3(I-1)*CC(M,I,K,4)) +
     +                            TI11* (WA1(I-2)*CC(M,I,K,2)-
     +                            WA1(I-1)*CC(M,I-1,K,2)-
     +                            (WA4(I-2)*CC(M,I,K,5)-WA4(I-1)*CC(M,
     +                            I-1,K,5))) + TI12*
     +                            (WA2(I-2)*CC(M,I,K,3)-
     +                            WA2(I-1)*CC(M,I-1,K,3)-
     +                            (WA3(I-2)*CC(M,I,K,4)-WA3(I-1)*CC(M,
     +                            I-1,K,4)))
                  CH(M,IC-1,2,K) = CC(M,I-1,K,1) +
     +                             TR11* (WA1(I-2)*CC(M,I-1,K,2)+
     +                             WA1(I-1)*CC(M,I,K,2)+
     +                             WA4(I-2)*CC(M,I-1,K,5)+
     +                             WA4(I-1)*CC(M,I,K,5)) +
     +                             TR12* (WA2(I-2)*CC(M,I-1,K,3)+
     +                             WA2(I-1)*CC(M,I,K,3)+
     +                             WA3(I-2)*CC(M,I-1,K,4)+
     +                             WA3(I-1)*CC(M,I,K,4)) -
     +                             (TI11* (WA1(I-2)*CC(M,I,K,
     +                             2)-WA1(I-1)*CC(M,I-1,K,
     +                             2)- (WA4(I-2)*CC(M,I,K,
     +                             5)-WA4(I-1)*CC(M,I-1,K,5)))+
     +                             TI12* (WA2(I-2)*CC(M,I,K,
     +                             3)-WA2(I-1)*CC(M,I-1,K,
     +                             3)- (WA3(I-2)*CC(M,I,K,
     +                             4)-WA3(I-1)*CC(M,I-1,K,4))))
                  CH(M,I,3,K) = (CC(M,I,K,1)+
     +                          TR11* ((WA1(I-2)*CC(M,I,K,2)-WA1(I-
     +                          1)*CC(M,I-1,K,2))+ (WA4(I-2)*CC(M,I,K,
     +                          5)-WA4(I-1)*CC(M,I-1,K,5)))+
     +                          TR12* ((WA2(I-2)*CC(M,I,K,
     +                          3)-WA2(I-1)*CC(M,I-1,K,
     +                          3))+ (WA3(I-2)*CC(M,I,K,
     +                          4)-WA3(I-1)*CC(M,I-1,K,4)))) +
     +                          (TI11* ((WA4(I-2)*CC(M,I-1,K,
     +                          5)+WA4(I-1)*CC(M,I,K,
     +                          5))- (WA1(I-2)*CC(M,I-1,K,
     +                          2)+WA1(I-1)*CC(M,I,K,2)))+
     +                          TI12* ((WA3(I-2)*CC(M,I-1,K,
     +                          4)+WA3(I-1)*CC(M,I,K,
     +                          4))- (WA2(I-2)*CC(M,I-1,K,
     +                          3)+WA2(I-1)*CC(M,I,K,3))))
                  CH(M,IC,2,K) = (TI11* ((WA4(I-2)*CC(M,I-1,K,
     +                           5)+WA4(I-1)*CC(M,I,K,
     +                           5))- (WA1(I-2)*CC(M,I-1,K,
     +                           2)+WA1(I-1)*CC(M,I,K,2)))+
     +                           TI12* ((WA3(I-2)*CC(M,I-1,K,
     +                           4)+WA3(I-1)*CC(M,I,K,
     +                           4))- (WA2(I-2)*CC(M,I-1,K,
     +                           3)+WA2(I-1)*CC(M,I,K,3)))) -
     +                           (CC(M,I,K,1)+TR11* ((WA1(I-2)*CC(M,I,K,
     +                           2)-WA1(I-1)*CC(M,I-1,K,
     +                           2))+ (WA4(I-2)*CC(M,I,K,
     +                           5)-WA4(I-1)*CC(M,I-1,K,5)))+
     +                           TR12* ((WA2(I-2)*CC(M,I,K,
     +                           3)-WA2(I-1)*CC(M,I-1,K,
     +                           3))+ (WA3(I-2)*CC(M,I,K,
     +                           4)-WA3(I-1)*CC(M,I-1,K,4))))
                  CH(M,I-1,5,K) = (CC(M,I-1,K,1)+
     +                            TR12* ((WA1(I-2)*CC(M,I-1,K,
     +                            2)+WA1(I-1)*CC(M,I,K,
     +                            2))+ (WA4(I-2)*CC(M,I-1,K,
     +                            5)+WA4(I-1)*CC(M,I,K,5)))+
     +                            TR11* ((WA2(I-2)*CC(M,I-1,K,
     +                            3)+WA2(I-1)*CC(M,I,K,
     +                            3))+ (WA3(I-2)*CC(M,I-1,K,
     +                            4)+WA3(I-1)*CC(M,I,K,4)))) +
     +                            (TI12* ((WA1(I-2)*CC(M,I,K,
     +                            2)-WA1(I-1)*CC(M,I-1,K,
     +                            2))- (WA4(I-2)*CC(M,I,K,
     +                            5)-WA4(I-1)*CC(M,I-1,K,5)))-
     +                            TI11* ((WA2(I-2)*CC(M,I,K,
     +                            3)-WA2(I-1)*CC(M,I-1,K,
     +                            3))- (WA3(I-2)*CC(M,I,K,
     +                            4)-WA3(I-1)*CC(M,I-1,K,4))))
                  CH(M,IC-1,4,K) = (CC(M,I-1,K,1)+
     +                             TR12* ((WA1(I-2)*CC(M,I-1,K,
     +                             2)+WA1(I-1)*CC(M,I,K,
     +                             2))+ (WA4(I-2)*CC(M,I-1,K,
     +                             5)+WA4(I-1)*CC(M,I,K,5)))+
     +                             TR11* ((WA2(I-2)*CC(M,I-1,K,
     +                             3)+WA2(I-1)*CC(M,I,K,
     +                             3))+ (WA3(I-2)*CC(M,I-1,K,
     +                             4)+WA3(I-1)*CC(M,I,K,4)))) -
     +                             (TI12* ((WA1(I-2)*CC(M,I,K,
     +                             2)-WA1(I-1)*CC(M,I-1,K,
     +                             2))- (WA4(I-2)*CC(M,I,K,
     +                             5)-WA4(I-1)*CC(M,I-1,K,5)))-
     +                             TI11* ((WA2(I-2)*CC(M,I,K,
     +                             3)-WA2(I-1)*CC(M,I-1,K,
     +                             3))- (WA3(I-2)*CC(M,I,K,
     +                             4)-WA3(I-1)*CC(M,I-1,K,4))))
                  CH(M,I,5,K) = (CC(M,I,K,1)+
     +                          TR12* ((WA1(I-2)*CC(M,I,K,2)-WA1(I-
     +                          1)*CC(M,I-1,K,2))+ (WA4(I-2)*CC(M,I,K,
     +                          5)-WA4(I-1)*CC(M,I-1,K,5)))+
     +                          TR11* ((WA2(I-2)*CC(M,I,K,
     +                          3)-WA2(I-1)*CC(M,I-1,K,
     +                          3))+ (WA3(I-2)*CC(M,I,K,
     +                          4)-WA3(I-1)*CC(M,I-1,K,4)))) +
     +                          (TI12* ((WA4(I-2)*CC(M,I-1,K,
     +                          5)+WA4(I-1)*CC(M,I,K,
     +                          5))- (WA1(I-2)*CC(M,I-1,K,
     +                          2)+WA1(I-1)*CC(M,I,K,2)))-
     +                          TI11* ((WA3(I-2)*CC(M,I-1,K,
     +                          4)+WA3(I-1)*CC(M,I,K,
     +                          4))- (WA2(I-2)*CC(M,I-1,K,
     +                          3)+WA2(I-1)*CC(M,I,K,3))))
                  CH(M,IC,4,K) = (TI12* ((WA4(I-2)*CC(M,I-1,K,
     +                           5)+WA4(I-1)*CC(M,I,K,
     +                           5))- (WA1(I-2)*CC(M,I-1,K,
     +                           2)+WA1(I-1)*CC(M,I,K,2)))-
     +                           TI11* ((WA3(I-2)*CC(M,I-1,K,
     +                           4)+WA3(I-1)*CC(M,I,K,
     +                           4))- (WA2(I-2)*CC(M,I-1,K,
     +                           3)+WA2(I-1)*CC(M,I,K,3)))) -
     +                           (CC(M,I,K,1)+TR12* ((WA1(I-2)*CC(M,I,K,
     +                           2)-WA1(I-1)*CC(M,I-1,K,
     +                           2))+ (WA4(I-2)*CC(M,I,K,
     +                           5)-WA4(I-1)*CC(M,I-1,K,5)))+
     +                           TR11* ((WA2(I-2)*CC(M,I,K,
     +                           3)-WA2(I-1)*CC(M,I-1,K,
     +                           3))+ (WA3(I-2)*CC(M,I,K,
     +                           4)-WA3(I-1)*CC(M,I-1,K,4))))
 1002         CONTINUE
  102     CONTINUE
  103 CONTINUE
      RETURN
      END
      SUBROUTINE DHRADFG(MP,IDO,IP,L1,IDL1,CC,C1,C2,MDIMCC,CH,CH2,
     +                   MDIMCH,WA)
      DOUBLE PRECISION CC
      DOUBLE PRECISION C1
      DOUBLE PRECISION C2
      DOUBLE PRECISION CH
      DOUBLE PRECISION CH2
      DOUBLE PRECISION WA
      DOUBLE PRECISION TPI
      DOUBLE PRECISION DPIMACH
      DOUBLE PRECISION ARG
      DOUBLE PRECISION DCP
      DOUBLE PRECISION DSP
      DOUBLE PRECISION AR1
      DOUBLE PRECISION AI1
      DOUBLE PRECISION AR1H
      DOUBLE PRECISION DC2
      DOUBLE PRECISION DS2
      DOUBLE PRECISION AR2
      DOUBLE PRECISION AI2
      DOUBLE PRECISION AR2H
c
c     a multiple fft package for spherepack
c
      DIMENSION CH(MDIMCH,IDO,L1,IP),CC(MDIMCC,IDO,IP,L1),
     +          C1(MDIMCC,IDO,L1,IP),C2(MDIMCC,IDL1,IP),
     +          CH2(MDIMCH,IDL1,IP),WA(IDO)

      TPI = 2.D0*DPIMACH()
      ARG = TPI/DBLE(IP)
      DCP = COS(ARG)
      DSP = SIN(ARG)
      IPPH = (IP+1)/2
      IPP2 = IP + 2
      IDP2 = IDO + 2
      NBD = (IDO-1)/2
      IF (IDO.EQ.1) GO TO 119
      DO 101 IK = 1,IDL1
          DO 1001 M = 1,MP
              CH2(M,IK,1) = C2(M,IK,1)
 1001     CONTINUE
  101 CONTINUE
      DO 103 J = 2,IP
          DO 102 K = 1,L1
              DO 1002 M = 1,MP
                  CH(M,1,K,J) = C1(M,1,K,J)
 1002         CONTINUE
  102     CONTINUE
  103 CONTINUE
      IF (NBD.GT.L1) GO TO 107
      IS = -IDO
      DO 106 J = 2,IP
          IS = IS + IDO
          IDIJ = IS
          DO 105 I = 3,IDO,2
              IDIJ = IDIJ + 2
              DO 104 K = 1,L1
                  DO 1004 M = 1,MP
                      CH(M,I-1,K,J) = WA(IDIJ-1)*C1(M,I-1,K,J) +
     +                                WA(IDIJ)*C1(M,I,K,J)
                      CH(M,I,K,J) = WA(IDIJ-1)*C1(M,I,K,J) -
     +                              WA(IDIJ)*C1(M,I-1,K,J)
 1004             CONTINUE
  104         CONTINUE
  105     CONTINUE
  106 CONTINUE
      GO TO 111
  107 IS = -IDO
      DO 110 J = 2,IP
          IS = IS + IDO
          DO 109 K = 1,L1
              IDIJ = IS
              DO 108 I = 3,IDO,2
                  IDIJ = IDIJ + 2
                  DO 1008 M = 1,MP
                      CH(M,I-1,K,J) = WA(IDIJ-1)*C1(M,I-1,K,J) +
     +                                WA(IDIJ)*C1(M,I,K,J)
                      CH(M,I,K,J) = WA(IDIJ-1)*C1(M,I,K,J) -
     +                              WA(IDIJ)*C1(M,I-1,K,J)
 1008             CONTINUE
  108         CONTINUE
  109     CONTINUE
  110 CONTINUE
  111 IF (NBD.LT.L1) GO TO 115
      DO 114 J = 2,IPPH
          JC = IPP2 - J
          DO 113 K = 1,L1
              DO 112 I = 3,IDO,2
                  DO 1012 M = 1,MP
                      C1(M,I-1,K,J) = CH(M,I-1,K,J) + CH(M,I-1,K,JC)
                      C1(M,I-1,K,JC) = CH(M,I,K,J) - CH(M,I,K,JC)
                      C1(M,I,K,J) = CH(M,I,K,J) + CH(M,I,K,JC)
                      C1(M,I,K,JC) = CH(M,I-1,K,JC) - CH(M,I-1,K,J)
 1012             CONTINUE
  112         CONTINUE
  113     CONTINUE
  114 CONTINUE
      GO TO 121
  115 DO 118 J = 2,IPPH
          JC = IPP2 - J
          DO 117 I = 3,IDO,2
              DO 116 K = 1,L1
                  DO 1016 M = 1,MP
                      C1(M,I-1,K,J) = CH(M,I-1,K,J) + CH(M,I-1,K,JC)
                      C1(M,I-1,K,JC) = CH(M,I,K,J) - CH(M,I,K,JC)
                      C1(M,I,K,J) = CH(M,I,K,J) + CH(M,I,K,JC)
                      C1(M,I,K,JC) = CH(M,I-1,K,JC) - CH(M,I-1,K,J)
 1016             CONTINUE
  116         CONTINUE
  117     CONTINUE
  118 CONTINUE
      GO TO 121
  119 DO 120 IK = 1,IDL1
          DO 1020 M = 1,MP
              C2(M,IK,1) = CH2(M,IK,1)
 1020     CONTINUE
  120 CONTINUE
  121 DO 123 J = 2,IPPH
          JC = IPP2 - J
          DO 122 K = 1,L1
              DO 1022 M = 1,MP
                  C1(M,1,K,J) = CH(M,1,K,J) + CH(M,1,K,JC)
                  C1(M,1,K,JC) = CH(M,1,K,JC) - CH(M,1,K,J)
 1022         CONTINUE
  122     CONTINUE
  123 CONTINUE
c
      AR1 = 1.D0
      AI1 = 0.D0
      DO 127 L = 2,IPPH
          LC = IPP2 - L
          AR1H = DCP*AR1 - DSP*AI1
          AI1 = DCP*AI1 + DSP*AR1
          AR1 = AR1H
          DO 124 IK = 1,IDL1
              DO 1024 M = 1,MP
                  CH2(M,IK,L) = C2(M,IK,1) + AR1*C2(M,IK,2)
                  CH2(M,IK,LC) = AI1*C2(M,IK,IP)
 1024         CONTINUE
  124     CONTINUE
          DC2 = AR1
          DS2 = AI1
          AR2 = AR1
          AI2 = AI1
          DO 126 J = 3,IPPH
              JC = IPP2 - J
              AR2H = DC2*AR2 - DS2*AI2
              AI2 = DC2*AI2 + DS2*AR2
              AR2 = AR2H
              DO 125 IK = 1,IDL1
                  DO 1025 M = 1,MP
                      CH2(M,IK,L) = CH2(M,IK,L) + AR2*C2(M,IK,J)
                      CH2(M,IK,LC) = CH2(M,IK,LC) + AI2*C2(M,IK,JC)
 1025             CONTINUE
  125         CONTINUE
  126     CONTINUE
  127 CONTINUE
      DO 129 J = 2,IPPH
          DO 128 IK = 1,IDL1
              DO 1028 M = 1,MP
                  CH2(M,IK,1) = CH2(M,IK,1) + C2(M,IK,J)
 1028         CONTINUE
  128     CONTINUE
  129 CONTINUE
c
      IF (IDO.LT.L1) GO TO 132
      DO 131 K = 1,L1
          DO 130 I = 1,IDO
              DO 1030 M = 1,MP
                  CC(M,I,1,K) = CH(M,I,K,1)
 1030         CONTINUE
  130     CONTINUE
  131 CONTINUE
      GO TO 135
  132 DO 134 I = 1,IDO
          DO 133 K = 1,L1
              DO 1033 M = 1,MP
                  CC(M,I,1,K) = CH(M,I,K,1)
 1033         CONTINUE
  133     CONTINUE
  134 CONTINUE
  135 DO 137 J = 2,IPPH
          JC = IPP2 - J
          J2 = J + J
          DO 136 K = 1,L1
              DO 1036 M = 1,MP
                  CC(M,IDO,J2-2,K) = CH(M,1,K,J)
                  CC(M,1,J2-1,K) = CH(M,1,K,JC)
 1036         CONTINUE
  136     CONTINUE
  137 CONTINUE
      IF (IDO.EQ.1) RETURN
      IF (NBD.LT.L1) GO TO 141
      DO 140 J = 2,IPPH
          JC = IPP2 - J
          J2 = J + J
          DO 139 K = 1,L1
              DO 138 I = 3,IDO,2
                  IC = IDP2 - I
                  DO 1038 M = 1,MP
                      CC(M,I-1,J2-1,K) = CH(M,I-1,K,J) + CH(M,I-1,K,JC)
                      CC(M,IC-1,J2-2,K) = CH(M,I-1,K,J) - CH(M,I-1,K,JC)
                      CC(M,I,J2-1,K) = CH(M,I,K,J) + CH(M,I,K,JC)
                      CC(M,IC,J2-2,K) = CH(M,I,K,JC) - CH(M,I,K,J)
 1038             CONTINUE
  138         CONTINUE
  139     CONTINUE
  140 CONTINUE
      RETURN
  141 DO 144 J = 2,IPPH
          JC = IPP2 - J
          J2 = J + J
          DO 143 I = 3,IDO,2
              IC = IDP2 - I
              DO 142 K = 1,L1
                  DO 1042 M = 1,MP
                      CC(M,I-1,J2-1,K) = CH(M,I-1,K,J) + CH(M,I-1,K,JC)
                      CC(M,IC-1,J2-2,K) = CH(M,I-1,K,J) - CH(M,I-1,K,JC)
                      CC(M,I,J2-1,K) = CH(M,I,K,J) + CH(M,I,K,JC)
                      CC(M,IC,J2-2,K) = CH(M,I,K,JC) - CH(M,I,K,J)
 1042             CONTINUE
  142         CONTINUE
  143     CONTINUE
  144 CONTINUE
      RETURN
      END
      FUNCTION DPIMACH()
      DOUBLE PRECISION DPIMACH

      DPIMACH = 3.14159265358979D0
      RETURN
      END
      SUBROUTINE DHRFFTB(M,N,R,MDIMR,WHRFFT,WORK)
      DOUBLE PRECISION R
      DOUBLE PRECISION WHRFFT
      DOUBLE PRECISION WORK
      DOUBLE PRECISION TFFT
c
c     a multiple fft package for spherepack
c
      DIMENSION R(MDIMR,N),WORK(1),WHRFFT(N+15)
      COMMON /HRF/TFFT

      IF (N.EQ.1) RETURN
c     tstart = second(dum)
      CALL DHRFTB1(M,N,R,MDIMR,WORK,WHRFFT,WHRFFT(N+1))
c     tfft = tfft+second(dum)-tstart
      RETURN
      END
      SUBROUTINE DHRFTB1(M,N,C,MDIMC,CH,WA,FAC)
      DOUBLE PRECISION C
      DOUBLE PRECISION CH
      DOUBLE PRECISION WA
      DOUBLE PRECISION FAC
c
c     a multiple fft package for spherepack
c
      DIMENSION CH(M,N),C(MDIMC,N),WA(N),FAC(15)

      NF = FAC(2)
      NA = 0
      L1 = 1
      IW = 1
      DO 116 K1 = 1,NF
          IP = FAC(K1+2)
          L2 = IP*L1
          IDO = N/L2
          IDL1 = IDO*L1
          IF (IP.NE.4) GO TO 103
          IX2 = IW + IDO
          IX3 = IX2 + IDO
          IF (NA.NE.0) GO TO 101
          CALL DHRADB4(M,IDO,L1,C,MDIMC,CH,M,WA(IW),WA(IX2),WA(IX3))
          GO TO 102
  101     CALL DHRADB4(M,IDO,L1,CH,M,C,MDIMC,WA(IW),WA(IX2),WA(IX3))
  102     NA = 1 - NA
          GO TO 115
  103     IF (IP.NE.2) GO TO 106
          IF (NA.NE.0) GO TO 104
          CALL DHRADB2(M,IDO,L1,C,MDIMC,CH,M,WA(IW))
          GO TO 105
  104     CALL DHRADB2(M,IDO,L1,CH,M,C,MDIMC,WA(IW))
  105     NA = 1 - NA
          GO TO 115
  106     IF (IP.NE.3) GO TO 109
          IX2 = IW + IDO
          IF (NA.NE.0) GO TO 107
          CALL DHRADB3(M,IDO,L1,C,MDIMC,CH,M,WA(IW),WA(IX2))
          GO TO 108
  107     CALL DHRADB3(M,IDO,L1,CH,M,C,MDIMC,WA(IW),WA(IX2))
  108     NA = 1 - NA
          GO TO 115
  109     IF (IP.NE.5) GO TO 112
          IX2 = IW + IDO
          IX3 = IX2 + IDO
          IX4 = IX3 + IDO
          IF (NA.NE.0) GO TO 110
          CALL DHRADB5(M,IDO,L1,C,MDIMC,CH,M,WA(IW),WA(IX2),WA(IX3),
     +                WA(IX4))
          GO TO 111
  110     CALL DHRADB5(M,IDO,L1,CH,M,C,MDIMC,WA(IW),WA(IX2),WA(IX3),
     +                WA(IX4))
  111     NA = 1 - NA
          GO TO 115
  112     IF (NA.NE.0) GO TO 113
          CALL DHRADBG(M,IDO,IP,L1,IDL1,C,C,C,MDIMC,CH,CH,M,WA(IW))
          GO TO 114
  113     CALL DHRADBG(M,IDO,IP,L1,IDL1,CH,CH,CH,M,C,C,MDIMC,WA(IW))
  114     IF (IDO.EQ.1) NA = 1 - NA
  115     L1 = L2
          IW = IW + (IP-1)*IDO
  116 CONTINUE
      IF (NA.EQ.0) RETURN
      DO 117 J = 1,N
          DO 117 I = 1,M
              C(I,J) = CH(I,J)
  117 CONTINUE
      RETURN
      END
      SUBROUTINE DHRADBG(MP,IDO,IP,L1,IDL1,CC,C1,C2,MDIMCC,CH,CH2,
     +                   MDIMCH,WA)
      DOUBLE PRECISION CC
      DOUBLE PRECISION C1
      DOUBLE PRECISION C2
      DOUBLE PRECISION CH
      DOUBLE PRECISION CH2
      DOUBLE PRECISION WA
      DOUBLE PRECISION TPI
      DOUBLE PRECISION DPIMACH
      DOUBLE PRECISION ARG
      DOUBLE PRECISION DCP
      DOUBLE PRECISION DSP
      DOUBLE PRECISION AR1
      DOUBLE PRECISION AI1
      DOUBLE PRECISION AR1H
      DOUBLE PRECISION DC2
      DOUBLE PRECISION DS2
      DOUBLE PRECISION AR2
      DOUBLE PRECISION AI2
      DOUBLE PRECISION AR2H
c
c     a multiple fft package for spherepack
c
      DIMENSION CH(MDIMCH,IDO,L1,IP),CC(MDIMCC,IDO,IP,L1),
     +          C1(MDIMCC,IDO,L1,IP),C2(MDIMCC,IDL1,IP),
     +          CH2(MDIMCH,IDL1,IP),WA(IDO)

      TPI = 2.D0*DPIMACH()
      ARG = TPI/DBLE(IP)
      DCP = COS(ARG)
      DSP = SIN(ARG)
      IDP2 = IDO + 2
      NBD = (IDO-1)/2
      IPP2 = IP + 2
      IPPH = (IP+1)/2
      IF (IDO.LT.L1) GO TO 103
      DO 102 K = 1,L1
          DO 101 I = 1,IDO
              DO 1001 M = 1,MP
                  CH(M,I,K,1) = CC(M,I,1,K)
 1001         CONTINUE
  101     CONTINUE
  102 CONTINUE
      GO TO 106
  103 DO 105 I = 1,IDO
          DO 104 K = 1,L1
              DO 1004 M = 1,MP
                  CH(M,I,K,1) = CC(M,I,1,K)
 1004         CONTINUE
  104     CONTINUE
  105 CONTINUE
  106 DO 108 J = 2,IPPH
          JC = IPP2 - J
          J2 = J + J
          DO 107 K = 1,L1
              DO 1007 M = 1,MP
                  CH(M,1,K,J) = CC(M,IDO,J2-2,K) + CC(M,IDO,J2-2,K)
                  CH(M,1,K,JC) = CC(M,1,J2-1,K) + CC(M,1,J2-1,K)
 1007         CONTINUE
  107     CONTINUE
  108 CONTINUE
      IF (IDO.EQ.1) GO TO 116
      IF (NBD.LT.L1) GO TO 112
      DO 111 J = 2,IPPH
          JC = IPP2 - J
          DO 110 K = 1,L1
              DO 109 I = 3,IDO,2
                  IC = IDP2 - I
                  DO 1009 M = 1,MP
                      CH(M,I-1,K,J) = CC(M,I-1,2*J-1,K) +
     +                                CC(M,IC-1,2*J-2,K)
                      CH(M,I-1,K,JC) = CC(M,I-1,2*J-1,K) -
     +                                 CC(M,IC-1,2*J-2,K)
                      CH(M,I,K,J) = CC(M,I,2*J-1,K) - CC(M,IC,2*J-2,K)
                      CH(M,I,K,JC) = CC(M,I,2*J-1,K) + CC(M,IC,2*J-2,K)
 1009             CONTINUE
  109         CONTINUE
  110     CONTINUE
  111 CONTINUE
      GO TO 116
  112 DO 115 J = 2,IPPH
          JC = IPP2 - J
          DO 114 I = 3,IDO,2
              IC = IDP2 - I
              DO 113 K = 1,L1
                  DO 1013 M = 1,MP
                      CH(M,I-1,K,J) = CC(M,I-1,2*J-1,K) +
     +                                CC(M,IC-1,2*J-2,K)
                      CH(M,I-1,K,JC) = CC(M,I-1,2*J-1,K) -
     +                                 CC(M,IC-1,2*J-2,K)
                      CH(M,I,K,J) = CC(M,I,2*J-1,K) - CC(M,IC,2*J-2,K)
                      CH(M,I,K,JC) = CC(M,I,2*J-1,K) + CC(M,IC,2*J-2,K)
 1013             CONTINUE
  113         CONTINUE
  114     CONTINUE
  115 CONTINUE
  116 AR1 = 1.D0
      AI1 = 0.D0
      DO 120 L = 2,IPPH
          LC = IPP2 - L
          AR1H = DCP*AR1 - DSP*AI1
          AI1 = DCP*AI1 + DSP*AR1
          AR1 = AR1H
          DO 117 IK = 1,IDL1
              DO 1017 M = 1,MP
                  C2(M,IK,L) = CH2(M,IK,1) + AR1*CH2(M,IK,2)
                  C2(M,IK,LC) = AI1*CH2(M,IK,IP)
 1017         CONTINUE
  117     CONTINUE
          DC2 = AR1
          DS2 = AI1
          AR2 = AR1
          AI2 = AI1
          DO 119 J = 3,IPPH
              JC = IPP2 - J
              AR2H = DC2*AR2 - DS2*AI2
              AI2 = DC2*AI2 + DS2*AR2
              AR2 = AR2H
              DO 118 IK = 1,IDL1
                  DO 1018 M = 1,MP
                      C2(M,IK,L) = C2(M,IK,L) + AR2*CH2(M,IK,J)
                      C2(M,IK,LC) = C2(M,IK,LC) + AI2*CH2(M,IK,JC)
 1018             CONTINUE
  118         CONTINUE
  119     CONTINUE
  120 CONTINUE
      DO 122 J = 2,IPPH
          DO 121 IK = 1,IDL1
              DO 1021 M = 1,MP
                  CH2(M,IK,1) = CH2(M,IK,1) + CH2(M,IK,J)
 1021         CONTINUE
  121     CONTINUE
  122 CONTINUE
      DO 124 J = 2,IPPH
          JC = IPP2 - J
          DO 123 K = 1,L1
              DO 1023 M = 1,MP
                  CH(M,1,K,J) = C1(M,1,K,J) - C1(M,1,K,JC)
                  CH(M,1,K,JC) = C1(M,1,K,J) + C1(M,1,K,JC)
 1023         CONTINUE
  123     CONTINUE
  124 CONTINUE
      IF (IDO.EQ.1) GO TO 132
      IF (NBD.LT.L1) GO TO 128
      DO 127 J = 2,IPPH
          JC = IPP2 - J
          DO 126 K = 1,L1
              DO 125 I = 3,IDO,2
                  DO 1025 M = 1,MP
                      CH(M,I-1,K,J) = C1(M,I-1,K,J) - C1(M,I,K,JC)
                      CH(M,I-1,K,JC) = C1(M,I-1,K,J) + C1(M,I,K,JC)
                      CH(M,I,K,J) = C1(M,I,K,J) + C1(M,I-1,K,JC)
                      CH(M,I,K,JC) = C1(M,I,K,J) - C1(M,I-1,K,JC)
 1025             CONTINUE
  125         CONTINUE
  126     CONTINUE
  127 CONTINUE
      GO TO 132
  128 DO 131 J = 2,IPPH
          JC = IPP2 - J
          DO 130 I = 3,IDO,2
              DO 129 K = 1,L1
                  DO 1029 M = 1,MP
                      CH(M,I-1,K,J) = C1(M,I-1,K,J) - C1(M,I,K,JC)
                      CH(M,I-1,K,JC) = C1(M,I-1,K,J) + C1(M,I,K,JC)
                      CH(M,I,K,J) = C1(M,I,K,J) + C1(M,I-1,K,JC)
                      CH(M,I,K,JC) = C1(M,I,K,J) - C1(M,I-1,K,JC)
 1029             CONTINUE
  129         CONTINUE
  130     CONTINUE
  131 CONTINUE
  132 CONTINUE
      IF (IDO.EQ.1) RETURN
      DO 133 IK = 1,IDL1
          DO 1033 M = 1,MP
              C2(M,IK,1) = CH2(M,IK,1)
 1033     CONTINUE
  133 CONTINUE
      DO 135 J = 2,IP
          DO 134 K = 1,L1
              DO 1034 M = 1,MP
                  C1(M,1,K,J) = CH(M,1,K,J)
 1034         CONTINUE
  134     CONTINUE
  135 CONTINUE
      IF (NBD.GT.L1) GO TO 139
      IS = -IDO
      DO 138 J = 2,IP
          IS = IS + IDO
          IDIJ = IS
          DO 137 I = 3,IDO,2
              IDIJ = IDIJ + 2
              DO 136 K = 1,L1
                  DO 1036 M = 1,MP
                      C1(M,I-1,K,J) = WA(IDIJ-1)*CH(M,I-1,K,J) -
     +                                WA(IDIJ)*CH(M,I,K,J)
                      C1(M,I,K,J) = WA(IDIJ-1)*CH(M,I,K,J) +
     +                              WA(IDIJ)*CH(M,I-1,K,J)
 1036             CONTINUE
  136         CONTINUE
  137     CONTINUE
  138 CONTINUE
      GO TO 143
  139 IS = -IDO
      DO 142 J = 2,IP
          IS = IS + IDO
          DO 141 K = 1,L1
              IDIJ = IS
              DO 140 I = 3,IDO,2
                  IDIJ = IDIJ + 2
                  DO 1040 M = 1,MP
                      C1(M,I-1,K,J) = WA(IDIJ-1)*CH(M,I-1,K,J) -
     +                                WA(IDIJ)*CH(M,I,K,J)
                      C1(M,I,K,J) = WA(IDIJ-1)*CH(M,I,K,J) +
     +                              WA(IDIJ)*CH(M,I-1,K,J)
 1040             CONTINUE
  140         CONTINUE
  141     CONTINUE
  142 CONTINUE
  143 RETURN
      END
      SUBROUTINE DHRADB4(MP,IDO,L1,CC,MDIMCC,CH,MDIMCH,WA1,WA2,WA3)
      DOUBLE PRECISION CC
      DOUBLE PRECISION CH
      DOUBLE PRECISION WA1
      DOUBLE PRECISION WA2
      DOUBLE PRECISION WA3
      DOUBLE PRECISION SQRT2
c
c     a multiple fft package for spherepack
c
      DIMENSION CC(MDIMCC,IDO,4,L1),CH(MDIMCH,IDO,L1,4),WA1(IDO),
     +          WA2(IDO),WA3(IDO)

      SQRT2 = SQRT(2.D0)
      DO 101 K = 1,L1
          DO 1001 M = 1,MP
              CH(M,1,K,3) = (CC(M,1,1,K)+CC(M,IDO,4,K)) -
     +                      (CC(M,IDO,2,K)+CC(M,IDO,2,K))
              CH(M,1,K,1) = (CC(M,1,1,K)+CC(M,IDO,4,K)) +
     +                      (CC(M,IDO,2,K)+CC(M,IDO,2,K))
              CH(M,1,K,4) = (CC(M,1,1,K)-CC(M,IDO,4,K)) +
     +                      (CC(M,1,3,K)+CC(M,1,3,K))
              CH(M,1,K,2) = (CC(M,1,1,K)-CC(M,IDO,4,K)) -
     +                      (CC(M,1,3,K)+CC(M,1,3,K))
 1001     CONTINUE
  101 CONTINUE
      IF (IDO-2) 107,105,102
  102 IDP2 = IDO + 2
      DO 104 K = 1,L1
          DO 103 I = 3,IDO,2
              IC = IDP2 - I
              DO 1002 M = 1,MP
                  CH(M,I-1,K,1) = (CC(M,I-1,1,K)+CC(M,IC-1,4,K)) +
     +                            (CC(M,I-1,3,K)+CC(M,IC-1,2,K))
                  CH(M,I,K,1) = (CC(M,I,1,K)-CC(M,IC,4,K)) +
     +                          (CC(M,I,3,K)-CC(M,IC,2,K))
                  CH(M,I-1,K,2) = WA1(I-2)* ((CC(M,I-1,1,K)-CC(M,IC-1,4,
     +                            K))- (CC(M,I,3,K)+CC(M,IC,2,K))) -
     +                            WA1(I-1)* ((CC(M,I,1,K)+CC(M,IC,4,K))+
     +                            (CC(M,I-1,3,K)-CC(M,IC-1,2,K)))
                  CH(M,I,K,2) = WA1(I-2)* ((CC(M,I,1,K)+CC(M,IC,4,K))+
     +                          (CC(M,I-1,3,K)-CC(M,IC-1,2,K))) +
     +                          WA1(I-1)* ((CC(M,I-1,1,K)-CC(M,IC-1,4,
     +                          K))- (CC(M,I,3,K)+CC(M,IC,2,K)))
                  CH(M,I-1,K,3) = WA2(I-2)* ((CC(M,I-1,1,K)+CC(M,IC-1,4,
     +                            K))- (CC(M,I-1,3,K)+CC(M,IC-1,2,K))) -
     +                            WA2(I-1)* ((CC(M,I,1,K)-CC(M,IC,4,K))-
     +                            (CC(M,I,3,K)-CC(M,IC,2,K)))
                  CH(M,I,K,3) = WA2(I-2)* ((CC(M,I,1,K)-CC(M,IC,4,K))-
     +                          (CC(M,I,3,K)-CC(M,IC,2,K))) +
     +                          WA2(I-1)* ((CC(M,I-1,1,K)+CC(M,IC-1,4,
     +                          K))- (CC(M,I-1,3,K)+CC(M,IC-1,2,K)))
                  CH(M,I-1,K,4) = WA3(I-2)* ((CC(M,I-1,1,K)-CC(M,IC-1,4,
     +                            K))+ (CC(M,I,3,K)+CC(M,IC,2,K))) -
     +                            WA3(I-1)* ((CC(M,I,1,K)+CC(M,IC,4,K))-
     +                            (CC(M,I-1,3,K)-CC(M,IC-1,2,K)))
                  CH(M,I,K,4) = WA3(I-2)* ((CC(M,I,1,K)+CC(M,IC,4,K))-
     +                          (CC(M,I-1,3,K)-CC(M,IC-1,2,K))) +
     +                          WA3(I-1)* ((CC(M,I-1,1,K)-CC(M,IC-1,4,
     +                          K))+ (CC(M,I,3,K)+CC(M,IC,2,K)))
 1002         CONTINUE
  103     CONTINUE
  104 CONTINUE
      IF (MOD(IDO,2).EQ.1) RETURN
  105 CONTINUE
      DO 106 K = 1,L1
          DO 1003 M = 1,MP
              CH(M,IDO,K,1) = (CC(M,IDO,1,K)+CC(M,IDO,3,K)) +
     +                        (CC(M,IDO,1,K)+CC(M,IDO,3,K))
              CH(M,IDO,K,2) = SQRT2* ((CC(M,IDO,1,K)-CC(M,IDO,3,K))-
     +                        (CC(M,1,2,K)+CC(M,1,4,K)))
              CH(M,IDO,K,3) = (CC(M,1,4,K)-CC(M,1,2,K)) +
     +                        (CC(M,1,4,K)-CC(M,1,2,K))
              CH(M,IDO,K,4) = -SQRT2* ((CC(M,IDO,1,K)-CC(M,IDO,3,K))+
     +                        (CC(M,1,2,K)+CC(M,1,4,K)))
 1003     CONTINUE
  106 CONTINUE
  107 RETURN
      END
      SUBROUTINE DHRADB2(MP,IDO,L1,CC,MDIMCC,CH,MDIMCH,WA1)
      DOUBLE PRECISION CC
      DOUBLE PRECISION CH
      DOUBLE PRECISION WA1
c
c     a multiple fft package for spherepack
c
      DIMENSION CC(MDIMCC,IDO,2,L1),CH(MDIMCH,IDO,L1,2),WA1(IDO)

      DO 101 K = 1,L1
          DO 1001 M = 1,MP
              CH(M,1,K,1) = CC(M,1,1,K) + CC(M,IDO,2,K)
              CH(M,1,K,2) = CC(M,1,1,K) - CC(M,IDO,2,K)
 1001     CONTINUE
  101 CONTINUE
      IF (IDO-2) 107,105,102
  102 IDP2 = IDO + 2
      DO 104 K = 1,L1
          DO 103 I = 3,IDO,2
              IC = IDP2 - I
              DO 1002 M = 1,MP
                  CH(M,I-1,K,1) = CC(M,I-1,1,K) + CC(M,IC-1,2,K)
                  CH(M,I,K,1) = CC(M,I,1,K) - CC(M,IC,2,K)
                  CH(M,I-1,K,2) = WA1(I-2)* (CC(M,I-1,1,K)-
     +                            CC(M,IC-1,2,K)) -
     +                            WA1(I-1)* (CC(M,I,1,K)+CC(M,IC,2,K))
                  CH(M,I,K,2) = WA1(I-2)* (CC(M,I,1,K)+CC(M,IC,2,K)) +
     +                          WA1(I-1)* (CC(M,I-1,1,K)-CC(M,IC-1,2,K))
 1002         CONTINUE
  103     CONTINUE
  104 CONTINUE
      IF (MOD(IDO,2).EQ.1) RETURN
  105 DO 106 K = 1,L1
          DO 1003 M = 1,MP
              CH(M,IDO,K,1) = CC(M,IDO,1,K) + CC(M,IDO,1,K)
              CH(M,IDO,K,2) = - (CC(M,1,2,K)+CC(M,1,2,K))
 1003     CONTINUE
  106 CONTINUE
  107 RETURN
      END
      SUBROUTINE DHRADB3(MP,IDO,L1,CC,MDIMCC,CH,MDIMCH,WA1,WA2)
      DOUBLE PRECISION CC
      DOUBLE PRECISION CH
      DOUBLE PRECISION WA1
      DOUBLE PRECISION WA2
      DOUBLE PRECISION ARG
      DOUBLE PRECISION DPIMACH
      DOUBLE PRECISION TAUR
      DOUBLE PRECISION TAUI
c
c     a multiple fft package for spherepack
c
      DIMENSION CC(MDIMCC,IDO,3,L1),CH(MDIMCH,IDO,L1,3),WA1(IDO),
     +          WA2(IDO)

      ARG = 2.D0*DPIMACH()/3.D0
      TAUR = COS(ARG)
      TAUI = SIN(ARG)
      DO 101 K = 1,L1
          DO 1001 M = 1,MP
              CH(M,1,K,1) = CC(M,1,1,K) + 2.D0*CC(M,IDO,2,K)
              CH(M,1,K,2) = CC(M,1,1,K) + (2.D0*TAUR)*CC(M,IDO,2,K) -
     +                      (2.D0*TAUI)*CC(M,1,3,K)
              CH(M,1,K,3) = CC(M,1,1,K) + (2.D0*TAUR)*CC(M,IDO,2,K) +
     +                      2.D0*TAUI*CC(M,1,3,K)
 1001     CONTINUE
  101 CONTINUE
      IF (IDO.EQ.1) RETURN
      IDP2 = IDO + 2
      DO 103 K = 1,L1
          DO 102 I = 3,IDO,2
              IC = IDP2 - I
              DO 1002 M = 1,MP
                  CH(M,I-1,K,1) = CC(M,I-1,1,K) +
     +                            (CC(M,I-1,3,K)+CC(M,IC-1,2,K))
                  CH(M,I,K,1) = CC(M,I,1,K) + (CC(M,I,3,K)-CC(M,IC,2,K))
                  CH(M,I-1,K,2) = WA1(I-2)* ((CC(M,I-1,1,K)+TAUR* (CC(M,
     +                            I-1,3,K)+CC(M,IC-1,2,K)))-
     +                            (TAUI* (CC(M,I,3,K)+CC(M,IC,2,K)))) -
     +                            WA1(I-1)* ((CC(M,I,1,K)+TAUR* (CC(M,I,
     +                            3,K)-CC(M,IC,2,K)))+
     +                            (TAUI* (CC(M,I-1,3,K)-CC(M,IC-1,2,
     +                            K))))
                  CH(M,I,K,2) = WA1(I-2)* ((CC(M,I,1,K)+TAUR* (CC(M,I,3,
     +                          K)-CC(M,IC,2,K)))+ (TAUI* (CC(M,I-1,3,
     +                          K)-CC(M,IC-1,2,K)))) +
     +                          WA1(I-1)* ((CC(M,I-1,1,K)+TAUR* (CC(M,
     +                          I-1,3,K)+CC(M,IC-1,2,K)))-
     +                          (TAUI* (CC(M,I,3,K)+CC(M,IC,2,K))))
                  CH(M,I-1,K,3) = WA2(I-2)* ((CC(M,I-1,1,K)+TAUR* (CC(M,
     +                            I-1,3,K)+CC(M,IC-1,2,K)))+
     +                            (TAUI* (CC(M,I,3,K)+CC(M,IC,2,K)))) -
     +                            WA2(I-1)* ((CC(M,I,1,K)+TAUR* (CC(M,I,
     +                            3,K)-CC(M,IC,2,K)))-
     +                            (TAUI* (CC(M,I-1,3,K)-CC(M,IC-1,2,
     +                            K))))
                  CH(M,I,K,3) = WA2(I-2)* ((CC(M,I,1,K)+TAUR* (CC(M,I,3,
     +                          K)-CC(M,IC,2,K)))- (TAUI* (CC(M,I-1,3,
     +                          K)-CC(M,IC-1,2,K)))) +
     +                          WA2(I-1)* ((CC(M,I-1,1,K)+TAUR* (CC(M,
     +                          I-1,3,K)+CC(M,IC-1,2,K)))+
     +                          (TAUI* (CC(M,I,3,K)+CC(M,IC,2,K))))
 1002         CONTINUE
  102     CONTINUE
  103 CONTINUE
      RETURN
      END
      SUBROUTINE DHRADB5(MP,IDO,L1,CC,MDIMCC,CH,MDIMCH,WA1,WA2,WA3,WA4)
      DOUBLE PRECISION CC
      DOUBLE PRECISION CH
      DOUBLE PRECISION WA1
      DOUBLE PRECISION WA2
      DOUBLE PRECISION WA3
      DOUBLE PRECISION WA4
      DOUBLE PRECISION ARG
      DOUBLE PRECISION DPIMACH
      DOUBLE PRECISION TR11
      DOUBLE PRECISION TI11
      DOUBLE PRECISION TR12
      DOUBLE PRECISION TI12
c
c     a multiple fft package for spherepack
c
      DIMENSION CC(MDIMCC,IDO,5,L1),CH(MDIMCH,IDO,L1,5),WA1(IDO),
     +          WA2(IDO),WA3(IDO),WA4(IDO)

      ARG = 2.D0*DPIMACH()/5.D0
      TR11 = COS(ARG)
      TI11 = SIN(ARG)
      TR12 = COS(2.D0*ARG)
      TI12 = SIN(2.D0*ARG)
      DO 101 K = 1,L1
          DO 1001 M = 1,MP
              CH(M,1,K,1) = CC(M,1,1,K) + 2.D0*CC(M,IDO,2,K) +
     +                      2.D0*CC(M,IDO,4,K)
              CH(M,1,K,2) = (CC(M,1,1,K)+TR11*2.D0*CC(M,IDO,2,K)+
     +                      TR12*2.D0*CC(M,IDO,4,K)) -
     +                      (TI11*2.D0*CC(M,1,3,K)+
     +                      TI12*2.D0*CC(M,1,5,K))
              CH(M,1,K,3) = (CC(M,1,1,K)+TR12*2.D0*CC(M,IDO,2,K)+
     +                      TR11*2.D0*CC(M,IDO,4,K)) -
     +                      (TI12*2.D0*CC(M,1,3,K)-
     +                      TI11*2.D0*CC(M,1,5,K))
              CH(M,1,K,4) = (CC(M,1,1,K)+TR12*2.D0*CC(M,IDO,2,K)+
     +                      TR11*2.D0*CC(M,IDO,4,K)) +
     +                      (TI12*2.D0*CC(M,1,3,K)-
     +                      TI11*2.D0*CC(M,1,5,K))
              CH(M,1,K,5) = (CC(M,1,1,K)+TR11*2.D0*CC(M,IDO,2,K)+
     +                      TR12*2.D0*CC(M,IDO,4,K)) +
     +                      (TI11*2.D0*CC(M,1,3,K)+
     +                      TI12*2.D0*CC(M,1,5,K))
 1001     CONTINUE
  101 CONTINUE
      IF (IDO.EQ.1) RETURN
      IDP2 = IDO + 2
      DO 103 K = 1,L1
          DO 102 I = 3,IDO,2
              IC = IDP2 - I
              DO 1002 M = 1,MP
                  CH(M,I-1,K,1) = CC(M,I-1,1,K) +
     +                            (CC(M,I-1,3,K)+CC(M,IC-1,2,K)) +
     +                            (CC(M,I-1,5,K)+CC(M,IC-1,4,K))
                  CH(M,I,K,1) = CC(M,I,1,K) +
     +                          (CC(M,I,3,K)-CC(M,IC,2,K)) +
     +                          (CC(M,I,5,K)-CC(M,IC,4,K))
                  CH(M,I-1,K,2) = WA1(I-2)* ((CC(M,I-1,1,K)+TR11* (CC(M,
     +                            I-1,3,K)+CC(M,IC-1,2,K))+TR12* (CC(M,
     +                            I-1,5,K)+CC(M,IC-1,4,K)))-
     +                            (TI11* (CC(M,I,3,K)+CC(M,IC,2,
     +                            K))+TI12* (CC(M,I,5,K)+CC(M,IC,4,K))))
     +                            - WA1(I-1)* ((CC(M,I,1,K)+TR11* (CC(M,
     +                            I,3,K)-CC(M,IC,2,K))+TR12* (CC(M,I,5,
     +                            K)-CC(M,IC,4,K)))+
     +                            (TI11* (CC(M,I-1,3,K)-CC(M,IC-1,2,
     +                            K))+TI12* (CC(M,I-1,5,K)-CC(M,IC-1,4,
     +                            K))))
                  CH(M,I,K,2) = WA1(I-2)* ((CC(M,I,1,K)+TR11* (CC(M,I,3,
     +                          K)-CC(M,IC,2,K))+TR12* (CC(M,I,5,
     +                          K)-CC(M,IC,4,K)))+ (TI11* (CC(M,I-1,3,
     +                          K)-CC(M,IC-1,2,K))+TI12* (CC(M,I-1,5,
     +                          K)-CC(M,IC-1,4,K)))) +
     +                          WA1(I-1)* ((CC(M,I-1,1,K)+TR11* (CC(M,
     +                          I-1,3,K)+CC(M,IC-1,2,K))+TR12* (CC(M,
     +                          I-1,5,K)+CC(M,IC-1,4,K)))-
     +                          (TI11* (CC(M,I,3,K)+CC(M,IC,2,
     +                          K))+TI12* (CC(M,I,5,K)+CC(M,IC,4,K))))
                  CH(M,I-1,K,3) = WA2(I-2)* ((CC(M,I-1,1,K)+TR12* (CC(M,
     +                            I-1,3,K)+CC(M,IC-1,2,K))+TR11* (CC(M,
     +                            I-1,5,K)+CC(M,IC-1,4,K)))-
     +                            (TI12* (CC(M,I,3,K)+CC(M,IC,2,
     +                            K))-TI11* (CC(M,I,5,K)+CC(M,IC,4,K))))
     +                            - WA2(I-1)* ((CC(M,I,1,K)+TR12* (CC(M,
     +                            I,3,K)-CC(M,IC,2,K))+TR11* (CC(M,I,5,
     +                            K)-CC(M,IC,4,K)))+
     +                            (TI12* (CC(M,I-1,3,K)-CC(M,IC-1,2,
     +                            K))-TI11* (CC(M,I-1,5,K)-CC(M,IC-1,4,
     +                            K))))
                  CH(M,I,K,3) = WA2(I-2)* ((CC(M,I,1,K)+TR12* (CC(M,I,3,
     +                          K)-CC(M,IC,2,K))+TR11* (CC(M,I,5,
     +                          K)-CC(M,IC,4,K)))+ (TI12* (CC(M,I-1,3,
     +                          K)-CC(M,IC-1,2,K))-TI11* (CC(M,I-1,5,
     +                          K)-CC(M,IC-1,4,K)))) +
     +                          WA2(I-1)* ((CC(M,I-1,1,K)+TR12* (CC(M,
     +                          I-1,3,K)+CC(M,IC-1,2,K))+TR11* (CC(M,
     +                          I-1,5,K)+CC(M,IC-1,4,K)))-
     +                          (TI12* (CC(M,I,3,K)+CC(M,IC,2,
     +                          K))-TI11* (CC(M,I,5,K)+CC(M,IC,4,K))))
                  CH(M,I-1,K,4) = WA3(I-2)* ((CC(M,I-1,1,K)+TR12* (CC(M,
     +                            I-1,3,K)+CC(M,IC-1,2,K))+TR11* (CC(M,
     +                            I-1,5,K)+CC(M,IC-1,4,K)))+
     +                            (TI12* (CC(M,I,3,K)+CC(M,IC,2,
     +                            K))-TI11* (CC(M,I,5,K)+CC(M,IC,4,K))))
     +                            - WA3(I-1)* ((CC(M,I,1,K)+TR12* (CC(M,
     +                            I,3,K)-CC(M,IC,2,K))+TR11* (CC(M,I,5,
     +                            K)-CC(M,IC,4,K)))-
     +                            (TI12* (CC(M,I-1,3,K)-CC(M,IC-1,2,
     +                            K))-TI11* (CC(M,I-1,5,K)-CC(M,IC-1,4,
     +                            K))))
                  CH(M,I,K,4) = WA3(I-2)* ((CC(M,I,1,K)+TR12* (CC(M,I,3,
     +                          K)-CC(M,IC,2,K))+TR11* (CC(M,I,5,
     +                          K)-CC(M,IC,4,K)))- (TI12* (CC(M,I-1,3,
     +                          K)-CC(M,IC-1,2,K))-TI11* (CC(M,I-1,5,
     +                          K)-CC(M,IC-1,4,K)))) +
     +                          WA3(I-1)* ((CC(M,I-1,1,K)+TR12* (CC(M,
     +                          I-1,3,K)+CC(M,IC-1,2,K))+TR11* (CC(M,
     +                          I-1,5,K)+CC(M,IC-1,4,K)))+
     +                          (TI12* (CC(M,I,3,K)+CC(M,IC,2,
     +                          K))-TI11* (CC(M,I,5,K)+CC(M,IC,4,K))))
                  CH(M,I-1,K,5) = WA4(I-2)* ((CC(M,I-1,1,K)+TR11* (CC(M,
     +                            I-1,3,K)+CC(M,IC-1,2,K))+TR12* (CC(M,
     +                            I-1,5,K)+CC(M,IC-1,4,K)))+
     +                            (TI11* (CC(M,I,3,K)+CC(M,IC,2,
     +                            K))+TI12* (CC(M,I,5,K)+CC(M,IC,4,K))))
     +                            - WA4(I-1)* ((CC(M,I,1,K)+TR11* (CC(M,
     +                            I,3,K)-CC(M,IC,2,K))+TR12* (CC(M,I,5,
     +                            K)-CC(M,IC,4,K)))-
     +                            (TI11* (CC(M,I-1,3,K)-CC(M,IC-1,2,
     +                            K))+TI12* (CC(M,I-1,5,K)-CC(M,IC-1,4,
     +                            K))))
                  CH(M,I,K,5) = WA4(I-2)* ((CC(M,I,1,K)+TR11* (CC(M,I,3,
     +                          K)-CC(M,IC,2,K))+TR12* (CC(M,I,5,
     +                          K)-CC(M,IC,4,K)))- (TI11* (CC(M,I-1,3,
     +                          K)-CC(M,IC-1,2,K))+TI12* (CC(M,I-1,5,
     +                          K)-CC(M,IC-1,4,K)))) +
     +                          WA4(I-1)* ((CC(M,I-1,1,K)+TR11* (CC(M,
     +                          I-1,3,K)+CC(M,IC-1,2,K))+TR12* (CC(M,
     +                          I-1,5,K)+CC(M,IC-1,4,K)))+
     +                          (TI11* (CC(M,I,3,K)+CC(M,IC,2,
     +                          K))+TI12* (CC(M,I,5,K)+CC(M,IC,4,K))))
 1002         CONTINUE
  102     CONTINUE
  103 CONTINUE
      RETURN
      END

      PROGRAM CCPLLL
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER (MREG=50,NREG=50)
      REAL XREG(MREG),YREG(NREG),ZREG(MREG,NREG)

      EXTERNAL COLOR
C
C Get data array
C
      CALL GETDAT(XREG,YREG,ZREG,MREG,NREG)
C
C Open GKS
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)

C
C Call Conpack color fill routine
C
      CALL TCCPLLB(ZREG,MREG,NREG,COLOR,IWKID)
C
C Close frame and close GKS
C
      CALL FRAME
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS

      STOP
      END

      SUBROUTINE TCCPLLB(ZREG,MREG,NREG,COLOR,IWKID)
      
      PARAMETER (LRWK=5000,LIWK=5000,LMAP=50000,NWRK=5000,NOGRPS=5)
      REAL ZREG(MREG,NREG),RWRK(LRWK), XWRK(NWRK), YWRK(NWRK)
      INTEGER MREG,NREG,IWRK(LIWK)
      INTEGER MAP(LMAP),IAREA(NOGRPS),IGRP(NOGRPS)

      EXTERNAL FILL
      EXTERNAL CPDRPL
      EXTERNAL COLOR
C
C Set fill style to solid and turn off clipping
C
      CALL GSFAIS(1)
      CALL GSCLIP(0)
C
C Set up label box options
C
      CALL CPSETI('LLP - LINE LABEL POSITIONING FLAG',2)
      CALL CPSETI('LLB - LINE LABEL BOX FLAG',1)
      CALL CPSETI('HLB - HIGH/LOW LABEL BOX FLAG',1)
      CALL CPSETI('ILB - INFORMATIONAL LABEL BOX FLAG',1)
      CALL CPSETR('LLL - LINE LABEL LINE WIDTH',1.)
      CALL CPSETR('HLL - HIGH/LOW LABEL LINE WIDTH',3.)
      CALL CPSETR('ILL - INFORMATIONAL LABEL LINE WIDTH',5.)
C
C Set number of contour levels and initialize Conpack
C
      CALL CPRECT(ZREG, MREG, MREG, NREG, RWRK, LRWK, IWRK, LIWK)
C
C Set up color table
C
      CALL CPPKCL (ZREG, RWRK, IWRK)
      CALL CPGETI('NCL - NUMBER OF CONTOUR LEVELS',NCL)
      CALL COLOR(NCL+1,IWKID)
C
C Draw Perimeter
C
      CALL CPBACK(ZREG, RWRK, IWRK)
C
C Initialize Areas
C
      CALL ARINAM(MAP, LMAP)
C
C Add label boxes to area map
C
      CALL CPLBAM(ZREG, RWRK, IWRK, MAP)
C
C Draw Labels
C
      CALL CPLBDR(ZREG, RWRK, IWRK)
C
C Add contours to area map
C
      CALL CPCLAM(ZREG, RWRK, IWRK, MAP)
C
C Fill contours
C
      CALL ARSCAM(MAP, XWRK, YWRK, NWRK, IAREA, IGRP, NOGRPS, FILL)

      RETURN
      END

      SUBROUTINE FILL (XWRK,YWRK,NWRK,IAREA,IGRP,NGRPS)
C
      DIMENSION XWRK(*),YWRK(*),IAREA(*),IGRP(*)

      DO 10, I=1,NGRPS
         IF (IGRP(I).EQ.3) IAREA3=IAREA(I)
 10   CONTINUE

      IF (IAREA3 .GT. 0) THEN
C
C If the area is defined by 3 or more points, fill it
C
         CALL GSFACI(IAREA3+2)
         CALL GFA(NWRK,XWRK,YWRK)
      ENDIF
C
C Otherwise, do nothing
C
      RETURN
      END

      SUBROUTINE GETDAT(XREG,YREG,ZREG,MREG,NREG)

      PARAMETER (NRAN=30,LRWK=5000,LIWK=5000)
      INTEGER MREG, NREG
      REAL XRAN(NRAN), YRAN(NRAN), ZRAN(NRAN)
      REAL XREG(MREG), YREG(NREG), ZREG(MREG,NREG), RWRK(LRWK)
      REAL XDELTA(50)
      INTEGER IWRK(LIWK)

      DATA XRAN /12., 60., 14., 33.,  8., 12., 43., 57., 22., 15.,
     +         19., 12., 64., 19., 15., 55., 31., 32., 33., 29.,
     +         18.,  1., 18., 42., 56.,  9.,  6., 12., 44., 19./
      DATA YRAN / 1.,  2.,  3., 53.,  7., 11., 13., 17., 19., 49.,
     +          1., 31., 37.,  5.,  7., 47., 61., 17.,  5., 23.,
     +         29.,  3.,  5., 41., 43.,  9., 13., 59.,  1., 67./
      DATA ZRAN /1.0, 1.5, 1.7, 1.4, 1.9, 1.0, 1.5, 1.2, 1.8, 1.4,
     +         1.8, 1.7, 1.9, 1.5, 1.2, 1.1, 1.3, 1.7, 1.2, 1.6,
     +         1.9, 1.0, 1.6, 1.3, 1.4, 1.8, 1.7, 1.5, 1.1, 1.0/
      DATA XDELTA/.00,.02,.04,.06,.08,.10,.12,.14,.16,.18,.20,
     +            .22,.24,.26,.28,.30,.32,.34,.36,.38,.40,.42,
     +            .44,.46,.48,.50,.52,.54,.56,.58,.60,.62,.64,
     +            .66,.68,.70,.72,.74,.76,.78,.80,.82,.84,.86,
     +            .88,.90,.92,.94,.96,.98/
C
C  Set the min and max data values.
C
      XMIN = 0.0
      XMAX = 65.0
      YMIN =  0.0
      YMAX = 68.0
C
C Choose the X and Y coordinates for interpolation points on the 
C regular grid.
C
      DO 101 I=1,MREG
         XREG(I)=XMIN + (XMAX - XMIN)*XDELTA(I)
 101  CONTINUE
C
      DO 102 I=1,NREG
         YREG(I)=YMIN + (YMAX - YMIN)*XDELTA(I)
 102  CONTINUE
C
C Interpolate data onto a regular grid
C
      CALL IDSFFT (1,NRAN,XRAN,YRAN,ZRAN,
     +     MREG,NREG,MREG,XREG,YREG,ZREG,IWRK,RWRK)

      RETURN
      END
      SUBROUTINE COLOR (N,IWKID)
C
C Background color
C Black
C
      CALL GSCR(IWKID,0,0.,0.,0.)
C
C First foreground color is white
C
      CALL GSCR(IWKID,1,1.,1.,1.)
C
C Second foreground color is gray
C
      CALL GSCR(IWKID,2,.75,.75,.75)
C
C Choose other foreground colors spaced equally around the spectrum
C
      ICNT=0
      HUES=360./N
C
C REDLN is intended to be the line between red and violet values
C
      REDLN=36.0
      LAP=INT(REDLN/HUES)
      DO 10, I=1,N
         XHUE=I*HUES
         CALL HLSRGB(XHUE,60.,75.,RED,GREEN,BLUE)
C
C Sort colors so that the redest is first, and violetest is last
C
         IF (XHUE.LE.REDLN) THEN
            CALL GSCR(IWKID,(N+2)-(LAP-I),RED,GREEN,BLUE)
            ICNT=ICNT+1
         ELSE
            CALL GSCR(IWKID,I-ICNT+2,RED,GREEN,BLUE)
         ENDIF
 10   CONTINUE

      RETURN
      END

      SUBROUTINE SGEQP3( M, N, A, LDA, JPVT, TAU, WORK, LWORK, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      INTEGER            INFO, LDA, LWORK, M, N
*     ..
*     .. Array Arguments ..
      INTEGER            JPVT( * )
      REAL               A( LDA, * ), TAU( * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  SGEQP3 computes a QR factorization with column pivoting of a
*  matrix A:  A*P = Q*R  using Level 3 BLAS.
*
*  Arguments
*  =========
*
*  M       (input) INTEGER
*          The number of rows of the matrix A. M >= 0.
*
*  N       (input) INTEGER
*          The number of columns of the matrix A.  N >= 0.
*
*  A       (input/output) REAL array, dimension (LDA,N)
*          On entry, the M-by-N matrix A.
*          On exit, the upper triangle of the array contains the
*          min(M,N)-by-N upper trapezoidal matrix R; the elements below
*          the diagonal, together with the array TAU, represent the
*          orthogonal matrix Q as a product of min(M,N) elementary
*          reflectors.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A. LDA >= max(1,M).
*
*  JPVT    (input/output) INTEGER array, dimension (N)
*          On entry, if JPVT(J).ne.0, the J-th column of A is permuted
*          to the front of A*P (a leading column); if JPVT(J)=0,
*          the J-th column of A is a free column.
*          On exit, if JPVT(J)=K, then the J-th column of A*P was the
*          the K-th column of A.
*
*  TAU     (output) REAL array, dimension (min(M,N))
*          The scalar factors of the elementary reflectors.
*
*  WORK    (workspace/output) REAL array, dimension (LWORK)
*          On exit, if INFO=0, WORK(1) returns the optimal LWORK.
*
*  LWORK   (input) INTEGER
*          The dimension of the array WORK. LWORK >= 3*N+1.
*          For optimal performance LWORK >= 2*N+( N+1 )*NB, where NB
*          is the optimal blocksize.
*
*          If LWORK = -1, then a workspace query is assumed; the routine
*          only calculates the optimal size of the WORK array, returns
*          this value as the first entry of the WORK array, and no error
*          message related to LWORK is issued by XERBLA.
*
*  INFO    (output) INTEGER
*          = 0: successful exit.
*          < 0: if INFO = -i, the i-th argument had an illegal value.
*
*  Further Details
*  ===============
*
*  The matrix Q is represented as a product of elementary reflectors
*
*     Q = H(1) H(2) . . . H(k), where k = min(m,n).
*
*  Each H(i) has the form
*
*     H(i) = I - tau * v * v'
*
*  where tau is a real/complex scalar, and v is a real/complex vector
*  with v(1:i-1) = 0 and v(i) = 1; v(i+1:m) is stored on exit in
*  A(i+1:m,i), and tau in TAU(i).
*
*  Based on contributions by
*    G. Quintana-Orti, Depto. de Informatica, Universidad Jaime I, Spain
*    X. Sun, Computer Science Dept., Duke University, USA
*
*  =====================================================================
*
*     .. Parameters ..
      INTEGER            INB, INBMIN, IXOVER
      PARAMETER          ( INB = 1, INBMIN = 2, IXOVER = 3 )
*     ..
*     .. Local Scalars ..
      LOGICAL            LQUERY
      INTEGER            FJB, IWS, J, JB, LWKOPT, MINMN, MINWS, NA, NB,
     $                   NBMIN, NFXD, NX, SM, SMINMN, SN, TOPBMN
*     ..
*     .. External Subroutines ..
      EXTERNAL           SGEQRF, SLAQP2, SLAQPS, SORMQR, SSWAP, XERBLA
*     ..
*     .. External Functions ..
      INTEGER            ILAENV
      REAL               SNRM2
      EXTERNAL           ILAENV, SNRM2
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          INT, MAX, MIN
*     ..
*     .. Executable Statements ..
*
      IWS = 3*N + 1
      MINMN = MIN( M, N )
*
*     Test input arguments
*     ====================
*
      INFO = 0
      NB = ILAENV( INB, 'SGEQRF', ' ', M, N, -1, -1 )
      LWKOPT = 2*N+( N+1 )*NB
      WORK( 1 ) = LWKOPT
      LQUERY = ( LWORK.EQ.-1 )
      IF( M.LT.0 ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( LDA.LT.MAX( 1, M ) ) THEN
         INFO = -4
      ELSE IF( ( LWORK.LT.IWS ) .AND. .NOT.LQUERY ) THEN
         INFO = -8
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'SGEQP3', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         RETURN
      END IF
*
*     Quick return if possible.
*
      IF( MINMN.EQ.0 ) THEN
         WORK( 1 ) = 1
         RETURN
      END IF
*
*     Move initial columns up front.
*
      NFXD = 1
      DO 10 J = 1, N
         IF( JPVT( J ).NE.0 ) THEN
            IF( J.NE.NFXD ) THEN
               CALL SSWAP( M, A( 1, J ), 1, A( 1, NFXD ), 1 )
               JPVT( J ) = JPVT( NFXD )
               JPVT( NFXD ) = J
            ELSE
               JPVT( J ) = J
            END IF
            NFXD = NFXD + 1
         ELSE
            JPVT( J ) = J
         END IF
   10 CONTINUE
      NFXD = NFXD - 1
*
*     Factorize fixed columns
*     =======================
*
*     Compute the QR factorization of fixed columns and update
*     remaining columns.
*
      IF( NFXD.GT.0 ) THEN
         NA = MIN( M, NFXD )
*CC      CALL SGEQR2( M, NA, A, LDA, TAU, WORK, INFO )
         CALL SGEQRF( M, NA, A, LDA, TAU, WORK, LWORK, INFO )
         IWS = MAX( IWS, INT( WORK( 1 ) ) )
         IF( NA.LT.N ) THEN
*CC         CALL SORM2R( 'Left', 'Transpose', M, N-NA, NA, A, LDA,
*CC  $                   TAU, A( 1, NA+1 ), LDA, WORK, INFO )
            CALL SORMQR( 'Left', 'Transpose', M, N-NA, NA, A, LDA, TAU,
     $                   A( 1, NA+1 ), LDA, WORK, LWORK, INFO )
            IWS = MAX( IWS, INT( WORK( 1 ) ) )
         END IF
      END IF
*
*     Factorize free columns
*     ======================
*
      IF( NFXD.LT.MINMN ) THEN
*
         SM = M - NFXD
         SN = N - NFXD
         SMINMN = MINMN - NFXD
*
*        Determine the block size.
*
         NB = ILAENV( INB, 'SGEQRF', ' ', SM, SN, -1, -1 )
         NBMIN = 2
         NX = 0
*
         IF( ( NB.GT.1 ) .AND. ( NB.LT.SMINMN ) ) THEN
*
*           Determine when to cross over from blocked to unblocked code.
*
            NX = MAX( 0, ILAENV( IXOVER, 'SGEQRF', ' ', SM, SN, -1,
     $           -1 ) )
*
*
            IF( NX.LT.SMINMN ) THEN
*
*              Determine if workspace is large enough for blocked code.
*
               MINWS = 2*SN + ( SN+1 )*NB
               IWS = MAX( IWS, MINWS )
               IF( LWORK.LT.MINWS ) THEN
*
*                 Not enough workspace to use optimal NB: Reduce NB and
*                 determine the minimum value of NB.
*
                  NB = ( LWORK-2*SN ) / ( SN+1 )
                  NBMIN = MAX( 2, ILAENV( INBMIN, 'SGEQRF', ' ', SM, SN,
     $                    -1, -1 ) )
*
*
               END IF
            END IF
         END IF
*
*        Initialize partial column norms. The first N elements of work
*        store the exact column norms.
*
         DO 20 J = NFXD + 1, N
            WORK( J ) = SNRM2( SM, A( NFXD+1, J ), 1 )
            WORK( N+J ) = WORK( J )
   20    CONTINUE
*
         IF( ( NB.GE.NBMIN ) .AND. ( NB.LT.SMINMN ) .AND.
     $       ( NX.LT.SMINMN ) ) THEN
*
*           Use blocked code initially.
*
            J = NFXD + 1
*
*           Compute factorization: while loop.
*
*
            TOPBMN = MINMN - NX
   30       CONTINUE
            IF( J.LE.TOPBMN ) THEN
               JB = MIN( NB, TOPBMN-J+1 )
*
*              Factorize JB columns among columns J:N.
*
               CALL SLAQPS( M, N-J+1, J-1, JB, FJB, A( 1, J ), LDA,
     $                      JPVT( J ), TAU( J ), WORK( J ), WORK( N+J ),
     $                      WORK( 2*N+1 ), WORK( 2*N+JB+1 ), N-J+1 )
*
               J = J + FJB
               GO TO 30
            END IF
         ELSE
            J = NFXD + 1
         END IF
*
*        Use unblocked code to factor the last or only block.
*
*
         IF( J.LE.MINMN )
     $      CALL SLAQP2( M, N-J+1, J-1, A( 1, J ), LDA, JPVT( J ),
     $                   TAU( J ), WORK( J ), WORK( N+J ),
     $                   WORK( 2*N+1 ) )
*
      END IF
*
      WORK( 1 ) = IWS
      RETURN
*
*     End of SGEQP3
*
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C   FFTPACK 5.0
C   Copyright (C) 1995-2004, Scientific Computing Division,
C   University Corporation for Atmospheric Research
C   Licensed under the GNU General Public License (GPL)
C
C   Authors:  Paul N. Swarztrauber and Richard A. Valent
C
C   $Id: rfftmf.f,v 1.2 2006-11-21 01:10:19 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      SUBROUTINE DRFFTMF(LOT,JUMP,N,INC,R,LENR,WSAVE,LENSAV,WORK,
     +                   LENWRK,IER)
      INTEGER LOT,JUMP,N,INC,LENR,LENSAV,LENWRK,IER
      DOUBLE PRECISION R(LENR),WSAVE(LENSAV),WORK(LENWRK)
      LOGICAL DXERCON
C
      IER = 0
C
      IF (LENR.LT. (LOT-1)*JUMP+INC* (N-1)+1) THEN
          IER = 1
          CALL DXERFFT('RFFTMF ',6)
      ELSE IF (LENSAV.LT.N+INT(LOG(DBLE(N)))+4) THEN
          IER = 2
          CALL DXERFFT('RFFTMF ',8)
      ELSE IF (LENWRK.LT.LOT*N) THEN
          IER = 3
          CALL DXERFFT('RFFTMF ',10)
      ELSE IF (.NOT.DXERCON(INC,JUMP,N,LOT)) THEN
          IER = 4
          CALL DXERFFT('RFFTMF ',-1)
      END IF
C
      IF (N.EQ.1) RETURN
C
      CALL DMRFTF1(LOT,JUMP,N,INC,R,WORK,WSAVE,WSAVE(N+1))
      RETURN
      END

C
C	$Id: gsstm.f,v 1.4 2008-07-27 00:21:02 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GSSTM (WKID,STDNR,MODE,ESW)
C
C  SET STRING MODE
C
      INTEGER ESSTM
      PARAMETER (ESSTM=80)
C
      INTEGER WKID,STDNR,MODE,ESW
C
C  The only reason this subroutine is in the NCAR GKS package is
C  to support the pause feature of FRAME and NBPICT in a standard
C  manner so that those two subroutines can work with a any level
C  2B GKS package.
C
C  Check if GKS is in the proper state.
C
      CALL GZCKST(7,ESSTM,IER)
      IF (IER .NE. 0) RETURN
C
C  Check if the workstation identifier is valid.
C
      CALL GZCKWK(20,ESSTM,WKID,IDUM,IER)
      IF (IER .NE. 0) RETURN
C
C  Check if the specified workstation is open.
C
      CALL GZCKWK(25,ESSTM,WKID,IDUM,IER)
      IF (IER .NE. 0) RETURN
C
C  Other checks should be added if this subroutine is ever fully
C  implemented for NCAR GKS.
C
      RETURN
      END

C NCLFORTSTART
      SUBROUTINE CALCDBZ(DBZ,PRS,TMK,QVP,QRA,QSN,QGR,WEDIM,SNDIM,BTDIM,
     +                   SN0,IVARINT,ILIQSKIN)
c
c     This routine computes equivalent reflectivity factor (in dBZ) at
c     each model grid point.  In calculating Ze, the RIP algorithm makes
c     assumptions consistent with those made in an early version
c     (ca. 1996) of the bulk mixed-phase microphysical scheme in the MM5
c     model (i.e., the scheme known as "Resiner-2").  For each species:
c
c     1. Particles are assumed to be spheres of constant density.  The
c     densities of rain drops, snow particles, and graupel particles are
c     taken to be rho_r = rho_l = 1000 kg m^-3, rho_s = 100 kg m^-3, and
c     rho_g = 400 kg m^-3, respectively. (l refers to the density of
c     liquid water.)
c
c     2. The size distribution (in terms of the actual diameter of the
c     particles, rather than the melted diameter or the equivalent solid
c     ice sphere diameter) is assumed to follow an exponential
c     distribution of the form N(D) = N_0 * exp( lambda*D ).
c
c     3. If ivarint=0, the intercept parameters are assumed constant
c     (as in early Reisner-2), with values of 8x10^6, 2x10^7, 
c    and 4x10^6 m^-4, for rain, snow, and graupel, respectively.
c    If ivarint=1, variable intercept parameters are used, as 
c    calculated in Thompson, Rasmussen, and Manning (2004, Monthly
c    Weather Review, Vol. 132, No. 2, pp. 519-542.)
c
c     4. If iliqskin=1, frozen particles that are at a temperature above
c     freezing are assumed to scatter as a liquid particle.
c
c     More information on the derivation of simulated reflectivity in
c     RIP can be found in Stoelinga (2005, unpublished write-up).
c     Contact Mark Stoelinga (stoeling@atmos.washington.edu) for a copy.
c

c   Arguments
      INTEGER WEDIM,SNDIM,BTDIM
      INTEGER SN0,IVARINT,ILIQSKIN
      DOUBLE PRECISION DBZ(WEDIM,SNDIM,BTDIM)
      DOUBLE PRECISION PRS(WEDIM,SNDIM,BTDIM)
      DOUBLE PRECISION TMK(WEDIM,SNDIM,BTDIM)
      DOUBLE PRECISION QVP(WEDIM,SNDIM,BTDIM)
      DOUBLE PRECISION QRA(WEDIM,SNDIM,BTDIM)
      DOUBLE PRECISION QSN(WEDIM,SNDIM,BTDIM)
      DOUBLE PRECISION QGR(WEDIM,SNDIM,BTDIM)

C NCLEND

c   Local Variables
      INTEGER I,J,K
      DOUBLE PRECISION TEMP_C,VIRTUAL_T
      DOUBLE PRECISION GONV,RONV,SONV
      DOUBLE PRECISION FACTOR_G,FACTOR_R,FACTOR_S
      DOUBLE PRECISION FACTORB_G,FACTORB_R,FACTORB_S
      DOUBLE PRECISION RHOAIR,Z_E

c   Constants used to calculate variable intercepts
      DOUBLE PRECISION R1,RON,RON2,SON,GON
      DOUBLE PRECISION RON_MIN,RON_QR0,RON_DELQR0
      DOUBLE PRECISION RON_CONST1R,RON_CONST2R
c   Constant intercepts
      DOUBLE PRECISION RN0_R,RN0_S,RN0_G
c   Other constants
      DOUBLE PRECISION RHO_R,RHO_S,RHO_G
      DOUBLE PRECISION GAMMA_SEVEN,ALPHA
      DOUBLE PRECISION RHOWAT,CELKEL,PI,RD


c   Constants used to calculate variable intercepts
      R1 = 1.D-15
      RON = 8.D6
      RON2 = 1.D10
      SON = 2.D7
      GON = 5.D7
      RON_MIN = 8.D6
      RON_QR0 = 0.00010D0
      RON_DELQR0 = 0.25D0*RON_QR0
      RON_CONST1R = (RON2-RON_MIN)*0.5D0
      RON_CONST2R = (RON2+RON_MIN)*0.5D0

c   Constant intercepts
      RN0_R = 8.D6
      RN0_S = 2.D7
      RN0_G = 4.D6

c   Other constants
      GAMMA_SEVEN = 720.D0
      RHOWAT = 1000.D0
      RHO_R = RHOWAT
      RHO_S = 100.D0
      RHO_G = 400.D0
      ALPHA = 0.224D0
      CELKEL = 273.15D0
      PI = 3.141592653589793D0
      RD = 287.04D0

c   Force all Q arrays to be 0.0 or greater.
      DO K = 1,BTDIM
         DO J = 1,SNDIM
            DO I = 1,WEDIM
               IF (QVP(I,J,K).LT.0.0) THEN
                  QVP(I,J,K) = 0.0
               END IF
               IF (QRA(I,J,K).LT.0.0) THEN
                  QRA(I,J,K) = 0.0
               END IF
               IF (QSN(I,J,K).LT.0.0) THEN
                  QSN(I,J,K) = 0.0
               END IF
               IF (QGR(I,J,K).LT.0.0) THEN
                  QGR(I,J,K) = 0.0
               END IF
            END DO
         END DO
      END DO

c   Input pressure is Pa, but we need hPa in calculations

      IF (SN0.EQ.0) THEN
          DO K = 1,BTDIM
              DO J = 1,SNDIM
                  DO I = 1,WEDIM
                      IF (TMK(I,J,K).LT.CELKEL) THEN
                          QSN(I,J,K) = QRA(I,J,K)
                          QRA(I,J,K) = 0.D0
                      END IF
                  END DO
              END DO
          END DO
      END IF


      FACTOR_R = GAMMA_SEVEN*1.D18* (1.D0/ (PI*RHO_R))**1.75D0
      FACTOR_S = GAMMA_SEVEN*1.D18* (1.D0/ (PI*RHO_S))**1.75D0*
     +           (RHO_S/RHOWAT)**2*ALPHA
      FACTOR_G = GAMMA_SEVEN*1.D18* (1.D0/ (PI*RHO_G))**1.75D0*
     +           (RHO_G/RHOWAT)**2*ALPHA


      DO K = 1,BTDIM
          DO J = 1,SNDIM
              DO I = 1,WEDIM

                  VIRTUAL_T = TMK(I,J,K)* (0.622D0+QVP(I,J,K))/
     +                        (0.622D0* (1.D0+QVP(I,J,K)))
                  RHOAIR = PRS(I,J,K) / (RD*VIRTUAL_T)

c      Adjust factor for brightband, where snow or graupel particle
c      scatters like liquid water (alpha=1.0) because it is assumed to
c      have a liquid skin.

                  IF (ILIQSKIN.EQ.1 .AND. TMK(I,J,K).GT.CELKEL) THEN
                      FACTORB_S = FACTOR_S/ALPHA
                      FACTORB_G = FACTOR_G/ALPHA
                  ELSE
                      FACTORB_S = FACTOR_S
                      FACTORB_G = FACTOR_G
                  END IF

c      Calculate variable intercept parameters

                  IF (IVARINT.EQ.1) THEN

                      TEMP_C = DMIN1(-0.001D0,TMK(I,J,K)-CELKEL)
                      SONV = DMIN1(2.0D8,2.0D6*EXP(-0.12D0*TEMP_C))

                      GONV = GON
                      IF (QGR(I,J,K).GT.R1) THEN
                          GONV = 2.38D0* (PI*RHO_G/
     +                           (RHOAIR*QGR(I,J,K)))**0.92D0
                          GONV = MAX(1.D4,MIN(GONV,GON))
                      END IF

                      RONV = RON2
                      IF (QRA(I,J,K).GT.R1) THEN
                          RONV = RON_CONST1R*TANH((RON_QR0-QRA(I,J,K))/
     +                           RON_DELQR0) + RON_CONST2R
                      END IF

                  ELSE

                      RONV = RN0_R
                      SONV = RN0_S
                      GONV = RN0_G

                  END IF

c      Total equivalent reflectivity factor (z_e, in mm^6 m^-3) is
c      the sum of z_e for each hydrometeor species:

                  Z_E = FACTOR_R* (RHOAIR*QRA(I,J,K))**1.75D0/
     +                  RONV**.75D0 + FACTORB_S*
     +                  (RHOAIR*QSN(I,J,K))**1.75D0/SONV**.75D0 +
     +                  FACTORB_G* (RHOAIR*QGR(I,J,K))**1.75D0/
     +                  GONV**.75D0

c      Adjust small values of Z_e so that dBZ is no lower than -30
                  Z_E = MAX(Z_E,.001D0)

c      Convert to dBZ
                  DBZ(I,J,K) = 10.D0*LOG10(Z_E)

              END DO
          END DO
      END DO

      RETURN
      END

C
C $Id: idxchn.f,v 1.4 2008-07-27 00:17:30 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      FUNCTION IDXCHN (X,Y,I1,I2,I3,I4)
C
        DIMENSION X(*),Y(*)
C
C This function determines whether or not two adjacent triangles in
C the triangulation should be "exchanged".  It generates the Delaunay
C triangulation, used by the package "nngridr", by preferring triangles
C whose circumscribed circles have no data points in their interiors.
C
C The input arguments are the X and Y coordinate arrays of the data and
C the indices of four data points - P1, P2, P3, and P4 - forming a
C quadrilateral, with P3 and P4 connected diagonally.  The function
C returns a 1 when it decides that P1 and P2 should be connected
C instead (an "exchange") and a 0 otherwise.
C
        VPDT(U1,V1,U2,V2,U3,V3)=(U1-U3)*(V2-V3)-(V1-V3)*(U2-U3)
C
C Extract the required coordinates.
C
        X1=X(I1)
        Y1=Y(I1)
        X2=X(I2)
        Y2=Y(I2)
        X3=X(I3)
        Y3=Y(I3)
        X4=X(I4)
        Y4=Y(I4)
C
C Assume no exchange (value = 0) until we find out otherwise.
C
        IVAL=0
C
C If interior angles are less than 180 degrees, and either the point
C (X2,Y2) is inside the circle passing through the points (X1,Y1),
C (X3,Y3), and (X4,Y4) or the point (X1,Y1) is inside the circle
C passing through the points (X2,Y2), (X3,Y3), and (X4,Y4), return
C the value 1; this will cause the triangulation to be changed so
C as to use the diagonal from point 1 to point 2, rather than the
C diagonal from point 3 to point 4.  (Note that, mathematically, only
C one of the tests inside the IF-block should need to be made, because
C passing one of the tests implies passing the other, as well.)
C
        IF (VPDT(X1,Y1,X2,Y2,X3,Y3)*VPDT(X1,Y1,X2,Y2,X4,Y4).LT.0.) THEN
          CALL IDGTCP (X1,Y1,X3,Y3,X4,Y4,XC,YC)
          IF ((X2-XC)*(X2-XC)+(Y2-YC)*(Y2-YC).LT.
     +        (X1-XC)*(X1-XC)+(Y1-YC)*(Y1-YC)) IVAL=1
          CALL IDGTCP (X2,Y2,X3,Y3,X4,Y4,XC,YC)
          IF ((X1-XC)*(X1-XC)+(Y1-YC)*(Y1-YC).LT.
     +        (X2-XC)*(X2-XC)+(Y2-YC)*(Y2-YC)) IVAL=1
        END IF
C
C Set the value of the function for return to the caller.
C
        IDXCHN=IVAL
C
C Done.
C
        RETURN
C
      END

C
C $Id: entsr.f,v 1.7 2008-07-27 00:17:29 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE ENTSR (IROLD,IRNEW)
C
C This routine returns, in IROLD, the current value of the recovery
C flag.  If the value of IRNEW is non-zero, ENTSR also resets the
C recovery flag: IRNEW = 1 activates recovery; IRNEW = 2 deactivates
C recovery.
C
C The common blocks SECOMI and SECOMC are used to hold shared variables
C of types INTEGER and CHARACTER, respectively, for the routine SETER
C and associated routines.  For descriptions of these variables and for
C default values of them, see the block data routine SEBLDAX.
C
        COMMON /SECOMI/ IERRU,IERRF,IRECF,LOMSG
        SAVE   /SECOMI/
C
        COMMON /SECOMC/ ERMSG
          CHARACTER*256 ERMSG
        SAVE   /SECOMC/
C
C Check for an illegal value of IRNEW.
C
        IF (IRNEW.LT.0.OR.IRNEW.GT.2)
     +     CALL SETER ('ENTSR - ILLEGAL VALUE OF THE RECOVERY FLAG',1,2)
C
C Return the previous value of IRECF in IROLD and, if IRNEW is nonzero,
C reset IRECF to that value.
C
        IROLD=IRECF
        IF (IRNEW.NE.0) IRECF=IRNEW
C
C Check for an uncleared prior error that is now unrecoverable.
C
        IF (IERRF.NE.0.AND.IRECF.EQ.2)
     +       CALL SETER ('ENTSR - PRIOR ERROR IS NOW UNRECOVERABLE',2,2)
C
C Done.
C
        RETURN
C
      END

        PROGRAM CPEX10
C
C This program shows a view of the area around Boulder, Colorado, as
C seen from a satellite directly above Washington, D.C.  Within a
C circular area near Boulder, color-filled contour bands are shown;
C state boundaries are drawn in black over them.  Outside that area,
C the surface of the globe is shaded gray, state boundaries are drawn
C in white, and lines of latitude and longitude are drawn in a light
C gray.  Two-letter mnemonics are used to identify the states; each
C is written using new mapping capabilities of the package PLOTCHAR.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
        PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Define parameters specifying the lengths of the two area maps and
C the real and integer workspaces that are used.
C
        PARAMETER (LAM1=2000,LAM2=30000,LRWK=200,LIWK=100)
C
C Declare an array in which to put an area map that will be used to
C distinguish the circular area near Boulder from the rest of the globe
C and another array in which to put an area map that will be used to
C color contour bands within that area.  This program could be written
C using a single area map; it is being done this way for illustrative
C purposes.
C
        DIMENSION IAM1(LAM1),IAM2(LAM2)
C
C Declare scratch arrays required by the routines ARSCAM, MAPBLM, and
C MAPGRM.
C
        DIMENSION XCRA(1000),YCRA(1000),IAIA(10),IAGI(10)
C
C Declare arrays in which to get the latitudes and longitudes of points
C defining a circle around Boulder on the surface of the globe.
C
        DIMENSION CLAT(100),CLON(100)
C
C Declare arrays in which to get the latitudes and longitudes of points
C defining a star over Boulder.
C
        DIMENSION XLAT(6),XLON(6)
C
C Define an array in which to generate some dummy data to contour and
C workspace arrays required by CONPACK.
C
        DIMENSION ZDAT(41,41),RWRK(LRWK),IWRK(LIWK)
C
C Declare external the routines that will draw the masked grid lines
C and geographical outlines and the routine that will color the contour
C bands in the circular area around Boulder.
C
        EXTERNAL DRAWGL,DRAWGO,COLRCB
C
C Declare the common block in which the angle at which the label of a
C point on the globe is to be written and the latitude and longitude
C of the point being labelled are transmitted to the routine PCMPXY, in
C the package PLOTCHAR.
C
        COMMON /PCMP04/ PANG,PLAT,PLON
        SAVE   /PCMP04/
C
C Define arrays to hold a list of state names, two-character mnemonics
C for the states, and the latitude and longitude of a point where the
C mnemonic may be placed to label the state.
C
        CHARACTER*14 SNAM(50)
C
        CHARACTER*2 SMNE(50)
C
        DIMENSION SLAT(50),SLON(50)
C
C Define the state-labelling data.
C
        DATA SNAM( 1),SMNE( 1),SLAT( 1), SLON( 1)
     +                       / 'Alabama       ' , 'AL' , 33.0 ,  -86.5 /
        DATA SNAM( 2),SMNE( 2),SLAT( 2), SLON( 2)
     +                       / 'Alaska        ' , 'AK' , 65.0 , -152.0 /
        DATA SNAM( 3),SMNE( 3),SLAT( 3), SLON( 3)
     +                       / 'Arizona       ' , 'AZ' , 34.7 , -111.5 /
        DATA SNAM( 4),SMNE( 4),SLAT( 4), SLON( 4)
     +                       / 'Arkansas      ' , 'AR' , 35.0 ,  -92.5 /
        DATA SNAM( 5),SMNE( 5),SLAT( 5), SLON( 5)
     +                       / 'California    ' , 'CA' , 37.5 , -120.5 /
        DATA SNAM( 6),SMNE( 6),SLAT( 6), SLON( 6)
     +                       / 'Colorado      ' , 'CO' , 39.0 , -105.8 /
        DATA SNAM( 7),SMNE( 7),SLAT( 7), SLON( 7)
     +                       / 'Connecticut   ' , 'CT' , 41.6 ,  -72.6 /
        DATA SNAM( 8),SMNE( 8),SLAT( 8), SLON( 8)
     +                       / 'Delaware      ' , 'DE' , 39.0 ,  -75.5 /
        DATA SNAM( 9),SMNE( 9),SLAT( 9), SLON( 9)
     +                       / 'Florida       ' , 'FL' , 28.5 ,  -82.0 /
        DATA SNAM(10),SMNE(10),SLAT(10), SLON(10)
     +                       / 'Georgia       ' , 'GA' , 32.5 ,  -83.0 /
        DATA SNAM(11),SMNE(11),SLAT(11), SLON(11)
     +                       / 'Hawaii        ' , 'HI' , 20.0 , -157.0 /
        DATA SNAM(12),SMNE(12),SLAT(12), SLON(12)
     +                       / 'Idaho         ' , 'ID' , 43.5 , -114.0 /
        DATA SNAM(13),SMNE(13),SLAT(13), SLON(13)
     +                       / 'Illinois      ' , 'IL' , 40.2 ,  -89.2 /
        DATA SNAM(14),SMNE(14),SLAT(14), SLON(14)
     +                       / 'Indiana       ' , 'IN' , 40.0 ,  -86.0 /
        DATA SNAM(15),SMNE(15),SLAT(15), SLON(15)
     +                       / 'Iowa          ' , 'IA' , 42.0 ,  -93.2 /
        DATA SNAM(16),SMNE(16),SLAT(16), SLON(16)
     +                       / 'Kansas        ' , 'KS' , 38.5 ,  -98.2 /
        DATA SNAM(17),SMNE(17),SLAT(17), SLON(17)
     +                       / 'Kentucky      ' , 'KY' , 37.4 ,  -84.5 /
        DATA SNAM(18),SMNE(18),SLAT(18), SLON(18)
     +                       / 'Louisiana     ' , 'LA' , 31.2 ,  -92.5 /
        DATA SNAM(19),SMNE(19),SLAT(19), SLON(19)
     +                       / 'Maine         ' , 'ME' , 45.5 ,  -69.0 /
        DATA SNAM(20),SMNE(20),SLAT(20), SLON(20)
     +                       / 'Maryland      ' , 'MD' , 39.2 ,  -76.5 /
        DATA SNAM(21),SMNE(21),SLAT(21), SLON(21)
     +                       / 'Massachusetts ' , 'MA' , 42.3 ,  -72.0 /
        DATA SNAM(22),SMNE(22),SLAT(22), SLON(22)
     +                       / 'Michigan      ' , 'MI' , 44.0 ,  -85.0 /
        DATA SNAM(23),SMNE(23),SLAT(23), SLON(23)
     +                       / 'Minnesota     ' , 'MN' , 46.0 ,  -94.5 /
        DATA SNAM(24),SMNE(24),SLAT(24), SLON(24)
     +                       / 'Mississippi   ' , 'MS' , 32.5 ,  -89.5 /
        DATA SNAM(25),SMNE(25),SLAT(25), SLON(25)
     +                       / 'Missouri      ' , 'MO' , 38.5 ,  -92.5 /
        DATA SNAM(26),SMNE(26),SLAT(26), SLON(26)
     +                       / 'Montana       ' , 'MT' , 47.0 , -109.5 /
        DATA SNAM(27),SMNE(27),SLAT(27), SLON(27)
     +                       / 'Nebraska      ' , 'NE' , 41.5 ,  -99.5 /
        DATA SNAM(28),SMNE(28),SLAT(28), SLON(28)
     +                       / 'Nevada        ' , 'NV' , 39.8 , -117.0 /
        DATA SNAM(29),SMNE(29),SLAT(29), SLON(29)
     +                       / 'New Hampshire ' , 'NH' , 43.2 ,  -71.6 /
        DATA SNAM(30),SMNE(30),SLAT(30), SLON(30)
     +                       / 'New Jersey    ' , 'NJ' , 39.7 ,  -74.5 /
        DATA SNAM(31),SMNE(31),SLAT(31), SLON(31)
     +                       / 'New Mexico    ' , 'NM' , 34.7 , -106.0 /
        DATA SNAM(32),SMNE(32),SLAT(32), SLON(32)
     +                       / 'New York      ' , 'NY' , 43.0 ,  -75.0 /
        DATA SNAM(33),SMNE(33),SLAT(33), SLON(33)
     +                       / 'North Carolina' , 'NC' , 35.5 ,  -79.5 /
        DATA SNAM(34),SMNE(34),SLAT(34), SLON(34)
     +                       / 'North Dakota  ' , 'ND' , 47.5 , -100.5 /
        DATA SNAM(35),SMNE(35),SLAT(35), SLON(35)
     +                       / 'Ohio          ' , 'OH' , 40.2 ,  -82.5 /
        DATA SNAM(36),SMNE(36),SLAT(36), SLON(36)
     +                       / 'Oklahoma      ' , 'OK' , 35.6 ,  -97.5 /
        DATA SNAM(37),SMNE(37),SLAT(37), SLON(37)
     +                       / 'Oregon        ' , 'OR' , 44.0 , -120.2 /
        DATA SNAM(38),SMNE(38),SLAT(38), SLON(38)
     +                       / 'Pennsylvania  ' , 'PA' , 40.8 ,  -77.6 /
        DATA SNAM(39),SMNE(39),SLAT(39), SLON(39)
     +                       / 'Rhode Island  ' , 'RI' , 41.7 ,  -71.5 /
        DATA SNAM(40),SMNE(40),SLAT(40), SLON(40)
     +                       / 'South Carolina' , 'SC' , 34.0 ,  -80.5 /
        DATA SNAM(41),SMNE(41),SLAT(41), SLON(41)
     +                       / 'South Dakota  ' , 'SD' , 44.5 , -100.5 /
        DATA SNAM(42),SMNE(42),SLAT(42), SLON(42)
     +                       / 'Tennessee     ' , 'TN' , 36.0 ,  -86.5 /
        DATA SNAM(43),SMNE(43),SLAT(43), SLON(43)
     +                       / 'Texas         ' , 'TX' , 32.0 , -100.0 /
        DATA SNAM(44),SMNE(44),SLAT(44), SLON(44)
     +                       / 'Utah          ' , 'UT' , 39.5 , -111.5 /
        DATA SNAM(45),SMNE(45),SLAT(45), SLON(45)
     +                       / 'Vermont       ' , 'VT' , 44.2 ,  -72.5 /
        DATA SNAM(46),SMNE(46),SLAT(46), SLON(46)
     +                       / 'Virginia      ' , 'VA' , 37.6 ,  -78.6 /
        DATA SNAM(47),SMNE(47),SLAT(47), SLON(47)
     +                       / 'Washington    ' , 'WA' , 47.5 , -120.5 /
        DATA SNAM(48),SMNE(48),SLAT(48), SLON(48)
     +                       / 'West Virginia ' , 'WV' , 38.5 ,  -80.8 /
        DATA SNAM(49),SMNE(49),SLAT(49), SLON(49)
     +                       / 'Wisconsin     ' , 'WI' , 44.5 ,  -89.5 /
        DATA SNAM(50),SMNE(50),SLAT(50), SLON(50)
     +                       / 'Wyoming       ' , 'WY' , 43.0 , -107.5 /
C
C Define multiplicative constants to convert from degrees to radians
C and from radians to degrees.
C
        DATA DTOR / .017453292519943 /
        DATA RTOD / 57.2957795130823 /
C
C Get the latitudes and longitudes of 100 points defining a circle on
C the globe centered at the point (40.0,-105.3) - the approximate
C latitude and longitude of Boulder, Colorado - and having a radius
C of 7 degrees.
C
        CALL NGGCOG (40.0,-105.3,7.0,CLAT,CLON,100)
C
C Generate some dummy data to contour later.
C
        DO 102 I=1,41
          X=REAL(I-1)/40.
          DO 101 J=1,41
            Y=REAL(J-1)/40.
            ZDAT(I,J)=X*X+Y*Y+X*Y+SIN(9.*X)*COS(9.*Y)
  101     CONTINUE
  102   CONTINUE
C
C Open GKS.
C
        CALL GOPKS (IERRF, ISZDM)
        CALL GOPWK (IWKID, LUNIT, IWTYPE)
        CALL GACWK (IWKID)
C
C Turn off clipping.
C
        CALL GSCLIP (0)
C
C Turn on solid fill.
C
        CALL GSFAIS (1)
C
C Define some colors to use.  Color index 2 is for grid lines far from
C Boulder, color index 3 is for geographical objects near Boulder, and
C color index 4 is for geographical objects far from Boulder.  Color
C index 5 is used for that part of the earth which is not within the
C circle around Boulder.  Color index 6 is used for the star over
C Boulder.  Color indices 101 through 116 are to be used for contour
C bands in the area near Boulder; they are evenly distributed between
C pure red and pure blue.
C
        CALL GSCR   (IWKID,0,0.,0.,0.)
        CALL GSCR   (IWKID,1,1.,1.,1.)
        CALL GSCR   (IWKID,2,.6,.6,.6)
        CALL GSCR   (IWKID,3,0.,0.,0.)
        CALL GSCR   (IWKID,4,1.,1.,1.)
        CALL GSCR   (IWKID,5,.4,.4,.4)
        CALL GSCR   (IWKID,6,1.,1.,0.)
C
        DO 103 I=101,116
          CALL GSCR (IWKID,I,REAL(116-I)/15.,0.,REAL(I-101)/15.)
  103   CONTINUE
C
C Put a label at the top of the plot.
C
        CALL SET    (0.,1.,0.,1.,0.,1.,0.,1.,1)
        CALL PLCHHQ (.5,.975,
     +         ':F25:SATELLITE VIEW OF CONTOUR BANDS IN A LIMITED AREA',
     +                                                       .018,0.,0.)
C
C Tell EZMAP where to put the map on the plotter frame.
C
        CALL MAPPOS (.05,.95,.05,.95)
C
C Tell EZMAP to use the view from a satellite above Washington, D.C.
C The basic satellite-view projection is rotated clockwise by 75
C degrees so that the direction a little north of due west is toward
C the top of the projection.
C
        CALL MAPROJ ('SV',38.,-76.,75.)
C
C Tell EZMAP how far the satellite is from the center of earth and
C make it look in a direction about 7/8 of the way between looking
C straight down and looking directly at the horizon.  We end up
C looking roughly in the direction of Boulder.
C
        DFCE=1.3
C
        CALL MPSETR ('SA',DFCE)
C
        CALL MPSETR ('S1',7.*RTOD*ASIN(1./DFCE)/8.)
C
C Set the parameter 'S2' so that the line of sight is displaced toward
C the top of the basic satellite view - that is to say, in the direction
C a little north of due west that the setting of ROTA implies - by the
C angle specified by 'S1'.
C
        CALL MPSETR ('S2',90.)
C
C Tell EZMAP the satellite has a total field of view of 40 degrees.
C
        CALL MAPSET ('AN',20.,20.,20.,20.)
C
C Tell EZMAP to use the outline with political and state boundaries.
C
        CALL MPSETC ('OU','PS')
C
C Tell EZMAP to use a one-degree grid.
C
        CALL MPSETI ('GR',1)
C
C Initialize EZMAP.
C
        CALL MAPINT
C
C Tell CONPACK not to call SET (because MAPINT has already done it).
C
        CALL CPSETI ('SET - DO-SET-CALL FLAG',0)
C
C Tell CONPACK to map the contour lines using EZMAP.
C
        CALL CPSETI ('MAP - MAPPING FLAG.',1)
C
C Tell CONPACK what longitudes the minimum and maximum values of the
C first array index correspond to.
C
        CALL CPSETR ('XC1 - X COORDINATE AT I=1',-115.)
        CALL CPSETR ('XCM - X COORDINATE AT I=M', -95.)
C
C Tell CONPACK what latitudes the minimum and maximum values of the
C second array index correspond to.
C
        CALL CPSETR ('YC1 - Y COORDINATE AT J=1',32.)
        CALL CPSETR ('YCN - Y COORDINATE AT J=N',48.)
C
C Tell CONPACK to use exactly 15 contour levels, splitting the range
C from the minimum value to the maximum value into 16 equal bands.
C
        CALL CPSETI ('CLS - CONTOUR LEVEL SELECTOR',-15)
C
C Tell CONPACK where the data to be contoured are, where the real and
C integer workspaces are, and how big each array is.
C
        CALL CPRECT (ZDAT,41,41,41,RWRK,LRWK,IWRK,LIWK)
C
C Initialize the first area-map array.
C
        CALL ARINAM (IAM1,LAM1)
C
C Put the projection of the circle around Boulder into the area map.
C The information goes into edge group 1.  The area inside the projected
C circle is characterized as area 1 and the area outside the circle as
C area 2.
C
        CALL MAPITA (CLAT(1),CLON(1),0,IAM1,1,1,2)
C
        DO 104 I=2,100
          CALL MAPITA (CLAT(I),CLON(I),1,IAM1,1,1,2)
  104   CONTINUE
C
        CALL MAPIQA (IAM1,1,1,2)
C
C Copy the information from the first area-map array to the second one.
C Note that the routine we use to do this, despite the "move" implied
C by its name, can actually be used in this way.
C
        CALL ARMVAM (IAM1,IAM2,LAM2)
C
C Add to the second area map the limb line and the perimeter for the
C satellite-view projection.  This is done by temporarily using no
C outline dataset, so that MAPBLA will put only the lines we want into
C the area map.  The edges will go in edge group 1.
C
        CALL MPSETC ('OU','NO')
        CALL MAPBLA (IAM2)
        CALL MPSETC ('OU','PS')
C
C Add to the second area map the contour lines for the area near
C Boulder.  They will go in edge group 3.
C
        CALL CPCLAM (ZDAT,RWRK,IWRK,IAM2)
C
C Scan the second area map to color the contour bands near Boulder.
C
        CALL ARSCAM (IAM2,XCRA,YCRA,1000,IAIA,IAGI,10,COLRCB)
C
C Double the line width.
C
        CALL GSLWSC (2.)
C
C Draw a masked latitude/longitude grid and masked outlines.
C
        CALL MAPGRM (IAM1,XCRA,YCRA,1000,IAIA,IAGI,10,DRAWGL)
        CALL MAPBLM (IAM1,XCRA,YCRA,1000,IAIA,IAGI,10,DRAWGO)
C
C Set the current polyline color index to draw a black line.
C
        CALL GSPLCI (0)
C
C Draw the circle around Boulder.
C
        CALL MAPIT (CLAT(1),CLON(1),0)
C
        DO 105 I=2,100
          CALL MAPIT (CLAT(I),CLON(I),1)
  105   CONTINUE
C
        CALL MAPIQ
C
C Set the current polyline color index to draw a yellow line.
C
        CALL GSPLCI (6)
C
C Put a star at the position of Boulder.
C
        CALL NGGSOG (40.,-105.,.25,XLAT,XLON)
C
        CALL MAPIT (XLAT(1),XLON(1),0)
C
        DO 106 I=2,6
          CALL MAPIT (XLAT(I),XLON(I),1)
  106   CONTINUE
C
        CALL MAPIQ
C
C Label the states using two-character mnemonics for them.
C
        CALL PCSETI ('MAP',4)
        CALL PCSETR ('ORV',1.E12)
        PANG=45.
C
        DO 107 I=1,50
          PLAT=SLAT(I)
          PLON=SLON(I)
          CALL PLCHHQ (0.,0.,SMNE(I),.5,0.,0.)
  107   CONTINUE
C
C Advance the frame.
C
        CALL FRAME
C
C Close GKS.
C
        CALL GDAWK (IWKID)
        CALL GCLWK (IWKID)
        CALL GCLKS
C
C Compute or get information about the amount of space used in each
C area-map array and in the real and integer workspace arrays and
C print it.
C
        CALL CPGETI ('RWU - INTEGER WORKSPACE USED',IRWS)
        CALL CPGETI ('IWU - INTEGER WORKSPACE USED',IIWS)
C
        PRINT * , 'NUMBER OF WORDS USED IN REAL WORKSPACE:    ',IRWS
        PRINT * , 'NUMBER OF WORDS USED IN INTEGER WORKSPACE: ',IIWS
        PRINT * , 'NUMBER OF WORDS USED IN AREA-MAP ARRAY 1:  ',
     +                                          LAM1-(IAM1(6)-IAM1(5)-1)
        PRINT * , 'NUMBER OF WORDS USED IN AREA-MAP ARRAY 2:  ',
     +                                          LAM2-(IAM2(6)-IAM2(5)-1)
C
C Done.
C
        STOP
C
      END



      SUBROUTINE DRAWGL (XCRA,YCRA,NCRA,IAAI,IAGI,NOGI)
C
        DIMENSION XCRA(*),YCRA(*),IAAI(*),IAGI(*)
C
C The routine DRAWGL draws the polyline defined by the points
C ((XCRA(I),YCRA(I)),I=1,NCRA) using color index 2 if the area
C identifier relative to edge group 1 is a 2, implying that the
C polyline is outside the circle around Boulder, Colorado; otherwise,
C it does not draw the polyline at all.
C
C Find the area identifier relative to edge group 1.
C
        IAI1=-1
C
        DO 101 I=1,NOGI
          IF (IAGI(I).EQ.1) IAI1=IAAI(I)
  101   CONTINUE
C
C If the polyline is outside the circle, draw it.
C
        IF (IAI1.EQ.2) THEN
          CALL GSPLCI (2)
          CALL CURVE (XCRA,YCRA,NCRA)
        END IF
C
C Done.
C
        RETURN
C
      END



      SUBROUTINE DRAWGO (XCRA,YCRA,NCRA,IAAI,IAGI,NOGI)
C
        DIMENSION XCRA(*),YCRA(*),IAAI(*),IAGI(*)
C
C The routine DRAWGO draws the polyline defined by the points
C ((XCRA(I),YCRA(I)),I=1,NCRA) using color index 3 if the area
C identifier relative to edge group 1 is a 1, implying that the
C polyline is inside the circle around Boulder, Colorado, and
C using color index 4, otherwise.
C
C Find the area identifier relative to edge group 1.
C
        IAI1=-1
C
        DO 101 I=1,NOGI
          IF (IAGI(I).EQ.1) IAI1=IAAI(I)
  101   CONTINUE
C
C Draw the polyline if the area identifier is a 1 or a 2, but not
C otherwise.
C
        IF (IAI1.EQ.1) THEN
          CALL GSPLCI (3)
        ELSE IF (IAI1.EQ.2) THEN
          CALL GSPLCI (4)
        END IF
C
        CALL CURVE (XCRA,YCRA,NCRA)
C
C Done.
C
        RETURN
C
      END



      SUBROUTINE COLRCB (XCRA,YCRA,NCRA,IAAI,IAGI,NOGI)
C
        DIMENSION XCRA(*),YCRA(*),IAAI(*),IAGI(*)
C
C The routine COLRCB colors the polygon defined by the points
C ((XCRA(I),YCRA(I)),I=1,NCRA) if and only if it is inside the
C circle around Boulder and it is a portion of one of the contour
C bands defined by the dummy data array.
C
C Find the area identifiers for the polygon relative to edge groups 1
C and 3.
C
        IAI1=-1
        IAI3=-1
C
        DO 101 I=1,NOGI
          IF (IAGI(I).EQ.1) IAI1=IAAI(I)
          IF (IAGI(I).EQ.3) IAI3=IAAI(I)
  101   CONTINUE
C
C Fill the polygon using a color implied by the contour level if it
C is inside the circle around Boulder and is part of a contour band.
C If it is outside the circle around Boulder, but is still on the
C globe, use color index 5 for it.
C
        IF (IAI1.EQ.1.AND.IAI3.GE.1.AND.IAI3.LE.16) THEN
          CALL GSFACI (100+IAI3)
          CALL GFA (NCRA-1,XCRA,YCRA)
        ELSE IF (IAI1.EQ.2) THEN
          CALL GSFACI (5)
          CALL GFA (NCRA-1,XCRA,YCRA)
        END IF
C
C Done.
C
        RETURN
C
      END

      SUBROUTINE ZGGBAK( JOB, SIDE, N, ILO, IHI, LSCALE, RSCALE, M, V,
     $                   LDV, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER          JOB, SIDE
      INTEGER            IHI, ILO, INFO, LDV, M, N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   LSCALE( * ), RSCALE( * )
      COMPLEX*16         V( LDV, * )
*     ..
*
*  Purpose
*  =======
*
*  ZGGBAK forms the right or left eigenvectors of a complex generalized
*  eigenvalue problem A*x = lambda*B*x, by backward transformation on
*  the computed eigenvectors of the balanced pair of matrices output by
*  ZGGBAL.
*
*  Arguments
*  =========
*
*  JOB     (input) CHARACTER*1
*          Specifies the type of backward transformation required:
*          = 'N':  do nothing, return immediately;
*          = 'P':  do backward transformation for permutation only;
*          = 'S':  do backward transformation for scaling only;
*          = 'B':  do backward transformations for both permutation and
*                  scaling.
*          JOB must be the same as the argument JOB supplied to ZGGBAL.
*
*  SIDE    (input) CHARACTER*1
*          = 'R':  V contains right eigenvectors;
*          = 'L':  V contains left eigenvectors.
*
*  N       (input) INTEGER
*          The number of rows of the matrix V.  N >= 0.
*
*  ILO     (input) INTEGER
*  IHI     (input) INTEGER
*          The integers ILO and IHI determined by ZGGBAL.
*          1 <= ILO <= IHI <= N, if N > 0; ILO=1 and IHI=0, if N=0.
*
*  LSCALE  (input) DOUBLE PRECISION array, dimension (N)
*          Details of the permutations and/or scaling factors applied
*          to the left side of A and B, as returned by ZGGBAL.
*
*  RSCALE  (input) DOUBLE PRECISION array, dimension (N)
*          Details of the permutations and/or scaling factors applied
*          to the right side of A and B, as returned by ZGGBAL.
*
*  M       (input) INTEGER
*          The number of columns of the matrix V.  M >= 0.
*
*  V       (input/output) COMPLEX*16 array, dimension (LDV,M)
*          On entry, the matrix of right or left eigenvectors to be
*          transformed, as returned by ZTGEVC.
*          On exit, V is overwritten by the transformed eigenvectors.
*
*  LDV     (input) INTEGER
*          The leading dimension of the matrix V. LDV >= max(1,N).
*
*  INFO    (output) INTEGER
*          = 0:  successful exit.
*          < 0:  if INFO = -i, the i-th argument had an illegal value.
*
*  Further Details
*  ===============
*
*  See R.C. Ward, Balancing the generalized eigenvalue problem,
*                 SIAM J. Sci. Stat. Comp. 2 (1981), 141-152.
*
*  =====================================================================
*
*     .. Local Scalars ..
      LOGICAL            LEFTV, RIGHTV
      INTEGER            I, K
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           XERBLA, ZDSCAL, ZSWAP
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters
*
      RIGHTV = LSAME( SIDE, 'R' )
      LEFTV = LSAME( SIDE, 'L' )
*
      INFO = 0
      IF( .NOT.LSAME( JOB, 'N' ) .AND. .NOT.LSAME( JOB, 'P' ) .AND.
     $    .NOT.LSAME( JOB, 'S' ) .AND. .NOT.LSAME( JOB, 'B' ) ) THEN
         INFO = -1
      ELSE IF( .NOT.RIGHTV .AND. .NOT.LEFTV ) THEN
         INFO = -2
      ELSE IF( N.LT.0 ) THEN
         INFO = -3
      ELSE IF( ILO.LT.1 ) THEN
         INFO = -4
      ELSE IF( IHI.LT.ILO .OR. IHI.GT.MAX( 1, N ) ) THEN
         INFO = -5
      ELSE IF( M.LT.0 ) THEN
         INFO = -6
      ELSE IF( LDV.LT.MAX( 1, N ) ) THEN
         INFO = -10
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'ZGGBAK', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
      IF( M.EQ.0 )
     $   RETURN
      IF( LSAME( JOB, 'N' ) )
     $   RETURN
*
      IF( ILO.EQ.IHI )
     $   GO TO 30
*
*     Backward balance
*
      IF( LSAME( JOB, 'S' ) .OR. LSAME( JOB, 'B' ) ) THEN
*
*        Backward transformation on right eigenvectors
*
         IF( RIGHTV ) THEN
            DO 10 I = ILO, IHI
               CALL ZDSCAL( M, RSCALE( I ), V( I, 1 ), LDV )
   10       CONTINUE
         END IF
*
*        Backward transformation on left eigenvectors
*
         IF( LEFTV ) THEN
            DO 20 I = ILO, IHI
               CALL ZDSCAL( M, LSCALE( I ), V( I, 1 ), LDV )
   20       CONTINUE
         END IF
      END IF
*
*     Backward permutation
*
   30 CONTINUE
      IF( LSAME( JOB, 'P' ) .OR. LSAME( JOB, 'B' ) ) THEN
*
*        Backward permutation on right eigenvectors
*
         IF( RIGHTV ) THEN
            IF( ILO.EQ.1 )
     $         GO TO 50
            DO 40 I = ILO - 1, 1, -1
               K = RSCALE( I )
               IF( K.EQ.I )
     $            GO TO 40
               CALL ZSWAP( M, V( I, 1 ), LDV, V( K, 1 ), LDV )
   40       CONTINUE
*
   50       CONTINUE
            IF( IHI.EQ.N )
     $         GO TO 70
            DO 60 I = IHI + 1, N
               K = RSCALE( I )
               IF( K.EQ.I )
     $            GO TO 60
               CALL ZSWAP( M, V( I, 1 ), LDV, V( K, 1 ), LDV )
   60       CONTINUE
         END IF
*
*        Backward permutation on left eigenvectors
*
   70    CONTINUE
         IF( LEFTV ) THEN
            IF( ILO.EQ.1 )
     $         GO TO 90
            DO 80 I = ILO - 1, 1, -1
               K = LSCALE( I )
               IF( K.EQ.I )
     $            GO TO 80
               CALL ZSWAP( M, V( I, 1 ), LDV, V( K, 1 ), LDV )
   80       CONTINUE
*
   90       CONTINUE
            IF( IHI.EQ.N )
     $         GO TO 110
            DO 100 I = IHI + 1, N
               K = LSCALE( I )
               IF( K.EQ.I )
     $            GO TO 100
               CALL ZSWAP( M, V( I, 1 ), LDV, V( K, 1 ), LDV )
  100       CONTINUE
         END IF
      END IF
*
  110 CONTINUE
*
      RETURN
*
*     End of ZGGBAK
*
      END

C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CSA1XD(NI,XI,YI,WTS,KNOTS,SSMTH,NDERIV,NO,XO,YO,NWRK,
     +                  WORK,IER)
      DOUBLE PRECISION XI
      DOUBLE PRECISION YI
      DOUBLE PRECISION WTS
      DOUBLE PRECISION SSMTH
      DOUBLE PRECISION XO
      DOUBLE PRECISION YO
      DOUBLE PRECISION WORK
      DOUBLE PRECISION XMN
      DOUBLE PRECISION XMX
      DOUBLE PRECISION SPLDED
C
      DIMENSION XI(NI),YI(NI),WTS(*),XO(NO),YO(NO),WORK(NWRK)
C
C  Check on the number of knots.
C
      IF (KNOTS.LT.4) THEN
          CALL CFAERR(202,' CSA1XD - must have at least four knots',39)
          IER = 202
          RETURN
      END IF
C
C  Check on the size of the workspace.
C
      IF (NWRK.LT.KNOTS* (KNOTS+3)) THEN
          CALL CFAERR(203,' CSA1XD - workspace too small',29)
          IER = 203
          RETURN
      END IF
C
C  Calculate the min and max for the knots as the minimum value of
C  the input data and output data and the maximum of the input and
C  output data.
C
      XMN = XI(1)
      XMX = XI(1)
      DO 10 I = 2,NI
          XMN = MIN(XMN,XI(I))
          XMX = MAX(XMX,XI(I))
   10 CONTINUE
      XMN = MIN(XMN,XO(1))
      XMX = MAX(XMX,XO(NO))
C
C  Find the coefficients.
C
      CALL SPLCWD(1,XI,1,YI,WTS,NI,XMN,XMX,KNOTS,SSMTH,WORK,KNOTS,
     +            WORK(KNOTS+1),NWRK-KNOTS,IERR)
      IF (IERR.NE.0) RETURN
C
C  Calculate the approximated values.
C
      DO 20 I = 1,NO
          YO(I) = SPLDED(1,XO(I),NDERIV,WORK,XMN,XMX,KNOTS,IER)
          IF (IERR.NE.0) RETURN
   20 CONTINUE
C
      RETURN
      END

C
C	$Id: ggdp.f,v 1.5 2008-07-27 00:20:57 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GGDP(N,PX,PY,PRIMID,LDR,DATREC)
C
C  GENERALIZED DRAWING PRIMITIVE
C
      INTEGER EGDP
      PARAMETER (EGDP=17)
C
      include 'gkscom.h'
C
      INTEGER N,PRIMID,LDR
      REAL PX(N),PY(N)
      CHARACTER*80 DATREC(LDR)
C
C  Check if GKS is in the proper state.
C
      CALL GZCKST(5,EGDP,IER)
      IF (IER .NE. 0) RETURN
C
C  Check that the number of points is valid.
C
      IF (.NOT.(N.GE.1)) THEN
        ERS = 1
        CALL GERHND(100,EGDP,ERF)
        ERS = 0
        RETURN
      ENDIF
C
C  Set function code and put out the real arrays across the
C  workstation interface.  Flag conversion to NDC space.
C  ID(1) contains the GDP identifier.
C  If ID(2)=0, then no data record will be shipped.  If
C  ID(2)=1, then the data record will be shipped via
C  the first workstation invocation subsequent to the
C  completion of sending the real arrays, i.e. the continuation
C  flag for sending over the real arrays will be set to zero
C  and the data record will be sent across the interface
C  completely independently as the next transmission.
C
      FCODE = 16
C
C  Set up flag in ID(2) to indicate if a data record is to follow
C  sending over the real arrays.
C
      CALL GZROI(0)
      IL1 = 2
      IL2 = 2
      ID(1) = PRIMID
      IF (LDR.GT.0) THEN
        ID(2) = 1
      ELSE
        ID(2) = 0
      ENDIF
C
C  Send over the real arrays.
C
      NPTOT = N
      CALL GZPUTR(NPTOT,N,PX,PY,1,IER)
      RERR = IER
      IF (RERR.NE.0) THEN
        ERS = 1
        CALL GERHND(RERR,EGDP,ERF)
        ERS = 0
        RETURN
      ENDIF
C
C  Send over the data record if there is one (recall that the
C  string length of STR is divisible by 80).
C
      IF (ID(2) .EQ. 1) THEN
        IF (LDR. EQ. 1) THEN
          CONT = 0
          STRL1 = 80
          STRL2 = 80
          STR(1:80) = DATREC(1)
          CALL GZTOWK
          IF (RERR.NE.0) THEN
            ERS = 1
            CALL GERHND(RERR,EGDP,ERF)
            ERS = 0
            RETURN
          ENDIF
        ELSE
C
C     SEND OVER THE DATA RECORD 80 CHARACTERS AT A TIME
C
          CONT = 1
          STRL1 = 80*LDR
          STRL2 = 80
          LDRM1 = LDR-1
          DO 200 I=1,LDRM1
            IF (I .GT. 1) IL2 = 0
            STR(1:80) = DATREC(I)
            CALL GZTOWK
            IF (RERR.NE.0) THEN
              ERS = 1
              CALL GERHND(RERR,EGDP,ERF)
              ERS = 0
              RETURN
            ENDIF
  200     CONTINUE
          CONT = 0
          STR(1:80) = DATREC(LDR)
          CALL GZTOWK
          IF (RERR.NE.0) THEN
            ERS = 1
            CALL GERHND(RERR,EGDP,ERF)
            ERS = 0
            RETURN
          ENDIF
        ENDIF
      ENDIF
C
      RETURN
      END

      PROGRAM CMPITM
C
C This program draws a map, then it draws the projection of a circle, 
C which is masked over land.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C The arrays CLAT and CLON will be used to hold lat/lon pairs defining
C the desired circle.
C
      EXTERNAL MASK1
      PARAMETER (NPTS=361,NWRK=5000,LMAP=150000,NGRPS=2)

      REAL CLAT(NPTS), CLON(NPTS), XWRK(NWRK), YWRK(NWRK)
      REAL PLIM1(2), PLIM2(2), PLIM3(2), PLIM4(2)
      INTEGER MAP(LMAP),IAREA(NGRPS),IGRP(NGRPS)

      DATA PLIM1 /20.,0./
      DATA PLIM2 /-85.,0./
      DATA PLIM3 /30.,0./
      DATA PLIM4 /-75.,0./
C
C Open GKS.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Draw the map, and set up area map.
C
      CALL TCMPMSK('ME',0.,-75.,0.,'PS','CO',
     +     PLIM1,PLIM2,PLIM3,PLIM4,2.,MAP,LMAP)
C
C Define a circle centered at RLAT,RLON
C
      CALL CIRCLE (25.,-80.,3.5,CLAT,CLON,NPTS)
C
C Draw the circle on the map.
C
      CALL MAPITM  (CLAT(1),CLON(1),0,MAP,XWRK,YWRK,NWRK,
     +     IAREA,IGRP,NGRPS,MASK1)
      DO 102 ICIR=2,NPTS
         CALL MAPITM (CLAT(ICIR),CLON(ICIR),1,MAP,XWRK,YWRK,NWRK,
     +        IAREA,IGRP,NGRPS,MASK1)
 102  CONTINUE
      CALL MAPIQM (MAP,XWRK,YWRK,NWRK,IAREA,IGRP,NGRPS,MASK1)
C
C Advance the frame.
C
      CALL FRAME
C
C Close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
C Done.
C
      STOP
C
      END

      SUBROUTINE CIRCLE (RLAT,RLON,RADIUS,CLAT,CLON,NPTS)
C
C Points on a circle around the North Pole are rotated to lie around
C the point at latitude RLAT and longitude RLON.
C RADIUS is the radius of the circle, in degrees.
C Return the lat/lon coordinates of the desired circle in CLAT & CLON.
C
      REAL RLAT, RLON, CLAT(NPTS), CLON(NPTS)
C
C DTOR and RTOD are the constants used to get from degrees to radians
C and vice-versa.
C
      DATA DTOR / .017453292519943 /
      DATA RTOD / 57.2957795130823 /
      DO 101 ICIR=1,NPTS
         ALAT=90.-RADIUS
         ALON=REAL(ICIR-1)
         UCRD=COS(DTOR*ALAT)*COS(DTOR*ALON)
         VCRD=COS(DTOR*ALAT)*SIN(DTOR*ALON)
         WCRD=SIN(DTOR*ALAT)
         IF (RLAT.GE.0) THEN
            CALL ROTATE (2,90.-RLAT,UCRD,VCRD,WCRD)
            CALL ROTATE (3,RLON,UCRD,VCRD,WCRD)
         ELSE
            CALL ROTATE (2,90.+ABS(RLAT),UCRD,VCRD,WCRD)
            CALL ROTATE (3,RLON,UCRD,VCRD,WCRD)
         ENDIF 
         CLAT(ICIR)=RTOD*ASIN(WCRD)
         CLON(ICIR)=RTOD*ATAN2(VCRD,UCRD)
 101  CONTINUE
      
      RETURN
      END
      SUBROUTINE ROTATE (IAXS,ANGL,UCRD,VCRD,WCRD)
C
C This routine rotates the point with coordinates (UCRD,VCRD,WCRD)
C by the angle ANGL about the axis specified by IAXS (1 for the
C U axis, 2 for the V axis, 3 for the W axis).  The coordinate
C system is assumed to be a right-handed one.
C
      SINA=SIN(.017453292519943*ANGL)
      COSA=COS(.017453292519943*ANGL)
C
      UTMP=UCRD
      VTMP=VCRD
      WTMP=WCRD
C
      IF (IAXS.EQ.1) THEN
         VCRD=VTMP*COSA-WTMP*SINA
         WCRD=WTMP*COSA+VTMP*SINA
      ELSE IF (IAXS.EQ.2) THEN
         UCRD=UTMP*COSA+WTMP*SINA
         WCRD=WTMP*COSA-UTMP*SINA
      ELSE
         UCRD=UTMP*COSA-VTMP*SINA
         VCRD=VTMP*COSA+UTMP*SINA
      END IF
C
      RETURN
C
      END
      SUBROUTINE TCMPMSK(PROJ, PLAT, PLON, ROTA, OUTLN,
     +     JLIM, PLIM1, PLIM2, PLIM3, PLIM4, GRD, MAP, LMAP)

      EXTERNAL MASK2
      PARAMETER (NWRK=5000,ISIZ=2)

      CHARACTER*2 PROJ, OUTLN, JLIM
      INTEGER MAP(LMAP), IAREA(ISIZ), IGRP(ISIZ)
      REAL XWRK(NWRK), YWRK(NWRK)
      REAL PLIM1(2), PLIM2(2), PLIM3(2), PLIM4(2)
C
C CMPLOT demonstrates MAPLOT drawing continental and political outlines
C
C Use solid lines for grid
C
      CALL DASHDB(65535)
C
C Draw Continental, political outlines 
C
      CALL MAPSTC ('OU - OUTLINE DATASET SELECTOR',OUTLN)
C
C Set grid spacing
C
      CALL MAPSTR ('GR - GRID SPACING',GRD)
C
C Set up projection
C
      CALL MAPROJ (PROJ,PLAT,PLON,ROTA)
C
C If it's a satellite projection, choose a satellite distance
C
      IF (PROJ.EQ.'SV') CALL MAPSTR ('SA - SATELLITE DISTANCE',5.)
C
C Set limits of map
C
      CALL MAPSET (JLIM,PLIM1,PLIM2,PLIM3,PLIM4)
C
C Initialize Maps and Areas
C
      CALL MAPINT
      CALL ARINAM (MAP,LMAP)
      CALL MAPBLA (MAP)
C
C Draw Masked Grid Lines
C
      CALL MAPGRM (MAP, XWRK, YWRK, NWRK, IAREA, IGRP, ISIZ, MASK2)
C
C Draw Continental Outlines and Perimeter
C
      CALL MAPLBL
      CALL MAPLOT
C
C Done.
C
      RETURN
      END

      SUBROUTINE MASK1(XC,YC,MCS,AREAID,GRPID,IDSIZE)

      INTEGER AREAID(IDSIZE),GRPID(IDSIZE),ID
      REAL XC(MCS),YC(MCS)
C
C Retrieve area id for geographical area
C
      DO 10, I=1,IDSIZE
         IF (GRPID(I).EQ.1) ID=AREAID(I)
 10   CONTINUE
C
C If the line is over water, and has 2 or more points draw it.
C
      IF ((MAPACI(ID).EQ.1).AND.(MCS.GE.2)) THEN
         CALL CURVED(XC,YC,MCS)
      ENDIF
C
C Otherwise, don't draw the line - mask it.
C
      RETURN
      END
      SUBROUTINE MASK2(XC,YC,MCS,AREAID,GRPID,IDSIZE)

      INTEGER AREAID(IDSIZE),GRPID(IDSIZE),ID
      REAL XC(MCS),YC(MCS)

      CALL DASHDB (29298)
C
C Retrieve area id for geographical area
C
      DO 10, I=1,IDSIZE
         IF (GRPID(I).EQ.1) ID=AREAID(I)
 10   CONTINUE
C
C If the line is over water, and has 2 or more points draw it.
C
      IF ((MAPACI(ID).EQ.1).AND.(MCS.GE.2)) THEN
         CALL CURVED(XC,YC,MCS)
      ENDIF
C
C Otherwise, don't draw the line - mask it.
C
      RETURN
      END

subroutine red2reg(nred,red,nlat,jlon,nlon,reg,ierror)
implicit none
 
integer, intent(in) :: nred
integer, intent(in) :: nlat
integer, intent(in) :: nlon

real(kind=8), intent(in)  :: red(nred)
integer, intent(in)       :: jlon(nlat)
real(kind=8), intent(out) :: reg(nlat,nlon)
integer, intent(out)      :: ierror

! Local Variables
      
real(kind=8), dimension(:,:), allocatable :: atmp
real(kind=8), dimension(:), allocatable   :: work
real(kind=8), dimension(:), allocatable   :: wsave

integer :: jlat
integer :: jptr

! ==========================================
! Error tests go here
! ==========================================
      
ierror=0
      
! ==========================================
! Forward FFT (real-> complex) the reduced 
! grid data_values and store in the 
! regular grid array
! ==========================================

reg(:,:) = 0.0_8
jptr=1
do jlat=1,nlat

   ! recompute FFT work arrays only when longitude changes
   
   if (jlat==1) then
      allocate(wsave(2*jlon(jlat)+15))
      allocate(work(jlon(jlat)))
      allocate(atmp(1,jlon(jlat)))
            
      call hrffti(jlon(jlat),wsave)
   else if (jlon(jlat) .ne. jlon(jlat-1)) then

      deallocate(wsave)
      deallocate(work)
      deallocate(atmp)

      allocate(wsave(2*jlon(jlat)+15))
      allocate(work(jlon(jlat)))
      allocate(atmp(1,jlon(jlat)))

      call hrffti(jlon(jlat),wsave)
   end if
   atmp(1,1:jlon(jlat)) = red(jptr:jlon(jlat)+jptr-1)
   call hrfftf(1,jlon(jlat),atmp,1,wsave,work)
   reg(jlat,1:jlon(jlat)) = atmp(1,1:jlon(jlat))/jlon(jlat) ! rescale wave numbers
   jptr=jptr+jlon(jlat)
end do
      
deallocate(wsave)
deallocate(work)
deallocate(atmp)

! =============================
! Inverse FFT (complex to real)
! =============================
              
allocate(wsave(2*nlon+15))
allocate(work(nlat*nlon))

call hrffti(nlon,wsave)
call hrfftb(nlat,nlon,reg,nlat,wsave,work)
      
deallocate(wsave)
deallocate(work)

end subroutine red2reg


subroutine reg2red(nlat,jlon,nlon,reg,nred,red,ierror)
implicit none

integer, intent(in) :: nlat
integer, intent(in) :: nlon
integer, intent(in) :: nred
      
integer, intent(in)                 :: jlon(nlat)
real(kind=8), intent(in)   ::   reg(nlat,nlon)
real(kind=8), intent(out)  :: red(nred)

integer, intent(out)                :: ierror

! Local Variables
      
real(kind=8), dimension(:,:), allocatable :: atmp, reg1
real(kind=8), dimension(:), allocatable :: work
real(kind=8), dimension(:), allocatable :: wsave

integer :: jlat, i
integer :: jptr
      
allocate(reg1(nlat,nlon))
reg1 = reg
! ===================================================
! Error tests go here.
! ===================================================
      
ierror=0
      
! ===================================================
! Forward FFT (complex to real) the regular grid data
! ===================================================
              
allocate(wsave(2*nlon+15))
allocate(work(nlat*nlon))

call hrffti(nlon,wsave)
call hrfftf(nlat,nlon,reg1,nlat,wsave,work)
      
deallocate(wsave)
deallocate(work)
      
! ==========================================
! Forward FFT (real-> complex) the reduced 
! grid data_values and store in the 
! regular grid array
! ==========================================

red(:) = 0.0_8
jptr=1
do jlat=1,nlat

   ! recompute FFT work arrays only when longitude changes
   
   if (jlat==1) then
      allocate(wsave(2*jlon(jlat)+15))
      allocate(work(jlon(jlat)))
      allocate(atmp(1,jlon(jlat)))
            
      call hrffti(jlon(jlat),wsave)
   else if (jlon(jlat) .ne. jlon(jlat-1)) then

      deallocate(wsave)
      deallocate(work)
      deallocate(atmp)

      allocate(wsave(2*jlon(jlat)+15))
      allocate(work(jlon(jlat)))
      allocate(atmp(1,jlon(jlat)))

      call hrffti(jlon(jlat),wsave)
   end if
         
   atmp(1,1:jlon(jlat)) = reg1(jlat,1:jlon(jlat))/nlon  ! rescale wave numbers
   call hrfftb(1,jlon(jlat),atmp,1,wsave,work)
   red(jptr:jlon(jlat)+jptr-1) = atmp(1,1:jlon(jlat))
         
   jptr=jptr+jlon(jlat)
end do
      
deallocate(wsave)
deallocate(work)
deallocate(atmp)
deallocate(reg1)

end subroutine reg2red


subroutine find_diff(nlats,ngpts,ngpts_perlats,u,un, &
          v,vn,ue,ve,iue,ive,ulat,ulon,vlat,vlon)
implicit none
integer, intent(in) :: nlats,ngpts,ngpts_perlats(nlats)
real(8), dimension(ngpts), intent(in) :: u,un,v,vn
real(8), intent(out) :: ue,ve
integer, intent(out) :: iue, ive, ulat,ulon,vlat,vlon
real(8) :: udf, vdf, uet, vet
integer :: gp, jlat, klon
ue = 0.d0
ve = 0.d0
gp = 0
do jlat = 1, nlats
  do klon = 1, ngpts_perlats(jlat)
    gp = gp + 1
    udf = u(gp) - un(gp)
    uet = udf/u(gp)
    if(abs(uet).ge.abs(ue)) then
       ue = uet
       iue = gp
       ulat = jlat
       ulon = klon
    endif
    vdf = v(gp) - vn(gp)
    vet = vdf/v(gp)
    if(abs(vet).ge.abs(ve)) then
       ve = vet
       ive = gp
       vlat = jlat
       vlon = klon
    endif
  end do
end do
end subroutine find_diff

C NCLFORTSTART
      subroutine dimavgwgt(nx, x, xmsg, wgt, iopt, xavg)
      implicit none
C                                 INPUT
      integer  nx, iopt
      double precision x(nx), wgt(nx), xmsg
C                                 OUTPUT
      double precision xavg
C NCLEND
      integer n, npts
      double precision xsum, wsum 

C NCL:  xWgtAvg = dim_avg_wgt(x, wgt, opt)

      xavg = xmsg
      xsum = 0.d0
      wsum = 0.d0
      npts = 0

      do n=1,nx
         if (x(n).ne.xmsg) then
             xsum = xsum + x(n)*wgt(n)
             wsum = wsum + wgt(n)
             npts = npts + 1
         end if
      end do

      if (wsum.gt.0.d0) then
          if ((iopt.eq.0 .and. npts.eq.nx) .or. iopt.eq.1 ) then
              xavg = xsum/wsum
              return
          end if

          if (iopt.gt.1 .and. npts.ge.iopt) then
              xavg = xsum/wsum
              return
          end if
      end if

      return
      end

C
C	$Id: conop1.f,v 1.4 2008-07-27 00:16:57 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CONOP1 (IOPT)
C
C SET THE CONTRAN OPTIONS
C
C INPUT
C     IOPT-CHARACTER STRING OF OPTION VALUE
C
C  SET COMMON DATA EQUAL TO INPUT DATA
C
C
C
      COMMON /CONRA1/ CL(30)     ,NCL        ,OLDZ       ,PV(210)    ,
     1                FINC       ,HI         ,FLO
      COMMON /CONRA2/ REPEAT     ,EXTRAP     ,PER        ,MESS       ,
     1                ISCALE     ,LOOK       ,PLDVLS     ,GRD        ,
     2                CINC       ,CHILO      ,CON        ,LABON      ,
     3                PMIMX      ,SCALE      ,FRADV      ,EXTRI      ,
     4                BPSIZ      ,LISTOP
      COMMON /CONRA3/ IREC
      COMMON /CONRA4/ NCP        ,NCPSZ
      COMMON /CONRA5/ NIT        ,ITIPV
      COMMON /CONRA6/ XST        ,YST        ,XED        ,YED        ,
     1                STPSZ      ,IGRAD      ,IG         ,XRG        ,
     2                YRG        ,BORD       ,PXST       ,PYST       ,
     3                PXED       ,PYED       ,ITICK
      COMMON /CONR18/ TITLE      ,ICNT   ,ITLSIZ
      COMMON /CONR19/ IHIGH      ,INMAJ      ,INLAB      ,INDAT      ,
     1              LEN      ,IFMT       ,LEND       ,
     2                IFMTD      ,ISIZEP     ,INMIN
      COMMON /CONRA9/ ICOORD(500),NP         ,MXXY       ,TR         ,
     1                BR         ,TL         ,BL         ,CONV       ,
     2                XN         ,YN         ,ITLL       ,IBLL       ,
     3                ITRL       ,IBRL       ,XC         ,YC         ,
     4                ITLOC(210) ,JX         ,JY         ,ILOC       ,
     5                ISHFCT     ,XO         ,YO         ,IOC        ,NC
      COMMON /CONR10/ NT         ,NL         ,NTNL       ,JWIPT      ,
     1                JWIWL      ,JWIWP      ,JWIPL      ,IPR        ,
     2                ITPV
      COMMON /CONR20/ NREP       ,NCRT       ,ISIZEL     ,
     1                MINGAP     ,ISIZEM         ,
     2                TENS
      COMMON /CONR12/ IXMAX      ,IYMAX      ,XMAX       ,YMAX
      LOGICAL         REPEAT     ,EXTRAP     ,PER        ,MESS       ,
     1                LOOK       ,PLDVLS     ,GRD        ,LABON      ,
     2                PMIMX      ,FRADV      ,EXTRI      ,CINC       ,
     3                TITLE      ,LISTOP     ,CHILO      ,CON
      COMMON /CONR13/XVS(50),YVS(50),ICOUNT,SPVAL,SHIELD,
     1               SLDPLT
      LOGICAL SHIELD,SLDPLT
      COMMON /CONR14/LINEAR
      LOGICAL LINEAR
      COMMON /CONR15/ ISTRNG
        CHARACTER*64 ISTRNG
        COMMON /CONR16/ FORM
        CHARACTER*10 FORM
        COMMON /CONR17/ NDASH, IDASH, EDASH
        CHARACTER*10 NDASH, IDASH, EDASH
        COMMON /RANINT/ IRANMJ, IRANMN, IRANTX
        COMMON /RAQINT/ IRAQMJ, IRAQMN, IRAQTX
        COMMON /RASINT/ IRASMJ, IRASMN, IRASTX
C
C
C
C  INTPR IS THE DASH PACKAGE COMMON BLOCK INTERFACE
C  NP11 IS NP IN ALL OTHER INTPR DEFINITIONS; NAME CHANGE BECAUSE OF
C  CONFLICT
C
      COMMON /INTPR/  IPAU       ,FPART      ,TENSN      ,NP11       ,
     1                SMALL      ,L1         ,ADDLR      ,ADDTB      ,
     2                MLLINE     ,ICLOSE
        CHARACTER*7  IOPT
        CHARACTER*2  TAG, OPT
C
C
        SAVE
C
C  DETERMINE OPTION AND ITS VALUE
C
        TAG = IOPT(1:2)
        IF (IOPT(3:3) .EQ. '=') THEN
                OPT = IOPT(4:5)
        ELSE
            OPT = IOPT(5:6)
        ENDIF
C
C  REP FOUND CHECK VALUE OF SWITCH
C
      IF (TAG .EQ. 'RE') THEN
C
C  SWITCH = ON CONTOUR SAME DATA
C
            IF (OPT .EQ. 'ON') THEN
              REPEAT = .TRUE.
              RETURN
C
C  SWITCH = OFF CONTOUR NEW DATA
C
            ELSEIF (OPT .EQ. 'OF') THEN
              REPEAT = .FALSE.
              RETURN
          ELSE
                  GOTO 120
            ENDIF
C
C  EXTRAPOLATION FLAG
C
      ELSEIF (TAG .EQ. 'EX') THEN
C
C  SWITCH = ON EXTRAPOLATE WHEN CONTOURING
C
            IF (OPT .EQ. 'ON') THEN
              EXTRAP = .TRUE.
              RETURN
C
C  SWITCH = OFF INTERPOLATE ONLY
C
            ELSEIF (OPT .EQ. 'OF') THEN
              EXTRAP = .FALSE.
              RETURN
          ELSE
                  GOTO 120
            ENDIF
C
C  PER FOUND SET PERIMETER
C
      ELSEIF (TAG .EQ. 'PE') THEN
C
C  SWITCH = ON DRAW PERIMETERS
C
            IF (OPT .EQ. 'ON') THEN
              PER = .TRUE.
C
C  TURN GRID OFF, USER WANTS PERIMETER
C
             GRD = .FALSE.
             RETURN
C
C  SWITCH = OFF DO NOT DRAW PERIMETERS
C
            ELSEIF (OPT .EQ. 'OF') THEN
             PER = .FALSE.
             RETURN
          ELSE
                  GOTO 120
            ENDIF
C
C  DEF FOUND SET ALL OPTIONS TO DEFAULT (NO SWITCHES)
C
        ELSEIF (TAG .EQ. 'DE') THEN
      PER = .TRUE.
      LISTOP = .FALSE.
      PMIMX = .FALSE.
      SCALE = 1.
      TENSN = TENS
      EXTRAP = .FALSE.
      TITLE = .FALSE.
      ITLSIZ = 16
      REPEAT = .FALSE.
      MESS = .TRUE.
      CON = .FALSE.
      CINC = .FALSE.
      CHILO = .FALSE.
      IGRAD = IG
      ISCALE = 0
      NCP = 4
      LOOK = .FALSE.
      GRD = .FALSE.
      PLDVLS = .FALSE.
      INMAJ = 1
      INMIN = 1
      INDAT = 1
      INLAB = 1
      IRANMJ = 1
      IRANMN = 1
      IRANTX = 1
      IRASMJ = 1
      IRASMN = 1
      IRASTX = 1
      IRAQMJ = 1
      IRAQMN = 1
      IRAQTX = 1
      BPSIZ = 0.
      LABON = .TRUE.
      ISIZEL = 9
      ISIZEP = 8
      ISIZEM = 15
      FRADV = .TRUE.
      EXTRI = .FALSE.
      MINGAP = 3
      LINEAR = .FALSE.
      ICOUNT = 0
      SHIELD = .FALSE.
      SLDPLT = .FALSE.
C
C  SET DEFAULT DASH PATTERN
C
         IDASH = '$$$$$$$$$$'
         NDASH = '$$$$$$$$$$'
         EDASH = '$$$$$$$$$$'
C
C  SET DEFAULT FORMAT
C
         FORM = '(G10.3)'
      RETURN
C
C  MES FOUND TEST VALUE OF SWITCH
C
      ELSEIF (TAG .EQ. 'ME') THEN
C
C  ACTIVATE CONRAN MESSAGE
C
            IF (OPT .EQ. 'ON') THEN
              MESS = .TRUE.
              RETURN
C
C  TURN OFF CONRAN MESSAGE
C
            ELSEIF (OPT .EQ. 'OF') THEN
              MESS = .FALSE.
              RETURN
          ELSE
                  GOTO 120
          ENDIF
C
C  SCALING OPTION GET VALUE OF SWITCH
C
      ELSEIF (TAG .EQ. 'SC') THEN
C
C  SET VALUE OF SCALE FLAG
C
            IF (OPT .EQ. 'ON') THEN
                  ISCALE = 0
                  RETURN
            ELSEIF (OPT .EQ. 'OF') THEN
                  ISCALE = 1
                  RETURN
            ELSEIF (OPT .EQ. 'PR') THEN
                  ISCALE = 2
                  RETURN
            ELSE
                  GOTO 120
            ENDIF
C
C  TRIANGLE FLAG GET VALUE OF SWITCH
C
      ELSEIF (TAG .EQ. 'TR') THEN
C
C  SWITCH ON
C
            IF (OPT .EQ. 'ON') THEN
              LOOK = .TRUE.
              RETURN
C
C  SWITCH OFF
C
          ELSEIF (OPT .EQ. 'OF') THEN
              LOOK = .FALSE.
              RETURN
          ELSE
                  GOTO 120
          ENDIF
C
C  PLOT DATA VALUES FLAG GET VALUE OF SWITCH
C
      ELSEIF (TAG .EQ. 'PD') THEN
C
C SWITCH ON
C
            IF (OPT .EQ. 'ON') THEN
              PLDVLS = .TRUE.
              RETURN
C
C  SWITCH OFF
C
            ELSEIF (OPT .EQ. 'OF') THEN
              PLDVLS = .FALSE.
              RETURN
          ELSE
                  GOTO 120
            ENDIF
C
C  GRID OPTION ACTIVATED GET VALUE OF SWITCH
C
      ELSEIF (TAG .EQ. 'GR') THEN
C
C  SWITCH ON SET GRID FLAG
C
            IF (OPT .EQ. 'ON') THEN
              GRD = .TRUE.
C
C  TURN PER OFF USER WANTS GRID
C
              PER = .FALSE.
              RETURN
C
C  SWITCH OFF CLEAR GRID FLAG
C
            ELSEIF (OPT .EQ. 'OF') THEN
              GRD = .FALSE.
              RETURN
          ELSE
                  GOTO 120
            ENDIF
C
C  LABEL PLOTTING FLAG GET VALUE OF SWITCH
C
      ELSEIF (TAG .EQ. 'LA') THEN
C
C  SWITCH ON LABEL CONTOURS
C
            IF (OPT .EQ. 'ON') THEN
              LABON = .TRUE.
                RETURN
C
C  SWITCH OFF DON"T LABEL CONTOURS
C
            ELSEIF (OPT .EQ. 'OF') THEN
              LABON = .FALSE.
              RETURN
          ELSE
                  GOTO 120
            ENDIF
C
C  PLOT THE RELATIVE MIN"S AND MAX"S
C
      ELSEIF (TAG .EQ. 'PM') THEN
C
C  SWTICH ON PLOT THE INFO
C
            IF (OPT .EQ. 'ON') THEN
              PMIMX = .TRUE.
                RETURN
C
C  SWTICH OFF DO NOT PLOT THE INFO
C
            ELSEIF (OPT .EQ. 'OF') THEN
              PMIMX = .FALSE.
                RETURN
          ELSE
                  GOTO 120
            ENDIF
C
C  ADVANCE FRAME BEFORE TRIANGULATION PLOT
C
      ELSEIF (TAG .EQ. 'TF') THEN
C
C  SWITCH ON ADVANCE FRAME
C
          IF (OPT .EQ. 'ON') THEN
                FRADV = .TRUE.
                RETURN
C
C  SWITCH OFF DO NOT ADVANCE FRAME
C
            ELSEIF (OPT .EQ. 'OF') THEN
                FRADV = .FALSE.
                RETURN
          ELSE
                  GOTO 120
            ENDIF
C
C  EXIT AFTER TRIANGULATION
C
      ELSEIF (TAG .EQ. 'TO') THEN
C
C  SWITCH ON EXIT AFTER TRIANGULATION
C
          IF (OPT .EQ. 'ON') THEN
                EXTRI = .TRUE.
                LOOK = .TRUE.
                FRADV = .FALSE.
                RETURN
C
C  SWITCH OFF DO NOT EXIT AFTER TRIANGULATION
C
          ELSEIF (OPT .EQ. 'OF') THEN
                FRADV = .TRUE.
                LOOK = .FALSE.
                EXTRI = .FALSE.
                RETURN
          ELSE
                  GOTO 120
            ENDIF
C
C  LIST OPTION GET VALUE OF SWITCH
C
      ELSEIF (TAG .EQ. 'LO') THEN
C
C  ON SET LIST OPTIONS FLAG
C
            IF (OPT .EQ. 'ON') THEN
              LISTOP = .TRUE.
                RETURN
C
C  TURN OFF LIST OPTIONS FLAG
C
          ELSEIF (OPT .EQ. 'OF') THEN
              LISTOP = .FALSE.
                RETURN
          ELSE
                  GOTO 120
            ENDIF
C
C  SET THE INTERPOLATION SCHEME
C
      ELSEIF (TAG .EQ. 'IT') THEN
C
C  SET TO C1 SURFACE
C
            IF (OPT .EQ. 'C1') THEN
              LINEAR = .FALSE.
                RETURN
C
C  SET TO LINEAR INTERPOLATION
C
            ELSEIF (OPT .EQ. 'LI') THEN
                LINEAR = .TRUE.
                RETURN
          ELSE
                  GOTO 120
            ENDIF
C
C  SET THE SHIELD PLOT FLAG
C
      ELSEIF (TAG .EQ. 'PS') THEN
C
C  TURN ON SHIELD PLOT
C
            IF (OPT .EQ. 'ON') THEN
                SLDPLT = .TRUE.
                RETURN
C
C  TURN OFF SHIELD PLOT
C
            ELSEIF (OPT .EQ. 'OF') THEN
                SLDPLT = .FALSE.
                RETURN
            ELSE
                  GOTO 120
            ENDIF
        ELSE
            GOTO 120
        ENDIF
C
C  ERROR UNDEFINED OPTION DETECTED
C
  120 CALL SETER (' CONOP1 -- UNDEFINED OPTION',1,1)
      RETURN
C
        END

C	$Id: wmlabs.f,v 1.13 2008-07-27 00:17:36 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE WMLABS(X,Y,SYMTYP)
C
C  Plot the symbol indicated by the string SYMTYP.  The symbol
C  is centered at (X,Y), where X and Y are world coordinates.
C  Legal values for SYMTYP are:
C
C         'HI'
C         'LOW'
C         'ARROW'
C         'DOT'
C         'CLOUD'
C         'ICE'
C         'IS' (Intermittent showers)
C         'IT' (Sunny, chance of T-storms)
C         'MC' (Mostly cloudy)
C         'MS' (Mostly sunny)
C         'RAIN'
C         'RS' (Rain and snow)
C         'SNOWFLAKES'
C         'SUN'
C         'THUNDERSTORM'
C         'VECTOR'
C         'WIND'
C
      CHARACTER*(*) SYMTYP
      CHARACTER*1 FCODE
      CHARACTER*5 CHRDIST
C
      include 'wmcomn.h'
C
C  Reference arrow.
C
      PARAMETER (IADIM=8,D2RAD=.017453293)
      DIMENSION XX(IADIM),YY(IADIM),ARROWX(IADIM),ARROWY(IADIM)
      REAL OLDWN(4),OLDVP(4),OCLIP(4)
      DIMENSION TMPX(IADIM),TMPY(IADIM)
      DATA XX/-1.000, -0.330, -0.360,  0.000,
     +        -0.360, -0.330, -1.000, -1.000  /
      DATA YY/-0.030, -0.030, -0.120,  0.000,
     +         0.120,  0.030,  0.030, -0.030  /
C
C  Array for vector draws.
C
      PARAMETER (IVSDM=5)
      DIMENSION VECTSX(IVSDM),VECTSY(IVSDM)
C
C  Save the current text function code and set it to a colon for
C  this subroutine.
C
      CALL PCGETC('FC',FCODE)
      CALL PCSETC('FC',':')
C
C  Save the current line and fill colors and set them to ICOLOR.
C
      CALL GQFAIS(IER,IFAISO)
      CALL GQFACI(IER,IFCLRO)
      CALL GQPLCI(IER,ILCLRO)
      CALL GSFAIS(1)
      CALL GSFACI(ICOLOR)
      CALL GSPLCI(ICOLOR)
C
C  Convert X and Y to NDC and work in NDC space.
C
      CALL WMW2NX(1,X,XNDC)
      CALL WMW2NY(1,Y,YNDC)
C
C  Save normalization transformation number 1 along with its
C  window and viewport and define a new transformation 1
C  that has as its window and viewport the current clip
C  rectangle.
C
      CALL GQCNTN(IER,NTRO)
      CALL GQCLIP(IER,ICLIP,OCLIP)
      CALL GQNT(1,IER,OLDWN,OLDVP)
C
      CALL GSWN(1,OCLIP(1),OCLIP(2),OCLIP(3),OCLIP(4))
      CALL GSVP(1,OCLIP(1),OCLIP(2),OCLIP(3),OCLIP(4))
      CALL GSELNT(1)
C
C  Turn on text extent computation for the remainder of the subroutine.
C
      CALL PCSETI('TE',1)
C
      SIZEL = WSIZES
C
      IF (SYMTYP(1:1).EQ.'H' .OR. SYMTYP(1:1).EQ.'h') THEN
C
C  Draw a high symbol.
C
        RADIUS = 1.10*SIZEL
        OFFSET = 0.15*RADIUS
        CALL NGGETI('CT',ICTYPO)
        CALL NGSETI('CT',0)
C
C  Shadow.
C
        IF (IHIGC1 .GE. 0) THEN
          CALL NGDOTS(XNDC-OFFSET,YNDC-OFFSET,1,2.*RADIUS,IHIGC1)
        ENDIF
C
C  Character background.
C
        IF (IHIGC2 .GE. 0) THEN
          CALL NGDOTS(XNDC,YNDC,1,2.*RADIUS,IHIGC2)
        ENDIF
        CALL NGSETI('CT',1)
C
C  Circumscribed circle.
C
        IF (IHIGC4 .GE. 0) THEN
          CALL NGDOTS(XNDC,YNDC,1,2.*RADIUS,IHIGC4)
        ENDIF
        CALL NGSETI('CT',ICTYPO)
        CALL PCGETI('CC - character color',ICLRO)
        CALL PCGETI('FN - font name',IFNTO)
        CALL PCSETI('CC - character color',IHIGC3)
        CALL PCSETI('FN - font name',22)
C
C  "H" character.
C
        IF (IHIGC3 .GE. 0) THEN
          CALL PLCHHQ(XNDC,YNDC,'H',SIZEL,0.,0.)
        ENDIF
        CALL PCSETI('CC - character color',ICLRO)
        CALL PCSETI('FN - font name',IFNTO)
      ELSE IF (SYMTYP(1:1).EQ.'L' .OR. SYMTYP(1:1).EQ.'l') THEN
C
C  Draw a low symbol.
C
        RADIUS = 1.0*SIZEL
        OFFSET = 0.20*RADIUS
        CALL NGGETI('CT',ICTYPO)
        CALL NGSETI('CT',0)
C
C  Shadow.
C
        IF (ILOWC1 .GE. 0) THEN
          CALL NGDOTS(XNDC,YNDC,1,2.*RADIUS+OFFSET,ILOWC1)
        ENDIF
C
C  Character background.
C
        IF (ILOWC2 .GE. 0) THEN
          CALL NGDOTS(XNDC,YNDC,1,2.*RADIUS,ILOWC2)
        ENDIF
        CALL NGSETI('CT',1)
C
C  Circumscribed circle.
C
        IF (ILOWC4 .GE. 0) THEN
          CALL NGDOTS(XNDC,YNDC,1,2.*RADIUS,ILOWC4)
        ENDIF
        CALL NGSETI('CT',ICTYPO)
        CALL PCGETI('CC - character color',ICLRO)
        CALL PCGETI('FN - font name',IFNTO)
        CALL PCSETI('CC - character color',ILOWC3)
        CALL PCSETI('FN - font name',22)
C
C  "L" character.
C
        IF (ILOWC3 .GE. 0) THEN
          CALL PLCHHQ (XNDC,YNDC,':F22:L',SIZEL,0.,0.)
        ENDIF
        CALL PCSETI('CC - CHARACTER COLOR',ICLRO)
        CALL PCSETI('FN - font name',IFNTO)
      ELSE IF (SYMTYP(1:1).EQ.'A' .OR. SYMTYP(1:1).EQ.'a') THEN
C
C  Draw an arrow of length ARWSIZ in direction ARWDIR with the
C  point of the arrow at (X,Y).
C
C  Scale the arrow.
C
        SS = ARWSIZ
        DO 10 I=1,IADIM
          IF (I.EQ.1 .OR. I.EQ.7 .OR. I.EQ.8) THEN
            ARROWX(I) = SS*ARWLEN*XX(I)
          ELSE
            ARROWX(I) = SS*XX(I)
          ENDIF
          ARROWY(I) = SS*YY(I)
   10   CONTINUE
C
C  Rotate the arrow.
C
        COSANG = COS(D2RAD*ARWDIR)
        SINANG = SIN(D2RAD*ARWDIR)
        DO 20 I=1,IADIM
          TMPX(I) = ARROWX(I)*COSANG-ARROWY(I)*SINANG
          TMPY(I) = ARROWX(I)*SINANG+ARROWY(I)*COSANG
   20   CONTINUE
        DO 30 I=1,IADIM
          ARROWX(I) = TMPX(I)
          ARROWY(I) = TMPY(I)
   30   CONTINUE
C
C  Translate the arrow.
C
        DO 40 I=1,IADIM
          ARROWX(I) = XNDC+ARROWX(I)
          ARROWY(I) = YNDC+ARROWY(I)
   40   CONTINUE
C
C  Draw a shadow if the arrow shadow color is non-negative.
C
        IF (IARSHC .GE. 0) THEN
          DO 50 I=1,IADIM 
            TMPX(I) = ARROWX(I)-.0019*ARWSIZ/0.035
            TMPY(I) = ARROWY(I)-.0019*ARWSIZ/0.035
   50     CONTINUE
          CALL GSFACI(IARSHC)
          CALL GFA(IADIM,TMPX,TMPY)
        ENDIF
C
C  Draw the arrow.
C
        CALL GSFACI(IAROWC)
        CALL GFA(IADIM,ARROWX,ARROWY)
C
C  Draw an outline around the arrow if the outline color is non-negative.
C
        IF (IAROUC .GE. 0) THEN
          CALL GSPLCI(IAROUC)
          CALL GPL(IADIM,ARROWX,ARROWY)
        ENDIF
      ELSE IF (SYMTYP(1:1).EQ.'V' .OR. SYMTYP(1:1).EQ.'v') THEN
C
C  Draw a vector scaled by a size based on the ratio between
C  VCNREF and VCUREF, in direction VCWDIR with the
C  tail of the vector at (X,Y).  Scale the vector arrow head 
C  by VCHSIZ.
C
C
C  Create a base vector of the correct size that will be 
C  rotated and translated appropirately.
C
        SCALE = VCNREF/VCUREF
        HEADANG = VHDANG*D2RAD
        VECTSX(1) = 0.
        VECTSX(2) = SCALE*VCSIZE
        VECTSX(3) = VECTSX(2)-COS(HEADANG)*VCHSIZ
        VECTSX(4) = VECTSX(2)
        VECTSX(5) = VECTSX(3)
C
        VECTSY(1) = 0.
        VECTSY(2) = 0.
        VECTSY(3) = SIN(HEADANG)*VCHSIZ
        VECTSY(4) = 0.
        VECTSY(5) = -VECTSY(3)
C
C  Rotate.
C
        COSANG = COS(D2RAD*VCWDIR)
        SINANG = SIN(D2RAD*VCWDIR)
        DO 110 I=1,IVSDM
          TMPX(I) = VECTSX(I)*COSANG-VECTSY(I)*SINANG
          TMPY(I) = VECTSX(I)*SINANG+VECTSY(I)*COSANG
  110   CONTINUE
        DO 111 I=1,IVSDM
          VECTSX(I) = TMPX(I)
          VECTSY(I) = TMPY(I)
  111   CONTINUE
C
C  Translate the vector.
C
        DO 120 I=1,IVSDM
          VECTSX(I) = VECTSX(I)+XNDC
          VECTSY(I) = VECTSY(I)+YNDC
  120   CONTINUE
C
C  Draw the vector.
C
        CALL GSPLCI(VCCOLR)
        CALL GSLWSC(VCLWID)
        CALL GPL(IVSDM,VECTSX,VECTSY)

      ELSE IF (SYMTYP(1:1).EQ.'D' .OR. SYMTYP(1:1).EQ.'d') THEN
C
C  Draw a dot to mark a city location.
C
        RADIUS = 0.5*CDOTSZ
        CALL NGGETI('CT',ICTYPO)
        CALL NGSETI('CT',0)
        CALL NGDOTS(XNDC,YNDC,1,3.5*RADIUS,IDOTBG)
        CALL NGDOTS(XNDC,YNDC,1,2.0*RADIUS,IDOTCO)
        CALL NGSETI('CT',ICTYPO)
      ELSE IF (SYMTYP(1:2).EQ.'SU' .OR. SYMTYP(1:2).EQ.'su' .OR.
     +         SYMTYP(1:2).EQ.'MC' .OR. SYMTYP(1:2).EQ.'mc' .OR.
     +         SYMTYP(1:2).EQ.'IS' .OR. SYMTYP(1:2).EQ.'is' .OR.
     +         SYMTYP(1:2).EQ.'IT' .OR. SYMTYP(1:2).EQ.'it' .OR.
     +         SYMTYP(1:2).EQ.'MS' .OR. SYMTYP(1:2).EQ.'ms') THEN
C
C  Draw a sun as a daily weather icon.
C
        CALL PCGETI('CC - character color',ICC)
C
C  Cloud first if mostly sunny or intermittant showers.
C
        IF(SYMTYP(1:2).EQ.'MS' .OR. SYMTYP(1:2).EQ.'ms') THEN
          CXOFF =  0.02
          CYOFF = -0.02
          IF (ICLDC3 .GE. 0) THEN
C
            CALL PCGETI('SF - shadow flag',ISF)
            CALL PCGETI('SC - shadow color',ISC)
            CALL PCGETR('SX - shadow X offset',OSX)
            CALL PCGETR('SY - shadow Y offset',OSY)
C
            CALL PCSETI('SF - shadow flag',1)
            CALL PCSETI('SC - shadow color',ICLDC3)
            CALL PCSETI('CC - character color',ICLDC3)
            CALL PCSETR('SX - shadow X offset', -.016)
            CALL PCSETR('SY - shadow Y offset', -.02)
C
            CALL PLCHHQ(XNDC+CXOFF,YNDC+CYOFF,':F37:k',10.*SIZEL,0.,0.)
C
            CALL PCSETI('SF - shadow flag',ISF)
            CALL PCSETI('SC - shadow color',ISC)
            CALL PCSETR('SX - shadow X offset',OSX)
            CALL PCSETR('SY - shadow Y offset',OSY)
          ENDIF
          IF (ICLDC1 .GE. 0) THEN
            CALL PCSETI('CC',ICLDC1)
            CALL PLCHHQ(XNDC+CXOFF,YNDC+CYOFF,':F37:k',10.*SIZEL,0.,0.)       
          ENDIF
          IF (ICLDC2 .GE. 0) THEN
            CALL PCSETI('CC',ICLDC2)
            CALL PLCHHQ(XNDC+CXOFF,YNDC+CYOFF,':F137:k',10.*SIZEL,0.,0.)       
          ENDIF
        ENDIF
C
C  Draw sun.
C
        SUNSIZ = 7.5*SIZEL
        SXOFF = 0.0
        SYOFF = 0.0
        IF (SYMTYP(1:2).EQ.'MS' .OR. SYMTYP(1:2).EQ.'ms' .OR.
     +      SYMTYP(1:2).EQ.'IT' .OR. SYMTYP(1:2).EQ.'it' .OR.
     +      SYMTYP(1:2).EQ.'IS' .OR. SYMTYP(1:2).EQ.'is' .OR.
     +      SYMTYP(1:2).EQ.'MC' .OR. SYMTYP(1:2).EQ.'mc') THEN
          SXOFF = -0.02
          SYOFF =  0.02
        ENDIF
        IF (ISUNC4 .GE. 0) THEN
C
          CALL PCGETI('SF - shadow flag',ISF)
          CALL PCGETI('SC - shadow color',ISC)
          CALL PCGETR('SX - shadow X offset',OSX)
          CALL PCGETR('SY - shadow Y offset',OSY)
C
          CALL PCSETI('SF - shadow flag',1)
          CALL PCSETI('SC - shadow color',ISUNC4)
          CALL PCSETI('CC - character color',ISUNC4)
          CALL PCSETR('SX - shadow X offset', -.016)
          CALL PCSETR('SY - shadow Y offset', -.02)
C
          CALL PLCHHQ(XNDC+SXOFF,YNDC+SYOFF,':F37:l',SUNSIZ,0.,0.)
C
          CALL PCSETI('SF - shadow flag',ISF)
          CALL PCSETI('SC - shadow color',ISC)
          CALL PCSETR('SX - shadow X offset',OSX)
          CALL PCSETR('SY - shadow Y offset',OSY)
        ENDIF
        IF (ISUNC2 .GE. 0) THEN
          CALL PCSETI('CC',ISUNC2)
          CALL PLCHHQ(XNDC+SXOFF,YNDC+SYOFF,':F37:l',SUNSIZ,0.,0.)
          IF (ISUNC3 .GE. 0) THEN
            CALL PCSETI('CC',ISUNC3)
            CALL PLCHHQ(XNDC+SXOFF,YNDC+SYOFF,':F137:l',SUNSIZ,0.,0.)
          ENDIF
        ENDIF
        IF (ISUNC1 .GE. 0) THEN
          CALL PCSETI('CC',ISUNC1)
          CALL PLCHHQ(XNDC+SXOFF,YNDC+SYOFF,':F37:m',SUNSIZ,0.,0.)
          IF (ISUNC3 .GE. 0) THEN
            CALL PCSETI('CC',ISUNC3)
            CALL PLCHHQ(XNDC+SXOFF,YNDC+SYOFF,':F137:m',SUNSIZ,0.,0.)
          ENDIF
        ENDIF
C
C  Add showers.
C
        IF (SYMTYP(1:2).EQ.'IS' .OR. SYMTYP(1:2).EQ.'is' .OR.
     +      SYMTYP(1:2).EQ.'IT' .OR. SYMTYP(1:2).EQ.'it') THEN
          CALL PCSETI('CC - character color',ICOLOR)
          CALL PLCHHQ(XNDC+CXOFF,YNDC+CYOFF,':F37:o',10.*SIZEL,0.,0.)
        ENDIF
C
C  Add thunder bolt.
C
        IF (SYMTYP(1:2).EQ.'IT' .OR. SYMTYP(1:2).EQ.'it') THEN
          OXNDC = XNDC+0.019*50.*SIZEL+CXOFF
          OYNDC = YNDC-0.06*50.*SIZEL+CYOFF
          TSIZ  = 6.*SIZEL
          CALL PCSETR('ZX',.8)
          CALL PCSETR('ZY',1.3)
          IF (ILTNC3 .GE. 0) THEN
            CALL PCGETI('SF - shadow flag',ISF)
            CALL PCGETI('SC - shadow color',ISC)
            CALL PCGETR('SX - shadow X offset',OSX)
            CALL PCGETR('SY - shadow Y offset',OSY)
C
            CALL PCSETI('SF - shadow flag',1)
            CALL PCSETI('SC - shadow color',ILTNC3)
            CALL PCSETI('CC - character color',ILTNC3)
            CALL PCSETR('SX - shadow X offset', -.015)
            CALL PCSETR('SY - shadow Y offset', -.04)
C
            CALL PLCHHQ(OXNDC,OYNDC,':F37:f',TSIZ,0.,0.)
C
            CALL PCSETI('SF - shadow flag',ISF)
            CALL PCSETI('SC - shadow color',ISC)
            CALL PCSETR('SX - shadow X offset',OSX)
            CALL PCSETR('SY - shadow Y offset',OSY)
          ENDIF
          IF (ILTNC1 .GE. 0) THEN
            CALL PCSETI('CC',ILTNC1)
            CALL PLCHHQ(OXNDC,OYNDC,':F37:f',TSIZ,0.,0.)
          ENDIF
          IF (ILTNC2 .GE. 0) THEN
            CALL PCSETI('CC',ILTNC2)
            CALL PLCHHQ(OXNDC,OYNDC,':F137:f',TSIZ,0.,0.)
          ENDIF
          CALL PCSETR('ZX',1.)
          CALL PCSETR('ZY',1.)
        ENDIF
C
C  Cloud last if mostly cloudy.
C
        IF(SYMTYP(1:2).EQ.'MC' .OR. SYMTYP(1:2).EQ.'mc' .OR.
     +     SYMTYP(1:2).EQ.'IT' .OR. SYMTYP(1:2).EQ.'it' .OR.
     +     SYMTYP(1:2).EQ.'IS' .OR. SYMTYP(1:2).EQ.'is') THEN
          CXOFF =  0.02
          CYOFF = -0.02
          IF (ICLDC3 .GE. 0) THEN
C
            CALL PCGETI('SF - shadow flag',ISF)
            CALL PCGETI('SC - shadow color',ISC)
            CALL PCGETR('SX - shadow X offset',OSX)
            CALL PCGETR('SY - shadow Y offset',OSY)
C
            CALL PCSETI('SF - shadow flag',1)
            CALL PCSETI('SC - shadow color',ICLDC3)
            CALL PCSETI('CC - character color',ICLDC3)
            CALL PCSETR('SX - shadow X offset', -.016)
            CALL PCSETR('SY - shadow Y offset', -.02)
C
            CALL PLCHHQ(XNDC+CXOFF,YNDC+CYOFF,':F37:k',10.*SIZEL,0.,0.)
C
            CALL PCSETI('SF - shadow flag',ISF)
            CALL PCSETI('SC - shadow color',ISC)
            CALL PCSETR('SX - shadow X offset',OSX)
            CALL PCSETR('SY - shadow Y offset',OSY)
          ENDIF
          IF (ICLDC1 .GE. 0) THEN
            CALL PCSETI('CC',ICLDC1)
            CALL PLCHHQ(XNDC+CXOFF,YNDC+CYOFF,':F37:k',10.*SIZEL,0.,0.)
          ENDIF
          IF (ICLDC2 .GE. 0) THEN
            CALL PCSETI('CC',ICLDC2)
            CALL PLCHHQ(XNDC+CXOFF,YNDC+CYOFF,':F137:k',10.*SIZEL,0.,0.)
          ENDIF
        ENDIF
        CALL PCSETI('CC - character color',ICC)
      ELSE IF (SYMTYP(1:1).EQ.'C' .OR. SYMTYP(1:1).EQ.'c'   .OR.
     +         SYMTYP(1:1).EQ.'R' .OR. SYMTYP(1:1).EQ.'r'   .OR.
     +         SYMTYP(1:2).EQ.'RS' .OR. SYMTYP(1:2).EQ.'rs' .OR.
     +         SYMTYP(1:2).EQ.'MC' .OR. SYMTYP(1:2).EQ.'mc' .OR.
     +         SYMTYP(1:2).EQ.'SN' .OR. SYMTYP(1:2).EQ.'sn') THEN
C
C  Draw a cloud as a daily weather icon.
C
        CALL PCGETI('CC - character color',ICC)
        IF (ICLDC3 .GE. 0) THEN
C
          CALL PCGETI('SF - shadow flag',ISF)
          CALL PCGETI('SC - shadow color',ISC)
          CALL PCGETR('SX - shadow X offset',OSX)
          CALL PCGETR('SY - shadow Y offset',OSY)
C
          CALL PCSETI('SF - shadow flag',1)
          CALL PCSETI('SC - shadow color',ICLDC3)
          CALL PCSETI('CC - character color',ICLDC3)
          CALL PCSETR('SX - shadow X offset', -.016)
          CALL PCSETR('SY - shadow Y offset', -.02)
C
          CALL PLCHHQ(XNDC,YNDC,':F37:k',10.*SIZEL,0.,0.)
C
          CALL PCSETI('SF - shadow flag',ISF)
          CALL PCSETI('SC - shadow color',ISC)
          CALL PCSETR('SX - shadow X offset',OSX)
          CALL PCSETR('SY - shadow Y offset',OSY)
        ENDIF
        IF (ICLDC1 .GE. 0) THEN
          CALL PCSETI('CC',ICLDC1)
          CALL PLCHHQ(XNDC,YNDC,':F37:k',10.*SIZEL,0.,0.)
        ENDIF
        IF (ICLDC2 .GE. 0) THEN
          CALL PCSETI('CC',ICLDC2)
          CALL PLCHHQ(XNDC,YNDC,':F137:k',10.*SIZEL,0.,0.)
        ENDIF
        IF (SYMTYP(1:1).EQ.'R'  .OR. SYMTYP(1:1).EQ.'r' .OR.
     +      SYMTYP(1:2).EQ.'RS' .OR. SYMTYP(1:2).EQ.'rs') THEN
          CALL PCSETI('CC - character color',ICOLOR)
          CALL PLCHHQ(XNDC,YNDC,':F37:o',10.*SIZEL,0.,0.)
        ENDIF
        IF (SYMTYP(1:2).EQ.'SN' .OR. SYMTYP(1:2).EQ.'sn' .OR.
     +      SYMTYP(1:2).EQ.'RS' .OR. SYMTYP(1:2).EQ.'rs') THEN
C
C  Draw snowflakes as part of daily weather icon.
C
          DSIZ = 1.3*SIZEL
          CALL PCGETI('CC',ISNFC1)
          CALL PCSETI('CC',ICOLOR)
          DO 60 I=1,3
            XP = XNDC+0.8*DSIZ+2.7*DSIZ*REAL(I-2)
            YP = YNDC-2.40*DSIZ
            CALL PLCHHQ(XP,YP,':F37:q',DSIZ,0.,0.)
   60     CONTINUE
          DO 70 I=1,2
            XP = XNDC+0.8*DSIZ+2.7*DSIZ*(REAL(I)-1.5)
            YP = YNDC-3.50*DSIZ
            CALL PLCHHQ(XP,YP,':F37:q',DSIZ,0.,0.)
   70     CONTINUE
          CALL PCSETI('CC',ISNFC1)
        ENDIF
        CALL PCSETI('CC - character color',ICC)
      ELSE IF (SYMTYP(1:1).EQ.'W' .OR. SYMTYP(1:1).EQ.'w') THEN
          CALL PCGETI('CC',ISNFC1)
          CALL PCSETI('CC',ICOLOR)
          CALL PLCHHQ(XNDC,YNDC,':F37:r',10.*SIZEL,0.,0.)
          CALL PCSETI('CC',ISNFC1)
      ELSE IF (SYMTYP(1:2).EQ.'IC' .OR. SYMTYP(1:2).EQ.'ic') THEN
C
C  Ice. Use the ARROW arrays as scratch space to store a region.
C
        DELX = 5.2*SIZEL
        DELY = 3.0*SIZEL
        ARROWX(1) = XNDC-DELX
        ARROWY(1) = YNDC+DELY
        ARROWX(2) = XNDC
        ARROWY(2) = YNDC+DELY
        ARROWX(3) = XNDC+DELX
        ARROWY(3) = YNDC+DELY
        ARROWX(4) = XNDC+DELX
        ARROWY(4) = YNDC-DELY
        ARROWX(5) = XNDC
        ARROWY(5) = YNDC-DELY
        ARROWX(6) = XNDC-DELX
        ARROWY(6) = YNDC-DELY
        ARROWX(7) = ARROWX(1)
        ARROWY(7) = ARROWY(1)
        CALL WMRGWT(7,ARROWX,ARROWY,37,105)
      ELSE IF (SYMTYP(1:1).EQ.'T' .OR. SYMTYP(1:1).EQ.'t') THEN
C
C  Draw a thunderstorm symbol as a daily weather icon.
C
        CALL PCGETI('CC - character color',ICC)
        CALL PCSETI('CC - character color',ICOLOR)
        CALL PLCHHQ(XNDC,YNDC,':F37:o',10.*SIZEL,0.,0.)
C
        OXNDC = XNDC+0.019*50.*SIZEL
        OYNDC = YNDC-0.06*50.*SIZEL
        TSIZ  = 6.*SIZEL
        CALL PCSETR('ZX',.8)
        CALL PCSETR('ZY',1.3)
        IF (ILTNC3 .GE. 0) THEN
          CALL PCGETI('SF - shadow flag',ISF)
          CALL PCGETI('SC - shadow color',ISC)
          CALL PCGETR('SX - shadow X offset',OSX)
          CALL PCGETR('SY - shadow Y offset',OSY)
C
          CALL PCSETI('SF - shadow flag',1)
          CALL PCSETI('SC - shadow color',ILTNC3)
          CALL PCSETI('CC - character color',ILTNC3)
          CALL PCSETR('SX - shadow X offset', -.015)
          CALL PCSETR('SY - shadow Y offset', -.04)
C
          CALL PLCHHQ(OXNDC,OYNDC,':F37:f',TSIZ,0.,0.)
C
          CALL PCSETI('SF - shadow flag',ISF)
          CALL PCSETI('SC - shadow color',ISC)
          CALL PCSETR('SX - shadow X offset',OSX)
          CALL PCSETR('SY - shadow Y offset',OSY)
        ENDIF
        IF (ILTNC1 .GE. 0) THEN
          CALL PCSETI('CC',ILTNC1)
          CALL PLCHHQ(OXNDC,OYNDC,':F37:f',TSIZ,0.,0.)
        ENDIF
        IF (ILTNC2 .GE. 0) THEN
          CALL PCSETI('CC',ILTNC2)
          CALL PLCHHQ(OXNDC,OYNDC,':F137:f',TSIZ,0.,0.)
        ENDIF
        CALL PCSETR('ZX',1.)
        CALL PCSETR('ZY',1.)
C
        IF (ICLDC3 .GE. 0) THEN
          CALL PCGETI('SF - shadow flag',ISF)
          CALL PCGETI('SC - shadow color',ISC)
          CALL PCGETR('SX - shadow X offset',OSX)
          CALL PCGETR('SY - shadow Y offset',OSY)
C
          CALL PCSETI('SF - shadow flag',1)
          CALL PCSETI('SC - shadow color',ICLDC3)
          CALL PCSETI('CC - character color',ICLDC3)
          CALL PCSETR('SX - shadow X offset', -.016)
          CALL PCSETR('SY - shadow Y offset', -.02)
C
          CALL PLCHHQ(XNDC,YNDC,':F37:k',10.*SIZEL,0.,0.)
C
          CALL PCSETI('SF - shadow flag',ISF)
          CALL PCSETI('SC - shadow color',ISC)
          CALL PCSETR('SX - shadow X offset',OSX)
          CALL PCSETR('SY - shadow Y offset',OSY)
        ENDIF
        IF (ICLDC1 .GE. 0) THEN
          CALL PCSETI('CC',ICLDC1)
          CALL PLCHHQ(XNDC,YNDC,':F37:k',10.*SIZEL,0.,0.)
        ENDIF
        IF (ICLDC2 .GE. 0) THEN
          CALL PCSETI('CC',ICLDC2)
          CALL PLCHHQ(XNDC,YNDC,':F137:k',10.*SIZEL,0.,0.)
        ENDIF
        CALL PCSETI('CC - character color',ICC)
      ENDIF
C
C  Restore original attrributes.
C
      CALL GSFAIS(IFAISO)
      CALL GSFACI(IFCLRO)
      CALL GSPLCI(ILCLRO)
      CALL GSELNT(NTRO)
      CALL GSWN(1,OLDWN(1),OLDWN(2),OLDWN(3),OLDWN(4))
      CALL GSVP(1,OLDVP(1),OLDVP(2),OLDVP(3),OLDVP(4))
      CALL PCSETI('TE',0)
      CALL PCSETC('FC',FCODE)
C
      RETURN
      END

      SUBROUTINE SLAEXC( WANTQ, N, T, LDT, Q, LDQ, J1, N1, N2, WORK,
     $                   INFO )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     February 29, 1992
*
*     .. Scalar Arguments ..
      LOGICAL            WANTQ
      INTEGER            INFO, J1, LDQ, LDT, N, N1, N2
*     ..
*     .. Array Arguments ..
      REAL               Q( LDQ, * ), T( LDT, * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  SLAEXC swaps adjacent diagonal blocks T11 and T22 of order 1 or 2 in
*  an upper quasi-triangular matrix T by an orthogonal similarity
*  transformation.
*
*  T must be in Schur canonical form, that is, block upper triangular
*  with 1-by-1 and 2-by-2 diagonal blocks; each 2-by-2 diagonal block
*  has its diagonal elemnts equal and its off-diagonal elements of
*  opposite sign.
*
*  Arguments
*  =========
*
*  WANTQ   (input) LOGICAL
*          = .TRUE. : accumulate the transformation in the matrix Q;
*          = .FALSE.: do not accumulate the transformation.
*
*  N       (input) INTEGER
*          The order of the matrix T. N >= 0.
*
*  T       (input/output) REAL array, dimension (LDT,N)
*          On entry, the upper quasi-triangular matrix T, in Schur
*          canonical form.
*          On exit, the updated matrix T, again in Schur canonical form.
*
*  LDT     (input)  INTEGER
*          The leading dimension of the array T. LDT >= max(1,N).
*
*  Q       (input/output) REAL array, dimension (LDQ,N)
*          On entry, if WANTQ is .TRUE., the orthogonal matrix Q.
*          On exit, if WANTQ is .TRUE., the updated matrix Q.
*          If WANTQ is .FALSE., Q is not referenced.
*
*  LDQ     (input) INTEGER
*          The leading dimension of the array Q.
*          LDQ >= 1; and if WANTQ is .TRUE., LDQ >= N.
*
*  J1      (input) INTEGER
*          The index of the first row of the first block T11.
*
*  N1      (input) INTEGER
*          The order of the first block T11. N1 = 0, 1 or 2.
*
*  N2      (input) INTEGER
*          The order of the second block T22. N2 = 0, 1 or 2.
*
*  WORK    (workspace) REAL array, dimension (N)
*
*  INFO    (output) INTEGER
*          = 0: successful exit
*          = 1: the transformed matrix T would be too far from Schur
*               form; the blocks are not swapped and T and Q are
*               unchanged.
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ZERO, ONE
      PARAMETER          ( ZERO = 0.0E+0, ONE = 1.0E+0 )
      REAL               TEN
      PARAMETER          ( TEN = 1.0E+1 )
      INTEGER            LDD, LDX
      PARAMETER          ( LDD = 4, LDX = 2 )
*     ..
*     .. Local Scalars ..
      INTEGER            IERR, J2, J3, J4, K, ND
      REAL               CS, DNORM, EPS, SCALE, SMLNUM, SN, T11, T22,
     $                   T33, TAU, TAU1, TAU2, TEMP, THRESH, WI1, WI2,
     $                   WR1, WR2, XNORM
*     ..
*     .. Local Arrays ..
      REAL               D( LDD, 4 ), U( 3 ), U1( 3 ), U2( 3 ),
     $                   X( LDX, 2 )
*     ..
*     .. External Functions ..
      REAL               SLAMCH, SLANGE
      EXTERNAL           SLAMCH, SLANGE
*     ..
*     .. External Subroutines ..
      EXTERNAL           SLACPY, SLANV2, SLARFG, SLARFX, SLARTG, SLASY2,
     $                   SROT
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, MAX
*     ..
*     .. Executable Statements ..
*
      INFO = 0
*
*     Quick return if possible
*
      IF( N.EQ.0 .OR. N1.EQ.0 .OR. N2.EQ.0 )
     $   RETURN
      IF( J1+N1.GT.N )
     $   RETURN
*
      J2 = J1 + 1
      J3 = J1 + 2
      J4 = J1 + 3
*
      IF( N1.EQ.1 .AND. N2.EQ.1 ) THEN
*
*        Swap two 1-by-1 blocks.
*
         T11 = T( J1, J1 )
         T22 = T( J2, J2 )
*
*        Determine the transformation to perform the interchange.
*
         CALL SLARTG( T( J1, J2 ), T22-T11, CS, SN, TEMP )
*
*        Apply transformation to the matrix T.
*
         IF( J3.LE.N )
     $      CALL SROT( N-J1-1, T( J1, J3 ), LDT, T( J2, J3 ), LDT, CS,
     $                 SN )
         CALL SROT( J1-1, T( 1, J1 ), 1, T( 1, J2 ), 1, CS, SN )
*
         T( J1, J1 ) = T22
         T( J2, J2 ) = T11
*
         IF( WANTQ ) THEN
*
*           Accumulate transformation in the matrix Q.
*
            CALL SROT( N, Q( 1, J1 ), 1, Q( 1, J2 ), 1, CS, SN )
         END IF
*
      ELSE
*
*        Swapping involves at least one 2-by-2 block.
*
*        Copy the diagonal block of order N1+N2 to the local array D
*        and compute its norm.
*
         ND = N1 + N2
         CALL SLACPY( 'Full', ND, ND, T( J1, J1 ), LDT, D, LDD )
         DNORM = SLANGE( 'Max', ND, ND, D, LDD, WORK )
*
*        Compute machine-dependent threshold for test for accepting
*        swap.
*
         EPS = SLAMCH( 'P' )
         SMLNUM = SLAMCH( 'S' ) / EPS
         THRESH = MAX( TEN*EPS*DNORM, SMLNUM )
*
*        Solve T11*X - X*T22 = scale*T12 for X.
*
         CALL SLASY2( .FALSE., .FALSE., -1, N1, N2, D, LDD,
     $                D( N1+1, N1+1 ), LDD, D( 1, N1+1 ), LDD, SCALE, X,
     $                LDX, XNORM, IERR )
*
*        Swap the adjacent diagonal blocks.
*
         K = N1 + N1 + N2 - 3
         GO TO ( 10, 20, 30 )K
*
   10    CONTINUE
*
*        N1 = 1, N2 = 2: generate elementary reflector H so that:
*
*        ( scale, X11, X12 ) H = ( 0, 0, * )
*
         U( 1 ) = SCALE
         U( 2 ) = X( 1, 1 )
         U( 3 ) = X( 1, 2 )
         CALL SLARFG( 3, U( 3 ), U, 1, TAU )
         U( 3 ) = ONE
         T11 = T( J1, J1 )
*
*        Perform swap provisionally on diagonal block in D.
*
         CALL SLARFX( 'L', 3, 3, U, TAU, D, LDD, WORK )
         CALL SLARFX( 'R', 3, 3, U, TAU, D, LDD, WORK )
*
*        Test whether to reject swap.
*
         IF( MAX( ABS( D( 3, 1 ) ), ABS( D( 3, 2 ) ), ABS( D( 3,
     $       3 )-T11 ) ).GT.THRESH )GO TO 50
*
*        Accept swap: apply transformation to the entire matrix T.
*
         CALL SLARFX( 'L', 3, N-J1+1, U, TAU, T( J1, J1 ), LDT, WORK )
         CALL SLARFX( 'R', J2, 3, U, TAU, T( 1, J1 ), LDT, WORK )
*
         T( J3, J1 ) = ZERO
         T( J3, J2 ) = ZERO
         T( J3, J3 ) = T11
*
         IF( WANTQ ) THEN
*
*           Accumulate transformation in the matrix Q.
*
            CALL SLARFX( 'R', N, 3, U, TAU, Q( 1, J1 ), LDQ, WORK )
         END IF
         GO TO 40
*
   20    CONTINUE
*
*        N1 = 2, N2 = 1: generate elementary reflector H so that:
*
*        H (  -X11 ) = ( * )
*          (  -X21 ) = ( 0 )
*          ( scale ) = ( 0 )
*
         U( 1 ) = -X( 1, 1 )
         U( 2 ) = -X( 2, 1 )
         U( 3 ) = SCALE
         CALL SLARFG( 3, U( 1 ), U( 2 ), 1, TAU )
         U( 1 ) = ONE
         T33 = T( J3, J3 )
*
*        Perform swap provisionally on diagonal block in D.
*
         CALL SLARFX( 'L', 3, 3, U, TAU, D, LDD, WORK )
         CALL SLARFX( 'R', 3, 3, U, TAU, D, LDD, WORK )
*
*        Test whether to reject swap.
*
         IF( MAX( ABS( D( 2, 1 ) ), ABS( D( 3, 1 ) ), ABS( D( 1,
     $       1 )-T33 ) ).GT.THRESH )GO TO 50
*
*        Accept swap: apply transformation to the entire matrix T.
*
         CALL SLARFX( 'R', J3, 3, U, TAU, T( 1, J1 ), LDT, WORK )
         CALL SLARFX( 'L', 3, N-J1, U, TAU, T( J1, J2 ), LDT, WORK )
*
         T( J1, J1 ) = T33
         T( J2, J1 ) = ZERO
         T( J3, J1 ) = ZERO
*
         IF( WANTQ ) THEN
*
*           Accumulate transformation in the matrix Q.
*
            CALL SLARFX( 'R', N, 3, U, TAU, Q( 1, J1 ), LDQ, WORK )
         END IF
         GO TO 40
*
   30    CONTINUE
*
*        N1 = 2, N2 = 2: generate elementary reflectors H(1) and H(2) so
*        that:
*
*        H(2) H(1) (  -X11  -X12 ) = (  *  * )
*                  (  -X21  -X22 )   (  0  * )
*                  ( scale    0  )   (  0  0 )
*                  (    0  scale )   (  0  0 )
*
         U1( 1 ) = -X( 1, 1 )
         U1( 2 ) = -X( 2, 1 )
         U1( 3 ) = SCALE
         CALL SLARFG( 3, U1( 1 ), U1( 2 ), 1, TAU1 )
         U1( 1 ) = ONE
*
         TEMP = -TAU1*( X( 1, 2 )+U1( 2 )*X( 2, 2 ) )
         U2( 1 ) = -TEMP*U1( 2 ) - X( 2, 2 )
         U2( 2 ) = -TEMP*U1( 3 )
         U2( 3 ) = SCALE
         CALL SLARFG( 3, U2( 1 ), U2( 2 ), 1, TAU2 )
         U2( 1 ) = ONE
*
*        Perform swap provisionally on diagonal block in D.
*
         CALL SLARFX( 'L', 3, 4, U1, TAU1, D, LDD, WORK )
         CALL SLARFX( 'R', 4, 3, U1, TAU1, D, LDD, WORK )
         CALL SLARFX( 'L', 3, 4, U2, TAU2, D( 2, 1 ), LDD, WORK )
         CALL SLARFX( 'R', 4, 3, U2, TAU2, D( 1, 2 ), LDD, WORK )
*
*        Test whether to reject swap.
*
         IF( MAX( ABS( D( 3, 1 ) ), ABS( D( 3, 2 ) ), ABS( D( 4, 1 ) ),
     $       ABS( D( 4, 2 ) ) ).GT.THRESH )GO TO 50
*
*        Accept swap: apply transformation to the entire matrix T.
*
         CALL SLARFX( 'L', 3, N-J1+1, U1, TAU1, T( J1, J1 ), LDT, WORK )
         CALL SLARFX( 'R', J4, 3, U1, TAU1, T( 1, J1 ), LDT, WORK )
         CALL SLARFX( 'L', 3, N-J1+1, U2, TAU2, T( J2, J1 ), LDT, WORK )
         CALL SLARFX( 'R', J4, 3, U2, TAU2, T( 1, J2 ), LDT, WORK )
*
         T( J3, J1 ) = ZERO
         T( J3, J2 ) = ZERO
         T( J4, J1 ) = ZERO
         T( J4, J2 ) = ZERO
*
         IF( WANTQ ) THEN
*
*           Accumulate transformation in the matrix Q.
*
            CALL SLARFX( 'R', N, 3, U1, TAU1, Q( 1, J1 ), LDQ, WORK )
            CALL SLARFX( 'R', N, 3, U2, TAU2, Q( 1, J2 ), LDQ, WORK )
         END IF
*
   40    CONTINUE
*
         IF( N2.EQ.2 ) THEN
*
*           Standardize new 2-by-2 block T11
*
            CALL SLANV2( T( J1, J1 ), T( J1, J2 ), T( J2, J1 ),
     $                   T( J2, J2 ), WR1, WI1, WR2, WI2, CS, SN )
            CALL SROT( N-J1-1, T( J1, J1+2 ), LDT, T( J2, J1+2 ), LDT,
     $                 CS, SN )
            CALL SROT( J1-1, T( 1, J1 ), 1, T( 1, J2 ), 1, CS, SN )
            IF( WANTQ )
     $         CALL SROT( N, Q( 1, J1 ), 1, Q( 1, J2 ), 1, CS, SN )
         END IF
*
         IF( N1.EQ.2 ) THEN
*
*           Standardize new 2-by-2 block T22
*
            J3 = J1 + N2
            J4 = J3 + 1
            CALL SLANV2( T( J3, J3 ), T( J3, J4 ), T( J4, J3 ),
     $                   T( J4, J4 ), WR1, WI1, WR2, WI2, CS, SN )
            IF( J3+2.LE.N )
     $         CALL SROT( N-J3-1, T( J3, J3+2 ), LDT, T( J4, J3+2 ),
     $                    LDT, CS, SN )
            CALL SROT( J3-1, T( 1, J3 ), 1, T( 1, J4 ), 1, CS, SN )
            IF( WANTQ )
     $         CALL SROT( N, Q( 1, J3 ), 1, Q( 1, J4 ), 1, CS, SN )
         END IF
*
      END IF
      RETURN
*
*     Exit with INFO = 1 if swap was rejected.
*
   50 INFO = 1
      RETURN
*
*     End of SLAEXC
*
      END

C
C	$Id: wmdflt.f,v 1.9 2008-07-27 00:17:36 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE WMDFLT()
C
C  Sets all attributes to their default values.  All values should
C  agree with those set in BLOCKDATA WMBLDAX.
C
      include 'wmcomn.h'
C
      SYMWID =  0.03250
      BEGDST =  0.01500
      ENDDST =  0.01500
      BETDST =  0.04500
      CRVLEN =  0.00000
      SLOPE1 =  0.00000
      SLOPE2 =  0.00000
      SLOPEL =  0.00000
      SLOPER =  0.00000
      RLINWD =  8.00000
      SLINWD =  0.00275
      WSIZEW =  0.01400
      WSIZEC =  0.01050
      WSIZET =  0.01650
      WSIZER =  0.00800
      WSIZES =  0.02000
      ARWSIZ =  0.03500
      ARWLEN =  1.00000
      ARWDIR =  0.00000
      CDOTSZ =  0.00600
      CTYMRG =  0.00200
      TMPMRG =  0.00100
      WBSHFT =  0.03500
      WBFTIC =  0.33000
      WBDIST =  0.10000
      WBCLMR =  0.25000
      WBBANG = 62.00000
      WBXL   =  0.00000
      WBXR   =  0.00000
      WBYB   =  0.00000
      WBYT   =  0.00000
      WBBASE =  0.30000
      WBLSIZ =  0.17000
      DLINWD =  2.00000
C
      IWBBAS =   0
      IWBDIR =   0
      IBGCTY =   0
      IFGTRG =   1
      IDOTCO =   1
      IDOTBG =   0
      IFRONT =   2
      IARNDX =   1
      ISLFLG =   3
      IALOFT =   0
      IWDTYP =   0
      ICOLOR =   1
      NPTSBZ =  51
      MAXSYM = 200
      ISUNC1 =   2
      ISUNC2 =   3
      ISUNC3 =   1
      ISUNC4 =   1
      ICLDC1 =   2
      ICLDC2 =   1
      ICLDC3 =   1
      ILTNC1 =   2
      ILTNC2 =   1
      ILTNC3 =   1
      NUMSYO =  -1
      IWARMC =   1
      ICOLDC =   1
      ITRO1C =   1
      ITRO2C =   1
      IHIGC1 =   1
      IHIGC2 =   0
      IHIGC3 =   1
      IHIGC4 =   1
      ILOWC1 =   0
      ILOWC2 =   1
      ILOWC3 =   0
      IRGLC1 =   1
      IRGLC2 =   0
      IRGLC3 =   1
      IRGLC4 =   1
      IRGLC5 =  -1
      IAROWC =   1
      IARSHC =  -1
      IAROUC =  -1
      IRLLSC =  -1
      IRLOUC =  -1
      IRLBKC =  -1
C
      DO 10 I=1,ISDIM
        ISTYPE(I) = 2
   10 CONTINUE
C
      END

C
C	$Id: gwpdvi.f,v 1.5 2008-07-27 00:21:08 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GWPDVI (INVAL, IPOINT, IPRIM)
C
C  Update attribute deferral variables for an integer-valued attribute.
C
C
C  PARAMETERS:
C    INPUT
C      INVAL   - New value for the attribute item.
C      IPOINT  - Pointer into deferral control variable structures, 
C                and into index array that gives start of primitive 
C                in attribute equivalencing array, integer version.
C      IPRIM   - Output primitive type associated with the attribute 
C                (1=POLYLINE, 2=POLYMARKER, 3=TEXT, 4=FILL AREA).  
C                Used to index into other of the control variable 
C                structures.
C
C    OUTPUT
C      Adjustment of attribute deferral control parameters in comMON.
C
      include 'gwiarq.h'
      include 'gwiast.h'
      include 'gwiadc.h'
C
      INTEGER INVAL(*), IPOINT, IPRIM
C
      LOGICAL CHGNS
      INTEGER I, IOFF, LNGVAL
C
      SAVE
C
C  Offset and length of attribute in equivalencing structures.
C
      IOFF   = ABS(IP2AEA(IPOINT))
      LNGVAL = IL2AEA(IPOINT)
C
C  Is the new value different from the last sent?
C
      CHGNS = INVAL(1).NE.MSAEQV(IOFF)
      DO 10 I=2,LNGVAL
        CHGNS = CHGNS.OR. INVAL(I).NE.MSAEQV(IOFF+I-1)
   10 CONTINUE
C
      IF (CHGNS) THEN
C
C  New and last sent differ.
C
C  Set aggregate change-pending parameter.
C
        AGPEND(IPRIM) = .TRUE.
      END IF
C
C  Copy new value to requested.
C
      MRAEQV(IOFF) = INVAL(1)
      DO 30 I=2,LNGVAL
        MRAEQV(IOFF+I-1) = INVAL(I)
   30 CONTINUE
C
C  Mark value change.
C
      VALCHG(IPOINT) = CHGNS
C
      RETURN
      END

C
C $Id: idpltr.f,v 1.4 2008-07-27 00:17:30 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE IDPLTR (NDAT,XDAT,YDAT,IWRK)
C
        DIMENSION XDAT(NDAT),YDAT(NDAT),IWRK(*)
C
C This routine plots the triangulation.  The arguments NDAT, XDAT, YDAT,
C YDAT, and IWRK are all as used in a previous call to either IDSFFT or
C IDBVIP:
C
C   NDAT is the number of data points.
C
C   (XDAT(I),I=1,NDAT) are the X coordinates of the data points.
C
C   (YDAT(I),I=1,NDAT) are the Y coordinates of the data points.
C
C   IWRK is the integer work array.
C
C Note that the caller is responsible for doing the SET call required
C to map the triangles to the correct position on the plotter frame.
C
C Note also that some triangle edges are drawn twice.  No attempt is
C made to prevent this.
C
C Check for an uncleared prior error.
C
        IF (ICFELL('IDPLTR (BIVAR) - UNCLEARED PRIOR ERROR',1).NE.0)
     +                                                        RETURN
C
C Draw the triangles.
C
        DO 101 I=1,IWRK(5)
          IOT1=IWRK(15+3*(I-1)+1)
          IOT2=IWRK(15+3*(I-1)+2)
          IOT3=IWRK(15+3*(I-1)+3)
          CALL FRSTPT (XDAT(IOT1),YDAT(IOT1))
          IF (ICFELL('IDPLTR',2).NE.0) RETURN
          CALL VECTOR (XDAT(IOT2),YDAT(IOT2))
          IF (ICFELL('IDPLTR',3).NE.0) RETURN
          CALL VECTOR (XDAT(IOT3),YDAT(IOT3))
          IF (ICFELL('IDPLTR',4).NE.0) RETURN
          CALL VECTOR (XDAT(IOT1),YDAT(IOT1))
          IF (ICFELL('IDPLTR',5).NE.0) RETURN
          CALL PLOTIF (0.,0.,2)
          IF (ICFELL('IDPLTR',6).NE.0) RETURN
  101   CONTINUE
C
C Done.
C
        RETURN
C
      END

C
C	$Id: wmlabw.f,v 1.6 2008-07-27 00:17:37 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE WMLABW(X,Y,LABEL)
C
C  Plot the label contained in the character variable LABEL 
C  centered at (X,Y), where X and Y are world coordinates.  
C  The labels are drawn with a shadow box.
C
      include 'wmcomn.h'
C
      CHARACTER*(*) LABEL
C
C  Save the current line and fill colors and set them to ICOLOR.
C
      CALL GQFAIS(IER,IFAISO)
      CALL GQFACI(IER,IFCLRO)
      CALL GQPLCI(IER,ILCLRO)
      CALL GSFACI(ICOLOR)
      CALL GSPLCI(ICOLOR)
C
C  Convert X and Y to NDC and work in NDC space.
C
      CALL WMW2NX(1,X,XNDC)
      CALL WMW2NY(1,Y,YNDC)
      CALL GQCNTN(IER,NTRO)
      CALL GSELNT(0)
      CALL PCSETI('TE',1)
C
      SIZEL = WSIZEW
C
C  Save Plotchar parameters.
C
      CALL PCGETI ('BF - BOX FLAG',IBFO)
      CALL PCGETR ('BM - BOX MARGIN',BMO)
      CALL PCGETR ('BX - BOX SHADOW X OFFSET',BXO)
      CALL PCGETR ('BY - BOX SHADOW Y OFFSET',BYO)
      CALL PCGETI ('BC(1) - BOX COLOR - BOX OUTLINE    ',IBC1)
      CALL PCGETI ('BC(2) - BOX COLOR - BOX FILL       ',IBC2)
      CALL PCGETI ('BC(3) - BOX COLOR - BOX SHADOW FILL',IBC3)
      CALL PCGETI ('CC - CHARACTER COLOR',ICCO)
      CALL PCGETI ('OC - outline color',IOC)
      CALL PCGETI ('OF - outline flag',IFC)
      CALL PCGETI ('FN - font number',IFNO)
C
C  Draw a label with a box around it.
C
      CALL PCSETI ('BF - BOX FLAG',7)
      CALL PCSETR ('BM - BOX MARGIN',.35)
      CALL PCSETR ('BX - BOX SHADOW X OFFSET',-0.20)
      CALL PCSETR ('BY - BOX SHADOW Y OFFSET',-0.20)
      CALL PCSETI ('BC(1) - BOX COLOR - BOX OUTLINE    ',IRGLC1)
      CALL PCSETI ('BC(2) - BOX COLOR - BOX FILL       ',IRGLC2)
      CALL PCSETI ('BC(3) - BOX COLOR - BOX SHADOW FILL',IRGLC3)
      CALL PCSETI ('CC - CHARACTER COLOR',IRGLC4)
      CALL PCSETI ('FN',22)
      IF (IRGLC5 .GE. 0) THEN
        CALL PCSETI ('OF - outline flag',1)
        CALL PCSETI ('OC - outline color',IRGLC5)
      ENDIF
      CALL PLCHHQ (XNDC,YNDC,LABEL,SIZEL,0.,0.)
C
C  Restore Plotchar parameters.
C
      CALL PCSETI ('BF - BOX FLAG',IBFO)
      CALL PCSETR ('BM - BOX MARGIN',BMO)
      CALL PCSETR ('BX - BOX SHADOW X OFFSET',BXO)
      CALL PCSETR ('BY - BOX SHADOW Y OFFSET',BYO)
      CALL PCSETI ('BC(1) - BOX COLOR - BOX OUTLINE    ',IBC1)
      CALL PCSETI ('BC(2) - BOX COLOR - BOX FILL       ',IBC2)
      CALL PCSETI ('BC(3) - BOX COLOR - BOX SHADOW FILL',IBC3)
      CALL PCSETI ('CC - CHARACTER COLOR',ICCO)
      CALL PCSETI ('OC - outline color',IOC)
      CALL PCSETI ('OF - outline flag',IFC)
      CALL PCSETI ('FN - font number',IFNO)
C
C  Restore GKS environment.
C
      CALL GSFAIS(IFAISO)
      CALL GSFACI(IFCLRO)
      CALL GSPLCI(ILCLRO)
      CALL GSELNT(NTRO)
      CALL PCSETI('TE',0)
C
      RETURN
      END

      SUBROUTINE DSTEVD( JOBZ, N, D, E, Z, LDZ, WORK, LWORK, IWORK,
     $                   LIWORK, INFO )
*
*  -- LAPACK driver routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          JOBZ
      INTEGER            INFO, LDZ, LIWORK, LWORK, N
*     ..
*     .. Array Arguments ..
      INTEGER            IWORK( * )
      DOUBLE PRECISION   D( * ), E( * ), WORK( * ), Z( LDZ, * )
*     ..
*
*  Purpose
*  =======
*
*  DSTEVD computes all eigenvalues and, optionally, eigenvectors of a
*  real symmetric tridiagonal matrix. If eigenvectors are desired, it
*  uses a divide and conquer algorithm.
*
*  The divide and conquer algorithm makes very mild assumptions about
*  floating point arithmetic. It will work on machines with a guard
*  digit in add/subtract, or on those binary machines without guard
*  digits which subtract like the Cray X-MP, Cray Y-MP, Cray C-90, or
*  Cray-2. It could conceivably fail on hexadecimal or decimal machines
*  without guard digits, but we know of none.
*
*  Arguments
*  =========
*
*  JOBZ    (input) CHARACTER*1
*          = 'N':  Compute eigenvalues only;
*          = 'V':  Compute eigenvalues and eigenvectors.
*
*  N       (input) INTEGER
*          The order of the matrix.  N >= 0.
*
*  D       (input/output) DOUBLE PRECISION array, dimension (N)
*          On entry, the n diagonal elements of the tridiagonal matrix
*          A.
*          On exit, if INFO = 0, the eigenvalues in ascending order.
*
*  E       (input/output) DOUBLE PRECISION array, dimension (N)
*          On entry, the (n-1) subdiagonal elements of the tridiagonal
*          matrix A, stored in elements 1 to N-1 of E; E(N) need not
*          be set, but is used by the routine.
*          On exit, the contents of E are destroyed.
*
*  Z       (output) DOUBLE PRECISION array, dimension (LDZ, N)
*          If JOBZ = 'V', then if INFO = 0, Z contains the orthonormal
*          eigenvectors of the matrix A, with the i-th column of Z
*          holding the eigenvector associated with D(i).
*          If JOBZ = 'N', then Z is not referenced.
*
*  LDZ     (input) INTEGER
*          The leading dimension of the array Z.  LDZ >= 1, and if
*          JOBZ = 'V', LDZ >= max(1,N).
*
*  WORK    (workspace/output) DOUBLE PRECISION array,
*                                         dimension (LWORK)
*          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*
*  LWORK   (input) INTEGER
*          The dimension of the array WORK.
*          If JOBZ  = 'N' or N <= 1 then LWORK must be at least 1.
*          If JOBZ  = 'V' and N > 1 then LWORK must be at least
*                         ( 1 + 4*N + N**2 ).
*
*          If LWORK = -1, then a workspace query is assumed; the routine
*          only calculates the optimal size of the WORK array, returns
*          this value as the first entry of the WORK array, and no error
*          message related to LWORK is issued by XERBLA.
*
*  IWORK   (workspace/output) INTEGER array, dimension (LIWORK)
*          On exit, if INFO = 0, IWORK(1) returns the optimal LIWORK.
*
*  LIWORK  (input) INTEGER
*          The dimension of the array IWORK.
*          If JOBZ  = 'N' or N <= 1 then LIWORK must be at least 1.
*          If JOBZ  = 'V' and N > 1 then LIWORK must be at least 3+5*N.
*
*          If LIWORK = -1, then a workspace query is assumed; the
*          routine only calculates the optimal size of the IWORK array,
*          returns this value as the first entry of the IWORK array, and
*          no error message related to LIWORK is issued by XERBLA.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*          > 0:  if INFO = i, the algorithm failed to converge; i
*                off-diagonal elements of E did not converge to zero.
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO, ONE
      PARAMETER          ( ZERO = 0.0D0, ONE = 1.0D0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            LQUERY, WANTZ
      INTEGER            ISCALE, LIWMIN, LWMIN
      DOUBLE PRECISION   BIGNUM, EPS, RMAX, RMIN, SAFMIN, SIGMA, SMLNUM,
     $                   TNRM
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      DOUBLE PRECISION   DLAMCH, DLANST
      EXTERNAL           LSAME, DLAMCH, DLANST
*     ..
*     .. External Subroutines ..
      EXTERNAL           DSCAL, DSTEDC, DSTERF, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          SQRT
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      WANTZ = LSAME( JOBZ, 'V' )
      LQUERY = ( LWORK.EQ.-1 .OR. LIWORK.EQ.-1 )
*
      INFO = 0
      LIWMIN = 1
      LWMIN = 1
      IF( N.GT.1 .AND. WANTZ ) THEN
         LWMIN = 1 + 4*N + N**2
         LIWMIN = 3 + 5*N
      END IF
*
      IF( .NOT.( WANTZ .OR. LSAME( JOBZ, 'N' ) ) ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( LDZ.LT.1 .OR. ( WANTZ .AND. LDZ.LT.N ) ) THEN
         INFO = -6
      ELSE IF( LWORK.LT.LWMIN .AND. .NOT.LQUERY ) THEN
         INFO = -8
      ELSE IF( LIWORK.LT.LIWMIN .AND. .NOT.LQUERY ) THEN
         INFO = -10
      END IF
*
      IF( INFO.EQ.0 ) THEN
         WORK( 1 ) = LWMIN
         IWORK( 1 ) = LIWMIN
      END IF
*
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DSTEVD', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
*
      IF( N.EQ.1 ) THEN
         IF( WANTZ )
     $      Z( 1, 1 ) = ONE
         RETURN
      END IF
*
*     Get machine constants.
*
      SAFMIN = DLAMCH( 'Safe minimum' )
      EPS = DLAMCH( 'Precision' )
      SMLNUM = SAFMIN / EPS
      BIGNUM = ONE / SMLNUM
      RMIN = SQRT( SMLNUM )
      RMAX = SQRT( BIGNUM )
*
*     Scale matrix to allowable range, if necessary.
*
      ISCALE = 0
      TNRM = DLANST( 'M', N, D, E )
      IF( TNRM.GT.ZERO .AND. TNRM.LT.RMIN ) THEN
         ISCALE = 1
         SIGMA = RMIN / TNRM
      ELSE IF( TNRM.GT.RMAX ) THEN
         ISCALE = 1
         SIGMA = RMAX / TNRM
      END IF
      IF( ISCALE.EQ.1 ) THEN
         CALL DSCAL( N, SIGMA, D, 1 )
         CALL DSCAL( N-1, SIGMA, E( 1 ), 1 )
      END IF
*
*     For eigenvalues only, call DSTERF.  For eigenvalues and
*     eigenvectors, call DSTEDC.
*
      IF( .NOT.WANTZ ) THEN
         CALL DSTERF( N, D, E, INFO )
      ELSE
         CALL DSTEDC( 'I', N, D, E, Z, LDZ, WORK, LWORK, IWORK, LIWORK,
     $                INFO )
      END IF
*
*     If matrix was scaled, then rescale eigenvalues appropriately.
*
      IF( ISCALE.EQ.1 )
     $   CALL DSCAL( N, ONE / SIGMA, D, 1 )
*
      WORK( 1 ) = LWMIN
      IWORK( 1 ) = LIWMIN
*
      RETURN
*
*     End of DSTEVD
*
      END

C
C	$Id: gspa.f,v 1.5 2008-07-27 00:21:02 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GSPA (SZX,SZY)
C
C  SET PATTERN SIZE
C
C  Currently this subroutine does nothing since ctrans does not support
C  the CGM PATTERN SIZE element.
C
      INTEGER ESPA
      PARAMETER (ESPA=39)
C
      include 'gkscom.h'
C
      REAL SZX,SZY
C
C  Remove this RETURN and uncomment appropriate lines to 
C  activate the subroutine.
C	
      RETURN
C
C  Check if GKS is in the proper state.
C
C     CALL GZCKST(8,ESPA,IER)
C     IF (IER .NE. 0) RETURN
C
C  Check that the size specifications are valid.
C
C     IF (SZX.LE.0. .OR. SZY.LE.0.) THEN
C       ERS = 1
C       CALL GERHND(87,ESPA,ERF)
C       ERS = 0
C       RETURN
C     ENDIF
C
C  Set the current pattern size variables
C  in the gks state list (these remain in world coordinates).
C
C     CPA(1) = SZX
C     CPA(2) = SZY
C
C  Transform pattern sizes to NDC space.
C
C     CALL GZW2NX(1,SZX,SZXN)
C     CALL GZW2NY(1,SZY,SZYN)
C
C  Invoke the workstation interface.
C
C     FCODE = 41
C     CONT  = 0
C     CALL GZROI(0)
C     RL1   = 1
C     RL2   = 1
C     RX(1) = SZXN
C     RY(1) = SZYN
C     CALL GZTOWK
C     IF (RERR .NE. 0) THEN
C       ERS = 1
C       CALL GERHND(RERR,ESPA,ERF)
C       ERS = 0
C     ENDIF
C
C     RETURN
      END

      SUBROUTINE DCALCORC(X,XAVE,XSTD,XMSG,NXY,Y,YMSG,CORC,IER)
      IMPLICIT NONE

c this routine will calculate the cross correlation coef between
c .   series x and series y
c this routine was originally meant to be in the inner portion
c .   of a loop

c     x         - input data 1D array  ( unchanged on output)
c     xave,xstd - ave and st. dev of x (input)
c     xmsg      - missing data code (if none set to some no. not
c                 encountered)
c     nxy       - length of x and y 1D vectors
c     y         - input data 1D array  ( unchanged on output)
c     ymsg      - missing data code (if none set to some no. not
c                 encountered)
c     corc      - correlation coef
c     ier       - error code (if ier=-1 then corc contains missing
c                 entry)
c --------------- input arguments
      INTEGER NXY
      DOUBLE PRECISION X(NXY),Y(NXY),XAVE,XSTD,XMSG,YMSG
c --------------- output arguments
      INTEGER IER
      DOUBLE PRECISION CORC
c --------------- local stuff
      INTEGER N,NPTUSX,NPTUSY
      DOUBLE PRECISION XVAR,YAVE,YVAR,YSTD,RN,XY,COVAR

      CORC = XMSG
      IF (XAVE.EQ.XMSG .OR. XSTD.EQ.XMSG) THEN
          CALL DSTAT2(X,NXY,XMSG,XAVE,XVAR,XSTD,NPTUSX,IER)
          IF (IER.NE.0 .OR. XSTD.EQ.0.0D0) THEN
              IER = 201
              RETURN
          END IF
      END IF

c calculate the mean and var of y

      CALL DSTAT2(Y,NXY,YMSG,YAVE,YVAR,YSTD,NPTUSY,IER)
      IF (IER.NE.0) RETURN
      IF (YSTD.EQ.0.D0) THEN
          IER = 203
          RETURN
      END IF

c calculate the cross correlation coef
c .   calculate the mean and variance of column nc in the data array

      RN = 0.D0
      XY = 0.D0
      DO N = 1,NXY
          IF (X(N).NE.XMSG .AND. Y(N).NE.YMSG) THEN
              RN = RN + 1.D0
              XY = XY + (Y(N)-YAVE)* (X(N)-XAVE)
          END IF
      END DO
      IF (RN.GT.2.D0) THEN
          COVAR = XY/ (RN-1.D0)
          CORC = COVAR/ (XSTD*YSTD)
      END IF

      RETURN
      END

      SUBROUTINE DCALCOVC(X,XAVE,XSTD,XMSG,NXY,Y,YMSG,COVC,IER)
      IMPLICIT NONE

c this routine will calculate the cross covariance between
c .   series x and series y 
c this routine was originally meant to be in the inner portion
c .   of a loop

c THIS ROUTINE DOES NOT NEED XSTD BUT IT WAS DUPLICTED
c FROM DCALCORC AND I WANTED TO MINIMIZE ANY WORK MaryH
c WOULD HAVE TO DO. SHE CAN BASICALLY DUPLICATE THE INTERFACE
c FOR DCALCORC.

c     x         - input data 1D array  ( unchanged on output)
c     xave,xstd - ave and st. dev of x (input)
c     xmsg      - missing data code (if none set to some no. not
c                 encountered)
c     nxy       - length of x and y 1D vectors
c     y         - input data 1D array  ( unchanged on output)
c     ymsg      - missing data code (if none set to some no. not
c                 encountered)
c     corc      - correlation coef
c     ier       - error code (if ier=-1 then corc contains missing
c                 entry)
c --------------- input arguments
      INTEGER NXY
      DOUBLE PRECISION X(NXY),Y(NXY),XAVE,XSTD,XMSG,YMSG
c --------------- output arguments
      INTEGER IER
      DOUBLE PRECISION COVC
c --------------- local stuff
      INTEGER N,NPTUSX,NPTUSY
      DOUBLE PRECISION XVAR,YAVE,YVAR,YSTD,RN,XY,COVAR

      COVC = XMSG
C C C IF (XAVE.EQ.XMSG .OR. XSTD.EQ.XMSG) THEN
      IF (XAVE.EQ.XMSG) THEN
          CALL DSTAT2(X,NXY,XMSG,XAVE,XVAR,XSTD,NPTUSX,IER)
          IF (IER.NE.0 .OR. XSTD.EQ.0.0D0) THEN
              IER = 201
              RETURN
          END IF
      END IF

c calculate the mean and var of y

      CALL DSTAT2(Y,NXY,YMSG,YAVE,YVAR,YSTD,NPTUSY,IER)
      IF (IER.NE.0) RETURN
      IF (YSTD.EQ.0.D0) THEN
          IER = 203
          RETURN
      END IF

c calculate the cross covariance 
c .   calculate the mean and variance of column nc in the data array

      RN = 0.D0
      XY = 0.D0
      DO N = 1,NXY
          IF (X(N).NE.XMSG .AND. Y(N).NE.YMSG) THEN
              RN = RN + 1.D0
              XY = XY + (Y(N)-YAVE)* (X(N)-XAVE)
          END IF
      END DO
      IF (RN.GT.2.D0) THEN
          COVC = XY/ (RN-1.D0)
      END IF

      RETURN
      END

C
C	$Id: contor.f,v 1.4 2008-07-27 00:23:00 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CONTOR (X,Y,IY,Z)
C
C  GENERATE CONTOUR LINES FOR ALL LEVELS WHICH APPLY
C  TO THE CURRENT LOCATION IN THE VIRTURAL GRID.
C
C INPUT
C       X-INPUT X COORD.
C       Y-INPUT Y COORD.
C       IY-VALUE OF DATA LOCATION ABOVE Z
C       Z-DATA VALUE AT LOC
C
C
C
C
      COMMON /CONRA1/ CL(30)     ,NCL        ,OLDZ       ,PV(210)    ,
     1                FINC       ,HI         ,FLO
      COMMON /CONRA2/ REPEAT     ,EXTRAP     ,PER        ,MESS       ,
     1                ISCALE     ,LOOK       ,PLDVLS     ,GRD        ,
     2                CINC       ,CHILO      ,CON        ,LABON      ,
     3                PMIMX      ,SCALE      ,FRADV      ,EXTRI      ,
     4                BPSIZ      ,LISTOP
      COMMON /CONRA3/ IREC
      COMMON /CONRA4/ NCP        ,NCPSZ
      COMMON /CONRA5/ NIT        ,ITIPV
      COMMON /CONRA6/ XST        ,YST        ,XED        ,YED        ,
     1                STPSZ      ,IGRAD      ,IG         ,XRG        ,
     2                YRG        ,BORD       ,PXST       ,PYST       ,
     3                PXED       ,PYED       ,ITICK
      COMMON /CONR18/ TITLE      ,ICNT   ,ITLSIZ
      COMMON /CONR19/ IHIGH      ,INMAJ      ,INLAB      ,INDAT      ,
     1              LEN      ,IFMT       ,LEND       ,
     2                IFMTD      ,ISIZEP     ,INMIN
      COMMON /CONRA9/ ICOORD(500),NP         ,MXXY       ,TR         ,
     1                BR         ,TL         ,BL         ,CONV       ,
     2                XN         ,YN         ,ITLL       ,IBLL       ,
     3                ITRL       ,IBRL       ,XC         ,YC         ,
     4                ITLOC(210) ,JX         ,JY         ,ILOC       ,
     5                ISHFCT     ,XO         ,YO         ,IOC        ,NC
      COMMON /CONR10/ NT         ,NL         ,NTNL       ,JWIPT      ,
     1                JWIWL      ,JWIWP      ,JWIPL      ,IPR        ,
     2                ITPV
      COMMON /CONR20/ NREP       ,NCRT       ,ISIZEL     ,
     1                MINGAP     ,ISIZEM         ,
     2                TENS
      COMMON /CONR12/ IXMAX      ,IYMAX      ,XMAX       ,YMAX
      LOGICAL         REPEAT     ,EXTRAP     ,PER        ,MESS       ,
     1                LOOK       ,PLDVLS     ,GRD        ,LABON      ,
     2                PMIMX      ,FRADV      ,EXTRI      ,CINC       ,
     3                TITLE      ,LISTOP     ,CHILO      ,CON
      COMMON /CONR15/ ISTRNG
        CHARACTER*64 ISTRNG
        COMMON /CONR16/ FORM
        CHARACTER*10 FORM
        COMMON /CONR17/ NDASH, IDASH, EDASH
        CHARACTER*10 NDASH, IDASH, EDASH
C
C
      SAVE
C
C  STATEMENT FUNCTIONS FOR MAPPING COORIDNATES TO DIFFIRENT POINTS
C
C     FX(XXX,YYY) = XXX
C     FY(XXX,YYY) = YYY
C
C  STATEMENT FUNCTIONS FOR CONTOUR PLACEMENT WITHIN CELLS
C
      CX(W1,W2) = STPSZ*( (W1-CV)/(W1-W2) )
      CY(W1,W2) = STPSZ*( (W1-CV)/(W1-W2) )
C
C  SET UP CELL VALUES
C
      PVIY = PV(IY+1)
      PVIYM1 = PV(IY)
C
C LOOP THROUGH ALL CONTOUR LEVELS
C
          DO   130 I=1,NCL
          CV = CL(I)
C
C  IF CURRENT Z VALUE LESS THAN CONTOUR THEN NEIGHBOR WILL BE WHERE
C  CONTOUR IS DRAWN.
C
          IF (Z.LT.CV) GO TO    60
C
C  CURRENT LOCATION IS WHERE CONTOUR WILL BE DRAWN
C
C  TEST FOR VERTICAL CONTOUR BREAK
C
          IF (OLDZ.GE.CV) GO TO    30
C
C  VERTICAL CONTOUR BREAK
C
C  CASE 1 LEFT NEIGHBOR LESS THAN CONTOUR LEVEL AND CURRENT
C  LOCATION GE CONTOUR VALUE
C
          IF (PVIY.GE.CV) GO TO    10
C
C  CASE 1A CONTOUR LOWER LEFT
C
C
C  CONTOUR FROM UPPER RIGHT
C
          XO = X-CX(Z,PVIY)
          YO = Y
          YN = Y-CY(Z,OLDZ)
          XN = X
          XO1 = FX(XO,YO)
          YO1 = FY(XO,YO)
          CALL FL2INT (XO1,YO1,IXO,IYO)
          CALL PLOTIT (IXO,IYO,0)
          XN1 = FX(XN,YN)
          YN1 = FY(XN,YN)
          CALL FL2INT (XN1,YN1,IXN,IYN)
          CALL PLOTIT (IXN,IYN,1)
          IF (PVIYM1.LT.CV) GO TO   130
C
C CASE 1B  CONTOR UPPER LEFT
C
          XO = X-STPSZ
          YO = Y-STPSZ+CY(PVIYM1,PVIY)
          XN = X-STPSZ+CX(PVIYM1,OLDZ)
          YN = Y-STPSZ
          GO TO   120
C
C  CONTOURS FROM ABOVE AND UPPER LEFT
C
   10     IF (PVIYM1.LT.CV) GO TO    20
C
C  CASE 1C CONTOUR LOWER LEFT
C
          XO = X-STPSZ+CX(PVIYM1,OLDZ)
          YO = Y-STPSZ
          YN = Y-CY(Z,OLDZ)
          XN = X
          GO TO   120
C
C CASE 1D CONTOUR FROM ABOVE
C
   20     XO = X-STPSZ
          YO = Y-CY(PVIY,PVIYM1)
          YN = Y-CY(Z,OLDZ)
          XN = X
          GO TO   120
C
C
C  TEST FOR HORIZONTAL CONTOUR BREAK
C
   30     IF (PVIY.LT.CV) GO TO    40
          IF (PVIYM1.GE.CV) GO TO   130
C
C  CASE 2A CONTOUR UPPER LEFT
C
          XO = X-STPSZ
          YO = Y-CY(PVIY,PVIYM1)
          XN = X-CX(OLDZ,PVIYM1)
          YN = Y-STPSZ
          GO TO   120
C
   40     IF (PVIYM1.LT.CV) GO TO    50
C
C  CASE 2B CONTOUR FROM UPPER RIGHT
C
          XO = X-STPSZ
          YO = Y-STPSZ+CY(PVIYM1,PVIY)
          XN = X-CX(Z,PVIY)
          YN = Y
          GO TO   120
C
C  CASE 2C CONTOUR FROM LEFT TO RIGHT
C
   50     XO = X-CX(OLDZ,PVIYM1)
          YO = Y-STPSZ
          XN = X-CX(Z,PVIY)
          YN = Y
          GO TO   120
C
C
C  CURRENT Z VALUE LESS THAN CONTOUR
C
C
   60     IF (OLDZ.LT.CV) GO TO    90
C
C  VERTICAL CONTOUR BREAK
C
C  CASE 3 CURRENT SPACE LESS THAN CONTOUR LEVEL AND LEFT
C  NEIGHBOR GE CONTOUR LEVEL
C
          IF (PVIYM1.GE.CV) GO TO    70
C
C  CASE 3A CONTOUR LOWER LEFT
C
          XO = X-CX(OLDZ,PVIYM1)
          YO = Y-STPSZ
          YN = Y-STPSZ+CY(OLDZ,Z)
          XN = X
          XO1 = FX(XO,YO)
          YO1 = FY(XO,YO)
          CALL FL2INT (XO1,YO1,IXO,IYO)
          CALL PLOTIT (IXO,IYO,0)
          XN1 = FX(XN,YN)
          YN1 = FY(XN,YN)
          CALL FL2INT (XN1,YN1,IXN,IYN)
          CALL PLOTIT (IXN,IYN,1)
          IF (PVIY.LT.CV) GO TO   130
C
C  CASE 3B CONTOUR UPPERRIGHT
C
          XO = X-STPSZ
          YO = Y-CY(PVIY,PVIYM1)
          XN = X-STPSZ+CX(PVIY,Z)
          YN = Y
          GO TO   120
C
   70     IF (PVIY.GE.CV) GO TO    80
C
C  CASE 3C CONTOUR FROM ABOVE
C
          XO = X-STPSZ
          YO = Y-STPSZ+CY(PVIYM1,PVIY)
          YN = Y-STPSZ+CY(OLDZ,Z)
          XN = X
          GO TO   120
C
C  CASE 3D CONTOUR LOWER RIGHT
C
   80     XO = X-STPSZ+CX(PVIY,Z)
          YO = Y
          YN = Y-STPSZ+CY(OLDZ,Z)
          XN = X
          GO TO   120
C
C
C
C  TEST FOR HORIZONTAL BREAK POINT
C
   90     IF (PVIY.GE.CV) GO TO   100
C
          IF (PVIYM1.LT.CV) GO TO   140
C
C  CASE 4A CONTOUR UPPER LEFT
C
          XO = X-STPSZ+CX(PVIYM1,OLDZ)
          YO = Y-STPSZ
          XN = X-STPSZ
          YN = Y-STPSZ+CY(PVIYM1,PVIY)
          GO TO   120
C
  100     IF (PVIYM1.GE.CV) GO TO   110
C
C  CASE 4B CONTOUR UPPER RIGHT
C
          XO = X-STPSZ
          YO = Y-CY(PVIY,PVIYM1)
          XN = X-STPSZ+CX(PVIY,Z)
          YN = Y
          GO TO   120
C
C  CASE 4C CONTOUR FROM LEFT TO RIGHT
C
  110     YO = Y-STPSZ
          XO = X-STPSZ+CX(PVIYM1,OLDZ)
          XN = X-STPSZ+CX(PVIY,Z)
          YN = Y
C
C  DRAW THE CONTOUR LINES NOT ALREADY TAKEN CARE OF
C
  120     XO1 = FX(XO,YO)
          YO1 = FY(XO,YO)
          CALL FL2INT (XO1,YO1,IXO,IYO)
          CALL PLOTIT (IXO,IYO,0)
          XN1 = FX(XN,YN)
          YN1 = FY(XN,YN)
          CALL FL2INT (XN1,YN1,IXN,IYN)
          CALL PLOTIT (IXN,IYN,1)
C
C
  130     CONTINUE
C
C     FLUSH PLOTIT BUFFER
C
      CALL PLOTIT(0,0,0)
  140 PV(IY) = OLDZ
      OLDZ = Z
      RETURN
C
C******************************************************************
C*                                                                *
C*                   REVISION HISTORY                             *
C*                                                                *
C*  JUNE 1980     ADDED CONRAQ TO ULIB                            *
C*  AUGUST 1980   CHANGED ACCESS CARD DOCUMENTATION               *
C*  DECEMBER 1980 MODIFIED COMMENT CARD DOCUMENTATION             *
C*  MARCH 1983    ADDED ASPECT RATIO ERROR                        *
C*  JULY 1983     ADDED LINEAR INTERPOLATION                      *
C*                REMOVED 7600 ACCESS CARDS                       *
C*  JULY 1984     CONVERTED TO FORTRAN77 AND GKS                  *
C*  JUNE 1988   CHANGED THREE COMMON BLOCK NAMES TO GET RID OF    *
C*              WARNING MESSAGES FROM SEGLDR ON THE CRAY          *
C*  MARCH 1990  CORRECTED USE OF SET CALLS                        *
C*                                                                *
C******************************************************************
C
      END

      PROGRAM AGEX13
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Define the data array.
C
      DIMENSION XYCD(226)
C
C Initialize GKS.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Fill the data array.
C
      READ 1001 , XYCD
C
      DO 101 I=1,226
        IF (XYCD(I).EQ.1.E36) GO TO 101
        XYCD(I)=2.**((XYCD(I)-15.)/2.5)
  101 CONTINUE
C
C Specify log/log plot.
C
      CALL DISPLA (0,0,4)
C
C Bump the line-maximum parameter past 42.
C
      CALL AGSETI ('LINE/MAXIMUM.',50)
C
C Specify x- and y-axis labels, grid background.
C
      CALL ANOTAT('LOGARITHMIC, BASE 2, EXPONENTIAL LABELS$',
     +            'LOGARITHMIC, BASE 2, NO-EXPONENT LABELS$',
     +            2,0,0,' ')
C
C Specify the graph label.
C
      CALL AGSETC ('LABEL/NAME.','T')
      CALL AGSETI ('LINE/NUMBER.',100)
      CALL AGSETC ('LINE/TEXT.','FINAL EXAMPLE$')
C
C Specify x-axis ticks and labels.
C
      CALL AGSETI ('BOTTOM/MAJOR/TYPE.',3)
      CALL AGSETF ('BOTTOM/MAJOR/BASE.',2.)
      CALL AGSETI ('BOTTOM/NUMERIC/TYPE.',2)
      CALL AGSETI ('BOTTOM/MINOR/SPACING.',4)
      CALL AGSETI ('BOTTOM/MINOR/PATTERN.',43690)
C
C Specify y-axis ticks and labels.
C
      CALL AGSETI ('LEFT/MAJOR/TYPE.',3)
      CALL AGSETF ('LEFT/MAJOR/BASE.',2.)
      CALL AGSETI ('LEFT/NUMERIC/TYPE.',3)
      CALL AGSETI ('LEFT/MINOR/SPACING.',4)
      CALL AGSETI ('LEFT/MINOR/PATTERN.',43690)
C
C Compute secondary control parameters.
C
      CALL AGSTUP (XYCD(1),1,0,113,2,XYCD(2),1,0,113,2)
C
C Draw the background.
C
      CALL AGBACK
C
C Draw the curve twice to make it darker.
C
      CALL AGCURV (XYCD(1),2,XYCD(2),2,113,1)
      CALL AGCURV (XYCD(1),2,XYCD(2),2,113,1)
C
C Draw a boundary around the edge of the plotter frame.
C
      CALL BNDARY
C
C Advance the frame.
C
      CALL FRAME
C
C Close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
C
C Format.
C
 1001 FORMAT (14E5.0)
C
      END
      SUBROUTINE BNDARY
C
C Routine to draw the plotter-frame edge.
C
      CALL PLOTIT (    0,    0,0)
      CALL PLOTIT (32767,    0,1)
      CALL PLOTIT (32767,32767,1)
      CALL PLOTIT (    0,32767,1)
      CALL PLOTIT (    0,    0,1)
      RETURN
      END

C
C $Id: pcrset.f,v 1.4 2008-07-27 00:17:20 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE PCRSET
C
C Calling PCRSET resets all internal parameters of PLOTCHAR to their
C default values.
C
C COMMON block declarations.
C
      COMMON /PCPRMS/ ADDS,CONS,DSTB,DSTL,DSTR,DSTT,HPIC(3),IBNU,
     +                IBXC(3),IBXF,ICEN,IORD,IOUC,IOUF,IPCC,IQUF,
     +                ISHC,ISHF,ITEF,JCOD,LSCI(16),NFCC,NODF,RBXL,
     +                RBXM,RBXX,RBXY,ROLW,RPLW,RSLW,SHDX,SHDY,SIZA,
     +                SSIC,SSPR,SUBS,VPIC(3),WPIC(3),XBEG,XCEN,XEND,
     +                XMUL(3),YBEG,YCEN,YEND,YMUL(3),ZINX,ZINY,ZINZ
      SAVE   /PCPRMS/
C
      COMMON /PCSVEM/ ICOD,IDDA(8625),IDDL,RDGU(7000),IDPC(256),IERU,
     +                INDA(789),INDL,INIT,IVCO,IVDU,NBPW,NPPW
      SAVE   /PCSVEM/
C
      COMMON /PCPFLQ/ IMAP,OORV,RHTW
      SAVE   /PCPFLQ/
C
C Check for an uncleared prior error.
C
      IF (ICFELL('PCRSET - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C Reset the values of internal parameters in common blocks.
C
      ADDS=0.
      CONS=0.
      DSTB=0.
      DSTL=0.
      DSTR=0.
      DSTT=0.
      HPIC(1)=21.
      HPIC(2)=13.
      HPIC(3)= 9.
      IBNU=3
      IBXC(1)=-1
      IBXC(2)=-1
      IBXC(3)=-1
      IBXF=0
      ICEN=0
      IMAP=0
      IORD=1
      IOUC=1
      IOUF=0
      IPCC=-1
      IQUF=0
      ISHC=0
      ISHF=0
      ITEF=0
      JCOD=0
      DO 101 I=1,16
        LSCI(I)=-1
  101 CONTINUE
      NFCC=ICHAR(':')
      NODF=0
      OORV=0.
      RBXL=0.
      RBXM=.15
      RBXX=-.05
      RBXY=-.05
      RHTW=1.75
      ROLW=0.
      RPLW=0.
      RSLW=0.
      SHDX=-.05
      SHDY=-.05
      SIZA=.888888888888888
      SSIC=7.
      SSPR=10.
      SUBS=0.
      VPIC(1)=32.
      VPIC(2)=20.
      VPIC(3)=14.
      WPIC(1)=16.
      WPIC(2)=12.
      WPIC(3)= 8.
      XBEG=0.
      XCEN=0.
      XEND=0.
      XMUL(1)=1.
      XMUL(2)=1.
      XMUL(3)=1.
      YBEG=0.
      YCEN=0.
      YEND=0.
      YMUL(1)=1.
      YMUL(2)=1.
      YMUL(3)=1.
      ZINX=1.
      ZINY=1.
      ZINZ=1.
C
C Done.
C
      RETURN
C
      END

C
C $Id: gzgte2.f,v 1.5 2008-07-27 00:21:03 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GZGTE2(NUM,ERMSG)
C
C  Given an NCAR GKS error number in NUM, this subroutine
C  returns the NCAR GKS error message string in ERMSG (the 
C  length of ERMSG will be a maximum of 210 characters). If
C  no error message is found for the given error number, the
C  string ' --UNKNOWN ERROR CODE' is returned in ERMSG.
C
      CHARACTER*(*) ERMSG
C
      include 'gkscom.h'
C
      INTEGER GZNUME
C
C  Determine the index into the error message array.
C
      IGKNER = GZNUME()
      DO 20 I=1,IGKNER
        IF (NUM .EQ. IERNMS(I)) THEN
          NDXER = I
          GO TO 50
        ENDIF
   20 CONTINUE
C
C  Error number is not known.
C
      NDXER = 79
   50 CONTINUE
      ERMSG = ERMSGS(NDXER)
C
      RETURN
      END

c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by UCAR                 .
c  .                                                             .
c  .       University Corporation for Atmospheric Research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                         SPHEREPACK                          .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c
c
c ... file vhsgc.f
c
c     this file contains code and documentation for subroutines
c     vhsgc and vhsgci
c
c ... files which must be loaded with vhsgc.f
c
c     sphcom.f, hrfft.f, gaqd.f
c
c     subroutine vhsgc(nlat,nlon,ityp,nt,v,w,idvw,jdvw,br,bi,cr,ci,
c    +                 mdab,ndab,wvhsgc,lvhsgc,work,lwork,ierror)
c
c     subroutine vhsgc performs the vector spherical harmonic synthesis
c     of the arrays br, bi, cr, and ci and stores the result in the
c     arrays v and w. v(i,j) and w(i,j) are the colatitudinal
c     (measured from the north pole) and east longitudinal components
c     respectively, located at the gaussian colatitude point theta(i)
c     and longitude phi(j) = (j-1)*2*pi/nlon. the spectral
c     representation of (v,w) is given below at output parameters v,w.
c
c     input parameters
c
c     nlat   the number of points in the gaussian colatitude grid on the
C*PL*ERROR* Comment line too long
c            full sphere. these lie in the interval (0,pi) and are computed
C*PL*ERROR* Comment line too long
c            in radians in theta(1) <...< theta(nlat) by subroutine gaqd.
C*PL*ERROR* Comment line too long
c            if nlat is odd the equator will be included as the grid point
c            theta((nlat+1)/2).  if nlat is even the equator will be
c            excluded as a grid point and will lie half way between
c            theta(nlat/2) and theta(nlat/2+1). nlat must be at least 3.
c            note: on the half sphere, the number of grid points in the
c            colatitudinal direction is nlat/2 if nlat is even or
c            (nlat+1)/2 if nlat is odd.
c
c     nlon   the number of distinct londitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater
c            than zero. the axisymmetric case corresponds to nlon=1.
c            the efficiency of the computation is improved when nlon
c            is a product of small prime numbers.
c
c     ityp   = 0  no symmetries exist about the equator. the synthesis
c                 is performed on the entire sphere.  i.e. on the
c                 arrays v(i,j),w(i,j) for i=1,...,nlat and
c                 j=1,...,nlon.
c
c            = 1  no symmetries exist about the equator. the synthesis
c                 is performed on the entire sphere.  i.e. on the
c                 arrays v(i,j),w(i,j) for i=1,...,nlat and
c                 j=1,...,nlon. the curl of (v,w) is zero. that is,
c                 (d/dtheta (sin(theta) w) - dv/dphi)/sin(theta) = 0.
c                 the coefficients cr and ci are zero.
c
c            = 2  no symmetries exist about the equator. the synthesis
c                 is performed on the entire sphere.  i.e. on the
c                 arrays v(i,j),w(i,j) for i=1,...,nlat and
c                 j=1,...,nlon. the divergence of (v,w) is zero. i.e.,
c                 (d/dtheta (sin(theta) v) + dw/dphi)/sin(theta) = 0.
c                 the coefficients br and bi are zero.
c
c            = 3  v is symmetric and w is antisymmetric about the
c                 equator. the synthesis is performed on the northern
c                 hemisphere only.  i.e., if nlat is odd the synthesis
c                 is performed on the arrays v(i,j),w(i,j) for
c                 i=1,...,(nlat+1)/2 and j=1,...,nlon. if nlat is
c                 even the synthesis is performed on the the arrays
c                 v(i,j),w(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
c
c            = 4  v is symmetric and w is antisymmetric about the
c                 equator. the synthesis is performed on the northern
c                 hemisphere only.  i.e., if nlat is odd the synthesis
c                 is performed on the arrays v(i,j),w(i,j) for
c                 i=1,...,(nlat+1)/2 and j=1,...,nlon. if nlat is
c                 even the synthesis is performed on the the arrays
c                 v(i,j),w(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
c                 the curl of (v,w) is zero. that is,
c                 (d/dtheta (sin(theta) w) - dv/dphi)/sin(theta) = 0.
c                 the coefficients cr and ci are zero.
c
c            = 5  v is symmetric and w is antisymmetric about the
c                 equator. the synthesis is performed on the northern
c                 hemisphere only.  i.e., if nlat is odd the synthesis
c                 is performed on the arrays v(i,j),w(i,j) for
c                 i=1,...,(nlat+1)/2 and j=1,...,nlon. if nlat is
c                 even the synthesis is performed on the the arrays
c                 v(i,j),w(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
c                 the divergence of (v,w) is zero. i.e.,
c                 (d/dtheta (sin(theta) v) + dw/dphi)/sin(theta) = 0.
c                 the coefficients br and bi are zero.
c
c            = 6  v is antisymmetric and w is symmetric about the
c                 equator. the synthesis is performed on the northern
c                 hemisphere only.  i.e., if nlat is odd the synthesis
c                 is performed on the arrays v(i,j),w(i,j) for
c                 i=1,...,(nlat+1)/2 and j=1,...,nlon. if nlat is
c                 even the synthesis is performed on the the arrays
c                 v(i,j),w(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
c
c            = 7  v is antisymmetric and w is symmetric about the
c                 equator. the synthesis is performed on the northern
c                 hemisphere only.  i.e., if nlat is odd the synthesis
c                 is performed on the arrays v(i,j),w(i,j) for
c                 i=1,...,(nlat+1)/2 and j=1,...,nlon. if nlat is
c                 even the synthesis is performed on the the arrays
c                 v(i,j),w(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
c                 the curl of (v,w) is zero. that is,
c                 (d/dtheta (sin(theta) w) - dv/dphi)/sin(theta) = 0.
c                 the coefficients cr and ci are zero.
c
c            = 8  v is antisymmetric and w is symmetric about the
c                 equator. the synthesis is performed on the northern
c                 hemisphere only.  i.e., if nlat is odd the synthesis
c                 is performed on the arrays v(i,j),w(i,j) for
c                 i=1,...,(nlat+1)/2 and j=1,...,nlon. if nlat is
c                 even the synthesis is performed on the the arrays
c                 v(i,j),w(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
c                 the divergence of (v,w) is zero. i.e.,
c                 (d/dtheta (sin(theta) v) + dw/dphi)/sin(theta) = 0.
c                 the coefficients br and bi are zero.
c
c
c     nt     the number of syntheses.  in the program that calls vhsgc,
c            the arrays v,w,br,bi,cr, and ci can be three dimensional
c            in which case multiple syntheses will be performed.
c            the third index is the synthesis index which assumes the
c            values k=1,...,nt.  for a single synthesis set nt=1. the
c            discription of the remaining parameters is simplified
c            by assuming that nt=1 or that all the arrays are two
c            dimensional.
c
c     idvw   the first dimension of the arrays v,w as it appears in
c            the program that calls vhsgc. if ityp .le. 2 then idvw
c            must be at least nlat.  if ityp .gt. 2 and nlat is
c            even then idvw must be at least nlat/2. if ityp .gt. 2
c            and nlat is odd then idvw must be at least (nlat+1)/2.
c
c     jdvw   the second dimension of the arrays v,w as it appears in
c            the program that calls vhsgc. jdvw must be at least nlon.
c
c     br,bi  two or three dimensional arrays (see input parameter nt)
c     cr,ci  that contain the vector spherical harmonic coefficients
c            in the spectral representation of v(i,j) and w(i,j) given
c            below at the discription of output parameters v and w.
c
c     mdab   the first dimension of the arrays br,bi,cr, and ci as it
c            appears in the program that calls vhsgc. mdab must be at
c            least min0(nlat,nlon/2) if nlon is even or at least
c            min0(nlat,(nlon+1)/2) if nlon is odd.
c
c     ndab   the second dimension of the arrays br,bi,cr, and ci as it
c            appears in the program that calls vhsgc. ndab must be at
c            least nlat.
c
c     wvhsgc an array which must be initialized by subroutine vhsgci.
c            once initialized, wvhsgc can be used repeatedly by vhsgc
c            as long as nlon and nlat remain unchanged.  wvhsgc must
c            not be altered between calls of vhsgc.
c
c     lvhsgc the dimension of the array wvhsgc as it appears in the
c            program that calls vhsgc. define
c
c               l1 = min0(nlat,nlon/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            then lvhsgc must be at least
c
c               4*nlat*l2+3*max0(l1-2,0)*(2*nlat-l1-1)+nlon+15
c
c     work   a work array that does not have to be saved.
c
c     lwork  the dimension of the array work as it appears in the
c            program that calls vhsgc. define
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            if ityp .le. 2 then lwork must be at least
c
c                    nlat*(2*nt*nlon+max0(6*l2,nlon))
c
c            if ityp .gt. 2 then lwork must be at least
c
c                    l2*(2*nt*nlon+max0(6*nlat,nlon))
c
c     **************************************************************
c
c     output parameters
c
c     v,w    two or three dimensional arrays (see input parameter nt)
c            in which the synthesis is stored. v is the colatitudinal
c            component and w is the east longitudinal component.
c            v(i,j),w(i,j) contain the components at the gaussian
c            colatitude theta(i) and longitude phi(j) = (j-1)*2*pi/nlon.
c            the index ranges are defined above at the input parameter
c            ityp. v and w are computed from the formulas given below.
c
c     define
c
c     1.  theta is colatitude and phi is east longitude
c
c     2.  the normalized associated legendre funnctions
c
c         pbar(m,n,theta) = sqrt((2*n+1)*factorial(n-m)
c                        /(2*factorial(n+m)))*sin(theta)**m/(2**n*
c                        factorial(n)) times the (n+m)th derivative
c                        of (x**2-1)**n with respect to x=cos(theta)
c
c     3.  vbar(m,n,theta) = the derivative of pbar(m,n,theta) with
c                           respect to theta divided by the square
c                           root of n(n+1).
c
c         vbar(m,n,theta) is more easily computed in the form
c
c         vbar(m,n,theta) = (sqrt((n+m)*(n-m+1))*pbar(m-1,n,theta)
c         -sqrt((n-m)*(n+m+1))*pbar(m+1,n,theta))/(2*sqrt(n*(n+1)))
c
c     4.  wbar(m,n,theta) = m/(sin(theta))*pbar(m,n,theta) divided
c                           by the square root of n(n+1).
c
c         wbar(m,n,theta) is more easily computed in the form
c
c         wbar(m,n,theta) = sqrt((2n+1)/(2n-1))*(sqrt((n+m)*(n+m-1))
c         *pbar(m-1,n-1,theta)+sqrt((n-m)*(n-m-1))*pbar(m+1,n-1,theta))
c         /(2*sqrt(n*(n+1)))
c
c
c    the colatitudnal dependence of the normalized surface vector
c                spherical harmonics are defined by
c
c     5.    bbar(m,n,theta) = (vbar(m,n,theta),i*wbar(m,n,theta))
c
c     6.    cbar(m,n,theta) = (i*wbar(m,n,theta),-vbar(m,n,theta))
c
c
c    the coordinate to index mappings
c
c     7.   phi(j) = (j-1)*2*pi/nlon, theta(i) is the i(th) guassian
c          point (see nlat as an input parameter).
c
c     the maximum (plus one) longitudinal wave number
c
c     8.     mmax = min0(nlat,nlon/2) if nlon is even or
c            mmax = min0(nlat,(nlon+1)/2) if nlon is odd.
c
c    if we further define the output vector as
c
c     9.    h(i,j) = (v(i,j),w(i,j))
c
c    and the complex coefficients
c
c     10.   b(m,n) = cmplx(br(m+1,n+1),bi(m+1,n+1))
c
c     11.   c(m,n) = cmplx(cr(m+1,n+1),ci(m+1,n+1))
c
c
c    then for i=1,...,nlat and  j=1,...,nlon
c
c        the expansion for real h(i,j) takes the form
c
c     h(i,j) = the sum from n=1 to n=nlat-1 of the real part of
c
c         .5*(b(0,n)*bbar(0,n,theta(i))+c(0,n)*cbar(0,n,theta(i)))
c
c     plus the sum from m=1 to m=mmax-1 of the sum from n=m to
c     n=nlat-1 of the real part of
c
c              b(m,n)*bbar(m,n,theta(i))*exp(i*m*phi(j))
c             +c(m,n)*cbar(m,n,theta(i))*exp(i*m*phi(j))
c
c   *************************************************************
c
c   in terms of real variables this expansion takes the form
c
c             for i=1,...,nlat and  j=1,...,nlon
c
c     v(i,j) = the sum from n=1 to n=nlat-1 of
c
c               .5*br(1,n+1)*vbar(0,n,theta(i))
c
c     plus the sum from m=1 to m=mmax-1 of the sum from n=m to
c     n=nlat-1 of the real part of
c
c       (br(m+1,n+1)*vbar(m,n,theta(i))-ci(m+1,n+1)*wbar(m,n,theta(i)))
c                                          *cos(m*phi(j))
c      -(bi(m+1,n+1)*vbar(m,n,theta(i))+cr(m+1,n+1)*wbar(m,n,theta(i)))
c                                          *sin(m*phi(j))
c
c    and for i=1,...,nlat and  j=1,...,nlon
c
c     w(i,j) = the sum from n=1 to n=nlat-1 of
c
c              -.5*cr(1,n+1)*vbar(0,n,theta(i))
c
c     plus the sum from m=1 to m=mmax-1 of the sum from n=m to
c     n=nlat-1 of the real part of
c
c      -(cr(m+1,n+1)*vbar(m,n,theta(i))+bi(m+1,n+1)*wbar(m,n,theta(i)))
c                                          *cos(m*phi(j))
c      +(ci(m+1,n+1)*vbar(m,n,theta(i))-br(m+1,n+1)*wbar(m,n,theta(i)))
c                                          *sin(m*phi(j))
c
c
c      br(m+1,nlat),bi(m+1,nlat),cr(m+1,nlat), and ci(m+1,nlat) are
c      assumed zero for m even.
c
c
c     ierror = 0  no errors
c            = 1  error in the specification of nlat
c            = 2  error in the specification of nlon
c            = 3  error in the specification of ityp
c            = 4  error in the specification of nt
c            = 5  error in the specification of idvw
c            = 6  error in the specification of jdvw
c            = 7  error in the specification of mdab
c            = 8  error in the specification of ndab
c            = 9  error in the specification of lvhsgc
c            = 10 error in the specification of lwork
c
c*************************************************************
c
c     subroutine vhsgci(nlat,nlon,wvhsgc,lvhsgc,dwork,ldwork,ierror)
c
c     subroutine vhsgci initializes the array wvhsgc which can then be
c     used repeatedly by subroutine vhsgc until nlat or nlon is changed.
c
c     input parameters
c
c     nlat   the number of points in the gaussian colatitude grid on the
C*PL*ERROR* Comment line too long
c            full sphere. these lie in the interval (0,pi) and are computed
C*PL*ERROR* Comment line too long
c            in radians in theta(1) <...< theta(nlat) by subroutine gaqd.
C*PL*ERROR* Comment line too long
c            if nlat is odd the equator will be included as the grid point
c            theta((nlat+1)/2).  if nlat is even the equator will be
c            excluded as a grid point and will lie half way between
c            theta(nlat/2) and theta(nlat/2+1). nlat must be at least 3.
c            note: on the half sphere, the number of grid points in the
c            colatitudinal direction is nlat/2 if nlat is even or
c            (nlat+1)/2 if nlat is odd.
c
c     nlon   the number of distinct londitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater
c            than zero. the axisymmetric case corresponds to nlon=1.
c            the efficiency of the computation is improved when nlon
c            is a product of small prime numbers.
c
c     lvhsgc the dimension of the array wvhsgc as it appears in the
c            program that calls vhsgc. define
c
c               l1 = min0(nlat,nlon/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            then lvhsgc must be at least
c
c               4*nlat*l2+3*max0(l1-2,0)*(2*nlat-l1-1)+nlon+15
c
c     work  a double precision work space that does not need to be saved
c
c     ldwork the dimension of the array dwork as it appears in the
c            program that calls vhsgsi. ldwork must be at least
c
c               2*nlat*(nlat+1)+1
c
c     **************************************************************
c
c     output parameters
c
c     wvhsgc an array which is initialized for use by subroutine vhsgc.
c            once initialized, wvhsgc can be used repeatedly by vhsgc
c            as long as nlat and nlon remain unchanged.  wvhsgc must not
c            be altered between calls of vhsgc.
c
c
c     ierror = 0  no errors
c            = 1  error in the specification of nlat
c            = 2  error in the specification of nlon
c            = 3  error in the specification of lvhsgc
c            = 4  error in the specification of ldwork
c
      SUBROUTINE DVHSGC(NLAT,NLON,ITYP,NT,V,W,IDVW,JDVW,BR,BI,CR,CI,
     +                  MDAB,NDAB,WVHSGC,LVHSGC,WORK,LWORK,IERROR)
      DOUBLE PRECISION V
      DOUBLE PRECISION W
      DOUBLE PRECISION BR
      DOUBLE PRECISION BI
      DOUBLE PRECISION CR
      DOUBLE PRECISION CI
      DOUBLE PRECISION WVHSGC
      DOUBLE PRECISION WORK
      DIMENSION V(IDVW,JDVW,1),W(IDVW,JDVW,1),BR(MDAB,NDAB,1),
     +          BI(MDAB,NDAB,1),CR(MDAB,NDAB,1),CI(MDAB,NDAB,1),WORK(1),
     +          WVHSGC(1)

      IERROR = 1
      IF (NLAT.LT.3) RETURN
      IERROR = 2
      IF (NLON.LT.1) RETURN
      IERROR = 3
      IF (ITYP.LT.0 .OR. ITYP.GT.8) RETURN
      IERROR = 4
      IF (NT.LT.0) RETURN
      IERROR = 5
      IMID = (NLAT+1)/2
      IF ((ITYP.LE.2.AND.IDVW.LT.NLAT) .OR.
     +    (ITYP.GT.2.AND.IDVW.LT.IMID)) RETURN
      IERROR = 6
      IF (JDVW.LT.NLON) RETURN
      IERROR = 7
      MMAX = MIN0(NLAT, (NLON+1)/2)
      IF (MDAB.LT.MMAX) RETURN
      IERROR = 8
      IF (NDAB.LT.NLAT) RETURN
      IERROR = 9
      LZZ1 = 2*NLAT*IMID
      LABC = 3* (MAX0(MMAX-2,0)* (NLAT+NLAT-MMAX-1))/2
c
c     check save work space length
c
      L1 = MIN0(NLAT, (NLON+1)/2)
      L2 = (NLAT+1)/2
      LWMIN = 4*NLAT*L2 + 3*MAX0(L1-2,0)* (2*NLAT-L1-1) + NLON + 15
      IF (LVHSGC.LT.LWMIN) RETURN


c     if(lvhsgc .lt. 2*(lzz1+labc)+nlon+15) return
      IERROR = 10
      IF (ITYP.LE.2 .AND. LWORK.LT.NLAT*
     +    (2*NT*NLON+MAX0(6*IMID,NLON))) RETURN
      IF (ITYP.GT.2 .AND. LWORK.LT.IMID*
     +    (2*NT*NLON+MAX0(6*NLAT,NLON))) RETURN
      IERROR = 0
      IDV = NLAT
      IF (ITYP.GT.2) IDV = IMID
      LNL = NT*IDV*NLON
      IST = 0
      IF (ITYP.LE.2) IST = IMID
      IW1 = IST + 1
      IW2 = LNL + 1
      IW3 = IW2 + IST
      IW4 = IW2 + LNL
      IW5 = IW4 + 3*IMID*NLAT
      LZZ1 = 2*NLAT*IMID
      LABC = 3* (MAX0(MMAX-2,0)* (NLAT+NLAT-MMAX-1))/2
      LWZVIN = LZZ1 + LABC
      JW1 = LWZVIN + 1
      JW2 = JW1 + LWZVIN
      CALL DVHSGC1(NLAT,NLON,ITYP,NT,IMID,IDVW,JDVW,V,W,MDAB,NDAB,BR,
     +             BI,CR,CI,IDV,WORK,WORK(IW1),WORK(IW2),WORK(IW3),
     +             WORK(IW4),WORK(IW5),WVHSGC,WVHSGC(JW1),WVHSGC(JW2))
      RETURN
      END
      SUBROUTINE DVHSGC1(NLAT,NLON,ITYP,NT,IMID,IDVW,JDVW,V,W,MDAB,NDAB,
     +                  BR,BI,CR,CI,IDV,VE,VO,WE,WO,VB,WB,WVBIN,WWBIN,
     +                  WRFFT)
      DOUBLE PRECISION V
      DOUBLE PRECISION W
      DOUBLE PRECISION BR
      DOUBLE PRECISION BI
      DOUBLE PRECISION CR
      DOUBLE PRECISION CI
      DOUBLE PRECISION VE
      DOUBLE PRECISION VO
      DOUBLE PRECISION WE
      DOUBLE PRECISION WO
      DOUBLE PRECISION VB
      DOUBLE PRECISION WB
      DOUBLE PRECISION WVBIN
      DOUBLE PRECISION WWBIN
      DOUBLE PRECISION WRFFT
      DIMENSION V(IDVW,JDVW,1),W(IDVW,JDVW,1),BR(MDAB,NDAB,1),
     +          BI(MDAB,NDAB,1),CR(MDAB,NDAB,1),CI(MDAB,NDAB,1),
     +          VE(IDV,NLON,1),VO(IDV,NLON,1),WE(IDV,NLON,1),
     +          WO(IDV,NLON,1),WVBIN(1),WWBIN(1),WRFFT(1),
     +          VB(IMID,NLAT,3),WB(IMID,NLAT,3)

      NLP1 = NLAT + 1
      MLAT = MOD(NLAT,2)
      MLON = MOD(NLON,2)
      MMAX = MIN0(NLAT, (NLON+1)/2)
      IMM1 = IMID
      IF (MLAT.NE.0) IMM1 = IMID - 1
      DO 10 K = 1,NT
          DO 10 J = 1,NLON
              DO 10 I = 1,IDV
                  VE(I,J,K) = 0.D0
                  WE(I,J,K) = 0.D0
   10 CONTINUE
      NDO1 = NLAT
      NDO2 = NLAT
      IF (MLAT.NE.0) NDO1 = NLAT - 1
      IF (MLAT.EQ.0) NDO2 = NLAT - 1
   18 ITYPP = ITYP + 1
      GO TO (1,100,200,300,400,500,600,700,800) ITYPP
c
c     case ityp=0   no symmetries
c
    1 CALL DVBIN(0,NLAT,NLON,0,VB,IV,WVBIN)
c
c     case m = 0
c
      DO 15 K = 1,NT
          DO 15 NP1 = 2,NDO2,2
              DO 15 I = 1,IMID
                  VE(I,1,K) = VE(I,1,K) + BR(1,NP1,K)*VB(I,NP1,IV)
                  WE(I,1,K) = WE(I,1,K) - CR(1,NP1,K)*VB(I,NP1,IV)
   15 CONTINUE
      DO 16 K = 1,NT
          DO 16 NP1 = 3,NDO1,2
              DO 16 I = 1,IMM1
                  VO(I,1,K) = VO(I,1,K) + BR(1,NP1,K)*VB(I,NP1,IV)
                  WO(I,1,K) = WO(I,1,K) - CR(1,NP1,K)*VB(I,NP1,IV)
   16 CONTINUE
c
c     case m = 1 through nlat-1
c
      IF (MMAX.LT.2) GO TO 950
      DO 30 MP1 = 2,MMAX
          M = MP1 - 1
          MP2 = MP1 + 1
          CALL DVBIN(0,NLAT,NLON,M,VB,IV,WVBIN)
          CALL DWBIN(0,NLAT,NLON,M,WB,IW,WWBIN)
          IF (MP1.GT.NDO1) GO TO 26
          DO 25 K = 1,NT
              DO 24 NP1 = MP1,NDO1,2
                  DO 23 I = 1,IMM1
                      VO(I,2*MP1-2,K) = VO(I,2*MP1-2,K) +
     +                                  BR(MP1,NP1,K)*VB(I,NP1,IV)
                      VE(I,2*MP1-2,K) = VE(I,2*MP1-2,K) -
     +                                  CI(MP1,NP1,K)*WB(I,NP1,IW)
                      VO(I,2*MP1-1,K) = VO(I,2*MP1-1,K) +
     +                                  BI(MP1,NP1,K)*VB(I,NP1,IV)
                      VE(I,2*MP1-1,K) = VE(I,2*MP1-1,K) +
     +                                  CR(MP1,NP1,K)*WB(I,NP1,IW)
                      WO(I,2*MP1-2,K) = WO(I,2*MP1-2,K) -
     +                                  CR(MP1,NP1,K)*VB(I,NP1,IV)
                      WE(I,2*MP1-2,K) = WE(I,2*MP1-2,K) -
     +                                  BI(MP1,NP1,K)*WB(I,NP1,IW)
                      WO(I,2*MP1-1,K) = WO(I,2*MP1-1,K) -
     +                                  CI(MP1,NP1,K)*VB(I,NP1,IV)
                      WE(I,2*MP1-1,K) = WE(I,2*MP1-1,K) +
     +                                  BR(MP1,NP1,K)*WB(I,NP1,IW)
   23             CONTINUE
                  IF (MLAT.EQ.0) GO TO 24
                  VE(IMID,2*MP1-2,K) = VE(IMID,2*MP1-2,K) -
     +                                 CI(MP1,NP1,K)*WB(IMID,NP1,IW)
                  VE(IMID,2*MP1-1,K) = VE(IMID,2*MP1-1,K) +
     +                                 CR(MP1,NP1,K)*WB(IMID,NP1,IW)
                  WE(IMID,2*MP1-2,K) = WE(IMID,2*MP1-2,K) -
     +                                 BI(MP1,NP1,K)*WB(IMID,NP1,IW)
                  WE(IMID,2*MP1-1,K) = WE(IMID,2*MP1-1,K) +
     +                                 BR(MP1,NP1,K)*WB(IMID,NP1,IW)
   24         CONTINUE
   25     CONTINUE
   26     IF (MP2.GT.NDO2) GO TO 30
          DO 29 K = 1,NT
              DO 28 NP1 = MP2,NDO2,2
                  DO 27 I = 1,IMM1
                      VE(I,2*MP1-2,K) = VE(I,2*MP1-2,K) +
     +                                  BR(MP1,NP1,K)*VB(I,NP1,IV)
                      VO(I,2*MP1-2,K) = VO(I,2*MP1-2,K) -
     +                                  CI(MP1,NP1,K)*WB(I,NP1,IW)
                      VE(I,2*MP1-1,K) = VE(I,2*MP1-1,K) +
     +                                  BI(MP1,NP1,K)*VB(I,NP1,IV)
                      VO(I,2*MP1-1,K) = VO(I,2*MP1-1,K) +
     +                                  CR(MP1,NP1,K)*WB(I,NP1,IW)
                      WE(I,2*MP1-2,K) = WE(I,2*MP1-2,K) -
     +                                  CR(MP1,NP1,K)*VB(I,NP1,IV)
                      WO(I,2*MP1-2,K) = WO(I,2*MP1-2,K) -
     +                                  BI(MP1,NP1,K)*WB(I,NP1,IW)
                      WE(I,2*MP1-1,K) = WE(I,2*MP1-1,K) -
     +                                  CI(MP1,NP1,K)*VB(I,NP1,IV)
                      WO(I,2*MP1-1,K) = WO(I,2*MP1-1,K) +
     +                                  BR(MP1,NP1,K)*WB(I,NP1,IW)
   27             CONTINUE
                  IF (MLAT.EQ.0) GO TO 28
                  VE(IMID,2*MP1-2,K) = VE(IMID,2*MP1-2,K) +
     +                                 BR(MP1,NP1,K)*VB(IMID,NP1,IV)
                  VE(IMID,2*MP1-1,K) = VE(IMID,2*MP1-1,K) +
     +                                 BI(MP1,NP1,K)*VB(IMID,NP1,IV)
                  WE(IMID,2*MP1-2,K) = WE(IMID,2*MP1-2,K) -
     +                                 CR(MP1,NP1,K)*VB(IMID,NP1,IV)
                  WE(IMID,2*MP1-1,K) = WE(IMID,2*MP1-1,K) -
     +                                 CI(MP1,NP1,K)*VB(IMID,NP1,IV)
   28         CONTINUE
   29     CONTINUE
   30 CONTINUE
      GO TO 950
c
c     case ityp=1   no symmetries,  cr and ci equal zero
c
  100 CALL DVBIN(0,NLAT,NLON,0,VB,IV,WVBIN)
c
c     case m = 0
c
      DO 115 K = 1,NT
          DO 115 NP1 = 2,NDO2,2
              DO 115 I = 1,IMID
                  VE(I,1,K) = VE(I,1,K) + BR(1,NP1,K)*VB(I,NP1,IV)
  115 CONTINUE
      DO 116 K = 1,NT
          DO 116 NP1 = 3,NDO1,2
              DO 116 I = 1,IMM1
                  VO(I,1,K) = VO(I,1,K) + BR(1,NP1,K)*VB(I,NP1,IV)
  116 CONTINUE
c
c     case m = 1 through nlat-1
c
      IF (MMAX.LT.2) GO TO 950
      DO 130 MP1 = 2,MMAX
          M = MP1 - 1
          MP2 = MP1 + 1
          CALL DVBIN(0,NLAT,NLON,M,VB,IV,WVBIN)
          CALL DWBIN(0,NLAT,NLON,M,WB,IW,WWBIN)
          IF (MP1.GT.NDO1) GO TO 126
          DO 125 K = 1,NT
              DO 124 NP1 = MP1,NDO1,2
                  DO 123 I = 1,IMM1
                      VO(I,2*MP1-2,K) = VO(I,2*MP1-2,K) +
     +                                  BR(MP1,NP1,K)*VB(I,NP1,IV)
                      VO(I,2*MP1-1,K) = VO(I,2*MP1-1,K) +
     +                                  BI(MP1,NP1,K)*VB(I,NP1,IV)
                      WE(I,2*MP1-2,K) = WE(I,2*MP1-2,K) -
     +                                  BI(MP1,NP1,K)*WB(I,NP1,IW)
                      WE(I,2*MP1-1,K) = WE(I,2*MP1-1,K) +
     +                                  BR(MP1,NP1,K)*WB(I,NP1,IW)
  123             CONTINUE
                  IF (MLAT.EQ.0) GO TO 124
                  WE(IMID,2*MP1-2,K) = WE(IMID,2*MP1-2,K) -
     +                                 BI(MP1,NP1,K)*WB(IMID,NP1,IW)
                  WE(IMID,2*MP1-1,K) = WE(IMID,2*MP1-1,K) +
     +                                 BR(MP1,NP1,K)*WB(IMID,NP1,IW)
  124         CONTINUE
  125     CONTINUE
  126     IF (MP2.GT.NDO2) GO TO 130
          DO 129 K = 1,NT
              DO 128 NP1 = MP2,NDO2,2
                  DO 127 I = 1,IMM1
                      VE(I,2*MP1-2,K) = VE(I,2*MP1-2,K) +
     +                                  BR(MP1,NP1,K)*VB(I,NP1,IV)
                      VE(I,2*MP1-1,K) = VE(I,2*MP1-1,K) +
     +                                  BI(MP1,NP1,K)*VB(I,NP1,IV)
                      WO(I,2*MP1-2,K) = WO(I,2*MP1-2,K) -
     +                                  BI(MP1,NP1,K)*WB(I,NP1,IW)
                      WO(I,2*MP1-1,K) = WO(I,2*MP1-1,K) +
     +                                  BR(MP1,NP1,K)*WB(I,NP1,IW)
  127             CONTINUE
                  IF (MLAT.EQ.0) GO TO 128
                  VE(IMID,2*MP1-2,K) = VE(IMID,2*MP1-2,K) +
     +                                 BR(MP1,NP1,K)*VB(IMID,NP1,IV)
                  VE(IMID,2*MP1-1,K) = VE(IMID,2*MP1-1,K) +
     +                                 BI(MP1,NP1,K)*VB(IMID,NP1,IV)
  128         CONTINUE
  129     CONTINUE
  130 CONTINUE
      GO TO 950
c
c     case ityp=2   no symmetries,  br and bi are equal to zero
c
  200 CALL DVBIN(0,NLAT,NLON,0,VB,IV,WVBIN)
c
c     case m = 0
c
      DO 215 K = 1,NT
          DO 215 NP1 = 2,NDO2,2
              DO 215 I = 1,IMID
                  WE(I,1,K) = WE(I,1,K) - CR(1,NP1,K)*VB(I,NP1,IV)
  215 CONTINUE
      DO 216 K = 1,NT
          DO 216 NP1 = 3,NDO1,2
              DO 216 I = 1,IMM1
                  WO(I,1,K) = WO(I,1,K) - CR(1,NP1,K)*VB(I,NP1,IV)
  216 CONTINUE
c
c     case m = 1 through nlat-1
c
      IF (MMAX.LT.2) GO TO 950
      DO 230 MP1 = 2,MMAX
          M = MP1 - 1
          MP2 = MP1 + 1
          CALL DVBIN(0,NLAT,NLON,M,VB,IV,WVBIN)
          CALL DWBIN(0,NLAT,NLON,M,WB,IW,WWBIN)
          IF (MP1.GT.NDO1) GO TO 226
          DO 225 K = 1,NT
              DO 224 NP1 = MP1,NDO1,2
                  DO 223 I = 1,IMM1
                      VE(I,2*MP1-2,K) = VE(I,2*MP1-2,K) -
     +                                  CI(MP1,NP1,K)*WB(I,NP1,IW)
                      VE(I,2*MP1-1,K) = VE(I,2*MP1-1,K) +
     +                                  CR(MP1,NP1,K)*WB(I,NP1,IW)
                      WO(I,2*MP1-2,K) = WO(I,2*MP1-2,K) -
     +                                  CR(MP1,NP1,K)*VB(I,NP1,IV)
                      WO(I,2*MP1-1,K) = WO(I,2*MP1-1,K) -
     +                                  CI(MP1,NP1,K)*VB(I,NP1,IV)
  223             CONTINUE
                  IF (MLAT.EQ.0) GO TO 224
                  VE(IMID,2*MP1-2,K) = VE(IMID,2*MP1-2,K) -
     +                                 CI(MP1,NP1,K)*WB(IMID,NP1,IW)
                  VE(IMID,2*MP1-1,K) = VE(IMID,2*MP1-1,K) +
     +                                 CR(MP1,NP1,K)*WB(IMID,NP1,IW)
  224         CONTINUE
  225     CONTINUE
  226     IF (MP2.GT.NDO2) GO TO 230
          DO 229 K = 1,NT
              DO 228 NP1 = MP2,NDO2,2
                  DO 227 I = 1,IMM1
                      VO(I,2*MP1-2,K) = VO(I,2*MP1-2,K) -
     +                                  CI(MP1,NP1,K)*WB(I,NP1,IW)
                      VO(I,2*MP1-1,K) = VO(I,2*MP1-1,K) +
     +                                  CR(MP1,NP1,K)*WB(I,NP1,IW)
                      WE(I,2*MP1-2,K) = WE(I,2*MP1-2,K) -
     +                                  CR(MP1,NP1,K)*VB(I,NP1,IV)
                      WE(I,2*MP1-1,K) = WE(I,2*MP1-1,K) -
     +                                  CI(MP1,NP1,K)*VB(I,NP1,IV)
  227             CONTINUE
                  IF (MLAT.EQ.0) GO TO 228
                  WE(IMID,2*MP1-2,K) = WE(IMID,2*MP1-2,K) -
     +                                 CR(MP1,NP1,K)*VB(IMID,NP1,IV)
                  WE(IMID,2*MP1-1,K) = WE(IMID,2*MP1-1,K) -
     +                                 CI(MP1,NP1,K)*VB(IMID,NP1,IV)
  228         CONTINUE
  229     CONTINUE
  230 CONTINUE
      GO TO 950
c
c     case ityp=3   v even,  w odd
c
  300 CALL DVBIN(0,NLAT,NLON,0,VB,IV,WVBIN)
c
c     case m = 0
c
      DO 315 K = 1,NT
          DO 315 NP1 = 2,NDO2,2
              DO 315 I = 1,IMID
                  VE(I,1,K) = VE(I,1,K) + BR(1,NP1,K)*VB(I,NP1,IV)
  315 CONTINUE
      DO 316 K = 1,NT
          DO 316 NP1 = 3,NDO1,2
              DO 316 I = 1,IMM1
                  WO(I,1,K) = WO(I,1,K) - CR(1,NP1,K)*VB(I,NP1,IV)
  316 CONTINUE
c
c     case m = 1 through nlat-1
c
      IF (MMAX.LT.2) GO TO 950
      DO 330 MP1 = 2,MMAX
          M = MP1 - 1
          MP2 = MP1 + 1
          CALL DVBIN(0,NLAT,NLON,M,VB,IV,WVBIN)
          CALL DWBIN(0,NLAT,NLON,M,WB,IW,WWBIN)
          IF (MP1.GT.NDO1) GO TO 326
          DO 325 K = 1,NT
              DO 324 NP1 = MP1,NDO1,2
                  DO 323 I = 1,IMM1
                      VE(I,2*MP1-2,K) = VE(I,2*MP1-2,K) -
     +                                  CI(MP1,NP1,K)*WB(I,NP1,IW)
                      VE(I,2*MP1-1,K) = VE(I,2*MP1-1,K) +
     +                                  CR(MP1,NP1,K)*WB(I,NP1,IW)
                      WO(I,2*MP1-2,K) = WO(I,2*MP1-2,K) -
     +                                  CR(MP1,NP1,K)*VB(I,NP1,IV)
                      WO(I,2*MP1-1,K) = WO(I,2*MP1-1,K) -
     +                                  CI(MP1,NP1,K)*VB(I,NP1,IV)
  323             CONTINUE
                  IF (MLAT.EQ.0) GO TO 324
                  VE(IMID,2*MP1-2,K) = VE(IMID,2*MP1-2,K) -
     +                                 CI(MP1,NP1,K)*WB(IMID,NP1,IW)
                  VE(IMID,2*MP1-1,K) = VE(IMID,2*MP1-1,K) +
     +                                 CR(MP1,NP1,K)*WB(IMID,NP1,IW)
  324         CONTINUE
  325     CONTINUE
  326     IF (MP2.GT.NDO2) GO TO 330
          DO 329 K = 1,NT
              DO 328 NP1 = MP2,NDO2,2
                  DO 327 I = 1,IMM1
                      VE(I,2*MP1-2,K) = VE(I,2*MP1-2,K) +
     +                                  BR(MP1,NP1,K)*VB(I,NP1,IV)
                      VE(I,2*MP1-1,K) = VE(I,2*MP1-1,K) +
     +                                  BI(MP1,NP1,K)*VB(I,NP1,IV)
                      WO(I,2*MP1-2,K) = WO(I,2*MP1-2,K) -
     +                                  BI(MP1,NP1,K)*WB(I,NP1,IW)
                      WO(I,2*MP1-1,K) = WO(I,2*MP1-1,K) +
     +                                  BR(MP1,NP1,K)*WB(I,NP1,IW)
  327             CONTINUE
                  IF (MLAT.EQ.0) GO TO 328
                  VE(IMID,2*MP1-2,K) = VE(IMID,2*MP1-2,K) +
     +                                 BR(MP1,NP1,K)*VB(IMID,NP1,IV)
                  VE(IMID,2*MP1-1,K) = VE(IMID,2*MP1-1,K) +
     +                                 BI(MP1,NP1,K)*VB(IMID,NP1,IV)
  328         CONTINUE
  329     CONTINUE
  330 CONTINUE
      GO TO 950
c
c     case ityp=4   v even,  w odd, and both cr and ci equal zero
c
  400 CALL DVBIN(1,NLAT,NLON,0,VB,IV,WVBIN)
c
c     case m = 0
c
      DO 415 K = 1,NT
          DO 415 NP1 = 2,NDO2,2
              DO 415 I = 1,IMID
                  VE(I,1,K) = VE(I,1,K) + BR(1,NP1,K)*VB(I,NP1,IV)
  415 CONTINUE
c
c     case m = 1 through nlat-1
c
      IF (MMAX.LT.2) GO TO 950
      DO 430 MP1 = 2,MMAX
          M = MP1 - 1
          MP2 = MP1 + 1
          CALL DVBIN(1,NLAT,NLON,M,VB,IV,WVBIN)
          CALL DWBIN(1,NLAT,NLON,M,WB,IW,WWBIN)
          IF (MP2.GT.NDO2) GO TO 430
          DO 429 K = 1,NT
              DO 428 NP1 = MP2,NDO2,2
                  DO 427 I = 1,IMM1
                      VE(I,2*MP1-2,K) = VE(I,2*MP1-2,K) +
     +                                  BR(MP1,NP1,K)*VB(I,NP1,IV)
                      VE(I,2*MP1-1,K) = VE(I,2*MP1-1,K) +
     +                                  BI(MP1,NP1,K)*VB(I,NP1,IV)
                      WO(I,2*MP1-2,K) = WO(I,2*MP1-2,K) -
     +                                  BI(MP1,NP1,K)*WB(I,NP1,IW)
                      WO(I,2*MP1-1,K) = WO(I,2*MP1-1,K) +
     +                                  BR(MP1,NP1,K)*WB(I,NP1,IW)
  427             CONTINUE
                  IF (MLAT.EQ.0) GO TO 428
                  VE(IMID,2*MP1-2,K) = VE(IMID,2*MP1-2,K) +
     +                                 BR(MP1,NP1,K)*VB(IMID,NP1,IV)
                  VE(IMID,2*MP1-1,K) = VE(IMID,2*MP1-1,K) +
     +                                 BI(MP1,NP1,K)*VB(IMID,NP1,IV)
  428         CONTINUE
  429     CONTINUE
  430 CONTINUE
      GO TO 950
c
c     case ityp=5   v even,  w odd,     br and bi equal zero
c
  500 CALL DVBIN(2,NLAT,NLON,0,VB,IV,WVBIN)
c
c     case m = 0
c
      DO 516 K = 1,NT
          DO 516 NP1 = 3,NDO1,2
              DO 516 I = 1,IMM1
                  WO(I,1,K) = WO(I,1,K) - CR(1,NP1,K)*VB(I,NP1,IV)
  516 CONTINUE
c
c     case m = 1 through nlat-1
c
      IF (MMAX.LT.2) GO TO 950
      DO 530 MP1 = 2,MMAX
          M = MP1 - 1
          MP2 = MP1 + 1
          CALL DVBIN(2,NLAT,NLON,M,VB,IV,WVBIN)
          CALL DWBIN(2,NLAT,NLON,M,WB,IW,WWBIN)
          IF (MP1.GT.NDO1) GO TO 530
          DO 525 K = 1,NT
              DO 524 NP1 = MP1,NDO1,2
                  DO 523 I = 1,IMM1
                      VE(I,2*MP1-2,K) = VE(I,2*MP1-2,K) -
     +                                  CI(MP1,NP1,K)*WB(I,NP1,IW)
                      VE(I,2*MP1-1,K) = VE(I,2*MP1-1,K) +
     +                                  CR(MP1,NP1,K)*WB(I,NP1,IW)
                      WO(I,2*MP1-2,K) = WO(I,2*MP1-2,K) -
     +                                  CR(MP1,NP1,K)*VB(I,NP1,IV)
                      WO(I,2*MP1-1,K) = WO(I,2*MP1-1,K) -
     +                                  CI(MP1,NP1,K)*VB(I,NP1,IV)
  523             CONTINUE
                  IF (MLAT.EQ.0) GO TO 524
                  VE(IMID,2*MP1-2,K) = VE(IMID,2*MP1-2,K) -
     +                                 CI(MP1,NP1,K)*WB(IMID,NP1,IW)
                  VE(IMID,2*MP1-1,K) = VE(IMID,2*MP1-1,K) +
     +                                 CR(MP1,NP1,K)*WB(IMID,NP1,IW)
  524         CONTINUE
  525     CONTINUE
  530 CONTINUE
      GO TO 950
c
c     case ityp=6   v odd  ,  w even
c
  600 CALL DVBIN(0,NLAT,NLON,0,VB,IV,WVBIN)
c
c     case m = 0
c
      DO 615 K = 1,NT
          DO 615 NP1 = 2,NDO2,2
              DO 615 I = 1,IMID
                  WE(I,1,K) = WE(I,1,K) - CR(1,NP1,K)*VB(I,NP1,IV)
  615 CONTINUE
      DO 616 K = 1,NT
          DO 616 NP1 = 3,NDO1,2
              DO 616 I = 1,IMM1
                  VO(I,1,K) = VO(I,1,K) + BR(1,NP1,K)*VB(I,NP1,IV)
  616 CONTINUE
c
c     case m = 1 through nlat-1
c
      IF (MMAX.LT.2) GO TO 950
      DO 630 MP1 = 2,MMAX
          M = MP1 - 1
          MP2 = MP1 + 1
          CALL DVBIN(0,NLAT,NLON,M,VB,IV,WVBIN)
          CALL DWBIN(0,NLAT,NLON,M,WB,IW,WWBIN)
          IF (MP1.GT.NDO1) GO TO 626
          DO 625 K = 1,NT
              DO 624 NP1 = MP1,NDO1,2
                  DO 623 I = 1,IMM1
                      VO(I,2*MP1-2,K) = VO(I,2*MP1-2,K) +
     +                                  BR(MP1,NP1,K)*VB(I,NP1,IV)
                      VO(I,2*MP1-1,K) = VO(I,2*MP1-1,K) +
     +                                  BI(MP1,NP1,K)*VB(I,NP1,IV)
                      WE(I,2*MP1-2,K) = WE(I,2*MP1-2,K) -
     +                                  BI(MP1,NP1,K)*WB(I,NP1,IW)
                      WE(I,2*MP1-1,K) = WE(I,2*MP1-1,K) +
     +                                  BR(MP1,NP1,K)*WB(I,NP1,IW)
  623             CONTINUE
                  IF (MLAT.EQ.0) GO TO 624
                  WE(IMID,2*MP1-2,K) = WE(IMID,2*MP1-2,K) -
     +                                 BI(MP1,NP1,K)*WB(IMID,NP1,IW)
                  WE(IMID,2*MP1-1,K) = WE(IMID,2*MP1-1,K) +
     +                                 BR(MP1,NP1,K)*WB(IMID,NP1,IW)
  624         CONTINUE
  625     CONTINUE
  626     IF (MP2.GT.NDO2) GO TO 630
          DO 629 K = 1,NT
              DO 628 NP1 = MP2,NDO2,2
                  DO 627 I = 1,IMM1
                      VO(I,2*MP1-2,K) = VO(I,2*MP1-2,K) -
     +                                  CI(MP1,NP1,K)*WB(I,NP1,IW)
                      VO(I,2*MP1-1,K) = VO(I,2*MP1-1,K) +
     +                                  CR(MP1,NP1,K)*WB(I,NP1,IW)
                      WE(I,2*MP1-2,K) = WE(I,2*MP1-2,K) -
     +                                  CR(MP1,NP1,K)*VB(I,NP1,IV)
                      WE(I,2*MP1-1,K) = WE(I,2*MP1-1,K) -
     +                                  CI(MP1,NP1,K)*VB(I,NP1,IV)
  627             CONTINUE
                  IF (MLAT.EQ.0) GO TO 628
                  WE(IMID,2*MP1-2,K) = WE(IMID,2*MP1-2,K) -
     +                                 CR(MP1,NP1,K)*VB(IMID,NP1,IV)
                  WE(IMID,2*MP1-1,K) = WE(IMID,2*MP1-1,K) -
     +                                 CI(MP1,NP1,K)*VB(IMID,NP1,IV)
  628         CONTINUE
  629     CONTINUE
  630 CONTINUE
      GO TO 950
c
c     case ityp=7   v odd, w even   cr and ci equal zero
c
  700 CALL DVBIN(2,NLAT,NLON,0,VB,IV,WVBIN)
c
c     case m = 0
c
      DO 716 K = 1,NT
          DO 716 NP1 = 3,NDO1,2
              DO 716 I = 1,IMM1
                  VO(I,1,K) = VO(I,1,K) + BR(1,NP1,K)*VB(I,NP1,IV)
  716 CONTINUE
c
c     case m = 1 through nlat-1
c
      IF (MMAX.LT.2) GO TO 950
      DO 730 MP1 = 2,MMAX
          M = MP1 - 1
          MP2 = MP1 + 1
          CALL DVBIN(2,NLAT,NLON,M,VB,IV,WVBIN)
          CALL DWBIN(2,NLAT,NLON,M,WB,IW,WWBIN)
          IF (MP1.GT.NDO1) GO TO 730
          DO 725 K = 1,NT
              DO 724 NP1 = MP1,NDO1,2
                  DO 723 I = 1,IMM1
                      VO(I,2*MP1-2,K) = VO(I,2*MP1-2,K) +
     +                                  BR(MP1,NP1,K)*VB(I,NP1,IV)
                      VO(I,2*MP1-1,K) = VO(I,2*MP1-1,K) +
     +                                  BI(MP1,NP1,K)*VB(I,NP1,IV)
                      WE(I,2*MP1-2,K) = WE(I,2*MP1-2,K) -
     +                                  BI(MP1,NP1,K)*WB(I,NP1,IW)
                      WE(I,2*MP1-1,K) = WE(I,2*MP1-1,K) +
     +                                  BR(MP1,NP1,K)*WB(I,NP1,IW)
  723             CONTINUE
                  IF (MLAT.EQ.0) GO TO 724
                  WE(IMID,2*MP1-2,K) = WE(IMID,2*MP1-2,K) -
     +                                 BI(MP1,NP1,K)*WB(IMID,NP1,IW)
                  WE(IMID,2*MP1-1,K) = WE(IMID,2*MP1-1,K) +
     +                                 BR(MP1,NP1,K)*WB(IMID,NP1,IW)
  724         CONTINUE
  725     CONTINUE
  730 CONTINUE
      GO TO 950
c
c     case ityp=8   v odd,  w even   br and bi equal zero
c
  800 CALL DVBIN(1,NLAT,NLON,0,VB,IV,WVBIN)
c
c     case m = 0
c
      DO 815 K = 1,NT
          DO 815 NP1 = 2,NDO2,2
              DO 815 I = 1,IMID
                  WE(I,1,K) = WE(I,1,K) - CR(1,NP1,K)*VB(I,NP1,IV)
  815 CONTINUE
c
c     case m = 1 through nlat-1
c
      IF (MMAX.LT.2) GO TO 950
      DO 830 MP1 = 2,MMAX
          M = MP1 - 1
          MP2 = MP1 + 1
          CALL DVBIN(1,NLAT,NLON,M,VB,IV,WVBIN)
          CALL DWBIN(1,NLAT,NLON,M,WB,IW,WWBIN)
          IF (MP2.GT.NDO2) GO TO 830
          DO 829 K = 1,NT
              DO 828 NP1 = MP2,NDO2,2
                  DO 827 I = 1,IMM1
                      VO(I,2*MP1-2,K) = VO(I,2*MP1-2,K) -
     +                                  CI(MP1,NP1,K)*WB(I,NP1,IW)
                      VO(I,2*MP1-1,K) = VO(I,2*MP1-1,K) +
     +                                  CR(MP1,NP1,K)*WB(I,NP1,IW)
                      WE(I,2*MP1-2,K) = WE(I,2*MP1-2,K) -
     +                                  CR(MP1,NP1,K)*VB(I,NP1,IV)
                      WE(I,2*MP1-1,K) = WE(I,2*MP1-1,K) -
     +                                  CI(MP1,NP1,K)*VB(I,NP1,IV)
  827             CONTINUE
                  IF (MLAT.EQ.0) GO TO 828
                  WE(IMID,2*MP1-2,K) = WE(IMID,2*MP1-2,K) -
     +                                 CR(MP1,NP1,K)*VB(IMID,NP1,IV)
                  WE(IMID,2*MP1-1,K) = WE(IMID,2*MP1-1,K) -
     +                                 CI(MP1,NP1,K)*VB(IMID,NP1,IV)
  828         CONTINUE
  829     CONTINUE
  830 CONTINUE
  950 DO 14 K = 1,NT
          CALL DHRFFTB(IDV,NLON,VE(1,1,K),IDV,WRFFT,VB)
          CALL DHRFFTB(IDV,NLON,WE(1,1,K),IDV,WRFFT,VB)
   14 CONTINUE
      IF (ITYP.GT.2) GO TO 12
      DO 60 K = 1,NT
          DO 60 J = 1,NLON
              DO 60 I = 1,IMM1
                  V(I,J,K) = .5D0* (VE(I,J,K)+VO(I,J,K))
                  W(I,J,K) = .5D0* (WE(I,J,K)+WO(I,J,K))
                  V(NLP1-I,J,K) = .5D0* (VE(I,J,K)-VO(I,J,K))
                  W(NLP1-I,J,K) = .5D0* (WE(I,J,K)-WO(I,J,K))
   60 CONTINUE
      GO TO 13
   12 DO 11 K = 1,NT
          DO 11 J = 1,NLON
              DO 11 I = 1,IMM1
                  V(I,J,K) = .5D0*VE(I,J,K)
                  W(I,J,K) = .5D0*WE(I,J,K)
   11 CONTINUE
   13 IF (MLAT.EQ.0) RETURN
      DO 65 K = 1,NT
          DO 65 J = 1,NLON
              V(IMID,J,K) = .5D0*VE(IMID,J,K)
              W(IMID,J,K) = .5D0*WE(IMID,J,K)
   65 CONTINUE
      RETURN
      END
      SUBROUTINE DVHSGCI(NLAT,NLON,WVHSGC,LVHSGC,DWORK,LDWORK,IERROR)
      DOUBLE PRECISION WVHSGC
      DIMENSION WVHSGC(LVHSGC)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION DWORK(LDWORK)

      IERROR = 1
      IF (NLAT.LT.3) RETURN
      IERROR = 2
      IF (NLON.LT.1) RETURN
      IERROR = 3
      IMID = (NLAT+1)/2
      LZZ1 = 2*NLAT*IMID
      MMAX = MIN0(NLAT, (NLON+1)/2)
      LABC = 3* (MAX0(MMAX-2,0)* (NLAT+NLAT-MMAX-1))/2
      IF (LVHSGC.LT.2* (LZZ1+LABC)+NLON+15) RETURN
      IERROR = 4
      IF (LDWORK.LT.2*NLAT* (NLAT+1)+1) RETURN
      IERROR = 0
c
c     compute gaussian points in first nlat+1 words of dwork
c     double precision
c
c     lwk = 2*nlat*(nlat+2)
      JW1 = 1
      JW2 = JW1 + NLAT
      JW3 = JW2 + NLAT
c     jw2 = jw1+nlat+nlat
c     jw3 = jw2+nlat+nlat
      CALL DGAQD(NLAT,DWORK(JW1),DWORK(JW2),DWORK(JW3),LDWORK,IERROR)
c     iwrk = nlat+2
      IWRK = (NLAT+1)/2 + 1
      CALL DVBGINT(NLAT,NLON,DWORK,WVHSGC,DWORK(IWRK))
      LWVBIN = LZZ1 + LABC
      IW1 = LWVBIN + 1
      CALL DWBGINT(NLAT,NLON,DWORK,WVHSGC(IW1),DWORK(IWRK))
      IW2 = IW1 + LWVBIN
      CALL DHRFFTI(NLON,WVHSGC(IW2))
      RETURN
      END

C
C     $Id: sgesl.f,v 1.1 1994-08-11 23:17:33 boote Exp $
C


      SUBROUTINE SGESL (A,LDA,N,IPVT,B,JOB)
      INTEGER LDA,N,IPVT(1),JOB
      REAL A(LDA,1),B(1)
C
C     SGESL SOLVES THE REAL SYSTEM
C     A * X = B  OR  TRANS(A) * X = B
C     USING THE FACTORS COMPUTED BY SGECO OR SGEFA.
C
C     ON ENTRY
C
C        A       REAL(LDA, N)
C                THE OUTPUT FROM SGECO OR SGEFA.
C
C        LDA     INTEGER
C                THE LEADING DIMENSION OF THE ARRAY  A .
C
C        N       INTEGER
C                THE ORDER OF THE MATRIX  A .
C
C        IPVT    INTEGER(N)
C                THE PIVOT VECTOR FROM SGECO OR SGEFA.
C
C        B       REAL(N)
C                THE RIGHT HAND SIDE VECTOR.
C
C        JOB     INTEGER
C                = 0         TO SOLVE  A*X = B ,
C                = NONZERO   TO SOLVE  TRANS(A)*X = B  WHERE
C                            TRANS(A)  IS THE TRANSPOSE.
C
C     ON RETURN
C
C        B       THE SOLUTION VECTOR  X .
C
C     ERROR CONDITION
C
C        A DIVISION BY ZERO WILL OCCUR IF THE INPUT FACTOR CONTAINS A
C        ZERO ON THE DIAGONAL.  TECHNICALLY THIS INDICATES SINGULARITY
C        BUT IT IS OFTEN CAUSED BY IMPROPER ARGUMENTS OR IMPROPER
C        SETTING OF LDA .  IT WILL NOT OCCUR IF THE SUBROUTINES ARE
C        CALLED CORRECTLY AND IF SGECO HAS SET RCOND .GT. 0.0
C        OR SGEFA HAS SET INFO .EQ. 0 .
C
C     TO COMPUTE  INVERSE(A) * C  WHERE  C  IS A MATRIX
C     WITH  P  COLUMNS
C           CALL SGECO(A,LDA,N,IPVT,RCOND,Z)
C           IF (RCOND IS TOO SMALL) GO TO ...
C           DO 10 J = 1, P
C              CALL SGESL(A,LDA,N,IPVT,C(1,J),0)
C        10 CONTINUE
C
C     LINPACK. THIS VERSION DATED 08/14/78 .
C     CLEVE MOLER, UNIVERSITY OF NEW MEXICO, ARGONNE NATIONAL LAB.
C
C     SUBROUTINES AND FUNCTIONS
C
C     BLAS SAXPY,SDOT
C
C     INTERNAL VARIABLES
C
      REAL SDOT,T
      INTEGER K,KB,L,NM1
C
C
      NM1 = N - 1
      IF (JOB .NE. 0) GO TO 50
C
C        JOB = 0 , SOLVE  A * X = B
C        FIRST SOLVE  L*Y = B
C
         IF (NM1 .LT. 1) GO TO 30
         DO 20 K = 1, NM1
            L = IPVT(K)
            T = B(L)
            IF (L .EQ. K) GO TO 10
               B(L) = B(K)
               B(K) = T
   10       CONTINUE
            CALL SAXPY(N-K,T,A(K+1,K),1,B(K+1),1)
   20    CONTINUE
   30    CONTINUE
C
C        NOW SOLVE  U*X = Y
C
         DO 40 KB = 1, N
            K = N + 1 - KB
            B(K) = B(K)/A(K,K)
            T = -B(K)
            CALL SAXPY(K-1,T,A(1,K),1,B(1),1)
   40    CONTINUE
      GO TO 100
   50 CONTINUE
C
C        JOB = NONZERO, SOLVE  TRANS(A) * X = B
C        FIRST SOLVE  TRANS(U)*Y = B
C
         DO 60 K = 1, N
            T = SDOT(K-1,A(1,K),1,B(1),1)
            B(K) = (B(K) - T)/A(K,K)
   60    CONTINUE
C
C        NOW SOLVE TRANS(L)*X = Y
C
         IF (NM1 .LT. 1) GO TO 90
         DO 80 KB = 1, NM1
            K = N - KB
            B(K) = B(K) + SDOT(N-K,A(K+1,K),1,B(K+1),1)
            L = IPVT(K)
            IF (L .EQ. K) GO TO 70
               T = B(L)
               B(L) = B(K)
               B(K) = T
   70       CONTINUE
   80    CONTINUE
   90    CONTINUE
  100 CONTINUE
      RETURN
      END

C
C	$Id: wmlabt.f,v 1.7 2008-07-27 00:17:37 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE WMLABT(X,Y,LABEL,IFLG)
C
C  Plots regional temperature labels with the option of
C  plotting arrows, depending on the value of IFLG.
C
C  If IFLG =
C
C       0 - Plots the label centered at (X,Y).
C       1-12 plots the label with an arrow positioned as per:
C
C
C
C                      6   5   4   3   2
C                       \   \  |  /   /
C                        \   \ | /   /
C                         -----------
C                         |         |
C                    7 -- |  LABEL  | -- 1
C                         |         |
C                         -----------
C                        /   / | \  \
C                       /   /  |  \  \
C                      8   9  10  11  12
C
C
C
C  For IFLG=1 through 12 the tip of the arrow is positioned at (X,Y).
C  For IFLG=0, only the label is drawn and not the arrow.
C
      CHARACTER*(*) LABEL
      PARAMETER (D2RAD=.017453293)
C
      include 'wmcomn.h'
C
      DIMENSION ANGS(12)
      DATA ANGS/0.,45.,60.,90.,120.,135.,180.,225.,250.,270.,300.,315./       
C
C  Save the current line and fill colors and set them to ICOLOR.
C
      CALL GQFAIS(IER,IFAISO)
      CALL GQFACI(IER,IFCLRO)
      CALL GQPLCI(IER,ILCLRO)
      CALL GSFAIS(1)
      CALL GSFACI(ICOLOR)
      CALL GSPLCI(ICOLOR)
      CALL PCGETI('FN',IFNO)
C
C  Convert X and Y to NDC and work in NDC space.
C
      CALL WMW2NX(1,X,XNDC)
      CALL WMW2NY(1,Y,YNDC)
      CALL GQCNTN(IER,NTRO)
      CALL GSELNT(0)
C
      SIZEL = WSIZET
C
C  Use Plotchar font Helvetica-bold.
C
      CALL PCSETI ('FN',22)
      JFLG = IFLG
C
C  If IFLG is out out range, just plot the string.
C
      IF (IFLG.GT.12 .OR. IFLG.LT.0) THEN
        JFLG = 0
      ENDIF
C
C  Scale the length of an arrow to leave space between the tail of
C  the arrow and the label.
C
      ELEN = 1.25*ARWSIZ*ARWLEN
C
C  Compute new coordinate positions to reposition the label so that
C  the arrow will have its tip at (X,Y).
C
      D1 = 0.707*ELEN
      D2 = ELEN*COS(60.*D2RAD)
      D3 = ELEN*SIN(60.*D2RAD)
      CALL PCSETI ('TE',1)
      CALL PLCHHQ (XNDC,YNDC,LABEL,SIZEL,360.,0.)
      CALL PCGETR ('DL',XL)
      CALL PCGETR ('DR',XR)
      CALL PCGETR ('DB',YB)
      CALL PCGETR ('DT',YT)
      CALL PCSETI ('TE',0)
C     
      IF (JFLG .EQ. 0) THEN
        XP = XNDC
        YP = YNDC
      ELSE IF (JFLG .EQ. 1) THEN
        XP = XNDC - ELEN - XR
        YP = YNDC
      ELSE IF (JFLG .EQ. 2) THEN
        XP = XNDC - D1 - XR
        YP = YNDC - D1 - YT
      ELSE IF (JFLG .EQ. 3) THEN
        XP = XNDC - D2 - 0.5*XR
        YP = YNDC - D3 - YT
      ELSE IF (JFLG .EQ. 4) THEN
        XP = XNDC
        YP = YNDC - ELEN - YT
      ELSE IF (JFLG .EQ. 5) THEN
        XP = XNDC + D2 + 0.5*XL
        YP = YNDC - D3 - YT
      ELSE IF (JFLG .EQ. 6) THEN
        XP = XNDC + D1 + XL
        YP = YNDC - D1 - YT
      ELSE IF (JFLG .EQ. 7) THEN
        XP = XNDC + ELEN + XL
        YP = YNDC
      ELSE IF (JFLG .EQ. 8) THEN
        XP = XNDC + D1 + XL
        YP = YNDC + D1 + YB
      ELSE IF (JFLG .EQ. 9) THEN
        XP = XNDC + D2 + 0.5*XL
        YP = YNDC + D3 + YB
      ELSE IF (JFLG .EQ. 10) THEN
        XP = XNDC
        YP = YNDC + ELEN + YB
      ELSE IF (JFLG .EQ. 11) THEN
        XP = XNDC - D2 - 0.5*XR
        YP = YNDC + D3 + YB
      ELSE IF (JFLG .EQ. 12) THEN
        XP = XNDC - D1 - XR
        YP = YNDC + D1 + YB
      ENDIF
C
C  Draw the label.
C
      CALL WMGETR('CMG',CMGO)
      CALL WMSETR('CMG',TMPMRG)
      CALL WMCHBG(XP,YP,LABEL,SIZEL)
      CALL WMSETR('CMG',CMGO)
C
      IF (JFLG .NE. 0) THEN
C
C  Draw the arrow.
C
        CALL WMGETR ('ARD',ARDO)
        CALL WMSETR ('ARD',ANGS(JFLG))
        CALL WMLABS (XNDC,YNDC,'ARROW')
      ENDIF
C
C  Restore the original environment.
C
   20 CONTINUE
      CALL GSFAIS(IFAISO)
      CALL GSFACI(IFCLRO)
      CALL GSPLCI(ILCLRO)
      CALL GSELNT(NTRO)
      CALL WMSETR('ARD',ARDO)
      CALL PCSETI('FN',IFNO)
C
      RETURN
      END

C
C $Id: mdilat.f,v 1.9 2008-09-18 00:42:17 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MDILAT (PLAT,PLON,UCOP,VCOP,
     +                   QLAT,QLON,UCOQ,VCOQ,
     +                   RLAT,     UCOR,VCOR)
C
C Given the lat/lon and U/V coordinates of two points P and Q and the
C latitude of a point R along the line in the U/V plane connecting the
C points P and Q, this routine returns the U and V coordinates of R,
C found using a binary-halving technique.
C
        DOUBLE PRECISION PLAT,PLON,UCOP,VCOP
        DOUBLE PRECISION QLAT,QLON,UCOQ,VCOQ
        DOUBLE PRECISION RLAT,     UCOR,VCOR
C
C Declare local variables.
C
        DOUBLE PRECISION ALAT,ALON,UCOA,VCOA
        DOUBLE PRECISION BLAT,BLON,UCOB,VCOB
        DOUBLE PRECISION CLAT,CLON,UCOC,VCOC
C
        INTEGER          NREP
C
        IF (PLAT.LT.QLAT) THEN
          ALAT=PLAT
          ALON=PLON
          UCOA=UCOP
          VCOA=VCOP
          BLAT=QLAT
          BLON=QLON
          UCOB=UCOQ
          VCOB=VCOQ
        ELSE
          ALAT=QLAT
          ALON=QLON
          UCOA=UCOQ
          VCOA=VCOQ
          BLAT=PLAT
          BLON=PLON
          UCOB=UCOP
          VCOB=VCOP
        END IF
C
        UCOC=UCOA
        VCOC=VCOA
C
        NREP=0
C
  101   IF (NREP.LT.100) THEN
          IF (ALAT.EQ.BLAT) GO TO 102
          UCOC=UCOA+((RLAT-ALAT)/(BLAT-ALAT))*(UCOB-UCOA)
          VCOC=VCOA+((RLAT-ALAT)/(BLAT-ALAT))*(VCOB-VCOA)
          CALL MDPTRI (UCOC,VCOC,CLAT,CLON)
          IF (CLAT.EQ.1.D12) GO TO 102
          IF (CLAT.LT.RLAT) THEN
            ALAT=CLAT
            ALON=CLON
            UCOA=UCOC
            VCOA=VCOC
          ELSE
            BLAT=CLAT
            BLON=CLON
            UCOB=UCOC
            VCOB=VCOC
          END IF
          NREP=NREP+1
          IF (ABS(CLAT-RLAT).GT..001D0*ABS(QLAT-PLAT)) GO TO 101
        END IF
C
  102   UCOR=UCOC
        VCOR=VCOC
C
        RETURN
C
      END

c subroutine lfin (init,theta,l,m,nm,pb,id,wlfin)
c
c dimension of           theta(l),  pb(id,nm+1),  wlfin(4*l*(nm+1))
c arguments
c
c purpose                given m and l, routine lfin calculates
c                        the normalized associated legendre functions
c                        pbar(n,m,theta) for n=m,...,nm and theta(i)
c                        for i=1,...,l where
c
c                        pbar(m,n,theta) = sqrt((2*n+1)*factorial(n-m)
c                        /(2*factorial(n+m)))*sin(theta)**m/(2**n*
c                        factorial(n)) times the (n+m)th derivative of
c                        (x**2-1)**n with respect to x=cos(theta)
c
c usage                  call lfin (init,theta,l,m,nm,pb,id,wlfin)
c
c arguments
c on input               init
c                        = 0
c                            initialization only - using parameters
c                            l, nm and the array theta, subroutine lfin
c                            initializes the array wlfin for subsequent
c                            use in the computation of the associated
c                            legendre functions pb. initialization does
c                            not have to be repeated unless l, nm or
c                            the array theta are changed.
c                        = 1
c                            subroutine lfin uses the array wlfin that
c                            was computed with init = 0 to compute pb
c
c                        theta
c                          an array that contains the colatitudes
c                          at which the associated legendre functions
c                          will be computed. the colatitudes must be
c                          specified in radians.
c
c                        l
c                          the length of the theta array. lfin is
c                          vectorized with vector length l.
c
c                        m
c                          nonnegative integer, less than nm, specifying
c                          degree of pbar(n,m,theta). subroutine lfin
c                          must be called starting with n=0. n must be
c                          incremented by one in subsequent calls and
c                          must not exceed nm.
c
c                        nm
c                          the maximum value of n and m
c
c                        id
c                          the first dimension of the two dimensional
c                          array pb as it appears in the program that
c                          calls lfin. (see output parameter pb)
c
c                        wlfin
c                          an array with length 4*l*(nm+1) which
c                          must be initialized by calling lfin
c                          with init=0 (see parameter init)  it
c                          must not be altered between calls to
c                          lfin.
c
c
c on output              pb
c                          a two dimensional array with first
c                          dimension id in the program that calls
c                          lfin. the second dimension of pb must
c                          be at least nm+1. starting with m=0
c                          lfin is called repeatedly with m being
c                          increased by one between calls. on each
c                          call, subroutine lfin computes pb(i,n+1)
c                          = pbar(m,n,theta(i)) for n=m,...,nm and
c                          i=1,...l.
c
c                        wlfin
c                          array containing values which must not
c                          be altered unless l, nm or the array theta
c                          are changed in which case lfin must be
c                          called with init=0 to reinitialize the
c                          wlfin array.
c
c special conditions     m must be increased by one between calls
c                        of lfin in which m is not zero.
c
c precision              single
c
c algorithm              routine lfin calculates pbar(n,m,theta) using
c                        a four term recurrence relation. (unpublished
c                        notes by paul n. swarztrauber)
c
      SUBROUTINE DLFIN(INIT,THETA,L,M,NM,PB,ID,WLFIN)
      DOUBLE PRECISION THETA
      DOUBLE PRECISION PB
      DOUBLE PRECISION WLFIN
      DIMENSION PB(1),WLFIN(1)
c
c     total length of wlfin is 4*l*(nm+1)
c
      LNX = L* (NM+1)
      IW1 = LNX + 1
      IW2 = IW1 + LNX
      IW3 = IW2 + LNX
      CALL DLFIN1(INIT,THETA,L,M,NM,ID,PB,WLFIN,WLFIN(IW1),WLFIN(IW2),
     +           WLFIN(IW3),WLFIN(IW2))
      RETURN
      END
      SUBROUTINE DLFIN1(INIT,THETA,L,M,NM,ID,P3,PHZ,PH1,P1,P2,CP)
      DOUBLE PRECISION THETA
      DOUBLE PRECISION P3
      DOUBLE PRECISION PHZ
      DOUBLE PRECISION PH1
      DOUBLE PRECISION P1
      DOUBLE PRECISION P2
      DOUBLE PRECISION CP
      DOUBLE PRECISION SSQRT2
      DOUBLE PRECISION FM
      DOUBLE PRECISION TM
      DOUBLE PRECISION TEMP
      DOUBLE PRECISION CC
      DOUBLE PRECISION EE
      DOUBLE PRECISION FN
      DOUBLE PRECISION TN
      DOUBLE PRECISION CN
      DOUBLE PRECISION FNPM
      DOUBLE PRECISION FNMM
      DOUBLE PRECISION DD
      DIMENSION P1(L,1),P2(L,1),P3(ID,1),PHZ(L,1),PH1(L,1),CP(1),
     +          THETA(1)

      NMP1 = NM + 1
      IF (INIT.NE.0) GO TO 5
      SSQRT2 = 1.D0/SQRT(2.D0)
      DO 10 I = 1,L
          PHZ(I,1) = SSQRT2
   10 CONTINUE
      DO 15 NP1 = 2,NMP1
          NH = NP1 - 1
          CALL DALFK(NH,0,CP)
          DO 16 I = 1,L
              CALL DLFPT(NH,0,THETA(I),CP,PHZ(I,NP1))
   16     CONTINUE
          CALL DALFK(NH,1,CP)
          DO 17 I = 1,L
              CALL DLFPT(NH,1,THETA(I),CP,PH1(I,NP1))
   17     CONTINUE
   15 CONTINUE
      RETURN
    5 MP1 = M + 1
      FM = DBLE(M)
      TM = FM + FM
      IF (M-1) 25,30,35
   25 DO 45 NP1 = 1,NMP1
          DO 45 I = 1,L
              P3(I,NP1) = PHZ(I,NP1)
              P1(I,NP1) = PHZ(I,NP1)
   45 CONTINUE
      RETURN
   30 DO 50 NP1 = 2,NMP1
          DO 50 I = 1,L
              P3(I,NP1) = PH1(I,NP1)
              P2(I,NP1) = PH1(I,NP1)
   50 CONTINUE
      RETURN
   35 TEMP = TM* (TM-1.D0)
      CC = SQRT((TM+1.D0)* (TM-2.D0)/TEMP)
      EE = SQRT(2.D0/TEMP)
      DO 85 I = 1,L
          P3(I,M+1) = CC*P1(I,M-1) - EE*P1(I,M+1)
   85 CONTINUE
      IF (M.EQ.NM) RETURN
      TEMP = TM* (TM+1.D0)
      CC = SQRT((TM+3.D0)* (TM-2.D0)/TEMP)
      EE = SQRT(6.D0/TEMP)
      DO 70 I = 1,L
          P3(I,M+2) = CC*P1(I,M) - EE*P1(I,M+2)
   70 CONTINUE
      MP3 = M + 3
      IF (NMP1.LT.MP3) GO TO 80
      DO 75 NP1 = MP3,NMP1
          N = NP1 - 1
          FN = DBLE(N)
          TN = FN + FN
          CN = (TN+1.D0)/ (TN-3.D0)
          FNPM = FN + FM
          FNMM = FN - FM
          TEMP = FNPM* (FNPM-1.D0)
          CC = SQRT(CN* (FNPM-3.D0)* (FNPM-2.D0)/TEMP)
          DD = SQRT(CN*FNMM* (FNMM-1.D0)/TEMP)
          EE = SQRT((FNMM+1.D0)* (FNMM+2.D0)/TEMP)
          DO 75 I = 1,L
              P3(I,NP1) = CC*P1(I,NP1-2) + DD*P3(I,NP1-2) - EE*P1(I,NP1)
   75 CONTINUE
   80 DO 90 NP1 = M,NMP1
          DO 90 I = 1,L
              P1(I,NP1) = P2(I,NP1)
              P2(I,NP1) = P3(I,NP1)
   90 CONTINUE
      RETURN
      END

      SUBROUTINE ZGESVD( JOBU, JOBVT, M, N, A, LDA, S, U, LDU, VT, LDVT,
     $                   WORK, LWORK, RWORK, INFO )
*
*  -- LAPACK driver routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     October 31, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          JOBU, JOBVT
      INTEGER            INFO, LDA, LDU, LDVT, LWORK, M, N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   RWORK( * ), S( * )
      COMPLEX*16         A( LDA, * ), U( LDU, * ), VT( LDVT, * ),
     $                   WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  ZGESVD computes the singular value decomposition (SVD) of a complex
*  M-by-N matrix A, optionally computing the left and/or right singular
*  vectors. The SVD is written
*
*       A = U * SIGMA * conjugate-transpose(V)
*
*  where SIGMA is an M-by-N matrix which is zero except for its
*  min(m,n) diagonal elements, U is an M-by-M unitary matrix, and
*  V is an N-by-N unitary matrix.  The diagonal elements of SIGMA
*  are the singular values of A; they are real and non-negative, and
*  are returned in descending order.  The first min(m,n) columns of
*  U and V are the left and right singular vectors of A.
*
*  Note that the routine returns V**H, not V.
*
*  Arguments
*  =========
*
*  JOBU    (input) CHARACTER*1
*          Specifies options for computing all or part of the matrix U:
*          = 'A':  all M columns of U are returned in array U:
*          = 'S':  the first min(m,n) columns of U (the left singular
*                  vectors) are returned in the array U;
*          = 'O':  the first min(m,n) columns of U (the left singular
*                  vectors) are overwritten on the array A;
*          = 'N':  no columns of U (no left singular vectors) are
*                  computed.
*
*  JOBVT   (input) CHARACTER*1
*          Specifies options for computing all or part of the matrix
*          V**H:
*          = 'A':  all N rows of V**H are returned in the array VT;
*          = 'S':  the first min(m,n) rows of V**H (the right singular
*                  vectors) are returned in the array VT;
*          = 'O':  the first min(m,n) rows of V**H (the right singular
*                  vectors) are overwritten on the array A;
*          = 'N':  no rows of V**H (no right singular vectors) are
*                  computed.
*
*          JOBVT and JOBU cannot both be 'O'.
*
*  M       (input) INTEGER
*          The number of rows of the input matrix A.  M >= 0.
*
*  N       (input) INTEGER
*          The number of columns of the input matrix A.  N >= 0.
*
*  A       (input/output) COMPLEX*16 array, dimension (LDA,N)
*          On entry, the M-by-N matrix A.
*          On exit,
*          if JOBU = 'O',  A is overwritten with the first min(m,n)
*                          columns of U (the left singular vectors,
*                          stored columnwise);
*          if JOBVT = 'O', A is overwritten with the first min(m,n)
*                          rows of V**H (the right singular vectors,
*                          stored rowwise);
*          if JOBU .ne. 'O' and JOBVT .ne. 'O', the contents of A
*                          are destroyed.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(1,M).
*
*  S       (output) DOUBLE PRECISION array, dimension (min(M,N))
*          The singular values of A, sorted so that S(i) >= S(i+1).
*
*  U       (output) COMPLEX*16 array, dimension (LDU,UCOL)
*          (LDU,M) if JOBU = 'A' or (LDU,min(M,N)) if JOBU = 'S'.
*          If JOBU = 'A', U contains the M-by-M unitary matrix U;
*          if JOBU = 'S', U contains the first min(m,n) columns of U
*          (the left singular vectors, stored columnwise);
*          if JOBU = 'N' or 'O', U is not referenced.
*
*  LDU     (input) INTEGER
*          The leading dimension of the array U.  LDU >= 1; if
*          JOBU = 'S' or 'A', LDU >= M.
*
*  VT      (output) COMPLEX*16 array, dimension (LDVT,N)
*          If JOBVT = 'A', VT contains the N-by-N unitary matrix
*          V**H;
*          if JOBVT = 'S', VT contains the first min(m,n) rows of
*          V**H (the right singular vectors, stored rowwise);
*          if JOBVT = 'N' or 'O', VT is not referenced.
*
*  LDVT    (input) INTEGER
*          The leading dimension of the array VT.  LDVT >= 1; if
*          JOBVT = 'A', LDVT >= N; if JOBVT = 'S', LDVT >= min(M,N).
*
*  WORK    (workspace/output) COMPLEX*16 array, dimension (LWORK)
*          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*
*  LWORK   (input) INTEGER
*          The dimension of the array WORK. LWORK >= 1.
*          LWORK >=  2*MIN(M,N)+MAX(M,N).
*          For good performance, LWORK should generally be larger.
*
*          If LWORK = -1, then a workspace query is assumed; the routine
*          only calculates the optimal size of the WORK array, returns
*          this value as the first entry of the WORK array, and no error
*          message related to LWORK is issued by XERBLA.
*
*  RWORK   (workspace) DOUBLE PRECISION array, dimension (5*min(M,N))
*          On exit, if INFO > 0, RWORK(1:MIN(M,N)-1) contains the
*          unconverged superdiagonal elements of an upper bidiagonal
*          matrix B whose diagonal is in S (not necessarily sorted).
*          B satisfies A = U * B * VT, so it has the same singular
*          values as A, and singular vectors related by U and VT.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit.
*          < 0:  if INFO = -i, the i-th argument had an illegal value.
*          > 0:  if ZBDSQR did not converge, INFO specifies how many
*                superdiagonals of an intermediate bidiagonal form B
*                did not converge to zero. See the description of RWORK
*                above for details.
*
*  =====================================================================
*
*     .. Parameters ..
      COMPLEX*16         CZERO, CONE
      PARAMETER          ( CZERO = ( 0.0D0, 0.0D0 ),
     $                   CONE = ( 1.0D0, 0.0D0 ) )
      DOUBLE PRECISION   ZERO, ONE
      PARAMETER          ( ZERO = 0.0D0, ONE = 1.0D0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            LQUERY, WNTUA, WNTUAS, WNTUN, WNTUO, WNTUS,
     $                   WNTVA, WNTVAS, WNTVN, WNTVO, WNTVS
      INTEGER            BLK, CHUNK, I, IE, IERR, IR, IRWORK, ISCL,
     $                   ITAU, ITAUP, ITAUQ, IU, IWORK, LDWRKR, LDWRKU,
     $                   MAXWRK, MINMN, MINWRK, MNTHR, NCU, NCVT, NRU,
     $                   NRVT, WRKBL
      DOUBLE PRECISION   ANRM, BIGNUM, EPS, SMLNUM
*     ..
*     .. Local Arrays ..
      DOUBLE PRECISION   DUM( 1 )
      COMPLEX*16         CDUM( 1 )
*     ..
*     .. External Subroutines ..
      EXTERNAL           DLASCL, XERBLA, ZBDSQR, ZGEBRD, ZGELQF, ZGEMM,
     $                   ZGEQRF, ZLACPY, ZLASCL, ZLASET, ZUNGBR, ZUNGLQ,
     $                   ZUNGQR, ZUNMBR
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            ILAENV
      DOUBLE PRECISION   DLAMCH, ZLANGE
      EXTERNAL           LSAME, ILAENV, DLAMCH, ZLANGE
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN, SQRT
*     ..
*     .. Executable Statements ..
*
*     Test the input arguments
*
      INFO = 0
      MINMN = MIN( M, N )
      MNTHR = ILAENV( 6, 'ZGESVD', JOBU // JOBVT, M, N, 0, 0 )
      WNTUA = LSAME( JOBU, 'A' )
      WNTUS = LSAME( JOBU, 'S' )
      WNTUAS = WNTUA .OR. WNTUS
      WNTUO = LSAME( JOBU, 'O' )
      WNTUN = LSAME( JOBU, 'N' )
      WNTVA = LSAME( JOBVT, 'A' )
      WNTVS = LSAME( JOBVT, 'S' )
      WNTVAS = WNTVA .OR. WNTVS
      WNTVO = LSAME( JOBVT, 'O' )
      WNTVN = LSAME( JOBVT, 'N' )
      MINWRK = 1
      LQUERY = ( LWORK.EQ.-1 )
*
      IF( .NOT.( WNTUA .OR. WNTUS .OR. WNTUO .OR. WNTUN ) ) THEN
         INFO = -1
      ELSE IF( .NOT.( WNTVA .OR. WNTVS .OR. WNTVO .OR. WNTVN ) .OR.
     $         ( WNTVO .AND. WNTUO ) ) THEN
         INFO = -2
      ELSE IF( M.LT.0 ) THEN
         INFO = -3
      ELSE IF( N.LT.0 ) THEN
         INFO = -4
      ELSE IF( LDA.LT.MAX( 1, M ) ) THEN
         INFO = -6
      ELSE IF( LDU.LT.1 .OR. ( WNTUAS .AND. LDU.LT.M ) ) THEN
         INFO = -9
      ELSE IF( LDVT.LT.1 .OR. ( WNTVA .AND. LDVT.LT.N ) .OR.
     $         ( WNTVS .AND. LDVT.LT.MINMN ) ) THEN
         INFO = -11
      END IF
*
*     Compute workspace
*      (Note: Comments in the code beginning "Workspace:" describe the
*       minimal amount of workspace needed at that point in the code,
*       as well as the preferred amount for good performance.
*       CWorkspace refers to complex workspace, and RWorkspace to
*       real workspace. NB refers to the optimal block size for the
*       immediately following subroutine, as returned by ILAENV.)
*
      IF( INFO.EQ.0 .AND. ( LWORK.GE.1 .OR. LQUERY ) .AND. M.GT.0 .AND.
     $    N.GT.0 ) THEN
         IF( M.GE.N ) THEN
*
*           Space needed for ZBDSQR is BDSPAC = 5*N
*
            IF( M.GE.MNTHR ) THEN
               IF( WNTUN ) THEN
*
*                 Path 1 (M much larger than N, JOBU='N')
*
                  MAXWRK = N + N*ILAENV( 1, 'ZGEQRF', ' ', M, N, -1,
     $                     -1 )
                  MAXWRK = MAX( MAXWRK, 2*N+2*N*
     $                     ILAENV( 1, 'ZGEBRD', ' ', N, N, -1, -1 ) )
                  IF( WNTVO .OR. WNTVAS )
     $               MAXWRK = MAX( MAXWRK, 2*N+( N-1 )*
     $                        ILAENV( 1, 'ZUNGBR', 'P', N, N, N, -1 ) )
                  MINWRK = 3*N
                  MAXWRK = MAX( MINWRK, MAXWRK )
               ELSE IF( WNTUO .AND. WNTVN ) THEN
*
*                 Path 2 (M much larger than N, JOBU='O', JOBVT='N')
*
                  WRKBL = N + N*ILAENV( 1, 'ZGEQRF', ' ', M, N, -1, -1 )
                  WRKBL = MAX( WRKBL, N+N*ILAENV( 1, 'ZUNGQR', ' ', M,
     $                    N, N, -1 ) )
                  WRKBL = MAX( WRKBL, 2*N+2*N*
     $                    ILAENV( 1, 'ZGEBRD', ' ', N, N, -1, -1 ) )
                  WRKBL = MAX( WRKBL, 2*N+N*
     $                    ILAENV( 1, 'ZUNGBR', 'Q', N, N, N, -1 ) )
                  MAXWRK = MAX( N*N+WRKBL, N*N+M*N )
                  MINWRK = 2*N + M
                  MAXWRK = MAX( MINWRK, MAXWRK )
               ELSE IF( WNTUO .AND. WNTVAS ) THEN
*
*                 Path 3 (M much larger than N, JOBU='O', JOBVT='S' or
*                 'A')
*
                  WRKBL = N + N*ILAENV( 1, 'ZGEQRF', ' ', M, N, -1, -1 )
                  WRKBL = MAX( WRKBL, N+N*ILAENV( 1, 'ZUNGQR', ' ', M,
     $                    N, N, -1 ) )
                  WRKBL = MAX( WRKBL, 2*N+2*N*
     $                    ILAENV( 1, 'ZGEBRD', ' ', N, N, -1, -1 ) )
                  WRKBL = MAX( WRKBL, 2*N+N*
     $                    ILAENV( 1, 'ZUNGBR', 'Q', N, N, N, -1 ) )
                  WRKBL = MAX( WRKBL, 2*N+( N-1 )*
     $                    ILAENV( 1, 'ZUNGBR', 'P', N, N, N, -1 ) )
                  MAXWRK = MAX( N*N+WRKBL, N*N+M*N )
                  MINWRK = 2*N + M
                  MAXWRK = MAX( MINWRK, MAXWRK )
               ELSE IF( WNTUS .AND. WNTVN ) THEN
*
*                 Path 4 (M much larger than N, JOBU='S', JOBVT='N')
*
                  WRKBL = N + N*ILAENV( 1, 'ZGEQRF', ' ', M, N, -1, -1 )
                  WRKBL = MAX( WRKBL, N+N*ILAENV( 1, 'ZUNGQR', ' ', M,
     $                    N, N, -1 ) )
                  WRKBL = MAX( WRKBL, 2*N+2*N*
     $                    ILAENV( 1, 'ZGEBRD', ' ', N, N, -1, -1 ) )
                  WRKBL = MAX( WRKBL, 2*N+N*
     $                    ILAENV( 1, 'ZUNGBR', 'Q', N, N, N, -1 ) )
                  MAXWRK = N*N + WRKBL
                  MINWRK = 2*N + M
                  MAXWRK = MAX( MINWRK, MAXWRK )
               ELSE IF( WNTUS .AND. WNTVO ) THEN
*
*                 Path 5 (M much larger than N, JOBU='S', JOBVT='O')
*
                  WRKBL = N + N*ILAENV( 1, 'ZGEQRF', ' ', M, N, -1, -1 )
                  WRKBL = MAX( WRKBL, N+N*ILAENV( 1, 'ZUNGQR', ' ', M,
     $                    N, N, -1 ) )
                  WRKBL = MAX( WRKBL, 2*N+2*N*
     $                    ILAENV( 1, 'ZGEBRD', ' ', N, N, -1, -1 ) )
                  WRKBL = MAX( WRKBL, 2*N+N*
     $                    ILAENV( 1, 'ZUNGBR', 'Q', N, N, N, -1 ) )
                  WRKBL = MAX( WRKBL, 2*N+( N-1 )*
     $                    ILAENV( 1, 'ZUNGBR', 'P', N, N, N, -1 ) )
                  MAXWRK = 2*N*N + WRKBL
                  MINWRK = 2*N + M
                  MAXWRK = MAX( MINWRK, MAXWRK )
               ELSE IF( WNTUS .AND. WNTVAS ) THEN
*
*                 Path 6 (M much larger than N, JOBU='S', JOBVT='S' or
*                 'A')
*
                  WRKBL = N + N*ILAENV( 1, 'ZGEQRF', ' ', M, N, -1, -1 )
                  WRKBL = MAX( WRKBL, N+N*ILAENV( 1, 'ZUNGQR', ' ', M,
     $                    N, N, -1 ) )
                  WRKBL = MAX( WRKBL, 2*N+2*N*
     $                    ILAENV( 1, 'ZGEBRD', ' ', N, N, -1, -1 ) )
                  WRKBL = MAX( WRKBL, 2*N+N*
     $                    ILAENV( 1, 'ZUNGBR', 'Q', N, N, N, -1 ) )
                  WRKBL = MAX( WRKBL, 2*N+( N-1 )*
     $                    ILAENV( 1, 'ZUNGBR', 'P', N, N, N, -1 ) )
                  MAXWRK = N*N + WRKBL
                  MINWRK = 2*N + M
                  MAXWRK = MAX( MINWRK, MAXWRK )
               ELSE IF( WNTUA .AND. WNTVN ) THEN
*
*                 Path 7 (M much larger than N, JOBU='A', JOBVT='N')
*
                  WRKBL = N + N*ILAENV( 1, 'ZGEQRF', ' ', M, N, -1, -1 )
                  WRKBL = MAX( WRKBL, N+M*ILAENV( 1, 'ZUNGQR', ' ', M,
     $                    M, N, -1 ) )
                  WRKBL = MAX( WRKBL, 2*N+2*N*
     $                    ILAENV( 1, 'ZGEBRD', ' ', N, N, -1, -1 ) )
                  WRKBL = MAX( WRKBL, 2*N+N*
     $                    ILAENV( 1, 'ZUNGBR', 'Q', N, N, N, -1 ) )
                  MAXWRK = N*N + WRKBL
                  MINWRK = 2*N + M
                  MAXWRK = MAX( MINWRK, MAXWRK )
               ELSE IF( WNTUA .AND. WNTVO ) THEN
*
*                 Path 8 (M much larger than N, JOBU='A', JOBVT='O')
*
                  WRKBL = N + N*ILAENV( 1, 'ZGEQRF', ' ', M, N, -1, -1 )
                  WRKBL = MAX( WRKBL, N+M*ILAENV( 1, 'ZUNGQR', ' ', M,
     $                    M, N, -1 ) )
                  WRKBL = MAX( WRKBL, 2*N+2*N*
     $                    ILAENV( 1, 'ZGEBRD', ' ', N, N, -1, -1 ) )
                  WRKBL = MAX( WRKBL, 2*N+N*
     $                    ILAENV( 1, 'ZUNGBR', 'Q', N, N, N, -1 ) )
                  WRKBL = MAX( WRKBL, 2*N+( N-1 )*
     $                    ILAENV( 1, 'ZUNGBR', 'P', N, N, N, -1 ) )
                  MAXWRK = 2*N*N + WRKBL
                  MINWRK = 2*N + M
                  MAXWRK = MAX( MINWRK, MAXWRK )
               ELSE IF( WNTUA .AND. WNTVAS ) THEN
*
*                 Path 9 (M much larger than N, JOBU='A', JOBVT='S' or
*                 'A')
*
                  WRKBL = N + N*ILAENV( 1, 'ZGEQRF', ' ', M, N, -1, -1 )
                  WRKBL = MAX( WRKBL, N+M*ILAENV( 1, 'ZUNGQR', ' ', M,
     $                    M, N, -1 ) )
                  WRKBL = MAX( WRKBL, 2*N+2*N*
     $                    ILAENV( 1, 'ZGEBRD', ' ', N, N, -1, -1 ) )
                  WRKBL = MAX( WRKBL, 2*N+N*
     $                    ILAENV( 1, 'ZUNGBR', 'Q', N, N, N, -1 ) )
                  WRKBL = MAX( WRKBL, 2*N+( N-1 )*
     $                    ILAENV( 1, 'ZUNGBR', 'P', N, N, N, -1 ) )
                  MAXWRK = N*N + WRKBL
                  MINWRK = 2*N + M
                  MAXWRK = MAX( MINWRK, MAXWRK )
               END IF
            ELSE
*
*              Path 10 (M at least N, but not much larger)
*
               MAXWRK = 2*N + ( M+N )*ILAENV( 1, 'ZGEBRD', ' ', M, N,
     $                  -1, -1 )
               IF( WNTUS .OR. WNTUO )
     $            MAXWRK = MAX( MAXWRK, 2*N+N*
     $                     ILAENV( 1, 'ZUNGBR', 'Q', M, N, N, -1 ) )
               IF( WNTUA )
     $            MAXWRK = MAX( MAXWRK, 2*N+M*
     $                     ILAENV( 1, 'ZUNGBR', 'Q', M, M, N, -1 ) )
               IF( .NOT.WNTVN )
     $            MAXWRK = MAX( MAXWRK, 2*N+( N-1 )*
     $                     ILAENV( 1, 'ZUNGBR', 'P', N, N, N, -1 ) )
               MINWRK = 2*N + M
               MAXWRK = MAX( MINWRK, MAXWRK )
            END IF
         ELSE
*
*           Space needed for ZBDSQR is BDSPAC = 5*M
*
            IF( N.GE.MNTHR ) THEN
               IF( WNTVN ) THEN
*
*                 Path 1t(N much larger than M, JOBVT='N')
*
                  MAXWRK = M + M*ILAENV( 1, 'ZGELQF', ' ', M, N, -1,
     $                     -1 )
                  MAXWRK = MAX( MAXWRK, 2*M+2*M*
     $                     ILAENV( 1, 'ZGEBRD', ' ', M, M, -1, -1 ) )
                  IF( WNTUO .OR. WNTUAS )
     $               MAXWRK = MAX( MAXWRK, 2*M+M*
     $                        ILAENV( 1, 'ZUNGBR', 'Q', M, M, M, -1 ) )
                  MINWRK = 3*M
                  MAXWRK = MAX( MINWRK, MAXWRK )
               ELSE IF( WNTVO .AND. WNTUN ) THEN
*
*                 Path 2t(N much larger than M, JOBU='N', JOBVT='O')
*
                  WRKBL = M + M*ILAENV( 1, 'ZGELQF', ' ', M, N, -1, -1 )
                  WRKBL = MAX( WRKBL, M+M*ILAENV( 1, 'ZUNGLQ', ' ', M,
     $                    N, M, -1 ) )
                  WRKBL = MAX( WRKBL, 2*M+2*M*
     $                    ILAENV( 1, 'ZGEBRD', ' ', M, M, -1, -1 ) )
                  WRKBL = MAX( WRKBL, 2*M+( M-1 )*
     $                    ILAENV( 1, 'ZUNGBR', 'P', M, M, M, -1 ) )
                  MAXWRK = MAX( M*M+WRKBL, M*M+M*N )
                  MINWRK = 2*M + N
                  MAXWRK = MAX( MINWRK, MAXWRK )
               ELSE IF( WNTVO .AND. WNTUAS ) THEN
*
*                 Path 3t(N much larger than M, JOBU='S' or 'A',
*                 JOBVT='O')
*
                  WRKBL = M + M*ILAENV( 1, 'ZGELQF', ' ', M, N, -1, -1 )
                  WRKBL = MAX( WRKBL, M+M*ILAENV( 1, 'ZUNGLQ', ' ', M,
     $                    N, M, -1 ) )
                  WRKBL = MAX( WRKBL, 2*M+2*M*
     $                    ILAENV( 1, 'ZGEBRD', ' ', M, M, -1, -1 ) )
                  WRKBL = MAX( WRKBL, 2*M+( M-1 )*
     $                    ILAENV( 1, 'ZUNGBR', 'P', M, M, M, -1 ) )
                  WRKBL = MAX( WRKBL, 2*M+M*
     $                    ILAENV( 1, 'ZUNGBR', 'Q', M, M, M, -1 ) )
                  MAXWRK = MAX( M*M+WRKBL, M*M+M*N )
                  MINWRK = 2*M + N
                  MAXWRK = MAX( MINWRK, MAXWRK )
               ELSE IF( WNTVS .AND. WNTUN ) THEN
*
*                 Path 4t(N much larger than M, JOBU='N', JOBVT='S')
*
                  WRKBL = M + M*ILAENV( 1, 'ZGELQF', ' ', M, N, -1, -1 )
                  WRKBL = MAX( WRKBL, M+M*ILAENV( 1, 'ZUNGLQ', ' ', M,
     $                    N, M, -1 ) )
                  WRKBL = MAX( WRKBL, 2*M+2*M*
     $                    ILAENV( 1, 'ZGEBRD', ' ', M, M, -1, -1 ) )
                  WRKBL = MAX( WRKBL, 2*M+( M-1 )*
     $                    ILAENV( 1, 'ZUNGBR', 'P', M, M, M, -1 ) )
                  MAXWRK = M*M + WRKBL
                  MINWRK = 2*M + N
                  MAXWRK = MAX( MINWRK, MAXWRK )
               ELSE IF( WNTVS .AND. WNTUO ) THEN
*
*                 Path 5t(N much larger than M, JOBU='O', JOBVT='S')
*
                  WRKBL = M + M*ILAENV( 1, 'ZGELQF', ' ', M, N, -1, -1 )
                  WRKBL = MAX( WRKBL, M+M*ILAENV( 1, 'ZUNGLQ', ' ', M,
     $                    N, M, -1 ) )
                  WRKBL = MAX( WRKBL, 2*M+2*M*
     $                    ILAENV( 1, 'ZGEBRD', ' ', M, M, -1, -1 ) )
                  WRKBL = MAX( WRKBL, 2*M+( M-1 )*
     $                    ILAENV( 1, 'ZUNGBR', 'P', M, M, M, -1 ) )
                  WRKBL = MAX( WRKBL, 2*M+M*
     $                    ILAENV( 1, 'ZUNGBR', 'Q', M, M, M, -1 ) )
                  MAXWRK = 2*M*M + WRKBL
                  MINWRK = 2*M + N
                  MAXWRK = MAX( MINWRK, MAXWRK )
               ELSE IF( WNTVS .AND. WNTUAS ) THEN
*
*                 Path 6t(N much larger than M, JOBU='S' or 'A',
*                 JOBVT='S')
*
                  WRKBL = M + M*ILAENV( 1, 'ZGELQF', ' ', M, N, -1, -1 )
                  WRKBL = MAX( WRKBL, M+M*ILAENV( 1, 'ZUNGLQ', ' ', M,
     $                    N, M, -1 ) )
                  WRKBL = MAX( WRKBL, 2*M+2*M*
     $                    ILAENV( 1, 'ZGEBRD', ' ', M, M, -1, -1 ) )
                  WRKBL = MAX( WRKBL, 2*M+( M-1 )*
     $                    ILAENV( 1, 'ZUNGBR', 'P', M, M, M, -1 ) )
                  WRKBL = MAX( WRKBL, 2*M+M*
     $                    ILAENV( 1, 'ZUNGBR', 'Q', M, M, M, -1 ) )
                  MAXWRK = M*M + WRKBL
                  MINWRK = 2*M + N
                  MAXWRK = MAX( MINWRK, MAXWRK )
               ELSE IF( WNTVA .AND. WNTUN ) THEN
*
*                 Path 7t(N much larger than M, JOBU='N', JOBVT='A')
*
                  WRKBL = M + M*ILAENV( 1, 'ZGELQF', ' ', M, N, -1, -1 )
                  WRKBL = MAX( WRKBL, M+N*ILAENV( 1, 'ZUNGLQ', ' ', N,
     $                    N, M, -1 ) )
                  WRKBL = MAX( WRKBL, 2*M+2*M*
     $                    ILAENV( 1, 'ZGEBRD', ' ', M, M, -1, -1 ) )
                  WRKBL = MAX( WRKBL, 2*M+( M-1 )*
     $                    ILAENV( 1, 'ZUNGBR', 'P', M, M, M, -1 ) )
                  MAXWRK = M*M + WRKBL
                  MINWRK = 2*M + N
                  MAXWRK = MAX( MINWRK, MAXWRK )
               ELSE IF( WNTVA .AND. WNTUO ) THEN
*
*                 Path 8t(N much larger than M, JOBU='O', JOBVT='A')
*
                  WRKBL = M + M*ILAENV( 1, 'ZGELQF', ' ', M, N, -1, -1 )
                  WRKBL = MAX( WRKBL, M+N*ILAENV( 1, 'ZUNGLQ', ' ', N,
     $                    N, M, -1 ) )
                  WRKBL = MAX( WRKBL, 2*M+2*M*
     $                    ILAENV( 1, 'ZGEBRD', ' ', M, M, -1, -1 ) )
                  WRKBL = MAX( WRKBL, 2*M+( M-1 )*
     $                    ILAENV( 1, 'ZUNGBR', 'P', M, M, M, -1 ) )
                  WRKBL = MAX( WRKBL, 2*M+M*
     $                    ILAENV( 1, 'ZUNGBR', 'Q', M, M, M, -1 ) )
                  MAXWRK = 2*M*M + WRKBL
                  MINWRK = 2*M + N
                  MAXWRK = MAX( MINWRK, MAXWRK )
               ELSE IF( WNTVA .AND. WNTUAS ) THEN
*
*                 Path 9t(N much larger than M, JOBU='S' or 'A',
*                 JOBVT='A')
*
                  WRKBL = M + M*ILAENV( 1, 'ZGELQF', ' ', M, N, -1, -1 )
                  WRKBL = MAX( WRKBL, M+N*ILAENV( 1, 'ZUNGLQ', ' ', N,
     $                    N, M, -1 ) )
                  WRKBL = MAX( WRKBL, 2*M+2*M*
     $                    ILAENV( 1, 'ZGEBRD', ' ', M, M, -1, -1 ) )
                  WRKBL = MAX( WRKBL, 2*M+( M-1 )*
     $                    ILAENV( 1, 'ZUNGBR', 'P', M, M, M, -1 ) )
                  WRKBL = MAX( WRKBL, 2*M+M*
     $                    ILAENV( 1, 'ZUNGBR', 'Q', M, M, M, -1 ) )
                  MAXWRK = M*M + WRKBL
                  MINWRK = 2*M + N
                  MAXWRK = MAX( MINWRK, MAXWRK )
               END IF
            ELSE
*
*              Path 10t(N greater than M, but not much larger)
*
               MAXWRK = 2*M + ( M+N )*ILAENV( 1, 'ZGEBRD', ' ', M, N,
     $                  -1, -1 )
               IF( WNTVS .OR. WNTVO )
     $            MAXWRK = MAX( MAXWRK, 2*M+M*
     $                     ILAENV( 1, 'ZUNGBR', 'P', M, N, M, -1 ) )
               IF( WNTVA )
     $            MAXWRK = MAX( MAXWRK, 2*M+N*
     $                     ILAENV( 1, 'ZUNGBR', 'P', N, N, M, -1 ) )
               IF( .NOT.WNTUN )
     $            MAXWRK = MAX( MAXWRK, 2*M+( M-1 )*
     $                     ILAENV( 1, 'ZUNGBR', 'Q', M, M, M, -1 ) )
               MINWRK = 2*M + N
               MAXWRK = MAX( MINWRK, MAXWRK )
            END IF
         END IF
         WORK( 1 ) = MAXWRK
      END IF
*
      IF( LWORK.LT.MINWRK .AND. .NOT.LQUERY ) THEN
         INFO = -13
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'ZGESVD', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( M.EQ.0 .OR. N.EQ.0 ) THEN
         IF( LWORK.GE.1 )
     $      WORK( 1 ) = ONE
         RETURN
      END IF
*
*     Get machine constants
*
      EPS = DLAMCH( 'P' )
      SMLNUM = SQRT( DLAMCH( 'S' ) ) / EPS
      BIGNUM = ONE / SMLNUM
*
*     Scale A if max element outside range [SMLNUM,BIGNUM]
*
      ANRM = ZLANGE( 'M', M, N, A, LDA, DUM )
      ISCL = 0
      IF( ANRM.GT.ZERO .AND. ANRM.LT.SMLNUM ) THEN
         ISCL = 1
         CALL ZLASCL( 'G', 0, 0, ANRM, SMLNUM, M, N, A, LDA, IERR )
      ELSE IF( ANRM.GT.BIGNUM ) THEN
         ISCL = 1
         CALL ZLASCL( 'G', 0, 0, ANRM, BIGNUM, M, N, A, LDA, IERR )
      END IF
*
      IF( M.GE.N ) THEN
*
*        A has at least as many rows as columns. If A has sufficiently
*        more rows than columns, first reduce using the QR
*        decomposition (if sufficient workspace available)
*
         IF( M.GE.MNTHR ) THEN
*
            IF( WNTUN ) THEN
*
*              Path 1 (M much larger than N, JOBU='N')
*              No left singular vectors to be computed
*
               ITAU = 1
               IWORK = ITAU + N
*
*              Compute A=Q*R
*              (CWorkspace: need 2*N, prefer N+N*NB)
*              (RWorkspace: need 0)
*
               CALL ZGEQRF( M, N, A, LDA, WORK( ITAU ), WORK( IWORK ),
     $                      LWORK-IWORK+1, IERR )
*
*              Zero out below R
*
               CALL ZLASET( 'L', N-1, N-1, CZERO, CZERO, A( 2, 1 ),
     $                      LDA )
               IE = 1
               ITAUQ = 1
               ITAUP = ITAUQ + N
               IWORK = ITAUP + N
*
*              Bidiagonalize R in A
*              (CWorkspace: need 3*N, prefer 2*N+2*N*NB)
*              (RWorkspace: need N)
*
               CALL ZGEBRD( N, N, A, LDA, S, RWORK( IE ), WORK( ITAUQ ),
     $                      WORK( ITAUP ), WORK( IWORK ), LWORK-IWORK+1,
     $                      IERR )
               NCVT = 0
               IF( WNTVO .OR. WNTVAS ) THEN
*
*                 If right singular vectors desired, generate P'.
*                 (CWorkspace: need 3*N-1, prefer 2*N+(N-1)*NB)
*                 (RWorkspace: 0)
*
                  CALL ZUNGBR( 'P', N, N, N, A, LDA, WORK( ITAUP ),
     $                         WORK( IWORK ), LWORK-IWORK+1, IERR )
                  NCVT = N
               END IF
               IRWORK = IE + N
*
*              Perform bidiagonal QR iteration, computing right
*              singular vectors of A in A if desired
*              (CWorkspace: 0)
*              (RWorkspace: need BDSPAC)
*
               CALL ZBDSQR( 'U', N, NCVT, 0, 0, S, RWORK( IE ), A, LDA,
     $                      CDUM, 1, CDUM, 1, RWORK( IRWORK ), INFO )
*
*              If right singular vectors desired in VT, copy them there
*
               IF( WNTVAS )
     $            CALL ZLACPY( 'F', N, N, A, LDA, VT, LDVT )
*
            ELSE IF( WNTUO .AND. WNTVN ) THEN
*
*              Path 2 (M much larger than N, JOBU='O', JOBVT='N')
*              N left singular vectors to be overwritten on A and
*              no right singular vectors to be computed
*
               IF( LWORK.GE.N*N+3*N ) THEN
*
*                 Sufficient workspace for a fast algorithm
*
                  IR = 1
                  IF( LWORK.GE.MAX( WRKBL, LDA*N )+LDA*N ) THEN
*
*                    WORK(IU) is LDA by N, WORK(IR) is LDA by N
*
                     LDWRKU = LDA
                     LDWRKR = LDA
                  ELSE IF( LWORK.GE.MAX( WRKBL, LDA*N )+N*N ) THEN
*
*                    WORK(IU) is LDA by N, WORK(IR) is N by N
*
                     LDWRKU = LDA
                     LDWRKR = N
                  ELSE
*
*                    WORK(IU) is LDWRKU by N, WORK(IR) is N by N
*
                     LDWRKU = ( LWORK-N*N ) / N
                     LDWRKR = N
                  END IF
                  ITAU = IR + LDWRKR*N
                  IWORK = ITAU + N
*
*                 Compute A=Q*R
*                 (CWorkspace: need N*N+2*N, prefer N*N+N+N*NB)
*                 (RWorkspace: 0)
*
                  CALL ZGEQRF( M, N, A, LDA, WORK( ITAU ),
     $                         WORK( IWORK ), LWORK-IWORK+1, IERR )
*
*                 Copy R to WORK(IR) and zero out below it
*
                  CALL ZLACPY( 'U', N, N, A, LDA, WORK( IR ), LDWRKR )
                  CALL ZLASET( 'L', N-1, N-1, CZERO, CZERO,
     $                         WORK( IR+1 ), LDWRKR )
*
*                 Generate Q in A
*                 (CWorkspace: need N*N+2*N, prefer N*N+N+N*NB)
*                 (RWorkspace: 0)
*
                  CALL ZUNGQR( M, N, N, A, LDA, WORK( ITAU ),
     $                         WORK( IWORK ), LWORK-IWORK+1, IERR )
                  IE = 1
                  ITAUQ = ITAU
                  ITAUP = ITAUQ + N
                  IWORK = ITAUP + N
*
*                 Bidiagonalize R in WORK(IR)
*                 (CWorkspace: need N*N+3*N, prefer N*N+2*N+2*N*NB)
*                 (RWorkspace: need N)
*
                  CALL ZGEBRD( N, N, WORK( IR ), LDWRKR, S, RWORK( IE ),
     $                         WORK( ITAUQ ), WORK( ITAUP ),
     $                         WORK( IWORK ), LWORK-IWORK+1, IERR )
*
*                 Generate left vectors bidiagonalizing R
*                 (CWorkspace: need N*N+3*N, prefer N*N+2*N+N*NB)
*                 (RWorkspace: need 0)
*
                  CALL ZUNGBR( 'Q', N, N, N, WORK( IR ), LDWRKR,
     $                         WORK( ITAUQ ), WORK( IWORK ),
     $                         LWORK-IWORK+1, IERR )
                  IRWORK = IE + N
*
*                 Perform bidiagonal QR iteration, computing left
*                 singular vectors of R in WORK(IR)
*                 (CWorkspace: need N*N)
*                 (RWorkspace: need BDSPAC)
*
                  CALL ZBDSQR( 'U', N, 0, N, 0, S, RWORK( IE ), CDUM, 1,
     $                         WORK( IR ), LDWRKR, CDUM, 1,
     $                         RWORK( IRWORK ), INFO )
                  IU = ITAUQ
*
*                 Multiply Q in A by left singular vectors of R in
*                 WORK(IR), storing result in WORK(IU) and copying to A
*                 (CWorkspace: need N*N+N, prefer N*N+M*N)
*                 (RWorkspace: 0)
*
                  DO 10 I = 1, M, LDWRKU
                     CHUNK = MIN( M-I+1, LDWRKU )
                     CALL ZGEMM( 'N', 'N', CHUNK, N, N, CONE, A( I, 1 ),
     $                           LDA, WORK( IR ), LDWRKR, CZERO,
     $                           WORK( IU ), LDWRKU )
                     CALL ZLACPY( 'F', CHUNK, N, WORK( IU ), LDWRKU,
     $                            A( I, 1 ), LDA )
   10             CONTINUE
*
               ELSE
*
*                 Insufficient workspace for a fast algorithm
*
                  IE = 1
                  ITAUQ = 1
                  ITAUP = ITAUQ + N
                  IWORK = ITAUP + N
*
*                 Bidiagonalize A
*                 (CWorkspace: need 2*N+M, prefer 2*N+(M+N)*NB)
*                 (RWorkspace: N)
*
                  CALL ZGEBRD( M, N, A, LDA, S, RWORK( IE ),
     $                         WORK( ITAUQ ), WORK( ITAUP ),
     $                         WORK( IWORK ), LWORK-IWORK+1, IERR )
*
*                 Generate left vectors bidiagonalizing A
*                 (CWorkspace: need 3*N, prefer 2*N+N*NB)
*                 (RWorkspace: 0)
*
                  CALL ZUNGBR( 'Q', M, N, N, A, LDA, WORK( ITAUQ ),
     $                         WORK( IWORK ), LWORK-IWORK+1, IERR )
                  IRWORK = IE + N
*
*                 Perform bidiagonal QR iteration, computing left
*                 singular vectors of A in A
*                 (CWorkspace: need 0)
*                 (RWorkspace: need BDSPAC)
*
                  CALL ZBDSQR( 'U', N, 0, M, 0, S, RWORK( IE ), CDUM, 1,
     $                         A, LDA, CDUM, 1, RWORK( IRWORK ), INFO )
*
               END IF
*
            ELSE IF( WNTUO .AND. WNTVAS ) THEN
*
*              Path 3 (M much larger than N, JOBU='O', JOBVT='S' or 'A')
*              N left singular vectors to be overwritten on A and
*              N right singular vectors to be computed in VT
*
               IF( LWORK.GE.N*N+3*N ) THEN
*
*                 Sufficient workspace for a fast algorithm
*
                  IR = 1
                  IF( LWORK.GE.MAX( WRKBL, LDA*N )+LDA*N ) THEN
*
*                    WORK(IU) is LDA by N and WORK(IR) is LDA by N
*
                     LDWRKU = LDA
                     LDWRKR = LDA
                  ELSE IF( LWORK.GE.MAX( WRKBL, LDA*N )+N*N ) THEN
*
*                    WORK(IU) is LDA by N and WORK(IR) is N by N
*
                     LDWRKU = LDA
                     LDWRKR = N
                  ELSE
*
*                    WORK(IU) is LDWRKU by N and WORK(IR) is N by N
*
                     LDWRKU = ( LWORK-N*N ) / N
                     LDWRKR = N
                  END IF
                  ITAU = IR + LDWRKR*N
                  IWORK = ITAU + N
*
*                 Compute A=Q*R
*                 (CWorkspace: need N*N+2*N, prefer N*N+N+N*NB)
*                 (RWorkspace: 0)
*
                  CALL ZGEQRF( M, N, A, LDA, WORK( ITAU ),
     $                         WORK( IWORK ), LWORK-IWORK+1, IERR )
*
*                 Copy R to VT, zeroing out below it
*
                  CALL ZLACPY( 'U', N, N, A, LDA, VT, LDVT )
                  CALL ZLASET( 'L', N-1, N-1, CZERO, CZERO, VT( 2, 1 ),
     $                         LDVT )
*
*                 Generate Q in A
*                 (CWorkspace: need N*N+2*N, prefer N*N+N+N*NB)
*                 (RWorkspace: 0)
*
                  CALL ZUNGQR( M, N, N, A, LDA, WORK( ITAU ),
     $                         WORK( IWORK ), LWORK-IWORK+1, IERR )
                  IE = 1
                  ITAUQ = ITAU
                  ITAUP = ITAUQ + N
                  IWORK = ITAUP + N
*
*                 Bidiagonalize R in VT, copying result to WORK(IR)
*                 (CWorkspace: need N*N+3*N, prefer N*N+2*N+2*N*NB)
*                 (RWorkspace: need N)
*
                  CALL ZGEBRD( N, N, VT, LDVT, S, RWORK( IE ),
     $                         WORK( ITAUQ ), WORK( ITAUP ),
     $                         WORK( IWORK ), LWORK-IWORK+1, IERR )
                  CALL ZLACPY( 'L', N, N, VT, LDVT, WORK( IR ), LDWRKR )
*
*                 Generate left vectors bidiagonalizing R in WORK(IR)
*                 (CWorkspace: need N*N+3*N, prefer N*N+2*N+N*NB)
*                 (RWorkspace: 0)
*
                  CALL ZUNGBR( 'Q', N, N, N, WORK( IR ), LDWRKR,
     $                         WORK( ITAUQ ), WORK( IWORK ),
     $                         LWORK-IWORK+1, IERR )
*
*                 Generate right vectors bidiagonalizing R in VT
*                 (CWorkspace: need N*N+3*N-1, prefer N*N+2*N+(N-1)*NB)
*                 (RWorkspace: 0)
*
                  CALL ZUNGBR( 'P', N, N, N, VT, LDVT, WORK( ITAUP ),
     $                         WORK( IWORK ), LWORK-IWORK+1, IERR )
                  IRWORK = IE + N
*
*                 Perform bidiagonal QR iteration, computing left
*                 singular vectors of R in WORK(IR) and computing right
*                 singular vectors of R in VT
*                 (CWorkspace: need N*N)
*                 (RWorkspace: need BDSPAC)
*
                  CALL ZBDSQR( 'U', N, N, N, 0, S, RWORK( IE ), VT,
     $                         LDVT, WORK( IR ), LDWRKR, CDUM, 1,
     $                         RWORK( IRWORK ), INFO )
                  IU = ITAUQ
*
*                 Multiply Q in A by left singular vectors of R in
*                 WORK(IR), storing result in WORK(IU) and copying to A
*                 (CWorkspace: need N*N+N, prefer N*N+M*N)
*                 (RWorkspace: 0)
*
                  DO 20 I = 1, M, LDWRKU
                     CHUNK = MIN( M-I+1, LDWRKU )
                     CALL ZGEMM( 'N', 'N', CHUNK, N, N, CONE, A( I, 1 ),
     $                           LDA, WORK( IR ), LDWRKR, CZERO,
     $                           WORK( IU ), LDWRKU )
                     CALL ZLACPY( 'F', CHUNK, N, WORK( IU ), LDWRKU,
     $                            A( I, 1 ), LDA )
   20             CONTINUE
*
               ELSE
*
*                 Insufficient workspace for a fast algorithm
*
                  ITAU = 1
                  IWORK = ITAU + N
*
*                 Compute A=Q*R
*                 (CWorkspace: need 2*N, prefer N+N*NB)
*                 (RWorkspace: 0)
*
                  CALL ZGEQRF( M, N, A, LDA, WORK( ITAU ),
     $                         WORK( IWORK ), LWORK-IWORK+1, IERR )
*
*                 Copy R to VT, zeroing out below it
*
                  CALL ZLACPY( 'U', N, N, A, LDA, VT, LDVT )
                  CALL ZLASET( 'L', N-1, N-1, CZERO, CZERO, VT( 2, 1 ),
     $                         LDVT )
*
*                 Generate Q in A
*                 (CWorkspace: need 2*N, prefer N+N*NB)
*                 (RWorkspace: 0)
*
                  CALL ZUNGQR( M, N, N, A, LDA, WORK( ITAU ),
     $                         WORK( IWORK ), LWORK-IWORK+1, IERR )
                  IE = 1
                  ITAUQ = ITAU
                  ITAUP = ITAUQ + N
                  IWORK = ITAUP + N
*
*                 Bidiagonalize R in VT
*                 (CWorkspace: need 3*N, prefer 2*N+2*N*NB)
*                 (RWorkspace: N)
*
                  CALL ZGEBRD( N, N, VT, LDVT, S, RWORK( IE ),
     $                         WORK( ITAUQ ), WORK( ITAUP ),
     $                         WORK( IWORK ), LWORK-IWORK+1, IERR )
*
*                 Multiply Q in A by left vectors bidiagonalizing R
*                 (CWorkspace: need 2*N+M, prefer 2*N+M*NB)
*                 (RWorkspace: 0)
*
                  CALL ZUNMBR( 'Q', 'R', 'N', M, N, N, VT, LDVT,
     $                         WORK( ITAUQ ), A, LDA, WORK( IWORK ),
     $                         LWORK-IWORK+1, IERR )
*
*                 Generate right vectors bidiagonalizing R in VT
*                 (CWorkspace: need 3*N-1, prefer 2*N+(N-1)*NB)
*                 (RWorkspace: 0)
*
                  CALL ZUNGBR( 'P', N, N, N, VT, LDVT, WORK( ITAUP ),
     $                         WORK( IWORK ), LWORK-IWORK+1, IERR )
                  IRWORK = IE + N
*
*                 Perform bidiagonal QR iteration, computing left
*                 singular vectors of A in A and computing right
*                 singular vectors of A in VT
*                 (CWorkspace: 0)
*                 (RWorkspace: need BDSPAC)
*
                  CALL ZBDSQR( 'U', N, N, M, 0, S, RWORK( IE ), VT,
     $                         LDVT, A, LDA, CDUM, 1, RWORK( IRWORK ),
     $                         INFO )
*
               END IF
*
            ELSE IF( WNTUS ) THEN
*
               IF( WNTVN ) THEN
*
*                 Path 4 (M much larger than N, JOBU='S', JOBVT='N')
*                 N left singular vectors to be computed in U and
*                 no right singular vectors to be computed
*
                  IF( LWORK.GE.N*N+3*N ) THEN
*
*                    Sufficient workspace for a fast algorithm
*
                     IR = 1
                     IF( LWORK.GE.WRKBL+LDA*N ) THEN
*
*                       WORK(IR) is LDA by N
*
                        LDWRKR = LDA
                     ELSE
*
*                       WORK(IR) is N by N
*
                        LDWRKR = N
                     END IF
                     ITAU = IR + LDWRKR*N
                     IWORK = ITAU + N
*
*                    Compute A=Q*R
*                    (CWorkspace: need N*N+2*N, prefer N*N+N+N*NB)
*                    (RWorkspace: 0)
*
                     CALL ZGEQRF( M, N, A, LDA, WORK( ITAU ),
     $                            WORK( IWORK ), LWORK-IWORK+1, IERR )
*
*                    Copy R to WORK(IR), zeroing out below it
*
                     CALL ZLACPY( 'U', N, N, A, LDA, WORK( IR ),
     $                            LDWRKR )
                     CALL ZLASET( 'L', N-1, N-1, CZERO, CZERO,
     $                            WORK( IR+1 ), LDWRKR )
*
*                    Generate Q in A
*                    (CWorkspace: need N*N+2*N, prefer N*N+N+N*NB)
*                    (RWorkspace: 0)
*
                     CALL ZUNGQR( M, N, N, A, LDA, WORK( ITAU ),
     $                            WORK( IWORK ), LWORK-IWORK+1, IERR )
                     IE = 1
                     ITAUQ = ITAU
                     ITAUP = ITAUQ + N
                     IWORK = ITAUP + N
*
*                    Bidiagonalize R in WORK(IR)
*                    (CWorkspace: need N*N+3*N, prefer N*N+2*N+2*N*NB)
*                    (RWorkspace: need N)
*
                     CALL ZGEBRD( N, N, WORK( IR ), LDWRKR, S,
     $                            RWORK( IE ), WORK( ITAUQ ),
     $                            WORK( ITAUP ), WORK( IWORK ),
     $                            LWORK-IWORK+1, IERR )
*
*                    Generate left vectors bidiagonalizing R in WORK(IR)
*                    (CWorkspace: need N*N+3*N, prefer N*N+2*N+N*NB)
*                    (RWorkspace: 0)
*
                     CALL ZUNGBR( 'Q', N, N, N, WORK( IR ), LDWRKR,
     $                            WORK( ITAUQ ), WORK( IWORK ),
     $                            LWORK-IWORK+1, IERR )
                     IRWORK = IE + N
*
*                    Perform bidiagonal QR iteration, computing left
*                    singular vectors of R in WORK(IR)
*                    (CWorkspace: need N*N)
*                    (RWorkspace: need BDSPAC)
*
                     CALL ZBDSQR( 'U', N, 0, N, 0, S, RWORK( IE ), CDUM,
     $                            1, WORK( IR ), LDWRKR, CDUM, 1,
     $                            RWORK( IRWORK ), INFO )
*
*                    Multiply Q in A by left singular vectors of R in
*                    WORK(IR), storing result in U
*                    (CWorkspace: need N*N)
*                    (RWorkspace: 0)
*
                     CALL ZGEMM( 'N', 'N', M, N, N, CONE, A, LDA,
     $                           WORK( IR ), LDWRKR, CZERO, U, LDU )
*
                  ELSE
*
*                    Insufficient workspace for a fast algorithm
*
                     ITAU = 1
                     IWORK = ITAU + N
*
*                    Compute A=Q*R, copying result to U
*                    (CWorkspace: need 2*N, prefer N+N*NB)
*                    (RWorkspace: 0)
*
                     CALL ZGEQRF( M, N, A, LDA, WORK( ITAU ),
     $                            WORK( IWORK ), LWORK-IWORK+1, IERR )
                     CALL ZLACPY( 'L', M, N, A, LDA, U, LDU )
*
*                    Generate Q in U
*                    (CWorkspace: need 2*N, prefer N+N*NB)
*                    (RWorkspace: 0)
*
                     CALL ZUNGQR( M, N, N, U, LDU, WORK( ITAU ),
     $                            WORK( IWORK ), LWORK-IWORK+1, IERR )
                     IE = 1
                     ITAUQ = ITAU
                     ITAUP = ITAUQ + N
                     IWORK = ITAUP + N
*
*                    Zero out below R in A
*
                     CALL ZLASET( 'L', N-1, N-1, CZERO, CZERO,
     $                            A( 2, 1 ), LDA )
*
*                    Bidiagonalize R in A
*                    (CWorkspace: need 3*N, prefer 2*N+2*N*NB)
*                    (RWorkspace: need N)
*
                     CALL ZGEBRD( N, N, A, LDA, S, RWORK( IE ),
     $                            WORK( ITAUQ ), WORK( ITAUP ),
     $                            WORK( IWORK ), LWORK-IWORK+1, IERR )
*
*                    Multiply Q in U by left vectors bidiagonalizing R
*                    (CWorkspace: need 2*N+M, prefer 2*N+M*NB)
*                    (RWorkspace: 0)
*
                     CALL ZUNMBR( 'Q', 'R', 'N', M, N, N, A, LDA,
     $                            WORK( ITAUQ ), U, LDU, WORK( IWORK ),
     $                            LWORK-IWORK+1, IERR )
                     IRWORK = IE + N
*
*                    Perform bidiagonal QR iteration, computing left
*                    singular vectors of A in U
*                    (CWorkspace: 0)
*                    (RWorkspace: need BDSPAC)
*
                     CALL ZBDSQR( 'U', N, 0, M, 0, S, RWORK( IE ), CDUM,
     $                            1, U, LDU, CDUM, 1, RWORK( IRWORK ),
     $                            INFO )
*
                  END IF
*
               ELSE IF( WNTVO ) THEN
*
*                 Path 5 (M much larger than N, JOBU='S', JOBVT='O')
*                 N left singular vectors to be computed in U and
*                 N right singular vectors to be overwritten on A
*
                  IF( LWORK.GE.2*N*N+3*N ) THEN
*
*                    Sufficient workspace for a fast algorithm
*
                     IU = 1
                     IF( LWORK.GE.WRKBL+2*LDA*N ) THEN
*
*                       WORK(IU) is LDA by N and WORK(IR) is LDA by N
*
                        LDWRKU = LDA
                        IR = IU + LDWRKU*N
                        LDWRKR = LDA
                     ELSE IF( LWORK.GE.WRKBL+( LDA+N )*N ) THEN
*
*                       WORK(IU) is LDA by N and WORK(IR) is N by N
*
                        LDWRKU = LDA
                        IR = IU + LDWRKU*N
                        LDWRKR = N
                     ELSE
*
*                       WORK(IU) is N by N and WORK(IR) is N by N
*
                        LDWRKU = N
                        IR = IU + LDWRKU*N
                        LDWRKR = N
                     END IF
                     ITAU = IR + LDWRKR*N
                     IWORK = ITAU + N
*
*                    Compute A=Q*R
*                    (CWorkspace: need 2*N*N+2*N, prefer 2*N*N+N+N*NB)
*                    (RWorkspace: 0)
*
                     CALL ZGEQRF( M, N, A, LDA, WORK( ITAU ),
     $                            WORK( IWORK ), LWORK-IWORK+1, IERR )
*
*                    Copy R to WORK(IU), zeroing out below it
*
                     CALL ZLACPY( 'U', N, N, A, LDA, WORK( IU ),
     $                            LDWRKU )
                     CALL ZLASET( 'L', N-1, N-1, CZERO, CZERO,
     $                            WORK( IU+1 ), LDWRKU )
*
*                    Generate Q in A
*                    (CWorkspace: need 2*N*N+2*N, prefer 2*N*N+N+N*NB)
*                    (RWorkspace: 0)
*
                     CALL ZUNGQR( M, N, N, A, LDA, WORK( ITAU ),
     $                            WORK( IWORK ), LWORK-IWORK+1, IERR )
                     IE = 1
                     ITAUQ = ITAU
                     ITAUP = ITAUQ + N
                     IWORK = ITAUP + N
*
*                    Bidiagonalize R in WORK(IU), copying result to
*                    WORK(IR)
*                    (CWorkspace: need   2*N*N+3*N,
*                                 prefer 2*N*N+2*N+2*N*NB)
*                    (RWorkspace: need   N)
*
                     CALL ZGEBRD( N, N, WORK( IU ), LDWRKU, S,
     $                            RWORK( IE ), WORK( ITAUQ ),
     $                            WORK( ITAUP ), WORK( IWORK ),
     $                            LWORK-IWORK+1, IERR )
                     CALL ZLACPY( 'U', N, N, WORK( IU ), LDWRKU,
     $                            WORK( IR ), LDWRKR )
*
*                    Generate left bidiagonalizing vectors in WORK(IU)
*                    (CWorkspace: need 2*N*N+3*N, prefer 2*N*N+2*N+N*NB)
*                    (RWorkspace: 0)
*
                     CALL ZUNGBR( 'Q', N, N, N, WORK( IU ), LDWRKU,
     $                            WORK( ITAUQ ), WORK( IWORK ),
     $                            LWORK-IWORK+1, IERR )
*
*                    Generate right bidiagonalizing vectors in WORK(IR)
*                    (CWorkspace: need   2*N*N+3*N-1,
*                                 prefer 2*N*N+2*N+(N-1)*NB)
*                    (RWorkspace: 0)
*
                     CALL ZUNGBR( 'P', N, N, N, WORK( IR ), LDWRKR,
     $                            WORK( ITAUP ), WORK( IWORK ),
     $                            LWORK-IWORK+1, IERR )
                     IRWORK = IE + N
*
*                    Perform bidiagonal QR iteration, computing left
*                    singular vectors of R in WORK(IU) and computing
*                    right singular vectors of R in WORK(IR)
*                    (CWorkspace: need 2*N*N)
*                    (RWorkspace: need BDSPAC)
*
                     CALL ZBDSQR( 'U', N, N, N, 0, S, RWORK( IE ),
     $                            WORK( IR ), LDWRKR, WORK( IU ),
     $                            LDWRKU, CDUM, 1, RWORK( IRWORK ),
     $                            INFO )
*
*                    Multiply Q in A by left singular vectors of R in
*                    WORK(IU), storing result in U
*                    (CWorkspace: need N*N)
*                    (RWorkspace: 0)
*
                     CALL ZGEMM( 'N', 'N', M, N, N, CONE, A, LDA,
     $                           WORK( IU ), LDWRKU, CZERO, U, LDU )
*
*                    Copy right singular vectors of R to A
*                    (CWorkspace: need N*N)
*                    (RWorkspace: 0)
*
                     CALL ZLACPY( 'F', N, N, WORK( IR ), LDWRKR, A,
     $                            LDA )
*
                  ELSE
*
*                    Insufficient workspace for a fast algorithm
*
                     ITAU = 1
                     IWORK = ITAU + N
*
*                    Compute A=Q*R, copying result to U
*                    (CWorkspace: need 2*N, prefer N+N*NB)
*                    (RWorkspace: 0)
*
                     CALL ZGEQRF( M, N, A, LDA, WORK( ITAU ),
     $                            WORK( IWORK ), LWORK-IWORK+1, IERR )
                     CALL ZLACPY( 'L', M, N, A, LDA, U, LDU )
*
*                    Generate Q in U
*                    (CWorkspace: need 2*N, prefer N+N*NB)
*                    (RWorkspace: 0)
*
                     CALL ZUNGQR( M, N, N, U, LDU, WORK( ITAU ),
     $                            WORK( IWORK ), LWORK-IWORK+1, IERR )
                     IE = 1
                     ITAUQ = ITAU
                     ITAUP = ITAUQ + N
                     IWORK = ITAUP + N
*
*                    Zero out below R in A
*
                     CALL ZLASET( 'L', N-1, N-1, CZERO, CZERO,
     $                            A( 2, 1 ), LDA )
*
*                    Bidiagonalize R in A
*                    (CWorkspace: need 3*N, prefer 2*N+2*N*NB)
*                    (RWorkspace: need N)
*
                     CALL ZGEBRD( N, N, A, LDA, S, RWORK( IE ),
     $                            WORK( ITAUQ ), WORK( ITAUP ),
     $                            WORK( IWORK ), LWORK-IWORK+1, IERR )
*
*                    Multiply Q in U by left vectors bidiagonalizing R
*                    (CWorkspace: need 2*N+M, prefer 2*N+M*NB)
*                    (RWorkspace: 0)
*
                     CALL ZUNMBR( 'Q', 'R', 'N', M, N, N, A, LDA,
     $                            WORK( ITAUQ ), U, LDU, WORK( IWORK ),
     $                            LWORK-IWORK+1, IERR )
*
*                    Generate right vectors bidiagonalizing R in A
*                    (CWorkspace: need 3*N-1, prefer 2*N+(N-1)*NB)
*                    (RWorkspace: 0)
*
                     CALL ZUNGBR( 'P', N, N, N, A, LDA, WORK( ITAUP ),
     $                            WORK( IWORK ), LWORK-IWORK+1, IERR )
                     IRWORK = IE + N
*
*                    Perform bidiagonal QR iteration, computing left
*                    singular vectors of A in U and computing right
*                    singular vectors of A in A
*                    (CWorkspace: 0)
*                    (RWorkspace: need BDSPAC)
*
                     CALL ZBDSQR( 'U', N, N, M, 0, S, RWORK( IE ), A,
     $                            LDA, U, LDU, CDUM, 1, RWORK( IRWORK ),
     $                            INFO )
*
                  END IF
*
               ELSE IF( WNTVAS ) THEN
*
*                 Path 6 (M much larger than N, JOBU='S', JOBVT='S'
*                         or 'A')
*                 N left singular vectors to be computed in U and
*                 N right singular vectors to be computed in VT
*
                  IF( LWORK.GE.N*N+3*N ) THEN
*
*                    Sufficient workspace for a fast algorithm
*
                     IU = 1
                     IF( LWORK.GE.WRKBL+LDA*N ) THEN
*
*                       WORK(IU) is LDA by N
*
                        LDWRKU = LDA
                     ELSE
*
*                       WORK(IU) is N by N
*
                        LDWRKU = N
                     END IF
                     ITAU = IU + LDWRKU*N
                     IWORK = ITAU + N
*
*                    Compute A=Q*R
*                    (CWorkspace: need N*N+2*N, prefer N*N+N+N*NB)
*                    (RWorkspace: 0)
*
                     CALL ZGEQRF( M, N, A, LDA, WORK( ITAU ),
     $                            WORK( IWORK ), LWORK-IWORK+1, IERR )
*
*                    Copy R to WORK(IU), zeroing out below it
*
                     CALL ZLACPY( 'U', N, N, A, LDA, WORK( IU ),
     $                            LDWRKU )
                     CALL ZLASET( 'L', N-1, N-1, CZERO, CZERO,
     $                            WORK( IU+1 ), LDWRKU )
*
*                    Generate Q in A
*                    (CWorkspace: need N*N+2*N, prefer N*N+N+N*NB)
*                    (RWorkspace: 0)
*
                     CALL ZUNGQR( M, N, N, A, LDA, WORK( ITAU ),
     $                            WORK( IWORK ), LWORK-IWORK+1, IERR )
                     IE = 1
                     ITAUQ = ITAU
                     ITAUP = ITAUQ + N
                     IWORK = ITAUP + N
*
*                    Bidiagonalize R in WORK(IU), copying result to VT
*                    (CWorkspace: need N*N+3*N, prefer N*N+2*N+2*N*NB)
*                    (RWorkspace: need N)
*
                     CALL ZGEBRD( N, N, WORK( IU ), LDWRKU, S,
     $                            RWORK( IE ), WORK( ITAUQ ),
     $                            WORK( ITAUP ), WORK( IWORK ),
     $                            LWORK-IWORK+1, IERR )
                     CALL ZLACPY( 'U', N, N, WORK( IU ), LDWRKU, VT,
     $                            LDVT )
*
*                    Generate left bidiagonalizing vectors in WORK(IU)
*                    (CWorkspace: need N*N+3*N, prefer N*N+2*N+N*NB)
*                    (RWorkspace: 0)
*
                     CALL ZUNGBR( 'Q', N, N, N, WORK( IU ), LDWRKU,
     $                            WORK( ITAUQ ), WORK( IWORK ),
     $                            LWORK-IWORK+1, IERR )
*
*                    Generate right bidiagonalizing vectors in VT
*                    (CWorkspace: need   N*N+3*N-1,
*                                 prefer N*N+2*N+(N-1)*NB)
*                    (RWorkspace: 0)
*
                     CALL ZUNGBR( 'P', N, N, N, VT, LDVT, WORK( ITAUP ),
     $                            WORK( IWORK ), LWORK-IWORK+1, IERR )
                     IRWORK = IE + N
*
*                    Perform bidiagonal QR iteration, computing left
*                    singular vectors of R in WORK(IU) and computing
*                    right singular vectors of R in VT
*                    (CWorkspace: need N*N)
*                    (RWorkspace: need BDSPAC)
*
                     CALL ZBDSQR( 'U', N, N, N, 0, S, RWORK( IE ), VT,
     $                            LDVT, WORK( IU ), LDWRKU, CDUM, 1,
     $                            RWORK( IRWORK ), INFO )
*
*                    Multiply Q in A by left singular vectors of R in
*                    WORK(IU), storing result in U
*                    (CWorkspace: need N*N)
*                    (RWorkspace: 0)
*
                     CALL ZGEMM( 'N', 'N', M, N, N, CONE, A, LDA,
     $                           WORK( IU ), LDWRKU, CZERO, U, LDU )
*
                  ELSE
*
*                    Insufficient workspace for a fast algorithm
*
                     ITAU = 1
                     IWORK = ITAU + N
*
*                    Compute A=Q*R, copying result to U
*                    (CWorkspace: need 2*N, prefer N+N*NB)
*                    (RWorkspace: 0)
*
                     CALL ZGEQRF( M, N, A, LDA, WORK( ITAU ),
     $                            WORK( IWORK ), LWORK-IWORK+1, IERR )
                     CALL ZLACPY( 'L', M, N, A, LDA, U, LDU )
*
*                    Generate Q in U
*                    (CWorkspace: need 2*N, prefer N+N*NB)
*                    (RWorkspace: 0)
*
                     CALL ZUNGQR( M, N, N, U, LDU, WORK( ITAU ),
     $                            WORK( IWORK ), LWORK-IWORK+1, IERR )
*
*                    Copy R to VT, zeroing out below it
*
                     CALL ZLACPY( 'U', N, N, A, LDA, VT, LDVT )
                     CALL ZLASET( 'L', N-1, N-1, CZERO, CZERO,
     $                            VT( 2, 1 ), LDVT )
                     IE = 1
                     ITAUQ = ITAU
                     ITAUP = ITAUQ + N
                     IWORK = ITAUP + N
*
*                    Bidiagonalize R in VT
*                    (CWorkspace: need 3*N, prefer 2*N+2*N*NB)
*                    (RWorkspace: need N)
*
                     CALL ZGEBRD( N, N, VT, LDVT, S, RWORK( IE ),
     $                            WORK( ITAUQ ), WORK( ITAUP ),
     $                            WORK( IWORK ), LWORK-IWORK+1, IERR )
*
*                    Multiply Q in U by left bidiagonalizing vectors
*                    in VT
*                    (CWorkspace: need 2*N+M, prefer 2*N+M*NB)
*                    (RWorkspace: 0)
*
                     CALL ZUNMBR( 'Q', 'R', 'N', M, N, N, VT, LDVT,
     $                            WORK( ITAUQ ), U, LDU, WORK( IWORK ),
     $                            LWORK-IWORK+1, IERR )
*
*                    Generate right bidiagonalizing vectors in VT
*                    (CWorkspace: need 3*N-1, prefer 2*N+(N-1)*NB)
*                    (RWorkspace: 0)
*
                     CALL ZUNGBR( 'P', N, N, N, VT, LDVT, WORK( ITAUP ),
     $                            WORK( IWORK ), LWORK-IWORK+1, IERR )
                     IRWORK = IE + N
*
*                    Perform bidiagonal QR iteration, computing left
*                    singular vectors of A in U and computing right
*                    singular vectors of A in VT
*                    (CWorkspace: 0)
*                    (RWorkspace: need BDSPAC)
*
                     CALL ZBDSQR( 'U', N, N, M, 0, S, RWORK( IE ), VT,
     $                            LDVT, U, LDU, CDUM, 1,
     $                            RWORK( IRWORK ), INFO )
*
                  END IF
*
               END IF
*
            ELSE IF( WNTUA ) THEN
*
               IF( WNTVN ) THEN
*
*                 Path 7 (M much larger than N, JOBU='A', JOBVT='N')
*                 M left singular vectors to be computed in U and
*                 no right singular vectors to be computed
*
                  IF( LWORK.GE.N*N+MAX( N+M, 3*N ) ) THEN
*
*                    Sufficient workspace for a fast algorithm
*
                     IR = 1
                     IF( LWORK.GE.WRKBL+LDA*N ) THEN
*
*                       WORK(IR) is LDA by N
*
                        LDWRKR = LDA
                     ELSE
*
*                       WORK(IR) is N by N
*
                        LDWRKR = N
                     END IF
                     ITAU = IR + LDWRKR*N
                     IWORK = ITAU + N
*
*                    Compute A=Q*R, copying result to U
*                    (CWorkspace: need N*N+2*N, prefer N*N+N+N*NB)
*                    (RWorkspace: 0)
*
                     CALL ZGEQRF( M, N, A, LDA, WORK( ITAU ),
     $                            WORK( IWORK ), LWORK-IWORK+1, IERR )
                     CALL ZLACPY( 'L', M, N, A, LDA, U, LDU )
*
*                    Copy R to WORK(IR), zeroing out below it
*
                     CALL ZLACPY( 'U', N, N, A, LDA, WORK( IR ),
     $                            LDWRKR )
                     CALL ZLASET( 'L', N-1, N-1, CZERO, CZERO,
     $                            WORK( IR+1 ), LDWRKR )
*
*                    Generate Q in U
*                    (CWorkspace: need N*N+N+M, prefer N*N+N+M*NB)
*                    (RWorkspace: 0)
*
                     CALL ZUNGQR( M, M, N, U, LDU, WORK( ITAU ),
     $                            WORK( IWORK ), LWORK-IWORK+1, IERR )
                     IE = 1
                     ITAUQ = ITAU
                     ITAUP = ITAUQ + N
                     IWORK = ITAUP + N
*
*                    Bidiagonalize R in WORK(IR)
*                    (CWorkspace: need N*N+3*N, prefer N*N+2*N+2*N*NB)
*                    (RWorkspace: need N)
*
                     CALL ZGEBRD( N, N, WORK( IR ), LDWRKR, S,
     $                            RWORK( IE ), WORK( ITAUQ ),
     $                            WORK( ITAUP ), WORK( IWORK ),
     $                            LWORK-IWORK+1, IERR )
*
*                    Generate left bidiagonalizing vectors in WORK(IR)
*                    (CWorkspace: need N*N+3*N, prefer N*N+2*N+N*NB)
*                    (RWorkspace: 0)
*
                     CALL ZUNGBR( 'Q', N, N, N, WORK( IR ), LDWRKR,
     $                            WORK( ITAUQ ), WORK( IWORK ),
     $                            LWORK-IWORK+1, IERR )
                     IRWORK = IE + N
*
*                    Perform bidiagonal QR iteration, computing left
*                    singular vectors of R in WORK(IR)
*                    (CWorkspace: need N*N)
*                    (RWorkspace: need BDSPAC)
*
                     CALL ZBDSQR( 'U', N, 0, N, 0, S, RWORK( IE ), CDUM,
     $                            1, WORK( IR ), LDWRKR, CDUM, 1,
     $                            RWORK( IRWORK ), INFO )
*
*                    Multiply Q in U by left singular vectors of R in
*                    WORK(IR), storing result in A
*                    (CWorkspace: need N*N)
*                    (RWorkspace: 0)
*
                     CALL ZGEMM( 'N', 'N', M, N, N, CONE, U, LDU,
     $                           WORK( IR ), LDWRKR, CZERO, A, LDA )
*
*                    Copy left singular vectors of A from A to U
*
                     CALL ZLACPY( 'F', M, N, A, LDA, U, LDU )
*
                  ELSE
*
*                    Insufficient workspace for a fast algorithm
*
                     ITAU = 1
                     IWORK = ITAU + N
*
*                    Compute A=Q*R, copying result to U
*                    (CWorkspace: need 2*N, prefer N+N*NB)
*                    (RWorkspace: 0)
*
                     CALL ZGEQRF( M, N, A, LDA, WORK( ITAU ),
     $                            WORK( IWORK ), LWORK-IWORK+1, IERR )
                     CALL ZLACPY( 'L', M, N, A, LDA, U, LDU )
*
*                    Generate Q in U
*                    (CWorkspace: need N+M, prefer N+M*NB)
*                    (RWorkspace: 0)
*
                     CALL ZUNGQR( M, M, N, U, LDU, WORK( ITAU ),
     $                            WORK( IWORK ), LWORK-IWORK+1, IERR )
                     IE = 1
                     ITAUQ = ITAU
                     ITAUP = ITAUQ + N
                     IWORK = ITAUP + N
*
*                    Zero out below R in A
*
                     CALL ZLASET( 'L', N-1, N-1, CZERO, CZERO,
     $                            A( 2, 1 ), LDA )
*
*                    Bidiagonalize R in A
*                    (CWorkspace: need 3*N, prefer 2*N+2*N*NB)
*                    (RWorkspace: need N)
*
                     CALL ZGEBRD( N, N, A, LDA, S, RWORK( IE ),
     $                            WORK( ITAUQ ), WORK( ITAUP ),
     $                            WORK( IWORK ), LWORK-IWORK+1, IERR )
*
*                    Multiply Q in U by left bidiagonalizing vectors
*                    in A
*                    (CWorkspace: need 2*N+M, prefer 2*N+M*NB)
*                    (RWorkspace: 0)
*
                     CALL ZUNMBR( 'Q', 'R', 'N', M, N, N, A, LDA,
     $                            WORK( ITAUQ ), U, LDU, WORK( IWORK ),
     $                            LWORK-IWORK+1, IERR )
                     IRWORK = IE + N
*
*                    Perform bidiagonal QR iteration, computing left
*                    singular vectors of A in U
*                    (CWorkspace: 0)
*                    (RWorkspace: need BDSPAC)
*
                     CALL ZBDSQR( 'U', N, 0, M, 0, S, RWORK( IE ), CDUM,
     $                            1, U, LDU, CDUM, 1, RWORK( IRWORK ),
     $                            INFO )
*
                  END IF
*
               ELSE IF( WNTVO ) THEN
*
*                 Path 8 (M much larger than N, JOBU='A', JOBVT='O')
*                 M left singular vectors to be computed in U and
*                 N right singular vectors to be overwritten on A
*
                  IF( LWORK.GE.2*N*N+MAX( N+M, 3*N ) ) THEN
*
*                    Sufficient workspace for a fast algorithm
*
                     IU = 1
                     IF( LWORK.GE.WRKBL+2*LDA*N ) THEN
*
*                       WORK(IU) is LDA by N and WORK(IR) is LDA by N
*
                        LDWRKU = LDA
                        IR = IU + LDWRKU*N
                        LDWRKR = LDA
                     ELSE IF( LWORK.GE.WRKBL+( LDA+N )*N ) THEN
*
*                       WORK(IU) is LDA by N and WORK(IR) is N by N
*
                        LDWRKU = LDA
                        IR = IU + LDWRKU*N
                        LDWRKR = N
                     ELSE
*
*                       WORK(IU) is N by N and WORK(IR) is N by N
*
                        LDWRKU = N
                        IR = IU + LDWRKU*N
                        LDWRKR = N
                     END IF
                     ITAU = IR + LDWRKR*N
                     IWORK = ITAU + N
*
*                    Compute A=Q*R, copying result to U
*                    (CWorkspace: need 2*N*N+2*N, prefer 2*N*N+N+N*NB)
*                    (RWorkspace: 0)
*
                     CALL ZGEQRF( M, N, A, LDA, WORK( ITAU ),
     $                            WORK( IWORK ), LWORK-IWORK+1, IERR )
                     CALL ZLACPY( 'L', M, N, A, LDA, U, LDU )
*
*                    Generate Q in U
*                    (CWorkspace: need 2*N*N+N+M, prefer 2*N*N+N+M*NB)
*                    (RWorkspace: 0)
*
                     CALL ZUNGQR( M, M, N, U, LDU, WORK( ITAU ),
     $                            WORK( IWORK ), LWORK-IWORK+1, IERR )
*
*                    Copy R to WORK(IU), zeroing out below it
*
                     CALL ZLACPY( 'U', N, N, A, LDA, WORK( IU ),
     $                            LDWRKU )
                     CALL ZLASET( 'L', N-1, N-1, CZERO, CZERO,
     $                            WORK( IU+1 ), LDWRKU )
                     IE = 1
                     ITAUQ = ITAU
                     ITAUP = ITAUQ + N
                     IWORK = ITAUP + N
*
*                    Bidiagonalize R in WORK(IU), copying result to
*                    WORK(IR)
*                    (CWorkspace: need   2*N*N+3*N,
*                                 prefer 2*N*N+2*N+2*N*NB)
*                    (RWorkspace: need   N)
*
                     CALL ZGEBRD( N, N, WORK( IU ), LDWRKU, S,
     $                            RWORK( IE ), WORK( ITAUQ ),
     $                            WORK( ITAUP ), WORK( IWORK ),
     $                            LWORK-IWORK+1, IERR )
                     CALL ZLACPY( 'U', N, N, WORK( IU ), LDWRKU,
     $                            WORK( IR ), LDWRKR )
*
*                    Generate left bidiagonalizing vectors in WORK(IU)
*                    (CWorkspace: need 2*N*N+3*N, prefer 2*N*N+2*N+N*NB)
*                    (RWorkspace: 0)
*
                     CALL ZUNGBR( 'Q', N, N, N, WORK( IU ), LDWRKU,
     $                            WORK( ITAUQ ), WORK( IWORK ),
     $                            LWORK-IWORK+1, IERR )
*
*                    Generate right bidiagonalizing vectors in WORK(IR)
*                    (CWorkspace: need   2*N*N+3*N-1,
*                                 prefer 2*N*N+2*N+(N-1)*NB)
*                    (RWorkspace: 0)
*
                     CALL ZUNGBR( 'P', N, N, N, WORK( IR ), LDWRKR,
     $                            WORK( ITAUP ), WORK( IWORK ),
     $                            LWORK-IWORK+1, IERR )
                     IRWORK = IE + N
*
*                    Perform bidiagonal QR iteration, computing left
*                    singular vectors of R in WORK(IU) and computing
*                    right singular vectors of R in WORK(IR)
*                    (CWorkspace: need 2*N*N)
*                    (RWorkspace: need BDSPAC)
*
                     CALL ZBDSQR( 'U', N, N, N, 0, S, RWORK( IE ),
     $                            WORK( IR ), LDWRKR, WORK( IU ),
     $                            LDWRKU, CDUM, 1, RWORK( IRWORK ),
     $                            INFO )
*
*                    Multiply Q in U by left singular vectors of R in
*                    WORK(IU), storing result in A
*                    (CWorkspace: need N*N)
*                    (RWorkspace: 0)
*
                     CALL ZGEMM( 'N', 'N', M, N, N, CONE, U, LDU,
     $                           WORK( IU ), LDWRKU, CZERO, A, LDA )
*
*                    Copy left singular vectors of A from A to U
*
                     CALL ZLACPY( 'F', M, N, A, LDA, U, LDU )
*
*                    Copy right singular vectors of R from WORK(IR) to A
*
                     CALL ZLACPY( 'F', N, N, WORK( IR ), LDWRKR, A,
     $                            LDA )
*
                  ELSE
*
*                    Insufficient workspace for a fast algorithm
*
                     ITAU = 1
                     IWORK = ITAU + N
*
*                    Compute A=Q*R, copying result to U
*                    (CWorkspace: need 2*N, prefer N+N*NB)
*                    (RWorkspace: 0)
*
                     CALL ZGEQRF( M, N, A, LDA, WORK( ITAU ),
     $                            WORK( IWORK ), LWORK-IWORK+1, IERR )
                     CALL ZLACPY( 'L', M, N, A, LDA, U, LDU )
*
*                    Generate Q in U
*                    (CWorkspace: need N+M, prefer N+M*NB)
*                    (RWorkspace: 0)
*
                     CALL ZUNGQR( M, M, N, U, LDU, WORK( ITAU ),
     $                            WORK( IWORK ), LWORK-IWORK+1, IERR )
                     IE = 1
                     ITAUQ = ITAU
                     ITAUP = ITAUQ + N
                     IWORK = ITAUP + N
*
*                    Zero out below R in A
*
                     CALL ZLASET( 'L', N-1, N-1, CZERO, CZERO,
     $                            A( 2, 1 ), LDA )
*
*                    Bidiagonalize R in A
*                    (CWorkspace: need 3*N, prefer 2*N+2*N*NB)
*                    (RWorkspace: need N)
*
                     CALL ZGEBRD( N, N, A, LDA, S, RWORK( IE ),
     $                            WORK( ITAUQ ), WORK( ITAUP ),
     $                            WORK( IWORK ), LWORK-IWORK+1, IERR )
*
*                    Multiply Q in U by left bidiagonalizing vectors
*                    in A
*                    (CWorkspace: need 2*N+M, prefer 2*N+M*NB)
*                    (RWorkspace: 0)
*
                     CALL ZUNMBR( 'Q', 'R', 'N', M, N, N, A, LDA,
     $                            WORK( ITAUQ ), U, LDU, WORK( IWORK ),
     $                            LWORK-IWORK+1, IERR )
*
*                    Generate right bidiagonalizing vectors in A
*                    (CWorkspace: need 3*N-1, prefer 2*N+(N-1)*NB)
*                    (RWorkspace: 0)
*
                     CALL ZUNGBR( 'P', N, N, N, A, LDA, WORK( ITAUP ),
     $                            WORK( IWORK ), LWORK-IWORK+1, IERR )
                     IRWORK = IE + N
*
*                    Perform bidiagonal QR iteration, computing left
*                    singular vectors of A in U and computing right
*                    singular vectors of A in A
*                    (CWorkspace: 0)
*                    (RWorkspace: need BDSPAC)
*
                     CALL ZBDSQR( 'U', N, N, M, 0, S, RWORK( IE ), A,
     $                            LDA, U, LDU, CDUM, 1, RWORK( IRWORK ),
     $                            INFO )
*
                  END IF
*
               ELSE IF( WNTVAS ) THEN
*
*                 Path 9 (M much larger than N, JOBU='A', JOBVT='S'
*                         or 'A')
*                 M left singular vectors to be computed in U and
*                 N right singular vectors to be computed in VT
*
                  IF( LWORK.GE.N*N+MAX( N+M, 3*N ) ) THEN
*
*                    Sufficient workspace for a fast algorithm
*
                     IU = 1
                     IF( LWORK.GE.WRKBL+LDA*N ) THEN
*
*                       WORK(IU) is LDA by N
*
                        LDWRKU = LDA
                     ELSE
*
*                       WORK(IU) is N by N
*
                        LDWRKU = N
                     END IF
                     ITAU = IU + LDWRKU*N
                     IWORK = ITAU + N
*
*                    Compute A=Q*R, copying result to U
*                    (CWorkspace: need N*N+2*N, prefer N*N+N+N*NB)
*                    (RWorkspace: 0)
*
                     CALL ZGEQRF( M, N, A, LDA, WORK( ITAU ),
     $                            WORK( IWORK ), LWORK-IWORK+1, IERR )
                     CALL ZLACPY( 'L', M, N, A, LDA, U, LDU )
*
*                    Generate Q in U
*                    (CWorkspace: need N*N+N+M, prefer N*N+N+M*NB)
*                    (RWorkspace: 0)
*
                     CALL ZUNGQR( M, M, N, U, LDU, WORK( ITAU ),
     $                            WORK( IWORK ), LWORK-IWORK+1, IERR )
*
*                    Copy R to WORK(IU), zeroing out below it
*
                     CALL ZLACPY( 'U', N, N, A, LDA, WORK( IU ),
     $                            LDWRKU )
                     CALL ZLASET( 'L', N-1, N-1, CZERO, CZERO,
     $                            WORK( IU+1 ), LDWRKU )
                     IE = 1
                     ITAUQ = ITAU
                     ITAUP = ITAUQ + N
                     IWORK = ITAUP + N
*
*                    Bidiagonalize R in WORK(IU), copying result to VT
*                    (CWorkspace: need N*N+3*N, prefer N*N+2*N+2*N*NB)
*                    (RWorkspace: need N)
*
                     CALL ZGEBRD( N, N, WORK( IU ), LDWRKU, S,
     $                            RWORK( IE ), WORK( ITAUQ ),
     $                            WORK( ITAUP ), WORK( IWORK ),
     $                            LWORK-IWORK+1, IERR )
                     CALL ZLACPY( 'U', N, N, WORK( IU ), LDWRKU, VT,
     $                            LDVT )
*
*                    Generate left bidiagonalizing vectors in WORK(IU)
*                    (CWorkspace: need N*N+3*N, prefer N*N+2*N+N*NB)
*                    (RWorkspace: 0)
*
                     CALL ZUNGBR( 'Q', N, N, N, WORK( IU ), LDWRKU,
     $                            WORK( ITAUQ ), WORK( IWORK ),
     $                            LWORK-IWORK+1, IERR )
*
*                    Generate right bidiagonalizing vectors in VT
*                    (CWorkspace: need   N*N+3*N-1,
*                                 prefer N*N+2*N+(N-1)*NB)
*                    (RWorkspace: need   0)
*
                     CALL ZUNGBR( 'P', N, N, N, VT, LDVT, WORK( ITAUP ),
     $                            WORK( IWORK ), LWORK-IWORK+1, IERR )
                     IRWORK = IE + N
*
*                    Perform bidiagonal QR iteration, computing left
*                    singular vectors of R in WORK(IU) and computing
*                    right singular vectors of R in VT
*                    (CWorkspace: need N*N)
*                    (RWorkspace: need BDSPAC)
*
                     CALL ZBDSQR( 'U', N, N, N, 0, S, RWORK( IE ), VT,
     $                            LDVT, WORK( IU ), LDWRKU, CDUM, 1,
     $                            RWORK( IRWORK ), INFO )
*
*                    Multiply Q in U by left singular vectors of R in
*                    WORK(IU), storing result in A
*                    (CWorkspace: need N*N)
*                    (RWorkspace: 0)
*
                     CALL ZGEMM( 'N', 'N', M, N, N, CONE, U, LDU,
     $                           WORK( IU ), LDWRKU, CZERO, A, LDA )
*
*                    Copy left singular vectors of A from A to U
*
                     CALL ZLACPY( 'F', M, N, A, LDA, U, LDU )
*
                  ELSE
*
*                    Insufficient workspace for a fast algorithm
*
                     ITAU = 1
                     IWORK = ITAU + N
*
*                    Compute A=Q*R, copying result to U
*                    (CWorkspace: need 2*N, prefer N+N*NB)
*                    (RWorkspace: 0)
*
                     CALL ZGEQRF( M, N, A, LDA, WORK( ITAU ),
     $                            WORK( IWORK ), LWORK-IWORK+1, IERR )
                     CALL ZLACPY( 'L', M, N, A, LDA, U, LDU )
*
*                    Generate Q in U
*                    (CWorkspace: need N+M, prefer N+M*NB)
*                    (RWorkspace: 0)
*
                     CALL ZUNGQR( M, M, N, U, LDU, WORK( ITAU ),
     $                            WORK( IWORK ), LWORK-IWORK+1, IERR )
*
*                    Copy R from A to VT, zeroing out below it
*
                     CALL ZLACPY( 'U', N, N, A, LDA, VT, LDVT )
                     CALL ZLASET( 'L', N-1, N-1, CZERO, CZERO,
     $                            VT( 2, 1 ), LDVT )
                     IE = 1
                     ITAUQ = ITAU
                     ITAUP = ITAUQ + N
                     IWORK = ITAUP + N
*
*                    Bidiagonalize R in VT
*                    (CWorkspace: need 3*N, prefer 2*N+2*N*NB)
*                    (RWorkspace: need N)
*
                     CALL ZGEBRD( N, N, VT, LDVT, S, RWORK( IE ),
     $                            WORK( ITAUQ ), WORK( ITAUP ),
     $                            WORK( IWORK ), LWORK-IWORK+1, IERR )
*
*                    Multiply Q in U by left bidiagonalizing vectors
*                    in VT
*                    (CWorkspace: need 2*N+M, prefer 2*N+M*NB)
*                    (RWorkspace: 0)
*
                     CALL ZUNMBR( 'Q', 'R', 'N', M, N, N, VT, LDVT,
     $                            WORK( ITAUQ ), U, LDU, WORK( IWORK ),
     $                            LWORK-IWORK+1, IERR )
*
*                    Generate right bidiagonalizing vectors in VT
*                    (CWorkspace: need 3*N-1, prefer 2*N+(N-1)*NB)
*                    (RWorkspace: 0)
*
                     CALL ZUNGBR( 'P', N, N, N, VT, LDVT, WORK( ITAUP ),
     $                            WORK( IWORK ), LWORK-IWORK+1, IERR )
                     IRWORK = IE + N
*
*                    Perform bidiagonal QR iteration, computing left
*                    singular vectors of A in U and computing right
*                    singular vectors of A in VT
*                    (CWorkspace: 0)
*                    (RWorkspace: need BDSPAC)
*
                     CALL ZBDSQR( 'U', N, N, M, 0, S, RWORK( IE ), VT,
     $                            LDVT, U, LDU, CDUM, 1,
     $                            RWORK( IRWORK ), INFO )
*
                  END IF
*
               END IF
*
            END IF
*
         ELSE
*
*           M .LT. MNTHR
*
*           Path 10 (M at least N, but not much larger)
*           Reduce to bidiagonal form without QR decomposition
*
            IE = 1
            ITAUQ = 1
            ITAUP = ITAUQ + N
            IWORK = ITAUP + N
*
*           Bidiagonalize A
*           (CWorkspace: need 2*N+M, prefer 2*N+(M+N)*NB)
*           (RWorkspace: need N)
*
            CALL ZGEBRD( M, N, A, LDA, S, RWORK( IE ), WORK( ITAUQ ),
     $                   WORK( ITAUP ), WORK( IWORK ), LWORK-IWORK+1,
     $                   IERR )
            IF( WNTUAS ) THEN
*
*              If left singular vectors desired in U, copy result to U
*              and generate left bidiagonalizing vectors in U
*              (CWorkspace: need 2*N+NCU, prefer 2*N+NCU*NB)
*              (RWorkspace: 0)
*
               CALL ZLACPY( 'L', M, N, A, LDA, U, LDU )
               IF( WNTUS )
     $            NCU = N
               IF( WNTUA )
     $            NCU = M
               CALL ZUNGBR( 'Q', M, NCU, N, U, LDU, WORK( ITAUQ ),
     $                      WORK( IWORK ), LWORK-IWORK+1, IERR )
            END IF
            IF( WNTVAS ) THEN
*
*              If right singular vectors desired in VT, copy result to
*              VT and generate right bidiagonalizing vectors in VT
*              (CWorkspace: need 3*N-1, prefer 2*N+(N-1)*NB)
*              (RWorkspace: 0)
*
               CALL ZLACPY( 'U', N, N, A, LDA, VT, LDVT )
               CALL ZUNGBR( 'P', N, N, N, VT, LDVT, WORK( ITAUP ),
     $                      WORK( IWORK ), LWORK-IWORK+1, IERR )
            END IF
            IF( WNTUO ) THEN
*
*              If left singular vectors desired in A, generate left
*              bidiagonalizing vectors in A
*              (CWorkspace: need 3*N, prefer 2*N+N*NB)
*              (RWorkspace: 0)
*
               CALL ZUNGBR( 'Q', M, N, N, A, LDA, WORK( ITAUQ ),
     $                      WORK( IWORK ), LWORK-IWORK+1, IERR )
            END IF
            IF( WNTVO ) THEN
*
*              If right singular vectors desired in A, generate right
*              bidiagonalizing vectors in A
*              (CWorkspace: need 3*N-1, prefer 2*N+(N-1)*NB)
*              (RWorkspace: 0)
*
               CALL ZUNGBR( 'P', N, N, N, A, LDA, WORK( ITAUP ),
     $                      WORK( IWORK ), LWORK-IWORK+1, IERR )
            END IF
            IRWORK = IE + N
            IF( WNTUAS .OR. WNTUO )
     $         NRU = M
            IF( WNTUN )
     $         NRU = 0
            IF( WNTVAS .OR. WNTVO )
     $         NCVT = N
            IF( WNTVN )
     $         NCVT = 0
            IF( ( .NOT.WNTUO ) .AND. ( .NOT.WNTVO ) ) THEN
*
*              Perform bidiagonal QR iteration, if desired, computing
*              left singular vectors in U and computing right singular
*              vectors in VT
*              (CWorkspace: 0)
*              (RWorkspace: need BDSPAC)
*
               CALL ZBDSQR( 'U', N, NCVT, NRU, 0, S, RWORK( IE ), VT,
     $                      LDVT, U, LDU, CDUM, 1, RWORK( IRWORK ),
     $                      INFO )
            ELSE IF( ( .NOT.WNTUO ) .AND. WNTVO ) THEN
*
*              Perform bidiagonal QR iteration, if desired, computing
*              left singular vectors in U and computing right singular
*              vectors in A
*              (CWorkspace: 0)
*              (RWorkspace: need BDSPAC)
*
               CALL ZBDSQR( 'U', N, NCVT, NRU, 0, S, RWORK( IE ), A,
     $                      LDA, U, LDU, CDUM, 1, RWORK( IRWORK ),
     $                      INFO )
            ELSE
*
*              Perform bidiagonal QR iteration, if desired, computing
*              left singular vectors in A and computing right singular
*              vectors in VT
*              (CWorkspace: 0)
*              (RWorkspace: need BDSPAC)
*
               CALL ZBDSQR( 'U', N, NCVT, NRU, 0, S, RWORK( IE ), VT,
     $                      LDVT, A, LDA, CDUM, 1, RWORK( IRWORK ),
     $                      INFO )
            END IF
*
         END IF
*
      ELSE
*
*        A has more columns than rows. If A has sufficiently more
*        columns than rows, first reduce using the LQ decomposition (if
*        sufficient workspace available)
*
         IF( N.GE.MNTHR ) THEN
*
            IF( WNTVN ) THEN
*
*              Path 1t(N much larger than M, JOBVT='N')
*              No right singular vectors to be computed
*
               ITAU = 1
               IWORK = ITAU + M
*
*              Compute A=L*Q
*              (CWorkspace: need 2*M, prefer M+M*NB)
*              (RWorkspace: 0)
*
               CALL ZGELQF( M, N, A, LDA, WORK( ITAU ), WORK( IWORK ),
     $                      LWORK-IWORK+1, IERR )
*
*              Zero out above L
*
               CALL ZLASET( 'U', M-1, M-1, CZERO, CZERO, A( 1, 2 ),
     $                      LDA )
               IE = 1
               ITAUQ = 1
               ITAUP = ITAUQ + M
               IWORK = ITAUP + M
*
*              Bidiagonalize L in A
*              (CWorkspace: need 3*M, prefer 2*M+2*M*NB)
*              (RWorkspace: need M)
*
               CALL ZGEBRD( M, M, A, LDA, S, RWORK( IE ), WORK( ITAUQ ),
     $                      WORK( ITAUP ), WORK( IWORK ), LWORK-IWORK+1,
     $                      IERR )
               IF( WNTUO .OR. WNTUAS ) THEN
*
*                 If left singular vectors desired, generate Q
*                 (CWorkspace: need 3*M, prefer 2*M+M*NB)
*                 (RWorkspace: 0)
*
                  CALL ZUNGBR( 'Q', M, M, M, A, LDA, WORK( ITAUQ ),
     $                         WORK( IWORK ), LWORK-IWORK+1, IERR )
               END IF
               IRWORK = IE + M
               NRU = 0
               IF( WNTUO .OR. WNTUAS )
     $            NRU = M
*
*              Perform bidiagonal QR iteration, computing left singular
*              vectors of A in A if desired
*              (CWorkspace: 0)
*              (RWorkspace: need BDSPAC)
*
               CALL ZBDSQR( 'U', M, 0, NRU, 0, S, RWORK( IE ), CDUM, 1,
     $                      A, LDA, CDUM, 1, RWORK( IRWORK ), INFO )
*
*              If left singular vectors desired in U, copy them there
*
               IF( WNTUAS )
     $            CALL ZLACPY( 'F', M, M, A, LDA, U, LDU )
*
            ELSE IF( WNTVO .AND. WNTUN ) THEN
*
*              Path 2t(N much larger than M, JOBU='N', JOBVT='O')
*              M right singular vectors to be overwritten on A and
*              no left singular vectors to be computed
*
               IF( LWORK.GE.M*M+3*M ) THEN
*
*                 Sufficient workspace for a fast algorithm
*
                  IR = 1
                  IF( LWORK.GE.MAX( WRKBL, LDA*N )+LDA*M ) THEN
*
*                    WORK(IU) is LDA by N and WORK(IR) is LDA by M
*
                     LDWRKU = LDA
                     CHUNK = N
                     LDWRKR = LDA
                  ELSE IF( LWORK.GE.MAX( WRKBL, LDA*N )+M*M ) THEN
*
*                    WORK(IU) is LDA by N and WORK(IR) is M by M
*
                     LDWRKU = LDA
                     CHUNK = N
                     LDWRKR = M
                  ELSE
*
*                    WORK(IU) is M by CHUNK and WORK(IR) is M by M
*
                     LDWRKU = M
                     CHUNK = ( LWORK-M*M ) / M
                     LDWRKR = M
                  END IF
                  ITAU = IR + LDWRKR*M
                  IWORK = ITAU + M
*
*                 Compute A=L*Q
*                 (CWorkspace: need M*M+2*M, prefer M*M+M+M*NB)
*                 (RWorkspace: 0)
*
                  CALL ZGELQF( M, N, A, LDA, WORK( ITAU ),
     $                         WORK( IWORK ), LWORK-IWORK+1, IERR )
*
*                 Copy L to WORK(IR) and zero out above it
*
                  CALL ZLACPY( 'L', M, M, A, LDA, WORK( IR ), LDWRKR )
                  CALL ZLASET( 'U', M-1, M-1, CZERO, CZERO,
     $                         WORK( IR+LDWRKR ), LDWRKR )
*
*                 Generate Q in A
*                 (CWorkspace: need M*M+2*M, prefer M*M+M+M*NB)
*                 (RWorkspace: 0)
*
                  CALL ZUNGLQ( M, N, M, A, LDA, WORK( ITAU ),
     $                         WORK( IWORK ), LWORK-IWORK+1, IERR )
                  IE = 1
                  ITAUQ = ITAU
                  ITAUP = ITAUQ + M
                  IWORK = ITAUP + M
*
*                 Bidiagonalize L in WORK(IR)
*                 (CWorkspace: need M*M+3*M, prefer M*M+2*M+2*M*NB)
*                 (RWorkspace: need M)
*
                  CALL ZGEBRD( M, M, WORK( IR ), LDWRKR, S, RWORK( IE ),
     $                         WORK( ITAUQ ), WORK( ITAUP ),
     $                         WORK( IWORK ), LWORK-IWORK+1, IERR )
*
*                 Generate right vectors bidiagonalizing L
*                 (CWorkspace: need M*M+3*M-1, prefer M*M+2*M+(M-1)*NB)
*                 (RWorkspace: 0)
*
                  CALL ZUNGBR( 'P', M, M, M, WORK( IR ), LDWRKR,
     $                         WORK( ITAUP ), WORK( IWORK ),
     $                         LWORK-IWORK+1, IERR )
                  IRWORK = IE + M
*
*                 Perform bidiagonal QR iteration, computing right
*                 singular vectors of L in WORK(IR)
*                 (CWorkspace: need M*M)
*                 (RWorkspace: need BDSPAC)
*
                  CALL ZBDSQR( 'U', M, M, 0, 0, S, RWORK( IE ),
     $                         WORK( IR ), LDWRKR, CDUM, 1, CDUM, 1,
     $                         RWORK( IRWORK ), INFO )
                  IU = ITAUQ
*
*                 Multiply right singular vectors of L in WORK(IR) by Q
*                 in A, storing result in WORK(IU) and copying to A
*                 (CWorkspace: need M*M+M, prefer M*M+M*N)
*                 (RWorkspace: 0)
*
                  DO 30 I = 1, N, CHUNK
                     BLK = MIN( N-I+1, CHUNK )
                     CALL ZGEMM( 'N', 'N', M, BLK, M, CONE, WORK( IR ),
     $                           LDWRKR, A( 1, I ), LDA, CZERO,
     $                           WORK( IU ), LDWRKU )
                     CALL ZLACPY( 'F', M, BLK, WORK( IU ), LDWRKU,
     $                            A( 1, I ), LDA )
   30             CONTINUE
*
               ELSE
*
*                 Insufficient workspace for a fast algorithm
*
                  IE = 1
                  ITAUQ = 1
                  ITAUP = ITAUQ + M
                  IWORK = ITAUP + M
*
*                 Bidiagonalize A
*                 (CWorkspace: need 2*M+N, prefer 2*M+(M+N)*NB)
*                 (RWorkspace: need M)
*
                  CALL ZGEBRD( M, N, A, LDA, S, RWORK( IE ),
     $                         WORK( ITAUQ ), WORK( ITAUP ),
     $                         WORK( IWORK ), LWORK-IWORK+1, IERR )
*
*                 Generate right vectors bidiagonalizing A
*                 (CWorkspace: need 3*M, prefer 2*M+M*NB)
*                 (RWorkspace: 0)
*
                  CALL ZUNGBR( 'P', M, N, M, A, LDA, WORK( ITAUP ),
     $                         WORK( IWORK ), LWORK-IWORK+1, IERR )
                  IRWORK = IE + M
*
*                 Perform bidiagonal QR iteration, computing right
*                 singular vectors of A in A
*                 (CWorkspace: 0)
*                 (RWorkspace: need BDSPAC)
*
                  CALL ZBDSQR( 'L', M, N, 0, 0, S, RWORK( IE ), A, LDA,
     $                         CDUM, 1, CDUM, 1, RWORK( IRWORK ), INFO )
*
               END IF
*
            ELSE IF( WNTVO .AND. WNTUAS ) THEN
*
*              Path 3t(N much larger than M, JOBU='S' or 'A', JOBVT='O')
*              M right singular vectors to be overwritten on A and
*              M left singular vectors to be computed in U
*
               IF( LWORK.GE.M*M+3*M ) THEN
*
*                 Sufficient workspace for a fast algorithm
*
                  IR = 1
                  IF( LWORK.GE.MAX( WRKBL, LDA*N )+LDA*M ) THEN
*
*                    WORK(IU) is LDA by N and WORK(IR) is LDA by M
*
                     LDWRKU = LDA
                     CHUNK = N
                     LDWRKR = LDA
                  ELSE IF( LWORK.GE.MAX( WRKBL, LDA*N )+M*M ) THEN
*
*                    WORK(IU) is LDA by N and WORK(IR) is M by M
*
                     LDWRKU = LDA
                     CHUNK = N
                     LDWRKR = M
                  ELSE
*
*                    WORK(IU) is M by CHUNK and WORK(IR) is M by M
*
                     LDWRKU = M
                     CHUNK = ( LWORK-M*M ) / M
                     LDWRKR = M
                  END IF
                  ITAU = IR + LDWRKR*M
                  IWORK = ITAU + M
*
*                 Compute A=L*Q
*                 (CWorkspace: need M*M+2*M, prefer M*M+M+M*NB)
*                 (RWorkspace: 0)
*
                  CALL ZGELQF( M, N, A, LDA, WORK( ITAU ),
     $                         WORK( IWORK ), LWORK-IWORK+1, IERR )
*
*                 Copy L to U, zeroing about above it
*
                  CALL ZLACPY( 'L', M, M, A, LDA, U, LDU )
                  CALL ZLASET( 'U', M-1, M-1, CZERO, CZERO, U( 1, 2 ),
     $                         LDU )
*
*                 Generate Q in A
*                 (CWorkspace: need M*M+2*M, prefer M*M+M+M*NB)
*                 (RWorkspace: 0)
*
                  CALL ZUNGLQ( M, N, M, A, LDA, WORK( ITAU ),
     $                         WORK( IWORK ), LWORK-IWORK+1, IERR )
                  IE = 1
                  ITAUQ = ITAU
                  ITAUP = ITAUQ + M
                  IWORK = ITAUP + M
*
*                 Bidiagonalize L in U, copying result to WORK(IR)
*                 (CWorkspace: need M*M+3*M, prefer M*M+2*M+2*M*NB)
*                 (RWorkspace: need M)
*
                  CALL ZGEBRD( M, M, U, LDU, S, RWORK( IE ),
     $                         WORK( ITAUQ ), WORK( ITAUP ),
     $                         WORK( IWORK ), LWORK-IWORK+1, IERR )
                  CALL ZLACPY( 'U', M, M, U, LDU, WORK( IR ), LDWRKR )
*
*                 Generate right vectors bidiagonalizing L in WORK(IR)
*                 (CWorkspace: need M*M+3*M-1, prefer M*M+2*M+(M-1)*NB)
*                 (RWorkspace: 0)
*
                  CALL ZUNGBR( 'P', M, M, M, WORK( IR ), LDWRKR,
     $                         WORK( ITAUP ), WORK( IWORK ),
     $                         LWORK-IWORK+1, IERR )
*
*                 Generate left vectors bidiagonalizing L in U
*                 (CWorkspace: need M*M+3*M, prefer M*M+2*M+M*NB)
*                 (RWorkspace: 0)
*
                  CALL ZUNGBR( 'Q', M, M, M, U, LDU, WORK( ITAUQ ),
     $                         WORK( IWORK ), LWORK-IWORK+1, IERR )
                  IRWORK = IE + M
*
*                 Perform bidiagonal QR iteration, computing left
*                 singular vectors of L in U, and computing right
*                 singular vectors of L in WORK(IR)
*                 (CWorkspace: need M*M)
*                 (RWorkspace: need BDSPAC)
*
                  CALL ZBDSQR( 'U', M, M, M, 0, S, RWORK( IE ),
     $                         WORK( IR ), LDWRKR, U, LDU, CDUM, 1,
     $                         RWORK( IRWORK ), INFO )
                  IU = ITAUQ
*
*                 Multiply right singular vectors of L in WORK(IR) by Q
*                 in A, storing result in WORK(IU) and copying to A
*                 (CWorkspace: need M*M+M, prefer M*M+M*N))
*                 (RWorkspace: 0)
*
                  DO 40 I = 1, N, CHUNK
                     BLK = MIN( N-I+1, CHUNK )
                     CALL ZGEMM( 'N', 'N', M, BLK, M, CONE, WORK( IR ),
     $                           LDWRKR, A( 1, I ), LDA, CZERO,
     $                           WORK( IU ), LDWRKU )
                     CALL ZLACPY( 'F', M, BLK, WORK( IU ), LDWRKU,
     $                            A( 1, I ), LDA )
   40             CONTINUE
*
               ELSE
*
*                 Insufficient workspace for a fast algorithm
*
                  ITAU = 1
                  IWORK = ITAU + M
*
*                 Compute A=L*Q
*                 (CWorkspace: need 2*M, prefer M+M*NB)
*                 (RWorkspace: 0)
*
                  CALL ZGELQF( M, N, A, LDA, WORK( ITAU ),
     $                         WORK( IWORK ), LWORK-IWORK+1, IERR )
*
*                 Copy L to U, zeroing out above it
*
                  CALL ZLACPY( 'L', M, M, A, LDA, U, LDU )
                  CALL ZLASET( 'U', M-1, M-1, CZERO, CZERO, U( 1, 2 ),
     $                         LDU )
*
*                 Generate Q in A
*                 (CWorkspace: need 2*M, prefer M+M*NB)
*                 (RWorkspace: 0)
*
                  CALL ZUNGLQ( M, N, M, A, LDA, WORK( ITAU ),
     $                         WORK( IWORK ), LWORK-IWORK+1, IERR )
                  IE = 1
                  ITAUQ = ITAU
                  ITAUP = ITAUQ + M
                  IWORK = ITAUP + M
*
*                 Bidiagonalize L in U
*                 (CWorkspace: need 3*M, prefer 2*M+2*M*NB)
*                 (RWorkspace: need M)
*
                  CALL ZGEBRD( M, M, U, LDU, S, RWORK( IE ),
     $                         WORK( ITAUQ ), WORK( ITAUP ),
     $                         WORK( IWORK ), LWORK-IWORK+1, IERR )
*
*                 Multiply right vectors bidiagonalizing L by Q in A
*                 (CWorkspace: need 2*M+N, prefer 2*M+N*NB)
*                 (RWorkspace: 0)
*
                  CALL ZUNMBR( 'P', 'L', 'C', M, N, M, U, LDU,
     $                         WORK( ITAUP ), A, LDA, WORK( IWORK ),
     $                         LWORK-IWORK+1, IERR )
*
*                 Generate left vectors bidiagonalizing L in U
*                 (CWorkspace: need 3*M, prefer 2*M+M*NB)
*                 (RWorkspace: 0)
*
                  CALL ZUNGBR( 'Q', M, M, M, U, LDU, WORK( ITAUQ ),
     $                         WORK( IWORK ), LWORK-IWORK+1, IERR )
                  IRWORK = IE + M
*
*                 Perform bidiagonal QR iteration, computing left
*                 singular vectors of A in U and computing right
*                 singular vectors of A in A
*                 (CWorkspace: 0)
*                 (RWorkspace: need BDSPAC)
*
                  CALL ZBDSQR( 'U', M, N, M, 0, S, RWORK( IE ), A, LDA,
     $                         U, LDU, CDUM, 1, RWORK( IRWORK ), INFO )
*
               END IF
*
            ELSE IF( WNTVS ) THEN
*
               IF( WNTUN ) THEN
*
*                 Path 4t(N much larger than M, JOBU='N', JOBVT='S')
*                 M right singular vectors to be computed in VT and
*                 no left singular vectors to be computed
*
                  IF( LWORK.GE.M*M+3*M ) THEN
*
*                    Sufficient workspace for a fast algorithm
*
                     IR = 1
                     IF( LWORK.GE.WRKBL+LDA*M ) THEN
*
*                       WORK(IR) is LDA by M
*
                        LDWRKR = LDA
                     ELSE
*
*                       WORK(IR) is M by M
*
                        LDWRKR = M
                     END IF
                     ITAU = IR + LDWRKR*M
                     IWORK = ITAU + M
*
*                    Compute A=L*Q
*                    (CWorkspace: need M*M+2*M, prefer M*M+M+M*NB)
*                    (RWorkspace: 0)
*
                     CALL ZGELQF( M, N, A, LDA, WORK( ITAU ),
     $                            WORK( IWORK ), LWORK-IWORK+1, IERR )
*
*                    Copy L to WORK(IR), zeroing out above it
*
                     CALL ZLACPY( 'L', M, M, A, LDA, WORK( IR ),
     $                            LDWRKR )
                     CALL ZLASET( 'U', M-1, M-1, CZERO, CZERO,
     $                            WORK( IR+LDWRKR ), LDWRKR )
*
*                    Generate Q in A
*                    (CWorkspace: need M*M+2*M, prefer M*M+M+M*NB)
*                    (RWorkspace: 0)
*
                     CALL ZUNGLQ( M, N, M, A, LDA, WORK( ITAU ),
     $                            WORK( IWORK ), LWORK-IWORK+1, IERR )
                     IE = 1
                     ITAUQ = ITAU
                     ITAUP = ITAUQ + M
                     IWORK = ITAUP + M
*
*                    Bidiagonalize L in WORK(IR)
*                    (CWorkspace: need M*M+3*M, prefer M*M+2*M+2*M*NB)
*                    (RWorkspace: need M)
*
                     CALL ZGEBRD( M, M, WORK( IR ), LDWRKR, S,
     $                            RWORK( IE ), WORK( ITAUQ ),
     $                            WORK( ITAUP ), WORK( IWORK ),
     $                            LWORK-IWORK+1, IERR )
*
*                    Generate right vectors bidiagonalizing L in
*                    WORK(IR)
*                    (CWorkspace: need M*M+3*M, prefer M*M+2*M+(M-1)*NB)
*                    (RWorkspace: 0)
*
                     CALL ZUNGBR( 'P', M, M, M, WORK( IR ), LDWRKR,
     $                            WORK( ITAUP ), WORK( IWORK ),
     $                            LWORK-IWORK+1, IERR )
                     IRWORK = IE + M
*
*                    Perform bidiagonal QR iteration, computing right
*                    singular vectors of L in WORK(IR)
*                    (CWorkspace: need M*M)
*                    (RWorkspace: need BDSPAC)
*
                     CALL ZBDSQR( 'U', M, M, 0, 0, S, RWORK( IE ),
     $                            WORK( IR ), LDWRKR, CDUM, 1, CDUM, 1,
     $                            RWORK( IRWORK ), INFO )
*
*                    Multiply right singular vectors of L in WORK(IR) by
*                    Q in A, storing result in VT
*                    (CWorkspace: need M*M)
*                    (RWorkspace: 0)
*
                     CALL ZGEMM( 'N', 'N', M, N, M, CONE, WORK( IR ),
     $                           LDWRKR, A, LDA, CZERO, VT, LDVT )
*
                  ELSE
*
*                    Insufficient workspace for a fast algorithm
*
                     ITAU = 1
                     IWORK = ITAU + M
*
*                    Compute A=L*Q
*                    (CWorkspace: need 2*M, prefer M+M*NB)
*                    (RWorkspace: 0)
*
                     CALL ZGELQF( M, N, A, LDA, WORK( ITAU ),
     $                            WORK( IWORK ), LWORK-IWORK+1, IERR )
*
*                    Copy result to VT
*
                     CALL ZLACPY( 'U', M, N, A, LDA, VT, LDVT )
*
*                    Generate Q in VT
*                    (CWorkspace: need 2*M, prefer M+M*NB)
*                    (RWorkspace: 0)
*
                     CALL ZUNGLQ( M, N, M, VT, LDVT, WORK( ITAU ),
     $                            WORK( IWORK ), LWORK-IWORK+1, IERR )
                     IE = 1
                     ITAUQ = ITAU
                     ITAUP = ITAUQ + M
                     IWORK = ITAUP + M
*
*                    Zero out above L in A
*
                     CALL ZLASET( 'U', M-1, M-1, CZERO, CZERO,
     $                            A( 1, 2 ), LDA )
*
*                    Bidiagonalize L in A
*                    (CWorkspace: need 3*M, prefer 2*M+2*M*NB)
*                    (RWorkspace: need M)
*
                     CALL ZGEBRD( M, M, A, LDA, S, RWORK( IE ),
     $                            WORK( ITAUQ ), WORK( ITAUP ),
     $                            WORK( IWORK ), LWORK-IWORK+1, IERR )
*
*                    Multiply right vectors bidiagonalizing L by Q in VT
*                    (CWorkspace: need 2*M+N, prefer 2*M+N*NB)
*                    (RWorkspace: 0)
*
                     CALL ZUNMBR( 'P', 'L', 'C', M, N, M, A, LDA,
     $                            WORK( ITAUP ), VT, LDVT,
     $                            WORK( IWORK ), LWORK-IWORK+1, IERR )
                     IRWORK = IE + M
*
*                    Perform bidiagonal QR iteration, computing right
*                    singular vectors of A in VT
*                    (CWorkspace: 0)
*                    (RWorkspace: need BDSPAC)
*
                     CALL ZBDSQR( 'U', M, N, 0, 0, S, RWORK( IE ), VT,
     $                            LDVT, CDUM, 1, CDUM, 1,
     $                            RWORK( IRWORK ), INFO )
*
                  END IF
*
               ELSE IF( WNTUO ) THEN
*
*                 Path 5t(N much larger than M, JOBU='O', JOBVT='S')
*                 M right singular vectors to be computed in VT and
*                 M left singular vectors to be overwritten on A
*
                  IF( LWORK.GE.2*M*M+3*M ) THEN
*
*                    Sufficient workspace for a fast algorithm
*
                     IU = 1
                     IF( LWORK.GE.WRKBL+2*LDA*M ) THEN
*
*                       WORK(IU) is LDA by M and WORK(IR) is LDA by M
*
                        LDWRKU = LDA
                        IR = IU + LDWRKU*M
                        LDWRKR = LDA
                     ELSE IF( LWORK.GE.WRKBL+( LDA+M )*M ) THEN
*
*                       WORK(IU) is LDA by M and WORK(IR) is M by M
*
                        LDWRKU = LDA
                        IR = IU + LDWRKU*M
                        LDWRKR = M
                     ELSE
*
*                       WORK(IU) is M by M and WORK(IR) is M by M
*
                        LDWRKU = M
                        IR = IU + LDWRKU*M
                        LDWRKR = M
                     END IF
                     ITAU = IR + LDWRKR*M
                     IWORK = ITAU + M
*
*                    Compute A=L*Q
*                    (CWorkspace: need 2*M*M+2*M, prefer 2*M*M+M+M*NB)
*                    (RWorkspace: 0)
*
                     CALL ZGELQF( M, N, A, LDA, WORK( ITAU ),
     $                            WORK( IWORK ), LWORK-IWORK+1, IERR )
*
*                    Copy L to WORK(IU), zeroing out below it
*
                     CALL ZLACPY( 'L', M, M, A, LDA, WORK( IU ),
     $                            LDWRKU )
                     CALL ZLASET( 'U', M-1, M-1, CZERO, CZERO,
     $                            WORK( IU+LDWRKU ), LDWRKU )
*
*                    Generate Q in A
*                    (CWorkspace: need 2*M*M+2*M, prefer 2*M*M+M+M*NB)
*                    (RWorkspace: 0)
*
                     CALL ZUNGLQ( M, N, M, A, LDA, WORK( ITAU ),
     $                            WORK( IWORK ), LWORK-IWORK+1, IERR )
                     IE = 1
                     ITAUQ = ITAU
                     ITAUP = ITAUQ + M
                     IWORK = ITAUP + M
*
*                    Bidiagonalize L in WORK(IU), copying result to
*                    WORK(IR)
*                    (CWorkspace: need   2*M*M+3*M,
*                                 prefer 2*M*M+2*M+2*M*NB)
*                    (RWorkspace: need   M)
*
                     CALL ZGEBRD( M, M, WORK( IU ), LDWRKU, S,
     $                            RWORK( IE ), WORK( ITAUQ ),
     $                            WORK( ITAUP ), WORK( IWORK ),
     $                            LWORK-IWORK+1, IERR )
                     CALL ZLACPY( 'L', M, M, WORK( IU ), LDWRKU,
     $                            WORK( IR ), LDWRKR )
*
*                    Generate right bidiagonalizing vectors in WORK(IU)
*                    (CWorkspace: need   2*M*M+3*M-1,
*                                 prefer 2*M*M+2*M+(M-1)*NB)
*                    (RWorkspace: 0)
*
                     CALL ZUNGBR( 'P', M, M, M, WORK( IU ), LDWRKU,
     $                            WORK( ITAUP ), WORK( IWORK ),
     $                            LWORK-IWORK+1, IERR )
*
*                    Generate left bidiagonalizing vectors in WORK(IR)
*                    (CWorkspace: need 2*M*M+3*M, prefer 2*M*M+2*M+M*NB)
*                    (RWorkspace: 0)
*
                     CALL ZUNGBR( 'Q', M, M, M, WORK( IR ), LDWRKR,
     $                            WORK( ITAUQ ), WORK( IWORK ),
     $                            LWORK-IWORK+1, IERR )
                     IRWORK = IE + M
*
*                    Perform bidiagonal QR iteration, computing left
*                    singular vectors of L in WORK(IR) and computing
*                    right singular vectors of L in WORK(IU)
*                    (CWorkspace: need 2*M*M)
*                    (RWorkspace: need BDSPAC)
*
                     CALL ZBDSQR( 'U', M, M, M, 0, S, RWORK( IE ),
     $                            WORK( IU ), LDWRKU, WORK( IR ),
     $                            LDWRKR, CDUM, 1, RWORK( IRWORK ),
     $                            INFO )
*
*                    Multiply right singular vectors of L in WORK(IU) by
*                    Q in A, storing result in VT
*                    (CWorkspace: need M*M)
*                    (RWorkspace: 0)
*
                     CALL ZGEMM( 'N', 'N', M, N, M, CONE, WORK( IU ),
     $                           LDWRKU, A, LDA, CZERO, VT, LDVT )
*
*                    Copy left singular vectors of L to A
*                    (CWorkspace: need M*M)
*                    (RWorkspace: 0)
*
                     CALL ZLACPY( 'F', M, M, WORK( IR ), LDWRKR, A,
     $                            LDA )
*
                  ELSE
*
*                    Insufficient workspace for a fast algorithm
*
                     ITAU = 1
                     IWORK = ITAU + M
*
*                    Compute A=L*Q, copying result to VT
*                    (CWorkspace: need 2*M, prefer M+M*NB)
*                    (RWorkspace: 0)
*
                     CALL ZGELQF( M, N, A, LDA, WORK( ITAU ),
     $                            WORK( IWORK ), LWORK-IWORK+1, IERR )
                     CALL ZLACPY( 'U', M, N, A, LDA, VT, LDVT )
*
*                    Generate Q in VT
*                    (CWorkspace: need 2*M, prefer M+M*NB)
*                    (RWorkspace: 0)
*
                     CALL ZUNGLQ( M, N, M, VT, LDVT, WORK( ITAU ),
     $                            WORK( IWORK ), LWORK-IWORK+1, IERR )
                     IE = 1
                     ITAUQ = ITAU
                     ITAUP = ITAUQ + M
                     IWORK = ITAUP + M
*
*                    Zero out above L in A
*
                     CALL ZLASET( 'U', M-1, M-1, CZERO, CZERO,
     $                            A( 1, 2 ), LDA )
*
*                    Bidiagonalize L in A
*                    (CWorkspace: need 3*M, prefer 2*M+2*M*NB)
*                    (RWorkspace: need M)
*
                     CALL ZGEBRD( M, M, A, LDA, S, RWORK( IE ),
     $                            WORK( ITAUQ ), WORK( ITAUP ),
     $                            WORK( IWORK ), LWORK-IWORK+1, IERR )
*
*                    Multiply right vectors bidiagonalizing L by Q in VT
*                    (CWorkspace: need 2*M+N, prefer 2*M+N*NB)
*                    (RWorkspace: 0)
*
                     CALL ZUNMBR( 'P', 'L', 'C', M, N, M, A, LDA,
     $                            WORK( ITAUP ), VT, LDVT,
     $                            WORK( IWORK ), LWORK-IWORK+1, IERR )
*
*                    Generate left bidiagonalizing vectors of L in A
*                    (CWorkspace: need 3*M, prefer 2*M+M*NB)
*                    (RWorkspace: 0)
*
                     CALL ZUNGBR( 'Q', M, M, M, A, LDA, WORK( ITAUQ ),
     $                            WORK( IWORK ), LWORK-IWORK+1, IERR )
                     IRWORK = IE + M
*
*                    Perform bidiagonal QR iteration, computing left
*                    singular vectors of A in A and computing right
*                    singular vectors of A in VT
*                    (CWorkspace: 0)
*                    (RWorkspace: need BDSPAC)
*
                     CALL ZBDSQR( 'U', M, N, M, 0, S, RWORK( IE ), VT,
     $                            LDVT, A, LDA, CDUM, 1,
     $                            RWORK( IRWORK ), INFO )
*
                  END IF
*
               ELSE IF( WNTUAS ) THEN
*
*                 Path 6t(N much larger than M, JOBU='S' or 'A',
*                         JOBVT='S')
*                 M right singular vectors to be computed in VT and
*                 M left singular vectors to be computed in U
*
                  IF( LWORK.GE.M*M+3*M ) THEN
*
*                    Sufficient workspace for a fast algorithm
*
                     IU = 1
                     IF( LWORK.GE.WRKBL+LDA*M ) THEN
*
*                       WORK(IU) is LDA by N
*
                        LDWRKU = LDA
                     ELSE
*
*                       WORK(IU) is LDA by M
*
                        LDWRKU = M
                     END IF
                     ITAU = IU + LDWRKU*M
                     IWORK = ITAU + M
*
*                    Compute A=L*Q
*                    (CWorkspace: need M*M+2*M, prefer M*M+M+M*NB)
*                    (RWorkspace: 0)
*
                     CALL ZGELQF( M, N, A, LDA, WORK( ITAU ),
     $                            WORK( IWORK ), LWORK-IWORK+1, IERR )
*
*                    Copy L to WORK(IU), zeroing out above it
*
                     CALL ZLACPY( 'L', M, M, A, LDA, WORK( IU ),
     $                            LDWRKU )
                     CALL ZLASET( 'U', M-1, M-1, CZERO, CZERO,
     $                            WORK( IU+LDWRKU ), LDWRKU )
*
*                    Generate Q in A
*                    (CWorkspace: need M*M+2*M, prefer M*M+M+M*NB)
*                    (RWorkspace: 0)
*
                     CALL ZUNGLQ( M, N, M, A, LDA, WORK( ITAU ),
     $                            WORK( IWORK ), LWORK-IWORK+1, IERR )
                     IE = 1
                     ITAUQ = ITAU
                     ITAUP = ITAUQ + M
                     IWORK = ITAUP + M
*
*                    Bidiagonalize L in WORK(IU), copying result to U
*                    (CWorkspace: need M*M+3*M, prefer M*M+2*M+2*M*NB)
*                    (RWorkspace: need M)
*
                     CALL ZGEBRD( M, M, WORK( IU ), LDWRKU, S,
     $                            RWORK( IE ), WORK( ITAUQ ),
     $                            WORK( ITAUP ), WORK( IWORK ),
     $                            LWORK-IWORK+1, IERR )
                     CALL ZLACPY( 'L', M, M, WORK( IU ), LDWRKU, U,
     $                            LDU )
*
*                    Generate right bidiagonalizing vectors in WORK(IU)
*                    (CWorkspace: need   M*M+3*M-1,
*                                 prefer M*M+2*M+(M-1)*NB)
*                    (RWorkspace: 0)
*
                     CALL ZUNGBR( 'P', M, M, M, WORK( IU ), LDWRKU,
     $                            WORK( ITAUP ), WORK( IWORK ),
     $                            LWORK-IWORK+1, IERR )
*
*                    Generate left bidiagonalizing vectors in U
*                    (CWorkspace: need M*M+3*M, prefer M*M+2*M+M*NB)
*                    (RWorkspace: 0)
*
                     CALL ZUNGBR( 'Q', M, M, M, U, LDU, WORK( ITAUQ ),
     $                            WORK( IWORK ), LWORK-IWORK+1, IERR )
                     IRWORK = IE + M
*
*                    Perform bidiagonal QR iteration, computing left
*                    singular vectors of L in U and computing right
*                    singular vectors of L in WORK(IU)
*                    (CWorkspace: need M*M)
*                    (RWorkspace: need BDSPAC)
*
                     CALL ZBDSQR( 'U', M, M, M, 0, S, RWORK( IE ),
     $                            WORK( IU ), LDWRKU, U, LDU, CDUM, 1,
     $                            RWORK( IRWORK ), INFO )
*
*                    Multiply right singular vectors of L in WORK(IU) by
*                    Q in A, storing result in VT
*                    (CWorkspace: need M*M)
*                    (RWorkspace: 0)
*
                     CALL ZGEMM( 'N', 'N', M, N, M, CONE, WORK( IU ),
     $                           LDWRKU, A, LDA, CZERO, VT, LDVT )
*
                  ELSE
*
*                    Insufficient workspace for a fast algorithm
*
                     ITAU = 1
                     IWORK = ITAU + M
*
*                    Compute A=L*Q, copying result to VT
*                    (CWorkspace: need 2*M, prefer M+M*NB)
*                    (RWorkspace: 0)
*
                     CALL ZGELQF( M, N, A, LDA, WORK( ITAU ),
     $                            WORK( IWORK ), LWORK-IWORK+1, IERR )
                     CALL ZLACPY( 'U', M, N, A, LDA, VT, LDVT )
*
*                    Generate Q in VT
*                    (CWorkspace: need 2*M, prefer M+M*NB)
*                    (RWorkspace: 0)
*
                     CALL ZUNGLQ( M, N, M, VT, LDVT, WORK( ITAU ),
     $                            WORK( IWORK ), LWORK-IWORK+1, IERR )
*
*                    Copy L to U, zeroing out above it
*
                     CALL ZLACPY( 'L', M, M, A, LDA, U, LDU )
                     CALL ZLASET( 'U', M-1, M-1, CZERO, CZERO,
     $                            U( 1, 2 ), LDU )
                     IE = 1
                     ITAUQ = ITAU
                     ITAUP = ITAUQ + M
                     IWORK = ITAUP + M
*
*                    Bidiagonalize L in U
*                    (CWorkspace: need 3*M, prefer 2*M+2*M*NB)
*                    (RWorkspace: need M)
*
                     CALL ZGEBRD( M, M, U, LDU, S, RWORK( IE ),
     $                            WORK( ITAUQ ), WORK( ITAUP ),
     $                            WORK( IWORK ), LWORK-IWORK+1, IERR )
*
*                    Multiply right bidiagonalizing vectors in U by Q
*                    in VT
*                    (CWorkspace: need 2*M+N, prefer 2*M+N*NB)
*                    (RWorkspace: 0)
*
                     CALL ZUNMBR( 'P', 'L', 'C', M, N, M, U, LDU,
     $                            WORK( ITAUP ), VT, LDVT,
     $                            WORK( IWORK ), LWORK-IWORK+1, IERR )
*
*                    Generate left bidiagonalizing vectors in U
*                    (CWorkspace: need 3*M, prefer 2*M+M*NB)
*                    (RWorkspace: 0)
*
                     CALL ZUNGBR( 'Q', M, M, M, U, LDU, WORK( ITAUQ ),
     $                            WORK( IWORK ), LWORK-IWORK+1, IERR )
                     IRWORK = IE + M
*
*                    Perform bidiagonal QR iteration, computing left
*                    singular vectors of A in U and computing right
*                    singular vectors of A in VT
*                    (CWorkspace: 0)
*                    (RWorkspace: need BDSPAC)
*
                     CALL ZBDSQR( 'U', M, N, M, 0, S, RWORK( IE ), VT,
     $                            LDVT, U, LDU, CDUM, 1,
     $                            RWORK( IRWORK ), INFO )
*
                  END IF
*
               END IF
*
            ELSE IF( WNTVA ) THEN
*
               IF( WNTUN ) THEN
*
*                 Path 7t(N much larger than M, JOBU='N', JOBVT='A')
*                 N right singular vectors to be computed in VT and
*                 no left singular vectors to be computed
*
                  IF( LWORK.GE.M*M+MAX( N+M, 3*M ) ) THEN
*
*                    Sufficient workspace for a fast algorithm
*
                     IR = 1
                     IF( LWORK.GE.WRKBL+LDA*M ) THEN
*
*                       WORK(IR) is LDA by M
*
                        LDWRKR = LDA
                     ELSE
*
*                       WORK(IR) is M by M
*
                        LDWRKR = M
                     END IF
                     ITAU = IR + LDWRKR*M
                     IWORK = ITAU + M
*
*                    Compute A=L*Q, copying result to VT
*                    (CWorkspace: need M*M+2*M, prefer M*M+M+M*NB)
*                    (RWorkspace: 0)
*
                     CALL ZGELQF( M, N, A, LDA, WORK( ITAU ),
     $                            WORK( IWORK ), LWORK-IWORK+1, IERR )
                     CALL ZLACPY( 'U', M, N, A, LDA, VT, LDVT )
*
*                    Copy L to WORK(IR), zeroing out above it
*
                     CALL ZLACPY( 'L', M, M, A, LDA, WORK( IR ),
     $                            LDWRKR )
                     CALL ZLASET( 'U', M-1, M-1, CZERO, CZERO,
     $                            WORK( IR+LDWRKR ), LDWRKR )
*
*                    Generate Q in VT
*                    (CWorkspace: need M*M+M+N, prefer M*M+M+N*NB)
*                    (RWorkspace: 0)
*
                     CALL ZUNGLQ( N, N, M, VT, LDVT, WORK( ITAU ),
     $                            WORK( IWORK ), LWORK-IWORK+1, IERR )
                     IE = 1
                     ITAUQ = ITAU
                     ITAUP = ITAUQ + M
                     IWORK = ITAUP + M
*
*                    Bidiagonalize L in WORK(IR)
*                    (CWorkspace: need M*M+3*M, prefer M*M+2*M+2*M*NB)
*                    (RWorkspace: need M)
*
                     CALL ZGEBRD( M, M, WORK( IR ), LDWRKR, S,
     $                            RWORK( IE ), WORK( ITAUQ ),
     $                            WORK( ITAUP ), WORK( IWORK ),
     $                            LWORK-IWORK+1, IERR )
*
*                    Generate right bidiagonalizing vectors in WORK(IR)
*                    (CWorkspace: need   M*M+3*M-1,
*                                 prefer M*M+2*M+(M-1)*NB)
*                    (RWorkspace: 0)
*
                     CALL ZUNGBR( 'P', M, M, M, WORK( IR ), LDWRKR,
     $                            WORK( ITAUP ), WORK( IWORK ),
     $                            LWORK-IWORK+1, IERR )
                     IRWORK = IE + M
*
*                    Perform bidiagonal QR iteration, computing right
*                    singular vectors of L in WORK(IR)
*                    (CWorkspace: need M*M)
*                    (RWorkspace: need BDSPAC)
*
                     CALL ZBDSQR( 'U', M, M, 0, 0, S, RWORK( IE ),
     $                            WORK( IR ), LDWRKR, CDUM, 1, CDUM, 1,
     $                            RWORK( IRWORK ), INFO )
*
*                    Multiply right singular vectors of L in WORK(IR) by
*                    Q in VT, storing result in A
*                    (CWorkspace: need M*M)
*                    (RWorkspace: 0)
*
                     CALL ZGEMM( 'N', 'N', M, N, M, CONE, WORK( IR ),
     $                           LDWRKR, VT, LDVT, CZERO, A, LDA )
*
*                    Copy right singular vectors of A from A to VT
*
                     CALL ZLACPY( 'F', M, N, A, LDA, VT, LDVT )
*
                  ELSE
*
*                    Insufficient workspace for a fast algorithm
*
                     ITAU = 1
                     IWORK = ITAU + M
*
*                    Compute A=L*Q, copying result to VT
*                    (CWorkspace: need 2*M, prefer M+M*NB)
*                    (RWorkspace: 0)
*
                     CALL ZGELQF( M, N, A, LDA, WORK( ITAU ),
     $                            WORK( IWORK ), LWORK-IWORK+1, IERR )
                     CALL ZLACPY( 'U', M, N, A, LDA, VT, LDVT )
*
*                    Generate Q in VT
*                    (CWorkspace: need M+N, prefer M+N*NB)
*                    (RWorkspace: 0)
*
                     CALL ZUNGLQ( N, N, M, VT, LDVT, WORK( ITAU ),
     $                            WORK( IWORK ), LWORK-IWORK+1, IERR )
                     IE = 1
                     ITAUQ = ITAU
                     ITAUP = ITAUQ + M
                     IWORK = ITAUP + M
*
*                    Zero out above L in A
*
                     CALL ZLASET( 'U', M-1, M-1, CZERO, CZERO,
     $                            A( 1, 2 ), LDA )
*
*                    Bidiagonalize L in A
*                    (CWorkspace: need 3*M, prefer 2*M+2*M*NB)
*                    (RWorkspace: need M)
*
                     CALL ZGEBRD( M, M, A, LDA, S, RWORK( IE ),
     $                            WORK( ITAUQ ), WORK( ITAUP ),
     $                            WORK( IWORK ), LWORK-IWORK+1, IERR )
*
*                    Multiply right bidiagonalizing vectors in A by Q
*                    in VT
*                    (CWorkspace: need 2*M+N, prefer 2*M+N*NB)
*                    (RWorkspace: 0)
*
                     CALL ZUNMBR( 'P', 'L', 'C', M, N, M, A, LDA,
     $                            WORK( ITAUP ), VT, LDVT,
     $                            WORK( IWORK ), LWORK-IWORK+1, IERR )
                     IRWORK = IE + M
*
*                    Perform bidiagonal QR iteration, computing right
*                    singular vectors of A in VT
*                    (CWorkspace: 0)
*                    (RWorkspace: need BDSPAC)
*
                     CALL ZBDSQR( 'U', M, N, 0, 0, S, RWORK( IE ), VT,
     $                            LDVT, CDUM, 1, CDUM, 1,
     $                            RWORK( IRWORK ), INFO )
*
                  END IF
*
               ELSE IF( WNTUO ) THEN
*
*                 Path 8t(N much larger than M, JOBU='O', JOBVT='A')
*                 N right singular vectors to be computed in VT and
*                 M left singular vectors to be overwritten on A
*
                  IF( LWORK.GE.2*M*M+MAX( N+M, 3*M ) ) THEN
*
*                    Sufficient workspace for a fast algorithm
*
                     IU = 1
                     IF( LWORK.GE.WRKBL+2*LDA*M ) THEN
*
*                       WORK(IU) is LDA by M and WORK(IR) is LDA by M
*
                        LDWRKU = LDA
                        IR = IU + LDWRKU*M
                        LDWRKR = LDA
                     ELSE IF( LWORK.GE.WRKBL+( LDA+M )*M ) THEN
*
*                       WORK(IU) is LDA by M and WORK(IR) is M by M
*
                        LDWRKU = LDA
                        IR = IU + LDWRKU*M
                        LDWRKR = M
                     ELSE
*
*                       WORK(IU) is M by M and WORK(IR) is M by M
*
                        LDWRKU = M
                        IR = IU + LDWRKU*M
                        LDWRKR = M
                     END IF
                     ITAU = IR + LDWRKR*M
                     IWORK = ITAU + M
*
*                    Compute A=L*Q, copying result to VT
*                    (CWorkspace: need 2*M*M+2*M, prefer 2*M*M+M+M*NB)
*                    (RWorkspace: 0)
*
                     CALL ZGELQF( M, N, A, LDA, WORK( ITAU ),
     $                            WORK( IWORK ), LWORK-IWORK+1, IERR )
                     CALL ZLACPY( 'U', M, N, A, LDA, VT, LDVT )
*
*                    Generate Q in VT
*                    (CWorkspace: need 2*M*M+M+N, prefer 2*M*M+M+N*NB)
*                    (RWorkspace: 0)
*
                     CALL ZUNGLQ( N, N, M, VT, LDVT, WORK( ITAU ),
     $                            WORK( IWORK ), LWORK-IWORK+1, IERR )
*
*                    Copy L to WORK(IU), zeroing out above it
*
                     CALL ZLACPY( 'L', M, M, A, LDA, WORK( IU ),
     $                            LDWRKU )
                     CALL ZLASET( 'U', M-1, M-1, CZERO, CZERO,
     $                            WORK( IU+LDWRKU ), LDWRKU )
                     IE = 1
                     ITAUQ = ITAU
                     ITAUP = ITAUQ + M
                     IWORK = ITAUP + M
*
*                    Bidiagonalize L in WORK(IU), copying result to
*                    WORK(IR)
*                    (CWorkspace: need   2*M*M+3*M,
*                                 prefer 2*M*M+2*M+2*M*NB)
*                    (RWorkspace: need   M)
*
                     CALL ZGEBRD( M, M, WORK( IU ), LDWRKU, S,
     $                            RWORK( IE ), WORK( ITAUQ ),
     $                            WORK( ITAUP ), WORK( IWORK ),
     $                            LWORK-IWORK+1, IERR )
                     CALL ZLACPY( 'L', M, M, WORK( IU ), LDWRKU,
     $                            WORK( IR ), LDWRKR )
*
*                    Generate right bidiagonalizing vectors in WORK(IU)
*                    (CWorkspace: need   2*M*M+3*M-1,
*                                 prefer 2*M*M+2*M+(M-1)*NB)
*                    (RWorkspace: 0)
*
                     CALL ZUNGBR( 'P', M, M, M, WORK( IU ), LDWRKU,
     $                            WORK( ITAUP ), WORK( IWORK ),
     $                            LWORK-IWORK+1, IERR )
*
*                    Generate left bidiagonalizing vectors in WORK(IR)
*                    (CWorkspace: need 2*M*M+3*M, prefer 2*M*M+2*M+M*NB)
*                    (RWorkspace: 0)
*
                     CALL ZUNGBR( 'Q', M, M, M, WORK( IR ), LDWRKR,
     $                            WORK( ITAUQ ), WORK( IWORK ),
     $                            LWORK-IWORK+1, IERR )
                     IRWORK = IE + M
*
*                    Perform bidiagonal QR iteration, computing left
*                    singular vectors of L in WORK(IR) and computing
*                    right singular vectors of L in WORK(IU)
*                    (CWorkspace: need 2*M*M)
*                    (RWorkspace: need BDSPAC)
*
                     CALL ZBDSQR( 'U', M, M, M, 0, S, RWORK( IE ),
     $                            WORK( IU ), LDWRKU, WORK( IR ),
     $                            LDWRKR, CDUM, 1, RWORK( IRWORK ),
     $                            INFO )
*
*                    Multiply right singular vectors of L in WORK(IU) by
*                    Q in VT, storing result in A
*                    (CWorkspace: need M*M)
*                    (RWorkspace: 0)
*
                     CALL ZGEMM( 'N', 'N', M, N, M, CONE, WORK( IU ),
     $                           LDWRKU, VT, LDVT, CZERO, A, LDA )
*
*                    Copy right singular vectors of A from A to VT
*
                     CALL ZLACPY( 'F', M, N, A, LDA, VT, LDVT )
*
*                    Copy left singular vectors of A from WORK(IR) to A
*
                     CALL ZLACPY( 'F', M, M, WORK( IR ), LDWRKR, A,
     $                            LDA )
*
                  ELSE
*
*                    Insufficient workspace for a fast algorithm
*
                     ITAU = 1
                     IWORK = ITAU + M
*
*                    Compute A=L*Q, copying result to VT
*                    (CWorkspace: need 2*M, prefer M+M*NB)
*                    (RWorkspace: 0)
*
                     CALL ZGELQF( M, N, A, LDA, WORK( ITAU ),
     $                            WORK( IWORK ), LWORK-IWORK+1, IERR )
                     CALL ZLACPY( 'U', M, N, A, LDA, VT, LDVT )
*
*                    Generate Q in VT
*                    (CWorkspace: need M+N, prefer M+N*NB)
*                    (RWorkspace: 0)
*
                     CALL ZUNGLQ( N, N, M, VT, LDVT, WORK( ITAU ),
     $                            WORK( IWORK ), LWORK-IWORK+1, IERR )
                     IE = 1
                     ITAUQ = ITAU
                     ITAUP = ITAUQ + M
                     IWORK = ITAUP + M
*
*                    Zero out above L in A
*
                     CALL ZLASET( 'U', M-1, M-1, CZERO, CZERO,
     $                            A( 1, 2 ), LDA )
*
*                    Bidiagonalize L in A
*                    (CWorkspace: need 3*M, prefer 2*M+2*M*NB)
*                    (RWorkspace: need M)
*
                     CALL ZGEBRD( M, M, A, LDA, S, RWORK( IE ),
     $                            WORK( ITAUQ ), WORK( ITAUP ),
     $                            WORK( IWORK ), LWORK-IWORK+1, IERR )
*
*                    Multiply right bidiagonalizing vectors in A by Q
*                    in VT
*                    (CWorkspace: need 2*M+N, prefer 2*M+N*NB)
*                    (RWorkspace: 0)
*
                     CALL ZUNMBR( 'P', 'L', 'C', M, N, M, A, LDA,
     $                            WORK( ITAUP ), VT, LDVT,
     $                            WORK( IWORK ), LWORK-IWORK+1, IERR )
*
*                    Generate left bidiagonalizing vectors in A
*                    (CWorkspace: need 3*M, prefer 2*M+M*NB)
*                    (RWorkspace: 0)
*
                     CALL ZUNGBR( 'Q', M, M, M, A, LDA, WORK( ITAUQ ),
     $                            WORK( IWORK ), LWORK-IWORK+1, IERR )
                     IRWORK = IE + M
*
*                    Perform bidiagonal QR iteration, computing left
*                    singular vectors of A in A and computing right
*                    singular vectors of A in VT
*                    (CWorkspace: 0)
*                    (RWorkspace: need BDSPAC)
*
                     CALL ZBDSQR( 'U', M, N, M, 0, S, RWORK( IE ), VT,
     $                            LDVT, A, LDA, CDUM, 1,
     $                            RWORK( IRWORK ), INFO )
*
                  END IF
*
               ELSE IF( WNTUAS ) THEN
*
*                 Path 9t(N much larger than M, JOBU='S' or 'A',
*                         JOBVT='A')
*                 N right singular vectors to be computed in VT and
*                 M left singular vectors to be computed in U
*
                  IF( LWORK.GE.M*M+MAX( N+M, 3*M ) ) THEN
*
*                    Sufficient workspace for a fast algorithm
*
                     IU = 1
                     IF( LWORK.GE.WRKBL+LDA*M ) THEN
*
*                       WORK(IU) is LDA by M
*
                        LDWRKU = LDA
                     ELSE
*
*                       WORK(IU) is M by M
*
                        LDWRKU = M
                     END IF
                     ITAU = IU + LDWRKU*M
                     IWORK = ITAU + M
*
*                    Compute A=L*Q, copying result to VT
*                    (CWorkspace: need M*M+2*M, prefer M*M+M+M*NB)
*                    (RWorkspace: 0)
*
                     CALL ZGELQF( M, N, A, LDA, WORK( ITAU ),
     $                            WORK( IWORK ), LWORK-IWORK+1, IERR )
                     CALL ZLACPY( 'U', M, N, A, LDA, VT, LDVT )
*
*                    Generate Q in VT
*                    (CWorkspace: need M*M+M+N, prefer M*M+M+N*NB)
*                    (RWorkspace: 0)
*
                     CALL ZUNGLQ( N, N, M, VT, LDVT, WORK( ITAU ),
     $                            WORK( IWORK ), LWORK-IWORK+1, IERR )
*
*                    Copy L to WORK(IU), zeroing out above it
*
                     CALL ZLACPY( 'L', M, M, A, LDA, WORK( IU ),
     $                            LDWRKU )
                     CALL ZLASET( 'U', M-1, M-1, CZERO, CZERO,
     $                            WORK( IU+LDWRKU ), LDWRKU )
                     IE = 1
                     ITAUQ = ITAU
                     ITAUP = ITAUQ + M
                     IWORK = ITAUP + M
*
*                    Bidiagonalize L in WORK(IU), copying result to U
*                    (CWorkspace: need M*M+3*M, prefer M*M+2*M+2*M*NB)
*                    (RWorkspace: need M)
*
                     CALL ZGEBRD( M, M, WORK( IU ), LDWRKU, S,
     $                            RWORK( IE ), WORK( ITAUQ ),
     $                            WORK( ITAUP ), WORK( IWORK ),
     $                            LWORK-IWORK+1, IERR )
                     CALL ZLACPY( 'L', M, M, WORK( IU ), LDWRKU, U,
     $                            LDU )
*
*                    Generate right bidiagonalizing vectors in WORK(IU)
*                    (CWorkspace: need M*M+3*M, prefer M*M+2*M+(M-1)*NB)
*                    (RWorkspace: 0)
*
                     CALL ZUNGBR( 'P', M, M, M, WORK( IU ), LDWRKU,
     $                            WORK( ITAUP ), WORK( IWORK ),
     $                            LWORK-IWORK+1, IERR )
*
*                    Generate left bidiagonalizing vectors in U
*                    (CWorkspace: need M*M+3*M, prefer M*M+2*M+M*NB)
*                    (RWorkspace: 0)
*
                     CALL ZUNGBR( 'Q', M, M, M, U, LDU, WORK( ITAUQ ),
     $                            WORK( IWORK ), LWORK-IWORK+1, IERR )
                     IRWORK = IE + M
*
*                    Perform bidiagonal QR iteration, computing left
*                    singular vectors of L in U and computing right
*                    singular vectors of L in WORK(IU)
*                    (CWorkspace: need M*M)
*                    (RWorkspace: need BDSPAC)
*
                     CALL ZBDSQR( 'U', M, M, M, 0, S, RWORK( IE ),
     $                            WORK( IU ), LDWRKU, U, LDU, CDUM, 1,
     $                            RWORK( IRWORK ), INFO )
*
*                    Multiply right singular vectors of L in WORK(IU) by
*                    Q in VT, storing result in A
*                    (CWorkspace: need M*M)
*                    (RWorkspace: 0)
*
                     CALL ZGEMM( 'N', 'N', M, N, M, CONE, WORK( IU ),
     $                           LDWRKU, VT, LDVT, CZERO, A, LDA )
*
*                    Copy right singular vectors of A from A to VT
*
                     CALL ZLACPY( 'F', M, N, A, LDA, VT, LDVT )
*
                  ELSE
*
*                    Insufficient workspace for a fast algorithm
*
                     ITAU = 1
                     IWORK = ITAU + M
*
*                    Compute A=L*Q, copying result to VT
*                    (CWorkspace: need 2*M, prefer M+M*NB)
*                    (RWorkspace: 0)
*
                     CALL ZGELQF( M, N, A, LDA, WORK( ITAU ),
     $                            WORK( IWORK ), LWORK-IWORK+1, IERR )
                     CALL ZLACPY( 'U', M, N, A, LDA, VT, LDVT )
*
*                    Generate Q in VT
*                    (CWorkspace: need M+N, prefer M+N*NB)
*                    (RWorkspace: 0)
*
                     CALL ZUNGLQ( N, N, M, VT, LDVT, WORK( ITAU ),
     $                            WORK( IWORK ), LWORK-IWORK+1, IERR )
*
*                    Copy L to U, zeroing out above it
*
                     CALL ZLACPY( 'L', M, M, A, LDA, U, LDU )
                     CALL ZLASET( 'U', M-1, M-1, CZERO, CZERO,
     $                            U( 1, 2 ), LDU )
                     IE = 1
                     ITAUQ = ITAU
                     ITAUP = ITAUQ + M
                     IWORK = ITAUP + M
*
*                    Bidiagonalize L in U
*                    (CWorkspace: need 3*M, prefer 2*M+2*M*NB)
*                    (RWorkspace: need M)
*
                     CALL ZGEBRD( M, M, U, LDU, S, RWORK( IE ),
     $                            WORK( ITAUQ ), WORK( ITAUP ),
     $                            WORK( IWORK ), LWORK-IWORK+1, IERR )
*
*                    Multiply right bidiagonalizing vectors in U by Q
*                    in VT
*                    (CWorkspace: need 2*M+N, prefer 2*M+N*NB)
*                    (RWorkspace: 0)
*
                     CALL ZUNMBR( 'P', 'L', 'C', M, N, M, U, LDU,
     $                            WORK( ITAUP ), VT, LDVT,
     $                            WORK( IWORK ), LWORK-IWORK+1, IERR )
*
*                    Generate left bidiagonalizing vectors in U
*                    (CWorkspace: need 3*M, prefer 2*M+M*NB)
*                    (RWorkspace: 0)
*
                     CALL ZUNGBR( 'Q', M, M, M, U, LDU, WORK( ITAUQ ),
     $                            WORK( IWORK ), LWORK-IWORK+1, IERR )
                     IRWORK = IE + M
*
*                    Perform bidiagonal QR iteration, computing left
*                    singular vectors of A in U and computing right
*                    singular vectors of A in VT
*                    (CWorkspace: 0)
*                    (RWorkspace: need BDSPAC)
*
                     CALL ZBDSQR( 'U', M, N, M, 0, S, RWORK( IE ), VT,
     $                            LDVT, U, LDU, CDUM, 1,
     $                            RWORK( IRWORK ), INFO )
*
                  END IF
*
               END IF
*
            END IF
*
         ELSE
*
*           N .LT. MNTHR
*
*           Path 10t(N greater than M, but not much larger)
*           Reduce to bidiagonal form without LQ decomposition
*
            IE = 1
            ITAUQ = 1
            ITAUP = ITAUQ + M
            IWORK = ITAUP + M
*
*           Bidiagonalize A
*           (CWorkspace: need 2*M+N, prefer 2*M+(M+N)*NB)
*           (RWorkspace: M)
*
            CALL ZGEBRD( M, N, A, LDA, S, RWORK( IE ), WORK( ITAUQ ),
     $                   WORK( ITAUP ), WORK( IWORK ), LWORK-IWORK+1,
     $                   IERR )
            IF( WNTUAS ) THEN
*
*              If left singular vectors desired in U, copy result to U
*              and generate left bidiagonalizing vectors in U
*              (CWorkspace: need 3*M-1, prefer 2*M+(M-1)*NB)
*              (RWorkspace: 0)
*
               CALL ZLACPY( 'L', M, M, A, LDA, U, LDU )
               CALL ZUNGBR( 'Q', M, M, N, U, LDU, WORK( ITAUQ ),
     $                      WORK( IWORK ), LWORK-IWORK+1, IERR )
            END IF
            IF( WNTVAS ) THEN
*
*              If right singular vectors desired in VT, copy result to
*              VT and generate right bidiagonalizing vectors in VT
*              (CWorkspace: need 2*M+NRVT, prefer 2*M+NRVT*NB)
*              (RWorkspace: 0)
*
               CALL ZLACPY( 'U', M, N, A, LDA, VT, LDVT )
               IF( WNTVA )
     $            NRVT = N
               IF( WNTVS )
     $            NRVT = M
               CALL ZUNGBR( 'P', NRVT, N, M, VT, LDVT, WORK( ITAUP ),
     $                      WORK( IWORK ), LWORK-IWORK+1, IERR )
            END IF
            IF( WNTUO ) THEN
*
*              If left singular vectors desired in A, generate left
*              bidiagonalizing vectors in A
*              (CWorkspace: need 3*M-1, prefer 2*M+(M-1)*NB)
*              (RWorkspace: 0)
*
               CALL ZUNGBR( 'Q', M, M, N, A, LDA, WORK( ITAUQ ),
     $                      WORK( IWORK ), LWORK-IWORK+1, IERR )
            END IF
            IF( WNTVO ) THEN
*
*              If right singular vectors desired in A, generate right
*              bidiagonalizing vectors in A
*              (CWorkspace: need 3*M, prefer 2*M+M*NB)
*              (RWorkspace: 0)
*
               CALL ZUNGBR( 'P', M, N, M, A, LDA, WORK( ITAUP ),
     $                      WORK( IWORK ), LWORK-IWORK+1, IERR )
            END IF
            IRWORK = IE + M
            IF( WNTUAS .OR. WNTUO )
     $         NRU = M
            IF( WNTUN )
     $         NRU = 0
            IF( WNTVAS .OR. WNTVO )
     $         NCVT = N
            IF( WNTVN )
     $         NCVT = 0
            IF( ( .NOT.WNTUO ) .AND. ( .NOT.WNTVO ) ) THEN
*
*              Perform bidiagonal QR iteration, if desired, computing
*              left singular vectors in U and computing right singular
*              vectors in VT
*              (CWorkspace: 0)
*              (RWorkspace: need BDSPAC)
*
               CALL ZBDSQR( 'L', M, NCVT, NRU, 0, S, RWORK( IE ), VT,
     $                      LDVT, U, LDU, CDUM, 1, RWORK( IRWORK ),
     $                      INFO )
            ELSE IF( ( .NOT.WNTUO ) .AND. WNTVO ) THEN
*
*              Perform bidiagonal QR iteration, if desired, computing
*              left singular vectors in U and computing right singular
*              vectors in A
*              (CWorkspace: 0)
*              (RWorkspace: need BDSPAC)
*
               CALL ZBDSQR( 'L', M, NCVT, NRU, 0, S, RWORK( IE ), A,
     $                      LDA, U, LDU, CDUM, 1, RWORK( IRWORK ),
     $                      INFO )
            ELSE
*
*              Perform bidiagonal QR iteration, if desired, computing
*              left singular vectors in A and computing right singular
*              vectors in VT
*              (CWorkspace: 0)
*              (RWorkspace: need BDSPAC)
*
               CALL ZBDSQR( 'L', M, NCVT, NRU, 0, S, RWORK( IE ), VT,
     $                      LDVT, A, LDA, CDUM, 1, RWORK( IRWORK ),
     $                      INFO )
            END IF
*
         END IF
*
      END IF
*
*     Undo scaling if necessary
*
      IF( ISCL.EQ.1 ) THEN
         IF( ANRM.GT.BIGNUM )
     $      CALL DLASCL( 'G', 0, 0, BIGNUM, ANRM, MINMN, 1, S, MINMN,
     $                   IERR )
         IF( INFO.NE.0 .AND. ANRM.GT.BIGNUM )
     $      CALL DLASCL( 'G', 0, 0, BIGNUM, ANRM, MINMN-1, 1,
     $                   RWORK( IE ), MINMN, IERR )
         IF( ANRM.LT.SMLNUM )
     $      CALL DLASCL( 'G', 0, 0, SMLNUM, ANRM, MINMN, 1, S, MINMN,
     $                   IERR )
         IF( INFO.NE.0 .AND. ANRM.LT.SMLNUM )
     $      CALL DLASCL( 'G', 0, 0, SMLNUM, ANRM, MINMN-1, 1,
     $                   RWORK( IE ), MINMN, IERR )
      END IF
*
*     Return optimal workspace in WORK(1)
*
      WORK( 1 ) = MAXWRK
*
      RETURN
*
*     End of ZGESVD
*
      END

C
C
C                Copyright (C)  2013
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
C
      SUBROUTINE map_next_point (rlat, rlon, u, v, pval, status, init)

      real rlat, rlon, u, v
      double precision pval
C
C status is 0 for a normal next point that falls within the map boundary
C           1 for a point that is not projectable
C           2 for a point that is projectable but outside the current map boundary -- not used for now
C           3 for a point that crosses the cyclic boundary
C init is 1 for a point that starts a polygon or polyline
C         0 otherwise
C
      integer status, init
C
      COMMON /MAPCM1/  COSO,COSR,SINO,SINR,IPRJ,IROD
      DOUBLE PRECISION COSO,COSR,SINO,SINR
      INTEGER          IPRJ,IROD
      SAVE   /MAPCM1/
C
      COMMON /MAPCM2/  BLAM,BLOM,PEPS,SLAM,SLOM,UCEN,UMAX,UMIN,UOFF,
     +     URNG,VCEN,VMAX,VMIN,VOFF,VRNG,ISSL
      DOUBLE PRECISION BLAM,BLOM,PEPS,SLAM,SLOM,UCEN,UMAX,UMIN,UOFF,
     +     URNG,VCEN,VMAX,VMIN,VOFF,VRNG
      INTEGER          ISSL
      SAVE   /MAPCM2/
C                                         

      COMMON /MAPCM8/  P,Q,R
      DOUBLE PRECISION P,Q,R
      SAVE   /MAPCM8/

      SAVE pold
C
C  P and PEPS are variables defined in EZMAP which are used to determine when a line crosses the cyclic boundary. PEPS is constant
C  relative to a particular map projection with set parameters for such things as center lon and map limites. P is calculated each time
C  the lat/lon to window transformation is performed for a particular point. Successive points where P differs by more than PEPS indicate
C  a crossing of the cyclic boundary. This routine is designed to give that information along with performing the transformation.
C
      status = 0
      if (peps .gt. 0.7 * (umax - umin)) then
         lpeps = .66 * peps
      else
         lpeps = peps
      end if


      CALL MAPTRN (RLAT,RLON,U,V)
      pval = p

      if (U .eq. 1e12) then
         status = 1
         pold = p
         return
      end if
         
      if (init .eq. 1) then
         pold = p
         return
      end if
      pnew = p

      if (iprj .ge. 2 .and. iprj .le. 6) then
C    
C crossover is not possible
C
         pold = pnew
         return
      end if

      if ((.not. pold .gt. 1e10) .AND. ABS(PNEW-POLD).GE.lpeps) then
         status = 3
C         print *, lpeps, pnew, pold, status
      end if

      pold = pnew

      return
      end

      PROGRAM FSSPOINT
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C INVOKE DEMO DRIVER
C
      CALL TAREAS(IWKID,IERR)
C
C Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      STOP
      END

      SUBROUTINE TAREAS (IWKID,IERROR)
C
C PURPOSE                To provide a simple demonstration of the use
C                        of AREAS.
C
C USAGE                  CALL TAREAS (IWKID,IERROR)
C
C ARGUMENTS
C
C ON INPUT               IWKID
C                          A workstation id number
C
C ON OUTPUT              IERROR
C
C                          an error parameter
C                          = 0, if the test is successful,
C                          = 1, otherwise
C
C I/O                    If the test is successful, the message
C
C                          AREAS TEST EXECUTED--SEE PLOTS TO CERTIFY
C
C                        is written on unit 6.
C
C PRECISION              Single.
C
C REQUIRED LIBRARY       AREAS, SPPS
C FILES
C
C REQUIRED GKS LEVEL     0A
C
C LANGUAGE               FORTRAN
C
C HISTORY                Written in JUNE, 1987.
C
C ALGORITHM              TAREAS constructs and colors a very simple
C                        picture illustrating the use of all of the
C                        routines in the package.
C
C PORTABILITY            FORTRAN 77
C
C Define an array in which to construct the area map.
C
        DIMENSION IAM(5000)
C
C Define the arrays needed for edge-coordinate data.
C
        DIMENSION XCA(73),YCA(73)
C
C Dimension the arrays needed by ARSCAM and ARDRLN for X/Y coordinates.
C
        DIMENSION XCS(150),YCS(150)
C
C Dimension the arrays needed by ARSCAM and ARDRLN for area and group
C identifiers.
C
        DIMENSION IAI(2),IAG(2)
C
C Define the RGB color triples needed below.
C
        DIMENSION RGB(3,15)
C
C Define a set of indices to order the colors.
C
        DIMENSION IOC(15)
C
C Define an array for GKS aspect source flags.
C
        DIMENSION IF(13)
C
C Declare the routine which will color the areas.
C
        EXTERNAL COLRAM
C
C Declare the routine which will draw lines over the circle.
C
        EXTERNAL COLRLN
C
        DATA RGB / 0.10 , 0.10 , 0.10 ,
     +             0.75 , 0.50 , 1.00 ,
     +             0.50 , 0.00 , 1.00 ,
     +             0.00 , 0.00 , 1.00 ,
     +             0.00 , 0.50 , 1.00 ,
     +             0.00 , 1.00 , 1.00 ,
     +             0.00 , 1.00 , 0.60 ,
     +             0.00 , 1.00 , 0.00 ,
     +             0.70 , 1.00 , 0.00 ,
     +             1.00 , 1.00 , 0.00 ,
     +             1.00 , 0.75 , 0.00 ,
     +             1.00 , 0.38 , 0.38 ,
     +             1.00 , 0.00 , 0.38 ,
     +             1.00 , 0.00 , 0.00 ,
     +             0.00 , 1.00 , 0.00 /
        DATA IOC / 6,2,5,12,10,11,1,3,4,8,9,7,13,14,15 /
C
C Declare the constant for converting from degrees to radians.
C
        DATA DTR / .017453292519943 /
C
C Set the aspect source flags for FILL AREA INTERIOR STYLE and for
C FILL AREA STYLE INDEX to "individual".
C
        CALL GQASF (IE,IF)
        IF(11)=1
        IF(12)=1
        CALL GSASF (IF)
C
C Force solid fill.
C
        CALL GSFAIS (1)
C
C Set the background color to white
C
        CALL GSCR(IWKID,0,1.,1.,1.)
C
C Define 15 different color indices.
C
        DO 101 J=1,15
           I=IOC(J)
           CALL GSCR(IWKID,J,RGB(1,I),RGB(2,I),RGB(3,I))
  101   CONTINUE
C
C Initialize the area map.
C
        CALL ARINAM (IAM,5000)
C
C Add edges to the area map.
C
        CALL SET (.01,.99,.01,.99,-1.,1.,-1.,1.,1)
C
C First, define a circle, using group 1 edges.  After this step, the
C area inside the circle has area identifier zero and the area outside
C has area identifier -1.
C
        DO 102 ING=1,73
           ANG=DTR*REAL(5*(ING-1))
           XCA(ING)=COS(ANG)
           YCA(ING)=SIN(ANG)
 102    CONTINUE
        CALL AREDAM (IAM,XCA,YCA,73,1,0,-1)
C
C Add lines splitting the circle into wedges.  The area identifiers
C for the wedges are added to the area map with this step.
C
        XCA(1)=0.
        YCA(1)=0.
        DO 103 ING=1,15
           ANG=DTR*REAL(24*(ING-1))
           XCA(2)=COS(ANG)
           YCA(2)=SIN(ANG)
           CALL AREDAM (IAM,XCA,YCA,2,1,ING,MOD(ING+13,15)+1)
 103    CONTINUE
C
C Now, put in another, smaller, off-center circle, using a group 2
C edge.  The interior of the circle has area identifier 1 and the
C exterior of the circle has group identifier 2.
C
        DO 104 ING=1,73
           ANG=DTR*REAL(5*(ING-1))
           XCA(ING)=.25+.5*COS(ANG)
           YCA(ING)=.25+.5*SIN(ANG)
 104    CONTINUE
        CALL AREDAM (IAM,XCA,YCA,73,2,1,2)
C
C Pre-process the area map.
C
        CALL ARPRAM (IAM,0,0,0)
C
C Compute and print the amount of space used in the area map.
C
        ISU=5000-(IAM(6)-IAM(5)-1)
        PRINT * , 'SPACE USED IN AREA MAP IS ',ISU
C
C Color the areas defined.
C
        CALL ARSCAM (IAM,XCS,YCS,150,IAI,IAG,2,COLRAM)
C
C In contrasting colors, draw three stars on the plot.
C
        DO 105 I=1,3
           IF (I.EQ.1) THEN
              XCN=-.5
              YCN=+.5
           ELSE IF (I.EQ.2) THEN
              XCN=-.5
              YCN=-.5
           ELSE IF (I.EQ.3) THEN
              XCN=+.5
              YCN=-.5
           END IF
           XCA(1)=XCN+.25*COS( 162.*DTR)
           YCA(1)=YCN+.25*SIN( 162.*DTR)
           XCA(2)=XCN+.25*COS(  18.*DTR)
           YCA(2)=YCN+.25*SIN(  18.*DTR)
           XCA(3)=XCN+.25*COS(-126.*DTR)
           YCA(3)=YCN+.25*SIN(-126.*DTR)
           XCA(4)=XCN+.25*COS(  90.*DTR)
           YCA(4)=YCN+.25*SIN(  90.*DTR)
           XCA(5)=XCN+.25*COS( -54.*DTR)
           YCA(5)=YCN+.25*SIN( -54.*DTR)
           XCA(6)=XCN+.25*COS( 162.*DTR)
           YCA(6)=YCN+.25*SIN( 162.*DTR)
           CALL ARDRLN (IAM,XCA,YCA,6,XCS,YCS,150,IAI,IAG,2,COLRLN)
 105    CONTINUE
C     
C     Draw a spiral of points in the blanked-out circle, using the colors
C     from edge group 1.
C     
        ICF=1
        DO 108 ING=1,1500
           RAD=REAL(ING)/1000.
           ANG=DTR*REAL(ING-1)
           XCD=.25+.5*RAD*COS(ANG)
           YCD=.25+.5*RAD*SIN(ANG)
           CALL ARGTAI (IAM,XCD,YCD,IAI,IAG,2,NAI,ICF)
           ITM=1
           DO 106 I=1,NAI
              IF (IAI(I).LT.0) ITM=0
 106       CONTINUE
           IF (ITM.NE.0) THEN
              IT1=0
              IT2=0
              DO 107 I=1,NAI
                 IF (IAG(I).EQ.1) IT1=IAI(I)
                 IF (IAG(I).EQ.2) IT2=IAI(I)
 107          CONTINUE
              IF (IT1.GT.0.AND.IT2.EQ.1) THEN
C     
C     Flush the polyline buffers and set polyline color index.
C     
                 CALL SFLUSH
                 CALL GSPLCI(IT1)
C     
                 CALL POINT (XCD,YCD)
              END IF
           END IF
           ICF=0
 108    CONTINUE
C
C Advance the frame.
C
        CALL FRAME
C
C Done.
C
        IERROR=0
        WRITE (6,1001)
C
        RETURN
C
 1001   FORMAT ('  AREAS TEST EXECUTED--SEE PLOTS TO CERTIFY')
C
      END
      SUBROUTINE COLRAM (XCS,YCS,NCS,IAI,IAG,NAI)
      DIMENSION XCS(*),YCS(*),IAI(*),IAG(*)
      ITM=1
      DO 101 I=1,NAI
         IF (IAI(I).LT.0) ITM=0
 101  CONTINUE
      IF (ITM.NE.0) THEN
         IT1=0
         DO 102 I=1,NAI
            IF (IAG(I).EQ.1) IT1=IAI(I)
            IF (IAG(I).EQ.2) IT2=IAI(I)
 102     CONTINUE
         IF (IT1.GT.0.AND.IT2.NE.1) THEN
C
C Set fill area color index.
C
            CALL GSFACI(IT1)
C     
            CALL GFA (NCS-1,XCS,YCS)
         END IF
      END IF
      RETURN
      END
      SUBROUTINE COLRLN (XCS,YCS,NCS,IAI,IAG,NAI)
      DIMENSION XCS(*),YCS(*),IAI(*),IAG(*)
      ITM=1
      DO 101 I=1,NAI
         IF (IAI(I).LT.0) ITM=0
 101  CONTINUE
      IF (ITM.NE.0) THEN
         IT1=0
         IT2=0
         DO 102 I=1,NAI
            IF (IAG(I).EQ.1) IT1=IAI(I)
            IF (IAG(I).EQ.2) IT2=IAI(I)
 102     CONTINUE
         IF (IT1.GT.0.AND.IT2.NE.1) THEN
C     
C     Flush PLOTIT's buffers and set polyline color index.
C     
            CALL PLOTIT(0,0,0)
            CALL GSPLCI(MOD(IT1+3,15)+1)
C     
            CALL GPL (NCS,XCS,YCS)
         END IF
      END IF
      RETURN
      END

C
C	$Id: remove32.f,v 1.4 2008-07-27 00:23:04 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE REMOVE (MX,MY,HIDDEN,IND)
C
C SUBROUTINE REMOVE CONTAINS THE DATA STRUCTURES FOR THE MODEL PICTURE
C WHICH IS USED TO DETERMINE IF A LINE WILL BE DRAWN OR REMOVED.
C ALL MANIPULATIONS ON THESE DATA STRUCTURES ARE DONE EXCLUSIVLY IN
C SUBROUTINE REMOVE.
C
C
C INPUT-OUTPUT-SPECIFICATIONS:
C
C  INPUT:
C   MX,MY: X- AND Y-COOORDINATES OF A POINT IN THE PLOTTING AREA.
C          MX AND MY RANGE FROM 0 TO 2**15-1.
C          NOTE: MX AND MY MAY BE LESS THAN 0 OR GREATER THAN 2**15-1
C                IN SOME SPECIAL CASES.
C   IND =1: REMOVE CALLED FROM RESET.
C          SET ALL ELEMENTS IN THE MODEL PICTURE TO NONMARKED.
C        =2: MARK THE POINT (MX,MY) AND THE POINTS NEXT TO IT.
C        =3: CHECK IF THE POINT (MX,MY) IS ALREADY MARKED. RETURN RESULT
C           IN HIDDEN.
C  OUTPUT:
C   MX, MY, AND IND ARE UNCHANGED.
C   HIDDEN: LOGICAL, ONLY RELEVANT IF IND=3.
C          RETURNS .TRUE. IF THE POINT WITH COORDINATES (MX,MY) IS
C          ALREADY MARKED, OTHERWISE .FALSE.
C  COMMON-BLOCKS:
C   ARRAY ISCREN IS CHANGED AS DEFINED ABOVE IF IND IS 1 OR 2.
C
C
C NOTE
C   THE IMPLEMENTATION OF THE MODEL PICTURE MAY BE CHANGED NOT HOWEVER
C   THE INPUT-OUTPUT SPECIFICATIONS STATED ABOVE.
C
C
C ALGORITHM
C THIS IMPLEMENTATION OF A MODEL PICTURE USES A BIT MAP. EACH PLOTTER
C ADDRESS (POINT) IS REPRESENTED BY A BIT IN THE ARRAY ISCREN. INITIALLY
C EACH BIT IS SET TO 0 BY A CALL TO THE SUBROUTINE RESET. WHEN A LINE
C IS DRAWN ALL BITS REPRESENTING POINTS ON THE LINE ARE SET TO 1. BEFORE
C A LINE IS DRAWN THE MODEL PICTURE IS CHECKED. IF THE BITS IN THE
C MODEL PICTURE REPRESENTING THE POINTS ON THE LINE ARE ALREADY 1 THEN
C THE LINE IS NOT DRAWN, OTHERWISE THE LINE IS DRAWN AND THE
C CORRESPONDING BITS ARE SET TO 1.
C
C
C
C
      LOGICAL HIDDEN
      SAVE
C
      DIMENSION MASK(64),MASK3(64)
C
C
C *********************************************************************
C
C MACHINE AND MODEL DEPENDENT DECLARATIONS AND CONSTANT DEFINITIONS
C
C
C CHOOSE NOW THE SIZE OF YOUR MODEL PICTURE AS NX BY NY.
C ONLY SIZES WITH NX EQUAL TO NY HAVE BEEN TESTED SO FAR.
C ALSO ONLY SIZES WITH NX AND NY POWERS OF 2 ARE POSSIBLE.
C MODEL PICTURES IN SIZE EQUAL TO OR CLOSE TO YOUR PLOTTER ADDRESS SPACE
C ARE RECOMMENDED.
C ASSUME THE MODEL PICTURE IS OF SIZE NX BY NY. THEN ARRAY ISCREN NEEDS
C NY COLUMNS AND NX/NBWD+1 ROWS WHERE NBWD IS THE NUMBER OF BITS PER
C INTEGER STORAGE UNIT.
      DIMENSION ISCREN(33,1024)
C E.G. FOR A 1024 BY 1024 MODEL PICTURE ON A 60 BIT MACHINE
C     DIMENSION ISCREN(18,1024)
C
C NX AND NY ARE THE LENGTHS OF THE MODEL PICTURE IN X AND Y DIRECTION.
C LX AND NY ARE THE DIMENSIONS OF THE ARRAY ISCREN WHICH IS USED TO
C REPRESENT THE MODEL PICTURE.
C FOR ANY SIZE OF A MODEL PICTURE THE NUMBER OF COLUMNS IN ISCREN IS
C ALWAYS EQUAL TO THE LENGTH OF THE MODEL PICTURE IN Y DIRECTION.
C
      DATA NX,NY,LX /1024,1024,33/
C E.G. FOR A 1024 BY 1024 MODEL PICTURE ON A 60 BIT MACHINE
C     DATA NX,NY,LX /1024,1024,18/
C
C NXSIZE IS AN INTEGER SUCH THAT 2**NXSIZE = NX
C NYSIZE IS AN INTEGER SUCH THAT 2**NYSIZE = NY
C
      DATA NXSIZE,NYSIZE /10,10/
C E. G. FOR A 1024 BY 1024 MODEL PICTURE
C     DATA NXSIZE,NYSIZE /10,10/
C
C
C END OF MACHINE AND MODEL DEPENDENT DECLARATIONS AND CONSTANT
C DEFINITIONS
C
C **********************************************************************
C
C ARRAY MASK CONTAINS SINGLE BIT MASKS FOR EACH BIT IN THE WORD.
C ENTRY I IN ARRAY MASK CONTAINS A WORD WITH THE I-TH BIT FROM THE RIGHT
C A 1 AND ALL OTHER BITS 0.
C THESE MASKS ARE USED TO CHECK IF A GIVEN POINT IN THE MODEL PICTURE
C HAS ALREADY BEEN MARKED.
C
C ARRAY MASK3 ALSO CONTAINS A MASK FOR EACH BIT IN THE WORD, BUT THE
C BIT TO THE LEFT AND THE BIT TO THE RIGHT ARE NOW SET AS WELL (EXCEPT
C AT THE EDGES). ENTRY I IN THE ARRAY MASK3 CONTAINS A WORD WITH THE
C (I-1)-TH,I-TH, AND(I+1)-TH BITS FROM THE RIGHT 1'S AND ALL OTHER BITS
C ZEROES.
C THESE MASKS ARE USED TO MARK 3 POINTS IN THE MODEL PICTURE AT THE SAME
C TIME.
C
C     FLAG FOR FIRST CALL (USED TO DETERMINE IF MASKS SHOULD
C     BE DEFINED BY CALLING INTMSK)
C
      DATA IFSTC/0/
C
C     DEFINE MASKS IF THIS IS THE FIRST CALL TO REMOVE
C
      IF (IFSTC .GT. 0) GO TO 5
C
C     CHECK IF THE IMPLEMENTATION-DEPENDENT CONSTANTS HAVE BEEN SET
C
      IF (NX .EQ. 0) THEN
        WRITE(6,500)
        STOP
      ENDIF
  500 FORMAT('     IN SUBROUTINE REMOVE OF DASHSUPR:',/
     -'       IMPLEMENTATION-DEPENDENT CONSTANTS NOT SET--',/
     -'       SEE INSTRUCTIONS AFTER INITIAL COMMENT CARDS.')
      CALL INTMSK(MASK,MASK3)
      IFSTC = 1
    5 CONTINUE
C
C IF COORDINATES ARE OUT OF RANGE, QUIT.  (DJK, 04/27/88)
C
      IF (MX.LT.0.OR.MX.GT.32767.OR.MY.LT.0.OR.MY.GT.32767) THEN
        IF (IND.EQ.3) HIDDEN=.TRUE.
        RETURN
      END IF
C
C RETRIEVE THE NUMBER OF BITS PER INTEGER STORAGE UNIT.
C
      NBPW = I1MACH(5)
C
C TRANSFORM THE INPUT COORDINATES INTO MODEL PICTURE COORDINATES.
C
      IX = ISHIFT (MX,NXSIZE-15)
      IY = ISHIFT (MY,NYSIZE-15) + 1
C
C FIND THE ELEMENT IN THE ISCREN ARRAY REPRESENTING THE POINT (MX,MY).
C
      IBIT = MOD(IX,NBPW)+1
      IX = IX/NBPW+1
C
C BRANCH DEPENDING ON FUNCTION TO BE PERFORMED
C
      GOTO (1,2,3) , IND
C
C ***********************************************
C
C CHECK IF THE POINT (MX,MY) IS ALREADY MARKED
C
    3 CONTINUE
      HIDDEN = .TRUE.
      ITEMP = IAND(ISCREN(IX,IY),MASK(IBIT))
      IF (ITEMP .EQ. 0) HIDDEN = .FALSE.
      RETURN
C
C ***********************************************
C
C MARK THE POINT (MX,MY) AND THE POINTS NEXT TO IT
C
    2 CONTINUE
C
C MARK THE POINTS (MX,MY) , (MX,MY+1) AND (MX,MY-1) IF THEY ARE IN
C THE PLOTTING AREA.
C MARK ALSO 3 POINTS FOR MX+1 AND MX-1 IN MOST CASES.
C
      ISCREN(IX,IY) = IOR(ISCREN(IX,IY),MASK3(IBIT))
      IF (IY .LT. NY) ISCREN(IX,IY+1) = IOR(ISCREN(IX,IY+1),MASK3(IBIT))
      IF (IY .GT. 1) ISCREN(IX,IY-1) = IOR(ISCREN(IX,IY-1),MASK3(IBIT))
      IF (IBIT .EQ. 1) GO TO 10
      IF (IBIT .EQ. NBPW) GO TO 20
      RETURN
C RETURN IF THE LEFT EDGE OF THE PLOTTING AREA IS REACHED.
   10 IF (IX .EQ. 1) RETURN
C
C MARK 3 POINTS TO THE LEFT OF (MX,MY)
C
      ISCREN(IX-1,IY) = IOR(ISCREN(IX-1,IY),MASK(NBPW))
      IF (IY .GT. 1) ISCREN(IX-1,IY-1) = IOR(ISCREN(IX-1,IY-1),
     1                                       MASK(NBPW))
      IF (IY .LT. NY)
     1    ISCREN(IX-1,IY+1) = IOR(ISCREN(IX-1,IY+1),MASK(NBPW))
      RETURN
C RETURN IF THE RIGHT EDGE OF THE PLOTTING AREA IS REACHED.
   20 IF (IX .EQ. LX) RETURN
C
C MARK 3 POINTS TO THE RIGHT OF (MX,MY).
C
      ISCREN(IX+1,IY) = IOR(ISCREN(IX+1,IY),MASK(1))
      IF (IY .GT. 1) ISCREN(IX+1,IY-1) =  IOR(ISCREN(IX+1,IY-1),MASK(1))
      IF (IY .LT. NY) ISCREN(IX+1,IY+1) = IOR(ISCREN(IX+1,IY+1),MASK(1))
      RETURN
C
C ***********************************************
C
C ENTRY RESET . SET ALL THE ELEMENTS IN THE ARRAY ISCREN TO 0.
C
    1 CONTINUE
      DO 40 J = 1,NY
      DO 30 I = 1,LX
         ISCREN(I,J) = 0
   30 CONTINUE
   40 CONTINUE
      RETURN
C
      END

c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by UCAR                 .
c  .                                                             .
c  .       University Corporation for Atmospheric Research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                         SPHEREPACK                          .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c
c
c
c ... file isfvpec.f
c
c     this file includes documentation and code for
c     subroutine isfvpec          i
c
c ... files which must be loaded with isfvpec.f
c
c     sphcom.f, hrfft.f, vhsec.f,shaec.f
c
c
c     subroutine isfvpec(nlat,nlon,isym,nt,sf,vp,idv,jdv,as,bs,av,bv,
c    +                   mdb,ndb,wvhsec,lvhsec,work,lwork,ierror)
c
c     given the scalar spherical harmonic coefficients as,bs precomputed
C*PL*ERROR* Comment line too long
c     by shaec for the scalar stream function sf and av,bv precomputed by
C*PL*ERROR* Comment line too long
c     shaec for the scalar velocity potenital vp, subroutine isfvpec computes
c     the vector field (v,w) corresponding to sf and vp.  w is the east
C*PL*ERROR* Comment line too long
c     longitudinal and v is the colatitudinal component of the vector field.
C*PL*ERROR* Comment line too long
c     (v,w) is expressed in terms of sf,vp by the helmholtz relations (in
c     mathematical spherical coordinates):
c
c          v = -1/sin(theta)*d(vp)/dlambda + d(st)/dtheta
c
c          w =  1/sin(theta)*d(st)/dlambda + d(vp)/dtheta
c
c     required legendre functions are recomputed rather than stored as
c     they are in subroutine isfvpes.  v(i,j) and w(i,j) are given at
c     colatitude
c
c            theta(i) = (i-1)*pi/(nlat-1)
c
c     and east longitude
c
c            lambda(j) = (j-1)*2*pi/nlon
c
c     on the sphere (pi=4.0*atan(1.0)).
c
c
c     input parameters
c
c     nlat   the number of colatitudes on the full sphere including the
c            poles. for example, nlat = 37 for a five degree grid.
c            nlat determines the grid increment in colatitude as
c            pi/(nlat-1).  if nlat is odd the equator is located at
c            grid point i=(nlat+1)/2. if nlat is even the equator is
c            located half way between points i=nlat/2 and i=nlat/2+1.
c            nlat must be at least 3. note: on the half sphere, the
c            number of grid points in the colatitudinal direction is
c            nlat/2 if nlat is even or (nlat+1)/2 if nlat is odd.
c
c     nlon   the number of distinct londitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater than
c            3.  the efficiency of the computation is improved when nlon
c            is a product of small prime numbers.
c
c
c     isym   a parameter which determines whether the vector field is
c            computed on the full or half sphere as follows:
c
c      = 0
c
c            the symmetries/antsymmetries described in isym=1,2 below
c            do not exist in sf,vp about the equator.  in this case v
c            and w are not necessarily symmetric or antisymmetric about
c            equator.  v and w are computed on the entire sphere.
c            i.e., in arrays sf(i,j),vp(i,j) for i=1,...,nlat and
c            j=1,...,nlon.
c
c      = 1
c
c            vp is antisymmetric and sf is symmetric about the equator.
c            in this case v is symmetric and w antisymmetric about
c            the equator and are computed for the northern hemisphere
c            only.  i.e., if nlat is odd the v(i,j),w(i,j) are computed
c            for i=1,...,(nlat+1)/2 and for j=1,...,nlon.  if nlat is
c            even then v(i,j),w(i,j) are computed for i=1,...,nlat/2
c            and j=1,...,nlon.
c
c      = 2
c
c            vp is symmetric and sf is antisymmetric about the equator.
c            in this case v is antisymmetric and w symmetric about
c            the equator and are computed for the northern hemisphere
c            only.  i.e., if nlat is odd the v(i,j),w(i,j) are computed
c            for i=1,...,(nlat+1)/2 and for j=1,...,nlon.  if nlat is
c            even then v(i,j),w(i,j) are computed for i=1,...,nlat/2
c            and j=1,...,nlon.
c
c     nt     nt is the number of scalar and vector fields.  some
C*PL*ERROR* Comment line too long
c            computational efficiency is obtained for multiple fields. arrays
C*PL*ERROR* Comment line too long
c            can be three dimensional corresponding to an indexed multiple
c            vector field.  in this case multiple vector synthesis will
c            be performed to compute (v,w) for each field.  the
c            third index is the synthesis index which assumes the values
c            k=1,...,nt.  for a single synthesis set nt = 1.  the
c            description of the remaining parameters is simplified by
C*PL*ERROR* Comment line too long
c            assuming that nt=1 or that all the arrays are two dimensional.
c
c     idv    the first dimension of the arrays v,w as it appears in
c            the program that calls isfvpec. if isym = 0 then idv
c            must be at least nlat.  if isym = 1 or 2 and nlat is
c            even then idv must be at least nlat/2. if isym = 1 or 2
c            and nlat is odd then idv must be at least (nlat+1)/2.
c
c     jdv    the second dimension of the arrays v,w as it appears in
c            the program that calls isfvpec. jdv must be at least nlon.
c
c     as,bs  two or three dimensional arrays (see input parameter nt)
c            that contain the spherical harmonic coefficients of
c            the scalar field sf as computed by subroutine shaec.
c
c     av,bv  two or three dimensional arrays (see input parameter nt)
c            that contain the spherical harmonic coefficients of
c            the scalar field vp as computed by subroutine shaec.
c
c     mdb    the first dimension of the arrays as,bs,av,bv as it
c            appears in the program that calls isfvpec. mdb must be at
c            least min0(nlat,(nlon+2)/2) if nlon is even or at least
c            min0(nlat,(nlon+1)/2) if nlon is odd.
c
c     ndb    the second dimension of the arrays as,bs,av,bv as it
c            appears in the program that calls isfvpec. ndb must be at
c            least nlat.
c
c     wvhsec an array which must be initialized by subroutine vhseci.
c            once initialized, wvhsec can be used repeatedly by isfvpec
c            as long as nlon and nlat remain unchanged.  wvhsec must
c            not bel altered between calls of isfvpec.
c
c
c     lvhsec the dimension of the array wvhsec as it appears in the
c            program that calls isfvpec. define
c
c               l1 = min0(nlat,nlon/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            then lvhsec must be at least
c
c
c               4*nlat*l2+3*max0(l1-2,0)*(nlat+nlat-l1-1)+nlon+15
c
c
c     work   a work array that does not have to be saved.
c
c     lwork  the dimension of the array work as it appears in the
c            program that calls isfvpec. define
c
c               l1 = min0(nlat,nlon/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2                    if nlat is even or
c               l2 = (nlat+1)/2                if nlat is odd
c
c            if isym = 0 then lwork must be at least
c
c               nlat*(2*nt*nlon+max0(6*l2,nlon)+4*l1*nt+1)
c
c            if isym = 1 or 2 then lwork must be at least
c
c               l2*(2*nt*nlon+max0(6*nlat,nlon))+nlat*(4*l1*nt+1)
c
c     **************************************************************
c
c     output parameters
c
c    v,w    two or three dimensional arrays (see input parameter nt)
c           that contains the vector field corresponding to the stream
c           function sf and velocity potential vp whose coefficients,
c           as,bs (for sf) and av,bv (for vp), were precomputed by
c           subroutine shaec.  v(i,j) and w(i,j) are given at the
c           colatitude point
c
c                theta(i) = (i-1)*pi/(nlat-1)
c
c           and longitude point
c
c                lambda(j) = (j-1)*2*pi/nlon
c
C*PL*ERROR* Comment line too long
c           the index ranges are defined above at the input parameter isym.
c
c
c    ierror = 0  no errors
c           = 1  error in the specification of nlat
c           = 2  error in the specification of nlon
c           = 3  error in the specification of isym
c           = 4  error in the specification of nt
c           = 5  error in the specification of idv
c           = 6  error in the specification of jdv
c           = 7  error in the specification of mdb
c           = 8  error in the specification of ndb
c           = 9  error in the specification of lvhsec
c           = 10 error in the specification of lwork
c **********************************************************************
c
      SUBROUTINE DISFVPEC(NLAT,NLON,ISYM,NT,V,W,IDV,JDV,AS,BS,AV,BV,MDB,
     +                   NDB,WVHSEC,LVHSEC,WORK,LWORK,IERROR)
      IMPLICIT NONE
      INTEGER NLAT,NLON,ISYM,NT,IDV,JDV,MDB,NDB,LVHSEC,LWORK,IERROR
      DOUBLE PRECISION V(IDV,JDV,NT),W(IDV,JDV,NT)
      DOUBLE PRECISION AS(MDB,NDB,NT),BS(MDB,NDB,NT)
      DOUBLE PRECISION AV(MDB,NDB,NT),BV(MDB,NDB,NT)
      DOUBLE PRECISION WVHSEC(LVHSEC),WORK(LWORK)
      INTEGER MMAX,L1,L2,LZZ1,LABC,MN,IS,LWK,IWK,LWMIN
      INTEGER IBR,IBI,ICR,ICI
c
c     check input parameters
c
      IERROR = 1
      IF (NLAT.LT.3) RETURN
      IERROR = 2
      IF (NLON.LT.4) RETURN
      IERROR = 3
      IF (ISYM.LT.0 .OR. ISYM.GT.2) RETURN
      IERROR = 4
      IF (NT.LT.0) RETURN
      IERROR = 5
      L2 = (NLAT+1)/2
      IF ((ISYM.EQ.0.AND.IDV.LT.NLAT) .OR.
     +    (ISYM.GT.0.AND.IDV.LT.L2)) RETURN
      IERROR = 6
      IF (JDV.LT.NLON) RETURN
      IERROR = 7
      L1 = MIN0(NLAT, (NLON+1)/2)
      IF (MDB.LT.MIN0(NLAT, (NLON+2)/2)) RETURN
      IERROR = 8
      IF (NDB.LT.NLAT) RETURN
      IERROR = 9
      LZZ1 = 2*NLAT*L2
      LABC = 3* (MAX0(L1-2,0)* (NLAT+NLAT-L1-1))/2
      IF (LVHSEC.LT.2* (LZZ1+LABC)+NLON+15) RETURN
      IERROR = 10
      IF (ISYM.EQ.0) THEN
          LWMIN = NLAT* (2*NT*NLON+MAX0(6*L2,NLON)+4*L1*NT+1)
      ELSE
          LWMIN = L2* (2*NT*NLON+MAX0(6*NLAT,NLON)) + NLAT* (4*L1*NT+1)
      END IF
      IF (LWORK.LT.LWMIN) RETURN
c
c     set first dimension for br,bi,cr,ci (as requried by vhsec)
c
      MMAX = MIN0(NLAT, (NLON+1)/2)
      MN = MMAX*NLAT*NT
      IERROR = 0
c
c     set work space pointers
c
      IBR = 1
      IBI = IBR + MN
      ICR = IBI + MN
      ICI = ICR + MN
      IS = ICI + MN
      IWK = IS + NLAT
      LWK = LWORK - 4*MN - NLAT
      CALL DISFVPEC1(NLAT,NLON,ISYM,NT,V,W,IDV,JDV,AS,BS,AV,BV,MDB,NDB,
     +              WORK(IBR),WORK(IBI),WORK(ICR),WORK(ICI),L1,WORK(IS),
     +              WVHSEC,LVHSEC,WORK(IWK),LWK,IERROR)
      RETURN
      END

      SUBROUTINE DISFVPEC1(NLAT,NLON,ISYM,NT,V,W,IDV,JDV,AS,BS,AV,BV,
     +                     MDB,NDB,BR,BI,CR,CI,MAB,FNN,WVHSEC,LVHSEC,
     +                     WK,LWK,IERROR)
      IMPLICIT NONE
      INTEGER NLAT,NLON,ISYM,NT,IDV,JDV,MDB,NDB,MAB,LVHSEC,LWK,IERROR
      DOUBLE PRECISION V(IDV,JDV,NT),W(IDV,JDV,NT)
      DOUBLE PRECISION AS(MDB,NDB,NT),BS(MDB,NDB,NT)
      DOUBLE PRECISION AV(MDB,NDB,NT),BV(MDB,NDB,NT)
      DOUBLE PRECISION BR(MAB,NLAT,NT),BI(MAB,NLAT,NT)
      DOUBLE PRECISION CR(MAB,NLAT,NT),CI(MAB,NLAT,NT)
      DOUBLE PRECISION WVHSEC(LVHSEC),WK(LWK),FNN(NLAT)
      INTEGER N,M,MMAX,K,ITYP
c
c     set coefficient multiplyers
c
      DO N = 2,NLAT
          FNN(N) = -SQRT(DBLE(N* (N-1)))
      END DO
      MMAX = MIN0(NLAT, (NLON+1)/2)
c
c     compute (v,w) coefficients from as,bs,av,bv
c
      DO K = 1,NT
          DO N = 1,NLAT
              DO M = 1,MAB
                  BR(M,N,K) = 0.0D0
                  BI(M,N,K) = 0.0D0
                  CR(M,N,K) = 0.0D0
                  CI(M,N,K) = 0.0D0
              END DO
          END DO
c
c     compute m=0 coefficients
c
          DO N = 2,NLAT
              BR(1,N,K) = -FNN(N)*AV(1,N,K)
              BI(1,N,K) = -FNN(N)*BV(1,N,K)
              CR(1,N,K) = FNN(N)*AS(1,N,K)
              CI(1,N,K) = FNN(N)*BS(1,N,K)
          END DO
c
c     compute m>0 coefficients using vector spherepack value for mmax
c
          DO M = 2,MMAX
              DO N = M,NLAT
                  BR(M,N,K) = -FNN(N)*AV(M,N,K)
                  BI(M,N,K) = -FNN(N)*BV(M,N,K)
                  CR(M,N,K) = FNN(N)*AS(M,N,K)
                  CI(M,N,K) = FNN(N)*BS(M,N,K)
              END DO
          END DO
      END DO
c
c     synthesize br,bi,cr,ci into (v,w)
c
      IF (ISYM.EQ.0) THEN
          ITYP = 0
      ELSE IF (ISYM.EQ.1) THEN
          ITYP = 3
      ELSE IF (ISYM.EQ.2) THEN
          ITYP = 6
      END IF
      CALL DVHSEC(NLAT,NLON,ITYP,NT,V,W,IDV,JDV,BR,BI,CR,CI,MAB,NLAT,
     +           WVHSEC,LVHSEC,WK,LWK,IERROR)
      RETURN
      END

        PROGRAM CPEX09
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
        PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Define an array for the data.
C
        DIMENSION ZDAT(40,40)
C
C Generate dummy data.
C
        CALL GENDAT (ZDAT,40,40,40,14,14,-145.6,389.7)
C
C Open GKS.
C
        CALL GOPKS (IERRF, ISZDM)
        CALL GOPWK (IWKID, LUNIT, IWTYPE)
        CALL GACWK (IWKID)
C
C Turn off clipping by GKS.
C
        CALL GSCLIP (0)
C
C Force the use of medium-quality characters by the package PLOTCHAR.
C
        CALL PCSETI ('QU - QUALITY OF CHARACTERS',1)
C
C Put a label at the top of the first plot.  (The SET call is not
C needed for CPEZCT, but for the labelling routine.)
C
        CALL SET (.05,.95,.05,.95,0.,1.,0.,1.,1)
        CALL LABTOP ('EXAMPLE 9-1',.017)
C
C Put a boundary line at the edge of the plotter frame.
C
        CALL BNDARY
C
C Contour the data, using the EZCNTR simulator.
C
        CALL CPEZCT (ZDAT,40,40)
C
C Contour a subset of the data, forcing a contour interval of 20, using
C the CONREC simulator.
C
        CALL CPCNRC (ZDAT(7,9),40,32,24,0.,0.,20.,3,0,-682)
C
C Put a boundary line at the edge of the plotter frame, label the plot,
C and advance the frame.
C
        CALL BNDARY
        CALL LABTOP ('EXAMPLE 9-2',.017)
        CALL FRAME
C
C Switch to the "penalty scheme" for positioning contour-line labels
C and change one of the constants which are used by it.
C
        CALL CPSETI ('LLP - LINE LABEL POSITIONING',3)
        CALL CPSETR ('PC1 - PENALTY SCHEME CONSTANT 1',1.5)
C
C Turn on the smoother, with a relatively high tension.
C
        CALL CPSETI ('T2D - TENSION ON THE 2D SMOOTHER',4)
C
C Force the labelling of every other contour line.  (This will only
C work when the contour interval is forced, as it will be in the next
C call to CPCNRC.)
C
        CALL CPSETI ('LIS - LABEL INTERVAL SPECIFIER',2)
C
C Repeat the last plot, forcing a contour interval of 10.
C
        CALL CPCNRC (ZDAT(7,9),40,32,24,0.,0.,10.,3,0,-682)
C
C Put a boundary line at the edge of the plotter frame, label the plot,
C and advance the frame.
C
        CALL BNDARY
        CALL LABTOP ('EXAMPLE 9-3',.017)
        CALL FRAME
C
C Create an EZMAP background.
C
        CALL MAPSTI ('PE - PERIMETER',0)
        CALL MAPSTI ('GR - GRID',0)
        CALL MAPSTC ('OU - OUTLINE DATASET','PS')
        CALL MAPSTI ('DO - DOTTING OF OUTLINES',1)
        CALL MAPSTR ('SA - SATELLITE HEIGHT',1.13)
        CALL MAPROJ ('SV - SATELLITE-VIEW',40.,-95.,0.)
        CALL MAPSET ('MA - MAXIMAL AREA',0.,0.,0.,0.)
        CALL MAPDRW
C
C Arrange for output from CPCNRC to be placed on the EZMAP background.
C
        CALL CPSETR ('XC1 - X COORDINATE AT I = 1',-130.)
        CALL CPSETR ('XCM - X COORDINATE AT I = M',-60.)
        CALL CPSETR ('YC1 - Y COORDINATE AT J = 1',10.)
        CALL CPSETR ('YCN - Y COORDINATE AT J = N',70.)
        CALL CPSETI ('MAP - MAPPING FLAG',1)
        CALL CPSETR ('ORV - OUT-OF-RANGE VALUE',1.E12)
C
C Define some special values and arrange for the special-value area to
C be outlined.
C
        ZDAT(15,13)=1.E36
        ZDAT(16,13)=1.E36
        ZDAT(15,14)=1.E36
        CALL CPSETR ('SPV - OUT-OF-RANGE VALUE',1.E36)
        CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',-2)
        CALL CPSETI ('CLU - CONTOUR LEVEL USE FLAG',1)
C
C Specify that high/low labels are to be written at an angle of 30
C degrees, using relatively small characters.  (These parameters will
C really be used for point-value labels.)
C
        CALL CPSETR ('HLA - HIGH/LOW LABEL ANGLE',30.)
        CALL CPSETR ('HLS - HIGH/LOW LABEL CHARACTER SIZE',.008)
C
C Turn off line labelling.
C
        CALL CPSETI ('LLP - LINE LABEL POSITIONING',0)
C
C Use the CONREC simulator to plot a subset of the data on the EZMAP
C background, labelling each data point.
C
        CALL CPCNRC (ZDAT(9,7),40,20,20,0.,0.,10.,4,1,-682)
C
C Put a boundary line at the edge of the plotter frame, label the plot,
C and advance the frame.
C
        CALL BNDARY
        CALL LABTOP ('EXAMPLE 9-4',.017)
        CALL FRAME
C
C Close GKS.
C
        CALL GDAWK (IWKID)
        CALL GCLWK (IWKID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END

C
C $Id: agftol.f,v 1.6 2008-07-27 00:14:34 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE AGFTOL (IAXS,IDMA,VINP,VOTP,VLCS,LLUA,UBEG,UDIF,FUNS,
     +                                                        NBTP,SBSE)
C
C The routine AGFTOL is used by AGAXIS to map a fractional distance
C along the axis to a value in the label coordinate system or vice-
C versa.  Its arguments are as follows:
C
C -- IAXS specifies which axis is being drawn.  It is passed to the
C    routine AGUTOL.  See AGAXIS for a complete description of IAXS.
C
C -- IDMA specifies the direction of the mapping - from the fractional
C    system to the label system if IDMA .GT. 0 or from the label system
C    to the fractional system if IDMA .LT. 0.  IDMA also specifies how
C    the label-system value is given to or returned by AGFTOL.
C
C     -- If ABSV(IDMA) .EQ. 1, an actual value in the label coordinate
C        system (VLCS) is given to or returned by AGFTOL.
C
C     -- If ABSV(IDMA) .NE. 1, a value of the exponent/multiplier EXMU
C        corresponding to VLCS is given to or returned by AGFTOL.
C
C -- VINP is an input value in one coordinate system.
C
C -- VOTP is an output value in the other coordinate system.
C
C -- VLCS is an output value in the label coordinate system, returned
C    no matter what the value of IDMA.
C
C -- LLUA, UBGA, and UDFA specify the mapping from the user coordinate
C    system to the fractional system and vice-versa.  See the routine
C    AGAXIS for a complete description of these parameters.
C
C -- FUNS is a function-selector, to be used in calls to AGUTOL.  It
C    selects the mapping from the user coordinate system to the label
C    coordinate system and vice-versa.  See the routine AGAXIS for a
C    complete description of this parameter.
C
C -- NBTP and SBSE specify the mapping of label-coordinate-system values
C    to exponent/multiplier values and vice-versa.  See the routine
C    AGNUMB for a complete dexcription of these parameters.
C
C Determine desired direction of mapping.
C
      IF (IDMA.GT.0) THEN
C
C Map axis fraction VINP to a label-coordinate-system value VLCS.
C
        VUCS=UBEG+VINP*UDIF
        IF (LLUA.NE.0) VUCS=10.**VUCS
        CALL AGUTOL (IAXS,FUNS,1,VUCS,VLCS)
C
C If IDMA .EQ. 1, caller wants VLCS - otherwise, map VLCS to the
C appropriate exponent/multiplier value EXMU - return value in VOTP.
C
        IF (IDMA.EQ.1) THEN
          VOTP=VLCS
          RETURN
        END IF
C
        GO TO (101,102,103) , NBTP
C
  101   VOTP=VLCS/SBSE
        RETURN
C
  102   VOTP=ALOG10(VLCS/SBSE)
        RETURN
C
  103   VOTP=ALOG10(ABS(VLCS))/ALOG10(ABS(SBSE))
        RETURN
C
      ELSE
C
C If IDMA .EQ. -1, caller has provided VINP .EQ. VLCS, a value in the
C label coordinate system - otherwise, VINP .EQ. EXMU, the exponent/
C multiplier needed to generate VLCS.
C
        IF (IDMA.EQ.(-1)) THEN
          VLCS=VINP
          GO TO 107
        END IF
C
        GO TO (104,105,106) , NBTP
C
  104   VLCS=SBSE*VINP
        GO TO 107
C
  105   VLCS=SBSE*10.**VINP
        GO TO 107
C
  106   VLCS=SIGN(1.,SBSE)*ABS(SBSE)**VINP
C
C Map label-system value VLCS to a user-system value VUCS.
C
  107   CALL AGUTOL (IAXS,FUNS,-1,VLCS,VUCS)
C
C Map user-system value VUCS to an axis fraction VOTP and return.
C
        IF (LLUA.NE.0) VUCS=ALOG10(VUCS)
        VOTP=(VUCS-UBEG)/UDIF
        RETURN
C
      END IF
C
      END

C
C	$Id: cscrlist.f,v 1.5 2008-07-27 03:10:06 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CSCRLIST (N,NCOL,X,Y,Z,LIST,LEND, LPTR,LNEW,
     .                   LTRI, LISTC,NB,RLATO,RLONO,RC,IER)
      INTEGER  N, NCOL, LIST(*), LEND(N), LPTR(*), LNEW,
     .         LTRI(6,NCOL), LISTC(*), NB, IER
      DOUBLE PRECISION X(N), Y(N), Z(N), RLATO(*), RLONO(*),
     .                 RC(*), XD, YD, ZD, PNM
C
C***********************************************************
C
C                                              From STRIPACK
C                                            Robert J. Renka
C                                  Dept. of Computer Science
C                                       Univ. of North Texas
C                                           renka@cs.unt.edu
C                                                   07/05/98
C
C   Given a Delaunay triangulation of nodes on the surface
C of the unit sphere, this subroutine returns the set of
C triangle circumcenters corresponding to Voronoi vertices,
C along with the circumradii and a list of triangle indexes
C LISTC stored in one-to-one correspondence with LIST/LPTR
C entries.
C
C   A triangle circumcenter is the point (unit vector) lying
C at the same angular distance from the three vertices and
C contained in the same hemisphere as the vertices.  (Note
C that the negative of a circumcenter is also equidistant
C from the vertices.)  If the triangulation covers the sur-
C face, the Voronoi vertices are the circumcenters of the
C triangles in the Delaunay triangulation.  LPTR, LEND, and
C LNEW are not altered in this case.
C
C   On the other hand, if the nodes are contained in a sin-
C gle hemisphere, the triangulation is implicitly extended
C to the entire surface by adding pseudo-arcs (of length
C greater than 180 degrees) between boundary nodes forming
C pseudo-triangles whose 'circumcenters' are included in the
C list.  This extension to the triangulation actually con-
C sists of a triangulation of the set of boundary nodes in
C which the swap test is reversed (a non-empty circumcircle
C test).  The negative circumcenters are stored as the
C pseudo-triangle 'circumcenters'.  LISTC, LPTR, LEND, and
C LNEW contain a data structure corresponding to the ex-
C tended triangulation (Voronoi diagram), but LIST is not
C altered in this case.  Thus, if it is necessary to retain
C the original (unextended) triangulation data structure,
C copies of LPTR and LNEW must be saved before calling this
C routine.
C
C
C On input:
C
C       N = Number of nodes in the triangulation.  N .GE. 3.
C           Note that, if N = 3, there are only two Voronoi
C           vertices separated by 180 degrees, and the
C           Voronoi regions are not well defined.
C
C       NCOL = Number of columns reserved for LTRI.  This
C              must be at least NB-2, where NB is the number
C              of boundary nodes.
C
C       X,Y,Z = Arrays of length N containing the Cartesian
C               coordinates of the nodes (unit vectors).
C
C       LIST = Integer array containing the set of adjacency
C              lists.  Refer to Subroutine CSTRMESH.
C
C       LEND = Set of pointers to ends of adjacency lists.
C              Refer to Subroutine CSTRMESH.
C
C The above parameters are not altered by this routine.
C
C       LPTR = Array of pointers associated with LIST.  Re-
C              fer to Subroutine CSTRMESH.
C
C       LNEW = Pointer to the first empty location in LIST
C              and LPTR (list length plus one).
C
C       LTRI = Integer work space array dimensioned 6 by
C              NCOL, or unused dummy parameter if NB = 0.
C
C       LISTC = Integer array of length at least 3*NT, where
C               NT = 2*N-4 is the number of triangles in the
C               triangulation (after extending it to cover
C               the entire surface if necessary).
C
C       RLATO,RLONO,RC = Arrays of length NT = 2*N-4.
C
C On output:
C
C       LPTR = Array of pointers associated with LISTC:
C              updated for the addition of pseudo-triangles
C              if the original triangulation contains
C              boundary nodes (NB > 0).
C
C       LNEW = Pointer to the first empty location in LISTC
C              and LPTR (list length plus one).  LNEW is not
C              altered if NB = 0.
C
C       LTRI = Triangle list whose first NB-2 columns con-
C              tain the indexes of a clockwise-ordered
C              sequence of vertices (first three rows)
C              followed by the LTRI column indexes of the
C              triangles opposite the vertices (or 0
C              denoting the exterior region) in the last
C              three rows.  This array is not generally of
C              any use.
C
C       LISTC = Array containing triangle indexes (indexes
C               to RLATO, RLONO, and RC) stored in 1-1 corres-
C               pondence with LIST/LPTR entries (or entries
C               that would be stored in LIST for the
C               extended triangulation):  the index of tri-
C               angle (N1,N2,N3) is stored in LISTC(K),
C               LISTC(L), and LISTC(M), where LIST(K),
C               LIST(L), and LIST(M) are the indexes of N2
C               as a neighbor of N1, N3 as a neighbor of N2,
C               and N1 as a neighbor of N3.  The Voronoi
C               region associated with a node is defined by
C               the CCW-ordered sequence of circumcenters in
C               one-to-one correspondence with its adjacency
C               list (in the extended triangulation).
C
C       NB = Number of boundary nodes unless IER = 1.
C
C       RLATO,RLONO = Arrays containing the lat/lon coordi-
C                     nates of the triangle circumcenters
C                     (Voronoi vertices).  The first NB-2 entries
C                     correspond to pseudo-triangles if NB > 0.
C
C       RC = Array containing circumradii (the arc lengths
C            or angles between the circumcenters and associ-
C            ated triangle vertices) in 1-1 correspondence
C            with circumcenters.
C
C       IER = Error indicator:
C             IER = 0 if no errors were encountered.
C             IER = 1 if N < 3.
C             IER = 2 if NCOL < NB-2.
C             IER = 3 if a triangle is degenerate (has ver-
C                     tices lying on a common geodesic).
C
C Modules required by CSCRLIST:  CSCIRCUM, CSLSTPTR, CSSWPTST
C
C Intrinsic functions called by CSCRLIST:  ABS, ACOS
C
C***********************************************************
C
      INTEGER CSLSTPTR
      INTEGER I1, I2, I3, I4, IERR, KT, KT1, KT2, KT11,
     .        KT12, KT21, KT22, LP, LPL, LPN, N0, N1, N2,
     .        N3, N4, NM2, NN, NT
      LOGICAL CSSWPTST
      LOGICAL SWP
      DOUBLE PRECISION C(3), T, V1(3), V2(3), V3(3)
C
C Local parameters:
C
C C =         Circumcenter returned by Subroutine CSCIRCUM
C I1,I2,I3 =  Permutation of (1,2,3):  LTRI row indexes
C I4 =        LTRI row index in the range 1 to 3
C IERR =      Error flag for calls to CSCIRCUM
C KT =        Triangle index
C KT1,KT2 =   Indexes of a pair of adjacent pseudo-triangles
C KT11,KT12 = Indexes of the pseudo-triangles opposite N1
C               and N2 as vertices of KT1
C KT21,KT22 = Indexes of the pseudo-triangles opposite N1
C               and N2 as vertices of KT2
C LP,LPN =    LIST pointers
C LPL =       LIST pointer of the last neighbor of N1
C N0 =        Index of the first boundary node (initial
C               value of N1) in the loop on boundary nodes
C               used to store the pseudo-triangle indexes
C               in LISTC
C N1,N2,N3 =  Nodal indexes defining a triangle (CCW order)
C               or pseudo-triangle (clockwise order)
C N4 =        Index of the node opposite N2 -> N1
C NM2 =       N-2
C NN =        Local copy of N
C NT =        Number of pseudo-triangles:  NB-2
C SWP =       Logical variable set to TRUE in each optimiza-
C               tion loop (loop on pseudo-arcs) iff a swap
C               is performed
C V1,V2,V3 =  Vertices of triangle KT = (N1,N2,N3) sent to
C               Subroutine CSCIRCUM
C
      NN = N
      NB = 0
      NT = 0
      IF (NN .LT. 3) GO TO 21
C
C Search for a boundary node N1.
C
      DO 1 N1 = 1,NN
        LP = LEND(N1)
        IF (LIST(LP) .LT. 0) GO TO 2
    1   CONTINUE
C
C The triangulation already covers the sphere.
C
      GO TO 9
C
C There are NB .GE. 3 boundary nodes.  Add NB-2 pseudo-
C   triangles (N1,N2,N3) by connecting N3 to the NB-3
C   boundary nodes to which it is not already adjacent.
C
C   Set N3 and N2 to the first and last neighbors,
C     respectively, of N1.
C
    2 N2 = -LIST(LP)
      LP = LPTR(LP)
      N3 = LIST(LP)
C
C   Loop on boundary arcs N1 -> N2 in clockwise order,
C     storing triangles (N1,N2,N3) in column NT of LTRI
C     along with the indexes of the triangles opposite
C     the vertices.
C
    3 NT = NT + 1
        IF (NT .LE. NCOL) THEN
          LTRI(1,NT) = N1
          LTRI(2,NT) = N2
          LTRI(3,NT) = N3
          LTRI(4,NT) = NT + 1
          LTRI(5,NT) = NT - 1
          LTRI(6,NT) = 0
        ENDIF
        N1 = N2
        LP = LEND(N1)
        N2 = -LIST(LP)
        IF (N2 .NE. N3) GO TO 3
C
      NB = NT + 2
      IF (NCOL .LT. NT) GO TO 22
      LTRI(4,NT) = 0
      IF (NT .EQ. 1) GO TO 7
C
C Optimize the exterior triangulation (set of pseudo-
C   triangles) by applying swaps to the pseudo-arcs N1-N2
C   (pairs of adjacent pseudo-triangles KT1 and KT2 > KT1).
C   The loop on pseudo-arcs is repeated until no swaps are
C   performed.
C
    4 SWP = .FALSE.
      DO 6 KT1 = 1,NT-1
        DO 5 I3 = 1,3
          KT2 = LTRI(I3+3,KT1)
          IF (KT2 .LE. KT1) GO TO 5
C
C   The LTRI row indexes (I1,I2,I3) of triangle KT1 =
C     (N1,N2,N3) are a cyclical permutation of (1,2,3).
C
          IF (I3 .EQ. 1) THEN
            I1 = 2
            I2 = 3
          ELSEIF (I3 .EQ. 2) THEN
            I1 = 3
            I2 = 1
          ELSE
            I1 = 1
            I2 = 2
          ENDIF
          N1 = LTRI(I1,KT1)
          N2 = LTRI(I2,KT1)
          N3 = LTRI(I3,KT1)
C
C   KT2 = (N2,N1,N4) for N4 = LTRI(I,KT2), where
C     LTRI(I+3,KT2) = KT1.
C
          IF (LTRI(4,KT2) .EQ. KT1) THEN
            I4 = 1
          ELSEIF (LTRI(5,KT2) .EQ. KT1) THEN
            I4 = 2
          ELSE
            I4 = 3
          ENDIF
          N4 = LTRI(I4,KT2)
C
C   The empty circumcircle test is reversed for the pseudo-
C     triangles.  The reversal is implicit in the clockwise
C     ordering of the vertices.
C
          IF ( .NOT. CSSWPTST(N1,N2,N3,N4,X,Y,Z) ) GO TO 5
C
C   Swap arc N1-N2 for N3-N4.  KTij is the triangle opposite
C     Nj as a vertex of KTi.
C
          SWP = .TRUE.
          KT11 = LTRI(I1+3,KT1)
          KT12 = LTRI(I2+3,KT1)
          IF (I4 .EQ. 1) THEN
            I2 = 2
            I1 = 3
          ELSEIF (I4 .EQ. 2) THEN
            I2 = 3
            I1 = 1
          ELSE
            I2 = 1
            I1 = 2
          ENDIF
          KT21 = LTRI(I1+3,KT2)
          KT22 = LTRI(I2+3,KT2)
          LTRI(1,KT1) = N4
          LTRI(2,KT1) = N3
          LTRI(3,KT1) = N1
          LTRI(4,KT1) = KT12
          LTRI(5,KT1) = KT22
          LTRI(6,KT1) = KT2
          LTRI(1,KT2) = N3
          LTRI(2,KT2) = N4
          LTRI(3,KT2) = N2
          LTRI(4,KT2) = KT21
          LTRI(5,KT2) = KT11
          LTRI(6,KT2) = KT1
C
C   Correct the KT11 and KT22 entries that changed.
C
          IF (KT11 .NE. 0) THEN
            I4 = 4
            IF (LTRI(4,KT11) .NE. KT1) THEN
              I4 = 5
              IF (LTRI(5,KT11) .NE. KT1) I4 = 6
            ENDIF
            LTRI(I4,KT11) = KT2
          ENDIF
          IF (KT22 .NE. 0) THEN
            I4 = 4
            IF (LTRI(4,KT22) .NE. KT2) THEN
              I4 = 5
              IF (LTRI(5,KT22) .NE. KT2) I4 = 6
            ENDIF
            LTRI(I4,KT22) = KT1
          ENDIF
    5     CONTINUE
    6   CONTINUE
      IF (SWP) GO TO 4
C
C Compute and store the negative circumcenters and radii of
C   the pseudo-triangles in the first NT positions.
C
    7 DO 8 KT = 1,NT
        N1 = LTRI(1,KT)
        N2 = LTRI(2,KT)
        N3 = LTRI(3,KT)
        V1(1) = X(N1)
        V1(2) = Y(N1)
        V1(3) = Z(N1)
        V2(1) = X(N2)
        V2(2) = Y(N2)
        V2(3) = Z(N2)
        V3(1) = X(N3)
        V3(2) = Y(N3)
        V3(3) = Z(N3)
        CALL CSCIRCUM (V1,V2,V3, C,IERR)
        IF (IERR .NE. 0) GO TO 23
C
C   Store the negative circumcenter and radius (computed
C     from <V1,C>).
C
        
        XD = C(1)
        YD = C(2)
        ZD = C(3)
        CALL CSSCOORDD(XD,YD,ZD,RLATO(KT),RLONO(KT),PNM)
        T = V1(1)*C(1) + V1(2)*C(2) + V1(3)*C(3)
        IF (T .LT. -1.0D0) T = -1.0D0
        IF (T .GT. 1.0D0) T = 1.0D0
        RC(KT) = ACOS(T)
    8   CONTINUE
C
C Compute and store the circumcenters and radii of the
C   actual triangles in positions KT = NT+1, NT+2, ...
C   Also, store the triangle indexes KT in the appropriate
C   LISTC positions.
C
    9 KT = NT
C
C   Loop on nodes N1.
C
      NM2 = NN - 2
      DO 12 N1 = 1,NM2
        LPL = LEND(N1)
        LP = LPL
        N3 = LIST(LP)
C
C   Loop on adjacent neighbors N2,N3 of N1 for which N2 > N1
C     and N3 > N1.
C
   10   LP = LPTR(LP)
          N2 = N3
          N3 = ABS(LIST(LP))
          IF (N2 .LE. N1  .OR.  N3 .LE. N1) GO TO 11
          KT = KT + 1
C
C   Compute the circumcenter C of triangle KT = (N1,N2,N3).
C
          V1(1) = X(N1)
          V1(2) = Y(N1)
          V1(3) = Z(N1)
          V2(1) = X(N2)
          V2(2) = Y(N2)
          V2(3) = Z(N2)
          V3(1) = X(N3)
          V3(2) = Y(N3)
          V3(3) = Z(N3)
          CALL CSCIRCUM (V1,V2,V3, C,IERR)
          IF (IERR .NE. 0) GO TO 23
C
C   Store the circumcenter, radius and triangle index.
C
          XD = C(1)
          YD = C(2)
          ZD = C(3)
          CALL CSSCOORDD(XD,YD,ZD,RLATO(KT),RLONO(KT),PNM)
          T = V1(1)*C(1) + V1(2)*C(2) + V1(3)*C(3)
          IF (T .LT. -1.0D0) T = -1.0D0
          IF (T .GT. 1.0D0) T = 1.0D0
          RC(KT) = ACOS(T)
C
C   Store KT in LISTC(LPN), where Abs(LIST(LPN)) is the
C     index of N2 as a neighbor of N1, N3 as a neighbor
C     of N2, and N1 as a neighbor of N3.
C
          LPN = CSLSTPTR(LPL,N2,LIST,LPTR)
          LISTC(LPN) = KT
          LPN = CSLSTPTR(LEND(N2),N3,LIST,LPTR)
          LISTC(LPN) = KT
          LPN = CSLSTPTR(LEND(N3),N1,LIST,LPTR)
          LISTC(LPN) = KT
   11     IF (LP .NE. LPL) GO TO 10
   12   CONTINUE
      IF (NT .EQ. 0) GO TO 20
C
C Store the first NT triangle indexes in LISTC.
C
C   Find a boundary triangle KT1 = (N1,N2,N3) with a
C     boundary arc opposite N3.
C
      KT1 = 0
   13 KT1 = KT1 + 1
      IF (LTRI(4,KT1) .EQ. 0) THEN
        I1 = 2
        I2 = 3
        I3 = 1
        GO TO 14
      ELSEIF (LTRI(5,KT1) .EQ. 0) THEN
        I1 = 3
        I2 = 1
        I3 = 2
        GO TO 14
      ELSEIF (LTRI(6,KT1) .EQ. 0) THEN
        I1 = 1
        I2 = 2
        I3 = 3
        GO TO 14
      ENDIF
      GO TO 13
   14 N1 = LTRI(I1,KT1)
      N0 = N1
C
C   Loop on boundary nodes N1 in CCW order, storing the
C     indexes of the clockwise-ordered sequence of triangles
C     that contain N1.  The first triangle overwrites the
C     last neighbor position, and the remaining triangles,
C     if any, are appended to N1's adjacency list.
C
C   A pointer to the first neighbor of N1 is saved in LPN.
C
   15 LP = LEND(N1)
      LPN = LPTR(LP)
      LISTC(LP) = KT1
C
C   Loop on triangles KT2 containing N1.
C
   16 KT2 = LTRI(I2+3,KT1)
      IF (KT2 .NE. 0) THEN
C
C   Append KT2 to N1's triangle list.
C
        LPTR(LP) = LNEW
        LP = LNEW
        LISTC(LP) = KT2
        LNEW = LNEW + 1
C
C   Set KT1 to KT2 and update (I1,I2,I3) such that
C     LTRI(I1,KT1) = N1.
C
        KT1 = KT2
        IF (LTRI(1,KT1) .EQ. N1) THEN
          I1 = 1
          I2 = 2
          I3 = 3
        ELSEIF (LTRI(2,KT1) .EQ. N1) THEN
          I1 = 2
          I2 = 3
          I3 = 1
        ELSE
          I1 = 3
          I2 = 1
          I3 = 2
        ENDIF
        GO TO 16
      ENDIF
C
C   Store the saved first-triangle pointer in LPTR(LP), set
C     N1 to the next boundary node, test for termination,
C     and permute the indexes:  the last triangle containing
C     a boundary node is the first triangle containing the
C     next boundary node.
C
      LPTR(LP) = LPN
      N1 = LTRI(I3,KT1)
      IF (N1 .NE. N0) THEN
        I4 = I3
        I3 = I2
        I2 = I1
        I1 = I4
        GO TO 15
      ENDIF
C
C No errors encountered.
C
   20 IER = 0
      RETURN
C
C N < 3.
C
   21 IER = 1
      RETURN
C
C Insufficient space reserved for LTRI.
C
   22 IER = 2
      RETURN
C
C Error flag returned by CSCIRCUM: KT indexes a null triangle.
C
   23 IER = 3
      RETURN
      END

C
C	$Id: binput.f,v 1.4 2008-07-27 12:23:43 haley Exp $
C                                                                      
C			     Copyright (C)  1997
C	     University Corporation for Atmospheric Research
C			     All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C

      SUBROUTINE BINPUT(IOS,STATUS)
C
C  Write out the binary graphcap file.
C
C  OUTPUT
C       IOS    --  The I/O status word,  this is valid only if STATUS
C                  indicates an error.
C       STATUS --  The error status as defined by COMMON CAPERR.
C
C  All information put to the output file is contained in
C  common blocks.  Following is a list of the common blocks
C  which are written out, and their sizes.  One record is
C  written for each common block.
C
C    COMMON       SIZE
C    ------       ------
C    CAPDEV       LENDEV
C    CAPLIN       LENLIN
C    CAPUSR       LENUSR
C    CAPCOL       LENCOL
C    CAPTXT       LENTXT
C    CAPMAR       LENMAR
C    CAPPLG       LENPLG
C    CAPBND       LENBND
C    CAPSCN       LENSCN
C
      COMMON /CAPIOB/ UNIT, IPTR, LSIZE, NFST, NFLG
      COMMON /CAPIO2/ LINE, GRNM
      INTEGER LNMAX
      PARAMETER (LNMAX=80)
      CHARACTER*80 LINE
      CHARACTER*80 GRNM
      INTEGER UNIT, IPTR, LSIZE, NFST, NFLG
      COMMON /CAPERR/ ALLOK, EOFFL, INTERR, MAXINT, PLBERR, PMBERR,
     1                FABERR, TXBERR, FLTERR, MAXFLT, NOTINT, SIZERR,
     2                UNDASC, DEVERR, DOCERR, TBLERR , STSZER, ENTERR,
     3                TABERR, TABSER, PRSFIL
      INTEGER ALLOK, EOFFL, INTERR, MAXINT, PLBERR, PMBERR,
     1        FABERR, TXBERR, FLTERR, MAXFLT, NOTINT, SIZERR, UNDASC,
     2        DEVERR, DOCERR, STSZER, ENTERR, TABERR, TABSER, TBLERR,
     3        PRSFIL
      COMMON /CAPDEV/ DGISTR, DGISIZ, DGESTR, DGESIZ, DTISTR,
     1                DTISIZ, DCDLLX, DCDLLY, DCDURX, DCDURY,
     3                DCOAVL, CORFMT, CORFIN, BATCH , DHCSIZ,
     4                DHCSTR, CORXOF, CORYOF, DASBIT, CORXSC,
     5                CORYSC, VDWLLX, VDWLLY, VDWURX, VDWURY
      INTEGER         DGIMAX, DGEMAX, DTIMAX, DCFTMX, DHCMAX
      PARAMETER   (DGIMAX=300, DGEMAX=150, DTIMAX=100)
      PARAMETER   (DCFTMX=30 , DHCMAX=50)
      INTEGER         DGISTR(DGIMAX), DGISIZ, DGESTR(DGEMAX),
     1                DGESIZ, DTISTR(DTIMAX), DTISIZ, DCDLLX,
     2                DCDLLY, DCDURX, DCDURY, CORFMT(DCFTMX,4),
     3                CORFIN(8)     , DHCSIZ, DHCSTR(DHCMAX),
     4                CORXOF, CORYOF, DASBIT, VDWLLX, VDWLLY,
     5                VDWURX, VDWURY
      REAL            CORXSC, CORYSC, CORRIN(8)
      LOGICAL         DCOAVL, BATCH
C  Size of the COMMON
      INTEGER         LENDEV
      PARAMETER   (LENDEV=DGIMAX+1+DGEMAX+1+DTIMAX+1+4+1+4*DCFTMX+
     1                  8+2+DHCMAX+9)
      EQUIVALENCE (CORFIN,CORRIN)
      COMMON /CAPLIN/ PLAVBL, LDSSTR, LDSSIZ, LDTSTR, LDTSIZ,
     1                LMSSTR, LMSSIZ, LMTSTR, LMTSIZ, LCSSTR,
     2                LCSSIZ, LCTSTR, LCTSIZ, LINFIN, LINFMT,
     3                LWSSTR, LWSSIZ, LWTSTR, LWTSIZ, LWTFIN,
     4                LWTFMT, LWTRNG, LWTSCF, LBSSTR, LBSSIZ,
     5                LBTSTR, LBTSIZ, LPSSTR, LPSSIZ, LPTSTR,
     6                LPTSIZ
      INTEGER         LDSMAX, LDTMAX, LMSMAX, LMTMAX, LCSMAX,
     1                LCTMAX, LVCFMX, LWSMAX, LWTMAX, LWTFMX,
     2                LBSMAX, LBTMAX, LPSMAX, LPTMAX
      PARAMETER   (LDSMAX=30, LDTMAX=15, LMSMAX=30, LMTMAX=15,
     1             LCSMAX=30, LCTMAX=15, LVCFMX=8,  LWSMAX=30,
     2             LWTMAX=15, LWTFMX=8 , LBSMAX=30, LBTMAX=15,
     3             LPSMAX=20, LPTMAX=20)
      INTEGER         LDSSTR(LDSMAX), LDSSIZ, LDTSTR(LDTMAX),
     1                LDTSIZ, LMSSTR(LMSMAX), LMSSIZ,
     2                LMTSTR(LMTMAX), LMTSIZ, LCSSTR(LCSMAX),
     3                LCSSIZ, LCTSTR(LCTMAX), LCTSIZ, LINFIN(8),
     4                LINFMT(LVCFMX,4)      , LWSSTR(LWSMAX),
     5                LWSSIZ, LWTSTR(LWTMAX), LWTSIZ, LWTFIN(8),
     6                LWTFMT(LWTFMX,4)      , LWTRNG(2)     ,
     7                LBSSTR(LBSMAX), LBSSIZ, LBTSTR(LBTMAX),
     8                LBTSIZ, LPSSTR(LPSMAX), LPSSIZ,
     9                LPTSTR(LPTMAX), LPTSIZ
      LOGICAL         PLAVBL
      REAL            LWTSCF,LINRIN(8),LWTRIN(8)
      INTEGER         LENLIN
      PARAMETER   (LENLIN=1+LDSMAX+1+LDTMAX+1+LMSMAX+1+
     1             LMTMAX+1+LCSMAX+1+LCTMAX+1+8+LVCFMX*4+
     2             LWSMAX+1+LWTMAX+1+8+LWTFMX*4+2+1+LBSMAX+
     3             1+LBTMAX+1+LPSMAX+1+LPTMAX+1)
      EQUIVALENCE (LINFIN,LINRIN), (LWTFIN,LWTRIN)
      COMMON /CAPUSR/ UPRSTR, UPRSIZ
      INTEGER    UPRMAX
      PARAMETER (UPRMAX=80)
      INTEGER    UPRSTR(UPRMAX), UPRSIZ
      INTEGER    LENUSR
      PARAMETER (LENUSR=UPRMAX+1)
      COMMON /CAPCOL/ COLINT, COLIDX, IDXCUR, VDMINT, DMPAVL, COLFMT
     1               ,COLFIN, IDXMAX, MSTSTR, MSTSIZ, MTRSTR, DMPMDL
     2               ,MTRSIZ, DMPIDV, DMPFIN, DMPFMT
      INTEGER         MAPMAX, COLMAX, MSTMAX, MTRMAX, DMPMAX
      PARAMETER   (MAPMAX=256, COLMAX=15, MSTMAX=50, MTRMAX=20)
      PARAMETER   (DMPMAX=50)
      INTEGER         COLINT(MAPMAX*3)      , COLIDX(MAPMAX), IDXCUR,
     1                VDMINT, COLFMT(COLMAX,4)      , COLFIN(8)     ,
     2                IDXMAX, MSTSTR(MSTMAX), MSTSIZ, MTRSTR(MTRMAX),
     3                DMPMDL, MTRSIZ, DMPFIN(8)     , DMPFMT(DMPMAX,4)
      LOGICAL         DMPAVL, DMPIDV
      REAL            COLRIN(8),DMPRIN(8)
      INTEGER LENCOL
      PARAMETER   (LENCOL=MAPMAX*3+MAPMAX+1+1+1+COLMAX*4+8+1+MSTMAX+
     1                    1+MTRMAX+1+1+1+8+DMPMAX*4)
      EQUIVALENCE (COLFIN,COLRIN),(DMPFIN,DMPRIN)
      COMMON/CAPBND/PLBTEC, PLIBTB, PLTBTB, PLWBTB, PLCBTB,
     1              PMBTEC, PMIBTB, PMTBTB, PMSBTB, PMCBTB,
     2              TXBTEC, TXIBTB, TXFBTB, TXPBTB, TCXBTB,
     3              TCSBTB, TXCBTB, FABTEC, FAIBTB, FISBTB,
     4              FASBTB, FACBTB
      INTEGER       TBLSIZ
      PARAMETER (TBLSIZ=6)
      INTEGER PLBTEC,PLIBTB(TBLSIZ),PLTBTB(TBLSIZ),PLCBTB(TBLSIZ),
     1        PMBTEC,PMIBTB(TBLSIZ),PMTBTB(TBLSIZ),PMCBTB(TBLSIZ),
     2        TXBTEC,TXIBTB(TBLSIZ),TXFBTB(TBLSIZ),TXPBTB(TBLSIZ),
     3        TXCBTB(TBLSIZ),FACBTB(TBLSIZ),
     4        FABTEC,FAIBTB(TBLSIZ),FISBTB(TBLSIZ),FASBTB(TBLSIZ)
      REAL PLWBTB(TBLSIZ),PMSBTB(TBLSIZ),TCXBTB(TBLSIZ),TCSBTB(TBLSIZ)
      INTEGER LENBND
      PARAMETER (LENBND=4+18*TBLSIZ)
      COMMON /CAPTXT/ TCSSTR, TCSSIZ, TCTSTR, TCTSIZ, TXTFIN, TXTFMT,
     1                TXSSTR, TXSSIZ, TXTSTR, TXTSIZ
      INTEGER         TCSMAX, TCTMAX, TVCFMX, TXSMAX, TXTMAX
      PARAMETER (TCSMAX=10, TCTMAX=10, TVCFMX=5, TXSMAX=20, TXTMAX=20)
      INTEGER         TCSSTR(TCSMAX), TCSSIZ, TCTSTR(TCTMAX), TCTSIZ,
     1                TXTFIN(5)     , TXTFMT(TVCFMX,4)      ,
     2                TXSSTR(TXSMAX), TXSSIZ, TXTSTR(TXTMAX), TXTSIZ
      INTEGER         LENTXT
      PARAMETER (LENTXT=TCSMAX+1+TCTMAX+1+5+TVCFMX*4+TXSMAX+1+
     1                  TXTMAX+1)
      COMMON /CAPMAR/ MCSSTR, MCSSIZ, MCTSTR, MCTSIZ, MARFIN, MARFMT,
     1                MRSSTR, MRSSIZ, MRTSTR, MRTSIZ, MDOTSZ
      INTEGER         MCSMAX, MCTMAX, MVCFMX, MRSMAX, MRTMAX
      PARAMETER (MCSMAX=30, MCTMAX=15, MVCFMX=5, MRSMAX=20, MRTMAX=10)
      INTEGER         MCSSTR(MCSMAX), MCSSIZ, MCTSTR(MCTMAX), MCTSIZ,
     1                MARFIN(5)     , MARFMT(MVCFMX,4)      ,
     2                MRSSTR(MRSMAX), MRSSIZ, MRTSTR(MRTMAX), MRTSIZ,
     3                MDOTSZ
      INTEGER         LENMAR
      PARAMETER (LENMAR=MCSMAX+1+MCTMAX+1+5+MVCFMX*4+MRSMAX+1+
     1           MRTMAX+1+1)
      COMMON /CAPPLG/ PCSSTR, PCSSIZ, PCTSTR, PCTSIZ, PLSSTR,
     1                PLSSIZ, PLTSTR, PLTSIZ, PBSSTR, PBSSIZ,
     2                PBTSTR, PBTSIZ, PHATSP, PMAXPT, PPSSTR,
     3                PPSSIZ, PPTSTR, PPTSIZ, PLGSIM, PSIMSP,
     4                PSIMTR
      INTEGER         PCSMAX, PCTMAX, PLSMAX, PLTMAX, PBSMAX,
     1                PBTMAX, PPSMAX, PPTMAX
      PARAMETER   (PCSMAX=20, PCTMAX=15, PLSMAX=40, PLTMAX=20)
      PARAMETER   (PBSMAX=30, PBTMAX=15, PPSMAX=20, PPTMAX=20)
      INTEGER         PCSSTR(PCSMAX), PCSSIZ, PCTSTR(PCTMAX), PCTSIZ,
     1                PLSSTR(PLSMAX), PLSSIZ, PLTSTR(PLTMAX), PLTSIZ,
     2                PBSSTR(PBSMAX), PBSSIZ, PBTSTR(PBTMAX), PBTSIZ,
     3                PHATSP, PMAXPT, PPSSTR(PPSMAX), PPSSIZ,
     4                PPTSTR(PPTMAX), PPTSIZ, PSIMSP, PSIMTR
      LOGICAL         PLGSIM
      INTEGER         LENPLG
      PARAMETER   (LENPLG=PCSMAX+1+PCTMAX+1+PLSMAX+1+PLTMAX+1+
     1                    PBSMAX+1+PBTMAX+1+1+1+PPSMAX+1+PPTMAX+
     2                    1+1+1+1)
      COMMON /CAPSPC/ DUMSPC,ENDDSP
      INTEGER     DUMSIZ,DUMSM1
      PARAMETER (DUMSIZ=327, DUMSM1=DUMSIZ-1)
      INTEGER     DUMSPC(DUMSM1),ENDDSP
      COMMON /CAPSCN/ SCSSTR, SCSSIZ, SCTSTR, SCTSIZ, SCNLLX,
     1                SCNLLY, SCNURX, SCNURY, SCNXOF, SCNYOF,
     2                SCNXSC, SCNYSC, SCNFMT, SCNFIN, SCVFMT,
     3                SCVFIN, SCNSIM
      INTEGER         SCSMAX, SCTMAX, SFMMAX, SFNMAX, SCVFMX,
     1                SCVFIX
      PARAMETER  (SCSMAX=50, SCTMAX=50, SFMMAX=10, SFNMAX=8)
      PARAMETER  (SCVFMX=10, SCVFIX=8)
      INTEGER         SCSSTR(SCSMAX), SCSSIZ, SCTSTR(SCTMAX), SCTSIZ,
     2                SCNLLX, SCNLLY, SCNURX, SCNURY, SCNXOF, SCNYOF,
     3                SCNFMT(SFMMAX,4)      , SCNFIN(SFNMAX),
     4                SCVFMT(SCVFMX,4)      , SCVFIN(SCVFIX)
      REAL            SCNXSC, SCNYSC, SCNRIN(SFNMAX), SCVRIN(SCVFIX)
      LOGICAL         SCNSIM
      INTEGER         LENSCN
      PARAMETER  (LENSCN=SCSMAX+1+SCTMAX+1+1+1+1+1+1+1+1+1+
     1                   (SFMMAX*4)+SFNMAX+(SCVFMX*4)+SCVFIX+1)
      EQUIVALENCE (SCNFIN,SCNRIN), (SCVFIN,SCVRIN)
C
      INTEGER IOS, STATUS
      REAL ALOG10
      INTEGER II
C
C  Initialize STATUS to ALLOK.
C
      STATUS = ALLOK
C
C  Set the size of the device color map if it has not been defined.
C
      IF (IDXMAX.EQ.-1) IDXMAX = IDXCUR
C
C  IF necessary, reduce the map size to the maximum allowed
C  in the translator.
C
      IF (IDXMAX .GT. MAPMAX) IDXMAX=MAPMAX
C
C  Write out the workstation DEVICE definitions.
C
      CORFIN(3) = DCFTMX
      CORFIN(4) = 4
      CALL BINWRI(UNIT, LENDEV, DGISTR, IOS, STATUS)
      IF (STATUS.NE.ALLOK)RETURN
C
C  Write out the workstation LINE drawing definitions.
C
      LINFIN(3) = LVCFMX
      LINFIN(4) = 4
      IF (LINFIN(1) .NE. 5) LINFIN(5) = 5
      LWTFIN(3) = LWTFMX
      LWTFIN(4) = 4
      IF (LWTFIN(1) .NE. 5) THEN
C
C  The QMS (flagged by NFLG=1) is treated specially.
C
        IF (NFLG .EQ. 1) THEN
          LWTFIN(5) = 2
        ELSE
          LWTFIN(5) = 5
        ENDIF
      ENDIF
      CALL BINWRI(UNIT, LENLIN, PLAVBL, IOS, STATUS)
      IF (STATUS.NE.ALLOK)RETURN
C
C  Write out the USER interface data.
C
      CALL BINWRI(UNIT, LENUSR, UPRSTR, IOS, STATUS)
      IF (STATUS.NE.ALLOK)RETURN
C
C  Write out the DEVICE color map information.
C
      COLFIN(3) = COLMAX
      COLFIN(4) = 4
C
C  Set the number of characters required to encode a color index,
C  if the encoding is not ASCII real.
C
      IF (COLFIN(1) .NE. 5) COLFIN(5) =
     -                           IFIX(ALOG10(FLOAT(IDXMAX+1))+1)
      DMPFIN(3) = DMPMAX
      DMPFIN(4) = 4
C
C  Set the number of characters required to encode a color intensity,
C  if the encoding is not ASCII real.
C
      IF (DMPFIN(1) .NE. 5) THEN
        IDX3 = MAPMAX*3
        INTMAX = 0
        DO 150 I=1,IDX3
        INTMAX = MAX0(COLINT(I),INTMAX)
  150   CONTINUE
        DMPFIN(5) = IFIX(ALOG10(FLOAT(INTMAX+1))+1)
      ENDIF
      CALL BINWRI(UNIT, LENCOL, COLINT, IOS, STATUS)
      IF (STATUS.NE.ALLOK)RETURN
C
C  Write out the device TEXT data.
C
      CALL BINWRI(UNIT, LENTXT, TCSSTR, IOS, STATUS)
      IF (STATUS.NE.ALLOK)RETURN
C
C  Write out the device MARKER data.
C
      CALL BINWRI(UNIT, LENMAR, MCSSTR, IOS, STATUS)
      IF (STATUS.NE.ALLOK)RETURN
C
C  Write out the device POLYGON data.
C
      CALL BINWRI(UNIT, LENPLG, PCSSTR, IOS, STATUS)
      IF (STATUS.NE.ALLOK)RETURN
C
C  Write out the BUNDLE tables.
C
      CALL BINWRI(UNIT, LENBND, PLBTEC, IOS, STATUS)
      IF (STATUS.NE.ALLOK)RETURN
C
C  Write out the RASTER class data.
C
      SCVFIN(3) = SCVFMX
      SCVFIN(4) = 4
      SCNFIN(3) = SFMMAX
      SCNFIN(4) = 4
      CALL BINWRI(UNIT, LENSCN, SCSSTR, IOS, STATUS)
      IF (STATUS.NE.ALLOK)RETURN
C
C  Zero out the dummy space and put to the output file.
C  Currently the first five locations of the dummy space
C  are defined to support the NCAR color DICOMED--this
C  situation will be cleaned up for Release 3.0 .
C
      DO 1111 II = 1,DUMSIZ
        DUMSPC(II) = 0
 1111 CONTINUE
      CALL BINWRI(UNIT, DUMSIZ, DUMSPC, IOS, STATUS)
C
      RETURN
      END

C -----------------------------------------------------------
C NCLFORTSTART
      SUBROUTINE DLININT1(NXI,XI,FI,ICYCX,NXO,XO,FO,XIW,FXIW,NXI2,XMSG,
     +                    IOPT,IER)
      IMPLICIT NONE
      INTEGER NXI,NXO,NXI2,IOPT,ICYCX,IER
      DOUBLE PRECISION XI(NXI),FI(NXI)
      DOUBLE PRECISION XO(NXO),FO(NXO),XMSG
      DOUBLE PRECISION XIW(NXI2),FXIW(NXI2)
C NCLEND

C This is written  with GNU f77 acceptable extensions
C .   to allow for compilation on linux platforms.
c .   This could be improved considerably with f90

c NCL:  fo = linint1 (xi,fi, wrapX, xo, iopt)
c
c            {nxi,nxo} = dimsizes( {xi,xo} )
c            fo is the same size xo and same type as "fi"
c            xmsg = fi@_FillValue
c            wrapX is an NCL logical; a False ==> 0
c                                     a True  ==> 1
c            iopt = 0 try to preserve msg areas
c                 = 1 try to fill in entire grid
c
c            The NCL wrapper should allow for multiple datasets
c            so the user need only make one call to the function.

c perform piecewise linear interpolation allowing for missing data
c .  nothing fancy

c nomenclature:
c .   nxi     - lengths of xi and dimensions of fi (must be >= 2)
c .   xi      - coordinates of fi (eg, lon)
c .             must be monotonically (in/de)creasing [same as xo]
c .   fi      - functional input values [2D]
c .   icycx   - 0 if fi is cyclic in x (cyclic pt should NOT included)
c .             .ne.0 if cyclic
c .   nxo     - lengths of xo and dimensions of fo (must be >= 1)
c .   xo      - coordinates of fo (eg, lon)
c .             must be monotonically (in/de)creasing [same as xi]
c .   fo      - functional output values [interpolated]
c .   xmsg    - missing code
c .   iopt    - options
c .           - iopt=0  means to try to preserve missing areas
c .           - iopt=1  means to try to try to fill-in missing areas
c .   ier     - error code
c .             =0;   no error
c .             =1;   not enough points in input/output array
c .             =2;   xi are not monotonically increasing
c .             =4;   xo yo are not monotonically increasing
c
c                              local
      INTEGER NX,NPTS,IFLAG,NXSTRT,NXLAST
c                              gross error checking
      IER = 0
      IF (NXO.LT.1) THEN
          IER = 1
          RETURN
      END IF
c                              initialize to msg
      DO NX = 1,NXO
          FO(NX) = XMSG
      END DO

      IF (NXI.LE.1) THEN
          IER = 1
          RETURN
      END IF
c                              mono (in/de)creasing ?
      CALL DMONOID2(NXI,XI,NXO,XO,IFLAG,IER)
      IF (IFLAG.EQ.0 .OR. IER.NE.0) RETURN
c                              are data to be treated cyclic?
      IF (ICYCX.EQ.0) THEN
c                              data are not cyclic
          IF (IOPT.EQ.0) THEN

              CALL DLIN2INT1(NXI,XI,FI,NXO,XO,FO,XMSG,IFLAG)
          ELSE IF (IOPT.EQ.1) THEN
c                              collapse data array (eliminate msg)
              NPTS = 0
              DO NX = 1,NXI
                  IF (FI(NX).NE.XMSG) THEN
                      NPTS = NPTS + 1
                      XIW(NPTS+1)  = XI(NX)
                      FXIW(NPTS+1) = FI(NX)
                  END IF
              END DO

              CALL DLIN2INT1(NPTS,XIW(2),FXIW(2),NXO,XO,FO,XMSG,IFLAG)
          END IF
      ELSE
c                              data are cyclic
          IF (IOPT.EQ.0) THEN
c                              preserve msg region
              DO NX = 1,NXI
                  XIW(NX+1)  = XI(NX)
                  FXIW(NX+1) = FI(NX)
              END DO

              CALL DLINCYC(NXI,XI,FI,1,NXI,IFLAG,XIW,FXIW,NXI)
              CALL DLIN2INT1(NXI+2,XIW,FXIW,NXO,XO,FO,XMSG,IFLAG)

          ELSE IF (IOPT.EQ.1) THEN
c                              collapse data array
              NPTS = 0
              NXSTRT = 0
              NXLAST = 0
              DO NX = 1,NXI
                  IF (FI(NX).NE.XMSG) THEN
                      NPTS = NPTS + 1
                      XIW(NPTS+1)  = XI(NX)
                      FXIW(NPTS+1) = FI(NX)
                      IF (NPTS.EQ.1) NXSTRT = NX
                      NXLAST = NX
                  END IF
              END DO

              IF (NPTS.EQ.0) THEN
                  IER = 1
                  RETURN
              END IF

              CALL DLINCYC(NXI,XI,FI,NXSTRT,NXLAST,IFLAG,XIW,FXIW,NPTS)
              CALL DLIN2INT1(NPTS+2,XIW,FXIW,NXO,XO,FO,XMSG,IFLAG)
c c c         do nx=0,npts+1
c c c            write (*,"(i5,2(1x,f10.5))") nx, xiw(nx+1), fxiw(nx+1)
c c c         end do
          END IF

      END IF

      RETURN
      END
c -----------------------------------------------------------
C NCLFORTSTART
      SUBROUTINE DLININT2(NXI,XI,NYI,YI,FI,ICYCX,NXO,XO,NYO,YO,FO,XIW,
     +                    FXIW,NXI2,XMSG,IOPT,IER)
      IMPLICIT NONE
      INTEGER NXI,NYI,NXO,NYO,NXI2,ICYCX,IOPT,IER
      DOUBLE PRECISION XI(NXI),YI(NYI),FI(NXI,NYI)
      DOUBLE PRECISION XO(NXO),YO(NYO),FO(NXO,NYO),XMSG
      DOUBLE PRECISION XIW(NXI2),FXIW(NXI2)
C NCLEND

C This is written  with GNU f77 acceptable extensions
C .   to allow for compilation on linux platforms.
c .   This could be improved considerably with f90

c NCL:  fo = linint2 (xi,yi,fi, wrapX, xo,yo, iopt)
c
c            {nxi,nyi,nxo,nyo} = dimsizes( {xi,yi,xo,yo} )
c            fo is the same size xo, yo and same type as "fi"
c            xmsg = fi@_FillValue
c            wrapX is an NCL logical; a False ==> 0
c                                     a True  ==> 1
c
c            The NCL wrapper should allow for multiple datasets
c            so the user need only make one call to the function.

c perform bilinear interpolation allowing for missing data
c .  nothing fancy

c nomenclature:
c .   nxi,nyi - lengths of xi,yi and dimensions of fi (must be >= 2)
c .   xi      - coordinates of fi (eg, lon)
c .             must be monotonically increasing
c .   yi      - coordinates of fi (eg, lat)
c .             must be monotonically increasing
c .   fi      - functional input values [2D]
c .   icycx   - 0 if fi is cyclic in x (cyclic pt should NOT included)
c .             .ne.0 if cyclic
c .   nxo,nyo - lengths of xo,yo and dimensions of fo (must be >= 2)
c .   xo      - coordinates of fo (eg, lon)
c .             must be monotonically increasing
c .   yo      - coordinates of fo (eg, lat)
c .             must be monotonically increasing
c .   fo      - functional output values [interpolated]
c .   xmsg    - missing code
c .   iopt    - =0 try to preserve msg areas
c .             =1 try to fill in entire grid
c .   ier     - error code
c .             =0;   no error
c .             =1;   not enough points in input/output array
c .             =2;   xi or xo are not monotonically (in/de)creasing
c .             =3;   yi or yo are not monotonically (in/de)creasing
c
c                              local and temporary/work arrays
      INTEGER IFLAG,NPTS,NXSTRT,NXLAST
      DOUBLE PRECISION YIW(NYI),FYIW(NYI),FOYW(NYO)
      DOUBLE PRECISION FTMP(NXO,NYI)

c                              local
      INTEGER NX,NY
c                              error checking
      IER = 0
      IF (NXO.LT.1 .OR. NYO.LT.1) THEN
          IER = 1
          RETURN
      END IF
c                              set to msg
      DO NY = 1,NYO
          DO NX = 1,NXO
              FO(NX,NY) = XMSG
          END DO
      END DO

      IF (NXI.LT.2 .OR. NYI.LT.2) THEN
          IER = 1
          RETURN
      END IF
c                              error mono increasing ?
      CALL DMONOID2(NXI,XI,NXO,XO,IFLAG,IER)
      IF (IFLAG.EQ.0 .OR. IER.NE.0) THEN
          IER = 2
          RETURN
      END IF
      CALL DMONOID2(NYI,YI,NYO,YO,IFLAG,IER)
      IF (IFLAG.EQ.0 .OR. IER.NE.0) THEN
          IER = 3
          RETURN
      END IF
c                               is the input array cyclic in x
      IF (ICYCX.EQ.0) THEN
c                               preserve missing areas
          IF (IOPT.EQ.0) THEN
c                               interpolate in the x direction
              DO NY = 1,NYI
                  CALL DLIN2INT1(NXI,XI,FI(1,NY),NXO,XO,FTMP(1,NY),
     +                          XMSG,IFLAG)
              END DO
c                               interpolate in the y direction
              DO NX = 1,NXO
                  DO NY = 1,NYI
                      FYIW(NY) = FTMP(NX,NY)
                  END DO

                  CALL DLIN2INT1(NYI,YI,FYIW,NYO,YO,FOYW,XMSG,IFLAG)

                  DO NY = 1,NYO
                      FO(NX,NY) = FOYW(NY)
                  END DO
              END DO
          ELSE IF (IOPT.EQ.1) THEN
c                               interpolate in the x direction
c                               collapse data array
              DO NY = 1,NYI
                  NPTS = 0
                  DO NX = 1,NXI
                      IF (FI(NX,NY).NE.XMSG) THEN
                          NPTS = NPTS + 1
                          XIW(NPTS+1)  = XI(NX)
                          FXIW(NPTS+1) = FI(NX,NY)
                      END IF
                  END DO

                  CALL DLIN2INT1(NPTS,XIW(2),FXIW(2),NXO,XO,FTMP(1,NY),
     +                          XMSG,IFLAG)
              END DO
c                               interpolate in the y direction
              DO NX = 1,NXO
                  NPTS = 0
                  DO NY = 1,NYI
                      IF (FTMP(NX,NY).NE.XMSG) THEN
                          NPTS = NPTS + 1
                          YIW(NPTS) = YI(NY)
                          FYIW(NPTS) = FTMP(NX,NY)
                      END IF
                  END DO

                  CALL DLIN2INT1(NPTS,YIW,FYIW,NYO,YO,FOYW,XMSG,IFLAG)

                  DO NY = 1,NYO
                      FO(NX,NY) = FOYW(NY)
                  END DO
              END DO

          END IF
      ELSE
c                               must be cyclic in x
c                               create cyclic "x" coordinates
          IF (IOPT.EQ.0) THEN
              DO NY = 1,NYI
                  DO NX = 1,NXI
                      XIW(NX+1)  = XI(NX)
                      FXIW(NX+1) = FI(NX,NY)
                  END DO

                  NPTS = NXI
                  CALL DLINCYC(NXI,XI,FI(1,NY),1,NXI,IFLAG,XIW,FXIW,
     +                         NPTS)
                  CALL DLIN2INT1(NXI+2,XIW,FXIW,NXO,XO,FTMP(1,NY),XMSG,
     +                           IFLAG)
              END DO
c                               interpolate in the y direction
              DO NX = 1,NXO
                  DO NY = 1,NYI
                      FYIW(NY) = FTMP(NX,NY)
                  END DO

                  CALL DLIN2INT1(NYI,YI,FYIW,NYO,YO,FOYW,XMSG,IFLAG)

                  DO NY = 1,NYO
                      FO(NX,NY) = FOYW(NY)
                  END DO
              END DO

          ELSE IF (IOPT.EQ.1) THEN
              DO NY = 1,NYI
c                              collapse data array
                  NPTS = 0
                  NXSTRT = 0
                  NXLAST = 0
                  DO NX = 1,NXI
                      IF (FI(NX,NY).NE.XMSG) THEN
                          NPTS = NPTS + 1
                          XIW(NPTS+1)  = XI(NX)
                          FXIW(NPTS+1) = FI(NX,NY)
                          IF (NPTS.EQ.1) NXSTRT = NX
                          NXLAST = NX
                      END IF
                  END DO

                  CALL DLINCYC(NXI,XI,FI(1,NY),NXSTRT,NXLAST,IFLAG,XIW,
     +                         FXIW,NPTS)
                  CALL DLIN2INT1(NPTS+2,XIW,FXIW,NXO,XO,FTMP(1,NY),
     +                           XMSG,IFLAG)
              END DO
c                               interpolate in the y direction
              DO NX = 1,NXO
                  NPTS = 0
                  DO NY = 1,NYI
                      IF (FTMP(NX,NY).NE.XMSG) THEN
                          NPTS = NPTS + 1
                          YIW(NPTS) = YI(NY)
                          FYIW(NPTS) = FTMP(NX,NY)
                      END IF
                  END DO

                  CALL DLIN2INT1(NPTS,YIW,FYIW,NYO,YO,FOYW,XMSG,IFLAG)

                  DO NY = 1,NYO
                      FO(NX,NY) = FOYW(NY)
                  END DO
              END DO
          END IF
      END IF

      RETURN
      END
c -----------------------------------------------------------
      SUBROUTINE DLIN2INT1(NIN,XI,FI,NOUT,XO,FO,XMSG,IFLAG)
      IMPLICIT NONE
      INTEGER NIN,NOUT,IFLAG
      DOUBLE PRECISION XI(NIN),FI(NIN),XO(NOUT),FO(NOUT),XMSG

c perform 1D piecewise linear interpolation allowing for missing data
c .  this works with lin2int [does no error chk]
c .  nothing fancy
c                              local
      INTEGER NI,NO,NISTRT,NIS,NEXACT
      DOUBLE PRECISION SLOPE

      DO NO = 1,NOUT
          FO(NO) = XMSG
      END DO
c                              main loop [exact matches]
c                              nistrt minimizes extra checks
      NEXACT = 0
      NISTRT = 1
      NIS = NISTRT
      DO NO = 1,NOUT
          DO NI = NISTRT,NIN
              IF (XO(NO).EQ.XI(NI)) THEN
                  FO(NO) = FI(NI)
                  NIS = NI + 1
                  NEXACT = NEXACT + 1
                  GO TO 10
              END IF
          END DO
   10     NISTRT = NIS
      END DO

c                              main loop [interpolation]
      IF (IFLAG.EQ.1) THEN
          DO NO = 1,NOUT
              DO NI = 1,NIN - 1
                  IF (XO(NO).GT.XI(NI) .AND. XO(NO).LT.XI(NI+1)) THEN
                      IF (FI(NI).NE.XMSG .AND. FI(NI+1).NE.XMSG) THEN
                          SLOPE = (FI(NI+1)-FI(NI))/ (XI(NI+1)-XI(NI))
                          FO(NO) = FI(NI) + SLOPE* (XO(NO)-XI(NI))
                      END IF
                  END IF
              END DO
          END DO
      ELSE IF (IFLAG.EQ.-1) THEN
          DO NO = 1,NOUT
              DO NI = 1,NIN - 1
                  IF (XO(NO).LT.XI(NI) .AND. XO(NO).GT.XI(NI+1)) THEN
                      IF (FI(NI).NE.XMSG .AND. FI(NI+1).NE.XMSG) THEN
                          SLOPE = (FI(NI+1)-FI(NI))/ (XI(NI+1)-XI(NI))
                          FO(NO) = FI(NI) + SLOPE* (XO(NO)-XI(NI))
                      END IF
                  END IF
              END DO
          END DO
      END IF

      RETURN
      END
c ---------------------------------------------
      SUBROUTINE DLINCYC(NXI,XI,FI,NXSTRT,NXLAST,IFLAG,XIW,FXIW,NPTS)
c
c handle the "x" cyclic point
c
      IMPLICIT NONE
      INTEGER NXI,NXSTRT,NXLAST,IFLAG,NPTS
      DOUBLE PRECISION XI(NXI),FI(NXI),XIW(0:NXI+1),FXIW(0:NXI+1)
      DOUBLE PRECISION DX


      IF (NXSTRT.EQ.1 .AND. NXLAST.EQ.NXI) THEN
          DX = ABS(XI(2)-XI(1))
          XIW(0) = XI(1) - IFLAG*DX
          FXIW(0) = FI(NXI)
          DX = ABS(XI(NXI)-XI(NXI-1))
          XIW(NPTS+1) = XI(NXI) + IFLAG*DX
          FXIW(NPTS+1) = FI(1)
      ELSE
c                              arbitrary
          DX = (NXSTRT+ (NXI-NXLAST))*ABS(XI(2)-XI(1))
          XIW(0) = XIW(1) - IFLAG*DX
          FXIW(0) = FXIW(NPTS)
          DX = ((NXI-NXLAST)+NXSTRT)*ABS(XI(NXI)-XI(NXI-1))
          XIW(NPTS+1) = XIW(NPTS) + IFLAG*DX
          FXIW(NPTS+1) = FXIW(1)
      END IF

      RETURN
      END
c ---------------------------------------------
      SUBROUTINE DMONOINC(X,NX,NER,IER)
      IMPLICIT NONE

c chk to make sure that x is monotonically increasing

      INTEGER NX,NER,IER
      DOUBLE PRECISION X(NX)
c                          local
      INTEGER N

      IER = 0
      IF (NX.LE.1) RETURN

      DO N = 1,NX - 1
          IF (X(N+1).LE.X(N)) THEN
              IER = NER
              RETURN
          END IF
      END DO

      RETURN
      END
c     ---------------------------------------------------
      SUBROUTINE DMONOID1(NIN,XI,IFLAG,IER)
c
c chk to see if a series is mono (in/de)creasing
c
      IMPLICIT NONE
      INTEGER NIN,IFLAG,IER
      DOUBLE PRECISION XI(NIN)
c                              local
      INTEGER NI

      IER = 0
      IFLAG = 0
c
c if only one element, then treat it as monotonically increasing
c
      IF (NIN.LT.2) THEN
         IFLAG = +1
         RETURN
      END IF

      IF (XI(2).GT.XI(1)) THEN
c                              ? mono INcreasing
          DO NI = 1,NIN - 1
              IF (XI(NI+1).LE.XI(NI)) THEN
                  IER = 2
                  RETURN
              END IF
          END DO

          IFLAG = +1
      ELSE
c                              ? mono DEcreasing
          DO NI = 1,NIN - 1
              IF (XI(NI+1).GE.XI(NI)) THEN
                  IER = 2
                  RETURN
              END IF
          END DO

          IFLAG = -1
      END IF

      RETURN
      END
c     ---------------------------------------------------
      SUBROUTINE DMONOID2(NIN,XI,NOUT,XO,IFLAG,IER)
c
c make sure the two series are mono (in/de)creasing
c
      IMPLICIT NONE
      INTEGER NIN,NOUT,IFLAG,IER
      DOUBLE PRECISION XI(NIN),XO(NOUT)
c                              local
      INTEGER NFLAG,NER

      IER = 0
      IFLAG = 0
      NFLAG = 0

      CALL DMONOID1(NIN,XI,IFLAG,IER)
      IF (IFLAG.EQ.0) THEN
         IER = 2
      ELSE
         CALL DMONOID1(NOUT,XO,NFLAG,NER)
         IF (NFLAG.EQ.0) THEN
            IER = 3
         ELSE IF (IFLAG.NE.NFLAG) THEN
            IER = 4
         END IF
      END IF

      RETURN
      END

c -----------------------------------------------------------
C NCLFORTSTART
      SUBROUTINE DLININT2PTS(NXI,XI,NYI,YI,FI,ICYCX,NXYO,XO,YO,FO,
     +                       XIW,FIXW,NXI2,XMSG,IER)
      IMPLICIT NONE
      INTEGER NXI,NYI,NXYO,ICYCX,NXI2,IER
      DOUBLE PRECISION XI(NXI),YI(NYI),FI(NXI,NYI)
      DOUBLE PRECISION XO(NXYO),YO(NXYO),FO(NXYO)
      DOUBLE PRECISION XIW(NXI2),FIXW(NXI2,NYI),XMSG
C NCLEND

C This is written  with GNU f77 acceptable extensions
C .   to allow for compilation on linux platforms.
c .   This could be improved considerably with f90

c NCL:  fo = linint2_points (xi,yi,fi, wrapX, xo,yo, foOpt)
c
c            {nxi,nyi} = dimsizes( {xi,yi} )
c            {nxyo} = dimsizes( {xo} )  = dimsizes( {yo} )
c            fo is the same size xo, yo and same type as "fi"
c            xmsg = fi@_FillValue
c            wrapX is an NCL logical; a False ==> 0
c                                     a True  ==> 1
c            foOpt unused option
c
c            The NCL wrapper should allow for multiple datasets
c            so the user need only make one call to the function.

c perform 2D piecewise linear interpolation allowing for missing data
c .  nothing fancy

c nomenclature:
c .   nxi,nyi - lengths of xi,yi and dimensions of fi (must be >= 2)
c .   xi      - coordinates of fi (eg, lon)
c .             must be monotonically increasing
c .   yi      - coordinates of fi (eg, lat)
c .             must be monotonically increasing
c .   fi      - functional input values [2D]
c .   icycx   - 0 if fi is cyclic in x (cyclic pt should NOT included)
c .             .ne.0 if cyclic
c .   nxyo    - number of xo,yo coordinate pairs
c .   xo,yo   - coordinate pairs
c .   fo      - functional output values [interpolated]
c .   xmsg    - missing code
c .   nopt    - option for how to handle case when not all values
c .              present
c .              >= 0 means set the interpolated point to xmsg
c .              =-1 try some sort of weighted average
c .   ier     - error code
c .             =0;   no error
c .             =1;   not enough points in input/output array
c .             =2/3; xi or yi are not monotonically increasing
c
c                              automatic temporary/work arrays
      DOUBLE PRECISION DX

c                              local
      INTEGER NX,NY,NOPT
c                              this could be made an argument
      NOPT = -1
c                              error checking
      IER = 0
      IF (NXI.LT.2 .OR. NYI.LT.2) THEN
          IER = 1
          RETURN
      END IF
c                              error mono increasing ?
      CALL DMONOINC(XI,NXI,2,IER)
      IF (IER.NE.0) RETURN
      CALL DMONOINC(YI,NYI,3,IER)
      IF (IER.NE.0) RETURN
c                               is the input array cyclic in x
      IF (ICYCX.EQ.0) THEN
          CALL DLINT2XY(NXI,XI,NYI,YI,FI,NXYO,XO,YO,FO,XMSG,NOPT,IER)
      ELSE
c                               must be cyclic in x
c                               create cyclic "x" coordinates
          DO NX = 1,NXI
              XIW(NX+1) = XI(NX)
          END DO
          DX = XI(2) - XI(1)
          XIW(1)    = XI(1) - DX
          XIW(NXI2) = XI(NXI) + DX

          DO NY = 1,NYI
              DO NX = 1,NXI
                  FIXW(NX+1,NY) = FI(NX,NY)
              END DO
              FIXW(1,NY)    = FI(NXI,NY)
              FIXW(NXI2,NY) = FI(1,NY)
          END DO
          CALL DLINT2XY(NXI2,XIW,NYI,YI,FIXW,NXYO,XO,YO,FO,XMSG,NOPT,
     +                  IER)
      END IF


      RETURN
      END

c -----------------------------------------------------------
c                           could be improved with f90 cycle/continue
      SUBROUTINE DLINT2XY(NXI,XI,NYI,YI,FI,NXYO,XO,YO,FO,XMSG,NOPT,IER)
      IMPLICIT NONE
      INTEGER NXI,NYI,NXYO,NOPT,IER
      DOUBLE PRECISION XI(NXI),YI(NYI),FI(NXI,NYI),XMSG
      DOUBLE PRECISION XO(NXYO),YO(NXYO),FO(NXYO)
c                               local
      INTEGER N,M,NXY,NN,MM
      DOUBLE PRECISION TMP1,TMP2,SLPX,SLPY

      DO NXY = 1,NXYO
          FO(NXY) = XMSG

          NN = 0
          DO N = 1,NXI - 1
              IF (XO(NXY).GE.XI(N) .AND. XO(NXY).LT.XI(N+1)) THEN
                  NN = N
                  GO TO 20
              END IF
          END DO

   20     MM = 0
          DO M = 1,NYI - 1
              IF (YO(NXY).GE.YI(M) .AND. YO(NXY).LT.YI(M+1)) THEN
                  MM = M
                  GO TO 40
              END IF
          END DO

   40     IF (NN.NE.0 .AND. MM.NE.0) THEN
              IF (XO(NXY).EQ.XI(NN) .AND. YO(NXY).EQ.YI(MM)) THEN
c                               exact location [no interpolation]
                  FO(NXY) = FI(NN,MM)
              ELSE IF (FI(NN,MM).NE.XMSG .AND. FI(NN+1,MM).NE.XMSG .AND.
     +                 FI(NN,MM+1).NE.XMSG .AND.
     +                 FI(NN+1,MM+1).NE.XMSG) THEN
c                               must interpolate: calculate slopes
                  SLPX = (XO(NXY)-XI(NN))/ (XI(NN+1)-XI(NN))
                  SLPY = (YO(NXY)-YI(MM))/ (YI(MM+1)-YI(MM))
c                               interpolate in "x" first
                  TMP1 = FI(NN,MM) + SLPX* (FI(NN+1,MM)-FI(NN,MM))
                  TMP2 = FI(NN,MM+1) + SLPX* (FI(NN+1,MM+1)-FI(NN,MM+1))
c                               interpolate in "y"
                  FO(NXY) = TMP1 + SLPY* (TMP2-TMP1)
              ELSE IF (NOPT.EQ.-1) THEN
                  CALL ESTFOW(FI(NN,MM),FI(NN+1,MM),FI(NN,MM+1),
     +                        FI(NN+1,MM+1),XI(NN),XI(NN+1),YI(MM),
     +                        YI(MM+1),FO(NXY),XO(NXY),YO(NXY),XMSG)
              END IF
          END IF

      END DO

      RETURN
      END
c ---------------------------------------------
      SUBROUTINE ESTFOW(F1,F2,F3,F4,X1,X2,Y1,Y2,F0,X0,Y0,XMSG)
      IMPLICIT NONE
      DOUBLE PRECISION F1,F2,F3,F4,X1,X2,Y1,Y2,F0,X0,Y0,XMSG
c local
      DOUBLE PRECISION FI(2,2),W(2,2),SUM,SWT
      INTEGER N,M

c     f3(x1,y2)+++++++++++f4(x2,y2)
c        f0(x0,y0)         someplace within the surrounding 4 pts
c     f3(x1,y1)+++++++++++f4(x2,y1)

c if all msg return

      F0 = XMSG
      IF (F1.EQ.XMSG .AND. F2.EQ.XMSG .AND. F3.EQ.XMSG .AND.
     +    F4.EQ.XMSG) RETURN

c compute 'distance wgted average
c .   make assumption that dx/dy are small and
c .   pythag theorem is good enough

c inverse distance wgts
      W(1,1) = 1.D0/SQRT((X1-X0)**2+ (Y1-Y0)**2)
      W(2,1) = 1.D0/SQRT((X2-X0)**2+ (Y1-Y0)**2)
      W(1,2) = 1.D0/SQRT((X1-X0)**2+ (Y2-Y0)**2)
      W(2,2) = 1.D0/SQRT((X2-X0)**2+ (Y2-Y0)**2)

      FI(1,1) = F1
      FI(2,1) = F2
      FI(1,2) = F3
      FI(2,2) = F4

      SUM = 0.D0
      SWT = 0.D0
      DO M = 1,2
          DO N = 1,2
              IF (FI(N,M).NE.XMSG) THEN
                  SUM = SUM + FI(N,M)*W(N,M)
                  SWT = SWT + W(N,M)
              END IF
          END DO
      END DO
c                               wgted average
      IF (SWT.GT.0.D0) THEN
          F0 = SUM/SWT
      END IF

      RETURN
      END

C
C	$Id: gqfai.f,v 1.5 2008-07-27 00:20:59 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GQFAI(ERRIND,INDEX)
C
C  INQUIRE FILL AREA INDEX
C
      include 'gkscom.h'
C
      INTEGER ERRIND,INDEX
C
C  Check if GKS is in the proper state.
C
      CALL GZCKST(8,-1,ERRIND)
      IF (ERRIND.EQ.0) THEN
       INDEX = CFAI
      ELSE
       INDEX = -1
      ENDIF
C
      RETURN
      END

C
C $Id: pj04dp.f,v 1.5 2008-07-27 00:17:10 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE PJ04DP (COORD,CRDIO,INDIC)
C
C -- L A M B E R T   C O N F O R M A L   C O N I C
C
      IMPLICIT DOUBLE PRECISION (A-Z)
      INTEGER INDIC
      DIMENSION GEOG(2),PROJ(2),COORD(2),CRDIO(2)
C **** PARAMETERS **** A,E,ES,LAT1,LAT2,LON0,LAT0,X0,Y0,NS,F,RH0 *******
      COMMON /ERRMZ0/ IERR
        INTEGER IERR
      SAVE   /ERRMZ0/
      COMMON /PRINZ0/ IPEMSG,IPELUN,IPPARM,IPPLUN
        INTEGER IPEMSG,IPELUN,IPPARM,IPPLUN
      SAVE   /PRINZ0/
      COMMON /PC04DP/ A,LON0,X0,Y0,E,F,NS,RH0
      DATA HALFPI /1.5707963267948966D0/
      DATA EPSLN /1.0D-10/
      DATA ZERO,ONE /0.0D0,1.0D0/
C
C -- F O R W A R D   . . .
C
      IF (INDIC .EQ. 0) THEN
C
         GEOG(1) = COORD(1)
         GEOG(2) = COORD(2)
         IERR = 0
         CON = ABS (ABS (GEOG(2)) - HALFPI)
         IF (CON .GT. EPSLN) GO TO 220
         CON = GEOG(2) * NS
         IF (CON .GT. ZERO) GO TO 210
         IF (IPEMSG .EQ. 0) WRITE (IPELUN,2030)
 2030    FORMAT (/' ERROR PJ04DP'/
     .            ' POINT CANNOT BE PROJECTED')
         IERR = 044
         RETURN
  210    RH = ZERO
         GO TO 230
  220    SINPHI = SIN (GEOG(2))
         TS = TSFNDP (E,GEOG(2),SINPHI)
         RH = A * F * TS ** NS
  230    THETA = NS * ADJLDP (GEOG(1) - LON0)
         PROJ(1) = X0 + RH * SIN (THETA)
         PROJ(2) = Y0 + RH0 - RH * COS (THETA)
         CRDIO(1) = PROJ(1)
         CRDIO(2) = PROJ(2)
         RETURN
      END IF
C
C -- I N V E R S E   . . .
C
      IF (INDIC .EQ. 1) THEN
C
         PROJ(1) = COORD(1)
         PROJ(2) = COORD(2)
         IERR = 0
         X = PROJ(1) - X0
         Y = RH0 - PROJ(2) + Y0
         RH = SIGN (SQRT (X*X + Y*Y) , NS)
         THETA = ZERO
         CON = SIGN (ONE , NS)
         IF (RH .NE. ZERO) THETA = ATAN2 (CON * X , CON * Y)
         IF (RH.NE.ZERO .OR. NS.GT.ZERO) GO TO 250
         GEOG(2) = - HALFPI
         GO TO 260
  250    CON = ONE / NS
         TS = (RH / (A * F)) ** CON
         GEOG(2) = PHI2DP (E,TS)
         IF (IERR .EQ. 0) GO TO 260
         IERR = 046
         RETURN
  260    GEOG(1) = ADJLDP (THETA / NS + LON0)
         CRDIO(1) = GEOG(1)
         CRDIO(2) = GEOG(2)
         RETURN
      END IF
C
      END

C
C $Id: hstbkd.f,v 1.7 2008-07-27 00:17:15 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE HSTBKD
C
C Calling this do-nothing subroutine forces "ld" to load the following
C block data routine (but only if they are in the same ".f" file).
C
        RETURN
C
      END
CNOSPLIT
      BLOCKDATA HSTBKDX
C
      COMMON /HSTGC1/ HORZNT, PERCNT, MIDVAL, SHADE, MEDIAN, PERIM,
     -       HFRAME, LISTOP, WINDOW, COLORS, HSTFOR, TITLE, LABEL,
     -       FREQNC, HWIND(4), COLSHA, COLREC, COLAXI, COLMED, COLTEX,
     -       COLTIT, COLPER, DRAWL, SPACE, LABMAX, CHARL, HEIGHT,
     -       ORIENT, COLSH2, SETSPA, SETSP2, MVALU, SETMVA, SETEPS,
     -       NMVAL, PMVAL, PERTIT
      LOGICAL HORZNT, PERCNT, MIDVAL, SHADE, MEDIAN, PERIM, HFRAME,
     -        LISTOP, WINDOW, COLORS, HSTFOR, TITLE, LABEL, FREQNC,
     -        DRAWL, SPACE, CHARL, MVALU, NMVAL, PMVAL, PERTIT
      COMMON /HSTGC2/ STRFOR, STRTIT, STRLAB, STRFRE, STRPER, LABTEX
      CHARACTER*96  STRTIT
      CHARACTER*55  STRFOR, STRLAB, STRFRE, STRPER
      CHARACTER*15 LABTEX(30)
      INTEGER  COLSHA, COLREC, COLAXI, COLMED, COLTEX
      INTEGER  COLTIT, COLPER, COLSH2, HEIGHT, ORIENT
C
      DATA HORZNT /.FALSE./
      DATA PERCNT /.TRUE./
      DATA MIDVAL /.TRUE./
      DATA SPACE  /.TRUE./
      DATA SHADE  /.TRUE./
      DATA DRAWL  /.FALSE./
      DATA MEDIAN /.FALSE./
      DATA PERIM  /.FALSE./
      DATA HFRAME /.TRUE./
      DATA LISTOP /.FALSE./
      DATA WINDOW /.FALSE./
      DATA COLORS /.FALSE./
      DATA HSTFOR /.FALSE./
      DATA TITLE  /.FALSE./
      DATA LABEL  /.FALSE./
      DATA FREQNC /.FALSE./
      DATA PERTIT /.FALSE./
      DATA CHARL  /.FALSE./
      DATA MVALU  /.FALSE./
      DATA NMVAL  /.TRUE./
      DATA PMVAL  /.TRUE./
      DATA HWIND  /0.,1.,0.,1./
      DATA COLSHA /1/
      DATA COLSH2 /1/
      DATA COLREC /1/
      DATA COLAXI /1/
      DATA COLMED /1/
      DATA COLTEX /1/
      DATA COLTIT /1/
      DATA COLPER /1/
      DATA HEIGHT /2/
      DATA ORIENT /0/
      DATA SETSPA /2./
      DATA SETSP2 /0./
      DATA SETMVA /-9999./
      DATA SETEPS /1.E-10/
      DATA STRFOR / '(G10.3)' /
      END

C
C	$Id: wmlgfa.f,v 1.4 2008-07-27 00:17:37 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE WMLGFA(XXC,YYC,NNC)
C
C  Subroutine for processing polygons generated by calls to PPINPO.
C
      DIMENSION XXC(NNC),YYC(NNC)
C
C  IDRFLG = -1  means draw a polyline only.
C         =  0  means draw a filled area only.
C         =  1  draws a filled area and a representative line for
C               showers.
C         =  2  draws a filled area and a representative line for
C               t-storms.
C         =  3  draws a filled area for showers.
C
      COMMON /WMLGCM/IDRFLG
C
      IF (IDRFLG .EQ. -1) THEN
        CALL GPL(NNC,XXC,YYC)
      ELSE IF (IDRFLG .EQ. 0) THEN
        CALL GFA(NNC,XXC,YYC)
      ELSE IF (IDRFLG .EQ. 1) THEN
        CALL GFA(NNC,XXC,YYC)
        CALL GQLWSC(IER,SCLO)
        CALL GSLWSC(.5)
        CALL GPL(2,XXC(2),YYC(2))
        CALL GSLWSC(SCLO)
      ELSE IF (IDRFLG .EQ. 2) THEN
        CALL GFA(NNC,XXC,YYC)
        CALL GQLWSC(IER,SCLO)
        CALL GSLWSC(.5)
        CALL GPL(4,XXC,YYC)
        CALL GSLWSC(SCLO)
      ELSE IF (IDRFLG .EQ. 3) THEN
        CALL GFA(NNC,XXC,YYC)
      ELSE IF (IDRFLG .EQ. 4) THEN
        CALL GFA(NNC,XXC,YYC)
        CALL GQLWSC(IER,SCLO)
        CALL GSLWSC(.5)
        CALL GPL(2,XXC,YYC)
        CALL GSLWSC(SCLO)
      ENDIF
C
      RETURN
      END

        PROGRAM TPPACK
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
        PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Open GKS, open a workstation of type 1, activate the workstation.
C
        CALL GOPKS (IERRF, ISZDM)
        CALL GOPWK (IWKID, LUNIT, IWTYPE)
        CALL GACWK (IWKID)
C
C Invoke the demo driver.
C
        CALL PPACK(IERR)
C
C Deactivate and close the workstation and close GKS.
C
        CALL GDAWK (IWKID)
        CALL GCLWK (IWKID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END

      SUBROUTINE PPACK (IERR)
C
C PURPOSE                To provide a simple demonstration of the use
C                        of a couple of the POLYPACK routines.
C
C USAGE                  CALL PPACK (IERR)
C
C ARGUMENTS
C
C ON OUTPUT              IERR
C
C                          an error parameter
C                          = 0, if the test is successful.
C
C I/O                    If the test is successful, the message
C
C                          POLYPACK TEST EXECUTED--SEE PLOTS TO CERTIFY
C
C                        is written on unit 6.
C
C PRECISION              Single.
C
C REQUIRED LIBRARY       POLYPACK, SPPS
C FILES
C
C REQUIRED GKS LEVEL     0A
C
C LANGUAGE               FORTRAN
C
C HISTORY                Written in June, 1994.
C
C ALGORITHM              TPPACK defines a simple clip polygon and a
C                        simple subject polygon, displays them both,
C                        and uses the POLYPACK routines PPINPO and
C                        PPINTR to fill the intersection.
C
C PORTABILITY            FORTRAN 77
C
C Declare arrays in which to define the clip polygon and the subject
C polygon.
C
        DIMENSION XCCP(5),YCCP(5),XCSP(11),YCSP(11)
C
C Declare the required work arrays.
C
        PARAMETER (NWRK=999)
C
        DIMENSION RWRK(NWRK),IWRK(NWRK)
C 
C The EQUIVALENCE line is commented out below. If memory storage is an
C issue for you, *and* RWRK is not a DOUBLE PRECISION variable, then you
C can uncomment this line.
C
C        EQUIVALENCE (RWRK(1),IWRK(1))
C
C Tell the compiler that the fill routines for polygons and trapezoids
C and the merge routine for polygons are EXTERNALs, not REALs.
C
        EXTERNAL FILLPO,FILLTR,MERGPO
C
C Merge polygons are formed in the common block MERGCM:
C
        COMMON /MERGCM/ XCMP(999),YCMP(999),NCMP
        SAVE   /MERGCM/
C
C Define the clip polygon to be a small square.
C
        DATA NCCP / 5 /
C
        DATA XCCP( 1),YCCP( 1) / -5. , -5. /
        DATA XCCP( 2),YCCP( 2) /  5. , -5. /
        DATA XCCP( 3),YCCP( 3) /  5. ,  5. /
        DATA XCCP( 4),YCCP( 4) / -5. ,  5. /
        DATA XCCP( 5),YCCP( 5) / -5. , -5. /
C
C Define the subject polygon to be a diamond with a hole in it.
C
        DATA NCSP / 11 /
C
        DATA XCSP( 1),YCSP( 1) /  0. ,  9. /
        DATA XCSP( 2),YCSP( 2) /  0. ,  6. /
        DATA XCSP( 3),YCSP( 3) /  6. ,  0. /
        DATA XCSP( 4),YCSP( 4) /  0. , -6. /
        DATA XCSP( 5),YCSP( 5) / -6. ,  0. /
        DATA XCSP( 6),YCSP( 6) /  0. ,  6. /
        DATA XCSP( 7),YCSP( 7) /  0. ,  9. /
        DATA XCSP( 8),YCSP( 8) / -9. ,  0. /
        DATA XCSP( 9),YCSP( 9) /  0. , -9. /
        DATA XCSP(10),YCSP(10) /  9. ,  0. /
        DATA XCSP(11),YCSP(11) /  0. ,  9. /
C
C Initialize the error flag to zero.
C
        IERR=0
C
C Enable solid fill instead of the default hollow fill.
C
        CALL GSFAIS (1)
C
C Turn off clipping by GKS.
C
        CALL GSCLIP (0)
C
C Put a label on the whole plot.
C
        CALL SET    (0.,1.,0.,1.,0.,1.,0.,1.,1)
        CALL PLCHHQ (.5,.975,'DEMONSTRATING THE USE OF POLYPACK',
     +                                                .015,0.,0.)
C
C In the upper left-hand corner, draw just the clip polygon and the
C subject polygon.
C
        CALL SET (.05,.475,.525,.95,-10.,10.,-10.,10.,1)
        CALL PLCHHQ (0.,-9.5,'The subject polygon (hollow diamond) and c
     +lip polygon (square).',.008,0.,0.)
        CALL GPL (NCCP,XCCP,YCCP)
        CALL GPL (NCSP,XCSP,YCSP)
C
C In the upper right-hand corner, fill the difference polygon, using
C PPDIPO and FILLPO.
C
        CALL SET (.525,.95,.525,.95,-10.,10.,-10.,10.,1)
        CALL PLCHHQ (0.,-9.5,'The difference (subject polygon minus clip
     + polygon).',.008,0.,0.)
        CALL GPL (NCCP,XCCP,YCCP)
        CALL GPL (NCSP,XCSP,YCSP)
        CALL PPDIPO (XCCP,YCCP,NCCP,XCSP,YCSP,NCSP,
     +                  RWRK,IWRK,NWRK,FILLPO,IERR)
        IF (IERR.NE.0) THEN
          WRITE (6,*) 'POLYPACK ROUTINE PPDIPO RETURNS IERR = ',IERR
          RETURN
        END IF
C
C In the lower left-hand corner, fill the intersection polygon, using
C PPINTR and FILLTR.
C
        CALL SET (.05,.475,.05,.475,-10.,10.,-10.,10.,1)
        CALL PLCHHQ (0.,-9.5,'The intersection of the subject and clip p
     +olygons.',.008,0.,0.)
        CALL GPL (NCCP,XCCP,YCCP)
        CALL GPL (NCSP,XCSP,YCSP)
        CALL PPINTR (XCCP,YCCP,NCCP,XCSP,YCSP,NCSP,
     +                  RWRK,IWRK,NWRK,FILLTR,IERR)
        IF (IERR.NE.0) THEN
          WRITE (6,*) 'POLYPACK ROUTINE PPINTR RETURNS IERR = ',IERR
          RETURN
        END IF
C
C In the lower right-hand corner, fill the union polygon, using PPUNPO
C and MERGPO.
C
        CALL SET (.525,.95,.05,.475,-10.,10.,-10.,10.,1)
        CALL PLCHHQ (0.,-9.5,'The union of the subject and clip polygons
     +.',.008,0.,0.)
        CALL GPL (NCCP,XCCP,YCCP)
        CALL GPL (NCSP,XCSP,YCSP)
        NCMP=0
        CALL PPUNPO (XCCP,YCCP,NCCP,XCSP,YCSP,NCSP,
     +                  RWRK,IWRK,NWRK,MERGPO,IERR)
        IF (IERR.NE.0) THEN
          WRITE (6,*) 'POLYPACK ROUTINE PPUNPO RETURNS IERR = ',IERR
          RETURN
        END IF
        IF (NCMP.EQ.0) THEN
          WRITE (6,*) 'MERGE POLYGON IS NULL'
          RETURN
        ELSE IF (NCMP.EQ.1000) THEN
          WRITE (6,*) 'MERGE POLYGON WAS TOO BIG TO HANDLE'
          RETURN
        ELSE
          CALL GFA (NCMP-1,XCMP,YCMP)
        END IF
C
C Advance the frame.
C
        CALL FRAME
C
C Write the appropriate message.
C
        WRITE (6,*) 'POLYPACK TEST EXECUTED--SEE PLOTS TO CERTIFY'
C
C Done.
C
        RETURN
C
      END



      SUBROUTINE FILLPO (XCRA,YCRA,NCRA)
C
        DIMENSION XCRA(NCRA),YCRA(NCRA)
C
C This routine processes polygons generated by the routines PPDIPO,
C PPINPO, and PPUNPO.
C
C Fill the polygon.
C
        CALL GFA (NCRA-1,XCRA,YCRA)
C
C Done.
C
        RETURN
C
      END



      SUBROUTINE FILLTR (XCBL,XCBR,YCOB,DXLE,DXRE,YCOT)
C
        DIMENSION XCRA(5),YCRA(5)
C
C This routine fills trapezoids generated by the routines PPDITR,
C PPINTR, and PPUNTR.
C
C If the trapezoid is not degenerate, fill it and outline it.
C
        IF (YCOT.GT.YCOB) THEN
          XCRA(1)=XCBL
          YCRA(1)=YCOB
          XCRA(2)=XCBR
          YCRA(2)=YCOB
          XCRA(3)=XCBR+DXRE*(YCOT-YCOB)
          YCRA(3)=YCOT
          XCRA(4)=XCBL+DXLE*(YCOT-YCOB)
          YCRA(4)=YCOT
          XCRA(5)=XCBL
          YCRA(5)=YCOB
          CALL GFA (4,XCRA,YCRA)
          CALL GPL (5,XCRA,YCRA)
        END IF
C
C Done.
C
        RETURN
C
      END



      SUBROUTINE MERGPO (XCRA,YCRA,NCRA)
C
        DIMENSION XCRA(NCRA),YCRA(NCRA)
C
C This routine merges the polygons generated by one of the routines
C PPDIPO, PPINPO, and PPUNPO into a single polygon with holes.
C
C Merge polygons are formed in the common block MERGCM:
C
        COMMON /MERGCM/ XCMP(999),YCMP(999),NCMP
        SAVE   /MERGCM/
C
C Copy the coordinates of the latest polygon into the merge polygon
C coordinate arrays and, if the polygon is not the first of the group,
C repeat the first point of the first polygon.  (Actually, the code
C below does something a little more complicated: if necessary, it
C interpolates points to ensure that the connecting lines between
C polygons consist of horizontal and/or vertical steps; this tends
C to prevent problems caused by deficiencies in the fill algorithms
C on some devices.)
C
        NTMP=NCMP
C
        IF (NTMP+NCRA+4.LE.999) THEN
          IF (NCMP.NE.0) THEN
            IF (XCMP(NTMP).NE.XCRA(1).AND.YCMP(NTMP).NE.YCRA(1)) THEN
              IF (YCMP(NTMP).LT.YCRA(1)) THEN
                NTMP=NTMP+1
                XCMP(NTMP)=XCRA(1)
                YCMP(NTMP)=YCMP(NTMP-1)
              ELSE
                NTMP=NTMP+1
                XCMP(NTMP)=XCMP(NTMP-1)
                YCMP(NTMP)=YCRA(1)
              END IF
            END IF
            NTMP=NTMP+1
            XCMP(NTMP)=XCRA(1)
            YCMP(NTMP)=YCRA(1)
          END IF
          DO 101 ICRA=1,NCRA
            XCMP(NTMP+ICRA)=XCRA(ICRA)
            YCMP(NTMP+ICRA)=YCRA(ICRA)
  101     CONTINUE
          NTMP=NTMP+NCRA
          IF (NCMP.NE.0) THEN
            IF (XCMP(NTMP).NE.XCMP(1).AND.YCMP(NTMP).NE.YCMP(1)) THEN
              IF (YCMP(NTMP).LT.YCMP(1)) THEN
                NTMP=NTMP+1
                XCMP(NTMP)=XCMP(1)
                YCMP(NTMP)=YCMP(NTMP-1)
              ELSE
                NTMP=NTMP+1
                XCMP(NTMP)=XCMP(NTMP-1)
                YCMP(NTMP)=YCMP(1)
              END IF
            END IF
            NTMP=NTMP+1
            XCMP(NTMP)=XCMP(1)
            YCMP(NTMP)=YCMP(1)
          END IF
        ELSE
          NTMP=1000
        END IF
C
        NCMP=NTMP
C
C Done.
C
        RETURN
C
      END

      SUBROUTINE CHER2 ( UPLO, N, ALPHA, X, INCX, Y, INCY, A, LDA )
*     .. Scalar Arguments ..
      COMPLEX            ALPHA
      INTEGER            INCX, INCY, LDA, N
      CHARACTER*1        UPLO
*     .. Array Arguments ..
      COMPLEX            A( LDA, * ), X( * ), Y( * )
*     ..
*
*  Purpose
*  =======
*
*  CHER2  performs the hermitian rank 2 operation
*
*     A := alpha*x*conjg( y' ) + conjg( alpha )*y*conjg( x' ) + A,
*
*  where alpha is a scalar, x and y are n element vectors and A is an n
*  by n hermitian matrix.
*
*  Parameters
*  ==========
*
*  UPLO   - CHARACTER*1.
*           On entry, UPLO specifies whether the upper or lower
*           triangular part of the array A is to be referenced as
*           follows:
*
*              UPLO = 'U' or 'u'   Only the upper triangular part of A
*                                  is to be referenced.
*
*              UPLO = 'L' or 'l'   Only the lower triangular part of A
*                                  is to be referenced.
*
*           Unchanged on exit.
*
*  N      - INTEGER.
*           On entry, N specifies the order of the matrix A.
*           N must be at least zero.
*           Unchanged on exit.
*
*  ALPHA  - COMPLEX         .
*           On entry, ALPHA specifies the scalar alpha.
*           Unchanged on exit.
*
*  X      - COMPLEX          array of dimension at least
*           ( 1 + ( n - 1 )*abs( INCX ) ).
*           Before entry, the incremented array X must contain the n
*           element vector x.
*           Unchanged on exit.
*
*  INCX   - INTEGER.
*           On entry, INCX specifies the increment for the elements of
*           X. INCX must not be zero.
*           Unchanged on exit.
*
*  Y      - COMPLEX          array of dimension at least
*           ( 1 + ( n - 1 )*abs( INCY ) ).
*           Before entry, the incremented array Y must contain the n
*           element vector y.
*           Unchanged on exit.
*
*  INCY   - INTEGER.
*           On entry, INCY specifies the increment for the elements of
*           Y. INCY must not be zero.
*           Unchanged on exit.
*
*  A      - COMPLEX          array of DIMENSION ( LDA, n ).
*           Before entry with  UPLO = 'U' or 'u', the leading n by n
*           upper triangular part of the array A must contain the upper
*           triangular part of the hermitian matrix and the strictly
*           lower triangular part of A is not referenced. On exit, the
*           upper triangular part of the array A is overwritten by the
*           upper triangular part of the updated matrix.
*           Before entry with UPLO = 'L' or 'l', the leading n by n
*           lower triangular part of the array A must contain the lower
*           triangular part of the hermitian matrix and the strictly
*           upper triangular part of A is not referenced. On exit, the
*           lower triangular part of the array A is overwritten by the
*           lower triangular part of the updated matrix.
*           Note that the imaginary parts of the diagonal elements need
*           not be set, they are assumed to be zero, and on exit they
*           are set to zero.
*
*  LDA    - INTEGER.
*           On entry, LDA specifies the first dimension of A as declared
*           in the calling (sub) program. LDA must be at least
*           max( 1, n ).
*           Unchanged on exit.
*
*
*  Level 2 Blas routine.
*
*  -- Written on 22-October-1986.
*     Jack Dongarra, Argonne National Lab.
*     Jeremy Du Croz, Nag Central Office.
*     Sven Hammarling, Nag Central Office.
*     Richard Hanson, Sandia National Labs.
*
*
*     .. Parameters ..
      COMPLEX            ZERO
      PARAMETER        ( ZERO = ( 0.0E+0, 0.0E+0 ) )
*     .. Local Scalars ..
      COMPLEX            TEMP1, TEMP2
      INTEGER            I, INFO, IX, IY, J, JX, JY, KX, KY
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     .. External Subroutines ..
      EXTERNAL           XERBLA
*     .. Intrinsic Functions ..
      INTRINSIC          CONJG, MAX, REAL
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      IF     ( .NOT.LSAME( UPLO, 'U' ).AND.
     $         .NOT.LSAME( UPLO, 'L' )      )THEN
         INFO = 1
      ELSE IF( N.LT.0 )THEN
         INFO = 2
      ELSE IF( INCX.EQ.0 )THEN
         INFO = 5
      ELSE IF( INCY.EQ.0 )THEN
         INFO = 7
      ELSE IF( LDA.LT.MAX( 1, N ) )THEN
         INFO = 9
      END IF
      IF( INFO.NE.0 )THEN
         CALL XERBLA( 'CHER2 ', INFO )
         RETURN
      END IF
*
*     Quick return if possible.
*
      IF( ( N.EQ.0 ).OR.( ALPHA.EQ.ZERO ) )
     $   RETURN
*
*     Set up the start points in X and Y if the increments are not both
*     unity.
*
      IF( ( INCX.NE.1 ).OR.( INCY.NE.1 ) )THEN
         IF( INCX.GT.0 )THEN
            KX = 1
         ELSE
            KX = 1 - ( N - 1 )*INCX
         END IF
         IF( INCY.GT.0 )THEN
            KY = 1
         ELSE
            KY = 1 - ( N - 1 )*INCY
         END IF
         JX = KX
         JY = KY
      END IF
*
*     Start the operations. In this version the elements of A are
*     accessed sequentially with one pass through the triangular part
*     of A.
*
      IF( LSAME( UPLO, 'U' ) )THEN
*
*        Form  A  when A is stored in the upper triangle.
*
         IF( ( INCX.EQ.1 ).AND.( INCY.EQ.1 ) )THEN
            DO 20, J = 1, N
               IF( ( X( J ).NE.ZERO ).OR.( Y( J ).NE.ZERO ) )THEN
                  TEMP1 = ALPHA*CONJG( Y( J ) )
                  TEMP2 = CONJG( ALPHA*X( J ) )
                  DO 10, I = 1, J - 1
                     A( I, J ) = A( I, J ) + X( I )*TEMP1 + Y( I )*TEMP2
   10             CONTINUE
                  A( J, J ) = REAL( A( J, J ) ) +
     $                        REAL( X( J )*TEMP1 + Y( J )*TEMP2 )
               ELSE
                  A( J, J ) = REAL( A( J, J ) )
               END IF
   20       CONTINUE
         ELSE
            DO 40, J = 1, N
               IF( ( X( JX ).NE.ZERO ).OR.( Y( JY ).NE.ZERO ) )THEN
                  TEMP1 = ALPHA*CONJG( Y( JY ) )
                  TEMP2 = CONJG( ALPHA*X( JX ) )
                  IX    = KX
                  IY    = KY
                  DO 30, I = 1, J - 1
                     A( I, J ) = A( I, J ) + X( IX )*TEMP1
     $                                     + Y( IY )*TEMP2
                     IX        = IX        + INCX
                     IY        = IY        + INCY
   30             CONTINUE
                  A( J, J ) = REAL( A( J, J ) ) +
     $                        REAL( X( JX )*TEMP1 + Y( JY )*TEMP2 )
               ELSE
                  A( J, J ) = REAL( A( J, J ) )
               END IF
               JX = JX + INCX
               JY = JY + INCY
   40       CONTINUE
         END IF
      ELSE
*
*        Form  A  when A is stored in the lower triangle.
*
         IF( ( INCX.EQ.1 ).AND.( INCY.EQ.1 ) )THEN
            DO 60, J = 1, N
               IF( ( X( J ).NE.ZERO ).OR.( Y( J ).NE.ZERO ) )THEN
                  TEMP1     = ALPHA*CONJG( Y( J ) )
                  TEMP2     = CONJG( ALPHA*X( J ) )
                  A( J, J ) = REAL( A( J, J ) ) +
     $                        REAL( X( J )*TEMP1 + Y( J )*TEMP2 )
                  DO 50, I = J + 1, N
                     A( I, J ) = A( I, J ) + X( I )*TEMP1 + Y( I )*TEMP2
   50             CONTINUE
               ELSE
                  A( J, J ) = REAL( A( J, J ) )
               END IF
   60       CONTINUE
         ELSE
            DO 80, J = 1, N
               IF( ( X( JX ).NE.ZERO ).OR.( Y( JY ).NE.ZERO ) )THEN
                  TEMP1     = ALPHA*CONJG( Y( JY ) )
                  TEMP2     = CONJG( ALPHA*X( JX ) )
                  A( J, J ) = REAL( A( J, J ) ) +
     $                        REAL( X( JX )*TEMP1 + Y( JY )*TEMP2 )
                  IX        = JX
                  IY        = JY
                  DO 70, I = J + 1, N
                     IX        = IX        + INCX
                     IY        = IY        + INCY
                     A( I, J ) = A( I, J ) + X( IX )*TEMP1
     $                                     + Y( IY )*TEMP2
   70             CONTINUE
               ELSE
                  A( J, J ) = REAL( A( J, J ) )
               END IF
               JX = JX + INCX
               JY = JY + INCY
   80       CONTINUE
         END IF
      END IF
*
      RETURN
*
*     End of CHER2 .
*
      END

      SUBROUTINE DLAR2V( N, X, Y, Z, INCX, C, S, INCC )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     February 29, 1992
*
*     .. Scalar Arguments ..
      INTEGER            INCC, INCX, N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   C( * ), S( * ), X( * ), Y( * ), Z( * )
*     ..
*
*  Purpose
*  =======
*
*  DLAR2V applies a vector of real plane rotations from both sides to
*  a sequence of 2-by-2 real symmetric matrices, defined by the elements
*  of the vectors x, y and z. For i = 1,2,...,n
*
*     ( x(i)  z(i) ) := (  c(i)  s(i) ) ( x(i)  z(i) ) ( c(i) -s(i) )
*     ( z(i)  y(i) )    ( -s(i)  c(i) ) ( z(i)  y(i) ) ( s(i)  c(i) )
*
*  Arguments
*  =========
*
*  N       (input) INTEGER
*          The number of plane rotations to be applied.
*
*  X       (input/output) DOUBLE PRECISION array,
*                         dimension (1+(N-1)*INCX)
*          The vector x.
*
*  Y       (input/output) DOUBLE PRECISION array,
*                         dimension (1+(N-1)*INCX)
*          The vector y.
*
*  Z       (input/output) DOUBLE PRECISION array,
*                         dimension (1+(N-1)*INCX)
*          The vector z.
*
*  INCX    (input) INTEGER
*          The increment between elements of X, Y and Z. INCX > 0.
*
*  C       (input) DOUBLE PRECISION array, dimension (1+(N-1)*INCC)
*          The cosines of the plane rotations.
*
*  S       (input) DOUBLE PRECISION array, dimension (1+(N-1)*INCC)
*          The sines of the plane rotations.
*
*  INCC    (input) INTEGER
*          The increment between elements of C and S. INCC > 0.
*
*  =====================================================================
*
*     .. Local Scalars ..
      INTEGER            I, IC, IX
      DOUBLE PRECISION   CI, SI, T1, T2, T3, T4, T5, T6, XI, YI, ZI
*     ..
*     .. Executable Statements ..
*
      IX = 1
      IC = 1
      DO 10 I = 1, N
         XI = X( IX )
         YI = Y( IX )
         ZI = Z( IX )
         CI = C( IC )
         SI = S( IC )
         T1 = SI*ZI
         T2 = CI*ZI
         T3 = T2 - SI*XI
         T4 = T2 + SI*YI
         T5 = CI*XI + T1
         T6 = CI*YI - T1
         X( IX ) = CI*T5 + SI*T4
         Y( IX ) = CI*T6 - SI*T3
         Z( IX ) = CI*T4 - SI*T5
         IX = IX + INCX
         IC = IC + INCC
   10 CONTINUE
*
*     End of DLAR2V
*
      RETURN
      END

      SUBROUTINE DLAHRD( N, K, NB, A, LDA, TAU, T, LDT, Y, LDY )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      INTEGER            K, LDA, LDT, LDY, N, NB
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), T( LDT, NB ), TAU( NB ),
     $                   Y( LDY, NB )
*     ..
*
*  Purpose
*  =======
*
*  DLAHRD reduces the first NB columns of a real general n-by-(n-k+1)
*  matrix A so that elements below the k-th subdiagonal are zero. The
*  reduction is performed by an orthogonal similarity transformation
*  Q' * A * Q. The routine returns the matrices V and T which determine
*  Q as a block reflector I - V*T*V', and also the matrix Y = A * V * T.
*
*  This is an auxiliary routine called by DGEHRD.
*
*  Arguments
*  =========
*
*  N       (input) INTEGER
*          The order of the matrix A.
*
*  K       (input) INTEGER
*          The offset for the reduction. Elements below the k-th
*          subdiagonal in the first NB columns are reduced to zero.
*
*  NB      (input) INTEGER
*          The number of columns to be reduced.
*
*  A       (input/output) DOUBLE PRECISION array, dimension (LDA,N-K+1)
*          On entry, the n-by-(n-k+1) general matrix A.
*          On exit, the elements on and above the k-th subdiagonal in
*          the first NB columns are overwritten with the corresponding
*          elements of the reduced matrix; the elements below the k-th
*          subdiagonal, with the array TAU, represent the matrix Q as a
*          product of elementary reflectors. The other columns of A are
*          unchanged. See Further Details.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(1,N).
*
*  TAU     (output) DOUBLE PRECISION array, dimension (NB)
*          The scalar factors of the elementary reflectors. See Further
*          Details.
*
*  T       (output) DOUBLE PRECISION array, dimension (LDT,NB)
*          The upper triangular matrix T.
*
*  LDT     (input) INTEGER
*          The leading dimension of the array T.  LDT >= NB.
*
*  Y       (output) DOUBLE PRECISION array, dimension (LDY,NB)
*          The n-by-nb matrix Y.
*
*  LDY     (input) INTEGER
*          The leading dimension of the array Y. LDY >= N.
*
*  Further Details
*  ===============
*
*  The matrix Q is represented as a product of nb elementary reflectors
*
*     Q = H(1) H(2) . . . H(nb).
*
*  Each H(i) has the form
*
*     H(i) = I - tau * v * v'
*
*  where tau is a real scalar, and v is a real vector with
*  v(1:i+k-1) = 0, v(i+k) = 1; v(i+k+1:n) is stored on exit in
*  A(i+k+1:n,i), and tau in TAU(i).
*
*  The elements of the vectors v together form the (n-k+1)-by-nb matrix
*  V which is needed, with T and Y, to apply the transformation to the
*  unreduced part of the matrix, using an update of the form:
*  A := (I - V*T*V') * (A - Y*V').
*
*  The contents of A on exit are illustrated by the following example
*  with n = 7, k = 3 and nb = 2:
*
*     ( a   h   a   a   a )
*     ( a   h   a   a   a )
*     ( a   h   a   a   a )
*     ( h   h   a   a   a )
*     ( v1  h   a   a   a )
*     ( v1  v2  a   a   a )
*     ( v1  v2  a   a   a )
*
*  where a denotes an element of the original matrix A, h denotes a
*  modified element of the upper Hessenberg matrix H, and vi denotes an
*  element of the vector defining H(i).
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO, ONE
      PARAMETER          ( ZERO = 0.0D+0, ONE = 1.0D+0 )
*     ..
*     .. Local Scalars ..
      INTEGER            I
      DOUBLE PRECISION   EI
*     ..
*     .. External Subroutines ..
      EXTERNAL           DAXPY, DCOPY, DGEMV, DLARFG, DSCAL, DTRMV
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MIN
*     ..
*     .. Executable Statements ..
*
*     Quick return if possible
*
      IF( N.LE.1 )
     $   RETURN
*
      DO 10 I = 1, NB
         IF( I.GT.1 ) THEN
*
*           Update A(1:n,i)
*
*           Compute i-th column of A - Y * V'
*
            CALL DGEMV( 'No transpose', N, I-1, -ONE, Y, LDY,
     $                  A( K+I-1, 1 ), LDA, ONE, A( 1, I ), 1 )
*
*           Apply I - V * T' * V' to this column (call it b) from the
*           left, using the last column of T as workspace
*
*           Let  V = ( V1 )   and   b = ( b1 )   (first I-1 rows)
*                    ( V2 )             ( b2 )
*
*           where V1 is unit lower triangular
*
*           w := V1' * b1
*
            CALL DCOPY( I-1, A( K+1, I ), 1, T( 1, NB ), 1 )
            CALL DTRMV( 'Lower', 'Transpose', 'Unit', I-1, A( K+1, 1 ),
     $                  LDA, T( 1, NB ), 1 )
*
*           w := w + V2'*b2
*
            CALL DGEMV( 'Transpose', N-K-I+1, I-1, ONE, A( K+I, 1 ),
     $                  LDA, A( K+I, I ), 1, ONE, T( 1, NB ), 1 )
*
*           w := T'*w
*
            CALL DTRMV( 'Upper', 'Transpose', 'Non-unit', I-1, T, LDT,
     $                  T( 1, NB ), 1 )
*
*           b2 := b2 - V2*w
*
            CALL DGEMV( 'No transpose', N-K-I+1, I-1, -ONE, A( K+I, 1 ),
     $                  LDA, T( 1, NB ), 1, ONE, A( K+I, I ), 1 )
*
*           b1 := b1 - V1*w
*
            CALL DTRMV( 'Lower', 'No transpose', 'Unit', I-1,
     $                  A( K+1, 1 ), LDA, T( 1, NB ), 1 )
            CALL DAXPY( I-1, -ONE, T( 1, NB ), 1, A( K+1, I ), 1 )
*
            A( K+I-1, I-1 ) = EI
         END IF
*
*        Generate the elementary reflector H(i) to annihilate
*        A(k+i+1:n,i)
*
         CALL DLARFG( N-K-I+1, A( K+I, I ), A( MIN( K+I+1, N ), I ), 1,
     $                TAU( I ) )
         EI = A( K+I, I )
         A( K+I, I ) = ONE
*
*        Compute  Y(1:n,i)
*
         CALL DGEMV( 'No transpose', N, N-K-I+1, ONE, A( 1, I+1 ), LDA,
     $               A( K+I, I ), 1, ZERO, Y( 1, I ), 1 )
         CALL DGEMV( 'Transpose', N-K-I+1, I-1, ONE, A( K+I, 1 ), LDA,
     $               A( K+I, I ), 1, ZERO, T( 1, I ), 1 )
         CALL DGEMV( 'No transpose', N, I-1, -ONE, Y, LDY, T( 1, I ), 1,
     $               ONE, Y( 1, I ), 1 )
         CALL DSCAL( N, TAU( I ), Y( 1, I ), 1 )
*
*        Compute T(1:i,i)
*
         CALL DSCAL( I-1, -TAU( I ), T( 1, I ), 1 )
         CALL DTRMV( 'Upper', 'No transpose', 'Non-unit', I-1, T, LDT,
     $               T( 1, I ), 1 )
         T( I, I ) = TAU( I )
*
   10 CONTINUE
      A( K+NB, NB ) = EI
*
      RETURN
*
*     End of DLAHRD
*
      END

c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by UCAR                 .
c  .                                                             .
c  .       University Corporation for Atmospheric Research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                         SPHEREPACK                          .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c
c
c ... file idvtes.f
c
c     this file includes documentation and code for
c     subroutine idvtes         i
c
c ... files which must be loaded with idvtes.f
c
c     sphcom.f, hrfft.f, vhses.f,shaes.f
c
c
c     subroutine idvtes(nlat,nlon,isym,nt,v,w,idvw,jdvw,ad,bd,av,bv,
c    +mdab,ndab,wvhses,lvhses,work,lwork,pertbd,pertbv,ierror)
c
c     given the scalar spherical harmonic coefficients ad,bd precomputed
C*PL*ERROR* Comment line too long
c     by subroutine shaes for the scalar field divg and coefficients av,bv
C*PL*ERROR* Comment line too long
c     precomputed by subroutine shaes for the scalar field vort, subroutine
C*PL*ERROR* Comment line too long
c     idvtes computes a vector field (v,w) whose divergence is divg - pertbd
C*PL*ERROR* Comment line too long
c     and whose vorticity is vort - pertbv.  w the is east longitude component
C*PL*ERROR* Comment line too long
c     and v is the colatitudinal component of the velocity.  if nt=1 (see nt
C*PL*ERROR* Comment line too long
c     below) pertrbd and pertbv are constants which must be subtracted from
C*PL*ERROR* Comment line too long
c     divg and vort for (v,w) to exist (see the description of pertbd and
C*PL*ERROR* Comment line too long
c     pertrbv below).  usually pertbd and pertbv are zero or small relative
C*PL*ERROR* Comment line too long
c     to divg and vort.  w(i,j) and v(i,j) are the velocity components at
c     colatitude
c
c            theta(i) = (i-1)*pi/(nlat-1)
c
c     and longitude
c
c            lambda(j) = (j-1)*2*pi/nlon
c
c     the
c
c            divergence(v(i,j),w(i,j))
c
c         =  [d(sint*v)/dtheta + dw/dlambda]/sint
c
c         =  divg(i,j) - pertbd
c
c     and
c
c            vorticity(v(i,j),w(i,j))
c
c         =  [-dv/dlambda + d(sint*w)/dtheta]/sint
c
c         =  vort(i,j) - pertbv
c
c     where
c
c            sint = cos(theta(i)).
c
c
c     input parameters
c
c     nlat   the number of colatitudes on the full sphere including the
c            poles. for example, nlat = 37 for a five degree grid.
c            nlat determines the grid increment in colatitude as
c            pi/(nlat-1).  if nlat is odd the equator is located at
c            grid point i=(nlat+1)/2. if nlat is even the equator is
c            located half way between points i=nlat/2 and i=nlat/2+1.
c            nlat must be at least 3. note: on the half sphere, the
c            number of grid points in the colatitudinal direction is
c            nlat/2 if nlat is even or (nlat+1)/2 if nlat is odd.
c
c     nlon   the number of distinct londitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater
c            than 3. the axisymmetric case corresponds to nlon=1.
c            the efficiency of the computation is improved when nlon
c            is a product of small prime numbers.
c
c
C*PL*ERROR* Comment line too long
c     isym   isym determines whether (v,w) are computed on the full or half
c            sphere as follows:
c
c      = 0
c            divg,vort are neither pairwise symmetric/antisymmetric nor
c            antisymmetric/symmetric about the equator as described for
C*PL*ERROR* Comment line too long
c            isym = 1 or isym = 2  below.  in this case, the vector field
C*PL*ERROR* Comment line too long
c            (v,w) is computed on the entire sphere.  i.e., in the arrays
c            w(i,j) and v(i,j) i=1,...,nlat and j=1,...,nlon.
c
c      = 1
c
C*PL*ERROR* Comment line too long
c            divg is antisymmetric and vort is symmetric about the equator.
C*PL*ERROR* Comment line too long
c            in this case w is antisymmetric and v is symmetric about the
C*PL*ERROR* Comment line too long
c            equator.  w and v are computed on the northern hemisphere only.
c            if nlat is odd they are computed for i=1,...,(nlat+1)/2
c            and j=1,...,nlon.  if nlat is even they are computed for
c            i=1,...,nlat/2 and j=1,...,nlon.
c
c      = 2
c
C*PL*ERROR* Comment line too long
c            divg is symmetric and vort is antisymmetric about the equator.
C*PL*ERROR* Comment line too long
c            in this case w is symmetric and v is antisymmetric about the
C*PL*ERROR* Comment line too long
c            equator.  w and v are computed on the northern hemisphere only.
c            if nlat is odd they are computed for i=1,...,(nlat+1)/2
c            and j=1,...,nlon.  if nlat is even they are computed for
c            i=1,...,nlat/2 and j=1,...,nlon.
c
c
C*PL*ERROR* Comment line too long
c     nt     in the program that calls idvtes, nt is the number of scalar
C*PL*ERROR* Comment line too long
c            and vector fields.  some computational efficiency is obtained
C*PL*ERROR* Comment line too long
c            for multiple fields.  the arrays ad,bd,av,bv,u, and v can be
c            three dimensional and pertbd,pertbv can be one dimensional
C*PL*ERROR* Comment line too long
c            corresponding to indexed multiple arrays divg, vort.  in this
c            case, multiple synthesis will be performed to compute each
C*PL*ERROR* Comment line too long
c            vector field.  the third index for ad,bd,av,bv,v,w and first
C*PL*ERROR* Comment line too long
c            pertrbd,pertbv is the synthesis index which assumes the values
C*PL*ERROR* Comment line too long
c            k=1,...,nt.  for a single synthesis set nt=1. the description of
C*PL*ERROR* Comment line too long
c            remaining parameters is simplified by assuming that nt=1 or that
c            ad,bd,av,bv,v,w are two dimensional and pertbd,pertbv are
c            constants.
c
c     idvw   the first dimension of the arrays v,w as it appears in
c            the program that calls idvtes. if isym = 0 then idvw
c            must be at least nlat.  if isym = 1 or 2 and nlat is
c            even then idvw must be at least nlat/2. if isym = 1 or 2
c            and nlat is odd then idvw must be at least (nlat+1)/2.
c
c     jdvw   the second dimension of the arrays v,w as it appears in
c            the program that calls idvtes. jdvw must be at least nlon.
c
c     ad,bd  two or three dimensional arrays (see input parameter nt)
c            that contain scalar spherical harmonic coefficients
C*PL*ERROR* Comment line too long
c            of the divergence array divg as computed by subroutine shaes.
c
c     av,bv  two or three dimensional arrays (see input parameter nt)
c            that contain scalar spherical harmonic coefficients
C*PL*ERROR* Comment line too long
c            of the vorticity array vort as computed by subroutine shaes.
C*PL*ERROR* Comment line too long
c     ***    ad,bd,av,bv must be computed by shaes prior to calling idvtes.
c
c     mdab   the first dimension of the arrays ad,bd,av,bv as it appears
C*PL*ERROR* Comment line too long
c            in the program that calls idvtes (and shaes). mdab must be at
c            least min0(nlat,(nlon+2)/2) if nlon is even or at least
c            min0(nlat,(nlon+1)/2) if nlon is odd.
c
C*PL*ERROR* Comment line too long
c     ndab   the second dimension of the arrays ad,bd,av,bv as it appears in
c            the program that calls idvtes (and shaes). ndab must be at
c            least nlat.
c
c  wvhses    an array which must be initialized by subroutine vhsesi.
c            wvhses can be used repeatedly by idvtes as long as nlon
c            and nlat remain unchanged.  wvhses must not be altered
c            between calls of idvtes.
c
c
c  lvhses    the dimension of the array wvhses as it appears in the
c            program that calls idvtes. define
c
c               l1 = min0(nlat,nlon/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            then lvhses must be at least
c
c               (l1*l2*(nlat+nlat-l1+1))/2+nlon+15
c
c
c     work   a work array that does not have to be saved.
c
c     lwork  the dimension of the array work as it appears in the
c            program that calls idvtes. define
c
c               l2 = nlat/2                    if nlat is even or
c               l2 = (nlat+1)/2                if nlat is odd
c               l1 = min0(nlat,nlon/2)       if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2)   if nlon is odd
c
c            if isym = 0 then lwork must be at least
c
c                       nlat*((2*nt+1)*nlon+4*nt*l1+1)
c
c            if isym = 1 or 2 then lwork must be at least
c
c                       (2*nt+1)*l2*nlon+nlat*(4*nt*l1+1)
c
c     **************************************************************
c
c     output parameters
c
c
C*PL*ERROR* Comment line too long
c     v,w   two or three dimensional arrays (see input parameter nt) that
c           contain a vector field whose divergence is divg - pertbd and
C*PL*ERROR* Comment line too long
c           whose vorticity is vort - pertbv.  w(i,j) is the east longitude
C*PL*ERROR* Comment line too long
c           component and v(i,j) is the colatitudinal component of velocity
c           at the colatitude theta(i) = (i-1)*pi/(nlat-1) and longitude
C*PL*ERROR* Comment line too long
c           lambda(j) = (j-1)*2*pi/nlon for i=1,...,nlat and j=1,...,nlon.
c
C*PL*ERROR* Comment line too long
c   pertbd  a nt dimensional array (see input parameter nt and assume nt=1
C*PL*ERROR* Comment line too long
c           for the description that follows).  divg - pertbd is a scalar
c           field which can be the divergence of a vector field (v,w).
c           pertbd is related to the scalar harmonic coefficients ad,bd
c           of divg (computed by shaes) by the formula
c
c                pertbd = ad(1,1)/(2.*sqrt(2.))
c
c           an unperturbed divg can be the divergence of a vector field
c           only if ad(1,1) is zero.  if ad(1,1) is nonzero (flagged by
c           pertbd nonzero) then subtracting pertbd from divg yields a
c           scalar field for which ad(1,1) is zero.  usually pertbd is
c           zero or small relative to divg.
c
C*PL*ERROR* Comment line too long
c   pertbv a nt dimensional array (see input parameter nt and assume nt=1
C*PL*ERROR* Comment line too long
c           for the description that follows).  vort - pertbv is a scalar
c           field which can be the vorticity of a vector field (v,w).
c           pertbv is related to the scalar harmonic coefficients av,bv
c           of vort (computed by shaes) by the formula
c
c                pertbv = av(1,1)/(2.*sqrt(2.))
c
c           an unperturbed vort can be the vorticity of a vector field
c           only if av(1,1) is zero.  if av(1,1) is nonzero (flagged by
c           pertbv nonzero) then subtracting pertbv from vort yields a
c           scalar field for which av(1,1) is zero.  usually pertbv is
c           zero or small relative to vort.
c
c    ierror = 0  no errors
c           = 1  error in the specification of nlat
c           = 2  error in the specification of nlon
c           = 3  error in the specification of isym
c           = 4  error in the specification of nt
c           = 5  error in the specification of idvw
c           = 6  error in the specification of jdvw
c           = 7  error in the specification of mdab
c           = 8  error in the specification of ndab
c           = 9  error in the specification of lvhses
c           = 10 error in the specification of lwork
c **********************************************************************
c
c
      SUBROUTINE DIDVTES(NLAT,NLON,ISYM,NT,V,W,IDVW,JDVW,AD,BD,AV,BV,
     +                  MDAB,NDAB,WVHSES,LVHSES,WORK,LWORK,PERTBD,
     +                  PERTBV,IERROR)
      DOUBLE PRECISION V
      DOUBLE PRECISION W
      DOUBLE PRECISION AD
      DOUBLE PRECISION BD
      DOUBLE PRECISION AV
      DOUBLE PRECISION BV
      DOUBLE PRECISION WVHSES
      DOUBLE PRECISION WORK
      DOUBLE PRECISION PERTBD
      DOUBLE PRECISION PERTBV
      DIMENSION W(IDVW,JDVW,NT),V(IDVW,JDVW,NT),PERTBD(NT),PERTBV(NT)
      DIMENSION AD(MDAB,NDAB,NT),BD(MDAB,NDAB,NT)
      DIMENSION AV(MDAB,NDAB,NT),BV(MDAB,NDAB,NT)
      DIMENSION WVHSES(LVHSES),WORK(LWORK)
c
c     check input parameters
c
      IERROR = 1
      IF (NLAT.LT.3) RETURN
      IERROR = 2
      IF (NLON.LT.4) RETURN
      IERROR = 3
      IF (ISYM.LT.0 .OR. ISYM.GT.2) RETURN
      IERROR = 4
      IF (NT.LT.0) RETURN
      IERROR = 5
      IMID = (NLAT+1)/2
      IF ((ISYM.EQ.0.AND.IDVW.LT.NLAT) .OR.
     +    (ISYM.NE.0.AND.IDVW.LT.IMID)) RETURN
      IERROR = 6
      IF (JDVW.LT.NLON) RETURN
      IERROR = 7
      MMAX = MIN0(NLAT, (NLON+1)/2)
      IF (MDAB.LT.MIN0(NLAT, (NLON+2)/2)) RETURN
      IERROR = 8
      IF (NDAB.LT.NLAT) RETURN
      IERROR = 9
      IDZ = (MMAX* (NLAT+NLAT-MMAX+1))/2
      LZIMN = IDZ*IMID
      IF (LVHSES.LT.LZIMN+LZIMN+NLON+15) RETURN
      IERROR = 10
c
c     verify unsaved work space length
c
      MN = MMAX*NLAT*NT
      IF (ISYM.NE.0 .AND. LWORK.LT.NLAT* (2*NT*NLON+MAX0(6*IMID,NLON))+
     +    4*MN+NLAT) RETURN
      IF (ISYM.EQ.0 .AND. LWORK.LT.IMID* (2*NT*NLON+MAX0(6*NLAT,NLON))+
     +    4*MN+NLAT) RETURN
      IERROR = 0
c
c     set work space pointers
c
      IBR = 1
      IBI = IBR + MN
      ICR = IBI + MN
      ICI = ICR + MN
      IS = ICI + MN
      IWK = IS + NLAT
      LIWK = LWORK - 4*MN - NLAT
      CALL DIDVTES1(NLAT,NLON,ISYM,NT,V,W,IDVW,JDVW,WORK(IBR),WORK(IBI),
     +             WORK(ICR),WORK(ICI),MMAX,WORK(IS),MDAB,NDAB,AD,BD,AV,
     +             BV,WVHSES,LVHSES,WORK(IWK),LIWK,PERTBD,PERTBV,IERROR)
      RETURN
      END

      SUBROUTINE DIDVTES1(NLAT,NLON,ISYM,NT,V,W,IDVW,JDVW,BR,BI,CR,CI,
     +                   MMAX,SQNN,MDAB,NDAB,AD,BD,AV,BV,WIDVTES,
     +                   LIDVTES,WK,LWK,PERTBD,PERTBV,IERROR)
      DOUBLE PRECISION V
      DOUBLE PRECISION W
      DOUBLE PRECISION BR
      DOUBLE PRECISION BI
      DOUBLE PRECISION CR
      DOUBLE PRECISION CI
      DOUBLE PRECISION SQNN
      DOUBLE PRECISION AD
      DOUBLE PRECISION BD
      DOUBLE PRECISION AV
      DOUBLE PRECISION BV
      DOUBLE PRECISION WIDVTES
      DOUBLE PRECISION WK
      DOUBLE PRECISION PERTBD
      DOUBLE PRECISION PERTBV
      DOUBLE PRECISION FN
      DIMENSION W(IDVW,JDVW,NT),V(IDVW,JDVW,NT)
      DIMENSION BR(MMAX,NLAT,NT),BI(MMAX,NLAT,NT),SQNN(NLAT)
      DIMENSION CR(MMAX,NLAT,NT),CI(MMAX,NLAT,NT)
      DIMENSION AD(MDAB,NDAB,NT),BD(MDAB,NDAB,NT)
      DIMENSION AV(MDAB,NDAB,NT),BV(MDAB,NDAB,NT)
      DIMENSION WIDVTES(LIDVTES),WK(LWK)
      DIMENSION PERTBD(NT),PERTBV(NT)
c
c     preset coefficient multiplyers in vector
c
      DO 1 N = 2,NLAT
          FN = DBLE(N-1)
          SQNN(N) = SQRT(FN* (FN+1.D0))
    1 CONTINUE
c
c     compute multiple vector fields coefficients
c
      DO 2 K = 1,NT
c
c     set divergence,vorticity perturbation constants
c
          PERTBD(K) = AD(1,1,K)/ (2.D0*SQRT(2.D0))
          PERTBV(K) = AV(1,1,K)/ (2.D0*SQRT(2.D0))
c
c     preset br,bi,cr,ci to 0.0
c
          DO 3 N = 1,NLAT
              DO 4 M = 1,MMAX
                  BR(M,N,K) = 0.0D0
                  BI(M,N,K) = 0.0D0
                  CR(M,N,K) = 0.0D0
                  CI(M,N,K) = 0.0D0
    4         CONTINUE
    3     CONTINUE
c
c     compute m=0 coefficients
c
          DO 5 N = 2,NLAT
              BR(1,N,K) = -AD(1,N,K)/SQNN(N)
              BI(1,N,K) = -BD(1,N,K)/SQNN(N)
              CR(1,N,K) = AV(1,N,K)/SQNN(N)
              CI(1,N,K) = BV(1,N,K)/SQNN(N)
    5     CONTINUE
c
c     compute m>0 coefficients
c
          DO 6 M = 2,MMAX
              DO 7 N = M,NLAT
                  BR(M,N,K) = -AD(M,N,K)/SQNN(N)
                  BI(M,N,K) = -BD(M,N,K)/SQNN(N)
                  CR(M,N,K) = AV(M,N,K)/SQNN(N)
                  CI(M,N,K) = BV(M,N,K)/SQNN(N)
    7         CONTINUE
    6     CONTINUE
    2 CONTINUE
c
c     set ityp for vector synthesis without assuming div=0 or curl=0
c
      IF (ISYM.EQ.0) THEN
          ITYP = 0
      ELSE IF (ISYM.EQ.1) THEN
          ITYP = 3
      ELSE IF (ISYM.EQ.2) THEN
          ITYP = 6
      END IF
c
c     sythesize br,bi,cr,ci into the vector field (v,w)
c
      CALL DVHSES(NLAT,NLON,ITYP,NT,V,W,IDVW,JDVW,BR,BI,CR,CI,MMAX,NLAT,
     +           WIDVTES,LIDVTES,WK,LWK,IERROR)
      RETURN
      END

C
C	$Id: wmsetc.f,v 1.7 2008-07-27 00:17:37 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE WMSETC (CNP,CVP)
C
      SAVE
C
      CHARACTER*(*) CNP,CVP
      CHARACTER*3   CC
C
C  This subroutine is called to give a character value to a specified
C  parameter.
C
C  CNP is the name of the parameter whose value is to be set.
C
C  CVP is a character variable containing the desired value.
C
C  Declare a local character variable in which to form an error message.
C
      CHARACTER*80 CTM
C
      include 'wmcomn.h'
C
C  Do a call forcing a BLOCKDATA to be loaded from a binary library.
C
      CALL WMBLDA
C
C  Check for an uncleared prior error.
C
      IF (ICFELL('WMSETC - Uncleared prior error',1) .NE. 0) RETURN
C
C  Check for a parameter name that is too short.
C
      IF (LEN(CNP) .LT. 3) THEN
        CTM(1:36)='WMSETC - Parameter name too short - '
        CTM(37:36+LEN(CNP)) = CNP
        CALL SETER (CTM(1:36+LEN(CNP)), 1, 1)
        GO TO 120
      ENDIF
C
C  FRO - Front type (one of 'WARM', 'COLD', 'OCCLUDED', 'STATIONARY',
C        'SQUALL', 'TROPICAL', 'CONVERGENCE').       
C
      IF (CNP(1:3).EQ.'FRO' .OR. CNP(1:3).EQ.'fro' .OR.
     +    CNP(1:3).EQ.'Fro') THEN
        CC = CVP(1:3)
        IF (CC.EQ.'COL' .OR. CC.EQ.'col' .OR. CC.EQ.'Col') THEN
          IFRONT = 1
          DO 10 I=1,MAXSYM
            ISTYPE(I) = IFRONT
   10     CONTINUE
        ELSE IF (CC.EQ.'WAR' .OR. CC.EQ.'war' .OR. CC.EQ.'War') THEN
          IFRONT = 2
          DO 40 I=1,MAXSYM
            ISTYPE(I) = IFRONT
   40     CONTINUE
        ELSE IF (CC.EQ.'STA' .OR. CC.EQ.'sta' .OR. CC.EQ.'Sta') THEN
          IFRONT = 3
          DO 50 I=1,MAXSYM
            IF (MOD(I,2) .EQ. 1) THEN
              ISTYPE(I) = 2
            ELSE
              ISTYPE(I) = -1
            ENDIF
   50     CONTINUE
        ELSE IF (CC.EQ.'OCC' .OR. CC.EQ.'occ' .OR. CC.EQ.'Occ') THEN
          IFRONT = 4
          DO 60 I=1,MAXSYM
            IF (MOD(I,2) .EQ. 1) THEN
              ISTYPE(I) = 2
            ELSE
              ISTYPE(I) = 1
            ENDIF
   60     CONTINUE
        ELSE IF (CC.EQ.'SQU' .OR. CC.EQ.'squ' .OR. CC.EQ.'Squ') THEN
          IFRONT = 5
        ELSE IF (CC.EQ.'TRO' .OR. CC.EQ.'tro' .OR. CC.EQ.'Tro') THEN
          IFRONT = 6
        ELSE IF (CC.EQ.'CON' .OR. CC.EQ.'con' .OR. CC.EQ.'Con') THEN
          IFRONT = 7
          DO 65 I=1,MAXSYM
            IF (MOD(I,2) .EQ. 1) THEN
              ISTYPE(I) = 3
            ELSE
              ISTYPE(I) = -3
            ENDIF
   65     CONTINUE
        ELSE
          CTM(1:42) = 'WMSETC - Parameter value out of range for '
          CTM(43:45) = CNP(1:3)
          CALL SETER (CTM(1:45), 2, 1)
          GO TO 120
        ENDIF
        GO TO 120
      ELSE
        CTM(1:36) = 'WMSETC - Parameter name not known - '
        CTM(37:39) = CNP(1:3)
        CALL SETER (CTM(1:39), 3, 1)
        GO TO 120
      ENDIF
C
  120 CONTINUE
      RETURN
      END

      SUBROUTINE PASSF2(IDO,L1,CC,CH,WA1)
      DOUBLE PRECISION CC
      DOUBLE PRECISION CH
      DOUBLE PRECISION WA1
      DOUBLE PRECISION TR2
      DOUBLE PRECISION TI2
      DIMENSION CC(IDO,2,L1),CH(IDO,L1,2),WA1(*)

      IF (IDO.GT.2) GO TO 102
      DO 101 K = 1,L1
          CH(1,K,1) = CC(1,1,K) + CC(1,2,K)
          CH(1,K,2) = CC(1,1,K) - CC(1,2,K)
          CH(2,K,1) = CC(2,1,K) + CC(2,2,K)
          CH(2,K,2) = CC(2,1,K) - CC(2,2,K)
  101 CONTINUE
      RETURN
  102 DO 104 K = 1,L1
          DO 103 I = 2,IDO,2
              CH(I-1,K,1) = CC(I-1,1,K) + CC(I-1,2,K)
              TR2 = CC(I-1,1,K) - CC(I-1,2,K)
              CH(I,K,1) = CC(I,1,K) + CC(I,2,K)
              TI2 = CC(I,1,K) - CC(I,2,K)
              CH(I,K,2) = WA1(I-1)*TI2 - WA1(I)*TR2
              CH(I-1,K,2) = WA1(I-1)*TR2 + WA1(I)*TI2
  103     CONTINUE
  104 CONTINUE
      RETURN
      END

C
C	$Id: gwiiws.f,v 1.6 2008-07-27 00:21:07 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GWIIWS
C
C  Initialization of constants.
C
C
C  Initialize workstation state list and other internal constants.
C
      include 'gwiwsl.h'
      include 'gwiins.h'
      include 'gwienu.h'
C
C  Internal constants.
C
C  MIN and MAX VDC address limits in the X and Y directions
C  (the VDC extent).
C
      MINXVD = 0
      MAXXVD = 32767
      MINYVD = 0
      MAXYVD = 32767
C
C  NDC to VDC mapping coefficients, X and Y directions.
C
      MXOFF = 0
      MXSCAL = 32767
      MYOFF = 0
      MYSCAL = 32767
C
C  WSL items.
C
C  State is inactive (0=GINACT)
C
      MSTATE = GINACT
C
C  Display surface is empty (1=GEMPTY)
C
      MDEMPT = GEMPTY
C
C  Requested workstation window in NDC is unit square.
C
      RWINDO(1) = 0.0
      RWINDO(2) = 1.0
      RWINDO(3) = 0.0
      RWINDO(4) = 1.0
C
C  Current workstation window in NDC is unit square.
C
      CWINDO(1) = 0.0
      CWINDO(2) = 1.0
      CWINDO(3) = 0.0
      CWINDO(4) = 1.0
C
C  Requested workstation viewport is real address space.
C
      RWKVP(1) = 0.
      RWKVP(2) = 32767.
      RWKVP(3) = 0.
      RWKVP(4) = 32767.
C
C  Current workstation viewport is real address space.
C
      CWKVP(1) = 0.
      CWKVP(2) = 32767.
      CWKVP(3) = 0.
      CWKVP(4) = 32767.
C
C  WSL clipping control parameters.
C
C  Clipping indicator is on (1=GCLIP)
C
      MRCLIP = GCLIP
C
C  Clipping rectangle.
C
      MRCREC(1) = MINXVD
      MRCREC(2) = MINYVD
      MRCREC(3) = MAXXVD
      MRCREC(4) = MAXYVD
C
      RETURN
      END

      SUBROUTINE DPTTS2( N, NRHS, D, E, B, LDB )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      INTEGER            LDB, N, NRHS
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   B( LDB, * ), D( * ), E( * )
*     ..
*
*  Purpose
*  =======
*
*  DPTTS2 solves a tridiagonal system of the form
*     A * X = B
*  using the L*D*L' factorization of A computed by DPTTRF.  D is a
*  diagonal matrix specified in the vector D, L is a unit bidiagonal
*  matrix whose subdiagonal is specified in the vector E, and X and B
*  are N by NRHS matrices.
*
*  Arguments
*  =========
*
*  N       (input) INTEGER
*          The order of the tridiagonal matrix A.  N >= 0.
*
*  NRHS    (input) INTEGER
*          The number of right hand sides, i.e., the number of columns
*          of the matrix B.  NRHS >= 0.
*
*  D       (input) DOUBLE PRECISION array, dimension (N)
*          The n diagonal elements of the diagonal matrix D from the
*          L*D*L' factorization of A.
*
*  E       (input) DOUBLE PRECISION array, dimension (N-1)
*          The (n-1) subdiagonal elements of the unit bidiagonal factor
*          L from the L*D*L' factorization of A.  E can also be regarded
*          as the superdiagonal of the unit bidiagonal factor U from the
*          factorization A = U'*D*U.
*
*  B       (input/output) DOUBLE PRECISION array, dimension (LDB,NRHS)
*          On entry, the right hand side vectors B for the system of
*          linear equations.
*          On exit, the solution vectors, X.
*
*  LDB     (input) INTEGER
*          The leading dimension of the array B.  LDB >= max(1,N).
*
*  =====================================================================
*
*     .. Local Scalars ..
      INTEGER            I, J
*     ..
*     .. External Subroutines ..
      EXTERNAL           DSCAL
*     ..
*     .. Executable Statements ..
*
*     Quick return if possible
*
      IF( N.LE.1 ) THEN
         IF( N.EQ.1 )
     $      CALL DSCAL( NRHS, 1.D0 / D( 1 ), B, LDB )
         RETURN
      END IF
*
*     Solve A * X = B using the factorization A = L*D*L',
*     overwriting each right hand side vector with its solution.
*
      DO 30 J = 1, NRHS
*
*           Solve L * x = b.
*
         DO 10 I = 2, N
            B( I, J ) = B( I, J ) - B( I-1, J )*E( I-1 )
   10    CONTINUE
*
*           Solve D * L' * x = b.
*
         B( N, J ) = B( N, J ) / D( N )
         DO 20 I = N - 1, 1, -1
            B( I, J ) = B( I, J ) / D( I ) - B( I+1, J )*E( I )
   20    CONTINUE
   30 CONTINUE
*
      RETURN
*
*     End of DPTTS2
*
      END

c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by UCAR                 .
c  .                                                             .
c  .       University Corporation for Atmospheric Research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                         SPHEREPACK                       .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c
c
c ... file sfvpec.f
c
c     this file includes documentation and code for
c     subroutine sfvpec          i
c
c ... files which must be loaded with sfvpec.f
c
c     sphcom.f, hrfft.f, vhaec.f, shsec.f
c
c
c     subroutine sfvpec(nlat,nlon,isym,nt,sf,vp,idv,jdv,br,bi,cr,ci,
c    +                   mdb,ndb,wshsec,lshsec,work,lwork,ierror)
c
c     given the vector spherical harmonic coefficients br,bi,cr,ci,
c     computed by subroutine vhaec for a vector field (v,w), sfvpec
c     computes a scalar stream function sf and scalar velocity potential
c     vp for (v,w).  (v,w) is expressed in terms of sf and vp by the
c     helmholtz relations (in mathematical spherical coordinates):
c
c          v = -1/sint*d(vp)/dlambda + d(st)/dtheta
c
c          w =  1/sint*d(st)/dlambda + d(vp)/dtheta
c
c     where sint = sin(theta).  w is the east longitudinal and v
c     is the colatitudinal component of the vector field from which
c     br,bi,cr,ci were precomputed.  required associated legendre
c     polynomials are recomputed rather than stored as they are in
c     subroutine sfvpes. sf(i,j) and vp(i,j) are given at colatitude
c
c            theta(i) = (i-1)*pi/(nlat-1)
c
c     and east longitude
c
c            lambda(j) = (j-1)*2*pi/nlon
c
c     on the sphere.
c
c
c     input parameters
c
c     nlat   the number of colatitudes on the full sphere including the
c            poles. for example, nlat = 37 for a five degree grid.
c            nlat determines the grid increment in colatitude as
c            pi/(nlat-1).  if nlat is odd the equator is located at
c            grid point i=(nlat+1)/2. if nlat is even the equator is
c            located half way between points i=nlat/2 and i=nlat/2+1.
c            nlat must be at least 3. note: on the half sphere, the
c            number of grid points in the colatitudinal direction is
c            nlat/2 if nlat is even or (nlat+1)/2 if nlat is odd.
c
c     nlon   the number of distinct londitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater than
c            3.  the efficiency of the computation is improved when nlon
c            is a product of small prime numbers.
c
c
C*PL*ERROR* Comment line too long
c     isym   a parameter which determines whether the stream function and
c            velocity potential are computed on the full or half sphere
c            as follows:
c
c      = 0
c
c            the symmetries/antsymmetries described in isym=1,2 below
c            do not exist in (v,w) about the equator.  in this case sf
c            and vp are not necessarily symmetric or antisymmetric about
c            the equator.  sf and vp are computed on the entire sphere.
c            i.e., in arrays sf(i,j),vp(i,j) for i=1,...,nlat and
c            j=1,...,nlon.
c
c      = 1
c
c            w is antisymmetric and v is symmetric about the equator.
c            in this case sf is symmetric and vp antisymmetric about
c            the equator and are computed for the northern hemisphere
C*PL*ERROR* Comment line too long
c            only.  i.e., if nlat is odd the sf(i,j),vp(i,j) are computed
c            for i=1,...,(nlat+1)/2 and for j=1,...,nlon.  if nlat is
c            even then sf(i,j),vp(i,j) are computed for i=1,...,nlat/2
c            and j=1,...,nlon.
c
c      = 2
c
c            w is symmetric and v is antisymmetric about the equator.
c            in this case sf is antisymmetric and vp symmetric about
c            the equator and are computed for the northern hemisphere
C*PL*ERROR* Comment line too long
c            only.  i.e., if nlat is odd the sf(i,j),vp(i,j) are computed
c            for i=1,...,(nlat+1)/2 and for j=1,...,nlon.  if nlat is
c            even then sf(i,j),vp(i,j) are computed for i=1,...,nlat/2
c            and j=1,...,nlon.
c
c     nt     nt is the number of scalar and vector fields.  some
C*PL*ERROR* Comment line too long
c            computational efficiency is obtained for multiple fields. arrays
C*PL*ERROR* Comment line too long
c            can be three dimensional corresponding to an indexed multiple
c            vector field.  in this case multiple scalar synthesis will
c            be performed to compute sf,vp for each field.  the
c            third index is the synthesis index which assumes the values
c            k=1,...,nt.  for a single synthesis set nt = 1.  the
c            description of the remaining parameters is simplified by
C*PL*ERROR* Comment line too long
c            assuming that nt=1 or that all the arrays are two dimensional.
c
c     idv    the first dimension of the arrays sf,vp as it appears in
c            the program that calls sfvpec. if isym = 0 then idv
c            must be at least nlat.  if isym = 1 or 2 and nlat is
c            even then idv must be at least nlat/2. if isym = 1 or 2
c            and nlat is odd then idv must be at least (nlat+1)/2.
c
c     jdv    the second dimension of the arrays sf,vp as it appears in
c            the program that calls sfvpec. jdv must be at least nlon.
c
c     br,bi, two or three dimensional arrays (see input parameter nt)
c     cr,ci  that contain vector spherical harmonic coefficients
c            of the vector field (v,w) as computed by subroutine vhaec.
c
c     mdb    the first dimension of the arrays br,bi,cr,ci as it
c            appears in the program that calls sfvpec. mdb must be at
c            least min0(nlat,nlon/2) if nlon is even or at least
c            min0(nlat,(nlon+1)/2) if nlon is odd.
c
c     ndb    the second dimension of the arrays br,bi,cr,ci as it
c            appears in the program that calls sfvpec. ndb must be at
c            least nlat.
c
c     wshsec an array which must be initialized by subroutine shseci.
c            once initialized, wshsec can be used repeatedly by sfvpec
c            as long as nlon and nlat remain unchanged.  wshsec must
c            not bel altered between calls of sfvpec.
c
c
c     lshsec the dimension of the array wshsec as it appears in the
c            program that calls sfvpec. define
c
c               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            then lshsec must be at least
c
c            2*nlat*l2+3*((l1-2)*(nlat+nlat-l1-1))/2+nlon+15
c
c
c     work   a work array that does not have to be saved.
c
c     lwork  the dimension of the array work as it appears in the
c            program that calls sfvpec. define
c
c               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2                    if nlat is even or
c               l2 = (nlat+1)/2                if nlat is odd
c
c            if isym is zero then lwork must be at least
c
c                nlat*((nt*nlon+max0(3*l2,nlon)) + 2*l1*nt+1)
c
c            if isym is not zero then lwork must be at least
c
c                l2*(nt*nlon+max0(3*nlat,nlon)) + nlat*(2*l1*nt+1)
c
c     **************************************************************
c
c     output parameters
c
c    sf,vp  two or three dimensional arrays (see input parameter nt)
c           that contains the stream function and velocity potential
c           of the vector field (v,w) whose coefficients br,bi,cr,ci
c           where precomputed by subroutine vhaec.  sf(i,j),vp(i,j)
c           are given at the colatitude point
c
c                theta(i) = (i-1)*pi/(nlat-1)
c
c           and longitude point
c
c                lambda(j) = (j-1)*2*pi/nlon
c
C*PL*ERROR* Comment line too long
c           the index ranges are defined above at the input parameter isym.
c
c
c    ierror = 0  no errors
c           = 1  error in the specification of nlat
c           = 2  error in the specification of nlon
c           = 3  error in the specification of isym
c           = 4  error in the specification of nt
c           = 5  error in the specification of idv
c           = 6  error in the specification of jdv
c           = 7  error in the specification of mdb
c           = 8  error in the specification of ndb
c           = 9  error in the specification of lshsec
c           = 10 error in the specification of lwork
c **********************************************************************
c
      SUBROUTINE DSFVPEC(NLAT,NLON,ISYM,NT,SF,VP,IDV,JDV,BR,BI,CR,CI,
     +                   MDB,NDB,WSHSEC,LSHSEC,WORK,LWORK,IERROR)
      IMPLICIT NONE
      INTEGER NLAT,NLON,ISYM,NT,IDV,JDV,MDB,NDB,LSHSEC,LWORK,IERROR
      DOUBLE PRECISION SF(IDV,JDV,NT),VP(IDV,JDV,NT)
      DOUBLE PRECISION BR(MDB,NDB,NT),BI(MDB,NDB,NT)
      DOUBLE PRECISION CR(MDB,NDB,NT),CI(MDB,NDB,NT)
      DOUBLE PRECISION WSHSEC(LSHSEC),WORK(LWORK)
      INTEGER IMID,MMAX,LZZ1,LABC,LS,NLN,MAB,MN,IA,IB,IS,LWK,IWK,LWMIN
c
c     check input parameters
c
      IERROR = 1
      IF (NLAT.LT.3) RETURN
      IERROR = 2
      IF (NLON.LT.4) RETURN
      IERROR = 3
      IF (ISYM.LT.0 .OR. ISYM.GT.2) RETURN
      IERROR = 4
      IF (NT.LT.0) RETURN
      IERROR = 5
      IMID = (NLAT+1)/2
      IF ((ISYM.EQ.0.AND.IDV.LT.NLAT) .OR.
     +    (ISYM.GT.0.AND.IDV.LT.IMID)) RETURN
      IERROR = 6
      IF (JDV.LT.NLON) RETURN
      IERROR = 7
      MMAX = MIN0(NLAT, (NLON+2)/2)
      IF (MDB.LT.MIN0(NLAT, (NLON+1)/2)) RETURN
      IERROR = 8
      IF (NDB.LT.NLAT) RETURN
      IERROR = 9
c
c     verify saved work space (same as shsec)
c
      IMID = (NLAT+1)/2
      LZZ1 = 2*NLAT*IMID
      LABC = 3* (MAX0(MMAX-2,0)* (NLAT+NLAT-MMAX-1))/2
      LWMIN = LZZ1 + LABC + NLON + 15

      IF (LSHSEC.LT.LWMIN) RETURN
c
c     verify unsaved work space (add to what shec requires)
c
      IERROR = 10
      LS = NLAT
      IF (ISYM.GT.0) LS = IMID
      NLN = NT*LS*NLON
c
c     set first dimension for a,b (as requried by shsec)
c
      MAB = MIN0(NLAT,NLON/2+1)
      MN = MAB*NLAT*NT
      IF (LWORK.LT.NLN+MAX0(LS*NLON,3*NLAT*IMID)+2*MN+NLAT) RETURN
      IERROR = 0
c
c     set work space pointers
c
      IA = 1
      IB = IA + MN
      IS = IB + MN
      IWK = IS + NLAT
      LWK = LWORK - 2*MN - NLAT
      CALL DSFVPEC1(NLAT,NLON,ISYM,NT,SF,VP,IDV,JDV,BR,BI,CR,CI,MDB,NDB,
     +             WORK(IA),WORK(IB),MAB,WORK(IS),WSHSEC,LSHSEC,
     +             WORK(IWK),LWK,IERROR)
      RETURN
      END

      SUBROUTINE DSFVPEC1(NLAT,NLON,ISYM,NT,SF,VP,IDV,JDV,BR,BI,CR,CI,
     +                   MDB,NDB,A,B,MAB,FNN,WSHSEC,LSHSEC,WK,LWK,
     +                   IERROR)
      IMPLICIT NONE
      INTEGER NLAT,NLON,ISYM,NT,IDV,JDV,MDB,NDB,MAB,LSHSEC,LWK,IERROR
      DOUBLE PRECISION SF(IDV,JDV,NT),VP(IDV,JDV,NT)
      DOUBLE PRECISION BR(MDB,NDB,NT),BI(MDB,NDB,NT),CR(MDB,NDB,NT),
     +                 CI(MDB,NDB,NT)
      DOUBLE PRECISION A(MAB,NLAT,NT),B(MAB,NLAT,NT)
      DOUBLE PRECISION WSHSEC(LSHSEC),WK(LWK),FNN(NLAT)
      INTEGER N,M,MMAX,K
c
c     set coefficient multiplyers
c
      DO N = 2,NLAT
          FNN(N) = 1.0D0/SQRT(DBLE(N* (N-1)))
      END DO
      MMAX = MIN0(NLAT, (NLON+1)/2)
c
c     compute sf scalar coefficients from cr,ci
c
      DO K = 1,NT
          DO N = 1,NLAT
              DO M = 1,MAB
                  A(M,N,K) = 0.0D0
                  B(M,N,K) = 0.0D0
              END DO
          END DO
c
c     compute m=0 coefficients
c
          DO N = 2,NLAT
              A(1,N,K) = -FNN(N)*CR(1,N,K)
              B(1,N,K) = -FNN(N)*CI(1,N,K)
          END DO
c
c     compute m>0 coefficients using vector spherepack value for mmax
c
          DO M = 2,MMAX
              DO N = M,NLAT
                  A(M,N,K) = -FNN(N)*CR(M,N,K)
                  B(M,N,K) = -FNN(N)*CI(M,N,K)
              END DO
          END DO
      END DO
c
c     synthesize a,b into st
c
      CALL DSHSEC(NLAT,NLON,ISYM,NT,SF,IDV,JDV,A,B,MAB,NLAT,WSHSEC,
     +           LSHSEC,WK,LWK,IERROR)
c
c    set coefficients for vp from br,bi
c
      DO K = 1,NT
          DO N = 1,NLAT
              DO M = 1,MAB
                  A(M,N,K) = 0.0D0
                  B(M,N,K) = 0.0D0
              END DO
          END DO
c
c     compute m=0 coefficients
c
          DO N = 2,NLAT
              A(1,N,K) = FNN(N)*BR(1,N,K)
              B(1,N,K) = FNN(N)*BI(1,N,K)
          END DO
c
c     compute m>0 coefficients using vector spherepack value for mmax
c
          MMAX = MIN0(NLAT, (NLON+1)/2)
          DO M = 2,MMAX
              DO N = M,NLAT
                  A(M,N,K) = FNN(N)*BR(M,N,K)
                  B(M,N,K) = FNN(N)*BI(M,N,K)
              END DO
          END DO
      END DO
c
c     synthesize a,b into vp
c
      CALL DSHSEC(NLAT,NLON,ISYM,NT,VP,IDV,JDV,A,B,MAB,NLAT,WSHSEC,
     +           LSHSEC,WK,LWK,IERROR)
      RETURN
      END

C
C $Id: msfndp.f,v 1.5 2008-07-27 00:17:09 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      DOUBLE PRECISION FUNCTION MSFNDP (ECCENT,SINPHI,COSPHI)
C
C This function computes the constant "small m".
C
      IMPLICIT DOUBLE PRECISION (A-Z)
      DATA ONE /1.0D0/
C
      CON = ECCENT * SINPHI
      MSFNDP = COSPHI / SQRT (ONE - CON * CON)
C
      RETURN
      END

C
C $Id: pwrx.f,v 1.5 2008-07-27 00:17:21 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE PWRX (X,Y,ID,N,SIZE,THETA,ICNT)
C
C PWRX IS AN OLD ENTRY POINT AND HAS BEEN REMOVED - USE PLOTCHAR
C
      WRITE (I1MACH(4),1001)
      WRITE (I1MACH(4),1002)
      STOP
C
 1001 FORMAT ('1'//////////)
 1002 FORMAT (' ****************************************'/
     1        ' *                                      *'/
     2        ' *                                      *'/
     3        ' *   THE ENTRY POINT PWRX IS NO LONGER  *'/
     4        ' *   SUPPORTED.  PLEASE USE PLOTCHAR.   *'/
     5        ' *                                      *'/
     6        ' *                                      *'/
     7        ' ****************************************')
      END

      SUBROUTINE DGEBAL( JOB, N, A, LDA, ILO, IHI, SCALE, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          JOB
      INTEGER            IHI, ILO, INFO, LDA, N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), SCALE( * )
*     ..
*
*  Purpose
*  =======
*
*  DGEBAL balances a general real matrix A.  This involves, first,
*  permuting A by a similarity transformation to isolate eigenvalues
*  in the first 1 to ILO-1 and last IHI+1 to N elements on the
*  diagonal; and second, applying a diagonal similarity transformation
*  to rows and columns ILO to IHI to make the rows and columns as
*  close in norm as possible.  Both steps are optional.
*
*  Balancing may reduce the 1-norm of the matrix, and improve the
*  accuracy of the computed eigenvalues and/or eigenvectors.
*
*  Arguments
*  =========
*
*  JOB     (input) CHARACTER*1
*          Specifies the operations to be performed on A:
*          = 'N':  none:  simply set ILO = 1, IHI = N, SCALE(I) = 1.0
*                  for i = 1,...,N;
*          = 'P':  permute only;
*          = 'S':  scale only;
*          = 'B':  both permute and scale.
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  A       (input/output) DOUBLE PRECISION array, dimension (LDA,N)
*          On entry, the input matrix A.
*          On exit,  A is overwritten by the balanced matrix.
*          If JOB = 'N', A is not referenced.
*          See Further Details.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(1,N).
*
*  ILO     (output) INTEGER
*  IHI     (output) INTEGER
*          ILO and IHI are set to integers such that on exit
*          A(i,j) = 0 if i > j and j = 1,...,ILO-1 or I = IHI+1,...,N.
*          If JOB = 'N' or 'S', ILO = 1 and IHI = N.
*
*  SCALE   (output) DOUBLE PRECISION array, dimension (N)
*          Details of the permutations and scaling factors applied to
*          A.  If P(j) is the index of the row and column interchanged
*          with row and column j and D(j) is the scaling factor
*          applied to row and column j, then
*          SCALE(j) = P(j)    for j = 1,...,ILO-1
*                   = D(j)    for j = ILO,...,IHI
*                   = P(j)    for j = IHI+1,...,N.
*          The order in which the interchanges are made is N to IHI+1,
*          then 1 to ILO-1.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit.
*          < 0:  if INFO = -i, the i-th argument had an illegal value.
*
*  Further Details
*  ===============
*
*  The permutations consist of row and column interchanges which put
*  the matrix in the form
*
*             ( T1   X   Y  )
*     P A P = (  0   B   Z  )
*             (  0   0   T2 )
*
*  where T1 and T2 are upper triangular matrices whose eigenvalues lie
*  along the diagonal.  The column indices ILO and IHI mark the starting
*  and ending columns of the submatrix B. Balancing consists of applying
*  a diagonal similarity transformation inv(D) * B * D to make the
*  1-norms of each row of B and its corresponding column nearly equal.
*  The output matrix is
*
*     ( T1     X*D          Y    )
*     (  0  inv(D)*B*D  inv(D)*Z ).
*     (  0      0           T2   )
*
*  Information about the permutations P and the diagonal matrix D is
*  returned in the vector SCALE.
*
*  This subroutine is based on the EISPACK routine BALANC.
*
*  Modified by Tzu-Yi Chen, Computer Science Division, University of
*    California at Berkeley, USA
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO, ONE
      PARAMETER          ( ZERO = 0.0D+0, ONE = 1.0D+0 )
      DOUBLE PRECISION   SCLFAC
      PARAMETER          ( SCLFAC = 0.8D+1 )
      DOUBLE PRECISION   FACTOR
      PARAMETER          ( FACTOR = 0.95D+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            NOCONV
      INTEGER            I, ICA, IEXC, IRA, J, K, L, M
      DOUBLE PRECISION   C, CA, F, G, R, RA, S, SFMAX1, SFMAX2, SFMIN1,
     $                   SFMIN2
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            IDAMAX
      DOUBLE PRECISION   DLAMCH
      EXTERNAL           LSAME, IDAMAX, DLAMCH
*     ..
*     .. External Subroutines ..
      EXTERNAL           DSCAL, DSWAP, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, MAX, MIN
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters
*
      INFO = 0
      IF( .NOT.LSAME( JOB, 'N' ) .AND. .NOT.LSAME( JOB, 'P' ) .AND.
     $    .NOT.LSAME( JOB, 'S' ) .AND. .NOT.LSAME( JOB, 'B' ) ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -4
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DGEBAL', -INFO )
         RETURN
      END IF
*
      K = 1
      L = N
*
      IF( N.EQ.0 )
     $   GO TO 210
*
      IF( LSAME( JOB, 'N' ) ) THEN
         DO 10 I = 1, N
            SCALE( I ) = ONE
   10    CONTINUE
         GO TO 210
      END IF
*
      IF( LSAME( JOB, 'S' ) )
     $   GO TO 120
*
*     Permutation to isolate eigenvalues if possible
*
      GO TO 50
*
*     Row and column exchange.
*
   20 CONTINUE
      SCALE( M ) = J
      IF( J.EQ.M )
     $   GO TO 30
*
      CALL DSWAP( L, A( 1, J ), 1, A( 1, M ), 1 )
      CALL DSWAP( N-K+1, A( J, K ), LDA, A( M, K ), LDA )
*
   30 CONTINUE
      GO TO ( 40, 80 )IEXC
*
*     Search for rows isolating an eigenvalue and push them down.
*
   40 CONTINUE
      IF( L.EQ.1 )
     $   GO TO 210
      L = L - 1
*
   50 CONTINUE
      DO 70 J = L, 1, -1
*
         DO 60 I = 1, L
            IF( I.EQ.J )
     $         GO TO 60
            IF( A( J, I ).NE.ZERO )
     $         GO TO 70
   60    CONTINUE
*
         M = L
         IEXC = 1
         GO TO 20
   70 CONTINUE
*
      GO TO 90
*
*     Search for columns isolating an eigenvalue and push them left.
*
   80 CONTINUE
      K = K + 1
*
   90 CONTINUE
      DO 110 J = K, L
*
         DO 100 I = K, L
            IF( I.EQ.J )
     $         GO TO 100
            IF( A( I, J ).NE.ZERO )
     $         GO TO 110
  100    CONTINUE
*
         M = K
         IEXC = 2
         GO TO 20
  110 CONTINUE
*
  120 CONTINUE
      DO 130 I = K, L
         SCALE( I ) = ONE
  130 CONTINUE
*
      IF( LSAME( JOB, 'P' ) )
     $   GO TO 210
*
*     Balance the submatrix in rows K to L.
*
*     Iterative loop for norm reduction
*
      SFMIN1 = DLAMCH( 'S' ) / DLAMCH( 'P' )
      SFMAX1 = ONE / SFMIN1
      SFMIN2 = SFMIN1*SCLFAC
      SFMAX2 = ONE / SFMIN2
  140 CONTINUE
      NOCONV = .FALSE.
*
      DO 200 I = K, L
         C = ZERO
         R = ZERO
*
         DO 150 J = K, L
            IF( J.EQ.I )
     $         GO TO 150
            C = C + ABS( A( J, I ) )
            R = R + ABS( A( I, J ) )
  150    CONTINUE
         ICA = IDAMAX( L, A( 1, I ), 1 )
         CA = ABS( A( ICA, I ) )
         IRA = IDAMAX( N-K+1, A( I, K ), LDA )
         RA = ABS( A( I, IRA+K-1 ) )
*
*        Guard against zero C or R due to underflow.
*
         IF( C.EQ.ZERO .OR. R.EQ.ZERO )
     $      GO TO 200
         G = R / SCLFAC
         F = ONE
         S = C + R
  160    CONTINUE
         IF( C.GE.G .OR. MAX( F, C, CA ).GE.SFMAX2 .OR.
     $       MIN( R, G, RA ).LE.SFMIN2 )GO TO 170
         F = F*SCLFAC
         C = C*SCLFAC
         CA = CA*SCLFAC
         R = R / SCLFAC
         G = G / SCLFAC
         RA = RA / SCLFAC
         GO TO 160
*
  170    CONTINUE
         G = C / SCLFAC
  180    CONTINUE
         IF( G.LT.R .OR. MAX( R, RA ).GE.SFMAX2 .OR.
     $       MIN( F, C, G, CA ).LE.SFMIN2 )GO TO 190
         F = F / SCLFAC
         C = C / SCLFAC
         G = G / SCLFAC
         CA = CA / SCLFAC
         R = R*SCLFAC
         RA = RA*SCLFAC
         GO TO 180
*
*        Now balance.
*
  190    CONTINUE
         IF( ( C+R ).GE.FACTOR*S )
     $      GO TO 200
         IF( F.LT.ONE .AND. SCALE( I ).LT.ONE ) THEN
            IF( F*SCALE( I ).LE.SFMIN1 )
     $         GO TO 200
         END IF
         IF( F.GT.ONE .AND. SCALE( I ).GT.ONE ) THEN
            IF( SCALE( I ).GE.SFMAX1 / F )
     $         GO TO 200
         END IF
         G = ONE / F
         SCALE( I ) = SCALE( I )*F
         NOCONV = .TRUE.
*
         CALL DSCAL( N-K+1, G, A( I, K ), LDA )
         CALL DSCAL( L, F, A( 1, I ), 1 )
*
  200 CONTINUE
*
      IF( NOCONV )
     $   GO TO 140
*
  210 CONTINUE
      ILO = K
      IHI = L
*
      RETURN
*
*     End of DGEBAL
*
      END

C
C $Id: e0fnsp.f,v 1.5 2008-07-27 00:17:08 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      REAL FUNCTION E0FNSP (ECCNTS)
C
C This function computes the constant E0.
C
      IMPLICIT REAL (A-Z)
      DATA QUART,ONE,ONEQ,THREE,SIXT /0.25E0,1.0E0,1.25E0,3.0E0,16.0E0/
C
      E0FNSP = ONE - QUART * ECCNTS * (ONE + ECCNTS / SIXT *
     .         (THREE + ONEQ * ECCNTS))
C
      RETURN
      END

C
C	$Id: iargct.f,v 1.4 2008-07-27 12:23:45 haley Exp $
C                                                                      
C			     Copyright (C)  2000
C	     University Corporation for Atmospheric Research
C			     All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C

      INTEGER FUNCTION IARGCT(DUMMY)
C***********************************************************************
C	
C	Function: IARGCT()
C
C	Purpose: To determine the number of arguments passed on
C		the command line.
C
C	Input Variables:
C		DUMMY:	Not actually used.
C
C	Function Return:
C		The number of arguments.
C
C
C***********************************************************************
      INTEGER DUMMY, IARGC
C
      IARGCT = IARGC()
C
      RETURN
      END

        PROGRAM TDSHPK
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
        PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Open GKS, open workstation of type 1, activate workstation.
C
        CALL GOPKS (IERRF, ISZDM)
        CALL GOPWK (IWKID, LUNIT, IWTYPE)
        CALL GACWK (IWKID)
C
C Invoke demo driver.
C
        CALL DSHPK (IERR,IWKID)
C
C Deactivate and close workstation, close GKS.
C
        CALL GDAWK (IWKID)
        CALL GCLWK (IWKID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END

      SUBROUTINE DSHPK (IERR,IWID)
C
C Declare arrays in which to put coordinates for calls to DPCURV.
C
        DIMENSION XCRA(1001),YCRA(1001)
C
C Declare an array in which to define the bits of an integer dash
C pattern (which saves one from having to do the binary to decimal
C conversion).
C
        DIMENSION IBTS(14)
C
C Define the fourteen bits of an integer dash pattern to be used.
C
        DATA IBTS / 1,0,1,1,0,1,1,1,0,1,1,1,1,0 /
C
C Define multiplicative constants to get from degrees to radians and
C vice-versa.
C
        DATA DTOR / .017453292519943 /
        DATA RTOD / 57.2957795130823 /
C
C Turn off clipping by GKS.
C
        CALL GSCLIP (0)
C
C Define some colors to use.
C
        CALL GSCR   (IWID,0,0.,0.,0.)
        CALL GSCR   (IWID,1,1.,1.,1.)
        CALL GSCR   (IWID,2,1.,0.,1.)
        CALL GSCR   (IWID,3,1.,1.,0.)
C
C Define the mapping from the user system to the fractional system for
C the first frame.
C
        CALL SET (.03,.97,.01,.95,-10.,10.,-10.,10.,1)
C
C Put a label at the top of the first frame.
C
        CALL PLCHHQ (CFUX(.5),CFUY(.975),
     +               'DEMONSTRATING THE USE OF DASHPACK - FRAME 1',
     +                                                  .015,0.,0.)
C
C Use the default character dash pattern to draw a box whose edges
C are straight lines and put a label in the middle of the box.
C
C Note: At this point, 'DPS' = 0, 'DPT' = 1111111111111111 (binary)
C or '$$$$$$$$$$$$$$$$' (character), 'LTL' = 0, 'MFS' = 1, 'PCF' = 0,
C 'SAF' = 360, 'SCF' = 0, 'SSL' = .01, 'TCS' = -1., 'WOC' = .01,
C 'WOG' = .005, and 'WOS' = .005.
C
        YCEN=8.5
C
        CALL DPLINE (-9.,YCEN+.75, 9.,YCEN+.75)
        CALL DPLINE ( 9.,YCEN+.75, 9.,YCEN-.75)
        CALL DPLINE ( 9.,YCEN-.75,-9.,YCEN-.75)
        CALL DPLINE (-9.,YCEN-.75,-9.,YCEN+.75)
C
        CALL PLCHHQ (0.,YCEN,'A box drawn using DPLINE and the default c
     +haracter dash pattern.',
     +                                                        .01,0.,0.)
C
C Redefine the character dash pattern, draw a second box whose edges
C are straight lines, and put a label in the middle of the box.
C
C Note: At this point, 'DPS' = 0, 'DPT' = 1111111111111111 (binary)
C or '$$$$$$$$$$$$$$$$' (character), 'LTL' = 0, 'MFS' = 1, 'PCF' = 0,
C 'SAF' = 360, 'SCF' = 0, 'SSL' = .01, 'TCS' = -1., 'WOC' = .01,
C 'WOG' = .005, and 'WOS' = .005.
C
        CALL DPSETC ('DPT - DASH PATTERN (CHARACTER)','$$$_$$$A')
C
C Note: At this point, 'DPS' = 0, 'DPT' = 1111111111111111 (binary)
C or '$$$_$$$A' (character), 'LTL' = 0, 'MFS' = 1, 'PCF' = 0,
C 'SAF' = 360, 'SCF' = 0, 'SSL' = .01, 'TCS' = -1., 'WOC' = .01,
C 'WOG' = .005, and 'WOS' = .005.
C
        YCEN=6.0
C
        CALL DPLINE (-9.,YCEN+.75, 9.,YCEN+.75)
        CALL DPLINE ( 9.,YCEN+.75, 9.,YCEN-.75)
        CALL DPLINE ( 9.,YCEN-.75,-9.,YCEN-.75)
        CALL DPLINE (-9.,YCEN-.75,-9.,YCEN+.75)
C
        CALL PLCHHQ (0.,YCEN,'A box drawn using DPLINE and a simple char
     +acter dash pattern.',
     +                                                        .01,0.,0.)
C
C Use a 14-bit binary dash pattern to draw a third box whose edges are
C straight lines and put a label in the middle of the box.  Note that
C the routine IPKBTS, which packs the bits of the integer dash pattern
C into an integer variable, is not a part of DASHPACK, but of this
C example.
C
C Note: At this point, 'DPS' = 0, 'DPT' = 1111111111111111 (binary)
C or '$$$_$$$A' (character), 'LTL' = 0, 'MFS' = 1, 'PCF' = 0,
C 'SAF' = 360, 'SCF' = 0, 'SSL' = .01, 'TCS' = -1., 'WOC' = .01,
C 'WOG' = .005, and 'WOS' = .005.
C
        CALL DPSETI ('DPS - DASH PATTERN SELECTOR',-14)
C
        CALL DPSETI ('DPT - DASH PATTERN (BINARY)',IPKBTS(IBTS,14))
C
C Note: At this point, 'DPS' = -14, 'DPT' = 01011011101111 (binary)
C or '$$$_$$$A' (character), 'LTL' = 0, 'MFS' = 1, 'PCF' = 0,
C 'SAF' = 360, 'SCF' = 0, 'SSL' = .01, 'TCS' = -1., 'WOC' = .01,
C 'WOG' = .005, and 'WOS' = .005.
C
        YCEN=3.5
C
        CALL DPLINE (-9.,YCEN+.75, 9.,YCEN+.75)
        CALL DPLINE ( 9.,YCEN+.75, 9.,YCEN-.75)
        CALL DPLINE ( 9.,YCEN-.75,-9.,YCEN-.75)
        CALL DPLINE (-9.,YCEN-.75,-9.,YCEN+.75)
C
        CALL PLCHHQ (0.,YCEN,'A box drawn using DPLINE and a 14-bit bina
     +ry dash pattern.',
     +                                                        .01,0.,0.)
C
C Draw an oval using DPCURV and a character dash pattern in which there
C are no breakpoints.  Smoothing is off by default.
C
C Note: At this point, 'DPS' = -14, 'DPT' = 01011011101111 (binary)
C or '$$$_$$$A' (character), 'LTL' = 0, 'MFS' = 1, 'PCF' = 0,
C 'SAF' = 360, 'SCF' = 0, 'SSL' = .01, 'TCS' = -1., 'WOC' = .01,
C 'WOG' = .005, and 'WOS' = .005.
C
        CALL DPSETI ('DPS - DASH PATTERN SELECTOR',0)
C
        CALL DPSETC ('DPT - DASH PATTERN (CHARACTER)',
     +                                    '$$$$$$$$$$$$W/O BREAKPOINTS')
C
C Note: At this point, 'DPS' = 0, 'DPT' = 01011011101111 (binary)
C or '$$$$$$$$$$$$W/O BREAKPOINTS' (character), 'LTL' = 0, 'MFS' = 1,
C 'PCF' = 0, 'SAF' = 360, 'SCF' = 0, 'SSL' = .01, 'TCS' = -1.,
C 'WOC' = .01, 'WOG' = .005, and 'WOS' = .005.
C
        YCEN=0.5
C
        DO 101 I=1,19
          ANGD=20.*REAL(I-1)
          XCRA(I)=9.*COS(DTOR*ANGD)
          YCRA(I)=.11*(9.**6-XCRA(I)**6)**(1/6.)
          IF (ANGD.GT.180.) YCRA(I)=-YCRA(I)
          YCRA(I)=YCEN+YCRA(I)
  101   CONTINUE
C
        CALL DPCURV (XCRA,YCRA,19)
C
        CALL PLCHHQ (0.,YCEN,'An oval drawn using DPCURV, with smoothing
     + off and a:C:dash pattern in which the labels have no breakpoints.
     +',
     +                                                        .01,0.,0.)
C
C Draw a second oval using DPCURV and a character dash pattern in which
C there are breakpoints.  Reduce the added space to be left in each
C label gap.  Smoothing is still off.
C
C Note: At this point, 'DPS' = 0, 'DPT' = 01011011101111 (binary)
C or '$$$$$$$$$$$$W/O BREAKPOINTS' (character), 'LTL' = 0, 'MFS' = 1,
C 'PCF' = 0, 'SAF' = 360, 'SCF' = 0, 'SSL' = .01, 'TCS' = -1.,
C 'WOC' = .01, 'WOG' = .005, and 'WOS' = .005.
C
        CALL DPSETC ('DPT - DASH PATTERN (CHARACTER)',
     +                       '$$$$$$$$$W|I|T|H| |B|R|E|A|K|P|O|I|N|T|S')
C
C Note: At this point, 'DPS' = 0, 'DPT' = 01011011101111 (binary)
C or '$$$$$$$$$W|I|T|H| |B|R|E|A|K|P|O|I|N|T|S' (character),
C 'LTL' = 0, 'MFS' = 1, 'PCF' = 0, 'SAF' = 360, 'SCF' = 0, 'SSL' = .01,
C 'TCS' = -1., 'WOC' = .01, 'WOG' = .005, and 'WOS' = .005.
C
        YCEN=-3.5
C
        DO 102 I=1,19
          ANGD=20.*REAL(I-1)
          XCRA(I)=9.*COS(DTOR*ANGD)
          YCRA(I)=.11*(9.**6-XCRA(I)**6)**(1/6.)
          IF (ANGD.GT.180.) YCRA(I)=-YCRA(I)
          YCRA(I)=YCEN+YCRA(I)
  102   CONTINUE
C
        CALL DPCURV (XCRA,YCRA,19)
C
        CALL PLCHHQ (0.,YCEN,'An oval drawn using DPCURV, with smoothing
     + off and:C:a dash pattern in which the labels have breakpoints.',
     +                                                        .01,0.,0.)
C
C Draw a third oval in the same way as the second one, but instead of
C embedding break characters in the label, turn on the single-character
C flag.  Turn on the smoother and use even less added space around each
C piece of the broken label.
C
C Note: At this point, 'DPS' = 0, 'DPT' = 01011011101111 (binary)
C or '$$$$$$$$$W|I|T|H| |B|R|E|A|K|P|O|I|N|T|S' (character),
C 'LTL' = 0, 'MFS' = 1, 'PCF' = 0, 'SAF' = 360, 'SCF' = 0, 'SSL' = .01,
C 'TCS' = -1., 'WOC' = .01, 'WOG' = .005, and 'WOS' = .005.
C
        CALL DPSETC ('DPT - DASH PATTERN (CHARACTER)',
     +                       '$$$$$$$$$$WITH SINGLE-CHARACTER FLAG SET')
C
        CALL DPSETI ('SCF - SINGLE-CHARACTER FLAG',1)
C
        CALL DPSETR ('TCS - TENSION ON CUBIC SPLINES',2.5)
C
C Note: At this point, 'DPS' = 0, 'DPT' = 01011011101111 (binary)
C or '$$$$$$$$$$WITH SINGLE-CHARACTER FLAG SET' (character),
C 'LTL' = 0, 'MFS' = 1, 'PCF' = 0, 'SAF' = 360, 'SCF' = 1, 'SSL' = .01,
C 'TCS' = 2.5, 'WOC' = .01, 'WOG' = .005, and 'WOS' = .005.
C
        YCEN=-7.5
C
        DO 103 I=1,19
          ANGD=20.*REAL(I-1)
          XCRA(I)=9.*COS(DTOR*ANGD)
          YCRA(I)=.11*(9.**6-XCRA(I)**6)**(1/6.)
          IF (ANGD.GT.180.) YCRA(I)=-YCRA(I)
          YCRA(I)=YCEN+YCRA(I)
  103   CONTINUE
C
        CALL DPCURV (XCRA,YCRA,19)
C
        CALL PLCHHQ (0.,YCEN,'An oval drawn using DPCURV, with smoothing
     + on and the:C:single-character flag set to create many breakpoints
     +.',
     +                                                        .01,0.,0.)
C
C Advance the frame.
C
        CALL FRAME
C
C Put a label at the top of the second frame.
C
        CALL PLCHHQ (CFUX(.5),CFUY(.975),
     +               'DEMONSTRATING THE USE OF DASHPACK - FRAME 2',
     +                                                  .015,0.,0.)
C
C Define the mapping from the user system to the fractional system in
C such a way as to use only the upper left quadrant of the frame.
C
        CALL SET (.030,.485,.495,.950,-10.,10.,-10.,10.,1)
C
C Use DPFRST, DPVECT, and DPCURV to draw a spiral.  The label will
C follow the curve, because the single-character flag is still on, and
C the curve will be smoothed, because the smoother is still turned on.
C The additional space around the label pieces is reduced even more.
C
C Note: At this point, 'DPS' = 0, 'DPT' = 01011011101111 (binary)
C or '$$$$$$$$$$WITH SINGLE-CHARACTER FLAG SET' (character),
C 'LTL' = 0, 'MFS' = 1, 'PCF' = 0, 'SAF' = 360, 'SCF' = 1, 'SSL' = .01,
C 'TCS' = 2.5, 'WOC' = .01, 'WOG' = .005, and 'WOS' = .005.
C
        CALL DPSETC ('DPT - DASH PATTERN (CHARACTER)',
     +                   '$$$$$$$A SPIRAL DRAWN USING DPFRST/VECT/LAST')
C
C Note: At this point, 'DPS' = 0, 'DPT' = 01011011101111 (binary)
C or '$$$$$$$A SPIRAL DRAWN USING DPFRST/VECT/LAST' (character),
C 'LTL' = 0, 'MFS' = 1, 'PCF' = 0, 'SAF' = 360, 'SCF' = 1, 'SSL' = .01,
C 'TCS' = 2.5, 'WOC' = .01, 'WOG' = .005, and 'WOS' = .005.
C
        CALL DPFRST (0.,0.)
C
        DO 104 I=2,101
          RRHO=8.*REAL(I-1)/100.
          THTA=8.*REAL(I-1)/50.
          CALL DPVECT(RRHO*COS(THTA),RRHO*SIN(THTA))
  104   CONTINUE
C
        CALL DPLAST
C
C Put a small label below the spiral.
C
        CALL PLCHHQ (0.,-9.,'Using DPFRST, DPVECT, and DPLAST.',
     +                                                .01,0.,0.)
C
C Define the mapping from the user system to the fractional system in
C such a way as to use only the upper right quadrant of the frame.
C
        CALL SET (.515,.970,.495,.950,-10.,10.,-10.,10.,1)
C
C Use DPDRAW to draw another spiral.  Note that the single-character
C flag is still on, so the label follows the curve.  Note also that,
C even though the smoother is still on, it has no effect on DPDRAW.
C
C Note: At this point, 'DPS' = 0, 'DPT' = 01011011101111 (binary)
C or '$$$$$$$A SPIRAL DRAWN USING DPFRST/VECT/LAST' (character),
C 'LTL' = 0, 'MFS' = 1, 'PCF' = 0, 'SAF' = 360, 'SCF' = 1, 'SSL' = .01,
C 'TCS' = 2.5, 'WOC' = .01, 'WOG' = .005, and 'WOS' = .005.
C
        CALL DPSETC ('DPT - DASH PATTERN (CHARACTER)',
     +             '$_$_$_$_$_$_$_$_$_$_$A SPIRAL DRAWN USING DPDRAW')
C
C Note: At this point, 'DPS' = 0, 'DPT' = 01011011101111 (binary)
C or '$_$_$_$_$_$_$_$_$_$_$A SPIRAL DRAWN USING DPDRAW' (character),
C 'LTL' = 0, 'MFS' = 1, 'PCF' = 0, 'SAF' = 360, 'SCF' = 1, 'SSL' = .01,
C 'TCS' = 2.5, 'WOC' = .01, 'WOG' = .005, and 'WOS' = .005.
C
        CALL DPDRAW (CUFX(0.),CUFY(0.),0)
C
        DO 105 I=2,101
          RRHO=8.*REAL(I-1)/100.
          THTA=6.28318530717958*REAL(I-1)/20.
          CALL DPDRAW (CUFX(RRHO*COS(THTA)),CUFY(RRHO*SIN(THTA)),1)
  105   CONTINUE
C
        CALL DPDRAW (0.,0.,2)
C
C Put a small label below the spiral.
C
        CALL PLCHHQ (0.,-9.,'Using DPDRAW.',.01,0.,0.)
C
C Define the mapping from the user system to the fractional system in
C such a way as to use only the lower left quadrant of the frame.
C
        CALL SET (.030,.485,.010,.455,-10.,10.,-10.,10.,1)
C
C Use DPSMTH to draw the same spiral.  The single-character flag is
C still on and smoothing is still on.
C
C Note: At this point, 'DPS' = 0, 'DPT' = 01011011101111 (binary)
C or '$_$_$_$_$_$_$_$_$_$_$A SPIRAL DRAWN USING DPDRAW' (character),
C 'LTL' = 0, 'MFS' = 1, 'PCF' = 0, 'SAF' = 360, 'SCF' = 1, 'SSL' = .01,
C 'TCS' = 2.5, 'WOC' = .01, 'WOG' = .005, and 'WOS' = .005.
C
        CALL DPSETC ('DPT - DASH PATTERN (CHARACTER)',
     +               '$_$_$_$_$_$_$_$_$_$_$A SPIRAL DRAWN USING DPSMTH')
C
C Note: At this point, 'DPS' = 0, 'DPT' = 01011011101111 (binary)
C or '$_$_$_$_$_$_$_$_$_$_$A SPIRAL DRAWN USING DPSMTH' (character),
C 'LTL' = 0, 'MFS' = 1, 'PCF' = 0, 'SAF' = 360, 'SCF' = 1, 'SSL' = .01,
C 'TCS' = 2.5, 'WOC' = .01, 'WOG' = .005, and 'WOS' = .005.
C
        CALL DPSMTH (CUFX(0.),CUFY(0.),0)
C
        DO 106 I=2,101
          RRHO=8.*REAL(I-1)/100.
          THTA=6.28318530717958*REAL(I-1)/20.
          CALL DPSMTH (CUFX(RRHO*COS(THTA)),CUFY(RRHO*SIN(THTA)),1)
  106   CONTINUE
C
        CALL DPSMTH (0.,0.,2)
C
C Put a small label below the spiral.
C
        CALL PLCHHQ (0.,-9.,'Using DPSMTH.',.01,0.,0.)
C
C Define the mapping from the user system to the fractional system in
C such a way as to use only the lower right quadrant of the frame.
C
        CALL SET (.515,.970,.010,.455,-10.,10.,-10.,10.,1)
C
C Use DPSMTH to draw another spiral.  This time, use PLCHHQ function
C codes in the label string and use color to distinguish the label
C from the line.
C
C Note: At this point, 'DPS' = 0, 'DPT' = 01011011101111 (binary)
C or '$_$_$_$_$_$_$_$_$_$_$A SPIRAL DRAWN USING DPSMTH' (character),
C 'LTL' = 0, 'MFS' = 1, 'PCF' = 0, 'SAF' = 360, 'SCF' = 1, 'SSL' = .01,
C 'TCS' = 2.5, 'WOC' = .01, 'WOG' = .005, and 'WOS' = .005.
C
        CALL DPSETC ('DPT - DASH PATTERN (CHARACTER)','$$$$$$$$$$$$$$$$$
     +$$$$$C|o|n|t|o|u|r| |l|e|v|e|l| |=| |1|3|.|6|2|:L1:4|1|0:S:14:N:')
C
        CALL DPSETI ('LTL - LINE-THROUGH-LABEL FLAG',1)
C
        CALL DPSETI ('SCF - SINGLE-CHARACTER FLAG',0)
C
        CALL DPSETR ('SSL - SMOOTHED SEGMENT LENGTH',.001)
C
C Note: At this point, 'DPS' = 0, 'DPT' = 01011011101111 (binary)
C or '$$$$$$$$$$$$$$$$$$$$$$C|o|n|t|o|u|r| |l|e|v|e|l| |=| |1|3|.|6|2|:L
C 1:4|1|0:S:14:N:' (character), 'LTL' = 1, 'MFS' = 1, 'PCF' = 0,
C 'SAF' = 360, 'SCF' = 0, 'SSL' = .001, 'TCS' = 2.5, 'WOC' = .01,
C 'WOG' = .005, and 'WOS' = .005.
C
        CALL GSPLCI (2)
        CALL PCSETI ('CC - CHARACTER COLOR',3)
C
        CALL DPSMTH (CUFX(0.),CUFY(0.),0)
C
        DO 107 I=2,101
          RRHO=8.*REAL(I-1)/100.
          THTA=6.28318530717958*REAL(I-1)/15.
          CALL DPSMTH (CUFX(RRHO*COS(THTA)),CUFY(RRHO*SIN(THTA)),1)
  107   CONTINUE
C
        CALL DPSMTH (0.,0.,2)
C
C Put a small label below the spiral.
C
        CALL GSPLCI (1)
        CALL PCSETI ('CC - CHARACTER COLOR',1)
C
        CALL PLCHHQ (0.,-9.,'Using PLCHHQ function codes and colors.',
     +                                                      .01,0.,0.)
C
C Advance the frame.
C
        CALL FRAME
C
C Put a label at the top of the third frame.
C
        CALL PLCHHQ (CFUX(.5),CFUY(.975),
     +               'DEMONSTRATING THE USE OF DASHPACK - FRAME 3',
     +                                                  .015,0.,0.)
C
C Define the mapping from the user system to the fractional system in
C such a way as to use only the upper left quadrant of the frame.
C
        CALL SET (.030,.485,.495,.950,-10.,10.,-10.,10.,1)
C
C Use DPSMTH to draw a spiral.  Use color to distinguish the labels
C from the line, and orient all the labels horizontally.
C
C Note: At this point, 'DPS' = 0, 'DPT' = 01011011101111 (binary)
C or '$$$$$$$$$$$$$$$$$$$$$$C|o|n|t|o|u|r| |l|e|v|e|l| |=| |1|3|.|6|2|:L
C 1:4|1|0:S:14:N:' (character), 'LTL' = 1, 'MFS' = 1, 'PCF' = 0,
C 'SAF' = 360, 'SCF' = 0, 'SSL' = .001, 'TCS' = 2.5, 'WOC' = .01,
C 'WOG' = .005, and 'WOS' = .005.
C
        CALL DPSETC ('DPT - DASH PATTERN (CHARACTER)','$$$$$$$$SPIRAL')
C
        CALL DPSETI ('SAF - STRING-ANGLE FLAG',-360)
C
C Note: At this point, 'DPS' = 0, 'DPT' = 01011011101111 (binary)
C or '$$$$$$$$SPIRAL' (character), 'LTL' = 1, 'MFS' = 1, 'PCF' = 0,
C 'SAF' = -360, 'SCF' = 0, 'SSL' = .001, 'TCS' = 2.5, 'WOC' = .01,
C 'WOG' = .005, and 'WOS' = .005.
C
        CALL GSPLCI (2)
        CALL PCSETI ('CC - CHARACTER COLOR',3)
C
        CALL DPSMTH (CUFX(0.),CUFY(0.),0)
C
        DO 108 I=2,101
          RRHO=8.*REAL(I-1)/100.
          THTA=8.*REAL(I-1)/50.
          CALL DPSMTH (CUFX(RRHO*COS(THTA)),CUFY(RRHO*SIN(THTA)),1)
  108   CONTINUE
C
        CALL DPSMTH (0.,0.,2)
C
C Put a small label below the spiral.
C
        CALL GSPLCI (1)
        CALL PCSETI ('CC - CHARACTER COLOR',1)
C
        CALL PLCHHQ (0.,-9.,'Using horizontal labels.',.01,0.,0.)
C
C Define the mapping from the user system to the fractional system in
C such a way as to use only the upper right quadrant of the frame.
C
        CALL SET (.515,.970,.495,.950,-10.,10.,-10.,10.,1)
C
C Use DPDRAW to draw a spiral.
C
C Note: At this point, 'DPS' = 0, 'DPT' = 01011011101111 (binary)
C or '$$$$$$$$SPIRAL' (character), 'LTL' = 1, 'MFS' = 1, 'PCF' = 0,
C 'SAF' = -360, 'SCF' = 0, 'SSL' = .001, 'TCS' = 2.5, 'WOC' = .01,
C 'WOG' = .005, and 'WOS' = .005.
C
        CALL DPSETC ('DPT - DASH PATTERN (CHARACTER)','$$$$$$$SPIRAL')
C
        CALL DPSETI ('LTL - LINE-THROUGH-LABEL FLAG',0)
C
        CALL DPSETI ('PCF - PLOTCHAR FLAG',1)
C
        CALL DPSETI ('SAF - STRING-ANGLE FLAG',360)
C
        CALL DPSETI ('SCF - SINGLE-CHARACTER FLAG',1)
C
C Note: At this point, 'DPS' = 0, 'DPT' = 01011011101111 (binary)
C or '$$$$$$$SPIRAL' (character), 'LTL' = 0, 'MFS' = 1, 'PCF' = 1,
C 'SAF' = 360, 'SCF' = 1, 'SSL' = .001, 'TCS' = 2.5, 'WOC' = .01,
C 'WOG' = .005, and 'WOS' = .005.
C
        CALL DPDRAW (CUFX(0.),CUFY(0.),0)
C
        DO 109 I=2,101
          RRHO=8.*REAL(I-1)/100.
          THTA=8.*REAL(I-1)/50.
          CALL DPDRAW (CUFX(RRHO*COS(THTA)),CUFY(RRHO*SIN(THTA)),1)
  109   CONTINUE
C
        CALL DPDRAW (0.,0.,2)
C
C Put a small label below the spiral.
C
        CALL PLCHHQ (0.,-9.,'Using PLCHMQ instead of PLCHHQ.',.01,0.,0.)
C
C Define the mapping from the user system to the fractional system in
C such a way as to use only the lower left quadrant of the frame.
C
        CALL SET (.030,.485,.010,.455,-10.,10.,-10.,10.,1)
C
C Use DPDRAW to draw a spiral.
C
C Note: At this point, 'DPS' = 0, 'DPT' = 01011011101111 (binary)
C or '$$$$$$$SPIRAL' (character), 'LTL' = 0, 'MFS' = 1, 'PCF' = 1,
C 'SAF' = 360, 'SCF' = 1, 'SSL' = .001, 'TCS' = 2.5, 'WOC' = .01,
C 'WOG' = .005, and 'WOS' = .005.
C
        CALL DPSETC ('DPT - DASH PATTERN (CHARACTER)','$_$_$_$SPIRAL')
C
        CALL DPSETI ('PCF - PLOTCHAR FLAG',0)
C
        CALL DPSETR ('WOC - WIDTH OF CHARACTERS',.02)
C
        CALL DPSETR ('WOG - WIDTH OF GAP',.01)
C
        CALL DPSETR ('WOS - WIDTH OF SOLID',.01)
C
C Note: At this point, 'DPS' = 0, 'DPT' = 01011011101111 (binary)
C or '$_$_$_$SPIRAL' (character), 'LTL' = 0, 'MFS' = 1, 'PCF' = 0,
C 'SAF' = 360, 'SCF' = 1, 'SSL' = .001, 'TCS' = 2.5, 'WOC' = .02,
C 'WOG' = .01, and 'WOS' = .01.
C
        CALL DPDRAW (CUFX(0.),CUFY(0.),0)
C
        DO 110 I=2,101
          RRHO=8.*REAL(I-1)/100.
          THTA=8.*REAL(I-1)/50.
          CALL DPDRAW (CUFX(RRHO*COS(THTA)),CUFY(RRHO*SIN(THTA)),1)
  110   CONTINUE
C
        CALL DPDRAW (0.,0.,2)
C
C Put a small label below the spiral.
C
        CALL PLCHHQ (0.,-9.,'Changing character and solid/gap sizes.',
     +                                                      .01,0.,0.)
C
C Define the mapping from the user system to the fractional system in
C such a way as to use only the lower right quadrant of the frame.
C
        CALL SET (.515,.970,.010,.455,-10.,10.,-10.,10.,1)
C
C Use DPDRAW to draw two spirals and then use 'MFS' to offset one.
C
C Note: At this point, 'DPS' = 0, 'DPT' = 01011011101111 (binary)
C or '$_$_$_$SPIRAL' (character), 'LTL' = 0, 'MFS' = 1, 'PCF' = 0,
C 'SAF' = 360, 'SCF' = 1, 'SSL' = .001, 'TCS' = 2.5, 'WOC' = .02,
C 'WOG' = .01, and 'WOS' = .01.
C
        CALL DPSETR ('WOC - WIDTH OF CHARACTERS',.008)
C
        CALL DPSETR ('WOG - WIDTH OF GAP',.008)
C
        CALL DPSETR ('WOS - WIDTH OF SOLID',.008)
C
C Note: At this point, 'DPS' = 0, 'DPT' = 01011011101111 (binary)
C or '$_$_$_$SPIRAL' (character), 'LTL' = 0, 'MFS' = 1, 'PCF' = 0,
C 'SAF' = 360, 'SCF' = 1, 'SSL' = .001, 'TCS' = 2.5, 'WOC' = .008,
C 'WOG' = .008, and 'WOS' = .008.
C
C Draw the first spiral.
C
        CALL DPSETC ('DPT - DASH PATTERN (CHARACTER)','$$$$$SPIRAL 1')
C
        CALL DPSETR ('MFS - MULTIPLIER FOR FIRST SOLID',1.5)
C
C Note: At this point, 'DPS' = 0, 'DPT' = 01011011101111 (binary)
C or '$$$$$SPIRAL 1' (character), 'LTL' = 0, 'MFS' = 1.5, 'PCF' = 0,
C 'SAF' = 360, 'SCF' = 1, 'SSL' = .001, 'TCS' = 2.5, 'WOC' = .008,
C 'WOG' = .008, and 'WOS' = .008.
C
        CALL DPDRAW (CUFX(0.),CUFY(0.),0)
C
        DO 111 I=2,101
          RRHO=6.*REAL(I-1)/100.
          THTA=8.*REAL(I-1)/50.
          CALL DPDRAW (CUFX(RRHO*COS(THTA)),CUFY(RRHO*SIN(THTA)),1)
  111   CONTINUE
C
        CALL DPDRAW (0.,0.,2)
C
C Draw the second spiral.
C
        CALL DPSETC ('DPT - DASH PATTERN (CHARACTER)','$$$$$SPIRAL 2')
C
        CALL DPSETR ('MFS - MULTIPLIER FOR FIRST SOLID',3.)
C
C Note: At this point, 'DPS' = 0, 'DPT' = 01011011101111 (binary)
C or '$$$$$SPIRAL 2' (character), 'LTL' = 0, 'MFS' = 3., 'PCF' = 0,
C 'SAF' = 360, 'SCF' = 1, 'SSL' = .001, 'TCS' = 2.5, 'WOC' = .008,
C 'WOG' = .008, and 'WOS' = .008.
C
        CALL DPDRAW (CUFX(0.),CUFY(0.),0)
C
        DO 112 I=2,101
          RRHO=8.*REAL(I-1)/100.
          THTA=8.*REAL(I-1)/50.
          CALL DPDRAW (CUFX(RRHO*COS(THTA)),CUFY(RRHO*SIN(THTA)),1)
  112   CONTINUE
C
        CALL DPDRAW (0.,0.,2)
C
C Put a small label below the spirals.
C
        CALL PLCHHQ (0.,-9.,'Using the first-solid multiplier.',
     +                                                      .01,0.,0.)
C
C Advance the frame.
C
        CALL FRAME
C
C Done.
C
        WRITE
     +    (6,'(''DASHPACK TEST EXECUTED OKAY - SEE PLOTS TO CERTIFY'')')
C
        IERR=0
C
        RETURN
C
      END



      FUNCTION IPKBTS (IBTS,NBTS)
C
C This value of this function, when given an array of NBTS 0s and 1s,
C is the integer resulting from packing those bits together, to be
C used as an integer dash pattern.
C
        DIMENSION IBTS(NBTS)
C
C Initialize the value of the function to zero.
C
        IPKBTS=0
C
C One at a time, shift the bits by the proper amount and "or" them into
C the value of the function, making sure to use only the lowest-order
C bit of each incoming array element.
C
        DO 101 I=1,NBTS
          IPKBTS=IOR(IPKBTS,ISHIFT(IAND(IBTS(I),1),NBTS-I))
  101   CONTINUE
C
C Done.
C
        RETURN
C
      END

c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by UCAR                 .
c  .                                                             .
c  .       University Corporation for Atmospheric Research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                         SPHEREPACK                          .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c
c ... file trssph.f
c
c     contains documentation and code for subroutine trssph
c
c ... required files
c
c     sphcom.f, hrfft.f, gaqd.f, shaec.f, shsec.f, shagc.f, shsgc.f
c
c
c     subroutine trssph(intl,igrida,nlona,nlata,da,igridb,nlonb,nlatb,
c    +db,wsave,lsave,lsvmin,work,lwork,lwkmin,dwork,ldwork,ier)
c
c *** purpose
c
C*PL*ERROR* Comment line too long
c     subroutine trssph transfers data given in array da on a grid on the
c     full sphere to data in array db on a grid on the full sphere.  the
c     grids on which da is given and db is generated can be specified
C*PL*ERROR* Comment line too long
c     independently of each other (see description below and the arguments
c     igrida,igridb).  for transferring vector data on the sphere, use
c     subroutine trvsph.

C*PL*ERROR* Comment line too long
c     notice that scalar and vector quantities are fundamentally different
C*PL*ERROR* Comment line too long
c     on the sphere.  for example, vectors are discontinuous and multiple
C*PL*ERROR* Comment line too long
c     valued at the poles.  scalars are continuous and single valued at the
C*PL*ERROR* Comment line too long
c     poles. erroneous results would be produced if one attempted to transfer
c     vector fields between grids with subroutine trssph applied to each
c     component of the vector.
c
c
c *** underlying grid assumptions and a description
c
C*PL*ERROR* Comment line too long
c     discussions with the ncar scd data support group and others indicate
C*PL*ERROR* Comment line too long
c     there is no standard grid for storing observational or model generated
c     data on the sphere.  subroutine trssph was designed to handle most
C*PL*ERROR* Comment line too long
c     cases likely to be encountered when moving data from one grid format
c     to another.
c
c     the grid on which da is given must be equally spaced in longitude
c     and either equally spaced or gaussian in latitude (or colatitude).
C*PL*ERROR* Comment line too long
c     longitude, which can be either the first or second dimension of da,
C*PL*ERROR* Comment line too long
c     subdivides [0,2pi) excluding the periodic point 2pi.  (co)latitude,
c     which can be the second or first dimension of da, has south
c     to north or north to south orientation with increasing subscript
c     value in da (see the argument igrida).
c
C*PL*ERROR* Comment line too long
c     the grid on which db is generated must be equally spaced in longitude
c     and either equally spaced or gaussian in latitude (or colatitude).
C*PL*ERROR* Comment line too long
c     longitude, which can be either the first or second dimension of db,
C*PL*ERROR* Comment line too long
c     subdivides [0,2pi) excluding the periodic point 2pi.  (co)latitude,
c     which can be the second or first dimension of db, has south
c     to north or north to south orientation with increasing subscript
c     value in db (see the argument igridb).
c
c     let nlon be either nlona or nlonb (the number of grid points in
c     longitude.  the longitude grid subdivides [0,2pi) into nlon spaced
c     points
c
c          (j-1)*2.*pi/nlon  (j=1,...,nlon).
c
C*PL*ERROR* Comment line too long
c     it is not necessary to communicate to subroutine trssph whether the
C*PL*ERROR* Comment line too long
c     underlying grids are in latitude or colatitude.  it is only necessary
C*PL*ERROR* Comment line too long
c     to communicate whether they run south to north or north to south with
C*PL*ERROR* Comment line too long
c     increasing subscripts.  a brief discussion of latitude and colatitude
c     follows.  equally spaced latitude grids are assumed to subdivide
c     [-pi/2,pi/2] with the south pole at -pi/2 and north pole at pi/2.
C*PL*ERROR* Comment line too long
c     equally spaced colatitude grids subdivide [0,pi] with the north pole
C*PL*ERROR* Comment line too long
c     at 0 and south pole at pi.  equally spaced partitions on the sphere
C*PL*ERROR* Comment line too long
c     include both poles.  gaussian latitude grids subdivide (-pi/2,pi/2)
C*PL*ERROR* Comment line too long
c     and gaussian colatitude grids subdivide (0,pi).  gaussian grids do not
C*PL*ERROR* Comment line too long
c     include the poles.  the gaussian grid points are uniquely determined by
c     the size of the partition.  they can be computed in colatitude in
C*PL*ERROR* Comment line too long
c     (0,pi) (north to south) in double precision by the spherepack subroutine
c     gaqd.  let nlat be nlata or nlatb if either the da or db grid is
c     gaussian.  let
c
c        north pole                             south pole
c        ----------                             ----------
c           0.0    <  cth(1) < ... < cth(nlat)  <   pi
c
c
c     be nlat gaussian colatitude points in the interval (0,pi) and let
c
c        south pole                        north pole
c        ----------                        ----------
c           -pi/2  < th(1) < ... < th(nlat) < pi/2
c
C*PL*ERROR* Comment line too long
c     be nlat gaussian latitude points in the open interval (-pi/2,pi/2).
c     these are related by
c
c          th(i) = -pi/2 + cth(i)  (i=1,...,nlat)
c
c     if the da or db grid is equally spaced in (co)latitude then
c
c          ctht(i) = (i-1)*pi/(nlat-1)
c                                               (i=1,...,nlat)
c          tht(i) = -pi/2 + (i-1)*pi/(nlat-1)
c
C*PL*ERROR* Comment line too long
c     define the equally spaced (north to south) colatitude and (south to
c     north) latitude grids.
c
c
c *** method (simplified description)
c
C*PL*ERROR* Comment line too long
c     for simplicity, assume da is a nlat by nlon data tabulation and da(i,j)
c     is the value at latitude theta(i) and longitude phi(j).  then
C*PL*ERROR* Comment line too long
c     coefficients a(m,n) and b(m,n) can be determined so that da(i,j) is
c     approximated by the sum
c
c         l-1  n
C*PL*ERROR* Comment line too long
c     (a) sum sum pbar(m,n,theta(i))*(a(m,n)*cos(m*phi(j)+b(m,n)*sin(m*phi(j))
c         n=0 m=0
c
C*PL*ERROR* Comment line too long
c     here pbar(n,m,theta) are the normalized associated legendre functions
C*PL*ERROR* Comment line too long
c     and l = min0(nlat,(nlon+2)/2).  the determination of a(m,n) and b(m,n)
C*PL*ERROR* Comment line too long
c     is called spherical harmonic analysis. a sum of this form can then be
c     used to regenerate the data in db on the new grid with the known
C*PL*ERROR* Comment line too long
c     a(m,n) and b(m,n).  this is referred to spherical harmonic synthesis.
C*PL*ERROR* Comment line too long
c     analysis and synthesis subroutines from the software package spherepack,
c     are used for these purposes.
c
C*PL*ERROR* Comment line too long
c     if da or db is not in mathematical spherical coordinates then array
C*PL*ERROR* Comment line too long
c     transposition and/or subscript reordering is used prior to harmonic
c     analysis and after harmonic synthesis.
c
c *** advantages
c
C*PL*ERROR* Comment line too long
c     the use of surface spherical harmonics to transfer spherical grid data
C*PL*ERROR* Comment line too long
c     has advantages over pointwise grid interpolation schemes on the sphere.
C*PL*ERROR* Comment line too long
c     it is highly accurate.  if p(x,y,z) is any polynomial of degree n or
C*PL*ERROR* Comment line too long
c     less in x,y,z cartesian coordinates which is restricted to the surface
C*PL*ERROR* Comment line too long
c     of the sphere, then p is exactly represented by sums of the form (a)
C*PL*ERROR* Comment line too long
c     whenever n = mino(nlat,nlon/2) (i.e., transfers with spherical harmonics
C*PL*ERROR* Comment line too long
c     have n(th) order accuracy.  by way of contrast, bilinear interpolation
C*PL*ERROR* Comment line too long
c     schemes are exact for polynomials of degree one.  bicubic interpolation
c     is exact only for polynomials of degree three or less.  the method
C*PL*ERROR* Comment line too long
c     also produces a weighted least squares fit to the data in which waves
C*PL*ERROR* Comment line too long
c     are resolved uniformly on the full sphere.  high frequencies, induced
c     by closeness of grid points near the poles (due to computational
c     or observational errors) are smoothed.  finally, the method is
C*PL*ERROR* Comment line too long
c     consistent with methods used to generate data in numerical spectral
C*PL*ERROR* Comment line too long
c     models based on spherical harmonics.  for more discussion of these and
C*PL*ERROR* Comment line too long
c     related issues,  see the article: "on the spectral approximation of
C*PL*ERROR* Comment line too long
c     discrete scalar and vector functions on the sphere," siam j. numer.
c     anal., vol 16. dec 1979, pp. 934-949, by paul swarztrauber.
c
c
c *** comment
c
C*PL*ERROR* Comment line too long
c     on a nlon by nlat or nlat by nlon grid (gaussian or equally spaced)
c     spherical harmonic analysis generates and synthesis utilizes
c     min0(nlat,(nlon+2)/2)) by nlat coefficients.  consequently, for
c     da and db,  if either
c
c             min0(nlatb,(nlonb+2)/2) < min0(nlata,(nlona+2)/2)
c
c     or if
c
c             nlatb < nlata
c
C*PL*ERROR* Comment line too long
c     then all the coefficients generated by an analysis of da cannot be used
C*PL*ERROR* Comment line too long
c     in the synthesis which generates db.  in this case "information" can be
C*PL*ERROR* Comment line too long
c     lost in generating db.  more precisely, information will be lost if the
C*PL*ERROR* Comment line too long
c     analysis of da yields nonzero coefficients which are outside the bounds
C*PL*ERROR* Comment line too long
c     determined by the db grid.  nevertheless, transference of values with
C*PL*ERROR* Comment line too long
c     spherical harmonics will yield results consistent with grid resolution
c     and is highly accurate.
c
c
c *** input arguments
c
c ... intl
c
C*PL*ERROR* Comment line too long
c     an initialization argument which should be zero on an initial call to
c     trssph.  intl should be one if trssph is being recalled and
c
c          igrida,nlona,nlata,igridb,nlonb,nlatb
c
C*PL*ERROR* Comment line too long
c     have not changed from the previous call.  if any of these arguments
C*PL*ERROR* Comment line too long
c     have changed, intl=0 must be used to avoid undetectable errors.  calls
C*PL*ERROR* Comment line too long
c     with intl=1 bypass redundant computation and save time.  it can be used
C*PL*ERROR* Comment line too long
c     when transferring multiple data sets with the same underlying grids.
c
c
c ... igrida
c
C*PL*ERROR* Comment line too long
c     an integer vector dimensioned two which identifies the underlying grid
c     on the full sphere for the given data array da as follows:
c
c     igrida(1)
c
c     = -1
c     if the latitude (or colatitude) grid for da is an equally spaced
c     partition of [-pi/2,pi/2] ( or [0,pi] ) including the poles which
c     runs north to south
c
c     = +1
c     if the latitude (or colatitude) grid for da is an equally spaced
c     partition of [-pi/2,pi/2] ( or [0,pi] ) including the poles which
c     runs south to north
c
c     = -2
C*PL*ERROR* Comment line too long
c     if the latitude (or colatitude) grid for da is a gaussian partition
c     of (-pi/2,pi/2) ( or (0,pi) ) excluding the poles which runs north
c     to south
c
c     = +2
C*PL*ERROR* Comment line too long
c     if the latitude (or colatitude) grid for da is a gaussian partition
c     of (-pi/2,pi/2) ( or (0,pi) ) excluding the poles which runs south
c     north
c
c     igrida(2)
c
c     = 0 if the underlying grid for da is a nlona by nlata
c
c     = 1 if the underlying grid for da is a nlata by nlona
c
c
c ... nlona
c
C*PL*ERROR* Comment line too long
c     the number of longitude points on the uniform grid which partitions
C*PL*ERROR* Comment line too long
c     [0,2pi) for the given data array da.  nlona is also the first or second
c     dimension of da (see igrida(2)) in the program which calls trssph.
C*PL*ERROR* Comment line too long
c     nlona determines the grid increment in longitude as 2*pi/nlona. for
C*PL*ERROR* Comment line too long
c     example nlona = 72 for a five degree grid.  nlona must be greater than
c     or equal to 4.  the efficiency of the computation is improved when
c     nlona is a product of small prime numbers
c
c ... nlata
c
c     the number of points in the latitude (or colatitude) grid
c     for the given data array da.  nlata is also the first or second
c     dimension of da (see igrida(2)) in the program which calls trssph.
C*PL*ERROR* Comment line too long
c     if nlata is odd then the equator will be located at the (nlata+1)/2
c     gaussian grid point.  if nlata is even then the equator will be
c     located half way between the nlata/2 and nlata/2+1 grid points.
c
c *** note:
c     igrida(1)=-1 or igrida(1)=-2 and igrida(2)=1 corresponds to
c     the "usual" mathematical spherical coordinate system required
c     by most of the drivers in spherepack2.  igrida(1)=1 or igrida(1)=2
c     and igrida(2)=0 corresponds to the "usual" geophysical spherical
c     coordinate system.
c
c ... da
c
c     a two dimensional array that contains the data to be transferred.
C*PL*ERROR* Comment line too long
c     da must be dimensioned nlona by nlata in the program calling trssph if
C*PL*ERROR* Comment line too long
c     igrida(2) = 0.  da must be dimensioned nlata by nlona in the program
C*PL*ERROR* Comment line too long
c     calling trssph if igrida(2) = 1.  if da is not properly dimensioned
C*PL*ERROR* Comment line too long
c     and if the latitude (colatitude) values do not run south to north or
C*PL*ERROR* Comment line too long
c     north to south as flagged by igrida(1) (this cannot be checked!) then
c     incorrect results will be produced.
c
c ... igridb
c
C*PL*ERROR* Comment line too long
c     an integer vector dimensioned two which identifies the underlying grid
c     on the full sphere for the transformed data array db as follows:
c
c     igridb(1)
c
c     = -1
c     if the latitude (or colatitude) grid for db is an equally spaced
c     partition of [-pi/2,pi/2] ( or [0,pi] ) including the poles which
c     north to south
c
c     = +1
c     if the latitude (or colatitude) grid for db is an equally spaced
c     partition of [-pi/2,pi/2] ( or [0,pi] ) including the poles which
c     south to north
c
c     = -2
C*PL*ERROR* Comment line too long
c     if the latitude (or colatitude) grid for db is a gaussian partition
C*PL*ERROR* Comment line too long
c     of (-pi/2,pi/2) ( or (0,pi) ) excluding the poles which runs north to
c     south
c
c     = +2
C*PL*ERROR* Comment line too long
c     if the latitude (or colatitude) grid for db is a gaussian partition
C*PL*ERROR* Comment line too long
c     of (-pi/2,pi/2) ( or (0,pi) ) excluding the poles which runs south to
c     north
c
c
c     igridb(2)
c
c     = 0 if the underlying grid for db is a nlonb by nlatb
c
c     = 1 if the underlying grid for db is a nlatb by nlonb
c
c
c ... nlonb
c
C*PL*ERROR* Comment line too long
c     the number of longitude points on the uniform grid which partitions
C*PL*ERROR* Comment line too long
c     [0,2pi) for the transformed data array db.  nlonb is also the first or
c     second dimension of db (see igridb(2)) in the program which calls
C*PL*ERROR* Comment line too long
c     trssph.  nlonb determines the grid increment in longitude as 2*pi/nlonb.
C*PL*ERROR* Comment line too long
c     for example nlonb = 72 for a five degree grid.  nlonb must be greater
C*PL*ERROR* Comment line too long
c     than or equal to 4.  the efficiency of the computation is improved when
c     nlonb is a product of small prime numbers
c
c ... nlatb
c
c     the number of points in the latitude (or colatitude) grid
C*PL*ERROR* Comment line too long
c     for the transformed data array db.  nlatb is also the first or second
c     dimension of db (see igridb(2)) in the program which calls trssph.
C*PL*ERROR* Comment line too long
c     if nlatb is odd then the equator will be located at the (nlatb+1)/2
c     gaussian grid point.  if nlatb is even then the equator will be
c     located half way between the nlatb/2 and nlatb/2+1 grid points.
c
c ... wsave
c
c     a saved work space array that can be utilized repeatedly by trssph
c     as long as the arguments nlata,nlona,nlatb,nlonb remain unchanged.
C*PL*ERROR* Comment line too long
c     wsave is set by a intl=0 call to trssph.  wsave must not be altered
c     when trssph is being recalled with intl=1.
c
c ... lsave
c
c     the dimension of the work space wsave as it appears in the program
c     that calls trssph.  the minimum required value of lsave for the
C*PL*ERROR* Comment line too long
c     current set of input arguments is set in the output argument lsvmin.
C*PL*ERROR* Comment line too long
c     it can be determined by calling trssph with lsave=0 and printing lsvmin.
c     let
c
c          lwa =  2*nlata*la2+3*((la1-2)*(nlata+nlata-la1-1))/2+nlona+15
c
c     if the grid for da is equally spaced in (co)latitude.  let
c
c          lwa = nlata*(2*la2+3*la1-2)+3*la1*(1-la1)/2+nlona+15
c
c     if the grid for da is gaussian in (co)latitude.
c     let
c
c          lwb = nlatb*(2*lb2+3*lb1-2)+3*lb1*(1-lb1)/2+nlonb+15
c
c     if the grid for db is gaussian in (co)latitude.  let
c
c          lwb = 2*nlatb*lb2+3*((lb1-2)*(nlatb+nlatb-lb1-1))/2+nlonb+15
c
c     if the grid for db is equally spaced in (co)latitude.  then
c     the quantity
c
c          lwa + lwb
c
c     is the minimum required length of wsave.  this value is returned
C*PL*ERROR* Comment line too long
c     in the output argument lsvmin even if lsave is to small (ierror=10)
c
c ... work
c
c     a real work array that does not have to be preserved
c
c ... lwork
c
c     the dimension of the array work as it appears in the program
C*PL*ERROR* Comment line too long
c     calling trssph. the minimum required value of lwork for the current
c     set of input arguments is set in the output argument lwkmin.
c     it can be determined by calling trssph with lwork=0 and printing
c     lwkmin.  an estimate for lwork follows.  let nlat,nlon,l1,l2 be
c     defined by
c
c       nlat = max0(nlata,nlatb), nlon = nax0(nlona,nlonb),
c       l1 = min0(nlat,(nlon+2)/2), l2 = (nlat+1)/2
c
c     then the quantity
c
c          nlat*(4*l1+nlon+2*nlat+4)+3*((l1-2)*2*(2*nlat-l1-1))/2
c
c     will suffice as a length for the unsaved work space.
c
C*PL*ERROR* Comment line too long
c  *  both of the formulas above for lsave and lwork may overestimate the
C*PL*ERROR* Comment line too long
c     required minimum values.  they can be predetermined by calling trssph
c     with lsave=lwork=0 and printout of lsvmin and lwkmin.
c
c ... dwork
c
c     a double precision work array that does not have to be preserved.
c
c ... ldwork
c
c     The length of dwork in the routine calling trssph.
c     Let
c
c       nlat = max0(nlata,nlatb)
c
c     ldwork must be at least nlat*(nlat+4)
c
c *** output arguments
c
c
c ... db
c
c     a two dimensional array that contains the transformed data.  db
C*PL*ERROR* Comment line too long
c     must be dimensioned nlonb by nlatb in the program calling trssph if
c     igridb(2) = 0 or 1.  db must be dimensioned nlatb by nlonb in the
c     program calling trssph if igridb(2) = 1.  if db is not properly
C*PL*ERROR* Comment line too long
c     dimensioned and if the latitude (colatitude) values do not run south
C*PL*ERROR* Comment line too long
c     north or north to south as flagged by igrdb(1) (this cannot be checked!)
c     then incorrect results will be produced.
c
c ... lsvmin
c
c     the minimum length of the saved work space in wsave.
c     lsvmin is computed even if lsave < lsvmin (ier = 10).
c
c ... lwkmin
c
c     the minimum length of the unsaved work space in work.
c     lwkmin is computed even if lwork < lwkmin (ier = 11).
c
c *** error argument
c
c ... ier = 0  if no errors are detected
c
c         = 1  if intl is not 0 or 1
c
c         = 2  if igrida(1) is not -1 or +1 or -2 or +2
c
c         = 3  if igrida(2) is not 0 or 1
c
c         = 4  if nlona is less than 4
c
c         = 5  if nlata is less than 3
c
c         = 6  if igridb(1) is not -1 or +1 or -2 or +2
c
c         = 7  if igridb(2) is not 0 or 1
c
c         = 8  if nlonb is less than 4
c
c         = 9  if nlatb is less than 3

C*PL*ERROR* Comment line too long
c         =10  if there is insufficient saved work space (lsave < lsvmin)
c
C*PL*ERROR* Comment line too long
c         =11  if there is insufficient unsaved work space (lwork < lwkmin)
c
c         =12  indicates failure in an eigenvalue routine which computes
c              gaussian weights and points
c
C*PL*ERROR* Comment line too long
c         =13  if ldwork is too small (insufficient unsaved double precision
c              work space)
c
c *****************************************************
c *****************************************************
c
c     end of argument description ... code follows
c
c *****************************************************
c *****************************************************
c
      SUBROUTINE DTRSSPH(INTL,IGRIDA,NLONA,NLATA,DA,IGRIDB,NLONB,NLATB,
     +                  DB,WSAVE,LSAVE,LSVMIN,WORK,LWORK,LWKMIN,DWORK,
     +                  LDWORK,IER)
      IMPLICIT NONE
      INTEGER INTL,IGRIDA(2),NLONA,NLATA,IGRIDB(2),NLONB,NLATB
      INTEGER LSAVE,LSVMIN,LWORK,LWKMIN,LDWORK,IER
      DOUBLE PRECISION DA(*),DB(*),WSAVE(*),WORK(*)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION DWORK(*)
      INTEGER IG,IGRDA,IGRDB,LA1,LA2,LB1,LB2,LWA,LWB,IAA,IAB,IBA,IBB
      INTEGER LWK3,LWK4,LW,IW,JB,NT,ISYM,NLAT
c
C*PL*ERROR* Comment line too long
c     include a save statement to ensure local variables in trssph, set during
c     an intl=0 call, are preserved if trssph is recalled with intl=1
c
      SAVE
c
c     check input arguments
c
      IER = 1
      IF (INTL* (INTL-1).NE.0) RETURN
      IER = 2
      IG = IGRIDA(1)
      IF ((IG-1)* (IG+1)* (IG-2)* (IG+2).NE.0) RETURN
      IER = 3
      IG = IGRIDA(2)
      IF (IG* (IG-1).NE.0) RETURN
      IER = 4
      IF (NLONA.LT.4) RETURN
      IER = 5
      IF (NLATA.LT.3) RETURN
      IER = 6
      IG = IGRIDB(1)
      IF ((IG-1)* (IG+1)* (IG-2)* (IG+2).NE.0) RETURN
      IER = 7
      IG = IGRIDB(2)
      IF (IG* (IG-1).NE.0) RETURN
      IER = 8
      IF (NLONB.LT.4) RETURN
      IER = 9
      IF (NLATB.LT.3) RETURN
      IER = 0

      IGRDA = IABS(IGRIDA(1))
      IGRDB = IABS(IGRIDB(1))
      IF (INTL.EQ.0) THEN
          LA1 = MIN0(NLATA, (NLONA+2)/2)
          LA2 = (NLATA+1)/2
          LB1 = MIN0(NLATB, (NLONB+2)/2)
          LB2 = (NLATB+1)/2
c
c     set saved work space length for analysis
c
          IF (IGRDA.EQ.1) THEN
c
c     saved space for analysis on  equally spaced grid
c
              LWA = 2*NLATA*LA2 + 3* ((LA1-2)* (NLATA+NLATA-LA1-1))/2 +
     +              NLONA + 15
          ELSE
c
c     saved space for analysis on gaussian grid
c
              LWA = NLATA* (2*LA2+3*LA1-2) + 3*LA1* (1-LA1)/2 + NLONA +
     +              15
          END IF
c
c     set wsave pointer
c
          JB = 1 + LWA
c
c     set pointers for spherical harmonic coefs
c
          IAA = 1
          IBA = IAA + LA1*NLATA
          IAB = IBA + LA1*NLATA
          IF (IGRDB.EQ.2) THEN
c
c     set saved work space length for gaussian synthesis
c
              LWB = NLATB* (2*LB2+3*LB1-2) + 3*LB1* (1-LB1)/2 + NLONB +
     +              15
          ELSE
c
c     set saved work space length for equally spaced synthesis
c
              LWB = 2*NLATB*LB2 + 3* ((LB1-2)* (NLATB+NLATB-LB1-1))/2 +
     +              NLONB + 15
          END IF
c
c     set minimum saved work space length
c
          LSVMIN = LWA + LWB
c
c     set remaining harmonic pointer
c
          IBB = IAB + LB1*NLATB
c
c     set pointers for remaining work
c
          IW = IBB + LB1*NLATB
c
c     set remaining work space length in lw
c
          LW = LWORK - IW
          LWK3 = NLATA*NLONA*2
          LWK4 = NLATB*NLONB*2
c
c     set minimum unsaved work space required by trssph
c
          LWKMIN = IW + MAX0(LWK3,LWK4)
c
c     set error flags if saved or unsaved work spaces are insufficient
c
          IER = 10
          IF (LSAVE.LT.LSVMIN) RETURN
          IER = 11
          IF (LWORK.LT.LWKMIN) RETURN
          IER = 13
          NLAT = MAX0(NLATA,NLATB)
          IF (LDWORK.LT.NLAT* (NLAT+4)) RETURN
          IER = 0
          IF (IGRDA.EQ.1) THEN
c
c     initialize wsave for equally spaced analysis
c
              CALL DSHAECI(NLATA,NLONA,WSAVE,LWA,DWORK,LDWORK,IER)
          ELSE
c
c     initialize wsave for gaussian analysis
c
              CALL DSHAGCI(NLATA,NLONA,WSAVE,LWA,DWORK,LDWORK,IER)
              IF (IER.NE.0) THEN
c
c     flag failure in spherepack gaussian software
c
                  IER = 12
                  RETURN
              END IF
          END IF

          IF (IGRDB.EQ.2) THEN
c
c     initialize wsave for gaussian synthesis
c
              CALL DSHSGCI(NLATB,NLONB,WSAVE(JB),LWB,DWORK,LDWORK,IER)
              IF (IER.NE.0) THEN
c
c     flag failure in spherepack gaussian software
c
                  IER = 12
                  RETURN
              END IF
          ELSE
c
c     initialize wsave for equally spaced synthesis
c
              CALL DSHSECI(NLATB,NLONB,WSAVE(JB),LWB,DWORK,LDWORK,IER)
          END IF
c
c     end of initialization (intl=0) call
c
      END IF
c
c     transpose and/or reorder (co)latitude if necessary for da
c     (arrays must have latitude (colatitude) as the first dimension
c     and run north to south for spherepack software)
c
      IF (IGRIDA(2).EQ.0) CALL DTRSPLAT(NLONA,NLATA,DA,WORK)
      IF (IGRIDA(1).GT.0) CALL DCONVLAT(NLATA,NLONA,DA)

      NT = 1
      ISYM = 0
      IF (IGRDA.EQ.2) THEN
c
c     do spherical harmonic analysis of "adjusted" da on gaussian grid
c
          CALL DSHAGC(NLATA,NLONA,ISYM,NT,DA,NLATA,NLONA,WORK(IAA),
     +               WORK(IBA),LA1,NLATA,WSAVE,LWA,WORK(IW),LW,IER)
      ELSE
c
C*PL*ERROR* Comment line too long
c     do spherical harmonic analysis of "adjusted" da on equally spaced grid
c
          CALL DSHAEC(NLATA,NLONA,ISYM,NT,DA,NLATA,NLONA,WORK(IAA),
     +               WORK(IBA),LA1,NLATA,WSAVE,LWA,WORK(IW),LW,IER)
      END IF
c
c     transfer da grid coefficients to db grid coefficients
c     truncating to zero as necessary
c
      CALL DTRAB(LA1,NLATA,WORK(IAA),WORK(IBA),LB1,NLATB,WORK(IAB),
     +          WORK(IBB))

      IF (IGRDB.EQ.1) THEN
c
C*PL*ERROR* Comment line too long
c     do spherical harmonic synthesis on nlatb by nlonb equally spaced grid
c
          CALL DSHSEC(NLATB,NLONB,ISYM,NT,DB,NLATB,NLONB,WORK(IAB),
     +               WORK(IBB),LB1,NLATB,WSAVE(JB),LWB,WORK(IW),LW,IER)
      ELSE
c
c     do spherical harmonic synthesis on nlatb by nlonb gaussian grid
c
          CALL DSHSGC(NLATB,NLONB,ISYM,NT,DB,NLATB,NLONB,WORK(IAB),
     +               WORK(IBB),LB1,NLATB,WSAVE(JB),LWB,WORK(IW),LW,IER)
      END IF
c
C*PL*ERROR* Comment line too long
c     both da,db are currently latitude by longitude north to south arrays
c     restore da and set db to agree with flags in igrida and igridb
c
      IF (IGRIDA(1).GT.0) CALL DCONVLAT(NLATA,NLONA,DA)
      IF (IGRIDB(1).GT.0) CALL DCONVLAT(NLATB,NLONB,DB)
      IF (IGRIDA(2).EQ.0) CALL DTRSPLAT(NLATA,NLONA,DA,WORK)
      IF (IGRIDB(2).EQ.0) CALL DTRSPLAT(NLATB,NLONB,DB,WORK)
      RETURN
      END

      SUBROUTINE DTRAB(MA,NA,AA,BA,MB,NB,AB,BB)
      IMPLICIT NONE
      INTEGER MA,NA,MB,NB,I,J,M,N
      DOUBLE PRECISION AA(MA,NA),BA(MA,NA),AB(MB,NB),BB(MB,NB)
c
c     set coefficients for b grid from coefficients for a grid
c
      M = MIN0(MA,MB)
      N = MIN0(NA,NB)
      DO J = 1,N
          DO I = 1,M
              AB(I,J) = AA(I,J)
              BB(I,J) = BA(I,J)
          END DO
      END DO
c
c     set coefs outside triangle to zero
c
      DO I = M + 1,MB
          DO J = 1,NB
              AB(I,J) = 0.0D0
              BB(I,J) = 0.0D0
          END DO
      END DO
      DO J = N + 1,NB
          DO I = 1,MB
              AB(I,J) = 0.0D0
              BB(I,J) = 0.0D0
          END DO
      END DO
      RETURN
      END

      SUBROUTINE DTRSPLAT(N,M,DATA,WORK)
c
c     transpose the n by m array data to a m by n array data
c     work must be at least n*m words long
c
      IMPLICIT NONE
      INTEGER N,M,I,J,IJ,JI
      DOUBLE PRECISION DATA(*),WORK(*)

      DO J = 1,M
          DO I = 1,N
              IJ = (J-1)*N + I
              WORK(IJ) = DATA(IJ)
          END DO
      END DO
      DO I = 1,N
          DO J = 1,M
              JI = (I-1)*M + J
              IJ = (J-1)*N + I
              DATA(JI) = WORK(IJ)
          END DO
      END DO
      RETURN
      END

      SUBROUTINE DCONVLAT(NLAT,NLON,DATA)
c
c     reverse order of latitude (colatitude) grids
c
      IMPLICIT NONE
      INTEGER NLAT,NLON,NLAT2,I,IB,J
      DOUBLE PRECISION DATA(NLAT,NLON),TEMP

      NLAT2 = NLAT/2
      DO I = 1,NLAT2
          IB = NLAT - I + 1
          DO J = 1,NLON
              TEMP = DATA(I,J)
              DATA(I,J) = DATA(IB,J)
              DATA(IB,J) = TEMP
          END DO
      END DO
      RETURN
      END

C
C	$Id: gzreop.f,v 1.7 2008-07-27 00:21:04 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GZREOP(LIDR,IDR,ENAM)
C
C  Reopen CGM workstation.
C
      include 'gkscom.h'
C
      INTEGER WKID,CONID,WTYPE,ENAM
      CHARACTER*80 IDR(LIDR)
      INTEGER LASF(13)
C
      INTEGER CIATT(31)
      REAL    CFATT(19)
C
      RERR = 0
C
C  Read in control information
C
C       WKID   -  workstation identifier.
C       CONID  -  connection identifier.
C       WTYPE  -  workstation type.
C       IAFLG  -  flag to indicate if attribute settings are being supplied.
C       NCLRS  -  the number of colors in the supplied color table
C                 (can equal 0).
C       NCXS   -  The color index associated with the first color in the
C                 color table (all other color indices are filled in in
C                 sequence).
C       NOPTN  -  the action to be taken -
C                    = 0 - reestablish the color table only.
C                    = 1 - reestablish the color table and GKS state
C                          (do not issue the state values to the metafile).
C                    = 2 - reestablish the color table and GKS state 
C                          (issue GKS state values to the metafile).
C                    = 3 - reestablish the color table and issue the
C                          current GKS state values to the metafile.
C
      READ(IDR(1),502) WKID,  CONID, WTYPE, IAFLG, NCLRS, NCXS, NOPTN
  502 FORMAT(7I5)
C
C  Check if the workstation identifier is valid.
C
      IF (WKID .LT. 0) THEN
        ERS = 1
        CALL GERHND(-401,ENAM,ERF)
        ERS = 0
        RETURN
      ENDIF
C
C  Check that the connection identifier is valid.
C
      IF (CONID.EQ.5 .OR. CONID.EQ.6) THEN
        ERS = 1
        CALL GERHND(-402,ENAM,ERF)
        ERS = 0
        RETURN
      ENDIF
C
C  Check that the workstation type is valid.
C
      IF (WTYPE .NE. GCGM) THEN
        ERS = 1
        CALL GERHND(-403,ENAM,ERF)
        ERS = 0
        RETURN
      ENDIF
C
C  Check if the workstation is currently open.
C
      IF (NOPWK .GT. 0) THEN
        DO 204 I=1,NOPWK
          IF (SOPWK(I) .EQ. WKID) THEN
            ERS = 1
            CALL GERHND(-404,ENAM,ERF)
            ERS = 0
            RETURN
          ENDIF
  204   CONTINUE
      ENDIF
C
C  Check if there is room for another open workstation.
C
      IF (NOPWK .GE. MOPWK) THEN
        ERS = 1
        CALL GERHND(-405,ENAM,ERF)
        ERS = 0
        RETURN
      ENDIF
C
C  Only one CGM workstation currently allowed.
C
      IF (WTYPE .EQ. GCGM) THEN
        DO 30 I=1,NOPWK
          IF (SWKTP(I) .EQ. GCGM) THEN
            ERS = 1
            CALL GERHND(-406,ENAM,ERF)
            ERS = 0
            RETURN
          ENDIF
   30   CONTINUE
      ENDIF
C
C  Set the operating state to WSOP if in state GKOP.
C
      IF (OPS .EQ. GGKOP) THEN
        OPS = GWSOP
      ENDIF
C
C  Add the workstation identifier to the set of open workstations.
C
      NOPWK = NOPWK+1
      SOPWK(NOPWK) = WKID
      SWKTP(NOPWK) = WTYPE
C
C  Pass file name and type information across the workstation interface.
C
      CUFLAG = WKID
      FCODE = -4
      CONT  = 0
      CALL GZROI(0)
      IL1   = 3
      IL2   = 3
      ID(1) = WKID
      ID(2) = CONID
      ID(3) = WTYPE
      CALL GZTOWK
      CUFLAG = -1
      IF (RERR .GT. 0) THEN
        RETURN
      ELSE IF (RERR .EQ. -10) THEN
        NOPICT = 1
      ENDIF
C
C  Re-establish the color table.
C
C    ICNDX is the current color index.
C    IANDX is a pointer into the color table of the IDR array.
C
      ICNDX = NCXS-1
      IANDX = 6
CRLB:      IF (IAFLG .NE. 0) IANDX = 12
      IF (IAFLG .NE. 0) IANDX = 14
C
      ICRM = MOD(NCLRS,4)
      ICDV = NCLRS/4
      DO 50 I=1,ICDV
        DO 60 J=1,4
          ID1 = 18*(J-1)+1
          ID2 = ID1+17
          READ(IDR(IANDX)(ID1:ID2),500) RED,GREEN,BLUE
  500     FORMAT(3F6.3)
          ICNDX = ICNDX+1
          CALL GSCR(WKID,ICNDX,RED,GREEN,BLUE) 
   60   CONTINUE
        IANDX = IANDX+1
   50 CONTINUE
C
      DO 70 J=1,ICRM
        ID1 = 18*(J-1)+1
        ID2 = ID1+17
        READ(IDR(IANDX)(ID1:ID2),500) RED,GREEN,BLUE
        ICNDX = ICNDX+1
        CALL GSCR(WKID,ICNDX,RED,GREEN,BLUE)
   70 CONTINUE
C
C  If the attributes are available, read them in.
C
      IF (IAFLG .NE. 0) THEN
C        --------------------------------------------------
C        Serializing these values was modified to support the presence of
C        32bit ARGB values, which are always *much* larger in magnitude
C        than the original I4 character fields.  Expanded to I10s; note
C        that 2 extra 80-character records are now required, so that
C        subsequent offsets into IDR have changed.     RLB 1/2012
C
C        READ(IDR( 6),503) (CIATT(LL),LL= 1,20)
C        READ(IDR( 7),504) (CIATT(LL),LL=21,31)
C        READ(IDR( 8),505) (CFATT(LL),LL= 1, 5)
C        READ(IDR( 9),505) (CFATT(LL),LL= 6,10)
C        READ(IDR(10),505) (CFATT(LL),LL=11,15)
C        READ(IDR(11),506) (CFATT(LL),LL=16,19)
C        --------------------------------------------------
        READ(IDR( 6),508) (CIATT(LL),LL= 1, 8)
        READ(IDR( 7),508) (CIATT(LL),LL= 9,16)
        READ(IDR( 8),508) (CIATT(LL),LL=17,24)
        READ(IDR( 9),508) (CIATT(LL),LL=25,31)
        READ(IDR(10),505) (CFATT(LL),LL= 1, 5)
        READ(IDR(11),505) (CFATT(LL),LL= 6,10)
        READ(IDR(12),505) (CFATT(LL),LL=11,15)
        READ(IDR(13),506) (CFATT(LL),LL=16,19)
  503   FORMAT(20I4)
  504   FORMAT(11I4)
  505   FORMAT(5E16.7)
  506   FORMAT(4E16.7)
  508   FORMAT(8I10)
      ENDIF
C
      CUFLAG = WKID
      IF (NOPTN.EQ.1 .OR. NOPTN.EQ.2) THEN
        CCLIP    = CIATT( 1)
        CPLI     = CIATT( 2)
        CLN      = CIATT( 3)
        CLWSC    = CFATT( 1)
        CPLCI    = CIATT( 4)
        CPMI     = CIATT( 5)
        CMK      = CIATT( 6)
        CMKS     = CFATT( 2)
        CPMCI    = CIATT( 7)
        CTXI     = CIATT( 8)
        CTXFP(1) = CIATT( 9)
        CTXFP(2) = CIATT(10)
        CCHXP    = CFATT( 3)
        CCHSP    = CFATT( 4)
        CTXCI    = CIATT(11)
        CCHH     = CFATT( 5)
        CCHUP(1) = CFATT( 6)
        CCHUP(2) = CFATT( 7)
        CTXP     = CIATT(12)
        CTXAL(1) = CIATT(13)
        CTXAL(2) = CIATT(14)
        CFAI     = CIATT(15)
        CFAIS    = CIATT(16)
        CFASI    = CIATT(17)
        CFACI    = CIATT(18)
        CPA(1)   = CFATT( 8)
        CPA(2)   = CFATT( 9)
        CPARF(1) = CFATT(10)
        CPARF(2) = CFATT(11)
        CLNA     = CIATT(19)
        CLWSCA   = CIATT(20)
        CPLCIA   = CIATT(21)
        CMKA     = CIATT(22)
        CMKSA    = CIATT(23)
        CPMCIA   = CIATT(24)
        CTXFPA   = CIATT(25)
        CCHXPA   = CIATT(26)
        CCHSPA   = CIATT(27)
        CTXCIA   = CIATT(28)
        CFAISA   = CIATT(29)
        CFASIA   = CIATT(30)
        CFACIA   = CIATT(31)
C
        CALL GSCLIP (CCLIP)
C       CALL GSPLI  (CPLI )
        CALL GSLN   (CLN  )
        CALL GSLWSC (CLWSC)
        CALL GSPLCI (CPLCI)
C       CALL GSPMI  (CPMI )
        CALL GSMK   (CMK  )
        CALL GSMKSC (CMKS )
        CALL GSPMCI (CPMCI)
C       CALL GSTXI  (CTXI )
        CALL GSTXFP (CTXFP(1),CTXFP(2))
        CALL GSCHXP (CCHXP)
        CALL GSCHSP (CCHSP)
        CALL GSTXCI (CTXCI)
        CALL GSCHH  (CCHH )
        CALL GSCHUP (CCHUP(1),CCHUP(2))
        CALL GSTXP  (CTXP )
        CALL GSTXAL (CTXAL(1),CTXAL(2))
C       CALL GSFAI  (CFAI )
        CALL GSFAIS (CFAIS)
        CALL GSFASI (CFASI)
        CALL GSFACI (CFACI)
C       CALL GSPA   (CPA  (1),CPA  (2))
C       CALL GSPARF (CPARF(1),CPARF(2))
        LASF( 1) = CLNA
        LASF( 2) = CLWSCA
        LASF( 3) = CPLCIA
        LASF( 4) = CMKA
        LASF( 5) = CMKSA
        LASF( 6) = CPMCIA
        LASF( 7) = CTXFPA
        LASF( 8) = CCHXPA
        LASF( 9) = CCHSPA
        LASF(10) = CTXCIA
        LASF(11) = CFAISA
        LASF(12) = CFASIA
        LASF(13) = CFACIA
        CALL GSASF (LASF)
      ENDIF
      IF (NOPTN.EQ.2 .OR. NOPTN.EQ.3) THEN
        CALL GSCLIP (CCLIP)
C       CALL GSPLI  (CPLI )
        CALL GSLN   (CLN  )
        CALL GSLWSC (CLWSC)
        CALL GSPLCI (CPLCI)
C       CALL GSPMI  (CPMI )
        CALL GSMK   (CMK  )
        CALL GSMKSC (CMKS )
        CALL GSPMCI (CPMCI)
C       CALL GSTXI  (CTXI )
        CALL GSTXFP (CTXFP(1),CTXFP(2))
        CALL GSCHXP (CCHXP)
        CALL GSCHSP (CCHSP)
        CALL GSTXCI (CTXCI)
        CALL GSCHH  (CCHH )
        CALL GSCHUP (CCHUP(1),CCHUP(2))
        CALL GSTXP  (CTXP )
        CALL GSTXAL (CTXAL(1),CTXAL(2))
C       CALL GSFAI  (CFAI )
        CALL GSFAIS (CFAIS)
        CALL GSFASI (CFASI)
        CALL GSFACI (CFACI)
C       CALL GSPA   (CPA  (1),CPA  (2))
C       CALL GSPARF (CPARF(1),CPARF(2))
        LASF( 1) = CLNA
        LASF( 2) = CLWSCA
        LASF( 3) = CPLCIA
        LASF( 4) = CMKA
        LASF( 5) = CMKSA
        LASF( 6) = CPMCIA
        LASF( 7) = CTXFPA
        LASF( 8) = CCHXPA
        LASF( 9) = CCHSPA
        LASF(10) = CTXCIA
        LASF(11) = CFAISA
        LASF(12) = CFASIA
        LASF(13) = CFACIA
        CALL GSASF (LASF)
C
C  Send out the context.
C
C  Put out new picture initialization if CGM and the picture is empty.
C
        IF (WTYPE .EQ. GCGM) THEN
          IF (NOPICT .LE. 0) THEN
            FCODEO = FCODE
            CONTO  = CONT
            FCODE = 91
            CONT  =  0
            CALL GZROI(0)
            CALL G01WDR(WKID,' ')
            FCODE  = FCODEO
            CONT   = CONTO
            NOPICT = 1
          ENDIF
        ENDIF
C
        CUFLAG = WKID
        FCODE = -6
        CONT  = 0
        CALL GZROI(0)
        IL1   = 0
        IL2   = 0
        CALL GZTOWK
        CUFLAG = -1
        IF (RERR .NE. 0) RETURN
      ENDIF
C
      CUFLAG = -1
C
C  Make sure that the current normalization transformation is in
C  effect.
C
      CALL GSELNT(CNT)
C
      RETURN
      END

C
C     $Id: saxpy.f,v 1.1 1994-08-11 23:17:30 boote Exp $
C
      SUBROUTINE SAXPY(N,SA,SX,INCX,SY,INCY)
C
C     CONSTANT TIMES A VECTOR PLUS A VECTOR.
C     USES UNROLLED LOOP FOR INCREMENTS EQUAL TO ONE.
C     JACK DONGARRA, LINPACK, 3/11/78.
C
      REAL SX(1),SY(1),SA
      INTEGER I,INCX,INCY,IX,IY,M,MP1,N
C
      IF(N.LE.0)RETURN
      IF (SA .EQ. 0.0) RETURN
      IF(INCX.EQ.1.AND.INCY.EQ.1)GO TO 20
C
C        CODE FOR UNEQUAL INCREMENTS OR EQUAL INCREMENTS
C          NOT EQUAL TO 1
C
      IX = 1
      IY = 1
      IF(INCX.LT.0)IX = (-N+1)*INCX + 1
      IF(INCY.LT.0)IY = (-N+1)*INCY + 1
      DO 10 I = 1,N
        SY(IY) = SY(IY) + SA*SX(IX)
        IX = IX + INCX
        IY = IY + INCY
   10 CONTINUE
      RETURN
C
C        CODE FOR BOTH INCREMENTS EQUAL TO 1
C
C
C        CLEAN-UP LOOP
C
   20 M = MOD(N,4)
      IF( M .EQ. 0 ) GO TO 40
      DO 30 I = 1,M
        SY(I) = SY(I) + SA*SX(I)
   30 CONTINUE
      IF( N .LT. 4 ) RETURN
   40 MP1 = M + 1
      DO 50 I = MP1,N,4
        SY(I) = SY(I) + SA*SX(I)
        SY(I + 1) = SY(I + 1) + SA*SX(I + 1)
        SY(I + 2) = SY(I + 2) + SA*SX(I + 2)
        SY(I + 3) = SY(I + 3) + SA*SX(I + 3)
   50 CONTINUE
      RETURN
      END

C
C $Id: mdlblt.f,v 1.8 2008-09-18 00:42:17 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MDLBLT (XCOP,YCOP,XCOQ,YCOQ,OFFX,OFFY,SIZE,ANGL,CENT)
C
        REAL XCOP,YCOP,XCOQ,YCOQ,OFFX,OFFY,SIZE,ANGL,CENT
C
        DOUBLE PRECISION PLAT,PLON,QLAT,QLON,DNCE,RLAT,UCOR,VCOR
C
C This routine attempts to put tick marks and latitude labels along an
C arbitrary line on a map drawn by EZMAP.  XCOP, YCOP, XCOQ, and YCOQ
C are the X and Y coordinates, in the fractional system, of two points,
C P and Q.  The latitude labels will be placed at positions between P
C and Q where the latitude is a multiple of some "nice" value.  OFFX
C and OFFY specify fractional-system X and Y components of an offset
C vector from a point to be labeled to a point relative to which the
C label will be positioned.  SIZE is the desired character width, in
C the fractional system.  ANGL is the angle, in degrees, at which the
C label is to be written.  CENT specifies what part of the label is to
C be placed on the end of the offset vector; CENT = -1. means the center
C of the left end of the label, CENT = 0. means the center of the whole
C label, and CENT = +1. means the center of the right end of the label.
C
C Care should be taken to choose points P and Q such that the value of
C latitude is monotonically increasing or decreasing along the line
C from P to Q.
C
        CHARACTER*128 CHRS
C
C Declare other local variables.
C
        INTEGER       I,IPLT,IQLT,NCHR
C
C Get the latitude and longitude of P.
C
        CALL MDPTRI (DBLE(CFUX(XCOP)),DBLE(CFUY(YCOP)),PLAT,PLON)
        IF (PLAT.EQ.1.D12) RETURN
C
C Get the latitude and longitude of Q.
C
        CALL MDPTRI (DBLE(CFUX(XCOQ)),DBLE(CFUY(YCOQ)),QLAT,QLON)
        IF (QLAT.EQ.1.D12) RETURN
C
C Compute a "nice" latitude interval to use.
C
        CALL MDGNIN (ABS(QLAT-PLAT)/4.D0,DNCE)
        IF (DNCE.EQ.0.D0) RETURN
C
C Compute limits to be used in the labeling loop.
C
        IPLT=INT((PLAT+90.D0)/DNCE)
        IQLT=INT((QLAT+90.D0)/DNCE)
C
C Loop to generate the labels.
C
        DO 101 I=MIN(IPLT,IQLT)-1,MAX(IPLT,IQLT)+1
          RLAT=DBLE(I)*DNCE-90.D0
          IF (RLAT.GT.MIN(PLAT,QLAT)-DNCE/100.D0.AND.
     +        RLAT.LT.MAX(PLAT,QLAT)+DNCE/100.D0) THEN
            CALL MDILAT (PLAT,PLON,DBLE(CFUX(XCOP)),DBLE(CFUY(YCOP)),
     +                   QLAT,QLON,DBLE(CFUX(XCOQ)),DBLE(CFUY(YCOQ)),
     +                   RLAT,UCOR,VCOR)
            CALL MDLACH (RLAT,CHRS,NCHR)
            CALL PLCHHQ (CFUX(CUFX(REAL(UCOR))+OFFX),
     +                   CFUY(CUFY(REAL(VCOR))+OFFY),
     +                   CHRS(1:NCHR),SIZE,ANGL,CENT)
          END IF
  101   CONTINUE
C
C Done.
C
        RETURN
C
      END

c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by UCAR                 .
c  .                                                             .
c  .       University Corporation for Atmospheric Research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                         SPHEREPACK                          .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c
c
c ... file igrades.f
c
c     this file includes documentation and code for
c     subroutine igrades         i
c
c ... files which must be loaded with igradec.f
c
c     sphcom.f, hrfft.f, shses.f,vhaes.f
c
c     subroutine igrades(nlat,nlon,isym,nt,sf,isf,jsf,br,bi,mdb,ndb,
c    +                   wshses,lshses,work,lwork,ierror)
c
c     let br,bi,cr,ci be the vector spherical harmonic coefficients
c     precomputed by vhaes for a vector field (v,w).  let (v',w') be
c     the irrotational component of (v,w) (i.e., (v',w') is generated
c     by assuming cr,ci are zero and synthesizing br,bi with vhses).
c     then subroutine igrades computes a scalar field sf such that
c
c            gradient(sf) = (v',w').
c
c     i.e.,
c
C*PL*ERROR* Comment line too long
c            v'(i,j) = d(sf(i,j))/dtheta          (colatitudinal component of
c                                                 the gradient)
c     and
c
C*PL*ERROR* Comment line too long
c            w'(i,j) = 1/sint*d(sf(i,j))/dlambda  (east longitudinal component
c                                                 of the gradient)
c
c     at colatitude
c
c            theta(i) = (i-1)*pi/(nlat-1)
c
c     and longitude
c
c            lambda(j) = (j-1)*2*pi/nlon
c
C*PL*ERROR* Comment line too long
c     where sint = sin(theta(i)).  required associated legendre polynomials
C*PL*ERROR* Comment line too long
c     are stored rather than recomputed as they are in subroutine igradec.
c
c     note:  for an irrotational vector field (v,w), subroutine igrades
c     computes a scalar field whose gradient is (v,w).  in ay case,
c     subroutine igrades "inverts" the gradient subroutine grades.
c
c
c     input parameters
c
c     nlat   the number of colatitudes on the full sphere including the
c            poles. for example, nlat = 37 for a five degree grid.
c            nlat determines the grid increment in colatitude as
c            pi/(nlat-1).  if nlat is odd the equator is located at
c            grid point i=(nlat+1)/2. if nlat is even the equator is
c            located half way between points i=nlat/2 and i=nlat/2+1.
c            nlat must be at least 3. note: on the half sphere, the
c            number of grid points in the colatitudinal direction is
c            nlat/2 if nlat is even or (nlat+1)/2 if nlat is odd.
c
c     nlon   the number of distinct londitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater than
c            3.  the efficiency of the computation is improved when nlon
c            is a product of small prime numbers.
c
c
c     isym   a parameter which determines whether the scalar field sf is
c            computed on the full or half sphere as follows:
c
c      = 0
c
c            the symmetries/antsymmetries described in isym=1,2 below
c            do not exist in (v,w) about the equator.  in this case sf
c            is neither symmetric nor antisymmetric about the equator.
c            sf is computed on the entire sphere.  i.e., in the array
c            sf(i,j) for i=1,...,nlat and  j=1,...,nlon
c
c      = 1
c
c            w is antisymmetric and v is symmetric about the equator.
c            in this case sf is antisymmetyric about the equator and
c            is computed for the northern hemisphere only.  i.e.,
c            if nlat is odd sf is computed in the array sf(i,j) for
c            i=1,...,(nlat+1)/2 and for j=1,...,nlon.  if nlat is even
c            sf is computed in the array sf(i,j) for i=1,...,nlat/2
c            and j=1,...,nlon.
c
c      = 2
c
c            w is symmetric and v is antisymmetric about the equator.
c            in this case sf is symmetyric about the equator and
c            is computed for the northern hemisphere only.  i.e.,
c            if nlat is odd sf is computed in the array sf(i,j) for
c            i=1,...,(nlat+1)/2 and for j=1,...,nlon.  if nlat is even
c            sf is computed in the array sf(i,j) for i=1,...,nlat/2
c            and j=1,...,nlon.
c
c
c     nt     nt is the number of scalar and vector fields.  some
c            computational efficiency is obtained for multiple fields.
C*PL*ERROR* Comment line too long
c            the arrays br,bi, and sf can be three dimensional corresponding
c            to an indexed multiple vector field (v,w).  in this case,
c            multiple scalar synthesis will be performed to compute each
C*PL*ERROR* Comment line too long
c            scalar field.  the third index for br,bi, and sf is the synthesis
c            index which assumes the values k = 1,...,nt.  for a single
c            synthesis set nt = 1.  the description of the remaining
C*PL*ERROR* Comment line too long
c            parameters is simplified by assuming that nt=1 or that br,bi,
c            and sf are two dimensional arrays.
c
c     isf    the first dimension of the array sf as it appears in
c            the program that calls igrades. if isym = 0 then isf
c            must be at least nlat.  if isym = 1 or 2 and nlat is
c            even then isf must be at least nlat/2. if isym = 1 or 2
c            and nlat is odd then isf must be at least (nlat+1)/2.
c
c     jsf    the second dimension of the array sf as it appears in
c            the program that calls igrades. jsf must be at least nlon.
c
c     br,bi  two or three dimensional arrays (see input parameter nt)
c            that contain vector spherical harmonic coefficients
c            of the vector field (v,w) as computed by subroutine vhaes.
c     ***    br,bi must be computed by vhaes prior to calling igrades.
c
C*PL*ERROR* Comment line too long
c     mdb    the first dimension of the arrays br and bi as it appears in
c            the program that calls igrades (and vhaes). mdb must be at
c            least min0(nlat,nlon/2) if nlon is even or at least
c            min0(nlat,(nlon+1)/2) if nlon is odd.
c
C*PL*ERROR* Comment line too long
c     ndb    the second dimension of the arrays br and bi as it appears in
c            the program that calls igrades (and vhaes). ndb must be at
c            least nlat.
c
c
c  wshses    an array which must be initialized by subroutine igradesi
c            (or equivalently by subroutine shsesi).  once initialized,
c            wshses can be used repeatedly by igrades as long as nlon
c            and nlat remain unchanged.  wshses must not be altered
c            between calls of igrades.
c
c
c  lshses    the dimension of the array wshses as it appears in the
c            program that calls igrades. define
c
c               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd.
c
c
c            then lshses must be greater than or equal to
c
c               (l1*l2*(nlat+nlat-l1+1))/2+nlon+15
c
c     work   a work array that does not have to be saved.
c
c     lwork  the dimension of the array work as it appears in the
c            program that calls igrades. define
c
c               l2 = nlat/2                    if nlat is even or
c               l2 = (nlat+1)/2                if nlat is odd
c               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            if isym = 0 lwork must be greater than or equal to
c
c               nlat*((nt+1)*nlon+2*nt*l1+1)
c
c            if isym > 0 lwork must be greater than or equal to
c
c               (nt+1)*l2*nlon+nlat*(2*nt*l1+1)
c
c
c
c     **************************************************************
c
c     output parameters
c
c
C*PL*ERROR* Comment line too long
c     sf    a two or three dimensional array (see input parameter nt) that
c           contain a scalar field whose gradient is the irrotational
c           component of the vector field (v,w).  the vector spherical
c           harmonic coefficients br,bi were precomputed by subroutine
c           vhaes.  sf(i,j) is given at the gaussian colatitude theta(i)
c           and longitude lambda(j) = (j-1)*2*pi/nlon.  the index ranges
c           are defined at input parameter isym.
c
c
c  ierror   = 0  no errors
c           = 1  error in the specification of nlat
c           = 2  error in the specification of nlon
c           = 3  error in the specification of isym
c           = 4  error in the specification of nt
c           = 5  error in the specification of isf
c           = 6  error in the specification of jsf
c           = 7  error in the specification of mdb
c           = 8  error in the specification of ndb
c           = 9  error in the specification of lshses
c           = 10 error in the specification of lwork
c
c **********************************************************************
c
      SUBROUTINE DIGRADES(NLAT,NLON,ISYM,NT,SF,ISF,JSF,BR,BI,MDB,NDB,
     +                   WSHSES,LSHSES,WORK,LWORK,IERROR)
      DOUBLE PRECISION SF
      DOUBLE PRECISION BR
      DOUBLE PRECISION BI
      DOUBLE PRECISION WSHSES
      DOUBLE PRECISION WORK
      DIMENSION SF(ISF,JSF,NT)
      DIMENSION BR(MDB,NDB,NT),BI(MDB,NDB,NT)
      DIMENSION WSHSES(LSHSES),WORK(LWORK)
c
c     check input parameters
c
      IERROR = 1
      IF (NLAT.LT.3) RETURN
      IERROR = 2
      IF (NLON.LT.4) RETURN
      IERROR = 3
      IF (ISYM.LT.0 .OR. ISYM.GT.2) RETURN
      IERROR = 4
      IF (NT.LT.0) RETURN
      IERROR = 5
      IMID = (NLAT+1)/2
      IF ((ISYM.EQ.0.AND.ISF.LT.NLAT) .OR.
     +    (ISYM.NE.0.AND.ISF.LT.IMID)) RETURN
      IERROR = 6
      IF (JSF.LT.NLON) RETURN
      IERROR = 7
      MMAX = MIN0(NLAT, (NLON+2)/2)
      IF (MDB.LT.MIN0(NLAT, (NLON+1)/2)) RETURN
      IERROR = 8
      IF (NDB.LT.NLAT) RETURN
      IERROR = 9
c
c     verify saved work space length
c
      IMID = (NLAT+1)/2
      LPIMN = (IMID*MMAX* (NLAT+NLAT-MMAX+1))/2
      IF (LSHSES.LT.LPIMN+NLON+15) RETURN
      IERROR = 10
c
c     set minimum and verify unsaved work space
c
      LS = NLAT
      IF (ISYM.GT.0) LS = IMID
      NLN = NT*LS*NLON
c
c     set first dimension for a,b (as requried by shses)
c
      MAB = MIN0(NLAT,NLON/2+1)
      MN = MAB*NLAT*NT
      LWKMIN = NLN + LS*NLON + 2*MN + NLAT
      IF (LWORK.LT.LWKMIN) RETURN
      IERROR = 0
c
c     set work space pointers
c
      IA = 1
      IB = IA + MN
      IS = IB + MN
      IWK = IS + NLAT
      LIWK = LWORK - 2*MN - NLAT
      CALL DIGRDES1(NLAT,NLON,ISYM,NT,SF,ISF,JSF,WORK(IA),WORK(IB),MAB,
     +             WORK(IS),MDB,NDB,BR,BI,WSHSES,LSHSES,WORK(IWK),LIWK,
     +             IERROR)
      RETURN
      END

      SUBROUTINE DIGRDES1(NLAT,NLON,ISYM,NT,SF,ISF,JSF,A,B,MAB,SQNN,MDB,
     +                   NDB,BR,BI,WSHSES,LSHSES,WK,LWK,IERROR)
      DOUBLE PRECISION SF
      DOUBLE PRECISION A
      DOUBLE PRECISION B
      DOUBLE PRECISION SQNN
      DOUBLE PRECISION BR
      DOUBLE PRECISION BI
      DOUBLE PRECISION WSHSES
      DOUBLE PRECISION WK
      DOUBLE PRECISION FN
      DIMENSION SF(ISF,JSF,NT)
      DIMENSION BR(MDB,NDB,NT),BI(MDB,NDB,NT),SQNN(NLAT)
      DIMENSION A(MAB,NLAT,NT),B(MAB,NLAT,NT)
      DIMENSION WSHSES(LSHSES),WK(LWK)
c
c     preset coefficient multiplyers in vector
c
      DO 1 N = 2,NLAT
          FN = DBLE(N-1)
          SQNN(N) = 1.0D0/SQRT(FN* (FN+1.D0))
    1 CONTINUE
c
c     set upper limit for vector m subscript
c
      MMAX = MIN0(NLAT, (NLON+1)/2)
c
c     compute multiple scalar field coefficients
c
      DO 2 K = 1,NT
c
c     preset to 0.0
c
          DO 3 N = 1,NLAT
              DO 4 M = 1,MAB
                  A(M,N,K) = 0.0D0
                  B(M,N,K) = 0.0D0
    4         CONTINUE
    3     CONTINUE
c
c     compute m=0 coefficients
c
          DO 5 N = 2,NLAT
              A(1,N,K) = BR(1,N,K)*SQNN(N)
              B(1,N,K) = BI(1,N,K)*SQNN(N)
    5     CONTINUE
c
c     compute m>0 coefficients
c
          DO 6 M = 2,MMAX
              DO 7 N = M,NLAT
                  A(M,N,K) = SQNN(N)*BR(M,N,K)
                  B(M,N,K) = SQNN(N)*BI(M,N,K)
    7         CONTINUE
    6     CONTINUE
    2 CONTINUE
c
c     scalar sythesize a,b into sf
c
      CALL DSHSES(NLAT,NLON,ISYM,NT,SF,ISF,JSF,A,B,MAB,NLAT,WSHSES,
     +           LSHSES,WK,LWK,IERROR)
      RETURN
      END

C
C	$Id: setr.f,v 1.4 2008-07-27 00:17:25 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE SETR (XMIN,XMAX,YMIN,YMAX,ZMIN,ZMAX,R0)
C
C THIS ROUTINE ESTABLISHES CERTAIN CONSTANTS SO THAT SRFACE
C PRODUCES A PICTURE WHOSE SIZE CHANGES WITH RESPECT TO THE
C VIEWERS DISTANCE FROM THE OBJECT.  IT CAN ALSO BE USED
C WHEN MAKING A MOVIE OF AN OBJECT EVOLVING IN TIME TO KEEP
C IT POSITIONED PROPERLY ON THE SCREEN, SAVING COMPUTER TIME
C IN THE BARGIN.  CALL IT WITH R0 NEGATIVE TO TURN OFF THIS
C FEATURE.
C PARAMETERS
C XMIN,XMAX - RANGE OF X ARRAY THAT WILL BE PASSED TO SRFACE.
C YMIN,YMAX - SAME IDEA, BUT FOR Y.
C ZMIN,ZMAX - SAME IDEA, BUT FOR Z.  IF A MOVIE IS BEING
C             MADE OF AN EVOLVING Z ARRAY, ZMIN AND ZMAX
C             SHOULD CONTAIN RANGE OF THE UNION OF ALL THE Z
C             ARRAYS.  THEY NEED NOT BE EXACT.
C R0        - DISTANCE BETWEEN OBSERVER AND POINT LOOKED AT
C             WHEN THE PICTURE IS TO FILL THE SCREEN WHEN
C             VIEWED FROM THE DIRECTION WHICH MAKES THE PIC-
C             TURE BIGGEST.  IF R0 IS NOT POSITIVE, THEN THE
C             RELATIVE SIZE FEATURE IS TURNED OFF, AND SUB-
C             SEQUENT PICTURES WILL FILL THE SCREEN.
C
      COMMON /SRFBLK/ LIMU(1024) ,LIML(1024) ,CL(41)     ,NCL        ,
     1                LL         ,FACT       ,IROT       ,NDRZ       ,
     2                NUPPER     ,NRSWT      ,BIGD       ,UMIN       ,
     3                UMAX       ,VMIN       ,VMAX       ,RZERO      ,
     4                IOFFP      ,NSPVAL     ,SPVAL      ,BIGEST
      COMMON /PWRZ1S/ XXMIN      ,XXMAX      ,YYMIN      ,YYMAX      ,
     1                ZZMIN      ,ZZMAX      ,DELCRT     ,EYEX       ,
     2                EYEY       ,EYEZ
C
C
      CALL Q8QST4 ('GRAPHX','SRFACE','SETR','VERSION 01')
      IF (R0)  10, 10, 20
   10 NRSWT = 0
      RETURN
   20 NRSWT = 1
      XXMIN = XMIN
      XXMAX = XMAX
      YYMIN = YMIN
      YYMAX = YMAX
      ZZMIN = ZMIN
      ZZMAX = ZMAX
      RZERO = R0
      LL = 0
      XAT = (XXMAX+XXMIN)*.5
      YAT = (YYMAX+YYMIN)*.5
      ZAT = (ZZMAX+ZZMIN)*.5
      ALPHA = -(YYMIN-YAT)/(XXMIN-XAT)
      YEYE = -RZERO/SQRT(1.+ALPHA*ALPHA)
      XEYE = YEYE*ALPHA
      YEYE = YEYE+YAT
      XEYE = XEYE+XAT
      ZEYE = ZAT
      CALL TRN32S (XAT,YAT,ZAT,XEYE,YEYE,ZEYE,0)
      XMN = XXMIN
      XMX = XXMAX
      YMN = YYMIN
      YMX = YYMAX
      ZMN = ZZMIN
      ZMX = ZZMAX
      CALL TRN32S (XMN,YMN,ZAT,UMN,DUMMY,DUMMIE,1)
      CALL TRN32S (XMX,YMN,ZMN,DUMMY,VMN,DUMMIE,1)
      CALL TRN32S (XMX,YMX,ZAT,UMX,DUMMY,DUMMIE,1)
      CALL TRN32S (XMX,YMN,ZMX,DUMMY,VMX,DUMMIE,1)
      UMIN = UMN
      UMAX = UMX
      VMIN = VMN
      VMAX = VMX
      BIGD = SQRT((XXMAX-XXMIN)**2+(YYMAX-YYMIN)**2+(ZZMAX-ZZMIN)**2)*.5
      RETURN
      END

c subroutine lfpt (n,m,theta,cp,pb)
c
c dimension of
c arguments
c                        cp((n/2)+1)
c
c purpose                routine lfpt uses coefficients computed by
c                        routine alfk to compute the single precision
c                        normalized associated legendre function pbar(n,
c                        m,theta) at colatitude theta.
c
c usage                  call lfpt(n,m,theta,cp,pb)
c
c arguments
c
c on input               n
c                          nonnegative integer specifying the degree of
c                          pbar(n,m,theta)
c                        m
c                          is the order of pbar(n,m,theta). m can be
c                          any integer however pbar(n,m,theta) = 0
c                          if abs(m) is greater than n and
c                          pbar(n,m,theta) = (-1)**m*pbar(n,-m,theta)
c                          for negative m.
c
c                        theta
c                          single precision colatitude in radians
c
c                        cp
c                          single precision array of length (n/2)+1
c                          containing coefficients computed by routine
c                          alfk
c
c on output              pb
c                          single precision variable containing
c                          pbar(n,m,theta)
c
c special conditions     calls to routine lfpt must be preceded by an
c                        appropriate call to routine alfk.
c
c precision              single
c
c algorithm              the trigonometric series formula used by
c                        routine lfpt to calculate pbar(n,m,th) at
c                        colatitude th depends on m and n as follows:
c
c                           1) for n even and m even, the formula is
c                              .5*cp(1) plus the sum from k=1 to k=n/2
c                              of cp(k)*cos(2*k*th)
c                           2) for n even and m odd. the formula is
c                              the sum from k=1 to k=n/2 of
c                              cp(k)*sin(2*k*th)
c                           3) for n odd and m even, the formula is
c                              the sum from k=1 to k=(n+1)/2 of
c                              cp(k)*cos((2*k-1)*th)
c                           4) for n odd and m odd, the formula is
c                              the sum from k=1 to k=(n+1)/2 of
c                              cp(k)*sin((2*k-1)*th)
c
c accuracy               comparison between routines lfpt and double
c                        precision dlfpt on the cray1 indicates greater
c                        accuracy for greater values on input parameter
c                        n.  agreement to 13 places was obtained for
c                        n=10 and to 12 places for n=100.
c
c timing                 time per call to routine lfpt is dependent on
c                        the input parameter n.
c
      SUBROUTINE DLFPT(N,M,THETA,CP,PB)
      DOUBLE PRECISION THETA
      DOUBLE PRECISION CP
      DOUBLE PRECISION PB
      DOUBLE PRECISION CDT
      DOUBLE PRECISION SDT
      DOUBLE PRECISION CT
      DOUBLE PRECISION ST
      DOUBLE PRECISION SUM
      DOUBLE PRECISION CTH
      DIMENSION CP(1)
c
      PB = 0.D0
      MA = IABS(M)
      IF (MA.GT.N) RETURN
      IF (N) 10,10,30
   10 IF (MA) 20,20,30
   20 PB = SQRT(.5D0)
      GO TO 140
   30 NP1 = N + 1
      NMOD = MOD(N,2)
      MMOD = MOD(MA,2)
      IF (NMOD) 40,40,90
   40 IF (MMOD) 50,50,70
   50 KDO = N/2 + 1
      CDT = COS(THETA+THETA)
      SDT = SIN(THETA+THETA)
      CT = 1.D0
      ST = 0.D0
      SUM = .5D0*CP(1)
      DO 60 KP1 = 2,KDO
          CTH = CDT*CT - SDT*ST
          ST = SDT*CT + CDT*ST
          CT = CTH
          SUM = SUM + CP(KP1)*CT
   60 CONTINUE
      PB = SUM
      GO TO 140
   70 KDO = N/2
      CDT = COS(THETA+THETA)
      SDT = SIN(THETA+THETA)
      CT = 1.D0
      ST = 0.D0
      SUM = 0.D0
      DO 80 K = 1,KDO
          CTH = CDT*CT - SDT*ST
          ST = SDT*CT + CDT*ST
          CT = CTH
          SUM = SUM + CP(K)*ST
   80 CONTINUE
      PB = SUM
      GO TO 140
   90 KDO = (N+1)/2
      IF (MMOD) 100,100,120
  100 CDT = COS(THETA+THETA)
      SDT = SIN(THETA+THETA)
      CT = COS(THETA)
      ST = -SIN(THETA)
      SUM = 0.D0
      DO 110 K = 1,KDO
          CTH = CDT*CT - SDT*ST
          ST = SDT*CT + CDT*ST
          CT = CTH
          SUM = SUM + CP(K)*CT
  110 CONTINUE
      PB = SUM
      GO TO 140
  120 CDT = COS(THETA+THETA)
      SDT = SIN(THETA+THETA)
      CT = COS(THETA)
      ST = -SIN(THETA)
      SUM = 0.D0
      DO 130 K = 1,KDO
          CTH = CDT*CT - SDT*ST
          ST = SDT*CT + CDT*ST
          CT = CTH
          SUM = SUM + CP(K)*ST
  130 CONTINUE
      PB = SUM
  140 RETURN
      END

      PROGRAM DSEX01D
C
      PARAMETER (NUM=1000, NX=21, NY=21, NZ=21)
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
      DOUBLE PRECISION XI(NUM), YI(NUM), ZI(NUM), U(NUM)
      DOUBLE PRECISION XO(NX),  YO(NY),  ZO(NZ),  OUTPUT(NX,NY,NZ)
      DOUBLE PRECISION XMIN,    YMIN,    ZMIN    
      DOUBLE PRECISION XMAX,    YMAX,    ZMAX
      REAL             XP(NX),  YP(NY),  ZP(NZ),  OUTP(NX,NY,NZ)
      INTEGER I, J, K, IER
C
      DATA XMIN,YMIN,ZMIN/ -2.D0, -2.D0, -2.D0/
      DATA XMAX,YMAX,ZMAX/  2.D0,  2.D0,  2.D0/
C
C  Create random data in three space and define a function.
C  To get this to work on your system, you may have to insert
C  the correct random number generator for your compiler.
C
      DO 10 I=1,NUM
        XI(I) = XMIN+(XMAX-XMIN)*DBLE(DSRND1D())
        YI(I) = YMIN+(YMAX-YMIN)*DBLE(DSRND1D())
        ZI(I) = ZMIN+(ZMAX-ZMIN)*DBLE(DSRND1D())
         U(I) = XI(I)**2 + YI(I)**2 + ZI(I)**2
   10 CONTINUE
C
C  Create the output grid.
C
      DO 102 I=1,NX
        XO(I) = XMIN+(DBLE(I-1)/DBLE(NX-1))*(XMAX-XMIN)
  102 CONTINUE
C
      DO 103 J =1,NY
        YO(J)= YMIN+(DBLE(J-1)/DBLE(NY-1))*(YMAX-YMIN)
  103 CONTINUE
C
      DO 104 K=1,NZ
        ZO(K) = ZMIN+(DBLE(K-1)/DBLE(NZ-1))*(ZMAX-ZMIN)
  104 CONTINUE
C
C  Interpolate.
C
      CALL DSGRID3D(NUM,XI,YI,ZI,U,NX,NY,NZ,XO,YO,ZO,OUTPUT,IER)
      IF (IER .NE. 0) THEN
        WRITE(6,520) IER
  520   FORMAT(' Error ',I3,' returned from DSGRID3D') 
        STOP
      ENDIF
C
C  Pass single precision arrays for plotting an isosurface.
C
      DO 105 I=1,NX
        XP(I) = XO(I)
        DO 106 J=1,NY
          YP(J) = YO(J)
          DO 107 K=1,NZ
            ZP(K) = ZO(K)
            OUTP(I,J,K) = OUTPUT(I,J,K)
  107     CONTINUE
  106   CONTINUE
  105 CONTINUE
C
C  Draw plot.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
      CALL TDEZ3D(NX, NY, NZ, XP, YP, ZP, OUTP, 3.0, 0., 0., 0., 6)
      CALL FRAME
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END
      REAL FUNCTION DSRND1D()
C
C  Portable random number generator.
C
      PARAMETER (MPLIER=16807,MODLUS=2147483647,MOBYMP=127773,
     +           MOMDMP=2836)
C
      INTEGER HVLUE, LVLUE, TESTV, NEXTN
      SAVE    NEXTN
      DATA JSEED,IFRST/123456789,0/
C
      IF (IFRST .EQ. 0) THEN
        NEXTN = JSEED
        IFRST = 1
      ENDIF
C
      HVLUE = NEXTN / MOBYMP
      LVLUE = MOD(NEXTN, MOBYMP)
      TESTV = MPLIER*LVLUE - MOMDMP*HVLUE
      IF (TESTV .GT. 0) THEN
        NEXTN = TESTV
      ELSE
        NEXTN = TESTV + MODLUS
      ENDIF
      DSRND1D = REAL(NEXTN)/REAL(MODLUS)
C
      RETURN
      END

C
C $Id: hlumapeod.f,v 1.13 2008-09-18 00:42:16 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE HLUMAPEOD (NOUT,NSEG,IDLS,IDRS,NPTS,PNTS)
        INTEGER NOUT,NSEG,IDLS,IDRS,NPTS
        REAL    PNTS(*)
        CALL MAPEOD (NOUT,NSEG,IDLS,IDRS,NPTS,PNTS)
        RETURN
      END

C
C $Id: mdpset.f,v 1.10 2008-09-18 00:42:17 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MDPSET (ARG1,ARG2,ARG3,ARG4,ARG5)
C
        CHARACTER*(*)    ARG1
        DOUBLE PRECISION ARG2(2),ARG3(2),ARG4(2),ARG5(2)
C
C Declare required common blocks.  See MAPBDX for descriptions of these
C common blocks and the variables in them.
C
        COMMON /MAPCM4/  GRDR,GRID,GRLA,GRLO,GRPO,OTOL,PDRE,PLA1,PLA2,
     +                   PLA3,PLA4,PLB1,PLB2,PLB3,PLB4,PLNO,PLTO,ROTA,
     +                   SRCH,XLOW,XROW,YBOW,YTOW,IDOT,IDSH,IDTL,ILCW,
     +                   ILTS,JPRJ,ELPF,INTF,LBLF,PRMF
        DOUBLE PRECISION GRDR,GRID,GRLA,GRLO,GRPO,OTOL,PDRE,PLA1,PLA2,
     +                   PLA3,PLA4,PLB1,PLB2,PLB3,PLB4,PLNO,PLTO,ROTA,
     +                   SRCH,XLOW,XROW,YBOW,YTOW
        INTEGER          IDOT,IDSH,IDTL,ILCW,ILTS,JPRJ
        LOGICAL          ELPF,INTF,LBLF,PRMF
        SAVE   /MAPCM4/
C
        COMMON /MAPCM5/  DDCT(5),DDCL(5),LDCT(6),LDCL(6),PDCT(19),
     +                   PDCL(19)
        CHARACTER*2      DDCT,DDCL,LDCT,LDCL,PDCT,PDCL
        SAVE   /MAPCM5/
C
C Declare local variables.
C
        INTEGER          I
C
C Check for an uncleared prior error.
C
        IF (ICFELL('MDPSET - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C Transfer the parameters defining the map limits.
C
        I=IDICTL(ARG1,LDCT,6)
        IF (I.EQ.0) I=IDICTL(ARG1,LDCL,6)
        IF (I.EQ.0) GO TO 901
        ILTS=I
C
        PLA1=ARG2(1)
        PLA2=ARG3(1)
        PLA3=ARG4(1)
        PLA4=ARG5(1)
C
        IF (I.EQ.3) THEN
          PLB1=ARG2(2)
          PLB2=ARG3(2)
          PLB3=ARG4(2)
          PLB4=ARG5(2)
        END IF
C
C Set the flag to indicate that initialization is now required.
C
        INTF=.TRUE.
C
C Done.
C
        RETURN
C
C Error exit.
C
  901   CALL MDPCEM ('MDPSET - UNKNOWN MAP AREA SPECIFIER ',ARG1,2,1)
        RETURN
C
      END

C
C $Id: tditri.f,v 1.4 2008-07-27 00:17:32 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE TDITRI (U,NU,V,NV,W,NW,F,LF1D,LF2D,FISO,
     +                               RTRI,MTRI,NTRI,IRST)
C
        DIMENSION U(NU),V(NV),W(NW),F(LF1D,LF2D,*),RTRI(10,MTRI)
C
C The routine TDITRI, given a 3-dimensional array of function values in
C the array F and a cutoff value FISO, generates a set of triangles
C representing the surface defined by those values and adds them to a
C list of triangles tendered by the user.  The arguments are as follows:
C
C   U is an input array of real values of the independent variable U.
C
C   NU is an input integer specifying the dimension of the array U.
C
C   V is an input array of real values of the independent variable V.
C
C   NV is an input integer specifying the dimension of the array V.
C
C   W is an input array of real values of the independent variable W.
C
C   NW is an input integer specifying the dimension of the array W.
C
C   F is the 3-dimensional real array of function values.  For each I
C   from 1 to NU, each J from 1 to NV, and each K from 1 to NW, F(I,J,K)
C   is the value of the function F at the point (U(I),V(J),W(K)).
C
C   LF1D is an input integer specifying the first (FORTRAN) dimension of
C   the array F.  It must be the case that LF1D is greater than or equal
C   to NU.
C
C   LF2D is an input integer specifying the second (FORTRAN) dimension
C   of the array F.  It must be the case that LF1D is greater than or
C   equal to NV.
C
C   FISO is the cutoff value defining the isosurface.  The object of
C   a call to TDITRI is to generate a set of triangles separating the
C   3-space box within which the function F is defined into two volumes:
C   one where the value of F is less than or equal to FISO and another
C   where the value of F is greater than FISO.
C
C   RTRI is a real array in which a list of triangles is being
C   generated; it is dimensioned 10 x MTRI.  Each 10-word entry in
C   the list consists of the U, V, and W coordinates of each of three
C   points, followed by a rendering style index.
C
C   MTRI is an input integer specifying the second dimension of the
C   array RTRI: the maximum number of triangles the list will hold.
C
C   NTRI is an input/output integer specifying the number of triangles
C   currently in the array RTRI.  Initially, NTRI must be zeroed by the
C   user.  Each call to one of the routines TDSTRI or TDITRI updates the
C   value of NTRI to reflect the number of triangles added to the list.
C
C   IRST is an input integer specifying the rendering style index to be
C   used for all the triangles generated by a particular call to TDITRI.
C   Note that more than one surface can be represented by the triangles
C   in the triangle list and that each surface can be rendered in its
C   own particular style.
C
C This routine deals, one at a time, with each cell of the 3-dimensional
C grid.  The following picture shows the order in which the corners of a
C cell are numbered:
C
C         7-------8
C        /|      /|
C       5-------6 |
C       | |     | |
C       | 3-----|-4
C       |/      |/
C       1-------2
C
C The U, V, and W coordinates defining each of the eight corners of such
C a cell are generated in the arrays BOXU, BOXV, and BOXW; the function
C values at each of those corners are put in BOXF.
C
        DIMENSION BOXU(8),BOXV(8),BOXW(8),BOXF(8)
C
C The arrays IOSU, IOSV, and IOSW specify index offsets to be used in
C setting elements of BOXU, BOXV, BOXW, and BOXF and are defined in a
C DATA statement below.
C
        DIMENSION IOSU(8),IOSV(8),IOSW(8)
C
C Because, at each corner of a cell, the value of F can be either less
C than or equal to FISO or greater than FISO, and because the cell has
C eight corners, there are 256 different cases to be considered.  Each
C of these can be associated with a particular eight-bit binary integer
C (between 0 and 255) in which each bit represents a particular corner
C of the cell; the bit is set to 1 if and only if the function value at
C that corner is less than or equal to FISO.  One need only consider the
C first 128 of these cases: for I greater than 127, case I is equivalent
C to case 255-I ("greater than or equal to" and "less than" are swapped
C with each other).  Observing that case 0 is trivial (no triangles),
C we can then consider only 127 cases numbered 1 through 127.  It turns
C out, by rotating the cell appropriately, each of these 127 cases can
C be reduced to one of 14 basic cases.  For each I, ABS(IACT(I))
C specifies which of the 14 basic cases case I reduces to and the values
C (IPER(L,I),L=1,8) specify which corners of the cell have to be treated
C as corners 1 through 8.  The sign of IACT(I) says whether triangles to
C be generated for case I mirror images of the triangles generated for
C basic case ABS(IACT(I)).
C
        DIMENSION IACT(127),IPER(8,127)
C
C Now, for each value of I from 1 to 14, inclusive, LBEG(I) and LEND(I)
C define the first and last entries in the arrays IP11, IP12, IP21,
C IP22, IP31, and IP32 that pertain to basic case I: for each L between
C LBEG(I) and LEND(I), three triangle corner points are defined -
C one obtained by interpolating between the points IP11(L) and IP12(L),
C another obtained by interpolating between the points IP21(L) and
C IP22(L), and a third obtained by interpolating between the points
C IP31(L) and IP32(L).
C
        DIMENSION LBEG(14),LEND(14)
C
        DIMENSION IP11(52),IP12(52),IP21(52),IP22(52),IP31(52),IP32(52)
C
C Define index offsets for corner points of a grid cell.
C
        DATA IOSU / 0,1,0,1,0,1,0,1 /
        DATA IOSV / 0,0,1,1,0,0,1,1 /
        DATA IOSW / 0,0,0,0,1,1,1,1 /
C
C Define IACT and IPER for 127 cases.
C
        DATA IACT(  1),(IPER(I,  1),I=1,8) /   1 , 1,2,3,4,5,6,7,8 /
        DATA IACT(  2),(IPER(I,  2),I=1,8) /   1 , 2,4,1,3,6,8,5,7 /
        DATA IACT(  3),(IPER(I,  3),I=1,8) /   2 , 1,2,3,4,5,6,7,8 /
        DATA IACT(  4),(IPER(I,  4),I=1,8) /   1 , 3,1,4,2,7,5,8,6 /
        DATA IACT(  5),(IPER(I,  5),I=1,8) /   2 , 3,1,4,2,7,5,8,6 /
        DATA IACT(  6),(IPER(I,  6),I=1,8) /   3 , 1,2,3,4,5,6,7,8 /
        DATA IACT(  7),(IPER(I,  7),I=1,8) /   4 , 1,2,3,4,5,6,7,8 /
        DATA IACT(  8),(IPER(I,  8),I=1,8) /   1 , 4,3,2,1,8,7,6,5 /
        DATA IACT(  9),(IPER(I,  9),I=1,8) /   3 , 3,1,4,2,7,5,8,6 /
        DATA IACT( 10),(IPER(I, 10),I=1,8) /   2 , 2,4,1,3,6,8,5,7 /
        DATA IACT( 11),(IPER(I, 11),I=1,8) /   4 , 2,4,1,3,6,8,5,7 /
        DATA IACT( 12),(IPER(I, 12),I=1,8) /   2 , 4,3,2,1,8,7,6,5 /
        DATA IACT( 13),(IPER(I, 13),I=1,8) /   4 , 3,1,4,2,7,5,8,6 /
        DATA IACT( 14),(IPER(I, 14),I=1,8) /   4 , 4,3,2,1,8,7,6,5 /
        DATA IACT( 15),(IPER(I, 15),I=1,8) /   5 , 1,2,3,4,5,6,7,8 /
        DATA IACT( 16),(IPER(I, 16),I=1,8) /   1 , 5,6,1,2,7,8,3,4 /
        DATA IACT( 17),(IPER(I, 17),I=1,8) /   2 , 5,1,7,3,6,2,8,4 /
        DATA IACT( 18),(IPER(I, 18),I=1,8) /   3 , 6,2,5,1,8,4,7,3 /
        DATA IACT( 19),(IPER(I, 19),I=1,8) /   4 , 1,5,2,6,3,7,4,8 /
        DATA IACT( 20),(IPER(I, 20),I=1,8) /   3 , 7,5,3,1,8,6,4,2 /
        DATA IACT( 21),(IPER(I, 21),I=1,8) /   4 , 1,3,5,7,2,4,6,8 /
        DATA IACT( 22),(IPER(I, 22),I=1,8) /   6 , 1,2,3,4,5,6,7,8 /
        DATA IACT( 23),(IPER(I, 23),I=1,8) /   7 , 1,2,3,4,5,6,7,8 /
        DATA IACT( 24),(IPER(I, 24),I=1,8) /   8 , 1,2,3,4,5,6,7,8 /
        DATA IACT( 25),(IPER(I, 25),I=1,8) /   9 , 1,2,3,4,5,6,7,8 /
        DATA IACT( 26),(IPER(I, 26),I=1,8) /   9 , 2,1,6,5,4,3,8,7 /
        DATA IACT( 27),(IPER(I, 27),I=1,8) /  10 , 1,2,3,4,5,6,7,8 /
        DATA IACT( 28),(IPER(I, 28),I=1,8) /   9 , 3,7,1,5,4,8,2,6 /
        DATA IACT( 29),(IPER(I, 29),I=1,8) /  11 , 1,2,3,4,5,6,7,8 /
        DATA IACT( 30),(IPER(I, 30),I=1,8) /  12 , 1,2,3,4,5,6,7,8 /
        DATA IACT( 31),(IPER(I, 31),I=1,8) /  -4 , 8,6,7,5,4,2,3,1 /
        DATA IACT( 32),(IPER(I, 32),I=1,8) /   1 , 6,8,2,4,5,7,1,3 /
        DATA IACT( 33),(IPER(I, 33),I=1,8) /   3 , 5,6,1,2,7,8,3,4 /
        DATA IACT( 34),(IPER(I, 34),I=1,8) /   2 , 6,2,5,1,8,4,7,3 /
        DATA IACT( 35),(IPER(I, 35),I=1,8) /   4 , 2,1,6,5,4,3,8,7 /
        DATA IACT( 36),(IPER(I, 36),I=1,8) /   8 , 2,4,1,3,6,8,5,7 /
        DATA IACT( 37),(IPER(I, 37),I=1,8) /   9 , 1,5,2,6,3,7,4,8 /
        DATA IACT( 38),(IPER(I, 38),I=1,8) /   9 , 2,4,1,3,6,8,5,7 /
        DATA IACT( 39),(IPER(I, 39),I=1,8) /  11 , 1,5,2,6,3,7,4,8 /
        DATA IACT( 40),(IPER(I, 40),I=1,8) /   3 , 8,4,6,2,7,3,5,1 /
        DATA IACT( 41),(IPER(I, 41),I=1,8) /   6 , 2,4,1,3,6,8,5,7 /
        DATA IACT( 42),(IPER(I, 42),I=1,8) /   4 , 2,6,4,8,1,5,3,7 /
        DATA IACT( 43),(IPER(I, 43),I=1,8) /   7 , 2,4,1,3,6,8,5,7 /
        DATA IACT( 44),(IPER(I, 44),I=1,8) /   9 , 4,2,8,6,3,1,7,5 /
        DATA IACT( 45),(IPER(I, 45),I=1,8) /  12 , 2,4,1,3,6,8,5,7 /
        DATA IACT( 46),(IPER(I, 46),I=1,8) /  10 , 2,4,1,3,6,8,5,7 /
        DATA IACT( 47),(IPER(I, 47),I=1,8) /  -4 , 7,8,5,6,3,4,1,2 /
        DATA IACT( 48),(IPER(I, 48),I=1,8) /   2 , 5,6,1,2,7,8,3,4 /
        DATA IACT( 49),(IPER(I, 49),I=1,8) /   4 , 5,6,1,2,7,8,3,4 /
        DATA IACT( 50),(IPER(I, 50),I=1,8) /   4 , 6,2,5,1,8,4,7,3 /
        DATA IACT( 51),(IPER(I, 51),I=1,8) /   5 , 5,6,1,2,7,8,3,4 /
        DATA IACT( 52),(IPER(I, 52),I=1,8) /   9 , 5,1,7,3,6,2,8,4 /
        DATA IACT( 53),(IPER(I, 53),I=1,8) /  10 , 5,1,7,3,6,2,8,4 /
        DATA IACT( 54),(IPER(I, 54),I=1,8) /  12 , 1,5,2,6,3,7,4,8 /
        DATA IACT( 55),(IPER(I, 55),I=1,8) /  -4 , 8,7,4,3,6,5,2,1 /
        DATA IACT( 56),(IPER(I, 56),I=1,8) /   9 , 6,8,2,4,5,7,1,3 /
        DATA IACT( 57),(IPER(I, 57),I=1,8) /  12 , 2,1,6,5,4,3,8,7 /
        DATA IACT( 58),(IPER(I, 58),I=1,8) /  11 , 2,1,6,5,4,3,8,7 /
        DATA IACT( 59),(IPER(I, 59),I=1,8) /  -4 , 7,3,8,4,5,1,6,2 /
        DATA IACT( 60),(IPER(I, 60),I=1,8) /  13 , 1,2,3,4,5,6,7,8 /
        DATA IACT( 61),(IPER(I, 61),I=1,8) /  -9 , 8,4,6,2,7,3,5,1 /
        DATA IACT( 62),(IPER(I, 62),I=1,8) /  -9 , 7,5,3,1,8,6,4,2 /
        DATA IACT( 63),(IPER(I, 63),I=1,8) /  -2 , 7,8,5,6,3,4,1,2 /
        DATA IACT( 64),(IPER(I, 64),I=1,8) /   1 , 7,8,5,6,3,4,1,2 /
        DATA IACT( 65),(IPER(I, 65),I=1,8) /   3 , 5,1,7,3,6,2,8,4 /
        DATA IACT( 66),(IPER(I, 66),I=1,8) /   8 , 3,1,4,2,7,5,8,6 /
        DATA IACT( 67),(IPER(I, 67),I=1,8) /   9 , 1,3,5,7,2,4,6,8 /
        DATA IACT( 68),(IPER(I, 68),I=1,8) /   2 , 3,7,1,5,4,8,2,6 /
        DATA IACT( 69),(IPER(I, 69),I=1,8) /   4 , 3,7,1,5,4,8,2,6 /
        DATA IACT( 70),(IPER(I, 70),I=1,8) /   9 , 3,1,4,2,7,5,8,6 /
        DATA IACT( 71),(IPER(I, 71),I=1,8) /  10 , 3,1,4,2,7,5,8,6 /
        DATA IACT( 72),(IPER(I, 72),I=1,8) /   3 , 3,4,7,8,1,2,5,6 /
        DATA IACT( 73),(IPER(I, 73),I=1,8) /   6 , 3,1,4,2,7,5,8,6 /
        DATA IACT( 74),(IPER(I, 74),I=1,8) /   9 , 4,8,3,7,2,6,1,5 /
        DATA IACT( 75),(IPER(I, 75),I=1,8) /  12 , 3,1,4,2,7,5,8,6 /
        DATA IACT( 76),(IPER(I, 76),I=1,8) /   4 , 3,4,7,8,1,2,5,6 /
        DATA IACT( 77),(IPER(I, 77),I=1,8) /   7 , 3,1,4,2,7,5,8,6 /
        DATA IACT( 78),(IPER(I, 78),I=1,8) /  11 , 3,1,4,2,7,5,8,6 /
        DATA IACT( 79),(IPER(I, 79),I=1,8) /  -4 , 6,5,8,7,2,1,4,3 /
        DATA IACT( 80),(IPER(I, 80),I=1,8) /   2 , 5,7,6,8,1,3,2,4 /
        DATA IACT( 81),(IPER(I, 81),I=1,8) /   4 , 5,1,7,3,6,2,8,4 /
        DATA IACT( 82),(IPER(I, 82),I=1,8) /   9 , 5,6,1,2,7,8,3,4 /
        DATA IACT( 83),(IPER(I, 83),I=1,8) /  11 , 5,6,1,2,7,8,3,4 /
        DATA IACT( 84),(IPER(I, 84),I=1,8) /   4 , 7,5,3,1,8,6,4,2 /
        DATA IACT( 85),(IPER(I, 85),I=1,8) /   5 , 1,3,5,7,2,4,6,8 /
        DATA IACT( 86),(IPER(I, 86),I=1,8) /  12 , 1,3,5,7,2,4,6,8 /
        DATA IACT( 87),(IPER(I, 87),I=1,8) /  -4 , 8,4,6,2,7,3,5,1 /
        DATA IACT( 88),(IPER(I, 88),I=1,8) /   9 , 7,3,8,4,5,1,6,2 /
        DATA IACT( 89),(IPER(I, 89),I=1,8) /  12 , 3,7,1,5,4,8,2,6 /
        DATA IACT( 90),(IPER(I, 90),I=1,8) /  13 , 1,3,5,7,2,4,6,8 /
        DATA IACT( 91),(IPER(I, 91),I=1,8) /  -9 , 8,7,4,3,6,5,2,1 /
        DATA IACT( 92),(IPER(I, 92),I=1,8) /  10 , 3,7,1,5,4,8,2,6 /
        DATA IACT( 93),(IPER(I, 93),I=1,8) /  -4 , 6,8,2,4,5,7,1,3 /
        DATA IACT( 94),(IPER(I, 94),I=1,8) /  -9 , 6,2,5,1,8,4,7,3 /
        DATA IACT( 95),(IPER(I, 95),I=1,8) /  -2 , 6,8,2,4,5,7,1,3 /
        DATA IACT( 96),(IPER(I, 96),I=1,8) /   3 , 8,6,7,5,4,2,3,1 /
        DATA IACT( 97),(IPER(I, 97),I=1,8) /   6 , 5,6,1,2,7,8,3,4 /
        DATA IACT( 98),(IPER(I, 98),I=1,8) /   9 , 6,5,8,7,2,1,4,3 /
        DATA IACT( 99),(IPER(I, 99),I=1,8) /  12 , 5,6,1,2,7,8,3,4 /
        DATA IACT(100),(IPER(I,100),I=1,8) /   9 , 7,8,5,6,3,4,1,2 /
        DATA IACT(101),(IPER(I,101),I=1,8) /  12 , 5,1,7,3,6,2,8,4 /
        DATA IACT(102),(IPER(I,102),I=1,8) /  13 , 5,1,7,3,6,2,8,4 /
        DATA IACT(103),(IPER(I,103),I=1,8) /  -9 , 8,6,7,5,4,2,3,1 /
        DATA IACT(104),(IPER(I,104),I=1,8) /   6 , 8,7,4,3,6,5,2,1 /
        DATA IACT(105),(IPER(I,105),I=1,8) /  14 , 1,2,3,4,5,6,7,8 /
        DATA IACT(106),(IPER(I,106),I=1,8) /  12 , 8,4,6,2,7,3,5,1 /
        DATA IACT(107),(IPER(I,107),I=1,8) /  -6 , 7,5,3,1,8,6,4,2 /
        DATA IACT(108),(IPER(I,108),I=1,8) /  12 , 8,7,4,3,6,5,2,1 /
        DATA IACT(109),(IPER(I,109),I=1,8) /  -6 , 6,2,5,1,8,4,7,3 /
        DATA IACT(110),(IPER(I,110),I=1,8) /  -9 , 5,7,6,8,1,3,2,4 /
        DATA IACT(111),(IPER(I,111),I=1,8) /  -3 , 7,8,5,6,3,4,1,2 /
        DATA IACT(112),(IPER(I,112),I=1,8) /   4 , 5,7,6,8,1,3,2,4 /
        DATA IACT(113),(IPER(I,113),I=1,8) /   7 , 5,6,1,2,7,8,3,4 /
        DATA IACT(114),(IPER(I,114),I=1,8) /  10 , 5,6,1,2,7,8,3,4 /
        DATA IACT(115),(IPER(I,115),I=1,8) /  -4 , 4,8,3,7,2,6,1,5 /
        DATA IACT(116),(IPER(I,116),I=1,8) /  11 , 5,1,7,3,6,2,8,4 /
        DATA IACT(117),(IPER(I,117),I=1,8) /  -4 , 4,2,8,6,3,1,7,5 /
        DATA IACT(118),(IPER(I,118),I=1,8) /  -9 , 4,3,2,1,8,7,6,5 /
        DATA IACT(119),(IPER(I,119),I=1,8) /  -2 , 4,8,3,7,2,6,1,5 /
        DATA IACT(120),(IPER(I,120),I=1,8) /  12 , 8,6,7,5,4,2,3,1 /
        DATA IACT(121),(IPER(I,121),I=1,8) /  -6 , 4,3,2,1,8,7,6,5 /
        DATA IACT(122),(IPER(I,122),I=1,8) /  -9 , 3,4,7,8,1,2,5,6 /
        DATA IACT(123),(IPER(I,123),I=1,8) /  -3 , 7,3,8,4,5,1,6,2 /
        DATA IACT(124),(IPER(I,124),I=1,8) /  -9 , 2,6,4,8,1,5,3,7 /
        DATA IACT(125),(IPER(I,125),I=1,8) /  -3 , 6,8,2,4,5,7,1,3 /
        DATA IACT(126),(IPER(I,126),I=1,8) /  -8 , 4,3,2,1,8,7,6,5 /
        DATA IACT(127),(IPER(I,127),I=1,8) /  -1 , 8,6,7,5,4,2,3,1 /
C
C Define LBEG and LEND for each of 14 basic cases.
C
        DATA LBEG /  1, 2, 4, 8,11,13,20,24,26,31,35,39,45,49 /
        DATA LEND /  1, 3, 7,10,12,19,23,25,30,34,38,44,48,52 /
C
C Define corner point data.
C
        DATA (IP11(I),I= 1,13) / 1,1,1,1,1,2,2,1,2,2,1,2,1 /
        DATA (IP12(I),I= 1,13) / 2,3,3,2,3,6,6,5,6,4,5,6,2 /
        DATA (IP21(I),I= 1,13) / 1,1,2,2,2,2,3,2,3,3,2,4,2 /
        DATA (IP22(I),I= 1,13) / 3,5,6,6,6,4,4,6,4,4,6,8,6 /
        DATA (IP31(I),I= 1,13) / 1,2,2,1,3,3,3,3,3,2,3,3,1 /
        DATA (IP32(I),I= 1,13) / 5,6,4,3,7,4,7,7,7,6,7,7,3 /
C
        DATA (IP11(I),I=14,26) / 1,1,5,2,2,2,3,2,2,2,1,2,1 /
        DATA (IP12(I),I=14,26) / 3,3,6,6,6,4,7,6,6,4,5,4,2 /
        DATA (IP21(I),I=14,26) / 2,5,2,3,3,3,5,3,3,3,5,4,2 /
        DATA (IP22(I),I=14,26) / 6,6,6,7,4,4,7,7,4,4,7,8,4 /
        DATA (IP31(I),I=14,26) / 5,1,5,5,3,2,5,5,3,2,5,3,5 /
        DATA (IP32(I),I=14,26) / 6,5,7,7,7,6,6,6,7,6,6,4,6 /
C
        DATA (IP11(I),I=27,39) / 5,4,1,3,1,1,1,2,1,1,1,1,1 /
        DATA (IP12(I),I=27,39) / 6,8,3,4,3,3,3,6,2,2,2,2,3 /
        DATA (IP21(I),I=27,39) / 2,5,5,5,5,5,2,4,2,4,3,5,5 /
        DATA (IP22(I),I=27,39) / 4,7,7,7,7,6,6,8,4,8,7,7,6 /
        DATA (IP31(I),I=27,39) / 4,5,3,4,5,2,3,3,4,3,5,5,1 /
        DATA (IP32(I),I=27,39) / 8,6,4,8,6,6,4,4,8,7,7,6,5 /
C
        DATA (IP11(I),I=40,52) / 1,1,2,3,3,1,2,1,2,1,2,2,3 /
        DATA (IP12(I),I=40,52) / 2,3,6,7,7,3,4,5,6,2,4,6,7 /
        DATA (IP21(I),I=40,52) / 2,2,4,5,5,2,4,5,5,1,4,5,7 /
        DATA (IP22(I),I=40,52) / 6,6,8,6,7,4,8,7,7,3,8,6,8 /
        DATA (IP31(I),I=40,52) / 1,5,5,4,5,3,3,2,6,1,3,6,5 /
        DATA (IP32(I),I=40,52) / 3,6,6,8,6,7,7,6,8,5,4,8,7 /
C
C The following arithmetic statement functions are used to generate the
C U, V, and W coordinates of the point lying between box corners ICN1
C and ICN2 where the interpolated value of the function F is equal to
C FISO.
C
        UINT(ICN1,ICN2)=BOXU(ICN1)+(BOXU(ICN2)-BOXU(ICN1))*
     +                             (FISO      -BOXF(ICN1))/
     +                             (BOXF(ICN2)-BOXF(ICN1))
C
        VINT(ICN1,ICN2)=BOXV(ICN1)+(BOXV(ICN2)-BOXV(ICN1))*
     +                             (FISO      -BOXF(ICN1))/
     +                             (BOXF(ICN2)-BOXF(ICN1))
C
        WINT(ICN1,ICN2)=BOXW(ICN1)+(BOXW(ICN2)-BOXW(ICN1))*
     +                             (FISO      -BOXF(ICN1))/
     +                             (BOXF(ICN2)-BOXF(ICN1))
C
C Get the real equivalent of the rendering style index.
C
        RRST=REAL(IRST)
C
C Loop through the cells of the 3-dimensional grid, determining what
C case applies to each cell and generating triangles in the triangle
C list to represent each cell through which the isosurface passes.
C Note that care is taken to trace each triangle counterclockwise as
C viewed from the side toward which the function value increases;
C this is important, as it enables the renderer to tell which side
C of a triangle is being looked at.
C
        DO 106 I=1,NU-1
          DO 105 J=1,NV-1
            DO 104 K=1,NW-1
              ICSE=0
              IF (F(I  ,J  ,K  ).LE.FISO) ICSE=ICSE+1
              IF (F(I+1,J  ,K  ).LE.FISO) ICSE=ICSE+2
              IF (F(I  ,J+1,K  ).LE.FISO) ICSE=ICSE+4
              IF (F(I+1,J+1,K  ).LE.FISO) ICSE=ICSE+8
              IF (F(I  ,J  ,K+1).LE.FISO) ICSE=ICSE+16
              IF (F(I+1,J  ,K+1).LE.FISO) ICSE=ICSE+32
              IF (F(I  ,J+1,K+1).LE.FISO) ICSE=ICSE+64
              IF (F(I+1,J+1,K+1).LE.FISO) ICSE=ICSE+128
              IF (ICSE.GT.0.AND.ICSE.LT.255) THEN
                IF (ICSE.LE.127) THEN
                  ITST=IACT(ICSE)
                ELSE
                  ICSE=255-ICSE
                  ITST=-IACT(ICSE)
                END IF
                DO 101 IPNT=1,8
                  BOXU(IPNT)=U(I+IOSU(IPER(IPNT,ICSE)))
                  BOXV(IPNT)=V(J+IOSV(IPER(IPNT,ICSE)))
                  BOXW(IPNT)=W(K+IOSW(IPER(IPNT,ICSE)))
                  BOXF(IPNT)=F(I+IOSU(IPER(IPNT,ICSE)),
     +                         J+IOSV(IPER(IPNT,ICSE)),
     +                         K+IOSW(IPER(IPNT,ICSE)))
  101           CONTINUE
                ISWP=(1-SIGN(1,ITST))/2
                NTRS=NTRI+1
                ITST=ABS(ITST)
                DO 102 L=LBEG(ITST),LEND(ITST)
                  IF (NTRI.LT.MTRI) THEN
                    NTRI=NTRI+1
                    RTRI(1,NTRI)=UINT(IP11(L),IP12(L))
                    RTRI(2,NTRI)=VINT(IP11(L),IP12(L))
                    RTRI(3,NTRI)=WINT(IP11(L),IP12(L))
                    RTRI(4,NTRI)=UINT(IP21(L),IP22(L))
                    RTRI(5,NTRI)=VINT(IP21(L),IP22(L))
                    RTRI(6,NTRI)=WINT(IP21(L),IP22(L))
                    RTRI(7,NTRI)=UINT(IP31(L),IP32(L))
                    RTRI(8,NTRI)=VINT(IP31(L),IP32(L))
                    RTRI(9,NTRI)=WINT(IP31(L),IP32(L))
                    RTRI(10,NTRI)=RRST
                  END IF
  102           CONTINUE
                IF (ISWP.NE.0) THEN
                  DO 103 ISWP=NTRS,NTRI
                    TMP1=RTRI(1,ISWP)
                    TMP2=RTRI(2,ISWP)
                    TMP3=RTRI(3,ISWP)
                    RTRI(1,ISWP)=RTRI(4,ISWP)
                    RTRI(2,ISWP)=RTRI(5,ISWP)
                    RTRI(3,ISWP)=RTRI(6,ISWP)
                    RTRI(4,ISWP)=TMP1
                    RTRI(5,ISWP)=TMP2
                    RTRI(6,ISWP)=TMP3
  103             CONTINUE
                END IF
              END IF
  104       CONTINUE
  105     CONTINUE
  106   CONTINUE
C
C Done.
C
        RETURN
C
      END

C
C	$Id: gbytes.f,v 1.4 2008-07-27 12:23:45 haley Exp $
C                                                                      
C			     Copyright (C)  2000
C	     University Corporation for Atmospheric Research
C			     All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C

      SUBROUTINE GBYTES (NPACK,ISAM,IBIT,NBITS,NSKIP,ITER)
C
C     This subroutine unpacks bit chunks from the input array NPACK
C     into the output array ISAM.  "ITER" bit chunks of length
C     "NBITS" with "NSKIP" bits being skipped between each bit
C     chunk in the input array are unpacked into ISAM.  Each
C     bit chunk in the input array it unpacked into a separate
C     word in ISAM, right-justified with zero-fill.  Initially
C     "IBIT" bits will be skipped at the beginning of the
C     input array before unpacking.
C
C
C     NPACK
C       Address of the first word of the array to be unpacked.
C
C     ISAM
C       Array to receive the unpacked bit chunks.  They will be
C       right-justified with zero-fill in this array.  ISAM
C       should be dimensioned for ITER.
C
C     IBIT
C       A bit-count offset to be used before the first bit chunk is
C       unpacked.  For example, if IBIT=3 and NBITS=5, then
C       3 bits in NPACK will be skipped and the next 5 bits
C       will be unpacked into ISAM(1).
C
C     NBITS
C       The number of bits in each bit chunk to be unpacked.
C
C     NSKIP
C       The number of bits to skip between each bit chunk to be
C       unpacked (after the first bit chunk has been unpacked.)
C
C     ITER
C       The number of bit chunks to be unpacked.
C
C
C Example:
C
C      CALL GBYTES(NPB,ISB,3,6,9,2)
C
C In this call, 3 bits would be skipped at the beginning of NPB;
C the next 6 bits would be unpacked into ISB(1) right-justified with
C zero-fill; 9 bits would be skipped in NPB; the next six bits of
C NPB would be unpacked into ISB(2) right-justified with zero-fill.
C
      IMPLICIT INTEGER (A-Z)
      DIMENSION NPACK(*),ISAM(*),MASK(64)
      SAVE NCALL,BPERI,MASK
      DATA NCALL/0/
C
C     Do initialization which needs to be done only on the
C     first call.
C
      IF (NCALL .EQ. 0) THEN
C
C       Get number of bits in an integer (word size)
C
        BPERI = I1MACH(5)
C
C       Set up masks
C
        MASK(1) = 1
        DO 10 I=2,BPERI
        MASK(I) = IOR(ISHIFT(MASK(I-1),1),1)
   10   CONTINUE
        NCALL = 1
      ENDIF
C
C     Check if NBITS is valid
C
      IF (NBITS.LE.BPERI .AND. NBITS.GT.0) GO TO 20
      WRITE(6,*) ' GBYTES--NBITS OUT OF RANGE'
      STOP
   20 CONTINUE
C
C     Define bit mask to be used for the words in ISAM
C
      MSK1 = MASK(NBITS)
C
C     Calculate the total number of bits used in the input array
C     by a bit-chunk move.
C
      BITSEP = NBITS+NSKIP
C
C     Fill the output array
C
      DO 50 I=1,ITER
C
C     Calculate the bit position in the input array where the bits
C     are to be unpacked.
C
      BPO = IBIT+(I-1)*BITSEP
C
C     Calculate the word position in the input array where the bits
C     are to be unpacked.
C
      WPO = BPO/BPERI+1
C
C     Calculate the number of bits in the current input word which
C     are to be unpacked.
C
      RBITS = BPERI*WPO-BPO
C
C     Compute shift.
C
      SHFT = NBITS-RBITS
C
C     Treat the case where there are enough bits in the current
C     word of the input word to be unpacked.
C
      IF (SHFT.GT.0) GO TO 30
      ISAM(I) = IAND(MSK1,ISHIFT(NPACK(WPO),SHFT))
      GO TO 40
C
C     Treat the case where the bits to be unpacked cross a word
C     boundary.
C
   30 CONTINUE
      BTMPL = ISHIFT(IAND(NPACK(WPO),MASK(RBITS)),SHFT)
      BTMPR = IAND(ISHIFT(NPACK(WPO+1),SHFT-BPERI),MASK(SHFT))
      ISAM(I) = IOR(BTMPL,BTMPR)
   40 CONTINUE
   50 CONTINUE
C
      RETURN
      END

C
C       $Id: stcycl.f,v 1.10 2008-07-27 00:17:27 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE STCYCL(U,V)
C
C Check for cyclic condition
C
      DIMENSION  U(IUD1,*), V(IVD1,*)
C
C ---------------------------------------------------------------------
C
C NOTE:
C Since implicit typing is used for all real and integer variables
C a consistent length convention has been adopted to help clarify the
C significance of the variables encountered in the code for this 
C utility. All local variable and subroutine parameter identifiers 
C are limited to 1,2,or 3 characters. Four character names identify  
C members of common blocks. Five and 6 character variable names 
C denote PARAMETER constants or subroutine or function names.
C
C Declare the ST common blocks.
C
      PARAMETER (IPLVLS = 256)
C
C Integer and real common block variables
C
C
      COMMON / STPAR /
     +                IUD1       ,IVD1       ,IPD1       ,
     +                IXD1       ,IXDM       ,IYD1       ,IYDN       ,
     +                IXM1       ,IYM1       ,IXM2       ,IYM2       ,
     +                IWKD       ,IWKU       ,ISET       ,IERR       ,
     +                IXIN       ,IYIN       ,IMSK       ,ICPM       ,
     +                NLVL       ,IPAI       ,ICTV       ,WDLV       ,
     +                UVMN       ,UVMX       ,PMIN       ,PMAX       ,
     +                IPLR       ,ISST       ,
     +                ICLR(IPLVLS)           ,TVLU(IPLVLS)
C
      COMMON / STTRAN /
     +                UVPS       ,
     +                UVPL       ,UVPR       ,UVPB       ,UVPT       ,
     +                UWDL       ,UWDR       ,UWDB       ,UWDT       ,
     +                UXC1       ,UXCM       ,UYC1       ,UYCN 
C
C Stream algorithm parameters
C
      COMMON / STSTRM /
     +                ISGD       ,IAGD       ,RARL       ,ICKP       ,
     +                ICKX       ,ITRP       ,ICYK       ,RVNL       ,
     +                ISVF       ,RUSV       ,RVSV       ,RNDA       ,
     +                ISPC       ,RPSV       ,RCDS       ,RSSP       ,
     +                RDFM       ,RSMD       ,RAMD       ,IGBS       ,
     +                ISTM       ,RVRL       ,RVFR       ,RVRM       ,
     +                IVPO       ,RAFR       ,RDMX       ,RDMN
C
C Text related parameters
C Note: graphical text output is not yet implemented for the
C       Streamline utility.
C
      COMMON / STTXP /
     +                FCWM    ,ICSZ    ,
     +                FMNS    ,FMNX    ,FMNY    ,IMNP    ,IMNC  ,
     +                FMXS    ,FMXX    ,FMXY    ,IMXP    ,IMXC  ,
     +                FZFS    ,FZFX    ,FZFY    ,IZFP    ,IZFC  ,
     +                FILS    ,FILX    ,FILY    ,IILP    ,IILC 
C
C Character variable declartions
C
      CHARACTER*160 CSTR
      PARAMETER (IPCHSZ=80)
      CHARACTER*(IPCHSZ)  CMNT,CMXT,CZFT,CILT
C
C Text string parameters
C
      COMMON / STCHAR / CSTR,CMNT,CMXT,CZFT,CILT
C
      SAVE /STPAR/, /STTRAN/, /STSTRM/, /STTXP/, /STCHAR/
C
C Internal buffer lengths
C
C IPNPTS - Number of points in the point buffer -- not less than 3
C IPLSTL - Streamline-crossover-check circular list length
C IPGRCT - Number of groups supported for area masking
C
      PARAMETER (IPNPTS = 256, IPLSTL = 750, IPGRCT = 64)
C
C ---------------------------------------------------------------------
C
      DO  10 J=IYD1,IYDN
C
         IF (U(IXD1,J).NE.U(IXDM,J) .OR. V(IXD1,J).NE.V(IXDM,J)) THEN
C
C Must not be cyclic: change the parameter and set IERR to -1
C
            ICYK = 0
            IERR = -1
            RETURN
         END IF
C
 10   CONTINUE
C
      RETURN
C
C-----------------------------------------------------------------------
C REVISION HISTORY
C
C OCTOBER, 1979     FIRST ADDED TO ULIB
C
C OCTOBER, 1980     ADDED BUGS SECTION
C
C JUNE, 1984        REMOVED STATEMENT FUNCTIONS ANDF AND ORF,
C                   CONVERTED TO FORTRAN77 AND GKS.
C
C MAY, 1988         CHANGED CODE (IN SUBROUTINE STDRAW) WHICH PROTECTS
C                   UX ELEMENTS FROM BECOMING ZERO.  THE ORIGINAL CODE
C                   CAUSED UNDERFLOW ON IBM MACHINES.  (DJK)
C
C MARCH, 1990       FIXED SAVING AND RESTORING OF SET CALL.
C-----------------------------------------------------------------------
C
      END

      PROGRAM TCONAN
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C OPEN GKS, OPEN WORKSTATION OF TYPE 1, ACTIVATE WORKSTATION
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C INVOKE DEMO DRIVER
C
      CALL CONAN(IERR)
C
C DEACTIVATE AND CLOSE WORKSTATION, CLOSE GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END
C
      SUBROUTINE CONAN (IERROR)
C
C PURPOSE                To provide a simple demonstration of
C                        standard contouring of irregularly spaced
C                        data using the CONRAN package.
C
C USAGE                  CALL CONAN (IERROR)
C
C ARGUMENTS
C
C ON OUTPUT              IERROR
C                          An integer variable
C                          = 0, if the test was successful,
C                          > 0, the test was not successful,
C                               and the error number corresponds
C                               to the number in the CONRAN listing.
C
C I/O                    If the test is successful, the message
C
C              CONRAN TEST EXECUTED--SEE PLOTS TO CERTIFY
C
C                        is printed on unit 6.  In addition, 2
C                        frames are produced on the machine graphics
C                        device.  The first plot is the contour plot.
C                        The second plot shows the triangulation of the
C                        data.  In order to determine if the test
C                        was successful, it is necessary to examine
C                        the plots.
C
C PRECISION              Single
C
C LANGUAGE               FORTRAN 77
C
C REQUIRED ROUTINES      CONRAN, CONTERP, CONCOM, DASHCHAR
C
C REQUIRED GKS LEVEL     0A
C
C ALGORITHM              A sparse dataset is defined in DATA statements.
C                        Options are selected to produce a plot title
C                        and display the triangulation generated by the
C                        interpolation routines.  Default options
C                        include a message at the bottom of the plot
C                        and a plot perimter.
C
C                        This is the standard version of the CONRAN
C                        family of utilities.
C
C                        The version of the package which produces
C                        smoothed contours is created by simply
C                        loading this package with DASHSMTH rather
C                        than DASHCHAR.
C
      COMMON /RANINT/ IRANMJ, IRANMN, IRANTX
C
C Set up the scratch arrays needed by CONRAN.
C
      DIMENSION WK(221),IWK(744),SCR(1600)
C
C Dimension arrays to hold the sparse dataset.
C
      DIMENSION XD(17),YD(17),ZD(17)
C
C Define the dataset.
C
      DATA XD(1),XD(2),XD(3),XD(4),XD(5),XD(6),XD(7),XD(8),
     1     XD(9),XD(10),XD(11),XD(12),XD(13),XD(14),XD(15),
     2     XD(16),XD(17)
     3     /3.,3.,10.,18.,18.,10.,10.,5.,1.,15.,20.,
     4          5.,15.,10.,7.,13.,16./
C
      DATA YD(1),YD(2),YD(3),YD(4),YD(5),YD(6),YD(7),YD(8),
     1     YD(9),YD(10),YD(11),YD(12),YD(13),YD(14),YD(15),
     2     YD(16),YD(17)
     3    /3.,18.,18.,3.,18.,10.,1.,5.,10.,5.,10.,
     4          15.,15.,15.,20.,20.,8./
C
      DATA ZD(1),ZD(2),ZD(3),ZD(4),ZD(5),ZD(6),ZD(7),ZD(8),
     1     ZD(9),ZD(10),ZD(11),ZD(12),ZD(13),ZD(14),ZD(15),
     2     ZD(16),ZD(17)
     3    /25.,25.,25.,25.,25.,-5.,1.,1.,1.,1.,1.,
     4          1.,1.,1.,1.,1.,25./
C
C Define the number of points in the dataset.
C
      DATA NDP/17/
C
C Set the PORT error handling routine to the recover mode.
C
      CALL ENTSR(IROLD,1)
C
C Define the plot title.
C
      CALL CONOP4('TLE=ON','DEMONSTRATION PLOT FOR CONRAN',29,0)
C
C Test for an error condition.
C
      IF (NERRO(IERROR).NE.0) GO TO 100
C
C No error encountered.
C
C
C Set the option to generate the triangulation display.
C
      CALL CONOP1('TRI=ON')
C
C Again, test for an error condition.
C
      IF (NERRO(IERROR).NE.0) GO TO 100
C
C No error encountered.
C
C Call CONRAN to contour the data.
C
      CALL CONRAN(XD,YD,ZD,NDP,WK,IWK,SCR)
C
C Again, test for an error condition.
C
      IF (NERRO(IERROR).NE.0) GO TO 100
C
C No error encountered.
C
C
C Advance the frame.  CONRAN does not do so internally.
C
        CALL FRAME
C
C Print the successful completion message.
C
      WRITE(6,10)
 10   FORMAT(' CONRAN TEST EXECUTED--SEE PLOTS TO CERTIFY')
      RETURN
C
C If an error was encountered call the PORT error print routine.
C This is only necessary if you are in recover mode, else the message
C is printed automatically.
C
 100  CALL EPRIN
      RETURN
      END

C
C	$Id: csnbcnt.f,v 1.5 2008-07-27 03:10:07 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      INTEGER FUNCTION CSNBCNT (LPL,LPTR)
      INTEGER LPL, LPTR(*)
C
C***********************************************************
C
C                                              From STRIPACK
C                                            Robert J. Renka
C                                  Dept. of Computer Science
C                                       Univ. of North Texas
C                                           renka@cs.unt.edu
C                                                   07/15/96
C
C   This function returns the number of neighbors of a node
C N0 in a triangulation created by Subroutine CSTRMESH.
C
C   This function is identical to the similarly named
C function in TRIPACK.
C
C
C On input:
C
C       LPL = LIST pointer to the last neighbor of N0 --
C             LPL = LEND(N0).
C
C       LPTR = Array of pointers associated with LIST.
C
C Input parameters are not altered by this function.
C
C On output:
C
C       CSNBCNT = Number of neighbors of N0.
C
C Modules required by CSNBCNT:  None
C
C***********************************************************
C
      INTEGER K, LP
C
C Local parameters:
C
C K =  Counter for computing the number of neighbors
C LP = LIST pointer
C
      LP = LPL
      K = 1
C
    1 LP = LPTR(LP)
        IF (LP .EQ. LPL) GO TO 2
        K = K + 1
        GO TO 1
C
    2 CSNBCNT = K
      RETURN
      END

C
C	$Id: g01flb.f,v 1.6 2008-07-27 00:21:05 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE G01FLB(GKSERR)
C
C  Write the metafile record out to the disk.
C
C  OUTPUT
C    GKSERR -- An error status flag.
C
C  All data is type integer unless otherwise indicated.
C
      IMPLICIT INTEGER (A-Z)
C
      include 'g01prm.h'
      include 'g01io.h'
C
      DIMENSION   FLAGS(12)
      CHARACTER*1 DNAME
C
C  Initialize flags array.
C
      DATA FLAGS( 1),FLAGS( 2),FLAGS( 3),FLAGS( 4)/0,0,0,0/
      DATA FLAGS( 5),FLAGS( 6),FLAGS( 7),FLAGS( 8)/0,0,0,0/
      DATA FLAGS( 9),FLAGS(10),FLAGS(11),FLAGS(12)/0,0,0,0/
C
C  Define the buffer reset point and clear the new frame flag.
C
      DATA BFREST,CLEAR/32,0/
C
C  Set the bit length for the ID part of a record, the number of bits per
C  byte, the field size for the record bit start for the record byte
C  length and the field size for the record byte length.
C
      DATA IDLEN,BYTSIZ,SIZST,SIZSZ/32,8,0,16/
C
C  Set the data type start bit in record, the data type length,
C  the new frame bit start bit, the new frame length.
C
      DATA MDTST,MDTSZ,MNFST,MNFSZ/16,4,20,1/
C
C  Enter the byte count.
C
      BCOUNT = (MBFPOS - IDLEN) / BYTSIZ
C
C  If the byte count is odd, then the final CGM element has an odd byte
C  count, so we should add a byte for the pad byte.
C
      IF (MOD(BCOUNT,2) .EQ. 1) THEN
        BCOUNT = BCOUNT+1
      ENDIF
C
C  Return if nothing in buffer.
C
      IF (BCOUNT .LE. 0) RETURN
      CALL SBYTES(MOUTBF,BCOUNT,SIZST,SIZSZ,0,1)
C
C  Enter the data type id.
C
      CALL SBYTES(MOUTBF,MDTYPE,MDTST,MDTSZ,0,1)
C
C  Put away new frame, begin metafile, and end metafile bits,
C  and then clear them.
C
      FLAGS(1) = MNFFLG
      FLAGS(2) = MBMFLG
      FLAGS(3) = MEMFLG
      CALL SBYTES(MOUTBF,FLAGS,MNFST,MNFSZ,0,12)
      MNFFLG = CLEAR
      MBMFLG = CLEAR
      MEMFLG = CLEAR
C
C  Write out the record.
C
      CALL G01MIO (3, MFGLUN, DNAME, MOUTBF, MOBFSZ, GKSERR)
      MRECNM = MRECNM + 1
C
C  Flush the system-level output buffer.
C
      CALL G01MIO (7, MFGLUN, DNAME, MOUTBF, MOBFSZ, GKSERR)
C
C  Reset the record pointer.
C
      MBFPOS = BFREST
C
      RETURN
      END

C
C $Id: nnuser_f.f,v 1.5 2008-07-27 03:10:13 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE NNSETC(PNAM,CVAL)
C
      CHARACTER*(*) PNAM,CVAL
C
      ILEN = LEN(CVAL)
      CALL FNNSETC(PNAM,CVAL,ILEN)
C
      RETURN
      END
      SUBROUTINE NNGETC(PNAM,CVAL)
C
      CHARACTER*(*) PNAM,CVAL
C
      ILEN = LEN(CVAL)
      CALL FNNGETC(PNAM,CVAL,ILEN)
C
      RETURN
      END

C
C	$Id: gzn2wy.f,v 1.6 2008-07-27 00:21:04 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GZN2WY(N,P,Q)
C
C  This subroutine takes the N points in the real array P,
C  which are assumed to be in NDC coordinates, and, using
C  the current normalization transformation, converts them
C  into world coordinates and stores them in Q.
C  This subroutine operates on Y-coordinates.
C
C
      include 'gkscom.h'
C
      INTEGER N
      REAL P(N),Q(N)
      ICNT  = CNT+1
      TMP1 = NTWN(ICNT,3)
      TMP2 = NTWN(ICNT,4)
      TMP3 = NTVP(ICNT,3)
      TMP4 = NTVP(ICNT,4)
      IF ((TMP3.EQ.TMP1) .AND. (TMP4.EQ.TMP2)) THEN
        DO 210 I=1,N
          Q(I) = P(I)
  210   CONTINUE
      ELSE
        SCALE = (TMP2-TMP1)/(TMP4-TMP3)
        DO 200 I=1,N
          Q(I) = TMP1+(P(I)-TMP3)*SCALE
  200   CONTINUE
      ENDIF
C
      RETURN
      END

      SUBROUTINE STZRQF( M, N, A, LDA, TAU, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      INTEGER            INFO, LDA, M, N
*     ..
*     .. Array Arguments ..
      REAL               A( LDA, * ), TAU( * )
*     ..
*
*  Purpose
*  =======
*
*  This routine is deprecated and has been replaced by routine STZRZF.
*
*  STZRQF reduces the M-by-N ( M<=N ) real upper trapezoidal matrix A
*  to upper triangular form by means of orthogonal transformations.
*
*  The upper trapezoidal matrix A is factored as
*
*     A = ( R  0 ) * Z,
*
*  where Z is an N-by-N orthogonal matrix and R is an M-by-M upper
*  triangular matrix.
*
*  Arguments
*  =========
*
*  M       (input) INTEGER
*          The number of rows of the matrix A.  M >= 0.
*
*  N       (input) INTEGER
*          The number of columns of the matrix A.  N >= M.
*
*  A       (input/output) REAL array, dimension (LDA,N)
*          On entry, the leading M-by-N upper trapezoidal part of the
*          array A must contain the matrix to be factorized.
*          On exit, the leading M-by-M upper triangular part of A
*          contains the upper triangular matrix R, and elements M+1 to
*          N of the first M rows of A, with the array TAU, represent the
*          orthogonal matrix Z as a product of M elementary reflectors.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(1,M).
*
*  TAU     (output) REAL array, dimension (M)
*          The scalar factors of the elementary reflectors.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*
*  Further Details
*  ===============
*
*  The factorization is obtained by Householder's method.  The kth
*  transformation matrix, Z( k ), which is used to introduce zeros into
*  the ( m - k + 1 )th row of A, is given in the form
*
*     Z( k ) = ( I     0   ),
*              ( 0  T( k ) )
*
*  where
*
*     T( k ) = I - tau*u( k )*u( k )',   u( k ) = (   1    ),
*                                                 (   0    )
*                                                 ( z( k ) )
*
*  tau is a scalar and z( k ) is an ( n - m ) element vector.
*  tau and z( k ) are chosen to annihilate the elements of the kth row
*  of X.
*
*  The scalar tau is returned in the kth element of TAU and the vector
*  u( k ) in the kth row of A, such that the elements of z( k ) are
*  in  a( k, m + 1 ), ..., a( k, n ). The elements of R are returned in
*  the upper triangular part of A.
*
*  Z is given by
*
*     Z =  Z( 1 ) * Z( 2 ) * ... * Z( m ).
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ONE, ZERO
      PARAMETER          ( ONE = 1.0E+0, ZERO = 0.0E+0 )
*     ..
*     .. Local Scalars ..
      INTEGER            I, K, M1
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN
*     ..
*     .. External Subroutines ..
      EXTERNAL           SAXPY, SCOPY, SGEMV, SGER, SLARFG, XERBLA
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      IF( M.LT.0 ) THEN
         INFO = -1
      ELSE IF( N.LT.M ) THEN
         INFO = -2
      ELSE IF( LDA.LT.MAX( 1, M ) ) THEN
         INFO = -4
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'STZRQF', -INFO )
         RETURN
      END IF
*
*     Perform the factorization.
*
      IF( M.EQ.0 )
     $   RETURN
      IF( M.EQ.N ) THEN
         DO 10 I = 1, N
            TAU( I ) = ZERO
   10    CONTINUE
      ELSE
         M1 = MIN( M+1, N )
         DO 20 K = M, 1, -1
*
*           Use a Householder reflection to zero the kth row of A.
*           First set up the reflection.
*
            CALL SLARFG( N-M+1, A( K, K ), A( K, M1 ), LDA, TAU( K ) )
*
            IF( ( TAU( K ).NE.ZERO ) .AND. ( K.GT.1 ) ) THEN
*
*              We now perform the operation  A := A*P( k ).
*
*              Use the first ( k - 1 ) elements of TAU to store  a( k ),
*              where  a( k ) consists of the first ( k - 1 ) elements of
*              the  kth column  of  A.  Also  let  B  denote  the  first
*              ( k - 1 ) rows of the last ( n - m ) columns of A.
*
               CALL SCOPY( K-1, A( 1, K ), 1, TAU, 1 )
*
*              Form   w = a( k ) + B*z( k )  in TAU.
*
               CALL SGEMV( 'No transpose', K-1, N-M, ONE, A( 1, M1 ),
     $                     LDA, A( K, M1 ), LDA, ONE, TAU, 1 )
*
*              Now form  a( k ) := a( k ) - tau*w
*              and       B      := B      - tau*w*z( k )'.
*
               CALL SAXPY( K-1, -TAU( K ), TAU, 1, A( 1, K ), 1 )
               CALL SGER( K-1, N-M, -TAU( K ), TAU, 1, A( K, M1 ), LDA,
     $                    A( 1, M1 ), LDA )
            END IF
   20    CONTINUE
      END IF
*
      RETURN
*
*     End of STZRQF
*
      END

      PROGRAM CSEX02
C
C  Show the effects of changing the weighting array.
C
C  The number of input data points.
C
      PARAMETER (NDATA=6)
C
C  The number of output data points.
C
      PARAMETER (NX=101)
C
C  The maximum number of knots used in any call.
C
      PARAMETER (NCF=5)
C
C  The size of the workspace.
C
      PARAMETER (NWRK=NCF*(NCF+3))
C
C  Array dimensions.
C
      DIMENSION XDATA(1,NDATA),YDATA(NDATA),XDATAT(NDATA)
      DIMENSION WTS(NDATA),WORK(NWRK)
      DIMENSION XO(NX),Y1(NX),Y2(NX),Y3(NX)
C
C  Initialize the weight array so that all input points are
C  weighted equally.
C
      DATA WTS/1.0, 1.0, 1.0, 1.0, 1.0, 1.0/
C
C  Specify the input data.
C
      DATA XDATA(1,1),XDATA(1,2),XDATA(1,3)/0.0, 0.2, 0.4/
      DATA XDATA(1,4),XDATA(1,5),XDATA(1,6)/0.6, 0.8, 1.0/
      DATA YDATA/0.0, 1.0, -0.7, -0.2, -0.1, 0.0/
C
C  Define the output coordinates.
C
      XINC = 1./REAL(NX-1)
      DO 10 I=1,NX
        XO(I) = (I-1)*XINC
   10 CONTINUE
C
C  Calculate the approximating curve with all weights equal.
C
      SSMTH = 0.
      NDERIV = 0
      CALL CSA1XS (NDATA,XDATA,YDATA,WTS,NCF,
     +             SSMTH,NDERIV,NX,XO,Y1,NWRK,WORK,IER)       
      IF (IER .NE. 0) THEN
        WRITE(6,520) IER
  520   FORMAT(' Error ',I3,' returned from CSA1XS')
        STOP
      ENDIF
C
C  Calculate the approximating curve with the second input coordinate
C  weighted as half the other weights.
C
      WTS(2) = 0.5
      CALL CSA1XS (NDATA,XDATA,YDATA,WTS,NCF,
     +             SSMTH,NDERIV,NX,XO,Y2,NWRK,WORK,IER)       
      IF (IER .NE. 0) THEN
        WRITE(6,520) IER
        STOP
      ENDIF
C
C  Calculate the approximating curve with the second input coordinate
C  ignored (i.e. with a weight of zero).
C
      WTS(2) = 0.0
      CALL CSA1XS (NDATA,XDATA,YDATA,WTS,NCF,
     +             SSMTH,NDERIV,NX,XO,Y3,NWRK,WORK,IER)       
      IF (IER .NE. 0) THEN
        WRITE(6,520) IER
        STOP
      ENDIF
C
C  Draw a plot of the approximation curves and mark the original points.
C
      DO 30 I=1,NDATA
        XDATAT(I) = XDATA(1,I)
   30 CONTINUE
      CALL DRWFT1(NDATA,XDATAT,YDATA,NX,XO,Y1,Y2,Y3)
C
      STOP
      END
      SUBROUTINE DRWFT1(NUMIN,X,Y,NUMOUT,XO,Y1,Y2,Y3)
C
C  This subroutine uses NCAR Graphics to plot curves.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C  Vertical position for initial curve.
C
      DATA YPOS_TOP/0.88/
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C  Define a color table.
C
      CALL GSCR(IWKID, 0, 1.0, 1.0, 1.0)
      CALL GSCR(IWKID, 1, 0.0, 0.0, 0.0)
      CALL GSCR(IWKID, 2, 1.0, 0.0, 0.0)
      CALL GSCR(IWKID, 3, 0.0, 1.0, 0.0)
      CALL GSCR(IWKID, 4, 0.0, 0.0, 1.0)
      CALL GSCLIP(0)
C
C  Plot the main title.
C
      CALL PLCHHQ(0.50,0.95,':F25:Effect of data weights',
     +            0.030,0.,0.)
C
C  Draw a background grid for the first curve.
C
      YB = -1.0
      YT =  1.0
      CALL BKGFT1(YPOS_TOP,'Weights = (1., 1., 1., 1., 1., 1.)',YB,YT)
      CALL GRIDAL(5,5,4,1,1,1,10,0.0,YB)
C
C  Graph the approximation curve where all input coordinates were
C  wieghted equally.
C
      CALL GPL(NUMOUT,XO,Y1)
C
C  Mark the original data points.
C
      CALL GSMKSC(2.)
      CALL GSPMCI(4)
      CALL GPM(NUMIN,X,Y)
C
C  Graph the approximation curve where the second input coordinate was
C  given a weight of 0.5.
C
      CALL BKGFT1(YPOS_TOP-0.3,
     +            'Weights = (1., .5, 1., 1., 1., 1.)',YB,YT)
      CALL GRIDAL(5,5,4,1,1,1,10,0.0,YB)
      CALL GPL(NUMOUT,XO,Y2)
      CALL GPM(NUMIN,X,Y)
C
C  Graph the approximation curve where the second input coordinate was
C  given a weight of 0.0 .
C
      CALL BKGFT1(YPOS_TOP-0.6,
     +            'Weights = (1., 0., 1., 1., 1., 1.)',YB,YT)
      CALL GRIDAL(5,5,4,1,1,1,10,0.0,YB)
      CALL GPL(NUMOUT,XO,Y3)
      CALL GPM(NUMIN,X,Y)
      CALL FRAME
C
      CALL GDAWK(IWKID)
      CALL GCLWK(IWKID)
      CALL GCLKS
C
      RETURN
      END
      SUBROUTINE BKGFT1(YPOS,LABEL,YB,YT)
C
C  This subroutine draws a background grid.
C
      DIMENSION XX(2),YY(2)
      CHARACTER*(*) LABEL
C
      CALL SET(0.,1.,0.,1.,0.,1.,0.,1.,1)
C
C  Plot the curve label using font 21 (Helvetica).
C
      CALL PCSETI('FN',21)
      CALL PLCHHQ(0.65,YPOS - 0.03,LABEL,0.023,0.,0.)
      CALL SET(0.13,0.93,YPOS-0.2,YPOS,0.0,1., YB, YT, 1)
C
C  Draw a horizontal line at Y=0. using color index 2.
C
      XX(1) = 0.
      XX(2) = 1.
      YY(1) = 0.
      YY(2) = 0.
      CALL GSPLCI(2)
      CALL GPL(2,XX,YY)
      CALL GSPLCI(1)
C
C  Set Gridal parameters.
C
C
C   Set LTY to indicate that the Plotchar routine PLCHHQ should be used.
C
      CALL GASETI('LTY',1)
C
C   Size and format for X axis labels.
C
      CALL GASETR('XLS',0.02)
      CALL GASETC('XLF','(F3.1)')
C
C   Size and format for Y axis labels.
C
      CALL GASETR('YLS',0.02)
      CALL GASETC('YLF','(F5.1)')
C
C   Length of major tick marks for the X and Y axes.
C
      CALL GASETR('XMJ',0.02)
      CALL GASETR('YMJ',0.02)
C
      RETURN
      END

C
C	$Id: wmchbg.f,v 1.6 2008-07-27 00:17:36 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE WMCHBG(X,Y,STR,SIZ)
C
C  Draw the label with an optional surrounding box on
C  a character-by-character basis for characters in STR.
C
      include 'wmcomn.h'
C
      CHARACTER*(*) STR
      CHARACTER*1 CTMP
      DIMENSION XBB(5),YBB(5)
C
      CALL PCGETI('TE - save text extent computation flag',ITEOLD)
      CALL PCGETI('SF - shadow flag',ISF)
      CALL PCGETI('SC - shadow color',ISC)
      CALL PCGETR('SX - shadow X offset',OSX)
      CALL PCGETR('SY - shadow Y offset',OSY)
      CALL PCGETI('CC - character color',ICC)
      CALL PCGETI('OF - outline flag',IOF)
      CALL PCGETI('OC - outline color',IOC)
      CALL PCGETI('FN - font number',IFNO)
C
C  Get starting coordinate for input string.
C
      CALL PCSETI('FN - font number',22)
      CALL PCSETI('TE - compute text extent information',1)
      CALL PLCHHQ(X,Y,STR,SIZ,360.,0.)
      CALL PCGETR('XB - beginning X point for plotting string',XBEG)
      CALL PCGETR('YC - beginning Y point for plotting string',YCEN)
C
      LLIM = LEN(STR)
      IF (IRLBKC .GE. 0) THEN
C
C  Plot background boxes for non-blank characters.
C
        DO 10 I=1,LLIM
          CTMP = STR(I:I)
          CALL PLCHHQ (XBEG,YCEN,CTMP,SIZ,360.,-1.)
          IF (CTMP .NE. ' ') THEN
            CALL PCGETR ('DL',XL)
            CALL PCGETR ('DR',XR)
            CALL PCGETR ('DB',YB)
            CALL PCGETR ('DT',YT)
            
            XBB(1) = (XBEG-XL)-CTYMRG
            YBB(1) = (YCEN+YT)+CTYMRG
            XBB(2) = (XBEG+XR)+CTYMRG
            YBB(2) = (YCEN+YT)+CTYMRG
            XBB(3) = (XBEG+XR)+CTYMRG
            YBB(3) = (YCEN-YB)-CTYMRG
            XBB(4) = (XBEG-XL)-CTYMRG
            YBB(4) = (YCEN-YB)-CTYMRG
            XBB(5) = XBB(1)
            YBB(5) = YBB(1)
            CALL GQFACI(IER,IFACO)
            CALL GSFACI(IRLBKC)
            CALL GFA(5,XBB,YBB)
            CALL GSFACI(IFACO)
          ENDIF
          CALL PCGETR ('XE',XEND)
          XBEG = XEND
   10   CONTINUE
      ENDIF
C
      CALL PCSETI('SF - shadow flag',0)
      IF (IRLLSC .GE. 0) THEN
        CALL PCSETI('SF - shadow flag',1)
        CALL PCSETI('SC - shadow color',IRLLSC)
        CALL PCSETR('SX - shadow X offset',-.14)
        CALL PCSETR('SY - shadow Y offset',-.13)
      ENDIF
      CALL PCSETI('OF - outline flag',0)
      IF (IRLOUC .GE. 0) THEN
        CALL PCSETI('OF - outline flag',1)
        CALL PCSETI('OC - outline color',IRLOUC)
      ENDIF
      CALL PCSETI('CC - character color',IFGTRG)
      CALL PLCHHQ (X,Y,STR,SIZ,0.,0.)
C
C  Restore original attributes.
C
      CALL PCSETI('TE',ITEOLD)
      CALL PCSETI('FN',IFNO)
      CALL PCSETI('SF - shadow flag',ISF)
      CALL PCSETI('SC - shadow color',ISC)
      CALL PCSETR('SX - shadow X offset',OSX)
      CALL PCSETR('SY - shadow Y offset',OSY)
      CALL PCSETI('OF - outline flag',IOF)
      CALL PCSETI('OC - outline color',IOC)
      CALL PCSETI('CC - character color',ICC)
C
      RETURN
      END

C
C $Id: displa.f,v 1.6 2008-07-27 00:14:36 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE DISPLA (LFRA,LROW,LTYP)
C
C The subroutine DISPLA resets the parameters IFRA, IROW, and/or LLUX
C and LLUY.
C
      IF (LFRA.NE.0) CALL AGSETI ('FRAM.', MAX(1,MIN(3,LFRA)))
C
      IF (LROW.NE.0) CALL AGSETI ('ROW .',LROW)
C
      IF (LTYP.EQ.0) RETURN
C
      ITYP=MAX(1,MIN(4,LTYP))
      CALL AGSETI ('X/LOGA.',   (1-ITYP)/2)
      CALL AGSETI ('Y/LOGA.',MOD(1-ITYP,2))
C
      RETURN
C
      END

      SUBROUTINE CSYRK ( UPLO, TRANS, N, K, ALPHA, A, LDA,
     $                   BETA, C, LDC )
*     .. Scalar Arguments ..
      CHARACTER*1        UPLO, TRANS
      INTEGER            N, K, LDA, LDC
      COMPLEX            ALPHA, BETA
*     .. Array Arguments ..
      COMPLEX            A( LDA, * ), C( LDC, * )
*     ..
*
*  Purpose
*  =======
*
*  CSYRK  performs one of the symmetric rank k operations
*
*     C := alpha*A*A' + beta*C,
*
*  or
*
*     C := alpha*A'*A + beta*C,
*
*  where  alpha and beta  are scalars,  C is an  n by n symmetric matrix
*  and  A  is an  n by k  matrix in the first case and a  k by n  matrix
*  in the second case.
*
*  Parameters
*  ==========
*
*  UPLO   - CHARACTER*1.
*           On  entry,   UPLO  specifies  whether  the  upper  or  lower
*           triangular  part  of the  array  C  is to be  referenced  as
*           follows:
*
*              UPLO = 'U' or 'u'   Only the  upper triangular part of  C
*                                  is to be referenced.
*
*              UPLO = 'L' or 'l'   Only the  lower triangular part of  C
*                                  is to be referenced.
*
*           Unchanged on exit.
*
*  TRANS  - CHARACTER*1.
*           On entry,  TRANS  specifies the operation to be performed as
*           follows:
*
*              TRANS = 'N' or 'n'   C := alpha*A*A' + beta*C.
*
*              TRANS = 'T' or 't'   C := alpha*A'*A + beta*C.
*
*           Unchanged on exit.
*
*  N      - INTEGER.
*           On entry,  N specifies the order of the matrix C.  N must be
*           at least zero.
*           Unchanged on exit.
*
*  K      - INTEGER.
*           On entry with  TRANS = 'N' or 'n',  K  specifies  the number
*           of  columns   of  the   matrix   A,   and  on   entry   with
*           TRANS = 'T' or 't',  K  specifies  the number of rows of the
*           matrix A.  K must be at least zero.
*           Unchanged on exit.
*
*  ALPHA  - COMPLEX         .
*           On entry, ALPHA specifies the scalar alpha.
*           Unchanged on exit.
*
*  A      - COMPLEX          array of DIMENSION ( LDA, ka ), where ka is
*           k  when  TRANS = 'N' or 'n',  and is  n  otherwise.
*           Before entry with  TRANS = 'N' or 'n',  the  leading  n by k
*           part of the array  A  must contain the matrix  A,  otherwise
*           the leading  k by n  part of the array  A  must contain  the
*           matrix A.
*           Unchanged on exit.
*
*  LDA    - INTEGER.
*           On entry, LDA specifies the first dimension of A as declared
*           in  the  calling  (sub)  program.   When  TRANS = 'N' or 'n'
*           then  LDA must be at least  max( 1, n ), otherwise  LDA must
*           be at least  max( 1, k ).
*           Unchanged on exit.
*
*  BETA   - COMPLEX         .
*           On entry, BETA specifies the scalar beta.
*           Unchanged on exit.
*
*  C      - COMPLEX          array of DIMENSION ( LDC, n ).
*           Before entry  with  UPLO = 'U' or 'u',  the leading  n by n
*           upper triangular part of the array C must contain the upper
*           triangular part  of the  symmetric matrix  and the strictly
*           lower triangular part of C is not referenced.  On exit, the
*           upper triangular part of the array  C is overwritten by the
*           upper triangular part of the updated matrix.
*           Before entry  with  UPLO = 'L' or 'l',  the leading  n by n
*           lower triangular part of the array C must contain the lower
*           triangular part  of the  symmetric matrix  and the strictly
*           upper triangular part of C is not referenced.  On exit, the
*           lower triangular part of the array  C is overwritten by the
*           lower triangular part of the updated matrix.
*
*  LDC    - INTEGER.
*           On entry, LDC specifies the first dimension of C as declared
*           in  the  calling  (sub)  program.   LDC  must  be  at  least
*           max( 1, n ).
*           Unchanged on exit.
*
*
*  Level 3 Blas routine.
*
*  -- Written on 8-February-1989.
*     Jack Dongarra, Argonne National Laboratory.
*     Iain Duff, AERE Harwell.
*     Jeremy Du Croz, Numerical Algorithms Group Ltd.
*     Sven Hammarling, Numerical Algorithms Group Ltd.
*
*
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     .. External Subroutines ..
      EXTERNAL           XERBLA
*     .. Intrinsic Functions ..
      INTRINSIC          MAX
*     .. Local Scalars ..
      LOGICAL            UPPER
      INTEGER            I, INFO, J, L, NROWA
      COMPLEX            TEMP
*     .. Parameters ..
      COMPLEX            ONE
      PARAMETER        ( ONE  = ( 1.0E+0, 0.0E+0 ) )
      COMPLEX            ZERO
      PARAMETER        ( ZERO = ( 0.0E+0, 0.0E+0 ) )
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      IF( LSAME( TRANS, 'N' ) )THEN
         NROWA = N
      ELSE
         NROWA = K
      END IF
      UPPER = LSAME( UPLO, 'U' )
*
      INFO = 0
      IF(      ( .NOT.UPPER               ).AND.
     $         ( .NOT.LSAME( UPLO , 'L' ) )      )THEN
         INFO = 1
      ELSE IF( ( .NOT.LSAME( TRANS, 'N' ) ).AND.
     $         ( .NOT.LSAME( TRANS, 'T' ) )      )THEN
         INFO = 2
      ELSE IF( N  .LT.0               )THEN
         INFO = 3
      ELSE IF( K  .LT.0               )THEN
         INFO = 4
      ELSE IF( LDA.LT.MAX( 1, NROWA ) )THEN
         INFO = 7
      ELSE IF( LDC.LT.MAX( 1, N     ) )THEN
         INFO = 10
      END IF
      IF( INFO.NE.0 )THEN
         CALL XERBLA( 'CSYRK ', INFO )
         RETURN
      END IF
*
*     Quick return if possible.
*
      IF( ( N.EQ.0 ).OR.
     $    ( ( ( ALPHA.EQ.ZERO ).OR.( K.EQ.0 ) ).AND.( BETA.EQ.ONE ) ) )
     $   RETURN
*
*     And when  alpha.eq.zero.
*
      IF( ALPHA.EQ.ZERO )THEN
         IF( UPPER )THEN
            IF( BETA.EQ.ZERO )THEN
               DO 20, J = 1, N
                  DO 10, I = 1, J
                     C( I, J ) = ZERO
   10             CONTINUE
   20          CONTINUE
            ELSE
               DO 40, J = 1, N
                  DO 30, I = 1, J
                     C( I, J ) = BETA*C( I, J )
   30             CONTINUE
   40          CONTINUE
            END IF
         ELSE
            IF( BETA.EQ.ZERO )THEN
               DO 60, J = 1, N
                  DO 50, I = J, N
                     C( I, J ) = ZERO
   50             CONTINUE
   60          CONTINUE
            ELSE
               DO 80, J = 1, N
                  DO 70, I = J, N
                     C( I, J ) = BETA*C( I, J )
   70             CONTINUE
   80          CONTINUE
            END IF
         END IF
         RETURN
      END IF
*
*     Start the operations.
*
      IF( LSAME( TRANS, 'N' ) )THEN
*
*        Form  C := alpha*A*A' + beta*C.
*
         IF( UPPER )THEN
            DO 130, J = 1, N
               IF( BETA.EQ.ZERO )THEN
                  DO 90, I = 1, J
                     C( I, J ) = ZERO
   90             CONTINUE
               ELSE IF( BETA.NE.ONE )THEN
                  DO 100, I = 1, J
                     C( I, J ) = BETA*C( I, J )
  100             CONTINUE
               END IF
               DO 120, L = 1, K
                  IF( A( J, L ).NE.ZERO )THEN
                     TEMP = ALPHA*A( J, L )
                     DO 110, I = 1, J
                        C( I, J ) = C( I, J ) + TEMP*A( I, L )
  110                CONTINUE
                  END IF
  120          CONTINUE
  130       CONTINUE
         ELSE
            DO 180, J = 1, N
               IF( BETA.EQ.ZERO )THEN
                  DO 140, I = J, N
                     C( I, J ) = ZERO
  140             CONTINUE
               ELSE IF( BETA.NE.ONE )THEN
                  DO 150, I = J, N
                     C( I, J ) = BETA*C( I, J )
  150             CONTINUE
               END IF
               DO 170, L = 1, K
                  IF( A( J, L ).NE.ZERO )THEN
                     TEMP      = ALPHA*A( J, L )
                     DO 160, I = J, N
                        C( I, J ) = C( I, J ) + TEMP*A( I, L )
  160                CONTINUE
                  END IF
  170          CONTINUE
  180       CONTINUE
         END IF
      ELSE
*
*        Form  C := alpha*A'*A + beta*C.
*
         IF( UPPER )THEN
            DO 210, J = 1, N
               DO 200, I = 1, J
                  TEMP = ZERO
                  DO 190, L = 1, K
                     TEMP = TEMP + A( L, I )*A( L, J )
  190             CONTINUE
                  IF( BETA.EQ.ZERO )THEN
                     C( I, J ) = ALPHA*TEMP
                  ELSE
                     C( I, J ) = ALPHA*TEMP + BETA*C( I, J )
                  END IF
  200          CONTINUE
  210       CONTINUE
         ELSE
            DO 240, J = 1, N
               DO 230, I = J, N
                  TEMP = ZERO
                  DO 220, L = 1, K
                     TEMP = TEMP + A( L, I )*A( L, J )
  220             CONTINUE
                  IF( BETA.EQ.ZERO )THEN
                     C( I, J ) = ALPHA*TEMP
                  ELSE
                     C( I, J ) = ALPHA*TEMP + BETA*C( I, J )
                  END IF
  230          CONTINUE
  240       CONTINUE
         END IF
      END IF
*
      RETURN
*
*     End of CSYRK .
*
      END

C
C	$Id: wmgetc.f,v 1.5 2008-07-27 00:17:36 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE WMGETC (CNP,CVP)
C
      SAVE
C
      CHARACTER*(*) CNP,CVP
C
C  This subroutine is called to retrieve the character value of a
C  specified parameter.
C
C  CNP is the name of the parameter whose value is to be retrieved.
C
C  CVP is a character variable in which the desired value is to be
C  returned by WMGETC.
C
C Declare a local character variable in which to form an error message.
C
      CHARACTER*80 CTM
C
      include 'wmcomn.h'
C
C  Do a call forcing a BLOCKDATA to be loaded from a binary library.
C
      CALL WMBLDA
C
C Check for an uncleared prior error.
C
      IF (ICFELL('WMGETC - Uncleared prior error',1) .NE. 0) RETURN
C
C Check for a parameter name that is too short.
C
      IF (LEN(CNP) .LT. 3) THEN
        CTM(1:36)='WMGETC - Parameter name too short - '
        CTM(37:36+LEN(CNP)) = CNP
        CALL SETER (CTM(1:36+LEN(CNP)), 1, 1)
        RETURN
      ENDIF
C
C Get the appropriate parameter value.
C
      IF (CNP(1:3).EQ.'FRO' .OR. CNP(1:3).EQ.'fro' .OR.
     +    CNP(1:3).EQ.'Fro') THEN
        IF (IFRONT .EQ. 1) THEN
          CVP = 'COLD'
        ELSE IF (IFRONT .EQ. 2) THEN
          CVP = 'WARM'
        ELSE IF (IFRONT .EQ. 3) THEN
          CVP = 'STATIONARY'
        ELSE IF (IFRONT .EQ. 4) THEN
          CVP = 'OCCLUDED'
        ELSE
          CTM(1:42) = 'WMGETC - Parameter value out of range for '
          CTM(43:45) = CNP(1:3)
          CALL SETER (CTM(1:45), 2, 1)
          GO TO 110
        ENDIF
        GO TO 110
      ELSE
        CTM(1:36) = 'WMGETC - Parameter name not known - '
        CTM(37:39) = CNP(1:3)
        CALL SETER (CTM(1:39), 5, 1)
        GO TO 110
      ENDIF
C
  110 CONTINUE
      RETURN
      END

C
C	$Id: csscoord.f,v 1.5 2008-07-27 03:10:07 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CSSCOORD (PX,PY,PZ, PLAT,PLON,PNRM)
      REAL PX, PY, PZ, PLAT, PLON, PNRM
C
C***********************************************************
C
C                                              From STRIPACK
C                                            Robert J. Renka
C                                  Dept. of Computer Science
C                                       Univ. of North Texas
C                                           renka@cs.unt.edu
C                                                   08/27/90
C
C   This subroutine converts a point P from Cartesian coor-
C dinates to spherical coordinates.
C
C
C On input:
C
C       PX,PY,PZ = Cartesian coordinates of P.
C
C Input parameters are not altered by this routine.
C
C On output:
C
C       PLAT = Latitude of P in the range -PI/2 to PI/2, or
C              0 if PNRM = 0.  PLAT should be scaled by
C              180/PI to obtain the value in degrees.
C
C       PLON = Longitude of P in the range -PI to PI, or 0
C              if P lies on the Z-axis.  PLON should be
C              scaled by 180/PI to obtain the value in
C              degrees.
C
C       PNRM = Magnitude (Euclidean norm) of P.
C
C Modules required by CSSCOORD:  None
C
C Intrinsic functions called by CSSCOORD:  ASIN, ATAN2, SQRT
C
C***********************************************************
C
      PNRM = SQRT(PX*PX + PY*PY + PZ*PZ)
      IF (PX .NE. 0.D0  .OR.  PY .NE. 0.D0) THEN
        PLON = ATAN2(PY,PX)
      ELSE
        PLON = 0.D0
      ENDIF
      IF (PNRM .NE. 0.D0) THEN
        PLAT = ASIN(PZ/PNRM)
      ELSE
        PLAT = 0.D0
      ENDIF
      RETURN
      END

C
C	$Id: gactm.f,v 1.5 2008-07-27 00:20:56 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GACTM(MINP,X0,Y0,DX,DY,PHI,SX,SY,SW,MOUT)
C
C  ACCUMULATE TRANSFORMATION MATRIX
C
      INTEGER EACTM
      PARAMETER (EACTM=106)
C
      REAL X0,Y0,DX,DY,PHI,MINP(2,3),MOUT(2,3)
      INTEGER SW
C
C  Check if GKS is in the proper state.
C
      CALL GZCKST(8,EACTM,IER)
      IF (IER .NE. 0) RETURN
C
C  The transformation takes place in NDC space, so do the
C  appropriate conversions.
C
      IF (SW .EQ. 0) THEN
        CALL GZW2NX(1,X0,XN0)
        CALL GZW2NY(1,Y0,YN0)
        CALL GZW2NX(1,DX,DTX)
        CALL GZW2NX(1,DY,DTY)
        CALL GZW2NX(1,0.,D0X)
        CALL GZW2NX(1,0.,D0Y)
        DNX = DTX - D0X
        DNY = DTY - D0Y
      ELSE
        XN0 = X0
        YN0 = Y0
        DNX = DX
        DNY = DY
      ENDIF        
C
C  Calculate the new transformtion matrix.
C
      IF (PHI .EQ. 0.) THEN
        MOUT(1,1) = SX*MINP(1,1)
        MOUT(1,2) = SX*MINP(1,2)
        MOUT(1,3) = SX*MINP(1,3)+DNX+XN0-XN0*SX
        MOUT(2,1) = SY*MINP(2,1)
        MOUT(2,2) = SY*MINP(2,2)
        MOUT(2,3) = SY*MINP(2,3)+DNY+YN0-YN0*SY
        GO TO 10
      ELSE
        CPHI = COS(PHI)
        SPHI = SIN(PHI)
C
        T11 = SX*CPHI
        T12 = -SY*SPHI
        T13 = DNX+XN0-XN0*SX*CPHI+YN0*SY*SPHI
        T21 = SX*SPHI
        T22 = SY*CPHI
        T23 = DNY+YN0-XN0*SX*SPHI-YN0*SY*CPHI
        MOUT(1,1) =  T11*MINP(1,1)+T12*MINP(2,1)
        MOUT(1,2) =  T11*MINP(1,2)+T12*MINP(2,2)
        MOUT(1,3) =  T11*MINP(1,3)+T12*MINP(2,3)+T13
        MOUT(2,1) =  T21*MINP(1,1)+T22*MINP(2,1)
        MOUT(2,2) =  T21*MINP(1,2)+T22*MINP(2,2)
        MOUT(2,3) =  T21*MINP(1,3)+T22*MINP(2,3)+T23
        GO TO 10
      ENDIF
C
   10 CONTINUE
      RETURN
      END

C
C $Id: mdpin2.f,v 1.8 2008-09-18 00:42:17 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MDPIN2 (TST1,TST2,TST3)
        REAL TST1,TST2,TST3
        TST1=1.
        TST2=TST1+1.E-10
        TST3=TST2+1.E-10
        RETURN
      END

C
C;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
C;                                                                      
C;                Copyright (C)  1996                                   
C;        University Corporation for Atmospheric Research               
C;                All Rights Reserved                                   
C;                                                                      
C;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
C 
C    File:       vc05f.f
C 
C    Author: Lynn Hermanson
C            National Center for Atmospheric Research
C            PO 3000, Boulder, Colorado
C  
C    Date:       April 11, 1996
C 
C    Description: Given a simple mathematically generated data set,
C                 which looks like the intersection of two vector fields
C                 with opposite directions,this program produces three
C                 plot frames which demonstrate the use of VectorPlot;1st-
C                 default resources, 2nd- overlayed on a world map, 3rd-
C                 overlayed on an orthographic projection of the globe
C                 centered on the north pole covering 90 to 40 degrees
C                 north latitude.
C 
C   Begin by generating the data set called "increasingvectors".
C   The values in the array "U" are defined to be the magnitude of the 
C   x component of the vectors.  The values in the array "V" are
C   defined to be the magnitude of the y component of the vectors. The
C   location of the vectors corresponds to the indices of the arrays.
C   Each index pair will eventually correspond to a latitude,longitude
C   location on a map. 
C ;;********* see resource file vc05.res ******

      external NhlFAppClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFCairoWindowWorkstationClass
      external NhlFMapPlotClass
      external NhlFVectorFieldClass
      external NhlFVectorPlotClass

      integer appid,wid,mapid,dataid,vcid
      integer srlist, ierr

      parameter(M=25,N=25)
      real U(M,N),V(M,N)

      integer len_dims(2) 
      real x,y
      integer i,j
      character*7  wks_type

      wks_type = "x11"

      DO 100 i= 1,25
         DO 200 j= 1,25
          x =  2.5*(i + 1)/1.4142
          y =  2.5*(j + 1)/1.4142
          U(i,j) = x
          V(i,j) = y
200   CONTINUE
100   CONTINUE

C Initialize the high level utility library

       call NhlFInitialize

C  Next,
C  create an application context. Set the app dir to the current
C  directory so the application looks for a resource file (vc05.res)
C  in the working directory. The necessary 
C  resources will be set in this program as each object is created.

C  Setup to choose the type of output workstation for all 3 frames.
C  Choose to display output to an X11 workstation.
C  Change the output from the
C  default colorMap (random sequence of colors) to a sequence
C  of colors so that vectors of increasing magnitude will move from
C  to cooler to hotter colors.

      call NhlFRLCreate(srlist,'SETRL')
      call NhlFRLClear(srlist)
      call NhlFRLSetstring(srlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'vc05',NhlFAppClass,0,
     1    srlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then

C Create a meta file workstation.
         call NhlFRLClear(srlist)
         call NhlFRLSetstring(srlist,'wkMetaName','./vc05f.ncgm',ierr)
         call NhlFCreate(wid,'vc05Work',NhlFNcgmWorkstationClass,0,
     1        srlist,ierr)
 
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then

C Create an X workstation.

         call NhlFRLClear(srlist)
         call NhlFRLSetstring(srlist,'wkPause','true',ierr)

C ;;********* see resource file vc05.res ******
C       call NhlFRLSetstring(srlist,'wkColorMap', 'temp1',ierr)
C 
         call NhlFCreate(wid,'vc05Work',
     +        NhlFCairoWindowWorkstationClass,
     1        0,srlist,ierr)
    
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
         
C Create an older-style PS workstation.

         call NhlFRLClear(srlist)
         call NhlFRLSetstring(srlist,'wkPSFileName','./vc05f.ps',ierr)
         call NhlFCreate(wid,'vc05Work',NhlFPSWorkstationClass,
     1        0,srlist,ierr)

      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then

C Create an older-style PDF workstation.

         call NhlFRLClear(srlist)
         call NhlFRLSetstring(srlist,'wkPDFFileName','./vc05f.pdf',ierr)
         call NhlFCreate(wid,'vc05Work',NhlFPDFWorkstationClass,
     1        0,srlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then

C Create a cairo PS/PDF  workstation.

         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetstring(srlist,'wkFileName','./vc05f',ierr)
         call NhlFCreate(wid,'vc05Work',
     1        NhlFCairoPSPDFWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then

C Create a cairo PNG  workstation.

         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetstring(srlist,'wkFileName','./vc05f',ierr)
         call NhlFCreate(wid,'vc05Work',
     1        NhlFCairoImageWorkstationClass,0,srlist,ierr)
      endif


C  BEGIN CREATING 1st FRAME

C  Create the 1st VectorField data object using the data set
C  generated above.

      call NhlFRLClear(srlist)
      len_dims(1) = N
      len_dims(2) = M
      call NhlFRLSetmdfloatarray(srlist,'vfUDataArray',U,2,
     1    len_dims,ierr)
      call NhlFRLSetmdfloatarray(srlist,'vfVDataArray',V,2,
     1    len_dims,ierr)
      call NhlFCreate(dataid,'increasingvectors',NhlFVectorFieldClass,
     1    appid,srlist,ierr)

C  Create the 1st VectorPlot object, supplying the 1st VectorField
C  object as data.
C  Turn off black and white arrows and use the temp1 colors spread
C  between
C  the lowest and highest vector magnitudes. The default vectors
C  appear as
C  solid lines with arrowheads in a linear coordinate system with the
C  origin at the lower left. Tickmarks with labels show the data
C  coordinate
C  range, and an informational label at the lower right gives
C  the reference vector value.

      call NhlFRLClear(srlist)
      call NhlFRLSetinteger(srlist,'vcVectorFieldData',dataid,ierr)

C ********* see resource file vc05.res ******
C       call NhlFRLSetstring(srlist,'vcMonoLineArrowColor','false',
C      1    ierr)
C       call NhlFRLSetstring(srlist,'vcMaxLevelCount',61,
C      1    ierr)
C 

      call NhlFCreate(vcid,'VectorPlot1',NhlFVectorPlotClass,wid,
     1    srlist,ierr)

C  Draw the 1st frame, signify end of 1st frame.

      call NhlFDraw(vcid,ierr)
      call NhlFFrame(wid,ierr)

C  Destroy the objects created for the 1st frame. 
C  Keep wid and appid for 2nd frame.

      call NhlFDestroy(dataid,ierr)
      call NhlFDestroy(vcid,ierr)

C  BEGIN CREATING 2nd FRAME

C  Create the 2nd VectorField data object using the same data.
C  Map the domain and range of the vector locations to the latitude
C  and longitude ranges of the world map on which the vectors
C  will be overlayed. Thus, cause the x axis locations to cover -180
C  to 180 degrees longitude, and cause the y axis locations to cover
C  -90 to 90 degrees latitude.
 
        call NhlFRLClear(srlist)
        call NhlFRLSetmdfloatArray(srlist,'vfUDataArray',U,2,
     1      len_dims,ierr)
        call NhlFRLSetmdfloatArray(srlist,'vfVDataArray',V,2,
     1      len_dims,ierr)

C ********* see resource file vc05.res ******   
C         call NhlFRLSetinteger(srlist,'vfXCStartV', -180,ierr)
C         call NhlFRLSetinteger(srlist,'vfXCEndV', 180,ierr)
C         call NhlFRLSetinteger(srlist,'vfYCStartV', -90,ierr)
C         call NhlFRLSetinteger(srlist,'vfYCEndV', 90,ierr)
C 

      call NhlFCreate(dataid,'increasingvectors2',NhlFVectorFieldClass,
     1      appid,srlist,ierr)


C  Create the 2nd VectorPlot object, as in the 1st frame.
C  Make the minimum vector length 1/3 of the reference vector length.

      call NhlFRLClear(srlist)
      call NhlFRLSetinteger(srlist,'vcVectorFieldData',dataid,ierr)

C ********* see resource file vc05.res ******
C       call NhlFRLSetstring(srlist,'vcMonoLineArrowColor','false',
C      1    ierr)
C       call NhlFRLSetstring(srlist,'vcMaxLevelCount',61,
C      1    ierr)
C       call NhlFRLSetfloat(srlist,'vcMinFracLengthF', .33,ierr)
C 

      call NhlFCreate(vcid,'VectorPlot2',NhlFVectorPlotClass,
     1      wid,srlist,ierr)
  

C  Create a mapPlot object consisting of, the default, gridded
C  world map.
C  Add a title object which says "vc05 frame 2".
C  Turn off the grid lines. 

      call NhlFRLClear(srlist)
      call NhlFRLSetstring(srlist,'pmTitleDisplayMode','always',ierr)
      call NhlFRLSetstring(srlist,'tiMainString','vc05 frame 2',
     1    ierr)

C********* see resource file vc05.res ******
C      call NhlFRLSetstring(srlist,'mpGridAndLimbOn', 'false',ierr)
C

      call NhlFCreate(mapid,'Map1',NhlFMapPlotClass,wid,srlist,ierr)

C  Overlay the VectorPlot2 VectorPlot object onto the Map1 MapPlot
C  object.

      call NhlFAddOverlay(mapid, vcid,-1,ierr)

C  Draw the 2nd frame. Signify end of 2nd frame.

 
      call NhlFDraw(mapid,ierr)
      call NhlFFrame(wid,ierr)

C  Destroy the objects created for 2nd frame. Keep wid and appid
C  for 3rd frame.

      call NhlFDestroy(dataid,ierr)
      call NhlFDestroy(vcid,ierr)
      call NhlFDestroy(mapid,ierr)

C  BEGIN CREATING 3rd FRAME

C  Create a data object from the same data.
C  Cause the x axis data locations to cover -180 to 180 degrees
C   longitude.
C  Cause the y axis data locations to cover 50 degrees latitude up
C  to the
C  north pole.

      call NhlFRLClear(srlist)
      call NhlFRLSetmdfloatArray(srlist,'vfUDataArray',U,2,
     1    len_dims,ierr)
      call NhlFRLSetmdfloatArray(srlist,'vfVDataArray',V,2,
     1    len_dims,ierr)

C********* see resource file vc05.res ******
C      call NhlFRLSetinteger(srlist,'vfXCStartV', -180,ierr)
C      call NhlFRLSetinteger(srlist,'vfXCEndV', 180,ierr)
C      call NhlFRLSetinteger(srlist,'vfYCStartV', 50,ierr)
C      call NhlFRLSetinteger(srlist,'vfYCEndV', 90,ierr)
C

      call NhlFCreate(dataid,'increasingvectors3',NhlFVectorFieldClass,
     1    appid,srlist,ierr)

C  Create a VectorPlot object, supplying the VectorField object as data,
C  as in frame 2. 
C  Double the default vector length in NDC. The default was to
C  dynamically
C  calulate it by dividing viewport width by the number of data values.
C  Display a horizontal label bar (at the bottom of the plot)
C  showing the color levels and their corresponding magnitudes.
C  Decrease the height of the label bar to .1 NDC so that it fits
C  into the
C  default viewPort.

        call NhlFRLClear(srlist)
      call NhlFRLSetinteger(srlist,'vcVectorFieldData',dataid,ierr)

C********* see resource file vc05.res ******
C      call NhlFRLSetstring(srlist,'vcMonoLineArrowColor','false',
C     1    ierr)
C      call NhlFRLSetstring(srlist,'vcMaxLevelCount',61,
C     1    ierr)
C      call NhlFRLSetfloat(srlist,'vcMinFracLengthF', .33,ierr)  
C      call NhlFRLSetfloat(srlist,'vcRefLengthF', .05,ierr)
C      call NhlFRLSetstring(srlist,'pmLabelBarDisplayMode','always',
C     1    ierr)
C      call NhlFRLSetstring(srlist,'pmLabelBarSide', 'bottom',ierr)
C      call NhlFRLSetstring(srlist,'lbOrientation','horizontal',ierr)
C      call  NhlFRLSetfloat(srlist,'pmLabelBarHeightF', .11,ierr)
C      call  NhlFRLSetfloat(srlist,'pmLabelBarWidthF', .6,ierr)
C

      call NhlFCreate(vcid,'VectorPlot3',NhlFVectorPlotClass,wid,
     1      srlist,ierr)

C  Create an orthographic map of the world, centered at the north pole,
C  making the points at all four of the frame edges be 50 degrees north
C  latitude. Make the center of the top edge of the frame be 180
C  degrees 
C  longitude, the center of the bottom edge of the frame correspond to
C  0 degrees longitude, the center of the left edge of the frame
C  correspond
C  to -90 degrees longitude,and the center of right edge of the frame
C  correspond to +90 degrees longitude.
C  Create a title object which says "vc05 frame 3".
C  Turn off the grid lines.

      call NhlFRLClear(srlist)
      call NhlFRLSetstring(srlist,'pmTitleDisplayMode','always',ierr)
      call NhlFRLSetstring(srlist,'tiMainString','vc05 frame 3',
     1    ierr)

C********* see resource file vc05.res ******
C      call NhlFRLSetstring(srlist,'mpProjection', 'Orthographic',
C    1    ierr)
C      call NhlFRLSetfloat(srlist,'mpCenterLatF', 90.0,ierr) 
C      call NhlFRLSetfloat(srlist,'mpCenterLonF', 0.0,ierr) 
C      call NhlFRLSetstring(srlist,'mpLimitMode', 'points',ierr)
C      call NhlFRLSetfloat(srlist,'mpBottomPointLatF', 50.0,ierr)
C      call NhlFRLSetfloat(srlist,'mpTopPointLatF', 50.0,ierr)
C      call NhlFRLSetfloat(srlist,'mpLeftPointLatF', 50.0,ierr)
C      call NhlFRLSetfloat(srlist,'mpRightPointLatF', 50.0,ierr)
C      call NhlFRLSetfloat(srlist,'mpBottomPointLonF', 0.0,ierr)
C      call NhlFRLSetfloat(srlist,'mpTopPointLonF', 180.0,ierr)
C      call NhlFRLSetfloat(srlist,'mpLeftPointLonF', 270.0,ierr)
C      call NhlFRLSetfloat(srlist,'mpRightPointLonF', 90.0,ierr)
C      call NhlFRLSetstring(srlist,'mpGridAndLimbOn', 'false',ierr)
C

      call NhlFCreate(mapid,'Map2',NhlFMapPlotClass,wid,srlist,ierr)

C  Overlay the VectorPlot3 VectorPlot object onto the Map2 MapPlot
C  object.


       call  NhlFAddOverlay(mapid, vcid,-1,ierr)


C  Draw the 3rd frame. Signify end of 3rd frame.

  
      call NhlFDraw(mapid,ierr)
      call NhlFFrame(wid,ierr)

C  Destroy all of the objects created, close the HLU library and exit.


      call NhlFDestroy(dataid,ierr)
      call NhlFDestroy(vcid,ierr)
      call NhlFDestroy(mapid,ierr)
      call NhlFDestroy(wid,ierr)
      call NhlFDestroy(appid,ierr)

      call NhlFClose
      
      stop
      end


 

      PROGRAM FTEX04D
C
C  Example of KURV1DP, KURV2DP, KURVDDP.
C
      PARAMETER (IDIM=11,IOUT=201,IDTEMP=9*IDIM)
      DOUBLE PRECISION X
      DOUBLE PRECISION Y
      DOUBLE PRECISION TEMP
      DOUBLE PRECISION U
      DOUBLE PRECISION XO
      DOUBLE PRECISION YO
      DOUBLE PRECISION XS
      DOUBLE PRECISION YS
      DOUBLE PRECISION XD
      DOUBLE PRECISION YD
      DOUBLE PRECISION XDD
      DOUBLE PRECISION YDD
      DOUBLE PRECISION XP
      DOUBLE PRECISION YP
      DOUBLE PRECISION S
      DOUBLE PRECISION SIGMA
      DOUBLE PRECISION SLOP1
      DOUBLE PRECISION SLOP2
      DOUBLE PRECISION TINC
      DIMENSION X(IDIM),Y(IDIM),TEMP(IDTEMP),U(IOUT),XO(IOUT),YO(IOUT),
     +          XS(IOUT),YS(IOUT),XD(IOUT),YD(IOUT),XDD(IOUT),YDD(IOUT)
      DIMENSION XP(IDIM),YP(IDIM),S(IDIM)
C
      DATA X/3.D0,4.D0,9.D0,16.D0,21.D0,27.D0,34.D0,36.D0,34.D0,26.D0,
     +     18.D0/
      DATA Y/2.4D0,9.6D0,14.4D0,12.0D0,9.6D0,8.4D0,13.2D0,21.6D0,30.0D0,
     +     37.2D0,38.4D0/
C
C  Do KURV1DP set up.
C
      SIGMA = 1.D0
      ISF = 3
      CALL KURV1DP(IDIM,X,Y,SLOP1,SLOP2,ISF,XP,YP,TEMP,S,SIGMA,IERR)
      IF (IERR.NE.0) THEN
          PRINT *,'Error return from KURV1DP =',IERR
          STOP
      END IF
C
C  Get interpolated points using KURV2DP.
C
      TINC = 1.0D0/ (IOUT-1)
      DO 10 I = 1,IOUT
          U(I) = (I-1)*TINC
          CALL KURV2DP(U(I),XO(I),YO(I),IDIM,X,Y,XP,YP,S,SIGMA)
   10 CONTINUE
C
C  Get the derivatives.
C
      DO 20 I = 1,IOUT
          CALL KURVDDP(U(I),XS(I),YS(I),XD(I),YD(I),XDD(I),YDD(I),IDIM,
     +        X,Y,XP,YP,S,SIGMA)
   20 CONTINUE
C
C This next section plots the data. You must have a double precision
C version of NCAR Graphics in order for this section to compile and
C run correctly.  For now, it is commented out.
C
C  Draw plot.
C
C      CALL DRWFT4(IDIM,X,Y,IOUT,XO,YO,U,XD,YD)
C
      STOP
      END
C      SUBROUTINE DRWFT4(II,X,Y,IOUT,XO,YO,U,XD,YD)
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
C      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C      DOUBLE PRECISION X
C      DOUBLE PRECISION Y
C      DOUBLE PRECISION XO
C      DOUBLE PRECISION YO
C      DOUBLE PRECISION U
C      DOUBLE PRECISION XD
C      DOUBLE PRECISION YD
C
C  Open GKS, open and activate a workstation.
C
C      CALL GOPKS(IERRF,ISZDM)
C      CALL GOPWK(IWKID,LUNIT,IWTYPE)
C      CALL GACWK(IWKID)
C
C  Define a color table.
C
C      CALL GSCR(IWKID,0,1.0D0,1.0D0,1.0D0)
C      CALL GSCR(IWKID,1,0.0D0,0.0D0,0.0D0)
C      CALL GSCR(IWKID,2,1.0D0,0.0D0,0.0D0)
C      CALL GSCR(IWKID,3,0.0D0,1.0D0,0.0D0)
C      CALL GSCR(IWKID,4,0.0D0,0.0D0,1.0D0)
C
C  Draw markers at original points.
C
C      CALL BKGFT4(0.D0,40.D0,0.D0,40.D0,0.15D0,0.85D0,
C     +            'Demo for KURV1DP/KURV2DP',0.035D0,0.5D0,0.93D0,0)
C      CALL GRIDAL(4,5,4,5,1,1,10,0.D0,0.D0)
C      CALL GSMKSC(2.D0)
C      CALL GSPMCI(4)
C      CALL GPM(II,X,Y)
C
C  Draw the interpolated curve
C
C      CALL CURVE(XO,YO,IOUT)
C      CALL FRAME
C
C  Plot the first derivatives of X and Y with respect to the parametric
C  variable U.
C
C      CALL SET(0.D0,1.D0,0.D0,1.D0,0.D0,1.D0,0.D0,1.D0,1)
C      CALL PCSETI('FN',21)
C      CALL PLCHHQ(0.5D0,0.95D0,'Derivatives from KURVDDP',0.035D0,0.D0,
C     +            0.D0)
C      CALL BKGFT4(0.D0,1.D0,-80.D0,80.D0,0.55D0,0.87D0,'dx/du',0.030D0,
C     +            0.65D0,0.82D0,1)
C      CALL GRIDAL(5,5,4,5,1,1,10,0.D0,-80.D0)
C      CALL CURVE(U,XD,IOUT)
C      CALL BKGFT4(0.D0,1.D0,-40.D0,80.D0,0.10D0,0.42D0,'dy/du',0.030D0,
C     +            0.39D0,0.37D0,1)
C      CALL GRIDAL(5,5,3,5,1,1,10,0.D0,-40.D0)
C      CALL CURVE(U,YD,IOUT)
C      CALL FRAME
C
C      CALL GDAWK(IWKID)
C      CALL GCLWK(IWKID)
C      CALL GCLKS
C
C      RETURN
C      END
C      SUBROUTINE BKGFT4(XL,XR,YB,YT,YPB,YPT,LABEL,SIZL,POSXL,POSYL,IZL)
C      DOUBLE PRECISION XL
C      DOUBLE PRECISION XR
C      DOUBLE PRECISION YB
C      DOUBLE PRECISION YT
C      DOUBLE PRECISION YPB
C      DOUBLE PRECISION YPT
C      DOUBLE PRECISION SIZL
C      DOUBLE PRECISION POSXL
C      DOUBLE PRECISION POSYL
C      DOUBLE PRECISION XX
C      DOUBLE PRECISION YY
C      DIMENSION XX(2),YY(2)
C      CHARACTER*(*) LABEL
C
C      CALL SET(0.D0,1.D0,0.D0,1.D0,0.D0,1.D0,0.D0,1.D0,1)
C      CALL PCSETI('FN',21)
C      CALL PLCHHQ(POSXL,POSYL,LABEL,SIZL,0.D0,0.D0)
C      CALL SET(0.17D0,0.87D0,YPB,YPT,XL,XR,YB,YT,1)
C      IF (IZL.NE.0) THEN
C          XX(1) = XL
C          XX(2) = XR
C          YY(1) = 0.D0
C          YY(2) = 0.D0
C          CALL GSPLCI(2)
C          CALL GPL(2,XX,YY)
C          CALL GSPLCI(1)
C      END IF
C
C      CALL GASETI('LTY',1)
C      CALL PCSETI('FN',21)
C      CALL GASETR('XLS',0.02D0)
C      CALL GASETC('XLF','(F4.1)')
C      CALL GASETR('YLS',0.02D0)
C      CALL GASETC('YLF','(F5.1)')
C      CALL GASETR('XMJ',0.02D0)
C      CALL GASETR('YMJ',0.02D0)
C
C      RETURN
C      END

C
C       $Id: sthluint.f,v 1.5 2008-07-27 00:17:28 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
C This module contains interface routines for StreamlinePlot
C
      SUBROUTINE STGETMAPINFO (IMP,ITR,VNL,DFM,XMN,XMX,YMN,YMX,
     +     XDL,XDH,YDL,YDH)
C
C The sole purpose of this routine is to make information from the
C mapping common block available to hlustmpxy, hlustimxy and hlustmpta
C
C --------------------------------------------------------------------
C
C The mapping common block: made available to user mapping routines
C
      COMMON /STMAP/
     +                IMAP       ,LNLG       ,INVX       ,INVY       ,
     +                XLOV       ,XHIV       ,YLOV       ,YHIV       ,
     +                WXMN       ,WXMX       ,WYMN       ,WYMX       ,
     +                XVPL       ,XVPR       ,YVPB       ,YVPT       ,
     +                XGDS       ,YGDS       ,NXCT       ,NYCT       ,
     +                ITRT       ,FW2W       ,FH2H       ,
     +                DFMG       ,VNML       ,RBIG       ,IBIG
C
      SAVE /STMAP/
C
C Math constants
C
      PARAMETER (PDTOR  = 0.017453292519943,
     +           PRTOD  = 57.2957795130823,
     +           P1XPI  = 3.14159265358979,
     +           P2XPI  = 6.28318530717959,
     +           P1D2PI = 1.57079632679489,
     +           P5D2PI = 7.85398163397448) 
C
      IMP = IMAP
      ITR = ITRT
      VNL = VNML
      DFM = DFMG
      XMN = WXMN
      XMX = WXMX
      YMN = WYMN
      YMX = WYMX
      XDL = MIN(XLOV,XHIV)
      XDH = MAX(XLOV,XHIV)
      YDL = MIN(YLOV,YHIV)
      YDH = MAX(YLOV,YHIV)
C
C Done.
C
      RETURN
C
      END

      subroutine plotfmt_rddata(istatus,nx,ny,slab)

      implicit none
      integer funit, nx, ny, istatus
      real slab(nx,ny)

      istatus = 1
      funit = 10
      read(unit=funit,err=1001,end=1001) slab

      istatus = 0
    
 1001 return
      end

      SUBROUTINE ZGTSV( N, NRHS, DL, D, DU, B, LDB, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      INTEGER            INFO, LDB, N, NRHS
*     ..
*     .. Array Arguments ..
      COMPLEX*16         B( LDB, * ), D( * ), DL( * ), DU( * )
*     ..
*
*  Purpose
*  =======
*
*  ZGTSV  solves the equation
*
*     A*X = B,
*
*  where A is an N-by-N tridiagonal matrix, by Gaussian elimination with
*  partial pivoting.
*
*  Note that the equation  A'*X = B  may be solved by interchanging the
*  order of the arguments DU and DL.
*
*  Arguments
*  =========
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  NRHS    (input) INTEGER
*          The number of right hand sides, i.e., the number of columns
*          of the matrix B.  NRHS >= 0.
*
*  DL      (input/output) COMPLEX*16 array, dimension (N-1)
*          On entry, DL must contain the (n-1) subdiagonal elements of
*          A.
*          On exit, DL is overwritten by the (n-2) elements of the
*          second superdiagonal of the upper triangular matrix U from
*          the LU factorization of A, in DL(1), ..., DL(n-2).
*
*  D       (input/output) COMPLEX*16 array, dimension (N)
*          On entry, D must contain the diagonal elements of A.
*          On exit, D is overwritten by the n diagonal elements of U.
*
*  DU      (input/output) COMPLEX*16 array, dimension (N-1)
*          On entry, DU must contain the (n-1) superdiagonal elements
*          of A.
*          On exit, DU is overwritten by the (n-1) elements of the first
*          superdiagonal of U.
*
*  B       (input/output) COMPLEX*16 array, dimension (LDB,NRHS)
*          On entry, the N-by-NRHS right hand side matrix B.
*          On exit, if INFO = 0, the N-by-NRHS solution matrix X.
*
*  LDB     (input) INTEGER
*          The leading dimension of the array B.  LDB >= max(1,N).
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*          > 0:  if INFO = i, U(i,i) is exactly zero, and the solution
*                has not been computed.  The factorization has not been
*                completed unless i = N.
*
*  =====================================================================
*
*     .. Parameters ..
      COMPLEX*16         ZERO
      PARAMETER          ( ZERO = ( 0.0D+0, 0.0D+0 ) )
*     ..
*     .. Local Scalars ..
      INTEGER            J, K
      COMPLEX*16         MULT, TEMP, ZDUM
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, DBLE, DIMAG, MAX
*     ..
*     .. External Subroutines ..
      EXTERNAL           XERBLA
*     ..
*     .. Statement Functions ..
      DOUBLE PRECISION   CABS1
*     ..
*     .. Statement Function definitions ..
      CABS1( ZDUM ) = ABS( DBLE( ZDUM ) ) + ABS( DIMAG( ZDUM ) )
*     ..
*     .. Executable Statements ..
*
      INFO = 0
      IF( N.LT.0 ) THEN
         INFO = -1
      ELSE IF( NRHS.LT.0 ) THEN
         INFO = -2
      ELSE IF( LDB.LT.MAX( 1, N ) ) THEN
         INFO = -7
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'ZGTSV ', -INFO )
         RETURN
      END IF
*
      IF( N.EQ.0 )
     $   RETURN
*
      DO 30 K = 1, N - 1
         IF( DL( K ).EQ.ZERO ) THEN
*
*           Subdiagonal is zero, no elimination is required.
*
            IF( D( K ).EQ.ZERO ) THEN
*
*              Diagonal is zero: set INFO = K and return; a unique
*              solution can not be found.
*
               INFO = K
               RETURN
            END IF
         ELSE IF( CABS1( D( K ) ).GE.CABS1( DL( K ) ) ) THEN
*
*           No row interchange required
*
            MULT = DL( K ) / D( K )
            D( K+1 ) = D( K+1 ) - MULT*DU( K )
            DO 10 J = 1, NRHS
               B( K+1, J ) = B( K+1, J ) - MULT*B( K, J )
   10       CONTINUE
            IF( K.LT.( N-1 ) )
     $         DL( K ) = ZERO
         ELSE
*
*           Interchange rows K and K+1
*
            MULT = D( K ) / DL( K )
            D( K ) = DL( K )
            TEMP = D( K+1 )
            D( K+1 ) = DU( K ) - MULT*TEMP
            IF( K.LT.( N-1 ) ) THEN
               DL( K ) = DU( K+1 )
               DU( K+1 ) = -MULT*DL( K )
            END IF
            DU( K ) = TEMP
            DO 20 J = 1, NRHS
               TEMP = B( K, J )
               B( K, J ) = B( K+1, J )
               B( K+1, J ) = TEMP - MULT*B( K+1, J )
   20       CONTINUE
         END IF
   30 CONTINUE
      IF( D( N ).EQ.ZERO ) THEN
         INFO = N
         RETURN
      END IF
*
*     Back solve with the matrix U from the factorization.
*
      DO 50 J = 1, NRHS
         B( N, J ) = B( N, J ) / D( N )
         IF( N.GT.1 )
     $      B( N-1, J ) = ( B( N-1, J )-DU( N-1 )*B( N, J ) ) / D( N-1 )
         DO 40 K = N - 2, 1, -1
            B( K, J ) = ( B( K, J )-DU( K )*B( K+1, J )-DL( K )*
     $                  B( K+2, J ) ) / D( K )
   40    CONTINUE
   50 CONTINUE
*
      RETURN
*
*     End of ZGTSV
*
      END

C
C $Id: mdprs.f,v 1.9 2008-09-18 00:42:17 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MDPRS
C
C Declare required common blocks.  See MAPBDX for descriptions of these
C common blocks and the variables in them.
C
        COMMON /MAPCM2/  BLAM,BLOM,PEPS,SLAM,SLOM,UCEN,UMAX,UMIN,UOFF,
     +                   URNG,VCEN,VMAX,VMIN,VOFF,VRNG,ISSL
        DOUBLE PRECISION BLAM,BLOM,PEPS,SLAM,SLOM,UCEN,UMAX,UMIN,UOFF,
     +                   URNG,VCEN,VMAX,VMIN,VOFF,VRNG
        INTEGER          ISSL
        SAVE   /MAPCM2/
C
        COMMON /MAPCM7/  ULOW,UROW,VBOW,VTOW
        DOUBLE PRECISION ULOW,UROW,VBOW,VTOW
        SAVE   /MAPCM7/
C
C Check for an uncleared prior error.
C
        IF (ICFELL('MDPRS - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C Restore the SET call.
C
        CALL SET (REAL(ULOW),REAL(UROW),REAL(VBOW),REAL(VTOW),
     +            REAL(UMIN),REAL(UMAX),REAL(VMIN),REAL(VMAX),1)
        IF (ICFELL('MDPRS',2).NE.0) RETURN
C
C Done.
C
        RETURN
C
      END

      SUBROUTINE ZGGSVD( JOBU, JOBV, JOBQ, M, N, P, K, L, A, LDA, B,
     $                   LDB, ALPHA, BETA, U, LDU, V, LDV, Q, LDQ, WORK,
     $                   RWORK, IWORK, INFO )
*
*  -- LAPACK driver routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          JOBQ, JOBU, JOBV
      INTEGER            INFO, K, L, LDA, LDB, LDQ, LDU, LDV, M, N, P
*     ..
*     .. Array Arguments ..
      INTEGER            IWORK( * )
      DOUBLE PRECISION   ALPHA( * ), BETA( * ), RWORK( * )
      COMPLEX*16         A( LDA, * ), B( LDB, * ), Q( LDQ, * ),
     $                   U( LDU, * ), V( LDV, * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  ZGGSVD computes the generalized singular value decomposition (GSVD)
*  of an M-by-N complex matrix A and P-by-N complex matrix B:
*
*        U'*A*Q = D1*( 0 R ),    V'*B*Q = D2*( 0 R )
*
*  where U, V and Q are unitary matrices, and Z' means the conjugate
*  transpose of Z.  Let K+L = the effective numerical rank of the
*  matrix (A',B')', then R is a (K+L)-by-(K+L) nonsingular upper
*  triangular matrix, D1 and D2 are M-by-(K+L) and P-by-(K+L) "diagonal"
*  matrices and of the following structures, respectively:
*
*  If M-K-L >= 0,
*
*                      K  L
*         D1 =     K ( I  0 )
*                  L ( 0  C )
*              M-K-L ( 0  0 )
*
*                    K  L
*         D2 =   L ( 0  S )
*              P-L ( 0  0 )
*
*                  N-K-L  K    L
*    ( 0 R ) = K (  0   R11  R12 )
*              L (  0    0   R22 )
*  where
*
*    C = diag( ALPHA(K+1), ... , ALPHA(K+L) ),
*    S = diag( BETA(K+1),  ... , BETA(K+L) ),
*    C**2 + S**2 = I.
*
*    R is stored in A(1:K+L,N-K-L+1:N) on exit.
*
*  If M-K-L < 0,
*
*                    K M-K K+L-M
*         D1 =   K ( I  0    0   )
*              M-K ( 0  C    0   )
*
*                      K M-K K+L-M
*         D2 =   M-K ( 0  S    0  )
*              K+L-M ( 0  0    I  )
*                P-L ( 0  0    0  )
*
*                     N-K-L  K   M-K  K+L-M
*    ( 0 R ) =     K ( 0    R11  R12  R13  )
*                M-K ( 0     0   R22  R23  )
*              K+L-M ( 0     0    0   R33  )
*
*  where
*
*    C = diag( ALPHA(K+1), ... , ALPHA(M) ),
*    S = diag( BETA(K+1),  ... , BETA(M) ),
*    C**2 + S**2 = I.
*
*    (R11 R12 R13 ) is stored in A(1:M, N-K-L+1:N), and R33 is stored
*    ( 0  R22 R23 )
*    in B(M-K+1:L,N+M-K-L+1:N) on exit.
*
*  The routine computes C, S, R, and optionally the unitary
*  transformation matrices U, V and Q.
*
*  In particular, if B is an N-by-N nonsingular matrix, then the GSVD of
*  A and B implicitly gives the SVD of A*inv(B):
*                       A*inv(B) = U*(D1*inv(D2))*V'.
*  If ( A',B')' has orthnormal columns, then the GSVD of A and B is also
*  equal to the CS decomposition of A and B. Furthermore, the GSVD can
*  be used to derive the solution of the eigenvalue problem:
*                       A'*A x = lambda* B'*B x.
*  In some literature, the GSVD of A and B is presented in the form
*                   U'*A*X = ( 0 D1 ),   V'*B*X = ( 0 D2 )
*  where U and V are orthogonal and X is nonsingular, and D1 and D2 are
*  ``diagonal''.  The former GSVD form can be converted to the latter
*  form by taking the nonsingular matrix X as
*
*                        X = Q*(  I   0    )
*                              (  0 inv(R) )
*
*  Arguments
*  =========
*
*  JOBU    (input) CHARACTER*1
*          = 'U':  Unitary matrix U is computed;
*          = 'N':  U is not computed.
*
*  JOBV    (input) CHARACTER*1
*          = 'V':  Unitary matrix V is computed;
*          = 'N':  V is not computed.
*
*  JOBQ    (input) CHARACTER*1
*          = 'Q':  Unitary matrix Q is computed;
*          = 'N':  Q is not computed.
*
*  M       (input) INTEGER
*          The number of rows of the matrix A.  M >= 0.
*
*  N       (input) INTEGER
*          The number of columns of the matrices A and B.  N >= 0.
*
*  P       (input) INTEGER
*          The number of rows of the matrix B.  P >= 0.
*
*  K       (output) INTEGER
*  L       (output) INTEGER
*          On exit, K and L specify the dimension of the subblocks
*          described in Purpose.
*          K + L = effective numerical rank of (A',B')'.
*
*  A       (input/output) COMPLEX*16 array, dimension (LDA,N)
*          On entry, the M-by-N matrix A.
*          On exit, A contains the triangular matrix R, or part of R.
*          See Purpose for details.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A. LDA >= max(1,M).
*
*  B       (input/output) COMPLEX*16 array, dimension (LDB,N)
*          On entry, the P-by-N matrix B.
*          On exit, B contains part of the triangular matrix R if
*          M-K-L < 0.  See Purpose for details.
*
*  LDB     (input) INTEGER
*          The leading dimension of the array B. LDB >= max(1,P).
*
*  ALPHA   (output) DOUBLE PRECISION array, dimension (N)
*  BETA    (output) DOUBLE PRECISION array, dimension (N)
*          On exit, ALPHA and BETA contain the generalized singular
*          value pairs of A and B;
*            ALPHA(1:K) = 1,
*            BETA(1:K)  = 0,
*          and if M-K-L >= 0,
*            ALPHA(K+1:K+L) = C,
*            BETA(K+1:K+L)  = S,
*          or if M-K-L < 0,
*            ALPHA(K+1:M)= C, ALPHA(M+1:K+L)= 0
*            BETA(K+1:M) = S, BETA(M+1:K+L) = 1
*          and
*            ALPHA(K+L+1:N) = 0
*            BETA(K+L+1:N)  = 0
*
*  U       (output) COMPLEX*16 array, dimension (LDU,M)
*          If JOBU = 'U', U contains the M-by-M unitary matrix U.
*          If JOBU = 'N', U is not referenced.
*
*  LDU     (input) INTEGER
*          The leading dimension of the array U. LDU >= max(1,M) if
*          JOBU = 'U'; LDU >= 1 otherwise.
*
*  V       (output) COMPLEX*16 array, dimension (LDV,P)
*          If JOBV = 'V', V contains the P-by-P unitary matrix V.
*          If JOBV = 'N', V is not referenced.
*
*  LDV     (input) INTEGER
*          The leading dimension of the array V. LDV >= max(1,P) if
*          JOBV = 'V'; LDV >= 1 otherwise.
*
*  Q       (output) COMPLEX*16 array, dimension (LDQ,N)
*          If JOBQ = 'Q', Q contains the N-by-N unitary matrix Q.
*          If JOBQ = 'N', Q is not referenced.
*
*  LDQ     (input) INTEGER
*          The leading dimension of the array Q. LDQ >= max(1,N) if
*          JOBQ = 'Q'; LDQ >= 1 otherwise.
*
*  WORK    (workspace) COMPLEX*16 array, dimension (max(3*N,M,P)+N)
*
*  RWORK   (workspace) DOUBLE PRECISION array, dimension (2*N)
*
*  IWORK   (workspace/output) INTEGER array, dimension (N)
*          On exit, IWORK stores the sorting information. More
*          precisely, the following loop will sort ALPHA
*             for I = K+1, min(M,K+L)
*                 swap ALPHA(I) and ALPHA(IWORK(I))
*             endfor
*          such that ALPHA(1) >= ALPHA(2) >= ... >= ALPHA(N).
*
*  INFO    (output)INTEGER
*          = 0:  successful exit.
*          < 0:  if INFO = -i, the i-th argument had an illegal value.
*          > 0:  if INFO = 1, the Jacobi-type procedure failed to
*                converge.  For further details, see subroutine ZTGSJA.
*
*  Internal Parameters
*  ===================
*
*  TOLA    DOUBLE PRECISION
*  TOLB    DOUBLE PRECISION
*          TOLA and TOLB are the thresholds to determine the effective
*          rank of (A',B')'. Generally, they are set to
*                   TOLA = MAX(M,N)*norm(A)*MAZHEPS,
*                   TOLB = MAX(P,N)*norm(B)*MAZHEPS.
*          The size of TOLA and TOLB may affect the size of backward
*          errors of the decomposition.
*
*  Further Details
*  ===============
*
*  2-96 Based on modifications by
*     Ming Gu and Huan Ren, Computer Science Division, University of
*     California at Berkeley, USA
*
*  =====================================================================
*
*     .. Local Scalars ..
      LOGICAL            WANTQ, WANTU, WANTV
      INTEGER            I, IBND, ISUB, J, NCYCLE
      DOUBLE PRECISION   ANORM, BNORM, SMAX, TEMP, TOLA, TOLB, ULP, UNFL
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      DOUBLE PRECISION   DLAMCH, ZLANGE
      EXTERNAL           LSAME, DLAMCH, ZLANGE
*     ..
*     .. External Subroutines ..
      EXTERNAL           DCOPY, XERBLA, ZGGSVP, ZTGSJA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN
*     ..
*     .. Executable Statements ..
*
*     Decode and test the input parameters
*
      WANTU = LSAME( JOBU, 'U' )
      WANTV = LSAME( JOBV, 'V' )
      WANTQ = LSAME( JOBQ, 'Q' )
*
      INFO = 0
      IF( .NOT.( WANTU .OR. LSAME( JOBU, 'N' ) ) ) THEN
         INFO = -1
      ELSE IF( .NOT.( WANTV .OR. LSAME( JOBV, 'N' ) ) ) THEN
         INFO = -2
      ELSE IF( .NOT.( WANTQ .OR. LSAME( JOBQ, 'N' ) ) ) THEN
         INFO = -3
      ELSE IF( M.LT.0 ) THEN
         INFO = -4
      ELSE IF( N.LT.0 ) THEN
         INFO = -5
      ELSE IF( P.LT.0 ) THEN
         INFO = -6
      ELSE IF( LDA.LT.MAX( 1, M ) ) THEN
         INFO = -10
      ELSE IF( LDB.LT.MAX( 1, P ) ) THEN
         INFO = -12
      ELSE IF( LDU.LT.1 .OR. ( WANTU .AND. LDU.LT.M ) ) THEN
         INFO = -16
      ELSE IF( LDV.LT.1 .OR. ( WANTV .AND. LDV.LT.P ) ) THEN
         INFO = -18
      ELSE IF( LDQ.LT.1 .OR. ( WANTQ .AND. LDQ.LT.N ) ) THEN
         INFO = -20
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'ZGGSVD', -INFO )
         RETURN
      END IF
*
*     Compute the Frobenius norm of matrices A and B
*
      ANORM = ZLANGE( '1', M, N, A, LDA, RWORK )
      BNORM = ZLANGE( '1', P, N, B, LDB, RWORK )
*
*     Get machine precision and set up threshold for determining
*     the effective numerical rank of the matrices A and B.
*
      ULP = DLAMCH( 'Precision' )
      UNFL = DLAMCH( 'Safe Minimum' )
      TOLA = MAX( M, N )*MAX( ANORM, UNFL )*ULP
      TOLB = MAX( P, N )*MAX( BNORM, UNFL )*ULP
*
      CALL ZGGSVP( JOBU, JOBV, JOBQ, M, P, N, A, LDA, B, LDB, TOLA,
     $             TOLB, K, L, U, LDU, V, LDV, Q, LDQ, IWORK, RWORK,
     $             WORK, WORK( N+1 ), INFO )
*
*     Compute the GSVD of two upper "triangular" matrices
*
      CALL ZTGSJA( JOBU, JOBV, JOBQ, M, P, N, K, L, A, LDA, B, LDB,
     $             TOLA, TOLB, ALPHA, BETA, U, LDU, V, LDV, Q, LDQ,
     $             WORK, NCYCLE, INFO )
*
*     Sort the singular values and store the pivot indices in IWORK
*     Copy ALPHA to RWORK, then sort ALPHA in RWORK
*
      CALL DCOPY( N, ALPHA, 1, RWORK, 1 )
      IBND = MIN( L, M-K )
      DO 20 I = 1, IBND
*
*        Scan for largest ALPHA(K+I)
*
         ISUB = I
         SMAX = RWORK( K+I )
         DO 10 J = I + 1, IBND
            TEMP = RWORK( K+J )
            IF( TEMP.GT.SMAX ) THEN
               ISUB = J
               SMAX = TEMP
            END IF
   10    CONTINUE
         IF( ISUB.NE.I ) THEN
            RWORK( K+ISUB ) = RWORK( K+I )
            RWORK( K+I ) = SMAX
            IWORK( K+I ) = K + ISUB
         ELSE
            IWORK( K+I ) = K + I
         END IF
   20 CONTINUE
*
      RETURN
*
*     End of ZGGSVD
*
      END

      SUBROUTINE SGTTS2( ITRANS, N, NRHS, DL, D, DU, DU2, IPIV, B, LDB )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      INTEGER            ITRANS, LDB, N, NRHS
*     ..
*     .. Array Arguments ..
      INTEGER            IPIV( * )
      REAL               B( LDB, * ), D( * ), DL( * ), DU( * ), DU2( * )
*     ..
*
*  Purpose
*  =======
*
*  SGTTS2 solves one of the systems of equations
*     A*X = B  or  A'*X = B,
*  with a tridiagonal matrix A using the LU factorization computed
*  by SGTTRF.
*
*  Arguments
*  =========
*
*  ITRANS  (input) INTEGER
*          Specifies the form of the system of equations.
*          = 0:  A * X = B  (No transpose)
*          = 1:  A'* X = B  (Transpose)
*          = 2:  A'* X = B  (Conjugate transpose = Transpose)
*
*  N       (input) INTEGER
*          The order of the matrix A.
*
*  NRHS    (input) INTEGER
*          The number of right hand sides, i.e., the number of columns
*          of the matrix B.  NRHS >= 0.
*
*  DL      (input) REAL array, dimension (N-1)
*          The (n-1) multipliers that define the matrix L from the
*          LU factorization of A.
*
*  D       (input) REAL array, dimension (N)
*          The n diagonal elements of the upper triangular matrix U from
*          the LU factorization of A.
*
*  DU      (input) REAL array, dimension (N-1)
*          The (n-1) elements of the first super-diagonal of U.
*
*  DU2     (input) REAL array, dimension (N-2)
*          The (n-2) elements of the second super-diagonal of U.
*
*  IPIV    (input) INTEGER array, dimension (N)
*          The pivot indices; for 1 <= i <= n, row i of the matrix was
*          interchanged with row IPIV(i).  IPIV(i) will always be either
*          i or i+1; IPIV(i) = i indicates a row interchange was not
*          required.
*
*  B       (input/output) REAL array, dimension (LDB,NRHS)
*          On entry, the matrix of right hand side vectors B.
*          On exit, B is overwritten by the solution vectors X.
*
*  LDB     (input) INTEGER
*          The leading dimension of the array B.  LDB >= max(1,N).
*
*  =====================================================================
*
*     .. Local Scalars ..
      INTEGER            I, IP, J
      REAL               TEMP
*     ..
*     .. Executable Statements ..
*
*     Quick return if possible
*
      IF( N.EQ.0 .OR. NRHS.EQ.0 )
     $   RETURN
*
      IF( ITRANS.EQ.0 ) THEN
*
*        Solve A*X = B using the LU factorization of A,
*        overwriting each right hand side vector with its solution.
*
         IF( NRHS.LE.1 ) THEN
            J = 1
   10       CONTINUE
*
*           Solve L*x = b.
*
            DO 20 I = 1, N - 1
               IP = IPIV( I )
               TEMP = B( I+1-IP+I, J ) - DL( I )*B( IP, J )
               B( I, J ) = B( IP, J )
               B( I+1, J ) = TEMP
   20       CONTINUE
*
*           Solve U*x = b.
*
            B( N, J ) = B( N, J ) / D( N )
            IF( N.GT.1 )
     $         B( N-1, J ) = ( B( N-1, J )-DU( N-1 )*B( N, J ) ) /
     $                       D( N-1 )
            DO 30 I = N - 2, 1, -1
               B( I, J ) = ( B( I, J )-DU( I )*B( I+1, J )-DU2( I )*
     $                     B( I+2, J ) ) / D( I )
   30       CONTINUE
            IF( J.LT.NRHS ) THEN
               J = J + 1
               GO TO 10
            END IF
         ELSE
            DO 60 J = 1, NRHS
*
*              Solve L*x = b.
*
               DO 40 I = 1, N - 1
                  IF( IPIV( I ).EQ.I ) THEN
                     B( I+1, J ) = B( I+1, J ) - DL( I )*B( I, J )
                  ELSE
                     TEMP = B( I, J )
                     B( I, J ) = B( I+1, J )
                     B( I+1, J ) = TEMP - DL( I )*B( I, J )
                  END IF
   40          CONTINUE
*
*              Solve U*x = b.
*
               B( N, J ) = B( N, J ) / D( N )
               IF( N.GT.1 )
     $            B( N-1, J ) = ( B( N-1, J )-DU( N-1 )*B( N, J ) ) /
     $                          D( N-1 )
               DO 50 I = N - 2, 1, -1
                  B( I, J ) = ( B( I, J )-DU( I )*B( I+1, J )-DU2( I )*
     $                        B( I+2, J ) ) / D( I )
   50          CONTINUE
   60       CONTINUE
         END IF
      ELSE
*
*        Solve A' * X = B.
*
         IF( NRHS.LE.1 ) THEN
*
*           Solve U'*x = b.
*
            J = 1
   70       CONTINUE
            B( 1, J ) = B( 1, J ) / D( 1 )
            IF( N.GT.1 )
     $         B( 2, J ) = ( B( 2, J )-DU( 1 )*B( 1, J ) ) / D( 2 )
            DO 80 I = 3, N
               B( I, J ) = ( B( I, J )-DU( I-1 )*B( I-1, J )-DU2( I-2 )*
     $                     B( I-2, J ) ) / D( I )
   80       CONTINUE
*
*           Solve L'*x = b.
*
            DO 90 I = N - 1, 1, -1
               IP = IPIV( I )
               TEMP = B( I, J ) - DL( I )*B( I+1, J )
               B( I, J ) = B( IP, J )
               B( IP, J ) = TEMP
   90       CONTINUE
            IF( J.LT.NRHS ) THEN
               J = J + 1
               GO TO 70
            END IF
*
         ELSE
            DO 120 J = 1, NRHS
*
*              Solve U'*x = b.
*
               B( 1, J ) = B( 1, J ) / D( 1 )
               IF( N.GT.1 )
     $            B( 2, J ) = ( B( 2, J )-DU( 1 )*B( 1, J ) ) / D( 2 )
               DO 100 I = 3, N
                  B( I, J ) = ( B( I, J )-DU( I-1 )*B( I-1, J )-
     $                        DU2( I-2 )*B( I-2, J ) ) / D( I )
  100          CONTINUE
               DO 110 I = N - 1, 1, -1
                  IF( IPIV( I ).EQ.I ) THEN
                     B( I, J ) = B( I, J ) - DL( I )*B( I+1, J )
                  ELSE
                     TEMP = B( I+1, J )
                     B( I+1, J ) = B( I, J ) - DL( I )*TEMP
                     B( I, J ) = TEMP
                  END IF
  110          CONTINUE
  120       CONTINUE
         END IF
      END IF
*
*     End of SGTTS2
*
      END

C
C       $Id: vvdraw.f,v 1.13 2008-07-27 00:17:35 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE VVDRAW (XB,YB,XE,YE,VLN,LBL,NC,IAM,VVUDMV,IDA)
C
      DIMENSION IAM(*)
C
      EXTERNAL VVUDMV
C
C This routine is called to draw a single arrow.  It has arguments as
C follows -
C
C XB,YB    -  Coordinate of arrow base, fractional coordinate
C XE,YE    -  Coordinate of arrow head, fractional coordinate
C VLN      -  Length of the vector (arrow)
C          -  (if negative does not draw the vector, but just 
C          -  calculates the vector's height and width)
C LBL      -  Character label to be put above arrow.
C NC       -  Number of characters in label.
C IAM      -  Area map (optional) for masking vectors
C VVUDMV   -  User-supplied function for drawing masked vectors
C IDA      -  Do area masking flag
C
C ---------------------------------------------------------------------
C
C NOTE:
C Since implicit typing is used for all real and integer variables
C a consistent length convention has been adopted to help clarify the
C significance of the variables encountered in the code for this 
C utility. All local variable and subroutine parameter identifiers 
C are limited to 1,2,or 3 characters. Four character names identify  
C members of common blocks. Five and 6 character variable names 
C denote PARAMETER constants or subroutine or function names.
C
C Declare the VV common blocks.
C
C IPLVLS - Maximum number of color threshold level values
C IPAGMX - Maximum number of area groups allowed in the area map
C
      PARAMETER (IPLVLS = 256, IPAGMX = 64)
C
C Integer and real common block variables
C
C
      COMMON /VVCOM/
     +                IUD1       ,IVD1       ,IPD1       ,IXDM       ,
     +                IYDN       ,VLOM       ,VHIM       ,ISET       ,
     +                VRMG       ,VRLN       ,VFRC       ,IXIN       ,
     +                IYIN       ,ISVF       ,UUSV       ,UVSV       ,
     +                UPSV       ,IMSK       ,ICPM       ,UVPS       ,
     +                UVPL       ,UVPR       ,UVPB       ,UVPT       ,
     +                UWDL       ,UWDR       ,UWDB       ,UWDT       ,
     +                UXC1       ,UXCM       ,UYC1       ,UYCN       ,
     +                NLVL       ,IPAI       ,ICTV       ,WDLV       ,
     +                UVMN       ,UVMX       ,PMIN       ,PMAX       ,
     +                RVMN       ,RVMX       ,RDMN       ,RDMX       ,
     +                ISPC       ,RVMD       ,IPLR       ,IVST       ,
     +                IVPO       ,ILBL       ,IDPF       ,IMSG       ,
     +                ICLR(IPLVLS)           ,TVLU(IPLVLS)
C
C Arrow size/shape parameters
C
        COMMON / VVARO /
     +                HDSZ       ,HINF       ,HANG       ,IAST       ,
     +                HSIN       ,HCOS       ,FAMN       ,FAMX       ,
     +                UVMG       ,FAIR       ,FAWR       ,FAWF       ,
     +                FAXR       ,FAXF       ,FAYR       ,FAYF       ,
     +                AROX(8)    ,AROY(8)    ,FXSZ       ,FYSZ       ,
     +                FXRF       ,FXMN       ,FYRF       ,FYMN       ,
     +                FWRF       ,FWMN       ,FIRF       ,FIMN       ,
     +                AXMN       ,AXMX       ,AYMN       ,AYMX       ,
     +                IACM       ,IAFO       ,WBAD       ,WBTF       ,
     +                WBCF       ,WBDF       ,WBSC
C
C
C Text related parameters
C
        COMMON /VVTXP /
     +                FCWM    ,ICSZ    ,
     +                FMNS    ,FMNX    ,FMNY    ,IMNP    ,IMNC  ,
     +                FMXS    ,FMXX    ,FMXY    ,IMXP    ,IMXC  ,
     +                FZFS    ,FZFX    ,FZFY    ,IZFP    ,IZFC  ,
     +                FILS    ,FILX    ,FILY    ,IILP    ,IILC  ,
     +                FLBS    ,ILBC

C
C Character variable declartions
C
      CHARACTER*160 CSTR
      PARAMETER (IPCHSZ=36)
      CHARACTER*(IPCHSZ)  CMNT,CMXT,CZFT,CLBT,CILT
C
C Text string parameters
C
      COMMON /VVCHAR/ CSTR,CMNT,CMXT,CZFT,CLBT,CILT
C
      SAVE /VVCOM/, /VVARO/, /VVTXP/, /VVCHAR/
C
C The mapping common block: made available to user mapping routines
C
      COMMON /VVMAP/
     +                IMAP       ,
     +                XVPL       ,XVPR       ,YVPB       ,YVPT       ,
     +                WXMN       ,WXMX       ,WYMN       ,WYMX       ,
     +                XLOV       ,XHIV       ,YLOV       ,YHIV       ,
     +                SXDC       ,SYDC       ,NXCT       ,NYCT       ,
     +                RLEN       ,LNLG       ,INVX       ,INVY       ,
     +                ITRT       ,IWCT       ,FW2W       ,FH2H       ,
     +                DVMN       ,DVMX       ,RBIG       ,IBIG
C
      SAVE /VVMAP/
C
C Math constants
C
      PARAMETER (PDTOR  = 0.017453292519943,
     +           PRTOD  = 57.2957795130823,
     +           P1XPI  = 3.14159265358979,
     +           P2XPI  = 6.28318530717959,
     +           P1D2PI = 1.57079632679489,
     +           P5D2PI = 7.85398163397448) 
C
C --------------------------------------------------------------------
C
C Local parameters
C
C Number of points in an arrow
C
      PARAMETER (IPAPCT=6)
C
C Local arrays
C
      DIMENSION IAI(IPAGMX), IAG(IPAGMX)
      DIMENSION XF(IPAPCT), YF(IPAPCT)
      DIMENSION XO(IPAPCT), YO(IPAPCT)
      DIMENSION WIN(4),VPT(4)
C
      CHARACTER*10 LBL
C
      IF (VLN.LT.0.0) THEN
         ISZ=1
         VLL=-VLN
      ELSE
         ISZ=0
         VLL=VLN
      END IF
C
C Transfer arguments to local variables and compute the vector length.
C
      DX=XE-XB
      DY=YE-YB
C
C Adjust the coordinates of the vector endpoints as implied by the
C vector positioning option.
C
      IF (IVPO .LT. 0) THEN
         XF(4) = XB
         YF(4) = YB
         XF(1) = XB - DX
         YF(1) = YB - DY
      ELSE IF (IVPO .EQ. 0) THEN
         XF(1) = XB - 0.5*DX
         YF(1) = YB - 0.5*DY
         XF(4) = XE - 0.5*DX
         YF(4) = YE - 0.5*DY
      ELSE
         XF(1) = XB
         YF(1) = YB
         XF(4) = XE
         YF(4) = YE
      END IF
C
C Determine the coordinates of the points used to draw the arrowhead.
C If the size is outside the range of the minimum and maximum sizes
C use fixed sizes
C
      C1 = HDSZ
      IF (VLL*C1 .LT. FAMN*FW2W) C1 = FAMN*FW2W/VLL
      IF (VLL*C1 .GT. FAMX*FW2W) C1 = FAMX*FW2W/VLL
C
C Calculate the remaining points in fractional coordinates
C
      XF(3) = XF(4)-C1*(HCOS*DX-HSIN*DY)
      YF(3) = YF(4)-C1*(HCOS*DY+HSIN*DX)
      XF(2) = XF(4)-C1*HINF*DX
      YF(2) = YF(4)-C1*HINF*DY
      XF(5) = XF(4)-C1*(HCOS*DX+HSIN*DY)
      YF(5) = YF(4)-C1*(HCOS*DY-HSIN*DX)
      XF(6) = XF(2)
      YF(6) = YF(2)
C
C
C Early return if just calculating the size
C
      IF (ISZ.EQ.1) THEN
         AYMN = 100.0
         AYMX = -100.
         AXMN = 100.0
         AXMX = -100.0
         DO 60 I=1,IPAPCT
            IF (XF(I) .LT. AXMN) AXMN = XF(I)
            IF (XF(I) .GT. AXMX) AXMX = XF(I)
            IF (YF(I) .LT. AYMN) AYMN = YF(I)
            IF (YF(I) .GT. AYMX) AYMX = YF(I)
 60      CONTINUE
         FXSZ = AXMX-AXMN
         FYSZ = AYMX-AYMN 
C
         RETURN
      END IF
C
C Set the the normalization transformation to an identity. Can't use
C the default transformation because we need to clip to the viewport
C
      CALL GQCNTN(IER,NTR)
      CALL GQNT(NTR,IER,WIN,VPT)
      CALL GSWN(NTR,VPT(1),VPT(2),VPT(3),VPT(4))
C
C Plot the arrow using areas or not, as required.
C
      IF (IDA .GT. 1) THEN
        CALL ARGTAI(IAM,XB,YB,IAI,IAG,IPAGMX,NAI,0)
        CALL VVUDMV(XF,YF,IPAPCT,IAI,IAG,NAI)
      ELSE IF (IDA .EQ. 1) THEN
         CALL ARDRLN(IAM,XF,YF,IPAPCT, 
     +        XO,YO,IPAPCT,IAI,IAG,IPAGMX,VVUDMV)
      ELSE
         CALL GPL(IPAPCT,XF,YF)
      END IF
C
C If requested, put the vector magnitude above the arrow.
C
      IF (NC .GT. 0) THEN
C
         PHI = ATAN2(DY,DX)
         IF (MOD(PHI+P5D2PI,P2XPI) .GT. P1XPI) PHI = PHI+P1XPI
         XC = 0.5*(XF(1)+XF(4))+1.25*FLBS*FW2W*COS(PHI+P1D2PI)
         YC = 0.5*(YF(1)+YF(4))+1.25*FLBS*FW2W*SIN(PHI+P1D2PI)
C
         CALL PLCHLQ(XC,YC,LBL(1:NC),FLBS*FW2W,PRTOD*PHI,0.0)
C
      END IF
C
C Restore the original transformation
C
      CALL GSWN(NTR,WIN(1),WIN(2),WIN(3),WIN(4))
C
C
      RETURN
      END

C
C $Id: nglogo.f,v 1.4 2008-07-27 00:17:18 haley Exp $
C                                                                      
C                Copyright (C)  2002
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE NGLOGO(IWK,X,Y,SIZE,ITYPE,ICOL1,ICOL2)
C
C  Draws a logo on a workstation.  The arguments are:
C
C     IWK (integer)
C       The workstation identifier for the workstation you 
C       want the logo plotted to.
C 
C     X,Y (real)
C       Normalized device coordinates specifying the center position
C       where you want the logo.  Normalized device coordinates are
C       between 0. and 1. and extend over the entire viewport.
C
C     SIZE (real)
C       The desired height of the logo, expressed in normalized device
C       coordinates.
C
C     ITYPE (integer)
C       The logo type.  There are three types:
C         1 - An NCAR logo.  This logo will be drawn in a single
C             color if IWK is not a PostScript workstation.  A full
C             color logo will be put to a PostScript workstation.
C         2 - A UCAR logo (just the UCAR star symbol).
C         3 - "NCAR" in Bell Gothic Black font.
C         4 - "UCAR" in Bell Gothic Black font, 
C         5 - UCAR star logo, plus "UCAR" in Bell Gothic Black font at
C             half the height of the star.  In this case, the 
C             coordinate (X,Y) specifies the center of the star part 
C             of the logo.
C             
C     ICOL1 (integer)
C       The color index to be used for the logo color.  For the
C       NCAR logo on PostScript output, this argument is ignored.
C
C     ICOL2 (integer)
C       A secondary color index used only for logo type 5.  For that
C       type, the UCAR star logo is drawn using color index ICOL1 and
C       the text string "UCAR" is drawn using color index ICOL2.
C 
      SAVE
C
      include 'ngcomn.h'
C
      PARAMETER (MAXACT=50)
      DIMENSION CR(4),IACTWKS(MAXACT)
C
C  Input and output data records for ESCAPE function calls.
C
      CHARACTER*80 IDR,CDUM,CTM
      CHARACTER*1  SCH
C
C  Check for an uncleared prior error.
C
      IDR = ' '
      IF (ICFELL('NGLOGO - Uncleared prior error',1) .NE. 0) RETURN
C
C  Turn clipping off.
C
      CALL GQCLIP(IER,IOLDCLIP,CR)
      CALL GSCLIP(0)
C
C  Get the number of the current transformation so it can be
C  restored at the end.
C
      CALL GQCNTN(IER,NTNR)
C
C  Determine the number of active workstations.
C
      CALL GQACWK(1,IER,NUMACT,IDM)
C
C  Check to see if IWK is among the active workstations.
C
      NOTIN = 1
      DO 10 I=1,NUMACT
        CALL GQACWK(I,IER,NUMACT,IACTWKS(I))
        IF (IACTWKS(I) .EQ. IWK) NOTIN = 0
   10 CONTINUE
      IF (NOTIN .EQ. 1) THEN 
        CTM(1:47) = 'NGLOGO - argument 1, workstation is not active.'
        RETURN
      ENDIF
C
C  Deactivate all workstations and reactivate IWK.
C
      DO 15 I=1,NUMACT
        CALL GDAWK(IACTWKS(I))
   15 CONTINUE
      CALL GACWK(IWK)
C
C  Determine some original settings for Plotchar to restore
C  at the end.
C
      CALL PCGETI('CC',ICOLOR)
      CALL PCGETI('FN',IFONT)
      CALL PCGETI('TE',ITEOLD)
      CALL PCGETC('FC',SCH)
C
      XN = X
      YN = Y
      SN = SIZE
C
C  Use the identity transformation.
C
      CALL GETSET(VX1,VX2,VY1,VY2,WX1,WX2,WY1,WY2,ISC)
      CALL SET(0.,1.,0.,1.,0.,1.,0.,1.,1)
      CALL PCSETC('FC',':')
C
C  NCAR logo.
C
      IF (ITYPE .EQ. 1) THEN
C
C  Handle the case for PostScript workstations where the
C  full color logo is put out.
C
        CALL GQWKC(IWK,IER,ICONID,IWTYP)
        IF (IWTYP.GE.20.AND.IWTYP.LE.31) THEN
C
          WRITE(IDR( 1: 5),501) IWK
          WRITE(IDR( 6:13),500) XN
          WRITE(IDR(14:21),500) YN
          WRITE(IDR(22:29),500) SN
C
  500     FORMAT(F8.4)
  501     FORMAT(I5)
C
          CALL GESC(-1527,1,IDR,1,IDUM,CDUM)
C
C  Handle the case for non-PostScript workstations.
C
        ELSE
          CALL PCSETI('CC',ICOL1)
          CALL PLCHHQ(X,Y,':F35:t',0.85*SN,0.,0.)
        ENDIF
C
C  UCAR logo - star only.
C
      ELSE IF (ITYPE .EQ. 2) THEN
        CALL PCSETI('CC',ICOL1)
C
C  "x" is digitized to look better at smaller sizes.
C
        IF (SN .GE. 0.125) THEN
          CALL PLCHHQ(XN,YN,':F35:u',0.85*SN,0.,0.)
        ELSE
          CALL PLCHHQ(XN,YN,':F35:x',0.85*SN,0.,0.)
        ENDIF
C
C  "NCAR" text only.
C
      ELSE IF (ITYPE .EQ. 3) THEN
        CALL PCSETI('CC',ICOL1)
        CALL PLCHHQ(XN,YN,':F35:v',0.85*SN,0.,0.)
C
C  "UCAR" text only.
C
      ELSE IF (ITYPE .EQ. 4) THEN
        CALL PCSETI('CC',ICOL1)
        CALL PLCHHQ(XN,YN,':F35:w',0.85*SN,0.,0.)
C
C  UCAR star logo with "UCAR" text.
C
      ELSE IF (ITYPE .EQ. 5) THEN
        CALL PCSETI('TE',1)
        CALL PCSETI('CC',ICOL1)
C
C  "x" is digitized to look better at smaller sizes.
C
        IF (SN .GE. 0.125) THEN
          CALL PLCHHQ(XN,YN,':F35:u',0.85*SN,0.,0.)
        ELSE
          CALL PLCHHQ(XN,YN,':F35:x',0.85*SN,0.,0.)
        ENDIF
        CALL PCGETR ('XE',XE)
        CALL PCSETI('CC',ICOL2)
        CALL PLCHHQ(XE,YN,':F35:w',0.425*SN,0.,-1.)
C
      ENDIF
C
C  Reactivate all deactivated workstations.
C
      DO 20 I=1,NUMACT
        IF (IACTWKS(I) .NE. IWK) CALL GACWK(IACTWKS(I))
   20 CONTINUE
C
C  Restore original settings.
C
      CALL SET(VX1,VX2,VY1,VY2,WX1,WX2,WY1,WY2,ISC)
      CALL GSELNT(NTNR)
      CALL GSCLIP(IOLDCLIP)
      CALL PCSETI('CC',ICOLOR)
      CALL PCSETI('FN',IFONT)
      CALL PCSETI('TE',ITEOLD)
      CALL PCSETC('FC',SCH)
C
      RETURN
      END

C
C	$Id: gqpa.f,v 1.5 2008-07-27 00:21:00 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GQPA(ERRIND,PWX,PWY,PHX,PHY)
C
C  INQUIRE PATTERN SIZE
C
      include 'gkscom.h'
C
      INTEGER ERRIND
      REAL    PWX,PWY,PHX,PHY
C
C  Check if GKS is in the proper state.
C
      CALL GZCKST(8,-1,ERRIND)
      IF (ERRIND.EQ.0) THEN
C
C  Pattern width and height vectors will always be along the 
C  coordinate axes since no metafile interpretation functions 
C  are in the package.
C
        PWX = CPA(1)
        PWY = 0.
        PHX = 0.
        PHY = CPA(2)
      ELSE
        PWX = -1.
        PWY = -1.
        PHX = -1.
        PHY = -1.
      ENDIF
C
      RETURN
      END

C
C	$Id: pwrybd.f,v 1.5 2008-07-27 00:17:21 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE PWRYBD
C
C Calling this do-nothing subroutine forces "ld" to load the following
C block data routine (but only if they are in the same ".f" file).
C
        RETURN
C
      END
CNOSPLIT
      BLOCKDATA PWRYBDX
      COMMON /PWRCOM/ USABLE
      LOGICAL         USABLE
      DATA USABLE/.FALSE./
C REVISION HISTORY------
C FEBURARY 1979    CREATED NEW ALGORITHM PWRITY TO REPLACE PWRY
C                  ADDED REVISION HISTORY
C JUNE 1979        CHANGE ARGUMENT THETA IN PWRITY FROM FLOATING TO
C                  INTEGER, USING ITHETA AS THE NEW NAME.  ITS
C                  MEANING IS NOW DEGREES INSTEAD OF RADIANS.
C JULY 1984        CONVERTED TO FORTRAN 77 AND GKS
C-----------------------------------------------------------------------
      END

      REAL             FUNCTION CLANGB( NORM, N, KL, KU, AB, LDAB,
     $                 WORK )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     October 31, 1992
*
*     .. Scalar Arguments ..
      CHARACTER          NORM
      INTEGER            KL, KU, LDAB, N
*     ..
*     .. Array Arguments ..
      REAL               WORK( * )
      COMPLEX            AB( LDAB, * )
*     ..
*
*  Purpose
*  =======
*
*  CLANGB  returns the value of the one norm,  or the Frobenius norm, or
*  the  infinity norm,  or the element of  largest absolute value  of an
*  n by n band matrix  A,  with kl sub-diagonals and ku super-diagonals.
*
*  Description
*  ===========
*
*  CLANGB returns the value
*
*     CLANGB = ( max(abs(A(i,j))), NORM = 'M' or 'm'
*              (
*              ( norm1(A),         NORM = '1', 'O' or 'o'
*              (
*              ( normI(A),         NORM = 'I' or 'i'
*              (
*              ( normF(A),         NORM = 'F', 'f', 'E' or 'e'
*
*  where  norm1  denotes the  one norm of a matrix (maximum column sum),
*  normI  denotes the  infinity norm  of a matrix  (maximum row sum) and
*  normF  denotes the  Frobenius norm of a matrix (square root of sum of
*  squares).  Note that  max(abs(A(i,j)))  is not a  matrix norm.
*
*  Arguments
*  =========
*
*  NORM    (input) CHARACTER*1
*          Specifies the value to be returned in CLANGB as described
*          above.
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.  When N = 0, CLANGB is
*          set to zero.
*
*  KL      (input) INTEGER
*          The number of sub-diagonals of the matrix A.  KL >= 0.
*
*  KU      (input) INTEGER
*          The number of super-diagonals of the matrix A.  KU >= 0.
*
*  AB      (input) COMPLEX array, dimension (LDAB,N)
*          The band matrix A, stored in rows 1 to KL+KU+1.  The j-th
*          column of A is stored in the j-th column of the array AB as
*          follows:
*          AB(ku+1+i-j,j) = A(i,j) for max(1,j-ku)<=i<=min(n,j+kl).
*
*  LDAB    (input) INTEGER
*          The leading dimension of the array AB.  LDAB >= KL+KU+1.
*
*  WORK    (workspace) REAL array, dimension (LWORK),
*          where LWORK >= N when NORM = 'I'; otherwise, WORK is not
*          referenced.
*
* =====================================================================
*
*     .. Parameters ..
      REAL               ONE, ZERO
      PARAMETER          ( ONE = 1.0E+0, ZERO = 0.0E+0 )
*     ..
*     .. Local Scalars ..
      INTEGER            I, J, K, L
      REAL               SCALE, SUM, VALUE
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           CLASSQ
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, MAX, MIN, SQRT
*     ..
*     .. Executable Statements ..
*
      IF( N.EQ.0 ) THEN
         VALUE = ZERO
      ELSE IF( LSAME( NORM, 'M' ) ) THEN
*
*        Find max(abs(A(i,j))).
*
         VALUE = ZERO
         DO 20 J = 1, N
            DO 10 I = MAX( KU+2-J, 1 ), MIN( N+KU+1-J, KL+KU+1 )
               VALUE = MAX( VALUE, ABS( AB( I, J ) ) )
   10       CONTINUE
   20    CONTINUE
      ELSE IF( ( LSAME( NORM, 'O' ) ) .OR. ( NORM.EQ.'1' ) ) THEN
*
*        Find norm1(A).
*
         VALUE = ZERO
         DO 40 J = 1, N
            SUM = ZERO
            DO 30 I = MAX( KU+2-J, 1 ), MIN( N+KU+1-J, KL+KU+1 )
               SUM = SUM + ABS( AB( I, J ) )
   30       CONTINUE
            VALUE = MAX( VALUE, SUM )
   40    CONTINUE
      ELSE IF( LSAME( NORM, 'I' ) ) THEN
*
*        Find normI(A).
*
         DO 50 I = 1, N
            WORK( I ) = ZERO
   50    CONTINUE
         DO 70 J = 1, N
            K = KU + 1 - J
            DO 60 I = MAX( 1, J-KU ), MIN( N, J+KL )
               WORK( I ) = WORK( I ) + ABS( AB( K+I, J ) )
   60       CONTINUE
   70    CONTINUE
         VALUE = ZERO
         DO 80 I = 1, N
            VALUE = MAX( VALUE, WORK( I ) )
   80    CONTINUE
      ELSE IF( ( LSAME( NORM, 'F' ) ) .OR. ( LSAME( NORM, 'E' ) ) ) THEN
*
*        Find normF(A).
*
         SCALE = ZERO
         SUM = ONE
         DO 90 J = 1, N
            L = MAX( 1, J-KU )
            K = KU + 1 - J + L
            CALL CLASSQ( MIN( N, J+KL )-L+1, AB( K, J ), 1, SCALE, SUM )
   90    CONTINUE
         VALUE = SCALE*SQRT( SUM )
      END IF
*
      CLANGB = VALUE
      RETURN
*
*     End of CLANGB
*
      END

      double precision function dzasum(n,zx,incx)
c
c     takes the sum of the absolute values.
c     jack dongarra, 3/11/78.
c     modified 3/93 to return if incx .le. 0.
c     modified 12/3/93, array(1) declarations changed to array(*)
c
      double complex zx(*)
      double precision stemp,dcabs1
      integer i,incx,ix,n
c
      dzasum = 0.0d0
      stemp = 0.0d0
      if( n.le.0 .or. incx.le.0 )return
      if(incx.eq.1)go to 20
c
c        code for increment not equal to 1
c
      ix = 1
      do 10 i = 1,n
        stemp = stemp + dcabs1(zx(ix))
        ix = ix + incx
   10 continue
      dzasum = stemp
      return
c
c        code for increment equal to 1
c
   20 do 30 i = 1,n
        stemp = stemp + dcabs1(zx(i))
   30 continue
      dzasum = stemp
      return
      end

      PROGRAM STEX03
C
C Example STEX03 draws a uniform southwesterly field on ten
C different EZMAP projections. A streamline representation overlays
C a rendering using vectors. Polar input mode is employed: all members
C of the U array, representing magnitude, are set to 1.0, while the
C V array contains the directional component, -135.0 degrees.
C
C All projections use the maximum possible extent of the globe, except
C except for frame 3, a Lambert Conical projection, for which a full
C globe projection is impossible.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C  
      PARAMETER (M=25, N=25)
      DIMENSION A(M,N),B(M,N),WRK(M*N*2)
C
C     Open GKS, open workstation, activate workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C     Generate the polar input mode component arrays.
C
      DO 2 I=1,M
         DO 1 J=1,N
            A(I,J) = 1.0
            B(I,J) = -135.0
 1       CONTINUE
 2    CONTINUE
C
C Set up a GKS color table
C
      CALL DFCLRS(IWKID)
C
C Do 10 different EZMAP projections, with Vectors and Streamlines
C superimposed
C
      DO 1000 I=1,10,1 
C
C Draw the map projections
C
         IF (I .EQ. 3) THEN
            CALL SUPMAP (3,0.,80.,70.,90.,80.,0.,0.,2,20,4,0,IERS)
         ELSE
            CALL SUPMAP (I,0.,0.,0.,0.,0.,0.,0.,1,20,2,0,IERS)
         END IF
C
C Set the Vectors coordinate parameters appropriately for a full
C globe polar input mode dataset projected using EZMAP
C
         CALL VVSETI('MAP -- Mapping Flag', 1)
         CALL VVSETI('SET -- Set Call Flag', 0)
         CALL VVSETR('XC1 -- Lower X Bound', -180.0)
         CALL VVSETR('XCM -- Upper X Bound', 180.0)
         CALL VVSETR('YC1 -- Lower Y Bound', -90.0)
         CALL VVSETR('YCN -- Upper Y Bound', 90.0)
         CALL VVSETI('PLR -- Vector Polar Flag', 1)
C
C Set the Streamlines coordinate parameters appropriately for a full
C globe polar input mode dataset projected using EZMAP
C
         CALL STSETI('MAP -- Mapping Flag', 1)
         CALL STSETI('SET -- Set Call Flag', 0)
         CALL STSETR('XC1 -- Lower X Bound', -180.0)
         CALL STSETR('XCM -- Upper X Bound', 180.0)
         CALL STSETR('YC1 -- Lower Y Bound', -90.0)
         CALL STSETR('YCN -- Upper Y Bound', 90.0)
         CALL STSETI('PLR -- Vector Polar Flag', 1)
C
C Draw the Vectors in one color
C
         CALL GSPLCI(3)
         CALL VVINIT(A,M,B,M,IDM,IDM,M,N,IDM,IDM,IDM,IDM)
         CALL VVECTR(A,B,IDM,IDM,IDM,IDM,IDM)
C
C Draw the Streamlines in another color
C
         CALL GSPLCI(7)
         CALL STINIT(A,M,B,M,IDM,IDM,M,N,WRK,2*M*N)
         CALL STREAM(A,B,IDM,IDM,IDM,WRK)
C
C Reset the color to the default color index and advance the frame.
C
         CALL GSPLCI(1)
         CALL FRAME
C
 1000 CONTINUE
C
C     Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END
C
C ==============================================================
C
      SUBROUTINE DFCLRS(IWKID)
C
C Define a set of RGB color triples for colors 0 through 15.
C
      PARAMETER (NCLRS=16)
      DIMENSION RGBV(3,NCLRS)
C
C Define the RGB color triples needed below.
C
      DATA RGBV / 
     +     0.00 , 0.00 , 0.00 ,
     +     1.00 , 1.00 , 1.00 ,
     +     0.70 , 0.70 , 0.70 ,
     +     0.75 , 0.50 , 1.00 ,
     +     0.50 , 0.00 , 1.00 ,
     +     0.00 , 0.00 , 1.00 ,
     +     0.00 , 0.50 , 1.00 ,
     +     0.00 , 1.00 , 1.00 ,
     +     0.00 , 1.00 , 0.60 ,
     +     0.00 , 1.00 , 0.00 ,
     +     0.70 , 1.00 , 0.00 ,
     +     1.00 , 1.00 , 0.00 ,
     +     1.00 , 0.75 , 0.00 ,
     +     1.00 , 0.38 , 0.38 ,
     +     1.00 , 0.00 , 0.38 ,
     +     1.00 , 0.00 , 0.00 /
C
C Define 16 different color indices, for indices 0 through 15.  The
C color corresponding to index 0 is black and the color corresponding
C to index 1 is white.
C
      DO 101 I=1,NCLRS
         CALL GSCR (IWKID,I-1,RGBV(1,I),RGBV(2,I),RGBV(3,I))
 101  CONTINUE
C
C Done.
C
        RETURN
C
      END
C

      SUBROUTINE SGERQF( M, N, A, LDA, TAU, WORK, LWORK, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      INTEGER            INFO, LDA, LWORK, M, N
*     ..
*     .. Array Arguments ..
      REAL               A( LDA, * ), TAU( * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  SGERQF computes an RQ factorization of a real M-by-N matrix A:
*  A = R * Q.
*
*  Arguments
*  =========
*
*  M       (input) INTEGER
*          The number of rows of the matrix A.  M >= 0.
*
*  N       (input) INTEGER
*          The number of columns of the matrix A.  N >= 0.
*
*  A       (input/output) REAL array, dimension (LDA,N)
*          On entry, the M-by-N matrix A.
*          On exit,
*          if m <= n, the upper triangle of the subarray
*          A(1:m,n-m+1:n) contains the M-by-M upper triangular matrix R;
*          if m >= n, the elements on and above the (m-n)-th subdiagonal
*          contain the M-by-N upper trapezoidal matrix R;
*          the remaining elements, with the array TAU, represent the
*          orthogonal matrix Q as a product of min(m,n) elementary
*          reflectors (see Further Details).
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(1,M).
*
*  TAU     (output) REAL array, dimension (min(M,N))
*          The scalar factors of the elementary reflectors (see Further
*          Details).
*
*  WORK    (workspace/output) REAL array, dimension (LWORK)
*          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*
*  LWORK   (input) INTEGER
*          The dimension of the array WORK.  LWORK >= max(1,M).
*          For optimum performance LWORK >= M*NB, where NB is
*          the optimal blocksize.
*
*          If LWORK = -1, then a workspace query is assumed; the routine
*          only calculates the optimal size of the WORK array, returns
*          this value as the first entry of the WORK array, and no error
*          message related to LWORK is issued by XERBLA.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*
*  Further Details
*  ===============
*
*  The matrix Q is represented as a product of elementary reflectors
*
*     Q = H(1) H(2) . . . H(k), where k = min(m,n).
*
*  Each H(i) has the form
*
*     H(i) = I - tau * v * v'
*
*  where tau is a real scalar, and v is a real vector with
*  v(n-k+i+1:n) = 0 and v(n-k+i) = 1; v(1:n-k+i-1) is stored on exit in
*  A(m-k+i,1:n-k+i-1), and tau in TAU(i).
*
*  =====================================================================
*
*     .. Local Scalars ..
      LOGICAL            LQUERY
      INTEGER            I, IB, IINFO, IWS, K, KI, KK, LDWORK, LWKOPT,
     $                   MU, NB, NBMIN, NU, NX
*     ..
*     .. External Subroutines ..
      EXTERNAL           SGERQ2, SLARFB, SLARFT, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN
*     ..
*     .. External Functions ..
      INTEGER            ILAENV
      EXTERNAL           ILAENV
*     ..
*     .. Executable Statements ..
*
*     Test the input arguments
*
      INFO = 0
      NB = ILAENV( 1, 'SGERQF', ' ', M, N, -1, -1 )
      LWKOPT = M*NB
      WORK( 1 ) = LWKOPT
      LQUERY = ( LWORK.EQ.-1 )
      IF( M.LT.0 ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( LDA.LT.MAX( 1, M ) ) THEN
         INFO = -4
      ELSE IF( LWORK.LT.MAX( 1, M ) .AND. .NOT.LQUERY ) THEN
         INFO = -7
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'SGERQF', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         RETURN
      END IF
*
*     Quick return if possible
*
      K = MIN( M, N )
      IF( K.EQ.0 ) THEN
         WORK( 1 ) = 1
         RETURN
      END IF
*
      NBMIN = 2
      NX = 1
      IWS = M
      IF( NB.GT.1 .AND. NB.LT.K ) THEN
*
*        Determine when to cross over from blocked to unblocked code.
*
         NX = MAX( 0, ILAENV( 3, 'SGERQF', ' ', M, N, -1, -1 ) )
         IF( NX.LT.K ) THEN
*
*           Determine if workspace is large enough for blocked code.
*
            LDWORK = M
            IWS = LDWORK*NB
            IF( LWORK.LT.IWS ) THEN
*
*              Not enough workspace to use optimal NB:  reduce NB and
*              determine the minimum value of NB.
*
               NB = LWORK / LDWORK
               NBMIN = MAX( 2, ILAENV( 2, 'SGERQF', ' ', M, N, -1,
     $                 -1 ) )
            END IF
         END IF
      END IF
*
      IF( NB.GE.NBMIN .AND. NB.LT.K .AND. NX.LT.K ) THEN
*
*        Use blocked code initially.
*        The last kk rows are handled by the block method.
*
         KI = ( ( K-NX-1 ) / NB )*NB
         KK = MIN( K, KI+NB )
*
         DO 10 I = K - KK + KI + 1, K - KK + 1, -NB
            IB = MIN( K-I+1, NB )
*
*           Compute the RQ factorization of the current block
*           A(m-k+i:m-k+i+ib-1,1:n-k+i+ib-1)
*
            CALL SGERQ2( IB, N-K+I+IB-1, A( M-K+I, 1 ), LDA, TAU( I ),
     $                   WORK, IINFO )
            IF( M-K+I.GT.1 ) THEN
*
*              Form the triangular factor of the block reflector
*              H = H(i+ib-1) . . . H(i+1) H(i)
*
               CALL SLARFT( 'Backward', 'Rowwise', N-K+I+IB-1, IB,
     $                      A( M-K+I, 1 ), LDA, TAU( I ), WORK, LDWORK )
*
*              Apply H to A(1:m-k+i-1,1:n-k+i+ib-1) from the right
*
               CALL SLARFB( 'Right', 'No transpose', 'Backward',
     $                      'Rowwise', M-K+I-1, N-K+I+IB-1, IB,
     $                      A( M-K+I, 1 ), LDA, WORK, LDWORK, A, LDA,
     $                      WORK( IB+1 ), LDWORK )
            END IF
   10    CONTINUE
         MU = M - K + I + NB - 1
         NU = N - K + I + NB - 1
      ELSE
         MU = M
         NU = N
      END IF
*
*     Use unblocked code to factor the last or only block
*
      IF( MU.GT.0 .AND. NU.GT.0 )
     $   CALL SGERQ2( MU, NU, A, LDA, TAU, WORK, IINFO )
*
      WORK( 1 ) = IWS
      RETURN
*
*     End of SGERQF
*
      END

      SUBROUTINE ZLARCM( M, N, A, LDA, B, LDB, C, LDC, RWORK )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      INTEGER            LDA, LDB, LDC, M, N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), RWORK( * )
      COMPLEX*16         B( LDB, * ), C( LDC, * )
*     ..
*
*  Purpose
*  =======
*
*  ZLARCM performs a very simple matrix-matrix multiplication:
*           C := A * B,
*  where A is M by M and real; B is M by N and complex;
*  C is M by N and complex.
*
*  Arguments
*  =========
*
*  M       (input) INTEGER
*          The number of rows of the matrix A and of the matrix C.
*          M >= 0.
*
*  N       (input) INTEGER
*          The number of columns and rows of the matrix B and
*          the number of columns of the matrix C.
*          N >= 0.
*
*  A       (input) DOUBLE PRECISION array, dimension (LDA, M)
*          A contains the M by M matrix A.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A. LDA >=max(1,M).
*
*  B       (input) DOUBLE PRECISION array, dimension (LDB, N)
*          B contains the M by N matrix B.
*
*  LDB     (input) INTEGER
*          The leading dimension of the array B. LDB >=max(1,M).
*
*  C       (input) COMPLEX*16 array, dimension (LDC, N)
*          C contains the M by N matrix C.
*
*  LDC     (input) INTEGER
*          The leading dimension of the array C. LDC >=max(1,M).
*
*  RWORK   (workspace) DOUBLE PRECISION array, dimension (2*M*N)
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ONE, ZERO
      PARAMETER          ( ONE = 1.0D0, ZERO = 0.0D0 )
*     ..
*     .. Local Scalars ..
      INTEGER            I, J, L
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          DBLE, DCMPLX, DIMAG
*     ..
*     .. External Subroutines ..
      EXTERNAL           DGEMM
*     ..
*     .. Executable Statements ..
*
*     Quick return if possible.
*
      IF( ( M.EQ.0 ) .OR. ( N.EQ.0 ) )
     $   RETURN
*
      DO 20 J = 1, N
         DO 10 I = 1, M
            RWORK( ( J-1 )*M+I ) = DBLE( B( I, J ) )
   10    CONTINUE
   20 CONTINUE
*
      L = M*N + 1
      CALL DGEMM( 'N', 'N', M, N, M, ONE, A, LDA, RWORK, M, ZERO,
     $            RWORK( L ), M )
      DO 40 J = 1, N
         DO 30 I = 1, M
            C( I, J ) = RWORK( L+( J-1 )*M+I-1 )
   30    CONTINUE
   40 CONTINUE
*
      DO 60 J = 1, N
         DO 50 I = 1, M
            RWORK( ( J-1 )*M+I ) = DIMAG( B( I, J ) )
   50    CONTINUE
   60 CONTINUE
      CALL DGEMM( 'N', 'N', M, N, M, ONE, A, LDA, RWORK, M, ZERO,
     $            RWORK( L ), M )
      DO 80 J = 1, N
         DO 70 I = 1, M
            C( I, J ) = DCMPLX( DBLE( C( I, J ) ),
     $                  RWORK( L+( J-1 )*M+I-1 ) )
   70    CONTINUE
   80 CONTINUE
*
      RETURN
*
*     End of ZLARCM
*
      END

C
C	$Id: gstxp.f,v 1.5 2008-07-27 00:21:02 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GSTXP (TXP)
C
C  SET TEXT PATH
C
      INTEGER ESTXP
      PARAMETER (ESTXP=33)
C
      include 'gkscom.h'
C
      INTEGER TXP
C
C  Check if GKS is in the proper state.
C
      CALL GZCKST(8,ESTXP,IER)
      IF (IER .NE. 0) RETURN
C
C  Check that the path is valid.
C
      IF (TXP.LT.0 .OR. TXP.GT.3) THEN
        ERS = 1
        CALL GERHND(2000,ESTXP,ERF)
        ERS = 0
        RETURN
      ENDIF
C
C  Set the current text path in the GKS state list.
C
      CTXP = TXP
C
C  Invoke the workstation interface.
C
      FCODE = 35
      CONT  = 0
      CALL GZROI(0)
      IL1   = 1
      IL2   = 1
      ID(1) = TXP
      CALL GZTOWK
      IF (RERR .NE. 0) THEN
        ERS = 1
        CALL GERHND(RERR,ESTXP,ERF)
        ERS = 0
      ENDIF
C
      RETURN
      END

      PROGRAM CSEX07
C
C  Do a 2D approximation using a list of output coordinates.  
C
C
C  The dimensionality of the problem.
C
      PARAMETER (NDIM=2)
C
C  The number of input data points.
C
      PARAMETER (NDATA=500)
C
C  The number of output data points in the X coordinate direction.
C
      PARAMETER (NX=29)
C
C  The number of output data points in the Y coordinate direction.
C
      PARAMETER (NY=25)
C
C  The number of output data points.
C
      PARAMETER (NO=NX*NY)
C
C  Specifty the number of knots in the X direction.
C
      PARAMETER (N1=10)
C
C  Specifty the number of knots in the Y direction.
C
      PARAMETER (N2=10)
C
C  The size of the workspace.
C
      PARAMETER (NCF=N1*N2, NWRK=NCF*(NCF+3))
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C  Dimension the arrays.
C
      DIMENSION XDATA(NDIM,NDATA),YDATA(NDATA),NODES(NDIM),WORK(NWRK)
      DATA XMIN,YMIN,XMAX,YMAX / -1.4, -1.2, 1.4, 1.2/
      REAL XO(NO),  YO(NO), OUTPUT(NO)
      REAL XP(NX),  YP(NY), OPLOT(NX,NY)
C
C  Create the data array for the surface.
C
      DO 10 I=1,NDATA
        XDATA(1,I) = XMIN+(XMAX-XMIN)*DSRND1()
        XDATA(2,I) = YMIN+(YMAX-YMIN)*DSRND1()
        YDATA(I)   = XDATA(1,I) + XDATA(2,I)
        T1 = 1.0/((ABS(XDATA(1,I)-0.1))**2.75 +
     +                     ABS(XDATA(2,I))**2.75+0.09)
        T2 = 1.0/((ABS(XDATA(1,I)+0.1))**2.75 +
     +                     ABS(XDATA(2,I))**2.75+0.09)
        YDATA(I) = 0.3*(YDATA(I)+T1-T2)
   10 CONTINUE
C
C  Create the output arrays.
C
      INDX = 0
      DO 103 J=1,NY
        DO 104 I=1,NX
          INDX = INDX+1
          XO(INDX) = XMIN+(REAL(I-1)/REAL(NX-1))*(XMAX-XMIN)
          YO(INDX) = YMIN+(REAL(J-1)/REAL(NY-1))*(YMAX-YMIN)
  104   CONTINUE
  103 CONTINUE
C
C  Specify the numbers of nodes in each coordinate.
C
      NODES(1) = N1
      NODES(2) = N2
C
      CALL CSA2LS (NDATA,XDATA,YDATA,NODES,NO,XO,YO,
     +             OUTPUT,NWRK,WORK,IER)
C
C  Plot the 2D surface approximation.
C
C Open GKS and define the foreground and background color.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C  Convert the linear output array to a 2D array.
C
      DO 21 I=1,NX
        DO 22 J=1,NY
            OPLOT(I,J) = OUTPUT((J-1)*NX + I)
   22   CONTINUE
   21 CONTINUE
C
C  Create the output grid for plotting.
C
      DO 105 I=1,NX
        XP(I) = XMIN+(REAL(I-1)/REAL(NX-1))*(XMAX-XMIN)
  105 CONTINUE
      DO 106 J=1,NY
        YP(J) = YMIN+(REAL(J-1)/REAL(NY-1))*(YMAX-YMIN)
  106 CONTINUE
C
C  Plot the surface.
C
      CALL TDEZ2D(NX, NY, XP, YP, OPLOT, 2.5, -154., 80., 6)
      CALL FRAME()
C
C Close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END
      REAL FUNCTION DSRND1()
C
C  Portable random number generator.
C
      PARAMETER (MPLIER=16807,MODLUS=2147483647,MOBYMP=127773,
     +           MOMDMP=2836)
C
      INTEGER HVLUE, LVLUE, TESTV, NEXTN
      SAVE    NEXTN
      DATA JSEED,IFRST/123456789,0/
C
      IF (IFRST .EQ. 0) THEN
        NEXTN = JSEED
        IFRST = 1
      ENDIF
C
      HVLUE = NEXTN / MOBYMP
      LVLUE = MOD(NEXTN, MOBYMP)
      TESTV = MPLIER*LVLUE - MOMDMP*HVLUE
      IF (TESTV .GT. 0) THEN
        NEXTN = TESTV
      ELSE
        NEXTN = TESTV + MODLUS
      ENDIF
      DSRND1 = REAL(NEXTN)/REAL(MODLUS)
C
      RETURN
      END

      SUBROUTINE CHSEQR( JOB, COMPZ, N, ILO, IHI, H, LDH, W, Z, LDZ,
     $                   WORK, LWORK, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          COMPZ, JOB
      INTEGER            IHI, ILO, INFO, LDH, LDZ, LWORK, N
*     ..
*     .. Array Arguments ..
      COMPLEX            H( LDH, * ), W( * ), WORK( * ), Z( LDZ, * )
*     ..
*
*  Purpose
*  =======
*
*  CHSEQR computes the eigenvalues of a complex upper Hessenberg
*  matrix H, and, optionally, the matrices T and Z from the Schur
*  decomposition H = Z T Z**H, where T is an upper triangular matrix
*  (the Schur form), and Z is the unitary matrix of Schur vectors.
*
*  Optionally Z may be postmultiplied into an input unitary matrix Q,
*  so that this routine can give the Schur factorization of a matrix A
*  which has been reduced to the Hessenberg form H by the unitary
*  matrix Q:  A = Q*H*Q**H = (QZ)*T*(QZ)**H.
*
*  Arguments
*  =========
*
*  JOB     (input) CHARACTER*1
*          = 'E': compute eigenvalues only;
*          = 'S': compute eigenvalues and the Schur form T.
*
*  COMPZ   (input) CHARACTER*1
*          = 'N': no Schur vectors are computed;
*          = 'I': Z is initialized to the unit matrix and the matrix Z
*                 of Schur vectors of H is returned;
*          = 'V': Z must contain an unitary matrix Q on entry, and
*                 the product Q*Z is returned.
*
*  N       (input) INTEGER
*          The order of the matrix H.  N >= 0.
*
*  ILO     (input) INTEGER
*  IHI     (input) INTEGER
*          It is assumed that H is already upper triangular in rows
*          and columns 1:ILO-1 and IHI+1:N. ILO and IHI are normally
*          set by a previous call to CGEBAL, and then passed to CGEHRD
*          when the matrix output by CGEBAL is reduced to Hessenberg
*          form. Otherwise ILO and IHI should be set to 1 and N
*          respectively.
*          1 <= ILO <= IHI <= N, if N > 0; ILO=1 and IHI=0, if N=0.
*
*  H       (input/output) COMPLEX array, dimension (LDH,N)
*          On entry, the upper Hessenberg matrix H.
*          On exit, if JOB = 'S', H contains the upper triangular matrix
*          T from the Schur decomposition (the Schur form). If
*          JOB = 'E', the contents of H are unspecified on exit.
*
*  LDH     (input) INTEGER
*          The leading dimension of the array H. LDH >= max(1,N).
*
*  W       (output) COMPLEX array, dimension (N)
*          The computed eigenvalues. If JOB = 'S', the eigenvalues are
*          stored in the same order as on the diagonal of the Schur form
*          returned in H, with W(i) = H(i,i).
*
*  Z       (input/output) COMPLEX array, dimension (LDZ,N)
*          If COMPZ = 'N': Z is not referenced.
*          If COMPZ = 'I': on entry, Z need not be set, and on exit, Z
*          contains the unitary matrix Z of the Schur vectors of H.
*          If COMPZ = 'V': on entry Z must contain an N-by-N matrix Q,
*          which is assumed to be equal to the unit matrix except for
*          the submatrix Z(ILO:IHI,ILO:IHI); on exit Z contains Q*Z.
*          Normally Q is the unitary matrix generated by CUNGHR after
*          the call to CGEHRD which formed the Hessenberg matrix H.
*
*  LDZ     (input) INTEGER
*          The leading dimension of the array Z.
*          LDZ >= max(1,N) if COMPZ = 'I' or 'V'; LDZ >= 1 otherwise.
*
*  WORK    (workspace/output) COMPLEX array, dimension (LWORK)
*          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*
*  LWORK   (input) INTEGER
*          The dimension of the array WORK.  LWORK >= max(1,N).
*
*          If LWORK = -1, then a workspace query is assumed; the routine
*          only calculates the optimal size of the WORK array, returns
*          this value as the first entry of the WORK array, and no error
*          message related to LWORK is issued by XERBLA.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*          > 0:  if INFO = i, CHSEQR failed to compute all the
*                eigenvalues in a total of 30*(IHI-ILO+1) iterations;
*                elements 1:ilo-1 and i+1:n of W contain those
*                eigenvalues which have been successfully computed.
*
*  =====================================================================
*
*     .. Parameters ..
      COMPLEX            ZERO, ONE
      PARAMETER          ( ZERO = ( 0.0E+0, 0.0E+0 ),
     $                   ONE = ( 1.0E+0, 0.0E+0 ) )
      REAL               RZERO, RONE, CONST
      PARAMETER          ( RZERO = 0.0E+0, RONE = 1.0E+0,
     $                   CONST = 1.5E+0 )
      INTEGER            NSMAX, LDS
      PARAMETER          ( NSMAX = 15, LDS = NSMAX )
*     ..
*     .. Local Scalars ..
      LOGICAL            INITZ, LQUERY, WANTT, WANTZ
      INTEGER            I, I1, I2, IERR, II, ITEMP, ITN, ITS, J, K, L,
     $                   MAXB, NH, NR, NS, NV
      REAL               OVFL, RTEMP, SMLNUM, TST1, ULP, UNFL
      COMPLEX            CDUM, TAU, TEMP
*     ..
*     .. Local Arrays ..
      REAL               RWORK( 1 )
      COMPLEX            S( LDS, NSMAX ), V( NSMAX+1 ), VV( NSMAX+1 )
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            ICAMAX, ILAENV
      REAL               CLANHS, SLAMCH, SLAPY2
      EXTERNAL           LSAME, ICAMAX, ILAENV, CLANHS, SLAMCH, SLAPY2
*     ..
*     .. External Subroutines ..
      EXTERNAL           CCOPY, CGEMV, CLACPY, CLAHQR, CLARFG, CLARFX,
     $                   CLASET, CSCAL, CSSCAL, SLABAD, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, AIMAG, CONJG, MAX, MIN, REAL
*     ..
*     .. Statement Functions ..
      REAL               CABS1
*     ..
*     .. Statement Function definitions ..
      CABS1( CDUM ) = ABS( REAL( CDUM ) ) + ABS( AIMAG( CDUM ) )
*     ..
*     .. Executable Statements ..
*
*     Decode and test the input parameters
*
      WANTT = LSAME( JOB, 'S' )
      INITZ = LSAME( COMPZ, 'I' )
      WANTZ = INITZ .OR. LSAME( COMPZ, 'V' )
*
      INFO = 0
      WORK( 1 ) = MAX( 1, N )
      LQUERY = ( LWORK.EQ.-1 )
      IF( .NOT.LSAME( JOB, 'E' ) .AND. .NOT.WANTT ) THEN
         INFO = -1
      ELSE IF( .NOT.LSAME( COMPZ, 'N' ) .AND. .NOT.WANTZ ) THEN
         INFO = -2
      ELSE IF( N.LT.0 ) THEN
         INFO = -3
      ELSE IF( ILO.LT.1 .OR. ILO.GT.MAX( 1, N ) ) THEN
         INFO = -4
      ELSE IF( IHI.LT.MIN( ILO, N ) .OR. IHI.GT.N ) THEN
         INFO = -5
      ELSE IF( LDH.LT.MAX( 1, N ) ) THEN
         INFO = -7
      ELSE IF( LDZ.LT.1 .OR. WANTZ .AND. LDZ.LT.MAX( 1, N ) ) THEN
         INFO = -10
      ELSE IF( LWORK.LT.MAX( 1, N ) .AND. .NOT.LQUERY ) THEN
         INFO = -12
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'CHSEQR', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         RETURN
      END IF
*
*     Initialize Z, if necessary
*
      IF( INITZ )
     $   CALL CLASET( 'Full', N, N, ZERO, ONE, Z, LDZ )
*
*     Store the eigenvalues isolated by CGEBAL.
*
      DO 10 I = 1, ILO - 1
         W( I ) = H( I, I )
   10 CONTINUE
      DO 20 I = IHI + 1, N
         W( I ) = H( I, I )
   20 CONTINUE
*
*     Quick return if possible.
*
      IF( N.EQ.0 )
     $   RETURN
      IF( ILO.EQ.IHI ) THEN
         W( ILO ) = H( ILO, ILO )
         RETURN
      END IF
*
*     Set rows and columns ILO to IHI to zero below the first
*     subdiagonal.
*
      DO 40 J = ILO, IHI - 2
         DO 30 I = J + 2, N
            H( I, J ) = ZERO
   30    CONTINUE
   40 CONTINUE
      NH = IHI - ILO + 1
*
*     I1 and I2 are the indices of the first row and last column of H
*     to which transformations must be applied. If eigenvalues only are
*     being computed, I1 and I2 are re-set inside the main loop.
*
      IF( WANTT ) THEN
         I1 = 1
         I2 = N
      ELSE
         I1 = ILO
         I2 = IHI
      END IF
*
*     Ensure that the subdiagonal elements are real.
*
      DO 50 I = ILO + 1, IHI
         TEMP = H( I, I-1 )
         IF( AIMAG( TEMP ).NE.RZERO ) THEN
            RTEMP = SLAPY2( REAL( TEMP ), AIMAG( TEMP ) )
            H( I, I-1 ) = RTEMP
            TEMP = TEMP / RTEMP
            IF( I2.GT.I )
     $         CALL CSCAL( I2-I, CONJG( TEMP ), H( I, I+1 ), LDH )
            CALL CSCAL( I-I1, TEMP, H( I1, I ), 1 )
            IF( I.LT.IHI )
     $         H( I+1, I ) = TEMP*H( I+1, I )
            IF( WANTZ )
     $         CALL CSCAL( NH, TEMP, Z( ILO, I ), 1 )
         END IF
   50 CONTINUE
*
*     Determine the order of the multi-shift QR algorithm to be used.
*
      NS = ILAENV( 4, 'CHSEQR', JOB // COMPZ, N, ILO, IHI, -1 )
      MAXB = ILAENV( 8, 'CHSEQR', JOB // COMPZ, N, ILO, IHI, -1 )
      IF( NS.LE.1 .OR. NS.GT.NH .OR. MAXB.GE.NH ) THEN
*
*        Use the standard double-shift algorithm
*
         CALL CLAHQR( WANTT, WANTZ, N, ILO, IHI, H, LDH, W, ILO, IHI, Z,
     $                LDZ, INFO )
         RETURN
      END IF
      MAXB = MAX( 2, MAXB )
      NS = MIN( NS, MAXB, NSMAX )
*
*     Now 1 < NS <= MAXB < NH.
*
*     Set machine-dependent constants for the stopping criterion.
*     If norm(H) <= sqrt(OVFL), overflow should not occur.
*
      UNFL = SLAMCH( 'Safe minimum' )
      OVFL = RONE / UNFL
      CALL SLABAD( UNFL, OVFL )
      ULP = SLAMCH( 'Precision' )
      SMLNUM = UNFL*( NH / ULP )
*
*     ITN is the total number of multiple-shift QR iterations allowed.
*
      ITN = 30*NH
*
*     The main loop begins here. I is the loop index and decreases from
*     IHI to ILO in steps of at most MAXB. Each iteration of the loop
*     works with the active submatrix in rows and columns L to I.
*     Eigenvalues I+1 to IHI have already converged. Either L = ILO, or
*     H(L,L-1) is negligible so that the matrix splits.
*
      I = IHI
   60 CONTINUE
      IF( I.LT.ILO )
     $   GO TO 180
*
*     Perform multiple-shift QR iterations on rows and columns ILO to I
*     until a submatrix of order at most MAXB splits off at the bottom
*     because a subdiagonal element has become negligible.
*
      L = ILO
      DO 160 ITS = 0, ITN
*
*        Look for a single small subdiagonal element.
*
         DO 70 K = I, L + 1, -1
            TST1 = CABS1( H( K-1, K-1 ) ) + CABS1( H( K, K ) )
            IF( TST1.EQ.RZERO )
     $         TST1 = CLANHS( '1', I-L+1, H( L, L ), LDH, RWORK )
            IF( ABS( REAL( H( K, K-1 ) ) ).LE.MAX( ULP*TST1, SMLNUM ) )
     $         GO TO 80
   70    CONTINUE
   80    CONTINUE
         L = K
         IF( L.GT.ILO ) THEN
*
*           H(L,L-1) is negligible.
*
            H( L, L-1 ) = ZERO
         END IF
*
*        Exit from loop if a submatrix of order <= MAXB has split off.
*
         IF( L.GE.I-MAXB+1 )
     $      GO TO 170
*
*        Now the active submatrix is in rows and columns L to I. If
*        eigenvalues only are being computed, only the active submatrix
*        need be transformed.
*
         IF( .NOT.WANTT ) THEN
            I1 = L
            I2 = I
         END IF
*
         IF( ITS.EQ.20 .OR. ITS.EQ.30 ) THEN
*
*           Exceptional shifts.
*
            DO 90 II = I - NS + 1, I
               W( II ) = CONST*( ABS( REAL( H( II, II-1 ) ) )+
     $                   ABS( REAL( H( II, II ) ) ) )
   90       CONTINUE
         ELSE
*
*           Use eigenvalues of trailing submatrix of order NS as shifts.
*
            CALL CLACPY( 'Full', NS, NS, H( I-NS+1, I-NS+1 ), LDH, S,
     $                   LDS )
            CALL CLAHQR( .FALSE., .FALSE., NS, 1, NS, S, LDS,
     $                   W( I-NS+1 ), 1, NS, Z, LDZ, IERR )
            IF( IERR.GT.0 ) THEN
*
*              If CLAHQR failed to compute all NS eigenvalues, use the
*              unconverged diagonal elements as the remaining shifts.
*
               DO 100 II = 1, IERR
                  W( I-NS+II ) = S( II, II )
  100          CONTINUE
            END IF
         END IF
*
*        Form the first column of (G-w(1)) (G-w(2)) . . . (G-w(ns))
*        where G is the Hessenberg submatrix H(L:I,L:I) and w is
*        the vector of shifts (stored in W). The result is
*        stored in the local array V.
*
         V( 1 ) = ONE
         DO 110 II = 2, NS + 1
            V( II ) = ZERO
  110    CONTINUE
         NV = 1
         DO 130 J = I - NS + 1, I
            CALL CCOPY( NV+1, V, 1, VV, 1 )
            CALL CGEMV( 'No transpose', NV+1, NV, ONE, H( L, L ), LDH,
     $                  VV, 1, -W( J ), V, 1 )
            NV = NV + 1
*
*           Scale V(1:NV) so that max(abs(V(i))) = 1. If V is zero,
*           reset it to the unit vector.
*
            ITEMP = ICAMAX( NV, V, 1 )
            RTEMP = CABS1( V( ITEMP ) )
            IF( RTEMP.EQ.RZERO ) THEN
               V( 1 ) = ONE
               DO 120 II = 2, NV
                  V( II ) = ZERO
  120          CONTINUE
            ELSE
               RTEMP = MAX( RTEMP, SMLNUM )
               CALL CSSCAL( NV, RONE / RTEMP, V, 1 )
            END IF
  130    CONTINUE
*
*        Multiple-shift QR step
*
         DO 150 K = L, I - 1
*
*           The first iteration of this loop determines a reflection G
*           from the vector V and applies it from left and right to H,
*           thus creating a nonzero bulge below the subdiagonal.
*
*           Each subsequent iteration determines a reflection G to
*           restore the Hessenberg form in the (K-1)th column, and thus
*           chases the bulge one step toward the bottom of the active
*           submatrix. NR is the order of G.
*
            NR = MIN( NS+1, I-K+1 )
            IF( K.GT.L )
     $         CALL CCOPY( NR, H( K, K-1 ), 1, V, 1 )
            CALL CLARFG( NR, V( 1 ), V( 2 ), 1, TAU )
            IF( K.GT.L ) THEN
               H( K, K-1 ) = V( 1 )
               DO 140 II = K + 1, I
                  H( II, K-1 ) = ZERO
  140          CONTINUE
            END IF
            V( 1 ) = ONE
*
*           Apply G' from the left to transform the rows of the matrix
*           in columns K to I2.
*
            CALL CLARFX( 'Left', NR, I2-K+1, V, CONJG( TAU ), H( K, K ),
     $                   LDH, WORK )
*
*           Apply G from the right to transform the columns of the
*           matrix in rows I1 to min(K+NR,I).
*
            CALL CLARFX( 'Right', MIN( K+NR, I )-I1+1, NR, V, TAU,
     $                   H( I1, K ), LDH, WORK )
*
            IF( WANTZ ) THEN
*
*              Accumulate transformations in the matrix Z
*
               CALL CLARFX( 'Right', NH, NR, V, TAU, Z( ILO, K ), LDZ,
     $                      WORK )
            END IF
  150    CONTINUE
*
*        Ensure that H(I,I-1) is real.
*
         TEMP = H( I, I-1 )
         IF( AIMAG( TEMP ).NE.RZERO ) THEN
            RTEMP = SLAPY2( REAL( TEMP ), AIMAG( TEMP ) )
            H( I, I-1 ) = RTEMP
            TEMP = TEMP / RTEMP
            IF( I2.GT.I )
     $         CALL CSCAL( I2-I, CONJG( TEMP ), H( I, I+1 ), LDH )
            CALL CSCAL( I-I1, TEMP, H( I1, I ), 1 )
            IF( WANTZ ) THEN
               CALL CSCAL( NH, TEMP, Z( ILO, I ), 1 )
            END IF
         END IF
*
  160 CONTINUE
*
*     Failure to converge in remaining number of iterations
*
      INFO = I
      RETURN
*
  170 CONTINUE
*
*     A submatrix of order <= MAXB in rows and columns L to I has split
*     off. Use the double-shift QR algorithm to handle it.
*
      CALL CLAHQR( WANTT, WANTZ, N, L, I, H, LDH, W, ILO, IHI, Z, LDZ,
     $             INFO )
      IF( INFO.GT.0 )
     $   RETURN
*
*     Decrement number of remaining iterations, and return to start of
*     the main loop with a new value of I.
*
      ITN = ITN - ITS
      I = L - 1
      GO TO 60
*
  180 CONTINUE
      WORK( 1 ) = MAX( 1, N )
      RETURN
*
*     End of CHSEQR
*
      END

C
C	$Id: ngblda.f,v 1.19 2010-02-08 05:58:44 fred Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE NGBLDA
C
C Calling this do-nothing subroutine forces "ld" to load the following
C block data routine (but only if they are in the same ".f" file).
C
        RETURN
C
      END
CNOSPLIT
      BLOCKDATA NGBLDAX
C
C  Specify default values for escape functions.
C
      include 'ngcomn.h'
C
C  Workstation IDs initially undefined.
C
      DATA IWKID, IXPS/-1, -1/
C
C  No full background color by default.
C
      DATA IFULLB/0/
C
C  Supression flag for PS.
C
      DATA ISUP/0/
C
C  Maximum stack and path sizes.
C
      DATA ISTKMX, IPTHMX/ 200, 1300/
C
C  Line joins and caps are round.
C
      DATA ILJOIN, ILCAP/ 1, 1/ 
C
C  Page coordinates, in default PostScript coordinate system.
C
      DATA ILLX, ILLY, IURX, IURY/ 36, 126, 576, 666/      
C
C  Page coordinates, in default PostScript coordinate system,
C  used for escape -1526.
C
      DATA NLLX, NLLY, NURX, NURY/ 36, 126, 576, 666/      
C
C  Bounding box for EPS/EPSI output.
C
      DATA MLLX, MLLY, MURX, MURY/ 36, 126, 576, 666/      
C
C  Fill and hatch spacings.
C
      DATA FILSPC, HATSPC/0.0005, .01/
C
C  Miter limit.
C
      DATA RMITER/ 10./
C
C  Nominal linewidth scale.
C
      DATA RNLSCL/ 1./
C
C  Coordinate scale factor.
C
      DATA ICOSCL/25/
C
C  PostScript color model (1=RGB, 0=CMYK)
C
      DATA IPSCM/1/
C
C  Maximum number of GKS errors allowed before abort.
C
      DATA IERRMX/10/
C
C  Flag to control whether GKS clipping is on (0 = no; 1 = yes).
C
      DATA IGKSCP/1/
C
C  Percentage error allow in matching colors in shared X color maps.
C
      DATA IPERCX/20/
C
C  Segment save flag. (1 = delete segments; 0 = save segments)
C
      DATA ISVSEG/1/
C
C  Color model flags
C
      DATA ISCX,IMCX,IPCX/0,0,0/
C
C  Flag for whether an X window should have a private color map.
C  (0 = no; 1 = yes).
C
      DATA IPRIVX/0/
C
C  File name and picture name.
C
      DATA CFILNM,CPICNM/'DEFAULT',' '/
C
C  Flag to NGDOTS to indicate whether to draw dots (=0) or circles (=1).
C
      DATA ICDFLG/0/
C
C  Logo type (1=full NCAR logo, 2=UCAR logo star, 
C             3="NCAR" in Bell Gothic Black font, 
C             4="UCAR" in Bell Gothic Black font, 
C             5=UCAR star logo, plus "UCAR" in Bell Gothic Black font) 
C
      DATA LOGOTYP/1/
C
C  Color indices for logos (primary and secondary colors).
C
      DATA LOGOCOL,LOGOSND/1,1/ 
C
C  Default X,Y NDC coordinate position for logos, and the default  size.
C
      DATA OXLOGO,OYLOGO,OLSIZE/0.93,0.05,0.07/
C
C  Defaults for the PDF bounding media box in 1/72" units.
C
      DATA IPGHGT,IPGWTH/792,612/
C
C  Defaults for the PS paper size in for the setpagedevice, in 1/72" units.
C
      DATA IPSHGT,IPSWTH/792,612/
C
      END

      PROGRAM FSLFONT
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C INVOKE DEMO DRIVER
C
      CALL FSLFNT(IERR)
C
C Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      STOP
      END
      SUBROUTINE FSLFNT (IERROR)
C
C PURPOSE                To provide a simple demonstration of the
C                        routine FSLFNT.
C
C USAGE                  CALL FSLFNT (IERROR)
C
C ARGUMENTS
C
C ON OUTPUT              IERROR
C                          An integer variable
C                            = 0  If there is a normal exit from FSLFNT
C                            = 1  Otherwise
C
C I/O                    If there is a normal exit from FSLFNT,
C                        the message
C
C                          FSLFNT TEST SUCCESSFUL . . . SEE PLOTS TO
C                          VERIFY PERFORMANCE
C
C                        is written on unit 6
C
C PRECISION              SINGLE
C
C REQUIRED LIBRARY       FSLFNT
C FILES
C
C LANGUAGE               FORTRAN
C
C HISTORY                Written  by members of the
C                        Scientific Computing Division of NCAR,
C                        Boulder Colorado
C
C PORTABILITY            FORTRAN 77
C
C
      CHARACTER*80    CARDS(6)
C
C Initialize the error parameter.
C
      IERROR = 1
C
C Store character strings in array CARDS.  These strings contain text,
C plus information regarding character size and location of the text
C on the scroll.
C
      NCARDS = 4
      CARDS(1) = '  512  760    1  1.5Demonstration'
      CARDS(2) = '  512  600    1  1.5Plot'
      CARDS(3) = '  512  440    1  1.0for'
      CARDS(4) = '  512  280    1  1.5STITLE'
C
C Employ the new high quality filled fonts in PLOTCHAR
C
      CALL PCSETC('FN','times-roman')
C
C Define the remaining inputs to routine STITLE.  Note that the
C output produced (a single frame with no scrolling to appear for
C 6.0 seconds) could equally well have been produced by FTITLE.
C We call STITLE in this demo to avoid reading the input lines.
C
      NYST  = 512
      NYFIN = 512
      TST   = 0.0
      TMV   = 0.0
      TFIN  = 6.0
      MOVIE =   1
C
C Call STITLE.
C
      CALL STITLE (CARDS,NCARDS,NYST,NYFIN,TST,TMV,TFIN,MOVIE)
      IERROR = 0
      WRITE (6,1001)
      RETURN
C
 1001 FORMAT ('     FSLFNT TEST SUCCESSFUL',24X,
     1        'SEE PLOTS TO VERIFY PERFORMANCE')
C
      END

C
C $Id: mdipai.f,v 1.3 2008-07-27 00:17:06 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      INTEGER FUNCTION MDIPAI (IAIN,IAIP)
C
        INTEGER IAIN,IAIP
C
        PARAMETER (MNAI=8000)
C
C The value of MDIPAI (IAIN,IAIP) is non-zero if and only if the area
C with area identifier IAIN is a part of the area with area identifier
C IAIP.
C
        COMMON /MAPCMX/  IATY(MNAI),ISCI(MNAI),IPAR(MNAI)
        INTEGER          IATY,ISCI,IPAR
        SAVE   /MAPCMX/
C
C Declare local variables.
C
        INTEGER          ITMP,NSTP
C
        MDIPAI=0
C
        IF (IAIP.LE.0) RETURN
C
        ITMP=IAIN
        NSTP=0
C
  101   IF (ITMP.GE.1.AND.ITMP.LE.MNAI) THEN
          IF (ITMP.NE.IAIP) THEN
            IF (IPAR(ITMP).NE.0.AND.NSTP.LT.10) THEN
              ITMP=IPAR(ITMP)
              NSTP=NSTP+1
              GO TO 101
            END IF
          ELSE
            MDIPAI=1
          END IF
        END IF
C
        RETURN
C
      END

C
C $Id: mdrset.f,v 1.10 2008-09-18 00:42:18 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MDRSET
C
C Declare required common blocks.  See MAPBDX for descriptions of these
C common blocks and the variables in them.
C
        COMMON /MAPCM1/  COSO,COSR,SINO,SINR,IPRJ,IROD
        DOUBLE PRECISION COSO,COSR,SINO,SINR
        INTEGER          IPRJ,IROD
        SAVE   /MAPCM1/
C
        COMMON /MAPCM2/  BLAM,BLOM,PEPS,SLAM,SLOM,UCEN,UMAX,UMIN,UOFF,
     +                   URNG,VCEN,VMAX,VMIN,VOFF,VRNG,ISSL
        DOUBLE PRECISION BLAM,BLOM,PEPS,SLAM,SLOM,UCEN,UMAX,UMIN,UOFF,
     +                   URNG,VCEN,VMAX,VMIN,VOFF,VRNG
        INTEGER          ISSL
        SAVE   /MAPCM2/
C
        COMMON /MAPCM3/  ITPN,NOUT,NPTS,IGID,IDLS,IDRS,BLAG,SLAG,BLOG,
     +                   SLOG,PNTS(200),IDOS(4)
        INTEGER          ITPN,NOUT,NPTS,IGID,IDLS,IDRS,IDOS
        REAL             BLAG,SLAG,BLOG,SLOG,PNTS
        SAVE   /MAPCM3/
C
        COMMON /MAPCM4/  GRDR,GRID,GRLA,GRLO,GRPO,OTOL,PDRE,PLA1,PLA2,
     +                   PLA3,PLA4,PLB1,PLB2,PLB3,PLB4,PLNO,PLTO,ROTA,
     +                   SRCH,XLOW,XROW,YBOW,YTOW,IDOT,IDSH,IDTL,ILCW,
     +                   ILTS,JPRJ,ELPF,INTF,LBLF,PRMF
        DOUBLE PRECISION GRDR,GRID,GRLA,GRLO,GRPO,OTOL,PDRE,PLA1,PLA2,
     +                   PLA3,PLA4,PLB1,PLB2,PLB3,PLB4,PLNO,PLTO,ROTA,
     +                   SRCH,XLOW,XROW,YBOW,YTOW
        INTEGER          IDOT,IDSH,IDTL,ILCW,ILTS,JPRJ
        LOGICAL          ELPF,INTF,LBLF,PRMF
        SAVE   /MAPCM4/
C
        COMMON /MAPCM5/  DDCT(5),DDCL(5),LDCT(6),LDCL(6),PDCT(19),
     +                   PDCL(19)
        CHARACTER*2      DDCT,DDCL,LDCT,LDCL,PDCT,PDCL
        SAVE   /MAPCM5/
C
        COMMON /MAPCM7/  ULOW,UROW,VBOW,VTOW
        DOUBLE PRECISION ULOW,UROW,VBOW,VTOW
        SAVE   /MAPCM7/
C
        COMMON /MAPCM8/  P,Q,R
        DOUBLE PRECISION P,Q,R
        SAVE   /MAPCM8/
C
        COMMON /MAPCMA/  DATL,DBTD,DDTS,DPLT,DPSQ,DSCA,DSSQ
        DOUBLE PRECISION DATL,DBTD,DDTS,DPLT,DPSQ,DSCA,DSSQ
        SAVE   /MAPCMA/
C
        COMMON /MAPCMC/  IGI1,IGI2,NCRA,NOVS,XCRA(100),YCRA(100)
        INTEGER          IGI1,IGI2,NCRA,NOVS
        REAL             XCRA,YCRA
        SAVE   /MAPCMC/
C
        COMMON /MAPCMP/  NPTB,XPTB(50),YPTB(50)
        INTEGER          NPTB
        REAL             XPTB,YPTB
        SAVE   /MAPCMP/
C
        COMMON /MAPCMQ/  ICIN(8)
        INTEGER          ICIN
        SAVE   /MAPCMQ/
C
        COMMON /MAPCMW/  CSLS,CSLT,SLTD,ISLT
        DOUBLE PRECISION CSLS,CSLT,SLTD
        INTEGER ISLT
        SAVE   /MAPCMW/
C
        COMMON /MAPRGD/  ICOL(5),ICSF(5),IDPF,LCRA,NILN,NILT,OLAT,OLON
        INTEGER          ICOL,ICSF,IDPF,LCRA,NILN,NILT
        REAL             OLAT,OLON
        SAVE   /MAPRGD/
C
        COMMON /MAPSAT/  ALFA,BETA,DCSA,DCSB,DSNA,DSNB,SALT,SSMO,SRSS
        DOUBLE PRECISION ALFA,BETA,DCSA,DCSB,DSNA,DSNB,SALT,SSMO,SRSS
        SAVE   /MAPSAT/
C
C Declare local variables.
C
        INTEGER          I
C
C Check for an uncleared prior error.
C
        IF (ICFELL('MDRSET - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C Reset all common variables to default values.
C
        IROD=0
        UMAX=1.D0
        UMIN=0.D0
        ITPN=1
        NOUT=1
        GRDR=1.D0
        GRID=10.D0
        GRLA=0.D0
        GRLO=0.D0
        GRPO=90.D0
        PDRE=32768.D0
        PLA1=0.D0
        PLA2=0.D0
        PLA3=0.D0
        PLA4=0.D0
        PLB1=0.D0
        PLB2=0.D0
        PLB3=0.D0
        PLB4=0.D0
        PLNO=0.D0
        PLTO=0.D0
        ROTA=0.D0
        SRCH=1.D0
        XLOW=.05D0
        XROW=.95D0
        YBOW=.05D0
        YTOW=.95D0
        IDOT=0
        IDSH=21845
        IDTL=0
        OTOL=.001D0
        ILCW=1
        ILTS=1
        JPRJ=7
        ELPF=.FALSE.
        INTF=.TRUE.
        LBLF=.TRUE.
        PRMF=.TRUE.
        ULOW=0.D0
        UROW=1.D0
        DDTS=96.D0
        DPLT=1.D0
        DSCA=1.D0
        IGI1=1
        IGI2=2
        NCRA=0
        NOVS=1
        NPTB=0
        DO 101 I=1,8
          ICIN(I)=-1
  101   CONTINUE
        CSLT=1.D0
        CSLS=1.D0
        SLTD=0.D0
        ISLT=0
        DO 102 I=1,5
          ICOL(I)=1
          ICSF(I)=MOD(I-1,2)
  102   CONTINUE
        IDPF=1
        NILN=50
        NILT=50
        ALFA=0.D0
        BETA=0.D0
        DCSA=1.D0
        DCSB=1.D0
        DSNA=0.D0
        DSNB=0.D0
        SALT=0.D0
        CALL MDPINT
        IF (ICFELL('MDRSET',2).NE.0) RETURN
        RETURN
      END

      SUBROUTINE ZSPRFS( UPLO, N, NRHS, AP, AFP, IPIV, B, LDB, X, LDX,
     $                   FERR, BERR, WORK, RWORK, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER          UPLO
      INTEGER            INFO, LDB, LDX, N, NRHS
*     ..
*     .. Array Arguments ..
      INTEGER            IPIV( * )
      DOUBLE PRECISION   BERR( * ), FERR( * ), RWORK( * )
      COMPLEX*16         AFP( * ), AP( * ), B( LDB, * ), WORK( * ),
     $                   X( LDX, * )
*     ..
*
*  Purpose
*  =======
*
*  ZSPRFS improves the computed solution to a system of linear
*  equations when the coefficient matrix is symmetric indefinite
*  and packed, and provides error bounds and backward error estimates
*  for the solution.
*
*  Arguments
*  =========
*
*  UPLO    (input) CHARACTER*1
*          = 'U':  Upper triangle of A is stored;
*          = 'L':  Lower triangle of A is stored.
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  NRHS    (input) INTEGER
*          The number of right hand sides, i.e., the number of columns
*          of the matrices B and X.  NRHS >= 0.
*
*  AP      (input) COMPLEX*16 array, dimension (N*(N+1)/2)
*          The upper or lower triangle of the symmetric matrix A, packed
*          columnwise in a linear array.  The j-th column of A is stored
*          in the array AP as follows:
*          if UPLO = 'U', AP(i + (j-1)*j/2) = A(i,j) for 1<=i<=j;
*          if UPLO = 'L', AP(i + (j-1)*(2*n-j)/2) = A(i,j) for j<=i<=n.
*
*  AFP     (input) COMPLEX*16 array, dimension (N*(N+1)/2)
*          The factored form of the matrix A.  AFP contains the block
*          diagonal matrix D and the multipliers used to obtain the
*          factor U or L from the factorization A = U*D*U**T or
*          A = L*D*L**T as computed by ZSPTRF, stored as a packed
*          triangular matrix.
*
*  IPIV    (input) INTEGER array, dimension (N)
*          Details of the interchanges and the block structure of D
*          as determined by ZSPTRF.
*
*  B       (input) COMPLEX*16 array, dimension (LDB,NRHS)
*          The right hand side matrix B.
*
*  LDB     (input) INTEGER
*          The leading dimension of the array B.  LDB >= max(1,N).
*
*  X       (input/output) COMPLEX*16 array, dimension (LDX,NRHS)
*          On entry, the solution matrix X, as computed by ZSPTRS.
*          On exit, the improved solution matrix X.
*
*  LDX     (input) INTEGER
*          The leading dimension of the array X.  LDX >= max(1,N).
*
*  FERR    (output) DOUBLE PRECISION array, dimension (NRHS)
*          The estimated forward error bound for each solution vector
*          X(j) (the j-th column of the solution matrix X).
*          If XTRUE is the true solution corresponding to X(j), FERR(j)
*          is an estimated upper bound for the magnitude of the largest
*          element in (X(j) - XTRUE) divided by the magnitude of the
*          largest element in X(j).  The estimate is as reliable as
*          the estimate for RCOND, and is almost always a slight
*          overestimate of the true error.
*
*  BERR    (output) DOUBLE PRECISION array, dimension (NRHS)
*          The componentwise relative backward error of each solution
*          vector X(j) (i.e., the smallest relative change in
*          any element of A or B that makes X(j) an exact solution).
*
*  WORK    (workspace) COMPLEX*16 array, dimension (2*N)
*
*  RWORK   (workspace) DOUBLE PRECISION array, dimension (N)
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*
*  Internal Parameters
*  ===================
*
*  ITMAX is the maximum number of steps of iterative refinement.
*
*  =====================================================================
*
*     .. Parameters ..
      INTEGER            ITMAX
      PARAMETER          ( ITMAX = 5 )
      DOUBLE PRECISION   ZERO
      PARAMETER          ( ZERO = 0.0D+0 )
      COMPLEX*16         ONE
      PARAMETER          ( ONE = ( 1.0D+0, 0.0D+0 ) )
      DOUBLE PRECISION   TWO
      PARAMETER          ( TWO = 2.0D+0 )
      DOUBLE PRECISION   THREE
      PARAMETER          ( THREE = 3.0D+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            UPPER
      INTEGER            COUNT, I, IK, J, K, KASE, KK, NZ
      DOUBLE PRECISION   EPS, LSTRES, S, SAFE1, SAFE2, SAFMIN, XK
      COMPLEX*16         ZDUM
*     ..
*     .. External Subroutines ..
      EXTERNAL           XERBLA, ZAXPY, ZCOPY, ZLACON, ZSPMV, ZSPTRS
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, DBLE, DIMAG, MAX
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      DOUBLE PRECISION   DLAMCH
      EXTERNAL           LSAME, DLAMCH
*     ..
*     .. Statement Functions ..
      DOUBLE PRECISION   CABS1
*     ..
*     .. Statement Function definitions ..
      CABS1( ZDUM ) = ABS( DBLE( ZDUM ) ) + ABS( DIMAG( ZDUM ) )
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      UPPER = LSAME( UPLO, 'U' )
      IF( .NOT.UPPER .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( NRHS.LT.0 ) THEN
         INFO = -3
      ELSE IF( LDB.LT.MAX( 1, N ) ) THEN
         INFO = -8
      ELSE IF( LDX.LT.MAX( 1, N ) ) THEN
         INFO = -10
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'ZSPRFS', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 .OR. NRHS.EQ.0 ) THEN
         DO 10 J = 1, NRHS
            FERR( J ) = ZERO
            BERR( J ) = ZERO
   10    CONTINUE
         RETURN
      END IF
*
*     NZ = maximum number of nonzero elements in each row of A, plus 1
*
      NZ = N + 1
      EPS = DLAMCH( 'Epsilon' )
      SAFMIN = DLAMCH( 'Safe minimum' )
      SAFE1 = NZ*SAFMIN
      SAFE2 = SAFE1 / EPS
*
*     Do for each right hand side
*
      DO 140 J = 1, NRHS
*
         COUNT = 1
         LSTRES = THREE
   20    CONTINUE
*
*        Loop until stopping criterion is satisfied.
*
*        Compute residual R = B - A * X
*
         CALL ZCOPY( N, B( 1, J ), 1, WORK, 1 )
         CALL ZSPMV( UPLO, N, -ONE, AP, X( 1, J ), 1, ONE, WORK, 1 )
*
*        Compute componentwise relative backward error from formula
*
*        max(i) ( abs(R(i)) / ( abs(A)*abs(X) + abs(B) )(i) )
*
*        where abs(Z) is the componentwise absolute value of the matrix
*        or vector Z.  If the i-th component of the denominator is less
*        than SAFE2, then SAFE1 is added to the i-th components of the
*        numerator and denominator before dividing.
*
         DO 30 I = 1, N
            RWORK( I ) = CABS1( B( I, J ) )
   30    CONTINUE
*
*        Compute abs(A)*abs(X) + abs(B).
*
         KK = 1
         IF( UPPER ) THEN
            DO 50 K = 1, N
               S = ZERO
               XK = CABS1( X( K, J ) )
               IK = KK
               DO 40 I = 1, K - 1
                  RWORK( I ) = RWORK( I ) + CABS1( AP( IK ) )*XK
                  S = S + CABS1( AP( IK ) )*CABS1( X( I, J ) )
                  IK = IK + 1
   40          CONTINUE
               RWORK( K ) = RWORK( K ) + CABS1( AP( KK+K-1 ) )*XK + S
               KK = KK + K
   50       CONTINUE
         ELSE
            DO 70 K = 1, N
               S = ZERO
               XK = CABS1( X( K, J ) )
               RWORK( K ) = RWORK( K ) + CABS1( AP( KK ) )*XK
               IK = KK + 1
               DO 60 I = K + 1, N
                  RWORK( I ) = RWORK( I ) + CABS1( AP( IK ) )*XK
                  S = S + CABS1( AP( IK ) )*CABS1( X( I, J ) )
                  IK = IK + 1
   60          CONTINUE
               RWORK( K ) = RWORK( K ) + S
               KK = KK + ( N-K+1 )
   70       CONTINUE
         END IF
         S = ZERO
         DO 80 I = 1, N
            IF( RWORK( I ).GT.SAFE2 ) THEN
               S = MAX( S, CABS1( WORK( I ) ) / RWORK( I ) )
            ELSE
               S = MAX( S, ( CABS1( WORK( I ) )+SAFE1 ) /
     $             ( RWORK( I )+SAFE1 ) )
            END IF
   80    CONTINUE
         BERR( J ) = S
*
*        Test stopping criterion. Continue iterating if
*           1) The residual BERR(J) is larger than machine epsilon, and
*           2) BERR(J) decreased by at least a factor of 2 during the
*              last iteration, and
*           3) At most ITMAX iterations tried.
*
         IF( BERR( J ).GT.EPS .AND. TWO*BERR( J ).LE.LSTRES .AND.
     $       COUNT.LE.ITMAX ) THEN
*
*           Update solution and try again.
*
            CALL ZSPTRS( UPLO, N, 1, AFP, IPIV, WORK, N, INFO )
            CALL ZAXPY( N, ONE, WORK, 1, X( 1, J ), 1 )
            LSTRES = BERR( J )
            COUNT = COUNT + 1
            GO TO 20
         END IF
*
*        Bound error from formula
*
*        norm(X - XTRUE) / norm(X) .le. FERR =
*        norm( abs(inv(A))*
*           ( abs(R) + NZ*EPS*( abs(A)*abs(X)+abs(B) ))) / norm(X)
*
*        where
*          norm(Z) is the magnitude of the largest component of Z
*          inv(A) is the inverse of A
*          abs(Z) is the componentwise absolute value of the matrix or
*             vector Z
*          NZ is the maximum number of nonzeros in any row of A, plus 1
*          EPS is machine epsilon
*
*        The i-th component of abs(R)+NZ*EPS*(abs(A)*abs(X)+abs(B))
*        is incremented by SAFE1 if the i-th component of
*        abs(A)*abs(X) + abs(B) is less than SAFE2.
*
*        Use ZLACON to estimate the infinity-norm of the matrix
*           inv(A) * diag(W),
*        where W = abs(R) + NZ*EPS*( abs(A)*abs(X)+abs(B) )))
*
         DO 90 I = 1, N
            IF( RWORK( I ).GT.SAFE2 ) THEN
               RWORK( I ) = CABS1( WORK( I ) ) + NZ*EPS*RWORK( I )
            ELSE
               RWORK( I ) = CABS1( WORK( I ) ) + NZ*EPS*RWORK( I ) +
     $                      SAFE1
            END IF
   90    CONTINUE
*
         KASE = 0
  100    CONTINUE
         CALL ZLACON( N, WORK( N+1 ), WORK, FERR( J ), KASE )
         IF( KASE.NE.0 ) THEN
            IF( KASE.EQ.1 ) THEN
*
*              Multiply by diag(W)*inv(A').
*
               CALL ZSPTRS( UPLO, N, 1, AFP, IPIV, WORK, N, INFO )
               DO 110 I = 1, N
                  WORK( I ) = RWORK( I )*WORK( I )
  110          CONTINUE
            ELSE IF( KASE.EQ.2 ) THEN
*
*              Multiply by inv(A)*diag(W).
*
               DO 120 I = 1, N
                  WORK( I ) = RWORK( I )*WORK( I )
  120          CONTINUE
               CALL ZSPTRS( UPLO, N, 1, AFP, IPIV, WORK, N, INFO )
            END IF
            GO TO 100
         END IF
*
*        Normalize error.
*
         LSTRES = ZERO
         DO 130 I = 1, N
            LSTRES = MAX( LSTRES, CABS1( X( I, J ) ) )
  130    CONTINUE
         IF( LSTRES.NE.ZERO )
     $      FERR( J ) = FERR( J ) / LSTRES
*
  140 CONTINUE
*
      RETURN
*
*     End of ZSPRFS
*
      END

C
C	$Id: clipit.f,v 1.5 2008-07-27 00:59:04 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
       SUBROUTINE CLIPIT(XIN,YIN,XOUT,YOUT,DRAW)
C
C  NO CLIPPING.
C
C  INPUT
C       XIN(2) - INTEGER ARRAY DEFINING THE X COORDINATE ENDPOINTS OF
C                THE LINE TO BE CLIPPED.
C       YIN(2) - INTEGER ARRAY DEFINING THE Y COORDINATE ENDPOINTS OF
C                THE LINE TO BE CLIPPED.
C  OUTPUT
C       XOUT(2) - INTEGER ARRAY DEFINING THE X COORDINATE ENDPOINTS OF
C                 THE CLIPPED LINE.
C       YOUT(2) - INTEGER ARRAY DEFINING THE Y COORDINATE ENDPOINTS OF
C                 THE CLIPPED LINE.
C       DRAW - LOGICAL FLAG INDICATING IF ANY PART OF THE LINE IS
C              VISIBLE.  TRUE-XOUT, YOUT VALID.  FALSE-NO LINE SEGMENT.
C
      INTEGER XIN(2), YIN(2), XOUT(2), YOUT(2)
      LOGICAL DRAW
C
      INTEGER X1, Y1, X2, Y2
      LOGICAL ACCEPT, REJECT, DONE
C
      COMMON /PGKSCOM/ CLPDAT, CLPFLG, POLIDX, LINTYP, LINWTH, LINCOL,
     1                LINRGB, MARIDX, MARSIZ, MARCOL, MARRGB, TXTIDX,
     2                INTSTL, PATIDX, FILCOL, FILRGB, MARTYP, HORIZ ,
     3                VERT  , PATH  , CHIGHT, XU    , YU    , XB    ,
     4                YB    , TXTCOL, FINDEX, CEXPN , CSPACE, CURIDX,
     5                CURIMP, CURINT, COLMOD, FILIDX, TXTRGB, PROPN ,
     6                FIRSTX, FIRSTY, LASTX , LASTY , TRATIO, CBV   ,
     7                CUV   , CHP   , CVP   , CCSPAC, CHHORZ, CDV   ,
     8                PMRSIZ, CLPX  , CLPY  , CLPP  , DEFREP, DEFLEN,
     9                VDCECR, TRANVN, TXTPRE, HATIDX, FILRPT, ASFSRF,
     A                ASFSDF, MAPMOD, VERSOK, PCBFST, CPGLEN, CLPNUL,
     B                MTDLEN
      INTEGER         CMPMAX, ASFMAX
      PARAMETER      (CMPMAX=256    , ASFMAX=18)
      LOGICAL         CLPFLG, PROPN , CHHORZ, DEFREP, CLPNUL, MAPMOD,
     1                VERSOK, PCBFST
      REAL            LINWTH, MARSIZ, CEXPN , CSPACE, TRATIO, CBV(2),
     1                CUV(2), CDV(2), CCSPAC
      INTEGER         CLPDAT(4)     , POLIDX, LINTYP, LINCOL, LINRGB(3),
     1                MARIDX, MARCOL, MARRGB(3)     , TXTIDX, INTSTL,
     2                PATIDX, FILCOL, FILRGB(3)     , MARTYP, HORIZ ,
     3                VERT  , PATH  , XU    , YU    , XB    , YB    ,
     4                TXTCOL, FINDEX, CURIMP(CMPMAX), CURINT(CMPMAX*3),
     5                CHIGHT, COLMOD, FILIDX, TXTRGB(3)     , CURIDX,
     6                FIRSTX, FIRSTY, LASTX , LASTY , CHP   , CVP   ,
     7                PMRSIZ, CLPX  , CLPY  , CLPP  , DEFLEN, TRANVN,
     8                TXTPRE, HATIDX, FILRPT(2)     , VDCECR(4)     ,
     9                ASFSRF(ASFMAX), ASFSDF(ASFMAX), CPGLEN, MTDLEN
      COMMON /GKSCHR/ MTDESC
      CHARACTER*80    MTDESC
C
C  INITIALIZE THE ALGORITHM
C
      ACCEPT = .TRUE.
      REJECT = .FALSE.
      DONE = .TRUE.
      X1 = XIN(1)
      Y1 = YIN(1)
      X2 = XIN(2)
      Y2 = YIN(2)
C
C   LOOP UNTIL A DECISION IS MADE ABOUT THE VISIBLE LINE SEGMENT
C
C
C  SET THE DRAW FLAG AND THE COORDINATES BASED ON THE ACCEPT FLAG
C
      DRAW = ACCEPT
      IF (ACCEPT) THEN
        XOUT(1) = X1
        XOUT(2) = X2
        YOUT(1) = Y1
        YOUT(2) = Y2
      END IF
C
      RETURN
      END

C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CSA3D(NI,XI,UI,KNOTS,NXO,NYO,NZO,XO,YO,ZO,UO,NWRK,WORK,
     +                 IER)
      DOUBLE PRECISION XI
      DOUBLE PRECISION UI
      DOUBLE PRECISION XO
      DOUBLE PRECISION YO
      DOUBLE PRECISION ZO
      DOUBLE PRECISION UO
      DOUBLE PRECISION WORK
      DOUBLE PRECISION WTS
      DOUBLE PRECISION SSMTH
C
      DIMENSION XI(3,NI),UI(NI),KNOTS(3),XO(NXO),YO(NYO),ZO(NZO),
     +          UO(NXO,NYO,NZO),WORK(NWRK),NDERIV(3)
      DATA NDERIV/0,0,0/
C
C  Check on the number of knots.
C
      NTOT = KNOTS(1)*KNOTS(2)*KNOTS(3)
C
      DO 20 I = 1,3
          IF (KNOTS(I).LT.4) THEN
              CALL CFAERR(202,
     +' CSA3D - must have at least four knots in every coordinate direct
     +ion',68)
              IER = 202
              RETURN
          END IF
   20 CONTINUE
C
C  Check on the size of the workspace.
C
      IF (NWRK.LT.NTOT* (NTOT+3)) THEN
          CALL CFAERR(203,' CSA3D - workspace too small',28)
          IER = 203
          RETURN
      END IF
C
C  Invoke the expanded function.
C
      WTS = -1.D0
      SSMTH = 0.D0
      CALL CSA3XD(NI,XI,UI,WTS,KNOTS,SSMTH,NDERIV,NXO,NYO,NZO,XO,YO,ZO,
     +            UO,NWRK,WORK,IER)
      IF (IERR.NE.0) RETURN
C
      RETURN
      END

      SUBROUTINE ZGEGV( JOBVL, JOBVR, N, A, LDA, B, LDB, ALPHA, BETA,
     $                  VL, LDVL, VR, LDVR, WORK, LWORK, RWORK, INFO )
*
*  -- LAPACK driver routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          JOBVL, JOBVR
      INTEGER            INFO, LDA, LDB, LDVL, LDVR, LWORK, N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   RWORK( * )
      COMPLEX*16         A( LDA, * ), ALPHA( * ), B( LDB, * ),
     $                   BETA( * ), VL( LDVL, * ), VR( LDVR, * ),
     $                   WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  This routine is deprecated and has been replaced by routine ZGGEV.
*
*  ZGEGV computes for a pair of N-by-N complex nonsymmetric matrices A
*  and B, the generalized eigenvalues (alpha, beta), and optionally,
*  the left and/or right generalized eigenvectors (VL and VR).
*
*  A generalized eigenvalue for a pair of matrices (A,B) is, roughly
*  speaking, a scalar w or a ratio  alpha/beta = w, such that  A - w*B
*  is singular.  It is usually represented as the pair (alpha,beta),
*  as there is a reasonable interpretation for beta=0, and even for
*  both being zero.  A good beginning reference is the book, "Matrix
*  Computations", by G. Golub & C. van Loan (Johns Hopkins U. Press)
*
*  A right generalized eigenvector corresponding to a generalized
*  eigenvalue  w  for a pair of matrices (A,B) is a vector  r  such
*  that  (A - w B) r = 0 .  A left generalized eigenvector is a vector
*  l such that l**H * (A - w B) = 0, where l**H is the
*  conjugate-transpose of l.
*
*  Note: this routine performs "full balancing" on A and B -- see
*  "Further Details", below.
*
*  Arguments
*  =========
*
*  JOBVL   (input) CHARACTER*1
*          = 'N':  do not compute the left generalized eigenvectors;
*          = 'V':  compute the left generalized eigenvectors.
*
*  JOBVR   (input) CHARACTER*1
*          = 'N':  do not compute the right generalized eigenvectors;
*          = 'V':  compute the right generalized eigenvectors.
*
*  N       (input) INTEGER
*          The order of the matrices A, B, VL, and VR.  N >= 0.
*
*  A       (input/output) COMPLEX*16 array, dimension (LDA, N)
*          On entry, the first of the pair of matrices whose
*          generalized eigenvalues and (optionally) generalized
*          eigenvectors are to be computed.
*          On exit, the contents will have been destroyed.  (For a
*          description of the contents of A on exit, see "Further
*          Details", below.)
*
*  LDA     (input) INTEGER
*          The leading dimension of A.  LDA >= max(1,N).
*
*  B       (input/output) COMPLEX*16 array, dimension (LDB, N)
*          On entry, the second of the pair of matrices whose
*          generalized eigenvalues and (optionally) generalized
*          eigenvectors are to be computed.
*          On exit, the contents will have been destroyed.  (For a
*          description of the contents of B on exit, see "Further
*          Details", below.)
*
*  LDB     (input) INTEGER
*          The leading dimension of B.  LDB >= max(1,N).
*
*  ALPHA   (output) COMPLEX*16 array, dimension (N)
*  BETA    (output) COMPLEX*16 array, dimension (N)
*          On exit, ALPHA(j)/BETA(j), j=1,...,N, will be the
*          generalized eigenvalues.
*
*          Note: the quotients ALPHA(j)/BETA(j) may easily over- or
*          underflow, and BETA(j) may even be zero.  Thus, the user
*          should avoid naively computing the ratio alpha/beta.
*          However, ALPHA will be always less than and usually
*          comparable with norm(A) in magnitude, and BETA always less
*          than and usually comparable with norm(B).
*
*  VL      (output) COMPLEX*16 array, dimension (LDVL,N)
*          If JOBVL = 'V', the left generalized eigenvectors.  (See
*          "Purpose", above.)
*          Each eigenvector will be scaled so the largest component
*          will have abs(real part) + abs(imag. part) = 1, *except*
*          that for eigenvalues with alpha=beta=0, a zero vector will
*          be returned as the corresponding eigenvector.
*          Not referenced if JOBVL = 'N'.
*
*  LDVL    (input) INTEGER
*          The leading dimension of the matrix VL. LDVL >= 1, and
*          if JOBVL = 'V', LDVL >= N.
*
*  VR      (output) COMPLEX*16 array, dimension (LDVR,N)
*          If JOBVR = 'V', the right generalized eigenvectors.  (See
*          "Purpose", above.)
*          Each eigenvector will be scaled so the largest component
*          will have abs(real part) + abs(imag. part) = 1, *except*
*          that for eigenvalues with alpha=beta=0, a zero vector will
*          be returned as the corresponding eigenvector.
*          Not referenced if JOBVR = 'N'.
*
*  LDVR    (input) INTEGER
*          The leading dimension of the matrix VR. LDVR >= 1, and
*          if JOBVR = 'V', LDVR >= N.
*
*  WORK    (workspace/output) COMPLEX*16 array, dimension (LWORK)
*          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*
*  LWORK   (input) INTEGER
*          The dimension of the array WORK.  LWORK >= max(1,2*N).
*          For good performance, LWORK must generally be larger.
*          To compute the optimal value of LWORK, call ILAENV to get
*          blocksizes (for ZGEQRF, ZUNMQR, and CUNGQR.)  Then compute:
*          NB  -- MAX of the blocksizes for ZGEQRF, ZUNMQR, and CUNGQR;
*          The optimal LWORK is  MAX( 2*N, N*(NB+1) ).
*
*          If LWORK = -1, then a workspace query is assumed; the routine
*          only calculates the optimal size of the WORK array, returns
*          this value as the first entry of the WORK array, and no error
*          message related to LWORK is issued by XERBLA.
*
*  RWORK   (workspace/output) DOUBLE PRECISION array, dimension (8*N)
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value.
*          =1,...,N:
*                The QZ iteration failed.  No eigenvectors have been
*                calculated, but ALPHA(j) and BETA(j) should be
*                correct for j=INFO+1,...,N.
*          > N:  errors that usually indicate LAPACK problems:
*                =N+1: error return from ZGGBAL
*                =N+2: error return from ZGEQRF
*                =N+3: error return from ZUNMQR
*                =N+4: error return from ZUNGQR
*                =N+5: error return from ZGGHRD
*                =N+6: error return from ZHGEQZ (other than failed
*                                               iteration)
*                =N+7: error return from ZTGEVC
*                =N+8: error return from ZGGBAK (computing VL)
*                =N+9: error return from ZGGBAK (computing VR)
*                =N+10: error return from ZLASCL (various calls)
*
*  Further Details
*  ===============
*
*  Balancing
*  ---------
*
*  This driver calls ZGGBAL to both permute and scale rows and columns
*  of A and B.  The permutations PL and PR are chosen so that PL*A*PR
*  and PL*B*R will be upper triangular except for the diagonal blocks
*  A(i:j,i:j) and B(i:j,i:j), with i and j as close together as
*  possible.  The diagonal scaling matrices DL and DR are chosen so
*  that the pair  DL*PL*A*PR*DR, DL*PL*B*PR*DR have elements close to
*  one (except for the elements that start out zero.)
*
*  After the eigenvalues and eigenvectors of the balanced matrices
*  have been computed, ZGGBAK transforms the eigenvectors back to what
*  they would have been (in perfect arithmetic) if they had not been
*  balanced.
*
*  Contents of A and B on Exit
*  -------- -- - --- - -- ----
*
*  If any eigenvectors are computed (either JOBVL='V' or JOBVR='V' or
*  both), then on exit the arrays A and B will contain the complex Schur
*  form[*] of the "balanced" versions of A and B.  If no eigenvectors
*  are computed, then only the diagonal blocks will be correct.
*
*  [*] In other words, upper triangular form.
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO, ONE
      PARAMETER          ( ZERO = 0.0D0, ONE = 1.0D0 )
      COMPLEX*16         CZERO, CONE
      PARAMETER          ( CZERO = ( 0.0D0, 0.0D0 ),
     $                   CONE = ( 1.0D0, 0.0D0 ) )
*     ..
*     .. Local Scalars ..
      LOGICAL            ILIMIT, ILV, ILVL, ILVR, LQUERY
      CHARACTER          CHTEMP
      INTEGER            ICOLS, IHI, IINFO, IJOBVL, IJOBVR, ILEFT, ILO,
     $                   IN, IRIGHT, IROWS, IRWORK, ITAU, IWORK, JC, JR,
     $                   LOPT, LWKMIN, LWKOPT, NB, NB1, NB2, NB3
      DOUBLE PRECISION   ABSAI, ABSAR, ABSB, ANRM, ANRM1, ANRM2, BNRM,
     $                   BNRM1, BNRM2, EPS, SAFMAX, SAFMIN, SALFAI,
     $                   SALFAR, SBETA, SCALE, TEMP
      COMPLEX*16         X
*     ..
*     .. Local Arrays ..
      LOGICAL            LDUMMA( 1 )
*     ..
*     .. External Subroutines ..
      EXTERNAL           XERBLA, ZGEQRF, ZGGBAK, ZGGBAL, ZGGHRD, ZHGEQZ,
     $                   ZLACPY, ZLASCL, ZLASET, ZTGEVC, ZUNGQR, ZUNMQR
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            ILAENV
      DOUBLE PRECISION   DLAMCH, ZLANGE
      EXTERNAL           LSAME, ILAENV, DLAMCH, ZLANGE
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, DBLE, DCMPLX, DIMAG, INT, MAX
*     ..
*     .. Statement Functions ..
      DOUBLE PRECISION   ABS1
*     ..
*     .. Statement Function definitions ..
      ABS1( X ) = ABS( DBLE( X ) ) + ABS( DIMAG( X ) )
*     ..
*     .. Executable Statements ..
*
*     Decode the input arguments
*
      IF( LSAME( JOBVL, 'N' ) ) THEN
         IJOBVL = 1
         ILVL = .FALSE.
      ELSE IF( LSAME( JOBVL, 'V' ) ) THEN
         IJOBVL = 2
         ILVL = .TRUE.
      ELSE
         IJOBVL = -1
         ILVL = .FALSE.
      END IF
*
      IF( LSAME( JOBVR, 'N' ) ) THEN
         IJOBVR = 1
         ILVR = .FALSE.
      ELSE IF( LSAME( JOBVR, 'V' ) ) THEN
         IJOBVR = 2
         ILVR = .TRUE.
      ELSE
         IJOBVR = -1
         ILVR = .FALSE.
      END IF
      ILV = ILVL .OR. ILVR
*
*     Test the input arguments
*
      LWKMIN = MAX( 2*N, 1 )
      LWKOPT = LWKMIN
      WORK( 1 ) = LWKOPT
      LQUERY = ( LWORK.EQ.-1 )
      INFO = 0
      IF( IJOBVL.LE.0 ) THEN
         INFO = -1
      ELSE IF( IJOBVR.LE.0 ) THEN
         INFO = -2
      ELSE IF( N.LT.0 ) THEN
         INFO = -3
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -5
      ELSE IF( LDB.LT.MAX( 1, N ) ) THEN
         INFO = -7
      ELSE IF( LDVL.LT.1 .OR. ( ILVL .AND. LDVL.LT.N ) ) THEN
         INFO = -11
      ELSE IF( LDVR.LT.1 .OR. ( ILVR .AND. LDVR.LT.N ) ) THEN
         INFO = -13
      ELSE IF( LWORK.LT.LWKMIN .AND. .NOT.LQUERY ) THEN
         INFO = -15
      END IF
*
      IF( INFO.EQ.0 ) THEN
         NB1 = ILAENV( 1, 'ZGEQRF', ' ', N, N, -1, -1 )
         NB2 = ILAENV( 1, 'ZUNMQR', ' ', N, N, N, -1 )
         NB3 = ILAENV( 1, 'ZUNGQR', ' ', N, N, N, -1 )
         NB = MAX( NB1, NB2, NB3 )
         LOPT = MAX( 2*N, N*( NB+1 ) )
         WORK( 1 ) = LOPT
      END IF
*
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'ZGEGV ', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
*
*     Get machine constants
*
      EPS = DLAMCH( 'E' )*DLAMCH( 'B' )
      SAFMIN = DLAMCH( 'S' )
      SAFMIN = SAFMIN + SAFMIN
      SAFMAX = ONE / SAFMIN
*
*     Scale A
*
      ANRM = ZLANGE( 'M', N, N, A, LDA, RWORK )
      ANRM1 = ANRM
      ANRM2 = ONE
      IF( ANRM.LT.ONE ) THEN
         IF( SAFMAX*ANRM.LT.ONE ) THEN
            ANRM1 = SAFMIN
            ANRM2 = SAFMAX*ANRM
         END IF
      END IF
*
      IF( ANRM.GT.ZERO ) THEN
         CALL ZLASCL( 'G', -1, -1, ANRM, ONE, N, N, A, LDA, IINFO )
         IF( IINFO.NE.0 ) THEN
            INFO = N + 10
            RETURN
         END IF
      END IF
*
*     Scale B
*
      BNRM = ZLANGE( 'M', N, N, B, LDB, RWORK )
      BNRM1 = BNRM
      BNRM2 = ONE
      IF( BNRM.LT.ONE ) THEN
         IF( SAFMAX*BNRM.LT.ONE ) THEN
            BNRM1 = SAFMIN
            BNRM2 = SAFMAX*BNRM
         END IF
      END IF
*
      IF( BNRM.GT.ZERO ) THEN
         CALL ZLASCL( 'G', -1, -1, BNRM, ONE, N, N, B, LDB, IINFO )
         IF( IINFO.NE.0 ) THEN
            INFO = N + 10
            RETURN
         END IF
      END IF
*
*     Permute the matrix to make it more nearly triangular
*     Also "balance" the matrix.
*
      ILEFT = 1
      IRIGHT = N + 1
      IRWORK = IRIGHT + N
      CALL ZGGBAL( 'P', N, A, LDA, B, LDB, ILO, IHI, RWORK( ILEFT ),
     $             RWORK( IRIGHT ), RWORK( IRWORK ), IINFO )
      IF( IINFO.NE.0 ) THEN
         INFO = N + 1
         GO TO 80
      END IF
*
*     Reduce B to triangular form, and initialize VL and/or VR
*
      IROWS = IHI + 1 - ILO
      IF( ILV ) THEN
         ICOLS = N + 1 - ILO
      ELSE
         ICOLS = IROWS
      END IF
      ITAU = 1
      IWORK = ITAU + IROWS
      CALL ZGEQRF( IROWS, ICOLS, B( ILO, ILO ), LDB, WORK( ITAU ),
     $             WORK( IWORK ), LWORK+1-IWORK, IINFO )
      IF( IINFO.GE.0 )
     $   LWKOPT = MAX( LWKOPT, INT( WORK( IWORK ) )+IWORK-1 )
      IF( IINFO.NE.0 ) THEN
         INFO = N + 2
         GO TO 80
      END IF
*
      CALL ZUNMQR( 'L', 'C', IROWS, ICOLS, IROWS, B( ILO, ILO ), LDB,
     $             WORK( ITAU ), A( ILO, ILO ), LDA, WORK( IWORK ),
     $             LWORK+1-IWORK, IINFO )
      IF( IINFO.GE.0 )
     $   LWKOPT = MAX( LWKOPT, INT( WORK( IWORK ) )+IWORK-1 )
      IF( IINFO.NE.0 ) THEN
         INFO = N + 3
         GO TO 80
      END IF
*
      IF( ILVL ) THEN
         CALL ZLASET( 'Full', N, N, CZERO, CONE, VL, LDVL )
         CALL ZLACPY( 'L', IROWS-1, IROWS-1, B( ILO+1, ILO ), LDB,
     $                VL( ILO+1, ILO ), LDVL )
         CALL ZUNGQR( IROWS, IROWS, IROWS, VL( ILO, ILO ), LDVL,
     $                WORK( ITAU ), WORK( IWORK ), LWORK+1-IWORK,
     $                IINFO )
         IF( IINFO.GE.0 )
     $      LWKOPT = MAX( LWKOPT, INT( WORK( IWORK ) )+IWORK-1 )
         IF( IINFO.NE.0 ) THEN
            INFO = N + 4
            GO TO 80
         END IF
      END IF
*
      IF( ILVR )
     $   CALL ZLASET( 'Full', N, N, CZERO, CONE, VR, LDVR )
*
*     Reduce to generalized Hessenberg form
*
      IF( ILV ) THEN
*
*        Eigenvectors requested -- work on whole matrix.
*
         CALL ZGGHRD( JOBVL, JOBVR, N, ILO, IHI, A, LDA, B, LDB, VL,
     $                LDVL, VR, LDVR, IINFO )
      ELSE
         CALL ZGGHRD( 'N', 'N', IROWS, 1, IROWS, A( ILO, ILO ), LDA,
     $                B( ILO, ILO ), LDB, VL, LDVL, VR, LDVR, IINFO )
      END IF
      IF( IINFO.NE.0 ) THEN
         INFO = N + 5
         GO TO 80
      END IF
*
*     Perform QZ algorithm
*
      IWORK = ITAU
      IF( ILV ) THEN
         CHTEMP = 'S'
      ELSE
         CHTEMP = 'E'
      END IF
      CALL ZHGEQZ( CHTEMP, JOBVL, JOBVR, N, ILO, IHI, A, LDA, B, LDB,
     $             ALPHA, BETA, VL, LDVL, VR, LDVR, WORK( IWORK ),
     $             LWORK+1-IWORK, RWORK( IRWORK ), IINFO )
      IF( IINFO.GE.0 )
     $   LWKOPT = MAX( LWKOPT, INT( WORK( IWORK ) )+IWORK-1 )
      IF( IINFO.NE.0 ) THEN
         IF( IINFO.GT.0 .AND. IINFO.LE.N ) THEN
            INFO = IINFO
         ELSE IF( IINFO.GT.N .AND. IINFO.LE.2*N ) THEN
            INFO = IINFO - N
         ELSE
            INFO = N + 6
         END IF
         GO TO 80
      END IF
*
      IF( ILV ) THEN
*
*        Compute Eigenvectors
*
         IF( ILVL ) THEN
            IF( ILVR ) THEN
               CHTEMP = 'B'
            ELSE
               CHTEMP = 'L'
            END IF
         ELSE
            CHTEMP = 'R'
         END IF
*
         CALL ZTGEVC( CHTEMP, 'B', LDUMMA, N, A, LDA, B, LDB, VL, LDVL,
     $                VR, LDVR, N, IN, WORK( IWORK ), RWORK( IRWORK ),
     $                IINFO )
         IF( IINFO.NE.0 ) THEN
            INFO = N + 7
            GO TO 80
         END IF
*
*        Undo balancing on VL and VR, rescale
*
         IF( ILVL ) THEN
            CALL ZGGBAK( 'P', 'L', N, ILO, IHI, RWORK( ILEFT ),
     $                   RWORK( IRIGHT ), N, VL, LDVL, IINFO )
            IF( IINFO.NE.0 ) THEN
               INFO = N + 8
               GO TO 80
            END IF
            DO 30 JC = 1, N
               TEMP = ZERO
               DO 10 JR = 1, N
                  TEMP = MAX( TEMP, ABS1( VL( JR, JC ) ) )
   10          CONTINUE
               IF( TEMP.LT.SAFMIN )
     $            GO TO 30
               TEMP = ONE / TEMP
               DO 20 JR = 1, N
                  VL( JR, JC ) = VL( JR, JC )*TEMP
   20          CONTINUE
   30       CONTINUE
         END IF
         IF( ILVR ) THEN
            CALL ZGGBAK( 'P', 'R', N, ILO, IHI, RWORK( ILEFT ),
     $                   RWORK( IRIGHT ), N, VR, LDVR, IINFO )
            IF( IINFO.NE.0 ) THEN
               INFO = N + 9
               GO TO 80
            END IF
            DO 60 JC = 1, N
               TEMP = ZERO
               DO 40 JR = 1, N
                  TEMP = MAX( TEMP, ABS1( VR( JR, JC ) ) )
   40          CONTINUE
               IF( TEMP.LT.SAFMIN )
     $            GO TO 60
               TEMP = ONE / TEMP
               DO 50 JR = 1, N
                  VR( JR, JC ) = VR( JR, JC )*TEMP
   50          CONTINUE
   60       CONTINUE
         END IF
*
*        End of eigenvector calculation
*
      END IF
*
*     Undo scaling in alpha, beta
*
*     Note: this does not give the alpha and beta for the unscaled
*     problem.
*
*     Un-scaling is limited to avoid underflow in alpha and beta
*     if they are significant.
*
      DO 70 JC = 1, N
         ABSAR = ABS( DBLE( ALPHA( JC ) ) )
         ABSAI = ABS( DIMAG( ALPHA( JC ) ) )
         ABSB = ABS( DBLE( BETA( JC ) ) )
         SALFAR = ANRM*DBLE( ALPHA( JC ) )
         SALFAI = ANRM*DIMAG( ALPHA( JC ) )
         SBETA = BNRM*DBLE( BETA( JC ) )
         ILIMIT = .FALSE.
         SCALE = ONE
*
*        Check for significant underflow in imaginary part of ALPHA
*
         IF( ABS( SALFAI ).LT.SAFMIN .AND. ABSAI.GE.
     $       MAX( SAFMIN, EPS*ABSAR, EPS*ABSB ) ) THEN
            ILIMIT = .TRUE.
            SCALE = ( SAFMIN / ANRM1 ) / MAX( SAFMIN, ANRM2*ABSAI )
         END IF
*
*        Check for significant underflow in real part of ALPHA
*
         IF( ABS( SALFAR ).LT.SAFMIN .AND. ABSAR.GE.
     $       MAX( SAFMIN, EPS*ABSAI, EPS*ABSB ) ) THEN
            ILIMIT = .TRUE.
            SCALE = MAX( SCALE, ( SAFMIN / ANRM1 ) /
     $              MAX( SAFMIN, ANRM2*ABSAR ) )
         END IF
*
*        Check for significant underflow in BETA
*
         IF( ABS( SBETA ).LT.SAFMIN .AND. ABSB.GE.
     $       MAX( SAFMIN, EPS*ABSAR, EPS*ABSAI ) ) THEN
            ILIMIT = .TRUE.
            SCALE = MAX( SCALE, ( SAFMIN / BNRM1 ) /
     $              MAX( SAFMIN, BNRM2*ABSB ) )
         END IF
*
*        Check for possible overflow when limiting scaling
*
         IF( ILIMIT ) THEN
            TEMP = ( SCALE*SAFMIN )*MAX( ABS( SALFAR ), ABS( SALFAI ),
     $             ABS( SBETA ) )
            IF( TEMP.GT.ONE )
     $         SCALE = SCALE / TEMP
            IF( SCALE.LT.ONE )
     $         ILIMIT = .FALSE.
         END IF
*
*        Recompute un-scaled ALPHA, BETA if necessary.
*
         IF( ILIMIT ) THEN
            SALFAR = ( SCALE*DBLE( ALPHA( JC ) ) )*ANRM
            SALFAI = ( SCALE*DIMAG( ALPHA( JC ) ) )*ANRM
            SBETA = ( SCALE*BETA( JC ) )*BNRM
         END IF
         ALPHA( JC ) = DCMPLX( SALFAR, SALFAI )
         BETA( JC ) = SBETA
   70 CONTINUE
*
   80 CONTINUE
      WORK( 1 ) = LWKOPT
*
      RETURN
*
*     End of ZGEGV
*
      END

      SUBROUTINE SGETRF( M, N, A, LDA, IPIV, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     March 31, 1993 
*
*     .. Scalar Arguments ..
      INTEGER            INFO, LDA, M, N
*     ..
*     .. Array Arguments ..
      INTEGER            IPIV( * )
      REAL               A( LDA, * )
*     ..
*
*  Purpose
*  =======
*
*  SGETRF computes an LU factorization of a general M-by-N matrix A
*  using partial pivoting with row interchanges.
*
*  The factorization has the form
*     A = P * L * U
*  where P is a permutation matrix, L is lower triangular with unit
*  diagonal elements (lower trapezoidal if m > n), and U is upper
*  triangular (upper trapezoidal if m < n).
*
*  This is the right-looking Level 3 BLAS version of the algorithm.
*
*  Arguments
*  =========
*
*  M       (input) INTEGER
*          The number of rows of the matrix A.  M >= 0.
*
*  N       (input) INTEGER
*          The number of columns of the matrix A.  N >= 0.
*
*  A       (input/output) REAL array, dimension (LDA,N)
*          On entry, the M-by-N matrix to be factored.
*          On exit, the factors L and U from the factorization
*          A = P*L*U; the unit diagonal elements of L are not stored.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(1,M).
*
*  IPIV    (output) INTEGER array, dimension (min(M,N))
*          The pivot indices; for 1 <= i <= min(M,N), row i of the
*          matrix was interchanged with row IPIV(i).
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*          > 0:  if INFO = i, U(i,i) is exactly zero. The factorization
*                has been completed, but the factor U is exactly
*                singular, and division by zero will occur if it is used
*                to solve a system of equations.
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ONE
      PARAMETER          ( ONE = 1.0E+0 )
*     ..
*     .. Local Scalars ..
      INTEGER            I, IINFO, J, JB, NB
*     ..
*     .. External Subroutines ..
      EXTERNAL           SGEMM, SGETF2, SLASWP, STRSM, XERBLA
*     ..
*     .. External Functions ..
      INTEGER            ILAENV
      EXTERNAL           ILAENV
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      IF( M.LT.0 ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( LDA.LT.MAX( 1, M ) ) THEN
         INFO = -4
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'SGETRF', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( M.EQ.0 .OR. N.EQ.0 )
     $   RETURN
*
*     Determine the block size for this environment.
*
      NB = ILAENV( 1, 'SGETRF', ' ', M, N, -1, -1 )
      IF( NB.LE.1 .OR. NB.GE.MIN( M, N ) ) THEN
*
*        Use unblocked code.
*
         CALL SGETF2( M, N, A, LDA, IPIV, INFO )
      ELSE
*
*        Use blocked code.
*
         DO 20 J = 1, MIN( M, N ), NB
            JB = MIN( MIN( M, N )-J+1, NB )
*
*           Factor diagonal and subdiagonal blocks and test for exact
*           singularity.
*
            CALL SGETF2( M-J+1, JB, A( J, J ), LDA, IPIV( J ), IINFO )
*
*           Adjust INFO and the pivot indices.
*
            IF( INFO.EQ.0 .AND. IINFO.GT.0 )
     $         INFO = IINFO + J - 1
            DO 10 I = J, MIN( M, J+JB-1 )
               IPIV( I ) = J - 1 + IPIV( I )
   10       CONTINUE
*
*           Apply interchanges to columns 1:J-1.
*
            CALL SLASWP( J-1, A, LDA, J, J+JB-1, IPIV, 1 )
*
            IF( J+JB.LE.N ) THEN
*
*              Apply interchanges to columns J+JB:N.
*
               CALL SLASWP( N-J-JB+1, A( 1, J+JB ), LDA, J, J+JB-1,
     $                      IPIV, 1 )
*
*              Compute block row of U.
*
               CALL STRSM( 'Left', 'Lower', 'No transpose', 'Unit', JB,
     $                     N-J-JB+1, ONE, A( J, J ), LDA, A( J, J+JB ),
     $                     LDA )
               IF( J+JB.LE.M ) THEN
*
*                 Update trailing submatrix.
*
                  CALL SGEMM( 'No transpose', 'No transpose', M-J-JB+1,
     $                        N-J-JB+1, JB, -ONE, A( J+JB, J ), LDA,
     $                        A( J, J+JB ), LDA, ONE, A( J+JB, J+JB ),
     $                        LDA )
               END IF
            END IF
   20    CONTINUE
      END IF
      RETURN
*
*     End of SGETRF
*
      END

C NCLFORTSTART
      SUBROUTINE TRVSPHX(INTL,IGRIDA,NLONA,NLATA,IVECA,UA,VA,IGRIDB,
     +                  NLONB,NLATB,IVECB,UB,VB,WSAVE,LSAVE,LSVMIN,WORK,
     +                  LWORK,LWKMIN,DWORK,LDWORK,IER,JMODE)
      IMPLICIT NONE
      INTEGER INTL,IGRIDA(2),NLONA,NLATA,IGRIDB(2),NLONB,NLATB
      INTEGER IVECA,IVECB,LSAVE,LSVMIN,LWORK,LWKMIN,LDWORK,IER, JMODE
      DOUBLE PRECISION UA(NLONA,NLATA),VA(NLONA,NLATA)
      DOUBLE PRECISION UB(NLONB,NLATB),VB(NLONB,NLATB)
      DOUBLE PRECISION WSAVE(LSAVE),WORK(LWORK)
      DOUBLE PRECISION DWORK(LDWORK)
C NCLEND
      INTEGER IG,IGRDA,IGRDB,LA1,LA2,LB1,LB2,LWA,LWB
      INTEGER IABR,IABI,IACR,IACI,IBBR,IBBI,IBCR,IBCI
      INTEGER NLAT,LWK1,LWK2,LW,IW,JB,NT,ITYP
      DOUBLE PRECISION RN
c
c     include a save statement to ensure local variables in trvsph, set during
c     an intl=0 call, are preserved if trvsph is recalled with intl=1
c
      SAVE
c
c     check input arguments
c
      IER = 1
      IF (INTL* (INTL-1).NE.0) RETURN
      IER = 2
      IG = IGRIDA(1)
      IF ((IG-1)* (IG+1)* (IG-2)* (IG+2).NE.0) RETURN
      IER = 3
      IG = IGRIDA(2)
      IF (IG* (IG-1).NE.0) RETURN
      IER = 4
      IF (NLONA.LT.4) RETURN
      IER = 5
      IF (NLATA.LT.3) RETURN
      IER = 6
      IF (IVECA* (IVECA-1).NE.0) RETURN
      IER = 7
      IG = IGRIDB(1)
      IF ((IG-1)* (IG+1)* (IG-2)* (IG+2).NE.0) RETURN
      IER = 8
      IG = IGRIDB(2)
      IF (IG* (IG-1).NE.0) RETURN
      IER = 9
      IF (NLONB.LT.4) RETURN
      IER = 10
      IF (NLATB.LT.3) RETURN
      IER = 11
      IF (IVECB* (IVECB-1).NE.0) RETURN
      IER = 0
      IGRDA = IABS(IGRIDA(1))
      IGRDB = IABS(IGRIDB(1))
      IF (INTL.EQ.0) THEN
          LA1 = MIN0(NLATA, (NLONA+1)/2)
          LA2 = (NLATA+1)/2
          LB1 = MIN0(NLATB, (NLONB+1)/2)
          LB2 = (NLATB+1)/2
c
c     saved space for analysis on a grid
c
          LWA = 4*NLATA*LA2 + 3*MAX0(LA1-2,0)* (2*NLATA-LA1-1) + LA2 +
     +          NLONA + 15
c
c     set saved work space length for synthesis on b grid
c
          LWB = 4*NLATB*LB2 + 3*MAX0(LB1-2,0)* (2*NLATB-LB1-1) + NLONB +
     +          15
c
c     set minimum required saved work space length
c
          LSVMIN = LWA + LWB
c
c     set wsave pointer
c
          JB = 1 + LWA
c
c     set pointers for vector spherical harmonic coefs in work
c
          IABR = 1
          IABI = IABR + LA1*NLATA
          IACR = IABI + LA1*NLATA
          IACI = IACR + LA1*NLATA
          IBBR = IACI + LA1*NLATA
          IBBI = IBBR + LB1*NLATB
          IBCR = IBBI + LB1*NLATB
          IBCI = IBCR + LB1*NLATB
c
c     set pointers for remaining work
c
          IW = IBCI + LB1*NLATB
c
c     set remaining work space length in lw
c
          LW = LWORK - IW
c
c     compute unsaved space for analysis and synthesis
c
          LWK1 = 2*NLATA* (2*NLONA+MAX0(6*LA2,NLONA))
          LWK2 = 2*NLATB* (2*NLONB+MAX0(6*LB2,NLONB))
c
c     set minimum unsaved work space required by trvsph
c
          LWKMIN = IW + MAX0(LWK1,LWK2)
c
c     set error flags if saved or unsaved work space is insufficient
c
          IER = 12
          IF (LSAVE.LT.LSVMIN) RETURN
          IER = 13
          IF (LWORK.LT.LWKMIN) RETURN
          IER = 15
          NLAT = MAX0(NLATA,NLATB)
          IF (LDWORK.LT.2*NLAT* (NLAT+1)+1) RETURN
          IER = 0
          IF (IGRDA.EQ.1) THEN
c
c     initialize wsave for equally spaced analysis
c
              CALL DVHAECI(NLATA,NLONA,WSAVE,LWA,DWORK,LDWORK,IER)
          ELSE
c
c     initialize wsave for gaussian analysis
c
              CALL DVHAGCI(NLATA,NLONA,WSAVE,LWA,DWORK,LDWORK,IER)
              IF (IER.NE.0) THEN
c
c     flag failure in spherepack gaussian software
c
                  IER = 14
                  RETURN
              END IF
          END IF

          IF (IGRDB.EQ.2) THEN
c
c     initialize wsave for gaussian synthesis
c
              CALL DVHSGCI(NLATB,NLONB,WSAVE(JB),LWB,DWORK,LDWORK,IER)
              IF (IER.NE.0) THEN
c
c     flag failure in spherepack gaussian software
c
                  IER = 14
                  RETURN
              END IF
          ELSE
c
c     initialize wsave for equally spaced synthesis
c
              CALL DVHSECI(NLATB,NLONB,WSAVE(JB),LWB,DWORK,LDWORK,IER)
          END IF
c
c     end of initialization (intl=0) call
c
      END IF
c
C*PL*ERROR* Comment line too long
c     convert the vector field (ua,va) to mathematical spherical coordinates
c
      IF (IGRIDA(2).EQ.0) THEN
          CALL DTRVPLAT(NLONA,NLATA,UA,WORK)
          CALL DTRVPLAT(NLONA,NLATA,VA,WORK)
      END IF
      IF (IGRIDA(1).GT.0) THEN
          CALL DCOVLAT(NLATA,NLONA,UA)
          CALL DCOVLAT(NLATA,NLONA,VA)
      END IF
      IF (IVECA.EQ.0) THEN
          CALL DNEGV(NLATA,NLONA,VA)
      END IF
      NT = 1
      ITYP = 0
c
c     analyze vector field
c
      IF (IGRDA.EQ.2) THEN
          CALL DVHAGC(NLATA,NLONA,ITYP,NT,VA,UA,NLATA,NLONA,WORK(IABR),
     +               WORK(IABI),WORK(IACR),WORK(IACI),LA1,NLATA,WSAVE,
     +               LWA,WORK(IW),LW,IER)
      ELSE
          CALL DVHAEC(NLATA,NLONA,ITYP,NT,VA,UA,NLATA,NLONA,WORK(IABR),
     +               WORK(IABI),WORK(IACR),WORK(IACI),LA1,NLATA,WSAVE,
     +               LWA,WORK(IW),LW,IER)
      END IF
c
c     transfer "a" grid coefficients to "b" grid coefficients
c
      CALL DTRVAB(LA1,NLATA,WORK(IABR),WORK(IABI),WORK(IACR),WORK(IACI),
     +            LB1,NLATB,WORK(IBBR),WORK(IBBI),WORK(IBCR),WORK(IBCI))
c     --------------------------NEW----------------------------------
c     (possibly) truncate and (possibly) taper the spectral coef
c
      IF (JMODE.NE.0) THEN
          CALL DTRITRUNC(NLATB,ABS(JMODE),NLATB,WORK(IBBR),WORK(IBBI))
          CALL DTRITRUNC(NLATB,ABS(JMODE),NLATB,WORK(IBCR),WORK(IBCI))
          IF (JMODE.LT.0) THEN
              RN = MAX(ABS(JMODE)/10,1)*10
c c c         RN = RN-1.0
              CALL DEXPTAPERSH(NLATB,NLATB,WORK(IBBR),WORK(IBBI)
     +                        ,RN,4,IER)
              CALL DEXPTAPERSH(NLATB,NLATB,WORK(IBCR),WORK(IBCI)
     +                        ,RN,4,IER)
          END IF
      END IF
c     ---------------------------------------------------------------
c
c     synthesize on b grid
c
      IF (IGRDB.EQ.1) THEN
          CALL DVHSEC(NLATB,NLONB,ITYP,NT,VB,UB,NLATB,NLONB,WORK(IBBR),
     +               WORK(IBBI),WORK(IBCR),WORK(IBCI),LB1,NLATB,
     +               WSAVE(JB),LWB,WORK(IW),LW,IER)
      ELSE
          CALL DVHSGC(NLATB,NLONB,ITYP,NT,VB,UB,NLATB,NLONB,WORK(IBBR),
     +               WORK(IBBI),WORK(IBCR),WORK(IBCI),LB1,NLATB,
     +               WSAVE(JB),LWB,WORK(IW),LW,IER)
      END IF
c
c     restore a grid and b grid vector fields (now in math coordinates) to
c     agree with grid flags in igrida,iveca,igridb,ivecb
c
      IF (IVECA.EQ.0) THEN
          CALL DNEGV(NLATA,NLONA,VA)
      END IF
      IF (IVECB.EQ.0) THEN
          CALL DNEGV(NLATB,NLONB,VB)
      END IF
      IF (IGRIDA(1).GT.0) THEN
          CALL DCOVLAT(NLATA,NLONA,UA)
          CALL DCOVLAT(NLATA,NLONA,VA)
      END IF
      IF (IGRIDB(1).GT.0) THEN
          CALL DCOVLAT(NLATB,NLONB,UB)
          CALL DCOVLAT(NLATB,NLONB,VB)
      END IF
      IF (IGRIDA(2).EQ.0) THEN
          CALL DTRVPLAT(NLATA,NLONA,UA,WORK)
          CALL DTRVPLAT(NLATA,NLONA,VA,WORK)
      END IF
      IF (IGRIDB(2).EQ.0) THEN
          CALL DTRVPLAT(NLATB,NLONB,UB,WORK)
          CALL DTRVPLAT(NLATB,NLONB,VB,WORK)
      END IF
      RETURN
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                       C
C                Copyright (C)  1995                                    C
C        University Corporation for Atmospheric Research                C
C                All Rights Reserved                                    C
C                                                                       C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C   File:         basic08f.f
C
C   Author:       David Brown (translated to Fortran by David Younghans)
C                 National Center for Atmospheric Research
C                 Boulder, Colorado  80303
C
C
C   Date:         Wed August 23, 1995
C
C   Description:  This Fortran program demonstrates how to draw
C                 a plot object including any annotations
C                 outside its viewport within a predefined 
C                 bounded area of NDC space. The subroutine 
C                 drbdplt is intended to be useful in any
C                 context where it is desired to keep an entire plot
C                 within predetermined boundaries.
C
C
      program basic08f
      implicit none
      external NhlFAppClass
      external NhlFNcgmWorkstationClass
      external NhlFCairoWindowWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFLogLinPlotClass
      external NhlFContourPlotClass
      
      integer appid,rlist,grlist
      integer wid,gid,ll_id,cn_id
      character*7  wks_type
      integer ierr

      real x(5),y(5)
C
C Define the workstation type
C
      wks_type = "x11"
C
C Initialize the high level utility library and create application.
C
      call NhlFInitialize
      call NhlFRLCreate(rlist,'SETRL')
      call NhlFRLCreate(grlist,'GETRL')

      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'appUsrDir','./',ierr)
      call NhlFRLSetString(rlist,'appDefaultParent','True',ierr)
      call NhlFCreate(appid,'basic08',NhlFAppClass,0,rlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create a metafile workstation with the default colormap.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkMetaName',
     &        './basic08f.ncgm',ierr)
         call NhlFCreate(wid,'simple',
     &        NhlfNcgmWorkstationClass,0,rlist,ierr)
      endif

      if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X workstation.         
C      
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPause','True',ierr)
         call NhlFCreate(wid,'simple',
     +        NhlFCairoWindowWorkstationClass,
     &        0,rlist,ierr)
      endif

      if (wks_type.eq."oldps".or.wks_type.eq."oldPS") then
C
C Create an older-style PS workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPSFileName',
     &        './basic08f.ps',ierr)
         call NhlFCreate(wid,'simple',NhlFPSWorkstationClass,
     &        0,rlist,ierr)
      endif
      if (wks_type.eq."oldpdf".or.wks_type.eq."oldPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPDFFileName',
     &        './basic08f.pdf',ierr)
         call NhlFCreate(wid,'simple_pdf',NhlFPDFWorkstationClass,
     &        0,rlist,ierr)
      endif
      if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     &    wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFileName','./basic08c',ierr)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(wid,'simple_cairo',
     +                   NhlFCairoPSPDFWorkstationClass,0,rlist,ierr)
      end if
      if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFileName','./basic08c',ierr)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(wid,'simple_cairo',
     +                   NhlFcairoImageWorkstationClass,0,rlist,ierr)
      end if
C
C Create a LogLinPlot with a viewport that fills the viewspace. This will
C be used for drawing immediate mode polylines indicating the intended
C boundary of each plot object.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetFloat(rlist,'vpXF',0.0,ierr)
      call NhlFRLSetFloat(rlist,'vpYF',1.0,ierr)
      call NhlFRLSetFloat(rlist,'vpHeightF',1.0,ierr)
      call NhlFRLSetFloat(rlist,'vpWidthF',1.0,ierr)
      call NhlFCreate(ll_id,'loglin',NhlFLogLinPlotClass,
     &     wid,rlist,ierr)
C
C Set GraphicStyle resources to modify the immediate mode line
C attributes.
C
      call NhlFRLClear(grlist)
      call NhlFRLGetInteger(grlist,'wkDefGraphicStyleId',gid,ierr)
      call NhlFGetValues(wid,grlist,ierr)

      call NhlFRLClear(rlist)
      call NhlFRLSetInteger(rlist,'gsLineColor',2,ierr)
      call NhlFRLSetInteger(rlist,'gsLineDashPattern',1,ierr)
      call NhlFSetValues(gid,rlist,ierr)
C
C Create an empty ContourPlot with a Title, a LableBar, and a Legend.
C Note that the viewport is square and covers the whole NDC space,
C meaning that if the plot were drawn as created, all annotations exterior
C to the viewport would be outside the viewspace and therefore clipped.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'pmLabelBarDisplayMode',
     &     'always',ierr)
      call NhlFRLSetString(rlist,'pmLegendDisplayMode',
     &     'always',ierr)
      call NhlFRLSetString(rlist,'tiMainString',
     &     'bounded contour plot',ierr)
      call NhlFRLSetFloat(rlist,'vpXF',0.0,ierr)
      call NhlFRLSetFloat(rlist,'vpYF',1.0,ierr)
      call NhlFRLSetFloat(rlist,'vpHeightF',1.0,ierr)
      call NhlFRLSetFloat(rlist,'vpWidthF',1.0,ierr)
      call NhlFCreate(cn_id,'contour',NhlFContourPlotClass,
     &     wid,rlist,ierr)
C
C The first frame illustrates drawing the plot with a 5% margin around
C the viewable area. Draw an immediate mode line indicating the boundary
C that defines the margin.
C
      x(1) = 0.05
      x(2) = 0.95
      x(3) = 0.95
      x(4) = 0.05
      x(5) = 0.05
      
      y(1) = 0.05
      y(2) = 0.05
      y(3) = 0.95
      y(4) = 0.95
      y(5) = 0.05

      call NhlFNDCPolyline(ll_id,gid,x,y,5,ierr)
C
C Draw the plot with the desired boundary parameters.
C
      call drbdplt(cn_id,.true.,0.05,0.95,0.05,0.95,rlist)
      call NhlFFrame(wid,ierr)
C
C The second frame illustrates use of the drbdplt subroutine
C to place several plots with varying aspect ratios in a single frame.
C
      x(1) = 0.025
      x(2) = 0.475
      x(3) = 0.475
      x(4) = 0.025
      x(5) = 0.025

      y(1) = 0.525
      y(2) = 0.525
      y(3) = 0.975
      y(4) = 0.975
      y(5) = 0.525

      call NhlFNDCPolyline(ll_id,gid,x,y,5,ierr)
C
C Set the ContourPlot viewport so that the width is twice the height.
C (The absolute numbers are not important here, only the ratio matters.)
C
      call NhlFRLClear(rlist)
      call NhlFRLSetFloat(rlist,'vpWidthF',0.6,ierr)
      call NhlFRLSetFloat(rlist,'vpHeightF',0.3,ierr)
      call NhlFRLSetString(rlist,'tiMainString',
     &     'width is limiting dimension',ierr)
      call NhlFsetValues(cn_id,rlist,ierr)
C
C Draw the plot with the desired boundary parameters.
C
      call drbdplt(cn_id,.true., 0.025, 0.475, 0.525, 0.975,
     &     rlist)
C
C Draw an immediate mode line indicating the desired boundary of the
C second plot.
C      
      x(1) = 0.525
      x(2) = 0.975
      x(3) = 0.975
      x(4) = 0.525
      x(5) = 0.525

      y(1) = 0.525
      y(2) = 0.525
      y(3) = 0.975
      y(4) = 0.975
      y(5) = 0.525

      call NhlFNDCPolyline(ll_id,gid,x,y,5,ierr)
C
C Set the ContourPlot viewport so that the height is twice the width.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetFloat(rlist,'vpWidthF',0.3,ierr)
      call NhlFRLSetFloat(rlist,'vpHeightF',0.6,ierr)
      call NhlFRLSetString(rlist,'tiMainString',
     &     'height is limiting dimension',ierr)
      call NhlFSetValues(cn_id,rlist,ierr)
C
C Draw the plot with the desired boundary parameters.
C
      call drbdplt(cn_id,.true., 0.525, 0.975, 0.525, 0.975,
     &     rlist)
C
C Draw an immediate mode line indicating the desired boundary of the
C third plot.
C
      x(1) = 0.125
      x(2) = 0.875
      x(3) = 0.875
      x(4) = 0.125
      x(5) = 0.125

      y(1) = 0.1
      y(2) = 0.1
      y(3) = 0.4
      y(4) = 0.4
      y(5) = 0.1

      call NhlFNDCPolyline(ll_id,gid,x,y,5,ierr)
C
C For this plot the aspect ratio is distorted in order to fill as much as
C possible of the desired area. Note that the space is not completely filled.
C This is because a number of factors affecting the final aspect ratio,
C such as the text size used for titles, are determined based on only
C one of the viewport's dimensions.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetFloat(rlist,'vpHeightF',1.0,ierr)
      call NhlFRLSetFloat(rlist,'vpWidthF',1.0,ierr)
      call NhlFRLSetString(rlist,'tiMainString',
     &     'distort aspect ratio to fill area',ierr)
      call NhlFSetValues(cn_id,rlist,ierr)
C
C Draw the plot with the desired boundary parameters.
C
      call drbdplt(cn_id,.false., 0.125, 0.875, 0.1, 0.4,
     &     rlist)
      call NhlFFrame(wid,ierr)
C
C Clean up
C
      call NhlFDestroy(wid,ierr)
      call NhlFClose

      stop
      
      end
C
C
C
      subroutine drbdplt(id,keep_aspect,left,right,
     &     bottom,top,rlist)
C
C This subroutine takes the plot object with identifier "id" and
C draws it within the NDC boundaries represented by left, right,
C top, and bottom. If keep_aspect is .true, the aspect ratio of the plot
C is preserved: the plot fills the extent of the limiting dimension and
C is centered within the extent of the other dimension. If keep_aspect is
C .false., the aspect ratio is distorted in order to fill as much of the
C space as possible, given certain limitations in the ability of some
C HLU object to distort themselves to any arbitrary aspect ratio.
C

      implicit none

      integer id
      logical keep_aspect
      real left,right,bottom,top

      integer grlist,rlist,ierr
      real x_save,y_save,width_save,height_save,
     &     bb_top,bb_bottom,bb_left,bb_right,bb_height,bb_width,
     &     frame_height,frame_width,
     &     factor,
     &     x_off,y_off,x,y,width,height

      call NhlFRLCreate(grlist,'GETRL')
      call NhlFRLClear(grlist)
      call NhlFRLGetFloat(grlist,'vpXF',x_save,ierr)
      call NhlFRLGetFloat(grlist,'vpYF',y_save,ierr)
      call NhlFRLGetFloat(grlist,'vpWidthF',width_save,ierr)
      call NhlFRLGetFloat(grlist,'vpHeightF',height_save,ierr)
      call NhlFGetValues(id,grlist,ierr)

      call NhlFGetBB(id,bb_top,bb_bottom,bb_left,bb_right,ierr)

      bb_height = bb_top - bb_bottom
      bb_width = bb_right - bb_left
      frame_height = top - bottom
      frame_width = right - left
      x = x_save
      y = y_save
      height = height_save
      width = width_save

      if (.not. keep_aspect) then
         factor = frame_width / bb_width
         width = width * factor
         x_off = (x - bb_left) * factor
         x = left + x_off
         factor = frame_height / bb_height
         height = height * factor
         y_off = (y - bb_top) * factor
         y = top + y_off

         call NhlFRLClear(rlist)
         call NhlFRLSetFloat(rlist,'vpXF',x,ierr)
         call NhlFRLSetFloat(rlist,'vpYF',y,ierr)
         call NhlFRLSetFloat(rlist,'vpWidthF',width,ierr)
         call NhlFRLSetFloat(rlist,'vpHeightF',height,ierr)
         call NhlFSetValues(id,rlist,ierr)

         call NhlFRLClear(grlist)
         call NhlFRLGetFloat(grlist,'vpXF',x,ierr)
         call NhlFRLGetFloat(grlist,'vpYF',y,ierr)
         call NhlFRLGetFloat(grlist,'vpWidthF',width,ierr)
         call NhlFRLGetFloat(grlist,'vpHeightF',height,ierr)
         call NhlFGetValues(id,grlist,ierr)

         call NhlFGetBB(id,bb_top,bb_bottom,bb_left,bb_right,ierr)

         bb_height = bb_top - bb_bottom
         bb_width = bb_right - bb_left

      endif

      if (bb_height / bb_width .lt. frame_height / frame_width) then
C
C Width is the limiting dimension.
C
         factor = frame_width / bb_width
         width = width * factor
         height = height * factor
         x_off = (x - bb_left) * factor
         y_off = (y - bb_top) * factor
         x = left + x_off
         bb_height = bb_height * factor
         y = top + y_off - 0.5 * (frame_height - bb_height)

      else
C
C Height is the limiting dimension.
C
         factor = frame_height / bb_height
         height = height * factor
         width = width * factor
         x_off = (x - bb_left) * factor
         y_off = (y - bb_top) * factor
         bb_width = bb_width * factor
         x = left + x_off + 0.5 * (frame_width - bb_width)
         y = top + y_off
      endif
         
      call NhlFRLClear(rlist)
      call NhlFRLSetFloat(rlist,'vpXF',x,ierr)
      call NhlFRLSetFloat(rlist,'vpYF',y,ierr)
      call NhlFRLSetFloat(rlist,'vpWidthF',width,ierr)
      call NhlFRLSetFloat(rlist,'vpHeightF',height,ierr)
      call NhlFSetValues(id,rlist,ierr)

      call NhlFDraw(id,ierr)

      call NhlFRLClear(rlist)
      call NhlFRLSetFloat(rlist,'vpXF',x_save,ierr)
      call NhlFRLSetFloat(rlist,'vpYF',y_save,ierr)
      call NhlFRLSetFloat(rlist,'vpWidthF',width_save,ierr)
      call NhlFRLSetFloat(rlist,'vpHeightF',height_save,ierr)
      call NhlFSetValues(id,rlist,ierr)

      return
      
      end

      PROGRAM AREX03
C
C This example shows the effect of the new internal parameter 'RC' on
C the process of reconciling conflicting area-identifier information.
C It puts into an area map five rows of decagons; each of the rows is
C identified with a particular edge group and a particular element of
C 'RC'.  Each of the decagons is drawn using 10 edge segments having
C different area identifiers; the area identifier associated with each
C edge is shown and the area identifier selected for the whole decagon
C is shown in its center.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
        PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Define the length of the area map array.
C
        PARAMETER (LAMA=50000)
C
C Declare the area map array for ARSCAM.
C
        DIMENSION IAMA(LAMA)
C
C Declare arrays in which to define edge segments for AREDAM.
C
        DIMENSION XEDG(11),YEDG(11)
C
C Declare an array in which to put area identifiers for each of the
C ten edges of each of the five decagons in each row of decagons on
C each of two frames.
C
        DIMENSION IAID(10,5,2)
C
C Declare external the user routine to process a subarea, so the
C compiler won't mistake its name for that of a variable.
C
        EXTERNAL URTPSA
C
C Declare scratch arrays for ARSCAM to use in calls to URTPSA.
C
        DIMENSION XCRA(1000),YCRA(1000),IAAI(9),IAGI(9)
C
C Declare a character temporary to use in writing area ids.
C
        CHARACTER*2 CTMP
C
C Declare a character variable in which to put the main title.
C
        CHARACTER*38 TITL
C
C Define the area identifiers to be used for each of the ten edges
C of each of the five decagons in each row of decagons.
C
        DATA IAID / -1 , -1 , -2 , -3 , -4 , -5 , -6 , -7 , -8 , -9 ,
     +               0 ,  0 ,  0 ,  0 ,  0 ,  0 ,  0 ,  0 ,  0 ,  0 ,
     +               1 ,  1 ,  1 ,  1 ,  1 ,  1 ,  1 ,  1 ,  1 ,  1 ,
     +               2 ,  1 ,  1 ,  1 ,  1 ,  1 ,  1 ,  1 ,  1 ,  1 ,
     +               1 ,  1 ,  1 ,  1 ,  1 ,  1 ,  1 ,  1 ,  1 ,  2 ,
     +               1 ,  1 ,  1 ,  1 ,  1 ,  2 ,  2 ,  2 ,  2 ,  2 ,
     +              -1 ,  1 ,  1 ,  1 ,  1 ,  2 ,  2 ,  2 ,  2 ,  2 ,
     +               0 ,  0 ,  0 ,  0 ,  0 ,  0 ,  0 ,  0 ,  0 ,  1 ,
     +               0 ,  0 ,  0 ,  0 ,  0 ,  0 ,  0 ,  2 ,  2 ,  1 ,
     +               0 ,  0 ,  0 ,  0 , -3 , -2 , -1 ,  2 ,  2 ,  1 /
C
C Define the title with an "n" to be replaced by a frame number.
C
        DATA TITL / 'USING VARIOUS VALUES OF ''RC'' - FRAME n' /
C
C Open GKS.
C
        CALL GOPKS (IERRF,ISZDM)
        CALL GOPWK (IWKID,LUNIT,IWTYPE)
        CALL GACWK (IWKID)
C
C Turn off clipping by GKS.
C
        CALL GSCLIP (0)
C
C Set up a convenient mapping from the user coordinate system to the
C fractional coordinate system.
C
        CALL SET (.15,.95,.02,.82,.5,5.5,.5,5.5,1)
C
C Tell PLOTCHAR to use font number 25 and to put outlines on all filled
C characters.
C
        CALL PCSETI ('FN - FONT NUMBER',25)
        CALL PCSETI ('OF - OUTLINE FLAG',1)
C
C Set up an outer loop on frame number.
C
        DO 105 IFRA=1,2
C
C Put some labels at the top of the plot.
C
        TITL(38:38)=CHAR(ICHAR('0')+IFRA)
        CALL PLCHHQ (CFUX(.5),CFUY(.954),TITL,.02,0.,0.)
C
        CALL PLCHHQ (CFUX(.5),CFUY(.918), 'The specified element of ''RC
     +'' is used for each decagon in a particular horizontal row.',
     +                                                       .012,0.,0.)
C
        CALL PLCHHQ (CFUX(.5),CFUY(.894), 'The same set of area identifi
     +ers is used for each decagon in a particular vertical column.',
     +                                                       .012,0.,0.)
C
        CALL PLCHHQ (CFUX(.5),CFUY(.870),'Each of the small numbers in a
     + decagon is an area identifier for one edge of the decagon.',
     +                                                       .012,0.,0.)
C
        CALL PLCHHQ (CFUX(.5),CFUY(.846),'(The larger the character size
     + used for the number, the more recently it was seen by AREAS.)',
     +                                                       .012,0.,0.)
C
        CALL PLCHHQ (CFUX(.5),CFUY(.822),'The largest number (in the cen
     +ter of the decagon) is a reconciled area identifier for the decago
     +n.',
     +                                                       .012,0.,0.)
C
C Set the values of the elements of the 'RC' parameter array so that
C each reconciliation method will be used for exactly one edge group.
C
        CALL ARSETI ('RC(1) - RECONCILIATION METHOD FOR GROUP 1',-2)
        CALL ARSETI ('RC(2) - RECONCILIATION METHOD FOR GROUP 2',-1)
        CALL ARSETI ('RC(3) - RECONCILIATION METHOD FOR GROUP 3', 0)
        CALL ARSETI ('RC(4) - RECONCILIATION METHOD FOR GROUP 4', 1)
        CALL ARSETI ('RC(5) - RECONCILIATION METHOD FOR GROUP 5', 2)
C
C Change the function-code signal character for PLOTCHAR so we can
C use colons in some labels.
C
        CALL PCSETC ('FC - FUNCTION-CODE CHARACTER','|')
C
C Put labels on each of the rows of decagons.
C
        CALL PLCHHQ (CFUX(.05),4.75,'RC(1): -2',.015,0.,-1.)
        CALL PLCHHQ (CFUX(.05),3.75,'RC(2): -1',.015,0.,-1.)
        CALL PLCHHQ (CFUX(.05),2.75,'RC(3):  0',.015,0.,-1.)
        CALL PLCHHQ (CFUX(.05),1.75,'RC(4): +1',.015,0.,-1.)
        CALL PLCHHQ (CFUX(.05),0.75,'RC(5): +2',.015,0.,-1.)
C
        CALL PLCHHQ (CFUX(.05),4.5,'Method: If any are negative, use -1;
     + else, use most-frequently-occurring value, possibly zero.',
     +                                                      .012,0.,-1.)
C
        CALL PLCHHQ (CFUX(.05),3.5,'Method: If any are negative, use -1;
     + if all are zero, use zero; else, use most-frequently-occurring no
     +n-zero.',
     +                                                      .012,0.,-1.)
C
        CALL PLCHHQ (CFUX(.05),2.5,'Method: If any are negative, use -1;
     + if all are zero, use zero; else, use most-recently-seen non-zero.
     +',
     +                                                      .012,0.,-1.)
C
        CALL PLCHHQ (CFUX(.05),1.5,'Method: Ignore zeroes; treat negativ
     +es as -1s; use most-frequently-occurring value in resulting set.',
     +                                                      .012,0.,-1.)
C
        CALL PLCHHQ (CFUX(.05),0.5, 'Method: Do not ignore zeroes; treat
     + negatives as -1s; use most-frequently-occurring value in resultin
     +g set.',
     +                                                      .012,0.,-1.)
C
C Change the function-code signal character for PLOTCHAR back to the
C default.
C
        CALL PCSETC ('FC - FUNCTION-CODE CHARACTER',':')
C
C Initialize the area map.
C
        CALL ARINAM (IAMA,LAMA)
C
C Put a collection of decagons into the area map.  Each horizontal row
C of decagons is identified with a particular edge group and therefore
C with a particular element of 'RC'.
C
        DO 104 IGID=1,5
          YCEN=REAL(6-IGID)
          DO 103 IDEC=1,5
            XCEN=REAL(IDEC)
            DO 101 IANG=1,10
              ANG1=.017453292519943*REAL(MOD(36*IANG-36,360))
              ANG2=.017453292519943*REAL(MOD(36*IANG-18,360))
              XEDG(IANG)=XCEN+.4*COS(ANG1)
              YEDG(IANG)=YCEN+.4*SIN(ANG1)
              WRITE (CTMP,'(I2)') IAID(IANG,IDEC,IFRA)
              CALL PLCHHQ (XCEN+.27*COS(ANG2),YCEN+.27*SIN(ANG2),CTMP,
     +                                    .006+.0009*REAL(IANG),0.,0.)
  101       CONTINUE
            XEDG(11)=XEDG(1)
            YEDG(11)=YEDG(1)
            CALL GSLWSC (2.)
            CALL GPL    (11,XEDG,YEDG)
            CALL GSLWSC (1.)
            DO 102 IANG=1,10
              CALL AREDAM (IAMA,XEDG(IANG),YEDG(IANG),2,IGID,
     +                                IAID(IANG,IDEC,IFRA),0)
  102       CONTINUE
  103     CONTINUE
  104   CONTINUE
C
C Scan the area map, extracting all subareas and delivering each to
C a processing routine that will just draw the edge of the area and
C write its area identifier, relative to the group IGID, in its
C center.
C
        CALL ARSCAM (IAMA,XCRA,YCRA,1000,IAAI,IAGI,9,URTPSA)
C
C Advance the frame.
C
        CALL FRAME
C
C End of frame loop.
C
  105   CONTINUE
C
C Close GKS.
C
        CALL GDAWK (IWKID)
        CALL GCLWK (IWKID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END



      SUBROUTINE URTPSA (XCRA,YCRA,NCRA,IAAI,IAGI,NGPS)
C
        DIMENSION XCRA(NCRA),YCRA(NCRA),IAAI(NGPS),IAGI(NGPS)
C
C Declare a character temporary to use in writing area identifiers.
C
        CHARACTER*2 CTMP
C
C If the number of groups reported is not equal to five, log an error
C and return.
C
        IF (NGPS.NE.5) THEN
          PRINT * , 'IN URTPSA, NGPS NOT EQUAL TO 5'
          RETURN
        END IF
C
C Otherwise, if the number of coordinates is eleven, it's one of the
C decagons, so plot the appropriate area identifier in the middle of it.
C
        IF (NCRA.EQ.11) THEN
          XCEN=0.
          YCEN=0.
          DO 101 I=1,NCRA-1
            XCEN=XCEN+XCRA(I)
            YCEN=YCEN+YCRA(I)
  101     CONTINUE
          XCEN=XCEN/REAL(NCRA-1)
          YCEN=YCEN/REAL(NCRA-1)
          IGID=MAX(1,MIN(5,1+INT((.82-YCEN)/.16)))
          IAID=-2
          DO 102 I=1,NGPS
            IF (IAGI(I).EQ.IGID) IAID=IAAI(I)
  102     CONTINUE
          IF (IAID.NE.-2) THEN
            WRITE (CTMP,'(I2)') IAID
            CALL PLCHHQ (XCEN,YCEN,CTMP,.02,0.,0.)
          ELSE
            PRINT * , 'IN URTPSA, DESIRED AREA IDENTIFIER NOT FOUND'
          END IF
        END IF
C
C Done.
C
        RETURN
C
      END

C
C $Id: mdptra.f,v 1.9 2008-09-18 00:42:17 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MDPTRA (RLAT,RLON,UVAL,VVAL)
C
        DOUBLE PRECISION RLAT,RLON,UVAL,VVAL
C
C Declare required common blocks.  See MAPBDX for descriptions of these
C common blocks and the variables in them.
C
        COMMON /MAPCM4/  GRDR,GRID,GRLA,GRLO,GRPO,OTOL,PDRE,PLA1,PLA2,
     +                   PLA3,PLA4,PLB1,PLB2,PLB3,PLB4,PLNO,PLTO,ROTA,
     +                   SRCH,XLOW,XROW,YBOW,YTOW,IDOT,IDSH,IDTL,ILCW,
     +                   ILTS,JPRJ,ELPF,INTF,LBLF,PRMF
        DOUBLE PRECISION GRDR,GRID,GRLA,GRLO,GRPO,OTOL,PDRE,PLA1,PLA2,
     +                   PLA3,PLA4,PLB1,PLB2,PLB3,PLB4,PLNO,PLTO,ROTA,
     +                   SRCH,XLOW,XROW,YBOW,YTOW
        INTEGER          IDOT,IDSH,IDTL,ILCW,ILTS,JPRJ
        LOGICAL          ELPF,INTF,LBLF,PRMF
        SAVE   /MAPCM4/
C
        COMMON /MAPCM6/  UCNM,UMNM,UMXM,URNM,VCNM,VMNM,VMXM,VRNM,ELPM
        DOUBLE PRECISION UCNM,UMNM,UMXM,URNM,VCNM,VMNM,VMXM,VRNM
        LOGICAL ELPM
        SAVE   /MAPCM6/
C
C Check for an uncleared prior error.
C
        IF (ICFELL('MDPTRA - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C If EZMAP needs initialization, do it.
C
        IF (INTF) THEN
          CALL MDPINT
          IF (ICFELL('MDPTRA',2).NE.0) RETURN
        END IF
C
C The call to MDPTRA is simply passed on to MDPTRN, but the values
C returned are checked to see if the point lies outside the perimeter;
C if so, the value 1.D12 is substituted for UVAL.
C
        CALL MDPTRN (RLAT,RLON,UVAL,VVAL)
        IF (ICFELL('MDPTRA',3).NE.0) RETURN
C
        IF (ELPM) THEN
          IF (((UVAL-UCNM)/URNM)**2+
     +        ((VVAL-VCNM)/VRNM)**2.GT.1.000002D0) THEN
            UVAL=1.D12
            VVAL=1.D12
          END IF
        ELSE
          IF (UVAL.LT.UMNM.OR.UVAL.GT.UMXM.OR.
     +        VVAL.LT.VMNM.OR.VVAL.GT.VMXM) THEN
            UVAL=1.D12
            VVAL=1.D12
          END IF
        END IF
C
        RETURN
C
      END

C
C $Id: agchax.f,v 1.6 2008-07-27 00:14:33 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE AGCHAX (IFLG,IAXS,IPRT,VILS)
C
C The routine AGCHAX is called by AGAXIS just before and just after each
C of a selected set of objects on the axes are drawn.  A user may supply
C a version to change the appearance of these objects.  The arguments
C are as follows:
C
C - IFLG is zero if a particular object is about to be drawn, non-zero
C   if it has just been drawn.
C
C - IAXS is the number of the axis in question.  The values 1, 2, 3, and
C   4 imply the right, left, bottom, and top axes, respectively.
C
C - IPRT is an integer implying which part of the axis is being drawn.
C   The value 1 implies the line itself, 2 a major tick, 3 a minor tick,
C   4 the mantissa of a label, and 5 the exponent of a label.
C
C - VILS is the value, in the label coordinate system along the axis,
C   associated with the position of the object being drawn.  IPRT=1
C   implies VILS=0.
C
C Done.
C
      RETURN
C
      END

      PROGRAM SFEX01
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Declare required dimensioned arrays.
C
      DIMENSION XRA(200),YRA(200),DST(220),IND(240)
      DIMENSION ID1(8,8),ID2(8,8),ID3(8,8),ID4(8,8)
C
C Define four different dot patterns.
C
      DATA ID1 / 1,1,0,0,0,0,1,1,
     +           1,1,0,1,1,0,1,1,
     +           0,0,0,1,1,0,0,0,
     +           0,1,1,1,1,1,1,0,
     +           0,1,1,1,1,1,1,0,
     +           0,0,0,1,1,0,0,0,
     +           1,1,0,1,1,0,1,1,
     +           1,1,0,0,0,0,1,1/
      DATA ID2 / 0,0,0,0,0,0,0,0,
     +           0,1,1,1,1,1,1,0,
     +           0,1,1,1,1,1,1,0,
     +           0,1,1,0,0,1,1,0,
     +           0,1,1,0,0,1,1,0,
     +           0,1,1,1,1,1,1,0,
     +           0,1,1,1,1,1,1,0,
     +           0,0,0,0,0,0,0,0/
      DATA ID3 / 0,0,0,0,0,0,0,0,
     +           0,0,0,0,1,0,0,0,
     +           0,0,0,1,1,1,0,0,
     +           0,1,0,0,1,0,0,1,
     +           0,0,1,1,1,1,1,0,
     +           0,0,0,0,1,0,0,0,
     +           0,0,0,1,0,1,0,0,
     +           0,1,1,0,0,0,1,1/
      DATA ID4 / 0,0,0,0,0,0,0,0,
     +           0,1,1,0,0,1,1,1,
     +           0,1,1,0,0,1,1,0,
     +           0,1,1,0,1,1,0,0,
     +           0,1,1,1,1,0,0,0,
     +           0,1,1,0,1,1,0,0,
     +           0,1,1,0,0,1,1,0,
     +           0,1,1,0,0,1,1,1/
C
C Open GKS.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Double the size of the GKS dot.
C
      CALL GSMKSC (2.)
C
C This code creates a single frame showing nine circles filled in
C various ways.  The DO-loop variable I says which row of circles
C we're working on (1 => top, 2 => middle, 3 => bottom).  The
C DO-loop variable J says which column of circles we're working
C on (1 => left, 2 => center, 3 => right).  The variable K gives
C the number of the circle currently being drawn and is used in
C a computed GO TO to determine which block of code is executed.
C
      DO 111 I=1,3
        YCN=REAL(4-I)
        DO 110 J=1,3
          XCN=REAL(J)
          K=3*(I-1)+J
          DO 100 L=1,101
            XRA(L)=XCN+.48*SIN(.062831853071796*REAL(L))
            YRA(L)=YCN+.48*COS(.062831853071796*REAL(L))
  100     CONTINUE
C
C Draw the circle.
C
          CALL SET (0.,1.,0.,1.,0.,4.,0.,4.,1)
          CALL CURVE (XRA,YRA,101)
C
C Jump to the proper piece of code to fill the circle.
C
          GO TO (101,102,103,104,105,106,107,108,109) , K
C
C Fill the first circle with horizontal lines.
C
  101     CALL SFWRLD (XRA,YRA,100,DST,102,IND,104)
          GO TO 110
C
C Fill the second circle in the same way, but add a diamond-shaped
C hole.
C
  102     XRA(101)=2.00
          YRA(101)=3.24
          XRA(102)=1.76
          YRA(102)=3.00
          XRA(103)=2.00
          YRA(103)=2.76
          XRA(104)=2.24
          YRA(104)=3.00
          XRA(105)=XRA(101)
          YRA(105)=YRA(101)
          XRA(106)=XRA(100)
          YRA(106)=YRA(100)
          CALL SFWRLD (XRA,YRA,106,DST,110,IND,114)
          GO TO 110
C
C Fill the third circle with lines in two different directions to
C create a cross-hatched effect and create a more complicated hole.
C
  103     XRA(101)=XRA( 40)
          YRA(101)=YRA( 40)
          XRA(102)=XRA( 80)
          YRA(102)=YRA( 80)
          XRA(103)=XRA( 20)
          YRA(103)=YRA( 20)
          XRA(104)=XRA( 60)
          YRA(104)=YRA( 60)
          XRA(105)=XRA(100)
          YRA(105)=YRA(100)
          CALL SFSETR ('SP - SPACING OF FILL LINES',.009)
          CALL SFSETI ('AN - ANGLE OF FILL LINES',45)
          CALL SFWRLD (XRA,YRA,105,DST,111,IND,117)
          CALL SFSETI ('AN - ANGLE OF FILL LINES',135)
          CALL SFNORM (XRA,YRA,105,DST,111,IND,117)
          GO TO 110
C
C Fill the fourth circle with the default dot pattern, increasing the
C inter-dot spacing considerably.
C
  104     CALL SFSETR ('SP - SPACING OF FILL LINES',.005)
          CALL SFSETI ('AN - ANGLE OF FILL LINES',0)
          CALL SFSETI ('DO - DOT-FILL FLAG',1)
          CALL SFWRLD (XRA,YRA,100,DST,102,IND,104)
          GO TO 110
C
C Fill the fifth circle with a combination of lines and dots.
C
  105     CALL SFSETR ('SP - SPACING OF FILL LINES',.012)
          CALL SFSETI ('DO - DOT-FILL FLAG',0)
          CALL SFWRLD (XRA,YRA,100,DST,102,IND,104)
          CALL SFSETR ('SP - SPACING OF FILL LINES',.006)
          CALL SFSETI ('DO - DOT-FILL FLAG',1)
          CALL SFNORM (XRA,YRA,100,DST,102,IND,104)
          GO TO 110
C
C Fill the sixth circle with a specified dot pattern.
C
  106     CALL SFSETR ('SP - SPACING OF FILL LINES',.004)
          CALL SFSETP (ID1)
          CALL SFWRLD (XRA,YRA,100,DST,102,IND,104)
          GO TO 110
C
C Fill the seventh circle with a different dot pattern, tilted at an
C angle.
C
  107     CALL SFSETI ('AN - ANGLE OF FILL LINES',45)
          CALL SFSETP (ID2)
          CALL SFWRLD (XRA,YRA,100,DST,102,IND,104)
          GO TO 110
C
C Fill the eighth circle with a different dot pattern, using characters.
C
  108     CALL GSCHH  (.004)
          CALL SFSETR ('SP - SPACING OF FILL LINES',.006)
          CALL SFSETI ('AN - ANGLE OF FILL LINES',0)
          CALL SFSETC ('CH - CHARACTER SPECIFIER','O')
          CALL SFSETP (ID3)
          CALL SFWRLD (XRA,YRA,100,DST,102,IND,104)
          GO TO 110
C
C Fill the last circle with K's, both large and small.
C
  109     CALL GSCHH  (.008)
          CALL SFSETR ('SP - SPACING OF FILL LINES',.012)
          CALL SFSETC ('CH - CHARACTER SPECIFIER','K')
          CALL SFSETP (ID4)
          CALL SFWRLD (XRA,YRA,100,DST,102,IND,104)
          GO TO 110
C
  110   CONTINUE
C
  111 CONTINUE
C
C Advance the frame.
C
      CALL FRAME
C
C Close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
C Done.
C
      STOP
C
      END

C
C	$Id: gwpart.f,v 1.4 2008-07-27 00:21:08 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GWPART(NBYTES,GKSERR)
C
C  This subroutine loads the next partition of an active instruction.
C
C  OUTPUT
C    GKSERR - The error status flag.
C
C  All data is type INTEGER unless otherwise indicated.
C
      IMPLICIT INTEGER (A-Z)
C
      include 'gwiins.h'
      include 'gwiio.h'
C
      SAVE
C
C  Define the CGM data element partition size.  To make the arithmetic
C  come out right in other parts of the code, this should be a multiple
C  of 256.
C
      DATA PARSIZ/32256/
C
      DATA ALLOK/0/
C
C  Define the short format length, short format count, long format flag,
C  continue flag on, continue flag off, continue length, long format
C  length.
C
      DATA CONON,CONOFF,CFMLNG,LFMLNG
     +    /    1,     0,     1,    15/
C
      GKSERR = ALLOK
C
C  Set the current partition byte count and the remainder byte count.
C
      IF (NBYTES .GT. PARSIZ) THEN
        MCCBYT = PARSIZ
        MCNBYT = NBYTES - PARSIZ
      ELSE
        MCCBYT = NBYTES
        MCNBYT = 0
      END IF
C
C  Set the continue flag.
C
      IF (MCNBYT .NE. 0) THEN
C
C  There is another partition.
C
        CALL GWILOD(CONON,CFMLNG,1,GKSERR)
      ELSE
C
C  Last partition.
C
        CALL GWILOD(CONOFF,CFMLNG,1,GKSERR)
      END IF
C
      IF (GKSERR .NE. ALLOK) RETURN
C
C  Set the long format operand list size.
C
      CALL GWILOD(MCCBYT,LFMLNG,1,GKSERR)
C
      RETURN
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C   FFTPACK 5.0
C   Copyright (C) 1995-2004, Scientific Computing Division,
C   University Corporation for Atmospheric Research
C   Licensed under the GNU General Public License (GPL)
C
C   Authors:  Paul N. Swarztrauber and Richard A. Valent
C
C   $Id: factor.f,v 1.2 2006-11-21 01:10:17 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      SUBROUTINE DFACTOR(N,NF,FAC)
      DOUBLE PRECISION FAC(*)
      INTEGER NTRYH(4)
      DATA NTRYH(1),NTRYH(2),NTRYH(3),NTRYH(4)/4,2,3,5/
C
      NL = N
      NF = 0
      J = 0
  101 J = J + 1
      IF (J-4) 102,102,103
  102 NTRY = NTRYH(J)
      GO TO 104
  103 NTRY = NTRY + 2
  104 NQ = NL/NTRY
      NR = NL - NTRY*NQ
      IF (NR) 101,105,101
  105 NF = NF + 1
      FAC(NF) = NTRY
      NL = NQ
      IF (NL.NE.1) GO TO 104
      RETURN
      END

      SUBROUTINE DTZRZF( M, N, A, LDA, TAU, WORK, LWORK, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      INTEGER            INFO, LDA, LWORK, M, N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), TAU( * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  DTZRZF reduces the M-by-N ( M<=N ) real upper trapezoidal matrix A
*  to upper triangular form by means of orthogonal transformations.
*
*  The upper trapezoidal matrix A is factored as
*
*     A = ( R  0 ) * Z,
*
*  where Z is an N-by-N orthogonal matrix and R is an M-by-M upper
*  triangular matrix.
*
*  Arguments
*  =========
*
*  M       (input) INTEGER
*          The number of rows of the matrix A.  M >= 0.
*
*  N       (input) INTEGER
*          The number of columns of the matrix A.  N >= 0.
*
*  A       (input/output) DOUBLE PRECISION array, dimension (LDA,N)
*          On entry, the leading M-by-N upper trapezoidal part of the
*          array A must contain the matrix to be factorized.
*          On exit, the leading M-by-M upper triangular part of A
*          contains the upper triangular matrix R, and elements M+1 to
*          N of the first M rows of A, with the array TAU, represent the
*          orthogonal matrix Z as a product of M elementary reflectors.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(1,M).
*
*  TAU     (output) DOUBLE PRECISION array, dimension (M)
*          The scalar factors of the elementary reflectors.
*
*  WORK    (workspace/output) DOUBLE PRECISION array, dimension (LWORK)
*          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*
*  LWORK   (input) INTEGER
*          The dimension of the array WORK.  LWORK >= max(1,M).
*          For optimum performance LWORK >= M*NB, where NB is
*          the optimal blocksize.
*
*          If LWORK = -1, then a workspace query is assumed; the routine
*          only calculates the optimal size of the WORK array, returns
*          this value as the first entry of the WORK array, and no error
*          message related to LWORK is issued by XERBLA.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*
*  Further Details
*  ===============
*
*  Based on contributions by
*    A. Petitet, Computer Science Dept., Univ. of Tenn., Knoxville, USA
*
*  The factorization is obtained by Householder's method.  The kth
*  transformation matrix, Z( k ), which is used to introduce zeros into
*  the ( m - k + 1 )th row of A, is given in the form
*
*     Z( k ) = ( I     0   ),
*              ( 0  T( k ) )
*
*  where
*
*     T( k ) = I - tau*u( k )*u( k )',   u( k ) = (   1    ),
*                                                 (   0    )
*                                                 ( z( k ) )
*
*  tau is a scalar and z( k ) is an ( n - m ) element vector.
*  tau and z( k ) are chosen to annihilate the elements of the kth row
*  of X.
*
*  The scalar tau is returned in the kth element of TAU and the vector
*  u( k ) in the kth row of A, such that the elements of z( k ) are
*  in  a( k, m + 1 ), ..., a( k, n ). The elements of R are returned in
*  the upper triangular part of A.
*
*  Z is given by
*
*     Z =  Z( 1 ) * Z( 2 ) * ... * Z( m ).
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO
      PARAMETER          ( ZERO = 0.0D+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            LQUERY
      INTEGER            I, IB, IWS, KI, KK, LDWORK, LWKOPT, M1, MU, NB,
     $                   NBMIN, NX
*     ..
*     .. External Subroutines ..
      EXTERNAL           DLARZB, DLARZT, DLATRZ, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN
*     ..
*     .. External Functions ..
      INTEGER            ILAENV
      EXTERNAL           ILAENV
*     ..
*     .. Executable Statements ..
*
*     Test the input arguments
*
      INFO = 0
      LQUERY = ( LWORK.EQ.-1 )
      IF( M.LT.0 ) THEN
         INFO = -1
      ELSE IF( N.LT.M ) THEN
         INFO = -2
      ELSE IF( LDA.LT.MAX( 1, M ) ) THEN
         INFO = -4
      ELSE IF( LWORK.LT.MAX( 1, M ) .AND. .NOT.LQUERY ) THEN
         INFO = -7
      END IF
*
      IF( INFO.EQ.0 ) THEN
*
*        Determine the block size.
*
         NB = ILAENV( 1, 'DGERQF', ' ', M, N, -1, -1 )
         LWKOPT = M*NB
         WORK( 1 ) = LWKOPT
      END IF
*
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DTZRZF', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( M.EQ.0 ) THEN
         WORK( 1 ) = 1
         RETURN
      ELSE IF( M.EQ.N ) THEN
         DO 10 I = 1, N
            TAU( I ) = ZERO
   10    CONTINUE
         WORK( 1 ) = 1
         RETURN
      END IF
*
      NBMIN = 2
      NX = 1
      IWS = M
      IF( NB.GT.1 .AND. NB.LT.M ) THEN
*
*        Determine when to cross over from blocked to unblocked code.
*
         NX = MAX( 0, ILAENV( 3, 'DGERQF', ' ', M, N, -1, -1 ) )
         IF( NX.LT.M ) THEN
*
*           Determine if workspace is large enough for blocked code.
*
            LDWORK = M
            IWS = LDWORK*NB
            IF( LWORK.LT.IWS ) THEN
*
*              Not enough workspace to use optimal NB:  reduce NB and
*              determine the minimum value of NB.
*
               NB = LWORK / LDWORK
               NBMIN = MAX( 2, ILAENV( 2, 'DGERQF', ' ', M, N, -1,
     $                 -1 ) )
            END IF
         END IF
      END IF
*
      IF( NB.GE.NBMIN .AND. NB.LT.M .AND. NX.LT.M ) THEN
*
*        Use blocked code initially.
*        The last kk rows are handled by the block method.
*
         M1 = MIN( M+1, N )
         KI = ( ( M-NX-1 ) / NB )*NB
         KK = MIN( M, KI+NB )
*
         DO 20 I = M - KK + KI + 1, M - KK + 1, -NB
            IB = MIN( M-I+1, NB )
*
*           Compute the TZ factorization of the current block
*           A(i:i+ib-1,i:n)
*
            CALL DLATRZ( IB, N-I+1, N-M, A( I, I ), LDA, TAU( I ),
     $                   WORK )
            IF( I.GT.1 ) THEN
*
*              Form the triangular factor of the block reflector
*              H = H(i+ib-1) . . . H(i+1) H(i)
*
               CALL DLARZT( 'Backward', 'Rowwise', N-M, IB, A( I, M1 ),
     $                      LDA, TAU( I ), WORK, LDWORK )
*
*              Apply H to A(1:i-1,i:n) from the right
*
               CALL DLARZB( 'Right', 'No transpose', 'Backward',
     $                      'Rowwise', I-1, N-I+1, IB, N-M, A( I, M1 ),
     $                      LDA, WORK, LDWORK, A( 1, I ), LDA,
     $                      WORK( IB+1 ), LDWORK )
            END IF
   20    CONTINUE
         MU = I + NB - 1
      ELSE
         MU = M
      END IF
*
*     Use unblocked code to factor the last or only block
*
      IF( MU.GT.0 )
     $   CALL DLATRZ( MU, N, N-M, A, LDA, TAU, WORK )
*
      WORK( 1 ) = LWKOPT
*
      RETURN
*
*     End of DTZRZF
*
      END

      SUBROUTINE CPPTRF( UPLO, N, AP, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER          UPLO
      INTEGER            INFO, N
*     ..
*     .. Array Arguments ..
      COMPLEX            AP( * )
*     ..
*
*  Purpose
*  =======
*
*  CPPTRF computes the Cholesky factorization of a complex Hermitian
*  positive definite matrix A stored in packed format.
*
*  The factorization has the form
*     A = U**H * U,  if UPLO = 'U', or
*     A = L  * L**H,  if UPLO = 'L',
*  where U is an upper triangular matrix and L is lower triangular.
*
*  Arguments
*  =========
*
*  UPLO    (input) CHARACTER*1
*          = 'U':  Upper triangle of A is stored;
*          = 'L':  Lower triangle of A is stored.
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  AP      (input/output) COMPLEX array, dimension (N*(N+1)/2)
*          On entry, the upper or lower triangle of the Hermitian matrix
*          A, packed columnwise in a linear array.  The j-th column of A
*          is stored in the array AP as follows:
*          if UPLO = 'U', AP(i + (j-1)*j/2) = A(i,j) for 1<=i<=j;
*          if UPLO = 'L', AP(i + (j-1)*(2n-j)/2) = A(i,j) for j<=i<=n.
*          See below for further details.
*
*          On exit, if INFO = 0, the triangular factor U or L from the
*          Cholesky factorization A = U**H*U or A = L*L**H, in the same
*          storage format as A.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*          > 0:  if INFO = i, the leading minor of order i is not
*                positive definite, and the factorization could not be
*                completed.
*
*  Further Details
*  ===============
*
*  The packed storage scheme is illustrated by the following example
*  when N = 4, UPLO = 'U':
*
*  Two-dimensional storage of the Hermitian matrix A:
*
*     a11 a12 a13 a14
*         a22 a23 a24
*             a33 a34     (aij = conjg(aji))
*                 a44
*
*  Packed storage of the upper triangle of A:
*
*  AP = [ a11, a12, a22, a13, a23, a33, a14, a24, a34, a44 ]
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ZERO, ONE
      PARAMETER          ( ZERO = 0.0E+0, ONE = 1.0E+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            UPPER
      INTEGER            J, JC, JJ
      REAL               AJJ
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      COMPLEX            CDOTC
      EXTERNAL           LSAME, CDOTC
*     ..
*     .. External Subroutines ..
      EXTERNAL           CHPR, CSSCAL, CTPSV, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          REAL, SQRT
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      UPPER = LSAME( UPLO, 'U' )
      IF( .NOT.UPPER .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'CPPTRF', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
*
      IF( UPPER ) THEN
*
*        Compute the Cholesky factorization A = U'*U.
*
         JJ = 0
         DO 10 J = 1, N
            JC = JJ + 1
            JJ = JJ + J
*
*           Compute elements 1:J-1 of column J.
*
            IF( J.GT.1 )
     $         CALL CTPSV( 'Upper', 'Conjugate transpose', 'Non-unit',
     $                     J-1, AP, AP( JC ), 1 )
*
*           Compute U(J,J) and test for non-positive-definiteness.
*
            AJJ = REAL( AP( JJ ) ) - CDOTC( J-1, AP( JC ), 1, AP( JC ),
     $            1 )
            IF( AJJ.LE.ZERO ) THEN
               AP( JJ ) = AJJ
               GO TO 30
            END IF
            AP( JJ ) = SQRT( AJJ )
   10    CONTINUE
      ELSE
*
*        Compute the Cholesky factorization A = L*L'.
*
         JJ = 1
         DO 20 J = 1, N
*
*           Compute L(J,J) and test for non-positive-definiteness.
*
            AJJ = REAL( AP( JJ ) )
            IF( AJJ.LE.ZERO ) THEN
               AP( JJ ) = AJJ
               GO TO 30
            END IF
            AJJ = SQRT( AJJ )
            AP( JJ ) = AJJ
*
*           Compute elements J+1:N of column J and update the trailing
*           submatrix.
*
            IF( J.LT.N ) THEN
               CALL CSSCAL( N-J, ONE / AJJ, AP( JJ+1 ), 1 )
               CALL CHPR( 'Lower', N-J, -ONE, AP( JJ+1 ), 1,
     $                    AP( JJ+N-J+1 ) )
               JJ = JJ + N - J + 1
            END IF
   20    CONTINUE
      END IF
      GO TO 40
*
   30 CONTINUE
      INFO = J
*
   40 CONTINUE
      RETURN
*
*     End of CPPTRF
*
      END

C NCLFORTSTART
c c c trend being calculated in C wrapper.
c c c SUBROUTINE kenststncl(xdata,n,s,z,prob,trend)
      SUBROUTINE kenststncl(xdata,n,s,z,prob)
      IMPLICIT none
C                                     ! INPUT
      INTEGER n
      DOUBLE PRECISION    xdata(n)
      DOUBLE PRECISION    eps
C                                     ! OUTPUT
      INTEGER s
c c c DOUBLE PRECISION    z, prob, trend
      DOUBLE PRECISION    z, prob
C NCLEND
      INTEGER nslp                                ! LOCAL ==> INTERFACE
      DOUBLE PRECISION    slope(n*(n-1)/2)        ! MALLOC: Thiel-Sens
      LOGICAL             tieflg(n)               ! MALLOC

      eps    = 1.0d-5                             ! make optional
      nslp   = n*(n-1)/2

c c c      call kenstst(xdata,n,s,z,prob,trend
c c c     +            ,nslp,slope,tieflg,eps,nslp)

      call kenstst(xdata,n,s,z,prob,nslp
     +             ,slope,tieflg,eps,nslp)

      return
      end

c-----------
c c c "trend" was removed from this routine because it is
c c c  being calculated in the NCL C wrapper.
c c c
c c c      SUBROUTINE kenstst(xdata,n,s,z,prob,trend   ! standard
c c c     +                  ,nslp,slope,tieflg,eps,nc)! for NCL interface
c-----------
      SUBROUTINE kenstst(xdata,n,s,z,prob,nslp,slope,tieflg,eps,nc)
      IMPLICIT none
C                                     ! INPUT
      INTEGER n
      DOUBLE PRECISION    xdata(n)
C                                     ! OUTPUT
      INTEGER s, nc
cc    DOUBLE PRECISION    z, prob, trend
      DOUBLE PRECISION    z, prob

      INTEGER nslp                    ! FROM INTERFACE
      DOUBLE PRECISION    slope(nslp) ! MALLOC: Thiel-Sens
      DOUBLE PRECISION    eps
      LOGICAL tieflg(n)
C                                     ! LOCAL
      INTEGER j, k, nt, ntie, ncrit
      DOUBLE PRECISION  diff, dave, var, vartie, zero

      zero = 0.0d0
      ncrit  =  10    ! series must be at least this length

      if (n.lt.ncrit) then
          s    = 0
          z    = zero
          prob = zero
          return
      end if

      eps     = 1d-5  ! closer than this is a tie
      vartie  = zero
      nc      = 0     ! total number of comparisons used (# of non-ties)
      s       = 0     ! S statistic

      DO j=1,nslp
         slope(j) = zero
      END DO

      DO j=1,n
         tieflg(j) = .false.
      END DO

      DO j=1,n-1

         ntie = 1     ! a value is always tied with itself

        DO k=j+1,n
           diff = xdata(k)-xdata(j)

C                     ! close enough for a tie?
           dave = (xdata(j)+xdata(k))/2.0d0  
           IF (diff.ne.0.0d0 .and. dave.ne.0.0d0) THEN
               if (abs(diff/dave) .lt. eps) diff = zero
           END IF

C                     ! counts
           nc = nc+1
           slope(nc) = diff/(k-j)

           IF (diff.gt.zero) THEN
               s = s+1
           ELSE IF (diff.lt.zero) THEN
               s = s-1
           ELSE
               ntie      = ntie + 1 
               tieflg(k) = .true.
           END IF
        END DO

        IF (ntie.ne.1 .and. .not.tieflg(j)) then
            vartie = vartie + ntie*(ntie-1d0)*(2d0*ntie+5d0)/18d0
c c c       write(*,'("ntie=",i4,"  vartie=",f8.1)') ntie, vartie
        END IF
      END DO
                                                   ! adjustment
      nt    = INT((1d0 + sqrt( 1d0 + 8d0*nc ))/2d0)
      var   = nt* (nt-1d0)* (2d0*nt + 5d0)/18d0    ! simple variance no ties
      var   = var - vartie                         ! adjust for ties

      IF (s.gt.zero) then
          z = (s-1d0)/sqrt(var)
      ELSEIF (s.lt.zero) then
          z = (s+1d0)/sqrt(var)
      ELSE
          z = zero
      END IF

      prob = erf(abs(z)/sqrt(2d0))
c
c Theil-Sen Trend Estimate: sort and take median.
c This is commented out so we can use qsort in
c the C wrapper routine instead, for faster sorting.
c c c
c c c      call dsortu(slope,nc)
c c c      IF (mod(nc,2).eq.0) THEN
c c c          trend = 0.5d0*(slope(nc/2)+slope(nc/2+1))
c c c      ELSE
c c c          trend = slope(nc/2+1)
c c c      END IF

c c c      write(*,'(" n=",i3," s=",i5, " nc=",i6, "  nt=",i3
c c c     *         ," var=",f8.1," vartie=",f8.1," trend=",f10.5)') 
c c c     *         n, s, nc, nt, var, vartie, trend
    
      RETURN
      END 

C
C $Id: tdpara.f,v 1.5 2008-07-27 00:17:33 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE TDPARA (ARG1,ARG2,ARG3,ARG4,ARG5,ARG6,ARG7,ARG8,ARG9)
C
C This routine is called to define a 3-D parallelogram in which 2-D
C objects may be drawn for projection to the image plane.  Its
C arguments are simply copied to a labeled common block.  The first
C three arguments are the X, Y, and Z coordinates of that corner of
C the parallelogram with 2-D coordinates (0.,0.).  The next three
C arguments are the X, Y, and Z components of a unit vector in the
C direction of that corner of the parallelogram with 2-D coordinates
C (1.,0.) and the last three arguments are the X, Y, and Z components
C of a unit vector in the direction of that corner of the parallelogram
C with 2-D coordinates (0.,1.).
C
C The variables in the following common block define the parallelogram.
C
        COMMON /TDCOM2/ XACP,YACP,ZACP,XCDX,YCDX,ZCDX,XCDY,YCDY,ZCDY
        SAVE   /TDCOM2/
C
C Do a call forcing a BLOCKDATA to be loaded from a binary library.
C
        CALL TDBLDA
C
C Check for an uncleared prior error.
C
        IF (ICFELL('TDPARA - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C Copy values from the argument list to the common block.
C
        XACP=ARG1
        YACP=ARG2
        ZACP=ARG3
C
        XCDX=ARG4
        YCDX=ARG5
        ZCDX=ARG6
C
        XCDY=ARG7
        YCDY=ARG8
        ZCDY=ARG9
C
C Done.
C
        RETURN
C
      END

      SUBROUTINE STRSEN( JOB, COMPQ, SELECT, N, T, LDT, Q, LDQ, WR, WI,
     $                   M, S, SEP, WORK, LWORK, IWORK, LIWORK, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          COMPQ, JOB
      INTEGER            INFO, LDQ, LDT, LIWORK, LWORK, M, N
      REAL               S, SEP
*     ..
*     .. Array Arguments ..
      LOGICAL            SELECT( * )
      INTEGER            IWORK( * )
      REAL               Q( LDQ, * ), T( LDT, * ), WI( * ), WORK( * ),
     $                   WR( * )
*     ..
*
*  Purpose
*  =======
*
*  STRSEN reorders the real Schur factorization of a real matrix
*  A = Q*T*Q**T, so that a selected cluster of eigenvalues appears in
*  the leading diagonal blocks of the upper quasi-triangular matrix T,
*  and the leading columns of Q form an orthonormal basis of the
*  corresponding right invariant subspace.
*
*  Optionally the routine computes the reciprocal condition numbers of
*  the cluster of eigenvalues and/or the invariant subspace.
*
*  T must be in Schur canonical form (as returned by SHSEQR), that is,
*  block upper triangular with 1-by-1 and 2-by-2 diagonal blocks; each
*  2-by-2 diagonal block has its diagonal elemnts equal and its
*  off-diagonal elements of opposite sign.
*
*  Arguments
*  =========
*
*  JOB     (input) CHARACTER*1
*          Specifies whether condition numbers are required for the
*          cluster of eigenvalues (S) or the invariant subspace (SEP):
*          = 'N': none;
*          = 'E': for eigenvalues only (S);
*          = 'V': for invariant subspace only (SEP);
*          = 'B': for both eigenvalues and invariant subspace (S and
*                 SEP).
*
*  COMPQ   (input) CHARACTER*1
*          = 'V': update the matrix Q of Schur vectors;
*          = 'N': do not update Q.
*
*  SELECT  (input) LOGICAL array, dimension (N)
*          SELECT specifies the eigenvalues in the selected cluster. To
*          select a real eigenvalue w(j), SELECT(j) must be set to
*          .TRUE.. To select a complex conjugate pair of eigenvalues
*          w(j) and w(j+1), corresponding to a 2-by-2 diagonal block,
*          either SELECT(j) or SELECT(j+1) or both must be set to
*          .TRUE.; a complex conjugate pair of eigenvalues must be
*          either both included in the cluster or both excluded.
*
*  N       (input) INTEGER
*          The order of the matrix T. N >= 0.
*
*  T       (input/output) REAL array, dimension (LDT,N)
*          On entry, the upper quasi-triangular matrix T, in Schur
*          canonical form.
*          On exit, T is overwritten by the reordered matrix T, again in
*          Schur canonical form, with the selected eigenvalues in the
*          leading diagonal blocks.
*
*  LDT     (input) INTEGER
*          The leading dimension of the array T. LDT >= max(1,N).
*
*  Q       (input/output) REAL array, dimension (LDQ,N)
*          On entry, if COMPQ = 'V', the matrix Q of Schur vectors.
*          On exit, if COMPQ = 'V', Q has been postmultiplied by the
*          orthogonal transformation matrix which reorders T; the
*          leading M columns of Q form an orthonormal basis for the
*          specified invariant subspace.
*          If COMPQ = 'N', Q is not referenced.
*
*  LDQ     (input) INTEGER
*          The leading dimension of the array Q.
*          LDQ >= 1; and if COMPQ = 'V', LDQ >= N.
*
*  WR      (output) REAL array, dimension (N)
*  WI      (output) REAL array, dimension (N)
*          The real and imaginary parts, respectively, of the reordered
*          eigenvalues of T. The eigenvalues are stored in the same
*          order as on the diagonal of T, with WR(i) = T(i,i) and, if
*          T(i:i+1,i:i+1) is a 2-by-2 diagonal block, WI(i) > 0 and
*          WI(i+1) = -WI(i). Note that if a complex eigenvalue is
*          sufficiently ill-conditioned, then its value may differ
*          significantly from its value before reordering.
*
*  M       (output) INTEGER
*          The dimension of the specified invariant subspace.
*          0 < = M <= N.
*
*  S       (output) REAL
*          If JOB = 'E' or 'B', S is a lower bound on the reciprocal
*          condition number for the selected cluster of eigenvalues.
*          S cannot underestimate the true reciprocal condition number
*          by more than a factor of sqrt(N). If M = 0 or N, S = 1.
*          If JOB = 'N' or 'V', S is not referenced.
*
*  SEP     (output) REAL
*          If JOB = 'V' or 'B', SEP is the estimated reciprocal
*          condition number of the specified invariant subspace. If
*          M = 0 or N, SEP = norm(T).
*          If JOB = 'N' or 'E', SEP is not referenced.
*
*  WORK    (workspace/output) REAL array, dimension (LWORK)
*          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*
*  LWORK   (input) INTEGER
*          The dimension of the array WORK.
*          If JOB = 'N', LWORK >= max(1,N);
*          if JOB = 'E', LWORK >= M*(N-M);
*          if JOB = 'V' or 'B', LWORK >= 2*M*(N-M).
*
*          If LWORK = -1, then a workspace query is assumed; the routine
*          only calculates the optimal size of the WORK array, returns
*          this value as the first entry of the WORK array, and no error
*          message related to LWORK is issued by XERBLA.
*
*  IWORK   (workspace) INTEGER array, dimension (LIWORK)
*          IF JOB = 'N' or 'E', IWORK is not referenced.
*
*  LIWORK  (input) INTEGER
*          The dimension of the array IWORK.
*          If JOB = 'N' or 'E', LIWORK >= 1;
*          if JOB = 'V' or 'B', LIWORK >= M*(N-M).
*
*          If LIWORK = -1, then a workspace query is assumed; the
*          routine only calculates the optimal size of the IWORK array,
*          returns this value as the first entry of the IWORK array, and
*          no error message related to LIWORK is issued by XERBLA.
*
*  INFO    (output) INTEGER
*          = 0: successful exit
*          < 0: if INFO = -i, the i-th argument had an illegal value
*          = 1: reordering of T failed because some eigenvalues are too
*               close to separate (the problem is very ill-conditioned);
*               T may have been partially reordered, and WR and WI
*               contain the eigenvalues in the same order as in T; S and
*               SEP (if requested) are set to zero.
*
*  Further Details
*  ===============
*
*  STRSEN first collects the selected eigenvalues by computing an
*  orthogonal transformation Z to move them to the top left corner of T.
*  In other words, the selected eigenvalues are the eigenvalues of T11
*  in:
*
*                Z'*T*Z = ( T11 T12 ) n1
*                         (  0  T22 ) n2
*                            n1  n2
*
*  where N = n1+n2 and Z' means the transpose of Z. The first n1 columns
*  of Z span the specified invariant subspace of T.
*
*  If T has been obtained from the real Schur factorization of a matrix
*  A = Q*T*Q', then the reordered real Schur factorization of A is given
*  by A = (Q*Z)*(Z'*T*Z)*(Q*Z)', and the first n1 columns of Q*Z span
*  the corresponding invariant subspace of A.
*
*  The reciprocal condition number of the average of the eigenvalues of
*  T11 may be returned in S. S lies between 0 (very badly conditioned)
*  and 1 (very well conditioned). It is computed as follows. First we
*  compute R so that
*
*                         P = ( I  R ) n1
*                             ( 0  0 ) n2
*                               n1 n2
*
*  is the projector on the invariant subspace associated with T11.
*  R is the solution of the Sylvester equation:
*
*                        T11*R - R*T22 = T12.
*
*  Let F-norm(M) denote the Frobenius-norm of M and 2-norm(M) denote
*  the two-norm of M. Then S is computed as the lower bound
*
*                      (1 + F-norm(R)**2)**(-1/2)
*
*  on the reciprocal of 2-norm(P), the true reciprocal condition number.
*  S cannot underestimate 1 / 2-norm(P) by more than a factor of
*  sqrt(N).
*
*  An approximate error bound for the computed average of the
*  eigenvalues of T11 is
*
*                         EPS * norm(T) / S
*
*  where EPS is the machine precision.
*
*  The reciprocal condition number of the right invariant subspace
*  spanned by the first n1 columns of Z (or of Q*Z) is returned in SEP.
*  SEP is defined as the separation of T11 and T22:
*
*                     sep( T11, T22 ) = sigma-min( C )
*
*  where sigma-min(C) is the smallest singular value of the
*  n1*n2-by-n1*n2 matrix
*
*     C  = kprod( I(n2), T11 ) - kprod( transpose(T22), I(n1) )
*
*  I(m) is an m by m identity matrix, and kprod denotes the Kronecker
*  product. We estimate sigma-min(C) by the reciprocal of an estimate of
*  the 1-norm of inverse(C). The true reciprocal 1-norm of inverse(C)
*  cannot differ from sigma-min(C) by more than a factor of sqrt(n1*n2).
*
*  When SEP is small, small changes in T can cause large changes in
*  the invariant subspace. An approximate bound on the maximum angular
*  error in the computed right invariant subspace is
*
*                      EPS * norm(T) / SEP
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ZERO, ONE
      PARAMETER          ( ZERO = 0.0E+0, ONE = 1.0E+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            LQUERY, PAIR, SWAP, WANTBH, WANTQ, WANTS,
     $                    WANTSP
      INTEGER            IERR, K, KASE, KK, KS, LIWMIN, LWMIN, N1, N2,
     $                   NN
      REAL               EST, RNORM, SCALE
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      REAL               SLANGE
      EXTERNAL           LSAME, SLANGE
*     ..
*     .. External Subroutines ..
      EXTERNAL           SLACON, SLACPY, STREXC, STRSYL, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, MAX, SQRT
*     ..
*     .. Executable Statements ..
*
*     Decode and test the input parameters
*
      WANTBH = LSAME( JOB, 'B' )
      WANTS = LSAME( JOB, 'E' ) .OR. WANTBH
      WANTSP = LSAME( JOB, 'V' ) .OR. WANTBH
      WANTQ = LSAME( COMPQ, 'V' )
*
      INFO = 0
      LQUERY = ( LWORK.EQ.-1 )
      IF( .NOT.LSAME( JOB, 'N' ) .AND. .NOT.WANTS .AND. .NOT.WANTSP )
     $     THEN
         INFO = -1
      ELSE IF( .NOT.LSAME( COMPQ, 'N' ) .AND. .NOT.WANTQ ) THEN
         INFO = -2
      ELSE IF( N.LT.0 ) THEN
         INFO = -4
      ELSE IF( LDT.LT.MAX( 1, N ) ) THEN
         INFO = -6
      ELSE IF( LDQ.LT.1 .OR. ( WANTQ .AND. LDQ.LT.N ) ) THEN
         INFO = -8
      ELSE
*
*        Set M to the dimension of the specified invariant subspace,
*        and test LWORK and LIWORK.
*
         M = 0
         PAIR = .FALSE.
         DO 10 K = 1, N
            IF( PAIR ) THEN
               PAIR = .FALSE.
            ELSE
               IF( K.LT.N ) THEN
                  IF( T( K+1, K ).EQ.ZERO ) THEN
                     IF( SELECT( K ) )
     $                  M = M + 1
                  ELSE
                     PAIR = .TRUE.
                     IF( SELECT( K ) .OR. SELECT( K+1 ) )
     $                  M = M + 2
                  END IF
               ELSE
                  IF( SELECT( N ) )
     $               M = M + 1
               END IF
            END IF
   10    CONTINUE
*
         N1 = M
         N2 = N - M
         NN = N1*N2
*
         IF(  WANTSP ) THEN
            LWMIN = MAX( 1, 2*NN )
            LIWMIN = MAX( 1, NN )
         ELSE IF( LSAME( JOB, 'N' ) ) THEN
            LWMIN = MAX( 1, N )
            LIWMIN = 1
         ELSE IF( LSAME( JOB, 'E' ) ) THEN
            LWMIN = MAX( 1, NN )
            LIWMIN = 1
         END IF
*
         IF( LWORK.LT.LWMIN .AND. .NOT.LQUERY ) THEN
            INFO = -15
         ELSE IF( LIWORK.LT.LIWMIN .AND. .NOT.LQUERY ) THEN
            INFO = -17
         END IF
      END IF
*
      IF( INFO.EQ.0 ) THEN
         WORK( 1 ) = LWMIN
         IWORK( 1 ) = LIWMIN
      END IF
*
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'STRSEN', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         RETURN
      END IF
*
*     Quick return if possible.
*
      IF( M.EQ.N .OR. M.EQ.0 ) THEN
         IF( WANTS )
     $      S = ONE
         IF( WANTSP )
     $      SEP = SLANGE( '1', N, N, T, LDT, WORK )
         GO TO 40
      END IF
*
*     Collect the selected blocks at the top-left corner of T.
*
      KS = 0
      PAIR = .FALSE.
      DO 20 K = 1, N
         IF( PAIR ) THEN
            PAIR = .FALSE.
         ELSE
            SWAP = SELECT( K )
            IF( K.LT.N ) THEN
               IF( T( K+1, K ).NE.ZERO ) THEN
                  PAIR = .TRUE.
                  SWAP = SWAP .OR. SELECT( K+1 )
               END IF
            END IF
            IF( SWAP ) THEN
               KS = KS + 1
*
*              Swap the K-th block to position KS.
*
               IERR = 0
               KK = K
               IF( K.NE.KS )
     $            CALL STREXC( COMPQ, N, T, LDT, Q, LDQ, KK, KS, WORK,
     $                         IERR )
               IF( IERR.EQ.1 .OR. IERR.EQ.2 ) THEN
*
*                 Blocks too close to swap: exit.
*
                  INFO = 1
                  IF( WANTS )
     $               S = ZERO
                  IF( WANTSP )
     $               SEP = ZERO
                  GO TO 40
               END IF
               IF( PAIR )
     $            KS = KS + 1
            END IF
         END IF
   20 CONTINUE
*
      IF( WANTS ) THEN
*
*        Solve Sylvester equation for R:
*
*           T11*R - R*T22 = scale*T12
*
         CALL SLACPY( 'F', N1, N2, T( 1, N1+1 ), LDT, WORK, N1 )
         CALL STRSYL( 'N', 'N', -1, N1, N2, T, LDT, T( N1+1, N1+1 ),
     $                LDT, WORK, N1, SCALE, IERR )
*
*        Estimate the reciprocal of the condition number of the cluster
*        of eigenvalues.
*
         RNORM = SLANGE( 'F', N1, N2, WORK, N1, WORK )
         IF( RNORM.EQ.ZERO ) THEN
            S = ONE
         ELSE
            S = SCALE / ( SQRT( SCALE*SCALE / RNORM+RNORM )*
     $          SQRT( RNORM ) )
         END IF
      END IF
*
      IF( WANTSP ) THEN
*
*        Estimate sep(T11,T22).
*
         EST = ZERO
         KASE = 0
   30    CONTINUE
         CALL SLACON( NN, WORK( NN+1 ), WORK, IWORK, EST, KASE )
         IF( KASE.NE.0 ) THEN
            IF( KASE.EQ.1 ) THEN
*
*              Solve  T11*R - R*T22 = scale*X.
*
               CALL STRSYL( 'N', 'N', -1, N1, N2, T, LDT,
     $                      T( N1+1, N1+1 ), LDT, WORK, N1, SCALE,
     $                      IERR )
            ELSE
*
*              Solve  T11'*R - R*T22' = scale*X.
*
               CALL STRSYL( 'T', 'T', -1, N1, N2, T, LDT,
     $                      T( N1+1, N1+1 ), LDT, WORK, N1, SCALE,
     $                      IERR )
            END IF
            GO TO 30
         END IF
*
         SEP = SCALE / EST
      END IF
*
   40 CONTINUE
*
*     Store the output eigenvalues in WR and WI.
*
      DO 50 K = 1, N
         WR( K ) = T( K, K )
         WI( K ) = ZERO
   50 CONTINUE
      DO 60 K = 1, N - 1
         IF( T( K+1, K ).NE.ZERO ) THEN
            WI( K ) = SQRT( ABS( T( K, K+1 ) ) )*
     $                SQRT( ABS( T( K+1, K ) ) )
            WI( K+1 ) = -WI( K )
         END IF
   60 CONTINUE
*
      WORK( 1 ) = LWMIN
      IWORK( 1 ) = LIWMIN
*
      RETURN
*
*     End of STRSEN
*
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C   FFTPACK 5.0
C   Copyright (C) 1995-2004, Scientific Computing Division,
C   University Corporation for Atmospheric Research
C   Licensed under the GNU General Public License (GPL)
C
C   Authors:  Paul N. Swarztrauber and Richard A. Valent
C
C   $Id: cfft1f.f,v 1.2 2006-11-21 01:10:16 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      SUBROUTINE DCFFT1F(N,INC,C,LENC,WSAVE,LENSAV,WORK,LENWRK,IER)
      INTEGER N,INC,LENC,LENSAV,LENWRK,IER
      DOUBLE COMPLEX C(LENC)
      DOUBLE PRECISION WSAVE(LENSAV),WORK(LENWRK)
C
      IER = 0
C
      IF (LENC.LT.INC* (N-1)+1) THEN
          IER = 1
          CALL DXERFFT('CFFT1F ',6)
      ELSE IF (LENSAV.LT.2*N+INT(LOG(DBLE(N)))+4) THEN
          IER = 2
          CALL DXERFFT('CFFT1F ',8)
      ELSE IF (LENWRK.LT.2*N) THEN
          IER = 3
          CALL DXERFFT('CFFTMF ',10)
      END IF
C
      IF (N.EQ.1) RETURN
C
      IW1 = N + N + 1
      CALL DC1FM1F(N,INC,C,WORK,WSAVE,WSAVE(IW1),WSAVE(IW1+1))
      RETURN
      END

C
C	$Id: gqeci.f,v 1.5 2008-07-27 00:20:59 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GQECI(WKID,N,ERRIND,OL,COLIND)
C
C  INQUIRE LIST element OF COLOUR INDICES
C
      include 'gkscom.h'
C
      INTEGER WKID,N,ERRIND,OL,COLIND
C
C  Check if GKS is in the proper state.
C
      CALL GZCKST(7,-1,ERRIND)
      IF (ERRIND .NE. 0) GOTO 100
C
C  Check if the workstation ID is valid.
C
      CALL GZCKWK(20,-1,WKID,IDUM,ERRIND)
      IF (ERRIND .NE. 0) GO TO 100
C
C  Check if the specified workstation is open.
C
      CALL GZCKWK(25,-1,WKID,IDUM,ERRIND)
      IF (ERRIND .NE. 0) GO TO 100
C
C  Check if the list element is non-negative.
C
      IF (N.LT.0) THEN
       ERRIND = 2002
       GOTO 100
      ENDIF
C
C  Check for invalid workstation categories.
C
      CALL GQWKC(WKID,ERRIND,ICONID,ITYPE)
      IF (ERRIND .NE. 0) GO TO 100
      CALL GQWKCA(ITYPE,ERRIND,ICAT)
      IF (ERRIND .NE. 0) GO TO 100
      IF (ICAT .EQ. GMI) THEN
        ERRIND = 33
        GO TO 100
      ELSE IF (ICAT .EQ. GINPUT) THEN
        ERRIND = 35
        GO TO 100
      ELSE IF (ICAT .EQ. GWISS) THEN
        ERRIND = 36
        GO TO 100
      ENDIF
C
C  Invoke the workstation interface routine.
C
      FCODE = -257
      CONT  = 0
      CALL GZROI(0)
      IL1   = 2
      IL2   = 2
      ID(1) = WKID
      ID(2) = N
      CALL GZIQWK(ITYPE,WKID)
      IF (RERR.NE.0) THEN
        ERRIND = RERR
        GOTO 100
      ENDIF
      OL     = ID(3)
      COLIND = ID(4)
      RETURN
C
  100 CONTINUE
      OL     = -1
      COLIND = -1
      RETURN
      END

      SUBROUTINE DLAPLL( N, X, INCX, Y, INCY, SSMIN )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     March 31, 1993
*
*     .. Scalar Arguments ..
      INTEGER            INCX, INCY, N
      DOUBLE PRECISION   SSMIN
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   X( * ), Y( * )
*     ..
*
*  Purpose
*  =======
*
*  Given two column vectors X and Y, let
*
*                       A = ( X Y ).
*
*  The subroutine first computes the QR factorization of A = Q*R,
*  and then computes the SVD of the 2-by-2 upper triangular matrix R.
*  The smaller singular value of R is returned in SSMIN, which is used
*  as the measurement of the linear dependency of the vectors X and Y.
*
*  Arguments
*  =========
*
*  N       (input) INTEGER
*          The length of the vectors X and Y.
*
*  X       (input/output) DOUBLE PRECISION array,
*                         dimension (1+(N-1)*INCX)
*          On entry, X contains the N-vector X.
*          On exit, X is overwritten.
*
*  INCX    (input) INTEGER
*          The increment between successive elements of X. INCX > 0.
*
*  Y       (input/output) DOUBLE PRECISION array,
*                         dimension (1+(N-1)*INCY)
*          On entry, Y contains the N-vector Y.
*          On exit, Y is overwritten.
*
*  INCY    (input) INTEGER
*          The increment between successive elements of Y. INCY > 0.
*
*  SSMIN   (output) DOUBLE PRECISION
*          The smallest singular value of the N-by-2 matrix A = ( X Y ).
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO, ONE
      PARAMETER          ( ZERO = 0.0D+0, ONE = 1.0D+0 )
*     ..
*     .. Local Scalars ..
      DOUBLE PRECISION   A11, A12, A22, C, SSMAX, TAU
*     ..
*     .. External Functions ..
      DOUBLE PRECISION   DDOT
      EXTERNAL           DDOT
*     ..
*     .. External Subroutines ..
      EXTERNAL           DAXPY, DLARFG, DLAS2
*     ..
*     .. Executable Statements ..
*
*     Quick return if possible
*
      IF( N.LE.1 ) THEN
         SSMIN = ZERO
         RETURN
      END IF
*
*     Compute the QR factorization of the N-by-2 matrix ( X Y )
*
      CALL DLARFG( N, X( 1 ), X( 1+INCX ), INCX, TAU )
      A11 = X( 1 )
      X( 1 ) = ONE
*
      C = -TAU*DDOT( N, X, INCX, Y, INCY )
      CALL DAXPY( N, C, X, INCX, Y, INCY )
*
      CALL DLARFG( N-1, Y( 1+INCY ), Y( 1+2*INCY ), INCY, TAU )
*
      A12 = Y( 1 )
      A22 = Y( 1+INCY )
*
*     Compute the SVD of 2-by-2 Upper triangular matrix.
*
      CALL DLAS2( A11, A12, A22, SSMIN, SSMAX )
*
      RETURN
*
*     End of DLAPLL
*
      END

      SUBROUTINE CLARTV( N, X, INCX, Y, INCY, C, S, INCC )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     February 29, 1992
*
*     .. Scalar Arguments ..
      INTEGER            INCC, INCX, INCY, N
*     ..
*     .. Array Arguments ..
      REAL               C( * )
      COMPLEX            S( * ), X( * ), Y( * )
*     ..
*
*  Purpose
*  =======
*
*  CLARTV applies a vector of complex plane rotations with real cosines
*  to elements of the complex vectors x and y. For i = 1,2,...,n
*
*     ( x(i) ) := (        c(i)   s(i) ) ( x(i) )
*     ( y(i) )    ( -conjg(s(i))  c(i) ) ( y(i) )
*
*  Arguments
*  =========
*
*  N       (input) INTEGER
*          The number of plane rotations to be applied.
*
*  X       (input/output) COMPLEX array, dimension (1+(N-1)*INCX)
*          The vector x.
*
*  INCX    (input) INTEGER
*          The increment between elements of X. INCX > 0.
*
*  Y       (input/output) COMPLEX array, dimension (1+(N-1)*INCY)
*          The vector y.
*
*  INCY    (input) INTEGER
*          The increment between elements of Y. INCY > 0.
*
*  C       (input) REAL array, dimension (1+(N-1)*INCC)
*          The cosines of the plane rotations.
*
*  S       (input) COMPLEX array, dimension (1+(N-1)*INCC)
*          The sines of the plane rotations.
*
*  INCC    (input) INTEGER
*          The increment between elements of C and S. INCC > 0.
*
*  =====================================================================
*
*     .. Local Scalars ..
      INTEGER            I, IC, IX, IY
      COMPLEX            XI, YI
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          CONJG
*     ..
*     .. Executable Statements ..
*
      IX = 1
      IY = 1
      IC = 1
      DO 10 I = 1, N
         XI = X( IX )
         YI = Y( IY )
         X( IX ) = C( IC )*XI + S( IC )*YI
         Y( IY ) = C( IC )*YI - CONJG( S( IC ) )*XI
         IX = IX + INCX
         IY = IY + INCY
         IC = IC + INCC
   10 CONTINUE
      RETURN
*
*     End of CLARTV
*
      END

      SUBROUTINE SLARRV( N, D, L, ISPLIT, M, W, IBLOCK, GERSCH, TOL, Z,
     $                   LDZ, ISUPPZ, WORK, IWORK, INFO )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      INTEGER            INFO, LDZ, M, N
      REAL               TOL
*     ..
*     .. Array Arguments ..
      INTEGER            IBLOCK( * ), ISPLIT( * ), ISUPPZ( * ),
     $                   IWORK( * )
      REAL               D( * ), GERSCH( * ), L( * ), W( * ), WORK( * ),
     $                   Z( LDZ, * )
*     ..
*
*  Purpose
*  =======
*
*  SLARRV computes the eigenvectors of the tridiagonal matrix
*  T = L D L^T given L, D and the eigenvalues of L D L^T.
*  The input eigenvalues should have high relative accuracy with
*  respect to the entries of L and D. The desired accuracy of the
*  output can be specified by the input parameter TOL.
*
*  Arguments
*  =========
*
*  N       (input) INTEGER
*          The order of the matrix.  N >= 0.
*
*  D       (input/output) REAL array, dimension (N)
*          On entry, the n diagonal elements of the diagonal matrix D.
*          On exit, D may be overwritten.
*
*  L       (input/output) REAL array, dimension (N-1)
*          On entry, the (n-1) subdiagonal elements of the unit
*          bidiagonal matrix L in elements 1 to N-1 of L. L(N) need
*          not be set. On exit, L is overwritten.
*
*  ISPLIT  (input) INTEGER array, dimension (N)
*          The splitting points, at which T breaks up into submatrices.
*          The first submatrix consists of rows/columns 1 to
*          ISPLIT( 1 ), the second of rows/columns ISPLIT( 1 )+1
*          through ISPLIT( 2 ), etc.
*
*  TOL     (input) REAL
*          The absolute error tolerance for the
*          eigenvalues/eigenvectors.
*          Errors in the input eigenvalues must be bounded by TOL.
*          The eigenvectors output have residual norms
*          bounded by TOL, and the dot products between different
*          eigenvectors are bounded by TOL. TOL must be at least
*          N*EPS*|T|, where EPS is the machine precision and |T| is
*          the 1-norm of the tridiagonal matrix.
*
*  M       (input) INTEGER
*          The total number of eigenvalues found.  0 <= M <= N.
*          If RANGE = 'A', M = N, and if RANGE = 'I', M = IU-IL+1.
*
*  W       (input) REAL array, dimension (N)
*          The first M elements of W contain the eigenvalues for
*          which eigenvectors are to be computed.  The eigenvalues
*          should be grouped by split-off block and ordered from
*          smallest to largest within the block ( The output array
*          W from SLARRE is expected here ).
*          Errors in W must be bounded by TOL (see above).
*
*  IBLOCK  (input) INTEGER array, dimension (N)
*          The submatrix indices associated with the corresponding
*          eigenvalues in W; IBLOCK(i)=1 if eigenvalue W(i) belongs to
*          the first submatrix from the top, =2 if W(i) belongs to
*          the second submatrix, etc. 
*
*  Z       (output) REAL array, dimension (LDZ, max(1,M) )
*          If JOBZ = 'V', then if INFO = 0, the first M columns of Z
*          contain the orthonormal eigenvectors of the matrix T
*          corresponding to the selected eigenvalues, with the i-th
*          column of Z holding the eigenvector associated with W(i).
*          If JOBZ = 'N', then Z is not referenced.
*          Note: the user must ensure that at least max(1,M) columns are
*          supplied in the array Z; if RANGE = 'V', the exact value of M
*          is not known in advance and an upper bound must be used.
*
*  LDZ     (input) INTEGER
*          The leading dimension of the array Z.  LDZ >= 1, and if
*          JOBZ = 'V', LDZ >= max(1,N).
*
*  ISUPPZ  (output) INTEGER ARRAY, dimension ( 2*max(1,M) )
*          The support of the eigenvectors in Z, i.e., the indices
*          indicating the nonzero elements in Z. The i-th eigenvector
*          is nonzero only in elements ISUPPZ( 2*i-1 ) through
*          ISUPPZ( 2*i ).
*
*  WORK    (workspace) REAL array, dimension (13*N)
*
*  IWORK   (workspace) INTEGER array, dimension (6*N)
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*          > 0:  if INFO = 1, internal error in SLARRB
*                if INFO = 2, internal error in SSTEIN
*
*  Further Details
*  ===============
*
*  Based on contributions by
*     Inderjit Dhillon, IBM Almaden, USA
*     Osni Marques, LBNL/NERSC, USA
*
*  =====================================================================
*
*     .. Parameters ..
      INTEGER            MGSSIZ
      PARAMETER          ( MGSSIZ = 20 )
      REAL               ZERO, ONE, FOUR
      PARAMETER          ( ZERO = 0.0E0, ONE = 1.0E0, FOUR = 4.0E0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            MGSCLS
      INTEGER            I, IBEGIN, IEND, IINDC1, IINDC2, IINDR, IINDWK, 
     $                   IINFO, IM, IN, INDERR, INDGAP, INDLD, INDLLD, 
     $                   INDWRK, ITER, ITMP1, ITMP2, J, JBLK, K, KTOT, 
     $                   LSBDPT, MAXITR, NCLUS, NDEPTH, NDONE, NEWCLS, 
     $                   NEWFRS, NEWFTT, NEWLST, NEWSIZ, NSPLIT, OLDCLS, 
     $                   OLDFST, OLDIEN, OLDLST, OLDNCL, P, Q, 
     $                   TEMP( 1 )
      REAL               EPS, GAP, LAMBDA, MGSTOL, MINGMA, MINRGP, 
     $                   NRMINV, RELGAP, RELTOL, RESID, RQCORR, SIGMA, 
     $                   TMP1, ZTZ
*     ..
*     .. External Functions ..
      REAL               SDOT, SLAMCH, SNRM2
      EXTERNAL           SDOT, SLAMCH, SNRM2
*     ..
*     .. External Subroutines ..
      EXTERNAL           SAXPY, SCOPY, SLAR1V, SLARRB, SLARRF, SLASET, 
     $                   SSCAL, SSTEIN
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, MAX, MIN, REAL, SQRT
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INDERR = N + 1
      INDLD = 2*N
      INDLLD = 3*N
      INDGAP = 4*N
      INDWRK = 5*N + 1
*
      IINDR = N
      IINDC1 = 2*N
      IINDC2 = 3*N
      IINDWK = 4*N + 1
*
      EPS = SLAMCH( 'Precision' )
*
      DO 10 I = 1, 2*N
         IWORK( I ) = 0
   10 CONTINUE
      DO 20 I = 1, M
         WORK( INDERR+I-1 ) = EPS*ABS( W( I ) )
   20 CONTINUE
      CALL SLASET( 'Full', N, N, ZERO, ZERO, Z, LDZ )
      MGSTOL = 5.0E0*EPS
*
      NSPLIT = IBLOCK( M )
      IBEGIN = 1
      DO 170 JBLK = 1, NSPLIT
         IEND = ISPLIT( JBLK )
*
*        Find the eigenvectors of the submatrix indexed IBEGIN
*        through IEND.
*
         IF( IBEGIN.EQ.IEND ) THEN
            Z( IBEGIN, IBEGIN ) = ONE
            ISUPPZ( 2*IBEGIN-1 ) = IBEGIN
            ISUPPZ( 2*IBEGIN ) = IBEGIN
            IBEGIN = IEND + 1
            GO TO 170
         END IF
         OLDIEN = IBEGIN - 1
         IN = IEND - OLDIEN
         RELTOL = MIN( 1.0E-2, ONE / REAL( IN ) )
         IM = IN
         CALL SCOPY( IM, W( IBEGIN ), 1, WORK, 1 )
         DO 30 I = 1, IN - 1
            WORK( INDGAP+I ) = WORK( I+1 ) - WORK( I )
   30    CONTINUE
         WORK( INDGAP+IN ) = MAX( ABS( WORK( IN ) ), EPS )
         NDONE = 0
*
         NDEPTH = 0
         LSBDPT = 1
         NCLUS = 1
         IWORK( IINDC1+1 ) = 1
         IWORK( IINDC1+2 ) = IN
*
*        While( NDONE.LT.IM ) do
*
   40    CONTINUE
         IF( NDONE.LT.IM ) THEN
            OLDNCL = NCLUS
            NCLUS = 0
            LSBDPT = 1 - LSBDPT
            DO 150 I = 1, OLDNCL
               IF( LSBDPT.EQ.0 ) THEN
                  OLDCLS = IINDC1
                  NEWCLS = IINDC2
               ELSE
                  OLDCLS = IINDC2
                  NEWCLS = IINDC1
               END IF
*
*              If NDEPTH > 1, retrieve the relatively robust
*              representation (RRR) and perform limited bisection
*              (if necessary) to get approximate eigenvalues.
*
               J = OLDCLS + 2*I
               OLDFST = IWORK( J-1 )
               OLDLST = IWORK( J )
               IF( NDEPTH.GT.0 ) THEN
                  J = OLDIEN + OLDFST
                  CALL SCOPY( IN, Z( IBEGIN, J ), 1, D( IBEGIN ), 1 )
                  CALL SCOPY( IN, Z( IBEGIN, J+1 ), 1, L( IBEGIN ), 1 )
                  SIGMA = L( IEND )
               END IF
               K = IBEGIN
               DO 50 J = 1, IN - 1
                  WORK( INDLD+J ) = D( K )*L( K )
                  WORK( INDLLD+J ) = WORK( INDLD+J )*L( K )
                  K = K + 1
   50          CONTINUE
               IF( NDEPTH.GT.0 ) THEN
                  CALL SLARRB( IN, D( IBEGIN ), L( IBEGIN ),
     $                         WORK( INDLD+1 ), WORK( INDLLD+1 ),
     $                         OLDFST, OLDLST, SIGMA, RELTOL, WORK,
     $                         WORK( INDGAP+1 ), WORK( INDERR ),
     $                         WORK( INDWRK ), IWORK( IINDWK ), IINFO )
                  IF( IINFO.NE.0 ) THEN
                     INFO = 1
                     RETURN
                  END IF
               END IF
*
*              Classify eigenvalues of the current representation (RRR)
*              as (i) isolated, (ii) loosely clustered or (iii) tightly
*              clustered
*
               NEWFRS = OLDFST
               DO 140 J = OLDFST, OLDLST
                  IF( J.EQ.OLDLST .OR. WORK( INDGAP+J ).GE.RELTOL*
     $                ABS( WORK( J ) ) ) THEN
                     NEWLST = J
                  ELSE
*
*                    continue (to the next loop)
*
                     RELGAP = WORK( INDGAP+J ) / ABS( WORK( J ) )
                     IF( J.EQ.NEWFRS ) THEN
                        MINRGP = RELGAP
                     ELSE
                        MINRGP = MIN( MINRGP, RELGAP )
                     END IF
                     GO TO 140
                  END IF
                  NEWSIZ = NEWLST - NEWFRS + 1
                  MAXITR = 10
                  NEWFTT = OLDIEN + NEWFRS
                  IF( NEWSIZ.GT.1 ) THEN
                     MGSCLS = NEWSIZ.LE.MGSSIZ .AND. MINRGP.GE.MGSTOL
                     IF( .NOT.MGSCLS ) THEN
                        CALL SLARRF( IN, D( IBEGIN ), L( IBEGIN ),
     $                               WORK( INDLD+1 ), WORK( INDLLD+1 ),
     $                               NEWFRS, NEWLST, WORK,
     $                               Z( IBEGIN, NEWFTT ),
     $                               Z( IBEGIN, NEWFTT+1 ),
     $                               WORK( INDWRK ), IWORK( IINDWK ),
     $                               INFO )
                        IF( INFO.EQ.0 ) THEN
                           NCLUS = NCLUS + 1
                           K = NEWCLS + 2*NCLUS
                           IWORK( K-1 ) = NEWFRS
                           IWORK( K ) = NEWLST
                        ELSE
                           INFO = 0
                           IF( MINRGP.GE.MGSTOL ) THEN
                              MGSCLS = .TRUE.
                           ELSE
*                           
*                             Call SSTEIN to process this tight cluster.
*                             This happens only if MINRGP <= MGSTOL
*                             and SLARRF returns INFO = 1. The latter
*                             means that a new RRR to "break" the
*                             cluster could not be found.
*
                              WORK( INDWRK ) = D( IBEGIN )
                              DO 60 K = 1, IN - 1
                                 WORK( INDWRK+K ) = D( IBEGIN+K ) +
     $                                              WORK( INDLLD+K )
   60                         CONTINUE
                              DO 70 K = 1, NEWSIZ
                                 IWORK( IINDWK+K-1 ) = 1
   70                         CONTINUE
                              DO 80 K = NEWFRS, NEWLST
                                 ISUPPZ( 2*( IBEGIN+K )-3 ) = 1
                                 ISUPPZ( 2*( IBEGIN+K )-2 ) = IN
   80                         CONTINUE
                              TEMP( 1 ) = IN
                              CALL SSTEIN( IN, WORK( INDWRK ),
     $                                     WORK( INDLD+1 ), NEWSIZ,
     $                                     WORK( NEWFRS ),
     $                                     IWORK( IINDWK ), TEMP( 1 ),
     $                                     Z( IBEGIN, NEWFTT ), LDZ,
     $                                     WORK( INDWRK+IN ),
     $                                     IWORK( IINDWK+IN ),
     $                                     IWORK( IINDWK+2*IN ), IINFO )
                              IF( IINFO.NE.0 ) THEN
                                 INFO = 2
                                 RETURN
                              END IF
                              NDONE = NDONE + NEWSIZ
                           END IF
                        END IF
                     END IF
                  ELSE
                     MGSCLS = .FALSE.
                  END IF
                  IF( NEWSIZ.EQ.1 .OR. MGSCLS ) THEN
                     KTOT = NEWFTT
                     DO 100 K = NEWFRS, NEWLST
                        ITER = 0
   90                   CONTINUE
                        LAMBDA = WORK( K )
                        CALL SLAR1V( IN, 1, IN, LAMBDA, D( IBEGIN ),
     $                               L( IBEGIN ), WORK( INDLD+1 ),
     $                               WORK( INDLLD+1 ),
     $                               GERSCH( 2*OLDIEN+1 ),
     $                               Z( IBEGIN, KTOT ), ZTZ, MINGMA,
     $                               IWORK( IINDR+KTOT ),
     $                               ISUPPZ( 2*KTOT-1 ),
     $                               WORK( INDWRK ) )
                        TMP1 = ONE / ZTZ
                        NRMINV = SQRT( TMP1 )
                        RESID = ABS( MINGMA )*NRMINV
                        RQCORR = MINGMA*TMP1
                        IF( K.EQ.IN ) THEN
                           GAP = WORK( INDGAP+K-1 )
                        ELSE IF( K.EQ.1 ) THEN
                           GAP = WORK( INDGAP+K )
                        ELSE
                           GAP = MIN( WORK( INDGAP+K-1 ),
     $                           WORK( INDGAP+K ) )
                        END IF
                        ITER = ITER + 1
                        IF( RESID.GT.TOL*GAP .AND. ABS( RQCORR ).GT.
     $                      FOUR*EPS*ABS( LAMBDA ) ) THEN
                           WORK( K ) = LAMBDA + RQCORR
                           IF( ITER.LT.MAXITR ) THEN
                              GO TO 90
                           END IF
                        END IF
                        IWORK( KTOT ) = 1
                        IF( NEWSIZ.EQ.1 )
     $                     NDONE = NDONE + 1
                        CALL SSCAL( IN, NRMINV, Z( IBEGIN, KTOT ), 1 )
                        KTOT = KTOT + 1
  100                CONTINUE
                     IF( NEWSIZ.GT.1 ) THEN
                        ITMP1 = ISUPPZ( 2*NEWFTT-1 )
                        ITMP2 = ISUPPZ( 2*NEWFTT )
                        KTOT = OLDIEN + NEWLST
                        DO 120 P = NEWFTT + 1, KTOT
                           DO 110 Q = NEWFTT, P - 1
                              TMP1 = -SDOT( IN, Z( IBEGIN, P ), 1,
     $                               Z( IBEGIN, Q ), 1 )
                              CALL SAXPY( IN, TMP1, Z( IBEGIN, Q ), 1,
     $                                    Z( IBEGIN, P ), 1 )
  110                      CONTINUE
                           TMP1 = ONE / SNRM2( IN, Z( IBEGIN, P ), 1 )
                           CALL SSCAL( IN, TMP1, Z( IBEGIN, P ), 1 )
                           ITMP1 = MIN( ITMP1, ISUPPZ( 2*P-1 ) )
                           ITMP2 = MAX( ITMP2, ISUPPZ( 2*P ) )
  120                   CONTINUE
                        DO 130 P = NEWFTT, KTOT
                           ISUPPZ( 2*P-1 ) = ITMP1
                           ISUPPZ( 2*P ) = ITMP2
  130                   CONTINUE
                        NDONE = NDONE + NEWSIZ
                     END IF
                  END IF
                  NEWFRS = J + 1
  140          CONTINUE
  150       CONTINUE
            NDEPTH = NDEPTH + 1
            GO TO 40
         END IF
         J = 2*IBEGIN
         DO 160 I = IBEGIN, IEND
            ISUPPZ( J-1 ) = ISUPPZ( J-1 ) + OLDIEN
            ISUPPZ( J ) = ISUPPZ( J ) + OLDIEN
            J = J + 2
  160    CONTINUE
         IBEGIN = IEND + 1
  170 CONTINUE
*
      RETURN
*
*     End of SLARRV
*
      END

C NCLFORTSTART
      SUBROUTINE DDTRNDX(X,NPTS,IOPT,XMEAN,XVARI,XVARO,C,IER)
      IMPLICIT NONE
      INTEGER NPTS, IOPT, IER
      DOUBLE PRECISION X(NPTS),C(3)
      DOUBLE PRECISION XMEAN
      DOUBLE PRECISION XVARI
      DOUBLE PRECISION XVARO
C NCLEND

      INTEGER I, N
      DOUBLE PRECISION XCNTR
      DOUBLE PRECISION FN
      DOUBLE PRECISION SUMX
      DOUBLE PRECISION SUMY
      DOUBLE PRECISION SUMX2
      DOUBLE PRECISION SUMX3
      DOUBLE PRECISION SUMX4
      DOUBLE PRECISION SUMXY
      DOUBLE PRECISION SUMX2Y
      DOUBLE PRECISION XS
      DOUBLE PRECISION D
      DOUBLE PRECISION XBAR

C DETREND THE SERIES X

C NOMENCLATURE :

C .   INPUT

C .   X         - SERIES TO BE DETRENDED
C .   NPTS      - LENGTH OF X
C .   IOPT      - DETRENDING OPTION
C .               IOPT < 0 : CALCULATE THE MEAN AND VARIANCE OF X THEN
C .                          RETURN
C .               IOPT = 0 : REMOVE THE MEAN ONLY
C .               IOPT = 1 : REMOVE THE MEAN AND USE LINEAR LST SQRS TO
C .                          DETREND
C .               IOPT = 2 : REMOVE THE MEAN AND USE QUADRATIC 
C .                          LST SQRS TO DETRD
C .
C .   OUTPUT
C .
C .   XMEAN     - MEAN OF THE ORIGINAL INPUT  SERIES (OUTPUT)
C .   XVARI     - VARIANCE OF THE ORIGINAL INPUT SERIES (OUTPUT)
C .   XVARO     - VARIANCE OF THE DETRENDED SERIES (OUTPUT)
C .               NOTE : XVARI = XVARO WHEN IOPT @ 0
C .   C         - COEFFICIENTS OF THE LEAST SQUARES POLYNOMIAL (OUTPUT)
C .               MUST BE DIMENSIONED (3) IN THE CALLING PROGRAM
C .               C(1)  CONSTANT
C .               C(2)  COEF OF FIRST POWER [SLOPE IF IOPT=1]
C .               C(3)  COEF OF SECOND POWER
C .   IER       - ERROR CODE


      C(1) = 0.D0
      C(2) = 0.D0
      C(3) = 0.D0

      IER = 0
      IF (NPTS.LT.2) IER = -21
      IF (IER.NE.0) RETURN

      N  = NPTS
      FN = DBLE(N)

C CALCULATE THE MEAN AND VARIANCE OF THE INPUT SERIES

      XMEAN = 0.0D0
      XVARI = 0.0D0
      DO I = 1,N
         XMEAN = XMEAN + X(I)
         XVARI = XVARI + X(I)*X(I)
      END DO
      XVARI = (XVARI-XMEAN*XMEAN/FN)/FN
      XMEAN = XMEAN/FN
      XVARO = XVARI

      IF (IOPT.LT.0) RETURN

C MUST AT LEAST WANT THE SERIES MEAN REMOVED (IOPT=0)

      DO I = 1,N
          X(I) = X(I) - XMEAN
      END DO

      IF (IOPT.EQ.1) THEN

C MUST ALSO WANT LEAST SQUARES TREND LINE REMOVED

          C(2) = 0.D0
          XCNTR = DBLE(N+1)*0.5D0
          DO I = 1,N
             C(2) = C(2) + X(I)* (DBLE(I)-XCNTR)
          END DO

C orig    C(2) = C(2)*12.D0/DBLE(N* (N*N-1))
          C(2) = (C(2)/FN)*(12.D0/(FN*FN-1.D0))

C Y-INTERCEPT
          C(1) = XMEAN - C(2)*XCNTR

          DO I = 1,N
             X(I) = X(I) - C(2)* (DBLE(I)-XCNTR)
          END DO

      ELSE IF (IOPT.EQ.2) THEN

C MUST WANT QUADRATIC DETRENDING

          SUMX = 0.D0
          SUMY = 0.D0
          SUMX2 = 0.D0
          SUMX3 = 0.D0
          SUMX4 = 0.D0
          SUMXY = 0.D0
          SUMX2Y = 0.D0
          DO 50 I = 1,N
              XS = DBLE(I)
              SUMX = SUMX + XS
              SUMY = SUMY + X(I)
              SUMX2 = SUMX2 + XS**2
              SUMX3 = SUMX3 + XS**3
              SUMX4 = SUMX4 + XS**4
              SUMXY = SUMXY + XS*X(I)
              SUMX2Y = SUMX2Y + XS**2*X(I)
   50     CONTINUE
          D = FN* (SUMX2*SUMX4-SUMX3**2) +
     +        SUMX* (SUMX3*SUMX2-SUMX*SUMX4) +
     +        SUMX2* (SUMX*SUMX3-SUMX2**2)
          C(1) = (SUMX2*SUMX4-SUMX3**2)*SUMY +
     +           (SUMX3*SUMX2-SUMX*SUMX4)*SUMXY +
     +           (SUMX*SUMX3-SUMX2**2)*SUMX2Y
          C(2) = (SUMX3*SUMX2-SUMX*SUMX4)*SUMY +
     +           (FN*SUMX4-SUMX2**2)*SUMXY +
     +           (SUMX*SUMX2-FN*SUMX3)*SUMX2Y
          C(3) = (SUMX*SUMX3-SUMX2**2)*SUMY +
     +           (SUMX*SUMX2-FN*SUMX3)*SUMXY + (FN*SUMX2-SUMX**2)*SUMX2Y
          C(1) = C(1)/D
          C(2) = C(2)/D
          C(3) = C(3)/D
          DO 60 I = 1,N
   60     X(I) = X(I) - (C(1)+C(2)*DBLE(I)+C(3)*DBLE(I)**2)

      END IF

C CALCULATE THE VARIANCE OF THE DETRENDED SERIES
C .   XBAR SHOULD BE ZERO TO MACHINE ACCURACY SUBTRACT IT OUT ANYWAY

      XBAR  = 0.0D0
      XVARO = 0.0D0
      DO I = 1,N
         XBAR = XBAR + X(I)
         XVARO = XVARO + X(I)*X(I)
      END DO
      XVARO = (XVARO-XBAR*XBAR/FN)/FN

      XBAR = XBAR/FN
      DO I = 1,N
         X(I) = X(I) - XBAR
      END DO

      RETURN
      END
c -------------------------------------------------------------
C NCLFORTSTART
      SUBROUTINE DDTRNDMSG(X,Y,NPTS,XMSG,YMSG,IOPT
     *                    ,YDT,SLOPE,YINT,IER)
      IMPLICIT NONE
      INTEGER NPTS,IOPT,IER
      DOUBLE PRECISION X(NPTS),Y(NPTS),SLOPE,YINT,YDT(NPTS)
      DOUBLE PRECISION XMSG,YMSG
C NCLEND

c NCL:   yNew = dtrend_msg (x[*]:numeric, y:numeric
c                          ,remove_mean:logical, return_info:logical)

c this routine will calculate the least squares "slope" and y-intercept
c .   remove the trend.
c .   (a) missing data are allowed.
c .   (b) data need not be equally spaced in "x"

c .   yLine = slope*y + yint
c .   ydt   = y - yLine

c arguments :
c .   x,y      - input vectors
c .   npts     - length of vectors x and y
c .   x/ymsg   - missing code: if no msg values set to some number
c .                            which will not be encountered.
c .              ymsg will be used to fill missing values
c .   iopt     - =1: (True)  Return YDT with the mean removed        
c .              =0: (Flase) do not remove the mean
c .   ydt      - detrended series
c .              this could be "y" if original series not needed
c .   slope    - slope (trend ... regression coef)
c .   yint     - y-intercept of the INPUT series
c .   ier      - if (ier.ne.0) an error has occurred

c                                      local
      INTEGER N
      DOUBLE PRECISION XDT(1:NPTS)
      DOUBLE PRECISION XYN,XSUM,YSUM,X2SUM,Y2SUM,XYSUM
      DOUBLE PRECISION XBAR,YBAR,XVAR,YVAR,XYVAR
      DOUBLE PRECISION XAVE,YAVE,XTOT,YTOT,YDTINT

      IER = 0
      SLOPE = YMSG
      YINT = YMSG

      IF (NPTS.LT.2) IER = 1
      IF (IER.NE.0) RETURN
c                               copy original series
      DO N = 1,NPTS
         XDT(N) = X(N)
         YDT(N) = Y(N)
      END DO
c                               loop to calculate sums
      XYN  = 0.0D0
      XSUM = 0.0D0
      YSUM = 0.0D0
      DO N = 1,NPTS
         IF (XDT(N).NE.XMSG .AND. YDT(N).NE.YMSG) THEN
             YSUM = YSUM + YDT(N)
             XSUM = XSUM + XDT(N)
             XYN  = XYN  + 1.D0
         END IF
      END DO
c                               all msg values or only one good point
c                                                    (not enough data)
      IF (XYN.LT.2.D0) THEN
          IER = 5
          RETURN
      END IF
c                               calculate mean of X and Y
      XBAR = XSUM/XYN
      YBAR = YSUM/XYN
C      print *,"                            "
C      print *," -------------------------- "
C      print *,"XBAR=",XBAR,"  YBAR=",YBAR 
c                               remove the X and Y means 
c                               This shifts the data: minimize
c                               roundoff for big X and/or Y numbers
      DO N = 1,NPTS
         IF (X(N).NE.XMSG .AND. Y(N).NE.YMSG) THEN
             XDT(N) = X(N) - XBAR
             YDT(N) = Y(N) - YBAR
C             print *,"N=",N,"  XDT(N)="+XDT(N),"  YDT(N)="+YDT(N)
C     *                     ,"  Y(N)="+Y(N)
         END IF
      END DO
c                               stats for shifted series 
      XTOT  = 0.0D0
      YTOT  = 0.0D0
      X2SUM = 0.0D0
      Y2SUM = 0.0D0
      XYSUM = 0.0D0
      DO N=1,NPTS
         IF (X(N).NE.XMSG .AND. Y(N).NE.YMSG) THEN
             XTOT  = XTOT  + XDT(N)
             YTOT  = YTOT  + YDT(N)
             X2SUM = X2SUM + XDT(N)*XDT(N)
             Y2SUM = Y2SUM + YDT(N)*YDT(N)
             XYSUM = XYSUM + XDT(N)*YDT(N)
         END IF
      END DO
c                               XAVE/YAVE should be 0.0
      XAVE  = XTOT/XYN
      YAVE  = YTOT/XYN
      XVAR  = X2SUM - XTOT*XTOT/XYN
      YVAR  = Y2SUM - YTOT*YTOT/XYN
      XYVAR = XYSUM - XTOT*YTOT/XYN
 
c                               slope and y-intercept: shifted series
      SLOPE = XYVAR/XVAR
      YDTINT= YAVE - SLOPE*XAVE
C      print *,"SLOPE=",SLOPE,"  YDTINT=",YDTINT, "  XAVE=",XAVE 
C     *                      ,"  YAVE=",YAVE 

c                               detrend the (mean removed) series
      DO N = 1,NPTS
          IF (X(N).NE.XMSG .AND. Y(N).NE.YMSG) THEN
              YDT(N) = YDT(N) - (SLOPE*XDT(N)+YDTINT)
          ELSE
              YDT(N) = YMSG
          END IF
      END DO
 
c                               return mean ?
      YINT = YBAR - SLOPE*XBAR
      IF (IOPT.EQ.0) THEN
          DO N = 1,NPTS
             IF (YDT(N).NE.YMSG) THEN
                 YDT(N) = YDT(N) + YBAR
             END IF
          END DO
      END IF

      RETURN
      END

# 1 "ompgen.F90"
# 1 "<built-in>"
# 1 "<command-line>"
# 1 "ompgen.F90"
MODULE omp_constants

    USE omp_lib

    INTEGER, PARAMETER :: fomp_sched_kind = 4
    INTEGER, PARAMETER :: fomp_lock_kind = 8
    INTEGER, PARAMETER :: fomp_nest_lock_kind = 8
    INTEGER(KIND=4), PARAMETER :: fomp_sched_static = 1
    INTEGER(KIND=4), PARAMETER :: fomp_sched_dynamic = 2
    INTEGER(KIND=4), PARAMETER :: fomp_sched_guided = 3
    INTEGER(KIND=4), PARAMETER :: fomp_sched_auto = 4

# 22 "ompgen.F90"

END MODULE omp_constants


FUNCTION fomp_enabled()

    IMPLICIT NONE

    !f2py threadsafe

    LOGICAL :: fomp_enabled


    fomp_enabled = .TRUE.




END FUNCTION fomp_enabled


SUBROUTINE fomp_set_num_threads(num_threads)

    USE omp_lib


    IMPLICIT NONE

    !f2py threadsafe

    INTEGER, INTENT(IN) :: num_threads


    CALL omp_set_num_threads(num_threads)





END SUBROUTINE fomp_set_num_threads


FUNCTION fomp_get_num_threads()

    USE omp_lib


    IMPLICIT NONE

    !f2py threadsafe

    INTEGER :: fomp_get_num_threads


    fomp_get_num_threads = omp_get_num_threads()




END FUNCTION fomp_get_num_threads


FUNCTION fomp_get_max_threads()

    USE omp_lib


    IMPLICIT NONE

    !f2py threadsafe

    INTEGER :: fomp_get_max_threads


    fomp_get_max_threads = omp_get_max_threads()




END FUNCTION fomp_get_max_threads


FUNCTION fomp_get_thread_num()

    USE omp_lib


    IMPLICIT NONE

    !f2py threadsafe

    INTEGER :: fomp_get_thread_num


    fomp_get_thread_num = omp_get_thread_num()




END FUNCTION fomp_get_thread_num


FUNCTION fomp_get_num_procs()

    USE omp_lib


    IMPLICIT NONE

    !f2py threadsafe

    INTEGER :: fomp_get_num_procs


    fomp_get_num_procs = omp_get_num_procs()




END FUNCTION fomp_get_num_procs


FUNCTION fomp_in_parallel()

    USE omp_lib


    IMPLICIT NONE

    !f2py threadsafe

    LOGICAL :: fomp_in_parallel


    fomp_in_parallel = omp_in_parallel()




END FUNCTION fomp_in_parallel


SUBROUTINE fomp_set_dynamic(dynamic_threads)

    USE omp_lib


    IMPLICIT NONE

    !f2py threadsafe

    LOGICAL, INTENT(IN) :: dynamic_threads


    CALL omp_set_dynamic(dynamic_threads)




END SUBROUTINE fomp_set_dynamic


FUNCTION fomp_get_dynamic()

    USE omp_lib


    IMPLICIT NONE

    !f2py threadsafe

    LOGICAL :: fomp_get_dynamic


    fomp_get_dynamic = omp_get_dynamic()




END FUNCTION fomp_get_dynamic


SUBROUTINE fomp_set_nested(nested)

    USE omp_lib


    IMPLICIT NONE

    !f2py threadsafe

    LOGICAL, INTENT(IN) :: nested


    CALL omp_set_nested(nested)




END SUBROUTINE fomp_set_nested


FUNCTION fomp_get_nested()

    USE omp_lib


    IMPLICIT NONE

    !f2py threadsafe

    LOGICAL :: fomp_get_nested


    fomp_get_nested = omp_get_nested()




END FUNCTION fomp_get_nested


SUBROUTINE fomp_set_schedule(kind, modifier)

    USE omp_lib

    USE omp_constants, ONLY : fomp_sched_kind

    IMPLICIT NONE

    !f2py threadsafe

    INTEGER(KIND=fomp_sched_kind), INTENT(IN) :: kind
    INTEGER, INTENT(IN) :: modifier


    CALL omp_set_schedule(kind, modifier)




END SUBROUTINE fomp_set_schedule


SUBROUTINE fomp_get_schedule(kind, modifier)

    USE omp_lib

    USE omp_constants, ONLY : fomp_sched_kind

    IMPLICIT NONE

    !f2py threadsafe

    INTEGER(KIND=fomp_sched_kind), INTENT(OUT) :: kind
    INTEGER, INTENT(OUT) :: modifier


    CALL omp_get_schedule(kind, modifier)





END SUBROUTINE fomp_get_schedule


FUNCTION fomp_get_thread_limit()

    USE omp_lib


    IMPLICIT NONE

    !f2py threadsafe

    INTEGER :: fomp_get_thread_limit


    fomp_get_thread_limit = omp_get_thread_limit()




END FUNCTION fomp_get_thread_limit


SUBROUTINE fomp_set_max_active_levels(max_levels)

    USE omp_lib


    IMPLICIT NONE

    !f2py threadsafe

    INTEGER, INTENT(IN) :: max_levels


    CALL omp_set_max_active_levels(max_levels)




END SUBROUTINE fomp_set_max_active_levels


FUNCTION fomp_get_max_active_levels()

    USE omp_lib


    IMPLICIT NONE

    !f2py threadsafe

    INTEGER :: fomp_get_max_active_levels


    fomp_get_max_active_levels = omp_get_max_active_levels()




END FUNCTION fomp_get_max_active_levels


FUNCTION fomp_get_level()

    USE omp_lib


    IMPLICIT NONE

    !f2py threadsafe

    INTEGER :: fomp_get_level


    fomp_get_level = omp_get_level()




END FUNCTION fomp_get_level


FUNCTION fomp_get_ancestor_thread_num(level)

    USE omp_lib


    IMPLICIT NONE

    !f2py threadsafe

    INTEGER, INTENT(IN) :: level
    INTEGER :: fomp_get_ancestor_thread_num


    fomp_get_ancestor_thread_num = omp_get_ancestor_thread_num(level)





END FUNCTION fomp_get_ancestor_thread_num


FUNCTION fomp_get_team_size(level)

    USE omp_lib


    IMPLICIT NONE

    !f2py threadsafe

    INTEGER, INTENT(IN) :: level
    INTEGER :: fomp_get_team_size


    fomp_get_team_size = omp_get_team_size(level)





END FUNCTION fomp_get_team_size


FUNCTION fomp_get_active_level()

    USE omp_lib


    IMPLICIT NONE

    !f2py threadsafe

    INTEGER :: fomp_get_active_level


    fomp_get_active_level = omp_get_active_level()




END FUNCTION fomp_get_active_level


FUNCTION fomp_in_final()

    USE omp_lib


    IMPLICIT NONE

    !f2py threadsafe

    LOGICAL :: fomp_in_final


    fomp_in_final = omp_in_final()




END FUNCTION fomp_in_final


SUBROUTINE fomp_init_lock(svar)

    USE omp_lib

    USE omp_constants, ONLY : fomp_lock_kind

    IMPLICIT NONE

    !f2py threadsafe

    INTEGER(KIND=fomp_lock_kind), INTENT(OUT) :: svar


    CALL omp_init_lock(svar)




END SUBROUTINE fomp_init_lock


SUBROUTINE fomp_init_nest_lock(nvar)

    USE omp_lib

    USE omp_constants, ONLY : fomp_nest_lock_kind

    IMPLICIT NONE

    !f2py threadsafe

    INTEGER(KIND=fomp_nest_lock_kind), INTENT(OUT) :: nvar


    CALL omp_init_nest_lock(nvar)




END SUBROUTINE fomp_init_nest_lock


SUBROUTINE fomp_destroy_lock(svar)

    USE omp_lib

    USE omp_constants, ONLY : fomp_lock_kind

    IMPLICIT NONE

    !f2py threadsafe

    INTEGER(KIND=fomp_lock_kind), INTENT(INOUT) :: svar


    CALL omp_destroy_lock(svar)





END SUBROUTINE fomp_destroy_lock


SUBROUTINE fomp_destroy_nest_lock(nvar)

    USE omp_lib

    USE omp_constants, ONLY : fomp_nest_lock_kind

    IMPLICIT NONE

    !f2py threadsafe

    INTEGER(KIND=fomp_nest_lock_kind), INTENT(INOUT) :: nvar


    CALL omp_destroy_nest_lock(nvar)




END SUBROUTINE fomp_destroy_nest_lock


SUBROUTINE fomp_set_lock(svar)

    USE omp_lib

    USE omp_constants, ONLY : fomp_lock_kind

    IMPLICIT NONE

    !f2py threadsafe

    INTEGER(KIND=fomp_lock_kind), INTENT(INOUT) :: svar


    CALL omp_set_lock(svar)




END SUBROUTINE fomp_set_lock


SUBROUTINE fomp_set_nest_lock(nvar)

    USE omp_lib

    USE omp_constants, ONLY : fomp_nest_lock_kind

    IMPLICIT NONE

    !f2py threadsafe

    INTEGER(KIND=fomp_nest_lock_kind), INTENT(INOUT) :: nvar


    CALL omp_set_nest_lock(nvar)




END SUBROUTINE fomp_set_nest_lock


SUBROUTINE fomp_unset_lock(svar)

    USE omp_lib

    USE omp_constants, ONLY : fomp_lock_kind

    IMPLICIT NONE

    !f2py threadsafe

    INTEGER(KIND=fomp_lock_kind), INTENT(INOUT) :: svar


    CALL omp_unset_lock(svar)




END SUBROUTINE fomp_unset_lock


SUBROUTINE fomp_unset_nest_lock(nvar)

    USE omp_lib

    USE omp_constants, ONLY : fomp_nest_lock_kind

    IMPLICIT NONE

    !f2py threadsafe

    INTEGER(KIND=fomp_nest_lock_kind), INTENT(INOUT) :: nvar


    CALL omp_unset_nest_lock(nvar)




END SUBROUTINE fomp_unset_nest_lock


FUNCTION fomp_test_lock(svar)

    USE omp_lib

    USE omp_constants, ONLY : fomp_lock_kind

    IMPLICIT NONE

    !f2py threadsafe

    INTEGER(KIND=fomp_lock_kind), INTENT(INOUT) :: svar
    LOGICAL :: fomp_test_lock


    fomp_test_lock =  omp_test_lock(svar)







END FUNCTION fomp_test_lock


FUNCTION fomp_test_nest_lock(nvar)

    USE omp_lib

    USE omp_constants, ONLY : fomp_nest_lock_kind

    IMPLICIT NONE

    !f2py threadsafe

    INTEGER(KIND=fomp_nest_lock_kind), INTENT(INOUT) :: nvar
    INTEGER :: fomp_test_nest_lock


    fomp_test_nest_lock =  omp_test_nest_lock(nvar)







END FUNCTION fomp_test_nest_lock


FUNCTION fomp_get_wtime()

    USE omp_lib


    IMPLICIT NONE

    !f2py threadsafe

    REAL (KIND=8) :: fomp_get_wtime


    fomp_get_wtime =  omp_get_wtime()






END FUNCTION fomp_get_wtime


FUNCTION fomp_get_wtick()

    USE omp_lib


    IMPLICIT NONE

    !f2py threadsafe

    REAL (KIND=8) :: fomp_get_wtick


    fomp_get_wtick =  omp_get_wtick()






END FUNCTION fomp_get_wtick

C
C $Id: mapio.f,v 1.24 2008-09-18 00:42:16 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MAPIO (IACT)
        INTEGER IACT
        CALL MDPIO (IACT)
        RETURN
      END

C
C	$Id: ggtitm.f,v 1.5 2008-07-27 00:20:57 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GGTITM (WKID,TYPE,LDR)
C
C  GET ITEM TYPE FROM GKSM
C
      INTEGER EGTITM
      PARAMETER (EGTITM=102)
C
      include 'gkscom.h'
C
      INTEGER WKID,TYPE,LDR
C
C  Check if GKS is in the proper state.
C
      CALL GZCKST(7,EGTITM,IER)
      IF (IER .NE. 0) RETURN
C
C  Check if the workstation ID is valid.
C
      CALL GZCKWK(20,EGTITM,WKID,IDUM,IER)
      IF (IER .NE. 0) RETURN
C
C  Check if the workstation is currently open.
C
      CALL GZCKWK(25,EGTITM,WKID,IDUM,IER)
      IF (IER .NE. 0) RETURN
C
C  Set function code and put out WKID.
C
C  Set the flag CUFLAG to indicate that the interface call should go
C  only to the specifically designated workstation.
C
      CUFLAG = WKID
      FCODE = 102
      CONT  = 0
      CALL GZROI(0)
      IL1 = 1
      IL2 = 1
      ID(1) = WKID
      CALL GZTOWK
      IF (RERR.NE.0) THEN
        ERS = 1
        CALL GERHND(RERR,EGTITM,ERF)
        ERS = 0
        RETURN
      ELSE
C
C  Read returned data.
C
        TYPE = ID(2)
        LDR  = ID(3)
      ENDIF
      CUFLAG = -1
C
      RETURN
      END

C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE SPLCW (NDIM,XDATA,L1XDAT,YDATA,WDATA,NDATA,XMIN,XMAX,
     1                  NODES,XTRAP,COEF,NCF,WORK,NWRK,IERROR)
      DIMENSION       XDATA(L1XDAT,NDATA)    ,YDATA(NDATA)           ,
     1                WDATA(NDATA)           ,XMIN(NDIM) ,XMAX(NDIM) ,
     2                NODES(NDIM),COEF(NCF)  ,WORK(NWRK)
      DIMENSION       X(4)       ,NDERIV(4)  ,IN(4)      ,INMX(4)
      COMMON /SPLCOM/ MDIM       ,DX(4)      ,DXIN(4)    ,IB(4)      ,
     1                IBMN(4)    ,IBMX(4)
      SAVE
C
C  The restriction that NDIM be less than are equat to 4 can be 
C  eliminated by increasing the above dimensions, but the required 
C  length of WORK becomes quite large.
C
C  SPCRIT is used to determine data sparseness as follows -
C  the weights assigned to all data points are totaled into the
C  variable TOTLWT. (If no weights are entered, it is set to
C  NDATA.)  Each node of the node network is assigned a
C  rectangle (in which it is contained) and the weights of all
C  data points which fall in that rectangle are totaled.  If that
C  total is less than SPCRIT*EXPECT (EXPECT is defined below),
C  then the node is ascertained to be in a data sparse location.
C  EXPECT is that fraction of TOTLWT that would be expected by
C  comparing the area of the rectangle with the total area under
C  consideration.
C
      DATA SPCRIT/.75/
C
      IERROR = 0
      MDIM = NDIM
      IF (MDIM.LT.1 .OR. MDIM.GT.4) GO TO 127
      NCOL = 1
      DO 101 IDIM=1,MDIM
         NOD = NODES(IDIM)
         IF (NOD .LT. 4) GO TO 128
C
C  Number of columns in least squares matrix = number of coefficients =
C  product of nodes over all dimensions.
C
         NCOL = NCOL*NOD
         XRNG = XMAX(IDIM)-XMIN(IDIM)
         IF (XRNG .EQ. 0.) GO TO 129
C
C  DX(IDIM) is the node spacing along the IDIM coordinate.
C
         DX(IDIM) = XRNG/FLOAT(NOD-1)
         DXIN(IDIM) = 1./DX(IDIM)
         NDERIV(IDIM) = 0
  101 CONTINUE
      IF (NCOL .GT. NCF) GO TO 130
      NWRK1 = 1
      MDATA = NDATA
      IF (MDATA .LT. 1) GO TO 131
C
C  SWGHT is a local variable = XTRAP, and can be considered a smoothing
C  weight for data sparse areas.  If SWGHT .EQ. 0, no smoothing
C  computations are performed.
C
      SWGHT = XTRAP
C
C  Set aside workspace for counting data points.
C
      IF (SWGHT .NE. 0.) NWRK1 = NCOL+1
C
C  NWLFT is the length of the remaining workspace.
C
      NWLFT = NWRK-NWRK1+1
      IF (NWLFT .LT. 1) GO TO 132
      IROW = 0
C
C  ROWWT is used to weight rows of the least squares matrix.
C
      ROWWT = 1.
C
C  Loop through all data points, computing a row for each.
C
      DO 108 IDATA=1,MDATA
C
C  WDATA(1).LT.0 means weights have not been entered.  In that case,
C  ROWWT is left equal to  1. for all points.  Otherwise ROWWT is
C  equal to WDATA(IDATA).
C
C  Every element of the row, as well as the corresponding right hand
C  side, is multiplied by ROWWT.
C
         IF (WDATA(1) .LT. 0.) GO TO 102
         ROWWT = WDATA(IDATA)
C
C  Data points with 0 weight are ignored.
C
         IF (ROWWT .EQ. 0.) GO TO 108
  102    IROW = IROW+1
C
C  One row of the least squares matrix corresponds to each data 
C  point.  The right hand for that row will correspond to the 
C  function value YDATA at that point.
C
         RHS = ROWWT*YDATA(IDATA)
         DO 103 IDIM=1,MDIM
            X(IDIM) = XDATA(IDIM,IDATA)
  103    CONTINUE
C
C  The COEF array serves as a row of least squares matrix.  
C  Its value is zero except for columns corresponding to functions 
C  which are nonzero at X.
C
         DO 104 ICOL=1,NCOL
            COEF(ICOL) = 0.
  104    CONTINUE
C
C  Compute the indices of basis functions which are nonzero at X.
C  IBMN is in the range 0 to nodes-2 and IBMX is in range 1 
C  to NODES-1.
C
         DO 105 IDIM=1,MDIM
            NOD = NODES(IDIM)
            IT = DXIN(IDIM)*(X(IDIM)-XMIN(IDIM))
            IBMN(IDIM) = MIN0(MAX0(IT-1,0),NOD-2)
            IB(IDIM) = IBMN(IDIM)
            IBMX(IDIM) = MAX0(MIN0(IT+2,NOD-1),1)
  105    CONTINUE
C
C  Begining of basis index loop - traverse all indices corresponding
C  to basis functions which are nonzero at X.  The indices are in 
C  IB and are passed through common to BASCMP.
C
  106    CALL BASCMP (X,NDERIV,XMIN,NODES,ICOL,BASM)
C
C  BASCMP computes ICOL and BASM where BASM is the value at X of 
C  the N-dimensional basis function corresponding to column ICOL.
C
         COEF(ICOL) = ROWWT*BASM
C
C  Increment the basis indices.
C
         DO 107 IDIM=1,MDIM
            IB(IDIM) = IB(IDIM)+1
            IF (IB(IDIM) .LE. IBMX(IDIM)) GO TO 106
            IB(IDIM) = IBMN(IDIM)
  107    CONTINUE
C
C  End of basis index loop.
C
C
C  Send a row of the least squares matrix to the reduction routine.
C
         CALL SUPRLS (IROW,COEF,NCOL,RHS,WORK(NWRK1),NWLFT,COEF,RESERR,
     1                LSERR)
         IF (LSERR .NE. 0) GO TO 133
  108 CONTINUE
C
C  Row computations for all data points are now complete.
C
C  If SWGHT.EQ.0, the least squares matrix is complete and no 
C  smoothing rows are computed.
C
      IF (SWGHT .EQ. 0.) GO TO 126
C
C  Initialize smoothing computations for data sparse areas.
C  Derivative constraints will always have zero right hand side.
C
      RHS = 0.
      NRECT = 1
C
C  Initialize the node indices and compute number of rectangles 
C  formed by the node network.
C
      DO 109 IDIM=1,MDIM
         IN(IDIM) = 0
         INMX(IDIM) = NODES(IDIM)-1
         NRECT = NRECT*INMX(IDIM)
  109 CONTINUE
C
C  Every node is assigned an element of the workspace (set aside
C  previously) in which data points are counted.
C
      DO 110 IIN=1,NCOL
         WORK(IIN) = 0.
  110 CONTINUE
C
C  Assign each data point to a node, total the assignments for 
C  each node, and save in the workspace.
C
      TOTLWT = 0.
      DO 112 IDATA=1,MDATA
C
C  BUMP is the weight associated with the data point.
C
         BUMP = 1.
         IF (WDATA(1) .GE. 0.) BUMP = WDATA(IDATA)
         IF (BUMP .EQ. 0.) GO TO 112
C
C  Find the nearest node.
C
         IIN = 0
         DO 111 IDIMC=1,MDIM
            IDIM = MDIM+1-IDIMC
            INIDIM = INT(DXIN(IDIM)*(XDATA(IDIM,IDATA)-XMIN(IDIM))+.5)
C
C  Points not in range (+ or - 1/2 node spacing) are not counted.
C
            IF (INIDIM.LT.0 .OR. INIDIM.GT.INMX(IDIM)) GO TO 112
C
C  Compute linear address of node in workspace by Horner's method.
C
            IIN = (INMX(IDIM)+1)*IIN+INIDIM
  111    CONTINUE
C
C  Bump counter for that node.
C
         WORK(IIN+1) = WORK(IIN+1)+BUMP
         TOTLWT = TOTLWT+BUMP
  112 CONTINUE
C
C  Compute the expected weight per rectangle.
C
      WTPRRC = TOTLWT/FLOAT(NRECT)
C
C  IN contains indices of the node (previously initialized).
C  IIN will be the linear address of the node in the workspace.
C
      IIN = 0
C
C  Loop through all nodes, computing derivative constraint rows 
C  for those in data sparse locations.
C
C  Begining of node index loop - traverse all node indices.
C  The indices are in IN.
C
  113 IIN = IIN+1
      EXPECT = WTPRRC
C
C  Rectangles at edge of network are smaller and hence less weight
C  should be expected.
C
      DO 114 IDIM=1,MDIM
         IF (IN(IDIM).EQ.0 .OR. IN(IDIM).EQ.INMX(IDIM))
     1       EXPECT = .5*EXPECT
  114 CONTINUE
C
C  The expected weight minus the actual weight serves to define 
C  data sparseness and is also used to weight the derivative
C  constraint rows.
C
C  There is no constraint if not data sparse.
C
      IF (WORK(IIN) .GE. SPCRIT*EXPECT) GO TO 124
      DCWGHT = EXPECT-WORK(IIN)
      DO 115 IDIM=1,MDIM
         INIDIM = IN(IDIM)
C
C  Compute the location of the node.
C
         X(IDIM) = XMIN(IDIM)+FLOAT(INIDIM)*DX(IDIM)
C
C  Compute the indices of the basis functions which are non-zero 
C  at the node.
C
         IBMN(IDIM) = INIDIM-1
         IBMX(IDIM) = INIDIM+1
C
C  Distinguish the boundaries.
C
         IF (INIDIM .EQ. 0) IBMN(IDIM) = 0
         IF (INIDIM .EQ. INMX(IDIM)) IBMX(IDIM) = INMX(IDIM)
C
C  Initialize the basis indices.
C
         IB(IDIM) = IBMN(IDIM)
  115 CONTINUE
C
C  Multiply by the extrapolation parameter (this acts as a 
C  smoothing weight).
C
      DCWGHT = SWGHT*DCWGHT
C
C  The COEF array serves as a row of the least squares matrix.  
C  Its value is zero except for columns corresponding to functions 
C  which are non-zero at the node.
C
      DO 116 ICOL=1,NCOL
         COEF(ICOL) = 0.
  116 CONTINUE
C
C  The 2nd derivative of a function of MDIM variables may be thought 
C  of as a symmetric MDIM x MDIM matrix of 2nd order partial 
C  derivatives.  Traverse the upper triangle of this matrix and, 
C  for each element, compute a row of the least squares matrix.
C
      DO 123 IDM=1,MDIM
         DO 122 JDM=IDM,MDIM
            DO 117 IDIM=1,MDIM
               NDERIV(IDIM) = 0
  117       CONTINUE
C
C  Off-diagonal elements appear twice by symmetry, so the corresponding
C  row is weighted by a factor of 2.
C
            ROWWT = 2.*DCWGHT
            IF (JDM .NE. IDM) GO TO 118
C
C  Diagonal.
C
            ROWWT = DCWGHT
            NDERIV(JDM) = 2
            IF (IN(IDM).NE.0 .AND. IN(IDM).NE.INMX(IDM)) GO TO 119
C
C  Node is at boundary.
C
C  Normal 2nd derivative constraint at boundary is not appropriate for
C  natural splines (2nd derivative 0 by definition).  Substitute
C  a 1st derivative constraint.
C
  118       NDERIV(IDM) = 1
            NDERIV(JDM) = 1
  119       IROW = IROW+1
C
C  Begining of basis index loop - traverse all indices corresponding
C  to basis functions which are non-zero at X.
C  The indices are in IB and are passed through common to BASCMP.
C
  120       CALL BASCMP (X,NDERIV,XMIN,NODES,ICOL,BASM)
C
C  BASCMP computes ICOL and BASM where BASM is the value at X of the
C  N-dimensional basis function corresponding to column ICOL.
C
            COEF(ICOL) = ROWWT*BASM
C
C  Increment the basis indices.
C
            DO 121 IDIM=1,MDIM
               IB(IDIM) = IB(IDIM)+1
               IF (IB(IDIM) .LE. IBMX(IDIM)) GO TO 120
               IB(IDIM) = IBMN(IDIM)
  121       CONTINUE
C
C  End of basis index loop.
C
C  Send row of least squares matrix to reduction routine.
C
         CALL SUPRLS (IROW,COEF,NCOL,RHS,WORK(NWRK1),NWLFT,COEF,RESERR,
     1                LSERR)
         IF (LSERR .NE. 0) GO TO 133
  122    CONTINUE
  123 CONTINUE
C
C  Increment node indices.
C
  124 DO 125 IDIM=1,MDIM
         IN(IDIM) = IN(IDIM)+1
         IF (IN(IDIM) .LE. INMX(IDIM)) GO TO 113
         IN(IDIM) = 0
  125 CONTINUE
C
C  End of node index loop.
C
C  Call for least squares solution in COEF array.
C
  126 IROW = 0
         CALL SUPRLS (IROW,COEF,NCOL,RHS,WORK(NWRK1),NWLFT,COEF,RESERR,
     1                LSERR)
         IF (LSERR .NE. 0) GO TO 133
      RETURN
C
C  Error section
C
  127 CONTINUE
      IERROR = 101
      CALL CFAERR (IERROR,' SPLCC or SPLCW - NDIM is less than 1 or is g
     +reater than 4  ',60)
      GO TO 134
  128 CONTINUE
      IERROR = 102
      CALL CFAERR (IERROR,' SPLCC or SPLCW - NODES(IDIM) is less than 4
     1for some IDIM  ',60)
      GO TO 134
  129 CONTINUE
      IERROR = 103
      CALL CFAERR (IERROR,' SPLCC or SPLCW - XMIN(IDIM) equals XMAX(IDIM
     +) for some IDIM',60)
      GO TO 134
  130 CONTINUE
      IERROR = 104
      CALL CFAERR (IERROR,' SPLCC or SPLCW - NCF (size of COEF) is too s
     +mall           ',60)
      GO TO 134
  131 CONTINUE
      IERROR = 105
      CALL CFAERR (IERROR,' SPLCC or SPLCW - NDATA is less than 1
     +               ',60)
      GO TO 134
  132 CONTINUE
      IERROR = 106
      CALL CFAERR (IERROR,' SPLCC or SPLCW - NWRK (size of WORK) is too 
     +small          ',60)
      GO TO 134
  133 CONTINUE
      IERROR = 107
      CALL CFAERR (IERROR,' SPLCC or SPLCW - SUPRLS failure (this usuall
     +y indicates insufficient input data',80)
C
  134 RETURN
      END

      SUBROUTINE CPTSVX( FACT, N, NRHS, D, E, DF, EF, B, LDB, X, LDX,
     $                   RCOND, FERR, BERR, WORK, RWORK, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          FACT
      INTEGER            INFO, LDB, LDX, N, NRHS
      REAL               RCOND
*     ..
*     .. Array Arguments ..
      REAL               BERR( * ), D( * ), DF( * ), FERR( * ),
     $                   RWORK( * )
      COMPLEX            B( LDB, * ), E( * ), EF( * ), WORK( * ),
     $                   X( LDX, * )
*     ..
*
*  Purpose
*  =======
*
*  CPTSVX uses the factorization A = L*D*L**H to compute the solution
*  to a complex system of linear equations A*X = B, where A is an
*  N-by-N Hermitian positive definite tridiagonal matrix and X and B
*  are N-by-NRHS matrices.
*
*  Error bounds on the solution and a condition estimate are also
*  provided.
*
*  Description
*  ===========
*
*  The following steps are performed:
*
*  1. If FACT = 'N', the matrix A is factored as A = L*D*L**H, where L
*     is a unit lower bidiagonal matrix and D is diagonal.  The
*     factorization can also be regarded as having the form
*     A = U**H*D*U.
*
*  2. If the leading i-by-i principal minor is not positive definite,
*     then the routine returns with INFO = i. Otherwise, the factored
*     form of A is used to estimate the condition number of the matrix
*     A.  If the reciprocal of the condition number is less than machine
*     precision, INFO = N+1 is returned as a warning, but the routine
*     still goes on to solve for X and compute error bounds as
*     described below.
*
*  3. The system of equations is solved for X using the factored form
*     of A.
*
*  4. Iterative refinement is applied to improve the computed solution
*     matrix and calculate error bounds and backward error estimates
*     for it.
*
*  Arguments
*  =========
*
*  FACT    (input) CHARACTER*1
*          Specifies whether or not the factored form of the matrix
*          A is supplied on entry.
*          = 'F':  On entry, DF and EF contain the factored form of A.
*                  D, E, DF, and EF will not be modified.
*          = 'N':  The matrix A will be copied to DF and EF and
*                  factored.
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  NRHS    (input) INTEGER
*          The number of right hand sides, i.e., the number of columns
*          of the matrices B and X.  NRHS >= 0.
*
*  D       (input) REAL array, dimension (N)
*          The n diagonal elements of the tridiagonal matrix A.
*
*  E       (input) COMPLEX array, dimension (N-1)
*          The (n-1) subdiagonal elements of the tridiagonal matrix A.
*
*  DF      (input or output) REAL array, dimension (N)
*          If FACT = 'F', then DF is an input argument and on entry
*          contains the n diagonal elements of the diagonal matrix D
*          from the L*D*L**H factorization of A.
*          If FACT = 'N', then DF is an output argument and on exit
*          contains the n diagonal elements of the diagonal matrix D
*          from the L*D*L**H factorization of A.
*
*  EF      (input or output) COMPLEX array, dimension (N-1)
*          If FACT = 'F', then EF is an input argument and on entry
*          contains the (n-1) subdiagonal elements of the unit
*          bidiagonal factor L from the L*D*L**H factorization of A.
*          If FACT = 'N', then EF is an output argument and on exit
*          contains the (n-1) subdiagonal elements of the unit
*          bidiagonal factor L from the L*D*L**H factorization of A.
*
*  B       (input) COMPLEX array, dimension (LDB,NRHS)
*          The N-by-NRHS right hand side matrix B.
*
*  LDB     (input) INTEGER
*          The leading dimension of the array B.  LDB >= max(1,N).
*
*  X       (output) COMPLEX array, dimension (LDX,NRHS)
*          If INFO = 0 or INFO = N+1, the N-by-NRHS solution matrix X.
*
*  LDX     (input) INTEGER
*          The leading dimension of the array X.  LDX >= max(1,N).
*
*  RCOND   (output) REAL
*          The reciprocal condition number of the matrix A.  If RCOND
*          is less than the machine precision (in particular, if
*          RCOND = 0), the matrix is singular to working precision.
*          This condition is indicated by a return code of INFO > 0.
*
*  FERR    (output) REAL array, dimension (NRHS)
*          The forward error bound for each solution vector
*          X(j) (the j-th column of the solution matrix X).
*          If XTRUE is the true solution corresponding to X(j), FERR(j)
*          is an estimated upper bound for the magnitude of the largest
*          element in (X(j) - XTRUE) divided by the magnitude of the
*          largest element in X(j).
*
*  BERR    (output) REAL array, dimension (NRHS)
*          The componentwise relative backward error of each solution
*          vector X(j) (i.e., the smallest relative change in any
*          element of A or B that makes X(j) an exact solution).
*
*  WORK    (workspace) COMPLEX array, dimension (N)
*
*  RWORK   (workspace) REAL array, dimension (N)
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*          > 0:  if INFO = i, and i is
*                <= N:  the leading minor of order i of A is
*                       not positive definite, so the factorization
*                       could not be completed, and the solution has not
*                       been computed. RCOND = 0 is returned.
*                = N+1: U is nonsingular, but RCOND is less than machine
*                       precision, meaning that the matrix is singular
*                       to working precision.  Nevertheless, the
*                       solution and error bounds are computed because
*                       there are a number of situations where the
*                       computed solution can be more accurate than the
*                       value of RCOND would suggest.
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ZERO
      PARAMETER          ( ZERO = 0.0E+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            NOFACT
      REAL               ANORM
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      REAL               CLANHT, SLAMCH
      EXTERNAL           LSAME, CLANHT, SLAMCH
*     ..
*     .. External Subroutines ..
      EXTERNAL           CCOPY, CLACPY, CPTCON, CPTRFS, CPTTRF, CPTTRS,
     $                   SCOPY, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      NOFACT = LSAME( FACT, 'N' )
      IF( .NOT.NOFACT .AND. .NOT.LSAME( FACT, 'F' ) ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( NRHS.LT.0 ) THEN
         INFO = -3
      ELSE IF( LDB.LT.MAX( 1, N ) ) THEN
         INFO = -9
      ELSE IF( LDX.LT.MAX( 1, N ) ) THEN
         INFO = -11
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'CPTSVX', -INFO )
         RETURN
      END IF
*
      IF( NOFACT ) THEN
*
*        Compute the L*D*L' (or U'*D*U) factorization of A.
*
         CALL SCOPY( N, D, 1, DF, 1 )
         IF( N.GT.1 )
     $      CALL CCOPY( N-1, E, 1, EF, 1 )
         CALL CPTTRF( N, DF, EF, INFO )
*
*        Return if INFO is non-zero.
*
         IF( INFO.NE.0 ) THEN
            IF( INFO.GT.0 )
     $         RCOND = ZERO
            RETURN
         END IF
      END IF
*
*     Compute the norm of the matrix A.
*
      ANORM = CLANHT( '1', N, D, E )
*
*     Compute the reciprocal of the condition number of A.
*
      CALL CPTCON( N, DF, EF, ANORM, RCOND, RWORK, INFO )
*
*     Set INFO = N+1 if the matrix is singular to working precision.
*
      IF( RCOND.LT.SLAMCH( 'Epsilon' ) )
     $   INFO = N + 1
*
*     Compute the solution vectors X.
*
      CALL CLACPY( 'Full', N, NRHS, B, LDB, X, LDX )
      CALL CPTTRS( 'Lower', N, NRHS, DF, EF, X, LDX, INFO )
*
*     Use iterative refinement to improve the computed solutions and
*     compute error bounds and backward error estimates for them.
*
      CALL CPTRFS( 'Lower', N, NRHS, D, E, DF, EF, B, LDB, X, LDX, FERR,
     $             BERR, WORK, RWORK, INFO )
*
      RETURN
*
*     End of CPTSVX
*
      END

C
C	$Id: gzcpwk.f,v 1.7 2008-07-27 00:21:03 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GZCPWK(WKID)
C
C  Copy the segment (whose name is stored in common variable
C  STR) to the workstation WKID.
C
C  The part of the code that interprets the segments is comprised
C  of the following subroutines:
C
C    GASPAR
C    GATELM 
C    GCELCD
C    GCELDC
C    GCELDR
C    GELMS
C    GESCFN
C    GFILAT
C    GKSPOP
C    GMARAT
C    GNINST
C    GENNEG
C    GNPART
C    GOPDEC
C    GPOLAT
C    GPUTPT
C    GSEGDT
C    GSEGRD
C    GTFLT
C    GTXTAT
C    GTXDRW
C    GXLATE
C    GXMDEF
C    GXOPDF
C    GZROI
C    GZW2GK
C
      include 'gkscom.h'
C
      INTEGER WKID
      INTEGER ICNTX(31)
      REAL    RCNTX(19)
      CHARACTER*80 IDR,ODR
C
      PARAMETER (MXCOL=256)
C
C  Open input segment for reading.
C
      ILEN = 0
      DO 10 I=1,80
      IF (STR(I:I).EQ.' ' .OR. STR(I:I).EQ.CHAR(0)) THEN
        ILEN = I-1
        GO TO 20
      ENDIF
   10 CONTINUE
   20 CONTINUE
      STR(ILEN+1:ILEN+1) = CHAR(0)
      CALL G01MIO(8, WCONID, STR(1:ILEN), IDUM1, IDUM2, IER)
      IF (IER .NE. 0) THEN
        RERR = -105
        RETURN
      ENDIF
C
C  Save the GKS attribute context.
C
      CALL GZSRAT(0,ICNTX,RCNTX)
C
C  Activate WKID if it is not active so that the output primitives
C  will be written to it.
C
      ISFLG = 0
      CALL GQWKS(WKID,IER,ISTATE)
      IF (ISTATE .EQ. 0) THEN
        ISFLG = 1
        CALL GACWK(WKID)
      ENDIF
C
C  Send a flag to PostScript workstations to indicate the beginning
C  of a segment copy so that the color setting can be retained and
C  reset after the copy.
C
      WRITE(IDR,500) WKID
  500 FORMAT(I5)
      CALL GESC(-1510,1,IDR,1,1,ODR)
C
C  Copy the segment.  Set CUFLAG to inidicate that the interface 
C  calls should go only to the designated workstation.
C
      CUFLAG = WKID
      CALL GZW2GK(WKID,WCONID,IER)
      CUFLAG = -1
C
C  Tell PostScript workstations that we are done copying the segment.
C
      CALL GESC(-1511,1,IDR,1,1,ODR)
      IF (IER .NE. 0) RETURN
C
C  Restore the attribute context.
C
      CALL GZSRAT(1,ICNTX,RCNTX)
C
C  Close the input segment.
C
      CALL G01MIO(2, WCONID, STR(1:ILEN), IDUM1, IDUM2, IER)
      IF (IER .NE. 0) RETURN
C
C  Deactive the workstation if it was not active upon invocation.
C
      IF (ISFLG .EQ. 1) CALL GDAWK(WKID)
C
      RETURN
      END 

      PROGRAM CEZMAP3
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      REAL PLIM1(2), PLIM2(2), PLIM3(2), PLIM4(2)

      DATA PLIM1 /0.,0./
      DATA PLIM2 /0.,0./
      DATA PLIM3 /0.,0./
      DATA PLIM4 /0.,0./
C
C Open GKS, Turn Clipping off
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Invoke demo driver
C
      CALL CEZMAP('SV',40.,-50.,0.,'PO','MA',PLIM1,PLIM2,PLIM3,PLIM4)
C
C Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS

      STOP
      END

      SUBROUTINE CEZMAP(PROJ, PLAT, PLON, ROTA, OUTLN,
     +     JLIM, PLIM1, PLIM2, PLIM3, PLIM4)
      
      CHARACTER*2 PROJ, OUTLN, JLIM
      REAL PLIM1(2), PLIM2(2), PLIM3(2), PLIM4(2)
C
C CMPLOT demonstrates MAPLOT drawing continental and political outlines
C
C Set up Maps.
C
C
C Draw Continental, political outlines 
C
      CALL MAPSTC ('OU - OUTLINE DATASET SELECTOR',OUTLN)
C
C Set up projection
C
      CALL MAPROJ (PROJ,PLAT,PLON,ROTA)
C
C If it's a satellite projection, choose a satellite distance
C
      IF (PROJ.EQ.'SV') CALL MAPSTR ('SA - SATELLITE DISTANCE',5.)
C
C Set limits of map
C
      CALL MAPSET (JLIM,PLIM1,PLIM2,PLIM3,PLIM4)
C
C Draw map
C
      CALL MAPDRW
C
C Advance the frame.
C
      CALL FRAME
C
C Done.
C
      RETURN
      END

C
C       $Id: vvdata.f,v 1.15 2008-07-27 00:17:35 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE VVDATA
C
C Calling this do-nothing subroutine forces "ld" to load the following
C block data routine (but only if they are in the same ".f" file).
C
        RETURN
C
      END
CNOSPLIT
      BLOCKDATA VVDATAX
C
C This 'routine' sets the default values of the VVECTR parameters.
C
C ---------------------------------------------------------------------
C
C NOTE:
C Since implicit typing is used for all real and integer variables
C a consistent length convention has been adopted to help clarify the
C significance of the variables encountered in the code for this 
C utility. All local variable and subroutine parameter identifiers 
C are limited to 1,2,or 3 characters. Four character names identify  
C members of common blocks. Five and 6 character variable names 
C denote PARAMETER constants or subroutine or function names.
C
C Declare the VV common blocks.
C
C IPLVLS - Maximum number of color threshold level values
C IPAGMX - Maximum number of area groups allowed in the area map
C
      PARAMETER (IPLVLS = 256, IPAGMX = 64)
C
C Integer and real common block variables
C
C
      COMMON /VVCOM/
     +                IUD1       ,IVD1       ,IPD1       ,IXDM       ,
     +                IYDN       ,VLOM       ,VHIM       ,ISET       ,
     +                VRMG       ,VRLN       ,VFRC       ,IXIN       ,
     +                IYIN       ,ISVF       ,UUSV       ,UVSV       ,
     +                UPSV       ,IMSK       ,ICPM       ,UVPS       ,
     +                UVPL       ,UVPR       ,UVPB       ,UVPT       ,
     +                UWDL       ,UWDR       ,UWDB       ,UWDT       ,
     +                UXC1       ,UXCM       ,UYC1       ,UYCN       ,
     +                NLVL       ,IPAI       ,ICTV       ,WDLV       ,
     +                UVMN       ,UVMX       ,PMIN       ,PMAX       ,
     +                RVMN       ,RVMX       ,RDMN       ,RDMX       ,
     +                ISPC       ,RVMD       ,IPLR       ,IVST       ,
     +                IVPO       ,ILBL       ,IDPF       ,IMSG       ,
     +                ICLR(IPLVLS)           ,TVLU(IPLVLS)
C
C Arrow size/shape parameters
C
        COMMON / VVARO /
     +                HDSZ       ,HINF       ,HANG       ,IAST       ,
     +                HSIN       ,HCOS       ,FAMN       ,FAMX       ,
     +                UVMG       ,FAIR       ,FAWR       ,FAWF       ,
     +                FAXR       ,FAXF       ,FAYR       ,FAYF       ,
     +                AROX(8)    ,AROY(8)    ,FXSZ       ,FYSZ       ,
     +                FXRF       ,FXMN       ,FYRF       ,FYMN       ,
     +                FWRF       ,FWMN       ,FIRF       ,FIMN       ,
     +                AXMN       ,AXMX       ,AYMN       ,AYMX       ,
     +                IACM       ,IAFO       ,WBAD       ,WBTF       ,
     +                WBCF       ,WBDF       ,WBSC
C
C
C Text related parameters
C
        COMMON /VVTXP /
     +                FCWM    ,ICSZ    ,
     +                FMNS    ,FMNX    ,FMNY    ,IMNP    ,IMNC  ,
     +                FMXS    ,FMXX    ,FMXY    ,IMXP    ,IMXC  ,
     +                FZFS    ,FZFX    ,FZFY    ,IZFP    ,IZFC  ,
     +                FILS    ,FILX    ,FILY    ,IILP    ,IILC  ,
     +                FLBS    ,ILBC

C
C Character variable declartions
C
      CHARACTER*160 CSTR
      PARAMETER (IPCHSZ=36)
      CHARACTER*(IPCHSZ)  CMNT,CMXT,CZFT,CLBT,CILT
C
C Text string parameters
C
      COMMON /VVCHAR/ CSTR,CMNT,CMXT,CZFT,CLBT,CILT
C
      SAVE /VVCOM/, /VVARO/, /VVTXP/, /VVCHAR/
C
C The mapping common block: made available to user mapping routines
C
      COMMON /VVMAP/
     +                IMAP       ,
     +                XVPL       ,XVPR       ,YVPB       ,YVPT       ,
     +                WXMN       ,WXMX       ,WYMN       ,WYMX       ,
     +                XLOV       ,XHIV       ,YLOV       ,YHIV       ,
     +                SXDC       ,SYDC       ,NXCT       ,NYCT       ,
     +                RLEN       ,LNLG       ,INVX       ,INVY       ,
     +                ITRT       ,IWCT       ,FW2W       ,FH2H       ,
     +                DVMN       ,DVMX       ,RBIG       ,IBIG
C
      SAVE /VVMAP/
C
C Math constants
C
      PARAMETER (PDTOR  = 0.017453292519943,
     +           PRTOD  = 57.2957795130823,
     +           P1XPI  = 3.14159265358979,
     +           P2XPI  = 6.28318530717959,
     +           P1D2PI = 1.57079632679489,
     +           P5D2PI = 7.85398163397448) 
C
C --------------------------------------------------------------------
C *********************************************************************
C 
C Initialization of VVCOM
C
C IUD1 -- 'UD1' -- First dimension of U
C
      DATA     IUD1 / -1 /
C
C IVD1 -- 'VD1' -- First dimension of V
C
      DATA     IVD1 / -1 /
C
C IPD1 -- 'PD1' -- First dimension of P
C
      DATA     IPD1 / -1 /
C
C IXDM -- 'XDM' -- First dimension of data for U,V,P
C
      DATA     IXDM / -1 /
C   
C IYDN -- 'YDN' -- Second dimension of data for U,V,P
C
      DATA     IYDN / -1 /
C
C VLOM -- 'VLC' -- Vector low cutoff  -- minimum size vector to plot
C                  Old FLO parameter
C
      DATA     VLOM / 0.0 /
C
C VHIM -- 'VHC' -- Vector high cutoff -- maximum size vector to plot
C                  Old HI parameter
C
      DATA     VHIM / 0.0 /
C
C ISET -- 'SET' -- The Set call flag - Old NSET parameter
C
      DATA     ISET / 1 /
C
C VRMG -- 'VRM' -- Reference magnitude - the magnitude represented by
C                  the reference length. If 0.0, the maximum magnitude
C                  is used as the reference magnitude
C
      DATA     VRMG / 0.0 /
C
C
C VRLN -- 'VRL' -- Old LENGTH parameter (but stored as a fraction of
C                  the viewport width). 
C                  0.0 causes VVINIT to select a value.
C
      DATA     VRLN / 0.0 /
C
C VFRC -- 'VFR' -- Fraction of the maximum length used to represent
C                  the minimum length vector. 1.0 causes all vectors to
C                  become maximum length. 0.0 means the minimum length 
C                  is linearly scaled from the maximum length (as now),
C
      DATA     VFRC / 0.0 /
C
C IXIN -- 'XIN' -- The X Axis grid increment, must be > 0
C IYIN -- 'YIN' -- The Y Axis grid increment, must be > 0
C
      DATA IXIN / 1 /
      DATA IYIN / 1 /
C
C
C ISVF -- 'SVF' -- Special value flag
C                  Old ISPV parameter
C
      DATA ISVF / 0 /
C
C UUSV -- 'USV' -- The U array special value 
C                  Old SPV(1)
C
      DATA UUSV / 1.0E12 /
C
C UVSV -- 'VSV' -- The V array special value
C                  Old SPV(2)
C
      DATA UVSV / 1.0E12 /
C
C UPSV -- 'PSV' -- The P array special value
C 
      DATA UPSV / 1.0E12 /
C
C IMSK -- 'MSK' -- Mask the vectors to an area map: <1 -- no mapping,
C                  1 - high precision mapping;>1 low precision mapping
C
      DATA IMSK / 0 /
C
C ICPM -- 'CPM' -- the compatibility mode. If 0, the default, the
C                  the behavior depends on whether the old routines
C                  or the new routines are called. If >0 the FX,FY,
C                  MXF,MYF functions are used. Additionally, when
C                  used in conjunction with the VELVCT routine, 
C                  has a meaningful range from -4 to +4 inclusive,
C                  where various combinations are allowed to use or
C                  ignore 1) the optional input parameters to
C                  VELVCT, 2) the data in VEC1 and VEC2 common
C                  3) FX, etc routines, as follows:
C
C                  -4: no FX, ignore params, ignore VEC1,VEC2
C                  -3: no FX, ignore params, use VEC1,VEC2
C                  -2: no FX, use params, ignore VEC1,VEC2
C                  -1: no FX, use params, use VEC1,VEC2
C                   0: default: same as -4 if VVINIT,VVECTR called,
C                      same as +1 if VELVCT,EZVEC, or VELVEC called.
C                  +1: FX, use params, use VEC1,VEC2
C                  +2: FX, use params, ignore VEC1,VEC2
C                  +3: FX, ignore params, use VEC1,VEC2
C                  +4: FX, ignore params, ignore VEC1,VEC2
C
C                  FX means using FX,FY,MXF,and MYF
C                  Params include FLO,HI,NSET,LENGTH,ISPV,SPV.
C                  VEC1,VEC2 data includes all settable values
C                  from these two common blocks.
C                  When parameters and common block values are
C                  used they override anything done using the
C                  vvset routines
C
      DATA ICPM / 0 /
C
C UVPS -- 'VPS' -- The viewport mode
C
      DATA UVPS / 0.25 /
C
C UVPL -- 'VPL' -- Viewport left
C
      DATA UVPL / 0.05 /
C
C UVPR -- 'VPR' -- Viewport right
C
      DATA UVPR / 0.95 /
C
C UVPB -- 'VPB' -- Viewport bottom
C
      DATA UVPB / 0.05 /
C
C UVPT -- 'VPT' -- Viewport top
C
      DATA UVPT / 0.95 /
C
C UWDL -- 'WDL' -- Window left
C
      DATA UWDL / 0.0 /
C
C UWDR -- 'WDR' -- Window right
C
      DATA UWDR / 0.0 /
C
C UWDB -- 'WDB' -- Window bottom
C
      DATA UWDB / 0.0 /
C
C UWDT -- 'WDT' -- Window top
C
      DATA UWDT / 0.0 /
C
C UXC1 -- 'XC1' -- minimum X coord
C
      DATA UXC1 / 0.0 /
C
C UXCM -- 'XCM' -- maximum Y coord
C
      DATA UXCM / 0.0 /
C
C UYC1 -- 'YC1' -- minimum Y coord
C
      DATA UYC1 / 0.0 /
C
C UYCN -- 'YCN' -- maximum Y coord
C
      DATA UYCN / 0.0 /
C
C NLVL -- 'NLV' -- number of distinct colors to use for the
C                    independent variable mapping -- cannot exceed
C                    IPLVLS, number of elements used in CLR and TVL
C                    
      DATA  NLVL /  0 /
C
C IPAI -- 'PAI' -- the current level -- must be set before 
C                   modifying an internal level array value
C
      DATA   IPAI /   1     /
C
C ICTV -- 'CTV' -- compute thresholds flag:
C                  -2: color vectors by scalar value, user sets TVL
C                  -1: color vectors by vector magnitude, user sets TVL
C                   0: no vector coloring
C                  +1: color vectors by magnitude, VVINIT sets TVL
C                  +2: color vectors by scalar array, VVINIT sets TVL
C
      DATA  ICTV /   0     /
C
C WDLV -- 'LWD' -- the width of a vector line
C 
      DATA  WDLV /   1.0   /
C
C UVMN -- the minimum vector magnitude
C UVMX -- the maximum vector magnitude
C PMIN -- 'PMN' -- the minimum scalar array value, read-only
C PMAX -- 'PMX' -- the maximum scalar array value, read-only
C
      DATA UVMN / 0.0 /
      DATA UVMX / 0.0 /
      DATA PMIN / 0.0 /
      DATA PMAX / 0.0 /
C
C RVMN -- 'VMN' -- the minimum vector magnitude, read-only
C RVMX -- 'VMX' -- the maximum vector magnitude, read-only
C RDMN -- 'DMN' -- the minimum vector in NDC, read-only
C RDMX -- 'DMX' -- the maximum vector in NDC, read-only
C
      DATA RVMN / 0.0 /
      DATA RVMX / 0.0 /
      DATA RDMN / 0.0 /
      DATA RDMX / 0.0 /
C
C ISPC -- 'SPC' -- Special color -- 
C                      < 0: no P special value
C                      = 0: don't draw vector that has a P spec val
C                      > 0: draw P special values using color SPC
C
C     DATA ISPC / -1 /
C
C RVMD -- 'VMD' -- vector minimum distance
C
      DATA RVMD / 0.0 /
C
C IPLR -- 'PLR' -- Polar coordinates for UV array flag
C
      DATA IPLR / 0 /
C
C IVST -- 'VST' -- Vector statistics flag
C
      DATA IVST / 0 /
C
C
C IVPO -- 'VPO' -- vector position flag: < 0 - head at position,
C               0 - center at position,  > 0 - tail at position
C
      DATA IVPO / 0 /
C
C
C ILBL -- 'LBL' -- Vector labelling flag: 0 - don't, 1 - do
C
      DATA ILBL / 0 /
C
C IDPF -- 'DPF' -- decimal point flag for vector label strings
C               1 - include decimal point, non-zero don't
C
      DATA IDPF / 1 /
C
C ICLR -- 'CLR' -- the GKS color index value
C
      DATA  ICLR / IPLVLS * 1 /
C
C TVLU -- 'TVL' -- the list of threshold values
C
      DATA  TVLU / IPLVLS * 0.0 /
C
C End of VVCOM intialization
C
C --------------------------------------------------------------------
C
C VVARO -Arrow size/shape parameters
C
C HDSZ - head size as fraction of arrow length
C
      DATA HDSZ / 0.25 /
C
C HINF - interior point of head as fraction of head size
C
      DATA HINF / 0.5 /
C
C HANG - half angle of head
C
      DATA HANG / 22.5 /
C
C FAMN -- 'AMN' -- arrow head min size as FVPW 
C                                        (fraction of viewport width)
C
      DATA FAMN / 0.005 /
C
C FAMX -- 'AMX' -- arrow head max size as FVPW
C
      DATA FAMX / 0.05 /
C
C IAST -- 'AST' -- arrow style (currently line or filled)
C
      DATA IAST / 0 /
C
C FAIR -- 'AIR' -- arrow interior position (reference)
C
      DATA FAIR / 0.33 /
C
C FAWR -- 'AWR' -- arrow width (reference)
C
      DATA FAWR / 0.1 /
C
C FAWF -- 'AWF' -- arrow width (minimum)
C
      DATA FAWF / 0.25 /
C
C FAXR -- 'AXR' -- arrowhead X-coord length (reference)
C
      DATA FAXR / 0.36 /
C
C FAXF -- 'AXF' -- arrowhead X-coord length (minimum)
C
      DATA FAXF / 0.25 /
C
C FAYR -- 'AYR' -- arrowhead Y-coord length (reference)
C
      DATA FAYR / 0.12 /
C
C FAYF -- 'AYF' -- arrowhead Y-coord length (minimum)
C
      DATA FAYF / 0.25 /
C
C IACM -- 'ACM' -- arrow color mode 
C                  (ignored if AST = 0)
C                 (if CTV is 0, all lines and fill become mono;
C                  only -2, -1, and 0 will be distinguishable states)
C                 -2 multi-fill, no-line
C                 -1 no-fill, multi-line
C                  0 multi-fill, mono-line
C                  1 mono-fill, multi-line
C                  2 multi-fill, multi-line
C
C
      DATA IACM / 0 /
C
C IAFO -- 'AFO' -- arrow fill over (arrow lines)
C
      DATA IAFO / 1 /
C
C WBAD -- 'WBA' -- wind barb angle
C
      DATA WBAD / 62.0 /
C
C WBTF -- 'WBT' -- wind barb tic size (fraction of wb length)
C
      DATA WBTF / 0.33 /
C
C WBCF -- 'WBC' -- wind barb zero circle size (fraction of wb length)
C
      DATA WBCF / 0.25 /
C
C WBDF -- 'WBD' -- wind barb distance (spacing beteen ticks as
C                                      fraction of wb length)
C
      DATA WBDF / 0.1 /
C
C WBSC -- 'WBS' -- wind barb scale factor
C
      DATA WBSC / 1.0 /
C
C
C --------------------------------------------------------------------
C
C VVTXP - Text parameters 
C
C FCWM -- 'CWM' -- character width multiple, scale factor for all 
C                  text put out by the VELVCT routine
C
      DATA FCWM / 1.0 /
C
C ICCM -- internal - maximum length of character strings
C
      DATA ICSZ / IPCHSZ /
C
C FMNS -- 'MNS' -- size of text for minimum vector string as FVPW
C FMNX -- 'MNX' -- X position of minimum vector string as FVPW
C FMNY -- 'MNY' -- Y position of minimum vector string as FVPW
C IMNP -- 'MNP' -- minimum vector string position flag
C IMNC -- 'MNC' -- color of text for minimum vector label
C 
      DATA FMNS / 0.0075 /
      DATA FMNX / 0.475 /
      DATA FMNY / -0.01 /
      DATA IMNP / 4 /
      DATA IMNC / -1 /
C
C FMXS -- 'MXS' -- size of text for maximum vector string as FVPW
C FMXX -- 'MXX' -- X position of maximum vector string as FVPW
C FMXY -- 'MXY' -- Y position of maximum vector string as FVPW
C IMXP -- 'MXP' -- maximum vector string position flag
C IMNC -- 'MXC' -- color of text for maximum vector label
C 
      DATA FMXS / 0.0075 /
      DATA FMXX / 0.525 /
      DATA FMXY / -0.01 /
      DATA IMXP / 2 /
      DATA IMXC / -1 /
C
C FZFS -- 'ZFS' -- size of text for zero field string as FVPW
C FZFX -- 'ZFX' -- X position of zero field string as FVPW
C FZFY -- 'ZFY' -- Y position of zero field string as FVPW
C IZFP -- 'ZFP' -- zero field string position flag
C IMNC -- 'ZFC' -- color of text for zero field label
C 
      DATA FZFS / 0.033 /
      DATA FZFX / 0.5 /
      DATA FZFY / 0.5 /
      DATA IZFP / 0 /
      DATA IZFC / -1 /
C
C FLBS -- 'LBS' -- vector label text size as FVPW
C IMNC -- 'LBC' -- color of text for vector labels
C 
      DATA FLBS / 0.007 /
      DATA ILBC / -1 /
C
C The informational label has not yet been implemented
C FILS -- 'ILS' -- size of text for informational label string as FVPW
C FILX -- 'ILX' -- X position of informational label string as FVPW
C FILY -- 'ILY' -- Y position of informational label string as FVPW
C IILP -- 'ILP' -- informational label string position flag
C IILC -- 'ILC' -- color of text for informational label
C 
      DATA FILS / 0.05 /
      DATA FILX / 0.0 /
      DATA FILY / 0.0 /
      DATA IILP / 0 /
      DATA IILC / -1 /
C
C ---------------------------------------------------------------------
C
C Beginning of VVCHAR initialization
C
      DATA CMNT / 'Minimum Vector' /
      DATA CMXT / 'Maximum Vector' /
      DATA CZFT / 'ZERO FIELD' /
      DATA CILT / 'Vector Field Map' /
C
C End of VVCHAR initialization
C
C *********************************************************************
C 
C VVMAP initialization
C
C RLEN -- 'RML' -- Vector max length in WC
C
      DATA RLEN / 0.0 /
C
C ITRT -- 'TRT' -- Transform type flag: 
C                      0  - transform position only
C                      1  - transform position and angle
C                      -1 - transform position, angle, and magnitude
C
      DATA ITRT / 1 /
C
C DVMN -- the minimum vector size in NDC
C DVMX -- the maximum vector size in NDC
C
      DATA DVMN / 0.0 /
      DATA DVMX / 0.0 /
C
C IMAP -- 'MAP' -- the mapping transformation to use
C
      DATA  IMAP / 0 /
C
C XVPL,XVPT,YVPB,YVPT -- the viewport values
C
C WXMN,WXMX,WYMN,WYMX -- the window minimum and maximum values
C
C XLOV,XHIV,YLOV,YHIV -- the mapped array endpoint values
C
C SXDC,SYDC -- scale values for the calculated vector endpoint
C
C NXCT,NYCT -- number of points in X and Y used for the plot
C
C RLEN -- maximum vector length in window coordinates
C
C LNLG -- the log scale mapping flag from SET call
C
C INVX,INVY -- inverse flags for the window boundaries
C
C *********************************************************************
C
C REVISION HISTORY ----------------------------------------------------
C
C FEBRUARY, 1979   ADDED REVISION HISTORY
C                  MODIFIED CODE TO CONFORM TO FORTRAN 66 STANDARD
C
C JULY, 1979       FIXED HI VECTOR TRAP AND MESSAGE INDICATING
C                  MAXIMUM VECTOR PLOTTED.
C
C DECEMBER, 1979   CHANGED THE STATISTICS CALL FROM CRAYLIB TO NSSL
C
C MARCH, 1981      FIXED SOME FRINGE-CASE ERRORS, CHANGED THE CODE TO
C                  USE FL2INTT AND PLOTIT INSTEAD OF MXMY, FRSTPT, AND
C                  VECTOR, AND MADE THE ARROWHEADS NARROWER (45 DEGREES
C                  APART, RATHER THAN 60 DEGREES APART)
C
C FEBRUARY, 1984   PROVIDED A DIMENSION STATEMENT FOR A VARIABLE INTO
C                  WHICH A TEN-CHARACTER STRING WAS BEING ENCODED.  ON
C                  THE CRAY, WHEN THE ENCODE WAS DONE, A WORD FOLLOWING
C                  THE VARIABLE WAS CLOBBERED, BUT THIS APPARENTLY MADE
C                  NO DIFFERENCE.  ON AT LEAST ONE OTHER MACHINE, THE
C                  CODE BLEW UP.  (ERROR REPORTED BY GREG WOODS)
C
C JULY, 1984       CONVERTED TO FORTRAN77 AND GKS.
C
C MARCH, 1990      CORRECTED THE USE OF SET CALLS.
C
C ---------------------------------------------------------------------
      END

      PROGRAM CCPCLU
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER (K=40,N=40,LRWK=1000,LIWK=1000)
      REAL Z(K,N), RWRK(LRWK)
      INTEGER I, M, IWRK(LIWK)

      CALL GETDAT (Z, K, M, N) 
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
      
      CALL CPSETI('CLS - CONTOUR LEVEL SELECTION FLAG',0)
      CALL CPSETI('NCL - NUMBER OF CONTOUR LEVELS',40)
      DO 11 I=1,40
         CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',I)
         CALL CPSETR ('CLV - CONTOUR LEVEL VALUES',5.0*REAL(I)-15.)
         CALL CPSETI ('CLU - CONTOUR LEVEL USE FLAG',MOD(I,4))
 11   CONTINUE
C
C Call conpack normally
C
      CALL CPRECT(Z,K,M,N,RWRK,LRWK,IWRK,LIWK)
      CALL CPBACK(Z, RWRK, IWRK)
      CALL CPCLDR(Z,RWRK,IWRK)
C
C Close frame
C
      CALL FRAME
C
C Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      
      STOP
      END

      SUBROUTINE GETDAT (Z, K, M, N)
      INTEGER I,J,K,M,N
      REAL Z(K,N)

      M=K
      DO 10, I=1,M
         DO 20, J=1,N
            Z(I,J)= 10.E-5*(-16.*REAL(I**2*J) +
     1           34*REAL(I*J**2) - REAL(6*I) + 93.)
 20      CONTINUE
 10   CONTINUE

      RETURN
      END

*DECK D1MACH
      DOUBLE PRECISION FUNCTION D1MACH (I)
C***BEGIN PROLOGUE  D1MACH
C***PURPOSE  Return floating point machine dependent constants.
C***LIBRARY   SLATEC
C***CATEGORY  R1
C***TYPE      DOUBLE PRECISION (R1MACH-S, D1MACH-D)
C***KEYWORDS  MACHINE CONSTANTS
C***AUTHOR  Fox, P. A., (Bell Labs)
C           Hall, A. D., (Bell Labs)
C           Schryer, N. L., (Bell Labs)
C***DESCRIPTION
C
C   D1MACH can be used to obtain machine-dependent parameters for the
C   local machine environment.  It is a function subprogram with one
C   (input) argument, and can be referenced as follows:
C
C        D = D1MACH(I)
C
C   where I=1,...,5.  The (output) value of D above is determined by
C   the (input) value of I.  The results for various values of I are
C   discussed below.
C
C   D1MACH( 1) = B**(EMIN-1), the smallest positive magnitude.
C   D1MACH( 2) = B**EMAX*(1 - B**(-T)), the largest magnitude.
C   D1MACH( 3) = B**(-T), the smallest relative spacing.
C   D1MACH( 4) = B**(1-T), the largest relative spacing.
C   D1MACH( 5) = LOG10(B)
C
C   Assume double precision numbers are represented in the T-digit,
C   base-B form
C
C              sign (B**E)*( (X(1)/B) + ... + (X(T)/B**T) )
C
C   where 0 .LE. X(I) .LT. B for I=1,...,T, 0 .LT. X(1), and
C   EMIN .LE. E .LE. EMAX.
C
C   The values of B, T, EMIN and EMAX are provided in I1MACH as
C   follows:
C   I1MACH(10) = B, the base.
C   I1MACH(14) = T, the number of base-B digits.
C   I1MACH(15) = EMIN, the smallest exponent E.
C   I1MACH(16) = EMAX, the largest exponent E.
C
C   To alter this function for a particular environment, the desired
C   set of DATA statements should be activated by removing the C from
C   column 1.  Also, the values of D1MACH(1) - D1MACH(4) should be
C   checked for consistency with the local operating system.
C
C***REFERENCES  P. A. Fox, A. D. Hall and N. L. Schryer, Framework for
C                 a portable library, ACM Transactions on Mathematical
C                 Software 4, 2 (June 1978), pp. 177-188.
C***ROUTINES CALLED  XERMSG
C***REVISION HISTORY  (YYMMDD)
C   750101  DATE WRITTEN
C   890213  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C   900618  Added DEC RISC constants.  (WRB)
C   900723  Added IBM RS 6000 constants.  (WRB)
C   900911  Added SUN 386i constants.  (WRB)
C   910710  Added HP 730 constants.  (SMR)
C   911114  Added Convex IEEE constants.  (WRB)
C   920121  Added SUN -r8 compiler option constants.  (WRB)
C   920229  Added Touchstone Delta i860 constants.  (WRB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C   920625  Added CONVEX -p8 and -pd8 compiler option constants.
C           (BKS, WRB)
C   930201  Added DEC Alpha and SGI constants.  (RWC and WRB)
C***END PROLOGUE  D1MACH
C
      INTEGER SMALL(4)
      INTEGER LARGE(4)
      INTEGER RIGHT(4)
      INTEGER DIVER(4)
      INTEGER LOG10(4)
C
      DOUBLE PRECISION DMACH(5)
      SAVE DMACH
C
      EQUIVALENCE (DMACH(1),SMALL(1))
      EQUIVALENCE (DMACH(2),LARGE(1))
      EQUIVALENCE (DMACH(3),RIGHT(1))
      EQUIVALENCE (DMACH(4),DIVER(1))
      EQUIVALENCE (DMACH(5),LOG10(1))
C
C     MACHINE CONSTANTS FOR THE AMIGA
C     ABSOFT FORTRAN COMPILER USING THE 68020/68881 COMPILER OPTION
C
C     DATA SMALL(1), SMALL(2) / Z'00100000', Z'00000000' /
C     DATA LARGE(1), LARGE(2) / Z'7FEFFFFF', Z'FFFFFFFF' /
C     DATA RIGHT(1), RIGHT(2) / Z'3CA00000', Z'00000000' /
C     DATA DIVER(1), DIVER(2) / Z'3CB00000', Z'00000000' /
C     DATA LOG10(1), LOG10(2) / Z'3FD34413', Z'509F79FF' /
C
C     MACHINE CONSTANTS FOR THE AMIGA
C     ABSOFT FORTRAN COMPILER USING SOFTWARE FLOATING POINT
C
C     DATA SMALL(1), SMALL(2) / Z'00100000', Z'00000000' /
C     DATA LARGE(1), LARGE(2) / Z'7FDFFFFF', Z'FFFFFFFF' /
C     DATA RIGHT(1), RIGHT(2) / Z'3CA00000', Z'00000000' /
C     DATA DIVER(1), DIVER(2) / Z'3CB00000', Z'00000000' /
C     DATA LOG10(1), LOG10(2) / Z'3FD34413', Z'509F79FF' /
C
C     MACHINE CONSTANTS FOR THE APOLLO
C
C     DATA SMALL(1), SMALL(2) / 16#00100000, 16#00000000 /
C     DATA LARGE(1), LARGE(2) / 16#7FFFFFFF, 16#FFFFFFFF /
C     DATA RIGHT(1), RIGHT(2) / 16#3CA00000, 16#00000000 /
C     DATA DIVER(1), DIVER(2) / 16#3CB00000, 16#00000000 /
C     DATA LOG10(1), LOG10(2) / 16#3FD34413, 16#509F79FF /
C
C     MACHINE CONSTANTS FOR THE BURROUGHS 1700 SYSTEM
C
C     DATA SMALL(1) / ZC00800000 /
C     DATA SMALL(2) / Z000000000 /
C     DATA LARGE(1) / ZDFFFFFFFF /
C     DATA LARGE(2) / ZFFFFFFFFF /
C     DATA RIGHT(1) / ZCC5800000 /
C     DATA RIGHT(2) / Z000000000 /
C     DATA DIVER(1) / ZCC6800000 /
C     DATA DIVER(2) / Z000000000 /
C     DATA LOG10(1) / ZD00E730E7 /
C     DATA LOG10(2) / ZC77800DC0 /
C
C     MACHINE CONSTANTS FOR THE BURROUGHS 5700 SYSTEM
C
C     DATA SMALL(1) / O1771000000000000 /
C     DATA SMALL(2) / O0000000000000000 /
C     DATA LARGE(1) / O0777777777777777 /
C     DATA LARGE(2) / O0007777777777777 /
C     DATA RIGHT(1) / O1461000000000000 /
C     DATA RIGHT(2) / O0000000000000000 /
C     DATA DIVER(1) / O1451000000000000 /
C     DATA DIVER(2) / O0000000000000000 /
C     DATA LOG10(1) / O1157163034761674 /
C     DATA LOG10(2) / O0006677466732724 /
C
C     MACHINE CONSTANTS FOR THE BURROUGHS 6700/7700 SYSTEMS
C
C     DATA SMALL(1) / O1771000000000000 /
C     DATA SMALL(2) / O7770000000000000 /
C     DATA LARGE(1) / O0777777777777777 /
C     DATA LARGE(2) / O7777777777777777 /
C     DATA RIGHT(1) / O1461000000000000 /
C     DATA RIGHT(2) / O0000000000000000 /
C     DATA DIVER(1) / O1451000000000000 /
C     DATA DIVER(2) / O0000000000000000 /
C     DATA LOG10(1) / O1157163034761674 /
C     DATA LOG10(2) / O0006677466732724 /
C
C     MACHINE CONSTANTS FOR THE CDC 170/180 SERIES USING NOS/VE
C
C     DATA SMALL(1) / Z"3001800000000000" /
C     DATA SMALL(2) / Z"3001000000000000" /
C     DATA LARGE(1) / Z"4FFEFFFFFFFFFFFE" /
C     DATA LARGE(2) / Z"4FFE000000000000" /
C     DATA RIGHT(1) / Z"3FD2800000000000" /
C     DATA RIGHT(2) / Z"3FD2000000000000" /
C     DATA DIVER(1) / Z"3FD3800000000000" /
C     DATA DIVER(2) / Z"3FD3000000000000" /
C     DATA LOG10(1) / Z"3FFF9A209A84FBCF" /
C     DATA LOG10(2) / Z"3FFFF7988F8959AC" /
C
C     MACHINE CONSTANTS FOR THE CDC 6000/7000 SERIES
C
C     DATA SMALL(1) / 00564000000000000000B /
C     DATA SMALL(2) / 00000000000000000000B /
C     DATA LARGE(1) / 37757777777777777777B /
C     DATA LARGE(2) / 37157777777777777777B /
C     DATA RIGHT(1) / 15624000000000000000B /
C     DATA RIGHT(2) / 00000000000000000000B /
C     DATA DIVER(1) / 15634000000000000000B /
C     DATA DIVER(2) / 00000000000000000000B /
C     DATA LOG10(1) / 17164642023241175717B /
C     DATA LOG10(2) / 16367571421742254654B /
C
C     MACHINE CONSTANTS FOR THE CELERITY C1260
C
C     DATA SMALL(1), SMALL(2) / Z'00100000', Z'00000000' /
C     DATA LARGE(1), LARGE(2) / Z'7FEFFFFF', Z'FFFFFFFF' /
C     DATA RIGHT(1), RIGHT(2) / Z'3CA00000', Z'00000000' /
C     DATA DIVER(1), DIVER(2) / Z'3CB00000', Z'00000000' /
C     DATA LOG10(1), LOG10(2) / Z'3FD34413', Z'509F79FF' /
C
C     MACHINE CONSTANTS FOR THE CONVEX
C     USING THE -fn OR -pd8 COMPILER OPTION
C
C     DATA DMACH(1) / Z'0010000000000000' /
C     DATA DMACH(2) / Z'7FFFFFFFFFFFFFFF' /
C     DATA DMACH(3) / Z'3CC0000000000000' /
C     DATA DMACH(4) / Z'3CD0000000000000' /
C     DATA DMACH(5) / Z'3FF34413509F79FF' /
C
C     MACHINE CONSTANTS FOR THE CONVEX
C     USING THE -fi COMPILER OPTION
C
C     DATA DMACH(1) / Z'0010000000000000' /
C     DATA DMACH(2) / Z'7FEFFFFFFFFFFFFF' /
C     DATA DMACH(3) / Z'3CA0000000000000' /
C     DATA DMACH(4) / Z'3CB0000000000000' /
C     DATA DMACH(5) / Z'3FD34413509F79FF' /
C
C     MACHINE CONSTANTS FOR THE CONVEX
C     USING THE -p8 COMPILER OPTION
C
C     DATA DMACH(1) / Z'00010000000000000000000000000000' /
C     DATA DMACH(2) / Z'7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF' /
C     DATA DMACH(3) / Z'3F900000000000000000000000000000' /
C     DATA DMACH(4) / Z'3F910000000000000000000000000000' /
C     DATA DMACH(5) / Z'3FFF34413509F79FEF311F12B35816F9' /
C
C     MACHINE CONSTANTS FOR THE CRAY
C
C     DATA SMALL(1) / 201354000000000000000B /
C     DATA SMALL(2) / 000000000000000000000B /
C     DATA LARGE(1) / 577767777777777777777B /
C     DATA LARGE(2) / 000007777777777777774B /
C     DATA RIGHT(1) / 376434000000000000000B /
C     DATA RIGHT(2) / 000000000000000000000B /
C     DATA DIVER(1) / 376444000000000000000B /
C     DATA DIVER(2) / 000000000000000000000B /
C     DATA LOG10(1) / 377774642023241175717B /
C     DATA LOG10(2) / 000007571421742254654B /
C
C     MACHINE CONSTANTS FOR THE DATA GENERAL ECLIPSE S/200
C     NOTE - IT MAY BE APPROPRIATE TO INCLUDE THE FOLLOWING CARD -
C     STATIC DMACH(5)
C
C     DATA SMALL /    20K, 3*0 /
C     DATA LARGE / 77777K, 3*177777K /
C     DATA RIGHT / 31420K, 3*0 /
C     DATA DIVER / 32020K, 3*0 /
C     DATA LOG10 / 40423K, 42023K, 50237K, 74776K /
C
C     MACHINE CONSTANTS FOR THE DEC ALPHA
C     USING G_FLOAT
C
C     DATA DMACH(1) / '0000000000000010'X /
C     DATA DMACH(2) / 'FFFFFFFFFFFF7FFF'X /
C     DATA DMACH(3) / '0000000000003CC0'X /
C     DATA DMACH(4) / '0000000000003CD0'X /
C     DATA DMACH(5) / '79FF509F44133FF3'X /
C
C     MACHINE CONSTANTS FOR THE DEC ALPHA
C     USING IEEE_FORMAT
C
C     DATA DMACH(1) / '0010000000000000'X /
C     DATA DMACH(2) / '7FEFFFFFFFFFFFFF'X /
C     DATA DMACH(3) / '3CA0000000000000'X /
C     DATA DMACH(4) / '3CB0000000000000'X /
C     DATA DMACH(5) / '3FD34413509F79FF'X /
C
C     MACHINE CONSTANTS FOR THE DEC RISC
C
C     DATA SMALL(1), SMALL(2) / Z'00000000', Z'00100000'/
C     DATA LARGE(1), LARGE(2) / Z'FFFFFFFF', Z'7FEFFFFF'/
C     DATA RIGHT(1), RIGHT(2) / Z'00000000', Z'3CA00000'/
C     DATA DIVER(1), DIVER(2) / Z'00000000', Z'3CB00000'/
C     DATA LOG10(1), LOG10(2) / Z'509F79FF', Z'3FD34413'/
C
C     MACHINE CONSTANTS FOR THE DEC VAX
C     USING D_FLOATING
C     (EXPRESSED IN INTEGER AND HEXADECIMAL)
C     THE HEX FORMAT BELOW MAY NOT BE SUITABLE FOR UNIX SYSTEMS
C     THE INTEGER FORMAT SHOULD BE OK FOR UNIX SYSTEMS
C
C     DATA SMALL(1), SMALL(2) /        128,           0 /
C     DATA LARGE(1), LARGE(2) /     -32769,          -1 /
C     DATA RIGHT(1), RIGHT(2) /       9344,           0 /
C     DATA DIVER(1), DIVER(2) /       9472,           0 /
C     DATA LOG10(1), LOG10(2) /  546979738,  -805796613 /
C
C     DATA SMALL(1), SMALL(2) / Z00000080, Z00000000 /
C     DATA LARGE(1), LARGE(2) / ZFFFF7FFF, ZFFFFFFFF /
C     DATA RIGHT(1), RIGHT(2) / Z00002480, Z00000000 /
C     DATA DIVER(1), DIVER(2) / Z00002500, Z00000000 /
C     DATA LOG10(1), LOG10(2) / Z209A3F9A, ZCFF884FB /
C
C     MACHINE CONSTANTS FOR THE DEC VAX
C     USING G_FLOATING
C     (EXPRESSED IN INTEGER AND HEXADECIMAL)
C     THE HEX FORMAT BELOW MAY NOT BE SUITABLE FOR UNIX SYSTEMS
C     THE INTEGER FORMAT SHOULD BE OK FOR UNIX SYSTEMS
C
C     DATA SMALL(1), SMALL(2) /         16,           0 /
C     DATA LARGE(1), LARGE(2) /     -32769,          -1 /
C     DATA RIGHT(1), RIGHT(2) /      15552,           0 /
C     DATA DIVER(1), DIVER(2) /      15568,           0 /
C     DATA LOG10(1), LOG10(2) /  1142112243, 2046775455 /
C
C     DATA SMALL(1), SMALL(2) / Z00000010, Z00000000 /
C     DATA LARGE(1), LARGE(2) / ZFFFF7FFF, ZFFFFFFFF /
C     DATA RIGHT(1), RIGHT(2) / Z00003CC0, Z00000000 /
C     DATA DIVER(1), DIVER(2) / Z00003CD0, Z00000000 /
C     DATA LOG10(1), LOG10(2) / Z44133FF3, Z79FF509F /
C
C     MACHINE CONSTANTS FOR THE ELXSI 6400
C     (ASSUMING REAL*8 IS THE DEFAULT DOUBLE PRECISION)
C
C     DATA SMALL(1), SMALL(2) / '00100000'X,'00000000'X /
C     DATA LARGE(1), LARGE(2) / '7FEFFFFF'X,'FFFFFFFF'X /
C     DATA RIGHT(1), RIGHT(2) / '3CB00000'X,'00000000'X /
C     DATA DIVER(1), DIVER(2) / '3CC00000'X,'00000000'X /
C     DATA LOG10(1), LOG10(2) / '3FD34413'X,'509F79FF'X /
C
C     MACHINE CONSTANTS FOR THE HARRIS 220
C
C     DATA SMALL(1), SMALL(2) / '20000000, '00000201 /
C     DATA LARGE(1), LARGE(2) / '37777777, '37777577 /
C     DATA RIGHT(1), RIGHT(2) / '20000000, '00000333 /
C     DATA DIVER(1), DIVER(2) / '20000000, '00000334 /
C     DATA LOG10(1), LOG10(2) / '23210115, '10237777 /
C
C     MACHINE CONSTANTS FOR THE HONEYWELL 600/6000 SERIES
C
C     DATA SMALL(1), SMALL(2) / O402400000000, O000000000000 /
C     DATA LARGE(1), LARGE(2) / O376777777777, O777777777777 /
C     DATA RIGHT(1), RIGHT(2) / O604400000000, O000000000000 /
C     DATA DIVER(1), DIVER(2) / O606400000000, O000000000000 /
C     DATA LOG10(1), LOG10(2) / O776464202324, O117571775714 /
C
C     MACHINE CONSTANTS FOR THE HP 730
C
C     DATA DMACH(1) / Z'0010000000000000' /
C     DATA DMACH(2) / Z'7FEFFFFFFFFFFFFF' /
C     DATA DMACH(3) / Z'3CA0000000000000' /
C     DATA DMACH(4) / Z'3CB0000000000000' /
C     DATA DMACH(5) / Z'3FD34413509F79FF' /
C
C     MACHINE CONSTANTS FOR THE HP 2100
C     THREE WORD DOUBLE PRECISION OPTION WITH FTN4
C
C     DATA SMALL(1), SMALL(2), SMALL(3) / 40000B,       0,       1 /
C     DATA LARGE(1), LARGE(2), LARGE(3) / 77777B, 177777B, 177776B /
C     DATA RIGHT(1), RIGHT(2), RIGHT(3) / 40000B,       0,    265B /
C     DATA DIVER(1), DIVER(2), DIVER(3) / 40000B,       0,    276B /
C     DATA LOG10(1), LOG10(2), LOG10(3) / 46420B,  46502B,  77777B /
C
C     MACHINE CONSTANTS FOR THE HP 2100
C     FOUR WORD DOUBLE PRECISION OPTION WITH FTN4
C
C     DATA SMALL(1), SMALL(2) /  40000B,       0 /
C     DATA SMALL(3), SMALL(4) /       0,       1 /
C     DATA LARGE(1), LARGE(2) /  77777B, 177777B /
C     DATA LARGE(3), LARGE(4) / 177777B, 177776B /
C     DATA RIGHT(1), RIGHT(2) /  40000B,       0 /
C     DATA RIGHT(3), RIGHT(4) /       0,    225B /
C     DATA DIVER(1), DIVER(2) /  40000B,       0 /
C     DATA DIVER(3), DIVER(4) /       0,    227B /
C     DATA LOG10(1), LOG10(2) /  46420B,  46502B /
C     DATA LOG10(3), LOG10(4) /  76747B, 176377B /
C
C     MACHINE CONSTANTS FOR THE HP 9000
C
C     DATA SMALL(1), SMALL(2) / 00040000000B, 00000000000B /
C     DATA LARGE(1), LARGE(2) / 17737777777B, 37777777777B /
C     DATA RIGHT(1), RIGHT(2) / 07454000000B, 00000000000B /
C     DATA DIVER(1), DIVER(2) / 07460000000B, 00000000000B /
C     DATA LOG10(1), LOG10(2) / 07764642023B, 12047674777B /
C
C     MACHINE CONSTANTS FOR THE IBM 360/370 SERIES,
C     THE XEROX SIGMA 5/7/9, THE SEL SYSTEMS 85/86, AND
C     THE PERKIN ELMER (INTERDATA) 7/32.
C
C     DATA SMALL(1), SMALL(2) / Z00100000, Z00000000 /
C     DATA LARGE(1), LARGE(2) / Z7FFFFFFF, ZFFFFFFFF /
C     DATA RIGHT(1), RIGHT(2) / Z33100000, Z00000000 /
C     DATA DIVER(1), DIVER(2) / Z34100000, Z00000000 /
C     DATA LOG10(1), LOG10(2) / Z41134413, Z509F79FF /
C
C     MACHINE CONSTANTS FOR THE IBM PC
C     ASSUMES THAT ALL ARITHMETIC IS DONE IN DOUBLE PRECISION
C     ON 8088, I.E., NOT IN 80 BIT FORM FOR THE 8087.
C
C     DATA SMALL(1) / 2.23D-308  /
C     DATA LARGE(1) / 1.79D+308  /
C     DATA RIGHT(1) / 1.11D-16   /
C     DATA DIVER(1) / 2.22D-16   /
C     DATA LOG10(1) / 0.301029995663981195D0 /
C
C     MACHINE CONSTANTS FOR THE IBM RS 6000
C
C     DATA DMACH(1) / Z'0010000000000000' /
C     DATA DMACH(2) / Z'7FEFFFFFFFFFFFFF' /
C     DATA DMACH(3) / Z'3CA0000000000000' /
C     DATA DMACH(4) / Z'3CB0000000000000' /
C     DATA DMACH(5) / Z'3FD34413509F79FF' /
C
C     MACHINE CONSTANTS FOR THE INTEL i860
C
C     DATA DMACH(1) / Z'0010000000000000' /
C     DATA DMACH(2) / Z'7FEFFFFFFFFFFFFF' /
C     DATA DMACH(3) / Z'3CA0000000000000' /
C     DATA DMACH(4) / Z'3CB0000000000000' /
C     DATA DMACH(5) / Z'3FD34413509F79FF' /
C
C     MACHINE CONSTANTS FOR THE PDP-10 (KA PROCESSOR)
C
C     DATA SMALL(1), SMALL(2) / "033400000000, "000000000000 /
C     DATA LARGE(1), LARGE(2) / "377777777777, "344777777777 /
C     DATA RIGHT(1), RIGHT(2) / "113400000000, "000000000000 /
C     DATA DIVER(1), DIVER(2) / "114400000000, "000000000000 /
C     DATA LOG10(1), LOG10(2) / "177464202324, "144117571776 /
C
C     MACHINE CONSTANTS FOR THE PDP-10 (KI PROCESSOR)
C
C     DATA SMALL(1), SMALL(2) / "000400000000, "000000000000 /
C     DATA LARGE(1), LARGE(2) / "377777777777, "377777777777 /
C     DATA RIGHT(1), RIGHT(2) / "103400000000, "000000000000 /
C     DATA DIVER(1), DIVER(2) / "104400000000, "000000000000 /
C     DATA LOG10(1), LOG10(2) / "177464202324, "476747767461 /
C
C     MACHINE CONSTANTS FOR PDP-11 FORTRAN SUPPORTING
C     32-BIT INTEGERS (EXPRESSED IN INTEGER AND OCTAL).
C
C     DATA SMALL(1), SMALL(2) /    8388608,           0 /
C     DATA LARGE(1), LARGE(2) / 2147483647,          -1 /
C     DATA RIGHT(1), RIGHT(2) /  612368384,           0 /
C     DATA DIVER(1), DIVER(2) /  620756992,           0 /
C     DATA LOG10(1), LOG10(2) / 1067065498, -2063872008 /
C
C     DATA SMALL(1), SMALL(2) / O00040000000, O00000000000 /
C     DATA LARGE(1), LARGE(2) / O17777777777, O37777777777 /
C     DATA RIGHT(1), RIGHT(2) / O04440000000, O00000000000 /
C     DATA DIVER(1), DIVER(2) / O04500000000, O00000000000 /
C     DATA LOG10(1), LOG10(2) / O07746420232, O20476747770 /
C
C     MACHINE CONSTANTS FOR PDP-11 FORTRAN SUPPORTING
C     16-BIT INTEGERS (EXPRESSED IN INTEGER AND OCTAL).
C
C     DATA SMALL(1), SMALL(2) /    128,      0 /
C     DATA SMALL(3), SMALL(4) /      0,      0 /
C     DATA LARGE(1), LARGE(2) /  32767,     -1 /
C     DATA LARGE(3), LARGE(4) /     -1,     -1 /
C     DATA RIGHT(1), RIGHT(2) /   9344,      0 /
C     DATA RIGHT(3), RIGHT(4) /      0,      0 /
C     DATA DIVER(1), DIVER(2) /   9472,      0 /
C     DATA DIVER(3), DIVER(4) /      0,      0 /
C     DATA LOG10(1), LOG10(2) /  16282,   8346 /
C     DATA LOG10(3), LOG10(4) / -31493, -12296 /
C
C     DATA SMALL(1), SMALL(2) / O000200, O000000 /
C     DATA SMALL(3), SMALL(4) / O000000, O000000 /
C     DATA LARGE(1), LARGE(2) / O077777, O177777 /
C     DATA LARGE(3), LARGE(4) / O177777, O177777 /
C     DATA RIGHT(1), RIGHT(2) / O022200, O000000 /
C     DATA RIGHT(3), RIGHT(4) / O000000, O000000 /
C     DATA DIVER(1), DIVER(2) / O022400, O000000 /
C     DATA DIVER(3), DIVER(4) / O000000, O000000 /
C     DATA LOG10(1), LOG10(2) / O037632, O020232 /
C     DATA LOG10(3), LOG10(4) / O102373, O147770 /
C
C     MACHINE CONSTANTS FOR THE SILICON GRAPHICS
C
C     DATA SMALL(1), SMALL(2) / Z'00100000', Z'00000000' /
C     DATA LARGE(1), LARGE(2) / Z'7FEFFFFF', Z'FFFFFFFF' /
C     DATA RIGHT(1), RIGHT(2) / Z'3CA00000', Z'00000000' /
C     DATA DIVER(1), DIVER(2) / Z'3CB00000', Z'00000000' /
C     DATA LOG10(1), LOG10(2) / Z'3FD34413', Z'509F79FF' /
C
C     MACHINE CONSTANTS FOR THE SUN
C
C     DATA DMACH(1) / Z'0010000000000000' /
C     DATA DMACH(2) / Z'7FEFFFFFFFFFFFFF' /
C     DATA DMACH(3) / Z'3CA0000000000000' /
C     DATA DMACH(4) / Z'3CB0000000000000' /
C     DATA DMACH(5) / Z'3FD34413509F79FF' /
C
C     MACHINE CONSTANTS FOR THE SUN
C     USING THE -r8 COMPILER OPTION
C
C     DATA DMACH(1) / Z'00010000000000000000000000000000' /
C     DATA DMACH(2) / Z'7FFEFFFFFFFFFFFFFFFFFFFFFFFFFFFF' /
C     DATA DMACH(3) / Z'3F8E0000000000000000000000000000' /
C     DATA DMACH(4) / Z'3F8F0000000000000000000000000000' /
C     DATA DMACH(5) / Z'3FFD34413509F79FEF311F12B35816F9' /
C
C     MACHINE CONSTANTS FOR THE SUN 386i
C
C     DATA SMALL(1), SMALL(2) / Z'FFFFFFFD', Z'000FFFFF' /
C     DATA LARGE(1), LARGE(2) / Z'FFFFFFB0', Z'7FEFFFFF' /
C     DATA RIGHT(1), RIGHT(2) / Z'000000B0', Z'3CA00000' /
C     DATA DIVER(1), DIVER(2) / Z'FFFFFFCB', Z'3CAFFFFF'
C     DATA LOG10(1), LOG10(2) / Z'509F79E9', Z'3FD34413' /
C
C     MACHINE CONSTANTS FOR THE UNIVAC 1100 SERIES FTN COMPILER
C
C     DATA SMALL(1), SMALL(2) / O000040000000, O000000000000 /
C     DATA LARGE(1), LARGE(2) / O377777777777, O777777777777 /
C     DATA RIGHT(1), RIGHT(2) / O170540000000, O000000000000 /
C     DATA DIVER(1), DIVER(2) / O170640000000, O000000000000 /
C     DATA LOG10(1), LOG10(2) / O177746420232, O411757177572 /
C
C***FIRST EXECUTABLE STATEMENT  D1MACH

      DATA DMACH(1) / 2.2250738585072014D-308 /
      DATA DMACH(2) / 1.7976931348623157D+308 /
      DATA DMACH(3) / 1.1102230246251565D-16 /
      DATA DMACH(4) / 2.2204460492503131D-16 /
      DATA DMACH(5) / 0.301029995663981195D0 /
 
C      DATA SMALL(2), SMALL(1) / Z'00100000', Z'00000000' /
C      DATA LARGE(2), LARGE(1) / Z'7FEFFFFF', Z'FFFFFFFF' /
C      DATA RIGHT(2), RIGHT(1) / Z'3CA00000', Z'00000000' /
C      DATA DIVER(2), DIVER(1) / Z'3CB00000', Z'00000000' /
C      DATA LOG10(2), LOG10(1) / Z'3FD34413', Z'509F79FF' /

      IF (I .LT. 1 .OR. I .GT. 5) WRITE(6,500)
  500 FORMAT(' ERROR IN D1MACH - I OUT OF BOUNDS')
C
      D1MACH = DMACH(I)
      RETURN
C
      END

      SUBROUTINE CSPTRI( UPLO, N, AP, IPIV, WORK, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER          UPLO
      INTEGER            INFO, N
*     ..
*     .. Array Arguments ..
      INTEGER            IPIV( * )
      COMPLEX            AP( * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  CSPTRI computes the inverse of a complex symmetric indefinite matrix
*  A in packed storage using the factorization A = U*D*U**T or
*  A = L*D*L**T computed by CSPTRF.
*
*  Arguments
*  =========
*
*  UPLO    (input) CHARACTER*1
*          Specifies whether the details of the factorization are stored
*          as an upper or lower triangular matrix.
*          = 'U':  Upper triangular, form is A = U*D*U**T;
*          = 'L':  Lower triangular, form is A = L*D*L**T.
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  AP      (input/output) COMPLEX array, dimension (N*(N+1)/2)
*          On entry, the block diagonal matrix D and the multipliers
*          used to obtain the factor U or L as computed by CSPTRF,
*          stored as a packed triangular matrix.
*
*          On exit, if INFO = 0, the (symmetric) inverse of the original
*          matrix, stored as a packed triangular matrix. The j-th column
*          of inv(A) is stored in the array AP as follows:
*          if UPLO = 'U', AP(i + (j-1)*j/2) = inv(A)(i,j) for 1<=i<=j;
*          if UPLO = 'L',
*             AP(i + (j-1)*(2n-j)/2) = inv(A)(i,j) for j<=i<=n.
*
*  IPIV    (input) INTEGER array, dimension (N)
*          Details of the interchanges and the block structure of D
*          as determined by CSPTRF.
*
*  WORK    (workspace) COMPLEX array, dimension (N)
*
*  INFO    (output) INTEGER
*          = 0: successful exit
*          < 0: if INFO = -i, the i-th argument had an illegal value
*          > 0: if INFO = i, D(i,i) = 0; the matrix is singular and its
*               inverse could not be computed.
*
*  =====================================================================
*
*     .. Parameters ..
      COMPLEX            ONE, ZERO
      PARAMETER          ( ONE = ( 1.0E+0, 0.0E+0 ),
     $                   ZERO = ( 0.0E+0, 0.0E+0 ) )
*     ..
*     .. Local Scalars ..
      LOGICAL            UPPER
      INTEGER            J, K, KC, KCNEXT, KP, KPC, KSTEP, KX, NPP
      COMPLEX            AK, AKKP1, AKP1, D, T, TEMP
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      COMPLEX            CDOTU
      EXTERNAL           LSAME, CDOTU
*     ..
*     .. External Subroutines ..
      EXTERNAL           CCOPY, CSPMV, CSWAP, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      UPPER = LSAME( UPLO, 'U' )
      IF( .NOT.UPPER .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'CSPTRI', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
*
*     Check that the diagonal matrix D is nonsingular.
*
      IF( UPPER ) THEN
*
*        Upper triangular storage: examine D from bottom to top
*
         KP = N*( N+1 ) / 2
         DO 10 INFO = N, 1, -1
            IF( IPIV( INFO ).GT.0 .AND. AP( KP ).EQ.ZERO )
     $         RETURN
            KP = KP - INFO
   10    CONTINUE
      ELSE
*
*        Lower triangular storage: examine D from top to bottom.
*
         KP = 1
         DO 20 INFO = 1, N
            IF( IPIV( INFO ).GT.0 .AND. AP( KP ).EQ.ZERO )
     $         RETURN
            KP = KP + N - INFO + 1
   20    CONTINUE
      END IF
      INFO = 0
*
      IF( UPPER ) THEN
*
*        Compute inv(A) from the factorization A = U*D*U'.
*
*        K is the main loop index, increasing from 1 to N in steps of
*        1 or 2, depending on the size of the diagonal blocks.
*
         K = 1
         KC = 1
   30    CONTINUE
*
*        If K > N, exit from loop.
*
         IF( K.GT.N )
     $      GO TO 50
*
         KCNEXT = KC + K
         IF( IPIV( K ).GT.0 ) THEN
*
*           1 x 1 diagonal block
*
*           Invert the diagonal block.
*
            AP( KC+K-1 ) = ONE / AP( KC+K-1 )
*
*           Compute column K of the inverse.
*
            IF( K.GT.1 ) THEN
               CALL CCOPY( K-1, AP( KC ), 1, WORK, 1 )
               CALL CSPMV( UPLO, K-1, -ONE, AP, WORK, 1, ZERO, AP( KC ),
     $                     1 )
               AP( KC+K-1 ) = AP( KC+K-1 ) -
     $                        CDOTU( K-1, WORK, 1, AP( KC ), 1 )
            END IF
            KSTEP = 1
         ELSE
*
*           2 x 2 diagonal block
*
*           Invert the diagonal block.
*
            T = AP( KCNEXT+K-1 )
            AK = AP( KC+K-1 ) / T
            AKP1 = AP( KCNEXT+K ) / T
            AKKP1 = AP( KCNEXT+K-1 ) / T
            D = T*( AK*AKP1-ONE )
            AP( KC+K-1 ) = AKP1 / D
            AP( KCNEXT+K ) = AK / D
            AP( KCNEXT+K-1 ) = -AKKP1 / D
*
*           Compute columns K and K+1 of the inverse.
*
            IF( K.GT.1 ) THEN
               CALL CCOPY( K-1, AP( KC ), 1, WORK, 1 )
               CALL CSPMV( UPLO, K-1, -ONE, AP, WORK, 1, ZERO, AP( KC ),
     $                     1 )
               AP( KC+K-1 ) = AP( KC+K-1 ) -
     $                        CDOTU( K-1, WORK, 1, AP( KC ), 1 )
               AP( KCNEXT+K-1 ) = AP( KCNEXT+K-1 ) -
     $                            CDOTU( K-1, AP( KC ), 1, AP( KCNEXT ),
     $                            1 )
               CALL CCOPY( K-1, AP( KCNEXT ), 1, WORK, 1 )
               CALL CSPMV( UPLO, K-1, -ONE, AP, WORK, 1, ZERO,
     $                     AP( KCNEXT ), 1 )
               AP( KCNEXT+K ) = AP( KCNEXT+K ) -
     $                          CDOTU( K-1, WORK, 1, AP( KCNEXT ), 1 )
            END IF
            KSTEP = 2
            KCNEXT = KCNEXT + K + 1
         END IF
*
         KP = ABS( IPIV( K ) )
         IF( KP.NE.K ) THEN
*
*           Interchange rows and columns K and KP in the leading
*           submatrix A(1:k+1,1:k+1)
*
            KPC = ( KP-1 )*KP / 2 + 1
            CALL CSWAP( KP-1, AP( KC ), 1, AP( KPC ), 1 )
            KX = KPC + KP - 1
            DO 40 J = KP + 1, K - 1
               KX = KX + J - 1
               TEMP = AP( KC+J-1 )
               AP( KC+J-1 ) = AP( KX )
               AP( KX ) = TEMP
   40       CONTINUE
            TEMP = AP( KC+K-1 )
            AP( KC+K-1 ) = AP( KPC+KP-1 )
            AP( KPC+KP-1 ) = TEMP
            IF( KSTEP.EQ.2 ) THEN
               TEMP = AP( KC+K+K-1 )
               AP( KC+K+K-1 ) = AP( KC+K+KP-1 )
               AP( KC+K+KP-1 ) = TEMP
            END IF
         END IF
*
         K = K + KSTEP
         KC = KCNEXT
         GO TO 30
   50    CONTINUE
*
      ELSE
*
*        Compute inv(A) from the factorization A = L*D*L'.
*
*        K is the main loop index, increasing from 1 to N in steps of
*        1 or 2, depending on the size of the diagonal blocks.
*
         NPP = N*( N+1 ) / 2
         K = N
         KC = NPP
   60    CONTINUE
*
*        If K < 1, exit from loop.
*
         IF( K.LT.1 )
     $      GO TO 80
*
         KCNEXT = KC - ( N-K+2 )
         IF( IPIV( K ).GT.0 ) THEN
*
*           1 x 1 diagonal block
*
*           Invert the diagonal block.
*
            AP( KC ) = ONE / AP( KC )
*
*           Compute column K of the inverse.
*
            IF( K.LT.N ) THEN
               CALL CCOPY( N-K, AP( KC+1 ), 1, WORK, 1 )
               CALL CSPMV( UPLO, N-K, -ONE, AP( KC+N-K+1 ), WORK, 1,
     $                     ZERO, AP( KC+1 ), 1 )
               AP( KC ) = AP( KC ) - CDOTU( N-K, WORK, 1, AP( KC+1 ),
     $                    1 )
            END IF
            KSTEP = 1
         ELSE
*
*           2 x 2 diagonal block
*
*           Invert the diagonal block.
*
            T = AP( KCNEXT+1 )
            AK = AP( KCNEXT ) / T
            AKP1 = AP( KC ) / T
            AKKP1 = AP( KCNEXT+1 ) / T
            D = T*( AK*AKP1-ONE )
            AP( KCNEXT ) = AKP1 / D
            AP( KC ) = AK / D
            AP( KCNEXT+1 ) = -AKKP1 / D
*
*           Compute columns K-1 and K of the inverse.
*
            IF( K.LT.N ) THEN
               CALL CCOPY( N-K, AP( KC+1 ), 1, WORK, 1 )
               CALL CSPMV( UPLO, N-K, -ONE, AP( KC+( N-K+1 ) ), WORK, 1,
     $                     ZERO, AP( KC+1 ), 1 )
               AP( KC ) = AP( KC ) - CDOTU( N-K, WORK, 1, AP( KC+1 ),
     $                    1 )
               AP( KCNEXT+1 ) = AP( KCNEXT+1 ) -
     $                          CDOTU( N-K, AP( KC+1 ), 1,
     $                          AP( KCNEXT+2 ), 1 )
               CALL CCOPY( N-K, AP( KCNEXT+2 ), 1, WORK, 1 )
               CALL CSPMV( UPLO, N-K, -ONE, AP( KC+( N-K+1 ) ), WORK, 1,
     $                     ZERO, AP( KCNEXT+2 ), 1 )
               AP( KCNEXT ) = AP( KCNEXT ) -
     $                        CDOTU( N-K, WORK, 1, AP( KCNEXT+2 ), 1 )
            END IF
            KSTEP = 2
            KCNEXT = KCNEXT - ( N-K+3 )
         END IF
*
         KP = ABS( IPIV( K ) )
         IF( KP.NE.K ) THEN
*
*           Interchange rows and columns K and KP in the trailing
*           submatrix A(k-1:n,k-1:n)
*
            KPC = NPP - ( N-KP+1 )*( N-KP+2 ) / 2 + 1
            IF( KP.LT.N )
     $         CALL CSWAP( N-KP, AP( KC+KP-K+1 ), 1, AP( KPC+1 ), 1 )
            KX = KC + KP - K
            DO 70 J = K + 1, KP - 1
               KX = KX + N - J + 1
               TEMP = AP( KC+J-K )
               AP( KC+J-K ) = AP( KX )
               AP( KX ) = TEMP
   70       CONTINUE
            TEMP = AP( KC )
            AP( KC ) = AP( KPC )
            AP( KPC ) = TEMP
            IF( KSTEP.EQ.2 ) THEN
               TEMP = AP( KC-N+K-1 )
               AP( KC-N+K-1 ) = AP( KC-N+KP-1 )
               AP( KC-N+KP-1 ) = TEMP
            END IF
         END IF
*
         K = K - KSTEP
         KC = KCNEXT
         GO TO 60
   80    CONTINUE
      END IF
*
      RETURN
*
*     End of CSPTRI
*
      END

C
C $Id: mdpvp.f,v 1.9 2008-09-18 00:42:17 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MDPVP (UOLD,VOLD,U,V)
C
        DOUBLE PRECISION UOLD,VOLD,U,V
C
C Plot the line segment from (UOLD,VOLD) TO (U,V), using either a solid
C line or a dotted line (depending on the value of the common variable
C IDTL).
C
C Declare required common blocks.  See MAPBDX for descriptions of these
C common blocks and the variables in them.
C
        COMMON /MAPCM4/  GRDR,GRID,GRLA,GRLO,GRPO,OTOL,PDRE,PLA1,PLA2,
     +                   PLA3,PLA4,PLB1,PLB2,PLB3,PLB4,PLNO,PLTO,ROTA,
     +                   SRCH,XLOW,XROW,YBOW,YTOW,IDOT,IDSH,IDTL,ILCW,
     +                   ILTS,JPRJ,ELPF,INTF,LBLF,PRMF
        DOUBLE PRECISION GRDR,GRID,GRLA,GRLO,GRPO,OTOL,PDRE,PLA1,PLA2,
     +                   PLA3,PLA4,PLB1,PLB2,PLB3,PLB4,PLNO,PLTO,ROTA,
     +                   SRCH,XLOW,XROW,YBOW,YTOW
        INTEGER          IDOT,IDSH,IDTL,ILCW,ILTS,JPRJ
        LOGICAL          ELPF,INTF,LBLF,PRMF
        SAVE   /MAPCM4/
C
        COMMON /MAPCMA/  DATL,DBTD,DDTS,DPLT,DPSQ,DSCA,DSSQ
        DOUBLE PRECISION DATL,DBTD,DDTS,DPLT,DPSQ,DSCA,DSSQ
        SAVE   /MAPCMA/
C
        COMMON /MAPCMP/  NPTB,XPTB(50),YPTB(50)
        INTEGER          NPTB
        REAL             XPTB,YPTB
        SAVE   /MAPCMP/
C
C Declare local variables.
C
        DOUBLE PRECISION DELU,DELV,VLEN
C
C Select vector or dot mode.
C
        IF (IDTL.EQ.0) THEN
C
C Use a single vector.
C
          CALL VECTD (REAL(U),REAL(V))
          IF (ICFELL('MDPVP',1).NE.0) RETURN
C
        ELSE
C
C Use dots.  DELU and DELV are the u and v components of the vector
C joining (UOLD,VOLD) to (U,V) and VLEN is the length of the vector.
C
          DELU=U-UOLD
          DELV=V-VOLD
C
          VLEN=SQRT(DELU*DELU+DELV*DELV)
C
C Now distribute dots along the vector.  The first one is spaced just
C far enough along it (DATL units) to be DBTD units away from the last
C dot on the previous vector and the rest are DBTD units apart.
C
  101     IF (DATL.LT.VLEN) THEN
            IF (NPTB.GE.50) THEN
              CALL POINTS (XPTB,YPTB,NPTB,0,0)
              IF (ICFELL('MDPVP',2).NE.0) RETURN
              NPTB=0
            END IF
            NPTB=NPTB+1
            XPTB(NPTB)=REAL(UOLD+(DATL/VLEN)*DELU)
            YPTB(NPTB)=REAL(VOLD+(DATL/VLEN)*DELV)
            DATL=DATL+DBTD
            GO TO 101
          END IF
C
C Set DATL for the next call.
C
          DATL=DATL-VLEN
C
        END IF
C
C Done.
C
        RETURN
C
      END

C
C $Id: idgtcp.f,v 1.4 2008-07-27 00:17:30 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE IDGTCP (X1,Y1,X2,Y2,X3,Y3,XC,YC)
C
C This subroutine, given the coordinates of three points in the plane -
C (X1,Y1), (X2,Y2), and (X3,Y3) - returns the coordinates of the center
C of the circle passing through those three points: (XC,YC).
C
        A=2.*(X1-X2)
        B=2.*(Y1-Y2)
        C=X1*X1-X2*X2+Y1*Y1-Y2*Y2
        D=2.*(X1-X3)
        E=2.*(Y1-Y3)
        F=X1*X1-X3*X3+Y1*Y1-Y3*Y3
        XC=(C*E-B*F)/(A*E-B*D)
        YC=(C*D-A*F)/(B*D-A*E)
C
        RETURN
C
      END

      PROGRAM FSRSRFAC
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C INVOKE DEMO DRIVER
C
      CALL TSRFAC(IWKID,IERR)
C
C     DEACTIVATE AND CLOSE WORKSTATION, CLOSE GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END
C
      SUBROUTINE TSRFAC (IWKID,IERROR)
C
C PURPOSE                To provide a simple demonstration of SRFACE.
C
C USAGE                  CALL TSRFAC (IWKID,IERROR)
C
C ARGUMENTS
C
C ON INPUT               IWKID
C                          A workstation id number
C
C ON OUTPUT              IERROR
C                          An integer variable
C                          = 0, if the test was successful,
C                          = 1, the test was not successful.
C
C I/O                    If the test is successful, the message
C
C               SRFACE TEST EXECUTED--SEE PLOT TO CERTIFY
C
C                        is printed on unit 6.  In addition, 1
C                        frame is produced on the machine graphics
C                        device.  In order to determine if the test
C                        was successful, it is necessary to examine
C                        the plot.
C
C PRECISION              Single
C
C LANGUAGE               FORTRAN 77
C
C REQUIRED ROUTINES      SRFACE
C
C REQUIRED GKS LEVEL     0A
C
C ALGORITHM              The function
C
C                          Z(X,Y) = .25*(X + Y + 1./((X-.1)**2+Y**2+.09)
C                                   -1./((X+.1)**2+Y**2+.09)
C
C                        for X = -1. to +1. in increments of .1, and
C                            Y = -1.2 to +1.2 in increments of .1,
C                        is computed.  Then, entry SURFACE
C                        is called to a generate surface plot of Z.
C
C HISTORY                SURFACE was first written in April 1979 and
C                        converted to FORTRAN 77 and GKS in March 1984.
C
C XX contains the X-direction coordinate values for Z(X,Y);  YY contains
C the Y-direction coordinate values for Z(X,Y);  Z contains the function
C values;  S contains values for the line of sight for entry SRFACE;
C WORK is a work array;  ANGH contains the angle in degrees in the X-Y
C plane to the line of sight;  and ANGV contains the angle in degrees
C from the X-Y plane to the line of sight.
C
      REAL            XX(21)     ,YY(25)     ,Z(21,25)   ,S(6)       ,
     1                WORK(1096)
C
      DATA  S(1), S(2), S(3), S(4), S(5), S(6)/
     1      -8.0, -6.0,  3.0,  0.0,  0.0,  0.0/
C
      DATA  ANGH/45./, ANGV/15./
C
C Specify coordinates for plot titles.  The values CX and CY
C define the center of the title string in a 0. to 1. range.
C
      DATA CX/.5/, CY/.9/
C
C Initialize the error parameter.
C
      IERROR = 0
C
C Set up a the background and foreground colors
C
C     White background
C
      CALL GSCR (IWKID,0,1.,1.,1.)
C
C     Blue foreground
C
      CALL GSCR (IWKID,1,0.,0.,1.)
C
C Fill the XX and YY coordinate arrays as well as the Z function array.
C
      DO  20 I=1,21
         X = .1*REAL(I-11)
         XX(I) = X
         DO  10 J=1,25
            Y = .1*REAL(J-13)
            YY(J) = Y
            Z(I,J) = (X+Y+1./((X-.1)**2+Y**2+.09)-
     1           1./((X+.1)**2+Y**2+.09))*.25
 10      CONTINUE
 20   CONTINUE
C
C Select the normalization transformation 0.
C
      CALL GSELNT(0)
C
C Add the plot title.
C
C Set the text alignment to center the string in horizontal and vertical
C
      CALL GSTXAL(2,3)
C
C Set the character height.
C
      CALL GSCHH(.016)
C
C Write the text.
C
      CALL GTX(CX,CY,'DEMONSTRATION PLOT FOR SRFACE ENTRY OF SRFACE')
C
      CALL SRFACE (XX,YY,Z,WORK,21,15,12,S,0.)
C
C This routine automatically generates frame advances.
C
C
      RETURN
C
      END

      SUBROUTINE SPPEQU( UPLO, N, AP, S, SCOND, AMAX, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     March 31, 1993 
*
*     .. Scalar Arguments ..
      CHARACTER          UPLO
      INTEGER            INFO, N
      REAL               AMAX, SCOND
*     ..
*     .. Array Arguments ..
      REAL               AP( * ), S( * )
*     ..
*
*  Purpose
*  =======
*
*  SPPEQU computes row and column scalings intended to equilibrate a
*  symmetric positive definite matrix A in packed storage and reduce
*  its condition number (with respect to the two-norm).  S contains the
*  scale factors, S(i)=1/sqrt(A(i,i)), chosen so that the scaled matrix
*  B with elements B(i,j)=S(i)*A(i,j)*S(j) has ones on the diagonal.
*  This choice of S puts the condition number of B within a factor N of
*  the smallest possible condition number over all possible diagonal
*  scalings.
*
*  Arguments
*  =========
*
*  UPLO    (input) CHARACTER*1
*          = 'U':  Upper triangle of A is stored;
*          = 'L':  Lower triangle of A is stored.
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  AP      (input) REAL array, dimension (N*(N+1)/2)
*          The upper or lower triangle of the symmetric matrix A, packed
*          columnwise in a linear array.  The j-th column of A is stored
*          in the array AP as follows:
*          if UPLO = 'U', AP(i + (j-1)*j/2) = A(i,j) for 1<=i<=j;
*          if UPLO = 'L', AP(i + (j-1)*(2n-j)/2) = A(i,j) for j<=i<=n.
*
*  S       (output) REAL array, dimension (N)
*          If INFO = 0, S contains the scale factors for A.
*
*  SCOND   (output) REAL
*          If INFO = 0, S contains the ratio of the smallest S(i) to
*          the largest S(i).  If SCOND >= 0.1 and AMAX is neither too
*          large nor too small, it is not worth scaling by S.
*
*  AMAX    (output) REAL
*          Absolute value of largest matrix element.  If AMAX is very
*          close to overflow or very close to underflow, the matrix
*          should be scaled.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*          > 0:  if INFO = i, the i-th diagonal element is nonpositive.
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ONE, ZERO
      PARAMETER          ( ONE = 1.0E+0, ZERO = 0.0E+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            UPPER
      INTEGER            I, JJ
      REAL               SMIN
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN, SQRT
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      UPPER = LSAME( UPLO, 'U' )
      IF( .NOT.UPPER .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'SPPEQU', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 ) THEN
         SCOND = ONE
         AMAX = ZERO
         RETURN
      END IF
*
*     Initialize SMIN and AMAX.
*
      S( 1 ) = AP( 1 )
      SMIN = S( 1 )
      AMAX = S( 1 )
*
      IF( UPPER ) THEN
*
*        UPLO = 'U':  Upper triangle of A is stored.
*        Find the minimum and maximum diagonal elements.
*
         JJ = 1
         DO 10 I = 2, N
            JJ = JJ + I
            S( I ) = AP( JJ )
            SMIN = MIN( SMIN, S( I ) )
            AMAX = MAX( AMAX, S( I ) )
   10    CONTINUE
*
      ELSE
*
*        UPLO = 'L':  Lower triangle of A is stored.
*        Find the minimum and maximum diagonal elements.
*
         JJ = 1
         DO 20 I = 2, N
            JJ = JJ + N - I + 2
            S( I ) = AP( JJ )
            SMIN = MIN( SMIN, S( I ) )
            AMAX = MAX( AMAX, S( I ) )
   20    CONTINUE
      END IF
*
      IF( SMIN.LE.ZERO ) THEN
*
*        Find the first non-positive diagonal element and return.
*
         DO 30 I = 1, N
            IF( S( I ).LE.ZERO ) THEN
               INFO = I
               RETURN
            END IF
   30    CONTINUE
      ELSE
*
*        Set the scale factors to the reciprocals
*        of the diagonal elements.
*
         DO 40 I = 1, N
            S( I ) = ONE / SQRT( S( I ) )
   40    CONTINUE
*
*        Compute SCOND = min(S(I)) / max(S(I))
*
         SCOND = SQRT( SMIN ) / SQRT( AMAX )
      END IF
      RETURN
*
*     End of SPPEQU
*
      END

      SUBROUTINE SSPTRF( UPLO, N, AP, IPIV, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          UPLO
      INTEGER            INFO, N
*     ..
*     .. Array Arguments ..
      INTEGER            IPIV( * )
      REAL               AP( * )
*     ..
*
*  Purpose
*  =======
*
*  SSPTRF computes the factorization of a real symmetric matrix A stored
*  in packed format using the Bunch-Kaufman diagonal pivoting method:
*
*     A = U*D*U**T  or  A = L*D*L**T
*
*  where U (or L) is a product of permutation and unit upper (lower)
*  triangular matrices, and D is symmetric and block diagonal with
*  1-by-1 and 2-by-2 diagonal blocks.
*
*  Arguments
*  =========
*
*  UPLO    (input) CHARACTER*1
*          = 'U':  Upper triangle of A is stored;
*          = 'L':  Lower triangle of A is stored.
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  AP      (input/output) REAL array, dimension (N*(N+1)/2)
*          On entry, the upper or lower triangle of the symmetric matrix
*          A, packed columnwise in a linear array.  The j-th column of A
*          is stored in the array AP as follows:
*          if UPLO = 'U', AP(i + (j-1)*j/2) = A(i,j) for 1<=i<=j;
*          if UPLO = 'L', AP(i + (j-1)*(2n-j)/2) = A(i,j) for j<=i<=n.
*
*          On exit, the block diagonal matrix D and the multipliers used
*          to obtain the factor U or L, stored as a packed triangular
*          matrix overwriting A (see below for further details).
*
*  IPIV    (output) INTEGER array, dimension (N)
*          Details of the interchanges and the block structure of D.
*          If IPIV(k) > 0, then rows and columns k and IPIV(k) were
*          interchanged and D(k,k) is a 1-by-1 diagonal block.
*          If UPLO = 'U' and IPIV(k) = IPIV(k-1) < 0, then rows and
*          columns k-1 and -IPIV(k) were interchanged and D(k-1:k,k-1:k)
*          is a 2-by-2 diagonal block.  If UPLO = 'L' and IPIV(k) =
*          IPIV(k+1) < 0, then rows and columns k+1 and -IPIV(k) were
*          interchanged and D(k:k+1,k:k+1) is a 2-by-2 diagonal block.
*
*  INFO    (output) INTEGER
*          = 0: successful exit
*          < 0: if INFO = -i, the i-th argument had an illegal value
*          > 0: if INFO = i, D(i,i) is exactly zero.  The factorization
*               has been completed, but the block diagonal matrix D is
*               exactly singular, and division by zero will occur if it
*               is used to solve a system of equations.
*
*  Further Details
*  ===============
*
*  5-96 - Based on modifications by J. Lewis, Boeing Computer Services
*         Company
*
*  If UPLO = 'U', then A = U*D*U', where
*     U = P(n)*U(n)* ... *P(k)U(k)* ...,
*  i.e., U is a product of terms P(k)*U(k), where k decreases from n to
*  1 in steps of 1 or 2, and D is a block diagonal matrix with 1-by-1
*  and 2-by-2 diagonal blocks D(k).  P(k) is a permutation matrix as
*  defined by IPIV(k), and U(k) is a unit upper triangular matrix, such
*  that if the diagonal block D(k) is of order s (s = 1 or 2), then
*
*             (   I    v    0   )   k-s
*     U(k) =  (   0    I    0   )   s
*             (   0    0    I   )   n-k
*                k-s   s   n-k
*
*  If s = 1, D(k) overwrites A(k,k), and v overwrites A(1:k-1,k).
*  If s = 2, the upper triangle of D(k) overwrites A(k-1,k-1), A(k-1,k),
*  and A(k,k), and v overwrites A(1:k-2,k-1:k).
*
*  If UPLO = 'L', then A = L*D*L', where
*     L = P(1)*L(1)* ... *P(k)*L(k)* ...,
*  i.e., L is a product of terms P(k)*L(k), where k increases from 1 to
*  n in steps of 1 or 2, and D is a block diagonal matrix with 1-by-1
*  and 2-by-2 diagonal blocks D(k).  P(k) is a permutation matrix as
*  defined by IPIV(k), and L(k) is a unit lower triangular matrix, such
*  that if the diagonal block D(k) is of order s (s = 1 or 2), then
*
*             (   I    0     0   )  k-1
*     L(k) =  (   0    I     0   )  s
*             (   0    v     I   )  n-k-s+1
*                k-1   s  n-k-s+1
*
*  If s = 1, D(k) overwrites A(k,k), and v overwrites A(k+1:n,k).
*  If s = 2, the lower triangle of D(k) overwrites A(k,k), A(k+1,k),
*  and A(k+1,k+1), and v overwrites A(k+2:n,k:k+1).
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ZERO, ONE
      PARAMETER          ( ZERO = 0.0E+0, ONE = 1.0E+0 )
      REAL               EIGHT, SEVTEN
      PARAMETER          ( EIGHT = 8.0E+0, SEVTEN = 17.0E+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            UPPER
      INTEGER            I, IMAX, J, JMAX, K, KC, KK, KNC, KP, KPC,
     $                   KSTEP, KX, NPP
      REAL               ABSAKK, ALPHA, COLMAX, D11, D12, D21, D22, R1,
     $                   ROWMAX, T, WK, WKM1, WKP1
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            ISAMAX
      EXTERNAL           LSAME, ISAMAX
*     ..
*     .. External Subroutines ..
      EXTERNAL           SSCAL, SSPR, SSWAP, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, MAX, SQRT
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      UPPER = LSAME( UPLO, 'U' )
      IF( .NOT.UPPER .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'SSPTRF', -INFO )
         RETURN
      END IF
*
*     Initialize ALPHA for use in choosing pivot block size.
*
      ALPHA = ( ONE+SQRT( SEVTEN ) ) / EIGHT
*
      IF( UPPER ) THEN
*
*        Factorize A as U*D*U' using the upper triangle of A
*
*        K is the main loop index, decreasing from N to 1 in steps of
*        1 or 2
*
         K = N
         KC = ( N-1 )*N / 2 + 1
   10    CONTINUE
         KNC = KC
*
*        If K < 1, exit from loop
*
         IF( K.LT.1 )
     $      GO TO 110
         KSTEP = 1
*
*        Determine rows and columns to be interchanged and whether
*        a 1-by-1 or 2-by-2 pivot block will be used
*
         ABSAKK = ABS( AP( KC+K-1 ) )
*
*        IMAX is the row-index of the largest off-diagonal element in
*        column K, and COLMAX is its absolute value
*
         IF( K.GT.1 ) THEN
            IMAX = ISAMAX( K-1, AP( KC ), 1 )
            COLMAX = ABS( AP( KC+IMAX-1 ) )
         ELSE
            COLMAX = ZERO
         END IF
*
         IF( MAX( ABSAKK, COLMAX ).EQ.ZERO ) THEN
*
*           Column K is zero: set INFO and continue
*
            IF( INFO.EQ.0 )
     $         INFO = K
            KP = K
         ELSE
            IF( ABSAKK.GE.ALPHA*COLMAX ) THEN
*
*              no interchange, use 1-by-1 pivot block
*
               KP = K
            ELSE
*
*              JMAX is the column-index of the largest off-diagonal
*              element in row IMAX, and ROWMAX is its absolute value
*
               ROWMAX = ZERO
               JMAX = IMAX
               KX = IMAX*( IMAX+1 ) / 2 + IMAX
               DO 20 J = IMAX + 1, K
                  IF( ABS( AP( KX ) ).GT.ROWMAX ) THEN
                     ROWMAX = ABS( AP( KX ) )
                     JMAX = J
                  END IF
                  KX = KX + J
   20          CONTINUE
               KPC = ( IMAX-1 )*IMAX / 2 + 1
               IF( IMAX.GT.1 ) THEN
                  JMAX = ISAMAX( IMAX-1, AP( KPC ), 1 )
                  ROWMAX = MAX( ROWMAX, ABS( AP( KPC+JMAX-1 ) ) )
               END IF
*
               IF( ABSAKK.GE.ALPHA*COLMAX*( COLMAX / ROWMAX ) ) THEN
*
*                 no interchange, use 1-by-1 pivot block
*
                  KP = K
               ELSE IF( ABS( AP( KPC+IMAX-1 ) ).GE.ALPHA*ROWMAX ) THEN
*
*                 interchange rows and columns K and IMAX, use 1-by-1
*                 pivot block
*
                  KP = IMAX
               ELSE
*
*                 interchange rows and columns K-1 and IMAX, use 2-by-2
*                 pivot block
*
                  KP = IMAX
                  KSTEP = 2
               END IF
            END IF
*
            KK = K - KSTEP + 1
            IF( KSTEP.EQ.2 )
     $         KNC = KNC - K + 1
            IF( KP.NE.KK ) THEN
*
*              Interchange rows and columns KK and KP in the leading
*              submatrix A(1:k,1:k)
*
               CALL SSWAP( KP-1, AP( KNC ), 1, AP( KPC ), 1 )
               KX = KPC + KP - 1
               DO 30 J = KP + 1, KK - 1
                  KX = KX + J - 1
                  T = AP( KNC+J-1 )
                  AP( KNC+J-1 ) = AP( KX )
                  AP( KX ) = T
   30          CONTINUE
               T = AP( KNC+KK-1 )
               AP( KNC+KK-1 ) = AP( KPC+KP-1 )
               AP( KPC+KP-1 ) = T
               IF( KSTEP.EQ.2 ) THEN
                  T = AP( KC+K-2 )
                  AP( KC+K-2 ) = AP( KC+KP-1 )
                  AP( KC+KP-1 ) = T
               END IF
            END IF
*
*           Update the leading submatrix
*
            IF( KSTEP.EQ.1 ) THEN
*
*              1-by-1 pivot block D(k): column k now holds
*
*              W(k) = U(k)*D(k)
*
*              where U(k) is the k-th column of U
*
*              Perform a rank-1 update of A(1:k-1,1:k-1) as
*
*              A := A - U(k)*D(k)*U(k)' = A - W(k)*1/D(k)*W(k)'
*
               R1 = ONE / AP( KC+K-1 )
               CALL SSPR( UPLO, K-1, -R1, AP( KC ), 1, AP )
*
*              Store U(k) in column k
*
               CALL SSCAL( K-1, R1, AP( KC ), 1 )
            ELSE
*
*              2-by-2 pivot block D(k): columns k and k-1 now hold
*
*              ( W(k-1) W(k) ) = ( U(k-1) U(k) )*D(k)
*
*              where U(k) and U(k-1) are the k-th and (k-1)-th columns
*              of U
*
*              Perform a rank-2 update of A(1:k-2,1:k-2) as
*
*              A := A - ( U(k-1) U(k) )*D(k)*( U(k-1) U(k) )'
*                 = A - ( W(k-1) W(k) )*inv(D(k))*( W(k-1) W(k) )'
*
               IF( K.GT.2 ) THEN
*
                  D12 = AP( K-1+( K-1 )*K / 2 )
                  D22 = AP( K-1+( K-2 )*( K-1 ) / 2 ) / D12
                  D11 = AP( K+( K-1 )*K / 2 ) / D12
                  T = ONE / ( D11*D22-ONE )
                  D12 = T / D12
*
                  DO 50 J = K - 2, 1, -1
                     WKM1 = D12*( D11*AP( J+( K-2 )*( K-1 ) / 2 )-
     $                      AP( J+( K-1 )*K / 2 ) )
                     WK = D12*( D22*AP( J+( K-1 )*K / 2 )-
     $                    AP( J+( K-2 )*( K-1 ) / 2 ) )
                     DO 40 I = J, 1, -1
                        AP( I+( J-1 )*J / 2 ) = AP( I+( J-1 )*J / 2 ) -
     $                     AP( I+( K-1 )*K / 2 )*WK -
     $                     AP( I+( K-2 )*( K-1 ) / 2 )*WKM1
   40                CONTINUE
                     AP( J+( K-1 )*K / 2 ) = WK
                     AP( J+( K-2 )*( K-1 ) / 2 ) = WKM1
   50             CONTINUE
*
               END IF
*
            END IF
         END IF
*
*        Store details of the interchanges in IPIV
*
         IF( KSTEP.EQ.1 ) THEN
            IPIV( K ) = KP
         ELSE
            IPIV( K ) = -KP
            IPIV( K-1 ) = -KP
         END IF
*
*        Decrease K and return to the start of the main loop
*
         K = K - KSTEP
         KC = KNC - K
         GO TO 10
*
      ELSE
*
*        Factorize A as L*D*L' using the lower triangle of A
*
*        K is the main loop index, increasing from 1 to N in steps of
*        1 or 2
*
         K = 1
         KC = 1
         NPP = N*( N+1 ) / 2
   60    CONTINUE
         KNC = KC
*
*        If K > N, exit from loop
*
         IF( K.GT.N )
     $      GO TO 110
         KSTEP = 1
*
*        Determine rows and columns to be interchanged and whether
*        a 1-by-1 or 2-by-2 pivot block will be used
*
         ABSAKK = ABS( AP( KC ) )
*
*        IMAX is the row-index of the largest off-diagonal element in
*        column K, and COLMAX is its absolute value
*
         IF( K.LT.N ) THEN
            IMAX = K + ISAMAX( N-K, AP( KC+1 ), 1 )
            COLMAX = ABS( AP( KC+IMAX-K ) )
         ELSE
            COLMAX = ZERO
         END IF
*
         IF( MAX( ABSAKK, COLMAX ).EQ.ZERO ) THEN
*
*           Column K is zero: set INFO and continue
*
            IF( INFO.EQ.0 )
     $         INFO = K
            KP = K
         ELSE
            IF( ABSAKK.GE.ALPHA*COLMAX ) THEN
*
*              no interchange, use 1-by-1 pivot block
*
               KP = K
            ELSE
*
*              JMAX is the column-index of the largest off-diagonal
*              element in row IMAX, and ROWMAX is its absolute value
*
               ROWMAX = ZERO
               KX = KC + IMAX - K
               DO 70 J = K, IMAX - 1
                  IF( ABS( AP( KX ) ).GT.ROWMAX ) THEN
                     ROWMAX = ABS( AP( KX ) )
                     JMAX = J
                  END IF
                  KX = KX + N - J
   70          CONTINUE
               KPC = NPP - ( N-IMAX+1 )*( N-IMAX+2 ) / 2 + 1
               IF( IMAX.LT.N ) THEN
                  JMAX = IMAX + ISAMAX( N-IMAX, AP( KPC+1 ), 1 )
                  ROWMAX = MAX( ROWMAX, ABS( AP( KPC+JMAX-IMAX ) ) )
               END IF
*
               IF( ABSAKK.GE.ALPHA*COLMAX*( COLMAX / ROWMAX ) ) THEN
*
*                 no interchange, use 1-by-1 pivot block
*
                  KP = K
               ELSE IF( ABS( AP( KPC ) ).GE.ALPHA*ROWMAX ) THEN
*
*                 interchange rows and columns K and IMAX, use 1-by-1
*                 pivot block
*
                  KP = IMAX
               ELSE
*
*                 interchange rows and columns K+1 and IMAX, use 2-by-2
*                 pivot block
*
                  KP = IMAX
                  KSTEP = 2
               END IF
            END IF
*
            KK = K + KSTEP - 1
            IF( KSTEP.EQ.2 )
     $         KNC = KNC + N - K + 1
            IF( KP.NE.KK ) THEN
*
*              Interchange rows and columns KK and KP in the trailing
*              submatrix A(k:n,k:n)
*
               IF( KP.LT.N )
     $            CALL SSWAP( N-KP, AP( KNC+KP-KK+1 ), 1, AP( KPC+1 ),
     $                        1 )
               KX = KNC + KP - KK
               DO 80 J = KK + 1, KP - 1
                  KX = KX + N - J + 1
                  T = AP( KNC+J-KK )
                  AP( KNC+J-KK ) = AP( KX )
                  AP( KX ) = T
   80          CONTINUE
               T = AP( KNC )
               AP( KNC ) = AP( KPC )
               AP( KPC ) = T
               IF( KSTEP.EQ.2 ) THEN
                  T = AP( KC+1 )
                  AP( KC+1 ) = AP( KC+KP-K )
                  AP( KC+KP-K ) = T
               END IF
            END IF
*
*           Update the trailing submatrix
*
            IF( KSTEP.EQ.1 ) THEN
*
*              1-by-1 pivot block D(k): column k now holds
*
*              W(k) = L(k)*D(k)
*
*              where L(k) is the k-th column of L
*
               IF( K.LT.N ) THEN
*
*                 Perform a rank-1 update of A(k+1:n,k+1:n) as
*
*                 A := A - L(k)*D(k)*L(k)' = A - W(k)*(1/D(k))*W(k)'
*
                  R1 = ONE / AP( KC )
                  CALL SSPR( UPLO, N-K, -R1, AP( KC+1 ), 1,
     $                       AP( KC+N-K+1 ) )
*
*                 Store L(k) in column K
*
                  CALL SSCAL( N-K, R1, AP( KC+1 ), 1 )
               END IF
            ELSE
*
*              2-by-2 pivot block D(k): columns K and K+1 now hold
*
*              ( W(k) W(k+1) ) = ( L(k) L(k+1) )*D(k)
*
*              where L(k) and L(k+1) are the k-th and (k+1)-th columns
*              of L
*
               IF( K.LT.N-1 ) THEN
*
*                 Perform a rank-2 update of A(k+2:n,k+2:n) as
*
*                 A := A - ( L(k) L(k+1) )*D(k)*( L(k) L(k+1) )'
*                    = A - ( W(k) W(k+1) )*inv(D(k))*( W(k) W(k+1) )'
*
                  D21 = AP( K+1+( K-1 )*( 2*N-K ) / 2 )
                  D11 = AP( K+1+K*( 2*N-K-1 ) / 2 ) / D21
                  D22 = AP( K+( K-1 )*( 2*N-K ) / 2 ) / D21
                  T = ONE / ( D11*D22-ONE )
                  D21 = T / D21
*
                  DO 100 J = K + 2, N
                     WK = D21*( D11*AP( J+( K-1 )*( 2*N-K ) / 2 )-
     $                    AP( J+K*( 2*N-K-1 ) / 2 ) )
                     WKP1 = D21*( D22*AP( J+K*( 2*N-K-1 ) / 2 )-
     $                      AP( J+( K-1 )*( 2*N-K ) / 2 ) )
*
                     DO 90 I = J, N
                        AP( I+( J-1 )*( 2*N-J ) / 2 ) = AP( I+( J-1 )*
     $                     ( 2*N-J ) / 2 ) - AP( I+( K-1 )*( 2*N-K ) /
     $                     2 )*WK - AP( I+K*( 2*N-K-1 ) / 2 )*WKP1
   90                CONTINUE
*
                     AP( J+( K-1 )*( 2*N-K ) / 2 ) = WK
                     AP( J+K*( 2*N-K-1 ) / 2 ) = WKP1
*
  100             CONTINUE
               END IF
            END IF
         END IF
*
*        Store details of the interchanges in IPIV
*
         IF( KSTEP.EQ.1 ) THEN
            IPIV( K ) = KP
         ELSE
            IPIV( K ) = -KP
            IPIV( K+1 ) = -KP
         END IF
*
*        Increase K and return to the start of the main loop
*
         K = K + KSTEP
         KC = KNC + N - K + 2
         GO TO 60
*
      END IF
*
  110 CONTINUE
      RETURN
*
*     End of SSPTRF
*
      END

      PROGRAM CCPVS
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Declare required data arrays and workspace arrays.
C
      PARAMETER(LMAP=100000,LWRK=1000)
      REAL ZDAT(23,14),RWRK(LWRK),XCRA(LWRK),YCRA(LWRK)
      INTEGER IWRK(LWRK),IAMA(LMAP), IAREA(2),IGRP(2)
C
C Declare the routine which will color the areas.
C
      EXTERNAL FILL
C
C Open GKS.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Turn off the clipping indicator.
C
      CALL GSCLIP (0)
C
C Force solid fill.
C
      CALL GSFAIS (1)
C
C Define color indices.
C
      CALL COLOR(IWKID)
C
C Generate an array of test data.
C
      CALL GENDAT (ZDAT,23,23,14,20,20,-136.148,451.834)
C
C Tell CONPACK to use 12 contour lines, splitting the range into 13
C equal bands, one for each of the 13 colors available.
C
      CALL CPSETI ('CLS - CONTOUR LEVEL SELECTOR',-12)
C
C Tell Conpack that we want 3 vertical strips
C
      CALL CPSETI ('NVS - NUMBER OF VERTICAL STRIPS',3)
C
C Initialize the drawing of the contour plot.
C
      CALL CPRECT (ZDAT,23,23,14,RWRK,LWRK,IWRK,LWRK)
C
C Initialize the area map and put the contour lines into it.
C
      CALL ARINAM (IAMA,LMAP)
      CALL CPCLAM (ZDAT,RWRK,IWRK,IAMA)
C
C Color the map.
C
      CALL ARSCAM (IAMA,XCRA,YCRA,LWRK,IAREA,IGRP,2,FILL)
C
C Put black contour lines over the colored map.
C
      CALL GSPLCI (0)
      CALL CPCLDR (ZDAT,RWRK,IWRK)
      CALL GSPLCI (1)
C
C Advance the frame.
C
      CALL FRAME
C
C Close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
C Done.
C
      STOP
C
      END
      SUBROUTINE FILL (XCRA,YCRA,NCRA,IAREA,IGRP,NGRPS)
C
      REAL XCRA(NCRA),YCRA(NCRA)
      INTEGER IAREA(NGRPS),IGRP(NGRPS)
C
C Get area identifiers for contour levels and vertical strips.
C
      IFILL=0
      DO 101 I=1,NGRPS
         IF (IGRP(I).EQ.3) IFILL=IAREA(I)
 101  CONTINUE
C
C Find the average X value of the X coordinates defining the area
C
      XSUM=0.
      DO 102 I=1,NCRA
         XSUM=XSUM+XCRA(I)
 102  CONTINUE
      XAVG=XSUM/REAL(NCRA)
C
C Fill vertical strip 1.
C
      IF (IFILL.GT.0.AND.XAVG.LT..35) THEN
         CALL GSFACI (IFILL+2)
         CALL GFA (NCRA-1,XCRA,YCRA)
C
C Fill vertical strip 2
C
      ELSE IF (IFILL.GT.0.AND.XAVG.GE..35.AND.XAVG.LE..65) THEN
         CALL GSFACI (IFILL+15)
         CALL GFA (NCRA-1,XCRA,YCRA)
C
C Fill vertical strip 3
C
      ELSE IF (IFILL.GT.0.AND.XAVG.GT..65) THEN
         CALL GSFACI (IFILL+28)
         CALL GFA (NCRA-1,XCRA,YCRA)
      END IF
C
C Done.
C
      RETURN
C
      END

      SUBROUTINE GENDAT (DATA,IDIM,M,N,MLOW,MHGH,DLOW,DHGH)
C
C This is a routine to generate test data for two-dimensional graphics
C routines.  Given an array "DATA", dimensioned "IDIM x 1", it fills
C the sub-array ((DATA(I,J),I=1,M),J=1,N) with a two-dimensional field
C of data having approximately "MLOW" lows and "MHGH" highs, a minimum
C value of exactly "DLOW" and a maximum value of exactly "DHGH".
C
C "MLOW" and "MHGH" are each forced to be greater than or equal to 1
C and less than or equal to 25.
C
C The function used is a sum of exponentials.
C
      DIMENSION DATA(IDIM,1),CCNT(3,50)
C
      FOVM=9./REAL(M)
      FOVN=9./REAL(N)
C
      NLOW=MAX(1,MIN(25,MLOW))
      NHGH=MAX(1,MIN(25,MHGH))
      NCNT=NLOW+NHGH
C
      DO 101 K=1,NCNT
         CCNT(1,K)=1.+(REAL(M)-1.)*FRAN()
         CCNT(2,K)=1.+(REAL(N)-1.)*FRAN()
         IF (K.LE.NLOW) THEN
            CCNT(3,K)=-1.
         ELSE
            CCNT(3,K)=+1.
         END IF
 101  CONTINUE
C
      DMIN=+1.E36
      DMAX=-1.E36
      DO 104 J=1,N
         DO 103 I=1,M
            DATA(I,J)=.5*(DLOW+DHGH)
            DO 102 K=1,NCNT
               TEMP=-((FOVM*(REAL(I)-CCNT(1,K)))**2+
     +              (FOVN*(REAL(J)-CCNT(2,K)))**2)
               IF (TEMP.GE.-20.) DATA(I,J)=DATA(I,J)+
     +              .5*(DHGH-DLOW)*CCNT(3,K)*EXP(TEMP)
 102        CONTINUE
            DMIN=MIN(DMIN,DATA(I,J))
            DMAX=MAX(DMAX,DATA(I,J))
 103     CONTINUE
 104  CONTINUE
C
      DO 106 J=1,N
         DO 105 I=1,M
            DATA(I,J)=(DATA(I,J)-DMIN)/(DMAX-DMIN)*(DHGH-DLOW)+DLOW
 105     CONTINUE
 106  CONTINUE
C
      RETURN
C
      END

      FUNCTION FRAN ()
      DIMENSION RSEQ (100)
      SAVE ISEQ
      DATA RSEQ / .749,.973,.666,.804,.081,.483,.919,.903,.951,.960 ,
     +     .039,.269,.270,.756,.222,.478,.621,.063,.550,.798 ,
     +     .027,.569,.149,.697,.451,.738,.508,.041,.266,.249 ,
     +     .019,.191,.266,.625,.492,.940,.508,.406,.972,.311 ,
     +     .757,.378,.299,.536,.619,.844,.342,.295,.447,.499 ,
     +     .688,.193,.225,.520,.954,.749,.997,.693,.217,.273 ,
     +     .961,.948,.902,.104,.495,.257,.524,.100,.492,.347 ,
     +     .981,.019,.225,.806,.678,.710,.235,.600,.994,.758 ,
     +     .682,.373,.009,.469,.203,.730,.588,.603,.213,.495 ,
     +     .884,.032,.185,.127,.010,.180,.689,.354,.372,.429 /
      DATA ISEQ / 0 /
      ISEQ=MOD(ISEQ,100)+1
      FRAN=RSEQ(ISEQ)
      RETURN
      END
      SUBROUTINE COLOR(IWKID)
C
C Background color
C Black
C
      CALL GSCR(IWKID,0,0.,0.,0.)
C
C Foreground colors
C White
C
      CALL GSCR(IWKID, 1, 1.0, 1.0, 1.0)
C
C Aqua
C
      CALL GSCR(IWKID, 2, 0.0, 0.9, 1.0)
C
C Red1
C
      CALL GSCR(IWKID, 3, 0.9, 0.25, 0.0)
C
C OrangeRed1
C
      CALL GSCR(IWKID, 4, 1.0, 0.0, 0.2)
C
C Orange1
C
      CALL GSCR(IWKID, 5, 1.0, 0.65, 0.0)
C
C Yellow1
C
      CALL GSCR(IWKID, 6, 1.0, 1.0, 0.0)
C
C GreenYellow1
C
      CALL GSCR(IWKID, 7, 0.7, 1.0, 0.2)
C
C Chartreuse1
C
      CALL GSCR(IWKID, 8, 0.5, 1.0, 0.0)
C
C Celeste1
C
      CALL GSCR(IWKID, 9, 0.2, 1.0, 0.5)
C
C Green1
C
      CALL GSCR(IWKID, 10, 0.2, 0.8, 0.2)
C
C DeepSkyBlue1
C
      CALL GSCR(IWKID, 11, 0.0, 0.75, 1.0)
C
C RoyalBlue1
C
      CALL GSCR(IWKID, 12, 0.25, 0.45, 0.95)
C
C SlateBlue1
C
      CALL GSCR(IWKID, 13, 0.4, 0.35, 0.8)
C
C DarkViolet1
C
      CALL GSCR(IWKID, 14, 0.6, 0.0, 0.8)
C
C Orchid1
C
      CALL GSCR(IWKID, 15, 0.85, 0.45, 0.8)
C
C Red2
C
      CALL GSCR(IWKID, 16, 0.77, 0.21, 0.0)
C
C OrangeRed2
C
      CALL GSCR(IWKID, 17, 0.85, 0.0, 0.17)
C
C Orange2
C
      CALL GSCR(IWKID, 18, 0.85, 0.55, 0.0)
C
C Yellow2
C
      CALL GSCR(IWKID, 19, 0.85, 0.85, 0.0)
C
C GreenYellow2
C
      CALL GSCR(IWKID, 20, 0.6, 0.85, 0.17)
C
C Chartreuse2
C
      CALL GSCR(IWKID, 21, 0.43, 0.85, 0.0)
C
C Celeste2
C
      CALL GSCR(IWKID, 22, 0.17, 0.85, 0.43)
C
C Green2
C
      CALL GSCR(IWKID, 23, 0.17, 0.68, 0.17)
C
C DeepSkyBlue2
C
      CALL GSCR(IWKID, 24, 0.0, 0.64, 0.85)
C
C RoyalBlue2
C
      CALL GSCR(IWKID, 25, 0.21, 0.38, 0.81)
C
C SlateBlue2
C
      CALL GSCR(IWKID, 26, 0.32, 0.3, 0.68)
C
C DarkViolet2
C
      CALL GSCR(IWKID, 27, 0.51, 0.0, 0.68)
C
C Orchid2
C
      CALL GSCR(IWKID, 28, 0.72, 0.38, 0.68)
C
C Red3
C
      CALL GSCR(IWKID, 29, 0.63, 0.18, 0.0)
C
C OrangeRed3
C
      CALL GSCR(IWKID, 30, 0.7, 0.0, 0.14)
C
C Orange3
C
      CALL GSCR(IWKID, 31, 0.6, 0.39, 0.0)
C
C Yellow3
C
      CALL GSCR(IWKID, 32, 0.7, 0.7, 0.0)
C
C GreenYellow3
C
      CALL GSCR(IWKID, 33, 0.49, 0.7, 0.14)
C
C Chartreuse3
C
      CALL GSCR(IWKID, 34, 0.35, 0.7, 0.0)
C
C Celeste3
C
      CALL GSCR(IWKID, 35, 0.14, 0.7, 0.35)
C
C Green3
C
      CALL GSCR(IWKID, 36, 0.14, 0.56, 0.14)
C
C DeepSkyBlue3
C
      CALL GSCR(IWKID, 37, 0.0, 0.53, 0.7)
C
C RoyalBlue3
C
      CALL GSCR(IWKID, 38, 0.18, 0.32, 0.67)
C
C SlateBlue3
C
      CALL GSCR(IWKID, 39, 0.28, 0.25, 0.56)
C
C DarkViolet3
C
      CALL GSCR(IWKID, 40, 0.42, 0.0, 0.56)
C
C Orchid3
C
      CALL GSCR(IWKID, 41, 0.6, 0.32, 0.56)
C
C Lavender
C
      CALL GSCR(IWKID, 42, 0.8, 0.8, 1.0)
C
C Gray
C
      CALL GSCR(IWKID, 43, 0.7, 0.7, 0.7)
C
C Done.
C
      RETURN
C
      END

      PROGRAM FTEX03
C
C  Example of CURVS, CURVPS.
C
C  Define dimensions, declare arrays.
C
      PARAMETER (IDIM=10,IOUT=201)
      DIMENSION X(IDIM),Y(IDIM),YS(IDIM),YSP(IDIM),TEMP(IDIM,11)
      DIMENSION XO(IOUT),YOS(IOUT),YOSP(IOUT)
C
C Specify the input data.
C
C
      DATA X/ 0.000, 0.210, 0.360, 0.540, 1.000, 
     +        1.500, 1.970, 2.300, 2.500, 2.700/
      DATA Y/ 0.000, 2.600, 3.000, 2.500, 0.000,
     +       -1.000, 0.000, 0.800, 0.920, 0.700/
C
C  Call CURVS setup.
C
      SIGMA = 1.0
      D     = 0.3
      ISW   = 1
      S     = REAL(IDIM)
      EPS   = SQRT(2./S)
      CALL CURVS(IDIM,X,Y,D,ISW,S,EPS,YS,YSP,SIGMA,TEMP,IERR)       
C
C  Call CURV2 and calculate the interpolated values and the integrals.
C
      XR =  5.
      XL = -1.
      XINC = (XR-XL)/(IOUT-1)
      DO 10 I=1,IOUT
        XO(I) = XL+(I-1)*XINC
        YOS(I) = CURV2(XO(I),IDIM,X,YS,YSP,SIGMA)
   10 CONTINUE
C
C  Call CURVPS setup.
C
      P = 3.
      CALL CURVPS(IDIM,X,Y,P,D,ISW,S,EPS,YS,YSP,SIGMA,TEMP,IERR)       
C
C  Call CURVP2 and calculate the interpolated values.
C
      DO 15 I=1,IOUT
        YOSP(I) = CURVP2(XO(I),IDIM,X,YS,P,YSP,SIGMA)
   15 CONTINUE
C
C  Plot the results.
C
      CALL DRWFT3(XL,XR,IDIM,X,Y,IOUT,XO,YO,YOS,YOSP)
C
      STOP
      END
      SUBROUTINE DRWFT3(XL,XR,II,X,Y,IO,XO,YO,YOS,YOSP)
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
      DATA YPOS_TOP/0.95/
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C  Define a color table.
C
      CALL GSCR(IWKID, 0, 1.0, 1.0, 1.0)
      CALL GSCR(IWKID, 1, 0.0, 0.0, 0.0)
      CALL GSCR(IWKID, 2, 1.0, 0.0, 0.0)
      CALL GSCR(IWKID, 3, 0.0, 1.0, 0.0)
      CALL GSCR(IWKID, 4, 0.0, 0.0, 1.0)
      CALL GSCLIP(1)
C
C  Graph the interpolated function values and mark the original
C  input data points.
C
      YB = -2.0
      YT =  4.0
      CALL BKGFT3(XL,XR,YPOS_TOP,'CURVS',0.42,YB,YT)
      CALL GRIDAL(6,5,3,1,1,1,10,XL,YB)
C
C  Mark the original data points.
C
      CALL GSMKSC(2.)
      CALL GSPMCI(4)
      CALL GPM(II,X,Y)
C
C  Graph the interpolated function values.
C
      CALL GPL(IO,XO,YOS)
C
C  Graph the periodic function.
C
      CALL BKGFT3(XL,XR,YPOS_TOP-0.5,'CURVPS',0.42,YB,YT)
      CALL GRIDAL(6,5,3,1,1,1,10,XL,YB)
      CALL GPL(IO,XO,YOSP)
      CALL GSPLCI(1)
C
C  Mark the original data points.
C
      CALL GSMKSC(2.)
      CALL GSPMCI(4)
      CALL GPM(II,X,Y)
C
      CALL FRAME
C
      CALL GDAWK(IWKID)
      CALL GCLWK(IWKID)
      CALL GCLKS
C
      RETURN
      END
      SUBROUTINE BKGFT3(XL,XR,YPOS,LABEL,XLP,YB,YT)
      DIMENSION XX(2),YY(2)
      CHARACTER*(*) LABEL
C
      CALL SET(0.,1.,0.,1.,0.,1.,0.,1.,1)
      CALL PCSETI('FN',21)
      CALL PLCHHQ(XLP,YPOS - 0.03,LABEL,0.025,0.,-1.)
      CALL SET(0.13,0.93,YPOS-0.35,YPOS,XL,XR,YB,YT,1)
      XX(1) = XL
      XX(2) = XR
      YY(1) = 0.
      YY(2) = 0.
      CALL GSPLCI(2)
      CALL GPL(2,XX,YY)
      CALL GSPLCI(1)

      CALL GASETI('LTY',1)
      CALL PCSETI('FN',21)
      CALL GASETR('XLS',0.02)
      CALL GASETC('XLF','(F4.1)')
      CALL GASETR('YLS',0.02)
      CALL GASETC('YLF','(F5.2)')
      CALL GASETR('XMJ',0.02)
      CALL GASETR('YMJ',0.02)
C
      RETURN
      END

C
C premaptform.f and maptform.f copied from RIP/src
C By So-Young Ha on Sep 29, 2005.
C
C
C NCLFORTSTART
      SUBROUTINE DMAPTFORM(DSKMC,MIYCORS,MJXCORS,NPROJ,XLATC,XLONC,
     +                     TRUE1,TRUE2,RIY,RJX,RLAT,RLON,IDIR)
C
C Input vars:        DSKMC, MIYCORS, MJXCORS, NPROJ, XLATC, XLONC,
C                    NPROJ, IDIR
C Input/output vars: RIY, RIX, RLAT
C Output vars:       TRUE1, TRUE2, RLON 
C 
C
C Possible NCL interface:
C
C   wrf_maptform(dskmc, miycors, mjxcors, nproj, xlatc, xlonc, riy, rjx,
C                idir, rlat, rlon, opts)
C
C where opts could contain the TRUE1 and TRUE2 information in some fashion.
C
      DOUBLE PRECISION PI_MPTF
      DOUBLE PRECISION RPD_MPTF
      DOUBLE PRECISION REARTH_MPTF
      DOUBLE PRECISION DSKMC_MPTF
      DOUBLE PRECISION XLONC_MPTF
      DOUBLE PRECISION CIY_MPTF
      DOUBLE PRECISION CJX_MPTF
      DOUBLE PRECISION CONE_MPTF
      DOUBLE PRECISION CONEI_MPTF
      DOUBLE PRECISION C1_MPTF
      DOUBLE PRECISION C2_MPTF
      DOUBLE PRECISION YC_MPTF
      DOUBLE PRECISION COTRUE1
      DOUBLE PRECISION YPOINT
      DOUBLE PRECISION XPOINT
      DOUBLE PRECISION DLON
C
c   This routine converts a coarse domain dot grid point, <riy,rjx>,
c   into a lat/lon point <rlat,rlon> if idir=1, or vice versa if
c   idir=-1. It works for Lambert Conformal (LC,1),
c   Polar Stereographic (ST,2), or Mercator (ME,3) projections,
c   with any true latitide(s).
c   It is assumed that premaptform has been called prior to this so
c   that the proper constants have been placed in the common block
c   called mptf, which should be declared in (and only in) the
c   main program and routines maptform (this routine) and premaptform.
c

C Input, Output Args
      INTEGER MIYCORS,MJXCORS,NPROJ
      DOUBLE PRECISION DSKMC,XLATC,XLONC,TRUE1,TRUE2
      INTEGER IDIR
C Latitude (-90->90 deg N)
      DOUBLE PRECISION RLAT
C Longitude (-180->180 E)
      DOUBLE PRECISION RLON
C Cartesian X coordinate
      DOUBLE PRECISION RIY
C Cartesian Y coordinate
      DOUBLE PRECISION RJX
C NCLEND


c ===========
c premaptform
c ===========
C 3.1415...
      PI_MPTF = 4.D0*ATAN(1.D0)
C radians per degree
      RPD_MPTF = PI_MPTF/180.D0
C radius of planet, in km
      REARTH_MPTF = 6370.949D0
      DSKMC_MPTF = DSKMC
      XLONC_MPTF = XLONC
      NPROJ_MPTF = NPROJ
      CIY_MPTF = .5D0* (1.D0+MIYCORS)
      CJX_MPTF = .5D0* (1.D0+MJXCORS)
c
C Mercator
      IF (NPROJ_MPTF.EQ.3) THEN
c
          TRUE1 = 0.D0
          TRUE2 = 0.D0
          IHM_MPTF = 1
          CONE_MPTF = 1.D0
          CONEI_MPTF = 1.D0
          C1_MPTF = 1.D0
          C2_MPTF = 1.D0
          YC_MPTF = REARTH_MPTF*LOG((1.D0+SIN(RPD_MPTF*XLATC))/
     +              COS(RPD_MPTF*XLATC))
c
C Lambert Comformal or Polar Stereographic
      ELSE
c
c   Make sure xlatc, true1, and true2 are all in same hemisphere,
c      and calculate ihm_mptf.
c
          IF (XLATC.GT.0.D0 .AND. TRUE1.GT.0.D0 .AND.
     +        TRUE2.GT.0.D0) THEN
              IHM_MPTF = 1
          ELSE IF (XLATC.LT.0.D0 .AND. TRUE1.LT.0.D0 .AND.
     +             TRUE2.LT.0.D0) THEN
              IHM_MPTF = -1
          ELSE
              WRITE (*,FMT=*) 'Invalid latitude parameters for map.'
              STOP
          END IF
c
c   Calculate cone factor
c
          IF (NPROJ_MPTF.EQ.1) THEN
              IF (TRUE1.NE.TRUE2) THEN
                  CONE_MPTF = LOG10(COS(RPD_MPTF*TRUE1)/
     +                        COS(RPD_MPTF*TRUE2))/
     +                        LOG10(TAN(.25D0*PI_MPTF-
     +                        IHM_MPTF*.5D0*RPD_MPTF*TRUE1)/
     +                        TAN(.25D0*PI_MPTF-IHM_MPTF*.5D0*RPD_MPTF*
     +                        TRUE2))
              ELSE
                  CONE_MPTF = COS(RPD_MPTF* (90.D0-IHM_MPTF*TRUE1))
              END IF
          ELSE IF (NPROJ_MPTF.EQ.2) THEN
              CONE_MPTF = 1.D0
          END IF
c
c   Calculate other constants
c
          CONEI_MPTF = 1.D0/CONE_MPTF
          COTRUE1 = IHM_MPTF*90.D0 - TRUE1
          IF (NPROJ_MPTF.EQ.1) THEN
              C1_MPTF = REARTH_MPTF*SIN(RPD_MPTF*COTRUE1)/
     +                  (CONE_MPTF* (IHM_MPTF*TAN(.5D0*RPD_MPTF*
     +                  COTRUE1))**CONE_MPTF)
              C2_MPTF = TAN(.5D0*RPD_MPTF*COTRUE1)*
     +                  (CONE_MPTF/ (IHM_MPTF*REARTH_MPTF*SIN(RPD_MPTF*
     +                  COTRUE1)))**CONEI_MPTF
              YC_MPTF = -C1_MPTF* (IHM_MPTF*
     +                  TAN(.25D0* (IHM_MPTF*PI_MPTF-
     +                  2.D0*RPD_MPTF*XLATC)))**CONE_MPTF
          ELSE IF (NPROJ_MPTF.EQ.2) THEN
              C1_MPTF = 1.D0 + COS(RPD_MPTF*COTRUE1)
              C2_MPTF = 1.D0
              YC_MPTF = -REARTH_MPTF*SIN(.5D0*IHM_MPTF*PI_MPTF-
     +                  RPD_MPTF*XLATC)*C1_MPTF/
     +                  (1.D0+COS(.5D0*IHM_MPTF*PI_MPTF-RPD_MPTF*XLATC))
          END IF
c
      END IF

c ========
c maptform
c ========

      IF (RLAT.EQ.-90.D0) PRINT *,'maptform:',RIY,RJX,RLAT,RLON,IDIR

C First, deal with idir=1
      IF (IDIR.EQ.1) THEN
c
          YPOINT = (RIY-CIY_MPTF)*DSKMC_MPTF + YC_MPTF
          XPOINT = (RJX-CJX_MPTF)*DSKMC_MPTF
c
          IF (NPROJ_MPTF.EQ.3) THEN
              RLAT = (2.D0*ATAN(EXP(YPOINT/REARTH_MPTF))-.5D0*PI_MPTF)/
     +               RPD_MPTF
              RLON = XLONC_MPTF + (XPOINT/REARTH_MPTF)/RPD_MPTF
          ELSE IF (NPROJ_MPTF.EQ.1) THEN
              RLAT = (.5D0*IHM_MPTF*PI_MPTF-
     +               2.D0*ATAN(C2_MPTF* (SQRT(XPOINT**2+
     +               YPOINT**2))**CONEI_MPTF))/RPD_MPTF
              RLON = XLONC_MPTF + (CONEI_MPTF*
     +               ATAN2(XPOINT,-IHM_MPTF*YPOINT))/RPD_MPTF
          ELSE IF (NPROJ_MPTF.EQ.2) THEN
              RLAT = (.5D0*IHM_MPTF*PI_MPTF-
     +               IHM_MPTF*2.D0*ATAN(SQRT(XPOINT**2+
     +               YPOINT**2)/ (REARTH_MPTF*C1_MPTF)))/RPD_MPTF
              IF (XPOINT.EQ.0.D0 .AND. YPOINT.EQ.0.D0) THEN
                  RLON = XLONC_MPTF
              ELSE
                  RLON = XLONC_MPTF + (ATAN2(XPOINT,-IHM_MPTF*YPOINT))/
     +                   RPD_MPTF
              END IF
          END IF
          RLON = MOD(RLON+900.D0,360.D0) - 180.D0
c
C Otherwise, deal with idir=-1
      ELSE
c
          DLON = RLON - XLONC_MPTF
          IF (DLON.LT.-180.D0) DLON = DLON + 360
          IF (DLON.GT.180.D0) DLON = DLON - 360
          IF (NPROJ_MPTF.EQ.3) THEN
              YPOINT = REARTH_MPTF*LOG((1.D0+SIN(RPD_MPTF*RLAT))/
     +                 COS(RPD_MPTF*RLAT))
              XPOINT = DLON*RPD_MPTF*REARTH_MPTF
          ELSE IF (NPROJ_MPTF.EQ.1) THEN
              YPOINT = -C1_MPTF* (IHM_MPTF*
     +                 TAN(.25D0* (IHM_MPTF*PI_MPTF-2.D0*RPD_MPTF*
     +                 RLAT)))**CONE_MPTF*COS(CONE_MPTF*RPD_MPTF*DLON)
              XPOINT = IHM_MPTF*C1_MPTF* (IHM_MPTF*
     +                 TAN(.25D0* (IHM_MPTF*PI_MPTF-
     +                 2.D0*RPD_MPTF*RLAT)))**CONE_MPTF*
     +                 SIN(CONE_MPTF*RPD_MPTF*DLON)
          ELSE IF (NPROJ_MPTF.EQ.2) THEN
              YPOINT = -REARTH_MPTF*SIN(.5D0*IHM_MPTF*PI_MPTF-
     +                 RPD_MPTF*RLAT)*C1_MPTF/ (1.D0+
     +                 COS(.5D0*IHM_MPTF*PI_MPTF-RPD_MPTF*RLAT))*
     +                 COS(RPD_MPTF*DLON)
              XPOINT = IHM_MPTF*REARTH_MPTF*
     +                 SIN(.5D0*IHM_MPTF*PI_MPTF-RPD_MPTF*RLAT)*C1_MPTF/
     +                 (1.D0+COS(.5D0*IHM_MPTF*PI_MPTF-RPD_MPTF*RLAT))*
     +                 SIN(RPD_MPTF*DLON)
          END IF
          RIY = (YPOINT-YC_MPTF)/DSKMC_MPTF + CIY_MPTF
          RJX = XPOINT/DSKMC_MPTF + CJX_MPTF
c
      END IF

      RETURN
      END

C********************************************************
C NCLFORTSTART
      SUBROUTINE DBINT3D(DATA_OUT,OBSII,OBSJJ,DATA_IN,NX,NY,NZ,NOBSICRS,
     +                   NOBSJCRS,ICRS,JCRS)
C
C Possible NCL interface:
C
C    data_out = wrf_bint3d(data_in,obsii,obsjj,icrs,jcrs)
C
C     !!! 1_based_array (cols x rows) in fortran <=> 0_based_array
C      (rows x cols) in NCL !!!
C     !!! Include K-index to make a 3-D array !!!
C
C     INPUT VARIABLES
C     ---------------
      INTEGER ICRS,JCRS,NX,NY,NZ
      INTEGER NOBSJCRS,NOBSICRS
      DOUBLE PRECISION OBSII(NOBSICRS,NOBSJCRS)
      DOUBLE PRECISION OBSJJ(NOBSICRS,NOBSJCRS)
      DOUBLE PRECISION DATA_IN(NX,NY,NZ)

C     OUTPUT
C     ---------------
      DOUBLE PRECISION DATA_OUT(NOBSICRS,NOBSJCRS,NZ)
C NCLEND

C     LOCAL
      DOUBLE PRECISION OBSI,OBSJ
      DOUBLE PRECISION DATA_OBS
C

      DO K = 1,NZ
          DO J = 1,NOBSJCRS
              DO I = 1,NOBSICRS
C grid index in lon
                  OBSI = OBSII(I,J)
C grid index in lat
                  OBSJ = OBSJJ(I,J)
                  DATA_OBS = 0.0D0
                  CALL DBINT(DATA_OBS,OBSI,OBSJ,DATA_IN(1,1,K),NX,NY,
     +                       ICRS,JCRS)
                  DATA_OUT(I,J,K) = DATA_OBS
              END DO
          END DO
      END DO

      RETURN
      END


      SUBROUTINE DBINT(PP,XX,YY,LIST,III,JJJ,ICRS,JCRS)
      DOUBLE PRECISION PP
      DOUBLE PRECISION X
      DOUBLE PRECISION Y
      DOUBLE PRECISION A
      DOUBLE PRECISION B
      DOUBLE PRECISION C
      DOUBLE PRECISION D
      DOUBLE PRECISION E
      DOUBLE PRECISION F
      DOUBLE PRECISION G
      DOUBLE PRECISION H
      DOUBLE PRECISION QQ
C
C --- BI-LINEAR INTERPOLATION AMONG FOUR GRID VALUES
C
C     INPUT : LIST, XX, YY
C     OUTPUT: PP
C
      INTEGER ICRS,JCRS,III,JJJ
      DOUBLE PRECISION XX,YY
      DOUBLE PRECISION LIST(III,JJJ),STL(4,4)

C MASS GRID IN WRF (I-> west-east, J-> south-north)
C
      IB = III - ICRS
      JB = JJJ - JCRS
      PP = 0.0D0
      N = 0
      I = INT(XX+0.00001D0)
      J = INT(YY+0.00001D0)
      X = XX - I
      Y = YY - J
      IF ((ABS(X).GT.0.00001D0) .OR. (ABS(Y).GT.0.00001D0)) THEN
C
          DO 2 K = 1,4
              KK = I + K
              DO 2 L = 1,4
                  STL(K,L) = 0.D0
                  LL = J + L
                  IF ((KK.GE.1) .AND. (KK.LE.IB) .AND. (LL.LE.JB) .AND.
     +                (LL.GE.1)) THEN
                      STL(K,L) = LIST(KK,LL)
                      N = N + 1
C .. a zero value inside the domain being set to 1.E-12:
                      IF (STL(K,L).EQ.0.D0) STL(K,L) = 1.D-12
                  END IF
    2     CONTINUE
C
          CALL DONED(A,X,STL(1,1),STL(2,1),STL(3,1),STL(4,1))
          CALL DONED(B,X,STL(1,2),STL(2,2),STL(3,2),STL(4,2))
          CALL DONED(C,X,STL(1,3),STL(2,3),STL(3,3),STL(4,3))
          CALL DONED(D,X,STL(1,4),STL(2,4),STL(3,4),STL(4,4))
C
C .. CHECK TANGENT LINEAR OF ONED, SAVE BASIC STATE:
C      WRITE(20) XX,YY,Y,A,B,C,D
C
          CALL DONED(PP,Y,A,B,C,D)
          IF (N.NE.16) THEN
              CALL DONED(E,Y,STL(1,1),STL(1,2),STL(1,3),STL(1,4))
              CALL DONED(F,Y,STL(2,1),STL(2,2),STL(2,3),STL(2,4))
              CALL DONED(G,Y,STL(3,1),STL(3,2),STL(3,3),STL(3,4))
              CALL DONED(H,Y,STL(4,1),STL(4,2),STL(4,3),STL(4,4))
C .. CHECK TANGENT LINEAR OF ONED, SAVE BASIC STATE:
C      WRITE(20) XX,YY,X,E,F,G,H
C
              CALL DONED(QQ,X,E,F,G,H)
              PP = (PP+QQ)*0.5D0
          END IF
C
      ELSE
C
          PP = LIST(I,J)
      END IF
C
      RETURN
      END



      SUBROUTINE DONED(Y,X,A,B,C,D)
      DOUBLE PRECISION Y
      DOUBLE PRECISION X
      DOUBLE PRECISION A
      DOUBLE PRECISION B
      DOUBLE PRECISION C
      DOUBLE PRECISION D
      DOUBLE PRECISION ONE
C
C ..  Input : X, A, B, C, D
C     Output: Y
C       1, 2, 3, and 4 points interpolation:
C       In this subroutine, the zero value of A, B, C, D means that
C       point outside the domain.
C
C .. 1-point:
C .. take the value at the second point:
      IF (X.EQ.0.D0) THEN
          ONE = B
C .. take the value at the third point:
      ELSE IF (X.EQ.1.D0) THEN
          ONE = C
C .. the point X outside the range:
      ELSE IF (B*C.EQ.0.D0) THEN
          ONE = 0.D0
      ELSE
          IF (A*D.EQ.0.D0) THEN
C .. 3-point interpolation:
              IF (A.NE.0.D0) THEN
                  ONE = B + X* (0.5D0* (C-A)+X* (0.5D0* (C+A)-B))
              ELSE IF (D.NE.0.D0) THEN
                  ONE = C + (1.0D0-X)* (0.5D0* (B-D)+
     +                  (1.0D0-X)* (0.5D0* (B+D)-C))
              ELSE
C .. 2-point interpolation:
                  ONE = B* (1.0D0-X) + C*X
              END IF
          ELSE
C .. 4-point interpolation:
              ONE = (1.0D0-X)* (B+X* (0.5D0* (C-A)+X* (0.5D0* (C+A)-B)))
     +              + X* (C+ (1.0D0-X)* (0.5D0* (B-D)+ (1.0D0-
     +              X)* (0.5D0* (B+D)-C)))
          END IF
      END IF
C
      Y = ONE
C
      RETURN

      END

        PROGRAM CPEX13
C
C This program produces a detailed picture of the contents of a typical
C CONPACK-produced area map.  It then shows three different situations
C that tend to cause problems.  This example is intended to be viewed
C while reading the text from the programmer document for CONPACK that
C describes each of the four frames.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
        PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Define various local parameters.
C
        PARAMETER (LRWK=5000,LIWK=5000,LAMA=20000,NCLV=4)
C
C Declare the basic data array, a real workspace array, and an integer
C workspace array.
C
        DIMENSION ZDAT(7,7),RWRK(LRWK),IWRK(LIWK)
C
C Declare a bigger data array to use for rho/theta data.
C
        DIMENSION RHTH(10,25)
C
C Declare an area-map array.
C
        DIMENSION IAMA(LAMA)
C
C Declare an array to hold contour levels.
C
        DIMENSION CLEV(NCLV)
C
C Define the contour levels at which contours are to be generated.
C
        DATA CLEV / .25,.52,.90,1.40 /
C
C Open GKS.
C
        CALL GOPKS (IERRF, ISZDM)
        CALL GOPWK (IWKID, LUNIT, IWTYPE)
        CALL GACWK (IWKID)
C
C Turn off clipping by GKS.
C
        CALL GSCLIP (0)
C
C Set internal parameters of AREAS that affect the appearance of the
C debug plots produced by ARDBPX.
C
        CALL ARSETR ('ID - IDENTIFIER DISTANCE',.008)
        CALL ARSETR ('IS - IDENTIFIER SIZE',.008)
        CALL ARSETR ('AL - ARROWHEAD LENGTH',0.)
        CALL ARSETR ('AW - ARROWHEAD WIDTH',0.)
C
C Tell the dash package to use alternating solids and gaps.  This
C pattern will be used for the circles on frame 3.
C
        CALL DPSETC ('DPT - DASH PATTERN','$_')
C
C Tell PLOTCHAR to use font number 25 (a filled font) and to outline
C each character.
C
        CALL PCSETI ('FN - FONT NUMBER',25)
        CALL PCSETI ('OF - OUTLINE FLAG',1)
C
C Tell PLOTCHAR to tell the Bezier package to reproduce the curves
C outlining the characters with a little less fidelity.  This cuts
C down on the size of the metafile.
C
        CALL PCSETR ('FB - FIDELITY OF BEZIER CURVES',.00015)
C
C
C ***** FIRST FRAME BEGINS ********************************************
C
C Put a label at the top of the first frame.
C
        CALL PLCHHQ (CFUX(.5),CFUY(.98),
     +          'A DETAILED VIEW OF A CONPACK AREA MAP (EDGE GROUP 3)',
     +                                                       .015,0.,0.)
C
C Put informative labels at the top and bottom of the frame.
C
        CALL PLCHHQ (CFUX(.5),CFUY(.95),'This is a simple case that demo
     +nstrates all the essential features of a CONPACK area map.',
     +                                                       .012,0.,0.)
        CALL PLCHHQ (CFUX(.5),CFUY(.926),'All the edge segments in group
     + 3 are shown, each with its own left and right area identifiers.',
     +                                                       .012,0.,0.)
        CALL PLCHHQ (CFUX(.5),CFUY(.062),'See the CONPACK programmer doc
     +ument for a complete description of this area map.',
     +                                                       .012,0.,0.)
        CALL PLCHHQ (CFUX(.5),CFUY(.038),'Also see the frames that follo
     +w for examples of situations in which problems can arise.',
     +                                                       .012,0.,0.)
C
C Define the mapping from the "user" system to the fractional system.
C
        CALL SET    (.05,.95,.05,.95,-.1,1.1,-.1,1.1,1)
C
C Tell CONPACK not to call SET.
C
        CALL CPSETI ('SET - DO-SET-CALL FLAG',0)
C
C Tell CONPACK to map output coordinates.  Included below is a special
C version of CPMPXY that, when 'MAP' = 1, does an identity mapping, but
C generates some out-of-range values.
C
        CALL CPSETI ('MAP - MAPPING FLAG',1)
C
C Tell CONPACK what to expect as an out-of-range value in the output
C from CPMPXY.
C
        CALL CPSETR ('ORV - OUT-OF-RANGE VALUE',1.E12)
C
C Tell CONPACK not to select contour levels.  We'll do it.
C
        CALL CPSETI ('CLS - CONTOUR LEVEL SELECTION METHOD',0)
C
C Tell CONPACK how many contour levels to use and exactly what those
C levels are.
C
        CALL CPSETI ('NCL - NUMBER OF CONTOUR LEVELS',NCLV)

        DO 103 ICLV=1,NCLV
          CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',ICLV)
          CALL CPSETR ('CLV - CONTOUR LEVEL',CLEV(ICLV))
          CALL CPSETI ('CLU - CONTOUR LEVEL USE FLAG',3)
  103   CONTINUE
C
C Tell CONPACK to position line labels using the regular scheme and
C modify a few parameters so as to get labels in particular places.
C
        CALL CPSETI ('LLP - LINE LABEL POSITIONING',2)
C
        CALL CPSETR ('RC1 - REGULAR SCHEME CONSTANT 1',.55)
        CALL CPSETR ('RC2 - REGULAR SCHEME CONSTANT 2',.85)
        CALL CPSETR ('RC3 - REGULAR SCHEME CONSTANT 3',0.)
C
        CALL CPSETR ('CWM - CHARACTER WIDTH MULTIPLIER',3.)
C
C Get rid of the informational label.
C
        CALL CPSETC ('ILT - INFORMATIONAL LABEL TEXT',' ')
C
C Tell CONPACK how to map the data grid into coordinates to be
C delivered to CPMPXY.
C
        CALL CPSETR ('XC1 - X COORDINATE FOR I = 1',0.)
        CALL CPSETR ('XCM - X COORDINATE FOR I = M',1.)
        CALL CPSETR ('YC1 - Y COORDINATE FOR J = 1',0.)
        CALL CPSETR ('YCN - Y COORDINATE FOR J = N',1.)
C
C Tell CONPACK what value is used in the data as a special value.
C
        CALL CPSETR ('SPV - SPECIAL VALUE',1.E36)
C
C Generate a simple two-dimensional data field.
C
        DO 102 I=1,7
          XCRD=REAL(I-1)/6.
          DO 101 J=1,7
            YCRD=REAL(J-1)/6.
            ZDAT(I,J)=XCRD**2+YCRD**2
  101     CONTINUE
  102   CONTINUE
C
C Put some special values in the lower left corner of the data field.
C
        ZDAT(1,1)=1.E36
        ZDAT(1,2)=1.E36
        ZDAT(2,1)=1.E36
        ZDAT(2,2)=1.E36
C
C Tell CONPACK the dimensions of its data array, the real workspace
C array, and the integer workspace array, so that it can initialize
C itself to work with those arrays.
C
        CALL CPRECT (ZDAT,7,7,7,RWRK,LRWK,IWRK,LIWK)
C
C Initialize the area map.
C
        CALL ARINAM (IAMA,LAMA)
C
C Put into the area map the viewport perimeter, the boundary of the
C "invisible" area (the area in which CPMPXY returns the value 'ORV'),
C the edge of the grid, the edges of the special-value areas, and the
C contour lines.
C
        CALL CPCLAM (ZDAT,RWRK,IWRK,IAMA)
C
C Put the label boxes into the area map.
C
        CALL CPLBAM (ZDAT,RWRK,IWRK,IAMA)
C
C Call a modified version of the AREAS routine ARDBPA to draw the
C contents of the area map.
C
        CALL ARDBPX (IAMA,3)
C
C Label features of interest on the plot.
C
        CALL PLCHHQ (CFUX(.90),CFUY(.11),'EDGE OF PLOTTER FRAME  ',
     +                                                  .008,0.,1.)
C
        CALL PLCHHQ (CFUX(.86),CFUY(.15),'EDGE OF VIEWPORT  ',
     +                                             .008,0.,1.)
C
        CALL PLCHHQ (CFUX(.80),CFUY(.32),'EDGE',
     +                               .008,0.,0.)
        CALL PLCHHQ (CFUX(.80),CFUY(.30),'OF',
     +                             .008,0.,0.)
        CALL PLCHHQ (CFUX(.80),CFUY(.28),'GRID',
     +                               .008,0.,0.)
C
        CALL PLCHHQ (CFUX(.30),CFUY(.34),'THIS IS A',
     +                                    .008,0.,0.)
        CALL PLCHHQ (CFUX(.30),CFUY(.32),'SPECIAL-VALUE',
     +                                        .008,0.,0.)
        CALL PLCHHQ (CFUX(.30),CFUY(.30),'AREA, IN WHICH ALL',
     +                                             .008,0.,0.)
        CALL PLCHHQ (CFUX(.30),CFUY(.28),'DATA VALUES ARE ',
     +                                           .008,0.,0.)
        CALL PLCHHQ (CFUX(.30),CFUY(.26),'EQUAL TO ''SPV''',
     +                                           .008,0.,0.)
C
        CALL PLCHHQ (CFUX(.77),CFUY(.83),'IN THIS AREA,',
     +                                        .008,0.,0.)
        CALL PLCHHQ (CFUX(.77),CFUY(.81),'CPMPXY RETURNS',
     +                                         .008,0.,0.)
        CALL PLCHHQ (CFUX(.77),CFUY(.79),'COORDINATE VALUES',
     +                                            .008,0.,0.)
        CALL PLCHHQ (CFUX(.77),CFUY(.77),'EQUAL TO ''ORV''; AREA',
     +                                                 .008,0.,0.)
        CALL PLCHHQ (CFUX(.77),CFUY(.75),'IS INVISIBLE UNDER',
     +                                             .008,0.,0.)
        CALL PLCHHQ (CFUX(.77),CFUY(.73),'MAPPING',
     +                                  .008,0.,0.)
C
        CALL PLCHHQ (CFUX(.505),CFUY(.61),'HERE ARE',
     +                                    .008,0.,0.)
        CALL PLCHHQ (CFUX(.505),CFUY(.59),'TWO',
     +                               .008,0.,0.)
        CALL PLCHHQ (CFUX(.505),CFUY(.57),'LABEL BOXES',
     +                                       .008,0.,0.)
C
        CALL PLCHHQ (CFUX(.28),CFUY(.43),'CONTOUR BAND 1',
     +                                         .008,0.,0.)
C
        CALL PLCHHQ (CFUX(.30),CFUY(.53),'CONTOUR BAND 2',
     +                                         .008,0.,0.)
C
        CALL PLCHHQ (CFUX(.36),CFUY(.67),'CONTOUR BAND 3',
     +                                         .008,0.,0.)
C
        CALL PLCHHQ (CFUX(.52),CFUY(.75),'CONTOUR BAND 4',
     +                                         .008,0.,0.)
C
        CALL PLCHHQ (CFUX(.48),CFUY(.30),'CONTOUR',
     +                                  .008,0.,0.)
        CALL PLCHHQ (CFUX(.48),CFUY(.28),'(LEVEL 1)',
     +                                    .008,0.,0.)
C
        CALL PLCHHQ (CFUX(.62),CFUY(.31),'CONTOUR',
     +                                  .008,0.,0.)
        CALL PLCHHQ (CFUX(.62),CFUY(.29),'(LEVEL 2)',
     +                                    .008,0.,0.)
C
        CALL PLCHHQ (CFUX(.73),CFUY(.40),'CONTOUR',
     +                                  .008,0.,0.)
        CALL PLCHHQ (CFUX(.73),CFUY(.38),'(LEVEL 3)',
     +                                    .008,0.,0.)
C
        CALL PLCHHQ (CFUX(.745),CFUY(.615),'CONTOUR',
     +                                    .008,0.,0.)
        CALL PLCHHQ (CFUX(.745),CFUY(.596),'(LEVEL 4)',
     +                                      .008,0.,0.)
C
C Advance the frame.
C
        CALL FRAME
C
C
C ***** SECOND FRAME BEGINS *******************************************
C
C Put a label at the top of the second frame.
C
        CALL PLCHHQ (CFUX(.5),CFUY(.98),'CONPACK AREA MAPS - FRAME 2',
     +                                                       .015,0.,0.)
C
C Put informative labels at the top and bottom of the frame.
C
        CALL PLCHHQ (CFUX(.5),CFUY(.95),'This frame shows what happens w
     +hen CPMPXY can''t do inverses (or incorrectly says it can''t).',
     +                                                       .012,0.,0.)
        CALL PLCHHQ (CFUX(.5),CFUY(.926),'The algorithm that generates t
     +he edge of the invisible area doesn''t work so well then.',
     +                                                       .012,0.,0.)
        CALL PLCHHQ (CFUX(.5),CFUY(.062),'In this case, the effects aren
     +''t too bad; more serious effects are sometimes seen.',
     +                                                       .012,0.,0.)
        CALL PLCHHQ (CFUX(.5),CFUY(.038),'See the CONPACK programmer doc
     +ument for a complete discussion of this problem.',
     +                                                       .012,0.,0.)
C
C Change to mapping function 2 to illustrate the problem with a CPMPXY
C that doesn't do inverses.  'MAP' = 2 is just like 'MAP' = 1 except
C that it doesn't do inverses.
C
        CALL CPSETI ('MAP - MAPPING FLAG',2)
C
C Tell CONPACK the dimensions of its data array, the real workspace
C array, and the integer workspace array, so that it can initialize
C itself to work with those arrays.
C
        CALL CPRECT (ZDAT,7,7,7,RWRK,LRWK,IWRK,LIWK)
C
C Initialize the area map.
C
        CALL ARINAM (IAMA,LAMA)
C
C Put into the area map the viewport perimeter, the boundary of the
C "invisible" area (the area in which CPMPXY returns the value 'ORV'),
C the edge of the grid, the edges of the special-value areas, and the
C contour lines.
C
        CALL CPCLAM (ZDAT,RWRK,IWRK,IAMA)
C
C Put the label boxes into the area map.
C
        CALL CPLBAM (ZDAT,RWRK,IWRK,IAMA)
C
C Call a modified version of the AREAS routine ARDBPA to draw the
C contents of the area map.
C
        CALL ARDBPX (IAMA,3)
C
C Label features of interest on the plot.
C
        CALL PLCHHQ (CFUX(.90),CFUY(.11),'EDGE OF PLOTTER FRAME  ',
     +                                                  .008,0.,1.)
C
        CALL PLCHHQ (CFUX(.86),CFUY(.15),'EDGE OF VIEWPORT  ',
     +                                             .008,0.,1.)
C
        CALL PLCHHQ (CFUX(.80),CFUY(.32),'EDGE',
     +                               .008,0.,0.)
        CALL PLCHHQ (CFUX(.80),CFUY(.30),'OF',
     +                             .008,0.,0.)
        CALL PLCHHQ (CFUX(.80),CFUY(.28),'GRID',
     +                               .008,0.,0.)
C
        CALL PLCHHQ (CFUX(.30),CFUY(.31),'SPECIAL-VALUE',
     +                                        .008,0.,0.)
        CALL PLCHHQ (CFUX(.30),CFUY(.29),'AREA',
     +                               .008,0.,0.)
C
        CALL PLCHHQ (CFUX(.77),CFUY(.78),'INVISIBLE AREA',
     +                                         .008,0.,0.)
C
        CALL PLCHHQ (CFUX(.505),CFUY(.59),'LABEL BOXES',
     +                                       .008,0.,0.)
C
        CALL PLCHHQ (CFUX(.28),CFUY(.43),'CONTOUR BAND 1',
     +                                         .008,0.,0.)
C
        CALL PLCHHQ (CFUX(.30),CFUY(.53),'CONTOUR BAND 2',
     +                                         .008,0.,0.)
C
        CALL PLCHHQ (CFUX(.36),CFUY(.67),'CONTOUR BAND 3',
     +                                         .008,0.,0.)
C
        CALL PLCHHQ (CFUX(.52),CFUY(.75),'CONTOUR BAND 4',
     +                                         .008,0.,0.)
C
        CALL PLCHHQ (CFUX(.48),CFUY(.30),'CONTOUR',
     +                                  .008,0.,0.)
        CALL PLCHHQ (CFUX(.48),CFUY(.28),'AT LEVEL 1',
     +                                     .008,0.,0.)
C
        CALL PLCHHQ (CFUX(.62),CFUY(.31),'CONTOUR',
     +                                  .008,0.,0.)
        CALL PLCHHQ (CFUX(.62),CFUY(.29),'AT LEVEL 2',
     +                                     .008,0.,0.)
C
        CALL PLCHHQ (CFUX(.73),CFUY(.40),'CONTOUR',
     +                                  .008,0.,0.)
        CALL PLCHHQ (CFUX(.73),CFUY(.38),'AT LEVEL 3',
     +                                     .008,0.,0.)
C
        CALL PLCHHQ (CFUX(.745),CFUY(.615),'CONTOUR',
     +                                    .008,0.,0.)
        CALL PLCHHQ (CFUX(.745),CFUY(.596),'AT LEVEL 4',
     +                                       .008,0.,0.)
C
C Advance the frame.
C
        CALL FRAME
C
C
C ***** THIRD FRAME BEGINS ********************************************
C
C Put a label at the top of the third frame.
C
        CALL PLCHHQ (CFUX(.5),CFUY(.98),'CONPACK AREA MAPS - FRAME 3',
     +                                                       .015,0.,0.)
C
C Put informative labels at the top and bottom of the frame.
C
        CALL PLCHHQ (CFUX(.5),CFUY(.95),'Sometimes a segment of a contou
     +r line is parallel to and just barely inside the edge of the grid.
     +',
     +                                                       .012,0.,0.)
        CALL PLCHHQ (CFUX(.5),CFUY(.926),'The dashed circles in the area
     + map below show the locations of two such contour-line segments.',
     +                                                       .012,0.,0.)
        CALL PLCHHQ (CFUX(.5),CFUY(.074), 'Prior to version 4, the outer
     + area identifier for such a segment could "leak" outside the grid.
     +',
     +                                                       .012,0.,0.)
        CALL PLCHHQ (CFUX(.5),CFUY(.050),'Now, conflicting information f
     +rom near-coincident segments is resolved in such a way as to avoid
     + problems.',
     +                                                       .012,0.,0.)
        CALL PLCHHQ (CFUX(.5),CFUY(.026),'See the CONPACK programmer doc
     +ument for a complete discussion of this problem.',
     +                                                       .012,0.,0.)
C
C Change the mapping back to what it was on the first frame.
C
        CALL CPSETI ('MAP - MAPPING FLAG',1)
C
C Generate data. The value "4.984615" has been carefully chosen to
C create the problem.
C
        DO 105 I=1,7
          XCRD=REAL(I-1)/6.
          DO 104 J=1,7
            YCRD=REAL(J-1)/6.
            ZDAT(I,J)=4.984615*((XCRD-.58333333)**2+(YCRD-.58333333)**2)
  104     CONTINUE
  105   CONTINUE
C
C Salt in some special values.
C
        ZDAT(1,1)=1.E36
        ZDAT(1,2)=1.E36
        ZDAT(2,1)=1.E36
        ZDAT(2,2)=1.E36
C
C Initialize the area map.
C
        CALL ARINAM (IAMA,LAMA)
C
C Tell CONPACK the dimensions of its data array, the real workspace
C array, and the integer workspace array, so that it can initialize
C itself to work with those arrays.
C
        CALL CPRECT (ZDAT,7,7,7,RWRK,LRWK,IWRK,LIWK)
C
C Put into the area map the viewport perimeter, the boundary of the
C "invisible" area (the area in which CPMPXY returns the value 'ORV'),
C the edge of the grid, the edges of the special-value areas, and the
C contour lines.
C
        CALL CPCLAM (ZDAT,RWRK,IWRK,IAMA)
C
C Call a modified version of the AREAS routine ARDBPA to draw the
C contents of the area map.
C
        CALL ARDBPX (IAMA,3)
C
C Draw a couple of circles around the problem areas.
C
        CALL CIRCLE (.1+.8*CUFX(.58333333),.1+.8*CUFY(1.),.065)
        CALL CIRCLE (.1+.8*CUFX(1.),.1+.8*CUFY(.58333333),.065)
C
C Label features of interest on the plot.
C
        CALL PLCHHQ (CFUX(.90),CFUY(.11),'EDGE OF PLOTTER FRAME  ',
     +                                                  .008,0.,1.)
C
        CALL PLCHHQ (CFUX(.86),CFUY(.15),'EDGE OF VIEWPORT  ',
     +                                             .008,0.,1.)
C
        CALL PLCHHQ (CFUX(.80),CFUY(.31),'EDGE',
     +                               .008,0.,0.)
        CALL PLCHHQ (CFUX(.80),CFUY(.29),'OF',
     +                             .008,0.,0.)
        CALL PLCHHQ (CFUX(.80),CFUY(.27),'GRID',
     +                               .008,0.,0.)
C
        CALL PLCHHQ (CFUX(.30),CFUY(.31),'SPECIAL-VALUE',
     +                                        .008,0.,0.)
        CALL PLCHHQ (CFUX(.30),CFUY(.29),'AREA',
     +                               .008,0.,0.)
C
        CALL PLCHHQ (CFUX(.77),CFUY(.78),'INVISIBLE AREA',
     +                                         .008,0.,0.)
C
C Advance the frame.
C
        CALL FRAME
C
C
C ***** FOURTH FRAME BEGINS *******************************************
C
C Put a label at the top of the fourth frame.
C
        CALL PLCHHQ (CFUX(.5),CFUY(.98),'CONPACK AREA MAPS - FRAME 4',
     +                                                       .015,0.,0.)
C
C Put informative labels at the top and bottom of the frame.
C
        CALL PLCHHQ (CFUX(.5),CFUY(.95),'Some mappings transform two dif
     +ferent parts of the grid to the same place in user coordinate spac
     +e.',
     +                                                       .012,0.,0.)
        CALL PLCHHQ (CFUX(.5),CFUY(.926),'The :F33:r/q:F: mapping used h
     +ere maps the grid into a doughnut; left and right edges map to the
     + same line.',
     +                                                       .012,0.,0.)
        CALL PLCHHQ (CFUX(.5),CFUY(.074),'Similarly, EZMAP frequently ma
     +ps the left and right edges of the grid into the same great circle
     +.',
     +                                                       .012,0.,0.)
        CALL PLCHHQ (CFUX(.5),CFUY(.050), 'This can sometimes cause area
     + identifiers for the outside of the grid to appear to apply to the
     + inside.',
     +                                                       .012,0.,0.)
        CALL PLCHHQ (CFUX(.5),CFUY(.026),'See the CONPACK programmer doc
     +ument for a complete discussion of this problem.',
     +                                                       .012,0.,0.)
C
C Redefine the mapping from the user system to the fractional system.
C
        CALL SET    (.05,.95,.05,.95,-1.1,1.1,-1.1,1.1,1)
C
C Change the mapping function to be used.  For 'MAP' = 3, we get a
C standard rho/theta mapping.
C
        CALL CPSETI ('MAP - MAPPING FLAG',3)
C
C Tell CONPACK that no out-of-range values will be returned.
C
        CALL CPSETR ('ORV - OUT-OF-RANGE VALUE',0.)
C
C Change the X and Y values assumed to correspond to the edges of the
C data grid.
C
        CALL CPSETR ('XC1 - X COORDINATE FOR I = 1',.3)
        CALL CPSETR ('XCM - X COORDINATE FOR I = M',1.)
        CALL CPSETR ('YC1 - Y COORDINATE FOR J = 1',  0.)
        CALL CPSETR ('YCN - Y COORDINATE FOR J = N',360.)
C
C Generate rho/theta data.
C
        DO 107 I=1,10
          RHO=.3+.07*REAL(I)
          DO 106 J=1,25
            THETA=.017453292519943*REAL(15*J-15)
            RHTH(I,J)=2.*RHO*COS(THETA)**2+RHO*SIN(THETA)**2
  106     CONTINUE
  107   CONTINUE
C
C Tell CONPACK the dimensions of its data array, the real workspace
C array, and the integer workspace array, so that it can initialize
C itself to work with those arrays.
C
        CALL CPRECT (RHTH,10,10,25,RWRK,LRWK,IWRK,LIWK)
C
C Initialize the area map.
C
        CALL ARINAM (IAMA,LAMA)
C
C Put into the area map the viewport perimeter, the  edge of the grid,
C the edges of the special-value areas, and the contour lines.
C
        CALL CPCLAM (RHTH,RWRK,IWRK,IAMA)
C
C Call a modified version of the AREAS routine ARDBPA to draw the
C contents of the area map.
C
        CALL ARDBPX (IAMA,3)
C
C Label features of interest on the plot.
C
        CALL PLCHHQ (CFUX(.90),CFUY(.11),'EDGE OF PLOTTER FRAME  ',
     +                                                  .008,0.,1.)
C
        CALL PLCHHQ (CFUX(.86),CFUY(.15),'EDGE OF VIEWPORT  ',
     +                                             .008,0.,1.)
C
        CALL PLCHHQ (CFUX(.24),CFUY(.83),'UPPER EDGE OF',
     +                                        .008,0.,0.)
        CALL PLCHHQ (CFUX(.24),CFUY(.81),'DATA GRID MAPS',
     +                                         .008,0.,0.)
        CALL PLCHHQ (CFUX(.24),CFUY(.79),'TO OUTER CIRCLE',
     +                                          .008,0.,0.)
C
        CALL PLCHHQ (CFUX(.50),CFUY(.52),'LOWER EDGE OF',
     +                                        .008,0.,0.)
        CALL PLCHHQ (CFUX(.50),CFUY(.50),'DATA GRID MAPS',
     +                                         .008,0.,0.)
        CALL PLCHHQ (CFUX(.50),CFUY(.48),'TO INNER CIRCLE',
     +                                          .008,0.,0.)
C
        CALL PLCHHQ (CFUX(.76),CFUY(.83),'LEFT AND RIGHT EDGES',
     +                                               .008,0.,0.)
        CALL PLCHHQ (CFUX(.76),CFUY(.81),'OF DATA GRID MAP TO',
     +                                              .008,0.,0.)
        CALL PLCHHQ (CFUX(.76),CFUY(.79),'HORIZONTAL LINE',
     +                                          .008,0.,0.)
C
C Advance the frame.
C
        CALL FRAME
C
C Close GKS.
C
        CALL GDAWK (IWKID)
        CALL GCLWK (IWKID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END



      SUBROUTINE CPMPXY (IMAP,XINP,YINP,XOTP,YOTP)
C
C When 'MAP' = 1, this version of CPMPXY just does the identity mapping
C and its inverse except in the upper right corner, in which it returns
C the out-of-range value (for illustrative purposes).
C
C Using 'MAP' = 2 is the same except that the routine says that it can't
C do the inverse mapping (IMAP = 0 and XINP = 1 gives YINP = 1 instead
C of 3).  This is used to show the adverse effects on the generation of
C the edge of the area invisible under the mapping.
C
C Using 'MAP' = 3 gives the polar coordinate transformation and its
C inverse.  No out-of-range values can be returned.
C
        IF (IMAP.EQ.0) THEN
          IF (XINP.EQ.1.) THEN
            YINP=3.
          ELSE IF (XINP.EQ.2.) THEN
            YINP=1.
          ELSE IF (XINP.EQ.3.) THEN
            YINP=3.
          ELSE
            YINP=3.
          END IF
        ELSE IF (ABS(IMAP).EQ.1.OR.ABS(IMAP).EQ.2) THEN
          IF ((XINP-1.)**2+(YINP-1.)**2.GT..0625) THEN
            XOTP=XINP
            YOTP=YINP
          ELSE
            XOTP=1.E12
            YOTP=1.E12
          END IF
        ELSE IF (ABS(IMAP).EQ.3) THEN
          IF (IMAP.GT.0) THEN
            XOTP=XINP*COS(.017453292519943*YINP)
            YOTP=XINP*SIN(.017453292519943*YINP)
          ELSE
            XOTP=SQRT(XINP*XINP+YINP*YINP)
            YOTP=57.2957795130823*ATAN2(YINP,XINP)
          END IF
        ELSE
          XOTP=XINP
          YOTP=YINP
        END IF
C
C Done.
C
        RETURN
C
      END



      SUBROUTINE ARDBPX (IAMA,IGIP)
C
        DIMENSION IAMA(*)
C
C The routine ARDBPX produces a picture of that part of the contents of
C the area map IAMA that belongs to the group IGIP; if IGIP is zero or
C negative, all groups of edges are shown.  This is a modified version
C of the AREAS routine ARDBPA.  No label is written at the top.  All
C color-setting and error-recovery code has been removed.  The code
C computing RXCN and RYCN has been changed to force the picture into
C a smaller square than the whole plotter frame (so that labels near
C the edge are readable and there is room for additional labels at top
C and bottom).
C
C The common block ARCOM1 is used to communicate with the arrow-drawing
C routine ARDBDA.
C
        COMMON /ARCOM1/ DT
C
C Bump the line width by a factor of two.
C
        CALL GSLWSC (2.)
C
C Extract the length of the area map.
C
        LAMA=IAMA(1)
C
C Save the current state of the SET call and switch to the fractional
C coordinate system.
C
        CALL GETSET (XVPL,XVPR,YVPB,YVPT,XWDL,XWDR,YWDB,YWDT,LNLG)
        CALL    SET (  0.,  1.,  0.,  1.,  0.,  1.,  0.,  1.,   1)
C
C Trace the edges in the area map, drawing arrows as we go.
C
        DT=0.
        INDX=8
        RXCN=.5
        RYCN=.5
C
  101   RXCO=RXCN
        RYCO=RYCN
C
        RXCN=.1+.8*REAL(IAMA(INDX+1))/1000000.
        RYCN=.1+.8*REAL(IAMA(INDX+2))/1000000.
C
        IF (IAMA(INDX+7).NE.0) THEN
          IGID=ABS(IAMA(INDX+7))
          IF (IGID.LT.IAMA(6)) THEN
            IGID=IAMA(IAMA(1)-IGID)/2
          ELSE
            IGID=IAMA(IGID)/2
          END IF
          IF (IGIP.LE.0.OR.IGID.EQ.IGIP) THEN
            IAIL=IAMA(INDX+8)
            IF (IAIL.GT.0) IAIL=IAMA(IAIL)/2
            IAIR=IAMA(INDX+9)
            IF (IAIR.GT.0) IAIR=IAMA(IAIR)/2
            CALL ARDBDA (RXCO,RYCO,RXCN,RYCN,IAIL,IAIR,IGIP,IGID)
          END IF
        ELSE
          DT=0.
        END IF
C
        IF (IAMA(INDX+3).NE.0) THEN
          INDX=IAMA(INDX+3)
          GO TO 101
        END IF
C
C Restore the original SET call.
C
        CALL SET (XVPL,XVPR,YVPB,YVPT,XWDL,XWDR,YWDB,YWDT,LNLG)
C
C Set the line width back to normal.
C
        CALL GSLWSC (1.)
C
C Done.
C
        RETURN
C
      END



      SUBROUTINE CIRCLE (XCEN,YCEN,RADC)
C
C This routine draws a circle with center (XCEN,YCEN) and radius RADC.
C All input variables are stated in the fractional system.
C
        CALL DPDRAW (XCEN+RADC,YCEN,0)
C
        DO 101 I=1,90
          ANGR=.017453292519943*REAL(4*I)
          CALL DPDRAW (XCEN+RADC*COS(ANGR),YCEN+RADC*SIN(ANGR),1)
  101   CONTINUE
C
        CALL DPDRAW (0.,0.,2)
C
C Done.
C
        RETURN
C
      END

C
C	$Id: csvoro.f,v 1.12 2008-07-27 03:10:09 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CSVORO(NPTS,RLATI,RLONI,NI,NF,IWK,RWK,NC,RLATO,RLONO,
     +                    RC,NCA,NUMV,NV,IER)
      DOUBLE PRECISION RWK(*)
C
C  This subroutine returns vertices for a Voronoi polygon
C  enclosing a given input coordinate.
C
C  Arguments:
C
C    NPTS  (Input)
C      The number of input data points (NPTS > 3)
C    RLATI  (Input)
C      An array, dimensioned for NPTS, containing the latitudes
C      of the input coordinates, in degrees.
C    RLONI  (Input)
C      An array, dimensioned for NPTS, containing the longitudes
C      of the input coordinates, in degrees.
C    NI (Input)
C      The index of the input coordinate for which you want
C      to determine the Voronoi polygon (0 .LE. NI .LE. NPTS).
C    NF (Input)
C      Flag indicating if this is the first call to CSVORO
C      to retrieve Voronoi polygons for this dataset (1=yes,
C      0=no).  Calls subsequent to the first call for a given
C      dataset are much faster than the first call.
C    IWK (Input)
C      Integer work space dimensioned for 27*NPTS.
C    RWK (Input)
C      Double precision work space dimensioned for 9*NPTS.
C    NC (Input)
C      The maximum size of the output arrays RLATO, RLONO, and RC.
C      NC should be 2*NPTS.
C    RLATO (Output)
C      An array of latitude values for the Voronoi indices.  These
C      are circumcenters of circles passing through the Delaunay
C      triangles.  If a coordinate is a boundary point, then
C      the circle may pass through certain "pseudo points" that
C      have been added to the original dataset in order to complete
C      the Voronoi polygon.  RLATO is returned in degrees.
C    RLONO (Output)
C      An array of longitude values for the Voronoi indices.  These
C      are circumcenters of circles passing through the Delaunay
C      triangles.  If a coordinate is a boundary point, then
C      the circle may pass through certain "pseudo points" that
C      have been added to the original dataset in order to complete
C      the Voronoi polygon.  RLONO is returned in degrees.
C    RC (Output)
C      Array containing the arc length (in degrees) of the angle
C      between a circumcenter and its associated triangle vertices.
C    NCA (Output)
C      The actual number of circumcenters returned in RLATO and RLONO.
C      This number may be larger than NPTS if the input dataset has
C      boundary points, since certain "pseudo points" may have been
C      added to the original dataset in order to complete the Voronoi
C      polygon set.
C    NUMV (Output)
C      The number of vertices in the Voronoi polygon enclosing
C      the coordinate (RLATI(NI),RLONI(NI)).
C    NV (Output)
C      An array (dimensioned for NPTS) containing NUMV indices for
C      the Voronoi polygon enclosing the coordinate (RLATI(NI),RLONI(NI)).
C      The indices returned in this array refer to the coordinates
C      returned in RLATO and RLONO.  For example, if the integer
C      "J" is an element of the NV array, then (RLATO(J),RLONO(J))
C      is a vertex of the Voronoi polygon enclosing (RLATI(NI),RLONI(NI)).
C      The indices in NV list out the vertices of the Voronoi in
C      counter-clockwise order.
C    IER (Output)
C      An error return value as per:
C         IER =  0  no error.
C         IER =  1  NPTS < 3.
C         IER =  4  first three coordinates are collinear.
C         IER =  6  internal error
C         IER = -L  if coordinates L and M coincide for some
C                   M > L >= 1 .
C
      PARAMETER (D2R=0.017453293, R2D=57.295778)
      DIMENSION RLATI(NPTS),RLONI(NPTS),IWK(*),RLATO(NC),RLONO(NC),
     +          RC(NC),NV(NPTS)
C
      SAVE
C
      IF (NF.EQ.1) THEN
C
C       Workspace position   Associated Variable     Size
C       ------------------   -------------------   --------
C         IWK(        1)            LIST            6*NPTS
C         IWK( 6*NPTS+1)            LPTR            6*NPTS
C         IWK(12*NPTS+1)            LEND              NPTS
C         IWK(13*NPTS+1)            NEAR              NPTS
C         IWK(14*NPTS+1)            NEXT              NPTS
C         IWK(15*NPTS+1)            LTRI            6*NPTS
C         IWK(21*NPTS+1)            LISTC           6*NPTS
C
C
C  Convert RLATI and RLONI to radians.
C
        N = NPTS 
        DO 7 I=1,N
          RWK(3*N+I) = DBLE(D2R*RLATI(I))
          RWK(4*N+I) = DBLE(D2R*RLONI(I))
    7   CONTINUE
C
C  Then convert to Cartesian coordinates.
C
        CALL CSTRANSD(N,RWK(3*N+1),RWK(4*N+1),RWK(1),
     +               RWK(N+1),RWK(2*N+1))
C
        CALL CSTRMESH(NPTS,RWK(1),RWK(N+1),RWK(2*N+1),
     +                IWK(1),IWK(6*NPTS+1),
     +                IWK(12*NPTS+1),LNEW,IWK(13*NPTS+1),
     +                IWK(14*NPTS+1),RWK(3*N+1),IER)
        IF (IER.EQ.0) THEN
            GO TO 210
        ELSE IF (IER.EQ.-1) THEN
            IER = 1
            GO TO 200
        ELSE IF (IER.EQ.-2) THEN
            IER = 4
            GO TO 200
        ELSE IF (IER.EQ.-3) THEN
            IER = 6
            GO TO 200
        ELSE IF (IER.GT.0) THEN
            IER = -IER
            GO TO 200
        ELSE
            IER = 6
            GO TO 200
C
        END IF
  210   CONTINUE
C
        N2 = NPTS*2
        DO 10 I = 1,N2
            RWK(3*N+I) = -99999.
   10   CONTINUE
C
C  Get the pointers to the Voronoi polygon vertices.
C
        CALL CSCRLIST(NPTS,NPTS,RWK(1),RWK(N+1),RWK(2*N+1),
     +                IWK(1),IWK(12*NPTS+1),
     +                IWK(6*NPTS+1),LNEW,IWK(15*NPTS+1),
     +                IWK(21*NPTS+1),NB,
     +                RWK(3*N+1),RWK(5*N+1),RWK(7*N+1),IER)
        IF (IER.EQ.0) THEN
            DO 160 K=1,N2
              RLATO(K) = R2D*REAL(RWK(3*N+K))
              RLONO(K) = R2D*REAL(RWK(5*N+K))
              RC(K)    = R2D*REAL(RWK(7*N+K))
  160       CONTINUE 
            GO TO 220
        ELSE IF (IER.EQ.1) THEN
            GO TO 200
        ELSE IF (IER.EQ.2) THEN
            IER = 10
            GO TO 200
        ELSE IF (IER.EQ.3) THEN
            IER = 11
            GO TO 200
        ELSE
            IER = 6
            GO TO 200
        END IF
  220   CONTINUE
C
C  Determine the number of circumcenters returned.
C
        DO 20 I = 1,N2
          IF (RWK(3*N+I).EQ.-99999.) THEN
            NCA = I - 1
            GO TO 25
          END IF
          IF (I.EQ.N2) NCA = N2
   20     CONTINUE
   25   CONTINUE
      END IF
C
C  Return the indices for the desired Voronoi polygon.
C
      LPL = IWK(12*NPTS+NI)
      NUMV = 1
      NV(NUMV) = IWK(21*NPTS+LPL)
      LP = LPL
   30 CONTINUE
      LP = IWK(6*NPTS+LP)
      NUMV = NUMV + 1
      NV(NUMV) = IWK(21*NPTS+LP)
      IF (LP.NE.LPL) GO TO 30
      RETURN
C
  200 CONTINUE
      CALL CSSERR('CSVORO',IER)
      NCA = 0
      NUMV = 0
      RETURN
C
      END

      SUBROUTINE CLATRZ( M, N, L, A, LDA, TAU, WORK )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      INTEGER            L, LDA, M, N
*     ..
*     .. Array Arguments ..
      COMPLEX            A( LDA, * ), TAU( * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  CLATRZ factors the M-by-(M+L) complex upper trapezoidal matrix
*  [ A1 A2 ] = [ A(1:M,1:M) A(1:M,N-L+1:N) ] as ( R  0 ) * Z by means
*  of unitary transformations, where  Z is an (M+L)-by-(M+L) unitary
*  matrix and, R and A1 are M-by-M upper triangular matrices.
*
*  Arguments
*  =========
*
*  M       (input) INTEGER
*          The number of rows of the matrix A.  M >= 0.
*
*  N       (input) INTEGER
*          The number of columns of the matrix A.  N >= 0.
*
*  L       (input) INTEGER
*          The number of columns of the matrix A containing the
*          meaningful part of the Householder vectors. N-M >= L >= 0.
*
*  A       (input/output) COMPLEX array, dimension (LDA,N)
*          On entry, the leading M-by-N upper trapezoidal part of the
*          array A must contain the matrix to be factorized.
*          On exit, the leading M-by-M upper triangular part of A
*          contains the upper triangular matrix R, and elements N-L+1 to
*          N of the first M rows of A, with the array TAU, represent the
*          unitary matrix Z as a product of M elementary reflectors.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(1,M).
*
*  TAU     (output) COMPLEX array, dimension (M)
*          The scalar factors of the elementary reflectors.
*
*  WORK    (workspace) COMPLEX array, dimension (M)
*
*  Further Details
*  ===============
*
*  Based on contributions by
*    A. Petitet, Computer Science Dept., Univ. of Tenn., Knoxville, USA
*
*  The factorization is obtained by Householder's method.  The kth
*  transformation matrix, Z( k ), which is used to introduce zeros into
*  the ( m - k + 1 )th row of A, is given in the form
*
*     Z( k ) = ( I     0   ),
*              ( 0  T( k ) )
*
*  where
*
*     T( k ) = I - tau*u( k )*u( k )',   u( k ) = (   1    ),
*                                                 (   0    )
*                                                 ( z( k ) )
*
*  tau is a scalar and z( k ) is an l element vector. tau and z( k )
*  are chosen to annihilate the elements of the kth row of A2.
*
*  The scalar tau is returned in the kth element of TAU and the vector
*  u( k ) in the kth row of A2, such that the elements of z( k ) are
*  in  a( k, l + 1 ), ..., a( k, n ). The elements of R are returned in
*  the upper triangular part of A1.
*
*  Z is given by
*
*     Z =  Z( 1 ) * Z( 2 ) * ... * Z( m ).
*
*  =====================================================================
*
*     .. Parameters ..
      COMPLEX            ZERO
      PARAMETER          ( ZERO = ( 0.0E+0, 0.0E+0 ) )
*     ..
*     .. Local Scalars ..
      INTEGER            I
      COMPLEX            ALPHA
*     ..
*     .. External Subroutines ..
      EXTERNAL           CLACGV, CLARFG, CLARZ
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          CONJG
*     ..
*     .. Executable Statements ..
*
*     Quick return if possible
*
      IF( M.EQ.0 ) THEN
         RETURN
      ELSE IF( M.EQ.N ) THEN
         DO 10 I = 1, N
            TAU( I ) = ZERO
   10    CONTINUE
         RETURN
      END IF
*
      DO 20 I = M, 1, -1
*
*        Generate elementary reflector H(i) to annihilate
*        [ A(i,i) A(i,n-l+1:n) ]
*
         CALL CLACGV( L, A( I, N-L+1 ), LDA )
         ALPHA = CONJG( A( I, I ) )
         CALL CLARFG( L+1, ALPHA, A( I, N-L+1 ), LDA, TAU( I ) )
         TAU( I ) = CONJG( TAU( I ) )
*
*        Apply H(i) to A(1:i-1,i:n) from the right
*
         CALL CLARZ( 'Right', I-1, N-I+1, L, A( I, N-L+1 ), LDA,
     $               CONJG( TAU( I ) ), A( 1, I ), LDA, WORK )
         A( I, I ) = CONJG( ALPHA )
*
   20 CONTINUE
*
      RETURN
*
*     End of CLATRZ
*
      END

C
C	$Id: csbnodes.f,v 1.5 2008-07-27 03:10:06 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CSBNODES (N,LIST,LPTR,LEND, NODES,NB,NA,NT)
      INTEGER N, LIST(*), LPTR(*), LEND(N), NODES(*), NB,
     .        NA, NT
C
C***********************************************************
C
C                                              From STRIPACK
C                                            Robert J. Renka
C                                  Dept. of Computer Science
C                                       Univ. of North Texas
C                                           renka@cs.unt.edu
C                                                   06/26/96
C
C   Given a triangulation of N nodes on the unit sphere
C created by Subroutine CSTRMESH, this subroutine returns an
C array containing the indexes (if any) of the counterclock-
C wise-ordered sequence of boundary nodes -- the nodes on
C the boundary of the convex hull of the set of nodes.  (The
C boundary is empty if the nodes do not lie in a single
C hemisphere.)  The numbers of boundary nodes, arcs, and
C triangles are also returned.
C
C
C On input:
C
C       N = Number of nodes in the triangulation.  N .GE. 3.
C
C       LIST,LPTR,LEND = Data structure defining the trian-
C                        gulation.  Refer to Subroutine
C                        CSTRMESH.
C
C The above parameters are not altered by this routine.
C
C       NODES = Integer array of length at least NB
C               (NB .LE. N).
C
C On output:
C
C       NODES = Ordered sequence of boundary node indexes
C               in the range 1 to N (in the first NB loca-
C               tions).
C
C       NB = Number of boundary nodes.
C
C       NA,NT = Number of arcs and triangles, respectively,
C               in the triangulation.
C
C Modules required by CSBNODES:  None
C
C***********************************************************
C
      INTEGER K, LP, N0, NN, NST
C
C Local parameters:
C
C K =   NODES index
C LP =  LIST pointer
C N0 =  Boundary node to be added to NODES
C NN =  Local copy of N
C NST = First element of nodes (arbitrarily chosen to be
C         the one with smallest index)
C
      NN = N
C
C Search for a boundary node.
C
      DO 1 NST = 1,NN
        LP = LEND(NST)
        IF (LIST(LP) .LT. 0) GO TO 2
    1   CONTINUE
C
C The triangulation contains no boundary nodes.
C
      NB = 0
      NA = 3*(NN-2)
      NT = 2*(NN-2)
      RETURN
C
C NST is the first boundary node encountered.  Initialize
C   for traversal of the boundary.
C
    2 NODES(1) = NST
      K = 1
      N0 = NST
C
C Traverse the boundary in counterclockwise order.
C
    3 LP = LEND(N0)
        LP = LPTR(LP)
        N0 = LIST(LP)
        IF (N0 .EQ. NST) GO TO 4
        K = K + 1
        NODES(K) = N0
        GO TO 3
C
C Store the counts.
C
    4 NB = K
      NT = 2*N - NB - 2
      NA = NT + N - 1
      RETURN
      END

C
C $Id: dprset.f,v 1.5 2008-07-27 00:16:59 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE DPRSET
C
C This routine restores the default values of DASHPACK parameters.
C
C Declare the character common block.
C
        COMMON /DPCMCH/ CHDP,CHRB,CHRG,CHRS
          CHARACTER*256 CHDP
          CHARACTER*1 CHRB,CHRG,CHRS
        SAVE   /DPCMCH/
C
C Declare the real/integer common block.
C
        COMMON /DPCMRI/ ANGF,DBPI,EPSI,IDPI,IDPS,ILTL,INDP,IPCF,ISBF,
     +                  ISCF,LCDP,RLS1,RLS2,RMFS,TENS,WCHR,WGAP,WSLD
        SAVE   /DPCMRI/
C
C Set all values.  For descriptions of the parameters being set, see
C the BLOCK DATA routine DPBLDAX.
C
        ANGF=360.
        CHDP='$$$$$$$$$$$$$$$$'
        CHRB='|'
        CHRG='_'
        CHRS='$'
        DBPI=.01
        EPSI=.000001
        IDPI=0
        IDPS=0
        ILTL=0
        INDP=65535
        IPCF=0
        ISBF=1
        ISCF=0
        LCDP=16
        RLS1=.5
        RLS2=0.
        RMFS=1.
        TENS=-1.
        WCHR=.01
        WGAP=.005
        WSLD=.005
C
C Done.
C
        RETURN
C
      END

C
C	$Id: patdrw.f,v 1.5 2008-07-27 00:59:04 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE PATDRW (IX, IY, IPEN, IOS, STATUS)
C
C  DRAW THE REQUESTED DASH PATTERN
C
C  INPUT
C       IX, IY - THE COORDINATES FOR THE MOVE OR DRAW IN VDC
C       IPEN - THE MOVE DRAW FLAG
C  OUTPUT
C       IOS - THE I/O STATUS FLAG VALID WHEN STATUS SET TO AN I/O ERROR
C       STATUS - THE STATUS FLAG DEFINED BY COMMON TREROR
C
      COMMON /TRDASH/ PATFLG, DASPAT, PATBIT, DEFPAT, DASHX, DASHY,
     1                PATVDC
      INTEGER DPATSZ, PATSIZ, DFPTSZ
      PARAMETER (DPATSZ=16, PATSIZ=320, DFPTSZ=4)
      INTEGER PATFLG, DASPAT, PATBIT, DEFPAT(DFPTSZ), DASHX,
     1        DASHY, PATVDC
      COMMON/TREROR/ ALLOK, MFRCHK, MTOPER, METRDC, REDERR, TYPCHG
     1             ,INVTYP, MINVLD, TYPERR, FRMEND, ENCINT, IVDCDT
     2             ,GCOERR, GCRERR, GCCERR, FCOERR, FCRERR, FCCERR
     3             ,PLIDXG, PMIDXG, TXIDXG, PGIDXG, INVLMT, CELERR
     4             ,COIERR, COLNRM, UNKNOW, UNKOPC, ENDMTF, VNEROR
     5             ,BADRSZ, DEVOUT, NOVERS, BADFNT, PGMERR, FASERR
     6             ,HINERR, VDWERR, RDWERR, RIXLIM
      INTEGER        ALLOK, MFRCHK, MTOPER, METRDC, REDERR, TYPCHG
     1             ,INVTYP, MINVLD, TYPERR, FRMEND, ENCINT, IVDCDT
     2             ,GCOERR, GCRERR, GCCERR, FCOERR, FCRERR, FCCERR
     3             ,PLIDXG, PMIDXG, TXIDXG, PGIDXG, INVLMT, CELERR
     4             ,COIERR, COLNRM, UNKNOW, UNKOPC, ENDMTF, VNEROR
     5             ,BADRSZ, DEVOUT, NOVERS, BADFNT, PGMERR, FASERR
     6             ,HINERR, VDWERR, RDWERR, RIXLIM
      COMMON /TRTYPE/ METMIN, METEXT, METPRT, METHED, MIOPCL, MXOPCL,
     1                MIOPID, MXOPID, ASCDEC, ASCHEX, ASCOCT, BINARY,
     2                GAHNOR, GALEFT, GACENT, GARITE, GAVNOR, GATOP ,
     3                GACAP , GAHALF, GABASE, GABOTT, GRIGHT, GLEFT ,
     4                GUP   ,
     5                GDOWN , CINDEX, CDIRCT, PENUP , PENDN , FLAGVL,
     6                SEPRVL, ASCTEK, TYPRGB, TYPBGR,
     7                TYPHLS, TYPMON, SOLID , DASHED, INVSBL, SOLPAT,
     8                ASFIND, ASFBND, ASFLNT, ASFLNW, ASFLNC, ASFMRT,
     9                ASFMRS, ASFMRC, ASFFIS, ASFFHI, ASFFPI, ASFFCO,
     A                ASFFPT, ASFFPW, ASFFPC, ASFTFI, ASFTPR, ASFTCX,
     B                ASFTCS, ASFTCO, ASCFLT, PHOLLO, PSOLID, PPATTR,
     C                PHATCH, PEMPTY, HHORIZ, HVERTI, HPOSLP, HNESLP,
     D                HHOAVE, HPOANE
      INTEGER         METMIN, METEXT, METPRT, METHED, MIOPCL, MXOPCL,
     1                MIOPID, MXOPID, ASCDEC, ASCHEX, ASCOCT, BINARY,
     2                GAHNOR, GALEFT, GACENT, GARITE, GAVNOR, GATOP ,
     3                GACAP , GAHALF, GABASE, GABOTT, GRIGHT, GLEFT ,
     4                GUP   ,
     5                GDOWN , CINDEX, CDIRCT, PENUP , PENDN , FLAGVL,
     6                SEPRVL, ASCTEK, TYPRGB, TYPBGR,
     7                TYPHLS, TYPMON, SOLID , DASHED, INVSBL, SOLPAT,
     8                ASFIND, ASFBND, ASFLNT, ASFLNW, ASFLNC, ASFMRT,
     9                ASFMRS, ASFMRC, ASFFIS, ASFFHI, ASFFPI, ASFFCO,
     A                ASFFPT, ASFFPW, ASFFPC, ASFTFI, ASFTPR, ASFTCX,
     B                ASFTCS, ASFTCO, ASCFLT, PHOLLO, PSOLID, PPATTR,
     C                PHATCH, PEMPTY, HHORIZ, HVERTI, HPOSLP, HNESLP,
     D                HHOAVE, HPOANE
      COMMON /PTRPARS/  MOPLEN, MCICPR, MCDCPR, MFLCPR, MIXCPR, MWHCPR,
     1                 MOPDLN, MCIDPR, MCDDPR, MFLDPR, MIXDPR, MWHDPR,
     2                 BYTSIZ, CONFLG, MENDPR, MENCPR
      INTEGER MOPCLL, MOPIDL, MSCLEN, MLGFLG, MCOLEN, MLOLEN
      PARAMETER (MOPCLL=4, MOPIDL=7, MCOLEN=1, MSCLEN=5, MLOLEN=15,
     1           MLGFLG=31)
       INTEGER         MOPLEN, MCICPR, MCDCPR, MFLCPR, MIXCPR, MWHCPR,
     1                 MOPDLN, MCIDPR, MCDDPR, MFLDPR, MIXDPR, MWHDPR,
     2                 BYTSIZ, CONFLG, MENDPR, MENCPR
C
      INTEGER IX, IY, IPEN, IOS, STATUS
C
      INTEGER DIST, IP, NX, NY, XD, YD, PDIST
      REAL XMV, YMV
      REAL FLOAT
C
      SAVE PDIST
C
C  IF PATTERN SOLID THEN PASS ON COORDINATES
C
      IF (PATFLG .EQ. SOLID) THEN
                CALL PLTCLP (IX, IY, IPEN, IOS, STATUS)
      ELSE IF (PATFLG .EQ. DASHED) THEN
C
C       DASHED PATTERN
C
        IF (IPEN .EQ. PENUP) THEN
C
C               RESET THE POINTERS THIS IS A MOVE
C
                PDIST = PATVDC
                PATBIT = 0
                DASHX = IX
                DASHY = IY
                CALL PLTCLP (IX, IY, IPEN,IOS, STATUS)
        ELSE
C
C               PEN DOWN SO COMPUTE DISTANCE
C
                XD = IX - DASHX
                YD = IY - DASHY
                DIST = SQRT(FLOAT((XD*XD) + (YD*YD)))
C
C               IF NO DISTANCE THEN RETURN
C
                IF ( DIST .EQ. 0) RETURN
C
                XMV = FLOAT(XD) / FLOAT(DIST)
                YMV = FLOAT(YD) / FLOAT(DIST)
C
C               LOOP FOR ALL DIST
C
 100            CONTINUE
                CALL GBYTES(DASPAT, IP, PATBIT, 1, 0, 1)
                IF (DIST .LE. PDIST) THEN
                        PDIST = PDIST - DIST
                        DIST = 0
                        NX = IX
                        NY = IY
                ELSE
                        NX = FLOAT(DASHX) + FLOAT(PDIST)*XMV
                        NY = FLOAT(DASHY) + FLOAT(PDIST)*YMV
                        DIST = DIST - PDIST
                        PATBIT = PATBIT + 1
                        PDIST = PATVDC
                        IF (PATBIT .EQ. DPATSZ) PATBIT = 0
                END IF
                CALL PLTCLP (NX, NY, IP, IOS, STATUS)
                IF (STATUS .NE. ALLOK) RETURN
                DASHX = NX
                DASHY = NY
C
C               CHECK IF MORE DRAWING REQUIRED
C
                IF (DIST .GT. 0) GO TO 100
C
        END IF
      END IF
C
      RETURN
      END

      SUBROUTINE PASSF4(IDO,L1,CC,CH,WA1,WA2,WA3)
      DOUBLE PRECISION CC
      DOUBLE PRECISION CH
      DOUBLE PRECISION WA1
      DOUBLE PRECISION WA2
      DOUBLE PRECISION WA3
      DOUBLE PRECISION TI1
      DOUBLE PRECISION TI2
      DOUBLE PRECISION TR4
      DOUBLE PRECISION TI3
      DOUBLE PRECISION TR1
      DOUBLE PRECISION TR2
      DOUBLE PRECISION TI4
      DOUBLE PRECISION TR3
      DOUBLE PRECISION CR3
      DOUBLE PRECISION CI3
      DOUBLE PRECISION CR2
      DOUBLE PRECISION CR4
      DOUBLE PRECISION CI2
      DOUBLE PRECISION CI4
      DIMENSION CC(IDO,4,L1),CH(IDO,L1,4),WA1(*),WA2(*),WA3(*)

      IF (IDO.NE.2) GO TO 102
      DO 101 K = 1,L1
          TI1 = CC(2,1,K) - CC(2,3,K)
          TI2 = CC(2,1,K) + CC(2,3,K)
          TR4 = CC(2,2,K) - CC(2,4,K)
          TI3 = CC(2,2,K) + CC(2,4,K)
          TR1 = CC(1,1,K) - CC(1,3,K)
          TR2 = CC(1,1,K) + CC(1,3,K)
          TI4 = CC(1,4,K) - CC(1,2,K)
          TR3 = CC(1,2,K) + CC(1,4,K)
          CH(1,K,1) = TR2 + TR3
          CH(1,K,3) = TR2 - TR3
          CH(2,K,1) = TI2 + TI3
          CH(2,K,3) = TI2 - TI3
          CH(1,K,2) = TR1 + TR4
          CH(1,K,4) = TR1 - TR4
          CH(2,K,2) = TI1 + TI4
          CH(2,K,4) = TI1 - TI4
  101 CONTINUE
      RETURN
  102 DO 104 K = 1,L1
          DO 103 I = 2,IDO,2
              TI1 = CC(I,1,K) - CC(I,3,K)
              TI2 = CC(I,1,K) + CC(I,3,K)
              TI3 = CC(I,2,K) + CC(I,4,K)
              TR4 = CC(I,2,K) - CC(I,4,K)
              TR1 = CC(I-1,1,K) - CC(I-1,3,K)
              TR2 = CC(I-1,1,K) + CC(I-1,3,K)
              TI4 = CC(I-1,4,K) - CC(I-1,2,K)
              TR3 = CC(I-1,2,K) + CC(I-1,4,K)
              CH(I-1,K,1) = TR2 + TR3
              CR3 = TR2 - TR3
              CH(I,K,1) = TI2 + TI3
              CI3 = TI2 - TI3
              CR2 = TR1 + TR4
              CR4 = TR1 - TR4
              CI2 = TI1 + TI4
              CI4 = TI1 - TI4
              CH(I-1,K,2) = WA1(I-1)*CR2 + WA1(I)*CI2
              CH(I,K,2) = WA1(I-1)*CI2 - WA1(I)*CR2
              CH(I-1,K,3) = WA2(I-1)*CR3 + WA2(I)*CI3
              CH(I,K,3) = WA2(I-1)*CI3 - WA2(I)*CR3
              CH(I-1,K,4) = WA3(I-1)*CR4 + WA3(I)*CI4
              CH(I,K,4) = WA3(I-1)*CI4 - WA3(I)*CR4
  103     CONTINUE
  104 CONTINUE
      RETURN
      END

C
C	$Id: g01clw.f,v 1.8 2008-07-27 00:21:05 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE G01CLW
C
C CLEAR WORKSTATION
C
      include 'g01prm.h'
      include 'g01rqa.h'
      include 'gksin.h'
      include 'g01wsl.h'
      include 'g01io.h'
      include 'g01ins.h'
      include 'g01ast.h'
      include 'g01dfa.h'
      include 'g01opc.h'
      include 'gksenu.h'
C
      INTEGER  NBYTES
C
      IF (MDEMPT.EQ.GNEMPT .OR. ID(2).EQ.GALWAY) THEN
C
C  Put out END PICTURE element (CLASS, ID, LENGTH), unless the
C  metafile is being truncated.
C
         IF (ID(3) .NE. 0) THEN
           NBYTES = 0
           CALL GPUTNI (CLENDP, IDENDP, NBYTES, RERR)
          ENDIF
C
C  Flush buffer.
C
         CALL G01FLB (RERR)
         IF (RERR.NE.0)  GO TO 77
C
C  Reset all attribute deferral control variables.
C
         IF (ID(3) .NE. 0) CALL GUPDVA
      ENDIF
C
C  Set WSL entry "DISPLAY SURFACE EMPTY" to "EMPTY"
C
      MDEMPT = GEMPTY
C
C  Set WSL entry "NEW FRAME ACTION NECESSARY AT UPDATE" to "NO".
C
      MNFRAM = GNO
C
C  If update state is pending, set current window and viewport
C  entries to those requested.
C
      IF (MTUS .EQ. GPEND) THEN
         CWINDO(1) = RWINDO(1)
         CWINDO(2) = RWINDO(2)
         CWINDO(3) = RWINDO(3)
         CWINDO(4) = RWINDO(4)
         CWKVP(1) = RWKVP(1)
         CWKVP(2) = RWKVP(2)
         CWKVP(3) = RWKVP(3)
         CWKVP(4) = RWKVP(4)
C
C  Set workstation update state to "NOT PENDING"
C
         MTUS = GNPEND
      ENDIF
C
C Clear picture name.
C
      MPNAME = ' '
C
C  Set the flag indicating that no new picture information has
C  been put out.
C
      NPFLG = 0
 77   RETURN
      END

C
C	$Id: csgetsig.f,v 1.5 2008-07-27 03:10:06 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CSGETSIG (N,X,Y,Z,H,LIST,LPTR,LEND,GRAD,
     .                   TOL, SIGMA, DSMAX,IER)
      INTEGER N, LIST(*), LPTR(*), LEND(N), IER
      DOUBLE PRECISION X(N), Y(N), Z(N), H(N), GRAD(3,N),
     .                 TOL, SIGMA(*), DSMAX
C
C***********************************************************
C
C                                              From SSRFPACK
C                                            Robert J. Renka
C                                  Dept. of Computer Science
C                                       Univ. of North Texas
C                                           renka@cs.unt.edu
C                                                   11/21/96
C
C   Given a triangulation of a set of nodes on the unit
C sphere, along with data values H and gradients GRAD at the
C nodes, this subroutine determines, for each triangulation
C arc, the smallest (nonnegative) tension factor SIGMA such
C that the Hermite interpolatory tension spline H(A), de-
C fined by SIGMA and the endpoint values and directional
C derivatives, preserves local shape properties of the data.
C In order to define the shape properties on an arc, it is
C convenient to map the arc to an interval (A1,A2).  Then,
C denoting the endpoint data values by H1,H2 and the deriva-
C tives (tangential gradient components) by HP1,HP2, and
C letting S = (H2-H1)/(A2-A1), the data properties are
C
C       Monotonicity:  S, HP1, and HP2 are nonnegative or
C                        nonpositive,
C   and
C
C       Convexity:     HP1 .LE. S .LE. HP2  or  HP1 .GE. S
C                        .GE. HP2.
C
C The corresponding properties of H are constant sign of the
C first and second derivatives, respectively.  Note that,
C unless HP1 = S = HP2, infinite tension is required (and H
C is linear on the interval) if S = 0 in the case of mono-
C tonicity, or if HP1 = S or HP2 = S in the case of
C convexity.
C
C   Note that if gradients are to be computed by Subroutine
C CSGRADG or function values and gradients are computed by
C CSSMSURF, it may be desirable to alternate those computa-
C tions (which require tension factors) with calls to this
C subroutine.  This iterative procedure should terminate
C with a call to CSGETSIG in order to ensure that the shape
C properties are preserved, and convergence can be achieved
C (at the cost of optimality) by allowing only increases in
C tension factors (refer to the parameter descriptions for
C SIGMA, DSMAX, and IER).
C
C   Refer to functions CSSIG0, CSSIG1, and CSSIG2 for means of
C selecting minimum tension factors to preserve more general
C properties.
C
C On input:
C
C       N = Number of nodes in the triangulation.  N .GE. 3.
C
C       X,Y,Z = Arrays of length N containing the Cartesian
C               coordinates of the nodes.
C
C       H = Array of length N containing data values at the
C           nodes.  H(I) is associated with (X(I),Y(I),Z(I))
C           for I = 1,...,N.
C
C       LIST,LPTR,LEND = Data structure defining the tri-
C                        angulation.  Refer to STRIPACK
C                        Subroutine CSTRMESH.
C
C       GRAD = Array dimensioned 3 by N whose columns con-
C              tain gradients at the nodes.  GRAD( ,J) must
C              be orthogonal to node J:  GRAD(1,J)*X(J) +
C              GRAD(2,J)*Y(J) + GRAD(3,J)*Z(J) = 0..  Refer
C              to Subroutines CSGRADG, CSGRADL, and CSSMSURF.
C
C       TOL = Tolerance whose magnitude determines how close
C             each tension factor is to its optimal value
C             when nonzero finite tension is necessary and
C             sufficient to satisfy the constraint --
C             abs(TOL) is an upper bound on the magnitude
C             of the smallest (nonnegative) or largest (non-
C             positive) value of the first or second deriva-
C             tive of H in the interval.  Thus, the con-
C             straint is satisfied, but possibly with more
C             tension than necessary.
C
C The above parameters are not altered by this routine.
C
C       SIGMA = Array of length 2*NA = 6*(N-1)-2*NB, where
C               NA and NB are the numbers of arcs and boun-
C               dary nodes, respectively, containing minimum
C               values of the tension factors.  The tension
C               factors are associated with arcs in one-to-
C               one correspondence with LIST entries.  Note
C               that each arc N1-N2 has two LIST entries and
C               thus, the tension factor is stored in both
C               SIGMA(I) and SIGMA(J) where LIST(I) = N2 (in
C               the adjacency list for N1) and LIST(J) = N1
C               (in the list associated with N2).  SIGMA
C               should be set to all zeros if minimal ten-
C               sion is desired, and should be unchanged
C               from a previous call in order to ensure con-
C               vergence of the iterative procedure describ-
C               ed in the header comments.
C
C On output:
C
C       SIGMA = Array containing tension factors for which
C               H(A) preserves the local data properties on
C               each triangulation arc, with the restriction
C               that SIGMA(I) .LE. 85 for all I (unless the
C               input value is larger).  The factors are as
C               small as possible (within the tolerance) but
C               not less than their input values.  If infin-
C               ite tension is required on an arc, the cor-
C               responding factor is SIGMA(I) = 85 (and H
C               is an approximation to the linear inter-
C               polant on the arc), and if neither property
C               is satisfied by the data, then SIGMA(I) = 0
C               (assuming its input value is 0), and thus H
C               is cubic on the arc.
C
C       DSMAX = Maximum increase in a component of SIGMA
C               from its input value.
C
C       IER = Error indicator and information flag:
C             IER = I if no errors were encountered and I
C                     components of SIGMA were altered from
C                     their input values for I .GE. 0.
C             IER = -1 if N < 3.  SIGMA is not altered in
C                      this case.
C             IER = -2 if duplicate nodes were encountered.
C
C STRIPACK modules required by CSGETSIG:  CSLSTPTR, CSSTORE
C
C SSRFPACK modules required by CSGETSIG:  CSARCLEN, CSSNHCSH
C
C Intrinsic functions called by CSGETSIG:  ABS, EXP, MAX, MIN,
C                                          SIGN, SQRT
C
C***********************************************************
C
      INTEGER CSLSTPTR
      DOUBLE PRECISION CSARCLEN, CSSTORE
      INTEGER ICNT, LP1, LP2, LPL, LUN, N1, N2, NIT, NM1
      DOUBLE PRECISION A, AL, C1, C2, COSHM, COSHMM, D0, D1,
     .                 D1D2, D1PD2, D2, DMAX, DSIG, DSM, E,
     .                 EMS, EMS2, F, F0, FMAX, FNEG, FP,
     .                 FTOL, P1(3), P2(3), RTOL, S, S1, S2,
     .                 SBIG, SCM, SGN, SIG, SIGIN, SINHM,
     .                 SSINH, SSM, STOL, T, T0, T1, T2, TM,
     .                 TP1, UN(3), UNORM
C
      DATA SBIG/85./,  LUN/-1/
      NM1 = N - 1
      IF (NM1 .LT. 2) GO TO 11
C
C Compute an absolute tolerance FTOL = abs(TOL) and a
C   relative tolerance RTOL = 100*Macheps.
C
      FTOL = ABS(TOL)
      RTOL = 1.
    1 RTOL = RTOL/2.
        IF (CSSTORE(RTOL+1.) .GT. 1.) GO TO 1
      RTOL = RTOL*200.
C
C Print a heading.
C
      IF (LUN .GE. 0) WRITE (LUN,100) N, FTOL
  100 FORMAT ('1',13X,'CSGETSIG -- N =',I4,', TOL = ',E10.3//)
C
C Initialize change counter ICNT and maximum change DSM for
C   the loop on arcs.
C
      ICNT = 0
      DSM = 0.
C
C Loop on arcs N1-N2 for which N2 > N1.  LPL points to the
C   last neighbor of N1.
C
      DO 10 N1 = 1,NM1
        LPL = LEND(N1)
        LP1 = LPL
C
C   Top of loop on neighbors N2 of N1.
C
    2   LP1 = LPTR(LP1)
        N2 = ABS(LIST(LP1))
        IF (N2 .LE. N1) GO TO 9
C
C Print a message and compute parameters for the arc:
C   nodal coordinates P1 and P2, arc-length AL,
C   UNORM = magnitude of P1 X P2, and
C   SIGIN = input SIGMA value.
C
        IF (LUN .GE. 0) WRITE (LUN,110) N1, N2
  110   FORMAT (/1X,'ARC',I4,' -',I4)
        P1(1) = X(N1)
        P1(2) = Y(N1)
        P1(3) = Z(N1)
        P2(1) = X(N2)
        P2(2) = Y(N2)
        P2(3) = Z(N2)
        AL = CSARCLEN(P1,P2)
        UN(1) = P1(2)*P2(3) - P1(3)*P2(2)
        UN(2) = P1(3)*P2(1) - P1(1)*P2(3)
        UN(3) = P1(1)*P2(2) - P1(2)*P2(1)
        UNORM = SQRT(UN(1)*UN(1)+UN(2)*UN(2)+UN(3)*UN(3))
        IF (UNORM .EQ. 0.  .OR.  AL .EQ. 0.) GO TO 12
        SIGIN = SIGMA(LP1)
        IF (SIGIN .GE. SBIG) GO TO 9
C
C Compute scaled directional derivatives S1,S2 at the end-
C   points (for the direction N1->N2), first difference S,
C   and second differences D1,D2.
C
        S1 = AL*(GRAD(1,N1)*P2(1) + GRAD(2,N1)*P2(2) +
     .               GRAD(3,N1)*P2(3))/UNORM
        S2 = -AL*(GRAD(1,N2)*P1(1) + GRAD(2,N2)*P1(2) +
     .            GRAD(3,N2)*P1(3))/UNORM
        S = H(N2) - H(N1)
        D1 = S - S1
        D2 = S2 - S
        D1D2 = D1*D2
C
C Test for infinite tension required to satisfy either
C   property.
C
        SIG = SBIG
        IF ((D1D2 .EQ. 0.  .AND.  S1 .NE. S2)  .OR.
     .      (S .EQ. 0.  .AND.  S1*S2 .GT. 0.)) GO TO 8
C
C Test for SIGMA = 0 sufficient.  The data satisfies convex-
C   ity iff D1D2 .GE. 0, and D1D2 = 0 implies S1 = S = S2.
C
        SIG = 0.
        IF (D1D2 .LT. 0.) GO TO 4
        IF (D1D2 .EQ. 0.) GO TO 8
        T = MAX(D1/D2,D2/D1)
        IF (T .LE. 2.) GO TO 8
        TP1 = T + 1.
C
C Convexity:  find a zero of F(SIG) = SIG*coshm(SIG)/
C   sinhm(SIG) - TP1.
C
C   F(0) = 2-T < 0, F(TP1) .GE. 0, the derivative of F
C     vanishes at SIG = 0, and the second derivative of F is
C     .2 at SIG = 0.  A quadratic approximation is used to
C     obtain a starting point for the Newton method.
C
        SIG = SQRT(10.*T-20.)
        NIT = 0
C
C   Top of loop:
C
    3   IF (SIG .LE. .5) THEN
          CALL CSSNHCSH (SIG, SINHM,COSHM,COSHMM)
          T1 = COSHM/SINHM
          FP = T1 + SIG*(SIG/SINHM - T1*T1 + 1.)
        ELSE
C
C   Scale sinhm and coshm by 2*exp(-SIG) in order to avoid
C     overflow with large SIG.
C
          EMS = EXP(-SIG)
          SSM = 1. - EMS*(EMS+SIG+SIG)
          T1 = (1.-EMS)*(1.-EMS)/SSM
          FP = T1 + SIG*(2.*SIG*EMS/SSM - T1*T1 + 1.)
        ENDIF
C
        F = SIG*T1 - TP1
        IF (LUN .GE. 0) WRITE (LUN,120) SIG, F, FP
  120   FORMAT (1X,'CONVEXITY -- SIG = ',E15.8,
     .          ', F(SIG) = ',E15.8/1X,35X,'FP(SIG) = ',
     .          E15.8)
        NIT = NIT + 1
C
C   Test for convergence.
C
        IF (FP .LE. 0.) GO TO 8
        DSIG = -F/FP
        IF (ABS(DSIG) .LE. RTOL*SIG  .OR.  (F .GE. 0.  .AND.
     .      F .LE. FTOL)  .OR.  ABS(F) .LE. RTOL) GO TO 8
C
C   Update SIG.
C
        SIG = SIG + DSIG
        GO TO 3
C
C Convexity cannot be satisfied.  Monotonicity can be satis-
C   fied iff S1*S .GE. 0 and S2*S .GE. 0 since S .NE. 0.
C
    4   IF (S1*S .LT. 0.  .OR.  S2*S .LT. 0.) GO TO 8
        T0 = 3.*S - S1 - S2
        D0 = T0*T0 - S1*S2
C
C SIGMA = 0 is sufficient for monotonicity iff S*T0 .GE. 0
C   or D0 .LE. 0.
C
        IF (D0 .LE. 0.  .OR.  S*T0 .GE. 0.) GO TO 8
C
C Monotonicity:  find a zero of F(SIG) = sign(S)*HP(R),
C   where HPP(R) = 0 and HP, HPP denote derivatives of H.
C   F has a unique zero, F(0) < 0, and F approaches
C   abs(S) as SIG increases.
C
C   Initialize parameters for the secant method.  The method
C     uses three points:  (SG0,F0), (SIG,F), and
C     (SNEG,FNEG), where SG0 and SNEG are defined implicitly
C     by DSIG = SIG - SG0 and DMAX = SIG - SNEG.
C
        SGN = SIGN(1.D0,S)
        SIG = SBIG
        FMAX = SGN*(SIG*S-S1-S2)/(SIG-2.)
        IF (FMAX .LE. 0.) GO TO 8
        STOL = RTOL*SIG
        F = FMAX
        F0 = SGN*D0/(3.*(D1-D2))
        FNEG = F0
        DSIG = SIG
        DMAX = SIG
        D1PD2 = D1 + D2
        NIT = 0
C
C   Top of loop:  compute the change in SIG by linear
C     interpolation.
C
    5   DSIG = -F*DSIG/(F-F0)
        IF (LUN .GE. 0) WRITE (LUN,130) DSIG
  130   FORMAT (1X,'MONOTONICITY -- DSIG = ',E15.8)
        IF ( ABS(DSIG) .GT. ABS(DMAX)  .OR.
     .       DSIG*DMAX .GT. 0. ) GO TO 7
C
C   Restrict the step-size such that abs(DSIG) .GE. STOL/2.
C     Note that DSIG and DMAX have opposite signs.
C
        IF (ABS(DSIG) .LT. STOL/2.) DSIG = -SIGN(STOL/2.,
     .                              DMAX)
C
C   Update SIG, F0, and F.
C
        SIG = SIG + DSIG
        F0 = F
        IF (SIG .LE. .5) THEN
C
C   Use approximations to the hyperbolic functions designed
C     to avoid cancellation error with small SIG.
C
          CALL CSSNHCSH (SIG, SINHM,COSHM,COSHMM)
          C1 = SIG*COSHM*D2 - SINHM*D1PD2
          C2 = SIG*(SINHM+SIG)*D2 - COSHM*D1PD2
          A = C2 - C1
          E = SIG*SINHM - COSHMM - COSHMM
        ELSE
C
C   Scale sinhm and coshm by 2*exp(-SIG) in order to avoid
C     overflow with large SIG.
C
          EMS = EXP(-SIG)
          EMS2 = EMS + EMS
          TM = 1. - EMS
          SSINH = TM*(1.+EMS)
          SSM = SSINH - SIG*EMS2
          SCM = TM*TM
          C1 = SIG*SCM*D2 - SSM*D1PD2
          C2 = SIG*SSINH*D2 - SCM*D1PD2
C
C   R is in (0,1) and well-defined iff HPP(T1)*HPP(T2) < 0.
C
          F = FMAX
          IF (C1*(SIG*SCM*D1 - SSM*D1PD2) .GE. 0.) GO TO 6
          A = EMS2*(SIG*TM*D2 + (TM-SIG)*D1PD2)
          IF (A*(C2+C1) .LT. 0.) GO TO 6
          E = SIG*SSINH - SCM - SCM
        ENDIF
C
        F = (SGN*(E*S2-C2) + SQRT(A*(C2+C1)))/E
C
C   Update the number of iterations NIT.
C
    6   NIT = NIT + 1
        IF (LUN .GE. 0) WRITE (LUN,140) NIT, SIG, F
  140   FORMAT (1X,11X,I2,' -- SIG = ',E15.8,', F = ',
     .          E15.8)
C
C   Test for convergence.
C
        STOL = RTOL*SIG
        IF (ABS(DMAX) .LE. STOL  .OR.  (F .GE. 0.  .AND.
     .      F .LE. FTOL)  .OR.  ABS(F) .LE. RTOL) GO TO 8
        DMAX = DMAX + DSIG
        IF (F0*F .GT. 0.  .AND.  ABS(F) .GE. ABS(F0))
     .     GO TO 7
        IF (F0*F .LE. 0.) THEN
C
C   F and F0 have opposite signs.  Update (SNEG,FNEG) to
C     (SG0,F0) so that F and FNEG always have opposite
C     signs.  If SIG is closer to SNEG than SG0 and abs(F)
C     < abs(FNEG), then swap (SNEG,FNEG) with (SG0,F0).
C
          T1 = DMAX
          T2 = FNEG
          DMAX = DSIG
          FNEG = F0
          IF ( ABS(DSIG) .GT. ABS(T1)  .AND.
     .         ABS(F) .LT. ABS(T2) ) THEN
C
            DSIG = T1
            F0 = T2
          ENDIF
        ENDIF
        GO TO 5
C
C   Bottom of loop:  F0*F > 0 and the new estimate would
C     be outside of the bracketing interval of length
C     abs(DMAX).  Reset (SG0,F0) to (SNEG,FNEG).
C
    7   DSIG = DMAX
        F0 = FNEG
        GO TO 5
C
C  Update SIGMA, ICNT, and DSM if necessary.
C
    8   SIG = MIN(SIG,SBIG)
        IF (SIG .GT. SIGIN) THEN
          SIGMA(LP1) = SIG
          LP2 = CSLSTPTR(LEND(N2),N1,LIST,LPTR)
          SIGMA(LP2) = SIG
          ICNT = ICNT + 1
          DSM = MAX(DSM,SIG-SIGIN)
        ENDIF
C
C Bottom of loop on neighbors N2 of N1.
C
    9   IF (LP1 .NE. LPL) GO TO 2
   10   CONTINUE
C
C No errors encountered.
C
      DSMAX = DSM
      IER = ICNT
      RETURN
C
C N < 3.
C
   11 DSMAX = 0.
      IER = -1
      RETURN
C
C Nodes N1 and N2 coincide.
C
   12 DSMAX = DSM
      IER = -2
      RETURN
      END

C
C	$Id: gpl.f,v 1.11 2008-07-27 00:20:58 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GPL(N,PX,PY)
C
C  POLYLINE
C
      INTEGER EPL
      PARAMETER (EPL=12)
C
C  Specify the maximum sized polygon that will be clipped to the NDC
C  viewport.
C
      PARAMETER (MAXCLP=250)
C
      include 'gkscom.h'
C
      INTEGER N
      REAL PX(N),PY(N)
C
C  Check if GKS is in the proper state.
C
      CALL GZCKST(5,EPL,IER)
      IF (IER .NE. 0) RETURN
C
C  Check that the number of points is valid.
C
      IF (.NOT.(N.GE.2)) THEN
        ERS = 1
        CALL GERHND(100,EPL,ERF)
        ERS = 0
        RETURN
      ENDIF
C
C  Set function code and put out the real arrays across the
C  workstation interface.  Flag conversion to NDC space (no
C  conversion is necessary for transformation 0).
C
      FCODE = 11
      CALL GZROI(0)
C
C  Clip the polyline to the NDC viewport if the polylines are small 
C  enough and clipping is on.
C
      IF (N .LE. MAXCLP .AND. GKSCLP.NE.0) THEN
        CALL GZN2WX(1,0.,XLFT)
        CALL GZN2WX(1,1.,XRIT)
        CALL GZN2WY(1,0.,YBOT)
        CALL GZN2WY(1,1.,YTOP)
        CALL GZCLLI (XLFT,XRIT,YBOT,YTOP,PX,PY,N,RWKSP,IWDIM,IERR)
C
C  If error, abandon any clipping and just put the line out.
C
        IF (IERR .NE. 0) GO TO 10
        RERR = 0
        RETURN
      ENDIF
C
   10 CONTINUE
C
      NPTOT = N
      CALL GZPUTR(NPTOT,N,PX,PY,MIN(CNT,1),IER)
      RERR = IER
      IF (RERR.NE.0) THEN
        ERS = 1
        CALL GERHND(RERR,EPL,ERF)
        ERS = 0
      ENDIF
C
      RETURN
      END

      PROGRAM CCPLINE
C 
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
      
      PARAMETER (K=9,N=7,LRWK=1000,LIWK=1000,LZDT=2000)
      REAL Z(K,N), ZDAT(LZDT), RWRK(LRWK)
      INTEGER M, IWRK(LIWK)
      
      CALL GETDAT (Z, K, M, N) 
C
C Open GKS
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Set up a color table
C
      CALL COLOR(IWKID)
C
C Set each contour level value
C
      CALL CPSETI ('CLS - CONTOUR LEVEL SELECTION',0)
      CALL CPSETI ('NCL - NUMBER OF CONTOUR LEVELS',13)
      DO 5, I=1,13
         CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',I)
         CALL CPSETR ('CLV - CONTOUR LEVEL VALUE',
     +        REAL(I-1)*1000.-500.)
         IF (MOD(I,3).EQ.0) THEN
C
C Make the contour line  dashed
C
            CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',I)
            CALL CPSETI ('CLD - CONTOUR LINE DASH PATTERN', 21845)
         ELSE IF (MOD(I,3).EQ.1) THEN
C
C Make the contour line three times as thick
C
            CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',I)
            CALL CPSETR ('CLL - CONTOUR LINE LINE WIDTH', 3.)
         ELSE IF (MOD(I,3).EQ.2) THEN
C
C Make the contour line  red
C
            CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',I)
            CALL CPSETI ('CLC - CONTOUR LINE COLOR INDEX',2)
         ENDIF
 5    CONTINUE     
C
C Initialize Conpack
C
      CALL CPSPS1(Z,K,M,N,RWRK,LRWK,IWRK,LIWK,ZDAT,LZDT)
C
C Draw perimeter
C
      CALL CPBACK(ZDAT, RWRK, IWRK)
C
C Draw Contours
C
      CALL CPCLDR(ZDAT,RWRK,IWRK)
C
C Close frame and close GKS
C
      CALL FRAME
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      
      STOP
      END
      
      SUBROUTINE GETDAT (Z, K, M, N)
      INTEGER I,J,K,M,N
      REAL Z(K,N)
      
      M=K
      RMIN = 0.
      RMAX = 0.
      DO 10, I=1,M
         DO 20, J=1,N
            Z(I,J)= -16.*REAL(I**2*J) +
     1           34*REAL(I*J**2) - REAL(6*I) + 93.
            IF (RMIN.GT.Z(I,J)) RMIN=Z(I,J)
            IF (RMAX.LT.Z(I,J)) RMAX=Z(I,J)
 20      CONTINUE
 10   CONTINUE
      
      RETURN
      END
      
      SUBROUTINE COLOR(IWKID)
      
      CALL GSCR(IWKID,0,0.,0.,0.)
      CALL GSCR(IWKID,1,1.,1.,1.)
      CALL GSCR(IWKID,2,1.,0.,0.)
      
      RETURN
      END
      

      SUBROUTINE ZGESVX( FACT, TRANS, N, NRHS, A, LDA, AF, LDAF, IPIV,
     $                   EQUED, R, C, B, LDB, X, LDX, RCOND, FERR, BERR,
     $                   WORK, RWORK, INFO )
*
*  -- LAPACK driver routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          EQUED, FACT, TRANS
      INTEGER            INFO, LDA, LDAF, LDB, LDX, N, NRHS
      DOUBLE PRECISION   RCOND
*     ..
*     .. Array Arguments ..
      INTEGER            IPIV( * )
      DOUBLE PRECISION   BERR( * ), C( * ), FERR( * ), R( * ),
     $                   RWORK( * )
      COMPLEX*16         A( LDA, * ), AF( LDAF, * ), B( LDB, * ),
     $                   WORK( * ), X( LDX, * )
*     ..
*
*  Purpose
*  =======
*
*  ZGESVX uses the LU factorization to compute the solution to a complex
*  system of linear equations
*     A * X = B,
*  where A is an N-by-N matrix and X and B are N-by-NRHS matrices.
*
*  Error bounds on the solution and a condition estimate are also
*  provided.
*
*  Description
*  ===========
*
*  The following steps are performed:
*
*  1. If FACT = 'E', real scaling factors are computed to equilibrate
*     the system:
*        TRANS = 'N':  diag(R)*A*diag(C)     *inv(diag(C))*X = diag(R)*B
*        TRANS = 'T': (diag(R)*A*diag(C))**T *inv(diag(R))*X = diag(C)*B
*        TRANS = 'C': (diag(R)*A*diag(C))**H *inv(diag(R))*X = diag(C)*B
*     Whether or not the system will be equilibrated depends on the
*     scaling of the matrix A, but if equilibration is used, A is
*     overwritten by diag(R)*A*diag(C) and B by diag(R)*B (if TRANS='N')
*     or diag(C)*B (if TRANS = 'T' or 'C').
*
*  2. If FACT = 'N' or 'E', the LU decomposition is used to factor the
*     matrix A (after equilibration if FACT = 'E') as
*        A = P * L * U,
*     where P is a permutation matrix, L is a unit lower triangular
*     matrix, and U is upper triangular.
*
*  3. If some U(i,i)=0, so that U is exactly singular, then the routine
*     returns with INFO = i. Otherwise, the factored form of A is used
*     to estimate the condition number of the matrix A.  If the
*     reciprocal of the condition number is less than machine precision,
*     INFO = N+1 is returned as a warning, but the routine still goes on
*     to solve for X and compute error bounds as described below.
*
*  4. The system of equations is solved for X using the factored form
*     of A.
*
*  5. Iterative refinement is applied to improve the computed solution
*     matrix and calculate error bounds and backward error estimates
*     for it.
*
*  6. If equilibration was used, the matrix X is premultiplied by
*     diag(C) (if TRANS = 'N') or diag(R) (if TRANS = 'T' or 'C') so
*     that it solves the original system before equilibration.
*
*  Arguments
*  =========
*
*  FACT    (input) CHARACTER*1
*          Specifies whether or not the factored form of the matrix A is
*          supplied on entry, and if not, whether the matrix A should be
*          equilibrated before it is factored.
*          = 'F':  On entry, AF and IPIV contain the factored form of A.
*                  If EQUED is not 'N', the matrix A has been
*                  equilibrated with scaling factors given by R and C.
*                  A, AF, and IPIV are not modified.
*          = 'N':  The matrix A will be copied to AF and factored.
*          = 'E':  The matrix A will be equilibrated if necessary, then
*                  copied to AF and factored.
*
*  TRANS   (input) CHARACTER*1
*          Specifies the form of the system of equations:
*          = 'N':  A * X = B     (No transpose)
*          = 'T':  A**T * X = B  (Transpose)
*          = 'C':  A**H * X = B  (Conjugate transpose)
*
*  N       (input) INTEGER
*          The number of linear equations, i.e., the order of the
*          matrix A.  N >= 0.
*
*  NRHS    (input) INTEGER
*          The number of right hand sides, i.e., the number of columns
*          of the matrices B and X.  NRHS >= 0.
*
*  A       (input/output) COMPLEX*16 array, dimension (LDA,N)
*          On entry, the N-by-N matrix A.  If FACT = 'F' and EQUED is
*          not 'N', then A must have been equilibrated by the scaling
*          factors in R and/or C.  A is not modified if FACT = 'F' or
*          'N', or if FACT = 'E' and EQUED = 'N' on exit.
*
*          On exit, if EQUED .ne. 'N', A is scaled as follows:
*          EQUED = 'R':  A := diag(R) * A
*          EQUED = 'C':  A := A * diag(C)
*          EQUED = 'B':  A := diag(R) * A * diag(C).
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(1,N).
*
*  AF      (input or output) COMPLEX*16 array, dimension (LDAF,N)
*          If FACT = 'F', then AF is an input argument and on entry
*          contains the factors L and U from the factorization
*          A = P*L*U as computed by ZGETRF.  If EQUED .ne. 'N', then
*          AF is the factored form of the equilibrated matrix A.
*
*          If FACT = 'N', then AF is an output argument and on exit
*          returns the factors L and U from the factorization A = P*L*U
*          of the original matrix A.
*
*          If FACT = 'E', then AF is an output argument and on exit
*          returns the factors L and U from the factorization A = P*L*U
*          of the equilibrated matrix A (see the description of A for
*          the form of the equilibrated matrix).
*
*  LDAF    (input) INTEGER
*          The leading dimension of the array AF.  LDAF >= max(1,N).
*
*  IPIV    (input or output) INTEGER array, dimension (N)
*          If FACT = 'F', then IPIV is an input argument and on entry
*          contains the pivot indices from the factorization A = P*L*U
*          as computed by ZGETRF; row i of the matrix was interchanged
*          with row IPIV(i).
*
*          If FACT = 'N', then IPIV is an output argument and on exit
*          contains the pivot indices from the factorization A = P*L*U
*          of the original matrix A.
*
*          If FACT = 'E', then IPIV is an output argument and on exit
*          contains the pivot indices from the factorization A = P*L*U
*          of the equilibrated matrix A.
*
*  EQUED   (input or output) CHARACTER*1
*          Specifies the form of equilibration that was done.
*          = 'N':  No equilibration (always true if FACT = 'N').
*          = 'R':  Row equilibration, i.e., A has been premultiplied by
*                  diag(R).
*          = 'C':  Column equilibration, i.e., A has been postmultiplied
*                  by diag(C).
*          = 'B':  Both row and column equilibration, i.e., A has been
*                  replaced by diag(R) * A * diag(C).
*          EQUED is an input argument if FACT = 'F'; otherwise, it is an
*          output argument.
*
*  R       (input or output) DOUBLE PRECISION array, dimension (N)
*          The row scale factors for A.  If EQUED = 'R' or 'B', A is
*          multiplied on the left by diag(R); if EQUED = 'N' or 'C', R
*          is not accessed.  R is an input argument if FACT = 'F';
*          otherwise, R is an output argument.  If FACT = 'F' and
*          EQUED = 'R' or 'B', each element of R must be positive.
*
*  C       (input or output) DOUBLE PRECISION array, dimension (N)
*          The column scale factors for A.  If EQUED = 'C' or 'B', A is
*          multiplied on the right by diag(C); if EQUED = 'N' or 'R', C
*          is not accessed.  C is an input argument if FACT = 'F';
*          otherwise, C is an output argument.  If FACT = 'F' and
*          EQUED = 'C' or 'B', each element of C must be positive.
*
*  B       (input/output) COMPLEX*16 array, dimension (LDB,NRHS)
*          On entry, the N-by-NRHS right hand side matrix B.
*          On exit,
*          if EQUED = 'N', B is not modified;
*          if TRANS = 'N' and EQUED = 'R' or 'B', B is overwritten by
*          diag(R)*B;
*          if TRANS = 'T' or 'C' and EQUED = 'C' or 'B', B is
*          overwritten by diag(C)*B.
*
*  LDB     (input) INTEGER
*          The leading dimension of the array B.  LDB >= max(1,N).
*
*  X       (output) COMPLEX*16 array, dimension (LDX,NRHS)
*          If INFO = 0 or INFO = N+1, the N-by-NRHS solution matrix X
*          to the original system of equations.  Note that A and B are
*          modified on exit if EQUED .ne. 'N', and the solution to the
*          equilibrated system is inv(diag(C))*X if TRANS = 'N' and
*          EQUED = 'C' or 'B', or inv(diag(R))*X if TRANS = 'T' or 'C'
*          and EQUED = 'R' or 'B'.
*
*  LDX     (input) INTEGER
*          The leading dimension of the array X.  LDX >= max(1,N).
*
*  RCOND   (output) DOUBLE PRECISION
*          The estimate of the reciprocal condition number of the matrix
*          A after equilibration (if done).  If RCOND is less than the
*          machine precision (in particular, if RCOND = 0), the matrix
*          is singular to working precision.  This condition is
*          indicated by a return code of INFO > 0.
*
*  FERR    (output) DOUBLE PRECISION array, dimension (NRHS)
*          The estimated forward error bound for each solution vector
*          X(j) (the j-th column of the solution matrix X).
*          If XTRUE is the true solution corresponding to X(j), FERR(j)
*          is an estimated upper bound for the magnitude of the largest
*          element in (X(j) - XTRUE) divided by the magnitude of the
*          largest element in X(j).  The estimate is as reliable as
*          the estimate for RCOND, and is almost always a slight
*          overestimate of the true error.
*
*  BERR    (output) DOUBLE PRECISION array, dimension (NRHS)
*          The componentwise relative backward error of each solution
*          vector X(j) (i.e., the smallest relative change in
*          any element of A or B that makes X(j) an exact solution).
*
*  WORK    (workspace) COMPLEX*16 array, dimension (2*N)
*
*  RWORK   (workspace/output) DOUBLE PRECISION array, dimension (2*N)
*          On exit, RWORK(1) contains the reciprocal pivot growth
*          factor norm(A)/norm(U). The "max absolute element" norm is
*          used. If RWORK(1) is much less than 1, then the stability
*          of the LU factorization of the (equilibrated) matrix A
*          could be poor. This also means that the solution X, condition
*          estimator RCOND, and forward error bound FERR could be
*          unreliable. If factorization fails with 0<INFO<=N, then
*          RWORK(1) contains the reciprocal pivot growth factor for the
*          leading INFO columns of A.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*          > 0:  if INFO = i, and i is
*                <= N:  U(i,i) is exactly zero.  The factorization has
*                       been completed, but the factor U is exactly
*                       singular, so the solution and error bounds
*                       could not be computed. RCOND = 0 is returned.
*                = N+1: U is nonsingular, but RCOND is less than machine
*                       precision, meaning that the matrix is singular
*                       to working precision.  Nevertheless, the
*                       solution and error bounds are computed because
*                       there are a number of situations where the
*                       computed solution can be more accurate than the
*                       value of RCOND would suggest.
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO, ONE
      PARAMETER          ( ZERO = 0.0D+0, ONE = 1.0D+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            COLEQU, EQUIL, NOFACT, NOTRAN, ROWEQU
      CHARACTER          NORM
      INTEGER            I, INFEQU, J
      DOUBLE PRECISION   AMAX, ANORM, BIGNUM, COLCND, RCMAX, RCMIN,
     $                   ROWCND, RPVGRW, SMLNUM
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      DOUBLE PRECISION   DLAMCH, ZLANGE, ZLANTR
      EXTERNAL           LSAME, DLAMCH, ZLANGE, ZLANTR
*     ..
*     .. External Subroutines ..
      EXTERNAL           XERBLA, ZGECON, ZGEEQU, ZGERFS, ZGETRF, ZGETRS,
     $                   ZLACPY, ZLAQGE
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN
*     ..
*     .. Executable Statements ..
*
      INFO = 0
      NOFACT = LSAME( FACT, 'N' )
      EQUIL = LSAME( FACT, 'E' )
      NOTRAN = LSAME( TRANS, 'N' )
      IF( NOFACT .OR. EQUIL ) THEN
         EQUED = 'N'
         ROWEQU = .FALSE.
         COLEQU = .FALSE.
      ELSE
         ROWEQU = LSAME( EQUED, 'R' ) .OR. LSAME( EQUED, 'B' )
         COLEQU = LSAME( EQUED, 'C' ) .OR. LSAME( EQUED, 'B' )
         SMLNUM = DLAMCH( 'Safe minimum' )
         BIGNUM = ONE / SMLNUM
      END IF
*
*     Test the input parameters.
*
      IF( .NOT.NOFACT .AND. .NOT.EQUIL .AND. .NOT.LSAME( FACT, 'F' ) )
     $     THEN
         INFO = -1
      ELSE IF( .NOT.NOTRAN .AND. .NOT.LSAME( TRANS, 'T' ) .AND. .NOT.
     $         LSAME( TRANS, 'C' ) ) THEN
         INFO = -2
      ELSE IF( N.LT.0 ) THEN
         INFO = -3
      ELSE IF( NRHS.LT.0 ) THEN
         INFO = -4
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -6
      ELSE IF( LDAF.LT.MAX( 1, N ) ) THEN
         INFO = -8
      ELSE IF( LSAME( FACT, 'F' ) .AND. .NOT.
     $         ( ROWEQU .OR. COLEQU .OR. LSAME( EQUED, 'N' ) ) ) THEN
         INFO = -10
      ELSE
         IF( ROWEQU ) THEN
            RCMIN = BIGNUM
            RCMAX = ZERO
            DO 10 J = 1, N
               RCMIN = MIN( RCMIN, R( J ) )
               RCMAX = MAX( RCMAX, R( J ) )
   10       CONTINUE
            IF( RCMIN.LE.ZERO ) THEN
               INFO = -11
            ELSE IF( N.GT.0 ) THEN
               ROWCND = MAX( RCMIN, SMLNUM ) / MIN( RCMAX, BIGNUM )
            ELSE
               ROWCND = ONE
            END IF
         END IF
         IF( COLEQU .AND. INFO.EQ.0 ) THEN
            RCMIN = BIGNUM
            RCMAX = ZERO
            DO 20 J = 1, N
               RCMIN = MIN( RCMIN, C( J ) )
               RCMAX = MAX( RCMAX, C( J ) )
   20       CONTINUE
            IF( RCMIN.LE.ZERO ) THEN
               INFO = -12
            ELSE IF( N.GT.0 ) THEN
               COLCND = MAX( RCMIN, SMLNUM ) / MIN( RCMAX, BIGNUM )
            ELSE
               COLCND = ONE
            END IF
         END IF
         IF( INFO.EQ.0 ) THEN
            IF( LDB.LT.MAX( 1, N ) ) THEN
               INFO = -14
            ELSE IF( LDX.LT.MAX( 1, N ) ) THEN
               INFO = -16
            END IF
         END IF
      END IF
*
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'ZGESVX', -INFO )
         RETURN
      END IF
*
      IF( EQUIL ) THEN
*
*        Compute row and column scalings to equilibrate the matrix A.
*
         CALL ZGEEQU( N, N, A, LDA, R, C, ROWCND, COLCND, AMAX, INFEQU )
         IF( INFEQU.EQ.0 ) THEN
*
*           Equilibrate the matrix.
*
            CALL ZLAQGE( N, N, A, LDA, R, C, ROWCND, COLCND, AMAX,
     $                   EQUED )
            ROWEQU = LSAME( EQUED, 'R' ) .OR. LSAME( EQUED, 'B' )
            COLEQU = LSAME( EQUED, 'C' ) .OR. LSAME( EQUED, 'B' )
         END IF
      END IF
*
*     Scale the right hand side.
*
      IF( NOTRAN ) THEN
         IF( ROWEQU ) THEN
            DO 40 J = 1, NRHS
               DO 30 I = 1, N
                  B( I, J ) = R( I )*B( I, J )
   30          CONTINUE
   40       CONTINUE
         END IF
      ELSE IF( COLEQU ) THEN
         DO 60 J = 1, NRHS
            DO 50 I = 1, N
               B( I, J ) = C( I )*B( I, J )
   50       CONTINUE
   60    CONTINUE
      END IF
*
      IF( NOFACT .OR. EQUIL ) THEN
*
*        Compute the LU factorization of A.
*
         CALL ZLACPY( 'Full', N, N, A, LDA, AF, LDAF )
         CALL ZGETRF( N, N, AF, LDAF, IPIV, INFO )
*
*        Return if INFO is non-zero.
*
         IF( INFO.NE.0 ) THEN
            IF( INFO.GT.0 ) THEN
*
*              Compute the reciprocal pivot growth factor of the
*              leading rank-deficient INFO columns of A.
*
               RPVGRW = ZLANTR( 'M', 'U', 'N', INFO, INFO, AF, LDAF,
     $                  RWORK )
               IF( RPVGRW.EQ.ZERO ) THEN
                  RPVGRW = ONE
               ELSE
                  RPVGRW = ZLANGE( 'M', N, INFO, A, LDA, RWORK ) /
     $                     RPVGRW
               END IF
               RWORK( 1 ) = RPVGRW
               RCOND = ZERO
            END IF
            RETURN
         END IF
      END IF
*
*     Compute the norm of the matrix A and the
*     reciprocal pivot growth factor RPVGRW.
*
      IF( NOTRAN ) THEN
         NORM = '1'
      ELSE
         NORM = 'I'
      END IF
      ANORM = ZLANGE( NORM, N, N, A, LDA, RWORK )
      RPVGRW = ZLANTR( 'M', 'U', 'N', N, N, AF, LDAF, RWORK )
      IF( RPVGRW.EQ.ZERO ) THEN
         RPVGRW = ONE
      ELSE
         RPVGRW = ZLANGE( 'M', N, N, A, LDA, RWORK ) / RPVGRW
      END IF
*
*     Compute the reciprocal of the condition number of A.
*
      CALL ZGECON( NORM, N, AF, LDAF, ANORM, RCOND, WORK, RWORK, INFO )
*
*     Set INFO = N+1 if the matrix is singular to working precision.
*
      IF( RCOND.LT.DLAMCH( 'Epsilon' ) )
     $   INFO = N + 1
*
*     Compute the solution matrix X.
*
      CALL ZLACPY( 'Full', N, NRHS, B, LDB, X, LDX )
      CALL ZGETRS( TRANS, N, NRHS, AF, LDAF, IPIV, X, LDX, INFO )
*
*     Use iterative refinement to improve the computed solution and
*     compute error bounds and backward error estimates for it.
*
      CALL ZGERFS( TRANS, N, NRHS, A, LDA, AF, LDAF, IPIV, B, LDB, X,
     $             LDX, FERR, BERR, WORK, RWORK, INFO )
*
*     Transform the solution matrix X to a solution of the original
*     system.
*
      IF( NOTRAN ) THEN
         IF( COLEQU ) THEN
            DO 80 J = 1, NRHS
               DO 70 I = 1, N
                  X( I, J ) = C( I )*X( I, J )
   70          CONTINUE
   80       CONTINUE
            DO 90 J = 1, NRHS
               FERR( J ) = FERR( J ) / COLCND
   90       CONTINUE
         END IF
      ELSE IF( ROWEQU ) THEN
         DO 110 J = 1, NRHS
            DO 100 I = 1, N
               X( I, J ) = R( I )*X( I, J )
  100       CONTINUE
  110    CONTINUE
         DO 120 J = 1, NRHS
            FERR( J ) = FERR( J ) / ROWCND
  120    CONTINUE
      END IF
*
      RWORK( 1 ) = RPVGRW
      RETURN
*
*     End of ZGESVX
*
      END

C
C       $Id: stgeti.f,v 1.7 2008-07-27 00:17:28 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
C
C-----------------------------------------------------------------------
C
      SUBROUTINE STGETI (CNM,IVL)
C
      CHARACTER*(*) CNM
C
C This subroutine is called to retrieve the integer value of a specified
C parameter.
C
C CNM is the name of the parameter whose value is to be retrieved.
C
C IVL is an integer variable in which the desired value is to be
C returned by STGETI.
C
C ---------------------------------------------------------------------
C
C Use STGETR to retrieve the real value, fix it, and return it to the
C user.
C
      CALL STGETR (CNM,RVL)
      IVL=INT(RVL)
C
C Done.
C
      RETURN
C
      END

C
C      $Id: xy16f.f,v 1.8 2010-03-15 22:49:25 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                       C
C                Copyright (C)  1996                                    C
C        University Corporation for Atmospheric Research                C
C                All Rights Reserved                                    C
C                                                                       C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C   File:       xy16f.f
C
C   Author:     Bob Lackman
C           National Center for Atmospheric Research
C           PO 3000, Boulder, Colorado
C
C   Date:       24 Jan 1996
C
C   Description:    Reads an ASCII file with 4 variables:
C                   lon, u, v, and t.  u, v, and t are plotted
C                   with 3 separate y axes.
C
C                   This example shows how the Data Spec object
C                   can be retrieved so you can change certain
C                   aspects of the plot, like the line color.
C                   line color.
C
C                   In this example, each of the three variables
C                   are assigned their own Y axis and scales by
C                   creating three distinct XyPlot objects. The
C                   first object is given a full grid and has
C                   its Y axis scale on the left. The second 
C                   object has no grid and the Y axis scale on
C                   the right of the first grid. The third
C                   object's viewport is made wider than the
C                   first two and its X axis is scaled so that
C                   the data end at the right grid boundary of
C                   the first object.  Only the Y axis on the
C                   right is drawn for the third object. The
C                   curves and the Y axis scales are color
C                   coordinated so you can tell which curve
C                   goes with which scale.
C                   
C                   There is no resource file for this example.
C
      external NhlFAppClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFCairoWindowWorkstationClass
      external NhlFCoordArraysClass
      external NhlFXyPlotClass
      external NhlFtitleclass
      external NhlFTextItemClass
      external NhlFTickMarkClass
      parameter(NCURVE=3,NPTS=129)
C
C Define variables for data
C
      real lon(NPTS),u(NPTS),v(NPTS),t(NPTS)
C
C Define variables for tick mark labels
C
      real ylvals(5),yrvals1(6),yrvals2(5)
      character yllabs(5)*4,yrlabs1(6)*3,yrlabs2(5)*4
      data ylvals/-90.,-80.,-70.,-60.,-50./
      data yllabs/'-90.','-80.','-70.','-60.','-50.'/
      data yrvals1/0.,10.,20.,30.,40.,50./
      data yrlabs1/'0.','10.','20.','30.','40.','50.'/
      data yrvals2/-20.,-10.,0.,10.,20./
      data yrlabs2/'-20.','-10.','0.','10.','20.'/
C
C Define HLU variables for creating objects.
C
      integer appid,field1,field2,field3,xy1,xy2,xy3,xworkid
      integer grlist, srlist, spec1, spec2, spec3
C
C Define variable for data file
C
      character*6 filename
      data filename/'xy.asc'/
C
C Indicate whether we want output to go to NCGM, X11 window or
C PS file.
C
      CHARACTER*7  wks_type
C
C Define the workstation type
C
      wks_type = "x11"
C
C Create Application object.
C
      call NhlFInitialize
      call NhlFRLCreate(srlist,'setrl')
      call NhlFRLCreate(grlist,'getrl')
      call NhlFRLClear(srlist)
      call NhlFRLSetString(srlist,'appDefaultParent','True',ierr)
      call NhlFRLSetString(srlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'xy16',NhlFAppClass,0,srlist,ierr)
C
C Read ASCII file "xy.asc".
C
      open(unit=10,file=filename,status='old',form='formatted',err=104)
C
C Read data.
C
      read(10,*)(lon(i),u(i),v(i),t(i),i=1,NPTS)
C
C Create an NCGM workstation.
C
      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkMetaName','./xy16f.ncgm',ierr)
         call NhlFCreate(xworkid,'xy16Work',
     +        NhlFNcgmWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X11 workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkPause','True',ierr)
         call NhlFCreate(xworkid,'xy16Work',
     +        NhlFCairoWindowWorkstationClass,
     +        0,srlist,ierr)
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PostScript workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkPSFileName','./xy16f.ps',ierr)
         call NhlFCreate(xworkid,'xy16Work',
     +        NhlFPSWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkPDFFileName','./xy16f.pdf',ierr)
         call NhlFCreate(xworkid,'xy16Work',
     +        NhlFPDFWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkFileName','./xy16f',ierr)
         call NhlFRLSetString(srlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(xworkid,'xy16Work',
     +        NhlFCairoPSPDFWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkFileName','./xy16f',ierr)
         call NhlFRLSetString(srlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(xworkid,'xy16Work',
     +        NhlFCairoImageWorkstationClass,0,srlist,ierr)
      endif
C
C  xy.asc has 4 vars of length 129 longitudes, lon, u, v, t
C
C     The data is taken at 43N latitude.  Longitude is an index
C     1-129 standing for 0 deg - 360 deg in steps of 360/128?
C     u and v are in m/s, and t is in deg K.
C
C     Convert from degrees K to degrees F and configure its extents
C     missing values.
C
      do i=1,NPTS
         t(i) = (t(i) - 273.15) * 9 / 5 + 32.0
         lon(i) = (lon(i) - 1.) * 360./128.
      end do
C
C Create the first Coord Arrays data object.
C
      call NhlFRLClear(srlist)
      call NhlFRLSetFloatArray(srlist,'caYArray',t,NPTS,ierr)
      call NhlFRLSetFloatArray(srlist,'caXArray',lon,NPTS,ierr)
      call NhlFCreate(field1,'field1',NhlFCoordArraysClass,
     +                0,srlist,ierr)
C
C Create the second Coord Arrays data object.
C
      call NhlFRLClear(srlist)
      call NhlFRLSetFloatArray(srlist,'caYArray',u,NPTS,ierr)
      call NhlFRLSetFloatArray(srlist,'caXArray',lon,NPTS,ierr)
      call NhlFCreate(field2,'field2',NhlFCoordArraysClass,
     +                0,srlist,ierr)
C
C Create the third Coord Arrays data object.
C
      call NhlFRLClear(srlist)
      call NhlFRLSetFloatArray(srlist,'caYArray',v,NPTS,ierr)
      call NhlFRLSetFloatArray(srlist,'caXArray',lon,NPTS,ierr)
      call NhlFCreate(field3,'field3',NhlFCoordArraysClass,
     +                0,srlist,ierr)
C
C Create XyPlot object for curve 1 and assign data to it.
C
      call NhlFRLClear(srlist)
      call NhlFRLSetFloat(srlist,'vpXF',.20,ierr)
      call NhlFRLSetFloat(srlist,'vpYF',.80,ierr)
      call NhlFRLSetFloat(srlist,'vpWidthF',.5,ierr)
      call NhlFRLSetFloat(srlist,'vpHeightF',.6,ierr)
      call NhlFRLSetInteger(srlist,'xyCoordData',field1,ierr)
      call NhlFRLSetString(srlist,'trYReverse','False',ierr)
      call NhlFRLSetFloat(srlist,'trYMaxF',-50.,ierr)
      call NhlFRLSetFloat(srlist,'trYMinF',-90.,ierr)
      call NhlFRLSetFloat(srlist,'trXMaxF',360.,ierr)
      call NhlFRLSetFloat(srlist,'trXMinF',0.,ierr)
      call NhlFRLSetString(srlist,'tmYROn','False',ierr)
      call NhlFRLSetString(srlist,'tmYUseLeft','False',ierr)
      call NhlFRLSetString(srlist,'tmYLLabelsOn','True',ierr)
      call NhlFRLSetFloat(srlist,'tmYLMajorLengthF',.01,ierr)
      call NhlFRLSetFloat(srlist,'tmYLMajorOutwardLengthF',.01,ierr)
      call NhlFRLSetString(srlist,'tmYLMode','Explicit',ierr)
      call NhlFRLSetFloatArray(srlist,'tmYLValues',ylvals,5,ierr)
      call NhlFRLSetStringArray(srlist,'tmYLLabels',yllabs,5,ierr)
      call NhlFRLSetString(srlist,'tmYLLabelsOn','True',ierr)
      call NhlFRLSetString(srlist,'tmYLLabelFontColor','red',ierr)
      call NhlFRLSetString(srlist,'tiXAxisString','Longitude (Degs)',
     +     ierr)
      call NhlFRLSetString(srlist,'tiYAxisString',
     +     'Temperature in Deg C',ierr)
      call NhlFRLSetFloat(srlist,'tiXAxisFontHeightF',0.02,ierr)
      call NhlFRLSetFloat(srlist,'tiYAxisFontHeightF',0.02,ierr)
      call NhlFRLSetString(srlist,'tiXAxisFont','helvetica-bold',ierr)
      call NhlFRLSetString(srlist,'tiYAxisFont','helvetica-bold',ierr)
      call NhlFRLSetString(srlist,'tiYAxisFontColor','red',ierr)
      call NhlFRLSetString(srlist,'tmYRMinorOn','False',ierr)
      call NhlFRLSetString(srlist,'tmYLMinorOn','False',ierr)
      call NhlFCreate(xy1,'xy1',NhlFXyPlotClass,xworkid,
     +     srlist,ierr)
C
C Create XyPlot object for curve 2 and assign data to it.
C
      call NhlFRLClear(srlist)
      call NhlFRLSetFloat(srlist,'vpXF',.20,ierr)
      call NhlFRLSetFloat(srlist,'vpYF',.80,ierr)
      call NhlFRLSetFloat(srlist,'vpWidthF',.5,ierr)
      call NhlFRLSetFloat(srlist,'vpHeightF',.6,ierr)
      call NhlFRLSetInteger(srlist,'xyCoordData',field2,ierr)
      call NhlFRLSetString(srlist,'trYReverse','False',ierr)
      call NhlFRLSetFloat(srlist,'trYMaxF',50.,ierr)
      call NhlFRLSetFloat(srlist,'trYMinF',0.,ierr)
      call NhlFRLSetFloat(srlist,'trXMaxF',360.,ierr)
      call NhlFRLSetFloat(srlist,'trXMinF',0.,ierr)
      call NhlFRLSetString(srlist,'tmYROn','True',ierr)
      call NhlFRLSetString(srlist,'tmYLOn','False',ierr)
      call NhlFRLSetString(srlist,'tmYUseLeft','False',ierr)
      call NhlFRLSetString(srlist,'tmYRLabelsOn','True',ierr)
      call NhlFRLSetString(srlist,'tmYLLabelsOn','False',ierr)
      call NhlFRLSetFloat(srlist,'tmYRMajorLengthF',.01,ierr)
      call NhlFRLSetFloat(srlist,'tmYRMajorOutwardLengthF',.01,ierr)
      call NhlFRLSetString(srlist,'tmYRMode','Explicit',ierr)
      call NhlFRLSetFloatArray(srlist,'tmYRValues',yrvals1,6,ierr)
      call NhlFRLSetStringArray(srlist,'tmYRLabels',yrlabs1,6,ierr)
      call NhlFRLSetString(srlist,'tmYRLabelFontColor','cyan',ierr)
      call NhlFRLSetString(srlist,'tiYAxisString',
     +     'U component of wind (m/s)',ierr)
      call NhlFRLSetString(srlist,'tiYAxisSide','Right',ierr)
      call NhlFRLSetFloat(srlist,'tiXAxisFontHeightF',0.02,ierr)
      call NhlFRLSetFloat(srlist,'tiYAxisFontHeightF',0.02,ierr)
      call NhlFRLSetString(srlist,'tiMainFont','helvetica-bold',ierr)
      call NhlFRLSetString(srlist,'tiXAxisFont','helvetica-bold',ierr)
      call NhlFRLSetString(srlist,'tiYAxisFont','helvetica-bold',ierr)
      call NhlFRLSetString(srlist,'tiYAxisFontColor','cyan',ierr)
      call NhlFRLSetString(srlist,'tmYRMinorOn','False',ierr)
      call NhlFRLSetString(srlist,'tmYLMinorOn','False',ierr)
      call NhlFCreate(xy2,'xy2',NhlFXyPlotClass,xworkid,
     +     srlist,ierr)
C
C Create XyPlot object for curve 3 and assign data to it.
C
C Increase the veiwport so the right scale will be about .15 NDC
C right of the other grids.  Plot only the right vertical axis.
C .5NDC = 360 deg lon, thus .65NDC = 360+108 deg lon.
C
      call NhlFRLClear(srlist)
      call NhlFRLSetFloat(srlist,'vpXF',.20,ierr)
      call NhlFRLSetFloat(srlist,'vpYF',.80,ierr)
      call NhlFRLSetFloat(srlist,'vpWidthF',.65,ierr)
      call NhlFRLSetFloat(srlist,'vpHeightF',.6,ierr)
      call NhlFRLSetInteger(srlist,'xyCoordData',field3,ierr)
      call NhlFRLSetString(srlist,'trYReverse','False',ierr)
      call NhlFRLSetFloat(srlist,'trYMaxF',20.,ierr)
      call NhlFRLSetFloat(srlist,'trYMinF',-20.,ierr)
      call NhlFRLSetFloat(srlist,'trXMaxF',468.,ierr)
      call NhlFRLSetFloat(srlist,'trXMinF',0.,ierr)
      call NhlFRLSetString(srlist,'tmYROn','True',ierr)
      call NhlFRLSetString(srlist,'tmYLOn','False',ierr)
      call NhlFRLSetString(srlist,'tmYUseLeft','False',ierr)
      call NhlFRLSetString(srlist,'tmYRLabelsOn','True',ierr)
      call NhlFRLSetFloat(srlist,'tmYRMajorLengthF',.01,ierr)
      call NhlFRLSetFloat(srlist,'tmYRMajorOutwardLengthF',.01,ierr)
      call NhlFRLSetString(srlist,'tmXBOn','False',ierr)
      call NhlFRLSetString(srlist,'tmXTOn','False',ierr)
      call NhlFRLSetString(srlist,'tmYLOn','False',ierr)
      call NhlFRLSetString(srlist,'tmYROn','True',ierr)
      call NhlFRLSetString(srlist,'tmYRMode','Explicit',ierr)
      call NhlFRLSetFloatArray(srlist,'tmYRValues',yrvals2,5,ierr)
      call NhlFRLSetStringArray(srlist,'tmYRLabels',yrlabs2,5,ierr)
      call NhlFRLSetString(srlist,'tmYRLabelFontColor','green',ierr)
      call NhlFRLSetString(srlist,'tiYAxisString',
     +     'V component of wind (m/s)',ierr)
      call NhlFRLSetString(srlist,'tiYAxisSide','Right',ierr)
      call NhlFRLSetFloat(srlist,'tiXAxisFontHeightF',0.02,ierr)
      call NhlFRLSetFloat(srlist,'tiYAxisFontHeightF',0.02,ierr)
      call NhlFRLSetString(srlist,'tiMainString',
     +     'Three Variables with Individual Scales',ierr)
      call NhlFRLSetFloat(srlist,'tiMainFontHeightF',0.030,ierr)
      call NhlFRLSetString(srlist,'tiMainFont','helvetica-bold',ierr)
      call NhlFRLSetString(srlist,'tiYAxisFont','helvetica-bold',ierr)
      call NhlFRLSetString(srlist,'tiYAxisFontColor','green',ierr)
      call NhlFRLSetString(srlist,'tmYRMinorOn','False',ierr)
      call NhlFRLSetString(srlist,'tmYLMinorOn','False',ierr)
      call NhlFRLSetString(srlist,'tmXBMinorOn','False',ierr)
      call NhlFRLSetString(srlist,'tmXTBorderOn','False',ierr)
      call NhlFRLSetString(srlist,'tmXBBorderOn','False',ierr)
      call NhlFRLSetString(srlist,'tmYLBorderOn','False',ierr)
      call NhlFCreate(xy3,'xy3',NhlFXyPlotClass,xworkid,
     +     srlist,ierr)
C
C Get the Data Spec Id of the first plot so we can then change
C the line color.
C
      call NhlFRLClear(grlist)
      call NhlFRLGetInteger(grlist,'xyCoordDataSpec',spec1,ierr)
      call NhlFGetValues(xy1,grlist,ierr)
      
      call NhlFRLClear(srlist)
      call NhlFRLSetString(srlist,'xyMonoLineColor','true',ierr)
      call NhlFRLSetString(srlist,'xyLineColor','red',ierr)
      call NhlFSetValues(spec1,srlist,ierr)
C
C Get the Data Spec id of the second plot so we can then change
C the line color.
C
      call NhlFRLClear(grlist)
      call NhlFRLGetInteger(grlist,'xyCoordDataSpec',spec2,ierr)
      call NhlFGetValues(xy2,grlist,ierr)

      call NhlFRLClear(srlist)
      call NhlFRLSetString(srlist,'xyMonoLineColor','true',ierr)
      call NhlFRLSetString(srlist,'xyLineColor','cyan',ierr)
      call NhlFSetValues(spec2,srlist,ierr)
C
C Get the Data Spec id of the third plot so we can then change
C the line color.
C
      call NhlFRLClear(grlist)
      call NhlFRLGetInteger(grlist,'xyCoordDataSpec',spec3,ierr)
      call NhlFGetValues(xy3,grlist,ierr)

      call NhlFRLClear(srlist)
      call NhlFRLSetString(srlist,'xyMonoLineColor','true',ierr)
      call NhlFRLSetString(srlist,'xyLineColor','green',ierr)
      call NhlFSetValues(spec3,srlist,ierr)
C
C Draw all three plots.
C
      call NhlFDraw(xy1,ierr)
      call NhlFDraw(xy2,ierr)
      call NhlFDraw(xy3,ierr)
      call NhlFFrame(xworkid,ierr)
      call NhlFClose
      stop
 104  write (6,*) 'error in opening file: ',filename
      end

      SUBROUTINE SLAGS2( UPPER, A1, A2, A3, B1, B2, B3, CSU, SNU, CSV,
     $                   SNV, CSQ, SNQ )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      LOGICAL            UPPER
      REAL               A1, A2, A3, B1, B2, B3, CSQ, CSU, CSV, SNQ,
     $                   SNU, SNV
*     ..
*
*  Purpose
*  =======
*
*  SLAGS2 computes 2-by-2 orthogonal matrices U, V and Q, such
*  that if ( UPPER ) then
*
*            U'*A*Q = U'*( A1 A2 )*Q = ( x  0  )
*                        ( 0  A3 )     ( x  x  )
*  and
*            V'*B*Q = V'*( B1 B2 )*Q = ( x  0  )
*                        ( 0  B3 )     ( x  x  )
*
*  or if ( .NOT.UPPER ) then
*
*            U'*A*Q = U'*( A1 0  )*Q = ( x  x  )
*                        ( A2 A3 )     ( 0  x  )
*  and
*            V'*B*Q = V'*( B1 0  )*Q = ( x  x  )
*                        ( B2 B3 )     ( 0  x  )
*
*  The rows of the transformed A and B are parallel, where
*
*    U = (  CSU  SNU ), V = (  CSV SNV ), Q = (  CSQ   SNQ )
*        ( -SNU  CSU )      ( -SNV CSV )      ( -SNQ   CSQ )
*
*  Z' denotes the transpose of Z.
*
*
*  Arguments
*  =========
*
*  UPPER   (input) LOGICAL
*          = .TRUE.: the input matrices A and B are upper triangular.
*          = .FALSE.: the input matrices A and B are lower triangular.
*
*  A1      (input) REAL
*  A2      (input) REAL
*  A3      (input) REAL
*          On entry, A1, A2 and A3 are elements of the input 2-by-2
*          upper (lower) triangular matrix A.
*
*  B1      (input) REAL
*  B2      (input) REAL
*  B3      (input) REAL
*          On entry, B1, B2 and B3 are elements of the input 2-by-2
*          upper (lower) triangular matrix B.
*
*  CSU     (output) REAL
*  SNU     (output) REAL
*          The desired orthogonal matrix U.
*
*  CSV     (output) REAL
*  SNV     (output) REAL
*          The desired orthogonal matrix V.
*
*  CSQ     (output) REAL
*  SNQ     (output) REAL
*          The desired orthogonal matrix Q.
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ZERO
      PARAMETER          ( ZERO = 0.0E+0 )
*     ..
*     .. Local Scalars ..
      REAL               A, AUA11, AUA12, AUA21, AUA22, AVB11, AVB12,
     $                   AVB21, AVB22, CSL, CSR, D, S1, S2, SNL,
     $                   SNR, UA11R, UA22R, VB11R, VB22R, B, C, R, UA11,
     $                   UA12, UA21, UA22, VB11, VB12, VB21, VB22
*     ..
*     .. External Subroutines ..
      EXTERNAL           SLARTG, SLASV2
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS
*     ..
*     .. Executable Statements ..
*
      IF( UPPER ) THEN
*
*        Input matrices A and B are upper triangular matrices
*
*        Form matrix C = A*adj(B) = ( a b )
*                                   ( 0 d )
*
         A = A1*B3
         D = A3*B1
         B = A2*B1 - A1*B2
*
*        The SVD of real 2-by-2 triangular C
*
*         ( CSL -SNL )*( A B )*(  CSR  SNR ) = ( R 0 )
*         ( SNL  CSL ) ( 0 D ) ( -SNR  CSR )   ( 0 T )
*
         CALL SLASV2( A, B, D, S1, S2, SNR, CSR, SNL, CSL )
*
         IF( ABS( CSL ).GE.ABS( SNL ) .OR. ABS( CSR ).GE.ABS( SNR ) )
     $        THEN
*
*           Compute the (1,1) and (1,2) elements of U'*A and V'*B,
*           and (1,2) element of |U|'*|A| and |V|'*|B|.
*
            UA11R = CSL*A1
            UA12 = CSL*A2 + SNL*A3
*
            VB11R = CSR*B1
            VB12 = CSR*B2 + SNR*B3
*
            AUA12 = ABS( CSL )*ABS( A2 ) + ABS( SNL )*ABS( A3 )
            AVB12 = ABS( CSR )*ABS( B2 ) + ABS( SNR )*ABS( B3 )
*
*           zero (1,2) elements of U'*A and V'*B
*
            IF( ( ABS( UA11R )+ABS( UA12 ) ).NE.ZERO ) THEN
               IF( AUA12 / ( ABS( UA11R )+ABS( UA12 ) ).LE.AVB12 /
     $             ( ABS( VB11R )+ABS( VB12 ) ) ) THEN
                  CALL SLARTG( -UA11R, UA12, CSQ, SNQ, R )
               ELSE
                  CALL SLARTG( -VB11R, VB12, CSQ, SNQ, R )
               END IF
            ELSE
               CALL SLARTG( -VB11R, VB12, CSQ, SNQ, R )
            END IF
*
            CSU = CSL
            SNU = -SNL
            CSV = CSR
            SNV = -SNR
*
         ELSE
*
*           Compute the (2,1) and (2,2) elements of U'*A and V'*B,
*           and (2,2) element of |U|'*|A| and |V|'*|B|.
*
            UA21 = -SNL*A1
            UA22 = -SNL*A2 + CSL*A3
*
            VB21 = -SNR*B1
            VB22 = -SNR*B2 + CSR*B3
*
            AUA22 = ABS( SNL )*ABS( A2 ) + ABS( CSL )*ABS( A3 )
            AVB22 = ABS( SNR )*ABS( B2 ) + ABS( CSR )*ABS( B3 )
*
*           zero (2,2) elements of U'*A and V'*B, and then swap.
*
            IF( ( ABS( UA21 )+ABS( UA22 ) ).NE.ZERO ) THEN
               IF( AUA22 / ( ABS( UA21 )+ABS( UA22 ) ).LE.AVB22 /
     $             ( ABS( VB21 )+ABS( VB22 ) ) ) THEN
                  CALL SLARTG( -UA21, UA22, CSQ, SNQ, R )
               ELSE
                  CALL SLARTG( -VB21, VB22, CSQ, SNQ, R )
               END IF
            ELSE
               CALL SLARTG( -VB21, VB22, CSQ, SNQ, R )
            END IF
*
            CSU = SNL
            SNU = CSL
            CSV = SNR
            SNV = CSR
*
         END IF
*
      ELSE
*
*        Input matrices A and B are lower triangular matrices
*
*        Form matrix C = A*adj(B) = ( a 0 )
*                                   ( c d )
*
         A = A1*B3
         D = A3*B1
         C = A2*B3 - A3*B2
*
*        The SVD of real 2-by-2 triangular C
*
*         ( CSL -SNL )*( A 0 )*(  CSR  SNR ) = ( R 0 )
*         ( SNL  CSL ) ( C D ) ( -SNR  CSR )   ( 0 T )
*
         CALL SLASV2( A, C, D, S1, S2, SNR, CSR, SNL, CSL )
*
         IF( ABS( CSR ).GE.ABS( SNR ) .OR. ABS( CSL ).GE.ABS( SNL ) )
     $        THEN
*
*           Compute the (2,1) and (2,2) elements of U'*A and V'*B,
*           and (2,1) element of |U|'*|A| and |V|'*|B|.
*
            UA21 = -SNR*A1 + CSR*A2
            UA22R = CSR*A3
*
            VB21 = -SNL*B1 + CSL*B2
            VB22R = CSL*B3
*
            AUA21 = ABS( SNR )*ABS( A1 ) + ABS( CSR )*ABS( A2 )
            AVB21 = ABS( SNL )*ABS( B1 ) + ABS( CSL )*ABS( B2 )
*
*           zero (2,1) elements of U'*A and V'*B.
*
            IF( ( ABS( UA21 )+ABS( UA22R ) ).NE.ZERO ) THEN
               IF( AUA21 / ( ABS( UA21 )+ABS( UA22R ) ).LE.AVB21 /
     $             ( ABS( VB21 )+ABS( VB22R ) ) ) THEN
                  CALL SLARTG( UA22R, UA21, CSQ, SNQ, R )
               ELSE
                  CALL SLARTG( VB22R, VB21, CSQ, SNQ, R )
               END IF
            ELSE
               CALL SLARTG( VB22R, VB21, CSQ, SNQ, R )
            END IF
*
            CSU = CSR
            SNU = -SNR
            CSV = CSL
            SNV = -SNL
*
         ELSE
*
*           Compute the (1,1) and (1,2) elements of U'*A and V'*B,
*           and (1,1) element of |U|'*|A| and |V|'*|B|.
*
            UA11 = CSR*A1 + SNR*A2
            UA12 = SNR*A3
*
            VB11 = CSL*B1 + SNL*B2
            VB12 = SNL*B3
*
            AUA11 = ABS( CSR )*ABS( A1 ) + ABS( SNR )*ABS( A2 )
            AVB11 = ABS( CSL )*ABS( B1 ) + ABS( SNL )*ABS( B2 )
*
*           zero (1,1) elements of U'*A and V'*B, and then swap.
*
            IF( ( ABS( UA11 )+ABS( UA12 ) ).NE.ZERO ) THEN
               IF( AUA11 / ( ABS( UA11 )+ABS( UA12 ) ).LE.AVB11 /
     $             ( ABS( VB11 )+ABS( VB12 ) ) ) THEN
                  CALL SLARTG( UA12, UA11, CSQ, SNQ, R )
               ELSE
                  CALL SLARTG( VB12, VB11, CSQ, SNQ, R )
               END IF
            ELSE
               CALL SLARTG( VB12, VB11, CSQ, SNQ, R )
            END IF
*
            CSU = SNR
            SNU = CSR
            CSV = SNL
            SNV = CSL
*
         END IF
*
      END IF
*
      RETURN
*
*     End of SLAGS2
*
      END

C
C $Id: mapstc.f,v 1.21 2008-09-18 00:42:16 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MAPSTC (WHCH,CVAL)
        CHARACTER*(*) WHCH
        CHARACTER*(*) CVAL
        IF (ICFELL('MAPSTC - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
        CALL MDSETC (WHCH,CVAL)
        IF (ICFELL('MAPSTC',2).NE.0) RETURN
        RETURN
      END

C
C $Id: mdrgsf.f,v 1.12 2008-09-18 00:42:18 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MDRGSF (IRGL,RWRK,LRWK,IAMA,LAMA)
C
        INTEGER IRGL,LRWK,IAMA(LAMA),LAMA
        REAL RWRK(LRWK)
C
C This routine is called to draw RANGS/GSHHS polygons in the current
C EZMAP window.  The argument IRGL specifies the level of resolution
C to be used, from 0 (highest resolution) to 4 (lowest resolution).
C
C Declare required common blocks.  See MAPBDX for descriptions of these
C common blocks and the variables in them.
C
        COMMON /MAPCM2/  BLAM,BLOM,PEPS,SLAM,SLOM,UCEN,UMAX,UMIN,UOFF,
     +                   URNG,VCEN,VMAX,VMIN,VOFF,VRNG,ISSL
        DOUBLE PRECISION BLAM,BLOM,PEPS,SLAM,SLOM,UCEN,UMAX,UMIN,UOFF,
     +                   URNG,VCEN,VMAX,VMIN,VOFF,VRNG
        INTEGER          ISSL
        SAVE   /MAPCM2/
C
        COMMON /MAPCM4/  GRDR,GRID,GRLA,GRLO,GRPO,OTOL,PDRE,PLA1,PLA2,
     +                   PLA3,PLA4,PLB1,PLB2,PLB3,PLB4,PLNO,PLTO,ROTA,
     +                   SRCH,XLOW,XROW,YBOW,YTOW,IDOT,IDSH,IDTL,ILCW,
     +                   ILTS,JPRJ,ELPF,INTF,LBLF,PRMF
        DOUBLE PRECISION GRDR,GRID,GRLA,GRLO,GRPO,OTOL,PDRE,PLA1,PLA2,
     +                   PLA3,PLA4,PLB1,PLB2,PLB3,PLB4,PLNO,PLTO,ROTA,
     +                   SRCH,XLOW,XROW,YBOW,YTOW
        INTEGER          IDOT,IDSH,IDTL,ILCW,ILTS,JPRJ
        LOGICAL          ELPF,INTF,LBLF,PRMF
        SAVE   /MAPCM4/
C
        COMMON /MAPRGD/  ICOL(5),ICSF(5),IDPF,LCRA,NILN,NILT,OLAT,OLON
        INTEGER          ICOL,ICSF,IDPF,LCRA,NILN,NILT
        REAL             OLAT,OLON
        SAVE   /MAPRGD/
C
C Declare local variables.
C
        DOUBLE PRECISION P,Q,RLAT,RLON,UPRJ,VPRJ
        INTEGER          I,J,ICAT,ICEL,IERR,IFAC,IFUA,IGCF,ILAT,ILON,
     +                   IRIM,IWGF,NPTS
        REAL             DUMI(4)
C
C Check for an uncleared prior error.
C
        IF (ICFELL('MDRGSF - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C If EZMAP needs initialization, do it.
C
        IF (INTF) THEN
          CALL MDPINT
          IF (ICFELL('MDRGSF',2).NE.0) RETURN
        END IF
C
C Open the RANGS/GSHHS files.
C
        CALL MDRGOF (MAX(0,MIN(4,IRGL)),ICAT,ICEL,IRIM)
        IF (ICFELL('MDRGSF',3).NE.0) RETURN
C
C Save the current state of the GKS clipping flag and turn clipping on.
C (Note that the call to GTX to write a blank is a work-around that has
C no visible effect on the picture but causes GKS to send the clipping
C flag and clipping rectangle to a workstation even if nothing else had
C previously been sent to it, so don't take it out unless you know that
C the behavior of GKS in this regard has been changed.)
C
        CALL GQCLIP (IERR,IGCF,DUMI)
C
        IF (IERR.NE.0) THEN
          CALL SETER ('MDRGSF - ERROR EXIT FROM GQCLIP',4,1)
          RETURN
        END IF
C
        CALL GTX    (CFUX(.5),CFUY(.5),' ')
C
        CALL GSCLIP (1)
C
C Save the current fill-area color.
C
        CALL GQFACI (IERR,IFAC)
C
        IF (IERR.NE.0) THEN
          CALL SETER ('MDRGSF - ERROR EXIT FROM GQFACI',5,1)
          RETURN
        END IF
C
C Decide whether to do the fill using MDRGSQ, which fills the polygons
C directly, or using MDRGSX, which uses an area map.  The latter is done
C only when the filling of the polygons at some nesting level is to be
C omitted, but the filling of those at a higher level was not.
C
        IFUA=-1
C
        DO 101 I=1,5
          IF (ICSF(I).GE.0) THEN
            IFUA=0
          ELSE
            IF (IFUA.EQ.0) THEN
              IFUA=2
              GO TO 102
            END IF
          END IF
  101   CONTINUE
C
        IF (IFUA.LT.0) GO TO 108
C
C Look for 1-degree lat/lon "squares" that are visible and plot
C polygons in them.
C
  102   NPTS=7
C
C Set the flag IWGF to say whether or not the whole globe is shown by
C the current projection.  If so (IWGF=1), there's no need to waste the
C time required to check each 1-degree square for intersection with
C the window.
C
        IWGF=0
        IF (BLAM-SLAM.GT.179.D0.AND.BLOM-SLOM.GT.359.D0) IWGF=1
C
C Loop through all the 1-degree lat/lon squares; for each one, do a
C quick test to see if the square is entirely invisible and, if not,
C do more exhaustive tests to see if part of it is visible.
C
        DO 107 ILON=0,359
          IF (IWGF.EQ.0.AND.
     +        (DBLE(ILON   ).GT.BLOM.OR.
     +         DBLE(ILON+1 ).LT.SLOM).AND.
     +        (DBLE(ILON-360).GT.BLOM.OR.
     +         DBLE(ILON-359).LT.SLOM).AND.
     +        (DBLE(ILON+360).GT.BLOM.OR.
     +         DBLE(ILON+361).LT.SLOM))                        GO TO 107
          DO 106 ILAT = -90,89
            IF (IWGF.EQ.0.AND.
     +          (DBLE(ILAT).GT.BLAM.OR.DBLE(ILAT+1).LT.SLAM))  GO TO 106
            DO 104 I=1,NPTS
              P=DBLE(I-1)/DBLE(NPTS-1)
              DO 103 J=1,NPTS
                Q=DBLE(J-1)/DBLE(NPTS-1)
                CALL MDPTRA (DBLE(ILAT)+P,DBLE(ILON)+Q,UPRJ,VPRJ)
                IF (UPRJ.NE.1.D12)                             GO TO 105
                CALL MDPTRI (UMIN+P*(UMAX-UMIN),VMIN+Q*(VMAX-VMIN),
     +                                                   RLAT,RLON)
                IF (RLON.LT.DBLE(ILON)) RLON=RLON+360.D0
                IF (RLON.GT.DBLE(ILON+360)) RLON=RLON-360.D0
                IF (RLAT.GE.DBLE(ILAT).AND.RLAT.LE.DBLE(ILAT+1).AND.
     +              RLON.GE.DBLE(ILON).AND.RLON.LE.DBLE(ILON+1))
     +                                                         GO TO 105
  103         CONTINUE
  104       CONTINUE
                                                               GO TO 106
  105       IF (IDPF.EQ.0.AND.IFUA.EQ.0) THEN
              CALL MDRGSQ (ICAT,ICEL,IRIM,ILAT,ILON,1,
     +                                       RWRK,RWRK(LRWK/2+1),LRWK/2)
            ELSE
              CALL MDRGSX (ICAT,ICEL,IRIM,ILAT,ILON,
     +                                     MAX(1,MIN(2,IDPF+IFUA)),IRGL,
     +                             IAMA,LAMA,RWRK,RWRK(LRWK/2+1),LRWK/2)
            END IF
            IF (ICFELL('MDRGSF',6).NE.0)                       GO TO 108
  106     CONTINUE
  107   CONTINUE
C
C Restore the fill-area color to its original value.
C
  108   CALL GSFACI (IFAC)
C
C Reset the clipping flag.
C
        CALL GSCLIP (IGCF)
C
C Close all RANGS/GSHHS files.
C
        CALL NGCLFI (ICAT)
        CALL NGCLFI (ICEL)
        CALL NGCLFI (IRIM)
C
C Done.
C
        RETURN
C
      END

C
C
C       $Id: coeff1.f,v 1.2 1997-05-05 21:45:41 boote Exp $
C
C PACKAGE CUBSPL         NOTE--DOCUMENTATION FOR INDIVIDUAL ROUTINES
C                              FOLLOWS THE GENERAL PACKAGE INFORMATION
C
C LATEST REVISION        JANUARY 1985
C
C PURPOSE                TO PERFORM ONE AND TWO-DIMENSIONAL CUBIC SPLINE
C                        INTERPOLATION WITH CHOICE OF BOUNDARY
C                        CONDITIONS.  THE FUNCTION AND SELECTED
C                        DERIVATIVES MAY BE EVALUATED AT ANY POINT WHERE
C                        INTERPOLATION IS REQUIRED.  IN THE
C                        TWO-DIMENSIONAL CASE, THE GIVEN DATA POINTS
C                        MUST BE ON A RECTANGULAR GRID, WHICH NEED NOT
C                        BE EQUALLY SPACED.  THE PACKAGE CUBSPL CONTAINS
C                        SEVEN ROUTINES.
C
C                        SUBROUTINE COEFF1
C                          COMPUTES THE COEFFICIENTS FOR ONE-DIMENSIONAL
C                          CUBIC SPLINE INTERPOLATION USING ONE OF
C                          THE FOLLOWING BOUNDARY CONDITIONS AT
C                          EACH END OF THE RANGE.
C                            . SECOND DERIVATIVE GIVEN AT BOUNDARY.
C                            . FIRST DERIVATIVE GIVEN AT BOUNDARY.
C                            . PERIODIC BOUNDARY CONDITION.
C                            . FIRST DERIVATIVE DETERMINED BY FITTING A
C                              CUBIC TO THE FOUR POINTS NEAREST TO THE
C                              BOUNDARY.
C
C                        SUBROUTINE TERP1
C                          USING THE COEFFICIENTS COMPUTED BY COEFF1,
C                          THIS ROUTINE EVALUATES THE FUNCTION AND/OR
C                          FIRST AND SECOND DERIVATIVES AT ANY POINT
C                          WHERE INTERPOLATION IS REQUIRED.
C
C                        SUBROUTINE COEFF2
C                          COMPUTES THE COEFFICIENTS FOR TWO-DIMENSIONAL
C                          BICUBIC SPLINE INTERPOLATION WITH THE SAME
C                          CHOICE OF BOUNDARY CONDITIONS AS FOR COEFF1.
C
C                        FUNCTION TERP2
C                          USING THE COEFFICIENTS PRODUCED BY COEFF2,
C                          THIS SUBROUTINE EVALUATES THE FUNCTION OR A
C                          SELECTED DERIVATIVE AT ANY POINT WHERE
C                          TWO-DIMENSIONAL INTERPOLATION IS REQUIRED.
C
C                        SUBROUTINE TRIP
C                          A SIMPLE PERIODIC, TRIDIAGONAL LINEAR
C                          EQUATION SOLVER USED BY COEFF1.
C
C                        SUBROUTINE SEARCH
C                          PERFORMS A BINARY SEARCH IN A ONE-DIMENSIONAL
C                          FLOATING POINT TABLE ARRANGED IN ASCENDING
C                          ORDER.  THIS ROUTINE IS CALLED BY TERP1 AND
C                          TERP2.
C
C                        SUBROUTINE INTERP
C                          GIVEN COEFFICIENTS PROVIDED BY COEFF1 AND THE
C                          POSITION OF THE INTERPOLATION POINT IN THE
C                          INDEPENDENT VARIABLE TABLE, THIS ROUTINE
C                          PERFORMS ONE-DIMENSIONAL INTERPOLATION FOR
C                          THE FUNCTION VALUE, FIRST AND SECOND
C                          DERIVATIVE, AS DESIRED.  THIS ROUTINE IS
C                          CALLED BY TERP1 AND TERP2.
C
C USAGE                  FOR ONE-DIMENSIONAL CUBIC SPLINE INTERPOLATION,
C                        THE USER FIRST CALLS COEFF1 BY
C
C                          CALL COEFF1 (N,X,F,W,IOP,INT,WK)
C
C                        THIS SUBROUTINE RETURNS THE COEFFICIENTS
C                        NEEDED FOR THE SUBSEQUENT INTERPOLATION
C                        IN THE ARRAY W.  THE USER THEN CALLS
C                        SUBROUTINE TERP1 BY
C
C                          CALL TERP1 (N,X,F,W,Y,INT,TAB,ITAB)
C
C                        IN ORDER TO COMPUTE THE VALUE OF THE
C                        FUNCTION AND/OR ITS DERIVATIVES.  THE USER
C                        SPECIFIES Y, THE VALUE OF THE INDEPENDENT
C                        VARIABLE WHERE THE INTERPOLATION IS TO BE
C                        PERFORMED.  THE INTERPOLATED VALUES ARE
C                        RETURNED IN TAB.  THE PARAMETERS
C                        N,X,F,W, AND INT MUST NOT BE CHANGED
C                        BETWEEN THE SUBROUTINE CALLS.
C
C                        FOR TWO-DIMENSIONAL CUBIC SPLINE INTERPOLATION
C                        THE USER FIRST CALLS COEFF2 BY
C
C                          CALL COEFF2 (NX,X,NY,Y,F,FXX,FYY,FXXYY,
C                                       IDM,IBD,WK)
C
C                        THIS SUBROUTINE RETURNS THE COEFFICIENTS
C                        NEEDED FOR THE SUBSEQUENT INTERPOLATION IN
C                        THE ARRAYS FXX, FYY, FXXYY.  THE USER THEN
C                        CALLS THE ROUTINE TERP2 BY
C
C                          R = TERP2 (XB,YB,NX,X,NY,Y,F,FXX,FYY,FXXYY,
C                                     IDM,IXD,IYD)
C
C                        IN ORDER TO PERFORM THE INTERPOLATION AT THE
C                        POINT SPECIFIED BY THE VALUES OF XB AND YB.
C                        DEPENDING ON THE VALUES INPUT IN IXD AND IYD,
C                        THE ROUTINE RETURNS AN INTERPOLATED VALUE
C                        FOR THE FUNCTION OR ONE OF ITS PARTIAL
C                        DERIVATIVES.  THE PARAMETERS NX,X,NY,Y,F,FXX,
C                        FYY,FXXYY, AND IDM MUST NOT BE CHANGED
C                        BETWEEN THE CALLS TO COEFF2 AND TERP2.
C
C SPECIAL CONDITIONS     TABLES OF INDEPENDENT VARIABLES MUST BE
C                        ARRANGED IN ASCENDING ORDER.  FOR
C                        TWO-DIMENSIONAL INTERPOLATION, THE DATA POINTS
C                        MUST LIE ON A RECTANGULAR MESH.
C
C I/O                    NONE
C
C PRECISION              SINGLE
C
C REQUIRED LIBRARY       NONE
C FILES
C
C LANGUAGE               FORTRAN
C
C HISTORY                THIS PACKAGE IS BASED ON THE ROUTINES
C                            LA E 102A, SPL1D1
C                            LA E 103A, SPL1D2
C                            LA E 104A, SPL2D1
C                            LA E 105A, SPL2D2
C                        OF THE LOS ALAMOS CUBIC SPLINE PACKAGE WRITTEN
C                        BY THOMAS J. JORDAN AND BERTHA FAGAN, 1968.
C                        THE ROUTINES HAVE BEEN STREAMLINED AND
C                        STANDARDIZED.  THE ALGORITHM FOR
C                        TWO-DIMENSIONAL INTERPOLATION IS CONSIDERABLY
C                        MODIFIED.
C
C ALGORITHM              FOR ONE-DIMENSIONAL INTERPOLATION, THE CUBIC
C                        SPLINE IS EXPRESSED IN TERMS OF THE FUNCTION
C                        VALUES AND SECOND DERIVATIVES AT THE DATA
C                        POINTS.  THE SECOND DERIVATIVES ARE
C                        DETERMINED FROM A TRIDIAGONAL LINEAR SYSTEM
C                        WHICH DESCRIBES THE CONTINUITY OF THE FIRST
C                        DERIVATIVE AND INCORPORATES THE GIVEN
C                        BOUNDARY CONDITIONS.  COEFF1  SETS UP THIS
C                        SYSTEM AND CALLS SUBROUTINE TRIP TO SOLVE IT.
C
C                        THE CUBIC SEGMENT BETWEEN TWO ADJACENT
C                        TABULAR POINTS IS CONSTRUCTED FROM THE
C                        FUNCTION VALUES AND SECOND DERIVATIVES AT
C                        THESE POINTS.  THESE PROVIDE THE FOUR
C                        CONSTANTS NEEDED TO DEFINE THE CUBIC
C                        UNIQUELY.  FROM THIS CUBIC, VALUES OF THE
C                        FUNCTION AND ITS FIRST AND SECOND
C                        DERIVATIVES ARE READILY DETERMINED AT ANY
C                        INTERMEDIATE POINT.  ONE-DIMENSIONAL
C                        INTERPOLATION IS PERFORMED BY THE ROUTINE
C                        TERP1.  FOR TWO-DIMENSIONAL INTERPOLATION,
C                        THE BICUBIC SPLINE IS DESCRIBED IN TERMS OF
C                        VALUES OF F,FXX,FYY, AND FXXYY  AT EACH
C                        POINT ON THE GIVEN TWO-DIMENSIONAL
C                        RECTANGULAR GRID OF DATA POINTS.  HERE F
C                        IS THE FUNCTION VALUE,
C
C                          FXX = (D/DX)**2*F
C
C                        AND SO ON.  THE COEFFICIENTS ARE DETERMINED
C                        BY COEFF2, WHICH USES SUCCESSIVE
C                        APPLICATIONS OF COEFF1.
C
C                        1.  THE ARRAY FXX IS DETERMINED BY APPLYING
C                            COEFF1 TO F ALONG EACH LINE IN THE
C                            X-DIRECTION.
C
C                        2.  THE ARRAY FYY IS DETERMINED BY APPLYING
C                            COEFF1 TO F ALONG EACH LINE IN THE
C                            Y-DIRECTION.
C
C                        3.  FXXYY IS DETERMINED ON THE CONSTANT Y
C                            BOUNDARIES BY APPLYING COEFF1 TO FYY
C                            ALONG THESE BOUNDARIES.
C
C                        4.  THE REMAINDER OF THE ARRAY FXXYY IS
C                            DETERMINED BY APPLYING COEFF1 TO FXX
C                            ALONG EACH LINE IN THE Y-DIRECTION.
C
C                        THE BICUBIC WITHIN ANY RECTANGULAR ELEMENT
C                        OF THE GRID IS CONSTRUCTED FROM THE VALUES
C                        OF F,FXX,FYY,FXXYY AT THE FOUR CORNERS.
C                        THESE PROVIDE THE 16 CONSTANTS NECESSARY
C                        TO DEFINE THE BICUBIC UNIQUELY.  TO FIND
C                        THE VALUE OF F CORRESPONDING TO A POINT
C                        (XB,YB) WITHIN THE ELEMENTARY RECTANGLE,
C                        (X(I),Y(J)),(X(I+1),Y(J)),(X(I),Y(J+1)),
C                        (X(I+1),Y(J+1)), FIVE ONE DIMENSIONAL
C                        INTERPOLATIONS ARE PERFORMED.
C
C                        1.  F AT (XB,Y(J)) AND (XB,Y(J+1)) ARE
C                            FOUND BY INTERPOLATING F IN THE
C                            X-DIRECTION USING FXX. (TWO INTERPOLATIONS)
C
C                        2.  FYY AT (XB,Y(J)) AND (XB,Y(J+1)) ARE
C                            FOUND BY INTERPOLATING FYY IN THE
C                            X-DIRECTION USING FXXYY. (TWO
C                            INTERPOLATIONS.)
C
C                        3.  FINALLY F AT (XB,YB) IS FOUND BY
C                        INTERPOLATING BETWEEN F(XB,Y(J)) AND
C                        F(XB,Y(J+1)) IN THE Y-DIRECTION USING
C                        VALUES OF FYY(XB,Y(J)) AND FYY(XB,Y(J+1))
C                        OBTAINED ABOVE. (ONE INTERPOLATION).
C
C                        TWO-DIMENSIONAL INTERPOLATION IS PERFORMED
C                        IN TERP2.
C
C REFERENCES             FOR GREATER DETAIL, SEE J.L.WALSH,
C                        J.H.AHLBERG, E.N.NILSEN, BEST APPROXIMATION
C                        PROPERTIES OF THE SPLINE FIT, JOURNAL OF
C                        MATHEMATICS AND MECHANICS, VOL.II(1962),
C                        225-234.
C
C                        T.L. JORDAN, SMOOTHING AND MULTIVARIABLE
C                        INTERPOLATION WITH SPLINES, LOS ALAMOS
C                        REPORT, LA-3137, 1965.
C
C ACCURACY               NEAR MACHINE ACCURACY WAS OBTAINED WHEN
C                        INTERPOLATING A CUBIC IN ONE DIMENSION
C                        OR A BICUBIC IN TWO DIMENSIONS.
C
C PORTABILITY            FULLY PORTABLE WITH RESPECT TO FORTRAN 66.
C***********************************************************************
C
C SUBROUTINE COEFF1 (N,X,F,W,IOP,INT,WK)
C
C DIMENSION OF           X(N),F(INT*(N-1)+1),W(INT*(N-1)+1),IOP(2),
C ARGUMENTS              WK(3*N+1)
C
C PURPOSE                SUBROUTINE COEFF1 COMPUTES THE COEFFICIENTS
C                        FOR ONE-DIMENSIONAL CUBIC SPLINE
C                        INTERPOLATION USING ONE OF THE FOLLOWING
C                        BOUNDARY CONDITIONS AT EACH END OF THE
C                        RANGE
C
C                        .  SECOND DERIVATIVES GIVEN AT BOUNDARY
C                        .  FIRST DERIVATIVE GIVEN AT BOUNDARY
C                        .  PERIODIC BOUNDARY CONDITIONS
C                        .  FIRST DERIVATIVE CALCULATED BY FITTING A
C                           CUBIC TO THE FOUR POINTS NEAREST TO THE
C                           BOUNDARY
C
C                        NOTE THAT TERP1 MUST BE CALLED TO PERFORM
C                        THE INTERPOLATION.
C
C USAGE                  CALL COEFF1 (N,X,F,W,IOP,INT,WK)
C
C ARGUMENTS
C
C ON INPUT               N
C                          THE NUMBER OF DATA POINTS.  N MUST BE AT
C                          LEAST 4.
C
C                        X
C                          TABLE OF N INDEPENDENT VARIABLE VALUES IN
C                          ASCENDING ORDER.  DIMENSION OF X IN CALLING
C                          PROGRAM MUST BE AT LEAST N.
C
C                        F
C                          TABLE OF N CORRESPONDING DEPENDENT VARIABLE
C                          VALUES.  THE VALUES ARE SEPARATED BY INTERVAL
C                          INT.  THIS IS USUALLY UNITY FOR
C                          ONE-DIMENSIONAL INTERPOLATION.  OTHER VALUES
C                          ARE USEFUL WHEN COEFF1 IS INCORPORATED IN A
C                          TWO-DIMENSIONAL INTERPOLATION SCHEME (SEE
C                          COEFF2).  DIMENSION OF F IN THE CALLING
C                          PROGRAM MUST BE AT LEAST (INT*(N-1)+1).
C
C                        IOP
C                          TWO ELEMENT INTEGER ARRAY DEFINING BOUNDARY
C                          CONDITIONS AT X(1) AND X(N) ACCORDING TO THE
C                          FOLLOWING CODE.
C
C                          FOR IOP(1)
C                          = 1  SECOND DERIVATIVE GIVEN AT X(1).  PLACE
C                               VALUE OF SECOND DERIVATIVE IN W(1)
C                               BEFORE CALL TO COEFF1.
C                          = 2  FIRST DERIVATIVE GIVEN AT X(1).  PLACE
C                               VALUE OF FIRST DERIVATIVE IN W(1) BEFORE
C                               CALL.
C                          = 3  PERIODIC BOUNDARY CONDITION.  X(1) AND
C                               X(N) ARE EQUIVALENT POINTS.  F(1) AND
C                               F(INT*(N-1)+1) ARE EQUAL.
C                          = 4  THE FIRST DERIVATIVE AT X(1) IS
C                               CALCULATED BY FITTING A CUBIC TO POINTS
C                               X(1) THROUGH X(4).
C                          SIMILARLY, IOP(2) DEFINES THE BOUNDARY
C                          CONDITION AT X(N).  WHEN IOP(2) = 1 (OR 2),
C                          THE VALUE OF THE SECOND (OR FIRST) DERIVATIVE
C                          MUST BE PLACED IN W(INT*(N-1)+1).  NOTE THAT
C                          IF IOP(1) = 3, CONSISTENCY DEMANDS THAT
C                          IOP(2) = 3 ALSO.
C
C                        INT
C                          SPACING IN F AND W TABLES.  FOR
C                          ONE-DIMENSIONAL INTERPOLATION THIS WILL
C                          USUALLY BE UNITY.
C
C                        WK
C                          WORK AREA OF DIMENSION AT LEAST (3*N+1).
C
C ON OUTPUT              W
C                          TABLE OF SECOND DERIVATIVES CORRESPONDING TO
C                          GIVEN X AND F VALUES.  THE SEPARATION OF
C                          TABULAR ENTRIES IS INT (SEE ABOVE).
C                          DIMENSION OF W IN THE CALLING PROGRAM MUST BE
C                          AT LEAST (INT*(N-1)+1).
C
C                          THE ARRAYS X, F, W ARE USED AS INPUT FOR THE
C                          ROUTINE TERP1, WHICH PERFORMS INTERPOLATION
C                          AT A GIVEN VALUE OF THE INDEPENDENT VARIABLE.
C
C TIMING                 THE TIMING IS LINEARLY PROPORTIONAL TO N, THE
C                        NUMBER OF DATA POINTS.
C***********************************************************************
C
C     SUBROUTINE TERP1 (N,X,F,W,Y,INT,TAB,ITAB)
C
C
C DIMENSION OF           X(N),F(INT*(N-1)+1),W(INT*(N-1)+1),TAB(3),
C ARGUMENTS              ITAB(3)
C
C PURPOSE                USING THE COEFFICIENTS COMPUTED BY COEFF1,
C                        THIS ROUTINE EVALUATES THE FUNCTION AND/OR
C                        FIRST AND SECOND DERIVATIVES AT ANY POINT.
C
C USAGE                  CALL TERP1 (N,X,F,W,Y,INT,TAB,ITAB)
C
C ARGUMENTS
C
C ON INPUT               N
C                          THE NUMBER OF DATA POINTS.  N MUST BE AT
C                          LEAST 4.
C
C                        X
C                          TABLE OF N INDEPENDENT VARIABLE VALUES IN
C                          ASCENDING ORDER.  DIMENSION OF X IN THE
C                          CALLING PROGRAM MUST BE AT LEAST N.
C
C                        F
C                          TABLE OF N CORRESPONDING DEPENDENT VARIABLE
C                          VALUES SEPARATED BY INTERVAL INT, USUALLY
C                          UNITY FOR ONE-DIMENSIONAL INTERPOLATION.
C                          DIMENSION OF F IN THE CALLING PROGRAM MUST BE
C                          AT LEAST (INT*(N-1)+1).
C
C                        W
C                          TABLE OF SECOND DERIVATIVES COMPUTED BY
C                          COEFF1.  THE SEPARATION OF TABULAR ENTRIES IS
C                          INT.  DIMENSION OF W IN THE CALLING PROGRAM
C                          MUST BE AT LEAST (INT*(N-1)+1).
C
C                        Y
C                          VALUE OF THE INDEPENDENT VARIABLE AT WHICH
C                          INTERPOLATION IS REQUIRED.  IF Y LIES OUTSIDE
C                          THE RANGE OF THE TABLE, EXTRAPOLATION TAKES
C                          PLACE.
C
C                        INT
C                          SPACING OF TABULAR ENTRIES IN F AND W ARRAYS.
C                          THIS IS USUALLY UNITY FOR ONE-DIMENSIONAL
C                          INTERPOLATION.
C
C                        ITAB
C                          THREE ELEMENT INTEGER ARRAY DEFINING
C                          INTERPOLATION TO BE PERFORMED AT Y.
C                            IF ITAB(1) = 1, THE FUNCTION VALUE IS
C                                            RETURNED IN TAB(1).
C                            IF ITAB(2) = 1, THE FIRST DERIVATIVE IS
C                                            RETURNED IN TAB(2).
C                            IF ITAB(3) = 1, THE SECOND DERIVATIVE IS
C                                            RETURNED IN TAB(3).
C                          IF ITAB(I) = 0 FOR I = 1, 2 OR 3, THE
C                          CORRESPONDING FUNCTION VALUE OR DERIVATIVE IS
C                          NOT COMPUTED AND TAB(I) IS NOT REFERENCED.
C
C ON OUTPUT              TAB
C                          THREE ELEMENT ARRAY IN WHICH INTERPOLATED
C                          FUNCTION VALUE, FIRST AND SECOND DERIVATIVES
C                          ARE RETURNED AS DICTATED BY ITAB (SEE ABOVE).
C
C TIMING                 THIS PROCEDURE IS FAST.  THE MAXIMUM TIME FOR
C                        THE BINARY SEARCH IS PROPORTIONAL TO ALOG(N).
C                        THE TIME FOR FUNCTION AND DERIVATIVE EVALUATION
C                        IS INDEPENDENT OF N.
C***********************************************************************
C
C     SUBROUTINE COEFF2 (NX,X,NY,Y,F,FXX,FYY,FXXYY,IDM,IBD,WK)
C
C
C DIMENSION OF           X(NX),Y(NY),F(IDM,NY),FXX(IDM,NY),FYY(IDM,NY),
C ARGUMENTS              FXXYY(IDM,NY),IBD(4),WK(3*MAX0(NX,NY)+1)
C                        (IDM MUST BE .GE. NX)
C
C PURPOSE                SUBROUTINE COEFF2 COMPUTES THE COEFFICIENTS
C                        FOR TWO-DIMENSIONAL BICUBIC SPLINE
C                        INTERPOLATION WITH THE SAME CHOICE OF
C                        BOUNDARY CONDITIONS AS FOR COEFF1.  TERP2
C                        IS CALLED TO PERFORM INTERPOLATION.
C
C USAGE                  CALL COEFF2 (NX,X,NY,Y,F,FXX,FYY,FXXYY,IDM,IBD,
C                                     WK)
C
C ARGUMENTS
C
C ON INPUT               NX
C                          NUMBER OF GRID POINTS IN THE X-DIRECTION.  NX
C                          MUST BE AT LEAST 4.
C
C                        X
C                          TABLE OF NX VALUES OF THE FIRST INDEPENDENT
C                          VARIABLE ARRANGED IN ASCENDING ORDER.
C                          DIMENSION OF X IN THE CALLING PROGRAM MUST BE
C                          AT LEAST NX.
C
C                        NY
C                          NUMBER OF GRID POINTS IN THE Y-DIRECTION.  NY
C                          MUST BE AT LEAST 4.
C
C                        Y
C                          TABLE OF NY VALUES OF THE SECOND INDEPENDENT
C                          VARIABLE ARRANGED IN ASCENDING ORDER.
C                          DIMENSION OF Y IN THE CALLING PROGRAM MUST BE
C                          AT LEAST NY.
C
C                        F
C                          TWO DIMENSIONAL ARRAY OF FUNCTION VALUES AT
C                          THE GRID POINTS DEFINED BY THE ARRAYS X AND
C                          Y.  DIMENSION OF F IN THE CALLING PROGRAM IS
C                          (IDM, NYY) WHERE
C                              IDM .GE. NX
C                              NYY .GE. NY
C
C                        IDM
C                          FIRST DIMENSION IN THE CALLING PROGRAM OF
C                          ARRAYS F, FXX, FYY, FXXYY.  IDM MUST BE AT
C                          LEAST NX.
C
C                        IBD
C                          FOUR ELEMENT INTEGER ARRAY DEFINING BOUNDARY
C                          CONDITIONS ACCORDING TO THE FOLLOWING CODE.
C                          FOR IBD(1)
C                          = 1  THE SECOND DERIVATIVE OF F WITH RESPECT
C                               TO X IS GIVEN AT (X(1),Y(J)) FOR
C                               J = 1,NY,1.  VALUES OF THIS SECOND
C                               DERIVATIVE MUST BE PLACED IN FXX(1,J)
C                               FOR J = 1,NY,1, BEFORE CALLING COEFF2.
C                          = 2  THE FIRST DERIVATIVE OF F WITH RESPECT
C                               TO X IS GIVEN AT (X(1),Y(J)) FOR
C                               J = 1,NY,1.  VALUES OF THE DERIVATIVE
C                               MUST BE PLACED IN FXX(1,J) FOR
C                               J = 1,NY,1 BEFORE CALLING COEFF2.
C                          = 3  PERIODIC BOUNDARY CONDITION IN THE
C                               X-DIRECTION.  (X(1),Y(J)) AND
C                               AND (X(NX),Y(J)) ARE EQUIVALENT POINTS
C                               FOR J = 1,NY,1.  F(1,J) AND F(NX,J) ARE
C                               EQUAL.
C                          = 4  THE FIRST DERIVATIVE OF F WITH RESPECT
C                               TO X AT (X(1),Y(J)) IS COMPUTED BY
C                               FITTING A CUBIC TO F(1,J) THROUGH F(4,J)
C                               FOR J = 1,NY,1.
C
C                          SIMILARLY, IBD(2) DEFINES THE BOUNDARY
C                          CONDITION AT (X(NX),Y(J)) FOR J = 1,NY,1.
C                          WHEN IBD(2) = 1 (OR 2) THE VALUES OF THE
C                          SECOND (OR FIRST) DERIVATIVE OF F WITH
C                          RESPECT TO X ARE PLACED IN FXX(NX,J) FOR
C                          J = 1,NY,1.
C                            NOTE THAT IF IBD(1) = 3, CONSISTENCY
C                            REQUIRES THAT IBD(2) = 3 ALSO.
C                          FOR IBD(3)
C                          = 1  THE SECOND DERIVATIVE OF F WITH RESPECT
C                               TO Y IS GIVEN AT (X(I),Y(1)).  PLACE
C                               VALUES OF THE DERIVATIVE IN FYY(I,1) FOR
C                               I = 1,NX,1 BEFORE CALLING COEFF2.
C                          = 2  THE FIRST DERIVATIVE OF F WITH RESPECT
C                               TO Y IS GIVEN AT (X(I),Y(1)).  VALUES OF
C                               THIS DERIVATIVE MUST BE PLACED IN
C                               FYY(I,1) FOR I = 1,NX,1 BEFORE CALLING
C                               COEFF2.
C                          = 3  PERIODIC BOUNDARY CONDITION IN THE
C                               Y-DIRECTION.  (X(I),Y(1)) AND
C                               (X(I),Y(NY)) ARE EQUIVALENT POINTS.
C                               F(I,1) AND F(I,NY) ARE EQUAL.
C                          = 4  THE FIRST DERIVATIVE OF F WITH RESPECT
C                               TO Y AT (X(I),Y(1)) IS COMPUTED BY
C                               FITTING A CUBIC TO F(I,1) THROUGH F(I,4)
C                               FOR I = 1,NX,1.
C
C                          SIMILARY, IBD(4) DEFINES THE BOUNDARY
C                          CONDITION AT (X(I),Y(NY)) FOR I = 1,NX,1 AND
C                          GIVEN DERIVATIVE VALUES ARE PLACED IN
C                          FYY(I,NY).
C                            NOTE THAT CONSISTENCY DEMANDS THAT IF
C                            IBD(3) = 3, THEN IBD(4) = 3 ALSO.
C
C                        WK
C                          WORK AREA OF DIMENSION AT LEAST
C                          (3*MAX0(NX,NY)+1)
C
C ON OUTPUT              FXX
C                          ARRAY OF SECOND DERIVATIVES OF F WITH RESPECT
C                          TO X COMPUTED BY COEFF2.  FXX(I,J) IS
C                          DERIVATIVE AT (X(I),Y(J)).  AS FOR F,
C                          DIMENSION OF FXX IN THE CALLING PROGRAM IS
C                          (IDM,NYY).
C
C                        FYY
C                          ARRAY OF SECOND DERIVATIVES OF F WITH RESPECT
C                          TO Y COMPUTED BY COEFF2.  DIMENSION OF FYY IN
C                          THE CALLING PROGRAM IS (IDM,NYY).
C
C                        FXXYY
C                          ARRAY OF FOURTH DERIVATIVES
C                          (D/DX)**2*(D/DY)**2*F, COMPUTED BY COEFF2.
C                          DIMENSION OF FXXYY IN THE CALLING PROGRAM IS
C                          (IDM,NYY).
C
C                        THE ARRAYS X, Y, F, FXX, FYY, FXXYY ARE USED AS
C                        INPUT FOR THE ROUTINE TERP2 WHICH PERFORMS
C                        INTERPOLATION AT REQUIRED VALUES OF THE TWO
C                        INDEPENDENT VARIABLES.
C
C TIMING                 THE TIMING IS PROPORTIONAL TO NX*NY.
C***********************************************************************
C
C     FUNCTION TERP2 (XB,YB,NX,X,NY,Y,F,FXX,FYY,FXXYY,IDM,IXD,IYD)
C
C
C DIMENSION OF           X(NX),Y(NY),F(IDM,NY),FXX(IDM,NY),FYY(IDM,NY),
C ARGUMENTS              FXXYY(IDM,NY))
C                        (IDM MUST BE .GE. NX)
C
C PURPOSE                USING THE COEFFICIENTS PRODUCED BY COEFF2,
C                        THIS ROUTINE EVALUATES THE FUNCTION ON A
C                        SELECTED DERIVATIVE OF ANY POINT WHERE
C                        TWO-DIMENSIONAL INTERPOLATION IS REQUIRED.
C
C USAGE                  R = TERP2 (XB,YB,NX,X,NY,Y,F,FXX,FYY,FXXYY,IDM,
C                                   IXD,IYD)
C
C ARGUMENTS
C
C ON INPUT               XB, YB
C                          VALUES OF THE INDEPENDENT VARIABLES, X AND Y,
C                          AT WHICH INTERPOLATION IS REQUIRED.
C
C                        NX
C                          NUMBER OF GRID POINTS IN THE X-DIRECTION.  NX
C                          MUST BE AT LEAST 4.
C
C                        X
C                          TABLE OF NX VALUES OF THE INDEPENDENT
C                          VARIABLE, X, ARRANGED IN ASCENDING ORDER.
C                          DIMENSION OF X IN THE CALLING PROGRAM MUST BE
C                          AT LEAST NX.
C
C                        NY
C                          NUMBER OF GRID POINTS IN THE Y-DIRECTION.  NY
C                          MUST BE AT LEAST 4.
C
C                        Y
C                          TABLE OF NY VALUES OF THE INDEPENDENT
C                          VARIABLE, Y, ARRANGED IN ASCENDING ORDER.
C                          DIMENSION OF Y IN THE CALLING PROGRAM MUST BE
C                          AT LEAST NY.
C
C                        F
C                          TWO-DIMENSIONAL ARRAY OF FUNCTION VALUES AT
C                          GRID POINTS DEFINED BY THE ARRAYS X AND Y.
C                          DIMENSION OF F IN THE CALLING PROGRAM IS
C                          (IDM,NYY), WHERE
C                              IDM .GE. NX
C                              NYY .GE. NY
C
C                        FXX
C                          ARRAY OF SECOND DERIVATIVES OF F WITH RESPECT
C                          TO X COMPUTED BY COEFF2.  DIMENSION OF FXX IN
C                          THE CALLING PROGRAM IS (IDM,NYY).  SEE UNDER
C                          F ABOVE.
C
C                        FYY
C                          ARRAY OF SECOND DERIVATIVES OF F WITH RESPECT
C                          TO Y COMPUTED BY COEFF2.  DIMENSION OF FYY IN
C                          THE CALLING PROGRAM IS (IDM,NYY).
C
C                        FXXYY
C                          ARRAY OF FOURTH DERIVATIVES,
C                          (D/DX)**2*(D/DY)**2*F, COMPUTED BY COEFF2.
C                          DIMENSION OF FXXYY IN THE CALLING PROGRAM IS
C                          (IDM,NYY).
C
C                        IDM
C                          FIRST DIMENSION IN THE CALLING PROGRAM OF
C                          ARRAYS F, FXX, FYY AND FXXYY,
C                              IDM .GE. NX
C
C                        IXD, IYD
C                          DEFINE DERIVATIVE TO BE RETURNED BY THE
C                          FUNCTION TERP2.  IXD, IYD MAY EACH TAKE THE
C                          THE VALUES 0, 1, 2.  THE DERIVATIVE RETURNED
C                          IS (D/DX)**IXD*(D/DY)**IYD*F.
C                            NOTE THAT IF IXD = IYD = 0, THE FUNCTION
C                            VALUE ITSELF IS RETURNED.
C
C TIMING                 THIS PROCEDURE IS FAST.  THE MAXIMUM
C                        TIME FOR THE BINARY SEARCH IS PROPORTIONAL TO
C                        ALOG(NX*NY).  THE TIME FOR FUNCTION EVALUATION
C                        IS INDEPENDENT OF N.
C***********************************************************************
      SUBROUTINE COEFF1 (N,X,F,W,IOP,INT,WK)
      DIMENSION       X(4)       ,F(4)       ,W(4)       ,IOP(2)     ,
     1                WK(N,4)
      SAVE
C
C ARITHMETIC STATENENT FUNCTION USED TO LOCATE ENTRIES IN F AND W ARRAYS
C
      II(INDEX)=(INDEX-1)*INT+1
C
C
C
C
C
C
C
C START TO SET UP TRIDIAGONAL SYSTEM
C
      J0 = 1
      DO 101 I=2,N
         JM = J0
         J0 = J0+INT
         WK(I,1) = X(I)-X(I-1)
         WK(I,2) = (F(J0)-F(JM))/WK(I,1)
         WK(I,3) = WK(I,1)/6.
         WK(I,1) = WK(I,1)/3.
  101 CONTINUE
      NN = N
      MK = IOP(1)
      ML = IOP(2)
C
C APPLY BOUNDARY CONDITIONS AT BOUNDARY 1
C
      GO TO (102,103,104,105),MK
C
C SECOND DERIVATIVE GIVEN AT BOUNDARY 1
C
  102 CONTINUE
      WK(2,2) = WK(3,2)-WK(2,2)-WK(2,3)*W(1)
      WK(2,3) = 0.
      WK(2,1) = WK(2,1)+WK(3,1)
      I1 = 2
      NN = NN-1
      GO TO 106
C
C FIRST DERIVATIVE GIVEN AT BOUNDARY 1
C
  103 CONTINUE
      WK(1,2) = WK(2,2)-W(1)
      WK(2,2) = WK(3,2)-WK(2,2)
      WK(1,3) = 0.
      WK(1,1) = WK(2,1)
      WK(2,1) = WK(2,1)+WK(3,1)
      I1 = 1
      GO TO 106
C
C PERIODIC BOUNDARY CONDITION
C
  104 CONTINUE
      Y2 = WK(2,2)
      B2 = WK(2,1)
      WK(2,2) = WK(3,2)-WK(2,2)
      WK(2,1) = WK(3,1)+WK(2,1)
      I1 = 2
      NN = NN-1
      GO TO 106
C
C FIRST DERIVATIVE AT BOUNDARY 1 FROM 4 POINT INTERPOLATION.
C
  105 CONTINUE
      A12 = X(1)-X(2)
      A13 = X(1)-X(3)
      A14 = X(1)-X(4)
      A23 = X(2)-X(3)
      A24 = X(2)-X(4)
      A34 = X(3)-X(4)
      J1 = 1
      J2 = J1+INT
      J3 = J2+INT
      J4 = J3+INT
      W(1)    = (1./A12+1./A13+1./A14)*F(J1)-
     1          A13*A14/(A12*A23*A24)*F(J2)+A12*A14/(A13*A23*A34)*F(J3)-
     2          A12*A13/(A14*A24*A34)*F(J4)
      GO TO 103
C COMPUTE TRIDIAGONAL ARRAYS
  106 CONTINUE
      I2 = N-2
      DO 107 I=3,I2
         WK(I,2) = WK(I+1,2)-WK(I,2)
         WK(I,1) = WK(I+1,1)+WK(I,1)
  107 CONTINUE
C
C APPLY BOUNDARY CONDITIONS AT BOUNDARY 2.
C
      IN = II(N)
      GO TO (108,109,110,111),ML
C
C SECOND DERIVATIVE GIVEN AT BOUNDARY 2.
C
  108 CONTINUE
      WK(N-1,2) = WK(N,2)-WK(N-1,2)-WK(N,3)*W(IN)
      WK(N,3) = 0.
      WK(N-1,1) = WK(N-1,1)+WK(N,1)
      NN = NN-1
      GO TO 112
C
C FIRST DERIVATIVE GIVEN AT BOUNDARY 2.
C
  109 CONTINUE
      WK(N-1,2) = WK(N,2)-WK(N-1,2)
      WK(N,2) = -WK(N,2)+W(IN)
      WK(N-1,1) = WK(N-1,1)+WK(N,1)
      WK(1,4) = 0.
      GO TO 112
C
C PERIODIC BOUNDARY CONDITION
C
  110 CONTINUE
      WK(N-1,2) = WK(N,2)-WK(N-1,2)
      WK(N,2) = Y2-WK(N,2)
      WK(N-1,1) = WK(N-1,1)+WK(N,1)
      WK(N,1) = WK(N,1)+B2
      WK(1,4) = WK(2,3)
      GO TO 112
C
C FIRST DERIVATIVE AT BOUNDARY 2 FROM 4 POINT INTERPOLATION.
C
  111 CONTINUE
      A12 = X(N)-X(N-1)
      A13 = X(N)-X(N-2)
      A14 = X(N)-X(N-3)
      A23 = X(N-1)-X(N-2)
      A24 = X(N-1)-X(N-3)
      A34 = X(N-2)-X(N-3)
      J1 = IN
      J2 = J1-INT
      J3 = J2-INT
      J4 = J3-INT
      W(IN)   = (1./A12+1./A13+1./A14)*F(J1)-
     1          A13*A14/(A12*A23*A24)*F(J2)+A12*A14/(A13*A23*A34)*F(J3)-
     2          A12*A13/(A14*A24*A34)*F(J4)
      GO TO 109
  112 CONTINUE
      IW1 = II(I1)
      CALL TRIP (NN,WK(I1,3),WK(I1,1),WK(I1+1,3),WK(I1,2),W(IW1),INT)
      GO TO (114,114,113,114),MK
  113 CONTINUE
      W(1) = W(IN)
  114 CONTINUE
      RETURN
      END

      SUBROUTINE DSTEV( JOBZ, N, D, E, Z, LDZ, WORK, INFO )
*
*  -- LAPACK driver routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER          JOBZ
      INTEGER            INFO, LDZ, N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   D( * ), E( * ), WORK( * ), Z( LDZ, * )
*     ..
*
*  Purpose
*  =======
*
*  DSTEV computes all eigenvalues and, optionally, eigenvectors of a
*  real symmetric tridiagonal matrix A.
*
*  Arguments
*  =========
*
*  JOBZ    (input) CHARACTER*1
*          = 'N':  Compute eigenvalues only;
*          = 'V':  Compute eigenvalues and eigenvectors.
*
*  N       (input) INTEGER
*          The order of the matrix.  N >= 0.
*
*  D       (input/output) DOUBLE PRECISION array, dimension (N)
*          On entry, the n diagonal elements of the tridiagonal matrix
*          A.
*          On exit, if INFO = 0, the eigenvalues in ascending order.
*
*  E       (input/output) DOUBLE PRECISION array, dimension (N)
*          On entry, the (n-1) subdiagonal elements of the tridiagonal
*          matrix A, stored in elements 1 to N-1 of E; E(N) need not
*          be set, but is used by the routine.
*          On exit, the contents of E are destroyed.
*
*  Z       (output) DOUBLE PRECISION array, dimension (LDZ, N)
*          If JOBZ = 'V', then if INFO = 0, Z contains the orthonormal
*          eigenvectors of the matrix A, with the i-th column of Z
*          holding the eigenvector associated with D(i).
*          If JOBZ = 'N', then Z is not referenced.
*
*  LDZ     (input) INTEGER
*          The leading dimension of the array Z.  LDZ >= 1, and if
*          JOBZ = 'V', LDZ >= max(1,N).
*
*  WORK    (workspace) DOUBLE PRECISION array, dimension (max(1,2*N-2))
*          If JOBZ = 'N', WORK is not referenced.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*          > 0:  if INFO = i, the algorithm failed to converge; i
*                off-diagonal elements of E did not converge to zero.
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO, ONE
      PARAMETER          ( ZERO = 0.0D0, ONE = 1.0D0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            WANTZ
      INTEGER            IMAX, ISCALE
      DOUBLE PRECISION   BIGNUM, EPS, RMAX, RMIN, SAFMIN, SIGMA, SMLNUM,
     $                   TNRM
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      DOUBLE PRECISION   DLAMCH, DLANST
      EXTERNAL           LSAME, DLAMCH, DLANST
*     ..
*     .. External Subroutines ..
      EXTERNAL           DSCAL, DSTEQR, DSTERF, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          SQRT
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      WANTZ = LSAME( JOBZ, 'V' )
*
      INFO = 0
      IF( .NOT.( WANTZ .OR. LSAME( JOBZ, 'N' ) ) ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( LDZ.LT.1 .OR. ( WANTZ .AND. LDZ.LT.N ) ) THEN
         INFO = -6
      END IF
*
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DSTEV ', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
*
      IF( N.EQ.1 ) THEN
         IF( WANTZ )
     $      Z( 1, 1 ) = ONE
         RETURN
      END IF
*
*     Get machine constants.
*
      SAFMIN = DLAMCH( 'Safe minimum' )
      EPS = DLAMCH( 'Precision' )
      SMLNUM = SAFMIN / EPS
      BIGNUM = ONE / SMLNUM
      RMIN = SQRT( SMLNUM )
      RMAX = SQRT( BIGNUM )
*
*     Scale matrix to allowable range, if necessary.
*
      ISCALE = 0
      TNRM = DLANST( 'M', N, D, E )
      IF( TNRM.GT.ZERO .AND. TNRM.LT.RMIN ) THEN
         ISCALE = 1
         SIGMA = RMIN / TNRM
      ELSE IF( TNRM.GT.RMAX ) THEN
         ISCALE = 1
         SIGMA = RMAX / TNRM
      END IF
      IF( ISCALE.EQ.1 ) THEN
         CALL DSCAL( N, SIGMA, D, 1 )
         CALL DSCAL( N-1, SIGMA, E( 1 ), 1 )
      END IF
*
*     For eigenvalues only, call DSTERF.  For eigenvalues and
*     eigenvectors, call DSTEQR.
*
      IF( .NOT.WANTZ ) THEN
         CALL DSTERF( N, D, E, INFO )
      ELSE
         CALL DSTEQR( 'I', N, D, E, Z, LDZ, WORK, INFO )
      END IF
*
*     If matrix was scaled, then rescale eigenvalues appropriately.
*
      IF( ISCALE.EQ.1 ) THEN
         IF( INFO.EQ.0 ) THEN
            IMAX = N
         ELSE
            IMAX = INFO - 1
         END IF
         CALL DSCAL( IMAX, ONE / SIGMA, D, 1 )
      END IF
*
      RETURN
*
*     End of DSTEV
*
      END

C
C $Id: psym3.f,v 1.6 2008-07-27 00:17:34 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE PSYM3 (U,V,W,ICHAR,SIZE,IDIR,ITOP,IUP)
      IF (IUP .EQ. 2) CALL VECT3 (U,V,W)
      CALL PWRZ (U,V,W,ICHAR,1,SIZE,IDIR,ITOP,0)
      RETURN
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C   FFTPACK 5.0
C   Copyright (C) 1995-2004, Scientific Computing Division,
C   University Corporation for Atmospheric Research
C   Licensed under the GNU General Public License (GPL)
C
C   Authors:  Paul N. Swarztrauber and Richard A. Valent
C
C   $Id: mradf2.f,v 1.2 2006-11-21 01:10:17 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      SUBROUTINE DMRADF2(M,IDO,L1,CC,IM1,IN1,CH,IM2,IN2,WA1)
      DOUBLE PRECISION CH(IN2,IDO,2,L1),CC(IN1,IDO,L1,2),WA1(IDO)
C
      M1D = (M-1)*IM1 + 1
      M2S = 1 - IM2
      DO 101 K = 1,L1
          M2 = M2S
          DO 1001 M1 = 1,M1D,IM1
              M2 = M2 + IM2
              CH(M2,1,1,K) = CC(M1,1,K,1) + CC(M1,1,K,2)
              CH(M2,IDO,2,K) = CC(M1,1,K,1) - CC(M1,1,K,2)
 1001     CONTINUE
  101 CONTINUE
      IF (IDO-2) 107,105,102
  102 IDP2 = IDO + 2
      DO 104 K = 1,L1
          DO 103 I = 3,IDO,2
              IC = IDP2 - I
              M2 = M2S
              DO 1003 M1 = 1,M1D,IM1
                  M2 = M2 + IM2
                  CH(M2,I,1,K) = CC(M1,I,K,1) +
     +                           (WA1(I-2)*CC(M1,I,K,2)-WA1(I-1)*
     +                           CC(M1,I-1,K,2))
                  CH(M2,IC,2,K) = (WA1(I-2)*CC(M1,I,K,2)-
     +                            WA1(I-1)*CC(M1,I-1,K,2)) -
     +                            CC(M1,I,K,1)
                  CH(M2,I-1,1,K) = CC(M1,I-1,K,1) +
     +                             (WA1(I-2)*CC(M1,I-1,K,2)+
     +                             WA1(I-1)*CC(M1,I,K,2))
                  CH(M2,IC-1,2,K) = CC(M1,I-1,K,1) -
     +                              (WA1(I-2)*CC(M1,I-1,K,2)+
     +                              WA1(I-1)*CC(M1,I,K,2))
 1003         CONTINUE
  103     CONTINUE
  104 CONTINUE
      IF (MOD(IDO,2).EQ.1) RETURN
  105 DO 106 K = 1,L1
          M2 = M2S
          DO 1006 M1 = 1,M1D,IM1
              M2 = M2 + IM2
              CH(M2,1,2,K) = -CC(M1,IDO,K,2)
              CH(M2,IDO,1,K) = CC(M1,IDO,K,1)
 1006     CONTINUE
  106 CONTINUE
  107 RETURN
      END

      PROGRAM TCONPA
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C OPEN GKS, OPEN WORKSTATION OF TYPE 1, ACTIVATE WORKSTATION
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C INVOKE DEMO DRIVER
C
      CALL CONPA(IERR,IWKID)
C
C DEACTIVATE AND CLOSE WORKSTATION, CLOSE GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END
C
      SUBROUTINE CONPA (IERR,IWKID)
C
C PURPOSE               To provide a simple demonstration of the use of
C                       CONPACK to contour regularly-spaced rectangular
C                       data.
C
C USAGE                 CALL CONPA (IERR)
C
C ARGUMENTS (OUTPUT)    IERR
C
C                         An integer variable
C                         = 0, if the test was successful,
C                         = 1, otherwise
C
C I/O                   If the test is successful, the message "CONPACK
C                       TEST EXECUTED--SEE PLOTS TO CERTIFY" is printed
C                       on unit 6.  In addition, three frames are drawn
C                       on the graphics device.  In order to determine
C                       if the test was successful, it is necessary to
C                       examine these frames.
C
C PRECISION             Single.
C
C LANGUAGE              FORTRAN 77.
C
C REQUIRED ROUTINES     The AREAS, CONPACK, LABELBAR, SOFTFILL, and
C                       SPPS packages.
C
C REQUIRED GKS LEVEL    0A.
C
C ALGORITHM             The function
C
C                         Z(X,Y) = X + Y + 1./((X-.1)**2+Y**2+.09)
C                                         -1./((X+.1)**2+Y**2+.09)
C
C                       for X = -1. to 1. in increments of .1, and Y =
C                       -1.2 to 1.2 in increments of .1, is computed.
C                       Then, entries CPEZCT and CPCNRC are called to
C                       generate contour plots of Z.
C
C ZDAT contains the values to be plotted.
C
        DIMENSION  ZDAT(21,25)
C
C Declare an array to hold the GKS "aspect source flags".
C
        DIMENSION IASF(13)
C
C Define real and integer work spaces and an area-map array.
C
        DIMENSION RWRK(1000),IWRK(1000),IAMA(20000)
C
C Define arrays for use by ARSCAM.
C
        DIMENSION XCRA(1000),YCRA(1000),IAIA(10),IGIA(10)
C
C Declare arrays to hold the list of indices and the list of labels
C required by the label-bar routine.
C
        DIMENSION LIND(10)
        CHARACTER*2 LLBS(9)
C
C Declare the routine which will color the areas.
C
        EXTERNAL CPCOLR
C
C Initialize the values in the aspect-source-flag array.
C
        DATA IASF / 13*1 /
C
C Define the list of indices and the list of labels required by the
C label-bar routine.
C
        DATA LIND / 6,7,8,9,10,11,12,13,14,15 /
C
        DATA LLBS / '-4','-3','-2','-1',' 0',' 1',' 2',' 3',' 4' /
C
C Initialize the error parameter.
C
        IERR = 0
C
C Fill the 2D array to be plotted.
C
        DO  102 I=1,21
          X=.1*REAL(I-11)
          DO 101 J=1,25
            Y = .1*REAL(J-13)
            ZDAT(I,J)=X+Y+1./((X-.10)**2+Y**2+.09)
     +                   -1./((X+.10)**2+Y**2+.09)
  101     CONTINUE
  102   CONTINUE
C
C Frame 1 -- CPEZCT.
C
C The routine CPEZCT requires only the array name and dimensions.
C
      CALL SET (0.,1.,0.,1.,0.,1.,0.,1.,1)
      CALL WTSTR (.5,.9765,
     +            'DEMONSTRATION PLOT FOR CONPACK ROUTINE CPEZCT',2,0,0)
C
      CALL CPEZCT (ZDAT,21,25)
C
C Frame 2 -- CPCNRC.
C
C The routine CPCNRC is called just like the old routine CONREC.
C
C In this example, the lowest contour level (-4.5), the highest contour
C level (4.5), and the increment between contour levels (0.3) are set.
C Line labels are positioned using the penalty scheme and the smoother
C is turned on.
C
      CALL SET (0.,1.,0.,1.,0.,1.,0.,1.,1)
      CALL WTSTR (.5,.9765,
     +            'DEMONSTRATION PLOT FOR CONPACK ROUTINE CPCNRC',2,0,0)
C
      CALL CPSETI ('LLP - LINE LABEL POSITIONING',3)
      CALL CPSETR ('T2D - TENSION ON 2D SPLINES',3.6)
      CALL CPCNRC (ZDAT,21,21,25,-4.5,4.5,.3,0,0,0)
      CALL FRAME
C
C Frame 3 - A solid-filled contour plot.
C
C Set all the GKS aspect source flags to "individual".
C
        CALL GSASF (IASF)
C
C Force solid fill.
C
        CALL GSFAIS (1)
C
C Turn off the clipping indicator.
C
        CALL GSCLIP (0)
C
C Define a bunch of color indices.
C
        CALL CPCLRS(IWKID)
C
C Put a label at the top of the frame.
C
      CALL SET (0.,1.,0.,1.,0.,1.,0.,1.,1)
      CALL WTSTR (.5,.9765,
     +            'DEMONSTRATION PLOT FOR BASIC CONPACK ROUTINES',2,0,0)
C
C Force the plot into the left side of the frame.
C
        CALL CPSETR ('VPR - VIEWPORT RIGHT',.75)
C
C Force the use of exactly 9 contour levels, specify those levels, and
C define exactly what is to be done at each level.
C
        CALL CPSETI ('CLS - CONTOUR LEVEL SELECTOR',0)
        CALL CPSETI ('NCL - NUMBER OF CONTOUR LEVELS',9)
C
        DO 103 I=1,9
          CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',I)
          CALL CPSETR ('CLV - CONTOUR LEVEL',REAL(I-5))
          CALL CPSETI ('CLU - CONTOUR LEVEL USE',1)
          CALL CPSETI ('AIB - AREA IDENTIFIER BELOW LEVEL',I)
          CALL CPSETI ('AIA - AREA IDENTIFIER ABOVE LEVEL',I+1)
  103   CONTINUE
C
C Initialize the drawing of the contour plot.
C
        CALL CPRECT (ZDAT,21,21,25,RWRK,1000,IWRK,1000)
C
C Initialize the area map and put the contour lines into it.
C
        CALL ARINAM (IAMA,20000)
        CALL CPCLAM (ZDAT,RWRK,IWRK,IAMA)
C
C Color the map.
C
        CALL ARSCAM (IAMA,XCRA,YCRA,1000,IAIA,IGIA,10,CPCOLR)
C
C Put black contour lines over the colored map.
C
        CALL GSPLCI (0)
        CALL CPCLDR (ZDAT,RWRK,IWRK)
        CALL GSPLCI (1)
C
C Draw a color bar for the plot.
C
        CALL LBSETI ('CBL - COLOR OF BOX LINES',2)
        CALL PCSETR ('CS - CONSTANT SPACING FLAG',1.25)
        CALL LBLBAR (1,.80,.95,.05,.95,10,.5,1.,LIND,0,LLBS,9,1)
C
C Advance the frame.
C
        CALL FRAME
C
C Log a successful-completion message and return to the caller.
C
        WRITE (6,1001)
C
        RETURN
C
 1001 FORMAT (' CONPACK TEST EXECUTED--SEE PLOTS TO CERTIFY')
C
      END
      SUBROUTINE CPCLRS(IWKID)
C
C Define a set of RGB color triples for colors 1 through 15.
C
        DIMENSION RGBV(3,15)
C
C Define the RGB color triples needed below.
C
        DATA RGBV / 1.00 , 1.00 , 1.00 ,
     +              0.70 , 0.70 , 0.70 ,
     +              0.75 , 0.50 , 1.00 ,
     +              0.50 , 0.00 , 1.00 ,
     +              0.00 , 0.00 , 1.00 ,
     +              0.00 , 0.50 , 1.00 ,
     +              0.00 , 1.00 , 1.00 ,
     +              0.00 , 1.00 , 0.60 ,
     +              0.00 , 1.00 , 0.00 ,
     +              0.70 , 1.00 , 0.00 ,
     +              1.00 , 1.00 , 0.00 ,
     +              1.00 , 0.75 , 0.00 ,
     +              1.00 , 0.38 , 0.38 ,
     +              1.00 , 0.00 , 0.38 ,
     +              1.00 , 0.00 , 0.00 /
C
C Define 16 different color indices, for indices 0 through 15.  The
C color corresponding to index 0 is black and the color corresponding
C to index 1 is white.
C
        CALL GSCR (IWKID,0,0.,0.,0.)
C
        DO 101 I=1,15
          CALL GSCR (IWKID,I,RGBV(1,I),RGBV(2,I),RGBV(3,I))
  101   CONTINUE
C
C Done.
C
        RETURN
C
      END
      SUBROUTINE CPCOLR (XCRA,YCRA,NCRA,IAIA,IGIA,NAIA)
C
        DIMENSION XCRA(*),YCRA(*),IAIA(*),IGIA(*)
C
C The arrays XCRA and YCRA, for indices 1 to NCRA, contain the X and Y
C coordinates of points defining a polygon.  The area identifiers in
C the array IAIA, each with an associated group identifier in the array
C IGIA, tell us whether the polygon is to be color-filled or not.
C
C
C Assume the polygon will be filled until we find otherwise.
C
        IFLL=1
C
C If any of the area identifiers is negative, don't fill the polygon.
C
        DO 101 I=1,NAIA
          IF (IAIA(I).LT.0) IFLL=0
  101   CONTINUE
C
C Otherwise, fill the polygon in the color implied by its area
C identifier relative to edge group 3 (the contour-line group).
C
        IF (IFLL.NE.0) THEN
          IFLL=0
          DO 102 I=1,NAIA
            IF (IGIA(I).EQ.3) IFLL=IAIA(I)
  102     CONTINUE
          IF (IFLL.GE.1.AND.IFLL.LE.10) THEN
            CALL GSFACI (IFLL+5)
            CALL GFA (NCRA-1,XCRA,YCRA)
          END IF
        END IF
C
C Done.
C
        RETURN
C
      END

      PROGRAM FGKGTX
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
      REAL PLIM1(2), PLIM2(2), PLIM3(2), PLIM4(2)

      DATA PLIM1 /0.,0./
      DATA PLIM2 /0.,0./
      DATA PLIM3 /0.,0./
      DATA PLIM4 /0.,0./
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C INVOKE DEMO DRIVER
C
      CALL GTXEXP('CE',-20.,-50.,0.,'PO','CO',21.3,-90.,-55.,-20.,IWKID)
C
C Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS

      STOP
      END

      SUBROUTINE GTXEXP(PROJ, PLAT, PLON, ROTA, OUTLN,
     1                  JLIM, PLIM1, PLIM2, PLIM3, PLIM4, IWKID)

      CHARACTER*2 PROJ, OUTLN, JLIM
      REAL PLIM1(2), PLIM2(2), PLIM3(2), PLIM4(2)
C
C PURPOSE                To provide a simple demonstration of the
C                        GKS GTX character drawing techniques.
C
C Set up a color table
C
      CALL DFCLRS (IWKID)
C
C Draw Continental, political outlines 
C
      CALL MAPSTC ('OU - OUTLINE DATASET SELECTOR',OUTLN)
C
C Set up projection
C
      CALL MAPROJ (PROJ,PLAT,PLON,ROTA)
C
C If it's a satellite projection, choose a satellite distance
C
      IF (PROJ.EQ.'SV') CALL MAPSTR ('SA - SATELLITE DISTANCE',5.)
C
C Set limits of map
C
      CALL MAPSET (JLIM,PLIM1,PLIM2,PLIM3,PLIM4)
C
C Turn off Grid lines
C
      CALL MAPSTR ('GR',0.)
C
C Turn off perimeter of map
C
      CALL MAPSTI ('PE', 0)
C
C Turn off map labels
C
      CALL MAPSTI ('LA', 0)
C
C Draw map
C
      CALL MAPDRW
C
C Label Brazil
C
C Set text color
C
      CALL GSTXCI(4)
C
C  Set text size
C
      CALL GSCHH(3.)
C
C Set the font
C
      CALL GSTXFP(-16,2)
C
C  Transform the coordinates
C
      CALL MAPTRA(-10.,-60.,X,Y)
C
C  Draw the text
C
      CALL GTX(X,Y,'Brazil')
C
C Label Argentina
C
C Set text color
C
      CALL GSTXCI(5)
C
C  Set text size
C
      CALL GSCHH(2.)
C
C Set the font
C
      CALL GSTXFP(-14,2)
C
C Transform the coordinates
C
      CALL MAPTRA(-43.,-68.,X,Y)
C
C Set the angle
C
      CALL GSCHUP (-1.,.3)
C
C Draw the text
C
      CALL GTX(X,Y,'Argentina')
C
C Label Uruguay
C
C Set text color
C
      CALL GSTXCI(6)
C
C Set text size
C
      CALL GSCHH(1.0)
C
C Set the font
C
      CALL GSTXFP(-4,2)
C
C Transform the coordinates
C
      CALL MAPTRA(-32.5,-58.,X,Y)
C
C Set the angle
C
      CALL GSCHUP (.7,1.)
C
C Draw the text
C
      CALL GTX(X,Y,'Uruguay')
C
C Label Paraguay
C
C Set text color
C
      CALL GSTXCI(5)
C
C Set text size
C
      CALL GSCHH(1.0)
C
C Set the font
C
      CALL GSTXFP(-4,2)
C
C Transform the coordinates
C
      CALL MAPTRA(-21.,-61.,X,Y)
C
C Set the angle
C
      CALL GSCHUP (1.,1.)
C
C Draw the text
C
      CALL GTX(X,Y,'Paraguay')
C
C Label Bolivia
C
C Set text color
C
      CALL GSTXCI(14)
C
C Set text size
C
      CALL GSCHH(1.6)
C
C Set the font
C
      CALL GSTXFP(-6,2)
C
C Transform the coordinates
C
      CALL MAPTRA(-17.,-68.,X,Y)
C
C Set the angle
C
      CALL GSCHUP (0.,1.)
C
C Draw the text
C
      CALL GTX(X,Y,'Bolivia')
C
C Label Chile
C
C  Set text color
C
      CALL GSTXCI(4)
C
C Set text size
C
      CALL GSCHH(1.5)
C
C Set the font
C
      CALL GSTXFP(-7,2)
C
C Transform the coordinates
C
      CALL MAPTRA(-40.,-72.,X,Y)
C
C Set the angle
C
      CALL GSCHUP (-1.,0.03)
C
C Expand the spacing between characters
C
      CALL GSCHSP(2.)
C
C Draw the text
C
      CALL GTX(X,Y,'Chile')
C
C Label Peru
C
C Set text color
C
      CALL GSTXCI(14)
C
C Set text size
C
      CALL GSCHH(3.)
C
C Set the font
C
       CALL GSTXFP(-15,2)
C
C Transform the coordinates
C
       CALL MAPTRA(-6.,-79.,X,Y)
C
C Set the angle
C
       CALL GSCHUP (1.,1.)
C
C Reset the spacing between characters
C
       CALL GSCHSP(0.)
C
C  Draw the text
C
       CALL GTX(X,Y,'Peru')
C
C Label Equador
C
C Set text color
C
       CALL GSTXCI(15)
C
C  Set text size
C
       CALL GSCHH(1.5)
C
C Set the font
C
       CALL GSTXFP(1,2)
C
C Transform the coordinates
C
       CALL MAPTRA(0.,-86.,X,Y)
C
C Set the angle
C
       CALL GSCHUP (0.,1.)
C
C Draw the text
C
       CALL GTX(X,Y,'Equador')
C
C Label Colombia
C
C Set text color
C
       CALL GSTXCI(1)
C
C Set text size
C
       CALL GSCHH(1.3)
C
C      Set the font
C
       CALL GSTXFP(-10,2)
C
C Transform the coordinates
C
       CALL MAPTRA(7.,-77.,X,Y)
C
C Set the angle
C
       CALL GSCHUP (.8,1.)
C
C Draw the text
C
       CALL GTX(X,Y,'Colombia')

C
C Label Venezuela
C
C Set text color
       CALL GSTXCI(3)
C
C Set text size
C
           CALL GSCHH(1.5)
C
C      Set the font
C
       CALL GSTXFP(-6,2)
C
C Transform the coordinates
C
       CALL MAPTRA(7.,-70.,X,Y)
C
C Set the angle
C
       CALL GSCHUP (0.,1.)
C
C Draw the text
C
       CALL GTX(X,Y,'Venezuela')

C
C Label Guyana
C
C Set text color
C
       CALL GSTXCI(1)
C
C Set text size
C
           CALL GSCHH(1.0)
C
C      Set the font
C
       CALL GSTXFP(-4,2)
C
C Transform the coordinates
C
       CALL MAPTRA(7.,-59.5,X,Y)
C
C Set the angle
C
       CALL GSCHUP (1.,0.2)
C
C Draw the text
C
       CALL GTX(X,Y,'Guyana')

C
C Label Fr. Guyana
C
C Set text color
       CALL GSTXCI(1)
C
C Set text size
C
           CALL GSCHH(1.2)
C
C      Set the font
C
       CALL GSTXFP(-4,2)
C
C Transform the coordinates
C
       CALL MAPTRA(2.,-53.5,X,Y)
C
C Set the angle
C
       CALL GSCHUP (-1.,.5)
C
C Draw the text
C
       CALL GTX(X,Y,'Fr. Guyana')
C
C Label Suriname
C
C Set text color
C
       CALL GSTXCI(14)
C
C Set text size
C
           CALL GSCHH(1.2)
C
C      Set the font
C
       CALL GSTXFP(-4,2)
C
C Transform the coordinates
C
       CALL MAPTRA(2.5,-56.,X,Y)
C
C Set the angle
C
       CALL GSCHUP (-1.,.2)
C
C Draw the text
C
       CALL GTX(X,Y,'Suriname')

C
C Label the plot
C
C Set text color
C
       CALL GSTXCI(1)
C
C Set text size
C
           CALL GSCHH(4.)
C
C      Set the font
C
       CALL GSTXFP(-14,2)
C
C Transform the coordinates
C
       CALL MAPTRA(15.,-80.,X,Y)
C
C Set the angle
C
       CALL GSCHUP (0.,1.)
C
C Draw the text
C
           CALL GTX (X,Y,'South America')
C
C Draw a border around plot
C
C Reset the plot window
C
      CALL SET(0.,1.,0.,1.,0.,1.,0.,1.,1)
C
C Set the line color to black
C
      CALL GSPLCI (1)
C
C  Create a background perimeter
C
      CALL FRSTPT( 0.0, 0.0)
      CALL VECTOR( 1.0, 0.0)
      CALL VECTOR( 1.0, 1.0)
      CALL VECTOR( 0.0, 1.0)
      CALL VECTOR( 0.0, 0.0)

C
C Advance the frame.
C
      CALL FRAME
C
C Done.
C
      RETURN
      END

      SUBROUTINE DFCLRS (IWKID)
C
C Define a set of RGB color triples for colors 1 through 15.
C
        DIMENSION RGBV(3,15)
C
C Define the RGB color triples needed below.
C
        DATA RGBV / 0.00 , 0.00 , 0.00 ,
     +              0.70 , 0.70 , 0.70 ,
     +              0.75 , 0.50 , 1.00 ,
     +              0.50 , 0.00 , 1.00 ,
     +              0.00 , 0.00 , 1.00 ,
     +              0.00 , 0.50 , 1.00 ,
     +              0.00 , 1.00 , 1.00 ,
     +              0.00 , 1.00 , 0.60 ,
     +              0.00 , 1.00 , 0.00 ,
     +              0.70 , 1.00 , 0.00 ,
     +              1.00 , 1.00 , 0.00 ,
     +              1.00 , 0.75 , 0.00 ,
     +              1.00 , 0.38 , 0.38 ,
     +              1.00 , 0.00 , 0.38 ,
     +              1.00 , 0.00 , 0.00 /
C
C Define 16 different color indices, for indices 0 through 15.  The
C color corresponding to index 0 is black and the color corresponding
C to index 1 is white.
C
        CALL GSCR (IWKID,0,1.,1.,1.)
C
        DO 101 I=1,15
          CALL GSCR (IWKID,I,RGBV(1,I),RGBV(2,I),RGBV(3,I))
  101   CONTINUE
C
C Done.
C
        RETURN
C
      END

C
C $Id: moproj.f,v 1.4 2008-09-18 00:42:18 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MOPROJ (DLAT,DLON,UVAL,VVAL)
C
        DOUBLE PRECISION DLAT,DLON,UVAL,VVAL
C
C The subroutine MOPROJ implements the true Mollweide projection,
C using formulas identical to those given on various Web sites (for
C example, Wikipedia).
C
C DLAT and DLON are input values of latitude and longitude, in radians.
C UVAL and VVAL are output values of U and V, in the projection plane.
C
C The common block MAPCM0 contains mathematical constants.
C
        COMMON /MAPCM0/  COS1,DTOR,DTRH,OOPI,PI,PIOF,PIOT,RTDD,RTOD,
     +                   SROT,SIN1,TOPI,TSRT
        DOUBLE PRECISION COS1,DTOR,DTRH,OOPI,PI,PIOF,PIOT,RTDD,RTOD,
     +                   SROT,SIN1,TOPI,TSRT
        SAVE   /MAPCM0/
C
C Local variables.
C
        DOUBLE PRECISION THTA,THTP
C
C Near the poles, the following code doesn't work properly, so we have
C to deal with that case separately:
C
        IF (ABS(DLAT)-PIOT.GT.-1.D-12) THEN
          UVAL=0.D0
          VVAL=SIGN(SROT,DLAT)
          RETURN
        END IF
C
C We have to do a Newton-Raphson iteration to get a value for "theta".
C Set up the iteration loop.  THTP is an initial guess (per MathWorld).
C
        THTP=2.D0*ASIN(MAX(-1.D0,MIN(+1.D0,DLAT/PIOT)))
C
C NITR keeps track of the number of iterations performed.
C
        NITR=1
C
C Iteration loop.  First, compute terms that occur frequently.
C
  101   THTA=THTP-(THTP+SIN(THTP)-PI*SIN(DLAT))/(1.D0+COS(THTP))
C
C If the improved value is not sufficiently different from the previous
C value and fewer than the maximum number of iterations have been done,
C go back for another one.  Otherwise, we have our value of THTA.
C
        IF (ABS(THTA-THTP).GT.1.D-12) THEN
          IF (NITR.LT.20) THEN
            THTP=THTA
            NITR=NITR+1
            GO TO 101
          END IF
        END IF
C
C Halve the value of "theta".
C
        THTA=.5D0*THTA
C
C Compute the values of UVAL and VVAL.
C
        UVAL=SROT*COS(THTA)*DLON/PIOT
        VVAL=SROT*SIN(THTA)
C
        RETURN
C
      END

C
C $Id: snhcshdp.f,v 1.3 2008-07-27 03:10:12 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
C NOTE: If you make any changes to this software, please remember to
C make the same changes to the corresponding single precision routine.
C
      SUBROUTINE SNHCSHDP(SINHM,COSHM,X,ISW)
      DOUBLE PRECISION SP14
      DOUBLE PRECISION SP13
      DOUBLE PRECISION SP12
      DOUBLE PRECISION SP11
      DOUBLE PRECISION SQ12
      DOUBLE PRECISION SQ11
      DOUBLE PRECISION SQ10
      DOUBLE PRECISION SP25
      DOUBLE PRECISION SP24
      DOUBLE PRECISION SP23
      DOUBLE PRECISION SP22
      DOUBLE PRECISION SP21
      DOUBLE PRECISION SQ22
      DOUBLE PRECISION SQ21
      DOUBLE PRECISION SQ20
      DOUBLE PRECISION SP35
      DOUBLE PRECISION SP34
      DOUBLE PRECISION SP33
      DOUBLE PRECISION SP32
      DOUBLE PRECISION SP31
      DOUBLE PRECISION SQ32
      DOUBLE PRECISION SQ31
      DOUBLE PRECISION SQ30
      DOUBLE PRECISION SP45
      DOUBLE PRECISION SP44
      DOUBLE PRECISION SP43
      DOUBLE PRECISION SP42
      DOUBLE PRECISION SP41
      DOUBLE PRECISION SQ42
      DOUBLE PRECISION SQ41
      DOUBLE PRECISION SQ40
      DOUBLE PRECISION CP5
      DOUBLE PRECISION CP4
      DOUBLE PRECISION CP3
      DOUBLE PRECISION CP2
      DOUBLE PRECISION CP1
      DOUBLE PRECISION CQ2
      DOUBLE PRECISION CQ1
      DOUBLE PRECISION CQ0
      DOUBLE PRECISION ZP4
      DOUBLE PRECISION ZP3
      DOUBLE PRECISION ZP2
      DOUBLE PRECISION ZP1
      DOUBLE PRECISION ZQ2
      DOUBLE PRECISION ZQ1
      DOUBLE PRECISION ZQ0
      DOUBLE PRECISION AX
      DOUBLE PRECISION XS
      DOUBLE PRECISION EXPX
c
      INTEGER ISW
      DOUBLE PRECISION SINHM,COSHM,X
c
c                                 coded by alan kaylor cline
c                           from fitpack -- january 26, 1987
c                        a curve and surface fitting package
c                      a product of pleasant valley software
c                  8603 altus cove, austin, texas 78759, usa
c
c this subroutine returns approximations to
c       sinhm(x) = sinh(x)/x-1
c       coshm(x) = cosh(x)-1
c and
c       coshmm(x) = (cosh(x)-1-x*x/2)/(x*x)
c with relative error less than 4.0e-14.
c
c on input--
c
c   x contains the value of the independent variable.
c
c   isw indicates the function desired
c           = -1 if only sinhm is desired,
c           =  0 if both sinhm and coshm are desired,
c           =  1 if only coshm is desired,
c           =  2 if only coshmm is desired,
c           =  3 if both sinhm and coshmm are desired.
c
c on output--
c
c   sinhm contains the value of sinhm(x) if isw .le. 0 or
c   isw .eq. 3 (sinhm is unaltered if isw .eq.1 or isw .eq.
c   2).
c
c   coshm contains the value of coshm(x) if isw .eq. 0 or
c   isw .eq. 1 and contains the value of coshmm(x) if isw
c   .ge. 2 (coshm is unaltered if isw .eq. -1).
c
c and
c
c   x and isw are unaltered.
c
c-----------------------------------------------------------
c
      DATA SP14/.227581660976348D-7/,SP13/.612189863171694D-5/,
     +     SP12/.715314759211209D-3/,SP11/.398088289992973D-1/,
     +     SQ12/.206382701413725D-3/,SQ11/-.611470260009508D-1/,
     +     SQ10/.599999999999986D+1/
      DATA SP25/.129094158037272D-9/,SP24/.473731823101666D-7/,
     +     SP23/.849213455598455D-5/,SP22/.833264803327242D-3/,
     +     SP21/.425024142813226D-1/,SQ22/.106008515744821D-3/,
     +     SQ21/-.449855169512505D-1/,SQ20/.600000000268619D+1/
      DATA SP35/.155193945864942D-9/,SP34/.511529451668737D-7/,
     +     SP33/.884775635776784D-5/,SP32/.850447617691392D-3/,
     +     SP31/.428888148791777D-1/,SQ32/.933128831061610D-4/,
     +     SQ31/-.426677570538507D-1/,SQ30/.600000145086489D+1/
      DATA SP45/.188070632058331D-9/,SP44/.545792817714192D-7/,
     +     SP43/.920119535795222D-5/,SP42/.866559391672985D-3/,
     +     SP41/.432535234960858D-1/,SQ42/.824891748820670D-4/,
     +     SQ41/-.404938841672262D-1/,SQ40/.600005006283834D+1/
      DATA CP5/.552200614584744D-9/,CP4/.181666923620944D-6/,
     +     CP3/.270540125846525D-4/,CP2/.206270719503934D-2/,
     +     CP1/.744437205569040D-1/,CQ2/.514609638642689D-4/,
     +     CQ1/-.177792255528382D-1/,CQ0/.200000000000000D+1/
      DATA ZP4/.664418805876835D-8/,ZP3/.218274535686385D-5/,
     +     ZP2/.324851059327161D-3/,ZP1/.244515150174258D-1/,
     +     ZQ2/.616165782306621D-3/,ZQ1/-.213163639579425D0/,
     +     ZQ0/.240000000000000D+2/
c
      AX = ABS(X)
      IF (ISW.GE.0) GO TO 5
c
c sinhm approximation
c
      IF (AX.GT.3.9D0) GO TO 2
      XS = AX*AX
      IF (AX.GT.2.2D0) GO TO 1
c
c sinhm approximation on (0.,2.2)
c
      SINHM = XS* ((((SP14*XS+SP13)*XS+SP12)*XS+SP11)*XS+1.D0)/
     +        ((SQ12*XS+SQ11)*XS+SQ10)
      RETURN
c
c sinhm approximation on (2.2,3.9)
c
    1 SINHM = XS* (((((SP25*XS+SP24)*XS+SP23)*XS+SP22)*XS+SP21)*XS+
     +        1.D0)/ ((SQ22*XS+SQ21)*XS+SQ20)
      RETURN
    2 IF (AX.GT.5.1D0) GO TO 3
c
c sinhm approximation on (3.9,5.1)
c
      XS = AX*AX
      SINHM = XS* (((((SP35*XS+SP34)*XS+SP33)*XS+SP32)*XS+SP31)*XS+
     +        1.D0)/ ((SQ32*XS+SQ31)*XS+SQ30)
      RETURN
    3 IF (AX.GT.6.1D0) GO TO 4
c
c sinhm approximation on (5.1,6.1)
c
      XS = AX*AX
      SINHM = XS* (((((SP45*XS+SP44)*XS+SP43)*XS+SP42)*XS+SP41)*XS+
     +        1.D0)/ ((SQ42*XS+SQ41)*XS+SQ40)
      RETURN
c
c sinhm approximation above 6.1
c
    4 EXPX = EXP(AX)
      SINHM = (EXPX-1.D0/EXPX)/ (AX+AX) - 1.D0
      RETURN
c
c coshm and (possibly) sinhm approximation
c
    5 IF (ISW.GE.2) GO TO 7
      IF (AX.GT.2.2D0) GO TO 6
      XS = AX*AX
      COSHM = XS* (((((CP5*XS+CP4)*XS+CP3)*XS+CP2)*XS+CP1)*XS+1.D0)/
     +        ((CQ2*XS+CQ1)*XS+CQ0)
      IF (ISW.EQ.0) SINHM = XS* ((((SP14*XS+SP13)*XS+SP12)*XS+SP11)*XS+
     +                      1.D0)/ ((SQ12*XS+SQ11)*XS+SQ10)
      RETURN
    6 EXPX = EXP(AX)
      COSHM = (EXPX+1.D0/EXPX)/2.D0 - 1.D0
      IF (ISW.EQ.0) SINHM = (EXPX-1.D0/EXPX)/ (AX+AX) - 1.D0
      RETURN
c
c coshmm and (possibly) sinhm approximation
c
    7 XS = AX*AX
      IF (AX.GT.2.2D0) GO TO 8
      COSHM = XS* ((((ZP4*XS+ZP3)*XS+ZP2)*XS+ZP1)*XS+1.D0)/
     +        ((ZQ2*XS+ZQ1)*XS+ZQ0)
      IF (ISW.EQ.3) SINHM = XS* ((((SP14*XS+SP13)*XS+SP12)*XS+SP11)*XS+
     +                      1.D0)/ ((SQ12*XS+SQ11)*XS+SQ10)
      RETURN
    8 EXPX = EXP(AX)
      COSHM = ((EXPX+1.D0/EXPX-XS)/2.D0-1.D0)/XS
      IF (ISW.EQ.3) SINHM = (EXPX-1.D0/EXPX)/ (AX+AX) - 1.D0
      RETURN
      END

C
C	$Id: htable.f,v 1.4 2008-07-27 00:17:21 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
C
      SUBROUTINE HTABLE
C
C Creates a machine independent table from which one can obtain
C the Hollerith code for a given character.
C
C The hollerith codes are used as an index into the array containing
C the digitizations of each of the characters.
C
      INTEGER  HOLLER, I, TBSIZE
      LOGICAL  READY
      PARAMETER (TBSIZE=256)
C
C If your machine uses the ASCII character set, TBSIZE can be changed
C to 128.
C
      COMMON / HOLTAB / HOLLER(TBSIZE), READY
C
C Define alphanumerics for use in setting up the table.
C
      CHARACTER*36 ALPHAN
      DATA ALPHAN / 'ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789' /
C
C First initialize the array to an error value, 200
C
      DO 5  I=1, TBSIZE
           HOLLER(I) = 200
 5    CONTINUE
C
C Use the intrinsic function ICHAR to map the hollerith codes into
C specific positions in the array HOLLER
C
C
C Put the codes for the alphanumerics in the array.
C
      DO 10 I=1,36
           HOLLER(ICHAR(ALPHAN(I:I))) = I
 10   CONTINUE
C
C Now put in the other accepted characters
C
      HOLLER( ICHAR(':') ) = 0
      HOLLER( ICHAR('+') ) = 37
      HOLLER( ICHAR('-') ) = 38
      HOLLER( ICHAR('*') ) = 39
      HOLLER( ICHAR('/') ) = 40
      HOLLER( ICHAR('(') ) = 41
      HOLLER( ICHAR(')') ) = 42
      HOLLER( ICHAR('$') ) = 43
      HOLLER( ICHAR('=') ) = 44
      HOLLER( ICHAR(' ') ) = 45
      HOLLER( ICHAR(',') ) = 46
      HOLLER( ICHAR('.') ) = 47
      HOLLER( ICHAR('''') ) = 52
C
C Set the flag to indicate the table is initialized
C
      READY = .TRUE.
C
C Done
C
      RETURN
      END

      SUBROUTINE CUNG2L( M, N, K, A, LDA, TAU, WORK, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      INTEGER            INFO, K, LDA, M, N
*     ..
*     .. Array Arguments ..
      COMPLEX            A( LDA, * ), TAU( * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  CUNG2L generates an m by n complex matrix Q with orthonormal columns,
*  which is defined as the last n columns of a product of k elementary
*  reflectors of order m
*
*        Q  =  H(k) . . . H(2) H(1)
*
*  as returned by CGEQLF.
*
*  Arguments
*  =========
*
*  M       (input) INTEGER
*          The number of rows of the matrix Q. M >= 0.
*
*  N       (input) INTEGER
*          The number of columns of the matrix Q. M >= N >= 0.
*
*  K       (input) INTEGER
*          The number of elementary reflectors whose product defines the
*          matrix Q. N >= K >= 0.
*
*  A       (input/output) COMPLEX array, dimension (LDA,N)
*          On entry, the (n-k+i)-th column must contain the vector which
*          defines the elementary reflector H(i), for i = 1,2,...,k, as
*          returned by CGEQLF in the last k columns of its array
*          argument A.
*          On exit, the m-by-n matrix Q.
*
*  LDA     (input) INTEGER
*          The first dimension of the array A. LDA >= max(1,M).
*
*  TAU     (input) COMPLEX array, dimension (K)
*          TAU(i) must contain the scalar factor of the elementary
*          reflector H(i), as returned by CGEQLF.
*
*  WORK    (workspace) COMPLEX array, dimension (N)
*
*  INFO    (output) INTEGER
*          = 0: successful exit
*          < 0: if INFO = -i, the i-th argument has an illegal value
*
*  =====================================================================
*
*     .. Parameters ..
      COMPLEX            ONE, ZERO
      PARAMETER          ( ONE = ( 1.0E+0, 0.0E+0 ),
     $                   ZERO = ( 0.0E+0, 0.0E+0 ) )
*     ..
*     .. Local Scalars ..
      INTEGER            I, II, J, L
*     ..
*     .. External Subroutines ..
      EXTERNAL           CLARF, CSCAL, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX
*     ..
*     .. Executable Statements ..
*
*     Test the input arguments
*
      INFO = 0
      IF( M.LT.0 ) THEN
         INFO = -1
      ELSE IF( N.LT.0 .OR. N.GT.M ) THEN
         INFO = -2
      ELSE IF( K.LT.0 .OR. K.GT.N ) THEN
         INFO = -3
      ELSE IF( LDA.LT.MAX( 1, M ) ) THEN
         INFO = -5
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'CUNG2L', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.LE.0 )
     $   RETURN
*
*     Initialise columns 1:n-k to columns of the unit matrix
*
      DO 20 J = 1, N - K
         DO 10 L = 1, M
            A( L, J ) = ZERO
   10    CONTINUE
         A( M-N+J, J ) = ONE
   20 CONTINUE
*
      DO 40 I = 1, K
         II = N - K + I
*
*        Apply H(i) to A(1:m-k+i,1:n-k+i) from the left
*
         A( M-N+II, II ) = ONE
         CALL CLARF( 'Left', M-N+II, II-1, A( 1, II ), 1, TAU( I ), A,
     $               LDA, WORK )
         CALL CSCAL( M-N+II-1, -TAU( I ), A( 1, II ), 1 )
         A( M-N+II, II ) = ONE - TAU( I )
*
*        Set A(m-k+i+1:m,n-k+i) to zero
*
         DO 30 L = M - N + II + 1, M
            A( L, II ) = ZERO
   30    CONTINUE
   40 CONTINUE
      RETURN
*
*     End of CUNG2L
*
      END

C
C $Id: agsetp.f,v 1.6 2008-07-27 00:14:35 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE AGSETP (TPID,FURA,LURA)
C
      CHARACTER*(*) TPID
      DIMENSION FURA(LURA)
C
C The routine AGSETP stores user-provided values of the AUTOGRAPH
C parameters specified by the parameter identifier TPID.  The arguments
C are as follows:
C
C -- TPID is the parameter identifier, a string of keywords separated
C    from each other by slashes and followed by a period.
C
C -- FURA is the user array from which parameter values are to be taken.
C
C -- LURA is the length of the user array.
C
C The following common block contains the AUTOGRAPH control parameters,
C all of which are real.  If it is changed, all of AUTOGRAPH (especially
C the routine AGSCAN) must be examined for possible side effects.
C
      COMMON /AGCONP/ QFRA,QSET,QROW,QIXY,QWND,QBAC , SVAL(2) ,
     +                XLGF,XRGF,YBGF,YTGF , XLGD,XRGD,YBGD,YTGD , SOGD ,
     +                XMIN,XMAX,QLUX,QOVX,QCEX,XLOW,XHGH ,
     +                YMIN,YMAX,QLUY,QOVY,QCEY,YLOW,YHGH ,
     +                QDAX(4),QSPA(4),PING(4),PINU(4),FUNS(4),QBTD(4),
     +                BASD(4),QMJD(4),QJDP(4),WMJL(4),WMJR(4),QMND(4),
     +                QNDP(4),WMNL(4),WMNR(4),QLTD(4),QLED(4),QLFD(4),
     +                QLOF(4),QLOS(4),DNLA(4),WCLM(4),WCLE(4) ,
     +                QODP,QCDP,WOCD,WODQ,QDSH(26) ,
     +                     QDLB,QBIM,FLLB(10,8),QBAN ,
     +                QLLN,TCLN,QNIM,FLLN(6,16),QNAN ,
     +                XLGW,XRGW,YBGW,YTGW , XLUW,XRUW,YBUW,YTUW ,
     +                XLCW,XRCW,YBCW,YTCW , WCWP,HCWP,SCWP ,
     +                XBGA(4),YBGA(4),UBGA(4),XNDA(4),YNDA(4),UNDA(4),
     +                QBTP(4),BASE(4),QMNT(4),QLTP(4),QLEX(4),QLFL(4),
     +                QCIM(4),QCIE(4),RFNL(4),WNLL(4),WNLR(4),WNLB(4),
     +                WNLE(4),QLUA(4) ,
     +                RBOX(6),DBOX(6,4),SBOX(6,4)
      SAVE /AGCONP/
C
C The following common block contains other AUTOGRAPH variables, both
C real and integer, which are not control parameters.
C
      COMMON /AGORIP/ SMRL , ISLD , MWCL,MWCM,MWCE,MDLA,MWCD,MWDQ ,
     +                INIF
      SAVE /AGORIP/
C
C The following common block contains other AUTOGRAPH variables, of type
C character.
C
      COMMON /AGOCHP/ CHS1,CHS2
      CHARACTER*504 CHS1,CHS2
      SAVE /AGOCHP/
C
C Define the array DUMI, which allows access to the control-parameter
C list as an array.
C
      DIMENSION DUMI(485)
      EQUIVALENCE (QFRA,DUMI)
C
C If initialization has not yet been done, do it.
C
      IF (INIF.EQ.0) THEN
        CALL AGINIT
      END IF
C
C The routine AGSCAN is called to scan the parameter identifier and to
C return three quantities describing the AUTOGRAPH parameters affected.
C
      CALL AGSCAN (TPID,LOPA,NIPA,IIPA)
C
C Determine the number of values to transfer.
C
      NURA=MAX(1,MIN(LURA,NIPA))
C
C If character-string dash patterns are being replaced by integer dash
C patterns, reclaim the space used in the character-storage arrays.
C
      CALL AGSCAN ('DASH/PATT.',LODP,NIDP,IIDP)
      IF (LOPA.LE.LODP+NIDP-1.AND.LOPA+NURA-1.GE.LODP) THEN
        MINI=MAX(LOPA,LODP)-LOPA+1
        MAXI=MIN(LOPA+NURA-1,LODP+NIDP-1)-LOPA+1
        DO 100 I=MINI,MAXI
          IF (FURA(I).GT.0.) CALL AGDLCH (INT(DUMI(LOPA+I-1)))
  100   CONTINUE
      END IF
C
C Save the current values of special values 1 and 2.
C
      SVL1=SVAL(1)
      SVL2=SVAL(2)
C
C Transfer the user-provided values to the parameter list.
C
      IDMI=LOPA-IIPA
C
      DO 101 IURA=1,NURA
        IDMI=IDMI+IIPA
        DUMI(IDMI)=FURA(IURA)
  101 CONTINUE
C
C If a specific item was changed, we may have a bit more work to do;
C otherwise, return to the user.
C
      IF (NIPA.NE.1) RETURN
C
C If the specific item was special value 1 or 2, scan the primary list
C of parameters for other occurrences of the special value and change
C them to the new value.
C
      IF (SVAL(1).NE.SVL1) THEN
        SVLO=SVL1
        SVLN=SVAL(1)
        GO TO 102
      END IF
C
      IF (SVAL(2).NE.SVL2) THEN
        SVLO=SVL2
        SVLN=SVAL(2)
        GO TO 102
      END IF
C
      GO TO 104
C
  102 CALL AGSCAN ('PRIM.',LOPR,NIPR,IIPR)
C
      IDMI=LOPR-IIPR
C
      DO 103 I=1,NIPR
        IDMI=IDMI+IIPR
        IF (DUMI(IDMI).EQ.SVLO) DUMI(IDMI)=SVLN
  103 CONTINUE
C
      RETURN
C
C If the specific item was the label control flag and it was set
C negative, delete all labels and lines.
C
  104 CALL AGSCAN ('LABE/CONT.',LOLC,NILC,IILC)
      IF (LOPA.NE.LOLC) GO TO 107
      IF (QDLB.GE.0.) RETURN
C
      QBAN=0.
      QNAN=0.
C
      LBIM=INT(QBIM)
C
      DO 105 I=1,LBIM
        IF (FLLB(1,I).NE.0.) THEN
          CALL AGDLCH (INT(FLLB(1,I)))
          FLLB(1,I)=0.
        END IF
  105 CONTINUE
C
      LNIM=INT(QNIM)
C
      DO 106 I=1,LNIM
        IF (FLLN(1,I).NE.SVAL(1)) THEN
          CALL AGDLCH (INT(FLLN(4,I)))
          FLLN(1,I)=SVAL(1)
        END IF
  106 CONTINUE
C
      RETURN
C
C If the specific item was the label name, reset it to an appropriate
C index in the label list, providing initial values if appropriate.
C
  107 CALL AGSCAN ('LABE/NAME.',LOLN,NILN,IILN)
      IF (LOPA.NE.LOLN) GO TO 109
C
      LBAN=0
      LBIM=INT(QBIM)
      QNAN=0.
C
      CALL AGGTCH (INT(FURA(1)),CHS1,LCS1)
C
      DO 108 I=1,LBIM
        IF (LBAN.EQ.0.AND.FLLB(1,I).EQ.0.) LBAN=I
        CALL AGGTCH (INT(FLLB(1,I)),CHS2,LCS2)
        IF (LCS1.NE.LCS2) GO TO 108
        IF (CHS1(1:LCS1).NE.CHS2(1:LCS2)) GO TO 108
        QBAN=REAL(I)
        CALL AGDLCH (INT(FURA(1)))
        RETURN
  108 CONTINUE
C
      IF (LBAN.EQ.0) GO TO 901
C
      QBAN=REAL(LBAN)
C
      FLLB( 1,LBAN)=FURA(1)
      FLLB( 2,LBAN)=0.
      FLLB( 3,LBAN)=.5
      FLLB( 4,LBAN)=.5
      FLLB( 5,LBAN)=0.
      FLLB( 6,LBAN)=0.
      FLLB( 7,LBAN)=0.
      FLLB( 8,LBAN)=0.
      FLLB( 9,LBAN)=0.
      FLLB(10,LBAN)=0.
C
      RETURN
C
C If the label access name is not set, skip.
C
  109 IF (QBAN.LE.0.) GO TO 122
C
      LBAN=INT(QBAN)
      LBIM=INT(QBIM)
      LNAN=INT(QNAN)
      LNIM=INT(QNIM)
C
C If the specific item was the suppression flag for the current label
C and it was set negative, delete the label and/or its lines.
C
      CALL AGSCAN ('LABE/SUPP.',LOLS,NILS,IILS)
      IF (LOPA.NE.LOLS) GO TO 111
      IF (FLLB(2,LBAN).GE.0.) RETURN
C
      ITMP=INT(FLLB(2,LBAN))
      FLLB(2,LBAN)=0.
      FLLB(9,LBAN)=0.
      LNIN=INT(FLLB(10,LBAN))
      FLLB(10,LBAN)=0.
      QNAN=0.
      IF (ITMP.EQ.(-1)) GO TO 110
      CALL AGDLCH (INT(FLLB(1,LBAN)))
      FLLB(1,LBAN)=0.
      QBAN=0.
C
  110 IF (LNIN.LT.1.OR.LNIN.GT.LNIM) RETURN
      FLLN(1,LNIN)=SVAL(1)
      CALL AGDLCH (INT(FLLN(4,LNIN)))
      LNIN=INT(FLLN(6,LNIN))
      GO TO 110
C
C If the specific item was the line number, reset it to an appropriate
C index in the line list, providing initial values if appropriate.
C
  111 CALL AGSCAN ('LINE/NUMB.',LOLN,NILN,IILN)
      IF (LOPA.NE.LOLN) GO TO 118
C
      LNIL=0
      LNIN=INT(FLLB(10,LBAN))
C
  112 IF (LNIN.LT.1.OR.LNIN.GT.LNIM) GO TO 115
      IF (LNAN-INT(FLLN(1,LNIN))) 113,114,115
C
  113 LNIL=LNIN
      LNIN=INT(FLLN(6,LNIN))
      GO TO 112
C
  114 QNAN=REAL(LNIN)
      RETURN
C
  115      DO 116 I=1,LNIM
           LNIT=I
           IF (FLLN(1,I).EQ.SVAL(1)) GO TO 117
  116      CONTINUE
C
      GO TO 903
C
  117 CALL AGSTCH (' ',1,ITMP)
C
      FLLN(1,LNIT)=REAL(LNAN)
      FLLN(2,LNIT)=0.
      FLLN(3,LNIT)=.015
      FLLN(4,LNIT)=ITMP
      FLLN(5,LNIT)=1.
      FLLN(6,LNIT)=REAL(LNIN)
C
      LNAN=LNIT
      IF (LNIL.EQ.0) FLLB(10,LBAN)=REAL(LNAN)
      IF (LNIL.NE.0) FLLN( 6,LNIL)=REAL(LNAN)
C
      FLLB(9,LBAN)=FLLB(9,LBAN)+1.
C
      QNAN=REAL(LNAN)
      RETURN
C
C If the line access number is not set, skip.
C
  118 IF (LNAN.LE.0) GO TO 122
C
C If the specific item was the suppression flag for the current line and
C it was set negative, delete the line.
C
      CALL AGSCAN ('LINE/SUPP.',LOLS,NILS,IILS)
      IF (LOPA.NE.LOLS) GO TO 121
      IF (FLLN(2,LNAN).GE.0.) RETURN
C
      LNIL=0
      LNIN=INT(FLLB(10,LBAN))
C
  119 IF (LNIN.LT.1.OR.LNIN.GT.LNIM) RETURN
      IF (LNAN.EQ.LNIN) GO TO 120
      LNIL=LNIN
      LNIN=INT(FLLN(6,LNIN))
      GO TO 119
C
  120 IF (LNIL.EQ.0) FLLB(10,LBAN)=FLLN(6,LNAN)
      IF (LNIL.NE.0) FLLN( 6,LNIL)=FLLN(6,LNAN)
      FLLN(1,LNAN)=SVAL(1)
      CALL AGDLCH (INT(FLLN(4,LNAN)))
      QNAN=0.
      RETURN
C
C If the specific item was the text of a line, set the length of the
C line, as well.
C
  121 CALL AGSCAN ('LINE/TEXT.',LOLT,NILT,IILT)
      IF (LOPA.NE.LOLT) GO TO 123
      CALL AGGTCH (INT(FURA(1)),CHS1,LCS1)
      FLLN(5,LNAN)=REAL(LCS1)
      RETURN
C
C See if the user is trying to get at a line of a non-existent label.
C
  122 CALL AGSCAN ('LINE/NUMB.',LOLN,NILN,IILN)
      IF (LOPA.EQ.LOLN) GO TO 902
C
C If the specific item was the background parameter, set up the back-
C ground requested by the user.
C
  123 CALL AGSCAN ('BACK.',LOBG,NIBG,IIBG)
      IF (LOPA.NE.LOBG) GO TO 130
C
      QBAC=MAX(1.,MIN(4.,QBAC))
      IBAC=INT(QBAC)
      GO TO (124,125,126,127) , IBAC
C
C Perimeter background.
C
  124 QLBC=4.
      QRTC=4.
      WMJI=.015
      WMNI=.010
      GO TO 128
C
C Grid background.
C
  125 QLBC=4.
      QRTC=-1.
      WMJI=1.
      WMNI=1.
      GO TO 128
C
C Half-axis background.
C
  126 QLBC=4.
      QRTC=0.
      WMJI=.015
      WMNI=.010
      GO TO 128
C
C No background.
C
  127 QLBC=0.
      QRTC=0.
      WMJI=.015
      WMNI=.010
C
  128 QDAX(1)=QLBC
      QDAX(2)=QRTC
      QDAX(3)=QLBC
      QDAX(4)=QRTC
C
      DO 129 I=1,4
        WMJR(I)=WMJI
        WMNR(I)=WMNI
  129 CONTINUE
C
      QDLB=REAL(2-2*(IBAC/4))
      RETURN
C
C If the specific item was the get-limits-from-last-SET-call parameter,
C do what is necessary.
C
  130 CALL AGSCAN ('SET .',LOSE,NISE,IISE)
      IF (LOPA.NE.LOSE) GO TO 131
C
      QSET=SIGN(MAX(1.,MIN(4.,ABS(QSET))),QSET)
C
      XLGD=.15
      XRGD=.95
      YBGD=.15
      YTGD=.95
      SOGD=0.
C
      XMIN=SVAL(1)
      XMAX=SVAL(1)
      QLUX=MIN(QLUX,0.)
      QOVX=0.
      QCEX=-1.
      XLOW=SVAL(1)
      XHGH=SVAL(1)
C
      YMIN=SVAL(1)
      YMAX=SVAL(1)
      QLUY=MIN(QLUY,0.)
      QOVY=0.
      QCEY=-1.
      YLOW=SVAL(1)
      YHGH=SVAL(1)
C
      RETURN
C
C Return to caller.
C
  131 RETURN
C
C Error exits.
C
  901 CALL AGPPID (TPID)
      CALL SETER ('AGSETP - LABEL LIST OVERFLOW - SEE AUTOGRAPH SPECIALI
     +ST',15,2)
C
  902 CALL AGPPID (TPID)
      CALL SETER ('AGSETP - ATTEMPT TO DEFINE LINE OF NON-EXISTENT LABEL
     +',16,2)
C
  903 CALL AGPPID (TPID)
      CALL SETER ('AGSETP - LINE LIST OVERFLOW - SEE AUTOGRAPH SPECIALIS
     +T',17,2)
C
      END

C NCLFORTSTART
      SUBROUTINE DSTDATMZ(NZ,Z,TT,DD,PP)
      IMPLICIT NONE
c                                   INPUT
      INTEGER NZ
      DOUBLE PRECISION Z(NZ)
c                                   OUTPUT
      DOUBLE PRECISION TT(NZ), DD(NZ), PP(NZ)
C NCLEND

C NCL:  tdp = stdAtmUsa76_z2tdp (z)

      INTEGER N,LFLAG

c multiple level interface for DSS "STDZ2P"
C  .  computes pressure, temperature, and density from input heights
C  .  based on US STANDARD ATMOSPHERE, 1976
C  .  values not valid above 84852 m.
C  Original source: NCAR, Data Support Section
C  .  http://dss.ucar.edu/libraries/meteorology/

c input only in meters from NCL
      LFLAG = 0

      DO N = 1,NZ
          IF (Z(N).GE.0.D0 .AND. Z(N).LE.84852.D0) THEN
              CALL STDZ2P(PP(N),Z(N),LFLAG,TT(N),DD(N))
          ELSE
              TT(N) = -999.D0
              DD(N) = -999.D0
              PP(N) = -999.D0
          END IF
      END DO

      RETURN
      END

C NCLFORTSTART
      SUBROUTINE DSTDATMP(NP,P,TT,DD,ZZ)
      IMPLICIT NONE
c                                   INPUT
      INTEGER NP
      DOUBLE PRECISION P(NP)
c                                   OUTPUT
      DOUBLE PRECISION TT(NP), DD(NP), ZZ(NP)
C NCLEND

C NCL:  tdz = stdAtmUsa76_p2tdz (p)

      INTEGER N
      DOUBLE PRECISION ZFT

c multiple level interface for DSS "STDP2Z"
C .   computes height, temperature, and density from input pressures
C .   based on US STANDARD ATMOSPHERE, 1976
C .   values not valid above 84852 m.
c .   do not return 'zft'
C  Original source: NCAR, Data Support Section
C  .  http://dss.ucar.edu/libraries/meteorology/

      DO N = 1,NP
          IF (P(N).GE.0.00373D0 .AND. P(N).LE.1013.25D0) THEN
              CALL STDP2Z(P(N),ZZ(N),ZFT,TT(N),DD(N))
          ELSE
              TT(N) = -999.D0
              DD(N) = -999.D0
              ZZ(N) = -999.D0
          END IF
      END DO

      RETURN
      END
C --------------------------------------------------
      SUBROUTINE STDZ2P(P,H1,L,TCENT,RHO)
      IMPLICIT NONE
      INTEGER L
      DOUBLE PRECISION P,H1,TCENT,RHO
C
C COMPUTES PRESSURE, TEMPERATURE, AND DENSITY VALUES FROM INPUT HEIGHTS
C  BASED ON US STANDARD ATMOSPHERE, 1976
C  VALUES NOT VALID ABOVE 84852 KM.
C
C INPUT
C       H1    - HEIGHT IN FEET OR METERS
C       L     - UNITS FLAG - 0=METERS, 1=FEET
C OUTPUT
C       P     - PRESSURE IN MB
C       TCENT - TEMPERATURE IN DEG C
C       RHO   - DENSITY IN KG/M3
C
      INTEGER I
      DOUBLE PRECISION HBASE(10),HTOP(10),TB(10),GRAD(10),ABST(10)
      DOUBLE PRECISION PB(11),RB(10),ABSZ,PZERP,G,R,CHECK,T,H,PZERO

      DATA HBASE/0.D0,1.1D4,2.D4,3.2D4,4.7D4,5.1D4,7.1D4,3*84852.0D0/
      DATA HTOP/1.1D4,2.D4,3.2D4,4.7D4,5.1D4,7.1D4,4*84852.0D0/
      DATA TB/15.D0,2*-56.5D0,-44.5D0,2*-2.5D0,-58.5D0,3*-86.2D0/
      DATA GRAD/-.0065D0,0.D0,0.001D0,0.0028D0,0.D0,-.0028D0,-.002D0,
     +     3*0.D0/
c djs DATA CHECK/0.D0/
C
C     H1 IS ALTITUDE: IF IN METERS SET L<=0.  IF IN FEET SET L>=1
C
c djs IF (CHECK.EQ.0.D0) THEN
          ABSZ  = 273.15D0
          PZERO = 1013.250D0
          G     = 980.665D0
          R     = 83143200.D0/28.9644D0
          PB(1) = PZERO

          DO I = 1,8
              ABST(I) = TB(I) + ABSZ
          END DO

          DO I = 1,8
              IF (GRAD(I).NE.0) THEN
                  PB(I+1) = PB(I)* (ABST(I+1)/ABST(I))**
     +                      (100.D0*G/ (-GRAD(I)*R))
              ELSE
                  PB(I+1) = PB(I)*2.7182818D0**
     +                      ((-100.D0*G/ (R*ABST(I)))*
     +                      (HTOP(I)-HBASE(I)))
              END IF
              RB(I) = 1000.D0*PB(I)/ (R*ABST(I))*1000.D0
          END DO
          CHECK = 10.D0
c djs END IF

      IF (L.GE.1) THEN
          H = H1*0.3048D0
      ELSE
          H = H1
      END IF

      DO I = 1,8
          IF (H.LE.HBASE(I+1)) THEN
              IF (GRAD(I).NE.0.D0) THEN
                  P = PB(I)* ((H-HBASE(I))*GRAD(I)/ABST(I)+1)**
     +                (-100.D0*G/ (GRAD(I)*R))
              ELSE
C                                 ISOTHERMAL LAYER
                  P = PB(I)*EXP((H-HBASE(I))* (-G)/ (0.01D0*R*ABST(I)))
              END IF

              T     = ABST(I) + GRAD(I)* (H-HBASE(I))
              TCENT = T - ABSZ
              RHO   = 1.D6*P/ (R*T)
              RETURN
          END IF
      END DO

      RETURN
      END
C --------------------------------------------------
      SUBROUTINE STDP2Z(P,H,HFT,TCENT,DENS)
      IMPLICIT NONE
      DOUBLE PRECISION P,H,HFT,TCENT,DENS
C
C COMPUTES HEIGHT, TEMPERATURE, AND DENSITY VALUES FROM INPUT PRESSURES
C  BASED ON US STANDARD ATMOSPHERE, 1976
C  VALUES NOT VALID ABOVE 84852 KM.
C
C INPUT
C       P     - PRESSURE IN MB
C OUTPUT
C       H     - HEIGHT IN METERS
C       HFT   - HEIGHT IN FEET
C       TCENT - TEMPERATURE IN DEG C
C       DENS  - DENSITY IN KG/M3
C
      INTEGER I
      DOUBLE PRECISION HBASE(10),HTOP(10),TB(10),GRAD(10),ABST(10),
     +                 PB(10),RB(10),ABSZ,G,R,T
      DATA HBASE/0.D0,1.1D4,2.D4,3.2D4,4.7D4,5.1D4,7.1D4,3*84852.0D0/
      DATA HTOP/1.1D4,2.D4,3.2D4,4.7D4,5.1D4,7.1D4,4*84852.0D0/
      DATA GRAD/-.0065D0,0.D0,0.001D0,0.0028D0,0.D0,-.0028D0,-.002D0,
     +     3*0.D0/
      DATA ABST/288.15D0,216.65D0,216.65D0,228.65D0,270.65D0,270.65D0,
     +     214.65D0,186.95D0,2*0.D0/
      DATA PB/1013.25D0,0.22632064D+03,0.54748887D+02,0.86801870D+01,
     +     0.11090631D+01,0.66938874D+00,0.39564205D-01,0.37338360D-02,
     +     2*0.D0/

      ABSZ = 273.15D0
      G = 980.665D0
      R = 83143200.D0/28.9644D0
      IF (P.LE.PB(1)) THEN
          DO I = 1,8
              IF (P.GE.PB(I+1)) GO TO 37
          END DO
      END IF


   37 CONTINUE
      IF (GRAD(I).NE.0.D0) THEN
          H = ABST(I)/ (-GRAD(I))* (1.D0-
     +        (P/PB(I))** (-GRAD(I)*R/ (100.D0*G))) + HBASE(I)
      ELSE
C  ISOTHERMAL LAYER
          H = HBASE(I) + 0.01D0*R*ABST(I)/G*DLOG(PB(I)/P)
      END IF

      T = ABST(I) + GRAD(I)* (H-HBASE(I))
      TCENT = T - ABSZ
      DENS = 1000*1000.D0*P/ (R*T)
      HFT = H/0.3048D0

      RETURN
      END

C
C	$Id: encd.f,v 1.5 2008-07-27 00:17:29 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE ENCD (VALU,ASH,IOUT,NC,IOFFD)
C
C ON INPUT     VALU      Floating point number from which a label is
C                        to be created in IOUT.
C
C              ASH       A scale factor used when IOFFD is non-zero.
C                        ASH should be non-negative.
C
C              IOFFD     If IOFFD .EQ. 0
C                             a label which reflects the magnitude
C                             of VALU is created.  Legal values for
C                             VALU are  0.0  and any value such that
C                             .1 .LE. ABS(VALU) .LE. 99999.49999...
C                             The label created in IOUT will have 3
C                             to 6 characters depending on the value
C                             of VALU.  See IOUT below.
C                        IF IOFFD .NE. 0
C                             a label is created which reflects the
C                             value in  VALU  scaled by  ASH.
C                             Legal values for VALU are 0. or
C                             any number such that
C                             1. .LE. ASH*ABS(VALU) .LT. 1000.
C                             The label created in IOUT will have
C                             1 to 3 characters, depending on the
C                             magnitude of ASH*VALU.  See IOUT below.
C
C ON OUTPUT    IOUT      Contains the created label.  It should have no
C                        leading blanks.  See NC.
C
C              NC        The number of characters in the label created
C                        in  IOUT.  NC will be between 1 and 6 inclusive.
C
      SAVE
      CHARACTER*(*)   IOUT
      CHARACTER*7     IFMT
C
      VAL = VALU
      IF (IOFFD .NE. 0) GO TO 103
      IF (VAL) 101,104,101
  101 CONTINUE
      LOG = INT((ALOG10(ABS(VAL))+.00001)+5000.)-5000
      V = VAL
      NS = MAX(4,MIN(6,LOG+2))
      ND = MIN(3,MAX(0,2-LOG))
      IF (VAL.LT.0)  NS = NS + 1
  102 CONTINUE
      WRITE (IFMT,'(A2,I2,A1,I1,A1)') '(F',NS,'.',ND,')'
      WRITE (IOUT,IFMT) V
      NC = NS
      IF (LOG.GE.3)  NC = NC - 1
      RETURN
  103 CONTINUE
      NS = 4
      IF (VAL.LT.0.)  NS=5
      IF (VAL.EQ.0.)  NS=2
      ND = 0
      V = VAL*ASH
      LOG = 100
      GO TO 102
  104 CONTINUE
      NS = 3
      ND = 1
      LOG = -100
      V = 0.
      GO TO 102
C
      END

      SUBROUTINE ZUNGRQ( M, N, K, A, LDA, TAU, WORK, LWORK, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      INTEGER            INFO, K, LDA, LWORK, M, N
*     ..
*     .. Array Arguments ..
      COMPLEX*16         A( LDA, * ), TAU( * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  ZUNGRQ generates an M-by-N complex matrix Q with orthonormal rows,
*  which is defined as the last M rows of a product of K elementary
*  reflectors of order N
*
*        Q  =  H(1)' H(2)' . . . H(k)'
*
*  as returned by ZGERQF.
*
*  Arguments
*  =========
*
*  M       (input) INTEGER
*          The number of rows of the matrix Q. M >= 0.
*
*  N       (input) INTEGER
*          The number of columns of the matrix Q. N >= M.
*
*  K       (input) INTEGER
*          The number of elementary reflectors whose product defines the
*          matrix Q. M >= K >= 0.
*
*  A       (input/output) COMPLEX*16 array, dimension (LDA,N)
*          On entry, the (m-k+i)-th row must contain the vector which
*          defines the elementary reflector H(i), for i = 1,2,...,k, as
*          returned by ZGERQF in the last k rows of its array argument
*          A.
*          On exit, the M-by-N matrix Q.
*
*  LDA     (input) INTEGER
*          The first dimension of the array A. LDA >= max(1,M).
*
*  TAU     (input) COMPLEX*16 array, dimension (K)
*          TAU(i) must contain the scalar factor of the elementary
*          reflector H(i), as returned by ZGERQF.
*
*  WORK    (workspace/output) COMPLEX*16 array, dimension (LWORK)
*          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*
*  LWORK   (input) INTEGER
*          The dimension of the array WORK. LWORK >= max(1,M).
*          For optimum performance LWORK >= M*NB, where NB is the
*          optimal blocksize.
*
*          If LWORK = -1, then a workspace query is assumed; the routine
*          only calculates the optimal size of the WORK array, returns
*          this value as the first entry of the WORK array, and no error
*          message related to LWORK is issued by XERBLA.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument has an illegal value
*
*  =====================================================================
*
*     .. Parameters ..
      COMPLEX*16         ZERO
      PARAMETER          ( ZERO = ( 0.0D+0, 0.0D+0 ) )
*     ..
*     .. Local Scalars ..
      LOGICAL            LQUERY
      INTEGER            I, IB, II, IINFO, IWS, J, KK, L, LDWORK,
     $                   LWKOPT, NB, NBMIN, NX
*     ..
*     .. External Subroutines ..
      EXTERNAL           XERBLA, ZLARFB, ZLARFT, ZUNGR2
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN
*     ..
*     .. External Functions ..
      INTEGER            ILAENV
      EXTERNAL           ILAENV
*     ..
*     .. Executable Statements ..
*
*     Test the input arguments
*
      INFO = 0
      NB = ILAENV( 1, 'ZUNGRQ', ' ', M, N, K, -1 )
      LWKOPT = MAX( 1, M )*NB
      WORK( 1 ) = LWKOPT
      LQUERY = ( LWORK.EQ.-1 )
      IF( M.LT.0 ) THEN
         INFO = -1
      ELSE IF( N.LT.M ) THEN
         INFO = -2
      ELSE IF( K.LT.0 .OR. K.GT.M ) THEN
         INFO = -3
      ELSE IF( LDA.LT.MAX( 1, M ) ) THEN
         INFO = -5
      ELSE IF( LWORK.LT.MAX( 1, M ) .AND. .NOT.LQUERY ) THEN
         INFO = -8
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'ZUNGRQ', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( M.LE.0 ) THEN
         WORK( 1 ) = 1
         RETURN
      END IF
*
      NBMIN = 2
      NX = 0
      IWS = M
      IF( NB.GT.1 .AND. NB.LT.K ) THEN
*
*        Determine when to cross over from blocked to unblocked code.
*
         NX = MAX( 0, ILAENV( 3, 'ZUNGRQ', ' ', M, N, K, -1 ) )
         IF( NX.LT.K ) THEN
*
*           Determine if workspace is large enough for blocked code.
*
            LDWORK = M
            IWS = LDWORK*NB
            IF( LWORK.LT.IWS ) THEN
*
*              Not enough workspace to use optimal NB:  reduce NB and
*              determine the minimum value of NB.
*
               NB = LWORK / LDWORK
               NBMIN = MAX( 2, ILAENV( 2, 'ZUNGRQ', ' ', M, N, K, -1 ) )
            END IF
         END IF
      END IF
*
      IF( NB.GE.NBMIN .AND. NB.LT.K .AND. NX.LT.K ) THEN
*
*        Use blocked code after the first block.
*        The last kk rows are handled by the block method.
*
         KK = MIN( K, ( ( K-NX+NB-1 ) / NB )*NB )
*
*        Set A(1:m-kk,n-kk+1:n) to zero.
*
         DO 20 J = N - KK + 1, N
            DO 10 I = 1, M - KK
               A( I, J ) = ZERO
   10       CONTINUE
   20    CONTINUE
      ELSE
         KK = 0
      END IF
*
*     Use unblocked code for the first or only block.
*
      CALL ZUNGR2( M-KK, N-KK, K-KK, A, LDA, TAU, WORK, IINFO )
*
      IF( KK.GT.0 ) THEN
*
*        Use blocked code
*
         DO 50 I = K - KK + 1, K, NB
            IB = MIN( NB, K-I+1 )
            II = M - K + I
            IF( II.GT.1 ) THEN
*
*              Form the triangular factor of the block reflector
*              H = H(i+ib-1) . . . H(i+1) H(i)
*
               CALL ZLARFT( 'Backward', 'Rowwise', N-K+I+IB-1, IB,
     $                      A( II, 1 ), LDA, TAU( I ), WORK, LDWORK )
*
*              Apply H' to A(1:m-k+i-1,1:n-k+i+ib-1) from the right
*
               CALL ZLARFB( 'Right', 'Conjugate transpose', 'Backward',
     $                      'Rowwise', II-1, N-K+I+IB-1, IB, A( II, 1 ),
     $                      LDA, WORK, LDWORK, A, LDA, WORK( IB+1 ),
     $                      LDWORK )
            END IF
*
*           Apply H' to columns 1:n-k+i+ib-1 of current block
*
            CALL ZUNGR2( IB, N-K+I+IB-1, IB, A( II, 1 ), LDA, TAU( I ),
     $                   WORK, IINFO )
*
*           Set columns n-k+i+ib:n of current block to zero
*
            DO 40 L = N - K + I + IB, N
               DO 30 J = II, II + IB - 1
                  A( J, L ) = ZERO
   30          CONTINUE
   40       CONTINUE
   50    CONTINUE
      END IF
*
      WORK( 1 ) = IWS
      RETURN
*
*     End of ZUNGRQ
*
      END

      SUBROUTINE CUNM2L( SIDE, TRANS, M, N, K, A, LDA, TAU, C, LDC,
     $                   WORK, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER          SIDE, TRANS
      INTEGER            INFO, K, LDA, LDC, M, N
*     ..
*     .. Array Arguments ..
      COMPLEX            A( LDA, * ), C( LDC, * ), TAU( * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  CUNM2L overwrites the general complex m-by-n matrix C with
*
*        Q * C  if SIDE = 'L' and TRANS = 'N', or
*
*        Q'* C  if SIDE = 'L' and TRANS = 'C', or
*
*        C * Q  if SIDE = 'R' and TRANS = 'N', or
*
*        C * Q' if SIDE = 'R' and TRANS = 'C',
*
*  where Q is a complex unitary matrix defined as the product of k
*  elementary reflectors
*
*        Q = H(k) . . . H(2) H(1)
*
*  as returned by CGEQLF. Q is of order m if SIDE = 'L' and of order n
*  if SIDE = 'R'.
*
*  Arguments
*  =========
*
*  SIDE    (input) CHARACTER*1
*          = 'L': apply Q or Q' from the Left
*          = 'R': apply Q or Q' from the Right
*
*  TRANS   (input) CHARACTER*1
*          = 'N': apply Q  (No transpose)
*          = 'C': apply Q' (Conjugate transpose)
*
*  M       (input) INTEGER
*          The number of rows of the matrix C. M >= 0.
*
*  N       (input) INTEGER
*          The number of columns of the matrix C. N >= 0.
*
*  K       (input) INTEGER
*          The number of elementary reflectors whose product defines
*          the matrix Q.
*          If SIDE = 'L', M >= K >= 0;
*          if SIDE = 'R', N >= K >= 0.
*
*  A       (input) COMPLEX array, dimension (LDA,K)
*          The i-th column must contain the vector which defines the
*          elementary reflector H(i), for i = 1,2,...,k, as returned by
*          CGEQLF in the last k columns of its array argument A.
*          A is modified by the routine but restored on exit.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.
*          If SIDE = 'L', LDA >= max(1,M);
*          if SIDE = 'R', LDA >= max(1,N).
*
*  TAU     (input) COMPLEX array, dimension (K)
*          TAU(i) must contain the scalar factor of the elementary
*          reflector H(i), as returned by CGEQLF.
*
*  C       (input/output) COMPLEX array, dimension (LDC,N)
*          On entry, the m-by-n matrix C.
*          On exit, C is overwritten by Q*C or Q'*C or C*Q' or C*Q.
*
*  LDC     (input) INTEGER
*          The leading dimension of the array C. LDC >= max(1,M).
*
*  WORK    (workspace) COMPLEX array, dimension
*                                   (N) if SIDE = 'L',
*                                   (M) if SIDE = 'R'
*
*  INFO    (output) INTEGER
*          = 0: successful exit
*          < 0: if INFO = -i, the i-th argument had an illegal value
*
*  =====================================================================
*
*     .. Parameters ..
      COMPLEX            ONE
      PARAMETER          ( ONE = ( 1.0E+0, 0.0E+0 ) )
*     ..
*     .. Local Scalars ..
      LOGICAL            LEFT, NOTRAN
      INTEGER            I, I1, I2, I3, MI, NI, NQ
      COMPLEX            AII, TAUI
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           CLARF, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          CONJG, MAX
*     ..
*     .. Executable Statements ..
*
*     Test the input arguments
*
      INFO = 0
      LEFT = LSAME( SIDE, 'L' )
      NOTRAN = LSAME( TRANS, 'N' )
*
*     NQ is the order of Q
*
      IF( LEFT ) THEN
         NQ = M
      ELSE
         NQ = N
      END IF
      IF( .NOT.LEFT .AND. .NOT.LSAME( SIDE, 'R' ) ) THEN
         INFO = -1
      ELSE IF( .NOT.NOTRAN .AND. .NOT.LSAME( TRANS, 'C' ) ) THEN
         INFO = -2
      ELSE IF( M.LT.0 ) THEN
         INFO = -3
      ELSE IF( N.LT.0 ) THEN
         INFO = -4
      ELSE IF( K.LT.0 .OR. K.GT.NQ ) THEN
         INFO = -5
      ELSE IF( LDA.LT.MAX( 1, NQ ) ) THEN
         INFO = -7
      ELSE IF( LDC.LT.MAX( 1, M ) ) THEN
         INFO = -10
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'CUNM2L', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( M.EQ.0 .OR. N.EQ.0 .OR. K.EQ.0 )
     $   RETURN
*
      IF( ( LEFT .AND. NOTRAN .OR. .NOT.LEFT .AND. .NOT.NOTRAN ) ) THEN
         I1 = 1
         I2 = K
         I3 = 1
      ELSE
         I1 = K
         I2 = 1
         I3 = -1
      END IF
*
      IF( LEFT ) THEN
         NI = N
      ELSE
         MI = M
      END IF
*
      DO 10 I = I1, I2, I3
         IF( LEFT ) THEN
*
*           H(i) or H(i)' is applied to C(1:m-k+i,1:n)
*
            MI = M - K + I
         ELSE
*
*           H(i) or H(i)' is applied to C(1:m,1:n-k+i)
*
            NI = N - K + I
         END IF
*
*        Apply H(i) or H(i)'
*
         IF( NOTRAN ) THEN
            TAUI = TAU( I )
         ELSE
            TAUI = CONJG( TAU( I ) )
         END IF
         AII = A( NQ-K+I, I )
         A( NQ-K+I, I ) = ONE
         CALL CLARF( SIDE, MI, NI, A( 1, I ), 1, TAUI, C, LDC, WORK )
         A( NQ-K+I, I ) = AII
   10 CONTINUE
      RETURN
*
*     End of CUNM2L
*
      END

C
C	$Id: cssig1.f,v 1.5 2008-07-27 03:10:08 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      DOUBLE PRECISION FUNCTION CSSIG1 (N1,N2,N,X,Y,Z,H,LIST,
     .                                LPTR,LEND,GRAD,IFLGB,
     .                                HPBND,TOL,
     .                                IFLGS, SIGMA, IER)
      INTEGER N1, N2, N, LIST(*), LPTR(*), LEND(N), IFLGB,
     .        IFLGS, IER
      DOUBLE PRECISION X(N), Y(N), Z(N), H(N), GRAD(3,N),
     .                 HPBND, TOL, SIGMA(*)
C
C***********************************************************
C
C                                              From SSRFPACK
C                                            Robert J. Renka
C                                  Dept. of Computer Science
C                                       Univ. of North Texas
C                                           renka@cs.unt.edu
C                                                   11/21/96
C
C   Given a triangulation of a set of nodes on the unit
C sphere, along with data values H and gradients GRAD at the
C nodes, this function determines the smallest tension fac-
C tor CSSIG1 such that the first derivative HP(A) of the
C Hermite interpolatory tension spline H(A), defined by CSSIG1
C and the endpoint values and directional derivatives asso-
C ciated with an arc N1-N2, is bounded (either above or
C below) by HPBND for all A in (A1,A2), where (A1,A2) de-
C notes an interval corresponding to the arc and A denotes
C arc-length.
C
C On input:
C
C       N1,N2 = Nodal indexes of the endpoints of an arc for
C               which the tension factor is to be computed.
C               The indexes must be distinct and lie in the
C               range 1 to N, and if IFLGS .GE. 1, they must
C               correspond to adjacent nodes in the triangu-
C               lation.
C
C       N = Number of nodes in the triangulation.  N .GE. 3.
C
C       X,Y,Z = Arrays of length N containing coordinates of
C               the nodes.  X(I)**2 + Y(I)**2 + Z(I)**2 = 1.
C
C       H = Array of length N containing data values at the
C           nodes.  H(I) is associated with (X(I),Y(I),Z(I))
C           for I = 1 to N.
C
C       LIST,LPTR,LEND = Data structure defining the trian-
C                        gulation.  Refer to STRIPACK
C                        Subroutine CSTRMESH.
C
C       GRAD = Array dimensioned 3 by N whose columns con-
C              gradients at the nodes.  GRAD( ,J) must be
C              orthogonal to node J:  GRAD(1,J)*X(J) +
C              GRAD(2,J)*Y(J) + GRAD(3,J)*Z(J) = 0.  Refer
C              to Subroutines CSGRADG, CSGRADL, and CSSMSURF.
C
C       IFLGB = Bound option indicator:
C               IFLGB = -1 if HPBND is a lower bound on HP.
C               IFLGB = 1 if HPBND is an upper bound on HP.
C
C       HPBND = Bound on HP.  HPBND .LE. min(HP1,HP2,S) if
C               IFLGB = -1 and HPBND .GE. max(HP1,HP2,S) if
C               IFLGB = 1, where HP1 and HP2 are the direc-
C               tional derivatives at the endpoints of the
C               arc N1-N2, and S is the slope of the linear
C               interpolant of the endpoint data values.
C
C       TOL = Tolerance whose magnitude determines how close
C             CSSIG1 is to its optimal value when nonzero
C             finite tension is necessary and sufficient to
C             satisfy the constraint.  For a lower bound,
C             CSSIG1 is chosen so that HPBND .LE. HPMIN .LE.
C             HPBND + abs(TOL), where HPMIN is the minimum
C             value of HP on the arc.  For an upper bound,
C             the maximum of HP satisfies HPBND - abs(TOL)
C             .LE. HPMAX .LE. HPBND.  Thus, the constraint
C             is satisfied but possibly with more tension
C             than necessary.
C
C       IFLGS = Tension array option indicator:
C               IFLGS .LE. 0 if SIGMA is not to be used.
C               IFLGS .GE. 1 if SIGMA is to be updated by
C                            storing CSSIG1 in the appropriate
C                            locations.
C
C The above parameters are not altered by this function.
C
C       SIGMA = Dummy parameter (IFLGS .LE. 0) or array
C               containing tension factors associated with
C               arcs in one-to-one correspondence with LIST
C               entries (IFLGS .GE. 1).  Refer to Subroutine
C               CSGETSIG.
C
C On output:
C
C       SIGMA = Tension factor array updated with the new
C               value if and only if IFLGS .GE. 1 and IER
C               .GE. 0.
C
C       IER = Error indicator:
C             IER = 0 if no errors were encountered and the
C                     constraint can be satisfied with fin-
C                     ite tension.
C             IER = 1 if no errors were encountered but in-
C                     finite tension is required to satisfy
C                     the constraint (e.g., IFLGB = -1,
C                     HPBND = S, and HP1 > S).
C             IER = -1 if N1, N2, N, or IFLGB is outside its
C                      valid range.
C             IER = -2 if nodes N1 and N2 coincide or IFLGS
C                      .GE. 1 and the nodes are not adja-
C                      cent.
C             IER = -3 if HPBND is outside its valid range.
C
C       CSSIG1 = Minimum tension factor defined above unless
C              IER < 0, in which case CSSIG1 = -1.  If IER
C              = 1, CSSIG1 is set to 85, resulting in an
C              approximation to the linear interpolant of
C              the endpoint values.
C
C STRIPACK module required by CSSIG1:  CSSTORE
C
C SSRFPACK modules required by CSSIG1:  CSARCLEN, CSSNHCSH
C
C Intrinsic functions called by CSSIG1:   ABS, EXP, MAX, MIN,
C                                         DBLE, SIGN, SQRT
C
C***********************************************************
C
      DOUBLE PRECISION CSARCLEN, CSSTORE
      INTEGER LP1, LP2, LPL, LUN, NIT
      DOUBLE PRECISION A, A0, AL, B0, BND, C0, C1, C2,
     .                 COSHM, COSHMM, D0, D1, D1PD2, D2,
     .                 DMAX, DSIG, E, EMS, EMS2, F, F0,
     .                 FMAX, FNEG, FTOL, P1(3), P2(3), RF,
     .                 RTOL, S, S1, S2, SBIG, SIG, SINH,
     .                 SINHM, STOL, T0, T1, T2, TM, UN(3),
     .                 UNORM
C
      DATA SBIG/85./,  LUN/-1/
      RF = DBLE(IFLGB)
      BND = HPBND
C
C Print a heading.
C
      IF (LUN .GE. 0  .AND.  RF .LT. 0.) WRITE (LUN,100) N1,
     .                                   N2, BND
      IF (LUN .GE. 0  .AND.  RF .GT. 0.) WRITE (LUN,110) N1,
     .                                   N2, BND
  100 FORMAT (//1X,'CSSIG1 -- N1 =',I4,', N2 =',I4,
     .        ', LOWER BOUND = ',E15.8)
  110 FORMAT (//1X,'CSSIG1 -- N1 =',I4,', N2 =',I4,
     .        ', UPPER BOUND = ',E15.8)
C
C Test for errors and store local parameters.
C
      IER = -1
      IF (MIN(N1,N2) .LT. 1  .OR.  N1 .EQ. N2  .OR.
     .    MAX(N1,N2,3) .GT. N  .OR.  ABS(RF) .NE. 1.)
     .   GO TO 11
      IER = -2
      IF (IFLGS .GT. 0) THEN
C
C   Set LP1 and LP2 to the pointers to N2 as a neighbor of
C     N1 and N1 as a neighbor of N2, respectively.
C
        LPL = LEND(N1)
        LP1 = LPTR(LPL)
    1   IF (LIST(LP1) .EQ. N2) GO TO 2
          LP1 = LPTR(LP1)
          IF (LP1 .NE. LPL) GO TO 1
        IF (ABS(LIST(LP1)) .NE. N2) GO TO 11
C
    2   LPL = LEND(N2)
        LP2 = LPTR(LPL)
    3   IF (LIST(LP2) .EQ. N1) GO TO 4
          LP2 = LPTR(LP2)
          IF (LP2 .NE. LPL) GO TO 3
        IF (ABS(LIST(LP2)) .NE. N1) GO TO 11
      ENDIF
C
C Store nodal coordinates P1 and P2, compute arc-length AL
C   and unit normal UN = (P1 X P2)/UNORM, and test for
C   coincident nodes.
C
    4 P1(1) = X(N1)
      P1(2) = Y(N1)
      P1(3) = Z(N1)
      P2(1) = X(N2)
      P2(2) = Y(N2)
      P2(3) = Z(N2)
      AL = CSARCLEN(P1,P2)
      UN(1) = P1(2)*P2(3) - P1(3)*P2(2)
      UN(2) = P1(3)*P2(1) - P1(1)*P2(3)
      UN(3) = P1(1)*P2(2) - P1(2)*P2(1)
      UNORM = SQRT(UN(1)*UN(1) + UN(2)*UN(2) + UN(3)*UN(3))
      IF (UNORM .EQ. 0.  .OR.  AL .EQ. 0.) GO TO 11
C
C Compute first difference S and scaled directional deriva-
C   tives S1,S2 at the endpoints (for the direction N1->N2).
C
      S = H(N2) - H(N1)
      S1 = AL*(GRAD(1,N1)*P2(1) + GRAD(2,N1)*P2(2) +
     .         GRAD(3,N1)*P2(3))/UNORM
      S2 = -AL*(GRAD(1,N2)*P1(1) + GRAD(2,N2)*P1(2) +
     .          GRAD(3,N2)*P1(3))/UNORM
C
C Test for a valid constraint.
C
      IER = -3
      IF ((RF .LT. 0.  .AND.  MIN(S1,S2,S) .LT. BND)  .OR.
     .    (RF .GT. 0.  .AND.  BND .LT. MAX(S1,S2,S)))
     .   GO TO 11
C
C Test for infinite tension required.
C
      IER = 1
      SIG = SBIG
      IF (S .EQ. BND  .AND.  (S1 .NE. S  .OR.  S2 .NE. S))
     .   GO TO 10
C
C Test for SIG = 0 sufficient.  The Hermite cubic interpo-
C   lant H0 has derivative HP0(T) = (S2 + 2*B0*R + A0*R**2)/
C   AL, where R = (T2-T)/AL.
C
      IER = 0
      SIG = 0.
      T0 = 3.*S - S1 - S2
      B0 = T0 - S2
      C0 = T0 - S1
      A0 = -B0 - C0
C
C   HP0(R) has an extremum (at R = -B0/A0) in (0,1) iff
C     B0*C0 > 0 and the third derivative of H0 has the
C     sign of A0.
C
      IF (B0*C0 .LE. 0.  .OR.  A0*RF .GT. 0.) GO TO 10
C
C   A0*RF < 0 and HP0(R) = -D0/(DT*A0) at R = -B0/A0.
C
      D0 = T0*T0 - S1*S2
      F0 = (BND + D0/(A0*AL))*RF
      IF (F0 .GE. 0.) GO TO 10
C
C Find a zero of F(SIG) = (BND-HP(R))*RF, where HP has an
C   extremum at R.  F has a unique zero, F(0) = F0 < 0, and
C   F = (BND-S)*RF > 0 for SIG sufficiently large.
C
C Initialize parameters for the secant method.  The method
C   uses three points:  (SG0,F0), (SIG,F), and (SNEG,FNEG),
C   where SG0 and SNEG are defined implicitly by DSIG = SIG
C   - SG0 and DMAX = SIG - SNEG.  SG0 is initially zero and
C   SIG is initialized to the zero of (BND - (SIG*S-S1-S2)/
C   (AL*(SIG-2.)))*RF -- a value for which F(SIG) .GE. 0 and
C   F(SIG) = 0 for SIG sufficiently large that 2*SIG is in-
C   significant relative to exp(SIG).
C
      FMAX = (BND-S/AL)*RF
      SIG = 2. - A0/(3.*(AL*BND-S))
      IF (LUN .GE. 0) WRITE (LUN,120) F0, FMAX, SIG
  120 FORMAT (1X,9X,'F0 = ',E15.8,', FMAX = ',E15.8/
     .        1X,8X,'SIG = ',E15.8/)
      IF (CSSTORE(SIG*EXP(-SIG)+.5) .EQ. .5) GO TO 10
      DSIG = SIG
      DMAX = -2.*SIG
      FNEG = FMAX
      D1 = S - S1
      D2 = S2 - S
      D1PD2 = D1 + D2
      NIT = 0
C
C Compute an absolute tolerance FTOL = abs(TOL), and a
C   relative tolerance RTOL = 100*Macheps.
C
      FTOL = ABS(TOL)
      RTOL = 1.
    5 RTOL = RTOL/2.
        IF (CSSTORE(RTOL+1.) .GT. 1.) GO TO 5
      RTOL = RTOL*200.
C
C Top of loop:  compute F.
C
    6 IF (SIG .LE. .5) THEN
C
C   Use approximations designed to avoid cancellation
C     error (associated with small SIG) in the modified
C     hyperbolic functions.
C
        CALL CSSNHCSH (SIG, SINHM,COSHM,COSHMM)
        C1 = SIG*COSHM*D2 - SINHM*D1PD2
        C2 = SIG*(SINHM+SIG)*D2 - COSHM*D1PD2
        A = C2 - C1
        E = SIG*SINHM - COSHMM - COSHMM
      ELSE
C
C   Scale SINHM and COSHM by 2*exp(-SIG) in order to avoid
C     overflow.
C
        EMS = EXP(-SIG)
        EMS2 = EMS + EMS
        TM = 1. - EMS
        SINH = TM*(1.+EMS)
        SINHM = SINH - SIG*EMS2
        COSHM = TM*TM
        C1 = SIG*COSHM*D2 - SINHM*D1PD2
        C2 = SIG*SINH*D2 - COSHM*D1PD2
        A = EMS2*(SIG*TM*D2 + (TM-SIG)*D1PD2)
        E = SIG*SINH - COSHM - COSHM
      ENDIF
C
C   The second derivative HPP of H(R) has a zero at exp(SIG*
C     R) = SQRT((C2+C1)/A) and R is in (0,1) and well-
C     defined iff HPP(T1)*HPP(T2) < 0.
C
      F = FMAX
      T1 = A*(C2+C1)
      IF (T1 .GE. 0.) THEN
        IF (C1*(SIG*COSHM*D1 - SINHM*D1PD2) .LT. 0.) THEN
C
C   HP(R) = (B+SIGN(A)*SQRT(A*C))/(AL*E) at the critical
C     value of R, where A = C2-C1, B = E*S2-C2, and C = C2 +
C     C1.  Note that RF*A < 0.
C
          F = (BND - (E*S2-C2 - RF*SQRT(T1))/(AL*E))*RF
        ENDIF
      ENDIF
C
C   Update the number of iterations NIT.
C
      NIT = NIT + 1
      IF (LUN .GE. 0) WRITE (LUN,130) NIT, SIG, F
  130 FORMAT (1X,3X,I2,' -- SIG = ',E15.8,', F = ',
     .        E15.8)
      IF (F0*F .LT. 0.) THEN
C
C   F0*F < 0.  Update (SNEG,FNEG) to (SG0,F0) so that F
C     and FNEG always have opposite signs.  If SIG is closer
C     to SNEG than SG0 and abs(F) < abs(FNEG), then swap
C     (SNEG,FNEG) with (SG0,F0).
C
        T1 = DMAX
        T2 = FNEG
        DMAX = DSIG
        FNEG = F0
        IF ( ABS(DSIG) .GT. ABS(T1)  .AND.
     .       ABS(F) .LT. ABS(T2) ) THEN
C
          DSIG = T1
          F0 = T2
        ENDIF
      ENDIF
C
C   Test for convergence.
C
      STOL = RTOL*SIG
      IF (ABS(DMAX) .LE. STOL  .OR.  (F .GE. 0.  .AND.
     .    F .LE. FTOL)  .OR.  ABS(F) .LE. RTOL) GO TO 10
      IF (F0*F .LT. 0.  .OR.  ABS(F) .LT. ABS(F0)) GO TO 8
C
C   F*F0 > 0 and the new estimate would be outside of the
C     bracketing interval of length abs(DMAX).  Reset
C     (SG0,F0) to (SNEG,FNEG).
C
    7 DSIG = DMAX
      F0 = FNEG
C
C   Compute the change in SIG by linear interpolation
C     between (SG0,F0) and (SIG,F).
C
    8 DSIG = -F*DSIG/(F-F0)
      IF (LUN .GE. 0) WRITE (LUN,140) DSIG
  140 FORMAT (1X,8X,'DSIG = ',E15.8)
      IF ( ABS(DSIG) .GT. ABS(DMAX)  .OR.
     .     DSIG*DMAX .GT. 0. ) GO TO 7
C
C   Restrict the step-size such that abs(DSIG) .GE. STOL/2.
C     Note that DSIG and DMAX have opposite signs.
C
      IF (ABS(DSIG) .LT. STOL/2.) DSIG = -SIGN(STOL/2.,DMAX)
C
C   Bottom of loop:  update SIG, DMAX, and F0.
C
      SIG = SIG + DSIG
      DMAX = DMAX + DSIG
      F0 = F
      GO TO 6
C
C No errors encountered.
C
   10 CSSIG1 = SIG
      IF (IFLGS .LE. 0) RETURN
      SIGMA(LP1) = SIG
      SIGMA(LP2) = SIG
      RETURN
C
C Error termination.
C
   11 CSSIG1 = -1.
      RETURN
      END

C
C $Id: qsfndp.f,v 1.5 2008-07-27 00:17:12 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      DOUBLE PRECISION FUNCTION QSFNDP (ECCENT,SINPHI,COSPHI)
C
C FUNCTION TO COMPUTE CONSTANT (SMALL Q).
C
      IMPLICIT DOUBLE PRECISION (A-Z)
      DATA HALF,ONE,TWO /0.5D0,1.0D0,2.0D0/
      DATA EPSLN /1.0D-7/
C
      IF (ECCENT .LT. EPSLN) GO TO 020
      CON = ECCENT * SINPHI
      QSFNDP = (ONE - ECCENT * ECCENT) * (SINPHI / (ONE - CON * CON) -
     .         (HALF / ECCENT) * LOG ((ONE - CON) / (ONE + CON)))
      RETURN
C
  020 QSFNDP = TWO * SINPHI
      RETURN
      END

C
C	$Id: gwiflb.f,v 1.4 2008-07-27 00:21:07 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GWIFLB(GKSERR)
C
C  Write the record out to the disk.
C
C  OUTPUT
C    GKSERR -- The error status flag.
C
C  All data is type INTEGER unless otherwise indicated.
C
      IMPLICIT INTEGER (A-Z)
C
      include 'gwiio.h'
C
      DIMENSION  FLAGS(12)
      CHARACTER*1 DNAME
C
      SAVE
C
C  Initialize flags array.
C
      DATA FLAGS( 1),FLAGS( 2),FLAGS( 3),FLAGS( 4)/0,0,0,0/
      DATA FLAGS( 5),FLAGS( 6),FLAGS( 7),FLAGS( 8)/0,0,0,0/
      DATA FLAGS( 9),FLAGS(10),FLAGS(11),FLAGS(12)/0,0,0,0/
C
C  Define the buffer reset point.
C
      DATA BFREST/32/
C
C  Set the bit length for id part of a record, the number of bits per
C  byte, the field size for the record bit start for the record byte
C  length and the field size for the record byte length.
C
      DATA IDLEN,BYTSIZ,SIZST,SIZSZ/32,8,0,16/
C
C  Set the data type start bit in record, the data type length ,
C  the new frame bit start bit, the new frame length.
C
      DATA MDTST,MDTSZ,MNFST,MNFSZ/16,4,20,1/
C
C  Enter the byte count.
C
      BCOUNT = (WBFPOS - IDLEN) / BYTSIZ
C
C  If the byte count is odd, then the final CGM element has an odd byte
C  count, so we should add a byte for the pad byte.
C
      IF (MOD(BCOUNT,2) .EQ. 1) THEN
        BCOUNT = BCOUNT+1
      ENDIF
C
C  Return if nothing is in the buffer.
C
      IF (BCOUNT .LE. 0) RETURN
      CALL SBYTES(WOUTBF,BCOUNT,SIZST,SIZSZ,0,1)
C
C  Enter the data type ID.
C
      CALL SBYTES(WOUTBF,WDTYPE,MDTST,MDTSZ,0,1)
C
C  All metafile flags are zero.
C
      CALL SBYTES(WOUTBF,FLAGS,MNFST,MNFSZ,0,12)
C
C  Write out the record.
C
C     MRCNMO = MRECNM
C     MRECNM = WRECNM
      CALL G01MIO (3, WSSLUN, DNAME, WOUTBF, WOBFSZ, GKSERR)
      WRECNM = WRECNM + 1
C     MRECNM = MRCNMO
C
C  Reset the record pointer.
C
      WBFPOS = BFREST
C
      RETURN
C
      END

C
C	$Id: csintrc0.f,v 1.6 2008-07-27 03:10:07 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CSINTRC0 (N,PLAT,PLON,X,Y,Z,W,LIST,LPTR,
     .                   LEND, IST, PW,IER)
      INTEGER N, LIST(*), LPTR(*), LEND(N), IST, IER
      DOUBLE PRECISION PLAT, PLON, X(N), Y(N), Z(N), W(N),
     .                 PW
C
C***********************************************************
C
C                                              From SSRFPACK
C                                            Robert J. Renka
C                                  Dept. of Computer Science
C                                       Univ. of North Texas
C                                           renka@cs.unt.edu
C                                                   11/30/99
C
C   Given a triangulation of a set of nodes on the unit
C sphere, along with data values at the nodes, this sub-
C routine computes the value at a point P of a continuous
C function which interpolates the data values.  The interp-
C olatory function is linear on each underlying triangle
C (planar triangle with the same vertices as a spherical
C triangle).  If P is not contained in a triangle, an ex-
C trapolated value is taken to be the interpolated value at
C the nearest point of the triangulation boundary.
C
C On input:
C
C       N = Number of nodes in the triangulation.  N .GE. 3.
C
C       PLAT,PLON = Latitude and longitude of P in radians.
C
C       X,Y,Z = Arrays containing Cartesian coordinates of
C               the nodes.
C
C       W = Array containing data values at the nodes.  W(I)
C           is associated with (X(I),Y(I),Z(I)) for I =
C           1,...,N.
C
C       LIST,LPTR,LEND = Data structure defining the trian-
C                        gulation.  Refer to STRIPACK
C                        Subroutine CSTRMESH.
C
C       IST = Index of the starting node in the search for a
C             triangle containing P.  1 .LE. IST .LE. N.
C             The output value of IST from a previous call
C             may be a good choice.
C
C Input parameters other than IST are not altered by this
C   routine.
C
C On output:
C
C       IST = Index of one of the vertices of the triangle
C             containing P (or nearest P) unless IER = -1
C             or IER = -2.
C
C       PW = Value of the interpolatory function at P if
C            IER .GE. 0.
C
C       IER = Error indicator:
C             IER = 0 if interpolation was performed
C                     successfully.
C             IER = 1 if extrapolation was performed
C                     successfully.
C             IER = -1 if N < 3 or IST is outside its valid
C                      range.
C             IER = -2 if the nodes are collinear.
C             IER = -3 if P is not in a triangle and the
C                      angle between P and the nearest boun-
C                      dary point is at least 90 degrees.
C
C STRIPACK modules required by CSINTRC0:  CSJRAND, CSLSTPTR,
C                                         CSSTORE, CSTRFIND
C
C Intrinsic functions called by CSINTRC0:  COS, SIN
C
C***********************************************************
C
      INTEGER I1, I2, I3, LP, N1, N2
      DOUBLE PRECISION B1, B2, B3, P(3), PTN1, PTN2, S12,
     .                 SUM
C
C Local parameters:
C
C B1,B2,B3 = Barycentric coordinates of the central projec-
C              tion of P onto the underlying planar trian-
C              gle, or (B1 and B2) projection of Q onto the
C              underlying line segment N1-N2 when P is
C              exterior.  Unnormalized coordinates are
C              computed by CSTRFIND when P is in a triangle.
C I1,I2,I3 = Vertex indexes returned by CSTRFIND
C LP =       LIST pointer to N1 as a neighbor of N2 or N2
C              as a neighbor of N1
C N1,N2 =    Endpoints of a boundary arc which is visible
C              from P when P is not contained in a triangle
C P =        Cartesian coordinates of P
C PTN1 =     Scalar product (P,N1)
C PTN2 =     Scalar product (P,N2)
C S12 =      Scalar product (N1,N2)
C SUM =      Quantity used to normalize the barycentric
C              coordinates
C
      IF (N .LT. 3  .OR.  IST .LT. 1  .OR.  IST .GT. N)
     .    GO TO 11
C
C Transform (PLAT,PLON) to Cartesian coordinates.
C
      P(1) = COS(PLAT)*COS(PLON)
      P(2) = COS(PLAT)*SIN(PLON)
      P(3) = SIN(PLAT)
C
C Find the vertex indexes of a triangle containing P.
C
      CALL CSTRFIND(IST,P,N,X,Y,Z,LIST,LPTR,LEND, B1,B2,B3,
     .            I1,I2,I3)
      IF (I1 .EQ. 0) GO TO 12
      IST = I1
      IF (I3 .NE. 0) THEN
C
C P is contained in the triangle (I1,I2,I3).  Normalize the
C   barycentric coordinates.
C
        SUM = B1 + B2 + B3
        PW = (B1*W(I1) + B2*W(I2) + B3*W(I3))/SUM
        IER = 0
        RETURN
      ENDIF
C
C P is exterior to the triangulation, and I1 and I2 are
C   boundary nodes which are visible from P.  Set PW to the
C   interpolated value at Q, where Q is the closest boundary
C   point to P.
C
C Traverse the boundary starting from the rightmost visible
C   node I1.
C
      N1 = I1
      PTN1 = P(1)*X(N1) + P(2)*Y(N1) + P(3)*Z(N1)
      IF (I1 .NE. I2) GO TO 2
C
C All boundary nodes are visible from P.  Find a boundary
C   arc N1->N2 such that P Left (N2 X N1)->N1.
C
C Counterclockwise boundary traversal:
C   Set N2 to the first neighbor of N1.
C
    1 LP = LEND(N1)
        LP = LPTR(LP)
        N2 = LIST(LP)
C
C Compute inner products (N1,N2) and (P,N2), and compute
C   B2 = DET(P,N1,N2 X N1).
C
        S12 = X(N1)*X(N2) + Y(N1)*Y(N2) + Z(N1)*Z(N2)
        PTN2 = P(1)*X(N2) + P(2)*Y(N2) + P(3)*Z(N2)
        B2 = PTN2 - S12*PTN1
        IF (B2 .LE. 0.) GO TO 2
C
C P Right (N2 X N1)->N1 -- Iterate.
C
        N1 = N2
        I1 = N1
        PTN1 = PTN2
        GO TO 1
C
C P Left (N2 X N1)->N1, where N2 is the first neighbor of P1.
C   Clockwise boundary traversal:
C
    2 N2 = N1
        PTN2 = PTN1
C
C Set N1 to the last neighbor of N2 and test for
C   termination.
C
        LP = LEND(N2)
        N1 = -LIST(LP)
        IF (N1 .EQ. I1) GO TO 13
C
C Compute inner products (N1,N2) and (P,N1).
C
        S12 = X(N1)*X(N2) + Y(N1)*Y(N2) + Z(N1)*Z(N2)
        PTN1 = P(1)*X(N1) + P(2)*Y(N1) + P(3)*Z(N1)
C
C Compute B2 = DET(P,N1,N2 X N1) = DET(Q,N1,N2 X N1)*(P,Q).
C
        B2 = PTN2 - S12*PTN1
        IF (B2 .LE. 0.) GO TO 2
C
C Compute B1 = DET(P,N2 X N1,N2) = DET(Q,N2 X N1,N2)*(P,Q).
C
      B1 = PTN1 - S12*PTN2
      IF (B1 .LE. 0.) THEN
C
C Q = N2.
C
        PW = W(N2)
      ELSE
C
C P Strictly Left (N2 X N1)->N2 and P Strictly Left
C   N1->(N2 X N1).  Thus Q lies on the interior of N1->N2.
C   Normalize the coordinates and compute PW.
C
        SUM = B1 + B2
        PW = (B1*W(N1) + B2*W(N2))/SUM
      ENDIF
      IER = 1
      RETURN
C
C N or IST is outside its valid range.
C
   11 IER = -1
      RETURN
C
C Collinear nodes.
C
   12 IER = -2
      RETURN
C
C The angular distance between P and the closest boundary
C   point to P is at least 90 degrees.
C
   13 IER = -3
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C


      SUBROUTINE SCM0   (PDL,PDR,PFL,PFR,KLG)
C
C---->
C**** SCM0   - Apply SCM0 limiter to derivative estimates.
C
C    M. HORTAL    ECMWF February 1991  closely following D. WILLIAMSON
C
C    Apply SCM0 limiter to derivative estimates.
C
C   output:
C     pdl   = the limited derivative at the left edge of the interval
C     pdr   = the limited derivative at the right edge of the interval
C
C   inputs
C     pdl   = the original derivative at the left edge
C     pdr   = the original derivative at the right edge
C     pfl   = function value at the left edge of the interval
C     pfr   = function value at the right edge of the interval
C     klg  = number of intervals where the derivatives are limited
C
C----<
      INTEGER KLG
C
      REAL PDL(KLG), PDR(KLG), PFL(KLG), PFR(KLG)
C
      INTEGER JL
C      
      REAL ZALPHA, ZBETA, ZEPS, ZFAC
C
  100 CONTINUE
C
C    define constants
C
      ZEPS=1.E-12
      ZFAC=3.*(1.-ZEPS)
C
      DO 200 JL=1,KLG
      IF(ABS(PFR(JL)-PFL(JL)).GT.ZEPS) THEN
          ZALPHA=PDL(JL)/(PFR(JL)-PFL(JL))
          ZBETA =PDR(JL)/(PFR(JL)-PFL(JL))
          IF(ZALPHA.LE.0.) PDL(JL)=0.
          IF(ZBETA .LE.0.) PDR(JL)=0.
          IF(ZALPHA.GT.ZFAC) PDL(JL)=ZFAC*(PFR(JL)-PFL(JL))
          IF(ZBETA .GT.ZFAC) PDR(JL)=ZFAC*(PFR(JL)-PFL(JL))
      ELSE
          PDL(JL)=0.
          PDR(JL)=0.
      ENDIF
  200 CONTINUE
      END

      SUBROUTINE ZGBMV ( TRANS, M, N, KL, KU, ALPHA, A, LDA, X, INCX,
     $                   BETA, Y, INCY )
*     .. Scalar Arguments ..
      COMPLEX*16         ALPHA, BETA
      INTEGER            INCX, INCY, KL, KU, LDA, M, N
      CHARACTER*1        TRANS
*     .. Array Arguments ..
      COMPLEX*16         A( LDA, * ), X( * ), Y( * )
*     ..
*
*  Purpose
*  =======
*
*  ZGBMV  performs one of the matrix-vector operations
*
*     y := alpha*A*x + beta*y,   or   y := alpha*A'*x + beta*y,   or
*
*     y := alpha*conjg( A' )*x + beta*y,
*
*  where alpha and beta are scalars, x and y are vectors and A is an
*  m by n band matrix, with kl sub-diagonals and ku super-diagonals.
*
*  Parameters
*  ==========
*
*  TRANS  - CHARACTER*1.
*           On entry, TRANS specifies the operation to be performed as
*           follows:
*
*              TRANS = 'N' or 'n'   y := alpha*A*x + beta*y.
*
*              TRANS = 'T' or 't'   y := alpha*A'*x + beta*y.
*
*              TRANS = 'C' or 'c'   y := alpha*conjg( A' )*x + beta*y.
*
*           Unchanged on exit.
*
*  M      - INTEGER.
*           On entry, M specifies the number of rows of the matrix A.
*           M must be at least zero.
*           Unchanged on exit.
*
*  N      - INTEGER.
*           On entry, N specifies the number of columns of the matrix A.
*           N must be at least zero.
*           Unchanged on exit.
*
*  KL     - INTEGER.
*           On entry, KL specifies the number of sub-diagonals of the
*           matrix A. KL must satisfy  0 .le. KL.
*           Unchanged on exit.
*
*  KU     - INTEGER.
*           On entry, KU specifies the number of super-diagonals of the
*           matrix A. KU must satisfy  0 .le. KU.
*           Unchanged on exit.
*
*  ALPHA  - COMPLEX*16      .
*           On entry, ALPHA specifies the scalar alpha.
*           Unchanged on exit.
*
*  A      - COMPLEX*16       array of DIMENSION ( LDA, n ).
*           Before entry, the leading ( kl + ku + 1 ) by n part of the
*           array A must contain the matrix of coefficients, supplied
*           column by column, with the leading diagonal of the matrix in
*           row ( ku + 1 ) of the array, the first super-diagonal
*           starting at position 2 in row ku, the first sub-diagonal
*           starting at position 1 in row ( ku + 2 ), and so on.
*           Elements in the array A that do not correspond to elements
*           in the band matrix (such as the top left ku by ku triangle)
*           are not referenced.
*           The following program segment will transfer a band matrix
*           from conventional full matrix storage to band storage:
*
*                 DO 20, J = 1, N
*                    K = KU + 1 - J
*                    DO 10, I = MAX( 1, J - KU ), MIN( M, J + KL )
*                       A( K + I, J ) = matrix( I, J )
*              10    CONTINUE
*              20 CONTINUE
*
*           Unchanged on exit.
*
*  LDA    - INTEGER.
*           On entry, LDA specifies the first dimension of A as declared
*           in the calling (sub) program. LDA must be at least
*           ( kl + ku + 1 ).
*           Unchanged on exit.
*
*  X      - COMPLEX*16       array of DIMENSION at least
*           ( 1 + ( n - 1 )*abs( INCX ) ) when TRANS = 'N' or 'n'
*           and at least
*           ( 1 + ( m - 1 )*abs( INCX ) ) otherwise.
*           Before entry, the incremented array X must contain the
*           vector x.
*           Unchanged on exit.
*
*  INCX   - INTEGER.
*           On entry, INCX specifies the increment for the elements of
*           X. INCX must not be zero.
*           Unchanged on exit.
*
*  BETA   - COMPLEX*16      .
*           On entry, BETA specifies the scalar beta. When BETA is
*           supplied as zero then Y need not be set on input.
*           Unchanged on exit.
*
*  Y      - COMPLEX*16       array of DIMENSION at least
*           ( 1 + ( m - 1 )*abs( INCY ) ) when TRANS = 'N' or 'n'
*           and at least
*           ( 1 + ( n - 1 )*abs( INCY ) ) otherwise.
*           Before entry, the incremented array Y must contain the
*           vector y. On exit, Y is overwritten by the updated vector y.
*
*
*  INCY   - INTEGER.
*           On entry, INCY specifies the increment for the elements of
*           Y. INCY must not be zero.
*           Unchanged on exit.
*
*
*  Level 2 Blas routine.
*
*  -- Written on 22-October-1986.
*     Jack Dongarra, Argonne National Lab.
*     Jeremy Du Croz, Nag Central Office.
*     Sven Hammarling, Nag Central Office.
*     Richard Hanson, Sandia National Labs.
*
*
*     .. Parameters ..
      COMPLEX*16         ONE
      PARAMETER        ( ONE  = ( 1.0D+0, 0.0D+0 ) )
      COMPLEX*16         ZERO
      PARAMETER        ( ZERO = ( 0.0D+0, 0.0D+0 ) )
*     .. Local Scalars ..
      COMPLEX*16         TEMP
      INTEGER            I, INFO, IX, IY, J, JX, JY, K, KUP1, KX, KY,
     $                   LENX, LENY
      LOGICAL            NOCONJ
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     .. External Subroutines ..
      EXTERNAL           XERBLA
*     .. Intrinsic Functions ..
      INTRINSIC          DCONJG, MAX, MIN
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      IF     ( .NOT.LSAME( TRANS, 'N' ).AND.
     $         .NOT.LSAME( TRANS, 'T' ).AND.
     $         .NOT.LSAME( TRANS, 'C' )      )THEN
         INFO = 1
      ELSE IF( M.LT.0 )THEN
         INFO = 2
      ELSE IF( N.LT.0 )THEN
         INFO = 3
      ELSE IF( KL.LT.0 )THEN
         INFO = 4
      ELSE IF( KU.LT.0 )THEN
         INFO = 5
      ELSE IF( LDA.LT.( KL + KU + 1 ) )THEN
         INFO = 8
      ELSE IF( INCX.EQ.0 )THEN
         INFO = 10
      ELSE IF( INCY.EQ.0 )THEN
         INFO = 13
      END IF
      IF( INFO.NE.0 )THEN
         CALL XERBLA( 'ZGBMV ', INFO )
         RETURN
      END IF
*
*     Quick return if possible.
*
      IF( ( M.EQ.0 ).OR.( N.EQ.0 ).OR.
     $    ( ( ALPHA.EQ.ZERO ).AND.( BETA.EQ.ONE ) ) )
     $   RETURN
*
      NOCONJ = LSAME( TRANS, 'T' )
*
*     Set  LENX  and  LENY, the lengths of the vectors x and y, and set
*     up the start points in  X  and  Y.
*
      IF( LSAME( TRANS, 'N' ) )THEN
         LENX = N
         LENY = M
      ELSE
         LENX = M
         LENY = N
      END IF
      IF( INCX.GT.0 )THEN
         KX = 1
      ELSE
         KX = 1 - ( LENX - 1 )*INCX
      END IF
      IF( INCY.GT.0 )THEN
         KY = 1
      ELSE
         KY = 1 - ( LENY - 1 )*INCY
      END IF
*
*     Start the operations. In this version the elements of A are
*     accessed sequentially with one pass through the band part of A.
*
*     First form  y := beta*y.
*
      IF( BETA.NE.ONE )THEN
         IF( INCY.EQ.1 )THEN
            IF( BETA.EQ.ZERO )THEN
               DO 10, I = 1, LENY
                  Y( I ) = ZERO
   10          CONTINUE
            ELSE
               DO 20, I = 1, LENY
                  Y( I ) = BETA*Y( I )
   20          CONTINUE
            END IF
         ELSE
            IY = KY
            IF( BETA.EQ.ZERO )THEN
               DO 30, I = 1, LENY
                  Y( IY ) = ZERO
                  IY      = IY   + INCY
   30          CONTINUE
            ELSE
               DO 40, I = 1, LENY
                  Y( IY ) = BETA*Y( IY )
                  IY      = IY           + INCY
   40          CONTINUE
            END IF
         END IF
      END IF
      IF( ALPHA.EQ.ZERO )
     $   RETURN
      KUP1 = KU + 1
      IF( LSAME( TRANS, 'N' ) )THEN
*
*        Form  y := alpha*A*x + y.
*
         JX = KX
         IF( INCY.EQ.1 )THEN
            DO 60, J = 1, N
               IF( X( JX ).NE.ZERO )THEN
                  TEMP = ALPHA*X( JX )
                  K    = KUP1 - J
                  DO 50, I = MAX( 1, J - KU ), MIN( M, J + KL )
                     Y( I ) = Y( I ) + TEMP*A( K + I, J )
   50             CONTINUE
               END IF
               JX = JX + INCX
   60       CONTINUE
         ELSE
            DO 80, J = 1, N
               IF( X( JX ).NE.ZERO )THEN
                  TEMP = ALPHA*X( JX )
                  IY   = KY
                  K    = KUP1 - J
                  DO 70, I = MAX( 1, J - KU ), MIN( M, J + KL )
                     Y( IY ) = Y( IY ) + TEMP*A( K + I, J )
                     IY      = IY      + INCY
   70             CONTINUE
               END IF
               JX = JX + INCX
               IF( J.GT.KU )
     $            KY = KY + INCY
   80       CONTINUE
         END IF
      ELSE
*
*        Form  y := alpha*A'*x + y  or  y := alpha*conjg( A' )*x + y.
*
         JY = KY
         IF( INCX.EQ.1 )THEN
            DO 110, J = 1, N
               TEMP = ZERO
               K    = KUP1 - J
               IF( NOCONJ )THEN
                  DO 90, I = MAX( 1, J - KU ), MIN( M, J + KL )
                     TEMP = TEMP + A( K + I, J )*X( I )
   90             CONTINUE
               ELSE
                  DO 100, I = MAX( 1, J - KU ), MIN( M, J + KL )
                     TEMP = TEMP + DCONJG( A( K + I, J ) )*X( I )
  100             CONTINUE
               END IF
               Y( JY ) = Y( JY ) + ALPHA*TEMP
               JY      = JY      + INCY
  110       CONTINUE
         ELSE
            DO 140, J = 1, N
               TEMP = ZERO
               IX   = KX
               K    = KUP1 - J
               IF( NOCONJ )THEN
                  DO 120, I = MAX( 1, J - KU ), MIN( M, J + KL )
                     TEMP = TEMP + A( K + I, J )*X( IX )
                     IX   = IX   + INCX
  120             CONTINUE
               ELSE
                  DO 130, I = MAX( 1, J - KU ), MIN( M, J + KL )
                     TEMP = TEMP + DCONJG( A( K + I, J ) )*X( IX )
                     IX   = IX   + INCX
  130             CONTINUE
               END IF
               Y( JY ) = Y( JY ) + ALPHA*TEMP
               JY      = JY      + INCY
               IF( J.GT.KU )
     $            KX = KX + INCX
  140       CONTINUE
         END IF
      END IF
*
      RETURN
*
*     End of ZGBMV .
*
      END

C
C $Id: rbglen.f,v 1.12 2008-09-18 00:42:18 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      DOUBLE PRECISION FUNCTION RBGLEN (RLAT)
C
        DOUBLE PRECISION RLAT
C
C The value of RBGLEN(RLAT) is the length of the parallel at latitude
C RLAT, stated as a fraction of the length of the equator.
C
C Declare local variables.
C
        DOUBLE PRECISION FLAT,PLEN(19)
C
        INTEGER          ILAT
C
C Define the contents of PLEN per the definition of the Robinson
C projection.  The values are associated with values of latitude from
C 0 North to 90 North at five-degree intervals.
C
        DATA PLEN( 1) / 1.0000D0 /
        DATA PLEN( 2) / 0.9986D0 /
        DATA PLEN( 3) / 0.9954D0 /
        DATA PLEN( 4) / 0.9900D0 /
        DATA PLEN( 5) / 0.9822D0 /
        DATA PLEN( 6) / 0.9730D0 /
        DATA PLEN( 7) / 0.9600D0 /
        DATA PLEN( 8) / 0.9427D0 /
        DATA PLEN( 9) / 0.9216D0 /
        DATA PLEN(10) / 0.8962D0 /
        DATA PLEN(11) / 0.8679D0 /
        DATA PLEN(12) / 0.8350D0 /
        DATA PLEN(13) / 0.7986D0 /
        DATA PLEN(14) / 0.7597D0 /
        DATA PLEN(15) / 0.7186D0 /
        DATA PLEN(16) / 0.6732D0 /
        DATA PLEN(17) / 0.6213D0 /
        DATA PLEN(18) / 0.5722D0 /
        DATA PLEN(19) / 0.5322D0 /
C
C Determine where the parallel of interest lies relative to the ones
C represented in the tables (between the ones associated with elements
C ILAT and ILAT+1 and a fractional distance FLAT from the former to the
C latter).
C
        ILAT=MAX(1,MIN(18,INT(1.D0+ABS(RLAT)/5.D0)))
C
        FLAT=1.D0+ABS(RLAT)/5.D0-DBLE(ILAT)
C
C Return the desired value.
C
        RBGLEN=(1.D0-FLAT)*PLEN(ILAT)+FLAT*PLEN(ILAT+1)
C
C Done.
C
        RETURN
C
      END

      SUBROUTINE DLAHQR( WANTT, WANTZ, N, ILO, IHI, H, LDH, WR, WI,
     $                   ILOZ, IHIZ, Z, LDZ, INFO )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      LOGICAL            WANTT, WANTZ
      INTEGER            IHI, IHIZ, ILO, ILOZ, INFO, LDH, LDZ, N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   H( LDH, * ), WI( * ), WR( * ), Z( LDZ, * )
*     ..
*
*  Purpose
*  =======
*
*  DLAHQR is an auxiliary routine called by DHSEQR to update the
*  eigenvalues and Schur decomposition already computed by DHSEQR, by
*  dealing with the Hessenberg submatrix in rows and columns ILO to IHI.
*
*  Arguments
*  =========
*
*  WANTT   (input) LOGICAL
*          = .TRUE. : the full Schur form T is required;
*          = .FALSE.: only eigenvalues are required.
*
*  WANTZ   (input) LOGICAL
*          = .TRUE. : the matrix of Schur vectors Z is required;
*          = .FALSE.: Schur vectors are not required.
*
*  N       (input) INTEGER
*          The order of the matrix H.  N >= 0.
*
*  ILO     (input) INTEGER
*  IHI     (input) INTEGER
*          It is assumed that H is already upper quasi-triangular in
*          rows and columns IHI+1:N, and that H(ILO,ILO-1) = 0 (unless
*          ILO = 1). DLAHQR works primarily with the Hessenberg
*          submatrix in rows and columns ILO to IHI, but applies
*          transformations to all of H if WANTT is .TRUE..
*          1 <= ILO <= max(1,IHI); IHI <= N.
*
*  H       (input/output) DOUBLE PRECISION array, dimension (LDH,N)
*          On entry, the upper Hessenberg matrix H.
*          On exit, if WANTT is .TRUE., H is upper quasi-triangular in
*          rows and columns ILO:IHI, with any 2-by-2 diagonal blocks in
*          standard form. If WANTT is .FALSE., the contents of H are
*          unspecified on exit.
*
*  LDH     (input) INTEGER
*          The leading dimension of the array H. LDH >= max(1,N).
*
*  WR      (output) DOUBLE PRECISION array, dimension (N)
*  WI      (output) DOUBLE PRECISION array, dimension (N)
*          The real and imaginary parts, respectively, of the computed
*          eigenvalues ILO to IHI are stored in the corresponding
*          elements of WR and WI. If two eigenvalues are computed as a
*          complex conjugate pair, they are stored in consecutive
*          elements of WR and WI, say the i-th and (i+1)th, with
*          WI(i) > 0 and WI(i+1) < 0. If WANTT is .TRUE., the
*          eigenvalues are stored in the same order as on the diagonal
*          of the Schur form returned in H, with WR(i) = H(i,i), and, if
*          H(i:i+1,i:i+1) is a 2-by-2 diagonal block,
*          WI(i) = sqrt(H(i+1,i)*H(i,i+1)) and WI(i+1) = -WI(i).
*
*  ILOZ    (input) INTEGER
*  IHIZ    (input) INTEGER
*          Specify the rows of Z to which transformations must be
*          applied if WANTZ is .TRUE..
*          1 <= ILOZ <= ILO; IHI <= IHIZ <= N.
*
*  Z       (input/output) DOUBLE PRECISION array, dimension (LDZ,N)
*          If WANTZ is .TRUE., on entry Z must contain the current
*          matrix Z of transformations accumulated by DHSEQR, and on
*          exit Z has been updated; transformations are applied only to
*          the submatrix Z(ILOZ:IHIZ,ILO:IHI).
*          If WANTZ is .FALSE., Z is not referenced.
*
*  LDZ     (input) INTEGER
*          The leading dimension of the array Z. LDZ >= max(1,N).
*
*  INFO    (output) INTEGER
*          = 0: successful exit
*          > 0: DLAHQR failed to compute all the eigenvalues ILO to IHI
*               in a total of 30*(IHI-ILO+1) iterations; if INFO = i,
*               elements i+1:ihi of WR and WI contain those eigenvalues
*               which have been successfully computed.
*
*  Further Details
*  ===============
*
*  2-96 Based on modifications by
*     David Day, Sandia National Laboratory, USA
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO, ONE, HALF
      PARAMETER          ( ZERO = 0.0D+0, ONE = 1.0D+0, HALF = 0.5D0 )
      DOUBLE PRECISION   DAT1, DAT2
      PARAMETER          ( DAT1 = 0.75D+0, DAT2 = -0.4375D+0 )
*     ..
*     .. Local Scalars ..
      INTEGER            I, I1, I2, ITN, ITS, J, K, L, M, NH, NR, NZ
      DOUBLE PRECISION   AVE, CS, DISC, H00, H10, H11, H12, H21, H22,
     $                   H33, H33S, H43H34, H44, H44S, OVFL, S, SMLNUM,
     $                   SN, SUM, T1, T2, T3, TST1, ULP, UNFL, V1, V2,
     $                   V3
*     ..
*     .. Local Arrays ..
      DOUBLE PRECISION   V( 3 ), WORK( 1 )
*     ..
*     .. External Functions ..
      DOUBLE PRECISION   DLAMCH, DLANHS
      EXTERNAL           DLAMCH, DLANHS
*     ..
*     .. External Subroutines ..
      EXTERNAL           DCOPY, DLANV2, DLARFG, DROT
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, MAX, MIN, SIGN, SQRT
*     ..
*     .. Executable Statements ..
*
      INFO = 0
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
      IF( ILO.EQ.IHI ) THEN
         WR( ILO ) = H( ILO, ILO )
         WI( ILO ) = ZERO
         RETURN
      END IF
*
      NH = IHI - ILO + 1
      NZ = IHIZ - ILOZ + 1
*
*     Set machine-dependent constants for the stopping criterion.
*     If norm(H) <= sqrt(OVFL), overflow should not occur.
*
      UNFL = DLAMCH( 'Safe minimum' )
      OVFL = ONE / UNFL
      CALL DLABAD( UNFL, OVFL )
      ULP = DLAMCH( 'Precision' )
      SMLNUM = UNFL*( NH / ULP )
*
*     I1 and I2 are the indices of the first row and last column of H
*     to which transformations must be applied. If eigenvalues only are
*     being computed, I1 and I2 are set inside the main loop.
*
      IF( WANTT ) THEN
         I1 = 1
         I2 = N
      END IF
*
*     ITN is the total number of QR iterations allowed.
*
      ITN = 30*NH
*
*     The main loop begins here. I is the loop index and decreases from
*     IHI to ILO in steps of 1 or 2. Each iteration of the loop works
*     with the active submatrix in rows and columns L to I.
*     Eigenvalues I+1 to IHI have already converged. Either L = ILO or
*     H(L,L-1) is negligible so that the matrix splits.
*
      I = IHI
   10 CONTINUE
      L = ILO
      IF( I.LT.ILO )
     $   GO TO 150
*
*     Perform QR iterations on rows and columns ILO to I until a
*     submatrix of order 1 or 2 splits off at the bottom because a
*     subdiagonal element has become negligible.
*
      DO 130 ITS = 0, ITN
*
*        Look for a single small subdiagonal element.
*
         DO 20 K = I, L + 1, -1
            TST1 = ABS( H( K-1, K-1 ) ) + ABS( H( K, K ) )
            IF( TST1.EQ.ZERO )
     $         TST1 = DLANHS( '1', I-L+1, H( L, L ), LDH, WORK )
            IF( ABS( H( K, K-1 ) ).LE.MAX( ULP*TST1, SMLNUM ) )
     $         GO TO 30
   20    CONTINUE
   30    CONTINUE
         L = K
         IF( L.GT.ILO ) THEN
*
*           H(L,L-1) is negligible
*
            H( L, L-1 ) = ZERO
         END IF
*
*        Exit from loop if a submatrix of order 1 or 2 has split off.
*
         IF( L.GE.I-1 )
     $      GO TO 140
*
*        Now the active submatrix is in rows and columns L to I. If
*        eigenvalues only are being computed, only the active submatrix
*        need be transformed.
*
         IF( .NOT.WANTT ) THEN
            I1 = L
            I2 = I
         END IF
*
         IF( ITS.EQ.10 .OR. ITS.EQ.20 ) THEN
*
*           Exceptional shift.
*
            S = ABS( H( I, I-1 ) ) + ABS( H( I-1, I-2 ) )
            H44 = DAT1*S + H( I, I )
            H33 = H44
            H43H34 = DAT2*S*S
         ELSE
*
*           Prepare to use Francis' double shift
*           (i.e. 2nd degree generalized Rayleigh quotient)
*
            H44 = H( I, I )
            H33 = H( I-1, I-1 )
            H43H34 = H( I, I-1 )*H( I-1, I )
            S = H( I-1, I-2 )*H( I-1, I-2 )
            DISC = ( H33-H44 )*HALF
            DISC = DISC*DISC + H43H34
            IF( DISC.GT.ZERO ) THEN
*
*              Real roots: use Wilkinson's shift twice
*
               DISC = SQRT( DISC )
               AVE = HALF*( H33+H44 )
               IF( ABS( H33 )-ABS( H44 ).GT.ZERO ) THEN
                  H33 = H33*H44 - H43H34
                  H44 = H33 / ( SIGN( DISC, AVE )+AVE )
               ELSE
                  H44 = SIGN( DISC, AVE ) + AVE
               END IF
               H33 = H44
               H43H34 = ZERO
            END IF
         END IF
*
*        Look for two consecutive small subdiagonal elements.
*
         DO 40 M = I - 2, L, -1
*           Determine the effect of starting the double-shift QR
*           iteration at row M, and see if this would make H(M,M-1)
*           negligible.
*
            H11 = H( M, M )
            H22 = H( M+1, M+1 )
            H21 = H( M+1, M )
            H12 = H( M, M+1 )
            H44S = H44 - H11
            H33S = H33 - H11
            V1 = ( H33S*H44S-H43H34 ) / H21 + H12
            V2 = H22 - H11 - H33S - H44S
            V3 = H( M+2, M+1 )
            S = ABS( V1 ) + ABS( V2 ) + ABS( V3 )
            V1 = V1 / S
            V2 = V2 / S
            V3 = V3 / S
            V( 1 ) = V1
            V( 2 ) = V2
            V( 3 ) = V3
            IF( M.EQ.L )
     $         GO TO 50
            H00 = H( M-1, M-1 )
            H10 = H( M, M-1 )
            TST1 = ABS( V1 )*( ABS( H00 )+ABS( H11 )+ABS( H22 ) )
            IF( ABS( H10 )*( ABS( V2 )+ABS( V3 ) ).LE.ULP*TST1 )
     $         GO TO 50
   40    CONTINUE
   50    CONTINUE
*
*        Double-shift QR step
*
         DO 120 K = M, I - 1
*
*           The first iteration of this loop determines a reflection G
*           from the vector V and applies it from left and right to H,
*           thus creating a nonzero bulge below the subdiagonal.
*
*           Each subsequent iteration determines a reflection G to
*           restore the Hessenberg form in the (K-1)th column, and thus
*           chases the bulge one step toward the bottom of the active
*           submatrix. NR is the order of G.
*
            NR = MIN( 3, I-K+1 )
            IF( K.GT.M )
     $         CALL DCOPY( NR, H( K, K-1 ), 1, V, 1 )
            CALL DLARFG( NR, V( 1 ), V( 2 ), 1, T1 )
            IF( K.GT.M ) THEN
               H( K, K-1 ) = V( 1 )
               H( K+1, K-1 ) = ZERO
               IF( K.LT.I-1 )
     $            H( K+2, K-1 ) = ZERO
            ELSE IF( M.GT.L ) THEN
               H( K, K-1 ) = -H( K, K-1 )
            END IF
            V2 = V( 2 )
            T2 = T1*V2
            IF( NR.EQ.3 ) THEN
               V3 = V( 3 )
               T3 = T1*V3
*
*              Apply G from the left to transform the rows of the matrix
*              in columns K to I2.
*
               DO 60 J = K, I2
                  SUM = H( K, J ) + V2*H( K+1, J ) + V3*H( K+2, J )
                  H( K, J ) = H( K, J ) - SUM*T1
                  H( K+1, J ) = H( K+1, J ) - SUM*T2
                  H( K+2, J ) = H( K+2, J ) - SUM*T3
   60          CONTINUE
*
*              Apply G from the right to transform the columns of the
*              matrix in rows I1 to min(K+3,I).
*
               DO 70 J = I1, MIN( K+3, I )
                  SUM = H( J, K ) + V2*H( J, K+1 ) + V3*H( J, K+2 )
                  H( J, K ) = H( J, K ) - SUM*T1
                  H( J, K+1 ) = H( J, K+1 ) - SUM*T2
                  H( J, K+2 ) = H( J, K+2 ) - SUM*T3
   70          CONTINUE
*
               IF( WANTZ ) THEN
*
*                 Accumulate transformations in the matrix Z
*
                  DO 80 J = ILOZ, IHIZ
                     SUM = Z( J, K ) + V2*Z( J, K+1 ) + V3*Z( J, K+2 )
                     Z( J, K ) = Z( J, K ) - SUM*T1
                     Z( J, K+1 ) = Z( J, K+1 ) - SUM*T2
                     Z( J, K+2 ) = Z( J, K+2 ) - SUM*T3
   80             CONTINUE
               END IF
            ELSE IF( NR.EQ.2 ) THEN
*
*              Apply G from the left to transform the rows of the matrix
*              in columns K to I2.
*
               DO 90 J = K, I2
                  SUM = H( K, J ) + V2*H( K+1, J )
                  H( K, J ) = H( K, J ) - SUM*T1
                  H( K+1, J ) = H( K+1, J ) - SUM*T2
   90          CONTINUE
*
*              Apply G from the right to transform the columns of the
*              matrix in rows I1 to min(K+3,I).
*
               DO 100 J = I1, I
                  SUM = H( J, K ) + V2*H( J, K+1 )
                  H( J, K ) = H( J, K ) - SUM*T1
                  H( J, K+1 ) = H( J, K+1 ) - SUM*T2
  100          CONTINUE
*
               IF( WANTZ ) THEN
*
*                 Accumulate transformations in the matrix Z
*
                  DO 110 J = ILOZ, IHIZ
                     SUM = Z( J, K ) + V2*Z( J, K+1 )
                     Z( J, K ) = Z( J, K ) - SUM*T1
                     Z( J, K+1 ) = Z( J, K+1 ) - SUM*T2
  110             CONTINUE
               END IF
            END IF
  120    CONTINUE
*
  130 CONTINUE
*
*     Failure to converge in remaining number of iterations
*
      INFO = I
      RETURN
*
  140 CONTINUE
*
      IF( L.EQ.I ) THEN
*
*        H(I,I-1) is negligible: one eigenvalue has converged.
*
         WR( I ) = H( I, I )
         WI( I ) = ZERO
      ELSE IF( L.EQ.I-1 ) THEN
*
*        H(I-1,I-2) is negligible: a pair of eigenvalues have converged.
*
*        Transform the 2-by-2 submatrix to standard Schur form,
*        and compute and store the eigenvalues.
*
         CALL DLANV2( H( I-1, I-1 ), H( I-1, I ), H( I, I-1 ),
     $                H( I, I ), WR( I-1 ), WI( I-1 ), WR( I ), WI( I ),
     $                CS, SN )
*
         IF( WANTT ) THEN
*
*           Apply the transformation to the rest of H.
*
            IF( I2.GT.I )
     $         CALL DROT( I2-I, H( I-1, I+1 ), LDH, H( I, I+1 ), LDH,
     $                    CS, SN )
            CALL DROT( I-I1-1, H( I1, I-1 ), 1, H( I1, I ), 1, CS, SN )
         END IF
         IF( WANTZ ) THEN
*
*           Apply the transformation to Z.
*
            CALL DROT( NZ, Z( ILOZ, I-1 ), 1, Z( ILOZ, I ), 1, CS, SN )
         END IF
      END IF
*
*     Decrement number of remaining iterations, and return to start of
*     the main loop with new value of I.
*
      ITN = ITN - ITS
      I = L - 1
      GO TO 10
*
  150 CONTINUE
      RETURN
*
*     End of DLAHQR
*
      END

C
C $Id: tdsort.f,v 1.5 2008-07-27 00:17:33 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE TDSORT (RWRK,NRWK,IORD,IWRK)
C
        DIMENSION RWRK(NRWK),IWRK(NRWK)
C
C Given an array of NRWK reals in an array RWRK and an order flag
C IORD, this routine returns a permutation vector IWRK such that, for
C every I and J such that 1.LE.I.LE.J.LE.NRWK, if IORD is zero, then
C RWRK(IWRK(I)).LE.RWRK(IWRK(J)), else RWRK(IWRK(I)).GE.RWRK(IWRK(J)).
C
        DO 101 I=1,NRWK
          IWRK(I)=I
  101   CONTINUE
C
        K=0
C
  102   IF (3*K+1.LT.NRWK) THEN
          K=3*K+1
          GO TO 102
        END IF
C
        IF (IORD.EQ.0) THEN
C
  103     IF (K.GT.0) THEN
C
            DO 105 I=1,NRWK-K
C
              J=I
C
  104         IF (RWRK(IWRK(J)).LE.RWRK(IWRK(J+K))) GO TO 105
              ITMP=IWRK(J)
              IWRK(J)=IWRK(J+K)
              IWRK(J+K)=ITMP
              J=J-K
              IF (J.LT.1) GO TO 105
              GO TO 104
C
  105       CONTINUE
C
            K=(K-1)/3
C
            GO TO 103
C
          END IF
C
        ELSE
C
  106     IF (K.GT.0) THEN
C
            DO 108 I=1,NRWK-K
C
              J=I
C
  107         IF (RWRK(IWRK(J)).GE.RWRK(IWRK(J+K))) GO TO 108
              ITMP=IWRK(J)
              IWRK(J)=IWRK(J+K)
              IWRK(J+K)=ITMP
              J=J-K
              IF (J.LT.1) GO TO 108
              GO TO 107
C
  108       CONTINUE
C
            K=(K-1)/3
C
            GO TO 106
C
          END IF
C
        END IF
C
C Done.
C
        RETURN
C
      END

C
C $Id: ngputg.f,v 1.6 2008-07-27 00:17:18 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE NGPUTG(IFNT,PCHAR,X,Y,SIZE,ICOLOR)
C
C  Draw the glyph associated with the ASCII character CHAR from
C  font number IFNT.
C
      CHARACTER*1 PCHAR,TCHAR
C
C  Disable the function code flag since it is never used and since
C  we want to allow for plotting all printable ASCII characters.
C  Save and restore the current flag as well as the font and
C  character color.
C
      CALL PCGETC('FC',TCHAR)
      CALL PCGETI('FN',IFNTO)
      CALL PCGETI('CC',ICLRO)
C
      CALL PCSETC('FC',CHAR(30))
      CALL PCSETI('FN',IFNT) 
      CALL PCSETI('CC',ICOLOR)
      CALL PLCHHQ(X,Y,PCHAR,6.*SIZE/7.,0.,0.) 
C
      CALL PCSETC('FC',TCHAR)
      CALL PCSETI('FN',IFNTO)
      CALL PCSETI('CC',ICLRO)
C
      RETURN
      END

      SUBROUTINE SSYEVD( JOBZ, UPLO, N, A, LDA, W, WORK, LWORK, IWORK,
     $                   LIWORK, INFO )
*
*  -- LAPACK driver routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          JOBZ, UPLO
      INTEGER            INFO, LDA, LIWORK, LWORK, N
*     ..
*     .. Array Arguments ..
      INTEGER            IWORK( * )
      REAL               A( LDA, * ), W( * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  SSYEVD computes all eigenvalues and, optionally, eigenvectors of a
*  real symmetric matrix A. If eigenvectors are desired, it uses a
*  divide and conquer algorithm.
*
*  The divide and conquer algorithm makes very mild assumptions about
*  floating point arithmetic. It will work on machines with a guard
*  digit in add/subtract, or on those binary machines without guard
*  digits which subtract like the Cray X-MP, Cray Y-MP, Cray C-90, or
*  Cray-2. It could conceivably fail on hexadecimal or decimal machines
*  without guard digits, but we know of none.
*
*  Because of large use of BLAS of level 3, SSYEVD needs N**2 more
*  workspace than SSYEVX.
*
*  Arguments
*  =========
*
*  JOBZ    (input) CHARACTER*1
*          = 'N':  Compute eigenvalues only;
*          = 'V':  Compute eigenvalues and eigenvectors.
*
*  UPLO    (input) CHARACTER*1
*          = 'U':  Upper triangle of A is stored;
*          = 'L':  Lower triangle of A is stored.
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  A       (input/output) REAL array, dimension (LDA, N)
*          On entry, the symmetric matrix A.  If UPLO = 'U', the
*          leading N-by-N upper triangular part of A contains the
*          upper triangular part of the matrix A.  If UPLO = 'L',
*          the leading N-by-N lower triangular part of A contains
*          the lower triangular part of the matrix A.
*          On exit, if JOBZ = 'V', then if INFO = 0, A contains the
*          orthonormal eigenvectors of the matrix A.
*          If JOBZ = 'N', then on exit the lower triangle (if UPLO='L')
*          or the upper triangle (if UPLO='U') of A, including the
*          diagonal, is destroyed.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(1,N).
*
*  W       (output) REAL array, dimension (N)
*          If INFO = 0, the eigenvalues in ascending order.
*
*  WORK    (workspace/output) REAL array,
*                                         dimension (LWORK)
*          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*
*  LWORK   (input) INTEGER
*          The dimension of the array WORK.
*          If N <= 1,               LWORK must be at least 1.
*          If JOBZ = 'N' and N > 1, LWORK must be at least 2*N+1.
*          If JOBZ = 'V' and N > 1, LWORK must be at least 
*                                                1 + 6*N + 2*N**2.
*
*          If LWORK = -1, then a workspace query is assumed; the routine
*          only calculates the optimal size of the WORK array, returns
*          this value as the first entry of the WORK array, and no error
*          message related to LWORK is issued by XERBLA.
*
*  IWORK   (workspace/output) INTEGER array, dimension (LIWORK)
*          On exit, if INFO = 0, IWORK(1) returns the optimal LIWORK.
*
*  LIWORK  (input) INTEGER
*          The dimension of the array IWORK.
*          If N <= 1,                LIWORK must be at least 1.
*          If JOBZ  = 'N' and N > 1, LIWORK must be at least 1.
*          If JOBZ  = 'V' and N > 1, LIWORK must be at least 3 + 5*N.
*
*          If LIWORK = -1, then a workspace query is assumed; the
*          routine only calculates the optimal size of the IWORK array,
*          returns this value as the first entry of the IWORK array, and
*          no error message related to LIWORK is issued by XERBLA.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*          > 0:  if INFO = i, the algorithm failed to converge; i
*                off-diagonal elements of an intermediate tridiagonal
*                form did not converge to zero.
*
*  Further Details
*  ===============
*
*  Based on contributions by
*     Jeff Rutter, Computer Science Division, University of California
*     at Berkeley, USA
*  Modified by Francoise Tisseur, University of Tennessee.
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ZERO, ONE
      PARAMETER          ( ZERO = 0.0E+0, ONE = 1.0E+0 )
*     ..
*     .. Local Scalars ..
*
      LOGICAL            LOWER, LQUERY, WANTZ
      INTEGER            IINFO, INDE, INDTAU, INDWK2, INDWRK, ISCALE,
     $                   LIOPT, LIWMIN, LLWORK, LLWRK2, LOPT, LWMIN
      REAL               ANRM, BIGNUM, EPS, RMAX, RMIN, SAFMIN, SIGMA,
     $                   SMLNUM
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      REAL               SLAMCH, SLANSY
      EXTERNAL           LSAME, SLAMCH, SLANSY
*     ..
*     .. External Subroutines ..
      EXTERNAL           SLACPY, SLASCL, SORMTR, SSCAL, SSTEDC, SSTERF,
     $                   SSYTRD, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, SQRT
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      WANTZ = LSAME( JOBZ, 'V' )
      LOWER = LSAME( UPLO, 'L' )
      LQUERY = ( LWORK.EQ.-1 .OR. LIWORK.EQ.-1 )
*
      INFO = 0
      IF( N.LE.1 ) THEN
         LIWMIN = 1
         LWMIN = 1
         LOPT = LWMIN
         LIOPT = LIWMIN
      ELSE
         IF( WANTZ ) THEN
            LIWMIN = 3 + 5*N
            LWMIN = 1 + 6*N + 2*N**2
         ELSE
            LIWMIN = 1
            LWMIN = 2*N + 1
         END IF
         LOPT = LWMIN
         LIOPT = LIWMIN
      END IF
      IF( .NOT.( WANTZ .OR. LSAME( JOBZ, 'N' ) ) ) THEN
         INFO = -1
      ELSE IF( .NOT.( LOWER .OR. LSAME( UPLO, 'U' ) ) ) THEN
         INFO = -2
      ELSE IF( N.LT.0 ) THEN
         INFO = -3
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -5
      ELSE IF( LWORK.LT.LWMIN .AND. .NOT.LQUERY ) THEN
         INFO = -8
      ELSE IF( LIWORK.LT.LIWMIN .AND. .NOT.LQUERY ) THEN
         INFO = -10
      END IF
*
      IF( INFO.EQ.0 ) THEN
         WORK( 1 ) = LOPT
         IWORK( 1 ) = LIOPT
      END IF
*
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'SSYEVD', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         RETURN 
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
*
      IF( N.EQ.1 ) THEN
         W( 1 ) = A( 1, 1 )
         IF( WANTZ )
     $      A( 1, 1 ) = ONE
         RETURN 
      END IF
*
*     Get machine constants.
*
      SAFMIN = SLAMCH( 'Safe minimum' )
      EPS = SLAMCH( 'Precision' )
      SMLNUM = SAFMIN / EPS
      BIGNUM = ONE / SMLNUM
      RMIN = SQRT( SMLNUM )
      RMAX = SQRT( BIGNUM )
*
*     Scale matrix to allowable range, if necessary.
*
      ANRM = SLANSY( 'M', UPLO, N, A, LDA, WORK )
      ISCALE = 0
      IF( ANRM.GT.ZERO .AND. ANRM.LT.RMIN ) THEN
         ISCALE = 1
         SIGMA = RMIN / ANRM
      ELSE IF( ANRM.GT.RMAX ) THEN
         ISCALE = 1
         SIGMA = RMAX / ANRM
      END IF
      IF( ISCALE.EQ.1 )
     $   CALL SLASCL( UPLO, 0, 0, ONE, SIGMA, N, N, A, LDA, INFO )
*
*     Call SSYTRD to reduce symmetric matrix to tridiagonal form.
*
      INDE = 1
      INDTAU = INDE + N
      INDWRK = INDTAU + N
      LLWORK = LWORK - INDWRK + 1
      INDWK2 = INDWRK + N*N
      LLWRK2 = LWORK - INDWK2 + 1
*
      CALL SSYTRD( UPLO, N, A, LDA, W, WORK( INDE ), WORK( INDTAU ),
     $             WORK( INDWRK ), LLWORK, IINFO )
      LOPT = 2*N + WORK( INDWRK )
*
*     For eigenvalues only, call SSTERF.  For eigenvectors, first call
*     SSTEDC to generate the eigenvector matrix, WORK(INDWRK), of the
*     tridiagonal matrix, then call SORMTR to multiply it by the
*     Householder transformations stored in A.
*
      IF( .NOT.WANTZ ) THEN
         CALL SSTERF( N, W, WORK( INDE ), INFO )
      ELSE
         CALL SSTEDC( 'I', N, W, WORK( INDE ), WORK( INDWRK ), N,
     $                WORK( INDWK2 ), LLWRK2, IWORK, LIWORK, INFO )
         CALL SORMTR( 'L', UPLO, 'N', N, N, A, LDA, WORK( INDTAU ),
     $                WORK( INDWRK ), N, WORK( INDWK2 ), LLWRK2, IINFO )
         CALL SLACPY( 'A', N, N, WORK( INDWRK ), N, A, LDA )
         LOPT = MAX( LOPT, 1+6*N+2*N**2 )
      END IF
*
*     If matrix was scaled, then rescale eigenvalues appropriately.
*
      IF( ISCALE.EQ.1 )
     $   CALL SSCAL( N, ONE / SIGMA, W, 1 )
*
      WORK( 1 ) = LOPT
      IWORK( 1 ) = LIOPT
*
      RETURN
*
*     End of SSYEVD
*
      END

      PROGRAM TPWRZT
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C OPEN GKS, OPEN WORKSTATION OF TYPE 1, ACTIVATE WORKSTATION
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C INVOKE DEMO DRIVER
C
      CALL TPWRZT1(IERR)
C
C DEACTIVATE AND CLOSE WORKSTATION, CLOSE GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END
C
      SUBROUTINE TPWRZT1 (IERROR)
C
C PURPOSE                To provide a simple demonstration of
C                        entry PWRZT with the THREED utility.
C
C USAGE                  CALL TPWRZT1 (IERROR)
C
C ARGUMENTS
C
C ON OUTPUT              IERROR
C                          An integer variable
C                          = 0, if the test was successful,
C                          = 1, otherwise
C
C I/O                    If the test is successful, the message
C
C               PWRZT TEST EXECUTED--SEE PLOTS TO CERTIFY
C
C                        is printed on unit 6.  In addition, 1
C                        frame is produced on the machine graphics
C                        device.  In order to determine if the test
C                        was successful, it is necessary to examine
C                        the plot.
C
C PRECISION              Single
C
C REQUIRED ROUTINES      PWRZT, THREED
C
C REQUIRED GKS LEVEL     0A
C
C LANGUAGE               FORTRAN 77
C
C ALGORITHM              The THREED package is called to establish a
C                        3-D projection onto 2 space, and to draw the
C                        axis lines.  PWRZT is then called to label
C                        the axes for a 3 space plot.
C
C EYE contains the (U,V,Z) coordinate of the eye position.
C
      REAL            EYE(3)
      DATA EYE(1), EYE(2), EYE(3) /3.5, 3.0, 5.0/
C
C Initialize the error parameter.
C
      IERROR = 1
C
C Select normalization transformation number 0.
C
      CALL GSELNT (0)
C
C A call to SET3 establishes the mapping of 3 space coordinates onto
C the coordinate system of the graphics device.
C
      CALL SET3 (.1,.9,.1,.9,0.,1.,0.,1.,0.,1.,EYE)
C
C Draw the 3 space axes.
C
      CALL LINE3 (0.,0.,0.,0.,0.,1.)
      CALL LINE3 (0.,0.,0.,0.,1.,0.)
      CALL LINE3 (0.,0.,0.,1.,0.,0.)
C
C PWRZT is used to label each of the axes and the plot
C
      ICNT = 0
      ISIZE = 30
      LINE = 2
      ITOP = 3
      CALL PWRZT (0.,.5,.1,'V-AXIS',6,ISIZE,LINE,ITOP,ICNT)
C
      LINE = -1
      ITOP = 3
      CALL PWRZT (.5,0.,.1,'U-AXIS',6,ISIZE,LINE,ITOP,ICNT)
C
      LINE = 3
      ITOP = -2
      CALL PWRZT (0.,.1,.5,'Z-AXIS',6,ISIZE,LINE,ITOP,ICNT)
C
      LINE = 2
      ITOP = -1
      ISIZE = 30
      ICNT = -1
      CALL PWRZT (.5,.2,0.,'DEMONSTRATION OF PWRZT WITH THREED',
     1            34,ISIZE,LINE,ITOP,ICNT)
      CALL FRAME
C
      IERROR = 0
      WRITE (6,1001)
C
      RETURN
 1001 FORMAT (' PWRZT TEST EXECUTED--SEE PLOT TO CERTIFY')
C
      END

      SUBROUTINE DGEGV( JOBVL, JOBVR, N, A, LDA, B, LDB, ALPHAR, ALPHAI,
     $                  BETA, VL, LDVL, VR, LDVR, WORK, LWORK, INFO )
*
*  -- LAPACK driver routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          JOBVL, JOBVR
      INTEGER            INFO, LDA, LDB, LDVL, LDVR, LWORK, N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), ALPHAI( * ), ALPHAR( * ),
     $                   B( LDB, * ), BETA( * ), VL( LDVL, * ),
     $                   VR( LDVR, * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  This routine is deprecated and has been replaced by routine DGGEV.
*
*  DGEGV computes for a pair of n-by-n real nonsymmetric matrices A and
*  B, the generalized eigenvalues (alphar +/- alphai*i, beta), and
*  optionally, the left and/or right generalized eigenvectors (VL and
*  VR).
*
*  A generalized eigenvalue for a pair of matrices (A,B) is, roughly
*  speaking, a scalar w or a ratio  alpha/beta = w, such that  A - w*B
*  is singular.  It is usually represented as the pair (alpha,beta),
*  as there is a reasonable interpretation for beta=0, and even for
*  both being zero.  A good beginning reference is the book, "Matrix
*  Computations", by G. Golub & C. van Loan (Johns Hopkins U. Press)
*
*  A right generalized eigenvector corresponding to a generalized
*  eigenvalue  w  for a pair of matrices (A,B) is a vector  r  such
*  that  (A - w B) r = 0 .  A left generalized eigenvector is a vector
*  l such that l**H * (A - w B) = 0, where l**H is the
*  conjugate-transpose of l.
*
*  Note: this routine performs "full balancing" on A and B -- see
*  "Further Details", below.
*
*  Arguments
*  =========
*
*  JOBVL   (input) CHARACTER*1
*          = 'N':  do not compute the left generalized eigenvectors;
*          = 'V':  compute the left generalized eigenvectors.
*
*  JOBVR   (input) CHARACTER*1
*          = 'N':  do not compute the right generalized eigenvectors;
*          = 'V':  compute the right generalized eigenvectors.
*
*  N       (input) INTEGER
*          The order of the matrices A, B, VL, and VR.  N >= 0.
*
*  A       (input/output) DOUBLE PRECISION array, dimension (LDA, N)
*          On entry, the first of the pair of matrices whose
*          generalized eigenvalues and (optionally) generalized
*          eigenvectors are to be computed.
*          On exit, the contents will have been destroyed.  (For a
*          description of the contents of A on exit, see "Further
*          Details", below.)
*
*  LDA     (input) INTEGER
*          The leading dimension of A.  LDA >= max(1,N).
*
*  B       (input/output) DOUBLE PRECISION array, dimension (LDB, N)
*          On entry, the second of the pair of matrices whose
*          generalized eigenvalues and (optionally) generalized
*          eigenvectors are to be computed.
*          On exit, the contents will have been destroyed.  (For a
*          description of the contents of B on exit, see "Further
*          Details", below.)
*
*  LDB     (input) INTEGER
*          The leading dimension of B.  LDB >= max(1,N).
*
*  ALPHAR  (output) DOUBLE PRECISION array, dimension (N)
*  ALPHAI  (output) DOUBLE PRECISION array, dimension (N)
*  BETA    (output) DOUBLE PRECISION array, dimension (N)
*          On exit, (ALPHAR(j) + ALPHAI(j)*i)/BETA(j), j=1,...,N, will
*          be the generalized eigenvalues.  If ALPHAI(j) is zero, then
*          the j-th eigenvalue is real; if positive, then the j-th and
*          (j+1)-st eigenvalues are a complex conjugate pair, with
*          ALPHAI(j+1) negative.
*
*          Note: the quotients ALPHAR(j)/BETA(j) and ALPHAI(j)/BETA(j)
*          may easily over- or underflow, and BETA(j) may even be zero.
*          Thus, the user should avoid naively computing the ratio
*          alpha/beta.  However, ALPHAR and ALPHAI will be always less
*          than and usually comparable with norm(A) in magnitude, and
*          BETA always less than and usually comparable with norm(B).
*
*  VL      (output) DOUBLE PRECISION array, dimension (LDVL,N)
*          If JOBVL = 'V', the left generalized eigenvectors.  (See
*          "Purpose", above.)  Real eigenvectors take one column,
*          complex take two columns, the first for the real part and
*          the second for the imaginary part.  Complex eigenvectors
*          correspond to an eigenvalue with positive imaginary part.
*          Each eigenvector will be scaled so the largest component
*          will have abs(real part) + abs(imag. part) = 1, *except*
*          that for eigenvalues with alpha=beta=0, a zero vector will
*          be returned as the corresponding eigenvector.
*          Not referenced if JOBVL = 'N'.
*
*  LDVL    (input) INTEGER
*          The leading dimension of the matrix VL. LDVL >= 1, and
*          if JOBVL = 'V', LDVL >= N.
*
*  VR      (output) DOUBLE PRECISION array, dimension (LDVR,N)
*          If JOBVR = 'V', the right generalized eigenvectors.  (See
*          "Purpose", above.)  Real eigenvectors take one column,
*          complex take two columns, the first for the real part and
*          the second for the imaginary part.  Complex eigenvectors
*          correspond to an eigenvalue with positive imaginary part.
*          Each eigenvector will be scaled so the largest component
*          will have abs(real part) + abs(imag. part) = 1, *except*
*          that for eigenvalues with alpha=beta=0, a zero vector will
*          be returned as the corresponding eigenvector.
*          Not referenced if JOBVR = 'N'.
*
*  LDVR    (input) INTEGER
*          The leading dimension of the matrix VR. LDVR >= 1, and
*          if JOBVR = 'V', LDVR >= N.
*
*  WORK    (workspace/output) DOUBLE PRECISION array, dimension (LWORK)
*          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*
*  LWORK   (input) INTEGER
*          The dimension of the array WORK.  LWORK >= max(1,8*N).
*          For good performance, LWORK must generally be larger.
*          To compute the optimal value of LWORK, call ILAENV to get
*          blocksizes (for DGEQRF, DORMQR, and DORGQR.)  Then compute:
*          NB  -- MAX of the blocksizes for DGEQRF, DORMQR, and DORGQR;
*          The optimal LWORK is:
*              2*N + MAX( 6*N, N*(NB+1) ).
*
*          If LWORK = -1, then a workspace query is assumed; the routine
*          only calculates the optimal size of the WORK array, returns
*          this value as the first entry of the WORK array, and no error
*          message related to LWORK is issued by XERBLA.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value.
*          = 1,...,N:
*                The QZ iteration failed.  No eigenvectors have been
*                calculated, but ALPHAR(j), ALPHAI(j), and BETA(j)
*                should be correct for j=INFO+1,...,N.
*          > N:  errors that usually indicate LAPACK problems:
*                =N+1: error return from DGGBAL
*                =N+2: error return from DGEQRF
*                =N+3: error return from DORMQR
*                =N+4: error return from DORGQR
*                =N+5: error return from DGGHRD
*                =N+6: error return from DHGEQZ (other than failed
*                                                iteration)
*                =N+7: error return from DTGEVC
*                =N+8: error return from DGGBAK (computing VL)
*                =N+9: error return from DGGBAK (computing VR)
*                =N+10: error return from DLASCL (various calls)
*
*  Further Details
*  ===============
*
*  Balancing
*  ---------
*
*  This driver calls DGGBAL to both permute and scale rows and columns
*  of A and B.  The permutations PL and PR are chosen so that PL*A*PR
*  and PL*B*R will be upper triangular except for the diagonal blocks
*  A(i:j,i:j) and B(i:j,i:j), with i and j as close together as
*  possible.  The diagonal scaling matrices DL and DR are chosen so
*  that the pair  DL*PL*A*PR*DR, DL*PL*B*PR*DR have elements close to
*  one (except for the elements that start out zero.)
*
*  After the eigenvalues and eigenvectors of the balanced matrices
*  have been computed, DGGBAK transforms the eigenvectors back to what
*  they would have been (in perfect arithmetic) if they had not been
*  balanced.
*
*  Contents of A and B on Exit
*  -------- -- - --- - -- ----
*
*  If any eigenvectors are computed (either JOBVL='V' or JOBVR='V' or
*  both), then on exit the arrays A and B will contain the real Schur
*  form[*] of the "balanced" versions of A and B.  If no eigenvectors
*  are computed, then only the diagonal blocks will be correct.
*
*  [*] See DHGEQZ, DGEGS, or read the book "Matrix Computations",
*      by Golub & van Loan, pub. by Johns Hopkins U. Press.
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO, ONE
      PARAMETER          ( ZERO = 0.0D0, ONE = 1.0D0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            ILIMIT, ILV, ILVL, ILVR, LQUERY
      CHARACTER          CHTEMP
      INTEGER            ICOLS, IHI, IINFO, IJOBVL, IJOBVR, ILEFT, ILO,
     $                   IN, IRIGHT, IROWS, ITAU, IWORK, JC, JR, LOPT,
     $                   LWKMIN, LWKOPT, NB, NB1, NB2, NB3
      DOUBLE PRECISION   ABSAI, ABSAR, ABSB, ANRM, ANRM1, ANRM2, BNRM,
     $                   BNRM1, BNRM2, EPS, ONEPLS, SAFMAX, SAFMIN,
     $                   SALFAI, SALFAR, SBETA, SCALE, TEMP
*     ..
*     .. Local Arrays ..
      LOGICAL            LDUMMA( 1 )
*     ..
*     .. External Subroutines ..
      EXTERNAL           DGEQRF, DGGBAK, DGGBAL, DGGHRD, DHGEQZ, DLACPY,
     $                   DLASCL, DLASET, DORGQR, DORMQR, DTGEVC, XERBLA
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            ILAENV
      DOUBLE PRECISION   DLAMCH, DLANGE
      EXTERNAL           LSAME, ILAENV, DLAMCH, DLANGE
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, INT, MAX
*     ..
*     .. Executable Statements ..
*
*     Decode the input arguments
*
      IF( LSAME( JOBVL, 'N' ) ) THEN
         IJOBVL = 1
         ILVL = .FALSE.
      ELSE IF( LSAME( JOBVL, 'V' ) ) THEN
         IJOBVL = 2
         ILVL = .TRUE.
      ELSE
         IJOBVL = -1
         ILVL = .FALSE.
      END IF
*
      IF( LSAME( JOBVR, 'N' ) ) THEN
         IJOBVR = 1
         ILVR = .FALSE.
      ELSE IF( LSAME( JOBVR, 'V' ) ) THEN
         IJOBVR = 2
         ILVR = .TRUE.
      ELSE
         IJOBVR = -1
         ILVR = .FALSE.
      END IF
      ILV = ILVL .OR. ILVR
*
*     Test the input arguments
*
      LWKMIN = MAX( 8*N, 1 )
      LWKOPT = LWKMIN
      WORK( 1 ) = LWKOPT
      LQUERY = ( LWORK.EQ.-1 )
      INFO = 0
      IF( IJOBVL.LE.0 ) THEN
         INFO = -1
      ELSE IF( IJOBVR.LE.0 ) THEN
         INFO = -2
      ELSE IF( N.LT.0 ) THEN
         INFO = -3
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -5
      ELSE IF( LDB.LT.MAX( 1, N ) ) THEN
         INFO = -7
      ELSE IF( LDVL.LT.1 .OR. ( ILVL .AND. LDVL.LT.N ) ) THEN
         INFO = -12
      ELSE IF( LDVR.LT.1 .OR. ( ILVR .AND. LDVR.LT.N ) ) THEN
         INFO = -14
      ELSE IF( LWORK.LT.LWKMIN .AND. .NOT.LQUERY ) THEN
         INFO = -16
      END IF
*
      IF( INFO.EQ.0 ) THEN
         NB1 = ILAENV( 1, 'DGEQRF', ' ', N, N, -1, -1 )
         NB2 = ILAENV( 1, 'DORMQR', ' ', N, N, N, -1 )
         NB3 = ILAENV( 1, 'DORGQR', ' ', N, N, N, -1 )
         NB = MAX( NB1, NB2, NB3 )
         LOPT = 2*N + MAX( 6*N, N*( NB+1 ) )
         WORK( 1 ) = LOPT
      END IF
*
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DGEGV ', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
*
*     Get machine constants
*
      EPS = DLAMCH( 'E' )*DLAMCH( 'B' )
      SAFMIN = DLAMCH( 'S' )
      SAFMIN = SAFMIN + SAFMIN
      SAFMAX = ONE / SAFMIN
      ONEPLS = ONE + ( 4*EPS )
*
*     Scale A
*
      ANRM = DLANGE( 'M', N, N, A, LDA, WORK )
      ANRM1 = ANRM
      ANRM2 = ONE
      IF( ANRM.LT.ONE ) THEN
         IF( SAFMAX*ANRM.LT.ONE ) THEN
            ANRM1 = SAFMIN
            ANRM2 = SAFMAX*ANRM
         END IF
      END IF
*
      IF( ANRM.GT.ZERO ) THEN
         CALL DLASCL( 'G', -1, -1, ANRM, ONE, N, N, A, LDA, IINFO )
         IF( IINFO.NE.0 ) THEN
            INFO = N + 10
            RETURN
         END IF
      END IF
*
*     Scale B
*
      BNRM = DLANGE( 'M', N, N, B, LDB, WORK )
      BNRM1 = BNRM
      BNRM2 = ONE
      IF( BNRM.LT.ONE ) THEN
         IF( SAFMAX*BNRM.LT.ONE ) THEN
            BNRM1 = SAFMIN
            BNRM2 = SAFMAX*BNRM
         END IF
      END IF
*
      IF( BNRM.GT.ZERO ) THEN
         CALL DLASCL( 'G', -1, -1, BNRM, ONE, N, N, B, LDB, IINFO )
         IF( IINFO.NE.0 ) THEN
            INFO = N + 10
            RETURN
         END IF
      END IF
*
*     Permute the matrix to make it more nearly triangular
*     Workspace layout:  (8*N words -- "work" requires 6*N words)
*        left_permutation, right_permutation, work...
*
      ILEFT = 1
      IRIGHT = N + 1
      IWORK = IRIGHT + N
      CALL DGGBAL( 'P', N, A, LDA, B, LDB, ILO, IHI, WORK( ILEFT ),
     $             WORK( IRIGHT ), WORK( IWORK ), IINFO )
      IF( IINFO.NE.0 ) THEN
         INFO = N + 1
         GO TO 120
      END IF
*
*     Reduce B to triangular form, and initialize VL and/or VR
*     Workspace layout:  ("work..." must have at least N words)
*        left_permutation, right_permutation, tau, work...
*
      IROWS = IHI + 1 - ILO
      IF( ILV ) THEN
         ICOLS = N + 1 - ILO
      ELSE
         ICOLS = IROWS
      END IF
      ITAU = IWORK
      IWORK = ITAU + IROWS
      CALL DGEQRF( IROWS, ICOLS, B( ILO, ILO ), LDB, WORK( ITAU ),
     $             WORK( IWORK ), LWORK+1-IWORK, IINFO )
      IF( IINFO.GE.0 )
     $   LWKOPT = MAX( LWKOPT, INT( WORK( IWORK ) )+IWORK-1 )
      IF( IINFO.NE.0 ) THEN
         INFO = N + 2
         GO TO 120
      END IF
*
      CALL DORMQR( 'L', 'T', IROWS, ICOLS, IROWS, B( ILO, ILO ), LDB,
     $             WORK( ITAU ), A( ILO, ILO ), LDA, WORK( IWORK ),
     $             LWORK+1-IWORK, IINFO )
      IF( IINFO.GE.0 )
     $   LWKOPT = MAX( LWKOPT, INT( WORK( IWORK ) )+IWORK-1 )
      IF( IINFO.NE.0 ) THEN
         INFO = N + 3
         GO TO 120
      END IF
*
      IF( ILVL ) THEN
         CALL DLASET( 'Full', N, N, ZERO, ONE, VL, LDVL )
         CALL DLACPY( 'L', IROWS-1, IROWS-1, B( ILO+1, ILO ), LDB,
     $                VL( ILO+1, ILO ), LDVL )
         CALL DORGQR( IROWS, IROWS, IROWS, VL( ILO, ILO ), LDVL,
     $                WORK( ITAU ), WORK( IWORK ), LWORK+1-IWORK,
     $                IINFO )
         IF( IINFO.GE.0 )
     $      LWKOPT = MAX( LWKOPT, INT( WORK( IWORK ) )+IWORK-1 )
         IF( IINFO.NE.0 ) THEN
            INFO = N + 4
            GO TO 120
         END IF
      END IF
*
      IF( ILVR )
     $   CALL DLASET( 'Full', N, N, ZERO, ONE, VR, LDVR )
*
*     Reduce to generalized Hessenberg form
*
      IF( ILV ) THEN
*
*        Eigenvectors requested -- work on whole matrix.
*
         CALL DGGHRD( JOBVL, JOBVR, N, ILO, IHI, A, LDA, B, LDB, VL,
     $                LDVL, VR, LDVR, IINFO )
      ELSE
         CALL DGGHRD( 'N', 'N', IROWS, 1, IROWS, A( ILO, ILO ), LDA,
     $                B( ILO, ILO ), LDB, VL, LDVL, VR, LDVR, IINFO )
      END IF
      IF( IINFO.NE.0 ) THEN
         INFO = N + 5
         GO TO 120
      END IF
*
*     Perform QZ algorithm
*     Workspace layout:  ("work..." must have at least 1 word)
*        left_permutation, right_permutation, work...
*
      IWORK = ITAU
      IF( ILV ) THEN
         CHTEMP = 'S'
      ELSE
         CHTEMP = 'E'
      END IF
      CALL DHGEQZ( CHTEMP, JOBVL, JOBVR, N, ILO, IHI, A, LDA, B, LDB,
     $             ALPHAR, ALPHAI, BETA, VL, LDVL, VR, LDVR,
     $             WORK( IWORK ), LWORK+1-IWORK, IINFO )
      IF( IINFO.GE.0 )
     $   LWKOPT = MAX( LWKOPT, INT( WORK( IWORK ) )+IWORK-1 )
      IF( IINFO.NE.0 ) THEN
         IF( IINFO.GT.0 .AND. IINFO.LE.N ) THEN
            INFO = IINFO
         ELSE IF( IINFO.GT.N .AND. IINFO.LE.2*N ) THEN
            INFO = IINFO - N
         ELSE
            INFO = N + 6
         END IF
         GO TO 120
      END IF
*
      IF( ILV ) THEN
*
*        Compute Eigenvectors  (DTGEVC requires 6*N words of workspace)
*
         IF( ILVL ) THEN
            IF( ILVR ) THEN
               CHTEMP = 'B'
            ELSE
               CHTEMP = 'L'
            END IF
         ELSE
            CHTEMP = 'R'
         END IF
*
         CALL DTGEVC( CHTEMP, 'B', LDUMMA, N, A, LDA, B, LDB, VL, LDVL,
     $                VR, LDVR, N, IN, WORK( IWORK ), IINFO )
         IF( IINFO.NE.0 ) THEN
            INFO = N + 7
            GO TO 120
         END IF
*
*        Undo balancing on VL and VR, rescale
*
         IF( ILVL ) THEN
            CALL DGGBAK( 'P', 'L', N, ILO, IHI, WORK( ILEFT ),
     $                   WORK( IRIGHT ), N, VL, LDVL, IINFO )
            IF( IINFO.NE.0 ) THEN
               INFO = N + 8
               GO TO 120
            END IF
            DO 50 JC = 1, N
               IF( ALPHAI( JC ).LT.ZERO )
     $            GO TO 50
               TEMP = ZERO
               IF( ALPHAI( JC ).EQ.ZERO ) THEN
                  DO 10 JR = 1, N
                     TEMP = MAX( TEMP, ABS( VL( JR, JC ) ) )
   10             CONTINUE
               ELSE
                  DO 20 JR = 1, N
                     TEMP = MAX( TEMP, ABS( VL( JR, JC ) )+
     $                      ABS( VL( JR, JC+1 ) ) )
   20             CONTINUE
               END IF
               IF( TEMP.LT.SAFMIN )
     $            GO TO 50
               TEMP = ONE / TEMP
               IF( ALPHAI( JC ).EQ.ZERO ) THEN
                  DO 30 JR = 1, N
                     VL( JR, JC ) = VL( JR, JC )*TEMP
   30             CONTINUE
               ELSE
                  DO 40 JR = 1, N
                     VL( JR, JC ) = VL( JR, JC )*TEMP
                     VL( JR, JC+1 ) = VL( JR, JC+1 )*TEMP
   40             CONTINUE
               END IF
   50       CONTINUE
         END IF
         IF( ILVR ) THEN
            CALL DGGBAK( 'P', 'R', N, ILO, IHI, WORK( ILEFT ),
     $                   WORK( IRIGHT ), N, VR, LDVR, IINFO )
            IF( IINFO.NE.0 ) THEN
               INFO = N + 9
               GO TO 120
            END IF
            DO 100 JC = 1, N
               IF( ALPHAI( JC ).LT.ZERO )
     $            GO TO 100
               TEMP = ZERO
               IF( ALPHAI( JC ).EQ.ZERO ) THEN
                  DO 60 JR = 1, N
                     TEMP = MAX( TEMP, ABS( VR( JR, JC ) ) )
   60             CONTINUE
               ELSE
                  DO 70 JR = 1, N
                     TEMP = MAX( TEMP, ABS( VR( JR, JC ) )+
     $                      ABS( VR( JR, JC+1 ) ) )
   70             CONTINUE
               END IF
               IF( TEMP.LT.SAFMIN )
     $            GO TO 100
               TEMP = ONE / TEMP
               IF( ALPHAI( JC ).EQ.ZERO ) THEN
                  DO 80 JR = 1, N
                     VR( JR, JC ) = VR( JR, JC )*TEMP
   80             CONTINUE
               ELSE
                  DO 90 JR = 1, N
                     VR( JR, JC ) = VR( JR, JC )*TEMP
                     VR( JR, JC+1 ) = VR( JR, JC+1 )*TEMP
   90             CONTINUE
               END IF
  100       CONTINUE
         END IF
*
*        End of eigenvector calculation
*
      END IF
*
*     Undo scaling in alpha, beta
*
*     Note: this does not give the alpha and beta for the unscaled
*     problem.
*
*     Un-scaling is limited to avoid underflow in alpha and beta
*     if they are significant.
*
      DO 110 JC = 1, N
         ABSAR = ABS( ALPHAR( JC ) )
         ABSAI = ABS( ALPHAI( JC ) )
         ABSB = ABS( BETA( JC ) )
         SALFAR = ANRM*ALPHAR( JC )
         SALFAI = ANRM*ALPHAI( JC )
         SBETA = BNRM*BETA( JC )
         ILIMIT = .FALSE.
         SCALE = ONE
*
*        Check for significant underflow in ALPHAI
*
         IF( ABS( SALFAI ).LT.SAFMIN .AND. ABSAI.GE.
     $       MAX( SAFMIN, EPS*ABSAR, EPS*ABSB ) ) THEN
            ILIMIT = .TRUE.
            SCALE = ( ONEPLS*SAFMIN / ANRM1 ) /
     $              MAX( ONEPLS*SAFMIN, ANRM2*ABSAI )
*
         ELSE IF( SALFAI.EQ.ZERO ) THEN
*
*           If insignificant underflow in ALPHAI, then make the
*           conjugate eigenvalue real.
*
            IF( ALPHAI( JC ).LT.ZERO .AND. JC.GT.1 ) THEN
               ALPHAI( JC-1 ) = ZERO
            ELSE IF( ALPHAI( JC ).GT.ZERO .AND. JC.LT.N ) THEN
               ALPHAI( JC+1 ) = ZERO
            END IF
         END IF
*
*        Check for significant underflow in ALPHAR
*
         IF( ABS( SALFAR ).LT.SAFMIN .AND. ABSAR.GE.
     $       MAX( SAFMIN, EPS*ABSAI, EPS*ABSB ) ) THEN
            ILIMIT = .TRUE.
            SCALE = MAX( SCALE, ( ONEPLS*SAFMIN / ANRM1 ) /
     $              MAX( ONEPLS*SAFMIN, ANRM2*ABSAR ) )
         END IF
*
*        Check for significant underflow in BETA
*
         IF( ABS( SBETA ).LT.SAFMIN .AND. ABSB.GE.
     $       MAX( SAFMIN, EPS*ABSAR, EPS*ABSAI ) ) THEN
            ILIMIT = .TRUE.
            SCALE = MAX( SCALE, ( ONEPLS*SAFMIN / BNRM1 ) /
     $              MAX( ONEPLS*SAFMIN, BNRM2*ABSB ) )
         END IF
*
*        Check for possible overflow when limiting scaling
*
         IF( ILIMIT ) THEN
            TEMP = ( SCALE*SAFMIN )*MAX( ABS( SALFAR ), ABS( SALFAI ),
     $             ABS( SBETA ) )
            IF( TEMP.GT.ONE )
     $         SCALE = SCALE / TEMP
            IF( SCALE.LT.ONE )
     $         ILIMIT = .FALSE.
         END IF
*
*        Recompute un-scaled ALPHAR, ALPHAI, BETA if necessary.
*
         IF( ILIMIT ) THEN
            SALFAR = ( SCALE*ALPHAR( JC ) )*ANRM
            SALFAI = ( SCALE*ALPHAI( JC ) )*ANRM
            SBETA = ( SCALE*BETA( JC ) )*BNRM
         END IF
         ALPHAR( JC ) = SALFAR
         ALPHAI( JC ) = SALFAI
         BETA( JC ) = SBETA
  110 CONTINUE
*
  120 CONTINUE
      WORK( 1 ) = LWKOPT
*
      RETURN
*
*     End of DGEGV
*
      END

C
C     $Id: xy11f.f,v 1.12 1998-11-24 17:06:24 haley Exp $
C
C****************************************************************
C                                                               *
C           Copyright (C)  1995                                 *
C   University Corporation for Atmospheric Research             *
C           All Rights Reserved                                 *
C                                                               *
C****************************************************************
C
C      File:            xy11f.f
C
C      Author:          Jeff Boote (converted to Fortran by Ed Stautler)
C                       National Center for Atmospheric Research
C                       PO 3000, Boulder, Colorado
C
C      Date:            Wed Mar 30 18:09:45 MST 1994
C
C      Description:     This example program demonstrates how to display
C                       your graphics to an X window, and then copy it
C                       into a meta file.
C
C
C Extern declarations for Types of objects that will be used
C
      external NhlFAppClass
      external NhlFCairoWindowWorkstationClass
      external NhlFNcgmWorkstationClass
      external NhlFXyPlotClass
      external NhlFCoordArraysClass

      integer appid
C
C Create data arrays to be plotted
C

      real Temp(28)
      real Pressure(28)

      data (Temp(i), i = 1,28) /-13.500000,-10.500000,-5.500000,
     %-3.100000,-1.300000,-6.700000,-12.900000,-13.100000,-17.700001,
     %-16.900000,-21.299999,-37.099998,-40.099998,-41.900002,-42.099998,
     %-62.700001,-59.299999,-60.700001,-52.099998,-55.099998,-55.900002,
     %-63.500000,-57.900002,-60.500000,-58.099998,-60.900002,-54.900002,
     %-57.299999 /

      data (Pressure(i), i = 1,28) /835.000000,832.000000,827.000000,
     %821.000000,791.000000,693.000000,627.000000,606.000000,560.000000,
     %555.000000,500.000000,383.000000,355.000000,339.000000,314.000000,
     %209.000000,192.000000,143.000000,111.000000,100.000000,95.300003,
     %76.400002,62.599998,58.299999,47.299999,30.000000,27.200001,
     %21.500000/
C
C   Initialize the error return variable
C
      data ierr / 0 /
C
C   Initialize the HLU library
C
      call NhlFInitialize
      call NhlFCreate(appid,'xy11',NhlFAppClass,0,0,ierr)
C
C   Create a ResList - This is filled with resource "Names" and
C   "Values" to apply to an HLU object.
C
      call NhlFRLCreate(list,'setrl')
C
C   Fill the ResList with the resources for the X Workstation
C   object - then create the X Workstation object.
C
      call NhlFRLClear(list)
      call NhlFRLSetInteger(list,'wkPause',1,ierr)
      call NhlFCreate(ixwork,'myxwork',
     +        NhlFCairoWindowWorkstationClass,0,
     %  list,ierr)

C
C   Fill the ResList with the resources for the NCGM Workstation
C   object - then create the NCGM Workstation object.
C
      call NhlFRLClear(list)
      call NhlFRLSetString(list,'wkMetaName','xy11f.ncgm',ierr)
      call NhlFCreate(incgmwork,'myncgmwork',
     %  NhlFNcgmWorkstationClass,0,list,ierr)

C
C   Fill the ResList with the resources for the CoordArrays
C   object - then create the CoordArrays data object.
C   This object is used to describe data to the HLU library.
C
      call NhlFRLClear(list)
      call NhlFRLSetFloatArray(list,'caXArray',Temp,28,ierr)
      call NhlFRLSetFloatArray(list,'caYArray',Pressure,28,ierr)
      call NhlFCreate(idata,'mydata',NhlFCoordArraysClass,0,list,
     %  ierr)
C
C   Fill the ResList with the resources for the XyPlot object
C   including the "Data" which is the object id for the
C   CoordArrays object that was just created.
C
      call NhlFRLClear(list)
      call NhlFRLSetFloat(list,'vpXF',0.25,ierr)
      call NhlFRLSetFloat(list,'vpYF',0.75,ierr)
      call NhlFRLSetFloat(list,'vpWidthF',0.5,ierr)
      call NhlFRLSetFloat(list,'vpHeightF',0.5,ierr)

      call NhlFRLSetInteger(list,'xyCoordData',idata,ierr)

      call NhlFRLSetInteger(list,'tiMainOn',1,ierr)
      call NhlFRLSetInteger(list,'tiXAxisOn',1,ierr)
      call NhlFRLSetInteger(list,'tiYAxisOn',1,ierr)

      call NhlFCreate(ixyplot,'myxyplot',NhlFXyPlotClass,ixwork,
     %  list,ierr)
C
C   We don't need the ResList any more - so destroy it.  Memory
C   is allocated for each reslist so it is important to destroy
C   them when you are done with them.
C
      call NhlFRLDestroy(list)
C
C   Draw the XyPlot - It was created as a child of the X Workstation
C   so it will draw to the X Workstation's device (Window).  Then
C   Call "Frame" for the X Workstation - this flushes the graphics
C   buffers so all the graphics are displayed - and since we
C   set the wkPause resource to True the program will pause on
C   the frame call until the user "clicks" in the Window.
C
      call NhlFDraw(ixyplot,ierr)
      call NhlFFrame(ixwork,ierr)
C
C   Move the XyPlot to the Ncgm Workstation - This makes the
C   XyPlot a child of the Ncgm Workstation so the XyPlot
C   will draw to the Ncgm Workstations' device instead of the
C   X Workstations device.
C
      call NhlFChangeWorkstation(ixyplot,incgmwork,ierr)
C
C   Draw the XyPlot - It is now a child of the Ncgm Workstation
C   so it will draw to the Ncgm Workstation's device (ncgm file).
C   Then C  Call "Frame" for the Ncgm Workstation - this flushes
C   the graphics C  buffers so all the graphics are displayed.
C
      call NhlFDraw(ixyplot,ierr)
      call NhlFFrame(incgmwork,ierr)
C
C   Destroy the X Workstation object - this also pop's down
C   the X Window. (Also free's all the memory associated with
C   the X Workstation)
C
      call NhlFDestroy(ixwork,ierr)
C
C   Destroy the Ncgm Workstation object - this closes the metafile
C   and puts the ENDMETAFILE marker in the file.
C   This also destroys the XyPlot object since the XyPlot is a
C   child of the Ncgm Workstation.
C
      call NhlFDestroy(incgmwork,ierr)

C
C   Close the library.
C
      call NhlFClose

      end

      PROGRAM CMPLOT
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Open GKS, Turn Clipping off
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Invoke demo driver
C
      CALL TCMPLOT(IWKID)
C
C Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS

      STOP
      END

      SUBROUTINE TCMPLOT(IWKID) 

      REAL PLIM1(2), PLIM2(2), PLIM3(2), PLIM4(2)

      DATA PLIM1 /0.,0./
      DATA PLIM2 /0.,0./
      DATA PLIM3 /0.,0./
      DATA PLIM4 /0.,0./
C
C CMPLOT demonstrates MAPLOT drawing continental and political outlines
C
C Set up color table
C
      CALL COLOR(IWKID)
C
C Draw Continental, political outlines in magenta
C
      CALL MAPSTC ('OU - OUTLINE DATASET SELECTOR','PO')
      CALL MAPSTI ('C5 - CONTINENTAL OUTLINE COLOR',5)
      CALL MAPSTI ('C7 - COUNTRY OUTLINE COLOR',5)
C
C Draw grid lines and limb line in green
C
      CALL MAPSTI ('C2 - GRID COLOR',2)
      CALL MAPSTI ('C4 - LIMB COLOR',2)
C
C Draw labels and perimeter in white
C
      CALL MAPSTI ('C1 - PERIMETER COLOR',1)
      CALL MAPSTI ('C3 - LABEL COLOR',1)
C
C Set up satellite projection
C
      CALL MAPROJ ('SV',40.,-50.,0.)
      CALL MAPSTR ('SA - SATELLITE DISTANCE',5.)
      CALL MAPSET ('MA',PLIM1,PLIM2,PLIM3,PLIM4)
C
C Set grid spacing to 10 degrees, and anchor grid curve at 10 degree 
C intervals.
C
      CALL MAPSTR ('GR - GRID SPACING',10.)
      CALL MAPSTR ('GD - GRID DRAWING RESOLUTION',10.)
C
C Make sure Labels are turned on
C
      CALL MAPSTI ('LA - LABEL FLAG',1)
C
C Label Size is given in NDCs by the formula NDC=LS/1024
C
      CALL MAPSTI ('LS - LABEL SIZE',40)
C
C Draw dotted continental outlines, and make dots reasonably close
C together
C
      CALL MAPSTI ('DO - DOTTED-OUTLINE SELECTOR',1)
      CALL MAPSTI ('DD - DISTANCE BETWEEN DOTS',56)
C
C Initialize Maps.
C
      CALL MAPINT
C
C Draw the latitiude and longitude lines and the limb line
C
      CALL MAPGRD
C
C Draw labels and perimeter
C
      CALL MAPLBL
C
C Draw continental and political outlines
C
      CALL MAPLOT
C
C Advance the frame.
C
      CALL FRAME
C
C Done.
C
      RETURN
      END
      SUBROUTINE COLOR(IWKID)
C
C Background color
C The background is white here for better visibility on paper
C
      CALL GSCR(IWKID,0,1.,1.,1.)
C
C Foreground colors
C
      CALL GSCR(IWKID,1,.7,0.,0.)
      CALL GSCR(IWKID,2,0.,.7,0.)
      CALL GSCR(IWKID,3,.7,.4,0.)
      CALL GSCR(IWKID,4,.3,.3,.7)
      CALL GSCR(IWKID,5,.7,0.,.7)
      CALL GSCR(IWKID,6,0.,.7,.7)
      CALL GSCR(IWKID,7,0.,0.,0.)

      RETURN
      END

      SUBROUTINE DGBBRD( VECT, M, N, NCC, KL, KU, AB, LDAB, D, E, Q,
     $                   LDQ, PT, LDPT, C, LDC, WORK, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER          VECT
      INTEGER            INFO, KL, KU, LDAB, LDC, LDPT, LDQ, M, N, NCC
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   AB( LDAB, * ), C( LDC, * ), D( * ), E( * ),
     $                   PT( LDPT, * ), Q( LDQ, * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  DGBBRD reduces a real general m-by-n band matrix A to upper
*  bidiagonal form B by an orthogonal transformation: Q' * A * P = B.
*
*  The routine computes B, and optionally forms Q or P', or computes
*  Q'*C for a given matrix C.
*
*  Arguments
*  =========
*
*  VECT    (input) CHARACTER*1
*          Specifies whether or not the matrices Q and P' are to be
*          formed.
*          = 'N': do not form Q or P';
*          = 'Q': form Q only;
*          = 'P': form P' only;
*          = 'B': form both.
*
*  M       (input) INTEGER
*          The number of rows of the matrix A.  M >= 0.
*
*  N       (input) INTEGER
*          The number of columns of the matrix A.  N >= 0.
*
*  NCC     (input) INTEGER
*          The number of columns of the matrix C.  NCC >= 0.
*
*  KL      (input) INTEGER
*          The number of subdiagonals of the matrix A. KL >= 0.
*
*  KU      (input) INTEGER
*          The number of superdiagonals of the matrix A. KU >= 0.
*
*  AB      (input/output) DOUBLE PRECISION array, dimension (LDAB,N)
*          On entry, the m-by-n band matrix A, stored in rows 1 to
*          KL+KU+1. The j-th column of A is stored in the j-th column of
*          the array AB as follows:
*          AB(ku+1+i-j,j) = A(i,j) for max(1,j-ku)<=i<=min(m,j+kl).
*          On exit, A is overwritten by values generated during the
*          reduction.
*
*  LDAB    (input) INTEGER
*          The leading dimension of the array A. LDAB >= KL+KU+1.
*
*  D       (output) DOUBLE PRECISION array, dimension (min(M,N))
*          The diagonal elements of the bidiagonal matrix B.
*
*  E       (output) DOUBLE PRECISION array, dimension (min(M,N)-1)
*          The superdiagonal elements of the bidiagonal matrix B.
*
*  Q       (output) DOUBLE PRECISION array, dimension (LDQ,M)
*          If VECT = 'Q' or 'B', the m-by-m orthogonal matrix Q.
*          If VECT = 'N' or 'P', the array Q is not referenced.
*
*  LDQ     (input) INTEGER
*          The leading dimension of the array Q.
*          LDQ >= max(1,M) if VECT = 'Q' or 'B'; LDQ >= 1 otherwise.
*
*  PT      (output) DOUBLE PRECISION array, dimension (LDPT,N)
*          If VECT = 'P' or 'B', the n-by-n orthogonal matrix P'.
*          If VECT = 'N' or 'Q', the array PT is not referenced.
*
*  LDPT    (input) INTEGER
*          The leading dimension of the array PT.
*          LDPT >= max(1,N) if VECT = 'P' or 'B'; LDPT >= 1 otherwise.
*
*  C       (input/output) DOUBLE PRECISION array, dimension (LDC,NCC)
*          On entry, an m-by-ncc matrix C.
*          On exit, C is overwritten by Q'*C.
*          C is not referenced if NCC = 0.
*
*  LDC     (input) INTEGER
*          The leading dimension of the array C.
*          LDC >= max(1,M) if NCC > 0; LDC >= 1 if NCC = 0.
*
*  WORK    (workspace) DOUBLE PRECISION array, dimension (2*max(M,N))
*
*  INFO    (output) INTEGER
*          = 0:  successful exit.
*          < 0:  if INFO = -i, the i-th argument had an illegal value.
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO, ONE
      PARAMETER          ( ZERO = 0.0D+0, ONE = 1.0D+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            WANTB, WANTC, WANTPT, WANTQ
      INTEGER            I, INCA, J, J1, J2, KB, KB1, KK, KLM, KLU1,
     $                   KUN, L, MINMN, ML, ML0, MN, MU, MU0, NR, NRT
      DOUBLE PRECISION   RA, RB, RC, RS
*     ..
*     .. External Subroutines ..
      EXTERNAL           DLARGV, DLARTG, DLARTV, DLASET, DROT, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters
*
      WANTB = LSAME( VECT, 'B' )
      WANTQ = LSAME( VECT, 'Q' ) .OR. WANTB
      WANTPT = LSAME( VECT, 'P' ) .OR. WANTB
      WANTC = NCC.GT.0
      KLU1 = KL + KU + 1
      INFO = 0
      IF( .NOT.WANTQ .AND. .NOT.WANTPT .AND. .NOT.LSAME( VECT, 'N' ) )
     $     THEN
         INFO = -1
      ELSE IF( M.LT.0 ) THEN
         INFO = -2
      ELSE IF( N.LT.0 ) THEN
         INFO = -3
      ELSE IF( NCC.LT.0 ) THEN
         INFO = -4
      ELSE IF( KL.LT.0 ) THEN
         INFO = -5
      ELSE IF( KU.LT.0 ) THEN
         INFO = -6
      ELSE IF( LDAB.LT.KLU1 ) THEN
         INFO = -8
      ELSE IF( LDQ.LT.1 .OR. WANTQ .AND. LDQ.LT.MAX( 1, M ) ) THEN
         INFO = -12
      ELSE IF( LDPT.LT.1 .OR. WANTPT .AND. LDPT.LT.MAX( 1, N ) ) THEN
         INFO = -14
      ELSE IF( LDC.LT.1 .OR. WANTC .AND. LDC.LT.MAX( 1, M ) ) THEN
         INFO = -16
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DGBBRD', -INFO )
         RETURN
      END IF
*
*     Initialize Q and P' to the unit matrix, if needed
*
      IF( WANTQ )
     $   CALL DLASET( 'Full', M, M, ZERO, ONE, Q, LDQ )
      IF( WANTPT )
     $   CALL DLASET( 'Full', N, N, ZERO, ONE, PT, LDPT )
*
*     Quick return if possible.
*
      IF( M.EQ.0 .OR. N.EQ.0 )
     $   RETURN
*
      MINMN = MIN( M, N )
*
      IF( KL+KU.GT.1 ) THEN
*
*        Reduce to upper bidiagonal form if KU > 0; if KU = 0, reduce
*        first to lower bidiagonal form and then transform to upper
*        bidiagonal
*
         IF( KU.GT.0 ) THEN
            ML0 = 1
            MU0 = 2
         ELSE
            ML0 = 2
            MU0 = 1
         END IF
*
*        Wherever possible, plane rotations are generated and applied in
*        vector operations of length NR over the index set J1:J2:KLU1.
*
*        The sines of the plane rotations are stored in WORK(1:max(m,n))
*        and the cosines in WORK(max(m,n)+1:2*max(m,n)).
*
         MN = MAX( M, N )
         KLM = MIN( M-1, KL )
         KUN = MIN( N-1, KU )
         KB = KLM + KUN
         KB1 = KB + 1
         INCA = KB1*LDAB
         NR = 0
         J1 = KLM + 2
         J2 = 1 - KUN
*
         DO 90 I = 1, MINMN
*
*           Reduce i-th column and i-th row of matrix to bidiagonal form
*
            ML = KLM + 1
            MU = KUN + 1
            DO 80 KK = 1, KB
               J1 = J1 + KB
               J2 = J2 + KB
*
*              generate plane rotations to annihilate nonzero elements
*              which have been created below the band
*
               IF( NR.GT.0 )
     $            CALL DLARGV( NR, AB( KLU1, J1-KLM-1 ), INCA,
     $                         WORK( J1 ), KB1, WORK( MN+J1 ), KB1 )
*
*              apply plane rotations from the left
*
               DO 10 L = 1, KB
                  IF( J2-KLM+L-1.GT.N ) THEN
                     NRT = NR - 1
                  ELSE
                     NRT = NR
                  END IF
                  IF( NRT.GT.0 )
     $               CALL DLARTV( NRT, AB( KLU1-L, J1-KLM+L-1 ), INCA,
     $                            AB( KLU1-L+1, J1-KLM+L-1 ), INCA,
     $                            WORK( MN+J1 ), WORK( J1 ), KB1 )
   10          CONTINUE
*
               IF( ML.GT.ML0 ) THEN
                  IF( ML.LE.M-I+1 ) THEN
*
*                    generate plane rotation to annihilate a(i+ml-1,i)
*                    within the band, and apply rotation from the left
*
                     CALL DLARTG( AB( KU+ML-1, I ), AB( KU+ML, I ),
     $                            WORK( MN+I+ML-1 ), WORK( I+ML-1 ),
     $                            RA )
                     AB( KU+ML-1, I ) = RA
                     IF( I.LT.N )
     $                  CALL DROT( MIN( KU+ML-2, N-I ),
     $                             AB( KU+ML-2, I+1 ), LDAB-1,
     $                             AB( KU+ML-1, I+1 ), LDAB-1,
     $                             WORK( MN+I+ML-1 ), WORK( I+ML-1 ) )
                  END IF
                  NR = NR + 1
                  J1 = J1 - KB1
               END IF
*
               IF( WANTQ ) THEN
*
*                 accumulate product of plane rotations in Q
*
                  DO 20 J = J1, J2, KB1
                     CALL DROT( M, Q( 1, J-1 ), 1, Q( 1, J ), 1,
     $                          WORK( MN+J ), WORK( J ) )
   20             CONTINUE
               END IF
*
               IF( WANTC ) THEN
*
*                 apply plane rotations to C
*
                  DO 30 J = J1, J2, KB1
                     CALL DROT( NCC, C( J-1, 1 ), LDC, C( J, 1 ), LDC,
     $                          WORK( MN+J ), WORK( J ) )
   30             CONTINUE
               END IF
*
               IF( J2+KUN.GT.N ) THEN
*
*                 adjust J2 to keep within the bounds of the matrix
*
                  NR = NR - 1
                  J2 = J2 - KB1
               END IF
*
               DO 40 J = J1, J2, KB1
*
*                 create nonzero element a(j-1,j+ku) above the band
*                 and store it in WORK(n+1:2*n)
*
                  WORK( J+KUN ) = WORK( J )*AB( 1, J+KUN )
                  AB( 1, J+KUN ) = WORK( MN+J )*AB( 1, J+KUN )
   40          CONTINUE
*
*              generate plane rotations to annihilate nonzero elements
*              which have been generated above the band
*
               IF( NR.GT.0 )
     $            CALL DLARGV( NR, AB( 1, J1+KUN-1 ), INCA,
     $                         WORK( J1+KUN ), KB1, WORK( MN+J1+KUN ),
     $                         KB1 )
*
*              apply plane rotations from the right
*
               DO 50 L = 1, KB
                  IF( J2+L-1.GT.M ) THEN
                     NRT = NR - 1
                  ELSE
                     NRT = NR
                  END IF
                  IF( NRT.GT.0 )
     $               CALL DLARTV( NRT, AB( L+1, J1+KUN-1 ), INCA,
     $                            AB( L, J1+KUN ), INCA,
     $                            WORK( MN+J1+KUN ), WORK( J1+KUN ),
     $                            KB1 )
   50          CONTINUE
*
               IF( ML.EQ.ML0 .AND. MU.GT.MU0 ) THEN
                  IF( MU.LE.N-I+1 ) THEN
*
*                    generate plane rotation to annihilate a(i,i+mu-1)
*                    within the band, and apply rotation from the right
*
                     CALL DLARTG( AB( KU-MU+3, I+MU-2 ),
     $                            AB( KU-MU+2, I+MU-1 ),
     $                            WORK( MN+I+MU-1 ), WORK( I+MU-1 ),
     $                            RA )
                     AB( KU-MU+3, I+MU-2 ) = RA
                     CALL DROT( MIN( KL+MU-2, M-I ),
     $                          AB( KU-MU+4, I+MU-2 ), 1,
     $                          AB( KU-MU+3, I+MU-1 ), 1,
     $                          WORK( MN+I+MU-1 ), WORK( I+MU-1 ) )
                  END IF
                  NR = NR + 1
                  J1 = J1 - KB1
               END IF
*
               IF( WANTPT ) THEN
*
*                 accumulate product of plane rotations in P'
*
                  DO 60 J = J1, J2, KB1
                     CALL DROT( N, PT( J+KUN-1, 1 ), LDPT,
     $                          PT( J+KUN, 1 ), LDPT, WORK( MN+J+KUN ),
     $                          WORK( J+KUN ) )
   60             CONTINUE
               END IF
*
               IF( J2+KB.GT.M ) THEN
*
*                 adjust J2 to keep within the bounds of the matrix
*
                  NR = NR - 1
                  J2 = J2 - KB1
               END IF
*
               DO 70 J = J1, J2, KB1
*
*                 create nonzero element a(j+kl+ku,j+ku-1) below the
*                 band and store it in WORK(1:n)
*
                  WORK( J+KB ) = WORK( J+KUN )*AB( KLU1, J+KUN )
                  AB( KLU1, J+KUN ) = WORK( MN+J+KUN )*AB( KLU1, J+KUN )
   70          CONTINUE
*
               IF( ML.GT.ML0 ) THEN
                  ML = ML - 1
               ELSE
                  MU = MU - 1
               END IF
   80       CONTINUE
   90    CONTINUE
      END IF
*
      IF( KU.EQ.0 .AND. KL.GT.0 ) THEN
*
*        A has been reduced to lower bidiagonal form
*
*        Transform lower bidiagonal form to upper bidiagonal by applying
*        plane rotations from the left, storing diagonal elements in D
*        and off-diagonal elements in E
*
         DO 100 I = 1, MIN( M-1, N )
            CALL DLARTG( AB( 1, I ), AB( 2, I ), RC, RS, RA )
            D( I ) = RA
            IF( I.LT.N ) THEN
               E( I ) = RS*AB( 1, I+1 )
               AB( 1, I+1 ) = RC*AB( 1, I+1 )
            END IF
            IF( WANTQ )
     $         CALL DROT( M, Q( 1, I ), 1, Q( 1, I+1 ), 1, RC, RS )
            IF( WANTC )
     $         CALL DROT( NCC, C( I, 1 ), LDC, C( I+1, 1 ), LDC, RC,
     $                    RS )
  100    CONTINUE
         IF( M.LE.N )
     $      D( M ) = AB( 1, M )
      ELSE IF( KU.GT.0 ) THEN
*
*        A has been reduced to upper bidiagonal form
*
         IF( M.LT.N ) THEN
*
*           Annihilate a(m,m+1) by applying plane rotations from the
*           right, storing diagonal elements in D and off-diagonal
*           elements in E
*
            RB = AB( KU, M+1 )
            DO 110 I = M, 1, -1
               CALL DLARTG( AB( KU+1, I ), RB, RC, RS, RA )
               D( I ) = RA
               IF( I.GT.1 ) THEN
                  RB = -RS*AB( KU, I )
                  E( I-1 ) = RC*AB( KU, I )
               END IF
               IF( WANTPT )
     $            CALL DROT( N, PT( I, 1 ), LDPT, PT( M+1, 1 ), LDPT,
     $                       RC, RS )
  110       CONTINUE
         ELSE
*
*           Copy off-diagonal elements to E and diagonal elements to D
*
            DO 120 I = 1, MINMN - 1
               E( I ) = AB( KU, I+1 )
  120       CONTINUE
            DO 130 I = 1, MINMN
               D( I ) = AB( KU+1, I )
  130       CONTINUE
         END IF
      ELSE
*
*        A is diagonal. Set elements of E to zero and copy diagonal
*        elements to D.
*
         DO 140 I = 1, MINMN - 1
            E( I ) = ZERO
  140    CONTINUE
         DO 150 I = 1, MINMN
            D( I ) = AB( 1, I )
  150    CONTINUE
      END IF
      RETURN
*
*     End of DGBBRD
*
      END

C
C $Id: mapgti.f,v 1.22 2008-09-18 00:42:16 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MAPGTI (WHCH,IVAL)
        CHARACTER*(*) WHCH
        INTEGER       IVAL
        IF (ICFELL('MAPGTI - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
        CALL MDGETI (WHCH,IVAL)
        IF (ICFELL('MAPGTI',2).NE.0) RETURN
        RETURN
      END

C
C	$Id: gschxp.f,v 1.5 2008-07-27 00:21:01 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GSCHXP (CHXP)
C
C  SET CHARACTER EXPANSION FACTOR
C
      INTEGER ESCHXP
      PARAMETER (ESCHXP=28)
C
      include 'gkscom.h'
C
      REAL CHXP
C
C  Check if GKS is in the proper state.
C
      CALL GZCKST(8,ESCHXP,IER)
      IF (IER .NE. 0) RETURN
C
C  Check if the expansion factor is valid.
C
      IF (CHXP.LE.0.) THEN
        ERS = 1
        CALL GERHND(77,ESCHXP,ERF)
        ERS = 0
        RETURN
      ENDIF
C
C  Set the current expansion factor in the GKS state list.
C
      CCHXP = CHXP
C
C  Invoke the workstation interface.
C
      FCODE = 31
      CONT  = 0
      CALL GZROI(0)
      RL1   = 1
      RL2   = 1
      RX(1) = CHXP
      CALL GZTOWK
      IF (RERR .NE. 0) THEN
        ERS = 1
        CALL GERHND(RERR,ESCHXP,ERF)
        ERS = 0
      ENDIF
C
      RETURN
      END

      SUBROUTINE SLAED1( N, D, Q, LDQ, INDXQ, RHO, CUTPNT, WORK, IWORK,
     $                   INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      INTEGER            CUTPNT, INFO, LDQ, N
      REAL               RHO
*     ..
*     .. Array Arguments ..
      INTEGER            INDXQ( * ), IWORK( * )
      REAL               D( * ), Q( LDQ, * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  SLAED1 computes the updated eigensystem of a diagonal
*  matrix after modification by a rank-one symmetric matrix.  This
*  routine is used only for the eigenproblem which requires all
*  eigenvalues and eigenvectors of a tridiagonal matrix.  SLAED7 handles
*  the case in which eigenvalues only or eigenvalues and eigenvectors
*  of a full symmetric matrix (which was reduced to tridiagonal form)
*  are desired.
*
*    T = Q(in) ( D(in) + RHO * Z*Z' ) Q'(in) = Q(out) * D(out) * Q'(out)
*
*     where Z = Q'u, u is a vector of length N with ones in the
*     CUTPNT and CUTPNT + 1 th elements and zeros elsewhere.
*
*     The eigenvectors of the original matrix are stored in Q, and the
*     eigenvalues are in D.  The algorithm consists of three stages:
*
*        The first stage consists of deflating the size of the problem
*        when there are multiple eigenvalues or if there is a zero in
*        the Z vector.  For each such occurence the dimension of the
*        secular equation problem is reduced by one.  This stage is
*        performed by the routine SLAED2.
*
*        The second stage consists of calculating the updated
*        eigenvalues. This is done by finding the roots of the secular
*        equation via the routine SLAED4 (as called by SLAED3).
*        This routine also calculates the eigenvectors of the current
*        problem.
*
*        The final stage consists of computing the updated eigenvectors
*        directly using the updated eigenvalues.  The eigenvectors for
*        the current problem are multiplied with the eigenvectors from
*        the overall problem.
*
*  Arguments
*  =========
*
*  N      (input) INTEGER
*         The dimension of the symmetric tridiagonal matrix.  N >= 0.
*
*  D      (input/output) REAL array, dimension (N)
*         On entry, the eigenvalues of the rank-1-perturbed matrix.
*         On exit, the eigenvalues of the repaired matrix.
*
*  Q      (input/output) REAL array, dimension (LDQ,N)
*         On entry, the eigenvectors of the rank-1-perturbed matrix.
*         On exit, the eigenvectors of the repaired tridiagonal matrix.
*
*  LDQ    (input) INTEGER
*         The leading dimension of the array Q.  LDQ >= max(1,N).
*
*  INDXQ  (input/output) INTEGER array, dimension (N)
*         On entry, the permutation which separately sorts the two
*         subproblems in D into ascending order.
*         On exit, the permutation which will reintegrate the
*         subproblems back into sorted order,
*         i.e. D( INDXQ( I = 1, N ) ) will be in ascending order.
*
*  RHO    (input) REAL
*         The subdiagonal entry used to create the rank-1 modification.
*
*  CUTPNT (input) INTEGER
*         The location of the last eigenvalue in the leading sub-matrix.
*         min(1,N) <= CUTPNT <= N/2.
*
*  WORK   (workspace) REAL array, dimension (4*N + N**2)
*
*  IWORK  (workspace) INTEGER array, dimension (4*N)
*
*  INFO   (output) INTEGER
*          = 0:  successful exit.
*          < 0:  if INFO = -i, the i-th argument had an illegal value.
*          > 0:  if INFO = 1, an eigenvalue did not converge
*
*  Further Details
*  ===============
*
*  Based on contributions by
*     Jeff Rutter, Computer Science Division, University of California
*     at Berkeley, USA
*  Modified by Francoise Tisseur, University of Tennessee.
*
*  =====================================================================
*
*     .. Local Scalars ..
      INTEGER            COLTYP, CPP1, I, IDLMDA, INDX, INDXC, INDXP,
     $                   IQ2, IS, IW, IZ, K, N1, N2
*     ..
*     .. External Subroutines ..
      EXTERNAL           SCOPY, SLAED2, SLAED3, SLAMRG, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
*
      IF( N.LT.0 ) THEN
         INFO = -1
      ELSE IF( LDQ.LT.MAX( 1, N ) ) THEN
         INFO = -4
      ELSE IF( MIN( 1, N / 2 ).GT.CUTPNT .OR. ( N / 2 ).LT.CUTPNT ) THEN
         INFO = -7
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'SLAED1', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
*
*     The following values are integer pointers which indicate
*     the portion of the workspace
*     used by a particular array in SLAED2 and SLAED3.
*
      IZ = 1
      IDLMDA = IZ + N
      IW = IDLMDA + N
      IQ2 = IW + N
*
      INDX = 1
      INDXC = INDX + N
      COLTYP = INDXC + N
      INDXP = COLTYP + N
*
*
*     Form the z-vector which consists of the last row of Q_1 and the
*     first row of Q_2.
*
      CALL SCOPY( CUTPNT, Q( CUTPNT, 1 ), LDQ, WORK( IZ ), 1 )
      CPP1 = CUTPNT + 1
      CALL SCOPY( N-CUTPNT, Q( CPP1, CPP1 ), LDQ, WORK( IZ+CUTPNT ), 1 )
*
*     Deflate eigenvalues.
*
      CALL SLAED2( K, N, CUTPNT, D, Q, LDQ, INDXQ, RHO, WORK( IZ ),
     $             WORK( IDLMDA ), WORK( IW ), WORK( IQ2 ),
     $             IWORK( INDX ), IWORK( INDXC ), IWORK( INDXP ),
     $             IWORK( COLTYP ), INFO )
*
      IF( INFO.NE.0 )
     $   GO TO 20
*
*     Solve Secular Equation.
*
      IF( K.NE.0 ) THEN
         IS = ( IWORK( COLTYP )+IWORK( COLTYP+1 ) )*CUTPNT +
     $        ( IWORK( COLTYP+1 )+IWORK( COLTYP+2 ) )*( N-CUTPNT ) + IQ2
         CALL SLAED3( K, N, CUTPNT, D, Q, LDQ, RHO, WORK( IDLMDA ),
     $                WORK( IQ2 ), IWORK( INDXC ), IWORK( COLTYP ),
     $                WORK( IW ), WORK( IS ), INFO )
         IF( INFO.NE.0 )
     $      GO TO 20
*
*     Prepare the INDXQ sorting permutation.
*
         N1 = K
         N2 = N - K
         CALL SLAMRG( N1, N2, D, 1, -1, INDXQ )
      ELSE
         DO 10 I = 1, N
            INDXQ( I ) = I
   10    CONTINUE
      END IF
*
   20 CONTINUE
      RETURN
*
*     End of SLAED1
*
      END

C
C $Id: kupy.f,v 1.7 2008-07-27 00:17:24 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      FUNCTION KUPY (RY)
C
C Given a Y coordinate RY in the user system, KUPY(RY) is a Y
C coordinate in the plotter system.
C
      COMMON /IUTLCM/ LL,MI,MX,MY,IU(96)
      SAVE /IUTLCM/
      DIMENSION WD(4),VP(4)
      CALL GQCNTN (IE,NT)
      IF (IE.NE.0) THEN
        CALL SETER ('KUPY - ERROR EXIT FROM GQCNTN',1,1)
        KUPY=0
        RETURN
      END IF
      CALL GQNT (NT,IE,WD,VP)
      IF (IE.NE.0) THEN
        CALL SETER ('KUPY - ERROR EXIT FROM GQNT',2,1)
        KUPY=0
        RETURN
      END IF
      I=3
      IF (MI.EQ.2.OR.MI.GE.4) I=4
      IF (LL.LE.1.OR.LL.EQ.3) THEN
        KUPY=1+INT(((RY-WD(I))/(WD(7-I)-WD(I))*(VP(4)-VP(3))+VP(3))*
     +             (2.**MY-1.))
      ELSE
        KUPY=1+INT(((ALOG10(RY)-WD(I))/(WD(7-I)-WD(I))*(VP(4)-VP(3))+
     +             VP(3))*(2.**MY-1.))
      ENDIF
      RETURN
      END

C
C	$Id: sfprcf.f,v 1.4 2008-07-27 12:23:42 haley Exp $
C                                                                      
C			     Copyright (C)  1997
C	     University Corporation for Atmospheric Research
C			     All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
C

      SUBROUTINE SFPRCF (ITYP,IOS, STATUS)
C
C  Process the input fontcap; define the output arrary in
C  COMMON block CAPFNT.
C
C  INPUT parameters:
C    None.
C
C  OUTPUT parameters:
C    ITYP    --  Type of fontcap: 0 for stroked; 1 for filled.
C    IOS     --  I/O status flag which has meaning only if there was
C                an I/O error (i.e. only if STATUS.GT.0).
C    STATUS  --  Integer-valued error status:
C                  =  0 -- No errors
C                  =  1 -- EOF encountered.
C                  =  2 -- Error decoding an integer value.
C                  =  3 -- Integer exceeds max. number of digits allowed.
C                  =  8 -- Error decoding floating-point value.
C                  =  9 -- Floating value exceeds maximum
C                          number of digits allowed.
C                  = 10 -- Not an integer field.
C                  = 11 -- String buffer not big enough
C                          to hold the input string.
C                  = 12 -- Non-ASCII value encountered.
C                  = 13 -- Keyword FONT_TYPE has not been defined.
C
      include 'fnterr.h'
      include 'fnttab.h'
      include 'capfnt.h'
      include 'fntcom.h'
C     
      INTEGER IOS, STATUS
      INTEGER WHICH(WHSIZE), ROW, ROW1, CURPOS, DUMMY
      INTEGER CURTMP, CHCNT
      INTEGER II,XIN,YIN,PEIN,PSIN,PIN
      INTEGER I1MACH
C
C  CURCHR  --  Number of the current character.
C  CURSTK  --  Stroke number (in the sequence of all strokes
C              processed for all characters) of the current
C              character being processed.
C  CBUF    --  Temporary stroke buffer (a single word of the CBUF
C              array is packed for each line encountered in
C              any stroke table.)
C
      INTEGER CURCHR, CURSTK, CBUF(1000)
C
C  Get the number of bits per word.
C
      INTEGER BTSWRD
      BTSWRD = I1MACH(5)
C
C  Initialize.
C
      CURCHR = 1
      CURSTK = 1
      CURPOS = 1
      DO 10 I=1,CHRSM1
      CPNTRS(I) = 0
   10 CONTINUE
      DO 20 I=1,CHRSM2
      CSTRKS(I) = 0
   20 CONTINUE
C
C  Get the first line of the file.
C
      CALL CFRDLN(ID1,ID2,STATUS)
      IF (STATUS .NE. ALLOK) RETURN
C
C  Process a filled font if requested.
C
      ITYP = 0
      IF (LINE(1:9) .EQ. 'FONT_NAME') THEN
        CALL FFPRSA(STATUS)
        ITYP = 1
        RETURN
      ENDIF
C
C  Continue processing, look for the next keyword.
C
 1    CONTINUE
      CALL SFSKBK(IOS, STATUS)
      IF (STATUS .NE. ALLOK) RETURN
C
C  Locate the keyword segment.
C  If no keyword is located on the line, then WHICH will
C  be returned as 0.  If a keyword is located, the the
C  first PTHBTS bits of WHICH will contain an integer
C  indicating which class has been found (1 for CHARACTER,
C  2 for COORD, etc.) and the next PTHBTS of WHICH will
C  contain an integer indicating which subclass has been
C  found (if the class is COORD for example, then the
C  second PTHBTS of WHICH will contain either 1 [for X],
C  or 2 [for Y], etc.)  
C
C
      CALL SFGTWK (WHICH, IOS, STATUS)
      IF (STATUS .NE. ALLOK) RETURN
C
C  If no keyword was matched on the current line, get a new line.
C
      IF (WHICH(1) .EQ. 0) GO TO 1
C
C  Get the major class number, and the subheading number.
C
      CALL GBYTES(WHICH, ROW, 0, PTHBTS, 0, 1)
      CALL GBYTES(WHICH, ROW1, PTHBTS, PTHBTS, 0, 1)
C
C  Branch to proper major class parsing.
C
      GO TO (100,200,300,400,500),ROW
C
C  CHARACTER class processing.
C
 100  CONTINUE
      IF (ROW1.EQ.1) THEN
        CALL SFGTIN(CHSTRT, 1, DUMMY, IOS, STATUS)
      ELSE IF (ROW1.EQ.2) THEN
        CALL SFGTIN(CHSEND, 1, DUMMY, IOS, STATUS)
      ELSE IF (ROW1.EQ.3) THEN
        CALL SFGTIN(CHRWDT, 1, DUMMY, IOS, STATUS)
      END IF
      GO TO 9000
C
C  COORD class processing.
C
 200  CONTINUE
      IF (ROW1.EQ.1) THEN
        CALL SFGTIN(CORXST, 1, DUMMY, IOS, STATUS)
        XIN=(BTSWRD-CORXST)-1
      ELSE IF (ROW1.EQ.3) THEN
        CALL SFGTIN(CORYST, 1, DUMMY, IOS, STATUS)
        YIN=(BTSWRD-CORYST)-1
      ELSE IF (ROW1.EQ.5) THEN
        CALL SFGTIN(CORPST, 1, DUMMY, IOS, STATUS)
        PIN=(BTSWRD-CORPST)-1
      ELSE IF (ROW1.EQ.2) THEN
        CALL SFGTIN(CORXLN, 1, DUMMY, IOS, STATUS)
      ELSE IF (ROW1.EQ.4) THEN
        CALL SFGTIN(CORYLN, 1, DUMMY, IOS, STATUS)
      ELSE IF (ROW1.EQ.6) THEN
        CALL SFGTIN(CORPLN, 1, DUMMY, IOS, STATUS)
      END IF
      GO TO 9000
C
C  PAINT class processing.
C
 300  CONTINUE
      IF (ROW1.EQ.1) THEN
        CALL SFGTIN(PBEGST, 1, DUMMY, IOS, STATUS)
        PSIN=(BTSWRD-PBEGST)-1
      ELSE IF (ROW1.EQ.3) THEN
        CALL SFGTIN(PENDST, 1, DUMMY, IOS, STATUS)
        PEIN=(BTSWRD-PENDST)-1
      ELSE IF (ROW1.EQ.2) THEN
        CALL SFGTIN(PBEGLN, 1, DUMMY, IOS, STATUS)
      ELSE IF (ROW1.EQ.4) THEN
        CALL SFGTIN(PENDLN, 1, DUMMY, IOS, STATUS)
      END IF
      GO TO 9000
C
C  CHAR class processing.
C
 400  CONTINUE
      IF (FNTTYP .LT. 0) THEN
        STATUS = 13
        RETURN
      ENDIF
C
      CPNTRS(CURCHR) = CURSTK
      CURCHR = CURCHR + 1
      IF (FNTTYP.EQ.1 .OR. FNTTYP.EQ.3) THEN
C  Process character left and character right values.
        CALL SFGTIN(CBUF,2,CHCNT,IOS,STATUS)
        CURTMP = 0
        CALL SBYTES(CURTMP,CBUF(1),XIN,CORXLN,0,1)     
        CALL SBYTES(CURTMP,CBUF(2),YIN,CORYLN,0,1)   
        CSTRKS(CURSTK) = CURTMP
        CPNLST = CURSTK
        CURSTK = CURSTK+1
      ENDIF
C  Process stroke data (no paint start/end data for filled fonts).
      IF (FNTTYP.EQ.2 .OR. FNTTYP.EQ.3) THEN
        ISMX = 600
      ELSE IF (FNTTYP.EQ.0 .OR. FNTTYP.EQ.1) THEN
        ISMX = 1000
      ENDIF
      CALL SFGTIN(CBUF, ISMX, CHCNT, IOS, STATUS)
      IF (FNTTYP.EQ.2 .OR. FNTTYP.EQ.3) THEN
        ISINC = 3
      ELSE IF (FNTTYP.EQ.0 .OR. FNTTYP.EQ.1) THEN
        ISINC = 5
      ENDIF
      DO 410 II = 1,CHCNT,ISINC
      CURTMP = 0
      CALL SBYTES(CURTMP,CBUF(II),XIN,CORXLN,0,1)     
      CALL SBYTES(CURTMP,CBUF(II+1),YIN,CORYLN,0,1)   
      CALL SBYTES(CURTMP,CBUF(II+2),PIN,CORPLN,0,1)   
      IF (FNTTYP.EQ.0 .OR. FNTTYP.EQ.1) THEN
        CALL SBYTES(CURTMP,CBUF(II+3),PSIN,PBEGLN,0,1)  
        CALL SBYTES(CURTMP,CBUF(II+4),PEIN,PENDLN,0,1)  
      ENDIF
      CSTRKS(CURSTK) = CURTMP
      CPNLST = CURSTK
      CURSTK = CURSTK + 1
 410  CONTINUE
      GO TO 9000
C
C  FONT class processing.
C
 500  CONTINUE
      IF (ROW1.EQ.1) THEN
        CALL SFGTIN(FNTRHT, 1, DUMMY, IOS, STATUS)
      ELSE IF (ROW1.EQ.2) THEN
        CALL SFGTIN(FNTTOP, 1, DUMMY, IOS, STATUS)
      ELSE IF (ROW1.EQ.3) THEN
        CALL SFGTIN(FNTCAP, 1, DUMMY, IOS, STATUS)
      ELSE IF (ROW1.EQ.4) THEN
        CALL SFGTIN(FNTHLF, 1, DUMMY, IOS, STATUS)
      ELSE IF (ROW1.EQ.5) THEN
        CALL SFGTIN(FNTBAS, 1, DUMMY, IOS, STATUS)
      ELSE IF (ROW1.EQ.6) THEN
        CALL SFGTIN(FNTBOT, 1, DUMMY, IOS, STATUS)
      ELSE IF (ROW1.EQ.7) THEN
        CALL SFGTIN(FNTTYP, 1, DUMMY, IOS, STATUS)
      END IF
        GO TO 9000
 9000 CONTINUE
      IF (STATUS .NE. ALLOK) RETURN
C
C  Go back and start the scan again.
C
      GO TO 1
C
      END

C
C	$Id: csc2s.f,v 1.5 2008-07-27 03:10:06 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CSC2S (N,X,Y,Z,RLAT,RLON)
      REAL X(N),Y(N),Z(N),RLAT(N),RLON(N)
C
C  This subroutine converts a point P from Cartesian coor-
C  dinates on a unit sphere to spherical coordinates.
C
C
C On input:
C
C       X,Y,Z = Cartesian coordinates of P.
C
C On output:
C
C       RLAT = Latitude of P, in degrees. - 90. .LE. RLAT .LE. 90.
C
C       PLON = Longitude of P, in degrees. -180. .LE. RLON .LE. 180.
C
C Modules required by CSC2S:  CSSCOORD
C
C Intrinsic functions called by CSC2S:  None
C
C***********************************************************
C
      PARAMETER (D2R=0.017453293, R2D=57.295778)
C
      DO 10 I=1,N
        CALL CSSCOORD(X(I),Y(I),Z(I),RLATD,RLOND,PRNM)
        RLAT(I) = R2D*RLATD
        RLON(I) = R2D*RLOND
   10 CONTINUE
C
      RETURN
      END

      PROGRAM SHEX01
C
C Test SHGETNP in package Shgrid.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C  Number of points in the dataset, number of near points, 
C  number of far points.
C
      PARAMETER(N=1331,NEAREST=500,NFARTHER=N-NEAREST)
      INTEGER NPTS(NEAREST), MPTS(NFARTHER)
C
      REAL X(N), Y(N), Z(N) 
      INTEGER IWK(2*N)
      REAL    RWK(11*N+6)
C
C  Workspace arrays for Tdpack.
C
      PARAMETER (MTRI=150000)
      DIMENSION RTRI(10,MTRI),RTWK(MTRI,2),ITWK(MTRI)
C
C  Generate an array of randomly-positioned points in the unit cube.
C
      DO 3 I=1,N
        X(I) = DSRND1()
        Y(I) = DSRND1()
        Z(I) = DSRND1()
    3 CONTINUE
C
C  Specify the reference point from which we want to find the NEAREST
C  nearest points.
C
      PX = 0.5
      PY = 0.5
      PZ = 0.5
C
C  Plot the points.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C  Initialize Tdpack parameters.
C
C
C  Move the plot up a bit.
C
      CALL TDSETR('VPB',0.09)
      CALL TDSETR('VPT',0.99)
      CALL TDSETR('VPL',0.11)
      CALL TDSETR('VPR',1.00)
      CALL TDINIT (4.6,  3.0, 3.3, 0.5, 0.5, 0.5, 0.5, 0.5, 2.7,0.)
C
C  Set up some colors using the standard Tdpack entry for that.
C
      CALL TDCLRS (IWKID, 1, 0., 0.8, 8, 37, 8)
C
C  Define style indices for shades of gray, green, and red.
C
      CALL TDSTRS (1,  8, 37,   8,  37, 1, 1, 0, 0.05, 0.05, 0.)
      CALL TDSTRS (3,  8, 37,  68,  97, 1, 1, 0, 0.05, 0.05, 0.)
      CALL TDSTRS (4,  8, 37,  98, 127, 1, 1, 0, 0.05, 0.05, 0.)
C
C  Store the indices of the nearest points in NPTS and the complement
C  of that set (with respect to the entire input dataset) in MPTS.
C
      CALL SHGETNP(PX,PY,PZ,N,X,Y,Z,0,IWK,RWK,NPTS(1),IER)
      DO 80 I=2,N
        IF (I .LE. NEAREST) THEN
          CALL SHGETNP(PX,PY,PZ,N,X,Y,Z,1,IWK,RWK,NPTS(I),IER)
        ELSE
          CALL SHGETNP(PX,PY,PZ,N,X,Y,Z,1,IWK,RWK,
     +                 MPTS(I-NEAREST),IER)
        ENDIF
   80 CONTINUE
C
C  Plot the near points in green.
C
      NTRI = 0
      DOTSIZE = 0.02
      DO 30 I=1,NEAREST
        INX = NPTS(I)
        CALL TDMTRI(-5,X(INX),Y(INX),Z(INX),DOTSIZE,RTRI,MTRI,NTRI,4,
     +                0.,0.,0.,1.,1.,1.)
   30 CONTINUE
C
C  Plot the farther points in gray.
C
      DO 90 I=1,NFARTHER
        INX = MPTS(I)
        CALL TDMTRI(-5,X(INX),Y(INX),Z(INX),DOTSIZE,RTRI,MTRI,NTRI,1,
     +                0.,0.,0.,1.,1.,1.)
   90 CONTINUE
C
C  Mark the reference point in red.
C
      CALL TDMTRI(-5,PX,PY,PZ,1.2*DOTSIZE,RTRI,MTRI,NTRI,3,
     +                0.,0.,0.,1.,1.,1.)
C
C  Draw.
C
      CALL TDOTRI(RTRI,MTRI,NTRI,RTWK,ITWK,0) 
      CALL TDDTRI(RTRI,MTRI,NTRI,ITWK) 
C
C  Draw a box around the perimeter.
C
      CALL TDGRDS (0., 1., 0., 1., 0., 1., -1., -1., -1.,11,0)
      CALL TDGRDS (0., 1., 0., 1., 0., 1., -1., -1., -1.,11,1)
C
C  Label the plot.
C
      CALL SET (0.,1.,0.,1.,0.,1.,0.,1.,1)
      CALL PLCHHQ(0.5,0.95,
     +            ':F26:Find the nearest N points in three space',
     +            0.025,0.,0.)
      CALL PLCHHQ(0.05,0.17,
     +            ':F22:Red ball = reference point',0.02,0.,-1.)
      CALL PLCHHQ(0.05,0.12,
     +            ':F22:Green balls = near points',0.02,0.,-1.)
      CALL PLCHHQ(0.05,0.07,
     +            ':F22:Gray balls = far points',0.02,0.,-1.)
C
      CALL FRAME
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      STOP
C
      END
      REAL FUNCTION DSRND1()
C
C  Portable random number generator.
C
      PARAMETER (MPLIER=16807,MODLUS=2147483647,MOBYMP=127773,
     +           MOMDMP=2836)
C
      INTEGER HVLUE, LVLUE, TESTV, NEXTN
      SAVE    NEXTN
      DATA JSEED,IFRST/123456789,0/
C
      IF (IFRST .EQ. 0) THEN
        NEXTN = JSEED
        IFRST = 1
      ENDIF
C
      HVLUE = NEXTN / MOBYMP
      LVLUE = MOD(NEXTN, MOBYMP)
      TESTV = MPLIER*LVLUE - MOMDMP*HVLUE
      IF (TESTV .GT. 0) THEN
        NEXTN = TESTV
      ELSE
        NEXTN = TESTV + MODLUS
      ENDIF
      DSRND1 = REAL(NEXTN)/REAL(MODLUS)
C
      RETURN
      END

      PROGRAM CLBFIL
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      CHARACTER*10 LAB1(4)
      INTEGER IFILL1(4)

      DATA LAB1 /'Four','Different','Fill','Styles'/
      DATA IFILL1 /1,2,3,4/
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Draw a horizontal bar
C
      CALL LBLBAR(0,.05,.95,.05,.95,4,1.,.3,IFILL1,2,LAB1,4,1)
C
C Advance frame
C
      CALL FRAME
C
C     DEACTIVATE AND CLOSE WORKSTATION, CLOSE GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      STOP
      END

      SUBROUTINE LBFILL(IFTP,XRA,YRA,NRA,INDX)
C
C Declare required dimensioned arrays.
C
      DIMENSION XRA(NRA),YRA(NRA),DST(500),IND(500)
      DIMENSION ID1(8,8),ID2(8,8),ID3(8,8)
C
C Define three different dot patterns.
C
      DATA ID1 / 1,1,0,0,0,0,1,1,
     +      1,1,0,1,1,0,1,1,
     +      0,0,0,1,1,0,0,0,
     +      0,1,1,1,1,1,1,0,
     +      0,1,1,1,1,1,1,0,
     +      0,0,0,1,1,0,0,0,
     +      1,1,0,1,1,0,1,1,
     +      1,1,0,0,0,0,1,1/
      DATA ID2 / 0,0,0,0,0,0,0,0,
     +      0,1,1,1,1,1,1,0,
     +      0,1,1,1,1,1,1,0,
     +      0,1,1,0,0,1,1,0,
     +      0,1,1,0,0,1,1,0,
     +      0,1,1,1,1,1,1,0,
     +      0,1,1,1,1,1,1,0,
     +      0,0,0,0,0,0,0,0/
      DATA ID3 / 0,0,0,0,0,0,0,0,
     +      0,1,1,0,0,1,1,1,
     +      0,1,1,0,0,1,1,0,
     +      0,1,1,0,1,1,0,0,
     +      0,1,1,1,1,0,0,0,
     +      0,1,1,0,1,1,0,0,
     +      0,1,1,0,0,1,1,0,
     +      0,1,1,0,0,1,1,1/
C
C Double the size of the GKS dot.
C
      CALL GSMKSC (2.)
C
C Fill the first box with a combination of lines and dots.
C
      IF (INDX.EQ.1) THEN
         CALL SFSETR ('SP - SPACING OF FILL LINES',.012)
         CALL SFSETI ('DO - DOT-FILL FLAG',0)
         CALL SFWRLD (XRA,YRA,NRA,DST,500,IND,500)
         CALL SFSETR ('SP - SPACING OF FILL LINES',.006)
         CALL SFSETI ('DO - DOT-FILL FLAG',1)
         CALL SFNORM (XRA,YRA,NRA,DST,500,IND,500)
      ENDIF
C
C Fill the second box with a specified dot pattern.
C
      IF (INDX.EQ.2) THEN
         CALL SFSETR ('SP - SPACING OF FILL LINES',.004)
         CALL SFSETP (ID1)
         CALL SFWRLD (XRA,YRA,NRA,DST,500,IND,500)
      ENDIF
C
C Fill the third box with a different dot pattern, tilted at an
C angle.
C
      IF (INDX.EQ.3) THEN
         CALL SFSETI ('AN - ANGLE OF FILL LINES',45)
         CALL SFSETP (ID2)
         CALL SFWRLD (XRA,YRA,NRA,DST,500,IND,500)
      ENDIF
C
C Fill the last box with K's, both large and small.
C
      IF (INDX.EQ.4) THEN
         CALL GSCHH  (.008)
         CALL SFSETR ('SP - SPACING OF FILL LINES',.012)
         CALL SFSETC ('CH - CHARACTER SPECIFIER','K')
         CALL SFSETP (ID3)
         CALL SFWRLD (XRA,YRA,NRA,DST,500,IND,500)
      ENDIF
C
C Done.
C
      RETURN
C
      END

C
C	$Id: cssmsurf.f,v 1.5 2008-07-27 03:10:08 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CSSMSURF (N,X,Y,Z,U,LIST,LPTR,LEND,IFLGS,
     .                   SIGMA,W,SM,SMTOL,GSTOL,LPRNT, F,
     .                   GRAD,IER)
      INTEGER N, LIST(*), LPTR(*), LEND(N), IFLGS, LPRNT,
     .        IER
      DOUBLE PRECISION X(N), Y(N), Z(N), U(N), SIGMA(*),
     .                 W(N), SM, SMTOL, GSTOL, F(N),
     .                 GRAD(3,N)
C
C***********************************************************
C
C                                              From SSRFPACK
C                                            Robert J. Renka
C                                  Dept. of Computer Science
C                                       Univ. of North Texas
C                                           renka@cs.unt.edu
C                                                   07/21/98
C
C   Given a triangulation of N nodes on the unit sphere with
C data values U at the nodes and tension factors SIGMA
C associated with the arcs, this routine determines a set of
C nodal function values F and gradients GRAD = (FX,FY,FZ)
C such that a quadratic functional Q1(F,GRAD) is minimized
C subject to the constraint Q2(F) .LE. SM for Q2(F) =
C (U-F)**T*W*(U-F), where W is a diagonal matrix of positive
C weights.  The functional Q1 is an approximation to the
C linearized curvature over the triangulation of a C-1 fun-
C ction F(V), V a unit vector, which interpolates the nodal
C values and gradients.  Subroutines CSINTRC1 and CSUNIF may be
C called to evaluate F at arbitrary points.
C
C   The smoothing procedure is an extension of the method
C for cubic spline smoothing due to C. Reinsch -- Numer.
C Math., 10 (1967) and 16 (1971).  Refer to Function CSFVAL
C for a further description of the interpolant F.  Letting
C D1F(T) and D2F(T) denote first and second derivatives of F
C with respect to a parameter T varying along a triangula-
C tion arc, Q1 is the sum of integrals over the arcs of
C D2F(T)**2 + ((SIGMA/L)*(D1F(T)-S))**2 where L denotes arc-
C length, SIGMA is the appropriate tension factor, and S is
C the slope of the linear function of T which interpolates
C the values of F at the endpoints of the arc.  Introducing
C a smoothing parameter P, and assuming the constraint is
C active, the problem is equivalent to minimizing Q(P,F,
C GRAD) = Q1(F,GRAD) + P*(Q2(F)-SM).  The secant method is
C used to find a zero of G(P) = 1/SQRT(Q2) - 1/SQRT(SM)
C where F(P) satisfies the order-3N symmetric positive def-
C inite linear system obtained by setting the gradient of Q
C (treated as a function of F and GRAD with GRAD tangent to
C the sphere surface) to zero.  The linear system is solved
C by the block Gauss-Seidel method (refer to CSSMSGS).
C
C   Note that the method can also be used to select grad-
C ients for the interpolation problem (F = U, SM = 0, and P
C infinite).  This is achieved by a call to Subroutine
C CSGRADG.
C
C On input:
C
C       N = Number of nodes in the triangulation.  N .GE. 3.
C
C       X,Y,Z = Arrays of length N containing Cartesian
C               coordinates of the nodes.
C
C       U = Array of length N containing data values at the
C           nodes.
C
C       LIST,LPTR,LEND = Data structure defining the trian-
C                        gulation.  Refer to STRIPACK
C                        Subroutine CSTRMESH.
C
C       IFLGS = Tension factor option:
C               IFLGS .LE. 0 if a single uniform tension
C                            factor is to be used.
C               IFLGS .GE. 1 if variable tension is desired.
C
C       SIGMA = Uniform tension factor (IFLGS .LE. 0), or
C               array containing tension factors associated
C               with arcs in one-to-one correspondence with
C               LIST entries (IFLGS .GE. 1).  Refer to Sub-
C               programs CSGETSIG, CSSIG0, CSSIG1, and CSSIG2.
C
C       W = Array of length N containing positive weights
C           associated with the data values.  The recommend-
C           ed value of W(I) is 1/DU**2 where DU is the
C           standard deviation associated with U(I).  DU**2
C           is the expected value of the squared error in
C           the measurement of U(I).  (The mean error is
C           assumed to be zero.)
C
C       SM = Positive parameter specifying an upper bound on
C            Q2(F).  Note that F is constant (and Q2(F)
C            is minimized) if SM is sufficiently large that
C            the constraint is not active.  It is recommend-
C            ed that SM satisfy N-SQRT(2N) .LE. SM .LE. N+
C            SQRT(2N).
C
C       SMTOL = Parameter in the open interval (0,1) speci-
C               fying the relative error allowed in satisfy-
C               ing the constraint -- the constraint is
C               assumed to be satisfied if SM*(1-SMTOL) .LE.
C               Q2 .LE. SM*(1+SMTOL).  A reasonable value
C               for SMTOL is SQRT(2/N).
C
C       GSTOL = Nonnegative tolerance defining the conver-
C               gence criterion for the Gauss-Seidel method.
C               Refer to parameter DFMAX in Subroutine
C               CSSMSGS.  A recommended value is .05*DU**2,
C               where DU is an average standard deviation
C               in the data values.
C
C       LPRNT = Logical unit on which diagnostic messages
C               are printed, or negative integer specifying
C               no diagnostics.  For each secant iteration,
C               the following values are printed:  P, G(P),
C               NIT, DFMAX, and DP, where NIT denotes the
C               number of Gauss-Seidel iterations used in
C               the computation of G, DFMAX denotes the max-
C               imum relative change in a solution component
C               in the last Gauss-Seidel iteration, and DP
C               is the change in P computed by linear inter-
C               polation between the current point (P,G) and
C               a previous point.
C
C Input parameters are not altered by this routine.
C
C On output:
C
C       F = Array of length N containing nodal function val-
C           ues unless IER < 0.
C
C       GRAD = 3 by N array whose columns contain gradients
C              of F at the nodes unless IER < 0.
C
C       IER = Error indicator and information flag:
C             IER = 0 if no errors were encountered and the
C                     constraint is active -- Q2(F) is ap-
C                     proximately equal to SM.
C             IER = 1 if no errors were encountered but the
C                     constraint is not active -- F and GRAD
C                     are the values and gradients of a con-
C                     stant function which minimizes Q2(F),
C                     and Q1 = 0.
C             IER = 2 if the constraint could not be satis-
C                     fied to within SMTOL due to
C                     ill-conditioned linear systems.
C             IER = -1 if N, W, SM, SMTOL, or GSTOL is out-
C                      side its valid range on input.
C             IER = -2 if all nodes are collinear or the
C                      triangulation is invalid.
C             IER = -3 if duplicate nodes were encountered.
C
C SSRFPACK modules required by CSSMSURF:  CSAPLYRT, CSCONSTR,
C                                         CSGRCOEF, CSSMSGS,
C                                         CSSNHCSH
C
C Intrinsic functions called by CSSMSURF:  ABS, SQRT
C
C***********************************************************
C
      INTEGER I, IERR, ITER, ITMAX, LUN, NIT, NITMAX, NN
      DOUBLE PRECISION C, DFMAX, DMAX, DP, G, G0, GNEG, P,
     .                 Q2, Q2MAX, Q2MIN, S, SUMW, TOL, WI
C
C Local parameters:
C
C ITMAX = Maximum number of secant iterations.
C LUN = Local copy of LPRNT.
C NITMAX = Maximum number of Gauss-Seidel iterations for
C          each secant iteration.
C NN = Local copy of N.
C TOL = Local copy of GSTOL.
C
      DATA ITMAX/50/,  NITMAX/40/
C
      NN = N
      TOL = GSTOL
      LUN = LPRNT
      IF (LUN .GT. 99) LUN = -1
C
C Test for errors and initialize F to the weighted least
C   squares fit of a constant function to the data.
C
      IER = -1
      IF (NN .LT. 3  .OR.  SM .LE. 0.  .OR.  SMTOL .LE. 0.
     .    .OR.  SMTOL .GE. 1.  .OR.  TOL .LE. 0.) RETURN
      C = 0.
      SUMW = 0.
      DO 1 I = 1,NN
        WI = W(I)
        IF (WI .LE. 0.) RETURN
        C = C + WI*U(I)
        SUMW = SUMW + WI
    1   CONTINUE
      C = C/SUMW
C
C Compute nodal values and gradients, and accumulate Q2 =
C   (U-F)**T*W*(U-F).
C
      Q2 = 0.
      DO 2 I = 1,NN
        F(I) = C
        GRAD(1,I) = 0.
        GRAD(2,I) = 0.
        GRAD(3,I) = 0.
        Q2 = Q2 + W(I)*(U(I)-F(I))**2
    2   CONTINUE
C
C Compute bounds on Q2 defined by SMTOL, and test for the
C   constraint satisfied by the constant fit.
C
      Q2MIN = SM*(1.-SMTOL)
      Q2MAX = SM*(1.+SMTOL)
      IF (Q2 .LE. Q2MAX) THEN
C
C The constraint is satisfied by a constant function.
C
        IER = 1
        IF (LUN .GE. 0) WRITE (LUN,100)
  100   FORMAT (///1X,'CSSMSURF -- THE CSCONSTRAINT IS NOT ',
     .          'ACTIVE AND THE FITTING FCN IS CONSTANT.')
        RETURN
      ENDIF
C
C Compute G0 = G(0) and print a heading.
C
      IER = 0
      S = 1./SQRT(SM)
      G0 = 1./SQRT(Q2) - S
      IF (LUN .GE. 0) WRITE (LUN,110) SM, TOL, NITMAX, G0
  110 FORMAT (///1X,'CSSMSURF -- SM = ',E10.4,', GSTOL = ',
     .        E7.1,', NITMAX = ',I2,', G(0) = ',E15.8)
C
C G(P) is strictly increasing and concave, and G(0) .LT. 0.
C   Initialize parameters for the secant method.  The method
C   uses three points -- (P0,G0), (P,G), and (PNEG,GNEG)
C   where P0 and PNEG are defined implicitly by DP = P - P0
C   and DMAX = P - PNEG.
C
      P = 10.*SM
      DP = P
      DMAX = 0.
      ITER = 0
C
C Top of loop -- compute G.
C
    3 NIT = NITMAX
      DFMAX = TOL
      CALL CSSMSGS (NN,X,Y,Z,U,LIST,LPTR,LEND,IFLGS,SIGMA,W,
     .            P, NIT,DFMAX,F,GRAD, IERR)
      IF (IERR .LT. 0) IER = IERR
C
C   IERR = -1 in CSSMSGS could be caused by P = 0 as a result
C     of inaccurate solutions to ill-conditioned systems.
C
      IF (IERR .EQ. -1) IER = 2
      IF (IERR .LT. 0) RETURN
      Q2 = 0.
      DO 4 I = 1,NN
        Q2 = Q2 + W(I)*(U(I)-F(I))**2
    4   CONTINUE
      G = 1./SQRT(Q2) - S
      ITER = ITER + 1
      IF (LUN .GE. 0) WRITE (LUN,120) ITER, P, G, NIT, DFMAX
  120 FORMAT (/1X,I2,' -- P = ',E15.8,', G = ',E15.8,
     .        ', NIT = ',I2,', DFMAX = ',E12.6)
C
C   Test for convergence.
C
      IF (Q2MIN .LE. Q2  .AND.  Q2 .LE. Q2MAX) RETURN
      IF (ITER .GE. ITMAX) THEN
        IER = 2
        RETURN
      ENDIF
      IF (DMAX .EQ. 0.  .AND.  G .LE. 0.) THEN
C
C   Increase P until G(P) > 0.
C
        P = 10.*P
        DP = P
        GO TO 3
      ENDIF
C
C   A bracketing interval [P0,P] has been found.
C
      IF (G0*G .LE. 0.) THEN
C
C   G0*G < 0.  Update (PNEG,GNEG) to (P0,G0) so that G
C     and GNEG always have opposite signs.
C
        DMAX = DP
        GNEG = G0
      ENDIF
C
C   Compute the change in P by linear interpolation between
C     (P0,G0) and (P,G).
C
    5 DP = -G*DP/(G-G0)
      IF (LUN .GE. 0) WRITE (LUN,130) DP
  130 FORMAT (1X,5X,'DP = ',E15.8)
      IF (ABS(DP) .GT. ABS(DMAX)) THEN
C
C   G0*G .GT. 0 and the new estimate would be outside of the
C     bracketing interval of length ABS(DMAX).  Reset
C     (P0,G0) to (PNEG,GNEG).
C
        DP = DMAX
        G0 = GNEG
        GO TO 5
      ENDIF
C
C   Bottom of loop -- update P, DMAX, and G0.
C
      P = P + DP
      DMAX = DMAX + DP
      G0 = G
      GO TO 3
      END

C
C	$Id: pwrtm.f,v 1.6 2008-07-27 00:23:04 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE PWRTM (X,Y,CHARS,JSIZE,JOR,JCNTR)
C
C
C PWRTM CAN BE CALLED TO DRAW CHARACTERS AND MARK THE REGIONS WHERE THE
C CHARACTERS HAVE BEEN DRAWN IN THE MODEL PICTURE.
C
C THE PARAMETERS TO PWRTM ARE EXACTLY THE SAME AS THE PARAMETERS TO
C THE UTILITY SUPPORT ROUTINE WTSTR.
C
C THE COORDINATES X AND Y ARE IN THE USER'S RESOLUTION, SINCE PWRTM
C IS A USER ENTRY POINT
C
      CHARACTER*(*) CHARS
C
C ISKIP IS INITIALIZED AND DESCRIBED IN BLOCKDATA DASHBDX.
C
      COMMON /DSUP1/ ISKIP
C
      COMMON/INTPR/IPAU,FPART,TENSN,NP,SMALL,L1,ADDLR,ADDTB,MLLINE,
     1    ICLOSE
      SAVE
C
C
C A CONSTANT USED TO COMPUTE THE NUMBER OF LINES TO BE MARKED.
C SQTDTH = SQRT(2)/3
C
      DATA SQTDTH /.47133/
C
C COPY INTO LOCAL VARIABLES
C
      ICNTR = JCNTR
      ISIZE = JSIZE
      IOR = JOR
C
C RETRIEVE THE USER'S RESOLUTION.
C
         CALL GETUSV('XF',LXSAVE)
         CALL GETUSV('YF',LYSAVE)
C
C DRAW THE CHARACTER STRING
C
      CALL WTSTR (X,Y,CHARS,ISIZE,IOR,ICNTR)
C
C RETURN IF STRING IS OF LENGTH 0
C
      IC = LEN(CHARS)
      IF (IC .EQ. 0) RETURN
C
C TRANSFORM COORDINATES INTO RESOLUTION 15.
C
      CALL FL2INT (X,Y,MXS,MYS)
C
C ADJUST ADDLR AND ADDTB TO 15 BIT RESOLUTION.
C
      IFIFTE = ISHIFT (1,15-10)
      ATBAD = ADDTB*REAL(IFIFTE)
      ALRAD = ADDLR*REAL(IFIFTE)
C
C COMPUTE THE SIZE OF A CHARACTER IN THE STRING DRAWN
C
      FISIZE = ISIZE*ISHIFT(1,15-LXSAVE)
      IF (ISIZE .GT. 3) GO TO 30
      FISIZE = 256. + REAL(ISIZE)*128.
      IF (ISIZE .EQ. 3) FISIZE = 768.
   30 CONTINUE
      LNT = INT(FISIZE*REAL(IC)+2.*ALRAD+.5)
C
C COMPUTE THE ANGLE IN WHICH THE STRING WAS DRAWN
C
      ANGLE = (REAL(IOR)*2.*3.1415)/360.
C
      SA = SIN(ANGLE)
      CA = COS(ANGLE)
C
C CORRECT FOR CENTERING OPTION.
C
      IF (ICNTR .EQ. 0) SHIFT = .5*REAL(LNT)
      IF (ICNTR .EQ. -1) SHIFT = ALRAD
      IF (ICNTR .EQ. 1) SHIFT = REAL(LNT)-.5*FISIZE-ALRAD
C
C ADD FREE SPACE AT TOP AND BOTTOM
C
      FISIZE = FISIZE + 2.*ATBAD
C
C FIND THE LEFT AND THE RIGHT END OF THE AREA TO BE MARKED.
C
      MXS1 = REAL(MXS)-SHIFT*CA+.5*FISIZE*SA
      MYS1 = REAL(MYS)-SHIFT*SA-.5*FISIZE*CA
      MXS2 = REAL(MXS)+(REAL(LNT)-SHIFT)*CA+.5*FISIZE*SA
      MYS2 = REAL(MYS)+(REAL(LNT)-SHIFT)*SA-.5*FISIZE*CA
C
C COMPUTE THE NUMBER OF LINES TO BE MARKED.
C
      NLINES = FISIZE*SQTDTH
C
      R = REAL(MAX(NLINES-1,1))/FISIZE
C
C MARK THE AREA WHERE THE STRING WAS DRAWN
C
      DO 90 I=1,NLINES,ISKIP
         P = REAL(I-1)/R
         MX1 = REAL(MXS1)-P*SA
         MY1 = REAL(MYS1)+P*CA
         MX2 = REAL(MXS2)-P*SA
         MY2 = REAL(MYS2)+P*CA
         CALL MARKL (MX1,MY1,MX2,MY2)
   90 CONTINUE
C
      RETURN
C
C------REVISION HISTORY
C
C JUNE 1984          CONVERTED TO FORTRAN77 AND GKS
C
C JUNE 1988          CHANGED THE NAME OF A COMMON BLOCK TO GET RID OF A
C                    WARNING FROM SEGLDR.  (DJK)
C
C NOVEMBER 1988      REMOVED KURV1S AND KURV2S.  IMPLEMENTED CALLS TO
C                    MSKRV1 AND MSKRV2 INSTEAD.
C
C-----------------------------------------------------------------------
C
      END

C
C	$Id: gqlwk.f,v 1.9 2009-04-08 23:18:21 fred Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GQLWK(WTYPE,ERRIND,MPLBTE,MPMBTE,MTXBTE,MFABTE,
     +                 MPAI,MCOLI)
C
C  INQUIRE MAXIMUM LENGTH OF WORKSTATION STATE TABLES
C
      include 'gkscom.h'
C
      INTEGER WTYPE,ERRIND,MPLBTE,MPMBTE,MTXBTE,MFABTE,MPAI,MCOLI
C
C  Check if GKS is in the proper state.
C
      CALL GZCKST(8,-1,ERRIND)
      IF (ERRIND .NE. 0) GOTO 100
C
C  Check that the workstation type is valid.
C
      CALL GZCKWK(22,-1,IDUM,WTYPE,ERRIND)
      IF (ERRIND .NE. 0) GO TO 100
C
C  Check if the workstation category is OUTPUT or OUTIN.
C
      CALL GQWKCA(WTYPE,ERRIND,ICAT)
      IF (ICAT.NE.GOUTPT .AND. ICAT.NE.GOUTIN) THEN
        ERRIND = 39
        GO TO 100
      ENDIF
C
      IF (WTYPE.EQ.GXWC .OR. WTYPE.EQ.GXWE .OR. WTYPE.EQ.GDMP .OR.
     +    WTYPE.EQ.GPIX) THEN
        MPLBTE = 0
        MPMBTE = 0
        MTXBTE = 0
        MFABTE = 0
        MPAI   = 0
        MCOLI  = 256
        RETURN
      ENDIF
C
      IF ((WTYPE.GE.GPSMIN .AND. WTYPE.LE.GPSMAX) .OR.
     +    (WTYPE.GE.GCROMIN .AND. WTYPE.LE.GCROMAX) .OR.
     +     WTYPE.EQ.GPDFP .OR. WTYPE.EQ.GPDFL) THEN
        DCUNIT = 1
        MPLBTE = 0
        MPMBTE = 0
        MTXBTE = 0
        MFABTE = 0
        MPAI   = 0
        MCOLI  = 256
        RETURN
      ENDIF
C
  100 CONTINUE
      MPLBTE = -1
      MPMBTE = -1
      MTXBTE = -1
      MFABTE = -1
      MPAI   = -1
      MCOLI  = -1
C
      RETURN
      END

      SUBROUTINE CGGES( JOBVSL, JOBVSR, SORT, SELCTG, N, A, LDA, B, LDB,
     $                  SDIM, ALPHA, BETA, VSL, LDVSL, VSR, LDVSR, WORK,
     $                  LWORK, RWORK, BWORK, INFO )
*
*  -- LAPACK driver routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          JOBVSL, JOBVSR, SORT
      INTEGER            INFO, LDA, LDB, LDVSL, LDVSR, LWORK, N, SDIM
*     ..
*     .. Array Arguments ..
      LOGICAL            BWORK( * )
      REAL               RWORK( * )
      COMPLEX            A( LDA, * ), ALPHA( * ), B( LDB, * ),
     $                   BETA( * ), VSL( LDVSL, * ), VSR( LDVSR, * ),
     $                   WORK( * )
*     ..
*     .. Function Arguments ..
      LOGICAL            SELCTG
      EXTERNAL           SELCTG
*     ..
*
*  Purpose
*  =======
*
*  CGGES computes for a pair of N-by-N complex nonsymmetric matrices
*  (A,B), the generalized eigenvalues, the generalized complex Schur
*  form (S, T), and optionally left and/or right Schur vectors (VSL
*  and VSR). This gives the generalized Schur factorization
*
*          (A,B) = ( (VSL)*S*(VSR)**H, (VSL)*T*(VSR)**H )
*
*  where (VSR)**H is the conjugate-transpose of VSR.
*
*  Optionally, it also orders the eigenvalues so that a selected cluster
*  of eigenvalues appears in the leading diagonal blocks of the upper
*  triangular matrix S and the upper triangular matrix T. The leading
*  columns of VSL and VSR then form an unitary basis for the
*  corresponding left and right eigenspaces (deflating subspaces).
*
*  (If only the generalized eigenvalues are needed, use the driver
*  CGGEV instead, which is faster.)
*
*  A generalized eigenvalue for a pair of matrices (A,B) is a scalar w
*  or a ratio alpha/beta = w, such that  A - w*B is singular.  It is
*  usually represented as the pair (alpha,beta), as there is a
*  reasonable interpretation for beta=0, and even for both being zero.
*
*  A pair of matrices (S,T) is in generalized complex Schur form if S
*  and T are upper triangular and, in addition, the diagonal elements
*  of T are non-negative real numbers.
*
*  Arguments
*  =========
*
*  JOBVSL  (input) CHARACTER*1
*          = 'N':  do not compute the left Schur vectors;
*          = 'V':  compute the left Schur vectors.
*
*  JOBVSR  (input) CHARACTER*1
*          = 'N':  do not compute the right Schur vectors;
*          = 'V':  compute the right Schur vectors.
*
*  SORT    (input) CHARACTER*1
*          Specifies whether or not to order the eigenvalues on the
*          diagonal of the generalized Schur form.
*          = 'N':  Eigenvalues are not ordered;
*          = 'S':  Eigenvalues are ordered (see SELCTG).
*
*  SELCTG  (input) LOGICAL FUNCTION of two COMPLEX arguments
*          SELCTG must be declared EXTERNAL in the calling subroutine.
*          If SORT = 'N', SELCTG is not referenced.
*          If SORT = 'S', SELCTG is used to select eigenvalues to sort
*          to the top left of the Schur form.
*          An eigenvalue ALPHA(j)/BETA(j) is selected if
*          SELCTG(ALPHA(j),BETA(j)) is true.
*
*          Note that a selected complex eigenvalue may no longer satisfy
*          SELCTG(ALPHA(j),BETA(j)) = .TRUE. after ordering, since
*          ordering may change the value of complex eigenvalues
*          (especially if the eigenvalue is ill-conditioned), in this
*          case INFO is set to N+2 (See INFO below).
*
*  N       (input) INTEGER
*          The order of the matrices A, B, VSL, and VSR.  N >= 0.
*
*  A       (input/output) COMPLEX array, dimension (LDA, N)
*          On entry, the first of the pair of matrices.
*          On exit, A has been overwritten by its generalized Schur
*          form S.
*
*  LDA     (input) INTEGER
*          The leading dimension of A.  LDA >= max(1,N).
*
*  B       (input/output) COMPLEX array, dimension (LDB, N)
*          On entry, the second of the pair of matrices.
*          On exit, B has been overwritten by its generalized Schur
*          form T.
*
*  LDB     (input) INTEGER
*          The leading dimension of B.  LDB >= max(1,N).
*
*  SDIM    (output) INTEGER
*          If SORT = 'N', SDIM = 0.
*          If SORT = 'S', SDIM = number of eigenvalues (after sorting)
*          for which SELCTG is true.
*
*  ALPHA   (output) COMPLEX array, dimension (N)
*  BETA    (output) COMPLEX array, dimension (N)
*          On exit,  ALPHA(j)/BETA(j), j=1,...,N, will be the
*          generalized eigenvalues.  ALPHA(j), j=1,...,N  and  BETA(j),
*          j=1,...,N  are the diagonals of the complex Schur form (A,B)
*          output by CGGES. The  BETA(j) will be non-negative real.
*
*          Note: the quotients ALPHA(j)/BETA(j) may easily over- or
*          underflow, and BETA(j) may even be zero.  Thus, the user
*          should avoid naively computing the ratio alpha/beta.
*          However, ALPHA will be always less than and usually
*          comparable with norm(A) in magnitude, and BETA always less
*          than and usually comparable with norm(B).
*
*  VSL     (output) COMPLEX array, dimension (LDVSL,N)
*          If JOBVSL = 'V', VSL will contain the left Schur vectors.
*          Not referenced if JOBVSL = 'N'.
*
*  LDVSL   (input) INTEGER
*          The leading dimension of the matrix VSL. LDVSL >= 1, and
*          if JOBVSL = 'V', LDVSL >= N.
*
*  VSR     (output) COMPLEX array, dimension (LDVSR,N)
*          If JOBVSR = 'V', VSR will contain the right Schur vectors.
*          Not referenced if JOBVSR = 'N'.
*
*  LDVSR   (input) INTEGER
*          The leading dimension of the matrix VSR. LDVSR >= 1, and
*          if JOBVSR = 'V', LDVSR >= N.
*
*  WORK    (workspace/output) COMPLEX array, dimension (LWORK)
*          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*
*  LWORK   (input) INTEGER
*          The dimension of the array WORK.  LWORK >= max(1,2*N).
*          For good performance, LWORK must generally be larger.
*
*          If LWORK = -1, then a workspace query is assumed; the routine
*          only calculates the optimal size of the WORK array, returns
*          this value as the first entry of the WORK array, and no error
*          message related to LWORK is issued by XERBLA.
*
*  RWORK   (workspace) REAL array, dimension (8*N)
*
*  BWORK   (workspace) LOGICAL array, dimension (N)
*          Not referenced if SORT = 'N'.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value.
*          =1,...,N:
*                The QZ iteration failed.  (A,B) are not in Schur
*                form, but ALPHA(j) and BETA(j) should be correct for
*                j=INFO+1,...,N.
*          > N:  =N+1: other than QZ iteration failed in CHGEQZ
*                =N+2: after reordering, roundoff changed values of
*                      some complex eigenvalues so that leading
*                      eigenvalues in the Generalized Schur form no
*                      longer satisfy SELCTG=.TRUE.  This could also
*                      be caused due to scaling.
*                =N+3: reordering falied in CTGSEN.
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ZERO, ONE
      PARAMETER          ( ZERO = 0.0E0, ONE = 1.0E0 )
      COMPLEX            CZERO, CONE
      PARAMETER          ( CZERO = ( 0.0E0, 0.0E0 ),
     $                   CONE = ( 1.0E0, 0.0E0 ) )
*     ..
*     .. Local Scalars ..
      LOGICAL            CURSL, ILASCL, ILBSCL, ILVSL, ILVSR, LASTSL,
     $                   LQUERY, WANTST
      INTEGER            I, ICOLS, IERR, IHI, IJOBVL, IJOBVR, ILEFT,
     $                   ILO, IRIGHT, IROWS, IRWRK, ITAU, IWRK, LWKMIN,
     $                   LWKOPT
      REAL               ANRM, ANRMTO, BIGNUM, BNRM, BNRMTO, EPS, PVSL,
     $                   PVSR, SMLNUM
*     ..
*     .. Local Arrays ..
      INTEGER            IDUM( 1 )
      REAL               DIF( 2 )
*     ..
*     .. External Subroutines ..
      EXTERNAL           CGEQRF, CGGBAK, CGGBAL, CGGHRD, CHGEQZ, CLACPY,
     $                   CLASCL, CLASET, CTGSEN, CUNGQR, CUNMQR, SLABAD,
     $                   XERBLA
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            ILAENV
      REAL               CLANGE, SLAMCH
      EXTERNAL           LSAME, ILAENV, CLANGE, SLAMCH
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, SQRT
*     ..
*     .. Executable Statements ..
*
*     Decode the input arguments
*
      IF( LSAME( JOBVSL, 'N' ) ) THEN
         IJOBVL = 1
         ILVSL = .FALSE.
      ELSE IF( LSAME( JOBVSL, 'V' ) ) THEN
         IJOBVL = 2
         ILVSL = .TRUE.
      ELSE
         IJOBVL = -1
         ILVSL = .FALSE.
      END IF
*
      IF( LSAME( JOBVSR, 'N' ) ) THEN
         IJOBVR = 1
         ILVSR = .FALSE.
      ELSE IF( LSAME( JOBVSR, 'V' ) ) THEN
         IJOBVR = 2
         ILVSR = .TRUE.
      ELSE
         IJOBVR = -1
         ILVSR = .FALSE.
      END IF
*
      WANTST = LSAME( SORT, 'S' )
*
*     Test the input arguments
*
      INFO = 0
      LQUERY = ( LWORK.EQ.-1 )
      IF( IJOBVL.LE.0 ) THEN
         INFO = -1
      ELSE IF( IJOBVR.LE.0 ) THEN
         INFO = -2
      ELSE IF( ( .NOT.WANTST ) .AND. ( .NOT.LSAME( SORT, 'N' ) ) ) THEN
         INFO = -3
      ELSE IF( N.LT.0 ) THEN
         INFO = -5
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -7
      ELSE IF( LDB.LT.MAX( 1, N ) ) THEN
         INFO = -9
      ELSE IF( LDVSL.LT.1 .OR. ( ILVSL .AND. LDVSL.LT.N ) ) THEN
         INFO = -14
      ELSE IF( LDVSR.LT.1 .OR. ( ILVSR .AND. LDVSR.LT.N ) ) THEN
         INFO = -16
      END IF
*
*     Compute workspace
*      (Note: Comments in the code beginning "Workspace:" describe the
*       minimal amount of workspace needed at that point in the code,
*       as well as the preferred amount for good performance.
*       NB refers to the optimal block size for the immediately
*       following subroutine, as returned by ILAENV.)
*
      LWKMIN = 1
      IF( INFO.EQ.0 .AND. ( LWORK.GE.1 .OR. LQUERY ) ) THEN
         LWKMIN = MAX( 1, 2*N )
         LWKOPT = N + N*ILAENV( 1, 'CGEQRF', ' ', N, 1, N, 0 )
         IF( ILVSL ) THEN
            LWKOPT = MAX( LWKOPT, N+N*ILAENV( 1, 'CUNGQR', ' ', N, 1, N,
     $               -1 ) )
         END IF
         WORK( 1 ) = LWKOPT
      END IF
*
      IF( LWORK.LT.LWKMIN .AND. .NOT.LQUERY )
     $   INFO = -18
*
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'CGGES ', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         RETURN
      END IF
*
*     Quick return if possible
*
      WORK( 1 ) = LWKOPT
      IF( N.EQ.0 ) THEN
         SDIM = 0
         RETURN
      END IF
*
*     Get machine constants
*
      EPS = SLAMCH( 'P' )
      SMLNUM = SLAMCH( 'S' )
      BIGNUM = ONE / SMLNUM
      CALL SLABAD( SMLNUM, BIGNUM )
      SMLNUM = SQRT( SMLNUM ) / EPS
      BIGNUM = ONE / SMLNUM
*
*     Scale A if max element outside range [SMLNUM,BIGNUM]
*
      ANRM = CLANGE( 'M', N, N, A, LDA, RWORK )
      ILASCL = .FALSE.
      IF( ANRM.GT.ZERO .AND. ANRM.LT.SMLNUM ) THEN
         ANRMTO = SMLNUM
         ILASCL = .TRUE.
      ELSE IF( ANRM.GT.BIGNUM ) THEN
         ANRMTO = BIGNUM
         ILASCL = .TRUE.
      END IF
*
      IF( ILASCL )
     $   CALL CLASCL( 'G', 0, 0, ANRM, ANRMTO, N, N, A, LDA, IERR )
*
*     Scale B if max element outside range [SMLNUM,BIGNUM]
*
      BNRM = CLANGE( 'M', N, N, B, LDB, RWORK )
      ILBSCL = .FALSE.
      IF( BNRM.GT.ZERO .AND. BNRM.LT.SMLNUM ) THEN
         BNRMTO = SMLNUM
         ILBSCL = .TRUE.
      ELSE IF( BNRM.GT.BIGNUM ) THEN
         BNRMTO = BIGNUM
         ILBSCL = .TRUE.
      END IF
*
      IF( ILBSCL )
     $   CALL CLASCL( 'G', 0, 0, BNRM, BNRMTO, N, N, B, LDB, IERR )
*
*     Permute the matrix to make it more nearly triangular
*     (Real Workspace: need 6*N)
*
      ILEFT = 1
      IRIGHT = N + 1
      IRWRK = IRIGHT + N
      CALL CGGBAL( 'P', N, A, LDA, B, LDB, ILO, IHI, RWORK( ILEFT ),
     $             RWORK( IRIGHT ), RWORK( IRWRK ), IERR )
*
*     Reduce B to triangular form (QR decomposition of B)
*     (Complex Workspace: need N, prefer N*NB)
*
      IROWS = IHI + 1 - ILO
      ICOLS = N + 1 - ILO
      ITAU = 1
      IWRK = ITAU + IROWS
      CALL CGEQRF( IROWS, ICOLS, B( ILO, ILO ), LDB, WORK( ITAU ),
     $             WORK( IWRK ), LWORK+1-IWRK, IERR )
*
*     Apply the orthogonal transformation to matrix A
*     (Complex Workspace: need N, prefer N*NB)
*
      CALL CUNMQR( 'L', 'C', IROWS, ICOLS, IROWS, B( ILO, ILO ), LDB,
     $             WORK( ITAU ), A( ILO, ILO ), LDA, WORK( IWRK ),
     $             LWORK+1-IWRK, IERR )
*
*     Initialize VSL
*     (Complex Workspace: need N, prefer N*NB)
*
      IF( ILVSL ) THEN
         CALL CLASET( 'Full', N, N, CZERO, CONE, VSL, LDVSL )
         CALL CLACPY( 'L', IROWS-1, IROWS-1, B( ILO+1, ILO ), LDB,
     $                VSL( ILO+1, ILO ), LDVSL )
         CALL CUNGQR( IROWS, IROWS, IROWS, VSL( ILO, ILO ), LDVSL,
     $                WORK( ITAU ), WORK( IWRK ), LWORK+1-IWRK, IERR )
      END IF
*
*     Initialize VSR
*
      IF( ILVSR )
     $   CALL CLASET( 'Full', N, N, CZERO, CONE, VSR, LDVSR )
*
*     Reduce to generalized Hessenberg form
*     (Workspace: none needed)
*
      CALL CGGHRD( JOBVSL, JOBVSR, N, ILO, IHI, A, LDA, B, LDB, VSL,
     $             LDVSL, VSR, LDVSR, IERR )
*
      SDIM = 0
*
*     Perform QZ algorithm, computing Schur vectors if desired
*     (Complex Workspace: need N)
*     (Real Workspace: need N)
*
      IWRK = ITAU
      CALL CHGEQZ( 'S', JOBVSL, JOBVSR, N, ILO, IHI, A, LDA, B, LDB,
     $             ALPHA, BETA, VSL, LDVSL, VSR, LDVSR, WORK( IWRK ),
     $             LWORK+1-IWRK, RWORK( IRWRK ), IERR )
      IF( IERR.NE.0 ) THEN
         IF( IERR.GT.0 .AND. IERR.LE.N ) THEN
            INFO = IERR
         ELSE IF( IERR.GT.N .AND. IERR.LE.2*N ) THEN
            INFO = IERR - N
         ELSE
            INFO = N + 1
         END IF
         GO TO 30
      END IF
*
*     Sort eigenvalues ALPHA/BETA if desired
*     (Workspace: none needed)
*
      IF( WANTST ) THEN
*
*        Undo scaling on eigenvalues before selecting
*
         IF( ILASCL )
     $      CALL CLASCL( 'G', 0, 0, ANRM, ANRMTO, N, 1, ALPHA, N, IERR )
         IF( ILBSCL )
     $      CALL CLASCL( 'G', 0, 0, BNRM, BNRMTO, N, 1, BETA, N, IERR )
*
*        Select eigenvalues
*
         DO 10 I = 1, N
            BWORK( I ) = SELCTG( ALPHA( I ), BETA( I ) )
   10    CONTINUE
*
         CALL CTGSEN( 0, ILVSL, ILVSR, BWORK, N, A, LDA, B, LDB, ALPHA,
     $                BETA, VSL, LDVSL, VSR, LDVSR, SDIM, PVSL, PVSR,
     $                DIF, WORK( IWRK ), LWORK-IWRK+1, IDUM, 1, IERR )
         IF( IERR.EQ.1 )
     $      INFO = N + 3
*
      END IF
*
*     Apply back-permutation to VSL and VSR
*     (Workspace: none needed)
*
      IF( ILVSL )
     $   CALL CGGBAK( 'P', 'L', N, ILO, IHI, RWORK( ILEFT ),
     $                RWORK( IRIGHT ), N, VSL, LDVSL, IERR )
      IF( ILVSR )
     $   CALL CGGBAK( 'P', 'R', N, ILO, IHI, RWORK( ILEFT ),
     $                RWORK( IRIGHT ), N, VSR, LDVSR, IERR )
*
*     Undo scaling
*
      IF( ILASCL ) THEN
         CALL CLASCL( 'U', 0, 0, ANRMTO, ANRM, N, N, A, LDA, IERR )
         CALL CLASCL( 'G', 0, 0, ANRMTO, ANRM, N, 1, ALPHA, N, IERR )
      END IF
*
      IF( ILBSCL ) THEN
         CALL CLASCL( 'U', 0, 0, BNRMTO, BNRM, N, N, B, LDB, IERR )
         CALL CLASCL( 'G', 0, 0, BNRMTO, BNRM, N, 1, BETA, N, IERR )
      END IF
*
      IF( WANTST ) THEN
*
*        Check if reordering is correct
*
         LASTSL = .TRUE.
         SDIM = 0
         DO 20 I = 1, N
            CURSL = SELCTG( ALPHA( I ), BETA( I ) )
            IF( CURSL )
     $         SDIM = SDIM + 1
            IF( CURSL .AND. .NOT.LASTSL )
     $         INFO = N + 2
            LASTSL = CURSL
   20    CONTINUE
*
      END IF
*
   30 CONTINUE
*
      WORK( 1 ) = LWKOPT
*
      RETURN
*
*     End of CGGES
*
      END

C
C $Id: tdline.f,v 1.4 2008-07-27 00:17:32 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE TDLINE (UCP1,VCP1,WCP1,UCP2,VCP2,WCP2)
C
C This routine draws a line joining the projections of two points in
C 3-space.  The points are defined by their positions in 3-space.
C
C Project the two points.
C
        CALL TDPRPT (UCP1,VCP1,WCP1,XCP1,YCP1)
        CALL TDPRPT (UCP2,VCP2,WCP2,XCP2,YCP2)
C
C Draw the line joining the projected points.
C
        CALL LINE   (XCP1,YCP1,XCP2,YCP2)
C
C Done.
C
        RETURN
C
      END

C
C $Id: mapgtd.f,v 1.8 2008-09-18 00:42:16 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MAPGTD (WHCH,DVAL)
        CHARACTER*(*)    WHCH
        DOUBLE PRECISION DVAL
        IF (ICFELL('MAPGTD - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
        CALL MDGETD (WHCH,DVAL)
        IF (ICFELL('MAPGTD',2).NE.0) RETURN
        RETURN
      END

C
C	$Id: gwid2r.f,v 1.4 2008-07-27 00:21:07 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GWID2R
C
C  Copy "DEFAULT" attribute context to "REQUESTED" context.
C
      include 'gwiarq.h'
      include 'gwiadf.h'
C
      INTEGER  I
C
      SAVE
C
C  Polyline attributes.
C
      MRPLIX = MDPLIX
      MRLTYP = MDLTYP
      ARLWSC = ADLWSC
      MRPLCI = MDPLCI
C
C  Polymarker attributes.
C
      MRPMIX = MDPMIX
      MRMTYP = MDMTYP
      ARMSZS = ADMSZS
      MRPMCI = MDPMCI
C
C  Text attributes.
C
      MRTXIX    = MDTXIX
      MRTXP     = MDTXP
      MRTXAL(1) = MDTXAL(1)
      MRTXAL(2) = MDTXAL(2)
      MRCHH     = MDCHH
      DO 10 I=1,4
        MRCHOV(I) = MDCHOV(I)
   10 CONTINUE
      MRTXFO = MDTXFO
      MRTXPR = MDTXPR
      ARCHXP = ADCHXP
      ARCHSP = ADCHSP
      MRTXCI = MDTXCI
C
C  Fill area attributes.
C
      MRFAIX    = MDFAIX
      MRPASZ(1) = MDPASZ(1)
      MRPASZ(2) = MDPASZ(2)
      MRPASZ(3) = MDPASZ(3)
      MRPASZ(4) = MDPASZ(4)
      MRPARF(1) = MDPARF(1)
      MRPARF(2) = MDPARF(2)
      MRFAIS    = MDFAIS
      MRFASI    = MDFASI
      MRFACI    = MDFACI
C
C  Aspect source flags.
C
      DO 20 I=1,13
        MRASF(I) = MDASF(I)
   20 CONTINUE
C
      RETURN
      END

C
C $Id: pj21sp.f,v 1.5 2008-07-27 00:17:11 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE PJ21SP (COORD,CRDIO,INDIC)
C
C -- R O B I N S O N
C
      IMPLICIT REAL (A-Z)
      INTEGER IP1,NN
      INTEGER INDIC
      DIMENSION GEOG(2),PROJ(2),COORD(2),CRDIO(2),
     . PR(20),XLR(20)
C **** PARAMETERS **** A,LON0,X0,Y0 ************************************
      COMMON /ERRMZ0/ IERR
        INTEGER IERR
      SAVE   /ERRMZ0/
      COMMON /PRINZ0/ IPEMSG,IPELUN,IPPARM,IPPLUN
        INTEGER IPEMSG,IPELUN,IPPARM,IPPLUN
      SAVE   /PRINZ0/
      COMMON /PC21SP/ A,LON0,X0,Y0,PR,XLR
      DATA DG1 /0.01745329252E0/
      DATA PI /3.14159265358979323846E0/
      DATA EPSLN /1.0E-10/
C
C -- F O R W A R D   . . .
C
      IF (INDIC .EQ. 0) THEN
C
         GEOG(1) = COORD(1)
         GEOG(2) = COORD(2)
         IERR = 0
         LON = ADJLSP (GEOG(1) - LON0)
         P2=ABS(GEOG(2)/5.0E0/DG1)
         IP1=INT(P2-EPSLN)
C
C        STIRLING'S INTERPOLATION FORMULA (USING 2ND DIFF.)
C            USED WITH LOOKUP TABLE TO COMPUTE RECTANGULAR COORDINATES
C            FROM LAT/LONG.
C
         P2=P2-IP1
         X=A*(XLR(IP1+2)+P2*(XLR(IP1+3)-XLR(IP1+1))/2.0E0
     .     +P2*P2*(XLR(IP1+3)-2.0E0*XLR(IP1+2)+XLR(IP1+1))/2.0E0)*LON
         Y=A*(PR(IP1+2)+P2*(PR(IP1+3)-PR(IP1+1))/2.0E0
     .     +P2*P2*(PR(IP1+3)-2.0E0*PR(IP1+2)+PR(IP1+1))/2.0E0)*PI/2.0E0
     .     *SIGN(1.0E0,GEOG(2))
         PROJ(1) = X0 + X
         PROJ(2) = Y0 + Y
         CRDIO(1) = PROJ(1)
         CRDIO(2) = PROJ(2)
         RETURN
      END IF
C
C -- I N V E R S E   . . .
C
      IF (INDIC .EQ. 1) THEN
C
         PROJ(1) = COORD(1)
         PROJ(2) = COORD(2)
         IERR = 0
         X = PROJ(1) - X0
         Y = PROJ(2) - Y0
         YY = 2.0E0 * Y / PI / A
         PHID = YY * 90.0E0
         P2 = ABS(PHID / 5.0E0)
         IP1 = INT(P2 - EPSLN)
         IF (IP1.EQ.0) IP1 = 1
         NN = 0
C
C     STIRLING'S INTERPOLATION FORMULA AS USED IN FORWARD TRANSFORMATION
C     IS REVERSED FOR FIRST ESTIMATION OF LAT. FROM RECTANGULAR
C     COORDINATES.  LAT. IS THEN ADJUSTED BY ITERATION UNTIL USE OF
C     FORWARD SERIES PROVIDES CORRECT VALUE OF Y WITHIN TOLERANCE.
C
  230    U = PR(IP1 + 3) - PR(IP1 + 1)
         V = PR(IP1 + 3) - 2.0E0 * PR(IP1 + 2) + PR(IP1 + 1)
         T = 2.0E0 * (ABS(YY) - PR(IP1 + 2))/ U
         C = V / U
         P2 = T * (1.0E0 - C * T * (1.0E0 - 2.0E0 * C * T))
         IF (P2.LT.0.0E0.AND.IP1.NE.1) GO TO 240
         PHID = SIGN((P2 + IP1) * 5.0E0, Y)
  235    P2 = ABS(PHID / 5.0E0)
         IP1 = INT(P2 - EPSLN)
         P2 = P2 - IP1
         Y1=A*(PR(IP1+2)+P2*(PR(IP1+3)-PR(IP1+1))/2.0E0
     .     +P2*P2*(PR(IP1+3)-2.0E0*PR(IP1+2)+PR(IP1+1))/2.0E0)*PI/2.0E0
     .     * SIGN(1.0E0,Y)
         PHID = PHID - 180.0E0* (Y1 - Y) / PI / A
         NN = NN + 1
         IF (NN.LE.20) GO TO 237
         IF (IPEMSG .EQ. 0) WRITE (IPELUN,245)
         IERR = 214
         RETURN
  237    IF (ABS(Y1 - Y).GT.0.00001E0) GO TO 235
         GO TO 250
  240    IP1 = IP1 - 1
         GO TO 230
  245    FORMAT (/' ERROR PJ21SP'/
     .            ' TOO MANY ITERATIONS FOR INVERSE ROBINSON')
  250    GEOG(2) = PHID * DG1
C
C        CALCULATE LONG. USING FINAL LAT. WITH TRANSPOSED FORWARD
C        STIRLING'S INTERPOLATION FORMULA.
C
         GEOG(1)=LON0+X/A/(XLR(IP1+2)+P2*(XLR(IP1+3)-XLR(IP1+1))/2.0E0
     .     +P2*P2*(XLR(IP1+3)-2.0E0*XLR(IP1+2)+XLR(IP1+1))/2.0E0)
         GEOG(1) = ADJLSP(GEOG(1))
         CRDIO(1) = GEOG(1)
         CRDIO(2) = GEOG(2)
         RETURN
      END IF
C
      END

C
C $Id: phi3sp.f,v 1.5 2008-07-27 00:17:10 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      REAL FUNCTION PHI3SP (ML,E0,E1,E2,E3)
C
C FUNCTION TO COMPUTE LATITUDE ANGLE (PHI-3).
C
      IMPLICIT REAL (A-Z)
      INTEGER II,NIT
      COMMON /ERRMZ0/ IERR
        INTEGER IERR
      SAVE   /ERRMZ0/
      COMMON /PRINZ0/ IPEMSG,IPELUN,IPPARM,IPPLUN
        INTEGER IPEMSG,IPELUN,IPPARM,IPPLUN
      SAVE   /PRINZ0/
      DATA TWO,FOUR,SIX /2.0E0,4.0E0,6.0E0/
      DATA TOL,NIT /1.0E-10,15/
C
      PHI = ML
      DO 020 II = 1,NIT
      DPHI = (ML + E1 * SIN (TWO * PHI) - E2 * SIN (FOUR * PHI)
     .       + E3 * SIN (SIX * PHI)) / E0 - PHI
      PHI = PHI + DPHI
      IF (ABS(DPHI) .GT. TOL) GO TO 020
      PHI3SP = PHI
      RETURN
  020 CONTINUE
C
      IF (IPEMSG .EQ. 0) WRITE (IPELUN,2000) NIT,ML,E0,E1,E2,E3
 2000 FORMAT (/' ERROR PHI3SP' /
     .         ' LATITUDE FAILED TO CONVERGE AFTER',I3,' ITERATIONS'/
     .         ' ML =',E25.16,'   E0 =',E25.16/
     .         ' E1 =',E25.16,'   E2 =',E25.16,'   E3=',E25.16)
      IERR = 003
      RETURN
C
      END

C
C $Id: mdritd.f,v 1.8 2008-09-18 00:42:18 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MDRITD (IAXS,ANGL,UCRD,VCRD,WCRD)
C
        INTEGER          IAXS
        DOUBLE PRECISION ANGL,UCRD,VCRD,WCRD
C
C Declare common block containing math constants.
C
        COMMON /MAPCM0/  COS1,DTOR,DTRH,OOPI,PI,PIOF,PIOT,RTDD,RTOD,
     +                   SROT,SIN1,TOPI,TSRT
        DOUBLE PRECISION COS1,DTOR,DTRH,OOPI,PI,PIOF,PIOT,RTDD,RTOD,
     +                   SROT,SIN1,TOPI,TSRT
        SAVE   /MAPCM0/
C
C Declare local variables.
C
        DOUBLE PRECISION SINA,COSA,UTMP,VTMP,WTMP
C
C This routine rotates the point with coordinates (UCRD,VCRD,WCRD) by
C the angle ANGL about the axis specified by IAXS (1 for the U axis,
C 2 for the V axis, 3 for the W axis).  A right-handed coordinate
C system is assumed.
C
        SINA=SIN(DTOR*ANGL)
        COSA=COS(DTOR*ANGL)
C
        UTMP=UCRD
        VTMP=VCRD
        WTMP=WCRD
C
        IF (IAXS.EQ.1) THEN
          VCRD=VTMP*COSA-WTMP*SINA
          WCRD=WTMP*COSA+VTMP*SINA
        ELSE IF (IAXS.EQ.2) THEN
          UCRD=UTMP*COSA+WTMP*SINA
          WCRD=WTMP*COSA-UTMP*SINA
        ELSE
          UCRD=UTMP*COSA-VTMP*SINA
          VCRD=VTMP*COSA+UTMP*SINA
        END IF
C
        RETURN
C
      END

      SUBROUTINE CBDSQR( UPLO, N, NCVT, NRU, NCC, D, E, VT, LDVT, U,
     $                   LDU, C, LDC, RWORK, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     October 31, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          UPLO
      INTEGER            INFO, LDC, LDU, LDVT, N, NCC, NCVT, NRU
*     ..
*     .. Array Arguments ..
      REAL               D( * ), E( * ), RWORK( * )
      COMPLEX            C( LDC, * ), U( LDU, * ), VT( LDVT, * )
*     ..
*
*  Purpose
*  =======
*
*  CBDSQR computes the singular value decomposition (SVD) of a real
*  N-by-N (upper or lower) bidiagonal matrix B:  B = Q * S * P' (P'
*  denotes the transpose of P), where S is a diagonal matrix with
*  non-negative diagonal elements (the singular values of B), and Q
*  and P are orthogonal matrices.
*
*  The routine computes S, and optionally computes U * Q, P' * VT,
*  or Q' * C, for given complex input matrices U, VT, and C.
*
*  See "Computing  Small Singular Values of Bidiagonal Matrices With
*  Guaranteed High Relative Accuracy," by J. Demmel and W. Kahan,
*  LAPACK Working Note #3 (or SIAM J. Sci. Statist. Comput. vol. 11,
*  no. 5, pp. 873-912, Sept 1990) and
*  "Accurate singular values and differential qd algorithms," by
*  B. Parlett and V. Fernando, Technical Report CPAM-554, Mathematics
*  Department, University of California at Berkeley, July 1992
*  for a detailed description of the algorithm.
*
*  Arguments
*  =========
*
*  UPLO    (input) CHARACTER*1
*          = 'U':  B is upper bidiagonal;
*          = 'L':  B is lower bidiagonal.
*
*  N       (input) INTEGER
*          The order of the matrix B.  N >= 0.
*
*  NCVT    (input) INTEGER
*          The number of columns of the matrix VT. NCVT >= 0.
*
*  NRU     (input) INTEGER
*          The number of rows of the matrix U. NRU >= 0.
*
*  NCC     (input) INTEGER
*          The number of columns of the matrix C. NCC >= 0.
*
*  D       (input/output) REAL array, dimension (N)
*          On entry, the n diagonal elements of the bidiagonal matrix B.
*          On exit, if INFO=0, the singular values of B in decreasing
*          order.
*
*  E       (input/output) REAL array, dimension (N)
*          On entry, the elements of E contain the
*          offdiagonal elements of of the bidiagonal matrix whose SVD
*          is desired. On normal exit (INFO = 0), E is destroyed.
*          If the algorithm does not converge (INFO > 0), D and E
*          will contain the diagonal and superdiagonal elements of a
*          bidiagonal matrix orthogonally equivalent to the one given
*          as input. E(N) is used for workspace.
*
*  VT      (input/output) COMPLEX array, dimension (LDVT, NCVT)
*          On entry, an N-by-NCVT matrix VT.
*          On exit, VT is overwritten by P' * VT.
*          VT is not referenced if NCVT = 0.
*
*  LDVT    (input) INTEGER
*          The leading dimension of the array VT.
*          LDVT >= max(1,N) if NCVT > 0; LDVT >= 1 if NCVT = 0.
*
*  U       (input/output) COMPLEX array, dimension (LDU, N)
*          On entry, an NRU-by-N matrix U.
*          On exit, U is overwritten by U * Q.
*          U is not referenced if NRU = 0.
*
*  LDU     (input) INTEGER
*          The leading dimension of the array U.  LDU >= max(1,NRU).
*
*  C       (input/output) COMPLEX array, dimension (LDC, NCC)
*          On entry, an N-by-NCC matrix C.
*          On exit, C is overwritten by Q' * C.
*          C is not referenced if NCC = 0.
*
*  LDC     (input) INTEGER
*          The leading dimension of the array C.
*          LDC >= max(1,N) if NCC > 0; LDC >=1 if NCC = 0.
*
*  RWORK   (workspace) REAL array, dimension (4*N)
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  If INFO = -i, the i-th argument had an illegal value
*          > 0:  the algorithm did not converge; D and E contain the
*                elements of a bidiagonal matrix which is orthogonally
*                similar to the input matrix B;  if INFO = i, i
*                elements of E have not converged to zero.
*
*  Internal Parameters
*  ===================
*
*  TOLMUL  REAL, default = max(10,min(100,EPS**(-1/8)))
*          TOLMUL controls the convergence criterion of the QR loop.
*          If it is positive, TOLMUL*EPS is the desired relative
*             precision in the computed singular values.
*          If it is negative, abs(TOLMUL*EPS*sigma_max) is the
*             desired absolute accuracy in the computed singular
*             values (corresponds to relative accuracy
*             abs(TOLMUL*EPS) in the largest singular value.
*          abs(TOLMUL) should be between 1 and 1/EPS, and preferably
*             between 10 (for fast convergence) and .1/EPS
*             (for there to be some accuracy in the results).
*          Default is to lose at either one eighth or 2 of the
*             available decimal digits in each computed singular value
*             (whichever is smaller).
*
*  MAXITR  INTEGER, default = 6
*          MAXITR controls the maximum number of passes of the
*          algorithm through its inner loop. The algorithms stops
*          (and so fails to converge) if the number of passes
*          through the inner loop exceeds MAXITR*N**2.
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ZERO
      PARAMETER          ( ZERO = 0.0E0 )
      REAL               ONE
      PARAMETER          ( ONE = 1.0E0 )
      REAL               NEGONE
      PARAMETER          ( NEGONE = -1.0E0 )
      REAL               HNDRTH
      PARAMETER          ( HNDRTH = 0.01E0 )
      REAL               TEN
      PARAMETER          ( TEN = 10.0E0 )
      REAL               HNDRD
      PARAMETER          ( HNDRD = 100.0E0 )
      REAL               MEIGTH
      PARAMETER          ( MEIGTH = -0.125E0 )
      INTEGER            MAXITR
      PARAMETER          ( MAXITR = 6 )
*     ..
*     .. Local Scalars ..
      LOGICAL            LOWER, ROTATE
      INTEGER            I, IDIR, ISUB, ITER, J, LL, LLL, M, MAXIT, NM1,
     $                   NM12, NM13, OLDLL, OLDM
      REAL               ABSE, ABSS, COSL, COSR, CS, EPS, F, G, H, MU,
     $                   OLDCS, OLDSN, R, SHIFT, SIGMN, SIGMX, SINL,
     $                   SINR, SLL, SMAX, SMIN, SMINL, SMINLO, SMINOA,
     $                   SN, THRESH, TOL, TOLMUL, UNFL
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      REAL               SLAMCH
      EXTERNAL           LSAME, SLAMCH
*     ..
*     .. External Subroutines ..
      EXTERNAL           CLASR, CSROT, CSSCAL, CSWAP, SLARTG, SLAS2,
     $                   SLASQ1, SLASV2, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, MAX, MIN, REAL, SIGN, SQRT
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      LOWER = LSAME( UPLO, 'L' )
      IF( .NOT.LSAME( UPLO, 'U' ) .AND. .NOT.LOWER ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( NCVT.LT.0 ) THEN
         INFO = -3
      ELSE IF( NRU.LT.0 ) THEN
         INFO = -4
      ELSE IF( NCC.LT.0 ) THEN
         INFO = -5
      ELSE IF( ( NCVT.EQ.0 .AND. LDVT.LT.1 ) .OR.
     $         ( NCVT.GT.0 .AND. LDVT.LT.MAX( 1, N ) ) ) THEN
         INFO = -9
      ELSE IF( LDU.LT.MAX( 1, NRU ) ) THEN
         INFO = -11
      ELSE IF( ( NCC.EQ.0 .AND. LDC.LT.1 ) .OR.
     $         ( NCC.GT.0 .AND. LDC.LT.MAX( 1, N ) ) ) THEN
         INFO = -13
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'CBDSQR', -INFO )
         RETURN
      END IF
      IF( N.EQ.0 )
     $   RETURN
      IF( N.EQ.1 )
     $   GO TO 160
*
*     ROTATE is true if any singular vectors desired, false otherwise
*
      ROTATE = ( NCVT.GT.0 ) .OR. ( NRU.GT.0 ) .OR. ( NCC.GT.0 )
*
*     If no singular vectors desired, use qd algorithm
*
      IF( .NOT.ROTATE ) THEN
         CALL SLASQ1( N, D, E, RWORK, INFO )
         RETURN
      END IF
*
      NM1 = N - 1
      NM12 = NM1 + NM1
      NM13 = NM12 + NM1
      IDIR = 0
*
*     Get machine constants
*
      EPS = SLAMCH( 'Epsilon' )
      UNFL = SLAMCH( 'Safe minimum' )
*
*     If matrix lower bidiagonal, rotate to be upper bidiagonal
*     by applying Givens rotations on the left
*
      IF( LOWER ) THEN
         DO 10 I = 1, N - 1
            CALL SLARTG( D( I ), E( I ), CS, SN, R )
            D( I ) = R
            E( I ) = SN*D( I+1 )
            D( I+1 ) = CS*D( I+1 )
            RWORK( I ) = CS
            RWORK( NM1+I ) = SN
   10    CONTINUE
*
*        Update singular vectors if desired
*
         IF( NRU.GT.0 )
     $      CALL CLASR( 'R', 'V', 'F', NRU, N, RWORK( 1 ), RWORK( N ),
     $                  U, LDU )
         IF( NCC.GT.0 )
     $      CALL CLASR( 'L', 'V', 'F', N, NCC, RWORK( 1 ), RWORK( N ),
     $                  C, LDC )
      END IF
*
*     Compute singular values to relative accuracy TOL
*     (By setting TOL to be negative, algorithm will compute
*     singular values to absolute accuracy ABS(TOL)*norm(input matrix))
*
      TOLMUL = MAX( TEN, MIN( HNDRD, EPS**MEIGTH ) )
      TOL = TOLMUL*EPS
*
*     Compute approximate maximum, minimum singular values
*
      SMAX = ZERO
      DO 20 I = 1, N
         SMAX = MAX( SMAX, ABS( D( I ) ) )
   20 CONTINUE
      DO 30 I = 1, N - 1
         SMAX = MAX( SMAX, ABS( E( I ) ) )
   30 CONTINUE
      SMINL = ZERO
      IF( TOL.GE.ZERO ) THEN
*
*        Relative accuracy desired
*
         SMINOA = ABS( D( 1 ) )
         IF( SMINOA.EQ.ZERO )
     $      GO TO 50
         MU = SMINOA
         DO 40 I = 2, N
            MU = ABS( D( I ) )*( MU / ( MU+ABS( E( I-1 ) ) ) )
            SMINOA = MIN( SMINOA, MU )
            IF( SMINOA.EQ.ZERO )
     $         GO TO 50
   40    CONTINUE
   50    CONTINUE
         SMINOA = SMINOA / SQRT( REAL( N ) )
         THRESH = MAX( TOL*SMINOA, MAXITR*N*N*UNFL )
      ELSE
*
*        Absolute accuracy desired
*
         THRESH = MAX( ABS( TOL )*SMAX, MAXITR*N*N*UNFL )
      END IF
*
*     Prepare for main iteration loop for the singular values
*     (MAXIT is the maximum number of passes through the inner
*     loop permitted before nonconvergence signalled.)
*
      MAXIT = MAXITR*N*N
      ITER = 0
      OLDLL = -1
      OLDM = -1
*
*     M points to last element of unconverged part of matrix
*
      M = N
*
*     Begin main iteration loop
*
   60 CONTINUE
*
*     Check for convergence or exceeding iteration count
*
      IF( M.LE.1 )
     $   GO TO 160
      IF( ITER.GT.MAXIT )
     $   GO TO 200
*
*     Find diagonal block of matrix to work on
*
      IF( TOL.LT.ZERO .AND. ABS( D( M ) ).LE.THRESH )
     $   D( M ) = ZERO
      SMAX = ABS( D( M ) )
      SMIN = SMAX
      DO 70 LLL = 1, M - 1
         LL = M - LLL
         ABSS = ABS( D( LL ) )
         ABSE = ABS( E( LL ) )
         IF( TOL.LT.ZERO .AND. ABSS.LE.THRESH )
     $      D( LL ) = ZERO
         IF( ABSE.LE.THRESH )
     $      GO TO 80
         SMIN = MIN( SMIN, ABSS )
         SMAX = MAX( SMAX, ABSS, ABSE )
   70 CONTINUE
      LL = 0
      GO TO 90
   80 CONTINUE
      E( LL ) = ZERO
*
*     Matrix splits since E(LL) = 0
*
      IF( LL.EQ.M-1 ) THEN
*
*        Convergence of bottom singular value, return to top of loop
*
         M = M - 1
         GO TO 60
      END IF
   90 CONTINUE
      LL = LL + 1
*
*     E(LL) through E(M-1) are nonzero, E(LL-1) is zero
*
      IF( LL.EQ.M-1 ) THEN
*
*        2 by 2 block, handle separately
*
         CALL SLASV2( D( M-1 ), E( M-1 ), D( M ), SIGMN, SIGMX, SINR,
     $                COSR, SINL, COSL )
         D( M-1 ) = SIGMX
         E( M-1 ) = ZERO
         D( M ) = SIGMN
*
*        Compute singular vectors, if desired
*
         IF( NCVT.GT.0 )
     $      CALL CSROT( NCVT, VT( M-1, 1 ), LDVT, VT( M, 1 ), LDVT,
     $                  COSR, SINR )
         IF( NRU.GT.0 )
     $      CALL CSROT( NRU, U( 1, M-1 ), 1, U( 1, M ), 1, COSL, SINL )
         IF( NCC.GT.0 )
     $      CALL CSROT( NCC, C( M-1, 1 ), LDC, C( M, 1 ), LDC, COSL,
     $                  SINL )
         M = M - 2
         GO TO 60
      END IF
*
*     If working on new submatrix, choose shift direction
*     (from larger end diagonal element towards smaller)
*
      IF( LL.GT.OLDM .OR. M.LT.OLDLL ) THEN
         IF( ABS( D( LL ) ).GE.ABS( D( M ) ) ) THEN
*
*           Chase bulge from top (big end) to bottom (small end)
*
            IDIR = 1
         ELSE
*
*           Chase bulge from bottom (big end) to top (small end)
*
            IDIR = 2
         END IF
      END IF
*
*     Apply convergence tests
*
      IF( IDIR.EQ.1 ) THEN
*
*        Run convergence test in forward direction
*        First apply standard test to bottom of matrix
*
         IF( ABS( E( M-1 ) ).LE.ABS( TOL )*ABS( D( M ) ) .OR.
     $       ( TOL.LT.ZERO .AND. ABS( E( M-1 ) ).LE.THRESH ) ) THEN
            E( M-1 ) = ZERO
            GO TO 60
         END IF
*
         IF( TOL.GE.ZERO ) THEN
*
*           If relative accuracy desired,
*           apply convergence criterion forward
*
            MU = ABS( D( LL ) )
            SMINL = MU
            DO 100 LLL = LL, M - 1
               IF( ABS( E( LLL ) ).LE.TOL*MU ) THEN
                  E( LLL ) = ZERO
                  GO TO 60
               END IF
               SMINLO = SMINL
               MU = ABS( D( LLL+1 ) )*( MU / ( MU+ABS( E( LLL ) ) ) )
               SMINL = MIN( SMINL, MU )
  100       CONTINUE
         END IF
*
      ELSE
*
*        Run convergence test in backward direction
*        First apply standard test to top of matrix
*
         IF( ABS( E( LL ) ).LE.ABS( TOL )*ABS( D( LL ) ) .OR.
     $       ( TOL.LT.ZERO .AND. ABS( E( LL ) ).LE.THRESH ) ) THEN
            E( LL ) = ZERO
            GO TO 60
         END IF
*
         IF( TOL.GE.ZERO ) THEN
*
*           If relative accuracy desired,
*           apply convergence criterion backward
*
            MU = ABS( D( M ) )
            SMINL = MU
            DO 110 LLL = M - 1, LL, -1
               IF( ABS( E( LLL ) ).LE.TOL*MU ) THEN
                  E( LLL ) = ZERO
                  GO TO 60
               END IF
               SMINLO = SMINL
               MU = ABS( D( LLL ) )*( MU / ( MU+ABS( E( LLL ) ) ) )
               SMINL = MIN( SMINL, MU )
  110       CONTINUE
         END IF
      END IF
      OLDLL = LL
      OLDM = M
*
*     Compute shift.  First, test if shifting would ruin relative
*     accuracy, and if so set the shift to zero.
*
      IF( TOL.GE.ZERO .AND. N*TOL*( SMINL / SMAX ).LE.
     $    MAX( EPS, HNDRTH*TOL ) ) THEN
*
*        Use a zero shift to avoid loss of relative accuracy
*
         SHIFT = ZERO
      ELSE
*
*        Compute the shift from 2-by-2 block at end of matrix
*
         IF( IDIR.EQ.1 ) THEN
            SLL = ABS( D( LL ) )
            CALL SLAS2( D( M-1 ), E( M-1 ), D( M ), SHIFT, R )
         ELSE
            SLL = ABS( D( M ) )
            CALL SLAS2( D( LL ), E( LL ), D( LL+1 ), SHIFT, R )
         END IF
*
*        Test if shift negligible, and if so set to zero
*
         IF( SLL.GT.ZERO ) THEN
            IF( ( SHIFT / SLL )**2.LT.EPS )
     $         SHIFT = ZERO
         END IF
      END IF
*
*     Increment iteration count
*
      ITER = ITER + M - LL
*
*     If SHIFT = 0, do simplified QR iteration
*
      IF( SHIFT.EQ.ZERO ) THEN
         IF( IDIR.EQ.1 ) THEN
*
*           Chase bulge from top to bottom
*           Save cosines and sines for later singular vector updates
*
            CS = ONE
            OLDCS = ONE
            DO 120 I = LL, M - 1
               CALL SLARTG( D( I )*CS, E( I ), CS, SN, R )
               IF( I.GT.LL )
     $            E( I-1 ) = OLDSN*R
               CALL SLARTG( OLDCS*R, D( I+1 )*SN, OLDCS, OLDSN, D( I ) )
               RWORK( I-LL+1 ) = CS
               RWORK( I-LL+1+NM1 ) = SN
               RWORK( I-LL+1+NM12 ) = OLDCS
               RWORK( I-LL+1+NM13 ) = OLDSN
  120       CONTINUE
            H = D( M )*CS
            D( M ) = H*OLDCS
            E( M-1 ) = H*OLDSN
*
*           Update singular vectors
*
            IF( NCVT.GT.0 )
     $         CALL CLASR( 'L', 'V', 'F', M-LL+1, NCVT, RWORK( 1 ),
     $                     RWORK( N ), VT( LL, 1 ), LDVT )
            IF( NRU.GT.0 )
     $         CALL CLASR( 'R', 'V', 'F', NRU, M-LL+1, RWORK( NM12+1 ),
     $                     RWORK( NM13+1 ), U( 1, LL ), LDU )
            IF( NCC.GT.0 )
     $         CALL CLASR( 'L', 'V', 'F', M-LL+1, NCC, RWORK( NM12+1 ),
     $                     RWORK( NM13+1 ), C( LL, 1 ), LDC )
*
*           Test convergence
*
            IF( ABS( E( M-1 ) ).LE.THRESH )
     $         E( M-1 ) = ZERO
*
         ELSE
*
*           Chase bulge from bottom to top
*           Save cosines and sines for later singular vector updates
*
            CS = ONE
            OLDCS = ONE
            DO 130 I = M, LL + 1, -1
               CALL SLARTG( D( I )*CS, E( I-1 ), CS, SN, R )
               IF( I.LT.M )
     $            E( I ) = OLDSN*R
               CALL SLARTG( OLDCS*R, D( I-1 )*SN, OLDCS, OLDSN, D( I ) )
               RWORK( I-LL ) = CS
               RWORK( I-LL+NM1 ) = -SN
               RWORK( I-LL+NM12 ) = OLDCS
               RWORK( I-LL+NM13 ) = -OLDSN
  130       CONTINUE
            H = D( LL )*CS
            D( LL ) = H*OLDCS
            E( LL ) = H*OLDSN
*
*           Update singular vectors
*
            IF( NCVT.GT.0 )
     $         CALL CLASR( 'L', 'V', 'B', M-LL+1, NCVT, RWORK( NM12+1 ),
     $                     RWORK( NM13+1 ), VT( LL, 1 ), LDVT )
            IF( NRU.GT.0 )
     $         CALL CLASR( 'R', 'V', 'B', NRU, M-LL+1, RWORK( 1 ),
     $                     RWORK( N ), U( 1, LL ), LDU )
            IF( NCC.GT.0 )
     $         CALL CLASR( 'L', 'V', 'B', M-LL+1, NCC, RWORK( 1 ),
     $                     RWORK( N ), C( LL, 1 ), LDC )
*
*           Test convergence
*
            IF( ABS( E( LL ) ).LE.THRESH )
     $         E( LL ) = ZERO
         END IF
      ELSE
*
*        Use nonzero shift
*
         IF( IDIR.EQ.1 ) THEN
*
*           Chase bulge from top to bottom
*           Save cosines and sines for later singular vector updates
*
            F = ( ABS( D( LL ) )-SHIFT )*
     $          ( SIGN( ONE, D( LL ) )+SHIFT / D( LL ) )
            G = E( LL )
            DO 140 I = LL, M - 1
               CALL SLARTG( F, G, COSR, SINR, R )
               IF( I.GT.LL )
     $            E( I-1 ) = R
               F = COSR*D( I ) + SINR*E( I )
               E( I ) = COSR*E( I ) - SINR*D( I )
               G = SINR*D( I+1 )
               D( I+1 ) = COSR*D( I+1 )
               CALL SLARTG( F, G, COSL, SINL, R )
               D( I ) = R
               F = COSL*E( I ) + SINL*D( I+1 )
               D( I+1 ) = COSL*D( I+1 ) - SINL*E( I )
               IF( I.LT.M-1 ) THEN
                  G = SINL*E( I+1 )
                  E( I+1 ) = COSL*E( I+1 )
               END IF
               RWORK( I-LL+1 ) = COSR
               RWORK( I-LL+1+NM1 ) = SINR
               RWORK( I-LL+1+NM12 ) = COSL
               RWORK( I-LL+1+NM13 ) = SINL
  140       CONTINUE
            E( M-1 ) = F
*
*           Update singular vectors
*
            IF( NCVT.GT.0 )
     $         CALL CLASR( 'L', 'V', 'F', M-LL+1, NCVT, RWORK( 1 ),
     $                     RWORK( N ), VT( LL, 1 ), LDVT )
            IF( NRU.GT.0 )
     $         CALL CLASR( 'R', 'V', 'F', NRU, M-LL+1, RWORK( NM12+1 ),
     $                     RWORK( NM13+1 ), U( 1, LL ), LDU )
            IF( NCC.GT.0 )
     $         CALL CLASR( 'L', 'V', 'F', M-LL+1, NCC, RWORK( NM12+1 ),
     $                     RWORK( NM13+1 ), C( LL, 1 ), LDC )
*
*           Test convergence
*
            IF( ABS( E( M-1 ) ).LE.THRESH )
     $         E( M-1 ) = ZERO
*
         ELSE
*
*           Chase bulge from bottom to top
*           Save cosines and sines for later singular vector updates
*
            F = ( ABS( D( M ) )-SHIFT )*( SIGN( ONE, D( M ) )+SHIFT /
     $          D( M ) )
            G = E( M-1 )
            DO 150 I = M, LL + 1, -1
               CALL SLARTG( F, G, COSR, SINR, R )
               IF( I.LT.M )
     $            E( I ) = R
               F = COSR*D( I ) + SINR*E( I-1 )
               E( I-1 ) = COSR*E( I-1 ) - SINR*D( I )
               G = SINR*D( I-1 )
               D( I-1 ) = COSR*D( I-1 )
               CALL SLARTG( F, G, COSL, SINL, R )
               D( I ) = R
               F = COSL*E( I-1 ) + SINL*D( I-1 )
               D( I-1 ) = COSL*D( I-1 ) - SINL*E( I-1 )
               IF( I.GT.LL+1 ) THEN
                  G = SINL*E( I-2 )
                  E( I-2 ) = COSL*E( I-2 )
               END IF
               RWORK( I-LL ) = COSR
               RWORK( I-LL+NM1 ) = -SINR
               RWORK( I-LL+NM12 ) = COSL
               RWORK( I-LL+NM13 ) = -SINL
  150       CONTINUE
            E( LL ) = F
*
*           Test convergence
*
            IF( ABS( E( LL ) ).LE.THRESH )
     $         E( LL ) = ZERO
*
*           Update singular vectors if desired
*
            IF( NCVT.GT.0 )
     $         CALL CLASR( 'L', 'V', 'B', M-LL+1, NCVT, RWORK( NM12+1 ),
     $                     RWORK( NM13+1 ), VT( LL, 1 ), LDVT )
            IF( NRU.GT.0 )
     $         CALL CLASR( 'R', 'V', 'B', NRU, M-LL+1, RWORK( 1 ),
     $                     RWORK( N ), U( 1, LL ), LDU )
            IF( NCC.GT.0 )
     $         CALL CLASR( 'L', 'V', 'B', M-LL+1, NCC, RWORK( 1 ),
     $                     RWORK( N ), C( LL, 1 ), LDC )
         END IF
      END IF
*
*     QR iteration finished, go back and check convergence
*
      GO TO 60
*
*     All singular values converged, so make them positive
*
  160 CONTINUE
      DO 170 I = 1, N
         IF( D( I ).LT.ZERO ) THEN
            D( I ) = -D( I )
*
*           Change sign of singular vectors, if desired
*
            IF( NCVT.GT.0 )
     $         CALL CSSCAL( NCVT, NEGONE, VT( I, 1 ), LDVT )
         END IF
  170 CONTINUE
*
*     Sort the singular values into decreasing order (insertion sort on
*     singular values, but only one transposition per singular vector)
*
      DO 190 I = 1, N - 1
*
*        Scan for smallest D(I)
*
         ISUB = 1
         SMIN = D( 1 )
         DO 180 J = 2, N + 1 - I
            IF( D( J ).LE.SMIN ) THEN
               ISUB = J
               SMIN = D( J )
            END IF
  180    CONTINUE
         IF( ISUB.NE.N+1-I ) THEN
*
*           Swap singular values and vectors
*
            D( ISUB ) = D( N+1-I )
            D( N+1-I ) = SMIN
            IF( NCVT.GT.0 )
     $         CALL CSWAP( NCVT, VT( ISUB, 1 ), LDVT, VT( N+1-I, 1 ),
     $                     LDVT )
            IF( NRU.GT.0 )
     $         CALL CSWAP( NRU, U( 1, ISUB ), 1, U( 1, N+1-I ), 1 )
            IF( NCC.GT.0 )
     $         CALL CSWAP( NCC, C( ISUB, 1 ), LDC, C( N+1-I, 1 ), LDC )
         END IF
  190 CONTINUE
      GO TO 220
*
*     Maximum number of iterations exceeded, failure to converge
*
  200 CONTINUE
      INFO = 0
      DO 210 I = 1, N - 1
         IF( E( I ).NE.ZERO )
     $      INFO = INFO + 1
  210 CONTINUE
  220 CONTINUE
      RETURN
*
*     End of CBDSQR
*
      END

C
C       $Id: ezvec.f,v 1.6 2008-07-27 00:17:34 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE EZVEC (U,V,M,N)
C
C THIS SUBROUTINE IS FOR THE USER WHO WANTS A QUICK-AND-DIRTY VECTOR
C PLOT WITH DEFAULT VALUES FOR MOST OF THE ARGUMENTS.
C
        SAVE
C
      DIMENSION       U(M,N)     ,V(M,N)     ,SPVAL(2)
C
      DATA FLO,HI,NSET,LENGTH,ISPV,SPVAL(1),SPVAL(2) /
     +      0.,0.,   0,     0,   0,      0.,      0. /
C
      CALL VELVCT (U,M,V,M,M,N,FLO,HI,NSET,LENGTH,ISPV,SPVAL)
      CALL FRAME
      RETURN
      END

C
C $Id: bcfcrv.f,v 1.5 2008-07-27 00:17:29 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE BCFCRV(BXI,BYI,NO,XO,YO)
C
C  This subroutine takes the four Bezier specification points in
C  BXI and BYI and returns an array of points ((XO(L),YO(L),L=1,NO)
C  along the Bezier curve using the cubic parametric equations for
C  the Bezier curve.  This subroutine is invoked only when the
C  subdivision algorithm is being overridden by user request.
C
C
      DIMENSION BXI(4),BYI(4),XO(NO),YO(NO)
C
C  Do a call forcing a BLOCKDATA to be loaded from a binary library.
C
      CALL PCBLDA
C
C  Compute the cubic polynomial coefficients.
C
      DX = BXI(1)
      CX = 3.*(BXI(2)-BXI(1))
      BX = 3.*(BXI(3)-BXI(2))-CX
      AX = BXI(4)-BXI(1)-CX-BX
C
      DY = BYI(1)
      CY = 3.*(BYI(2)-BYI(1))
      BY = 3.*(BYI(3)-BYI(2))-CY
      AY = BYI(4)-BYI(1)-CY-BY
C
C  Compute the points along the curve.
C
      XO(1) = BXI(1)
      YO(1) = BYI(1)
C
      AINC = 1./(NO-1)
      DO 10 I=2,NO
        T = REAL(I-1)*AINC
        XO(I) = ((AX*T+BX)*T+CX)*T+DX
        YO(I) = ((AY*T+BY)*T+CY)*T+DY
   10 CONTINUE
C
      RETURN
      END

      DOUBLE PRECISION FUNCTION DLAPY3( X, Y, Z )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     October 31, 1992
*
*     .. Scalar Arguments ..
      DOUBLE PRECISION   X, Y, Z
*     ..
*
*  Purpose
*  =======
*
*  DLAPY3 returns sqrt(x**2+y**2+z**2), taking care not to cause
*  unnecessary overflow.
*
*  Arguments
*  =========
*
*  X       (input) DOUBLE PRECISION
*  Y       (input) DOUBLE PRECISION
*  Z       (input) DOUBLE PRECISION
*          X, Y and Z specify the values x, y and z.
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO
      PARAMETER          ( ZERO = 0.0D0 )
*     ..
*     .. Local Scalars ..
      DOUBLE PRECISION   W, XABS, YABS, ZABS
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, MAX, SQRT
*     ..
*     .. Executable Statements ..
*
      XABS = ABS( X )
      YABS = ABS( Y )
      ZABS = ABS( Z )
      W = MAX( XABS, YABS, ZABS )
      IF( W.EQ.ZERO ) THEN
         DLAPY3 = ZERO
      ELSE
         DLAPY3 = W*SQRT( ( XABS / W )**2+( YABS / W )**2+
     $            ( ZABS / W )**2 )
      END IF
      RETURN
*
*     End of DLAPY3
*
      END

C
C	$Id: lodctb.f,v 1.4 2008-07-27 00:59:04 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE LODCTB(IOS,STATUS)
C
C  Send out the color table to the device.
C
C  OUTPUT
C    IOS    -  The I/O status, valid only if STATUS is non-zero.
C    STATUS -  The status of the request, defined by COMMON TREROR.
C
      COMMON/TREROR/ ALLOK, MFRCHK, MTOPER, METRDC, REDERR, TYPCHG
     1             ,INVTYP, MINVLD, TYPERR, FRMEND, ENCINT, IVDCDT
     2             ,GCOERR, GCRERR, GCCERR, FCOERR, FCRERR, FCCERR
     3             ,PLIDXG, PMIDXG, TXIDXG, PGIDXG, INVLMT, CELERR
     4             ,COIERR, COLNRM, UNKNOW, UNKOPC, ENDMTF, VNEROR
     5             ,BADRSZ, DEVOUT, NOVERS, BADFNT, PGMERR, FASERR
     6             ,HINERR, VDWERR, RDWERR, RIXLIM
      INTEGER        ALLOK, MFRCHK, MTOPER, METRDC, REDERR, TYPCHG
     1             ,INVTYP, MINVLD, TYPERR, FRMEND, ENCINT, IVDCDT
     2             ,GCOERR, GCRERR, GCCERR, FCOERR, FCRERR, FCCERR
     3             ,PLIDXG, PMIDXG, TXIDXG, PGIDXG, INVLMT, CELERR
     4             ,COIERR, COLNRM, UNKNOW, UNKOPC, ENDMTF, VNEROR
     5             ,BADRSZ, DEVOUT, NOVERS, BADFNT, PGMERR, FASERR
     6             ,HINERR, VDWERR, RDWERR, RIXLIM
      COMMON /CINFO/COLVLS,INTS,NUMI
      DIMENSION COLVLS(3,256),INTS(256)
C
      INTEGER IOS, STATUS
C
      STATUS = ALLOK
      CALL GSCR(1,0,0.,0.,0.)
      DO 10 I=1,NUMI
      CALL GSCR(1,I,COLVLS(1,I),COLVLS(2,I),COLVLS(3,I))
   10 CONTINUE
C
      RETURN
      END

C
C $Id: mdrgdi.f,v 1.9 2008-09-18 00:42:18 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MDRGDI (DINM)
C
C This routine is expected to return the name of the directory in which
C the RANGS/GSHHS data files have been placed.
C
        CHARACTER*(*) DINM
C
C The pathname for the directory is obtained from the NCAR Graphics
C routine GNGPAT, which examines various environment variables and
C returns a value for DINM, as follows:
C
C   Environment variable set:   Value returned in DINM:
C   -------------------------   ------------------------------------
C   NCARG_RANGS                 $NCARG_RANGS
C   NCARG_DATABASE              $NCARG_DATABASE/rangs
C   NCARG_NCARG                 $NCARG_NCARG/database/rangs
C   NCARG_LIB                   $NCARG_LIB/ncarg/database/rangs
C   NCARG_ROOT                  $NCARG_ROOT/lib/ncarg/database/rangs
C
C (A user could also elect to supply his or her own version of MDRGDI,
C in which the value of DINM is set directly.)
C
        CALL GNGPAT (DINM,'rangs',ISTA)
C
C If the status parameter is anything other than -1, we have the value
C we need; otherwise, log an error and return.
C
        IF (ISTA.EQ.-1) THEN
          CALL SETER ('MDRGDI - REPLACE ME - RETURN NAME OF DIRECTORY CO
     +NTAINING DATA',1,1)
          DINM='.'
        END IF
C
C Done.
C
        RETURN
C
      END

C
C $Id: agdshn.f,v 1.6 2008-07-27 00:14:34 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      CHARACTER*16 FUNCTION AGDSHN (IDSH)
C
C The value of this function is the name of the dash pattern numbered
C IDSH - that is to say, the character string 'DASH/PATTERN/n.', where
C n is an integer between 1 and 99, equal to MAX(1,MIN(99,IDSH)).
C
      AGDSHN='DASH/PATTERN/  .'
C
      KDSH=MAX(1,MIN(99,IDSH))
C
      DO 101 I=15,14,-1
        AGDSHN(I:I)=CHAR(ICHAR('0')+MOD(KDSH,10))
        IF (KDSH.LE.9) GO TO 102
        KDSH=KDSH/10
  101 CONTINUE
C
  102 RETURN
C
      END

      SUBROUTINE CLAHRD( N, K, NB, A, LDA, TAU, T, LDT, Y, LDY )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      INTEGER            K, LDA, LDT, LDY, N, NB
*     ..
*     .. Array Arguments ..
      COMPLEX            A( LDA, * ), T( LDT, NB ), TAU( NB ),
     $                   Y( LDY, NB )
*     ..
*
*  Purpose
*  =======
*
*  CLAHRD reduces the first NB columns of a complex general n-by-(n-k+1)
*  matrix A so that elements below the k-th subdiagonal are zero. The
*  reduction is performed by a unitary similarity transformation
*  Q' * A * Q. The routine returns the matrices V and T which determine
*  Q as a block reflector I - V*T*V', and also the matrix Y = A * V * T.
*
*  This is an auxiliary routine called by CGEHRD.
*
*  Arguments
*  =========
*
*  N       (input) INTEGER
*          The order of the matrix A.
*
*  K       (input) INTEGER
*          The offset for the reduction. Elements below the k-th
*          subdiagonal in the first NB columns are reduced to zero.
*
*  NB      (input) INTEGER
*          The number of columns to be reduced.
*
*  A       (input/output) COMPLEX array, dimension (LDA,N-K+1)
*          On entry, the n-by-(n-k+1) general matrix A.
*          On exit, the elements on and above the k-th subdiagonal in
*          the first NB columns are overwritten with the corresponding
*          elements of the reduced matrix; the elements below the k-th
*          subdiagonal, with the array TAU, represent the matrix Q as a
*          product of elementary reflectors. The other columns of A are
*          unchanged. See Further Details.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(1,N).
*
*  TAU     (output) COMPLEX array, dimension (NB)
*          The scalar factors of the elementary reflectors. See Further
*          Details.
*
*  T       (output) COMPLEX array, dimension (LDT,NB)
*          The upper triangular matrix T.
*
*  LDT     (input) INTEGER
*          The leading dimension of the array T.  LDT >= NB.
*
*  Y       (output) COMPLEX array, dimension (LDY,NB)
*          The n-by-nb matrix Y.
*
*  LDY     (input) INTEGER
*          The leading dimension of the array Y. LDY >= max(1,N).
*
*  Further Details
*  ===============
*
*  The matrix Q is represented as a product of nb elementary reflectors
*
*     Q = H(1) H(2) . . . H(nb).
*
*  Each H(i) has the form
*
*     H(i) = I - tau * v * v'
*
*  where tau is a complex scalar, and v is a complex vector with
*  v(1:i+k-1) = 0, v(i+k) = 1; v(i+k+1:n) is stored on exit in
*  A(i+k+1:n,i), and tau in TAU(i).
*
*  The elements of the vectors v together form the (n-k+1)-by-nb matrix
*  V which is needed, with T and Y, to apply the transformation to the
*  unreduced part of the matrix, using an update of the form:
*  A := (I - V*T*V') * (A - Y*V').
*
*  The contents of A on exit are illustrated by the following example
*  with n = 7, k = 3 and nb = 2:
*
*     ( a   h   a   a   a )
*     ( a   h   a   a   a )
*     ( a   h   a   a   a )
*     ( h   h   a   a   a )
*     ( v1  h   a   a   a )
*     ( v1  v2  a   a   a )
*     ( v1  v2  a   a   a )
*
*  where a denotes an element of the original matrix A, h denotes a
*  modified element of the upper Hessenberg matrix H, and vi denotes an
*  element of the vector defining H(i).
*
*  =====================================================================
*
*     .. Parameters ..
      COMPLEX            ZERO, ONE
      PARAMETER          ( ZERO = ( 0.0E+0, 0.0E+0 ),
     $                   ONE = ( 1.0E+0, 0.0E+0 ) )
*     ..
*     .. Local Scalars ..
      INTEGER            I
      COMPLEX            EI
*     ..
*     .. External Subroutines ..
      EXTERNAL           CAXPY, CCOPY, CGEMV, CLACGV, CLARFG, CSCAL,
     $                   CTRMV
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MIN
*     ..
*     .. Executable Statements ..
*
*     Quick return if possible
*
      IF( N.LE.1 )
     $   RETURN
*
      DO 10 I = 1, NB
         IF( I.GT.1 ) THEN
*
*           Update A(1:n,i)
*
*           Compute i-th column of A - Y * V'
*
            CALL CLACGV( I-1, A( K+I-1, 1 ), LDA )
            CALL CGEMV( 'No transpose', N, I-1, -ONE, Y, LDY,
     $                  A( K+I-1, 1 ), LDA, ONE, A( 1, I ), 1 )
            CALL CLACGV( I-1, A( K+I-1, 1 ), LDA )
*
*           Apply I - V * T' * V' to this column (call it b) from the
*           left, using the last column of T as workspace
*
*           Let  V = ( V1 )   and   b = ( b1 )   (first I-1 rows)
*                    ( V2 )             ( b2 )
*
*           where V1 is unit lower triangular
*
*           w := V1' * b1
*
            CALL CCOPY( I-1, A( K+1, I ), 1, T( 1, NB ), 1 )
            CALL CTRMV( 'Lower', 'Conjugate transpose', 'Unit', I-1,
     $                  A( K+1, 1 ), LDA, T( 1, NB ), 1 )
*
*           w := w + V2'*b2
*
            CALL CGEMV( 'Conjugate transpose', N-K-I+1, I-1, ONE,
     $                  A( K+I, 1 ), LDA, A( K+I, I ), 1, ONE,
     $                  T( 1, NB ), 1 )
*
*           w := T'*w
*
            CALL CTRMV( 'Upper', 'Conjugate transpose', 'Non-unit', I-1,
     $                  T, LDT, T( 1, NB ), 1 )
*
*           b2 := b2 - V2*w
*
            CALL CGEMV( 'No transpose', N-K-I+1, I-1, -ONE, A( K+I, 1 ),
     $                  LDA, T( 1, NB ), 1, ONE, A( K+I, I ), 1 )
*
*           b1 := b1 - V1*w
*
            CALL CTRMV( 'Lower', 'No transpose', 'Unit', I-1,
     $                  A( K+1, 1 ), LDA, T( 1, NB ), 1 )
            CALL CAXPY( I-1, -ONE, T( 1, NB ), 1, A( K+1, I ), 1 )
*
            A( K+I-1, I-1 ) = EI
         END IF
*
*        Generate the elementary reflector H(i) to annihilate
*        A(k+i+1:n,i)
*
         EI = A( K+I, I )
         CALL CLARFG( N-K-I+1, EI, A( MIN( K+I+1, N ), I ), 1,
     $                TAU( I ) )
         A( K+I, I ) = ONE
*
*        Compute  Y(1:n,i)
*
         CALL CGEMV( 'No transpose', N, N-K-I+1, ONE, A( 1, I+1 ), LDA,
     $               A( K+I, I ), 1, ZERO, Y( 1, I ), 1 )
         CALL CGEMV( 'Conjugate transpose', N-K-I+1, I-1, ONE,
     $               A( K+I, 1 ), LDA, A( K+I, I ), 1, ZERO, T( 1, I ),
     $               1 )
         CALL CGEMV( 'No transpose', N, I-1, -ONE, Y, LDY, T( 1, I ), 1,
     $               ONE, Y( 1, I ), 1 )
         CALL CSCAL( N, TAU( I ), Y( 1, I ), 1 )
*
*        Compute T(1:i,i)
*
         CALL CSCAL( I-1, -TAU( I ), T( 1, I ), 1 )
         CALL CTRMV( 'Upper', 'No transpose', 'Non-unit', I-1, T, LDT,
     $               T( 1, I ), 1 )
         T( I, I ) = TAU( I )
*
   10 CONTINUE
      A( K+NB, NB ) = EI
*
      RETURN
*
*     End of CLAHRD
*
      END

C
C	$Id: mkmsk.f,v 1.4 2008-07-27 00:17:21 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MKMSK
C
C  THIS ROUTINE GENERATES THE MACHINE-DEPENDENT DATA VALUES
C  USED BY XTCH.
C
C
      COMMON/PINIT/MASK(4),MASK6(64),MASK12(64),LAST6,LAST12,
     +     IBIT15,MASK14,NUM15U,NBWD
C
C  MASK FOR 15-BIT PARCELS(77777B)
C
      IMSK1 = 32767
C
C
C  FIND THE NUMBER OF BITS PER WORD
C
      NBWD = I1MACH(5)
C
C  COMPUTE THE NUMBER OF 15-BIT PARCELS
C
      NUM15U = NBWD/15
C
C  IPRCT AND IPRCT2 ARE USED TO PREVENT SIGN EXTENSION WHEN DOING LEFT
C  SHIFTS.
C
      ITEMP = ISHIFT(IMSK1,(NBWD-16))
      IPRCT = ITEMP
      IT1 = NUM15U-1
      DO 100 I = 1,IT1
      IPRCT = ISHIFT(IPRCT,-15)
      IPRCT = IOR(ITEMP,IPRCT)
  100 CONTINUE
      IPRCT = IOR(IPRCT,IMSK1)
C
      IPRCT2 = ISHIFT(IPRCT,-14)
C
C  LEFT JUSTIFY
C
      LEFTJS = NBWD-15
      IMSK1 = ISHIFT(IMSK1,LEFTJS)
C
C  GENERATE THE MASKS FOR THE 15 BIT PARCELS
C
C
      DO 10 I = 1 , NUM15U
      MASK(I) = IMSK1
C
C  SHIFT FOR NEXT PARCEL
C
      IMSK1 = ISHIFT(IMSK1,-15)
C
C  PROTECT FROM SIGN EXTENSION (RELEVANT ONLY ON FIRST PASS)
C
      IMSK1 = IAND(IMSK1,IPRCT2)
   10 CONTINUE
C
C
C  MASK FOR 6-BIT PARCELS (77B)
C
      IMSK2 = 63
C
C  MASK FOR 12-BIT PARCELS (7777B)
C
      IMSK3 = 4095
C
C  LEFT JUSTIFY
C
      LEFTJS = NBWD-6
      IMSK2 = ISHIFT(IMSK2,LEFTJS)
C
      LEFTJS = NBWD-12
      IMSK3 = ISHIFT(IMSK3,LEFTJS)
C
C  SET UP ALL POSSIBLE 6- AND 12-BIT UNITS
C  NOTE THAT MASKS WILL ALSO BE USED WHEN UNITS CROSS WORD BOUNDARIES
C
C
      DO 20 I = 1 , NBWD
C
C  6 BIT MASKS
C
      MASK6(I) = IMSK2
      IMSK2 = ISHIFT(IMSK2,-1)
C
C PROTECTION FROM SIGN EXTENSION (RELEVANT ONLY ON THE FIRST PASS)
C
      IMSK2 = IAND(IMSK2,IPRCT)
C
C  12 BIT MASKS
C
      MASK12(I) = IMSK3
      IMSK3 = ISHIFT(IMSK3,-1)
C
C  PROTECT FROM SIGN EXTENSION (RELEVANT ONLY ON THE FIRST PASS)
C
      IMSK3 = IAND(IMSK3,IPRCT)
   20 CONTINUE
C
C
C  MASK FOR 6-BIT RIGHT-JUSTIFIED UNIT (77B)
C
      LAST6 = 63
C
C  MASK FOR 12-BIT RIGHT-JUSTIFIED UNIT (7777B)
C
      LAST12 = 4095
C
C  MASK FOR 15-TH BIT FROM THE RIGHT (40000B)
C
      IBIT15 = 16384
C
C  MASK FOR 14-BIT RIGHT-JUSTIFIED UNIT (37777B)
C
      MASK14 = 16383
      RETURN
C
C REVISION HISTORY -----------------------------------------------------
C
C OCTOBER 1984     CONVERTED TO GKS AND FORTRAN 77.  REMOVED CDC7600
C                  CODE.
C
C SEPTEMBER 1980   CORRECTED ERRORS PREVENTING THE USE OF SUBSCRIPTS
C                  IN VERTICALLY-WRITTEN LABELS AND THE USE OF NUMERIC
C                  FUNCTION CODES IN GENERAL.  (DJK)
C
C JUNE 1988        CHANGED THE NAME OF A COMMON BLOCK TO GET RID OF A
C                  WARNING FROM SEGLDR.  (DJK)
C
C OCTOBER 1988     FIXED A PROBLEM IN THE SUBROUTINE HTABLE.  (DJK)
C
      END

C
C $Id: haproj.f,v 1.4 2008-09-18 00:42:16 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE HAPROJ (DLAT,DLON,UVAL,VVAL)
C
        DOUBLE PRECISION DLAT,DLON,UVAL,VVAL
C
C The subroutine HAPROJ implements a closed form of the Hammer
C projection, using formulas identical to those given on various Web
C sites.
C
C DLAT and DLON are input values of latitude and longitude, in radians.
C UVAL and VVAL are output values of U and V, in the projection plane.
C
C The common block MAPCM0 contains mathematical constants.
C
        COMMON /MAPCM0/  COS1,DTOR,DTRH,OOPI,PI,PIOF,PIOT,RTDD,RTOD,
     +                   SROT,SIN1,TOPI,TSRT
        DOUBLE PRECISION COS1,DTOR,DTRH,OOPI,PI,PIOF,PIOT,RTDD,RTOD,
     +                   SROT,SIN1,TOPI,TSRT
        SAVE   /MAPCM0/
C
C Local variable.
C
        DOUBLE PRECISION TVAL
C
C Do the math.
C
        TVAL=SQRT(1.D0+COS(DLAT)*COS(.5D0*DLON))
C
        UVAL=TSRT*COS(DLAT)*SIN(.5D0*DLON)/TVAL
        VVAL=SROT*SIN(DLAT)/TVAL
C
        RETURN
C
      END

      PROGRAM IFTRAN
C
C $Id: Iftran.f,v 1.7 2008-04-11 20:11:24 kennison Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C                       Copyright (C) 1989 by UCAR                     C
C            University Corporation for Atmospheric Research           C
C                          All Rights Reserved                         C
C                                                                      C
C                          IFTRAN Version 1.00                         C
C                                                                      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      COMMON /IFTCM1/ DBLS,DSOK,IBIT,ICRB,ICRI,ICRJ,ICRK,ICRL,ICUB,IFIN,
     +                IFOC,IFOF,IFOI,IFON,IFOS,IFVA(16),IFVI,IGND,
     +          IGNI,IGNN,IINP,INCL,INCP,INCU,IOCC,IOCP,IOTC,IOTX,
     +          IOUT,IPOC,IPOF,IPOI,IPON,IPOS,ISAV,ISGT,ISRA,ISRL,
     +          ISRM,ISRP(1023),ISRS,ISRT,ISRX,ISTB,ISTC,ISTD,
     +      ISTE,ISTF,ISTK(96),ISTL,ISTS,ISUM,ISVI,ISVN,
     +ITYQ,IUAF,IUCF,KWOK,LNCD,NABT,NAMI(500),NAMP,                NAMQ,
     +NAMR,NCLI,NCLO,NCTO,NDNT,NERR,NEST,NLNE,NLNX,                NPGE
      COMMON /IFTCM2/ IADE(26),IBUF(80),ICHS(50),ICNC,ICRD(1701),
     +            IEVS,IEVT,IHDR(115),ILCA(26),INSB(81),
     +            ISRC(6000),ISTA(1327),ITBC,ITYP,IUSB(81),
     +    IXCC,NAMC(1000),PTYP
      CHARACTER*1     IADE,IBUF,ICHS,ICNC,ICRD,IEVS,IEVT,IHDR,ILCA,INSB,
     +                ISRC,ISTA,ITBC,ITYP,IUSB,IXCC,NAMC,PTYP
      LOGICAL         DBLS,DSOK,IOCC,ISRA,ISRX,KWOK
      COMMON /IFTCM3/ IU1B(512),IU2B(512),CRC1,CRC2,SFUN,TBCH
      CHARACTER*1     IU1B,IU2B,CRC1,CRC2,TBCH
      CHARACTER*17    SFUN
      COMMON /IFTCM4/ IU1P,IU1Q,IU2P,IU2Q
      CHARACTER*80 ARGU
      CALL IFTRBD
      CRC1=CHAR(10)
      CRC2=CHAR(13)
      TBCH=CHAR(9)
      CALL NGCPID (IPID)
      IPID=10000+MOD(ABS(IPID),10000)
      WRITE (SFUN(12:16),'(I5)') IPID
      SFUN( 1:12)='/tmp/iftran.'
      SFUN(17:17)=CHAR(0)
      IU1P=0
      IU1Q=0
      IU2P=0
      IU2Q=0
      NPAR=IARGC()
      IF (.NOT.(NPAR.GT.0)) GO TO 10001
      DO 10002 IPAR=1,NPAR
      CALL GETARG(IPAR,ARGU)
      IF (.NOT.(ARGU(1:1).EQ.'-')) GO TO 10003
      IF (.NOT.(ARGU(2:2).EQ.'l'.OR.ARGU(2:2).EQ.'L')) GO TO 10004
      ITMP=IOUT
      IOUT=IOTC
      IOTC=ITMP
      GO TO 10005
10004 CONTINUE
      IF (.NOT.(ARGU(2:2).EQ.'6')) GO TO 10006
      IBIT=0
      GO TO 10005
10006 CONTINUE
      IF (.NOT.(ARGU(2:2).EQ.'7')) GO TO 10007
      IBIT=1
10005 CONTINUE
10007 CONTINUE
      GO TO 10008
10003 CONTINUE
      DO 10009 I=1,80
      IF (.NOT.(ARGU(I:I).EQ.' ')) GO TO 10010
      ITMP=I
      GO TO 101
10010 CONTINUE
10009 CONTINUE
      ITMP=80
  101 ARGU(I:I)=CHAR(0)
      IF (.NOT.(IOUT.EQ.0)) GO TO 10011
      CALL NGOFWO (ARGU,IOUT,ITMP)
      GO TO 10012
10011 CONTINUE
      IF (.NOT.(IOTC.EQ.0)) GO TO 10013
      CALL NGOFWO (ARGU,IOTC,ITMP)
10012 CONTINUE
10013 CONTINUE
10008 CONTINUE
10002 CONTINUE
10001 CONTINUE
      CALL NGOFRW (SFUN,ISAV,ITMP)
      IF (ITMP.NE.0) ISAV=0
      CALL IFTRAX
      IF (IINP.GT.2) CALL NGCLFI (IINP)
      IF (IOUT.GT.2) CALL NGCLFI (IOUT)
      IF (IOTC.GT.2) CALL NGCLFI (IOTC)
      IF (ISAV.GT.2) CALL NGCLFI (ISAV)
      IF (ISAV.GT.2) CALL NGRMFI (SFUN)
      WRITE (0,1001) NCTO,NERR
      CALL NGEXIT(NERR)
      STOP
 1001 FORMAT ('*** IFTRAN SUMMARY - ',I5,' CARDS, ',I3,' ERRORS ***')
      END
      SUBROUTINE IFTRBD
      RETURN
      END
CNOSPLIT - makes Fsplit put next routine in same file as last routine.
      BLOCKDATA IFTRBDX
      COMMON /IFTCM1/ DBLS,DSOK,IBIT,ICRB,ICRI,ICRJ,ICRK,ICRL,ICUB,IFIN,
     +                IFOC,IFOF,IFOI,IFON,IFOS,IFVA(16),IFVI,IGND,
     +          IGNI,IGNN,IINP,INCL,INCP,INCU,IOCC,IOCP,IOTC,IOTX,
     +          IOUT,IPOC,IPOF,IPOI,IPON,IPOS,ISAV,ISGT,ISRA,ISRL,
     +          ISRM,ISRP(1023),ISRS,ISRT,ISRX,ISTB,ISTC,ISTD,
     +      ISTE,ISTF,ISTK(96),ISTL,ISTS,ISUM,ISVI,ISVN,
     +ITYQ,IUAF,IUCF,KWOK,LNCD,NABT,NAMI(500),NAMP,                NAMQ,
     +NAMR,NCLI,NCLO,NCTO,NDNT,NERR,NEST,NLNE,NLNX,                NPGE
      COMMON /IFTCM2/ IADE(26),IBUF(80),ICHS(50),ICNC,ICRD(1701),
     +            IEVS,IEVT,IHDR(115),ILCA(26),INSB(81),
     +            ISRC(6000),ISTA(1327),ITBC,ITYP,IUSB(81),
     +    IXCC,NAMC(1000),PTYP
      CHARACTER*1     IADE,IBUF,ICHS,ICNC,ICRD,IEVS,IEVT,IHDR,ILCA,INSB,
     +                ISRC,ISTA,ITBC,ITYP,IUSB,IXCC,NAMC,PTYP
      LOGICAL         DBLS,DSOK,IOCC,ISRA,ISRX,KWOK
      DATA DBLS / .FALSE. /
      DATA DSOK / .TRUE. /
      DATA IADE / 26*'D' /
      DATA IBIT / 0 /
      DATA ICHS / '$' , 'A' , 'B' , 'C' , 'D' , 'E' , 'F' , 'G' , 'H' ,
     +            'I' , 'J' , 'K' , 'L' , 'M' , 'N' , 'O' , 'P' , 'Q' ,
     +            'R' , 'S' , 'T' , 'U' , 'V' , 'W' , 'X' , 'Y' , 'Z' ,
     +            '0' , '1' , '2' , '3' , '4' , '5' , '6' , '7' , '8' ,
     +            '9' , ',' , ' ' , '+' , '-' , '*' , '/' , '(' , ')' ,
     +            '=' , '.' , '''' , '"' ,
     +            ' ' /
      DATA ICRB / 0 /
      DATA ICRI / 0 / , ICRJ / 0 / , ICRK / 0 / , ICRL / 0 /
      DATA ICUB / 0 /
      DATA IFIN / 0 /
      DATA IFOC,IFOF,IFOI,IFON,IFOS / 0 , 1 , 0 , 0 , 0 /
      DATA IFVA(1) / 1 / , IFVI / 1 /
      DATA IGND / -1 /
      DATA IGNI / 19999 /
      DATA IGNN / 19999 /
      DATA IHDR / '1' , ' ' , ' ' , 'S' , 'E' , 'Q' , ' ' , 'N' , 'E' ,
     +            'S' , 'T' , ' ' , 'S' , 'O' , 'U' , 'R' , 'C' , 'E' ,
     +            10*' ' , 72*'-' , 5*' '     , 'P' , 'A' , 'G' , 'E' ,
     +                                                          6*' ' /
      DATA IINP / 0 /
      DATA ILCA / 'a' , 'b' , 'c' , 'd' , 'e' , 'f' , 'g' , 'h' , 'i' ,
     +            'j' , 'k' , 'l' , 'm' , 'n' , 'o' , 'p' , 'q' , 'r' ,
     +            's' , 't' , 'u' , 'v' , 'w' , 'x' , 'y' , 'z' /
      DATA INCP / 0 /
      DATA INCU / 0 /
      DATA IOCC / .FALSE. /
      DATA IOCP / 0 /
      DATA IOTC / 1 /
      DATA IOUT / 0 /
      DATA IPOC,IPOF,IPOI,IPON,IPOS / 1 , 1 , 1 , 0 , 1 /
      DATA ISAV / 0 /
      DATA ISGT / 0 /
      DATA ISRA / .FALSE. /
      DATA ISRL / 0 /
      DATA ISRM / 1327 /
      DATA ISRS / 0 /
      DATA ISRT / 0 /
      DATA ISRX / .FALSE. /
      DATA ISTL / 0 /
      DATA ISTS / 0 /
      DATA ISUM / 2 /
      DATA ISVI / 0 /
      DATA ISVN / 0 /
      DATA IUAF / 0 /
      DATA IUCF / 1 /
      DATA KWOK / .FALSE. /
      DATA LNCD / 80 /
      DATA NABT / 0 /
      DATA NAMP / 0 / , NAMQ / 500 /
      DATA NAMR / 0 /
      DATA NCLI / 0 /
      DATA NCTO / 0 /
      DATA NDNT / -4 /
      DATA NERR / 0 /
      DATA NEST / 0 /
      DATA NLNE / 55 /
      DATA NLNX / 0 /
      DATA NPGE / 0 /
      END
      SUBROUTINE IFTRAX
      COMMON /IFTCM1/ DBLS,DSOK,IBIT,ICRB,ICRI,ICRJ,ICRK,ICRL,ICUB,IFIN,
     +                IFOC,IFOF,IFOI,IFON,IFOS,IFVA(16),IFVI,IGND,
     +          IGNI,IGNN,IINP,INCL,INCP,INCU,IOCC,IOCP,IOTC,IOTX,
     +          IOUT,IPOC,IPOF,IPOI,IPON,IPOS,ISAV,ISGT,ISRA,ISRL,
     +          ISRM,ISRP(1023),ISRS,ISRT,ISRX,ISTB,ISTC,ISTD,
     +      ISTE,ISTF,ISTK(96),ISTL,ISTS,ISUM,ISVI,ISVN,
     +ITYQ,IUAF,IUCF,KWOK,LNCD,NABT,NAMI(500),NAMP,                NAMQ,
     +NAMR,NCLI,NCLO,NCTO,NDNT,NERR,NEST,NLNE,NLNX,                NPGE
      COMMON /IFTCM2/ IADE(26),IBUF(80),ICHS(50),ICNC,ICRD(1701),
     +            IEVS,IEVT,IHDR(115),ILCA(26),INSB(81),
     +            ISRC(6000),ISTA(1327),ITBC,ITYP,IUSB(81),
     +    IXCC,NAMC(1000),PTYP
      CHARACTER*1     IADE,IBUF,ICHS,ICNC,ICRD,IEVS,IEVT,IHDR,ILCA,INSB,
     +                ISRC,ISTA,ITBC,ITYP,IUSB,IXCC,NAMC,PTYP
      LOGICAL         DBLS,DSOK,IOCC,ISRA,ISRX,KWOK
      IOTX=IOUT
      ICHS(50)=CHAR(0)
      ICNC=ICHS(50)
      ITBC=ICHS(50)
      IXCC=ICHS(50)
      IEVS=ICHS(50)
      IEVT=ICHS(50)
      DO 10001 I=1,1023
      ISRP(I)=0
10001 CONTINUE
10002 CONTINUE
      IF (.NOT.(ISTS.GE.0)) GO TO 10003
      IF (.NOT.(ISTS.EQ.0)) GO TO 10004
      IGNN=IGNI
      ISGT=0
      ISTL=0
      ISTS=1
      NAMP=0
      NAMQ=500
      NAMR=0
      NCLO=0
      NEST=0
      NLNX=0
      PTYP=ICHS(50)
10004 CONTINUE
      CALL GETSTA
      IF (.NOT.(ICRI.EQ.(-1))) GO TO 10005
      ISTS=-1
      IF (NEST.NE.0) CALL ERRM(1)
      GO TO 10006
10005 CONTINUE
      IF (.NOT.(ITYP.EQ.ICHS(4))) GO TO 10007
      CALL CRDOUT
      GO TO 10006
10007 CONTINUE
      IF (.NOT.(ITYP.EQ.ICHS(10))) GO TO 10008
      GO TO (101,102,103,104,105,106,107,107,115,126,
     +       108,108,117,124,109,110,111,112,113,114,
     +       116,125,126,115,118,119,120,127,121,123) , ITYQ
  101 CALL CCSET(ISTA(ISTC),ICHS( 2))
      GO TO 199
  102 ISRX=ISRA
      ISRA=.TRUE.
      I1=INDEX1(ICHS(38),ISTA,ISTC,ISTB-1)
      IF (.NOT.(I1.GT.0)) GO TO 10009
      CALL MULREP(I1+1)
      GO TO 10010
10009 CONTINUE
      I1=ISTB-1
10010 CONTINUE
      GO TO 122
  103 ICNC=ISTA(ISTC)
      GO TO 199
  104 CALL CCSET(ISTA(ISTC),ICHS( 5))
      GO TO 199
  105 DSOK=.TRUE.
      GO TO 199
  106 NLNX=0
      GO TO 199
  107 CALL CCSET(ISTA(ISTC),ICHS( 6))
      GO TO 199
  115 CONTINUE
      IF (.NOT.(ABS(IFVA(IFVI)).EQ.1)) GO TO 10011
      IFVA(IFVI)=-2*IFVA(IFVI)
      GO TO 10012
10011 CONTINUE
      IF (.NOT.(ABS(IFVA(IFVI)).EQ.2)) GO TO 10013
      CALL ERRM(8)
      GO TO 10012
10013 CONTINUE
      IF (.NOT.(IFVA(IFVI).EQ.(-3))) GO TO 10014
      IFVA(IFVI)=-2
10012 CONTINUE
10014 CONTINUE
      GO TO 199
  108 ISRA=ISRX
      GO TO 199
  117 CONTINUE
      IF (.NOT.(IFVI.GT.1)) GO TO 10015
      IFVI=IFVI-1
      GO TO 10016
10015 CONTINUE
      CALL ERRM(8)
10016 CONTINUE
      GO TO 199
  124 CONTINUE
      IF (.NOT.(IFVI.LT.16)) GO TO 10017
      IFVI=IFVI+1
      IF (.NOT.(IFVA(IFVI-1).LE.0)) GO TO 10018
      IFVA(IFVI)=0
      GO TO 10019
10018 CONTINUE
      IFVA(IFVI)=-1
      IF (.NOT.(ISRA)) GO TO 10020
      ITMP=ISTB-1
      CALL REPL2(ISTA,1327,ISTB,ISTC,ITMP,ISTF)
10020 CONTINUE
      IF (ISTA(ISTC).NE.ICHS(28)) IFVA(IFVI)=+1
10019 CONTINUE
      GO TO 10021
10017 CONTINUE
      CALL ERRM(8)
      CALL NGEXIT(NERR)
      STOP
10021 CONTINUE
      GO TO 199
  109 CONTINUE
      IF (.NOT.(ISRA)) GO TO 10022
      ITMP=ISTB-1
      CALL REPL2(ISTA,1327,ISTB,ISTC,ITMP,ISTF)
10022 CONTINUE
      IF (.NOT.(INCP.LE.0.AND.IUAF.EQ.0)) GO TO 10023
      CALL INCLPM(INCU,INCL,IREW)
      IF (.NOT.(INCU.GT.0)) GO TO 10024
      INCP=-1
      IF (.NOT.(ICRK.GT.0)) GO TO 10025
      INCP=1
      CALL XMIT(ICRL-ICRK+1,ICRD(ICRK),INSB)
      NCLI=NCLI-1
10025 CONTINUE
      ICRK=0
      ICRL=ICRJ
      IF (IREW.NE.0) CALL IFTRIO(3,INCU,ICRD,0,0)
      GO TO 10026
10024 CONTINUE
      CALL ERRM(18)
10026 CONTINUE
      GO TO 10027
10023 CONTINUE
      CALL ERRM(18)
10027 CONTINUE
      GO TO 199
  110 KWOK=.TRUE.
      GO TO 199
  111 IOUT=IOTX
      GO TO 199
  112 DSOK=.FALSE.
      GO TO 199
  113 KWOK=.FALSE.
      GO TO 199
  114 IOUT=0
      GO TO 199
  116 ISRA=.FALSE.
      ISRX=.FALSE.
      GO TO 199
  125 CONTINUE
      IF (.NOT.(ISRA)) GO TO 10028
      ITMP=ISTB-1
      CALL REPL2(ISTA,1327,ISTB,ISTC,ITMP,ISTF)
10028 CONTINUE
      CALL SETOPT
      GO TO 199
  126 CONTINUE
      IF (.NOT.(IFVA(IFVI).EQ.1)) GO TO 10029
      IFVA(IFVI)=-3
      GO TO 10030
10029 CONTINUE
      IF (.NOT.(IFVA(IFVI).EQ.(-1))) GO TO 10031
      IF (.NOT.(ISRA)) GO TO 10032
      ITMP=ISTB-1
      CALL REPL2(ISTA,1327,ISTB,ISTC,ITMP,ISTF)
10032 CONTINUE
      IF (ISTA(ISTC).NE.ICHS(28)) IFVA(IFVI)=+1
      GO TO 10030
10031 CONTINUE
      IF (.NOT.(ABS(IFVA(IFVI)).EQ.2)) GO TO 10033
      CALL ERRM(8)
10030 CONTINUE
10033 CONTINUE
      GO TO 199
  118 CONTINUE
      IF (.NOT.(ISTA(ISTC).NE.ICHS(50))) GO TO 10034
      CALL MULREP(ISTC)
10034 CONTINUE
      ISRA=.TRUE.
      ISRX=.TRUE.
      GO TO 199
  119 CONTINUE
      IF (.NOT.(IUAF.NE.0)) GO TO 10035
      CALL ERRM(16)
      GO TO 10036
10035 CONTINUE
      IF (.NOT.(ISAV.EQ.0)) GO TO 10037
      CALL ERRM(15)
      GO TO 10038
10037 CONTINUE
      IF (.NOT.(ISRA)) GO TO 10039
      ITMP=ISTB-1
      CALL REPL2(ISTA,1327,ISTB,ISTC,ITMP,ISTF)
10039 CONTINUE
      CALL SAVUSE(1,KSAV)
      IF (.NOT.(KSAV.EQ.(-1))) GO TO 10040
      ISTS=-1
      GO TO 999
10040 CONTINUE
10038 CONTINUE
10036 CONTINUE
      GO TO 199
  120 ITBC=ISTA(ISTC)
      GO TO 199
  127 ITMP=MIN(ISTB-ISTC,72)
      CALL XMIT(ITMP,ISTA(ISTC),IHDR(29))
      IF (ITMP.LT.72) CALL XMIT(ITMP-72,ICHS(39),IHDR(ITMP+29))
      GO TO 199
  121 I1=ISTB-1
  122 CONTINUE
      IF (.NOT.(ISAV.EQ.0)) GO TO 10041
      CALL ERRM(15)
      GO TO 10042
10041 CONTINUE
      IF (.NOT.(IUAF.NE.0)) GO TO 10043
      CALL ERRM(14)
      GO TO 10044
10043 CONTINUE
      IF (ISRA) CALL REPL2(ISTA,1327,ISTB,ISTC,I1,ISTF)
      CALL SAVUSE(2,KUSE)
      IF (.NOT.(KUSE.EQ.(-1))) GO TO 10045
      CALL ERRM(17)
      GO TO 10046
10045 CONTINUE
      IUAF=-1
      IF (.NOT.(ICRK.GT.0)) GO TO 10047
      IUAF=1
      CALL XMIT(ICRL-ICRK+1,ICRD(ICRK),IUSB)
      NCLI=NCLI-1
10047 CONTINUE
      ICRK=0
      ICRL=ICRJ
10046 CONTINUE
10044 CONTINUE
10042 CONTINUE
      GO TO 199
  123 IXCC=ISTA(ISTC)
      GO TO 199
  199 CALL CRDOUT
      GO TO 10006
10008 CONTINUE
      IF (.NOT.(ISRA)) GO TO 10048
      ITMP=ISTB-1
      CALL REPL2(ISTA,1327,ISTB,1,ITMP,ISTF)
10048 CONTINUE
      CALL PAQQ(KEY)
      IF (.NOT.(KEY.EQ.0)) GO TO 10049
      IF (IHDR(29).EQ.ICHS(41)) CALL XMIT(72,ICRD(ICRI),IHDR(29))
      CALL CRDOUT
      ISGT=0
      GO TO 10050
10049 CONTINUE
      ITYP=ICHS(20)
      GO TO (201,202,203,217,204,205,206,207,208,209,
     +       210,211,212,213,298,214,215,216,217,218,
     +       298,298,219,220,221,298                ) , KEY
  201 CALL BLOCKS
      GO TO 299
  202 CALL DOSTAT
      GO TO 299
  203 CALL ELSORF
      GO TO 299
  204 ITYP=ICHS( 7)
      CALL CRDOUT
      IF (.NOT.(NEST.NE.0)) GO TO 10051
      CALL ERRM(1)
10051 CONTINUE
      IF (.NOT.(NAMP.NE.0)) GO TO 10052
      I=0
      DO 10053 J=1,NAMP,4
      IF (.NOT.(NAMI(J).GT.0)) GO TO 10054
      IF (.NOT.(I.EQ.0)) GO TO 10055
      I=1
      CALL ERRM(35)
      CALL XMIT(-6,ICHS(39),IHDR(29))
10055 CONTINUE
      CALL SPCOUT(1)
      K=NAMI(J+1)
      CALL XMIT(NAMI(J+2),NAMC(K),IHDR(35))
      CALL IFTRIO(2,IOUT,IHDR(29),NAMI(J+2)+6,0)
10054 CONTINUE
10053 CONTINUE
10052 CONTINUE
      ISTS=0
      CALL XMIT(-72,ICHS(41),IHDR(29))
      GO TO 299
  205 CALL ENDBLO
      GO TO 299
  206 CALL ENDDO
      GO TO 299
  207 CALL ENDFOR
      GO TO 299
  208 CALL ENDIF
      GO TO 299
  209 CALL ENDLOO
      GO TO 299
  210 CALL ENDWHI
      GO TO 299
  211 CALL EXITST
      GO TO 299
  212 CALL EXITIF
      GO TO 299
  213 CALL FORSTA
      GO TO 299
  214 CALL IFSTAT
      GO TO 299
  215 CALL INVOKE
      GO TO 299
  216 CALL LOOPST
      GO TO 299
  217 CALL ELSORF
      GO TO 299
  218 CALL REPETE
      GO TO 299
  219 CALL UNTIL
      GO TO 299
  220 CALL WHILE
      GO TO 299
  221 CONTINUE
      IF (.NOT.(IBIT.EQ.0)) GO TO 10056
      CALL IFSTAT
      GO TO 10057
10056 CONTINUE
      CALL STAK(2,0,0)
      ITYP=ICHS( 7)
      CALL CRDOUT
      NEST=NEST+1
10057 CONTINUE
      GO TO 299
  298 ISGT=1
      ITYP=ICHS( 7)
      CALL CRDOUT
  299 CONTINUE
10050 CONTINUE
10006 CONTINUE
      GO TO 10002
10003 CONTINUE
  999 RETURN
      END
      SUBROUTINE BLOCKS
      COMMON /IFTCM1/ DBLS,DSOK,IBIT,ICRB,ICRI,ICRJ,ICRK,ICRL,ICUB,IFIN,
     +                IFOC,IFOF,IFOI,IFON,IFOS,IFVA(16),IFVI,IGND,
     +          IGNI,IGNN,IINP,INCL,INCP,INCU,IOCC,IOCP,IOTC,IOTX,
     +          IOUT,IPOC,IPOF,IPOI,IPON,IPOS,ISAV,ISGT,ISRA,ISRL,
     +          ISRM,ISRP(1023),ISRS,ISRT,ISRX,ISTB,ISTC,ISTD,
     +      ISTE,ISTF,ISTK(96),ISTL,ISTS,ISUM,ISVI,ISVN,
     +ITYQ,IUAF,IUCF,KWOK,LNCD,NABT,NAMI(500),NAMP,                NAMQ,
     +NAMR,NCLI,NCLO,NCTO,NDNT,NERR,NEST,NLNE,NLNX,                NPGE
      COMMON /IFTCM2/ IADE(26),IBUF(80),ICHS(50),ICNC,ICRD(1701),
     +            IEVS,IEVT,IHDR(115),ILCA(26),INSB(81),
     +            ISRC(6000),ISTA(1327),ITBC,ITYP,IUSB(81),
     +    IXCC,NAMC(1000),PTYP
      CHARACTER*1     IADE,IBUF,ICHS,ICNC,ICRD,IEVS,IEVT,IHDR,ILCA,INSB,
     +                ISRC,ISTA,ITBC,ITYP,IUSB,IXCC,NAMC,PTYP
      LOGICAL         DBLS,DSOK,IOCC,ISRA,ISRX,KWOK
      CALL NAMBLO(N1,0)
      CALL CRDOUT
      CALL LABOUT
      IF (.NOT.(N1.GT.0)) GO TO 10001
      NAMI(N1)=-ABS(NAMI(N1))
      N2=0
      IF (.NOT.(ISGT.EQ.0)) GO TO 10002
      CALL NEWNUM(N2)
      CALL GOTOCD(N2)
10002 CONTINUE
      ITMP=ABS(NAMI(N1))
      CALL CONTCD(ITMP)
      CALL STAK(9,N1,N2)
      NEST=NEST+1
10001 CONTINUE
      RETURN
      END
      SUBROUTINE CCSET(ICHR,JADE)
      CHARACTER*1 ICHR,JADE
      COMMON /IFTCM1/ DBLS,DSOK,IBIT,ICRB,ICRI,ICRJ,ICRK,ICRL,ICUB,IFIN,
     +                IFOC,IFOF,IFOI,IFON,IFOS,IFVA(16),IFVI,IGND,
     +          IGNI,IGNN,IINP,INCL,INCP,INCU,IOCC,IOCP,IOTC,IOTX,
     +          IOUT,IPOC,IPOF,IPOI,IPON,IPOS,ISAV,ISGT,ISRA,ISRL,
     +          ISRM,ISRP(1023),ISRS,ISRT,ISRX,ISTB,ISTC,ISTD,
     +      ISTE,ISTF,ISTK(96),ISTL,ISTS,ISUM,ISVI,ISVN,
     +ITYQ,IUAF,IUCF,KWOK,LNCD,NABT,NAMI(500),NAMP,                NAMQ,
     +NAMR,NCLI,NCLO,NCTO,NDNT,NERR,NEST,NLNE,NLNX,                NPGE
      COMMON /IFTCM2/ IADE(26),IBUF(80),ICHS(50),ICNC,ICRD(1701),
     +            IEVS,IEVT,IHDR(115),ILCA(26),INSB(81),
     +            ISRC(6000),ISTA(1327),ITBC,ITYP,IUSB(81),
     +    IXCC,NAMC(1000),PTYP
      CHARACTER*1     IADE,IBUF,ICHS,ICNC,ICRD,IEVS,IEVT,IHDR,ILCA,INSB,
     +                ISRC,ISTA,ITBC,ITYP,IUSB,IXCC,NAMC,PTYP
      LOGICAL         DBLS,DSOK,IOCC,ISRA,ISRX,KWOK
      I=INDEX1(ICHR,ICHS(2),1,26)
      IF (.NOT.(I.LT.1.OR.I.GT.26)) GO TO 10001
      I=INDEX1(ICHR,ILCA,1,26)
10001 CONTINUE
      IF (.NOT.(I.GE.1.AND.I.LE.26)) GO TO 10002
      IADE(I)=JADE
      IF (.NOT.(ICRK.GT.0.AND.ICRD(ICRL).EQ.ICHR)) GO TO 10003
      IF (.NOT.(JADE.EQ.ICHS(2))) GO TO 10004
      ICRD(ICRK)=ICHS(39)
      GO TO 10005
10004 CONTINUE
      IF (.NOT.(JADE.EQ.ICHS(5))) GO TO 10006
      ICRD(ICRK)=ICHS( 4)
      GO TO 10005
10006 CONTINUE
      ICRD(ICRK)=ICHS(50)
10005 CONTINUE
10003 CONTINUE
      GO TO 10007
10002 CONTINUE
      CALL ERRM(27)
10007 CONTINUE
      RETURN
      END
      SUBROUTINE CONTCD(N)
      COMMON /IFTCM1/ DBLS,DSOK,IBIT,ICRB,ICRI,ICRJ,ICRK,ICRL,ICUB,IFIN,
     +                IFOC,IFOF,IFOI,IFON,IFOS,IFVA(16),IFVI,IGND,
     +          IGNI,IGNN,IINP,INCL,INCP,INCU,IOCC,IOCP,IOTC,IOTX,
     +          IOUT,IPOC,IPOF,IPOI,IPON,IPOS,ISAV,ISGT,ISRA,ISRL,
     +          ISRM,ISRP(1023),ISRS,ISRT,ISRX,ISTB,ISTC,ISTD,
     +      ISTE,ISTF,ISTK(96),ISTL,ISTS,ISUM,ISVI,ISVN,
     +ITYQ,IUAF,IUCF,KWOK,LNCD,NABT,NAMI(500),NAMP,                NAMQ,
     +NAMR,NCLI,NCLO,NCTO,NDNT,NERR,NEST,NLNE,NLNX,                NPGE
      COMMON /IFTCM2/ IADE(26),IBUF(80),ICHS(50),ICNC,ICRD(1701),
     +            IEVS,IEVT,IHDR(115),ILCA(26),INSB(81),
     +            ISRC(6000),ISTA(1327),ITBC,ITYP,IUSB(81),
     +    IXCC,NAMC(1000),PTYP
      CHARACTER*1     IADE,IBUF,ICHS,ICNC,ICRD,IEVS,IEVT,IHDR,ILCA,INSB,
     +                ISRC,ISTA,ITBC,ITYP,IUSB,IXCC,NAMC,PTYP
      LOGICAL         DBLS,DSOK,IOCC,ISRA,ISRX,KWOK
      CHARACTER*1 ICNT(9)
      DATA ICNT / ' ','C','O','N','T','I','N','U','E' /
      CALL CVD(N,IBUF,5)
      CALL XMIT(9,ICNT,IBUF(6))
      CALL XMIT(-58,ICHS(39),IBUF(15))
      CALL OUTBUF
      ISGT=0
      RETURN
      END
      SUBROUTINE CRDOUT
      COMMON /IFTCM1/ DBLS,DSOK,IBIT,ICRB,ICRI,ICRJ,ICRK,ICRL,ICUB,IFIN,
     +                IFOC,IFOF,IFOI,IFON,IFOS,IFVA(16),IFVI,IGND,
     +          IGNI,IGNN,IINP,INCL,INCP,INCU,IOCC,IOCP,IOTC,IOTX,
     +          IOUT,IPOC,IPOF,IPOI,IPON,IPOS,ISAV,ISGT,ISRA,ISRL,
     +          ISRM,ISRP(1023),ISRS,ISRT,ISRX,ISTB,ISTC,ISTD,
     +      ISTE,ISTF,ISTK(96),ISTL,ISTS,ISUM,ISVI,ISVN,
     +ITYQ,IUAF,IUCF,KWOK,LNCD,NABT,NAMI(500),NAMP,                NAMQ,
     +NAMR,NCLI,NCLO,NCTO,NDNT,NERR,NEST,NLNE,NLNX,                NPGE
      COMMON /IFTCM2/ IADE(26),IBUF(80),ICHS(50),ICNC,ICRD(1701),
     +            IEVS,IEVT,IHDR(115),ILCA(26),INSB(81),
     +            ISRC(6000),ISTA(1327),ITBC,ITYP,IUSB(81),
     +    IXCC,NAMC(1000),PTYP
      CHARACTER*1     IADE,IBUF,ICHS,ICNC,ICRD,IEVS,IEVT,IHDR,ILCA,INSB,
     +                ISRC,ISTA,ITBC,ITYP,IUSB,IXCC,NAMC,PTYP
      LOGICAL         DBLS,DSOK,IOCC,ISRA,ISRX,KWOK
      CHARACTER*1 LINE(128),IDOT
      IF (.NOT.(IOUT.NE.0)) GO TO 10001
      IF (.NOT.((ITYP.EQ.ICHS(4).AND.IPOC.NE.0).OR.(ITYP.EQ.ICHS(7).AND.
     +IPOF.NE.0).OR.(ITYP.EQ.ICHS(10).AND.IPOI.NE.0).OR.(ITYP.EQ.ICHS(20
     +).AND.IPOS.NE.0))) GO TO 10002
      NIST=MAX(NEST,0)
      JDNT=ABS(NDNT)
      NIND=MIN(NIST*JDNT,116-LNCD)
      KSEQ=201-LNCD
      LSEQ=LNCD-72
      IF (.NOT.(ITYP.EQ.ICHS(4).AND.NIST.NE.0)) GO TO 10003
      NIND=MIN(NIND,112-LNCD)
      ISPL=1
      KSPL=18+NIND
      IDOT=ICHS(42)
      GO TO 10004
10003 CONTINUE
      ISPL=6
      KSPL=19+NIND
      IDOT=ICHS(47)
10004 CONTINUE
      IF (.NOT.(DSOK)) GO TO 10005
      DBLS=ITYP.NE.PTYP
      IF (.NOT.(DBLS)) GO TO 10006
      CALL SPCOUT(1)
10006 CONTINUE
      GO TO 10007
10005 CONTINUE
      DBLS=.FALSE.
10007 CONTINUE
      IF (.NOT.(ISTF.NE.0.AND.ICRB.NE.0)) GO TO 10008
      I=1
      J=72
      K=ICRL+1
      L=0
10009 CONTINUE
      IF (K+LNCD.GT.1701) K=1
      IF (.NOT.(K.LE.ICRI.AND.K+LNCD.GE.ICRI)) GO TO 10010
      CALL ERRM(7)
      GO TO 101
10010 CONTINUE
      IF (.NOT.(L.NE.0)) GO TO 10011
      IF (.NOT.(ITYP.EQ.ICHS(4))) GO TO 10012
      ICRD(K)=ISTA(1)
      ICRD(K+1)=ICHS(39)
      GO TO 10013
10012 CONTINUE
      IF (.NOT.(ITYP.EQ.ICHS(10))) GO TO 10014
      ICRD(K)=ICHS(38)
      GO TO 10013
10014 CONTINUE
      CALL XMIT(-5,ICHS(39),ICRD(K))
      ICRD(K+5)=ICHS(40)
10013 CONTINUE
10011 CONTINUE
      M=MIN(J,ISTB-I)
      N=K+L
      CALL XMIT(M,ISTA(I),ICRD(N))
      M=M+N
      IF (M.LT.K+72) CALL XMIT(M-K-72,ICHS(39),ICRD(M))
      CALL XMIT(8,ICRD(ICRI+72),ICRD(K+72))
      I=I+J
      IF (I.GE.ISTB) GO TO 10015
      K=K+LNCD+1
      IF (.NOT.(L.EQ.0)) GO TO 10016
      IF (.NOT.(ITYP.EQ.ICHS(4))) GO TO 10017
      J=70
      L=2
      GO TO 10018
10017 CONTINUE
      IF (.NOT.(ITYP.EQ.ICHS(10))) GO TO 10019
      J=71
      L=1
      GO TO 10018
10019 CONTINUE
      J=66
      L=6
10018 CONTINUE
10016 CONTINUE
      IF (.NOT.(ICRI+LNCD.NE.ICRJ)) GO TO 10020
      ICRI=ICRI+LNCD+1
      IF (ICRI+LNCD.GT.1701) ICRI=1
10020 CONTINUE
      GO TO 10009
10015 CONTINUE
      ICRI=ICRL+1
      IF (ICRI+LNCD.GT.1701) ICRI=1
      ICRJ=K+LNCD
      ICRL=ICRJ
      IF (.NOT.(ICRK.GT.0)) GO TO 10021
      K=ICRJ+1
      IF (K+LNCD.GT.1701) K=1
      CALL XMIT(LNCD+1,ICRD(ICRK),ICRD(K))
      ICRK=K
      ICRL=ICRK+LNCD
10021 CONTINUE
10008 CONTINUE
  101 I=ICRI
10022 CONTINUE
      CALL XMIT(-128,ICHS(39),LINE)
      IF (.NOT.(I.EQ.ICRI)) GO TO 10023
      IF (DBLS) LINE(1)=ICHS(28)
      CALL CVD(NCLO,LINE(2),5)
      CALL CVD(NIST,LINE(8),2)
10023 CONTINUE
      IF (.NOT.(NIST.GT.0.AND.NDNT.LT.0)) GO TO 10024
      DO 10025 J=1,NIND,JDNT
      LINE(J+18)=IDOT
10025 CONTINUE
10024 CONTINUE
      CALL XMIT(ISPL,ICRD(I),LINE(13))
      JSPL=I+ISPL
      CALL XMIT(72-ISPL,ICRD(JSPL),LINE(KSPL))
      IF (.NOT.(IPON.EQ.1)) GO TO 10026
      CALL CVD(NIST,LINE(KSEQ),3)
      CALL CVD(NCLO,LINE(KSEQ+3),5)
      GO TO 10027
10026 CONTINUE
      IF (.NOT.(IPON.EQ.2)) GO TO 10028
      CALL XMIT(LSEQ,ICRD(I+72),LINE(KSEQ))
10027 CONTINUE
10028 CONTINUE
      CALL SPCOUT(1)
      CALL IFTRIO(2,IOUT,LINE,LSTNB(LINE,1,128),1)
      IF (I+LNCD.EQ.ICRJ) GO TO 10029
      I=I+LNCD+1
      IF (I+LNCD.GT.1701) I=1
      GO TO 10022
10029 CONTINUE
      PTYP=ITYP
10002 CONTINUE
10001 CONTINUE
      IF (.NOT.(IOTC.NE.0.AND.ISTB.GT.1)) GO TO 10030
      IF (.NOT.(ITYP.EQ.ICHS(4))) GO TO 10031
      IF (IFOC.EQ.0) GO TO 102
      IBUF(1)=ICHS( 4)
      I=2
      J=71
      GO TO 10032
10031 CONTINUE
      IF (.NOT.(ITYP.EQ.ICHS(7))) GO TO 10033
      IF (IFOF.EQ.0) GO TO 102
      CALL XMIT(6,ISTA,IBUF)
      I=7
      J=66
      GO TO 10032
10033 CONTINUE
      IF (.NOT.(ITYP.EQ.ICHS(10))) GO TO 10034
      IF (IFOI.EQ.0) GO TO 102
      IBUF(1)=ICHS( 4)
      I=2
      J=71
      GO TO 10032
10034 CONTINUE
      IF (.NOT.(ITYP.EQ.ICHS(20))) GO TO 10035
      IF (IFOS.EQ.0) GO TO 102
      IBUF(1)=ICHS( 4)
      CALL XMIT(5,ISTA(2),IBUF(2))
      I=7
      J=66
10032 CONTINUE
10035 CONTINUE
      K=I
10036 CONTINUE
      L=MIN(J,ISTB-I)
      CALL XMIT(L,ISTA(I),IBUF(K))
      M=K+L
      IF (M.LT.73) CALL XMIT(M-73,ICHS(39),IBUF(M))
      CALL OUTBUF
      I=I+L
      IF (I.GE.ISTB) GO TO 10037
      IF (.NOT.(I.EQ.73)) GO TO 10038
      IF (.NOT.(ITYP.EQ.ICHS(7))) GO TO 10039
      CALL XMIT(-5,ICHS(39),IBUF)
      IBUF(6)=ICHS(40)
      GO TO 10040
10039 CONTINUE
      IF (.NOT.(ITYP.EQ.ICHS(20))) GO TO 10041
      CALL XMIT(-4,ICHS(39),IBUF(2))
      IBUF(6)=ICHS(40)
10040 CONTINUE
10041 CONTINUE
10038 CONTINUE
      GO TO 10036
10037 CONTINUE
10030 CONTINUE
  102 RETURN
      END
      SUBROUTINE CVD(NUMB,ISTR,LSTR)
      CHARACTER*1 ISTR(LSTR)
      COMMON /IFTCM1/ DBLS,DSOK,IBIT,ICRB,ICRI,ICRJ,ICRK,ICRL,ICUB,IFIN,
     +                IFOC,IFOF,IFOI,IFON,IFOS,IFVA(16),IFVI,IGND,
     +          IGNI,IGNN,IINP,INCL,INCP,INCU,IOCC,IOCP,IOTC,IOTX,
     +          IOUT,IPOC,IPOF,IPOI,IPON,IPOS,ISAV,ISGT,ISRA,ISRL,
     +          ISRM,ISRP(1023),ISRS,ISRT,ISRX,ISTB,ISTC,ISTD,
     +      ISTE,ISTF,ISTK(96),ISTL,ISTS,ISUM,ISVI,ISVN,
     +ITYQ,IUAF,IUCF,KWOK,LNCD,NABT,NAMI(500),NAMP,                NAMQ,
     +NAMR,NCLI,NCLO,NCTO,NDNT,NERR,NEST,NLNE,NLNX,                NPGE
      COMMON /IFTCM2/ IADE(26),IBUF(80),ICHS(50),ICNC,ICRD(1701),
     +            IEVS,IEVT,IHDR(115),ILCA(26),INSB(81),
     +            ISRC(6000),ISTA(1327),ITBC,ITYP,IUSB(81),
     +    IXCC,NAMC(1000),PTYP
      CHARACTER*1     IADE,IBUF,ICHS,ICNC,ICRD,IEVS,IEVT,IHDR,ILCA,INSB,
     +                ISRC,ISTA,ITBC,ITYP,IUSB,IXCC,NAMC,PTYP
      LOGICAL         DBLS,DSOK,IOCC,ISRA,ISRX,KWOK
      CALL XMIT(-LSTR,ICHS(39),ISTR)
      I=LSTR
      N=NUMB
10001 CONTINUE
      J=28+MOD(N,10)
      ISTR(I)=ICHS(J)
      I=I-1
      N=N/10
      IF (.NOT.(I.EQ.0.OR.N.EQ.0)) GO TO 10001
      RETURN
      END
      SUBROUTINE CVINT(N,K,ISTR,I,LSTR)
      CHARACTER*1 ISTR(1)
      COMMON /IFTCM1/ DBLS,DSOK,IBIT,ICRB,ICRI,ICRJ,ICRK,ICRL,ICUB,IFIN,
     +                IFOC,IFOF,IFOI,IFON,IFOS,IFVA(16),IFVI,IGND,
     +          IGNI,IGNN,IINP,INCL,INCP,INCU,IOCC,IOCP,IOTC,IOTX,
     +          IOUT,IPOC,IPOF,IPOI,IPON,IPOS,ISAV,ISGT,ISRA,ISRL,
     +          ISRM,ISRP(1023),ISRS,ISRT,ISRX,ISTB,ISTC,ISTD,
     +      ISTE,ISTF,ISTK(96),ISTL,ISTS,ISUM,ISVI,ISVN,
     +ITYQ,IUAF,IUCF,KWOK,LNCD,NABT,NAMI(500),NAMP,                NAMQ,
     +NAMR,NCLI,NCLO,NCTO,NDNT,NERR,NEST,NLNE,NLNX,                NPGE
      COMMON /IFTCM2/ IADE(26),IBUF(80),ICHS(50),ICNC,ICRD(1701),
     +            IEVS,IEVT,IHDR(115),ILCA(26),INSB(81),
     +            ISRC(6000),ISTA(1327),ITBC,ITYP,IUSB(81),
     +    IXCC,NAMC(1000),PTYP
      CHARACTER*1     IADE,IBUF,ICHS,ICNC,ICRD,IEVS,IEVT,IHDR,ILCA,INSB,
     +                ISRC,ISTA,ITBC,ITYP,IUSB,IXCC,NAMC,PTYP
      LOGICAL         DBLS,DSOK,IOCC,ISRA,ISRX,KWOK
      N=0
10001 CONTINUE
      IF (.NOT.(I.LE.LSTR)) GO TO 10002
      IF (.NOT.(ISTR(I).GE.ICHS(28).AND.ISTR(I).LE.ICHS(37)))
     +GO TO 10003
      N=10*N+INDEX1(ISTR(I),ICHS(28),1,12)-1
      GO TO 10004
10003 CONTINUE
      IF (.NOT.(ISTR(I).EQ.ICHS(38))) GO TO 10005
      K=11
      RETURN
10005 CONTINUE
      IF (.NOT.(ISTR(I).EQ.ICHS(39))) GO TO 10006
      K=12
      RETURN
10006 CONTINUE
      K=0
      RETURN
10004 CONTINUE
      I=I+1
      GO TO 10001
10002 CONTINUE
      K=12
      RETURN
      END
      SUBROUTINE DOSTAT
      COMMON /IFTCM1/ DBLS,DSOK,IBIT,ICRB,ICRI,ICRJ,ICRK,ICRL,ICUB,IFIN,
     +                IFOC,IFOF,IFOI,IFON,IFOS,IFVA(16),IFVI,IGND,
     +          IGNI,IGNN,IINP,INCL,INCP,INCU,IOCC,IOCP,IOTC,IOTX,
     +          IOUT,IPOC,IPOF,IPOI,IPON,IPOS,ISAV,ISGT,ISRA,ISRL,
     +          ISRM,ISRP(1023),ISRS,ISRT,ISRX,ISTB,ISTC,ISTD,
     +      ISTE,ISTF,ISTK(96),ISTL,ISTS,ISUM,ISVI,ISVN,
     +ITYQ,IUAF,IUCF,KWOK,LNCD,NABT,NAMI(500),NAMP,                NAMQ,
     +NAMR,NCLI,NCLO,NCTO,NDNT,NERR,NEST,NLNE,NLNX,                NPGE
      COMMON /IFTCM2/ IADE(26),IBUF(80),ICHS(50),ICNC,ICRD(1701),
     +            IEVS,IEVT,IHDR(115),ILCA(26),INSB(81),
     +            ISRC(6000),ISTA(1327),ITBC,ITYP,IUSB(81),
     +    IXCC,NAMC(1000),PTYP
      CHARACTER*1     IADE,IBUF,ICHS,ICNC,ICRD,IEVS,IEVT,IHDR,ILCA,INSB,
     +                ISRC,ISTA,ITBC,ITYP,IUSB,IXCC,NAMC,PTYP
      LOGICAL         DBLS,DSOK,IOCC,ISRA,ISRX,KWOK
      CHARACTER*1 KDO(2)
      DATA KDO / 'D', 'O' /
      CALL NEWNUM(N1)
      CALL STAK(5,N1,0)
      CALL CRDOUT
      CALL LABOUT
      CALL OUTSTR(KDO,1,2)
      CALL OUTSTR(ICHS(39),1,1)
      CALL OUTNUM(N1)
      CALL OUTSTR(ICHS(39),1,1)
      IF (.NOT.(ISTA(ISTD+1).NE.ICHS(44))) GO TO 10001
      CALL OUTSTR(ISTA,ISTD+1,ISTE-1)
      GO TO 10002
10001 CONTINUE
      CALL OUTSTR(ISTA,ISTD+2,ISTE-2)
10002 CONTINUE
      CALL OUTLIN(0)
      NEST=NEST+1
      RETURN
      END
      SUBROUTINE ELSORF
      COMMON /IFTCM1/ DBLS,DSOK,IBIT,ICRB,ICRI,ICRJ,ICRK,ICRL,ICUB,IFIN,
     +                IFOC,IFOF,IFOI,IFON,IFOS,IFVA(16),IFVI,IGND,
     +          IGNI,IGNN,IINP,INCL,INCP,INCU,IOCC,IOCP,IOTC,IOTX,
     +          IOUT,IPOC,IPOF,IPOI,IPON,IPOS,ISAV,ISGT,ISRA,ISRL,
     +          ISRM,ISRP(1023),ISRS,ISRT,ISRX,ISTB,ISTC,ISTD,
     +      ISTE,ISTF,ISTK(96),ISTL,ISTS,ISUM,ISVI,ISVN,
     +ITYQ,IUAF,IUCF,KWOK,LNCD,NABT,NAMI(500),NAMP,                NAMQ,
     +NAMR,NCLI,NCLO,NCTO,NDNT,NERR,NEST,NLNE,NLNX,                NPGE
      COMMON /IFTCM2/ IADE(26),IBUF(80),ICHS(50),ICNC,ICRD(1701),
     +            IEVS,IEVT,IHDR(115),ILCA(26),INSB(81),
     +            ISRC(6000),ISTA(1327),ITBC,ITYP,IUSB(81),
     +    IXCC,NAMC(1000),PTYP
      CHARACTER*1     IADE,IBUF,ICHS,ICNC,ICRD,IEVS,IEVT,IHDR,ILCA,INSB,
     +                ISRC,ISTA,ITBC,ITYP,IUSB,IXCC,NAMC,PTYP
      LOGICAL         DBLS,DSOK,IOCC,ISRA,ISRX,KWOK
      CHARACTER*1 IELI(8),ITHN(5)
      DATA IELI / 'E','L','S','E',' ','I','F',' ' /
      DATA ITHN / ' ','T','H','E','N' /
      CALL UNSTAK(N0,N1,N2)
      NEST=NEST-1
      IF (.NOT.(IBIT.EQ.0)) GO TO 10001
      IF (.NOT.(N0.EQ.1.AND.N2.NE.0)) GO TO 10002
      CALL CRDOUT
      IF (N1.EQ.0.AND.ISGT.EQ.0) CALL NEWNUM(N1)
      CALL GOTOCD(N1)
      CALL LABOUT
      CALL CONTCD(N2)
      N2=0
      IF (.NOT.(ISTD.LE.ISTE)) GO TO 10003
      CALL NEWNUM(N2)
      CALL IFNOT(ISTA,ISTD,ISTE,N2)
10003 CONTINUE
      GO TO 10004
10002 CONTINUE
      CALL ERRM(5)
      CALL CRDOUT
10004 CONTINUE
      GO TO 10005
10001 CONTINUE
      IF (.NOT.(N0.EQ.1)) GO TO 10006
      IF (.NOT.(ISTD.LE.ISTE)) GO TO 10007
      ISTB=ISTE-ISTD+21
      IF (.NOT.(ISTB.LE.1327)) GO TO 10008
      CALL XMIT(8,IELI,ISTA(7))
      CALL XMIT(ISTE-ISTD+1,ISTA(ISTD),ISTA(15))
      CALL XMIT(5,ITHN,ISTA(ISTB-5))
      ISTA(ISTB)=ICHS(50)
      GO TO 10009
10008 CONTINUE
      CALL ERRM(32)
      CALL NGEXIT(NERR)
      STOP
10009 CONTINUE
10007 CONTINUE
      ITYP=ICHS( 7)
      CALL CRDOUT
      ISGT=0
      GO TO 10010
10006 CONTINUE
      IF (.NOT.(N0.EQ.2)) GO TO 10011
      ITYP=ICHS( 7)
      CALL CRDOUT
      ISGT=0
      GO TO 10010
10011 CONTINUE
      CALL ERRM(5)
      CALL CRDOUT
10010 CONTINUE
10005 CONTINUE
      CALL STAK(N0,N1,N2)
      NEST=NEST+1
      RETURN
      END
      SUBROUTINE ENDBLO
      COMMON /IFTCM1/ DBLS,DSOK,IBIT,ICRB,ICRI,ICRJ,ICRK,ICRL,ICUB,IFIN,
     +                IFOC,IFOF,IFOI,IFON,IFOS,IFVA(16),IFVI,IGND,
     +          IGNI,IGNN,IINP,INCL,INCP,INCU,IOCC,IOCP,IOTC,IOTX,
     +          IOUT,IPOC,IPOF,IPOI,IPON,IPOS,ISAV,ISGT,ISRA,ISRL,
     +          ISRM,ISRP(1023),ISRS,ISRT,ISRX,ISTB,ISTC,ISTD,
     +      ISTE,ISTF,ISTK(96),ISTL,ISTS,ISUM,ISVI,ISVN,
     +ITYQ,IUAF,IUCF,KWOK,LNCD,NABT,NAMI(500),NAMP,                NAMQ,
     +NAMR,NCLI,NCLO,NCTO,NDNT,NERR,NEST,NLNE,NLNX,                NPGE
      COMMON /IFTCM2/ IADE(26),IBUF(80),ICHS(50),ICNC,ICRD(1701),
     +            IEVS,IEVT,IHDR(115),ILCA(26),INSB(81),
     +            ISRC(6000),ISTA(1327),ITBC,ITYP,IUSB(81),
     +    IXCC,NAMC(1000),PTYP
      CHARACTER*1     IADE,IBUF,ICHS,ICNC,ICRD,IEVS,IEVT,IHDR,ILCA,INSB,
     +                ISRC,ISTA,ITBC,ITYP,IUSB,IXCC,NAMC,PTYP
      LOGICAL         DBLS,DSOK,IOCC,ISRA,ISRX,KWOK
      CHARACTER*1 ITX1(7),ITX2(5)
      DATA ITX1 / 'G', 'O', ' ', 'T', 'O', ' ', '(' /
      DATA ITX2 / ')' , ' ' , ',' , ' ' , 'L' /
      NEST=NEST-1
      CALL CRDOUT
      CALL LABOUT
      CALL UNSTAK(N0,N1,N2)
      IF (.NOT.(N0.EQ.9)) GO TO 10001
      IF (.NOT.(ISGT.EQ.0.AND.NAMI(N1+3).GT.0)) GO TO 10002
      CALL OUTSTR(ITX1,1,7)
      I=NAMI(N1+3)
10003 CONTINUE
      IF (.NOT.(I.NE.0)) GO TO 10004
      CALL OUTNUM(NAMI(I))
      I=NAMI(I+1)
      IF (I.NE.0) CALL OUTCHR(ICHS(38))
      GO TO 10003
10004 CONTINUE
      CALL OUTSTR(ITX2,1,5)
      N3=ABS(NAMI(N1))
      CALL OUTNUM(N3)
      CALL OUTLIN(1)
10002 CONTINUE
      IF (N2.NE.0) CALL CONTCD(N2)
      GO TO 10005
10001 CONTINUE
      CALL ERRM(24)
      NEST=NEST+1
      CALL STAK(N0,N1,N2)
10005 CONTINUE
      RETURN
      END
      SUBROUTINE ENDDO
      COMMON /IFTCM1/ DBLS,DSOK,IBIT,ICRB,ICRI,ICRJ,ICRK,ICRL,ICUB,IFIN,
     +                IFOC,IFOF,IFOI,IFON,IFOS,IFVA(16),IFVI,IGND,
     +          IGNI,IGNN,IINP,INCL,INCP,INCU,IOCC,IOCP,IOTC,IOTX,
     +          IOUT,IPOC,IPOF,IPOI,IPON,IPOS,ISAV,ISGT,ISRA,ISRL,
     +          ISRM,ISRP(1023),ISRS,ISRT,ISRX,ISTB,ISTC,ISTD,
     +      ISTE,ISTF,ISTK(96),ISTL,ISTS,ISUM,ISVI,ISVN,
     +ITYQ,IUAF,IUCF,KWOK,LNCD,NABT,NAMI(500),NAMP,                NAMQ,
     +NAMR,NCLI,NCLO,NCTO,NDNT,NERR,NEST,NLNE,NLNX,                NPGE
      COMMON /IFTCM2/ IADE(26),IBUF(80),ICHS(50),ICNC,ICRD(1701),
     +            IEVS,IEVT,IHDR(115),ILCA(26),INSB(81),
     +            ISRC(6000),ISTA(1327),ITBC,ITYP,IUSB(81),
     +    IXCC,NAMC(1000),PTYP
      CHARACTER*1     IADE,IBUF,ICHS,ICNC,ICRD,IEVS,IEVT,IHDR,ILCA,INSB,
     +                ISRC,ISTA,ITBC,ITYP,IUSB,IXCC,NAMC,PTYP
      LOGICAL         DBLS,DSOK,IOCC,ISRA,ISRX,KWOK
      NEST=NEST-1
      CALL CRDOUT
      CALL LABOUT
      CALL UNSTAK(N0,N1,N2)
      IF (.NOT.(N0.EQ.5)) GO TO 10001
      CALL CONTCD(N1)
      GO TO 10002
10001 CONTINUE
      CALL ERRM(3)
      CALL STAK(N0,N1,N2)
      NEST=NEST+1
10002 CONTINUE
      RETURN
      END
      SUBROUTINE ENDFOR
      COMMON /IFTCM1/ DBLS,DSOK,IBIT,ICRB,ICRI,ICRJ,ICRK,ICRL,ICUB,IFIN,
     +                IFOC,IFOF,IFOI,IFON,IFOS,IFVA(16),IFVI,IGND,
     +          IGNI,IGNN,IINP,INCL,INCP,INCU,IOCC,IOCP,IOTC,IOTX,
     +          IOUT,IPOC,IPOF,IPOI,IPON,IPOS,ISAV,ISGT,ISRA,ISRL,
     +          ISRM,ISRP(1023),ISRS,ISRT,ISRX,ISTB,ISTC,ISTD,
     +      ISTE,ISTF,ISTK(96),ISTL,ISTS,ISUM,ISVI,ISVN,
     +ITYQ,IUAF,IUCF,KWOK,LNCD,NABT,NAMI(500),NAMP,                NAMQ,
     +NAMR,NCLI,NCLO,NCTO,NDNT,NERR,NEST,NLNE,NLNX,                NPGE
      COMMON /IFTCM2/ IADE(26),IBUF(80),ICHS(50),ICNC,ICRD(1701),
     +            IEVS,IEVT,IHDR(115),ILCA(26),INSB(81),
     +            ISRC(6000),ISTA(1327),ITBC,ITYP,IUSB(81),
     +    IXCC,NAMC(1000),PTYP
      CHARACTER*1     IADE,IBUF,ICHS,ICNC,ICRD,IEVS,IEVT,IHDR,ILCA,INSB,
     +                ISRC,ISTA,ITBC,ITYP,IUSB,IXCC,NAMC,PTYP
      LOGICAL         DBLS,DSOK,IOCC,ISRA,ISRX,KWOK
      NEST=NEST-1
      CALL CRDOUT
      CALL LABOUT
      CALL UNSTAK(N0,N1,N2)
      IF (.NOT.(N0.EQ.7)) GO TO 10001
      CALL GOTOCD(N1)
      CALL CONTCD(N2)
      GO TO 10002
10001 CONTINUE
      CALL ERRM(23)
      CALL STAK(N0,N1,N2)
      NEST=NEST+1
10002 CONTINUE
      RETURN
      END
      SUBROUTINE ENDIF
      COMMON /IFTCM1/ DBLS,DSOK,IBIT,ICRB,ICRI,ICRJ,ICRK,ICRL,ICUB,IFIN,
     +                IFOC,IFOF,IFOI,IFON,IFOS,IFVA(16),IFVI,IGND,
     +          IGNI,IGNN,IINP,INCL,INCP,INCU,IOCC,IOCP,IOTC,IOTX,
     +          IOUT,IPOC,IPOF,IPOI,IPON,IPOS,ISAV,ISGT,ISRA,ISRL,
     +          ISRM,ISRP(1023),ISRS,ISRT,ISRX,ISTB,ISTC,ISTD,
     +      ISTE,ISTF,ISTK(96),ISTL,ISTS,ISUM,ISVI,ISVN,
     +ITYQ,IUAF,IUCF,KWOK,LNCD,NABT,NAMI(500),NAMP,                NAMQ,
     +NAMR,NCLI,NCLO,NCTO,NDNT,NERR,NEST,NLNE,NLNX,                NPGE
      COMMON /IFTCM2/ IADE(26),IBUF(80),ICHS(50),ICNC,ICRD(1701),
     +            IEVS,IEVT,IHDR(115),ILCA(26),INSB(81),
     +            ISRC(6000),ISTA(1327),ITBC,ITYP,IUSB(81),
     +    IXCC,NAMC(1000),PTYP
      CHARACTER*1     IADE,IBUF,ICHS,ICNC,ICRD,IEVS,IEVT,IHDR,ILCA,INSB,
     +                ISRC,ISTA,ITBC,ITYP,IUSB,IXCC,NAMC,PTYP
      LOGICAL         DBLS,DSOK,IOCC,ISRA,ISRX,KWOK
      NEST=NEST-1
      CALL UNSTAK(N0,N1,N2)
      IF (.NOT.(IBIT.EQ.0)) GO TO 10001
      IF (.NOT.(N0.EQ.1)) GO TO 10002
      CALL CRDOUT
      CALL LABOUT
      IF (.NOT.(N1.NE.0)) GO TO 10003
      CALL CONTCD(N1)
10003 CONTINUE
      IF (.NOT.(N2.NE.0)) GO TO 10004
      CALL CONTCD(N2)
10004 CONTINUE
      GO TO 10005
10002 CONTINUE
      CALL ERRM(2)
      CALL CRDOUT
      CALL STAK(N0,N1,N2)
      NEST=NEST+1
10005 CONTINUE
      GO TO 10006
10001 CONTINUE
      IF (.NOT.(N0.EQ.1.OR.N0.EQ.2)) GO TO 10007
      ITYP=ICHS( 7)
      CALL CRDOUT
      ISGT=0
      GO TO 10008
10007 CONTINUE
      CALL ERRM(2)
      CALL CRDOUT
      CALL STAK(N0,N1,N2)
      NEST=NEST+1
10008 CONTINUE
10006 CONTINUE
      RETURN
      END
      SUBROUTINE ENDLOO
      COMMON /IFTCM1/ DBLS,DSOK,IBIT,ICRB,ICRI,ICRJ,ICRK,ICRL,ICUB,IFIN,
     +                IFOC,IFOF,IFOI,IFON,IFOS,IFVA(16),IFVI,IGND,
     +          IGNI,IGNN,IINP,INCL,INCP,INCU,IOCC,IOCP,IOTC,IOTX,
     +          IOUT,IPOC,IPOF,IPOI,IPON,IPOS,ISAV,ISGT,ISRA,ISRL,
     +          ISRM,ISRP(1023),ISRS,ISRT,ISRX,ISTB,ISTC,ISTD,
     +      ISTE,ISTF,ISTK(96),ISTL,ISTS,ISUM,ISVI,ISVN,
     +ITYQ,IUAF,IUCF,KWOK,LNCD,NABT,NAMI(500),NAMP,                NAMQ,
     +NAMR,NCLI,NCLO,NCTO,NDNT,NERR,NEST,NLNE,NLNX,                NPGE
      COMMON /IFTCM2/ IADE(26),IBUF(80),ICHS(50),ICNC,ICRD(1701),
     +            IEVS,IEVT,IHDR(115),ILCA(26),INSB(81),
     +            ISRC(6000),ISTA(1327),ITBC,ITYP,IUSB(81),
     +    IXCC,NAMC(1000),PTYP
      CHARACTER*1     IADE,IBUF,ICHS,ICNC,ICRD,IEVS,IEVT,IHDR,ILCA,INSB,
     +                ISRC,ISTA,ITBC,ITYP,IUSB,IXCC,NAMC,PTYP
      LOGICAL         DBLS,DSOK,IOCC,ISRA,ISRX,KWOK
      NEST=NEST-1
      CALL CRDOUT
      CALL LABOUT
      CALL UNSTAK(N0,N1,N2)
      IF (.NOT.(N0.EQ.6)) GO TO 10001
      CALL GOTOCD(N1)
      IF (N2.NE.0) CALL CONTCD(N2)
      GO TO 10002
10001 CONTINUE
      CALL ERRM(20)
      CALL STAK(N0,N1,N2)
      NEST=NEST+1
10002 CONTINUE
      RETURN
      END
      SUBROUTINE ENDWHI
      COMMON /IFTCM1/ DBLS,DSOK,IBIT,ICRB,ICRI,ICRJ,ICRK,ICRL,ICUB,IFIN,
     +                IFOC,IFOF,IFOI,IFON,IFOS,IFVA(16),IFVI,IGND,
     +          IGNI,IGNN,IINP,INCL,INCP,INCU,IOCC,IOCP,IOTC,IOTX,
     +          IOUT,IPOC,IPOF,IPOI,IPON,IPOS,ISAV,ISGT,ISRA,ISRL,
     +          ISRM,ISRP(1023),ISRS,ISRT,ISRX,ISTB,ISTC,ISTD,
     +      ISTE,ISTF,ISTK(96),ISTL,ISTS,ISUM,ISVI,ISVN,
     +ITYQ,IUAF,IUCF,KWOK,LNCD,NABT,NAMI(500),NAMP,                NAMQ,
     +NAMR,NCLI,NCLO,NCTO,NDNT,NERR,NEST,NLNE,NLNX,                NPGE
      COMMON /IFTCM2/ IADE(26),IBUF(80),ICHS(50),ICNC,ICRD(1701),
     +            IEVS,IEVT,IHDR(115),ILCA(26),INSB(81),
     +            ISRC(6000),ISTA(1327),ITBC,ITYP,IUSB(81),
     +    IXCC,NAMC(1000),PTYP
      CHARACTER*1     IADE,IBUF,ICHS,ICNC,ICRD,IEVS,IEVT,IHDR,ILCA,INSB,
     +                ISRC,ISTA,ITBC,ITYP,IUSB,IXCC,NAMC,PTYP
      LOGICAL         DBLS,DSOK,IOCC,ISRA,ISRX,KWOK
      NEST=NEST-1
      CALL CRDOUT
      CALL LABOUT
      CALL UNSTAK(N0,N1,N2)
      IF (.NOT.(N0.EQ.4)) GO TO 10001
      CALL GOTOCD(N1)
      CALL CONTCD(N2)
      GO TO 10002
10001 CONTINUE
      CALL ERRM(4)
      CALL STAK(N0,N1,N2)
      NEST=NEST+1
10002 CONTINUE
      RETURN
      END
      SUBROUTINE ERRM(N)
      COMMON /IFTCM1/ DBLS,DSOK,IBIT,ICRB,ICRI,ICRJ,ICRK,ICRL,ICUB,IFIN,
     +                IFOC,IFOF,IFOI,IFON,IFOS,IFVA(16),IFVI,IGND,
     +          IGNI,IGNN,IINP,INCL,INCP,INCU,IOCC,IOCP,IOTC,IOTX,
     +          IOUT,IPOC,IPOF,IPOI,IPON,IPOS,ISAV,ISGT,ISRA,ISRL,
     +          ISRM,ISRP(1023),ISRS,ISRT,ISRX,ISTB,ISTC,ISTD,
     +      ISTE,ISTF,ISTK(96),ISTL,ISTS,ISUM,ISVI,ISVN,
     +ITYQ,IUAF,IUCF,KWOK,LNCD,NABT,NAMI(500),NAMP,                NAMQ,
     +NAMR,NCLI,NCLO,NCTO,NDNT,NERR,NEST,NLNE,NLNX,                NPGE
      COMMON /IFTCM2/ IADE(26),IBUF(80),ICHS(50),ICNC,ICRD(1701),
     +            IEVS,IEVT,IHDR(115),ILCA(26),INSB(81),
     +            ISRC(6000),ISTA(1327),ITBC,ITYP,IUSB(81),
     +    IXCC,NAMC(1000),PTYP
      CHARACTER*1     IADE,IBUF,ICHS,ICNC,ICRD,IEVS,IEVT,IHDR,ILCA,INSB,
     +                ISRC,ISTA,ITBC,ITYP,IUSB,IXCC,NAMC,PTYP
      LOGICAL         DBLS,DSOK,IOCC,ISRA,ISRX,KWOK
      DIMENSION IPTR(37)
      CHARACTER*1 IERR(28),IMSG(818),
     +            IM01(16),IM02(15),IM03(15),IM04(18),IM05(22),IM06(18),
     +            IM07(28),IM08(22),IM09(27),IM10(31),IM11(26),IM12(32),
     +            IM13(13),IM14(23),IM15(34),IM16(28),IM17(21),IM18(31),
     +            IM19(14),IM20(17),IM21(28),IM22(22),IM23(16),IM24(18),
     +            IM25(26),IM26(19),IM27(30),IM28(19),IM29(33),IM30(31),
     +            IM31(26),IM32(19),IM33(24),IM34(21),IM35(19),IM36(16)
      EQUIVALENCE (IMSG(  1),IM01(1)) , (IMSG( 17),IM02(1)) ,
     +            (IMSG( 32),IM03(1)) , (IMSG( 47),IM04(1)) ,
     +            (IMSG( 65),IM05(1)) , (IMSG( 87),IM06(1)) ,
     +            (IMSG(105),IM07(1)) , (IMSG(133),IM08(1)) ,
     +            (IMSG(155),IM09(1)) , (IMSG(182),IM10(1)) ,
     +            (IMSG(213),IM11(1)) , (IMSG(239),IM12(1)) ,
     +            (IMSG(271),IM13(1)) , (IMSG(284),IM14(1)) ,
     +            (IMSG(307),IM15(1)) , (IMSG(341),IM16(1)) ,
     +            (IMSG(369),IM17(1)) , (IMSG(390),IM18(1)) ,
     +            (IMSG(421),IM19(1)) , (IMSG(435),IM20(1)) ,
     +            (IMSG(452),IM21(1)) , (IMSG(480),IM22(1)) ,
     +            (IMSG(502),IM23(1)) , (IMSG(518),IM24(1)) ,
     +            (IMSG(536),IM25(1)) , (IMSG(562),IM26(1)) ,
     +            (IMSG(581),IM27(1)) , (IMSG(611),IM28(1)) ,
     +            (IMSG(630),IM29(1)) , (IMSG(663),IM30(1)) ,
     +            (IMSG(694),IM31(1)) , (IMSG(720),IM32(1)) ,
     +            (IMSG(739),IM33(1)) , (IMSG(763),IM34(1)) ,
     +            (IMSG(784),IM35(1)) , (IMSG(803),IM36(1))
      DATA IPTR / 1,17,32,47,65,87,105,133,155,182,213,239,271,284,307,
     +            341,369,390,421,435,452,480,502,518,536,562,581,611,
     +            630,663,694,720,739,763,784,803,819 /
      DATA IERR / ' ',10*'*',' ','E','R','R','O','R',' ',10*'*' /
      DATA IM01 / ' ','M','I','S','S','I','N','G',' ','E','N','D',' ',
     +            '.','.','.'/
      DATA IM02 / ' ','I','N','V','A','L','I','D',' ','E','N','D',' ',
     +            'I','F'/
      DATA IM03 / ' ','I','N','V','A','L','I','D',' ','E','N','D',' ',
     +            'D','O'/
      DATA IM04 / ' ','I','N','V','A','L','I','D',' ','E','N','D',' ',
     +            'W','H','I','L','E'/
      DATA IM05 / ' ','I','N','V','A','L','I','D',' ','E','L','S','E',
     +            ' ','O','R',' ','O','R',' ','I','F'/
      DATA IM06 / ' ','C','O','M','M','A','N','D',' ','N','O','T',' ',
     +            'K','N','O','W','N'/
      DATA IM07 / ' ','I','N','P','U','T',' ','C','A','R','D',' ','B',
     +            'U','F','F','E','R',' ','T','O','O',' ','S','H','O',
     +            'R','T'/
      DATA IM08 / ' ','.','I','F',' ','U','S','E','D',' ','I','N','C',
     +            'O','R','R','E','C','T','L','Y',' '/
      DATA IM09 / ' ','R','E','P','L','A','C','E','M','E','N','T',' ',
     +            'T','A','B','L','E',' ','O','V','E','R','F','L','O',
     +            'W'/
      DATA IM10 / ' ','C','H','A','R','A','C','T','E','R',' ','S','T',
     +            'O','R','A','G','E',' ','I','N','S','U','F','F','I',
     +            'C','I','E','N','T'/
      DATA IM11 / ' ','S','T','R','I','N','G','-','R','E','P','L','A',
     +            'C','E','M','E','N','T',' ','E','R','R','O','R',' '/
      DATA IM12 / ' ','I','N','T','E','R','N','A','L',' ','I','F','T',
     +            'R','A','N',' ','E','R','R','O','R',' ','I','N',' ',
     +            'S','A','V','U','S','E'/
      DATA IM13 / ' ','M','I','S','S','I','N','G',' ','.','E','N','D'/
      DATA IM14 / ' ','N','E','S','T','E','D',' ','U','S','E',' ','N',
     +            'O','T',' ','A','L','L','O','W','E','D'/
      DATA IM15 / ' ','N','O',' ','F','I','L','E',' ','A','V','A','I',
     +            'L','A','B','L','E',' ','F','O','R',' ','S','A','V',
     +            'E',' ','O','R',' ','U','S','E'/
      DATA IM16 / ' ','S','A','V','E',' ','W','I','T','H','I','N',' ',
     +            'U','S','E',' ','N','O','T',' ','A','L','L','O','W',
     +            'E','D'/
      DATA IM17 / ' ','S','A','V','E',' ','G','R','O','U','P',' ','N',
     +            'O','T',' ','F','O','U','N','D'/
      DATA IM18 / ' ','I','N','V','A','L','I','D',' ','I','N','C','L',
     +            'U','D','E',' ','C','A','R','D',' ','-',' ','I','G',
     +            'N','O','R','E','D'/
      DATA IM19 / ' ','I','N','V','A','L','I','D',' ','U','N','T','I',
     +            'L'/
      DATA IM20 / ' ','I','N','V','A','L','I','D',' ','E','N','D',' ',
     +            'L','O','O','P'/
      DATA IM21 / ' ','N','O',' ','L','O','O','P',' ','F','O','R',' ',
     +            'E','X','I','T',' ','O','R',' ','E','X','I','T',' ',
     +            'I','F'/
      DATA IM22 / ' ','I','N','V','A','L','I','D',' ','F','O','R',' ',
     +            'S','T','A','T','E','M','E','N','T'/
      DATA IM23 / ' ','I','N','V','A','L','I','D',' ','E','N','D',' ',
     +            'F','O','R'/
      DATA IM24 / ' ','I','N','V','A','L','I','D',' ','E','N','D',' ',
     +            'B','L','O','C','K'/
      DATA IM25 / ' ','B','L','O','C','K',' ','I','N','F','O',' ','T',
     +            'A','B','L','E',' ','O','V','E','R','F','L','O','W'/
      DATA IM26 / ' ','I','N','V','A','L','I','D',' ','B','L','O','C',
     +            'K',' ','N','A','M','E'/
      DATA IM27 / ' ','I','F','T','R','A','N',' ','C','O','M','M','A',
     +            'N','D',' ','-',' ','S','Y','N','T','A','X',' ','E',
     +            'R','R','O','R'/
      DATA IM28 / ' ','I','F','T','R','A','N',' ','L','O','G','I','C',
     +            ' ','E','R','R','O','R'/
      DATA IM29 / ' ','S','Y','N','T','A','X',' ','E','R','R','O','R',
     +            ' ','I','N',' ','I','F','T','R','A','N',' ','C','O',
     +            'N','S','T','R','U','C','T'/
      DATA IM30 / ' ','S','T','A','T','E','M','E','N','T','-','L','A',
     +            'B','E','L','-','S','T','A','C','K',' ','O','V','E',
     +            'R','F','L','O','W'/
      DATA IM31 / ' ','B','L','O','C','K',' ','N','A','M','E',' ','T',
     +            'A','B','L','E',' ','O','V','E','R','F','L','O','W'/
      DATA IM32 / ' ','S','T','A','T','E','M','E','N','T',' ','T','O',
     +            'O',' ','L','O','N','G'/
      DATA IM33 / ' ','S','T','R','I','N','G','-','E','V','A','L','U',
     +            'A','T','I','O','N',' ','E','R','R','O','R'/
      DATA IM34 / ' ','I','N','V','O','K','E',' ','F','O','L','L','O',
     +            'W','S',' ','B','L','O','C','K'/
      DATA IM35 / ' ','B','L','O','C','K','S',' ','U','N','D','E','F',
     +            'I','N','E','D',' ','-'/
      DATA IM36 / ' ','B','L','O','C','K',' ','R','E','D','E','F','I',
     +            'N','E','D'/
      NERR=NERR+1
      NMSG=N
      IF (NMSG.LT.1.OR.NMSG.GT.36) NMSG=28
      INDM=IPTR(NMSG)
      LENM=IPTR(NMSG+1)-IPTR(NMSG)
      IF (.NOT.(IOUT.NE.0)) GO TO 10001
      CALL SPCOUT(1)
      CALL IFTRIO(2,IOUT,IERR,28,0)
      CALL SPCOUT(1)
      CALL IFTRIO(2,IOUT,IMSG(INDM),LENM,0)
10001 CONTINUE
      CALL TYPERR(N,IMSG(INDM),LENM)
      RETURN
      END
      SUBROUTINE EXITIF
      COMMON /IFTCM1/ DBLS,DSOK,IBIT,ICRB,ICRI,ICRJ,ICRK,ICRL,ICUB,IFIN,
     +                IFOC,IFOF,IFOI,IFON,IFOS,IFVA(16),IFVI,IGND,
     +          IGNI,IGNN,IINP,INCL,INCP,INCU,IOCC,IOCP,IOTC,IOTX,
     +          IOUT,IPOC,IPOF,IPOI,IPON,IPOS,ISAV,ISGT,ISRA,ISRL,
     +          ISRM,ISRP(1023),ISRS,ISRT,ISRX,ISTB,ISTC,ISTD,
     +      ISTE,ISTF,ISTK(96),ISTL,ISTS,ISUM,ISVI,ISVN,
     +ITYQ,IUAF,IUCF,KWOK,LNCD,NABT,NAMI(500),NAMP,                NAMQ,
     +NAMR,NCLI,NCLO,NCTO,NDNT,NERR,NEST,NLNE,NLNX,                NPGE
      COMMON /IFTCM2/ IADE(26),IBUF(80),ICHS(50),ICNC,ICRD(1701),
     +            IEVS,IEVT,IHDR(115),ILCA(26),INSB(81),
     +            ISRC(6000),ISTA(1327),ITBC,ITYP,IUSB(81),
     +    IXCC,NAMC(1000),PTYP
      CHARACTER*1     IADE,IBUF,ICHS,ICNC,ICRD,IEVS,IEVT,IHDR,ILCA,INSB,
     +                ISRC,ISTA,ITBC,ITYP,IUSB,IXCC,NAMC,PTYP
      LOGICAL         DBLS,DSOK,IOCC,ISRA,ISRX,KWOK
      CALL EXITXX(N2)
      IF (N2.GT.0) CALL IFTRUE(ISTA,ISTD+1,ISTE-1,N2)
      RETURN
      END
      SUBROUTINE EXITST
      CALL EXITXX(N2)
      IF (N2.GT.0) CALL GOTOCD(N2)
      RETURN
      END
      SUBROUTINE EXITXX(N2)
      COMMON /IFTCM1/ DBLS,DSOK,IBIT,ICRB,ICRI,ICRJ,ICRK,ICRL,ICUB,IFIN,
     +                IFOC,IFOF,IFOI,IFON,IFOS,IFVA(16),IFVI,IGND,
     +          IGNI,IGNN,IINP,INCL,INCP,INCU,IOCC,IOCP,IOTC,IOTX,
     +          IOUT,IPOC,IPOF,IPOI,IPON,IPOS,ISAV,ISGT,ISRA,ISRL,
     +          ISRM,ISRP(1023),ISRS,ISRT,ISRX,ISTB,ISTC,ISTD,
     +      ISTE,ISTF,ISTK(96),ISTL,ISTS,ISUM,ISVI,ISVN,
     +ITYQ,IUAF,IUCF,KWOK,LNCD,NABT,NAMI(500),NAMP,                NAMQ,
     +NAMR,NCLI,NCLO,NCTO,NDNT,NERR,NEST,NLNE,NLNX,                NPGE
      COMMON /IFTCM2/ IADE(26),IBUF(80),ICHS(50),ICNC,ICRD(1701),
     +            IEVS,IEVT,IHDR(115),ILCA(26),INSB(81),
     +            ISRC(6000),ISTA(1327),ITBC,ITYP,IUSB(81),
     +    IXCC,NAMC(1000),PTYP
      CHARACTER*1     IADE,IBUF,ICHS,ICNC,ICRD,IEVS,IEVT,IHDR,ILCA,INSB,
     +                ISRC,ISTA,ITBC,ITYP,IUSB,IXCC,NAMC,PTYP
      LOGICAL         DBLS,DSOK,IOCC,ISRA,ISRX,KWOK
      CALL STAKFI(6,N1,N2,NDEE)
      NEST=NEST-NDEE
      CALL CRDOUT
      CALL LABOUT
      NEST=NEST+NDEE
      IF (.NOT.(N1.LE.0)) GO TO 10001
      CALL ERRM(21)
      GO TO 10002
10001 CONTINUE
      IF (.NOT.(N2.LE.0)) GO TO 10003
      CALL NEWNUM(N2)
      I=ISTL-3*(NDEE-1)
      ISTK(I)=N2
10003 CONTINUE
10002 CONTINUE
      RETURN
      END
      SUBROUTINE FORSTA
      COMMON /IFTCM1/ DBLS,DSOK,IBIT,ICRB,ICRI,ICRJ,ICRK,ICRL,ICUB,IFIN,
     +                IFOC,IFOF,IFOI,IFON,IFOS,IFVA(16),IFVI,IGND,
     +          IGNI,IGNN,IINP,INCL,INCP,INCU,IOCC,IOCP,IOTC,IOTX,
     +          IOUT,IPOC,IPOF,IPOI,IPON,IPOS,ISAV,ISGT,ISRA,ISRL,
     +          ISRM,ISRP(1023),ISRS,ISRT,ISRX,ISTB,ISTC,ISTD,
     +      ISTE,ISTF,ISTK(96),ISTL,ISTS,ISUM,ISVI,ISVN,
     +ITYQ,IUAF,IUCF,KWOK,LNCD,NABT,NAMI(500),NAMP,                NAMQ,
     +NAMR,NCLI,NCLO,NCTO,NDNT,NERR,NEST,NLNE,NLNX,                NPGE
      COMMON /IFTCM2/ IADE(26),IBUF(80),ICHS(50),ICNC,ICRD(1701),
     +            IEVS,IEVT,IHDR(115),ILCA(26),INSB(81),
     +            ISRC(6000),ISTA(1327),ITBC,ITYP,IUSB(81),
     +    IXCC,NAMC(1000),PTYP
      CHARACTER*1     IADE,IBUF,ICHS,ICNC,ICRD,IEVS,IEVT,IHDR,ILCA,INSB,
     +                ISRC,ISTA,ITBC,ITYP,IUSB,IXCC,NAMC,PTYP
      LOGICAL         DBLS,DSOK,IOCC,ISRA,ISRX,KWOK
      CHARACTER*1 ITCH
      DIMENSION IBEG(8),IEND(8),LKWD(6),KWPT(6)
      CHARACTER*1 KYWD(6,6),IFST(4),IGST(7),ILTS(4),IGTS(4)
      DATA LKWD / 3 , 3 , 5 , 6 , 6 , 5 /
      DATA KWPT / 4 , 5 , 5 , 6 , 7 , 8 /
      DATA KYWD / 'T' , 'O' , ' ' , ' ' , ' ' , ' ' ,
     +            'B' , 'Y' , ' ' , ' ' , ' ' , ' ' ,
     +            'S' , 'T' , 'E' , 'P' , ' ' , ' ' ,
     +            'W' , 'H' , 'I' , 'L' , 'E' , ' ' ,
     +            'U' , 'N' , 'T' , 'I' , 'L' , ' ' ,
     +            'N' , 'E' , 'X' , 'T' , ' ' , ' ' /
      DATA IFST / 'I' , 'F' , ' ' , '(' /
      DATA IGST / ' ' , 'G' , 'O' , ' ' , 'T' , 'O' , ' ' /
      DATA ILTS / '.' , 'L' , 'T' , '.' /
      DATA IGTS / '.' , 'G' , 'T' , '.' /
      CALL CRDOUT
      CALL LABOUT
      CALL NEWNUM(N1)
      CALL NEWNUM(N2)
      CALL NEWNUM(N3)
      CALL STAK(7,N1,N2)
      NEST=NEST+1
      DO 10001 I=1,8
      IBEG(I)=0
10001 CONTINUE
      IEQ=INDEX1(ICHS(46),ISTA,ISTD,ISTE)
      IF (IEQ.EQ.0) GO TO 101
      IBEG(1)=ISTD+1
      IF (ISTA(ISTD+1).EQ.ICHS(44)) IBEG(1)=ISTD+2
      IEND(1)=IEQ-1
      IBEG(2)=IEQ
      IEND(2)=IEQ
      IBEG(3)=IEQ+1
      LPRE=3
      ISCN=IEQ+2
10002 CONTINUE
      IF (.NOT.(ISCN.LT.ISTE)) GO TO 10003
      IF (.NOT.(ISTA(ISCN).EQ.ICHS(39))) GO TO 10004
      DO 10005 IKWD=1,6
      MTCH=0
      DO 10006 I=1,LKWD(IKWD)
      ITCH=ISTA(ISCN+I)
      IF (.NOT.(ITCH.GE.ILCA(1).AND.ITCH.LE.ILCA(26))) GO TO 10007
      ITCH=CHAR(ICHAR(ICHS( 2))+ICHAR(ITCH)-ICHAR(ILCA( 1)))
10007 CONTINUE
      IF (ITCH.NE.KYWD(I,IKWD)) GO TO 102
10006 CONTINUE
      MTCH=1
  102 CONTINUE
      IF (.NOT.(MTCH.NE.0)) GO TO 10008
      LCUR=KWPT(IKWD)
      IF (IBEG(LCUR).NE.0) GO TO 101
      IEND(LPRE)=ISCN-1
      LPRE=LCUR
      IBEG(LCUR)=ISCN+1+LKWD(IKWD)
      ISCN=ISCN+LKWD(IKWD)
10008 CONTINUE
10005 CONTINUE
10004 CONTINUE
      ISCN=ISCN+1
      GO TO 10002
10003 CONTINUE
      IEND(LPRE)=ISTE-1
      IF (ISTA(ISTD+1).EQ.ICHS(44)) IEND(LPRE)=ISTE-2
      IF (.NOT.(IBEG(8).NE.0)) GO TO 10009
      IF (IBEG(4).NE.0.OR.IBEG(5).NE.0) GO TO 101
      GO TO 10010
10009 CONTINUE
      IF (.NOT.(IBEG(5).EQ.0)) GO TO 10011
      INCK=1
      ISGN=0
      GO TO 10012
10011 CONTINUE
      I=IBEG(5)
      INCK=0
      ISGN=0
      IF (.NOT.(ISTA(I).EQ.ICHS(40))) GO TO 10013
      INCK=1
      ISGN=1
      GO TO 10014
10013 CONTINUE
      IF (.NOT.(ISTA(I).EQ.ICHS(41))) GO TO 10015
      INCK=-1
      ISGN=-1
      GO TO 10014
10015 CONTINUE
      IF (.NOT.(ISTA(I).EQ.ICHS(47).OR.(ISTA(I).GE.ICHS(28).AND.ISTA(I).
     +LE.ICHS(37)))) GO TO 10016
      INCK=1
10014 CONTINUE
10016 CONTINUE
10017 CONTINUE
      IF (.NOT.(INCK.NE.0.AND.I.LT.IEND(5))) GO TO 10018
      I=I+1
      IF (ISTA(I).NE.ICHS(47).AND.ISTA(I).NE.ICHS(39).AND.
     +                            (ISTA(I).LT.ICHS(28).OR.ISTA(I).GT.ICH
     +S(37))) INCK=0
      GO TO 10017
10018 CONTINUE
10012 CONTINUE
      IF (.NOT.(INCK.EQ.0)) GO TO 10019
      CALL NEWNUM(N4)
      CALL NEWNUM(N5)
      CALL NEWNUM(N6)
10019 CONTINUE
10010 CONTINUE
      CALL OUTSTR(ISTA,IBEG(1),IEND(3))
      CALL OUTLIN(0)
      CALL GOTOCD(N3)
      CALL CONTCD(N1)
      IF (.NOT.(IBEG(7).NE.0)) GO TO 10020
      CALL IFTRUE(ISTA,IBEG(7),IEND(7),N2)
10020 CONTINUE
      CALL OUTSTR(ISTA,IBEG(1),IEND(2))
      IF (.NOT.(IBEG(8).NE.0)) GO TO 10021
      CALL OUTSTR(ISTA,IBEG(8),IEND(8))
      GO TO 10022
10021 CONTINUE
      CALL OUTSTR(ISTA,IBEG(1),IEND(1))
      IF (ISGN.EQ.0) CALL OUTCHR(ICHS(40))
      IF (.NOT.(IBEG(5).EQ.0)) GO TO 10023
      CALL OUTCHR(ICHS(29))
      GO TO 10024
10023 CONTINUE
      CALL OUTSTR(ISTA,IBEG(5),IEND(5))
10024 CONTINUE
10022 CONTINUE
      CALL OUTLIN(0)
      CALL CONTCD(N3)
      IF (.NOT.(IBEG(4).NE.0)) GO TO 10025
      IF (.NOT.(INCK.EQ.0)) GO TO 10026
      CALL OUTSTR(IFST,1,4)
      CALL OUTSTR(ISTA,IBEG(5),IEND(5))
      CALL OUTCHR(ICHS(45))
      CALL OUTCHR(ICHS(39))
      CALL OUTNUM(N4)
      CALL OUTCHR(ICHS(38))
      CALL OUTNUM(N5)
      CALL OUTCHR(ICHS(38))
      CALL OUTNUM(N6)
      CALL OUTLIN(0)
      CALL CONTCD(N4)
10026 CONTINUE
      IF (.NOT.(INCK.LE.0)) GO TO 10027
      CALL OUTSTR(IFST,1,4)
      CALL OUTSTR(ISTA,IBEG(1),IEND(1))
      CALL OUTSTR(ILTS,1,4)
      CALL OUTCHR(ICHS(44))
      CALL OUTSTR(ISTA,IBEG(4),IEND(4))
      CALL OUTCHR(ICHS(45))
      CALL OUTCHR(ICHS(45))
      CALL OUTSTR(IGST,1,7)
      CALL OUTNUM(N2)
      CALL OUTLIN(0)
10027 CONTINUE
      IF (.NOT.(INCK.EQ.0)) GO TO 10028
      CALL GOTOCD(N5)
      CALL CONTCD(N6)
10028 CONTINUE
      IF (.NOT.(INCK.GE.0)) GO TO 10029
      CALL OUTSTR(IFST,1,4)
      CALL OUTSTR(ISTA,IBEG(1),IEND(1))
      CALL OUTSTR(IGTS,1,4)
      CALL OUTCHR(ICHS(44))
      CALL OUTSTR(ISTA,IBEG(4),IEND(4))
      CALL OUTCHR(ICHS(45))
      CALL OUTCHR(ICHS(45))
      CALL OUTSTR(IGST,1,7)
      CALL OUTNUM(N2)
      CALL OUTLIN(0)
10029 CONTINUE
      IF (.NOT.(INCK.EQ.0)) GO TO 10030
      CALL CONTCD(N5)
10030 CONTINUE
10025 CONTINUE
      IF (.NOT.(IBEG(6).NE.0)) GO TO 10031
      I=IBEG(6)-1
      ISTA(I)=ICHS(44)
      I=IEND(6)+1
      ISTA(I)=ICHS(45)
      CALL IFNOT(ISTA,IBEG(6)-1,IEND(6)+1,N2)
10031 CONTINUE
      RETURN
  101 CALL ERRM(22)
      RETURN
      END
      SUBROUTINE GETSTA
      COMMON /IFTCM1/ DBLS,DSOK,IBIT,ICRB,ICRI,ICRJ,ICRK,ICRL,ICUB,IFIN,
     +                IFOC,IFOF,IFOI,IFON,IFOS,IFVA(16),IFVI,IGND,
     +          IGNI,IGNN,IINP,INCL,INCP,INCU,IOCC,IOCP,IOTC,IOTX,
     +          IOUT,IPOC,IPOF,IPOI,IPON,IPOS,ISAV,ISGT,ISRA,ISRL,
     +          ISRM,ISRP(1023),ISRS,ISRT,ISRX,ISTB,ISTC,ISTD,
     +      ISTE,ISTF,ISTK(96),ISTL,ISTS,ISUM,ISVI,ISVN,
     +ITYQ,IUAF,IUCF,KWOK,LNCD,NABT,NAMI(500),NAMP,                NAMQ,
     +NAMR,NCLI,NCLO,NCTO,NDNT,NERR,NEST,NLNE,NLNX,                NPGE
      COMMON /IFTCM2/ IADE(26),IBUF(80),ICHS(50),ICNC,ICRD(1701),
     +            IEVS,IEVT,IHDR(115),ILCA(26),INSB(81),
     +            ISRC(6000),ISTA(1327),ITBC,ITYP,IUSB(81),
     +    IXCC,NAMC(1000),PTYP
      CHARACTER*1     IADE,IBUF,ICHS,ICNC,ICRD,IEVS,IEVT,IHDR,ILCA,INSB,
     +                ISRC,ISTA,ITBC,ITYP,IUSB,IXCC,NAMC,PTYP
      LOGICAL         DBLS,DSOK,IOCC,ISRA,ISRX,KWOK
      CHARACTER*1 ICMP(30,5),JXCC,ITCH
      DATA (ICMP( 1,J),J=1,5) / 'A' , 'C' , 'T' , 'I' , 'V' /
      DATA (ICMP( 2,J),J=1,5) / 'C' , 'A' , 'L' , 'L' , ' ' /
      DATA (ICMP( 3,J),J=1,5) / 'C' , 'O' , 'N' , 'T' , 'I' /
      DATA (ICMP( 4,J),J=1,5) / 'D' , 'E' , 'A' , 'C' , 'T' /
      DATA (ICMP( 5,J),J=1,5) / 'D' , 'S' , 'O' , 'K' , ' ' /
      DATA (ICMP( 6,J),J=1,5) / 'E' , 'J' , 'E' , 'C' , 'T' /
      DATA (ICMP( 7,J),J=1,5) / 'E' , 'L' , ' ' , ' ' , ' ' /
      DATA (ICMP( 8,J),J=1,5) / 'E' , 'L' , 'I' , 'M' , 'I' /
      DATA (ICMP( 9,J),J=1,5) / 'E' , 'L' , 'S' , 'E' , ' ' /
      DATA (ICMP(10,J),J=1,5) / 'E' , 'L' , 'S' , 'E' , 'I' /
      DATA (ICMP(11,J),J=1,5) / 'E' , 'N' , ' ' , ' ' , ' ' /
      DATA (ICMP(12,J),J=1,5) / 'E' , 'N' , 'D' , ' ' , ' ' /
      DATA (ICMP(13,J),J=1,5) / 'E' , 'N' , 'D' , 'I' , 'F' /
      DATA (ICMP(14,J),J=1,5) / 'I' , 'F' , ' ' , ' ' , ' ' /
      DATA (ICMP(15,J),J=1,5) / 'I' , 'N' , 'C' , 'L' , 'U' /
      DATA (ICMP(16,J),J=1,5) / 'K' , 'W' , 'O' , 'K' , ' ' /
      DATA (ICMP(17,J),J=1,5) / 'L' , 'I' , 'S' , 'T' , ' ' /
      DATA (ICMP(18,J),J=1,5) / 'N' , 'O' , 'D' , 'S' , 'O' /
      DATA (ICMP(19,J),J=1,5) / 'N' , 'O' , 'K' , 'W' , 'O' /
      DATA (ICMP(20,J),J=1,5) / 'N' , 'O' , 'L' , 'I' , 'S' /
      DATA (ICMP(21,J),J=1,5) / 'N' , 'O' , 'R' , 'E' , 'P' /
      DATA (ICMP(22,J),J=1,5) / 'O' , 'P' , 'T' , 'I' , 'O' /
      DATA (ICMP(23,J),J=1,5) / 'O' , 'R' , 'I' , 'F' , ' ' /
      DATA (ICMP(24,J),J=1,5) / 'O' , 'T' , 'H' , 'E' , 'R' /
      DATA (ICMP(25,J),J=1,5) / 'R' , 'E' , 'P' , 'L' , 'A' /
      DATA (ICMP(26,J),J=1,5) / 'S' , 'A' , 'V' , 'E' , ' ' /
      DATA (ICMP(27,J),J=1,5) / 'T' , 'A' , 'B' , ' ' , ' ' /
      DATA (ICMP(28,J),J=1,5) / 'T' , 'I' , 'T' , 'L' , 'E' /
      DATA (ICMP(29,J),J=1,5) / 'U' , 'S' , 'E' , ' ' , ' ' /
      DATA (ICMP(30,J),J=1,5) / 'X' , 'C' , 'O' , 'M' , ' ' /
  101 CONTINUE
      IF (.NOT.(ICRK.EQ.(-1))) GO TO 10001
      ICRI=-1
      ICRJ=0
      ICRK=0
      ICRL=0
      RETURN
10001 CONTINUE
      ISTF=0
      ITMP=MAX(ICRK,1)
      IF (.NOT.(ICRK.EQ.0.OR.ICRD(ITMP).EQ.ICHS(50))) GO TO 10002
10003 CONTINUE
      CALL RDCRD(ICRD,IEOF,1)
      IF (.NOT.(IEOF.NE.0)) GO TO 10004
      ICRI=-1
      ICRJ=0
      ICRK=0
      ICRL=0
      RETURN
10004 CONTINUE
      IF (.NOT.(ICRD(1).NE.ICHS(50))) GO TO 10003
      ICRK=1
      ICRL=LNCD+1
10002 CONTINUE
      ICRI=ICRK
      ICRJ=ICRL
      ICRK=0
      NCLO=NCLO+NCLI
      NCLI=0
      IF (.NOT.(ICRD(ICRI).EQ.ICHS(4).OR.ICRD(ICRI).EQ.ILCA(3).OR.ICRD(I
     +CRI).EQ.ICHS(47).OR.ICRD(ICRI).EQ.ICHS(42))) GO TO 10005
      IF (.NOT.((ICRD(ICRI+1).LT.ICHS(2).OR.ICRD(ICRI+1).GT.ICHS(27)).AN
     +D.(ICRD(ICRI+1).LT.ILCA(1).OR.ICRD(ICRI+1).GT.ILCA(26))))
     +GO TO 10006
      IF (IFVA(IFVI).LE.0) GO TO 101
      ICRD(ICRI)=ICHS( 4)
      ITYP=ICHS( 4)
      IF (.NOT.(IFOC.NE.0)) GO TO 10007
      CALL XMIT(72,ICRD(ICRI),ISTA)
      ISTB=73
      GO TO 10008
10007 CONTINUE
      ISTB=1
10008 CONTINUE
      ISTA(ISTB)=ICHS(50)
      RETURN
10006 CONTINUE
      IF (.NOT.((ICRD(ICRI).EQ.ICHS(4).OR.ICRD(ICRI).EQ.ILCA(3)).AND.(IC
     +RD(ICRI+1).EQ.ICHS(5).OR.ICRD(ICRI+1).EQ.ILCA(4)).AND.(ICRD(ICRI+2
     +).EQ.ICHS(10).OR.ICRD(ICRI+2).EQ.ILCA(9)).AND.(ICRD(ICRI+3).EQ.ICH
     +S(19).OR.ICRD(ICRI+3).EQ.ILCA(18)).AND.ICRD(ICRI+4).EQ.ICHS(1).AND
     +.ICRD(ICRI+5).EQ.ICHS(39))) GO TO 10009
      IF (IFVA(IFVI).LE.0) GO TO 101
      ITYP=ICHS( 7)
      GO TO 10010
10009 CONTINUE
      ICRD(ICRI)=ICHS(47)
      ITYP=ICHS(10)
10010 CONTINUE
      GO TO 10011
10005 CONTINUE
      IF (IFVA(IFVI).LE.0) GO TO 101
      ITYP=ICHS( 7)
10011 CONTINUE
10012 CONTINUE
      ICRK=ICRJ+1
      IF (ICRK+LNCD.GT.1701) ICRK=1
      ICRL=ICRK+LNCD
      IF (.NOT.(ICRK.LE.ICRI.AND.ICRL.GE.ICRI)) GO TO 10013
      CALL ERRM(7)
      ICRK=0
      ICRL=ICRJ
      GO TO 10014
10013 CONTINUE
10015 CONTINUE
      CALL RDCRD(ICRD(ICRK),IEOF,1)
      IF (.NOT.(IEOF.NE.0)) GO TO 10016
      ICRK=-1
      ICRL=ICRJ
      GO TO 10014
10016 CONTINUE
      IF (.NOT.(ITYP.EQ.ICHS(10).OR.ICRD(ICRK).NE.ICHS(50))) GO TO 10015
      IF (ICRD(ICRK).EQ.ICHS(4).OR.ICRD(ICRK).EQ.ILCA(3).OR.ICRD(ICRK).E
     +Q.ICHS(47).OR.ICRD(ICRK).EQ.ICHS(42)) GO TO 10014
      IF (ITYP.EQ.ICHS(7).AND.(ICRD(ICRK+5).EQ.ICHS(39).OR.ICRD(ICRK+5).
     +EQ.ICHS(28))) GO TO 10014
      IF (ITYP.EQ.ICHS(10).AND.ICRD(ICRK).NE.ICHS(38)) GO TO 10014
      ICRJ=ICRL
      GO TO 10012
10014 CONTINUE
      I=ICRI
      IF (.NOT.(ITYP.EQ.ICHS(7))) GO TO 10017
      CALL XMIT(6,ICRD(ICRI),ISTA)
      ISTB=6
      J=ICRI+6
      K=66
      GO TO 10018
10017 CONTINUE
      CALL XMIT(1,ICRD(ICRI),ISTA)
      ISTB=1
      J=ICRI+1
      K=71
10018 CONTINUE
      JXCC=IXCC
      IF (.NOT.(ITYP.EQ.ICHS(10))) GO TO 10019
      IF ((ICRD(ICRI+1).EQ.ICHS(25).OR.ICRD(ICRI+1).EQ.ILCA(24)).AND.
     +              (ICRD(ICRI+2).EQ.ICHS( 4).OR.ICRD(ICRI+2).EQ.ILCA( 3
     +))) JXCC=ICHS(50)
10019 CONTINUE
10020 CONTINUE
      IF (.NOT.(JXCC.EQ.ICHS(50))) GO TO 10021
      L=K
      GO TO 10022
10021 CONTINUE
      L=INDEX1(JXCC,ICRD(J),1,K)-1
      IF (L.LT.0) L=K
10022 CONTINUE
      CALL XMIT (L,ICRD(J),ISTA(ISTB+1))
      ISTB=ISTB+L
      IF (.NOT.(I+LNCD.EQ.ICRJ)) GO TO 10023
      ISTB=LSTNB(ISTA,1,ISTB)
      IF (.NOT.(ISTB.LT.7)) GO TO 10024
      CALL XMIT(ISTB-7,ICHS(39),ISTA(ISTB+1))
      ISTB=7
10024 CONTINUE
      GO TO 10025
10023 CONTINUE
      I=I+LNCD+1
      J=J+LNCD+1
      IF (.NOT.(I+LNCD.GT.1701)) GO TO 10026
      J=1+J-I
      I=1
10026 CONTINUE
      GO TO 10020
10025 CONTINUE
      ISTB=ISTB+1
      ISTA(ISTB)=ICHS(50)
      IF (.NOT.(ITYP.EQ.ICHS(10))) GO TO 10027
      ITYQ=1
      ITYR=30
      ISTC = 2
      GO TO 10030
10028 CONTINUE
      IF (ITYQ.EQ.0.OR.ISTA(ISTC).EQ.ICHS(39)) GO TO 10029
      ISTC =ISTC +1
10030 CONTINUE
      IF (ISTC .GT.(6)) GO TO 10029
      IF (.NOT.(ITYQ.NE.ITYR.OR.ISTA(ISTC).NE.ICHS(39))) GO TO 10031
      ITCH=ISTA(ISTC)
      IF (.NOT.(ITCH.GE.ILCA(1).AND.ITCH.LE.ILCA(26))) GO TO 10032
      ITCH=CHAR(ICHAR(ICHS( 2))+ICHAR(ITCH)-ICHAR(ILCA( 1)))
10032 CONTINUE
      ITYQ=INDEX1(ITCH,ICMP(1,ISTC-1),ITYQ,ITYR)
10033 CONTINUE
      IF (.NOT.(ITYQ.NE.0.AND.ITCH.NE.ICMP(ITYR,ISTC-1))) GO TO 10034
      ITYR=ITYR-1
      GO TO 10033
10034 CONTINUE
10031 CONTINUE
      GO TO 10028
10029 CONTINUE
      IF (.NOT.(ITYQ.NE.ITYR)) GO TO 10035
      IF (IFVA(IFVI).LE.0) GO TO 101
      IF (.NOT.(IUCF.NE.0)) GO TO 10036
      CALL ERRM(6)
10036 CONTINUE
      ICRD(ICRI)=ICHS( 4)
      ITYP=ICHS( 4)
      RETURN
10035 CONTINUE
      IF (.NOT.(IFVA(IFVI).LE.0)) GO TO 10037
      IF (ITYQ.NE.9.AND.ITYQ.NE.10.AND.ITYQ.NE.13.AND.
     +           ITYQ.NE.14.AND.ITYQ.NE.23.AND.ITYQ.NE.24) GO TO 101
10037 CONTINUE
      IF (ISTA(ISTC).NE.ICHS(39)) ISTC=INDEX1(ICHS(39),ISTA,ISTC+1,ISTB)
      IF (.NOT.(ISTC.NE.0)) GO TO 10038
      ISTC=NINDX1(ICHS(39),ISTA,ISTC+1,ISTB)
      GO TO 10039
10038 CONTINUE
      ISTC=ISTB
10039 CONTINUE
      RETURN
10027 CONTINUE
      IF (.NOT.(ICUB.NE.0.AND.ITYP.EQ.ICHS(7).AND.(ISTA(6).EQ.ICHS(39).O
     +R.ISTA(6).EQ.ICHS(28)).AND.ISTA(7).EQ.ICHS(39))) GO TO 10040
      I=NINDX1(ICHS(39),ISTA,7,ISTB)
      CALL XMIT(ISTB-I+1,ISTA(I),ISTA(7))
      ISTB=ISTB-I+7
      ISTF=1
10040 CONTINUE
      RETURN
      END
      SUBROUTINE GOTOCD(N)
      COMMON /IFTCM1/ DBLS,DSOK,IBIT,ICRB,ICRI,ICRJ,ICRK,ICRL,ICUB,IFIN,
     +                IFOC,IFOF,IFOI,IFON,IFOS,IFVA(16),IFVI,IGND,
     +          IGNI,IGNN,IINP,INCL,INCP,INCU,IOCC,IOCP,IOTC,IOTX,
     +          IOUT,IPOC,IPOF,IPOI,IPON,IPOS,ISAV,ISGT,ISRA,ISRL,
     +          ISRM,ISRP(1023),ISRS,ISRT,ISRX,ISTB,ISTC,ISTD,
     +      ISTE,ISTF,ISTK(96),ISTL,ISTS,ISUM,ISVI,ISVN,
     +ITYQ,IUAF,IUCF,KWOK,LNCD,NABT,NAMI(500),NAMP,                NAMQ,
     +NAMR,NCLI,NCLO,NCTO,NDNT,NERR,NEST,NLNE,NLNX,                NPGE
      COMMON /IFTCM2/ IADE(26),IBUF(80),ICHS(50),ICNC,ICRD(1701),
     +            IEVS,IEVT,IHDR(115),ILCA(26),INSB(81),
     +            ISRC(6000),ISTA(1327),ITBC,ITYP,IUSB(81),
     +    IXCC,NAMC(1000),PTYP
      CHARACTER*1     IADE,IBUF,ICHS,ICNC,ICRD,IEVS,IEVT,IHDR,ILCA,INSB,
     +                ISRC,ISTA,ITBC,ITYP,IUSB,IXCC,NAMC,PTYP
      LOGICAL         DBLS,DSOK,IOCC,ISRA,ISRX,KWOK
      CHARACTER*1 IGOT(12)
      DATA IGOT / 6*' ','G','O',' ','T','O',' ' /
      IF (.NOT.(ISGT.EQ.0)) GO TO 10001
      CALL XMIT(12,IGOT,IBUF)
      CALL CVD(N,IBUF(13),5)
      CALL XMIT(-55,ICHS(39),IBUF(18))
      CALL OUTBUF
      ISGT=1
10001 CONTINUE
      RETURN
      END
      SUBROUTINE IFNOT(ISTR,I0,I1,N)
      CHARACTER*1 ISTR(1)
      COMMON /IFTCM1/ DBLS,DSOK,IBIT,ICRB,ICRI,ICRJ,ICRK,ICRL,ICUB,IFIN,
     +                IFOC,IFOF,IFOI,IFON,IFOS,IFVA(16),IFVI,IGND,
     +          IGNI,IGNN,IINP,INCL,INCP,INCU,IOCC,IOCP,IOTC,IOTX,
     +          IOUT,IPOC,IPOF,IPOI,IPON,IPOS,ISAV,ISGT,ISRA,ISRL,
     +          ISRM,ISRP(1023),ISRS,ISRT,ISRX,ISTB,ISTC,ISTD,
     +      ISTE,ISTF,ISTK(96),ISTL,ISTS,ISUM,ISVI,ISVN,
     +ITYQ,IUAF,IUCF,KWOK,LNCD,NABT,NAMI(500),NAMP,                NAMQ,
     +NAMR,NCLI,NCLO,NCTO,NDNT,NERR,NEST,NLNE,NLNX,                NPGE
      COMMON /IFTCM2/ IADE(26),IBUF(80),ICHS(50),ICNC,ICRD(1701),
     +            IEVS,IEVT,IHDR(115),ILCA(26),INSB(81),
     +            ISRC(6000),ISTA(1327),ITBC,ITYP,IUSB(81),
     +    IXCC,NAMC(1000),PTYP
      CHARACTER*1     IADE,IBUF,ICHS,ICNC,ICRD,IEVS,IEVT,IHDR,ILCA,INSB,
     +                ISRC,ISTA,ITBC,ITYP,IUSB,IXCC,NAMC,PTYP
      LOGICAL         DBLS,DSOK,IOCC,ISRA,ISRX,KWOK
      CHARACTER*1 ISIF(15),ISGO(6)
      DATA ISIF / 6*' ' , 'I' , 'F' , ' ' , '(' , '.' , 'N' , 'O' ,
     +            'T' , '.' /
      DATA ISGO / 'G' , 'O' , ' ' , 'T' , 'O' , ' ' /
      CALL XMIT(15,ISIF,IBUF)
      J=15
      I=I0
10001 CONTINUE
      IF (.NOT.(I.LE.I1)) GO TO 10002
      IF (.NOT.(J.EQ.72)) GO TO 10003
      L10005=    1
      GO TO 10005
10004 CONTINUE
10003 CONTINUE
      K=MIN(I1-I+1,72-J)
      CALL XMIT(K,ISTR(I),IBUF(J+1))
      I=I+K
      J=J+K
      GO TO 10001
10002 CONTINUE
      IF (.NOT.(J.EQ.72)) GO TO 10006
      L10005=    2
      GO TO 10005
10007 CONTINUE
10006 CONTINUE
      J=J+1
      IBUF(J)=ICHS(45)
      IF (.NOT.(J.NE.72)) GO TO 10008
      J=J+1
      IBUF(J)=ICHS(39)
10008 CONTINUE
      IF (.NOT.(J.GT.61)) GO TO 10009
      L10005=    3
      GO TO 10005
10010 CONTINUE
10009 CONTINUE
      CALL XMIT(6,ISGO,IBUF(J+1))
      CALL CVD(N,IBUF(J+7),5)
      J=J+11
      L10005=    4
      GO TO 10005
10011 CONTINUE
      RETURN
10005 CONTINUE
      CALL XMIT(J-72,ICHS(39),IBUF(J+1))
      CALL OUTBUF
      IBUF(6)=ICHS(40)
      J=6
      GO TO (10004,10007,10010,10011) , L10005
      END
      SUBROUTINE IFSTAT
      COMMON /IFTCM1/ DBLS,DSOK,IBIT,ICRB,ICRI,ICRJ,ICRK,ICRL,ICUB,IFIN,
     +                IFOC,IFOF,IFOI,IFON,IFOS,IFVA(16),IFVI,IGND,
     +          IGNI,IGNN,IINP,INCL,INCP,INCU,IOCC,IOCP,IOTC,IOTX,
     +          IOUT,IPOC,IPOF,IPOI,IPON,IPOS,ISAV,ISGT,ISRA,ISRL,
     +          ISRM,ISRP(1023),ISRS,ISRT,ISRX,ISTB,ISTC,ISTD,
     +      ISTE,ISTF,ISTK(96),ISTL,ISTS,ISUM,ISVI,ISVN,
     +ITYQ,IUAF,IUCF,KWOK,LNCD,NABT,NAMI(500),NAMP,                NAMQ,
     +NAMR,NCLI,NCLO,NCTO,NDNT,NERR,NEST,NLNE,NLNX,                NPGE
      COMMON /IFTCM2/ IADE(26),IBUF(80),ICHS(50),ICNC,ICRD(1701),
     +            IEVS,IEVT,IHDR(115),ILCA(26),INSB(81),
     +            ISRC(6000),ISTA(1327),ITBC,ITYP,IUSB(81),
     +    IXCC,NAMC(1000),PTYP
      CHARACTER*1     IADE,IBUF,ICHS,ICNC,ICRD,IEVS,IEVT,IHDR,ILCA,INSB,
     +                ISRC,ISTA,ITBC,ITYP,IUSB,IXCC,NAMC,PTYP
      LOGICAL         DBLS,DSOK,IOCC,ISRA,ISRX,KWOK
      CHARACTER*1 IIFS(3),ITHN(5)
      DATA IIFS / 'I','F',' ' /
      DATA ITHN / ' ','T','H','E','N' /
      IF (.NOT.(IBIT.EQ.0)) GO TO 10001
      CALL CRDOUT
      CALL LABOUT
      CALL NEWNUM(N2)
      CALL STAK(1,0,N2)
      CALL IFNOT(ISTA,ISTD,ISTE,N2)
      NEST=NEST+1
      GO TO 10002
10001 CONTINUE
      ISTB=ISTE-ISTD+16
      IF (.NOT.(ISTB.LE.1327)) GO TO 10003
      CALL XMIT(3,IIFS,ISTA(7))
      CALL XMIT(ISTE-ISTD+1,ISTA(ISTD),ISTA(10))
      CALL XMIT(5,ITHN,ISTA(ISTB-5))
      ISTA(ISTB)=ICHS(50)
      GO TO 10004
10003 CONTINUE
      CALL ERRM(32)
      CALL NGEXIT(NERR)
      STOP
10004 CONTINUE
      CALL STAK(1,0,0)
      ITYP=ICHS( 7)
      CALL CRDOUT
      NEST=NEST+1
      ISGT=0
10002 CONTINUE
      RETURN
      END
      SUBROUTINE IFTRIO (IKEY,IUNT,ITXT,LNTH,IEOF)
      CHARACTER*1 ITXT(*)
      COMMON /IFTCM1/ DBLS,DSOK,IBIT,ICRB,ICRI,ICRJ,ICRK,ICRL,ICUB,IFIN,
     +                IFOC,IFOF,IFOI,IFON,IFOS,IFVA(16),IFVI,IGND,
     +          IGNI,IGNN,IINP,INCL,INCP,INCU,IOCC,IOCP,IOTC,IOTX,
     +          IOUT,IPOC,IPOF,IPOI,IPON,IPOS,ISAV,ISGT,ISRA,ISRL,
     +          ISRM,ISRP(1023),ISRS,ISRT,ISRX,ISTB,ISTC,ISTD,
     +      ISTE,ISTF,ISTK(96),ISTL,ISTS,ISUM,ISVI,ISVN,
     +ITYQ,IUAF,IUCF,KWOK,LNCD,NABT,NAMI(500),NAMP,                NAMQ,
     +NAMR,NCLI,NCLO,NCTO,NDNT,NERR,NEST,NLNE,NLNX,                NPGE
      COMMON /IFTCM2/ IADE(26),IBUF(80),ICHS(50),ICNC,ICRD(1701),
     +            IEVS,IEVT,IHDR(115),ILCA(26),INSB(81),
     +            ISRC(6000),ISTA(1327),ITBC,ITYP,IUSB(81),
     +    IXCC,NAMC(1000),PTYP
      CHARACTER*1     IADE,IBUF,ICHS,ICNC,ICRD,IEVS,IEVT,IHDR,ILCA,INSB,
     +                ISRC,ISTA,ITBC,ITYP,IUSB,IXCC,NAMC,PTYP
      LOGICAL         DBLS,DSOK,IOCC,ISRA,ISRX,KWOK
      COMMON /IFTCM3/ IU1B(512),IU2B(512),CRC1,CRC2,SFUN,TBCH
      CHARACTER*1     IU1B,IU2B,CRC1,CRC2,TBCH
      CHARACTER*17    SFUN
      COMMON /IFTCM4/ IU1P,IU1Q,IU2P,IU2Q
      IF (.NOT.(IKEY.EQ.1)) GO TO 10001
      IF (.NOT.(IUNT.EQ.IINP)) GO TO 10002
      ITBF=0
      DO 10003 I=1,32767
      IF (.NOT.(ITBF.LE.0)) GO TO 10004
      IF (.NOT.(IU1P.GE.IU1Q)) GO TO 10005
      CALL NGRDCH (IUNT,IU1B,512,IU1R)
      IF (.NOT.(IU1R.LE.0)) GO TO 10006
      IEOF=1
      RETURN
10006 CONTINUE
      IU1P=0
      IU1Q=IU1R
10005 CONTINUE
      IU1P=IU1P+1
      IF (.NOT.(IU1B(IU1P).EQ.CRC1.OR.IU1B(IU1P).EQ.CRC2)) GO TO 10007
      IF (I.LE.LNTH) CALL XMIT(I-LNTH-1,ICHS(39),ITXT(I))
      IEOF=0
      IF ( ITXT(1).EQ.'.'.AND.
     +    (ITXT(2).EQ.'F'.OR.ITXT(2).EQ.'f').AND.
     +    (ITXT(3).EQ.'I'.OR.ITXT(3).EQ.'i')) IEOF=1
      RETURN
10007 CONTINUE
      IF (.NOT.(IU1B(IU1P).EQ.TBCH)) GO TO 10008
      IF (I.LE.LNTH) ITXT(I)=' '
      ITBF=8*((I-1)/8+1)-I
      GO TO 10009
10008 CONTINUE
      IF (I.LE.LNTH) ITXT(I)=IU1B(IU1P)
10009 CONTINUE
      GO TO 10010
10004 CONTINUE
      IF (I.LE.LNTH) ITXT(I)=' '
      ITBF=ITBF-1
10010 CONTINUE
10003 CONTINUE
      GO TO 10011
10002 CONTINUE
      IF (.NOT.(IUNT.EQ.INCU)) GO TO 10012
      ITBF=0
      DO 10013 I=1,32767
      IF (.NOT.(ITBF.LE.0)) GO TO 10014
      IF (.NOT.(IU2P.GE.IU2Q)) GO TO 10015
      CALL NGRDCH (IUNT,IU2B,512,IU2R)
      IF (.NOT.(IU2R.LE.0)) GO TO 10016
      IEOF=1
      RETURN
10016 CONTINUE
      IU2P=0
      IU2Q=IU2R
10015 CONTINUE
      IU2P=IU2P+1
      IF (.NOT.(IU2B(IU2P).EQ.CRC1.OR.IU2B(IU2P).EQ.CRC2)) GO TO 10017
      IF (I.LE.LNTH) CALL XMIT(I-LNTH-1,ICHS(39),ITXT(I))
      IEOF=0
      IF (ITXT(1).EQ.'.'.AND.
     +    (ITXT(2).EQ.'F'.OR.ITXT(2).EQ.'f').AND.
     +    (ITXT(3).EQ.'I'.OR.ITXT(3).EQ.'i')) IEOF=1
      RETURN
10017 CONTINUE
      IF (.NOT.(IU2B(IU2P).EQ.TBCH)) GO TO 10018
      IF (I.LE.LNTH) ITXT(I)=' '
      ITBF=8*((I-1)/8+1)-I
      GO TO 10019
10018 CONTINUE
      IF (I.LE.LNTH) ITXT(I)=IU2B(IU2P)
10019 CONTINUE
      GO TO 10020
10014 CONTINUE
      IF (I.LE.LNTH) ITXT(I)=' '
      ITBF=ITBF-1
10020 CONTINUE
10013 CONTINUE
      GO TO 10011
10012 CONTINUE
      CALL NGRDCH (IUNT,ITXT,LNTH,LNRD)
      IF (.NOT.(LNRD.EQ.LNTH)) GO TO 10021
      IEOF=0
      GO TO 10022
10021 CONTINUE
      IEOF=1
10022 CONTINUE
10011 CONTINUE
      GO TO 10023
10001 CONTINUE
      IF (.NOT.(IKEY.EQ.2)) GO TO 10024
      IF (.NOT.(IUNT.EQ.ISAV)) GO TO 10025
      CALL NGWRCH (IUNT,ITXT,LNTH,LNWR)
      GO TO 10026
10025 CONTINUE
      ITMP=LSTNB(ITXT,1,LNTH)
      CALL NGWRCH (IUNT,ITXT,ITMP,LNWR)
      CALL NGWRCH (IUNT,CRC1,   1,LNWR)
10026 CONTINUE
      GO TO 10023
10024 CONTINUE
      IF (.NOT.(IKEY.EQ.3)) GO TO 10027
      IF (.NOT.(IUNT.EQ.ISAV)) GO TO 10028
      CALL NGCLFI (ISAV)
      CALL NGOFRW (SFUN,ISAV,ITMP)
      IF (ITMP.NE.0) ISAV=0
10028 CONTINUE
10023 CONTINUE
10027 CONTINUE
      RETURN
      END
      SUBROUTINE IFTRUE(ISTR,I0,I1,N)
      CHARACTER*1 ISTR(1)
      COMMON /IFTCM1/ DBLS,DSOK,IBIT,ICRB,ICRI,ICRJ,ICRK,ICRL,ICUB,IFIN,
     +                IFOC,IFOF,IFOI,IFON,IFOS,IFVA(16),IFVI,IGND,
     +          IGNI,IGNN,IINP,INCL,INCP,INCU,IOCC,IOCP,IOTC,IOTX,
     +          IOUT,IPOC,IPOF,IPOI,IPON,IPOS,ISAV,ISGT,ISRA,ISRL,
     +          ISRM,ISRP(1023),ISRS,ISRT,ISRX,ISTB,ISTC,ISTD,
     +      ISTE,ISTF,ISTK(96),ISTL,ISTS,ISUM,ISVI,ISVN,
     +ITYQ,IUAF,IUCF,KWOK,LNCD,NABT,NAMI(500),NAMP,                NAMQ,
     +NAMR,NCLI,NCLO,NCTO,NDNT,NERR,NEST,NLNE,NLNX,                NPGE
      COMMON /IFTCM2/ IADE(26),IBUF(80),ICHS(50),ICNC,ICRD(1701),
     +            IEVS,IEVT,IHDR(115),ILCA(26),INSB(81),
     +            ISRC(6000),ISTA(1327),ITBC,ITYP,IUSB(81),
     +    IXCC,NAMC(1000),PTYP
      CHARACTER*1     IADE,IBUF,ICHS,ICNC,ICRD,IEVS,IEVT,IHDR,ILCA,INSB,
     +                ISRC,ISTA,ITBC,ITYP,IUSB,IXCC,NAMC,PTYP
      LOGICAL         DBLS,DSOK,IOCC,ISRA,ISRX,KWOK
      CHARACTER*1 ISIF(10),ISGO(6)
      DATA ISIF / 6*' ' , 'I' , 'F' , ' ' , '(' /
      DATA ISGO / 'G' , 'O' , ' ' , 'T' , 'O' , ' ' /
      CALL XMIT(10,ISIF,IBUF)
      J=10
      I=I0
10001 CONTINUE
      IF (.NOT.(I.LE.I1)) GO TO 10002
      IF (.NOT.(J.EQ.72)) GO TO 10003
      L10005=    1
      GO TO 10005
10004 CONTINUE
10003 CONTINUE
      K=MIN(I1-I+1,72-J)
      CALL XMIT(K,ISTR(I),IBUF(J+1))
      I=I+K
      J=J+K
      GO TO 10001
10002 CONTINUE
      IF (.NOT.(J.EQ.72)) GO TO 10006
      L10005=    2
      GO TO 10005
10007 CONTINUE
10006 CONTINUE
      J=J+1
      IBUF(J)=ICHS(45)
      IF (.NOT.(J.NE.72)) GO TO 10008
      J=J+1
      IBUF(J)=ICHS(39)
10008 CONTINUE
      IF (.NOT.(J.GT.61)) GO TO 10009
      L10005=    3
      GO TO 10005
10010 CONTINUE
10009 CONTINUE
      CALL XMIT(6,ISGO,IBUF(J+1))
      CALL CVD(N,IBUF(J+7),5)
      J=J+11
      L10005=    4
      GO TO 10005
10011 CONTINUE
      RETURN
10005 CONTINUE
      CALL XMIT(J-72,ICHS(39),IBUF(J+1))
      CALL OUTBUF
      IBUF(6)=ICHS(40)
      J=6
      GO TO (10004,10007,10010,10011) , L10005
      END
      SUBROUTINE INCLPM(NUNT,LENC,IREW)
      COMMON /IFTCM1/ DBLS,DSOK,IBIT,ICRB,ICRI,ICRJ,ICRK,ICRL,ICUB,IFIN,
     +                IFOC,IFOF,IFOI,IFON,IFOS,IFVA(16),IFVI,IGND,
     +          IGNI,IGNN,IINP,INCL,INCP,INCU,IOCC,IOCP,IOTC,IOTX,
     +          IOUT,IPOC,IPOF,IPOI,IPON,IPOS,ISAV,ISGT,ISRA,ISRL,
     +          ISRM,ISRP(1023),ISRS,ISRT,ISRX,ISTB,ISTC,ISTD,
     +      ISTE,ISTF,ISTK(96),ISTL,ISTS,ISUM,ISVI,ISVN,
     +ITYQ,IUAF,IUCF,KWOK,LNCD,NABT,NAMI(500),NAMP,                NAMQ,
     +NAMR,NCLI,NCLO,NCTO,NDNT,NERR,NEST,NLNE,NLNX,                NPGE
      COMMON /IFTCM2/ IADE(26),IBUF(80),ICHS(50),ICNC,ICRD(1701),
     +            IEVS,IEVT,IHDR(115),ILCA(26),INSB(81),
     +            ISRC(6000),ISTA(1327),ITBC,ITYP,IUSB(81),
     +    IXCC,NAMC(1000),PTYP
      CHARACTER*1     IADE,IBUF,ICHS,ICNC,ICRD,IEVS,IEVT,IHDR,ILCA,INSB,
     +                ISRC,ISTA,ITBC,ITYP,IUSB,IXCC,NAMC,PTYP
      LOGICAL         DBLS,DSOK,IOCC,ISRA,ISRX,KWOK
      CHARACTER*80 CFNM
      IF (.NOT.(ISTC.LT.ISTB)) GO TO 10001
      J=0
      DO 10002 I=ISTC,ISTB-1
      J=J+1
      IF (J.LT.80) CFNM(J:J)=ISTA(I)
10002 CONTINUE
      CFNM(J+1:J+1)=ICHS(50)
      CALL NGOFRO (CFNM,NUNT,ITMP)
      IU2P=0
      IU2Q=0
      LENC=80
      IREW=0
      GO TO 10003
10001 CONTINUE
      NUNT=0
10003 CONTINUE
      RETURN
      END
      FUNCTION INDEX1(ICHR,ISTR,L0,L1)
      CHARACTER*1 ICHR,ISTR(1)
      IF (.NOT.(L0.LE.L1)) GO TO 10001
      DO 10002 L=L0,L1
      IF (ICHR.EQ.ISTR(L)) GO TO 101
10002 CONTINUE
10001 CONTINUE
      L=0
  101 INDEX1=L
      RETURN
      END
      SUBROUTINE INVOKE
      COMMON /IFTCM1/ DBLS,DSOK,IBIT,ICRB,ICRI,ICRJ,ICRK,ICRL,ICUB,IFIN,
     +                IFOC,IFOF,IFOI,IFON,IFOS,IFVA(16),IFVI,IGND,
     +          IGNI,IGNN,IINP,INCL,INCP,INCU,IOCC,IOCP,IOTC,IOTX,
     +          IOUT,IPOC,IPOF,IPOI,IPON,IPOS,ISAV,ISGT,ISRA,ISRL,
     +          ISRM,ISRP(1023),ISRS,ISRT,ISRX,ISTB,ISTC,ISTD,
     +      ISTE,ISTF,ISTK(96),ISTL,ISTS,ISUM,ISVI,ISVN,
     +ITYQ,IUAF,IUCF,KWOK,LNCD,NABT,NAMI(500),NAMP,                NAMQ,
     +NAMR,NCLI,NCLO,NCTO,NDNT,NERR,NEST,NLNE,NLNX,                NPGE
      COMMON /IFTCM2/ IADE(26),IBUF(80),ICHS(50),ICNC,ICRD(1701),
     +            IEVS,IEVT,IHDR(115),ILCA(26),INSB(81),
     +            ISRC(6000),ISTA(1327),ITBC,ITYP,IUSB(81),
     +    IXCC,NAMC(1000),PTYP
      CHARACTER*1     IADE,IBUF,ICHS,ICNC,ICRD,IEVS,IEVT,IHDR,ILCA,INSB,
     +                ISRC,ISTA,ITBC,ITYP,IUSB,IXCC,NAMC,PTYP
      LOGICAL         DBLS,DSOK,IOCC,ISRA,ISRX,KWOK
      CALL NEWNUM(IR)
      NR=IR
      CALL NAMBLO(N1,NR)
      CALL CRDOUT
      CALL LABOUT
      IF (.NOT.(N1.GT.0)) GO TO 10001
      N3=ABS(NAMI(N1))
      IF (.NOT.(NAMI(N1+3).GE.0)) GO TO 10002
      CALL OUTCHR(ICHS(13))
      CALL OUTNUM(N3)
      CALL OUTCHR(ICHS(46))
      CALL OUTNUM(NR)
      CALL OUTLIN(0)
      CALL GOTOCD(N3)
      CALL CONTCD(IR)
      GO TO 10003
10002 CONTINUE
      CALL GOTOCD(N3)
10003 CONTINUE
10001 CONTINUE
      RETURN
      END
      SUBROUTINE LABOUT
      COMMON /IFTCM1/ DBLS,DSOK,IBIT,ICRB,ICRI,ICRJ,ICRK,ICRL,ICUB,IFIN,
     +                IFOC,IFOF,IFOI,IFON,IFOS,IFVA(16),IFVI,IGND,
     +          IGNI,IGNN,IINP,INCL,INCP,INCU,IOCC,IOCP,IOTC,IOTX,
     +          IOUT,IPOC,IPOF,IPOI,IPON,IPOS,ISAV,ISGT,ISRA,ISRL,
     +          ISRM,ISRP(1023),ISRS,ISRT,ISRX,ISTB,ISTC,ISTD,
     +      ISTE,ISTF,ISTK(96),ISTL,ISTS,ISUM,ISVI,ISVN,
     +ITYQ,IUAF,IUCF,KWOK,LNCD,NABT,NAMI(500),NAMP,                NAMQ,
     +NAMR,NCLI,NCLO,NCTO,NDNT,NERR,NEST,NLNE,NLNX,                NPGE
      COMMON /IFTCM2/ IADE(26),IBUF(80),ICHS(50),ICNC,ICRD(1701),
     +            IEVS,IEVT,IHDR(115),ILCA(26),INSB(81),
     +            ISRC(6000),ISTA(1327),ITBC,ITYP,IUSB(81),
     +    IXCC,NAMC(1000),PTYP
      CHARACTER*1     IADE,IBUF,ICHS,ICNC,ICRD,IEVS,IEVT,IHDR,ILCA,INSB,
     +                ISRC,ISTA,ITBC,ITYP,IUSB,IXCC,NAMC,PTYP
      LOGICAL         DBLS,DSOK,IOCC,ISRA,ISRX,KWOK
      CHARACTER*1 ICNT(9)
      DATA ICNT / ' ' , 'C' , 'O' , 'N' , 'T' , 'I' , 'N' , 'U' , 'E' /
      DO 10001 I=1,5
      IF (ISTA(I).NE.ICHS(39)) GO TO 101
10001 CONTINUE
      RETURN
  101 CALL XMIT(5,ISTA,IBUF)
      CALL XMIT(9,ICNT,IBUF(6))
      CALL XMIT(-66,ICHS(39),IBUF(15))
      CALL OUTBUF
      ISGT=0
      RETURN
      END
      SUBROUTINE LOOPST
      COMMON /IFTCM1/ DBLS,DSOK,IBIT,ICRB,ICRI,ICRJ,ICRK,ICRL,ICUB,IFIN,
     +                IFOC,IFOF,IFOI,IFON,IFOS,IFVA(16),IFVI,IGND,
     +          IGNI,IGNN,IINP,INCL,INCP,INCU,IOCC,IOCP,IOTC,IOTX,
     +          IOUT,IPOC,IPOF,IPOI,IPON,IPOS,ISAV,ISGT,ISRA,ISRL,
     +          ISRM,ISRP(1023),ISRS,ISRT,ISRX,ISTB,ISTC,ISTD,
     +      ISTE,ISTF,ISTK(96),ISTL,ISTS,ISUM,ISVI,ISVN,
     +ITYQ,IUAF,IUCF,KWOK,LNCD,NABT,NAMI(500),NAMP,                NAMQ,
     +NAMR,NCLI,NCLO,NCTO,NDNT,NERR,NEST,NLNE,NLNX,                NPGE
      COMMON /IFTCM2/ IADE(26),IBUF(80),ICHS(50),ICNC,ICRD(1701),
     +            IEVS,IEVT,IHDR(115),ILCA(26),INSB(81),
     +            ISRC(6000),ISTA(1327),ITBC,ITYP,IUSB(81),
     +    IXCC,NAMC(1000),PTYP
      CHARACTER*1     IADE,IBUF,ICHS,ICNC,ICRD,IEVS,IEVT,IHDR,ILCA,INSB,
     +                ISRC,ISTA,ITBC,ITYP,IUSB,IXCC,NAMC,PTYP
      LOGICAL         DBLS,DSOK,IOCC,ISRA,ISRX,KWOK
      CALL CRDOUT
      CALL LABOUT
      CALL NEWNUM(N1)
      CALL STAK(6,N1,0)
      CALL CONTCD(N1)
      NEST=NEST+1
      RETURN
      END
      FUNCTION LSTNB(ISTR,L0,L1)
      CHARACTER*1 ISTR(1)
      COMMON /IFTCM1/ DBLS,DSOK,IBIT,ICRB,ICRI,ICRJ,ICRK,ICRL,ICUB,IFIN,
     +                IFOC,IFOF,IFOI,IFON,IFOS,IFVA(16),IFVI,IGND,
     +          IGNI,IGNN,IINP,INCL,INCP,INCU,IOCC,IOCP,IOTC,IOTX,
     +          IOUT,IPOC,IPOF,IPOI,IPON,IPOS,ISAV,ISGT,ISRA,ISRL,
     +          ISRM,ISRP(1023),ISRS,ISRT,ISRX,ISTB,ISTC,ISTD,
     +      ISTE,ISTF,ISTK(96),ISTL,ISTS,ISUM,ISVI,ISVN,
     +ITYQ,IUAF,IUCF,KWOK,LNCD,NABT,NAMI(500),NAMP,                NAMQ,
     +NAMR,NCLI,NCLO,NCTO,NDNT,NERR,NEST,NLNE,NLNX,                NPGE
      COMMON /IFTCM2/ IADE(26),IBUF(80),ICHS(50),ICNC,ICRD(1701),
     +            IEVS,IEVT,IHDR(115),ILCA(26),INSB(81),
     +            ISRC(6000),ISTA(1327),ITBC,ITYP,IUSB(81),
     +    IXCC,NAMC(1000),PTYP
      CHARACTER*1     IADE,IBUF,ICHS,ICNC,ICRD,IEVS,IEVT,IHDR,ILCA,INSB,
     +                ISRC,ISTA,ITBC,ITYP,IUSB,IXCC,NAMC,PTYP
      LOGICAL         DBLS,DSOK,IOCC,ISRA,ISRX,KWOK
      LSTNB=L1
10001 CONTINUE
      IF (.NOT.(LSTNB.GT.L0)) GO TO 10002
      IF (ISTR(LSTNB).NE.ICHS(39)) RETURN
      LSTNB=LSTNB-1
      GO TO 10001
10002 CONTINUE
      RETURN
      END
      SUBROUTINE MULREP(ISTX)
      COMMON /IFTCM1/ DBLS,DSOK,IBIT,ICRB,ICRI,ICRJ,ICRK,ICRL,ICUB,IFIN,
     +                IFOC,IFOF,IFOI,IFON,IFOS,IFVA(16),IFVI,IGND,
     +          IGNI,IGNN,IINP,INCL,INCP,INCU,IOCC,IOCP,IOTC,IOTX,
     +          IOUT,IPOC,IPOF,IPOI,IPON,IPOS,ISAV,ISGT,ISRA,ISRL,
     +          ISRM,ISRP(1023),ISRS,ISRT,ISRX,ISTB,ISTC,ISTD,
     +      ISTE,ISTF,ISTK(96),ISTL,ISTS,ISUM,ISVI,ISVN,
     +ITYQ,IUAF,IUCF,KWOK,LNCD,NABT,NAMI(500),NAMP,                NAMQ,
     +NAMR,NCLI,NCLO,NCTO,NDNT,NERR,NEST,NLNE,NLNX,                NPGE
      COMMON /IFTCM2/ IADE(26),IBUF(80),ICHS(50),ICNC,ICRD(1701),
     +            IEVS,IEVT,IHDR(115),ILCA(26),INSB(81),
     +            ISRC(6000),ISTA(1327),ITBC,ITYP,IUSB(81),
     +    IXCC,NAMC(1000),PTYP
      CHARACTER*1     IADE,IBUF,ICHS,ICNC,ICRD,IEVS,IEVT,IHDR,ILCA,INSB,
     +                ISRC,ISTA,ITBC,ITYP,IUSB,IXCC,NAMC,PTYP
      LOGICAL         DBLS,DSOK,IOCC,ISRA,ISRX,KWOK
      CHARACTER*1 ICH
      I1=NINDX1(ICHS(39),ISTA,ISTX,ISTB-1)
      IF (I1.EQ.0) RETURN
10001 CONTINUE
      ICH=ISTA(I1)
      I2=INDEX1(ICH,ISTA,I1+1,ISTB-1)
      IF (.NOT.(I2.LE.I1+1)) GO TO 10002
      CALL ERRM(11)
      RETURN
10002 CONTINUE
      I3=INDEX1(ICH,ISTA,I2+1,ISTB-1)
      IF (.NOT.(I3.EQ.0)) GO TO 10003
      CALL ERRM(11)
      RETURN
10003 CONTINUE
      IF (.NOT.(ISRA)) GO TO 10004
      J3=I3-1
      IF (I2.LT.J3) CALL REPL2(ISTA,1327,ISTB,I2+1,J3,ISTF)
      I3=J3+1
10004 CONTINUE
      CALL REPL1(ISTA(I1+1),I2-I1-1,ISTA(I2+1),I3-I2-1)
      I=NINDX1(ICHS(39),ISTA,I3+1,ISTB-1)
      IF (I.LE.0) RETURN
      IF (.NOT.(ISTA(I).NE.ICHS(38))) GO TO 10005
      CALL ERRM(11)
      RETURN
10005 CONTINUE
      I1=NINDX1(ICHS(39),ISTA,I+1,ISTB-1)
      IF (.NOT.(I1.EQ.0)) GO TO 10006
      CALL ERRM(11)
      RETURN
10006 CONTINUE
      GO TO 10001
      END
      SUBROUTINE NAMBLO(NUMB,IREF)
      COMMON /IFTCM1/ DBLS,DSOK,IBIT,ICRB,ICRI,ICRJ,ICRK,ICRL,ICUB,IFIN,
     +                IFOC,IFOF,IFOI,IFON,IFOS,IFVA(16),IFVI,IGND,
     +          IGNI,IGNN,IINP,INCL,INCP,INCU,IOCC,IOCP,IOTC,IOTX,
     +          IOUT,IPOC,IPOF,IPOI,IPON,IPOS,ISAV,ISGT,ISRA,ISRL,
     +          ISRM,ISRP(1023),ISRS,ISRT,ISRX,ISTB,ISTC,ISTD,
     +      ISTE,ISTF,ISTK(96),ISTL,ISTS,ISUM,ISVI,ISVN,
     +ITYQ,IUAF,IUCF,KWOK,LNCD,NABT,NAMI(500),NAMP,                NAMQ,
     +NAMR,NCLI,NCLO,NCTO,NDNT,NERR,NEST,NLNE,NLNX,                NPGE
      COMMON /IFTCM2/ IADE(26),IBUF(80),ICHS(50),ICNC,ICRD(1701),
     +            IEVS,IEVT,IHDR(115),ILCA(26),INSB(81),
     +            ISRC(6000),ISTA(1327),ITBC,ITYP,IUSB(81),
     +    IXCC,NAMC(1000),PTYP
      CHARACTER*1     IADE,IBUF,ICHS,ICNC,ICRD,IEVS,IEVT,IHDR,ILCA,INSB,
     +                ISRC,ISTA,ITBC,ITYP,IUSB,IXCC,NAMC,PTYP
      LOGICAL         DBLS,DSOK,IOCC,ISRA,ISRX,KWOK
      J=ISTD-1
      DO 10001 I=ISTD,ISTE
      IF (.NOT.(ISTA(I).NE.ICHS(44).AND.ISTA(I).NE.ICHS(39).AND.ISTA(I).
     +NE.ICHS(45))) GO TO 10002
      J=J+1
      ISTA(J)=ISTA(I)
10002 CONTINUE
10001 CONTINUE
      ISTE=J
      IF (.NOT.(ISTE.LT.ISTD)) GO TO 10003
      CALL ERRM(26)
      NUMB=0
      RETURN
10003 CONTINUE
      NUMB=1
10004 CONTINUE
      IF (.NOT.(NUMB.LT.NAMP)) GO TO 10005
      IF (.NOT.(NAMI(NUMB+2).EQ.ISTE-ISTD+1)) GO TO 10006
      I=NAMI(NUMB+1)
      IF (.NOT.(NOTEQ(NAMC(I),ISTA(ISTD),NAMI(NUMB+2)).EQ.0))
     +GO TO 10007
      IF (.NOT.(NAMI(NUMB).LT.0)) GO TO 10008
      IF (.NOT.(IREF.NE.0)) GO TO 10009
      CALL ERRM(34)
      GO TO 10010
10009 CONTINUE
      CALL ERRM(36)
10010 CONTINUE
10008 CONTINUE
      GO TO 101
10007 CONTINUE
10006 CONTINUE
      NUMB=NUMB+4
      GO TO 10004
10005 CONTINUE
      IF (.NOT.(NUMB+4.GT.NAMQ)) GO TO 10011
      CALL ERRM(25)
      NUMB=0
      RETURN
10011 CONTINUE
      IF (.NOT.(NAMR+ISTE-ISTD+1.GT.1000)) GO TO 10012
      CALL ERRM(31)
      NUMB=0
      RETURN
10012 CONTINUE
      CALL NEWNUM(NAMI(NUMB))
      NAMI(NUMB+1)=NAMR+1
      NAMI(NUMB+2)=ISTE-ISTD+1
      NAMI(NUMB+3)=0
      IF ( ISTA(ISTE-2).EQ.ICHS(38).AND.
     +         (ISTA(ISTE-1).EQ.ICHS(15).OR.ISTA(ISTE-1).EQ.ILCA(14)).AN
     +D.                 (ISTA(ISTE  ).EQ.ICHS(19).OR.ISTA(ISTE  ).EQ.IL
     +CA(18)) )
     +        NAMI(NUMB+3)=-1
      NAMP=NAMP+4
      CALL XMIT (ISTE-ISTD+1,ISTA(ISTD),NAMC(NAMR+1))
      NAMR=NAMR+ISTE-ISTD+1
  101 CONTINUE
      IF (.NOT.(IREF.NE.0)) GO TO 10013
      IF (.NOT.(NAMQ-2.LT.NAMP)) GO TO 10014
      CALL ERRM(25)
      RETURN
10014 CONTINUE
      IF (.NOT.(NAMI(NUMB+3).GE.0)) GO TO 10015
      ITMP=NUMB+2
      JTMP=1
10016 CONTINUE
      IF (.NOT.(NAMI(ITMP+1).NE.0)) GO TO 10017
      ITMP=NAMI(ITMP+1)
      JTMP=JTMP+1
      GO TO 10016
10017 CONTINUE
      NAMQ=NAMQ-2
      NAMI(NAMQ+1)=IREF
      NAMI(NAMQ+2)=0
      NAMI(ITMP+1)=NAMQ+1
      IREF=JTMP
10015 CONTINUE
10013 CONTINUE
      RETURN
      END
      SUBROUTINE NEWNUM(NUMB)
      COMMON /IFTCM1/ DBLS,DSOK,IBIT,ICRB,ICRI,ICRJ,ICRK,ICRL,ICUB,IFIN,
     +                IFOC,IFOF,IFOI,IFON,IFOS,IFVA(16),IFVI,IGND,
     +          IGNI,IGNN,IINP,INCL,INCP,INCU,IOCC,IOCP,IOTC,IOTX,
     +          IOUT,IPOC,IPOF,IPOI,IPON,IPOS,ISAV,ISGT,ISRA,ISRL,
     +          ISRM,ISRP(1023),ISRS,ISRT,ISRX,ISTB,ISTC,ISTD,
     +      ISTE,ISTF,ISTK(96),ISTL,ISTS,ISUM,ISVI,ISVN,
     +ITYQ,IUAF,IUCF,KWOK,LNCD,NABT,NAMI(500),NAMP,                NAMQ,
     +NAMR,NCLI,NCLO,NCTO,NDNT,NERR,NEST,NLNE,NLNX,                NPGE
      COMMON /IFTCM2/ IADE(26),IBUF(80),ICHS(50),ICNC,ICRD(1701),
     +            IEVS,IEVT,IHDR(115),ILCA(26),INSB(81),
     +            ISRC(6000),ISTA(1327),ITBC,ITYP,IUSB(81),
     +    IXCC,NAMC(1000),PTYP
      CHARACTER*1     IADE,IBUF,ICHS,ICNC,ICRD,IEVS,IEVT,IHDR,ILCA,INSB,
     +                ISRC,ISTA,ITBC,ITYP,IUSB,IXCC,NAMC,PTYP
      LOGICAL         DBLS,DSOK,IOCC,ISRA,ISRX,KWOK
      NUMB=IGNN
      IGNN=IGNN+IGND
      RETURN
      END
      FUNCTION NINDX1(ICHR,ISTR,L0,L1)
      CHARACTER*1 ICHR,ISTR(1)
      IF (.NOT.(L0.LE.L1)) GO TO 10001
      DO 10002 L=L0,L1
      IF (ICHR.NE.ISTR(L)) GO TO 101
10002 CONTINUE
10001 CONTINUE
      L=0
  101 NINDX1=L
      RETURN
      END
      FUNCTION NOTEQ(IST1,IST2,N)
      CHARACTER*1 IST1(1),IST2(1)
      IF (.NOT.(N.GT.0)) GO TO 10001
      DO 10002 I=1,N
      IF (IST1(I).NE.IST2(I)) GO TO 101
10002 CONTINUE
10001 CONTINUE
      I=0
  101 NOTEQ=I
      RETURN
      END
      SUBROUTINE OUTBUF
      COMMON /IFTCM1/ DBLS,DSOK,IBIT,ICRB,ICRI,ICRJ,ICRK,ICRL,ICUB,IFIN,
     +                IFOC,IFOF,IFOI,IFON,IFOS,IFVA(16),IFVI,IGND,
     +          IGNI,IGNN,IINP,INCL,INCP,INCU,IOCC,IOCP,IOTC,IOTX,
     +          IOUT,IPOC,IPOF,IPOI,IPON,IPOS,ISAV,ISGT,ISRA,ISRL,
     +          ISRM,ISRP(1023),ISRS,ISRT,ISRX,ISTB,ISTC,ISTD,
     +      ISTE,ISTF,ISTK(96),ISTL,ISTS,ISUM,ISVI,ISVN,
     +ITYQ,IUAF,IUCF,KWOK,LNCD,NABT,NAMI(500),NAMP,                NAMQ,
     +NAMR,NCLI,NCLO,NCTO,NDNT,NERR,NEST,NLNE,NLNX,                NPGE
      COMMON /IFTCM2/ IADE(26),IBUF(80),ICHS(50),ICNC,ICRD(1701),
     +            IEVS,IEVT,IHDR(115),ILCA(26),INSB(81),
     +            ISRC(6000),ISTA(1327),ITBC,ITYP,IUSB(81),
     +    IXCC,NAMC(1000),PTYP
      CHARACTER*1     IADE,IBUF,ICHS,ICNC,ICRD,IEVS,IEVT,IHDR,ILCA,INSB,
     +                ISRC,ISTA,ITBC,ITYP,IUSB,IXCC,NAMC,PTYP
      LOGICAL         DBLS,DSOK,IOCC,ISRA,ISRX,KWOK
      CHARACTER*1 JBUF(80)
      SAVE NCJB
      DATA JBUF(1),JBUF(2),JBUF(3),JBUF(4),JBUF(5),JBUF(6) / 5*' ','+' /
      DATA NCJB / 0 /
      IF (IOTC.EQ.0) RETURN
      IF (.NOT.(IFON.EQ.1)) GO TO 10001
      CALL CVD(MAX(NEST,0),IBUF(73),3)
      CALL CVD(NCLO,IBUF(76),5)
      GO TO 10002
10001 CONTINUE
      IF (.NOT.(IFON.EQ.2)) GO TO 10003
      CALL XMIT(8,ICRD(ICRI+72),IBUF(73))
      GO TO 10002
10003 CONTINUE
      CALL XMIT(-8,ICHS(39),IBUF(73))
10002 CONTINUE
      MEST=MAX(0,MIN(66,NEST*IFIN))
      IF (.NOT.(IBUF(1).EQ.ICHS(4).OR.IBUF(1).EQ.ILCA(3))) GO TO 10004
      IF (.NOT.(NCJB.NE.0)) GO TO 10005
      DO 10006 I=7,6+NCJB
      IF (JBUF(I).NE.ICHS(39)) GO TO 101
10006 CONTINUE
      GO TO 102
  101 CALL IFTRIO (2,IOTC,JBUF,80,0)
  102 NCJB=0
10005 CONTINUE
      CALL IFTRIO (2,IOTC,IBUF,80,0)
      GO TO 10007
10004 CONTINUE
      IF (.NOT.(IBUF(6).NE.ICHS(40))) GO TO 10008
      IF (.NOT.(NCJB.NE.0)) GO TO 10009
      DO 10010 I=7,6+NCJB
      IF (JBUF(I).NE.ICHS(39)) GO TO 103
10010 CONTINUE
      GO TO 104
  103 CALL IFTRIO (2,IOTC,JBUF,80,0)
  104 NCJB=0
10009 CONTINUE
      IF (.NOT.(MEST.NE.0)) GO TO 10011
      CALL XMIT (MEST,IBUF(73-MEST),JBUF(7))
      CALL XMIT (MEST-66,ICHS(39),JBUF(7+MEST))
      CALL XMIT (8,IBUF(73),JBUF(73))
      NCJB=MEST
      I=72
10012 CONTINUE
      IF (.NOT.(I.GE.7+MEST)) GO TO 10013
      IBUF(I)=IBUF(I-MEST)
      I=I-1
      GO TO 10012
10013 CONTINUE
      CALL XMIT (-MEST,ICHS(39),IBUF(7))
10011 CONTINUE
      CALL IFTRIO (2,IOTC,IBUF,80,0)
      GO TO 10007
10008 CONTINUE
      IF (.NOT.(MEST.EQ.0)) GO TO 10014
      CALL IFTRIO (2,IOTC,IBUF,80,0)
      GO TO 10015
10014 CONTINUE
      CALL XMIT (66-NCJB,IBUF(7),JBUF(7+NCJB))
      CALL XMIT (8,IBUF(73),JBUF(73))
      CALL IFTRIO (2,IOTC,JBUF,80,0)
      CALL XMIT (NCJB,IBUF(73-NCJB),JBUF(7))
      CALL XMIT (NCJB-66,ICHS(39),JBUF(7+NCJB))
10015 CONTINUE
10007 CONTINUE
      RETURN
      END
      SUBROUTINE OUTCHR(ICHR)
      CHARACTER*1 ICHR
      COMMON /IFTCM1/ DBLS,DSOK,IBIT,ICRB,ICRI,ICRJ,ICRK,ICRL,ICUB,IFIN,
     +                IFOC,IFOF,IFOI,IFON,IFOS,IFVA(16),IFVI,IGND,
     +          IGNI,IGNN,IINP,INCL,INCP,INCU,IOCC,IOCP,IOTC,IOTX,
     +          IOUT,IPOC,IPOF,IPOI,IPON,IPOS,ISAV,ISGT,ISRA,ISRL,
     +          ISRM,ISRP(1023),ISRS,ISRT,ISRX,ISTB,ISTC,ISTD,
     +      ISTE,ISTF,ISTK(96),ISTL,ISTS,ISUM,ISVI,ISVN,
     +ITYQ,IUAF,IUCF,KWOK,LNCD,NABT,NAMI(500),NAMP,                NAMQ,
     +NAMR,NCLI,NCLO,NCTO,NDNT,NERR,NEST,NLNE,NLNX,                NPGE
      COMMON /IFTCM2/ IADE(26),IBUF(80),ICHS(50),ICNC,ICRD(1701),
     +            IEVS,IEVT,IHDR(115),ILCA(26),INSB(81),
     +            ISRC(6000),ISTA(1327),ITBC,ITYP,IUSB(81),
     +    IXCC,NAMC(1000),PTYP
      CHARACTER*1     IADE,IBUF,ICHS,ICNC,ICRD,IEVS,IEVT,IHDR,ILCA,INSB,
     +                ISRC,ISTA,ITBC,ITYP,IUSB,IXCC,NAMC,PTYP
      LOGICAL         DBLS,DSOK,IOCC,ISRA,ISRX,KWOK
      IF (.NOT.(IOCP.EQ.0)) GO TO 10001
      CALL XMIT(-80,ICHS(39),IBUF)
      IF (IOCC) IBUF(6)=ICHS(40)
      IOCP=6
10001 CONTINUE
      IOCP=IOCP+1
      IBUF(IOCP)=ICHR
      IF (.NOT.(IOCP.GE.72)) GO TO 10002
      CALL OUTBUF
      IOCP=0
      IOCC=.TRUE.
10002 CONTINUE
      RETURN
      END
      SUBROUTINE OUTLIN(JSGT)
      COMMON /IFTCM1/ DBLS,DSOK,IBIT,ICRB,ICRI,ICRJ,ICRK,ICRL,ICUB,IFIN,
     +                IFOC,IFOF,IFOI,IFON,IFOS,IFVA(16),IFVI,IGND,
     +          IGNI,IGNN,IINP,INCL,INCP,INCU,IOCC,IOCP,IOTC,IOTX,
     +          IOUT,IPOC,IPOF,IPOI,IPON,IPOS,ISAV,ISGT,ISRA,ISRL,
     +          ISRM,ISRP(1023),ISRS,ISRT,ISRX,ISTB,ISTC,ISTD,
     +      ISTE,ISTF,ISTK(96),ISTL,ISTS,ISUM,ISVI,ISVN,
     +ITYQ,IUAF,IUCF,KWOK,LNCD,NABT,NAMI(500),NAMP,                NAMQ,
     +NAMR,NCLI,NCLO,NCTO,NDNT,NERR,NEST,NLNE,NLNX,                NPGE
      COMMON /IFTCM2/ IADE(26),IBUF(80),ICHS(50),ICNC,ICRD(1701),
     +            IEVS,IEVT,IHDR(115),ILCA(26),INSB(81),
     +            ISRC(6000),ISTA(1327),ITBC,ITYP,IUSB(81),
     +    IXCC,NAMC(1000),PTYP
      CHARACTER*1     IADE,IBUF,ICHS,ICNC,ICRD,IEVS,IEVT,IHDR,ILCA,INSB,
     +                ISRC,ISTA,ITBC,ITYP,IUSB,IXCC,NAMC,PTYP
      LOGICAL         DBLS,DSOK,IOCC,ISRA,ISRX,KWOK
      IF (.NOT.(IOCP.GT.0)) GO TO 10001
      CALL OUTBUF
      IOCP=0
10001 CONTINUE
      IOCC=.FALSE.
      ISGT=JSGT
      RETURN
      END
      SUBROUTINE OUTNUM(NUMB)
      CHARACTER*1 ISTR(5)
      CALL CVD(NUMB,ISTR,5)
      CALL OUTSTR(ISTR,1,5)
      RETURN
      END
      SUBROUTINE OUTSTR(ISTR,I0,I1)
      CHARACTER*1 ISTR(1)
      DO 10001 I=I0,I1
      CALL OUTCHR(ISTR(I))
10001 CONTINUE
      RETURN
      END
      SUBROUTINE PAQQ(KEY)
      COMMON /IFTCM1/ DBLS,DSOK,IBIT,ICRB,ICRI,ICRJ,ICRK,ICRL,ICUB,IFIN,
     +                IFOC,IFOF,IFOI,IFON,IFOS,IFVA(16),IFVI,IGND,
     +          IGNI,IGNN,IINP,INCL,INCP,INCU,IOCC,IOCP,IOTC,IOTX,
     +          IOUT,IPOC,IPOF,IPOI,IPON,IPOS,ISAV,ISGT,ISRA,ISRL,
     +          ISRM,ISRP(1023),ISRS,ISRT,ISRX,ISTB,ISTC,ISTD,
     +      ISTE,ISTF,ISTK(96),ISTL,ISTS,ISUM,ISVI,ISVN,
     +ITYQ,IUAF,IUCF,KWOK,LNCD,NABT,NAMI(500),NAMP,                NAMQ,
     +NAMR,NCLI,NCLO,NCTO,NDNT,NERR,NEST,NLNE,NLNX,                NPGE
      COMMON /IFTCM2/ IADE(26),IBUF(80),ICHS(50),ICNC,ICRD(1701),
     +            IEVS,IEVT,IHDR(115),ILCA(26),INSB(81),
     +            ISRC(6000),ISTA(1327),ITBC,ITYP,IUSB(81),
     +    IXCC,NAMC(1000),PTYP
      CHARACTER*1     IADE,IBUF,ICHS,ICNC,ICRD,IEVS,IEVT,IHDR,ILCA,INSB,
     +                ISRC,ISTA,ITBC,ITYP,IUSB,IXCC,NAMC,PTYP
      LOGICAL         DBLS,DSOK,IOCC,ISRA,ISRX,KWOK
      CHARACTER*1 ITCH
      CHARACTER*1 LTPS(24,9),ITHN(4),ICPI
      DIMENSION LTPE(24)
      DATA (LTPS( 1,J),J=1,9) / 'B','L','O','C','K',' ',' ',' ',' ' / ,
     +      LTPE( 1  )        / 1 /
      DATA (LTPS( 2,J),J=1,9) / 'D','O',' ',' ',' ',' ',' ',' ',' ' / ,
     +      LTPE( 2  )        / 1 /
      DATA (LTPS( 3,J),J=1,9) / 'E','L','S','E',' ',' ',' ',' ',' ' / ,
     +      LTPE( 3  )        / 0 /
      DATA (LTPS( 4,J),J=1,9) / 'E','L','S','E','I','F',' ',' ',' ' / ,
     +      LTPE( 4  )        / 1 /
      DATA (LTPS( 5,J),J=1,9) / 'E','N','D',' ',' ',' ',' ',' ',' ' / ,
     +      LTPE( 5  )        / 0 /
      DATA (LTPS( 6,J),J=1,9) / 'E','N','D','B','L','O','C','K',' ' / ,
     +      LTPE( 6  )        / 0 /
      DATA (LTPS( 7,J),J=1,9) / 'E','N','D','D','O',' ',' ',' ',' ' / ,
     +      LTPE( 7  )        / 0 /
      DATA (LTPS( 8,J),J=1,9) / 'E','N','D','F','O','R',' ',' ',' ' / ,
     +      LTPE( 8  )        / 0 /
      DATA (LTPS( 9,J),J=1,9) / 'E','N','D','I','F',' ',' ',' ',' ' / ,
     +      LTPE( 9  )        / 0 /
      DATA (LTPS(10,J),J=1,9) / 'E','N','D','L','O','O','P',' ',' ' / ,
     +      LTPE(10  )        / 0 /
      DATA (LTPS(11,J),J=1,9) / 'E','N','D','W','H','I','L','E',' ' / ,
     +      LTPE(11  )        / 0 /
      DATA (LTPS(12,J),J=1,9) / 'E','X','I','T',' ',' ',' ',' ',' ' / ,
     +      LTPE(12  )        / 0 /
      DATA (LTPS(13,J),J=1,9) / 'E','X','I','T','I','F',' ',' ',' ' / ,
     +      LTPE(13  )        / 1 /
      DATA (LTPS(14,J),J=1,9) / 'F','O','R',' ',' ',' ',' ',' ',' ' / ,
     +      LTPE(14  )        / 1 /
      DATA (LTPS(15,J),J=1,9) / 'G','O','T','O',' ',' ',' ',' ',' ' / ,
     +      LTPE(15  )        / 2 /
      DATA (LTPS(16,J),J=1,9) / 'I','F',' ',' ',' ',' ',' ',' ',' ' / ,
     +      LTPE(16  )        / 1 /
      DATA (LTPS(17,J),J=1,9) / 'I','N','V','O','K','E',' ',' ',' ' / ,
     +      LTPE(17  )        / 1 /
      DATA (LTPS(18,J),J=1,9) / 'L','O','O','P',' ',' ',' ',' ',' ' / ,
     +      LTPE(18  )        / 0 /
      DATA (LTPS(19,J),J=1,9) / 'O','R','I','F',' ',' ',' ',' ',' ' / ,
     +      LTPE(19  )        / 1 /
      DATA (LTPS(20,J),J=1,9) / 'R','E','P','E','A','T',' ',' ',' ' / ,
     +      LTPE(20  )        / 0 /
      DATA (LTPS(21,J),J=1,9) / 'R','E','T','U','R','N',' ',' ',' ' / ,
     +      LTPE(21  )        / 3 /
      DATA (LTPS(22,J),J=1,9) / 'S','T','O','P',' ',' ',' ',' ',' ' / ,
     +      LTPE(22  )        / 4 /
      DATA (LTPS(23,J),J=1,9) / 'U','N','T','I','L',' ',' ',' ',' ' / ,
     +      LTPE(23  )        / 1 /
      DATA (LTPS(24,J),J=1,9) / 'W','H','I','L','E',' ',' ',' ',' ' / ,
     +      LTPE(24  )        / 1 /
      DATA ITHN / 'T' , 'H' , 'E' , 'N' /
      KEY=0
      ISTD=ISTB+1
      ISTE=ISTB
      ITPL=1
      ITPH=24
      MTCH=0
      NCBS=0
      I0=7
      I1=ISTB-1
      DO 10001 I=I0,I1
      ITCH=ISTA(I)
      IF (.NOT.(ITCH.GE.ILCA(1).AND.ITCH.LE.ILCA(26))) GO TO 10002
      ITCH=CHAR(ICHAR(ICHS( 2))+ICHAR(ITCH)-ICHAR(ILCA( 1)))
10002 CONTINUE
      IF (.NOT.(ITCH.NE.ICHS(39))) GO TO 10003
      IF (.NOT.(ITPL.LT.ITPH)) GO TO 10004
      MTCH=MTCH+1
      ITPL=INDEX1(ITCH,LTPS(1,MTCH),ITPL,ITPH)
      IF (ITPL.EQ.0) RETURN
10005 CONTINUE
      IF (.NOT.(ITCH.NE.LTPS(ITPH,MTCH))) GO TO 10006
      ITPH=ITPH-1
      GO TO 10005
10006 CONTINUE
      GO TO 10007
10004 CONTINUE
      IF (.NOT.(LTPS(ITPL,MTCH+1).NE.ICHS(39))) GO TO 10008
      MTCH=MTCH+1
      IF (ITCH.NE.LTPS(ITPL,MTCH)) RETURN
      GO TO 10007
10008 CONTINUE
      IF (.NOT.(LTPE(ITPL).EQ.0)) GO TO 10009
      RETURN
10009 CONTINUE
      IF (.NOT.(LTPE(ITPL).EQ.1)) GO TO 10010
      IF (.NOT.(KWOK)) GO TO 10011
      IF (NCBS.EQ.0) RETURN
      ISTE=ISTE+1
      IF (ISTE.GT.1327) GO TO 106
      ISTA(ISTE)=ICHS(44)
      GO TO 10012
10011 CONTINUE
      IF (ITCH.NE.ICHS(44)) RETURN
10012 CONTINUE
      GO TO 101
10010 CONTINUE
      GO TO 105
10007 CONTINUE
      NCBS=0
      GO TO 10013
10003 CONTINUE
      NCBS=NCBS+1
10013 CONTINUE
10001 CONTINUE
      IF (LTPS(ITPL,MTCH+1).EQ.ICHS(39).AND.LTPE(ITPL).NE.1) KEY=ITPL
      RETURN
  101 LEVP=0
      IPAS=0
      NCBS=0
      IZRP=0
      INTV=0
      ICPI=ICHS(39)
      I0=I
      DO 10014 I=I0,I1
      IF (.NOT.(IPAS.LT.0)) GO TO 10015
      IF (IPAS.EQ.(-1).AND.ISTA(I).EQ.ICHS(48)) IPAS=0
      IF (IPAS.EQ.(-2).AND.ISTA(I).EQ.ICHS(49)) IPAS=0
      GO TO 10016
10015 CONTINUE
      IF (.NOT.(IPAS.GT.0)) GO TO 10017
      IPAS=IPAS-1
      GO TO 10016
10017 CONTINUE
      IF (.NOT.(ISTA(I).EQ.ICHS(39))) GO TO 10018
      NCBS=NCBS+1
      IF (.NOT.(NCBS.EQ.1.AND.ITPL.EQ.14)) GO TO 10019
      ISTE=ISTE+1
      IF (ISTE.GT.1327) GO TO 106
      ISTA(ISTE)=ICHS(39)
10019 CONTINUE
      GO TO 103
10018 CONTINUE
      IF (.NOT.(IZRP.NE.0)) GO TO 10020
      IF (.NOT.(KWOK)) GO TO 10021
      IF (ISTA(I).NE.ICHS(40).AND.ISTA(I).NE.ICHS(41).AND.
     +              ISTA(I).NE.ICHS(42).AND.ISTA(I).NE.ICHS(43).AND.
     +                        ISTA(I).NE.ICHS(47)
     + ) GO TO 104
      IZRP=0
      GO TO 10022
10021 CONTINUE
      GO TO 104
10022 CONTINUE
      GO TO 10016
10020 CONTINUE
      IF (.NOT.(ISTA(I).EQ.ICHS(48))) GO TO 10023
      IPAS=-1
      GO TO 10016
10023 CONTINUE
      IF (.NOT.(ISTA(I).EQ.ICHS(49))) GO TO 10024
      IPAS=-2
      GO TO 10016
10024 CONTINUE
      IF (.NOT.(ISTA(I).EQ.ICHS(44))) GO TO 10025
      LEVP=LEVP+1
      GO TO 10016
10025 CONTINUE
      IF (.NOT.(ISTA(I).EQ.ICHS(45))) GO TO 10026
      LEVP=LEVP-1
      IF (.NOT.(LEVP.LT.0)) GO TO 10027
      CALL ERRM(29)
      RETURN
10027 CONTINUE
      IF (.NOT.(LEVP.EQ.0)) GO TO 10028
      IZRP=1
10028 CONTINUE
      GO TO 10016
10026 CONTINUE
      IF (.NOT.(INTV.NE.0.AND.(ISTA(I).EQ.ICHS(9).OR.ISTA(I).EQ.ILCA(8).
     +OR.ISTA(I).EQ.ICHS(13).OR.ISTA(I).EQ.ILCA(12).OR.ISTA(I).EQ.ICHS(1
     +9).OR.ISTA(I).EQ.ILCA(18)))) GO TO 10029
      IF (.NOT.(ICPI.GE.ILCA(1).AND.ICPI.LE.ILCA(26))) GO TO 10030
      ICPI=CHAR(ICHAR(ICHS( 2))+ICHAR(ICPI)-ICHAR(ILCA( 1)))
10030 CONTINUE
      IF (.NOT.(ICPI.LT.ICHS(2).OR.ICPI.GT.ICHS(27))) GO TO 10031
      IPAS=INTV
10031 CONTINUE
      GO TO 10016
10029 CONTINUE
      J=INDEX1(ISTA(I),ICHS(28),1,10)-1
      IF (.NOT.(J.GE.0)) GO TO 10032
      IF (INTV.LT.3276) INTV=10*INTV+J
      GO TO 102
10032 CONTINUE
10016 CONTINUE
      INTV=0
      ICPI=ISTA(I)
  102 NCBS=0
      ISTE=ISTE+1
      IF (ISTE.GT.1327) GO TO 106
      ISTA(ISTE)=ISTA(I)
  103 CONTINUE
10014 CONTINUE
      IF (.NOT.(KWOK)) GO TO 10033
      IF (.NOT.(LEVP.EQ.0.AND.IPAS.GE.0)) GO TO 10034
      KEY=ITPL
      IF (.NOT.(IPAS.GT.0)) GO TO 10035
      ITMP=ISTE+1
      ISTE=ISTE+IPAS
      IF (ISTE.GT.1327) GO TO 106
      DO 10036 I=ITMP,ISTE
      ISTA(I)=ICHS(39)
10036 CONTINUE
10035 CONTINUE
      ISTE=ISTE+1
      IF (ISTE.GT.1327) GO TO 106
      ISTA(ISTE)=ICHS(45)
      GO TO 10037
10034 CONTINUE
      CALL ERRM(29)
10037 CONTINUE
      GO TO 10038
10033 CONTINUE
      IF (IZRP.NE.0) KEY=ITPL
10038 CONTINUE
      RETURN
  104 CONTINUE
      IF (.NOT.(ITPL.EQ.16.AND.(ISTA(I).GE.ICHS(28).AND.ISTA(I).LE.ICHS(
     +37)))) GO TO 10039
      KEY=26
      RETURN
10039 CONTINUE
      IF (.NOT.(ITPL.EQ.4.OR.ITPL.EQ.16.OR.ITPL.EQ.19)) GO TO 10040
      MTCH=0
      I0=I
      DO 10041 I=I0,I1
      ITCH=ISTA(I)
      IF (.NOT.(ITCH.GE.ILCA(1).AND.ITCH.LE.ILCA(26))) GO TO 10042
      ITCH=CHAR(ICHAR(ICHS( 2))+ICHAR(ITCH)-ICHAR(ILCA( 1)))
10042 CONTINUE
      IF (.NOT.(ITCH.NE.ICHS(39))) GO TO 10043
      MTCH=MTCH+1
      IF (ITCH.NE.ITHN(MTCH)) RETURN
10043 CONTINUE
10041 CONTINUE
      IF (.NOT.(MTCH.EQ.4)) GO TO 10044
      IF (ITPL.EQ.4.OR.ITPL.EQ.19) KEY=ITPL
      IF (ITPL.EQ.16) KEY=25
      RETURN
10044 CONTINUE
10040 CONTINUE
      RETURN
  105 I0=I
      DO 10045 I=I0,I1
      IF (ISTA(I).EQ.ICHS(46)) RETURN
10045 CONTINUE
      KEY=ITPL
      RETURN
  106 CALL ERRM(32)
      CALL NGEXIT(NERR)
      STOP
      END
      SUBROUTINE RDCRD(JCRD,IEOF,IPCC)
      CHARACTER*1 JCRD(1)
      COMMON /IFTCM1/ DBLS,DSOK,IBIT,ICRB,ICRI,ICRJ,ICRK,ICRL,ICUB,IFIN,
     +                IFOC,IFOF,IFOI,IFON,IFOS,IFVA(16),IFVI,IGND,
     +          IGNI,IGNN,IINP,INCL,INCP,INCU,IOCC,IOCP,IOTC,IOTX,
     +          IOUT,IPOC,IPOF,IPOI,IPON,IPOS,ISAV,ISGT,ISRA,ISRL,
     +          ISRM,ISRP(1023),ISRS,ISRT,ISRX,ISTB,ISTC,ISTD,
     +      ISTE,ISTF,ISTK(96),ISTL,ISTS,ISUM,ISVI,ISVN,
     +ITYQ,IUAF,IUCF,KWOK,LNCD,NABT,NAMI(500),NAMP,                NAMQ,
     +NAMR,NCLI,NCLO,NCTO,NDNT,NERR,NEST,NLNE,NLNX,                NPGE
      COMMON /IFTCM2/ IADE(26),IBUF(80),ICHS(50),ICNC,ICRD(1701),
     +            IEVS,IEVT,IHDR(115),ILCA(26),INSB(81),
     +            ISRC(6000),ISTA(1327),ITBC,ITYP,IUSB(81),
     +    IXCC,NAMC(1000),PTYP
      CHARACTER*1     IADE,IBUF,ICHS,ICNC,ICRD,IEVS,IEVT,IHDR,ILCA,INSB,
     +                ISRC,ISTA,ITBC,ITYP,IUSB,IXCC,NAMC,PTYP
      LOGICAL         DBLS,DSOK,IOCC,ISRA,ISRX,KWOK
      CHARACTER*1 ITCH
  101 IEOF=0
      IF (.NOT.(ABS(IUAF).EQ.1)) GO TO 10001
      CALL IFTRIO(1,ISAV,JCRD,LNCD+1,IEOF)
      IF (.NOT.(JCRD(LNCD+1).EQ.ICHS(6))) GO TO 10002
      IUAF=IUAF+1
10002 CONTINUE
      GO TO 10003
10001 CONTINUE
      IF (.NOT.(IUAF.EQ.2)) GO TO 10004
      CALL XMIT(LNCD+1,IUSB,JCRD)
      IUAF=0
      GO TO 10003
10004 CONTINUE
      IF (.NOT.(ABS(INCP).EQ.1)) GO TO 10005
      LNRD=MIN(LNCD,INCL)
      CALL IFTRIO(1,INCU,JCRD,LNRD,IEOF)
      IF (.NOT.(IEOF.NE.0)) GO TO 10006
      INCP=INCP+1
      GO TO 101
10006 CONTINUE
      IF (LNRD.LT.LNCD) CALL XMIT(LNRD-LNCD,ICHS(39),JCRD(LNRD+1))
      GO TO 10003
10005 CONTINUE
      IF (.NOT.(INCP.EQ.2)) GO TO 10007
      CALL XMIT(LNCD+1,INSB,JCRD)
      INCP=0
      GO TO 10003
10007 CONTINUE
      CALL IFTRIO(1,IINP,JCRD,LNCD,IEOF)
      IF (IEOF.NE.0) RETURN
10003 CONTINUE
      NCLI=NCLI+1
      NCTO=NCTO+1
      IF (IPCC.EQ.0) RETURN
      JCRD(LNCD+1)=JCRD(1)
      IF (.NOT.(JCRD(1).NE.ICHS(39))) GO TO 10008
      ITCH=JCRD(1)
      IF (.NOT.((ITCH.GE.ICHS(2).AND.ITCH.LE.ICHS(27)).OR.(ITCH.GE.ILCA(
     +1).AND.ITCH.LE.ILCA(26)))) GO TO 10009
      I=INDEX1(ITCH,ICHS(2),1,26)
      IF (I.EQ.0) I=INDEX1(ITCH,ILCA,1,26)
      IF (.NOT.(IADE(I).EQ.ICHS(2))) GO TO 10010
      JCRD(1)=ICHS(39)
      GO TO 10011
10010 CONTINUE
      IF (.NOT.(IADE(I).EQ.ICHS(5))) GO TO 10012
      JCRD(1)=ICHS( 4)
      GO TO 10011
10012 CONTINUE
      JCRD(1)=ICHS(50)
10011 CONTINUE
10009 CONTINUE
10008 CONTINUE
      IF (.NOT.(JCRD(1).NE.ICHS(4).AND.JCRD(1).NE.ILCA(3).AND.JCRD(1).NE
     +.ICHS(47).AND.JCRD(1).NE.ICHS(42))) GO TO 10013
      IF (.NOT.(ITBC.NE.ICHS(50))) GO TO 10014
      I=INDEX1(ITBC,JCRD,1,6)
      IF (.NOT.(I.GT.0)) GO TO 10015
      IF (.NOT.(I.LE.5)) GO TO 10016
      DO 10017 J=1,66
      K=73-J
      L=I+67-J
      JCRD(K)=JCRD(L)
10017 CONTINUE
10016 CONTINUE
      CALL XMIT(I-7,ICHS(39),JCRD(I))
10015 CONTINUE
10014 CONTINUE
      IF (.NOT.(ICNC.NE.ICHS(50).AND.JCRD(1).EQ.ICNC)) GO TO 10018
      DO 10019 I=1,67
      J=73-I
      K=68-I
      JCRD(J)=JCRD(K)
10019 CONTINUE
      CALL XMIT(-5,ICHS(39),JCRD(1))
10018 CONTINUE
10013 CONTINUE
      RETURN
      END
      SUBROUTINE REPETE
      COMMON /IFTCM1/ DBLS,DSOK,IBIT,ICRB,ICRI,ICRJ,ICRK,ICRL,ICUB,IFIN,
     +                IFOC,IFOF,IFOI,IFON,IFOS,IFVA(16),IFVI,IGND,
     +          IGNI,IGNN,IINP,INCL,INCP,INCU,IOCC,IOCP,IOTC,IOTX,
     +          IOUT,IPOC,IPOF,IPOI,IPON,IPOS,ISAV,ISGT,ISRA,ISRL,
     +          ISRM,ISRP(1023),ISRS,ISRT,ISRX,ISTB,ISTC,ISTD,
     +      ISTE,ISTF,ISTK(96),ISTL,ISTS,ISUM,ISVI,ISVN,
     +ITYQ,IUAF,IUCF,KWOK,LNCD,NABT,NAMI(500),NAMP,                NAMQ,
     +NAMR,NCLI,NCLO,NCTO,NDNT,NERR,NEST,NLNE,NLNX,                NPGE
      COMMON /IFTCM2/ IADE(26),IBUF(80),ICHS(50),ICNC,ICRD(1701),
     +            IEVS,IEVT,IHDR(115),ILCA(26),INSB(81),
     +            ISRC(6000),ISTA(1327),ITBC,ITYP,IUSB(81),
     +    IXCC,NAMC(1000),PTYP
      CHARACTER*1     IADE,IBUF,ICHS,ICNC,ICRD,IEVS,IEVT,IHDR,ILCA,INSB,
     +                ISRC,ISTA,ITBC,ITYP,IUSB,IXCC,NAMC,PTYP
      LOGICAL         DBLS,DSOK,IOCC,ISRA,ISRX,KWOK
      CALL CRDOUT
      CALL LABOUT
      CALL NEWNUM(N1)
      CALL STAK(8,N1,0)
      CALL CONTCD(N1)
      NEST=NEST+1
      RETURN
      END
      SUBROUTINE REPL1(IOST,LOST,IRST,LRST)
      CHARACTER*1 IOST(LOST),IRST(LRST)
      COMMON /IFTCM1/ DBLS,DSOK,IBIT,ICRB,ICRI,ICRJ,ICRK,ICRL,ICUB,IFIN,
     +                IFOC,IFOF,IFOI,IFON,IFOS,IFVA(16),IFVI,IGND,
     +          IGNI,IGNN,IINP,INCL,INCP,INCU,IOCC,IOCP,IOTC,IOTX,
     +          IOUT,IPOC,IPOF,IPOI,IPON,IPOS,ISAV,ISGT,ISRA,ISRL,
     +          ISRM,ISRP(1023),ISRS,ISRT,ISRX,ISTB,ISTC,ISTD,
     +      ISTE,ISTF,ISTK(96),ISTL,ISTS,ISUM,ISVI,ISVN,
     +ITYQ,IUAF,IUCF,KWOK,LNCD,NABT,NAMI(500),NAMP,                NAMQ,
     +NAMR,NCLI,NCLO,NCTO,NDNT,NERR,NEST,NLNE,NLNX,                NPGE
      COMMON /IFTCM2/ IADE(26),IBUF(80),ICHS(50),ICNC,ICRD(1701),
     +            IEVS,IEVT,IHDR(115),ILCA(26),INSB(81),
     +            ISRC(6000),ISTA(1327),ITBC,ITYP,IUSB(81),
     +    IXCC,NAMC(1000),PTYP
      CHARACTER*1     IADE,IBUF,ICHS,ICNC,ICRD,IEVS,IEVT,IHDR,ILCA,INSB,
     +                ISRC,ISTA,ITBC,ITYP,IUSB,IXCC,NAMC,PTYP
      LOGICAL         DBLS,DSOK,IOCC,ISRA,ISRX,KWOK
      IF (ISRS.NE.0) RETURN
      ISRM=MIN(ISRM,LOST)
      IF (.NOT.(ISRL+LOST+LRST+2.GT.6000)) GO TO 10001
      I=1
10002 CONTINUE
      IF (.NOT.(I.LT.ISRL)) GO TO 10003
      J=I+1
      DO 10004 K=1,2
10005 CONTINUE
      IF (.NOT.(ISRC(J).NE.ICHS(50))) GO TO 10006
      J=J+1
      GO TO 10005
10006 CONTINUE
      J=J+1
10004 CONTINUE
      DO 10007 K=1,1023
      IF (ISRP(K).EQ.I) GO TO 101
10007 CONTINUE
      CALL XMIT(ISRL-J+1,ISRC(J),ISRC(I))
      ISRL=ISRL+I-J
      DO 10008 K=1,1023
      IF (ISRP(K).GT.I) ISRP(K)=ISRP(K)+I-J
10008 CONTINUE
      J=I
  101 I=J
      GO TO 10002
10003 CONTINUE
      IF (.NOT.(ISRL+LOST+LRST+2.GT.6000)) GO TO 10009
      CALL ERRM(10)
      ISRS=1
      RETURN
10009 CONTINUE
10001 CONTINUE
      I=ISRL+1
      CALL XMIT(LOST,IOST,ISRC(ISRL+1))
      ISRL=ISRL+LOST+1
      ISRC(ISRL)=ICHS(50)
      CALL XMIT(LRST,IRST,ISRC(ISRL+1))
      ISRL=ISRL+LRST+1
      ISRC(ISRL)=ICHS(50)
      J=0
      DO 10010 K=1,MIN(LOST,4)
      J=100*J+ICHAR(IOST(K))
10010 CONTINUE
      J=1+MOD(J,1023)
      DO 10011 K=1,1023
      IF (.NOT.(ISRP(J).EQ.0)) GO TO 10012
      ISRP(J)=I
      RETURN
10012 CONTINUE
      L=ISRP(J)
      IF (.NOT.(NOTEQ(ISRC(I),ISRC(L),LOST+1).EQ.0)) GO TO 10013
      ISRP(J)=I
      RETURN
10013 CONTINUE
      J=MOD(J,1023)+1
10011 CONTINUE
      CALL ERRM(9)
      ISRS=1
      RETURN
      END
      SUBROUTINE REPL2(ISTR,MSTR,LSTR,IBSS,IESS,NSRD)
      CHARACTER*1 ISTR(MSTR)
      COMMON /IFTCM1/ DBLS,DSOK,IBIT,ICRB,ICRI,ICRJ,ICRK,ICRL,ICUB,IFIN,
     +                IFOC,IFOF,IFOI,IFON,IFOS,IFVA(16),IFVI,IGND,
     +          IGNI,IGNN,IINP,INCL,INCP,INCU,IOCC,IOCP,IOTC,IOTX,
     +          IOUT,IPOC,IPOF,IPOI,IPON,IPOS,ISAV,ISGT,ISRA,ISRL,
     +          ISRM,ISRP(1023),ISRS,ISRT,ISRX,ISTB,ISTC,ISTD,
     +      ISTE,ISTF,ISTK(96),ISTL,ISTS,ISUM,ISVI,ISVN,
     +ITYQ,IUAF,IUCF,KWOK,LNCD,NABT,NAMI(500),NAMP,                NAMQ,
     +NAMR,NCLI,NCLO,NCTO,NDNT,NERR,NEST,NLNE,NLNX,                NPGE
      COMMON /IFTCM2/ IADE(26),IBUF(80),ICHS(50),ICNC,ICRD(1701),
     +            IEVS,IEVT,IHDR(115),ILCA(26),INSB(81),
     +            ISRC(6000),ISTA(1327),ITBC,ITYP,IUSB(81),
     +    IXCC,NAMC(1000),PTYP
      CHARACTER*1     IADE,IBUF,ICHS,ICNC,ICRD,IEVS,IEVT,IHDR,ILCA,INSB,
     +                ISRC,ISTA,ITBC,ITYP,IUSB,IXCC,NAMC,PTYP
      LOGICAL         DBLS,DSOK,IOCC,ISRA,ISRX,KWOK
      ILST=IESS-ISRM+1
      ISRN=MIN(ISRM,4)
      JEVS=0
      I=IBSS
      IF (.NOT.(ISRT.EQ.0)) GO TO 10001
  101 CONTINUE
10002 CONTINUE
      IF (.NOT.(I.LE.LSTR)) GO TO 10003
      IF (.NOT.(ISTR(I).EQ.IEVS)) GO TO 10004
      IF (.NOT.(JEVS.EQ.0)) GO TO 10005
      JEVS=I
      I=I+1
      GO TO 101
10005 CONTINUE
10004 CONTINUE
      IF (.NOT.(ISTR(I).EQ.IEVT)) GO TO 10006
      IF (.NOT.(JEVS.NE.0)) GO TO 10007
      JEVT=I
      CALL REPL3(ISTR,MSTR,LSTR,JEVS,JEVT,NSRD)
      IESS=IESS+JEVT-I
      ILST=ILST+JEVT-I
      I=JEVT+1
      JEVS=0
      GO TO 101
10007 CONTINUE
10006 CONTINUE
      IF (.NOT.(I.LE.ILST)) GO TO 10008
      LSRN=MIN(IESS-I+1,4)
      DO 10009 JSRN=ISRN,LSRN
      KSRN=ISRN+LSRN-JSRN
      J=0
      DO 10010 K=I,I+KSRN-1
      J=100*J+ICHAR(ISTR(K))
10010 CONTINUE
      J=1+MOD(J,1023)
      LMAX=0
      MMAX=0
      IF (.NOT.(ISRP(J).NE.0)) GO TO 10011
      K=J
10012 CONTINUE
      L=ISRP(K)
      M=I
10013 CONTINUE
      IF (ISRC(L).NE.ISTR(M)) GO TO 10014
      IF (.NOT.(ISRC(L+1).EQ.ICHS(50))) GO TO 10015
      IF (.NOT.(M.GT.MMAX.AND.M-I+1.GE.KSRN)) GO TO 10016
      LMAX=L
      MMAX=M
      GO TO 10014
10016 CONTINUE
10015 CONTINUE
      IF (M.EQ.IESS) GO TO 10014
      L=L+1
      M=M+1
      GO TO 10013
10014 CONTINUE
      K=MOD(K,1023)+1
      IF (.NOT.(K.EQ.J.OR.ISRP(K).EQ.0)) GO TO 10012
      IF (.NOT.(MMAX.NE.0)) GO TO 10017
      L=LMAX
      M=MMAX
      J=L+2
10018 CONTINUE
      IF (ISRC(J).EQ.ICHS(50)) GO TO 10019
      IF (I.LE.M) ISTR(I)=ISRC(J)
      I=I+1
      J=J+1
      GO TO 10018
10019 CONTINUE
      K=I-M-1
      IF (.NOT.(K.LT.0)) GO TO 10020
      CALL XMIT(LSTR-M,ISTR(M+1),ISTR(I))
      LSTR=LSTR+K
      IESS=IESS+K
      ILST=ILST+K
      GO TO 10021
10020 CONTINUE
      IF (.NOT.(K.GT.0)) GO TO 10022
      L=J-K
      IF (.NOT.(LSTR+K.GT.MSTR)) GO TO 10023
      CALL ERRM(32)
      K=MSTR-LSTR
10023 CONTINUE
      J=LSTR
      N=LSTR+K
10024 CONTINUE
      IF (.NOT.(J.GT.M)) GO TO 10025
      ISTR(N)=ISTR(J)
      J=J-1
      N=N-1
      GO TO 10024
10025 CONTINUE
      CALL XMIT(K,ISRC(L),ISTR(M+1))
      LSTR=LSTR+K
      IESS=IESS+K
      ILST=ILST+K
10021 CONTINUE
10022 CONTINUE
      NSRD=NSRD+1
      GO TO 101
10017 CONTINUE
10011 CONTINUE
10009 CONTINUE
10008 CONTINUE
      I=I+1
      GO TO 10002
10003 CONTINUE
      GO TO 10026
10001 CONTINUE
  102 ITKO=0
10027 CONTINUE
      IF (.NOT.(I.LE.LSTR)) GO TO 10028
      IF (.NOT.(ISTR(I).EQ.IEVS)) GO TO 10029
      IF (.NOT.(JEVS.EQ.0)) GO TO 10030
      JEVS=I
      I=I+1
      GO TO 102
10030 CONTINUE
10029 CONTINUE
      IF (.NOT.(ISTR(I).EQ.IEVT)) GO TO 10031
      IF (.NOT.(JEVS.NE.0)) GO TO 10032
      JEVT=I
      CALL REPL3(ISTR,MSTR,LSTR,JEVS,JEVT,NSRD)
      IESS=IESS+JEVT-I
      ILST=ILST+JEVT-I
      I=JEVT+1
      JEVS=0
      GO TO 102
10032 CONTINUE
10031 CONTINUE
      IF (.NOT.(I.LE.ILST)) GO TO 10033
      ITKN=0
      IF ((ISTR(I).GE.ICHS( 2).AND.ISTR(I).LE.ICHS(27)).OR.
     +              (ISTR(I).GE.ILCA( 1).AND.ISTR(I).LE.ILCA(26)).OR.IST
     +R(I).EQ.ICHS( 1))
     +             ITKN=1
      IF (.NOT.(ITKO.EQ.0.AND.ITKN.NE.0)) GO TO 10034
      LSRN=MIN(IESS-I+1,4)
      DO 10035 JSRN=ISRN,LSRN
      KSRN=ISRN+LSRN-JSRN
      J=0
      DO 10036 K=I,I+KSRN-1
      J=100*J+ICHAR(ISTR(K))
10036 CONTINUE
      J=1+MOD(J,1023)
      LMAX=0
      MMAX=0
      IF (.NOT.(ISRP(J).NE.0)) GO TO 10037
      K=J
10038 CONTINUE
      L=ISRP(K)
      M=I
10039 CONTINUE
      IF (ISRC(L).NE.ISTR(M)) GO TO 10040
      IF (.NOT.(ISRC(L+1).EQ.ICHS(50))) GO TO 10041
      IF (.NOT.(M.GT.MMAX.AND.M-I+1.GE.KSRN)) GO TO 10042
      LMAX=L
      MMAX=M
      GO TO 10040
10042 CONTINUE
10041 CONTINUE
      IF (M.EQ.IESS) GO TO 10040
      L=L+1
      M=M+1
      GO TO 10039
10040 CONTINUE
      K=MOD(K,1023)+1
      IF (.NOT.(K.EQ.J.OR.ISRP(K).EQ.0)) GO TO 10038
      IF (.NOT.(MMAX.NE.0)) GO TO 10043
      L=LMAX
      M=MMAX
      J=L+2
10044 CONTINUE
      IF (ISRC(J).EQ.ICHS(50)) GO TO 10045
      IF (I.LE.M) ISTR(I)=ISRC(J)
      I=I+1
      J=J+1
      GO TO 10044
10045 CONTINUE
      K=I-M-1
      IF (.NOT.(K.LT.0)) GO TO 10046
      CALL XMIT(LSTR-M,ISTR(M+1),ISTR(I))
      LSTR=LSTR+K
      IESS=IESS+K
      ILST=ILST+K
      GO TO 10047
10046 CONTINUE
      IF (.NOT.(K.GT.0)) GO TO 10048
      L=J-K
      IF (.NOT.(LSTR+K.GT.MSTR)) GO TO 10049
      CALL ERRM(32)
      K=MSTR-LSTR
10049 CONTINUE
      J=LSTR
      N=LSTR+K
10050 CONTINUE
      IF (.NOT.(J.GT.M)) GO TO 10051
      ISTR(N)=ISTR(J)
      J=J-1
      N=N-1
      GO TO 10050
10051 CONTINUE
      CALL XMIT(K,ISRC(L),ISTR(M+1))
      LSTR=LSTR+K
      IESS=IESS+K
      ILST=ILST+K
10047 CONTINUE
10048 CONTINUE
      NSRD=NSRD+1
      GO TO 102
10043 CONTINUE
10037 CONTINUE
10035 CONTINUE
10034 CONTINUE
10033 CONTINUE
      I=I+1
      ITKO=ITKN
      GO TO 10027
10028 CONTINUE
10026 CONTINUE
      RETURN
      END
      SUBROUTINE REPL3(ISTR,MSTR,LSTR,IBSS,IESS,NSRD)
      CHARACTER*1 ISTR(MSTR)
      COMMON /IFTCM1/ DBLS,DSOK,IBIT,ICRB,ICRI,ICRJ,ICRK,ICRL,ICUB,IFIN,
     +                IFOC,IFOF,IFOI,IFON,IFOS,IFVA(16),IFVI,IGND,
     +          IGNI,IGNN,IINP,INCL,INCP,INCU,IOCC,IOCP,IOTC,IOTX,
     +          IOUT,IPOC,IPOF,IPOI,IPON,IPOS,ISAV,ISGT,ISRA,ISRL,
     +          ISRM,ISRP(1023),ISRS,ISRT,ISRX,ISTB,ISTC,ISTD,
     +      ISTE,ISTF,ISTK(96),ISTL,ISTS,ISUM,ISVI,ISVN,
     +ITYQ,IUAF,IUCF,KWOK,LNCD,NABT,NAMI(500),NAMP,                NAMQ,
     +NAMR,NCLI,NCLO,NCTO,NDNT,NERR,NEST,NLNE,NLNX,                NPGE
      COMMON /IFTCM2/ IADE(26),IBUF(80),ICHS(50),ICNC,ICRD(1701),
     +            IEVS,IEVT,IHDR(115),ILCA(26),INSB(81),
     +            ISRC(6000),ISTA(1327),ITBC,ITYP,IUSB(81),
     +    IXCC,NAMC(1000),PTYP
      CHARACTER*1     IADE,IBUF,ICHS,ICNC,ICRD,IEVS,IEVT,IHDR,ILCA,INSB,
     +                ISRC,ISTA,ITBC,ITYP,IUSB,IXCC,NAMC,PTYP
      LOGICAL         DBLS,DSOK,IOCC,ISRA,ISRX,KWOK
      CHARACTER*1 ITCH
      DIMENSION IOPR(32),IOPS(64),IGTS(16),IOPL(20),            KOPR(9)
      CHARACTER*1 LOPR(9,5),LOPS(16,7),INCH(12)
      DATA IOPL / 0,1,2*2,2*3,6*5,6,7,8,9,10,11,12,13 /
      DATA (LOPR(1,J),J=1,5),KOPR(1) / '.' , 'A' , 'N' , 'D' , '.', 14 /
      DATA (LOPR(2,J),J=1,5),KOPR(2) / '.' , 'E' , 'Q' , '.' , ' ', 11 /
      DATA (LOPR(3,J),J=1,5),KOPR(3) / '.' , 'G' , 'E' , '.' , ' ', 10 /
      DATA (LOPR(4,J),J=1,5),KOPR(4) / '.' , 'G' , 'T' , '.' , ' ',  9 /
      DATA (LOPR(5,J),J=1,5),KOPR(5) / '.' , 'L' , 'E' , '.' , ' ',  8 /
      DATA (LOPR(6,J),J=1,5),KOPR(6) / '.' , 'L' , 'T' , '.' , ' ',  7 /
      DATA (LOPR(7,J),J=1,5),KOPR(7) / '.' , 'N' , 'E' , '.' , ' ', 12 /
      DATA (LOPR(8,J),J=1,5),KOPR(8) / '.' , 'O' , 'R' , '.' , ' ', 16 /
      DATA (LOPR(9,J),J=1,5),KOPR(9) / '.' , 'X' , 'O' , 'R' , '.', 15 /
      DATA (LOPS( 1,J),J=1,7) / 'A' , 'B' , 'S' , '(' , ' ' , ' ' , ' '/
      DATA (LOPS( 2,J),J=1,7) / 'A' , 'N' , 'D' , '(' , ' ' , ' ' , ' '/
      DATA (LOPS( 3,J),J=1,7) / 'M' , 'A' , 'S' , 'K' , '(' , ' ' , ' '/
      DATA (LOPS( 4,J),J=1,7) / 'M' , 'A' , 'X' , '(' , ' ' , ' ' , ' '/
      DATA (LOPS( 5,J),J=1,7) / 'M' , 'I' , 'N' , '(' , ' ' , ' ' , ' '/
      DATA (LOPS( 6,J),J=1,7) / 'M' , 'O' , 'D' , '(' , ' ' , ' ' , ' '/
      DATA (LOPS( 7,J),J=1,7) / 'N' , 'O' , 'T' , '(' , ' ' , ' ' , ' '/
      DATA (LOPS( 8,J),J=1,7) / 'O' , 'R' , '(' , ' ' , ' ' , ' ' , ' '/
      DATA (LOPS( 9,J),J=1,7) / 'S' , 'H' , 'I' , 'F' , 'T' , '(' , ' '/
      DATA (LOPS(10,J),J=1,7) / 'S' , 'I' , 'G' , 'N' , '(' , ' ' , ' '/
      DATA (LOPS(11,J),J=1,7) / 'X' , 'O' , 'R' , '(' , ' ' , ' ' , ' '/
      DATA (LOPS(12,J),J=1,7) / '.' , 'F' , 'A' , 'L' , 'S' , 'E' , '.'/
      DATA (LOPS(13,J),J=1,7) / '.' , 'F' , '.' , ' ' , ' ' , ' ' , ' '/
      DATA (LOPS(14,J),J=1,7) / '.' , 'N' , 'O' , 'T' , '.' , ' ' , ' '/
      DATA (LOPS(15,J),J=1,7) / '.' , 'T' , 'R' , 'U' , 'E' , '.' , ' '/
      DATA (LOPS(16,J),J=1,7) / '.' , 'T' , '.' , ' ' , ' ' , ' ' , ' '/
      NOPR=0
      NOPS=0
      NGTS=0
      I=IBSS
      IOOO=0
10001 CONTINUE
      IF (.NOT.(I.LE.IESS)) GO TO 10002
      IF (.NOT.(ISTR(I).NE.ICHS(39))) GO TO 10003
      IF (.NOT.(IOOO.EQ.0)) GO TO 10004
      IF (.NOT.(ISTR(I).NE.ICHS(40))) GO TO 10005
      IF (.NOT.(ISTR(I).EQ.ICHS(41))) GO TO 10006
      JOPR=2
      L10008=    1
      GO TO 10008
10007 CONTINUE
      GO TO 10009
10006 CONTINUE
      IF (.NOT.(ISTR(I).EQ.ICHS(44).OR.ISTR(I).EQ.IEVS)) GO TO 10010
      JGTS=0
      L10012=    1
      GO TO 10012
10011 CONTINUE
      JOPR=19
      L10008=    2
      GO TO 10008
10013 CONTINUE
      GO TO 10009
10010 CONTINUE
      IF (.NOT.(ISTR(I).GE.ICHS(28).AND.ISTR(I).LE.ICHS(37)))
     +GO TO 10014
      CALL CVINT(JOPS,KSTP,ISTR,I,IESS)
      L10016=    1
      GO TO 10016
10015 CONTINUE
      I=I-1
      GO TO 10009
10014 CONTINUE
      INDL=1
      INDH=16
      MTCH=1
10017 CONTINUE
      ITCH=ISTR(I)
      IF (.NOT.(ITCH.GE.ILCA(1).AND.ITCH.LE.ILCA(26))) GO TO 10018
      ITCH=CHAR(ICHAR(ICHS( 2))+ICHAR(ITCH)-ICHAR(ILCA( 1)))
10018 CONTINUE
      INDL=INDEX1(ITCH,LOPS(1,MTCH),INDL,INDH)
      IF (.NOT.(INDL.EQ.0)) GO TO 10019
      GO TO 10021
10019 CONTINUE
10022 CONTINUE
      IF (.NOT.(ITCH.NE.LOPS(INDH,MTCH))) GO TO 10023
      INDH=INDH-1
      GO TO 10022
10023 CONTINUE
      MTCH=MTCH+1
      IF (MTCH.EQ.8.OR.LOPS(INDL,MTCH).EQ.ICHS(39)) GO TO 10024
      I=NINDX1(ICHS(39),ISTR,I+1,IESS)
      IF (.NOT.(I.EQ.0)) GO TO 10025
      GO TO 10021
10025 CONTINUE
      GO TO 10017
10024 CONTINUE
      IF (.NOT.(INDL.LE.11)) GO TO 10027
      JGTS=INDL*1000
      L10012=    2
      GO TO 10012
10028 CONTINUE
      JOPR=19
      L10008=    3
      GO TO 10008
10029 CONTINUE
      GO TO 10030
10027 CONTINUE
      IF (.NOT.(INDL.EQ.12.OR.INDL.EQ.13)) GO TO 10031
      JOPS=0
      L10016=    2
      GO TO 10016
10032 CONTINUE
      GO TO 10030
10031 CONTINUE
      IF (.NOT.(INDL.EQ.14)) GO TO 10033
      JOPR=13
      L10008=    4
      GO TO 10008
10034 CONTINUE
      GO TO 10030
10033 CONTINUE
      JOPS=1
      L10016=    3
      GO TO 10016
10035 CONTINUE
10030 CONTINUE
10009 CONTINUE
10005 CONTINUE
      GO TO 10036
10004 CONTINUE
      IF (.NOT.(ISTR(I).EQ.ICHS(42))) GO TO 10037
      J=NINDX1(ICHS(39),ISTR,I+1,IESS)
      IF (.NOT.(J.NE.0.AND.ISTR(J).EQ.ICHS(42))) GO TO 10038
      I=J
      JOPR=1
      GO TO 10039
10038 CONTINUE
      JOPR=3
10039 CONTINUE
      GO TO 10040
10037 CONTINUE
      IF (.NOT.(ISTR(I).EQ.ICHS(43))) GO TO 10041
      JOPR=4
      GO TO 10040
10041 CONTINUE
      IF (.NOT.(ISTR(I).EQ.ICHS(40))) GO TO 10042
      JOPR=5
      GO TO 10040
10042 CONTINUE
      IF (.NOT.(ISTR(I).EQ.ICHS(41))) GO TO 10043
      JOPR=6
      GO TO 10040
10043 CONTINUE
      IF (.NOT.(ISTR(I).EQ.ICHS(38))) GO TO 10044
      IF (.NOT.(NGTS.EQ.0.OR.IGTS(NGTS).EQ.0)) GO TO 10045
      GO TO 10021
10045 CONTINUE
      JOPR=17
      GO TO 10040
10044 CONTINUE
      IF (.NOT.(ISTR(I).EQ.ICHS(45).OR.ISTR(I).EQ.IEVT)) GO TO 10047
      IF (.NOT.(NGTS.EQ.0)) GO TO 10048
      GO TO 10021
10048 CONTINUE
      JOPR=20
      GO TO 10040
10047 CONTINUE
      INDL=1
      INDH=9
      MTCH=1
10050 CONTINUE
      ITCH=ISTR(I)
      IF (.NOT.(ITCH.GE.ILCA(1).AND.ITCH.LE.ILCA(26))) GO TO 10051
      ITCH=CHAR(ICHAR(ICHS( 2))+ICHAR(ITCH)-ICHAR(ILCA( 1)))
10051 CONTINUE
      INDL=INDEX1(ITCH,LOPR(1,MTCH),INDL,INDH)
      IF (.NOT.(INDL.EQ.0)) GO TO 10052
      GO TO 10021
10052 CONTINUE
10054 CONTINUE
      IF (.NOT.(ITCH.NE.LOPR(INDH,MTCH))) GO TO 10055
      INDH=INDH-1
      GO TO 10054
10055 CONTINUE
      MTCH=MTCH+1
      IF (MTCH.EQ.6.OR.LOPR(INDL,MTCH).EQ.ICHS(39)) GO TO 10056
      I=NINDX1(ICHS(39),ISTR,I+1,IESS)
      IF (.NOT.(I.EQ.0)) GO TO 10057
      GO TO 10021
10057 CONTINUE
      GO TO 10050
10056 CONTINUE
      JOPR=KOPR(INDL)
10040 CONTINUE
      L10060=    1
      GO TO 10060
10059 CONTINUE
      IF (.NOT.(JOPR.NE.20)) GO TO 10061
      L10008=    5
      GO TO 10008
10062 CONTINUE
10061 CONTINUE
10036 CONTINUE
10003 CONTINUE
      I=I+1
      GO TO 10001
10002 CONTINUE
      JOPR=18
      L10060=    2
      GO TO 10060
10063 CONTINUE
      IF (.NOT.(NOPR.NE.0.OR.NOPS.NE.1.OR.NGTS.NE.0)) GO TO 10064
      GO TO 10021
10064 CONTINUE
      CALL CVD(ABS(IOPS(1)),INCH,12)
      I=NINDX1(ICHS(39),INCH,1,12)
      J=IBSS
      IF (.NOT.(IOPS(1).LT.0)) GO TO 10066
      ISTR(J)=ICHS(41)
      J=J+1
10066 CONTINUE
      IF (.NOT.(J+13-I+LSTR-IESS.GT.MSTR)) GO TO 10067
      GO TO 10021
10067 CONTINUE
      K=MIN(13-I,IESS+1-J)
      CALL XMIT(K,INCH(I),ISTR(J))
      I=I+K
      J=J+K
      K=IESS+1-J
      IF (.NOT.(K.EQ.0)) GO TO 10069
      K=13-I
      IF (.NOT.(K.NE.0)) GO TO 10070
      L=LSTR+K
      M=LSTR
10071 CONTINUE
      IF (.NOT.(M.GE.IESS+1)) GO TO 10072
      ISTR(L)=ISTR(M)
      L=L-1
      M=M-1
      GO TO 10071
10072 CONTINUE
      LSTR=LSTR+K
      IESS=IESS+K
      CALL XMIT(K,INCH(I),ISTR(J))
10070 CONTINUE
      GO TO 10073
10069 CONTINUE
      CALL XMIT(LSTR-IESS,ISTR(IESS+1),ISTR(J))
      LSTR=LSTR-K
      IESS=IESS-K
10073 CONTINUE
      NSRD=NSRD+1
      RETURN
10008 CONTINUE
      NOPR=NOPR+1
      IF (.NOT.(NOPR.GT.32)) GO TO 10074
      GO TO 10021
10074 CONTINUE
      IOPR(NOPR)=JOPR
      IOOO=0
      GO TO (10007,10013,10029,10034,10062) , L10008
10016 CONTINUE
      NOPS=NOPS+1
      IF (.NOT.(NOPS.GT.64)) GO TO 10076
      GO TO 10021
10076 CONTINUE
      IOPS(NOPS)=JOPS
      IOOO=1
      GO TO (10015,10032,10035) , L10016
10012 CONTINUE
      NGTS=NGTS+1
      IF (.NOT.(NGTS.GT.16)) GO TO 10078
      GO TO 10021
10078 CONTINUE
      IGTS(NGTS)=JGTS
      GO TO (10011,10028) , L10012
10060 CONTINUE
      JOPL=IOPL(JOPR)
10080 CONTINUE
      IF (NOPR.EQ.0) GO TO 10081
      MOPR=IOPR(NOPR)
      IF (IOPL(MOPR).GT.JOPL) GO TO 10081
      GO TO (101,102,103,104,105,106,107,108,109,110,
     +       111,112,113,114,115,116,117,118,119,120) , MOPR
  101 CONTINUE
      IF (.NOT.(IOPS(NOPS).LT.0.OR.(IOPS(NOPS-1).EQ.0.AND.IOPS(NOPS).EQ.
     +0))) GO TO 10082
      GO TO 10021
10082 CONTINUE
      IOPS(NOPS-1)=IOPS(NOPS-1)**IOPS(NOPS)
      GO TO 198
  102 IOPS(NOPS)=-IOPS(NOPS)
      GO TO 199
  103 IOPS(NOPS-1)=IOPS(NOPS-1)*IOPS(NOPS)
      GO TO 198
  104 IOPS(NOPS-1)=IOPS(NOPS-1)/IOPS(NOPS)
      GO TO 198
  105 IOPS(NOPS-1)=IOPS(NOPS-1)+IOPS(NOPS)
      GO TO 198
  106 IOPS(NOPS-1)=IOPS(NOPS-1)-IOPS(NOPS)
      GO TO 198
  107 CONTINUE
      IF (.NOT.(IOPS(NOPS-1).LT.IOPS(NOPS))) GO TO 10084
      IOPS(NOPS-1)=1
      GO TO 10085
10084 CONTINUE
      IOPS(NOPS-1)=0
10085 CONTINUE
      GO TO 198
  108 CONTINUE
      IF (.NOT.(IOPS(NOPS-1).LE.IOPS(NOPS))) GO TO 10086
      IOPS(NOPS-1)=1
      GO TO 10087
10086 CONTINUE
      IOPS(NOPS-1)=0
10087 CONTINUE
      GO TO 198
  109 CONTINUE
      IF (.NOT.(IOPS(NOPS-1).GT.IOPS(NOPS))) GO TO 10088
      IOPS(NOPS-1)=1
      GO TO 10089
10088 CONTINUE
      IOPS(NOPS-1)=0
10089 CONTINUE
      GO TO 198
  110 CONTINUE
      IF (.NOT.(IOPS(NOPS-1).GE.IOPS(NOPS))) GO TO 10090
      IOPS(NOPS-1)=1
      GO TO 10091
10090 CONTINUE
      IOPS(NOPS-1)=0
10091 CONTINUE
      GO TO 198
  111 CONTINUE
      IF (.NOT.(IOPS(NOPS-1).EQ.IOPS(NOPS))) GO TO 10092
      IOPS(NOPS-1)=1
      GO TO 10093
10092 CONTINUE
      IOPS(NOPS-1)=0
10093 CONTINUE
      GO TO 198
  112 CONTINUE
      IF (.NOT.(IOPS(NOPS-1).NE.IOPS(NOPS))) GO TO 10094
      IOPS(NOPS-1)=1
      GO TO 10095
10094 CONTINUE
      IOPS(NOPS-1)=0
10095 CONTINUE
      GO TO 198
  113 IOPS(NOPS)=1-IOPS(NOPS)
      GO TO 199
  114 IOPS(NOPS-1)=IOPS(NOPS-1)*IOPS(NOPS)
      GO TO 198
  115 IOPS(NOPS-1)=MOD(IOPS(NOPS-1)+IOPS(NOPS),2)
      GO TO 198
  116 IOPS(NOPS-1)=IOPS(NOPS-1)+IOPS(NOPS)-IOPS(NOPS-1)*IOPS(NOPS)
      GO TO 198
  117 IGTS(NGTS)=IGTS(NGTS)+1
      GO TO 199
  118 CONTINUE
      GO TO 10021
  119 CONTINUE
      IF (.NOT.(NGTS.LE.0)) GO TO 10097
      GO TO 10021
10097 CONTINUE
      IF (.NOT.(IGTS(NGTS).NE.0)) GO TO 10099
      NFUN=IGTS(NGTS)/1000
      NAM1=MOD(IGTS(NGTS),1000)
      GO TO (201,202,203,204,205,206,207,208,209,210,211) , NFUN
  201 CONTINUE
      IF (.NOT.(NAM1.NE.0)) GO TO 10100
      GO TO 10021
10100 CONTINUE
      IOPS(NOPS)=ABS(IOPS(NOPS))
      GO TO 299
  202 CONTINUE
      GO TO 10021
  203 CONTINUE
      IF (.NOT.(NAM1.NE.0)) GO TO 10103
      GO TO 10021
10103 CONTINUE
      GO TO 10021
  204 CONTINUE
      IF (.NOT.(NAM1.NE.0)) GO TO 10106
      DO 10107 IARG=1,NAM1
      IOPS(NOPS-1)=MAX(IOPS(NOPS-1),IOPS(NOPS))
      NOPS=NOPS-1
10107 CONTINUE
10106 CONTINUE
      GO TO 299
  205 CONTINUE
      IF (.NOT.(NAM1.NE.0)) GO TO 10108
      DO 10109 IARG=1,NAM1
      IOPS(NOPS-1)=MIN(IOPS(NOPS-1),IOPS(NOPS))
      NOPS=NOPS-1
10109 CONTINUE
10108 CONTINUE
      GO TO 299
  206 CONTINUE
      IF (.NOT.(NAM1.NE.1)) GO TO 10110
      GO TO 10021
10110 CONTINUE
      IOPS(NOPS-1)=MOD(IOPS(NOPS-1),IOPS(NOPS))
      GO TO 298
  207 CONTINUE
      IF (.NOT.(NAM1.NE.0)) GO TO 10112
      GO TO 10021
10112 CONTINUE
      GO TO 10021
  208 CONTINUE
      GO TO 10021
  209 CONTINUE
      IF (.NOT.(NAM1.NE.1)) GO TO 10116
      GO TO 10021
10116 CONTINUE
      GO TO 10021
  210 CONTINUE
      IF (.NOT.(NAM1.NE.1)) GO TO 10119
      GO TO 10021
10119 CONTINUE
      IOPS(NOPS-1)=SIGN(IOPS(NOPS-1),IOPS(NOPS))
      GO TO 298
  211 CONTINUE
      GO TO 10021
  298 NOPS=NOPS-NAM1
10099 CONTINUE
  299 NGTS=NGTS-1
      JOPL=0
      GO TO 199
  120 CONTINUE
      GO TO 10021
  198 NOPS=NOPS-1
  199 NOPR=NOPR-1
      GO TO 10080
10081 CONTINUE
      GO TO (10059,10063) , L10060
10021 CONTINUE
      CALL ERRM(33)
      RETURN
      END
      SUBROUTINE SAVUSE(ISUB,KSVE)
      COMMON /IFTCM1/ DBLS,DSOK,IBIT,ICRB,ICRI,ICRJ,ICRK,ICRL,ICUB,IFIN,
     +                IFOC,IFOF,IFOI,IFON,IFOS,IFVA(16),IFVI,IGND,
     +          IGNI,IGNN,IINP,INCL,INCP,INCU,IOCC,IOCP,IOTC,IOTX,
     +          IOUT,IPOC,IPOF,IPOI,IPON,IPOS,ISAV,ISGT,ISRA,ISRL,
     +          ISRM,ISRP(1023),ISRS,ISRT,ISRX,ISTB,ISTC,ISTD,
     +      ISTE,ISTF,ISTK(96),ISTL,ISTS,ISUM,ISVI,ISVN,
     +ITYQ,IUAF,IUCF,KWOK,LNCD,NABT,NAMI(500),NAMP,                NAMQ,
     +NAMR,NCLI,NCLO,NCTO,NDNT,NERR,NEST,NLNE,NLNX,                NPGE
      COMMON /IFTCM2/ IADE(26),IBUF(80),ICHS(50),ICNC,ICRD(1701),
     +            IEVS,IEVT,IHDR(115),ILCA(26),INSB(81),
     +            ISRC(6000),ISTA(1327),ITBC,ITYP,IUSB(81),
     +    IXCC,NAMC(1000),PTYP
      CHARACTER*1     IADE,IBUF,ICHS,ICNC,ICRD,IEVS,IEVT,IHDR,ILCA,INSB,
     +                ISRC,ISTA,ITBC,ITYP,IUSB,IXCC,NAMC,PTYP
      LOGICAL         DBLS,DSOK,IOCC,ISRA,ISRX,KWOK
      ICR1=ICRL+1
      IF (ICR1+LNCD.GT.1701) ICR1=1
      ICR2=ICR1+LNCD
      IF (.NOT.(ICR1.LE.ICRI.AND.ICR2.GE.ICRI)) GO TO 10001
      CALL ERRM(7)
      KSVE=-1
      RETURN
10001 CONTINUE
      GO TO (101,102) , ISUB
  101 IF (ISVN.LE.0) CALL IFTRIO(3,ISAV,ICRD,0,0)
10002 CONTINUE
      IF (.NOT.(ISVI.LT.ISVN)) GO TO 10003
      CALL IFTRIO(1,ISAV,ICRD(ICR1),LNCD+1,IEOF)
      IF (.NOT.(IEOF.NE.0)) GO TO 10004
      CALL ERRM(12)
      KSVE=-1
      RETURN
10004 CONTINUE
      IF (ICRD(ICR2).EQ.ICHS( 6)) ISVI=ISVI+1
      GO TO 10002
10003 CONTINUE
      I=MIN(ISTB-ISTC+1,LNCD)
      CALL XMIT(I,ISTA(ISTC),ICRD(ICR1))
      I=ICR1+I
      CALL XMIT(I-ICR2,ICHS(39),ICRD(I))
      ICRD(ICR2)=ICHS(20)
      CALL IFTRIO(2,ISAV,ICRD(ICR1),LNCD+1,0)
      IF (ICRK.NE.(-1)) ICRD(ICRK)=ICRD(ICRL)
      ICRD(ICRL)=ICHS(39)
10005 CONTINUE
      IF (.NOT.(ICRK.EQ.(-1))) GO TO 10006
      KSVE=-1
      CALL ERRM(13)
      RETURN
10006 CONTINUE
      IF (.NOT.(ICRD(ICRK).EQ.ICHS(4).OR.ICRD(ICRK).EQ.ILCA(3).OR.ICRD(I
     +CRK).EQ.ICHS(47).OR.ICRD(ICRK).EQ.ICHS(42))) GO TO 10007
      IF (.NOT.((ICRD(ICRK+1).EQ.ICHS(6).OR.ICRD(ICRK+1).EQ.ILCA(5)).AND
     +.(ICRD(ICRK+2).EQ.ICHS(15).OR.ICRD(ICRK+2).EQ.ILCA(14)).AND.ICRD(I
     +CRK+4).NE.ICHS(10).AND.ICRD(ICRK+4).NE.ILCA(9))) GO TO 10008
      ICRD(ICRL)=ICHS( 6)
10008 CONTINUE
10007 CONTINUE
      CALL IFTRIO(2,ISAV,ICRD(ICRK),LNCD+1,0)
      IF (ICRD(ICRL).EQ.ICHS(6)) GO TO 10009
      CALL RDCRD(ICRD(ICRK),IEOF,0)
      IF (.NOT.(IEOF.NE.0)) GO TO 10010
      ICRK=-1
      ICRL=ICRJ
10010 CONTINUE
      GO TO 10005
10009 CONTINUE
      ICRK=0
      ICRL=ICRJ
      ISVN=ISVN+1
      ISVI=ISVN
      KSVE=0
      RETURN
  102 LENC=INDEX1(ICHS(38),ISTA(ISTC),1,ISTB-ISTC)-1
      IF (.NOT.(LENC.GT.0)) GO TO 10011
      LENC=LSTNB(ISTA(ISTC),1,LENC)
      GO TO 10012
10011 CONTINUE
      LENC=ISTB-ISTC
10012 CONTINUE
      LENC=MIN(LENC,LNCD)
      INUL=ICR1+LENC
      IF (.NOT.(LENC.EQ.0)) GO TO 10013
      CALL ERRM(17)
      KSVE=-1
      RETURN
10013 CONTINUE
      I = 1
      GO TO 10016
10014 CONTINUE
      I =I +1
10016 CONTINUE
      IF (I .GT.(ISVN)) GO TO 10015
      IF (.NOT.(ISVI.GE.ISVN)) GO TO 10017
      CALL IFTRIO(3,ISAV,ICRD,0,0)
      ISVI=0
10017 CONTINUE
10018 CONTINUE
      CALL IFTRIO(1,ISAV,ICRD(ICR1),LNCD+1,IEOF)
      IF (.NOT.(IEOF.NE.0)) GO TO 10019
      CALL ERRM(12)
      KSVE=-1
      RETURN
10019 CONTINUE
      IF (.NOT.(ICRD(ICR2).EQ.ICHS(20))) GO TO 10018
      ISVI=ISVI+1
      IF (.NOT.(NOTEQ(ISTA(ISTC),ICRD(ICR1),LENC).EQ.0)) GO TO 10020
      IF (.NOT.(LENC.EQ.LNCD.OR.ICRD(INUL).EQ.ICHS(50))) GO TO 10021
      KSVE=0
      RETURN
10021 CONTINUE
10020 CONTINUE
      GO TO 10014
10015 CONTINUE
      KSVE=-1
      CALL IFTRIO(3,ISAV,ICRD,0,0)
      ISVI=0
      RETURN
      END
      SUBROUTINE SETOPT
      COMMON /IFTCM1/ DBLS,DSOK,IBIT,ICRB,ICRI,ICRJ,ICRK,ICRL,ICUB,IFIN,
     +                IFOC,IFOF,IFOI,IFON,IFOS,IFVA(16),IFVI,IGND,
     +          IGNI,IGNN,IINP,INCL,INCP,INCU,IOCC,IOCP,IOTC,IOTX,
     +          IOUT,IPOC,IPOF,IPOI,IPON,IPOS,ISAV,ISGT,ISRA,ISRL,
     +          ISRM,ISRP(1023),ISRS,ISRT,ISRX,ISTB,ISTC,ISTD,
     +      ISTE,ISTF,ISTK(96),ISTL,ISTS,ISUM,ISVI,ISVN,
     +ITYQ,IUAF,IUCF,KWOK,LNCD,NABT,NAMI(500),NAMP,                NAMQ,
     +NAMR,NCLI,NCLO,NCTO,NDNT,NERR,NEST,NLNE,NLNX,                NPGE
      COMMON /IFTCM2/ IADE(26),IBUF(80),ICHS(50),ICNC,ICRD(1701),
     +            IEVS,IEVT,IHDR(115),ILCA(26),INSB(81),
     +            ISRC(6000),ISTA(1327),ITBC,ITYP,IUSB(81),
     +    IXCC,NAMC(1000),PTYP
      CHARACTER*1     IADE,IBUF,ICHS,ICNC,ICRD,IEVS,IEVT,IHDR,ILCA,INSB,
     +                ISRC,ISTA,ITBC,ITYP,IUSB,IXCC,NAMC,PTYP
      LOGICAL         DBLS,DSOK,IOCC,ISRA,ISRX,KWOK
      CHARACTER*1 ITC1,ITC2
      CHARACTER*1 ICHV
      INTEGER IINV
      LOGICAL ILOV
      CHARACTER*1 IKWD(2,28)
      DATA (IKWD(I, 1),I=1,2) / 'B' , 'I' /
      DATA (IKWD(I, 2),I=1,2) / 'C' , 'B' /
      DATA (IKWD(I, 3),I=1,2) / 'C' , 'C' /
      DATA (IKWD(I, 4),I=1,2) / 'D' , 'S' /
      DATA (IKWD(I, 5),I=1,2) / 'E' , 'S' /
      DATA (IKWD(I, 6),I=1,2) / 'E' , 'T' /
      DATA (IKWD(I, 7),I=1,2) / 'I' , 'F' /
      DATA (IKWD(I, 8),I=1,2) / 'I' , 'L' /
      DATA (IKWD(I, 9),I=1,2) / 'K' , 'W' /
      DATA (IKWD(I,10),I=1,2) / 'L' , 'I' /
      DATA (IKWD(I,11),I=1,2) / 'L' , 'R' /
      DATA (IKWD(I,12),I=1,2) / 'L' , 'S' /
      DATA (IKWD(I,13),I=1,2) / 'O' , 'C' /
      DATA (IKWD(I,14),I=1,2) / 'O' , 'F' /
      DATA (IKWD(I,15),I=1,2) / 'O' , 'I' /
      DATA (IKWD(I,16),I=1,2) / 'O' , 'N' /
      DATA (IKWD(I,17),I=1,2) / 'O' , 'S' /
      DATA (IKWD(I,18),I=1,2) / 'P' , 'C' /
      DATA (IKWD(I,19),I=1,2) / 'P' , 'F' /
      DATA (IKWD(I,20),I=1,2) / 'P' , 'I' /
      DATA (IKWD(I,21),I=1,2) / 'P' , 'N' /
      DATA (IKWD(I,22),I=1,2) / 'P' , 'R' /
      DATA (IKWD(I,23),I=1,2) / 'P' , 'S' /
      DATA (IKWD(I,24),I=1,2) / 'R' , 'S' /
      DATA (IKWD(I,25),I=1,2) / 'R' , 'T' /
      DATA (IKWD(I,26),I=1,2) / 'T' , 'C' /
      DATA (IKWD(I,27),I=1,2) / 'U' , 'C' /
      DATA (IKWD(I,28),I=1,2) / 'X' , 'C' /
10001 CONTINUE
      DO 10002 J=1,28
      ITC1=ISTA(ISTC)
      IF (.NOT.(ITC1.GE.ILCA(1).AND.ITC1.LE.ILCA(26))) GO TO 10003
      ITC1=CHAR(ICHAR(ICHS( 2))+ICHAR(ITC1)-ICHAR(ILCA( 1)))
10003 CONTINUE
      ITC2=ISTA(ISTC+1)
      IF (.NOT.(ITC2.GE.ILCA(1).AND.ITC2.LE.ILCA(26))) GO TO 10004
      ITC2=CHAR(ICHAR(ICHS( 2))+ICHAR(ITC2)-ICHAR(ILCA( 1)))
10004 CONTINUE
      IF (.NOT.(ITC1.EQ.IKWD(1,J).AND.ITC2.EQ.IKWD(2,J))) GO TO 10005
      NKWD=J
      ISTC=NINDX1(ICHS(39),ISTA,ISTC+2,ISTB)
      IF (.NOT.(ISTA(ISTC).NE.ICHS(46))) GO TO 10006
      ICHV=ICHS(50)
      IINV=1
      ILOV=.TRUE.
      GO TO 10007
10006 CONTINUE
      ISTC=NINDX1(ICHS(39),ISTA,ISTC+1,ISTB)
      IF (ISTA(ISTC).EQ.ICHS(50)) GO TO 198
      ICHV=ISTA(ISTC)
      IINV=0
      ILOV=.FALSE.
      IF (.NOT.(ISTA(ISTC).EQ.ICHS(41))) GO TO 10008
      ISTC=ISTC+1
      CALL CVINT(IINV,KSTP,ISTA,ISTC,ISTB)
      IINV=-IINV
      IF (IINV.NE.0) ILOV=.TRUE.
      GO TO 10009
10008 CONTINUE
      IF (.NOT.(ISTA(ISTC).GE.ICHS(28).AND.ISTA(ISTC).LE.ICHS(37)))
     +GO TO 10010
      CALL CVINT(IINV,KSTP,ISTA,ISTC,ISTB)
      IF (IINV.NE.0) ILOV=.TRUE.
      GO TO 10009
10010 CONTINUE
      IF (.NOT.(ISTA(ISTC).EQ.ICHS(21).OR.ISTA(ISTC).EQ.ILCA(20)))
     +GO TO 10011
      ISTC=NINDX1(ICHS(39),ISTA,ISTC+1,ISTB)
      IINV=1
      ILOV=.TRUE.
      GO TO 10009
10011 CONTINUE
      ISTC=NINDX1(ICHS(39),ISTA,ISTC+1,ISTB)
10009 CONTINUE
10007 CONTINUE
      GO TO (101,102,103,104,105,106,107,108,109,110,
     +       111,112,113,114,115,116,117,118,119,120,
     +       121,122,123,124,125,126,127,128        ) , NKWD
  101 CONTINUE
      IF (.NOT.(NEST.EQ.0)) GO TO 10012
      IBIT=IINV
      IF (IBIT.EQ.6.OR.IBIT.EQ.66) IBIT=0
10012 CONTINUE
  102 ICUB=IINV
      GO TO 199
  103 ICNC=ICHV
      GO TO 199
  104 DSOK=ILOV
      GO TO 199
  105 IEVS=ICHV
      IF (IEVT.EQ.ICHS(50)) IEVT=IEVS
      GO TO 199
  106 IEVT=ICHV
      GO TO 199
  107 IFIN=IINV
      GO TO 199
  108 NDNT=IINV
      GO TO 199
  109 KWOK=ILOV
      GO TO 199
  110 IGND=IINV
      GO TO 199
  111 ICRB=IINV
      GO TO 199
  112 IGNI=IINV
      IGNN=IINV
      GO TO 199
  113 IFOC=IINV
      GO TO 199
  114 IFOF=IINV
      GO TO 199
  115 IFOI=IINV
      GO TO 199
  116 IFON=IINV
      GO TO 199
  117 IFOS=IINV
      GO TO 199
  118 IPOC=IINV
      GO TO 199
  119 IPOF=IINV
      GO TO 199
  120 IPOI=IINV
      GO TO 199
  121 IPON=IINV
      GO TO 199
  122 CONTINUE
      IF (.NOT.(ILOV)) GO TO 10013
      IOUT=IOTX
      GO TO 10014
10013 CONTINUE
      IOUT=0
10014 CONTINUE
      GO TO 199
  123 IPOS=IINV
      GO TO 199
  124 ISRA=ILOV
      ISRX=ILOV
      GO TO 199
  125 ISRT=IINV
      GO TO 199
  126 ITBC=ICHV
      GO TO 199
  127 IUCF=IINV
      GO TO 199
  128 IXCC=ICHV
      GO TO 199
10005 CONTINUE
10002 CONTINUE
  198 CALL ERRM(27)
      ISTC=ISTC+1
      IF (ISTC.GE.ISTB) GO TO 10015
  199 ISTC=NINDX1(ICHS(39),ISTA,ISTC,ISTB)
      IF (ISTC.GE.ISTB) GO TO 10015
      IF (ISTA(ISTC).EQ.ICHS(38)) ISTC=NINDX1(ICHS(39),ISTA,ISTC+1,ISTB)
      GO TO 10001
10015 CONTINUE
      RETURN
      END
      SUBROUTINE SPCOUT(NLNS)
      COMMON /IFTCM1/ DBLS,DSOK,IBIT,ICRB,ICRI,ICRJ,ICRK,ICRL,ICUB,IFIN,
     +                IFOC,IFOF,IFOI,IFON,IFOS,IFVA(16),IFVI,IGND,
     +          IGNI,IGNN,IINP,INCL,INCP,INCU,IOCC,IOCP,IOTC,IOTX,
     +          IOUT,IPOC,IPOF,IPOI,IPON,IPOS,ISAV,ISGT,ISRA,ISRL,
     +          ISRM,ISRP(1023),ISRS,ISRT,ISRX,ISTB,ISTC,ISTD,
     +      ISTE,ISTF,ISTK(96),ISTL,ISTS,ISUM,ISVI,ISVN,
     +ITYQ,IUAF,IUCF,KWOK,LNCD,NABT,NAMI(500),NAMP,                NAMQ,
     +NAMR,NCLI,NCLO,NCTO,NDNT,NERR,NEST,NLNE,NLNX,                NPGE
      COMMON /IFTCM2/ IADE(26),IBUF(80),ICHS(50),ICNC,ICRD(1701),
     +            IEVS,IEVT,IHDR(115),ILCA(26),INSB(81),
     +            ISRC(6000),ISTA(1327),ITBC,ITYP,IUSB(81),
     +    IXCC,NAMC(1000),PTYP
      CHARACTER*1     IADE,IBUF,ICHS,ICNC,ICRD,IEVS,IEVT,IHDR,ILCA,INSB,
     +                ISRC,ISTA,ITBC,ITYP,IUSB,IXCC,NAMC,PTYP
      LOGICAL         DBLS,DSOK,IOCC,ISRA,ISRX,KWOK
      CHARACTER*1 ISKP(2)
      DATA ISKP / ' ' , ' ' /
      IF (.NOT.(IOUT.NE.0)) GO TO 10001
      NLNX=NLNX-NLNS
      IF (.NOT.(NLNX.LT.0)) GO TO 10002
      IF (.NOT.(NCLO.LE.1)) GO TO 10003
      CALL TYPHED(IHDR(2),NERR)
      NPGE=0
      DBLS=.FALSE.
      PTYP=ITYP
10003 CONTINUE
      NPGE=NPGE+1
      CALL CVD(NPGE,IHDR(111),5)
      CALL IFTRIO(2,IOUT,IHDR,115,0)
      CALL IFTRIO(2,IOUT,ISKP,2,0)
      NLNX=NLNE-NLNS
10002 CONTINUE
10001 CONTINUE
      END
      SUBROUTINE STAK(N0,N1,N2)
      COMMON /IFTCM1/ DBLS,DSOK,IBIT,ICRB,ICRI,ICRJ,ICRK,ICRL,ICUB,IFIN,
     +                IFOC,IFOF,IFOI,IFON,IFOS,IFVA(16),IFVI,IGND,
     +          IGNI,IGNN,IINP,INCL,INCP,INCU,IOCC,IOCP,IOTC,IOTX,
     +          IOUT,IPOC,IPOF,IPOI,IPON,IPOS,ISAV,ISGT,ISRA,ISRL,
     +          ISRM,ISRP(1023),ISRS,ISRT,ISRX,ISTB,ISTC,ISTD,
     +      ISTE,ISTF,ISTK(96),ISTL,ISTS,ISUM,ISVI,ISVN,
     +ITYQ,IUAF,IUCF,KWOK,LNCD,NABT,NAMI(500),NAMP,                NAMQ,
     +NAMR,NCLI,NCLO,NCTO,NDNT,NERR,NEST,NLNE,NLNX,                NPGE
      COMMON /IFTCM2/ IADE(26),IBUF(80),ICHS(50),ICNC,ICRD(1701),
     +            IEVS,IEVT,IHDR(115),ILCA(26),INSB(81),
     +            ISRC(6000),ISTA(1327),ITBC,ITYP,IUSB(81),
     +    IXCC,NAMC(1000),PTYP
      CHARACTER*1     IADE,IBUF,ICHS,ICNC,ICRD,IEVS,IEVT,IHDR,ILCA,INSB,
     +                ISRC,ISTA,ITBC,ITYP,IUSB,IXCC,NAMC,PTYP
      LOGICAL         DBLS,DSOK,IOCC,ISRA,ISRX,KWOK
      IF (N0.LT.0) RETURN
      ISTL=ISTL+3
      IF (.NOT.(ISTL.GT.96)) GO TO 10001
      CALL ERRM(30)
      CALL NGEXIT(NERR)
      STOP
10001 CONTINUE
      ISTK(ISTL-2)=N0
      ISTK(ISTL-1)=N1
      ISTK(ISTL  )=N2
      RETURN
      END
      SUBROUTINE STAKFI(N0,N1,N2,N3)
      COMMON /IFTCM1/ DBLS,DSOK,IBIT,ICRB,ICRI,ICRJ,ICRK,ICRL,ICUB,IFIN,
     +                IFOC,IFOF,IFOI,IFON,IFOS,IFVA(16),IFVI,IGND,
     +          IGNI,IGNN,IINP,INCL,INCP,INCU,IOCC,IOCP,IOTC,IOTX,
     +          IOUT,IPOC,IPOF,IPOI,IPON,IPOS,ISAV,ISGT,ISRA,ISRL,
     +          ISRM,ISRP(1023),ISRS,ISRT,ISRX,ISTB,ISTC,ISTD,
     +      ISTE,ISTF,ISTK(96),ISTL,ISTS,ISUM,ISVI,ISVN,
     +ITYQ,IUAF,IUCF,KWOK,LNCD,NABT,NAMI(500),NAMP,                NAMQ,
     +NAMR,NCLI,NCLO,NCTO,NDNT,NERR,NEST,NLNE,NLNX,                NPGE
      COMMON /IFTCM2/ IADE(26),IBUF(80),ICHS(50),ICNC,ICRD(1701),
     +            IEVS,IEVT,IHDR(115),ILCA(26),INSB(81),
     +            ISRC(6000),ISTA(1327),ITBC,ITYP,IUSB(81),
     +    IXCC,NAMC(1000),PTYP
      CHARACTER*1     IADE,IBUF,ICHS,ICNC,ICRD,IEVS,IEVT,IHDR,ILCA,INSB,
     +                ISRC,ISTA,ITBC,ITYP,IUSB,IXCC,NAMC,PTYP
      LOGICAL         DBLS,DSOK,IOCC,ISRA,ISRX,KWOK
      ISTP=ISTL-2
      N3=1
10001 CONTINUE
      IF (.NOT.(ISTP.GT.0)) GO TO 10002
      IF (.NOT.(N0.EQ.ISTK(ISTP))) GO TO 10003
      N1=ISTK(ISTP+1)
      N2=ISTK(ISTP+2)
      RETURN
10003 CONTINUE
      ISTP=ISTP-3
      N3=N3+1
      GO TO 10001
10002 CONTINUE
      N1=0
      N2=0
      N3=0
      RETURN
      END
      SUBROUTINE TYPERR(NMSG,IMSG,LMSG)
      CHARACTER*1 IMSG(LMSG)
      COMMON /IFTCM1/ DBLS,DSOK,IBIT,ICRB,ICRI,ICRJ,ICRK,ICRL,ICUB,IFIN,
     +                IFOC,IFOF,IFOI,IFON,IFOS,IFVA(16),IFVI,IGND,
     +          IGNI,IGNN,IINP,INCL,INCP,INCU,IOCC,IOCP,IOTC,IOTX,
     +          IOUT,IPOC,IPOF,IPOI,IPON,IPOS,ISAV,ISGT,ISRA,ISRL,
     +          ISRM,ISRP(1023),ISRS,ISRT,ISRX,ISTB,ISTC,ISTD,
     +      ISTE,ISTF,ISTK(96),ISTL,ISTS,ISUM,ISVI,ISVN,
     +ITYQ,IUAF,IUCF,KWOK,LNCD,NABT,NAMI(500),NAMP,                NAMQ,
     +NAMR,NCLI,NCLO,NCTO,NDNT,NERR,NEST,NLNE,NLNX,                NPGE
      COMMON /IFTCM2/ IADE(26),IBUF(80),ICHS(50),ICNC,ICRD(1701),
     +            IEVS,IEVT,IHDR(115),ILCA(26),INSB(81),
     +            ISRC(6000),ISTA(1327),ITBC,ITYP,IUSB(81),
     +    IXCC,NAMC(1000),PTYP
      CHARACTER*1     IADE,IBUF,ICHS,ICNC,ICRD,IEVS,IEVT,IHDR,ILCA,INSB,
     +                ISRC,ISTA,ITBC,ITYP,IUSB,IXCC,NAMC,PTYP
      LOGICAL         DBLS,DSOK,IOCC,ISRA,ISRX,KWOK
      IF (.NOT.(ISUM.NE.0)) GO TO 10001
      WRITE(0,1001) NMSG,(IMSG(I),I=2,LMSG)
      WRITE(0,1002) (IHDR(I),I=29,81)
      ITMP=ICRI+52
      WRITE(0,1003) NCTO,NCLO,(ICRD(I),I=ICRI,ITMP)
10001 CONTINUE
      RETURN
 1001 FORMAT ('ERROR MESSAGE NUMBER',I3,' - ',53A1)
 1002 FORMAT ('FIRST CARD OF ROUTINE   - '   ,53A1)
 1003 FORMAT ('CARD',I5,' - ',I5,' LOCAL - ' ,53A1)
      END
      SUBROUTINE TYPHED(HEAD,NERR)
      CHARACTER*1 HEAD(1)
      RETURN
      END
      SUBROUTINE UNSTAK(N0,N1,N2)
      COMMON /IFTCM1/ DBLS,DSOK,IBIT,ICRB,ICRI,ICRJ,ICRK,ICRL,ICUB,IFIN,
     +                IFOC,IFOF,IFOI,IFON,IFOS,IFVA(16),IFVI,IGND,
     +          IGNI,IGNN,IINP,INCL,INCP,INCU,IOCC,IOCP,IOTC,IOTX,
     +          IOUT,IPOC,IPOF,IPOI,IPON,IPOS,ISAV,ISGT,ISRA,ISRL,
     +          ISRM,ISRP(1023),ISRS,ISRT,ISRX,ISTB,ISTC,ISTD,
     +      ISTE,ISTF,ISTK(96),ISTL,ISTS,ISUM,ISVI,ISVN,
     +ITYQ,IUAF,IUCF,KWOK,LNCD,NABT,NAMI(500),NAMP,                NAMQ,
     +NAMR,NCLI,NCLO,NCTO,NDNT,NERR,NEST,NLNE,NLNX,                NPGE
      COMMON /IFTCM2/ IADE(26),IBUF(80),ICHS(50),ICNC,ICRD(1701),
     +            IEVS,IEVT,IHDR(115),ILCA(26),INSB(81),
     +            ISRC(6000),ISTA(1327),ITBC,ITYP,IUSB(81),
     +    IXCC,NAMC(1000),PTYP
      CHARACTER*1     IADE,IBUF,ICHS,ICNC,ICRD,IEVS,IEVT,IHDR,ILCA,INSB,
     +                ISRC,ISTA,ITBC,ITYP,IUSB,IXCC,NAMC,PTYP
      LOGICAL         DBLS,DSOK,IOCC,ISRA,ISRX,KWOK
      IF (.NOT.(ISTL.LE.0)) GO TO 10001
      N0=-1
      GO TO 10002
10001 CONTINUE
      N0=ISTK(ISTL-2)
      N1=ISTK(ISTL-1)
      N2=ISTK(ISTL  )
      ISTL=ISTL-3
10002 CONTINUE
      RETURN
      END
      SUBROUTINE UNTIL
      COMMON /IFTCM1/ DBLS,DSOK,IBIT,ICRB,ICRI,ICRJ,ICRK,ICRL,ICUB,IFIN,
     +                IFOC,IFOF,IFOI,IFON,IFOS,IFVA(16),IFVI,IGND,
     +          IGNI,IGNN,IINP,INCL,INCP,INCU,IOCC,IOCP,IOTC,IOTX,
     +          IOUT,IPOC,IPOF,IPOI,IPON,IPOS,ISAV,ISGT,ISRA,ISRL,
     +          ISRM,ISRP(1023),ISRS,ISRT,ISRX,ISTB,ISTC,ISTD,
     +      ISTE,ISTF,ISTK(96),ISTL,ISTS,ISUM,ISVI,ISVN,
     +ITYQ,IUAF,IUCF,KWOK,LNCD,NABT,NAMI(500),NAMP,                NAMQ,
     +NAMR,NCLI,NCLO,NCTO,NDNT,NERR,NEST,NLNE,NLNX,                NPGE
      COMMON /IFTCM2/ IADE(26),IBUF(80),ICHS(50),ICNC,ICRD(1701),
     +            IEVS,IEVT,IHDR(115),ILCA(26),INSB(81),
     +            ISRC(6000),ISTA(1327),ITBC,ITYP,IUSB(81),
     +    IXCC,NAMC(1000),PTYP
      CHARACTER*1     IADE,IBUF,ICHS,ICNC,ICRD,IEVS,IEVT,IHDR,ILCA,INSB,
     +                ISRC,ISTA,ITBC,ITYP,IUSB,IXCC,NAMC,PTYP
      LOGICAL         DBLS,DSOK,IOCC,ISRA,ISRX,KWOK
      NEST=NEST-1
      CALL CRDOUT
      CALL LABOUT
      CALL UNSTAK(N0,N1,N2)
      IF (.NOT.(N0.EQ.8)) GO TO 10001
      CALL IFNOT(ISTA,ISTD,ISTE,N1)
      GO TO 10002
10001 CONTINUE
      CALL ERRM(19)
      CALL STAK(N0,N1,N2)
      NEST=NEST+1
10002 CONTINUE
      RETURN
      END
      SUBROUTINE WHILE
      COMMON /IFTCM1/ DBLS,DSOK,IBIT,ICRB,ICRI,ICRJ,ICRK,ICRL,ICUB,IFIN,
     +                IFOC,IFOF,IFOI,IFON,IFOS,IFVA(16),IFVI,IGND,
     +          IGNI,IGNN,IINP,INCL,INCP,INCU,IOCC,IOCP,IOTC,IOTX,
     +          IOUT,IPOC,IPOF,IPOI,IPON,IPOS,ISAV,ISGT,ISRA,ISRL,
     +          ISRM,ISRP(1023),ISRS,ISRT,ISRX,ISTB,ISTC,ISTD,
     +      ISTE,ISTF,ISTK(96),ISTL,ISTS,ISUM,ISVI,ISVN,
     +ITYQ,IUAF,IUCF,KWOK,LNCD,NABT,NAMI(500),NAMP,                NAMQ,
     +NAMR,NCLI,NCLO,NCTO,NDNT,NERR,NEST,NLNE,NLNX,                NPGE
      COMMON /IFTCM2/ IADE(26),IBUF(80),ICHS(50),ICNC,ICRD(1701),
     +            IEVS,IEVT,IHDR(115),ILCA(26),INSB(81),
     +            ISRC(6000),ISTA(1327),ITBC,ITYP,IUSB(81),
     +    IXCC,NAMC(1000),PTYP
      CHARACTER*1     IADE,IBUF,ICHS,ICNC,ICRD,IEVS,IEVT,IHDR,ILCA,INSB,
     +                ISRC,ISTA,ITBC,ITYP,IUSB,IXCC,NAMC,PTYP
      LOGICAL         DBLS,DSOK,IOCC,ISRA,ISRX,KWOK
      CALL CRDOUT
      CALL LABOUT
      CALL NEWNUM(N1)
      CALL NEWNUM(N2)
      CALL STAK(4,N1,N2)
      CALL CONTCD(N1)
      CALL IFNOT(ISTA,ISTD,ISTE,N2)
      NEST=NEST+1
      RETURN
      END
      SUBROUTINE XMIT(N,IS,ID)
      CHARACTER*1 IS(1),ID(1)
      IF (N.EQ.0) RETURN
      IF (N.GT.0) GO TO 101
      M=-N
      DO 10001 I=1,M
      ID(I)=IS(1)
10001 CONTINUE
      RETURN
  101 CONTINUE
      DO 10002 I=1,N
      ID(I)=IS(I)
10002 CONTINUE
      RETURN
      END

C
C $Id: kupx.f,v 1.7 2008-07-27 00:17:24 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      FUNCTION KUPX (RX)
C
C Given an X coordinate RX in the user system, KUPX(RX) is an X
C coordinate in the plotter system.
C
      COMMON /IUTLCM/ LL,MI,MX,MY,IU(96)
      SAVE /IUTLCM/
      DIMENSION WD(4),VP(4)
      CALL GQCNTN (IE,NT)
      IF (IE.NE.0) THEN
        CALL SETER ('KUPX - ERROR EXIT FROM GQCNTN',1,1)
        KUPX=0
        RETURN
      END IF
      CALL GQNT (NT,IE,WD,VP)
      IF (IE.NE.0) THEN
        CALL SETER ('KUPX - ERROR EXIT FROM GQNT',2,1)
        KUPX=0
        RETURN
      END IF
      I=1
      IF (MI.GE.3) I=2
      IF (LL.LE.2) THEN
        KUPX=1+INT(((RX-WD(I))/(WD(3-I)-WD(I))*(VP(2)-VP(1))+VP(1))*
     +             (2.**MX-1.))
      ELSE
        KUPX=1+INT(((ALOG10(RX)-WD(I))/(WD(3-I)-WD(I))*(VP(2)-VP(1))+
     +             VP(1))*(2.**MX-1.))
      ENDIF
      RETURN
      END

C
C $Id: cmfy.f,v 1.7 2008-07-27 00:17:23 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      FUNCTION CMFY (IY)
C
C Given a Y coordinate IY in the metacode system, CMFY(IY) is a Y
C coordinate in the fractional system.
C
      CMFY=REAL(IY)/32767.
      RETURN
      END

C
C      $Id: nm02f.f,v 1.6 2010-03-15 22:49:24 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                       C
C                Copyright (C)  1997                                    C
C        University Corporation for Atmospheric Research                C
C                All Rights Reserved                                    C
C                                                                       C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C  File:       nm02f.c
C
C  Author:     Mary Haley (taken from one of Fred Clare's examples)
C          National Center for Atmospheric Research
C          PO 3000, Boulder, Colorado
C
C  Date:       Mon Dec 22 11:46:43 MST 1997
C
C  Description: Simple example of natural neighbor linear interpolation.
C
      external NhlFAppClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFCairoWindowWorkstationClass
      external NhlFscalarFieldClass
      external NhlFcontourPlotClass

      parameter(Npts=6,NumXOut=21,NumYOut=21)
      parameter(IDIM=2*NumXOut*NumYOut)


      real  xo(NumXOut), yo(NumYOut), zo(NumXOut,NumYOut)
      real x(Npts),y(Npts),z(Npts)
      data x/0.00, 1.00, 0.00, 1.00, 0.40, 0.75/
      data y/0.00, 0.00, 1.00, 1.00, 0.20, 0.65/
      data z/0.00, 0.00, 0.00, 0.00, 1.25, 0.80/
      dimension iwork(IDIM)
      real xc, yc
      integer ier
      integer appid,wid,gkswid
      integer srlist, grlist
      integer i
      character*7  wks_type
C
C Default is to display output to an NCGM workstation.
C
      wks_type = "ncgm"
C
C Initialize the high level utility library
C
      call NhlFInitialize
C
C Create an application context. Set the app dir to the current directory
C so the application looks for a resource file in the working directory.
C In this example the resource file supplies the plot title only.
C
      call NhlFRLCreate(srlist,'setrl')
      call NhlFRLCreate(grlist,'getrl')

      call NhlFRLClear(srlist)
      call NhlFRLSetString(srlist,'appDefaultParent','True',ierr)
      call NhlFRLSetString(srlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'nm02',NhlFAppClass,0,srlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkMetaName','./nm02f.ncgm',ierr)
         call NhlFCreate(wid,'nm01Work',
     +        NhlFNcgmWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X11 workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkPause','True',ierr)
         call NhlFCreate(wid,'nm01Work',
     +        NhlFCairoWindowWorkstationClass,
     +        0,srlist,ierr)
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PostScript workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkPSFileName','./nm02f.ps',ierr)
         call NhlFCreate(wid,'nm01Work',
     +        NhlFPSWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkPDFFileName','./nm02f.pdf',ierr)
         call NhlFCreate(wid,'nm01Work',
     +        NhlFPDFWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkFileName','./nm02f',ierr)
         call NhlFRLSetString(srlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(wid,'nm01Work',
     +        NhlFCairoPSPDFWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkFileName','./nm02f',ierr)
         call NhlFRLSetString(srlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(wid,'nm01Work',
     +        NhlFCairoImageWorkstationClass,0,srlist,ierr)
      endif

C
C  Define the output grid.
C
      xmin = 0.
      xmax = 1.
      xc = (xmax-xmin)/(NumXOut-1.) 
      do 20 i=1,NumXOut
        xo(i) = xmin+real(i-1) * xc
 20   continue

      ymin = 0.
      ymax = 1.
      yc = (ymax-ymin)/(NumYOut-1.) 
      do 30 i=1,NumYOut
        yo(i) = ymin+real(i-1) * yc
 30   continue

      call nnseti('IGR',1)
      call natgrids(Npts, x, y, z, NumXOut, NumYOut, xo, yo, zo, ier)
C
C Get Workstation ID.
C
      call NhlFRLClear(grlist)
      call NhlFRLGetInteger(grlist,'wkGksWorkId',gkswid,ierr)
      call NhlFGetValues(wid,grlist,ierr)
C
C There's no HLU object for surface plots yet, so we need to call the
C LLUs to get a surface plot.
C
      call gacwk (gkswid)
      call drwsrf (gkswid,NumXOut,NumYOut,xo,yo,zo,15.,-25.,90.,iwork)
      call gdawk (gkswid)
C
C NhlDestroy destroys the given id and all of its children.
C
      call NhlFDestroy(wid,ierr)
C
C Restores state.
C
      call NhlFClose
      stop
      end

      subroutine drwsrf(wkid,nx,ny,x,y,z,s1,s2,s3,iwk)
C
C  Procedure DRWSRF uses the NCAR Graphics function SRFACE to
C  draw a surface plot of the data values in Z.
C 
C  The point of observation is calculated from the 3D coordinate
C  (S1, S2, S3); the point looked at is the center of the surface.
C 
C   NX     -  Dimension of the X-axis variable X.
C   NY     -  Dimension of the Y-axis variable Y.
C   X      -  An array of X-axis values.
C   Y      -  An array of Y-axis values.
C   Z      -  An array dimensioned for NX x NY containing data
C             values for each (X,Y) coordinate.
C   S1     -  X value for the eye position.
C   S2     -  Y value for the eye position.
C   S3     -  Z value for the eye position.
C   IWK    -  Work space dimensioned for at least 2*NX*NY.
C 
C  
      dimension x(nx),y(ny),z(nx,ny),iwk(*)
      integer wkid
      dimension S(6)
c
c  Find the extreme values.
c
      xmn =  x(1)
      xmx =  x(1)
      ymn =  y(1)
      ymx =  y(1)
      zmn =  z(1,1)
      zmx =  z(1,1)

      do 10 i=2,nx
        xmn = min(xmn,x(i))
        xmx = max(xmx,x(i))
   10 continue

      do 11 i=1,ny
        ymn = min(ymn,y(i))
        ymx = max(ymx,y(i))
   11 continue

      do 12 i=1,nx
        do 13 j=1,ny
          zmn = min(zmn,z(i,j))
          zmx = max(zmx,z(i,j))
   13   continue
   12 continue

      if (s1.eq.0. .and. s2.eq.0. .and. s3.eq.0.) then
        st1 = -3.
        st2 = -1.5
        st3 = 0.75
      else
        st1 = s1
        st2 = s2
        st3 = s3
      endif
      s(1) = 5.*st1*(xmx-xmn)
      s(2) = 5.*st2*(ymx-ymn)
      s(3) = 5.*st3*(zmx-zmn)
      s(4) = 0.5*(xmx-xmn)
      s(5) = 0.5*(ymx-ymn)
      s(6) = 0.5*(zmx-zmn)
C
C Set foreground/background colors
C
      call gscr(wkid, 0, 1.00, 1.00, 1.00)
      call gscr(wkid, 1, 0.00, 0.00, 0.00)

      call srface (x,y,z,iwk,nx,nx,ny,s,0.)

      return
      end

      subroutine numrun2(nx, ntim, xin, optknt, xknt )
      implicit none
C
C knt = dim_numrun_n( x, optknt, n)
C                                                      INPUT
      integer  nx, ntim, optknt, optend
      integer  xin(nx,ntim) 
C                                                      OUTPUT
      integer  xknt(nx,ntim) 
C                                                      LOCAL 
      integer  n, j, t, knt, yin(0:nx+1)

      if (optknt.eq.0) then
          do t=1,ntim
            do n=1,nx
               xknt(n,t) = 0
              do j=1,nx-n+1
                 if (all(xin(j:j+n-1,t).eq.1)) then
                     xknt(n,t) = xknt(n,t)+1
                 end if
              end do
            end do
          end do

          return
      end if

c count unique sequences: pad ending with 0 to force a count

      if (optknt.eq.1) then
          do t=1,ntim

             yin(0)    = 0
             yin(1:nx) = xin(:,t)
             yin(nx+1) = 0

            do n=1,nx
               xknt(n,t) = 0
              do j=1,nx-n+1
                 if (yin(j-1).eq.0          .and. 
     +               all(yin(j:j+n-1).eq.1) .and.
     +               yin(j+n).eq.0        ) then
                     xknt(n,t) = xknt(n,t)+1
                 end if
              end do
            end do
          end do
          return
      end if

      return
      end
C ------
      subroutine numrun1(nx, xin, optknt, xknt )
      implicit none
C
C knt = dim_numrun_n( x, optknt, n)
C                                                      INPUT
      integer  nx, optknt, optend
      integer  xin(nx) 
C                                                      OUTPUT
      integer  xknt(nx) 
C                                                      LOCAL 
      integer  n, j, knt, yin(0:nx+1)

      if (optknt.eq.0) then
          do n=1,nx
             xknt(n) = 0
            do j=1,nx-n+1
               if (all(xin(j:j+n-1).eq.1)) then
                   xknt(n) = xknt(n)+1
               end if
            end do
          end do
          return
      end if

c count unique sequences: pad ending with 0 to force a count

      if (optknt.eq.1) then
          yin(0)    = 0
          yin(1:nx) = xin
          yin(nx+1) = 0

          do n=1,nx
             xknt(n) = 0
            do j=1,nx-n+1
               if (yin(j-1).eq.0          .and. 
     +             all(yin(j:j+n-1).eq.1) .and.
     +             yin(j+n).eq.0        ) then
                   xknt(n) = xknt(n)+1
               end if
            end do
          end do
          return
      end if

      return
      end

      SUBROUTINE ZLAR1V( N, B1, BN, SIGMA, D, L, LD, LLD, GERSCH, Z,
     $                   ZTZ, MINGMA, R, ISUPPZ, WORK )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      INTEGER            B1, BN, N, R
      DOUBLE PRECISION   MINGMA, SIGMA, ZTZ
*     ..
*     .. Array Arguments ..
      INTEGER            ISUPPZ( * )
      DOUBLE PRECISION   D( * ), GERSCH( * ), L( * ), LD( * ), LLD( * ),
     $                   WORK( * )
      COMPLEX*16         Z( * )
*     ..
*
*  Purpose
*  =======
*
*  ZLAR1V computes the (scaled) r-th column of the inverse of
*  the sumbmatrix in rows B1 through BN of the tridiagonal matrix
*  L D L^T - sigma I. The following steps accomplish this computation :
*  (a) Stationary qd transform,  L D L^T - sigma I = L(+) D(+) L(+)^T,
*  (b) Progressive qd transform, L D L^T - sigma I = U(-) D(-) U(-)^T,
*  (c) Computation of the diagonal elements of the inverse of
*      L D L^T - sigma I by combining the above transforms, and choosing
*      r as the index where the diagonal of the inverse is (one of the)
*      largest in magnitude.
*  (d) Computation of the (scaled) r-th column of the inverse using the
*      twisted factorization obtained by combining the top part of the
*      the stationary and the bottom part of the progressive transform.
*
*  Arguments
*  =========
*
*  N        (input) INTEGER
*           The order of the matrix L D L^T.
*
*  B1       (input) INTEGER
*           First index of the submatrix of L D L^T.
*
*  BN       (input) INTEGER
*           Last index of the submatrix of L D L^T.
*
*  SIGMA    (input) DOUBLE PRECISION
*           The shift. Initially, when R = 0, SIGMA should be a good
*           approximation to an eigenvalue of L D L^T.
*
*  L        (input) DOUBLE PRECISION array, dimension (N-1)
*           The (n-1) subdiagonal elements of the unit bidiagonal matrix
*           L, in elements 1 to N-1.
*
*  D        (input) DOUBLE PRECISION array, dimension (N)
*           The n diagonal elements of the diagonal matrix D.
*
*  LD       (input) DOUBLE PRECISION array, dimension (N-1)
*           The n-1 elements L(i)*D(i).
*
*  LLD      (input) DOUBLE PRECISION array, dimension (N-1)
*           The n-1 elements L(i)*L(i)*D(i).
*
*  GERSCH   (input) DOUBLE PRECISION array, dimension (2*N)
*           The n Gerschgorin intervals. These are used to restrict
*           the initial search for R, when R is input as 0.
*
*  Z        (output) COMPLEX*16 array, dimension (N)
*           The (scaled) r-th column of the inverse. Z(R) is returned
*           to be 1.
*
*  ZTZ      (output) DOUBLE PRECISION
*           The square of the norm of Z.
*
*  MINGMA   (output) DOUBLE PRECISION
*           The reciprocal of the largest (in magnitude) diagonal
*           element of the inverse of L D L^T - sigma I.
*
*  R        (input/output) INTEGER
*           Initially, R should be input to be 0 and is then output as
*           the index where the diagonal element of the inverse is
*           largest in magnitude. In later iterations, this same value
*           of R should be input.
*
*  ISUPPZ   (output) INTEGER array, dimension (2)
*           The support of the vector in Z, i.e., the vector Z is
*           nonzero only in elements ISUPPZ(1) through ISUPPZ( 2 ).
*
*  WORK     (workspace) DOUBLE PRECISION array, dimension (4*N)
*
*  Further Details
*  ===============
*
*  Based on contributions by
*     Inderjit Dhillon, IBM Almaden, USA
*     Osni Marques, LBNL/NERSC, USA
*     Ken Stanley, Computer Science Division, University of
*       California at Berkeley, USA
*
*  =====================================================================
*
*     .. Parameters ..
      INTEGER            BLKSIZ
      PARAMETER          ( BLKSIZ = 32 )
      DOUBLE PRECISION   ZERO, ONE
      PARAMETER          ( ZERO = 0.0D0, ONE = 1.0D0 )
      COMPLEX*16         CONE
      PARAMETER          ( CONE = ( 1.0D0, 0.0D0 ) )
*     ..
*     .. Local Scalars ..
      LOGICAL            SAWNAN
      INTEGER            FROM, I, INDP, INDS, INDUMN, J, R1, R2, TO
      DOUBLE PRECISION   DMINUS, DPLUS, EPS, S, TMP
*     ..
*     .. External Functions ..
      DOUBLE PRECISION   DLAMCH
      EXTERNAL           DLAMCH
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, DBLE, MAX, MIN
*     ..
*     .. Executable Statements ..
*
      EPS = DLAMCH( 'Precision' )
      IF( R.EQ.0 ) THEN
*
*        Eliminate the top and bottom indices from the possible values
*        of R where the desired eigenvector is largest in magnitude.
*
         R1 = B1
         DO 10 I = B1, BN
            IF( SIGMA.GE.GERSCH( 2*I-1 ) .OR. SIGMA.LE.GERSCH( 2*I ) )
     $           THEN
               R1 = I
               GO TO 20
            END IF
   10    CONTINUE
   20    CONTINUE
         R2 = BN
         DO 30 I = BN, B1, -1
            IF( SIGMA.GE.GERSCH( 2*I-1 ) .OR. SIGMA.LE.GERSCH( 2*I ) )
     $           THEN
               R2 = I
               GO TO 40
            END IF
   30    CONTINUE
   40    CONTINUE
      ELSE
         R1 = R
         R2 = R
      END IF
*
      INDUMN = N
      INDS = 2*N + 1
      INDP = 3*N + 1
      SAWNAN = .FALSE.
*
*     Compute the stationary transform (using the differential form)
*     untill the index R2
*
      IF( B1.EQ.1 ) THEN
         WORK( INDS ) = ZERO
      ELSE
         WORK( INDS ) = LLD( B1-1 )
      END IF
      S = WORK( INDS ) - SIGMA
      DO 50 I = B1, R2 - 1
         DPLUS = D( I ) + S
         WORK( I ) = LD( I ) / DPLUS
         WORK( INDS+I ) = S*WORK( I )*L( I )
         S = WORK( INDS+I ) - SIGMA
   50 CONTINUE
*
      IF( .NOT.( S.GT.ZERO .OR. S.LT.ONE ) ) THEN
*
*        Run a slower version of the above loop if a NaN is detected
*
         SAWNAN = .TRUE.
         J = B1 + 1
   60    CONTINUE
         IF( WORK( INDS+J ).GT.ZERO .OR. WORK( INDS+J ).LT.ONE ) THEN
            J = J + 1
            GO TO 60
         END IF
         WORK( INDS+J ) = LLD( J )
         S = WORK( INDS+J ) - SIGMA
         DO 70 I = J + 1, R2 - 1
            DPLUS = D( I ) + S
            WORK( I ) = LD( I ) / DPLUS
            IF( WORK( I ).EQ.ZERO ) THEN
               WORK( INDS+I ) = LLD( I )
            ELSE
               WORK( INDS+I ) = S*WORK( I )*L( I )
            END IF
            S = WORK( INDS+I ) - SIGMA
   70    CONTINUE
      END IF
      WORK( INDP+BN-1 ) = D( BN ) - SIGMA
      DO 80 I = BN - 1, R1, -1
         DMINUS = LLD( I ) + WORK( INDP+I )
         TMP = D( I ) / DMINUS
         WORK( INDUMN+I ) = L( I )*TMP
         WORK( INDP+I-1 ) = WORK( INDP+I )*TMP - SIGMA
   80 CONTINUE
      TMP = WORK( INDP+R1-1 )
      IF( .NOT.( TMP.GT.ZERO .OR. TMP.LT.ONE ) ) THEN
*
*        Run a slower version of the above loop if a NaN is detected
*
         SAWNAN = .TRUE.
         J = BN - 3
   90    CONTINUE
         IF( WORK( INDP+J ).GT.ZERO .OR. WORK( INDP+J ).LT.ONE ) THEN
            J = J - 1
            GO TO 90
         END IF
         WORK( INDP+J ) = D( J+1 ) - SIGMA
         DO 100 I = J, R1, -1
            DMINUS = LLD( I ) + WORK( INDP+I )
            TMP = D( I ) / DMINUS
            WORK( INDUMN+I ) = L( I )*TMP
            IF( TMP.EQ.ZERO ) THEN
               WORK( INDP+I-1 ) = D( I ) - SIGMA
            ELSE
               WORK( INDP+I-1 ) = WORK( INDP+I )*TMP - SIGMA
            END IF
  100    CONTINUE
      END IF
*
*     Find the index (from R1 to R2) of the largest (in magnitude)
*     diagonal element of the inverse
*
      MINGMA = WORK( INDS+R1-1 ) + WORK( INDP+R1-1 )
      IF( MINGMA.EQ.ZERO )
     $   MINGMA = EPS*WORK( INDS+R1-1 )
      R = R1
      DO 110 I = R1, R2 - 1
         TMP = WORK( INDS+I ) + WORK( INDP+I )
         IF( TMP.EQ.ZERO )
     $      TMP = EPS*WORK( INDS+I )
         IF( ABS( TMP ).LT.ABS( MINGMA ) ) THEN
            MINGMA = TMP
            R = I + 1
         END IF
  110 CONTINUE
*
*     Compute the (scaled) r-th column of the inverse
*
      ISUPPZ( 1 ) = B1
      ISUPPZ( 2 ) = BN
      Z( R ) = CONE
      ZTZ = ONE
      IF( .NOT.SAWNAN ) THEN
         FROM = R - 1
         TO = MAX( R-BLKSIZ, B1 )
  120    CONTINUE
         IF( FROM.GE.B1 ) THEN
            DO 130 I = FROM, TO, -1
               Z( I ) = -( WORK( I )*Z( I+1 ) )
               ZTZ = ZTZ + DBLE( Z( I )*Z( I ) )
  130       CONTINUE
            IF( ABS( Z( TO ) ).LE.EPS .AND. ABS( Z( TO+1 ) ).LE.EPS )
     $           THEN
               ISUPPZ( 1 ) = TO + 2
            ELSE
               FROM = TO - 1
               TO = MAX( TO-BLKSIZ, B1 )
               GO TO 120
            END IF
         END IF
         FROM = R + 1
         TO = MIN( R+BLKSIZ, BN )
  140    CONTINUE
         IF( FROM.LE.BN ) THEN
            DO 150 I = FROM, TO
               Z( I ) = -( WORK( INDUMN+I-1 )*Z( I-1 ) )
               ZTZ = ZTZ + DBLE( Z( I )*Z( I ) )
  150       CONTINUE
            IF( ABS( Z( TO ) ).LE.EPS .AND. ABS( Z( TO-1 ) ).LE.EPS )
     $           THEN
               ISUPPZ( 2 ) = TO - 2
            ELSE
               FROM = TO + 1
               TO = MIN( TO+BLKSIZ, BN )
               GO TO 140
            END IF
         END IF
      ELSE
         DO 160 I = R - 1, B1, -1
            IF( Z( I+1 ).EQ.ZERO ) THEN
               Z( I ) = -( LD( I+1 ) / LD( I ) )*Z( I+2 )
            ELSE IF( ABS( Z( I+1 ) ).LE.EPS .AND. ABS( Z( I+2 ) ).LE.
     $               EPS ) THEN
               ISUPPZ( 1 ) = I + 3
               GO TO 170
            ELSE
               Z( I ) = -( WORK( I )*Z( I+1 ) )
            END IF
            ZTZ = ZTZ + DBLE( Z( I )*Z( I ) )
  160    CONTINUE
  170    CONTINUE
         DO 180 I = R, BN - 1
            IF( Z( I ).EQ.ZERO ) THEN
               Z( I+1 ) = -( LD( I-1 ) / LD( I ) )*Z( I-1 )
            ELSE IF( ABS( Z( I ) ).LE.EPS .AND. ABS( Z( I-1 ) ).LE.EPS )
     $                THEN
               ISUPPZ( 2 ) = I - 2
               GO TO 190
            ELSE
               Z( I+1 ) = -( WORK( INDUMN+I )*Z( I ) )
            END IF
            ZTZ = ZTZ + DBLE( Z( I+1 )*Z( I+1 ) )
  180    CONTINUE
  190    CONTINUE
      END IF
      DO 200 I = B1, ISUPPZ( 1 ) - 3
         Z( I ) = ZERO
  200 CONTINUE
      DO 210 I = ISUPPZ( 2 ) + 3, BN
         Z( I ) = ZERO
  210 CONTINUE
*
      RETURN
*
*     End of ZLAR1V
*
      END

C
C	$Id: lcm.f,v 1.4 2008-07-27 00:59:03 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      FUNCTION LCM(I,J)
      INTEGER REM
      M=IABS(I)
      N=IABS(J)
      LCM=0
      IF (M.LE.0 .OR. N.LE.0) RETURN
  101 REM=MOD(M,N)
      IF (REM.LE.0) GOTO 102
      M=N
      N=REM
      GOTO 101
  102 LCM=IABS(I*J/N)
      RETURN
      END

C
C $Id: tdprpa.f,v 1.5 2008-07-27 00:17:33 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE TDPRPA (XIPA,YIPA,XI2D,YI2D)
C
C This routine, given the X and Y coordinates of a point in the
C parallelogram defined by the last call to TDPARA, return the X
C and Y coordinates of its image in the image plane.
C
C The variables in the following common block define the parallelogram.
C
        COMMON /TDCOM2/ XACP,YACP,ZACP,XCDX,YCDX,ZCDX,XCDY,YCDY,ZCDY
        SAVE   /TDCOM2/
C
C Do a call forcing a BLOCKDATA to be loaded from a binary library.
C
        CALL TDBLDA
C
C Check for an uncleared prior error.
C
        IF (ICFELL('TDPRPA - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C Compute the coordinates of the point in 3-space.
C
        XI3D=XACP+XIPA*XCDX+YIPA*XCDY
        YI3D=YACP+XIPA*YCDX+YIPA*YCDY
        ZI3D=ZACP+XIPA*ZCDX+YIPA*ZCDY
C
C Pass the buck to the routine TDPRPT.
C
        CALL TDPRPT (XI3D,YI3D,ZI3D,XI2D,YI2D)
        IF (ICFELL('TDPRPA',2).NE.0) RETURN
C
C Done.
C
        RETURN
C
      END

C
C	$Id: gwifa.f,v 1.7 2008-07-27 00:21:07 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GWIFA
C
C  Process GKS fill area instruction.
C
      include 'gksin.h'
      include 'gwiio.h'
      include 'gwiins.h'
      include 'gwiwsl.h'
      include 'gwiarq.h'
      include 'gwiast.h'
      include 'gwiadc.h'
      include 'gwiopc.h'
      include 'gwienu.h'
C
      INTEGER  KALL, IPRIM, NBYTES, INDX1, INDX2, IX
      SAVE
C
      DATA  KALL/0/, IPRIM/4/
C
C
      KALL = KALL+1
      IF  (KALL .EQ. 1) THEN
C
C  If the picture is empty, send the clip indicator and rectangle;
C  set the WSL entry "DISPLAY SURFACE EMPTY" to "NOT EMPTY".
C
        IF (MDEMPT .EQ. GEMPTY) CALL GWICLP(1)
        MDEMPT = GNEMPT
C
C  Process pending attributes.
C
        IF (AGPEND(IPRIM)) THEN
C
C  Some changes are pending.
C
          IF (VALCHG(IVFAIX))  THEN
C
C  GKS fill area index, send CGM fill bundle index.
C
            NBYTES = 1+(MIXFW-1)/8
            CALL GWPTNI (CLFBIX, IDFBIX,  NBYTES,  RERR)
            CALL GWPTPR (MRFAIX, MIXFW,  1, RERR)
            IF (RERR .NE. 0) RETURN
C
C  Set sent value to requested, clear change flag.
C
            MSFAIX         = MRFAIX
            VALCHG(IVFAIX) = .FALSE.
          END IF
          IF (VALCHG(IVFAIS))  THEN
C
C  GKS fill area interior style, send CGM interior style.
C
            NBYTES = 1+(MEFW-1)/8
            CALL GWPTNI (CLINTS, IDINTS, NBYTES,  RERR)
            CALL GWPTPR (MRFAIS, MEFW,  1, RERR)
            IF (RERR .NE. 0) RETURN
C
C  Set sent value to requested, clear change flag.
C
            MSFAIS         = MRFAIS
            VALCHG(IVFAIS) = .FALSE.
          END IF
          IF (VALCHG(IVFASI))  THEN
C
C  GKS fill area style index, send just the hatch index since we
C  are currently not supporting the pattern index.
C
            NBYTES = 1+(MIXFW-1)/8
            CALL GWPTNI (CLHAIX, IDHAIX, NBYTES,  RERR)
            CALL GWPTPR (MRFASI, MIXFW, 1, RERR)
            IF (RERR .NE. 0) RETURN
C
C  Set sent value to requested, clear change flag.
C
            MSFASI = MRFASI
            VALCHG(IVFASI) = .FALSE.
          END IF
          IF (VALCHG(IVFACI))  THEN
C
C  GKS fill area color index, send CGM fill color.
C
            NBYTES = 1+(MCIXFW-1)/8
            CALL GWPTNI (CLFCLR, IDFCLR, NBYTES, RERR)
            CALL GWPTPR (MRFACI, MCIXFW,  1, RERR)
            IF (RERR .NE. 0) RETURN
C
C  Set sent value to requested, clear change flag.
C
            MSFACI         = MRFACI
            VALCHG(IVFACI) = .FALSE.
          END IF
          IF (ANYASF)  THEN
C
C  Some GKS ASF has changed, send CGM ASFs.
C
            CALL GWISAS (IPRIM, RERR)
            IF (RERR.NE.0)  RETURN
          END IF
C
C  Clear aggregate change variable.
C
          AGPEND(IPRIM) = .FALSE.
        END IF
C
C  Treat first call, put out opcode, and points.
C
C
C  Put out opcode (class and id) and total length.
C
        NBYTES = 1+(2*RL1*MVDCFW-1)/8
        CALL GWPTNI (CLPGON, IDPGON, NBYTES, RERR)
        IF (RERR .NE. 0) RETURN
C
C  Put out first points array.
C
C  Truncate points to limits of NDC unit square, convert to VDC,
C  and store in WPXPY.
C
        DO 30 IX=1,RL2
          INDX1 = 2*IX-1
          INDX2 = INDX1+1
          WPXPY(INDX1) = MXOFF+INT(REAL(MXSCAL)*
     -                   (MAX(0.,MIN(1.0,RX(IX)))))
          WPXPY(INDX2) = MYOFF+INT(REAL(MYSCAL)*
     -                   (MAX(0.,MIN(1.0,RY(IX)))))
   30   CONTINUE
C
C  Send out points.
C
        CALL GWPTPR (WPXPY,  MVDCFW,     2*RL2, RERR)
        IF (RERR .NE. 0) RETURN
C
C  If there is to be no continuation, reset the parameter "KALL".
C
        IF (CONT .EQ. 0) THEN
          KALL = 0
          RETURN
        ENDIF
      ENDIF
C
C  Treat the continuation calls.
C
      IF (KALL .GT. 1) THEN
C
C  Truncate points to limits of NDC unit square, convert to VDC,
C  and store in WPXPY.
C
        DO 40 IX=1,RL2
          INDX1 = 2*IX-1
          INDX2 = INDX1+1
          WPXPY(INDX1) = MXOFF+INT(REAL(MXSCAL)*
     -                   (MAX(0.,MIN(1.0,RX(IX)))))
          WPXPY(INDX2) = MYOFF+INT(REAL(MYSCAL)*
     -                   (MAX(0.,MIN(1.0,RY(IX)))))
   40   CONTINUE
        IF (CONT .EQ. 0) THEN
          CALL GWPTPR (WPXPY,  MVDCFW,     2*RL2, RERR)
          IF (RERR .NE. 0) RETURN
          KALL = 0
        ELSE
          CALL GWPTPR (WPXPY,  MVDCFW,     2*RL2, RERR)
          IF (RERR .NE. 0) RETURN
        ENDIF
      ENDIF
      RETURN
C
      END

C
C	$Id: csstore.f,v 1.5 2008-07-27 03:10:08 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      DOUBLE PRECISION FUNCTION CSSTORE (X)
      DOUBLE PRECISION X
C
C***********************************************************
C
C                                              From STRIPACK
C                                            Robert J. Renka
C                                  Dept. of Computer Science
C                                       Univ. of North Texas
C                                           renka@cs.unt.edu
C                                                   05/09/92
C
C   This function forces its argument X to be stored in a
C memory location, thus providing a means of determining
C floating point number characteristics (such as the machine
C precision) when it is necessary to avoid computation in
C high precision registers.
C
C
C On input:
C
C       X = Value to be stored.
C
C X is not altered by this function.
C
C On output:
C
C       CSSTORE = Value of X after it has been stored and
C               possibly truncated or rounded to the single
C               precision word length.
C
C Modules required by CSSTORE:  None
C
C***********************************************************
C
      DOUBLE PRECISION Y
      COMMON/STCOM/Y
      Y = X
      CSSTORE = Y
      RETURN
      END

        PROGRAM CARLNE
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER (LMAP=150000, NGEO=43, NPTS=50, NGRPS=2)
      PARAMETER (NWRK=1000)

      INTEGER MAP(LMAP), IAREA(NGRPS), IGRP(NGRPS)
      REAL XGEO(NGEO), YGEO(NGEO), X(12), Y(12)
      REAL XCNTR(NPTS), YCNTR1(NPTS), YCNTR2(NPTS), YCNTR3(NPTS)
      REAL YCNTR4(NPTS), YCNTR5(NPTS)
      REAL XWRK(NWRK), YWRK(NWRK)
      CHARACTER*14 STRING

      EXTERNAL MASK

      DATA XGEO / .63, .12, .05, .07, .10, .04, .19, .31, .31, .41,
     +     .39, .47, .64, .63, .70, .66, .67, .69, .76, .92,
     2     .95, .69, .64, .53, .53, .60, .63, .63, .72, .74,
     3     .79, .75, .75, .80, .75, .70, .68, .64, .63, .55,
     4     .55, .63, .63/
      DATA YGEO / .94, .95, .92, .85, .83, .78, .84, .75, .69, .58,
     +     .64, .55, .47, .37, .30, .05, .03, .05, .13, .26,
     2     .38, .52, .50, .57, .63, .63, .59, .64, .72, .71,
     3     .75, .75, .77, .78, .85, .83, .86, .86, .77, .80,
     4     .86, .90, .94/
      DATA X /.10, .22, .25, .25, .25, .50,
     +     .30, .47, .50, .77, .75, .68/
      DATA Y /.98, .70, .55, .38, .18, .18,
     +     .90, .85, .70, .35, .18, .05/
C     
C Generate Contour lines
C     
      DO 10 J=1,NPTS
         DIST = REAL(J-1)/REAL(NPTS-1)
         XCNTR (J) = DIST
         YCNTR1(J) = .1*COS(4.*3.14*DIST)+.15
         YCNTR2(J) = .1*COS(4.*3.14*DIST)+.30
         YCNTR3(J) = .1*COS(4.*3.14*DIST)+.50
         YCNTR4(J) = .1*COS(4.*3.14*DIST)+.70
         YCNTR5(J) = .1*COS(4.*3.14*DIST)+.85
 10   CONTINUE
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Set up color table and set Dash pattern to solid
C
      CALL COLOR (IWKID)
      CALL DASHDB(65535)
C
C Outline continents in red
C
      CALL GSPLCI (1)
      CALL CURVE (XGEO,YGEO,NGEO)
C
C Initialize Areas
C
      CALL ARINAM (MAP,LMAP)
C
C Add continents to area map in group 1.
C
      CALL AREDAM (MAP, XGEO, YGEO, NGEO, 1, 2, 1)
C
C Add contours to area map in group 3.
C
      CALL AREDAM (MAP, XCNTR, YCNTR1, NPTS, 3, 2, 1)
      CALL AREDAM (MAP, XCNTR, YCNTR2, NPTS, 3, 3, 2)
      CALL AREDAM (MAP, XCNTR, YCNTR3, NPTS, 3, 4, 3)
      CALL AREDAM (MAP, XCNTR, YCNTR4, NPTS, 3, 5, 4)
      CALL AREDAM (MAP, XCNTR, YCNTR5, NPTS, 3, 6, 5)
C
C Write out area and group identifiers for each area, using red for
C geographic identifiers, and green for contour identifiers.
C
      DO 20 I=1,12
         CALL ARGTAI(MAP, X(I), Y(I), IAREA, IGRP, NGRPS, NAI, 1)
         DO 30 J=1,2
            WRITE (STRING,11) J,IAREA(J),J,IGRP(J)
            IF (IGRP(J).EQ.1) THEN
               CALL GSPLCI(1)
               CALL PLCHHQ (X(I), Y(I), STRING, .01, 0., 0.)
            ENDIF
            IF (IGRP(J).EQ.3) THEN
               CALL GSPLCI(6)
               CALL PLCHHQ (X(I), Y(I)-.018, STRING, .01, 0., 0.)
            ENDIF
 30      CONTINUE
 20   CONTINUE
C
C Draw contour lines only over water
C
      CALL GSPLCI(7)
      CALL ARDRLN(MAP,XCNTR,YCNTR1,NPTS,XWRK,YWRK,NWRK,
     +     IAREA,IGRP,NGRPS,MASK)
      CALL ARDRLN(MAP,XCNTR,YCNTR2,NPTS,XWRK,YWRK,NWRK,
     +     IAREA,IGRP,NGRPS,MASK)
      CALL GSLWSC(2.)
      CALL GSPLCI(2)
      CALL ARDRLN(MAP,XCNTR,YCNTR3,NPTS,XWRK,YWRK,NWRK,
     +     IAREA,IGRP,NGRPS,MASK)
      CALL GSLWSC(1.)
      CALL GSPLCI(7)
      CALL ARDRLN(MAP,XCNTR,YCNTR4,NPTS,XWRK,YWRK,NWRK,
     +     IAREA,IGRP,NGRPS,MASK)
      CALL ARDRLN(MAP,XCNTR,YCNTR5,NPTS,XWRK,YWRK,NWRK,
     +     IAREA,IGRP,NGRPS,MASK)
      
      CALL FRAME
C
C Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      
 11   FORMAT ('A(',I1,')=',I1,' G(',I1,')=',I1)
      STOP
      END

      SUBROUTINE COLOR (IWKID)
C
C Define color table
C
C Background is white to show up on both paper and terminal
C
      CALL GSCR(IWKID,0,1.,1.,1.)
C
C Red
C
      CALL GSCR(IWKID,1,.7,0.,0.)
C
C Green
C
      CALL GSCR(IWKID,2,0.,.7,0.)
C
C Yellow
C
      CALL GSCR(IWKID,3,.7,.7,0.)
C
C Blue
C
      CALL GSCR(IWKID,4,0.,0.,.7)
C
C Magenta
C
      CALL GSCR(IWKID,5,.7,0.,.7)
C
C Aqua
C
      CALL GSCR(IWKID,6,0.,.7,.7)
C
C Black
C
      CALL GSCR(IWKID,7,0.,0.,0.)

      RETURN
      END
      
      SUBROUTINE MASK(XC,YC,MCS,IAREA,IGRP,NGRPS)
      
      INTEGER IAREA(NGRPS),IGRP(NGRPS),IDGEO
      REAL XC(MCS),YC(MCS)
      
      IDGEO=-1
C
C Retrieve geographic area identifier
C
      DO 10, I=1,NGRPS
         IF (IGRP(I).EQ.1) IDGEO=IAREA(I)
 10   CONTINUE
C
C If the contour segment is over water, then draw it
C
      IF (IDGEO .EQ. 1) THEN
         CALL CURVED(XC,YC,MCS)
      ENDIF
C
C Otherwise, don't draw the line - mask it.
C
      RETURN
      END

      PROGRAM CCPCICA
C
C This program plots contours over a world map.  The subroutine
C MKDAT generates some random data and sets values between longitudes
C 121W and 161W and between latitudes 6S to 4N to the special value
C 1.E36.  These special values will be plotted as gray, the color
C so specified for this in subroutine COLOR.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER (NLON=361,NLAT=181,LRWK=5000,LIWK=5000,
     1     ICAM=512,ICAN=512)
      REAL ZDAT(NLON,NLAT),RWRK(LRWK)
      INTEGER IASF(13),IWRK(LIWK),ICRA(ICAM,ICAN)
      DATA IASF / 13*1 /
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
      CALL GSCLIP (0)
      CALL GSASF (IASF)
C 
C Set up a color table
C 
      CALL COLOR(IWKID)
C 
C Create some data
C 
      CALL MKDAT (2,ZDAT,NLON,NLAT)
C 
C Zero cell array
C 
      DO 10 I=1,ICAM
         DO 20 J=1,ICAN
            ICRA(I,J)=0
 20      CONTINUE
 10   CONTINUE
C 
C Setup a map
C 
      CALL SETMAP ('SV',40.,-105.)
C 
C Setup contour options - in particular set the special value
C to 1.E36 .
C 
      CALL SETCTR (0,1,-180.,180.,-90.,90.,1.E36)
C 
C Initialize Conpack
C 
      CALL CPRECT (ZDAT,NLON,NLON,NLAT,RWRK,LRWK,IWRK,LIWK)
C 
C Set cell array values and map it to user coordinates
C 
      CALL CPCICA (ZDAT,RWRK,IWRK,ICRA,ICAM,ICAM,ICAN,0.,0.,1.,1.)
C 
C Draw cell array and flush buffer
C 
      CALL GCA (CFUX(0.),CFUY(0.),CFUX(1.),CFUY(1.),ICAM,ICAN,1,1,
     1     ICAM,ICAN,ICRA)
      CALL SFLUSH
C 
C Draw contour lines
C 
      CALL GSPLCI (0)
      CALL CPCLDR (ZDAT,RWRK,IWRK)
      CALL SFLUSH
C 
C Draw Map
C 
      CALL GSPLCI (1)
      CALL GSLWSC (3.)
      CALL MAPLOT
      CALL GSLWSC (1.)
      CALL MAPGRD
      CALL SFLUSH
C 
C Draw title
C 
      CALL SET (0.,1.,0.,1.,0.,1.,0.,1.,1)
      CALL GSPLCI (1)
      CALL PLCHHQ (.5,.95,'Cell Array in Conpack',.03,0.,0.)
C 
C Close Frame
C 
      CALL FRAME
C
C Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      
      STOP
      END
      

      SUBROUTINE MKDAT(NCTFR,ZDAT,NLON,NLAT)
C 
C Create some data to contour
C 
      REAL ZDAT(NLON,NLAT)
C 
C NCTFR is used to generate a random number, ZDAT is the data array
C 
      CALL GGDINI (0.,1.,NCTFR,.9)
      ZMIN= 1.E36
      ZMAX=-1.E36
      DO 10 I=1,NLON
         RLON=.017453292519943*(-180.+360.*REAL(I-1)/REAL(NLON-1))
         DO 20 J=1,NLAT
            RLAT=.017453292519943*(-90.+180.*REAL(J-1)/REAL(NLAT-1))
            ZDAT(I,J)=GGDPNT(RLAT,RLON)+.5*COS(4.*RLAT)
            ZMIN=MIN(ZMIN,ZDAT(I,J))
            ZMAX=MAX(ZMAX,ZDAT(I,J))
 20      CONTINUE
 10   CONTINUE
      DO 30 I=1,NLON
         DO 40 J=1,NLAT
            ZDAT(I,J)=((ZDAT(I,J)-ZMIN)/(ZMAX-ZMIN))*130.-10.
 40      CONTINUE
 30   CONTINUE
      DO 50 I=20,60
         DO 60 J=85,95
            ZDAT(I,J)=1.E36
 60      CONTINUE
 50   CONTINUE
      
      RETURN
      END
      

      SUBROUTINE SETMAP (PTYPE,PLAT,PLON)
C 
C Set up a map projection with desired options, but don't draw it.
C 
      CHARACTER*2 PTYPE
      
      CALL MAPPOS (.05,.90,.05,.90)
      CALL MAPROJ (PTYPE,PLAT,PLON,0.)
      CALL MAPSET ('MA - MAXIMAL AREA',0.,0.,0.,0.)
      CALL MAPINT
      
      RETURN
      END
      

      SUBROUTINE SETCTR (ISET,MAPFLG,XMIN,XMAX,YMIN,YMAX,SPVAL)
C 
C Set up Conpack options, but don't do anything
C 
      CALL CPSETI ('SET - DO-SET-CALL FLAG',ISET)
      CALL CPSETI ('MAP - MAPPING FLAG',MAPFLG)
      CALL CPSETR ('XC1 - X COORDINATE AT I=1',XMIN)
      CALL CPSETR ('XCM - X COORDINATE AT I=M',XMAX)
      CALL CPSETR ('YC1 - Y COORDINATE AT J=1',YMIN)
      CALL CPSETR ('YCN - Y COORDINATE AT J=N',YMAX)
      CALL CPSETI ('CLS - CONTOUR LEVEL SELECTOR',1)
      CALL CPSETR ('CMN - CONTOUR LEVEL MINIMUM',0.)
      CALL CPSETR ('CMX - CONTOUR LEVEL MAXIMUM',110.)
      CALL CPSETR ('CIS - CONTOUR INTERVAL SPECIFIER',10.)
      CALL CPSETR ('ORV - OUT-OF-RANGE VALUE',1.E12)
      CALL CPSETR ('SPV - SPECIAL VALUE',SPVAL)
      CALL CPSETI ('CAF - CELL ARRAY FLAG',2)
      CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',-1)
      CALL CPSETI ('AIA - AREA IDENTIFIER OUTSIDE THE GRID',99)
      CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',-2)
      CALL CPSETI ('AIA - AREA IDENTIFIER - SPECIAL-VALUE AREAS',100)
      CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',-3)
      CALL CPSETI ('AIA - AREA IDENTIFIER - OUT-OF-RANGE AREAS',101)
      CALL CPSETI ('LLP - LINE LABEL POSITIONING',0)
      CALL CPSETC ('HLT - HIGH/LOW TEXT',' ')
*     CALL CPSETC ('ILT - INFORMATIONAL LABEL TEXT',' ')
C
      RETURN
      END


      SUBROUTINE COLOR(IWKID)
      CALL GSCR (IWKID, 0,0.000,0.000,0.000)
      CALL GSCR (IWKID, 1,1.000,1.000,1.000)
      CALL GSCR (IWKID, 2,0.500,1.000,1.000)
      DO 10 I=3,15
         CALL GSCR (IWKID,I,
     1         MAX(0.,MIN(1.,1.-REAL(ABS(I- 3)/10.))),
     2         MAX(0.,MIN(1.,1.-REAL(ABS(I- 9)/10.))),
     3         MAX(0.,MIN(1.,1.-REAL(ABS(I-15)/10.))))
 10   CONTINUE
      CALL GSCR (IWKID,16,1.,0.,0.)
C     Define color to be used outside the grid.
      CALL GSCR (IWKID,101,0.,0.,0.)
C     Define color to be used in special-value areas.
      CALL GSCR (IWKID,102,.5,.5,.5)
C     Define color to be used in out-of-range areas.
      CALL GSCR (IWKID,103,0.,0.,0.) ! OUT-OF-RANGE AREA
      RETURN
      END

C
C $Id: pcgpai.f,v 1.7 2008-07-27 00:17:19 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE PCGPAI (CHRS,IBEG,IVAL)
C
C This routine looks for a subscript of the form "(n)" in positions IBEG
C and following of the character string CHRS.  It returns the value of
C "n" (which may be negative) in IVAL.  If no subscript is found, IVAL
C is zeroed.
C
        CHARACTER*(*) CHRS
        CHARACTER*1 ICHR
C
        IVAL=0
        ISGN=1
C
        ISTA=0
C
        DO 101 ICHS=IBEG,LEN(CHRS)
          ICHR=CHRS(ICHS:ICHS)
          IF (ICHR.NE.' ') THEN
            IF (ISTA.EQ.0) THEN
              IF (ICHR.NE.'(') GO TO 102
              ISTA=1
            ELSE IF (ISTA.EQ.1) THEN
              IF (ICHAR(CHRS(ICHS:ICHS)).GE.ICHAR('0').AND.
     +            ICHAR(CHRS(ICHS:ICHS)).LE.ICHAR('9')) THEN
                IVAL=ICHAR(CHRS(ICHS:ICHS))-ICHAR('0')
              ELSE IF (ICHR.EQ.'-') THEN
                ISGN=-1
              ELSE IF (ICHR.NE.'+') THEN
                GO TO 102
              END IF
              ISTA=2
            ELSE IF (ISTA.EQ.2) THEN
              IF (ICHAR(CHRS(ICHS:ICHS)).GE.ICHAR('0').AND.
     +            ICHAR(CHRS(ICHS:ICHS)).LE.ICHAR('9')) THEN
                IVAL=IVAL*10+ICHAR(CHRS(ICHS:ICHS))-ICHAR('0')
              ELSE IF (ICHR.NE.')') THEN
                GO TO 102
              ELSE
                GO TO 103
              END IF
            END IF
          END IF
  101   CONTINUE
C
  102   IVAL=0
        RETURN
C
  103   IVAL=ISGN*IVAL
        RETURN
C
      END

C
C	$Id: ngseti.f,v 1.23 2010-02-08 05:58:44 fred Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE NGSETI (CNP,IVP)
C
      SAVE
C
      CHARACTER*(*) CNP
C
C  This subroutine is called to give an integer value to a specified
C  parameter.
C
C  CNP is the name of the parameter whose value is to be set.
C
C  IVP is an integer variable containing the desired value.
C
C
C  Declare a local character variable in which to form an error message.       
C
      CHARACTER*80 CTM
C
      include 'ngcomn.h'
C
C  Input and output data records for ESCAPE function calls.
C
      CHARACTER*80 IDR,CDUM
C
C  Do a call forcing a BLOCKDATA to be loaded from a binary library.
C
      CALL NGBLDA
C
C  Check for an uncleared prior error.
C
      IF (ICFELL('NGSETI - Uncleared prior error',1) .NE. 0) RETURN
C
C  Check for a parameter name that is too short.
C
      IF (LEN(CNP) .LT. 2) THEN
        CTM(1:36) = 'NGSETI - Parameter name too short - '
        CTM(37:36+LEN(CNP)) = CNP
        CALL SETER (CTM(1:36+LEN(CNP)), 1, 1)
        GO TO 120
      ENDIF
C
C  Do a crude check to see if IVP is within range (primarily to 
C  make sure that a floating point number has not been supplied).
C
      IF (IVP .GT. 10000000) THEN
        CTM(1:42) = 'NGSETI - Parameter value out of range for '
        CTM(43:44) = CNP(1:2)
        CALL SETER (CTM(1:44), 2, 1)
        RETURN
      ENDIF
C
C  Set the appropriate parameter.
C
      IDR = ' '
C
C  WO - Workstation ID
C
      IF (CNP(1:2).EQ.'WO' .OR. CNP(1:2).EQ.'wo' .OR.
     +    CNP(1:2).EQ.'Wo') THEN
C
C  Check to make sure that the referenced workstation is open.
C
        IF (NGCKOP(IVP) .EQ. 0) THEN
          CTM =
     +     'NGSETI - value for WO must reference an open workstation.'       
          CALL SETER (CTM(1:60), 3, 1)
          GO TO 120
        ENDIF
        IWKID = IVP
        GO TO 120
C
C  CL - GKS clipping (0 = off; 1 = on).
C
      ELSE IF (CNP(1:2).EQ.'CL' .OR. CNP(1:2).EQ.'cl' .OR.
     +         CNP(1:2).EQ.'Cl') THEN
        IF (IVP.NE.0 .AND. IVP.NE.1) THEN
          CALL SETER ('NGSETI - value for CL must be zero or one',
     +                 4, 1)
          GO TO 120
        ENDIF
        IGKSCP = IVP
        WRITE(IDR(1:5), 500) IGKSCP
        CALL GESC(-1399,1,IDR,1,IDUM,CDUM)
        GO TO 120
C
C  ER - Error number limit for GKS errors issued before abort.
C
      ELSE IF (CNP(1:2).EQ.'ER' .OR. CNP(1:2).EQ.'er' .OR.
     +         CNP(1:2).EQ.'Er') THEN
        IERRMX = MAX(0, IVP)
        WRITE(IDR(1:10), 510) IERRMX
        CALL GESC(-1398,1,IDR,1,IDUM,CDUM)
        GO TO 120
C
C  FU - Full background.
C
      ELSE IF (CNP(1:2).EQ.'FU' .OR. CNP(1:2).EQ.'fu' .OR.
     +         CNP(1:2).EQ.'Fu') THEN
        IF (IWKID .LT. 0) THEN
          CTM =
     +      'NGSETI - you must set a value for WO before setting FU'
          CALL SETER (CTM(1:60), 5, 1)
          GO TO 120
        ENDIF
        WRITE(IDR, 500) IWKID
  500   FORMAT(I5)
        IF (IVP .NE. 0) THEN
          IFULLB = 1
          IDR(6:7) = ' 1'
        ELSE
          IFULLB = 0
          IDR(6:7) = ' 0'
        ENDIF
        CALL GESC(-1517,1,IDR,1,IDUM,CDUM)
        GO TO 120
C
C  SU - Suppress background color box in PS output.
C
      ELSE IF (CNP(1:2).EQ.'SU' .OR. CNP(1:2).EQ.'su' .OR.
     +         CNP(1:2).EQ.'Su') THEN
        ISUP = IVP
        WRITE(IDR(1:5), 500) ISUP
        CALL GESC(-1524,1,IDR,1,IDUM,CDUM)
        GO TO 120
C
C  PL - indicate portrait/landscape mode for PS output.
C
      ELSE IF (CNP(1:2).EQ.'PL' .OR. CNP(1:2).EQ.'pl' .OR.
     +         CNP(1:2).EQ.'Pl') THEN
        IF (IWKID .LT. 0) THEN
          CTM =
     +      'NGSETI - you must set a value for WO before setting PL'
          CALL SETER (CTM(1:60), 15, 1)
          GO TO 120
        ENDIF
        WRITE(IDR(1: 5), 500) IWKID
        IPTLD = IVP
        WRITE(IDR(6:10), 500) IPTLD
        CALL GESC(-1525,1,IDR,1,IDUM,CDUM)
        GO TO 120
C
C  IG - Flag for indicating whether clipping rectangles in segments
C       should be transformed according the the current segment
C       transformation.
C
      ELSE IF (CNP(1:2).EQ.'IG' .OR. CNP(1:2).EQ.'ig' .OR.
     +         CNP(1:2).EQ.'Ig') THEN
        INCSEG = IVP
        WRITE(IDR(1:5), 500) INCSEG
        CALL GESC(-1386,1,IDR,1,IDUM,CDUM)
        GO TO 120
C
C  SS - Flag for indicating whether segments should be saved.
C
      ELSE IF (CNP(1:2).EQ.'SS' .OR. CNP(1:2).EQ.'ss' .OR.
     +         CNP(1:2).EQ.'Ss') THEN
        ISVSEG = IVP
        WRITE(IDR(1:5), 500) ISVSEG
        CALL GESC(-1397,1,IDR,1,IDUM,CDUM)
        GO TO 120
C
C  ST - Stack size limit.
C
      ELSE IF (CNP(1:2).EQ.'ST' .OR. CNP(1:2).EQ.'st' .OR.
     +         CNP(1:2).EQ.'St') THEN
        IF (IWKID .LT. 0) THEN
          CTM =
     +      'NGSETI - you must set a value for WO before setting ST'
          CALL SETER (CTM(1:60), 7, 1)
          GO TO 120
        ENDIF
        IF (IVP .LE. 0) THEN
          CALL SETER ('NGSETI - value for ST must be positive', 8, 1)
          GO TO 120
        ENDIF
        WRITE(IDR(1: 5), 500) IWKID
        ISTKMX = IVP
        WRITE(IDR(7:16), 510) ISTKMX
  510   FORMAT(I10)
        CALL GESC(-1514,1,IDR,1,IDUM,CDUM)
        GO TO 120
C
C  PA - Path size limit.
C
      ELSE IF (CNP(1:2).EQ.'PA' .OR. CNP(1:2).EQ.'pa' .OR.
     +         CNP(1:2).EQ.'Pa') THEN
        IF (IWKID .LT. 0) THEN
          CTM =
     +      'NGSETI - you must set a value for WO before setting PA'
          CALL SETER (CTM(1:60), 9, 1)
          GO TO 120
        ENDIF
        IF (IVP .LE. 0) THEN
          CALL SETER ('NGSETI - value for PA must be positive', 10, 1)
          GO TO 120
        ENDIF
        WRITE(IDR(1: 5), 500) IWKID
        IPTHMX = IVP
        WRITE(IDR(7:16), 510) IPTHMX
        CALL GESC(-1515,1,IDR,1,IDUM,CDUM)
        GO TO 120
C
C  PE - Percentage error allowed in color matching in X output.
C
      ELSE IF (CNP(1:2).EQ.'PE' .OR. CNP(1:2).EQ.'pe' .OR.
     +         CNP(1:2).EQ.'Pe') THEN
        IF (IWKID .LT. 0) THEN
          CTM =
     +      'NGSETI - you must set a value for WO before setting PE'
          CALL SETER (CTM(1:60), 11, 1)
          GO TO 120
        ENDIF
        IF (IVP.LT.0 .OR. IVP.GT.100) THEN
          CALL SETER ('NGSETI - value for PE must be between 0 and 100',       
     +                    12, 1)
          GO TO 120
        ENDIF
        WRITE(IDR(1: 5), 500) IWKID
        IPERCX = IVP
        WRITE(IDR(6:10), 500) IPERCX
        CALL GESC(-1400,1,IDR,1,IDUM,CDUM)
        GO TO 120
C
C  PR - Flag private color map in X output.
C
      ELSE IF (CNP(1:2).EQ.'PR' .OR. CNP(1:2).EQ.'pr' .OR.
     +         CNP(1:2).EQ.'Pr') THEN
        IF (IWKID .LT. 0) THEN
          CTM =
     +      'NGSETI - you must set a value for WO before setting PR'
          CALL SETER (CTM(1:60), 13, 1)
          GO TO 120
        ENDIF
        WRITE(IDR(1: 5), 500) IWKID
        IPRIVX = IVP
        WRITE(IDR(7:16), 510) IPRIVX
        CALL GESC(-1401,1,IDR,1,IDUM,CDUM)
        GO TO 120
C
C  SC - Shared Color model in X output.
C
      ELSE IF (CNP(1:2).EQ.'SC' .OR. CNP(1:2).EQ.'sc' .OR.
     +         CNP(1:2).EQ.'Sc') THEN
        WRITE(IDR(1: 5), 500) IVP
        ISCX = IVP
        WRITE(IDR(7:11), 500) 0
        CALL GESC(-1402,1,IDR,1,IDUM,CDUM)
        GO TO 120
C
C  PC - Private Color model in X output.
C
      ELSE IF (CNP(1:2).EQ.'PC' .OR. CNP(1:2).EQ.'pc' .OR.
     +         CNP(1:2).EQ.'Pc') THEN
        WRITE(IDR(1: 5), 500) IVP
        IPCX = IVP
        WRITE(IDR(7:11), 500) 1
        CALL GESC(-1402,1,IDR,1,IDUM,CDUM)
        GO TO 120
C
C  MC - Mixed Color model in X output.
C
      ELSE IF (CNP(1:2).EQ.'MC' .OR. CNP(1:2).EQ.'mc' .OR.
     +         CNP(1:2).EQ.'Mc') THEN
        WRITE(IDR(1: 5), 500) IVP
        IMCX = IVP
        WRITE(IDR(7:11), 500) 2
        CALL GESC(-1402,1,IDR,1,IDUM,CDUM)
        GO TO 120
C
C  PU - Pause in X driver.
C
      ELSE IF (CNP(1:2).EQ.'PU' .OR. CNP(1:2).EQ.'pu' .OR.
     +         CNP(1:2).EQ.'Pu') THEN
        IXPS = IVP
        IF (IXPS .LT. 0) THEN
          CTM =
     +      'NGSETI - invalid workstation ID for PU parameter.'
          CALL SETER (CTM(1:60), 14, 1)
          GO TO 120
        ENDIF
        WRITE(IDR, 500) IXPS
        CALL GESC(-1396,1,IDR,1,IDUM,CDUM)
        GO TO 120
C
C  JO - Line join type.
C
      ELSE IF (CNP(1:2).EQ.'JO' .OR. CNP(1:2).EQ.'jo' .OR.
     +         CNP(1:2).EQ.'Jo') THEN
        IF (IWKID .LT. 0) THEN
          CTM =
     +      'NGSETI - you must set a value for WO before setting JO'
          CALL SETER (CTM(1:60), 15, 1)
          GO TO 120
        ENDIF
        WRITE(IDR(1: 5), 500) IWKID
        IF (IVP .LE. 0) THEN
          ILJOIN = 0
        ELSE IF (IVP .GE. 2) THEN
          ILJOIN = 2
        ELSE
          ILJOIN = 1
        ENDIF
        WRITE(IDR(7:7), 520) ILJOIN
  520   FORMAT(I1)
        CALL GESC(-1518,1,IDR,1,IDUM,CDUM)
        GO TO 120
C
C  CA - Line cap type.
C
      ELSE IF (CNP(1:2).EQ.'CA' .OR. CNP(1:2).EQ.'ca' .OR.
     +         CNP(1:2).EQ.'Ca') THEN
        IF (IWKID .LT. 0) THEN
          CTM =
     +      'NGSETI - you must set a value for WO before setting CA'
          CALL SETER (CTM(1:60), 16, 1)
          GO TO 120
        ENDIF
        WRITE(IDR(1: 5), 500) IWKID
        IF (IVP .LE. 0) THEN
          ILCAP = 0
        ELSE IF (IVP .GE. 2) THEN
          ILCAP = 2
        ELSE
          ILCAP = 1
        ENDIF
        WRITE(IDR(7:7), 520) ILCAP
        CALL GESC(-1519,1,IDR,1,IDUM,CDUM)
        GO TO 120
C
C  LB - Color index for secondary color for logos.
C
      ELSE IF (CNP(1:2).EQ.'LB' .OR. CNP(1:2).EQ.'lb' .OR.
     +         CNP(1:2).EQ.'Lb') THEN
        IF (IVP .LT. 0) THEN
          LOGOSND = 1
        ELSE
          LOGOSND = IVP
        ENDIF
        GO TO 120
C
C  LC - Color index for logos to non-PostScript workstations.
C
      ELSE IF (CNP(1:2).EQ.'LC' .OR. CNP(1:2).EQ.'lc' .OR.
     +         CNP(1:2).EQ.'Lc') THEN
        IF (IVP .LT. 0) THEN
          LOGOCOL = 1
        ELSE
          LOGOCOL = IVP
        ENDIF
        GO TO 120
C
C  LT - Logo type.
C
      ELSE IF (CNP(1:2).EQ.'LT' .OR. CNP(1:2).EQ.'lt' .OR.
     +         CNP(1:2).EQ.'Lt') THEN
        IF (IVP.LT.1 .OR. IVP.GT.5) THEN
          LOGOTYP = 1
        ELSE
          LOGOTYP = IVP
        ENDIF
        GO TO 120
C
C  LX - Lower left X coordinate on PostScript/PDF output page.
C
      ELSE IF (CNP(1:2).EQ.'LX' .OR. CNP(1:2).EQ.'lx' .OR.
     +         CNP(1:2).EQ.'Lx') THEN
        IF (IVP.LT.-72000 .OR. IVP.GT.72000) THEN
          CALL SETER('NGSETI - LX value out of range, no action taken',       
     +                17, 1)
          GO TO 120
        ENDIF
        ILLX = IVP
        WRITE(IDR( 2:10), 530) ILLX
        WRITE(IDR(12:20), 530) ILLY
        WRITE(IDR(22:30), 530) IURX
        WRITE(IDR(32:40), 530) IURY
  530   FORMAT(I9)
        CALL GESC(-1521,1,IDR,1,IDUM,CDUM)
        GO TO 120
C
C  LY - Lower left Y coordinate on PostScript/PDF output page.
C
      ELSE IF (CNP(1:2).EQ.'LY' .OR. CNP(1:2).EQ.'ly' .OR.
     +         CNP(1:2).EQ.'Ly') THEN
        IF (IVP.LT.-72000 .OR. IVP.GT.72000) THEN
          CALL SETER('NGSETI - LY value out of range, no action taken',       
     +                18, 1)
          GO TO 120
        ENDIF
        ILLY = IVP
        WRITE(IDR( 2:10), 530) ILLX
        WRITE(IDR(12:20), 530) ILLY
        WRITE(IDR(22:30), 530) IURX
        WRITE(IDR(32:40), 530) IURY
        CALL GESC(-1521,1,IDR,1,IDUM,CDUM)
        GO TO 120
C
C  UX - Upper right X coordinate on PostScript/PDF output page.
C
      ELSE IF (CNP(1:2).EQ.'UX' .OR. CNP(1:2).EQ.'ux' .OR.
     +         CNP(1:2).EQ.'Ux') THEN
        IF (IVP.LT.-72000 .OR. IVP.GT.72000) THEN
          CALL SETER('NGSETI - UX value out of range, no action taken',       
     +                19, 1)
          GO TO 120
        ELSE IF (IVP .LE. ILLX) THEN
          CALL SETER('NGSETI - LX >= UX, no action taken', 20, 1)
          GO TO 120
        ENDIF
        IURX = IVP
        WRITE(IDR( 2:10), 530) ILLX
        WRITE(IDR(12:20), 530) ILLY
        WRITE(IDR(22:30), 530) IURX
        WRITE(IDR(32:40), 530) IURY
        CALL GESC(-1521,1,IDR,1,IDUM,CDUM)
        GO TO 120
C
C  UY - Upper right Y coordinate on PostScript/PDF output page.
C
      ELSE IF (CNP(1:2).EQ.'UY' .OR. CNP(1:2).EQ.'uy' .OR.
     +         CNP(1:2).EQ.'Uy') THEN
        IF (IVP.LT.-72000 .OR. IVP.GT.72000) THEN
          CALL SETER('NGSETI - UY value out of range, no action taken',       
     +                21, 1)
          GO TO 120
        ELSE IF (IVP .LE. ILLY) THEN
          CALL SETER('NGSETI - LY >= UY, no action taken', 22, 1)
          GO TO 120
        ENDIF
        IURY = IVP
        WRITE(IDR( 2:10), 530) ILLX
        WRITE(IDR(12:20), 530) ILLY
        WRITE(IDR(22:30), 530) IURX
        WRITE(IDR(32:40), 530) IURY
        CALL GESC(-1521,1,IDR,1,IDUM,CDUM)
        GO TO 120
C
C  PX - Lower left X coordinate on PostScript/PDF output page, used to
C       change coordinates between pictures, or mid picture.
C
      ELSE IF (CNP(1:2).EQ.'PX' .OR. CNP(1:2).EQ.'px' .OR.
     +         CNP(1:2).EQ.'Px') THEN
        IF (IVP.LT.-72000 .OR. IVP.GT.72000) THEN
          CALL SETER('NGSETI - PX value out of range, no action taken',       
     +                17, 1)
          GO TO 120
        ENDIF
        IF (IWKID .LT. 0) THEN
          CTM =
     +      'NGSETI - you must set a value for WO before setting PX'
          CALL SETER (CTM(1:60), 15, 1)
          GO TO 120
        ENDIF
        WRITE(IDR(1: 5), 500) IWKID
        NLLX = IVP
        WRITE(IDR( 6:14), 530) NLLX
        WRITE(IDR(15:23), 530) NLLY
        WRITE(IDR(24:32), 530) NURX
        WRITE(IDR(33:41), 530) NURY
        CALL GESC(-1526,1,IDR,1,IDUM,CDUM)
        GO TO 120
C
C  PY - Lower left Y coordinate on PostScript/PDF output page, used to
C       change coordinates between pictures, or mid picture.
C
      ELSE IF (CNP(1:2).EQ.'PY' .OR. CNP(1:2).EQ.'py' .OR.
     +         CNP(1:2).EQ.'Py') THEN
        IF (IVP.LT.-72000 .OR. IVP.GT.72000) THEN
          CALL SETER('NGSETI - PY value out of range, no action taken',       
     +                17, 1)
          GO TO 120
        ENDIF
        IF (IWKID .LT. 0) THEN
          CTM =
     +      'NGSETI - you must set a value for WO before setting PY'
          CALL SETER (CTM(1:60), 15, 1)
          GO TO 120
        ENDIF
        WRITE(IDR(1: 5), 500) IWKID
        NLLY = IVP
        WRITE(IDR( 6:14), 530) NLLX
        WRITE(IDR(15:23), 530) NLLY
        WRITE(IDR(24:32), 530) NURX
        WRITE(IDR(33:41), 530) NURY
        CALL GESC(-1526,1,IDR,1,IDUM,CDUM)
        GO TO 120
C
C  QX - Upper right X coordinate on PostScript/PDF output page, used to
C       change coordinates between pictures, or mid picture.
C
      ELSE IF (CNP(1:2).EQ.'QX' .OR. CNP(1:2).EQ.'qx' .OR.
     +         CNP(1:2).EQ.'Qx') THEN
        IF (IVP.LT.-72000 .OR. IVP.GT.72000) THEN
          CALL SETER('NGSETI - QX value out of range, no action taken',       
     +                17, 1)
          GO TO 120
        ENDIF
        IF (IWKID .LT. 0) THEN
          CTM =
     +      'NGSETI - you must set a value for WO before setting QX'
          CALL SETER (CTM(1:60), 15, 1)
          GO TO 120
        ENDIF
        WRITE(IDR(1: 5), 500) IWKID
        NURX = IVP
        WRITE(IDR( 6:14), 530) NLLX
        WRITE(IDR(15:23), 530) NLLY
        WRITE(IDR(24:32), 530) NURX
        WRITE(IDR(33:41), 530) NURY
        CALL GESC(-1526,1,IDR,1,IDUM,CDUM)
        GO TO 120
C
C  QY - Upper right Y coordinate on PostScript/PDF output page, used to
C       change coordinates between pictures, or mid picture.
C
      ELSE IF (CNP(1:2).EQ.'QY' .OR. CNP(1:2).EQ.'qy' .OR.
     +         CNP(1:2).EQ.'Qy') THEN
        IF (IVP.LT.-72000 .OR. IVP.GT.72000) THEN
          CALL SETER('NGSETI - QY value out of range, no action taken',       
     +                17, 1)
          GO TO 120
        ENDIF
        IF (IWKID .LT. 0) THEN
          CTM =
     +      'NGSETI - you must set a value for WO before setting QY'
          CALL SETER (CTM(1:60), 15, 1)
          GO TO 120
        ENDIF
        WRITE(IDR(1: 5), 500) IWKID
        NURY = IVP
        WRITE(IDR( 6:14), 530) NLLX
        WRITE(IDR(15:23), 530) NLLY
        WRITE(IDR(24:32), 530) NURX
        WRITE(IDR(33:41), 530) NURY
        CALL GESC(-1526,1,IDR,1,IDUM,CDUM)
        GO TO 120
C
C  AX - Lower left X coordinate on PostScript output page, used to
C       specify the bounding box for EPS/EPSI.
C
      ELSE IF (CNP(1:2).EQ.'AX' .OR. CNP(1:2).EQ.'ax' .OR.
     +         CNP(1:2).EQ.'Ax') THEN
        IF (IVP.LT.-72000 .OR. IVP.GT.72000) THEN
          CALL SETER('NGSETI - AX value out of range, no action taken',       
     +                17, 1)
          GO TO 120
        ENDIF
        IF (IWKID .LT. 0) THEN
          CTM =
     +      'NGSETI - you must set a value for WO before setting AX'
          CALL SETER (CTM(1:60), 15, 1)
          GO TO 120
        ENDIF
        WRITE(IDR(1: 5), 500) IWKID
        MLLX = IVP
        WRITE(IDR( 6:14), 530) MLLX
        WRITE(IDR(15:23), 530) MLLY
        WRITE(IDR(24:32), 530) MURX
        WRITE(IDR(33:41), 530) MURY
        CALL GESC(-1528,1,IDR,1,IDUM,CDUM)
        GO TO 120
C
C  AY - Lower left Y coordinate on PostScript output page, used to
C       specify the bounding box for EPS/EPSI.
C
      ELSE IF (CNP(1:2).EQ.'AY' .OR. CNP(1:2).EQ.'ay' .OR.
     +         CNP(1:2).EQ.'Ay') THEN
        IF (IVP.LT.-72000 .OR. IVP.GT.72000) THEN
          CALL SETER('NGSETI - AY value out of range, no action taken',       
     +                17, 1)
          GO TO 120
        ENDIF
        IF (IWKID .LT. 0) THEN
          CTM =
     +      'NGSETI - you must set a value for WO before setting AY'
          CALL SETER (CTM(1:60), 15, 1)
          GO TO 120
        ENDIF
        WRITE(IDR(1: 5), 500) IWKID
        MLLY = IVP
        WRITE(IDR( 6:14), 530) MLLX
        WRITE(IDR(15:23), 530) MLLY
        WRITE(IDR(24:32), 530) MURX
        WRITE(IDR(33:41), 530) MURY
        CALL GESC(-1528,1,IDR,1,IDUM,CDUM)
        GO TO 120
C
C  BX - Upper right X coordinate on PostScript output page, used to
C       specify the bounding box for EPS/EPSI.
C
      ELSE IF (CNP(1:2).EQ.'BX' .OR. CNP(1:2).EQ.'bx' .OR.
     +         CNP(1:2).EQ.'Bx') THEN
        IF (IVP.LT.-72000 .OR. IVP.GT.72000) THEN
          CALL SETER('NGSETI - BX value out of range, no action taken',       
     +                17, 1)
          GO TO 120
        ENDIF
        IF (IWKID .LT. 0) THEN
          CTM =
     +      'NGSETI - you must set a value for WO before setting BX'
          CALL SETER (CTM(1:60), 15, 1)
          GO TO 120
        ENDIF
        WRITE(IDR(1: 5), 500) IWKID
        MURX = IVP
        WRITE(IDR( 6:14), 530) MLLX
        WRITE(IDR(15:23), 530) MLLY
        WRITE(IDR(24:32), 530) MURX
        WRITE(IDR(33:41), 530) MURY
        CALL GESC(-1528,1,IDR,1,IDUM,CDUM)
        GO TO 120
C
C  BY - Upper right Y coordinate on PostScript output page, used to
C       specify the bounding box for EPS/EPSI.
C
      ELSE IF (CNP(1:2).EQ.'BY' .OR. CNP(1:2).EQ.'by' .OR.
     +         CNP(1:2).EQ.'By') THEN
        IF (IVP.LT.-72000 .OR. IVP.GT.72000) THEN
          CALL SETER('NGSETI - BY value out of range, no action taken',       
     +                17, 1)
          GO TO 120
        ENDIF
        IF (IWKID .LT. 0) THEN
          CTM =
     +      'NGSETI - you must set a value for WO before setting BY'
          CALL SETER (CTM(1:60), 15, 1)
          GO TO 120
        ENDIF
        WRITE(IDR(1: 5), 500) IWKID
        MURY = IVP
        WRITE(IDR( 6:14), 530) MLLX
        WRITE(IDR(15:23), 530) MLLY
        WRITE(IDR(24:32), 530) MURX
        WRITE(IDR(33:41), 530) MURY
        CALL GESC(-1528,1,IDR,1,IDUM,CDUM)
        GO TO 120
C
C  CO - Scale factor for PostScript coordinates.
C
      ELSE IF (CNP(1:2).EQ.'CO' .OR. CNP(1:2).EQ.'co' .OR.
     +         CNP(1:2).EQ.'Co') THEN
        ICOSCL = MAX(IVP,1)
        WRITE(IDR(1:5), 500) ICOSCL
        CALL GESC(-1522,1,IDR,1,IDUM,CDUM)
        GO TO 120
C
C  CM - PostScript color model.
C
      ELSE IF (CNP(1:2).EQ.'CM' .OR. CNP(1:2).EQ.'cm' .OR.
     +         CNP(1:2).EQ.'Cm') THEN
        IPSCM = IVP
        WRITE(IDR(1: 5), 500) IVP
        CALL GESC(-1523,1,IDR,1,IDUM,CDUM)
        GO TO 120
C
C  CT - Flag to indicate if NGDOTS draws circles or filled dots (0=dots;
C       1=circles).
C
      ELSE IF (CNP(1:2).EQ.'CT' .OR. CNP(1:2).EQ.'ct' .OR.
     +         CNP(1:2).EQ.'Ct') THEN
        ICDFLG = MIN(IVP,1)
        GO TO 120
C
C  PH - Sets the page height (in 1/72" coordinates) for the PDF media box.
C
      ELSE IF (CNP(1:2).EQ.'PH' .OR. CNP(1:2).EQ.'ph' .OR.
     +         CNP(1:2).EQ.'Ph') THEN
        IPGHGT = IVP
        WRITE(IDR(1: 5), 500) IVP
        CALL GESC(-1530,1,IDR,1,IDUM,CDUM)
        GO TO 120
C
C  PW - Sets the page width (in 1/72" coordinates) for the PDF media box.
C
      ELSE IF (CNP(1:2).EQ.'PW' .OR. CNP(1:2).EQ.'pw' .OR.
     +         CNP(1:2).EQ.'Pw') THEN
        IPGWTH = IVP
        WRITE(IDR(1: 5), 500) IVP
        CALL GESC(-1529,1,IDR,1,IDUM,CDUM)
        GO TO 120
C
C  SH - Sets the page height (in 1/72" coordinates) for PS PageSize
C
      ELSE IF (CNP(1:2).EQ.'SH' .OR. CNP(1:2).EQ.'sh' .OR.
     +         CNP(1:2).EQ.'Sh') THEN
        IPSHGT = IVP
        WRITE(IDR(1: 5), 500) IVP
        CALL GESC(-1532,1,IDR,1,IDUM,CDUM)
        GO TO 120
C
C  SW - Sets the page width (in 1/72" coordinates) for the PS PageSize
C
      ELSE IF (CNP(1:2).EQ.'SW' .OR. CNP(1:2).EQ.'sw' .OR.
     +         CNP(1:2).EQ.'Sw') THEN
        IPSWTH = IVP
        WRITE(IDR(1: 5), 500) IVP
        CALL GESC(-1531,1,IDR,1,IDUM,CDUM)
        GO TO 120
      ELSE
        CTM(1:36) = 'NGSETI - Parameter name not known - '
        CTM(37:38) = CNP(1:2)
        CALL SETER (CTM(1:38), 23, 1)
        GO TO 120
      ENDIF
C
  120 CONTINUE
      RETURN
      END

C
C	$Id: pcffme.f,v 1.5 2008-07-27 00:17:19 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE PCFFME (CHGT)
C
C Extract the informational part of the fontcap.
C
      include 'pcffme.h'
      include 'pcffdx.h'
C
C  Type flag.
C
      CALL GBYTES(IBFC,TYPFLG,0,16,0,1)
C
C  Other fields.
C
      CALL GBYTES(IBFC,FNINFO(2),336,16,0,NUMNTR-1)
C
C  Generate negative numbers if required.
C
      DO 80 I=2,NUMNTR
        CALL PCGNEG (FNINFO(I),ITMP)
        FNINFO(I) = ITMP
   80 CONTINUE
C
C  Get the byte pointers for the characters.
C
      NUMCHR = CHREND-CHRSTR+1
      CALL GBYTES(IBFC,CHRPNT,8*TABPNT,16,0,NUMCHR)
C
      RETURN
      END

C
C	$Id: wmsect.f,v 1.4 2008-07-27 00:17:37 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE WMSECT(RECT1,RECT2,ISECT,RECT3)
C
C  Given two rectangles RECT1 and RECT2 (stored as XL,YB,XR,YT),
C  calculate the intersection of the two rectangles.  If the 
C  intersection is not null, set ISECT to 1 and store the intersection
C  in RECT3.  If the intersection is null, set ISECT to 0 and return
C  all 0's in RECT3.
C
      DIMENSION RECT1(4),RECT2(4),RECT3(4)
C
      S2LLX = RECT2(1)
      S2LLY = RECT2(2)
      S2URX = RECT2(3)
      S2URY = RECT2(4)
      S1LLX = RECT1(1)
      S1LLY = RECT1(2)
      S1URX = RECT1(3)
      S1URY = RECT1(4)
C
      IF (S2LLX.LT.S1URX .AND. S1LLX.LT.S2URX .AND.
     +    S2LLY.LT.S1URY .AND. S1LLY.LT.S2URY)  THEN
        ISECT = 1
        RECT3(1) = MAX(S1LLX, S2LLX)
        RECT3(2) = MAX(S1LLY, S2LLY)
        RECT3(3) = MIN(S1URX, S2URX)
        RECT3(4) = MIN(S1URY, S2URY)
      ELSE
        ISECT = 0
        RECT3(1) = 0.
        RECT3(2) = 0.
        RECT3(3) = 0.
        RECT3(4) = 0.
      ENDIF
C
      RETURN
      END

      PROGRAM AGEX10
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Define the data arrays.
C
      REAL XDRA(1201),YDRA(1201)
C
C Initialize GKS.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Fill the data arrays.  The independent variable represents
C time during the year (a hypothetical year with equal-length
C months) and is set up so that minor ticks can be lengthened
C to delimit the months; the major ticks, though shortened to
C invisibility, still determine where the labels go.
C
      DO 101 I=1,1201
        XDRA(I)=REAL(I-51)
        YDRA(I)=COSH(REAL(I-601)/202.)
  101 CONTINUE
C
C Change the labels on the bottom and left axes.
C
      CALL ANOTAT ('MONTHS OF THE YEAR$',
     +             'ROMAN NUMERALS$',0,0,0,' ')
C
C Fix the minimum and maximum values on both axes and prevent
C AUTOGRAPH from using rounded values at the ends of the axes.
C
      CALL AGSETF ('X/MIN.',-50.)
      CALL AGSETF ('X/MAX.',1150.)
      CALL AGSETI ('X/NICE.',0)
C
      CALL AGSETF ('Y/MIN.',1.)
      CALL AGSETF ('Y/MAX.',10.)
      CALL AGSETI ('Y/NICE.',0)
C
C Specify the spacing between major tick marks on all axes.
C Note that the AUTOGRAPH dummy routine AGCHNL is supplanted
C (below) by one which supplies dates for the bottom axis and
C Roman numerals for the left axis in place of the numeric
C labels one would otherwise get.
C
      CALL AGSETI ('  LEFT/MAJOR/TYPE.',1)
      CALL AGSETI (' RIGHT/MAJOR/TYPE.',1)
      CALL AGSETI ('BOTTOM/MAJOR/TYPE.',1)
      CALL AGSETI ('   TOP/MAJOR/TYPE.',1)
C
      CALL AGSETF ('  LEFT/MAJOR/BASE.',  1.)
      CALL AGSETF (' RIGHT/MAJOR/BASE.',  1.)
      CALL AGSETF ('BOTTOM/MAJOR/BASE.',100.)
      CALL AGSETF ('   TOP/MAJOR/BASE.',100.)
C
C Suppress minor ticks on the left and right axes.
C
      CALL AGSETI ('  LEFT/MINOR/SPACING.',0)
      CALL AGSETI (' RIGHT/MINOR/SPACING.',0)
C
C On the bottom and top axes, put one minor tick between each
C pair of major ticks, shorten major ticks to invisibility,
C and lengthen minor ticks.  The net effect is to make the
C minor ticks delimit the beginning and end of each month,
C while the major ticks, though invisible, cause the names of
C the months to be where we want them.
C
      CALL AGSETI ('BOTTOM/MINOR/SPACING.',1)
      CALL AGSETI ('   TOP/MINOR/SPACING.',1)
C
      CALL AGSETF ('BOTTOM/MAJOR/INWARD. ',0.)
      CALL AGSETF ('BOTTOM/MINOR/INWARD. ',.015)
      CALL AGSETF ('   TOP/MAJOR/INWARD. ',0.)
      CALL AGSETF ('   TOP/MINOR/INWARD. ',.015)
C
C Draw a boundary around the edge of the plotter frame.
C
      CALL BNDARY
C
C Draw the graph, using EZXY.
C
      CALL EZXY (XDRA,YDRA,1201,
     +           'EXAMPLE 10 (MODIFIED NUMERIC LABELS)$')
C
C Close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
C
      END
      SUBROUTINE AGCHNL (IAXS,VILS,CHRM,MCIM,NCIM,IPXM,
     +                                  CHRE,MCIE,NCIE)
C
      CHARACTER*(*) CHRM,CHRE
C
C Define the names of the months for use on the bottom axis.
C
      CHARACTER*3 MONS(12)
      DATA MONS / 'JAN','FEB','MAR','APR','MAY','JUN',
     +            'JUL','AUG','SEP','OCT','NOV','DEC'/
C
C Modify the numeric labels on the left axis.
C
      IF (IAXS.EQ.1) THEN
        CALL AGCORN (INT(VILS),CHRM,NCIM)
        IPXM=0
        NCIE=0
C
C Modify the numeric labels on the bottom axis.
C
      ELSE IF (IAXS.EQ.3) THEN
        IMON=INT(VILS+.5)/100+1
        CHRM(1:3)=MONS(IMON)
        NCIM=3
        IPXM=0
        NCIE=0
      END IF
C
C Done.
C
      RETURN
C
      END
      SUBROUTINE AGCORN (NTGR,BCRN,NCRN)
C
      CHARACTER*(*) BCRN
C
C This routine receives an integer in NTGR and returns its
C Roman-numeral equivalent in the first NCRN characters of
C the character variable BCRN.  It only works for integers
C within a limited range and it does some rather unorthodox
C things (like using zero and minus).
C
C ICH1, ICH5, and IC10 are character variables used for the
C single-unit, five-unit, and ten-unit symbols at a given
C level.
C
      CHARACTER*1 ICH1,ICH5,IC10
C
C Treat numbers outside the range (-4000,+4000) as infinites.
C
      IF (ABS(NTGR).GE.4000) THEN
        IF (NTGR.GT.0) THEN
          NCRN=5
          BCRN(1:5)='(INF)'
        ELSE
          NCRN=6
          BCRN(1:6)='(-INF)'
        END IF
        RETURN
      END IF
C
C Use a '0' for the zero.  The Romans never had it so good.
C
      IF (NTGR.EQ.0) THEN
        NCRN=1
        BCRN(1:1)='0'
        RETURN
      END IF
C
C Zero the character counter.
C
      NCRN=0
C
C Handle negative integers by prefixing a minus sign.
C
      IF (NTGR.LT.0) THEN
        NCRN=NCRN+1
        BCRN(NCRN:NCRN)='-'
      END IF
C
C Initialize constants.  We'll check for thousands first.
C
      IMOD=10000
      IDIV=1000
      ICH1='M'
C
C Find out how many thousands (hundreds, tens, units) there
C are and jump to the proper code block for each case.
C
  101 INTG=MOD(ABS(NTGR),IMOD)/IDIV
C
      GO TO (107,104,104,104,102,103,103,103,103,106),INTG+1
C
C Four - add ICH1 followed by ICH5.
C
  102 NCRN=NCRN+1
      BCRN(NCRN:NCRN)=ICH1
C
C Five through eight - add ICH5, followed by INTG-5 ICH1's.
C
  103 NCRN=NCRN+1
      BCRN(NCRN:NCRN)=ICH5
C
      INTG=INTG-5
      IF (INTG.LE.0) GO TO 107
C
C One through three - add that many ICH1's.
C
  104 DO 105 I=1,INTG
        NCRN=NCRN+1
        BCRN(NCRN:NCRN)=ICH1
  105 CONTINUE
C
      GO TO 107
C
C Nine - add ICH1, followed by IC10.
C
  106 NCRN=NCRN+1
      BCRN(NCRN:NCRN)=ICH1
      NCRN=NCRN+1
      BCRN(NCRN:NCRN)=IC10
C
C If we're done, exit.
C
  107 IF (IDIV.EQ.1) RETURN
C
C Otherwise, tool up for the next digit and loop back.
C
      IMOD=IMOD/10
      IDIV=IDIV/10
      IC10=ICH1
C
      IF (IDIV.EQ.100) THEN
        ICH5='D'
        ICH1='C'
      ELSE IF (IDIV.EQ.10) THEN
        ICH5='L'
        ICH1='X'
      ELSE
        ICH5='V'
        ICH1='I'
      END IF
C
      GO TO 101
C
      END
      SUBROUTINE BNDARY
C
C Routine to draw the plotter-frame edge.
C
      CALL PLOTIT (    0,    0,0)
      CALL PLOTIT (32767,    0,1)
      CALL PLOTIT (32767,32767,1)
      CALL PLOTIT (    0,32767,1)
      CALL PLOTIT (    0,    0,1)
      RETURN
      END

C NCLFORTSTART
      SUBROUTINE DFOURINFO(X,NPTS,NHRET,NHAR,SCLPHA,AMP,PHA,PCV,A,B,
     +     AMPX,PHAX,PCVX,WRK,LWRK)
      IMPLICIT NONE

C NCL:   finfo = fourier_info(x, nhret, sclpha)

c perform a fourier analysis on a series of data points
c return the amplitude, phase and % variance explained

c input
      INTEGER NPTS,NHRET
      DOUBLE PRECISION X(NPTS),SCLPHA
c output
      DOUBLE PRECISION AMP(NHRET),PHA(NHRET),PCV(NHRET)
      INTEGER LWRK,NHAR
      DOUBLE PRECISION WRK(LWRK)
      DOUBLE PRECISION A(*), B(*), AMPX(*),PHAX(*),PCVX(*)
C NCLEND

c local
      INTEGER NH,NHX
      DOUBLE PRECISION ANOT,SCALE
C      DOUBLE PRECISION WRK(3*NPTS+15)
C      DOUBLE PRECISION A(NPTS/2),B(NPTS/2)
C      DOUBLE PRECISION AMPX(NPTS/2),PHAX(NPTS/2),PCVX(NPTS/2)

C      NHAR = NPTS/2
C      LWRK = 3*NPTS + 15

      CALL DFINFO(X,NPTS,NHAR,ANOT,A,B,WRK,LWRK,AMPX,PHAX,PCVX)

      NHX = NHRET
      IF (NHRET.GT.NHAR) NHX = NHAR

      SCALE = SCLPHA
      IF (SCALE.EQ.0.0D0) SCALE = 1.0D0

      DO NH = 1,NHX
          AMP(NH) = AMPX(NH)
          PHA(NH) = PHAX(NH)*SCALE
          PCV(NH) = PCVX(NH)
      END DO

      RETURN
      END
c ------------------------------------------------------------------
      SUBROUTINE DFINFO(X,NPTS,NHAR,ANOT,A,B,WRK,LWRK,AMP,PHASE,PCVAR)
      IMPLICIT NONE

c calculate the amplitude ,phase and % variance explained per harmonic
c .   of the fourier series.

      INTEGER NPTS,NHAR,LWRK
      DOUBLE PRECISION X(NPTS)
      DOUBLE PRECISION ANOT,A(*),B(*),AMP(*),PHASE(*),PCVAR(*)
      DOUBLE PRECISION WRK(LWRK)
c local
      INTEGER N
      DOUBLE PRECISION W,VARTOT,EPS

      W   = DBLE(NPTS)/ (8.D0*ATAN(1.D0))
      EPS = 1.D-12

      DO N = 1,NHAR
          A(N) = 0.0D0
          B(N) = 0.0D0
      END DO

      CALL DEZFFTI(NPTS,WRK)
      CALL DEZFFTF(NPTS,X,ANOT,A,B,WRK)

      VARTOT = 0.D0
      DO N = 1,NHAR
          AMP(N) = SQRT(A(N)*A(N)+B(N)*B(N))

          IF (A(N).EQ.0.D0 .AND. B(N).EQ.0.D0) THEN
              PHASE(N) = 0.D0
          ELSE
              PHASE(N) = ATAN2(B(N),A(N))*W/DBLE(N)
              IF (PHASE(N).LT.0.0D0) THEN
                  PHASE(N) = PHASE(N) + DBLE(NPTS)/DBLE(N)
              END IF
          END IF

          VARTOT = VARTOT + 0.5D0*AMP(N)*AMP(N)
          PCVAR(N) = 0.D0
      END DO


      IF (VARTOT.GT.EPS) THEN
          DO N = 1,NHAR
              PCVAR(N) = ((0.5D0*AMP(N)*AMP(N))/VARTOT)*100.D0
          END DO
      ELSE
         DO N = 1,NHAR
            AMP(N)   = 0.0D0
            PHASE(N) = 0.0D0
            PCVAR(N) = 0.0D0
         END DO
      END IF

      RETURN
      END

C
C $Id: mdpvpd.f,v 1.9 2008-09-18 00:42:17 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MDPVPD (UOLD,VOLD,U,V)
C
        DOUBLE PRECISION UOLD,VOLD,U,V
C
C Plot the line segment from (UOLD,VOLD) TO (U,V), using either a solid
C line or a dotted line (depending on the value of the common variable
C IDTL).
C
C Declare required common blocks.  See MAPBDX for descriptions of these
C common blocks and the variables in them.
C
        COMMON /MAPCM4/  GRDR,GRID,GRLA,GRLO,GRPO,OTOL,PDRE,PLA1,PLA2,
     +                   PLA3,PLA4,PLB1,PLB2,PLB3,PLB4,PLNO,PLTO,ROTA,
     +                   SRCH,XLOW,XROW,YBOW,YTOW,IDOT,IDSH,IDTL,ILCW,
     +                   ILTS,JPRJ,ELPF,INTF,LBLF,PRMF
        DOUBLE PRECISION GRDR,GRID,GRLA,GRLO,GRPO,OTOL,PDRE,PLA1,PLA2,
     +                   PLA3,PLA4,PLB1,PLB2,PLB3,PLB4,PLNO,PLTO,ROTA,
     +                   SRCH,XLOW,XROW,YBOW,YTOW
        INTEGER          IDOT,IDSH,IDTL,ILCW,ILTS,JPRJ
        LOGICAL          ELPF,INTF,LBLF,PRMF
        SAVE   /MAPCM4/
C
        COMMON /MAPCMA/  DATL,DBTD,DDTS,DPLT,DPSQ,DSCA,DSSQ
        DOUBLE PRECISION DATL,DBTD,DDTS,DPLT,DPSQ,DSCA,DSSQ
        SAVE   /MAPCMA/
C
        COMMON /MAPCMP/  NPTB,XPTB(50),YPTB(50)
        INTEGER          NPTB
        REAL             XPTB,YPTB
        SAVE   /MAPCMP/
C
C Declare local variables.
C
        DOUBLE PRECISION DELU,DELV,VLEN
C
C Select vector or dot mode.
C
        IF (IDTL.EQ.0) THEN
C
C Use a single vector.
C
          CALL DPVECT (REAL(U),REAL(V))
          IF (ICFELL('MDPVPD',1).NE.0) RETURN
C
        ELSE
C
C Use dots.  DELU and DELV are the u and v components of the vector
C joining (UOLD,VOLD) to (U,V) and VLEN is the length of the vector.
C
          DELU=U-UOLD
          DELV=V-VOLD
C
          VLEN=SQRT(DELU*DELU+DELV*DELV)
C
C Now distribute dots along the vector.  The first one is spaced just
C far enough along it (DATL units) to be DBTD units away from the last
C dot on the previous vector and the rest are DBTD units apart.
C
  101     IF (DATL.LT.VLEN) THEN
            IF (NPTB.GE.50) THEN
              CALL POINTS (XPTB,YPTB,NPTB,0,0)
              IF (ICFELL('MDPVPD',2).NE.0) RETURN
              NPTB=0
            END IF
            NPTB=NPTB+1
            XPTB(NPTB)=UOLD+(DATL/VLEN)*DELU
            YPTB(NPTB)=VOLD+(DATL/VLEN)*DELV
            DATL=DATL+DBTD
            GO TO 101
          END IF
C
C Set DATL for the next call.
C
          DATL=DATL-VLEN
C
        END IF
C
C Done.
C
        RETURN
C
      END

      SUBROUTINE CTGEX2( WANTQ, WANTZ, N, A, LDA, B, LDB, Q, LDQ, Z,
     $                   LDZ, J1, INFO )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      LOGICAL            WANTQ, WANTZ
      INTEGER            INFO, J1, LDA, LDB, LDQ, LDZ, N
*     ..
*     .. Array Arguments ..
      COMPLEX            A( LDA, * ), B( LDB, * ), Q( LDQ, * ),
     $                   Z( LDZ, * )
*     ..
*
*  Purpose
*  =======
*
*  CTGEX2 swaps adjacent diagonal 1 by 1 blocks (A11,B11) and (A22,B22)
*  in an upper triangular matrix pair (A, B) by an unitary equivalence
*  transformation.
*
*  (A, B) must be in generalized Schur canonical form, that is, A and
*  B are both upper triangular.
*
*  Optionally, the matrices Q and Z of generalized Schur vectors are
*  updated.
*
*         Q(in) * A(in) * Z(in)' = Q(out) * A(out) * Z(out)'
*         Q(in) * B(in) * Z(in)' = Q(out) * B(out) * Z(out)'
*
*
*  Arguments
*  =========
*
*  WANTQ   (input) LOGICAL
*          .TRUE. : update the left transformation matrix Q;
*          .FALSE.: do not update Q.
*
*  WANTZ   (input) LOGICAL
*          .TRUE. : update the right transformation matrix Z;
*          .FALSE.: do not update Z.
*
*  N       (input) INTEGER
*          The order of the matrices A and B. N >= 0.
*
*  A       (input/output) COMPLEX arrays, dimensions (LDA,N)
*          On entry, the matrix A in the pair (A, B).
*          On exit, the updated matrix A.
*
*  LDA     (input)  INTEGER
*          The leading dimension of the array A. LDA >= max(1,N).
*
*  B       (input/output) COMPLEX arrays, dimensions (LDB,N)
*          On entry, the matrix B in the pair (A, B).
*          On exit, the updated matrix B.
*
*  LDB     (input)  INTEGER
*          The leading dimension of the array B. LDB >= max(1,N).
*
*  Q       (input/output) COMPLEX array, dimension (LDZ,N)
*          If WANTQ = .TRUE, on entry, the unitary matrix Q. On exit,
*          the updated matrix Q.
*          Not referenced if WANTQ = .FALSE..
*
*  LDQ     (input) INTEGER
*          The leading dimension of the array Q. LDQ >= 1;
*          If WANTQ = .TRUE., LDQ >= N.
*
*  Z       (input/output) COMPLEX array, dimension (LDZ,N)
*          If WANTZ = .TRUE, on entry, the unitary matrix Z. On exit,
*          the updated matrix Z.
*          Not referenced if WANTZ = .FALSE..
*
*  LDZ     (input) INTEGER
*          The leading dimension of the array Z. LDZ >= 1;
*          If WANTZ = .TRUE., LDZ >= N.
*
*  J1      (input) INTEGER
*          The index to the first block (A11, B11).
*
*  INFO    (output) INTEGER
*           =0:  Successful exit.
*           =1:  The transformed matrix pair (A, B) would be too far
*                from generalized Schur form; the problem is ill-
*                conditioned. (A, B) may have been partially reordered,
*                and ILST points to the first row of the current
*                position of the block being moved.
*
*
*  Further Details
*  ===============
*
*  Based on contributions by
*     Bo Kagstrom and Peter Poromaa, Department of Computing Science,
*     Umea University, S-901 87 Umea, Sweden.
*
*  In the current code both weak and strong stability tests are
*  performed. The user can omit the strong stability test by changing
*  the internal logical parameter WANDS to .FALSE.. See ref. [2] for
*  details.
*
*  [1] B. Kagstrom; A Direct Method for Reordering Eigenvalues in the
*      Generalized Real Schur Form of a Regular Matrix Pair (A, B), in
*      M.S. Moonen et al (eds), Linear Algebra for Large Scale and
*      Real-Time Applications, Kluwer Academic Publ. 1993, pp 195-218.
*
*  [2] B. Kagstrom and P. Poromaa; Computing Eigenspaces with Specified
*      Eigenvalues of a Regular Matrix Pair (A, B) and Condition
*      Estimation: Theory, Algorithms and Software, Report UMINF-94.04,
*      Department of Computing Science, Umea University, S-901 87 Umea,
*      Sweden, 1994. Also as LAPACK Working Note 87. To appear in
*      Numerical Algorithms, 1996.
*
*  =====================================================================
*
*     .. Parameters ..
      COMPLEX            CZERO, CONE
      PARAMETER          ( CZERO = ( 0.0E+0, 0.0E+0 ),
     $                   CONE = ( 1.0E+0, 0.0E+0 ) )
      REAL               TEN
      PARAMETER          ( TEN = 10.0E+0 )
      INTEGER            LDST
      PARAMETER          ( LDST = 2 )
      LOGICAL            WANDS
      PARAMETER          ( WANDS = .TRUE. )
*     ..
*     .. Local Scalars ..
      LOGICAL            STRONG, WEAK
      INTEGER            I, M
      REAL               CQ, CZ, EPS, SA, SB, SCALE, SMLNUM, SS, SUM,
     $                   THRESH, WS
      COMPLEX            CDUM, F, G, SQ, SZ
*     ..
*     .. Local Arrays ..
      COMPLEX            S( LDST, LDST ), T( LDST, LDST ), WORK( 8 )
*     ..
*     .. External Functions ..
      REAL               SLAMCH
      EXTERNAL           SLAMCH
*     ..
*     .. External Subroutines ..
      EXTERNAL           CLACPY, CLARTG, CLASSQ, CROT
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, CONJG, MAX, REAL, SQRT
*     ..
*     .. Executable Statements ..
*
      INFO = 0
*
*     Quick return if possible
*
      IF( N.LE.1 )
     $   RETURN
*
      M = LDST
      WEAK = .FALSE.
      STRONG = .FALSE.
*
*     Make a local copy of selected block in (A, B)
*
      CALL CLACPY( 'Full', M, M, A( J1, J1 ), LDA, S, LDST )
      CALL CLACPY( 'Full', M, M, B( J1, J1 ), LDB, T, LDST )
*
*     Compute the threshold for testing the acceptance of swapping.
*
      EPS = SLAMCH( 'P' )
      SMLNUM = SLAMCH( 'S' ) / EPS
      SCALE = REAL( CZERO )
      SUM = REAL( CONE )
      CALL CLACPY( 'Full', M, M, S, LDST, WORK, M )
      CALL CLACPY( 'Full', M, M, T, LDST, WORK( M*M+1 ), M )
      CALL CLASSQ( 2*M*M, WORK, 1, SCALE, SUM )
      SA = SCALE*SQRT( SUM )
      THRESH = MAX( TEN*EPS*SA, SMLNUM )
*
*     Compute unitary QL and RQ that swap 1-by-1 and 1-by-1 blocks
*     using Givens rotations and perform the swap tentatively.
*
      F = S( 2, 2 )*T( 1, 1 ) - T( 2, 2 )*S( 1, 1 )
      G = S( 2, 2 )*T( 1, 2 ) - T( 2, 2 )*S( 1, 2 )
      SA = ABS( S( 2, 2 ) )
      SB = ABS( T( 2, 2 ) )
      CALL CLARTG( G, F, CZ, SZ, CDUM )
      SZ = -SZ
      CALL CROT( 2, S( 1, 1 ), 1, S( 1, 2 ), 1, CZ, CONJG( SZ ) )
      CALL CROT( 2, T( 1, 1 ), 1, T( 1, 2 ), 1, CZ, CONJG( SZ ) )
      IF( SA.GE.SB ) THEN
         CALL CLARTG( S( 1, 1 ), S( 2, 1 ), CQ, SQ, CDUM )
      ELSE
         CALL CLARTG( T( 1, 1 ), T( 2, 1 ), CQ, SQ, CDUM )
      END IF
      CALL CROT( 2, S( 1, 1 ), LDST, S( 2, 1 ), LDST, CQ, SQ )
      CALL CROT( 2, T( 1, 1 ), LDST, T( 2, 1 ), LDST, CQ, SQ )
*
*     Weak stability test: |S21| + |T21| <= O(EPS F-norm((S, T)))
*
      WS = ABS( S( 2, 1 ) ) + ABS( T( 2, 1 ) )
      WEAK = WS.LE.THRESH
      IF( .NOT.WEAK )
     $   GO TO 20
*
      IF( WANDS ) THEN
*
*        Strong stability test:
*           F-norm((A-QL'*S*QR, B-QL'*T*QR)) <= O(EPS*F-norm((A, B)))
*
         CALL CLACPY( 'Full', M, M, S, LDST, WORK, M )
         CALL CLACPY( 'Full', M, M, T, LDST, WORK( M*M+1 ), M )
         CALL CROT( 2, WORK, 1, WORK( 3 ), 1, CZ, -CONJG( SZ ) )
         CALL CROT( 2, WORK( 5 ), 1, WORK( 7 ), 1, CZ, -CONJG( SZ ) )
         CALL CROT( 2, WORK, 2, WORK( 2 ), 2, CQ, -SQ )
         CALL CROT( 2, WORK( 5 ), 2, WORK( 6 ), 2, CQ, -SQ )
         DO 10 I = 1, 2
            WORK( I ) = WORK( I ) - A( J1+I-1, J1 )
            WORK( I+2 ) = WORK( I+2 ) - A( J1+I-1, J1+1 )
            WORK( I+4 ) = WORK( I+4 ) - B( J1+I-1, J1 )
            WORK( I+6 ) = WORK( I+6 ) - B( J1+I-1, J1+1 )
   10    CONTINUE
         SCALE = REAL( CZERO )
         SUM = REAL( CONE )
         CALL CLASSQ( 2*M*M, WORK, 1, SCALE, SUM )
         SS = SCALE*SQRT( SUM )
         STRONG = SS.LE.THRESH
         IF( .NOT.STRONG )
     $      GO TO 20
      END IF
*
*     If the swap is accepted ("weakly" and "strongly"), apply the
*     equivalence transformations to the original matrix pair (A,B)
*
      CALL CROT( J1+1, A( 1, J1 ), 1, A( 1, J1+1 ), 1, CZ, CONJG( SZ ) )
      CALL CROT( J1+1, B( 1, J1 ), 1, B( 1, J1+1 ), 1, CZ, CONJG( SZ ) )
      CALL CROT( N-J1+1, A( J1, J1 ), LDA, A( J1+1, J1 ), LDA, CQ, SQ )
      CALL CROT( N-J1+1, B( J1, J1 ), LDB, B( J1+1, J1 ), LDB, CQ, SQ )
*
*     Set  N1 by N2 (2,1) blocks to 0
*
      A( J1+1, J1 ) = CZERO
      B( J1+1, J1 ) = CZERO
*
*     Accumulate transformations into Q and Z if requested.
*
      IF( WANTZ )
     $   CALL CROT( N, Z( 1, J1 ), 1, Z( 1, J1+1 ), 1, CZ, CONJG( SZ ) )
      IF( WANTQ )
     $   CALL CROT( N, Q( 1, J1 ), 1, Q( 1, J1+1 ), 1, CQ, CONJG( SQ ) )
*
*     Exit with INFO = 0 if swap was successfully performed.
*
      RETURN
*
*     Exit with INFO = 1 if swap was rejected.
*
   20 CONTINUE
      INFO = 1
      RETURN
*
*     End of CTGEX2
*
      END

C
C	$Id: lblank.f,v 1.4 2008-07-27 12:23:45 haley Exp $
C                                                                      
C			     Copyright (C)  2000
C	     University Corporation for Atmospheric Research
C			     All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C

c Fortran function lblank
c
c Returns:	Index of last character in string
c
c Side Effects:	None
c
c Purpose:	To provide the ability to concatenate two
c		character strings based on what is in them
c		rather than their length.
c
c Comments:	Used to be a relatively standard function,
c		before the onset (onslaught?) of System V.
c
c Author:	Don Middleton
c		NCAR Graphics Group
c		November 1988
c
      integer function lblank(str)
      character*(*) str

      do 10 i=len(str), 1, -1
	if (str(i:i).ne.' ') then
	  lblank = i
	  return
	endif
10    continue

      lblank = 1
      end

C
C	$Id: gcelcd.f,v 1.5 2008-07-27 00:20:56 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
        SUBROUTINE GCELCD(WKID,IOS,STATUS)
C
C  Process the control elements.
C
C  At present the working control elements include:
C     VDC INTEGER PRECISION
C     CLIP RECTANGLE
C     CLIP INDICATOR
C  All other control elements will be ignored.
C
      include 'trinst.h'
      include 'trpars.h'
      include 'trstat.h'
      include 'trcode.h'
      include 'gkscom.h'
C
      INTEGER WKID, IOS, STATUS
      INTEGER TMP, XMIN, XMAX, YMIN, YMAX, CLPDAT(4)
C
      STATUS = 0
C
      IF (OPID .EQ. CELMVI) THEN
C
C  VDC integer precision.
C
        CALL GOPDEC(MOPLEN,MWHCPR,1,IOS,STATUS)
      ELSE IF (OPID .EQ. CELMCR) THEN
C
C  Set the clip rectangle for normalization transformation 1 that
C  we are currently using.  Transform the clipping rectangle if
C  IGSGCP is non-zero.
C
        CALL GOPDEC(CLPDAT,MOPLEN,4,IOS,STATUS)
        XMIN = CLPDAT(1)
        XMIN = MIN(XMIN,CLPDAT(3))
        XMAX = CLPDAT(3)
        XMAX = MAX(XMAX,CLPDAT(1))
        YMIN = CLPDAT(2)
        YMIN = MIN(YMIN,CLPDAT(4))
        YMAX = CLPDAT(4)
        YMAX = MAX(YMAX,CLPDAT(2))
        IF (IGSGCP .EQ. 0) THEN
          CALL GSWN(1,REAL(XMIN)/32767.,REAL(XMAX)/32767.,
     +                   REAL(YMIN)/32767.,REAL(YMAX)/32767.)
          CALL GSVP(1,REAL(XMIN)/32767.,REAL(XMAX)/32767.,
     +                   REAL(YMIN)/32767.,REAL(YMAX)/32767.)
        ELSE
          XMN = REAL(XMIN)/32767.
          XMX = REAL(XMAX)/32767.
          YMN = REAL(YMIN)/32767.
          YMX = REAL(YMAX)/32767.
          XM1 = CURTM(1,1)*XMN + CURTM(1,2)*YMN + CURTM(1,3)
          YM1 = CURTM(2,1)*XMN + CURTM(2,2)*YMN + CURTM(2,3)
          XM2 = CURTM(1,1)*XMX + CURTM(1,2)*YMX + CURTM(1,3)
          YM2 = CURTM(2,1)*XMX + CURTM(2,2)*YMX + CURTM(2,3)
          XM1 = MAX(0.,XM1)
          XM2 = MIN(1.,XM2)
          YM1 = MAX(0.,YM1)
          YM2 = MIN(1.,YM2)
          CALL GSWN(1,XM1,XM2,YM1,YM2)
          CALL GSVP(1,XM1,XM2,YM1,YM2)
        ENDIF
C
      ELSE IF (OPID.EQ.CELMCI) THEN
C
C  Set the clipping indicator.
C
        CALL GOPDEC(TMP,MENCPR,1,IOS,STATUS)
        CALL GSCLIP(TMP)
      END IF
C
C  Check the instruction status.
C
      IF (STATUS .NE. 0) RETURN
C
C  If the instruction is continued, then loop to get the 
C  full operand list.
C
  10  CONTINUE
      IF (CNTINU) THEN
        CALL GNPART(IOS,STATUS) 
        IF (STATUS .NE. 0) RETURN
        GO TO 10
      END IF 
C
      RETURN
      END

      SUBROUTINE STPTRI( UPLO, DIAG, N, AP, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER          DIAG, UPLO
      INTEGER            INFO, N
*     ..
*     .. Array Arguments ..
      REAL               AP( * )
*     ..
*
*  Purpose
*  =======
*
*  STPTRI computes the inverse of a real upper or lower triangular
*  matrix A stored in packed format.
*
*  Arguments
*  =========
*
*  UPLO    (input) CHARACTER*1
*          = 'U':  A is upper triangular;
*          = 'L':  A is lower triangular.
*
*  DIAG    (input) CHARACTER*1
*          = 'N':  A is non-unit triangular;
*          = 'U':  A is unit triangular.
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  AP      (input/output) REAL array, dimension (N*(N+1)/2)
*          On entry, the upper or lower triangular matrix A, stored
*          columnwise in a linear array.  The j-th column of A is stored
*          in the array AP as follows:
*          if UPLO = 'U', AP(i + (j-1)*j/2) = A(i,j) for 1<=i<=j;
*          if UPLO = 'L', AP(i + (j-1)*((2*n-j)/2) = A(i,j) for j<=i<=n.
*          See below for further details.
*          On exit, the (triangular) inverse of the original matrix, in
*          the same packed storage format.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*          > 0:  if INFO = i, A(i,i) is exactly zero.  The triangular
*                matrix is singular and its inverse can not be computed.
*
*  Further Details
*  ===============
*
*  A triangular matrix A can be transferred to packed storage using one
*  of the following program segments:
*
*  UPLO = 'U':                      UPLO = 'L':
*
*        JC = 1                           JC = 1
*        DO 2 J = 1, N                    DO 2 J = 1, N
*           DO 1 I = 1, J                    DO 1 I = J, N
*              AP(JC+I-1) = A(I,J)              AP(JC+I-J) = A(I,J)
*      1    CONTINUE                    1    CONTINUE
*           JC = JC + J                      JC = JC + N - J + 1
*      2 CONTINUE                       2 CONTINUE
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ONE, ZERO
      PARAMETER          ( ONE = 1.0E+0, ZERO = 0.0E+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            NOUNIT, UPPER
      INTEGER            J, JC, JCLAST, JJ
      REAL               AJJ
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           SSCAL, STPMV, XERBLA
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      UPPER = LSAME( UPLO, 'U' )
      NOUNIT = LSAME( DIAG, 'N' )
      IF( .NOT.UPPER .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = -1
      ELSE IF( .NOT.NOUNIT .AND. .NOT.LSAME( DIAG, 'U' ) ) THEN
         INFO = -2
      ELSE IF( N.LT.0 ) THEN
         INFO = -3
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'STPTRI', -INFO )
         RETURN
      END IF
*
*     Check for singularity if non-unit.
*
      IF( NOUNIT ) THEN
         IF( UPPER ) THEN
            JJ = 0
            DO 10 INFO = 1, N
               JJ = JJ + INFO
               IF( AP( JJ ).EQ.ZERO )
     $            RETURN
   10       CONTINUE
         ELSE
            JJ = 1
            DO 20 INFO = 1, N
               IF( AP( JJ ).EQ.ZERO )
     $            RETURN
               JJ = JJ + N - INFO + 1
   20       CONTINUE
         END IF
         INFO = 0
      END IF
*
      IF( UPPER ) THEN
*
*        Compute inverse of upper triangular matrix.
*
         JC = 1
         DO 30 J = 1, N
            IF( NOUNIT ) THEN
               AP( JC+J-1 ) = ONE / AP( JC+J-1 )
               AJJ = -AP( JC+J-1 )
            ELSE
               AJJ = -ONE
            END IF
*
*           Compute elements 1:j-1 of j-th column.
*
            CALL STPMV( 'Upper', 'No transpose', DIAG, J-1, AP,
     $                  AP( JC ), 1 )
            CALL SSCAL( J-1, AJJ, AP( JC ), 1 )
            JC = JC + J
   30    CONTINUE
*
      ELSE
*
*        Compute inverse of lower triangular matrix.
*
         JC = N*( N+1 ) / 2
         DO 40 J = N, 1, -1
            IF( NOUNIT ) THEN
               AP( JC ) = ONE / AP( JC )
               AJJ = -AP( JC )
            ELSE
               AJJ = -ONE
            END IF
            IF( J.LT.N ) THEN
*
*              Compute elements j+1:n of j-th column.
*
               CALL STPMV( 'Lower', 'No transpose', DIAG, N-J,
     $                     AP( JCLAST ), AP( JC+1 ), 1 )
               CALL SSCAL( N-J, AJJ, AP( JC+1 ), 1 )
            END IF
            JCLAST = JC
            JC = JC - N + J - 2
   40    CONTINUE
      END IF
*
      RETURN
*
*     End of STPTRI
*
      END

      REAL             FUNCTION SLAPY3( X, Y, Z )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     October 31, 1992
*
*     .. Scalar Arguments ..
      REAL               X, Y, Z
*     ..
*
*  Purpose
*  =======
*
*  SLAPY3 returns sqrt(x**2+y**2+z**2), taking care not to cause
*  unnecessary overflow.
*
*  Arguments
*  =========
*
*  X       (input) REAL
*  Y       (input) REAL
*  Z       (input) REAL
*          X, Y and Z specify the values x, y and z.
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ZERO
      PARAMETER          ( ZERO = 0.0E0 )
*     ..
*     .. Local Scalars ..
      REAL               W, XABS, YABS, ZABS
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, MAX, SQRT
*     ..
*     .. Executable Statements ..
*
      XABS = ABS( X )
      YABS = ABS( Y )
      ZABS = ABS( Z )
      W = MAX( XABS, YABS, ZABS )
      IF( W.EQ.ZERO ) THEN
         SLAPY3 = ZERO
      ELSE
         SLAPY3 = W*SQRT( ( XABS / W )**2+( YABS / W )**2+
     $            ( ZABS / W )**2 )
      END IF
      RETURN
*
*     End of SLAPY3
*
      END

C
C	$Id: gqwkcl.f,v 1.5 2008-07-27 00:21:01 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GQWKCL(WTYPE,ERRIND,VRTYPE)
C
C  INQUIRE WORKSTATION CLASSIFICATION
C
      include 'gkscom.h'
C
      INTEGER WTYPE,ERRIND,VRTYPE
C
C  Check if GKS is in the proper state.
C
      CALL GZCKST(8,-1,ERRIND)
      IF (ERRIND .NE. 0) GOTO 100
C
C  Check that the workstation type is valid.
C
      CALL GZCKWK(22,-1,IDUM,WTYPE,ERRIND)
      IF (ERRIND .NE. 0) GO TO 100
C
C  Invoke interface.
C
      FCODE = -128
      CONT  = 0
      CALL GZROI(0)
      IL1   = 1
      IL2   = 1
      ID(1) = WTYPE
      IWK   = -1
      CALL GZIQWK(WTYPE,IWK)
      IF (RERR .NE. 0) THEN
        ERRIND = RERR
        GOTO 100
      ENDIF
      VRTYPE = ID(2)
      RETURN
C
  100 CONTINUE
      VRTYPE = -1
      RETURN
      END

C
C $Id: agezsu.f,v 1.7 2008-07-27 00:14:34 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE AGEZSU (ITOC,XDRA,YDRA,IDXY,MANY,NPTS,LABG,IIVX,IIEX,
     +                                                      IIVY,IIEY)
C
      REAL XDRA(1),YDRA(1)
      CHARACTER*(*) LABG
C
C The routine AGEZSU is used by the AUTOGRAPH routines EZY, EZXY, EZMY,
C EZMXY, and IDIOT to examine those parameters which are peculiar to the
C old version of AUTOGRAPH and to do the appropriate call to AGSTUP.
C The arguments are as follows:
C
C -- ITOC indicates which routine is calling AGEZSU, as follows:
C
C     -- ITOC .EQ. 1 - call by EZY
C     -- ITOC .EQ. 2 - call by EZXY
C     -- ITOC .EQ. 3 - call by EZMY
C     -- ITOC .EQ. 4 - call by EZMXY
C     -- ITOC .EQ. 5 - call by IDIOT
C
C -- XDRA is an array of x-coordinate data.
C
C -- YDRA is an array of y-coordinate data.
C
C -- IDXY is the first dimension of YDRA.
C
C -- MANY is the number of curves defined by XDRA and YDRA.
C
C -- NPTS is the number of points per curve.
C
C -- LABG is a new header label (or the single character CHAR(0), if the
C    header label is to be unchanged).
C
C -- IIVX, IIEX, IIVY, and IIEY are indexing controls for the x and y
C    data arrays, computed and returned by AGEZSU for use in setting up
C    calls to the routine AGCURV.
C
C Examine the frame-advance parameter.  Do frame advance as appropriate.
C
      CALL AGGETI ('FRAM.',IFRA)
      IFRA=MAX(1,MIN(3,IFRA))
C
      IF (IFRA.EQ.3) CALL FRAME
C
C Set up the header label.
C
      IF (ICHAR(LABG(1:1)).NE.0) THEN
        CALL AGSETC ('LABE/NAME.', 'T')
        CALL AGSETI ('LINE/NUMB.', 100)
        CALL AGSETC ('LINE/TEXT.',LABG)
      END IF
C
C Set up the AGSTUP arguments defining the coordinate-data arrays.
C
      CALL AGGETI ('ROW .',IROW)
      IROW=MAX(-2,MIN(+2,IROW))
C
      NVIY=MANY
      IIVY=IDXY
      NEVY=NPTS
      IIEY=1
C
      IF (IROW.LE.0.AND.ITOC.GE.3.AND.ITOC.LE.4) THEN
        IIVY=1
        IIEY=IDXY
      END IF
C
      NVIX=NVIY
      IIVX=IIVY
      NEVX=NEVY
      IIEX=IIEY
C
      IF (ABS(IROW).LE.1) THEN
        NVIX=1
        IIVX=0
        NEVX=NPTS
        IIEX=1
      END IF
C
      IF (ITOC.EQ.1.OR.ITOC.EQ.3) IIEX=0
C
C Do the AGSTUP call.
C
      CALL AGSTUP (XDRA,NVIX,IIVX,NEVX,IIEX,YDRA,NVIY,IIVY,NEVY,IIEY)
C
C Done.
C
      RETURN
C
      END

C
C       $Id: stutil.f,v 1.5 2009-04-22 19:26:37 dbrown Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
C
      SUBROUTINE STARDR(XUS,YUS,XND,YND,TA,VMF,SV,IAM,STUMSL,IST)
C
C This routine draws the arrow. Calculations are in fractional
C coordinates to ensure uniform arrows irrespective of the 
C mapping in effect.
C A small fraction of the differential change is used to find the
C tangent angle at the current position. Once the angle is known the
C arrow can be drawn at a fixed size independent of the mapping
C routine currently employed.
C
C Input parameters:
C
C XUS,YUS - current position in user space
C XND,YND - current position in NDC space
C TA    - Angle in NDC
C VMF   - magnitude of vector relative to maximum magnitude
C SV    - scalar value used to determine arrowhead color
C IAM   - Area mask array
C STUMSL - User defined masked streamline drawing routine
C
C Output parameters:
C
C IST - Status code, indicates success or failure
C
      DIMENSION  IAM(*)
      EXTERNAL STUMSL
C
C ---------------------------------------------------------------------
C
C NOTE:
C Since implicit typing is used for all real and integer variables
C a consistent length convention has been adopted to help clarify the
C significance of the variables encountered in the code for this 
C utility. All local variable and subroutine parameter identifiers 
C are limited to 1,2,or 3 characters. Four character names identify  
C members of common blocks. Five and 6 character variable names 
C denote PARAMETER constants or subroutine or function names.
C
C Declare the ST common blocks.
C
      PARAMETER (IPLVLS = 256)
C
C Integer and real common block variables
C
C
      COMMON / STPAR /
     +                IUD1       ,IVD1       ,IPD1       ,
     +                IXD1       ,IXDM       ,IYD1       ,IYDN       ,
     +                IXM1       ,IYM1       ,IXM2       ,IYM2       ,
     +                IWKD       ,IWKU       ,ISET       ,IERR       ,
     +                IXIN       ,IYIN       ,IMSK       ,ICPM       ,
     +                NLVL       ,IPAI       ,ICTV       ,WDLV       ,
     +                UVMN       ,UVMX       ,PMIN       ,PMAX       ,
     +                IPLR       ,ISST       ,
     +                ICLR(IPLVLS)           ,TVLU(IPLVLS)
C
      COMMON / STTRAN /
     +                UVPS       ,
     +                UVPL       ,UVPR       ,UVPB       ,UVPT       ,
     +                UWDL       ,UWDR       ,UWDB       ,UWDT       ,
     +                UXC1       ,UXCM       ,UYC1       ,UYCN 
C
C Stream algorithm parameters
C
      COMMON / STSTRM /
     +                ISGD       ,IAGD       ,RARL       ,ICKP       ,
     +                ICKX       ,ITRP       ,ICYK       ,RVNL       ,
     +                ISVF       ,RUSV       ,RVSV       ,RNDA       ,
     +                ISPC       ,RPSV       ,RCDS       ,RSSP       ,
     +                RDFM       ,RSMD       ,RAMD       ,IGBS       ,
     +                ISTM       ,RVRL       ,RVFR       ,RVRM       ,
     +                IVPO       ,RAFR       ,RDMX       ,RDMN
C
C Text related parameters
C Note: graphical text output is not yet implemented for the
C       Streamline utility.
C
      COMMON / STTXP /
     +                FCWM    ,ICSZ    ,
     +                FMNS    ,FMNX    ,FMNY    ,IMNP    ,IMNC  ,
     +                FMXS    ,FMXX    ,FMXY    ,IMXP    ,IMXC  ,
     +                FZFS    ,FZFX    ,FZFY    ,IZFP    ,IZFC  ,
     +                FILS    ,FILX    ,FILY    ,IILP    ,IILC 
C
C Character variable declartions
C
      CHARACTER*160 CSTR
      PARAMETER (IPCHSZ=80)
      CHARACTER*(IPCHSZ)  CMNT,CMXT,CZFT,CILT
C
C Text string parameters
C
      COMMON / STCHAR / CSTR,CMNT,CMXT,CZFT,CILT
C
      SAVE /STPAR/, /STTRAN/, /STSTRM/, /STTXP/, /STCHAR/
C
C Internal buffer lengths
C
C IPNPTS - Number of points in the point buffer -- not less than 3
C IPLSTL - Streamline-crossover-check circular list length
C IPGRCT - Number of groups supported for area masking
C
      PARAMETER (IPNPTS = 256, IPLSTL = 750, IPGRCT = 64)
C
C --------------------------------------------------------------------
C
C The mapping common block: made available to user mapping routines
C
      COMMON /STMAP/
     +                IMAP       ,LNLG       ,INVX       ,INVY       ,
     +                XLOV       ,XHIV       ,YLOV       ,YHIV       ,
     +                WXMN       ,WXMX       ,WYMN       ,WYMX       ,
     +                XVPL       ,XVPR       ,YVPB       ,YVPT       ,
     +                XGDS       ,YGDS       ,NXCT       ,NYCT       ,
     +                ITRT       ,FW2W       ,FH2H       ,
     +                DFMG       ,VNML       ,RBIG       ,IBIG
C
      SAVE /STMAP/
C
C Math constants
C
      PARAMETER (PDTOR  = 0.017453292519943,
     +           PRTOD  = 57.2957795130823,
     +           P1XPI  = 3.14159265358979,
     +           P2XPI  = 6.28318530717959,
     +           P1D2PI = 1.57079632679489,
     +           P5D2PI = 7.85398163397448) 
C
C ---------------------------------------------------------------------
C
C Point buffers
C
      DIMENSION AX(3), AY(3), AS(3)
C
C Local variables
C
C AX, AY   - Arrow head point buffers
C AS       - Arrow head scalar value
C DXW, DYW - Change in X,Y in window coordinates
C XF, YF   - Arrow head position in the fractional system
C DXF,DYF  - Incremental change in the fractional system
C PHI      - Tangent angle
C K        - Loop index and sign factor for each edge of the arrow
C KK       - Index for the arrow head array, within the loop
C D30      - Half the angle of the point of the arrow head (about 30 o)
C XX,YY    - Ends of the arrow in window coordinates
C
C Parameters:
C
C PHFANG - Half the angle of the arrow head (0.5 in radians is 
C          approximately equivalent to 30 degrees)
C PLWFCT - Linewidth factor, arrow size is increased by this 
C          much when the linewidth is greater than 1.0

      PARAMETER (PHFANG=0.5, PLWFCT=0.15)
C
C ---------------------------------------------------------------------
C
      IST=0
C
      AX(2) = XUS
      AY(2) = YUS
      AS(2) = SV
      FLW = 1.0 + PLWFCT*MAX(0.0,WDLV-1.0)
      SIZ = RNDA * RAFR
      SIZ = SIZ + (RNDA - SIZ) * VMF
C
      DO 10 K = -1,1,2
C
C K serves as a sign determining factor; KK indexes the point array.
C
         KK=K+2
         D30 = -(P1D2PI-TA)+REAL(K)*PHFANG
         XX = +SIZ*FLW*SIN(D30)+XND
         YY = -SIZ*FLW*COS(D30)+YND
         AX(KK) = CFUX(XX)
         AY(KK) = CFUY(YY)
         AS(KK) = SV
C
 10   CONTINUE
C
      CALL STLNSG(AX,AY,AS,3,IAM,STUMSL)
C
C Done
C
      RETURN
      END
C
C ---------------------------------------------------------------------
C
      SUBROUTINE STLNSG(X,Y,P,IPC,IAM,STUMSL)
C
C This routine draws colored streamline segments for each different
C color represented in the scalar value buffer.
C If masking is in effect the area line drawing subroutine, 
C ARDRLN is called. Otherwise CURVE is invoked. 
C  
C Input parameters:
C
C X,Y - Point arrays
C P   - Scalar value array
C IPC - Number of points
C IAM   - Area mask array
C STUMSL - User-defined masked streamline drawing routine
C
      DIMENSION X(IPC), Y(IPC), P(IPC)
      DIMENSION  IAM(*)
      EXTERNAL STUMSL
C
C ---------------------------------------------------------------------
C
C NOTE:
C Since implicit typing is used for all real and integer variables
C a consistent length convention has been adopted to help clarify the
C significance of the variables encountered in the code for this 
C utility. All local variable and subroutine parameter identifiers 
C are limited to 1,2,or 3 characters. Four character names identify  
C members of common blocks. Five and 6 character variable names 
C denote PARAMETER constants or subroutine or function names.
C
C Declare the ST common blocks.
C
      PARAMETER (IPLVLS = 256)
C
C Integer and real common block variables
C
C
      COMMON / STPAR /
     +                IUD1       ,IVD1       ,IPD1       ,
     +                IXD1       ,IXDM       ,IYD1       ,IYDN       ,
     +                IXM1       ,IYM1       ,IXM2       ,IYM2       ,
     +                IWKD       ,IWKU       ,ISET       ,IERR       ,
     +                IXIN       ,IYIN       ,IMSK       ,ICPM       ,
     +                NLVL       ,IPAI       ,ICTV       ,WDLV       ,
     +                UVMN       ,UVMX       ,PMIN       ,PMAX       ,
     +                IPLR       ,ISST       ,
     +                ICLR(IPLVLS)           ,TVLU(IPLVLS)
C
      COMMON / STTRAN /
     +                UVPS       ,
     +                UVPL       ,UVPR       ,UVPB       ,UVPT       ,
     +                UWDL       ,UWDR       ,UWDB       ,UWDT       ,
     +                UXC1       ,UXCM       ,UYC1       ,UYCN 
C
C Stream algorithm parameters
C
      COMMON / STSTRM /
     +                ISGD       ,IAGD       ,RARL       ,ICKP       ,
     +                ICKX       ,ITRP       ,ICYK       ,RVNL       ,
     +                ISVF       ,RUSV       ,RVSV       ,RNDA       ,
     +                ISPC       ,RPSV       ,RCDS       ,RSSP       ,
     +                RDFM       ,RSMD       ,RAMD       ,IGBS       ,
     +                ISTM       ,RVRL       ,RVFR       ,RVRM       ,
     +                IVPO       ,RAFR       ,RDMX       ,RDMN
C
C Text related parameters
C Note: graphical text output is not yet implemented for the
C       Streamline utility.
C
      COMMON / STTXP /
     +                FCWM    ,ICSZ    ,
     +                FMNS    ,FMNX    ,FMNY    ,IMNP    ,IMNC  ,
     +                FMXS    ,FMXX    ,FMXY    ,IMXP    ,IMXC  ,
     +                FZFS    ,FZFX    ,FZFY    ,IZFP    ,IZFC  ,
     +                FILS    ,FILX    ,FILY    ,IILP    ,IILC 
C
C Character variable declartions
C
      CHARACTER*160 CSTR
      PARAMETER (IPCHSZ=80)
      CHARACTER*(IPCHSZ)  CMNT,CMXT,CZFT,CILT
C
C Text string parameters
C
      COMMON / STCHAR / CSTR,CMNT,CMXT,CZFT,CILT
C
      SAVE /STPAR/, /STTRAN/, /STSTRM/, /STTXP/, /STCHAR/
C
C Internal buffer lengths
C
C IPNPTS - Number of points in the point buffer -- not less than 3
C IPLSTL - Streamline-crossover-check circular list length
C IPGRCT - Number of groups supported for area masking
C
      PARAMETER (IPNPTS = 256, IPLSTL = 750, IPGRCT = 64)
C
      DIMENSION IAI(IPGRCT),IAG(IPGRCT)
      DIMENSION XO(IPNPTS), YO(IPNPTS)
      DIMENSION IC(IPNPTS)
C
      IF (ICTV .EQ. 0) THEN
         IF (IMSK.LT.1) THEN
            CALL CURVE(X,Y,IPC)
         ELSE
            CALL ARDRLN(IAM, X, Y, IPC, XO, YO, IPC, 
     +           IAI, IAG, IPGRCT, STUMSL)
         END IF
C
         RETURN
C
      END IF
C
C Colored streamlines:
C First convert the scalar values into color indexes.
C
      DO 20 I = 1,IPC,1
         IF (ISPC.GE.0 .AND. P(I).EQ.RPSV) THEN
            IC(I) = ISPC
            GO TO 20
         END IF
         DO 10 J = 1,NLVL,1
            IF (P(I).LE.TVLU(J) .OR. J.EQ.NLVL) THEN
               IC(I) = ICLR(J)
               GO TO 20
            END IF
 10      CONTINUE
 20   CONTINUE

      ICI = IC(1)
      IS = 1
      DO 30 I = 1,IPC,1
         IF (IC(I) .NE. ICI) THEN
            NPT = I - IS + 1
            IF (NPT .EQ. 1) THEN
               NPT = NPT + 1
               IF (IS .EQ. IPC) THEN
                  IS = IPC - 1
               END IF
            END IF
            CALL GSPLCI(ICI)
            IF (IMSK.LT.1) THEN
               CALL CURVE(X(IS),Y(IS),NPT)
            ELSE
               CALL ARDRLN(IAM, X(IS), Y(IS), NPT, XO, YO, IPC, 
     +              IAI, IAG, IPGRCT, STUMSL)
            END IF
            ICI = IC(I)
            IS = I
         END IF
 30   CONTINUE
C
      NPT = IPC - IS + 1
      IF (NPT .EQ. 1) THEN
         NPT = NPT + 1
         IF (IS .EQ. IPC) THEN
            IS = IPC - 1
         END IF
      END IF
      CALL GSPLCI(ICI)
      IF (IMSK.LT.1) THEN
         CALL CURVE(X(IS),Y(IS),NPT)
      ELSE
         CALL ARDRLN(IAM, X(IS), Y(IS), NPT, XO, YO, IPC, 
     +        IAI, IAG, IPGRCT, STUMSL)
      END IF
C            
C Done
C 
      RETURN
      END
C
C ---------------------------------------------------------------------
C
      SUBROUTINE STSVCK(U,V,I,J,IST)
C
      DIMENSION  U(IUD1,*), V(IVD1,*)
C
C Checks for special values in the vicinity of I,J
C
C Input parameters
C
C U,V - vector field components array
C I,J - current array position
C
C Output parameters:
C
C IST - status value, 0 if no special values in neighborhood
C
C ---------------------------------------------------------------------
C
C NOTE:
C Since implicit typing is used for all real and integer variables
C a consistent length convention has been adopted to help clarify the
C significance of the variables encountered in the code for this 
C utility. All local variable and subroutine parameter identifiers 
C are limited to 1,2,or 3 characters. Four character names identify  
C members of common blocks. Five and 6 character variable names 
C denote PARAMETER constants or subroutine or function names.
C
C Declare the ST common blocks.
C
      PARAMETER (IPLVLS = 256)
C
C Integer and real common block variables
C
C
      COMMON / STPAR /
     +                IUD1       ,IVD1       ,IPD1       ,
     +                IXD1       ,IXDM       ,IYD1       ,IYDN       ,
     +                IXM1       ,IYM1       ,IXM2       ,IYM2       ,
     +                IWKD       ,IWKU       ,ISET       ,IERR       ,
     +                IXIN       ,IYIN       ,IMSK       ,ICPM       ,
     +                NLVL       ,IPAI       ,ICTV       ,WDLV       ,
     +                UVMN       ,UVMX       ,PMIN       ,PMAX       ,
     +                IPLR       ,ISST       ,
     +                ICLR(IPLVLS)           ,TVLU(IPLVLS)
C
      COMMON / STTRAN /
     +                UVPS       ,
     +                UVPL       ,UVPR       ,UVPB       ,UVPT       ,
     +                UWDL       ,UWDR       ,UWDB       ,UWDT       ,
     +                UXC1       ,UXCM       ,UYC1       ,UYCN 
C
C Stream algorithm parameters
C
      COMMON / STSTRM /
     +                ISGD       ,IAGD       ,RARL       ,ICKP       ,
     +                ICKX       ,ITRP       ,ICYK       ,RVNL       ,
     +                ISVF       ,RUSV       ,RVSV       ,RNDA       ,
     +                ISPC       ,RPSV       ,RCDS       ,RSSP       ,
     +                RDFM       ,RSMD       ,RAMD       ,IGBS       ,
     +                ISTM       ,RVRL       ,RVFR       ,RVRM       ,
     +                IVPO       ,RAFR       ,RDMX       ,RDMN
C
C Text related parameters
C Note: graphical text output is not yet implemented for the
C       Streamline utility.
C
      COMMON / STTXP /
     +                FCWM    ,ICSZ    ,
     +                FMNS    ,FMNX    ,FMNY    ,IMNP    ,IMNC  ,
     +                FMXS    ,FMXX    ,FMXY    ,IMXP    ,IMXC  ,
     +                FZFS    ,FZFX    ,FZFY    ,IZFP    ,IZFC  ,
     +                FILS    ,FILX    ,FILY    ,IILP    ,IILC 
C
C Character variable declartions
C
      CHARACTER*160 CSTR
      PARAMETER (IPCHSZ=80)
      CHARACTER*(IPCHSZ)  CMNT,CMXT,CZFT,CILT
C
C Text string parameters
C
      COMMON / STCHAR / CSTR,CMNT,CMXT,CZFT,CILT
C
      SAVE /STPAR/, /STTRAN/, /STSTRM/, /STTXP/, /STCHAR/
C
C Internal buffer lengths
C
C IPNPTS - Number of points in the point buffer -- not less than 3
C IPLSTL - Streamline-crossover-check circular list length
C IPGRCT - Number of groups supported for area masking
C
      PARAMETER (IPNPTS = 256, IPLSTL = 750, IPGRCT = 64)
C
C ---------------------------------------------------------------------
C
      IST = 0
C
      IF (U(I,J).EQ.RUSV) THEN
         IST = -1
         RETURN
      ELSE IF (V(I,J).EQ.RVSV) THEN
         IST = -1
         RETURN
      END IF
C
      IF (I.EQ.IXDM .OR. J.EQ.IYDN) THEN
         RETURN
      END IF
C
      IF (U(I,J+1).EQ.RUSV) THEN
         IST = -1
      ELSE IF (U(I+1,J).EQ.RUSV) THEN
         IST = -1
      ELSE IF (U(I+1,J+1).EQ.RUSV) THEN
         IST = -1
      ELSE IF (V(I,J+1).EQ.RVSV) THEN
         IST = -1
      ELSE IF (V(I+1,J).EQ.RVSV) THEN
         IST = -1
      ELSE IF (V(I+1,J+1).EQ.RVSV) THEN
         IST = -1
      END IF
C
C Done
C
      RETURN
      END
C
C ---------------------------------------------------------------------
C
      SUBROUTINE STMPUV(UI,VI,UO,VO,IST)
C
C Maps the U,V vector component values
C
C Input parameters:
C
C UI,VI  - Input values of U,V
C
C     Output parameters:
C
C UO,VO  - Output mapped component values
C IST    - Status value
C 
C ---------------------------------------------------------------------
C
C NOTE:
C Since implicit typing is used for all real and integer variables
C a consistent length convention has been adopted to help clarify the
C significance of the variables encountered in the code for this 
C utility. All local variable and subroutine parameter identifiers 
C are limited to 1,2,or 3 characters. Four character names identify  
C members of common blocks. Five and 6 character variable names 
C denote PARAMETER constants or subroutine or function names.
C
C Declare the ST common blocks.
C
      PARAMETER (IPLVLS = 256)
C
C Integer and real common block variables
C
C
      COMMON / STPAR /
     +                IUD1       ,IVD1       ,IPD1       ,
     +                IXD1       ,IXDM       ,IYD1       ,IYDN       ,
     +                IXM1       ,IYM1       ,IXM2       ,IYM2       ,
     +                IWKD       ,IWKU       ,ISET       ,IERR       ,
     +                IXIN       ,IYIN       ,IMSK       ,ICPM       ,
     +                NLVL       ,IPAI       ,ICTV       ,WDLV       ,
     +                UVMN       ,UVMX       ,PMIN       ,PMAX       ,
     +                IPLR       ,ISST       ,
     +                ICLR(IPLVLS)           ,TVLU(IPLVLS)
C
      COMMON / STTRAN /
     +                UVPS       ,
     +                UVPL       ,UVPR       ,UVPB       ,UVPT       ,
     +                UWDL       ,UWDR       ,UWDB       ,UWDT       ,
     +                UXC1       ,UXCM       ,UYC1       ,UYCN 
C
C Stream algorithm parameters
C
      COMMON / STSTRM /
     +                ISGD       ,IAGD       ,RARL       ,ICKP       ,
     +                ICKX       ,ITRP       ,ICYK       ,RVNL       ,
     +                ISVF       ,RUSV       ,RVSV       ,RNDA       ,
     +                ISPC       ,RPSV       ,RCDS       ,RSSP       ,
     +                RDFM       ,RSMD       ,RAMD       ,IGBS       ,
     +                ISTM       ,RVRL       ,RVFR       ,RVRM       ,
     +                IVPO       ,RAFR       ,RDMX       ,RDMN
C
C Text related parameters
C Note: graphical text output is not yet implemented for the
C       Streamline utility.
C
      COMMON / STTXP /
     +                FCWM    ,ICSZ    ,
     +                FMNS    ,FMNX    ,FMNY    ,IMNP    ,IMNC  ,
     +                FMXS    ,FMXX    ,FMXY    ,IMXP    ,IMXC  ,
     +                FZFS    ,FZFX    ,FZFY    ,IZFP    ,IZFC  ,
     +                FILS    ,FILX    ,FILY    ,IILP    ,IILC 
C
C Character variable declartions
C
      CHARACTER*160 CSTR
      PARAMETER (IPCHSZ=80)
      CHARACTER*(IPCHSZ)  CMNT,CMXT,CZFT,CILT
C
C Text string parameters
C
      COMMON / STCHAR / CSTR,CMNT,CMXT,CZFT,CILT
C
      SAVE /STPAR/, /STTRAN/, /STSTRM/, /STTXP/, /STCHAR/
C
C Internal buffer lengths
C
C IPNPTS - Number of points in the point buffer -- not less than 3
C IPLSTL - Streamline-crossover-check circular list length
C IPGRCT - Number of groups supported for area masking
C
      PARAMETER (IPNPTS = 256, IPLSTL = 750, IPGRCT = 64)
C
C --------------------------------------------------------------------
C
C The mapping common block: made available to user mapping routines
C
      COMMON /STMAP/
     +                IMAP       ,LNLG       ,INVX       ,INVY       ,
     +                XLOV       ,XHIV       ,YLOV       ,YHIV       ,
     +                WXMN       ,WXMX       ,WYMN       ,WYMX       ,
     +                XVPL       ,XVPR       ,YVPB       ,YVPT       ,
     +                XGDS       ,YGDS       ,NXCT       ,NYCT       ,
     +                ITRT       ,FW2W       ,FH2H       ,
     +                DFMG       ,VNML       ,RBIG       ,IBIG
C
      SAVE /STMAP/
C
C Math constants
C
      PARAMETER (PDTOR  = 0.017453292519943,
     +           PRTOD  = 57.2957795130823,
     +           P1XPI  = 3.14159265358979,
     +           P2XPI  = 6.28318530717959,
     +           P1D2PI = 1.57079632679489,
     +           P5D2PI = 7.85398163397448) 
C
C Statement functions for field tranformations
C
      FU(X,Y) = X
      FV(X,Y) = Y
C
C ---------------------------------------------------------------------
C
      IST = 0
C
C Input array polar mode
C
      IF (IPLR .LT. 1) THEN
         UT=UI
         VT=VI
      ELSE IF (IPLR .EQ. 1) THEN
         UT = UI*COS(PDTOR*VI)
         VT = UI*SIN(PDTOR*VI)
      ELSE IF (IPLR .GT. 1) THEN
         UT = UI*COS(VI)
         VT = UI*SIN(VI)
      END IF
C
C Allow mapping using FU,FV functions
C
      UO = FU(UT,VT)
      VO = FV(UT,VT)
C
C Done
C
      RETURN
      END
C
C ---------------------------------------------------------------------
C
      SUBROUTINE STZERO
C
C ---------------------------------------------------------------------
C
C NOTE:
C Since implicit typing is used for all real and integer variables
C a consistent length convention has been adopted to help clarify the
C significance of the variables encountered in the code for this 
C utility. All local variable and subroutine parameter identifiers 
C are limited to 1,2,or 3 characters. Four character names identify  
C members of common blocks. Five and 6 character variable names 
C denote PARAMETER constants or subroutine or function names.
C
C Declare the ST common blocks.
C
      PARAMETER (IPLVLS = 256)
C
C Integer and real common block variables
C
C
      COMMON / STPAR /
     +                IUD1       ,IVD1       ,IPD1       ,
     +                IXD1       ,IXDM       ,IYD1       ,IYDN       ,
     +                IXM1       ,IYM1       ,IXM2       ,IYM2       ,
     +                IWKD       ,IWKU       ,ISET       ,IERR       ,
     +                IXIN       ,IYIN       ,IMSK       ,ICPM       ,
     +                NLVL       ,IPAI       ,ICTV       ,WDLV       ,
     +                UVMN       ,UVMX       ,PMIN       ,PMAX       ,
     +                IPLR       ,ISST       ,
     +                ICLR(IPLVLS)           ,TVLU(IPLVLS)
C
      COMMON / STTRAN /
     +                UVPS       ,
     +                UVPL       ,UVPR       ,UVPB       ,UVPT       ,
     +                UWDL       ,UWDR       ,UWDB       ,UWDT       ,
     +                UXC1       ,UXCM       ,UYC1       ,UYCN 
C
C Stream algorithm parameters
C
      COMMON / STSTRM /
     +                ISGD       ,IAGD       ,RARL       ,ICKP       ,
     +                ICKX       ,ITRP       ,ICYK       ,RVNL       ,
     +                ISVF       ,RUSV       ,RVSV       ,RNDA       ,
     +                ISPC       ,RPSV       ,RCDS       ,RSSP       ,
     +                RDFM       ,RSMD       ,RAMD       ,IGBS       ,
     +                ISTM       ,RVRL       ,RVFR       ,RVRM       ,
     +                IVPO       ,RAFR       ,RDMX       ,RDMN
C
C Text related parameters
C Note: graphical text output is not yet implemented for the
C       Streamline utility.
C
      COMMON / STTXP /
     +                FCWM    ,ICSZ    ,
     +                FMNS    ,FMNX    ,FMNY    ,IMNP    ,IMNC  ,
     +                FMXS    ,FMXX    ,FMXY    ,IMXP    ,IMXC  ,
     +                FZFS    ,FZFX    ,FZFY    ,IZFP    ,IZFC  ,
     +                FILS    ,FILX    ,FILY    ,IILP    ,IILC 
C
C Character variable declartions
C
      CHARACTER*160 CSTR
      PARAMETER (IPCHSZ=80)
      CHARACTER*(IPCHSZ)  CMNT,CMXT,CZFT,CILT
C
C Text string parameters
C
      COMMON / STCHAR / CSTR,CMNT,CMXT,CZFT,CILT
C
      SAVE /STPAR/, /STTRAN/, /STSTRM/, /STTXP/, /STCHAR/
C
C Internal buffer lengths
C
C IPNPTS - Number of points in the point buffer -- not less than 3
C IPLSTL - Streamline-crossover-check circular list length
C IPGRCT - Number of groups supported for area masking
C
      PARAMETER (IPNPTS = 256, IPLSTL = 750, IPGRCT = 64)
C --------------------------------------------------------------------
C
C The mapping common block: made available to user mapping routines
C
      COMMON /STMAP/
     +                IMAP       ,LNLG       ,INVX       ,INVY       ,
     +                XLOV       ,XHIV       ,YLOV       ,YHIV       ,
     +                WXMN       ,WXMX       ,WYMN       ,WYMX       ,
     +                XVPL       ,XVPR       ,YVPB       ,YVPT       ,
     +                XGDS       ,YGDS       ,NXCT       ,NYCT       ,
     +                ITRT       ,FW2W       ,FH2H       ,
     +                DFMG       ,VNML       ,RBIG       ,IBIG
C
      SAVE /STMAP/
C
C Math constants
C
      PARAMETER (PDTOR  = 0.017453292519943,
     +           PRTOD  = 57.2957795130823,
     +           P1XPI  = 3.14159265358979,
     +           P2XPI  = 6.28318530717959,
     +           P1D2PI = 1.57079632679489,
     +           P5D2PI = 7.85398163397448) 
C
      IF (CZFT(1:1) .EQ. ' ') THEN
         RETURN
      END IF
C
      CALL GQPLCI(IER,IOC)
      CALL GQTXCI(IER,IOT)
C
C Turn clipping off and SET to an identity transform
C
      CALL GQCLIP(IER,ICL,IAR)
      CALL GSCLIP(0)
      CALL GETSET(VPL,VPR,VPB,VPT,WDL,WDR,WDB,WDT,ILG)
      CALL SET(0.0,1.0,0.0,1.0,0.0,1.0,0.0,1.0,1)
C     
      XF = XVPL + FZFX * FW2W
      YF = YVPB + FZFY * FH2H
      CALL VVTXLN(CZFT,IPCHSZ,IB,IE)
      CALL VVTXIQ(CZFT(IB:IE),FZFS*FW2W,W,H)
      CALL VVTXPO(IZFP,XF,YF,W,H,XW,YW)
      IF (IZFC .GE. 0) THEN
         CALL GSTXCI(IZFC)
         CALL GSPLCI(IZFC)
      ELSE
         CALL  GSPLCI(IOT)
      END IF
C     
      CALL PLCHHQ(XW,YW,CZFT(IB:IE),FZFS*FW2W,0.0,0.0)
C     
      CALL GSTXCI(IOT)
      CALL GSPLCI(IOC)
C     
C     Restore clipping and the set transformation.
C     
      CALL GSCLIP(ICL)
      CALL SET(VPL,VPR,VPB,VPT,WDL,WDR,WDB,WDT,ILG)
C
C Done
C
      RETURN
      END
C
C ---------------------------------------------------------------------
C
      SUBROUTINE STITSV(PS,I,J,X,Y,DP)
C
C Input parameters:
C
C PS     - array containing scalar field values
C I,J    - the current grid indices
C X,Y    - the X,Y position relative to the grid
C
C Output parameters:
C
C DP     - Interpolated value of the scalar field value at the 
C          specified point
C
C Interpolation routine to calculate the interpolated scalar value.
C The philosphy here is to utilize as many points as possible
C (within reason) in order to obtain a pleasing and accurate plot.
C Interpolation schemes desired by other users may easily be
C substituted if desired.
C
      DIMENSION PS(IPD1,*)
C
C ---------------------------------------------------------------------
C
C NOTE:
C Since implicit typing is used for all real and integer variables
C a consistent length convention has been adopted to help clarify the
C significance of the variables encountered in the code for this 
C utility. All local variable and subroutine parameter identifiers 
C are limited to 1,2,or 3 characters. Four character names identify  
C members of common blocks. Five and 6 character variable names 
C denote PARAMETER constants or subroutine or function names.
C
C Declare the ST common blocks.
C
      PARAMETER (IPLVLS = 256)
C
C Integer and real common block variables
C
C
      COMMON / STPAR /
     +                IUD1       ,IVD1       ,IPD1       ,
     +                IXD1       ,IXDM       ,IYD1       ,IYDN       ,
     +                IXM1       ,IYM1       ,IXM2       ,IYM2       ,
     +                IWKD       ,IWKU       ,ISET       ,IERR       ,
     +                IXIN       ,IYIN       ,IMSK       ,ICPM       ,
     +                NLVL       ,IPAI       ,ICTV       ,WDLV       ,
     +                UVMN       ,UVMX       ,PMIN       ,PMAX       ,
     +                IPLR       ,ISST       ,
     +                ICLR(IPLVLS)           ,TVLU(IPLVLS)
C
      COMMON / STTRAN /
     +                UVPS       ,
     +                UVPL       ,UVPR       ,UVPB       ,UVPT       ,
     +                UWDL       ,UWDR       ,UWDB       ,UWDT       ,
     +                UXC1       ,UXCM       ,UYC1       ,UYCN 
C
C Stream algorithm parameters
C
      COMMON / STSTRM /
     +                ISGD       ,IAGD       ,RARL       ,ICKP       ,
     +                ICKX       ,ITRP       ,ICYK       ,RVNL       ,
     +                ISVF       ,RUSV       ,RVSV       ,RNDA       ,
     +                ISPC       ,RPSV       ,RCDS       ,RSSP       ,
     +                RDFM       ,RSMD       ,RAMD       ,IGBS       ,
     +                ISTM       ,RVRL       ,RVFR       ,RVRM       ,
     +                IVPO       ,RAFR       ,RDMX       ,RDMN
C
C Text related parameters
C Note: graphical text output is not yet implemented for the
C       Streamline utility.
C
      COMMON / STTXP /
     +                FCWM    ,ICSZ    ,
     +                FMNS    ,FMNX    ,FMNY    ,IMNP    ,IMNC  ,
     +                FMXS    ,FMXX    ,FMXY    ,IMXP    ,IMXC  ,
     +                FZFS    ,FZFX    ,FZFY    ,IZFP    ,IZFC  ,
     +                FILS    ,FILX    ,FILY    ,IILP    ,IILC 
C
C Character variable declartions
C
      CHARACTER*160 CSTR
      PARAMETER (IPCHSZ=80)
      CHARACTER*(IPCHSZ)  CMNT,CMXT,CZFT,CILT
C
C Text string parameters
C
      COMMON / STCHAR / CSTR,CMNT,CMXT,CZFT,CILT
C
      SAVE /STPAR/, /STTRAN/, /STSTRM/, /STTXP/, /STCHAR/
C
C Internal buffer lengths
C
C IPNPTS - Number of points in the point buffer -- not less than 3
C IPLSTL - Streamline-crossover-check circular list length
C IPGRCT - Number of groups supported for area masking
C
      PARAMETER (IPNPTS = 256, IPLSTL = 750, IPGRCT = 64)
C
C FDLI  - Double linear interpolation formula
C FBESL - Bessel 16 pt interpolation formula ( most used formula )
C FQUAD - Quadratic interpolation formula
C
      FDLI(Z,Z1,Z2,Z3,DX,DY) = (1.-DX)*((1.-DY)*Z +DY*Z1)
     +                         +     DX *((1.-DY)*Z2+DY*Z3)
      FBESL(Z,ZP1,ZP2,ZM1,DZ)=Z+DZ*(ZP1-Z+0.25*(DZ-1.)*((ZP2-ZP1-Z+ZM1)
     +                        +0.666667*(DZ-0.5)*(ZP2-3.*ZP1+3.*Z-ZM1)))
      FQUAD(Z,ZP1,ZM1,DZ)=Z+0.5*DZ*(ZP1-ZM1+DZ*(ZP1-2.*Z+ZM1))
C
C ---------------------------------------------------------------------
C
      DX = X-AINT(X)
      DY = Y-AINT(Y)
      ITF = 1
      IM1 = I-1
      IP2 = I+2
C
C Determine which interpolation formula to use 
C depending on I,J location or the special flags
C
      IF (I.GE.IXDM .OR. J.GE.IYDN) THEN
C
C This branch should never be taken if STDRAW is correct, but is 
C included for safety
C
         RETURN
C
      ELSE IF(ISPC.GE.0) THEN
         ITF = 1
C
C Check for special values in any of the interpolation cells
C and return the special value if necessary.
C
         IF (PS(I,J).EQ.RPSV .OR. PS(I,J+1).EQ.RPSV
     +        .OR. PS(I+1,J).EQ.RPSV .OR. PS(I+1,J+1).EQ.RPSV) THEN
            DP = RPSV
            RETURN
         END IF
      ELSE IF (ITRP.NE.0 .OR. ISVF.NE.0) THEN
         ITF = 1
      ELSE IF (J.GT.IYD1 .AND. J.LT.IYM1 
     +        .AND. I.GT.IXD1 .AND. I.LT.IXM1) THEN
         ITF = 2
      ELSE IF (J.EQ.IYM1 .AND. I.GT.IXD1 .AND. I.LT.IXM1) THEN
         ITF = 3
      ELSE IF (J.EQ.IYD1) THEN
         ITF = 1
      ELSE IF (ICYK.NE.1) THEN
         IF (I.EQ.IXD1) THEN
            ITF = 1
         ELSE IF (I.EQ.IXM1) THEN
            ITF = 4
         END IF
      ELSE IF (I.EQ.IXD1 .AND. J.LT.IYM1) THEN 
         IM1 = IXM1
         ITF = 2
      ELSE IF (I.EQ.IXM1 .AND. J.LT.IYM1) THEN
         IP2 = IXD1+1
         ITF = 2
      ELSE IF (J.EQ.IYM1 .AND. I.EQ.IXD1) THEN
         IM1 = IXM1
         ITF = 3
      ELSE IF (J.EQ.IYM1 .AND. I.EQ.IXM1) THEN
         IP2 = IXD1+1
         ITF = 3
      END IF
C
      IF (ITF .EQ. 1) THEN
C
C Double linear interpolation formula. This scheme works at all points
C but the resulting streamlines are not as pleasing as those drawn
C by FBESL or FQUAD. Currently this is utilized
C only at certain boundary points or if ITRP is not equal to zero,
C or if special value processing is turned on.
C
         DP = FDLI(PS(I,J),PS(I,J+1),PS(I+1,J),PS(I+1,J+1),DX,DY)
C
      ELSE IF (ITF .EQ. 2) THEN
C
C 16 point bessel interpolation scheme.
C
         UJM1 = FBESL(PS(I,J-1),PS(I+1,J-1),PS(IP2,J-1),PS(IM1,J-1),DX)
         UJ   = FBESL(PS(I,J),PS(I+1,J),PS(IP2,J),PS(IM1,J),DX)
         UJP1 = FBESL(PS(I,J+1),PS(I+1,J+1),PS(IP2,J+1),PS(IM1,J+1),DX)
         UJP2 = FBESL(PS(I,J+2),PS(I+1,J+2),PS(IP2,J+2),PS(IM1,J+2),DX)
         DP   = FBESL(UJ,UJP1,UJP2,UJM1,DY)
C
      ELSE IF (ITF .EQ. 3) THEN
C
C 12 point interpolation scheme applicable to one row from top boundary
C
         UJM1 = FBESL(PS(I,J-1),PS(I+1,J-1),PS(IP2,J-1),PS(IM1,J-1),DX)
         UJ   = FBESL(PS(I,J),PS(I+1,J),PS(IP2,J),PS(IM1,J),DX)
         UJP1 = FBESL(PS(I,J+1),PS(I+1,J+1),PS(IP2,J+1),PS(IM1,J+1),DX)
         DP   = FQUAD(UJ,UJP1,UJM1,DY)
C
      ELSE IF (ITF .EQ. 4) THEN
C
C 9 point interpolation scheme for use in the non-cyclic case
C at I=IXM1; J > IYD1 and J <= IYM1
C
         UJP1 = FQUAD(PS(I,J+1),PS(I+1,J+1),PS(IM1,J+1),DX)
         UJ   = FQUAD(PS(I,J),PS(I+1,J),PS(IM1,J),DX)
         UJM1 = FQUAD(PS(I,J-1),PS(I+1,J-1),PS(IM1,J-1),DX)
         DP   = FQUAD(UJ,UJP1,UJM1,DY)
C
      END IF
C
C Done
C
      RETURN
      END

C
C	$Id: gzn2wx.f,v 1.6 2008-07-27 00:21:04 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GZN2WX(N,P,Q)
C
C  This subroutine takes the N points in the real array P,
C  which are assumed to be in NDC coordinates, and, using
C  the current normalization transformation, converts them
C  into world coordinates and stores them in Q.
C  This subroutine operates on X-coordinates.
C
C
      include 'gkscom.h'
C
      INTEGER N
      REAL P(N),Q(N)
      ICNT  = CNT+1
      TMP1 = NTWN(ICNT,1)
      TMP2 = NTWN(ICNT,2)
      TMP3 = NTVP(ICNT,1)
      TMP4 = NTVP(ICNT,2)
      IF ((TMP3.EQ.TMP1) .AND. (TMP4.EQ.TMP2)) THEN
        DO 210 I=1,N
          Q(I) = P(I)
  210   CONTINUE
      ELSE
        SCALE = (TMP2-TMP1)/(TMP4-TMP3)
        DO 200 I=1,N
          Q(I) = TMP1+(P(I)-TMP3)*SCALE
  200   CONTINUE
      ENDIF
C
      RETURN
      END

C
C $Id: e1fnsp.f,v 1.5 2008-07-27 00:17:08 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      REAL FUNCTION E1FNSP (ECCNTS)
C
C This function computes the constant E1.
C
      IMPLICIT REAL (A-Z)
      DATA CON1,CON2,CON3 /0.375E0,0.25E0,0.46875E0/
      DATA ONE /1.0E0/
C
      E1FNSP = CON1 * ECCNTS * (ONE + CON2 * ECCNTS *
     .         (ONE + CON3 * ECCNTS))
C
      RETURN
      END

C
C      $Id: pr03f.f,v 1.7 2010-03-15 22:49:24 haley Exp $
C
C***********************************************************************
C                                                                      *
C                Copyright (C)  1996                                   *
C        University Corporation for Atmospheric Research               *
C                All Rights Reserved                                   *
C                                                                      *
C***********************************************************************
C
C  File:       pr03f.c
C
C  Author:     David Brown
C          National Center for Atmospheric Research
C          PO 3000, Boulder, Colorado
C
C  Date:       Mon May 13 14:00:21 MDT 1996
C
C  Description:    Demonstrates graphics primitives drawn in NDC space
C                  Many of the primitives are clipped in order to test
C                  the way clipping works.
C
      external NhlFAppClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFCairoWindowWorkstationClass
      external NhlFLogLinPlotClass
      external NhlFGraphicStyleClass

      integer rlist,grlist
      integer appid,wid,canvas,gsid,id
      integer i 
      real plx(4),ply(4),pmx(4),pmy(4),pgx(4),pgy(4)
      real dpgx(7),dpgy(7)
      data plx/0.1,0.9,0.5,0.1/
      data ply/0.1,0.1,0.9,0.1/
      data pmx/0.05,0.95,0.5,0.5/
      data pmy/0.05,0.05,1.05,0.5/
      data pgx/0.2,0.8,0.5,0.2/
      data pgy/0.25,0.25,0.85,0.25/
      data dpgx/10.0,110.0,110.0,5.0,110.0,10.0,10.0/
      data dpgy/1.,1.,20.0,20.,110.,110,1.0/
      character*7  wks_type
C
C Define the workstation type
C
      wks_type = "x11"
C
C Initialize the high level utility library
C
      call NhlFInitialize()
C
C Create an application context. Set the app dir to the current
C directory so the application looks for a resource file in the working
C directory. 
C
      call NhlFRLCreate(rlist,'SETRL')
      call NhlFRLCreate(grlist,'GETRL')

      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'pr03',NhlFappClass,
     1     0,rlist,ierr)


      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C  Create a meta file workstation.
C   
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'wkMetaName','./pr03f.ncgm',ierr)
      call NhlFCreate(wid,'pr03Work',NhlFncgmWorkstationClass,
     1    0,rlist,ierr)
    
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C  Create an X workstation.
C   
      call NhlFRLClear(rlist)
      call NhlFRLSetInteger(rlist,'wkPause','true',ierr)
      call NhlFCreate(wid,'pr03Work',
     1            NhlFCairoWindowWorkstationClass,
     1            appid,rlist,ierr)
    
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C  Create an older-style PS workstation.
C   
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'wkPSFileName','./pr03f.ps',ierr)
      call NhlFCreate(wid,'pr03Work',NhlFpsWorkstationClass,
     1    appid,rlist,ierr)

      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C  Create an older-style PDF workstation.
C   
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'wkPDFFileName','./pr03f.pdf',ierr)
      call NhlFCreate(wid,'pr03Work',NhlFpdfWorkstationClass,
     1    appid,rlist,ierr)

      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C  Create a cairo PS/PDF workstation.
C   
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
      call NhlFRLSetString(rlist,'wkFileName','./pr03f',ierr)
      call NhlFCreate(wid,'pr03Work',
     1    NhlFCairoPSpdfWorkstationClass,appid,rlist,ierr)

      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C  Create a cairo PNG workstation.
C   
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
      call NhlFRLSetString(rlist,'wkFileName','./pr03f',ierr)
      call NhlFCreate(wid,'pr03Work',
     1    NhlFCairoImageWorkstationClass,appid,rlist,ierr)

      endif    
C
C Get the workstation default GraphicStyle and change the value of
C one of its resources
C
      call NhlFRLGetInteger(grlist,'wkDefGraphicStyleId',id,ierr)
      call NhlFGetValues(wid,grlist,ierr)
      call NhlFRLClear(rlist)
      call NhlFRLSetInteger(rlist,'gsLineColor',2,ierr)
      call NhlFSetValues(id,rlist,ierr)
C
C Create a LogLinPlot that covers the entire NDC space 
C to use as a drawing canvas
C
      call NhlFRLClear(rlist)
      call NhlFRLSetFloat(rlist,'vpXF',0.0,ierr)
      call NhlFRLSetFloat(rlist,'vpYF',1.0,ierr)
      call NhlFRLSetFloat(rlist,'vpWidthF',1.0,ierr)
      call NhlFRLSetFloat(rlist,'vpHeightF',1.0,ierr)
      call NhlFCreate(canvas,'canvas',NhlFlogLinPlotClass,wid,rlist,
     1     ierr)
C
C Explicitly create a GraphicStyle
C
      call NhlFRLClear(rlist)
      call NhlFCreate(gsid,'style',NhlFgraphicStyleClass,wid,rlist,
     1     ierr)
C
C Set workstation line attributes and draw a triangle
C
      call NhlFRLClear(rlist)
      call NhlFRLSetInteger(rlist,'gsLineDashPattern',2,ierr)
      call NhlFRLSetFloat(rlist,'gsLineThicknessF',3.0,ierr)
      call NhlFSetValues(gsid,rlist,ierr)

      call NhlFDraw(canvas,ierr)
C
C The polyline call uses the default GraphicStyle. Polygon and
C Polymarker use the explicitly created GraphicStyle.
C
      call NhlFNDCPolyline(canvas,gsid,plx,ply,4,ierr)
      call NhlFNDCPolygon(canvas,gsid,pgx,pgy,4,ierr)
      call NhlFNDCPolymarker(canvas,gsid,pmx,pmy,4,ierr)
      call NhlFFrame(wid,ierr)

      call NhlFRLClear(rlist)
      call NhlFRLSetFloat(rlist,'vpXF',0.2,ierr)
      call NhlFRLSetFloat(rlist,'vpYF',0.8,ierr)
      call NhlFRLSetFloat(rlist,'vpWidthF',0.6,ierr)
      call NhlFRLSetFloat(rlist,'vpHeightF',0.6,ierr)
      call NhlFSetValues(canvas,rlist,ierr)
       
      call NhlFDraw(canvas,ierr)
      call NhlFNDCPolyline(canvas,gsid,plx,ply,4,ierr)
      call NhlFNDCPolygon(canvas,gsid,pgx,pgy,4,ierr)
      call NhlFNDCPolymarker(canvas,gsid,pmx,pmy,4,ierr)
      call NhlFFrame(wid,ierr)

      do 10 i=1,4
         plx(i) = plx(i) + 0.4
         ply(i) = ply(i) + 0.4
         pgx(i) = pgx(i) + 0.4
         pgy(i) = pgy(i) + 0.4
         pmx(i) = pmx(i) + 0.4
         pmy(i) = pmy(i) + 0.4
 10   continue
       
      call NhlFDraw(canvas,ierr)
      call NhlFNDCPolyline(canvas,gsid,plx,ply,4,ierr)
      call NhlFNDCPolygon(canvas,gsid,pgx,pgy,4,ierr)
      call NhlFNDCPolymarker(canvas,gsid,pmx,pmy,4,ierr)
      call NhlFFrame(wid,ierr)

      do 20 i=1,4
         plx(i) = plx(i) - 0.4
         ply(i) = ply(i) - 0.4
         pgx(i) = pgx(i) - 0.4
         pgy(i) = pgy(i) - 0.4
         pmx(i) = pmx(i) - 0.4
         pmy(i) = pmy(i) - 0.4
 20      continue
C
C Modify the data values to be in a meaningful range relative to
C the data coordinate extent.
C
      do 30 i=1,4
         plx(i) = plx(i) * 100.0 + 50.
         ply(i) = ply(i) * 100.0 + 50.
         pgx(i) = pgx(i) * 100.0 + 50.
         pgy(i) = pgy(i) * 100.0 + 50.
         pmx(i) = pmx(i) * 100.0 + 50.
         pmy(i) = pmy(i) * 100.0 + 50.
 30   continue

      call NhlFDraw(canvas,ierr)
      call NhlFDataPolyline(canvas,gsid,plx,ply,4,ierr)
      call NhlFDataPolymarker(canvas,gsid,pmx,pmy,4,ierr)
      call NhlFDataPolygon(canvas,gsid,pgx,pgy,4,ierr)
      call NhlFFrame(wid,ierr)

      do 40 i=1,4
         plx(i) = plx(i) - 80.
         ply(i) = ply(i) - 80.
         pgx(i) = pgx(i) - 80.
         pgy(i) = pgy(i) - 80.
         pmx(i) = pmx(i) - 80.
         pmy(i) = pmy(i) - 80.
 40   continue

      call NhlFDraw(canvas,ierr)
      call NhlFDataPolyline(canvas,gsid,plx,ply,4,ierr)
      call NhlFDataPolymarker(canvas,gsid,pmx,pmy,4,ierr)
      call NhlFDataPolygon(canvas,gsid,pgx,pgy,4,ierr)
      call NhlFFrame(wid,ierr)

      call NhlFDraw(canvas,ierr)
      call NhlFDataPolygon(canvas,gsid,dpgx,dpgy,7,ierr)
      call NhlFFrame(wid,ierr)

      call NhlFClose()
      stop
      end

      DOUBLE PRECISION FUNCTION DGENCHI(DF)
C**********************************************************************
C
C       DOUBLE PRECISION FUNCTION DGENCHI( DF )
C                Generate random value of CHIsquare variable
C
C
C                              Function
C
C
C     Generates random deviate from the distribution of a chisquare
C     with DF degrees of freedom random variable.
C
C
C                              Arguments
C
C
C     DF --> Degrees of freedom of the chisquare
C            (Must be positive)
C                    DOUBLE PRECISION DF
C
C
C                              Method
C
C
C     Uses relation between chisquare and gamma.
C
C**********************************************************************
C     .. Scalar Arguments ..
      DOUBLE PRECISION DF
C     ..
C     .. External Functions ..
      DOUBLE PRECISION DGENGAM
      EXTERNAL DGENGAM
C     ..
C     .. Executable Statements ..
      IF (.NOT. (DF.LE.0.0D0)) GO TO 10
      WRITE (*,FMT=*) 'DF <= 0 in DGENCHI - ABORT'
      WRITE (*,FMT=*) 'Value of DF: ',DF
      STOP 'DF <= 0 in DGENCHI - ABORT'

   10 DGENCHI = 2.0D0*DGENGAM(1.0D0,DF/2.0D0)
      RETURN

      END
c -------------------------------------------------
      DOUBLE PRECISION FUNCTION DGENGAM(A,R)
C**********************************************************************
C
C        DOUBLE PRECISION FUNCTION DGENGAM( A, R )
C           GENerates random deviates from GAMma distribution
C
C
C                              Function
C
C
C     Generates random deviates from the gamma distribution whose
C     density is
C          (A**R)/Gamma(R) * X**(R-1) * Exp(-A*X)
C
C
C                              Arguments
C
C
C     A --> Location parameter of Gamma distribution
C                         DOUBLE PRECISION A
C
C     R --> Shape parameter of Gamma distribution
C                         DOUBLE PRECISION R
C
C
C                              Method
C
C
C     Renames DSGAMMA from TOMS as slightly modified by BWB to use
C     DRANFD instead of SUNIF.
C
C     For details see:
C               (Case R >= 1.0)
C               Ahrens, J.H. and Dieter, U.
C               Generating Gamma Variates by a
C               Modified Rejection Technique.
C               Comm. ACM, 25,1 (Jan. 1982), 47 - 54.
C     Algorithm GD
C
C               (Case 0.0 <= R <= 1.0)
C               Ahrens, J.H. and Dieter, U.
C               Computer Methods for Sampling from Gamma,
C               Beta, Poisson and Binomial Distributions.
C               Computing, 12 (1974), 223-246/
C     Adapted algorithm GS.
C
C**********************************************************************
C     .. Scalar Arguments ..
      DOUBLE PRECISION A,R
C     ..
C     .. External Functions ..
      DOUBLE PRECISION DSGAMMA
      EXTERNAL DSGAMMA
C     ..
C     .. Executable Statements ..
      DGENGAM = DSGAMMA(R)
      DGENGAM = DGENGAM/A
      RETURN

      END
c -------------------------------------------------
      DOUBLE PRECISION FUNCTION DGENNOR(AV,SD)
C**********************************************************************
C
C        DOUBLE PRECISION FUNCTION DGENNOR( AV, SD )
C
C         GENerate random deviate from a NORmal distribution
C
C
C                              Function
C
C
C     Generates a single random deviate from a normal distribution
C     with mean, AV, and standard deviation, SD.
C
C
C                              Arguments
C
C
C     AV --> Mean of the normal distribution.
C                         DOUBLE PRECISION AV
C
C     SD --> Standard deviation of the normal distribution.
C                         DOUBLE PRECISION SD
C
C     DGENNOR <-- Generated normal deviate.
C                         DOUBLE PRECISION DGENNOR
C
C
C                              Method
C
C
C     Renames DSNORM from TOMS as slightly modified by BWB to use
C     DRANFD instead of SUNIF.
C
C     For details see:
C               Ahrens, J.H. and Dieter, U.
C               Extensions of Forsythe's Method for Random
C               Sampling from the Normal Distribution.
C               Math. Comput., 27,124 (Oct. 1973), 927 - 937.
C
C
C**********************************************************************
C     .. Scalar Arguments ..
      DOUBLE PRECISION AV,SD
C     ..
C     .. External Functions ..
      DOUBLE PRECISION DSNORM
      EXTERNAL DSNORM
C     ..
C     .. Executable Statements ..
      DGENNOR = SD*DSNORM() + AV
      RETURN

      END
c -------------------------------------------------
      DOUBLE PRECISION FUNCTION DGENUNF(LOW,HIGH)
C**********************************************************************
C
C         DOUBLE PRECISION FUNCTION DGENUNF( LOW, HIGH )
C
C               GeNerate Uniform Real between LOW and HIGH
C
C
C                              Function
C
C
C     Generates a real uniformly distributed between LOW and HIGH.
C
C
C                              Arguments
C
C
C     LOW --> Low bound (exclusive) on real value to be generated
C                    DOUBLE PRECISION LOW
C
C     HIGH --> High bound (exclusive) on real value to be generated
C                    DOUBLE PRECISION HIGH
C
C**********************************************************************
C     .. Scalar Arguments ..
      DOUBLE PRECISION HIGH,LOW
C     ..
C     .. External Functions ..
      DOUBLE PRECISION DRANFD
      EXTERNAL DRANFD
C     ..
C     .. Executable Statements ..
      IF (.NOT. (LOW.GT.HIGH)) GO TO 10
      WRITE (*,FMT=*) 'LOW > HIGH in DGENUNF: LOW ',LOW,' HIGH: ',HIGH
      WRITE (*,FMT=*) 'Abort'
      STOP 'LOW > High in DGENUNF - Abort'

   10 DGENUNF = LOW + (HIGH-LOW)*DRANFD()

      RETURN

      END
c -------------------------------------------------
      SUBROUTINE DGETCGN(G)
      INTEGER G
C**********************************************************************
C
C      SUBROUTINE DGETCGN(G)
C                         Get GeNerator
C
C     Returns in G the number of the current random number generator
C
C
C                              Arguments
C
C
C     G <-- Number of the current random number generator (1..32)
C                    INTEGER G
C
C**********************************************************************
C
      INTEGER CURNTG,NUMG
      SAVE CURNTG
      PARAMETER (NUMG=32)
      DATA CURNTG/1/
C
      G = CURNTG
      RETURN

      ENTRY SETCGN(G)
C**********************************************************************
C
C     SUBROUTINE SETCGN( G )
C                      Set GeNerator
C
C     Sets  the  current  generator to G.    All references to a
C     generat are to the current generator.
C
C
C                              Arguments
C
C
C     G --> Number of the current random number generator (1..32)
C                    INTEGER G
C
C**********************************************************************
C
C     Abort if generator number out of range
C
      IF (.NOT. (G.LT.0.OR.G.GT.NUMG)) GO TO 10
      WRITE (*,FMT=*) ' Generator number out of range in SETCGN:',
     +  ' Legal range is 1 to ',NUMG,' -- ABORT!'
      STOP ' Generator number out of range in SETCGN'

   10 CURNTG = G
      RETURN

      END
c -------------------------------------------------
      SUBROUTINE GETSD(ISEED1,ISEED2)
C**********************************************************************
C
C     SUBROUTINE GETSD(G,ISEED1,ISEED2)
C               GET SeeD
C
C     Returns the value of two integer seeds of the current generator
C
C     This is a transcription from Pascal to Fortran of routine
C     Get_State from the paper
C
C     L'Ecuyer, P. and  Cote,  S. "Implementing a Random Number
C     Package with Splitting Facilities."  ACM  Transactions on
C     Mathematical Software, 17:98-111 (1991)
C
C
C                              Arguments
C
C
C
C     ISEED1 <- First integer seed of generator G
C                                   INTEGER ISEED1
C
C     ISEED2 <- Second integer seed of generator G
C                                   INTEGER ISEED1
C
C**********************************************************************
C     .. Parameters ..
      INTEGER NUMG
      PARAMETER (NUMG=32)
C     ..
C     .. Scalar Arguments ..
      INTEGER ISEED1,ISEED2
C     ..
C     .. Scalars in Common ..
      INTEGER A1,A1VW,A1W,A2,A2VW,A2W,M1,M2
C     ..
C     .. Arrays in Common ..
      INTEGER CG1(NUMG),CG2(NUMG),IG1(NUMG),IG2(NUMG),LG1(NUMG),
     +        LG2(NUMG)
      LOGICAL QANTI(NUMG)
C     ..
C     .. Local Scalars ..
      INTEGER G
C     ..
C     .. External Functions ..
      LOGICAL QRGNIN
      EXTERNAL QRGNIN
C     ..
C     .. External Subroutines ..
      EXTERNAL DGETCGN
C     ..
C     .. Common blocks ..
      COMMON /GLOBE/M1,M2,A1,A2,A1W,A2W,A1VW,A2VW,IG1,IG2,LG1,LG2,CG1,
     +       CG2,QANTI
C     ..
C     .. Save statement ..
      SAVE /GLOBE/
C     ..
C     .. Executable Statements ..
C     Abort unless random number generator initialized
      IF (QRGNIN()) GO TO 10
      WRITE (*,FMT=*) ' GETSD called before random number generator ',
     +  ' initialized -- abort!'
      STOP ' GETSD called before random number generator initialized'

   10 CALL DGETCGN(G)
      ISEED1 = CG1(G)
      ISEED2 = CG2(G)
      RETURN

      END
c -------------------------------------------------
      INTEGER FUNCTION IGNLGI()
C**********************************************************************
C
C     INTEGER FUNCTION IGNLGI()
C               GeNerate LarGe Integer
C
C     Returns a random integer following a uniform distribution over
C     (1, 2147483562) using the current generator.
C
C     This is a transcription from Pascal to Fortran of routine
C     Random from the paper
C
C     L'Ecuyer, P. and Cote, S. "Implementing a Random Number Package
C     with Splitting Facilities." ACM Transactions on Mathematical
C     Software, 17:98-111 (1991)
C
C**********************************************************************
C     .. Parameters ..
      INTEGER NUMG
      PARAMETER (NUMG=32)
C     ..
C     .. Scalars in Common ..
      INTEGER A1,A1VW,A1W,A2,A2VW,A2W,M1,M2
C     ..
C     .. Arrays in Common ..
      INTEGER CG1(NUMG),CG2(NUMG),IG1(NUMG),IG2(NUMG),LG1(NUMG),
     +        LG2(NUMG)
      LOGICAL QANTI(NUMG)
C     ..
C     .. Local Scalars ..
      INTEGER CURNTG,K,S1,S2,Z
      LOGICAL QQSSD
C     ..
C     .. External Functions ..
      LOGICAL QRGNIN
      EXTERNAL QRGNIN
C     ..
C     .. External Subroutines ..
      EXTERNAL DGETCGN,INRGCM,RGNQSD,SETALL
C     ..
C     .. Common blocks ..
      COMMON /GLOBE/M1,M2,A1,A2,A1W,A2W,A1VW,A2VW,IG1,IG2,LG1,LG2,CG1,
     +       CG2,QANTI
C     ..
C     .. Save statement ..
      SAVE /GLOBE/
C     ..
C     .. Executable Statements ..
C
C     IF THE RANDOM NUMBER PACKAGE HAS NOT BEEN INITIALIZED YET, DO SO.
C     IT CAN BE INITIALIZED IN ONE OF TWO WAYS : 1) THE FIRST CALL TO
C     THIS ROUTINE  2) A CALL TO SETALL.
C
      IF (.NOT. (QRGNIN())) CALL INRGCM
      CALL RGNQSD(QQSSD)
      IF (.NOT. (QQSSD)) CALL SETALL(1234567890,123456789)
C
C     Get Current Generator
C
      CALL DGETCGN(CURNTG)
      S1 = CG1(CURNTG)
      S2 = CG2(CURNTG)
      K = S1/53668
      S1 = A1* (S1-K*53668) - K*12211
      IF (S1.LT.0) S1 = S1 + M1
      K = S2/52774
      S2 = A2* (S2-K*52774) - K*3791
      IF (S2.LT.0) S2 = S2 + M2
      CG1(CURNTG) = S1
      CG2(CURNTG) = S2
      Z = S1 - S2
      IF (Z.LT.1) Z = Z + M1 - 1
      IF (QANTI(CURNTG)) Z = M1 - Z
      IGNLGI = Z
      RETURN

      END
c -------------------------------------------------
      INTEGER FUNCTION IGNUIN(LOW,HIGH)
C**********************************************************************
C
C     INTEGER FUNCTION IGNUIN( LOW, HIGH )
C
C               GeNerate Uniform INteger
C
C
C                              Function
C
C
C     Generates an integer uniformly distributed between LOW and HIGH.
C
C
C                              Arguments
C
C
C     LOW --> Low bound (inclusive) on integer value to be generated
C                         INTEGER LOW
C
C     HIGH --> High bound (inclusive) on integer value to be generated
C                         INTEGER HIGH
C
C
C                              Note
C
C
C     If (HIGH-LOW) > 2,147,483,561 prints error message on * unit and
C     stops the program.
C
C**********************************************************************

C     IGNLGI generates integers between 1 and 2147483562
C     MAXNUM is 1 less than maximum generable value
C     .. Parameters ..
      INTEGER MAXNUM
      PARAMETER (MAXNUM=2147483561)
      CHARACTER*(*) ERR1,ERR2
      PARAMETER (ERR1='LOW > HIGH in IGNUIN',
     +          ERR2=' ( HIGH - LOW ) > 2,147,483,561 in IGNUIN')
C     ..
C     .. Scalar Arguments ..
      INTEGER HIGH,LOW
C     ..
C     .. Local Scalars ..
      INTEGER ERR,IGN,MAXNOW,RANGE,RANP1
C     ..
C     .. External Functions ..
      INTEGER IGNLGI
      EXTERNAL IGNLGI
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC MOD
C     ..
C     .. Executable Statements ..
      IF (.NOT. (LOW.GT.HIGH)) GO TO 10
      ERR = 1
C      ABORT-PROGRAM
      GO TO 80

   10 RANGE = HIGH - LOW
      IF (.NOT. (RANGE.GT.MAXNUM)) GO TO 20
      ERR = 2
C      ABORT-PROGRAM
      GO TO 80

   20 IF (.NOT. (LOW.EQ.HIGH)) GO TO 30
      IGNUIN = LOW
      RETURN

      GO TO 70

C     Number to be generated should be in range 0..RANGE
C     Set MAXNOW so that the number of integers in 0..MAXNOW is an
C     integral multiple of the number in 0..RANGE

   30 RANP1 = RANGE + 1
      MAXNOW = (MAXNUM/RANP1)*RANP1
   40 IGN = IGNLGI() - 1
      IF (.NOT. (IGN.LE.MAXNOW)) GO TO 50
      IGNUIN = LOW + MOD(IGN,RANP1)
      RETURN

   50 GO TO 40

   60 CONTINUE
   70 CONTINUE
   80 IF (.NOT. (ERR.EQ.1)) GO TO 90
      WRITE (*,FMT=*) ERR1
      GO TO 100

C     TO ABORT-PROGRAM
   90 WRITE (*,FMT=*) ERR2
  100 WRITE (*,FMT=*) ' LOW: ',LOW,' HIGH: ',HIGH
      WRITE (*,FMT=*) ' Abort on Fatal ERROR'
      IF (.NOT. (ERR.EQ.1)) GO TO 110
      STOP 'LOW > HIGH in IGNUIN'

      GO TO 120

  110 STOP ' ( HIGH - LOW ) > 2,147,483,561 in IGNUIN'

  120 END
c -------------------------------------------------
      SUBROUTINE INITGN(ISDTYP)
C**********************************************************************
C
C     SUBROUTINE INITGN(ISDTYP)
C          INIT-ialize current G-e-N-erator
C
C     Reinitializes the state of the current generator
C
C     This is a transcription from Pascal to Fortran of routine
C     Init_Generator from the paper
C
C     L'Ecuyer, P. and Cote, S. "Implementing a Random Number Package
C     with Splitting Facilities." ACM Transactions on Mathematical
C     Software, 17:98-111 (1991)
C
C
C                              Arguments
C
C
C     ISDTYP -> The state to which the generator is to be set
C
C          ISDTYP = -1  => sets the seeds to their initial value
C          ISDTYP =  0  => sets the seeds to the first value of
C                          the current block
C          ISDTYP =  1  => sets the seeds to the first value of
C                          the next block
C
C                                   INTEGER ISDTYP
C
C**********************************************************************
C     .. Parameters ..
      INTEGER NUMG
      PARAMETER (NUMG=32)
C     ..
C     .. Scalar Arguments ..
      INTEGER ISDTYP
C     ..
C     .. Scalars in Common ..
      INTEGER A1,A1VW,A1W,A2,A2VW,A2W,M1,M2
C     ..
C     .. Arrays in Common ..
      INTEGER CG1(NUMG),CG2(NUMG),IG1(NUMG),IG2(NUMG),LG1(NUMG),
     +        LG2(NUMG)
      LOGICAL QANTI(NUMG)
C     ..
C     .. Local Scalars ..
      INTEGER G
C     ..
C     .. External Functions ..
      LOGICAL QRGNIN
      INTEGER MLTMOD
      EXTERNAL QRGNIN,MLTMOD
C     ..
C     .. External Subroutines ..
      EXTERNAL DGETCGN
C     ..
C     .. Common blocks ..
      COMMON /GLOBE/M1,M2,A1,A2,A1W,A2W,A1VW,A2VW,IG1,IG2,LG1,LG2,CG1,
     +       CG2,QANTI
C     ..
C     .. Save statement ..
      SAVE /GLOBE/
C     ..
C     .. Executable Statements ..
C     Abort unless random number generator initialized
      IF (QRGNIN()) GO TO 10
      WRITE (*,FMT=*) ' INITGN called before random number generator ',
     +  ' initialized -- abort!'
      STOP ' INITGN called before random number generator initialized'

   10 CALL DGETCGN(G)
      IF ((-1).NE. (ISDTYP)) GO TO 20
      LG1(G) = IG1(G)
      LG2(G) = IG2(G)
      GO TO 50

   20 IF ((0).NE. (ISDTYP)) GO TO 30
      CONTINUE
      GO TO 50
C     do nothing
   30 IF ((1).NE. (ISDTYP)) GO TO 40
      LG1(G) = MLTMOD(A1W,LG1(G),M1)
      LG2(G) = MLTMOD(A2W,LG2(G),M2)
      GO TO 50

   40 STOP 'ISDTYP NOT IN RANGE'

   50 CG1(G) = LG1(G)
      CG2(G) = LG2(G)
      RETURN

      END
c -------------------------------------------------
      SUBROUTINE INRGCM
C**********************************************************************
C
C     SUBROUTINE INRGCM()
C          INitialize Random number Generator CoMmon
C
C
C                              Function
C
C
C     Initializes common area for random number generator. This saves
C     the nuisance of a BLOCK DATA routine and the difficulty of
C     assuring that the routine is loaded with the other routines.
C
C**********************************************************************
C     .. Parameters ..
      INTEGER NUMG
      PARAMETER (NUMG=32)
C     ..
C     .. Scalars in Common ..
      INTEGER A1,A1VW,A1W,A2,A2VW,A2W,M1,M2
C     ..
C     .. Arrays in Common ..
      INTEGER CG1(NUMG),CG2(NUMG),IG1(NUMG),IG2(NUMG),LG1(NUMG),
     +        LG2(NUMG)
      LOGICAL QANTI(NUMG)
C     ..
C     .. Local Scalars ..
      INTEGER I
      LOGICAL QDUM
C     ..
C     .. External Functions ..
      LOGICAL QRGNSN
      EXTERNAL QRGNSN
C     ..
C     .. Common blocks ..
      COMMON /GLOBE/M1,M2,A1,A2,A1W,A2W,A1VW,A2VW,IG1,IG2,LG1,LG2,CG1,
     +       CG2,QANTI
C     ..
C     .. Save statement ..
      SAVE /GLOBE/
C     ..
C     .. Executable Statements ..
C     V=20;                            W=30;
C
C     A1W = MOD(A1**(2**W),M1)         A2W = MOD(A2**(2**W),M2)
C     A1VW = MOD(A1**(2**(V+W)),M1)    A2VW = MOD(A2**(2**(V+W)),M2)
C
C   If V or W is changed A1W, A2W, A1VW, and A2VW need to be
C   recomputed.  An efficient way to precompute a**(2*j) MOD m is to
C   start with a and square it j times modulo m using the function
C   MLTMOD.
C
      M1 = 2147483563
      M2 = 2147483399
      A1 = 40014
      A2 = 40692
      A1W = 1033780774
      A2W = 1494757890
      A1VW = 2082007225
      A2VW = 784306273
      DO 10 I = 1,NUMG
          QANTI(I) = .FALSE.
   10 CONTINUE
C
C     Tell the world that common has been initialized
C
      QDUM = QRGNSN(.TRUE.)
      RETURN

      END
c -------------------------------------------------
      INTEGER FUNCTION MLTMOD(A,S,M)
C**********************************************************************
C
C     INTEGER FUNCTION MLTMOD(A,S,M)
C
C                    Returns (A*S) MOD M
C
C     This is a transcription from Pascal to Fortran of routine
C     MULtMod_Decompos from the paper
C
C     L'Ecuyer, P. and Cote, S. "Implementing a Random Number Package
C     with Splitting Facilities." ACM Transactions on Mathematical
C     Software, 17:98-111 (1991)
C
C
C                              Arguments
C
C
C     A, S, M  -->
C                         INTEGER A,S,M
C
C**********************************************************************
C     .. Parameters ..
      INTEGER H
      PARAMETER (H=32768)
C     ..
C     .. Scalar Arguments ..
      INTEGER A,M,S
C     ..
C     .. Local Scalars ..
      INTEGER A0,A1,K,P,Q,QH,RH
C     ..
C     .. Executable Statements ..
C
C     H = 2**((b-2)/2) where b = 32 because we are using a 32 bit
C      machine. On a different machine recompute H
C
      IF (.NOT. (A.LE.0.OR.A.GE.M.OR.S.LE.0.OR.S.GE.M)) GO TO 10
      WRITE (*,FMT=*) ' A, M, S out of order in MLTMOD - ABORT!'
      WRITE (*,FMT=*) ' A = ',A,' S = ',S,' M = ',M
      WRITE (*,FMT=*) ' MLTMOD requires: 0 < A < M; 0 < S < M'
      STOP ' A, M, S out of order in MLTMOD - ABORT!'

   10 IF (.NOT. (A.LT.H)) GO TO 20
      A0 = A
      P = 0
      GO TO 120

   20 A1 = A/H
      A0 = A - H*A1
      QH = M/H
      RH = M - H*QH
      IF (.NOT. (A1.GE.H)) GO TO 50
      A1 = A1 - H
      K = S/QH
      P = H* (S-K*QH) - K*RH
   30 IF (.NOT. (P.LT.0)) GO TO 40
      P = P + M
      GO TO 30

   40 GO TO 60

   50 P = 0
C
C     P = (A2*S*H)MOD M
C
   60 IF (.NOT. (A1.NE.0)) GO TO 90
      Q = M/A1
      K = S/Q
      P = P - K* (M-A1*Q)
      IF (P.GT.0) P = P - M
      P = P + A1* (S-K*Q)
   70 IF (.NOT. (P.LT.0)) GO TO 80
      P = P + M
      GO TO 70

   80 CONTINUE
   90 K = P/QH
C
C     P = ((A2*H + A1)*S)MOD M
C
      P = H* (P-K*QH) - K*RH
  100 IF (.NOT. (P.LT.0)) GO TO 110
      P = P + M
      GO TO 100

  110 CONTINUE
  120 IF (.NOT. (A0.NE.0)) GO TO 150
C
C     P = ((A2*H + A1)*H*S)MOD M
C
      Q = M/A0
      K = S/Q
      P = P - K* (M-A0*Q)
      IF (P.GT.0) P = P - M
      P = P + A0* (S-K*Q)
  130 IF (.NOT. (P.LT.0)) GO TO 140
      P = P + M
      GO TO 130

  140 CONTINUE
  150 MLTMOD = P
C
      RETURN

      END
c -------------------------------------------------
      LOGICAL FUNCTION QRGNIN()
C**********************************************************************
C
C     LOGICAL FUNCTION QRGNIN()
C               Q Random GeNerators INitialized?
C
C     A trivial routine to determine whether or not the random
C     number generator has been initialized.  Returns .TRUE. if
C     it has, else .FALSE.
C
C**********************************************************************
C     .. Scalar Arguments ..
      LOGICAL QVALUE
C     ..
C     .. Local Scalars ..
      LOGICAL QINIT
C     ..
C     .. Entry Points ..
      LOGICAL QRGNSN
C     ..
C     .. Save statement ..
      SAVE QINIT
C     ..
C     .. Data statements ..
      DATA QINIT/.FALSE./
C     ..
C     .. Executable Statements ..
      QRGNIN = QINIT
      RETURN

      ENTRY QRGNSN(QVALUE)
C**********************************************************************
C
C     LOGICAL FUNCTION QRGNSN( QVALUE )
C               Q Random GeNerators Set whether iNitialized
C
C     Sets state of whether random number generator is initialized
C     to QVALUE.
C
C     This routine is actually an entry in QRGNIN, hence it is a
C     logical function.  It returns the (meaningless) value .TRUE.
C
C**********************************************************************
      QINIT = QVALUE
      QRGNSN = .TRUE.
      RETURN

      END
c -------------------------------------------------
      DOUBLE PRECISION FUNCTION DRANFD()
C**********************************************************************
C     NAME CHANGED BY DJS TO AVOID NAMING CONFLICTS
C**********************************************************************
C
C          DOUBLE PRECISION FUNCTION DRANFD()
C                RANDom number generator as a Function
C
C     Returns a random floating point number from a uniform
C     distribution over 0 - 1 (endpoints of this interval are not
C     returned) using the current generator
C
C     This is a transcription from Pascal to Fortran of routine
C     Uniform_01 from the paper
C
C     L'Ecuyer, P. and Cote, S. "Implementing a Random Number Package
C     with Splitting Facilities." ACM Transactions on Mathematical
C     Software, 17:98-111 (1991)
C
C**********************************************************************
C     .. External Functions ..
      INTEGER IGNLGI
      EXTERNAL IGNLGI
C     ..
C     .. Executable Statements ..
C
C     4.656613057E-10 is 1/M1  M1 is set in a data statement in IGNLGI
C      and is currently 2147483563. If M1 changes, change this also.
C
      DRANFD = IGNLGI()*4.656613057D-10
      RETURN

      END
c -------------------------------------------------
      SUBROUTINE SETALL(ISEED1,ISEED2)
C**********************************************************************
C
C      SUBROUTINE SETALL(ISEED1,ISEED2)
C               SET ALL random number generators
C
C     Sets the initial seed of generator 1 to ISEED1 and ISEED2. The
C     initial seeds of the other generators are set accordingly, and
C     all generators states are set to these seeds.
C
C     This is a transcription from Pascal to Fortran of routine
C     Set_Initial_Seed from the paper
C
C     L'Ecuyer, P. and Cote, S. "Implementing a Random Number Package
C     with Splitting Facilities." ACM Transactions on Mathematical
C     Software, 17:98-111 (1991)
C
C
C                              Arguments
C
C
C     ISEED1 -> First of two integer seeds
C                                   INTEGER ISEED1
C
C     ISEED2 -> Second of two integer seeds
C                                   INTEGER ISEED1
C
C**********************************************************************
C     .. Parameters ..
      INTEGER NUMG
      PARAMETER (NUMG=32)
C     ..
C     .. Scalar Arguments ..
      INTEGER ISEED1,ISEED2
      LOGICAL QSSD
C     ..
C     .. Scalars in Common ..
      INTEGER A1,A1VW,A1W,A2,A2VW,A2W,M1,M2
C     ..
C     .. Arrays in Common ..
      INTEGER CG1(NUMG),CG2(NUMG),IG1(NUMG),IG2(NUMG),LG1(NUMG),
     +        LG2(NUMG)
      LOGICAL QANTI(NUMG)
C     ..
C     .. Local Scalars ..
      INTEGER G,OCGN
      LOGICAL QQSSD
C     ..
C     .. External Functions ..
      INTEGER MLTMOD
      LOGICAL QRGNIN
      EXTERNAL MLTMOD,QRGNIN
C     ..
C     .. External Subroutines ..
      EXTERNAL DGETCGN,INITGN,INRGCM,SETCGN
C     ..
C     .. Common blocks ..
      COMMON /GLOBE/M1,M2,A1,A2,A1W,A2W,A1VW,A2VW,IG1,IG2,LG1,LG2,CG1,
     +       CG2,QANTI
C     ..
C     .. Save statement ..
      SAVE /GLOBE/,QQSSD
C     ..
C     .. Data statements ..
      DATA QQSSD/.FALSE./
C     ..
C     .. Executable Statements ..
C
C     TELL IGNLGI, THE ACTUAL NUMBER GENERATOR, THAT THIS ROUTINE
C      HAS BEEN CALLED.
C
      QQSSD = .TRUE.
      CALL DGETCGN(OCGN)
C
C     Initialize Common Block if Necessary
C
      IF (.NOT. (QRGNIN())) CALL INRGCM
      IG1(1) = ISEED1
      IG2(1) = ISEED2
      CALL INITGN(-1)
      DO 10 G = 2,NUMG
          IG1(G) = MLTMOD(A1VW,IG1(G-1),M1)
          IG2(G) = MLTMOD(A2VW,IG2(G-1),M2)
          CALL SETCGN(G)
          CALL INITGN(-1)
   10 CONTINUE
      CALL SETCGN(OCGN)
      RETURN

      ENTRY RGNQSD(QSSD)
C**********************************************************************
C
C     SUBROUTINE RGNQSD
C                    Random Number Generator Query SeeD set?
C
C     Returns (LOGICAL) QSSD as .TRUE. if SETALL has been invoked,
C     otherwise returns .FALSE.
C
C**********************************************************************
      QSSD = QQSSD
      RETURN

      END
c -------------------------------------------------
      SUBROUTINE SETSD(ISEED1,ISEED2)
C**********************************************************************
C
C     SUBROUTINE SETSD(ISEED1,ISEED2)
C               SET S-ee-D of current generator
C
C     Resets the initial seed of the current generator to ISEED1 and
C     ISEED2. The seeds of the other generators remain unchanged.
C
C     This is a transcription from Pascal to Fortran of routine
C     Set_Seed from the paper
C
C     L'Ecuyer, P. and Cote, S. "Implementing a Random Number Package
C     with Splitting Facilities." ACM Transactions on Mathematical
C     Software, 17:98-111 (1991)
C
C
C                              Arguments
C
C
C     ISEED1 -> First integer seed
C                                   INTEGER ISEED1
C
C     ISEED2 -> Second integer seed
C                                   INTEGER ISEED1
C
C**********************************************************************
C     .. Parameters ..
      INTEGER NUMG
      PARAMETER (NUMG=32)
C     ..
C     .. Scalar Arguments ..
      INTEGER ISEED1,ISEED2
C     ..
C     .. Scalars in Common ..
      INTEGER A1,A1VW,A1W,A2,A2VW,A2W,M1,M2
C     ..
C     .. Arrays in Common ..
      INTEGER CG1(NUMG),CG2(NUMG),IG1(NUMG),IG2(NUMG),LG1(NUMG),
     +        LG2(NUMG)
      LOGICAL QANTI(NUMG)
C     ..
C     .. Local Scalars ..
      INTEGER G
C     ..
C     .. External Functions ..
      LOGICAL QRGNIN
      EXTERNAL QRGNIN
C     ..
C     .. External Subroutines ..
      EXTERNAL DGETCGN,INITGN
C     ..
C     .. Common blocks ..
      COMMON /GLOBE/M1,M2,A1,A2,A1W,A2W,A1VW,A2VW,IG1,IG2,LG1,LG2,CG1,
     +       CG2,QANTI
C     ..
C     .. Save statement ..
      SAVE /GLOBE/
C     ..
C     .. Executable Statements ..
C     Abort unless random number generator initialized
      IF (QRGNIN()) GO TO 10
      WRITE (*,FMT=*) ' SETSD called before random number generator ',
     +  ' initialized -- abort!'
      STOP ' SETSD called before random number generator initialized'

   10 CALL DGETCGN(G)
      IG1(G) = ISEED1
      IG2(G) = ISEED2
      CALL INITGN(-1)
      RETURN

      END
c -------------------------------------------------
      DOUBLE PRECISION FUNCTION DSEXPO()
      DOUBLE PRECISION Q
      DOUBLE PRECISION Q1
      DOUBLE PRECISION A
      DOUBLE PRECISION U
      DOUBLE PRECISION DRANFD
      DOUBLE PRECISION USTAR
      DOUBLE PRECISION UMIN
C*********************************************************************C
C                                                                     C
C                                                                     C
C    (STANDARD-)  E X P O N E N T I A L   DISTRIBUTION                C
C                                                                     C
C                                                                     C
C*********************************************************************C
**********************************************************************C
C                                                                     C
C    FOR DETAILS SEE:                                                 C
C                                                                     C
C              AHRENS, J.H. AND DIETER, U.                            C
C              COMPUTER METHODS FOR SAMPLING FROM THE                 C
C              EXPONENTIAL AND NORMAL DISTRIBUTIONS.                  C
C              COMM. ACM, 15,10 (OCT. 1972), 873 - 882.               C
C                                                                     C
C    ALL STATEMENT NUMBERS CORRESPOND TO THE STEPS OF ALGORITHM       C
C    'SA' IN THE ABOVE PAPER (SLIGHTLY MODIFIED IMPLEMENTATION)       C
C                                                                     C
C    Modified by Barry W. Brown, Feb 3, 1988 to use DRANFD instead of C
C    SUNIF.  The argument IR thus goes away.                          C
C                                                                     C
C*********************************************************************C
C
      DIMENSION Q(8)
      EQUIVALENCE (Q(1),Q1)
C
C     Q(N) = SUM(ALOG(2.0)**K/K!)    K=1,..,N ,      THE HIGHEST N
C     (HERE 8) IS DETERMINED BY Q(N)=1.0 WITHIN STANDARD PRECISION
C
      DATA Q/.6931472D0,.9333737D0,.9888778D0,.9984959D0,.9998293D0,
     +     .9999833D0,.9999986D0,.9999999D0/
C
   10 A = 0.0D0
      U = DRANFD()
      GO TO 30

   20 A = A + Q1
   30 U = U + U
      IF (U.LE.1.0D0) GO TO 20
   40 U = U - 1.0D0
      IF (U.GT.Q1) GO TO 60
   50 DSEXPO = A + U
      RETURN

   60 I = 1
      USTAR = DRANFD()
      UMIN = USTAR
   70 USTAR = DRANFD()
      IF (USTAR.LT.UMIN) UMIN = USTAR
   80 I = I + 1
      IF (U.GT.Q(I)) GO TO 70
   90 DSEXPO = A + UMIN*Q1
      RETURN

      END
c -------------------------------------------------
      DOUBLE PRECISION FUNCTION DSGAMMA(A)
      DOUBLE PRECISION A
      DOUBLE PRECISION Q1
      DOUBLE PRECISION Q2
      DOUBLE PRECISION Q3
      DOUBLE PRECISION Q4
      DOUBLE PRECISION Q5
      DOUBLE PRECISION Q6
      DOUBLE PRECISION Q7
      DOUBLE PRECISION A1
      DOUBLE PRECISION A2
      DOUBLE PRECISION A3
      DOUBLE PRECISION A4
      DOUBLE PRECISION A5
      DOUBLE PRECISION A6
      DOUBLE PRECISION A7
      DOUBLE PRECISION E1
      DOUBLE PRECISION E2
      DOUBLE PRECISION E3
      DOUBLE PRECISION E4
      DOUBLE PRECISION E5
      DOUBLE PRECISION AA
      DOUBLE PRECISION AAA
      DOUBLE PRECISION SQRT32
      DOUBLE PRECISION S2
      DOUBLE PRECISION S
      DOUBLE PRECISION D
      DOUBLE PRECISION Q0
      DOUBLE PRECISION B
      DOUBLE PRECISION SI
      DOUBLE PRECISION C
      DOUBLE PRECISION T
      DOUBLE PRECISION DSNORM
      DOUBLE PRECISION X
      DOUBLE PRECISION U
      DOUBLE PRECISION DRANFD
      DOUBLE PRECISION R
      DOUBLE PRECISION V
      DOUBLE PRECISION Q
      DOUBLE PRECISION E
      DOUBLE PRECISION DSEXPO
      DOUBLE PRECISION W
      DOUBLE PRECISION P
C*********************************************************************C
C                                                                     C
C                                                                     C
C    (STANDARD-)  G A M M A  DISTRIBUTION                             C
C                                                                     C
C                                                                     C
C*********************************************************************C
C*********************************************************************C
C                                                                     C
C              PARAMETER  A >= 1.0  !                                 C
C                                                                     C
C*********************************************************************C
C                                                                     C
C    FOR DETAILS SEE:                                                 C
C                                                                     C
C              AHRENS, J.H. AND DIETER, U.                            C
C              GENERATING GAMMA VARIATES BY A                         C
C              MODIFIED REJECTION TECHNIQUE.                          C
C              COMM. ACM, 25,1 (JAN. 1982), 47 - 54.                  C
C                                                                     C
C    STEP NUMBERS CORRESPOND TO ALGORITHM 'GD' IN THE ABOVE PAPER     C
C                                (STRAIGHTFORWARD IMPLEMENTATION)     C
C                                                                     C
C    Modified by Barry W. Brown, Feb 3, 1988 to use DRANFD instead of C
C    SUNIF.  The argument IR thus goes away.                          C
C                                                                     C
C*********************************************************************C
C                                                                     C
C              PARAMETER  0.0 < A < 1.0  !                            C
C                                                                     C
C*********************************************************************C
C                                                                     C
C    FOR DETAILS SEE:                                                 C
C                                                                     C
C              AHRENS, J.H. AND DIETER, U.                            C
C              COMPUTER METHODS FOR SAMPLING FROM GAMMA,              C
C              BETA, POISSON AND BINOMIAL DISTRIBUTIONS.              C
C              COMPUTING, 12 (1974), 223 - 246.                       C
C                                                                     C
C    (ADAPTED IMPLEMENTATION OF ALGORITHM 'GS' IN THE ABOVE PAPER)    C
C                                                                     C
C*********************************************************************C
C
C    INPUT: A =PARAMETER (MEAN) OF THE STANDARD GAMMA DISTRIBUTION
C    OUTPUT: DSGAMMA = SAMPLE FROM THE GAMMA-(A)-DISTRIBUTION
C
C    COEFFICIENTS Q(K) - FOR Q0 = SUM(Q(K)*A**(-K))
C    COEFFICIENTS A(K) - FOR Q = Q0+(T*T/2)*SUM(A(K)*V**K)
C    COEFFICIENTS E(K) - FOR EXP(Q)-1 = SUM(E(K)*Q**K)
C
      DATA Q1,Q2,Q3,Q4,Q5,Q6,Q7/.04166669D0,.02083148D0,.00801191D0,
     +     .00144121D0,-.00007388D0,.00024511D0,.00024240D0/
      DATA A1,A2,A3,A4,A5,A6,A7/.3333333D0,-.2500030D0,.2000062D0,
     +     -.1662921D0,.1423657D0,-.1367177D0,.1233795D0/
      DATA E1,E2,E3,E4,E5/1.D0,.4999897D0,.1668290D0,.0407753D0,
     +     .0102930D0/
C
C     PREVIOUS A PRE-SET TO ZERO - AA IS A', AAA IS A"
C     SQRT32 IS THE SQUAREROOT OF 32 = 5.656854249492380
C
      DATA AA/0.0D0/,AAA/0.0D0/,SQRT32/5.656854D0/
C
C     SAVE STATEMENTS
C
      SAVE AA,AAA,S2,S,D,Q0,B,SI,C
C
      IF (A.EQ.AA) GO TO 10
      IF (A.LT.1.0D0) GO TO 140
C
C     STEP  1:  RECALCULATIONS OF S2,S,D IF A HAS CHANGED
C
      AA = A
      S2 = A - 0.5D0
      S = SQRT(S2)
      D = SQRT32 - 12.0D0*S
C
C     STEP  2:  T=STANDARD NORMAL DEVIATE,
C               X=(S,1/2)-NORMAL DEVIATE.
C               IMMEDIATE ACCEPTANCE (I)
C
   10 T = DSNORM()
      X = S + 0.5D0*T
      DSGAMMA = X*X
      IF (T.GE.0.0D0) RETURN
C
C     STEP  3:  U= 0,1 -UNIFORM SAMPLE. SQUEEZE ACCEPTANCE (S)
C
      U = DRANFD()
      IF (D*U.LE.T*T*T) RETURN
C
C     STEP  4:  RECALCULATIONS OF Q0,B,SI,C IF NECESSARY
C
      IF (A.EQ.AAA) GO TO 40
      AAA = A
      R = 1.0D0/A
      Q0 = ((((((Q7*R+Q6)*R+Q5)*R+Q4)*R+Q3)*R+Q2)*R+Q1)*R
C
C               APPROXIMATION DEPENDING ON SIZE OF PARAMETER A
C               THE CONSTANTS IN THE EXPRESSIONS FOR B, SI AND
C               C WERE ESTABLISHED BY NUMERICAL EXPERIMENTS
C
      IF (A.LE.3.686D0) GO TO 30
      IF (A.LE.13.022D0) GO TO 20
C
C               CASE 3:  A .GT. 13.022
C
      B = 1.77D0
      SI = .75D0
      C = .1515D0/S
      GO TO 40
C
C               CASE 2:  3.686 .LT. A .LE. 13.022
C
   20 B = 1.654D0 + .0076D0*S2
      SI = 1.68D0/S + .275D0
      C = .062D0/S + .024D0
      GO TO 40
C
C               CASE 1:  A .LE. 3.686
C
   30 B = .463D0 + S + .178D0*S2
      SI = 1.235D0
      C = .195D0/S - .079D0 + .16D0*S
C
C     STEP  5:  NO QUOTIENT TEST IF X NOT POSITIVE
C
   40 IF (X.LE.0.0D0) GO TO 70
C
C     STEP  6:  CALCULATION OF V AND QUOTIENT Q
C
      V = T/ (S+S)
      IF (ABS(V).LE.0.25D0) GO TO 50
      Q = Q0 - S*T + 0.25D0*T*T + (S2+S2)*DLOG(1.0D0+V)
      GO TO 60

   50 Q=Q0+0.5D0*T*T*((((((A7*V+A6)*V+A5)*V+A4)*V+A3)*V+A2)*V+A1)*V
C
C     STEP  7:  QUOTIENT ACCEPTANCE (Q)
C
   60 IF (DLOG(1.0D0-U).LE.Q) RETURN
C
C     STEP  8:  E=STANDARD EXPONENTIAL DEVIATE
C               U= 0,1 -UNIFORM DEVIATE
C               T=(B,SI)-DOUBLE EXPONENTIAL (LAPLACE) SAMPLE
C
   70 E = DSEXPO()
      U = DRANFD()
      U = U + U - 1.0D0
      T = B + SIGN(SI*E,U)
      IF (.NOT. (U.GE.0.0D0)) GO TO 80
      T = B + SI*E
      GO TO 90

   80 T = B - SI*E

C
C     STEP  9:  REJECTION IF T .LT. TAU(1) = -.71874483771719
C
   90 IF (T.LT. (-.7187449D0)) GO TO 70
C
C     STEP 10:  CALCULATION OF V AND QUOTIENT Q
C
      V = T/ (S+S)
      IF (ABS(V).LE.0.25D0) GO TO 100
      Q = Q0 - S*T + 0.25D0*T*T + (S2+S2)*DLOG(1.0D0+V)
      GO TO 110

  100 Q=Q0+0.5D0*T*T*((((((A7*V+A6)*V+A5)*V+A4)*V+A3)*V+A2)*V+A1)*V
C
C     STEP 11:  HAT ACCEPTANCE (H) (IF Q NOT POSITIVE GO TO STEP 8)
C
  110 IF (Q.LE.0.0D0) GO TO 70
      IF (Q.LE.0.5D0) GO TO 120
      W = EXP(Q) - 1.0D0
      GO TO 130

  120 W = ((((E5*Q+E4)*Q+E3)*Q+E2)*Q+E1)*Q
C
C               IF T IS REJECTED, SAMPLE AGAIN AT STEP 8
C
  130 IF (C*ABS(U).GT.W*EXP(E-0.5D0*T*T)) GO TO 70
      X = S + 0.5D0*T
      DSGAMMA = X*X
      RETURN
C
C     ALTERNATE METHOD FOR PARAMETERS A BELOW 1  (.3678794=EXP(-1.))
C
  140 AA = 0.0D0
      B = 1.0D0 + .3678794D0*A
  150 P = B*DRANFD()
      IF (P.GE.1.0D0) GO TO 160
      DSGAMMA = EXP(DLOG(P)/A)
      IF (DSEXPO().LT.DSGAMMA) GO TO 150
      RETURN

  160 DSGAMMA = -DLOG((B-P)/A)
      IF (DSEXPO().LT. (1.0D0-A)*DLOG(DSGAMMA)) GO TO 150
      RETURN

      END
c -------------------------------------------------
      DOUBLE PRECISION FUNCTION DSNORM()
      DOUBLE PRECISION A
      DOUBLE PRECISION D
      DOUBLE PRECISION T
      DOUBLE PRECISION H
      DOUBLE PRECISION U
      DOUBLE PRECISION DRANFD
      DOUBLE PRECISION S
      DOUBLE PRECISION USTAR
      DOUBLE PRECISION AA
      DOUBLE PRECISION W
      DOUBLE PRECISION Y
      DOUBLE PRECISION TT
C*********************************************************************C
C                                                                     C
C                                                                     C
C    (STANDARD-)  N O R M A L  DISTRIBUTION                           C
C                                                                     C
C                                                                     C
C*********************************************************************C
C*********************************************************************C
C                                                                     C
C    FOR DETAILS SEE:                                                 C
C                                                                     C
C              AHRENS, J.H. AND DIETER, U.                            C
C              EXTENSIONS OF FORSYTHE'S METHOD FOR RANDOM             C
C              SAMPLING FROM THE NORMAL DISTRIBUTION.                 C
C              MATH. COMPUT., 27,124 (OCT. 1973), 927 - 937.          C
C                                                                     C
C    ALL STATEMENT NUMBERS CORRESPOND TO THE STEPS OF ALGORITHM 'FL'  C
C    (M=5) IN THE ABOVE PAPER     (SLIGHTLY MODIFIED IMPLEMENTATION)  C
C                                                                     C
C    Modified by Barry W. Brown, Feb 3, 1988 to use DRANFD instead of C
C    SUNIF.  The argument IR thus goes away.                          C
C                                                                     C
C*********************************************************************C
C
      DIMENSION A(32),D(31),T(31),H(31)
C
C     THE DEFINITIONS OF THE CONSTANTS A(K), D(K), T(K) AND
C     H(K) ARE ACCORDING TO THE ABOVEMENTIONED ARTICLE
C
      DATA A/0.0D0,.3917609D-1,.7841241D-1,.1177699D0,.1573107D0,
     +     .1970991D0,.2372021D0,.2776904D0,.3186394D0,.3601299D0,
     +     .4022501D0,.4450965D0,.4887764D0,.5334097D0,.5791322D0,
     +     .6260990D0,.6744898D0,.7245144D0,.7764218D0,.8305109D0,
     +     .8871466D0,.9467818D0,1.009990D0,1.077516D0,1.150349D0,
     +     1.229859D0,1.318011D0,1.417797D0,1.534121D0,1.675940D0,
     +     1.862732D0,2.153875D0/
      DATA D/5*0.0D0,.2636843D0,.2425085D0,.2255674D0,.2116342D0,
     +     .1999243D0,.1899108D0,.1812252D0,.1736014D0,.1668419D0,
     +     .1607967D0,.1553497D0,.1504094D0,.1459026D0,.1417700D0,
     +     .1379632D0,.1344418D0,.1311722D0,.1281260D0,.1252791D0,
     +     .1226109D0,.1201036D0,.1177417D0,.1155119D0,.1134023D0,
     +     .1114027D0,.1095039D0/
      DATA T/.7673828D-3,.2306870D-2,.3860618D-2,.5438454D-2,
     +     .7050699D-2,.8708396D-2,.1042357D-1,.1220953D-1,.1408125D-1,
     +     .1605579D-1,.1815290D-1,.2039573D-1,.2281177D-1,.2543407D-1,
     +     .2830296D-1,.3146822D-1,.3499233D-1,.3895483D-1,.4345878D-1,
     +     .4864035D-1,.5468334D-1,.6184222D-1,.7047983D-1,.8113195D-1,
     +     .9462444D-1,.1123001D0,.1364980D0,.1716886D0,.2276241D0,
     +     .3304980D0,.5847031D0/
      DATA H/.3920617D-1,.3932705D-1,.3950999D-1,.3975703D-1,
     +     .4007093D-1,.4045533D-1,.4091481D-1,.4145507D-1,.4208311D-1,
     +     .4280748D-1,.4363863D-1,.4458932D-1,.4567523D-1,.4691571D-1,
     +     .4833487D-1,.4996298D-1,.5183859D-1,.5401138D-1,.5654656D-1,
     +     .5953130D-1,.6308489D-1,.6737503D-1,.7264544D-1,.7926471D-1,
     +     .8781922D-1,.9930398D-1,.1155599D0,.1404344D0,.1836142D0,
     +     .2790016D0,.7010474D0/
C
   10 U = DRANFD()
      S = 0.0D0
      IF (U.GT.0.5D0) S = 1.0D0
      U = U + U - S
   20 U = 32.0D0*U
      I = INT(U)
      IF (I.EQ.32) I = 31
      IF (I.EQ.0) GO TO 100
C
C                                START CENTER
C
   30 USTAR = U - DBLE(I)
      AA = A(I)
   40 IF (USTAR.LE.T(I)) GO TO 60
      W = (USTAR-T(I))*H(I)
C
C                                EXIT   (BOTH CASES)
C
   50 Y = AA + W
      DSNORM = Y
      IF (S.EQ.1.0D0) DSNORM = -Y
      RETURN
C
C                                CENTER CONTINUED
C
   60 U = DRANFD()
      W = U* (A(I+1)-AA)
      TT = (0.5D0*W+AA)*W
      GO TO 80

   70 TT = U
      USTAR = DRANFD()
   80 IF (USTAR.GT.TT) GO TO 50
   90 U = DRANFD()
      IF (USTAR.GE.U) GO TO 70
      USTAR = DRANFD()
      GO TO 40
C
C                                START TAIL
C
  100 I = 6
      AA = A(32)
      GO TO 120

  110 AA = AA + D(I)
      I = I + 1
  120 U = U + U
      IF (U.LT.1.0D0) GO TO 110
  130 U = U - 1.0D0
  140 W = U*D(I)
      TT = (0.5D0*W+AA)*W
      GO TO 160

  150 TT = U
  160 USTAR = DRANFD()
      IF (USTAR.GT.TT) GO TO 50
  170 U = DRANFD()
      IF (USTAR.GE.U) GO TO 150
      U = DRANFD()
      GO TO 140

      END

C
C $Id:$
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
C NOTE: If you make any changes to this software, please remember to
C make the same changes to the corresponding double precision routine.
C
      subroutine curvps (n,x,y,p,d,isw,s,eps,ys,ysp,sigma,
     *                   temp,ierr)
C
      integer n,isw,ierr
      real x(n),y(n),p,d(n),s,eps,ys(n),ysp(n),sigma,
     *     temp(n,11)
c
c                                 coded by alan kaylor cline
c                              from fitpack -- april 8, 1991
c                        a curve and surface fitting package
c                      a product of pleasant valley software
c                  8603 altus cove, austin, texas 78759, usa
c
c this subroutine determines the parameters necessary to
c compute a periodic smoothing spline under tension. for a
c given increasing sequence of abscissae (x(i)), i = 1,...,n
c and associated ordinates (y(i)), i = 1,...,n, letting p be
c the period, x(n+1) = x(1)+p, and y(n+1) = y(1), the
c function determined minimizes the summation from i = 1 to
c n of the square of the second derivative of f plus sigma
c squared times the difference of the first derivative of f
c and (f(x(i+1))-f(x(i)))/(x(i+1)-x(i)) squared, over all
c functions f with period p and two continuous derivatives
c such that the summation of the square of
c (f(x(i))-y(i))/d(i) is less than or equal to a given
c constant s, where (d(i)), i = 1,...,n are a given set of
c observation weights. the function determined is a periodic
c spline under tension with third derivative discontinuities
c at (x(i)) i = 1,...,n (and all periodic translations of
c these values). for actual computation of points on the
c curve it is necessary to call the function curvp2. the
c determination of the curve is performed by subroutine
c curvpp, the subroutin curvps only decomposes the workspace
c for curvpp.
c
c on input--
c
c   n is the number of values to be smoothed (n.ge.2).
c
c   x is an array of the n increasing abscissae of the
c   values to be smoothed.
c
c   y is an array of the n ordinates of the values to be
c   smoothed, (i. e. y(k) is the functional value
c   corresponding to x(k) ).
c
c   p is the period (p .gt. x(n)-x(1)).
c
c   d is a parameter containing the observation weights.
c   this may either be an array of length n or a scalar
c   (interpreted as a constant). the value of d
c   corresponding to the observation (x(k),y(k)) should
c   be an approximation to the standard deviation of error.
c
c   isw contains a switch indicating whether the parameter
c   d is to be considered a vector or a scalar,
c          = 0 if d is an array of length n,
c          = 1 if d is a scalar.
c
c   s contains the value controlling the smoothing. this
c   must be non-negative. for s equal to zero, the
c   subroutine does interpolation, larger values lead to
c   smoother funtions. if parameter d contains standard
c   deviation estimates, a reasonable value for s is
c   float(n).
c
c   eps contains a tolerance on the relative precision to
c   which s is to be interpreted. this must be greater than
c   or equal to zero and less than or equal to one. a
c   reasonable value for eps is sqrt(2./float(n)).
c
c   ys is an array of length at least n.
c
c   ysp is an array of length at least n.
c
c   sigma contains the tension factor. this value indicates
c   the degree to which the first derivative part of the
c   smoothing functional is emphasized. if sigma is nearly
c   zero (e. g. .001) the resulting curve is approximately a
c   cubic spline. if sigma is large (e. g. 50.) the
c   resulting curve is nearly a polygonal line. if sigma
c   equals zero a cubic spline results. a standard value for
c   sigma is approximately 1.
c
c and
c
c   temp is an array of length at least 11*n which is used
c   for scratch storage.
c
c on output--
c
c   ys contains the smoothed ordinate values.
c
c   ysp contains the values of the second derivative of the
c   smoothed curve at the given nodes.
c
c   ierr contains an error flag,
c        = 0 for normal return,
c        = 1 if n is less than 2,
c        = 2 if s is negative,
c        = 3 if eps is negative or greater than one,
c        = 4 if x-values are not strictly increasing,
c        = 5 if a d-value is non-positive,
c        = 6 if p is less than or equal to x(n)-x(1).
c
c and
c
c   n, x, y, p, d, isw, s, eps, and sigma are unaltered.
c
c this subroutine references package modules curvpp, ftstore,
c terms, and snhcsh.
c
c-----------------------------------------------------------
c
c decompose temp into eleven arrays and call curvpp
c
      call curvpp (n,x,y,p,d,isw,s,eps,ys,ysp,sigma,
     *             temp(1,1),temp(1,2),temp(1,3),temp(1,4),
     *             temp(1,5),temp(1,6),temp(1,7),temp(1,8),
     *             temp(1,9),temp(1,10),temp(1,11),ierr)
      return
      end

      PROGRAM EPLTCH
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C --- D E C L A R A T I O N S -----------------------------------------
C
C Define arrays for column labels and row labels for the plots showing
C the complex and duplex character sets.
C
      CHARACTER*9 CLBL(12)
      CHARACTER*5 RLBL(48)
C
C Define a couple of temporary variables of type CHARACTER.
C
      CHARACTER*6 CTMP
      CHARACTER*8 CHRS
C
C Define an array in which to put the numbers of the filled fonts.
C
      DIMENSION IFFN(23)
C
C Define character arrays needed for example 1-10.  These are used
C to sidestep problems on various machines with backslashes in
C FORTRAN code.
C
      CHARACTER*1  SPCH(32)
      CHARACTER*32 SOSC
C
C Define the column and row labels.  The character string ':c:r', where
C "c" is the first three characters of a column label and "r" is the
C first character of a row label, is used to select the character to
C be written in that column of that row.
C
      DATA CLBL /'PRU(0000)','PRL(0100)','IRU(0200)','IRL(0300)',
     +           'KRU(0400)','KRL(0500)','PGU(0600)','PGL(0700)',
     +           'IGU(1000)','IGL(1100)','KGU(1200)','KGL(1300)'/
C
      DATA RLBL /'A(01)','B(02)','C(03)','D(04)','E(05)','F(06)',
     +           'G(07)','H(10)','I(11)','J(12)','K(13)','L(14)',
     +           'M(15)','N(16)','O(17)','P(20)','Q(21)','R(22)',
     +           'S(23)','T(24)','U(25)','V(26)','W(27)','X(30)',
     +           'Y(31)','Z(32)','0(33)','1(34)','2(35)','3(36)',
     +           '4(37)','5(40)','6(41)','7(42)','8(43)','9(44)',
     +           '+(45)','-(46)','*(47)','/(50)','((51)',')(52)',
     +           '$(53)','=(54)',' (55)',',(56)','.(57)','     '/
C
C Define a flag which says, if 0, that the first eight plots are to
C occupy eight separate frames and, if 1, that those plots are to be
C compressed onto two frames.
C
      DATA ICMP / 1 /
C
C Define the special characters needed in example 1-10.
C
      DATA SPCH / '!', '"', '#', '$', '%', '&', '''','(', ')', '*',
     +            '+', ',', '-', '.', '/', ':', ';', '<', '=', '>',
     +            '?', '@', '[', '\\',']', '^', '_', '`', '{', '|',
     +            '}', '~'                                        /
C
C Define the font numbers for the filled fonts.
C
      DATA IFFN / 1, 21, 22, 25, 26, 29, 30, 33, 34, 35, 36, 37 ,
     +              121,122,125,126,129,130,133,134,135,136,137 /
C
C --- E X E C U T A B L E   C O D E -----------------------------------
C
C Open GKS.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Set the "fill area interior style" to "solid".
C
      CALL GSFAIS (1)
C
C Do a call to SET which allows us to use fractional coordinates.
C
      CALL SET (0.,1.,0.,1.,0.,1.,0.,1.,1)
C
C --- E X A M P L E S   1 - 1   T H R O U G H   1 - 8 -----------------
C
C Produce examples of the complex and duplex character sets.
C
C Compute a character-size multiplier, depending on whether the first
C eight plots are being put on eight frames or two.
C
      CSMU=REAL(2-ICMP)
C
C Each pass through the loop on I produces four plots - the first four
C for the complex set, and the second four for the duplex set.
C
      DO 105 I=1,2
C
C Change to the appropriate character set.
C
        CALL PCSETI ('CD',I-1)
C
C Each pass through the following loop produces a single plot.
C
        DO 104 J=1,4
C
C If the first eight plots are to be compressed, re-do the SET call to
C put the plot in a particular quadrant of the frame.
C
          IF (ICMP.NE.0)
     +      CALL SET (.5*REAL(MOD(J-1,2)),.5*REAL(MOD(J-1,2))+.5,
     +                .5-.5*REAL((J-1)/2),   1.-.5*REAL((J-1)/2),
     +                                             0.,1.,0.,1.,1)
C
C Put labels at the top of the frame and along the left edge.
C
          IF (I.EQ.1) THEN
            CALL PLCHHQ (.5,.98,'PLCHHQ - COMPLEX CHARACTER SET',
     +                                                   CSMU*.01,0.,0.)
          ELSE
            CALL PLCHHQ (.5,.98,'PLCHHQ - DUPLEX CHARACTER SET',
     +                                                   CSMU*.01,0.,0.)
          END IF
C
          CALL PLCHHQ (.58,.9267,
     +                 'FUNCTION CODES SPECIFYING SIZE, FONT, AND CASE',
     +                                                CSMU*.00735,0.,0.)
C
          CALL PLCHHQ (.035,.445,':D:STANDARD FORTRAN CHARACTERS',
     +                                                CSMU*.00735,0.,0.)
C
C Force constant spacing of the characters used for the column and row
C labels, so that they will line up better with each other.
C
          CALL PCSETR ('CS',1.25)
C
C Label the columns.
C
          DO 101 K=1,12
            XPOS=.125+.07*REAL(K)
            CALL PLCHHQ (XPOS,.90,CLBL(K)(1:3),CSMU*.006,0.,0.)
            CALL PLCHHQ (XPOS,.88,CLBL(K)(4:9),CSMU*.004,0.,0.)
  101     CONTINUE
C
C Each pass through the following loop produces a single row.
C
          DO 103 K=1,12
C
C Compute the Y coordinate of the row.
C
            YPOS=.9-.07*REAL(K)
C
C Label the row.
C
            CALL PLCHHQ (.085,YPOS,RLBL(12*(J-1)+K)(1:1),CSMU*.006,0.,
     +                                                              -1.)
            CALL PLCHHQ (.105,YPOS,RLBL(12*(J-1)+K)(2:5),CSMU*.004,0.,
     +                                                              -1.)
C
C Each pass through the following loop produces a single character.
C
            DO 102 L=1,12
              XPOS=.125+.07*REAL(L)
              CTMP=':'//CLBL(L)(1:3)//':'//RLBL(12*(J-1)+K)(1:1)
              CALL PLCHHQ (XPOS,YPOS,CTMP,CSMU*.01,0.,0.)
  102       CONTINUE
C
  103     CONTINUE
C
C Return to variable spacing.
C
          CALL PCSETR ('CS',0.)
C
C If eight frames are being produced, advance the frame here.
C
        IF (ICMP.EQ.0) CALL FRAME
C
  104   CONTINUE
C
C If two frames are being produced, advance the frame here.
C
        IF (ICMP.NE.0) CALL FRAME
C
  105 CONTINUE
C
C Return to the complex character set.
C
      CALL PCSETI ('CD',0)
C
C If two frames were produced, re-do the call to SET which allows us to
C use fractional coordinates.
C
      IF (ICMP.NE.0) CALL SET (0.,1.,0.,1.,0.,1.,0.,1.,1)
C
C --- E X A M P L E   1 - 9 -------------------------------------------
C
C Do a single frame showing various capabilities of PLCHHQ.
C
C Put labels at the top of the plot.
C
      CALL PLCHHQ (.5,.98,'PLCHHQ - VARIOUS CAPABILITIES',.02,0.,0.)
C
C First, write characters at various sizes.
C
      CALL PLCHHQ (.225,.900,'SIZE is -1.0',-1.0,0.,0.)
      CALL PLCHHQ (.225,.873,'SIZE is -.75',-.75,0.,0.)
      CALL PLCHHQ (.225,.846,'SIZE is .015',.015,0.,0.)
      CALL PLCHHQ (.225,.811,'SIZE is .020',.020,0.,0.)
      CALL PLCHHQ (.225,.776,'SIZE is 15.0',15.0,0.,0.)
      CALL PLCHHQ (.225,.742,'SIZE is 20.0',20.0,0.,0.)
C
C Next, write characters at various angles.
C
      CALL PLCHHQ (.225,.453,'   ANGD is   0.',.012,  0.,-1.)
      CALL PLCHHQ (.225,.453,'   ANGD is  45.',.012, 45.,-1.)
      CALL PLCHHQ (.225,.453,'   ANGD is  90.',.012, 90.,-1.)
      CALL PLCHHQ (.225,.453,'   ANGD is 135.',.012,135.,-1.)
      CALL PLCHHQ (.225,.453,'   ANGD is 180.',.012,180.,-1.)
      CALL PLCHHQ (.225,.453,'   ANGD is 225.',.012,225.,-1.)
      CALL PLCHHQ (.225,.453,'   ANGD is 270.',.012,270.,-1.)
      CALL PLCHHQ (.225,.453,'   ANGD is 315.',.012,315.,-1.)
C
C Next, use various values of the centering option.
C
      CALL PLCHHQ (.225,.164,'CNTR is -1.5',.012,0.,-1.5)
      CALL PLCHHQ (.225,.140,'CNTR is -1.0',.012,0.,-1.0)
      CALL PLCHHQ (.225,.116,'CNTR is -0.5',.012,0.,-0.5)
      CALL PLCHHQ (.225,.092,'CNTR is  0.0',.012,0., 0.0)
      CALL PLCHHQ (.225,.068,'CNTR is +0.5',.012,0.,+0.5)
      CALL PLCHHQ (.225,.044,'CNTR is +1.0',.012,0.,+1.0)
      CALL PLCHHQ (.225,.020,'CNTR is +1.5',.012,0.,+1.5)
C
C Turn on the computation of text-extent-vector magnitudes and use
C them to draw a box around a label.  (DRAWBX is not part of PLOTCHAR;
C the code for it appears at the end of this example.)
C
      CALL PCSETI ('TE - TEXT EXTENT FLAG',1)
C
      CALL PLCHHQ (.130,.140,'TEXT EXTENT BOX',.012,35.,0.)
      CALL DRAWBX (.130,.140,35.,.01)
C
      CALL PCSETI ('TE - TEXT EXTENT FLAG',0)
C
C On the right side of the frame, create examples of the various kinds
C of function codes.  First, do them using high-quality characters.
C
      CALL PLCHHQ (.715,.900,'HIGH-QUALITY CHARACTERS USED BELOW',
     +                                                       .012,0.,0.)
C
      CALL PCSETC ('FC','$')
      CALL PLCHHQ (.625,.870,'INPUT STRING',.012,0.,0.)
      CALL PLCHHQ (.625,.840,'------------',.012,0.,0.)
      CALL PLCHHQ (.625,.810,':L:A',.012,0.,0.)
      CALL PLCHHQ (.625,.780,':IGL:A',.012,0.,0.)
      CALL PLCHHQ (.625,.750,'A:S:2:N:+B:S:2:N:',.012,0.,0.)
      CALL PLCHHQ (.625,.720,'A:S:B',.012,0.,0.)
      CALL PLCHHQ (.625,.690,'A:SPU:B',.012,0.,0.)
      CALL PLCHHQ (.625,.660,':GIU:+',.012,0.,0.)
      CALL PLCHHQ (.625,.630,':1045:',.012,0.,0.)
      CALL PLCHHQ (.625,.600,'10:S:10:S:100',.012,0.,0.)
      CALL PLCHHQ (.625,.570,'X:B1:2:S1:3',.012,0.,0.)
      CALL PLCHHQ (.625,.540,'X:B1:2:S:3:N:Y:S:2',.012,0.,0.)
      CALL PLCHHQ (.625,.510,'X:S:A:B:1:NN:ABC',.012,0.,0.)
      CALL PLCHHQ (.625,.480,'1.3648:L1:410:S:-13',.012,0.,0.)
C
      CALL PCSETC ('FC',':')
      CALL PLCHHQ (.875,.870,'RESULT',.012,0.,0.)
      CALL PLCHHQ (.875,.840,'------',.012,0.,0.)
      CALL PLCHHQ (.875,.810,':L:A',.012,0.,0.)
      CALL PLCHHQ (.875,.780,':IGL:A',.012,0.,0.)
      CALL PLCHHQ (.875,.750,'A:S:2:N:+B:S:2:N:',.012,0.,0.)
      CALL PLCHHQ (.875,.720,'A:S:B',.012,0.,0.)
      CALL PLCHHQ (.875,.690,'A:SPU:B',.012,0.,0.)
      CALL PLCHHQ (.875,.660,':GIU:+',.012,0.,0.)
      CALL PLCHHQ (.875,.630,':1045:',.012,0.,0.)
      CALL PLCHHQ (.875,.600,'10:S:10:S:100',.012,0.,0.)
      CALL PLCHHQ (.875,.570,'X:B1:2:S1:3',.012,0.,0.)
      CALL PLCHHQ (.875,.540,'X:B1:2:S:3:N:Y:S:2',.012,0.,0.)
      CALL PLCHHQ (.875,.510,'X:S:A:B:1:NN:ABC',.012,0.,0.)
      CALL PLCHHQ (.875,.480,'1.3648:L1:410:S:-13',.012,0.,0.)
C
C Now, do the same examples using medium-quality characters.
C
      CALL PLCHHQ (.715,.440,'MEDIUM-QUALITY CHARACTERS USED BELOW',
     +                                                       .012,0.,0.)
C
      CALL PCSETI ('QU',1)
C
      CALL PCSETC ('FC','$')
      CALL PLCHHQ (.625,.410,'INPUT STRING',.012,0.,0.)
      CALL PLCHHQ (.625,.380,'------------',.012,0.,0.)
      CALL PLCHHQ (.625,.350,':L:A',.012,0.,0.)
      CALL PLCHHQ (.625,.320,':IGL:A',.012,0.,0.)
      CALL PLCHHQ (.625,.290,'A:S:2:N:+B:S:2:N:',.012,0.,0.)
      CALL PLCHHQ (.625,.260,'A:S:B',.012,0.,0.)
      CALL PLCHHQ (.625,.230,'A:SPU:B',.012,0.,0.)
      CALL PLCHHQ (.625,.200,':GIU:+',.012,0.,0.)
      CALL PLCHHQ (.625,.170,':1045:',.012,0.,0.)
      CALL PLCHHQ (.625,.140,'10:S:10:S:100',.012,0.,0.)
      CALL PLCHHQ (.625,.110,'X:B1:2:S1:3',.012,0.,0.)
      CALL PLCHHQ (.625,.080,'X:B1:2:S:3:N:Y:S:2',.012,0.,0.)
      CALL PLCHHQ (.625,.050,'X:S:A:B:1:NN:ABC',.012,0.,0.)
      CALL PLCHHQ (.625,.020,'1.3648:L1:410:S:-13',.012,0.,0.)
C
      CALL PCSETC ('FC',':')
      CALL PLCHHQ (.875,.410,'RESULT',.012,0.,0.)
      CALL PLCHHQ (.875,.380,'------',.012,0.,0.)
      CALL PLCHHQ (.875,.350,':L:A',.012,0.,0.)
      CALL PLCHHQ (.875,.320,':IGL:A',.012,0.,0.)
      CALL PLCHHQ (.875,.290,'A:S:2:N:+B:S:2:N:',.012,0.,0.)
      CALL PLCHHQ (.875,.260,'A:S:B',.012,0.,0.)
      CALL PLCHHQ (.875,.230,'A:SPU:B',.012,0.,0.)
      CALL PLCHHQ (.875,.200,':GIU:+',.012,0.,0.)
      CALL PLCHHQ (.875,.170,':1045:',.012,0.,0.)
      CALL PLCHHQ (.875,.140,'10:S:10:S:100',.012,0.,0.)
      CALL PLCHHQ (.875,.110,'X:B1:2:S1:3',.012,0.,0.)
      CALL PLCHHQ (.875,.080,'X:B1:2:S:3:N:Y:S:2',.012,0.,0.)
      CALL PLCHHQ (.875,.050,'X:S:A:B:1:NN:ABC',.012,0.,0.)
      CALL PLCHHQ (.875,.020,'1.3648:L1:410:S:-13',.012,0.,0.)
C
      CALL PCSETI ('QU',0)
C
C Advance the frame.
C
      CALL FRAME
C
C --- E X A M P L E   1 - 1 0 -----------------------------------------
C
C Do a single frame showing the medium-quality characters with various
C aspect ratios.
C
C Put labels at the top of the plot.
C
      CALL PLCHMQ (.5,.98,
     +             'PLCHMQ - ALL CHARACTERS - VARIOUS ASPECT RATIOS',
     +                                                        .02,0.,0.)
C
      CALL PLCHMQ (.5,.95,'(Ratio of height to width varies from 2 in th
     +e top group down to .5 in the bottom group.)',.01,0.,0.)
C
C Produce five groups of characters.
C
      DO 111 I=1,32
        SOSC(I:I)=SPCH(I)
  111 CONTINUE
C
      DO 106 I=1,5
        YPOS=1.-.18*REAL(I)
        CALL PCSETR ('HW',2.-1.5*REAL(I-1)/4.)
        CALL PLCHMQ (.5,YPOS+.04,'ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789',
     +                                                        .02,0.,0.)
        CALL PLCHMQ (.5,YPOS    ,'abcdefghijklmnopqrstuvwxyz0123456789',
     +                                                        .02,0.,0.)
        CALL PLCHMQ (.5,YPOS-.04,SOSC(1:32),.02,0.,0.)
  106 CONTINUE
C
C Advance the frame.
C
      CALL FRAME
C
C --- E X A M P L E   1 - 1 1 -----------------------------------------
C
C Do a single frame showing all the characters in the fontcap databases,
C access to which was added in June of 1990.
C
C Double the line width.
C
      CALL PLOTIF (0.,0.,2)
      CALL GSLWSC (2.)
C
C Put a label at the top of the plot.
C
      CALL PLCHHQ (.5,.98,'PLCHHQ - FONTCAP DATABASES ADDED 6/90',
     +                                                        .02,0.,0.)
C
C Temporarily use the slash as a function code character.
C
      CALL PCSETC ('FC - FUNCTION CODE CHARACTER','/')
C
C Put an explanatory note on the plot.
C
      CALL PLCHHQ (.5,.945,':F1:c selects the ASCII character "c", as sh
     +own in the first two lines.',.01,0.,0.)
C
      CALL PLCHHQ (.5,.925,':Fn:c (2/F18/K/F0/n/F18/K/F0/20) selects the
     + corresponding character from font n.',.01,0.,0.)
C
C Return to a colon as the function code character.
C
      CALL PCSETC ('FC - FUNCTION CODE CHARACTER',':')
C
C Loop through all the available fonts.
C
      DO 108 IFNT=1,20
C
        YCEN=.945-.045*REAL(IFNT)
C
        WRITE (CHRS,'(I8)') IFNT
        CHRS(1:4)='FONT'
        CALL PCSETI ('FN - FONTCAP NUMBER',7)
        CALL PLCHHQ (.005,YCEN,CHRS,.012,0.,-1.)
C
        CALL PCSETI ('FN - FONTCAP NUMBER',IFNT)
C
C Draw all the meaningful characters from the font.
C
        DO 107 ICHR=33,126
          IF (ICHR.LE.79) THEN
            XCEN=.125+.0183*REAL(ICHR-32)
          ELSE
            XCEN=.125+.0183*REAL(ICHR-79)
          END IF
          IF (ICHR.EQ.80) YCEN=YCEN-.0225
          IF (CHAR(ICHR).EQ.':') CALL PCSETC ('FC','!')
          CALL PLCHHQ (XCEN,YCEN,CHAR(ICHR),.01,0.,0.)
          IF (CHAR(ICHR).EQ.':') CALL PCSETC ('FC',':')
  107   CONTINUE
C
C End of loop through fonts.
C
  108 CONTINUE
C
C Restore the fontcap number to 0 to select the PWRITX database.
C
      CALL PCSETI ('FN - FONTCAP NUMBER',0)
C
C Go back to normal line width.
C
      CALL PLOTIF (0.,0.,2)
      CALL GSLWSC (1.)
C
C Advance the frame.
C
      CALL FRAME
C
C --- E X A M P L E   1 - 1 2 -----------------------------------------
C
C Do a single frame showing the use of fontcap databases and some of
C the new features added in June of 1990.
C
C Double the line width.
C
      CALL PLOTIF (0.,0.,2)
      CALL GSLWSC (2.)
C
C Put a label at the top of the plot.
C
      CALL PLCHHQ (.5,.98,'PLCHHQ - FEATURES ADDED 6/90',.02,0.,0.)
C
C Temporarily use the slash as a function code character.
C
      CALL PCSETC ('FC - FUNCTION CODE CHARACTER','/')
C
C Combine characters from several different fonts to produce a single
C line.
C
      CALL PLCHHQ (.5,.910,'/F13/A line containing characters from sever
     +al fonts:  /F8/P/BF13/0/N/=/F5/g/SF13/2/N/+/F5/j/SF13/2/N/',
     +                                                       .012,0.,0.)
C
C Reset the internal parameter 'FN' to 4 and write a line illustrating
C the effect of function codes "Fn", "F", and "F0".  Then reset 'FN'
C to 0.
C
      CALL PCSETI ('FN - FONT NUMBER',4)
      CALL PLCHHQ (.5,.844,'Set ''FN'' (Font Number) to 4 and write a li
     +ne using "F" function codes:',.012,0.,0.)
      CALL PLCHHQ (.5,.820,'Before an F10 - /F10/after an F10 - /F/after
     + an F - /F0/after an F0.',.012,0.,0.)
      CALL PCSETI ('FN - FONT NUMBER',0)
C
C Write lines illustrating various kinds of zooming.
C
      CALL PLCHHQ (.500,.754,'/F13/Unzoomed characters from font 13.',
     +.012,0.,0.)
      CALL PLCHHQ (.500,.730,'/F13X150Q/Characters zoomed in width, usin
     +g X150Q.',.012,0.,0.)
      CALL PLCHHQ (.500,.700,'/F13Y150Q/Characters zoomed in height, usi
     +ng Y150Q.',.012,0.,0.)
      CALL PLCHHQ (.500,.664,'/F13Z150Q/Characters zoomed both ways, usi
     +ng Z150Q.',.012,0.,0.)
C
C Write a line illustrating non-aligned zooming in height.
C
      CALL PLCHHQ (.5,.630,'/F13/Unaligned zoom of selected characters:
     + /F16Y200/S/Y/cientific /Y200/V/Y/isualization /Y200/G/Y/roup',
     +                                                       .012,0.,0.)
C
C Write lines illustrating the use of 'AS' and 'SS'.
C
      CALL PCSETR ('AS - ADD SPACE BETWEEN CHARACTERS     ',.125)
      CALL PCSETR ('SS - SUBTRACT SPACE BETWEEN CHARACTERS',  0.)
      CALL PLCHHQ (.5,.564,'/F14/Line written with ''AS'' = .125 and ''S
     +S'' = 0.',.012,0.,0.)
      CALL PCSETR ('AS - ADD SPACE BETWEEN CHARACTERS     ',  0.)
      CALL PCSETR ('SS - SUBTRACT SPACE BETWEEN CHARACTERS',  0.)
      CALL PLCHHQ (.5,.540, '/F14/Line written with ''AS'' = 0. and ''SS
     +'' = 0.',.012,0.,0.)
      CALL PCSETR ('AS - ADD SPACE BETWEEN CHARACTERS     ',  0.)
      CALL PCSETR ('SS - SUBTRACT SPACE BETWEEN CHARACTERS',.125)
      CALL PLCHHQ (.5,.516, '/F14/Line written with ''AS'' = 0. and ''SS
     +'' = .125',.012,0.,0.)
      CALL PCSETR ('AS - ADD SPACE BETWEEN CHARACTERS     ',  0.)
      CALL PCSETR ('SS - SUBTRACT SPACE BETWEEN CHARACTERS',  0.)
C
C Illustrate the difference between inexact centering and exact
C centering of a single character.
C
      CALL PCSETR ('SS - SUBTRACT SPACE BETWEEN CHARACTERS',.128)
C
      CALL PLCHHQ (.1,.455,'/F7/This "g" is centered on the cross using
     + CNTR = 0. and ''CE'' = 0:',.012,0.,-1.)
      CALL LINE (.880,.455,.920,.455)
      CALL LINE (.900,.435,.900,.475)
      CALL PCSETI ('CE - CENTERING OPTION',0)
      CALL PLCHHQ (.9,.455,'/F7/g',.025,0.,0.)
      CALL PCSETI ('CE - CENTERING OPTION',0)
C
      CALL PLCHHQ (.1,.405,'/F7/This "g" is centered on the cross using
     + CNTR = 0. and ''CE'' = 1:',.012,0.,-1.)
      CALL LINE (.880,.405,.920,.405)
      CALL LINE (.900,.385,.900,.425)
      CALL PCSETI ('CE - CENTERING OPTION',1)
      CALL PLCHHQ (.9,.405,'/F7/g',.025,0.,0.)
      CALL PCSETI ('CE - CENTERING OPTION',0)
C
      CALL PCSETR ('SS - SUBTRACT SPACE BETWEEN CHARACTERS',0.)
C
C Put some large characters on a grid to show the digitization.
C
      CALL PLCHHQ (.5,.312,'Large characters on digitization grid.  X''s
     + mark edge points of the characters.',.01,0.,0.)
C
      CALL PCGETR ('SA - SIZE ADJUSTMENT',SIZA)
      WDTH=.15
      XLFT=.500-48.*(WDTH/16.)
      XRGT=.500+48.*(WDTH/16.)
      YBOT=.150-11.*(WDTH/16.)
      YTOP=.150+14.*(WDTH/16.)
C
      CALL PLOTIF (0.,0.,2)
      CALL GSLWSC (1.)
C
      DO 109 I=-48,48
        XCRD=.500+REAL(I)*(WDTH/16.)
        CALL LINE (XCRD,YBOT,XCRD,YTOP)
  109 CONTINUE
C
      DO 110 J=-11,14
        YCRD=.150+REAL(J)*(WDTH/16.)
        CALL LINE (XLFT,YCRD,XRGT,YCRD)
  110 CONTINUE
C
      CALL PLOTIF (0.,0.,2)
      CALL GSLWSC (2.)
C
      XCRD=.500-45.*(WDTH/16.)
      YCRD=.150+1.5*(WDTH/16.)
      CALL LINE (XCRD-WDTH/32.,YCRD-WDTH/32.,
     +           XCRD+WDTH/32.,YCRD+WDTH/32.)
      CALL LINE (XCRD-WDTH/32.,YCRD+WDTH/32.,
     +           XCRD+WDTH/32.,YCRD-WDTH/32.)
      CALL PLCHHQ (XCRD,YCRD,'/F9/A',WDTH/SIZA,0.,-1.)
      CALL PCGETR ('XE - X COORDINATE AT END OF STRING',XCRD)
      CALL LINE (XCRD-WDTH/32.,YCRD-WDTH/32.,
     +           XCRD+WDTH/32.,YCRD+WDTH/32.)
      CALL LINE (XCRD-WDTH/32.,YCRD+WDTH/32.,
     +           XCRD+WDTH/32.,YCRD-WDTH/32.)
      CALL PLCHHQ (XCRD,YCRD,'/F9/B',WDTH/SIZA,0.,-1.)
      CALL PCGETR ('XE - X COORDINATE AT END OF STRING',XCRD)
      CALL LINE (XCRD-WDTH/32.,YCRD-WDTH/32.,
     +           XCRD+WDTH/32.,YCRD+WDTH/32.)
      CALL LINE (XCRD-WDTH/32.,YCRD+WDTH/32.,
     +           XCRD+WDTH/32.,YCRD-WDTH/32.)
      CALL PLCHHQ (XCRD,YCRD,'/F9/C',WDTH/SIZA,0.,-1.)
      CALL PCGETR ('XE - X COORDINATE AT END OF STRING',XCRD)
      CALL LINE (XCRD-WDTH/32.,YCRD-WDTH/32.,
     +           XCRD+WDTH/32.,YCRD+WDTH/32.)
      CALL LINE (XCRD-WDTH/32.,YCRD+WDTH/32.,
     +           XCRD+WDTH/32.,YCRD-WDTH/32.)
      CALL PLCHHQ (XCRD,YCRD,'/F9/D',WDTH/SIZA,0.,-1.)
      CALL PCGETR ('XE - X COORDINATE AT END OF STRING',XCRD)
      CALL LINE (XCRD-WDTH/32.,YCRD-WDTH/32.,
     +           XCRD+WDTH/32.,YCRD+WDTH/32.)
      CALL LINE (XCRD-WDTH/32.,YCRD+WDTH/32.,
     +           XCRD+WDTH/32.,YCRD-WDTH/32.)
C
C Return to a colon as the function code character.
C
      CALL PCSETC ('FC - FUNCTION CODE CHARACTER',':')
C
C Go back to normal line width.
C
      CALL PLOTIF (0.,0.,2)
      CALL GSLWSC (1.)
C
C Advance the frame.
C
      CALL FRAME
C
C --- E X A M P L E   1 - 1 3 -----------------------------------------
C
C Do a single frame showing all the characters in the fontcap databases,
C access to which was added in October of 1992.
C
C Put a label at the top of the plot.
C
      CALL PLCHHQ (.5,.98,'PLCHHQ - FONTCAP DATABASES ADDED 10/92',
     +                                                        .02,0.,0.)
C
C Temporarily use the slash as a function code character.
C
      CALL PCSETC ('FC - FUNCTION CODE CHARACTER','/')
C
C Put an explanatory note on the plot.
C
      CALL PLCHHQ (.5,.945,':F1:c selects the ASCII character "c", as sh
     +own in the first two lines.',.01,0.,0.)
C
      CALL PLCHHQ (.5,.925,':Fn:c selects the corresponding character fr
     +om font n.',.01,0.,0.)
C
C Return to a colon as the function code character.
C
      CALL PCSETC ('FC - FUNCTION CODE CHARACTER',':')
C
C Loop through all the new filled fonts.
C
      DO 113 IFNS=1,23
C
        YCEN=.945-.0391304*REAL(IFNS)
C
        WRITE (CHRS,'(I8)') IFFN(IFNS)
        CHRS(1:4)='FONT'
        CALL PCSETI ('FN - FONTCAP NUMBER',7)
        CALL PLCHHQ (.005,YCEN,CHRS,.012,0.,-1.)
C
        CALL PCSETI ('FN - FONTCAP NUMBER',IFFN(IFNS))
C
C Draw all the meaningful characters from the font.
C
        DO 112 ICHR=33,126
          IF (ICHR.LE.79) THEN
            XCEN=.125+.0183*REAL(ICHR-32)
          ELSE
            XCEN=.125+.0183*REAL(ICHR-79)
          END IF
          IF (ICHR.EQ.80) YCEN=YCEN-.0195652
          IF (CHAR(ICHR).EQ.':') CALL PCSETC ('FC','!')
          CALL PLCHHQ (XCEN,YCEN,CHAR(ICHR),.01,0.,0.)
          IF (CHAR(ICHR).EQ.':') CALL PCSETC ('FC',':')
  112   CONTINUE
C
C End of loop through fonts.
C
  113 CONTINUE
C
C Restore the fontcap number to 0 to select the PWRITX database.
C
      CALL PCSETI ('FN - FONTCAP NUMBER',0)
C
C Advance the frame.
C
      CALL FRAME
C
C --- E X A M P L E   1 - 1 4 -----------------------------------------
C
C Do a single frame showing some of the new features added in December
C of 1992.
C
C Put a label at the top of the plot and, below that, an explanatory
C note.
C
      CALL PLCHHQ (.5,.975,':F25:PLCHHQ - FEATURES ADDED 12/92',
     +                                                       .025,0.,0.)
C
      CALL PCSETR ('SS - SUBTRACT SPACE BETWEEN CHARACTERS',.275)
      CALL PLCHHQ (.5,.938,':F13:(Use idt''s ''zoom'' to view some of th
     +is in detail, especially stacking.)',
     +                                                       .017,0.,0.)
      CALL PCSETR ('SS - SUBTRACT SPACE BETWEEN CHARACTERS',0.)
C
C Illustrate the use of filled fonts with shadows and outlines.  First,
C define some colors to use.
C
      CALL GSCR (IWKID,2,0.,.5,.5)
      CALL GSCR (IWKID,3,.9,.9,0.)
      CALL GSCR (IWKID,4,1.,.3,.3)
      CALL GSCR (IWKID,5,0.,0.,1.)
      CALL GSCR (IWKID,6,.2,.2,.2)
C
C Write a line.
C
      CALL PLCHHQ (.5,.900,':F26:By default, the current foreground colo
     +r is used.',
     +                                                       .024,0.,0.)
C
C Define the principal color to be used for characters.
C
      CALL PCSETI ('CC - CHARACTER COLOR',4)
C
C Write another line.
C
      CALL PLCHHQ (.5,.850,':F26:A non-negative ''CC'' requests a differ
     +ent color.',
     +                                                       .026,0.,0.)
C
C Turn on character shadows and define various characteristics of the
C shadow.
C
      CALL PCSETI ('SF - SHADOW FLAG',1)
      CALL PCSETR ('SX - SHADOW OFFSET IN X',-.1)
      CALL PCSETR ('SY - SHADOW OFFSET IN Y',-.1)
      CALL PCSETI ('SC - SHADOW COLOR',2)
C
C Write another line.
C
      CALL PLCHHQ (.5,.796,':F26:''SF'', ''SC'', ''SX'', and ''SY'' crea
     +te shadows.',
     +                                                       .028,0.,0.)
C
C Turn on character outlines and define the color of the outline.
C
      CALL PCSETI ('OF - OUTLINE FLAG',1)
      CALL PCSETI ('OC - OUTLINE COLOR',3)
      CALL PCSETI ('OL - OUTLINE LINE WIDTH',1)
C
C Write another line.
C
      CALL PLCHHQ (.5,.738,':F26:''OF'', ''OC'', and ''OL'' add outlines
     +.',
     +                                                       .030,0.,0.)
C
C Turn on the drawing of boxes and define characteristics of them.
C
      CALL PCSETI ('BF - BOX FLAG',7)
      CALL PCSETI ('BL - BOX LINE WIDTH',2)
      CALL PCSETR ('BM - BOX MARGIN',.15)
      CALL PCSETR ('BX - BOX SHADOW X OFFSET',-.1)
      CALL PCSETR ('BY - BOX SHADOW Y OFFSET',-.1)
      CALL PCSETI ('BC(1) - BOX COLOR - BOX OUTLINE    ',5)
      CALL PCSETI ('BC(2) - BOX COLOR - BOX FILL       ',6)
      CALL PCSETI ('BC(3) - BOX COLOR - BOX SHADOW FILL',2)
C
C Write another line.
C
      CALL PLCHHQ (.5,.672,':F26:''BF'', ''BC'', ''BL'', ''BM'', ''BX'',
     + and ''BY'' add a box.',
     +                                                       .026,0.,0.)
C
C Get rid of the box shadow, which doesn't add much.
C
      CALL PCSETI ('BF - BOX FLAG',3)
C
C Write another line.
C
      CALL PCSETC ('FC - FUNCTION-CODE CHARACTER','/')
      CALL PLCHHQ (.5,.592,'/F26/''MA'' and ''OR'' are used for mapping:
     +',
     +                                                       .030,0.,0.)
      CALL PCSETC ('FC - FUNCTION CODE CHARACTER',':')
C
C Write a couple of headers for the plots that follow.
C
      CALL PLCHHQ (.28,.528,':F25:(EZMAP)',.024,0.,0.)
      CALL PLCHHQ (.72,.528,':F33:(r:F25: and :F33:q)',.024,0.,0.)
C
C Initialize EZMAP and draw a background.
C
      CALL MAPSTC ('OU','CO')
      CALL MAPSTI ('GR',5)
      CALL MAPPOS (.065,.495,.065,.495)
      CALL MAPSTR ('SA',8.5)
      CALL MAPROJ ('SV',0.,-25.,0.)
      CALL MAPINT
      CALL MAPLOT
      CALL MAPGRD
C
C Tell PLOTCHAR to map characters through EZMAP.
C
      CALL PCSETI ('MA - MAPPING FLAG',1)
      CALL PCSETR ('OR - OUT-OF-RANGE FLAG',1.E12)
C
C Write a line across the surface of the globe.
C
      CALL PLCHHQ (-25.,0.,':F25Y200:NCAR GRAPHICS',8.,30.,0.)
C
C Do an appropriate SET call for a rho-theta mapping.
C
      CALL SET    (.505,.935,.065,.495,-27.5,27.5,-27.5,27.5,1)
C
C Tell PLOTCHAR to use a rho-theta mapping.
C
      CALL PCSETI ('MA - MAPPING FLAG',2)
      CALL PCSETR ('OR - OUT-OF-RANGE FLAG',0.)
C
C Write three lines in rho/theta space, orienting them so they come out
C in a circle after mapping.
C
      CALL PLCHHQ (20., 90.,':F25Y125:NCAR GRAPHICS',8.,-90.,0.)
      CALL PLCHHQ (20.,210.,':F25Y125:NCAR GRAPHICS',8.,-90.,0.)
      CALL PLCHHQ (20.,-30.,':F25Y125:NCAR GRAPHICS',8.,-90.,0.)
C
C Turn off mapping and recall SET to allow fractional coordinates again.
C
      CALL PCSETI ('MA - MAPPING FLAG',0)
C
      CALL SET    (0.,1.,0.,1.,0.,1.,0.,1.,1)
C
C Change the drawing order to allow for "stacking" characters from
C right to left.
C
      CALL PCSETI ('DO - DRAWING ORDER',-2)
C
C Reduce the space between characters so the "stacking" is visible.
C
      CALL PCSETR ('SS - SUBTRACT-SPACE FLAG',.3)
C
C Turn off the box.  Make the shadows black and position them so they
C help make the stacked characters readable.
C
      CALL PCSETI ('BF - BOX FLAG',0)
      CALL PCSETI ('SC - SHADOW COLOR',0)
      CALL PCSETR ('SX - SHADOW OFFSET IN X',.1)
      CALL PCSETR ('SY - SHADOW OFFSET IN Y',0.)
C
C Write a final line demonstrating "stacking".
C
      CALL PLCHHQ (.5,.030,':F26:Use    ''DO''    and    ''SS''    to   +
     + "stack"    characters    in    either    direction.',
     +                                                       .026,0.,0.)
C
C Advance the frame.
C
      CALL FRAME
C
C --- E N D   O F   E X A M P L E S -----------------------------------
C
C Close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
C Done.
C
      STOP
C
      END



      SUBROUTINE DRAWBX (XCEN,YCEN,ANGD,XTRA)
      CALL PCGETR ('DL - DISTANCE LEFT  ',DSTL)
      CALL PCGETR ('DR - DISTANCE RIGHT ',DSTR)
      CALL PCGETR ('DB - DISTANCE BOTTOM',DSTB)
      CALL PCGETR ('DT - DISTANCE TOP   ',DSTT)
      ANGR=.017453292519943*ANGD
      SINA=SIN(ANGR)
      COSA=COS(ANGR)
      XFRA=CUFX(XCEN)
      YFRA=CUFY(YCEN)
      XALB=XFRA-(DSTL+XTRA)*COSA+(DSTB+XTRA)*SINA
      YALB=YFRA-(DSTL+XTRA)*SINA-(DSTB+XTRA)*COSA
      XARB=XFRA+(DSTR+XTRA)*COSA+(DSTB+XTRA)*SINA
      YARB=YFRA+(DSTR+XTRA)*SINA-(DSTB+XTRA)*COSA
      XART=XFRA+(DSTR+XTRA)*COSA-(DSTT+XTRA)*SINA
      YART=YFRA+(DSTR+XTRA)*SINA+(DSTT+XTRA)*COSA
      XALT=XFRA-(DSTL+XTRA)*COSA-(DSTT+XTRA)*SINA
      YALT=YFRA-(DSTL+XTRA)*SINA+(DSTT+XTRA)*COSA
      CALL PLOTIF (XALB,YALB,0)
      CALL PLOTIF (XARB,YARB,1)
      CALL PLOTIF (XART,YART,1)
      CALL PLOTIF (XALT,YALT,1)
      CALL PLOTIF (XALB,YALB,1)
      CALL PLOTIF (0.,0.,2)
      RETURN
      END

      PROGRAM FCOVER
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C This program requires the input data file 'fcover.dat'
C It reads the data from standard input, e.g.: fcover < fcover.dat
C
      PARAMETER (MSIZE=73, NSIZE=73)
C
      DIMENSION U(MSIZE,NSIZE), V(MSIZE,NSIZE), P(MSIZE,NSIZE)
C
C Conpack work space and Areas area map
C
      PARAMETER (ICPIWL=1000, ICPRWL=5000, IAREAL=20000)
      DIMENSION RWRK(ICPRWL),IWRK(ICPIWL)
      DIMENSION IAM(IAREAL)
C
C Arrays for drawing masked grids
C
      PARAMETER (MCRA=64, NOGI=64)
      DIMENSION XCRA(MCRA),YCRA(MCRA),IAAI(NOGI),IAGI(NOGI)
C
C map filling arrays
C
      PARAMETER (LMAP=150000,NWRK=10000,ISIZ=5)
      INTEGER MAP(LMAP), IAREA(ISIZ), IGRP(ISIZ)
      REAL XWRK(NWRK), YWRK(NWRK)
C
C External subroutine declarations
C
      EXTERNAL FILL
      EXTERNAL DRAWCL
      EXTERNAL VVUDMV
      PARAMETER (NCLRS1=15, NCLRS2=9)
      DIMENSION RGB1(3,NCLRS1)
      DIMENSION ICLR1(NCLRS1)
C
      DIMENSION RGB2(3,NCLRS2)
      DIMENSION ICLR2(NCLRS2)
      COMMON /CBFILL/ IFILIX(2), RLWFAC
C
C Empirically determined vector thinning data
C Starting from the pole, each row of vectors is weeded, mod the
C value of this data.
C
      PARAMETER (NROWS = 11)
      DIMENSION ITHIN(NROWS)
      DATA ITHIN /90,15,5,5,4,4,3,3,2,2,2/
C
C Indices used for vector coloring
C
      DATA ICLR1 / 10, 17, 24, 31, 38, 45, 52, 60, 67, 
     +             74, 81, 88, 95, 102, 109 /
C
C Define a set of RGB color triples for vector colors
C
C
      DATA RGB1 /
     +       0.00000,   1.00000,   0.00000,
     +       0.14286,   1.00000,   0.00000,
     +       0.28571,   1.00000,   0.00000,
     +       0.42857,   1.00000,   0.00000,
     +       0.57143,   1.00000,   0.00000,
     +       0.71429,   1.00000,   0.00000,
     +       0.85714,   1.00000,   0.00000,
     +       1.00000,   1.00000,   0.00000,
     +       1.00000,   0.85714,   0.00000,
     +       1.00000,   0.71429,   0.00000,
     +       1.00000,   0.57143,   0.00000,
     +       1.00000,   0.42857,   0.00000,
     +       1.00000,   0.28571,   0.00000,
     +       1.00000,   0.14286,   0.00000,
     +       1.00000,   0.00000,   0.00000 /
C
C Indices used for coloring other plot features; be careful not
C to duplicate any color indices in ICLR1
C
      DATA ICLR2 / 0, 1, 2, 149, 225, 175, 176, 200, 3 /
C
C RGB values for other plot features
C
      DATA RGB2 / 
     +     1.0,1.0,1.0,
     +     0.0,0.0,0.0,
     +     0.9,0.9,0.9,
     +     0.6,0.6,0.6,
     +     0.3,0.3,0.3,
     +     0.8,0.9,1.0,
     +     0.5,0.0,0.5, 
C
C This is the ocean color; the color actually used on the 
C Fundamentals cover is the following commented out value --
C for viewing on a workstation a bit darker color makes the
C lettering easier to read.
C
C     +     0.0,0.9,1.0,
     +     0.0,0.5,0.7,
     +     0.0,0.0,0.0  /
C
C -----------------------------------------------------------------
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Give initial value to fill color index stored common block CBFILL
C
      IFILIX(1) = 149
      IFILIX(2) = 200
      RLWFAC=1.0
C
C Set up auxiliary colors
C
      DO 10 I=1,NCLRS2,1
         CALL GSCR(IWKID,ICLR2(I),RGB2(1,I),RGB2(2,I),RGB2(3,I))
 10   CONTINUE
C
C Read the input array data
C
      CALL RDDATA(U,V,P,MSIZE,NSIZE)
C
C Message the data to eliminate surplus of vectors near the pole
C
      DO 50 J=NSIZE,NSIZE-NROWS+1,-1
         DO 49 I=1,MSIZE
            IF (MOD(I,ITHIN(NSIZE-J+1)).NE.0) THEN
               U(I,J) = -9999.0
            ENDIF
 49      CONTINUE
 50   CONTINUE
C
C Set up the EZMAP projection
C         
      CALL MAPSTC ('OU - OUTLINE DATASET SELECTOR','CO')
      CALL MAPSET('CO',10.0,-180.0,10.0,0.0)
      CALL MAPROJ('ST',90.0,180.0,45.0)
      CALL MAPINT
C
C Initialize Maps and Areas
C
      CALL MAPINT
      CALL ARINAM (MAP,LMAP)
      CALL MAPBLA (MAP)
C
C Tell Vectors to use the mapping established by EZMAP
C
      CALL VVSETI('MAP -- Mapping Flag', 1)
      CALL VVSETI('SET -- Set Call Flag', 0)
C
C Set up data coordinate boundaries and special value processing 
C appropriately for the dataset 
C
      CALL VVSETR('XC1 -- Lower X Bound', -180.0)
      CALL VVSETR('XCM -- Upper X Bound', 180.0)
      CALL VVSETR('YC1 -- Lower X Bound', -90.0)
      CALL VVSETR('YCN -- Upper Y Bound', 90.0)
C
      CALL VVSETI('SVF -- Special Values Flag', 3)
      CALL VVSETR('USV -- U Special Value', -9999.0)
      CALL VVSETR('VSV -- V Special Value', -9999.0)
      CALL VVSETR('PSV - P Special Value', -9999.0)
      CALL VVSETI('SPC - P Special Color', 1)
C
C Do the equivalent Conpack setup; note that the special value
C parameter works a bit differently, and also Conpack requires
C an Out of Range value to be set whenever the data grid extends
C outside the map boundaries. The standard value for the default
C version of CPMPXY is 1.0E12
C
      CALL CPSETI('MAP -- Mapping Flag', 1)
      CALL CPSETI('SET -- Set Call Flag', 0)
      CALL CPSETR('XC1 -- Lower X Bound', -180.0)
      CALL CPSETR('XCM -- Upper X Bound', 180.0)
      CALL CPSETR('YC1 -- Lower X Bound', -90.0)
      CALL CPSETR('YCN -- Upper Y Bound', 90.0)
      CALL CPSETR('SPV -- Special Value',-9999.0)
      CALL CPSETR('ORV -- Out of Range Value',1.0E12)
C
C Set Conpack graphics text parameters
C
      CALL SETCGT
C
C Turn on statistics reporting, turn off vector text blocks
C
      CALL VVSETI('VST -- Vector Statistics', 1)
      CALL VVSETC('MNT - Minimum Vector Text Block', ' ')
      CALL VVSETC('MXT - Maximum Vector Text Block', ' ')
C
C Initialize the drawing of the contour plot, and tell Conpack
C to pick contour levels.
C
      CALL CPRECT (P,MSIZE,MSIZE,NSIZE,RWRK,ICPRWL,IWRK,ICPIWL)
      CALL CPPKCL (P,RWRK,IWRK)
C
C Set up contour line attributes
C
      CALL CPGETI('NCL - Number Of Contour Levels',NCLV)
      CALL SETCLA(NCLV, ICLR2(6),ICLR2(3))
C
C Initialize the area map, and add the Conpack labels to the area map
C
      CALL ARINAM (IAM,IAREAL)
      CALL CPLBAM (P,RWRK,IWRK,IAM)
C
C Set up vector color processing
C
      CALL VVSETI('MSK -- Vector Masking',1)
      CALL VVSETI('CTV -- Color Thresholds Value', 2)
      CALL VVSETI('NLV -- Number Of Levels', NCLRS1)
      DO 100 J=1,NCLRS1,1
         CALL GSCR(IWKID,ICLR1(J),RGB1(1,J),RGB1(2,J),RGB1(3,J))
         CALL VVSETI('PAI -- Parameter Array Index', J)
         CALL VVSETI('CLR -- GKS Color Index', ICLR1(J))
 100  CONTINUE
C
C Modify the color table for a blue background
C and modify the contour attributes
C
      CALL GSCR(IWKID,ICLR2(1),RGB2(1,8),RGB2(2,8),RGB2(3,8))
      CALL GSCR(IWKID,ICLR2(2),RGB2(1,1),RGB2(2,1),RGB2(3,1))
      CALL SETCLA(NCLV, ICLR2(7),ICLR2(3))
C
C Draw four frames showing first the complete picture, then the
C plot decomposed into 1) Ezmap components 2) Conpack components
C and 3) Vectors components
C
      DO 1000 I=1,4
C
C Solid file continental boundaries
C
         IF (I.EQ.1 .OR. I.EQ.2) THEN
C    
C Color fill land masses using a gray scale value
C
            CALL GSFAIS (1)
            CALL ARSCAM (MAP, XWRK, YWRK, NWRK, IAREA, IGRP, ISIZ, FILL)
C
C Draw boundaries, including the limb
C
            CALL MAPSTI('C5 - Continental Outline Color',ICLR2(9))
            CALL MAPLOT
         END IF
C
C Draw the masked contour lines
C
         IF (I.EQ.1 .OR. I.EQ.3) THEN
            CALL CPCLDM (P,RWRK,IWRK,IAM,DRAWCL)
         END IF
C
C Draw the map grid
C
         IF (I.EQ.1 .OR. I.EQ.2) THEN
            CALL MAPSTI('C2 - Grid',ICLR2(9))
            CALL GSPLCI(ICLR2(9))
            CALL MAPGRM (IAM,XCRA,YCRA,MCRA,IAAI,IAGI,NOGI,DRAWCL)
            CALL GSPLCI(1)
         END IF
C
         IF (I.EQ.1 .OR. I.EQ.4) THEN
C
C Initialize Vectors
C
            CALL VVINIT (U,MSIZE,V,MSIZE,P,MSIZE,MSIZE,NSIZE,IDM,IDM)
C
C Adjust vector rendering options
C
            CALL VVSETR('AMN -- Arrow Minimum Size',0.007)
            CALL VVSETR('LWD -- Vector Line Width',3.00*RLWFAC)
            CALL VVGETR('VMN -- Minimum Vector',VMN)
            CALL VVGETR('VMX -- Maximum Vector',VMX)
            CALL VVSETR('VLC -- Vector Low Cutoff',VMN+0.1*(VMX-VMN))
            CALL VVGETR('DMX -- Device Maximum Vector Length',DMX)
            CALL GETSET(VL,VR,VB,VT,UL,UR,UB,UT,LL)
            CALL VVSETR('VRL - Vector Realized Length',4.0*DMX/(VR-VL))
            CALL VVSETR('VFR -- Vector Fractional Minimum',0.4)
C
C Draw the vector field plot
C
            CALL VVECTR (U,V,P,IAM,VVUDMV,IDM)
         END IF
C
C Draw labels last
C
         IF (I.EQ.1 .OR. I.EQ.3) THEN
            CALL CPSETI('HLB',1)
            CALL GSFAIS(0)
            CALL CPLBDR (P,RWRK,IWRK)
         END IF
C
C Draw a perimeter boundary and eject the frame
C
         CALL PERIM(1,0,1,0)
         CALL FRAME
C
 1000 CONTINUE
C
C     Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      STOP
      END
C
      SUBROUTINE RDDATA(U,V,P,M,N)
C
C Read the data arrays from the standard input 
C
      DIMENSION U(M,N), V(M,N), P(M,N)
C     
      READ (*,*) U
      READ (*,*) V
      READ (*,*) P
C
      RETURN
      END
C
C =====================================================================
C
      SUBROUTINE DRAWCL (XCS,YCS,NCS,IAI,IAG,NAI)
C
C Routine for masked drawing of contour and grid lines
C
C This version of DRAWCL draws the polyline defined by the points
C ((XCS(I),YCS(I)),I=1,NCS) if and only if none of the area identifiers
C for the area containing the polyline are negative.  The dash package
C routine CURVED is called to do the drawing.
C
      DIMENSION XCS(*),YCS(*),IAI(*),IAG(*)
C
C Turn on drawing.
C
      IDR=1
C
C If any area identifier is negative, turn off drawing.
C
      DO 101 I=1,NAI
         IF (IAI(I).LT.0) IDR=0
 101  CONTINUE
C
C If drawing is turned on, draw the polyline.
C
      IF (IDR.NE.0) CALL CURVED (XCS,YCS,NCS)
C
C Done.
C
      RETURN
C
      END
C
C =====================================================================
C
      SUBROUTINE SETCGT
C
C Sets Conpack Graphics Text Parameters
C
      CALL CPSETI ('LLP - LINE LABEL POSITIONING',0)
      CALL CPSETI ('RWC - REAL WORKSPACE FOR CONTOURS',200)
      CALL CPSETI ('HLB - HIGH/LOW LABEL BOX FLAG',1)
      CALL CPSETI ('LLB - line label box flag',0)
      CALL CPSETC ('ILT - INFORMATION LABEL TEXT',' ')
      CALL CPSETI ('HLO - HIGH/LOW LABEL OVERLAP FLAG',11)
      CALL CPSETR ('CWM - CHARACTER WIDTH MULTIPLIER',1.25)
C
      RETURN
      END
C
C =====================================================================
C
      SUBROUTINE SETCLA (NCLV, ICLCLR, IAXCLR)
C
      COMMON /CBFILL/ IFILIX(2), RLWFAC
C
C Sets Contour Line Attributes
C
      DO 100 ICLV=1,NCLV
C
         CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',ICLV)
         CALL CPGETI ('CLU - CONTOUR LEVEL USE FLAG',ICLU)
         CALL CPSETR ('CLL - CONTOUR-LINE LINE WIDTH',3.0*RLWFAC)
         CALL CPSETI ('CLC - CONTOUR-LINE COLOR', ICLCLR)
         IF (ICLU.EQ.3) THEN
            CALL CPSETR ('CLL - CONTOUR-LINE LINE WIDTH',6.0*RLWFAC)
         END IF
C
 100  CONTINUE
C
C 'Special' contour lines - grid, special values, and out of range
C boundaries 
C
      CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',-1)
      CALL CPSETI ('CLU - CONTOUR LEVEL USE FLAG',0)
      CALL CPSETR ('CLL - CONTOUR LEVEL LINE WIDTH',2.)
      CALL CPSETI ('CLC - CONTOUR LEVEL LINE COLOR',IAXCLR)
C
      CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',-2)
      CALL CPSETI ('CLU - CONTOUR LEVEL USE FLAG',1)
      CALL CPSETR ('CLL - CONTOUR LEVEL LINE WIDTH',2.)
      CALL CPSETI ('CLC - CONTOUR LEVEL LINE COLOR',IAXCLR)
C
      CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',-3)
      CALL CPSETI ('CLU - CONTOUR LEVEL USE FLAG',1)
      CALL CPSETR ('CLL - CONTOUR LEVEL LINE WIDTH',2.)
      CALL CPSETI ('CLC - CONTOUR LEVEL LINE COLOR',IAXCLR)
C
      RETURN
      END
C
      SUBROUTINE FILL (XWRK,YWRK,NWRK,IAREA,IGRP,IDSIZ)
C
      DIMENSION XWRK(*),YWRK(*),IAREA(*),IGRP(*)
C
      COMMON /CBFILL/ IFILIX(2), RLWFAC
C
C Retrieve area id for geographic area
C
      ID = 0
      DO 10, I=1,IDSIZ
         IF (IGRP(I) .EQ. 1) ID = IAREA(I)
 10   CONTINUE
C
C If it's not water, draw it
C
      IF (ID .GE. 1) THEN
         IF (MAPACI(ID).NE.1) THEN
            CALL GSFACI(IFILIX(1))
         ELSE
            CALL GSFACI(IFILIX(2))
         END IF
         CALL GFA(NWRK,XWRK,YWRK)
      ENDIF
C
C Otherwise, do nothing
C
      RETURN
      END

      SUBROUTINE ZDRSCL( N, SA, SX, INCX )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      INTEGER            INCX, N
      DOUBLE PRECISION   SA
*     ..
*     .. Array Arguments ..
      COMPLEX*16         SX( * )
*     ..
*
*  Purpose
*  =======
*
*  ZDRSCL multiplies an n-element complex vector x by the real scalar
*  1/a.  This is done without overflow or underflow as long as
*  the final result x/a does not overflow or underflow.
*
*  Arguments
*  =========
*
*  N       (input) INTEGER
*          The number of components of the vector x.
*
*  SA      (input) DOUBLE PRECISION
*          The scalar a which is used to divide each component of x.
*          SA must be >= 0, or the subroutine will divide by zero.
*
*  SX      (input/output) COMPLEX*16 array, dimension
*                         (1+(N-1)*abs(INCX))
*          The n-element vector x.
*
*  INCX    (input) INTEGER
*          The increment between successive values of the vector SX.
*          > 0:  SX(1) = X(1) and SX(1+(i-1)*INCX) = x(i),     1< i<= n
*
* =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO, ONE
      PARAMETER          ( ZERO = 0.0D+0, ONE = 1.0D+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            DONE
      DOUBLE PRECISION   BIGNUM, CDEN, CDEN1, CNUM, CNUM1, MUL, SMLNUM
*     ..
*     .. External Functions ..
      DOUBLE PRECISION   DLAMCH
      EXTERNAL           DLAMCH
*     ..
*     .. External Subroutines ..
      EXTERNAL           DLABAD, ZDSCAL
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS
*     ..
*     .. Executable Statements ..
*
*     Quick return if possible
*
      IF( N.LE.0 )
     $   RETURN
*
*     Get machine parameters
*
      SMLNUM = DLAMCH( 'S' )
      BIGNUM = ONE / SMLNUM
      CALL DLABAD( SMLNUM, BIGNUM )
*
*     Initialize the denominator to SA and the numerator to 1.
*
      CDEN = SA
      CNUM = ONE
*
   10 CONTINUE
      CDEN1 = CDEN*SMLNUM
      CNUM1 = CNUM / BIGNUM
      IF( ABS( CDEN1 ).GT.ABS( CNUM ) .AND. CNUM.NE.ZERO ) THEN
*
*        Pre-multiply X by SMLNUM if CDEN is large compared to CNUM.
*
         MUL = SMLNUM
         DONE = .FALSE.
         CDEN = CDEN1
      ELSE IF( ABS( CNUM1 ).GT.ABS( CDEN ) ) THEN
*
*        Pre-multiply X by BIGNUM if CDEN is small compared to CNUM.
*
         MUL = BIGNUM
         DONE = .FALSE.
         CNUM = CNUM1
      ELSE
*
*        Multiply X by CNUM / CDEN and return.
*
         MUL = CNUM / CDEN
         DONE = .TRUE.
      END IF
*
*     Scale the vector X by MUL
*
      CALL ZDSCAL( N, MUL, SX, INCX )
*
      IF( .NOT.DONE )
     $   GO TO 10
*
      RETURN
*
*     End of ZDRSCL
*
      END

C
C	$Id: gqwks.f,v 1.5 2008-07-27 00:21:01 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GQWKS(WKID,ERRIND,STATE)
C
C  INQUIRE WORKSTATION STATE
C
      include 'gkscom.h'
C
      INTEGER WKID,ERRIND,STATE
C
C  Check if GKS is in the proper state.
C
      CALL GZCKST(7,-1,ERRIND)
      IF (ERRIND .NE. 0) GOTO 100
C
C  Check that the workstation identifier is valid.
C
      CALL GZCKWK(20,-1,WKID,IDUM,ERRIND)
      IF (ERRIND .NE. 0) GO TO 100
C
C  Check if the specified workstation is open.
C
      CALL GZCKWK(25,-1,WKID,IDUM,ERRIND)
      IF (ERRIND .NE. 0) GO TO 100
C
C  Check for invalid workstation categories.
C
      CALL GQWKC(WKID,ERRIND,ICONID,ITYPE)
      IF (ERRIND .NE. 0) GO TO 100
      CALL GQWKCA(ITYPE,ERRIND,ICAT)
      IF (ERRIND .NE. 0) GO TO 100
      IF (ICAT .EQ. GMI) THEN
        ERRIND = 33
        GO TO 100
      ELSE IF (ICAT .EQ. GINPUT) THEN
        ERRIND = 35
        GO TO 100
      ENDIF
C
      STATE = 0
      DO 10 I=1,NACWK
        IF (WKID .EQ. SACWK(I)) THEN
          STATE =1
          RETURN
        ENDIF
   10 CONTINUE
      RETURN
C
  100 CONTINUE
      STATE = -1
      RETURN
      END

C
C $Id: kurv1.f,v 1.5 2008-07-27 03:10:11 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
C NOTE: If you make any changes to this software, please remember to
C make the same changes to the corresponding double precision routine.
C
      subroutine kurv1 (n,x,y,slp1,slpn,islpsw,xp,yp,temp,s,
     *                  sigma,ierr)
c
      integer n,islpsw,ierr
      real x(n),y(n),slp1,slpn,xp(n),yp(n),temp(n),s(n),
     *     sigma
c
c                                 coded by alan kaylor cline
c                           from fitpack -- january 26, 1987
c                        a curve and surface fitting package
c                      a product of pleasant valley software
c                  8603 altus cove, austin, texas 78759, usa
c
c this subroutine determines the parameters necessary to
c compute a spline under tension forming a curve in the
c plane and passing through a sequence of pairs (x(1),y(1)),
c ...,(x(n),y(n)). for actual computation of points on the
c curve it is necessary to call the subroutine kurv2.
c
c on input--
c
c   n is the number of points to be interpolated (n.ge.2).
c
c   x is an array containing the n x-coordinates of the
c   points.
c
c   y is an array containing the n y-coordinates of the
c   points. (adjacent x-y pairs must be distinct, i. e.
c   either x(i) .ne. x(i+1) or y(i) .ne. y(i+1), for
c   i = 1,...,n-1.)
c
c   slp1 and slpn contain the desired values for the angles
c   (in radians) of the slope at (x(1),y(1)) and (x(n),y(n))
c   respectively. the angles are measured counter-clock-
c   wise from the x-axis and the positive sense of the curve
c   is assumed to be that moving from point 1 to point n.
c   the user may omit values for either or both of these
c   parameters and signal this with islpsw.
c
c   islpsw contains a switch indicating which slope data
c   should be used and which should be estimated by this
c   subroutine,
c          = 0 if slp1 and slpn are to be used,
c          = 1 if slp1 is to be used but not slpn,
c          = 2 if slpn is to be used but not slp1,
c          = 3 if both slp1 and slpn are to be estimated
c              internally.
c
c   xp and yp are arrays of length at least n.
c
c   temp is an array of length at least n which is used
c   for scratch storage.
c
c   s is an array of length at least n.
c
c and
c
c   sigma contains the tension factor. this value indicates
c   the curviness desired. if abs(sigma) is nearly zero
c   (e.g. .001) the resulting curve is approximately a cubic
c   spline. if abs(sigma) is large (e. g. 50.) the resulting
c   curve is nearly a polygonal line. if sigma equals zero a
c   cubic spline results. a standard value for sigma is
c   approximately 1. in absolute value.
c
c on output--
c
c   xp and yp contain information about the curvature of the
c   curve at the given nodes.
c
c   s contains the polygonal arclengths of the curve.
c
c   ierr contains an error flag,
c        = 0 for normal return,
c        = 1 if n is less than 2,
c        = 2 if adjacent coordinate pairs coincide.
c
c and
c
c   n, x, y, slp1, slpn, islpsw, and sigma are unaltered.
c
c this subroutine references package modules ceez, terms,
c and snhcsh.
c
c-----------------------------------------------------------
c
      nm1 = n-1
      np1 = n+1
      ierr = 0
      if (n .le. 1) go to 11
c
c determine polygonal arclengths
c
      s(1) = 0.
      do 1 i = 2,n
        im1 = i-1
    1   s(i) = s(im1)+sqrt((x(i)-x(im1))**2+
     *         (y(i)-y(im1))**2)
c
c denormalize tension factor
c
      sigmap = abs(sigma)*float(n-1)/s(n)
c
c approximate end slopes
c
      if (islpsw .ge. 2) go to 2
      slpp1x = cos(slp1)
      slpp1y = sin(slp1)
      go to 4
    2 dels1 = s(2)-s(1)
      dels2 = dels1+dels1
      if (n .gt. 2) dels2 = s(3)-s(1)
      if (dels1 .eq. 0. .or. dels2 .eq. 0.) go to 12
      call ceez (dels1,dels2,sigmap,c1,c2,c3,n)
      sx = c1*x(1)+c2*x(2)
      sy = c1*y(1)+c2*y(2)
      if (n .eq. 2) go to 3
      sx = sx+c3*x(3)
      sy = sy+c3*y(3)
    3 delt = sqrt(sx*sx+sy*sy)
      slpp1x = sx/delt
      slpp1y = sy/delt
    4 if (islpsw .eq. 1 .or. islpsw .eq. 3) go to 5
      slppnx = cos(slpn)
      slppny = sin(slpn)
      go to 7
    5 delsn = s(n)-s(nm1)
      delsnm = delsn+delsn
      if (n .gt. 2) delsnm = s(n)-s(n-2)
      if (delsn .eq. 0. .or. delsnm .eq. 0.) go to 12
      call ceez (-delsn,-delsnm,sigmap,c1,c2,c3,n)
      sx = c1*x(n)+c2*x(nm1)
      sy = c1*y(n)+c2*y(nm1)
      if (n .eq. 2) go to 6
      sx = sx+c3*x(n-2)
      sy = sy+c3*y(n-2)
    6 delt = sqrt(sx*sx+sy*sy)
      slppnx = sx/delt
      slppny = sy/delt
c
c set up right hand sides and tridiagonal system for xp and
c yp and perform forward elimination
c
    7 dx1 = (x(2)-x(1))/s(2)
      dy1 = (y(2)-y(1))/s(2)
      call terms (diag1,sdiag1,sigmap,s(2))
      xp(1) = (dx1-slpp1x)/diag1
      yp(1) = (dy1-slpp1y)/diag1
      temp(1) = sdiag1/diag1
      if (n .eq. 2) go to 9
      do 8 i = 2,nm1
        dels2 = s(i+1)-s(i)
        if (dels2 .eq. 0.) go to 12
        dx2 = (x(i+1)-x(i))/dels2
        dy2 = (y(i+1)-y(i))/dels2
        call terms (diag2,sdiag2,sigmap,dels2)
        diag = diag1+diag2-sdiag1*temp(i-1)
        diagin = 1./diag
        xp(i) = (dx2-dx1-sdiag1*xp(i-1))*diagin
        yp(i) = (dy2-dy1-sdiag1*yp(i-1))*diagin
        temp(i) = sdiag2*diagin
        dx1 = dx2
        dy1 = dy2
        diag1 = diag2
    8   sdiag1 = sdiag2
    9 diag = diag1-sdiag1*temp(nm1)
      xp(n) = (slppnx-dx1-sdiag1*xp(nm1))/diag
      yp(n) = (slppny-dy1-sdiag1*yp(nm1))/diag
c
c perform back substitution
c
      do 10 i = 2,n
        ibak = np1-i
        xp(ibak) = xp(ibak)-temp(ibak)*xp(ibak+1)
   10   yp(ibak) = yp(ibak)-temp(ibak)*yp(ibak+1)
      return
c
c too few points
c
   11 ierr = 1
      return
c
c coincident adjacent points
c
   12 ierr = 2
      return
      end

C
C	$Id: ngckop.f,v 1.4 2008-07-27 00:17:17 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      INTEGER FUNCTION NGCKOP(IWKID)
C
C  Function to check if the workstation, whose workstation ID is
C  given in IWKID, is currently open.  If it is open, then the
C  function returns a 1, otherwise the function returns a 0.
C
      CALL GQOPWK(0,IER,NOPN,LID)
      IF (NOPN .EQ. 0) THEN
        NGCKOP = 0
        RETURN
      ELSE
        DO 10 I=1,NOPN
          CALL GQOPWK(I,IER,NOPN,LID)
          IF (IWKID .EQ. LID) THEN
            NGCKOP = 1
            RETURN
          ENDIF
   10   CONTINUE
      ENDIF
C
      NGCKOP = 0
      RETURN
      END

      SUBROUTINE DGELSD( M, N, NRHS, A, LDA, B, LDB, S, RCOND, RANK,
     $                   WORK, LWORK, IWORK, INFO )
*
*  -- LAPACK driver routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     October 31, 1999
*
*     .. Scalar Arguments ..
      INTEGER            INFO, LDA, LDB, LWORK, M, N, NRHS, RANK
      DOUBLE PRECISION   RCOND
*     ..
*     .. Array Arguments ..
      INTEGER            IWORK( * )
      DOUBLE PRECISION   A( LDA, * ), B( LDB, * ), S( * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  DGELSD computes the minimum-norm solution to a real linear least
*  squares problem:
*      minimize 2-norm(| b - A*x |)
*  using the singular value decomposition (SVD) of A. A is an M-by-N
*  matrix which may be rank-deficient.
*
*  Several right hand side vectors b and solution vectors x can be
*  handled in a single call; they are stored as the columns of the
*  M-by-NRHS right hand side matrix B and the N-by-NRHS solution
*  matrix X.
*
*  The problem is solved in three steps:
*  (1) Reduce the coefficient matrix A to bidiagonal form with
*      Householder transformations, reducing the original problem
*      into a "bidiagonal least squares problem" (BLS)
*  (2) Solve the BLS using a divide and conquer approach.
*  (3) Apply back all the Householder tranformations to solve
*      the original least squares problem.
*
*  The effective rank of A is determined by treating as zero those
*  singular values which are less than RCOND times the largest singular
*  value.
*
*  The divide and conquer algorithm makes very mild assumptions about
*  floating point arithmetic. It will work on machines with a guard
*  digit in add/subtract, or on those binary machines without guard
*  digits which subtract like the Cray X-MP, Cray Y-MP, Cray C-90, or
*  Cray-2. It could conceivably fail on hexadecimal or decimal machines
*  without guard digits, but we know of none.
*
*  Arguments
*  =========
*
*  M       (input) INTEGER
*          The number of rows of A. M >= 0.
*
*  N       (input) INTEGER
*          The number of columns of A. N >= 0.
*
*  NRHS    (input) INTEGER
*          The number of right hand sides, i.e., the number of columns
*          of the matrices B and X. NRHS >= 0.
*
*  A       (input) DOUBLE PRECISION array, dimension (LDA,N)
*          On entry, the M-by-N matrix A.
*          On exit, A has been destroyed.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(1,M).
*
*  B       (input/output) DOUBLE PRECISION array, dimension (LDB,NRHS)
*          On entry, the M-by-NRHS right hand side matrix B.
*          On exit, B is overwritten by the N-by-NRHS solution
*          matrix X.  If m >= n and RANK = n, the residual
*          sum-of-squares for the solution in the i-th column is given
*          by the sum of squares of elements n+1:m in that column.
*
*  LDB     (input) INTEGER
*          The leading dimension of the array B. LDB >= max(1,max(M,N)).
*
*  S       (output) DOUBLE PRECISION array, dimension (min(M,N))
*          The singular values of A in decreasing order.
*          The condition number of A in the 2-norm = S(1)/S(min(m,n)).
*
*  RCOND   (input) DOUBLE PRECISION
*          RCOND is used to determine the effective rank of A.
*          Singular values S(i) <= RCOND*S(1) are treated as zero.
*          If RCOND < 0, machine precision is used instead.
*
*  RANK    (output) INTEGER
*          The effective rank of A, i.e., the number of singular values
*          which are greater than RCOND*S(1).
*
*  WORK    (workspace/output) DOUBLE PRECISION array, dimension (LWORK)
*          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*
*  LWORK   (input) INTEGER
*          The dimension of the array WORK. LWORK must be at least 1.
*          The exact minimum amount of workspace needed depends on M,
*          N and NRHS. As long as LWORK is at least
*              12*N + 2*N*SMLSIZ + 8*N*NLVL + N*NRHS + (SMLSIZ+1)**2,
*          if M is greater than or equal to N or
*              12*M + 2*M*SMLSIZ + 8*M*NLVL + M*NRHS + (SMLSIZ+1)**2,
*          if M is less than N, the code will execute correctly.
*          SMLSIZ is returned by ILAENV and is equal to the maximum
*          size of the subproblems at the bottom of the computation
*          tree (usually about 25), and
*             NLVL = MAX( 0, INT( LOG_2( MIN( M,N )/(SMLSIZ+1) ) ) + 1 )
*          For good performance, LWORK should generally be larger.
*
*          If LWORK = -1, then a workspace query is assumed; the routine
*          only calculates the optimal size of the WORK array, returns
*          this value as the first entry of the WORK array, and no error
*          message related to LWORK is issued by XERBLA.
*
*  IWORK   (workspace) INTEGER array, dimension (LIWORK)
*          LIWORK >= 3 * MINMN * NLVL + 11 * MINMN,
*          where MINMN = MIN( M,N ).
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value.
*          > 0:  the algorithm for computing the SVD failed to converge;
*                if INFO = i, i off-diagonal elements of an intermediate
*                bidiagonal form did not converge to zero.
*
*  Further Details
*  ===============
*
*  Based on contributions by
*     Ming Gu and Ren-Cang Li, Computer Science Division, University of
*       California at Berkeley, USA
*     Osni Marques, LBNL/NERSC, USA
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO, ONE, TWO
      PARAMETER          ( ZERO = 0.0D0, ONE = 1.0D0, TWO = 2.0D0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            LQUERY
      INTEGER            IASCL, IBSCL, IE, IL, ITAU, ITAUP, ITAUQ,
     $                   LDWORK, MAXMN, MAXWRK, MINMN, MINWRK, MM,
     $                   MNTHR, NLVL, NWORK, SMLSIZ, WLALSD
      DOUBLE PRECISION   ANRM, BIGNUM, BNRM, EPS, SFMIN, SMLNUM
*     ..
*     .. External Subroutines ..
      EXTERNAL           DGEBRD, DGELQF, DGEQRF, DLABAD, DLACPY, DLALSD,
     $                   DLASCL, DLASET, DORMBR, DORMLQ, DORMQR, XERBLA
*     ..
*     .. External Functions ..
      INTEGER            ILAENV
      DOUBLE PRECISION   DLAMCH, DLANGE
      EXTERNAL           ILAENV, DLAMCH, DLANGE
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          DBLE, INT, LOG, MAX, MIN
*     ..
*     .. Executable Statements ..
*
*     Test the input arguments.
*
      INFO = 0
      MINMN = MIN( M, N )
      MAXMN = MAX( M, N )
      MNTHR = ILAENV( 6, 'DGELSD', ' ', M, N, NRHS, -1 )
      LQUERY = ( LWORK.EQ.-1 )
      IF( M.LT.0 ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( NRHS.LT.0 ) THEN
         INFO = -3
      ELSE IF( LDA.LT.MAX( 1, M ) ) THEN
         INFO = -5
      ELSE IF( LDB.LT.MAX( 1, MAXMN ) ) THEN
         INFO = -7
      END IF
*
      SMLSIZ = ILAENV( 9, 'DGELSD', ' ', 0, 0, 0, 0 )
*
*     Compute workspace.
*     (Note: Comments in the code beginning "Workspace:" describe the
*     minimal amount of workspace needed at that point in the code,
*     as well as the preferred amount for good performance.
*     NB refers to the optimal block size for the immediately
*     following subroutine, as returned by ILAENV.)
*
      MINWRK = 1
      MINMN = MAX( 1, MINMN )
      NLVL = MAX( INT( LOG( DBLE( MINMN ) / DBLE( SMLSIZ+1 ) ) /
     $       LOG( TWO ) ) + 1, 0 )
*
      IF( INFO.EQ.0 ) THEN
         MAXWRK = 0
         MM = M
         IF( M.GE.N .AND. M.GE.MNTHR ) THEN
*
*           Path 1a - overdetermined, with many more rows than columns.
*
            MM = N
            MAXWRK = MAX( MAXWRK, N+N*ILAENV( 1, 'DGEQRF', ' ', M, N,
     $               -1, -1 ) )
            MAXWRK = MAX( MAXWRK, N+NRHS*
     $               ILAENV( 1, 'DORMQR', 'LT', M, NRHS, N, -1 ) )
         END IF
         IF( M.GE.N ) THEN
*
*           Path 1 - overdetermined or exactly determined.
*
            MAXWRK = MAX( MAXWRK, 3*N+( MM+N )*
     $               ILAENV( 1, 'DGEBRD', ' ', MM, N, -1, -1 ) )
            MAXWRK = MAX( MAXWRK, 3*N+NRHS*
     $               ILAENV( 1, 'DORMBR', 'QLT', MM, NRHS, N, -1 ) )
            MAXWRK = MAX( MAXWRK, 3*N+( N-1 )*
     $               ILAENV( 1, 'DORMBR', 'PLN', N, NRHS, N, -1 ) )
            WLALSD = 9*N+2*N*SMLSIZ+8*N*NLVL+N*NRHS+(SMLSIZ+1)**2
            MAXWRK = MAX( MAXWRK, 3*N+WLALSD )
            MINWRK = MAX( 3*N+MM, 3*N+NRHS, 3*N+WLALSD )
         END IF
         IF( N.GT.M ) THEN
            WLALSD = 9*M+2*M*SMLSIZ+8*M*NLVL+M*NRHS+(SMLSIZ+1)**2
            IF( N.GE.MNTHR ) THEN
*
*              Path 2a - underdetermined, with many more columns
*              than rows.
*
               MAXWRK = M + M*ILAENV( 1, 'DGELQF', ' ', M, N, -1, -1 )
               MAXWRK = MAX( MAXWRK, M*M+4*M+2*M*
     $                  ILAENV( 1, 'DGEBRD', ' ', M, M, -1, -1 ) )
               MAXWRK = MAX( MAXWRK, M*M+4*M+NRHS*
     $                  ILAENV( 1, 'DORMBR', 'QLT', M, NRHS, M, -1 ) )
               MAXWRK = MAX( MAXWRK, M*M+4*M+( M-1 )*
     $                  ILAENV( 1, 'DORMBR', 'PLN', M, NRHS, M, -1 ) )
               IF( NRHS.GT.1 ) THEN
                  MAXWRK = MAX( MAXWRK, M*M+M+M*NRHS )
               ELSE
                  MAXWRK = MAX( MAXWRK, M*M+2*M )
               END IF
               MAXWRK = MAX( MAXWRK, M+NRHS*
     $                  ILAENV( 1, 'DORMLQ', 'LT', N, NRHS, M, -1 ) )
               MAXWRK = MAX( MAXWRK, M*M+4*M+WLALSD )
            ELSE
*
*              Path 2 - remaining underdetermined cases.
*
               MAXWRK = 3*M + ( N+M )*ILAENV( 1, 'DGEBRD', ' ', M, N,
     $                  -1, -1 )
               MAXWRK = MAX( MAXWRK, 3*M+NRHS*
     $                  ILAENV( 1, 'DORMBR', 'QLT', M, NRHS, N, -1 ) )
               MAXWRK = MAX( MAXWRK, 3*M+M*
     $                  ILAENV( 1, 'DORMBR', 'PLN', N, NRHS, M, -1 ) )
               MAXWRK = MAX( MAXWRK, 3*M+WLALSD )
            END IF
            MINWRK = MAX( 3*M+NRHS, 3*M+M, 3*M+WLALSD )
         END IF
         MINWRK = MIN( MINWRK, MAXWRK )
         WORK( 1 ) = MAXWRK
         IF( LWORK.LT.MINWRK .AND. .NOT.LQUERY ) THEN
            INFO = -12
         END IF
      END IF
*
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DGELSD', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         GO TO 10
      END IF
*
*     Quick return if possible.
*
      IF( M.EQ.0 .OR. N.EQ.0 ) THEN
         RANK = 0
         RETURN
      END IF
*
*     Get machine parameters.
*
      EPS = DLAMCH( 'P' )
      SFMIN = DLAMCH( 'S' )
      SMLNUM = SFMIN / EPS
      BIGNUM = ONE / SMLNUM
      CALL DLABAD( SMLNUM, BIGNUM )
*
*     Scale A if max entry outside range [SMLNUM,BIGNUM].
*
      ANRM = DLANGE( 'M', M, N, A, LDA, WORK )
      IASCL = 0
      IF( ANRM.GT.ZERO .AND. ANRM.LT.SMLNUM ) THEN
*
*        Scale matrix norm up to SMLNUM.
*
         CALL DLASCL( 'G', 0, 0, ANRM, SMLNUM, M, N, A, LDA, INFO )
         IASCL = 1
      ELSE IF( ANRM.GT.BIGNUM ) THEN
*
*        Scale matrix norm down to BIGNUM.
*
         CALL DLASCL( 'G', 0, 0, ANRM, BIGNUM, M, N, A, LDA, INFO )
         IASCL = 2
      ELSE IF( ANRM.EQ.ZERO ) THEN
*
*        Matrix all zero. Return zero solution.
*
         CALL DLASET( 'F', MAX( M, N ), NRHS, ZERO, ZERO, B, LDB )
         CALL DLASET( 'F', MINMN, 1, ZERO, ZERO, S, 1 )
         RANK = 0
         GO TO 10
      END IF
*
*     Scale B if max entry outside range [SMLNUM,BIGNUM].
*
      BNRM = DLANGE( 'M', M, NRHS, B, LDB, WORK )
      IBSCL = 0
      IF( BNRM.GT.ZERO .AND. BNRM.LT.SMLNUM ) THEN
*
*        Scale matrix norm up to SMLNUM.
*
         CALL DLASCL( 'G', 0, 0, BNRM, SMLNUM, M, NRHS, B, LDB, INFO )
         IBSCL = 1
      ELSE IF( BNRM.GT.BIGNUM ) THEN
*
*        Scale matrix norm down to BIGNUM.
*
         CALL DLASCL( 'G', 0, 0, BNRM, BIGNUM, M, NRHS, B, LDB, INFO )
         IBSCL = 2
      END IF
*
*     If M < N make sure certain entries of B are zero.
*
      IF( M.LT.N )
     $   CALL DLASET( 'F', N-M, NRHS, ZERO, ZERO, B( M+1, 1 ), LDB )
*
*     Overdetermined case.
*
      IF( M.GE.N ) THEN
*
*        Path 1 - overdetermined or exactly determined.
*
         MM = M
         IF( M.GE.MNTHR ) THEN
*
*           Path 1a - overdetermined, with many more rows than columns.
*
            MM = N
            ITAU = 1
            NWORK = ITAU + N
*
*           Compute A=Q*R.
*           (Workspace: need 2*N, prefer N+N*NB)
*
            CALL DGEQRF( M, N, A, LDA, WORK( ITAU ), WORK( NWORK ),
     $                   LWORK-NWORK+1, INFO )
*
*           Multiply B by transpose(Q).
*           (Workspace: need N+NRHS, prefer N+NRHS*NB)
*
            CALL DORMQR( 'L', 'T', M, NRHS, N, A, LDA, WORK( ITAU ), B,
     $                   LDB, WORK( NWORK ), LWORK-NWORK+1, INFO )
*
*           Zero out below R.
*
            IF( N.GT.1 ) THEN
               CALL DLASET( 'L', N-1, N-1, ZERO, ZERO, A( 2, 1 ), LDA )
            END IF
         END IF
*
         IE = 1
         ITAUQ = IE + N
         ITAUP = ITAUQ + N
         NWORK = ITAUP + N
*
*        Bidiagonalize R in A.
*        (Workspace: need 3*N+MM, prefer 3*N+(MM+N)*NB)
*
         CALL DGEBRD( MM, N, A, LDA, S, WORK( IE ), WORK( ITAUQ ),
     $                WORK( ITAUP ), WORK( NWORK ), LWORK-NWORK+1,
     $                INFO )
*
*        Multiply B by transpose of left bidiagonalizing vectors of R.
*        (Workspace: need 3*N+NRHS, prefer 3*N+NRHS*NB)
*
         CALL DORMBR( 'Q', 'L', 'T', MM, NRHS, N, A, LDA, WORK( ITAUQ ),
     $                B, LDB, WORK( NWORK ), LWORK-NWORK+1, INFO )
*
*        Solve the bidiagonal least squares problem.
*
         CALL DLALSD( 'U', SMLSIZ, N, NRHS, S, WORK( IE ), B, LDB,
     $                RCOND, RANK, WORK( NWORK ), IWORK, INFO )
         IF( INFO.NE.0 ) THEN
            GO TO 10
         END IF
*
*        Multiply B by right bidiagonalizing vectors of R.
*
         CALL DORMBR( 'P', 'L', 'N', N, NRHS, N, A, LDA, WORK( ITAUP ),
     $                B, LDB, WORK( NWORK ), LWORK-NWORK+1, INFO )
*
      ELSE IF( N.GE.MNTHR .AND. LWORK.GE.4*M+M*M+
     $         MAX( M, 2*M-4, NRHS, N-3*M ) ) THEN
*
*        Path 2a - underdetermined, with many more columns than rows
*        and sufficient workspace for an efficient algorithm.
*
         LDWORK = M
         IF( LWORK.GE.MAX( 4*M+M*LDA+MAX( M, 2*M-4, NRHS, N-3*M ),
     $       M*LDA+M+M*NRHS ) )LDWORK = LDA
         ITAU = 1
         NWORK = M + 1
*
*        Compute A=L*Q.
*        (Workspace: need 2*M, prefer M+M*NB)
*
         CALL DGELQF( M, N, A, LDA, WORK( ITAU ), WORK( NWORK ),
     $                LWORK-NWORK+1, INFO )
         IL = NWORK
*
*        Copy L to WORK(IL), zeroing out above its diagonal.
*
         CALL DLACPY( 'L', M, M, A, LDA, WORK( IL ), LDWORK )
         CALL DLASET( 'U', M-1, M-1, ZERO, ZERO, WORK( IL+LDWORK ),
     $                LDWORK )
         IE = IL + LDWORK*M
         ITAUQ = IE + M
         ITAUP = ITAUQ + M
         NWORK = ITAUP + M
*
*        Bidiagonalize L in WORK(IL).
*        (Workspace: need M*M+5*M, prefer M*M+4*M+2*M*NB)
*
         CALL DGEBRD( M, M, WORK( IL ), LDWORK, S, WORK( IE ),
     $                WORK( ITAUQ ), WORK( ITAUP ), WORK( NWORK ),
     $                LWORK-NWORK+1, INFO )
*
*        Multiply B by transpose of left bidiagonalizing vectors of L.
*        (Workspace: need M*M+4*M+NRHS, prefer M*M+4*M+NRHS*NB)
*
         CALL DORMBR( 'Q', 'L', 'T', M, NRHS, M, WORK( IL ), LDWORK,
     $                WORK( ITAUQ ), B, LDB, WORK( NWORK ),
     $                LWORK-NWORK+1, INFO )
*
*        Solve the bidiagonal least squares problem.
*
         CALL DLALSD( 'U', SMLSIZ, M, NRHS, S, WORK( IE ), B, LDB,
     $                RCOND, RANK, WORK( NWORK ), IWORK, INFO )
         IF( INFO.NE.0 ) THEN
            GO TO 10
         END IF
*
*        Multiply B by right bidiagonalizing vectors of L.
*
         CALL DORMBR( 'P', 'L', 'N', M, NRHS, M, WORK( IL ), LDWORK,
     $                WORK( ITAUP ), B, LDB, WORK( NWORK ),
     $                LWORK-NWORK+1, INFO )
*
*        Zero out below first M rows of B.
*
         CALL DLASET( 'F', N-M, NRHS, ZERO, ZERO, B( M+1, 1 ), LDB )
         NWORK = ITAU + M
*
*        Multiply transpose(Q) by B.
*        (Workspace: need M+NRHS, prefer M+NRHS*NB)
*
         CALL DORMLQ( 'L', 'T', N, NRHS, M, A, LDA, WORK( ITAU ), B,
     $                LDB, WORK( NWORK ), LWORK-NWORK+1, INFO )
*
      ELSE
*
*        Path 2 - remaining underdetermined cases.
*
         IE = 1
         ITAUQ = IE + M
         ITAUP = ITAUQ + M
         NWORK = ITAUP + M
*
*        Bidiagonalize A.
*        (Workspace: need 3*M+N, prefer 3*M+(M+N)*NB)
*
         CALL DGEBRD( M, N, A, LDA, S, WORK( IE ), WORK( ITAUQ ),
     $                WORK( ITAUP ), WORK( NWORK ), LWORK-NWORK+1,
     $                INFO )
*
*        Multiply B by transpose of left bidiagonalizing vectors.
*        (Workspace: need 3*M+NRHS, prefer 3*M+NRHS*NB)
*
         CALL DORMBR( 'Q', 'L', 'T', M, NRHS, N, A, LDA, WORK( ITAUQ ),
     $                B, LDB, WORK( NWORK ), LWORK-NWORK+1, INFO )
*
*        Solve the bidiagonal least squares problem.
*
         CALL DLALSD( 'L', SMLSIZ, M, NRHS, S, WORK( IE ), B, LDB,
     $                RCOND, RANK, WORK( NWORK ), IWORK, INFO )
         IF( INFO.NE.0 ) THEN
            GO TO 10
         END IF
*
*        Multiply B by right bidiagonalizing vectors of A.
*
         CALL DORMBR( 'P', 'L', 'N', N, NRHS, M, A, LDA, WORK( ITAUP ),
     $                B, LDB, WORK( NWORK ), LWORK-NWORK+1, INFO )
*
      END IF
*
*     Undo scaling.
*
      IF( IASCL.EQ.1 ) THEN
         CALL DLASCL( 'G', 0, 0, ANRM, SMLNUM, N, NRHS, B, LDB, INFO )
         CALL DLASCL( 'G', 0, 0, SMLNUM, ANRM, MINMN, 1, S, MINMN,
     $                INFO )
      ELSE IF( IASCL.EQ.2 ) THEN
         CALL DLASCL( 'G', 0, 0, ANRM, BIGNUM, N, NRHS, B, LDB, INFO )
         CALL DLASCL( 'G', 0, 0, BIGNUM, ANRM, MINMN, 1, S, MINMN,
     $                INFO )
      END IF
      IF( IBSCL.EQ.1 ) THEN
         CALL DLASCL( 'G', 0, 0, SMLNUM, BNRM, N, NRHS, B, LDB, INFO )
      ELSE IF( IBSCL.EQ.2 ) THEN
         CALL DLASCL( 'G', 0, 0, BIGNUM, BNRM, N, NRHS, B, LDB, INFO )
      END IF
*
   10 CONTINUE
      WORK( 1 ) = MAXWRK
      RETURN
*
*     End of DGELSD
*
      END

C
C      $Id: vc02f.f,v 1.5 2010-03-15 22:49:25 haley Exp $
C
C***********************************************************************
C                                                                      *
C                Copyright (C)  1996                                   *
C        University Corporation for Atmospheric Research               *
C                All Rights Reserved                                   *
C                                                                      *
C***********************************************************************
C
C   File:       vc02f.f
C 
C   Author:     David Brown
C               National Center for Atmospheric Research
C               PO 3000, Boulder, Colorado
C 
C   Date:       Fri May 10 8:30:55 MDT 1996
C 
C    Description:   Given a simple mathematically generated data set,
C                   demonstrates line-drawn vector arrows and the use
C                   of some basic VectorPlot resources
C

      external NhlFAppClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFCairoWindowWorkstationClass
      external NhlFVectorPlotClass
      external NhlFVectorFieldClass
      parameter(M=30,N=25)
      parameter(PI=3.14159)

      character*7  wks_type
      integer appid,wid,vcid,vfid
      integer rlist,grlist
      integer len_dims(2)
      real reflen
      real U(M,N),V(M,N)
      real igrid, jgrid
      integer i,j

      wks_type = "x11"
C
C Generate vector data arrays
C
      igrid = 2.0 * PI / real(M)
      jgrid = 2.0 * PI / real(N)
      do 20 j = 1,N
         do 10 i=1,M
            U(i,j) = 10.0 * cos(jgrid * real(j-1))
            V(i,j) = 10.0 * cos(igrid * real(i-1))
 10      continue
 20   continue
C
C Initialize the high level utility library
C
      call NhlFInitialize
C
C Create an application context. Set the app dir to the current
C directory so the application looks for a resource file in the working
C directory. 
C
      call NhlFRLCreate(rlist,'SETRL')
      call NhlFRLCreate(grlist,'GETRL')
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'vc02',NhlFappClass,0,rlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkMetaName','./vc02f.ncgm',ierr)
         call NhlFCreate(wid,'vc02Work',NhlFNcgmWorkstationClass,
     1     0,rlist,ierr)
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPause','True',ierr)
         call NhlFCreate(wid,'vc02Work',
     +        NhlFCairoWindowWorkstationClass,
     1        0,rlist,ierr) 
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PostScript workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPSFileName','./vc02f.ps',ierr)
         call NhlFCreate(wid,'vc02Work',NhlFPSWorkstationClass,
     1        0,rlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPDFFileName','./vc02f.pdf',ierr)
         call NhlFCreate(wid,'vc02Work',NhlFPDFWorkstationClass,
     1        0,rlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF object.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetstring(rlist,'wkFileName','./vc02f',ierr)
         call NhlFCreate(wid,'vc02Work',
     1        NhlFCairoPSPDFWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG object.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetstring(rlist,'wkFileName','./vc02f',ierr)
         call NhlFCreate(wid,'vc02Work',
     1        NhlFCairoImageWorkstationClass,0,rlist,ierr)
      endif
C
C Create a VectorField data object using the data set defined above.
C By default the array bounds will define the data boundaries
C (zero-based, as in C language conventions)
C
      len_dims(1) = M
      len_dims(2) = N
      call NhlFRLClear(rlist)
      call NhlFRLSetMDFloatArray(rlist,'vfUDataArray',U,2,len_dims,ierr)
      call NhlFRLSetMDFloatArray(rlist,'vfVDataArray',V,2,len_dims,ierr)
      call NhlFCreate(vfid,'vectorfield',NhlFVectorFieldClass,appid,
     1     rlist,ierr)
C
C Create a VectorPlot object, supplying the VectorField object as data
C Setting vcMonoLineArrowColor False causes VectorPlot to color the
C vector arrows individually, based, by default, on each vector's
C magnitude.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'tiMainString',
     1     'Line-Drawn Vectors (colored by magnitude)',ierr)

      call NhlFRLSetString(rlist,'vcMonoLineArrowColor','false',ierr)

      call NhlFRLSetInteger(rlist,'vcVectorFieldData',vfid,ierr)
      call NhlFCreate(vcid,'vectorplot',NhlFVectorPlotClass,wid,
     1     rlist,ierr)
      call NhlFDraw(vcid,ierr)
      call NhlFFrame(wid,ierr)
C
C All the vector arrows are scaled in length based on their magnitude
C relative to a reference magnitude (the maximum magnitude by default)
C Setting the arrow length of the reference magnitude, therefore,
C adjusts the length of all the vector arrows in the plot. In
C addition, you can specify a length for the smallest vector in the
C plot, as a fraction of the length of the reference vector. In this
C case, the remaining arrows are scaled based on both these lengths.
C Since the initial reference length is established dynamically, the 
C simplest way to adjust the overall arrow length is to 
C retrieve the initially set value of 'vcRefLengthF' and then multiply 
C by the desired factor.
C
      call NhlFRLClear(grlist)
      call NhlFRLGetFloat(grlist,'vcRefLengthF',reflen,ierr)
      call NhlFGetValues(vcid,grlist,ierr)

      reflen = reflen * 1.5
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'tiMainString',
     1     'Adjusting the Reference and Minimum Length',ierr)
      call NhlFRLSetFloat(rlist,'vcRefLengthF',reflen,ierr)
      call NhlFRLSetFloat(rlist,'vcMinFracLengthF',0.3,ierr)
      call NhlFSetValues(vcid,rlist,ierr)

      call NhlFDraw(vcid,ierr)
      call NhlFFrame(wid,ierr)
C
C Note that setting the reference magnitude also affects the length
C of the arrows. In this case it is an inverse relationship.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'tiMainString',
     1     'Adjusting the Reference Magnitude',ierr)
      call NhlFRLSetFloat(rlist,'vcRefMagnitudeF',20.0,ierr)
      call NhlFSetValues(vcid,rlist,ierr)

      call NhlFDraw(vcid,ierr)
      call NhlFFrame(wid,ierr)
C
C There are two vector annotations known as the reference vector 
C annotation and the minimum vector annotation. Their resources are
C prefixed respectively by "vcRefAnno" and "vcMinAnno". Only the
C reference vector annotation is displayed by default. Here, the
C minimum vector annotation is turned on, and some resources of each
C annotation are modified.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'tiMainString',
     1     'Modifying the Vector Annotations',ierr)
      call NhlFRLSetFloat(rlist,'vcRefAnnoFontHeightF',0.015,ierr)
      call NhlFRLSetString(rlist,'vcRefAnnoString1',
     1     '$VMG$ meters/sec',ierr)
      call NhlFRLSetString(rlist,'vcRefAnnoString2On','False',ierr)
      call NhlFRLSetString(rlist,'vcMinAnnoOn','True',ierr)
      call NhlFRLSetString(rlist,'vcMinAnnoString1',
     1     '$VMG$ meters/sec',ierr)
      call NhlFRLSetString(rlist,'vcMinAnnoString2On','False',ierr)
      call NhlFSetValues(vcid,rlist,ierr)

      call NhlFDraw(vcid,ierr)
      call NhlFFrame(wid,ierr)
C
C Line-drawn arrowheads are sized proportionally to the arrow length 
C unless the resulting size would be outside the limits defined by 
C the arrowhead minimum and maximum size resources. Setting the 
C minimum and maximum sizes to the same value causes all the
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'tiMainString',
     1     'Uniformly-sized Arrow Heads',ierr)
      call NhlFRLSetFloat(rlist,'vcLineArrowHeadMinSizeF',0.01,ierr)
      call NhlFRLSetFloat(rlist,'vcLineArrowHeadMaxSizeF',0.01,ierr)
      call NhlFSetValues(vcid,rlist,ierr)

      call NhlFDraw(vcid,ierr)
      call NhlFFrame(wid,ierr)
C
C Destroy the objects created, close the HLU library and exit.
C
      call NhlFDestroy(appid,ierr)
      call NhlFClose
      stop
      end

C
C	$Id: gninst.f,v 1.4 2008-07-27 00:20:58 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GNINST(IOS,STATUS)
C
C  Get the next instruction in the segment.
C
      include 'trpars.h'
      include 'trinst.h'
      include 'trbufr.h'
C
      INTEGER IOS,STATUS
      INTEGER MODPOS, CONVAL
C
      STATUS = 0
C       
C  Check if on a new instruction boundary.
C
      MODPOS = MOD(METBIT,MINSBD)
      IF (0 .NE. MODPOS) METBIT = METBIT + MODPOS
C
C  Check if there is room left for opcode extract in the buffer.
C
      IF (MRECLN .LT. (METBIT+MOPCLL+MOPIDL)) THEN
C
C  Read in a new record.
C
        CALL GSEGRD (IOS,STATUS)
        IF (STATUS .NE. 0) RETURN
      END IF
C
C  Extract the opcode class.
C
      CALL GBYTES(MBUFER,OPCL,METBIT,MOPCLL,0,1)
      METBIT = METBIT + MOPCLL
C
C  Test for valid element class.
C
      IF (OPCL.LT.0 .OR. OPCL.GT.7) THEN
        STATUS = 7
        RETURN
      END IF
C
C  Read in element code.
C
      CALL GBYTES(MBUFER,OPID,METBIT,MOPIDL,0,1)
      METBIT = METBIT + MOPIDL
C
C  Test for valid element code.
C
      IF (OPID.LT.0 .OR. OPID.GT.127) THEN
        STATUS = 7
        RETURN
      END IF
C
C  Valid opcode, get the short count field.
C
      CALL GBYTES(MBUFER,LEN,METBIT,MSCLEN,0,1)
      METBIT = METBIT + MSCLEN
C
C  Test for the long count requirement.
C
      IF (LEN .LT. MLGFLG) THEN
C       
C  Short count valid, set pointers.
C
        CNTINU   = .FALSE.
        MOPRST = METBIT
        METBIT = METBIT + (LEN*BYTSIZ)
C
C  Return the short instruction format.
C
        RETURN
      END IF
C
C  Parse the long instruction format.
C
C  First test if there is enough room in the buffer.
C
      IF (MRECLN .LT. (METBIT+MCOLEN+MLOLEN)) THEN
C
C  Read in a new record.
C
        CALL GSEGRD (IOS,STATUS)
        IF (STATUS .NE. 0) RETURN
      END IF
C
C  Get the continue flag value.
C
      CALL GBYTES(MBUFER,CONVAL,METBIT,MCOLEN,0,1) 
      METBIT = METBIT + MCOLEN
      IF (CONVAL .EQ. CONFLG) THEN
        CNTINU = .TRUE.
      ELSE
        CNTINU = .FALSE.
      END IF
C
C  Get the long operand 8 bit byte count field.
C
      CALL GBYTES(MBUFER,LEN,METBIT,MLOLEN,0,1)
      METBIT = METBIT + MLOLEN
C
      MOPRST = METBIT
      METBIT = METBIT + (LEN*BYTSIZ)
C
C  Normal exit.
C
      RETURN
      END

C
C $Id: mdutfd.f,v 1.3 2008-07-27 00:17:09 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MDUTFD (RLAT,RLON,UVAL,VVAL)
C
C Given RLAT and RLON, in degrees, return UVAL and VVAL, in meters.
C
        DOUBLE PRECISION RLAT,RLON,UVAL,VVAL
C
C Declare common blocks required to communicate with USGS code.
C
        COMMON /ERRMZ0/ IERR
        SAVE   /ERRMZ0/
C
        COMMON /USGSC1/  UTPA(15),UUMN,UUMX,UVMN,UVMX,IPRF
        DOUBLE PRECISION UTPA,UUMN,UUMX,UVMN,UVMX
        INTEGER IPRF
        SAVE   /USGSC1/
C
C Declare required double-precision variables.
C
        DOUBLE PRECISION CRDI(2),CRDO(2),CRDT(2),DTST
C
C Declare a required double-precision function.
C
        DOUBLE PRECISION MDGDDP
C
C Define a couple of conversion constants.
C
        DOUBLE PRECISION DTOR,RTOD
C
        DATA DTOR / .017453292519943D0 /
        DATA RTOD / 57.2957795130823D0 /
C
C Do a call forcing a BLOCKDATA to be loaded from a binary library.
C
        CALL GTPZBD
C
C If the USGS package is initialized, zero the error flag; otherwise,
C take an error exit.
C
        IF (IPRF.GE.3.AND.IPRF.LE.23) THEN
          IERR=0
        ELSE
          IERR=1
          UVAL=1.D12
          VVAL=1.D12
          RETURN
        END IF
C
C Generate coordinates for projection routine.
C
        CRDI(1)=DTOR*RLON
        CRDI(2)=DTOR*RLAT
C
        GO TO (        103,104,105,106,107,108,109,110,
     +         111,112,113,114,115,116,117,118,119,120,
     +         121,122,123                             ) , IPRF-2
C
  103   CALL PJ03DP (CRDI,CRDO,0)
        GO TO 201
C
  104   CALL PJ04DP (CRDI,CRDO,0)
        GO TO 201
C
  105   CALL PJ05DP (CRDI,CRDO,0)
        GO TO 201
C
  106   CALL PJ06DP (CRDI,CRDO,0)
        GO TO 201
C
  107   DTST=ABS(RLON-UTPA(5))
C
        IF (DTST.LE.90.D0.OR.ABS(DTST-360.D0).LE.90.D0) THEN
          CALL PJ07DP (CRDI,CRDO,0)
        ELSE
          IERR=1
        END IF
C
        GO TO 201
C
  108   CALL PJ08DP (CRDI,CRDO,0)
        GO TO 201
C
  109   CALL PJ09DP (CRDI,CRDO,0)
        GO TO 201
C
  110   CALL PJ10DP (CRDI,CRDO,0)
        GO TO 201
C
  111   CALL PJ11DP (CRDI,CRDO,0)
        GO TO 201
C
  112   CALL PJ12DP (CRDI,CRDO,0)
        GO TO 201
C
  113   CALL PJ13DP (CRDI,CRDO,0)
        GO TO 201
C
  114   CALL PJ14DP (CRDI,CRDO,0)
        GO TO 201
C
  115   CALL PJ15DP (CRDI,CRDO,0)
        GO TO 201
C
  116   CALL PJ16DP (CRDI,CRDO,0)
        GO TO 201
C
  117   CALL PJ17DP (CRDI,CRDO,0)
        GO TO 201
C
  118   CALL PJ18DP (CRDI,CRDO,0)
        GO TO 201
C
  119   CALL PJ19DP (CRDI,CRDO,0)
        GO TO 201
C
  120   CALL PJ20DP (CRDI,CRDO,0)
        GO TO 201
C
  121   CALL PJ21DP (CRDI,CRDO,0)
        GO TO 201
C
  122   CALL PJ22DP (CRDI,CRDO,0)
        CALL PJ22DP (CRDO,CRDT,1)
C
        IF (IERR.EQ.0) THEN
          IF (MDGDDP(RTOD*CRDI(2),RTOD*CRDI(1),
     +               RTOD*CRDT(2),RTOD*CRDT(1)).GT.1.D-2) THEN
            IERR=1
          END IF
        END IF
C
        GO TO 201
C
  123   CALL PJ23DP (CRDI,CRDO,0)
        GO TO 201
C
  201   IF (IERR.EQ.0) THEN
          UVAL=CRDO(1)
          VVAL=CRDO(2)
        ELSE
          UVAL=1.D12
          VVAL=1.D12
        END IF
C
        RETURN
C
      END

c***********************************************************************
c Find the Gauss-Lobatto collocation points xGL(i) and the
c corresponding weights.
c***********************************************************************
C NCL:  gau = gausLobat (npts)
C NCLFORTSTART
      subroutine   GausLobat(xGL,weight,npts)
      implicit     none
c                             INPUT
      integer      npts
c                             OUTPUT [return like NCL 'gaus']
      double precision weight(npts), xGL(npts)
C NCLEND
      integer      n
c                            return G-L wgts and 'lat'
      call   GaussLobatto(xGL,weight,npts)
c                            switch sign: make -1 to +1 [symmetric]
      if (xGL(1).gt.xGL(2)) then
          do n=1,npts
             xGL(n) = -xGL(n)
          end do
      end if
c                            make range [-90,90]
      do n=1,npts
         xGL(n) = xGL(n)*90.d0
      end do

      return
      end
c *********************************************************************
c ....Find the Gauss-Lobatto weights associated with the GL latitudes
c ....Requested by Erik Kluzek
c *********************************************************************
C NCL:  gauLat = gausLobatWgt (xGLAT)
C NCLFORTSTART
      subroutine findglw (xGLAT, weight, npts)
      implicit   none
c                             INPUT  [xGLAT are [+90 to -90]
      integer    npts
      double precision     xGLAT(npts) 
c                             OUTPUT [1D array: double]
      double precision     weight(npts)
C NCLEND
      integer    N, m
      double precision     dt, func0, func1, func2, temp

      N  = npts-1
      dt = 2.d0/(N*(N+1.d0))

      do m = 1,N+1
        temp = xGLAT(m)/90.d0
        call jacobf(func0,func1,func2,temp,N)
        weight(m) = dt / (func0**2)
c c c   write(6,"('FINDGLW:',i4,4f12.5)") m,func0,xGLAT(m),weight(m)
      enddo

      return
      end
c *************** COMPUTATIONAL ROUTINES **********************
      subroutine   GaussLobatto(xGL,weight,npts)
      implicit     none
      integer      npts
      double precision       weight(npts), xGL(npts)

      integer      N, nh, nr, m
      double precision       pi,dt, xh,xl, func0,func1,func2
      data         pi/3.1415926535897932384d0/

      N = npts-1

c.....Find 1st half of the roots by direct solution

      nh = N/2
      dt = pi/(2.d0*N+1.d0)

      do m = 1,nh
        xh = cos( (2.d0*m-1.d0)*dt)
        xl = cos( 2.d0*m*dt)
        call NewtonRaphson1(xl,xh,weight(m),N)
      enddo

      nr = N-2*nh

      if (nr.ne.0) then
c.......N is odd
        weight(nh+1) = 0.d0
      endif

c.....Find 2nd half of the roots by symmetry

      do m = nh+nr+1,N
        weight(m) =-weight(N-m+1)
      enddo

c.....Find 1st half of the roots by direct solution

      xGL(1) = 1.d0
      nh = (N-1)/2

      do m = 1,nh
        xh = weight(m)
        xl = weight(m+1)
        call NewtonRaphson2(xl,xh,xGL(m+1),N)
      enddo

      nr = N-1-2*nh

      if (nr.ne.0) then
c.......N is odd
        xGL(nh+2) = 0.d0
      endif

c.....Find 2nd half of the roots by symmetry

      do m = nh+nr+2,N+1
        xGL(m) =-xGL(N+2-m)
      enddo

c.....Find the Gauss-Lobatto weights

      N  = npts-1
      dt = 2.d0/(N*(N+1.d0))

      do m = 1,N+1
        call jacobf(func0,func1,func2,xGL(m),N)
        weight(m) = dt / (func0**2)
      enddo

      return
      end

c**********************************************************************
c Combination of Newton-Raphson iterations and Bisection method.
c xl and xh are the initial bracketing of the root xm.
c**********************************************************************

      subroutine   NewtonRaphson1(xl,xh,xm,N)
      implicit     none

      integer      k,ITERMAX,N
      double precision  xl,xh,xm,xn, func0,func1,func2, error, TOLERANCE
      parameter   (ITERMAX=100, TOLERANCE=1.d-15)

c.....Find function values at bracketing points

      call jacobf(xm,func1,func2,xl,N)
      call jacobf(xn,func1,func2,xh,N)

      if (xm*xn.gt.0.d0) then
         write(6,*)' root is not bracketed'
         return
      endif

c.....Rearrange xl and xh so that f(xl)< 0.d0 < f(xh)

      if (xm.gt.0.d0) then
         xm = xl
         xl = xh
         xh = xm
      endif

c.....Initial width of bracketed interval

      error = abs(xh-xl)

c.....Initialize guess for root

      xm = 0.5d0*(xl+xh)

      k = 0

      do while (error.gt.TOLERANCE .and. k.lt.ITERMAX)
         k = k+1
         call jacobf(func0,func1,func2,xm,N)

c........Adjust the bracketing of the root
         if (func0.gt.0.d0) then
            xh = xm
         else
            xl = xm
         endif

c........Tentative newton-Raphson step

         xn = xm - func0/func1

         if ((xn-xl)*(xn-xh).gt.0.d0) then
c...........Bisection step
            xm = 0.5d0* (xh+xl)
            error = abs(xh-xl)
         else
c...........Newton-Raphson step successfull
            error = abs(xn-xm)
            xm = xn
         endif
      enddo

c.....Check if solution converged

      if (error.gt.TOLERANCE) then
         write(6,*) 'solution did not converge'
      endif

      return
      end

c**********************************************************************
c Combination of Newton-Raphson iterations and Bisection method.
c xl and xh are the initial bracketing of the root xm.
c**********************************************************************

      subroutine   NewtonRaphson2(xl,xh,xm,N)
      implicit     none

      integer      k,ITERMAX,N
      double precision xl,xh,xm,xn, func0,func1,func2, error, TOLERANCE
      parameter   (ITERMAX=100, TOLERANCE=1.d-15)

c.....Find function values at bracketing points

      call jacobf(func0,xm,func2,xl,N)
      call jacobf(func0,xn,func2,xh,N)

      if (xm*xn.gt.0.d0) then
         write(6,*)' root is not bracketed'
         return
      endif

c.....Rearrange xl and xh so that f(xl)< 0.d0 < f(xh)

      if (xm.gt.0.d0) then
         xm = xl
         xl = xh
         xh = xm
      endif

c.....Initial width of bracketed interval

      error = abs(xh-xl)

c.....Initialize guess for root

      xm = 0.5d0*(xl+xh)

      k = 0

      do while (error.gt.TOLERANCE .and. k.lt.ITERMAX)
         k = k+1
         call jacobf(func0,func1,func2,xm,N)

c........Adjust the bracketing of the root
         if (func1.gt.0.d0) then
            xh = xm
         else
            xl = xm
         endif

c........Tentative newton-Raphson step

         xn = xm - func1/func2

         if ((xn-xl)*(xn-xh).gt.0.d0) then
c...........Bisection step
            xm = 0.5d0* (xh+xl)
            error = abs(xh-xl)
         else
c...........Newton-Raphson step successfull
            error = abs(xn-xm)
            xm = xn
         endif
      enddo

c.....Check if solution converged

      if (error.gt.TOLERANCE) then
         write(6,*) 'solution did not converge'
      endif

      return
      end

c**********************************************************************
c Compute the Jacobi polynomials and their derivatives using
c the recurrence relationship.
c p0_3 = Legendre polynomial of degree N
c p1_3 = 1st derivative of Legendre polynomial of degree N at x
c p2_3 = 2nd derivative of Legendre polynomial of degree N at x
c**********************************************************************

      subroutine   jacobf(p0_3,p1_3,p2_3,x,N)
      implicit     none

      integer      N, k
      double precision p0_1, p0_2, p0_3, p1_1, p1_2
     *               , p1_3, p2_1, p2_2, p2_3, a1, a2, x

      p0_3 = 1.d0
      p1_3 = 0.d0
      p2_3 = 0.d0

      if (N.ne.0) then
        p0_2 = p0_3
        p1_2 = p1_3
        p2_2 = p2_3
        p0_3 = x
        p1_3 = 1.d0
        p2_3 = 0.d0

        do k = 2,N
          p0_1 = p0_2
          p1_1 = p1_2
          p2_1 = p2_2
          p0_2 = p0_3
          p1_2 = p1_3
          p2_2 = p2_3

          a1 = (2.d0*k-1.d0) / k
          a2 = (k-1.d0) / k

          p0_3 = a1*x*p0_2 - a2*p0_1
          p1_3 = a1*x*p1_2 - a2*p1_1 + a1*p0_2
          p2_3 = a1*x*p2_2 - a2*p2_1 + 2.d0*a1*p1_2
        enddo
      endif

      return
      end

c**********************************************************************
c Compute the Jacobi polynomials using c the recurrence relationship.
c p_3 = Legendre polynomial of degree N
c p_2 = Legendre polynomial of degree N-1 at x
c p_1 = Legendre polynomial of degree N-2 at x
c**********************************************************************

      function     Legendre(x,N)
      implicit     none

      integer      N, k
      double precision p_1, p_2, p_3, x, Legendre

      p_3 = 1.d0

      if (N.ne.0) then
        p_2 = p_3
        p_3 = x
        do k = 2,N
          p_1 = p_2
          p_2 = p_3
          p_3 = ( (2.d0*k-1.d0)*x*p_2 - (k-1.d0)*p_1 ) / k
        enddo
      endif

      Legendre = p_3

      return
      end

c***********************************************************************
c Compute the matrix giving the first derivative to the Cardinal 
c Legendre functions. To compute the first derivative just form the
c matrix product [dcpdxv]{u}={u_ksi}. Reapply previous formula for 
c higher order derivative.

c npts:number of collocation points 1<=i<=npts
c dcpdxv(i,j): derivative of pressure cardinal function i evaluated at 
c 		velocity node j
c***********************************************************************

      subroutine   CoefPgOnVg(dcpdxv,xvg,xpg,legep,npts,nptp)
      implicit     none

      integer      npts,nptp,N,i,j
      double precision  
     *             Legendre,fact,f1,f2,func0,func1,func2,dis,
     *             xvg(npts),xpg(nptp),legep(nptp),dcpdxv(nptp,npts)

      N = nptp-1

      do i = 1,nptp
        legep(i) = Legendre(xpg(i),N)
      enddo

      fact = N*(N+1)

      do j = 1,npts
        call jacobf(func0,func1,func2,xvg(j),N)
        f1 = fact*func0
        f2 = (1.d0-xvg(j)**2) * func1

        do i = 1,nptp
          if (xvg(j).ne.xpg(i)) then
            dis = xvg(j) - xpg(i)
            dcpdxv(i,j) = (f1*dis+f2) / (fact*legep(i)*dis*dis)
          else
            dcpdxv(i,j) = 0.d0
          endif
        enddo
      enddo

      dcpdxv(nptp,npts) =-0.25d0*fact
      dcpdxv(1,1) = 0.25d0*fact

      return
      end

C
C $Id: dplast.f,v 1.6 2008-07-27 00:16:59 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE DPLAST
C
C This routine generates the appropriate call to terminate a curve
C drawn by an initial call to DPFRST and one or more subsequent calls
C to DPVECT.
C
C Declare the real/integer common block.
C
        COMMON /DPCMRI/ ANGF,DBPI,EPSI,IDPI,IDPS,ILTL,INDP,IPCF,ISBF,
     +                  ISCF,LCDP,RLS1,RLS2,RMFS,TENS,WCHR,WGAP,WSLD
        SAVE   /DPCMRI/
C
C Check for an uncleared prior error.
C
        IF (ICFELL('DPLAST - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C Call the appropriate lower-level routine, depending on whether
C smoothing is turned on or not.
C
        IF (TENS.LT.0.) THEN
          CALL DPDRAW (0.,0.,2)
          IF (ICFELL('DPLAST',2).NE.0) RETURN
        ELSE
          CALL DPSMTH (0.,0.,2)
          IF (ICFELL('DPLAST',3).NE.0) RETURN
        END IF
C
C Done.
C
        RETURN
C
      END

C
C	$Id: pcbdff.f,v 1.7 2008-07-27 00:17:18 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE PCBDFF
C
C Calling this do-nothing subroutine forces "ld" to load the following
C block data routine (but only if they are in the same ".f" file).
C
        RETURN
C
      END
CNOSPLIT
      BLOCKDATA PCBDFFX
C
C BLOCK DATA for filled fonts.
C
      include 'pcffme.doc'
      include 'pcffme.h'
      include 'pcffdx.doc'
      include 'pcffdx.h'
      include 'pcffsp.doc'
      include 'pcffsp.h'
C
C Initialize a single variable to avoid a loader error on
C some systems.  This blockdata subroutine is here as a
C dummy in case it should ever be needed in the future.
C
      DATA TYPFLG / 0 /
C
      END

      SUBROUTINE DPTTRS( N, NRHS, D, E, B, LDB, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      INTEGER            INFO, LDB, N, NRHS
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   B( LDB, * ), D( * ), E( * )
*     ..
*
*  Purpose
*  =======
*
*  DPTTRS solves a tridiagonal system of the form
*     A * X = B
*  using the L*D*L' factorization of A computed by DPTTRF.  D is a
*  diagonal matrix specified in the vector D, L is a unit bidiagonal
*  matrix whose subdiagonal is specified in the vector E, and X and B
*  are N by NRHS matrices.
*
*  Arguments
*  =========
*
*  N       (input) INTEGER
*          The order of the tridiagonal matrix A.  N >= 0.
*
*  NRHS    (input) INTEGER
*          The number of right hand sides, i.e., the number of columns
*          of the matrix B.  NRHS >= 0.
*
*  D       (input) DOUBLE PRECISION array, dimension (N)
*          The n diagonal elements of the diagonal matrix D from the
*          L*D*L' factorization of A.
*
*  E       (input) DOUBLE PRECISION array, dimension (N-1)
*          The (n-1) subdiagonal elements of the unit bidiagonal factor
*          L from the L*D*L' factorization of A.  E can also be regarded
*          as the superdiagonal of the unit bidiagonal factor U from the
*          factorization A = U'*D*U.
*
*  B       (input/output) DOUBLE PRECISION array, dimension (LDB,NRHS)
*          On entry, the right hand side vectors B for the system of
*          linear equations.
*          On exit, the solution vectors, X.
*
*  LDB     (input) INTEGER
*          The leading dimension of the array B.  LDB >= max(1,N).
*
*  INFO    (output) INTEGER
*          = 0: successful exit
*          < 0: if INFO = -k, the k-th argument had an illegal value
*
*  =====================================================================
*
*     .. Local Scalars ..
      INTEGER            J, JB, NB
*     ..
*     .. External Functions ..
      INTEGER            ILAENV
      EXTERNAL           ILAENV
*     ..
*     .. External Subroutines ..
      EXTERNAL           DPTTS2, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN
*     ..
*     .. Executable Statements ..
*
*     Test the input arguments.
*
      INFO = 0
      IF( N.LT.0 ) THEN
         INFO = -1
      ELSE IF( NRHS.LT.0 ) THEN
         INFO = -2
      ELSE IF( LDB.LT.MAX( 1, N ) ) THEN
         INFO = -6
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DPTTRS', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 .OR. NRHS.EQ.0 )
     $   RETURN
*
*     Determine the number of right-hand sides to solve at a time.
*
      IF( NRHS.EQ.1 ) THEN
         NB = 1
      ELSE
         NB = MAX( 1, ILAENV( 1, 'DPTTRS', ' ', N, NRHS, -1, -1 ) )
      END IF
*
      IF( NB.GE.NRHS ) THEN
         CALL DPTTS2( N, NRHS, D, E, B, LDB )
      ELSE
         DO 10 J = 1, NRHS, NB
            JB = MIN( NRHS-J+1, NB )
            CALL DPTTS2( N, JB, D, E, B( 1, J ), LDB )
   10    CONTINUE
      END IF
*
      RETURN
*
*     End of DPTTRS
*
      END

C
C $Id: mdlacd.f,v 1.6 2008-09-18 00:42:17 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MDLACD (RLAT,CHRS,NCHR,NOFD)
C
C This routine, given a latitude RLAT and a character buffer CHRS,
C returns CHRS and NCHR such that CHRS(1:NCHR), when written by PLCHHQ,
C will yield a representation of RLAT in degrees and possibly fractions
C of a degree north or south of the equator.
C
        DOUBLE PRECISION RLAT
        CHARACTER*(*)    CHRS
        INTEGER          NCHR,NOFD
C
C Declare local variables.
C
        INTEGER          I,ILAT
C
C Compute the absolute value of the latitude in units of 10**(-5)
C degrees, limiting it to the range [0,9000000].
C
        ILAT=MIN(9000000,INT(100000.D0*ABS(RLAT)+.5D0))
C
C If the value is zero, return a string that will make PLCHHQ write a
C 0 followed by a degree sign.
C
        IF (ILAT.EQ.0) THEN
          NCHR=7
          CHRS='0:F34:0'
          RETURN
        END IF
C
C Otherwise, put blanks in the buffer and zero the current character
C count.
C
        CHRS=' '
        NCHR=0
C
C Put the number of degrees in the buffer.
C
        CALL MDINCH (ILAT/100000,CHRS,NCHR)
C
C If there is to be a fractional part, put it in the buffer.
C
        IF (NOFD.NE.0) THEN
          NCHR=NCHR+1
          CHRS(NCHR:NCHR)='.'
          DO 101 I=1,NOFD
            CALL MDINCH (MOD(ILAT/10**(5-I),10),CHRS,NCHR)
  101     CONTINUE
        END IF
C
C Add the code for a degree sign to the buffer.
C
        NCHR=NCHR+9
        CHRS(NCHR-8:NCHR)=':F34:0:F:'
C
C Finally, put either an "S" or an "N" in the buffer.
C
        NCHR=NCHR+1
C
        IF (RLAT.LT.0.) THEN
          CHRS(NCHR:NCHR)='S'
        ELSE
          CHRS(NCHR:NCHR)='N'
        END IF
C
C Done.
C
        RETURN
C
      END

C
C $Id: tsfndp.f,v 1.5 2008-07-27 00:17:12 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      DOUBLE PRECISION FUNCTION TSFNDP (ECCENT,PHI,SINPHI)
C
C FUNCTION TO COMPUTE CONSTANT (SMALL T).
C
      IMPLICIT DOUBLE PRECISION (A-Z)
      DATA HALF,ONE /0.5D0,1.0D0/
      DATA HALFPI /1.5707963267948966D0/
C
      CON = ECCENT * SINPHI
      COM = HALF * ECCENT
      CON = ((ONE - CON) / (ONE + CON)) ** COM
      TSFNDP = TAN (HALF * (HALFPI - PHI)) / CON
C
      RETURN
      END

      SUBROUTINE ZSTEDC( COMPZ, N, D, E, Z, LDZ, WORK, LWORK, RWORK,
     $                   LRWORK, IWORK, LIWORK, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          COMPZ
      INTEGER            INFO, LDZ, LIWORK, LRWORK, LWORK, N
*     ..
*     .. Array Arguments ..
      INTEGER            IWORK( * )
      DOUBLE PRECISION   D( * ), E( * ), RWORK( * )
      COMPLEX*16         WORK( * ), Z( LDZ, * )
*     ..
*
*  Purpose
*  =======
*
*  ZSTEDC computes all eigenvalues and, optionally, eigenvectors of a
*  symmetric tridiagonal matrix using the divide and conquer method.
*  The eigenvectors of a full or band complex Hermitian matrix can also
*  be found if ZHETRD or ZHPTRD or ZHBTRD has been used to reduce this
*  matrix to tridiagonal form.
*
*  This code makes very mild assumptions about floating point
*  arithmetic. It will work on machines with a guard digit in
*  add/subtract, or on those binary machines without guard digits
*  which subtract like the Cray X-MP, Cray Y-MP, Cray C-90, or Cray-2.
*  It could conceivably fail on hexadecimal or decimal machines
*  without guard digits, but we know of none.  See DLAED3 for details.
*
*  Arguments
*  =========
*
*  COMPZ   (input) CHARACTER*1
*          = 'N':  Compute eigenvalues only.
*          = 'I':  Compute eigenvectors of tridiagonal matrix also.
*          = 'V':  Compute eigenvectors of original Hermitian matrix
*                  also.  On entry, Z contains the unitary matrix used
*                  to reduce the original matrix to tridiagonal form.
*
*  N       (input) INTEGER
*          The dimension of the symmetric tridiagonal matrix.  N >= 0.
*
*  D       (input/output) DOUBLE PRECISION array, dimension (N)
*          On entry, the diagonal elements of the tridiagonal matrix.
*          On exit, if INFO = 0, the eigenvalues in ascending order.
*
*  E       (input/output) DOUBLE PRECISION array, dimension (N-1)
*          On entry, the subdiagonal elements of the tridiagonal matrix.
*          On exit, E has been destroyed.
*
*  Z       (input/output) COMPLEX*16 array, dimension (LDZ,N)
*          On entry, if COMPZ = 'V', then Z contains the unitary
*          matrix used in the reduction to tridiagonal form.
*          On exit, if INFO = 0, then if COMPZ = 'V', Z contains the
*          orthonormal eigenvectors of the original Hermitian matrix,
*          and if COMPZ = 'I', Z contains the orthonormal eigenvectors
*          of the symmetric tridiagonal matrix.
*          If  COMPZ = 'N', then Z is not referenced.
*
*  LDZ     (input) INTEGER
*          The leading dimension of the array Z.  LDZ >= 1.
*          If eigenvectors are desired, then LDZ >= max(1,N).
*
*  WORK    (workspace/output) COMPLEX*16 array, dimension (LWORK)
*          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*
*  LWORK   (input) INTEGER
*          The dimension of the array WORK.
*          If COMPZ = 'N' or 'I', or N <= 1, LWORK must be at least 1.
*          If COMPZ = 'V' and N > 1, LWORK must be at least N*N.
*
*          If LWORK = -1, then a workspace query is assumed; the routine
*          only calculates the optimal size of the WORK array, returns
*          this value as the first entry of the WORK array, and no error
*          message related to LWORK is issued by XERBLA.
*
*  RWORK   (workspace/output) DOUBLE PRECISION array,
*                                         dimension (LRWORK)
*          On exit, if INFO = 0, RWORK(1) returns the optimal LRWORK.
*
*  LRWORK  (input) INTEGER
*          The dimension of the array RWORK.
*          If COMPZ = 'N' or N <= 1, LRWORK must be at least 1.
*          If COMPZ = 'V' and N > 1, LRWORK must be at least
*                         1 + 3*N + 2*N*lg N + 3*N**2 ,
*                         where lg( N ) = smallest integer k such
*                         that 2**k >= N.
*          If COMPZ = 'I' and N > 1, LRWORK must be at least
*                         1 + 4*N + 2*N**2 .
*
*          If LRWORK = -1, then a workspace query is assumed; the
*          routine only calculates the optimal size of the RWORK array,
*          returns this value as the first entry of the RWORK array, and
*          no error message related to LRWORK is issued by XERBLA.
*
*  IWORK   (workspace/output) INTEGER array, dimension (LIWORK)
*          On exit, if INFO = 0, IWORK(1) returns the optimal LIWORK.
*
*  LIWORK  (input) INTEGER
*          The dimension of the array IWORK.
*          If COMPZ = 'N' or N <= 1, LIWORK must be at least 1.
*          If COMPZ = 'V' or N > 1,  LIWORK must be at least
*                                    6 + 6*N + 5*N*lg N.
*          If COMPZ = 'I' or N > 1,  LIWORK must be at least
*                                    3 + 5*N .
*
*          If LIWORK = -1, then a workspace query is assumed; the
*          routine only calculates the optimal size of the IWORK array,
*          returns this value as the first entry of the IWORK array, and
*          no error message related to LIWORK is issued by XERBLA.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit.
*          < 0:  if INFO = -i, the i-th argument had an illegal value.
*          > 0:  The algorithm failed to compute an eigenvalue while
*                working on the submatrix lying in rows and columns
*                INFO/(N+1) through mod(INFO,N+1).
*
*  Further Details
*  ===============
*
*  Based on contributions by
*     Jeff Rutter, Computer Science Division, University of California
*     at Berkeley, USA
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO, ONE, TWO
      PARAMETER          ( ZERO = 0.0D0, ONE = 1.0D0, TWO = 2.0D0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            LQUERY
      INTEGER            END, I, ICOMPZ, II, J, K, LGN, LIWMIN, LL,
     $                   LRWMIN, LWMIN, M, SMLSIZ, START
      DOUBLE PRECISION   EPS, ORGNRM, P, TINY
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            ILAENV
      DOUBLE PRECISION   DLAMCH, DLANST
      EXTERNAL           LSAME, ILAENV, DLAMCH, DLANST
*     ..
*     .. External Subroutines ..
      EXTERNAL           DLASCL, DLASET, DSTEDC, DSTEQR, DSTERF, XERBLA,
     $                   ZLACPY, ZLACRM, ZLAED0, ZSTEQR, ZSWAP
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, DBLE, INT, LOG, MAX, MOD, SQRT
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      LQUERY = ( LWORK.EQ.-1 .OR. LRWORK.EQ.-1 .OR. LIWORK.EQ.-1 )
*
      IF( LSAME( COMPZ, 'N' ) ) THEN
         ICOMPZ = 0
      ELSE IF( LSAME( COMPZ, 'V' ) ) THEN
         ICOMPZ = 1
      ELSE IF( LSAME( COMPZ, 'I' ) ) THEN
         ICOMPZ = 2
      ELSE
         ICOMPZ = -1
      END IF
      IF( N.LE.1 .OR. ICOMPZ.LE.0 ) THEN
         LWMIN = 1
         LIWMIN = 1
         LRWMIN = 1
      ELSE
         LGN = INT( LOG( DBLE( N ) ) / LOG( TWO ) )
         IF( 2**LGN.LT.N )
     $      LGN = LGN + 1
         IF( 2**LGN.LT.N )
     $      LGN = LGN + 1
         IF( ICOMPZ.EQ.1 ) THEN
            LWMIN = N*N
            LRWMIN = 1 + 3*N + 2*N*LGN + 3*N**2
            LIWMIN = 6 + 6*N + 5*N*LGN
         ELSE IF( ICOMPZ.EQ.2 ) THEN
            LWMIN = 1
            LRWMIN = 1 + 4*N + 2*N**2
            LIWMIN = 3 + 5*N
         END IF
      END IF
      IF( ICOMPZ.LT.0 ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( ( LDZ.LT.1 ) .OR. ( ICOMPZ.GT.0 .AND. LDZ.LT.MAX( 1,
     $         N ) ) ) THEN
         INFO = -6
      ELSE IF( LWORK.LT.LWMIN .AND. .NOT.LQUERY ) THEN
         INFO = -8
      ELSE IF( LRWORK.LT.LRWMIN .AND. .NOT.LQUERY ) THEN
         INFO = -10
      ELSE IF( LIWORK.LT.LIWMIN .AND. .NOT.LQUERY ) THEN
         INFO = -12
      END IF
*
      IF( INFO.EQ.0 ) THEN
         WORK( 1 ) = LWMIN
         RWORK( 1 ) = LRWMIN
         IWORK( 1 ) = LIWMIN
      END IF
*
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'ZSTEDC', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
      IF( N.EQ.1 ) THEN
         IF( ICOMPZ.NE.0 )
     $      Z( 1, 1 ) = ONE
         RETURN
      END IF
*
      SMLSIZ = ILAENV( 9, 'ZSTEDC', ' ', 0, 0, 0, 0 )
*
*     If the following conditional clause is removed, then the routine
*     will use the Divide and Conquer routine to compute only the
*     eigenvalues, which requires (3N + 3N**2) real workspace and
*     (2 + 5N + 2N lg(N)) integer workspace.
*     Since on many architectures DSTERF is much faster than any other
*     algorithm for finding eigenvalues only, it is used here
*     as the default.
*
*     If COMPZ = 'N', use DSTERF to compute the eigenvalues.
*
      IF( ICOMPZ.EQ.0 ) THEN
         CALL DSTERF( N, D, E, INFO )
         RETURN
      END IF
*
*     If N is smaller than the minimum divide size (SMLSIZ+1), then
*     solve the problem with another solver.
*
      IF( N.LE.SMLSIZ ) THEN
         IF( ICOMPZ.EQ.0 ) THEN
            CALL DSTERF( N, D, E, INFO )
            RETURN
         ELSE IF( ICOMPZ.EQ.2 ) THEN
            CALL ZSTEQR( 'I', N, D, E, Z, LDZ, RWORK, INFO )
            RETURN
         ELSE
            CALL ZSTEQR( 'V', N, D, E, Z, LDZ, RWORK, INFO )
            RETURN
         END IF
      END IF
*
*     If COMPZ = 'I', we simply call DSTEDC instead.
*
      IF( ICOMPZ.EQ.2 ) THEN
         CALL DLASET( 'Full', N, N, ZERO, ONE, RWORK, N )
         LL = N*N + 1
         CALL DSTEDC( 'I', N, D, E, RWORK, N, RWORK( LL ), LRWORK-LL+1,
     $                IWORK, LIWORK, INFO )
         DO 20 J = 1, N
            DO 10 I = 1, N
               Z( I, J ) = RWORK( ( J-1 )*N+I )
   10       CONTINUE
   20    CONTINUE
         RETURN
      END IF
*
*     From now on, only option left to be handled is COMPZ = 'V',
*     i.e. ICOMPZ = 1.
*
*     Scale.
*
      ORGNRM = DLANST( 'M', N, D, E )
      IF( ORGNRM.EQ.ZERO )
     $   RETURN
*
      EPS = DLAMCH( 'Epsilon' )
*
      START = 1
*
*     while ( START <= N )
*
   30 CONTINUE
      IF( START.LE.N ) THEN
*
*     Let END be the position of the next subdiagonal entry such that
*     E( END ) <= TINY or END = N if no such subdiagonal exists.  The
*     matrix identified by the elements between START and END
*     constitutes an independent sub-problem.
*
         END = START
   40    CONTINUE
         IF( END.LT.N ) THEN
            TINY = EPS*SQRT( ABS( D( END ) ) )*SQRT( ABS( D( END+1 ) ) )
            IF( ABS( E( END ) ).GT.TINY ) THEN
               END = END + 1
               GO TO 40
            END IF
         END IF
*
*        (Sub) Problem determined.  Compute its size and solve it.
*
         M = END - START + 1
         IF( M.GT.SMLSIZ ) THEN
            INFO = SMLSIZ
*
*           Scale.
*
            ORGNRM = DLANST( 'M', M, D( START ), E( START ) )
            CALL DLASCL( 'G', 0, 0, ORGNRM, ONE, M, 1, D( START ), M,
     $                   INFO )
            CALL DLASCL( 'G', 0, 0, ORGNRM, ONE, M-1, 1, E( START ),
     $                   M-1, INFO )
*
            CALL ZLAED0( N, M, D( START ), E( START ), Z( 1, START ),
     $                   LDZ, WORK, N, RWORK, IWORK, INFO )
            IF( INFO.GT.0 ) THEN
               INFO = ( INFO / ( M+1 )+START-1 )*( N+1 ) +
     $                MOD( INFO, ( M+1 ) ) + START - 1
               RETURN
            END IF
*
*           Scale back.
*
            CALL DLASCL( 'G', 0, 0, ONE, ORGNRM, M, 1, D( START ), M,
     $                   INFO )
*
         ELSE
            CALL DSTEQR( 'I', M, D( START ), E( START ), RWORK, M,
     $                   RWORK( M*M+1 ), INFO )
            CALL ZLACRM( N, M, Z( 1, START ), LDZ, RWORK, M, WORK, N,
     $                   RWORK( M*M+1 ) )
            CALL ZLACPY( 'A', N, M, WORK, N, Z( 1, START ), LDZ )
            IF( INFO.GT.0 ) THEN
               INFO = START*( N+1 ) + END
               RETURN
            END IF
         END IF
*
         START = END + 1
         GO TO 30
      END IF
*
*     endwhile
*
*     If the problem split any number of times, then the eigenvalues
*     will not be properly ordered.  Here we permute the eigenvalues
*     (and the associated eigenvectors) into ascending order.
*
      IF( M.NE.N ) THEN
*
*        Use Selection Sort to minimize swaps of eigenvectors
*
         DO 60 II = 2, N
            I = II - 1
            K = I
            P = D( I )
            DO 50 J = II, N
               IF( D( J ).LT.P ) THEN
                  K = J
                  P = D( J )
               END IF
   50       CONTINUE
            IF( K.NE.I ) THEN
               D( K ) = D( I )
               D( I ) = P
               CALL ZSWAP( N, Z( 1, I ), 1, Z( 1, K ), 1 )
            END IF
   60    CONTINUE
      END IF
*
      WORK( 1 ) = LWMIN
      RWORK( 1 ) = LRWMIN
      IWORK( 1 ) = LIWMIN
*
      RETURN
*
*     End of ZSTEDC
*
      END

        PROGRAM MPEX13
C
C This program shows how to use EZMAP routines providing access to
C the RANGS database ("Regionally Accessible Nested Global Shorelines")
C created by Reiner Feistel, which make use of the GSHHS database
C ("Global Self-consistent Heirarchical High-resolution Shorelines")
C created by Paul Wessel and Walter H. F. Smith.  The original data were
C from the World Vector Shoreline and World Databank II databases.
C
C It also demonstrates the use of routines for labelling latitudes or
C longitudes along a specified line on a map.
C
C Note that, as it stands, this program will fail to produce any plots
C using the RANGS/GSHHS data, because that data will not be available
C to it.  The user must add a routine called MDRGDI, which looks like
C this:
C
C     SUBROUTINE MDRGDI (DINM)
C
C This is a user-replaceable routine that returns the name of the
C directory in which the RANGS/GSHHS data files have been placed.
C
C       CHARACTER*(*) DINM
C
C Return the name of the directory where the RANGS/GSHHS data reside.
C
C       DINM='/fs/scd/home1/kennison/Mapping/RANGSData'
C
C Done.
C
C       RETURN
C
C     END
C
C The specified directory must contain the following files:
C
C   gshhs(0).rim 89496428 bytes
C   gshhs(1).rim 20775224 bytes
C   gshhs(2).rim  5099196 bytes
C   gshhs(3).rim  1109192 bytes
C   gshhs(4).rim   170948 bytes
C   rangs(0).cat   259200 bytes
C   rangs(0).cel  6518664 bytes
C   rangs(1).cat   259200 bytes
C   rangs(1).cel  5945492 bytes
C   rangs(2).cat   259200 bytes
C   rangs(2).cel  4062215 bytes
C   rangs(3).cat   259200 bytes
C   rangs(3).cel  3398642 bytes
C   rangs(4).cat   259200 bytes
C   rangs(4).cel  3045848 bytes
C
C These files may be obtained from Rainer Feistel's Web site:
C
C   http://www.io-warnemuende.de/homepages/rfeistel/index.html
C
C A description of the files is available here:
C
C   http://www.agu.org/eos_elec/99063e.html
C
C Hopefully, these files will also be available from the NCAR Graphics
C Web site.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
        PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Declare arrays to hold center-point positions, angular half-widths,
C grid spacings, resolutions, and titles for four different maps to
C be drawn.  For each of the four, the map is drawn three different
C times, once using the old 'CO' database, once using the database
C "Earth..2", and again using the RANGS/GSHHS database.
C
        DOUBLE PRECISION PLAT(4),PLON(4),ANGL(4),GRSP(4)
        INTEGER IRGL(4)
        CHARACTER*16 TITL(4)
C
C Declare arrays to hold color indices to be passed to MDRGSC, defining
C the colors to be used on maps drawn from the RANGS/GSHHS database
C
        DIMENSION ICOL(5),ICSF(5)
C
C Declare a character-size variable.
C
        REAL CHSZ
C
C Declare stuff required to do color fill.
C
        PARAMETER (LAMA=200000,NCRA=10000,NGPS=10,LRWK=2*NCRA)
C
        DIMENSION IAMA(LAMA),XCRA(NCRA),YCRA(NCRA),IAAI(NGPS),IAGI(NGPS)
C
        DIMENSION RWRK(LRWK)
        EQUIVALENCE (RWRK(1),XCRA(1)),(RWRK(NCRA+1),YCRA(1))
C
        EXTERNAL COLRCO,COLRE2
C
C Define the center-point positions and angular half-width for each of
C the four plots.
C
        DATA PLAT(1),PLON(1),ANGL(1) /  23.0D0 , -76.0D0 , 5.0D0 /
        DATA PLAT(2),PLON(2),ANGL(2) / -53.5D0 , -70.0D0 , 3.0D0 /
        DATA PLAT(3),PLON(3),ANGL(3) /  54.5D0 ,  -2.0D0 , 4.5D0 /
        DATA PLAT(4),PLON(4),ANGL(4) /  37.0D0 , 126.5D0 , 4.0D0 /
C
C Define the resolution of the grid and the level of the RANGS data
C to be used on each of the four plots.
C
        DATA GRSP(1),IRGL(1) / 1.D0 , 0 /
        DATA GRSP(2),IRGL(2) / 1.D0 , 0 /
        DATA GRSP(3),IRGL(3) / 1.D0 , 0 /
        DATA GRSP(4),IRGL(4) / 1.D0 , 0 /
C
C Define titles for the tops of the plots, describing the place mapped.
C
        DATA TITL(1) / 'Caribbean' /
        DATA TITL(2) / 'Tierra del Fuego' /
        DATA TITL(3) / 'Great Britain' /
        DATA TITL(4) / 'Korea' /
C
C Define the character size to be used for lat/lon labels.
C
        DATA CHSZ / .014 /
C
C Tell the user what he needs to do to get this to run.
C
        PRINT * , ' '
        PRINT * , 'This example will not run properly until you have'
        PRINT * , 'downloaded the RANGS/GSHHS data, supplied a routine'
        PRINT * , 'for EZMAP to call to find out which directory the'
        PRINT * , 'data are in, and removed these PRINTs and the STOP'
        PRINT * , 'which follows them.  See code for full information.'
        PRINT * , ' '
        STOP
C
C Open GKS.
C
        CALL GOPKS (IERRF, ISZDM)
        CALL GOPWK (IWKID, LUNIT, IWTYPE)
        CALL GACWK (IWKID)
C
C Turn off clipping by GKS (so labels don't get clipped).
C
        CALL GSCLIP (0)
C
C Define some colors to use.  0 and 1 are black and white, the default
C background and foreground colors.  2 through 6 are used for coloring
C RANGS/GSHHS areas "ocean", "land", "lake", "island in lake", and
C "pond on island in lake", respectively.  7 is for debug use.
C
        CALL GSCR (1,0,0.,0.,0.)
        CALL GSCR (1,1,1.,1.,1.)
C
        CALL GSCR (1,2,0.,0.,1.)
        CALL GSCR (1,3,0.,1.,0.)
        CALL GSCR (1,4,0.,1.,1.)
        CALL GSCR (1,5,0.,1.,0.)
        CALL GSCR (1,6,0.,1.,1.)
C
        CALL GSCR (1,7,1.,0.,0.)
C
C Tell EZMAP to draw the map in a bit smaller square, leaving room for
C lat/lon labels around the edge.
C
        CALL MAPPOS (.08,.92,.08,.92)
C
C Tell EZMAP what colors to use for the outlines and filled areas
C produced from the RANGS/GSHHS data.
C
        ICOL(1)=7
        ICOL(2)=7
        ICOL(3)=7
        ICOL(4)=7
        ICOL(5)=7
C
        ICSF(1)=2
        ICSF(2)=3
        ICSF(3)=4
        ICSF(4)=5
        ICSF(5)=6
C
        CALL MDRGSC (ICOL,ICSF)
C
C Increase the number of points to be interpolated along the edges of
C the 1-degree cells (to get rid of some edge effects that otherwise
C occur).
C
        CALL MPSETI ('II',64064)
C       CALL MPSETD ('GD',.1D0)
C
C Set the PLOTCHAR font, character color, and outlining.
C
        CALL PCSETI ('FN',26)
        CALL PCSETI ('CC', 1)
        CALL PCSETI ('OF', 1)
        CALL PCSETI ('OC', 1)
C
C Loop to do views of four different spots on the globe.
C
        DO 101 ISPT=1,4
C
C Print the loop index, so the user will know something is happening.
C (This program runs pretty slowly.)
C
          PRINT * , ' '
          PRINT * , 'POSITION NUMBER ',ISPT,'    ',TITL(ISPT)
C
C Define a satellite altitude (for use if 'SV' is selected below).
C
          CALL MAPSTD ('SA',2.5D0)
C
C Define the projection to be used.  (If only a small portion of the
C projection plane is being shown, it doesn't make too much difference
C which projection is chosen.)
C
C         CALL MDPROJ ('ST',PLAT(ISPT),PLON(ISPT),0.D0)
          CALL MDPROJ ('OR',PLAT(ISPT),PLON(ISPT),0.D0)
C         CALL MDPROJ ('CE',PLAT(ISPT),PLON(ISPT),0.D0)
C         CALL MDPROJ ('MO',PLAT(ISPT),PLON(ISPT),0.D0)
C         CALL MDPROJ ('ME',PLAT(ISPT),PLON(ISPT),0.D0)
C         CALL MDPROJ ('RO',PLAT(ISPT),PLON(ISPT),0.D0)
C         CALL MDPROJ ('AE',PLAT(ISPT),PLON(ISPT),0.D0)
C         CALL MDPROJ ('LE',PLAT(ISPT),PLON(ISPT),0.D0)
C         CALL MDPROJ ('GN',PLAT(ISPT),PLON(ISPT),0.D0)
C         CALL MDPROJ ('SV',PLAT(ISPT),PLON(ISPT),0.D0)
C
C Define the limits of the map.
C
          CALL MDPSET ('AN',ANGL(ISPT),ANGL(ISPT),ANGL(ISPT),ANGL(ISPT))
C
C Here's an interesting combination:
C
C         CALL MAPSTD ('SA',1.03125D0)
C         CALL MDPROJ ('SV',PLAT(ISPT),PLON(ISPT),0.D0)
C         CALL MDPSET ('AN',     65.D0,     65.D0,     65.D0,     65.D0)
C
C Tell EZMAP what spacing to use on the grid.
C
          CALL MAPSTD ('GR',GRSP(ISPT))
C
C Draw a default EZMAP map, using the outline database 'CO', and then
C add a grid, lat/lon labels, and informational labels.
C
          PRINT * , '  USING DATABASE "CO"'
          CALL ARINAM (IAMA,LAMA)
          CALL MDPBLA (IAMA)
          CALL ARSCAM (IAMA,XCRA,YCRA,NCRA,IAAI,IAGI,NGPS,COLRCO)
          CALL GSPLCI (7)
          CALL MDPLOT
          CALL GSPLCI (1)
          CALL MDPGRD
          CALL MDLBLT (.08,.08,.08,.92,-CHSZ,    0.,CHSZ,0.,+1.)
          CALL MDLBLT (.92,.08,.92,.92, CHSZ,    0.,CHSZ,0.,-1.)
          CALL MDLBLN (.08,.08,.92,.08,0.,-1.5*CHSZ,CHSZ,0., 0.)
          CALL MDLBLN (.08,.92,.92,.92,0.,+1.5*CHSZ,CHSZ,0., 0.)
          CALL PLCHHQ (CFUX(.5),CFUY(.975),
     +                 TITL(ISPT)(1:MDILNB(TITL(ISPT))),.015,0.,0.)
          CALL PLCHHQ (CFUX(.5),CFUY(.025),'Old Database "CO"',
     +                                              .015,0.,0.)
          CALL FRAME
C
C Draw a map using outlines from the database "Earth..2", and then
C add a grid, lat/lon labels, and informational labels.
C
          PRINT * , '  USING DATABASE "Earth..2"'
          CALL ARINAM (IAMA,LAMA)
          CALL MDLNAM ('Earth..2',1,IAMA)
          CALL ARSCAM (IAMA,XCRA,YCRA,NCRA,IAAI,IAGI,NGPS,COLRE2)
          CALL GSPLCI (7)
          CALL MDLNDR ('Earth..2',1)
          CALL GSPLCI (1)
          CALL MDPGRD
          CALL MDLBLT (.08,.08,.08,.92,-CHSZ,    0.,CHSZ,0.,+1.)
          CALL MDLBLT (.92,.08,.92,.92, CHSZ,    0.,CHSZ,0.,-1.)
          CALL MDLBLN (.08,.08,.92,.08,0.,-1.5*CHSZ,CHSZ,0., 0.)
          CALL MDLBLN (.08,.92,.92,.92,0.,+1.5*CHSZ,CHSZ,0., 0.)
          CALL PLCHHQ (CFUX(.5),CFUY(.975),
     +                 TITL(ISPT)(1:MDILNB(TITL(ISPT))),.015,0.,0.)
          CALL PLCHHQ (CFUX(.5),CFUY(.025),'Earth..2',.015,0.,0.)
          CALL FRAME
C
C Now, draw a solid-filled map using the RANGS/GSHHS data.
C
          PRINT * , '  USING RANGS/GSHHS DATABASE'
C
          CALL MDRGSF (IRGL(ISPT),RWRK,LRWK,IAMA,LAMA)
C
C Add outlines using the RANGS/GSHHS data.
C
          CALL MDRGOL (IRGL(ISPT),RWRK,LRWK)
C
C Overlay a lat/lon grid.
C
          CALL MDPGRD
C
C Add latitude and longitude labels.
C
          CALL MDLBLT (.08,.08,.08,.92,-CHSZ,    0.,CHSZ,0.,+1.)
          CALL MDLBLT (.92,.08,.92,.92, CHSZ,    0.,CHSZ,0.,-1.)
          CALL MDLBLN (.08,.08,.92,.08,0.,-1.5*CHSZ,CHSZ,0., 0.)
          CALL MDLBLN (.08,.92,.92,.92,0.,+1.5*CHSZ,CHSZ,0., 0.)
C
C Put a label at the top of the plot.
C
          CALL PLCHHQ (CFUX(.5),CFUY(.975),
     +                 TITL(ISPT)(1:MDILNB(TITL(ISPT))),.015,0.,0.)
C
C Put a label at the bottom of the plot.
C
          CALL PLCHHQ (CFUX(.5),CFUY(.025),'RANGS/GSHHS',.015,0.,0.)
C
C Advance the plotter frame.
C
          CALL FRAME
C
C End of loop.
C
  101   CONTINUE
C
C Reset the PLOTCHAR font, character color, and outlining.
C
        CALL PCSETI ('FN', 0)
        CALL PCSETI ('CC',-1)
        CALL PCSETI ('OF', 0)
        CALL PCSETI ('OC', 1)
C
C Close GKS.
C
        CALL GDAWK (IWKID)
        CALL GCLWK (IWKID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END


      SUBROUTINE COLRCO (XCRA,YCRA,NCRA,IAAI,IAGI,NGPS)
        DIMENSION XCRA(NCRA),YCRA(NCRA),IAAI(NGPS),IAGI(NGPS)
        IAI1=-1
        DO 101 IGRP=1,NGPS
          IF (IAGI(IGRP).EQ.1) IAI1=IAAI(IGRP)
  101   CONTINUE
        IF (IAI1.GT.0) THEN
          IF (MDPACI(IAI1).EQ.1) THEN
C           OCEAN
            CALL GSFACI (2)
          ELSE
C           LAND
            CALL GSFACI (3)
          END IF
          CALL GFA    (NCRA-1,XCRA,YCRA)
        END IF
        RETURN
      END


      SUBROUTINE COLRE2 (XCRA,YCRA,NCRA,IAAI,IAGI,NGPS)
        DIMENSION XCRA(NCRA),YCRA(NCRA),IAAI(NGPS),IAGI(NGPS)
        IAI1=-1
        DO 101 IGRP=1,NGPS
          IF (IAGI(IGRP).EQ.1) IAI1=IAAI(IGRP)
  101   CONTINUE
        IF (IAI1.GT.0) THEN
          IF (MDIPAN(IAI1,'Water').NE.0) THEN
C           OCEAN
            CALL GSFACI (2)
          ELSE
C           LAND
            CALL GSFACI (3)
          END IF
          CALL GFA    (NCRA-1,XCRA,YCRA)
        END IF
        RETURN
      END

C
C $Id: mdptre.f,v 1.9 2008-09-18 00:42:17 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MDPTRE (UINS,VINS,UOUT,VOUT,UINT,VINT)
C
        DOUBLE PRECISION UINS,VINS,UOUT,VOUT,UINT,VINT
C
C This routine finds the point of intersection (UINT,VINT) of the line
C from (UINS,VINS) to (UOUT,VOUT) with the edge of an elliptical frame.
C The first point is inside the frame and the second outside the frame.
C
C Because MDPTRE can be called with the same actual arguments for UINT
C and VINT as for UOUT and VOUT, respectively, UINT and VINT must not
C be reset until all use of UOUT and VOUT is complete.
C
C Declare required common blocks.  See MAPBDX for descriptions of these
C common blocks and the variables in them.
C
        COMMON /MAPCM2/  BLAM,BLOM,PEPS,SLAM,SLOM,UCEN,UMAX,UMIN,UOFF,
     +                   URNG,VCEN,VMAX,VMIN,VOFF,VRNG,ISSL
        DOUBLE PRECISION BLAM,BLOM,PEPS,SLAM,SLOM,UCEN,UMAX,UMIN,UOFF,
     +                   URNG,VCEN,VMAX,VMIN,VOFF,VRNG
        INTEGER          ISSL
        SAVE   /MAPCM2/
C
C Declare local variables.
C
        DOUBLE PRECISION A,B,C,P,Q,UTM1,UTM2,UTM3,VTM1,VTM2,VTM3
C
C What's involved is just a lot of algebra.
C
        IF (ABS(UOUT-UINS).GT.ABS(VOUT-VINS)) THEN
          P=(VOUT-VINS)/(UOUT-UINS)
          Q=(UOUT*VINS-UINS*VOUT)/(UOUT-UINS)
          A=VRNG*VRNG+P*P*URNG*URNG
          B=2.D0*(P*Q*URNG*URNG-UCEN*VRNG*VRNG-P*URNG*URNG*VCEN)
          C=UCEN*UCEN*VRNG*VRNG+Q*Q*URNG*URNG-2.D0*Q*URNG*URNG*VCEN+
     +                           URNG*URNG*VCEN*VCEN-URNG*URNG*VRNG*VRNG
          UTM1=SQRT(MAX(B*B-4.D0*A*C,0.D0))
          UTM2=.5D0*(-B-UTM1)/A
          UTM3=.5D0*(-B+UTM1)/A
          IF (ABS(UTM2-(UINS+UOUT)/2.D0).LT.
     +        ABS(UTM3-(UINS+UOUT)/2.D0)) THEN
            UINT=UTM2
          ELSE
            UINT=UTM3
          END IF
          VINT=P*UINT+Q
        ELSE
          P=(UOUT-UINS)/(VOUT-VINS)
          Q=(UINS*VOUT-UOUT*VINS)/(VOUT-VINS)
          A=URNG*URNG+P*P*VRNG*VRNG
          B=2.D0*(P*Q*VRNG*VRNG-URNG*URNG*VCEN-P*UCEN*VRNG*VRNG)
          C=URNG*URNG*VCEN*VCEN+Q*Q*VRNG*VRNG-2.D0*Q*UCEN*VRNG*VRNG+
     +                           UCEN*UCEN*VRNG*VRNG-URNG*URNG*VRNG*VRNG
          VTM1=SQRT(MAX(B*B-4.D0*A*C,0.D0))
          VTM2=.5D0*(-B-VTM1)/A
          VTM3=.5D0*(-B+VTM1)/A
          IF (ABS(VTM2-(VINS+VOUT)/2.D0).LT.
     +        ABS(VTM3-(VINS+VOUT)/2.D0)) THEN
            VINT=VTM2
          ELSE
            VINT=VTM3
          END IF
          UINT=P*VINT+Q
        END IF
C
C Done.
C
        RETURN
C
      END

C
C	$Id: lined.f,v 1.4 2008-07-27 00:23:04 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE LINED (XA,YA,XB,YB)
C USER ENTRY POINT.
C
      DATA IDUMMY /0/
      CALL FL2INT (XA,YA,IXA,IYA)
      CALL FL2INT (XB,YB,IXB,IYB)
C
      CALL CUTUP (IXA,IYA,IXB,IYB)
      CALL CFVLD (3,IDUMMY,IDUMMY)
C
      RETURN
      END

C
C	$Id: gqchw.f,v 1.5 2008-07-27 00:20:58 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GQCHW (ERRIND,CHW)
C
C  INQUIRE CHARACTER WIDTH
C
      include 'gkscom.h'
C
      INTEGER ERRIND
      REAL    CHW
C
C  Check if GKS is in the proper state.
C
      CALL GZCKST(8,-1,ERRIND)
      IF (ERRIND .EQ. 0) THEN
        CHW = CCHH*CCHXP
      ELSE
        CHW = -1.
      ENDIF
C
      RETURN
      END

C
C	$Id: gupdvi.f,v 1.7 2008-07-27 00:21:07 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GUPDVI (INVAL, IPOINT, IPRIM)
C
C  Update the attribute deferral variables for an integer-valued
C  attribute.
C
C  Parameters:
C    INPUT
C      INVAL  -- New value for the attribute item.
C      IPOINT -- Pointer into the deferral control variable
C                structures, and into the index array that
C                gives the start of the primitive in the attribute
C                equivalencing array, integer version.
C      IPRIM  -- Output primitive type associated with
C                the attribute (1=POLYLINE, 2=POLYMARKER,
C                3=TEXT, 4=FILL AREA).  Used to index into
C                other of the control variable structures.
C	
C      OUTPUT
C        Adjustment of attribute deferral control parameters
C        in common.
C
C
      include 'g01prm.h'
      include 'g01rqa.h'
      include 'g01ast.h'
      include 'g01adc.h'
C
      INTEGER INVAL(*), IPOINT, IPRIM
C
      LOGICAL CHGNS
      INTEGER I, IOFF, LNGVAL
C
C  Offset and length of attribute in equivalencing structures.
C
      IOFF   = ABS(IP2AEA(IPOINT))
      LNGVAL = IL2AEA(IPOINT)
C
C  Is the new value different from the last sent?
C
      CHGNS = INVAL(1).NE.MSAEQV(IOFF)
      DO 10 I=2,LNGVAL
        CHGNS = CHGNS.OR. INVAL(I).NE.MSAEQV(IOFF+I-1)
   10 CONTINUE
C
      IF (CHGNS) THEN
C
C  New and last sent differ.
C
C  Set aggregate change-pending parameter.
C
        AGPEND(IPRIM) = .TRUE.
      END IF
C
C  Copy new value to requested.
C
      MRAEQV(IOFF) = INVAL(1)
      DO 30 I=2,LNGVAL
        MRAEQV(IOFF+I-1) = INVAL(I)
   30 CONTINUE
C
C  Mark value change.
C
      VALCHG(IPOINT) = CHGNS
C
        RETURN
        END

C
C	$Id: cstrmesh.f,v 1.6 2008-07-27 03:10:08 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CSTRMESH (N,X,Y,Z, LIST,LPTR,LEND,LNEW,NEAR,
     +                     NEXT,DIST,IER)
      INTEGER N, LIST(*), LPTR(*), LEND(N), LNEW, NEAR(N),
     +        NEXT(N), IER
      DOUBLE PRECISION X(N), Y(N), Z(N), DIST(N)
C
C***********************************************************
C
C                                              From STRIPACK
C                                            Robert J. Renka
C                                  Dept. of Computer Science
C                                       Univ. of North Texas
C                                           renka@cs.unt.edu
C                                                   07/08/99
C
C   This subroutine creates a Delaunay triangulation of a
C set of N arbitrarily distributed points, referred to as
C nodes, on the surface of the unit sphere.  The Delaunay
C triangulation is defined as a set of (spherical) triangles
C with the following five properties:
C
C  1)  The triangle vertices are nodes.
C  2)  No triangle contains a node other than its vertices.
C  3)  The interiors of the triangles are pairwise disjoint.
C  4)  The union of triangles is the convex hull of the set
C        of nodes (the smallest convex set that contains
C        the nodes).  If the nodes are not contained in a
C        single hemisphere, their convex hull is the en-
C        tire sphere and there are no boundary nodes.
C        Otherwise, there are at least three boundary nodes.
C  5)  The interior of the circumcircle of each triangle
C        contains no node.
C
C The first four properties define a triangulation, and the
C last property results in a triangulation which is as close
C as possible to equiangular in a certain sense and which is
C uniquely defined unless four or more nodes lie in a common
C plane.  This property makes the triangulation well-suited
C for solving closest-point problems and for triangle-based
C interpolation.
C
C   The algorithm has expected time complexity O(N*log(N))
C for most nodal distributions.
C
C   Spherical coordinates (latitude and longitude) may be
C converted to Cartesian coordinates by Subroutine CSTRANSD.
C
C   The following is a list of the software package modules
C which a user may wish to call directly:
C
C  CSADDNOD - Updates the triangulation by appending a new
C             node.
C
C  CSAREAS  - Returns the area of a spherical triangle.
C
C  CSBNODES - Returns an array containing the indexes of the
C             boundary nodes (if any) in counterclockwise
C             order.  Counts of boundary nodes, triangles,
C             and arcs are also returned.
C
C  CSCIRCUM - Returns the circumcenter of a spherical trian-
C             gle.
C
C  CSCRLIST - Returns the set of triangle circumcenters
C             (Voronoi vertices) and circumradii associated
C             with a triangulation.
C
C  CSDELARC - Deletes a boundary arc from a triangulation.
C
C  CSDELNOD - Updates the triangulation with a nodal deletion.
C
C  CSEDGE   - Forces an arbitrary pair of nodes to be connec-
C             ted by an arc in the triangulation.
C
C  CSGETNP  - Determines the ordered sequence of L closest
C             nodes to a given node, along with the associ-
C             ated distances.
C
C  CSINSIDE - Locates a point relative to a polygon on the
C             surface of the sphere.
C
C  CSINTRSC - Returns the point of intersection between a
C             pair of great circle arcs.
C
C  CSJRAND  - Generates a uniformly distributed pseudo-random
C             integer.
C
C  CSLEFT   - Locates a point relative to a great circle.
C
C  CSNEARND - Returns the index of the nearest node to an
C             arbitrary point, along with its squared
C             distance.
C
C  CSSCOORD - Converts a point from Cartesian coordinates to
C             spherical coordinates.
C
C  CSSTORE  - Forces a value to be stored in main memory so
C             that the precision of floating point numbers
C             in memory locations rather than registers is
C             computed.
C
C  CSTRANSD - Transforms spherical coordinates into Cartesian
C             coordinates on the unit sphere for input to
C             Subroutine CSTRMESH.
C
C  CSTRLIST - Converts the triangulation data structure to a
C             triangle list more suitable for use in a fin-
C             ite element code.
C
C  CSTRLPRT - Prints the triangle list created by Subroutine
C             CSTRLIST.
C
C  CSTRMESH - Creates a Delaunay triangulation of a set of
C             nodes.
C
C  CSTRPRNT - Prints the triangulation data structure and,
C             optionally, the nodal coordinates.
C
C On input:
C
C       N = Number of nodes in the triangulation.  N .GE. 3.
C
C       X,Y,Z = Arrays of length N containing the Cartesian
C               coordinates of distinct nodes.  (X(K),Y(K),
C               Z(K)) is referred to as node K, and K is re-
C               ferred to as a nodal index.  It is required
C               that X(K)**2 + Y(K)**2 + Z(K)**2 = 1 for all
C               K.  The first three nodes must not be col-
C               linear (lie on a common great circle).
C
C The above parameters are not altered by this routine.
C
C       LIST,LPTR = Arrays of length at least 6N-12.
C
C       LEND = Array of length at least N.
C
C       NEAR,NEXT,DIST = Work space arrays of length at
C                        least N.  The space is used to
C                        efficiently determine the nearest
C                        triangulation node to each un-
C                        processed node for use by CSADDNOD.
C
C On output:
C
C       LIST = Set of nodal indexes which, along with LPTR,
C              LEND, and LNEW, define the triangulation as a
C              set of N adjacency lists -- counterclockwise-
C              ordered sequences of neighboring nodes such
C              that the first and last neighbors of a bound-
C              ary node are boundary nodes (the first neigh-
C              bor of an interior node is arbitrary).  In
C              order to distinguish between interior and
C              boundary nodes, the last neighbor of each
C              boundary node is represented by the negative
C              of its index.
C
C       LPTR = Set of pointers (LIST indexes) in one-to-one
C              correspondence with the elements of LIST.
C              LIST(LPTR(I)) indexes the node which follows
C              LIST(I) in cyclical counterclockwise order
C              (the first neighbor follows the last neigh-
C              bor).
C
C       LEND = Set of pointers to adjacency lists.  LEND(K)
C              points to the last neighbor of node K for
C              K = 1,...,N.  Thus, LIST(LEND(K)) < 0 if and
C              only if K is a boundary node.
C
C       LNEW = Pointer to the first empty location in LIST
C              and LPTR (list length plus one).  LIST, LPTR,
C              LEND, and LNEW are not altered if IER < 0,
C              and are incomplete if IER > 0.
C
C       NEAR,NEXT,DIST = Garbage.
C
C       IER = Error indicator:
C             IER =  0 if no errors were encountered.
C             IER = -1 if N < 3 on input.
C             IER = -2 if the first three nodes are
C                      collinear.
C             IER =  L if nodes L and M coincide for some
C                      M > L.  The data structure represents
C                      a triangulation of nodes 1 to M-1 in
C                      this case.
C
C Modules required by CSTRMESH:  CSADDNOD, CSBDYADD, CSCOVSPH,
C                                CSINSERT, CSINTADD, CSJRAND,
C                                CSLEFT, CSLSTPTR, CSSTORE, CSSWAP,
C                                CSSWPTST, CSTRFIND
C
C Intrinsic function called by CSTRMESH:  ABS
C
C***********************************************************
C
      INTEGER I, I0, J, K, LP, LPL, NEXTI, NN
      LOGICAL CSLEFT
      DOUBLE PRECISION D, D1, D2, D3
C
C Local parameters:
C
C D =        (Negative cosine of) distance from node K to
C              node I
C D1,D2,D3 = Distances from node K to nodes 1, 2, and 3,
C              respectively
C I,J =      Nodal indexes
C I0 =       Index of the node preceding I in a sequence of
C              unprocessed nodes:  I = NEXT(I0)
C K =        Index of node to be added and DO-loop index:
C              K > 3
C LP =       LIST index (pointer) of a neighbor of K
C LPL =      Pointer to the last neighbor of K
C NEXTI =    NEXT(I)
C NN =       Local copy of N
C
      NN = N
      IF (NN .LT. 3) THEN
        IER = -1
        RETURN
      ENDIF
C
C Store the first triangle in the linked list.
C
      IF ( .NOT. CSLEFT (X(1),Y(1),Z(1),X(2),Y(2),Z(2),
     .                 X(3),Y(3),Z(3)) ) THEN
C
C   The first triangle is (3,2,1) = (2,1,3) = (1,3,2).
C
        LIST(1) = 3
        LPTR(1) = 2
        LIST(2) = -2
        LPTR(2) = 1
        LEND(1) = 2
C
        LIST(3) = 1
        LPTR(3) = 4
        LIST(4) = -3
        LPTR(4) = 3
        LEND(2) = 4
C
        LIST(5) = 2
        LPTR(5) = 6
        LIST(6) = -1
        LPTR(6) = 5
        LEND(3) = 6
C
      ELSEIF ( .NOT. CSLEFT(X(2),Y(2),Z(2),X(1),Y(1),Z(1),
     .                    X(3),Y(3),Z(3)) )
     .       THEN
C
C   The first triangle is (1,2,3):  3 Strictly Left 1->2,
C     i.e., node 3 lies in the left hemisphere defined by
C     arc 1->2.
C
        LIST(1) = 2
        LPTR(1) = 2
        LIST(2) = -3
        LPTR(2) = 1
        LEND(1) = 2
C
        LIST(3) = 3
        LPTR(3) = 4
        LIST(4) = -1
        LPTR(4) = 3
        LEND(2) = 4
C
        LIST(5) = 1
        LPTR(5) = 6
        LIST(6) = -2
        LPTR(6) = 5
        LEND(3) = 6
C
      ELSE
C
C   The first three nodes are collinear.
C
        IER = -2
        RETURN
      ENDIF
C
C Initialize LNEW and test for N = 3.
C
      LNEW = 7
      IF (NN .EQ. 3) THEN
        IER = 0
        RETURN
      ENDIF
C
C A nearest-node data structure (NEAR, NEXT, and DIST) is
C   used to obtain an expected-time (N*log(N)) incremental
C   algorithm by enabling constant search time for locating
C   each new node in the triangulation.
C
C For each unprocessed node K, NEAR(K) is the index of the
C   triangulation node closest to K (used as the starting
C   point for the search in Subroutine CSTRFIND) and DIST(K)
C   is an increasing function of the arc length (angular
C   distance) between nodes K and NEAR(K):  -Cos(a) for arc
C   length a.
C
C Since it is necessary to efficiently find the subset of
C   unprocessed nodes associated with each triangulation
C   node J (those that have J as their NEAR entries), the
C   subsets are stored in NEAR and NEXT as follows:  for
C   each node J in the triangulation, I = NEAR(J) is the
C   first unprocessed node in J's set (with I = 0 if the
C   set is empty), L = NEXT(I) (if I > 0) is the second,
C   NEXT(L) (if L > 0) is the third, etc.  The nodes in each
C   set are initially ordered by increasing indexes (which
C   maximizes efficiency) but that ordering is not main-
C   tained as the data structure is updated.
C
C Initialize the data structure for the single triangle.
C
      NEAR(1) = 0
      NEAR(2) = 0
      NEAR(3) = 0
      DO 1 K = NN,4,-1
        D1 = -(X(K)*X(1) + Y(K)*Y(1) + Z(K)*Z(1))
        D2 = -(X(K)*X(2) + Y(K)*Y(2) + Z(K)*Z(2))
        D3 = -(X(K)*X(3) + Y(K)*Y(3) + Z(K)*Z(3))
        IF (D1 .LE. D2  .AND.  D1 .LE. D3) THEN
          NEAR(K) = 1
          DIST(K) = D1
          NEXT(K) = NEAR(1)
          NEAR(1) = K
        ELSEIF (D2 .LE. D1  .AND.  D2 .LE. D3) THEN
          NEAR(K) = 2
          DIST(K) = D2
          NEXT(K) = NEAR(2)
          NEAR(2) = K
        ELSE
          NEAR(K) = 3
          DIST(K) = D3
          NEXT(K) = NEAR(3)
          NEAR(3) = K
        ENDIF
    1   CONTINUE
C
C Add the remaining nodes
C
      DO 6 K = 4,NN
        CALL CSADDNOD (NEAR(K),K,X,Y,Z, LIST,LPTR,LEND,
     .               LNEW, IER)
        IF (IER .NE. 0) RETURN
C
C Remove K from the set of unprocessed nodes associated
C   with NEAR(K).
C
        I = NEAR(K)
        IF (NEAR(I) .EQ. K) THEN
          NEAR(I) = NEXT(K)
        ELSE
          I = NEAR(I)
    2     I0 = I
            I = NEXT(I0)
            IF (I .NE. K) GO TO 2
          NEXT(I0) = NEXT(K)
        ENDIF
        NEAR(K) = 0
C
C Loop on neighbors J of node K.
C
        LPL = LEND(K)
        LP = LPL
    3   LP = LPTR(LP)
          J = ABS(LIST(LP))
C
C Loop on elements I in the sequence of unprocessed nodes
C   associated with J:  K is a candidate for replacing J
C   as the nearest triangulation node to I.  The next value
C   of I in the sequence, NEXT(I), must be saved before I
C   is moved because it is altered by adding I to K's set.
C
          I = NEAR(J)
    4     IF (I .EQ. 0) GO TO 5
          NEXTI = NEXT(I)
C
C Test for the distance from I to K less than the distance
C   from I to J.
C
          D = -(X(I)*X(K) + Y(I)*Y(K) + Z(I)*Z(K))
          IF (D .LT. DIST(I)) THEN
C
C Replace J by K as the nearest triangulation node to I:
C   update NEAR(I) and DIST(I), and remove I from J's set
C   of unprocessed nodes and add it to K's set.
C
            NEAR(I) = K
            DIST(I) = D
            IF (I .EQ. NEAR(J)) THEN
              NEAR(J) = NEXTI
            ELSE
              NEXT(I0) = NEXTI
            ENDIF
            NEXT(I) = NEAR(K)
            NEAR(K) = I
          ELSE
            I0 = I
          ENDIF
C
C Bottom of loop on I.
C
          I = NEXTI
          GO TO 4
C
C Bottom of loop on neighbors J.
C
    5     IF (LP .NE. LPL) GO TO 3
    6   CONTINUE
      RETURN
      END

      PROGRAM FFEX01
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Invoke demo driver
C
      CALL FEX01(IERR)
C
C     Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      STOP
      END
C
      SUBROUTINE FEX01 (IERROR)
C
      PARAMETER (PI=3.14159) 
      PARAMETER (MSIZE=21, NSIZE=25, IWSIZE = 2*MSIZE*NSIZE)
C
      REAL U(MSIZE,NSIZE), V(MSIZE,NSIZE), WRK(IWSIZE)
C
C Set the grid dimensions.
C
      DATA M, N /MSIZE, NSIZE/
C
C Specify horizontal and vertical vector components U and V on
C the rectangular grid.
C
      GISIZE = 2.0*PI/REAL(M)
      GJSIZE = 2.0*PI/REAL(N)
      DO  20 J = 1,N
         DO  10 I = 1,M
            U(I,J) = COS(GISIZE*(REAL(I)-1.0))
            V(I,J) = COS(GJSIZE*(REAL(J)-1.0))
   10    CONTINUE
   20 CONTINUE
C
C Draw the field with streamlines overlaid on vectors
C
      IDM = 0
      RDM = 0.0
      CALL VVINIT(U,M,V,M,RDM,IDM,M,N,RDM,IDM)
      CALL VVECTR(U,V,RDM,IDM,IDM,RDM)
      CALL STINIT(U,M,V,M,RDM,IDM,M,N,WRK,IWSIZE)
      CALL STREAM(U,V,RDM,IDM,IDM,WRK)
      CALL PERIM(1,0,1,0)
      CALL FRAME
C
C Draw just the vectors
C 
C
      IDM = 0
      RDM = 0.0
      CALL VVINIT(U,M,V,M,RDM,IDM,M,N,RDM,IDM)
      CALL VVECTR(U,V,RDM,IDM,IDM,RDM)
      CALL PERIM(1,0,1,0)
      CALL FRAME
C
C Draw just the streamlines
C
      IDM = 0
      RDM = 0.0
      CALL STINIT(U,M,V,M,RDM,IDM,M,N,WRK,IWSIZE)
      CALL STREAM(U,V,RDM,IDM,IDM,WRK)
      CALL PERIM(1,0,1,0)
      CALL FRAME
C
      END

C
C $Id: pj16sp.f,v 1.5 2008-07-27 00:17:11 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE PJ16SP (COORD,CRDIO,INDIC)
C
C -- S I N U S O I D A L
C
      IMPLICIT REAL (A-Z)
      INTEGER INDIC
      DIMENSION GEOG(2),PROJ(2),COORD(2),CRDIO(2)
C **** PARAMETERS **** A,LON0,X0,Y0 ************************************
      COMMON /ERRMZ0/ IERR
        INTEGER IERR
      SAVE   /ERRMZ0/
      COMMON /PRINZ0/ IPEMSG,IPELUN,IPPARM,IPPLUN
        INTEGER IPEMSG,IPELUN,IPPARM,IPPLUN
      SAVE   /PRINZ0/
      COMMON /PC16SP/ A,LON0,X0,Y0
      DATA HALFPI /1.5707963267948966E0/
      DATA EPSLN /1.0E-10/
C
C -- F O R W A R D   . . .
C
      IF (INDIC .EQ. 0) THEN
C
         GEOG(1) = COORD(1)
         GEOG(2) = COORD(2)
         IERR = 0
         LON = ADJLSP (GEOG(1) - LON0)
         PROJ(1) = X0 + A * LON * COS (GEOG(2))
         PROJ(2) = Y0 + A * GEOG(2)
         CRDIO(1) = PROJ(1)
         CRDIO(2) = PROJ(2)
         RETURN
      END IF
C
C -- I N V E R S E   . . .
C
      IF (INDIC .EQ. 1) THEN
C
         PROJ(1) = COORD(1)
         PROJ(2) = COORD(2)
         IERR = 0
         X = PROJ(1) - X0
         Y = PROJ(2) - Y0
         GEOG(2) = Y / A
         IF (ABS(GEOG(2)) .LE. HALFPI) GO TO 230
         IF (IPEMSG .EQ. 0) WRITE (IPELUN,2020)
 2020    FORMAT (/' ERROR PJ16SP'/
     .            ' INPUT DATA ERROR')
         IERR = 164
         RETURN
  230    CON = ABS (GEOG(2)) - HALFPI
         IF (ABS (CON) .GT. EPSLN) GO TO 240
         GEOG(1) = LON0
         CRDIO(1) = GEOG(1)
         CRDIO(2) = GEOG(2)
         RETURN
  240    GEOG(1) = ADJLSP (LON0 + X / (A * COS (GEOG(2))))
         CRDIO(1) = GEOG(1)
         CRDIO(2) = GEOG(2)
         RETURN
      END IF
C
      END

C
C $Id: mpseti.f,v 1.18 2008-09-18 00:42:18 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MPSETI (WHCH,IVAL)
        CHARACTER*(*) WHCH
        INTEGER       IVAL
        IF (ICFELL('MPSETI - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
        CALL MDSETI (WHCH,IVAL)
        IF (ICFELL('MPSETI',2).NE.0) RETURN
        RETURN
      END

C
C	$Id: plgcls.f,v 1.4 2008-07-27 12:23:44 haley Exp $
C                                                                      
C			     Copyright (C)  1997
C	     University Corporation for Atmospheric Research
C			     All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C

      SUBROUTINE PLGCLS(WHICH, IOS, STATUS)
C
C  Process the PLOYGON keywords.
C
C
C  INPUT
C       WHICH   --  the encoded path flags.
C
C  OUTPUT
C       IOS     --  I/O status flag.  This flag is valid only
C                   if STATUS indicates an error.
C       STATUS  --  The error status as defined in COMMON CAPERR.
C
C
      COMMON /PARTB1/ PART1, KEYSEP, KEYTER, FRMCOM
      COMMON /PARTB2/ PART2, PART3, PART4, PART5, CTSTR, CTLOC
C
C  THE NUMBER OF WORDS IN THE SEARCH PATH MUST BE BIG ENOUGH TO HOLD
C       THE NUMBER OF BITS PER PATH TIMES THE NUMBER OF LEVELS
C
      INTEGER WHSIZE
      PARAMETER (WHSIZE=20)
C
      INTEGER PARTSZ, OTHSZ, NTABLE
      PARAMETER(PARTSZ=3000, OTHSZ=150, NTABLE=50)
      CHARACTER*1 KEYSEP,KEYTER
      CHARACTER*1 FRMCOM(2)
      INTEGER PART2(OTHSZ), PART3(OTHSZ), PART4(NTABLE), PART5(NTABLE*2)
      CHARACTER*1 PART1(PARTSZ)
      INTEGER CTSTR, CTLOC
      COMMON /CAPERR/ ALLOK, EOFFL, INTERR, MAXINT, PLBERR, PMBERR,
     1                FABERR, TXBERR, FLTERR, MAXFLT, NOTINT, SIZERR,
     2                UNDASC, DEVERR, DOCERR, TBLERR , STSZER, ENTERR,
     3                TABERR, TABSER, PRSFIL
      INTEGER ALLOK, EOFFL, INTERR, MAXINT, PLBERR, PMBERR,
     1        FABERR, TXBERR, FLTERR, MAXFLT, NOTINT, SIZERR, UNDASC,
     2        DEVERR, DOCERR, STSZER, ENTERR, TABERR, TABSER, TBLERR,
     3        PRSFIL
      COMMON /CAPPLG/ PCSSTR, PCSSIZ, PCTSTR, PCTSIZ, PLSSTR,
     1                PLSSIZ, PLTSTR, PLTSIZ, PBSSTR, PBSSIZ,
     2                PBTSTR, PBTSIZ, PHATSP, PMAXPT, PPSSTR,
     3                PPSSIZ, PPTSTR, PPTSIZ, PLGSIM, PSIMSP,
     4                PSIMTR
      INTEGER         PCSMAX, PCTMAX, PLSMAX, PLTMAX, PBSMAX,
     1                PBTMAX, PPSMAX, PPTMAX
      PARAMETER   (PCSMAX=20, PCTMAX=15, PLSMAX=40, PLTMAX=20)
      PARAMETER   (PBSMAX=30, PBTMAX=15, PPSMAX=20, PPTMAX=20)
      INTEGER         PCSSTR(PCSMAX), PCSSIZ, PCTSTR(PCTMAX), PCTSIZ,
     1                PLSSTR(PLSMAX), PLSSIZ, PLTSTR(PLTMAX), PLTSIZ,
     2                PBSSTR(PBSMAX), PBSSIZ, PBTSTR(PBTMAX), PBTSIZ,
     3                PHATSP, PMAXPT, PPSSTR(PPSMAX), PPSSIZ,
     4                PPTSTR(PPTMAX), PPTSIZ, PSIMSP, PSIMTR
      LOGICAL         PLGSIM
      INTEGER         LENPLG
      PARAMETER   (LENPLG=PCSMAX+1+PCTMAX+1+PLSMAX+1+PLTMAX+1+
     1                    PBSMAX+1+PBTMAX+1+1+1+PPSMAX+1+PPTMAX+
     2                    1+1+1+1)
C
      INTEGER WHICH(WHSIZE), IOS, STATUS
      INTEGER ROW2, ROW3, ROW4
C
C  Branch to the proper level 2 processing.
C
      ROW2 = WHICH(2)
      ROW3 = WHICH(3)
      ROW4 = WHICH(4)
C
C  POLYGON class processing.
C
C  ROW2   ROW3  ROW4  Keyword
C  ----   ----  ----  ---------------------------------------
C   1     1     1    POLYGON_COLOR_INSTRUCTION_START
C   1     1     2    POLYGON_COLOR_INSTRUCTION_TERMINATOR
C   3     1          POLYGON_INSTRUCTION_START
C   3     2          POLYGON_INSTRUCTION_TERMINATOR
C   4                POLYGON_SIMULATE
C   5     1     1    POLYGON_BACKGROUND_COLOR_INSTRUCTION_START
C   5     1     2    POLYGON_BACKGROUND_COLOR_INSTRUCTION_TERMINATOR
C   6     1          POLYGON_POINT_START
C   6     2          POLYGON_POINT_TERMINATOR
C   8                POLYGON_SIMULATION_SPACING
C   9                POLYGON_SIMULATION_TRUNCATION
C  10                POLYGON_MAXIMUM_POINTS
C  11                POLYGON_HATCH_SPACING
C
C
      IF (ROW2.EQ.1 .AND. ROW3.EQ.1) THEN
        IF (ROW4 .EQ. 1) THEN
                CALL GTSTR(PCSSTR, PCSMAX, PCSSIZ, IOS, STATUS)
        ELSE IF (ROW4 .EQ. 2) THEN
                CALL GTSTR(PCTSTR, PCTMAX, PCTSIZ, IOS, STATUS)
        END IF
      ELSE IF (ROW2.EQ.3 .AND. ROW3.EQ.1) THEN
                CALL GTSTR(PLSSTR, PLSMAX, PLSSIZ, IOS, STATUS)
      ELSE IF (ROW2.EQ.3 .AND. ROW3.EQ.2) THEN
                CALL GTSTR(PLTSTR, PLTMAX, PLTSIZ, IOS, STATUS)
      ELSE IF (ROW2.EQ.4) THEN
                CALL GTLOG(PLGSIM, 1, DUMMY, IOS, STATUS)
      ELSE IF (ROW2.EQ.5 .AND. ROW3.EQ.1) THEN
        IF (ROW4 .EQ. 1) THEN
                CALL GTSTR(PBSSTR, PBSMAX, PBSSIZ, IOS, STATUS)
        ELSE IF (ROW4 .EQ. 2) THEN
                CALL GTSTR(PBTSTR, PBTMAX, PBTSIZ, IOS, STATUS)
        END IF
      ELSE IF (ROW2.EQ.6 .AND. ROW3.EQ.1) THEN
                CALL GTSTR(PPSSTR, PPSMAX, PPSSIZ, IOS, STATUS)
      ELSE IF (ROW2.EQ.6 .AND. ROW3.EQ.2) THEN
                CALL GTSTR(PPTSTR, PPTMAX, PPTSIZ, IOS, STATUS)
      ELSE IF (ROW2.EQ.8) THEN
                CALL GTINT(PSIMSP, 1, DUMMY, IOS, STATUS)
      ELSE IF (ROW2.EQ.9) THEN
                CALL GTINT(PSIMTR, 1, DUMMY, IOS, STATUS)
      ELSE IF (ROW2.EQ.10) THEN
                CALL GTINT(PMAXPT, 1, DUMMY, IOS, STATUS)
      ELSE IF (ROW2.EQ.11) THEN
                CALL GTINT(PHATSP, 1, DUMMY, IOS, STATUS)
      END IF
C
      RETURN
      END

C
C	$Id: gsfais.f,v 1.5 2008-07-27 00:21:02 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GSFAIS (INTS)
C
C  SET FILL AREA INTERIOR STYLE
C
      INTEGER ESFAIS
      PARAMETER (ESFAIS=36)
C
      include 'gkscom.h'
C
      INTEGER INTS
C
C  Check if GKS is in the proper state.
C
      CALL GZCKST(8,ESFAIS,IER)
      IF (IER .NE. 0) RETURN
C
C  Check that INTS is in range.  Range extended 10/2013 in support of 
C  Jira1667.
C
      IF (INTS.LT.0 .OR. INTS.GT.4) THEN
        ERS = 1
        CALL GERHND(2000,ESFAIS,ERF)
        ERS = 0
        RETURN
      ENDIF
C
C  Set the current index in the GKS state list.
C
      CFAIS = INTS
C
C  Invoke the workstation interface.
C
      FCODE = 38
      CONT  = 0
      CALL GZROI(0)
      IL1   = 1
      IL2   = 1
      ID(1) = INTS
      CALL GZTOWK
      IF (RERR .NE. 0) THEN
        ERS = 1
        CALL GERHND(RERR,ESFAIS,ERF)
        ERS = 0
      ENDIF
C
      RETURN
      END

C
C	$Id: msceez.f,v 1.4 2008-07-27 00:17:30 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MSCEEZ (DEL1,DEL2,SIGMA,C1,C2,C3,N)
C
C ---------------------------------------------------------------------
C Note:  This routine comes from a proprietary package called FITPACK.
C It is used in the NCAR graphics package by permission of the author,
C Alan Cline.
C ---------------------------------------------------------------------
C
C                                            CODED BY ALAN KAYLOR CLINE
C                                         FROM FITPACK -- JUNE 22, 1986
C                                   A CURVE AND SURFACE FITTING PACKAGE
C                                 A PRODUCT OF PLEASANT VALLEY SOFTWARE
C                             8603 ALTUS COVE, AUSTIN, TEXAS 78759, USA
C
C ---------------------------------------------------------------------
C
C THIS SUBROUTINE DETERMINES THE COEFFICIENTS C1, C2, AND C3
C USED TO DETERMINE ENDPOINT SLOPES. SPECIFICALLY, IF
C FUNCTION VALUES Y1, Y2, AND Y3 ARE GIVEN AT POINTS X1, X2,
C AND X3, RESPECTIVELY, THE QUANTITY C1*Y1 + C2*Y2 + C3*Y3
C IS THE VALUE OF THE DERIVATIVE AT X1 OF A SPLINE UNDER
C TENSION (WITH TENSION FACTOR SIGMA) PASSING THROUGH THE
C THREE POINTS AND HAVING THIRD DERIVATIVE EQUAL TO ZERO AT
C X1. OPTIONALLY, ONLY TWO VALUES, C1 AND C2 ARE DETERMINED.
C
C ON INPUT--
C
C   DEL1 IS X2-X1 (.GT. 0.).
C
C   DEL2 IS X3-X1 (.GT. 0.). IF N .EQ. 2, THIS PARAMETER IS
C   IGNORED.
C
C   SIGMA IS THE TENSION FACTOR.
C
C   N IS A SWITCH INDICATING THE NUMBER OF COEFFICIENTS TO
C   BE RETURNED. IF N .EQ. 2 ONLY TWO COEFFICIENTS ARE
C   RETURNED. OTHERWISE ALL THREE ARE RETURNED.
C
C ON OUTPUT--
C
C   C1, C2, AND C3 CONTAIN THE COEFFICIENTS.
C
C NONE OF THE INPUT PARAMETERS ARE ALTERED.
C
C THIS SUBROUTINE REFERENCES PACKAGE MODULE MSSHCH.
C
C-----------------------------------------------------------
C
      IF (N .EQ. 2) GO TO 2
      IF (SIGMA .NE. 0.) GO TO 1
      DEL = DEL2-DEL1
C
C TENSION .EQ. 0.
C
      C1 = -(DEL1+DEL2)/(DEL1*DEL2)
      C2 = DEL2/(DEL1*DEL)
      C3 = -DEL1/(DEL2*DEL)
      RETURN
C
C TENSION .NE. 0.
C
    1 CALL MSSHCH (DUMMY,COSHM1,SIGMA*DEL1,1)
      CALL MSSHCH (DUMMY,COSHM2,SIGMA*DEL2,1)
      DELP = SIGMA*(DEL2+DEL1)/2.
      DELM = SIGMA*(DEL2-DEL1)/2.
      CALL MSSHCH (SINHMP,DUMMY,DELP,-1)
      CALL MSSHCH (SINHMM,DUMMY,DELM,-1)
      DENOM = COSHM1*(DEL2-DEL1)-2.*DEL1*DELP*DELM*
     *        (1.+SINHMP)*(1.+SINHMM)
      C1 = 2.*DELP*DELM*(1.+SINHMP)*(1.+SINHMM)/DENOM
      C2 = -COSHM2/DENOM
      C3 = COSHM1/DENOM
      RETURN
C
C TWO COEFFICIENTS
C
    2 C1 = -1./DEL1
      C2 = -C1
      RETURN
      END

      DOUBLE PRECISION FUNCTION DNRM2 ( N, X, INCX )
*     .. Scalar Arguments ..
      INTEGER                           INCX, N
*     .. Array Arguments ..
      DOUBLE PRECISION                  X( * )
*     ..
*
*  DNRM2 returns the euclidean norm of a vector via the function
*  name, so that
*
*     DNRM2 := sqrt( x'*x )
*
*
*
*  -- This version written on 25-October-1982.
*     Modified on 14-October-1993 to inline the call to DLASSQ.
*     Sven Hammarling, Nag Ltd.
*
*
*     .. Parameters ..
      DOUBLE PRECISION      ONE         , ZERO
      PARAMETER           ( ONE = 1.0D+0, ZERO = 0.0D+0 )
*     .. Local Scalars ..
      INTEGER               IX
      DOUBLE PRECISION      ABSXI, NORM, SCALE, SSQ
*     .. Intrinsic Functions ..
      INTRINSIC             ABS, SQRT
*     ..
*     .. Executable Statements ..
      IF( N.LT.1 .OR. INCX.LT.1 )THEN
         NORM  = ZERO
      ELSE IF( N.EQ.1 )THEN
         NORM  = ABS( X( 1 ) )
      ELSE
         SCALE = ZERO
         SSQ   = ONE
*        The following loop is equivalent to this call to the LAPACK
*        auxiliary routine:
*        CALL DLASSQ( N, X, INCX, SCALE, SSQ )
*
         DO 10, IX = 1, 1 + ( N - 1 )*INCX, INCX
            IF( X( IX ).NE.ZERO )THEN
               ABSXI = ABS( X( IX ) )
               IF( SCALE.LT.ABSXI )THEN
                  SSQ   = ONE   + SSQ*( SCALE/ABSXI )**2
                  SCALE = ABSXI
               ELSE
                  SSQ   = SSQ   +     ( ABSXI/SCALE )**2
               END IF
            END IF
   10    CONTINUE
         NORM  = SCALE * SQRT( SSQ )
      END IF
*
      DNRM2 = NORM
      RETURN
*
*     End of DNRM2.
*
      END

C NCLFORTSTART
      subroutine thorn2(t,ntim,tmsg,lat,etp,ier)
      implicit none
C                                        INPUT
      integer ntim, ier
      double precision t(ntim), lat, tmsg
C                                        OUTPUT
      double precision etp(ntim)
C NCLEND
C --------------------------------------------------------------------
C Computation of evapotranspiration using the method of Thornthwaite
C --------------------------------------------------------------------
C                       This allows missing values 
C --------------------------------------------------------------------
C Original C-code: http://sac.csic.es/spei/spei_index.html
C --------------------------------------------------------------------
C                                        LOCAL
      integer          nt, nmo, nmos, nyrs, knt
      double precision J, J2, J3, c, N, K(12), pi, rad, tmo
      double precision tanlat, tanLatMonth, omega
     +              ,  tanDelta(12), days(12), julian(12)

      data days     /  31,28,31,30,31,30,31,31,30,31,30,31/
      data julian   /  16, 45.5, 75  ,105.5,136  ,166.5
     +              , 197,228  ,258.5,289  ,319.5,350  /
      data pi       /3.14159265358979d0/
      data rad      /0.0174532925d0/

C  average solar declination angle for each month of the year

      data tanDelta / -0.37012566,-0.23853358,-0.04679872, 0.16321764

     +              ,  0.32930908, 0.40677729, 0.3747741 , 0.239063
     +              ,  0.04044485,-0.16905776,-0.33306377,-0.40743608 /

      nmos = 12
      nyrs = ntim/nmos

      do nt=1,ntim
         etp(nt) = tmsg   
      end do

      ier  = 0
      if (mod(ntim,nyrs).ne.0) then
          ier = 1
          return
      end if

c calculate climatological monthly temperatures and use these
c .   to calculate a climatological annual temp. efficiency index (J)

      J   = 0.0d0
      do nmo=1,nmos
         knt = 0
         tmo = 0.0d0
c                               ! every 12-th value (eg: all Januaries)
        do nt=nmo,ntim,nmos  
           if (t(nt).ne.tmsg) then
               tmo = tmo + t(nt)
               knt = knt + 1
           end if
        end do
c                               ! monthly climatology
         if (knt.gt.0) then
             tmo = tmo/knt
             if (tmo.gt.0.0d0) J = J + (tmo/5d0)**1.514
         end if
      end do
c                               ! if J=0 ... nothing else matters
      if (J.eq.0.0d0) then
          do nt=1,ntim
             if (t(nt).ne.tmsg) then
                 etp(nt) = 0.0d0   
             end if
          end do
          return
      end if

C Compute exponent (c)

      J2 = J*J
      J3 = J*J2
      c  = 0.000000675d0*J3 - 0.0000771d0*J2 + 0.01792d0*J + 0.49239d0

C Compute K: monthly correction factor which is a function of latitude

       tanLat = tan(rad*lat)
       do nmo=1,nmos
          tanLatMonth = tanLat*tanDelta(nmo) 
          if (tanLatMonth.gt.-1.0d0 .and. tanLatMonth.lt.1.0d0) then
              omega = acos(-tanLatMonth)
          elseif (tanLatMonth.le.-1.0d0) then
               omega = 0
          else
               omega = pi
          end if
          N = 24d0*omega/pi    !  monthly average number of sun hours
          K(nmo) = (N/12d0)*days(nmo)/30d0
       end do

C Calculate evapotranspiration

        do nmo=1,nmos
          do nt=nmo,ntim,nmos
             if (t(nt).ne.tmsg) then
                 if (t(nt).gt.0.0d0) then
                     etp(nt) = K(nmo)*16*((10*t(nt)/J))**c 
                 else
                     etp(nt) = 0.0d0
                 end if
             end if
          end do
        end do
        
      end

C
C $Id: mdpitd.f,v 1.9 2008-09-18 00:42:17 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MDPITD (XLAT,XLON,IFST)
C
        DOUBLE PRECISION XLAT,XLON
        INTEGER          IFST
C
C Declare required common blocks.  See MAPBDX for descriptions of these
C common blocks and the variables in them.
C
        COMMON /MAPCM0/  COS1,DTOR,DTRH,OOPI,PI,PIOF,PIOT,RTDD,RTOD,
     +                   SROT,SIN1,TOPI,TSRT
        DOUBLE PRECISION COS1,DTOR,DTRH,OOPI,PI,PIOF,PIOT,RTDD,RTOD,
     +                   SROT,SIN1,TOPI,TSRT
        SAVE   /MAPCM0/
C
        COMMON /MAPCM1/  COSO,COSR,SINO,SINR,IPRJ,IROD
        DOUBLE PRECISION COSO,COSR,SINO,SINR
        INTEGER          IPRJ,IROD
        SAVE   /MAPCM1/
C
        COMMON /MAPCM2/  BLAM,BLOM,PEPS,SLAM,SLOM,UCEN,UMAX,UMIN,UOFF,
     +                   URNG,VCEN,VMAX,VMIN,VOFF,VRNG,ISSL
        DOUBLE PRECISION BLAM,BLOM,PEPS,SLAM,SLOM,UCEN,UMAX,UMIN,UOFF,
     +                   URNG,VCEN,VMAX,VMIN,VOFF,VRNG
        INTEGER          ISSL
        SAVE   /MAPCM2/
C
        COMMON /MAPCM4/  GRDR,GRID,GRLA,GRLO,GRPO,OTOL,PDRE,PLA1,PLA2,
     +                   PLA3,PLA4,PLB1,PLB2,PLB3,PLB4,PLNO,PLTO,ROTA,
     +                   SRCH,XLOW,XROW,YBOW,YTOW,IDOT,IDSH,IDTL,ILCW,
     +                   ILTS,JPRJ,ELPF,INTF,LBLF,PRMF
        DOUBLE PRECISION GRDR,GRID,GRLA,GRLO,GRPO,OTOL,PDRE,PLA1,PLA2,
     +                   PLA3,PLA4,PLB1,PLB2,PLB3,PLB4,PLNO,PLTO,ROTA,
     +                   SRCH,XLOW,XROW,YBOW,YTOW
        INTEGER          IDOT,IDSH,IDTL,ILCW,ILTS,JPRJ
        LOGICAL          ELPF,INTF,LBLF,PRMF
        SAVE   /MAPCM4/
C
        COMMON /MAPCM8/  P,Q,R
        DOUBLE PRECISION P,Q,R
        SAVE   /MAPCM8/
C
        COMMON /MAPCMA/  DATL,DBTD,DDTS,DPLT,DPSQ,DSCA,DSSQ
        DOUBLE PRECISION DATL,DBTD,DDTS,DPLT,DPSQ,DSCA,DSSQ
        SAVE   /MAPCMA/
C
        COMMON /USGSC1/  UTPA(15),UUMN,UUMX,UVMN,UVMX,IPRF
        DOUBLE PRECISION UTPA,UUMN,UUMX,UVMN,UVMX
        INTEGER          IPRF
        SAVE   /USGSC1/
C
C Declare local variables.
C
        DOUBLE PRECISION APTX,CPLN,CPLT,CXLN,CXLT,DTST,PAPE,PNEW,POLD,
     +                   RLAT,RLATI(100),RLNE,RLNO,RLON,RLONI(100),RLTE,
     +                   RLTO,RMLO,RMUL,SPLN,SPLT,SXLN,SXLT,UCOE,UNEW,
     +                   UOLD,VCOE,VNEW,VOLD,XLNO,XLTO
C
        INTEGER          IOPI,IVIS,IVSO,NOPI
C
        SAVE             IVSO,POLD,RLNO,RLTO,RMLO,UOLD,VOLD,XLNO,XLTO
C
        DATA IVSO,POLD,RLNO,RLTO,RMLO,UOLD,VOLD,XLNO,XLTO / 0,8*0.D0 /
C
C Check for an uncleared prior error.
C
        IF (ICFELL('MDPITD - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C If EZMAP needs initialization, do it.
C
        IF (INTF) THEN
          CALL MDPINT
          IF (ICFELL('MDPITD',2).NE.0) RETURN
        END IF
C
C Initialize the variables that control interpolation.
C
        IOPI=0
        NOPI=0
C
C If the projection is one of those in which great distortion occurs at
C points opposite the pole, see if some points need to be interpolated.
C
C Note that I originally did this for four different projections, but it
C really needs to be done only for the Lambert Equal-Area and Azimuthal
C Equidistant projections, as these are the only two that are sometimes
C used to show the entire globe.  When I added the USGS projections, I
C did not bother to provide interpolation for the other two projections
C (the Gnomonic and the Stereographic), but I also did not remove the
C interpolation that was being done for the forms of these projections
C that we already had (03/11/99).
C
        IF ((IPRJ.EQ.0.AND.(IPRF.EQ. 3.OR.IPRF.EQ. 8.OR.
     +                      IPRF.EQ.11.OR.IPRF.EQ.12)).OR.
     +      IPRJ.EQ.2.OR.IPRJ.EQ.4.OR.IPRJ.EQ.5.OR.IPRJ.EQ.6) THEN
          IF (IPRJ.EQ.0) THEN
            IF (IPRF.EQ.3.OR.IPRF.EQ.8) THEN
              CPLT=0.D0
              SPLT=1.D0
              CPLN=1.D0
              SPLN=0.D0
              IF (IPRF.EQ.8.AND.UTPA(9).EQ.0.D0) THEN
                DTST=UTPA(3)
              ELSE
                DTST=.5D0*UTPA(3)+UTPA(4)
              END IF
              IF (DTST.GT.0.D0) THEN
                DTST=90.D0-DTST
              ELSE
                SPLT=-SPLT
                DTST=DTST+90.D0
              END IF
            ELSE
              CPLT=COS(DTOR*UTPA(6))
              SPLT=SIN(DTOR*UTPA(6))
              CPLN=COS(DTOR*UTPA(5))
              SPLN=SIN(DTOR*UTPA(5))
            END IF
          ELSE
            CPLT=COS(DTOR*PLTO)
            SPLT=SIN(DTOR*PLTO)
            CPLN=COS(DTOR*PLNO)
            SPLN=SIN(DTOR*PLNO)
          END IF
          CXLT=COS(DTOR*XLAT)
          SXLT=SIN(DTOR*XLAT)
          CXLN=COS(DTOR*XLON)
          SXLN=SIN(DTOR*XLON)
          APTX=2.D0*RTOD*ASIN(SQRT((CXLT*CXLN-CPLT*CPLN)**2+
     +                             (CXLT*SXLN-CPLT*SPLN)**2+
     +                             (SXLT     -SPLT     )**2)/2.D0)
          IF (IPRJ.EQ.0.AND.(IPRF.EQ.3.OR.IPRF.EQ.8)) THEN
            IF (APTX.LE.DTST) THEN
              RMUL=MAX(1.D0,MIN(51.D0,51.D0*((DTST-APTX)/DTST)**8))
            ELSE
              RMUL=MAX(1.D0,MIN(51.D0,51.D0*((APTX-DTST)/
     +                                          (180.D0-DTST))**8))
            END IF
          ELSE IF (IPRJ.EQ.2) THEN
            IF (APTX.LE.179.999D0) THEN
              RMUL=MIN(101.D0,1.D0/(1.D0+COS(DTOR*APTX)))
            ELSE
              RMUL=101.D0
            END IF
          ELSE IF ((IPRJ.EQ.0.AND.IPRF.EQ.11).OR.IPRJ.EQ.4) THEN
            IF (APTX.LE.179.999D0) THEN
              RMUL=MIN(101.D0,2.D0/SQRT(2.D0*(1.D0+COS(DTOR*APTX))))
            ELSE
              RMUL=101.D0
            END IF
          ELSE IF (IPRJ.EQ.5) THEN
            IF (APTX.LT.89.999D0) THEN
              RMUL=MIN(21.D0,1.D0/COS(DTOR*APTX))
            ELSE
              RMUL=21.D0
            END IF
          ELSE IF ((IPRJ.EQ.0.AND.IPRF.EQ.12).OR.IPRJ.EQ.6) THEN
            IF (APTX.LE..00001D0) THEN
              RMUL=1.D0
            ELSE IF (APTX.LT.179.999D0) THEN
              RMUL=MIN(101.D0,DTOR*APTX/SIN(DTOR*APTX))
            ELSE
              RMUL=101.D0
            END IF
          END IF
          IF (IFST.NE.0) THEN
            NOPI=MAX(0,MIN(50,INT(MAX(RMLO,RMUL))/2))
            IF (NOPI.NE.0)
     +                CALL MDPGCI (XLTO,XLNO,XLAT,XLON,NOPI,RLATI,RLONI)
          END IF
          XLTO=XLAT
          XLNO=XLON
          RMLO=RMUL
        END IF
C
C Return here for the next interpolated point.
C
  101   IF (IOPI.LT.NOPI) THEN
          IOPI=IOPI+1
          RLAT=RLATI(IOPI)
          RLON=RLONI(IOPI)
        ELSE
          IOPI=IOPI+1
          RLAT=XLAT
          RLON=XLON
        END IF
C
C Project the point (RLAT,RLON) to (UNEW,VNEW), using the routine
C MDPTRA, which returns 1.D12 for UNEW and VNEW in areas outside the
C perimeter and on the "wrong" side of a limb line.  Also save PNEW
C for "crossover" testing.
C
        CALL MDPTRA (RLAT,RLON,UNEW,VNEW)
        IF (ICFELL('MDPITD',3).NE.0) RETURN
        PNEW=P
C
C If the new point is invisible, we only have to draw something if it's
C not a first point and the last point was visible, in which case we
C interpolate to find a point at the edge of the visible area and then
C extend the line we're drawing to that point.  In any case, we jump to
C save information about the new point and get another.
C
        IF (UNEW.GE.1.D12) THEN
          IVIS=0
          IF (IFST.NE.0.AND.IVSO.NE.0) THEN
            CALL MDITVE (RLTO,RLNO,POLD,UOLD,VOLD,
     +                   RLAT,RLON,PNEW,UNEW,VNEW,
     +                   RLTE,RLNE,PAPE,UCOE,VCOE)
            IF (ICFELL('MDPITD',4).NE.0) RETURN
            CALL MDPVPD (UOLD,VOLD,UCOE,VCOE)
            IF (ICFELL('MDPITD',5).NE.0) RETURN
          END IF
          GO TO 103
        END IF
C
C Otherwise, the new point is visible; things get more complicated.
C
        IVIS=1
C
C If the new point is a first point, initialize a new set of line draws,
C then jump to save information about the new point and get another.
C
        IF (IFST.EQ.0) THEN
          IF (IDTL.EQ.0) THEN
            CALL DPFRST (REAL(UNEW),REAL(VNEW))
            IF (ICFELL('MDPITD',6).NE.0) RETURN
          ELSE
            DATL=0.D0
          END IF
          GO TO 103
        END IF
C
C Otherwise, the new point is visible and it's not a first point; if the
C last point was invisible, find a point at the edge of the visible area
C and start a new set of line draws there.
C
        IF (IVSO.EQ.0) THEN
          CALL MDITVE (RLAT,RLON,PNEW,UNEW,VNEW,
     +                 RLTO,RLNO,POLD,UOLD,VOLD,
     +                 RLTO,RLNO,POLD,UOLD,VOLD)
          IF (ICFELL('MDPITD',7).NE.0) RETURN
          IVSO=1
          IF (IDTL.EQ.0) THEN
            CALL DPFRST (REAL(UOLD),REAL(VOLD))
            IF (ICFELL('MDPITD',8).NE.0) RETURN
          ELSE
            DATL=0.D0
          END IF
        END IF
C
C The new point is visible; so was the old one.  If the projection type
C is one of those for which "crossover" is not possible, just jump to
C extend the line to the new point.
C
        IF (IPRJ.GE.2.AND.IPRJ.LE.6) GO TO 102
C
        IF (IPRJ.EQ.0.AND.(IPRF.EQ. 6.OR.IPRF.EQ.10.OR.IPRF.EQ.11.OR.
     +                     IPRF.EQ.12.OR.IPRF.EQ.13.OR.IPRF.EQ.14.OR.
     +                     IPRF.EQ.15.OR.IPRF.EQ.23)) GO TO 102
C
C Test for "crossover"; if it has not occurred, jump to extend the line.
C
        IF (ABS(PNEW-POLD).LT.PEPS) GO TO 102
C
C The new and old points are both visible and "crossover" has occurred.
C We must extend the line to one edge of the map and restart it at the
C other edge.
C
        CALL MDITVE (RLTO,RLNO,POLD,UOLD,VOLD,
     +               RLAT,RLON,PNEW,UNEW,VNEW,
     +               RLTE,RLNE,PAPE,UCOE,VCOE)
        IF (ICFELL('MDPITD',9).NE.0) RETURN
        CALL MDPVPD (UOLD,VOLD,UCOE,VCOE)
        IF (ICFELL('MDPITD',10).NE.0) RETURN
C
        CALL MDITVE (RLAT,RLON,PNEW,UNEW,VNEW,
     +               RLTO,RLNO,POLD,UOLD,VOLD,
     +               RLTO,RLNO,POLD,UOLD,VOLD)
        IF (ICFELL('MDPITD',11).NE.0) RETURN
C
C Start a new series of line draws with the old point.
C
        IVSO=1
        IF (IDTL.EQ.0) THEN
          CALL DPFRST (REAL(UOLD),REAL(VOLD))
          IF (ICFELL('MDPITD',12).NE.0) RETURN
        ELSE
          DATL=0.D0
        END IF
C
C Continue the line to the new point.  If it's too close to the old
C point and output of it isn't forced, skip it.
C
  102   IF ((IOPI.LE.NOPI.OR.IFST.LT.2).AND.
     +      ((UNEW-UOLD)**2+(VNEW-VOLD)**2)*DSSQ.LE.DPSQ)GO TO 104
        CALL MDPVPD (UOLD,VOLD,UNEW,VNEW)
        IF (ICFELL('MDPITD',13).NE.0) RETURN
C
C Save information about the current point for the next call.
C
  103   IVSO=IVIS
        RLTO=RLAT
        RLNO=RLON
        POLD=PNEW
        UOLD=UNEW
        VOLD=VNEW
C
C If interpolation is taking place, loop back for the next point.
C
  104   IF (IOPI.LE.NOPI) GO TO 101
C
C Done.
C
        RETURN
C
      END

      PROGRAM CCPCFF
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER (M=40,N=40,LRWK=3500,LIWK=4000)
      REAL Z(M,N), RWRK(LRWK)
      INTEGER IWRK(LIWK)
      
      CALL GETDAT (Z, M, N)
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
      CALL GSCLIP (0)
C
C Initialize Conpack
C
      CALL CPRECT(Z, M, M, N, RWRK, LRWK, IWRK, LIWK)
      CALL CPGETI('CFF - CONSTANT FIELD FOUND FLAG',ICFF)
      IF (ICFF .NE. 0) GOTO 101
C
C Draw Perimeter
C
      CALL CPBACK(Z, RWRK, IWRK)
C
C Draw Contours
C
      CALL CPLBDR(Z,RWRK,IWRK)
      CALL CPCLDR(Z,RWRK,IWRK)
C     
C Close frame and close GKS
C
      CALL FRAME
C
C Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      STOP
      
 101  WRITE (6,*) 'The field is constant.'
      WRITE (6,*) 'This program does not create a valid CGM file.'
      
      STOP
      END
      
      SUBROUTINE GETDAT (Z, M, N)
      INTEGER I,J,M,N
      REAL Z(M,N)
      
      DO 10, I=1,M
         DO 20, J=1,N
            Z(I,J)=13.0
 20      CONTINUE
 10   CONTINUE
      
      RETURN
      END

      PROGRAM PGKEX19
C 
C  Getting a PostScript plot to fill an entire page.
C
C  Define error file, Fortran unit number, and workstation type,
C  and workstation ID.
C
      PARAMETER (IERRF=6, LUNIT=2, IWKID=1)
      CHARACTER*3 LAB
C
C  Open GKS.
C
      CALL GOPKS (IERRF,IDUM) 
C
C  Open and activate a color PostScript workstation.
C
      CALL GOPWK (IWKID, 2, NGPSWK('PS','PORTRAIT','COLOR'))
      CALL GACWK (IWKID) 
C
C  Draw three rows and four columns of square boxes.
C
      NUM = 0
      DO 10 J=1,3
        Y = 0.25*REAL(J-1)
        DO 20 I=1,4
          NUM = NUM+1
          WRITE(LAB,'(I3)') NUM
          X = 0.25*REAL(I-1)
          CALL BOX(X, Y, 0.25, LAB)
   20   CONTINUE
   10 CONTINUE
      CALL FRAME
C
C  Close things out.
C
      CALL GDAWK(IWKID)
      CALL GCLWK(IWKID)
      CALL GCLKS
C
      STOP
      END
      SUBROUTINE BOX(X,Y,SZ,LAB)
C
C  Draw a square box with lower left corner at (X,Y) and size SZ x SZ 
C  and put the label LAB in the center.
C
      CHARACTER*3 LAB
      DIMENSION A(5),B(5)
C
C  Draw box.
C
      A(1) = X
      B(1) = Y
      A(2) = X+SZ
      B(2) = Y
      A(3) = A(2)
      B(3) = Y+SZ
      A(4) = X
      B(4) = B(3)
      A(5) = X
      B(5) = Y
      CALL GPL(5,A,B)
C
C  Write label in box.
C
      CALL GSCHH(0.25*SZ)
      CALL GSTXAL(2,3)
      CALL GTX(X+.5*SZ, Y+.5*SZ, LAB)
C
      RETURN
      END

c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by ucar                 .
c  .                                                             .
c  .       university corporation for atmospheric research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                         SPHEREPACK                          .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c
c
c ... file vhaec.f
c
c     this file contains code and documentation for subroutines
c     vhaec and vhaeci
c
c ... files which must be loaded with vhaec.f
c
c     sphcom.f, hrfft.f
c
c
c     subroutine vhaec(nlat,nlon,ityp,nt,v,w,idvw,jdvw,br,bi,cr,ci,
c    +                 mdab,ndab,wvhaec,lvhaec,work,lwork,ierror)
c
c     subroutine vhaec performs the vector spherical harmonic analysis
c     on the vector field (v,w) and stores the result in the arrays
c     br, bi, cr, and ci. v(i,j) and w(i,j) are the colatitudinal
c     (measured from the north pole) and east longitudinal components
c     respectively, located at colatitude theta(i) = (i-1)*pi/(nlat-1)
c     and longitude phi(j) = (j-1)*2*pi/nlon. the spectral
c     representation of (v,w) is given at output parameters v,w in
c     subroutine vhsec.
c
c     input parameters
c
c     nlat   the number of colatitudes on the full sphere including the
c            poles. for example, nlat = 37 for a five degree grid.
c            nlat determines the grid increment in colatitude as
c            pi/(nlat-1).  if nlat is odd the equator is located at
c            grid point i=(nlat+1)/2. if nlat is even the equator is
c            located half way between points i=nlat/2 and i=nlat/2+1.
c            nlat must be at least 3. note: on the half sphere, the
c            number of grid points in the colatitudinal direction is
c            nlat/2 if nlat is even or (nlat+1)/2 if nlat is odd.
c
c     nlon   the number of distinct londitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater
c            than zero. the axisymmetric case corresponds to nlon=1.
c            the efficiency of the computation is improved when nlon
c            is a product of small prime numbers.
c
c     ityp   = 0  no symmetries exist about the equator. the analysis
c                 is performed on the entire sphere.  i.e. on the
c                 arrays v(i,j),w(i,j) for i=1,...,nlat and
c                 j=1,...,nlon.
c
c            = 1  no symmetries exist about the equator. the analysis
c                 is performed on the entire sphere.  i.e. on the
c                 arrays v(i,j),w(i,j) for i=1,...,nlat and
c                 j=1,...,nlon. the curl of (v,w) is zero. that is,
c                 (d/dtheta (sin(theta) w) - dv/dphi)/sin(theta) = 0.
c                 the coefficients cr and ci are zero.
c
c            = 2  no symmetries exist about the equator. the analysis
c                 is performed on the entire sphere.  i.e. on the
c                 arrays v(i,j),w(i,j) for i=1,...,nlat and
c                 j=1,...,nlon. the divergence of (v,w) is zero. i.e.,
c                 (d/dtheta (sin(theta) v) + dw/dphi)/sin(theta) = 0.
c                 the coefficients br and bi are zero.
c
c            = 3  v is symmetric and w is antisymmetric about the
c                 equator. the analysis is performed on the northern
c                 hemisphere only.  i.e., if nlat is odd the analysis
c                 is performed on the arrays v(i,j),w(i,j) for
c                 i=1,...,(nlat+1)/2 and j=1,...,nlon. if nlat is
c                 even the analysis is performed on the the arrays
c                 v(i,j),w(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
c
c            = 4  v is symmetric and w is antisymmetric about the
c                 equator. the analysis is performed on the northern
c                 hemisphere only.  i.e., if nlat is odd the analysis
c                 is performed on the arrays v(i,j),w(i,j) for
c                 i=1,...,(nlat+1)/2 and j=1,...,nlon. if nlat is
c                 even the analysis is performed on the the arrays
c                 v(i,j),w(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
c                 the curl of (v,w) is zero. that is,
c                 (d/dtheta (sin(theta) w) - dv/dphi)/sin(theta) = 0.
c                 the coefficients cr and ci are zero.
c
c            = 5  v is symmetric and w is antisymmetric about the
c                 equator. the analysis is performed on the northern
c                 hemisphere only.  i.e., if nlat is odd the analysis
c                 is performed on the arrays v(i,j),w(i,j) for
c                 i=1,...,(nlat+1)/2 and j=1,...,nlon. if nlat is
c                 even the analysis is performed on the the arrays
c                 v(i,j),w(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
c                 the divergence of (v,w) is zero. i.e.,
c                 (d/dtheta (sin(theta) v) + dw/dphi)/sin(theta) = 0.
c                 the coefficients br and bi are zero.
c
c            = 6  v is antisymmetric and w is symmetric about the
c                 equator. the analysis is performed on the northern
c                 hemisphere only.  i.e., if nlat is odd the analysis
c                 is performed on the arrays v(i,j),w(i,j) for
c                 i=1,...,(nlat+1)/2 and j=1,...,nlon. if nlat is
c                 even the analysis is performed on the the arrays
c                 v(i,j),w(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
c
c            = 7  v is antisymmetric and w is symmetric about the
c                 equator. the analysis is performed on the northern
c                 hemisphere only.  i.e., if nlat is odd the analysis
c                 is performed on the arrays v(i,j),w(i,j) for
c                 i=1,...,(nlat+1)/2 and j=1,...,nlon. if nlat is
c                 even the analysis is performed on the the arrays
c                 v(i,j),w(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
c                 the curl of (v,w) is zero. that is,
c                 (d/dtheta (sin(theta) w) - dv/dphi)/sin(theta) = 0.
c                 the coefficients cr and ci are zero.
c
c            = 8  v is antisymmetric and w is symmetric about the
c                 equator. the analysis is performed on the northern
c                 hemisphere only.  i.e., if nlat is odd the analysis
c                 is performed on the arrays v(i,j),w(i,j) for
c                 i=1,...,(nlat+1)/2 and j=1,...,nlon. if nlat is
c                 even the analysis is performed on the the arrays
c                 v(i,j),w(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
c                 the divergence of (v,w) is zero. i.e.,
c                 (d/dtheta (sin(theta) v) + dw/dphi)/sin(theta) = 0.
c                 the coefficients br and bi are zero.
c
c
c     nt     the number of analyses.  in the program that calls vhaec,
c            the arrays v,w,br,bi,cr, and ci can be three dimensional
c            in which case multiple analyses will be performed.
c            the third index is the analysis index which assumes the
c            values k=1,...,nt.  for a single analysis set nt=1. the
c            discription of the remaining parameters is simplified
c            by assuming that nt=1 or that all the arrays are two
c            dimensional.
c
c     v,w    two or three dimensional arrays (see input parameter nt)
c            that contain the vector function to be analyzed.
c            v is the colatitudnal component and w is the east
c            longitudinal component. v(i,j),w(i,j) contain the
c            components at colatitude theta(i) = (i-1)*pi/(nlat-1)
c            and longitude phi(j) = (j-1)*2*pi/nlon. the index ranges
c            are defined above at the input parameter ityp.
c
c     idvw   the first dimension of the arrays v,w as it appears in
c            the program that calls vhaec. if ityp .le. 2 then idvw
c            must be at least nlat.  if ityp .gt. 2 and nlat is
c            even then idvw must be at least nlat/2. if ityp .gt. 2
c            and nlat is odd then idvw must be at least (nlat+1)/2.
c
c     jdvw   the second dimension of the arrays v,w as it appears in
c            the program that calls vhaec. jdvw must be at least nlon.
c
c     mdab   the first dimension of the arrays br,bi,cr, and ci as it
c            appears in the program that calls vhaec. mdab must be at
c            least min0(nlat,nlon/2) if nlon is even or at least
c            min0(nlat,(nlon+1)/2) if nlon is odd.
c
c     ndab   the second dimension of the arrays br,bi,cr, and ci as it
c            appears in the program that calls vhaec. ndab must be at
c            least nlat.
c
c     wvhaec an array which must be initialized by subroutine vhaeci.
c            once initialized, wvhaec can be used repeatedly by vhaec
c            as long as nlon and nlat remain unchanged.  wvhaec must
c            not be altered between calls of vhaec.
c
c     lvhaec the dimension of the array wvhaec as it appears in the
c            program that calls vhaec. define
c
c               l1 = min0(nlat,nlon/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            then lvhaec must be at least
c
c            4*nlat*l2+3*max0(l1-2,0)*(nlat+nlat-l1-1)+nlon+15
c
c
c     work   a work array that does not have to be saved.
c
c     lwork  the dimension of the array work as it appears in the
c            program that calls vhaec. define
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            if ityp .le. 2 then lwork must be at least
c
c                    nlat*(2*nt*nlon+max0(6*l2,nlon))
c
c            if ityp .gt. 2 then lwork must be at least
c
c                    l2*(2*nt*nlon+max0(6*nlat,nlon))
c
c     **************************************************************
c
c     output parameters
c
c     br,bi  two or three dimensional arrays (see input parameter nt)
c     cr,ci  that contain the vector spherical harmonic coefficients
c            in the spectral representation of v(i,j) and w(i,j) given
c            in the discription of subroutine vhsec. br(mp1,np1),
c            bi(mp1,np1),cr(mp1,np1), and ci(mp1,np1) are computed
c            for mp1=1,...,mmax and np1=mp1,...,nlat except for np1=nlat
c            and odd mp1. mmax=min0(nlat,nlon/2) if nlon is even or
c            mmax=min0(nlat,(nlon+1)/2) if nlon is odd.
c
c     ierror = 0  no errors
c            = 1  error in the specification of nlat
c            = 2  error in the specification of nlon
c            = 3  error in the specification of ityp
c            = 4  error in the specification of nt
c            = 5  error in the specification of idvw
c            = 6  error in the specification of jdvw
c            = 7  error in the specification of mdab
c            = 8  error in the specification of ndab
c            = 9  error in the specification of lvhaec
c            = 10 error in the specification of lwork
c
c
c *******************************************************************
c
c     subroutine vhaeci(nlat,nlon,wvhaec,lvhaec,dwork,ldwork,ierror)
c
c     subroutine vhaeci initializes the array wvhaec which can then be
c     used repeatedly by subroutine vhaec until nlat or nlon is changed.
c
c     input parameters
c
c     nlat   the number of colatitudes on the full sphere including the
c            poles. for example, nlat = 37 for a five degree grid.
c            nlat determines the grid increment in colatitude as
c            pi/(nlat-1).  if nlat is odd the equator is located at
c            grid point i=(nlat+1)/2. if nlat is even the equator is
c            located half way between points i=nlat/2 and i=nlat/2+1.
c            nlat must be at least 3. note: on the half sphere, the
c            number of grid points in the colatitudinal direction is
c            nlat/2 if nlat is even or (nlat+1)/2 if nlat is odd.
c
c     nlon   the number of distinct londitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater
c            than zero. the axisymmetric case corresponds to nlon=1.
c            the efficiency of the computation is improved when nlon
c            is a product of small prime numbers.
c
c     lvhaec the dimension of the array wvhaec as it appears in the
c            program that calls vhaec. define
c
c               l1 = min0(nlat,nlon/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            then lvhaec must be at least
c
c            4*nlat*l2+3*max0(l1-2,0)*(nlat+nlat-l1-1)+nlon+15
c
c
C*PL*ERROR* Comment line too long
c     dwork  a double precision work array that does not have to be saved.
c
c     ldwork the dimension of the array dwork as it appears in the
c            program that calls vhaec. ldwork must be at least
c            2*(nlat+2)
c
c
c     **************************************************************
c
c     output parameters
c
c     wvhaec an array which is initialized for use by subroutine vhaec.
c            once initialized, wvhaec can be used repeatedly by vhaec
c            as long as nlat or nlon remain unchanged.  wvhaec must not
c            be altered between calls of vhaec.
c
c
c     ierror = 0  no errors
c            = 1  error in the specification of nlat
c            = 2  error in the specification of nlon
c            = 3  error in the specification of lvhaec
c            = 4  error in the specification of ldwork
c
c
c **********************************************************************
      SUBROUTINE DVHAEC(NLAT,NLON,ITYP,NT,V,W,IDVW,JDVW,BR,BI,CR,CI,
     +                  MDAB,NDAB,WVHAEC,LVHAEC,WORK,LWORK,IERROR)
      DOUBLE PRECISION V
      DOUBLE PRECISION W
      DOUBLE PRECISION BR
      DOUBLE PRECISION BI
      DOUBLE PRECISION CR
      DOUBLE PRECISION CI
      DOUBLE PRECISION WVHAEC
      DOUBLE PRECISION WORK
      DIMENSION V(IDVW,JDVW,1),W(IDVW,JDVW,1),BR(MDAB,NDAB,1),
     +          BI(MDAB,NDAB,1),CR(MDAB,NDAB,1),CI(MDAB,NDAB,1),WORK(1),
     +          WVHAEC(1)

      IERROR = 1
      IF (NLAT.LT.3) RETURN
      IERROR = 2
      IF (NLON.LT.1) RETURN
      IERROR = 3
      IF (ITYP.LT.0 .OR. ITYP.GT.8) RETURN
      IERROR = 4
      IF (NT.LT.0) RETURN
      IERROR = 5
      IMID = (NLAT+1)/2
      IF ((ITYP.LE.2.AND.IDVW.LT.NLAT) .OR.
     +    (ITYP.GT.2.AND.IDVW.LT.IMID)) RETURN
      IERROR = 6
      IF (JDVW.LT.NLON) RETURN
      IERROR = 7
      MMAX = MIN0(NLAT, (NLON+1)/2)
      IF (MDAB.LT.MMAX) RETURN
      IERROR = 8
      IF (NDAB.LT.NLAT) RETURN
      IERROR = 9
      LZZ1 = 2*NLAT*IMID
      LABC = 3* (MAX0(MMAX-2,0)* (NLAT+NLAT-MMAX-1))/2
      IF (LVHAEC.LT.2* (LZZ1+LABC)+NLON+15) RETURN
      IERROR = 10
      IF (ITYP.LE.2 .AND. LWORK.LT.NLAT*
     +    (2*NT*NLON+MAX0(6*IMID,NLON))) RETURN
      IF (ITYP.GT.2 .AND. LWORK.LT.IMID*
     +    (2*NT*NLON+MAX0(6*NLAT,NLON))) RETURN
      IERROR = 0
      IDV = NLAT
      IF (ITYP.GT.2) IDV = IMID
      LNL = NT*IDV*NLON
      IST = 0
      IF (ITYP.LE.2) IST = IMID
      IW1 = IST + 1
      IW2 = LNL + 1
      IW3 = IW2 + IST
      IW4 = IW2 + LNL
      IW5 = IW4 + 3*IMID*NLAT
      LWZVIN = LZZ1 + LABC
      JW1 = LWZVIN + 1
      JW2 = JW1 + LWZVIN
      CALL DVHAEC1(NLAT,NLON,ITYP,NT,IMID,IDVW,JDVW,V,W,MDAB,NDAB,BR,
     +             BI,CR,CI,IDV,WORK,WORK(IW1),WORK(IW2),WORK(IW3),
     +             WORK(IW4),WORK(IW5),WVHAEC,WVHAEC(JW1),WVHAEC(JW2))
      RETURN
      END
      SUBROUTINE DVHAEC1(NLAT,NLON,ITYP,NT,IMID,IDVW,JDVW,V,W,MDAB,NDAB,
     +                  BR,BI,CR,CI,IDV,VE,VO,WE,WO,ZV,ZW,WZVIN,WZWIN,
     +                  WRFFT)
      DOUBLE PRECISION V
      DOUBLE PRECISION W
      DOUBLE PRECISION BR
      DOUBLE PRECISION BI
      DOUBLE PRECISION CR
      DOUBLE PRECISION CI
      DOUBLE PRECISION VE
      DOUBLE PRECISION VO
      DOUBLE PRECISION WE
      DOUBLE PRECISION WO
      DOUBLE PRECISION ZV
      DOUBLE PRECISION ZW
      DOUBLE PRECISION WZVIN
      DOUBLE PRECISION WZWIN
      DOUBLE PRECISION WRFFT
      DOUBLE PRECISION TSN
      DOUBLE PRECISION FSN
      DIMENSION V(IDVW,JDVW,1),W(IDVW,JDVW,1),BR(MDAB,NDAB,1),
     +          BI(MDAB,NDAB,1),CR(MDAB,NDAB,1),CI(MDAB,NDAB,1),
     +          VE(IDV,NLON,1),VO(IDV,NLON,1),WE(IDV,NLON,1),
     +          WO(IDV,NLON,1),WZVIN(1),WZWIN(1),WRFFT(1),
     +          ZV(IMID,NLAT,3),ZW(IMID,NLAT,3)

      NLP1 = NLAT + 1
      TSN = 2.D0/NLON
      FSN = 4.D0/NLON
      MLAT = MOD(NLAT,2)
      MLON = MOD(NLON,2)
      MMAX = MIN0(NLAT, (NLON+1)/2)
      IMM1 = IMID
      IF (MLAT.NE.0) IMM1 = IMID - 1
      IF (ITYP.GT.2) GO TO 3
      DO 5 K = 1,NT
          DO 5 I = 1,IMM1
              DO 5 J = 1,NLON
                  VE(I,J,K) = TSN* (V(I,J,K)+V(NLP1-I,J,K))
                  VO(I,J,K) = TSN* (V(I,J,K)-V(NLP1-I,J,K))
                  WE(I,J,K) = TSN* (W(I,J,K)+W(NLP1-I,J,K))
                  WO(I,J,K) = TSN* (W(I,J,K)-W(NLP1-I,J,K))
    5 CONTINUE
      GO TO 2
    3 DO 8 K = 1,NT
          DO 8 I = 1,IMM1
              DO 8 J = 1,NLON
                  VE(I,J,K) = FSN*V(I,J,K)
                  VO(I,J,K) = FSN*V(I,J,K)
                  WE(I,J,K) = FSN*W(I,J,K)
                  WO(I,J,K) = FSN*W(I,J,K)
    8 CONTINUE
    2 IF (MLAT.EQ.0) GO TO 7
      DO 6 K = 1,NT
          DO 6 J = 1,NLON
              VE(IMID,J,K) = TSN*V(IMID,J,K)
              WE(IMID,J,K) = TSN*W(IMID,J,K)
    6 CONTINUE
    7 DO 9 K = 1,NT
          CALL DHRFFTF(IDV,NLON,VE(1,1,K),IDV,WRFFT,ZV)
          CALL DHRFFTF(IDV,NLON,WE(1,1,K),IDV,WRFFT,ZV)
    9 CONTINUE
      NDO1 = NLAT
      NDO2 = NLAT
      IF (MLAT.NE.0) NDO1 = NLAT - 1
      IF (MLAT.EQ.0) NDO2 = NLAT - 1
      IF (ITYP.EQ.2 .OR. ITYP.EQ.5 .OR. ITYP.EQ.8) GO TO 11
      DO 10 K = 1,NT
          DO 10 MP1 = 1,MMAX
              DO 10 NP1 = MP1,NLAT
                  BR(MP1,NP1,K) = 0.D0
                  BI(MP1,NP1,K) = 0.D0
   10 CONTINUE
   11 IF (ITYP.EQ.1 .OR. ITYP.EQ.4 .OR. ITYP.EQ.7) GO TO 13
      DO 12 K = 1,NT
          DO 12 MP1 = 1,MMAX
              DO 12 NP1 = MP1,NLAT
                  CR(MP1,NP1,K) = 0.D0
                  CI(MP1,NP1,K) = 0.D0
   12 CONTINUE
   13 ITYPP = ITYP + 1
      GO TO (1,100,200,300,400,500,600,700,800) ITYPP
c
c     case ityp=0 ,  no symmetries
c
    1 CALL DZVIN(0,NLAT,NLON,0,ZV,IV,WZVIN)
c
c     case m=0
c
      DO 15 K = 1,NT
          DO 15 I = 1,IMID
              DO 15 NP1 = 2,NDO2,2
                  BR(1,NP1,K) = BR(1,NP1,K) + ZV(I,NP1,IV)*VE(I,1,K)
                  CR(1,NP1,K) = CR(1,NP1,K) - ZV(I,NP1,IV)*WE(I,1,K)
   15 CONTINUE
      DO 16 K = 1,NT
          DO 16 I = 1,IMM1
              DO 16 NP1 = 3,NDO1,2
                  BR(1,NP1,K) = BR(1,NP1,K) + ZV(I,NP1,IV)*VO(I,1,K)
                  CR(1,NP1,K) = CR(1,NP1,K) - ZV(I,NP1,IV)*WO(I,1,K)
   16 CONTINUE
c
c     case m = 1 through nlat-1
c
      IF (MMAX.LT.2) RETURN
      DO 20 MP1 = 2,MMAX
          M = MP1 - 1
          MP2 = MP1 + 1
          CALL DZVIN(0,NLAT,NLON,M,ZV,IV,WZVIN)
          CALL DZWIN(0,NLAT,NLON,M,ZW,IW,WZWIN)
          IF (MP1.GT.NDO1) GO TO 17
          DO 23 K = 1,NT
              DO 23 I = 1,IMM1
                  DO 23 NP1 = MP1,NDO1,2
                      BR(MP1,NP1,K) = BR(MP1,NP1,K) +
     +                                ZV(I,NP1,IV)*VO(I,2*MP1-2,K) +
     +                                ZW(I,NP1,IW)*WE(I,2*MP1-1,K)
                      BI(MP1,NP1,K) = BI(MP1,NP1,K) +
     +                                ZV(I,NP1,IV)*VO(I,2*MP1-1,K) -
     +                                ZW(I,NP1,IW)*WE(I,2*MP1-2,K)
                      CR(MP1,NP1,K) = CR(MP1,NP1,K) -
     +                                ZV(I,NP1,IV)*WO(I,2*MP1-2,K) +
     +                                ZW(I,NP1,IW)*VE(I,2*MP1-1,K)
                      CI(MP1,NP1,K) = CI(MP1,NP1,K) -
     +                                ZV(I,NP1,IV)*WO(I,2*MP1-1,K) -
     +                                ZW(I,NP1,IW)*VE(I,2*MP1-2,K)
   23     CONTINUE
          IF (MLAT.EQ.0) GO TO 17
          DO 24 K = 1,NT
              DO 24 NP1 = MP1,NDO1,2
                  BR(MP1,NP1,K) = BR(MP1,NP1,K) +
     +                            ZW(IMID,NP1,IW)*WE(IMID,2*MP1-1,K)
                  BI(MP1,NP1,K) = BI(MP1,NP1,K) -
     +                            ZW(IMID,NP1,IW)*WE(IMID,2*MP1-2,K)
                  CR(MP1,NP1,K) = CR(MP1,NP1,K) +
     +                            ZW(IMID,NP1,IW)*VE(IMID,2*MP1-1,K)
                  CI(MP1,NP1,K) = CI(MP1,NP1,K) -
     +                            ZW(IMID,NP1,IW)*VE(IMID,2*MP1-2,K)
   24     CONTINUE
   17     IF (MP2.GT.NDO2) GO TO 20
          DO 21 K = 1,NT
              DO 21 I = 1,IMM1
                  DO 21 NP1 = MP2,NDO2,2
                      BR(MP1,NP1,K) = BR(MP1,NP1,K) +
     +                                ZV(I,NP1,IV)*VE(I,2*MP1-2,K) +
     +                                ZW(I,NP1,IW)*WO(I,2*MP1-1,K)
                      BI(MP1,NP1,K) = BI(MP1,NP1,K) +
     +                                ZV(I,NP1,IV)*VE(I,2*MP1-1,K) -
     +                                ZW(I,NP1,IW)*WO(I,2*MP1-2,K)
                      CR(MP1,NP1,K) = CR(MP1,NP1,K) -
     +                                ZV(I,NP1,IV)*WE(I,2*MP1-2,K) +
     +                                ZW(I,NP1,IW)*VO(I,2*MP1-1,K)
                      CI(MP1,NP1,K) = CI(MP1,NP1,K) -
     +                                ZV(I,NP1,IV)*WE(I,2*MP1-1,K) -
     +                                ZW(I,NP1,IW)*VO(I,2*MP1-2,K)
   21     CONTINUE
          IF (MLAT.EQ.0) GO TO 20
          DO 22 K = 1,NT
              DO 22 NP1 = MP2,NDO2,2
                  BR(MP1,NP1,K) = BR(MP1,NP1,K) +
     +                            ZV(IMID,NP1,IV)*VE(IMID,2*MP1-2,K)
                  BI(MP1,NP1,K) = BI(MP1,NP1,K) +
     +                            ZV(IMID,NP1,IV)*VE(IMID,2*MP1-1,K)
                  CR(MP1,NP1,K) = CR(MP1,NP1,K) -
     +                            ZV(IMID,NP1,IV)*WE(IMID,2*MP1-2,K)
                  CI(MP1,NP1,K) = CI(MP1,NP1,K) -
     +                            ZV(IMID,NP1,IV)*WE(IMID,2*MP1-1,K)
   22     CONTINUE
   20 CONTINUE
      RETURN
c
c     case ityp=1 ,  no symmetries but cr and ci equal zero
c
  100 CALL DZVIN(0,NLAT,NLON,0,ZV,IV,WZVIN)
c
c     case m=0
c
      DO 115 K = 1,NT
          DO 115 I = 1,IMID
              DO 115 NP1 = 2,NDO2,2
                  BR(1,NP1,K) = BR(1,NP1,K) + ZV(I,NP1,IV)*VE(I,1,K)
  115 CONTINUE
      DO 116 K = 1,NT
          DO 116 I = 1,IMM1
              DO 116 NP1 = 3,NDO1,2
                  BR(1,NP1,K) = BR(1,NP1,K) + ZV(I,NP1,IV)*VO(I,1,K)
  116 CONTINUE
c
c     case m = 1 through nlat-1
c
      IF (MMAX.LT.2) RETURN
      DO 120 MP1 = 2,MMAX
          M = MP1 - 1
          MP2 = MP1 + 1
          CALL DZVIN(0,NLAT,NLON,M,ZV,IV,WZVIN)
          CALL DZWIN(0,NLAT,NLON,M,ZW,IW,WZWIN)
          IF (MP1.GT.NDO1) GO TO 117
          DO 123 K = 1,NT
              DO 123 I = 1,IMM1
                  DO 123 NP1 = MP1,NDO1,2
                      BR(MP1,NP1,K) = BR(MP1,NP1,K) +
     +                                ZV(I,NP1,IV)*VO(I,2*MP1-2,K) +
     +                                ZW(I,NP1,IW)*WE(I,2*MP1-1,K)
                      BI(MP1,NP1,K) = BI(MP1,NP1,K) +
     +                                ZV(I,NP1,IV)*VO(I,2*MP1-1,K) -
     +                                ZW(I,NP1,IW)*WE(I,2*MP1-2,K)
  123     CONTINUE
          IF (MLAT.EQ.0) GO TO 117
          DO 124 K = 1,NT
              DO 124 NP1 = MP1,NDO1,2
                  BR(MP1,NP1,K) = BR(MP1,NP1,K) +
     +                            ZW(IMID,NP1,IW)*WE(IMID,2*MP1-1,K)
                  BI(MP1,NP1,K) = BI(MP1,NP1,K) -
     +                            ZW(IMID,NP1,IW)*WE(IMID,2*MP1-2,K)
  124     CONTINUE
  117     IF (MP2.GT.NDO2) GO TO 120
          DO 121 K = 1,NT
              DO 121 I = 1,IMM1
                  DO 121 NP1 = MP2,NDO2,2
                      BR(MP1,NP1,K) = BR(MP1,NP1,K) +
     +                                ZV(I,NP1,IV)*VE(I,2*MP1-2,K) +
     +                                ZW(I,NP1,IW)*WO(I,2*MP1-1,K)
                      BI(MP1,NP1,K) = BI(MP1,NP1,K) +
     +                                ZV(I,NP1,IV)*VE(I,2*MP1-1,K) -
     +                                ZW(I,NP1,IW)*WO(I,2*MP1-2,K)
  121     CONTINUE
          IF (MLAT.EQ.0) GO TO 120
          DO 122 K = 1,NT
              DO 122 NP1 = MP2,NDO2,2
                  BR(MP1,NP1,K) = BR(MP1,NP1,K) +
     +                            ZV(IMID,NP1,IV)*VE(IMID,2*MP1-2,K)
                  BI(MP1,NP1,K) = BI(MP1,NP1,K) +
     +                            ZV(IMID,NP1,IV)*VE(IMID,2*MP1-1,K)
  122     CONTINUE
  120 CONTINUE
      RETURN
c
c     case ityp=2 ,  no symmetries but br and bi equal zero
c
  200 CALL DZVIN(0,NLAT,NLON,0,ZV,IV,WZVIN)
c
c     case m=0
c
      DO 215 K = 1,NT
          DO 215 I = 1,IMID
              DO 215 NP1 = 2,NDO2,2
                  CR(1,NP1,K) = CR(1,NP1,K) - ZV(I,NP1,IV)*WE(I,1,K)
  215 CONTINUE
      DO 216 K = 1,NT
          DO 216 I = 1,IMM1
              DO 216 NP1 = 3,NDO1,2
                  CR(1,NP1,K) = CR(1,NP1,K) - ZV(I,NP1,IV)*WO(I,1,K)
  216 CONTINUE
c
c     case m = 1 through nlat-1
c
      IF (MMAX.LT.2) RETURN
      DO 220 MP1 = 2,MMAX
          M = MP1 - 1
          MP2 = MP1 + 1
          CALL DZVIN(0,NLAT,NLON,M,ZV,IV,WZVIN)
          CALL DZWIN(0,NLAT,NLON,M,ZW,IW,WZWIN)
          IF (MP1.GT.NDO1) GO TO 217
          DO 223 K = 1,NT
              DO 223 I = 1,IMM1
                  DO 223 NP1 = MP1,NDO1,2
                      CR(MP1,NP1,K) = CR(MP1,NP1,K) -
     +                                ZV(I,NP1,IV)*WO(I,2*MP1-2,K) +
     +                                ZW(I,NP1,IW)*VE(I,2*MP1-1,K)
                      CI(MP1,NP1,K) = CI(MP1,NP1,K) -
     +                                ZV(I,NP1,IV)*WO(I,2*MP1-1,K) -
     +                                ZW(I,NP1,IW)*VE(I,2*MP1-2,K)
  223     CONTINUE
          IF (MLAT.EQ.0) GO TO 217
          DO 224 K = 1,NT
              DO 224 NP1 = MP1,NDO1,2
                  CR(MP1,NP1,K) = CR(MP1,NP1,K) +
     +                            ZW(IMID,NP1,IW)*VE(IMID,2*MP1-1,K)
                  CI(MP1,NP1,K) = CI(MP1,NP1,K) -
     +                            ZW(IMID,NP1,IW)*VE(IMID,2*MP1-2,K)
  224     CONTINUE
  217     IF (MP2.GT.NDO2) GO TO 220
          DO 221 K = 1,NT
              DO 221 I = 1,IMM1
                  DO 221 NP1 = MP2,NDO2,2
                      CR(MP1,NP1,K) = CR(MP1,NP1,K) -
     +                                ZV(I,NP1,IV)*WE(I,2*MP1-2,K) +
     +                                ZW(I,NP1,IW)*VO(I,2*MP1-1,K)
                      CI(MP1,NP1,K) = CI(MP1,NP1,K) -
     +                                ZV(I,NP1,IV)*WE(I,2*MP1-1,K) -
     +                                ZW(I,NP1,IW)*VO(I,2*MP1-2,K)
  221     CONTINUE
          IF (MLAT.EQ.0) GO TO 220
          DO 222 K = 1,NT
              DO 222 NP1 = MP2,NDO2,2
                  CR(MP1,NP1,K) = CR(MP1,NP1,K) -
     +                            ZV(IMID,NP1,IV)*WE(IMID,2*MP1-2,K)
                  CI(MP1,NP1,K) = CI(MP1,NP1,K) -
     +                            ZV(IMID,NP1,IV)*WE(IMID,2*MP1-1,K)
  222     CONTINUE
  220 CONTINUE
      RETURN
c
c     case ityp=3 ,  v even , w odd
c
  300 CALL DZVIN(0,NLAT,NLON,0,ZV,IV,WZVIN)
c
c     case m=0
c
      DO 315 K = 1,NT
          DO 315 I = 1,IMID
              DO 315 NP1 = 2,NDO2,2
                  BR(1,NP1,K) = BR(1,NP1,K) + ZV(I,NP1,IV)*VE(I,1,K)
  315 CONTINUE
      DO 316 K = 1,NT
          DO 316 I = 1,IMM1
              DO 316 NP1 = 3,NDO1,2
                  CR(1,NP1,K) = CR(1,NP1,K) - ZV(I,NP1,IV)*WO(I,1,K)
  316 CONTINUE
c
c     case m = 1 through nlat-1
c
      IF (MMAX.LT.2) RETURN
      DO 320 MP1 = 2,MMAX
          M = MP1 - 1
          MP2 = MP1 + 1
          CALL DZVIN(0,NLAT,NLON,M,ZV,IV,WZVIN)
          CALL DZWIN(0,NLAT,NLON,M,ZW,IW,WZWIN)
          IF (MP1.GT.NDO1) GO TO 317
          DO 323 K = 1,NT
              DO 323 I = 1,IMM1
                  DO 323 NP1 = MP1,NDO1,2
                      CR(MP1,NP1,K) = CR(MP1,NP1,K) -
     +                                ZV(I,NP1,IV)*WO(I,2*MP1-2,K) +
     +                                ZW(I,NP1,IW)*VE(I,2*MP1-1,K)
                      CI(MP1,NP1,K) = CI(MP1,NP1,K) -
     +                                ZV(I,NP1,IV)*WO(I,2*MP1-1,K) -
     +                                ZW(I,NP1,IW)*VE(I,2*MP1-2,K)
  323     CONTINUE
          IF (MLAT.EQ.0) GO TO 317
          DO 324 K = 1,NT
              DO 324 NP1 = MP1,NDO1,2
                  CR(MP1,NP1,K) = CR(MP1,NP1,K) +
     +                            ZW(IMID,NP1,IW)*VE(IMID,2*MP1-1,K)
                  CI(MP1,NP1,K) = CI(MP1,NP1,K) -
     +                            ZW(IMID,NP1,IW)*VE(IMID,2*MP1-2,K)
  324     CONTINUE
  317     IF (MP2.GT.NDO2) GO TO 320
          DO 321 K = 1,NT
              DO 321 I = 1,IMM1
                  DO 321 NP1 = MP2,NDO2,2
                      BR(MP1,NP1,K) = BR(MP1,NP1,K) +
     +                                ZV(I,NP1,IV)*VE(I,2*MP1-2,K) +
     +                                ZW(I,NP1,IW)*WO(I,2*MP1-1,K)
                      BI(MP1,NP1,K) = BI(MP1,NP1,K) +
     +                                ZV(I,NP1,IV)*VE(I,2*MP1-1,K) -
     +                                ZW(I,NP1,IW)*WO(I,2*MP1-2,K)
  321     CONTINUE
          IF (MLAT.EQ.0) GO TO 320
          DO 322 K = 1,NT
              DO 322 NP1 = MP2,NDO2,2
                  BR(MP1,NP1,K) = BR(MP1,NP1,K) +
     +                            ZV(IMID,NP1,IV)*VE(IMID,2*MP1-2,K)
                  BI(MP1,NP1,K) = BI(MP1,NP1,K) +
     +                            ZV(IMID,NP1,IV)*VE(IMID,2*MP1-1,K)
  322     CONTINUE
  320 CONTINUE
      RETURN
c
c     case ityp=4 ,  v even, w odd, and cr and ci equal 0.
c
  400 CALL DZVIN(1,NLAT,NLON,0,ZV,IV,WZVIN)
c
c     case m=0
c
      DO 415 K = 1,NT
          DO 415 I = 1,IMID
              DO 415 NP1 = 2,NDO2,2
                  BR(1,NP1,K) = BR(1,NP1,K) + ZV(I,NP1,IV)*VE(I,1,K)
  415 CONTINUE
c
c     case m = 1 through nlat-1
c
      IF (MMAX.LT.2) RETURN
      DO 420 MP1 = 2,MMAX
          M = MP1 - 1
          MP2 = MP1 + 1
          CALL DZVIN(1,NLAT,NLON,M,ZV,IV,WZVIN)
          CALL DZWIN(1,NLAT,NLON,M,ZW,IW,WZWIN)
          IF (MP2.GT.NDO2) GO TO 420
          DO 421 K = 1,NT
              DO 421 I = 1,IMM1
                  DO 421 NP1 = MP2,NDO2,2
                      BR(MP1,NP1,K) = BR(MP1,NP1,K) +
     +                                ZV(I,NP1,IV)*VE(I,2*MP1-2,K) +
     +                                ZW(I,NP1,IW)*WO(I,2*MP1-1,K)
                      BI(MP1,NP1,K) = BI(MP1,NP1,K) +
     +                                ZV(I,NP1,IV)*VE(I,2*MP1-1,K) -
     +                                ZW(I,NP1,IW)*WO(I,2*MP1-2,K)
  421     CONTINUE
          IF (MLAT.EQ.0) GO TO 420
          DO 422 K = 1,NT
              DO 422 NP1 = MP2,NDO2,2
                  BR(MP1,NP1,K) = BR(MP1,NP1,K) +
     +                            ZV(IMID,NP1,IV)*VE(IMID,2*MP1-2,K)
                  BI(MP1,NP1,K) = BI(MP1,NP1,K) +
     +                            ZV(IMID,NP1,IV)*VE(IMID,2*MP1-1,K)
  422     CONTINUE
  420 CONTINUE
      RETURN
c
c     case ityp=5   v even, w odd, and br and bi equal zero
c
  500 CALL DZVIN(2,NLAT,NLON,0,ZV,IV,WZVIN)
c
c     case m=0
c
      DO 516 K = 1,NT
          DO 516 I = 1,IMM1
              DO 516 NP1 = 3,NDO1,2
                  CR(1,NP1,K) = CR(1,NP1,K) - ZV(I,NP1,IV)*WO(I,1,K)
  516 CONTINUE
c
c     case m = 1 through nlat-1
c
      IF (MMAX.LT.2) RETURN
      DO 520 MP1 = 2,MMAX
          M = MP1 - 1
          MP2 = MP1 + 1
          CALL DZVIN(2,NLAT,NLON,M,ZV,IV,WZVIN)
          CALL DZWIN(2,NLAT,NLON,M,ZW,IW,WZWIN)
          IF (MP1.GT.NDO1) GO TO 520
          DO 523 K = 1,NT
              DO 523 I = 1,IMM1
                  DO 523 NP1 = MP1,NDO1,2
                      CR(MP1,NP1,K) = CR(MP1,NP1,K) -
     +                                ZV(I,NP1,IV)*WO(I,2*MP1-2,K) +
     +                                ZW(I,NP1,IW)*VE(I,2*MP1-1,K)
                      CI(MP1,NP1,K) = CI(MP1,NP1,K) -
     +                                ZV(I,NP1,IV)*WO(I,2*MP1-1,K) -
     +                                ZW(I,NP1,IW)*VE(I,2*MP1-2,K)
  523     CONTINUE
          IF (MLAT.EQ.0) GO TO 520
          DO 524 K = 1,NT
              DO 524 NP1 = MP1,NDO1,2
                  CR(MP1,NP1,K) = CR(MP1,NP1,K) +
     +                            ZW(IMID,NP1,IW)*VE(IMID,2*MP1-1,K)
                  CI(MP1,NP1,K) = CI(MP1,NP1,K) -
     +                            ZW(IMID,NP1,IW)*VE(IMID,2*MP1-2,K)
  524     CONTINUE
  520 CONTINUE
      RETURN
c
c     case ityp=6 ,  v odd , w even
c
  600 CALL DZVIN(0,NLAT,NLON,0,ZV,IV,WZVIN)
c
c     case m=0
c
      DO 615 K = 1,NT
          DO 615 I = 1,IMID
              DO 615 NP1 = 2,NDO2,2
                  CR(1,NP1,K) = CR(1,NP1,K) - ZV(I,NP1,IV)*WE(I,1,K)
  615 CONTINUE
      DO 616 K = 1,NT
          DO 616 I = 1,IMM1
              DO 616 NP1 = 3,NDO1,2
                  BR(1,NP1,K) = BR(1,NP1,K) + ZV(I,NP1,IV)*VO(I,1,K)
  616 CONTINUE
c
c     case m = 1 through nlat-1
c
      IF (MMAX.LT.2) RETURN
      DO 620 MP1 = 2,MMAX
          M = MP1 - 1
          MP2 = MP1 + 1
          CALL DZVIN(0,NLAT,NLON,M,ZV,IV,WZVIN)
          CALL DZWIN(0,NLAT,NLON,M,ZW,IW,WZWIN)
          IF (MP1.GT.NDO1) GO TO 617
          DO 623 K = 1,NT
              DO 623 I = 1,IMM1
                  DO 623 NP1 = MP1,NDO1,2
                      BR(MP1,NP1,K) = BR(MP1,NP1,K) +
     +                                ZV(I,NP1,IV)*VO(I,2*MP1-2,K) +
     +                                ZW(I,NP1,IW)*WE(I,2*MP1-1,K)
                      BI(MP1,NP1,K) = BI(MP1,NP1,K) +
     +                                ZV(I,NP1,IV)*VO(I,2*MP1-1,K) -
     +                                ZW(I,NP1,IW)*WE(I,2*MP1-2,K)
  623     CONTINUE
          IF (MLAT.EQ.0) GO TO 617
          DO 624 K = 1,NT
              DO 624 NP1 = MP1,NDO1,2
                  BR(MP1,NP1,K) = BR(MP1,NP1,K) +
     +                            ZW(IMID,NP1,IW)*WE(IMID,2*MP1-1,K)
                  BI(MP1,NP1,K) = BI(MP1,NP1,K) -
     +                            ZW(IMID,NP1,IW)*WE(IMID,2*MP1-2,K)
  624     CONTINUE
  617     IF (MP2.GT.NDO2) GO TO 620
          DO 621 K = 1,NT
              DO 621 I = 1,IMM1
                  DO 621 NP1 = MP2,NDO2,2
                      CR(MP1,NP1,K) = CR(MP1,NP1,K) -
     +                                ZV(I,NP1,IV)*WE(I,2*MP1-2,K) +
     +                                ZW(I,NP1,IW)*VO(I,2*MP1-1,K)
                      CI(MP1,NP1,K) = CI(MP1,NP1,K) -
     +                                ZV(I,NP1,IV)*WE(I,2*MP1-1,K) -
     +                                ZW(I,NP1,IW)*VO(I,2*MP1-2,K)
  621     CONTINUE
          IF (MLAT.EQ.0) GO TO 620
          DO 622 K = 1,NT
              DO 622 NP1 = MP2,NDO2,2
                  CR(MP1,NP1,K) = CR(MP1,NP1,K) -
     +                            ZV(IMID,NP1,IV)*WE(IMID,2*MP1-2,K)
                  CI(MP1,NP1,K) = CI(MP1,NP1,K) -
     +                            ZV(IMID,NP1,IV)*WE(IMID,2*MP1-1,K)
  622     CONTINUE
  620 CONTINUE
      RETURN
c
c     case ityp=7   v odd, w even, and cr and ci equal zero
c
  700 CALL DZVIN(2,NLAT,NLON,0,ZV,IV,WZVIN)
c
c     case m=0
c
      DO 716 K = 1,NT
          DO 716 I = 1,IMM1
              DO 716 NP1 = 3,NDO1,2
                  BR(1,NP1,K) = BR(1,NP1,K) + ZV(I,NP1,IV)*VO(I,1,K)
  716 CONTINUE
c
c     case m = 1 through nlat-1
c
      IF (MMAX.LT.2) RETURN
      DO 720 MP1 = 2,MMAX
          M = MP1 - 1
          MP2 = MP1 + 1
          CALL DZVIN(2,NLAT,NLON,M,ZV,IV,WZVIN)
          CALL DZWIN(2,NLAT,NLON,M,ZW,IW,WZWIN)
          IF (MP1.GT.NDO1) GO TO 720
          DO 723 K = 1,NT
              DO 723 I = 1,IMM1
                  DO 723 NP1 = MP1,NDO1,2
                      BR(MP1,NP1,K) = BR(MP1,NP1,K) +
     +                                ZV(I,NP1,IV)*VO(I,2*MP1-2,K) +
     +                                ZW(I,NP1,IW)*WE(I,2*MP1-1,K)
                      BI(MP1,NP1,K) = BI(MP1,NP1,K) +
     +                                ZV(I,NP1,IV)*VO(I,2*MP1-1,K) -
     +                                ZW(I,NP1,IW)*WE(I,2*MP1-2,K)
  723     CONTINUE
          IF (MLAT.EQ.0) GO TO 720
          DO 724 K = 1,NT
              DO 724 NP1 = MP1,NDO1,2
                  BR(MP1,NP1,K) = BR(MP1,NP1,K) +
     +                            ZW(IMID,NP1,IW)*WE(IMID,2*MP1-1,K)
                  BI(MP1,NP1,K) = BI(MP1,NP1,K) -
     +                            ZW(IMID,NP1,IW)*WE(IMID,2*MP1-2,K)
  724     CONTINUE
  720 CONTINUE
      RETURN
c
c     case ityp=8   v odd, w even, and both br and bi equal zero
c
  800 CALL DZVIN(1,NLAT,NLON,0,ZV,IV,WZVIN)
c
c     case m=0
c
      DO 815 K = 1,NT
          DO 815 I = 1,IMID
              DO 815 NP1 = 2,NDO2,2
                  CR(1,NP1,K) = CR(1,NP1,K) - ZV(I,NP1,IV)*WE(I,1,K)
  815 CONTINUE
c
c     case m = 1 through nlat-1
c
      IF (MMAX.LT.2) RETURN
      DO 820 MP1 = 2,MMAX
          M = MP1 - 1
          MP2 = MP1 + 1
          CALL DZVIN(1,NLAT,NLON,M,ZV,IV,WZVIN)
          CALL DZWIN(1,NLAT,NLON,M,ZW,IW,WZWIN)
          IF (MP2.GT.NDO2) GO TO 820
          DO 821 K = 1,NT
              DO 821 I = 1,IMM1
                  DO 821 NP1 = MP2,NDO2,2
                      CR(MP1,NP1,K) = CR(MP1,NP1,K) -
     +                                ZV(I,NP1,IV)*WE(I,2*MP1-2,K) +
     +                                ZW(I,NP1,IW)*VO(I,2*MP1-1,K)
                      CI(MP1,NP1,K) = CI(MP1,NP1,K) -
     +                                ZV(I,NP1,IV)*WE(I,2*MP1-1,K) -
     +                                ZW(I,NP1,IW)*VO(I,2*MP1-2,K)
  821     CONTINUE
          IF (MLAT.EQ.0) GO TO 820
          DO 822 K = 1,NT
              DO 822 NP1 = MP2,NDO2,2
                  CR(MP1,NP1,K) = CR(MP1,NP1,K) -
     +                            ZV(IMID,NP1,IV)*WE(IMID,2*MP1-2,K)
                  CI(MP1,NP1,K) = CI(MP1,NP1,K) -
     +                            ZV(IMID,NP1,IV)*WE(IMID,2*MP1-1,K)
  822     CONTINUE
  820 CONTINUE
      RETURN
      END
      SUBROUTINE DVHAECI(NLAT,NLON,WVHAEC,LVHAEC,DWORK,LDWORK,IERROR)
      DOUBLE PRECISION WVHAEC
      DIMENSION WVHAEC(LVHAEC)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION DWORK(LDWORK)

      IERROR = 1
      IF (NLAT.LT.3) RETURN
      IERROR = 2
      IF (NLON.LT.1) RETURN
      IERROR = 3
      IMID = (NLAT+1)/2
      LZZ1 = 2*NLAT*IMID
      MMAX = MIN0(NLAT, (NLON+1)/2)
      LABC = 3* (MAX0(MMAX-2,0)* (NLAT+NLAT-MMAX-1))/2
      IF (LVHAEC.LT.2* (LZZ1+LABC)+NLON+15) RETURN
      IERROR = 4
      IF (LDWORK.LT.2*NLAT+2) RETURN
      IERROR = 0
      CALL DZVINIT(NLAT,NLON,WVHAEC,DWORK)
      LWZVIN = LZZ1 + LABC
      IW1 = LWZVIN + 1
      CALL DZWINIT(NLAT,NLON,WVHAEC(IW1),DWORK)
      IW2 = IW1 + LWZVIN
      CALL DHRFFTI(NLON,WVHAEC(IW2))
      RETURN
      END

C
C	$Id: conxch.f,v 1.5 2008-07-27 00:16:57 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      INTEGER FUNCTION CONXCH (X,Y,I1,I2,I3,I4)
C
C THIS FUNCTION DETERMINES WHETHER OR NOT THE EXCHANGE OF TWO
C TRIANGLES IS NECESSARY ON THE BASIS OF MAX-MIN-ANGLE CRITERION
C BY C. L. LAWSON.
C THE INPUT PARAMETERS ARE
C     X,Y = ARRAYS CONTAINING THE COORDINATES OF THE DATA
C           POINTS,
C     I1,I2,I3,I4 = POINT NUMBERS OF FOUR POINTS P1, P2,
C                   P3, AND P4 THAT FORM A QUADRILATERAL
C                   WITH P3 AND P4 CONNECTED DIADONALLY.
C THIS FUNCTION RETURNS A VALUE 1 (ONE) WHEN AN EXCHANGE IS
C NEEDED, AND 0 (ZERO) OTHERWISE.
C DECLARATION STATEMENTS
C
      DIMENSION       X(1)       ,Y(1)
      DIMENSION       X0(4)      ,Y0(4)
      EQUIVALENCE     (C2SQ,C1SQ),(A3SQ,B2SQ),(B3SQ,A1SQ),(A4SQ,B1SQ),
     1                (B4SQ,A2SQ),(C4SQ,C3SQ)
C
        SAVE
C
C STATEMENT FUNCTIONS
C
C CALCULATION
C
      X0(1) = X(I1)
      Y0(1) = Y(I1)
      X0(2) = X(I2)
      Y0(2) = Y(I2)
      X0(3) = X(I3)
      Y0(3) = Y(I3)
      X0(4) = X(I4)
      Y0(4) = Y(I4)
      IDX = 0
      U3 = (Y0(2)-Y0(3))*(X0(1)-X0(3))-(X0(2)-X0(3))*(Y0(1)-Y0(3))
      U4 = (Y0(1)-Y0(4))*(X0(2)-X0(4))-(X0(1)-X0(4))*(Y0(2)-Y0(4))
      IF (U3*U4 .LE. 0.0) GO TO  100
      U1 = (Y0(3)-Y0(1))*(X0(4)-X0(1))-(X0(3)-X0(1))*(Y0(4)-Y0(1))
      U2 = (Y0(4)-Y0(2))*(X0(3)-X0(2))-(X0(4)-X0(2))*(Y0(3)-Y0(2))
      A1SQ = (X0(1)-X0(3))**2+(Y0(1)-Y0(3))**2
      B1SQ = (X0(4)-X0(1))**2+(Y0(4)-Y0(1))**2
      C1SQ = (X0(3)-X0(4))**2+(Y0(3)-Y0(4))**2
      A2SQ = (X0(2)-X0(4))**2+(Y0(2)-Y0(4))**2
      B2SQ = (X0(3)-X0(2))**2+(Y0(3)-Y0(2))**2
      C3SQ = (X0(2)-X0(1))**2+(Y0(2)-Y0(1))**2
      S1SQ = U1*U1/(C1SQ*MAX(A1SQ,B1SQ))
      S2SQ = U2*U2/(C2SQ*MAX(A2SQ,B2SQ))
      S3SQ = U3*U3/(C3SQ*MAX(A3SQ,B3SQ))
      S4SQ = U4*U4/(C4SQ*MAX(A4SQ,B4SQ))
      IF (MIN(S1SQ,S2SQ) .LT. MIN(S3SQ,S4SQ)) IDX = 1
  100 CONXCH = IDX
      RETURN
C
      END

      PROGRAM PGKEX15
C
C  Illustrate filled area by replicating a basic filled area over a
C  large area to produce a pattern with perceptual multistability.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF,IDUM)
      CALL GOPWK (IWKID,LUNIT,IWTYPE)
      CALL GACWK (IWKID)
C
C  Define colors.
C
      CALL GSCR(IWKID,0,1.,1.,1.)
      CALL GSCR(IWKID,1,0.,0.,1.)
      CALL GSCR(IWKID,2,.4,.0,.4)
C
C  Replicate the small filled area over the entire plot.
C
      DO 20 J=1,8,2
        DO 10 I=1,10,2
          CALL DRWSO(.05+(I-1)*.1,.14+(J-1)*.1,.1,0.)
          CALL DRWSO(.15+(I-1)*.1,.14+(J-1)*.1,.1,180.)
          CALL DRWSO(.05+(I-1)*.1,.24+(J-1)*.1,.1,180.)
          CALL DRWSO(.15+(I-1)*.1,.24+(J-1)*.1,.1,0.)
   10   CONTINUE
   20 CONTINUE
C
C  Label the plot using Plotchar.
C
      CALL PCSETI('FN',25)
      CALL PCSETI('CC',2)
      CALL PLCHHQ(.5,.94,'Filled areas',.035,0.,0.)
C
C  Terminate the picture, deactivate and close the workstation,
C  close GKS.
C
      CALL FRAME
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END
      SUBROUTINE DRWSO(X,Y,SCALE,ANGD)
C
C  Draw the fill area at coordinate (X,Y) at angle ANGD (in degrees)
C  and scaled by SCALE.  Using a higher level of GKS one could use
C  segment transformations to do the rotation, translation, and
C  scaling, but it is done directly here.
C
      PARAMETER (ID=16, H=1.)
      DIMENSION XA(ID),YA(ID),XB(ID),YB(ID)
C
C  Coordinates for the basic fill pattern.
C
      DATA XA /  0.000000,  0.130602,  0.500000,  0.315301,
     -           0.500000,  0.315301,  0.130602,  0.130602,
     -           0.000000, -0.130602, -0.130602, -0.315301,
     -          -0.500000, -0.315301, -0.500000, -0.130602 /
      DATA YA / -0.500000, -0.369398, -0.369398, -0.184699,
     -           0.000000,  0.184699,  0.000000,  0.369398,
     -           0.500000,  0.369398,  0.000000,  0.184699,
     -           0.000000, -0.184699, -0.369398, -0.369398 /
      DATA  RADC/.0174532/
      SAVE XA,YA
C
C  Convert the angle to radians.
C
      ANGR = RADC*ANGD
C
C  Translate, scale, and rotate the object so that its center is
C  at (X,Y).
C
      DO 20 K=1,ID
      XB(K) = X+SCALE*(XA(K)*COS(ANGR)-YA(K)*SIN(ANGR))
      YB(K) = Y+SCALE*(XA(K)*SIN(ANGR)+YA(K)*COS(ANGR))
   20 CONTINUE
      CALL GSFAIS(1)
      CALL GSFACI(1)
      CALL GFA(ID,XB,YB)
      RETURN
      END

      PROGRAM CCPHCF
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C 
C This program demonstrates the use of hachures
C 
      PARAMETER (M=20,N=30,LRWK=3500,LIWK=3500)
      REAL ZREG(M,N), RWRK(LRWK)
      INTEGER IWRK(LIWK)
C 
C Create some data
C 
      CALL GENDAT (ZREG,M,M,N,5,15,5.,15.)
C 
C Open GKS, open and activate a workstation.
C 
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Turn on hachures and demonstrate changing hachure spacing and length
C
      CALL CPSETI('HCF - HACHURING FLAG',2)
      CALL CPSETR('HCS - HACHURE SPACING',.05)
      CALL CPSETR('HCL - HACHURE LENGTH',.01)
C
C Initialize Conpack
C
      CALL CPRECT(ZREG,M,M,N,RWRK,LRWK,IWRK,LIWK)
C
C Draw perimiter
C
      CALL CPBACK(ZREG, RWRK, IWRK)
C
C Draw Contours
C
      CALL CPCLDR(ZREG,RWRK,IWRK)
C     
C Close frame and close GKS
C
      CALL FRAME
C 
C Deactivate and close workstation, close GKS.
C 
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      
      STOP
      END
      SUBROUTINE GENDAT (DATA,IDIM,M,N,MLOW,MHGH,DLOW,DHGH)
C 
C This is a routine to generate test data for two-dimensional graphics
C routines.  Given an array "DATA", dimensioned "IDIM x 1", it fills
C the sub-array ((DATA(I,J),I=1,M),J=1,N) with a two-dimensional field
C of data having approximately "MLOW" lows and "MHGH" highs, a minimum
C value of exactly "DLOW" and a maximum value of exactly "DHGH".
C 
C "MLOW" and "MHGH" are each forced to be greater than or equal to 1
C and less than or equal to 25.
C 
C The function used is a sum of exponentials.
C 
      DIMENSION DATA(IDIM,1),CCNT(3,50)
C 
      FOVM=9./REAL(M)
      FOVN=9./REAL(N)
C 
      NLOW=MAX(1,MIN(25,MLOW))
      NHGH=MAX(1,MIN(25,MHGH))
      NCNT=NLOW+NHGH
C 
      DO 101 K=1,NCNT
         CCNT(1,K)=1.+(REAL(M)-1.)*FRAN()
         CCNT(2,K)=1.+(REAL(N)-1.)*FRAN()
         IF (K.LE.NLOW) THEN
            CCNT(3,K)=-1.
         ELSE
            CCNT(3,K)=+1.
         END IF
 101  CONTINUE
C 
      DMIN=+1.E36
      DMAX=-1.E36
      DO 104 J=1,N
         DO 103 I=1,M
            DATA(I,J)=.5*(DLOW+DHGH)
            DO 102 K=1,NCNT
               TEMP=-((FOVM*(REAL(I)-CCNT(1,K)))**2+
     1              (FOVN*(REAL(J)-CCNT(2,K)))**2)
               IF (TEMP.GE.-20.) DATA(I,J)=DATA(I,J)+
     1              .5*(DHGH-DLOW)*CCNT(3,K)*EXP(TEMP)
 102        CONTINUE
            DMIN=MIN(DMIN,DATA(I,J))
            DMAX=MAX(DMAX,DATA(I,J))
 103     CONTINUE
 104  CONTINUE
C 
      DO 106 J=1,N
         DO 105 I=1,M
            DATA(I,J)=(DATA(I,J)-DMIN)/(DMAX-DMIN)*(DHGH-DLOW)+DLOW
 105     CONTINUE
 106  CONTINUE
C 
      RETURN
C 
      END
      FUNCTION FRAN ()
      DIMENSION RSEQ (100)
      SAVE ISEQ
      DATA RSEQ / .749,.973,.666,.804,.081,.483,.919,.903,.951,.960 ,
     1      .039,.269,.270,.756,.222,.478,.621,.063,.550,.798 ,
     2      .027,.569,.149,.697,.451,.738,.508,.041,.266,.249 ,
     3      .019,.191,.266,.625,.492,.940,.508,.406,.972,.311 ,
     4      .757,.378,.299,.536,.619,.844,.342,.295,.447,.499 ,
     5      .688,.193,.225,.520,.954,.749,.997,.693,.217,.273 ,
     6      .961,.948,.902,.104,.495,.257,.524,.100,.492,.347 ,
     7      .981,.019,.225,.806,.678,.710,.235,.600,.994,.758 ,
     8      .682,.373,.009,.469,.203,.730,.588,.603,.213,.495 ,
     9      .884,.032,.185,.127,.010,.180,.689,.354,.372,.429 /
      DATA ISEQ / 0 /
      ISEQ=MOD(ISEQ,100)+1
      FRAN=RSEQ(ISEQ)
      RETURN
      END

C
C	$Id: csgrcoef.f,v 1.5 2008-07-27 03:10:07 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CSGRCOEF (SIGMA, D,SD)
      DOUBLE PRECISION SIGMA, D, SD
C
C***********************************************************
C
C                                              From SSRFPACK
C                                            Robert J. Renka
C                                  Dept. of Computer Science
C                                       Univ. of North Texas
C                                           renka@cs.unt.edu
C                                                   11/21/96
C
C   This subroutine computes factors involved in the linear
C systems solved by Subroutines CSGRADG and CSSMSGS.
C
C On input:
C
C       SIGMA = Nonnegative tension factor associated with a
C               triangulation arc.
C
C SIGMA is not altered by this routine.
C
C On output:
C
C       D = Diagonal factor.  D = SIG*(SIG*Coshm(SIG) -
C           Sinhm(SIG))/E where E = SIG*Sinh(SIG) - 2*
C           Coshm(SIG).  D > 0, and D = 4 at SIG = 0.
C
C       SD = Off-diagonal factor.  SD = SIG*Sinhm(SIG)/E.
C            SD > 0, and SD = 2 at SIG = 0.
C
C SSRFPACK module required by CSGRCOEF:  CSSNHCSH
C
C Intrinsic function called by CSGRCOEF:  EXP
C
C***********************************************************
C
      DOUBLE PRECISION COSHM, COSHMM, E, EMS, SCM, SIG,
     .                 SINHM, SSINH, SSM
      SIG = SIGMA
      IF (SIG .LT. 1.D-9) THEN
C
C Cubic function:
C
        D = 4.
        SD = 2.
      ELSEIF (SIG .LE. .5) THEN
C
C 0 < SIG .LE. .5.
C
C Use approximations designed to avoid cancellation error
C   in the hyperbolic functions when SIGMA is small.
C
        CALL CSSNHCSH (SIG, SINHM,COSHM,COSHMM)
        E = SIG*SINHM - COSHMM - COSHMM
        D = SIG*(SIG*COSHM-SINHM)/E
        SD = SIG*SINHM/E
      ELSE
C
C SIG > .5.
C
C Scale SINHM, COSHM, and E by 2*EXP(-SIG) in order to
C   avoid overflow when SIGMA is large.
C
        EMS = EXP(-SIG)
        SSINH = 1. - EMS*EMS
        SSM = SSINH - 2.*SIG*EMS
        SCM = (1.-EMS)*(1.-EMS)
        E = SIG*SSINH - SCM - SCM
        D = SIG*(SIG*SCM-SSM)/E
        SD = SIG*SSM/E
      ENDIF
      RETURN
      END

C
C	$Id: csfval.f,v 1.5 2008-07-27 03:10:06 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      DOUBLE PRECISION FUNCTION CSFVAL (B1,B2,B3,V1,V2,V3,F1,
     .                                F2,F3,G1,G2,G3,CSSIG1,
     .                                CSSIG2,SIG3)
      DOUBLE PRECISION B1, B2, B3, V1(3), V2(3), V3(3), F1,
     .                 F2, F3, G1(3), G2(3), G3(3), CSSIG1,
     .                 CSSIG2, SIG3
C
C***********************************************************
C
C                                              From SSRFPACK
C                                            Robert J. Renka
C                                  Dept. of Computer Science
C                                       Univ. of North Texas
C                                           renka@cs.unt.edu
C                                                   05/09/92
C
C   Given data values and gradients at the three vertices of
C a spherical triangle containing a point P, this routine
C computes the value of F at P where F interpolates the ver-
C tex data.  Along the triangle sides, the interpolatory
C function F is the Hermite interpolatory tension spline
C defined by the values and tangential gradient components
C at the endpoints, and the gradient component normal to the
C triangle side varies linearly with respect to arc-length
C between the normal gradient components at the endpoints.
C A first-order C-1 blending method is used on the underly-
C ing planar triangle.  Since values and gradients on an arc
C depend only on the vertex data, the method results in C-1
C continuity when used to interpolate over a triangulation.
C
C   The blending method consists of taking F(P) to be a
C weighted sum of the values at PP of three univariate Her-
C mite interpolatory tension splines defined on the line
C segments which join the vertices to the opposite sides and
C pass through PP:  the central projection of P onto the
C underlying planar triangle.  The tension factors for these
C splines are obtained by linear interpolation between the
C pair of tension factors associated with the triangle sides
C which join at the appropriate vertex.
C
C   A tension factor SIGMA associated with a Hermite interp-
C olatory tension spline is a nonnegative parameter which
C determines the curviness of the spline.  SIGMA = 0 results
C in a cubic spline, and the spline approaches the linear
C interpolant as SIGMA increases.
C
C On input:
C
C       B1,B2,B3 = Barycentric coordinates of PP with re-
C                  spect to the (planar) underlying triangle
C                  (V1,V2,V3), where PP is the central
C                  projection of P onto this triangle.
C
C       V1,V2,V3 = Cartesian coordinates of the vertices of
C                  a spherical triangle containing P.  V3
C                  Left V1->V2.
C
C       F1,F2,F3 = Data values associated with the vertices.
C
C       G1,G2,G3 = Gradients associated with the vertices.
C                  Gi is orthogonal to Vi for i = 1,2,3.
C
C       CSSIG1,CSSIG2,SIG3 = Tension factors associated with the
C                        triangle sides opposite V1, V2, and
C                        V3, respectively.
C
C Input parameters are not altered by this function.
C
C On output:
C
C       CSFVAL = Interpolated value at P.
C
C Each vector V above contains X, Y, and Z components in
C   V(1), V(2), and V(3), respectively.
C
C SSRFPACK modules required by CSFVAL:  CSARCINT, CSARCLEN, CSHVAL
C
C Intrinsic function called by CSFVAL:  SQRT
C
C***********************************************************
C
      DOUBLE PRECISION CSHVAL
      INTEGER I
      DOUBLE PRECISION C1, C2, C3, DS, DUM, DV, F, G(3),
     .                 Q1(3), Q2(3), Q3(3), SIG, SUM, S1,
     .                 S2, S3, U1(3), U2(3), U3(3), U1N,
     .                 U2N, U3N, VAL
C
C Local parameters:
C
C C1,C2,C3 =    Coefficients (weight functions) of partial
C                 interpolants.  C1 = 1 on the edge opposite
C                 V1 and C1 = 0 on the other edges.  Simi-
C                 larly for C2 and C3.  C1+C2+C3 = 1.
C DS =          Directional derivative (scaled by distnace)
C                 at U1, U2, or U3:  DS = (G,U1-V1)/U1N =
C                 -(G,V1)/U1N on side opposite V1, where G/
C                 U1N (plus an orthogonal component) is the
C                 projection of G onto the planar triangle
C DUM =         Dummy variable for calls to CSARCINT
C DV =          Directional derivatives (scaled by distance)
C                 at a vertex:  D1 = (G1,U1-V1) = (G1,U1)
C F,G =         Value and gradient at Q1 Q2, or Q3 obtained
C                 by interpolation along one of the arcs of
C                 the spherical triangle
C I =           DO-loop index
C Q1,Q2,Q3 =    Central projections of U1, U2, and U3 onto
C                 the sphere and thus lying on an arc of the
C                 spherical triangle
C SIG =         Tension factor for a side-vertex (partial)
C                 interpolant:  obtained by linear interpo-
C                 lation applied to triangle side tensions
C SUM =         Quantity used to normalize C1, C2, and C3
C S1,S2,S3 =    Sums of pairs of barycentric coordinates:
C                 used to compute U1, U2, U3, and SIG
C U1,U2,U3 =    Points on the boundary of the planar trian-
C                 gle and lying on the lines containing PP
C                 and the vertices.  U1 is opposite V1, etc.
C U1N,U2N,U3N = Quantities used to compute Q1, Q2, and Q3
C                 (magnitudes of U1, U2, and U3)
C VAL =         Local variable used to accumulate the con-
C                 tributions to CSFVAL
C
C
C Compute weight functions C1, C2, and C3.
C
      C1 = B2*B3
      C2 = B3*B1
      C3 = B1*B2
      SUM = C1 + C2 + C3
      IF (SUM .LE. 0.) THEN
C
C P coincides with a vertex.
C
        CSFVAL = B1*F1 + B2*F2 + B3*F3
        RETURN
      ENDIF
C
C Normalize C1, C2, and C3.
C
      C1 = C1/SUM
      C2 = C2/SUM
      C3 = C3/SUM
C
C Compute (S1,S2,S3), (U1,U2,U3) and (U1N,U2N,U3N).
C
      S1 = B2 + B3
      S2 = B3 + B1
      S3 = B1 + B2
      U1N = 0.
      U2N = 0.
      U3N = 0.
      DO 1 I = 1,3
        U1(I) = (B2*V2(I) + B3*V3(I))/S1
        U2(I) = (B3*V3(I) + B1*V1(I))/S2
        U3(I) = (B1*V1(I) + B2*V2(I))/S3
        U1N = U1N + U1(I)*U1(I)
        U2N = U2N + U2(I)*U2(I)
        U3N = U3N + U3(I)*U3(I)
    1   CONTINUE
C
C Compute Q1, Q2, and Q3.
C
      U1N = SQRT(U1N)
      U2N = SQRT(U2N)
      U3N = SQRT(U3N)
      DO 2 I = 1,3
        Q1(I) = U1(I)/U1N
        Q2(I) = U2(I)/U2N
        Q3(I) = U3(I)/U3N
    2   CONTINUE
C
C Compute interpolated value (VAL) at P by looping on
C   triangle sides.
C
      VAL = 0.
C
C Contribution from side opposite V1:
C
C   Compute value and gradient at Q1 by interpolating
C     between V2 and V3.
C
      CALL CSARCINT (Q1,V2,V3,F2,F3,G2,G3,CSSIG1, F,G,DUM)
C
C   Add in the contribution.
C
      DV = G1(1)*U1(1) + G1(2)*U1(2) + G1(3)*U1(3)
      DS = -(G(1)*V1(1) + G(2)*V1(2) + G(3)*V1(3))/U1N
      SIG = (B2*SIG3 + B3*CSSIG2)/S1
      VAL = VAL + C1*CSHVAL(B1,F1,F,DV,DS,SIG)
C
C Contribution from side opposite V2:
C
C   Compute value and gradient at Q2 by interpolating
C     between V3 and V1.
C
      CALL CSARCINT (Q2,V3,V1,F3,F1,G3,G1,CSSIG2, F,G,DUM)
C
C   Add in the contribution.
C
      DV = G2(1)*U2(1) + G2(2)*U2(2) + G2(3)*U2(3)
      DS = -(G(1)*V2(1) + G(2)*V2(2) + G(3)*V2(3))/U2N
      SIG = (B3*CSSIG1 + B1*SIG3)/S2
      VAL = VAL + C2*CSHVAL(B2,F2,F,DV,DS,SIG)
C
C Contribution from side opposite V3:
C
C   Compute interpolated value and gradient at Q3
C     by interpolating between V1 and V2.
C
      CALL CSARCINT (Q3,V1,V2,F1,F2,G1,G2,SIG3, F,G,DUM)
C
C   Add in the final contribution.
C
      DV = G3(1)*U3(1) + G3(2)*U3(2) + G3(3)*U3(3)
      DS = -(G(1)*V3(1) + G(2)*V3(2) + G(3)*V3(3))/U3N
      SIG = (B1*CSSIG2 + B2*CSSIG1)/S3
      CSFVAL = VAL + C3*CSHVAL(B3,F3,F,DV,DS,SIG)
      RETURN
      END

C
C $Id: tdgrid.f,v 1.4 2008-07-27 00:17:32 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE TDGRID (XBEG,XSTP,NOXS,YBEG,YSTP,NOYS,IGRD)
C
C The routine TDGRID is called to draw a grid in the parallelogram
C defined by the last call to TDPARA.  The arguments are as follows:
C
C   XBEG, XSTP, and NOXS define where ticks or grid lines are to be
C   drawn along the "X" axis of the parallelogram (at XBEG, XBEG+XSTP,
C   XBEG+2*XSTP, ... XBEG+NOXS*XSTP).
C
C   YBEG, YSTP, and NOYS define where ticks or grid lines are to be
C   drawn along the "Y" axis of the parallelogram (at YBEG, YBEG+YSTP,
C   YBEG+2*YSTP, ... YBEG+NOYS*YSTP).
C
C   IGRD defines what is to be drawn and has one of the values 1 (draw
C   just a perimeter), 2 (draw a perimeter with inward-pointing ticks),
C   or 3 (draw a perimeter with a grid).
C
C The code is pretty straightforward ...
C
        IF (IGRD.GT.0) THEN
          CALL TDLNPA (0.,0.,1.,0.)
          CALL TDLNPA (1.,0.,1.,1.)
          CALL TDLNPA (1.,1.,0.,1.)
          CALL TDLNPA (0.,1.,0.,0.)
          IF (IGRD.EQ.2) THEN
            DO 101 I=1,NOXS
              CALL TDLNPA (XBEG+REAL(I-1)*XSTP,0.0,
     +                     XBEG+REAL(I-1)*XSTP,.02)
              CALL TDLNPA (XBEG+REAL(I-1)*XSTP,1.0,
     +                     XBEG+REAL(I-1)*XSTP,.98)
  101       CONTINUE
            DO 102 J=1,NOYS
              CALL TDLNPA (0.0,YBEG+REAL(J-1)*YSTP,
     +                     .02,YBEG+REAL(J-1)*YSTP)
              CALL TDLNPA (1.0,YBEG+REAL(J-1)*YSTP,
     +                     .98,YBEG+REAL(J-1)*YSTP)
  102       CONTINUE
          ELSE IF (IGRD.EQ.3) THEN
            DO 103 I=1,NOXS
              CALL TDLNPA (XBEG+REAL(I-1)*XSTP,0.,
     +                     XBEG+REAL(I-1)*XSTP,1.)
  103       CONTINUE
            DO 104 J=1,NOYS
              CALL TDLNPA (0.,YBEG+REAL(J-1)*YSTP,
     +                     1.,YBEG+REAL(J-1)*YSTP)
  104       CONTINUE
          END IF
        END IF
C
C Done.
C
        RETURN
C
      END

      PROGRAM MPEX05
C
C The program MPEX05 produces a single frame with maximal-area
C views of all the EZMAP projections of the globe.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
        PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Define the label for the top of the map.
C
      CHARACTER*37 PLBL
C
      DATA PLBL / 'MAXIMAL-AREA PROJECTIONS OF ALL TYPES' /
C
C Open GKS.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Turn off the clipping indicator.
C
      CALL GSCLIP (0)
C
C Set the outline-dataset parameter.
C
      CALL MAPSTC ('OU','CO')
C
C Put meridians and parallels every 15 degrees.
C
      CALL MAPSTI ('GR',15)
C
C Reduce the label size.
C
      CALL MAPSTI ('LS',0)
C
C Lambert conformal conic.
C
      CALL MAPPOS (.025,.24375,.63125,.85)
      CALL MAPROJ ('LC',30.,0.,45.)
      CALL MAPDRW
C
C Stereographic.
C
      CALL MAPPOS (.26875,.4875,.63125,.85)
      CALL MAPROJ ('ST',0.,0.,0.)
      CALL MAPDRW
C
C Orthographic.
C
      CALL MAPPOS (.5125,.73125,.63125,.85)
      CALL MAPROJ ('OR',0.,0.,0.)
      CALL MAPDRW
C
C Lambert equal-area.
C
      CALL MAPPOS (.75625,.975,.63125,.85)
      CALL MAPROJ ('LE',0.,0.,0.)
      CALL MAPDRW
C
C Gnomonic.
C
      CALL MAPPOS (.025,.24375,.3875,.60625)
      CALL MAPROJ ('GN',0.,0.,0.)
      CALL MAPDRW
C
C Azimuthal equidistant.
C
      CALL MAPPOS (.26875,.4875,.3875,.60625)
      CALL MAPROJ ('AE',0.,0.,0.)
      CALL MAPDRW
C
C Satellite-view.
C
      CALL MAPPOS (.5125,.73125,.3875,.60625)
      CALL MAPROJ ('SV',0.,0.,0.)
      CALL MAPSTR ('SA',2.)
      CALL MAPDRW
C
C Mercator.
C
      CALL MAPPOS (.75625,.975,.3875,.60625)
      CALL MAPROJ ('ME',0.,0.,0.)
      CALL MAPDRW
C
C Cylindrical equidistant.
C
      CALL MAPPOS (.025,.4875,.13125,.3625)
      CALL MAPROJ ('CE',0.,0.,0.)
      CALL MAPDRW
C
C Mollweide type.
C
      CALL MAPPOS (.5125,.975,.13125,.3625)
      CALL MAPROJ ('MO',0.,0.,0.)
      CALL MAPDRW
C
C Put the label at the top of the plot ...
C
      CALL SET (0.,1.,0.,1.,0.,1.,0.,1.,1)
      CALL PWRIT (.5,.925,PLBL,37,2,0,0)
C
C and the labels under each sub-plot.
C
      CALL PWRIT (.134375,.61875,'LAMBERT CONFORMAL CONIC',
     +                                                  23,0,0,0)
      CALL PWRIT (.378125,.61875,'STEREOGRAPHIC',13,0,0,0)
      CALL PWRIT (.621875,.61875,'ORTHOGRAPHIC',12,0,0,0)
      CALL PWRIT (.865625,.61875,'LAMBERT EQUAL-AREA',18,0,0,0)
      CALL PWRIT (.134375,.375,'GNOMONIC',8,0,0,0)
      CALL PWRIT (.378125,.375,'AZIMUTHAL EQUIDISTANT',21,0,0,0)
      CALL PWRIT (.621875,.375,'SATELLITE-VIEW',14,0,0,0)
      CALL PWRIT (.865625,.375,'MERCATOR',8,0,0,0)
      CALL PWRIT (.25625,.11875,'CYLINDRICAL EQUIDISTANT',
     +                                                  23,0,0,0)
      CALL PWRIT (.74375,.11875,'MOLLWEIDE TYPE',14,0,0,0)
C
C Draw a boundary around the edge of the plotter frame.
C
      CALL BNDARY
C
C Advance the frame.
C
      CALL FRAME
C
C Close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
C Done.
C
      STOP
C
      END
      SUBROUTINE MAPEOD (NOUT,NSEG,IDLS,IDRS,NPTS,PNTS)
C
      DIMENSION PNTS(*)
C
C This version of MAPEOD uses area identifiers for the outline
C dataset 'CO' to suppress all but the major global land masses.
C
      IF (IDLS.NE.  2.AND.IDRS.NE.  2) NPTS=0
C
      IF (IDLS.NE.  1.AND.IDRS.NE.  1.AND.
     +    IDLS.NE.  3.AND.IDRS.NE.  3.AND.
     +    IDLS.NE. 11.AND.IDRS.NE. 11.AND.
     +    IDLS.NE. 79.AND.IDRS.NE. 79.AND.
     +    IDLS.NE. 99.AND.IDRS.NE. 99.AND.
     +    IDLS.NE.104.AND.IDRS.NE.104.AND.
     +    IDLS.NE.107.AND.IDRS.NE.107.AND.
     +    IDLS.NE.163.AND.IDRS.NE.163     ) NPTS=0
C
C Done.
C
      RETURN
C
      END

      SUBROUTINE CFFTI1(N,WA,IFAC)
      DOUBLE PRECISION WA
      DOUBLE PRECISION TPI
      DOUBLE PRECISION DPIMACH
      DOUBLE PRECISION DUM
      DOUBLE PRECISION ARGH
      DOUBLE PRECISION FI
      DOUBLE PRECISION ARGLD
      DOUBLE PRECISION ARG
      DIMENSION WA(*),IFAC(*),NTRYH(4)
      DATA NTRYH(1),NTRYH(2),NTRYH(3),NTRYH(4)/3,4,2,5/

      NL = N
      NF = 0
      J = 0
  101 J = J + 1
      IF (J-4) 102,102,103
  102 NTRY = NTRYH(J)
      GO TO 104
  103 NTRY = NTRY + 2
  104 NQ = NL/NTRY
      NR = NL - NTRY*NQ
      IF (NR) 101,105,101
  105 NF = NF + 1
      IFAC(NF+2) = NTRY
      NL = NQ
      IF (NTRY.NE.2) GO TO 107
      IF (NF.EQ.1) GO TO 107
      DO 106 I = 2,NF
          IB = NF - I + 2
          IFAC(IB+2) = IFAC(IB+1)
  106 CONTINUE
      IFAC(3) = 2
  107 IF (NL.NE.1) GO TO 104
      IFAC(1) = N
      IFAC(2) = NF
      TPI = 2.D0*DPIMACH(DUM)
      ARGH = TPI/DBLE(N)
      I = 2
      L1 = 1
      DO 110 K1 = 1,NF
          IP = IFAC(K1+2)
          LD = 0
          L2 = L1*IP
          IDO = N/L2
          IDOT = IDO + IDO + 2
          IPM = IP - 1
          DO 109 J = 1,IPM
              I1 = I
              WA(I-1) = 1.D0
              WA(I) = 0.D0
              LD = LD + L1
              FI = 0.D0
              ARGLD = DBLE(LD)*ARGH
              DO 108 II = 4,IDOT,2
                  I = I + 2
                  FI = FI + 1.D0
                  ARG = FI*ARGLD
                  WA(I-1) = COS(ARG)
                  WA(I) = SIN(ARG)
  108         CONTINUE
              IF (IP.LE.5) GO TO 109
              WA(I1-1) = WA(I-1)
              WA(I1) = WA(I)
  109     CONTINUE
          L1 = L2
  110 CONTINUE
      RETURN
      END

C
C	$Id: gqppar.f,v 1.6 2008-07-27 00:21:00 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GQPPAR(WTYPE,PPAI,NMX,MMX,ERRIND,N,M,PARRAY)
C
C  INQUIRE PREDEFINED PATTERN REPRESENTATION
C
      include 'gkscom.h'
C
      INTEGER WTYPE,PPAI,NMX,MMX,ERRIND,N,M,PARRAY(NMX,MMX)
C
C  Check if GKS is in the proper state.
C
      CALL GZCKST(8,-1,ERRIND)
      IF (ERRIND .NE. 0) GOTO 100
C
C  Check that the workstation type is valid.
C
      CALL GZCKWK(22,-1,IDUM,WTYPE,ERRIND)
      IF (ERRIND .NE. 0) GO TO 100
C
C  Check if the workstation category is OUTPUT or OUTIN.
C
      CALL GQWKCA(WTYPE,ERRIND,ICAT)
      IF (ICAT.NE.GOUTPT .AND. ICAT.NE.GOUTIN) THEN
        ERRIND = 39
        GO TO 100
      ENDIF
C
C  Check if index is positive.
C
      IF (PPAI.LT.1) THEN
        ERRIND = 85
        GO TO 100
      ENDIF
C
C  Since no drivers currently support pattern representations, return
C  error indicator 90.  When and if any drivers supports pattern fill,
C  uncomment the remaining code.
C
      ERRIND = 90
      GO TO 100
C
C  Invoke interface.
C
C     FCODE = -120
C     CONT  = 0
C     CALL GZROI(0)
C     IL1   = 4
C     IL2   = 4
C     ID(1) = WTYPE
C     ID(2) = PPAI
C     ID(3) = NMX
C     ID(4) = MMX
C     IWK   = -1
C     CALL GZIQWK(WTYPE,IWK)
C     IF (RERR.NE.0) THEN
C       ERRIND = RERR
C       GOTO 100
C     ENDIF
C     N = ID(5)
C     M = ID(6)
C
C  Bring over the pattern array.
C
C     INDX = (N*M-1)/128
C     IF (INDX.EQ.0) THEN
C       CALL GZFMWK
C       INDX = 0
C       DO 200 J=1,M
C         DO 201 I=1,N
C           INDX = INDX+1
C           PARRAY(I,J) = ID(INDX)
C 201     CONTINUE
C 200   CONTINUE
C     ELSE
C       CALL GZFMWK
C       INDX = 0
C       DO 202 J=1,M
C         DO 203 I=1,N
C           INDX = INDX+1
C           PARRAY(I,J) = ID(INDX)
C           JMD = MOD(INDX,128)
C           IF (JMD.EQ.0.AND.CONT.EQ.1) THEN
C            CALL GZFMWK
C            INDX = 0
C           ENDIF
C 203     CONTINUE
C 202   CONTINUE
C     ENDIF
C     RETURN
C
  100 CONTINUE
      N = -1
      M = -1
      PARRAY(1,1) = -1
C
      RETURN
      END

C
C $Id: mpsetl.f,v 1.18 2008-09-18 00:42:18 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MPSETL (WHCH,LVAL)
        CHARACTER*(*) WHCH
        LOGICAL       LVAL
        IF (ICFELL('MPSETL - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
        CALL MDSETL (WHCH,LVAL)
        IF (ICFELL('MPSETL',2).NE.0) RETURN
        RETURN
      END

C
C $Id: pj23sp.f,v 1.5 2008-07-27 00:17:12 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE PJ23SP (COORD,CRDIO,INDIC)
C
C -- M O D I F I E D   S T E R E O G R A P H I C   -   A L A S K A
C
      IMPLICIT REAL (A-Z)
      INTEGER N,J,NN
      INTEGER INDIC
      DIMENSION GEOG(2),PROJ(2),COORD(2),CRDIO(2),
     . ACOEF(6),BCOEF(6)
C **** PARAMETERS **** A,E,ES,LON0,LAT0,X0,Y0,SINPH0,COSPH0 ************
      COMMON /ERRMZ0/ IERR
        INTEGER IERR
      SAVE   /ERRMZ0/
      COMMON /PRINZ0/ IPEMSG,IPELUN,IPPARM,IPPLUN
        INTEGER IPEMSG,IPELUN,IPPARM,IPPLUN
      SAVE   /PRINZ0/
      COMMON /PC23SP/ A,LON0,X0,Y0,ACOEF,BCOEF,EC,LAT0,CCHIO,SCHIO,N
      DATA HALFPI /1.5707963267948966E0/
      DATA EPSLN /1.0E-10/
      DATA ZERO,ONE,TWO /0.0E0,1.0E0,2.0E0/
C
C -- F O R W A R D   . . .
C
      IF (INDIC .EQ. 0) THEN
C
         GEOG(1) = COORD(1)
         GEOG(2) = COORD(2)
         IERR = 0
         IF (MDDASP(GEOG).GT.30.E0) THEN
           IF (IPEMSG.EQ.0) WRITE (IPELUN,2020)
 2020      FORMAT (/' ERROR PJ23SP'/
     .              ' POINT IS TOO FAR FROM CENTER OF PROJECTION')
           IERR = 233
           RETURN
         END IF
         LON = ADJLSP (GEOG(1) - LON0)
C
C     CALCULATE X-PRIME AND Y-PRIME FOR OBLIQUE STEREOGRAPHIC PROJ.
C          FROM LAT/LONG.
C
         SINLON = SIN (LON)
         COSLON = COS (LON)
         ESPHI = EC *SIN(GEOG(2))
         CHI=TWO*ATAN(TAN((HALFPI+GEOG(2))/TWO)*((ONE-ESPHI)/(ONE
     .      +ESPHI))**(EC/TWO)) - HALFPI
         SCHI=SIN(CHI)
         CCHI=COS(CHI)
         G=SCHIO*SCHI+CCHIO*CCHI*COSLON
         S=TWO/(ONE+G)
         XP=S*CCHI*SINLON
         YP=S*(CCHIO*SCHI-SCHIO*CCHI*COSLON)
C
C     USE KNUTH ALGORITHM FOR SUMMING COMPLEX TERMS, TO CONVERT
C     OBLIQUE STEREOGRAPHIC TO MODIFIED-STEREOGRAPHIC COORD.
C
         R=XP+XP
         S=XP*XP+YP*YP
         AR=ACOEF(N)
         AI=BCOEF(N)
         BR=ACOEF(N-1)
         BI=BCOEF(N-1)
         DO 140 J=2,N
         ARN=BR+R*AR
         AIN=BI+R*AI
         IF (J.EQ.N) GO TO 140
         BR=ACOEF(N-J)-S*AR
         BI=BCOEF(N-J)-S*AI
         AR=ARN
         AI=AIN
  140    CONTINUE
         BR=-S*AR
         BI=-S*AI
         AR=ARN
         AI=AIN
         X=XP*AR-YP*AI+BR
         Y=YP*AR+XP*AI+BI
         PROJ(1)=X*A+X0
         PROJ(2)=Y*A+Y0
         CRDIO(1) = PROJ(1)
         CRDIO(2) = PROJ(2)
         RETURN
      END IF
C
C -- I N V E R S E   . . .
C
      IF (INDIC .EQ. 1) THEN
C
         PROJ(1) = COORD(1)
         PROJ(2) = COORD(2)
         IERR = 0
         X = (PROJ(1) - X0)/A
         Y = (PROJ(2) - Y0)/A
         XP=X
         YP=Y
         NN=0
C
C     USE KNUTH ALGORITHM FOR SUMMING COMPLEX TERMS, TO CONVERT
C     MODIFIED-STEREOGRAPHIC CONFORMAL TO OBLIQUE STEREOGRAPHIC
C     COORDINATES (XP,YP).
C
  225    R=XP+XP
         S=XP*XP+YP*YP
         AR=ACOEF(N)
         AI=BCOEF(N)
         BR=ACOEF(N-1)
         BI=BCOEF(N-1)
         CR=N*AR
         CI=N*AI
         DR=(N-1)*BR
         DI=(N-1)*BI
         DO 230 J=2,N
         ARN=BR+R*AR
         AIN=BI+R*AI
         IF (J.EQ.N) GO TO 230
         BR=ACOEF(N-J)-S*AR
         BI=BCOEF(N-J)-S*AI
         AR=ARN
         AI=AIN
         CRN=DR+R*CR
         CIN=DI+R*CI
         DR=(N-J)*ACOEF(N-J)-S*CR
         DI=(N-J)*BCOEF(N-J)-S*CI
         CR=CRN
         CI=CIN
  230    CONTINUE
         BR=-S*AR
         BI=-S*AI
         AR=ARN
         AI=AIN
         FXYR=XP*AR-YP*AI+BR-X
         FXYI=YP*AR+XP*AI+BI-Y
         FPXYR=XP*CR-YP*CI+DR
         FPXYI=YP*CR+XP*CI+DI
         DEN=FPXYR*FPXYR+FPXYI*FPXYI
         DXP=-(FXYR*FPXYR+FXYI*FPXYI)/DEN
         DYP=-(FXYI*FPXYR-FXYR*FPXYI)/DEN
         XP=XP+DXP
         YP=YP+DYP
         DS=ABS(DXP)+ABS(DYP)
         NN=NN+1
         IF (NN.LE.20) GO TO 237
         IF (IPEMSG .EQ. 0) WRITE (IPELUN,235)
  235    FORMAT (/' ERROR PJ23SP'/
     .            ' TOO MANY ITERATIONS IN ITERATING INVERSE')
         IERR = 235
         GO TO 238
  237    IF (DS.GT.EPSLN) GO TO 225
C
C     CONVERT OBLIQUE STEREOGRAPHIC COORDINATES TO LAT/LONG.
C
  238    RH = SQRT (XP * XP + YP * YP)
         Z = TWO * ATAN (RH / TWO)
         SINZ = SIN (Z)
         COSZ = COS (Z)
         GEOG(1) = LON0
         IF (ABS(RH) .GT. EPSLN) GO TO 240
         GEOG(2) = LAT0
         CRDIO(1) = GEOG(1)
         CRDIO(2) = GEOG(2)
         RETURN
  240    CHI = ASINSP (COSZ * SCHIO + YP *SINZ * CCHIO / RH)
         NN=0
         PHI=CHI
  250    ESPHI=EC*SIN(PHI)
         DPHI=TWO*ATAN(TAN((HALFPI+CHI)/TWO)*((ONE+ESPHI)/(ONE-ESPHI))
     .      **(EC/TWO)) - HALFPI - PHI
         PHI = PHI + DPHI
         NN = NN + 1
         IF (NN.LE.20) GO TO 257
         IF (IPEMSG .EQ. 0) WRITE (IPELUN,255)
  255    FORMAT (/' ERROR PJ23SP'/
     .            ' TOO MANY ITERATIONS IN CALCULATING PHI FROM CHI')
         IERR = 236
         GO TO 260
  257    IF (ABS(DPHI).GT.EPSLN) GO TO 250
  260    GEOG(2)=PHI
         GEOG(1) = ADJLSP (LON0 + ATAN2(XP*SINZ, RH*CCHIO*COSZ-YP*SCHIO
     .     *SINZ))
         CRDIO(1) = GEOG(1)
         CRDIO(2) = GEOG(2)
         RETURN
      END IF
C
      END

      REAL             FUNCTION SLANSY( NORM, UPLO, N, A, LDA, WORK )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     October 31, 1992
*
*     .. Scalar Arguments ..
      CHARACTER          NORM, UPLO
      INTEGER            LDA, N
*     ..
*     .. Array Arguments ..
      REAL               A( LDA, * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  SLANSY  returns the value of the one norm,  or the Frobenius norm, or
*  the  infinity norm,  or the  element of  largest absolute value  of a
*  real symmetric matrix A.
*
*  Description
*  ===========
*
*  SLANSY returns the value
*
*     SLANSY = ( max(abs(A(i,j))), NORM = 'M' or 'm'
*              (
*              ( norm1(A),         NORM = '1', 'O' or 'o'
*              (
*              ( normI(A),         NORM = 'I' or 'i'
*              (
*              ( normF(A),         NORM = 'F', 'f', 'E' or 'e'
*
*  where  norm1  denotes the  one norm of a matrix (maximum column sum),
*  normI  denotes the  infinity norm  of a matrix  (maximum row sum) and
*  normF  denotes the  Frobenius norm of a matrix (square root of sum of
*  squares).  Note that  max(abs(A(i,j)))  is not a  matrix norm.
*
*  Arguments
*  =========
*
*  NORM    (input) CHARACTER*1
*          Specifies the value to be returned in SLANSY as described
*          above.
*
*  UPLO    (input) CHARACTER*1
*          Specifies whether the upper or lower triangular part of the
*          symmetric matrix A is to be referenced.
*          = 'U':  Upper triangular part of A is referenced
*          = 'L':  Lower triangular part of A is referenced
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.  When N = 0, SLANSY is
*          set to zero.
*
*  A       (input) REAL array, dimension (LDA,N)
*          The symmetric matrix A.  If UPLO = 'U', the leading n by n
*          upper triangular part of A contains the upper triangular part
*          of the matrix A, and the strictly lower triangular part of A
*          is not referenced.  If UPLO = 'L', the leading n by n lower
*          triangular part of A contains the lower triangular part of
*          the matrix A, and the strictly upper triangular part of A is
*          not referenced.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(N,1).
*
*  WORK    (workspace) REAL array, dimension (LWORK),
*          where LWORK >= N when NORM = 'I' or '1' or 'O'; otherwise,
*          WORK is not referenced.
*
* =====================================================================
*
*     .. Parameters ..
      REAL               ONE, ZERO
      PARAMETER          ( ONE = 1.0E+0, ZERO = 0.0E+0 )
*     ..
*     .. Local Scalars ..
      INTEGER            I, J
      REAL               ABSA, SCALE, SUM, VALUE
*     ..
*     .. External Subroutines ..
      EXTERNAL           SLASSQ
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, MAX, SQRT
*     ..
*     .. Executable Statements ..
*
      IF( N.EQ.0 ) THEN
         VALUE = ZERO
      ELSE IF( LSAME( NORM, 'M' ) ) THEN
*
*        Find max(abs(A(i,j))).
*
         VALUE = ZERO
         IF( LSAME( UPLO, 'U' ) ) THEN
            DO 20 J = 1, N
               DO 10 I = 1, J
                  VALUE = MAX( VALUE, ABS( A( I, J ) ) )
   10          CONTINUE
   20       CONTINUE
         ELSE
            DO 40 J = 1, N
               DO 30 I = J, N
                  VALUE = MAX( VALUE, ABS( A( I, J ) ) )
   30          CONTINUE
   40       CONTINUE
         END IF
      ELSE IF( ( LSAME( NORM, 'I' ) ) .OR. ( LSAME( NORM, 'O' ) ) .OR.
     $         ( NORM.EQ.'1' ) ) THEN
*
*        Find normI(A) ( = norm1(A), since A is symmetric).
*
         VALUE = ZERO
         IF( LSAME( UPLO, 'U' ) ) THEN
            DO 60 J = 1, N
               SUM = ZERO
               DO 50 I = 1, J - 1
                  ABSA = ABS( A( I, J ) )
                  SUM = SUM + ABSA
                  WORK( I ) = WORK( I ) + ABSA
   50          CONTINUE
               WORK( J ) = SUM + ABS( A( J, J ) )
   60       CONTINUE
            DO 70 I = 1, N
               VALUE = MAX( VALUE, WORK( I ) )
   70       CONTINUE
         ELSE
            DO 80 I = 1, N
               WORK( I ) = ZERO
   80       CONTINUE
            DO 100 J = 1, N
               SUM = WORK( J ) + ABS( A( J, J ) )
               DO 90 I = J + 1, N
                  ABSA = ABS( A( I, J ) )
                  SUM = SUM + ABSA
                  WORK( I ) = WORK( I ) + ABSA
   90          CONTINUE
               VALUE = MAX( VALUE, SUM )
  100       CONTINUE
         END IF
      ELSE IF( ( LSAME( NORM, 'F' ) ) .OR. ( LSAME( NORM, 'E' ) ) ) THEN
*
*        Find normF(A).
*
         SCALE = ZERO
         SUM = ONE
         IF( LSAME( UPLO, 'U' ) ) THEN
            DO 110 J = 2, N
               CALL SLASSQ( J-1, A( 1, J ), 1, SCALE, SUM )
  110       CONTINUE
         ELSE
            DO 120 J = 1, N - 1
               CALL SLASSQ( N-J, A( J+1, J ), 1, SCALE, SUM )
  120       CONTINUE
         END IF
         SUM = 2*SUM
         CALL SLASSQ( N, A, LDA+1, SCALE, SUM )
         VALUE = SCALE*SQRT( SUM )
      END IF
*
      SLANSY = VALUE
      RETURN
*
*     End of SLANSY
*
      END

C
C $Id: dpsmth.f,v 1.6 2008-07-27 00:16:59 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE DPSMTH (XCPF,YCPF,IFVL)
C
C DPSMTH is called just like DPDRAW, but it arranges for the curve
C defined by a series of calls - a "first-point" call followed by one
C or more "vector" calls and then a terminating "last-point" call - to
C be smoothed; it then interpolates points on the smoothed curve and
C passes them on to DPDRAW.  Like DPDRAW, DPSMTH tries to be forgiving
C when "first point" and "last point" calls are omitted; in such cases,
C instead of issuing an error message and stopping, it does whatever
C its internal state implies would be the logical action.
C
C Define the lengths of the segment buffers, in which the coordinates
C of points are collected before smoothing takes place, and therefore
C the lengths of the scratch arrays needed by the smoothing routines.
C
        PARAMETER (LSGB=100)
C
C Declare the real/integer common block.
C
        COMMON /DPCMRI/ ANGF,DBPI,EPSI,IDPI,IDPS,ILTL,INDP,IPCF,ISBF,
     +                  ISCF,LCDP,RLS1,RLS2,RMFS,TENS,WCHR,WGAP,WSLD
        SAVE   /DPCMRI/
C
C Declare scratch arrays needed by the smoothing routines.
C
        DIMENSION SCR1(LSGB),SCR2(LSGB),SCR3(LSGB),SCR4(LSGB)
C
C Declare the arrays for the segment buffer, in which the coordinates
C of points defining curves to be smoothed are collected.
C
        DIMENSION XSGB(LSGB),YSGB(LSGB)
C
C Declare which quantities must be preserved from call to call.
C
        SAVE IFSF,NSGB,SBFS,SCR1,SCR2,SCR3,SCR4,SELS,XBFS,XSGB,XELS,
     +       YBFS,YSGB,YELS
C
C Initialize the first-segment flag, which says whether we're working
C on the first segment of a curve or not.
C
        DATA IFSF / 1 /
C
C Initialize the count of the number of points in the segment buffer.
C
        DATA NSGB / 0 /
C
C Initialize some quantities that will otherwise cause the code to blow
C up on some machines with some compilers (because FORTRAN insists on
C evaluating the entire contents of an IF clause, even when it doesn't
C need to).
C
        DATA XBFS,XELS,YBFS,YELS / 4*0. /
C
C Check for an uncleared prior error.
C
        IF (ICFELL('DPSMTH - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C See if the segment buffer needs to be processed and dumped.
C
        IF ((IFVL.NE.1.AND.NSGB.GE.   2).OR.
     +      (IFVL.EQ.1.AND.NSGB.GE.LSGB)) THEN
C
C Yes.  First, determine how slopes are to be computed.
C
          IF (IFSF.NE.0.AND.NSGB.GT.3.AND.
     +        ABS(XSGB(NSGB)-XSGB(1)).LT.EPSI.AND.
     +        ABS(YSGB(NSGB)-YSGB(1)).LT.EPSI) THEN
            ISLP=4
          ELSE IF (IFSF.EQ.0.AND.
     +             ABS(XSGB(1)-XELS).LT.EPSI.AND.
     +             ABS(YSGB(1)-YELS).LT.EPSI) THEN
            ISLP=1
            SLP1=SELS
            IF (ABS(XSGB(NSGB)-XBFS).LT.EPSI.AND.
     +          ABS(YSGB(NSGB)-YBFS).LT.EPSI) THEN
              ISLP=0
              SLPN=SBFS
            END IF
          ELSE
            ISLP=3
          END IF
C
C Then, call MSKRV1 to compute coefficients of the smoothed curve.
C
          CALL MSKRV1 (NSGB,XSGB,YSGB,SLP1,SLPN,
     +                 SCR1,SCR2,SCR3,SCR4,MAX(0.,TENS),ISLP)
          IF (ICFELL('DPSMTH',2).NE.0) RETURN
C
C Determine how many points to interpolate along the curve.
C
          RNIN=REAL(MAX(3,1+INT(SCR4(NSGB)/DBPI)))
C
C Interpolate points along the curve and deliver them to the drawing
C routine.
C
          RIIN=1.
C
  101     IF (RIIN.LT.RNIN) THEN
            CALL MSKRV2 (RIIN/RNIN,XTMP,YTMP,NSGB,
     +                   XSGB,YSGB,SCR1,SCR2,SCR4,MAX(0.,TENS),0,DUMI)
            IF (ICFELL('DPSMTH',3).NE.0) RETURN
          ELSE
            XTMP=XSGB(NSGB)
            YTMP=YSGB(NSGB)
          END IF
C
          CALL DPDRAW (XTMP,YTMP,1)
          IF (ICFELL('DPSMTH',4).NE.0) RETURN
C
          RIIN=RIIN+1.
          IF (RIIN.LE.RNIN) GO TO 101
C
C If we just did the first segment of a curve, save the coordinates
C of the point at its beginning, save the slope that the smoother used
C there, and then turn off the first-segment flag.
C
          IF (IFSF.NE.0) THEN
            XBFS=XSGB(1)
            YBFS=YSGB(1)
            CALL MSKRV2 (0.,XTMP,YTMP,NSGB,
     +                   XSGB,YSGB,SCR1,SCR2,SCR4,MAX(0.,TENS),1,SBFS)
            IF (ICFELL('DPSMTH',5).NE.0) RETURN
            IFSF=0
          END IF
C
C Save the coordinates of the point at the end of the segment just
C done and the slope that the smoother used there.
C
          XELS=XSGB(NSGB)
          YELS=YSGB(NSGB)
          CALL MSKRV2 (1.,XTMP,YTMP,NSGB,
     +                 XSGB,YSGB,SCR1,SCR2,SCR4,MAX(0.,TENS),1,SELS)
          IF (ICFELL('DPSMTH',6).NE.0) RETURN
C
C Copy the last point of the segment to the beginning of the segment
C buffer and reset the number of points in the segment buffer to one.
C
          XSGB(1)=XSGB(NSGB)
          YSGB(1)=YSGB(NSGB)
          NSGB=1
C
        END IF
C
C If the point defined by this call is an initial point, make it the
C only point in the segment buffer, turn on the first-segment flag,
C and deliver the point to the drawing routine.
C
        IF (IFVL.LE.0.OR.(IFVL.EQ.1.AND.NSGB.EQ.0)) THEN
C
          XSGB(1)=XCPF
          YSGB(1)=YCPF
          NSGB=1
C
          IFSF=1
C
          CALL DPDRAW (XCPF,YCPF,0)
          IF (ICFELL('DPSMTH',7).NE.0) RETURN
C
C If the point is not an initial point, just make it the next point in
C the segment buffer (unless the point is too close to the previous
C one, in which case it is just ignored.)
C
        ELSE IF (IFVL.EQ.1.AND.NSGB.NE.0) THEN
C
          IF (ABS(XCPF-XSGB(NSGB)).GT.EPSI.OR.
     +        ABS(YCPF-YSGB(NSGB)).GT.EPSI) THEN
C
            NSGB=NSGB+1
            XSGB(NSGB)=XCPF
            YSGB(NSGB)=YCPF
C
          END IF
C
C If the object of the call was to dump the segment buffer, clear the
C count of points in it, reset the first-segment flag, and re-initialize
C the drawing routine.
C
        ELSE
C
          NSGB=0
          IFSF=1
C
          CALL DPDRAW (0.,0.,2)
          IF (ICFELL('DPSMTH',8).NE.0) RETURN
C
        END IF
C
C Done.
C
        RETURN
C
      END

      PROGRAM CLASS1
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      INTEGER IND(100)
      REAL XBALLN(15),YBALLN(15),XSTR1(2),YSTR1(2)
      REAL XSTR2(8),YSTR2(8), XMOUTH(5),YMOUTH(5),EYE(2)
      REAL XHEAD(28),YHEAD(28),XNECK(2),YNECK(2)
      REAL XBLNKT(11),YBLNKT(11), XTAIL(16),YTAIL(16)
      REAL XRHLEG(8),YRHLEG(8), XBELLY(3),YBELLY(3)
      REAL XFFLEG(14),YFFLEG(14),DST(100)
      
C
C Read in the data
C
      READ (*,*) (XBALLN(I),I=1,15)
      READ (*,*) (YBALLN(I),I=1,15)
      READ (*,*) (XSTR1(I),I=1,2)
      READ (*,*) (YSTR1(I),I=1,2)
      READ (*,*) (XSTR2(I),I=1,8)
      READ (*,*) (YSTR2(I),I=1,8)
      READ (*,*) (XMOUTH(I),I=1,5)
      READ (*,*) (YMOUTH(I),I=1,5)
      READ (*,*) (EYE(I),I=1,2)
      READ (*,*) (XHEAD(I),I=1,28)
      READ (*,*) (YHEAD(I),I=1,28)
      READ (*,*) (XNECK(I),I=1,2)
      READ (*,*) (YNECK(I),I=1,2)
      READ (*,*) (XBLNKT(I),I=1,11)
      READ (*,*) (YBLNKT(I),I=1,11)
      READ (*,*) (XTAIL(I),I=1,16)
      READ (*,*) (YTAIL(I),I=1,16)
      READ (*,*) (XRHLEG(I),I=1,8)
      READ (*,*) (YRHLEG(I),I=1,8)
      READ (*,*) (XBELLY(I),I=1,3)
      READ (*,*) (YBELLY(I),I=1,3)
      READ (*,*) (XFFLEG(I),I=1,14)
      READ (*,*) (YFFLEG(I),I=1,14)
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Set up color table
C
      CALL GSCR(IWKID,0,0.0,0.0,0.0)
      CALL GSCR(IWKID,1,1.0,1.0,1.0)
      CALL GSCR(IWKID,2,1.0,0.7,0.7)
      CALL GSCR(IWKID,3,0.0,1.0,1.0)
      CALL GSCR(IWKID,4,1.0,1.0,0.3)
C
C Set title color and draw title before changing 
C from default normalization transformation
C
      CALL GSPLCI(4)
      CALL PLCHHQ(0.5,.92,'Every dog has his day',.017,0.0,0.0)
C
C Set normalization transformation and scaling
C
      CALL SET(0.1,0.9,0.1,0.9,-4.,14.,0.0,18.0,1)
C
C Set eye color and draw eye
C
      CALL GSPMCI(2)
      CALL POINTS(EYE(1),EYE(2),1,-4,0)
C
C Fill balloon using GKS
C
      CALL GSFAIS(1)
      CALL GSFACI(3)
      CALL GFA(15,XBALLN,YBALLN)
C
C Stipple in patch on dogs back
C
      CALL GSPMCI(1)
      CALL SFSETR('SP - Spacing',.005)
      CALL SFSETI('DO - Dot fill',1)
      CALL SFWRLD(XBLNKT,YBLNKT,11,DST,100,IND,100)
C
C Set dash pattern, and draw outlines
C
      CALL DASHDC('$$$$$$$$$$$$$$$$',1,1)
      CALL CURVED(XBALLN,YBALLN,15)
      CALL CURVED(XSTR1,YSTR1,2)
      CALL CURVED(XSTR2,YSTR2,8)
      CALL CURVED(XMOUTH,YMOUTH,5)
      CALL CURVED(XHEAD,YHEAD,28)
      CALL CURVED(XNECK,YNECK,2)
      CALL CURVED(XTAIL,YTAIL,16)
      CALL CURVED(XRHLEG,YRHLEG,8)
      CALL CURVED(XBELLY,YBELLY,3)
      CALL CURVED(XFFLEG,YFFLEG,14)
      CALL FRAME
C
C Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      STOP
      END

C
C	$Id: gupdvr.f,v 1.7 2008-07-27 00:21:07 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
        SUBROUTINE GUPDVR (RNVAL, IPOINT, IPRIM)
C
C  Update attribute deferral variables for a real-valued attribute.
C
C
C  Parameters:
C
C    INPUT
C      RNVAL   - New value for the attribute item.
C      IPOINT  - Pointer into deferral control variable structures, 
C                and into the index array that gives the start of the
C                primitive in the attribute equivalencing array, 
C                real version.
C      IPRIM   - Output primitive type associated with the attribute 
C                (1=POLYLINE, 2=POLYMARKER, 3=TEXT, 4=FILL AREA).  
C                used to index into other of the control variable 
C                structures.
C
C      OUTPUT
C        Adjustment of attribute deferral control parameters in COMMON.        
C
      include 'g01prm.h'
      include 'g01rqa.h'
      include 'g01ast.h'
      include 'g01adc.h'
C
      REAL    RNVAL(*)
      INTEGER IPOINT, IPRIM
C
      LOGICAL CHGNS
      INTEGER I, IOFF, LNGVAL
C
C  Offset and length of attribute in equivalencing structures.
C
      IOFF   = ABS(IP2AEA(IPOINT))
      LNGVAL = IL2AEA(IPOINT)
C
C  Is the new value different from the last sent?
C
      CHGNS = RNVAL(1).NE.ASAEQV(IOFF)
      DO 10 I=2,LNGVAL
        CHGNS = CHGNS.OR. RNVAL(I).NE.ASAEQV(IOFF+I-1)
   10 CONTINUE
C
      IF (CHGNS) THEN
C
C  New and last sent differ -- set aggregate change-pending parameter.
C
        AGPEND(IPRIM) = .TRUE.
      END IF
C
C  Copy new value to requested.
C
      ARAEQV(IOFF) = RNVAL(1)
      DO 30 I=2,LNGVAL
        ARAEQV(IOFF+I-1) = RNVAL(I)
   30 CONTINUE
C
C  Mark value change.
C
      VALCHG(IPOINT) = CHGNS
C
      RETURN
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C   FFTPACK 5.0
C   Copyright (C) 1995-2004, Scientific Computing Division,
C   University Corporation for Atmospheric Research
C   Licensed under the GNU General Public License (GPL)
C
C   Authors:  Paul N. Swarztrauber and Richard A. Valent
C
C   $Id: cmf4kb.f,v 1.2 2006-11-21 01:10:16 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      SUBROUTINE DCMF4KB(LOT,IDO,L1,NA,CC,IM1,IN1,CH,IM2,IN2,WA)
      DOUBLE PRECISION TI1
      DOUBLE PRECISION TI2
      DOUBLE PRECISION TR4
      DOUBLE PRECISION TI3
      DOUBLE PRECISION TR1
      DOUBLE PRECISION TR2
      DOUBLE PRECISION TI4
      DOUBLE PRECISION TR3
      DOUBLE PRECISION CR3
      DOUBLE PRECISION CI3
      DOUBLE PRECISION CR2
      DOUBLE PRECISION CR4
      DOUBLE PRECISION CI2
      DOUBLE PRECISION CI4
      DOUBLE PRECISION CC(2,IN1,L1,IDO,4),CH(2,IN2,L1,4,IDO),WA(IDO,3,2)
C
C FFTPACK 5.0 auxiliary routine
C
      M1D = (LOT-1)*IM1 + 1
      M2S = 1 - IM2
      IF (IDO.GT.1 .OR. NA.EQ.1) GO TO 102
      DO 101 K = 1,L1
          DO 101 M1 = 1,M1D,IM1
              TI1 = CC(2,M1,K,1,1) - CC(2,M1,K,1,3)
              TI2 = CC(2,M1,K,1,1) + CC(2,M1,K,1,3)
              TR4 = CC(2,M1,K,1,4) - CC(2,M1,K,1,2)
              TI3 = CC(2,M1,K,1,2) + CC(2,M1,K,1,4)
              TR1 = CC(1,M1,K,1,1) - CC(1,M1,K,1,3)
              TR2 = CC(1,M1,K,1,1) + CC(1,M1,K,1,3)
              TI4 = CC(1,M1,K,1,2) - CC(1,M1,K,1,4)
              TR3 = CC(1,M1,K,1,2) + CC(1,M1,K,1,4)
              CC(1,M1,K,1,1) = TR2 + TR3
              CC(1,M1,K,1,3) = TR2 - TR3
              CC(2,M1,K,1,1) = TI2 + TI3
              CC(2,M1,K,1,3) = TI2 - TI3
              CC(1,M1,K,1,2) = TR1 + TR4
              CC(1,M1,K,1,4) = TR1 - TR4
              CC(2,M1,K,1,2) = TI1 + TI4
              CC(2,M1,K,1,4) = TI1 - TI4
  101 CONTINUE
      RETURN
  102 DO 103 K = 1,L1
          M2 = M2S
          DO 103 M1 = 1,M1D,IM1
              M2 = M2 + IM2
              TI1 = CC(2,M1,K,1,1) - CC(2,M1,K,1,3)
              TI2 = CC(2,M1,K,1,1) + CC(2,M1,K,1,3)
              TR4 = CC(2,M1,K,1,4) - CC(2,M1,K,1,2)
              TI3 = CC(2,M1,K,1,2) + CC(2,M1,K,1,4)
              TR1 = CC(1,M1,K,1,1) - CC(1,M1,K,1,3)
              TR2 = CC(1,M1,K,1,1) + CC(1,M1,K,1,3)
              TI4 = CC(1,M1,K,1,2) - CC(1,M1,K,1,4)
              TR3 = CC(1,M1,K,1,2) + CC(1,M1,K,1,4)
              CH(1,M2,K,1,1) = TR2 + TR3
              CH(1,M2,K,3,1) = TR2 - TR3
              CH(2,M2,K,1,1) = TI2 + TI3
              CH(2,M2,K,3,1) = TI2 - TI3
              CH(1,M2,K,2,1) = TR1 + TR4
              CH(1,M2,K,4,1) = TR1 - TR4
              CH(2,M2,K,2,1) = TI1 + TI4
              CH(2,M2,K,4,1) = TI1 - TI4
  103 CONTINUE
      IF (IDO.EQ.1) RETURN
      DO 105 I = 2,IDO
          DO 104 K = 1,L1
              M2 = M2S
              DO 104 M1 = 1,M1D,IM1
                  M2 = M2 + IM2
                  TI1 = CC(2,M1,K,I,1) - CC(2,M1,K,I,3)
                  TI2 = CC(2,M1,K,I,1) + CC(2,M1,K,I,3)
                  TI3 = CC(2,M1,K,I,2) + CC(2,M1,K,I,4)
                  TR4 = CC(2,M1,K,I,4) - CC(2,M1,K,I,2)
                  TR1 = CC(1,M1,K,I,1) - CC(1,M1,K,I,3)
                  TR2 = CC(1,M1,K,I,1) + CC(1,M1,K,I,3)
                  TI4 = CC(1,M1,K,I,2) - CC(1,M1,K,I,4)
                  TR3 = CC(1,M1,K,I,2) + CC(1,M1,K,I,4)
                  CH(1,M2,K,1,I) = TR2 + TR3
                  CR3 = TR2 - TR3
                  CH(2,M2,K,1,I) = TI2 + TI3
                  CI3 = TI2 - TI3
                  CR2 = TR1 + TR4
                  CR4 = TR1 - TR4
                  CI2 = TI1 + TI4
                  CI4 = TI1 - TI4
                  CH(1,M2,K,2,I) = WA(I,1,1)*CR2 - WA(I,1,2)*CI2
                  CH(2,M2,K,2,I) = WA(I,1,1)*CI2 + WA(I,1,2)*CR2
                  CH(1,M2,K,3,I) = WA(I,2,1)*CR3 - WA(I,2,2)*CI3
                  CH(2,M2,K,3,I) = WA(I,2,1)*CI3 + WA(I,2,2)*CR3
                  CH(1,M2,K,4,I) = WA(I,3,1)*CR4 - WA(I,3,2)*CI4
                  CH(2,M2,K,4,I) = WA(I,3,1)*CI4 + WA(I,3,2)*CR4
  104     CONTINUE
  105 CONTINUE
      RETURN
      END

C
C       $Id: shqshep.f,v 1.6 2008-07-27 03:10:13 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE SHQSHEP (N,X,Y,Z,F,NQ,NW,NR, LCELL,LNEXT,
     +                   XYZMIN,XYZDEL,RMAX,RSQ,A,IER)
      INTEGER N, NQ, NW, NR, LCELL(NR,NR,NR), LNEXT(N), IER
      REAL    X(N), Y(N), Z(N), F(N), XYZMIN(3), XYZDEL(3),
     +        RMAX, RSQ(N), A(9,N)
C
C***********************************************************
C
C                                               ROBERT RENKA
C                                       UNIV. OF NORTH TEXAS
C                                             (817) 565-2767
C                                                   01/08/90
C
C  This subroutine computes a set of parameters A and RSQ
C  defining a smooth (once continuously differentiable) tri-
C  variate function Q(X,Y,Z) which interpolates data values
C  F at scattered nodes (X,Y,Z).  The interpolant Q may be
C  evaluated at an arbitrary point by function SH3VAL, and
C  its first derivatives are computed by subroutine SH3GRD.
C  The interpolation scheme is a modified quadratic Shepard
C  method --
C
C  Q = (W(1)*Q(1)+W(2)*Q(2)+..+W(N)*Q(N))/(W(1)+W(2)+..+W(N))
C
C  For trivariate functions W(K) and Q(K).  The nodal functions
C  are given by
C
C  Q(K)(X,Y,Z) = A(1,K)*DX**2 + A(2,K)*DX*DY + A(3,K)*DY**2 +
C                A(4,K)*DX*DZ + A(5,K)*DY*DZ + A(6,K)*DZ**2 +
C                A(7,K)*DX + A(8,K)*DY + A(9,K)*DZ + F(K)
C
C  where DX = (X-X(K)), DY = (Y-Y(K)), and DZ = (Z-Z(K)).
C  Thus, Q(K) is a quadratic function which interpolates the
C  data value at node K.  Its coefficients A(,K) are obtained
C  by a weighted least squares fit to the closest NQ data
C  points with weights similar to W(K).  Note that the radius
C  of influence for the least squares fit is fixed for each
C  K, but varies with K.
C
C  The weights are taken to be
C
C      W(K)(X,Y,Z) = ( (R(K)-D(K))+ / R(K)*D(K) )**2
C
C  where (R(K)-D(K))+ = 0 if R(K) .LE. D(K), and D(K)(X,Y,Z)
C  is the Euclidean distance between (X,Y,Z) and node K.  The
C  radius of influence R(K) varies with K and is chosen so
C  that NW nodes are within the radius.  Note that W(K) is
C  not defined at node (X(K),Y(K),Z(K)), but Q(X,Y,Z) has
C  limit F(K) as (X,Y,Z) approaches (X(K),Y(K),Z(K)).
C
C  ON INPUT --
C
C    N = Number of nodes and associated data values.
C        N .GE. 10.
C
C    X,Y,Z = Arrays of length N containing the Cartesian
C            coordinates of the nodes.
C
C    F = Array of length N containing the data values
C        in one-to-one correspondence with the nodes.
C
C    NQ = Number of data points to be used in the least
C         squares fit for coefficients defining the nodal
C         functions Q(K).  A recommended value is NQ =
C         17.  9 .LE. NQ .LE. MIN(40,N-1).
C
C    NW = Number of nodes within (and defining) the radii
C         of influence R(K) which enter into the weights
C         W(K).  For N sufficiently large, a recommended
C         value is NW = 32.  1 .LE. NW .LE. MIN(40,N-1).
C
C    NR = Number of rows, columns, and planes in the cell
C         grid defined in subroutine SHSTORE3.  A box con-
C         taining the nodes is partitioned into cells in
C         order to increase search efficiency.  NR =
C         (N/3)**(1/3) is recommended.  NR .GE. 1.
C
C  The above parameters are not altered by this routine.
C
C    LCELL = Array of length .GE. NR**3.
C
C    LNEXT = Array of length .GE. N.
C
C    XYZMIN,XYZDEL = Arrays of length .GE. 3.
C
C    RSQ = Array of length .GE. N.
C
C    A = Array of length .GE. 9N.
C
C  ON OUTPUT --
C
C    LCELL = NR by NR by NR array of nodal indices associated
C            with cells.  Refer to SHSTORE3.
C
C    LNEXT = Array of length N containing next-node indices.
C            Refer to SHSTORE3.
C
C    XYZMIN,XYZDEL = Arrays of length 3 containing minimum
C                    nodal coordinates and cell dimensions,
C                    respectively.  Refer to SHSTORE3.
C
C    RMAX = Square root of the largest element in RSQ --
C           maximum radius R(K).
C
C    RSQ = Array containing the squares of the radii R(K)
C          which enter into the weights W(K).
C
C    A = 9 by N array containing the coefficients for
C        quadratic nodal function Q(K) in column K.
C
C  Note that the above output parameters are not defined
C  unless IER = 0.
C
C    IER = Error indicator --
C      IER = 3 - NQ must > 9
C      IER = 4 - NW must be at least 1
C      IER = 5 - must have N < NQ < 41
C      IER = 6 - must have N < NW < 41
C      IER = 7 - cell grid dimensions must be positive
C      IER = 8 - duplicate input points encountered
C      IER = 9 - collinear input, no unique solution
C
C  MODULES REQUIRED BY SHQSHEP -- SHGETNP3, SHGIVENS, SHROT,
C                                SHSETUP, SHSTORE3
C
C  INTRINSIC FUNCTIONS CALLED BY SHQSHEP -- ABS, AMIN1, FLOAT,
C                                          MAX0, MIN0, SQRT
C
C***********************************************************
C
      INTEGER I, IB, IERR, IP1, IRM1, IROW, J, JP1, K, LMAX,
     +        LNP, NEQ, NN, NNQ, NNR, NNW, NP, NPTS(40),
     +        NQWMAX
      REAL    AV, AVSQ, B(10,10), C, DMIN, DTOL, FK, RQ, RS,
     +        RSMX, RSOLD, RTOL, RWS, S, SF, SUM, T, XK, YK,
     +        ZK, XYZDL(3), XYZMN(3)
C
      DATA    RTOL/1.E-5/, DTOL/.01/, SF/1./
C
C  LOCAL PARAMETERS --
C
C  AV =     Root-mean-square distance between K and the
C           nodes in the least squares system (unless
C           additional nodes are introduced for stability).
C           The first 6 columns of the matrix are scaled
C           by 1/AVSQ, the last 3 by 1/AV.
C  AVSQ =   AV*AV
C  B =      Transpose of the augmented regression matrix.
C  C =      First component of the plane rotation used to
C           zero the lower triangle of B**T -- computed
C           by subroutine SHGIVENS
C  DMIN =   Minimum of the magnitudes of the diagonal
C           elements of the regression matrix after
C           zeros are introduced below the diagonal
C  DTOL =   Tolerance for detecting an ill-conditioned
C           system.  The system is accepted when DMIN .GE. DTOL
C  FK =     Data value at node K -- F(K)
C  I =      Index for A, B, NPTS, XYZMIN, XYZMN, XYZDEL, and XYZDL
C  IB =     Do-loop index for back solve
C  IERR =   Error flag for the call to SHSTORE3
C  IP1 =    I+1
C  IRM1 =   IROW-1
C  IROW =   Row index for B
C  J =      Index for A and B
C  JP1 =    J+1
C  K =      Nodal function index and column index for A
C  LMAX =   Maximum number of NPTS elements (must be consistent
C           with the dimension statement above)
C  LNP =    Current length of NPTS
C  NEQ =    Number of equations in the least squares fit
C  NN =     Local copy of N
C  NNQ =    Local copy of NQ
C  NNR =    Local copy of NR
C  NNW =    Local copy of NW
C  NP =     NPTS element
C  NPTS =   Array containing the indices of a sequence of
C           nodes to be used in the least squares fit
C           or to compute RSQ.  The nodes are ordered by
C           distance from K and the last element
C           (usually indexed by LNP) is used only to
C           determine RQ, or RSQ(K) if NW .GT. NQ
C  NQWMAX = MAX(NQ,NW)
C  RQ =     Radius of influence which enters into the
C           weights for Q(K) (see subroutine SHSETUP)
C  RS =     Squared distance between K and NPTS(LNP) --
C           used to compute RQ and RSQ(K)
C  RSMX =   Maximum RSQ element encountered
C  RSOLD =  Squared distance between K and NPTS(LNP-1) --
C           used to compute a relative change in RS
C           between succeeding NPTS elements
C  RTOL =   Tolerance for detecting a sufficiently large
C           relative change in RS.  If the change is
C           not greater than RTOL, the nodes are
C           treated as being the same distance from K
C  RWS =    Current value of RSQ(K)
C  S =      Second component of the plane Givens rotation
C  SF =     Marquardt stabilization factor used to damp
C           out the first 6 solution components (second
C           partials of the quadratic) when the system
C           is ill-conditioned.  As SF increases, the
C           fitting function approaches a linear
C  SUM =    Sum of squared Euclidean distances between
C           node K and the nodes used in the least
C           squares fit (unless additional nodes are
C           added for stability)
C  T =      Temporary variable for accumulating a scalar
C           product in the back solve
C  XK =     Coordinate of node K -- X(K)
C  YK =     Coordinate of node K -- Y(K)
C  ZK =     Coordinate of node K -- Z(K)
C  XYZDL =  Local variables for XYZDEL
C  XYZMN =  Local variables for XYZMIN
C
      NN = N
      NNQ = NQ
      NNW = NW
      NNR = NR
      NQWMAX = MAX0(NNQ,NNW)
      LMAX = MIN0(40,NN-1)
      IF (9 .GT. NNQ) THEN
        GO TO 30
      ELSE IF (1 .GT. NNW) THEN
        GO TO 31
      ELSE IF (NNQ .GT. LMAX) THEN
        GO TO 32
      ELSE IF (NNW .GT. LMAX) THEN
        GO TO 33
      ELSE IF (NNR .LT. 1) THEN
        GO TO 34
      ENDIF
C
C  Create the cell data structure, and initialize RSMX.
C
      CALL SHSTORE3 (NN,X,Y,Z,NNR, LCELL,LNEXT,XYZMN,XYZDL,
     +             IERR)
      IF (IERR .NE. 0) GO TO 22
      RSMX = 0.
C
C  Outer loop on node K
C
      DO 18 K = 1,NN
        XK = X(K)
        YK = Y(K)
        ZK = Z(K)
        FK = F(K)
C
C  Mark node K to exclude it from the search for nearest neighbors.
C
        LNEXT(K) = -LNEXT(K)
C
C  Initialize for loop on NPTS.
C
        RS = 0.
        SUM = 0.
        RWS = 0.
        RQ = 0.
        LNP = 0
C
C  Compute NPTS, LNP, RWS, NEQ, RQ, and AVSQ.
C
    1   SUM = SUM + RS
          IF (LNP .EQ. LMAX) GO TO 3
          LNP = LNP + 1
          RSOLD = RS
          CALL SHGETNP3 (XK,YK,ZK,X,Y,Z,NNR,LCELL,LNEXT,XYZMN,
     +                 XYZDL, NP,RS)
          IF (RS .EQ. 0.) GO TO 21
          NPTS(LNP) = NP
          IF ( (RS-RSOLD)/RS .LT.  RTOL ) GO TO 1
          IF (RWS .EQ. 0.  .AND.  LNP .GT. NNW) RWS = RS
          IF (RQ .NE. 0.  .OR.  LNP .LE. NNQ) GO TO 2
C
C  RQ = 0 (not yet computed) and LNP .GT. NQ.  RQ =
C  SQRT(RS) is sufficiently large to (strictly) include
C  NQ nodes.  The least squares fit will include NEQ =
C  LNP-1 equations for 9 .LE. NQ .LE. NEQ .LT. LMAX .LE. N-1.
C
          NEQ = LNP - 1
          RQ = SQRT(RS)
          AVSQ = SUM/FLOAT(NEQ)
C
C  Bottom of loop -- test for termination.
C
    2     IF (LNP .GT. NQWMAX) GO TO 4
          GO TO 1
C
C  All LMAX nodes are included in NPTS.  RWS and/or RQ**2 is
C  (arbitrarily) taken to be 10 percent larger than the
C  distance RS to the last node included.
C
    3   IF (RWS .EQ. 0.) RWS = 1.1*RS
        IF (RQ .NE. 0.) GO TO 4
          NEQ = LMAX
          RQ = SQRT(1.1*RS)
          AVSQ = SUM/FLOAT(NEQ)
C
C  Store RSQ(K), update RSMX if necessary, and compute AV.
C
    4   RSQ(K) = RWS
        IF (RWS .GT. RSMX) RSMX = RWS
        AV = SQRT(AVSQ)
C
C  Set up the augmented regression matrix (transposed) as the
C  columns of B, and zero out the lower triangle (upper
C  triangle of B) with Givens rotations -- QR decomposition
C  with orthogonal matrix Q not stored.
C
        I = 0
    5     I = I + 1
          NP = NPTS(I)
          IROW = MIN0(I,10)
          CALL SHSETUP (XK,YK,ZK,FK,X(NP),Y(NP),Z(NP),F(NP),
     +                 AV,AVSQ,RQ, B(1,IROW))
          IF (I .EQ. 1) GO TO 5
          IRM1 = IROW-1
          DO 6 J = 1,IRM1
            JP1 = J + 1
            CALL SHGIVENS (B(J,J),B(J,IROW),C,S)
    6       CALL SHROT (10-J,C,S,B(JP1,J),B(JP1,IROW))
          IF (I .LT. NEQ) GO TO 5
C
C  Test the system for ill-conditioning.
C
        DMIN = AMIN1( ABS(B(1,1)),ABS(B(2,2)),ABS(B(3,3)),
     +                ABS(B(4,4)),ABS(B(5,5)),ABS(B(6,6)),
     +                ABS(B(7,7)),ABS(B(8,8)),ABS(B(9,9)) )
        IF (DMIN*RQ .GE. DTOL) GO TO 13
        IF (NEQ .EQ. LMAX) GO TO 10
C
C  Increase RQ and add another equation to the system to
C  improve the conditioning.  The number of NPTS elements
C  is also increased if necessary.
C
    7   RSOLD = RS
        NEQ = NEQ + 1
        IF (NEQ .EQ. LMAX) GO TO 9
        IF (NEQ .EQ. LNP) GO TO 8
C
C  NEQ .LT. LNP
C
        NP = NPTS(NEQ+1)
        RS = (X(NP)-XK)**2 + (Y(NP)-YK)**2 + (Z(NP)-ZK)**2
        IF ( (RS-RSOLD)/RS .LT. RTOL ) GO TO 7
        RQ = SQRT(RS)
        GO TO 5
C
C  Add an element to NPTS.
C
    8   LNP = LNP + 1
        CALL SHGETNP3 (XK,YK,ZK,X,Y,Z,NNR,LCELL,LNEXT,XYZMN,
     +               XYZDL, NP,RS)
        IF (NP .EQ. 0) GO TO 21
        NPTS(LNP) = NP
        IF ( (RS-RSOLD)/RS .LT. RTOL ) GO TO 7
        RQ = SQRT(RS)
        GO TO 5
C
    9   RQ = SQRT(1.1*RS)
        GO TO 5
C
C  Stabilize the system by damping second partials -- add
C  multiples of the first six unit vectors to the first
C  six equations.
C
   10   DO 12 I = 1,6
          B(I,10) = SF
          IP1 = I + 1
          DO 11 J = IP1,10
   11       B(J,10) = 0.
          DO 12 J = I,9
            JP1 = J + 1
            CALL SHGIVENS (B(J,J),B(J,10),C,S)
   12       CALL SHROT (10-J,C,S,B(JP1,J),B(JP1,10))
C
C  Test the stabilized system for ill-conditioning.
C
        DMIN = AMIN1( ABS(B(1,1)),ABS(B(2,2)),ABS(B(3,3)),
     +                ABS(B(4,4)),ABS(B(5,5)),ABS(B(6,6)),
     +                ABS(B(7,7)),ABS(B(8,8)),ABS(B(9,9)) )
        IF (DMIN*RQ .LT. DTOL) GO TO 22
C
C  Solve the 9 by 9 triangular system for the coefficients
C
   13   DO 15 IB = 1,9
          I = 10-IB
          T = 0.
          IF (I .EQ. 9) GO TO 15
          IP1 = I + 1
          DO 14 J = IP1,9
   14       T = T + B(J,I)*A(J,K)
   15     A(I,K) = (B(10,I)-T)/B(I,I)
C
C  Scale the coefficients to adjust for the column scaling.
C
        DO 16 I = 1,6
   16     A(I,K) = A(I,K)/AVSQ
        A(7,K) = A(7,K)/AV
        A(8,K) = A(8,K)/AV
        A(9,K) = A(9,K)/AV
C
C  Unmark k and the elements of NPTS.
C
        LNEXT(K) = -LNEXT(K)
        DO 17 I = 1,LNP
          NP = NPTS(I)
   17     LNEXT(NP) = -LNEXT(NP)
   18   CONTINUE
C
C  No errors encountered.
C
      DO 19 I = 1,3
        XYZMIN(I) = XYZMN(I)
   19   XYZDEL(I) = XYZDL(I)
      RMAX = SQRT(RSMX)
      IER = 0
      RETURN
C
C  N, NQ, NW, or NR is out of range.
C
   30 CONTINUE
      CALL SHERR (3,'SHQSHEP - number of data points used in least squar
     +es fit must be > 9',69)
      IER = 3
      RETURN
   31 CONTINUE
      CALL SHERR (4,'SHQSHEP - NFL (number of points used to calculate w
     +eights) must be at least 1',76)
      IER = 4
      RETURN
   32 CONTINUE
      CALL SHERR (5,'SHQSHEP - number of points used in least squares fi
     +t too large',61)
      IER = 5
      RETURN
   33 CONTINUE
      CALL SHERR (6,'SHQSHEP - number of points used in calculating weig
     +hts too large',63)
      IER = 6
      RETURN
   34 CONTINUE
      CALL SHERR (7,'SHQSHEP - cell grid dimensions must be positive',
     +            47)
      IER = 7
      RETURN
C
C  Duplicate nodes were encountered by SHGETNP3.
C
   21 CONTINUE
      CALL SHERR (8,'SHQSHEP - duplicate input points encountered',44)
      IER = 8
      RETURN
C
C  No unique solution due to collinear nodes.
C
   22 CONTINUE
      DO 23 I = 1,3
        XYZMIN(I) = XYZMN(I)
        XYZDEL(I) = XYZDL(I)
   23 CONTINUE
      CALL SHERR (9,'SHQSHEP - collinear input, no unique solution',45)       
      IER = 9
C
      RETURN
      END

      SUBROUTINE CPOTRF( UPLO, N, A, LDA, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER          UPLO
      INTEGER            INFO, LDA, N
*     ..
*     .. Array Arguments ..
      COMPLEX            A( LDA, * )
*     ..
*
*  Purpose
*  =======
*
*  CPOTRF computes the Cholesky factorization of a complex Hermitian
*  positive definite matrix A.
*
*  The factorization has the form
*     A = U**H * U,  if UPLO = 'U', or
*     A = L  * L**H,  if UPLO = 'L',
*  where U is an upper triangular matrix and L is lower triangular.
*
*  This is the block version of the algorithm, calling Level 3 BLAS.
*
*  Arguments
*  =========
*
*  UPLO    (input) CHARACTER*1
*          = 'U':  Upper triangle of A is stored;
*          = 'L':  Lower triangle of A is stored.
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  A       (input/output) COMPLEX array, dimension (LDA,N)
*          On entry, the Hermitian matrix A.  If UPLO = 'U', the leading
*          N-by-N upper triangular part of A contains the upper
*          triangular part of the matrix A, and the strictly lower
*          triangular part of A is not referenced.  If UPLO = 'L', the
*          leading N-by-N lower triangular part of A contains the lower
*          triangular part of the matrix A, and the strictly upper
*          triangular part of A is not referenced.
*
*          On exit, if INFO = 0, the factor U or L from the Cholesky
*          factorization A = U**H*U or A = L*L**H.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(1,N).
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*          > 0:  if INFO = i, the leading minor of order i is not
*                positive definite, and the factorization could not be
*                completed.
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ONE
      COMPLEX            CONE
      PARAMETER          ( ONE = 1.0E+0, CONE = ( 1.0E+0, 0.0E+0 ) )
*     ..
*     .. Local Scalars ..
      LOGICAL            UPPER
      INTEGER            J, JB, NB
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            ILAENV
      EXTERNAL           LSAME, ILAENV
*     ..
*     .. External Subroutines ..
      EXTERNAL           CGEMM, CHERK, CPOTF2, CTRSM, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      UPPER = LSAME( UPLO, 'U' )
      IF( .NOT.UPPER .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -4
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'CPOTRF', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
*
*     Determine the block size for this environment.
*
      NB = ILAENV( 1, 'CPOTRF', UPLO, N, -1, -1, -1 )
      IF( NB.LE.1 .OR. NB.GE.N ) THEN
*
*        Use unblocked code.
*
         CALL CPOTF2( UPLO, N, A, LDA, INFO )
      ELSE
*
*        Use blocked code.
*
         IF( UPPER ) THEN
*
*           Compute the Cholesky factorization A = U'*U.
*
            DO 10 J = 1, N, NB
*
*              Update and factorize the current diagonal block and test
*              for non-positive-definiteness.
*
               JB = MIN( NB, N-J+1 )
               CALL CHERK( 'Upper', 'Conjugate transpose', JB, J-1,
     $                     -ONE, A( 1, J ), LDA, ONE, A( J, J ), LDA )
               CALL CPOTF2( 'Upper', JB, A( J, J ), LDA, INFO )
               IF( INFO.NE.0 )
     $            GO TO 30
               IF( J+JB.LE.N ) THEN
*
*                 Compute the current block row.
*
                  CALL CGEMM( 'Conjugate transpose', 'No transpose', JB,
     $                        N-J-JB+1, J-1, -CONE, A( 1, J ), LDA,
     $                        A( 1, J+JB ), LDA, CONE, A( J, J+JB ),
     $                        LDA )
                  CALL CTRSM( 'Left', 'Upper', 'Conjugate transpose',
     $                        'Non-unit', JB, N-J-JB+1, CONE, A( J, J ),
     $                        LDA, A( J, J+JB ), LDA )
               END IF
   10       CONTINUE
*
         ELSE
*
*           Compute the Cholesky factorization A = L*L'.
*
            DO 20 J = 1, N, NB
*
*              Update and factorize the current diagonal block and test
*              for non-positive-definiteness.
*
               JB = MIN( NB, N-J+1 )
               CALL CHERK( 'Lower', 'No transpose', JB, J-1, -ONE,
     $                     A( J, 1 ), LDA, ONE, A( J, J ), LDA )
               CALL CPOTF2( 'Lower', JB, A( J, J ), LDA, INFO )
               IF( INFO.NE.0 )
     $            GO TO 30
               IF( J+JB.LE.N ) THEN
*
*                 Compute the current block column.
*
                  CALL CGEMM( 'No transpose', 'Conjugate transpose',
     $                        N-J-JB+1, JB, J-1, -CONE, A( J+JB, 1 ),
     $                        LDA, A( J, 1 ), LDA, CONE, A( J+JB, J ),
     $                        LDA )
                  CALL CTRSM( 'Right', 'Lower', 'Conjugate transpose',
     $                        'Non-unit', N-J-JB+1, JB, CONE, A( J, J ),
     $                        LDA, A( J+JB, J ), LDA )
               END IF
   20       CONTINUE
         END IF
      END IF
      GO TO 40
*
   30 CONTINUE
      INFO = INFO + J - 1
*
   40 CONTINUE
      RETURN
*
*     End of CPOTRF
*
      END

      PROGRAM FFEX00
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Draws a uniform field over an azimuthal projection of the globe
C Continental boundaries are filled with a grayscale value
C
      EXTERNAL FILL
C
      PARAMETER (LMAP=200000,NWRK=20000,ISIZ=5)
      INTEGER MAP(LMAP), IAREA(ISIZ), IGRP(ISIZ)
      REAL XWRK(NWRK), YWRK(NWRK)
C
      PARAMETER (M=18 , N=18)
      DIMENSION A(M,N),B(M,N),WRK(M*N*2)
      PARAMETER (NCLRS=4)
      DIMENSION ICLR(NCLRS)
C
      DIMENSION RGBV(3,NCLRS)
      COMMON /CBFILL/ IFILIX
C
      DATA ICLR / 2, 3, 64, 196 /
      DATA RGBV / 
     +     0.0,1.0,1.0,
     +     0.75,0.0,1.0,
     +     0.75,0.75,0.75,
     +     0.5,0.5,0.5 /
C
C Give initial value to fill color index stored common block CBFILL
C
      IFILIX = 196
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Set up colors for fixed table grayscale and color workstations
C
      CALL GSCR(IWKID,0,0.,0.,0.)
      CALL GSCR(IWKID,1,1.,1.,1.)
      DO 100 I=1,NCLRS,1
         CALL GSCR(IWKID,ICLR(I),RGBV(1,I),RGBV(2,I),RGBV(3,I))
 100  CONTINUE
C     
C Generate uniform field intended for polar input mode.
C
      DO 2 I=1,M
         DO 1 J=1,N
            A(I,J) = 1.0
            B(I,J) = 45.0
 1       CONTINUE
 2    CONTINUE
C
C Set up the map projection
C
      CALL MAPSTC ('OU - OUTLINE DATASET SELECTOR','CO')
      CALL MAPROJ ('AE',0.0,0.0,0.0)
      CALL MAPSET ('MA',0.0,0.0,0.0,0.0)
C
C Initialize Maps and Areas
C
      CALL MAPINT
      CALL ARINAM (MAP,LMAP)
      CALL MAPBLA (MAP)
C    
C Color fill land masses using a gray scale value
C
      CALL GSFAIS (1)
      CALL ARSCAM (MAP, XWRK, YWRK, NWRK, IAREA, IGRP, ISIZ, FILL)
C
C Draw boundaries, including the limb
C
      CALL GSPLCI(ICLR(3))
      CALL MAPSTI ('C4 - LIMB COLOR',ICLR(3))
      CALL MAPSTI('LA - LABEL FLAG',0)
      CALL MAPSTI('EL - ELLIPTICAL-PERIMETER SELECTOR',1)
      CALL MAPLBL
      CALL MAPLOT
C
C Set up Streamline parameters
C
      CALL STSETI('MAP -- Mapping Flag', 1)
      CALL STSETI('SET -- Do Set Call Flag', 0)
      CALL STSETR('XC1 -- Lower X Bound', -180.0)
      CALL STSETR('XCM -- Upper X Bound', 180.0)
      CALL STSETR('YC1 -- Lower Y Bound', -90.0)
      CALL STSETR('YCN -- Upper Y Bound', 90.0)
      CALL STSETI('PLR -- Streamline Polar Flag', 1)
      CALL STSETI('TRP -- Interpolation Method', 1)
      CALL STSETR('SSP -- Stream Spacing', 0.005)
      CALL STSETR('DFM - Differential Magnitude', 0.005)
C
C Set up Vectors parameters
C
      CALL VVSETI('MAP -- Mapping Flag', 1)
      CALL VVSETI('SET -- Do Set Call Flag', 0)
      CALL VVSETR('XC1 -- Lower X Bound', -180.0)
      CALL VVSETR('XCM -- Upper X Bound', 180.0)
      CALL VVSETR('YC1 -- Lower Y Bound', -90.0)
      CALL VVSETR('YCN -- Upper Y Bound', 90.0)
      CALL VVSETI('PLR -- Vector Polar Flag', 1)
      CALL VVSETR('VFR -- Vector Fractional Minimum', 0.7)
      CALL VVSETC('MNT -- Minimum Vector Text', ' ')
      CALL VVSETC('MXT -- Maximum Vector Text', ' ')
C
C Draw Vectors
C
      IDM=0
      RDM=0.0
      CALL GSPLCI(ICLR(2))
      CALL VVINIT(A,M,B,M,RDM,IDM,M,N,RDM,IDM)
      CALL VVECTR(A,B,RDM,IDM,IDM,RDM)
C
C Draw Streamlines
C
      CALL GSPLCI(ICLR(1))
      CALL STINIT(A,M,B,M,RDM,IDM,M,N,WRK,2*M*N)
      CALL STREAM(A,B,RDM,IDM,IDM,WRK)
C
      CALL GSPLCI(1)
C
C Draw a perimeter and eject the frame
C
      CALL PERIM(1,0,1,0)
      CALL FRAME
C
C     Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      STOP
      END
C
      SUBROUTINE FILL (XWRK,YWRK,NWRK,IAREA,IGRP,IDSIZ)
C
      DIMENSION XWRK(*),YWRK(*),IAREA(*),IGRP(*)
C
      COMMON /CBFILL/ IFILIX
C
C Retrieve area id for geographic area
C
      ID = 0
      DO 10, I=1,IDSIZ
         IF (IGRP(I) .EQ. 1) ID = IAREA(I)
 10   CONTINUE
C
C If it's not water, draw it
C
      IF (ID .GE. 1 .AND. MAPACI(ID).NE.1) THEN
         CALL GSFACI(IFILIX)
         CALL GFA(NWRK,XWRK,YWRK)
      ENDIF
C
C Otherwise, do nothing
C
      RETURN
      END

C NCLFORTSTART
      subroutine wksmooth121 (vv,vn,nn,spv,dum)
      implicit none
      integer nn,vn
      double precision vv(vn), spv, dum(vn)
C NCLEND

c NCL procedure:   wk_smooth121( x )

c vv  - input and output
c vn  - length of vv
c nn  - length of vv ... near as I can tell
c spv - missing value
c dum - work array same length as vv

c Smooths vv by passing it through a 1-2-1 filter.
c The first and last points are given 3-1 (1st) or 1-3 (last)
c weightings (Note that this conserves the total sum).
c The routine also skips-over missing data (spv)
c There are 'nn' pieces of useful information, which may be less
c than or equal to 'vn'.
  
      integer i

      i = 0
 10   continue
      i = i+1
      if (vv(i).eq.spv) then
          dum(i) = spv
      elseif(i.eq.1) then
          if(vv(i+1).ne.spv) then
             dum(i) = (3.0d0*vv(i)+vv(i+1))/4.0d0
          else
             dum(i) = vv(i)
          end if
      elseif(vv(i-1).eq.spv) then
          if(vv(i+1).ne.spv) then
             dum(i) = (3.0d0*vv(i)+vv(i+1))/4.0d0
          else
             dum(i) = vv(i)
          end if
      elseif(i.eq.nn.or.vv(i+1).eq.spv) then
          if(vv(i-1).ne.spv) then
             dum(i) = (vv(i-1)+3.0d0*vv(i))/4.0d0
          else
             dum(i) = vv(i)
          end if
      else
           dum(i) = (1.0d0*vv(i-1)+2.0d0*vv(i)+1.0d0*vv(i+1))/4.0d0
      end if
      if (i.ne.nn) go to 10

      do i = 1,nn
         vv(i) = dum(i)
      end do
      end

C
C	$Id: msbsf2.f,v 1.5 2008-07-27 00:17:30 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MSBSF2 (DXMIN,DXMAX,MD,DYMIN,DYMAX,ND,DZ,
     *                   IDZ,M,N,XMIN,XMAX,YMIN,YMAX,Z,IZ,
     *                   ZP,WORK,SIGMA)
C
      DIMENSION DZ(IDZ,ND),Z(IZ,N),ZP(M,N,3),WORK(4,MD)
C
C ---------------------------------------------------------------------
C Note:  This routine comes from a proprietary package called FITPACK.
C It is used in the NCAR graphics package by permission of the author,
C Alan Cline.
C ---------------------------------------------------------------------
C
C                                            CODED BY ALAN KAYLOR CLINE
C                                         FROM FITPACK -- JUNE 22, 1986
C                                   A CURVE AND SURFACE FITTING PACKAGE
C                                 A PRODUCT OF PLEASANT VALLEY SOFTWARE
C                             8603 ALTUS COVE, AUSTIN, TEXAS 78759, USA
C
C ---------------------------------------------------------------------
C
C THIS SUBROUTINE MAPS VALUES ONTO A SURFACE AT EVERY POINT
C OF A GRID EQUALLY SPACED IN BOTH X AND Y COORDINATES. THE
C SURFACE INTERPOLATION IS PERFORMED USING A BI-SPLINE UNDER
C TENSION. THE SUBROUTINE MSBSF1 SHOULD BE CALLED EARLIER TO
C DETERMINE CERTAIN NECESSARY PARAMETERS. IN BOTH MSBSF1 AND
C MSBSF2, THE ORIGINAL GRID IS ASSUMED TO BE EQUALLY SPACED
C IN THE X AND Y COORDINATES.
C
C ON INPUT--
C
C   DXMIN AND DXMAX CONTAIN THE LOWER AND UPPER LIMITS,
C   RESPECTIVELY, OF THE X-COORDINATES OF THE SECOND GRID.
C
C   MD CONTAINS THE NUMBER OF GRID LINES IN THE X DIRECTION
C   OF THE SECOND GRID (MD .GE. 1).
C
C   DYMIN AND DYMAX CONTAIN THE LOWER AND UPPER LIMITS,
C   RESPECTIVELY, OF THE Y-COORDINATES OF THE SECOND GRID.
C
C   ND CONTAINS THE NUMBER OF GRID LINES IN THE Y DIRECTION
C   OF THE SECOND GRID (ND .GE. 1).
C
C   IDZ CONTAINS THE ROW DIMENSION OF THE ARRAY DZ AS
C   DECLARED IN THE CALLING PROGRAM.
C
C   M AND N CONTAIN THE NUMBER OF GRID LINES IN THE X- AND
C   Y-DIRECTIONS, RESPECTIVELY, OF THE RECTANGULAR GRID
C   WHICH SPECIFIED THE SURFACE.
C
C   XMIN AND XMAX ARE THE LOWER AND UPPER LIMITS,
C   RESPECTIVELY, OF THE GRID IN THE X DIRECTION.
C
C   YMIN AND YMAX ARE THE LOWER AND UPPER LIMITS,
C   RESPECTIVELY, OF THE GRID IN THE Y DIRECTION.
C
C   Z IS A MATRIX CONTAINING THE M * N FUNCTIONAL VALUES
C   CORRESPONDING TO THE GRID VALUES (I. E. Z(I,J) IS THE
C   SURFACE VALUE AT THE POINT (X(I),Y(J)) FOR I = 1,...,M
C   AND J = 1,...,N, WHERE X(I) REPRESENTS THE I-TH
C   EQUISPACED X VALUE AND Y(J) REPRESENTS THE J-TH
C   EQUISPACED Y VALUE).
C
C   IZ CONTAINS THE ROW DIMENSION OF THE ARRAY Z AS DECLARED
C   IN THE CALLING PROGRAM.
C
C   ZP IS AN ARRAY OF 3*M*N LOCATIONS STORED WITH THE
C   VARIOUS SURFACE DERIVATIVE INFORMATION DETERMINED BY
C   SURF1.
C
C   WORK IS AN ARRAY OF 4*MD LOCATIONS TO BE USED INTERNALLY
C   FOR WORKSPACE.
C
C   SIGMA CONTAINS THE TENSION FACTOR (ITS SIGN IS IGNORED).
C
C THE PARAMETERS M, N, XMIN, XMAX, YMIN, YMAX, Z, IZ, ZP,
C AND SIGMA SHOULD BE INPUT UNALTERED FROM THE OUTPUT OF
C MSBSF1.
C
C ON OUTPUT--
C
C   DZ CONTAINS THE MD BY ND ARRAY OF SURFACE VALUES
C   INTERPOLATED AT THE POINTS OF THE SECOND GRID.
C
C NONE OF THE INPUT PARAMETERS ARE ALTERED.
C
C THIS FUNCTION REFERENCES PACKAGE MODULE MSSHCH.
C
C-----------------------------------------------------------
C
C DENORMALIZE TENSION FACTOR IN X AND Y DIRECTION
C
      SIGMAX = ABS(SIGMA)*REAL(M-1)/(XMAX-XMIN)
      SIGMAY = ABS(SIGMA)*REAL(N-1)/(YMAX-YMIN)
C
C FIND INTERVALS OF SECOND X GRID WITH RESPECT TO ORIGINAL X
C GRID
C
      DELTDX = 0.
      IF (MD .GE. 2) DELTDX = (DXMAX-DXMIN)/REAL(MD-1)
      DELX = (XMAX-XMIN)/REAL(M-1)
      IF (SIGMAX .NE. 0.) CALL MSSHCH (SINHMS,DUMMY,
     *                                 SIGMAX*DELX,-1)
      DO 2 II = 1,MD
        XII = DXMIN+REAL(II-1)*DELTDX
        I = 2+INT((XII-XMIN)/DELX)
        IF (I .LT. 2) I = 2
        IF (I .GT. M) I = M
        DEL1 = XII-XMIN-REAL(I-2)*DELX
        DEL2 = DELX-DEL1
        WORK(1,II) = DEL2/DELX
        WORK(2,II) = DEL1/DELX
        IF (SIGMAX .NE. 0.) GO TO 1
        TEMP = -DEL1*DEL2/(6.*DELX)
        WORK(3,II) = TEMP*(DEL2+DELX)
        WORK(4,II) = TEMP*(DEL1+DELX)
        GO TO 2
    1   CALL MSSHCH (SINHM1,DUMMY,SIGMAX*DEL1,-1)
        CALL MSSHCH (SINHM2,DUMMY,SIGMAX*DEL2,-1)
        TEMP = SIGMAX*SIGMAX*DELX*(1.+SINHMS)
        WORK(3,II) = DEL2*(SINHM2-SINHMS)/TEMP
        WORK(4,II) = DEL1*(SINHM1-SINHMS)/TEMP
    2   CONTINUE
C
C FIND INTERVALS OF SECOND Y GRID WITH RESPECT TO ORIGINAL Y
C GRID AND PERFORM INTRPOLATION
C
      DELTDY = 0.
      IF (ND .GE. 2) DELTDY = (DYMAX-DYMIN)/REAL(ND-1)
      DELY = (YMAX-YMIN)/REAL(N-1)
      IF (SIGMAY .NE. 0.) CALL MSSHCH (SINHMS,DUMMY,
     *                                 SIGMAY*DELY,-1)
      DO 5 JJ=1,ND
        YJJ = DYMIN+REAL(JJ-1)*DELTDY
        J = 2+INT((YJJ-YMIN)/DELY)
        IF (J .LT. 2) J = 2
        IF (J .GT. N) J = N
        JM1 = J-1
        DEL1 = YJJ-YMIN-REAL(J-2)*DELY
        DEL2 = DELY-DEL1
        C1 = DEL2/DELY
        C2 = DEL1/DELY
        IF (SIGMAY .NE. 0.) GO TO 3
        TEMP = -DEL1*DEL2/(6.*DELY)
        C3 = TEMP*(DEL2+DELY)
        C4 = TEMP*(DEL1+DELY)
        GO TO 4
    3   CALL MSSHCH (SINHM1,DUMMY,SIGMAY*DEL1,-1)
        CALL MSSHCH (SINHM2,DUMMY,SIGMAY*DEL2,-1)
        TEMP = SIGMAY*SIGMAY*DELY*(1.+SINHMS)
        C3 = DEL2*(SINHM2-SINHMS)/TEMP
        C4 = DEL1*(SINHM1-SINHMS)/TEMP
    4   LASTI = 0
        DO 5 II=1,MD
          XII = DXMIN+REAL(II-1)*DELTDX
          I = 2+INT((XII-XMIN)/DELX)
          IF (I .LT. 2) I = 2
          IF (I .GT. M) I = M
          IM1 = I-1
          IF (IM1 .EQ. LASTI) GO TO 5
          LASTI = IM1
          ZIM1 = C1*Z(IM1,JM1)+C2*Z(IM1,J)
     *           +C3*ZP(IM1,JM1,1)+C4*ZP(IM1,J,1)
          ZI = C1*Z(I,JM1)+C2*Z(I,J)
     *         +C3*ZP(I,JM1,1)+C4*ZP(I,J,1)
          ZXXIM1 = C1*ZP(IM1,JM1,2)+C2*ZP(IM1,J,2)
     *             +C3*ZP(IM1,JM1,3)+C4*ZP(IM1,J,3)
          ZXXI = C1*ZP(I,JM1,2)+C2*ZP(I,J,2)
     *           +C3*ZP(I,JM1,3)+C4*ZP(I,J,3)
    5     DZ(II,JJ) = WORK(1,II)*ZIM1+WORK(2,II)*ZI
     *                +WORK(3,II)*ZXXIM1+WORK(4,II)*ZXXI
      RETURN
      END

C
C	$Id: csbdyadd.f,v 1.5 2008-07-27 03:10:06 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CSBDYADD (KK,I1,I2, LIST,LPTR,LEND,LNEW )
      INTEGER KK, I1, I2, LIST(*), LPTR(*), LEND(*), LNEW
C
C***********************************************************
C
C                                              From STRIPACK
C                                            Robert J. Renka
C                                  Dept. of Computer Science
C                                       Univ. of North Texas
C                                           renka@cs.unt.edu
C                                                   07/11/96
C
C   This subroutine adds a boundary node to a triangulation
C of a set of KK-1 points on the unit sphere.  The data
C structure is updated with the insertion of node KK, but no
C optimization is performed.
C
C   This routine is identical to the similarly named routine
C in TRIPACK.
C
C
C On input:
C
C       KK = Index of a node to be connected to the sequence
C            of all visible boundary nodes.  KK .GE. 1 and
C            KK must not be equal to I1 or I2.
C
C       I1 = First (rightmost as viewed from KK) boundary
C            node in the triangulation that is visible from
C            node KK (the line segment KK-I1 intersects no
C            arcs.
C
C       I2 = Last (leftmost) boundary node that is visible
C            from node KK.  I1 and I2 may be determined by
C            Subroutine CSTRFIND.
C
C The above parameters are not altered by this routine.
C
C       LIST,LPTR,LEND,LNEW = Triangulation data structure
C                             created by Subroutine CSTRMESH.
C                             Nodes I1 and I2 must be in-
C                             cluded in the triangulation.
C
C On output:
C
C       LIST,LPTR,LEND,LNEW = Data structure updated with
C                             the addition of node KK.  Node
C                             KK is connected to I1, I2, and
C                             all boundary nodes in between.
C
C Module required by CSBDYADD:  CSINSERT
C
C***********************************************************
C
      INTEGER K, LP, LSAV, N1, N2, NEXT, NSAV
C
C Local parameters:
C
C K =     Local copy of KK
C LP =    LIST pointer
C LSAV =  LIST pointer
C N1,N2 = Local copies of I1 and I2, respectively
C NEXT =  Boundary node visible from K
C NSAV =  Boundary node visible from K
C
      K = KK
      N1 = I1
      N2 = I2
C
C Add K as the last neighbor of N1.
C
      LP = LEND(N1)
      LSAV = LPTR(LP)
      LPTR(LP) = LNEW
      LIST(LNEW) = -K
      LPTR(LNEW) = LSAV
      LEND(N1) = LNEW
      LNEW = LNEW + 1
      NEXT = -LIST(LP)
      LIST(LP) = NEXT
      NSAV = NEXT
C
C Loop on the remaining boundary nodes between N1 and N2,
C   adding K as the first neighbor.
C
    1 LP = LEND(NEXT)
        CALL CSINSERT (K,LP, LIST,LPTR,LNEW )
        IF (NEXT .EQ. N2) GO TO 2
        NEXT = -LIST(LP)
        LIST(LP) = NEXT
        GO TO 1
C
C Add the boundary nodes between N1 and N2 as neighbors
C   of node K.
C
    2 LSAV = LNEW
      LIST(LNEW) = N1
      LPTR(LNEW) = LNEW + 1
      LNEW = LNEW + 1
      NEXT = NSAV
C
    3 IF (NEXT .EQ. N2) GO TO 4
        LIST(LNEW) = NEXT
        LPTR(LNEW) = LNEW + 1
        LNEW = LNEW + 1
        LP = LEND(NEXT)
        NEXT = LIST(LP)
        GO TO 3
C
    4 LIST(LNEW) = -N2
      LPTR(LNEW) = LSAV
      LEND(K) = LNEW
      LNEW = LNEW + 1
      RETURN
      END

MODULE omp_constants
#ifdef _OPENMP
    USE omp_lib

    INTEGER, PARAMETER :: fomp_sched_kind = 4
    INTEGER, PARAMETER :: fomp_lock_kind = 8
    INTEGER, PARAMETER :: fomp_nest_lock_kind = 8
    INTEGER(KIND=4), PARAMETER :: fomp_sched_static = 1
    INTEGER(KIND=4), PARAMETER :: fomp_sched_dynamic = 2
    INTEGER(KIND=4), PARAMETER :: fomp_sched_guided = 3
    INTEGER(KIND=4), PARAMETER :: fomp_sched_auto = 4

#else
    INTEGER, PARAMETER :: fomp_sched_kind = 4
    INTEGER, PARAMETER :: fomp_lock_kind = 4
    INTEGER, PARAMETER :: fomp_nest_lock_kind = 8
    INTEGER(KIND=4), PARAMETER :: fomp_sched_static = 1
    INTEGER(KIND=4), PARAMETER :: fomp_sched_dynamic = 2
    INTEGER(KIND=4), PARAMETER :: fomp_sched_guided = 3
    INTEGER(KIND=4), PARAMETER :: fomp_sched_auto = 4
#endif

END MODULE omp_constants


FUNCTION fomp_enabled()

    IMPLICIT NONE

    !f2py threadsafe

    LOGICAL :: fomp_enabled

#ifdef _OPENMP
    fomp_enabled = .TRUE.
#else
    fomp_enabled = .FALSE.
#endif

END FUNCTION fomp_enabled


SUBROUTINE fomp_set_num_threads(num_threads)
#ifdef _OPENMP
    USE omp_lib
#endif

    IMPLICIT NONE

    !f2py threadsafe

    INTEGER, INTENT(IN) :: num_threads

#ifdef _OPENMP
    CALL omp_set_num_threads(num_threads)
#else
    IF (.FALSE.) PRINT *, num_threads
#endif


END SUBROUTINE fomp_set_num_threads


FUNCTION fomp_get_num_threads()
#ifdef _OPENMP
    USE omp_lib
#endif

    IMPLICIT NONE

    !f2py threadsafe

    INTEGER :: fomp_get_num_threads

#ifdef _OPENMP
    fomp_get_num_threads = omp_get_num_threads()
#else
    fomp_get_num_threads = -1
#endif

END FUNCTION fomp_get_num_threads


FUNCTION fomp_get_max_threads()
#ifdef _OPENMP
    USE omp_lib
#endif

    IMPLICIT NONE

    !f2py threadsafe

    INTEGER :: fomp_get_max_threads

#ifdef _OPENMP
    fomp_get_max_threads = omp_get_max_threads()
#else
    fomp_get_max_threads = -1
#endif

END FUNCTION fomp_get_max_threads


FUNCTION fomp_get_thread_num()
#ifdef _OPENMP
    USE omp_lib
#endif

    IMPLICIT NONE

    !f2py threadsafe

    INTEGER :: fomp_get_thread_num

#ifdef _OPENMP
    fomp_get_thread_num = omp_get_thread_num()
#else
    fomp_get_thread_num = -1
#endif

END FUNCTION fomp_get_thread_num


FUNCTION fomp_get_num_procs()
#ifdef _OPENMP
    USE omp_lib
#endif

    IMPLICIT NONE

    !f2py threadsafe

    INTEGER :: fomp_get_num_procs

#ifdef _OPENMP
    fomp_get_num_procs = omp_get_num_procs()
#else
    fomp_get_num_procs = -1
#endif

END FUNCTION fomp_get_num_procs


FUNCTION fomp_in_parallel()
#ifdef _OPENMP
    USE omp_lib
#endif

    IMPLICIT NONE

    !f2py threadsafe

    LOGICAL :: fomp_in_parallel

#ifdef _OPENMP
    fomp_in_parallel = omp_in_parallel()
#else
    fomp_in_parallel = .FALSE.
#endif

END FUNCTION fomp_in_parallel


SUBROUTINE fomp_set_dynamic(dynamic_threads)
#ifdef _OPENMP
    USE omp_lib
#endif

    IMPLICIT NONE

    !f2py threadsafe

    LOGICAL, INTENT(IN) :: dynamic_threads

#ifdef _OPENMP
    CALL omp_set_dynamic(dynamic_threads)
#else
    IF (.FALSE.) PRINT *, dynamic_threads
#endif

END SUBROUTINE fomp_set_dynamic


FUNCTION fomp_get_dynamic()
#ifdef _OPENMP
    USE omp_lib
#endif

    IMPLICIT NONE

    !f2py threadsafe

    LOGICAL :: fomp_get_dynamic

#ifdef _OPENMP
    fomp_get_dynamic = omp_get_dynamic()
#else
    fomp_get_dynamic = .FALSE.
#endif

END FUNCTION fomp_get_dynamic


SUBROUTINE fomp_set_nested(nested)
#ifdef _OPENMP
    USE omp_lib
#endif

    IMPLICIT NONE

    !f2py threadsafe

    LOGICAL, INTENT(IN) :: nested

#ifdef _OPENMP
    CALL omp_set_nested(nested)
#else
    IF (.FALSE.) PRINT *, nested
#endif

END SUBROUTINE fomp_set_nested


FUNCTION fomp_get_nested()
#ifdef _OPENMP
    USE omp_lib
#endif

    IMPLICIT NONE

    !f2py threadsafe

    LOGICAL :: fomp_get_nested

#ifdef _OPENMP
    fomp_get_nested = omp_get_nested()
#else
    fomp_get_nested = .FALSE.
#endif

END FUNCTION fomp_get_nested


SUBROUTINE fomp_set_schedule(kind, modifier)
#ifdef _OPENMP
    USE omp_lib
#endif
    USE omp_constants, ONLY : fomp_sched_kind

    IMPLICIT NONE

    !f2py threadsafe

    INTEGER(KIND=fomp_sched_kind), INTENT(IN) :: kind
    INTEGER, INTENT(IN) :: modifier

#ifdef _OPENMP
    CALL omp_set_schedule(kind, modifier)
#else
    IF (.FALSE.) PRINT *, kind, modifier
#endif

END SUBROUTINE fomp_set_schedule


SUBROUTINE fomp_get_schedule(kind, modifier)
#ifdef _OPENMP
    USE omp_lib
#endif
    USE omp_constants, ONLY : fomp_sched_kind

    IMPLICIT NONE

    !f2py threadsafe

    INTEGER(KIND=fomp_sched_kind), INTENT(OUT) :: kind
    INTEGER, INTENT(OUT) :: modifier

#ifdef _OPENMP
    CALL omp_get_schedule(kind, modifier)
#else
    kind = -1
    modifier = -1
#endif

END SUBROUTINE fomp_get_schedule


FUNCTION fomp_get_thread_limit()
#ifdef _OPENMP
    USE omp_lib
#endif

    IMPLICIT NONE

    !f2py threadsafe

    INTEGER :: fomp_get_thread_limit

#ifdef _OPENMP
    fomp_get_thread_limit = omp_get_thread_limit()
#else
    fomp_get_thread_limit = -1
#endif

END FUNCTION fomp_get_thread_limit


SUBROUTINE fomp_set_max_active_levels(max_levels)
#ifdef _OPENMP
    USE omp_lib
#endif

    IMPLICIT NONE

    !f2py threadsafe

    INTEGER, INTENT(IN) :: max_levels

#ifdef _OPENMP
    CALL omp_set_max_active_levels(max_levels)
#else
    IF (.FALSE.) PRINT *, max_levels
#endif

END SUBROUTINE fomp_set_max_active_levels


FUNCTION fomp_get_max_active_levels()
#ifdef _OPENMP
    USE omp_lib
#endif

    IMPLICIT NONE

    !f2py threadsafe

    INTEGER :: fomp_get_max_active_levels

#ifdef _OPENMP
    fomp_get_max_active_levels = omp_get_max_active_levels()
#else
    fomp_get_max_active_levels = -1
#endif

END FUNCTION fomp_get_max_active_levels


FUNCTION fomp_get_level()
#ifdef _OPENMP
    USE omp_lib
#endif

    IMPLICIT NONE

    !f2py threadsafe

    INTEGER :: fomp_get_level

#ifdef _OPENMP
    fomp_get_level = omp_get_level()
#else
    fomp_get_level = -1
#endif

END FUNCTION fomp_get_level


FUNCTION fomp_get_ancestor_thread_num(level)
#ifdef _OPENMP
    USE omp_lib
#endif

    IMPLICIT NONE

    !f2py threadsafe

    INTEGER, INTENT(IN) :: level
    INTEGER :: fomp_get_ancestor_thread_num

#ifdef _OPENMP
    fomp_get_ancestor_thread_num = omp_get_ancestor_thread_num(level)
#else
    IF (.FALSE.) PRINT *, level
    fomp_get_ancestor_thread_num = -1
#endif

END FUNCTION fomp_get_ancestor_thread_num


FUNCTION fomp_get_team_size(level)
#ifdef _OPENMP
    USE omp_lib
#endif

    IMPLICIT NONE

    !f2py threadsafe

    INTEGER, INTENT(IN) :: level
    INTEGER :: fomp_get_team_size

#ifdef _OPENMP
    fomp_get_team_size = omp_get_team_size(level)
#else
    IF (.FALSE.) PRINT *, level
    fomp_get_team_size = -1
#endif

END FUNCTION fomp_get_team_size


FUNCTION fomp_get_active_level()
#ifdef _OPENMP
    USE omp_lib
#endif

    IMPLICIT NONE

    !f2py threadsafe

    INTEGER :: fomp_get_active_level

#ifdef _OPENMP
    fomp_get_active_level = omp_get_active_level()
#else
    fomp_get_active_level = -1
#endif

END FUNCTION fomp_get_active_level


FUNCTION fomp_in_final()
#ifdef _OPENMP
    USE omp_lib
#endif

    IMPLICIT NONE

    !f2py threadsafe

    LOGICAL :: fomp_in_final

#ifdef _OPENMP
    fomp_in_final = omp_in_final()
#else
    fomp_in_final = .FALSE.
#endif

END FUNCTION fomp_in_final


SUBROUTINE fomp_init_lock(svar)
#ifdef _OPENMP
    USE omp_lib
#endif
    USE omp_constants, ONLY : fomp_lock_kind

    IMPLICIT NONE

    !f2py threadsafe

    INTEGER(KIND=fomp_lock_kind), INTENT(OUT) :: svar

#ifdef _OPENMP
    CALL omp_init_lock(svar)
#else
    svar = -1
#endif

END SUBROUTINE fomp_init_lock


SUBROUTINE fomp_init_nest_lock(nvar)
#ifdef _OPENMP
    USE omp_lib
#endif
    USE omp_constants, ONLY : fomp_nest_lock_kind

    IMPLICIT NONE

    !f2py threadsafe

    INTEGER(KIND=fomp_nest_lock_kind), INTENT(OUT) :: nvar

#ifdef _OPENMP
    CALL omp_init_nest_lock(nvar)
#else
    nvar = -1
#endif

END SUBROUTINE fomp_init_nest_lock


SUBROUTINE fomp_destroy_lock(svar)
#ifdef _OPENMP
    USE omp_lib
#endif
    USE omp_constants, ONLY : fomp_lock_kind

    IMPLICIT NONE

    !f2py threadsafe

    INTEGER(KIND=fomp_lock_kind), INTENT(INOUT) :: svar

#ifdef _OPENMP
    CALL omp_destroy_lock(svar)
#else
    IF (.FALSE.) PRINT *, svar
#endif


END SUBROUTINE fomp_destroy_lock


SUBROUTINE fomp_destroy_nest_lock(nvar)
#ifdef _OPENMP
    USE omp_lib
#endif
    USE omp_constants, ONLY : fomp_nest_lock_kind

    IMPLICIT NONE

    !f2py threadsafe

    INTEGER(KIND=fomp_nest_lock_kind), INTENT(INOUT) :: nvar

#ifdef _OPENMP
    CALL omp_destroy_nest_lock(nvar)
#else
    IF (.FALSE.) PRINT *, nvar
#endif

END SUBROUTINE fomp_destroy_nest_lock


SUBROUTINE fomp_set_lock(svar)
#ifdef _OPENMP
    USE omp_lib
#endif
    USE omp_constants, ONLY : fomp_lock_kind

    IMPLICIT NONE

    !f2py threadsafe

    INTEGER(KIND=fomp_lock_kind), INTENT(INOUT) :: svar

#ifdef _OPENMP
    CALL omp_set_lock(svar)
#else
    IF (.FALSE.) PRINT *, svar
#endif

END SUBROUTINE fomp_set_lock


SUBROUTINE fomp_set_nest_lock(nvar)
#ifdef _OPENMP
    USE omp_lib
#endif
    USE omp_constants, ONLY : fomp_nest_lock_kind

    IMPLICIT NONE

    !f2py threadsafe

    INTEGER(KIND=fomp_nest_lock_kind), INTENT(INOUT) :: nvar

#ifdef _OPENMP
    CALL omp_set_nest_lock(nvar)
#else
    IF (.FALSE.) PRINT *, nvar
#endif

END SUBROUTINE fomp_set_nest_lock


SUBROUTINE fomp_unset_lock(svar)
#ifdef _OPENMP
    USE omp_lib
#endif
    USE omp_constants, ONLY : fomp_lock_kind

    IMPLICIT NONE

    !f2py threadsafe

    INTEGER(KIND=fomp_lock_kind), INTENT(INOUT) :: svar

#ifdef _OPENMP
    CALL omp_unset_lock(svar)
#else
    IF (.FALSE.) PRINT *, svar
#endif

END SUBROUTINE fomp_unset_lock


SUBROUTINE fomp_unset_nest_lock(nvar)
#ifdef _OPENMP
    USE omp_lib
#endif
    USE omp_constants, ONLY : fomp_nest_lock_kind

    IMPLICIT NONE

    !f2py threadsafe

    INTEGER(KIND=fomp_nest_lock_kind), INTENT(INOUT) :: nvar

#ifdef _OPENMP
    CALL omp_unset_nest_lock(nvar)
#else
    IF (.FALSE.) PRINT *, nvar
#endif

END SUBROUTINE fomp_unset_nest_lock


FUNCTION fomp_test_lock(svar)
#ifdef _OPENMP
    USE omp_lib
#endif
    USE omp_constants, ONLY : fomp_lock_kind

    IMPLICIT NONE

    !f2py threadsafe

    INTEGER(KIND=fomp_lock_kind), INTENT(INOUT) :: svar
    LOGICAL :: fomp_test_lock

#ifdef _OPENMP
    fomp_test_lock =  omp_test_lock(svar)
#else
    IF (.FALSE.) PRINT *, svar
    fomp_test_lock = .FALSE.
#endif



END FUNCTION fomp_test_lock


FUNCTION fomp_test_nest_lock(nvar)
#ifdef _OPENMP
    USE omp_lib
#endif
    USE omp_constants, ONLY : fomp_nest_lock_kind

    IMPLICIT NONE

    !f2py threadsafe

    INTEGER(KIND=fomp_nest_lock_kind), INTENT(INOUT) :: nvar
    INTEGER :: fomp_test_nest_lock

#ifdef _OPENMP
    fomp_test_nest_lock =  omp_test_nest_lock(nvar)
#else
    IF (.FALSE.) PRINT *, nvar
    fomp_test_nest_lock = -1
#endif



END FUNCTION fomp_test_nest_lock


FUNCTION fomp_get_wtime()
#ifdef _OPENMP
    USE omp_lib
#endif

    IMPLICIT NONE

    !f2py threadsafe

    REAL (KIND=8) :: fomp_get_wtime

#ifdef _OPENMP
    fomp_get_wtime =  omp_get_wtime()
#else
    fomp_get_wtime = -1
#endif



END FUNCTION fomp_get_wtime


FUNCTION fomp_get_wtick()
#ifdef _OPENMP
    USE omp_lib
#endif

    IMPLICIT NONE

    !f2py threadsafe

    REAL (KIND=8) :: fomp_get_wtick

#ifdef _OPENMP
    fomp_get_wtick =  omp_get_wtick()
#else
    fomp_get_wtick = -1
#endif



END FUNCTION fomp_get_wtick

      SUBROUTINE PRESHYBRID(P0,PS,HYA,HYB,KLVL,PHY)
      IMPLICIT NONE

c NCL: phy  = pres_hybrid (ps,p0,hya,hyb)
c      klvl = dimsizes(hya)
c                              input
      INTEGER KLVL
      DOUBLE PRECISION P0,PS,HYA(KLVL),HYB(KLVL)
c                              output
      DOUBLE PRECISION PHY(KLVL)
c                              local
      INTEGER K

      DO K = 1,KLVL
          PHY(K) = P0*HYA(K) + HYB(K)*PS
      END DO

      RETURN
      END

      SUBROUTINE DPRESHYBRID(P0,PS,HYAI,HYBI,KLVL,DPHY)
      IMPLICIT NONE

c NCL: dphy  = dpres_hybrid (ps,p0,hyai,hybi)
c      klvl  = dimsizes(hyai)

c this routine interploates ccm2/3 hybrid coordinate data
c     to pressure coordinates. These are ordered from top-to-bottom.

c     formula for the pressure of a hybrid surface is;
c          phy(k) = hya(k)*p0 + hyb(k)*psfc

c     input
c          hyai   - is the "a" or pressure hybrid coef
c          hybi   - is the "b" or sigma coeficient
c          p0     - is the base pressure in pascals [Pa]
c          psfc   - is the surface pressure in pascals [Pa]
c     output
c          dphy    - delta pressure [Pa]
c                              INPUT
      INTEGER KLVL
      DOUBLE PRECISION P0,PS,HYAI(KLVL),HYBI(KLVL)
c                              OUTPUT
      DOUBLE PRECISION DPHY(KLVL-1)
c                              LOCAL
      INTEGER K

      DO K = 1,KLVL - 1
          DPHY(K) = ABS(P0* (HYAI(K+1)-HYAI(K))+ (HYAI(K+1)-HYBI(K))*PS)
      END DO

      RETURN
      END

C
C	$Id: rascls.f,v 1.4 2008-07-27 12:23:44 haley Exp $
C                                                                      
C			     Copyright (C)  1997
C	     University Corporation for Atmospheric Research
C			     All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C

      SUBROUTINE RASCLS(WHICH, IOS, STATUS)
C
C
C  Process the RASTER keywords.
C
C
C  INPUT
C       WHICH   --  the encoded path flags.
C
C  OUTPUT
C       IOS     --  I/O status flag.  This flag is valid only
C                   if STATUS indicates an error.
C       STATUS  --  The error status as defined in COMMON CAPERR.
C
C
      COMMON /PARTB1/ PART1, KEYSEP, KEYTER, FRMCOM
      COMMON /PARTB2/ PART2, PART3, PART4, PART5, CTSTR, CTLOC
C
C  THE NUMBER OF WORDS IN THE SEARCH PATH MUST BE BIG ENOUGH TO HOLD
C       THE NUMBER OF BITS PER PATH TIMES THE NUMBER OF LEVELS
C
      INTEGER WHSIZE
      PARAMETER (WHSIZE=20)
C
      INTEGER PARTSZ, OTHSZ, NTABLE
      PARAMETER(PARTSZ=3000, OTHSZ=150, NTABLE=50)
      CHARACTER*1 KEYSEP,KEYTER
      CHARACTER*1 FRMCOM(2)
      INTEGER PART2(OTHSZ), PART3(OTHSZ), PART4(NTABLE), PART5(NTABLE*2)
      CHARACTER*1 PART1(PARTSZ)
      INTEGER CTSTR, CTLOC
      COMMON /CAPSCN/ SCSSTR, SCSSIZ, SCTSTR, SCTSIZ, SCNLLX,
     1                SCNLLY, SCNURX, SCNURY, SCNXOF, SCNYOF,
     2                SCNXSC, SCNYSC, SCNFMT, SCNFIN, SCVFMT,
     3                SCVFIN, SCNSIM
      INTEGER         SCSMAX, SCTMAX, SFMMAX, SFNMAX, SCVFMX,
     1                SCVFIX
      PARAMETER  (SCSMAX=50, SCTMAX=50, SFMMAX=10, SFNMAX=8)
      PARAMETER  (SCVFMX=10, SCVFIX=8)
      INTEGER         SCSSTR(SCSMAX), SCSSIZ, SCTSTR(SCTMAX), SCTSIZ,
     2                SCNLLX, SCNLLY, SCNURX, SCNURY, SCNXOF, SCNYOF,
     3                SCNFMT(SFMMAX,4)      , SCNFIN(SFNMAX),
     4                SCVFMT(SCVFMX,4)      , SCVFIN(SCVFIX)
      REAL            SCNXSC, SCNYSC, SCNRIN(SFNMAX), SCVRIN(SCVFIX)
      LOGICAL         SCNSIM
      INTEGER         LENSCN
      PARAMETER  (LENSCN=SCSMAX+1+SCTMAX+1+1+1+1+1+1+1+1+1+
     1                   (SFMMAX*4)+SFNMAX+(SCVFMX*4)+SCVFIX+1)
      EQUIVALENCE (SCNFIN,SCNRIN), (SCVFIN,SCVRIN)
C
      INTEGER WHICH(WHSIZE), IOS, STATUS
      INTEGER ROW1, ROW2, ROW3
      INTEGER DUMMY, HOLDER(SFNMAX*4), II, JJ
C
C  Branch to the proper level 2 processing.
C
      ROW1 = WHICH(2)
      ROW2 = WHICH(3)
C
C  RASTER class processing--
C
C      ROW1    ROW2    ROW3     Keyword
C      ----    ----    ----     --------------------------------------
C       1       1               RASTER_COORD_LOWER_LEFT_X
C       1       2               RASTER_COORD_LOWER_LEFT_Y
C       1       3               RASTER_COORD_UPPER_RIGHT_X
C       1       4               RASTER_COORD_UPPER_RIGHT_Y
C       1       7               RASTER_COORD_XOFFSET
C       1       8               RASTER_COORD_YOFFSET
C       1       9               RASTER_COORD_XSCALE
C       1      10               RASTER_COORD_YSCALE
C       2       1               RASTER_DATA_FORMAT
C       2       2               RASTER_DATA_ENCODING
C       2       3               RASTER_DATA_FLOATING_INFO
C       3       1       1       RASTER_VECTOR_COUNT_FORMAT
C       3       1       2       RASTER_VECTOR_COUNT_ENCODING
C       3       1       3       RASTER_VECTOR_COUNT_FLOATING_INFO
C       4       1       1       RASTER_HORIZONTAL_INSTRUCTION_START
C       4       1       2       RASTER_HORIZONTAL_INSTRUCTION_TERMINATOR
C       5                       RASTER_SIMULATE
C
      IF (ROW1.EQ.1 .AND. ROW2.EQ.1) THEN
        CALL GTINT(SCNLLX, 1, DUMMY, IOS, STATUS)
      ELSE IF (ROW1.EQ.1 .AND. ROW2.EQ.2) THEN
        CALL GTINT(SCNLLY, 1, DUMMY, IOS, STATUS)
      ELSE IF (ROW1.EQ.1 .AND. ROW2.EQ.3) THEN
        CALL GTINT(SCNURX, 1, DUMMY, IOS, STATUS)
      ELSE IF (ROW1.EQ.1 .AND. ROW2.EQ.4) THEN
        CALL GTINT(SCNURY, 1, DUMMY, IOS, STATUS)
      ELSE IF (ROW1.EQ.1 .AND. ROW2.EQ.7) THEN
        CALL GTINT(SCNXOF, 1, DUMMY, IOS, STATUS)
      ELSE IF (ROW1.EQ.1 .AND. ROW2.EQ.8) THEN
        CALL GTINT(SCNYOF, 1, DUMMY, IOS, STATUS)
      ELSE IF (ROW1.EQ.1 .AND. ROW2.EQ.9) THEN
        CALL GTFLT(SCNXSC, 1, DUMMY, IOS, STATUS)
      ELSE IF (ROW1.EQ.1 .AND. ROW2.EQ.10) THEN
        CALL GTFLT(SCNYSC, 1, DUMMY, IOS, STATUS)
      ELSE IF (ROW1.EQ.2 .AND. ROW2.EQ.1) THEN
        CALL GTINT(HOLDER, SFMMAX*4, DUMMY, IOS, STATUS)
        IF (DUMMY .NE. 0) THEN
                SCNFIN(2) = DUMMY/4
                DO 10 II = 1,SCNFIN(2)
                DO 10 JJ = 1,4
                        SCNFMT(II,JJ) = HOLDER((II-1)*4+JJ)
 10             CONTINUE
        END IF
      ELSE IF (ROW1.EQ.2 .AND. ROW2.EQ.2) THEN
        CALL GTINT(SCNFIN(1), 1, DUMMY, IOS, STATUS)
      ELSE IF (ROW1.EQ.2 .AND. ROW2.EQ.3) THEN
        CALL GTFLT(SCNRIN(5), 4, DUMMY, IOS, STATUS)
      ELSE IF (ROW1.EQ.5) THEN
        CALL GTLOG(SCNSIM, 1, DUMMY, IOS, STATUS)
      ELSE IF (ROW1.EQ.4) THEN
        ROW3 = WHICH(4)
        IF(ROW2.EQ.1 .AND. ROW3.EQ.1) THEN
                CALL GTSTR(SCSSTR, SCSMAX, SCSSIZ, IOS, STATUS)
        ELSE IF (ROW2.EQ.1 .AND. ROW3.EQ.2) THEN
                CALL GTSTR(SCTSTR, SCTMAX, SCTSIZ, IOS, STATUS)
        END IF
      ELSE IF (ROW1.EQ.3 .AND.ROW2.EQ.1) THEN
        ROW3 = WHICH(4)
        IF (ROW3.EQ.1) THEN
                CALL GTINT(HOLDER, SCVFMX*4, DUMMY, IOS, STATUS)
                IF (DUMMY .NE. 0) THEN
                        SCVFIN(2) = DUMMY/4
                        DO 20 II = 1,SCVFIN(2)
                        DO 20 JJ = 1,4
                                SCVFMT(II,JJ) = HOLDER((II-1)*4+JJ)
 20                     CONTINUE
                END IF
        ELSE IF (ROW3.EQ.2) THEN
                CALL GTINT(SCVFIN(1), 1, DUMMY, IOS, STATUS)
        ELSE IF (ROW3.EQ.3) THEN
                CALL GTFLT(SCVRIN(5), 4, DUMMY, IOS, STATUS)
        END IF
C
      END IF
      RETURN
      END

C
C $Id: ticks.f,v 1.7 2008-07-27 00:17:14 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE TICKS (LMJR,LMNR)
        IF (ICFELL('TICKS - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
        CALL TICK4 (LMJR,LMNR,LMJR,LMNR)
        IF (ICFELL('TICKS',2).NE.0) RETURN
        RETURN
      END

C
C $Id: plchhz.f,v 1.2 2008-07-27 00:17:20 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE PLCHHZ (XPOS,YPOS,SLEN,CHRS,SIZE,ANGD,CNTR)
C
        CHARACTER CHRS*(*)
C
C This routine is just like PLCHHQ (which it eventually calls), but it
C has an additional argument SLEN which is the desired length, in the
C fractional coordinate system, of the character string written.  If
C the length of the string without zooming is between 4/5ths and 5/4ths
C of the desired length, the capability of zooming in the X direction
C is used to make the string have exactly the desired length.  This can
C be used to generate paragraphs that are justified on both left and
C right.
C
C First, save current values of some internal parameters of PLOTCHAR.
C
        CALL PCGETI ('TE',ISTE)
        CALL PCGETR ('ZX',ZOOX)
        CALL PCGETR ('ZY',ZOOY)
        CALL PCGETR ('ZZ',ZOOZ)
C
C Reset the parameters.
C
        CALL PCSETI ('TE',1)
        CALL PCSETR ('ZX',1.)
        CALL PCSETR ('ZY',1.)
        CALL PCSETR ('ZZ',1.)
C
C Find the length of the unzoomed character string.
C
        CALL PLCHHQ (XPOS,YPOS,CHRS,SIZE,360.,CNTR)
        CALL PCGETR ('DL',DLFT)
        CALL PCGETR ('DR',DRGT)
C
C If the zoom factor required to make the character string have the
C desired length is in the acceptable range, use it.
C
        ZOOM=SLEN/(DLFT+DRGT)
        IF (ZOOM.GT..8.AND.ZOOM.LT.1.25) THEN
          CALL PCSETR ('ZX',ZOOM)
        END IF
C
C Write the character string.
C
        CALL PLCHHQ (XPOS,YPOS,CHRS,SIZE,MOD(ANGD,360.),CNTR)
C
C Reset internal parameters of PLOTCHAR that might have been changed.
C
        CALL PCSETI ('TE',ISTE)
        CALL PCSETR ('ZX',ZOOX)
        CALL PCSETR ('ZY',ZOOY)
        CALL PCSETR ('ZZ',ZOOZ)
C
C Done.
C
        RETURN
C
      END

C
C $Id: mdplot.f,v 1.10 2008-09-18 00:42:17 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MDPLOT
C
C Declare required common blocks.  See MAPBDX for descriptions of these
C common blocks and the variables in them.
C
        COMMON /MAPCM0/  COS1,DTOR,DTRH,OOPI,PI,PIOF,PIOT,RTDD,RTOD,
     +                   SROT,SIN1,TOPI,TSRT
        DOUBLE PRECISION COS1,DTOR,DTRH,OOPI,PI,PIOF,PIOT,RTDD,RTOD,
     +                   SROT,SIN1,TOPI,TSRT
        SAVE   /MAPCM0/
C
        COMMON /MAPCM2/  BLAM,BLOM,PEPS,SLAM,SLOM,UCEN,UMAX,UMIN,UOFF,
     +                   URNG,VCEN,VMAX,VMIN,VOFF,VRNG,ISSL
        DOUBLE PRECISION BLAM,BLOM,PEPS,SLAM,SLOM,UCEN,UMAX,UMIN,UOFF,
     +                   URNG,VCEN,VMAX,VMIN,VOFF,VRNG
        INTEGER          ISSL
        SAVE   /MAPCM2/
C
        COMMON /MAPCM3/  ITPN,NOUT,NPTS,IGID,IDLS,IDRS,BLAG,SLAG,BLOG,
     +                   SLOG,PNTS(200),IDOS(4)
        INTEGER          ITPN,NOUT,NPTS,IGID,IDLS,IDRS,IDOS
        REAL             BLAG,SLAG,BLOG,SLOG,PNTS
        SAVE   /MAPCM3/
C
        COMMON /MAPCM4/  GRDR,GRID,GRLA,GRLO,GRPO,OTOL,PDRE,PLA1,PLA2,
     +                   PLA3,PLA4,PLB1,PLB2,PLB3,PLB4,PLNO,PLTO,ROTA,
     +                   SRCH,XLOW,XROW,YBOW,YTOW,IDOT,IDSH,IDTL,ILCW,
     +                   ILTS,JPRJ,ELPF,INTF,LBLF,PRMF
        DOUBLE PRECISION GRDR,GRID,GRLA,GRLO,GRPO,OTOL,PDRE,PLA1,PLA2,
     +                   PLA3,PLA4,PLB1,PLB2,PLB3,PLB4,PLNO,PLTO,ROTA,
     +                   SRCH,XLOW,XROW,YBOW,YTOW
        INTEGER          IDOT,IDSH,IDTL,ILCW,ILTS,JPRJ
        LOGICAL          ELPF,INTF,LBLF,PRMF
        SAVE   /MAPCM4/
C
C Declare local variables.
C
        INTEGER          IGIS,IWGF,K,NSEG
C
C Check for an uncleared prior error.
C
        IF (ICFELL('MDPLOT - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C If EZMAP needs initialization, do it.
C
        IF (INTF) THEN
          CALL MDPINT
          IF (ICFELL('MDPLOT',2).NE.0) RETURN
        END IF
C
C If the selected outline type is "NONE", skip to the limb line code.
C
        IF (NOUT.LE.0) GO TO 104
C
C Set the flag IWGF to say whether or not the whole globe is shown by
C the current projection.  If so (IWGF=1), there's no need to waste the
C time required to check each outline point group for intersection with
C the window.
C
        IWGF=0
        IF (BLAM-SLAM.GT.179.D0.AND.BLOM-SLOM.GT.359.D0) IWGF=1
C
C IGIS keeps track of changes in the group identifier, so that the
C color index can be changed when necessary.
C
        IGIS=0
C
C Position to the user-selected portion of the outline dataset.
C
        CALL MDPIO (1)
        IF (ICFELL('MDPLOT',3).NE.0) RETURN
        NSEG=0
C
C Read the next record (group of points).
C
  101   CALL MDPIO (2)
        IF (ICFELL('MDPLOT',4).NE.0) RETURN
        NSEG=NSEG+1
C
C Check for the end of the desired data.
C
        IF (NPTS.EQ.0) GO TO 103
C
C If less than the whole globe is shown by the projection, do a quick
C check for intersection of the box surrounding the point group with
C the area shown.
C
        IF (IWGF.EQ.0) THEN
          IF (DBLE(SLAG).GT.BLAM.OR.DBLE(BLAG).LT.SLAM) GO TO 101
          IF ((DBLE(SLOG     ).GT.BLOM.OR.
     +         DBLE(BLOG     ).LT.SLOM).AND.
     +        (DBLE(SLOG-360.).GT.BLOM.OR.
     +         DBLE(BLOG-360.).LT.SLOM).AND.
     +        (DBLE(SLOG+360.).GT.BLOM.OR.
     +         DBLE(BLOG+360.).LT.SLOM)) GO TO 101
        END IF
C
C See if the user wants to omit this point group.
C
        CALL HLUMAPEOD (NOUT,NSEG,IDOS(NOUT)+IDLS,
     +                            IDOS(NOUT)+IDRS,NPTS,PNTS)
        IF (ICFELL('MDPLOT',5).NE.0) RETURN
        IF (NPTS.LE.1) GO TO 101
C
C If we've switched to a new group, set the color index, dotting, and
C dash pattern for the group.
C
        IF (IGID.NE.IGIS) THEN
          IF (IGIS.NE.0) THEN
            CALL MDPCHI (-4-IGIS,0,0)
            IF (ICFELL('MDPLOT',6).NE.0) RETURN
          END IF
          CALL MDPCHI (4+IGID,IDOT,IOR(ISHIFT(32767,1),1))
          IF (ICFELL('MDPLOT',7).NE.0) RETURN
          IGIS=IGID
        END IF
C
C Plot the group.
C
        CALL MAPIT (PNTS(1),PNTS(2),0)
        IF (ICFELL('MDPLOT',8).NE.0) RETURN
C
        DO 102 K=2,NPTS-1
          CALL MAPIT (PNTS(2*K-1),PNTS(2*K),1)
          IF (ICFELL('MDPLOT',9).NE.0) RETURN
  102   CONTINUE
C
        CALL MAPIT (PNTS(2*NPTS-1),PNTS(2*NPTS),2)
        IF (ICFELL('MDPLOT',10).NE.0) RETURN
C
C Go get another group.
C
        GO TO 101
C
C Reset the color index, dotting, and dash pattern, if necessary.
C
  103   IF (IGIS.NE.0) THEN
          CALL MDPCHI (-4-IGIS,0,0)
          IF (ICFELL('MDPLOT',11).NE.0) RETURN
        END IF
C
C If the limb lines will not be (or have not been) drawn by MAPGRD,
C do it here.
C
  104   IF (GRID.LE.0.D0) THEN
          CALL MDPLMB
          IF (ICFELL('MDPLOT',12).NE.0) RETURN
        END IF
C
C Done.
C
        RETURN
C
      END

      SUBROUTINE CPBSV( UPLO, N, KD, NRHS, AB, LDAB, B, LDB, INFO )
*
*  -- LAPACK driver routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     March 31, 1993 
*
*     .. Scalar Arguments ..
      CHARACTER          UPLO
      INTEGER            INFO, KD, LDAB, LDB, N, NRHS
*     ..
*     .. Array Arguments ..
      COMPLEX            AB( LDAB, * ), B( LDB, * )
*     ..
*
*  Purpose
*  =======
*
*  CPBSV computes the solution to a complex system of linear equations
*     A * X = B,
*  where A is an N-by-N Hermitian positive definite band matrix and X
*  and B are N-by-NRHS matrices.
*
*  The Cholesky decomposition is used to factor A as
*     A = U**H * U,  if UPLO = 'U', or
*     A = L * L**H,  if UPLO = 'L',
*  where U is an upper triangular band matrix, and L is a lower
*  triangular band matrix, with the same number of superdiagonals or
*  subdiagonals as A.  The factored form of A is then used to solve the
*  system of equations A * X = B.
*
*  Arguments
*  =========
*
*  UPLO    (input) CHARACTER*1
*          = 'U':  Upper triangle of A is stored;
*          = 'L':  Lower triangle of A is stored.
*
*  N       (input) INTEGER
*          The number of linear equations, i.e., the order of the
*          matrix A.  N >= 0.
*
*  KD      (input) INTEGER
*          The number of superdiagonals of the matrix A if UPLO = 'U',
*          or the number of subdiagonals if UPLO = 'L'.  KD >= 0.
*
*  NRHS    (input) INTEGER
*          The number of right hand sides, i.e., the number of columns
*          of the matrix B.  NRHS >= 0.
*
*  AB      (input/output) COMPLEX array, dimension (LDAB,N)
*          On entry, the upper or lower triangle of the Hermitian band
*          matrix A, stored in the first KD+1 rows of the array.  The
*          j-th column of A is stored in the j-th column of the array AB
*          as follows:
*          if UPLO = 'U', AB(KD+1+i-j,j) = A(i,j) for max(1,j-KD)<=i<=j;
*          if UPLO = 'L', AB(1+i-j,j)    = A(i,j) for j<=i<=min(N,j+KD).
*          See below for further details.
*
*          On exit, if INFO = 0, the triangular factor U or L from the
*          Cholesky factorization A = U**H*U or A = L*L**H of the band
*          matrix A, in the same storage format as A.
*
*  LDAB    (input) INTEGER
*          The leading dimension of the array AB.  LDAB >= KD+1.
*
*  B       (input/output) COMPLEX array, dimension (LDB,NRHS)
*          On entry, the N-by-NRHS right hand side matrix B.
*          On exit, if INFO = 0, the N-by-NRHS solution matrix X.
*
*  LDB     (input) INTEGER
*          The leading dimension of the array B.  LDB >= max(1,N).
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*          > 0:  if INFO = i, the leading minor of order i of A is not
*                positive definite, so the factorization could not be
*                completed, and the solution has not been computed.
*
*  Further Details
*  ===============
*
*  The band storage scheme is illustrated by the following example, when
*  N = 6, KD = 2, and UPLO = 'U':
*
*  On entry:                       On exit:
*
*      *    *   a13  a24  a35  a46      *    *   u13  u24  u35  u46
*      *   a12  a23  a34  a45  a56      *   u12  u23  u34  u45  u56
*     a11  a22  a33  a44  a55  a66     u11  u22  u33  u44  u55  u66
*
*  Similarly, if UPLO = 'L' the format of A is as follows:
*
*  On entry:                       On exit:
*
*     a11  a22  a33  a44  a55  a66     l11  l22  l33  l44  l55  l66
*     a21  a32  a43  a54  a65   *      l21  l32  l43  l54  l65   *
*     a31  a42  a53  a64   *    *      l31  l42  l53  l64   *    *
*
*  Array elements marked * are not used by the routine.
*
*  =====================================================================
*
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           CPBTRF, CPBTRS, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      IF( .NOT.LSAME( UPLO, 'U' ) .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( KD.LT.0 ) THEN
         INFO = -3
      ELSE IF( NRHS.LT.0 ) THEN
         INFO = -4
      ELSE IF( LDAB.LT.KD+1 ) THEN
         INFO = -6
      ELSE IF( LDB.LT.MAX( 1, N ) ) THEN
         INFO = -8
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'CPBSV ', -INFO )
         RETURN
      END IF
*
*     Compute the Cholesky factorization A = U'*U or A = L*L'.
*
      CALL CPBTRF( UPLO, N, KD, AB, LDAB, INFO )
      IF( INFO.EQ.0 ) THEN
*
*        Solve the system A*X = B, overwriting B with X.
*
         CALL CPBTRS( UPLO, N, KD, NRHS, AB, LDAB, B, LDB, INFO )
*
      END IF
      RETURN
*
*     End of CPBSV
*
      END

C
C $Id: agppid.f,v 1.6 2008-07-27 00:14:35 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE AGPPID (TPID)
C
      CHARACTER*(*) TPID
C
C The object of this routine is to print out a parameter identifier
C which has caused some kind of problem.
C
C Define a character variable to hold the print line.
C
      CHARACTER*124 TEMP
C
C Set up the print line.
C
      TEMP='0PARAMETER IDENTIFIER - '
C
C Transfer characters of the parameter identifier, one at a time, until
C 100 have been transferred or a period is encountered, whichever occurs
C first.  This is done so as to allow for old programs on the Cray which
C used Hollerith strings as parameter identifiers.
C
      I=24
C
      DO 101 J=1,100
        I=I+1
        TEMP(I:I)=TPID(J:J)
        IF (TEMP(I:I).EQ.'.') GO TO 102
  101 CONTINUE
C
C Print the line.
C
  102 WRITE (I1MACH(4),1001) TEMP
C
C Done.
C
      RETURN
C
C Format.
C
 1001 FORMAT (A124)
C
      END

C
C	$Id: consld.f,v 1.5 2008-07-27 00:16:55 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
        SUBROUTINE CONSLD (SCRARR)
C
C  THIS ROUTINE IS USED TO GENERATE A SHIELD WHERE CONTOUR
C  DRAWING IS ALLOWED.
C
C  THE ROUTINE TAKES THE SILHOUETTE INFORMATION FROM COMMON BLOCK
C  CONR13 AND TRANSFORMS THIS INTO A SHIELD TO BE USED IN THE
C  SCRATCH ARRAY PASSED IN BY THE USER (THE SCRATCH ARRAY HOLDS THE
C  GRIDED DATA FROM THE INTERPOLATION).
C
C  INPUT
C       SCRARR-THE SCRATCH ARRAY HOLDING THE INTERPOLATED DATA
C
C
C
C
      COMMON /CONRA1/ CL(30)     ,NCL        ,OLDZ       ,PV(210)    ,
     1                FINC       ,HI         ,FLO
      COMMON /CONRA6/ XST        ,YST        ,XED        ,YED        ,
     1                STPSZ      ,IGRAD      ,IG         ,XRG        ,
     2                YRG        ,BORD       ,PXST       ,PYST       ,
     3                PXED       ,PYED       ,ITICK
      COMMON /CONRA9/ ICOORD(500),  NP       ,MXXY       ,TR         ,
     1                BR         ,TL         ,BL         ,CONV       ,
     2                XN         ,YN         ,ITLL       ,IBLL       ,
     3                ITRL       ,IBRL       ,XC         ,YC         ,
     4                ITLOC(210) ,JX         ,JY         ,ILOC       ,
     5                ISHFCT     ,XO         ,YO         ,IOC        ,NC
      COMMON /CONR12/ IXMAX      ,IYMAX      ,XMAX       ,YMAX
      COMMON /CONR13/XVS(50),YVS(50),ICOUNT,SPVAL,SHIELD,
     1               SLDPLT
      LOGICAL SHIELD,SLDPLT
C
C  INCREASE THE RESOLUTION OF THE SHIELD PROFILE
C
      DIMENSION SCRARR(1)
C
        SAVE
      DATA RESINC/8.0/
C
C  STATEMENT FUNCTION TO MAKE ARRAY ACCESS SEEM LIKE MATRIX ACCESS
C
C
C
      IGADDR(XXX,YYY) =
     1 INT((YYY-YST)/STPSZ+.5)+(INT((XXX-XST)/STPSZ+.5))*IYMAX+1
C
C  SET THE SPECIAL VALUE
C
      SPVAL = SPVAL * 2.
C
C  SET THE USER ARRAY LOCATIONS TO TEMPORARY POINTERS
C
C  LOOP FOR ALL SHIELD ELEMENTS
C
      DO 100 IC = 1,ICOUNT
C
C       ASSIGN LINE SEGMENT END POINTS
C
        X1 = XVS(IC)
        Y1 = YVS(IC)
        IF (IC .EQ. ICOUNT) GO TO 10
                X2 = XVS(IC+1)
                Y2 = YVS(IC+1)
                GO TO 15
 10             CONTINUE
                X2 = XVS(1)
                Y2 = YVS(1)
 15     CONTINUE
C
C  INSURE THAT ALL POINTS ARE IN THE CONVEX HULL
C
      IF (X1.GT.XED) X1 = XED
      IF (X1.LT.XST) X1 = XST
      IF (X2.GT.XED) X2 = XED
      IF (X2.LT.XST) X2 = XST
      IF (Y1.GT.YED) Y1 = YED
      IF (Y1.LT.YST) Y1 = YST
      IF (Y2.GT.YED) Y2 = YED
      IF (Y2.LT.YST) Y2 = YST
C
C       SET THE START OF THE LINE SEGMENT SCRATCH LOCATION TO
C       THE SPECIAL VALUE
C
        II = IGADDR(X1,Y1)
        SCRARR(II) = SPVAL
C
C       FIND THE LENGTH OF THE LINE SEGMENT
C
        DIST = SQRT(((X2-X1)**2)+((Y2-Y1)**2))
C
C       IF LENGTH SHORTER THAN STEP SIZE THEN THERE IS NOTHING TO DO
C
        IF (DIST .LE. STPSZ) GO TO 100
C
C       SET UP LOOP TO SET ALL CELLS ON THE LINE SEGMENT
C
        NSTPS = (DIST/STPSZ)*RESINC
        XSTP = (X2-X1)/REAL(NSTPS)
        YSTP = (Y2-Y1)/REAL(NSTPS)
        X = X1
        Y = Y1
        DO 20 K = 1,NSTPS
                X = X + XSTP
                Y = Y + YSTP
                II = IGADDR(X,Y)
                SCRARR(II) = SPVAL
 20     CONTINUE
C
 100  CONTINUE
C
C  FILL THE SHIELDED AREAS
C       FOR EACH COLUMN THE ELEMENTS ARE SET TO SPVAL IF FILL IS TRUE.
C       THE VALUE OF FILL IS NEGATED EVERY TIME A SPVAL IS ENCOUNTERED,
C       AND THAT CELL REMAINS UNCHANGED.
C
C       LOOP THROUGH THE GRID
C
        DO 39 I = 1,IXMAX
C
C               GET THE START AND END FOR THE COLUMN
C
                IYS = (I-1)*IYMAX+1
                IYE = I*IYMAX
C
C               ADVANCE IN THE FORWARD DIRECTION
C
                DO 32 J = IYS,IYE
C
C                       IF NOT SPVAL THEN SET CELL AS APPROPIATE
C
                        IF (SCRARR(J).EQ.SPVAL) GO TO 33
                                SCRARR(J) = SPVAL
 32             CONTINUE
                GO TO 39
C
C               ADVANCE IN THE BACKWARD DIRECTION
C
 33             CONTINUE
                DO 34 J = 1,IYMAX
                        NJ =IYE+1-J
C                       IF NOT SPVAL THEN SET CELL AS APPROPIATE
C
                        IF (SCRARR(NJ).EQ.SPVAL) GO TO 39
                                SCRARR(NJ) = SPVAL
 34             CONTINUE
 39     CONTINUE
C
      RETURN
      END

C
C $Id: cfux.f,v 1.7 2008-07-27 00:17:23 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      FUNCTION CFUX (RX)
C
C Given an X coordinate RX in the fractional system, CFUX(RX) is an X
C coordinate in the user system.
C
      COMMON /IUTLCM/ LL,MI,MX,MY,IU(96)
      SAVE /IUTLCM/
      DIMENSION WD(4),VP(4)
      CALL GQCNTN (IE,NT)
      IF (IE.NE.0) THEN
        CALL SETER ('CFUX - ERROR EXIT FROM GQCNTN',1,1)
        CFUX=0.
        RETURN
      END IF
      CALL GQNT (NT,IE,WD,VP)
      IF (IE.NE.0) THEN
        CALL SETER ('CFUX - ERROR EXIT FROM GQNT',2,1)
        CFUX=0.
        RETURN
      END IF
      I=1
      IF (MI.GE.3) I=2
      CFUX=WD(I)+(RX-VP(1))/(VP(2)-VP(1))*(WD(3-I)-WD(I))
      IF (LL.GE.3) CFUX=10.**CFUX
      RETURN
      END

C
C	$Id: gqfaf.f,v 1.5 2008-07-27 00:20:59 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GQFAF(WTYPE,NI,NH,ERRIND,NIS,IS,NHS,HS,NPFAI)
C
C  INQUIRE FILL AREA FACILITIES
C
      include 'gkscom.h'
C
      INTEGER WTYPE,NI,NH,ERRIND,NIS,IS,NHS,HS,NPFAI
C
C  Check if GKS is in the proper state.
C
      CALL GZCKST(8,-1,ERRIND)
      IF (ERRIND .NE. 0) GOTO 100
C
C  Check that the workstation type is valid.
C
      CALL GZCKWK(22,-1,IDUM,WTYPE,ERRIND)
      IF (ERRIND .NE. 0) GO TO 100
C
C  Check on bounds for NI and NH.
C
      IF (NI.LT.0 .OR. NI.GT.3 .OR. NH.LT.0) THEN
        ERRIND = 2000
        GO TO 100
      ENDIF
C
C  Check if the workstation category is OUTPUT or OUTIN.
C
      CALL GQWKCA(WTYPE,ERRIND,ICAT)
      IF (ICAT.NE.GOUTPT .AND. ICAT.NE.GOUTIN) THEN
        ERRIND = 39
        GO TO 100
      ENDIF
C
C  Invoke interface.
C
      FCODE = -112
      CONT  = 0
      CALL GZROI(0)
      IL1   = 3
      IL2   = 3
      ID(1) = WTYPE
      ID(2) = NI
      ID(3) = NH
      IWK   = -1
      CALL GZIQWK(WTYPE,IWK)
      IF (RERR.NE.0) THEN
        ERRIND = RERR
        GOTO 100
      ENDIF
      NIS   = ID(4)
      IS    = ID(5)
      NHS   = ID(6)
      HS    = ID(7)
      NPFAI = ID(8)
      RETURN
C
  100 CONTINUE
      NIS   = -1
      IS    = -1
      NHS   = -1
      HS    = -1
      NPFAI = -1
      RETURN
      END

      SUBROUTINE ZTRTRS( UPLO, TRANS, DIAG, N, NRHS, A, LDA, B, LDB,
     $                   INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER          DIAG, TRANS, UPLO
      INTEGER            INFO, LDA, LDB, N, NRHS
*     ..
*     .. Array Arguments ..
      COMPLEX*16         A( LDA, * ), B( LDB, * )
*     ..
*
*  Purpose
*  =======
*
*  ZTRTRS solves a triangular system of the form
*
*     A * X = B,  A**T * X = B,  or  A**H * X = B,
*
*  where A is a triangular matrix of order N, and B is an N-by-NRHS
*  matrix.  A check is made to verify that A is nonsingular.
*
*  Arguments
*  =========
*
*  UPLO    (input) CHARACTER*1
*          = 'U':  A is upper triangular;
*          = 'L':  A is lower triangular.
*
*  TRANS   (input) CHARACTER*1
*          Specifies the form of the system of equations:
*          = 'N':  A * X = B     (No transpose)
*          = 'T':  A**T * X = B  (Transpose)
*          = 'C':  A**H * X = B  (Conjugate transpose)
*
*  DIAG    (input) CHARACTER*1
*          = 'N':  A is non-unit triangular;
*          = 'U':  A is unit triangular.
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  NRHS    (input) INTEGER
*          The number of right hand sides, i.e., the number of columns
*          of the matrix B.  NRHS >= 0.
*
*  A       (input) COMPLEX*16 array, dimension (LDA,N)
*          The triangular matrix A.  If UPLO = 'U', the leading N-by-N
*          upper triangular part of the array A contains the upper
*          triangular matrix, and the strictly lower triangular part of
*          A is not referenced.  If UPLO = 'L', the leading N-by-N lower
*          triangular part of the array A contains the lower triangular
*          matrix, and the strictly upper triangular part of A is not
*          referenced.  If DIAG = 'U', the diagonal elements of A are
*          also not referenced and are assumed to be 1.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(1,N).
*
*  B       (input/output) COMPLEX*16 array, dimension (LDB,NRHS)
*          On entry, the right hand side matrix B.
*          On exit, if INFO = 0, the solution matrix X.
*
*  LDB     (input) INTEGER
*          The leading dimension of the array B.  LDB >= max(1,N).
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0: if INFO = -i, the i-th argument had an illegal value
*          > 0: if INFO = i, the i-th diagonal element of A is zero,
*               indicating that the matrix is singular and the solutions
*               X have not been computed.
*
*  =====================================================================
*
*     .. Parameters ..
      COMPLEX*16         ZERO, ONE
      PARAMETER          ( ZERO = ( 0.0D+0, 0.0D+0 ),
     $                   ONE = ( 1.0D+0, 0.0D+0 ) )
*     ..
*     .. Local Scalars ..
      LOGICAL            NOUNIT
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           XERBLA, ZTRSM
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      NOUNIT = LSAME( DIAG, 'N' )
      IF( .NOT.LSAME( UPLO, 'U' ) .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = -1
      ELSE IF( .NOT.LSAME( TRANS, 'N' ) .AND. .NOT.
     $         LSAME( TRANS, 'T' ) .AND. .NOT.LSAME( TRANS, 'C' ) ) THEN
         INFO = -2
      ELSE IF( .NOT.NOUNIT .AND. .NOT.LSAME( DIAG, 'U' ) ) THEN
         INFO = -3
      ELSE IF( N.LT.0 ) THEN
         INFO = -4
      ELSE IF( NRHS.LT.0 ) THEN
         INFO = -5
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -7
      ELSE IF( LDB.LT.MAX( 1, N ) ) THEN
         INFO = -9
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'ZTRTRS', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
*
*     Check for singularity.
*
      IF( NOUNIT ) THEN
         DO 10 INFO = 1, N
            IF( A( INFO, INFO ).EQ.ZERO )
     $         RETURN
   10    CONTINUE
      END IF
      INFO = 0
*
*     Solve A * x = b,  A**T * x = b,  or  A**H * x = b.
*
      CALL ZTRSM( 'Left', UPLO, TRANS, DIAG, N, NRHS, ONE, A, LDA, B,
     $            LDB )
*
      RETURN
*
*     End of ZTRTRS
*
      END

      SUBROUTINE DRWCON(NX,NY,XI,YI,ZDAT)
C
C  Use the NCAR Graphics CONPACK package to draw a color contour 
C  plot of the data in ZDAT.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
      DIMENSION ZDAT(NX,NY)
      DIMENSION RWRK(2000),IWRK(1000),IAMA(20000)
      DIMENSION XCRA(1000),YCRA(1000),IAIA(10),IGIA(10)
C
      EXTERNAL CPCOLR,CPDRPL
C
C  Open GKS if not open; open and activate a workstation; define
C  some colors.
C
      JTYPE = IWTYPE
      CALL GQOPS(ISTATE)
      IF (ISTATE .EQ. 0) THEN
        CALL GOPKS (IERRF, ISZDM)
        IF (JTYPE .EQ. 1) THEN
          CALL NGSETC('ME','con.ncgm')
        ELSE IF ( (JTYPE .GE. 20) .AND. (JTYPE .LE. 31) ) THEN
          CALL NGSETC('ME','con.ps')
        ENDIF
        CALL GOPWK (IWKID, LUNIT, JTYPE)
        CALL GACWK (IWKID)
        CALL GSCR(IWKID, 0, 1.00, 1.00, 1.00)
        CALL GSCR(IWKID, 1, 0.00, 0.00, 0.00)
        CALL GSCR(IWKID, 2, 0.00, 1.00, 1.00)
        CALL GSCR(IWKID, 3, 0.00, 1.00, 0.00)
        CALL GSCR(IWKID, 4, 0.70, 1.00, 0.00)
        CALL GSCR(IWKID, 5, 1.00, 1.00, 0.00)
        CALL GSCR(IWKID, 6, 1.00, 0.75, 0.00)
        CALL GSCR(IWKID, 7, 1.00, 0.50, 0.50)
        CALL GSCR(IWKID, 8, 1.00, 0.00, 0.00)
      ENDIF
C
      IERR = 0
C
      CALL CPSETI('CLS - CONTOUR LEVEL SELECTOR',0)
      CALL CPSETI('NCL - NUMBER OF CONTOUR LEVELS',7)
C
      DO 103 I=1,7
        CALL CPSETI('PAI - parameter array index',I)
        CALL CPSETR('CLV - contour level',10.*REAL(I))
        CALL CPSETI('CLU - contour level use',3)
        CALL CPSETI('LLC - contour label color',1)
  103 CONTINUE
C
C Initialize the drawing of the contour plot.
C
      CALL CPSETR('VPL - viewport left',0.05)
      CALL CPSETR('VPR - viewport right',0.95)
      CALL CPSETR('VPB - viewport bottom',0.05)
      CALL CPSETR('VPT - viewport top',0.95)
      CALL PCSETI('FN  - font number (Helvetica bold)' ,22)
      CALL PCSETI('CC  - font color',1)
      CALL CPSETR('T2D - tension of 2D splines',4.)
      CALL CPSETI('LLP - line label positioning, penalty scheme',3)
      CALL CPSETI('LLO - line label orientation',1)
      CALL CPSETC('LOT - low labels off',' ')
      CALL CPSETR('CWM - character width multiplier',2.5)
      CALL CPSETC('ILT - informational label off',' ')
      CALL CPRECT(ZDAT,NX,NX,NY,RWRK,2000,IWRK,1000)
C
C Initialize the area map and put the contour lines into it.
C
      CALL ARINAM (IAMA,20000)
      CALL CPCLAM (ZDAT,RWRK,IWRK,IAMA)
      CALL CPLBAM (ZDAT,RWRK,IWRK,IAMA)
C
C Color the map.
C
      CALL ARSCAM (IAMA,XCRA,YCRA,1000,IAIA,IGIA,7,CPCOLR)
C
C Put black contour lines over the colored map.
C
      CALL GSPLCI (1)
      CALL CPCLDM (ZDAT,RWRK,IWRK,IAMA,CPDRPL)
      CALL CPLBDR (ZDAT,RWRK,IWRK)
      CALL PERIM(1,0,1,0)
C
      CALL FRAME
C
C  Close down GKS.
C
      IF (ISTATE .EQ. 0) THEN
        CALL GDAWK (IWKID)
        CALL GCLWK (IWKID)
        CALL GCLKS
      ENDIF
C
      RETURN
      END
      SUBROUTINE CPCOLR (XCRA,YCRA,NCRA,IAIA,IGIA,NAIA)
C
      DIMENSION XCRA(*),YCRA(*),IAIA(*),IGIA(*)
C
      DO 102 I=1,NAIA
        IF (IGIA(I) .EQ. 3) IFLL = IAIA(I)
  102 CONTINUE
      IF (IFLL.GE.1 .AND. IFLL.LE.8) THEN
        CALL GSFACI (IFLL+1)
        CALL GFA (NCRA-1,XCRA,YCRA)
      END IF
C
      RETURN
      END
      SUBROUTINE DRWSRF(NX,NY,X,Y,Z,S1,S2,S3,IWK)
C
C  Procedure DRWSRF uses the NCAR Graphics function SRFACE to
C  draw a surface plot of the data values in Z.
C 
C  The point of observation is calculated from the 3D coordinate
C  (S1, S2, S3); the point looked at is the center of the surface.
C 
C   NX     -  Dimension of the X-axis variable X.
C   NY     -  Dimension of the Y-axis variable Y.
C   X      -  An array of X-axis values.
C   Y      -  An array of Y-axis values.
C   Z      -  An array dimensioned for NX x NY containing data
C             values for each (X,Y) coordinate.
C   S1     -  X value for the eye position.
C   S2     -  Y value for the eye position.
C   S3     -  Z value for the eye position.
C   IWK    -  Work space dimensioned for at least 2*NX*NY.
C 
C  
      DIMENSION X(NX),Y(NY),Z(NX,NY),IWK(*)
C
      PARAMETER (IERRF=6, LUNIT=2, IWKID=1, IWTYPE=8)
      DIMENSION S(6)
C
C  Open GKS, open and activate a workstation.
C
      JTYPE = IWTYPE
      CALL GQOPS(ISTATE)
      IF (ISTATE .EQ. 0) THEN
        CALL GOPKS (IERRF, ISZDM)
        IF (JTYPE .EQ. 1) THEN
          CALL NGSETC('ME','srf.ncgm')
        ELSE IF ( (JTYPE .GE. 20) .AND. (JTYPE .LE. 31) ) THEN
          CALL NGSETC('ME','srf.ps')
        ENDIF
        CALL GOPWK (IWKID, LUNIT, JTYPE)
        CALL GSCR(IWKID,0,1.,1.,1.)
        CALL GSCR(IWKID,1,0.,0.,0.)
        CALL GACWK (IWKID)
      ENDIF
C
C  Find the extreme values.
C
      XMN =  X(1)
      XMX =  X(1)
      YMN =  Y(1)
      YMX =  Y(1)
      ZMN =  Z(1,1)
      ZMX =  Z(1,1)
C
      DO 10 I=2,NX
        XMN = MIN(XMN,X(I))
        XMX = MAX(XMX,X(I))
   10 CONTINUE
C
      DO 11 I=1,NY
        YMN = MIN(YMN,Y(I))
        YMX = MAX(YMX,Y(I))
   11 CONTINUE
C
      DO 12 I=1,NX
        DO 13 J=1,NY
          ZMN = MIN(ZMN,Z(I,J))
          ZMX = MAX(ZMX,Z(I,J))
   13   CONTINUE
   12 CONTINUE
C
      IF (S1.EQ.0. .AND. S2.EQ.0. .AND. S3.EQ.0.) THEN
        ST1 = -3.
        ST2 = -1.5
        ST3 = 0.75
      ELSE
        ST1 = S1
        ST2 = S2
        ST3 = S3
      ENDIF
      S(1) = 5.*ST1*(XMX-XMN)
      S(2) = 5.*ST2*(YMX-YMN)
      S(3) = 5.*ST3*(ZMX-ZMN)
      S(4) = 0.5*(XMX-XMN)
      S(5) = 0.5*(YMX-YMN)
      S(6) = 0.5*(ZMX-ZMN)
C
      CALL SRFACE (X,Y,Z,IWK,NX,NX,NY,S,0.)
C
C  Close down GKS.
C
      IF (ISTATE .EQ. 0) THEN
        CALL GDAWK (IWKID)
        CALL GCLWK (IWKID)
        CALL GCLKS
      ENDIF
C
      RETURN
      END
      SUBROUTINE DRWVCT(LX,LY,U,V)
C
C  Where U and V are 2D arrays, this subroutine uses NCAR Graphics to
C  draw a vector plot of the vectors (U(I,J),V(I,J)) 
C  for I=1,LX and J=1,LY.
C
      DIMENSION U(LX,LY),V(LX,LY)
      PARAMETER (IERRF=6, LUNIT=2, IWKID=1, IWTYPE=8)
C
      JTYPE = IWTYPE
      CALL GQOPS(ISTATE)
      IF (ISTATE .EQ. 0) THEN
        CALL GOPKS (IERRF, ISZDM)
        IF (JTYPE .EQ. 1) THEN
          CALL NGSETC('ME','vec.ncgm')
        ELSE IF ( (JTYPE .GE. 20) .AND. (JTYPE .LE. 31) ) THEN
          CALL NGSETC('ME','vec.ps')
        ENDIF
        CALL GOPWK (IWKID, LUNIT, JTYPE)
        CALL GACWK (IWKID)
        CALL GSCR(IWKID, 0, 1.00, 1.00, 1.00)
        CALL GSCR(IWKID, 1, 0.00, 0.00, 0.00)
      ENDIF
C
      CALL VVINIT(U,LX,V,LY,PDUM,1,LX,LY,WRK,1)
      CALL VVSETC('MNT',' ')
      CALL VVSETC('MXT',' ')
      CALL VVECTR(U,V,P,IAM,VVMSKD,WRK)
      CALL FRAME
C
      IF (ISTATE .EQ. 0) THEN
        CALL GDAWK (IWKID)
        CALL GCLWK (IWKID)
        CALL GCLKS
      ENDIF
C
      RETURN
      END

C
C	$Id: nggetr.f,v 1.6 2008-07-27 00:17:18 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE NGGETR (CNP,RVP)
C
      SAVE
C
      CHARACTER*(*) CNP
C
C  This subroutine is called to retrieve the real value of a specified
C  parameter.
C
C  CNP is the name of the parameter whose value is to be retrieved.
C
C  RVP is a real variable in which the desired value is to be returned
C  by NGGETR.
C
C  Declare a local character variable in which to form an error message.
C
      CHARACTER*80 CTM
C
      include 'ngcomn.h'
C
C  Do a call forcing a BLOCKDATA to be loaded from a binary library.
C
      CALL NGBLDA
C
C  Check for an uncleared prior error.
C
      IF (ICFELL('NGGETR - Uncleared prior error',1) .NE. 0) RETURN
C
C Check for a parameter name that is too short.
C
      IF (LEN(CNP) .LT. 2) THEN
        CTM(1:36)='NGGETR - Parameter name too short - '
        CTM(37:36+LEN(CNP)) = CNP
        CALL SETER (CTM(1:36+LEN(CNP)), 1, 1)
        GO TO 110
      ENDIF
C
C Get the appropriate parameter value.
C
      IF (CNP(1:2).EQ.'FI' .OR. CNP(1:2).EQ.'fi' .OR. 
     +    CNP(1:2).EQ.'Fi') THEN
        RVP = FILSPC
        GO TO 110
      ELSE IF (CNP(1:2).EQ.'HA' .OR. CNP(1:2).EQ.'ha' .OR. 
     +    CNP(1:2).EQ.'Ha') THEN
        RVP = HATSPC
        GO TO 110
      ELSE IF (CNP(1:2).EQ.'MI' .OR. CNP(1:2).EQ.'mi' .OR. 
     +    CNP(1:2).EQ.'Mi') THEN
        RVP = RMITER
        GO TO 110
      ELSE IF (CNP(1:2).EQ.'NO' .OR. CNP(1:2).EQ.'no' .OR. 
     +    CNP(1:2).EQ.'No') THEN
        RVP = RNLSCL
        GO TO 110
      ELSE IF (CNP(1:2).EQ.'OX' .OR. CNP(1:2).EQ.'ox' .OR. 
     +    CNP(1:2).EQ.'Ox') THEN
        RVP = OXLOGO
        GO TO 110
      ELSE IF (CNP(1:2).EQ.'OY' .OR. CNP(1:2).EQ.'oy' .OR. 
     +    CNP(1:2).EQ.'Oy') THEN
        RVP = OYLOGO
        GO TO 110
      ELSE IF (CNP(1:2).EQ.'OS' .OR. CNP(1:2).EQ.'os' .OR. 
     +    CNP(1:2).EQ.'Os') THEN
        RVP = OLSIZE
        GO TO 110
      ELSE
        CTM(1:36) = 'NGGETR - Parameter name not known - '
        CTM(37:38) = CNP(1:2)
        CALL SETER (CTM(1:38), 2, 1)
        GO TO 110
      ENDIF
C
  110 CONTINUE
      RETURN
      END

C
C	$Id: dashdb.f,v 1.5 2008-07-27 00:23:03 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE DASHDB (IPAT)
C
C ARGUMENTS              IPAT
C ON INPUT                 IPAT IS A 16-BIT DASH PATTERN.  BY DEFAULT
C                          EACH BIT IN THE PATTERN REPRESENTS 3 PLOTTER
C                          ADDRESS UNITS (1=SOLID, 0=BLANK)
C
C
C
C USER ENTRY POINT.
C DASHDB GIVES AN INTERNAL REPRESENTATION TO THE DASH PATTERN WHICH IS
C SPECIFIED IN ITS ARGUMENT. THIS INTERNAL REPRESENTATION IS PASSED
C TO ROUTINE CFVLD IN THE COMMON-BLOCK DASHD1.
C
      DIMENSION IPAT(1)
      COMMON/INTPR/IPAU,FPART,TENSN,NP,SMALL,L1,ADDLR,ADDTB,MLLINE,
     1    ICLOSE
C
C DASHD1 IS FOR COMMUNICATION BETWEEN THE ROUTINES DASHDB AND CFVLD.
C ISL, MNCSTR AND IGP ARE INITIALIZED IN DASHBDX.
C
      COMMON /DASHD1/  ISL,  L,  ISIZE,  IP(100),  NWDSM1,  IPFLAG(100)
     1                 ,MNCSTR, IGP
C
C IFCFLG IS THE FIRST CALL FLAG FOR DASHDB. IT IS INITIALIZED IN
C DASHBDX.
C
      COMMON /DDFLAG/ IFCFLG
C
C IFSTFL CONTROLS THAT FRSTD IS CALLED BEFORE VECTD IS CALLED (IN CFVLD)
C WHENEVER DASHDB HAS BEEN CALLED. IT IS INITIALIZED IN DASHBDX AND
C REFERENCED IN CFVLD.
C
      COMMON /DCFLAG/ IFSTFL
C
C IFSTF2 CONTROLS THAT THE FRSTD ENTRY IS CALLED IN FDVDLD BEFORE THE
C VECTD ENTRY IS CALLED WHENEVER DASHDB OR DASHDC HAS BEEN CALLED. IT IS
C INITIALIZED IN DASHBDX AND REFERENCED IN FDVDLD.
C
      COMMON /DFFLAG/ IFSTF2
C
C LOCAL VARIABLES TO DASHDB ARE SAVED IN DSAVE6 FOR THE NEXT CALL TO
C DASHDB.
C
      COMMON /DSAVE6/ MASK, NCHRWD, NBWD, MNCST1
      SAVE
C
C Do a call forcing a BLOCKDATA to be loaded from a binary library.
C
      CALL DASHBD
C THE FOLLOWING CALL IS FOR LIBRARY STATISTICS GATHERING AT NCAR
      CALL Q8QST4 ('GRAPHX', 'DASHSMTH', 'DASHDB', 'VERSION  1')
      IF (IFCFLG .EQ. 2) GOTO 10
C
C CHECK IF THE CONSTANTS IN THE BLOCKDATA DASHBDX ARE LOADED CORRECTLY
C
      IF (MNCSTR .EQ. 15) GOTO 6
      CALL SETER('DASHDB -- BLOCKDATA DASHBDX APPARENTLY NOT LOADED CORR
     1ECTLY',1,2)
    6 CONTINUE
C
C INITIALIZATION
C
      MNCST1 = MNCSTR + 1
C
C MASK IS AN ALL SOLID PATTERN
C
      MASK=IOR(ISHIFT(32767,1),1)
C
      IFCFLG = 2
C
C L - NUMBER OF WORDS IN THE FINAL PATTERN, POINTER TO IP ARRAY.
C ISL - FLAG FOR ALL SOLID PATTERN (1) OR ALL GAP PATTERN (-1).
C IFSTFL - FLAG TO CONTROL THAT FRSTD IS CALLED IN CFVLD BEFORE VECTD IS
C          CALLED, WHENEVER DASHDB OR DASHDC HAS BEEN CALLED.
C IFSTF2 - FLAG TO CONTROL THAT FRSTD IS CALLED IN FDVDLD BEFORE VECTD
C          IS CALLED, WHENEVER DASHDB OR DASHDC HAS BEEN CALLED.
C
   10 CONTINUE
      NCHRTS = 0
      L = 0
      ISL = 0
      IFSTFL = 1
      IFSTF2 = 1
C
      ICRT = IPAU*ISHIFT(1,15-10)
      IF (IPAT(1) .NE. 0) GO TO 260
      ISL = -1
      RETURN
  260 IF (IPAT(1) .NE. MASK) GO TO 270
      ISL = 1
      RETURN
  270 NMODE1 = IAND(ISHIFT(IPAT(1),-15),1)
      DO 290 I = 1,16
      IF (NMODE1 .NE. IAND(ISHIFT(IPAT(1),I-16),1)) GO TO 280
      NMODE1 = 1 - NMODE1
      L = L + 1
      IP(L) = 0
      IPFLAG(L) = 1 - 2*NMODE1
  280 IP(L) = IP(L) + ICRT
  290 CONTINUE
      RETURN
      END

      subroutine zrotg(ca,cb,c,s)
      double complex ca,cb,s
      double precision c
      double precision norm,scale
      double complex alpha
      if (cdabs(ca) .ne. 0.0d0) go to 10
         c = 0.0d0
         s = (1.0d0,0.0d0)
         ca = cb
         go to 20
   10 continue
         scale = cdabs(ca) + cdabs(cb)
         norm = scale*dsqrt((cdabs(ca/dcmplx(scale,0.0d0)))**2 +
     *                      (cdabs(cb/dcmplx(scale,0.0d0)))**2)
         alpha = ca /cdabs(ca)
         c = cdabs(ca) / norm
         s = alpha * dconjg(cb) / norm
         ca = alpha * norm
   20 continue
      return
      end

C
C	$Id: grditm.f,v 1.5 2008-07-27 00:21:01 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GRDITM (WKID,MLDR,LDR,DATREC)
C
C  READ ITEM FROM GKSM
C
      INTEGER ERDITM
      PARAMETER (ERDITM=103)
C
      include 'gkscom.h'
C
      INTEGER WKID,LDR
      CHARACTER*80 DATREC(MLDR)
C
C  Check if GKS is in the proper state.
C
      CALL GZCKST(7,ERDITM,IER)
      IF (IER .NE. 0) RETURN
C
C  Check if the workstation ID is valid.
C
      CALL GZCKWK(20,ERDITM,WKID,IDUM,IER)
      IF (IER .NE. 0) RETURN
C
C  Check if the workstation is currently open.
C
      CALL GZCKWK(25,ERDITM,WKID,IDUM,IER)
      IF (IER .NE. 0) RETURN
C
C  Set function code and put out WKID, TYPE, LDR, and the data
C  record in STR.
C
C  Set the flag CUFLAG to indicate that the interface call should go
C  only to the specifically designated workstation.
C
      CUFLAG = WKID
      FCODE = 103
      CONT  = 0
      CALL GZROI(0)
      IL1 = 2
      IL2 = 2
      ID(1) = WKID
      ID(2) = MLDR
      CALL GZTOWK
      CUFLAG = -1
      IF (RERR .NE. 0) THEN
        ERS = 1
        CALL GERHND(RERR,ERDITM,ERF)
        ERS = 0
        RETURN
      ELSE
C
C  Read returned data record.
C
      LDR = ID(3)
C
C  Check on returned length.
C
      IF (LDR .GT. MLDR) THEN
        ERS = 1
        CALL GERHND(2001,ERDITM,ERF)
        ERS = 0
        RETURN
      ENDIF
      DATREC(1) = STR(1:80)
      IF (LDR .GT. 1) THEN
        INDX = 1
  200   CONTINUE
        INDX = INDX+1
        CALL GZFMWK
        DATREC(INDX) = STR(1:80)
        IF (CONT.EQ.0 .OR. INDX.GE.LDR) GO TO 201
          GO TO 200
  201     CONTINUE
        ENDIF
      ENDIF
C
      RETURN
      END

C
C $Id: aggtch.f,v 1.6 2008-07-27 00:14:34 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE AGGTCH (IDCS,CHST,LNCS)
C
      CHARACTER*(*) CHST
C
C This routine gets character strings previously stored by the routine
C AGSTCH (which see).  It has the following arguments:
C
C -- IDCS is the identifying integer returned by AGSTCH when the string
C    was stored.
C
C -- CHST is the character string returned.
C
C -- LNCS is the length of the character string returned in CHST.
C
C The following common blocks contain variables which are required for
C the character-storage-and-retrieval scheme of AUTOGRAPH.
C
      COMMON /AGCHR1/ LNIC,INCH(2,50),LNCA,INCA
      SAVE /AGCHR1/
C
      COMMON /AGCHR2/ CHRA(2000)
      CHARACTER*1 CHRA
      SAVE /AGCHR2/
C
C First, blank-fill the character variable to be returned.
C
      CHST=' '
C
C If the identifier is less than -LNIC, the (one-character) string is
C retrieved from it.
C
      IF (IDCS.LT.(-LNIC)) THEN
        CHST=CHAR(-IDCS-LNIC-1)
        LNCS=1
C
C If the identifier is between -LNIC and -1, its absolute value is the
C index, in INCH, of the descriptor of the character string stored in
C CHRA.
C
      ELSE IF (IDCS.LE.(-1)) THEN
        I=-IDCS
        J=INCH(1,I)-1
        IF (J.GE.0) THEN
          LNCS=MIN(LEN(CHST),INCH(2,I))
          DO 101 K=1,LNCS
            J=J+1
            CHST(K:K)=CHRA(J)
  101     CONTINUE
        ELSE
          LNCS=0
        END IF
C
C In all other cases, return a single blank.
C
      ELSE
        LNCS=1
C
      END IF
C
C Done.
C
      RETURN
C
      END

      SUBROUTINE DTRTRI( UPLO, DIAG, N, A, LDA, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     March 31, 1993
*
*     .. Scalar Arguments ..
      CHARACTER          DIAG, UPLO
      INTEGER            INFO, LDA, N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * )
*     ..
*
*  Purpose
*  =======
*
*  DTRTRI computes the inverse of a real upper or lower triangular
*  matrix A.
*
*  This is the Level 3 BLAS version of the algorithm.
*
*  Arguments
*  =========
*
*  UPLO    (input) CHARACTER*1
*          = 'U':  A is upper triangular;
*          = 'L':  A is lower triangular.
*
*  DIAG    (input) CHARACTER*1
*          = 'N':  A is non-unit triangular;
*          = 'U':  A is unit triangular.
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  A       (input/output) DOUBLE PRECISION array, dimension (LDA,N)
*          On entry, the triangular matrix A.  If UPLO = 'U', the
*          leading N-by-N upper triangular part of the array A contains
*          the upper triangular matrix, and the strictly lower
*          triangular part of A is not referenced.  If UPLO = 'L', the
*          leading N-by-N lower triangular part of the array A contains
*          the lower triangular matrix, and the strictly upper
*          triangular part of A is not referenced.  If DIAG = 'U', the
*          diagonal elements of A are also not referenced and are
*          assumed to be 1.
*          On exit, the (triangular) inverse of the original matrix, in
*          the same storage format.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(1,N).
*
*  INFO    (output) INTEGER
*          = 0: successful exit
*          < 0: if INFO = -i, the i-th argument had an illegal value
*          > 0: if INFO = i, A(i,i) is exactly zero.  The triangular
*               matrix is singular and its inverse can not be computed.
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ONE, ZERO
      PARAMETER          ( ONE = 1.0D+0, ZERO = 0.0D+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            NOUNIT, UPPER
      INTEGER            J, JB, NB, NN
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            ILAENV
      EXTERNAL           LSAME, ILAENV
*     ..
*     .. External Subroutines ..
      EXTERNAL           DTRMM, DTRSM, DTRTI2, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      UPPER = LSAME( UPLO, 'U' )
      NOUNIT = LSAME( DIAG, 'N' )
      IF( .NOT.UPPER .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = -1
      ELSE IF( .NOT.NOUNIT .AND. .NOT.LSAME( DIAG, 'U' ) ) THEN
         INFO = -2
      ELSE IF( N.LT.0 ) THEN
         INFO = -3
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -5
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DTRTRI', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
*
*     Check for singularity if non-unit.
*
      IF( NOUNIT ) THEN
         DO 10 INFO = 1, N
            IF( A( INFO, INFO ).EQ.ZERO )
     $         RETURN
   10    CONTINUE
         INFO = 0
      END IF
*
*     Determine the block size for this environment.
*
      NB = ILAENV( 1, 'DTRTRI', UPLO // DIAG, N, -1, -1, -1 )
      IF( NB.LE.1 .OR. NB.GE.N ) THEN
*
*        Use unblocked code
*
         CALL DTRTI2( UPLO, DIAG, N, A, LDA, INFO )
      ELSE
*
*        Use blocked code
*
         IF( UPPER ) THEN
*
*           Compute inverse of upper triangular matrix
*
            DO 20 J = 1, N, NB
               JB = MIN( NB, N-J+1 )
*
*              Compute rows 1:j-1 of current block column
*
               CALL DTRMM( 'Left', 'Upper', 'No transpose', DIAG, J-1,
     $                     JB, ONE, A, LDA, A( 1, J ), LDA )
               CALL DTRSM( 'Right', 'Upper', 'No transpose', DIAG, J-1,
     $                     JB, -ONE, A( J, J ), LDA, A( 1, J ), LDA )
*
*              Compute inverse of current diagonal block
*
               CALL DTRTI2( 'Upper', DIAG, JB, A( J, J ), LDA, INFO )
   20       CONTINUE
         ELSE
*
*           Compute inverse of lower triangular matrix
*
            NN = ( ( N-1 ) / NB )*NB + 1
            DO 30 J = NN, 1, -NB
               JB = MIN( NB, N-J+1 )
               IF( J+JB.LE.N ) THEN
*
*                 Compute rows j+jb:n of current block column
*
                  CALL DTRMM( 'Left', 'Lower', 'No transpose', DIAG,
     $                        N-J-JB+1, JB, ONE, A( J+JB, J+JB ), LDA,
     $                        A( J+JB, J ), LDA )
                  CALL DTRSM( 'Right', 'Lower', 'No transpose', DIAG,
     $                        N-J-JB+1, JB, -ONE, A( J, J ), LDA,
     $                        A( J+JB, J ), LDA )
               END IF
*
*              Compute inverse of current diagonal block
*
               CALL DTRTI2( 'Lower', DIAG, JB, A( J, J ), LDA, INFO )
   30       CONTINUE
         END IF
      END IF
*
      RETURN
*
*     End of DTRTRI
*
      END

      SUBROUTINE ZPPEQU( UPLO, N, AP, S, SCOND, AMAX, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     March 31, 1993
*
*     .. Scalar Arguments ..
      CHARACTER          UPLO
      INTEGER            INFO, N
      DOUBLE PRECISION   AMAX, SCOND
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   S( * )
      COMPLEX*16         AP( * )
*     ..
*
*  Purpose
*  =======
*
*  ZPPEQU computes row and column scalings intended to equilibrate a
*  Hermitian positive definite matrix A in packed storage and reduce
*  its condition number (with respect to the two-norm).  S contains the
*  scale factors, S(i)=1/sqrt(A(i,i)), chosen so that the scaled matrix
*  B with elements B(i,j)=S(i)*A(i,j)*S(j) has ones on the diagonal.
*  This choice of S puts the condition number of B within a factor N of
*  the smallest possible condition number over all possible diagonal
*  scalings.
*
*  Arguments
*  =========
*
*  UPLO    (input) CHARACTER*1
*          = 'U':  Upper triangle of A is stored;
*          = 'L':  Lower triangle of A is stored.
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  AP      (input) COMPLEX*16 array, dimension (N*(N+1)/2)
*          The upper or lower triangle of the Hermitian matrix A, packed
*          columnwise in a linear array.  The j-th column of A is stored
*          in the array AP as follows:
*          if UPLO = 'U', AP(i + (j-1)*j/2) = A(i,j) for 1<=i<=j;
*          if UPLO = 'L', AP(i + (j-1)*(2n-j)/2) = A(i,j) for j<=i<=n.
*
*  S       (output) DOUBLE PRECISION array, dimension (N)
*          If INFO = 0, S contains the scale factors for A.
*
*  SCOND   (output) DOUBLE PRECISION
*          If INFO = 0, S contains the ratio of the smallest S(i) to
*          the largest S(i).  If SCOND >= 0.1 and AMAX is neither too
*          large nor too small, it is not worth scaling by S.
*
*  AMAX    (output) DOUBLE PRECISION
*          Absolute value of largest matrix element.  If AMAX is very
*          close to overflow or very close to underflow, the matrix
*          should be scaled.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*          > 0:  if INFO = i, the i-th diagonal element is nonpositive.
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ONE, ZERO
      PARAMETER          ( ONE = 1.0D+0, ZERO = 0.0D+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            UPPER
      INTEGER            I, JJ
      DOUBLE PRECISION   SMIN
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          DBLE, MAX, MIN, SQRT
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      UPPER = LSAME( UPLO, 'U' )
      IF( .NOT.UPPER .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'ZPPEQU', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 ) THEN
         SCOND = ONE
         AMAX = ZERO
         RETURN
      END IF
*
*     Initialize SMIN and AMAX.
*
      S( 1 ) = DBLE( AP( 1 ) )
      SMIN = S( 1 )
      AMAX = S( 1 )
*
      IF( UPPER ) THEN
*
*        UPLO = 'U':  Upper triangle of A is stored.
*        Find the minimum and maximum diagonal elements.
*
         JJ = 1
         DO 10 I = 2, N
            JJ = JJ + I
            S( I ) = DBLE( AP( JJ ) )
            SMIN = MIN( SMIN, S( I ) )
            AMAX = MAX( AMAX, S( I ) )
   10    CONTINUE
*
      ELSE
*
*        UPLO = 'L':  Lower triangle of A is stored.
*        Find the minimum and maximum diagonal elements.
*
         JJ = 1
         DO 20 I = 2, N
            JJ = JJ + N - I + 2
            S( I ) = DBLE( AP( JJ ) )
            SMIN = MIN( SMIN, S( I ) )
            AMAX = MAX( AMAX, S( I ) )
   20    CONTINUE
      END IF
*
      IF( SMIN.LE.ZERO ) THEN
*
*        Find the first non-positive diagonal element and return.
*
         DO 30 I = 1, N
            IF( S( I ).LE.ZERO ) THEN
               INFO = I
               RETURN
            END IF
   30    CONTINUE
      ELSE
*
*        Set the scale factors to the reciprocals
*        of the diagonal elements.
*
         DO 40 I = 1, N
            S( I ) = ONE / SQRT( S( I ) )
   40    CONTINUE
*
*        Compute SCOND = min(S(I)) / max(S(I))
*
         SCOND = SQRT( SMIN ) / SQRT( AMAX )
      END IF
      RETURN
*
*     End of ZPPEQU
*
      END

      PROGRAM TGFLAS
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C OPEN GKS, OPEN WORKSTATION OF TYPE 1, ACTIVATE WORKSTATION
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C INVOKE DEMO DRIVER
C
      CALL GFLAS(IERR)
C
C DEACTIVATE AND CLOSE WORKSTATION, CLOSE GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END
C
      SUBROUTINE GFLAS (IERROR)
C
C PURPOSE                To provide a simple demonstration of the
C                        GFLASH package.
C
C USAGE                  CALL GFLAS (IERROR)
C
C ARGUMENTS
C
C ON OUTPUT              IERROR
C                          An integer variable
C                            = 0  If there is a normal exit from GFLASH,
C                            = 1  Otherwise
C
C I/O                    If there is a normal exit from GFLASH,
C                        the message
C
C                          GFLASH TEST SUCCESSFUL . . . SEE PLOTS TO
C                          VERIFY PERFORMANCE
C
C                        is written on unit 6
C
C PRECISION              SINGLE
C
C REQUIRED LIBRARY       GFLASH
C FILES
C
C LANGUAGE               FORTRAN
C
C HISTORY                Written  by members of the
C                        Scientific Computing Division of NCAR,
C                        Boulder Colorado
C
C PORTABILITY            FORTRAN 77
C
C NOTE                   The call to GOPWK will have to be modified
C                        when using a non-NCAR GKS package.  The third
C                        argument must be the workstation type for WISS.
C
C
C  Data for the graphical objects.
C
      DATA    TWOPI/6.283185/
      DATA    X0C, Y0C, RC, NPTC/ 0.325, 0.5, 0.10 , 210/
      DATA    X0P, Y0P, RP, NPTP/ 0.500, 0.5, 0.35 ,  16/
      DATA    X0S, Y0S, RS      / 0.675, 0.5, 0.10      /
C
C Establish the viewport and window.
C
      CALL SET(0.,1.,0.,1.,0.,1.,0.,1.,1)
C
C  Initialize the GFLASH package.  If using a non-NCAR GKS package
C  the final argument in the following call should be replaced with
C  the workstation type for WISS.
C
      CALL GOPWK(9,1,3)
C
C  Put a circle in a buffer with identifier 1.
C
      CALL GFLAS1(1)
      DTHETA = TWOPI/NPTC
      CALL FRSTPT(X0C+RC,Y0C)
      DO 20 I=1,NPTC
      ANG = DTHETA*REAL(I)
      XC = RC*COS(ANG)
      YC = RC*SIN(ANG)
      CALL VECTOR(X0C+XC,Y0C+YC)
   20 CONTINUE
      CALL GFLAS2
C
C  Put a polygonal fan in a buffer with identifier 2.
C
      CALL GFLAS1(2)
      DTHETA = TWOPI/NPTP
      DO 10 I=1,NPTP
      ANG = DTHETA*REAL(I)
      XC = RP*COS(ANG)
      YC = RP*SIN(ANG)
      CALL LINE(X0P,Y0P,X0P+XC,Y0P+YC)
   10 CONTINUE
      CALL GFLAS2
C
C  Put a square in a buffer with identifier 3.
C
      CALL GFLAS1(3)
      CALL FRSTPT(X0S+RS,Y0S+RS)
      CALL VECTOR(X0S-RS,Y0S+RS)
      CALL VECTOR(X0S-RS,Y0S-RS)
      CALL VECTOR(X0S+RS,Y0S-RS)
      CALL VECTOR(X0S+RS,Y0S+RS)
      CALL GFLAS2
C
C  Put a background perimeter in a buffer with identifier 4.
C
      CALL GFLAS1(4)
      CALL FRSTPT( 0.0, 0.0)
      CALL VECTOR( 1.0, 0.0)
      CALL VECTOR( 1.0, 1.0)
      CALL VECTOR( 0.0, 1.0)
      CALL VECTOR( 0.0, 0.0)
      CALL GFLAS2
C
C  Create plots.
C
C  Frame 1 -- title, circle, and fan.
C
      CALL PLCHLQ(0.5,0.91,'FRAME 1',25.,0.,0.)
      CALL GFLAS3(1)
      CALL GFLAS3(2)
      CALL GFLAS3(4)
      CALL FRAME
C
C  Frame 2 -- fan, title, and square.
C
      CALL GFLAS3(2)
      CALL PLCHLQ(0.5,0.91,'FRAME 2',25.,0.,0.)
      CALL GFLAS3(3)
      CALL GFLAS3(4)
      CALL FRAME
C
C  Frame 3 -- circle, square, fan, and title (note that the change
C             in window affects the PLCHLQ call, but not the elements
C             in the buffers -- this illustrates the independent
C             nature of the FLASH buffers).
C
      CALL SET (0.,1.,0.,1.,0.,10.,0.,10.,1)
      CALL GFLAS3(1)
      CALL GFLAS3(3)
      CALL GFLAS3(2)
      CALL PLCHLQ(5.0,9.1,'FRAME 3',25.,0.,0.)
      CALL GFLAS3(4)
      CALL FRAME
C
C  Close the GFLASH package.
C
      CALL GCLWK(9)
C
      END

C
C $Id: maptri.f,v 1.20 2008-09-18 00:42:16 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MAPTRI (UVAL,VVAL,RLAT,RLON)
        REAL   UVAL,VVAL,RLAT,RLON
        DOUBLE PRECISION DLAT,DLON
        IF (ICFELL('MAPTRI - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
        CALL MDPTRI (DBLE(UVAL),DBLE(VVAL),DLAT,DLON)
        IF (ICFELL('MAPTRI',2).NE.0) RETURN
        IF (DLAT.NE.1.D12) THEN
          RLAT=REAL(DLAT)
          RLON=REAL(DLON)
        ELSE
          RLAT=1.E12
          RLON=1.E12
        END IF
        RETURN
      END

C
C $Id: agscan.f,v 1.9 2008-07-27 00:14:35 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE AGSCAN (TPID,LOPA,NIPA,IIPA)
C
      CHARACTER*(*) TPID
C
C The routine AGSCAN is used by AGGETP and AGSETP to scan a parameter
C identifier and return a description of the parameter-list items which
C are specified by that parameter identifier.  It has the following
C arguments:
C
C -- TPID is the parameter identifier.
C
C -- LOPA is the index of the first parameter-list item specified.
C
C -- NIPA is the number of parameter-list items specified.
C
C -- IIPA is the index increment between one of the parameter-list items
C    specified and the next (meaningless if NIPA=1).
C
C
C BEWARE BEWARE BEWARE BEWARE BEWARE BEWARE BEWARE BEWARE BEWARE BEWARE
C
C Originally, this routine used the function "LOC" to return, in LOPA,
C the base address, in core, of the specified parameter group.  To some
C degree, it was thereby insulated from changes in the labelled common
C block AGCONP.  With the demise of "LOC", LOPA has been re-defined and
C that insulation no longer exists.  In the following code, there are
C integers which represent the indices of desired quantities in common.
C
C BEWARE BEWARE BEWARE BEWARE BEWARE BEWARE BEWARE BEWARE BEWARE BEWARE
C
C
C The following common block contains the AUTOGRAPH control parameters,
C all of which are real.  If it is changed, all of AUTOGRAPH (especially
C the routine AGSCAN) must be examined for possible side effects.
C
      COMMON /AGCONP/ QFRA,QSET,QROW,QIXY,QWND,QBAC , SVAL(2) ,
     +                XLGF,XRGF,YBGF,YTGF , XLGD,XRGD,YBGD,YTGD , SOGD ,
     +                XMIN,XMAX,QLUX,QOVX,QCEX,XLOW,XHGH ,
     +                YMIN,YMAX,QLUY,QOVY,QCEY,YLOW,YHGH ,
     +                QDAX(4),QSPA(4),PING(4),PINU(4),FUNS(4),QBTD(4),
     +                BASD(4),QMJD(4),QJDP(4),WMJL(4),WMJR(4),QMND(4),
     +                QNDP(4),WMNL(4),WMNR(4),QLTD(4),QLED(4),QLFD(4),
     +                QLOF(4),QLOS(4),DNLA(4),WCLM(4),WCLE(4) ,
     +                QODP,QCDP,WOCD,WODQ,QDSH(26) ,
     +                     QDLB,QBIM,FLLB(10,8),QBAN ,
     +                QLLN,TCLN,QNIM,FLLN(6,16),QNAN ,
     +                XLGW,XRGW,YBGW,YTGW , XLUW,XRUW,YBUW,YTUW ,
     +                XLCW,XRCW,YBCW,YTCW , WCWP,HCWP,SCWP ,
     +                XBGA(4),YBGA(4),UBGA(4),XNDA(4),YNDA(4),UNDA(4),
     +                QBTP(4),BASE(4),QMNT(4),QLTP(4),QLEX(4),QLFL(4),
     +                QCIM(4),QCIE(4),RFNL(4),WNLL(4),WNLR(4),WNLB(4),
     +                WNLE(4),QLUA(4) ,
     +                RBOX(6),DBOX(6,4),SBOX(6,4)
      SAVE /AGCONP/
C
C Do a call forcing a BLOCKDATA to be loaded from a binary library.
C
      CALL AGDFLT
C
C Extract the values of a couple of required dimensions.
C
      LBIM=INT(QBIM)
      LNIM=INT(QNIM)
C
C Initialize the parameter-identifier character index.
C
      IPID=0
C
C Initialize the value of the index increment to be returned.
C
      IIPA=1
C
C Find the first keyword in the parameter identifier.
C
      CALL AGSRCH (TPID,IPID,IKWL,'PRIMFRAMSET ROW INVEWINDNULLGRAPGRIDX
     +   Y   AXISLEFTRIGHBOTTTOP DASHLABELINESECOBACK',
     +                            'primframset row invewindnullgrapgridx
     +   y   axisleftrighbotttop dashlabelinesecoback')
C
      GO TO (101,102,103,104,105,106,107,108,109,110,
     +       111,113,114,114,114,114,132,133,147,155,166,901) , IKWL
C
C PRIMARY CONTROL PARAMETERS.
C
  101 LOPA=1
      NIPA=336
      GO TO 203
C
C FRAME PARAMETER.
C
  102 LOPA=1
      GO TO 202
C
C SET PARAMETER.
C
  103 LOPA=2
      GO TO 202
C
C ROW PARAMETER.
C
  104 LOPA=3
      GO TO 202
C
C X/Y INVERSION PARAMETER.
C
  105 LOPA=4
      GO TO 202
C
C WINDOWING PARAMETER.
C
  106 LOPA=5
      GO TO 202
C
C BACKGROUND PARAMETER.
C
  166 LOPA=6
      GO TO 202
C
C NULL PARAMETER(S).
C
  107 LOPA=7
      NIPA=2
      IF (TPID(IPID:IPID).EQ.'.') RETURN
C
      CALL AGSRCH (TPID,IPID,IKWL,'1   2   ',
     +                            '1   2   ')
C
      IF (IKWL.EQ.3) GO TO 901
      GO TO 201
C
C PLOT (GRAPH) WINDOW PARAMETERS.
C
  108 LOPA=9
      NIPA=4
      IF (TPID(IPID:IPID).EQ.'.') RETURN
C
      CALL AGSRCH (TPID,IPID,IKWL,'LEFTRIGHBOTTTOP ',
     +                            'leftrighbotttop ')
C
      IF (IKWL.EQ.5) GO TO 901
      GO TO 201
C
C GRID WINDOW PARAMETERS.
C
  109 LOPA=13
      NIPA=5
      IF (TPID(IPID:IPID).EQ.'.') RETURN
C
      CALL AGSRCH (TPID,IPID,IKWL,'LEFTRIGHBOTTTOP SHAP',
     +                            'leftrighbotttop shap')
C
      IF (IKWL.EQ.6) GO TO 901
      GO TO 201
C
C X DATA PARAMETERS.
C
  110 LOPA=18
      GO TO 112
C
C Y DATA PARAMETERS.
C
  111 LOPA=25
C
C X OR Y DATA PARAMETERS.
C
  112 NIPA=7
      IF (TPID(IPID:IPID).EQ.'.') RETURN
C
      CALL AGSRCH (TPID,IPID,IKWL,'MINIMAXILOGAORDENICESMALLARG',
     +                            'minimaxilogaordenicesmallarg')
C
      IF (IKWL.EQ.8) GO TO 901
      GO TO 201
C
C AXIS PARAMETERS.
C
  113 LOPA=32
      NIPA=92
      IF (TPID(IPID:IPID).EQ.'.') RETURN
C
      CALL AGSRCH (TPID,IPID,IKWL,'LEFTRIGHBOTTTOP ',
     +                            'leftrighbotttop ')
C
      IF (IKWL.EQ.5) GO TO 901
      IKWL=IKWL+12
C
C LEFT, RIGHT, BOTTOM, OR TOP AXIS PARAMETERS.
C
  114 LOPA=19+IKWL
      NIPA=23
      IIPA=4
      IF (TPID(IPID:IPID).EQ.'.') RETURN
C
      CALL AGSRCH (TPID,IPID,IKWL,
     +       'CONTLINEINTEFUNCTICKMAJOMINONUMETYPEEXPOFRACANGLOFFSWIDT',
     +       'contlineintefunctickmajominonumetypeexpofracangloffswidt')
C
      GO TO (202,201,115,167,116,117,123,126,127,127,127,
     +       127,127,127,901) , IKWL
C
C AXIS INTERSECTION PARAMETERS.
C
  115 LOPA=LOPA+8
      NIPA=2
      IF (TPID(IPID:IPID).EQ.'.') RETURN
C
      CALL AGSRCH (TPID,IPID,IKWL,'GRIDUSER',
     +                            'griduser')
C
      IF (IKWL.EQ.3) GO TO 901
      GO TO 201
C
C AXIS MAPPING FUNCTION.
C
  167 LOPA=LOPA+16
      GO TO 202
C
C AXIS TICK PARAMETERS.
C
  116 LOPA=LOPA+20
      NIPA=10
      IF (TPID(IPID:IPID).EQ.'.') RETURN
C
      CALL AGSRCH (TPID,IPID,IKWL,'MAJOMINO',
     +                            'majomino')
C
      LOPA=LOPA-20
      GO TO (117,123,901) , IKWL
C
C AXIS MAJOR-TICK PARAMETERS.
C
  117 LOPA=LOPA+20
      NIPA=6
      IF (TPID(IPID:IPID).EQ.'.') RETURN
C
      CALL AGSRCH (TPID,IPID,IKWL,'SPACTYPEBASECOUNPATTLENGOUTWINWA',
     +                            'spactypebasecounpattlengoutwinwa')
C
      GO TO (118,119,119,119,120,121,122,122,901) , IKWL
C
C AXIS MAJOR-TICK SPACING PARAMETERS.
C
  118 NIPA=3
      IF (TPID(IPID:IPID).EQ.'.') RETURN
C
      CALL AGSRCH (TPID,IPID,IKWL,'TYPEBASECOUN',
     +                            'typebasecoun')
C
      IF (IKWL.EQ.4) GO TO 901
C
      GO TO 201
C
  119 IKWL=IKWL-1
      GO TO 201
C
C AXIS MAJOR-TICK DASH PATTERN.
C
  120 LOPA=LOPA+12
      GO TO 202
C
C AXIS MAJOR-TICK LENGTH PARAMETERS.
C
  121 LOPA=LOPA+16
      NIPA=2
      IF (TPID(IPID:IPID).EQ.'.') RETURN
C
      CALL AGSRCH (TPID,IPID,IKWL,'OUTWINWA',
     +                            'outwinwa')
C
      IF (IKWL.EQ.3) GO TO 901
      GO TO 201
C
  122 LOPA=LOPA+16
      IKWL=IKWL-6
      GO TO 201
C
C AXIS MINOR-TICK PARAMETERS.
C
  123 LOPA=LOPA+44
      NIPA=4
      IF (TPID(IPID:IPID).EQ.'.') RETURN
C
      CALL AGSRCH (TPID,IPID,IKWL,'SPACPATTLENGOUTWINWA',
     +                            'spacpattlengoutwinwa')
C
      GO TO (202,201,124,125,125,901) , IKWL
C
C AXIS MINOR-TICK LENGTH PARAMETERS.
C
  124 LOPA=LOPA+8
      NIPA=2
      IF (TPID(IPID:IPID).EQ.'.') RETURN
C
      CALL AGSRCH (TPID,IPID,IKWL,'OUTWINWA',
     +                            'outwinwa')
C
      IF (IKWL.EQ.3) GO TO 901
      GO TO 201
C
  125 LOPA=LOPA+8
      IKWL=IKWL-3
      GO TO 201
C
C AXIS NUMERIC-LABEL PARAMETERS.
C
  126 LOPA=LOPA+60
      NIPA=8
      IF (TPID(IPID:IPID).EQ.'.') RETURN
C
      CALL AGSRCH (TPID,IPID,IKWL,'TYPEEXPOFRACANGLOFFSWIDT',
     +                            'typeexpofracangloffswidt')
C
      GO TO 128
C
  127 LOPA=LOPA+60
      IKWL=IKWL-8
C
  128 GO TO (202,201,201,129,130,131,901) ,IKWL
C
C AXIS NUMERIC-LABEL ORIENTATION ANGLE.
C
  129 LOPA=LOPA+12
      NIPA=2
      IF (TPID(IPID:IPID).EQ.'.') RETURN
C
      CALL AGSRCH (TPID,IPID,IKWL,'1ST 2ND ',
     +                            '1st 2nd ')
C
      IF (IKWL.EQ.3) GO TO 901
      GO TO 201
C
C AXIS NUMERIC-LABEL OFFSET.
C
  130 LOPA=LOPA+20
      GO TO 202
C
C AXIS NUMERIC-LABEL WIDTH PARAMETERS.
C
  131 LOPA=LOPA+24
      NIPA=2
      IF (TPID(IPID:IPID).EQ.'.') RETURN
C
      CALL AGSRCH (TPID,IPID,IKWL,'MANTEXPO',
     +                            'mantexpo')
C
      IF (IKWL.EQ.3) GO TO 901
      GO TO 201
C
C DASH-PATTERN PARAMETERS.
C
  132 LOPA=124
      NIPA=30
      IF (TPID(IPID:IPID).EQ.'.') RETURN
      JPID=IPID
      CALL AGSRCH (TPID,IPID,IKWL,'SELELENGCHARDOLLPATT',
     +                            'selelengchardollpatt')
      IF (IKWL.EQ.6) THEN
        IPID=JPID
        GO TO 168
      END IF
      IF (IKWL.NE.5) GO TO 201
  168 LOPA=LOPA+4
      NIPA=26
      IF (TPID(IPID:IPID).EQ.'.') RETURN
      CALL AGSRCH (TPID,IPID,IKWL,
     +'1   2   3   4   5   6   7   8   9   10  11  12  13  14  15  16  1
     +7  18  19  20  21  22  23  24  25  26  ',
     +'1   2   3   4   5   6   7   8   9   10  11  12  13  14  15  16  1
     +7  18  19  20  21  22  23  24  25  26  ')
      IF (IKWL.EQ.27) GO TO 901
      GO TO 201
C
C LABEL PARAMETERS.
C
  133 LBAN=INT(QBAN)
C
      LOPA=154
      NIPA=3+LBIM*10
      IF (TPID(IPID:IPID).EQ.'.') RETURN
C
      CALL AGSRCH (TPID,IPID,IKWL,
     +                   'CONTBUFFNAMEDEFISUPPBASEOFFSANGLCENTLINEINDE',
     +                   'contbuffnamedefisuppbaseoffsanglcentlineinde')
C
      GO TO (202,136,139,140,141,141,141,141,141,141,141,901) , IKWL
C
C LABEL BUFFER PARAMETERS.
C
  136 LOPA=155
      NIPA=1+LBIM*10
      IF (TPID(IPID:IPID).EQ.'.') RETURN
C
      CALL AGSRCH (TPID,IPID,IKWL,'LENGCONTNAME',
     +                            'lengcontname')
C
      GO TO (202,137,138,901) , IKWL
C
C LABEL BUFFER CONTENTS.
C
  137 LOPA=156
      NIPA=LBIM*10
      GO TO 203
C
C LABEL BUFFER NAMES.
C
  138 LOPA=156
      NIPA=LBIM
      IIPA=10
      GO TO 203
C
C LABEL NAME.
C
  139 LOPA=236+10*LBIM-80
      GO TO 202
C
C LABEL DEFINITION.
C
  140 IF (LBAN.LT.1.OR.LBAN.GT.LBIM) GO TO 902
C
      LOPA=157+(LBAN-1)*10
      NIPA=9
      IF (TPID(IPID:IPID).EQ.'.') GO TO 203
C
      CALL AGSRCH (TPID,IPID,IKWL,'SUPPBASEOFFSANGLCENTLINEINDE',
     +                            'suppbaseoffsanglcentlineinde')
C
      GO TO 142
C
  141 IF (LBAN.LT.1.OR.LBAN.GT.LBIM) GO TO 902
C
      LOPA=157+(LBAN-1)*10
      IKWL=IKWL-4
C
  142 GO TO (202,143,144,146,146,146,146,901) , IKWL
C
C LABEL POSITION.
C
  143 LOPA=LOPA+1
      GO TO 145
C
C LABEL OFFSET.
C
  144 LOPA=LOPA+3
C
C LABEL POSITION OR OFFSET.
C
  145 NIPA=2
      IF (TPID(IPID:IPID).EQ.'.') RETURN
C
      CALL AGSRCH (TPID,IPID,IKWL,'X   Y   ',
     +                            'x   y   ')
C
      IF (IKWL.EQ.3) GO TO 901
      GO TO 201
C
C OTHER LABEL ATTRIBUTES.
C
  146 LOPA=LOPA+5
      IKWL=IKWL-3
      GO TO 201
C
C LINE PARAMETERS.
C
  147 LNAN=INT(QNAN)
C
      LOPA=237+10*LBIM-80
      NIPA=4+LNIM*6
      IF (TPID(IPID:IPID).EQ.'.') RETURN
C
      CALL AGSRCH (TPID,IPID,IKWL,
     +                       'MAXIEND BUFFNUMBDEFISUPPCHARTEXTLENGINDE',
     +                       'maxiend buffnumbdefisuppchartextlenginde')
C
      GO TO (202,201,150,152,153,154,154,154,154,154,901) , IKWL
C
C LINE BUFFER PARAMETERS.
C
  150 LOPA=239+10*LBIM-80
      NIPA=1+LNIM*6
      IF (TPID(IPID:IPID).EQ.'.') RETURN
C
      CALL AGSRCH (TPID,IPID,IKWL,'LENGCONT',
     +                            'lengcont')
C
      GO TO (202,151,901) , IKWL
C
C LINE BUFFER CONTENTS.
C
  151 LOPA=240+10*LBIM-80
      NIPA=LNIM*6
      GO TO 203
C
C LINE NUMBER.
C
  152 LOPA=336+10*LBIM-80+6*LNIM-96
      GO TO 202
C
C LINE DEFINITION.
C
  153 IF (LNAN.LT.1.OR.LNAN.GT.LNIM) GO TO 903
C
      LOPA=241+10*LBIM-80+(LNAN-1)*6
      NIPA=5
      IF (TPID(IPID:IPID).EQ.'.') GO TO 203
C
      CALL AGSRCH (TPID,IPID,IKWL,'SUPPCHARTEXTLENGINDE',
     +                            'suppchartextlenginde')
C
      IF (IKWL.EQ.6) GO TO 901
      GO TO 201
C
  154 IF (LNAN.LT.1.OR.LNAN.GT.LNIM) GO TO 903
      LOPA=241+10*LBIM-80+(LNAN-1)*6
      IKWL=IKWL-5
      GO TO 201
C
C SECONDARY CONTROL PARAMETERS.
C
  155 LOPA=337+10*LBIM-80+6*LNIM-96
      NIPA=149
      IF (TPID(IPID:IPID).EQ.'.') GO TO 203
C
      CALL AGSRCH (TPID,IPID,IKWL,
     +                       'GRAPUSERCURVDIMEAXISLEFTRIGHBOTTTOP LABE',
     +                       'grapusercurvdimeaxisleftrighbotttop labe')
C
      GO TO (156,157,158,159,160,161,161,161,161,165,901) , IKWL
C
C PLOT (GRAPH) WINDOW EDGES.
C
  156 LOPA=337+10*LBIM-80+6*LNIM-96
      NIPA=4
      GO TO 203
C
C USER WINDOW PARAMETERS.
C
  157 LOPA=341+10*LBIM-80+6*LNIM-96
      NIPA=4
      GO TO 203
C
C CURVE WINDOW PARAMETERS.
C
  158 LOPA=345+10*LBIM-80+6*LNIM-96
      NIPA=4
      GO TO 203
C
C CURVE WINDOW DIMENSIONS.
C
  159 LOPA=349+10*LBIM-80+6*LNIM-96
      NIPA=3
      GO TO 203
C
C AXIS PARAMETERS.
C
  160 LOPA=352+10*LBIM-80+6*LNIM-96
      NIPA=80
      IF (TPID(IPID:IPID).EQ.'.') GO TO 203
C
      CALL AGSRCH (TPID,IPID,IKWL,'LEFTRIGHBOTTTOP ',
     +                            'leftrighbotttop ')
C
      IF (IKWL.EQ.5) GO TO 901
C
      IKWL=IKWL+5
C
C LEFT, RIGHT, BOTTOM, OR TOP AXIS PARAMETERS.
C
  161 LOPA=346+10*LBIM-80+6*LNIM-96+IKWL
      NIPA=20
      IIPA=4
      IF (TPID(IPID:IPID).EQ.'.') RETURN
C
      CALL AGSRCH (TPID,IPID,IKWL,'POSITICKNUME',
     +                            'positicknume')
C
      GO TO (162,163,164,901) , IKWL
C
C AXIS POSITIONING PARAMETERS.
C
  162 NIPA=6
      GO TO 203
C
C AXIS TICK PARAMETERS.
C
  163 LOPA=LOPA+24
      NIPA=3
      GO TO 203
C
C AXIS NUMERIC-LABEL PARAMETERS.
C
  164 LOPA=LOPA+36
      NIPA=11
      GO TO 203
C
C LABEL BOXES.
C
  165 LOPA=432+10*LBIM-80+6*LNIM-96
      NIPA=54
      IF (TPID(IPID:IPID).EQ.'.') GO TO 203
C
      CALL AGSRCH (TPID,IPID,IKWL,'LEFTRIGHBOTTTOP CENTGRAP',
     +                            'leftrighbotttop centgrap')
C
      IF (IKWL.EQ.7) GO TO 901
C
      LOPA=LOPA+IKWL-1
      NIPA=9
      IIPA=6
      GO TO 203
C
C Normal exits.
C
  201 LOPA=LOPA+(IKWL-1)*IIPA
C
  202 NIPA=1
C
  203 IF (TPID(IPID:IPID).EQ.'.') RETURN
C
      CALL AGPPID (TPID)
      WRITE (I1MACH(4),1001)
      RETURN
C
C Error exits.
C
  901 CALL AGPPID (TPID)
      CALL SETER ('AGGETP OR AGSETP - ILLEGAL KEYWORD USED IN PARAMETER
     +IDENTIFIER',11,2)
C
  902 CALL AGPPID (TPID)
      CALL SETER ('AGGETP OR AGSETP - ATTEMPT TO ACCESS LABEL ATTRIBUTES
     + BEFORE SETTING LABEL NAME',12,2)
C
  903 CALL AGPPID (TPID)
      CALL SETER ('AGGETP OR AGSETP - ATTEMPT TO ACCESS LINE ATTRIBUTES
     +BEFORE SETTING LINE NUMBER',13,2)
C
C Formats.
C
 1001 FORMAT (' WARNING - ABOVE PARAMETER IDENTIFIER HAS TOO MANY KEYWOR
     +DS')
C
      END

C
C $Id: kurv1dp.f,v 1.3 2008-07-27 03:10:11 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
C NOTE: If you make any changes to this software, please remember to
C make the same changes to the corresponding single precision routine.
C
      SUBROUTINE KURV1DP(N,X,Y,SLP1,SLPN,ISLPSW,XP,YP,TEMP,S,SIGMA,IERR)
      DOUBLE PRECISION SIGMAP
      DOUBLE PRECISION SLPP1X
      DOUBLE PRECISION SLPP1Y
      DOUBLE PRECISION DELS1
      DOUBLE PRECISION DELS2
      DOUBLE PRECISION C1
      DOUBLE PRECISION C2
      DOUBLE PRECISION C3
      DOUBLE PRECISION SX
      DOUBLE PRECISION SY
      DOUBLE PRECISION DELT
      DOUBLE PRECISION SLPPNX
      DOUBLE PRECISION SLPPNY
      DOUBLE PRECISION DELSN
      DOUBLE PRECISION DELSNM
      DOUBLE PRECISION DX1
      DOUBLE PRECISION DY1
      DOUBLE PRECISION DIAG1
      DOUBLE PRECISION SDIAG1
      DOUBLE PRECISION DX2
      DOUBLE PRECISION DY2
      DOUBLE PRECISION DIAG2
      DOUBLE PRECISION SDIAG2
      DOUBLE PRECISION DIAG
      DOUBLE PRECISION DIAGIN
c
      INTEGER N,ISLPSW,IERR
      DOUBLE PRECISION X(N),Y(N),SLP1,SLPN,XP(N),YP(N),TEMP(N),S(N),
     +                 SIGMA
c
c                                 coded by alan kaylor cline
c                           from fitpack -- january 26, 1987
c                        a curve and surface fitting package
c                      a product of pleasant valley software
c                  8603 altus cove, austin, texas 78759, usa
c
c this subroutine determines the parameters necessary to
c compute a spline under tension forming a curve in the
c plane and passing through a sequence of pairs (x(1),y(1)),
c ...,(x(n),y(n)). for actual computation of points on the
c curve it is necessary to call the subroutine kurv2.
c
c on input--
c
c   n is the number of points to be interpolated (n.ge.2).
c
c   x is an array containing the n x-coordinates of the
c   points.
c
c   y is an array containing the n y-coordinates of the
c   points. (adjacent x-y pairs must be distinct, i. e.
c   either x(i) .ne. x(i+1) or y(i) .ne. y(i+1), for
c   i = 1,...,n-1.)
c
c   slp1 and slpn contain the desired values for the angles
c   (in radians) of the slope at (x(1),y(1)) and (x(n),y(n))
c   respectively. the angles are measured counter-clock-
c   wise from the x-axis and the positive sense of the curve
c   is assumed to be that moving from point 1 to point n.
c   the user may omit values for either or both of these
c   parameters and signal this with islpsw.
c
c   islpsw contains a switch indicating which slope data
c   should be used and which should be estimated by this
c   subroutine,
c          = 0 if slp1 and slpn are to be used,
c          = 1 if slp1 is to be used but not slpn,
c          = 2 if slpn is to be used but not slp1,
c          = 3 if both slp1 and slpn are to be estimated
c              internally.
c
c   xp and yp are arrays of length at least n.
c
c   temp is an array of length at least n which is used
c   for scratch storage.
c
c   s is an array of length at least n.
c
c and
c
c   sigma contains the tension factor. this value indicates
c   the curviness desired. if abs(sigma) is nearly zero
c   (e.g. .001) the resulting curve is approximately a cubic
c   spline. if abs(sigma) is large (e. g. 50.) the resulting
c   curve is nearly a polygonal line. if sigma equals zero a
c   cubic spline results. a standard value for sigma is
c   approximately 1. in absolute value.
c
c on output--
c
c   xp and yp contain information about the curvature of the
c   curve at the given nodes.
c
c   s contains the polygonal arclengths of the curve.
c
c   ierr contains an error flag,
c        = 0 for normal return,
c        = 1 if n is less than 2,
c        = 2 if adjacent coordinate pairs coincide.
c
c and
c
c   n, x, y, slp1, slpn, islpsw, and sigma are unaltered.
c
c this subroutine references package modules ceez, terms,
c and snhcsh.
c
c-----------------------------------------------------------
c
      NM1 = N - 1
      NP1 = N + 1
      IERR = 0
      IF (N.LE.1) GO TO 11
c
c determine polygonal arclengths
c
      S(1) = 0.D0
      DO 1 I = 2,N
          IM1 = I - 1
    1 S(I) = S(IM1) + SQRT((X(I)-X(IM1))**2+ (Y(I)-Y(IM1))**2)
c
c denormalize tension factor
c
      SIGMAP = ABS(SIGMA)*DBLE(N-1)/S(N)
c
c approximate end slopes
c
      IF (ISLPSW.GE.2) GO TO 2
      SLPP1X = COS(SLP1)
      SLPP1Y = SIN(SLP1)
      GO TO 4
    2 DELS1 = S(2) - S(1)
      DELS2 = DELS1 + DELS1
      IF (N.GT.2) DELS2 = S(3) - S(1)
      IF (DELS1.EQ.0.D0 .OR. DELS2.EQ.0.D0) GO TO 12
      CALL CEEZDP(DELS1,DELS2,SIGMAP,C1,C2,C3,N)
      SX = C1*X(1) + C2*X(2)
      SY = C1*Y(1) + C2*Y(2)
      IF (N.EQ.2) GO TO 3
      SX = SX + C3*X(3)
      SY = SY + C3*Y(3)
    3 DELT = SQRT(SX*SX+SY*SY)
      SLPP1X = SX/DELT
      SLPP1Y = SY/DELT
    4 IF (ISLPSW.EQ.1 .OR. ISLPSW.EQ.3) GO TO 5
      SLPPNX = COS(SLPN)
      SLPPNY = SIN(SLPN)
      GO TO 7
    5 DELSN = S(N) - S(NM1)
      DELSNM = DELSN + DELSN
      IF (N.GT.2) DELSNM = S(N) - S(N-2)
      IF (DELSN.EQ.0.D0 .OR. DELSNM.EQ.0.D0) GO TO 12
      CALL CEEZDP(-DELSN,-DELSNM,SIGMAP,C1,C2,C3,N)
      SX = C1*X(N) + C2*X(NM1)
      SY = C1*Y(N) + C2*Y(NM1)
      IF (N.EQ.2) GO TO 6
      SX = SX + C3*X(N-2)
      SY = SY + C3*Y(N-2)
    6 DELT = SQRT(SX*SX+SY*SY)
      SLPPNX = SX/DELT
      SLPPNY = SY/DELT
c
c set up right hand sides and tridiagonal system for xp and
c yp and perform forward elimination
c
    7 DX1 = (X(2)-X(1))/S(2)
      DY1 = (Y(2)-Y(1))/S(2)
      CALL TERMSDP(DIAG1,SDIAG1,SIGMAP,S(2))
      XP(1) = (DX1-SLPP1X)/DIAG1
      YP(1) = (DY1-SLPP1Y)/DIAG1
      TEMP(1) = SDIAG1/DIAG1
      IF (N.EQ.2) GO TO 9
      DO 8 I = 2,NM1
          DELS2 = S(I+1) - S(I)
          IF (DELS2.EQ.0.D0) GO TO 12
          DX2 = (X(I+1)-X(I))/DELS2
          DY2 = (Y(I+1)-Y(I))/DELS2
          CALL TERMSDP(DIAG2,SDIAG2,SIGMAP,DELS2)
          DIAG = DIAG1 + DIAG2 - SDIAG1*TEMP(I-1)
          DIAGIN = 1.D0/DIAG
          XP(I) = (DX2-DX1-SDIAG1*XP(I-1))*DIAGIN
          YP(I) = (DY2-DY1-SDIAG1*YP(I-1))*DIAGIN
          TEMP(I) = SDIAG2*DIAGIN
          DX1 = DX2
          DY1 = DY2
          DIAG1 = DIAG2
    8 SDIAG1 = SDIAG2
    9 DIAG = DIAG1 - SDIAG1*TEMP(NM1)
      XP(N) = (SLPPNX-DX1-SDIAG1*XP(NM1))/DIAG
      YP(N) = (SLPPNY-DY1-SDIAG1*YP(NM1))/DIAG
c
c perform back substitution
c
      DO 10 I = 2,N
          IBAK = NP1 - I
          XP(IBAK) = XP(IBAK) - TEMP(IBAK)*XP(IBAK+1)
   10 YP(IBAK) = YP(IBAK) - TEMP(IBAK)*YP(IBAK+1)
      RETURN
c
c too few points
c
   11 IERR = 1
      RETURN
c
c coincident adjacent points
c
   12 IERR = 2
      RETURN
      END

      SUBROUTINE CGBCON( NORM, N, KL, KU, AB, LDAB, IPIV, ANORM, RCOND,
     $                   WORK, RWORK, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER          NORM
      INTEGER            INFO, KL, KU, LDAB, N
      REAL               ANORM, RCOND
*     ..
*     .. Array Arguments ..
      INTEGER            IPIV( * )
      REAL               RWORK( * )
      COMPLEX            AB( LDAB, * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  CGBCON estimates the reciprocal of the condition number of a complex
*  general band matrix A, in either the 1-norm or the infinity-norm,
*  using the LU factorization computed by CGBTRF.
*
*  An estimate is obtained for norm(inv(A)), and the reciprocal of the
*  condition number is computed as
*     RCOND = 1 / ( norm(A) * norm(inv(A)) ).
*
*  Arguments
*  =========
*
*  NORM    (input) CHARACTER*1
*          Specifies whether the 1-norm condition number or the
*          infinity-norm condition number is required:
*          = '1' or 'O':  1-norm;
*          = 'I':         Infinity-norm.
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  KL      (input) INTEGER
*          The number of subdiagonals within the band of A.  KL >= 0.
*
*  KU      (input) INTEGER
*          The number of superdiagonals within the band of A.  KU >= 0.
*
*  AB      (input) COMPLEX array, dimension (LDAB,N)
*          Details of the LU factorization of the band matrix A, as
*          computed by CGBTRF.  U is stored as an upper triangular band
*          matrix with KL+KU superdiagonals in rows 1 to KL+KU+1, and
*          the multipliers used during the factorization are stored in
*          rows KL+KU+2 to 2*KL+KU+1.
*
*  LDAB    (input) INTEGER
*          The leading dimension of the array AB.  LDAB >= 2*KL+KU+1.
*
*  IPIV    (input) INTEGER array, dimension (N)
*          The pivot indices; for 1 <= i <= N, row i of the matrix was
*          interchanged with row IPIV(i).
*
*  ANORM   (input) REAL
*          If NORM = '1' or 'O', the 1-norm of the original matrix A.
*          If NORM = 'I', the infinity-norm of the original matrix A.
*
*  RCOND   (output) REAL
*          The reciprocal of the condition number of the matrix A,
*          computed as RCOND = 1/(norm(A) * norm(inv(A))).
*
*  WORK    (workspace) COMPLEX array, dimension (2*N)
*
*  RWORK   (workspace) REAL array, dimension (N)
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0: if INFO = -i, the i-th argument had an illegal value
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ONE, ZERO
      PARAMETER          ( ONE = 1.0E+0, ZERO = 0.0E+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            LNOTI, ONENRM
      CHARACTER          NORMIN
      INTEGER            IX, J, JP, KASE, KASE1, KD, LM
      REAL               AINVNM, SCALE, SMLNUM
      COMPLEX            T, ZDUM
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            ICAMAX
      REAL               SLAMCH
      COMPLEX            CDOTC
      EXTERNAL           LSAME, ICAMAX, SLAMCH, CDOTC
*     ..
*     .. External Subroutines ..
      EXTERNAL           CAXPY, CLACON, CLATBS, CSRSCL, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, AIMAG, MIN, REAL
*     ..
*     .. Statement Functions ..
      REAL               CABS1
*     ..
*     .. Statement Function definitions ..
      CABS1( ZDUM ) = ABS( REAL( ZDUM ) ) + ABS( AIMAG( ZDUM ) )
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      ONENRM = NORM.EQ.'1' .OR. LSAME( NORM, 'O' )
      IF( .NOT.ONENRM .AND. .NOT.LSAME( NORM, 'I' ) ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( KL.LT.0 ) THEN
         INFO = -3
      ELSE IF( KU.LT.0 ) THEN
         INFO = -4
      ELSE IF( LDAB.LT.2*KL+KU+1 ) THEN
         INFO = -6
      ELSE IF( ANORM.LT.ZERO ) THEN
         INFO = -8
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'CGBCON', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      RCOND = ZERO
      IF( N.EQ.0 ) THEN
         RCOND = ONE
         RETURN
      ELSE IF( ANORM.EQ.ZERO ) THEN
         RETURN
      END IF
*
      SMLNUM = SLAMCH( 'Safe minimum' )
*
*     Estimate the norm of inv(A).
*
      AINVNM = ZERO
      NORMIN = 'N'
      IF( ONENRM ) THEN
         KASE1 = 1
      ELSE
         KASE1 = 2
      END IF
      KD = KL + KU + 1
      LNOTI = KL.GT.0
      KASE = 0
   10 CONTINUE
      CALL CLACON( N, WORK( N+1 ), WORK, AINVNM, KASE )
      IF( KASE.NE.0 ) THEN
         IF( KASE.EQ.KASE1 ) THEN
*
*           Multiply by inv(L).
*
            IF( LNOTI ) THEN
               DO 20 J = 1, N - 1
                  LM = MIN( KL, N-J )
                  JP = IPIV( J )
                  T = WORK( JP )
                  IF( JP.NE.J ) THEN
                     WORK( JP ) = WORK( J )
                     WORK( J ) = T
                  END IF
                  CALL CAXPY( LM, -T, AB( KD+1, J ), 1, WORK( J+1 ), 1 )
   20          CONTINUE
            END IF
*
*           Multiply by inv(U).
*
            CALL CLATBS( 'Upper', 'No transpose', 'Non-unit', NORMIN, N,
     $                   KL+KU, AB, LDAB, WORK, SCALE, RWORK, INFO )
         ELSE
*
*           Multiply by inv(U').
*
            CALL CLATBS( 'Upper', 'Conjugate transpose', 'Non-unit',
     $                   NORMIN, N, KL+KU, AB, LDAB, WORK, SCALE, RWORK,
     $                   INFO )
*
*           Multiply by inv(L').
*
            IF( LNOTI ) THEN
               DO 30 J = N - 1, 1, -1
                  LM = MIN( KL, N-J )
                  WORK( J ) = WORK( J ) - CDOTC( LM, AB( KD+1, J ), 1,
     $                        WORK( J+1 ), 1 )
                  JP = IPIV( J )
                  IF( JP.NE.J ) THEN
                     T = WORK( JP )
                     WORK( JP ) = WORK( J )
                     WORK( J ) = T
                  END IF
   30          CONTINUE
            END IF
         END IF
*
*        Divide X by 1/SCALE if doing so will not cause overflow.
*
         NORMIN = 'Y'
         IF( SCALE.NE.ONE ) THEN
            IX = ICAMAX( N, WORK, 1 )
            IF( SCALE.LT.CABS1( WORK( IX ) )*SMLNUM .OR. SCALE.EQ.ZERO )
     $         GO TO 40
            CALL CSRSCL( N, SCALE, WORK, 1 )
         END IF
         GO TO 10
      END IF
*
*     Compute the estimate of the reciprocal condition number.
*
      IF( AINVNM.NE.ZERO )
     $   RCOND = ( ONE / AINVNM ) / ANORM
*
   40 CONTINUE
      RETURN
*
*     End of CGBCON
*
      END

C
C $Id: semess.f,v 1.6 2008-07-27 00:17:31 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      FUNCTION SEMESS (ITRIM)
C
        CHARACTER*113 SEMESS
C
C The value of this function is some portion of the current error
C message (blanks if there is no current error).  If the value of
C ITRIM is less than or equal to zero, the entire error message is
C returned.  If the value of ITRIM is equal to 1, prepended routine
C names and associated slashes are removed.  If the value of ITRIM
C is 2 or greater, all routine names are removed, along with the
C following hyphen and the blanks around the hyphen.  For example,
C if the current error message is
C
C   'CPCLAM/AREDAM - AREA-MAP ARRAY OVERFLOW'
C
C then
C
C   SEMESS(0)='CPCLAM/AREDAM - AREA-MAP ARRAY OVERFLOW'
C   SEMESS(1)='AREDAM - AREA-MAP ARRAY OVERFLOW'
C   SEMESS(2)='AREA-MAP ARRAY OVERFLOW'
C
C The common blocks SECOMI and SECOMC are used to hold shared variables
C of types INTEGER and CHARACTER, respectively, for the routine SETER
C and associated routines.  For descriptions of these variables and for
C default values of them, see the block data routine SEBLDAX.
C
        COMMON /SECOMI/ IERRU,IERRF,IRECF,LOMSG
        SAVE   /SECOMI/
C
        COMMON /SECOMC/ ERMSG
          CHARACTER*256 ERMSG
        SAVE   /SECOMC/
C
C Return either blanks or the requested portion of the current message.
C
        IF (IERRF.EQ.0) THEN
          SEMESS=' '
        ELSE IF (ITRIM.LE.0) THEN
          SEMESS=ERMSG(1:LOMSG)
        ELSE
          IBEG=1
          IF (ITRIM.EQ.1) THEN
            DO 101 I=1,LOMSG
              IF (ERMSG(I:I).EQ.'/') IBEG=I+1
              IF (ERMSG(I:I).EQ.'-') GO TO 103
  101       CONTINUE
          ELSE
            DO 102 I=1,LOMSG
              IF (ERMSG(I:I).EQ.'-') THEN
                IBEG=I+2
                GO TO 103
              END IF
  102       CONTINUE
          END IF
  103     IF (IBEG.GT.LOMSG) IBEG=1
          SEMESS=ERMSG(IBEG:LOMSG)
        END IF
C
C Done.
C
        RETURN
C
      END

C NCLFORTSTART
      SUBROUTINE DLLTOIJ(MAP_PROJ,TRUELAT1,TRUELAT2,STDLON,LAT1,LON1,
     +                   POLE_LAT,POLE_LON,KNOWNI,KNOWNJ,DX,DY,LATINC,
     +                   LONINC,LAT,LON,LOC)
      DOUBLE PRECISION DELTALON1
      DOUBLE PRECISION TL1R


ccc       Converts input lat/lon values to the cartesian (i,j) value
ccc       for the given projection.

      INTEGER MAP_PROJ
      DOUBLE PRECISION TRUELAT1,TRUELAT2,STDLON
      DOUBLE PRECISION LAT1,LON1,POLE_LAT,POLE_LON,KNOWNI,KNOWNJ
      DOUBLE PRECISION DX,DY,LATINC,LONINC,LAT,LON,LOC(2)
C NCLEND

      DOUBLE PRECISION CLAIN,DLON,RSW,DELTALON,DELTALAT
      DOUBLE PRECISION REFLON,SCALE_TOP,ALA1,ALO1,ALA,ALO,RM,POLEI,POLEJ
c Earth radius divided by dx
      DOUBLE PRECISION REBYDX
      DOUBLE PRECISION DELTALON1TL1R,CTL1R,ARG,CONE,HEMI
      DOUBLE PRECISION I,J
      DOUBLE PRECISION LAT1N,LON1N,OLAT,OLON

      DOUBLE PRECISION PI,RAD_PER_DEG,DEG_PER_RAD,RE_M

ccc      lat1     ! SW latitude (1,1) in degrees (-90->90N)
ccc      lon1     ! SW longitude (1,1) in degrees (-180->180E)
ccc      dx       ! Grid spacing in meters at truelats
ccc      dlat     ! Lat increment for lat/lon grids
ccc      dlon     ! Lon increment for lat/lon grids
ccc      stdlon   ! Longitude parallel to y-axis (-180->180E)
ccc      truelat1 ! First true latitude (all projections)
ccc      truelat2 ! Second true lat (LC only)
ccc      hemi     ! 1 for NH, -1 for SH
ccc      cone     ! Cone factor for LC projections
ccc      polei    ! Computed i-location of pole point
ccc      polej    ! Computed j-location of pole point
ccc      rsw      ! Computed radius to SW corner
ccc      knowni   ! X-location of known lat/lon
ccc      knownj   ! Y-location of known lat/lon
ccc      RE_M     ! Radius of spherical earth, meters
ccc      REbydx   ! Earth radius divided by dx

      PI = 3.141592653589793D0
      RAD_PER_DEG = PI/180.D0
      DEG_PER_RAD = 180.D0/PI
c Radius of spherical earth, meters
      RE_M = 6370000.D0
      REBYDX = RE_M/DX

      HEMI = 1.0D0
      IF (TRUELAT1.LT.0.0D0) THEN
          HEMI = -1.0D0
      END IF


ccc      !MERCATOR
      IF (MAP_PROJ.EQ.3) THEN

ccc         !  Preliminary variables
          CLAIN = COS(RAD_PER_DEG*TRUELAT1)
          DLON = DX/ (RE_M*CLAIN)

ccc         ! Compute distance from equator to origin, and store in 
ccc         ! the rsw tag.
          RSW = 0.D0
          IF (LAT1.NE.0.D0) THEN
              RSW = (DLOG(TAN(0.5D0* ((LAT1+90.D0)*RAD_PER_DEG))))/DLON
          END IF

          DELTALON = LON - LON1
          IF (DELTALON.LT.-180.D0) DELTALON = DELTALON + 360.D0
          IF (DELTALON.GT.180.D0) DELTALON = DELTALON - 360.D0
          I = KNOWNI + (DELTALON/ (DLON*DEG_PER_RAD))
          J = KNOWNJ + (DLOG(TAN(0.5D0* ((LAT+90.D0)*RAD_PER_DEG))))/
     +        DLON - RSW

ccc      !PS
      ELSE IF (MAP_PROJ.EQ.2) THEN

          REFLON = STDLON + 90.D0

ccc         ! Compute numerator term of map scale factor
          SCALE_TOP = 1.D0 + HEMI*SIN(TRUELAT1*RAD_PER_DEG)

ccc         ! Compute radius to lower-left (SW) corner
          ALA1 = LAT1*RAD_PER_DEG
          RSW = REBYDX*COS(ALA1)*SCALE_TOP/ (1.D0+HEMI*SIN(ALA1))

ccc         ! Find the pole point
          ALO1 = (LON1-REFLON)*RAD_PER_DEG
          POLEI = KNOWNI - RSW*COS(ALO1)
          POLEJ = KNOWNJ - HEMI*RSW*SIN(ALO1)

ccc         ! Find radius to desired point
          ALA = LAT*RAD_PER_DEG
          RM = REBYDX*COS(ALA)*SCALE_TOP/ (1.D0+HEMI*SIN(ALA))
          ALO = (LON-REFLON)*RAD_PER_DEG
          I = POLEI + RM*COS(ALO)
          J = POLEJ + HEMI*RM*SIN(ALO)

ccc      !LAMBERT
      ELSE IF (MAP_PROJ.EQ.1) THEN

          IF (ABS(TRUELAT2).GT.90.D0) THEN
              TRUELAT2 = TRUELAT1
          END IF

          IF (ABS(TRUELAT1-TRUELAT2).GT.0.1D0) THEN
              CONE = (DLOG(COS(TRUELAT1*RAD_PER_DEG))-
     +               DLOG(COS(TRUELAT2*RAD_PER_DEG)))/
     +               (DLOG(TAN((90.D0-ABS(TRUELAT1))*RAD_PER_DEG*
     +               0.5D0))-DLOG(TAN((90.D0-ABS(TRUELAT2))*RAD_PER_DEG*
     +               0.5D0)))
          ELSE
              CONE = SIN(ABS(TRUELAT1)*RAD_PER_DEG)
          END IF

ccc         ! Compute longitude differences and ensure we stay
ccc         ! out of the forbidden "cut zone"
          DELTALON1 = LON1 - STDLON
          IF (DELTALON1.GT.+180.D0) DELTALON1 = DELTALON1 - 360.D0
          IF (DELTALON1.LT.-180.D0) DELTALON1 = DELTALON1 + 360.D0

ccc         ! Convert truelat1 to radian and compute COS for later use
          TL1R = TRUELAT1*RAD_PER_DEG
          CTL1R = COS(TL1R)

ccc         ! Compute the radius to our known lower-left (SW) corner
          RSW = REBYDX*CTL1R/CONE* (TAN((90.D0*HEMI-
     +          LAT1)*RAD_PER_DEG/2.D0)/TAN((90.D0*HEMI-
     +          TRUELAT1)*RAD_PER_DEG/2.D0))**CONE

ccc         ! Find pole point
          ARG = CONE* (DELTALON1*RAD_PER_DEG)
          POLEI = HEMI*KNOWNI - HEMI*RSW*SIN(ARG)
          POLEJ = HEMI*KNOWNJ + RSW*COS(ARG)

ccc         ! Compute deltalon between known longitude and standard
ccc         ! lon and ensure it is not in the cut zone
          DELTALON = LON - STDLON
          IF (DELTALON.GT.+180.D0) DELTALON = DELTALON - 360.D0
          IF (DELTALON.LT.-180.D0) DELTALON = DELTALON + 360.D0

ccc         ! Radius to desired point
          RM = REBYDX*CTL1R/CONE* (TAN((90.D0*HEMI-
     +         LAT)*RAD_PER_DEG/2.D0)/TAN((90.D0*HEMI-
     +         TRUELAT1)*RAD_PER_DEG/2.D0))**CONE

          ARG = CONE* (DELTALON*RAD_PER_DEG)
          I = POLEI + HEMI*RM*SIN(ARG)
          J = POLEJ - RM*COS(ARG)

ccc         ! Finally, if we are in the southern hemisphere, flip the
ccc         ! i/j values to a coordinate system where (1,1) is the SW
ccc         ! corner (what we assume) which is different than the
ccc         ! original NCEP algorithms which used the NE corner as
ccc         ! the origin in the southern hemisphere (left-hand vs.
ccc         ! right-hand coordinate?)
          I = HEMI*I
          J = HEMI*J


ccc     !lat-lon
      ELSE IF (MAP_PROJ.EQ.6) THEN

          IF (POLE_LAT.NE.90.D0) THEN
              CALL ROTATECOORDS(LAT,LON,OLAT,OLON,POLE_LAT,POLE_LON,
     +                          STDLON,-1)
              LAT = OLAT
              LON = OLON + STDLON
          END IF

c         ! make sure center lat/lon is good
          IF (POLE_LAT.NE.90.D0) THEN
              CALL ROTATECOORDS(LAT1,LON1,OLAT,OLON,POLE_LAT,POLE_LON,
     +                          STDLON,-1)
              LAT1N = OLAT
              LON1N = OLON + STDLON
              DELTALAT = LAT - LAT1N
              DELTALON = LON - LON1N
          ELSE
              DELTALAT = LAT - LAT1
              DELTALON = LON - LON1
          END IF

c         ! Compute i/j
          I = DELTALON/LONINC
          J = DELTALAT/LATINC

          I = I + KNOWNI
          J = J + KNOWNJ

      ELSE

          PRINT *,'ERROR: Do not know map projection ',MAP_PROJ

      END IF

      LOC(1) = J
      LOC(2) = I

      RETURN
      END


C NCLFORTSTART
      SUBROUTINE DIJTOLL(MAP_PROJ,TRUELAT1,TRUELAT2,STDLON,LAT1,LON1,
     +                   POLE_LAT,POLE_LON,KNOWNI,KNOWNJ,DX,DY,LATINC,
     +                   LONINC,AI,AJ,LOC)
      DOUBLE PRECISION GI2
      DOUBLE PRECISION ARCCOS
      DOUBLE PRECISION DELTALON1
      DOUBLE PRECISION TL1R

ccc     ! Converts input lat/lon values to the cartesian (i,j) value
ccc     ! for the given projection.

      INTEGER MAP_PROJ
      DOUBLE PRECISION TRUELAT1,TRUELAT2,STDLON
      DOUBLE PRECISION LAT1,LON1,POLE_LAT,POLE_LON,KNOWNI,KNOWNJ
      DOUBLE PRECISION DX,DY,LATINC,LONINC,AI,AJ,LOC(2)
C NCLEND

      DOUBLE PRECISION CLAIN,DLON,RSW,DELTALON,DELTALAT
      DOUBLE PRECISION REFLON,SCALE_TOP,ALA1,ALO1,ALA,ALO,RM,POLEI,POLEJ
c Earth radius divided by dx
      DOUBLE PRECISION REBYDX
      DOUBLE PRECISION DELTALON1TL1R,CTL1R,ARG,CONE,HEMI

      DOUBLE PRECISION PI,RAD_PER_DEG,DEG_PER_RAD,RE_M

      DOUBLE PRECISION INEW,JNEW,R,R2
      DOUBLE PRECISION CHI,CHI1,CHI2
      DOUBLE PRECISION XX,YY,LAT,LON

      DOUBLE PRECISION RLAT,RLON,OLAT,OLON,LAT1N,LON1N
      DOUBLE PRECISION PHI_NP,LAM_NP,LAM_0,DLAM
      DOUBLE PRECISION SINPHI,COSPHI,COSLAM,SINLAM


ccc     lat1     ! SW latitude (1,1) in degrees (-90->90N)
ccc     lon1     ! SW longitude (1,1) in degrees (-180->180E)
ccc     dx       ! Grid spacing in meters at truelats
ccc     dlat     ! Lat increment for lat/lon grids
ccc     dlon     ! Lon increment for lat/lon grids
ccc     stdlon   ! Longitude parallel to y-axis (-180->180E)
ccc     truelat1 ! First true latitude (all projections)
ccc     truelat2 ! Second true lat (LC only)
ccc     hemi     ! 1 for NH, -1 for SH
ccc     cone     ! Cone factor for LC projections
ccc     polei    ! Computed i-location of pole point
ccc     polej    ! Computed j-location of pole point
ccc     rsw      ! Computed radius to SW corner
ccc     knowni   ! X-location of known lat/lon
ccc     knownj   ! Y-location of known lat/lon
ccc     RE_M     ! Radius of spherical earth, meters
ccc     REbydx   ! Earth radius divided by dx

      PI = 3.141592653589793D0
      RAD_PER_DEG = PI/180.D0
      DEG_PER_RAD = 180.D0/PI
c Radius of spherical earth, meters
      RE_M = 6370000.D0
      REBYDX = RE_M/DX

      HEMI = 1.0D0
      IF (TRUELAT1.LT.0.0D0) THEN
          HEMI = -1.0D0
      END IF


ccc     !MERCATOR
      IF (MAP_PROJ.EQ.3) THEN

ccc       !  Preliminary variables
          CLAIN = COS(RAD_PER_DEG*TRUELAT1)
          DLON = DX/ (RE_M*CLAIN)

ccc       ! Compute distance from equator to origin, and store in 
ccc       ! the rsw tag.
          RSW = 0.D0
          IF (LAT1.NE.0.D0) THEN
              RSW = (DLOG(TAN(0.5D0* ((LAT1+90.D0)*RAD_PER_DEG))))/DLON
          END IF

          LAT = 2.0D0*ATAN(EXP(DLON* (RSW+AJ-KNOWNJ)))*DEG_PER_RAD -
     +          90.D0
          LON = (AI-KNOWNI)*DLON*DEG_PER_RAD + LON1
          IF (LON.GT.180.D0) LON = LON - 360.D0
          IF (LON.LT.-180.D0) LON = LON + 360.D0


ccc     !PS
      ELSE IF (MAP_PROJ.EQ.2) THEN

ccc       ! Compute the reference longitude by rotating 90 degrees to
ccc       ! the east to find the longitude line parallel to the 
ccc       ! positive x-axis.
          REFLON = STDLON + 90.D0

ccc       ! Compute numerator term of map scale factor
          SCALE_TOP = 1.D0 + HEMI*SIN(TRUELAT1*RAD_PER_DEG)

ccc       ! Compute radius to known point
          ALA1 = LAT1*RAD_PER_DEG
          RSW = REBYDX*COS(ALA1)*SCALE_TOP/ (1.D0+HEMI*SIN(ALA1))

ccc       ! Find the pole point
          ALO1 = (LON1-REFLON)*RAD_PER_DEG
          POLEI = KNOWNI - RSW*COS(ALO1)
          POLEJ = KNOWNJ - HEMI*RSW*SIN(ALO1)

ccc       ! Compute radius to point of interest
          XX = AI - POLEI
          YY = (AJ-POLEJ)*HEMI
          R2 = XX**2 + YY**2

ccc       ! Now the magic code
          IF (R2.EQ.0.D0) THEN
              LAT = HEMI*90.D0
              LON = REFLON
          ELSE
              GI2 = (REBYDX*SCALE_TOP)**2.D0
              LAT = DEG_PER_RAD*HEMI*ASIN((GI2-R2)/ (GI2+R2))
              ARCCOS = ACOS(XX/SQRT(R2))
              IF (YY.GT.0) THEN
                  LON = REFLON + DEG_PER_RAD*ARCCOS
              ELSE
                  LON = REFLON - DEG_PER_RAD*ARCCOS
              END IF
          END IF

ccc       ! Convert to a -180 -> 180 East convention
          IF (LON.GT.180.D0) LON = LON - 360.D0
          IF (LON.LT.-180.D0) LON = LON + 360.D0

ccc     !LAMBERT
      ELSE IF (MAP_PROJ.EQ.1) THEN

          IF (ABS(TRUELAT2).GT.90.D0) THEN
              TRUELAT2 = TRUELAT1
          END IF

          IF (ABS(TRUELAT1-TRUELAT2).GT.0.1D0) THEN
              CONE = (DLOG(COS(TRUELAT1*RAD_PER_DEG))-
     +               DLOG(COS(TRUELAT2*RAD_PER_DEG)))/
     +               (DLOG(TAN((90.D0-ABS(TRUELAT1))*RAD_PER_DEG*
     +               0.5D0))-DLOG(TAN((90.D0-ABS(TRUELAT2))*RAD_PER_DEG*
     +               0.5D0)))
          ELSE
              CONE = SIN(ABS(TRUELAT1)*RAD_PER_DEG)
          END IF

ccc       ! Compute longitude differences and ensure we stay out of the
ccc       ! forbidden "cut zone"
          DELTALON1 = LON1 - STDLON
          IF (DELTALON1.GT.+180.D0) DELTALON1 = DELTALON1 - 360.D0
          IF (DELTALON1.LT.-180.D0) DELTALON1 = DELTALON1 + 360.D0

ccc       ! Convert truelat1 to radian and compute COS for later use
          TL1R = TRUELAT1*RAD_PER_DEG
          CTL1R = COS(TL1R)

ccc       ! Compute the radius to our known point
          RSW = REBYDX*CTL1R/CONE* (TAN((90.D0*HEMI-
     +          LAT1)*RAD_PER_DEG/2.D0)/TAN((90.D0*HEMI-
     +          TRUELAT1)*RAD_PER_DEG/2.D0))**CONE

ccc       ! Find pole point
          ALO1 = CONE* (DELTALON1*RAD_PER_DEG)
          POLEI = HEMI*KNOWNI - HEMI*RSW*SIN(ALO1)
          POLEJ = HEMI*KNOWNJ + RSW*COS(ALO1)

          CHI1 = (90.D0-HEMI*TRUELAT1)*RAD_PER_DEG
          CHI2 = (90.D0-HEMI*TRUELAT2)*RAD_PER_DEG

ccc       ! See if we are in the southern hemispere and flip the 
ccc       ! indices if we are.
          INEW = HEMI*AI
          JNEW = HEMI*AJ

ccc       ! Compute radius**2 to i/j location
          REFLON = STDLON + 90.D0
          XX = INEW - POLEI
          YY = POLEJ - JNEW
          R2 = (XX*XX+YY*YY)
          R = SQRT(R2)/REBYDX

ccc       ! Convert to lat/lon
          IF (R2.EQ.0.D0) THEN
              LAT = HEMI*90.D0
              LON = STDLON
          ELSE
              LON = STDLON + DEG_PER_RAD*ATAN2(HEMI*XX,YY)/CONE
              LON = DMOD(LON+360.D0,360.D0)
              IF (CHI1.EQ.CHI2) THEN
                  CHI = 2.0D0*ATAN((R/TAN(CHI1))** (1.D0/CONE)*
     +                  TAN(CHI1*0.5D0))
              ELSE
                  CHI = 2.0D0*ATAN((R*CONE/SIN(CHI1))** (1.D0/CONE)*
     +                  TAN(CHI1*0.5D0))
              END IF
              LAT = (90.0D0-CHI*DEG_PER_RAD)*HEMI
          END IF

          IF (LON.GT.+180.D0) LON = LON - 360.D0
          IF (LON.LT.-180.D0) LON = LON + 360.D0


ccc     !lat-lon
      ELSE IF (MAP_PROJ.EQ.6) THEN

          INEW = AI - KNOWNI
          JNEW = AJ - KNOWNJ

          IF (INEW.LT.0.D0) INEW = INEW + 360.D0/LONINC
          IF (INEW.GE.360.D0/DX) INEW = INEW - 360.D0/LONINC
c
ccc       ! Compute deltalat and deltalon
          DELTALAT = JNEW*LATINC
          DELTALON = INEW*LONINC

          IF (POLE_LAT.NE.90.D0) THEN
              CALL ROTATECOORDS(LAT1,LON1,OLAT,OLON,POLE_LAT,POLE_LON,
     +                          STDLON,-1)
              LAT1N = OLAT
              LON1N = OLON + STDLON
              LAT = DELTALAT + LAT1N
              LON = DELTALON + LON1N
          ELSE
              LAT = DELTALAT + LAT1
              LON = DELTALON + LON1
          END IF


          IF (POLE_LAT.NE.90.D0) THEN
              LON = LON - STDLON
              CALL ROTATECOORDS(LAT,LON,OLAT,OLON,POLE_LAT,POLE_LON,
     +                          STDLON,1)
              LAT = OLAT
              LON = OLON
          END IF

          IF (LON.LT.-180.D0) LON = LON + 360.D0
          IF (LON.GT.180.D0) LON = LON - 360.D0

      ELSE

          PRINT *,'ERROR: Do not know map projection ',MAP_PROJ

      END IF

      LOC(1) = LAT
      LOC(2) = LON
      RETURN

      END


C NCLFORTSTART
      SUBROUTINE ROTATECOORDS(ILAT,ILON,OLAT,OLON,LAT_NP,LON_NP,LON_0,
     +                        DIRECTION)
      DOUBLE PRECISION ILAT,ILON
      DOUBLE PRECISION OLAT,OLON
      DOUBLE PRECISION LAT_NP,LON_NP,LON_0
      INTEGER DIRECTION
C NCLEND

c       ! >=0, default : computational -> geographical
c       ! < 0          : geographical  -> computational

      DOUBLE PRECISION RLAT,RLON
      DOUBLE PRECISION PHI_NP,LAM_NP,LAM_0,DLAM
      DOUBLE PRECISION SINPHI,COSPHI,COSLAM,SINLAM
      DOUBLE PRECISION PI,RAD_PER_DEG,DEG_PER_RAD

      PI = 3.141592653589793D0
      RAD_PER_DEG = PI/180.D0
      DEG_PER_RAD = 180.D0/PI

c       ! Convert all angles to radians
      PHI_NP = LAT_NP*RAD_PER_DEG
      LAM_NP = LON_NP*RAD_PER_DEG
      LAM_0 = LON_0*RAD_PER_DEG
      RLAT = ILAT*RAD_PER_DEG
      RLON = ILON*RAD_PER_DEG

      IF (DIRECTION.LT.0) THEN
c          ! The equations are exactly the same except for one
c          ! small difference with respect to longitude ...
          DLAM = PI - LAM_0
      ELSE
          DLAM = LAM_NP
      END IF
      SINPHI = COS(PHI_NP)*COS(RLAT)*COS(RLON-DLAM) +
     +         SIN(PHI_NP)*SIN(RLAT)
      COSPHI = SQRT(1.D0-SINPHI*SINPHI)
      COSLAM = SIN(PHI_NP)*COS(RLAT)*COS(RLON-DLAM) -
     +         COS(PHI_NP)*SIN(RLAT)
      SINLAM = COS(RLAT)*SIN(RLON-DLAM)
      IF (COSPHI.NE.0.D0) THEN
          COSLAM = COSLAM/COSPHI
          SINLAM = SINLAM/COSPHI
      END IF
      OLAT = DEG_PER_RAD*ASIN(SINPHI)
      OLON = DEG_PER_RAD* (ATAN2(SINLAM,COSLAM)-DLAM-LAM_0+LAM_NP)

      END

C
C $Id: aginit.f,v 1.6 2008-07-27 00:14:34 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE AGINIT
C
C This routine is called to initialize some machine-dependent constants.
C
C The following common block contains the AUTOGRAPH control parameters,
C all of which are real.  If it is changed, all of AUTOGRAPH (especially
C the routine AGSCAN) must be examined for possible side effects.
C
      COMMON /AGCONP/ QFRA,QSET,QROW,QIXY,QWND,QBAC , SVAL(2) ,
     +                XLGF,XRGF,YBGF,YTGF , XLGD,XRGD,YBGD,YTGD , SOGD ,
     +                XMIN,XMAX,QLUX,QOVX,QCEX,XLOW,XHGH ,
     +                YMIN,YMAX,QLUY,QOVY,QCEY,YLOW,YHGH ,
     +                QDAX(4),QSPA(4),PING(4),PINU(4),FUNS(4),QBTD(4),
     +                BASD(4),QMJD(4),QJDP(4),WMJL(4),WMJR(4),QMND(4),
     +                QNDP(4),WMNL(4),WMNR(4),QLTD(4),QLED(4),QLFD(4),
     +                QLOF(4),QLOS(4),DNLA(4),WCLM(4),WCLE(4) ,
     +                QODP,QCDP,WOCD,WODQ,QDSH(26) ,
     +                     QDLB,QBIM,FLLB(10,8),QBAN ,
     +                QLLN,TCLN,QNIM,FLLN(6,16),QNAN ,
     +                XLGW,XRGW,YBGW,YTGW , XLUW,XRUW,YBUW,YTUW ,
     +                XLCW,XRCW,YBCW,YTCW , WCWP,HCWP,SCWP ,
     +                XBGA(4),YBGA(4),UBGA(4),XNDA(4),YNDA(4),UNDA(4),
     +                QBTP(4),BASE(4),QMNT(4),QLTP(4),QLEX(4),QLFL(4),
     +                QCIM(4),QCIE(4),RFNL(4),WNLL(4),WNLR(4),WNLB(4),
     +                WNLE(4),QLUA(4) ,
     +                RBOX(6),DBOX(6,4),SBOX(6,4)
      SAVE /AGCONP/
C
C The following common block contains other AUTOGRAPH variables, both
C real and integer, which are not control parameters.
C
      COMMON /AGORIP/ SMRL , ISLD , MWCL,MWCM,MWCE,MDLA,MWCD,MWDQ ,
     +                INIF
      SAVE /AGORIP/
C
C The following common block contains the new variable SMLL, which is
C essentially the smallest positive real number X such that "1.+X" is
C different from "1.".  This is used for some purposes for which the
C variable SMRL was previously used.  (10/21/89)
C
      COMMON /AGORIQ/ SMLL
      SAVE /AGORIQ/
C
C Fill in the names of the four pre-defined labels.
C
      CALL AGSTCH ('L',1,IDCS)
      FLLB(1,1)=REAL(IDCS)
      CALL AGSTCH ('R',1,IDCS)
      FLLB(1,2)=REAL(IDCS)
      CALL AGSTCH ('B',1,IDCS)
      FLLB(1,3)=REAL(IDCS)
      CALL AGSTCH ('T',1,IDCS)
      FLLB(1,4)=REAL(IDCS)
C
C Declare the rest of the label-definition slots to be available.
C
      LBIM=INT(QBIM)
C
      DO 101 J=5,LBIM
        FLLB(1,J)=0.
  101 CONTINUE
C
C Fill in the text of the four pre-defined lines.
C
      CALL AGSTCH ('Y',1,IDCS)
      FLLN(4,1)=REAL(IDCS)
      CALL AGSTCH (' ',1,IDCS)
      FLLN(4,2)=REAL(IDCS)
      CALL AGSTCH ('X',1,IDCS)
      FLLN(4,3)=REAL(IDCS)
      CALL AGSTCH (' ',1,IDCS)
      FLLN(4,4)=REAL(IDCS)
C
C Declare the rest of the line-definition slots to be available.
C
      LNIM=INT(QNIM)
C
      DO 102 J=5,LNIM
        FLLN(1,J)=SVAL(1)
  102 CONTINUE
C
C Set the value of 'LINE/TERMINATOR.'
C
      CALL AGSTCH ('$',1,IDCS)
      TCLN=REAL(IDCS)
C
C Compute the values of SMLL and SMRL.
C
      SMLL=MAX(1.E-13,2./REAL(I1MACH(10))**I1MACH(11))
      SMRL=8.*SMLL
C
C ISLD is an integer containing 16 one bits (right-justified with zero
C fill to the left).  It is used to direct the DASHCHAR package to draw
C solid lines.  To generate it, we start with a 15-bit mask and then
C add another bit.
C
      ISLD = 32767
      ISLD = ISHIFT(ISLD,1)
      ISLD = IOR(ISLD,1)
C
C Set the initialization flag to indicate initialization has been done.
C
      INIF=1
C
C Done.
C
      RETURN
C
      END

C
C	$Id: conint.f,v 1.4 2008-07-27 00:16:57 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CONINT (NDP,XD,YD,ZD,NCP,IPC,PD)
C
C THIS SUBROUTINE ESTIMATES PARTIAL DERIVATIVES OF THE FIRST AND
C SECOND ORDER AT THE DATA POINTS.
C THE INPUT PARAMETERS ARE
C
C     NDP = NUMBER OF DATA POINTS,
C     XD,YD,ZD = ARRAYS CONTAINING THE X, Y, AND Z COORDI-
C                NATES OF DATA POINTS,
C     NCP = NUMBER OF DATA POINTS TO BE USED FOR ESTIMATION
C           OF PARTIAL DERIVATIVES AT EACH DATA POINT,
C     IPC = INTEGER ARRAY CONTAINING THE POINT NUMBERS OF
C           NCP DATA POINTS CLOSEST TO EACH OF THE NDP DATA
C           POINT.
C THE OUTPUT PARAMETER IS
C
C     PD  = ARRAY OF DIMENSION 5*NDP, WHERE THE ESTIMATED
C
C           ZX, ZY, ZXX, ZXY, AND ZYY VALUES AT THE DATA
C           POINTS ARE TO BE STORED.
C DECLARATION STATEMENTS
C
C
      DIMENSION       XD(NDP)    ,YD(NDP)    ,ZD(NDP)    ,IPC(1)     ,
     1                PD(1)
      REAL            NMX        ,NMY        ,NMZ        ,NMXX       ,
     1                NMXY        ,NMYX       ,NMYY
C
      SAVE
C
C PRELIMINARY PROCESSING
C
C
      NCPM1 = NCP-1
C
C ESTIMATION OF ZX AND ZY
C
C
      DO  130 IP0=1,NDP
         X0 = XD(IP0)
         Y0 = YD(IP0)
         Z0 = ZD(IP0)
         NMX = 0.0
         NMY = 0.0
         NMZ = 0.0
         JIPC0 = NCP*(IP0-1)
         DO  120 IC1=1,NCPM1
            JIPC = JIPC0+IC1
            IPI = IPC(JIPC)
            DX1 = XD(IPI)-X0
            DY1 = YD(IPI)-Y0
            DZ1 = ZD(IPI)-Z0
            IC2MN = IC1+1
            DO  110 IC2=IC2MN,NCP
               JIPC = JIPC0+IC2
               IPI = IPC(JIPC)
               DX2 = XD(IPI)-X0
               DY2 = YD(IPI)-Y0
               DNMZ = DX1*DY2-DY1*DX2
               IF (DNMZ .EQ. 0.0) GO TO  110
               DZ2 = ZD(IPI)-Z0
               DNMX = DY1*DZ2-DZ1*DY2
               DNMY = DZ1*DX2-DX1*DZ2
               IF (DNMZ .GE. 0.0) GO TO  100
               DNMX = -DNMX
               DNMY = -DNMY
               DNMZ = -DNMZ
  100          NMX = NMX+DNMX
               NMY = NMY+DNMY
               NMZ = NMZ+DNMZ
  110       CONTINUE
  120    CONTINUE
         JPD0 = 5*IP0
         PD(JPD0-4) = -NMX/NMZ
         PD(JPD0-3) = -NMY/NMZ
  130 CONTINUE
C
C ESTIMATION OF ZXX, ZXY, AND ZYY
C
C
      DO  170 IP0=1,NDP
         JPD0 = JPD0+5
         X0 = XD(IP0)
         JPD0 = 5*IP0
         Y0 = YD(IP0)
         ZX0 = PD(JPD0-4)
         ZY0 = PD(JPD0-3)
         NMXX = 0.0
         NMXY = 0.0
         NMYX = 0.0
         NMYY = 0.0
         NMZ = 0.0
         JIPC0 = NCP*(IP0-1)
         DO  160 IC1=1,NCPM1
            JIPC = JIPC0+IC1
            IPI = IPC(JIPC)
            DX1 = XD(IPI)-X0
            DY1 = YD(IPI)-Y0
            JPD = 5*IPI
            DZX1 = PD(JPD-4)-ZX0
            DZY1 = PD(JPD-3)-ZY0
            IC2MN = IC1+1
            DO  150 IC2=IC2MN,NCP
               JIPC = JIPC0+IC2
               IPI = IPC(JIPC)
               DX2 = XD(IPI)-X0
               DY2 = YD(IPI)-Y0
               DNMZ = DX1*DY2-DY1*DX2
               IF (DNMZ .EQ. 0.0) GO TO  150
               JPD = 5*IPI
               DZX2 = PD(JPD-4)-ZX0
               DZY2 = PD(JPD-3)-ZY0
               DNMXX = DY1*DZX2-DZX1*DY2
               DNMXY = DZX1*DX2-DX1*DZX2
               DNMYX = DY1*DZY2-DZY1*DY2
               DNMYY = DZY1*DX2-DX1*DZY2
               IF (DNMZ .GE. 0.0) GO TO  140
               DNMXX = -DNMXX
               DNMXY = -DNMXY
               DNMYX = -DNMYX
               DNMYY = -DNMYY
               DNMZ = -DNMZ
  140          NMXX = NMXX+DNMXX
               NMXY = NMXY+DNMXY
               NMYX = NMYX+DNMYX
               NMYY = NMYY+DNMYY
               NMZ = NMZ+DNMZ
  150       CONTINUE
  160    CONTINUE
         PD(JPD0-2) = -NMXX/NMZ
         PD(JPD0-1) = -(NMXY+NMYX)/(2.0*NMZ)
         PD(JPD0) = -NMYY/NMZ
  170 CONTINUE
      RETURN
      END

C
C $Id: wtstr.f,v 1.7 2008-07-27 00:17:25 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE WTSTR (PX,PY,CH,IS,IO,IC)
C
C WTSTR is called to draw a character string in a specified position.
C
C PX and PY specify, in user coordinates, the position of a point
C relative to which a character string is to be positioned.
C
C CH is the character string to be written.
C
C IS is the desired size of the characters to be used, stated as a
C character width in the plotter coordinate system.  The values 0, 1,
C 2, and 3 mean 8, 12, 16, and 24, respectively.
C
C IO is the desired orientation angle, in degrees counterclockwise from
C a horizontal vector pointing to the right.
C
C IC specifies the desired type of centering.  A negative value puts
C (PX,PY) in the center of the left end of the character string, a zero
C puts (PX,PY) in the center of the whole string, and a positive value
C puts (PX,PY) in the center of the right end of the character string.
C
      CHARACTER*(*) CH
C
C Define arrays in which to save the current viewport and window.
C
      DIMENSION VP(4),WD(4)
C
C Check for an uncleared prior error.
C
      IF (ICFELL('WTSTR - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C Flush the pen-move buffer.
C
      CALL PLOTIF (0.,0.,2)
      IF (ICFELL('WTSTR',2).NE.0) RETURN
C
C Compute the coordinates of (PX,PY) in the fractional coordinate
C system (normalized device coordinates).
C
      XN=CUFX(PX)
      IF (ICFELL('WTSTR',3).NE.0) RETURN
      YN=CUFY(PY)
      IF (ICFELL('WTSTR',4).NE.0) RETURN
C
C Save the current window and, if necessary, redefine it so that we can
C use normalized device coordinates.
C
      CALL GQCNTN (IE,NT)
      IF (IE.NE.0) THEN
        CALL SETER ('WTSTR - ERROR EXIT FROM GQCNTN',5,1)
        RETURN
      END IF
      IF (NT.NE.0) THEN
        CALL GQNT (NT,IE,WD,VP)
        IF (IE.NE.0) THEN
          CALL SETER ('WTSTR - ERROR EXIT FROM GQNT',6,1)
          RETURN
        END IF
        CALL GSWN (NT,VP(1),VP(2),VP(3),VP(4))
      END IF
C
C Save current character height, text path, character up vector, and
C text alignment.
C
      CALL GQCHH (IE,OS)
      IF (IE.NE.0) THEN
        CALL SETER ('WTSTR - ERROR EXIT FROM GQCHH',7,1)
        RETURN
      END IF
      CALL GQTXP (IE,IP)
      IF (IE.NE.0) THEN
        CALL SETER ('WTSTR - ERROR EXIT FROM GQTXP',8,1)
        RETURN
      END IF
      CALL GQCHUP (IE,UX,UY)
      IF (IE.NE.0) THEN
        CALL SETER ('WTSTR - ERROR EXIT FROM GQCHUP',9,1)
        RETURN
      END IF
      CALL GQTXAL (IE,IX,IY)
      IF (IE.NE.0) THEN
        CALL SETER ('WTSTR - ERROR EXIT FROM GQTXAL',10,1)
        RETURN
      END IF
C
C Define the character height.  (The final scale factor is derived from
C the default font.)
C
      CALL GETUSV ('YF',MY)
      IF (ICFELL('WTSTR',11).NE.0) RETURN
      YS=REAL(2**MY)
      IF (IS.GE.0.AND.IS.LE.3) THEN
        CS=REAL(8+4*IS+4*(IS/3))/YS
      ELSE
        CS=MIN(REAL(IS),YS)/YS
      ENDIF
C
C     CS=CS*1.0
C
      CALL GSCHH(CS)
C
C Define the text path.
C
      CALL GSTXP (0)
C
C Define the character up vector.
C
      JO=MOD(IO,360)
      IF (JO.EQ.0) THEN
        CALL GSCHUP (0.,1.)
      ELSE IF (JO.EQ.90) THEN
        CALL GSCHUP (-1.,0.)
      ELSE IF (JO.EQ.180) THEN
        CALL GSCHUP (0.,-1.)
      ELSE IF (JO.EQ.270) THEN
        CALL GSCHUP (1.,0.)
      ELSE IF (JO.GT.0.AND.JO.LT.180) THEN
        CALL GSCHUP (-1.,1./TAN(REAL(JO)*3.1415926/180.))
      ELSE
        CALL GSCHUP (1.,-1./TAN(REAL(JO)*3.1415926/180.))
      ENDIF
C
C Define the text alignment.
C
      CALL GSTXAL (MAX(-1,MIN(+1,IC))+2,3)
C
C Plot the characters.
C
      CALL GTX (XN,YN,CH)
C
C Restore the original text attributes.
C
      CALL GSCHH (OS)
      CALL GSTXP (IP)
      CALL GSCHUP (UX,UY)
      CALL GSTXAL (IX,IY)
C
C Restore the window definition.
C
      IF (NT.NE.0) THEN
        CALL GSWN (NT,WD(1),WD(2),WD(3),WD(4))
      END IF
C
C Update the pen position.
C
      CALL FRSTPT (PX,PY)
      IF (ICFELL('WTSTR',12).NE.0) RETURN
C
C Done.
C
      RETURN
C
      END

      PROGRAM MPEX07
C
C This program produces a stereographic view of the North Pole,
C with labelled meridians.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
        PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Define the label for the top of the map.
C
      CHARACTER*32 PLBL
C
      DATA PLBL / 'MERIDIONAL LABELS ON A POLAR MAP' /
C
C Open GKS.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Turn off the clipping indicator.
C
      CALL GSCLIP (0)
C
C Move the map a little to provide more room for labels.
C
      CALL MAPPOS (.075,.925,.05,.90)
C
C Use an elliptical (circular, in this case) perimeter.
C
      CALL MAPSTI ('EL',1)
C
C Show continents and international boundaries.
C
      CALL MAPSTC ('OU','PO')
C
C Use a stereographic projection, centered at the North Pole.
C
      CALL MAPROJ ('ST',90.,0.,-100.)
C
C Specify the angular distances to the edges of the map.
C
      CALL MAPSET ('AN',80.,80.,80.,80.)
C
C Draw the map.
C
      CALL MAPDRW
C
C Call a routine to label the meridians.  This routine is not
C a part of EZMAP; the code is given below.
C
      CALL MAPLBM
C
C Put the label at the top of the plot.
C
      CALL SET (0.,1.,0.,1.,0.,1.,0.,1.,1)
      CALL PWRIT (.5,.975,PLBL,32,2,0,0)
C
C Draw a boundary around the edge of the plotter frame.
C
      CALL BNDARY
C
C Advance the frame.
C
      CALL FRAME
C
C Close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
C Done.
C
      STOP
C
      END
      SUBROUTINE MAPLBM
C
C This routine labels the meridians if and only if the current
C projection is azimuthal and centered at one of the poles, a
C circular boundary is being used, and the grid increment is an
C integral divisor of 180.  The routine was not thought general
C enough to include in EZMAP itself, but may nevertheless be of
C interest to users.
C
C Necessary local declarations.
C
      CHARACTER*2 PROJ
      CHARACTER*3 CHRS
      CHARACTER*4 CHLB
C
C See if the conditions required for MAPLBM to work are met.
C
C The projection must be azimuthal, ...
C
      CALL MAPGTC ('PR',PROJ)
      IF (PROJ.NE.'ST'.AND.PROJ.NE.'OR'.AND.PROJ.NE.'LE'.AND.
     +    PROJ.NE.'GN'.AND.PROJ.NE.'AE') RETURN
C
C the pole latitude must be +90 degrees or -90 degrees, ...
C
      CALL MAPGTR ('PT',PLAT)
      IF (ABS(PLAT).LT.89.9999) RETURN
C
C the perimeter must be elliptical, ...
C
      CALL MAPGTI ('EL',IELP)
      IF (IELP.EQ.0) RETURN
C
C the values used in the SET call must define a circle, ...
C
      CALL GETSET (FLEW,FREW,FBEW,FTEW,ULEW,UREW,VBEW,VTEW,LNLG)
      ILEW=KFPX(FLEW)
      IREW=KFPX(FREW)
      IBEW=KFPY(FBEW)
      ITEW=KFPY(FTEW)
      IF (ULEW+UREW.GT.0.0001.OR.VBEW+VTEW.GT.0.0001) RETURN
      IF (ULEW+VTEW.GT.0.0001.OR.VBEW+UREW.GT.0.0001) RETURN
C
C and the grid spacing must be an integral divisor of 180.
C
      CALL MAPGTR ('GR',GRID)
      IF (MOD(GRID,1.).NE.0.OR.
     +    MOD(180,INT(GRID)).NE.0) RETURN
C
C All conditions are satisfied.  Label the meridians.
C
C Collect the necessary information.
C
      IGRD=GRID
      CALL MAPGTR ('PN',PLON)
      CALL MAPGTR ('RO',ROTA)
      CALL MAPGTI ('LS',ICSZ)
      IF (ICSZ.EQ.0) THEN
        ICSZ=8
      ELSE IF (ICSZ.EQ.1) THEN
        ICSZ=12
      ELSE IF (ICSZ.EQ.2) THEN
        ICSZ=16
      ELSE IF (ICSZ.EQ.3) THEN
        ICSZ=24
      END IF
      WOCH=(REAL(  ICSZ)/REAL(IREW-ILEW))*(UREW-ULEW)
      HOCH=(REAL(2*ICSZ)/REAL(ITEW-IBEW))*(VTEW-VBEW)
      HOLB=HOCH/1.5
C
C Loop on the label values.
C
      DO 101 I=-180,179,IGRD
C
C Express the value of the longitude in a nice form.
C
        WRITE (CHRS,1001) ABS(I)
        NCHS=0
        IF (ABS(I).GE.100) THEN
          NCHS=NCHS+1
          CHLB(NCHS:NCHS)=CHRS(1:1)
        END IF
        IF (ABS(I).GE.10) THEN
          NCHS=NCHS+1
          CHLB(NCHS:NCHS)=CHRS(2:2)
        END IF
        NCHS=NCHS+1
        CHLB(NCHS:NCHS)=CHRS(3:3)
        IF (I.GT.-180.AND.I.LT.0) THEN
          NCHS=NCHS+1
          CHLB(NCHS:NCHS)='W'
        ELSE IF (I.GT.0.AND.I.LT.180) THEN
          NCHS=NCHS+1
          CHLB(NCHS:NCHS)='E'
        END IF
C
C Compute the width of the label.
C
       WOLB=REAL(NCHS)*WOCH
C
C Find the angle at which the labelled meridian lies on the plot.
C
        IF (PLAT.GT.0.) THEN
          ANGD=REAL(I-90)-PLON-ROTA
        ELSE
          ANGD=REAL(90-I)+PLON-ROTA
        END IF
C
C Reduce the angle to the range from -180 to +180 and
C find its equivalent in radians.
C
        ANGD=ANGD+(SIGN(180.,180.-ANGD)
     +            -SIGN(180.,ANGD+180.))
        ANGR=.017453292519943*ANGD
C
C Figure out where the end of the meridian is.
C
        XEND=UREW*COS(ANGR)
        YEND=VTEW*SIN(ANGR)
C
C Extend the meridian a little to make a tick mark.
C
        CALL LINE (XEND,YEND,1.015*XEND,1.015*YEND)
C
C Compute a center position for the label which puts its nearest
C edge at a fixed distance from the perimeter.  First, compute
C the components (DELX,DELY) of the vector from the center of the
C label box to the edge nearest the perimeter.
C
        IF      (ANGD.LT.-179.9999) THEN
          DELX=+0.5*WOLB
          DELY= 0.
        ELSE IF (ANGD.LT. -90.0001) THEN
          DELX=+0.5*WOLB
          DELY=+0.5*HOLB
        ELSE IF (ANGD.LT. -89.9999) THEN
          DELX= 0.0
          DELY=+0.5*HOLB
        ELSE IF (ANGD.LT.  -0.0001) THEN
          DELX=-0.5*WOLB
          DELY=+0.5*HOLB
        ELSE IF (ANGD.LT.  +0.0001) THEN
          DELX=-0.5*WOLB
          DELY= 0.0
        ELSE IF (ANGD.LT. +89.9999) THEN
          DELX=-0.5*WOLB
          DELY=-0.5*HOLB
        ELSE IF (ANGD.LT. +90.0001) THEN
          DELX= 0.0
          DELY=-0.5*HOLB
        ELSE IF (ANGD.LT.+179.9999) THEN
          DELX=+0.5*WOLB
          DELY=-0.5*HOLB
        ELSE
          DELX=+0.5*WOLB
          DELY= 0.0
        END IF
C
C Then, solve (for FMUL) the following equation:
C
C   SQRT((FMUL*XEND+DELX)**2+(FMUL*YEND+DELY)**2))=1.02*UREW
C
C which expresses the condition that the corner of the box
C nearest the circular perimeter should be at a distance of
C 1.02*(the radius of the perimeter) away from the center of
C the plot.
C
        A=XEND*XEND+YEND*YEND
        B=2.*(XEND*DELX+YEND*DELY)
        C=DELX*DELX+DELY*DELY-1.0404*UREW*UREW
C
        FMUL=(-B+SQRT(B*B-4.*A*C))/(2.*A)
C
C Draw the label.
C
        CALL PWRIT (FMUL*XEND,FMUL*YEND,CHLB,NCHS,ICSZ,0,0)
C
C End of loop.
C
  101 CONTINUE
C
C Done.
C
      RETURN
C
C Format
C
 1001 FORMAT (I3)
C
      END

      PROGRAM FCCE02
C
C PURPOSE                To provide a demonstration of the routines in
C                        the package COLCONV and to test them.
C
C I/O                    If the test is successful, the message
C
C                        COLCONV TEST SUCCESSFUL
C
C                        is written on unit 6.
C
C                        Otherwise, the message
C
C                        COLCONV TEST SUCCESSFUL
C
C                        is written on unit 6.
C
C REQUIRED PACKAGES      COLCONV
C
C ALGORITHM              TCOLCV executes six calls to test each of
C                        the color conversions:
C
C                              HLS to RGB
C                              RGB to HLS
C                              HSV to RGB
C                              RGB to HSV
C                              YIQ to RGB
C                              RGB to YIQ
C
C ---------------------------------------------------------------------
C
C  Initialize the error flag.
C
      IERR = 0
C
C  Set tolerance limit for HLS and HSV tests.
C
      EPS = 0.00001
C
C  HLS to RGB.
C
      HUE    = 120.
      RLIGHT =  50.
      SATR   = 100.
      CALL HLSRGB(HUE,RLIGHT,SATR,RED,GREEN,BLUE)
      IF ( (ABS(RED-1.) .GT. EPS) .OR. (ABS(GREEN) .GT. EPS) .OR.
     *     (ABS(BLUE) .GT. EPS) ) IERR = 1
C
C  RGB to HLS.
C
      RED   = 1.
      GREEN = 0.
      BLUE  = 0.
      CALL RGBHLS(RED,GREEN,BLUE,HUE,RLIGHT,SATR)
      IF ( (ABS(HUE-120.) .GT. EPS) .OR. (ABS(RLIGHT-50.) .GT. EPS) .OR.
     *     (ABS(SATR-100.) .GT. EPS) ) IERR = 1
C
C  HSV to RGB.
C
      HUE   = 120.
      SATR  = 1.
      VALUE = 1.
      CALL HSVRGB(HUE,SATR,VALUE,RED,GREEN,BLUE)
      IF ( (ABS(RED-0.) .GT. EPS) .OR. (ABS(GREEN-1.) .GT. EPS) .OR.
     *     (ABS(BLUE-0.) .GT. EPS) ) IERR = 1
C
C  RGB to HSV.
C
      RED   = 0.
      GREEN = 0.
      BLUE  = 1.
      CALL RGBHSV(RED,GREEN,BLUE,HUE,SATR,VALUE)
      IF ( (ABS(HUE-240.) .GT. EPS) .OR. (ABS(SATR-1.) .GT. EPS) .OR.
     *     (ABS(VALUE-1.) .GT. EPS) ) IERR = 1
C
C  Set tolerance limit for YIQ tests.
C
      EPS = 0.01
C
C  YIQ to RGB.
C
      Y = 0.59
      RI = -.28
      Q = -.52
      CALL YIQRGB(Y,RI,Q,RED,GREEN,BLUE)
      IF ( (ABS(RED-0.) .GT. EPS) .OR. (ABS(GREEN-1.) .GT. EPS) .OR.
     *     (ABS(BLUE-0.) .GT. EPS) ) IERR = 1
C
C  RGB to YIQ.
C
      RED   = 1.0
      GREEN = 1.0
      BLUE  = 1.0
      CALL RGBYIQ(RED,GREEN,BLUE,Y,RI,Q)
      IF ( (ABS(Y-1.) .GT. EPS) .OR. (ABS(RI) .GT. EPS) .OR.
     *     (ABS(Q) .GT. EPS) ) IERR = 1
C
      IF (IERR .EQ. 0) THEN
        WRITE (6,1001)
      ELSE
        WRITE (6,1002)
      ENDIF
C
      STOP
C
 1001 FORMAT (' COLCONV TEST SUCCESSFUL')
 1002 FORMAT (' COLCONV TEST UNSUCCESSFUL')
      END

      PROGRAM FTEX01D
C
C  Example of CURV1DP, CURV2DP, CURVDDP, CURVIDP.
C
C  Define dimensions, declare arrays.
C
      PARAMETER (IDIM=11,IOUT=201)
      DOUBLE PRECISION X
      DOUBLE PRECISION Y
      DOUBLE PRECISION YP
      DOUBLE PRECISION TEMP
      DOUBLE PRECISION XO
      DOUBLE PRECISION YO
      DOUBLE PRECISION YD
      DOUBLE PRECISION YI
      DOUBLE PRECISION SLP1
      DOUBLE PRECISION SLPN
      DOUBLE PRECISION SIGMA
      DOUBLE PRECISION XINC
      DOUBLE PRECISION CURV2DP
      DOUBLE PRECISION CURVDDP
      DOUBLE PRECISION CURVIDP
      DIMENSION X(IDIM),Y(IDIM),YP(IDIM),TEMP(IDIM,2)
      DIMENSION XO(IOUT),YO(IOUT),YD(IOUT),YI(IOUT)
C
C Specify the input data.
C
C
      DATA X/0.00D0,2.00D0,5.00D0,8.00D0,10.00D0,13.00D0,15.00D0,
     +     18.00D0,21.00D0,23.00D0,30.00D0/
      DATA Y/1.00D0,0.81D0,0.00D0,-0.81D0,-1.00D0,-0.84D0,-0.56D0,
     +     0.04D0,0.73D0,1.18D0,2.0D0/
C
C  Call CURV1DP setup, specifying that the derivatives should be
C  zero at the end points.
C
      SLP1 = 0.D0
      SLPN = 0.D0
      ISLPSW = 0
      SIGMA = 1.D0
      CALL CURV1DP(IDIM,X,Y,SLP1,SLPN,ISLPSW,YP,TEMP,SIGMA,IERR)
C
C  Call CURV2DP and calculate the interpolated values, the derivatives,
C  and the integrals.
C
      XINC = 30.D0/ (IOUT-1)
      DO 10 I = 1,IOUT
          XO(I) = (I-1)*XINC
          YO(I) = CURV2DP(XO(I),IDIM,X,Y,YP,SIGMA)
          YD(I) = CURVDDP(XO(I),IDIM,X,Y,YP,SIGMA)
          YI(I) = CURVIDP(XO(1),XO(I),IDIM,X,Y,YP,SIGMA)
   10 CONTINUE
C
C This next section plots the data. You must have a double precision
C version of NCAR Graphics in order for this section to compile and
C run correctly.  For now, it is commented out.
C
C  Draw a plot of the interpolated functions and mark the original points.
C
C      CALL DRWFT1(IDIM,X,Y,IOUT,XO,YO,YD,YI)
C
      STOP
      END
C      SUBROUTINE DRWFT1(II,X,Y,IO,XO,YO,YD,YI)
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C      DOUBLE PRECISION X
C      DOUBLE PRECISION Y
C      DOUBLE PRECISION XO
C      DOUBLE PRECISION YO
C      DOUBLE PRECISION YD
C      DOUBLE PRECISION YI
C      DOUBLE PRECISION YPOS_TOP
C      DOUBLE PRECISION YB
C      DOUBLE PRECISION YT
C
C      DATA YPOS_TOP/0.88D0/
C
C  Open GKS, open and activate a workstation.
C
C      CALL GOPKS(IERRF,ISZDM)
C      CALL GOPWK(IWKID,LUNIT,IWTYPE)
C      CALL GACWK(IWKID)
C
C  Define a color table.
C
C      CALL GSCR(IWKID,0,1.0D0,1.0D0,1.0D0)
C      CALL GSCR(IWKID,1,0.0D0,0.0D0,0.0D0)
C      CALL GSCR(IWKID,2,1.0D0,0.0D0,0.0D0)
C      CALL GSCR(IWKID,3,0.0D0,1.0D0,0.0D0)
C      CALL GSCR(IWKID,4,0.0D0,0.0D0,1.0D0)
C      CALL GSCLIP(0)
C
C  Plot main title.
C
C      CALL PLCHHQ(0.50D0,0.95D0,
C     +     ':F25:Demo for CURVDP, CURVDDP, CURVIDP',
C     +     0.030D0,0.D0,0.D0)
C
C  Graph the interpolated function values and mark the original
C  input data points.
C
C      YB = -1.0D0
C      YT = 2.0D0
C      CALL BKGFT1(YPOS_TOP,'Function',YB,YT)
C      CALL GRIDAL(6,5,3,1,1,1,10,0.0D0,YB)
C
C  Mark the original data points.
C
C      CALL GSMKSC(2.D0)
C      CALL GSPMCI(4)
C      CALL GSLWSC(1.D0)
C      CALL GPM(II,X,Y)
C
C  Graph the interpolated function values.
C
C      CALL GPL(IO,XO,YO)
C
C  Graph the derivative.
C
C      YB = -0.3D0
C      YT = 0.3D0
C      CALL BKGFT1(YPOS_TOP-0.3D0,'Derivative',YB,YT)
C      CALL GRIDAL(6,5,3,1,1,1,10,0.0D0,YB)
C      CALL GPL(IO,XO,YD)
C      CALL GSPLCI(1)
C
C  Graph the integral.
C
C      YB = -6.0D0
C      YT = 10.0D0
C      CALL BKGFT1(YPOS_TOP-0.6D0,'Integral',YB,YT)
C      CALL GRIDAL(6,5,4,1,1,1,10,0.0D0,YB)
C      CALL GPL(IO,XO,YI)
C      CALL GSPLCI(1)
C      CALL FRAME
C
C      CALL GDAWK(IWKID)
C      CALL GCLWK(IWKID)
C      CALL GCLKS
C
C      RETURN
C      END
C      SUBROUTINE BKGFT1(YPOS,LABEL,YB,YT)
C      DOUBLE PRECISION YPOS
C      DOUBLE PRECISION YB
C      DOUBLE PRECISION YT
C      DOUBLE PRECISION XX
C      DOUBLE PRECISION YY
C      DIMENSION XX(2),YY(2)
C      CHARACTER*(*) LABEL
C
C      CALL SET(0.D0,1.D0,0.D0,1.D0,0.D0,1.D0,0.D0,1.D0,1)
C      CALL PCSETI('FN',21)
C      CALL PLCHHQ(0.20D0,YPOS-0.03D0,LABEL,0.025D0,0.D0,-1.D0)
C      CALL SET(0.13D0,0.93D0,YPOS-0.2D0,YPOS,0.0D0,30.0D0,YB,YT,1)
C      XX(1) = 0.D0
C      XX(2) = 30.D0
C      YY(1) = 0.D0
C      YY(2) = 0.D0
C      CALL GSPLCI(2)
C      CALL GPL(2,XX,YY)
C      CALL GSPLCI(1)
C
C      CALL GASETI('LTY',1)
C      CALL PCSETI('FN',21)
C      CALL GASETR('XLS',0.02D0)
C      CALL GASETC('XLF','(I3)')
C      CALL GASETR('YLS',0.02D0)
C      CALL GASETC('YLF','(F5.1)')
C      CALL GASETR('XMJ',0.02D0)
C      CALL GASETR('YMJ',0.02D0)
C
C      RETURN
C      END

C
C $Id: curvddp.f,v 1.3 2008-07-27 03:10:10 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
C NOTE: If you make any changes to this software, please remember to
C make the same changes to the corresponding single precision routine.
C
      FUNCTION CURVDDP(T,N,X,Y,YP,SIGMA)
      DOUBLE PRECISION CURVDDP
      DOUBLE PRECISION SIGMAP
      DOUBLE PRECISION DEL1
      DOUBLE PRECISION DEL2
      DOUBLE PRECISION DELS
      DOUBLE PRECISION SUM
      DOUBLE PRECISION SIGDEL
      DOUBLE PRECISION SS
      DOUBLE PRECISION DUMMY
      DOUBLE PRECISION C1
      DOUBLE PRECISION C2
c
      INTEGER N
      DOUBLE PRECISION T,X(N),Y(N),YP(N),SIGMA
c
c                                 coded by alan kaylor cline
c                           from fitpack -- january 26, 1987
c                        a curve and surface fitting package
c                      a product of pleasant valley software
c                  8603 altus cove, austin, texas 78759, usa
c
c this function differentiates a curve at a given point
c using a spline under tension. the subroutine curv1 should
c be called earlier to determine certain necessary
c parameters.
c
c on input--
c
c   t contains a real value at which the derivative is to be
c   determined.
c
c   n contains the number of points which were specified to
c   determine the curve.
c
c   x and y are arrays containing the abscissae and
c   ordinates, respectively, of the specified points.
c
c   yp is an array of second derivative values of the curve
c   at the nodes.
c
c and
c
c   sigma contains the tension factor (its sign is ignored).
c
c the parameters n, x, y, yp, and sigma should be input
c unaltered from the output of curv1.
c
c on output--
c
c   curvddp contains the derivative value.
c
c none of the input parameters are altered.
c
c this function references package modules intrvldp and
c snhcshdp.
c
c-----------------------------------------------------------
c
c determine interval
c
      IM1 = INTRVLDP(T,X,N)
      I = IM1 + 1
c
c denormalize tension factor
c
      SIGMAP = ABS(SIGMA)*DBLE(N-1)/ (X(N)-X(1))
c
c set up and perform differentiation
c
      DEL1 = T - X(IM1)
      DEL2 = X(I) - T
      DELS = X(I) - X(IM1)
      SUM = (Y(I)-Y(IM1))/DELS
      IF (SIGMAP.NE.0.D0) GO TO 1
      CURVDDP = SUM + (YP(I)* (2.D0*DEL1*DEL1-DEL2* (DEL1+DELS))-
     +        YP(IM1)* (2.D0*DEL2*DEL2-DEL1* (DEL2+DELS)))/ (6.D0*DELS)
      RETURN
    1 SIGDEL = SIGMAP*DELS
      CALL SNHCSHDP(SS,DUMMY,SIGDEL,-1)
      CALL SNHCSHDP(DUMMY,C1,SIGMAP*DEL1,1)
      CALL SNHCSHDP(DUMMY,C2,SIGMAP*DEL2,1)
      CURVDDP = SUM + (YP(I)* (C1-SS)-YP(IM1)* (C2-SS))/
     +        (SIGDEL*SIGMAP* (1.D0+SS))
      RETURN
      END

C
C $Id: DATAITEMF.f,v 1.1 2001-10-09 00:18:34 haley Exp $
C
C****************************************************************
C                                                               *
C                       Copyright (C)  1995                     *
C       University Corporation for Atmospheric Research         *
C                       All Rights Reserved                     *
C                                                               *
C****************************************************************
C
C      File:            DATAITEM.f
C
C      Author:          Jeff W. Boote
C                       National Center for Atmospheric Research
C                       PO 3000, Boulder, Colorado
C
C      Date:            Tue Feb 14 12:17:04 MST 1995
C
C      Description:     
C
      subroutine nhlfisdataitem(id,istat)

        integer id,istat
        call nhlpfisdataitem(id,istat)
      end

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C   FFTPACK 5.0
C   Copyright (C) 1995-2004, Scientific Computing Division,
C   University Corporation for Atmospheric Research
C   Licensed under the GNU General Public License (GPL)
C
C   Authors:  Paul N. Swarztrauber and Richard A. Valent
C
C   $Id: cosqmi.f,v 1.2 2006-11-21 01:10:17 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      SUBROUTINE DCOSQMI(N,WSAVE,LENSAV,IER)
      DOUBLE PRECISION PIH
      DOUBLE PRECISION DT
      DOUBLE PRECISION FK
      INTEGER N,LENSAV,IER
      DOUBLE PRECISION WSAVE(LENSAV)
C
      IER = 0
C
      IF (LENSAV.LT.2*N+INT(LOG(DBLE(N)))+4) THEN
          IER = 2
          CALL DXERFFT('COSQMI',3)
          GO TO 300
      END IF
C
      PIH = 2.D0*ATAN(1.D0)
      DT = PIH/DBLE(N)
      FK = 0.D0
      DO 101 K = 1,N
          FK = FK + 1.D0
          WSAVE(K) = COS(FK*DT)
  101 CONTINUE
      LNSV = N + INT(LOG(DBLE(N))) + 4
      CALL DRFFTMI(N,WSAVE(N+1),LNSV,IER1)
      IF (IER1.NE.0) THEN
          IER = 20
          CALL DXERFFT('COSQMI',-5)
      END IF
  300 CONTINUE
      RETURN
      END

      PROGRAM FDLDASHC
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C INVOKE DEMO DRIVER
C
      CALL LINEEX (IWKID)
C
C     DEACTIVATE AND CLOSE WORKSTATION, CLOSE GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      STOP
      END
C
      SUBROUTINE LINEEX (IWKID)
C
C PURPOSE                To provide a simple demonstration of the
C                        different line drawing techniques.
C
C USAGE                  CALL LINEEX (IWKID)
C
C ARGUMENTS
C
C ON INPUT               IWKID
C                          Workstation id
C
C LANGUAGE               FORTRAN
C
C HISTORY                Written  by members of the
C                        Scientific Computing Division of NCAR,
C                        Boulder Colorado
C
C PORTABILITY            FORTRAN 77
C
C NOTE                   The call to GOPWK will have to be modified
C                        when using a non-NCAR GKS package.  The third
C                        argument must be the workstation type for WISS.
C
C
      CHARACTER STR*60
C
C  Data for the graphical objects.
C
      DATA    TWOPI/6.283185/
      DATA    X0P, Y0P, RP, NPTP/ 0.500, 0.5, 0.45 ,  16/
C
C Declare the constant for converting from degrees to radians.
C     
      DATA DTR / .017453292519943 /
C
C Establish the viewport and window.
C
      CALL SET(.01,.99,0.01,.99,0.,1.,0.,1.,1)
C
C Turn buffering off
C
      CALL SETUSV('PB',2)
C
C Set up a color table
C
C White background
C
      CALL GSCR (IWKID,0,1.,1.,1.)
C
C Black foreground
C
      CALL GSCR (IWKID,1,0.,0.,0.)
C
C Red
C
      CALL GSCR (IWKID,2,1.,0.,0.)
C
C Green
C
      CALL GSCR (IWKID,3,0.,1.,0.)
C
C Blue
C
      CALL GSCR (IWKID,4,0.,0.,1.)
C
C  Create a polygonal fan 
C
      DTHETA = TWOPI/NPTP
      DO 10 I=1,6
         ANG = DTHETA*REAL(I) + .19625
         XC = RP*COS(ANG)
         YC = RP*SIN(ANG)
C
C Set the line color
C 
         CALL GSPLCI (MOD(I,4)+1)
C
C Set line width 
C 
         CALL GSLWSC(2.) 

         IF (I .EQ. 1) THEN
C
C  Solid Line (the default)
C
            STR = '$$$$Solid$$$$$$$$$$$$$$$$$$$$$$$$$$$$$'
            CALL DASHDC(STR,20,20)
            CALL GSLN(1)
            CALL LINED(X0P,Y0P,X0P+XC,Y0P+YC)
         ELSEIF (I .EQ. 2) THEN
C
C Dashed line
C
            STR = '$$$$Dashed$$$$$$$$$$$$$$$$$$$$$$$$$$$$$'
            CALL DASHDC(STR,20,20)
            CALL GSLN(2)
            CALL LINED(X0P,Y0P,X0P+XC,Y0P+YC)
         ELSEIF (I .EQ. 3) THEN
C
C Dotted line
C
            STR = '$$$$Dotted$$$$$$$$$$$$$$$$$$$$$$$$$$$$$'
            CALL DASHDC(STR,20,20)
            CALL GSLN(3)
            CALL LINED(X0P,Y0P,X0P+XC,Y0P+YC)
         ELSEIF (I .EQ. 4) THEN
C
C Dashed dotted line
C
            STR = '$$$$Dotted''Dashed$$$$$$$$$$$$$$$$$$$$$$$$$$$$$'
            CALL DASHDC(STR,20,20)
            CALL GSLN(4)
            CALL LINED(X0P,Y0P,X0P+XC,Y0P+YC)
         ELSEIF (I .EQ. 5) THEN
C
C Don't do anything different here
C Color is changed at beginning of loop
C
            STR = '$$$$Color''Any$$$$$$$$$$$$$$$$$$$$$$$$$$$$$'
            CALL DASHDC(STR,20,20)
            CALL LINED(X0P,Y0P,X0P+XC,Y0P+YC)
         ELSEIF (I .EQ. 6) THEN
C
C Increase the line width 
C
            STR = '$$$$Width''Any$$$$$$$$$$$$$$$$$$$$$$$$$$$$$'
            CALL DASHDC(STR,20,20)
            CALL GSLWSC(10.) 
            CALL LINED(X0P,Y0P,X0P+XC,Y0P+YC)
         ELSEIF (I .EQ. 7) THEN
         ELSEIF (I .EQ. 8) THEN
         ENDIF
C
C Reset the line type to a thin black solid line
C
         CALL GSLN(1)
         CALL GSLWSC(2.) 
         CALL GSPLCI (1)
 10   CONTINUE
C
C Create and Plot 2 Sine Curves
C
C Set line width
C
      CALL GSLWSC(4.) 
C
C Set the dash pattern
C
      STR = '$''$Draw''Any''Curve$''$''$''$''$''$''$'''
      CALL DASHDC(STR,15,20)
C
C Move plotter pen
C
      CALL FRSTD(0.,.25)
C
C Compute the curve coordinates
C
      DO 20 I=1,360
         Y = (SIN(REAL(I)*(TWOPI/360.)) * .25) + .25
         CALL VECTD(REAL(I)/360.,Y)
 20   CONTINUE
C
C Set line width
C
      CALL GSLWSC(2.) 
C
C  Set the dash pattern
C
      STR = '$''$$''$$$''$$$$ Any''Pattern'
      CALL DASHDC(STR,20,20)
C
C Set the line color to green
C
      CALL GSPLCI (3)
C
C Move plotter pen
C
      CALL FRSTD(0.,.125)
C
C Compute the curve coordinates
C
      DO 30 I=1,360
         Y = (SIN(REAL(I)*(TWOPI/360.)) * .125) + .125
         CALL VECTD(REAL(I)/720.,Y)
 30   CONTINUE
C
C Create and plot a spiral curve
C
      CALL SET (.4,.9,.0,.55,-1.,1.,-1.,1.,1)
      STR = '$$$$$$$$$$$$$$$$$$$$$$$$$$Any''Shape'
      CALL DASHDC(STR,80,20)
C
C Move plotter pen
C
      RAD=.001
      XCD=.25+.5*RAD*COS(0.)
      YCD=.25+.5*RAD*SIN(0.)
      CALL FRSTD(XCD,YCD)
C
C Set the line color to red
C
      CALL GSPLCI (2)
      DO 40 ING=1,1500
         RAD=REAL(ING)/1000.
         ANG=DTR*REAL(ING-1)
         XCD=.25+.5*RAD*COS(ANG)
         YCD=.25+.5*RAD*SIN(ANG)
         CALL VECTD(XCD, YCD)
 40   CONTINUE
      CALL SET(0.,1.,0.,1.,0.,1.,0.,1.,1)
C
C Set the line color to black
C
      CALL GSPLCI (1)
C
C  Create a background perimeter 
C
      CALL FRSTPT( 0.0, 0.0)
      CALL VECTOR( 1.0, 0.0)
      CALL VECTOR( 1.0, 1.0)
      CALL VECTOR( 0.0, 1.0)
      CALL VECTOR( 0.0, 0.0)
C
C  Label the plot
C
C     CALL PLCHLQ(0.5,0.91,'',25.,0.,0.)
      CALL FRAME
C
      END

      PROGRAM TCOLCV

      CALL COLCV(IERR)
C
      STOP
      END
C
      SUBROUTINE COLCV (IERR)
C
C PURPOSE                To provide a demonstration of the routines in
C                        the package COLCONV and to test them.
C
C USAGE                  CALL COLCV (IERR)
C
C ARGUMENTS
C
C ON OUTPUT              IERR
C                          An integer variable
C                          = 0, if the test is successful,
C                          = 1, otherwise
C
C I/O                    If the test is successful, the message
C
C                        COLCONV TEST SUCCESSFUL
C
C                        is written on unit 6.
C
C                        Otherwise, the message
C
C                        COLCONV TEST SUCCESSFUL
C
C                        is written on unit 6.
C
C PRECISION              Single
C
C REQUIRED PACKAGES      COLCONV
C
C REQUIRED GKS LEVEL     NONE
C
C LANGUAGE               FORTRAN
C
C ALGORITHM              TCOLCV executes six calls to test each of
C                        the color conversions:
C
C                              HLS to RGB
C                              RGB to HLS
C                              HSV to RGB
C                              RGB to HSV
C                              YIQ to RGB
C                              RGB to YIQ
C
C ---------------------------------------------------------------------
C
C  Initialize the error flag.
C
      IERR = 0
C
C  Set tolerance limit for HLS and HSV tests.
C
      EPS = 0.00001
C
C  HLS to RGB.
C
      CALL HLSRGB(120.,50.,100.,R,G,B)
      IF ( (ABS(R-1.) .GT. EPS) .OR. (ABS(G) .GT. EPS) .OR.
     *     (ABS(B) .GT. EPS) ) IERR = 1
C
C  RGB to HLS.
C
      CALL RGBHLS(1.,0.,0.,H,FL,S)
      IF ( (ABS(H-120.) .GT. EPS) .OR. (ABS(FL-50.) .GT. EPS) .OR.
     *     (ABS(S-100.) .GT. EPS) ) IERR = 1
C
C  HSV to RGB.
C
      CALL HSVRGB(120.,1.,1.,R,G,B)
      IF ( (ABS(R-0.) .GT. EPS) .OR. (ABS(G-1.) .GT. EPS) .OR.
     *     (ABS(B-0.) .GT. EPS) ) IERR = 1
C
C  RGB to HSV.
C
      CALL RGBHSV(0.,0.,1.,H,S,V)
      IF ( (ABS(H-240.) .GT. EPS) .OR. (ABS(S-1.) .GT. EPS) .OR.
     *     (ABS(V-1.) .GT. EPS) ) IERR = 1
C
C  Set tolerance limit for YIQ tests.
C
      EPS = 0.01
C
C  YIQ to RGB.
C
      CALL YIQRGB(0.58701, -0.27431, -0.52299,R,G,B)
      IF ( (ABS(R-0.) .GT. EPS) .OR. (ABS(G-1.) .GT. EPS) .OR.
     *     (ABS(B-0.) .GT. EPS) ) IERR = 1
C
C  RGB to YIQ.
C
      CALL RGBYIQ(1.,1.,1.,Y,FI,Q)
      IF ( (ABS(Y-1.) .GT. EPS) .OR. (ABS(FI) .GT. EPS) .OR.
     *     (ABS(Q) .GT. EPS) ) IERR = 1
C
      IF (IERR .EQ. 0) THEN
        WRITE (6,1001)
      ELSE
        WRITE (6,1002)
      ENDIF
C
      RETURN
C
 1001 FORMAT (' COLCONV TEST SUCCESSFUL')
 1002 FORMAT (' COLCONV TEST UNSUCCESSFUL')
      END

C
C	$Id: fngbkd.f,v 1.5 2008-07-27 00:59:02 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE FNGBKD
C
C Calling this do-nothing subroutine forces "ld" to load the following
C block data routine (but only if they are in the same ".f" file).
C
        RETURN
C
      END
CNOSPLIT
      BLOCKDATA FNGBKDX
C
      PARAMETER ( NUM=71 , NUMA=468 )
      COMMON /SUBNMS/SUBNAM,ALLNAM
      CHARACTER*10 SUBNAM(NUM),ALLNAM(NUMA)
C
      DATA (SUBNAM(I),I=1,NUM)/
     -     'AXES'  ,'CONOP1','CONOP2','CONOP3','CONOP4',
     -     'CURVE' ,'CURVE3','CURVED','DASHLN','DASHD' ,
     -     'ENCODE','FENCE3','FL2INT','FLASH1','FLASH2','FLASH3',
     -     'FLASH4','FLUSH' ,'FLUSHB','FRAME' ,'FRST3' ,'FRSTD' ,
     -     'FRSTPT','GETCHR','GETCND','GETOPT','GETSET','GETSI' ,
     -     'INTT'  ,'JUSTFY','LINE'  ,'LINE3' ,'LINED' ,'LOC'   ,
     -     'MXMY'  ,'OPTION','OPTN'  ,'PACKUM','PERIM3','PERROR',
     -     'PLOTIT','POINT' ,'POINT3','POINTS','PORGN' ,'PREOUT',
     -     'PSCALE','PSYM'  ,'PSYM3' ,'PUT42' ,'PUTINS','PWRIT' ,
     -     'PWRITX','PWRITY','PWRM'  ,'PWRT'  ,'PWRX'  ,'PWRY'  ,
     -     'SET'   ,'SET3'  ,'SETCHR','SETCND','SETI'  ,'TICK3' ,
     -     'TICK43','TRANS' ,'ULIBER','VECT3' ,'VECTD' ,'VECTOR',
     -     'WRITEB'/
C
      DATA (ALLNAM(LL),LL=  1,108)  /
     -     'ADDCHR','AGAXIS','AGBACK','AGBNCH','AGCHAX','AGCHCU',
     -     'AGCHIL','AGCHNL','AGCTCS','AGCTKO','AGCURV','AGDASH',
     -     'AGDFLT','AGDLCH','AGDSHN','AGEXAX','AGEXUS','AGEZSU',
     -     'AGFPBN','AGFTOL','AGGETC','AGGETF','AGGETI','AGGETP',
     -     'AGGTCH','AGINIT','AGKURV','AGLBLS','AGMAXI','AGMINI',
     -     'AGNUMB','AGPPID','AGPWRT','AGQURV','AGRPCH','AGRSTR',
     -     'AGSAVE','AGSCAN','AGSETC','AGSETF','AGSETI','AGSETP',
     -     'AGSRCH','AGSTCH','AGSTUP','AGUTOL','ANOTAT','ARINT' ,
     -     'AXES'  ,'BD1'   ,'BD2'   ,'BLANK' ,'BOUND' ,'BUFF'  ,
     -     'C2W'   ,'CA2B'  ,'CALCNT','CARDIN','CCHECK','CCON'  ,
     -     'CERMSG','CFVLD' ,'CH8'   ,'CHKCYC','CLGEN' ,'CLSET' ,
     -     'CMP2'  ,'COMBIN','CONBDN','CONBND','CONCAL','CONCLD',
     -     'CONCLS','CONCOM','CONDET','CONDRW','CONDSD','CONECD',
     -     'CONGEN','CONINT','CONLCM','CONLIN','CONLOC','CONLOD',
     -     'CONOP1','CONOP2','CONOP3','CONOP4','CONOT2','CONOUT',
     -     'CONPDV','CONPMM','CONPMS','CONRAN','CONRAQ','CONRAS',
     -     'CONREC','CONREO','CONSET','CONSLD','CONSSD','CONSTP',
     -     'CONSWV','CONTLK','CONTNG','CONTOR','CONXCH','COPY'   /
      DATA (ALLNAM(LL),LL=109,216)  /
     -     'CREB15','CREBIN','CTCELL','CTRINT','CURVE' ,'CURVE3',
     -     'CURVED','CURVEW','CUTUP' ,'DANDR' ,'DASHBD','DASHD' ,
     -     'DASHLN','DASHMC','DAT1'  ,'DAT2'  ,'DAT3'  ,'DAT4'  ,
     -     'DAT5'  ,'DAT6'  ,'DAT7'  ,'DAT8'  ,'DCHECK','DCON'  ,
     -     'DGMOD' ,'DISPLA','DOTEDG','DPORT' ,'DRAWI' ,'DRAWMC',
     -     'DRAWPV','DRAWS' ,'DRAWT' ,'DRCNTR','CRDRLN','DRWBRB',
     -     'DRWSTR','DRWVEC','DTOA'  ,'E9RIN' ,'ENCD'  ,'ENCODE',
     -     'ENTSR' ,'EPRIN' ,'ERROF' ,'ETOA'  ,'EXPAND','EZBARB',
     -     'EZCNTR','EZHFTN','EZISOS','EZMXY' ,'EZMY'  ,'EZSRFC',
     -     'EZSTRM','EZVEC' ,'EZXY'  ,'EZY'   ,'FDUM'  ,'FDVDLD',
     -     'FENCE3','FILL'  ,'FILLBD','FILLCK','FILLIN','FILLNC',
     -     'FILLOP','FILLPA','FL2INT','FLASH1','FLASH2','FLASH3',
     -     'FLASH4','FLMHDR','FLSALL','FLSH'  ,'FLUSH' ,'FLUSHB',
     -     'FRADV' ,'FRAME' ,'FRST3' ,'FRSTC' ,'FRSTD' ,'FRSTPT',
     -     'FRSTS' ,'FRSTW' ,'FTOI'  ,'G16UPK','GAP'   ,'GASCCH',
     -     'GENCHR','GET16' ,'GETCHR','GETCND','GETDAT','GETFLT',
     -     'GETHOL','GETINT','GETOPT','GETRNG','GETSET','GETSI' ,
     -     'GETTYP','GNEWPT','GRAY'  ,'GRDINT','GRID'  ,'GRIDAL' /
      DATA (ALLNAM(LL),LL=217,324)  /
     -     'GRIDL' ,'GTCH'  ,'GTNUM' ,'GTNUMB','HAFTON','HALFAX',
     -     'HEADER','HFINIT','HILO'  ,'I8SAV' ,'IDICTL','IDIOT' ,
     -     'IMPCHK','INIT3D','INITZI','INITZS','INITZT','INSTP' ,
     -     'INTERT','INTT'  ,'ISOSRB','ISOSRF','JLM2'  ,'JUSTFY',
     -     'KURV1S','KURV2S','LABEL' ,'LABMOD','LASTD' ,'LGFILE',
     -     'LINE'  ,'LINE3' ,'LINE3W','LINEAR','LINED' ,'LINEW' ,
     -     'LOC'   ,'MAPBD' ,'MAPCEM','MAPCHI','MAPDRW','MAPEOS',
     -     'MAPFST','MAPGRD','MAPGTC','MAPGTI','MAPGTL','MAPGTR',
     -     'MAPINT','MAPIO' ,'MAPIQ' ,'MAPIT' ,'MAPLBL','MAPLMB',
     -     'MAPLOT','MAPPOS','MAPROJ','MAPRS' ,'MAPRST','MAPSAV',
     -     'MAPSET','MAPSTC','MAPSTI','MAPSTL','MAPSTR','MAPTRE',
     -     'MAPTRN','MAPTRP','MAPUSR','MAPVEC','MAPVP' ,'MARKL' ,
     -     'MAXMIN','MCSCAL','MCTR'  ,'MCTRAN','MCTRHX','MFCLOS',
     -     'MFCMDL','MFCPFR','MFED'  ,'MFEWT' ,'MFFSTF','MFGATH',
     -     'MFGETD','MFINIT','MFNREC','MFOPEN','MFPAR1','MFPAR2',
     -     'MFPAR4','MFPAR5','MFPAR6','MFPAR7','MFPARS','MFPERR',
     -     'MFREAD','MFRMBL','MFSORT','MFTYPE','MFWRIT','MINMAX',
     -     'MKMSK' ,'MMASK' ,'MOVCHR','MTITLE','MXMY'  ,'MXMYW'  /
      DATA (ALLNAM(LL),LL=325,432)  /
     -     'NAMEFR','NERRO' ,'NEWPEN','NUFRAM','OPTION','OPTN'  ,
     -     'OPTN2' ,'OUTZRO','PACKUM','PASS2' ,'PCRBIN','PERIM' ,
     -     'PERIM3','PERIML','PERROR','PLOT'  ,'PLOTIT','PLOTIW',
     -     'PLOTMC','PLOTS' ,'PLTGRD','PNUM'  ,'POINT' ,'POINT3',
     -     'POINTS','POINTW','PORGN' ,'POSITN','PRCARG','PREFIX',
     -     'PREOUT','PREP'  ,'PRGO'  ,'PRINT' ,'PRSET' ,'PRSIMX',
     -     'PRTOD' ,'PSCALE','PSTART','PSYM'  ,'PSYM3' ,'PUT42' ,
     -     'PUTINS','PWRIQ' ,'PWRIT' ,'PWRITV','PWRITW','PWRITX',
     -     'PWRITY','PWRM'  ,'PWRT'  ,'PWRX'  ,'PWRXBD','PWRY'  ,
     -     'PWRYBD','PWRYGT','PWRYMC','PWRYSO','PWRYW' ,'PWRZ'  ,
     -     'PWRZGI','PWRZGS','PWRZGT','PWRZI' ,'PWRZOI','PWRZOS',
     -     'PWRZOT','PWRZS' ,'PWRZT' ,'PWWBKD','PWWGET','PWWSOR',
     -     'QUICK' ,'RDAMRC','RDLINE','RDSYS' ,'RDWT'  ,'REMOVE',
     -     'REORD' ,'RESET' ,'RETSR' ,'RITE'  ,'SCALEB','SCAN'  ,
     -     'SCPLTW','SCPWTW','SCRLBD','SCROLL','SET'   ,'SET3'  ,
     -     'SET3D' ,'SETCHR','SETCND','SETER' ,'SETI'  ,'SETR'  ,
     -     'SETUM' ,'SETW'  ,'SKFILE','SKIP'  ,'SPACE' ,'SPLINT',
     -     'SRFABD','SRFACE','STCNTR','STLINE','STRMLN','SUPCON' /
      DATA (ALLNAM(LL),LL=433,468)  /
     -     'SUPMAP','T20'   ,'T268'  ,'T400'  ,'TERM'  ,'TEXT'  ,
     -     'THREBD','TICK3' ,'TICK4' ,'TICK43','TICKS' ,'TPGPHC',
     -     'TR32'  ,'TRANS' ,'TRIDIP','TRN32I','TRN32S','TRN32T',
     -     'UERRBD','ULIBER','UNHEX' ,'VECT3' ,'VECTD' ,'VECTOR',
     -     'VECTW' ,'VELDAT','VELVCT','VELVEC','VMAP'  ,'W2C'   ,
     -     'WINSYS','WNDBRB','WNDOUT','WRITEB','XTCH'  ,'XTCHDT' /
      END

C
C	$Id: reset.f,v 1.4 2008-07-27 00:16:58 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE RESET
C
C  USER ENTRY POINT
C  USED IN DASHCHAR AND DASHSMTH FOR COMPATIBILITY WITH CONREC AND
C  AUTOGRAPH WHICH ALSO USE DASHSUPR.  THUS SUBROUTINE PERFORMS NO
C  FUNCTION.
C
C-----------------------------------------------------------------------
C
C REVISION HISTORY--
C
C MAY 1984         CONVERTED TO FORTRAN 77 AND GKS.  CHANGED ENTRY
C                  DASHD TO DASHDB AND DASHDC.  DISALLOWED REAL
C                  ISIZE ARGUMENTS.
C
C DECEMBER 1979    ADDED A LIBRARY STATISTICS CALL AND A REVISION
C                  HISTORY
C
C JUNE 1988        CHANGED THE NAME OF A COMMON BLOCK TO GET RID OF A
C                  WARNING FROM SEGLDR.  (DJK)
C
C-----------------------------------------------------------------------
      END

      SUBROUTINE DLAEIN( RIGHTV, NOINIT, N, H, LDH, WR, WI, VR, VI, B,
     $                   LDB, WORK, EPS3, SMLNUM, BIGNUM, INFO )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      LOGICAL            NOINIT, RIGHTV
      INTEGER            INFO, LDB, LDH, N
      DOUBLE PRECISION   BIGNUM, EPS3, SMLNUM, WI, WR
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   B( LDB, * ), H( LDH, * ), VI( * ), VR( * ),
     $                   WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  DLAEIN uses inverse iteration to find a right or left eigenvector
*  corresponding to the eigenvalue (WR,WI) of a real upper Hessenberg
*  matrix H.
*
*  Arguments
*  =========
*
*  RIGHTV   (input) LOGICAL
*          = .TRUE. : compute right eigenvector;
*          = .FALSE.: compute left eigenvector.
*
*  NOINIT   (input) LOGICAL
*          = .TRUE. : no initial vector supplied in (VR,VI).
*          = .FALSE.: initial vector supplied in (VR,VI).
*
*  N       (input) INTEGER
*          The order of the matrix H.  N >= 0.
*
*  H       (input) DOUBLE PRECISION array, dimension (LDH,N)
*          The upper Hessenberg matrix H.
*
*  LDH     (input) INTEGER
*          The leading dimension of the array H.  LDH >= max(1,N).
*
*  WR      (input) DOUBLE PRECISION
*  WI      (input) DOUBLE PRECISION
*          The real and imaginary parts of the eigenvalue of H whose
*          corresponding right or left eigenvector is to be computed.
*
*  VR      (input/output) DOUBLE PRECISION array, dimension (N)
*  VI      (input/output) DOUBLE PRECISION array, dimension (N)
*          On entry, if NOINIT = .FALSE. and WI = 0.0, VR must contain
*          a real starting vector for inverse iteration using the real
*          eigenvalue WR; if NOINIT = .FALSE. and WI.ne.0.0, VR and VI
*          must contain the real and imaginary parts of a complex
*          starting vector for inverse iteration using the complex
*          eigenvalue (WR,WI); otherwise VR and VI need not be set.
*          On exit, if WI = 0.0 (real eigenvalue), VR contains the
*          computed real eigenvector; if WI.ne.0.0 (complex eigenvalue),
*          VR and VI contain the real and imaginary parts of the
*          computed complex eigenvector. The eigenvector is normalized
*          so that the component of largest magnitude has magnitude 1;
*          here the magnitude of a complex number (x,y) is taken to be
*          |x| + |y|.
*          VI is not referenced if WI = 0.0.
*
*  B       (workspace) DOUBLE PRECISION array, dimension (LDB,N)
*
*  LDB     (input) INTEGER
*          The leading dimension of the array B.  LDB >= N+1.
*
*  WORK   (workspace) DOUBLE PRECISION array, dimension (N)
*
*  EPS3    (input) DOUBLE PRECISION
*          A small machine-dependent value which is used to perturb
*          close eigenvalues, and to replace zero pivots.
*
*  SMLNUM  (input) DOUBLE PRECISION
*          A machine-dependent value close to the underflow threshold.
*
*  BIGNUM  (input) DOUBLE PRECISION
*          A machine-dependent value close to the overflow threshold.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          = 1:  inverse iteration did not converge; VR is set to the
*                last iterate, and so is VI if WI.ne.0.0.
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO, ONE, TENTH
      PARAMETER          ( ZERO = 0.0D+0, ONE = 1.0D+0, TENTH = 1.0D-1 )
*     ..
*     .. Local Scalars ..
      CHARACTER          NORMIN, TRANS
      INTEGER            I, I1, I2, I3, IERR, ITS, J
      DOUBLE PRECISION   ABSBII, ABSBJJ, EI, EJ, GROWTO, NORM, NRMSML,
     $                   REC, ROOTN, SCALE, TEMP, VCRIT, VMAX, VNORM, W,
     $                   W1, X, XI, XR, Y
*     ..
*     .. External Functions ..
      INTEGER            IDAMAX
      DOUBLE PRECISION   DASUM, DLAPY2, DNRM2
      EXTERNAL           IDAMAX, DASUM, DLAPY2, DNRM2
*     ..
*     .. External Subroutines ..
      EXTERNAL           DLADIV, DLATRS, DSCAL
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, DBLE, MAX, SQRT
*     ..
*     .. Executable Statements ..
*
      INFO = 0
*
*     GROWTO is the threshold used in the acceptance test for an
*     eigenvector.
*
      ROOTN = SQRT( DBLE( N ) )
      GROWTO = TENTH / ROOTN
      NRMSML = MAX( ONE, EPS3*ROOTN )*SMLNUM
*
*     Form B = H - (WR,WI)*I (except that the subdiagonal elements and
*     the imaginary parts of the diagonal elements are not stored).
*
      DO 20 J = 1, N
         DO 10 I = 1, J - 1
            B( I, J ) = H( I, J )
   10    CONTINUE
         B( J, J ) = H( J, J ) - WR
   20 CONTINUE
*
      IF( WI.EQ.ZERO ) THEN
*
*        Real eigenvalue.
*
         IF( NOINIT ) THEN
*
*           Set initial vector.
*
            DO 30 I = 1, N
               VR( I ) = EPS3
   30       CONTINUE
         ELSE
*
*           Scale supplied initial vector.
*
            VNORM = DNRM2( N, VR, 1 )
            CALL DSCAL( N, ( EPS3*ROOTN ) / MAX( VNORM, NRMSML ), VR,
     $                  1 )
         END IF
*
         IF( RIGHTV ) THEN
*
*           LU decomposition with partial pivoting of B, replacing zero
*           pivots by EPS3.
*
            DO 60 I = 1, N - 1
               EI = H( I+1, I )
               IF( ABS( B( I, I ) ).LT.ABS( EI ) ) THEN
*
*                 Interchange rows and eliminate.
*
                  X = B( I, I ) / EI
                  B( I, I ) = EI
                  DO 40 J = I + 1, N
                     TEMP = B( I+1, J )
                     B( I+1, J ) = B( I, J ) - X*TEMP
                     B( I, J ) = TEMP
   40             CONTINUE
               ELSE
*
*                 Eliminate without interchange.
*
                  IF( B( I, I ).EQ.ZERO )
     $               B( I, I ) = EPS3
                  X = EI / B( I, I )
                  IF( X.NE.ZERO ) THEN
                     DO 50 J = I + 1, N
                        B( I+1, J ) = B( I+1, J ) - X*B( I, J )
   50                CONTINUE
                  END IF
               END IF
   60       CONTINUE
            IF( B( N, N ).EQ.ZERO )
     $         B( N, N ) = EPS3
*
            TRANS = 'N'
*
         ELSE
*
*           UL decomposition with partial pivoting of B, replacing zero
*           pivots by EPS3.
*
            DO 90 J = N, 2, -1
               EJ = H( J, J-1 )
               IF( ABS( B( J, J ) ).LT.ABS( EJ ) ) THEN
*
*                 Interchange columns and eliminate.
*
                  X = B( J, J ) / EJ
                  B( J, J ) = EJ
                  DO 70 I = 1, J - 1
                     TEMP = B( I, J-1 )
                     B( I, J-1 ) = B( I, J ) - X*TEMP
                     B( I, J ) = TEMP
   70             CONTINUE
               ELSE
*
*                 Eliminate without interchange.
*
                  IF( B( J, J ).EQ.ZERO )
     $               B( J, J ) = EPS3
                  X = EJ / B( J, J )
                  IF( X.NE.ZERO ) THEN
                     DO 80 I = 1, J - 1
                        B( I, J-1 ) = B( I, J-1 ) - X*B( I, J )
   80                CONTINUE
                  END IF
               END IF
   90       CONTINUE
            IF( B( 1, 1 ).EQ.ZERO )
     $         B( 1, 1 ) = EPS3
*
            TRANS = 'T'
*
         END IF
*
         NORMIN = 'N'
         DO 110 ITS = 1, N
*
*           Solve U*x = scale*v for a right eigenvector
*             or U'*x = scale*v for a left eigenvector,
*           overwriting x on v.
*
            CALL DLATRS( 'Upper', TRANS, 'Nonunit', NORMIN, N, B, LDB,
     $                   VR, SCALE, WORK, IERR )
            NORMIN = 'Y'
*
*           Test for sufficient growth in the norm of v.
*
            VNORM = DASUM( N, VR, 1 )
            IF( VNORM.GE.GROWTO*SCALE )
     $         GO TO 120
*
*           Choose new orthogonal starting vector and try again.
*
            TEMP = EPS3 / ( ROOTN+ONE )
            VR( 1 ) = EPS3
            DO 100 I = 2, N
               VR( I ) = TEMP
  100       CONTINUE
            VR( N-ITS+1 ) = VR( N-ITS+1 ) - EPS3*ROOTN
  110    CONTINUE
*
*        Failure to find eigenvector in N iterations.
*
         INFO = 1
*
  120    CONTINUE
*
*        Normalize eigenvector.
*
         I = IDAMAX( N, VR, 1 )
         CALL DSCAL( N, ONE / ABS( VR( I ) ), VR, 1 )
      ELSE
*
*        Complex eigenvalue.
*
         IF( NOINIT ) THEN
*
*           Set initial vector.
*
            DO 130 I = 1, N
               VR( I ) = EPS3
               VI( I ) = ZERO
  130       CONTINUE
         ELSE
*
*           Scale supplied initial vector.
*
            NORM = DLAPY2( DNRM2( N, VR, 1 ), DNRM2( N, VI, 1 ) )
            REC = ( EPS3*ROOTN ) / MAX( NORM, NRMSML )
            CALL DSCAL( N, REC, VR, 1 )
            CALL DSCAL( N, REC, VI, 1 )
         END IF
*
         IF( RIGHTV ) THEN
*
*           LU decomposition with partial pivoting of B, replacing zero
*           pivots by EPS3.
*
*           The imaginary part of the (i,j)-th element of U is stored in
*           B(j+1,i).
*
            B( 2, 1 ) = -WI
            DO 140 I = 2, N
               B( I+1, 1 ) = ZERO
  140       CONTINUE
*
            DO 170 I = 1, N - 1
               ABSBII = DLAPY2( B( I, I ), B( I+1, I ) )
               EI = H( I+1, I )
               IF( ABSBII.LT.ABS( EI ) ) THEN
*
*                 Interchange rows and eliminate.
*
                  XR = B( I, I ) / EI
                  XI = B( I+1, I ) / EI
                  B( I, I ) = EI
                  B( I+1, I ) = ZERO
                  DO 150 J = I + 1, N
                     TEMP = B( I+1, J )
                     B( I+1, J ) = B( I, J ) - XR*TEMP
                     B( J+1, I+1 ) = B( J+1, I ) - XI*TEMP
                     B( I, J ) = TEMP
                     B( J+1, I ) = ZERO
  150             CONTINUE
                  B( I+2, I ) = -WI
                  B( I+1, I+1 ) = B( I+1, I+1 ) - XI*WI
                  B( I+2, I+1 ) = B( I+2, I+1 ) + XR*WI
               ELSE
*
*                 Eliminate without interchanging rows.
*
                  IF( ABSBII.EQ.ZERO ) THEN
                     B( I, I ) = EPS3
                     B( I+1, I ) = ZERO
                     ABSBII = EPS3
                  END IF
                  EI = ( EI / ABSBII ) / ABSBII
                  XR = B( I, I )*EI
                  XI = -B( I+1, I )*EI
                  DO 160 J = I + 1, N
                     B( I+1, J ) = B( I+1, J ) - XR*B( I, J ) +
     $                             XI*B( J+1, I )
                     B( J+1, I+1 ) = -XR*B( J+1, I ) - XI*B( I, J )
  160             CONTINUE
                  B( I+2, I+1 ) = B( I+2, I+1 ) - WI
               END IF
*
*              Compute 1-norm of offdiagonal elements of i-th row.
*
               WORK( I ) = DASUM( N-I, B( I, I+1 ), LDB ) +
     $                     DASUM( N-I, B( I+2, I ), 1 )
  170       CONTINUE
            IF( B( N, N ).EQ.ZERO .AND. B( N+1, N ).EQ.ZERO )
     $         B( N, N ) = EPS3
            WORK( N ) = ZERO
*
            I1 = N
            I2 = 1
            I3 = -1
         ELSE
*
*           UL decomposition with partial pivoting of conjg(B),
*           replacing zero pivots by EPS3.
*
*           The imaginary part of the (i,j)-th element of U is stored in
*           B(j+1,i).
*
            B( N+1, N ) = WI
            DO 180 J = 1, N - 1
               B( N+1, J ) = ZERO
  180       CONTINUE
*
            DO 210 J = N, 2, -1
               EJ = H( J, J-1 )
               ABSBJJ = DLAPY2( B( J, J ), B( J+1, J ) )
               IF( ABSBJJ.LT.ABS( EJ ) ) THEN
*
*                 Interchange columns and eliminate
*
                  XR = B( J, J ) / EJ
                  XI = B( J+1, J ) / EJ
                  B( J, J ) = EJ
                  B( J+1, J ) = ZERO
                  DO 190 I = 1, J - 1
                     TEMP = B( I, J-1 )
                     B( I, J-1 ) = B( I, J ) - XR*TEMP
                     B( J, I ) = B( J+1, I ) - XI*TEMP
                     B( I, J ) = TEMP
                     B( J+1, I ) = ZERO
  190             CONTINUE
                  B( J+1, J-1 ) = WI
                  B( J-1, J-1 ) = B( J-1, J-1 ) + XI*WI
                  B( J, J-1 ) = B( J, J-1 ) - XR*WI
               ELSE
*
*                 Eliminate without interchange.
*
                  IF( ABSBJJ.EQ.ZERO ) THEN
                     B( J, J ) = EPS3
                     B( J+1, J ) = ZERO
                     ABSBJJ = EPS3
                  END IF
                  EJ = ( EJ / ABSBJJ ) / ABSBJJ
                  XR = B( J, J )*EJ
                  XI = -B( J+1, J )*EJ
                  DO 200 I = 1, J - 1
                     B( I, J-1 ) = B( I, J-1 ) - XR*B( I, J ) +
     $                             XI*B( J+1, I )
                     B( J, I ) = -XR*B( J+1, I ) - XI*B( I, J )
  200             CONTINUE
                  B( J, J-1 ) = B( J, J-1 ) + WI
               END IF
*
*              Compute 1-norm of offdiagonal elements of j-th column.
*
               WORK( J ) = DASUM( J-1, B( 1, J ), 1 ) +
     $                     DASUM( J-1, B( J+1, 1 ), LDB )
  210       CONTINUE
            IF( B( 1, 1 ).EQ.ZERO .AND. B( 2, 1 ).EQ.ZERO )
     $         B( 1, 1 ) = EPS3
            WORK( 1 ) = ZERO
*
            I1 = 1
            I2 = N
            I3 = 1
         END IF
*
         DO 270 ITS = 1, N
            SCALE = ONE
            VMAX = ONE
            VCRIT = BIGNUM
*
*           Solve U*(xr,xi) = scale*(vr,vi) for a right eigenvector,
*             or U'*(xr,xi) = scale*(vr,vi) for a left eigenvector,
*           overwriting (xr,xi) on (vr,vi).
*
            DO 250 I = I1, I2, I3
*
               IF( WORK( I ).GT.VCRIT ) THEN
                  REC = ONE / VMAX
                  CALL DSCAL( N, REC, VR, 1 )
                  CALL DSCAL( N, REC, VI, 1 )
                  SCALE = SCALE*REC
                  VMAX = ONE
                  VCRIT = BIGNUM
               END IF
*
               XR = VR( I )
               XI = VI( I )
               IF( RIGHTV ) THEN
                  DO 220 J = I + 1, N
                     XR = XR - B( I, J )*VR( J ) + B( J+1, I )*VI( J )
                     XI = XI - B( I, J )*VI( J ) - B( J+1, I )*VR( J )
  220             CONTINUE
               ELSE
                  DO 230 J = 1, I - 1
                     XR = XR - B( J, I )*VR( J ) + B( I+1, J )*VI( J )
                     XI = XI - B( J, I )*VI( J ) - B( I+1, J )*VR( J )
  230             CONTINUE
               END IF
*
               W = ABS( B( I, I ) ) + ABS( B( I+1, I ) )
               IF( W.GT.SMLNUM ) THEN
                  IF( W.LT.ONE ) THEN
                     W1 = ABS( XR ) + ABS( XI )
                     IF( W1.GT.W*BIGNUM ) THEN
                        REC = ONE / W1
                        CALL DSCAL( N, REC, VR, 1 )
                        CALL DSCAL( N, REC, VI, 1 )
                        XR = VR( I )
                        XI = VI( I )
                        SCALE = SCALE*REC
                        VMAX = VMAX*REC
                     END IF
                  END IF
*
*                 Divide by diagonal element of B.
*
                  CALL DLADIV( XR, XI, B( I, I ), B( I+1, I ), VR( I ),
     $                         VI( I ) )
                  VMAX = MAX( ABS( VR( I ) )+ABS( VI( I ) ), VMAX )
                  VCRIT = BIGNUM / VMAX
               ELSE
                  DO 240 J = 1, N
                     VR( J ) = ZERO
                     VI( J ) = ZERO
  240             CONTINUE
                  VR( I ) = ONE
                  VI( I ) = ONE
                  SCALE = ZERO
                  VMAX = ONE
                  VCRIT = BIGNUM
               END IF
  250       CONTINUE
*
*           Test for sufficient growth in the norm of (VR,VI).
*
            VNORM = DASUM( N, VR, 1 ) + DASUM( N, VI, 1 )
            IF( VNORM.GE.GROWTO*SCALE )
     $         GO TO 280
*
*           Choose a new orthogonal starting vector and try again.
*
            Y = EPS3 / ( ROOTN+ONE )
            VR( 1 ) = EPS3
            VI( 1 ) = ZERO
*
            DO 260 I = 2, N
               VR( I ) = Y
               VI( I ) = ZERO
  260       CONTINUE
            VR( N-ITS+1 ) = VR( N-ITS+1 ) - EPS3*ROOTN
  270    CONTINUE
*
*        Failure to find eigenvector in N iterations
*
         INFO = 1
*
  280    CONTINUE
*
*        Normalize eigenvector.
*
         VNORM = ZERO
         DO 290 I = 1, N
            VNORM = MAX( VNORM, ABS( VR( I ) )+ABS( VI( I ) ) )
  290    CONTINUE
         CALL DSCAL( N, ONE / VNORM, VR, 1 )
         CALL DSCAL( N, ONE / VNORM, VI, 1 )
*
      END IF
*
      RETURN
*
*     End of DLAEIN
*
      END

C
C $Id: mapdrw.f,v 1.22 2008-09-18 00:42:16 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MAPDRW
        IF (ICFELL('MAPDRW - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
        CALL MDPDRW
        IF (ICFELL('MAPDRW',2).NE.0) RETURN
        RETURN
      END

C
C $Id: agdlch.f,v 1.6 2008-07-27 00:14:34 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE AGDLCH (IDCS)
C
C This routine deletes character strings previously stored by the
C routine AGSTCH (which see).  It has the following argument:
C
C -- IDCS is the identifying integer returned by AGSTCH when the string
C    was stored.
C
C The following common blocks contain variables which are required for
C the character-storage-and-retrieval scheme of AUTOGRAPH.
C
      COMMON /AGCHR1/ LNIC,INCH(2,50),LNCA,INCA
      SAVE /AGCHR1/
C
      COMMON /AGCHR2/ CHRA(2000)
      CHARACTER*1 CHRA
      SAVE /AGCHR2/
C
C Only if the identifier is between -LNIC and -1, inclusive, was the
C string ever stored, so that it needs to be deleted.  If the string is
C the last one in CHRA, we can just set INCA to point to the position
C preceding it; otherwise, we zero out the string but don't bother to
C collapse CHRA, which will happen in AGSTCH when the space is needed
C again.  In either case, the index entry in INCH is zeroed.
C
      IF (IDCS.GE.(-LNIC).AND.IDCS.LE.(-1)) THEN
        I=-IDCS
        J=INCH(1,I)
        IF (J.GT.0) THEN
          K=J+INCH(2,I)-1
          IF (K.EQ.INCA) THEN
            INCA=J-1
          ELSE
            DO 101 L=J,K
              CHRA(L)=CHAR(0)
  101       CONTINUE
          END IF
          INCH(1,I)=0
        END IF
      END IF
C
C Done.
C
      RETURN
C
      END

      PROGRAM TDASHP
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C OPEN GKS, OPEN WORKSTATION OF TYPE 1, ACTIVATE WORKSTATION
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C INVOKE DEMO DRIVER
C
      CALL DASHP(IERR)
C
C DEACTIVATE AND CLOSE WORKSTATION, CLOSE GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END
C
      SUBROUTINE DASHP (IERROR)
C
C PURPOSE                To provide a simple demonstration of DASHSUPR
C
C USAGE                  CALL DASHP (IERROR)
C
C ARGUMENTS
C
C ON OUTPUT              IERROR
C                          An integer variable
C                          = 0, if the test was successful,
C                          = 1, otherwise
C
C I/O                    If the test is successful, the message
C
C               DASHSUPR TEST EXECUTED--SEE PLOT TO CERTIFY
C
C                        is printed on unit 6.  In addition, 1
C                        frame is produced on the machine graphics
C                        device.  In order to determine if the test
C                        was successful, it is necessary to examine
C                        the plot.
C
C PRECISION              Single
C
C REQUIRED ROUTINES      DASHSUPR
C
C REQUIRED GKS LEVEL     0A
C
C LANGUAGE               FORTRAN 77
C
C ALGORITHM              TDASHP utilizes the software DASHSUPR
C                        routines DASHDB, DASHDC, FRSTD, VECTD,
C                        LINED, and CURVED to draw 5 curves on 1
C                        picture using 5 different DASHSUPR patterns.
C                        Each curve is centered about solid axis
C                        lines and labelled with the binary
C                        representation of the DASHSUPR pattern used.
C
C X contains the abscissae and Y the ordinates of the curve to be plotted.
C
      DIMENSION       X(31)      ,Y(31)
C
C Select normalization transformation 0.
C
      CALL GSELNT(0)
C
C RESET initializes the model picture array.  It should be called with
C each new frame.  The call should occur before a call to any other
C DASHSUPR routine.
C
      CALL RESET
C
C
C Set a solid dash pattern,  1111111111111111 (BINARY).
C Boolean operations (using locally-implemented support
C routines) are used to support porting to hosts with 16
C bit integers.
C
      ISOLID = IOR (ISHIFT (32767,1), 1)
C
      DO 130 K=1,5
         CALL DASHDB (ISOLID)
         ORG =1.07-0.195*K
C
C Draw the central axis for each curve.
C
         CALL FRSTD (.50,ORG-0.03)
         CALL VECTD (.50,ORG+0.03)
         CALL LASTD
         CALL LINED (.109,ORG,.891,ORG)
C
C Call DASHDC with a different dashed line and character combination
C for each of 5 different curves.
C
         GO TO ( 10, 20, 30, 40, 50),K
   10    CALL DASHDC ('$''$''$''$''$''$''$''$K = 1',10,12)
         GO TO  60
   20    CALL DASHDC ('$$$$$$''$''$$$$$$K = 2',10,12)
         GO TO  60
   30    CALL DASHDC ('$$$$''$$$$''$$$$''K = 3',10,12)
         GO TO  60
   40    CALL DASHDC ('$$$$$''''''''''$$$$$K = 4',10,12)
         GO TO  60
   50    CALL DASHDC ('$$$''$$$''$$$''$$$K = 5',10,12)
   60    CONTINUE
C
C Compute the curve coordinates and draw the curve.
C
         DO  70 I=1,31
            THETA = REAL(I-1)*3.1415926535897932/15.
            X(I) = 0.5+.4*COS(THETA)
            Y(I) = ORG+.075*SIN(REAL(K)*THETA)
   70    CONTINUE
         CALL CURVED (X,Y,31)
C
C Label the curves with the character representation of the appropriate
C DASHSUPR pattern.  In the pattern labels, A and D should be interpreted
C as the apostrophe and dollar sign.
C
C Locate the string at the left end, but vertically centered.
C
        CALL GSTXAL(1,3)
C
C       SET CHARACTER HEIGHT
C
         CALL GSCHH(.012)
C
         ORY = ORG+.089
         GO TO ( 80, 90,100,110,120),K
   80    CALL GTX(.1,ORY,'IPAT=DADADADADADADADK=1')
         GO TO 130
   90    CALL GTX(.1,ORY,'IPAT=DDDDDDADADDDDDDK=2')
         GO TO 130
  100    CALL GTX(.1,ORY,'IPAT=DDDDADDDDADDDDAK=3')
         GO TO 130
  110    CALL GTX(.1,ORY,'IPAT=DDDDDAAAAADDDDDK=4')
         GO TO 130
  120    CALL GTX(.1,ORY,'IPAT=DDDADDDADDDADDDK=5')
C
  130 CONTINUE
C
      CALL GSTXAL(2,3)
      CALL GTX (.5,.985,'DEMONSTRATION PLOT FOR DASHSUPR')
      CALL GTX (.5,.013,'IN IPAT STRINGS, A AND D SHOULD BE INTERPRETED
     1AS APOSTROPHE AND DOLLAR SIGN')
      CALL FRAME
C
      IERROR = 0
      WRITE (6,1001)
C
      RETURN
C
 1001 FORMAT (' DASHSUPR TEST EXECUTED--SEE PLOT TO CERTIFY')
C
      END

      SUBROUTINE CPBTRS( UPLO, N, KD, NRHS, AB, LDAB, B, LDB, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER          UPLO
      INTEGER            INFO, KD, LDAB, LDB, N, NRHS
*     ..
*     .. Array Arguments ..
      COMPLEX            AB( LDAB, * ), B( LDB, * )
*     ..
*
*  Purpose
*  =======
*
*  CPBTRS solves a system of linear equations A*X = B with a Hermitian
*  positive definite band matrix A using the Cholesky factorization
*  A = U**H*U or A = L*L**H computed by CPBTRF.
*
*  Arguments
*  =========
*
*  UPLO    (input) CHARACTER*1
*          = 'U':  Upper triangular factor stored in AB;
*          = 'L':  Lower triangular factor stored in AB.
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  KD      (input) INTEGER
*          The number of superdiagonals of the matrix A if UPLO = 'U',
*          or the number of subdiagonals if UPLO = 'L'.  KD >= 0.
*
*  NRHS    (input) INTEGER
*          The number of right hand sides, i.e., the number of columns
*          of the matrix B.  NRHS >= 0.
*
*  AB      (input) COMPLEX array, dimension (LDAB,N)
*          The triangular factor U or L from the Cholesky factorization
*          A = U**H*U or A = L*L**H of the band matrix A, stored in the
*          first KD+1 rows of the array.  The j-th column of U or L is
*          stored in the j-th column of the array AB as follows:
*          if UPLO ='U', AB(kd+1+i-j,j) = U(i,j) for max(1,j-kd)<=i<=j;
*          if UPLO ='L', AB(1+i-j,j)    = L(i,j) for j<=i<=min(n,j+kd).
*
*  LDAB    (input) INTEGER
*          The leading dimension of the array AB.  LDAB >= KD+1.
*
*  B       (input/output) COMPLEX array, dimension (LDB,NRHS)
*          On entry, the right hand side matrix B.
*          On exit, the solution matrix X.
*
*  LDB     (input) INTEGER
*          The leading dimension of the array B.  LDB >= max(1,N).
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*
*  =====================================================================
*
*     .. Local Scalars ..
      LOGICAL            UPPER
      INTEGER            J
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           CTBSV, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      UPPER = LSAME( UPLO, 'U' )
      IF( .NOT.UPPER .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( KD.LT.0 ) THEN
         INFO = -3
      ELSE IF( NRHS.LT.0 ) THEN
         INFO = -4
      ELSE IF( LDAB.LT.KD+1 ) THEN
         INFO = -6
      ELSE IF( LDB.LT.MAX( 1, N ) ) THEN
         INFO = -8
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'CPBTRS', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 .OR. NRHS.EQ.0 )
     $   RETURN
*
      IF( UPPER ) THEN
*
*        Solve A*X = B where A = U'*U.
*
         DO 10 J = 1, NRHS
*
*           Solve U'*X = B, overwriting B with X.
*
            CALL CTBSV( 'Upper', 'Conjugate transpose', 'Non-unit', N,
     $                  KD, AB, LDAB, B( 1, J ), 1 )
*
*           Solve U*X = B, overwriting B with X.
*
            CALL CTBSV( 'Upper', 'No transpose', 'Non-unit', N, KD, AB,
     $                  LDAB, B( 1, J ), 1 )
   10    CONTINUE
      ELSE
*
*        Solve A*X = B where A = L*L'.
*
         DO 20 J = 1, NRHS
*
*           Solve L*X = B, overwriting B with X.
*
            CALL CTBSV( 'Lower', 'No transpose', 'Non-unit', N, KD, AB,
     $                  LDAB, B( 1, J ), 1 )
*
*           Solve L'*X = B, overwriting B with X.
*
            CALL CTBSV( 'Lower', 'Conjugate transpose', 'Non-unit', N,
     $                  KD, AB, LDAB, B( 1, J ), 1 )
   20    CONTINUE
      END IF
*
      RETURN
*
*     End of CPBTRS
*
      END

C
C       $Id: curvs2dp.f,v 1.3 2008-07-27 03:10:11 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
C NOTE: If you make any changes to this software, please remember to
C make the same changes to the corresponding single precision routine.
C
      SUBROUTINE CURVS2DP(T,N,PARAM,X,Y,XP,YP,SIGMA,XO,YO)
      DOUBLE PRECISION XO
      DOUBLE PRECISION YO
      DOUBLE PRECISION CURV2DP
C
C  This subroutine is a companion to CURV1SDP which must be
C  called before calling this subroutine.  CURV2SDP calculates
C  an interpolated value for a smoothing spline under tension
C  at a given point.  CURVS1DP must be called before CURVS2DP to
C  determine certain necessary parameters.
C
C  On input:
C
C    T
C      A real value to be mapped onto the interpolating curve.
C      Values of T between zero and one interpolate the original
C      data; any values of T outside this range result in
C      extrapolation.
C
C    N
C      The number of points which were specified to
C      determine the curve.
C
C    PARAM
C      The arc lengths computed by CURVS1DP.
C
C    X
C*PL*ERROR* Comment line too long
C      An array containing the X-coordinate values of the specified points.
C
C    Y
C*PL*ERROR* Comment line too long
C      An array containing the Y-coordinate values of the specified points.
C
C    XP
C      An array of second derivative values as calculated by CURVS1DP.
C
C    YP
C      An array of second derivative values as calculated by CURVS1DP.
C
C    SIGMA
C      The tension factor (its sign is ignored).
C
C  On output:
C
C    XO
C      The interpolated X value.
C
C    YO
C      The interpolated Y value.
C
C  The parameters N, X, Y, XP, YP, and SIGMA should be input
C  unaltered from the output of CURVS1DP.
C
      DOUBLE PRECISION T,PARAM(N),X(N),Y(N),XP(N),YP(N),SIGMA
C
      XO = CURV2DP(T,N,PARAM,X,XP,SIGMA)
      YO = CURV2DP(T,N,PARAM,Y,YP,SIGMA)
C
      RETURN
      END

C
C	$Id: gcsgwk.f,v 1.9 2008-07-27 00:20:57 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GCSGWK(WKID,SGNA)
C
C  COPY SEGMENT TO WORKSTATION.
C
      INTEGER ECSGWK
      PARAMETER (ECSGWK=62)
C
      include 'gkscom.h'
      include 'trstat.h'
C
      INTEGER WKID,SGNA,WKTP,WKCT,FCODEO,CONTO
C
C  This subroutine is here solely as support for the SPPS GFLASn
C  entries.  Full segmentation is not a part of the NCAR GKS
C  package at this time.  The NCAR package is non-standard to the
C  extent that certain segmentation functions are supported, but
C  not all level 1 functions are supported.  This subroutine should
C  be considered a user entry point only by way of the GFLASn
C  calls--it should never be called directly be the user.
C
C
C  Check if GKS is in the proper state.
C
      CALL GZCKST(6,ECSGWK,IER)
      IF (IER .NE. 0) RETURN
C
C  Check if the workstation identifier is valid.
C
      CALL GZCKWK(20,ECSGWK,WKID,IDUM,IER)
      IF (IER .NE. 0) RETURN
C
C  Check if the specified workstation is open.
C
      CALL GZCKWK(25,ECSGWK,WKID,IDUM,IER)
      IF (IER .NE. 0) RETURN
C
C  Check if WISS is open.
C
      DO 200 I=1,NOPWK
        CALL GQWKCA(SWKTP(I),IER,IWCAT)
        IF (IWCAT .EQ. GWISS) GO TO 10
  200 CONTINUE
      ERS = 1
      CALL GERHND(27,ECSGWK,ERF)
      ERS = 0
      RETURN
C
   10 CONTINUE
C
C  Determine the workstation type.
C
      DO 201 I=1,NOPWK
        IF (SOPWK(I) .EQ. WKID) THEN
        WKTP = SWKTP(I)
        GO TO 20
      ENDIF
  201 CONTINUE
   20 CONTINUE
C
C  Get the workstation category.
C
      CALL GQWKCA(WKTP,IER,WKCT)
C
C  Check if an MI workstation.
C
      IF (WKCT .EQ. GMI) THEN
        ERS = 1
        CALL GERHND(33,ECSGWK,ERF)
        ERS = 0
        RETURN
      ENDIF
C
C  Check if input workstation.
C
      IF (WKCT .EQ. GINPUT) THEN
        ERS = 1
        CALL GERHND(35,ECSGWK,ERF)
        ERS = 0
        RETURN
      ENDIF
C
C  Check if WISS workstation.
C
      IF (WKCT .EQ. GWISS) THEN
        ERS = 1
        CALL GERHND(36,ECSGWK,ERF)
        ERS = 0
        RETURN
      ENDIF
C
C  Check that the segment name is valid.
C
      IF (SGNA.LT.0 .OR. SGNA.GT.99) THEN
        ERS = 1
        CALL GERHND(120,ECSGWK,ERF)
        ERS = 0
        RETURN
      ENDIF
C
C  Check if the segment name is in WISS.
C
      DO 202 I=1,NUMSEG
        IF (SEGS(I) .EQ. SGNA) THEN
          STR = ' '
          STR = SEGNAM(I)
          GO TO 30
        ENDIF
  202 CONTINUE
      ERS = 1
      CALL GERHND(124,ECSGWK,ERF)
      ERS = 0
      RETURN
   30 CONTINUE
C
C  If the copy is to a non-CGM, or if the segment transformation
C  is not the identity, or if the clipping rectangle transform 
C  flag is set, do the copy by parsing the segments.
C
      DO 60 I=1,NUMSEG
        IF (SEGS(I) .EQ. SGNA) THEN
          MXSREC = SEGLEN(I)
C
C  Retrieve the current segment transformation.
C
          CURTM(1,1) = SEGT(I,1,1) 
          CURTM(1,2) = SEGT(I,1,2) 
          CURTM(1,3) = SEGT(I,1,3) 
          CURTM(2,1) = SEGT(I,2,1) 
          CURTM(2,2) = SEGT(I,2,2) 
          CURTM(2,3) = SEGT(I,2,3) 
          GO TO 70
        ENDIF
   60 CONTINUE
   70 CONTINUE
      IF (WKTP.NE.GCGM .OR. IGSGCP.NE.0 
     +                 .OR. CURTM(1,1).NE.1. .OR.CURTM(1,2).NE.0.
     +                 .OR. CURTM(1,3).NE.0. .OR.CURTM(2,1).NE.0.
     +                 .OR. CURTM(2,2).NE.1. .OR.CURTM(2,3).NE.0.
     +                 ) THEN
        CALL GZCPWK(WKID)
        RETURN
      ELSE
C
C  Copy to the metafile.
C
C
C  Invoke the workstation interface.
C
C  Put out a new picture initialization if the picture is empty.
C
        IF (NOPICT .LE. 0) THEN
          FCODEO = FCODE
          CONTO  = CONT
          FCODE  = 91
          CONT   =  0
          CALL G01WDR(WKID,' ')
          FCODE  = FCODEO
          CONT   = CONTO
          NOPICT = 1
        ENDIF
C
C  Set the flag CUFLAG to indicate that the interface call should go
C  only to the specifically designated workstation.
C
        CUFLAG = WKID
        FCODE = 82
        CONT  = 0
        CALL GZROI(0)
        IL1 = 3
        IL2 = 3
        ID(1) = WCONID
        ID(2) = SGNA
        DO 40 I=1,NUMSEG
          IF (SEGS(I) .EQ. SGNA) THEN
            ID(3) = SEGLEN(I)
            GO TO 50
          ENDIF
   40   CONTINUE
   50   CONTINUE
        STRL1 = 80
        STRL2 = 80
        CALL GZTOWK
        IF (RERR.NE.0) THEN
          ERS = 1
          CALL GERHND(RERR,ECSGWK,ERF)
          ERS = 0
        ENDIF
      ENDIF
      CUFLAG = -1
C
      RETURN
      END

C
C $Id: pcffgd.f,v 1.6 2008-07-27 00:17:19 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE PCFFGD (IPSS,NASC,CHGT,SIZE,RDGU,LDGU,NDGU)
C
C Get the digitization of the character whose ASCII decimal equivalent
C is NASC and store in RGDU.
C
      include 'pcffme.h'
      include 'pcffdx.h'
      include 'pcffsp.h'
C
      DIMENSION RDGU(LDGU)
      DIMENSION TWINO(4),TVPTO(4)
C
      IF (NASC.GT.CHREND .OR. NASC.LT.CHRSTR) THEN
        NDGU = 0
        GO TO 90
      ENDIF
C
C Get the byte pointers delimiting the digitization for the character.
C
      IADDR1 = CHRPNT(NASC-CHRSTR+1)
      IF (NASC .EQ. CHREND) THEN
        IADDR2 = LSTPNT
      ELSE
        IADDR2 = CHRPNT(NASC-CHRSTR+2)
      ENDIF
      IADDL = IADDR2-IADDR1
C
C Get the character description from the binary fontcap.
C
      NUMPKT = (8*IADDL)/(PKFLWD+XBITWD+YBITWD)
      IF (NUMPKT .GT. ICLEN) THEN
        NDGU = 0  
        GO TO 90
      ENDIF
      CALL PCFFGP(NUMPKT,8*IADDR1,SFLGS,IXC,IYC)
C
C  Create the digitization.
C
      I = 1
   80 CONTINUE
       IF (SFLGS(I) .EQ. 6) THEN
C
C Begin character, get width.
C
         CWIDTH = REAL(IYC(I))
C
C  Subtract off the biases from the coordinate points; translate the
C  font coordinate system to the PLOTCHAR one; scale to the desired
C  height.
C
         XOFF = -0.5*CWIDTH
         YOFF = REAL(FBASE-FHALF)
         DO 20 IC=1,NUMPKT
           IF (SFLGS(IC).EQ.0 .OR. SFLGS(IC).EQ.4) THEN
             XC(IC) = (REAL((IXC(IC)-XBIAS))+XOFF)*SCALE
             YC(IC) = (REAL((IYC(IC)-YBIAS))+YOFF)*SCALE
           ENDIF
   20    CONTINUE
C
C  Set the left and right concatenation points.
C
         JNDX = 1
         RDGU(JNDX) = XOFF*SCALE
         JNDX = JNDX+1
         RDGU(JNDX) = -XOFF*SCALE
         IF (IPSS .EQ. 1) THEN
           NDGU = JNDX
           GO TO 90
         ENDIF
C
C  Define normalization transformation 1 to be consistent with the 
C  Bezier fidelity parameter and select normalization transformation 1.
C
         CALL GQCNTN(IER,NTRO)
         CALL GQNT(1,IER,TWINO,TVPTO)
         YMAX = REAL(FHALF-FBASE)*SCALE/SIZE
         YMIN = -YMAX
         XMAX = YMAX
         XMIN = YMIN
         CALL GSWN(1,XMIN,XMAX,YMIN,YMAX)
         CALL GSVP(1,0.,1.,0.,1.)
         CALL GSELNT(1)
       ELSE IF (SFLGS(I) .EQ. 1) THEN
C
C End a region (or a polyline if an outline font is requested).
C
         IF (OUTLIN .NE. 0) THEN
           JNDX = JNDX+1
           RDGU(JNDX) = -2048.  
           JNDX = JNDX+1
           RDGU(JNDX) = 0.
         ELSE
           JNDX = JNDX+1
           RDGU(JNDX) = -2047.  
           JNDX = JNDX+1
           RDGU(JNDX) = 0.
         ENDIF
         NDGU = JNDX
         IF (NDGU .GT. LDGU) CALL SETER
     +         ('PCFFGD - INTERNAL LOGIC ERROR - SEE CONSULTANT',1,2)
       ELSE IF (SFLGS(I) .EQ. 7) THEN
C
C End a polyline.
C
         JNDX = JNDX+1
         RDGU(JNDX) = -2048.  
         JNDX = JNDX+1
         RDGU(JNDX) = 0.
         NDGU = JNDX
         IF (NDGU .GT. LDGU) CALL SETER
     +         ('PCFFGD - INTERNAL LOGIC ERROR - SEE CONSULTANT',1,2)
       ELSE IF (SFLGS(I) .EQ. 2) THEN
C
C Add the points for a hole to the path, or draw the hole if an
C outline font is requested.
C
         XORIG = RDGU(JNDX-1)
         YORIG = RDGU(JNDX)
         IF (OUTLIN .EQ. 1) THEN
C
C Draw the current line.
C
           JNDX = JNDX+1
           RDGU(JNDX) = -2048.
           JNDX = JNDX+1
           RDGU(JNDX) = 0.
         ENDIF 
         CALL PCFFHL (I,JNDX,XORIG,YORIG,NCO,JNDXO,RDGU(1))
         JNDX = JNDXO
         I = NCO
       ELSE IF (SFLGS(I) .EQ. 0) THEN
C
C Add the point to the path.
C
         JNDX = JNDX+1
         RDGU(JNDX) = XC(I)
         JNDX = JNDX+1
         RDGU(JNDX) = YC(I)
       ELSE IF (SFLGS(I) .EQ. 4) THEN
C
C  Process the Bezier curve.
C
         BCNTLX(1) = RDGU(JNDX-1)
         BCNTLY(1) = RDGU(JNDX)
         DO 30 IB=2,4
           BCNTLX(IB) = XC(I+IB-2)
           BCNTLY(IB) = YC(I+IB-2)
   30    CONTINUE
C
         CALL BCCURV(BCNTLX,BCNTLY,IBZL,BZXC,BZYC,NBP)
C
C  Add the interpolated points to the curve (start at 2 since the
C  original point is already in the curve).
C
         DO 60 K=2,NBP
           JNDX = JNDX+1
           RDGU(JNDX) = BZXC(K) 
           JNDX = JNDX+1
           RDGU(JNDX) = BZYC(K) 
   60    CONTINUE
         I = I+2
       ELSE IF (SFLGS(I) .EQ. 5) THEN
C
C  Re-establish normalization transformation 1 and select the
C  normalization transformation that was in effect at the beginning.
C
         CALL GSWN(1,TWINO(1),TWINO(2),TWINO(3),TWINO(4))
         CALL GSVP(1,TVPTO(1),TVPTO(2),TVPTO(3),TVPTO(4))
         CALL GSELNT(NTRO)
         GO TO 90
       ELSE
         PRINT * , 'PCFFGD -- Invalid fontcap encoding encountered.'
         STOP
       ENDIF
C
      IF (I .GE. NUMPKT) THEN
        GO TO 90
      ELSE
        I = I+1
        GO TO 80
      ENDIF
C
   90 CONTINUE
C
      RETURN
      END

      SUBROUTINE SLAG2( A, LDA, B, LDB, SAFMIN, SCALE1, SCALE2, WR1,
     $                  WR2, WI )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     March 31, 1993
*
*     .. Scalar Arguments ..
      INTEGER            LDA, LDB
      REAL               SAFMIN, SCALE1, SCALE2, WI, WR1, WR2
*     ..
*     .. Array Arguments ..
      REAL               A( LDA, * ), B( LDB, * )
*     ..
*
*  Purpose
*  =======
*
*  SLAG2 computes the eigenvalues of a 2 x 2 generalized eigenvalue
*  problem  A - w B, with scaling as necessary to avoid over-/underflow.
*
*  The scaling factor "s" results in a modified eigenvalue equation
*
*      s A - w B
*
*  where  s  is a non-negative scaling factor chosen so that  w,  w B,
*  and  s A  do not overflow and, if possible, do not underflow, either.
*
*  Arguments
*  =========
*
*  A       (input) REAL array, dimension (LDA, 2)
*          On entry, the 2 x 2 matrix A.  It is assumed that its 1-norm
*          is less than 1/SAFMIN.  Entries less than
*          sqrt(SAFMIN)*norm(A) are subject to being treated as zero.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= 2.
*
*  B       (input) REAL array, dimension (LDB, 2)
*          On entry, the 2 x 2 upper triangular matrix B.  It is
*          assumed that the one-norm of B is less than 1/SAFMIN.  The
*          diagonals should be at least sqrt(SAFMIN) times the largest
*          element of B (in absolute value); if a diagonal is smaller
*          than that, then  +/- sqrt(SAFMIN) will be used instead of
*          that diagonal.
*
*  LDB     (input) INTEGER
*          The leading dimension of the array B.  LDB >= 2.
*
*  SAFMIN  (input) REAL
*          The smallest positive number s.t. 1/SAFMIN does not
*          overflow.  (This should always be SLAMCH('S') -- it is an
*          argument in order to avoid having to call SLAMCH frequently.)
*
*  SCALE1  (output) REAL
*          A scaling factor used to avoid over-/underflow in the
*          eigenvalue equation which defines the first eigenvalue.  If
*          the eigenvalues are complex, then the eigenvalues are
*          ( WR1  +/-  WI i ) / SCALE1  (which may lie outside the
*          exponent range of the machine), SCALE1=SCALE2, and SCALE1
*          will always be positive.  If the eigenvalues are real, then
*          the first (real) eigenvalue is  WR1 / SCALE1 , but this may
*          overflow or underflow, and in fact, SCALE1 may be zero or
*          less than the underflow threshhold if the exact eigenvalue
*          is sufficiently large.
*
*  SCALE2  (output) REAL
*          A scaling factor used to avoid over-/underflow in the
*          eigenvalue equation which defines the second eigenvalue.  If
*          the eigenvalues are complex, then SCALE2=SCALE1.  If the
*          eigenvalues are real, then the second (real) eigenvalue is
*          WR2 / SCALE2 , but this may overflow or underflow, and in
*          fact, SCALE2 may be zero or less than the underflow
*          threshhold if the exact eigenvalue is sufficiently large.
*
*  WR1     (output) REAL
*          If the eigenvalue is real, then WR1 is SCALE1 times the
*          eigenvalue closest to the (2,2) element of A B**(-1).  If the
*          eigenvalue is complex, then WR1=WR2 is SCALE1 times the real
*          part of the eigenvalues.
*
*  WR2     (output) REAL
*          If the eigenvalue is real, then WR2 is SCALE2 times the
*          other eigenvalue.  If the eigenvalue is complex, then
*          WR1=WR2 is SCALE1 times the real part of the eigenvalues.
*
*  WI      (output) REAL
*          If the eigenvalue is real, then WI is zero.  If the
*          eigenvalue is complex, then WI is SCALE1 times the imaginary
*          part of the eigenvalues.  WI will always be non-negative.
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ZERO, ONE, TWO
      PARAMETER          ( ZERO = 0.0E+0, ONE = 1.0E+0, TWO = 2.0E+0 )
      REAL               HALF
      PARAMETER          ( HALF = ONE / TWO )
      REAL               FUZZY1
      PARAMETER          ( FUZZY1 = ONE+1.0E-5 )
*     ..
*     .. Local Scalars ..
      REAL               A11, A12, A21, A22, ABI22, ANORM, AS11, AS12,
     $                   AS22, ASCALE, B11, B12, B22, BINV11, BINV22,
     $                   BMIN, BNORM, BSCALE, BSIZE, C1, C2, C3, C4, C5,
     $                   DIFF, DISCR, PP, QQ, R, RTMAX, RTMIN, S1, S2,
     $                   SAFMAX, SHIFT, SS, SUM, WABS, WBIG, WDET,
     $                   WSCALE, WSIZE, WSMALL
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, MAX, MIN, SIGN, SQRT
*     ..
*     .. Executable Statements ..
*
      RTMIN = SQRT( SAFMIN )
      RTMAX = ONE / RTMIN
      SAFMAX = ONE / SAFMIN
*
*     Scale A
*
      ANORM = MAX( ABS( A( 1, 1 ) )+ABS( A( 2, 1 ) ),
     $        ABS( A( 1, 2 ) )+ABS( A( 2, 2 ) ), SAFMIN )
      ASCALE = ONE / ANORM
      A11 = ASCALE*A( 1, 1 )
      A21 = ASCALE*A( 2, 1 )
      A12 = ASCALE*A( 1, 2 )
      A22 = ASCALE*A( 2, 2 )
*
*     Perturb B if necessary to insure non-singularity
*
      B11 = B( 1, 1 )
      B12 = B( 1, 2 )
      B22 = B( 2, 2 )
      BMIN = RTMIN*MAX( ABS( B11 ), ABS( B12 ), ABS( B22 ), RTMIN )
      IF( ABS( B11 ).LT.BMIN )
     $   B11 = SIGN( BMIN, B11 )
      IF( ABS( B22 ).LT.BMIN )
     $   B22 = SIGN( BMIN, B22 )
*
*     Scale B
*
      BNORM = MAX( ABS( B11 ), ABS( B12 )+ABS( B22 ), SAFMIN )
      BSIZE = MAX( ABS( B11 ), ABS( B22 ) )
      BSCALE = ONE / BSIZE
      B11 = B11*BSCALE
      B12 = B12*BSCALE
      B22 = B22*BSCALE
*
*     Compute larger eigenvalue by method described by C. van Loan
*
*     ( AS is A shifted by -SHIFT*B )
*
      BINV11 = ONE / B11
      BINV22 = ONE / B22
      S1 = A11*BINV11
      S2 = A22*BINV22
      IF( ABS( S1 ).LE.ABS( S2 ) ) THEN
         AS12 = A12 - S1*B12
         AS22 = A22 - S1*B22
         SS = A21*( BINV11*BINV22 )
         ABI22 = AS22*BINV22 - SS*B12
         PP = HALF*ABI22
         SHIFT = S1
      ELSE
         AS12 = A12 - S2*B12
         AS11 = A11 - S2*B11
         SS = A21*( BINV11*BINV22 )
         ABI22 = -SS*B12
         PP = HALF*( AS11*BINV11+ABI22 )
         SHIFT = S2
      END IF
      QQ = SS*AS12
      IF( ABS( PP*RTMIN ).GE.ONE ) THEN
         DISCR = ( RTMIN*PP )**2 + QQ*SAFMIN
         R = SQRT( ABS( DISCR ) )*RTMAX
      ELSE
         IF( PP**2+ABS( QQ ).LE.SAFMIN ) THEN
            DISCR = ( RTMAX*PP )**2 + QQ*SAFMAX
            R = SQRT( ABS( DISCR ) )*RTMIN
         ELSE
            DISCR = PP**2 + QQ
            R = SQRT( ABS( DISCR ) )
         END IF
      END IF
*
*     Note: the test of R in the following IF is to cover the case when
*           DISCR is small and negative and is flushed to zero during
*           the calculation of R.  On machines which have a consistent
*           flush-to-zero threshhold and handle numbers above that
*           threshhold correctly, it would not be necessary.
*
      IF( DISCR.GE.ZERO .OR. R.EQ.ZERO ) THEN
         SUM = PP + SIGN( R, PP )
         DIFF = PP - SIGN( R, PP )
         WBIG = SHIFT + SUM
*
*        Compute smaller eigenvalue
*
         WSMALL = SHIFT + DIFF
         IF( HALF*ABS( WBIG ).GT.MAX( ABS( WSMALL ), SAFMIN ) ) THEN
            WDET = ( A11*A22-A12*A21 )*( BINV11*BINV22 )
            WSMALL = WDET / WBIG
         END IF
*
*        Choose (real) eigenvalue closest to 2,2 element of A*B**(-1)
*        for WR1.
*
         IF( PP.GT.ABI22 ) THEN
            WR1 = MIN( WBIG, WSMALL )
            WR2 = MAX( WBIG, WSMALL )
         ELSE
            WR1 = MAX( WBIG, WSMALL )
            WR2 = MIN( WBIG, WSMALL )
         END IF
         WI = ZERO
      ELSE
*
*        Complex eigenvalues
*
         WR1 = SHIFT + PP
         WR2 = WR1
         WI = R
      END IF
*
*     Further scaling to avoid underflow and overflow in computing
*     SCALE1 and overflow in computing w*B.
*
*     This scale factor (WSCALE) is bounded from above using C1 and C2,
*     and from below using C3 and C4.
*        C1 implements the condition  s A  must never overflow.
*        C2 implements the condition  w B  must never overflow.
*        C3, with C2,
*           implement the condition that s A - w B must never overflow.
*        C4 implements the condition  s    should not underflow.
*        C5 implements the condition  max(s,|w|) should be at least 2.
*
      C1 = BSIZE*( SAFMIN*MAX( ONE, ASCALE ) )
      C2 = SAFMIN*MAX( ONE, BNORM )
      C3 = BSIZE*SAFMIN
      IF( ASCALE.LE.ONE .AND. BSIZE.LE.ONE ) THEN
         C4 = MIN( ONE, ( ASCALE / SAFMIN )*BSIZE )
      ELSE
         C4 = ONE
      END IF
      IF( ASCALE.LE.ONE .OR. BSIZE.LE.ONE ) THEN
         C5 = MIN( ONE, ASCALE*BSIZE )
      ELSE
         C5 = ONE
      END IF
*
*     Scale first eigenvalue
*
      WABS = ABS( WR1 ) + ABS( WI )
      WSIZE = MAX( SAFMIN, C1, FUZZY1*( WABS*C2+C3 ),
     $        MIN( C4, HALF*MAX( WABS, C5 ) ) )
      IF( WSIZE.NE.ONE ) THEN
         WSCALE = ONE / WSIZE
         IF( WSIZE.GT.ONE ) THEN
            SCALE1 = ( MAX( ASCALE, BSIZE )*WSCALE )*
     $               MIN( ASCALE, BSIZE )
         ELSE
            SCALE1 = ( MIN( ASCALE, BSIZE )*WSCALE )*
     $               MAX( ASCALE, BSIZE )
         END IF
         WR1 = WR1*WSCALE
         IF( WI.NE.ZERO ) THEN
            WI = WI*WSCALE
            WR2 = WR1
            SCALE2 = SCALE1
         END IF
      ELSE
         SCALE1 = ASCALE*BSIZE
         SCALE2 = SCALE1
      END IF
*
*     Scale second eigenvalue (if real)
*
      IF( WI.EQ.ZERO ) THEN
         WSIZE = MAX( SAFMIN, C1, FUZZY1*( ABS( WR2 )*C2+C3 ),
     $           MIN( C4, HALF*MAX( ABS( WR2 ), C5 ) ) )
         IF( WSIZE.NE.ONE ) THEN
            WSCALE = ONE / WSIZE
            IF( WSIZE.GT.ONE ) THEN
               SCALE2 = ( MAX( ASCALE, BSIZE )*WSCALE )*
     $                  MIN( ASCALE, BSIZE )
            ELSE
               SCALE2 = ( MIN( ASCALE, BSIZE )*WSCALE )*
     $                  MAX( ASCALE, BSIZE )
            END IF
            WR2 = WR2*WSCALE
         ELSE
            SCALE2 = ASCALE*BSIZE
         END IF
      END IF
*
*     End of SLAG2
*
      RETURN
      END

      SUBROUTINE DSYSVX( FACT, UPLO, N, NRHS, A, LDA, AF, LDAF, IPIV, B,
     $                   LDB, X, LDX, RCOND, FERR, BERR, WORK, LWORK,
     $                   IWORK, INFO )
*
*  -- LAPACK driver routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          FACT, UPLO
      INTEGER            INFO, LDA, LDAF, LDB, LDX, LWORK, N, NRHS
      DOUBLE PRECISION   RCOND
*     ..
*     .. Array Arguments ..
      INTEGER            IPIV( * ), IWORK( * )
      DOUBLE PRECISION   A( LDA, * ), AF( LDAF, * ), B( LDB, * ),
     $                   BERR( * ), FERR( * ), WORK( * ), X( LDX, * )
*     ..
*
*  Purpose
*  =======
*
*  DSYSVX uses the diagonal pivoting factorization to compute the
*  solution to a real system of linear equations A * X = B,
*  where A is an N-by-N symmetric matrix and X and B are N-by-NRHS
*  matrices.
*
*  Error bounds on the solution and a condition estimate are also
*  provided.
*
*  Description
*  ===========
*
*  The following steps are performed:
*
*  1. If FACT = 'N', the diagonal pivoting method is used to factor A.
*     The form of the factorization is
*        A = U * D * U**T,  if UPLO = 'U', or
*        A = L * D * L**T,  if UPLO = 'L',
*     where U (or L) is a product of permutation and unit upper (lower)
*     triangular matrices, and D is symmetric and block diagonal with
*     1-by-1 and 2-by-2 diagonal blocks.
*
*  2. If some D(i,i)=0, so that D is exactly singular, then the routine
*     returns with INFO = i. Otherwise, the factored form of A is used
*     to estimate the condition number of the matrix A.  If the
*     reciprocal of the condition number is less than machine precision,
*     INFO = N+1 is returned as a warning, but the routine still goes on
*     to solve for X and compute error bounds as described below.
*
*  3. The system of equations is solved for X using the factored form
*     of A.
*
*  4. Iterative refinement is applied to improve the computed solution
*     matrix and calculate error bounds and backward error estimates
*     for it.
*
*  Arguments
*  =========
*
*  FACT    (input) CHARACTER*1
*          Specifies whether or not the factored form of A has been
*          supplied on entry.
*          = 'F':  On entry, AF and IPIV contain the factored form of
*                  A.  AF and IPIV will not be modified.
*          = 'N':  The matrix A will be copied to AF and factored.
*
*  UPLO    (input) CHARACTER*1
*          = 'U':  Upper triangle of A is stored;
*          = 'L':  Lower triangle of A is stored.
*
*  N       (input) INTEGER
*          The number of linear equations, i.e., the order of the
*          matrix A.  N >= 0.
*
*  NRHS    (input) INTEGER
*          The number of right hand sides, i.e., the number of columns
*          of the matrices B and X.  NRHS >= 0.
*
*  A       (input) DOUBLE PRECISION array, dimension (LDA,N)
*          The symmetric matrix A.  If UPLO = 'U', the leading N-by-N
*          upper triangular part of A contains the upper triangular part
*          of the matrix A, and the strictly lower triangular part of A
*          is not referenced.  If UPLO = 'L', the leading N-by-N lower
*          triangular part of A contains the lower triangular part of
*          the matrix A, and the strictly upper triangular part of A is
*          not referenced.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(1,N).
*
*  AF      (input or output) DOUBLE PRECISION array, dimension (LDAF,N)
*          If FACT = 'F', then AF is an input argument and on entry
*          contains the block diagonal matrix D and the multipliers used
*          to obtain the factor U or L from the factorization
*          A = U*D*U**T or A = L*D*L**T as computed by DSYTRF.
*
*          If FACT = 'N', then AF is an output argument and on exit
*          returns the block diagonal matrix D and the multipliers used
*          to obtain the factor U or L from the factorization
*          A = U*D*U**T or A = L*D*L**T.
*
*  LDAF    (input) INTEGER
*          The leading dimension of the array AF.  LDAF >= max(1,N).
*
*  IPIV    (input or output) INTEGER array, dimension (N)
*          If FACT = 'F', then IPIV is an input argument and on entry
*          contains details of the interchanges and the block structure
*          of D, as determined by DSYTRF.
*          If IPIV(k) > 0, then rows and columns k and IPIV(k) were
*          interchanged and D(k,k) is a 1-by-1 diagonal block.
*          If UPLO = 'U' and IPIV(k) = IPIV(k-1) < 0, then rows and
*          columns k-1 and -IPIV(k) were interchanged and D(k-1:k,k-1:k)
*          is a 2-by-2 diagonal block.  If UPLO = 'L' and IPIV(k) =
*          IPIV(k+1) < 0, then rows and columns k+1 and -IPIV(k) were
*          interchanged and D(k:k+1,k:k+1) is a 2-by-2 diagonal block.
*
*          If FACT = 'N', then IPIV is an output argument and on exit
*          contains details of the interchanges and the block structure
*          of D, as determined by DSYTRF.
*
*  B       (input) DOUBLE PRECISION array, dimension (LDB,NRHS)
*          The N-by-NRHS right hand side matrix B.
*
*  LDB     (input) INTEGER
*          The leading dimension of the array B.  LDB >= max(1,N).
*
*  X       (output) DOUBLE PRECISION array, dimension (LDX,NRHS)
*          If INFO = 0 or INFO = N+1, the N-by-NRHS solution matrix X.
*
*  LDX     (input) INTEGER
*          The leading dimension of the array X.  LDX >= max(1,N).
*
*  RCOND   (output) DOUBLE PRECISION
*          The estimate of the reciprocal condition number of the matrix
*          A.  If RCOND is less than the machine precision (in
*          particular, if RCOND = 0), the matrix is singular to working
*          precision.  This condition is indicated by a return code of
*          INFO > 0.
*
*  FERR    (output) DOUBLE PRECISION array, dimension (NRHS)
*          The estimated forward error bound for each solution vector
*          X(j) (the j-th column of the solution matrix X).
*          If XTRUE is the true solution corresponding to X(j), FERR(j)
*          is an estimated upper bound for the magnitude of the largest
*          element in (X(j) - XTRUE) divided by the magnitude of the
*          largest element in X(j).  The estimate is as reliable as
*          the estimate for RCOND, and is almost always a slight
*          overestimate of the true error.
*
*  BERR    (output) DOUBLE PRECISION array, dimension (NRHS)
*          The componentwise relative backward error of each solution
*          vector X(j) (i.e., the smallest relative change in
*          any element of A or B that makes X(j) an exact solution).
*
*  WORK    (workspace/output) DOUBLE PRECISION array, dimension (LWORK)
*          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*
*  LWORK   (input) INTEGER
*          The length of WORK.  LWORK >= 3*N, and for best performance
*          LWORK >= N*NB, where NB is the optimal blocksize for
*          DSYTRF.
*
*          If LWORK = -1, then a workspace query is assumed; the routine
*          only calculates the optimal size of the WORK array, returns
*          this value as the first entry of the WORK array, and no error
*          message related to LWORK is issued by XERBLA.
*
*  IWORK   (workspace) INTEGER array, dimension (N)
*
*  INFO    (output) INTEGER
*          = 0: successful exit
*          < 0: if INFO = -i, the i-th argument had an illegal value
*          > 0: if INFO = i, and i is
*                <= N:  D(i,i) is exactly zero.  The factorization
*                       has been completed but the factor D is exactly
*                       singular, so the solution and error bounds could
*                       not be computed. RCOND = 0 is returned.
*                = N+1: D is nonsingular, but RCOND is less than machine
*                       precision, meaning that the matrix is singular
*                       to working precision.  Nevertheless, the
*                       solution and error bounds are computed because
*                       there are a number of situations where the
*                       computed solution can be more accurate than the
*                       value of RCOND would suggest.
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO
      PARAMETER          ( ZERO = 0.0D+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            LQUERY, NOFACT
      INTEGER            LWKOPT, NB
      DOUBLE PRECISION   ANORM
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            ILAENV
      DOUBLE PRECISION   DLAMCH, DLANSY
      EXTERNAL           LSAME, ILAENV, DLAMCH, DLANSY
*     ..
*     .. External Subroutines ..
      EXTERNAL           DLACPY, DSYCON, DSYRFS, DSYTRF, DSYTRS, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      NOFACT = LSAME( FACT, 'N' )
      LQUERY = ( LWORK.EQ.-1 )
      IF( .NOT.NOFACT .AND. .NOT.LSAME( FACT, 'F' ) ) THEN
         INFO = -1
      ELSE IF( .NOT.LSAME( UPLO, 'U' ) .AND. .NOT.LSAME( UPLO, 'L' ) )
     $          THEN
         INFO = -2
      ELSE IF( N.LT.0 ) THEN
         INFO = -3
      ELSE IF( NRHS.LT.0 ) THEN
         INFO = -4
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -6
      ELSE IF( LDAF.LT.MAX( 1, N ) ) THEN
         INFO = -8
      ELSE IF( LDB.LT.MAX( 1, N ) ) THEN
         INFO = -11
      ELSE IF( LDX.LT.MAX( 1, N ) ) THEN
         INFO = -13
      ELSE IF( LWORK.LT.MAX( 1, 3*N ) .AND. .NOT.LQUERY ) THEN
         INFO = -18
      END IF
*
      IF( INFO.EQ.0 ) THEN
         NB = ILAENV( 1, 'DSYTRF', UPLO, N, -1, -1, -1 )
         LWKOPT = N*NB
         WORK( 1 ) = LWKOPT
      END IF
*
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DSYSVX', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         RETURN
      END IF
*
      IF( NOFACT ) THEN
*
*        Compute the factorization A = U*D*U' or A = L*D*L'.
*
         CALL DLACPY( UPLO, N, N, A, LDA, AF, LDAF )
         CALL DSYTRF( UPLO, N, AF, LDAF, IPIV, WORK, LWORK, INFO )
*
*        Return if INFO is non-zero.
*
         IF( INFO.NE.0 ) THEN
            IF( INFO.GT.0 )
     $         RCOND = ZERO
            RETURN
         END IF
      END IF
*
*     Compute the norm of the matrix A.
*
      ANORM = DLANSY( 'I', UPLO, N, A, LDA, WORK )
*
*     Compute the reciprocal of the condition number of A.
*
      CALL DSYCON( UPLO, N, AF, LDAF, IPIV, ANORM, RCOND, WORK, IWORK,
     $             INFO )
*
*     Set INFO = N+1 if the matrix is singular to working precision.
*
      IF( RCOND.LT.DLAMCH( 'Epsilon' ) )
     $   INFO = N + 1
*
*     Compute the solution vectors X.
*
      CALL DLACPY( 'Full', N, NRHS, B, LDB, X, LDX )
      CALL DSYTRS( UPLO, N, NRHS, AF, LDAF, IPIV, X, LDX, INFO )
*
*     Use iterative refinement to improve the computed solutions and
*     compute error bounds and backward error estimates for them.
*
      CALL DSYRFS( UPLO, N, NRHS, A, LDA, AF, LDAF, IPIV, B, LDB, X,
     $             LDX, FERR, BERR, WORK, IWORK, INFO )
*
      RETURN
*
*     End of DSYSVX
*
      END

C
C	$Id: cssmsgs.f,v 1.5 2008-07-27 03:10:08 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CSSMSGS (N,X,Y,Z,U,LIST,LPTR,LEND,IFLGS,
     .                  SIGMA,W,P, NIT,DFMAX,F,GRAD, IER)
      INTEGER N, LIST(*), LPTR(*), LEND(N), IFLGS, NIT, IER
      DOUBLE PRECISION X(N), Y(N), Z(N), U(N), SIGMA(*),
     .                 W(N), P, DFMAX, F(N), GRAD(3,N)
C
C***********************************************************
C
C                                              From SSRFPACK
C                                            Robert J. Renka
C                                  Dept. of Computer Science
C                                       Univ. of North Texas
C                                           renka@cs.unt.edu
C                                                   07/25/96
C
C   This subroutine solves the symmetric positive definite
C linear system associated with minimizing the quadratic
C functional Q(F,FX,FY,FZ) described in Subroutine CSSMSURF.
C Since the gradient at node K lies in the plane tangent to
C the sphere surface at K, it is effectively defined by only
C two components -- its X and Y components in the coordinate
C system obtained by rotating K to the north pole.  Thus,
C the minimization problem corresponds to an order-3N system
C which is solved by the block Gauss-Seidel method with 3 by
C 3 blocks.
C
C On input:
C
C       N,X,Y,Z,U,LIST,LPTR,LEND,IFLGS,SIGMA,W = Parameters
C           as described in Subroutine CSSMSURF.
C
C       P = Positive smoothing parameter defining Q.
C
C The above parameters are not altered by this routine.
C
C       NIT = Maximum number of iterations to be used.  This
C             maximum will likely be achieved if DFMAX is
C             smaller than the machine precision.  NIT .GE.
C             0.
C
C       DFMAX = Nonnegative convergence criterion.  The
C               method is terminated when the maximum
C               change in a solution F-component between
C               iterations is at most DFMAX.  The change in
C               a component is taken to be the absolute
C               difference relative to 1 plus the old value.
C
C       F = Initial estimate of the first N solution compo-
C           nents.
C
C       GRAD = 3 by N array containing initial estimates of
C              the last 3N solution components (the gradi-
C              ent with FX, FY, and FZ in rows 1, 2, and 3,
C              respectively).
C
C On output:
C
C       NIT = Number of Gauss-Seidel iterations employed.
C
C       DFMAX = Maximum relative change in a solution F-
C               component at the last iteration.
C
C       F = First N solution components -- function values
C           at the nodes.
C
C       GRAD = Last 3N solution components -- gradients at
C              the nodes.
C
C       IER = Error indicator:
C             IER = 0 if no errors were encountered and the
C                     convergence criterion was achieved.
C             IER = 1 if no errors were encountered but con-
C                     vergence was not achieved within NIT
C                     iterations.
C             IER = -1 if N, P, NIT, or DFMAX is outside its
C                      valid range on input.  F and GRAD are
C                      not altered in this case.
C             IER = -2 if all nodes are collinear or the
C                      triangulation is invalid.
C             IER = -3 if duplicate nodes were encountered.
C
C SSRFPACK modules required by CSSMSGS:  CSAPLYRT, CSCONSTR,
C                                        CSGRCOEF, CSSNHCSH
C
C Intrinsic functions called by CSSMSGS:  ABS, ATAN, MAX, SQRT
C
C***********************************************************
C
      INTEGER IFL, ITER, ITMAX, J, K, LPJ, LPL, NN
      DOUBLE PRECISION ALFA, ALFSQ, C11, C12, C13, C22, C23,
     .                 C33, CC22, CC23, CC33, CX, CY, DEN1,
     .                 DEN2, DET, DF, DFMX, DGK(3), DGX,
     .                 DGY, FK, G1, G2, G3, GJK, GKJ, PP,
     .                 R1, R2, R3, RR2, RR3, SIG, SINAL, SX,
     .                 SY, T, T1, T2, T3, T4, T5, T6, TOL,
     .                 XJ, XK, XS, YJ, YK, YS, ZJ, ZK
C
      NN = N
      IFL = IFLGS
      PP = P
      ITMAX = NIT
      TOL = DFMAX
C
C Test for errors in input and initialize iteration count,
C   tension factor, and output value of DFMAX.
C
      IF (NN .LT. 3  .OR.  PP .LE. 0.  .OR.  ITMAX .LT. 0
     .    .OR.  TOL .LT. 0.) GO TO 5
      ITER = 0
      SIG = SIGMA(1)
      DFMX = 0.
C
C Top of iteration loop.
C
    1 IF (ITER .EQ. ITMAX) GO TO 4
      DFMX = 0.
C
C   Loop on nodes.
C
      DO 3 K = 1,NN
        XK = X(K)
        YK = Y(K)
        ZK = Z(K)
        FK = F(K)
        G1 = GRAD(1,K)
        G2 = GRAD(2,K)
        G3 = GRAD(3,K)
C
C   Construct the rotation mapping node K to the north pole.
C
        CALL CSCONSTR (XK,YK,ZK, CX,SX,CY,SY)
C
C   Initialize components of the order-3 system for the
C     change (DF,DGX,DGY) in the K-th solution components.
C
        C11 = PP*W(K)
        C12 = 0.
        C13 = 0.
        C22 = 0.
        C23 = 0.
        C33 = 0.
        R1 = C11*(U(K)-FK)
        R2 = 0.
        R3 = 0.
C
C   Loop on neighbors J of node K.
C
        LPL = LEND(K)
        LPJ = LPL
    2   LPJ = LPTR(LPJ)
          J = ABS(LIST(LPJ))
C
C   Compute the coordinates of J in the rotated system.
C
          T = SX*Y(J) + CX*Z(J)
          YJ = CX*Y(J) - SX*Z(J)
          ZJ = SY*X(J) + CY*T
          XJ = CY*X(J) - SY*T
C
C   Compute arc-length ALFA between K and J, ALFSQ = ALFA*
C     ALFA, SINAL = SIN(ALFA), DEN1 = ALFA*SIN(ALFA)**2, and
C     DEN2 = ALFSQ*SINAL.
C
          ALFA = 2.D0*ATAN(SQRT((1.D0-ZJ)/(1.D0+ZJ)))
          ALFSQ = ALFA*ALFA
          XS = XJ*XJ
          YS = YJ*YJ
          SINAL = SQRT(XS+YS)
          DEN1 = ALFA*(XS+YS)
          DEN2 = ALFSQ*SINAL
C
C   Test for coincident nodes and compute functions of SIG:
C     T1 = SIG*SIG*COSHM/E, T2 = SIG*SINHM/E, and T3 = SIG*
C     (SIG*COSHM-SINHM)/E for E = SIG*SINH - 2*COSHM.
C
          IF (DEN1 .EQ. 0.) GO TO 7
          IF (IFL .GE. 1) SIG = SIGMA(LPJ)
          CALL CSGRCOEF (SIG, T3,T2)
          T1 = T2 + T3
C
C   Update system components for node J.
C
          T4 = 2.*T1/(ALFA*ALFSQ)
          T5 = T1/DEN2
          T6 = T3/DEN1
          C11 = C11 + T4
          C12 = C12 + T5*XJ
          C13 = C13 + T5*YJ
          C22 = C22 + T6*XS
          C23 = C23 + T6*XJ*YJ
          C33 = C33 + T6*YS
          GKJ = G1*X(J) + G2*Y(J) + G3*Z(J)
          GJK = GRAD(1,J)*XK + GRAD(2,J)*YK + GRAD(3,J)*ZK
          R1 = R1 + T4*(F(J)-FK) + T5*(GJK-GKJ)
          T = T5*(F(J)-FK) - T6*GKJ + T2*GJK/DEN1
          R2 = R2 + T*XJ
          R3 = R3 + T*YJ
C
C   Bottom of loop on neighbors.
C
          IF (LPJ .NE. LPL) GO TO 2
C
C   Solve the system associated with the K-th block.
C
        CC22 = C11*C22 - C12*C12
        CC23 = C11*C23 - C12*C13
        CC33 = C11*C33 - C13*C13
        RR2 = C11*R2 - C12*R1
        RR3 = C11*R3 - C13*R1
        DET = CC22*CC33 - CC23*CC23
        IF (DET .EQ. 0.  .OR.  CC22 .EQ. 0.  .OR.
     .      C11 .EQ. 0.) GO TO 6
        DGY = (CC22*RR3 - CC23*RR2)/DET
        DGX = (RR2 - CC23*DGY)/CC22
        DF = (R1 - C12*DGX - C13*DGY)/C11
C
C   Rotate (DGX,DGY,0) back to the original coordinate
C     system, and update GRAD( ,K), F(K), and DFMX.
C
        CALL CSAPLYRT (DGX,DGY,CX,SX,CY,SY, DGK)
        GRAD(1,K) = G1 + DGK(1)
        GRAD(2,K) = G2 + DGK(2)
        GRAD(3,K) = G3 + DGK(3)
        F(K) = FK + DF
        DFMX = MAX(DFMX,ABS(DF)/(1.+ABS(FK)))
    3   CONTINUE
C
C   Increment ITER and test for convergence.
C
      ITER = ITER + 1
      IF (DFMX .GT. TOL) GO TO 1
C
C The method converged.
C
      NIT = ITER
      DFMAX = DFMX
      IER = 0
      RETURN
C
C The method failed to converge within NIT iterations.
C
    4 DFMAX = DFMX
      IER = 1
      RETURN
C
C Invalid input parameter.
C
    5 NIT = 0
      DFMAX = 0.
      IER = -1
      RETURN
C
C Node K and its neighbors are collinear.
C
    6 NIT = 0
      DFMAX = DFMX
      IER = -2
      RETURN
C
C Nodes J and K coincide.
C
    7 NIT = 0
      DFMAX = DFMX
      IER = -3
      RETURN
      END

      SUBROUTINE SPBSTF( UPLO, N, KD, AB, LDAB, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER          UPLO
      INTEGER            INFO, KD, LDAB, N
*     ..
*     .. Array Arguments ..
      REAL               AB( LDAB, * )
*     ..
*
*  Purpose
*  =======
*
*  SPBSTF computes a split Cholesky factorization of a real
*  symmetric positive definite band matrix A.
*
*  This routine is designed to be used in conjunction with SSBGST.
*
*  The factorization has the form  A = S**T*S  where S is a band matrix
*  of the same bandwidth as A and the following structure:
*
*    S = ( U    )
*        ( M  L )
*
*  where U is upper triangular of order m = (n+kd)/2, and L is lower
*  triangular of order n-m.
*
*  Arguments
*  =========
*
*  UPLO    (input) CHARACTER*1
*          = 'U':  Upper triangle of A is stored;
*          = 'L':  Lower triangle of A is stored.
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  KD      (input) INTEGER
*          The number of superdiagonals of the matrix A if UPLO = 'U',
*          or the number of subdiagonals if UPLO = 'L'.  KD >= 0.
*
*  AB      (input/output) REAL array, dimension (LDAB,N)
*          On entry, the upper or lower triangle of the symmetric band
*          matrix A, stored in the first kd+1 rows of the array.  The
*          j-th column of A is stored in the j-th column of the array AB
*          as follows:
*          if UPLO = 'U', AB(kd+1+i-j,j) = A(i,j) for max(1,j-kd)<=i<=j;
*          if UPLO = 'L', AB(1+i-j,j)    = A(i,j) for j<=i<=min(n,j+kd).
*
*          On exit, if INFO = 0, the factor S from the split Cholesky
*          factorization A = S**T*S. See Further Details.
*
*  LDAB    (input) INTEGER
*          The leading dimension of the array AB.  LDAB >= KD+1.
*
*  INFO    (output) INTEGER
*          = 0: successful exit
*          < 0: if INFO = -i, the i-th argument had an illegal value
*          > 0: if INFO = i, the factorization could not be completed,
*               because the updated element a(i,i) was negative; the
*               matrix A is not positive definite.
*
*  Further Details
*  ===============
*
*  The band storage scheme is illustrated by the following example, when
*  N = 7, KD = 2:
*
*  S = ( s11  s12  s13                     )
*      (      s22  s23  s24                )
*      (           s33  s34                )
*      (                s44                )
*      (           s53  s54  s55           )
*      (                s64  s65  s66      )
*      (                     s75  s76  s77 )
*
*  If UPLO = 'U', the array AB holds:
*
*  on entry:                          on exit:
*
*   *    *   a13  a24  a35  a46  a57   *    *   s13  s24  s53  s64  s75
*   *   a12  a23  a34  a45  a56  a67   *   s12  s23  s34  s54  s65  s76
*  a11  a22  a33  a44  a55  a66  a77  s11  s22  s33  s44  s55  s66  s77
*
*  If UPLO = 'L', the array AB holds:
*
*  on entry:                          on exit:
*
*  a11  a22  a33  a44  a55  a66  a77  s11  s22  s33  s44  s55  s66  s77
*  a21  a32  a43  a54  a65  a76   *   s12  s23  s34  s54  s65  s76   *
*  a31  a42  a53  a64  a64   *    *   s13  s24  s53  s64  s75   *    *
*
*  Array elements marked * are not used by the routine.
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ONE, ZERO
      PARAMETER          ( ONE = 1.0E+0, ZERO = 0.0E+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            UPPER
      INTEGER            J, KLD, KM, M
      REAL               AJJ
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           SSCAL, SSYR, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN, SQRT
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      UPPER = LSAME( UPLO, 'U' )
      IF( .NOT.UPPER .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( KD.LT.0 ) THEN
         INFO = -3
      ELSE IF( LDAB.LT.KD+1 ) THEN
         INFO = -5
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'SPBSTF', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
*
      KLD = MAX( 1, LDAB-1 )
*
*     Set the splitting point m.
*
      M = ( N+KD ) / 2
*
      IF( UPPER ) THEN
*
*        Factorize A(m+1:n,m+1:n) as L**T*L, and update A(1:m,1:m).
*
         DO 10 J = N, M + 1, -1
*
*           Compute s(j,j) and test for non-positive-definiteness.
*
            AJJ = AB( KD+1, J )
            IF( AJJ.LE.ZERO )
     $         GO TO 50
            AJJ = SQRT( AJJ )
            AB( KD+1, J ) = AJJ
            KM = MIN( J-1, KD )
*
*           Compute elements j-km:j-1 of the j-th column and update the
*           the leading submatrix within the band.
*
            CALL SSCAL( KM, ONE / AJJ, AB( KD+1-KM, J ), 1 )
            CALL SSYR( 'Upper', KM, -ONE, AB( KD+1-KM, J ), 1,
     $                 AB( KD+1, J-KM ), KLD )
   10    CONTINUE
*
*        Factorize the updated submatrix A(1:m,1:m) as U**T*U.
*
         DO 20 J = 1, M
*
*           Compute s(j,j) and test for non-positive-definiteness.
*
            AJJ = AB( KD+1, J )
            IF( AJJ.LE.ZERO )
     $         GO TO 50
            AJJ = SQRT( AJJ )
            AB( KD+1, J ) = AJJ
            KM = MIN( KD, M-J )
*
*           Compute elements j+1:j+km of the j-th row and update the
*           trailing submatrix within the band.
*
            IF( KM.GT.0 ) THEN
               CALL SSCAL( KM, ONE / AJJ, AB( KD, J+1 ), KLD )
               CALL SSYR( 'Upper', KM, -ONE, AB( KD, J+1 ), KLD,
     $                    AB( KD+1, J+1 ), KLD )
            END IF
   20    CONTINUE
      ELSE
*
*        Factorize A(m+1:n,m+1:n) as L**T*L, and update A(1:m,1:m).
*
         DO 30 J = N, M + 1, -1
*
*           Compute s(j,j) and test for non-positive-definiteness.
*
            AJJ = AB( 1, J )
            IF( AJJ.LE.ZERO )
     $         GO TO 50
            AJJ = SQRT( AJJ )
            AB( 1, J ) = AJJ
            KM = MIN( J-1, KD )
*
*           Compute elements j-km:j-1 of the j-th row and update the
*           trailing submatrix within the band.
*
            CALL SSCAL( KM, ONE / AJJ, AB( KM+1, J-KM ), KLD )
            CALL SSYR( 'Lower', KM, -ONE, AB( KM+1, J-KM ), KLD,
     $                 AB( 1, J-KM ), KLD )
   30    CONTINUE
*
*        Factorize the updated submatrix A(1:m,1:m) as U**T*U.
*
         DO 40 J = 1, M
*
*           Compute s(j,j) and test for non-positive-definiteness.
*
            AJJ = AB( 1, J )
            IF( AJJ.LE.ZERO )
     $         GO TO 50
            AJJ = SQRT( AJJ )
            AB( 1, J ) = AJJ
            KM = MIN( KD, M-J )
*
*           Compute elements j+1:j+km of the j-th column and update the
*           trailing submatrix within the band.
*
            IF( KM.GT.0 ) THEN
               CALL SSCAL( KM, ONE / AJJ, AB( 2, J ), 1 )
               CALL SSYR( 'Lower', KM, -ONE, AB( 2, J ), 1,
     $                    AB( 1, J+1 ), KLD )
            END IF
   40    CONTINUE
      END IF
      RETURN
*
   50 CONTINUE
      INFO = J
      RETURN
*
*     End of SPBSTF
*
      END

C
C	$Id: markl.f,v 1.6 2008-07-27 00:23:04 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MARKL (MX1,MY1,MX2,MY2)
C
C MARKL MARKS A LINE FROM POINT (MX1,MY1) TO POINT (MX2,MY2) IN THE
C MODEL PICTURE.
C
C ***********************************
C
C NOTE: LINES OF LENGTH LESS OR EQUAL 2 ARE NOT MARKED.
C       THE VERY FIRST POINT OF A LINE IS NOT MARKED, BUT IT WAS
C        MARKED WITH THE PRECEEDING LINE SEGMENT.
C
C ***********************************
C
C ISKIP IS USED TO ADJUST DASHSUPR TO THE SIZE OF THE MODEL PICTURE AS
C DEFINED IN THE SUBROUTINE REMOVE. ISKIP IS INITIALIZED IN DASHBDX.
C
      COMMON /DSUP1/ ISKIP
C
      LOGICAL LDUMMY
      SAVE
C
      DATA LDUMMY /.TRUE./
C
      DX = MX2-MX1
      DY = MY2-MY1
      IF (ABS(DX)-ABS(DY)) 60,50,10
C
C DX IS LONGER THAN DY.
C
   10 SLOPE = DY/DX
      IF (DX .LT. 0.) GO TO 30
      MX1S = MX1+2*ISKIP
      MX2S = MX2-1*ISKIP
      IF (MX1S .GT. MX2S) RETURN
C
      DO 20 MX=MX1S,MX2S,ISKIP
         MY = INT(REAL(MY1)+REAL(MX-MX1)*SLOPE+.5)
         CALL REMOVE (MX,MY,LDUMMY,2)
   20 CONTINUE
      RETURN
C
   30 MX1S = MX1-2*ISKIP
      MX2S = MX2+1*ISKIP
      IF (MX1S .LT. MX2S) RETURN
      DO 40 MX=MX2S,MX1S,ISKIP
         MY = INT(REAL(MY2)+REAL(MX-MX2)*SLOPE+.5)
         CALL REMOVE (MX,MY,LDUMMY,2)
   40 CONTINUE
      RETURN
C
C DX AND DY HAVE SAME LENGTH.
C
   50 IF (DX .NE. 0.) GO TO 10
      CALL REMOVE (MX2,MY2,LDUMMY,2)
      RETURN
C
C DY IS LONGER THAN DX.
C
   60 SLOPE = DX/DY
      IF (DY .LT. 0.) GO TO 80
      MY1S = MY1+2*ISKIP
      MY2S = MY2-1*ISKIP
      IF (MY1S .GT. MY2S) RETURN
C
      DO 70 MY=MY1S,MY2S,ISKIP
         MX = INT(REAL(MX1)+REAL(MY-MY1)*SLOPE+.5)
         CALL REMOVE (MX,MY,LDUMMY,2)
   70 CONTINUE
      RETURN
C
   80 MY1S = MY1-2*ISKIP
      MY2S = MY2+1*ISKIP
      IF (MY1S .LT. MY2S) RETURN
C
      DO 90 MY=MY2S,MY1S,ISKIP
         MX = INT(REAL(MX2)+REAL(MY-MY2)*SLOPE+.5)
         CALL REMOVE (MX,MY,LDUMMY,2)
   90 CONTINUE
C
      RETURN
      END

C
C $Id: dpline.f,v 1.6 2008-07-27 00:16:59 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE DPLINE (XCP1,YCP1,XCP2,YCP2)
C
C Given the user coordinates of the two points (XCP1,YCP1) and
C (XCP2,YCP2), this routine just draws a straight line connecting
C them.
C
C Declare the real/integer common block.
C
        COMMON /DPCMRI/ ANGF,DBPI,EPSI,IDPI,IDPS,ILTL,INDP,IPCF,ISBF,
     +                  ISCF,LCDP,RLS1,RLS2,RMFS,TENS,WCHR,WGAP,WSLD
        SAVE   /DPCMRI/
C
C Check for an uncleared prior error.
C
        IF (ICFELL('DPLINE - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C Just draw a line connecting two points.  Such lines are never
C smoothed.
C
        XTMP=CUFX(XCP1)
        IF (ICFELL('DPLINE',2).NE.0) RETURN
C
        YTMP=CUFY(YCP1)
        IF (ICFELL('DPLINE',3).NE.0) RETURN
C
        CALL DPDRAW (XTMP,YTMP,0)
        IF (ICFELL('DPLINE',4).NE.0) RETURN
C
        XTMP=CUFX(XCP2)
        IF (ICFELL('DPLINE',5).NE.0) RETURN
C
        YTMP=CUFY(YCP2)
        IF (ICFELL('DPLINE',6).NE.0) RETURN
C
        CALL DPDRAW (XTMP,YTMP,1)
        IF (ICFELL('DPLINE',7).NE.0) RETURN
C
        CALL DPDRAW (0.,0.,2)
        IF (ICFELL('DPLINE',8).NE.0) RETURN
C
C Done.
C
        RETURN
C
      END

      PROGRAM FTEX06
C
C  Example of SURF1/SURF2.
C
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
      PARAMETER (NXI=11,NYI=17,NXO=31,NYO=21,IDTEMP=2*NYI+NXI)
C
      DIMENSION X(NXI),Y(NYI),Z(NXI,NYI)
      DIMENSION ZX1(NYI),ZXM(NYI),ZY1(NXI),ZYN(NXI)
      DIMENSION ZP(NXI,NYI,3),TEMP(IDTEMP)
      DIMENSION XO(NXO),YO(NYO),ZO(NXO,NYO)
C
C Declare a function ZF(U,V) that defines a surface.
C
      ZF(U,V)=.5+.25*SIN(-7.*U)+.25*COS(5.*V)
C
C Define the surface to be drawn.
C
      DO 104 I=1,NXI
         X(I) = REAL(I-1)/REAL(NXI-1)
         DO 103 J=1,NYI
            Y(J) = REAL(J-1)/REAL(NYI-1)
            Z(I,J)=ZF(X(I),Y(J))
 103     CONTINUE
 104  CONTINUE
C
C  Do SURF1 set up.
C
      SIGMA = 1.
      ISF   = 255
      CALL SURF1(NXI,NYI,X,Y,Z,NXI,ZX1,ZXM,ZY1,ZYN,
     +           ZXY11,ZXYM1,ZXY1N,ZXYMN,ISF,ZP,TEMP,SIGMA,IERR)
      IF (IERR .NE. 0) THEN
        PRINT *, 'Error return from SURF =',IERR
        STOP
      ENDIF
C
C  Get interpolated points using SURF2.
C
      TINCX = 1.0/(NXO-1)
      TINCY = 1.0/(NYO-1)
      DO 20 I=1,NXO
        XO(I) = (I-1)*TINCX
        DO 10 J=1,NYO
          YO(J) = (J-1)*TINCY
          ZO(I,J) = SURF2(XO(I),YO(J),NXI,NYI,X,Y,Z,NXI,ZP,SIGMA)
   10   CONTINUE
   20 CONTINUE
C
C  Plot a surface.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
      CALL TDEZ2D(NXO, NYO, XO, YO, ZO, 3., 36., 67., -6)
      CALL FRAME()
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END

        PROGRAM FSFSGFA

        PARAMETER (MREG=50,NREG=50)
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      REAL XREG(MREG),YREG(NREG),ZREG(MREG,NREG)
C
C Get data array
C
      CALL GETDAT(XREG,YREG,ZREG,MREG,NREG)
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Call Conpack color fill routine
C
      CALL CSFILL(ZREG,MREG,NREG,-15,IWKID)
C
C Close frame and close GKS
C
      CALL FRAME
C
C Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS

      STOP
      END

      SUBROUTINE CSFILL(ZREG,MREG,NREG,NCL,IWKID)

      PARAMETER (LRWK=5000,LIWK=5000,LMAP=50000,NWRK=5000,NOGRPS=5)
      REAL ZREG(MREG,NREG),RWRK(LRWK), XWRK(NWRK), YWRK(NWRK)
      INTEGER MREG,NREG,IWRK(LIWK)
      INTEGER MAP(LMAP),IAREA(NOGRPS),IGRP(NOGRPS)
      
      EXTERNAL SFILL
C
C Set up color table
C
      CALL COLOR (IWKID)
C
C First draw B&W plot to left
C
      CALL CPSETR('VPL - VIEWPORT LEFT',0.)
      CALL CPSETR('VPR - VIEWPORT RIGHT',.49)
C
C Set number of contour levels and initialize Conpack
C
      CALL CPSETI('CLS - CONTOUR LEVEL SELECTION FLAG',NCL)
      CALL CPRECT(ZREG, MREG, MREG, NREG, RWRK, LRWK, IWRK, LIWK)
C
C Set up B&W fill options
C
      CALL SFSETI('TY - TYPE OF FILL',-4)
C
C Draw Perimeter
C
      CALL CPBACK(ZREG, RWRK, IWRK)
C
C Initialize Areas
C
      CALL ARINAM(MAP, LMAP)
C
C Add contours to area map
C
      CALL CPCLAM(ZREG, RWRK, IWRK, MAP)
C
C Fill contours
C
      CALL ARSCAM(MAP, XWRK, YWRK, NWRK, IAREA, IGRP, NOGRPS, SFILL)
C
C Draw contours, masking label boxes
C
      CALL GSPLCI(0)
      CALL CPCLDR(ZREG, RWRK, IWRK)
      CALL GSPLCI(1)
C
C Second draw color plot to left
C
      CALL CPSETR('VPL - VIEWPORT LEFT',.51)
      CALL CPSETR('VPR - VIEWPORT RIGHT',1.)
      CALL CPRECT(ZREG, MREG, MREG, NREG, RWRK, LRWK, IWRK, LIWK)
C
C Set up color fill options
C
      CALL GSFAIS(1)
      CALL SFSETI('TY - TYPE OF FILL',0)
C
C Draw Perimeter
C
      CALL CPBACK(ZREG, RWRK, IWRK)
C
C Initialize Areas
C
      CALL ARINAM(MAP, LMAP)
C
C Add contours to area map
C
      CALL CPCLAM(ZREG, RWRK, IWRK, MAP)
C     
C Fill contours
C
      CALL ARSCAM(MAP, XWRK, YWRK, NWRK, IAREA, IGRP, NOGRPS, SFILL)
C     
C Draw contours, masking label boxes
C
      CALL GSPLCI(0)
      CALL CPCLDR(ZREG, RWRK, IWRK)
      RETURN
      END
      
      SUBROUTINE SFILL (XWRK,YWRK,NWRK,IAREA,IGRP,NGRPS)
C
      REAL XWRK(*),YWRK(*),ISCR(5000)
      INTEGER IAREA(*),IGRP(*),RSCR(5000)

      DO 10, I=1,NGRPS
         IF (IGRP(I).EQ.3) IAREA3=IAREA(I)
 10   CONTINUE

      IF (IAREA3 .GE. 1) THEN
C
C If the area is defined by 3 or more points, fill it
C
         CALL SFSGFA(XWRK,YWRK,NWRK,RSCR,5000,ISCR,5000,IAREA3+1)
      ENDIF
C
C Otherwise, do nothing
C
      RETURN
      END

      SUBROUTINE GETDAT(XREG,YREG,ZREG,MREG,NREG)

      PARAMETER (NRAN=30,LRWK=5000,LIWK=5000)
      REAL XRAN(NRAN), YRAN(NRAN), ZRAN(NRAN)
      REAL XREG(MREG), YREG(NREG), ZREG(MREG,NREG), RWRK(LRWK)
      INTEGER IWRK(LIWK)
      
      DATA XRAN /12., 60., 14., 33.,  8., 12., 43., 57., 22., 15.,
     1     19., 12., 64., 19., 15., 55., 31., 32., 33., 29.,
     2     18.,  1., 18., 42., 56.,  9.,  6., 12., 44., 19./
      DATA YRAN / 1.,  2.,  3., 53.,  7., 11., 13., 17., 19., 49.,
     1     1., 31., 37.,  5.,  7., 47., 61., 17.,  5., 23.,
     2     29.,  3.,  5., 41., 43.,  9., 13., 59.,  1., 67./
      DATA ZRAN /1.0, 1.5, 1.7, 1.4, 1.9, 1.0, 1.5, 1.2, 1.8, 1.4,
     1     1.8, 1.7, 1.9, 1.5, 1.2, 1.1, 1.3, 1.7, 1.2, 1.6,
     2     1.9, 1.0, 1.6, 1.3, 1.4, 1.8, 1.7, 1.5, 1.1, 1.0/
C
C  Set the min and max data values.
C
      XMIN = 0.0
      XMAX = 65.0
      YMIN =  0.0
      YMAX = 68.0
C
C Choose the X and Y coordinates for interpolation points on the 
C regular grid.
C
      DO 101 I=1,MREG
         XREG(I)=XMIN + (XMAX - XMIN)* REAL(I-1)/MREG
 101  CONTINUE
C
      DO 102 I=1,NREG
         YREG(I)=YMIN + (YMAX - YMIN)* REAL(I-1)/NREG
 102  CONTINUE
C
C Interpolate data onto a regular grid
C
      CALL IDSFFT (1,NRAN,XRAN,YRAN,ZRAN,
     +     MREG,NREG,MREG,XREG,YREG,ZREG,IWRK,RWRK)
      
      RETURN
      END

      SUBROUTINE COLOR (IWKID)
C
C BACKGROUND COLOR
C BLACK
C
      CALL GSCR(IWKID,0,0.,0.,0.)
C
C FORGROUND COLORS
C White
C
      CALL GSCR(IWKID,  1, 1.0, 1.0, 1.0)
C 
      CALL GSCR(IWKID,  2, 0.85, 0.45, 0.4)
C
C Red
C
      CALL GSCR(IWKID,  3, 0.9, 0.25, 0.0)
C
C OrangeRed
C
      CALL GSCR(IWKID,  4, 1.0, 0.0, 0.2)
C
C Orange
C
      CALL GSCR(IWKID,  5, 1.0, 0.65, 0.0)
C
C Gold
C
      CALL GSCR(IWKID,  6, 1.0, 0.85, 0.0)
C
C Yellow
C
      CALL GSCR(IWKID,  7, 1.0, 1.0, 0.0)
C
C GreenYellow
C
      CALL GSCR(IWKID,  8, 0.7, 1.0, 0.2)
C
C Chartreuse
C
      CALL GSCR(IWKID,  9, 0.5, 1.0, 0.0)
C
C Green
C
      CALL GSCR(IWKID, 10, 0.2, 0.8, 0.2)
C
C Celeste
C
      CALL GSCR(IWKID, 11, 0.2, 1.0, 0.7)
C
C Aqua
C
      CALL GSCR(IWKID, 12, 0.0, 0.9, 1.0)
C
C DeepSkyBlue
C
      CALL GSCR(IWKID, 13, 0.0, 0.75, 1.0)
C
C RoyalBlue
C
      CALL GSCR(IWKID, 14, 0.25, 0.45, 0.95)
C
C SlateBlue
C
      CALL GSCR(IWKID, 15, 0.4, 0.35, 0.8)
C
C DarkViolet
C
      CALL GSCR(IWKID, 16, 0.6, 0.0, 0.8)
C
C Lavender
C
      CALL GSCR(IWKID, 17, 0.8, 0.8, 1.0)
C
C Sienna
C
      CALL GSCR(IWKID, 18, 0.63, 0.32, 0.18)
C
C Done.
C
        RETURN
C
      END

C
C $Id: tdstrs.f,v 1.5 2008-07-27 00:17:33 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE TDSTRS (IRST,IA01,IA02,IA03,IA04,IA05,IA06,IA07,RA08,
     +                                                      RA09,RA10)
C
C This routine allows the caller to set the values defining a particular
C rendering style.  The arguments are as follows (all are input, those
C beginning with an "I" are of type INTEGER, those beginning with an "R"
C are of type "REAL"):
C
C   IRST is the index of the rendering style for which values are to
C   be set and should be in the range from 1 to 64, inclusive.
C
C   IA01 and IA02 are color indices specifying a range of colors to be
C   used for the "bottom" side of a surface (where function values are
C   less than the value on the surface).  If IA01 is negative, filling
C   of triangles seen from the "bottom" is turned off.  If IA01 is zero
C   or greater, but IA02 is less than or equal to it, the color with
C   index IA01 is used.  If IA01 is zero or greater and IA02 is greater
C   than IA01, then a range of color indices is specified; colors near
C   the beginning of that range are used for triangles that are nearly
C   perpendicular to the line of sight, while colors near the end of
C   that range are used for triangles more nearly parallel to the line
C   of sight.
C
C   IA03 and IA04 are color indices specifying a range of colors to be
C   used for the "top" side of a surface (with function values greater
C   than the value in the surface).  If IA03 is negative, filling
C   of triangles seen from the "top" is turned off.  If IA03 is zero
C   or greater, but IA04 is less than or equal to it, the color with
C   index IA03 is used.  If IA03 is zero or greater and IA04 is greater
C   than IA03, then a range of color indices is specified; colors near
C   the beginning of that range are used for triangles that are nearly
C   perpendicular to the line of sight, while colors near the end of
C   that range are used for triangles more nearly parallel to the line
C   of sight.
C
C   IA05 is the color index specifying a color to be used for lines
C   drawn on the "bottom" side of a surface.  If IA05 is negative, the
C   drawing of these lines is turned off.
C
C   IA06 is the color index specifying a color to be used for lines
C   drawn on the "top" side of a surface.  If IA06 is negative, the
C   drawing of these lines is turned off.
C
C   IA07 is a flag, which, if set non-zero, turns on the drawing of
C   the boundaries of the individual triangles into which surfaces
C   have been decomposed.
C
C   RA08, RA09, and RA10 are the distances between slices in the U, V,
C   and W directions, respectively.
C
C Declare a necessary TDPACK common block.
C
        COMMON /TDCOM3/ IFC1(64),IFC2(64),IFC3(64),IFC4(64),ILC1(64)
        COMMON /TDCOM3/ ILC2(64),ILTD(64),USTP(64),VSTP(64),WSTP(64)
        SAVE   /TDCOM3/
C
C Copy the values into common.
C
        INDX=MAX(1,MIN(64,IRST))
        IFC1(INDX)=IA01
        IFC2(INDX)=IA02
        IFC3(INDX)=IA03
        IFC4(INDX)=IA04
        ILC1(INDX)=IA05
        ILC2(INDX)=IA06
        ILTD(INDX)=IA07
        USTP(INDX)=RA08
        VSTP(INDX)=RA09
        WSTP(INDX)=RA10
C
C Done.
C
        RETURN
C
      END

C
C       $Id: ezstrm.f,v 1.8 2008-07-27 00:17:27 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE EZSTRM(U,V,WORK,IMAX,JMAX)
C
      DIMENSION U(IMAX,JMAX), V(IMAX,JMAX), WORK(1)
C
      CALL STRMLN(U,V,WORK,IMAX,IMAX,JMAX,0,IER)
C
      RETURN
      END

C
C $Id: kurvpd.f,v 1.5 2008-07-27 03:10:12 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
C NOTE: If you make any changes to this software, please remember to
C make the same changes to the corresponding double precision routine.
C
      subroutine kurvpd (t,xs,ys,xst,yst,xstt,ystt,n,x,y,xp,
     *                  yp,s,sigma)
c
      integer n
      real t,xs,ys,xst,yst,xstt,ystt,x(n),y(n),xp(n),yp(n),
     *     s(n),sigma
c
c                                 coded by alan kaylor cline
c                           from fitpack -- january 26, 1987
c                        a curve and surface fitting package
c                      a product of pleasant valley software
c                  8603 altus cove, austin, texas 78759, usa
c
c this subroutine performs the mapping of points in the
c interval (0.,1.) onto a closed curve in the plane. it also
c returns the first and second derivatives of the component
c functions. the subroutine kurvp1 should be called earlier
c to determine certain necessary parameters. the resulting
c curve has a parametric representation both of whose
c components are periodic splines under tension and
c functions of the polygonal arclength parameter.
c
c on input--
c
c   t contains a value to be mapped onto the curve. the
c   interval (0.,1.) is mapped onto the entire closed curve
c   with both 0. and 1. mapping to (x(1),y(1)). the mapping
c   is periodic with period one thus any interval of the
c   form (tt,tt+1.) maps onto the entire curve.
c
c   n contains the number of points which were specified
c   to determine the curve.
c
c   x and y are arrays containing the x- and y-coordinates
c   of the specified points.
c
c   xp and yp are the arrays output from kurvp1 containing
c   curvature information.
c
c   s is an array containing the polygonal arclengths of
c   the curve.
c
c and
c
c   sigma contains the tension factor (its sign is ignored).
c
c the parameters n, x, y, xp, yp, s and sigma should
c be input unaltered from the output of kurvp1.
c
c on output--
c
c   xs and ys contain the x- and y-coordinates of the image
c   point on the curve. xst and yst contain the first
c   derivatives of the x- and y-components of the mapping
c   with respect to t. xstt and ystt contain the second
c   derivatives of the x- and y-components of the mapping
c   with respect to t.
c
c none of the input parameters are altered.
c
c this subroutine references package modules intrvl and
c snhcsh.
c
c-----------------------------------------------------------
c
c determine interval
c
      tn = t-float(ifix(t))
      if (tn .lt. 0.) tn = tn+1.
      tn = s(n)*tn+s(1)
      im1 = n
      if (tn .lt. s(n)) im1 = intrvl(tn,s,n)
      i = im1+1
      if (i .gt. n) i = 1
c
c denormalize tension factor
c
      sigmap = abs(sigma)*float(n)/s(n)
c
c set up and perform interpolation
c
      si = s(i)
      if (im1 .eq. n) si = s(n)+s(1)
      del1 = tn-s(im1)
      del2 = si-tn
      dels = si-s(im1)
      sumx = (x(i)*del1+x(im1)*del2)/dels
      sumy = (y(i)*del1+y(im1)*del2)/dels
      sumxt = s(n)*(x(i)-x(im1))/dels
      sumyt = s(n)*(y(i)-y(im1))/dels
      if (sigmap .ne. 0.) go to 1
      dels6 = 6.*dels
      d = del1*del2/dels6
      c1 = -(del1+dels)*d
      c2 = -(del2+dels)*d
      dels6 = dels6/s(n)
      ct1 = (2.*del1*del1-del2*(del1+dels))/dels6
      ct2 = -(2.*del2*del2-del1*(del2+dels))/dels6
      dels = dels/(s(n)*s(n))
      ctt1 = del1/dels
      ctt2 = del2/dels
      go to 2
    1 sigdel = sigmap*dels
      call snhcsh (ss,dummy,sigdel,-1)
      call snhcsh (s1,co1,sigmap*del1,0)
      call snhcsh (s2,co2,sigmap*del2,0)
      d = sigdel*sigmap*(1.+ss)
      c1 = del1*(s1-ss)/d
      c2 = del2*(s2-ss)/d
      ct1 = (co1-ss)*s(n)/d
      ct2 = -(co2-ss)*s(n)/d
      ctt1 = del1*(1.+s1)*s(n)*s(n)/(dels*(1.+ss))
      ctt2 = del2*(1.+s2)*s(n)*s(n)/(dels*(1.+ss))
    2 xs = sumx+c1*xp(i)+c2*xp(im1)
      ys = sumy+c1*yp(i)+c2*yp(im1)
      xst = sumxt+ct1*xp(i)+ct2*xp(im1)
      yst = sumyt+ct1*yp(i)+ct2*yp(im1)
      xstt = ctt1*xp(i)+ctt2*xp(im1)
      ystt = ctt1*yp(i)+ctt2*yp(im1)
      return
      end

C NCLFORTSTART
      subroutine omcalcccm(u     ,v    ,d    
     +                     ,dpsl ,dpsm  ,pmid ,pdel  
     +                     ,psfc ,hybd  ,hybm ,nprlev
     +                     ,omega,ilon  ,jlat ,klev )
      implicit none

c NCL: omega = omega_ccm (u     ,v    ,div         \
c                        ,dpsl ,dpsm  ,pmid ,pdel  \
c                        ,psfc ,hybd  ,hybm ,nprlev)
c
c-----------------------------------------------------------------------
c >>>> Andy Mai modified omcalc.f90 from the CAM3.0_p1 code to add
c      latitude and time dimensions.
c >>>> Dennis Shea dumbed it down to f77 and removed the "time"
c      dimension to minimize the size of the u/v arrays.  The
c      interface will loop thru the time steps.
c-----------------------------------------------------------------------
c
c Purpose:
c Calculate vertical pressure velocity (omega = dp/dt)
c
c Method:
c First evaluate the expressions for omega/p, then rescale to omega at
c the end.
c
c Author: CCM1
c-----------------------------------------------------------------------
c $Id: omcalc_ccm.f,v 1.1 2005-09-28 00:31:44 haley Exp $
c $Author: haley $
c
c------------------------------Arguments--------------------------------
c nomenclature
c .   u       - zonal wind
c .   v       - meridional wind
c .   d       - divergence
c .   dpsl    - longitudinal component of grad ln(ps)
c .   dpsm    - latitudinal component of grad ln(ps)
c .   pmid    - mid-level pressures
c .   pdel    - layer thicknesses (pressure)
c .   psfc    - bottom interface pressure ["pbot" in origial code]
c .   hybd    - hybi(k+1)-hybi(k)
c .   hybm    - mid-level hybrid coefficients
c .   nprlev  - first pure pressure level
c .
c .   omega   - vertical pressure velocity  [OUTPUT]
c-----------------------------------------------------------------------
C                                             ! input
      integer          ilon   ,jlat   ,klev   ,nprlev

      double precision d(ilon,jlat,klev)
      double precision u(ilon,jlat,klev)
      double precision v(ilon,jlat,klev)
      double precision pmid(ilon,jlat,klev)
      double precision pdel(ilon,jlat,klev)

      double precision psfc(ilon,jlat)
      double precision dpsl(ilon,jlat)
      double precision dpsm(ilon,jlat)

      double precision hybd(klev)
      double precision hybm(klev)
C                                             ! output
      double precision omega(ilon,jlat,klev)
C NCLEND
c-----------------------------------------------------------------------

c---------------------------Local workspace-----------------------------
c .   hkk     - diagonal element of hydrostatic matrix
c .   hlk     - super diagonal element
c .   suml    - partial sum over l = (1, k-1)
c .   vgpk    - v dot grad ps
c .   tmp     - vector temporary
c-------------------------- Automatic arrays----------------------------
      double precision hkk(ilon,jlat)
      double precision hlk(ilon,jlat)
      double precision suml(ilon,jlat)
      double precision rpmid(ilon,jlat,klev)
      double precision vgpk
      double precision tmp
c-----------------------------------------------------------------------
c     i,j,k - longitude, latitude, level indices
      integer  i,j,k

c
c Zero partial sum
c
        do j=1,jlat
          do i=1,ilon
             suml(i,j) = 0.d0
          end do
        end do
c
c calculate inverse [no need to check for 0.0]
c
      do k=1,klev
        do j=1,jlat
          do i=1,ilon
            rpmid(i,j,k) = 1.d0/pmid(i,j,k)
          end do
        end do
      end do
c
c Pure pressure part: top level
c
        do j=1,jlat
          do i=1,ilon
            hkk(i,j)     = 0.5*rpmid(i,j,1)
            omega(i,j,1) = -hkk(i,j)*d(i,j,1)*pdel(i,j,1)
            suml(i,j)    = suml(i,j) + d(i,j,1)*pdel(i,j,1)
          end do
        end do
c
c sum(k)(v(j)*ps*grad(lnps)*db(j)) part. Not normally invoked since
c the top layer is normally a pure pressure layer.
c
      if (1.ge.nprlev) then
            do j=1,jlat
              do i=1,ilon
                vgpk = (u(i,j,1)*dpsl(i,j)
     +                + v(i,j,1)*dpsm(i,j))*psfc(i,j)
                tmp = vgpk*hybd(1)
                omega(i,j,1) = omega(i,j,1)
     +                         + hybm(1)*rpmid(i,j,1)*vgpk
     +                         - hkk(i,j)*tmp
                suml(i,j) = suml(i,j) + tmp
              end do
            end do
      end if
c
c Integrals to level above bottom
c
      do k=2,klev-1
c
c Pure pressure part
c
          do j=1,jlat
            do i=1,ilon
              hkk(i,j)     = 0.5*rpmid(i,j,k)
              hlk(i,j)     =     rpmid(i,j,k)
              omega(i,j,k) = -hkk(i,j)*d(i,j,k)*pdel(i,j,k)
     +                        - hlk(i,j)*suml(i,j)
              suml(i,j)    = suml(i,j) + d(i,j,k)*pdel(i,j,k)
            end do
          end do
c
c v(j)*grad(lnps) part
c
        if (k.ge.nprlev) then
              do j=1,jlat
                do i=1,ilon
                  vgpk         = (u(i,j,k)*dpsl(i,j)
     +                         + v(i,j,k)*dpsm(i,j))*psfc(i,j)
                  tmp          = vgpk*hybd(k)
                  omega(i,j,k) = omega(i,j,k)
     +                         + hybm(k)*rpmid(i,j,k)*vgpk
     +                         - hkk(i,j)*tmp
                  suml(i,j)    = suml(i,j) + tmp
                end do
              end do
        end if

      end do
c
c Pure pressure part: bottom level
c
        do j=1,jlat
          do i=1,ilon
             hkk(i,j) = 0.5*rpmid(i,j,klev)
             hlk(i,j) =     rpmid(i,j,klev)
             omega(i,j,klev) =
     +           - hkk(i,j)*d(i,j,klev)*pdel(i,j,klev)
     +           - hlk(i,j)*suml(i,j)
          end do
        end do
c
c v(j)*grad(lnps) part. Normally invoked, but omitted if the model is
c running in pure pressure coordinates throughout (e.g. stratospheric
c mechanistic model).
c
      if (klev.ge.nprlev) then
          do j=1,jlat
            do i=1,ilon
              vgpk = (u(i,j,klev)*dpsl(i,j)
     +              + v(i,j,klev)*dpsm(i,j))* psfc(i,j)
              omega(i,j,klev) = omega(i,j,klev)
     +                          + hybm(klev)*rpmid(i,j,klev)*vgpk
     +                          - hkk(i,j)*vgpk*hybd(klev)
            end do
          end do
      end if
c
c The above expressions give omega/p. Rescale to omega.
c
        do k=1,klev
          do j=1,jlat
            do i=1,ilon
               omega(i,j,k) = omega(i,j,k)*pmid(i,j,k)
            end do
          end do
        end do

      return
      end

C
C       $Id: myf.f,v 1.6 2008-07-27 00:17:34 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      FUNCTION MYF(X,Y,U,V,SFX,SFY,MX,MY)
C
C
C The mapping common block: made available to user mapping routines
C
      COMMON /VVMAP/
     +                IMAP       ,
     +                XVPL       ,XVPR       ,YVPB       ,YVPT       ,
     +                WXMN       ,WXMX       ,WYMN       ,WYMX       ,
     +                XLOV       ,XHIV       ,YLOV       ,YHIV       ,
     +                SXDC       ,SYDC       ,NXCT       ,NYCT       ,
     +                RLEN       ,LNLG       ,INVX       ,INVY       ,
     +                ITRT       ,IWCT       ,FW2W       ,FH2H       ,
     +                DVMN       ,DVMX       ,RBIG       ,IBIG
C
      SAVE /VVMAP/
C
C Math constants
C
      PARAMETER (PDTOR  = 0.017453292519943,
     +           PRTOD  = 57.2957795130823,
     +           P1XPI  = 3.14159265358979,
     +           P2XPI  = 6.28318530717959,
     +           P1D2PI = 1.57079632679489,
     +           P5D2PI = 7.85398163397448) 
C
C --------------------------------------------------------------------
C
      PARAMETER (PRCFAC=1E5,
     +           PVFRAC=0.001,
     +           PFOVFL=1E12,
     +           IPMXCT=10,
     +           PDUVML=2.0)
C
C
C     The function FY behaves in an analagous manner to FX as
C     described above.
C
      GOTO (10,20,30)  IMAP+1
C
C     The identity transformation.
C
10    CONTINUE
      MYF = MY + INT(SFY * V)
      RETURN
C
C     EZMAP overlaying.
C
20    CONTINUE
C
      UVLEN=SQRT(U**2+V**2)
C
C
C Check the vector magnitude
C
      IF (INT(UVLEN*PRCFAC) .EQ. 0) THEN
         MYF=IBIG
         RETURN
      END IF
C
      CLMT=PVFRAC/UVLEN
C
      XLON = XLOV + (X-1.)*(XHIV-XLOV)/(REAL(NXCT)-1.)
      YLAT = YLOV + (Y-1.)*(YHIV-YLOV)/(REAL(NYCT)-1.)
C
      CFCT=COS(YLAT*PDTOR)
      ICNT = 0
      ISGN = 1
C
      CALL MAPTRN(YLAT,XLON,X1,Y1)
C
 35   CONTINUE
      CALL MAPTRN(YLAT + ISGN*CLMT*V,XLON + ISGN*CLMT*U/CFCT,X2,Y2)

      VCLEN=SQRT((X2-X1)**2+(Y2-Y1)**2)
C
      IF (VCLEN .GT. RLEN) THEN
         IF (ISGN .EQ. -1) THEN
            MYF=IBIG
            RETURN
         ELSE
            ISGN=-1
            GO TO 35
         END IF
      ELSE IF (INT(VCLEN*PRCFAC) .EQ. 0) THEN
         IF (ICNT .LT. 10) THEN
            ICNT = ICNT + 1
            CLMT = CLMT * 2.0
            GO TO 35
         ELSE
            MYF = IBIG
            RETURN
         END IF
      END IF
C
      IF (ABS(Y2) .GE. PFOVFL) THEN
         MYF = IBIG
         RETURN
      END IF
C
      T=ISGN*((Y2-Y1)/VCLEN)*UVLEN
C
      MYF=MY+INT(SFY*T)
      RETURN
C
30    CONTINUE
C
C     Polar coordinate transformation.
C
      WRITE(*,*) 'Polar mapping not implemented in this version of MYF'
C
      RETURN
      END

C
C $Id: lnbpcs.f,v 1.4 2008-07-27 00:17:31 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      FUNCTION LNBPCS (CHRS)
C
        CHARACTER*(*) CHRS
C
C The value of LNBPCS(CHRS), where CHRS is a character string of
C arbitrary length starting with a non-blank, is the position of
C the last character in CHRS which is non-blank (the "Length of
C the Non-Blank Portion of the Character String").  For an all-blank
C string, the value 1 is returned.
C
        NCHS=LEN(CHRS)
C
        DO 101 I=NCHS,1,-1
          IF (CHRS(I:I).NE.' ') THEN
            LNBPCS=I
            RETURN
          END IF
  101   CONTINUE
C
        LNBPCS=1
C
C Done.
C
        RETURN
C
      END

C
C $Id: pcsetr.f,v 1.16 2008-07-27 00:17:20 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE PCSETR (WHCH,RVAL)
C
      CHARACTER*(*) WHCH
C
C The subroutine PCSETR may be used to set PLCHHQ parameters which have
C values of type REAL.
C
C COMMON block declarations.
C
      COMMON /PCPRMS/ ADDS,CONS,DSTB,DSTL,DSTR,DSTT,HPIC(3),IBNU,
     +                IBXC(3),IBXF,ICEN,IORD,IOUC,IOUF,IPCC,IQUF,
     +                ISHC,ISHF,ITEF,JCOD,LSCI(16),NFCC,NODF,RBXL,
     +                RBXM,RBXX,RBXY,ROLW,RPLW,RSLW,SHDX,SHDY,SIZA,
     +                SSIC,SSPR,SUBS,VPIC(3),WPIC(3),XBEG,XCEN,XEND,
     +                XMUL(3),YBEG,YCEN,YEND,YMUL(3),ZINX,ZINY,ZINZ
      SAVE   /PCPRMS/
C
      COMMON /PCPFLQ/ IMAP,OORV,RHTW
      SAVE   /PCPFLQ/
C
C Do a call forcing a BLOCKDATA to be loaded from a binary library.
C
      CALL PCBLDA
C
C Check for an uncleared prior error.
C
      IF (ICFELL('PCSETR - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C Set the selected parameter.
C
      IF      (WHCH(1:2).EQ.'AS'.OR.WHCH(1:2).EQ.'as') THEN
        ADDS=RVAL
      ELSE IF (WHCH(1:2).EQ.'BC'.OR.WHCH(1:2).EQ.'bc') THEN
        CALL PCGPAI (WHCH,3,IPAI)
        IF (IPAI.EQ.0) THEN
          IBXC(1)=INT(RVAL)
        ELSE IF (IPAI.GE.1.AND.IPAI.LE.3) THEN
          IBXC(IPAI)=INT(RVAL)
        ELSE
          CALL SETER ('PCSETR - BOX COLOR ARRAY INDEX IS OUT OF RANGE',
     +                                                             2,1)
          RETURN
        END IF
      ELSE IF (WHCH(1:2).EQ.'BF'.OR.WHCH(1:2).EQ.'bf') THEN
        IBXF=INT(RVAL)
      ELSE IF (WHCH(1:2).EQ.'BL'.OR.WHCH(1:2).EQ.'bl') THEN
        RBXL=RVAL
      ELSE IF (WHCH(1:2).EQ.'BM'.OR.WHCH(1:2).EQ.'bm') THEN
        RBXM=RVAL
      ELSE IF (WHCH(1:2).EQ.'BX'.OR.WHCH(1:2).EQ.'bx') THEN
        RBXX=RVAL
      ELSE IF (WHCH(1:2).EQ.'BY'.OR.WHCH(1:2).EQ.'by') THEN
        RBXY=RVAL
      ELSE IF (WHCH(1:2).EQ.'CC'.OR.WHCH(1:2).EQ.'cc') THEN
        CALL PCGPAI (WHCH,3,IPAI)
        IF (IPAI.EQ.0) THEN
          IPCC=INT(RVAL)
        ELSE IF (IPAI.GE.1.AND.IPAI.LE.16) THEN
          LSCI(IPAI)=INT(RVAL)
        ELSE
          CALL SETER ('PCSETR - COLOR ARRAY INDEX IS OUT OF RANGE',3,1)
          RETURN
        END IF
      ELSE IF (WHCH(1:2).EQ.'CD'.OR.WHCH(1:2).EQ.'cd') THEN
        JCOD=MAX(0,MIN(1,INT(RVAL)))
      ELSE IF (WHCH(1:2).EQ.'CE'.OR.WHCH(1:2).EQ.'ce') THEN
        ICEN=MAX(0,MIN(1,INT(RVAL)))
      ELSE IF (WHCH(1:2).EQ.'CH'.OR.WHCH(1:2).EQ.'ch') THEN
        HPIC(3)=MAX(0.,RVAL)
        YMUL(3)=HPIC(3)/9.
      ELSE IF (WHCH(1:2).EQ.'CL'.OR.WHCH(1:2).EQ.'cl') THEN
        RPLW=MAX(0.,RVAL)
      ELSE IF (WHCH(1:2).EQ.'CS'.OR.WHCH(1:2).EQ.'cs') THEN
        CONS=RVAL/2.
      ELSE IF (WHCH(1:2).EQ.'CV'.OR.WHCH(1:2).EQ.'cv') THEN
        VPIC(3)=MAX(0.,RVAL)
      ELSE IF (WHCH(1:2).EQ.'CW'.OR.WHCH(1:2).EQ.'cw') THEN
        WPIC(3)=MAX(0.,RVAL)
        XMUL(3)=WPIC(3)/8.
      ELSE IF (WHCH(1:2).EQ.'DO'.OR.WHCH(1:2).EQ.'do') THEN
        IORD=MAX(-2,MIN(+2,INT(RVAL)))
        IF (IORD.EQ.0) IORD=1
      ELSE IF (WHCH(1:2).EQ.'FB'.OR.WHCH(1:2).EQ.'fb') THEN
        CALL BCSETR ('FTL',RVAL)
        IF (ICFELL('PCSETR',4).NE.0) RETURN
      ELSE IF (WHCH(1:2).EQ.'FN'.OR.WHCH(1:2).EQ.'fn') THEN
        NODF=ABS(INT(RVAL))
        IF ((NODF.GE. 23.AND.NODF.LE. 24).OR.
     +      (NODF.GE. 27.AND.NODF.LE. 28).OR.
     +      (NODF.GE. 31.AND.NODF.LE. 32).OR.
     +      (NODF.GE. 38.AND.NODF.LE.120).OR.
     +      (NODF.GE.123.AND.NODF.LE.124).OR.
     +      (NODF.GE.127.AND.NODF.LE.128).OR.
     +      (NODF.GE.131.AND.NODF.LE.132).OR.NODF.GE.138) NODF=1
      ELSE IF (WHCH(1:2).EQ.'HW'.OR.WHCH(1:2).EQ.'hw') THEN
        RHTW=RVAL
      ELSE IF (WHCH(1:2).EQ.'IH'.OR.WHCH(1:2).EQ.'ih') THEN
        HPIC(2)=MAX(0.,RVAL)
        YMUL(2)=HPIC(2)/13.
      ELSE IF (WHCH(1:2).EQ.'IS'.OR.WHCH(1:2).EQ.'is') THEN
        SSIC=MAX(0.,RVAL)
      ELSE IF (WHCH(1:2).EQ.'IV'.OR.WHCH(1:2).EQ.'iv') THEN
        VPIC(2)=MAX(0.,RVAL)
      ELSE IF (WHCH(1:2).EQ.'IW'.OR.WHCH(1:2).EQ.'iw') THEN
        WPIC(2)=MAX(0.,RVAL)
        XMUL(2)=WPIC(2)/12.
      ELSE IF (WHCH(1:2).EQ.'MA'.OR.WHCH(1:2).EQ.'ma') THEN
        IMAP=MAX(0,INT(RVAL))
      ELSE IF (WHCH(1:2).EQ.'OC'.OR.WHCH(1:2).EQ.'oc') THEN
        IOUC=INT(RVAL)
      ELSE IF (WHCH(1:2).EQ.'OF'.OR.WHCH(1:2).EQ.'of') THEN
        IOUF=MAX(0,MIN(1,INT(RVAL)))
      ELSE IF (WHCH(1:2).EQ.'OL'.OR.WHCH(1:2).EQ.'ol') THEN
        ROLW=MAX(0.,RVAL)
      ELSE IF (WHCH(1:2).EQ.'OR'.OR.WHCH(1:2).EQ.'or') THEN
        OORV=RVAL
      ELSE IF (WHCH(1:2).EQ.'PH'.OR.WHCH(1:2).EQ.'ph') THEN
        HPIC(1)=MAX(0.,RVAL)
        YMUL(1)=HPIC(1)/21.
      ELSE IF (WHCH(1:2).EQ.'PS'.OR.WHCH(1:2).EQ.'ps') THEN
        SSPR=MAX(0.,RVAL)
      ELSE IF (WHCH(1:2).EQ.'PV'.OR.WHCH(1:2).EQ.'pv') THEN
        VPIC(1)=MAX(0.,RVAL)
      ELSE IF (WHCH(1:2).EQ.'PW'.OR.WHCH(1:2).EQ.'pw') THEN
        WPIC(1)=MAX(0.,RVAL)
        XMUL(1)=WPIC(1)/16.
      ELSE IF (WHCH(1:2).EQ.'QU'.OR.WHCH(1:2).EQ.'qu') THEN
        IQUF=MAX(0,MIN(2,INT(RVAL)))
      ELSE IF (WHCH(1:2).EQ.'SA'.OR.WHCH(1:2).EQ.'sa') THEN
        SIZA=MAX(0.,RVAL)
      ELSE IF (WHCH(1:2).EQ.'SC'.OR.WHCH(1:2).EQ.'sc') THEN
        ISHC=INT(RVAL)
      ELSE IF (WHCH(1:2).EQ.'SF'.OR.WHCH(1:2).EQ.'sf') THEN
        ISHF=MAX(0,MIN(1,INT(RVAL)))
      ELSE IF (WHCH(1:2).EQ.'SL'.OR.WHCH(1:2).EQ.'sl') THEN
        RSLW=MAX(0.,RVAL)
      ELSE IF (WHCH(1:2).EQ.'SS'.OR.WHCH(1:2).EQ.'ss') THEN
        SUBS=RVAL
      ELSE IF (WHCH(1:2).EQ.'SX'.OR.WHCH(1:2).EQ.'sx') THEN
        SHDX=RVAL
      ELSE IF (WHCH(1:2).EQ.'SY'.OR.WHCH(1:2).EQ.'sy') THEN
        SHDY=RVAL
      ELSE IF (WHCH(1:2).EQ.'TE'.OR.WHCH(1:2).EQ.'te') THEN
        ITEF=MAX(0,MIN(1,INT(RVAL)))
      ELSE IF (WHCH(1:2).EQ.'UN'.OR.WHCH(1:2).EQ.'un') THEN
        IBNU=MAX(1,INT(RVAL))
      ELSE IF (WHCH(1:2).EQ.'ZX'.OR.WHCH(1:2).EQ.'zx') THEN
        ZINX=MAX(0.,RVAL)
      ELSE IF (WHCH(1:2).EQ.'ZY'.OR.WHCH(1:2).EQ.'zy') THEN
        ZINY=MAX(0.,RVAL)
      ELSE IF (WHCH(1:2).EQ.'ZZ'.OR.WHCH(1:2).EQ.'zz') THEN
        ZINZ=MAX(0.,RVAL)
      ELSE
        CALL SETER ('PCSETR - UNRECOGNIZED PARAMETER NAME',5,1)
        RETURN
      END IF
C
C Done.
C
      RETURN
C
      END

C
C	$Id: creb15.f,v 1.5 2008-07-27 01:04:31 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C

      SUBROUTINE CREB15(INUNIT,IOUTUN,INNUM,ITEMP,LENTEM)
C
C ROUTINE TO STORE A SEQUENCE OF INTEGERS INTO AN ARRAY.
C
C ON ENTRY
C     INUNIT IS A FILE WHICH CONTAINS INNUM CARD IMAGES. EACH CARD
C     IMAGE CONTAINS 16 INTEGERS, EACH IN AN I5 FORMAT. EACH INTEGER
C     REPRESENTS A POSITIVE 15 BIT VALUE.
C     INUNIT CAN BE READ BY CREB15.
C     IOUTUN IS A UNIT NUMBER WHERE CREB15 CAN WRITE A RECORD.
C     IOUTUN IS ASSUMED TO BE POSITIONED RIGHT.
C     ITEMP IS AN ARRAY OF LENGTH LENTEM. ITS ELEMENTS MAY HAVE
C     ANY VALUE.
C     LENTEM MUST BE (INNUM*16-1)/NUM15+1 OR BIGGER, WHERE NUM15 IS
C     THE NUMBER OF 15 BIT UNITS WHICH FIT AS A WHOLE INTO 1 WORD.
C     INNUM IS THE NUMBER OF CARD IMAGES ON FILE INUNIT.
C ON EXIT
C     THE VALUES OF INUNIT,IOUTUN, AND INNUM ARE UNCHANGED.
C     FILE INUNIT IS REWOUND BUT OTHERWISE UNCHANGED.
C     ITEMP CONTAINS THE INTEGERS FROM FILE INUNIT STORED LEFT
C     JUSTIFIED AS 15 BIT UNITS WITH AS MANY UNITS PER WORD AS
C     POSSIBLE WITHOUT CROSSING WORD BOUNDARIES.
C     A BINARY RECORD IS WRITTEN ON UNIT IOUTUN WHICH CONTAINS THE FIRST
C     NUMOUT WORDS OF THE ARRAY ITEMP AS ONE LONG BIT STRING,
C     WHERE NUMOUT IS EXACTLY (INNUM*16-1)/NUM15+1 AND NUM15 DEFINED
C     AS ABOVE.
C CALLS
C     IAND,IOR,ISHIFT
C
      DIMENSION ITEMP(LENTEM)
C
C TEMPORARY STORAGE TO CONTAIN 1 CARD IMAGE.
      DIMENSION ICARD(16)
C
C SEE BLOCK DATA DPORTX FOR MEANING OF CONSTANTS IN COMMON BLOCK.
      COMMON /IDC1/ NBWD, IZERO, MA15
C
C
C LOCAL VARIABLES
C   IWORD - THE ENTRY IN THE ARRAY ITEMP WHICH IS CURRENTLY BEING
C           FILLED
C   IN15 - CONTAINS 15 BIT UNIT, RIGHT JUSTIFIED.
C   IIN15 - CONTAINS THE 15 BIT UNIT - OR PART OF IT - AT THE POSITION
C           WHICH IT WILL HAVE IN ITEMP(IWORD)
C   IPOS - THE NUMBER OF 15 BIT UNITS ALREADY STORED IN THE CURRENT
C          WORD + 1 .
C   ICARD - TEMPORARY STORAGE FOR 1 CARD IMAGE.
C   NUM15 - THE NUMBER OF 15 BIT UNITS WHICH FIT AS A WHOLE INTO 1 WORD.
C
C
C THE NUMBER OF 15 BIT UNITS WHICH FIT AS A WHOLE INTO ONE WORD.
C
      NUM15 = NBWD/15
C
      REWIND INUNIT
C
C
C
      IPOS = 1
      IWORD = 1
      ITEMP(1) = IZERO
C
C     READ THE INTEGERS FROM FILE INUNIT AND STORE THEM INTO THE
C     ARRAY ITEMP AS WHOLE UNITS, LEFT JUSTIFIED.
C
C LOOP THROUGH ALL CARD IMAGES.
      DO 1 I = 1,INNUM
      READ(INUNIT,100)(ICARD(J),J=1,16)
C LOOP THROUG ALL 15 BIT UNITS ON A CARD IMAGE.
      DO 10 J=1,16
      IN15 = ICARD(J)
C STORE 15 BIT UNIT AT CORRECT POSITION IN WORD.
      IIN15 = ISHIFT(IAND(IN15,MA15),NBWD-IPOS*15)
      ITEMP(IWORD) = IOR(IIN15,ITEMP(IWORD))
      IPOS = IPOS + 1
      IF (IPOS .LE. NUM15) GOTO 11
C START A NEW WORD.
      IPOS = 1
      IWORD = IWORD + 1
      ITEMP(IWORD) = IZERO
   11 CONTINUE
   10 CONTINUE
    1 CONTINUE
C
C
C WRITE 1 RECORD IN A BINARY FILE.
C
      WRITE(IOUTUN) (ITEMP(J),J=1,IWORD)
C
      REWIND INUNIT
C
  100 FORMAT(16I5)
C
      RETURN
      END

C
C	$Id: ffprcf.f,v 1.4 2008-07-27 12:23:42 haley Exp $
C                                                                      
C			     Copyright (C)  1997
C	     University Corporation for Atmospheric Research
C			     All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C

      SUBROUTINE FFPRCF(IER)
C
C  Process the character entries in the ASCII fontcap.
C
      include 'fntcom.h'
C
      INTEGER BYTPNT,STATE,IVALS(6)
C
C  Initialize the byte and bit pointers (start after the table of indices
C  and the pointer to the last byte).
C
      NUMCHR = CHREND-CHRSTR+1
      BYTPNT = TABPNT+NBYPWD*((2*NUMCHR-1)/NBYPWD)+NBYPWD
      BITPNT = 8*BYTPNT
      STATE  = 0
C
      DO 10 I=1,NUMCHR
   20   CONTINUE
        CALL CFRDLN(INUM,IWID,IER)
        IF (IER .NE. 0) GO TO 30
        IF (LINE(1:10) .EQ. 'BEGIN_CHAR') THEN
          IF (STATE .EQ. 0) THEN
C
C  Initialize --
C    Flag the state and put the byte address for this charater in 
C    the index array.  Put out the character number and width
C    packet.
C           
            STATE = 1
C
C  Round the bit pointer to the nearest byte.
C
            M8 = MOD(BITPNT,8)
            IF (M8 .NE. 0) BITPNT = BITPNT+8-M8
C
C  Round the byte pointer to the nearest word and adjust the bit pointer.
C
            BYTPNT = BITPNT/8
            BYTPNT = NBYPWD*((BYTPNT-1)/NBYPWD)+NBYPWD
            BITPNT = 8*BYTPNT
C
C  Byte address to index table.
C
            CALL SBYTES(BUFFER,BYTPNT,8*(TABPNT+2*(I-1)),16,0,1) 
C
C  Number/width packet.
C
            CALL FFPPKT(BITPNT,BEGINC,INUM,IWID)
            BITPNT = BITPNT+PKWID
            GO TO 20
          ELSE
            IER = EORD
            GO TO 30
          ENDIF
        ELSE
          IF (STATE .EQ. 1) THEN
            IF (LINE(1:12).EQ.'BEGIN_REGION' .OR. 
     +          LINE(1:10).EQ.'BEGIN_LINE') THEN
   40         CONTINUE
              CALL CFRDLN(IDUM1,IDUM2,IER)
              IF (LINE(1:3).NE.'BEG' .AND. LINE(1:3).NE.'END') THEN
C
C  Has to be coordinate data or Bezier control points to get here.
C
                CALL FFTKIN(LINE,NUMI,IVALS,IER)
                IF (IER .NE. 0) GO TO 30
                IF (NUMI .EQ. 2) THEN
C
C  Coordinate data, add biases before writing.
C
                  IVALS(1) = IVALS(1)+XBIAS
                  IVALS(2) = IVALS(2)+YBIAS
                  CALL FFPPKT(BITPNT,COORD,IVALS(1),IVALS(2))
                  BITPNT = BITPNT+PKWID
                  GO TO 40
                ELSE IF (NUMI .EQ. 6) THEN
C
C  Bezier control points.
C
                  IVALS(1) = IVALS(1)+XBIAS
                  IVALS(2) = IVALS(2)+YBIAS
                  CALL FFPPKT(BITPNT,BEZIER,IVALS(1),IVALS(2))
                  BITPNT = BITPNT+PKWID
                  DO 60 J=2,3
                    IX = 2*J-1
                    IY = IX+1
                    IVALS(IX) = IVALS(IX)+XBIAS
                    IVALS(IY) = IVALS(IY)+YBIAS
                    CALL FFPPKT(BITPNT,COORD,IVALS(IX),IVALS(IY))
                    BITPNT = BITPNT+PKWID
   60             CONTINUE
                  GO TO 40
                ELSE
                  IER = EORD
                  GO TO 30
                ENDIF
              ELSE IF (LINE(1:10) .EQ. 'BEGIN_HOLE') THEN
C
C  Process hole.
C
                CALL FFPHOL(IER)
                IF (IER .NE. 0) THEN
                  RETURN
                ELSE
                  GO TO 40
                ENDIF
              ELSE IF (LINE(1:10) .EQ. 'END_REGION') THEN
                CALL FFPPKT(BITPNT,ENDR,0,0)
                BITPNT = BITPNT+PKWID
                GO TO 20
              ELSE IF (LINE(1:8) .EQ. 'END_LINE') THEN
                CALL FFPPKT(BITPNT,ENDL,0,0)
                BITPNT = BITPNT+PKWID
                GO TO 20
              ELSE
                IER = EORD
                GO TO 30
              ENDIF 
            ELSE
              IF (LINE(1:8) .EQ. 'END_CHAR') THEN
                STATE = 0
                CALL FFPPKT(BITPNT,ENDC,0,0)
                BITPNT = BITPNT+PKWID
                GO TO 10
              ELSE
                IER = EORD
                GO TO 30
              ENDIF
            ENDIF
          ELSE
            IER = EORD
            GO TO 30
          ENDIF
        ENDIF
   10 CONTINUE
C
C  Put out the pointer to the last byte.
C
      M8 = MOD(BITPNT,8)
      IF (M8 .NE. 0) BITPNT = BITPNT+8-M8
      LSTPNT = BITPNT/8
C
C  Get the number of words to write out.
C
      NWRDS = (NBYPWD*((LSTPNT-1)/NBYPWD)+NBYPWD)/NBYPWD
C
C  The offset is computed using two bytes for each of the internals
C  in the internals array INTARR and 40 bytes for the font name.
C
      CALL SBYTES(BUFFER,LSTPNT,8*(2*NUMNTR+40),16,0,1)
   30 CONTINUE
C
      RETURN
      END

C
C $Id: vector.f,v 1.7 2008-07-27 00:17:25 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE VECTOR (PX,PY)
C
C Draw a vector (line segment) from the current pen position to the new
C pen position (PX,PY), in the user coordinate system, and then make
C (PX,PY) the current pen position.
C
      IF (ICFELL('VECTOR - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
      CALL PLOTIF (CUFX(PX),CUFY(PY),1)
      IF (ICFELL('VECTOR',2).NE.0) RETURN
      RETURN
      END

C NCLFORTSTART
      SUBROUTINE ROTEOF (NV,NF,V,ND, EVAL, ROTPCV, ROTVAR, VMSG, IOPT,
     +                   KFLAG)
      IMPLICIT NONE
      INTEGER  NV,NF,ND, IOPT, KFLAG
      DOUBLE PRECISION V(ND,NF),EVAL(NF),ROTPCV(NF),ROTVAR(NF), VMSG
C NCLEND
      INTEGER N,M
      DOUBLE PRECISION A(NV),B(NV),C(NV), TVAR

      TVAR = EVAL(1)/(ROTPCV(1)*0.01d0)
c     PRINT *, "TVAR=",TVAR

C check for missing values: Use appropriate subroutine
      KFLAG = 0
      DO N=1,NF
        DO M=1,ND
           IF (V(M,N).EQ.VMSG) THEN
               KFLAG = 1
               GO TO 100
           END IF
        END DO
      END DO
  100 CONTINUE

      IF (IOPT.NE.0) THEN
C Scale the input eigenvector matrix
          DO N=1,NF
            DO M=1,ND
               IF (V(M,N).NE.VMSG) THEN
                   V(M,N) = V(M,N)*DSQRT( EVAL(N) )
               END IF
            END DO
          END DO
      END IF

      DO M=1,NV
         A(M) = VMSG
         B(M) = VMSG
         C(M) = VMSG
      END DO

      IF (KFLAG.EQ.0) THEN
          CALL VORS(NV,NF,V,A,B,C,ND) 
      ELSE
          CALL VORSMSG(NV,NF,V,A,B,C,ND,VMSG) 
      END IF  

      DO N=1,NF
        ROTVAR(N) = 0.0D0
        DO M=1,ND
           IF (V(M,N).NE.VMSG) THEN
              ROTVAR(N) = ROTVAR(N) + V(M,N)**2
           END IF
        END DO
      END DO
      
C % variance explained

      IF (IOPT.NE.0) THEN
          DO N=1,NF
            ROTPCV(N) = (ROTVAR(N)/TVAR)*100D0
          END DO
      ELSE 
          DO N=1,NF
            ROTPCV(N) = 100.D0/ND
          END DO
      END IF
      
      IF (IOPT.LE.0) RETURN

C unscale [denormalize]

      DO N=1,NF
        DO M=1,ND
           IF (V(M,N).NE.VMSG) THEN
               V(M,N) = V(M,N)/DSQRT( ROTVAR(N) )
           END IF
        END DO
      END DO


      RETURN
      END
c ------------------------------------
      SUBROUTINE VORS(NV,NF,V,A,B,C,ND)
      IMPLICIT NONE
      INTEGER NV,NF,ND
      DOUBLE PRECISION V(ND,NF),A(NV),B(NV),C(NV)

      INTEGER I,J,KR,M,N
      DOUBLE PRECISION T,PI,TWOPI,REPS,AA,BB,CC,DD,XN,XD,Y,CY,SY,TEMP

      DOUBLE PRECISION DSUMFR,DSCPFR

c +++ very old fortran 66 ++++ used arithmetic "if"
c         I have made some minor changes made

c note: changed names SCPF=>DSCPFR and   SUMF=>DSUMFR
c       to minimize possible name conflicts with other funtions/subroutines
c
c ***** This gives the same answers as IMSL's FROTA *****
c *****      with w=1.0, norm=1, maxit=30           *****
c
c nv    - # of variables [rows]
c nf    - # of factors   [columns]
c v     - matrix to be rotated
c a     - % variation of rotated factors
c b     - communalities of variables [%]
c c     - work vector
c nd    - lead dimension [# rows] of v in the main program
c
c Orthogonal Rotation according to varimax  criteria.
c Kaiser row normalization is used prior to rotation.
c ie: On input, each row is normalized by dividing each row
c     by the square root of the sum of its squared elements.
c     Before returning each row is denormalized.

c Each possible pair of factor vectors [principal components]
c    is rotated to maximize the column-variance criterion
c    in turn until a complete pass through all combinations
c    does not result in any rotations of more than "reps" radians.
c The percentages of trace are recomputed for each factor vector
c    and returned in vector "a" (actually, the first "nfac" 
c    elements of "a").
c The percentages of trace are computed for each row of the
c    rotated matrix and returned in vector "b". When  computed
c    as proportions (row sums of squares of the loading matrix)
c    they are called "communalities" and are not affected by the
c    rotation process. This will be exactly 100% only when all
c    the variance of the particular variable is completely
c    accounted for by the extracted factors.
c
c D.J. Veldman
c Fortran Programming for the Behavioral Sciences
c Holt, Rinehart, Winston, 1967
c pp 214-215

      T = NV
      PI = 4.D0*ATAN(1.D0)
      TWOPI = 2.D0*PI
C epsilon (radians)=1 deg
c c c reps = pi/180.
C this matches IMSL
      REPS = 0.0001D0

C normalize the rows of v
      DO I = 1,NV
          B(I) = SQRT(DSUMFR(V, (-I), (-NF),ND))
          DO J = 1,NF
              V(I,J) = V(I,J)/B(I)
          END DO
      END DO

   10 CONTINUE
      KR = 0
      DO M = 1,NF
          DO N = M,NF
              IF (M.NE.N) THEN
C compute angle of rotation
                  DO I = 1,NV
                      A(I) = V(I,M)*V(I,M) - V(I,N)*V(I,N)
                      C(I) = 2.0D0*V(I,M)*V(I,N)
                  END DO

                  AA = DSUMFR(A,1,NV,ND)
                  BB = DSUMFR(C,1,NV,ND)
                  CC = DSUMFR(A,1, (-NV),ND) - DSUMFR(C,1, (-NV),ND)
                  DD = DSCPFR(A,C,1,1,NV,ND)*2.0D0
                  XN = DD - 2.0D0*AA*BB/T
c compute angle of rotation
                  XD = CC - (AA*AA-BB*BB)/T

                  Y = ATAN(XN/XD)
                  IF (XD.LT.0.D0) THEN
                      IF (XN.GE.0.D0) Y = Y + TWOPI
                      Y = Y - PI
                  END IF
                  Y = Y/4.0D0
                  IF (ABS(Y).LT.REPS) GO TO 1002

c count rotations
                  KR = KR + 1
                  CY = COS(Y)
                  SY = SIN(Y)
c rotate the axis
                  DO I = 1,NV
                      TEMP = V(I,M)*CY + V(I,N)*SY
                      V(I,N) = V(I,N)*CY - V(I,M)*SY
                      V(I,M) = TEMP
                  END DO
              END IF
 1002         CONTINUE
          END DO
      END DO
      IF (KR.GT.0) GO TO 10
c denormailize rows of v
      DO J = 1,NF
          DO I = 1,NV
              V(I,J) = V(I,J)*B(I)
          END DO
c % variation: note the A is dimensioned A(NV)
c              but the % variation is in A(NF) [a subset of A]
          A(J) = (DSUMFR(V,J, (-NV),ND)/T)*100.D0
      END DO

      DO I = 1,NV
C % communitalities
          B(I) = B(I)*B(I)*100.D0
      END DO

      RETURN
      END
c ------------------------------------
      DOUBLE PRECISION FUNCTION DSUMFR(X,KK,NN,ND)
      IMPLICIT NONE
      INTEGER KK,NN,ND
      DOUBLE PRECISION X(ND,1)

c         awkward due to arithmetic if in orig code
c computes sum of x or x**2 from a vector
c x   = input array
c nn  = number of values to be summed.
c       if (nn.lt.0) sum of x**2 is computed
c kk  = row or column number if x is a matrix.
c       kk=1 means x is a vector
c       kk>1 means it is a column vector
c       kk<0 means it is a   row  vector
c nd  = actual first dimension of x in the
c       aclling routine

c note: changed name SUMF=>DSUMFR to minimize possible name conflicts

C local
      INTEGER N,K,I

      DSUMFR = 0.0D0
      N = IABS(NN)
      K = IABS(KK)
      IF (NN.LE.0) THEN
          IF (NN.EQ.0) GO TO 55
          IF (KK.LT.0) GO TO 15
          IF (KK.EQ.0) GO TO 55
          GO TO 25
      END IF
      IF (KK.LT.0) GO TO 35
      IF (KK.EQ.0) GO TO 55
      GO TO 45
   15 CONTINUE
      DO I = 1,N
          DSUMFR = DSUMFR + X(K,I)*X(K,I)
      END DO
      RETURN

   25 CONTINUE
      DO I = 1,N
          DSUMFR = DSUMFR + X(I,K)*X(I,K)
      END DO
      RETURN

   35 CONTINUE
      DO I = 1,N
          DSUMFR = DSUMFR + X(K,I)
      END DO
      RETURN

   45 CONTINUE
      DO I = 1,N
          DSUMFR = DSUMFR + X(I,K)
      END DO
   55 CONTINUE
      RETURN

      END
c ------------------------------------------------
      DOUBLE PRECISION FUNCTION DSCPFR(X,Y,KX,KY,N,ND)
      IMPLICIT NONE
      INTEGER KX,KY,N,ND
      DOUBLE PRECISION X(ND,1),Y(ND,1)

C local
      INTEGER J,K,I

c         awkward due to arithmetic if in orig code
c computes the sum of cross products (scalar product) of two vectors
c x,y - input arrays [may be the same]
c kx,ky - row  or column numbers for x and y (if matrices)
c         set=1 if vector
c         if kx or ky is positive and not 1, it is a column vector
c         if kx or ky is negative and not 1, it is a   row  vector
c n     - the number of products to be summed, elements of each vector
c nd    - actual first dimension of x in the calling routine

c note: changed name SCPF=>DSCPFR to minimize possible name conflicts

      J = IABS(KX)
      K = IABS(KY)
      DSCPFR = 0.0D0

      IF (KX.LE.0) THEN
          IF (KX.EQ.0) GO TO 55
          IF (KY.LT.0) GO TO 15
          IF (KY.EQ.0) GO TO 55
          GO TO 25
      END IF
      IF (KY.LT.0) GO TO 35
      IF (KY.EQ.0) GO TO 55
      GO TO 45
   15 CONTINUE
      DO I = 1,N
          DSCPFR = DSCPFR + X(J,I)*Y(K,I)
      END DO
      RETURN

   25 CONTINUE
      DO I = 1,N
          DSCPFR = DSCPFR + X(J,I)*Y(I,K)
      END DO
      RETURN

   35 CONTINUE
      DO I = 1,N
          DSCPFR = DSCPFR + X(I,J)*Y(K,I)
      END DO
      RETURN

   45 CONTINUE
      DO I = 1,N
          DSCPFR = DSCPFR + X(I,J)*Y(I,K)
      END DO
      RETURN

   55 CONTINUE
      RETURN
      END
C ------------
      SUBROUTINE VORSMSG(NV,NF,V,A,B,C,ND,VMSG)
      IMPLICIT NONE
      INTEGER NV,NF,ND
      DOUBLE PRECISION V(ND,NF),A(NV),B(NV),C(NV), VMSG

c local
      INTEGER N,M, NVTMP
      DOUBLE PRECISION VTMP(ND,NF)

      DO N=1,NF
        DO M=1,ND
           VTMP(M,N) = VMSG
        END DO
      END DO

      DO N=1,NF
         NVTMP = 0
        DO M=1,ND
           IF (V(M,N).NE.VMSG) THEN
               NVTMP = NVTMP+1 
               VTMP(NVTMP,N) = V(M,N)
           END IF
        END DO
      END DO

      CALL VORS(NVTMP,NF,VTMP,A,B,C,ND) 

      DO N=1,NF
         NVTMP = 0
        DO M=1,ND
           IF (V(M,N).NE.VMSG) THEN
               NVTMP = NVTMP+1 
               V(M,N) = VTMP(NVTMP,N)
           END IF
        END DO
      END DO

      RETURN
      END

C
C $Id: mdsetd.f,v 1.11 2008-09-18 12:19:11 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MDSETD (WHCH,DVAL)
C
        CHARACTER*(*)    WHCH
        DOUBLE PRECISION DVAL
C
C Declare required common blocks.  See MAPBDX for descriptions of these
C common blocks and the variables in them.
C
        COMMON /MAPCM0/  COS1,DTOR,DTRH,OOPI,PI,PIOF,PIOT,RTDD,RTOD,
     +                   SROT,SIN1,TOPI,TSRT
        DOUBLE PRECISION COS1,DTOR,DTRH,OOPI,PI,PIOF,PIOT,RTDD,RTOD,
     +                   SROT,SIN1,TOPI,TSRT
        SAVE   /MAPCM0/
C
        COMMON /MAPCM2/  BLAM,BLOM,PEPS,SLAM,SLOM,UCEN,UMAX,UMIN,UOFF,
     +                   URNG,VCEN,VMAX,VMIN,VOFF,VRNG,ISSL
        DOUBLE PRECISION BLAM,BLOM,PEPS,SLAM,SLOM,UCEN,UMAX,UMIN,UOFF,
     +                   URNG,VCEN,VMAX,VMIN,VOFF,VRNG
        INTEGER          ISSL
        SAVE   /MAPCM2/
C
        COMMON /MAPCM4/  GRDR,GRID,GRLA,GRLO,GRPO,OTOL,PDRE,PLA1,PLA2,
     +                   PLA3,PLA4,PLB1,PLB2,PLB3,PLB4,PLNO,PLTO,ROTA,
     +                   SRCH,XLOW,XROW,YBOW,YTOW,IDOT,IDSH,IDTL,ILCW,
     +                   ILTS,JPRJ,ELPF,INTF,LBLF,PRMF
        DOUBLE PRECISION GRDR,GRID,GRLA,GRLO,GRPO,OTOL,PDRE,PLA1,PLA2,
     +                   PLA3,PLA4,PLB1,PLB2,PLB3,PLB4,PLNO,PLTO,ROTA,
     +                   SRCH,XLOW,XROW,YBOW,YTOW
        INTEGER          IDOT,IDSH,IDTL,ILCW,ILTS,JPRJ
        LOGICAL          ELPF,INTF,LBLF,PRMF
        SAVE   /MAPCM4/
C
        COMMON /MAPCM7/  ULOW,UROW,VBOW,VTOW
        DOUBLE PRECISION ULOW,UROW,VBOW,VTOW
        SAVE   /MAPCM7/
C
        COMMON /MAPCMA/  DATL,DBTD,DDTS,DPLT,DPSQ,DSCA,DSSQ
        DOUBLE PRECISION DATL,DBTD,DDTS,DPLT,DPSQ,DSCA,DSSQ
        SAVE   /MAPCMA/
C
        COMMON /MAPCMW/  CSLS,CSLT,SLTD,ISLT
        DOUBLE PRECISION CSLS,CSLT,SLTD
        INTEGER ISLT
        SAVE   /MAPCMW/
C
        COMMON /MAPSAT/  ALFA,BETA,DCSA,DCSB,DSNA,DSNB,SALT,SSMO,SRSS
        DOUBLE PRECISION ALFA,BETA,DCSA,DCSB,DSNA,DSNB,SALT,SSMO,SRSS
        SAVE   /MAPSAT/
C
        IF (ICFELL('MDSETD - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
        IF      (WHCH(1:2).EQ.'DD'.OR.WHCH(1:2).EQ.'dd') THEN
          DDTS=DVAL
          DBTD=DDTS/DSCA
        ELSE IF (WHCH(1:2).EQ.'GD'.OR.WHCH(1:2).EQ.'gd') THEN
          GRDR=MAX(.001D0,MIN(10.D0,DVAL))
        ELSE IF (WHCH(1:2).EQ.'GN'.OR.WHCH(1:2).EQ.'gn') THEN
          GRLO=DVAL
        ELSE IF (WHCH(1:2).EQ.'GP'.OR.WHCH(1:2).EQ.'gp') THEN
          GRPO=MAX(0.D0,MIN(90360.D0,DVAL))
        ELSE IF (WHCH(1:2).EQ.'GR'.OR.WHCH(1:2).EQ.'gr') THEN
          GRID=DVAL
        ELSE IF (WHCH(1:2).EQ.'GT'.OR.WHCH(1:2).EQ.'gt') THEN
          GRLA=DVAL
        ELSE IF (WHCH(1:2).EQ.'MV'.OR.WHCH(1:2).EQ.'mv') THEN
          DPLT=DVAL
          DPSQ=DPLT*DPLT
        ELSE IF (WHCH(1:2).EQ.'OT'.OR.WHCH(1:2).EQ.'ot') THEN
          OTOL=MAX(0.D0,DVAL)
        ELSE IF (WHCH(1:2).EQ.'RE'.OR.WHCH(1:2).EQ.'re') THEN
          PDRE=DVAL
          INTF=.TRUE.
        ELSE IF (WHCH(1:2).EQ.'SA'.OR.WHCH(1:2).EQ.'sa') THEN
          SALT=DVAL
          IF (ABS(SALT).GT.1.D0) THEN
            SSMO=SALT*SALT-1.D0
            SRSS=SQRT(SSMO)
          END IF
          INTF=.TRUE.
        ELSE IF (WHCH(1:2).EQ.'SL'.OR.WHCH(1:2).EQ.'sl') THEN
          SLTD=MAX(-1.D0,MIN(91.D0,DVAL))
          INTF=.TRUE.
        ELSE IF (WHCH(1:2).EQ.'S1'.OR.WHCH(1:2).EQ.'s1') THEN
          ALFA=ABS(DVAL)
          DSNA=SIN(DTOR*ALFA)
          DCSA=COS(DTOR*ALFA)
          INTF=.TRUE.
        ELSE IF (WHCH(1:2).EQ.'S2'.OR.WHCH(1:2).EQ.'s2') THEN
          BETA=DVAL
          DSNB=SIN(DTOR*BETA)
          DCSB=COS(DTOR*BETA)
          INTF=.TRUE.
        ELSE IF (WHCH(1:2).EQ.'SR'.OR.WHCH(1:2).EQ.'sr') THEN
          SRCH=MAX(.001D0,MIN(10.D0,DVAL))
          INTF=.TRUE.
        ELSE
          GO TO 901
        END IF
C
C Done.
C
        RETURN
C
C Error exits.
C
  901   CALL MDPCEM ('MDSETD - UNKNOWN PARAMETER NAME ',WHCH,2,1)
        RETURN
C
      END

      PROGRAM MPEX15
C
C This is a test program for the routines MAPNGR, MAPNGD, and MAPNGQ,
C which allow one to display a transformed PNG as an Ezmap background.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
        PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Define flags that control the drawing of grids and outlines.
C
        DATA IGRD,IOUT / 2,4 /
C
C Define conversion constants.
C
        DATA DTOR / .017453292519943 /
        DATA RTOD / 57.2957795130823 /
C
C Open GKS.
C
        CALL GOPKS (IERRF,0)
        CALL GOPWK (IWKID,LUNIT,IWTYPE)
        CALL GACWK (IWKID)
C
C Turn off clipping.
C
        CALL GSCLIP (0)
C
C Define basic colors.
C
        CALL GSCR (IWKID,0,1.,1.,1.)
        CALL GSCR (IWKID,1,0.,0.,0.)
        CALL GSCR (IWKID,2,1.,0.,0.)
        CALL GSCR (IWKID,3,0.,.8,0.)
C
C Define 129 gray-scale colors.
C
        DO 101 I=4,132
          P=REAL(I-4)/128.
          CALL GSCR (IWKID,I,P,P,P)
  101   CONTINUE
C
C Turn error recovery on.
C
        CALL ENTSR (ITMP,1)
C
C Tell PLOTCHAR to use a filled font and to outline the characters.
C
        CALL PCSETI ('FN',25)
        CALL PCSETI ('OF',1)
C
C Tell EZMAP what grid spacing to use.
C
        CALL MPSETI ('GR',IGRD)
C
C Read a PNG, downloaded from Wikimapia, showing most of Europe, and
C an associated PNGI and initilize information that geo-references the
C PNG so that it can be displayed as a background on a different
C projection of the globe.
C
        CALL MAPNGR ('Europe.png'//CHAR(0),40000)
C
C If an error occurred, print an error message.
C
        IF (NERRO(ITMP).NE.0) THEN
C
          CALL EPRIN
          CALL ERROF
          STOP
C
C Otherwise, produce the example plot.
C
        ELSE
C
C Initialize EZMAP to produce a satellite view of Europe looking north
C from a position somewhere over the Mediterranean.
C
          CALL MAPROJ ('SV', 25., 18., 10.)
          DFCE=2.
          CALL MPSETR ('SA',DFCE)
          CALL MPSETR ('S1',.6*RTOD*ASIN(1./DFCE))
          CALL MPSETR ('S2',90.)
          CALL MAPSET ('AN',8.,8.,8.,8.)
C
          CALL MAPINT
C
C Draw the projected PNG of the European map.
C
          CALL MAPNGD (4194304,0,4,129)
C
          IF (IGRD.NE.0) THEN
            CALL PLOTIF (0.,0.,2)
            CALL GSLWSC (2.)
            CALL GSPLCI (2)
            CALL MDPGRD
            CALL MDPLBL
            CALL PLOTIF (0.,0.,2)
            CALL GSLWSC (1.)
            CALL GSPLCI (1)
          END IF
C
C If the "outline" flag is set, overlay geopolitical boundary lines
C from "Earth..4" on the map.
C
          IF (IOUT.NE.0) THEN
            CALL PLOTIF (0.,0.,2)
            CALL GSLWSC (2.)
            CALL GSPLCI (3)
            CALL MDLNDR ('Earth..4',IOUT)
            CALL PLOTIF (0.,0.,2)
            CALL GSLWSC (1.)
            CALL GSPLCI (1)
          END IF
C
C Supply a title for the frame.
C
          CALL PLCHHQ (CFUX(.5),CFUY(.975),
     +               'USING A PROJECTED PNG AS A BACKGROUND',.018,0.,0.)
C
          CALL FRAME
C
          CALL MAPNGQ
C
        END IF
C
C Close GKS.
C
        CALL GDAWK (IWKID)
        CALL GCLWK (IWKID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END

C
C $Id: nadraw.f,v 1.4 2008-07-27 03:11:53 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE NADRAW (NUMV,VORX,VORY,IWORK,WORK)
C
C  Draw a Voronoi polygon whose vertices are (VORX(I),VORY(I),I=1,NUMV), 
C  but are not in any particular order.
C
      DIMENSION VORX(NUMV),VORY(NUMV),IWORK(NUMV),WORK(NUMV)
      DIMENSION XX(2),YY(2)
      PARAMETER (D2R = 57.29578)
C
C  Find the extreme values.
C
      XMN =  VORX(1)
      XMX =  VORX(1)
      YMN =  VORY(1)
      YMX =  VORY(1)
C
      DO 10 I=2,NUMV
        XMN = MIN(XMN,VORX(I))
        XMX = MAX(XMX,VORX(I))
        YMN = MIN(YMN,VORY(I))
        YMX = MAX(YMX,VORY(I))
   10 CONTINUE
C
C  Find a point in the middle of the polygon as a reference point.
C
      XMID = 0.5*(XMX+XMN)
      YMID = 0.5*(YMX+YMN)
C
C  Find the angles to the vertices from the reference point and sort 
C  the vertices in ascending angular order.
C
      DO 15 I=1,NUMV
        WORK(I) = ATAN2(VORY(I)-YMID,VORX(I)-XMID)*D2R
   15 CONTINUE
C
      CALL NASORT(WORK,IWORK,NUMV)
C
C  Draw lines between the vertices.
C
      CALL GQPLCI(IER,ICOL)
      CALL GQLN(IER,ILN)
      CALL SFLUSH()
      CALL GSPLCI(5)
      CALL GSLN(1)
      DO 20 I=1,NUMV-1
        IDX1 = IWORK(I)
        IDX2 = IWORK(I+1)
        XX(1) = VORX(IDX1)
        YY(1) = VORY(IDX1)
        XX(2) = VORX(IDX2)
        YY(2) = VORY(IDX2)
        CALL GPL(2,XX,YY)
   20 CONTINUE
      IDX1 = IWORK(NUMV)
      IDX2 = IWORK(1)
      XX(1) = VORX(IDX1)
      YY(1) = VORY(IDX1)
      XX(2) = VORX(IDX2)
      YY(2) = VORY(IDX2)
      CALL GPL(2,XX,YY)
      CALL SFLUSH()
      CALL GSPLCI(ICOL)
      CALL GSLN(ILN)
C    
      RETURN
      END

C
C	$Id: gelms.f,v 1.4 2008-07-27 00:20:57 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
        SUBROUTINE GELMS(IOS,STATUS)
C
C  This routine invokes the processors for the valid 
C  graphical elements.
C
C  Supported graphical elements: 
C       POLYLINE
C       POLYMARKER
C       TEXT
C       POLYGON
C       CELL ARRAY
C       GENERALIZED DRAWING PRIMITIVE
C
      include 'trinst.h'
      include 'trcode.h'
C
      INTEGER IOS, STATUS
C
      IF (OPID .EQ. GPELPL) THEN
C
C  POLYLINE
C
        CALL GPUTPT(11)
C
      ELSE IF (OPID .EQ. GPELPM) THEN
C
C  POLYMARKER
C
        CALL GPUTPT(12)
C
      ELSE IF (OPID .EQ. GPELPG) THEN
C
C  POLYGON
C
        CALL GPUTPT(14)
C
      ELSE IF (OPID .EQ. GPELTX) THEN 
C
C  TEXT
C
        CALL GTXDRW(IOS,STATUS)
C
      ELSE IF (OPID .EQ. GPELCA) THEN
C
C  CELL ARRAY
C
        CALL GCELDR(IOS,STATUS)
C
      ELSE IF (OPID.EQ.GPELGP) THEN
C
C  GENERALIZED DRAWING PRIMITIVE (Currently not supported).
C
        CALL GSKPOP(8,LEN,IOS,STATUS)
      END IF
C
      RETURN
      END

C
C $Id: agstup.f,v 1.12 2008-07-27 00:14:36 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE AGSTUP (XDRA,NVIX,IIVX,NEVX,IIEX,
     +                   YDRA,NVIY,IIVY,NEVY,IIEY)
C
      DIMENSION XDRA(1),YDRA(1)
C
C The routine AGSTUP is called to examine the parameter list, to provide
C default values for missing parameters, and to check for and cope with
C label overlap problems.
C
C The arguments describe the x and y data arrays to be used for the next
C graph.  See the routine AGEXUS for a description of them.
C
C The following common block contains the AUTOGRAPH control parameters,
C all of which are real.  If it is changed, all of AUTOGRAPH (especially
C the routine AGSCAN) must be examined for possible side effects.
C
      COMMON /AGCONP/ QFRA,QSET,QROW,QIXY,QWND,QBAC , SVAL(2) ,
     +                XLGF,XRGF,YBGF,YTGF , XLGD,XRGD,YBGD,YTGD , SOGD ,
     +                XMIN,XMAX,QLUX,QOVX,QCEX,XLOW,XHGH ,
     +                YMIN,YMAX,QLUY,QOVY,QCEY,YLOW,YHGH ,
     +                QDAX(4),QSPA(4),PING(4),PINU(4),FUNS(4),QBTD(4),
     +                BASD(4),QMJD(4),QJDP(4),WMJL(4),WMJR(4),QMND(4),
     +                QNDP(4),WMNL(4),WMNR(4),QLTD(4),QLED(4),QLFD(4),
     +                QLOF(4),QLOS(4),DNLA(4),WCLM(4),WCLE(4) ,
     +                QODP,QCDP,WOCD,WODQ,QDSH(26) ,
     +                     QDLB,QBIM,FLLB(10,8),QBAN ,
     +                QLLN,TCLN,QNIM,FLLN(6,16),QNAN ,
     +                XLGW,XRGW,YBGW,YTGW , XLUW,XRUW,YBUW,YTUW ,
     +                XLCW,XRCW,YBCW,YTCW , WCWP,HCWP,SCWP ,
     +                XBGA(4),YBGA(4),UBGA(4),XNDA(4),YNDA(4),UNDA(4),
     +                QBTP(4),BASE(4),QMNT(4),QLTP(4),QLEX(4),QLFL(4),
     +                QCIM(4),QCIE(4),RFNL(4),WNLL(4),WNLR(4),WNLB(4),
     +                WNLE(4),QLUA(4) ,
     +                RBOX(6),DBOX(6,4),SBOX(6,4)
      SAVE /AGCONP/
C
C The following common block contains other AUTOGRAPH variables, both
C real and integer, which are not control parameters.
C
      COMMON /AGORIP/ SMRL , ISLD , MWCL,MWCM,MWCE,MDLA,MWCD,MWDQ ,
     +                INIF
      SAVE /AGORIP/
C
C Do a call forcing a BLOCKDATA to be loaded from a binary library.
C
      CALL AGDFLT
C
C If initialization has not yet been done, do it.
C
      IF (INIF.EQ.0) THEN
        CALL AGINIT
      END IF
C
C Compute the width and height of the plotter frame.
C
      CALL GETSI (IWFP,IHFP)
      WOFP=2.**IWFP-1.
      HOFP=2.**IHFP-1.
C
C Examine the get-limits-from-last-set-call parameter.
C
      IF (ABS(QSET).EQ.1.) GO TO 141
C
      CALL GETSET (XLCW,XRCW,YBCW,YTCW,XMNT,XMXT,YMNT,YMXT,LILO)
C
      QLUX=REAL((1-LILO)/2)
      QLUY=REAL(MOD(1-LILO,2))
C
      IF (ABS(QSET).EQ.3.) GO TO 140
C
      XLGD=(XLCW-XLGF)/(XRGF-XLGF)
      XRGD=(XRCW-XLGF)/(XRGF-XLGF)
      YBGD=(YBCW-YBGF)/(YTGF-YBGF)
      YTGD=(YTCW-YBGF)/(YTGF-YBGF)
      SOGD=0.
C
      IF (ABS(QSET).EQ.2.) GO TO 141
C
  140 XMIN=MIN(XMNT,XMXT)
      XMAX=MAX(XMNT,XMXT)
      QOVX=0.
      IF (XMNT.GT.XMXT) QOVX=1.
      QCEX=0.
C
      YMIN=MIN(YMNT,YMXT)
      YMAX=MAX(YMNT,YMXT)
      QOVY=0.
      IF (YMNT.GT.YMXT) QOVY=1.
      QCEY=0.
C
  141 CONTINUE
C
C Examine the graph-window parameters.
C
      XLGF=MAX(0.,MIN(1.,XLGF))
      XRGF=MAX(0.,MIN(1.,XRGF))
      YBGF=MAX(0.,MIN(1.,YBGF))
      YTGF=MAX(0.,MIN(1.,YTGF))
C
      IF (XLGF.GE.XRGF.OR.YBGF.GE.YTGF) GO TO 901
C
C Examine the grid-window parameters.
C
      XLGD=MAX(0.,MIN(1.,XLGD))
      XRGD=MAX(0.,MIN(1.,XRGD))
      YBGD=MAX(0.,MIN(1.,YBGD))
      YTGD=MAX(0.,MIN(1.,YTGD))
C
      IF (XLGD.GE.XRGD.OR.YBGD.GE.YTGD) GO TO 902
C
C Examine the user-window minima and maxima for special values.  Compute
C tentative values of the user-window edge parameters.
C
      QIXY=MAX(0.,MIN(1.,QIXY))
C
      IF (QIXY.NE.0.) GO TO 142
C
      CALL AGEXUS (SVAL,XMIN,XMAX,XLOW,XHGH,
     +                               XDRA,NVIX,IIVX,NEVX,IIEX,XLUW,XRUW)
      CALL AGEXUS (SVAL,YMIN,YMAX,YLOW,YHGH,
     +                               YDRA,NVIY,IIVY,NEVY,IIEY,YBUW,YTUW)
      GO TO 143
C
  142 CALL AGEXUS (SVAL,XMIN,XMAX,XLOW,XHGH,
     +                               YDRA,NVIY,IIVY,NEVY,IIEY,XLUW,XRUW)
      CALL AGEXUS (SVAL,YMIN,YMAX,YLOW,YHGH,
     +                               XDRA,NVIX,IIVX,NEVX,IIEX,YBUW,YTUW)
C
  143 CONTINUE
C
C Examine the user-window nice-value-at-ends parameters.  INAX and INAY
C specify which axis has the nice values (if any).
C
      QCEX=MAX(-1.,MIN(+1.,QCEX))
      INAX=INT(QCEX)
      IF (INAX.NE.0) INAX=(INAX+7)/2
C
      QCEY=MAX(-1.,MIN(+1.,QCEY))
      INAY=INT(QCEY)
      IF (INAY.NE.0) INAY=(INAY+3)/2
C
C Examine the user-window linear-log flags.
C
      QLUX=MAX(-1.,MIN(1.,QLUX))
      QLUY=MAX(-1.,MIN(1.,QLUY))
C
C Examine the axis parameters.
C
      QLUD=ABS(QLUY)
      INAD=INAY
      UMIN=YBUW
      UMAX=YTUW
      QMIN=YBUW
      QMAX=YTUW
C
      I=0
C
  101 I=I+1
      IF (I.EQ.5) GO TO 104
C
      IF (I.EQ.3) THEN
        QLUD=ABS(QLUX)
        INAD=INAX
        UMIN=XLUW
        UMAX=XRUW
        QMIN=XLUW
        QMAX=XRUW
      END IF
C
      QDAX(I)=MAX(-1.,MIN(4.,QDAX(I)))
      IF (QDAX(I).LE.0.) GO TO 102
      QLUA(I)=QLUD
      QBTP(I)=QBTD(I)
      IF (QBTD(I).EQ.SVAL(1).OR.QBTD(I).EQ.SVAL(2)) QBTP(I)=1.+QLUD
      QBTP(I)=MAX(0.,MIN(3.,QBTP(I)))
      IF (QBTD(I).EQ.SVAL(2)) QBTD(I)=QBTP(I)
C
      CALL AGEXAX (I,SVAL,UMIN,UMAX,INAD-I,QLUD,FUNS(I),QBTP(I),BASD(I),
     +             BASE(I),QMJD(I),QMND(I),QMNT(I),QLTD(I),QLTP(I),
     +             QLED(I),QLEX(I),QLFD(I),QLFL(I),QMIN,QMAX)
C
      QSPA(I)=MAX(0.,MIN(1.,QSPA(I)))
      IF (QJDP(I).EQ.SVAL(1).OR.QJDP(I).EQ.SVAL(2)) QJDP(I)=65535.
      IF (QNDP(I).EQ.SVAL(1).OR.QNDP(I).EQ.SVAL(2)) QNDP(I)=65535.
C
  102 IF (I.EQ.2) THEN
        YBUW=QMIN
        YTUW=QMAX
      ELSE IF (I.EQ.4) THEN
        XLUW=QMIN
        XRUW=QMAX
      END IF
C
      GO TO 101
C
C Examine the user-window min-max/max-min ordering parameters.  Compute
C final values of the user-window edge parameters.
C
  104 QOVX=MAX(0.,MIN(1.,QOVX))
      IF (QOVX.EQ.0.) GO TO 105
      TEMP=XLUW
      XLUW=XRUW
      XRUW=TEMP
C
  105 QOVY=MAX(0.,MIN(1.,QOVY))
      IF (QOVY.EQ.0.) GO TO 106
      TEMP=YBUW
      YBUW=YTUW
      YTUW=TEMP
C
C Determine the exact size and shape of the curve window.
C
  106 XLGW=XLGF*WOFP
      XRGW=XRGF*WOFP
      YBGW=YBGF*HOFP
      YTGW=YTGF*HOFP
C
      XLCW=XLGW+XLGD*(XRGW-XLGW)
      XRCW=XLGW+XRGD*(XRGW-XLGW)
      YBCW=YBGW+YBGD*(YTGW-YBGW)
      YTCW=YBGW+YTGD*(YTGW-YBGW)
C
      WCWP=XRCW-XLCW
      HCWP=YTCW-YBCW
C
      ARWH=WCWP/HCWP
C
      IF (SOGD) 107,115,108
C
  107 DRWH=ABS(SOGD)
      GO TO 111
C
  108 DRWH=ABS((XRUW-XLUW)/(YTUW-YBUW))
      IF (SOGD-1.) 109,110,110
C
  109 IF (DRWH.LT.SOGD.OR.(1./DRWH).LT.SOGD) GO TO 115
      GO TO 111
C
  110 IF (DRWH.GT.SOGD.OR.(1./DRWH).GT.SOGD) DRWH=1.
C
  111 IF (DRWH-ARWH) 112,115,113
C
  112 XLCW=XLCW+.5*(WCWP-HCWP*DRWH)
      XRCW=XRCW-.5*(WCWP-HCWP*DRWH)
      GO TO 114
C
  113 YBCW=YBCW+.5*(HCWP-WCWP/DRWH)
      YTCW=YTCW-.5*(HCWP-WCWP/DRWH)
C
  114 WCWP=XRCW-XLCW
      HCWP=YTCW-YBCW
C
  115 SCWP=MIN(WCWP,HCWP)
C
      XLGW=(XLGW-XLCW)/WCWP
      XRGW=(XRGW-XLCW)/WCWP
      YBGW=(YBGW-YBCW)/HCWP
      YTGW=(YTGW-YBCW)/HCWP
C
      XLCW=XLCW/WOFP
      XRCW=XRCW/WOFP
      YBCW=YBCW/HOFP
      YTCW=YTCW/HOFP
C
C Make sure the number of dash patterns is in range.
C
      QODP=MAX(-26.,MIN(+26.,QODP))
      IF (QODP.EQ.0.) QODP=-1.
C
C Examine the windowing parameter.
C
      QWND=MAX(0.,MIN(1.,QWND))
C
C Do a test run of the routine AGLBLS to find out how much space will be
C required for labels in each of the six label boxes.
C
      QDLB=MAX(0.,MIN(2.,QDLB))
      IDLB=INT(QDLB)
      LBIM=INT(QBIM)
C
      CALL AGLBLS (-IDLB,WCWP,HCWP,FLLB,LBIM,FLLN,DBOX,SBOX,RBOX)
C
C Compute the desired and smallest-possible widths of the labels in
C boxes 1 and 2.
C
      DWB1=MAX(0.,DBOX(1,2)-DBOX(1,1))
      SWB1=MAX(0.,SBOX(1,2)-SBOX(1,1))
      DWB2=MAX(0.,DBOX(2,2)-DBOX(2,1))
      SWB2=MAX(0.,SBOX(2,2)-SBOX(2,1))
C
C Compute the desired and smallest-possible heights of the labels in
C boxes 3 and 4.
C
      DHB3=MAX(0.,DBOX(3,4)-DBOX(3,3))
      SHB3=MAX(0.,SBOX(3,4)-SBOX(3,3))
      DHB4=MAX(0.,DBOX(4,4)-DBOX(4,3))
      SHB4=MAX(0.,SBOX(4,4)-SBOX(4,3))
C
C Do test runs of AGAXIS for each of the four axes to see how much space
C will be required for numeric labels.
C
      I=0
C
  118 I=I+1
      IF (I.EQ.5) GO TO 128
C
      XYPI=REAL(1-MOD(I,2))
      IF (QDAX(I).EQ.0.) GO TO 121
      IF (PING(I).NE.SVAL(1)) XYPI=PING(I)
C
      IF (I.GE.3) GO TO 119
C
      XYMN=XLGW
      XYMX=XRGW
      IF (PINU(I).EQ.SVAL(1)) GO TO 120
      XYPI=(PINU(I)-XLUW)/(XRUW-XLUW)
      IF (QLUX.NE.0.) XYPI=(ALOG10(PINU(I))-ALOG10(XLUW))/
     +                                       (ALOG10(XRUW)-ALOG10(XLUW))
      GO TO 120
C
  119 XYMN=YBGW
      XYMX=YTGW
      IF (PINU(I).EQ.SVAL(1)) GO TO 120
      XYPI=(PINU(I)-YBUW)/(YTUW-YBUW)
      IF (QLUY.NE.0.) XYPI=(ALOG10(PINU(I))-ALOG10(YBUW))/
     +                                       (ALOG10(YTUW)-ALOG10(YBUW))
C
  120 XYPI=MAX(XYMN,MIN(XYMX,XYPI))
C
  121 GO TO (122,123,124,125) , I
C
C Left y axis.
C
  122 XBGA(1)=XYPI
      YBGA(1)=0.
      UBGA(1)=YBUW
      XNDA(1)=XYPI
      YNDA(1)=1.
      UNDA(1)=YTUW
      WNLL(1)=XYPI-XLGW-DWB1
      WNLR(1)=XRGW-XYPI-DWB2
      GO TO 126
C
C Right y axis.
C
  123 XBGA(2)=XYPI
      YBGA(2)=1.
      UBGA(2)=YTUW
      XNDA(2)=XYPI
      YNDA(2)=0.
      UNDA(2)=YBUW
      WNLL(2)=XRGW-XYPI-DWB2
      WNLR(2)=XYPI-XLGW-DWB1
      GO TO 126
C
C Bottom x axis.
C
  124 XBGA(3)=1.
      YBGA(3)=XYPI
      UBGA(3)=XRUW
      XNDA(3)=0.
      YNDA(3)=XYPI
      UNDA(3)=XLUW
      WNLL(3)=XYPI-YBGW-DHB3
      WNLR(3)=YTGW-XYPI-DHB4
      GO TO 126
C
C Top x axis.
C
  125 XBGA(4)=0.
      YBGA(4)=XYPI
      UBGA(4)=XLUW
      XNDA(4)=1.
      YNDA(4)=XYPI
      UNDA(4)=XRUW
      WNLL(4)=YTGW-XYPI-DHB4
      WNLR(4)=XYPI-YBGW-DHB3
C
  126 IF (QDAX(I).GT.0.) THEN
        CALL AGAXIS (I,QDAX(I),QSPA(I),WCWP,HCWP,XBGA(I),YBGA(I),
     +               XNDA(I),YNDA(I),QLUA(I),UBGA(I),UNDA(I),FUNS(I),
     +               QBTP(I),BASE(I),QJDP(I),WMJL(I),WMJR(I),QMNT(I),
     +               QNDP(I),WMNL(I),WMNR(I),QLTP(I),QLEX(I),QLFL(I),
     +               QLOF(I),QLOS(I),DNLA(I),WCLM(I),WCLE(I),RFNL(I),
     +               QCIM(I),QCIE(I),WNLL(I),WNLR(I),10.,11.)
      ELSE
        WNLL(I)=0.
        WNLR(I)=0.
      END IF
      GO TO 118
C
C If no labels are to be drawn, AGSTUP is now done.
C
  128 IF (IDLB.EQ.0) GO TO 138
C
C Check the label boxes, moving and/or shrinking them to prevent the
C labels in them from overlapping any portion of any axis.  The labels
C on an axis may have to be moved, as well.
C
C Box 1 - to the left of the curve window.
C
      IF (DBOX(1,2).GT.0.) GO TO 903
      DBOX(1,2)=MIN(0.,XBGA(1)-WNLL(1),XBGA(2)-WNLR(2))
      DBOX(1,1)=DBOX(1,2)-DWB1
      IF (DBOX(1,1).LT.XLGW) DBOX(1,1)=MIN(DBOX(1,2)-SWB1,XLGW)
      IF (DBOX(1,1).GE.XLGW) GO TO 130
      DBOX(1,1)=XLGW
      DBOX(1,2)=XLGW+SWB1
      TEMP=XBGA(1)-WNLL(1)-DBOX(1,2)
      IF (TEMP.GE.0.) GO TO 129
      WNLL(1)=WNLL(1)+TEMP
      WNLR(1)=WNLR(1)-TEMP
  129 TEMP=XBGA(2)-WNLR(2)-DBOX(1,2)
      IF (TEMP.GE.0.) GO TO 130
      WNLL(2)=WNLL(2)-TEMP
      WNLR(2)=WNLR(2)+TEMP
C
C Box 2 - to the right of the curve window.
C
  130 IF (DBOX(2,1).LT.1.) GO TO 904
      DBOX(2,1)=MAX(1.,XBGA(1)+WNLR(1),XBGA(2)+WNLL(2))
      DBOX(2,2)=DBOX(2,1)+DWB2
      IF (DBOX(2,2).GT.XRGW) DBOX(2,2)=MAX(DBOX(2,1)+SWB2,XRGW)
      IF (DBOX(2,2).LE.XRGW) GO TO 132
      DBOX(2,1)=XRGW-SWB2
      DBOX(2,2)=XRGW
      TEMP=XBGA(1)+WNLR(1)-DBOX(2,1)
      IF (TEMP.LE.0.) GO TO 131
      WNLL(1)=WNLL(1)+TEMP
      WNLR(1)=WNLR(1)-TEMP
  131 TEMP=XBGA(2)+WNLL(2)-DBOX(2,1)
      IF (TEMP.LE.0.) GO TO 132
      WNLL(2)=WNLL(2)-TEMP
      WNLR(2)=WNLR(2)+TEMP
C
C Box 3 - below the curve window.
C
  132 IF (DBOX(3,4).GT.0.) GO TO 905
      DBOX(3,4)=MIN(0.,YBGA(3)-WNLL(3),YBGA(4)-WNLR(4))
      DBOX(3,3)=DBOX(3,4)-DHB3
      IF (DBOX(3,3).LT.YBGW) DBOX(3,3)=MIN(DBOX(3,4)-SHB3,YBGW)
      IF (DBOX(3,3).GE.YBGW) GO TO 134
      DBOX(3,3)=YBGW
      DBOX(3,4)=YBGW+SHB3
      TEMP=YBGA(3)-WNLL(3)-DBOX(3,4)
      IF (TEMP.GE.0.) GO TO 133
      WNLL(3)=WNLL(3)+TEMP
      WNLR(3)=WNLR(3)-TEMP
  133 TEMP=YBGA(4)-WNLR(4)-DBOX(3,4)
      IF (TEMP.GE.0.) GO TO 134
      WNLL(4)=WNLL(4)-TEMP
      WNLR(4)=WNLR(4)+TEMP
C
C Box 4 - above the curve window.
C
  134 IF (DBOX(4,3).LT.1.) GO TO 906
      DBOX(4,3)=MAX(1.,YBGA(3)+WNLR(3),YBGA(4)+WNLL(4))
      DBOX(4,4)=DBOX(4,3)+DHB4
      IF (DBOX(4,4).GT.YTGW) DBOX(4,4)=MAX(DBOX(4,3)+SHB4,YTGW)
      IF (DBOX(4,4).LE.YTGW) GO TO 136
      DBOX(4,3)=YTGW-SHB4
      DBOX(4,4)=YTGW
      TEMP=YBGA(3)+WNLR(3)-DBOX(4,3)
      IF (TEMP.LE.0.) GO TO 135
      WNLL(3)=WNLL(3)+TEMP
      WNLR(3)=WNLR(3)-TEMP
  135 TEMP=YBGA(4)+WNLL(4)-DBOX(4,3)
      IF (TEMP.LE.0.) GO TO 136
      WNLL(4)=WNLL(4)-TEMP
      WNLR(4)=WNLR(4)+TEMP
C
C Box 5 - the curve window itself.
C
  136 IF (DBOX(5,1).LT.0..OR.DBOX(5,2).GT.1..OR.
     +                     DBOX(5,3).LT.0..OR.DBOX(5,4).GT.1.) GO TO 907
C
      DBOX(5,1)=MAX(XLGW,XBGA(1)+WNLR(1))
      DBOX(5,2)=MIN(XRGW,XBGA(2)-WNLR(2))
      DBOX(5,3)=MAX(YBGW,YBGA(3)+WNLR(3))
      DBOX(5,4)=MIN(YTGW,YBGA(4)-WNLR(4))
C
C Do a final check on all boxes for labels running outside the graph
C window.
C
           DO 137 NBOX=1,6
           DBOX(NBOX,1)=MAX(XLGW,DBOX(NBOX,1))
           DBOX(NBOX,2)=MIN(XRGW,DBOX(NBOX,2))
           DBOX(NBOX,3)=MAX(YBGW,DBOX(NBOX,3))
           DBOX(NBOX,4)=MIN(YTGW,DBOX(NBOX,4))
  137      CONTINUE
C
C Do a "SET" call for the user and return.
C
  138 CALL PLOTIT (0,0,2)
      CALL SET (XLCW,XRCW,YBCW,YTCW,XLUW,XRUW,YBUW,YTUW,
     +                            1+ABS(INT(QLUX))*2+ABS(INT(QLUY)))
C
      RETURN
C
C Error exits.
C
  901 CALL SETER ('AGSTUP - GRAPH WINDOW IMPROPERLY SPECIFIED',20,2)
C
  902 CALL SETER ('AGSTUP - GRID WINDOW IMPROPERLY SPECIFIED',21,2)
C
  903 CALL SETER ('AGSTUP - LEFT LABELS IMPROPERLY SPECIFIED',22,2)
C
  904 CALL SETER ('AGSTUP - RIGHT LABELS IMPROPERLY SPECIFIED',23,2)
C
  905 CALL SETER ('AGSTUP - BOTTOM LABELS IMPROPERLY SPECIFIED',24,2)
C
  906 CALL SETER ('AGSTUP - TOP LABELS IMPROPERLY SPECIFIED',25,2)
C
  907 CALL SETER ('AGSTUP - INTERIOR LABELS IMPROPERLY SPECIFIED',26,2)
C
      END

C
C	$Id: gspli.f,v 1.5 2008-07-27 00:21:02 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GSPLI(INDEX)
C
C  SET POLYLINE INDEX
C
      INTEGER ESPLI
      PARAMETER (ESPLI=18)
C
      include 'gkscom.h'
C
C  Check if GKS is in the proper state.
C
      CALL GZCKST(8,ESPLI,IER)
      IF (IER .NE. 0) RETURN
C
C  Check that the index is valid (this will have to be changed
C  for implementations higher than 0A).
C
      IF (INDEX.LE.0 .OR. INDEX.GT.5) THEN
        ERS = 1
        CALL GERHND(60,ESPLI,ERF)
        ERS = 0
        RETURN
      ENDIF
C
C  Set the current index in the GKS state list.
C
      CPLI = INDEX
C
C  Invoke the workstation interface.
C
      FCODE = 21
      CONT  = 0
      CALL GZROI(0)
      IL1   = 1
      IL2   = 1
      ID(1) = INDEX
      CALL GZTOWK
      IF (RERR.NE.0 .AND. RERR.NE.-109) THEN
        ERS = 1
        CALL GERHND(RERR,ESPLI,ERF)
        ERS = 0
      ENDIF
C
      RETURN
      END

C
C	$Id: intcnv.f,v 1.4 2008-07-27 12:23:44 haley Exp $
C                                                                      
C			     Copyright (C)  1997
C	     University Corporation for Atmospheric Research
C			     All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C

      SUBROUTINE INTCNV(INTVAL, CURPTR, IOS, STATUS)
C
C  Attempt to decode an integer starting at position CURPTR
C  in the input buffer.
C
C  The special symbol C  "W" is interpreted to be the wordsize in
C  bits of the host machine.  The special symbol "W1" is interpreted
C  as W-1.
C
C  INPUT
C       CURPTR  --  The current location in the input buffer.
C
C  OUTPUT
C       INTVAL  --  The decoded integer value.
C       IOS     --  I/O status flag.  This flag is valid only
C                   if STATUS indicates an error.
C       STATUS  --  The error status as defined in COMMON CAPERR.
C
C  Note:  If the request is successful, then IPTR will be updated to
C         point to the next position past the integer;  if the request
C         fails, IPTR will remain unchanged.
C
      COMMON /CAPERR/ ALLOK, EOFFL, INTERR, MAXINT, PLBERR, PMBERR,
     1                FABERR, TXBERR, FLTERR, MAXFLT, NOTINT, SIZERR,
     2                UNDASC, DEVERR, DOCERR, TBLERR , STSZER, ENTERR,
     3                TABERR, TABSER, PRSFIL
      INTEGER ALLOK, EOFFL, INTERR, MAXINT, PLBERR, PMBERR,
     1        FABERR, TXBERR, FLTERR, MAXFLT, NOTINT, SIZERR, UNDASC,
     2        DEVERR, DOCERR, STSZER, ENTERR, TABERR, TABSER, TBLERR,
     3        PRSFIL
      COMMON /CAPIOB/ UNIT, IPTR, LSIZE, NFST, NFLG
      COMMON /CAPIO2/ LINE, GRNM
      INTEGER LNMAX
      PARAMETER (LNMAX=80)
      CHARACTER*80 LINE
      CHARACTER*80 GRNM
      INTEGER UNIT, IPTR, LSIZE, NFST, NFLG
C
      INTEGER INTVAL, CURPTR, IOS, STATUS
C
C  Define the maximum number of digits allowed in the input stream.
C  If this number is changed, then the integer width in the format
C  statement with label 80 must be changed to the same value as
C  INTMX.
C
      INTEGER INTMX
      PARAMETER (INTMX=6)
      INTEGER I, II, TPTR, NUMSZ
      CHARACTER*1 DECPT, MINUS, ZERO, NINE, WSZ
      CHARACTER*1 BUF1(INTMX),BLANK
      CHARACTER*(INTMX) BUF2
C
      DATA DECPT, MINUS, ZERO, NINE /'.', '-', '0', '9'/
      DATA WSZ /'W'/
      DATA BLANK/' '/
C
C  Check that the input string is numeric.
C
      I = CURPTR
      IF (LINE(I:I).NE.DECPT .AND. LINE(I:I).NE.MINUS .AND.
     1    LINE(I:I).NE.WSZ   .AND.
     2   (LINE(I:I).LT.ZERO  .OR.  LINE(I:I).GT.NINE)) THEN
        STATUS = NOTINT
        RETURN
      END IF
C
C  Process until a blank or end-of-line is encountered.
C
      NUMSZ = 0
      DO 50 II = CURPTR, LSIZE
        IF (LINE(II:II) .NE.BLANK) THEN
                NUMSZ = NUMSZ + 1
C
C  Error -- NUMSZ exceeds the maximum number of digits allowed.
C
                IF (NUMSZ .GT. INTMX) THEN
                        STATUS = MAXINT
                        RETURN
                END IF
                BUF1(NUMSZ) = LINE(II:II)
                TPTR = II + 1
        ELSE
C
C  End of number.
C
                GO TO 55
        END IF
 50   CONTINUE
C
C  Set buffer pointer to current location.
C
 55   CONTINUE
      IPTR = TPTR
C
C  Blank out the conversion buffer.
C
      DO 60 II = 1,INTMX
        BUF2(II:II) = BLANK
 60   CONTINUE
C
C  Move the string to the conversion buffer.
C
       DO 70 II = 1,NUMSZ
        BUF2((INTMX-II+1):(INTMX-II+1)) = BUF1((NUMSZ-II)+1)
 70    CONTINUE
C
C  Convert to an integer.
C
      IF (BUF2(INTMX:INTMX) .EQ. 'W') THEN
        INTVAL = I1MACH(5)
      ELSE IF (BUF2(INTMX-1:INTMX) .EQ. 'W1') THEN
        INTVAL = I1MACH(5) - 1
      ELSE
        READ(BUF2,80,ERR=1000) INTVAL
      ENDIF
      RETURN
C
C  Error exit.
C
 1000 CONTINUE
      STATUS = INTERR
      RETURN
C
 80   FORMAT(I6)
C
      END

      SUBROUTINE CLAEIN( RIGHTV, NOINIT, N, H, LDH, W, V, B, LDB, RWORK,
     $                   EPS3, SMLNUM, INFO )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      LOGICAL            NOINIT, RIGHTV
      INTEGER            INFO, LDB, LDH, N
      REAL               EPS3, SMLNUM
      COMPLEX            W
*     ..
*     .. Array Arguments ..
      REAL               RWORK( * )
      COMPLEX            B( LDB, * ), H( LDH, * ), V( * )
*     ..
*
*  Purpose
*  =======
*
*  CLAEIN uses inverse iteration to find a right or left eigenvector
*  corresponding to the eigenvalue W of a complex upper Hessenberg
*  matrix H.
*
*  Arguments
*  =========
*
*  RIGHTV   (input) LOGICAL
*          = .TRUE. : compute right eigenvector;
*          = .FALSE.: compute left eigenvector.
*
*  NOINIT   (input) LOGICAL
*          = .TRUE. : no initial vector supplied in V
*          = .FALSE.: initial vector supplied in V.
*
*  N       (input) INTEGER
*          The order of the matrix H.  N >= 0.
*
*  H       (input) COMPLEX array, dimension (LDH,N)
*          The upper Hessenberg matrix H.
*
*  LDH     (input) INTEGER
*          The leading dimension of the array H.  LDH >= max(1,N).
*
*  W       (input) COMPLEX
*          The eigenvalue of H whose corresponding right or left
*          eigenvector is to be computed.
*
*  V       (input/output) COMPLEX array, dimension (N)
*          On entry, if NOINIT = .FALSE., V must contain a starting
*          vector for inverse iteration; otherwise V need not be set.
*          On exit, V contains the computed eigenvector, normalized so
*          that the component of largest magnitude has magnitude 1; here
*          the magnitude of a complex number (x,y) is taken to be
*          |x| + |y|.
*
*  B       (workspace) COMPLEX array, dimension (LDB,N)
*
*  LDB     (input) INTEGER
*          The leading dimension of the array B.  LDB >= max(1,N).
*
*  RWORK   (workspace) REAL array, dimension (N)
*
*  EPS3    (input) REAL
*          A small machine-dependent value which is used to perturb
*          close eigenvalues, and to replace zero pivots.
*
*  SMLNUM  (input) REAL
*          A machine-dependent value close to the underflow threshold.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          = 1:  inverse iteration did not converge; V is set to the
*                last iterate.
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ONE, TENTH
      PARAMETER          ( ONE = 1.0E+0, TENTH = 1.0E-1 )
      COMPLEX            ZERO
      PARAMETER          ( ZERO = ( 0.0E+0, 0.0E+0 ) )
*     ..
*     .. Local Scalars ..
      CHARACTER          NORMIN, TRANS
      INTEGER            I, IERR, ITS, J
      REAL               GROWTO, NRMSML, ROOTN, RTEMP, SCALE, VNORM
      COMPLEX            CDUM, EI, EJ, TEMP, X
*     ..
*     .. External Functions ..
      INTEGER            ICAMAX
      REAL               SCASUM, SCNRM2
      COMPLEX            CLADIV
      EXTERNAL           ICAMAX, SCASUM, SCNRM2, CLADIV
*     ..
*     .. External Subroutines ..
      EXTERNAL           CLATRS, CSSCAL
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, AIMAG, MAX, REAL, SQRT
*     ..
*     .. Statement Functions ..
      REAL               CABS1
*     ..
*     .. Statement Function definitions ..
      CABS1( CDUM ) = ABS( REAL( CDUM ) ) + ABS( AIMAG( CDUM ) )
*     ..
*     .. Executable Statements ..
*
      INFO = 0
*
*     GROWTO is the threshold used in the acceptance test for an
*     eigenvector.
*
      ROOTN = SQRT( REAL( N ) )
      GROWTO = TENTH / ROOTN
      NRMSML = MAX( ONE, EPS3*ROOTN )*SMLNUM
*
*     Form B = H - W*I (except that the subdiagonal elements are not
*     stored).
*
      DO 20 J = 1, N
         DO 10 I = 1, J - 1
            B( I, J ) = H( I, J )
   10    CONTINUE
         B( J, J ) = H( J, J ) - W
   20 CONTINUE
*
      IF( NOINIT ) THEN
*
*        Initialize V.
*
         DO 30 I = 1, N
            V( I ) = EPS3
   30    CONTINUE
      ELSE
*
*        Scale supplied initial vector.
*
         VNORM = SCNRM2( N, V, 1 )
         CALL CSSCAL( N, ( EPS3*ROOTN ) / MAX( VNORM, NRMSML ), V, 1 )
      END IF
*
      IF( RIGHTV ) THEN
*
*        LU decomposition with partial pivoting of B, replacing zero
*        pivots by EPS3.
*
         DO 60 I = 1, N - 1
            EI = H( I+1, I )
            IF( CABS1( B( I, I ) ).LT.CABS1( EI ) ) THEN
*
*              Interchange rows and eliminate.
*
               X = CLADIV( B( I, I ), EI )
               B( I, I ) = EI
               DO 40 J = I + 1, N
                  TEMP = B( I+1, J )
                  B( I+1, J ) = B( I, J ) - X*TEMP
                  B( I, J ) = TEMP
   40          CONTINUE
            ELSE
*
*              Eliminate without interchange.
*
               IF( B( I, I ).EQ.ZERO )
     $            B( I, I ) = EPS3
               X = CLADIV( EI, B( I, I ) )
               IF( X.NE.ZERO ) THEN
                  DO 50 J = I + 1, N
                     B( I+1, J ) = B( I+1, J ) - X*B( I, J )
   50             CONTINUE
               END IF
            END IF
   60    CONTINUE
         IF( B( N, N ).EQ.ZERO )
     $      B( N, N ) = EPS3
*
         TRANS = 'N'
*
      ELSE
*
*        UL decomposition with partial pivoting of B, replacing zero
*        pivots by EPS3.
*
         DO 90 J = N, 2, -1
            EJ = H( J, J-1 )
            IF( CABS1( B( J, J ) ).LT.CABS1( EJ ) ) THEN
*
*              Interchange columns and eliminate.
*
               X = CLADIV( B( J, J ), EJ )
               B( J, J ) = EJ
               DO 70 I = 1, J - 1
                  TEMP = B( I, J-1 )
                  B( I, J-1 ) = B( I, J ) - X*TEMP
                  B( I, J ) = TEMP
   70          CONTINUE
            ELSE
*
*              Eliminate without interchange.
*
               IF( B( J, J ).EQ.ZERO )
     $            B( J, J ) = EPS3
               X = CLADIV( EJ, B( J, J ) )
               IF( X.NE.ZERO ) THEN
                  DO 80 I = 1, J - 1
                     B( I, J-1 ) = B( I, J-1 ) - X*B( I, J )
   80             CONTINUE
               END IF
            END IF
   90    CONTINUE
         IF( B( 1, 1 ).EQ.ZERO )
     $      B( 1, 1 ) = EPS3
*
         TRANS = 'C'
*
      END IF
*
      NORMIN = 'N'
      DO 110 ITS = 1, N
*
*        Solve U*x = scale*v for a right eigenvector
*          or U'*x = scale*v for a left eigenvector,
*        overwriting x on v.
*
         CALL CLATRS( 'Upper', TRANS, 'Nonunit', NORMIN, N, B, LDB, V,
     $                SCALE, RWORK, IERR )
         NORMIN = 'Y'
*
*        Test for sufficient growth in the norm of v.
*
         VNORM = SCASUM( N, V, 1 )
         IF( VNORM.GE.GROWTO*SCALE )
     $      GO TO 120
*
*        Choose new orthogonal starting vector and try again.
*
         RTEMP = EPS3 / ( ROOTN+ONE )
         V( 1 ) = EPS3
         DO 100 I = 2, N
            V( I ) = RTEMP
  100    CONTINUE
         V( N-ITS+1 ) = V( N-ITS+1 ) - EPS3*ROOTN
  110 CONTINUE
*
*     Failure to find eigenvector in N iterations.
*
      INFO = 1
*
  120 CONTINUE
*
*     Normalize eigenvector.
*
      I = ICAMAX( N, V, 1 )
      CALL CSSCAL( N, ONE / CABS1( V( I ) ), V, 1 )
*
      RETURN
*
*     End of CLAEIN
*
      END

C
C $Id: tddtri.f,v 1.4 2008-07-27 00:17:32 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE TDDTRI (RTRI,MTRI,NTRI,ITWK)
C
        DIMENSION RTRI(10,MTRI),ITWK(NTRI)
C
C The routine TDDTRI is called to draw triangles that have previously
C been generated by calls to the routines TDSTRI and/or TDITRI (or in
C some other way) and ordered by a call to the routine TDOTRI (or in
C some other way).  Its arguments are as follows:
C
C   RTRI is a real array in which a list of triangles has been
C   generated; it is dimensioned 10 x MTRI.  Each 10-word entry in
C   the list consists of the U, V, and W coordinates of each of three
C   points, followed by a rendering style index.
C
C   MTRI is an input integer specifying the second dimension of the
C   array RTRI: the maximum number of triangles the list will hold.
C
C   NTRI is an input integer specifying the number of triangles in the
C   array RTRI.  Initially, NTRI must be zeroed by the user.  Each call
C   to one of the routines TDSTRI or TDITRI updates the value of NTRI
C   to reflect the number of triangles added to the list.
C
C   ITWK is an integer input array, dimensioned at least NTRI, in
C   which has been stored a permutation of the integers from 1 to NTRI.
C   The triangles will be rendered in the order specified by this array.
C   One possible way of setting the contents of ITWK is to call the
C   routine TDOTRI.
C
C Declare required TDPACK common blocks.
C
        COMMON /TDCOM1/ IH,IT,XM,YM,ZM,XO,YO,ZO,XT,YT,ZT,OE,XE,YE,ZE
        COMMON /TDCOM1/ A1,B1,C1,D1,E1,A2,B2,C2,D2,E2,A3,B3,C3,D3,E3
        COMMON /TDCOM1/ IS,FV,VL,VR,VB,VT,WL,WR,WB,WT
        SAVE   /TDCOM1/
C
        COMMON /TDCOM3/ IFC1(64),IFC2(64),IFC3(64),IFC4(64),ILC1(64)
        COMMON /TDCOM3/ ILC2(64),ILTD(64),USTP(64),VSTP(64),WSTP(64)
        SAVE   /TDCOM3/
C
        COMMON /TDCOM6/ ISHD,XPLS,YPLS,ZPLS
        SAVE   /TDCOM6/
C
C Declare some arrays to use in drawing/filling triangles.
C
        DIMENSION X(3),Y(3)
C
C Declare the radians-to-degrees conversion constant.
C
        DATA RTOD / 57.2957795130823 /
C
C Declare arithmetic statement functions that are used in the code that
C determines the line of intersection of a triangle with a slice in one
C of the three coordinate directions.
C
        FIN1(R,J,K)=(R              -RTRI(J,ITWK(I)))/
     +              (RTRI(K,ITWK(I))-RTRI(J,ITWK(I)))
C
        FIN2(T,J,K)=RTRI(J,ITWK(I))+T*(RTRI(K,ITWK(I))-RTRI(J,ITWK(I)))
C
C Declare an arithmetic statement function that can be used to tell
C whether the vertices of a triangle are given in clockwise order or
C counterclockwise order.
C
        VPDT(U1,V1,U2,V2,U3,V3)=(U1-U3)*(V2-V3)-(V1-V3)*(U2-U3)
C
C Initialize fill-color and line-color controls.
C
        CALL GQPLCI (IERR,ILCS)
        ILCC=ILCS
        CALL GQFACI (IERR,IFCS)
        IFCC=IFCS
C
C Deal with the triangles one at a time.
C
        DO 105 I=1,NTRI
C
C Pull out the rendering style for the triangle.
C
          IRST=MAX(1,MIN(64,INT(RTRI(10,ITWK(I)))))
C
C If the values will be needed, project the vertices of the triangle
C and then determine which side we're looking at the triangle from.
C
          IF (IFC1(IRST).GE.0.OR.IFC3(IRST).GE.0.OR.
     +        ILC1(IRST).GE.0.OR.ILC2(IRST).GE.0) THEN
            CALL TDPRPT (RTRI(1,ITWK(I)),
     +                   RTRI(2,ITWK(I)),
     +                   RTRI(3,ITWK(I)),
     +                         X(1),Y(1))
            CALL TDPRPT (RTRI(4,ITWK(I)),
     +                   RTRI(5,ITWK(I)),
     +                   RTRI(6,ITWK(I)),
     +                         X(2),Y(2))
            CALL TDPRPT (RTRI(7,ITWK(I)),
     +                   RTRI(8,ITWK(I)),
     +                   RTRI(9,ITWK(I)),
     +                         X(3),Y(3))
            SIDE=SIGN(1.,VPDT(X(1),Y(1),X(2),Y(2),X(3),Y(3)))
            IF (IH.NE.0) SIDE=-SIDE
          END IF
C
C Determine whether or not the triangle is to be filled and, if so, in
C what color.  (The most complicated possibility is that the triangle
C is to be filled in a color depending on the angle between its normal
C and the line from its center to the specified position of the light
C source.)
C
          IF ((IFC1(IRST).GE.0.AND.IFC2(IRST).GT.IFC1(IRST).AND.
     +                                                SIDE.LT.0.).OR.
     +        (IFC3(IRST).GE.0.AND.IFC4(IRST).GT.IFC3(IRST).AND.
     +                                                SIDE.GE.0.)) THEN
            UDN1=RTRI(2,ITWK(I))*(RTRI(9,ITWK(I))-RTRI(6,ITWK(I)))+
     +           RTRI(5,ITWK(I))*(RTRI(3,ITWK(I))-RTRI(9,ITWK(I)))+
     +           RTRI(8,ITWK(I))*(RTRI(6,ITWK(I))-RTRI(3,ITWK(I)))
            VDN1=RTRI(1,ITWK(I))*(RTRI(6,ITWK(I))-RTRI(9,ITWK(I)))+
     +           RTRI(4,ITWK(I))*(RTRI(9,ITWK(I))-RTRI(3,ITWK(I)))+
     +           RTRI(7,ITWK(I))*(RTRI(3,ITWK(I))-RTRI(6,ITWK(I)))
            WDN1=RTRI(1,ITWK(I))*(RTRI(8,ITWK(I))-RTRI(5,ITWK(I)))+
     +           RTRI(4,ITWK(I))*(RTRI(2,ITWK(I))-RTRI(8,ITWK(I)))+
     +           RTRI(7,ITWK(I))*(RTRI(5,ITWK(I))-RTRI(2,ITWK(I)))
            IF (XPLS.EQ.0..AND.YPLS.EQ.0..AND.ZPLS.EQ.0.) THEN
              UDN2=XM  -(RTRI(1,ITWK(I))+RTRI(4,ITWK(I))+
     +                                   RTRI(7,ITWK(I)))/3.
              VDN2=YM  -(RTRI(2,ITWK(I))+RTRI(5,ITWK(I))+
     +                                   RTRI(8,ITWK(I)))/3.
              WDN2=ZM  -(RTRI(3,ITWK(I))+RTRI(6,ITWK(I))+
     +                                   RTRI(9,ITWK(I)))/3.
            ELSE
              UDN2=XPLS-(RTRI(1,ITWK(I))+RTRI(4,ITWK(I))+
     +                                   RTRI(7,ITWK(I)))/3.
              VDN2=YPLS-(RTRI(2,ITWK(I))+RTRI(5,ITWK(I))+
     +                                   RTRI(8,ITWK(I)))/3.
              WDN2=ZPLS-(RTRI(3,ITWK(I))+RTRI(6,ITWK(I))+
     +                                   RTRI(9,ITWK(I)))/3.
            END IF
            IF (UDN1.NE.0..OR.VDN1.NE.0..OR.WDN1.NE.0.) THEN
              ANGD=RTOD*ABS(ACOS(-SIDE*(UDN1*UDN2+VDN1*VDN2+WDN1*WDN2)/
     +                            SQRT((UDN1*UDN1+VDN1*VDN1+WDN1*WDN1)*
     +                                 (UDN2*UDN2+VDN2*VDN2+WDN2*WDN2))
     +                                                                ))
            ELSE
              ANGD=90.
            END IF
            IF (ISHD.EQ.0) THEN
              IF (ANGD.GT.90.) ANGD=180.-ANGD
              IF (SIDE.LT.0.) THEN
                IFCD=MAX(IFC1(IRST),MIN(IFC2(IRST),
     +               IFC1(IRST)+INT(ANGD/(90./REAL(IFC2(IRST)-
     +                                             IFC1(IRST)+1)))))
              ELSE
                IFCD=MAX(IFC3(IRST),MIN(IFC4(IRST),
     +               IFC3(IRST)+INT(ANGD/(90./REAL(IFC4(IRST)-
     +                                             IFC3(IRST)+1)))))
              END IF
            ELSE
              IF (SIDE.LT.0.) THEN
                IFCD=MAX(IFC1(IRST),MIN(IFC2(IRST),
     +               IFC1(IRST)+INT(ANGD/(180./REAL(IFC2(IRST)-
     +                                              IFC1(IRST)+1)))))
              ELSE
                IFCD=MAX(IFC3(IRST),MIN(IFC4(IRST),
     +               IFC3(IRST)+INT(ANGD/(180./REAL(IFC4(IRST)-
     +                                              IFC3(IRST)+1)))))
              END IF
            END IF
          ELSE IF (SIDE.LT.0..AND.IFC1(IRST).GE.0) THEN
            IFCD=IFC1(IRST)
          ELSE IF (SIDE.GE.0..AND.IFC3(IRST).GE.0) THEN
            IFCD=IFC3(IRST)
          ELSE
            IFCD=-1
          END IF
C
C If the fill color desired is different from the current fill color,
C reset the latter.
C
          IF (IFCD.GE.0.AND.IFCC.NE.IFCD) THEN
            CALL GSFACI (IFCD)
            IFCC=IFCD
          END IF
C
C If appropriate, fill the triangle.
C
          IF (IFCD.GE.0) CALL GFA (3,X,Y)
C
C Determine whether or not any lines are to be drawn in the triangle
C and, if so, set the desired color index.
C
          IF (SIDE.LT.0..AND.ILC1(IRST).GE.0) THEN
            ILCD=ILC1(IRST)
          ELSE IF (SIDE.GE.0..AND.ILC2(IRST).GE.0) THEN
            ILCD=ILC2(IRST)
          ELSE
            ILCD=-1
          END IF
C
C If the desired line color is different from the current line color,
C reset the latter.
C
          IF (ILCD.GE.0.AND.ILCC.NE.ILCD) THEN
            CALL PLOTIF (0.,0.,2)
            CALL GSPLCI (ILCD)
            ILCC=ILCD
          END IF
C
C If the triangle outline is to be drawn, do that.
C
          IF (ILCD.GE.0.AND.ILTD(IRST).NE.0) THEN
            CALL LINE (X(1),Y(1),X(2),Y(2))
            CALL LINE (X(2),Y(2),X(3),Y(3))
            CALL LINE (X(3),Y(3),X(1),Y(1))
          END IF
C
C If U slices are do be drawn, do that.
C
          IF (ILCD.GE.0.AND.USTP(IRST).GT.0.) THEN
            UMIN=MIN(RTRI(1,ITWK(I)),RTRI(4,ITWK(I)),RTRI(7,ITWK(I)))
            UMAX=MAX(RTRI(1,ITWK(I)),RTRI(4,ITWK(I)),RTRI(7,ITWK(I)))
            IF (UMIN.NE.UMAX) THEN
              UEPS=1.E-3*(UMAX-UMIN)
              IST1=INT((UMIN-UEPS)/USTP(IRST)+.5+SIGN(.5,UMIN-UEPS))
              IST2=INT((UMAX+UEPS)/USTP(IRST)-.5+SIGN(.5,UMAX+UEPS))
              DO 102 ISTP=IST1,IST2
                UVAL=REAL(ISTP)*USTP(IRST)
                IF (RTRI(1,ITWK(I)).NE.RTRI(4,ITWK(I))) THEN
                  T12=FIN1(UVAL,1,4)
                ELSE
                  T12=-1.
                END IF
                IF (RTRI(4,ITWK(I)).NE.RTRI(7,ITWK(I))) THEN
                  T23=FIN1(UVAL,4,7)
                ELSE
                  T23=-1.
                END IF
                IF (RTRI(7,ITWK(I)).NE.RTRI(1,ITWK(I))) THEN
                  T31=FIN1(UVAL,7,1)
                ELSE
                  T31=-1.
                END IF
                IF (UMIN.EQ.MIN(RTRI(1,ITWK(I)),RTRI(4,ITWK(I))).AND.
     +              UMAX.EQ.MAX(RTRI(1,ITWK(I)),RTRI(4,ITWK(I)))) THEN
                  IF (T23.GE.-.001.AND.T23.LE.1.001) THEN
                    CALL TDLINE (UVAL,FIN2(T12,2,5),FIN2(T12,3,6),
     +                           UVAL,FIN2(T23,5,8),FIN2(T23,6,9))
                  ELSE IF (T31.GE.-.001.AND.T31.LE.1.001) THEN
                    CALL TDLINE (UVAL,FIN2(T12,2,5),FIN2(T12,3,6),
     +                           UVAL,FIN2(T31,8,2),FIN2(T31,9,3))
                  END IF
                ELSE
     +          IF (UMIN.EQ.MIN(RTRI(4,ITWK(I)),RTRI(7,ITWK(I))).AND.
     +              UMAX.EQ.MAX(RTRI(4,ITWK(I)),RTRI(7,ITWK(I))))THEN
                  IF (T31.GE.-.001.AND.T31.LE.1.001) THEN
                    CALL TDLINE (UVAL,FIN2(T23,5,8),FIN2(T23,6,9),
     +                           UVAL,FIN2(T31,8,2),FIN2(T31,9,3))
                  ELSE IF (T12.GE.-.001.AND.T12.LE.1.001) THEN
                    CALL TDLINE (UVAL,FIN2(T12,2,5),FIN2(T12,3,6),
     +                           UVAL,FIN2(T23,5,8),FIN2(T23,6,9))
                  END IF
                ELSE
                  IF (T12.GE.-.001.AND.T12.LE.1.001) THEN
                    CALL TDLINE (UVAL,FIN2(T12,2,5),FIN2(T12,3,6),
     +                           UVAL,FIN2(T31,8,2),FIN2(T31,9,3))
                  ELSE IF (T23.GE.-.001.AND.T23.LE.1.001) THEN
                    CALL TDLINE (UVAL,FIN2(T23,5,8),FIN2(T23,6,9),
     +                           UVAL,FIN2(T31,8,2),FIN2(T31,9,3))
                  END IF
                END IF
  102         CONTINUE
            END IF
          END IF
C
C If V slices are do be drawn, do that.
C
          IF (ILCD.GE.0.AND.VSTP(IRST).GT.0.) THEN
            VMIN=MIN(RTRI(2,ITWK(I)),RTRI(5,ITWK(I)),RTRI(8,ITWK(I)))
            VMAX=MAX(RTRI(2,ITWK(I)),RTRI(5,ITWK(I)),RTRI(8,ITWK(I)))
            IF (VMIN.NE.VMAX) THEN
              VEPS=1.E-3*(VMAX-VMIN)
              IST1=INT((VMIN-VEPS)/VSTP(IRST)+.5+SIGN(.5,VMIN-VEPS))
              IST2=INT((VMAX+VEPS)/VSTP(IRST)-.5+SIGN(.5,VMAX+VEPS))
              DO 103 ISTP=IST1,IST2
                VVAL=REAL(ISTP)*VSTP(IRST)
                IF (RTRI(2,ITWK(I)).NE.RTRI(5,ITWK(I))) THEN
                  T12=FIN1(VVAL,2,5)
                ELSE
                  T12=-1.
                END IF
                IF (RTRI(5,ITWK(I)).NE.RTRI(8,ITWK(I))) THEN
                  T23=FIN1(VVAL,5,8)
                ELSE
                  T23=-1.
                END IF
                IF (RTRI(8,ITWK(I)).NE.RTRI(2,ITWK(I))) THEN
                  T31=FIN1(VVAL,8,2)
                ELSE
                  T31=-1.
                END IF
                IF (VMIN.EQ.MIN(RTRI(2,ITWK(I)),RTRI(5,ITWK(I))).AND.
     +              VMAX.EQ.MAX(RTRI(2,ITWK(I)),RTRI(5,ITWK(I)))) THEN
                  IF (T23.GE.-.001.AND.T23.LE.1.001) THEN
                    CALL TDLINE (FIN2(T12,1,4),VVAL,FIN2(T12,3,6),
     +                           FIN2(T23,4,7),VVAL,FIN2(T23,6,9))
                  ELSE IF (T31.GE.-.001.AND.T31.LE.1.001) THEN
                    CALL TDLINE (FIN2(T12,1,4),VVAL,FIN2(T12,3,6),
     +                           FIN2(T31,7,1),VVAL,FIN2(T31,9,3))
                  END IF
                ELSE
     +          IF (VMIN.EQ.MIN(RTRI(5,ITWK(I)),RTRI(8,ITWK(I))).AND.
     +              VMAX.EQ.MAX(RTRI(5,ITWK(I)),RTRI(8,ITWK(I))))THEN
                  IF (T31.GE.-.001.AND.T31.LE.1.001) THEN
                    CALL TDLINE (FIN2(T23,4,7),VVAL,FIN2(T23,6,9),
     +                           FIN2(T31,7,1),VVAL,FIN2(T31,9,3))
                  ELSE IF (T12.GE.-.001.AND.T12.LE.1.001) THEN
                    CALL TDLINE (FIN2(T12,1,4),VVAL,FIN2(T12,3,6),
     +                           FIN2(T23,4,7),VVAL,FIN2(T23,6,9))
                  END IF
                ELSE
                  IF (T12.GE.-.001.AND.T12.LE.1.001) THEN
                    CALL TDLINE (FIN2(T12,1,4),VVAL,FIN2(T12,3,6),
     +                           FIN2(T31,7,1),VVAL,FIN2(T31,9,3))
                  ELSE IF (T23.GE.-.001.AND.T23.LE.1.001) THEN
                    CALL TDLINE (FIN2(T23,4,7),VVAL,FIN2(T23,6,9),
     +                           FIN2(T31,7,1),VVAL,FIN2(T31,9,3))
                  END IF
                END IF
  103         CONTINUE
            END IF
          END IF
C
C If W slices are do be drawn, do that.
C
          IF (ILCD.GE.0.AND.WSTP(IRST).GT.0.) THEN
            WMIN=MIN(RTRI(3,ITWK(I)),RTRI(6,ITWK(I)),RTRI(9,ITWK(I)))
            WMAX=MAX(RTRI(3,ITWK(I)),RTRI(6,ITWK(I)),RTRI(9,ITWK(I)))
            IF (WMIN.NE.WMAX) THEN
              WEPS=1.E-3*(WMAX-WMIN)
              IST1=INT((WMIN-WEPS)/WSTP(IRST)+.5+SIGN(.5,WMIN-WEPS))
              IST2=INT((WMAX+WEPS)/WSTP(IRST)-.5+SIGN(.5,WMAX+WEPS))
              DO 104 ISTP=IST1,IST2
                WVAL=REAL(ISTP)*WSTP(IRST)
                IF (RTRI(3,ITWK(I)).NE.RTRI(6,ITWK(I))) THEN
                  T12=FIN1(WVAL,3,6)
                ELSE
                  T12=-1.
                END IF
                IF (RTRI(6,ITWK(I)).NE.RTRI(9,ITWK(I))) THEN
                  T23=FIN1(WVAL,6,9)
                ELSE
                  T23=-1.
                END IF
                IF (RTRI(9,ITWK(I)).NE.RTRI(3,ITWK(I))) THEN
                  T31=FIN1(WVAL,9,3)
                ELSE
                  T31=-1.
                END IF
                IF (WMIN.EQ.MIN(RTRI(3,ITWK(I)),RTRI(6,ITWK(I))).AND.
     +              WMAX.EQ.MAX(RTRI(3,ITWK(I)),RTRI(6,ITWK(I)))) THEN
                  IF (T23.GE.-.001.AND.T23.LE.1.001) THEN
                    CALL TDLINE (FIN2(T12,1,4),FIN2(T12,2,5),WVAL,
     +                           FIN2(T23,4,7),FIN2(T23,5,8),WVAL)
                  ELSE IF (T31.GE.-.001.AND.T31.LE.1.001) THEN
                    CALL TDLINE (FIN2(T12,1,4),FIN2(T12,2,5),WVAL,
     +                           FIN2(T31,7,1),FIN2(T31,8,2),WVAL)
                  END IF
                ELSE
     +          IF (WMIN.EQ.MIN(RTRI(6,ITWK(I)),RTRI(9,ITWK(I))).AND.
     +              WMAX.EQ.MAX(RTRI(6,ITWK(I)),RTRI(9,ITWK(I))))THEN
                  IF (T31.GE.-.001.AND.T31.LE.1.001) THEN
                    CALL TDLINE (FIN2(T23,4,7),FIN2(T23,5,8),WVAL,
     +                           FIN2(T31,7,1),FIN2(T31,8,2),WVAL)
                  ELSE IF (T12.GE.-.001.AND.T12.LE.1.001) THEN
                    CALL TDLINE (FIN2(T12,1,4),FIN2(T12,2,5),WVAL,
     +                           FIN2(T23,4,7),FIN2(T23,5,8),WVAL)
                  END IF
                ELSE
                  IF (T12.GE.-.001.AND.T12.LE.1.001) THEN
                    CALL TDLINE (FIN2(T12,1,4),FIN2(T12,2,5),WVAL,
     +                           FIN2(T31,7,1),FIN2(T31,8,2),WVAL)
                  ELSE IF (T23.GE.-.001.AND.T23.LE.1.001) THEN
                    CALL TDLINE (FIN2(T23,4,7),FIN2(T23,5,8),WVAL,
     +                           FIN2(T31,7,1),FIN2(T31,8,2),WVAL)
                  END IF
                END IF
  104         CONTINUE
            END IF
          END IF
C
  105   CONTINUE
C
C Restore entry values of fill and polyline color indices.
C
        IF (ILCC.NE.ILCS) THEN
          CALL PLOTIF (0.,0.,2)
          CALL GSPLCI (ILCS)
        END IF
C
        IF (IFCC.NE.IFCS) CALL GSFACI (IFCS)
C
C Done.
C
        RETURN
C
      END

C
C $Id: ctcell.f,v 1.5 2008-07-27 00:17:25 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CTCELL (Z,MX,NX,NY,M,I0,J0)
C
C CTCELL COMPUTES LINES OF CONSTANT Z (CONTOUR LINES) IN ONE
C CELL OF THE ARRAY Z FOR THE SRFACE PACKAGE.
C Z,MX,NX,NY ARE THE SAME AS IN SRFACE.
C M          BY THE TIME CTCELL IS FIRST CALLED, M CONTAINS
C            THE TWO-SPACE PLOTTER LOCATION OF EACH Z POINT.
C            U(Z(I,J))=M(1,I,J).  V(Z(I,J))=M(2,I,J)
C I0,J0      THE CELL Z(I0,J0) TO Z(I0+1,J0+1) IS THE ONE TO
C            BE CONTOURED.
C
      DIMENSION       Z(MX,NY)   ,M(2,NX,NY)
      COMMON /SRFBLK/ LIMU(1024) ,LIML(1024) ,CL(41)     ,NCL        ,
     1                LL         ,FACT       ,IROT       ,NDRZ       ,
     2                NUPPER     ,NRSWT      ,BIGD       ,UMIN       ,
     3                UMAX       ,VMIN       ,VMAX       ,RZERO      ,
     4                IOFFP      ,NSPVAL     ,SPVAL      ,BIGEST
      DATA IDUB/0/
      R(HO,HU) = (HO-CV)/(HO-HU)
      I1 = I0
      I1P1 = I1+1
      J1 = J0
      J1P1 = J1+1
      H1 = Z(I1,J1)
      H2 = Z(I1,J1P1)
      H3 = Z(I1P1,J1P1)
      H4 = Z(I1P1,J1)
      IF (IOFFP .NE. 1) GO TO  10
      IF (H1.EQ.SPVAL .OR. H2.EQ.SPVAL .OR. H3.EQ.SPVAL .OR.
     1    H4.EQ.SPVAL) RETURN
   10 IF (MIN(H1,H2,H3,H4) .GT. CL(NCL)) RETURN
      DO 110 K=1,NCL
C
C FOR EACH CONTOUR LEVEL, DESIDE WHICH OF THE 16 BASIC SIT-
C UATIONS EXISTS, THEN INTERPOLATE IN TWO-SPACE TO FIND THE
C END POINTS OF THE CONTOUR LINE SEGMENT WITHIN THIS CELL.
C
         CV = CL(K)
         K1 = (INT(SIGN(1.,H1-CV))+1)/2
         K2 = (INT(SIGN(1.,H2-CV))+1)/2
         K3 = (INT(SIGN(1.,H3-CV))+1)/2
         K4 = (INT(SIGN(1.,H4-CV))+1)/2
         JUMP = 1+K1+K2*2+K3*4+K4*8
         GO TO (120, 30, 50, 60, 70, 20, 80, 90, 90, 80,
     1           40, 70, 60, 50, 30,110),JUMP
   20    IDUB = 1
   30    RA = R(H1,H2)
         MUA = REAL(M(1,I1,J1))+RA*REAL(M(1,I1,J1P1)-M(1,I1,J1))
         MVA = REAL(M(2,I1,J1))+RA*REAL(M(2,I1,J1P1)-M(2,I1,J1))
         RB = R(H1,H4)
         MUB = REAL(M(1,I1,J1))+RB*REAL(M(1,I1P1,J1)-M(1,I1,J1))
         MVB = REAL(M(2,I1,J1))+RB*REAL(M(2,I1P1,J1)-M(2,I1,J1))
         GO TO 100
   40    IDUB = -1
   50    RA = R(H2,H1)
         MUA = REAL(M(1,I1,J1P1))+RA*REAL(M(1,I1,J1)-M(1,I1,J1P1))
         MVA = REAL(M(2,I1,J1P1))+RA*REAL(M(2,I1,J1)-M(2,I1,J1P1))
         RB = R(H2,H3)
         MUB = REAL(M(1,I1,J1P1))+RB*REAL(M(1,I1P1,J1P1)-M(1,I1,J1P1))
         MVB = REAL(M(2,I1,J1P1))+RB*REAL(M(2,I1P1,J1P1)-M(2,I1,J1P1))
         GO TO 100
   60    RA = R(H2,H3)
         MUA = REAL(M(1,I1,J1P1))+RA*REAL(M(1,I1P1,J1P1)-M(1,I1,J1P1))
         MVA = REAL(M(2,I1,J1P1))+RA*REAL(M(2,I1P1,J1P1)-M(2,I1,J1P1))
         RB = R(H1,H4)
         MUB = REAL(M(1,I1,J1))+RB*REAL(M(1,I1P1,J1)-M(1,I1,J1))
         MVB = REAL(M(2,I1,J1))+RB*REAL(M(2,I1P1,J1)-M(2,I1,J1))
         GO TO 100
   70    RA = R(H3,H2)
         MUA = REAL(M(1,I1P1,J1P1))+
     1         RA*REAL(M(1,I1,J1P1)-M(1,I1P1,J1P1))
         MVA = REAL(M(2,I1P1,J1P1))+
     1         RA*REAL(M(2,I1,J1P1)-M(2,I1P1,J1P1))
         RB = R(H3,H4)
         MUB = REAL(M(1,I1P1,J1P1))+
     1         RB*REAL(M(1,I1P1,J1)-M(1,I1P1,J1P1))
         MVB = REAL(M(2,I1P1,J1P1))+
     1         RB*REAL(M(2,I1P1,J1)-M(2,I1P1,J1P1))
         IDUB = 0
         GO TO 100
   80    RA = R(H2,H1)
         MUA = REAL(M(1,I1,J1P1))+RA*REAL(M(1,I1,J1)-M(1,I1,J1P1))
         MVA = REAL(M(2,I1,J1P1))+RA*REAL(M(2,I1,J1)-M(2,I1,J1P1))
         RB = R(H3,H4)
         MUB = REAL(M(1,I1P1,J1P1))+
     1         RB*REAL(M(1,I1P1,J1)-M(1,I1P1,J1P1))
         MVB = REAL(M(2,I1P1,J1P1))+
     1         RB*REAL(M(2,I1P1,J1)-M(2,I1P1,J1P1))
         GO TO 100
   90    RA = R(H4,H1)
         MUA = REAL(M(1,I1P1,J1))+RA*REAL(M(1,I1,J1)-M(1,I1P1,J1))
         MVA = REAL(M(2,I1P1,J1))+RA*REAL(M(2,I1,J1)-M(2,I1P1,J1))
         RB = R(H4,H3)
         MUB = REAL(M(1,I1P1,J1))+RB*REAL(M(1,I1P1,J1P1)-M(1,I1P1,J1))
         MVB = REAL(M(2,I1P1,J1))+RB*REAL(M(2,I1P1,J1P1)-M(2,I1P1,J1))
         IDUB = 0
  100    CALL DRAWS (MUA,MVA,MUB,MVB,1,0)
         IF (IDUB)  90,110, 70
  110 CONTINUE
  120 RETURN
      END

C
C $Id: bcsubd.f,v 1.4 2008-07-27 00:17:29 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE BCSUBD(BX,BY,SX,SY,TX,TY)
C
C  Do a midpoint subdivision of the input Bezier curve whose control 
C  points are in BX and BY to create two Bezier curves whose control
C  points are in SX, SY and TX, TY.
C
      DIMENSION BX(4),BY(4),SX(4),SY(4),TX(4),TY(4)
C
      SX(1) = BX(1)
      SY(1) = BY(1)
      SX(2) = .5*(BX(1)+BX(2))
      SY(2) = .5*(BY(1)+BY(2))
      TMPX  = .5*(BX(2)+BX(3))
      TMPY  = .5*(BY(2)+BY(3))
      SX(3) = .5*(SX(2)+TMPX)
      SY(3) = .5*(SY(2)+TMPY)
      TX(4) = BX(4)
      TY(4) = BY(4)
      TX(3) = .5*(BX(3)+BX(4))
      TY(3) = .5*(BY(3)+BY(4))
      TX(2) = .5*(TMPX+TX(3))
      TY(2) = .5*(TMPY+TY(3))
      SX(4) = .5*(SX(3)+TX(2))
      SY(4) = .5*(SY(3)+TY(2))
      TX(1) = SX(4)
      TY(1) = SY(4)
C
      RETURN
      END

c======================================================================
c
c !IROUTINE: capecalc3d -- Calculate CAPE and CIN
c
c !DESCRIPTION:
c
c   If i3dflag=1, this routine calculates CAPE and CIN (in m**2/s**2,
c   or J/kg) for every grid point in the entire 3D domain (treating
c   each grid point as a parcel).  If i3dflag=0, then it
c   calculates CAPE and CIN only for the parcel with max theta-e in
c   the column, (i.e. something akin to Colman's MCAPE).  By "parcel",
c   we mean a 500-m deep parcel, with actual temperature and moisture
c   averaged over that depth.
c
c   In the case of i3dflag=0,
c   CAPE and CIN are 2D fields that are placed in the k=mkzh slabs of
c   the cape and cin arrays.  Also, if i3dflag=0, LCL and LFC heights
c   are put in the k=mkzh-1 and k=mkzh-2 slabs of the cin array.
c
c ASSUMPTIONS:
c
c !REVISION HISTORY:
c     2005-May-15 - Mark T. Stoelinga - oringinal version from RIP4
c     2005-Nov-28 - J. Schramm - modified to run outside of RIP4 with
c     2012-Jul-18 - M. Haley - modified to change/add missing value.
c                                NCL
c
c !INTERFACE:
c ------------------------------------------------------------------
C NCLFORTSTART
      SUBROUTINE DCAPECALC3D(PRS,TMK,QVP,GHT,TER,SFP,CAPE,CIN,CMSG,
     +                       MIY,MJX,MKZH,I3DFLAG,TER_FOLLOW,PSAFILE)
c
      IMPLICIT NONE
      INTEGER MIY,MJX,MKZH,I3DFLAG,TER_FOLLOW
      DOUBLE PRECISION PRS(MIY,MJX,MKZH)
      DOUBLE PRECISION TMK(MIY,MJX,MKZH)
      DOUBLE PRECISION QVP(MIY,MJX,MKZH)
      DOUBLE PRECISION GHT(MIY,MJX,MKZH)
      DOUBLE PRECISION TER(MIY,MJX)
      DOUBLE PRECISION SFP(MIY,MJX)
      DOUBLE PRECISION CAPE(MIY,MJX,MKZH)
      DOUBLE PRECISION CIN(MIY,MJX,MKZH)
      DOUBLE PRECISION CMSG
      CHARACTER*(*) PSAFILE
C NCLEND
c Local variables
      INTEGER I,J,K,ILCL,IUP,KEL,KK,KLCL,KLEV,KLFC,KMAX,KPAR,KPAR1,KPAR2
      DOUBLE PRECISION DAVG,ETHMAX,Q,T,P,E,ETH,TLCL,ZLCL
      DOUBLE PRECISION CP,EPS,GAMMA,GAMMAMD,RGAS,RGASMD,TLCLC1,TLCLC2,
     +                 TLCLC3,TLCLC4
      DOUBLE PRECISION CPMD,THTECON1,THTECON2,THTECON3
      DOUBLE PRECISION CELKEL,EZERO,ESLCON1,ESLCON2,GRAV
      DOUBLE PRECISION PAVG,VIRTUAL,P1,P2,PP1,PP2,TH,TOTTHE,TOTQVP,
     +                 TOTPRS
      DOUBLE PRECISION CPM,DELTAP,ETHPARI,GAMMAM,GHTPARI,QVPPARI,
     +                 PRSPARI,TMKPARI
      DOUBLE PRECISION FACDEN,FAC1,FAC2,QVPLIFT,TMKLIFT,TVENV,TVLIFT,
     +                 GHTLIFT
      DOUBLE PRECISION ESLIFT,TMKENV,QVPENV,TONPSADIABAT
      DOUBLE PRECISION BENAMIN,DZ,PUP,PDN
      DOUBLE PRECISION BUOY(150),ZREL(150),BENACCUM(150),
     +                 PRSF(MIY,MJX,MKZH)
      DOUBLE PRECISION PSADITHTE(150),PSADIPRS(150),PSADITMK(150,150)
c
C The comments were taken from a Mark Stoelinga email, 23 Apr 2007,
C in response to a user getting the "Outside of lookup table bounds"
C error message. 
C
C TMKPARI  - Initial temperature of parcel, K
C    Values of 300 okay. (Not sure how much from this you can stray.)
C
C PRSPARI - Initial pressure of parcel, hPa
C    Values of 980 okay. (Not sure how much from this you can stray.)
C
C THTECON1, THTECON2, THTECON3
C     These are all constants, the first in K and the other two have
C     no units.  Values of 3376, 2.54, and 0.81 were stated as being
C     okay.
C
C TLCL - The temperature at the parcel's lifted condensation level, K
C        should be a reasonable atmospheric temperature around 250-300 K
C        (398 is "way too high")
C
C QVPPARI - The initial water vapor mixing ratio of the parcel,
C           kg/kg (should range from 0.000 to 0.025)
C

c Constants
      IUP = 6
      CELKEL = 273.15D0
      GRAV = 9.81D0
C hPa
      EZERO = 6.112D0
      ESLCON1 = 17.67D0
      ESLCON2 = 29.65D0
      EPS = 0.622D0
C J/K/kg
      RGAS = 287.04D0
C  J/K/kg  Note: not using Bolton's value of 1005.7
      CP = 1004.D0
      GAMMA = RGAS/CP
C  cp_moist=cp*(1.+cpmd*qvp)
      CPMD = .887D0
C  rgas_moist=rgas*(1.+rgasmd*qvp)
      RGASMD = .608D0
C  gamma_moist=gamma*(1.+gammamd*qvp)
      GAMMAMD = RGASMD - CPMD
      TLCLC1 = 2840.D0
      TLCLC2 = 3.5D0
      TLCLC3 = 4.805D0
      TLCLC4 = 55.D0
C  K
      THTECON1 = 3376.D0
      THTECON2 = 2.54D0
      THTECON3 = .81D0
c
c  Calculated the pressure at full sigma levels (a set of pressure
c  levels that bound the layers represented by the vertical grid points)

      CALL DPFCALC(PRS,SFP,PRSF,MIY,MJX,MKZH,TER_FOLLOW)
c
c  Before looping, set lookup table for getting temperature on
c  a pseudoadiabat.
c
      CALL DLOOKUP_TABLE(PSADITHTE,PSADIPRS,PSADITMK,PSAFILE)
c
C   do j=1,mjx-1
      DO J = 1,MJX
C   do i=1,miy-1
          DO I = 1,MIY
              CAPE(I,J,1) = 0.D0
              CIN(I,J,1) = 0.D0
c
              IF (I3DFLAG.EQ.1) THEN
                  KPAR1 = 2
                  KPAR2 = MKZH
              ELSE
c
c      Find parcel with max theta-e in lowest 3 km AGL.
c
                  ETHMAX = -1.D0
                  DO K = MKZH,1,-1
                      IF (GHT(I,J,K)-TER(I,J).LT.3000.D0) THEN
                          Q = MAX(QVP(I,J,K),1.D-15)
                          T = TMK(I,J,K)
                          P = PRS(I,J,K)
                          E = Q*P/ (EPS+Q)
                          TLCL = TLCLC1/ (LOG(T**TLCLC2/E)-TLCLC3) +
     +                           TLCLC4
                          ETH = T* (1000.D0/P)**
     +                          (GAMMA* (1.D0+GAMMAMD*Q))*
     +                          EXP((THTECON1/TLCL-THTECON2)*Q*
     +                          (1.D0+THTECON3*Q))
                          IF (ETH.GT.ETHMAX) THEN
                              KLEV = K
                              ETHMAX = ETH
                          END IF
                      END IF
                  END DO
                  KPAR1 = KLEV
                  KPAR2 = KLEV
c
c      Establish average properties of that parcel
c         (over depth of approximately davg meters)
c
c         davg=.1
                  DAVG = 500.D0
                  PAVG = DAVG*PRS(I,J,KPAR1)*GRAV/
     +                   (RGAS*VIRTUAL(TMK(I,J,KPAR1),QVP(I,J,KPAR1)))
                  P2 = MIN(PRS(I,J,KPAR1)+.5D0*PAVG,PRSF(I,J,MKZH))
                  P1 = P2 - PAVG
                  TOTTHE = 0.D0
                  TOTQVP = 0.D0
                  TOTPRS = 0.D0
                  DO K = MKZH,2,-1
                      IF (PRSF(I,J,K).LE.P1) GO TO 35
                      IF (PRSF(I,J,K-1).GE.P2) GO TO 34
                      P = PRS(I,J,K)
                      PUP = PRSF(I,J,K)
                      PDN = PRSF(I,J,K-1)
                      Q = MAX(QVP(I,J,K),1.D-15)
                      TH = TMK(I,J,K)* (1000.D0/P)**
     +                     (GAMMA* (1.D0+GAMMAMD*Q))
                      PP1 = MAX(P1,PDN)
                      PP2 = MIN(P2,PUP)
                      IF (PP2.GT.PP1) THEN
                          DELTAP = PP2 - PP1
                          TOTQVP = TOTQVP + Q*DELTAP
                          TOTTHE = TOTTHE + TH*DELTAP
                          TOTPRS = TOTPRS + DELTAP
                      END IF
   34                 CONTINUE
                  END DO
   35             CONTINUE
                  QVPPARI = TOTQVP/TOTPRS
                  TMKPARI = (TOTTHE/TOTPRS)*
     +                      (PRS(I,J,KPAR1)/1000.D0)** (GAMMA*
     +                      (1.D0+GAMMAMD*QVP(I,J,KPAR1)))
              END IF
c
              DO KPAR = KPAR1,KPAR2
c
c   Calculate temperature and moisture properties of parcel
c     (Note, qvppari and tmkpari already calculated above for 2D case.)
c
                  IF (I3DFLAG.EQ.1) THEN
                      QVPPARI = QVP(I,J,KPAR)
                      TMKPARI = TMK(I,J,KPAR)
                  END IF
                  PRSPARI = PRS(I,J,KPAR)
                  GHTPARI = GHT(I,J,KPAR)
                  GAMMAM = GAMMA* (1.D0+GAMMAMD*QVPPARI)
                  CPM = CP* (1.D0+CPMD*QVPPARI)
c
                  E = MAX(1.D-20,QVPPARI*PRSPARI/ (EPS+QVPPARI))
                  TLCL = TLCLC1/ (LOG(TMKPARI**TLCLC2/E)-TLCLC3) +
     +                   TLCLC4
                  ETHPARI = TMKPARI* (1000.D0/PRSPARI)**
     +                      (GAMMA* (1.D0+GAMMAMD*QVPPARI))*
     +                      EXP((THTECON1/TLCL-THTECON2)*QVPPARI*
     +                      (1.D0+THTECON3*QVPPARI))
                  ZLCL = GHTPARI + (TMKPARI-TLCL)/ (GRAV/CPM)
c
c   Calculate buoyancy and relative height of lifted parcel at
c   all levels, and store in bottom up arrays.  Add a level at the LCL,
c   and at all points where buoyancy is zero.
c
C  for arrays that go bottom to top
                  KK = 0
                  ILCL = 0
                  IF (GHTPARI.GE.ZLCL) THEN
c
c      initial parcel already saturated or supersaturated.
c
                      ILCL = 2
                      KLCL = 1
                  END IF
                  DO K = KPAR,1,-1
C  for arrays that go bottom to top
   33                 KK = KK + 1
C  model level is below LCL
                      IF (GHT(I,J,K).LT.ZLCL) THEN
                          QVPLIFT = QVPPARI
                          TMKLIFT = TMKPARI - GRAV/CPM*
     +                              (GHT(I,J,K)-GHTPARI)
                          TVENV = VIRTUAL(TMK(I,J,K),QVP(I,J,K))
                          TVLIFT = VIRTUAL(TMKLIFT,QVPLIFT)
                          GHTLIFT = GHT(I,J,K)
                      ELSE IF (GHT(I,J,K).GE.ZLCL .AND. ILCL.EQ.0) THEN
c
c     This model level and previous model level straddle the LCL,
c     so first create a new level in the bottom-up array, at the LCL.
c
                          TMKLIFT = TLCL
                          QVPLIFT = QVPPARI
                          FACDEN = GHT(I,J,K) - GHT(I,J,K+1)
                          FAC1 = (ZLCL-GHT(I,J,K+1))/FACDEN
                          FAC2 = (GHT(I,J,K)-ZLCL)/FACDEN
                          TMKENV = TMK(I,J,K+1)*FAC2 + TMK(I,J,K)*FAC1
                          QVPENV = QVP(I,J,K+1)*FAC2 + QVP(I,J,K)*FAC1
                          TVENV = VIRTUAL(TMKENV,QVPENV)
                          TVLIFT = VIRTUAL(TMKLIFT,QVPLIFT)
                          GHTLIFT = ZLCL
                          ILCL = 1
                      ELSE
                          TMKLIFT = TONPSADIABAT(ETHPARI,PRS(I,J,K),
     +                              PSADITHTE,PSADIPRS,PSADITMK,GAMMA)
                          ESLIFT = EZERO*EXP(ESLCON1* (TMKLIFT-CELKEL)/
     +                             (TMKLIFT-ESLCON2))
                          QVPLIFT = EPS*ESLIFT/ (PRS(I,J,K)-ESLIFT)
                          TVENV = VIRTUAL(TMK(I,J,K),QVP(I,J,K))
                          TVLIFT = VIRTUAL(TMKLIFT,QVPLIFT)
                          GHTLIFT = GHT(I,J,K)
                      END IF
C  buoyancy
                      BUOY(KK) = GRAV* (TVLIFT-TVENV)/TVENV
                      ZREL(KK) = GHTLIFT - GHTPARI
                      IF ((KK.GT.1).AND.
     +                    (BUOY(KK)*BUOY(KK-1).LT.0.0D0)) THEN
c
c   Parcel ascent curve crosses sounding curve, so create a new level
c   in the bottom-up array at the crossing.
c
                          KK = KK + 1
                          BUOY(KK) = BUOY(KK-1)
                          ZREL(KK) = ZREL(KK-1)
                          BUOY(KK-1) = 0.D0
                          ZREL(KK-1) = ZREL(KK-2) +
     +                                 BUOY(KK-2)/ (BUOY(KK-2)-
     +                                 BUOY(KK))* (ZREL(KK)-ZREL(KK-2))
                      END IF
                      IF (ILCL.EQ.1) THEN
                          KLCL = KK
                          ILCL = 2
                          GO TO 33
                      END IF
                  END DO
                  KMAX = KK
                  IF (KMAX.GT.150) THEN
                      print *,
     +                  'capecalc3d: kmax got too big. kmax=',KMAX
                      STOP
                  END IF
c
c   If no LCL was found, set klcl to kmax.  It is probably not really
c   at kmax, but this will make the rest of the routine behave
c   properly.
c
                  IF (ILCL.EQ.0) KLCL=KMAX
c
c   Get the accumulated buoyant energy from the parcel's starting
c   point, at all levels up to the top level.
c
                  BENACCUM(1) = 0.0D0
                  BENAMIN = 9D9
                  DO K = 2,KMAX
                      DZ = ZREL(K) - ZREL(K-1)
                      BENACCUM(K) = BENACCUM(K-1) +
     +                              .5D0*DZ* (BUOY(K-1)+BUOY(K))
                      IF (BENACCUM(K).LT.BENAMIN) THEN
                          BENAMIN = BENACCUM(K)
                      END IF
                  END DO
c
c     Determine equilibrium level (EL), which we define as the highest
c     level of non-negative buoyancy above the LCL. Note, this may be
c     the top level if the parcel is still buoyant there.
c
                  DO K = KMAX,KLCL,-1
                      IF (BUOY(K).GE.0.D0) THEN
C  k of equilibrium level
                          KEL = K
                          GO TO 50
                      END IF
                  END DO
c
c   If we got through that loop, then there is no non-negative
c   buoyancy above the LCL in the sounding.  In these situations,
c   both CAPE and CIN will be set to -0.1 J/kg. (See below about
c   missing values in V6.1.0). Also, where CAPE is
c   non-zero, CAPE and CIN will be set to a minimum of +0.1 J/kg, so
c   that the zero contour in either the CIN or CAPE fields will
c   circumscribe regions of non-zero CAPE.
c
c   In V6.1.0 of NCL, we added a _FillValue attribute to the return
c   value of this function. At that time we decided to change -0.1 
c   to a more appropriate missing value, which is passed into this 
c   routine as CMSG.
c
c                 CAPE(I,J,KPAR) = -0.1D0
c                 CIN(I,J,KPAR) = -0.1D0
                  CAPE(I,J,KPAR) = CMSG
                  CIN(I,J,KPAR)  = CMSG
                  KLFC = KMAX
c
                  GO TO 102
c
   50             CONTINUE
c
c   If there is an equilibrium level, then CAPE is positive.  We'll
c   define the level of free convection (LFC) as the point below the
c   EL, but at or above the LCL, where accumulated buoyant energy is a
c   minimum.  The net positive area (accumulated buoyant energy) from
c   the LFC up to the EL will be defined as the CAPE, and the net
c   negative area (negative of accumulated buoyant energy) from the
c   parcel starting point to the LFC will be defined as the convective
c   inhibition (CIN).
c
c   First get the LFC according to the above definition.
c
                  BENAMIN = 9D9
                  KLFC = KMAX
                  DO K = KLCL,KEL
                      IF (BENACCUM(K).LT.BENAMIN) THEN
                          BENAMIN = BENACCUM(K)
                          KLFC = K
                      END IF
                  END DO
c
c   Now we can assign values to cape and cin
c
                  CAPE(I,J,KPAR) = MAX(BENACCUM(KEL)-BENAMIN,0.1D0)
                  CIN(I,J,KPAR) = MAX(-BENAMIN,0.1D0)
c
c   CIN is uninteresting when CAPE is small (< 100 J/kg), so set
c   CIN to -0.1 (see note about missing values in V6.1.0) in 
c   that case.
c
c   In V6.1.0 of NCL, we added a _FillValue attribute to the return
c   value of this function. At that time we decided to change -0.1 
c   to a more appropriate missing value, which is passed into this 
c   routine as CMSG.
c
C                 IF (CAPE(I,J,KPAR).LT.100.D0) CIN(I,J,KPAR) = -0.1D0
                  IF (CAPE(I,J,KPAR).LT.100.D0) CIN(I,J,KPAR) = CMSG
  102             CONTINUE
c
              END DO
c
              IF (I3DFLAG.EQ.0) THEN
                  CAPE(I,J,MKZH) = CAPE(I,J,KPAR1)
                  CIN(I,J,MKZH) = CIN(I,J,KPAR1)
C  meters AGL
                  CIN(I,J,MKZH-1) = ZREL(KLCL) + GHTPARI - TER(I,J)
C  meters AGL
                  CIN(I,J,MKZH-2) = ZREL(KLFC) + GHTPARI - TER(I,J)
              END IF
c
          END DO
      END DO
c
      RETURN
      END
c                                                                     c
c*********************************************************************c
c                                                                     c
C NCLFORTSTART
      DOUBLE PRECISION FUNCTION TONPSADIABAT(THTE,PRS,PSADITHTE,
     &                                       PSADIPRS,PSADITMK,GAMMA)
      IMPLICIT NONE
      DOUBLE PRECISION THTE
      DOUBLE PRECISION PRS
      DOUBLE PRECISION PSADITHTE
      DOUBLE PRECISION PSADIPRS
      DOUBLE PRECISION PSADITMK
      DOUBLE PRECISION GAMMA
C NCLEND
      DOUBLE PRECISION FRACJT
      DOUBLE PRECISION FRACJT2
      DOUBLE PRECISION FRACIP
      DOUBLE PRECISION FRACIP2
      DIMENSION PSADITHTE(150),PSADIPRS(150),PSADITMK(150,150)
      INTEGER IP, IPCH, JT, JTCH
c                                                                     c
c   This function gives the temperature (in K) on a moist adiabat
c   (specified by thte in K) given pressure in hPa.  It uses a
c   lookup table, with data that was generated by the Bolton (1980)
c   formula for theta_e.
c
c     First check if pressure is less than min pressure in lookup table.
c     If it is, assume parcel is so dry that the given theta-e value can
c     be interpretted as theta, and get temperature from the simple dry
c     theta formula.
c
      IF (PRS.LE.PSADIPRS(150)) THEN
          TONPSADIABAT = THTE* (PRS/1000.D0)**GAMMA
          RETURN
      END IF
c
c   Otherwise, look for the given thte/prs point in the lookup table.
c
      DO JTCH = 1,150 - 1
          IF (THTE.GE.PSADITHTE(JTCH) .AND.
     +        THTE.LT.PSADITHTE(JTCH+1)) THEN
              JT = JTCH
              GO TO 213
          END IF
      END DO
      JT = -1
  213 CONTINUE
      DO IPCH = 1,150 - 1
          IF (PRS.LE.PSADIPRS(IPCH) .AND. PRS.GT.PSADIPRS(IPCH+1)) THEN
              IP = IPCH
              GO TO 215
          END IF
      END DO
      IP = -1
  215 CONTINUE
      IF (JT.EQ.-1 .OR. IP.EQ.-1) THEN
         print *,'capecalc3d: ',
     +           'Outside of lookup table bounds. prs,thte=',
     +      PRS,THTE
          STOP
      END IF
      FRACJT = (THTE-PSADITHTE(JT))/ (PSADITHTE(JT+1)-PSADITHTE(JT))
      FRACJT2 = 1.D0 - FRACJT
      FRACIP = (PSADIPRS(IP)-PRS)/ (PSADIPRS(IP)-PSADIPRS(IP+1))
      FRACIP2 = 1.D0 - FRACIP
      IF (PSADITMK(IP,JT).GT.1D9 .OR. PSADITMK(IP+1,JT).GT.1D9 .OR.
     +    PSADITMK(IP,JT+1).GT.1D9 .OR. PSADITMK(IP+1,JT+1).GT.1D9) THEN
          print *,'capecalc3d: ',
     +      'Tried to access missing temperature in lookup table.',
     +      'Prs and Thte probably unreasonable. prs,thte=',PRS,THTE
          STOP
      END IF
      TONPSADIABAT = FRACIP2*FRACJT2*PSADITMK(IP,JT) +
     +               FRACIP*FRACJT2*PSADITMK(IP+1,JT) +
     +               FRACIP2*FRACJT*PSADITMK(IP,JT+1) +
     +               FRACIP*FRACJT*PSADITMK(IP+1,JT+1)
c
      RETURN
      END
c                                                                     c
c*********************************************************************c
      SUBROUTINE DLOOKUP_TABLE(PSADITHTE,PSADIPRS,PSADITMK,FNAME)
      DOUBLE PRECISION PSADITHTE
      DOUBLE PRECISION PSADIPRS
      DOUBLE PRECISION PSADITMK
c   Set up lookup table for getting temperature on a pseudoadiabat.
c   (Borrow the unit number for the stationlist, just for the moment.)
c
C      CHARACTER*15 FNAME
      CHARACTER*(*) FNAME
      DIMENSION PSADITHTE(150),PSADIPRS(150),PSADITMK(150,150)

C      FNAME = 'psadilookup.dat'
      IUSTNLIST = 33
      OPEN (UNIT=IUSTNLIST,FILE=FNAME,FORM='formatted',STATUS='old')
      DO I = 1,14
          READ (IUSTNLIST,FMT=*)
      END DO
      READ (IUSTNLIST,FMT=*) NTHTE,NPRS
      IF (NTHTE.NE.150 .OR. NPRS.NE.150) THEN
          WRITE (IUP,FMT=*)
     +      'Number of pressure or theta_e levels in lookup table'
          WRITE (IUP,FMT=*) 'file not = 150.  Check lookup table file.'
          STOP
      END IF
      READ (IUSTNLIST,FMT=173) (PSADITHTE(JT),JT=1,NTHTE)
      READ (IUSTNLIST,FMT=173) (PSADIPRS(IP),IP=1,NPRS)
      READ (IUSTNLIST,FMT=173) ((PSADITMK(IP,JT),IP=1,NPRS),JT=1,NTHTE)
  173 FORMAT (5D15.7)
      CLOSE (IUSTNLIST)

      RETURN
      END
c                                                                     c
c*********************************************************************c
c                                                                     c
      SUBROUTINE DPFCALC(PRS,SFP,PF,MIY,MJX,MKZH,TER_FOLLOW)
      DOUBLE PRECISION PRS
      DOUBLE PRECISION SFP
      DOUBLE PRECISION PF
c
c     Historically, this routine calculated the pressure at full sigma
c     levels when RIP was specifically designed for MM4/MM5 output.
c     With the new generalized RIP (Feb '02), this routine is still
c     intended to calculate a set of pressure levels that bound the
c     layers represented by the vertical grid points, although no such
c     layer boundaries are assumed to be defined.  The routine simply
c     uses the midpoint between the pressures of the vertical grid
c     points as the bounding levels.  The array only contains mkzh
c     levels, so the pressure of the top of the uppermost layer is
c     actually excluded.  The kth value of pf is the lower bounding
c     pressure for the layer represented by kth data level.  At the
c     lower bounding level of the lowest model layer, it uses the
c     surface pressure, unless the data set is pressure-level data, in
c     which case it assumes the lower bounding pressure level is as far
c     below the lowest vertical level as the upper bounding pressure
c     level is above.
c
      DIMENSION PRS(MIY,MJX,MKZH),SFP(MIY,MJX),PF(MIY,MJX,MKZH)
      INTEGER TER_FOLLOW
c
C  do j=1,mjx-1  Artifact of MM5
      DO J = 1,MJX
C  do i=1,miy-1  staggered grid
          DO I = 1,MIY
              DO K = 1,MKZH
                  IF (K.EQ.MKZH) THEN
C  terrain-following data
                      IF (TER_FOLLOW.EQ.1) THEN
                          PF(I,J,K) = SFP(I,J)
C  pressure-level data
                      ELSE
                          PF(I,J,K) = .5D0* (3.D0*PRS(I,J,K)-
     +                                PRS(I,J,K-1))
                      END IF
                  ELSE
                      PF(I,J,K) = .5D0* (PRS(I,J,K+1)+PRS(I,J,K))
                  END IF
              END DO
          END DO
      END DO
c
      RETURN
      END
c======================================================================
c
c !IROUTINE: VIRTUAL -- Calculate virtual temperature (K)
c
c !DESCRIPTION:
c
c   This function returns a single value of virtual temperature in
c   K, given temperature in K and mixing ratio in kg/kg.  For an
c   array of virtual temperatures, use subroutine VIRTUAL_TEMP.
c
c !INPUT:
c    RATMIX - water vapor mixing ratio (kg/kg)
c    TEMP   - temperature (K)
c
c !OUTPUT:
c    TV     - Virtual temperature (K)
c
c !ASSUMPTIONS:
c
c !REVISION HISTORY:
c     2009-March  - Mark T. Stoelinga - from RIP4.5
c     2010-August - J. Schramm - modified to run with NCL and ARW wrf output
c
c ------------------------------------------------------------------
C NCLFORTSTART
      DOUBLE PRECISION FUNCTION VIRTUAL(TEMP,RATMIX)
      IMPLICIT NONE
      DOUBLE PRECISION TEMP,RATMIX
C NCLEND
      DOUBLE PRECISION EPS
      EPS = 0.622D0
      VIRTUAL = TEMP* (EPS+RATMIX)/ (EPS* (1.D0+RATMIX))
      RETURN
      END

C NCLFORTSTART
      SUBROUTINE STATTROPX(NLEV,NLEVM,PFULL,TFULL,TMSG,LAPSEC,PUNIT
     +                     ,PTROP,ITROP,LAPSE,PHALF,PMB)
      IMPLICIT NONE
c                                                   ! INPUT
      INTEGER NLEV, NLEVM, PUNIT
      DOUBLE PRECISION PFULL(NLEV),TFULL(NLEV),TMSG,LAPSEC
c                                                   ! OUTPUT
      DOUBLE PRECISION PTROP
      INTEGER ITROP
c                                                   ! Work arrays
      DOUBLE PRECISION LAPSE(NLEVM),PHALF(NLEVM)
      DOUBLE PRECISION PMB(NLEV)
C NCLEND

c NCL  trop = trop_wmo(p,t,opt)
      INTEGER N

C      NLEVM = NLEV + 1
C                            DSTATTROP REQUIRES mb  [ hPa ]
      IF (PUNIT.EQ.0) THEN
          DO N=1,NLEV
             PMB(N) = PFULL(N)
          END DO
      ELSE
          DO N=1,NLEV
             PMB(N) = PFULL(N)*0.01D0
          END DO
      END IF

      CALL DSTATTROP(NLEV,PMB,TFULL,TMSG,LAPSEC,PTROP,ITROP
     +              ,NLEVM,LAPSE,PHALF)

C                                RETURN AS Pascals [ Pa ] if necessary
      IF (PUNIT.NE.0) THEN
          PTROP = PTROP*100.D0
      END IF

C SUBTRACT ONE FOR NCL 0-BASED INDEXING

      ITROP = ITROP -1

      RETURN
      END

      SUBROUTINE DSTATTROP(NLEV,PFULL,TFULL,TMSG,LAPSEC,PTROP,ITROP
     +                    ,NLEVM,LAPSE,PHALF)
c
c**********************************************************************
c     input : p, t        real(nlev)
c     input : nlev        real
c     output: ptrop       real
c     output: itrop     integer
c
c     programmed by Dominik Brunner              V1.0 Aug 2000
c     modified for use within NCL                D Shea Jan 2009
c
c     built upon routine stattrop by Peter van Velthoven,
c     KNMI, The Netherlands
c     and on the ECHAM4/CHEM routine xttphwmo by
c     Thomas Reichle, Christine Land, B. Steil and R. Hein, DLR
c
c     purpose
c     -------
c     stattrop computes the pressure (Pa) at the thermal (static) tropopause
c     (TP) for a 1D column (sounding) of pressures and temperatures following
c     the definition of the height of the tropopause as postulated by WMO (1957).
c
c     ATTENTION: In the current formulation of the program the first
c     level (index 1) must be at the top of the atmosphere and the
c     last level (index nlev) at the surface
c
c     interface
c     ---------
c     call stattrop(pfull, tfull, nlev, ptrop, itrop)
c     - Input
c       nlev : number of vertical levels
c       pfull: pressure in 1D column at nlev full levels (layers)
c       tfull: temperature in 1D column at nlev full levels
c     - Output
c       ptrop: height of the tropopause in Pa
c       itrop: index of *layer* containing the tropopause
c
c     methods
c     -------
c     - Lapse rate gamma = -dT/dz
c       Using the hydrostatic approximation
c
c       dz = -dp/(g*rho) = -dp/p * R/g * T = -dlnp * R/g * T
c
c       we get -dT/dz = dT/T * g/R *1/dlnp = dlnT/dlnp
c
c     - Variables are assumed to vary linearly in log(pressure)
c     - The tropopause is the lowest level above 450 hPa fullfilling
c       the WMO criterium. If ptrop is < 85 hPa it is set to 85 hPa.
c       If no tropopause is found ptrop is set to 'tmsg'.
c
c     references
c     ----------
c
c     - WMO (1992): International meteorological vocabulary, Genf, 784pp.:
c
c       " 1. The first tropopause is defined as the lowest level at which
c       the lapse rate decreases to 2 deg C per kilometer or less,
c       provided also the average lapse rate between this level and
c       all higher levels within 2 kilometers does not exceed 2 deg C"
c
c     - Randel WJ, Wu F, Gaffen DJ, Interannual variability of the tropical
c       tropopause derived from radiosonde data and NCEP reanalyses,
c       JOURNAL OF GEOPHYSICAL RESEARCH, 105, 15509-15523, 2000.
c
c       The following webpage clearifies the calculation of the tropopause
c       in the NCEP reanalysis: http://dss.ucar.edu/pub/reanalysis/FAQ.html
c
c       For comparison NCEP reanalysis tropopause pressures can be obtained
c       from http://www.cdc.noaa.gov/cdc/reanalysis/reanalysis.shtml
c
c**********************************************************************

      IMPLICIT NONE
c                                                   ! INPUT
      INTEGER NLEV,NLEVM
      DOUBLE PRECISION PFULL(NLEV),TFULL(NLEV),TMSG,LAPSEC
      DOUBLE PRECISION LAPSE(NLEVM),PHALF(NLEVM)
c                                                   ! OUTPUT
      DOUBLE PRECISION PTROP
      INTEGER ITROP
C NCLEND

      DOUBLE PRECISION PMIN, PMAX, P1, P2, WEIGHT
      DOUBLE PRECISION DELTAZ,P2KM,LAPSEAVG,LAPSESUM
      DOUBLE PRECISION GRAV,RGAS,CONST,RINVAL
      PARAMETER (GRAV=9.80665D0,RGAS=287.04D0
     +          ,CONST=1000.D0*GRAV/RGAS)
      INTEGER ILEV,ILEV1,KOUNT,L
      LOGICAL FOUND

      RINVAL = TMSG
      PTROP = RINVAL
      FOUND = .false.
      ITROP = -999

c c c do ilev=1,nlevm
c c c     lapse(ilev) = tmsg
c c c     phalf(ilev) = tmsg
c c c end do

c     deltaz is layer thickness used for second tropopause criterium
c     pmin and pmax allowed tropopause pressure

      DELTAZ = 2.D0
      PMIN   = 85.D0
      PMAX   = 450.D0

c     Loop from model top to surface and calculate lapse rate gamma=-dT/dz (K/km)
      DO ILEV = 1,NLEV - 1
          ILEV1 = ILEV + 1
          LAPSE(ILEV) = DLOG(TFULL(ILEV)) - DLOG(TFULL(ILEV1))
          LAPSE(ILEV) = LAPSE(ILEV)/ (DLOG(PFULL(ILEV))-
     +                  DLOG(PFULL(ILEV1)))
          LAPSE(ILEV) = CONST*LAPSE(ILEV)
          PHALF(ILEV) = (PFULL(ILEV)+PFULL(ILEV1))*0.5D0

c c c    print *,ilev, lapse(ilev),  phalf(ilev)
      END DO

c     Loop from surface to top to find (lowest) tropopause

      DO ILEV = NLEV - 2,1,-1
c 1st test: -dT/dz less than 2 K/km and pressure LT pmax? ****
          IF (LAPSE(ILEV).LT.LAPSEC .AND. PFULL(ILEV).LT.PMAX) THEN
              IF (.NOT.FOUND) THEN
c Interpolate tropopause pressure linearly in log(p)
                  P1 = DLOG(PHALF(ILEV))
                  P2 = DLOG(PHALF(ILEV+1))
                  IF (LAPSE(ILEV).NE.LAPSE(ILEV+1)) THEN
                      WEIGHT = (LAPSEC-LAPSE(ILEV))/
     +                         (LAPSE(ILEV+1)-LAPSE(ILEV))
c                                                ! tropopause pressure
                      PTROP = EXP(P1+WEIGHT* (P2-P1))
                  ELSE
                      PTROP = PHALF(ILEV)
                  END IF
c 2nd test: average -dT/dz in layer deltaz above TP
c           must not be greater than 2K/km
c           press 2 km above TP
                  P2KM = EXP(DLOG(PTROP)-DELTAZ*CONST/TFULL(ILEV))

c init avg. lapse rate 2 km above TP
                  LAPSESUM = 0.0D0
                  LAPSEAVG = 1.D9

                  KOUNT = 0
                  DO L = ILEV,1,-1
                      IF (PHALF(L).LT.P2KM) GO TO 100
                      LAPSESUM = LAPSESUM + LAPSE(L)
                      KOUNT = KOUNT + 1
                      LAPSEAVG = LAPSESUM/KOUNT
                  END DO
  100             CONTINUE

                  FOUND = LAPSEAVG .LT. LAPSEC
c     Discard tropopause?
                  IF (.NOT.FOUND) THEN
                      PTROP = RINVAL
                  ELSE
c ptrop must be .ge. 85 hPa; assign level (layer) index
                      PTROP = MAX(PTROP,PMIN)
                      ITROP = ILEV
                  END IF
              END IF
          END IF
      END DO

c c c if (.not.found) then
c c c    write(*,*)
c c c&       'STATTROP-warning: no static tropopause found:'
c c c    write(*,*) 'phalf:', phalf
c c c    write(*,*) 'lapse:', lapse
c c c end if

      RETURN
      END

C
C	$Id: gtint.f,v 1.4 2008-07-27 12:23:44 haley Exp $
C                                                                      
C			     Copyright (C)  1997
C	     University Corporation for Atmospheric Research
C			     All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C

      SUBROUTINE GTINT(STRING, STRMAX, STRSIZ, IOS, STATUS)
C
C  Get a string of integers from the input file.  The special symbol
C  "W" is interpreted to be the wordsize in bits of the host machine.
C  The special symbol "W1" is interpreted as W-1.
C
C  INPUT
C       STRMAX  --  The maximum number of integer values
C                   to transfer.
C
C  OUTPUT
C       STRING  --  The array of integer values.
C       STRSIZ  --  The number of integer values actually
C                   transfered.
C       IOS     --  I/O status flag.  This flag is valid only
C                   if STATUS indicates an error.
C       STATUS  --  The error status as defined in COMMON CAPERR.
C
      COMMON /CAPERR/ ALLOK, EOFFL, INTERR, MAXINT, PLBERR, PMBERR,
     1                FABERR, TXBERR, FLTERR, MAXFLT, NOTINT, SIZERR,
     2                UNDASC, DEVERR, DOCERR, TBLERR , STSZER, ENTERR,
     3                TABERR, TABSER, PRSFIL
      INTEGER ALLOK, EOFFL, INTERR, MAXINT, PLBERR, PMBERR,
     1        FABERR, TXBERR, FLTERR, MAXFLT, NOTINT, SIZERR, UNDASC,
     2        DEVERR, DOCERR, STSZER, ENTERR, TABERR, TABSER, TBLERR,
     3        PRSFIL
      COMMON /CAPIOB/ UNIT, IPTR, LSIZE, NFST, NFLG
      COMMON /CAPIO2/ LINE, GRNM
      INTEGER LNMAX
      PARAMETER (LNMAX=80)
      CHARACTER*80 LINE
      CHARACTER*80 GRNM
      INTEGER UNIT, IPTR, LSIZE, NFST, NFLG
C
      INTEGER STRMAX, STRING(STRMAX), STRSIZ, IOS, STATUS
      INTEGER CURVAL, II
C
C  Set STRING size to null.
C
      STRSIZ = 0
C
C  Skip blanks.
C
 10   CONTINUE
      CALL SKPBLK(IOS, STATUS)
      IF (STATUS .NE. ALLOK) RETURN
C
C  Try to get an integer.
C
      II = IPTR
      CALL INTCNV(CURVAL, II, IOS, STATUS)
      IF (STATUS.NE.ALLOK) THEN
        IF (STATUS .EQ. NOTINT) STATUS = ALLOK
        RETURN
      END IF
C
C  If the requested number of values has not been extracted,
C  try to get another value, otherwise set error condition and
C  return.
C
      IF (STRSIZ .LT. STRMAX) THEN
        STRSIZ = STRSIZ + 1
        STRING(STRSIZ) = CURVAL
        GO TO 10
      ELSE
        STATUS = SIZERR
        RETURN
      END IF
      END

C
C $Id: TdpackDemo.f,v 1.8 2008-07-27 00:59:07 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      PROGRAM TDDEMO
C
C Declare parameters specifying the maximum sizes of the data-defining
C arrays and the size of the triangle-list array.
C
        PARAMETER (IMAX=81,JMAX=81,KMAX=81,MTRI=80000)
C
C Declare local dimensioned variables to hold data defining a simple
C surface or an isosurface.
C
        DIMENSION U(IMAX),V(JMAX),W(KMAX),S(IMAX,JMAX),F(IMAX,JMAX,KMAX)
C
C Declare the local dimensioned variable in which the triangle list is
C to be constructed and a couple of temporary variables used in sorting
C the list.
C
        DIMENSION RTRI(10,MTRI),RTWK(MTRI,2),ITWK(MTRI)
C
C Declare some character variables into which to encode numeric and
C informational labels for the axes.
C
        CHARACTER*128 UNLB,VNLB,WNLB,UILB,VILB,WILB,PILB
C
C Declare some character variables in which formats for encoding the
C numeric labels are kept.
C
        CHARACTER*16 UFMT,VFMT,WFMT
C
C Define a character variable into which to read a file name.
C
        CHARACTER*128 FLNM
C
C Define a character variable into which to read commands.
C
        CHARACTER*1 COMD
C
C Declare a variable to hold the names of the various mark types.
C
        CHARACTER*15 IMKT(5)
C
C Define the conversion constant from degrees to radians.
C
        DATA DTOR / .017453292519943 /
C
C Set the default handedness of the coordinate system.  This must match
C the default value of the TDPACK internal parameter 'HND'.  Zero means
C a right-handed system, one a left-handed system.
C
        DATA IHND / 0 /
C
C Set the default value of the parameter that says whether or not the
C X workstation will be updated as changes are made.  (When making a
C movie, it's a good idea to set this to zero.)
C
        DATA IUXW / 1 /
C
C Set the default value of the surface selector.
C
        DATA ISAS / -1 /
C
C Set the default values of the dimensions of the data arrays.
C
        DATA IDIM,JDIM,KDIM / 21,21,21 /
C
C Set the default value of the flag that says whether the basic color
C scheme will be white on black (IBOW=0) or black on white (IBOW=1).
C
        DATA IBOW / 0 /
C
C Set the default values of parameters determining the eye position, the
C position of the point looked at, and the field of view.
C
        DATA ANG1,ANG2,REYE,RAPT,FOVP / -35.,25.,2.9,0.,20. /
C
C Set the default value of the TDPACK character multiplier.
C
        DATA RCS1 / 1.25 /
C
C Set the default value of the parameter that says to compute new center
C positions for the exponentials used to generate dummy surfaces and
C isosurfaces.  Basically, with ICEN = 0, the same surface will be
C generated by consecutive calls to GENDAT or to TDGNDT, even if the
C dimensions of the data array are changed, but, with ICEN = 1, a
C different surface will be generated each time.
C
        DATA ICEN / 0 /
C
C Set the default cut-off values for generated isosurfaces.
C
        DATA FIS1,FIS2 / 95.,95. /
C
C Set the default value of the multiplier for the random number term
C in the code used to compute the surface/isosurface data.
C
        DATA RNDM / 0. /
C
C Set the default value of the parameter that says what kinds of grids
C are to be drawn.
C
        DATA IGDF / 13 /
C
C Set the default value of parameters that specify the grid spacing.
C
        DATA UGIN,VGIN,WGIN / 1.,1.,1. /
C
C Set the default value of parameters that specify the label spacing.
C
        DATA ULIN,VLIN,WLIN / 5.,5.,5. /
C
C Set the default values of parameters specifying how the numeric labels
C are to be encoded.
C
        DATA UFMT / '(21(1X,F5.1))' /
        DATA VFMT / '(21(1X,F5.1))' /
        DATA WFMT / '(21(1X,F5.1))' /
C
C Set the default values of the U, V, and W axis labels and the plot
C label.
C
        DATA UILB / 'U Coordinate Values' /
        DATA VILB / 'V Coordinate Values' /
        DATA WILB / 'W Coordinate Values' /
C
        DATA PILB / ' ' /
C
C Set the default value of the parameter that controls fading of axis
C labels for rotation angles near multiples of 90 degrees.
C
        DATA IFDE / 0 /
C
C Set the default values of parameters used to position the plot label.
C
        DATA PILX,PILY / 0. , .54 /
C
C Set the default value of the flag that says whether or not to draw a
C 3D grid of marks.
C
        DATA IMRK / 0 /
C
C Set the default value of the mark size parameter.
C
        DATA SMRK / .025 /
C
C Set the default value of parameters that specify the mark spacing.
C
        DATA UMKS,VMKS,WMKS / 5.,5.,5. /
C
C Set the default value of the parameter that determines how the
C triangles are ordered.  This will be used as the final argument in
C calls to TDOTRI.
C
        DATA IORD / 0 /
C
C Define default values of the shading parameters.
C
        DATA SHDE,SHDR,ISHD,ANG3,ANG4
     +       /.15,  1.,   0,  0.,  0./
C
C Define default values of the rendering-style parameters.
C
        DATA IFCB,IFCT,ILCB,ILCT,IDTR,USIN,VSIN,WSIN
     +       /  4,   2, 116, 116,   0,  1.,  1.,  1./
C
C Set a couple of counters that keep track of how many NCGM and
C PostScript frames have been saved.
C
        DATA NFNG,NFPS / 0,0 /
C
C Set the default value of the stereo-view flag.  The user can set it
C negative to get stereo views on a single frame or positive to get
C stereo views on separate frames.  In either case, its absolute value
C is the angle, in degrees, between the lines of sight of the two views.
C
        DATA STVF / 0. /
C
C When STVF is set negative. WOSW is the width of each stereo window,
C as a fraction of the width of the plotter frame.  If this value is
C set greater than .5, the windows will overlap slightly.
C
        DATA WOSW / .5 /
C
C Define the names of the various mark types.
C
        DATA IMKT / 'a tetrahedron.','an octahedron.','a cube.',
     +                         'an icosahedron.', 'a "sphere".'/
C
C Open GKS.
C
        CALL GOPKS (6,0)
C
C Open and activate an X workstation.
C
        CALL GOPWK (1,0,8)
        CALL GACWK (1)
C
C Open and activate an NCGM workstation.
C
        CALL GOPWK (2,0,1)
        CALL GACWK (2)
C
C Open and activate a PostScript workstation.
C
        CALL GOPWK (3,0,20)
        CALL GACWK (3)
C
C Turn clipping off.
C
        CALL GSCLIP (0)
C
C Select a "fill area interior style" of "solid".
C
        CALL GSFAIS (1)
C
C Double the line width.
C
        CALL GSLWSC (2.)
C
C Define colors on all the workstations.
C
        DO 102 IWID=1,3
          CALL TDCLRS (IWID,IBOW,SHDE,SHDR,101,116,0)
  102   CONTINUE
C
C Save the values of SHDE and SHDR.
C
        SSHE=SHDE
        SSHR=SHDR
C
C Deactivate the NCGM and PostScript workstations.
C
        CALL GDAWK (2)
        CALL GDAWK (3)
C
C Select font number 25, turn on the outlining of filled fonts, set the
C line width to 1, and turn off the setting of the outline color.
C
        CALL PCSETI ('FN - FONT NUMBER',25)
        CALL PCSETI ('OF - OUTLINE FLAG',1)
        CALL PCSETR ('OL - OUTLINE LINE WIDTH',1.)
        CALL PCSETR ('OC - OUTLINE LINE COLOR',-1.)
C
C Compute values defining the surface to be depicted.
C
  103   PRINT * , 'Generating U data.'
C
        DO 104 I=1,IDIM
          U(I)=REAL(I-1)
  104   CONTINUE
C
        UMIN=U(   1)
        UMAX=U(IDIM)
        UMID=.5*(UMIN+UMAX)
C
        PRINT * , 'Generating V data.'
C
        DO 105 J=1,JDIM
          V(J)=REAL(J-1)
  105   CONTINUE
C
        VMIN=V(   1)
        VMAX=V(JDIM)
        VMID=.5*(VMIN+VMAX)
C
        PRINT * , 'Generating W data.'
C
        DO 106 K=1,KDIM
          W(K)=REAL(K-1)
  106   CONTINUE
C
        WMIN=W(   1)
        WMAX=W(KDIM)
        WMID=.5*(WMIN+WMAX)
C
C Generate data representing a simple surface, a sphere, a torus, two
C interlocking tori, three joined tori, or any of the above with some
C added random noise, depending on the value of ISAS.
C
        IF (ISAS.LT.0) THEN
          PRINT * , 'Generating a simple random surface.'
          CALL GENDAT (S,IMAX,IDIM,JDIM,23,23,WMIN,WMAX,ICEN)
          IF (RNDM.NE.0.) CALL ADDRAN (F,IMAX,IDIM,JDIM,WMIN,WMAX,RNDM)
        ELSE IF (ISAS.EQ.0) THEN
          PRINT * , 'Generating a random isosurface.'
          CALL TDGNDT (F,IMAX,JMAX,IDIM,JDIM,KDIM,23,23,0.,190.,ICEN)
          IF (RNDM.NE.0.) CALL TDADRN (F,IMAX,JMAX,IDIM,JDIM,KDIM,
     +                                               0.,190.,RNDM)
        ELSE IF (ISAS.GE.1.AND.ISAS.LE.5) THEN
          PRINT * , 'Generating a canned isosurface.'
          FMIN=+1.E36
          FMAX=-1.E36
          DO 109 I=1,IDIM
            UTMP=1.-2.*(REAL(IDIM-I)/REAL(IDIM-1))
            DO 108 J=1,JDIM
              VTMP=1.-2.*(REAL(JDIM-J)/REAL(JDIM-1))
              DO 107 K=1,KDIM
                WTMP=1.-2.*(REAL(KDIM-K)/REAL(KDIM-1))
                IF      (ISAS.EQ.1) THEN
                  F(I,J,K)=100.*SQRT(UTMP**2+VTMP**2+WTMP**2)
                ELSE IF (ISAS.EQ.2) THEN
                  F(I,J,K)=380.*
     +                     SQRT((SQRT(UTMP**2+VTMP**2)-.7)**2+WTMP**2)
                ELSE IF (ISAS.EQ.3) THEN
                  F(I,J,K)=380.*
     +                     MIN(SQRT((SQRT((1.35*UTMP+.35)**2+
     +                          (1.35*VTMP)**2)-.7)**2+(1.35*WTMP)**2),
     +                         SQRT((SQRT((1.35*UTMP-.35)**2+
     +                          (1.35*WTMP)**2)-.7)**2+(1.35*VTMP)**2))
                ELSE IF (ISAS.EQ.4) THEN
                  F(I,J,K)=760.*MIN(
     +                     SQRT((SQRT(UTMP**2+VTMP**2)-.7)**2+WTMP**2),
     +                     SQRT((SQRT(WTMP**2+UTMP**2)-.7)**2+VTMP**2),
     +                     SQRT((SQRT(VTMP**2+WTMP**2)-.7)**2+UTMP**2))
                ELSE IF (ISAS.EQ.5) THEN
                  F(I,J,K)=4.*FIS1*(UTMP**2+VTMP**2-.75*WTMP**2)
                END IF
                FMIN=MIN(FMIN,F(I,J,K))
                FMAX=MAX(FMAX,F(I,J,K))
  107         CONTINUE
  108       CONTINUE
  109     CONTINUE
          IF (RNDM.NE.0.) CALL TDADRN (F,IMAX,JMAX,IDIM,JDIM,KDIM,
     +                                             FMIN,FMAX,RNDM)
        END IF
C
C Get triangles representing the surface, to be rendered using rendering
C style 1.
C
  110   PRINT * , 'Generating triangles representing the surface.'
C
        NTRI=0
C
        IF (ISAS.LT.0.OR.(ISAS.GE.99.AND.ISAS.LE.105)) THEN
          CALL TDSTRI (U,IDIM,V,JDIM,S,IMAX,RTRI,MTRI,NTRI,1)
          IF (NTRI.LT.MTRI) THEN
            PRINT * , 'Percentage of triangle space used by TDSTRI:',
     +                                INT(100.*REAL(NTRI)/REAL(MTRI))
          ELSE
            PRINT * , 'Triangle space overflow on call to TDSTRI.'
          END IF
        ELSE
          IF (FIS1.EQ.FIS2) THEN
            CALL TDITRI (U,IDIM,V,JDIM,W,KDIM,F,IMAX,JMAX,FIS1,
     +                                        RTRI,MTRI,NTRI,1)
          ELSE
            CALL TDITRI (U,IDIM,V,JDIM,W,KDIM,F,IMAX,JMAX,FIS1,
     +                                        RTRI,MTRI,NTRI,2)
            CALL TDITRI (U,IDIM,V,JDIM,W,KDIM,F,IMAX,JMAX,FIS2,
     +                                        RTRI,MTRI,NTRI,3)
          END IF
          IF (NTRI.LT.MTRI) THEN
            PRINT * , 'Percentage of triangle space used by TDITRI:',
     +                                INT(100.*REAL(NTRI)/REAL(MTRI))
          ELSE
            PRINT * , 'Triangle space overflow on call to TDITRI.'
          END IF
        END IF
C
C If it's been requested, put a 3D grid of marks inside the viewing box.
C
        IF (IMRK.NE.0) THEN
C
          IF (UMKS.GT.0..AND.UMAX-UMIN.LE.20.*UMKS) THEN
            UEPS=1.E-3*(UMAX-UMIN)
            IST1=INT((UMIN-UEPS)/UMKS+.5+SIGN(.5,UMIN-UEPS))
            IST2=INT((UMAX+UEPS)/UMKS-.5+SIGN(.5,UMAX+UEPS))
          ELSE
            IST1=1
            IST2=0
          END IF
C
          IF (VMKS.GT.0..AND.VMAX-VMIN.LE.20.*VMKS) THEN
            VEPS=1.E-3*(VMAX-VMIN)
            JST1=INT((VMIN-VEPS)/VMKS+.5+SIGN(.5,VMIN-VEPS))
            JST2=INT((VMAX+VEPS)/VMKS-.5+SIGN(.5,VMAX+VEPS))
          ELSE
            JST1=1
            JST2=0
          END IF
C
          IF (WMKS.GT.0..AND.WMAX-WMIN.LE.20.*WMKS) THEN
            WEPS=1.E-3*(WMAX-WMIN)
            KST1=INT((WMIN-WEPS)/WMKS+.5+SIGN(.5,WMIN-WEPS))
            KST2=INT((WMAX+WEPS)/WMKS-.5+SIGN(.5,WMAX+WEPS))
          ELSE
            KST1=1
            KST2=0
          END IF
C
          IF (IST1.LE.IST2.AND.JST1.LE.JST2.AND.KST1.LE.KST2) THEN
            SIZE=SMRK*MIN(UMAX-UMIN,VMAX-VMIN,WMAX-WMIN)
            DO 903 I=IST1,IST2
              UVAL=UMKS*REAL(I)
              DO 902 J=JST1,JST2
                VVAL=VMKS*REAL(J)
                DO 901 K=KST1,KST2
                  WVAL=WMKS*REAL(K)
                  CALL TDMTRI (IMRK,UVAL,VVAL,WVAL,SIZE,
     +                         RTRI,MTRI,NTRI,4,
     +                         UMIN,VMIN,WMIN,UMAX,VMAX,WMAX)
  901           CONTINUE
  902         CONTINUE
  903       CONTINUE
          ELSE
            PRINT * , 'Omitting marks - either one of the specified'
            PRINT * , 'mark intervals is non-positive or the marks'
            PRINT * , 'would be too crowded.'
          END IF
C
        END IF
C
C Tell the user what the minima and maxima are.
C
  111   PRINT * , 'U minimum and maximum: ',UMIN,UMAX
        PRINT * , 'V minimum and maximum: ',VMIN,VMAX
        PRINT * , 'W minimum and maximum: ',WMIN,WMAX
C
C Define numeric and informational labels for the plot.
C
        PRINT * , 'Encoding labels for the plot.'
C
        IF (ULIN.GT.0.) THEN
          IF (UMAX-UMIN.LE.20.*ULIN) THEN
            UEPS=1.E-3*(UMAX-UMIN)
            IST1=INT((UMIN-UEPS)/ULIN+.5+SIGN(.5,UMIN-UEPS))
            IST2=INT((UMAX+UEPS)/ULIN-.5+SIGN(.5,UMAX+UEPS))
            WRITE (UNLB,UFMT) (ULIN*REAL(I),I=IST1,IST2)
          ELSE
            PRINT *, 'Omitting too-dense numeric labels in U direction.'
            UNLB=' '
          END IF
        END IF
C
        IF (VLIN.GT.0.) THEN
          IF (VMAX-VMIN.LE.20.*VLIN) THEN
            VEPS=1.E-3*(VMAX-VMIN)
            JST1=INT((VMIN-VEPS)/VLIN+.5+SIGN(.5,VMIN-VEPS))
            JST2=INT((VMAX+VEPS)/VLIN-.5+SIGN(.5,VMAX+VEPS))
            WRITE (VNLB,VFMT) (VLIN*REAL(J),J=JST1,JST2)
          ELSE
            PRINT *, 'Omitting too-dense numeric labels in V direction.'
            VNLB=' '
          END IF
        END IF
C
        IF (WLIN.GT.0.) THEN
          IF (WMAX-WMIN.LE.20.*WLIN) THEN
            WEPS=1.E-3*(WMAX-WMIN)
            KST1=INT((WMIN-WEPS)/WLIN+.5+SIGN(.5,WMIN-WEPS))
            KST2=INT((WMAX+WEPS)/WLIN-.5+SIGN(.5,WMAX+WEPS))
            WRITE (WNLB,WFMT) (WLIN*REAL(K),K=KST1,KST2)
          ELSE
            PRINT *, 'Omitting too-dense numeric labels in W direction.'
            WNLB=' '
          END IF
        END IF
C
C Set the overall character multiplier for TDPACK.
C
        CALL TDSETR ('CS1',RCS1)
C
C Define rendering styles 1, 2, and 3.
C
        PRINT * , 'Defining rendering styles.'
C
        IF (IFCB.LT.0.OR.IFCB.GT.7.OR.SHDE.EQ.0.) THEN
          IFC1=IFCB
          IFC2=IFCB
        ELSE
          IFC1=101+IFCB*16
          IFC2=116+IFCB*16
        END IF
C
        IF (IFCT.LT.0.OR.IFCT.GT.7.OR.SHDE.EQ.0.) THEN
          IFC3=IFCT
          IFC4=IFCT
        ELSE
          IFC3=101+IFCT*16
          IFC4=116+IFCT*16
        END IF
C
        IF (USIN.NE.0..AND.UMAX-UMIN.LE.50.*USIN) THEN
          USIM=1.
        ELSE
          IF (USIN.NE.0.)
     +    PRINT * , 'Omitting too-dense slice lines in U direction.'
          USIM=0.
        END IF
C
        IF (VSIN.NE.0..AND.VMAX-VMIN.LE.50.*VSIN) THEN
          VSIM=1.
        ELSE
          IF (VSIN.NE.0.)
     +    PRINT * , 'Omitting too-dense slice lines in V direction.'
          VSIM=0.
        END IF
C
        WSIM=1.
C
        IF (WSIN.NE.0..AND.WMAX-WMIN.LE.50.*WSIN) THEN
          WSIM=1.
        ELSE
          IF (WSIN.NE.0.)
     +    PRINT * , 'Omitting too-dense slice lines in W direction.'
          WSIM=0.
        END IF
C
        CALL TDSTRS (1,IFC1,IFC2,IFC3,IFC4,ILCB,ILCT,IDTR,
     +                      USIM*USIN,VSIM*VSIN,WSIM*WSIN)
        CALL TDSTRS (2, 109, 116,IFC3,IFC4,  -1,ILCT,IDTR,
     +                      USIM*USIN,VSIM*VSIN,WSIM*WSIN)
        CALL TDSTRS (3,IFC1,IFC2, 109, 116,ILCB,  -1,IDTR,
     +                      USIM*USIN,VSIM*VSIN,WSIM*WSIN)
        CALL TDSTRS (4, 109, 116, 213, 228,  -1,  -1,   0,
     +                             0.,       0.,       0.)
C
C Check for too-dense grid lines.
C
        PRINT * , 'Checking grid parameters.'
C
        IF (UGIN.GT.0.) THEN
          IF (UMAX-UMIN.LE.50.*UGIN) THEN
            UGIM=1.
          ELSE
            PRINT * , 'Omitting too-dense grid lines in U direction.'
            UGIM=0.
          END IF
        END IF
C
        IF (VGIN.GT.0.) THEN
          IF (VMAX-VMIN.LE.50.*VGIN) THEN
            VGIM=1.
          ELSE
            PRINT * , 'Omitting too-dense grid lines in V direction.'
            VGIM=0.
          END IF
        END IF
C
        IF (WGIN.GT.0.) THEN
          IF (WMAX-WMIN.LE.50.*WGIN) THEN
            WGIM=1.
          ELSE
            PRINT * , 'Omitting too-dense grid lines in W direction.'
            WGIM=0.
          END IF
        END IF
C
C Determine the positions of the eye and the point looked at.
C
        PRINT * , 'Determining eye position.'
C
        DOFB=SQRT((UMAX-UMIN)**2+(VMAX-VMIN)**2+(WMAX-WMIN)**2)
        DEYE=REYE*DOFB
        DAPT=RAPT*DOFB
C
        UEYE=UMID+DEYE*COS(DTOR*ANG1)*COS(DTOR*ANG2)
        VEYE=VMID+DEYE*SIN(DTOR*ANG1)*COS(DTOR*ANG2)
        WEYE=WMID+DEYE*SIN(DTOR*ANG2)
C
        UAPT=UMID-DAPT*COS(DTOR*ANG1)*COS(DTOR*ANG2)
        VAPT=VMID-DAPT*SIN(DTOR*ANG1)*COS(DTOR*ANG2)
        WAPT=WMID-DAPT*SIN(DTOR*ANG2)
C
C Compute some derivative quantities that are needed to put a label on
C the plot.
C
        UDNL=UMID-UEYE
        VDNL=VMID-VEYE
        WDNL=WMID-WEYE
C
        IF (IHND.EQ.0) THEN
          UDNX=VMID-VEYE
          VDNX=UEYE-UMID
          WDNX=0.
          UDNY=VDNX*WDNL-VDNL*WDNX
          VDNY=WDNX*UDNL-WDNL*UDNX
          WDNY=UDNX*VDNL-UDNL*VDNX
        ELSE
          UDNX=VEYE-VMID
          VDNX=UMID-UEYE
          WDNX=0.
          UDNY=VDNL*WDNX-VDNX*WDNL
          VDNY=WDNL*UDNX-WDNX*UDNL
          WDNY=UDNL*VDNX-UDNX*VDNL
        END IF
C
        DNOM=SQRT(UDNX*UDNX+VDNX*VDNX+WDNX*WDNX)
        UDCX=UDNX/DNOM
        VDCX=VDNX/DNOM
        WDCX=WDNX/DNOM
C
        DNOM=SQRT(UDNY*UDNY+VDNY*VDNY+WDNY*WDNY)
        UDCY=UDNY/DNOM
        VDCY=VDNY/DNOM
        WDCY=WDNY/DNOM
C
        CALL TDGETR ('CS1',CSM1)
        CSM2=CSM1*MIN(UMAX-UMIN,VMAX-VMIN,WMAX-WMIN)
C
C Initialize TDPACK.
C
        PRINT * , 'Initializing TDPACK.'
C
        CALL TDINIT (UEYE,VEYE,WEYE,UAPT,VAPT,WAPT,UAPT,VAPT,WAPT+1.,0.)
        CALL GETSET (XVPL,XVPR,YVPB,YVPT,XWDL,XWDR,YWDB,YWDT,LNLG)
C
C If the X workstation is not to be updated, jump to get user input.
C
        IF (IUXW.EQ.0) GO TO 112
C
C Clear the X workstation.
C
        CALL GCLRWK (1,1)
C
C Draw the plot label, if any.  The plot label is positioned in a
C rectangle that is perpendicular to the line of sight and passes
C through the midpoint of the data box; some algebra is required to
C come up with the direction cosines of the sides of that rectangle.
C We can then call TDPARA to define it as the current reference
C parallelogram and TDPLCH to draw a label relative to the rectangle.
C
        IF (PILB.NE.' ') THEN
          PRINT * , 'Drawing plot label.'
          CALL TDPARA (UMID-.5*DOFB*(UDCX+UDCY),
     +                 VMID-.5*DOFB*(VDCX+VDCY),
     +                 WMID-.5*DOFB*(WDCX+WDCY),
     +                 UDCX,VDCX,WDCX,UDCY,VDCY,WDCY)
          CALL TDPLCH ((.5+PILX)*DOFB,(.5+PILY)*DOFB,
     +                 PILB(1:LNBPCS(PILB)),.04*CSM2,0.,0.)
        END IF
C
C Put some simple labels on the axes of the plot.  If the last argument
C in the call to TDLBLS is a zero, all six outer edges of the projection
C of the box are labelled; if the argument is non-zero, then only three
C edges are labelled (which three depends on the sign of the argument),
C which gives one set of U axis labels, one set of V axis labels, and
C one set of W axis labels.  If the label fading flag is set and the
C viewing angle is close to a multiple of 90 degrees, the polyline and
C fill area color indices are set so as to do the fade (useful mostly
C when a movie is being made).
C
        IF (IGDF.NE.0) THEN
C
          PRINT * , 'Drawing axis labels.'
C
          IF (IFDE.NE.0) THEN
            ANGM=MOD(ANG1,90.)
            IF (ANGM.LT. 0.) ANGM=90.+ANGM
            IF (ANGM.GT.45.) ANGM=90.-ANGM
            MANG=101+INT(ANGM)
          ELSE
            MANG=116
          END IF
C
          IF (MANG.GT.101) THEN
            IF (MANG.GE.102.AND.MANG.LE.115) THEN
              CALL SFLUSH
              IF (IBOW.EQ.0) THEN
                CALL GSPLCI (217-MANG)
                CALL GSFACI (217-MANG)
              ELSE
                CALL GSPLCI (MANG)
                CALL GSFACI (MANG)
              END IF
            END IF
            CALL TDLBLS (UMIN,VMIN,WMIN,UMAX,VMAX,WMAX,
     +                   UNLB,VNLB,WNLB,UILB,VILB,WILB,1)
            IF (MANG.GE.102.AND.MANG.LE.115) THEN
              CALL SFLUSH
              CALL GSPLCI (1)
              CALL GSFACI (1)
            END IF
          END IF
C
C Draw the sides of the box that could be hidden.
C
          PRINT * , 'Drawing far sides of box.'
C
          CALL TDGRDS (UMIN,VMIN,WMIN,UMAX,VMAX,WMAX,
     +                 UGIM*UGIN,VGIM*VGIN,WGIM*WGIN,IGDF,1)
C
        END IF
C
C Draw all the triangles.
C
        PRINT * , 'Rendering surface.'
C
        CALL TDOTRI (RTRI,MTRI,NTRI,RTWK,ITWK,IORD)
        CALL TDDTRI (RTRI,MTRI,NTRI,ITWK)
C
C Draw the sides of the box that cannot be hidden.
C
        IF (IGDF.NE.0) THEN
C
          PRINT * , 'Drawing near sides of box.'
C
          CALL TDGRDS (UMIN,VMIN,WMIN,UMAX,VMAX,WMAX,
     +                 UGIM*UGIN,VGIM*VGIN,WGIM*WGIN,IGDF,0)
C
        END IF
C
C Flush buffers and update the X workstation.
C
        CALL SFLUSH
        CALL GUWK (1,0)
C
C Let the user enter a command.
C
  112   PRINT * , ' '
        PRINT * , 'Enter a command (H for help, Q for quit):'
C
        READ  '(A1)', COMD
C
        IF      (COMD.EQ.'D'.OR.COMD.EQ.'d') THEN
C
          IF (ISAS.GE. 99) ISAS=ISAS-100
          ISAS=MAX(-1,MIN(5,ISAS))
          PRINT * , ' '
          PRINT * , 'Change the type of data displayed (Y or N)?'
          READ  '(A1)', COMD
          IF (COMD.EQ.'Y'.OR.COMD.EQ.'y') THEN
            PRINT * , ' '
            PRINT * , 'The current surface type selector is ',ISAS
            PRINT * , ' '
            PRINT * , 'Enter -1 for a random surface, 0 for a random'
            PRINT * , 'isosurface, 1-5 for various canned isosurfaces,'
            PRINT * , '6 or greater to read a data file.'
            CALL TDRDIN (ITMP,ISAS)
            IF (ITMP.LE.5) THEN
              ISAS=MAX(-1,ITMP)
            ELSE
              PRINT * , ' '
              PRINT * , 'Enter the name of a data file:'
              READ '(A128)' , FLNM
              OPEN (13,FILE=FLNM(1:LNBPCS(FLNM)),STATUS='OLD',
     +                                         FORM='FORMATTED',ERR=113)
              PRINT * , 'File opened successfully.'
              READ (13,'(2I4)',ERR=113) IDIM,JDIM
              IF (IDIM.LT.1.OR.IDIM.GT.IMAX.OR.
     +            JDIM.LT.1.OR.JDIM.GT.JMAX) THEN
                PRINT * , 'Dimensions read are out of range!'
                GO TO 112
              END IF
              READ (13,'(6E12.0)',ERR=113,END=114)
     +                                     UMIN,UMAX,VMIN,VMAX,WMIN,WMAX
              UMID=.5*(UMIN+UMAX)
              VMID=.5*(VMIN+VMAX)
              WMID=.5*(WMIN+WMAX)
              READ (13,'(6E12.0)',ERR=113,END=114) (U(I),I=1,IDIM)
              READ (13,'(6E12.0)',ERR=113,END=114) (V(I),I=1,JDIM)
              READ (13,'(6E12.0)',ERR=113,END=114)
     +                                ((S(I,J),I=1,IDIM),J=1,JDIM)
              CLOSE (13)
              ISAS=ISAS+100
              GO TO 110
  113         PRINT * , ' '
              PRINT * , 'Error trying to read data file!'
              GO TO 112
  114         PRINT * , ' '
              PRINT * , 'Premature EOF on data file!'
              GO TO 112
            END IF
          END IF
          PRINT * , ' '
          PRINT * , 'Change the data dimensions (Y or N)?'
          READ  '(A1)', COMD
          IF (COMD.EQ.'Y'.OR.COMD.EQ.'y') THEN
            PRINT * , ' '
            PRINT * , 'Current dimensions are as follows:'
            PRINT * , '  1st data dimension: ',IDIM
            PRINT * , '  2nd data dimension: ',JDIM
            PRINT * , '  3rd data dimension: ',KDIM
            PRINT * , ' '
            PRINT * , 'Enter the new 1st data dimension:'
            CALL TDRDIN (IDIM,IDIM)
            IDIM=MAX(5,MIN(IMAX,IDIM))
            PRINT * , 'Enter the new 2nd data dimension:'
            CALL TDRDIN (JDIM,JDIM)
            JDIM=MAX(5,MIN(JMAX,JDIM))
            PRINT * , 'Enter the new 3rd data dimension:'
            CALL TDRDIN (KDIM,KDIM)
            JDIM=MAX(5,MIN(KMAX,KDIM))
          END IF
          IF (ISAS.LE.0) THEN
            PRINT * , ' '
            PRINT * , 'Use old centers for exponentials (Y or N)?'
            READ  '(A1)', COMD
            IF (COMD.EQ.'Y'.OR.COMD.EQ.'y') THEN
              ICEN=0
            ELSE
              ICEN=1
            END IF
          END IF
          GO TO 103
C
        ELSE IF (COMD.EQ.'G'.OR.COMD.EQ.'g') THEN
C
          PRINT * , ' '
          PRINT * , 'Current value of grid type selector: ',IGDF
          PRINT * , ' '
          PRINT * , 'Enter new value of grid type selector (a 2-digit'
          PRINT * , 'integer).  The first digit applies to the near'
          PRINT * , 'sides of the box and the second to the far sides'
          PRINT * , 'of the box.  Each digit is a 0 (nothing), a 1'
          PRINT * , '(perimeter only), a 2 (perimeter plus ticks),'
          PRINT * , 'or a 3 (perimeter plus grid lines):'
          CALL TDRDIN (IGDF,IGDF)
          IGDF=10*MAX(0,MIN(3,IGDF/10))+MAX(0,MIN(3,MOD(IGDF,10)))
          IF (IGDF.NE.0) THEN
            PRINT * , ' '
            PRINT * , 'Change spacing of grid lines (Y or N)?'
            READ  '(A1)', COMD
            IF (COMD.EQ.'Y'.OR.COMD.EQ.'y') THEN
              PRINT * , ' '
              PRINT * , 'Current spacing of grid lines:'
              PRINT * , '  Grid-line spacing in U: ',UGIN
              PRINT * , '  Grid-line spacing in V: ',VGIN
              PRINT * , '  Grid-line spacing in W: ',WGIN
              PRINT * , ' '
              PRINT * , 'Enter new value for grid-line spacing in U:'
              CALL TDRDRN (UGIN,UGIN)
              UGIN=MAX(0.,UGIN)
              PRINT * , 'Enter new value for grid-line spacing in V:'
              CALL TDRDRN (VGIN,VGIN)
              VGIN=MAX(0.,VGIN)
              PRINT * , 'Enter new value for grid-line spacing in W:'
              CALL TDRDRN (WGIN,WGIN)
              WGIN=MAX(0.,WGIN)
            END IF
            PRINT * , ' '
            PRINT * , 'Change spacing of numeric labels (Y or N)?'
            READ  '(A1)', COMD
            IF (COMD.EQ.'Y'.OR.COMD.EQ.'y') THEN
            PRINT * , ' '
              PRINT * , 'Current spacing of numeric labels:'
              PRINT * , '  Numeric-label spacing in U: ',ULIN
              PRINT * , '  Numeric-label spacing in V: ',VLIN
              PRINT * , '  Numeric-label spacing in W: ',WLIN
              PRINT * , ' '
              PRINT * , 'Enter new value for label spacing in U:'
              CALL TDRDRN (ULIN,ULIN)
              ULIN=MAX(0.,ULIN)
              PRINT * , 'Enter new value for label spacing in V:'
              CALL TDRDRN (VLIN,VLIN)
              VLIN=MAX(0.,VLIN)
              PRINT * , 'Enter new value for label spacing in W:'
              CALL TDRDRN (WLIN,WLIN)
              WLIN=MAX(0.,WLIN)
            END IF
            PRINT * , ' '
            PRINT * , 'Change formats for numeric labels (Y or N)?'
            READ  '(A1)', COMD
            IF (COMD.EQ.'Y'.OR.COMD.EQ.'y') THEN
            PRINT * , ' '
              PRINT * , 'Current formats for numeric labels:'
              PRINT * , '  Format for U labels: ',UFMT(1:LNBPCS(UFMT))
              PRINT * , '  Format for V labels: ',VFMT(1:LNBPCS(VFMT))
              PRINT * , '  Format for W labels: ',WFMT(1:LNBPCS(WFMT))
              PRINT * , ' '
              PRINT * , 'Formats must not be more than 16 characters'
              PRINT * , 'long and must not specify a line more than'
              PRINT * , '128 characters long.  Enter them carefully.'
              PRINT * , ' '
              PRINT * , 'Enter new U format:'
              READ '(A16)' , UFMT
              PRINT * , 'Enter new V format:'
              READ '(A16)' , VFMT
              PRINT * , 'Enter new W format:'
              READ '(A16)' , WFMT
            END IF
            PRINT * , ' '
            PRINT * , 'Change informational labels (Y or N)?'
            READ  '(A1)', COMD
            IF (COMD.EQ.'Y'.OR.COMD.EQ.'y') THEN
              PRINT * , ' '
              PRINT * , 'Current U axis label:',UILB(1:LNBPCS(UILB))
              PRINT * , 'Current V axis label:',VILB(1:LNBPCS(VILB))
              PRINT * , 'Current W axis label:',WILB(1:LNBPCS(WILB))
              PRINT * , 'Current plot label:  ',PILB(1:LNBPCS(PILB))
              PRINT * , ' '
              PRINT * , 'Enter new U axis label:'
              READ '(A128)' , UILB
              PRINT * , 'Enter new V axis label:'
              READ '(A128)' , VILB
              PRINT * , 'Enter new W axis label:'
              READ '(A128)' , WILB
              PRINT * , 'Enter new plot label:'
              READ '(A128)' , PILB
            END IF
            PRINT * , ' '
            PRINT * , 'Change informational-label positions (Y or N)?'
            READ  '(A1)', COMD
            IF (COMD.EQ.'Y'.OR.COMD.EQ.'y') THEN
              PRINT * , ' '
              PRINT * , 'Current plot label position (horizontal):',PILX
              PRINT * , 'Current plot label position (vertical):  ',PILY
              PRINT * , ' '
              PRINT * , 'Enter new plot label position (horizontal):'
              CALL TDRDRN (PILX,PILX)
              PILX=MAX(-1.,MIN(1.,PILX))
              PRINT * , 'Enter new plot label position (vertical):'
              CALL TDRDRN (PILY,PILY)
              PILY=MAX(-1.,MIN(1.,PILY))
            END IF
            PRINT * , ' '
            IF (IFDE.NE.0) THEN
              PRINT * , 'Axis labels are currently faded for azimuth ang
     +les near 90 degrees.'
            ELSE
              PRINT * , 'Axis labels are not currently faded for azimuth
     + angles near 90 degrees.'
            END IF
            PRINT * , ' '
            PRINT * , 'Fade labels for azimuth angles near 90 degrees (Y
     + or N)?'
            READ  '(A1)', COMD
            IF (COMD.EQ.'Y'.OR.COMD.EQ.'y') THEN
              IFDE=1
            ELSE
              IFDE=0
            END IF
          END IF
          GO TO 111
C
        ELSE IF (COMD.EQ.'H'.OR.COMD.EQ.'h') THEN
C
          PRINT * , ' '
          PRINT * , 'Possible commands are as follows:'
          PRINT * , '  D  =>  Data change'
          PRINT * , '  G  =>  Grid change'
          PRINT * , '  H  =>  Help'
          PRINT * , '  M  =>  Miscellaneous changes'
          PRINT * , '  Q  =>  Quit'
          PRINT * , '  R  =>  Refresh/rendering change'
          PRINT * , '  S  =>  Save plot (NCGM and/or PostScript)'
          PRINT * , '  V  =>  View change'
          GO TO 112
C
        ELSE IF (COMD.EQ.'M'.OR.COMD.EQ.'m') THEN
C
          PRINT * , ' '
          IF (IBOW.EQ.0) THEN
            PRINT * , 'The color scheme flag is now 0 (white on black).'
          ELSE
            PRINT * , 'The color scheme flag is now 1 (black on white).'
          END IF
          PRINT * , ' '
          PRINT * , 'Enter new color scheme flag (0 => WOB, 1 => BOW):'
          CALL TDRDIN (ITMP,IBOW)
          ITMP=MAX(0,MIN(1,ITMP))
          IF (ITMP.NE.IBOW) THEN
            IBOW=ITMP
            CALL GCLRWK (1,1)
            DO 115 IWID=1,3
              IF (IWID.NE.1) CALL GACWK (IWID)
              IF (IBOW.EQ.0) THEN
                CALL GSCR (IWID,0,0.,0.,0.) ! black
                CALL GSCR (IWID,1,1.,1.,1.) ! white
              ELSE
                CALL GSCR (IWID,0,1.,1.,1.) ! white
                CALL GSCR (IWID,1,0.,0.,0.) ! black
              END IF
              IF (IWID.NE.1) CALL GDAWK (IWID)
  115       CONTINUE
            SSHE=SHDE
            SSHR=SHDR
          END IF
C
          PRINT * , ' '
          IF (IUXW.EQ.0) THEN
            PRINT * , 'The X-workstation-update flag is now 0 (off).'
          ELSE
            PRINT * , 'The X-workstation-update flag is now 1 (on).'
          END IF
          PRINT * , ' '
          PRINT * , 'Enter new X-workstation-update flag (0 => off, 1 =>
     + on):'
          CALL TDRDIN (IUXW,IUXW)
          IUXW=MAX(0,MIN(1,IUXW))
C
          PRINT * , ' '
          IF (IHND.EQ.0) THEN
            PRINT * , 'The handedness flag is now 0 (right-handed).'
          ELSE
            PRINT * , 'The handedness flag is now 1 (left-handed).'
          END IF
          PRINT * , ' '
          PRINT * , 'Enter new handedness flag (0 => right, 1 => left):'
          CALL TDRDIN (IHND,IHND)
          IHND=MAX(0,MIN(1,IHND))
          CALL TDSETI ('HND',IHND)
C
          PRINT * , ' '
          PRINT * , 'Current value of stereo-view flag: ',STVF
          PRINT * , ' '
          PRINT * , 'Enter a new value of the stereo-view flag, which'
          PRINT * , 'is set non-zero to make the S command save stereo'
          PRINT * , 'views.  Use a negative value to get each stereo'
          PRINT * , 'pair on a single frame or a positive value to use'
          PRINT * , 'separate frames.  The absolute value is the angle,'
          PRINT * , 'in degrees, between the lines of sight of the two'
          PRINT * , 'views.  (A value of one or two degrees seems to'
          PRINT * , 'work best):'
          CALL TDRDRN (STVF,STVF)
          STVF=MAX(-10.,MIN(10.,STVF))
C
          PRINT * , ' '
          PRINT * , 'Current character size multiplier: ',RCS1
          PRINT * , ' '
          PRINT * , 'Enter new value for character size multiplier:'
          CALL TDRDRN (RCS1,RCS1)
          RCS1=MAX(.1,MIN(10.,RCS1))
C
          PRINT * , ' '
          PRINT * , 'Multiplier for random term in dummy data: ',RNDM
          PRINT * , ' '
          PRINT * , 'Enter new multiplier for random term:'
          CALL TDRDRN (RNDM,RNDM)
          RNDM=MAX(0.,RNDM)
C
          PRINT * , ' '
          PRINT * , 'Current triangle-ordering flag: ',IORD
          PRINT * , ' '
          PRINT * , 'Enter new triangle-ordering flag (0 => sort on  '
          PRINT * , 'distances to triangle centers, -1 => sort on    '
          PRINT * , 'distances to triangle farpoints, +1 => sort on  '
          PRINT * , 'distances to triangle farpoints and then run an '
          PRINT * , 'algorithm to fix ordering errors):'
          CALL TDRDIN (IORD,IORD)
          IORD=MAX(-1,MIN(+1,IORD))
C
          PRINT * , ' '
          PRINT * , 'Current flag for the grid of 3D marks: ',IMRK
          IF (IMRK.EQ.0) THEN
            PRINT * , 'No grid of 3D marks is to be generated.'
          ELSE
            PRINT * , 'Grid of 3D marks is to be generated, each ',
     +                      IMKT(IABS(IMRK))(1:LNBPCS(IMKT(IABS(IMRK))))
            IF (IMRK.LT.0) THEN
              PRINT * , 'Marks are not to be clipped by the data box.'
            ELSE
              PRINT * , 'Marks are to be clipped by the data box.'
            END IF
          END IF
          IMKO=IMRK
          SMKO=SMRK
          UMKO=UMKS
          VMKO=VMKS
          WMKO=WMKS
          PRINT * , ' '
          PRINT * , 'Enter new value of flag for the grid of 3D marks'
          PRINT * , '(0 => no marks, 1 => tetrahedron, 2 => octahedron,'
          PRINT * , '3 = > cube, 4 => icosahedron, 5 => sphere; use a'
          PRINT * , 'negated value to omit clipping by data box.'
          CALL TDRDIN (IMRK,IMRK)
          IMRK=MAX(-5,MIN(5,IMRK))
          IF (IMRK.NE.0) THEN
            PRINT * , ' '
            PRINT * , 'Current value of mark size parameter:   ',SMRK
            PRINT * , ' '
            PRINT * , 'Enter new mark size (as a fraction of the'
            PRINT * , 'smallest side of the data box):'
            CALL TDRDRN (SMRK,SMRK)
            SMRK=MAX(.001,MIN(1.,SMRK))
            PRINT * , ' '
            PRINT * , 'Current mark spacing parameters:',UMKS,VMKS,WMKS
            PRINT * , ' '
            PRINT * , 'Enter new mark spacing in U:'
            CALL TDRDRN (UMKS,UMKS)
            UMKS=MAX(0.,UMKS)
            PRINT * , 'Enter new mark spacing in V:'
            CALL TDRDRN (VMKS,VMKS)
            VMKS=MAX(0.,VMKS)
            PRINT * , 'Enter new mark spacing in W:'
            CALL TDRDRN (WMKS,WMKS)
            WMKS=MAX(0.,WMKS)
          END IF
C
          PRINT * , ' '
          PRINT * , 'Current isosurface cut-off value 1: ',FIS1
          PRINT * , 'Current isosurface cut-off value 2: ',FIS2
          PRINT * , ' '
          PRINT * , 'Isosurface cut-off values must be between 0'
          PRINT * , 'and 200 (the initial values were 95 and 95).'
          PRINT * , 'If the two values are equal, one isosurface'
          PRINT * , 'is specified; if the two values are different,'
          PRINT * , 'two isosurfaces are specified.'
          PRINT * , ' '
          PRINT * , 'Enter new isosurface cut-off value 1:'
          OFS1=FIS1
          CALL TDRDRN (FIS1,FIS1)
          FIS1=MAX(0.,MIN(200.,FIS1))
          PRINT * , 'Enter new isosurface cut-off value 2:'
          OFS2=FIS2
          CALL TDRDRN (FIS2,FIS2)
          FIS2=MAX(0.,MIN(200.,FIS2))
          IF (FIS1.GT.FIS2) THEN
            FIS0=FIS1
            FIS1=FIS2
            FIS2=FIS0
          END IF
C
          IF (IMRK.NE.IMKO.OR.SMRK.NE.SMKO.OR.UMKS.NE.UMKO.OR.
     +        UMKS.NE.UMKO.OR.VMKS.NE.VMKO.OR.WMKS.NE.WMKO.OR.
     +        FIS1.NE.OFS1.OR.FIS2.NE.OFS2) THEN
            GO TO 110
          ELSE
            GO TO 111
          END IF
C
        ELSE IF (COMD.EQ.'Q'.OR.COMD.EQ.'q') THEN
C
          CALL GDAWK (1)
          CALL GCLWK (1)
          CALL GCLWK (2)
          IF (NFPS.NE.0) THEN
            CALL GACWK (3)
            CALL GCLRWK (3,1)
            CALL GDAWK (3)
          END IF
          CALL GCLWK (3)
          CALL GCLKS
          STOP
C
        ELSE IF (COMD.EQ.'R'.OR.COMD.EQ.'r') THEN
C
          PRINT * , ' '
          PRINT * , 'Redrawing the picture.'
          PRINT * , ' '
          PRINT * , 'Change the shading parameters (Y or N)?'
          READ  '(A1)', COMD
          IF (COMD.EQ.'Y'.OR.COMD.EQ.'y') THEN
            PRINT * , ' '
            PRINT * , 'Current shading parameter values are as follows:'
            PRINT * , '  Shading parameter 1:   ',SHDE
            PRINT * , '  Shading parameter 2:   ',SHDR
            PRINT * , '  TDPACK parameter SHD:  ',ISHD
            PRINT * , '  Light source azimuth:  ',ANG3
            PRINT * , '  Light source elevation:',ANG4
            PRINT * , ' '
            PRINT * , 'Note that if both angles are zero, the light'
            PRINT * , 'source is at the position of the viewer.'
            PRINT * , ' '
            PRINT * , 'Enter new shading parameter 1 (0 => shading off,'
            PRINT * , 'near 0 => brighter colors, near 1 => pastels).'
            CALL TDRDRN (SHDE,SHDE)
            SHDE=MAX(0.,MIN(1.,SHDE))
            PRINT * , 'Enter new shading parameter 2 (near 0 => small'
            PRINT * , 'range of shades, near 1 => full range).'
            CALL TDRDRN (SHDR,SHDR)
            SHDR=MAX(0.,MIN(1.,SHDR))
            PRINT * , 'Enter new value of TDPACK internal parameter SHD'
            PRINT * , '(0 => shading over a 90-degree range of triangle'
            PRINT * , 'orientations, 1 => over a 180-degree range):'
            CALL TDRDIN (ISHD,ISHD)
            ISHD=MAX(0,MIN(1,ISHD))
            CALL TDSETI ('SHD',ISHD)
            PRINT * , 'Enter light source angle 1 (azimuth, in degrees):
     +'
            CALL TDRDRN (ANG3,ANG3)
            ANG3=SIGN(MOD(ABS(ANG3),360.),ANG3)
            PRINT * , 'Enter light source angle 2 (elevation, in degrees
     +):'
            CALL TDRDRN (ANG4,ANG4)
            ANG4=MAX(-89.999,MIN(+89.999,ANG4))
            IF (ANG3.NE.0..OR.ANG4.NE.0.) THEN
              UCLS=UMID+100.*DOFB*COS(DTOR*ANG3)*COS(DTOR*ANG4)
              VCLS=VMID+100.*DOFB*SIN(DTOR*ANG3)*COS(DTOR*ANG4)
              WCLS=WMID+100.*DOFB*SIN(DTOR*ANG4)
            ELSE
              UCLS=0.
              VCLS=0.
              WCLS=0.
            END IF
            CALL TDSETR ('LSU',UCLS)
            CALL TDSETR ('LSV',VCLS)
            CALL TDSETR ('LSW',WCLS)
            IF (SHDE.NE.0..AND.(SHDE.NE.SSHE.OR.SHDR.NE.SSHR)) THEN
              CALL GCLRWK (1,1)
              DO 117 IWID=1,3
                IF (IWID.NE.1) CALL GACWK (IWID)
                CALL TDCLRS (IWID,IBOW,SHDE,SHDR,101,116,0)
                IF (IWID.NE.1) CALL GDAWK (IWID)
  117         CONTINUE
              SSHE=SHDE
              SSHR=SHDR
            END IF
          END IF
          PRINT * , ' '
          PRINT * , 'Change the rendering parameters (Y or N)?'
          READ  '(A1)', COMD
          IF (COMD.EQ.'Y'.OR.COMD.EQ.'y') THEN
            PRINT * , ' '
            PRINT * , 'Usable color indices are as follows:'
            PRINT * , '  -1 => if line color, line not drawn; if fill co
     +lor, no fill done'
            PRINT * , '   0 => background or 101-116 => shades from all-
     +white to all-black'
            PRINT * , '   1 => foreground or 117-132 => shades of gray (
     +light to dark)'
            PRINT * , '   2 => red        or 133-148 => shades of red (l
     +ight to dark)'
            PRINT * ,  '   3 => green      or 149-164 => shades of green
     + (light to dark)'
            PRINT * , '   4 => blue       or 165-180 => shades of blue (
     +light to dark)'
            PRINT * , '   5 => cyan       or 181-196 => shades of cyan (
     +light to dark)'
            PRINT * , '   6 => magenta    or 197-212 => shades of magent
     +a (light to dark)'
            PRINT * , '   7 => yellow     or 213-228 => shades of yellow
     + (light to dark)'
            PRINT * , '  Colors with indices 117 through 228 are affecte
     +d by the values of'
            PRINT * , '  shading flags.  Using a fill color index 0 thro
     +ugh 7 when shading'
            PRINT * , '  is turned on implies using shades of that color
     + (for example, use'
            PRINT * , '  of the value 4 implies the use of color indices
     + 165 through 180).'
            PRINT * , ' '
            PRINT * , 'Current rendering values are as follows:'
            PRINT * , '  Bottom/top fill colors:      ',IFCB,IFCT
            PRINT * , '  Bottom/top line colors:      ',ILCB,ILCT
            PRINT * , '  Triangle-drawing flag:       ',IDTR
            PRINT * , '  U/V/W slice separations:     ',USIN,VSIN,WSIN
            PRINT * , ' '
            PRINT * , 'Enter new bottom fill color:'
            CALL TDRDIN (IFCB,IFCB)
            IFCB=MAX(-1,IFCB)
            PRINT * , 'Enter new top fill color:'
            CALL TDRDIN (IFCT,IFCT)
            IFCT=MAX(-1,IFCT)
            PRINT * , 'Enter new bottom line color:'
            CALL TDRDIN (ILCB,ILCB)
            ILCB=MAX(-1,ILCB)
            PRINT * , 'Enter new top line color:'
            CALL TDRDIN (ILCT,ILCT)
            ILCT=MAX(-1,ILCT)
            PRINT * , 'Enter new triangle-drawing flag (0 or 1):'
            CALL TDRDIN (IDTR,IDTR)
            IDTR=MAX(0,MIN(1,IDTR))
            PRINT * , 'Enter new U slice separation (0 => none):'
            CALL TDRDRN (USIN,USIN)
            USIN=MAX(0.,USIN)
            PRINT * , 'Enter new V slice separation (0 => none):'
            CALL TDRDRN (VSIN,VSIN)
            VSIN=MAX(0.,VSIN)
            PRINT * , 'Enter new W slice separation (0 => none):'
            CALL TDRDRN (WSIN,WSIN)
            WSIN=MAX(0.,WSIN)
          END IF
          GO TO 111
C
        ELSE IF (COMD.EQ.'S'.OR.COMD.EQ.'s') THEN
C
          PRINT * , ' '
          IF (STVF.EQ.0.) THEN
            PRINT * , 'Saving just the current image.  (An M command'
            PRINT * , 'can be used to turn on saving of stereo pairs.)'
          ELSE
            PRINT * , 'Saving a stereo pair of the current image.'
          END IF
          PRINT * , ' '
          PRINT * , 'Do you want to save to an NCAR CGM file (Y or N)?'
          READ  '(A1)', COMD
          IF (COMD.NE.'Y'.AND.COMD.NE.'y') THEN
            ISNG=0
          ELSE
            ISNG=1
            CALL GACWK (2)
            NFNG=NFNG+1
            IF (NFNG.GT.1) CALL GCLRWK (2,1)
          END IF
          PRINT * , ' '
          PRINT * , 'Do you want to save to a PostScript file (Y or N)?'
          READ  '(A1)', COMD
          IF (COMD.NE.'Y'.AND.COMD.NE.'y') THEN
            ISPS=0
          ELSE
            ISPS=1
            CALL GACWK (3)
            NFPS=NFPS+1
            IF (NFPS.GT.1) CALL GCLRWK (3,1)
          END IF
          IF (ISNG.NE.0.OR.ISPS.NE.0) THEN
            CALL GDAWK(1)
            OFFS=-(DEYE+DAPT)*TAN(DTOR*ABS(STVF)/2.)
  118       PRINT * , ' '
            IF      (OFFS.LT.0.) THEN
              PRINT * , 'Initializing TDPACK for left-eye view.'
            ELSE IF (OFFS.GT.0.) THEN
              PRINT * , 'Initializing TDPACK for right-eye view.'
            ELSE
              PRINT * , 'Initializing TDPACK for single view.'
            END IF
            CALL TDINIT (UEYE,VEYE,WEYE,UAPT,VAPT,WAPT,
     +                                  UAPT,VAPT,WAPT+1.,OFFS)
            CALL GETSET (XVPL,XVPR,YVPB,YVPT,XWDL,XWDR,YWDB,YWDT,LNLG)
            IF (OFFS.NE.0..AND.STVF.LT.0.) THEN
              IF (OFFS.LT.0.) THEN
                CALL SET  (1.-WOSW,1.,.5-.5*WOSW,.5+.5*WOSW,
     +                             XWDL,XWDR,YWDB,YWDT,LNLG)
              ELSE
                CALL SET  (  0., WOSW,.5-.5*WOSW,.5+.5*WOSW,
     +                             XWDL,XWDR,YWDB,YWDT,LNLG)
              END IF
            END IF
            IF (PILB.NE.' ') THEN
              PRINT * , 'Drawing plot label.'
              CALL TDPARA (UMID-.5*DOFB*(UDCX+UDCY),
     +                     VMID-.5*DOFB*(VDCX+VDCY),
     +                     WMID-.5*DOFB*(WDCX+WDCY),
     +                     UDCX,VDCX,WDCX,UDCY,VDCY,WDCY)
              CALL TDPLCH ((.5+PILX)*DOFB,(.5+PILY)*DOFB,
     +                     PILB(1:LNBPCS(PILB)),.04*CSM2,0.,0.)
            END IF
            IF (IGDF.NE.0) THEN
              PRINT * , 'Drawing axis labels.'
              IF (IFDE.NE.0) THEN
                ANGM=MOD(ANG1,90.)
                IF (ANGM.LT. 0.) ANGM=90.+ANGM
                IF (ANGM.GT.45.) ANGM=90.-ANGM
                MANG=101+INT(ANGM)
              ELSE
                MANG=116
              END IF
              IF (MANG.GT.101) THEN
                IF (MANG.GE.102.AND.MANG.LE.115) THEN
                  CALL SFLUSH
                  IF (IBOW.EQ.0) THEN
                    CALL GSPLCI (217-MANG)
                    CALL GSFACI (217-MANG)
                  ELSE
                    CALL GSPLCI (MANG)
                    CALL GSFACI (MANG)
                  END IF
                END IF
                CALL TDLBLS (UMIN,VMIN,WMIN,UMAX,VMAX,WMAX,
     +                       UNLB,VNLB,WNLB,UILB,VILB,WILB,1)
                IF (MANG.GE.102.AND.MANG.LE.115) THEN
                  CALL SFLUSH
                  CALL GSPLCI (1)
                  CALL GSFACI (1)
                END IF
              END IF
              PRINT * , 'Drawing far sides of box.'
              CALL TDGRDS (UMIN,VMIN,WMIN,UMAX,VMAX,WMAX,
     +                     UGIM*UGIN,VGIM*VGIN,WGIM*WGIN,IGDF,1)
            END IF
            PRINT * , 'Rendering surface.'
            CALL TDOTRI (RTRI,MTRI,NTRI,RTWK,ITWK,IORD)
            CALL TDDTRI (RTRI,MTRI,NTRI,ITWK)
            IF (IGDF.NE.0) THEN
              PRINT * , 'Drawing near sides of box.'
              CALL TDGRDS (UMIN,VMIN,WMIN,UMAX,VMAX,WMAX,
     +                     UGIM*UGIN,VGIM*VGIN,WGIM*WGIN,IGDF,0)
            END IF
            IF      (OFFS.LT.0.) THEN
              CALL PLCHHQ (.98*XWDL+.02*XWDR,.98*YWDB+.02*YWDT,'L',.006,
     +                                                            0.,0.)
            ELSE IF (OFFS.GT.0.) THEN
              CALL PLCHHQ (.02*XWDL+.98*XWDR,.98*YWDB+.02*YWDT,'R',.006,
     +                                                            0.,0.)
            END IF
            CALL SFLUSH
            IF (ISNG.NE.0) CALL GUWK (2,0)
            IF (ISPS.NE.0) CALL GUWK (3,0)
            IF (OFFS.LT.0.) THEN
              OFFS=-OFFS
              IF (STVF.GT.0.) THEN
                IF (ISNG.NE.0) CALL GCLRWK (2,1)
                IF (ISPS.NE.0) CALL GCLRWK (3,1)
              END IF
              GO TO 118
            END IF
            IF (ISNG.NE.0) CALL GDAWK (2)
            IF (ISPS.NE.0) CALL GDAWK (3)
            CALL GACWK(1)
          END IF
          GO TO 112
C
        ELSE IF (COMD.EQ.'V'.OR.COMD.EQ.'v') THEN
C
          PRINT * , ' '
          PRINT * , 'Changing view angle and distance.  Current'
          PRINT * , 'values are as follows:'
          PRINT * , '  Viewing angle 1 (azimuth):                 ',ANG1
          PRINT * , '  Viewing angle 2 (elevation):               ',ANG2
          PRINT * , '  Distance to eye (diagonal multiple):       ',REYE
          PRINT * , '  Distance to aim point (diagonal multiple): ',RAPT
          PRINT * , '  Field of view (in degrees):                ',FOVP
          PRINT * , ' '
          PRINT * , 'Enter viewing angle 1 (azimuth, in degrees):'
          CALL TDRDRN (ANG1,ANG1)
          ANG1=SIGN(MOD(ABS(ANG1),360.),ANG1)
          PRINT * , 'Enter viewing angle 2 (elevation, in degrees):'
          CALL TDRDRN (ANG2,ANG2)
          ANG2=MAX(-89.999,MIN(+89.999,ANG2))
          PRINT * , 'Enter distance to eye (diagonal multiple):'
          CALL TDRDRN (REYE,REYE)
          REYE=MAX(.51,MIN(51.,REYE))
          PRINT * , 'Enter distance to aim point (diagonal multiple):'
          CALL TDRDRN (RAPT,RAPT)
          RAPT=MAX(-.9*REYE,MIN(100.*REYE,RAPT))
          PRINT * , 'Enter desired field of view (in degrees):'
          CALL TDRDRN (FOVP,FOVP)
          FOVP=MAX(1.,MIN(179.,FOVP))
          CALL TDSETR ('FOV',FOVP)
          GO TO 111
C
        ELSE
C
          PRINT * , ' '
          PRINT * , 'Illegal command.  Try again.'
C
          GO TO 112
C
        END IF
C
      END


      SUBROUTINE GENDAT (DATA,IMAX,IDIM,JDIM,MLOW,MHGH,DLOW,DHGH,ICEN)
C
C This is a routine to generate test data for two-dimensional graphics
C routines.  Given an array "DATA", dimensioned "IMAX x 1", it fills
C the sub-array ((DATA(I,J),I=1,IDIM),J=1,JDIM) with a two-dimensional
C field of data having approximately "MLOW" lows and "MHGH" highs, a
C minimum value of exactly "DLOW" and a maximum value of exactly "DHGH".
C If ICEN is non-zero, new centers are computed for the exponentials,
C yielding a whole new field.
C
C "MLOW" and "MHGH" are each forced to be greater than or equal to 1
C and less than or equal to 25.
C
C The function used is a sum of exponentials.
C
        DIMENSION DATA(IMAX,*),CCNT(3,50)
C
        SAVE NLOW,NHGH,NCNT,CCNT
C
        DATA NCNT / 0 /
C
        IF (ICEN.NE.0.OR.NCNT.EQ.0) THEN
C
          NLOW=MAX0(1,MIN0(25,MLOW))
          NHGH=MAX0(1,MIN0(25,MHGH))
          NCNT=NLOW+NHGH
C
          DO 101 ICNT=1,NCNT
            CCNT(1,ICNT)=FRAN()
            CCNT(2,ICNT)=FRAN()
            IF (ICNT.LE.NLOW) THEN
              CCNT(3,ICNT)=-1.
            ELSE
              CCNT(3,ICNT)=+1.
            END IF
  101     CONTINUE
C
        END IF
C
        DMIN=+1.E36
        DMAX=-1.E36
C
        DO 104 I=1,IDIM
          XPOS=REAL(I-1)/REAL(IDIM-1)
          DO 103 J=1,JDIM
            YPOS=REAL(J-1)/REAL(JDIM-1)
            DATA(I,J)=0.
            DO 102 K=1,NCNT
              TEMP=-50.*((XPOS-CCNT(1,K))**2+(YPOS-CCNT(2,K))**2)
              IF (TEMP.GE.-20.) DATA(I,J)=DATA(I,J)+CCNT(3,K)*EXP(TEMP)
  102       CONTINUE
            DMIN=MIN(DMIN,DATA(I,J))
            DMAX=MAX(DMAX,DATA(I,J))
  103     CONTINUE
  104   CONTINUE
C
        DO 106 I=1,IDIM
          DO 105 J=1,JDIM
            DATA(I,J)=(DATA(I,J)-DMIN)/(DMAX-DMIN)*(DHGH-DLOW)+DLOW
  105     CONTINUE
  106   CONTINUE
C
        RETURN
C
      END


      SUBROUTINE ADDRAN (DATA,IMAX,IDIM,JDIM,DLOW,DHGH,RNDM)
C
        DIMENSION DATA(IMAX,*)
C
C This subroutine is called to add a random quantity to each element of
C the IDIM x JDIM array DATA, whose first FORTRAN dimension is IMAX.
C
C The magnitude of the random quantity is stated as a multiple (RNDM)
C of the range of the data.
C
        DMUL=RNDM*(DHGH-DLOW)
C
        DMIN=+1.E36
        DMAX=-1.E36
C
C Add random quantities to the data.
C
        DO 102 I=1,IDIM
          DO 101 J=1,JDIM
            DATA(I,J)=DATA(I,J)+DMUL*FRAN()
            DMIN=MIN(DMIN,DATA(I,J))
            DMAX=MAX(DMAX,DATA(I,J))
  101     CONTINUE
  102   CONTINUE
C
C Readjust the data to have the high and low values as before.
C
        DO 104 I=1,IDIM
          DO 103 J=1,JDIM
            DATA(I,J)=(DATA(I,J)-DMIN)/(DMAX-DMIN)*(DHGH-DLOW)+DLOW
  103     CONTINUE
  104   CONTINUE
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE TDGNDT (DATA,IMAX,JMAX,IDIM,JDIM,KDIM,MLOW,MHGH,
     +                                            DLOW,DHGH,ICEN)
C
C This is a routine to generate test data for three-dimensional graphics
C routines.  Given an array "DATA", dimensioned "IMAX x JMAX x ...", it
C fills the sub-array (((DATA(I,J,K),I=1,MX),J=1,MY),K=1,MZ) with a
C three-dimensional field of data having approximately "MLOW" lows and
C "MHGH" highs, a minimum value of exactly "DLOW" and a maximum value
C of exactly "DHGH".  If ICEN is non-zero, new centers are computed for
C the exponentials, yielding a whole new field.
C
C "MLOW" and "MHGH" are each forced to be greater than or equal to 1
C and less than or equal to 25.
C
C The function used is a sum of exponentials.
C
        DIMENSION DATA(IMAX,JMAX,*),CCNT(4,50)
C
        SAVE NLOW,NHGH,NCNT,CCNT
C
        DATA NCNT / 0 /
C
        IF (ICEN.NE.0.OR.NCNT.EQ.0) THEN
C
          NLOW=MAX0(1,MIN0(25,MLOW))
          NHGH=MAX0(1,MIN0(25,MHGH))
          NCNT=NLOW+NHGH
C
          DO 101 ICNT=1,NCNT
            CCNT(1,ICNT)=FRAN()
            CCNT(2,ICNT)=FRAN()
            CCNT(3,ICNT)=FRAN()
            IF (ICNT.LE.NLOW) THEN
              CCNT(4,ICNT)=-1.
            ELSE
              CCNT(4,ICNT)=+1.
            END IF
  101     CONTINUE
C
        END IF
C
        DMIN=+1.E36
        DMAX=-1.E36
C
        DO 105 I=1,IDIM
          XPOS=REAL(I-1)/REAL(IDIM-1)
          DO 104 J=1,JDIM
            YPOS=REAL(J-1)/REAL(JDIM-1)
            DO 103 K=1,KDIM
              ZPOS=REAL(K-1)/REAL(KDIM-1)
              DATA(I,J,K)=0.
              DO 102 ICNT=1,NCNT
                TEMP=-50.*((XPOS-CCNT(1,ICNT))**2+
     +                     (YPOS-CCNT(2,ICNT))**2+
     +                     (ZPOS-CCNT(3,ICNT))**2)
                IF (TEMP.GE.-20.) DATA(I,J,K)=DATA(I,J,K)+
     +                                        CCNT(4,ICNT)*EXP(TEMP)
  102         CONTINUE
              DMIN=MIN(DMIN,DATA(I,J,K))
              DMAX=MAX(DMAX,DATA(I,J,K))
  103       CONTINUE
  104     CONTINUE
  105   CONTINUE
C
        DO 108 I=1,IDIM
          DO 107 J=1,JDIM
            DO 106 K=1,KDIM
              DATA(I,J,K)=DLOW+((DATA(I,J,K)-DMIN)/
     +                          (DMAX       -DMIN))*(DHGH-DLOW)
  106       CONTINUE
  107     CONTINUE
  108   CONTINUE
C
        RETURN
C
      END


      SUBROUTINE TDADRN (DATA,IMAX,JMAX,IDIM,JDIM,KDIM,DLOW,DHGH,RNDM)
C
        DIMENSION DATA(IMAX,JMAX,*)
C
C This subroutine is called to add a random quantity to each element of
C the IDIM x JDIM x KDIM array DATA, whose first two FORTRAN dimensions
C are IMAX and JMAX.
C
C The magnitude of the random quantity is stated as a multiple (RNDM)
C of the range of the data.
C
        DMUL=RNDM*(DHGH-DLOW)
C
        DMIN=+1.E36
        DMAX=-1.E36
C
C Add random quantities to the data.
C
        DO 103 I=1,IDIM
          DO 102 J=1,JDIM
            DO 101 K=1,KDIM
              DATA(I,J,K)=DATA(I,J,K)+DMUL*FRAN()
              DMIN=MIN(DMIN,DATA(I,J,K))
              DMAX=MAX(DMAX,DATA(I,J,K))
  101       CONTINUE
  102     CONTINUE
  103   CONTINUE
C
C Readjust the data to have the high and low values as before.
C
        DO 106 I=1,IDIM
          DO 105 J=1,JDIM
            DO 104 K=1,KDIM
              DATA(I,J,K)=(DATA(I,J,K)-DMIN)/(DMAX-DMIN)*
     +                                       (DHGH-DLOW)+DLOW
  104       CONTINUE
  105     CONTINUE
  106   CONTINUE
C
C Done.
C
        RETURN
C
      END


      FUNCTION FRAN()
C
C Pseudo-random-number generator.
C
        DOUBLE PRECISION X
        SAVE X
        DATA X / 2.718281828459045D0 /
        X=MOD(9821.D0*X+.211327D0,1.D0)
        FRAN=REAL(X)
        RETURN
      END


      SUBROUTINE TDRDIN (IVAL,IDEF)
C
C This routine reads a line of input to get an integer value IVAL.  If
C the line is entirely blank, the default value IDEF is returned.  If
C the line contains an illegal character, another line is obtained.
C
        CHARACTER*128 LINE
C
C Assume the default value will be returned until we find otherwise.
C
        IVAL=IDEF
C
C Get a line from standard input.
C
        READ '(A128)' , LINE
C
        IF (LINE.NE.' ') THEN
          READ (LINE,*) IVAL
        END IF
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE TDRDRN (RVAL,RDEF)
C
C This routine reads a line of input to get a real number RVAL.  If
C the line is entirely blank, the default value RDEF is returned.  If
C the line contains an illegal character, another line is obtained.
C
        CHARACTER*128 LINE
C
C Assume the default value will be returned until we find otherwise.
C
        RVAL=RDEF
C
C Get a line from standard input.
C
        READ '(A128)' , LINE
C
        IF (LINE.NE.' ') THEN
          READ (LINE,*) RVAL
        END IF
C
C Done.
C
        RETURN
C
      END

C
C	$Id: grqst.f,v 1.5 2008-07-27 00:21:01 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GRQST (WKID,STDNR,STAT,LOSTR,STR)
C
C  REQUEST STRING
C
      INTEGER ERQST
      PARAMETER (ERQST=86)
C
      INTEGER WKID,STDNR,STAT,LOSTR
      CHARACTER*(*) STR
C
      CHARACTER*80 IDR,ODR
C
C  The only reason this subroutine is in the NCAR GKS package is
C  to support the pause feature of FRAME and NGPICT in a standard
C  manner so that those two subroutines can work with a any level
C  2B GKS package.
C
C  Check if GKS is in the proper state.
C
      CALL GZCKST(7,ERQST,IER)
      IF (IER .NE. 0) RETURN
C
C  Check if the workstation identifier is valid.
C
      CALL GZCKWK(20,ERQST,WKID,IDUM,IER)
      IF (IER .NE. 0) RETURN
C
C  Check if the specified workstation is open.
C
      CALL GZCKWK(25,ERQST,WKID,IDUM,IER)
      IF (IER .NE. 0) RETURN
C
C  Other checks should be added if this subroutine is ever fully
C  implemented for NCAR GKS.
C
C
C  Make the interface call to pause.
C
      WRITE(IDR,500) WKID
  500 FORMAT(I5)
      CALL GESC(-1396,1,IDR,1,1,ODR)
C
      RETURN
      END

C
C       $Id: velvct.f,v 1.22 2008-07-27 00:17:34 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE VELVCT (U,LU,V,LV,M,N,FLO,HI,NSET,LENGTH,ISPV,SPV)
C
C This is the old form of the velocity vector subroutine
C
C
C DIMENSION OF           U(LU,N),V(LV,N),SPV(2)
C ARGUMENTS
C
      DIMENSION U(LU,N),V(LV,N),SPV(2)
C
C The original discussion explaining the routine follows the code
C Note that to use of this function does not preclude use of other
C new added features. By default the FX,FY,MXF,MYF routines are used
C but the new mapping function VVMPXY may be called with the proper
C setting of the compatibility flag parameter, 'CPM'. Look in vvdata.f
C for usage of this parameter.
C
C The original VELVCT common blocks. All values contained in these
C common blocks that are intended to be modified by the user are
C transferred into the VVCOM common block used by the new routines in
C the VELVCT package. Since the VEC1 and VEC2 blocks now appear
C only in this routine, the data are initialized here.
C
      COMMON /VEC1/   ASH        ,EXT        ,ICTRFG     ,ILAB       ,
     +                IOFFD      ,IOFFM      ,ISX        ,ISY        ,
     +                RMN        ,RMX        ,SIDE       ,SIZE       ,
     +                XLT        ,YBT        ,ZMN        ,ZMX
C     
      COMMON /VEC2/   BIG        ,INCX       ,INCY
C     
      SAVE /VEC1/, /VEC2/
C
C Internal parameters of VELVCT are as follows.
C
C                        Name   Default  Function
C                        ----   -------  --------
C
C                        BIG   R1MACH(2) No longer needed
C
C                        EXT     0.25    The lengths of the sides of the
C                                        plot are proportional to M and
C                                        N when ISET is less than or
C                                        equal to zero, except when
C                                        MIN(M,N)/MAX(M,N) is less than
C                                        EXT, in which case a square
C                                        graph is plotted.
C
C                        ICTRFG    1     Flag to control the position of
C                                        the arrow relative to  a base
C                                        point at (MX,MY).
C
C                                        Zero - center at (MX,MY)
C
C                                        Positive - tail at (MX,MY)
C
C                                        Negative -  head at (MX,MY)
C
C                        ILAB      0     Flag to control the drawing of
C                                        line labels.
C
C                                        Zero - do not draw the labels
C
C                                        Non-zero - draw the labels
C
C                        INCX      1     X-coordinate step size for less
C                                        dense arrays.
C
C                        INCY      1     Y-coordinate step size.
C
C                        IOFFD     0     Flag to control normalization
C                                        of label numbers.
C
C                                        Zero - include a decimal point
C                                        when possible
C
C                                        Non-zero - normalize all label
C                                        numbers by ASH
C
C                        IOFFM     0     Flag to control plotting of
C                                        the message below the plot.
C
C                                        Zero - plot the message
C
C                                        Non-zero - do not plot it
C
C                        RMN     160.    Arrow size below which the
C                                        head no longer shrinks, on a
C                                        2**15 x 2**15 grid.
C
C                        RMX    6400.    Arrow size above which the
C                                        head no longer grows larger,
C                                        on a 2**15 x 2**15 grid.
C
C                        SIDE    0.90    Length of longer edge of plot.
C                                        (see also EXT.)
C
C                        SIZE    256.    Width of the characters in
C                                        vector labels, on a 2**15 x
C                                        2**15 grid.
C
C                        XLT     0.05    Left hand edge of the plot.
C                                        (0 is the left edge of the
C                                        frame, 1 the right edge.)
C
C                        YBT     0.05    Bottom edge of the plot (0 is
C                                        the bottom of the frame, 1 the
C                                        top of the frame.)
C
C ---------------------------------------------------------------------
C
C NOTE:
C Since implicit typing is used for all real and integer variables
C a consistent length convention has been adopted to help clarify the
C significance of the variables encountered in the code for this 
C utility. All local variable and subroutine parameter identifiers 
C are limited to 1,2,or 3 characters. Four character names identify  
C members of common blocks. Five and 6 character variable names 
C denote PARAMETER constants or subroutine or function names.
C
C Declare the VV common blocks.
C
C IPLVLS - Maximum number of color threshold level values
C IPAGMX - Maximum number of area groups allowed in the area map
C
      PARAMETER (IPLVLS = 256, IPAGMX = 64)
C
C Integer and real common block variables
C
C
      COMMON /VVCOM/
     +                IUD1       ,IVD1       ,IPD1       ,IXDM       ,
     +                IYDN       ,VLOM       ,VHIM       ,ISET       ,
     +                VRMG       ,VRLN       ,VFRC       ,IXIN       ,
     +                IYIN       ,ISVF       ,UUSV       ,UVSV       ,
     +                UPSV       ,IMSK       ,ICPM       ,UVPS       ,
     +                UVPL       ,UVPR       ,UVPB       ,UVPT       ,
     +                UWDL       ,UWDR       ,UWDB       ,UWDT       ,
     +                UXC1       ,UXCM       ,UYC1       ,UYCN       ,
     +                NLVL       ,IPAI       ,ICTV       ,WDLV       ,
     +                UVMN       ,UVMX       ,PMIN       ,PMAX       ,
     +                RVMN       ,RVMX       ,RDMN       ,RDMX       ,
     +                ISPC       ,RVMD       ,IPLR       ,IVST       ,
     +                IVPO       ,ILBL       ,IDPF       ,IMSG       ,
     +                ICLR(IPLVLS)           ,TVLU(IPLVLS)
C
C Arrow size/shape parameters
C
        COMMON / VVARO /
     +                HDSZ       ,HINF       ,HANG       ,IAST       ,
     +                HSIN       ,HCOS       ,FAMN       ,FAMX       ,
     +                UVMG       ,FAIR       ,FAWR       ,FAWF       ,
     +                FAXR       ,FAXF       ,FAYR       ,FAYF       ,
     +                AROX(8)    ,AROY(8)    ,FXSZ       ,FYSZ       ,
     +                FXRF       ,FXMN       ,FYRF       ,FYMN       ,
     +                FWRF       ,FWMN       ,FIRF       ,FIMN       ,
     +                AXMN       ,AXMX       ,AYMN       ,AYMX       ,
     +                IACM       ,IAFO       ,WBAD       ,WBTF       ,
     +                WBCF       ,WBDF       ,WBSC
C
C
C Text related parameters
C
        COMMON /VVTXP /
     +                FCWM    ,ICSZ    ,
     +                FMNS    ,FMNX    ,FMNY    ,IMNP    ,IMNC  ,
     +                FMXS    ,FMXX    ,FMXY    ,IMXP    ,IMXC  ,
     +                FZFS    ,FZFX    ,FZFY    ,IZFP    ,IZFC  ,
     +                FILS    ,FILX    ,FILY    ,IILP    ,IILC  ,
     +                FLBS    ,ILBC

C
C Character variable declartions
C
      CHARACTER*160 CSTR
      PARAMETER (IPCHSZ=36)
      CHARACTER*(IPCHSZ)  CMNT,CMXT,CZFT,CLBT,CILT
C
C Text string parameters
C
      COMMON /VVCHAR/ CSTR,CMNT,CMXT,CZFT,CLBT,CILT
C
      SAVE /VVCOM/, /VVARO/, /VVTXP/, /VVCHAR/
C
C The mapping common block: made available to user mapping routines
C
      COMMON /VVMAP/
     +                IMAP       ,
     +                XVPL       ,XVPR       ,YVPB       ,YVPT       ,
     +                WXMN       ,WXMX       ,WYMN       ,WYMX       ,
     +                XLOV       ,XHIV       ,YLOV       ,YHIV       ,
     +                SXDC       ,SYDC       ,NXCT       ,NYCT       ,
     +                RLEN       ,LNLG       ,INVX       ,INVY       ,
     +                ITRT       ,IWCT       ,FW2W       ,FH2H       ,
     +                DVMN       ,DVMX       ,RBIG       ,IBIG
C
      SAVE /VVMAP/
C
C Math constants
C
      PARAMETER (PDTOR  = 0.017453292519943,
     +           PRTOD  = 57.2957795130823,
     +           P1XPI  = 3.14159265358979,
     +           P2XPI  = 6.28318530717959,
     +           P1D2PI = 1.57079632679489,
     +           P5D2PI = 7.85398163397448) 
C
C --------------------------------------------------------------------
C
C Local variables:
C
C IPM             - parameter use flag
C ICB             - VEC1,VEC2 common blocks use flag
C VXL,VXR,VYB,VYT - saved viewport boundary
C WXL,WXR,WYB,WYT - saved window boundary
C X1,X2,Y1,Y2     - temporary viewport boundary
C X3,Y3,X4,Y4     - temporary window boundary
C SVM             - Size of Viewport, Metacode coords
C LEN             - maximum vector size in Metacode coords
C RDA             - real dummy array variable
C IDA             - integer dummy array variable
C XP              - X coordinate position
C YP              - Y coordinate position
C TSZ             - text size
C
C Saved values of internal parameters (Note that these do not follow
C the usually observed rule of using 3 characters or less for local
C variables):
C SVLC,SVHC,ISSET,SVRL,ISSVF,SUSV,SVSV,SVPS,ISVPO,ISLBL,ISDPF,
C SAMN,SAMX,SLBS,ISXIN,ISYIN,ISMXP,SMXX,SMXY
C
C The character variables must be declared:
C
      CHARACTER*(IPCHSZ) CSMNT, CSMXT
      EXTERNAL VVDUMB
C
C This is an empirically derived factor for converting from the
C WTSTR text size to PLCHHQ text
C
      PARAMETER (PHQCVT = 0.8)
C
C Dummy variable
C
      DIMENSION RDA(1)
      DIMENSION IDA(1)
      DATA RDA / 0.0 /
      DATA IDA / 0 / 
C
C -------------------------------------------------------------------
C
C Do a call forcing a BLOCKDATA to be loaded from a binary library.
C
        CALL VELDAT
C
C Save the values of all internal parameters that might be reset
C
      CALL VVGETR('VLC - Vector Low Cutoff Value', SVLC)
      CALL VVGETR('VHC - Vector High Cutoff Value',SVHC)
      CALL VVGETI('SET - Do SET Call Flag', ISSET)
      CALL VVGETR('VRL - Maximum Vector Realized Length', SVRL)
      CALL VVGETI('SVF - Special Value Flag', ISSVF)
      CALL VVGETR('USV - U Array Special Value', SUSV)
      CALL VVGETR('VSV - V Array Special Value', SVSV)
      CALL VVGETR('VPS - Viewport Mode Setting', SVPS)
      CALL VVGETI('VPO - Vector Position Method', ISVPO)
      CALL VVGETI('LBL - Vector Labelling Flag', ISLBL)
      CALL VVGETI('DPF - Label Normalization', ISDPF)
      CALL VVGETR('AMN - Arrow Head Minimum Size', SAMN)
      CALL VVGETR('AMX - Arrow Head Maximum Size', SAMX)
      CALL VVGETR('LBS - Vector Label Text Size', SLBS)
      CALL VVGETI('XIN - X Grid Increment', ISXIN)
      CALL VVGETI('YIN - Y Grid Increment', ISYIN)
      CALL VVGETC('MNT - Minimum Vector Text', CSMNT)
      CALL VVGETC('MXT - Maximum Vector Text', CSMXT)
      CALL VVGETI('MXP - Maximum Text Position Mode', ISMXP)
      CALL VVGETR('MXX - Maximum Text X Position', SMXX)
      CALL VVGETR('MXY - Maximum Text Y Position', SMXY)
C
C Set up the scaling of the plot.
C
      CALL GETSET (VXL,VXR,VYB,VYT,WXL,WXR,WYB,WYT,LL)
C
      X1=VXL
      X2=VXR
      Y1=VYB
      Y2=VYT
      SVM = REAL(KFMX(X2) - KFMX(X1))
C
C Set the parameter and common block use flags
C Note that the value of ICPM is temporarily modified if it
C is equal to the default value. It will be restored as soon as
C the vectors are drawn
C
      IPM = 0
      ICB = 0
      IF (ICPM .GE. -2 .AND. ICPM .LE. 2) IPM = 1
      IF (ABS(ICPM).EQ.1 .OR. ABS(ICPM).EQ.3 .OR. ICPM.EQ.0) ICB = 1 
      IF (ICPM.EQ.0) ICPM = 99
C
      IF (IPM .EQ. 1) THEN
C
C VELVCT parameters override Vectors internal parameters
C
         IF (NSET .LT. 0) THEN
C
            X3 = 1.
            X4 = REAL(M)
            Y3 = 1.
            Y4 = REAL(N)
            CALL SET(X1,X2,Y1,Y2,X3,X4,Y3,Y4,1)
C     
         ELSE IF (NSET .EQ. 0) THEN
C     
            X1 = XLT
            X2 = XLT+SIDE
            Y1 = YBT
            Y2 = YBT+SIDE
            X3 = 1.
            Y3 = 1.
            X4 = REAL(M)
            Y4 = REAL(N)
            IF (MIN(X4,Y4)/MAX(X4,Y4) .GE. EXT) THEN
               IF (M .GT. N) THEN
                  Y2 = YBT+SIDE*Y4/X4
               ELSE 
                  X2 = XLT+SIDE*X4/Y4
               END IF
            END IF
C     
            CALL SET(X1,X2,Y1,Y2,X3,X4,Y3,Y4,1)
            CALL PERIM (1,0,1,0)
            SVM = REAL(KFMX(X2) - KFMX(X1))
C     
         END IF
C
C Use VVSET calls to transfer parameter values into the common block
C 
C Use of FLO and HI correspond to negative values for VLC and VHC
C
         CALL VVSETR('VLC - Vector Low Cutoff Value', MIN(0.0,-FLO))
         CALL VVSETR('VHC - Vector High Cutoff Value', MIN(0.0,-HI))
C
C Since the set call has been handled VVINIT should not do a SET
C
         CALL VVSETI('SET - Do SET Call Flag', 0)
C
C Convert the maximum vector length from plotter address units to
C a fraction of the viewport
C
         CALL GETUSV('XF',ISX)
         ISX = 2**(15-ISX)
         IF (LENGTH .EQ. 0) THEN
            VRL=0.0
         ELSE
            VRL=CMFX(LENGTH*ISX)/(X2-X1)
         ENDIF
         CALL VVSETR('VRL - Maximum Vector Realized Length', VRL)
C
C     Special values
C
         CALL VVSETI('SVF - Special Value Flag', ISPV)
         IF (ISPV .EQ. 1 .OR. ISPV .EQ. 3 .OR. ISPV .EQ. 4) THEN
            CALL VVSETR('USV - U Array Special Value', SPV(1))
         END IF
         IF (ISPV .EQ. 2 .OR. ISPV .EQ. 3 .OR. ISPV .EQ. 4) THEN
            CALL VVSETR('VSV - V Array Special Value', SPV(2))
         END IF
      END IF
C
C Common block values
C
      IF (ICB .EQ. 1) THEN
C
C VEC1, VEC2 values override Vectors internal parameters
C
         CALL VVSETR('VPS - Viewport Mode Setting', EXT)
         CALL VVSETI('VPO - Vector Position Method', ICTRFG)
         CALL VVSETI('LBL - Vector Labelling Flag', ILAB)
         CALL VVSETI('DPF - Label Normalization', IOFFD)
C
C Convert minimum and maximum arrow head sizes and the vector 
C label character size to fraction of viewport width.
C
         AMN = RMN / SVM
         AMX = RMX / SVM
         TSZ = PHQCVT * SIZE / SVM
C
         CALL VVSETR('AMN - Arrow Head Minimum Size', AMN)
         CALL VVSETR('AMX - Arrow Head Maximum Size', AMX)
         CALL VVSETR('LBS - Vector Label Text Size', TSZ)
C
C Viewport values (XLT,YBT,SIDE) do not need to be set since they
C have been handled above.
C
         CALL VVSETI('XIN - X Grid Increment', INCX)
         CALL VVSETI('YIN - Y Grid Increment', INCY)
C
C Depending on the value of the message flag, set up the 
C min/max text blocks to emulate the old VELVCT. 
C
         CALL VVSETC('MNT - Minimum Vector Text', ' ')
         IF (IOFFM .NE. 0) THEN
            CALL VVSETC('MXT - Maximum Vector Text', ' ')
         ELSE
C
C Calculate text position values to place text at lower right of
C plotter frame (0.05,0.005 NDC units from the corner)
C rather than under lower left of viewport.
C Also calculate a fixed text size based on the size hardcoded 
C in the old version of VELVCT.
C
            XP=1.0+(1.0-X2-0.05)/(X2-X1)
            YP=(0.005-Y1)/(Y2-Y1)
            TSZ=CPFX(MAX(256/ISX,8))/(X2-X1)
            CALL VVSETR('MXS - Maximum Text Size', TSZ)
            CALL VVSETI('MXP - Maximum Text Position Mode', -2)
            CALL VVSETR('MXX - Maximum Text X Position', XP)
            CALL VVSETR('MXY - Maximum Text Y Position', YP)
            CALL VVSETC('MXT - Maximum Vector Text', 'MAXIMUM VECTOR')
         END IF
C
      END IF
C
C Initialize the vector plotting routine and plot the vectors
C
      CALL VVINIT(U,LU,V,LV,FDA,0,M,N,FDA,0)
C
      CALL VVECTR(U,V,FDA,IDA,VVDUMB,FDA)
C
C Restore original SET values, if required.
C
      IF (NSET .LE. 0) THEN
         CALL SET (VXL,VXR,VYB,VYT,WXL,WXR,WYB,WYT,LL)
      END IF
C
C Restore the compatibility flag value if necessary
C
      IF (ICPM .EQ. 99) ICPM = 0
C
C Reset all internal parameters that may have been modified
C
      CALL VVSETR('VLC - Vector Low Cutoff Value', SVLC)
      CALL VVSETR('VHC - Vector High Cutoff Value',SVHC)
      CALL VVSETI('SET - Do SET Call Flag', ISSET)
      CALL VVSETR('VRL - Maximum Vector Realized Length', SVRL)
      CALL VVSETI('SVF - SpeciaL Value Flag', ISSVF)
      CALL VVSETR('USV - U Array Special Value', SUSV)
      CALL VVSETR('VSV - V Array Special Value', SVSV)
      CALL VVSETR('VPS - Viewport Mode Setting', SVPS)
      CALL VVSETI('VPO - Vector Position Method', ISVPO)
      CALL VVSETI('LBL - Vector Labelling Flag', ISLBL)
      CALL VVSETI('DPF - Label Normalization', ISDPF)
      CALL VVSETR('AMN - Arrow Head Minimum Size', SAMN)
      CALL VVSETR('AMX - Arrow Head Maximum Size', SAMX)
      CALL VVSETR('LBS - Vector Label Text Size', SLBS)
      CALL VVSETI('XIN - X Grid Increment', ISXIN)
      CALL VVSETI('YIN - Y Grid Increment', ISYIN)
      CALL VVSETC('MNT - Minimum Vector Text', CSMNT)
      CALL VVSETC('MXT - Maximum Vector Text', CSMXT)
      CALL VVSETI('MXP - Maximum Text Position Mode', ISMXP)
      CALL VVSETR('MXX - Maximum Text X Position', SMXX)
      CALL VVSETR('MXY - Maximum Text Y Position', SMXY)
C
      RETURN
      END
C
C ------------------------------------------------------------------
C Original discussion of the VELVCT routine follows:
C
C USAGE                  If the following assumptions are met, use
C
C                               CALL EZVEC (U,V,M,N)
C
C                          Assumptions -
C
C                            --The whole array is processed.
C                            --The scale factor is chosen internally.
C                            --The perimeter is drawn.
C                            --FRAME is called after plotting.
C                            --There are no special values.
C
C                        If these assumptions are not met, use
C
C             CALL VELVCT(U,LU,V,LV,M,N,FLO,HI,NSET,LENGTH,ISPV,SPV)
C
C ARGUMENTS
C
C ON INPUT               U,V
C
C                          The (origins of the) two-dimensional arrays
C                          containing the velocity field to be plotted.
C                          The vector at the point (I,J) has magnitude
C                          SQRT(U(I,J)**2+V(I,J)**2) and direction
C                          ATAN2(V(I,J),U(I,J)).  Other representations,
C                          such as (R,THETA), can be plotted by
C                          changing statement functions in this routine.
C
C                        LU
C
C                          The first dimension of U in the calling
C                          program.
C
C                        LV
C
C                          The first dimension of V in the calling
C                          program.
C
C
C                        M
C
C                          The number of data values to be plotted in
C                          the X-direction (the first subscript
C                          direction).  When plotting the entire array,
C                          LU = LV = M. (PV would also = M).
C
C                        N
C
C                          The number of data values to be plotted in
C                          the Y-direction (the second subscript
C                          direction).
C
C                        FLO
C
C                          The minimum vector magnitude to be shown.
C
C                        HI
C
C                          The maximum vector magnitude to be shown. (A
C                          value less than or equal to zero causes the
C                          maximum value of SQRT(U**2+V**2) to be used.)
C
C                        ISET
C
C                          Flag to control scaling -
C
C                          If ISET is zero, VELVCT establishes the
C                          window and viewport to properly
C                          scale plotting instructions to the standard
C                          configuration.  PERIM is called to draw a
C                          border.
C
C                          If ISET is greater than zero, VELVCT assumes
C                          that the user has established the window
C                          and viewport in such a way as to properly
C                          scale the plotting instructions generated
C                          by VELVCT.  PERIM is not called.
C
C                          If ISET is less than zero, VELVCT
C                          places the contour plot
C                          within the limits of the user's current
C                          window and viewport.  PERIM is not called.
C
C                        LENGTH
C
C                          The length, in Plotter Address Units (PAUs),
C                          of a vector having magnitude HI
C                          (or, if HI=0, the length in PAUs
C                          of the longest vector).  If LENGTH=0, a
C                          value is chosen such that the longest vector
C                          could just reach to the tail of the next
C                          vector.  If the horizontal and vertical
C                          resolutions of the plotter are different,
C                          LENGTH should be non-zero and specified as a
C                          horizontal distance.
C
C                        ISVF
C
C                          Flag to control the special value feature.
C
C                             0 means that the feature is not in use.
C
C                             1 means that if the value of
C                               U(I,J)=UUSV the vector will not be
C                               plotted.
C
C                             2 means that if the value of
C                               V(I,J)=UVSV the vector will not be
C                               plotted.
C
C                             3 means that if either U(I,J)=UUSV or
C                               V(I,J)=UVSV then the vector will not
C                               be plotted.
C
C                             4 means that if U(I,J)=UUSV
C                               and V(I,J)=UVSV, the vector
C                               will not be plotted.
C
C                        SPV
C
C                        An array of length 2 which gives the value
C                        in the U array and the value in the V array
C                        which denote missing values.
C                        This argument is ignored if ISVF=0.
C
C
C ON OUTPUT              All arguments remain unchanged.
C
C NOTE                   The endpoints of each arrow drawn are (FX(X,Y),
C                        FY(X,Y)) and (MXF(X,Y,U,V,SFX,SFY,MX,MY),
C                        MYF(X,Y,U,V,SFX,SFY,MX,MY)) where X=I, Y=J,
C                        U=U(I,J), V=V(I,J), and SFX and SFY are scale
C                        factors.  Here I is the X-index and J is the
C                        Y-index.  (MX,MY) is the location of the tail.
C                        Thus the actual length of the arrow is
C                        SQRT(DX**2+DY**2) and the direction is
C                        ATAN2(DX,DY), where DX=MX-MXF(...) and
C                        DY=MY-MYF(...).
C
C ENTRY POINTS           VELVCT,EZVECT,VELVEC
C
C COMMON BLOCKS          VEC1,VEC2
C
C I/O                    Plots the vector field.
C
C PRECISION              Single
C
C LANGUAGE               FORTRAN
C
C REQUIRED LIBRARY       GRIDAL and the SPPS
C ROUTINES
C
C REQUIRED GKS LEVEL     0A
C
C HISTORY                Written and standardized in November 1973.
C                        Revised in May, 1975, to include MXF and MYF.
C                        Revised in March, 1981, to fix certain errors;
C                        to use FL2INT and PLOTIT instead of MXMY,
C                        FRSTPT, and VECTOR; and to make the arrowheads
C                        narrower.  Converted to FORTRAN77 and GKS
C                        in July 1984.
C
C ALGORITHM              Each vector is examined, possibly transformed,
C                        then plotted.
C
C PORTABILITY            FORTRAN77
C
C ---------------------------------------------------------------------
C
C SPECIAL NOTE -
C
C Using this routine to put vectors on an arbitrary background drawn by
C SUPMAP is a bit tricky.  The arithmetic statement functions FX and FY
C are easy to replace.  The problem arises in replacing MXF and MYF.
C The following example may be helpful. (SUPMAP is an entry point in
C the EZMAP package.)
C
C Suppose that we have two arrays, CLON(36,9) and CLAT(36,9), which
C contain the E-W and N-S components of a wind flow field on the surface
C of the earth.  CLON(I,J) is the magnitude of the easterly flow.
C CLAT(I,J) is the magnitude of the northerly flow at a longitude (I-1)
C *10 degrees east of Greenwich and a latitude (J-1)*10 degrees north of
C the equator.  SUPMAP is to be used to draw a polar projection of the
C earth and VELVCT is to be used to superimpose vectors representing the
C flow field on it.  The following steps would be necessary:
C
C     1.  CALL SUPMAP (1,90.,0.,-90.,90.,90.,90.,90.,-4,10,0,1,IER)
C         to draw the map.
C
C     2.  CALL VELVCT (CLON,36,CLAT,36,36,9,0.,0.,1,50,0,0.) to put
C         vectors on it.  Notice that ISET has the value 1 to tell
C         VELVCT that SUPMAP has done the required SET call.
C
C     3.  In order to ensure that step 2 will work properly, delete
C         the arithmetic statement functions FX, FY, MXF, and MYF
C         from VELVCT and include the following functions.
C
C     FUNCTION FX(XX,YY)
C     CALL MAPTRN (10.*(YY-1.),10.*(XX-1.),X,Y)
C     FX=X
C     RETURN
C     END
C
C     FUNCTION FY(XX,YY)
C     CALL MAPTRN (10.*(YY-1.),10.*(XX-1.),X,Y)
C     FY=Y
C     RETURN
C     END
C
C     FUNCTION MXF(XX,YY,UU,VV,SFX,SFY,MX,MY)
C     CFCT=COS(.17453292519943*(YY-1.))
C     CALL MAPTRN(10.*(YY-1.)         ,10.*(XX-1.)              ,X1,Y1)
C     CALL MAPTRN(10.*(YY-1.)+1.E-6*VV,10.*(XX-1.)+1.E-6*UU/CFCT,X2,Y2)
C     U=((X2-X1)/SQRT((X2-X1)**2+(Y2-Y1)**2))*SQRT(UU**2+VV**2)
C     MXF=MX+INT(SFX*U)
C     RETURN
C     END
C
C     FUNCTION MYF(XX,YY,UU,VV,SFX,SFY,MX,MY)
C     CFCT=COS(.17453292519943*(YY-1.))
C     CALL MAPTRN(10.*(YY-1.)         ,10.*(XX-1.)              ,X1,Y1)
C     CALL MAPTRN(10.*(YY-1.)+1.E-6*VV,10.*(XX-1.)+1.E-6*UU/CFCT,X2,Y2)
C     V=((Y2-Y1)/SQRT((X2-X1)**2+(Y2-Y1)**2))*SQRT(UU**2+VV**2)
C     MYF=MY+INT(SFY*V)
C     RETURN
C     END
C
C The basic notion behind the coding of the MXF and MYF functions is as
C follows.Since UU and VV are the longitudinal and latitudinal components,
C respectively, of a velocity vector having units of distance over time,
C 1.E-6*UU/COS(latitude) and 1.E-6*VV represent the change in longitude
C and latitude, respectively, of a particle moving with the flow field
C for a very short period of time.  The routine MAPTRN is used to find
C the position of the particle's projection at the beginning and end of
C that tiny time slice and, therefore, the direction in which to draw
C the arrow representing the velocity vector so that it will be tangent
C to a projected flow line of the field at that point.  The values U
C and V are computed so as to give the arrow the length implied by UU
C and VV.  (The code ensures that SQRT(U**2+V**2) is equal to
C SQRT(UU**2+VV**2).)  The length of the arrow represents the magnitude
C of the velocity vector, unaffected by perspective.  The scaling set
C up by VELVCT will therefore be appropriate for the arrows drawn.
C
C This method is rather heuristic and has three inherent problems.
C First, the constant 1.E-6 may need to be made larger or smaller,
C depending on the magnitude of your U/V data.  Second, the north and
C south poles must be avoided.  At either pole, CFCT goes to zero,
C giving a division by zero; in a small region near the pole, the
C method may try to use MAPTRN with a latitude outside the range
C (-90,+90).  Third, the projection must be set up so as to avoid
C having vector basepoints at the exact edge of the map.  Vectors
C there will be of the correct length, but they may be drawn in the
C wrong direction (when the projected particle track determining the
C direction crosses the edge and reappears elsewhere on the map).
C With a little care, the desired results may be obtained.
C
C
C ---------------------------------------------------------------------
C End of discussion

C
C $Id: curv1dp.f,v 1.3 2008-07-27 03:10:10 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
C NOTE: If you make any changes to this software, please remember to
C make the same changes to the corresponding single precision routine.
C
      SUBROUTINE CURV1DP(N,X,Y,SLP1,SLPN,ISLPSW,YP,TEMP,SIGMA,IERR)
      DOUBLE PRECISION SIGMAP
      DOUBLE PRECISION SLPP1
      DOUBLE PRECISION DELX1
      DOUBLE PRECISION DELX2
      DOUBLE PRECISION C1
      DOUBLE PRECISION C2
      DOUBLE PRECISION C3
      DOUBLE PRECISION SLPPN
      DOUBLE PRECISION DELXN
      DOUBLE PRECISION DELXNM
      DOUBLE PRECISION DX1
      DOUBLE PRECISION DIAG1
      DOUBLE PRECISION SDIAG1
      DOUBLE PRECISION DX2
      DOUBLE PRECISION DIAG2
      DOUBLE PRECISION SDIAG2
      DOUBLE PRECISION DIAG
c
      INTEGER N,ISLPSW,IERR
      DOUBLE PRECISION X(N),Y(N),SLP1,SLPN,YP(N),TEMP(N),SIGMA
c
c                                 coded by alan kaylor cline
c                           from fitpack -- january 26, 1987
c                        a curve and surface fitting package
c                      a product of pleasant valley software
c                  8603 altus cove, austin, texas 78759, usa
c
c this subroutine determines the parameters necessary to
c compute an interpolatory spline under tension through
c a sequence of functional values. the slopes at the two
c ends of the curve may be specified or omitted.  for actual
c computation of points on the curve it is necessary to call
c the function curv2dp.
c
c on input--
c
c   n is the number of values to be interpolated (n.ge.2).
c
c   x is an array of the n increasing abscissae of the
c   functional values.
c
c   y is an array of the n ordinates of the values, (i. e.
c   y(k) is the functional value corresponding to x(k) ).
c
c   slp1 and slpn contain the desired values for the first
c   derivative of the curve at x(1) and x(n), respectively.
c   the user may omit values for either or both of these
c   parameters and signal this with islpsw.
c
c   islpsw contains a switch indicating which slope data
c   should be used and which should be estimated by this
c   subroutine,
c          = 0 if slp1 and slpn are to be used,
c          = 1 if slp1 is to be used but not slpn,
c          = 2 if slpn is to be used but not slp1,
c          = 3 if both slp1 and slpn are to be estimated
c              internally.
c
c   yp is an array of length at least n.
c
c   temp is an array of length at least n which is used for
c   scratch storage.
c
c and
c
c   sigma contains the tension factor. this value indicates
c   the curviness desired. if abs(sigma) is nearly zero
c   (e.g. .001) the resulting curve is approximately a
c   cubic spline. if abs(sigma) is large (e.g. 50.) the
c   resulting curve is nearly a polygonal line. if sigma
c   equals zero a cubic spline results.  a standard value
c   for sigma is approximately 1. in absolute value.
c
c on output--
c
c   yp contains the values of the second derivative of the
c   curve at the given nodes.
c
c   ierr contains an error flag,
c        = 0 for normal return,
c        = 1 if n is less than 2,
c        = 2 if x-values are not strictly increasing.
c
c and
c
c   n, x, y, slp1, slpn, islpsw and sigma are unaltered.
c
c this subroutine references package modules ceez, terms,
c and snhcsh.
c
c-----------------------------------------------------------
c
      NM1 = N - 1
      NP1 = N + 1
      IERR = 0
      IF (N.LE.1) GO TO 8
      IF (X(N).LE.X(1)) GO TO 9
c
c denormalize tension factor
c
      SIGMAP = ABS(SIGMA)*DBLE(N-1)/ (X(N)-X(1))
c
c approximate end slopes
c
      IF (ISLPSW.GE.2) GO TO 1
      SLPP1 = SLP1
      GO TO 2
    1 DELX1 = X(2) - X(1)
      DELX2 = DELX1 + DELX1
      IF (N.GT.2) DELX2 = X(3) - X(1)
      IF (DELX1.LE.0.D0 .OR. DELX2.LE.DELX1) GO TO 9
      CALL CEEZDP(DELX1,DELX2,SIGMAP,C1,C2,C3,N)
      SLPP1 = C1*Y(1) + C2*Y(2)
      IF (N.GT.2) SLPP1 = SLPP1 + C3*Y(3)
    2 IF (ISLPSW.EQ.1 .OR. ISLPSW.EQ.3) GO TO 3
      SLPPN = SLPN
      GO TO 4
    3 DELXN = X(N) - X(NM1)
      DELXNM = DELXN + DELXN
      IF (N.GT.2) DELXNM = X(N) - X(N-2)
      IF (DELXN.LE.0.D0 .OR. DELXNM.LE.DELXN) GO TO 9
      CALL CEEZDP(-DELXN,-DELXNM,SIGMAP,C1,C2,C3,N)
      SLPPN = C1*Y(N) + C2*Y(NM1)
      IF (N.GT.2) SLPPN = SLPPN + C3*Y(N-2)
c
c set up right hand side and tridiagonal system for yp and
c perform forward elimination
c
    4 DELX1 = X(2) - X(1)
      IF (DELX1.LE.0.D0) GO TO 9
      DX1 = (Y(2)-Y(1))/DELX1
      CALL TERMSDP(DIAG1,SDIAG1,SIGMAP,DELX1)
      YP(1) = (DX1-SLPP1)/DIAG1
      TEMP(1) = SDIAG1/DIAG1
      IF (N.EQ.2) GO TO 6
      DO 5 I = 2,NM1
          DELX2 = X(I+1) - X(I)
          IF (DELX2.LE.0.D0) GO TO 9
          DX2 = (Y(I+1)-Y(I))/DELX2
          CALL TERMSDP(DIAG2,SDIAG2,SIGMAP,DELX2)
          DIAG = DIAG1 + DIAG2 - SDIAG1*TEMP(I-1)
          YP(I) = (DX2-DX1-SDIAG1*YP(I-1))/DIAG
          TEMP(I) = SDIAG2/DIAG
          DX1 = DX2
          DIAG1 = DIAG2
    5 SDIAG1 = SDIAG2
    6 DIAG = DIAG1 - SDIAG1*TEMP(NM1)
      YP(N) = (SLPPN-DX1-SDIAG1*YP(NM1))/DIAG
c
c perform back substitution
c
      DO 7 I = 2,N
          IBAK = NP1 - I
    7 YP(IBAK) = YP(IBAK) - TEMP(IBAK)*YP(IBAK+1)
      RETURN
c
c too few points
c
    8 IERR = 1
      RETURN
c
c x-values not strictly increasing
c
    9 IERR = 2
      RETURN
      END

      PROGRAM FFEX05
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C This program requires the input data file 'ffex05.dat'
C It reads the data from standard input, e.g.: ffex05 < ffex05.dat
C
      PARAMETER (MSIZE=73, NSIZE=73)
C
      DIMENSION U(MSIZE,NSIZE), V(MSIZE,NSIZE), P(MSIZE,NSIZE)
C
C Conpack work space and Areas area map
C
      PARAMETER (ICPIWL=1000, ICPRWL=5000, IAREAL=20000)
      DIMENSION RWRK(ICPRWL),IWRK(ICPIWL)
      DIMENSION IAM(IAREAL)
C
C Arrays for drawing masked grids
C
      PARAMETER (MCRA=64, NOGI=64)
      DIMENSION XCRA(MCRA),YCRA(MCRA),IAAI(NOGI),IAGI(NOGI)
C
C External subroutine declarations
C
      EXTERNAL DRAWCL
      EXTERNAL VVUDMV
      PARAMETER (NCLRS1=14, NCLRS2=7)
      DIMENSION RGB1(3,NCLRS1)
      DIMENSION ICLR1(NCLRS1)
C
      DIMENSION RGB2(3,NCLRS2)
      DIMENSION ICLR2(NCLRS2)
C
C Empirically determined vector thinning data
C Starting from the pole, each row of vectors is weeded, mod the
C value of this data.
C
      PARAMETER (NROWS = 11)
      DIMENSION ITHIN(NROWS)
      DATA ITHIN /90,15,5,5,4,4,3,3,2,2,2/
C
C Indices used for vector coloring
C
      DATA ICLR1 / 10, 17, 24, 31, 38, 45, 52, 60, 67, 
     +             74, 81, 88, 95, 102 /

C
C Define a set of RGB color triples for vector colors
C
      DATA RGB1 / 
     +     0.0,1.0,1.0,
     +     0.0745098,0.92549,0.92549,
     +     0.152941,0.847059,0.847059,
     +     0.231373,0.768627,0.768627,
     +     0.305882,0.694118,0.694118,
     +     0.384314,0.615686,0.615686,
     +     0.462745,0.537255,0.537255,
     +     0.537255,0.462745,0.462745,
     +     0.615686,0.384314,0.384314,
     +     0.694118,0.305882,0.305882,
     +     0.768627,0.231373,0.23137,
     +     0.847059,0.152941,0.152941,
     +     0.92549,0.0745098,0.074509,
     +     1.0,0.0,0.0 /
C
C Indices used for coloring other plot features; be careful not
C to duplicate any color indices in ICLR1
C
      DATA ICLR2 / 0, 1, 2, 149, 225, 175, 176 /
C
C RGB values for other plot features
C
      DATA RGB2 / 
     +     1.0,1.0,1.0,
     +     0.0,0.0,0.0,
     +     0.9,0.9,0.9,
     +     0.6,0.6,0.6,
     +     0.3,0.3,0.3,
     +     0.8,0.9,1.0,
     +     0.25,0.0,0.5 /
C
C -----------------------------------------------------------------
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Set up auxiliary colors
C
      DO 10 I=1,NCLRS2,1
         CALL GSCR(IWKID,ICLR2(I),RGB2(1,I),RGB2(2,I),RGB2(3,I))
 10   CONTINUE
C
C Read the input array data
C
      CALL RDDATA(U,V,P,MSIZE,NSIZE)
C
C Message the data to eliminate surplus of vectors near the pole
C
      DO 50 J=NSIZE,NSIZE-NROWS+1,-1
         DO 49 I=1,MSIZE
            IF (MOD(I,ITHIN(NSIZE-J+1)).NE.0) THEN
               U(I,J) = -9999.0
            ENDIF
 49      CONTINUE
 50   CONTINUE
C
C Set up the EZMAP projection
C         
      CALL MAPSET('CO',20.0,-180.0,20.0,0.0)
      CALL MAPROJ('ST',90.0,180.0,45.0)
      CALL MAPINT
C
C Tell Vectors to use the mapping established by EZMAP
C
      CALL VVSETI('MAP -- Mapping Flag', 1)
      CALL VVSETI('SET -- Set Call Flag', 0)
C
C Set up data coordinate boundaries and special value processing 
C appropriately for the dataset 
C
      CALL VVSETR('XC1 -- Lower X Bound', -180.0)
      CALL VVSETR('XCM -- Upper X Bound', 180.0)
      CALL VVSETR('YC1 -- Lower X Bound', -90.0)
      CALL VVSETR('YCN -- Upper Y Bound', 90.0)
C
      CALL VVSETI('SVF -- Special Values Flag', 3)
      CALL VVSETR('USV -- U Special Value', -9999.0)
      CALL VVSETR('VSV -- V Special Value', -9999.0)
      CALL VVSETR('PSV - P Special Value', -9999.0)
      CALL VVSETI('SPC - P Special Color', 1)
C
C Do the equivalent Conpack setup; note that the special value
C parameter works a bit differently, and also Conpack requires
C an Out of Range value to be set whenever the data grid extends
C outside the map boundaries. The standard value for the default
C version of CPMPXY is 1.0E12
C
      CALL CPSETI('MAP -- Mapping Flag', 1)
      CALL CPSETI('SET -- Set Call Flag', 0)
      CALL CPSETR('XC1 -- Lower X Bound', -180.0)
      CALL CPSETR('XCM -- Upper X Bound', 180.0)
      CALL CPSETR('YC1 -- Lower X Bound', -90.0)
      CALL CPSETR('YCN -- Upper Y Bound', 90.0)
      CALL CPSETR('SPV -- Special Value',-9999.0)
      CALL CPSETR('ORV -- Out of Range Value',1.0E12)
C
C Set Conpack graphics text parameters
C
      CALL SETCGT
C
C Turn on statistics reporting
C
      CALL VVSETI('VST -- Vector Statistics', 1)
C
C Initialize the drawing of the contour plot, and tell Conpack
C to pick contour levels.
C
      CALL CPRECT (P,MSIZE,MSIZE,NSIZE,RWRK,ICPRWL,IWRK,ICPIWL)
      CALL CPPKCL (P,RWRK,IWRK)
C
C Set up contour line attributes
C
      CALL CPGETI('NCL - Number Of Contour Levels',NCLV)
      CALL SETCLA(NCLV, ICLR2(6),ICLR2(3))
C
C Initialize the area map, and add the Conpack labels to the area map
C
      CALL ARINAM (IAM,IAREAL)
      CALL CPLBAM (P,RWRK,IWRK,IAM)
C
C Set up vector color processing
C
      CALL VVSETI('MSK -- Vector Masking',1)
      CALL VVSETI('CTV -- Color Thresholds Value', 2)
      CALL VVSETI('NLV -- Number Of Levels', NCLRS1)
      DO 100 I=1,NCLRS1,1
         CALL GSCR(IWKID,ICLR1(I),RGB1(1,I),RGB1(2,I),RGB1(3,I))
         CALL VVSETI('PAI -- Parameter Array Index', I)
         CALL VVSETI('CLR -- GKS Color Index', ICLR1(I))
 100  CONTINUE

      DO 1000 I=1,6
C
C For the last frame modify the color table for a black background
C and modify the contour attributes
C
         IF (I.EQ.6) THEN
            CALL GSCR(IWKID,ICLR2(1),RGB2(1,2),RGB2(2,2),RGB2(3,2))
            CALL GSCR(IWKID,ICLR2(2),RGB2(1,1),RGB2(2,1),RGB2(3,1))
            CALL SETCLA(NCLV, ICLR2(7),ICLR2(3))
         END IF
C
C Draw the masked contour lines
C
         IF (I.EQ.3 .OR. I.GE.5) THEN
            CALL CPCLDM (P,RWRK,IWRK,IAM,DRAWCL)
         END IF
C
C Draw the continental outline with a wide line
C
         IF (I.EQ.2 .OR. I.GE.5) THEN
            ICOL=ICLR2(3)
            IF (I.GT.5) ICOL=ICLR2(5)
            CALL MAPSTI('C5 - Continental Outline Color',ICOL)
            CALL GSLWSC(8.0)
            CALL MAPLOT
         END IF
         CALL GSLWSC(1.0)
C
C Draw the map grid
C
         IF (I.EQ.1 .OR. I.GE.5) THEN
            CALL MAPSTI('C2 - Grid',ICLR2(4))
            CALL GSPLCI(ICLR2(2))
            CALL MAPGRM (IAM,XCRA,YCRA,MCRA,IAAI,IAGI,NOGI,DRAWCL)
            CALL GSPLCI(1)
         END IF
C
         IF (I.EQ.4 .OR. I.GE.5) THEN
C
C Initialize Vectors
C
            CALL VVINIT (U,MSIZE,V,MSIZE,P,MSIZE,MSIZE,NSIZE,IDM,IDM)
C
C Adjust vector rendering options
C
            CALL VVSETR('AMN -- Arrow Minimum Size',0.007)
            CALL VVSETR('LWD -- Vector Line Width',1.75)
            CALL VVGETR('VMN -- Minimum Vector',VMN)
            CALL VVGETR('VMX -- Maximum Vector',VMX)
            CALL VVSETR('VLC -- Vector Low Cutoff',VMN+0.1*(VMX-VMN))
            CALL VVGETR('DMX -- Device Maximum Vector Length',DMX)
            CALL GETSET(VL,VR,VB,VT,UL,UR,UB,UT,LL)
            CALL VVSETR('VRL - Vector Realized Length',4.0*DMX/(VR-VL))
            CALL VVSETR('VFR -- Vector Fractional Minimum',0.4)
C
C Draw the vector field plot
C
            CALL VVECTR (U,V,P,IAM,VVUDMV,IDM)
         END IF
C
C Draw continental outlines again with thin line and brighter
C
         IF (I.EQ.2 .OR. I.GE.5) THEN
            CALL MAPSTI('C5 - Continental Outline Color',ICLR2(2))
            CALL MAPLOT
         END IF
C
C Draw labels last
C
         IF (I.EQ.3 .OR. I.GE.5) THEN
            IF (I.GT.5) THEN
               CALL CPSETI('HLB',1)
               CALL GSFAIS(0)
            ELSE
               CALL CPSETI('HLB',3)
               CALL GSFAIS(1)
            END IF
            CALL CPLBDR (P,RWRK,IWRK)
         END IF
C
C Draw a perimeter boundary and eject the frame
C
         CALL PERIM(1,0,1,0)
         CALL FRAME
C
 1000 CONTINUE
C
C     Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      STOP
      END
C
      SUBROUTINE RDDATA(U,V,P,M,N)
C
C Read the data arrays from the standard input 
C
      DIMENSION U(M,N), V(M,N), P(M,N)
C     
      READ (*,*) U
      READ (*,*) V
      READ (*,*) P
C
      RETURN
      END
C
C =====================================================================
C
      SUBROUTINE DRAWCL (XCS,YCS,NCS,IAI,IAG,NAI)
C
C Routine for masked drawing of contour and grid lines
C
C This version of DRAWCL draws the polyline defined by the points
C ((XCS(I),YCS(I)),I=1,NCS) if and only if none of the area identifiers
C for the area containing the polyline are negative.  The dash package
C routine CURVED is called to do the drawing.
C
      DIMENSION XCS(*),YCS(*),IAI(*),IAG(*)
C
C Turn on drawing.
C
      IDR=1
C
C If any area identifier is negative, turn off drawing.
C
      DO 101 I=1,NAI
         IF (IAI(I).LT.0) IDR=0
 101  CONTINUE
C
C If drawing is turned on, draw the polyline.
C
      IF (IDR.NE.0) CALL CURVED (XCS,YCS,NCS)
C
C Done.
C
      RETURN
C
      END
C
C =====================================================================
C
      SUBROUTINE SETCGT
C
C Sets Conpack Graphics Text Parameters
C
      CALL CPSETI ('LLP - LINE LABEL POSITIONING',3)
      CALL CPSETI ('RWC - REAL WORKSPACE FOR CONTOURS',200)
      CALL CPSETI ('HLB - HIGH/LOW LABEL BOX FLAG',1)
      CALL CPSETI ('LLB - HIGH/LOW LABEL BOX FLAG',0)
      CALL CPSETC ('ILT - INFORMATION LABEL TEXT',' ')
      CALL CPSETI ('HLO - HIGH/LOW LABEL OVERLAP FLAG',11)
      CALL CPSETR ('CWM - CHARACTER WIDTH MULTIPLIER',1.25)
C
      RETURN
      END
C
C =====================================================================
C
      SUBROUTINE SETCLA (NCLV, ICLCLR, IAXCLR)
C
C Sets Contour Line Attributes
C
      DO 100 ICLV=1,NCLV
C
         CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',ICLV)
         CALL CPGETI ('CLU - CONTOUR LEVEL USE FLAG',ICLU)
         CALL CPSETI ('CLL - CONTOUR-LINE LINE WIDTH',3)
         CALL CPSETI ('CLC - CONTOUR-LINE COLOR', ICLCLR)
         IF (ICLU.EQ.3) THEN
            CALL CPSETI ('CLL - CONTOUR-LINE LINE WIDTH',6)
         END IF
C
 100  CONTINUE
C
C 'Special' contour lines - grid, special values, and out of range
C boundaries 
C
      CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',-1)
      CALL CPSETI ('CLU - CONTOUR LEVEL USE FLAG',0)
      CALL CPSETR ('CLL - CONTOUR LEVEL LINE WIDTH',2.)
      CALL CPSETI ('CLC - CONTOUR LEVEL LINE COLOR',IAXCLR)
C
      CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',-2)
      CALL CPSETI ('CLU - CONTOUR LEVEL USE FLAG',1)
      CALL CPSETR ('CLL - CONTOUR LEVEL LINE WIDTH',2.)
      CALL CPSETI ('CLC - CONTOUR LEVEL LINE COLOR',IAXCLR)
C
      CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',-3)
      CALL CPSETI ('CLU - CONTOUR LEVEL USE FLAG',1)
      CALL CPSETR ('CLL - CONTOUR LEVEL LINE WIDTH',2.)
      CALL CPSETI ('CLC - CONTOUR LEVEL LINE COLOR',IAXCLR)
C
      RETURN
      END

C
C	$Id: gethol.f,v 1.4 2008-07-27 00:17:21 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
C
      SUBROUTINE GETHOL (INCHAR,IOUTCH,IERR)
C ON ENTRY
C   INCHAR is a single FORTRAN 77 type character.
C   IOUTCH AND IERR MAY HAVE ANY VALUE.
C   Subroutine HTABLE must have already been called
C ON EXIT
C   INCHAR IS UNCHANGED.
C   IOUTCH CONTAINS THE REPRESENTATION OF THE CHARACTER IN INCHAR IN
C   HOLLERITH CODE, RIGHT JUSTIFIED.
C   IOUTCH CONTAINS 200 IF INCHAR DID NOT REPRESENT A FORTRAN CHARACTER
C   OR AN APOSTROPHE.
C   IERR = 0 IF THE CHARACTER IN INCHAR WAS REALLY IN THE FORTRAN
C            CHARACTER SET OR AN APOSTROPHE.
C        = 1 OTHERWISE
C
      INTEGER     TBSIZE, IOUTCH, HOLLER, IERR
      PARAMETER (TBSIZE=256)
C
C If your machine uses the ASCII character set, TBSIZE can be changed
C to 128.
C
      COMMON /HOLTAB/ HOLLER(TBSIZE), READY
      LOGICAL     READY
      CHARACTER*1 INCHAR
C
C This routine depends on the fact that the HOLLER array has been
C initialized by a call to HTABLE
C
      IF ( .NOT. READY) THEN
           IERR   = 1
           IOUTCH = 200
           GOTO 999
      ENDIF
C
      IERR   = 0
C
C Initialize the error indicator to 'no error', then retrieve the
C value from the hollerith code table using the intrinsic ICHAR
C function as an index into the table.
C
      IOUTCH = HOLLER ( ICHAR(INCHAR) )
      IF (IOUTCH .EQ. 200) IERR = 1
C
 999  CONTINUE
      RETURN
      END

C
C	$Id: csdelnod.f,v 1.5 2008-07-27 03:10:06 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CSDELNOD (K, N,X,Y,Z,LIST,LPTR,LEND,LNEW,LWK,
     .                   IWK, IER)
      INTEGER K, N, LIST(*), LPTR(*), LEND(*), LNEW, LWK,
     .        IWK(2,*), IER
      DOUBLE PRECISION X(*), Y(*), Z(*)
C
C***********************************************************
C
C                                              From STRIPACK
C                                            Robert J. Renka
C                                  Dept. of Computer Science
C                                       Univ. of North Texas
C                                           renka@cs.unt.edu
C                                                   11/30/99
C
C   This subroutine deletes node K (along with all arcs
C incident on node K) from a triangulation of N nodes on the
C unit sphere, and inserts arcs as necessary to produce a
C triangulation of the remaining N-1 nodes.  If a Delaunay
C triangulation is input, a Delaunay triangulation will
C result, and thus, CSDELNOD reverses the effect of a call to
C Subroutine CSADDNOD.
C
C
C On input:
C
C       K = Index (for X, Y, and Z) of the node to be
C           deleted.  1 .LE. K .LE. N.
C
C K is not altered by this routine.
C
C       N = Number of nodes in the triangulation on input.
C           N .GE. 4.  Note that N will be decremented
C           following the deletion.
C
C       X,Y,Z = Arrays of length N containing the Cartesian
C               coordinates of the nodes in the triangula-
C               tion.
C
C       LIST,LPTR,LEND,LNEW = Data structure defining the
C                             triangulation.  Refer to Sub-
C                             routine CSTRMESH.
C
C       LWK = Number of columns reserved for IWK.  LWK must
C             be at least NNB-3, where NNB is the number of
C             neighbors of node K, including an extra
C             pseudo-node if K is a boundary node.
C
C       IWK = Integer work array dimensioned 2 by LWK (or
C             array of length .GE. 2*LWK).
C
C On output:
C
C       N = Number of nodes in the triangulation on output.
C           The input value is decremented unless 1 .LE. IER
C           .LE. 4.
C
C       X,Y,Z = Updated arrays containing nodal coordinates
C               (with elements K+1,...,N+1 shifted up one
C               position, thus overwriting element K) unless
C               1 .LE. IER .LE. 4.
C
C       LIST,LPTR,LEND,LNEW = Updated triangulation data
C                             structure reflecting the dele-
C                             tion unless 1 .LE. IER .LE. 4.
C                             Note that the data structure
C                             may have been altered if IER >
C                             3.
C
C       LWK = Number of IWK columns required unless IER = 1
C             or IER = 3.
C
C       IWK = Indexes of the endpoints of the new arcs added
C             unless LWK = 0 or 1 .LE. IER .LE. 4.  (Arcs
C             are associated with columns, or pairs of
C             adjacent elements if IWK is declared as a
C             singly-subscripted array.)
C
C       IER = Error indicator:
C             IER = 0 if no errors were encountered.
C             IER = 1 if K or N is outside its valid range
C                     or LWK < 0 on input.
C             IER = 2 if more space is required in IWK.
C                     Refer to LWK.
C             IER = 3 if the triangulation data structure is
C                     invalid on input.
C             IER = 4 if K indexes an interior node with
C                     four or more neighbors, none of which
C                     can be swapped out due to collineari-
C                     ty, and K cannot therefore be deleted.
C             IER = 5 if an error flag (other than IER = 1)
C                     was returned by CSOPTIM.  An error
C                     message is written to the standard
C                     output unit in this case.
C             IER = 6 if error flag 1 was returned by CSOPTIM.
C                     This is not necessarily an error, but
C                     the arcs may not be optimal.
C
C   Note that the deletion may result in all remaining nodes
C being collinear.  This situation is not flagged.
C
C Modules required by CSDELNOD:  CSDELNB, CSLEFT, CSLSTPTR, CSNBCNT,
C                                CSOPTIM, CSSWAP, CSSWPTST
C
C Intrinsic function called by CSDELNOD:  ABS
C
C***********************************************************
C
      INTEGER CSLSTPTR, CSNBCNT
      INTEGER I, IERR, IWL, J, LNW, LP, LP21, LPF, LPH, LPL,
     .        LPL2, LPN, LWKL, N1, N2, NFRST, NIT, NL, NN,
     .        NNB, NR
      LOGICAL CSLEFT
      LOGICAL BDRY
      DOUBLE PRECISION X1, X2, XL, XR, Y1, Y2, YL, YR, Z1,
     .                 Z2, ZL, ZR
C
C Local parameters:
C
C BDRY =    Logical variable with value TRUE iff N1 is a
C             boundary node
C I,J =     DO-loop indexes
C IERR =    Error flag returned by CSOPTIM
C IWL =     Number of IWK columns containing arcs
C LNW =     Local copy of LNEW
C LP =      LIST pointer
C LP21 =    LIST pointer returned by CSSWAP
C LPF,LPL = Pointers to the first and last neighbors of N1
C LPH =     Pointer (or flag) returned by CSDELNB
C LPL2 =    Pointer to the last neighbor of N2
C LPN =     Pointer to a neighbor of N1
C LWKL =    Input value of LWK
C N1 =      Local copy of K
C N2 =      Neighbor of N1
C NFRST =   First neighbor of N1:  LIST(LPF)
C NIT =     Number of iterations in CSOPTIM
C NR,NL =   Neighbors of N1 preceding (to the right of) and
C             following (to the left of) N2, respectively
C NN =      Number of nodes in the triangulation
C NNB =     Number of neighbors of N1 (including a pseudo-
C             node representing the boundary if N1 is a
C             boundary node)
C X1,Y1,Z1 = Coordinates of N1
C X2,Y2,Z2 = Coordinates of N2
C XL,YL,ZL = Coordinates of NL
C XR,YR,ZR = Coordinates of NR
C
C
C Set N1 to K and NNB to the number of neighbors of N1 (plus
C   one if N1 is a boundary node), and test for errors.  LPF
C   and LPL are LIST indexes of the first and last neighbors
C   of N1, IWL is the number of IWK columns containing arcs,
C   and BDRY is TRUE iff N1 is a boundary node.
C
      N1 = K
      NN = N
      IF (N1 .LT. 1  .OR.  N1 .GT. NN  .OR.  NN .LT. 4  .OR.
     .    LWK .LT. 0) GO TO 21
      LPL = LEND(N1)
      LPF = LPTR(LPL)
      NNB = CSNBCNT(LPL,LPTR)
      BDRY = LIST(LPL) .LT. 0
      IF (BDRY) NNB = NNB + 1
      IF (NNB .LT. 3) GO TO 23
      LWKL = LWK
      LWK = NNB - 3
      IF (LWKL .LT. LWK) GO TO 22
      IWL = 0
      IF (NNB .EQ. 3) GO TO 3
C
C Initialize for loop on arcs N1-N2 for neighbors N2 of N1,
C   beginning with the second neighbor.  NR and NL are the
C   neighbors preceding and following N2, respectively, and
C   LP indexes NL.  The loop is exited when all possible
C   swaps have been applied to arcs incident on N1.
C
      X1 = X(N1)
      Y1 = Y(N1)
      Z1 = Z(N1)
      NFRST = LIST(LPF)
      NR = NFRST
      XR = X(NR)
      YR = Y(NR)
      ZR = Z(NR)
      LP = LPTR(LPF)
      N2 = LIST(LP)
      X2 = X(N2)
      Y2 = Y(N2)
      Z2 = Z(N2)
      LP = LPTR(LP)
C
C Top of loop:  set NL to the neighbor following N2.
C
    1 NL = ABS(LIST(LP))
      IF (NL .EQ. NFRST  .AND.  BDRY) GO TO 3
      XL = X(NL)
      YL = Y(NL)
      ZL = Z(NL)
C
C   Test for a convex quadrilateral.  To avoid an incorrect
C     test caused by collinearity, use the fact that if N1
C     is a boundary node, then N1 CSLEFT NR->NL and if N2 is
C     a boundary node, then N2 CSLEFT NL->NR.
C
      LPL2 = LEND(N2)
      IF ( .NOT. ((BDRY  .OR.  CSLEFT(XR,YR,ZR,XL,YL,ZL,X1,Y1,
     .      Z1))  .AND.  (LIST(LPL2) .LT. 0  .OR.
     .      CSLEFT(XL,YL,ZL,XR,YR,ZR,X2,Y2,Z2))) ) THEN
C
C   Nonconvex quadrilateral -- no swap is possible.
C
        NR = N2
        XR = X2
        YR = Y2
        ZR = Z2
        GO TO 2
      ENDIF
C
C   The quadrilateral defined by adjacent triangles
C     (N1,N2,NL) and (N2,N1,NR) is convex.  Swap in
C     NL-NR and store it in IWK unless NL and NR are
C     already adjacent, in which case the swap is not
C     possible.  Indexes larger than N1 must be decremented
C     since N1 will be deleted from X, Y, and Z.
C
      CALL CSSWAP (NL,NR,N1,N2, LIST,LPTR,LEND, LP21)
      IF (LP21 .EQ. 0) THEN
        NR = N2
        XR = X2
        YR = Y2
        ZR = Z2
        GO TO 2
      ENDIF
      IWL = IWL + 1
      IF (NL .LE. N1) THEN
        IWK(1,IWL) = NL
      ELSE
        IWK(1,IWL) = NL - 1
      ENDIF
      IF (NR .LE. N1) THEN
        IWK(2,IWL) = NR
      ELSE
        IWK(2,IWL) = NR - 1
      ENDIF
C
C   Recompute the LIST indexes and NFRST, and decrement NNB.
C
      LPL = LEND(N1)
      NNB = NNB - 1
      IF (NNB .EQ. 3) GO TO 3
      LPF = LPTR(LPL)
      NFRST = LIST(LPF)
      LP = CSLSTPTR(LPL,NL,LIST,LPTR)
      IF (NR .EQ. NFRST) GO TO 2
C
C   NR is not the first neighbor of N1.
C     Back up and test N1-NR for a swap again:  Set N2 to
C     NR and NR to the previous neighbor of N1 -- the
C     neighbor of NR which follows N1.  LP21 points to NL
C     as a neighbor of NR.
C
      N2 = NR
      X2 = XR
      Y2 = YR
      Z2 = ZR
      LP21 = LPTR(LP21)
      LP21 = LPTR(LP21)
      NR = ABS(LIST(LP21))
      XR = X(NR)
      YR = Y(NR)
      ZR = Z(NR)
      GO TO 1
C
C   Bottom of loop -- test for termination of loop.
C
    2 IF (N2 .EQ. NFRST) GO TO 3
      N2 = NL
      X2 = XL
      Y2 = YL
      Z2 = ZL
      LP = LPTR(LP)
      GO TO 1
C
C Delete N1 and all its incident arcs.  If N1 is an interior
C   node and either NNB > 3 or NNB = 3 and N2 CSLEFT NR->NL,
C   then N1 must be separated from its neighbors by a plane
C   containing the origin -- its removal reverses the effect
C   of a call to CSCOVSPH, and all its neighbors become
C   boundary nodes.  This is achieved by treating it as if
C   it were a boundary node (setting BDRY to TRUE, changing
C   a sign in LIST, and incrementing NNB).
C
    3 IF (.NOT. BDRY) THEN
        IF (NNB .GT. 3) THEN
          BDRY = .TRUE.
        ELSE
          LPF = LPTR(LPL)
          NR = LIST(LPF)
          LP = LPTR(LPF)
          N2 = LIST(LP)
          NL = LIST(LPL)
          BDRY = CSLEFT(X(NR),Y(NR),Z(NR),X(NL),Y(NL),Z(NL),
     .                X(N2),Y(N2),Z(N2))
        ENDIF
        IF (BDRY) THEN
C
C   IF a boundary node already exists, then N1 and its
C     neighbors cannot be converted to boundary nodes.
C     (They must be collinear.)  This is a problem if
C     NNB > 3.
C
          DO 4 I = 1,NN
            IF (LIST(LEND(I)) .LT. 0) THEN
              BDRY = .FALSE.
              GO TO 5
            ENDIF
    4       CONTINUE
          LIST(LPL) = -LIST(LPL)
          NNB = NNB + 1
        ENDIF
      ENDIF
    5 IF (.NOT. BDRY  .AND.  NNB .GT. 3) GO TO 24
C
C Initialize for loop on neighbors.  LPL points to the last
C   neighbor of N1.  LNEW is stored in local variable LNW.
C
      LP = LPL
      LNW = LNEW
C
C Loop on neighbors N2 of N1, beginning with the first.
C
    6 LP = LPTR(LP)
        N2 = ABS(LIST(LP))
        CALL CSDELNB (N2,N1,N, LIST,LPTR,LEND,LNW, LPH)
        IF (LPH .LT. 0) GO TO 23
C
C   LP and LPL may require alteration.
C
        IF (LPL .EQ. LNW) LPL = LPH
        IF (LP .EQ. LNW) LP = LPH
        IF (LP .NE. LPL) GO TO 6
C
C Delete N1 from X, Y, Z, and LEND, and remove its adjacency
C   list from LIST and LPTR.  LIST entries (nodal indexes)
C   which are larger than N1 must be decremented.
C
      NN = NN - 1
      IF (N1 .GT. NN) GO TO 9
      DO 7 I = N1,NN
        X(I) = X(I+1)
        Y(I) = Y(I+1)
        Z(I) = Z(I+1)
        LEND(I) = LEND(I+1)
    7   CONTINUE
C
      DO 8 I = 1,LNW-1
        IF (LIST(I) .GT. N1) LIST(I) = LIST(I) - 1
        IF (LIST(I) .LT. -N1) LIST(I) = LIST(I) + 1
    8   CONTINUE
C
C   For LPN = first to last neighbors of N1, delete the
C     preceding neighbor (indexed by LP).
C
C   Each empty LIST,LPTR location LP is filled in with the
C     values at LNW-1, and LNW is decremented.  All pointers
C     (including those in LPTR and LEND) with value LNW-1
C     must be changed to LP.
C
C  LPL points to the last neighbor of N1.
C
    9 IF (BDRY) NNB = NNB - 1
      LPN = LPL
      DO 13 J = 1,NNB
        LNW = LNW - 1
        LP = LPN
        LPN = LPTR(LP)
        LIST(LP) = LIST(LNW)
        LPTR(LP) = LPTR(LNW)
        IF (LPTR(LPN) .EQ. LNW) LPTR(LPN) = LP
        IF (LPN .EQ. LNW) LPN = LP
        DO 10 I = NN,1,-1
          IF (LEND(I) .EQ. LNW) THEN
            LEND(I) = LP
            GO TO 11
          ENDIF
   10     CONTINUE
C
   11   DO 12 I = LNW-1,1,-1
          IF (LPTR(I) .EQ. LNW) LPTR(I) = LP
   12     CONTINUE
   13   CONTINUE
C
C Update N and LNEW, and optimize the patch of triangles
C   containing K (on input) by applying swaps to the arcs
C   in IWK.
C
      N = NN
      LNEW = LNW
      IF (IWL .GT. 0) THEN
        NIT = 4*IWL
        CALL CSOPTIM (X,Y,Z,IWL, LIST,LPTR,LEND,NIT,IWK, IERR)
        IF (IERR .NE. 0  .AND.  IERR .NE. 1) GO TO 25
        IF (IERR .EQ. 1) GO TO 26
      ENDIF
C
C Successful termination.
C
      IER = 0
      RETURN
C
C Invalid input parameter.
C
   21 IER = 1
      RETURN
C
C Insufficient space reserved for IWK.
C
   22 IER = 2
      RETURN
C
C Invalid triangulation data structure.  NNB < 3 on input or
C   N2 is a neighbor of N1 but N1 is not a neighbor of N2.
C
   23 IER = 3
      RETURN
C
C N1 is interior but NNB could not be reduced to 3.
C
   24 IER = 4
      RETURN
C
C Error flag (other than 1) returned by CSOPTIM.
C
   25 IER = 5
      WRITE (*,100) NIT, IERR
  100 FORMAT (//5X,'*** Error in CSOPTIM (called from ',
     .        'CSDELNOD):  NIT = ',I4,', IER = ',I1,' ***'/)
      RETURN
C
C Error flag 1 returned by CSOPTIM.
C
   26 IER = 6
      RETURN
      END

C
C $Id: VIEWF.f,v 1.1 2001-10-09 00:18:37 haley Exp $
C
C****************************************************************
C                                                               *
C                       Copyright (C)  1994                     *
C       University Corporation for Atmospheric Research         *
C                       All Rights Reserved                     *
C                                                               *
C****************************************************************
C
C      File:            VIEW.f
C
C      Author:          Jeff W. Boote
C                       National Center for Atmospheric Research
C                       PO 3000, Boulder, Colorado
C
C      Date:            Fri Apr 15 16:55:34 MDT 1994
C
C      Description:     
C
      subroutine nhlfgetbb(ipid,top,bottom,left,right,ierr)
        integer ipid,ierr
        real top,bottom,left,right
        call nhlfpgetbb(ipid,top,bottom,left,right,ierr)
      end
      subroutine nhlfisview(id,istat)

        integer id,istat
        call nhlpfisview(id,istat)
      end

C
C $Id: mdppos.f,v 1.9 2008-09-18 00:42:17 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MDPPOS (ARG1,ARG2,ARG3,ARG4)
C
        DOUBLE PRECISION ARG1,ARG2,ARG3,ARG4
C
C Declare required common blocks.  See MAPBDX for descriptions of these
C common blocks and the variables in them.
C
        COMMON /MAPCM4/  GRDR,GRID,GRLA,GRLO,GRPO,OTOL,PDRE,PLA1,PLA2,
     +                   PLA3,PLA4,PLB1,PLB2,PLB3,PLB4,PLNO,PLTO,ROTA,
     +                   SRCH,XLOW,XROW,YBOW,YTOW,IDOT,IDSH,IDTL,ILCW,
     +                   ILTS,JPRJ,ELPF,INTF,LBLF,PRMF
        DOUBLE PRECISION GRDR,GRID,GRLA,GRLO,GRPO,OTOL,PDRE,PLA1,PLA2,
     +                   PLA3,PLA4,PLB1,PLB2,PLB3,PLB4,PLNO,PLTO,ROTA,
     +                   SRCH,XLOW,XROW,YBOW,YTOW
        INTEGER          IDOT,IDSH,IDTL,ILCW,ILTS,JPRJ
        LOGICAL          ELPF,INTF,LBLF,PRMF
        SAVE   /MAPCM4/
C
C Check for an uncleared prior error.
C
        IF (ICFELL('MDPPOS - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C Check the arguments for errors.
C
        IF (ARG1.LT.0.D0.OR.ARG1.GE.ARG2.OR.ARG2.GT.1.D0) GO TO 901
        IF (ARG3.LT.0.D0.OR.ARG3.GE.ARG4.OR.ARG4.GT.1.D0) GO TO 901
C
C Transfer in the values.
C
        XLOW=ARG1
        XROW=ARG2
        YBOW=ARG3
        YTOW=ARG4
C
C Set the flag to indicate that initialization is now required.
C
        INTF=.TRUE.
C
C Done.
C
        RETURN
C
C Error exit.
C
  901   CALL SETER ('MDPPOS - ARGUMENTS ARE INCORRECT',2,1)
        RETURN
C
      END

C
C     $Id: mp02f.f,v 1.15 2010-03-15 22:49:24 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C                            Copyright (C)  1995                       C
C                 University Corporation for Atmospheric Research      C
C                            All Rights Reserved                       C
C                                                                      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C      File:            mp02f.f
C
C      Author:          Dave Brown (converted to Fortran by Mary Haley)
C                       National Center for Atmospheric Research
C                       PO 3000, Boulder, Colorado
C
C      Date:            Tue Jan 24 10:08:49 MST 1995
C
C      Description:     Demonstrates individual control of MapPlot areas
C
      external NhlFAppClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFCairoWindowWorkstationClass
      external NhlFMapPlotClass
      integer appid,wid,mapid
      integer rlist
C
C String arrays for specifying areas
C
      character*10 fill_specs(7)
      data fill_specs/'mexico','bolivia','brazil','nicaragua',
     1                     'cuba','haiti','canada'/

      character*11 outline_specs(6)
      data outline_specs/'argentina','paraguay','colombia',
     1                    'us-colorado','us-texas','us-kentucky'/

      character*11 mask_specs(7)
      data mask_specs/'us-colorado','us-texas','us-kentucky',
     1            'bolivia','paraguay','nicaragua','oceans'/
      character*7  wks_type
C
C Default is to display output to an X workstation
C
      wks_type = "x11"
C
C Initialize the high level utility library
C
      call NhlFInitialize
C
C Create an application context. Set the app dir to the current
C directory so the application looks for a resource file in the
C working directory. The resource file sets most of the Contour
C resources that remain fixed throughout the life of the Contour
C object.
C
      call NhlFRLCreate(rlist,'SETRL')
      call NhlFRLClear(rlist)
      call NhlFRLSetstring(rlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'mp02',NhlFAppClass,0,rlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkMetaName','./mp02f.ncgm',ierr)
         call NhlFCreate(wid,'mp02Work',NhlFNcgmWorkstationClass,0,
     1        rlist,ierr)
      else  if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X workstation
C
         call NhlFRLClear(rlist)
         call NhlFRLSetinteger(rlist,'wkPause',1,ierr)
         call NhlFCreate(wid,'mp02Work',
     +     NhlFCairoWindowWorkstationClass,0,
     1     rlist,ierr)
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PostScript workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPSFileName','./mp02f.ps',ierr)
         call NhlFCreate(wid,'mp02Work',NhlFPSWorkstationClass,0,
     1        rlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPDFFileName','./mp02f.pdf',ierr)
         call NhlFCreate(wid,'mp02Work',NhlFPDFWorkstationClass,0,
     1        rlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF object.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetstring(rlist,'wkFileName','./mp02f',ierr)
         call NhlFCreate(wid,'mp02Work',
     1        NhlFCairoPSPDFWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG object.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetstring(rlist,'wkFileName','./mp02f',ierr)
         call NhlFCreate(wid,'mp02Work',
     1        NhlFCairoImageWorkstationClass,0,rlist,ierr)
      endif
C
C Create a plot focusing on North and South America
C Outlines are on by default turn fill on.
C By default the geophysical boundary set is used both for outline and
C fill.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetstring(rlist,'pmTitleDisplayMode','always',ierr)
      call NhlFRLSetstring(rlist,'tiMainString','mp02f - Frame 1',
     1    ierr)
      call NhlFRLSetstring(rlist,'mpFillOn','TRUE',ierr)
      call NhlFRLSetstring(rlist,'mpProjection','orthographic',ierr)
      call NhlFRLSetString(rlist,'mpPerimOn','true',ierr)
      call NhlFRLSetfloat(rlist,'mpCenterLatF',10.0,ierr)
      call NhlFRLSetfloat(rlist,'mpCenterLonF',-90.0,ierr)
      call NhlFRLSetfloat(rlist,'mpCenterRotF',45.0,ierr)
      call NhlFRLSetstring(rlist,'mpLimitMode','latlon',ierr)
      call NhlFRLSetfloat(rlist,'mpMinLatF',-60.0,ierr)
      call NhlFRLSetfloat(rlist,'mpMaxLatF',60.0,ierr)
      call NhlFRLSetfloat(rlist,'mpMinLonF',-135.0,ierr)
      call NhlFRLSetfloat(rlist,'mpMaxLonF',-45.0,ierr)
C
C Highlight selected countries using their "political" color.
C
      call NhlFRLSetstringarray(rlist,'mpFillAreaSpecifiers',
     1      fill_specs,7,ierr)
      
      call NhlFCreate(mapid,'Map0',NhlFMapPlotClass,wid,rlist,ierr)
      call NhlFDraw(mapid,ierr)
      call NhlFFrame(wid,ierr)
C
C Individually outline some other countries and some US states.
C
      call NhlFRLClear(rlist)  
      call NhlFRLSetstring(rlist,'tiMainString','mp02f - Frame 2',ierr)
      call NhlFRLSetstringarray(rlist,'mpOutlineSpecifiers',
     1    outline_specs,6,ierr)
      call NhlFSetValues(mapid,rlist,ierr)

      call NhlFDraw(mapid,ierr)
      call NhlFFrame(wid,ierr)
C
C Turn off the base geophysical set for outlines and fill, leaving only
C the specified areas.
C Also change the specification, 'canada' to 'canada*', 
C in order to draw all areas belonging to Canada.
C Note that another color, mpDefaultFillColor, is used for all areas
C within the map projection that are otherwise not drawn, including the
C oceans. If you look closely, you will see that the Canadian lakes 
C are not drawn in the color used in the previous frame for the ocean.
C The wild card specification, 'canada*', picks up all the lakes of
C Canada Lakes are drawn using mpInlandWaterFillColor, which is, by
C default, set to the same color as mpOceanFillColor.
C
      fill_specs(5) = 'canada*'
      call NhlFRLClear(rlist)  
      call NhlFRLSetstring(rlist,'tiMainString','mp02f - Frame 3',ierr)
      call NhlFRLSetstring(rlist,'mpFillBoundarySets','noBoundaries',
     *   ierr)
      call NhlFRLSetstring(rlist,'mpOutlineBoundarySets','noBoundaries',
     1     ierr)
      call NhlFRLSetstringarray(rlist,'mpFillAreaSpecifiers',
     1     fill_specs,7,ierr)
      call NhlFSetValues(mapid,rlist,ierr)

      call NhlFDraw(mapid,ierr)
      call NhlFFrame(wid,ierr)
C
C You can also specify area groupings using certain predefined 
C string constants: set 'continents' on to demonstrate.
C Masking an area is different from not explicitly drawing it. In order
C to mask a region you must explicitly include it on in the Mask
C specification list. There is an order of precedence for fill and
C masking. Explicitly named areas take precedence over area groupings, 
C and small areas take precedence over enclosing larger areas.
C Otherwise masking takes precedence over filling.
C >>> Masking or filling individual US states causes processing time
C >>> and memory requirements to increase substantially. Hopefully the 
C >>> performance can be improved before the release.
C
      fill_specs(1) = 'continents'
      fill_specs(2) = 'us'
      call NhlFRLClear(rlist)  
      call NhlFRLSetstring(rlist,'tiMainString','mp02f - Frame 4',ierr)
      call NhlFRLSetstring(rlist,'mpFillBoundarySets','NoBoundaries',
     1    ierr)
      call NhlFRLSetstringarray(rlist,'mpFillAreaSpecifiers',
     1     fill_specs,7,ierr)
      call NhlFRLSetString(rlist,'mpAreaMaskingOn','True',ierr)
      call NhlFRLSetstringarray(rlist,'mpMaskAreaSpecifiers',
     1        mask_specs,7,ierr)
      call NhlFSetValues(mapid,rlist,ierr)

      call NhlFDraw(mapid,ierr)
      call NhlFFrame(wid,ierr)
C
C Destroy the objects created, close the HLU library and exit.
C
      call NhlFDestroy(mapid,ierr)
      call NhlFDestroy(wid,ierr)
      call NhlFDestroy(appid,ierr)
      call NhlFClose
      stop 
      end

c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by UCAR                 .
c  .                                                             .
c  .       University Corporation for Atmospheric Research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                         SPHEREPACK                          .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c
c
c ... file vlapes.f
c
c     this file includes documentation and code for
c     subroutine vlapes          i
c
c ... files which must be loaded with vlapes.f
c
c     sphcom.f, hrfft.f, vhaes.f, vhses.f
c
c
c
c
C*PL*ERROR* Comment line too long
c     subroutine vlapes(nlat,nlon,ityp,nt,vlap,wlap,idvw,jdvw,br,bi,cr,ci,
c    +mdbc,ndbc,wvhses,lvhses,work,lwork,ierror)
c
c
C*PL*ERROR* Comment line too long
c     subroutine vlapes computes the vector laplacian of the vector field
C*PL*ERROR* Comment line too long
c     (v,w) in (vlap,wlap) (see the definition of the vector laplacian at
c     the output parameter description of vlap,wlap below).  w and wlap
c     are east longitudinal components of the vectors.  v and vlap are
c     colatitudinal components of the vectors.  br,bi,cr, and ci are the
C*PL*ERROR* Comment line too long
c     vector harmonic coefficients of (v,w).  these must be precomputed by
C*PL*ERROR* Comment line too long
c     vhaes and are input parameters to vlapes.  the laplacian components
C*PL*ERROR* Comment line too long
c     in (vlap,wlap) have the same symmetry or lack of symmetry about the
C*PL*ERROR* Comment line too long
c     equator as (v,w).  the input parameters ityp,nt,mdbc,nbdc must have
C*PL*ERROR* Comment line too long
c     the same values used by vhaes to compute br,bi,cr, and ci for (v,w).
c     vlap(i,j) and wlap(i,j) are given on the sphere at the colatitude
c
c            theta(i) = (i-1)*pi/(nlat-1)
c
c     for i=1,...,nlat and east longitude
c
c            lambda(j) = (j-1)*2*pi/nlon
c
c     for j=1,...,nlon.
c
c
c     input parameters
c
c     nlat   the number of colatitudes on the full sphere including the
c            poles. for example, nlat = 37 for a five degree grid.
c            nlat determines the grid increment in colatitude as
c            pi/(nlat-1).  if nlat is odd the equator is located at
c            grid point i=(nlat+1)/2. if nlat is even the equator is
c            located half way between points i=nlat/2 and i=nlat/2+1.
c            nlat must be at least 3. note: on the half sphere, the
c            number of grid points in the colatitudinal direction is
c            nlat/2 if nlat is even or (nlat+1)/2 if nlat is odd.
c
c     nlon   the number of distinct longitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater
c            than zero. the axisymmetric case corresponds to nlon=1.
c            the efficiency of the computation is improved when nlon
c            is a product of small prime numbers.
c
C*PL*ERROR* Comment line too long
c     ityp   this parameter should have the same value input to subroutine
c            vhaes to compute the coefficients br,bi,cr, and ci for the
c            vector field (v,w).  ityp is set as follows:
c
C*PL*ERROR* Comment line too long
c            = 0  no symmetries exist in (v,w) about the equator. (vlap,wlap)
C*PL*ERROR* Comment line too long
c                 is computed and stored on the entire sphere in the arrays
C*PL*ERROR* Comment line too long
c                 vlap(i,j) and wlap(i,j) for i=1,...,nlat and j=1,...,nlon.
c
c
C*PL*ERROR* Comment line too long
c            = 1  no symmetries exist in (v,w) about the equator. (vlap,wlap)
C*PL*ERROR* Comment line too long
c                 is computed and stored on the entire sphere in the arrays
C*PL*ERROR* Comment line too long
c                 vlap(i,j) and wlap(i,j) for i=1,...,nlat and j=1,...,nlon.
C*PL*ERROR* Comment line too long
c                 the vorticity of (v,w) is zero so the coefficients cr and
C*PL*ERROR* Comment line too long
c                 ci are zero and are not used.  the vorticity of (vlap,wlap)
c                 is also zero.
c
c
C*PL*ERROR* Comment line too long
c            = 2  no symmetries exist in (v,w) about the equator. (vlap,wlap)
C*PL*ERROR* Comment line too long
c                 is computed and stored on the entire sphere in the arrays
C*PL*ERROR* Comment line too long
c                 vlap(i,j) and wlap(i,j) for i=1,...,nlat and j=1,...,nlon.
C*PL*ERROR* Comment line too long
c                 the divergence of (v,w) is zero so the coefficients br and
C*PL*ERROR* Comment line too long
c                 bi are zero and are not used.  the divergence of (vlap,wlap)
c                 is also zero.
c
C*PL*ERROR* Comment line too long
c            = 3  w is antisymmetric and v is symmetric about the equator.
C*PL*ERROR* Comment line too long
c                 consequently wlap is antisymmetric and vlap is symmetric.
c                 (vlap,wlap) is computed and stored on the northern
C*PL*ERROR* Comment line too long
c                 hemisphere only.  if nlat is odd, storage is in the arrays
C*PL*ERROR* Comment line too long
c                 vlap(i,j),wlap(i,j) for i=1,...,(nlat+1)/2 and j=1,...,nlon.
c                 if nlat is even, storage is in the arrays vlap(i,j),
c                 wlap(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
c
C*PL*ERROR* Comment line too long
c            = 4  w is antisymmetric and v is symmetric about the equator.
C*PL*ERROR* Comment line too long
c                 consequently wlap is antisymmetric and vlap is symmetric.
c                 (vlap,wlap) is computed and stored on the northern
C*PL*ERROR* Comment line too long
c                 hemisphere only.  if nlat is odd, storage is in the arrays
C*PL*ERROR* Comment line too long
c                 vlap(i,j),wlap(i,j) for i=1,...,(nlat+1)/2 and j=1,...,nlon.
c                 if nlat is even, storage is in the arrays vlap(i,j),
c                 wlap(i,j) for i=1,...,nlat/2 and j=1,...,nlon.  the
C*PL*ERROR* Comment line too long
c                 vorticity of (v,w) is zero so the coefficients cr,ci are
c                 zero and are not used. the vorticity of (vlap,wlap) is
c                 also zero.
c
C*PL*ERROR* Comment line too long
c            = 5  w is antisymmetric and v is symmetric about the equator.
C*PL*ERROR* Comment line too long
c                 consequently wlap is antisymmetric and vlap is symmetric.
c                 (vlap,wlap) is computed and stored on the northern
C*PL*ERROR* Comment line too long
c                 hemisphere only.  if nlat is odd, storage is in the arrays
C*PL*ERROR* Comment line too long
c                 vlap(i,j),wlap(i,j) for i=1,...,(nlat+1)/2 and j=1,...,nlon.
c                 if nlat is even, storage is in the arrays vlap(i,j),
c                 wlap(i,j) for i=1,...,nlat/2 and j=1,...,nlon.  the
c                 divergence of (v,w) is zero so the coefficients br,bi
C*PL*ERROR* Comment line too long
c                 are zero and are not used. the divergence of (vlap,wlap)
c                 is also zero.
c
c
C*PL*ERROR* Comment line too long
c            = 6  w is symmetric and v is antisymmetric about the equator.
C*PL*ERROR* Comment line too long
c                 consequently wlap is symmetric and vlap is antisymmetric.
c                 (vlap,wlap) is computed and stored on the northern
C*PL*ERROR* Comment line too long
c                 hemisphere only.  if nlat is odd, storage is in the arrays
C*PL*ERROR* Comment line too long
c                 vlap(i,j),wlap(i,j) for i=1,...,(nlat+1)/2 and j=1,...,nlon.
c                 if nlat is even, storage is in the arrays vlap(i,j),
c                 wlap(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
c
C*PL*ERROR* Comment line too long
c            = 7  w is symmetric and v is antisymmetric about the equator.
C*PL*ERROR* Comment line too long
c                 consequently wlap is symmetric and vlap is antisymmetric.
c                 (vlap,wlap) is computed and stored on the northern
C*PL*ERROR* Comment line too long
c                 hemisphere only.  if nlat is odd, storage is in the arrays
C*PL*ERROR* Comment line too long
c                 vlap(i,j),wlap(i,j) for i=1,...,(nlat+1)/2 and j=1,...,nlon.
c                 if nlat is even, storage is in the arrays vlap(i,j),
c                 wlap(i,j) for i=1,...,nlat/2 and j=1,...,nlon.  the
C*PL*ERROR* Comment line too long
c                 vorticity of (v,w) is zero so the coefficients cr,ci are
c                 zero and are not used. the vorticity of (vlap,wlap) is
c                 also zero.
c
C*PL*ERROR* Comment line too long
c            = 8  w is symmetric and v is antisymmetric about the equator.
C*PL*ERROR* Comment line too long
c                 consequently wlap is symmetric and vlap is antisymmetric.
c                 (vlap,wlap) is computed and stored on the northern
C*PL*ERROR* Comment line too long
c                 hemisphere only.  if nlat is odd, storage is in the arrays
C*PL*ERROR* Comment line too long
c                 vlap(i,j),wlap(i,j) for i=1,...,(nlat+1)/2 and j=1,...,nlon.
c                 if nlat is even, storage is in the arrays vlap(i,j),
c                 wlap(i,j) for i=1,...,nlat/2 and j=1,...,nlon.  the
c                 divergence of (v,w) is zero so the coefficients br,bi
C*PL*ERROR* Comment line too long
c                 are zero and are not used. the divergence of (vlap,wlap)
c                 is also zero.
c
c
C*PL*ERROR* Comment line too long
c     nt     nt is the number of vector fields (v,w).  some computational
c            efficiency is obtained for multiple fields.  in the program
c            that calls vlapes, the arrays vlap,wlap,br,bi,cr and ci
C*PL*ERROR* Comment line too long
c            can be three dimensional corresponding to an indexed multiple
c            vector field.  in this case multiple vector synthesis will
C*PL*ERROR* Comment line too long
c            be performed to compute the vector laplacian for each field.
C*PL*ERROR* Comment line too long
c            the third index is the synthesis index which assumes the values
C*PL*ERROR* Comment line too long
c            k=1,...,nt.  for a single synthesis set nt=1.  the description
C*PL*ERROR* Comment line too long
c            of the remaining parameters is simplified by assuming that nt=1
c            or that all arrays are two dimensional.
c
C*PL*ERROR* Comment line too long
c   idvw     the first dimension of the arrays vlap and wlap as it appears
C*PL*ERROR* Comment line too long
c            in the program that calls vlapes.  if ityp=0,1, or 2  then idvw
C*PL*ERROR* Comment line too long
c            must be at least nlat.  if ityp > 2 and nlat is even then idvw
C*PL*ERROR* Comment line too long
c            must be at least nlat/2. if ityp > 2 and nlat is odd then idvw
c            must be at least (nlat+1)/2.
c
C*PL*ERROR* Comment line too long
c   jdvw     the second dimension of the arrays vlap and wlap as it appears
C*PL*ERROR* Comment line too long
c            in the program that calls vlapes. jdvw must be at least nlon.
c
c
c   br,bi    two or three dimensional arrays (see input parameter nt)
c   cr,ci    that contain vector spherical harmonic coefficients
c            of the vector field (v,w) as computed by subroutine vhaes.
c            br,bi,cr and ci must be computed by vhaes prior to calling
c            vlapes.  if ityp=1,4, or 7 then cr,ci are not used and can
c            be dummy arguments.  if ityp=2,5, or 8 then br,bi are not
c            used and can be dummy arguments.
c
c    mdbc    the first dimension of the arrays br,bi,cr and ci as it
c            appears in the program that calls vlapes.  mdbc must be
c            at least min0(nlat,nlon/2) if nlon is even or at least
c            min0(nlat,(nlon+1)/2) if nlon is odd.
c
c    ndbc    the second dimension of the arrays br,bi,cr and ci as it
c            appears in the program that calls vlapes. ndbc must be at
c            least nlat.
c
c    wvhses  an array which must be initialized by subroutine vhsesi.
c            once initialized, vhses
c            can be used repeatedly by vlapes as long as nlat and nlon
c            remain unchanged.  wvhses must not be altered between calls
c            of vlapes.
c
c    lvhses  the dimension of the array wvhses as it appears in the
c            program that calls vlapes.  let
c
c               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd.
c
c            then lvhses must be greater than or equal
c
c               (l1*l2*(nlat+nlat-l1+1))/2+nlon+15
c
c     work   a work array that does not have to be saved.
c
c     lwork  the dimension of the array work as it appears in the
c            program that calls vlapes. define
c
c               l2 = nlat/2                    if nlat is even or
c               l2 = (nlat+1)/2                if nlat is odd
c               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            if ityp .le. 2 then
c
c               (2*nt+1)*nlat*nlon + nlat*(4*nt*l1+1)
c
c            or if ityp .gt. 2 then
c
c               (2*nt+1)*l2*nlon + nlat*(4*nt*l1+1)
c
c            will suffice as a length for lwork.
c
c     **************************************************************
c
c     output parameters
c
c
C*PL*ERROR* Comment line too long
c    vlap,   two or three dimensional arrays (see input parameter nt) that
C*PL*ERROR* Comment line too long
c    wlap    contain the vector laplacian of the field (v,w).  wlap(i,j) is
C*PL*ERROR* Comment line too long
c            the east longitude component and vlap(i,j) is the colatitudinal
c            component of the vector laplacian.  the definition of the
c            vector laplacian follows:
c
C*PL*ERROR* Comment line too long
c            let cost and sint be the cosine and sine at colatitude theta.
C*PL*ERROR* Comment line too long
c            let d( )/dlambda  and d( )/dtheta be the first order partial
C*PL*ERROR* Comment line too long
c            derivatives in longitude and colatitude.  let del2 be the scalar
c            laplacian operator
c
c                 del2(s) = [d(sint*d(s)/dtheta)/dtheta +
c                             2            2
c                            d (s)/dlambda /sint]/sint
c
c            then the vector laplacian opeator
c
c                 dvel2(v,w) = (vlap,wlap)
c
c            is defined by
c
c                 vlap = del2(v) - (2*cost*dw/dlambda + v)/sint**2
c
c                 wlap = del2(w) + (2*cost*dv/dlambda - w)/sint**2
c
C*PL*ERROR* Comment line too long
c  ierror    a parameter which flags errors in input parameters as follows:
c
c            = 0  no errors detected
c
c            = 1  error in the specification of nlat
c
c            = 2  error in the specification of nlon
c
c            = 3  error in the specification of ityp
c
c            = 4  error in the specification of nt
c
c            = 5  error in the specification of idvw
c
c            = 6  error in the specification of jdvw
c
c            = 7  error in the specification of mdbc
c
c            = 8  error in the specification of ndbc
c
c            = 9  error in the specification of lvhses
c
c            = 10 error in the specification of lwork
c
c
c **********************************************************************
c
c     end of documentation for vlapes
c
c **********************************************************************
c
      SUBROUTINE DVLAPES(NLAT,NLON,ITYP,NT,VLAP,WLAP,IDVW,JDVW,BR,BI,CR,
     +                  CI,MDBC,NDBC,WVHSES,LVHSES,WORK,LWORK,IERROR)
      DOUBLE PRECISION VLAP
      DOUBLE PRECISION WLAP
      DOUBLE PRECISION BR
      DOUBLE PRECISION BI
      DOUBLE PRECISION CR
      DOUBLE PRECISION CI
      DOUBLE PRECISION WVHSES
      DOUBLE PRECISION WORK
      DIMENSION VLAP(IDVW,JDVW,NT),WLAP(IDVW,JDVW,NT)
      DIMENSION BR(MDBC,NDBC,NT),BI(MDBC,NDBC,NT)
      DIMENSION CR(MDBC,NDBC,NT),CI(MDBC,NDBC,NT)
      DIMENSION WVHSES(LVHSES),WORK(LWORK)

      IERROR = 1
      IF (NLAT.LT.3) RETURN
      IERROR = 2
      IF (NLON.LT.1) RETURN
      IERROR = 3
      IF (ITYP.LT.0 .OR. ITYP.GT.8) RETURN
      IERROR = 4
      IF (NT.LT.0) RETURN
      IERROR = 5
      IMID = (NLAT+1)/2
      IF ((ITYP.LE.2.AND.IDVW.LT.NLAT) .OR.
     +    (ITYP.GT.2.AND.IDVW.LT.IMID)) RETURN
      IERROR = 6
      IF (JDVW.LT.NLON) RETURN
      IERROR = 7
      MMAX = MIN0(NLAT, (NLON+1)/2)
      IF (MDBC.LT.MMAX) RETURN
      IERROR = 8
      IF (NDBC.LT.NLAT) RETURN
      IERROR = 9
      IDZ = (MMAX* (NLAT+NLAT-MMAX+1))/2
      LZIMN = IDZ*IMID
      LSAVMIN = LZIMN + LZIMN + NLON + 15
      IF (LVHSES.LT.LSAVMIN) RETURN
c
c     verify unsaved work space length
c
      MN = MMAX*NLAT*NT
      L2 = (NLAT+1)/2
      L1 = MIN0(NLAT,NLON/2+1)
      IF (ITYP.LE.2) THEN
          LWKMIN = (2*NT+1)*NLAT*NLON + NLAT* (4*NT*L1+1)
      ELSE
          LWKMIN = (2*NT+1)*L2*NLON + NLAT* (4*NT*L1+1)
      END IF
      IF (LWORK.LT.LWKMIN) RETURN
      IERROR = 0
c
c     set work space pointers for vector laplacian coefficients
c
      IF (ITYP.EQ.0 .OR. ITYP.EQ.3 .OR. ITYP.EQ.6) THEN
          IBR = 1
          IBI = IBR + MN
          ICR = IBI + MN
          ICI = ICR + MN
      ELSE IF (ITYP.EQ.1 .OR. ITYP.EQ.4 .OR. ITYP.EQ.7) THEN
          IBR = 1
          IBI = IBR + MN
          ICR = IBI + MN
          ICI = ICR
      ELSE
          IBR = 1
          IBI = 1
          ICR = IBI + MN
          ICI = ICR + MN
      END IF
      IFN = ICI + MN
      IWK = IFN + NLAT
      LIWK = LWORK - 4*MN - NLAT
      CALL DVLAPES1(NLAT,NLON,ITYP,NT,VLAP,WLAP,IDVW,JDVW,WORK(IBR),
     +             WORK(IBI),WORK(ICR),WORK(ICI),MMAX,WORK(IFN),MDBC,
     +             NDBC,BR,BI,CR,CI,WVHSES,LVHSES,WORK(IWK),LIWK,IERROR)
      RETURN
      END

      SUBROUTINE DVLAPES1(NLAT,NLON,ITYP,NT,VLAP,WLAP,IDVW,JDVW,BRLAP,
     +                   BILAP,CRLAP,CILAP,MMAX,FNN,MDB,NDB,BR,BI,CR,CI,
     +                   WSAVE,LSAVE,WK,LWK,IERROR)
      DOUBLE PRECISION VLAP
      DOUBLE PRECISION WLAP
      DOUBLE PRECISION BRLAP
      DOUBLE PRECISION BILAP
      DOUBLE PRECISION CRLAP
      DOUBLE PRECISION CILAP
      DOUBLE PRECISION FNN
      DOUBLE PRECISION BR
      DOUBLE PRECISION BI
      DOUBLE PRECISION CR
      DOUBLE PRECISION CI
      DOUBLE PRECISION WSAVE
      DOUBLE PRECISION WK
      DOUBLE PRECISION FN
      DIMENSION VLAP(IDVW,JDVW,NT),WLAP(IDVW,JDVW,NT)
      DIMENSION FNN(NLAT),BRLAP(MMAX,NLAT,NT),BILAP(MMAX,NLAT,NT)
      DIMENSION CRLAP(MMAX,NLAT,NT),CILAP(MMAX,NLAT,NT)
      DIMENSION BR(MDB,NDB,NT),BI(MDB,NDB,NT)
      DIMENSION CR(MDB,NDB,NT),CI(MDB,NDB,NT)
      DIMENSION WSAVE(LSAVE),WK(LWK)
c
c     preset coefficient multiplyers
c
      DO 1 N = 2,NLAT
          FN = DBLE(N-1)
          FNN(N) = -FN* (FN+1.D0)
    1 CONTINUE
c
c     set laplacian coefficients from br,bi,cr,ci
c
      IF (ITYP.EQ.0 .OR. ITYP.EQ.3 .OR. ITYP.EQ.6) THEN
c
c     all coefficients needed
c
          DO 2 K = 1,NT
              DO 3 N = 1,NLAT
                  DO 4 M = 1,MMAX
                      BRLAP(M,N,K) = 0.0D0
                      BILAP(M,N,K) = 0.0D0
                      CRLAP(M,N,K) = 0.0D0
                      CILAP(M,N,K) = 0.0D0
    4             CONTINUE
    3         CONTINUE
              DO 5 N = 2,NLAT
                  BRLAP(1,N,K) = FNN(N)*BR(1,N,K)
                  BILAP(1,N,K) = FNN(N)*BI(1,N,K)
                  CRLAP(1,N,K) = FNN(N)*CR(1,N,K)
                  CILAP(1,N,K) = FNN(N)*CI(1,N,K)
    5         CONTINUE
              DO 6 M = 2,MMAX
                  DO 7 N = M,NLAT
                      BRLAP(M,N,K) = FNN(N)*BR(M,N,K)
                      BILAP(M,N,K) = FNN(N)*BI(M,N,K)
                      CRLAP(M,N,K) = FNN(N)*CR(M,N,K)
                      CILAP(M,N,K) = FNN(N)*CI(M,N,K)
    7             CONTINUE
    6         CONTINUE
    2     CONTINUE
      ELSE IF (ITYP.EQ.1 .OR. ITYP.EQ.4 .OR. ITYP.EQ.7) THEN
c
c     vorticity is zero so cr,ci=0 not used
c
          DO 12 K = 1,NT
              DO 13 N = 1,NLAT
                  DO 14 M = 1,MMAX
                      BRLAP(M,N,K) = 0.0D0
                      BILAP(M,N,K) = 0.0D0
   14             CONTINUE
   13         CONTINUE
              DO 15 N = 2,NLAT
                  BRLAP(1,N,K) = FNN(N)*BR(1,N,K)
                  BILAP(1,N,K) = FNN(N)*BI(1,N,K)
   15         CONTINUE
              DO 16 M = 2,MMAX
                  DO 17 N = M,NLAT
                      BRLAP(M,N,K) = FNN(N)*BR(M,N,K)
                      BILAP(M,N,K) = FNN(N)*BI(M,N,K)
   17             CONTINUE
   16         CONTINUE
   12     CONTINUE
      ELSE
c
c     divergence is zero so br,bi=0 not used
c
          DO 22 K = 1,NT
              DO 23 N = 1,NLAT
                  DO 24 M = 1,MMAX
                      CRLAP(M,N,K) = 0.0D0
                      CILAP(M,N,K) = 0.0D0
   24             CONTINUE
   23         CONTINUE
              DO 25 N = 2,NLAT
                  CRLAP(1,N,K) = FNN(N)*CR(1,N,K)
                  CILAP(1,N,K) = FNN(N)*CI(1,N,K)
   25         CONTINUE
              DO 26 M = 2,MMAX
                  DO 27 N = M,NLAT
                      CRLAP(M,N,K) = FNN(N)*CR(M,N,K)
                      CILAP(M,N,K) = FNN(N)*CI(M,N,K)
   27             CONTINUE
   26         CONTINUE
   22     CONTINUE
      END IF
c
c     sythesize coefs into vector field (vlap,wlap)
c
      CALL DVHSES(NLAT,NLON,ITYP,NT,VLAP,WLAP,IDVW,JDVW,BRLAP,BILAP,
     +           CRLAP,CILAP,MMAX,NLAT,WSAVE,LSAVE,WK,LWK,IERROR)
      RETURN
      END

      PROGRAM FGKLNWTH
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C INVOKE DEMO DRIVER
C
      CALL LINEEX (IWKID)
C
C Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      STOP
      END
C
      SUBROUTINE LINEEX (IWKID)
C
C PURPOSE                To provide a simple demonstration of 
C                        how to change line width.
C
C USAGE                  CALL LINEEX (IWKID) 
C
C ARGUMENTS
C
C ON INPUT               IWKID
C                          Workstation id
C
C LANGUAGE               FORTRAN
C
C PORTABILITY            FORTRAN 77
C
C NOTE                   The call to GOPWK will have to be modified
C                        when using a non-NCAR GKS package.  The third
C                        argument must be the workstation type for WISS.
C
C

C  Data for the graphical objects.
C
      DATA    TWOPI/6.283185/
      DATA    X0P, Y0P, RP, NPTP/ 0.500, 0.5, 0.40 ,  16/
C
C Declare the constant for converting from degrees to radians.
C
      DATA DTR / .017453292519943 /
C
C Establish the viewport and window.
C
      CALL SET(.01,.99,0.01,.99,0.,1.,0.,1.,1)
C
C Turn buffering off
C
      CALL SETUSV('PB',2)
C
C Set up a color table
C
C
C White background
C
      CALL GSCR (IWKID,0,1.,1.,1.)
C
C Black foreground
C
      CALL GSCR (IWKID,1,0.,0.,0.)
C
C Red
C
      CALL GSCR (IWKID,2,1.,0.,0.)
C
C Green
C
      CALL GSCR (IWKID,3,0.,1.,0.)
C
C Blue
C
      CALL GSCR (IWKID,4,0.,0.,1.)
C
C Create a polygonal fan 
C
      DTHETA = TWOPI/NPTP
      DO 10 I=1,16
         ANG = DTHETA*REAL(I) + .19625
         XC = RP*COS(ANG)
         YC = RP*SIN(ANG)
C
C Set the line color
C 
         CALL GSPLCI (1)
C
C Set line width 
C 
         CALL GSLWSC(REAL(I)) 
C
C Draw a line
C
         CALL LINED(X0P,Y0P,X0P+XC,Y0P+YC)
 10   CONTINUE
      
      CALL SET(0.,1.,0.,1.,0.,1.,0.,1.,1)
C
C Set the line color to black
C
      CALL GSPLCI (1)
C
C Create a background perimeter 
C
      CALL FRSTPT( 0.0, 0.0)
      CALL VECTOR( 1.0, 0.0)
      CALL VECTOR( 1.0, 1.0)
      CALL VECTOR( 0.0, 1.0)
      CALL VECTOR( 0.0, 0.0)
C
C Label the plot
C
      CALL PLCHLQ(0.5,0.91,'Changing Line Width',25.,0.,0.)
C
C Advance the frame
C
      CALL FRAME
C
      END

C
C $Id: pcgeti.f,v 1.12 2008-07-27 00:17:19 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE PCGETI (WHCH,IVAL)
C
      CHARACTER*(*) WHCH
C
C The subroutine PCGETI may be used to get PLCHHQ parameters which have
C values of type INTEGER.
C
C Check for an uncleared prior error.
C
      IF (ICFELL('PCGETI - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C Just convert it into a call to the routine PCGETR.
C
      CALL PCGETR (WHCH,RVAL)
      IF (ICFELL('PCGETI',2).NE.0) RETURN
      IVAL=INT(RVAL)
C
C Done.
C
      RETURN
C
      END

C
C	$Id: sfgtkw.f,v 1.4 2008-07-27 12:23:42 haley Exp $
C                                                                      
C			     Copyright (C)  1997
C	     University Corporation for Atmospheric Research
C			     All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE SFGTWK (WHICH, IOS, STATUS)
C
C  Scan the input line for a keyword.
C
C  OUTPUT
C    WHICH  -  Flag indicating which keyword was found.  WHICH is
C              returned as zero if there was no keyword found.
C    IOS    -  The I/O status, this value has meaning only if an 
C              error condition obtains (i.e. only if STATUS .GT. 0).
C    STATUS -  Status indicator, see subroutine SFPRCF for details.
C
C  COMMON variable IPTR --
C              Points to the next position in the line when a
C              keyword has been found, otherwise IPTR is unchanged.
C
      include 'fnterr.h'
      include 'fnttab.h'
      include 'fntcom.h'
C
      INTEGER IOS, STATUS, WHICH(WHSIZE)
C
      CHARACTER*1 BLANK
      INTEGER ROW, II, IPOS, IEND, TPTR, LEVEL, ROWNUM, TBIDX, DIM1
     1       ,DIM2, CHSTRT, RPTR, LEV
      LOGICAL SFFNDC
C
      DATA BLANK/' '/
C
C  Initialize as a failure.
C
      WHICH(1) = 0
C
C  Skip over any blanks.
C
      CALL SFSKBK(IOS, STATUS)
      IF (STATUS .NE. ALLOK) RETURN
C
C  Set a temporary line pointer.
C
      TPTR = IPTR
C
C  Initialize the level counter (level 0 is major class; level 1
C  is subclass of major class.)
C
      LEVEL = 0
C
C   Start search at index 1.
C
      ROWNUM = 1
C
C   Continue search .
C
 10   CONTINUE
      TBIDX = PART3(ROWNUM)
      CHSTRT = PART4(TBIDX)
      DIM1 = PART5((TBIDX*2)-1)
      DIM2 = PART5(TBIDX*2)
      LEVEL = LEVEL + 1
C
C  Loop through all possible entries in the current table.
C
      DO 100 ROW = 1,DIM1
        IEND = DIM2 * ROW + CHSTRT
        IPOS = DIM2 * (ROW-1) + CHSTRT
C
C  Loop from current position in the line searching for a match.
C
        DO 50 II = TPTR, LSIZE
C
C  Continue as long as the characters match a keyword.
C
          IF (LINE(II:II) .NE. PART1(IPOS)) GO TO 100
C
C  Increment the table position pointer.
C
          IPOS = IPOS + 1
C
C  If at end of table entry, then a match has been made.
C
          IF (IPOS.GE.IEND .OR. PART1(IPOS).EQ.BLANK) THEN
C
C  Set the first PTHBTS of WHICH to integer flag for major class; 
C  find subclass.
C
             LEV = (LEVEL-1)*PTHBTS
             CALL SBYTES(WHICH,ROW,LEV,PTHBTS,0,1)
             TPTR = II
             GO TO 1000
           END IF
  50    CONTINUE
C
C  Fall through, there is no match, check next row.
C
 100  CONTINUE
C
C  No match, increment pointer and return.
C
      WHICH(1) = 0
      IPTR = IPTR + 1
      RETURN
C
C  Either a major class was matched on pass 1 (LEV = 0) in which
C  case search for a subclass; or a subclass was found on pass 2
C  (LEV = 1), so terminate.
C
 1000 CONTINUE
C
C  ROWNUM will equal zero on a second pass (the trailing zeros in
C  the PART2 common block serve as pass 2 termination flags).
C
      ROWNUM = PART2(ROWNUM+ROW-1)
      IF (ROWNUM .EQ. 0) THEN
C
C  End of search, check that keyword terminates with a blank.
C
        RPTR = IPTR
        IPTR = TPTR + 1
        IF ( SFFNDC(KEYTER) ) THEN
          RETURN
        ELSE
C
C  Fail, reset pointer to start and clear WHICH.
C
          IPTR = RPTR
          WHICH(1) = 0
          RETURN
        END IF
      END IF
C
C  Check for a seperator.
C
      RPTR = IPTR
      IPTR = TPTR + 1
      IF (SFFNDC(KEYSEP)) THEN
C
C  All OK, so continue.
C
        TPTR = IPTR
        GO TO 10
      ELSE
C
C  Failure.
C
        WHICH(1) = 0
        IPTR = RPTR
        RETURN
      END IF
C
      END

c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by UCAR                 .
c  .                                                             .
c  .       University Corporation for Atmospheric Research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                         SPHEREPACK                          .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c
c
c ... file vtsgs.f
c
c     this file includes documentation and code for
c     subroutines vtsgs and vtsgsi
c
c ... files which must be loaded with vtsgs.f
c
c     sphcom.f, hrfft.f, vhags.f, vhsgs.f,gaqd.f
c
c
c     subroutine vtsgs(nlat,nlon,ityp,nt,vt,wt,idvw,jdvw,br,bi,cr,ci,
c    +                 mdab,ndab,wvts,lwvts,work,lwork,ierror)
c
c     given the vector harmonic analysis br,bi,cr, and ci (computed
c     by subroutine vhags) of some vector function (v,w), this
c     subroutine computes the vector function (vt,wt) which is
c     the derivative of (v,w) with respect to colatitude theta. vtsgs
c     is similar to vhsgs except the vector harmonics are replaced by
c     their derivative with respect to colatitude with the result that
c     (vt,wt) is computed instead of (v,w). vt(i,j) is the derivative
c     of the colatitudinal component v(i,j) at the gaussian colatitude
c     point theta(i) and longitude phi(j) = (j-1)*2*pi/nlon. the
c     spectral representation of (vt,wt) is given below at output
c     parameters vt,wt.
c
c     input parameters
c
c     nlat   the number of gaussian colatitudinal grid points theta(i)
c            such that 0 < theta(1) <...< theta(nlat) < pi. they are
c            computed by subroutine gaqd which is called by this
c            subroutine. if nlat is odd the equator is
c            theta((nlat+1)/2). if nlat is even the equator lies
c            half way between theta(nlat/2) and theta(nlat/2+1). nlat
c            must be at least 3. note: if (v,w) is symmetric about
c            the equator (see parameter ityp below) the number of
c            colatitudinal grid points is nlat/2 if nlat is even or
c            (nlat+1)/2 if nlat is odd.
c
c     nlon   the number of distinct londitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater
c            than zero. the axisymmetric case corresponds to nlon=1.
c            the efficiency of the computation is improved when nlon
c            is a product of small prime numbers.
c
c     ityp   = 0  no symmetries exist about the equator. the synthesis
c                 is performed on the entire sphere. i.e. the arrays
c                 vt(i,j),wt(i,j) are computed for i=1,...,nlat and
c                 j=1,...,nlon.
c
c            = 1  no symmetries exist about the equator however the
c                 the coefficients cr and ci are zero which implies
c                 that the curl of (v,w) is zero. that is,
c                 (d/dtheta (sin(theta) w) - dv/dphi)/sin(theta) = 0.
c                 the calculations are performed on the entire sphere.
c                 i.e. the arrays vt(i,j),wt(i,j) are computed for
c                 i=1,...,nlat and j=1,...,nlon.
c
c            = 2  no symmetries exist about the equator however the
c                 the coefficients br and bi are zero which implies
c                 that the divergence of (v,w) is zero. that is,
c                 (d/dtheta (sin(theta) v) + dw/dphi)/sin(theta) = 0.
c                 the calculations are performed on the entire sphere.
c                 i.e. the arrays vt(i,j),wt(i,j) are computed for
c                 i=1,...,nlat and j=1,...,nlon.
c
c            = 3  vt is odd and wt is even about the equator. the
c                 synthesis is performed on the northern hemisphere
c                 only.  i.e., if nlat is odd the arrays vt(i,j)
c                 and wt(i,j) are computed for i=1,...,(nlat+1)/2
c                 and j=1,...,nlon. if nlat is even the arrays
c                 are computed for i=1,...,nlat/2 and j=1,...,nlon.
c
c            = 4  vt is odd and wt is even about the equator and the
c                 coefficients cr and ci are zero. the synthesis is
c                 performed on the northern hemisphere only. i.e. if
c                 nlat is odd the arrays vt(i,j),wt(i,j) are computed
c                 for i=1,...,(nlat+1)/2 and j=1,...,nlon. if nlat is
c                 even the arrays vt(i,j),wt(i,j) are computed for
c                 i=1,...,nlat/2 and j=1,...,nlon.
c
c            = 5  vt is odd and wt is even about the equator and the
c                 coefficients br and bi are zero. the synthesis is
c                 performed on the northern hemisphere only. i.e. if
c                 nlat is odd the arrays vt(i,j),wt(i,j) are computed
c                 for i=1,...,(nlat+1)/2 and j=1,...,nlon. if nlat is
c                 even the arrays vt(i,j),wt(i,j) are computed for
c                 i=1,...,nlat/2 and j=1,...,nlon.
c
c            = 6  vt is even and wt is odd about the equator. the
c                 synthesis is performed on the northern hemisphere
c                 only.  i.e., if nlat is odd the arrays vt(i,j),wt(i,j)
c                 are computed for i=1,...,(nlat+1)/2 and j=1,...,nlon.
C*PL*ERROR* Comment line too long
c                 if nlat is even the arrays vt(i,j),wt(i,j) are computed
c                 for i=1,...,nlat/2 and j=1,...,nlon.
c
c            = 7  vt is even and wt is odd about the equator and the
c                 coefficients cr and ci are zero. the synthesis is
c                 performed on the northern hemisphere only. i.e. if
c                 nlat is odd the arrays vt(i,j),wt(i,j) are computed
c                 for i=1,...,(nlat+1)/2 and j=1,...,nlon. if nlat is
c                 even the arrays vt(i,j),wt(i,j) are computed for
c                 i=1,...,nlat/2 and j=1,...,nlon.
c
c            = 8  vt is even and wt is odd about the equator and the
c                 coefficients br and bi are zero. the synthesis is
c                 performed on the northern hemisphere only. i.e. if
c                 nlat is odd the arrays vt(i,j),wt(i,j) are computed
c                 for i=1,...,(nlat+1)/2 and j=1,...,nlon. if nlat is
c                 even the arrays vt(i,j),wt(i,j) are computed for
c                 i=1,...,nlat/2 and j=1,...,nlon.
c
c     nt     the number of syntheses.  in the program that calls vtsgs,
c            the arrays vt,wt,br,bi,cr, and ci can be three dimensional
c            in which case multiple syntheses will be performed.
c            the third index is the synthesis index which assumes the
c            values k=1,...,nt.  for a single synthesis set nt=1. the
c            discription of the remaining parameters is simplified
c            by assuming that nt=1 or that all the arrays are two
c            dimensional.
c
c     idvw   the first dimension of the arrays vt,wt as it appears in
c            the program that calls vtsgs. if ityp .le. 2 then idvw
c            must be at least nlat.  if ityp .gt. 2 and nlat is
c            even then idvw must be at least nlat/2. if ityp .gt. 2
c            and nlat is odd then idvw must be at least (nlat+1)/2.
c
c     jdvw   the second dimension of the arrays vt,wt as it appears in
c            the program that calls vtsgs. jdvw must be at least nlon.
c
c     br,bi  two or three dimensional arrays (see input parameter nt)
c     cr,ci  that contain the vector spherical harmonic coefficients
c            of (v,w) as computed by subroutine vhags.
c
c     mdab   the first dimension of the arrays br,bi,cr, and ci as it
c            appears in the program that calls vtsgs. mdab must be at
c            least min0(nlat,nlon/2) if nlon is even or at least
c            min0(nlat,(nlon+1)/2) if nlon is odd.
c
c     ndab   the second dimension of the arrays br,bi,cr, and ci as it
c            appears in the program that calls vtsgs. ndab must be at
c            least nlat.
c
c     wvts   an array which must be initialized by subroutine vtsgsi.
c            once initialized, wvts can be used repeatedly by vtsgs
c            as long as nlon and nlat remain unchanged.  wvts must
c            not be altered between calls of vtsgs.
c
c     lwvts  the dimension of the array wvts as it appears in the
c            program that calls vtsgs. define
c
c               l1 = min0(nlat,nlon/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            then lwvts must be at least
c
c                 l1*l2*(nlat+nlat-l1+1)+nlon+15
c
c
c     work   a work array that does not have to be saved.
c
c     lwork  the dimension of the array work as it appears in the
c            program that calls vtsgs. define
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            if ityp .le. 2 then lwork must be at least
c
c                       (2*nt+1)*nlat*nlon
c
c            if ityp .gt. 2 then lwork must be at least
c
c                        (2*nt+1)*l2*nlon
c
c     **************************************************************
c
c     output parameters
c
c     vt,wt  two or three dimensional arrays (see input parameter nt)
c            in which the derivative of (v,w) with respect to
c            colatitude theta is stored. vt(i,j),wt(i,j) contain the
c            derivatives at gaussian colatitude points theta(i) for
c            i=1,...,nlat and longitude phi(j) = (j-1)*2*pi/nlon.
c            the index ranges are defined above at the input parameter
c            ityp. vt and wt are computed from the formulas for v and
c            w given in subroutine vhsgs but with vbar and wbar replaced
c           with their derivatives with respect to colatitude. these
c            derivatives are denoted by vtbar and wtbar.
c
c
c   *************************************************************
c
c   in terms of real variables this expansion takes the form
c
c             for i=1,...,nlat and  j=1,...,nlon
c
c     vt(i,j) = the sum from n=1 to n=nlat-1 of
c
c               .5*br(1,n+1)*vtbar(0,n,theta(i))
c
c     plus the sum from m=1 to m=mmax-1 of the sum from n=m to
c     n=nlat-1 of the real part of
c
c       (br(m+1,n+1)*vtbar(m,n,theta(i))
c                   -ci(m+1,n+1)*wtbar(m,n,theta(i)))*cos(m*phi(j))
c      -(bi(m+1,n+1)*vtbar(m,n,theta(i))
c                   +cr(m+1,n+1)*wtbar(m,n,theta(i)))*sin(m*phi(j))
c
c    and for i=1,...,nlat and  j=1,...,nlon
c
c     wt(i,j) = the sum from n=1 to n=nlat-1 of
c
c              -.5*cr(1,n+1)*vtbar(0,n,theta(i))
c
c     plus the sum from m=1 to m=mmax-1 of the sum from n=m to
c     n=nlat-1 of the real part of
c
c      -(cr(m+1,n+1)*vtbar(m,n,theta(i))
c                   +bi(m+1,n+1)*wtbar(m,n,theta(i)))*cos(m*phi(j))
c      +(ci(m+1,n+1)*vtbar(m,n,theta(i))
c                   -br(m+1,n+1)*wtbar(m,n,theta(i)))*sin(m*phi(j))
c
c
c      br(m+1,nlat),bi(m+1,nlat),cr(m+1,nlat), and ci(m+1,nlat) are
c      assumed zero for m even.
c
c
c     ierror = 0  no errors
c            = 1  error in the specification of nlat
c            = 2  error in the specification of nlon
c            = 3  error in the specification of ityp
c            = 4  error in the specification of nt
c            = 5  error in the specification of idvw
c            = 6  error in the specification of jdvw
c            = 7  error in the specification of mdab
c            = 8  error in the specification of ndab
c            = 9  error in the specification of lwvts
c            = 10 error in the specification of lwork
c
c
c *******************************************************************
c
c     subroutine vtsgsi(nlat,nlon,wvts,lwvts,work,lwork,dwork,ldwork,
c    +                  ierror)
c
c     subroutine vtsgsi initializes the array wvts which can then be
c     used repeatedly by subroutine vtsgs until nlat or nlon is changed.
c
c     input parameters
c
c     nlat   the number of gaussian colatitudinal grid points theta(i)
c            such that 0 < theta(1) <...< theta(nlat) < pi. they are
c            computed by subroutine gaqd which is called by this
c            subroutine. if nlat is odd the equator is
c            theta((nlat+1)/2). if nlat is even the equator lies
c            half way between theta(nlat/2) and theta(nlat/2+1). nlat
c            must be at least 3. note: if (v,w) is symmetric about
c            the equator (see parameter ityp below) the number of
c            colatitudinal grid points is nlat/2 if nlat is even or
c            (nlat+1)/2 if nlat is odd.
c
c     nlon   the number of distinct londitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater
c            than zero. the axisymmetric case corresponds to nlon=1.
c            the efficiency of the computation is improved when nlon
c            is a product of small prime numbers.
c
c     lwvts  the dimension of the array wvts as it appears in the
c            program that calls vtsgs. define
c
c               l1 = min0(nlat,nlon/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            then lwvts must be at least
c
c                  l1*l2*(nlat+nlat-l1+1)+nlon+15
c
c
c     work   a work array that does not have to be saved.
c
c     lwork  the dimension of the array work as it appears in the
c            program that calls vtsgs. lwork must be at least
c
c            3*(max0(l1-2,0)*(nlat+nlat-l1-1))/2+(5*l2+2)*nlat
c
C*PL*ERROR* Comment line too long
c     dwork  a double precision work array that does not have to be saved
c
c     ldwork the length of dwork.  ldwork must be at least
c            3*nlat+2
c
c     **************************************************************
c
c     output parameters
c
c     wvts   an array which is initialized for use by subroutine vtsgs.
c            once initialized, wvts can be used repeatedly by vtsgs
c            as long as nlat or nlon remain unchanged.  wvts must not
c            be altered between calls of vtsgs.
c
c
c     ierror = 0  no errors
c            = 1  error in the specification of nlat
c            = 2  error in the specification of nlon
c            = 3  error in the specification of lwvts
c            = 4  error in the specification of lwork
c            = 5  error in the specification of ldwork
c
      SUBROUTINE DVTSGS(NLAT,NLON,ITYP,NT,VT,WT,IDVW,JDVW,BR,BI,CR,CI,
     +                 MDAB,NDAB,WVTS,LWVTS,WORK,LWORK,IERROR)
      DOUBLE PRECISION VT
      DOUBLE PRECISION WT
      DOUBLE PRECISION BR
      DOUBLE PRECISION BI
      DOUBLE PRECISION CR
      DOUBLE PRECISION CI
      DOUBLE PRECISION WVTS
      DOUBLE PRECISION WORK
c
      DIMENSION VT(IDVW,JDVW,1),WT(IDVW,JDVW,1),BR(MDAB,NDAB,1),
     +          BI(MDAB,NDAB,1),CR(MDAB,NDAB,1),CI(MDAB,NDAB,1),WORK(1),
     +          WVTS(1)

      IERROR = 1
      IF (NLAT.LT.3) RETURN
      IERROR = 2
      IF (NLON.LT.1) RETURN
      IERROR = 3
      IF (ITYP.LT.0 .OR. ITYP.GT.8) RETURN
      IERROR = 4
      IF (NT.LT.0) RETURN
      IERROR = 5
      IMID = (NLAT+1)/2
      IF ((ITYP.LE.2.AND.IDVW.LT.NLAT) .OR.
     +    (ITYP.GT.2.AND.IDVW.LT.IMID)) RETURN
      IERROR = 6
      IF (JDVW.LT.NLON) RETURN
      IERROR = 7
      MMAX = MIN0(NLAT, (NLON+1)/2)
      IF (MDAB.LT.MMAX) RETURN
      IERROR = 8
      IF (NDAB.LT.NLAT) RETURN
      IERROR = 9
      IDZ = (MMAX* (NLAT+NLAT-MMAX+1))/2
      LZIMN = IDZ*IMID
      IF (LWVTS.LT.LZIMN+LZIMN+NLON+15) RETURN
      IERROR = 10
      IDV = NLAT
      IF (ITYP.GT.2) IDV = IMID
      LNL = NT*IDV*NLON
      IF (LWORK.LT.LNL+LNL+IDV*NLON) RETURN
      IERROR = 0
      IST = 0
      IF (ITYP.LE.2) IST = IMID
      IW1 = IST + 1
      IW2 = LNL + 1
      IW3 = IW2 + IST
      IW4 = IW2 + LNL
      JW1 = LZIMN + 1
      JW2 = JW1 + LZIMN
      CALL DVTSGS1(NLAT,NLON,ITYP,NT,IMID,IDVW,JDVW,VT,WT,MDAB,NDAB,BR,
     +            BI,CR,CI,IDV,WORK,WORK(IW1),WORK(IW2),WORK(IW3),
     +            WORK(IW4),IDZ,WVTS,WVTS(JW1),WVTS(JW2))
      RETURN
      END
      SUBROUTINE DVTSGS1(NLAT,NLON,ITYP,NT,IMID,IDVW,JDVW,VT,WT,MDAB,
     +                  NDAB,BR,BI,CR,CI,IDV,VTE,VTO,WTE,WTO,WORK,IDZ,
     +                  VB,WB,WRFFT)
      DOUBLE PRECISION VT
      DOUBLE PRECISION WT
      DOUBLE PRECISION BR
      DOUBLE PRECISION BI
      DOUBLE PRECISION CR
      DOUBLE PRECISION CI
      DOUBLE PRECISION VTE
      DOUBLE PRECISION VTO
      DOUBLE PRECISION WTE
      DOUBLE PRECISION WTO
      DOUBLE PRECISION WORK
      DOUBLE PRECISION VB
      DOUBLE PRECISION WB
      DOUBLE PRECISION WRFFT
      DIMENSION VT(IDVW,JDVW,1),WT(IDVW,JDVW,1),BR(MDAB,NDAB,1),
     +          BI(MDAB,NDAB,1),CR(MDAB,NDAB,1),CI(MDAB,NDAB,1),
     +          VTE(IDV,NLON,1),VTO(IDV,NLON,1),WTE(IDV,NLON,1),
     +          WTO(IDV,NLON,1),WORK(1),WRFFT(1),VB(IMID,1),WB(IMID,1)

      NLP1 = NLAT + 1
      MLAT = MOD(NLAT,2)
      MLON = MOD(NLON,2)
      MMAX = MIN0(NLAT, (NLON+1)/2)
      IMM1 = IMID
      IF (MLAT.NE.0) IMM1 = IMID - 1
      DO 10 K = 1,NT
          DO 10 J = 1,NLON
              DO 10 I = 1,IDV
                  VTE(I,J,K) = 0.D0
                  WTE(I,J,K) = 0.D0
   10 CONTINUE
      NDO1 = NLAT
      NDO2 = NLAT
      IF (MLAT.NE.0) NDO1 = NLAT - 1
      IF (MLAT.EQ.0) NDO2 = NLAT - 1
   18 ITYPP = ITYP + 1
      GO TO (1,100,200,300,400,500,600,700,800) ITYPP
c
c     case ityp=0   no symmetries
c
c     case m = 0
c
    1 DO 15 K = 1,NT
          DO 15 NP1 = 2,NDO2,2
              DO 15 I = 1,IMM1
                  VTO(I,1,K) = VTO(I,1,K) + BR(1,NP1,K)*VB(I,NP1)
                  WTO(I,1,K) = WTO(I,1,K) - CR(1,NP1,K)*VB(I,NP1)
   15 CONTINUE
      DO 16 K = 1,NT
          DO 16 NP1 = 3,NDO1,2
              DO 16 I = 1,IMID
                  VTE(I,1,K) = VTE(I,1,K) + BR(1,NP1,K)*VB(I,NP1)
                  WTE(I,1,K) = WTE(I,1,K) - CR(1,NP1,K)*VB(I,NP1)
   16 CONTINUE
c
c     case m = 1 through nlat-1
c
      IF (MMAX.LT.2) GO TO 950
      DO 30 MP1 = 2,MMAX
          M = MP1 - 1
          MB = M* (NLAT-1) - (M* (M-1))/2
          MP2 = MP1 + 1
          IF (MP1.GT.NDO1) GO TO 26
          DO 25 K = 1,NT
              DO 24 NP1 = MP1,NDO1,2
                  MN = MB + NP1
                  DO 23 I = 1,IMM1
                      VTE(I,2*MP1-2,K) = VTE(I,2*MP1-2,K) +
     +                                   BR(MP1,NP1,K)*VB(I,MN)
                      VTO(I,2*MP1-2,K) = VTO(I,2*MP1-2,K) -
     +                                   CI(MP1,NP1,K)*WB(I,MN)
                      VTE(I,2*MP1-1,K) = VTE(I,2*MP1-1,K) +
     +                                   BI(MP1,NP1,K)*VB(I,MN)
                      VTO(I,2*MP1-1,K) = VTO(I,2*MP1-1,K) +
     +                                   CR(MP1,NP1,K)*WB(I,MN)
                      WTE(I,2*MP1-2,K) = WTE(I,2*MP1-2,K) -
     +                                   CR(MP1,NP1,K)*VB(I,MN)
                      WTO(I,2*MP1-2,K) = WTO(I,2*MP1-2,K) -
     +                                   BI(MP1,NP1,K)*WB(I,MN)
                      WTE(I,2*MP1-1,K) = WTE(I,2*MP1-1,K) -
     +                                   CI(MP1,NP1,K)*VB(I,MN)
                      WTO(I,2*MP1-1,K) = WTO(I,2*MP1-1,K) +
     +                                   BR(MP1,NP1,K)*WB(I,MN)
   23             CONTINUE
                  IF (MLAT.EQ.0) GO TO 24
                  VTE(IMID,2*MP1-2,K) = VTE(IMID,2*MP1-2,K) +
     +                                  BR(MP1,NP1,K)*VB(IMID,MN)
                  VTE(IMID,2*MP1-1,K) = VTE(IMID,2*MP1-1,K) +
     +                                  BI(MP1,NP1,K)*VB(IMID,MN)
                  WTE(IMID,2*MP1-2,K) = WTE(IMID,2*MP1-2,K) -
     +                                  CR(MP1,NP1,K)*VB(IMID,MN)
                  WTE(IMID,2*MP1-1,K) = WTE(IMID,2*MP1-1,K) -
     +                                  CI(MP1,NP1,K)*VB(IMID,MN)
   24         CONTINUE
   25     CONTINUE
   26     IF (MP2.GT.NDO2) GO TO 30
          DO 29 K = 1,NT
              DO 28 NP1 = MP2,NDO2,2
                  MN = MB + NP1
                  DO 27 I = 1,IMM1
                      VTO(I,2*MP1-2,K) = VTO(I,2*MP1-2,K) +
     +                                   BR(MP1,NP1,K)*VB(I,MN)
                      VTE(I,2*MP1-2,K) = VTE(I,2*MP1-2,K) -
     +                                   CI(MP1,NP1,K)*WB(I,MN)
                      VTO(I,2*MP1-1,K) = VTO(I,2*MP1-1,K) +
     +                                   BI(MP1,NP1,K)*VB(I,MN)
                      VTE(I,2*MP1-1,K) = VTE(I,2*MP1-1,K) +
     +                                   CR(MP1,NP1,K)*WB(I,MN)
                      WTO(I,2*MP1-2,K) = WTO(I,2*MP1-2,K) -
     +                                   CR(MP1,NP1,K)*VB(I,MN)
                      WTE(I,2*MP1-2,K) = WTE(I,2*MP1-2,K) -
     +                                   BI(MP1,NP1,K)*WB(I,MN)
                      WTO(I,2*MP1-1,K) = WTO(I,2*MP1-1,K) -
     +                                   CI(MP1,NP1,K)*VB(I,MN)
                      WTE(I,2*MP1-1,K) = WTE(I,2*MP1-1,K) +
     +                                   BR(MP1,NP1,K)*WB(I,MN)
   27             CONTINUE
                  IF (MLAT.EQ.0) GO TO 28
                  VTE(IMID,2*MP1-2,K) = VTE(IMID,2*MP1-2,K) -
     +                                  CI(MP1,NP1,K)*WB(IMID,MN)
                  VTE(IMID,2*MP1-1,K) = VTE(IMID,2*MP1-1,K) +
     +                                  CR(MP1,NP1,K)*WB(IMID,MN)
                  WTE(IMID,2*MP1-2,K) = WTE(IMID,2*MP1-2,K) -
     +                                  BI(MP1,NP1,K)*WB(IMID,MN)
                  WTE(IMID,2*MP1-1,K) = WTE(IMID,2*MP1-1,K) +
     +                                  BR(MP1,NP1,K)*WB(IMID,MN)
   28         CONTINUE
   29     CONTINUE
   30 CONTINUE
      GO TO 950
c
c     case ityp=1   no symmetries,  cr and ci equal zero
c
c     case m = 0
c
  100 DO 115 K = 1,NT
          DO 115 NP1 = 2,NDO2,2
              DO 115 I = 1,IMM1
                  VTO(I,1,K) = VTO(I,1,K) + BR(1,NP1,K)*VB(I,NP1)
  115 CONTINUE
      DO 116 K = 1,NT
          DO 116 NP1 = 3,NDO1,2
              DO 116 I = 1,IMID
                  VTE(I,1,K) = VTE(I,1,K) + BR(1,NP1,K)*VB(I,NP1)
  116 CONTINUE
c
c     case m = 1 through nlat-1
c
      IF (MMAX.LT.2) GO TO 950
      DO 130 MP1 = 2,MMAX
          M = MP1 - 1
          MB = M* (NLAT-1) - (M* (M-1))/2
          MP2 = MP1 + 1
          IF (MP1.GT.NDO1) GO TO 126
          DO 125 K = 1,NT
              DO 124 NP1 = MP1,NDO1,2
                  MN = MB + NP1
                  DO 123 I = 1,IMM1
                      VTE(I,2*MP1-2,K) = VTE(I,2*MP1-2,K) +
     +                                   BR(MP1,NP1,K)*VB(I,MN)
                      VTE(I,2*MP1-1,K) = VTE(I,2*MP1-1,K) +
     +                                   BI(MP1,NP1,K)*VB(I,MN)
                      WTO(I,2*MP1-2,K) = WTO(I,2*MP1-2,K) -
     +                                   BI(MP1,NP1,K)*WB(I,MN)
                      WTO(I,2*MP1-1,K) = WTO(I,2*MP1-1,K) +
     +                                   BR(MP1,NP1,K)*WB(I,MN)
  123             CONTINUE
                  IF (MLAT.EQ.0) GO TO 124
                  VTE(IMID,2*MP1-2,K) = VTE(IMID,2*MP1-2,K) +
     +                                  BR(MP1,NP1,K)*VB(IMID,MN)
                  VTE(IMID,2*MP1-1,K) = VTE(IMID,2*MP1-1,K) +
     +                                  BI(MP1,NP1,K)*VB(IMID,MN)
  124         CONTINUE
  125     CONTINUE
  126     IF (MP2.GT.NDO2) GO TO 130
          DO 129 K = 1,NT
              DO 128 NP1 = MP2,NDO2,2
                  MN = MB + NP1
                  DO 127 I = 1,IMM1
                      VTO(I,2*MP1-2,K) = VTO(I,2*MP1-2,K) +
     +                                   BR(MP1,NP1,K)*VB(I,MN)
                      VTO(I,2*MP1-1,K) = VTO(I,2*MP1-1,K) +
     +                                   BI(MP1,NP1,K)*VB(I,MN)
                      WTE(I,2*MP1-2,K) = WTE(I,2*MP1-2,K) -
     +                                   BI(MP1,NP1,K)*WB(I,MN)
                      WTE(I,2*MP1-1,K) = WTE(I,2*MP1-1,K) +
     +                                   BR(MP1,NP1,K)*WB(I,MN)
  127             CONTINUE
                  IF (MLAT.EQ.0) GO TO 128
                  WTE(IMID,2*MP1-2,K) = WTE(IMID,2*MP1-2,K) -
     +                                  BI(MP1,NP1,K)*WB(IMID,MN)
                  WTE(IMID,2*MP1-1,K) = WTE(IMID,2*MP1-1,K) +
     +                                  BR(MP1,NP1,K)*WB(IMID,MN)
  128         CONTINUE
  129     CONTINUE
  130 CONTINUE
      GO TO 950
c
c     case ityp=2   no symmetries,  br and bi are equal to zero
c
c     case m = 0
c
  200 DO 215 K = 1,NT
          DO 215 NP1 = 2,NDO2,2
              DO 215 I = 1,IMM1
                  WTO(I,1,K) = WTO(I,1,K) - CR(1,NP1,K)*VB(I,NP1)
  215 CONTINUE
      DO 216 K = 1,NT
          DO 216 NP1 = 3,NDO1,2
              DO 216 I = 1,IMID
                  WTE(I,1,K) = WTE(I,1,K) - CR(1,NP1,K)*VB(I,NP1)
  216 CONTINUE
c
c     case m = 1 through nlat-1
c
      IF (MMAX.LT.2) GO TO 950
      DO 230 MP1 = 2,MMAX
          M = MP1 - 1
          MB = M* (NLAT-1) - (M* (M-1))/2
          MP2 = MP1 + 1
          IF (MP1.GT.NDO1) GO TO 226
          DO 225 K = 1,NT
              DO 224 NP1 = MP1,NDO1,2
                  MN = MB + NP1
                  DO 223 I = 1,IMM1
                      VTO(I,2*MP1-2,K) = VTO(I,2*MP1-2,K) -
     +                                   CI(MP1,NP1,K)*WB(I,MN)
                      VTO(I,2*MP1-1,K) = VTO(I,2*MP1-1,K) +
     +                                   CR(MP1,NP1,K)*WB(I,MN)
                      WTE(I,2*MP1-2,K) = WTE(I,2*MP1-2,K) -
     +                                   CR(MP1,NP1,K)*VB(I,MN)
                      WTE(I,2*MP1-1,K) = WTE(I,2*MP1-1,K) -
     +                                   CI(MP1,NP1,K)*VB(I,MN)
  223             CONTINUE
                  IF (MLAT.EQ.0) GO TO 224
                  WTE(IMID,2*MP1-2,K) = WTE(IMID,2*MP1-2,K) -
     +                                  CR(MP1,NP1,K)*VB(IMID,MN)
                  WTE(IMID,2*MP1-1,K) = WTE(IMID,2*MP1-1,K) -
     +                                  CI(MP1,NP1,K)*VB(IMID,MN)
  224         CONTINUE
  225     CONTINUE
  226     IF (MP2.GT.NDO2) GO TO 230
          DO 229 K = 1,NT
              DO 228 NP1 = MP2,NDO2,2
                  MN = MB + NP1
                  DO 227 I = 1,IMM1
                      VTE(I,2*MP1-2,K) = VTE(I,2*MP1-2,K) -
     +                                   CI(MP1,NP1,K)*WB(I,MN)
                      VTE(I,2*MP1-1,K) = VTE(I,2*MP1-1,K) +
     +                                   CR(MP1,NP1,K)*WB(I,MN)
                      WTO(I,2*MP1-2,K) = WTO(I,2*MP1-2,K) -
     +                                   CR(MP1,NP1,K)*VB(I,MN)
                      WTO(I,2*MP1-1,K) = WTO(I,2*MP1-1,K) -
     +                                   CI(MP1,NP1,K)*VB(I,MN)
  227             CONTINUE
                  IF (MLAT.EQ.0) GO TO 228
                  VTE(IMID,2*MP1-2,K) = VTE(IMID,2*MP1-2,K) -
     +                                  CI(MP1,NP1,K)*WB(IMID,MN)
                  VTE(IMID,2*MP1-1,K) = VTE(IMID,2*MP1-1,K) +
     +                                  CR(MP1,NP1,K)*WB(IMID,MN)
  228         CONTINUE
  229     CONTINUE
  230 CONTINUE
      GO TO 950
c
c     case ityp=3   v odd,  w even
c
c     case m = 0
c
  300 DO 315 K = 1,NT
          DO 315 NP1 = 2,NDO2,2
              DO 315 I = 1,IMM1
                  VTO(I,1,K) = VTO(I,1,K) + BR(1,NP1,K)*VB(I,NP1)
  315 CONTINUE
      DO 316 K = 1,NT
          DO 316 NP1 = 3,NDO1,2
              DO 316 I = 1,IMID
                  WTE(I,1,K) = WTE(I,1,K) - CR(1,NP1,K)*VB(I,NP1)
  316 CONTINUE
c
c     case m = 1 through nlat-1
c
      IF (MMAX.LT.2) GO TO 950
      DO 330 MP1 = 2,MMAX
          M = MP1 - 1
          MB = M* (NLAT-1) - (M* (M-1))/2
          MP2 = MP1 + 1
          IF (MP1.GT.NDO1) GO TO 326
          DO 325 K = 1,NT
              DO 324 NP1 = MP1,NDO1,2
                  MN = MB + NP1
                  DO 323 I = 1,IMM1
                      VTO(I,2*MP1-2,K) = VTO(I,2*MP1-2,K) -
     +                                   CI(MP1,NP1,K)*WB(I,MN)
                      VTO(I,2*MP1-1,K) = VTO(I,2*MP1-1,K) +
     +                                   CR(MP1,NP1,K)*WB(I,MN)
                      WTE(I,2*MP1-2,K) = WTE(I,2*MP1-2,K) -
     +                                   CR(MP1,NP1,K)*VB(I,MN)
                      WTE(I,2*MP1-1,K) = WTE(I,2*MP1-1,K) -
     +                                   CI(MP1,NP1,K)*VB(I,MN)
  323             CONTINUE
                  IF (MLAT.EQ.0) GO TO 324
                  WTE(IMID,2*MP1-2,K) = WTE(IMID,2*MP1-2,K) -
     +                                  CR(MP1,NP1,K)*VB(IMID,MN)
                  WTE(IMID,2*MP1-1,K) = WTE(IMID,2*MP1-1,K) -
     +                                  CI(MP1,NP1,K)*VB(IMID,MN)
  324         CONTINUE
  325     CONTINUE
  326     IF (MP2.GT.NDO2) GO TO 330
          DO 329 K = 1,NT
              DO 328 NP1 = MP2,NDO2,2
                  MN = MB + NP1
                  DO 327 I = 1,IMM1
                      VTO(I,2*MP1-2,K) = VTO(I,2*MP1-2,K) +
     +                                   BR(MP1,NP1,K)*VB(I,MN)
                      VTO(I,2*MP1-1,K) = VTO(I,2*MP1-1,K) +
     +                                   BI(MP1,NP1,K)*VB(I,MN)
                      WTE(I,2*MP1-2,K) = WTE(I,2*MP1-2,K) -
     +                                   BI(MP1,NP1,K)*WB(I,MN)
                      WTE(I,2*MP1-1,K) = WTE(I,2*MP1-1,K) +
     +                                   BR(MP1,NP1,K)*WB(I,MN)
  327             CONTINUE
                  IF (MLAT.EQ.0) GO TO 328
                  WTE(IMID,2*MP1-2,K) = WTE(IMID,2*MP1-2,K) -
     +                                  BI(MP1,NP1,K)*WB(IMID,MN)
                  WTE(IMID,2*MP1-1,K) = WTE(IMID,2*MP1-1,K) +
     +                                  BR(MP1,NP1,K)*WB(IMID,MN)
  328         CONTINUE
  329     CONTINUE
  330 CONTINUE
      GO TO 950
c
c     case ityp=4   v odd,  w even, and both cr and ci equal zero
c
c     case m = 0
c
  400 DO 415 K = 1,NT
          DO 415 NP1 = 2,NDO2,2
              DO 415 I = 1,IMM1
                  VTO(I,1,K) = VTO(I,1,K) + BR(1,NP1,K)*VB(I,NP1)
  415 CONTINUE
c
c     case m = 1 through nlat-1
c
      IF (MMAX.LT.2) GO TO 950
      DO 430 MP1 = 2,MMAX
          M = MP1 - 1
          MB = M* (NLAT-1) - (M* (M-1))/2
          MP2 = MP1 + 1
          IF (MP2.GT.NDO2) GO TO 430
          DO 429 K = 1,NT
              DO 428 NP1 = MP2,NDO2,2
                  MN = MB + NP1
                  DO 427 I = 1,IMM1
                      VTO(I,2*MP1-2,K) = VTO(I,2*MP1-2,K) +
     +                                   BR(MP1,NP1,K)*VB(I,MN)
                      VTO(I,2*MP1-1,K) = VTO(I,2*MP1-1,K) +
     +                                   BI(MP1,NP1,K)*VB(I,MN)
                      WTE(I,2*MP1-2,K) = WTE(I,2*MP1-2,K) -
     +                                   BI(MP1,NP1,K)*WB(I,MN)
                      WTE(I,2*MP1-1,K) = WTE(I,2*MP1-1,K) +
     +                                   BR(MP1,NP1,K)*WB(I,MN)
  427             CONTINUE
                  IF (MLAT.EQ.0) GO TO 428
                  WTE(IMID,2*MP1-2,K) = WTE(IMID,2*MP1-2,K) -
     +                                  BI(MP1,NP1,K)*WB(IMID,MN)
                  WTE(IMID,2*MP1-1,K) = WTE(IMID,2*MP1-1,K) +
     +                                  BR(MP1,NP1,K)*WB(IMID,MN)
  428         CONTINUE
  429     CONTINUE
  430 CONTINUE
      GO TO 950
c
c     case ityp=5   v odd,  w even,     br and bi equal zero
c
c     case m = 0
c
  500 DO 516 K = 1,NT
          DO 516 NP1 = 3,NDO1,2
              DO 516 I = 1,IMID
                  WTE(I,1,K) = WTE(I,1,K) - CR(1,NP1,K)*VB(I,NP1)
  516 CONTINUE
c
c     case m = 1 through nlat-1
c
      IF (MMAX.LT.2) GO TO 950
      DO 530 MP1 = 2,MMAX
          M = MP1 - 1
          MB = M* (NLAT-1) - (M* (M-1))/2
          MP2 = MP1 + 1
          IF (MP1.GT.NDO1) GO TO 530
          DO 525 K = 1,NT
              DO 524 NP1 = MP1,NDO1,2
                  MN = MB + NP1
                  DO 523 I = 1,IMM1
                      VTO(I,2*MP1-2,K) = VTO(I,2*MP1-2,K) -
     +                                   CI(MP1,NP1,K)*WB(I,MN)
                      VTO(I,2*MP1-1,K) = VTO(I,2*MP1-1,K) +
     +                                   CR(MP1,NP1,K)*WB(I,MN)
                      WTE(I,2*MP1-2,K) = WTE(I,2*MP1-2,K) -
     +                                   CR(MP1,NP1,K)*VB(I,MN)
                      WTE(I,2*MP1-1,K) = WTE(I,2*MP1-1,K) -
     +                                   CI(MP1,NP1,K)*VB(I,MN)
  523             CONTINUE
                  IF (MLAT.EQ.0) GO TO 524
                  WTE(IMID,2*MP1-2,K) = WTE(IMID,2*MP1-2,K) -
     +                                  CR(MP1,NP1,K)*VB(IMID,MN)
                  WTE(IMID,2*MP1-1,K) = WTE(IMID,2*MP1-1,K) -
     +                                  CI(MP1,NP1,K)*VB(IMID,MN)
  524         CONTINUE
  525     CONTINUE
  530 CONTINUE
      GO TO 950
c
c     case ityp=6   v even  ,  w odd
c
c     case m = 0
c
  600 DO 615 K = 1,NT
          DO 615 NP1 = 2,NDO2,2
              DO 615 I = 1,IMM1
                  WTO(I,1,K) = WTO(I,1,K) - CR(1,NP1,K)*VB(I,NP1)
  615 CONTINUE
      DO 616 K = 1,NT
          DO 616 NP1 = 3,NDO1,2
              DO 616 I = 1,IMID
                  VTE(I,1,K) = VTE(I,1,K) + BR(1,NP1,K)*VB(I,NP1)
  616 CONTINUE
c
c     case m = 1 through nlat-1
c
      IF (MMAX.LT.2) GO TO 950
      DO 630 MP1 = 2,MMAX
          M = MP1 - 1
          MB = M* (NLAT-1) - (M* (M-1))/2
          MP2 = MP1 + 1
          IF (MP1.GT.NDO1) GO TO 626
          DO 625 K = 1,NT
              DO 624 NP1 = MP1,NDO1,2
                  MN = MB + NP1
                  DO 623 I = 1,IMM1
                      VTE(I,2*MP1-2,K) = VTE(I,2*MP1-2,K) +
     +                                   BR(MP1,NP1,K)*VB(I,MN)
                      VTE(I,2*MP1-1,K) = VTE(I,2*MP1-1,K) +
     +                                   BI(MP1,NP1,K)*VB(I,MN)
                      WTO(I,2*MP1-2,K) = WTO(I,2*MP1-2,K) -
     +                                   BI(MP1,NP1,K)*WB(I,MN)
                      WTO(I,2*MP1-1,K) = WTO(I,2*MP1-1,K) +
     +                                   BR(MP1,NP1,K)*WB(I,MN)
  623             CONTINUE
                  IF (MLAT.EQ.0) GO TO 624
                  VTE(IMID,2*MP1-2,K) = VTE(IMID,2*MP1-2,K) +
     +                                  BR(MP1,NP1,K)*VB(IMID,MN)
                  VTE(IMID,2*MP1-1,K) = VTE(IMID,2*MP1-1,K) +
     +                                  BI(MP1,NP1,K)*VB(IMID,MN)
  624         CONTINUE
  625     CONTINUE
  626     IF (MP2.GT.NDO2) GO TO 630
          DO 629 K = 1,NT
              DO 628 NP1 = MP2,NDO2,2
                  MN = MB + NP1
                  DO 627 I = 1,IMM1
                      VTE(I,2*MP1-2,K) = VTE(I,2*MP1-2,K) -
     +                                   CI(MP1,NP1,K)*WB(I,MN)
                      VTE(I,2*MP1-1,K) = VTE(I,2*MP1-1,K) +
     +                                   CR(MP1,NP1,K)*WB(I,MN)
                      WTO(I,2*MP1-2,K) = WTO(I,2*MP1-2,K) -
     +                                   CR(MP1,NP1,K)*VB(I,MN)
                      WTO(I,2*MP1-1,K) = WTO(I,2*MP1-1,K) -
     +                                   CI(MP1,NP1,K)*VB(I,MN)
  627             CONTINUE
                  IF (MLAT.EQ.0) GO TO 628
                  VTE(IMID,2*MP1-2,K) = VTE(IMID,2*MP1-2,K) -
     +                                  CI(MP1,NP1,K)*WB(IMID,MN)
                  VTE(IMID,2*MP1-1,K) = VTE(IMID,2*MP1-1,K) +
     +                                  CR(MP1,NP1,K)*WB(IMID,MN)
  628         CONTINUE
  629     CONTINUE
  630 CONTINUE
      GO TO 950
c
c     case ityp=7   v even, w odd   cr and ci equal zero
c
c     case m = 0
c
  700 DO 716 K = 1,NT
          DO 716 NP1 = 3,NDO1,2
              DO 716 I = 1,IMID
                  VTE(I,1,K) = VTE(I,1,K) + BR(1,NP1,K)*VB(I,NP1)
  716 CONTINUE
c
c     case m = 1 through nlat-1
c
      IF (MMAX.LT.2) GO TO 950
      DO 730 MP1 = 2,MMAX
          M = MP1 - 1
          MB = M* (NLAT-1) - (M* (M-1))/2
          MP2 = MP1 + 1
          IF (MP1.GT.NDO1) GO TO 730
          DO 725 K = 1,NT
              DO 724 NP1 = MP1,NDO1,2
                  MN = MB + NP1
                  DO 723 I = 1,IMM1
                      VTE(I,2*MP1-2,K) = VTE(I,2*MP1-2,K) +
     +                                   BR(MP1,NP1,K)*VB(I,MN)
                      VTE(I,2*MP1-1,K) = VTE(I,2*MP1-1,K) +
     +                                   BI(MP1,NP1,K)*VB(I,MN)
                      WTO(I,2*MP1-2,K) = WTO(I,2*MP1-2,K) -
     +                                   BI(MP1,NP1,K)*WB(I,MN)
                      WTO(I,2*MP1-1,K) = WTO(I,2*MP1-1,K) +
     +                                   BR(MP1,NP1,K)*WB(I,MN)
  723             CONTINUE
                  IF (MLAT.EQ.0) GO TO 724
                  VTE(IMID,2*MP1-2,K) = VTE(IMID,2*MP1-2,K) +
     +                                  BR(MP1,NP1,K)*VB(IMID,MN)
                  VTE(IMID,2*MP1-1,K) = VTE(IMID,2*MP1-1,K) +
     +                                  BI(MP1,NP1,K)*VB(IMID,MN)
  724         CONTINUE
  725     CONTINUE
  730 CONTINUE
      GO TO 950
c
c     case ityp=8   v even,  w odd,   br and bi equal zero
c
c     case m = 0
c
  800 DO 815 K = 1,NT
          DO 815 NP1 = 2,NDO2,2
              DO 815 I = 1,IMM1
                  WTO(I,1,K) = WTO(I,1,K) - CR(1,NP1,K)*VB(I,NP1)
  815 CONTINUE
c
c     case m = 1 through nlat-1
c
      IF (MMAX.LT.2) GO TO 950
      DO 830 MP1 = 2,MMAX
          M = MP1 - 1
          MB = M* (NLAT-1) - (M* (M-1))/2
          MP2 = MP1 + 1
          IF (MP2.GT.NDO2) GO TO 830
          DO 829 K = 1,NT
              DO 828 NP1 = MP2,NDO2,2
                  MN = MB + NP1
                  DO 827 I = 1,IMM1
                      VTE(I,2*MP1-2,K) = VTE(I,2*MP1-2,K) -
     +                                   CI(MP1,NP1,K)*WB(I,MN)
                      VTE(I,2*MP1-1,K) = VTE(I,2*MP1-1,K) +
     +                                   CR(MP1,NP1,K)*WB(I,MN)
                      WTO(I,2*MP1-2,K) = WTO(I,2*MP1-2,K) -
     +                                   CR(MP1,NP1,K)*VB(I,MN)
                      WTO(I,2*MP1-1,K) = WTO(I,2*MP1-1,K) -
     +                                   CI(MP1,NP1,K)*VB(I,MN)
  827             CONTINUE
                  IF (MLAT.EQ.0) GO TO 828
                  VTE(IMID,2*MP1-2,K) = VTE(IMID,2*MP1-2,K) -
     +                                  CI(MP1,NP1,K)*WB(IMID,MN)
                  VTE(IMID,2*MP1-1,K) = VTE(IMID,2*MP1-1,K) +
     +                                  CR(MP1,NP1,K)*WB(IMID,MN)
  828         CONTINUE
  829     CONTINUE
  830 CONTINUE
  950 DO 14 K = 1,NT
          CALL DHRFFTB(IDV,NLON,VTE(1,1,K),IDV,WRFFT,WORK)
          CALL DHRFFTB(IDV,NLON,WTE(1,1,K),IDV,WRFFT,WORK)
   14 CONTINUE
      IF (ITYP.GT.2) GO TO 12
      DO 60 K = 1,NT
          DO 60 J = 1,NLON
              DO 60 I = 1,IMM1
                  VT(I,J,K) = .5D0* (VTE(I,J,K)+VTO(I,J,K))
                  WT(I,J,K) = .5D0* (WTE(I,J,K)+WTO(I,J,K))
                  VT(NLP1-I,J,K) = .5D0* (VTE(I,J,K)-VTO(I,J,K))
                  WT(NLP1-I,J,K) = .5D0* (WTE(I,J,K)-WTO(I,J,K))
   60 CONTINUE
      GO TO 13
   12 DO 11 K = 1,NT
          DO 11 J = 1,NLON
              DO 11 I = 1,IMM1
                  VT(I,J,K) = .5D0*VTE(I,J,K)
                  WT(I,J,K) = .5D0*WTE(I,J,K)
   11 CONTINUE
   13 IF (MLAT.EQ.0) RETURN
      DO 65 K = 1,NT
          DO 65 J = 1,NLON
              VT(IMID,J,K) = .5D0*VTE(IMID,J,K)
              WT(IMID,J,K) = .5D0*WTE(IMID,J,K)
   65 CONTINUE
      RETURN
      END
      SUBROUTINE DVTSGSI(NLAT,NLON,WVTS,LWVTS,WORK,LWORK,DWORK,LDWORK,
     +                  IERROR)
      DOUBLE PRECISION WVTS
      DOUBLE PRECISION WORK
c
c     define imid = (nlat+1)/2 and mmax = min0(nlat,(nlon+1)/2)
c     the length of wvts is imid*mmax*(nlat+nlat-mmax+1)+nlon+15
c     and the length of work is labc+5*nlat*imid+2*nlat where
c     labc = 3*(max0(mmax-2,0)*(nlat+nlat-mmax-1))/2
c
      DIMENSION WVTS(LWVTS),WORK(LWORK)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION DWORK(LDWORK)

      IERROR = 1
      IF (NLAT.LT.3) RETURN
      IERROR = 2
      IF (NLON.LT.1) RETURN
      IERROR = 3
      MMAX = MIN0(NLAT,NLON/2+1)
      IMID = (NLAT+1)/2
      LZIMN = (IMID*MMAX* (NLAT+NLAT-MMAX+1))/2
      IF (LWVTS.LT.LZIMN+LZIMN+NLON+15) RETURN
      IERROR = 4
      LABC = 3* (MAX0(MMAX-2,0)* (NLAT+NLAT-MMAX-1))/2
      LVIN = 3*NLAT*IMID
      LWVBIN = 2*NLAT*IMID + LABC
      LTHETA = NLAT + NLAT
      IF (LWORK.LT.LVIN+LWVBIN+LTHETA) RETURN
      IERROR = 5
      IF (LDWORK.LT.3*NLAT+2) RETURN
      IERROR = 0
      IW1 = LVIN + 1
      IW2 = IW1 + LWVBIN
      JW1 = NLAT + 1
      JW2 = JW1 + NLAT
      CALL DVETG1(NLAT,NLON,IMID,WVTS,WVTS(LZIMN+1),WORK,WORK(IW1),
     +            DWORK,DWORK(JW1),DWORK(JW2),IERROR)
      IF (IERROR.NE.0) RETURN
      CALL DHRFFTI(NLON,WVTS(2*LZIMN+1))
      RETURN
      END
      SUBROUTINE DVETG1(NLAT,NLON,IMID,VB,WB,VIN,WVBIN,THETA,WTS,DWORK,
     +                 IERROR)
      DOUBLE PRECISION VB
      DOUBLE PRECISION WB
      DOUBLE PRECISION VIN
      DOUBLE PRECISION WVBIN
      DIMENSION VB(IMID,*),WB(IMID,*),VIN(IMID,NLAT,3),WVBIN(*)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION DWORK(*),THETA(*),WTS(*)

      MMAX = MIN0(NLAT,NLON/2+1)
      LDWORK = 1
      CALL DGAQD(NLAT,THETA,WTS,DWORK,LDWORK,IERR)
      IF (IERR.EQ.0) GO TO 10
      IERROR = 10 + IERR
      RETURN
   10 CALL DVTGINT(NLAT,NLON,THETA,WVBIN,DWORK)
      DO 33 MP1 = 1,MMAX
          M = MP1 - 1
          CALL DVBIN(0,NLAT,NLON,M,VIN,I3,WVBIN)
          DO 33 NP1 = MP1,NLAT
              MN = M* (NLAT-1) - (M* (M-1))/2 + NP1
              DO 33 I = 1,IMID
                  VB(I,MN) = VIN(I,NP1,I3)
   33 CONTINUE
      CALL DWTGINT(NLAT,NLON,THETA,WVBIN,DWORK)
      DO 34 MP1 = 1,MMAX
          M = MP1 - 1
          CALL DWBIN(0,NLAT,NLON,M,VIN,I3,WVBIN)
          DO 34 NP1 = MP1,NLAT
              MN = M* (NLAT-1) - (M* (M-1))/2 + NP1
              DO 34 I = 1,IMID
                  WB(I,MN) = VIN(I,NP1,I3)
   34 CONTINUE
      RETURN
      END

C
C	$Id: contng.f,v 1.4 2008-07-27 00:16:57 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CONTNG (NDP,XD,YD,NT,IPT,NL,IPL,IWL,IWP,WK)
C
C THIS SUBROUTINE PERFORMS TRIANGULATION.  IT DIVIDES THE X-Y
C PLANE INTO A NUMBER OF TRIANGLES ACCORDING TO GIVEN DATA
C POINTS IN THE PLANE, DETERMINES LINE SEGMENTS THAT FORM THE
C BORDER OF DATA AREA, AND DETERMINES THE TRIANGLE NUMBERS
C CORRESPONDING TO THE BORDER LINE SEGMENTS.
C AT COMPLETION, POINT NUMBERS OF THE VERTEXES OF EACH TRIANGLE
C ARE LISTED COUNTER-CLOCKWISE.  POINT NUMBERS OF THE END POINTS
C OF EACH BORDER LINE SEGMENT ARE LISTED COUNTER-CLOCKWISE,
C LISTING ORDER OF THE LINE SEGMENTS BEING COUNTER-CLOCKWISE.
C THE INPUT PARAMETERS ARE
C     NDP = NUMBER OF DATA POINTS,
C     XD  = ARRAY OF DIMENSION NDP CONTAINING THE
C           X COORDINATES OF THE DATA POINTS,
C     YD  = ARRAY OF DIMENSION NDP CONTAINING THE
C           Y COORDINATES OF THE DATA POINTS.
C THE OUTPUT PARAMETERS ARE
C     NT  = NUMBER OF TRIANGLES,
C     IPT = ARRAY OF DIMENSION 6*NDP-15, WHERE THE POINT
C           NUMBERS OF THE VERTEXES OF THE (IT)TH TRIANGLE
C           ARE TO BE STORED AS THE (3*IT-2)ND, (3*IT-1)ST,
C           AND (3*IT)TH ELEMENTS, IT=1,2,...,NT,
C     NL  = NUMBER OF BORDER LINE SEGMENTS,
C     IPL = ARRAY OF DIMENSION 6*NDP, WHERE THE POINT
C           NUMBERS OF THE END POINTS OF THE (IL)TH BORDER
C           LINE SEGMENT AND ITS RESPECTIVE TRIANGLE NUMBER
C           ARE TO BE STORED AS THE (3*IL-2)ND, (3*IL-1)ST,
C           AND (3*IL)TH ELEMENTS, IL=1,2,..., NL.
C THE OTHER PARAMETERS ARE
C     IWL = INTEGER ARRAY OF DIMENSION 18*NDP USED
C           INTERNALLY AS A WORK AREA,
C     IWP = INTEGER ARRAY OF DIMENSION NDP USED
C           INTERNALLY AS A WORK AREA,
C     WK  = ARRAY OF DIMENSION NDP USED INTERNALLY AS A
C           WORK AREA.
C DECLARATION STATEMENTS
C
      SAVE
C
      INTEGER         CONXCH
      COMMON /CONRA3/ IREC
      DIMENSION       XD(*)      ,YD(*)      ,IPT(*)     ,IPL(*)     ,
     1                IWL(*)     ,IWP(*)     ,WK(*)
      DIMENSION       ITF(2)
        CHARACTER*4  IP1C, IP2C
        CHARACTER*64  ITEMP
      DATA  RATIO/1.0E-6/, NREP/100/
C
C STATEMENT FUNCTIONS
C
      DSQF(U1,V1,U2,V2) = (U2-U1)**2+(V2-V1)**2
      SIDE(U1,V1,U2,V2,U3,V3) = (V3-V1)*(U2-U1)-(U3-U1)*(V2-V1)
C
C PRELIMINARY PROCESSING
C
      NDPM1 = NDP-1
C
C DETERMINES THE CLOSEST PAIR OF DATA POINTS AND THEIR MIDPOINT.
C
      DSQMN = DSQF(XD(1),YD(1),XD(2),YD(2))
      IPMN1 = 1
      IPMN2 = 2
      DO  140 IP1=1,NDPM1
         X1 = XD(IP1)
         Y1 = YD(IP1)
         IP1P1 = IP1+1
         DO  130 IP2=IP1P1,NDP
            DSQI = DSQF(X1,Y1,XD(IP2),YD(IP2))
            IF (DSQI .NE. 0.) GO TO  120
C
C  ERROR, IDENTICAL INPUT DATA POINTS
C
          ITEMP = ' CONTNG-IDENTICAL INPUT DATA POINTS FOUND
     1 AT      AND      '
          WRITE(IP1C,'(I4)')IP1
            WRITE(IP2C,'(I4)')IP2
            CALL SETER (ITEMP,1,1)
            ITEMP(46:49) = IP1C
            ITEMP(55:58) = IP2C
            RETURN
  120       IF (DSQI .GE. DSQMN) GO TO  130
            DSQMN = DSQI
            IPMN1 = IP1
            IPMN2 = IP2
  130    CONTINUE
  140 CONTINUE
      DSQ12 = DSQMN
      XDMP = (XD(IPMN1)+XD(IPMN2))/2.0
      YDMP = (YD(IPMN1)+YD(IPMN2))/2.0
C
C SORTS THE OTHER (NDP-2) DATA POINTS IN ASCENDING ORDER OF
C DISTANCE FROM THE MIDPOINT AND STORES THE SORTED DATA POINT
C NUMBERS IN THE IWP ARRAY.
C
      JP1 = 2
      DO  150 IP1=1,NDP
         IF (IP1.EQ.IPMN1 .OR. IP1.EQ.IPMN2) GO TO  150
         JP1 = JP1+1
         IWP(JP1) = IP1
         WK(JP1) = DSQF(XDMP,YDMP,XD(IP1),YD(IP1))
  150 CONTINUE
      DO  170 JP1=3,NDPM1
         DSQMN = WK(JP1)
         JPMN = JP1
         DO  160 JP2=JP1,NDP
            IF (WK(JP2) .GE. DSQMN) GO TO  160
            DSQMN = WK(JP2)
            JPMN = JP2
  160    CONTINUE
         ITS = IWP(JP1)
         IWP(JP1) = IWP(JPMN)
         IWP(JPMN) = ITS
         WK(JPMN) = WK(JP1)
  170 CONTINUE
C
C IF NECESSARY, MODIFIES THE ORDERING IN SUCH A WAY THAT THE
C FIRST THREE DATA POINTS ARE NOT COLLINEAR.
C
      AR = DSQ12*RATIO
      X1 = XD(IPMN1)
      Y1 = YD(IPMN1)
      DX21 = XD(IPMN2)-X1
      DY21 = YD(IPMN2)-Y1
      DO  180 JP=3,NDP
         IP = IWP(JP)
         IF (ABS((YD(IP)-Y1)*DX21-(XD(IP)-X1)*DY21) .GT. AR) GO TO  190
  180 CONTINUE
      CALL SETER (' CONTNG - ALL COLLINEAR DATA POINTS',1,1)
  190 IF (JP .EQ. 3) GO TO  210
      JPMX = JP
      JP = JPMX+1
      DO  200 JPC=4,JPMX
         JP = JP-1
         IWP(JP) = IWP(JP-1)
  200 CONTINUE
      IWP(3) = IP
C
C FORMS THE FIRST TRIANGLE.  STORES POINT NUMBERS OF THE VER-
C TEXES OF THE TRIANGLE IN THE IPT ARRAY, AND STORES POINT NUM-
C BERS OF THE BORDER LINE SEGMENTS AND THE TRIANGLE NUMBER IN
C THE IPL ARRAY.
C
  210 IP1 = IPMN1
      IP2 = IPMN2
      IP3 = IWP(3)
      IF (SIDE(XD(IP1),YD(IP1),XD(IP2),YD(IP2),XD(IP3),YD(IP3)) .GE.
     1    0.0) GO TO  220
      IP1 = IPMN2
      IP2 = IPMN1
  220 NT0 = 1
      NTT3 = 3
      IPT(1) = IP1
      IPT(2) = IP2
      IPT(3) = IP3
      NL0 = 3
      NLT3 = 9
      IPL(1) = IP1
      IPL(2) = IP2
      IPL(3) = 1
      IPL(4) = IP2
      IPL(5) = IP3
      IPL(6) = 1
      IPL(7) = IP3
      IPL(8) = IP1
      IPL(9) = 1
C
C ADDS THE REMAINING (NDP-3) DATA POINTS, ONE BY ONE.
C
      DO  400 JP1=4,NDP
         IP1 = IWP(JP1)
         X1 = XD(IP1)
         Y1 = YD(IP1)
C
C - DETERMINES THE VISIBLE BORDER LINE SEGMENTS.
C
         IP2 = IPL(1)
         JPMN = 1
         DXMN = XD(IP2)-X1
         DYMN = YD(IP2)-Y1
         DSQMN = DXMN**2+DYMN**2
         ARMN = DSQMN*RATIO
         JPMX = 1
         DXMX = DXMN
         DYMX = DYMN
         DSQMX = DSQMN
         ARMX = ARMN
         DO  240 JP2=2,NL0
            IP2 = IPL(3*JP2-2)
            DX = XD(IP2)-X1
            DY = YD(IP2)-Y1
            AR = DY*DXMN-DX*DYMN
            IF (AR .GT. ARMN) GO TO  230
            DSQI = DX**2+DY**2
            IF (AR.GE.(-ARMN) .AND. DSQI.GE.DSQMN) GO TO  230
            JPMN = JP2
            DXMN = DX
            DYMN = DY
            DSQMN = DSQI
            ARMN = DSQMN*RATIO
  230       AR = DY*DXMX-DX*DYMX
            IF (AR .LT. (-ARMX)) GO TO  240
            DSQI = DX**2+DY**2
            IF (AR.LE.ARMX .AND. DSQI.GE.DSQMX) GO TO  240
            JPMX = JP2
            DXMX = DX
            DYMX = DY
            DSQMX = DSQI
            ARMX = DSQMX*RATIO
  240    CONTINUE
         IF (JPMX .LT. JPMN) JPMX = JPMX+NL0
         NSH = JPMN-1
         IF (NSH .LE. 0) GO TO  270
C
C - SHIFTS (ROTATES) THE IPL ARRAY TO HAVE THE INVISIBLE BORDER
C - LINE SEGMENTS CONTAINED IN THE FIRST PART OF THE IPL ARRAY.
C
         NSHT3 = NSH*3
         DO  250 JP2T3=3,NSHT3,3
            JP3T3 = JP2T3+NLT3
            IPL(JP3T3-2) = IPL(JP2T3-2)
            IPL(JP3T3-1) = IPL(JP2T3-1)
            IPL(JP3T3) = IPL(JP2T3)
  250    CONTINUE
         DO  260 JP2T3=3,NLT3,3
            JP3T3 = JP2T3+NSHT3
            IPL(JP2T3-2) = IPL(JP3T3-2)
            IPL(JP2T3-1) = IPL(JP3T3-1)
            IPL(JP2T3) = IPL(JP3T3)
  260    CONTINUE
         JPMX = JPMX-NSH
C
C - ADDS TRIANGLES TO THE IPT ARRAY, UPDATES BORDER LINE
C - SEGMENTS IN THE IPL ARRAY, AND SETS FLAGS FOR THE BORDER
C - LINE SEGMENTS TO BE REEXAMINED IN THE IWL ARRAY.
C
  270    JWL = 0
         DO  310 JP2=JPMX,NL0
            JP2T3 = JP2*3
            IPL1 = IPL(JP2T3-2)
            IPL2 = IPL(JP2T3-1)
            IT = IPL(JP2T3)
C
C - - ADDS A TRIANGLE TO THE IPT ARRAY.
C
            NT0 = NT0+1
            NTT3 = NTT3+3
            IPT(NTT3-2) = IPL2
            IPT(NTT3-1) = IPL1
            IPT(NTT3) = IP1
C
C - - UPDATES BORDER LINE SEGMENTS IN THE IPL ARRAY.
C
            IF (JP2 .NE. JPMX) GO TO  280
            IPL(JP2T3-1) = IP1
            IPL(JP2T3) = NT0
  280       IF (JP2 .NE. NL0) GO TO  290
            NLN = JPMX+1
            NLNT3 = NLN*3
            IPL(NLNT3-2) = IP1
            IPL(NLNT3-1) = IPL(1)
            IPL(NLNT3) = NT0
C
C - - DETERMINES THE VERTEX THAT DOES NOT LIE ON THE BORDER
C - - LINE SEGMENTS.
C
  290       ITT3 = IT*3
            IPTI = IPT(ITT3-2)
            IF (IPTI.NE.IPL1 .AND. IPTI.NE.IPL2) GO TO  300
            IPTI = IPT(ITT3-1)
            IF (IPTI.NE.IPL1 .AND. IPTI.NE.IPL2) GO TO  300
            IPTI = IPT(ITT3)
C
C - - CHECKS IF THE EXCHANGE IS NECESSARY.
C
  300       IF (CONXCH(XD,YD,IP1,IPTI,IPL1,IPL2) .EQ. 0) GO TO  310
C
C - - MODIFIES THE IPT ARRAY WHEN NECESSARY.
C
            IPT(ITT3-2) = IPTI
            IPT(ITT3-1) = IPL1
            IPT(ITT3) = IP1
            IPT(NTT3-1) = IPTI
            IF (JP2 .EQ. JPMX) IPL(JP2T3) = IT
            IF (JP2.EQ.NL0 .AND. IPL(3).EQ.IT) IPL(3) = NT0
C
C - - SETS FLAGS IN THE IWL ARRAY.
C
            JWL = JWL+4
            IWL(JWL-3) = IPL1
            IWL(JWL-2) = IPTI
            IWL(JWL-1) = IPTI
            IWL(JWL) = IPL2
  310    CONTINUE
         NL0 = NLN
         NLT3 = NLNT3
         NLF = JWL/2
         IF (NLF .EQ. 0) GO TO  400
C
C - IMPROVES TRIANGULATION.
C
         NTT3P3 = NTT3+3
         DO  390 IREP=1,NREP
            DO  370 ILF=1,NLF
               ILFT2 = ILF*2
               IPL1 = IWL(ILFT2-1)
               IPL2 = IWL(ILFT2)
C
C - - LOCATES IN THE IPT ARRAY TWO TRIANGLES ON BOTH SIDES OF
C - - THE FLAGGED LINE SEGMENT.
C
               NTF = 0
               DO  320 ITT3R=3,NTT3,3
                  ITT3 = NTT3P3-ITT3R
                  IPT1 = IPT(ITT3-2)
                  IPT2 = IPT(ITT3-1)
                  IPT3 = IPT(ITT3)
                  IF (IPL1.NE.IPT1 .AND. IPL1.NE.IPT2 .AND.
     1                IPL1.NE.IPT3) GO TO  320
                  IF (IPL2.NE.IPT1 .AND. IPL2.NE.IPT2 .AND.
     1                IPL2.NE.IPT3) GO TO  320
                  NTF = NTF+1
                  ITF(NTF) = ITT3/3
                  IF (NTF .EQ. 2) GO TO  330
  320          CONTINUE
               IF (NTF .LT. 2) GO TO  370
C
C - - DETERMINES THE VERTEXES OF THE TRIANGLES THAT DO NOT LIE
C - - ON THE LINE SEGMENT.
C
  330          IT1T3 = ITF(1)*3
               IPTI1 = IPT(IT1T3-2)
               IF (IPTI1.NE.IPL1 .AND. IPTI1.NE.IPL2) GO TO  340
               IPTI1 = IPT(IT1T3-1)
               IF (IPTI1.NE.IPL1 .AND. IPTI1.NE.IPL2) GO TO  340
               IPTI1 = IPT(IT1T3)
  340          IT2T3 = ITF(2)*3
               IPTI2 = IPT(IT2T3-2)
               IF (IPTI2.NE.IPL1 .AND. IPTI2.NE.IPL2) GO TO  350
               IPTI2 = IPT(IT2T3-1)
               IF (IPTI2.NE.IPL1 .AND. IPTI2.NE.IPL2) GO TO  350
               IPTI2 = IPT(IT2T3)
C
C - - CHECKS IF THE EXCHANGE IS NECESSARY.
C
  350          IF (CONXCH(XD,YD,IPTI1,IPTI2,IPL1,IPL2) .EQ. 0)
     1             GO TO  370
C
C - - MODIFIES THE IPT ARRAY WHEN NECESSARY.
C
               IPT(IT1T3-2) = IPTI1
               IPT(IT1T3-1) = IPTI2
               IPT(IT1T3) = IPL1
               IPT(IT2T3-2) = IPTI2
               IPT(IT2T3-1) = IPTI1
               IPT(IT2T3) = IPL2
C
C - - SETS NEW FLAGS.
C
               JWL = JWL+8
               IWL(JWL-7) = IPL1
               IWL(JWL-6) = IPTI1
               IWL(JWL-5) = IPTI1
               IWL(JWL-4) = IPL2
               IWL(JWL-3) = IPL2
               IWL(JWL-2) = IPTI2
               IWL(JWL-1) = IPTI2
               IWL(JWL) = IPL1
               DO  360 JLT3=3,NLT3,3
                  IPLJ1 = IPL(JLT3-2)
                  IPLJ2 = IPL(JLT3-1)
                  IF ((IPLJ1.EQ.IPL1 .AND. IPLJ2.EQ.IPTI2) .OR.
     1                (IPLJ2.EQ.IPL1 .AND. IPLJ1.EQ.IPTI2))
     2                IPL(JLT3) = ITF(1)
                  IF ((IPLJ1.EQ.IPL2 .AND. IPLJ2.EQ.IPTI1) .OR.
     1                (IPLJ2.EQ.IPL2 .AND. IPLJ1.EQ.IPTI1))
     2                IPL(JLT3) = ITF(2)
  360          CONTINUE
  370       CONTINUE
            NLFC = NLF
            NLF = JWL/2
            IF (NLF .EQ. NLFC) GO TO  400
C
C - - RESETS THE IWL ARRAY FOR THE NEXT ROUND.
C
            JWL = 0
            JWL1MN = (NLFC+1)*2
            NLFT2 = NLF*2
            DO  380 JWL1=JWL1MN,NLFT2,2
               JWL = JWL+2
               IWL(JWL-1) = IWL(JWL1-1)
               IWL(JWL) = IWL(JWL1)
  380       CONTINUE
            NLF = JWL/2
  390    CONTINUE
  400 CONTINUE
C
C REARRANGE THE IPT ARRAY SO THAT THE VERTEXES OF EACH TRIANGLE
C ARE LISTED COUNTER-CLOCKWISE.
C
      DO  410 ITT3=3,NTT3,3
         IP1 = IPT(ITT3-2)
         IP2 = IPT(ITT3-1)
         IP3 = IPT(ITT3)
         IF (SIDE(XD(IP1),YD(IP1),XD(IP2),YD(IP2),XD(IP3),YD(IP3)) .GE.
     1       0.0) GO TO  410
         IPT(ITT3-2) = IP2
         IPT(ITT3-1) = IP1
  410 CONTINUE
      NT = NT0
      NL = NL0
      RETURN
      END

C
C $Id: pcsort.f,v 1.10 2008-07-27 00:17:20 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE PCSORT (LCHR,INDX,NLCH)
C
C This routine sorts the character array LCHR, which is NLCH long, into
C ascending order.  The elements in the integer array INDX are sorted
C along with LCHR, so that the relationship between them is maintained.
C A bubble sort is used.
C
      CHARACTER*1 LCHR(NLCH),CTM1,CTM2
      DIMENSION   INDX(NLCH)
C
C Initialize the first pass.
C
      IBEG=1
      IEND=NLCH
      ISTP=1
C
C At most NLCH-1 passes are needed.
C
      DO 102 NPSS=1,NLCH-1
C
        IDNE=1
        I=IBEG
C
C If adjacent elements need to be switched, do it.
C
  101   IF (ISTP*(ICHAR(LCHR(I))-ICHAR(LCHR(I+ISTP))).GT.0) THEN
          IDNE=0
          CTM1=LCHR(I)
          CTM2=LCHR(I+ISTP)
          LCHR(I)=CTM2
          LCHR(I+ISTP)=CTM1
          ITMP=INDX(I)
          INDX(I)=INDX(I+ISTP)
          INDX(I+ISTP)=ITMP
        END IF
C
C If the pass isn't done, move to the next set of adjacent elements.
C
        I=I+ISTP
        IF (I.NE.IEND) GO TO 101
C
C Pass done; if none were switched during this pass, we can quit.
C
        IF (IDNE.NE.0) RETURN
C
C Set up the next pass in the other direction.
C
        ISTP=-ISTP
        ITMP=IBEG
        IBEG=IEND+ISTP
        IEND=ITMP
C
  102 CONTINUE
C
C Done.
C
      RETURN
C
      END

C
C $Id: isfill.f,v 1.5 2008-07-27 00:17:15 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE ISFILL
C
C This routine fills the interior of the marked contour line in the
C screen model ISCR, OR's that screen model into the screen model ISCA,
C and then zeroes ISCR.
C
      COMMON /ISCOMN/ BIG,BIGD,DBPI,IDONE,IFILL,IFLIP,IONES,IHSS(1000),
     +                IREF,ISCA(16,256),ISCALE,ISCR(16,256),ISLBT,ISDR,
     +                LHSS,LX,NFPW,NINU,NINV,NINW,NX,NY,R0,RNX,RNY,
     +                SMALL,SVAL,TENSN,U,V,W,XMAX,XMIN,YMAX,YMIN,XVPL,
     +                XVPR,YVPB,YVPT
      SAVE   /ISCOMN/
C
      IF (IFILL.EQ.0) RETURN
C
      DO 105 IY=1,NY
        IV=0
        IZ=0
        DO 102 IW=1,LX
          IF (ISCR(IW,IY).EQ.0) THEN
            IF (IV.NE.0) ISCR(IW,IY)=IOR(ISCR(IW,IY),IONES)
          ELSE
            DO 101 IB=NFPW,1,-1
              IT=IAND(ISHIFT(ISCR(IW,IY),2*(1-IB)),3)
              IF (IT.EQ.2) THEN
                IV=3
                ISCR(IW,IY)=IOR(ISCR(IW,IY),ISHIFT(IV,2*(IB-1)))
              ELSE
                IF (IV.NE.0.AND.IT.NE.3)
     +                  ISCR(IW,IY)=IOR(ISCR(IW,IY),ISHIFT(IV,2*(IB-1)))
                IF (IT.EQ.1.AND.IV.EQ.0) IZ=1
                IF (IT.NE.0) IV=0
              END IF
  101       CONTINUE
          END IF
  102   CONTINUE
        IF (IZ.NE.0) THEN
          IV=0
          DO 104 IW=LX,1,-1
            IF (ISCR(IW,IY).EQ.0) THEN
              IF (IV.NE.0) ISCR(IW,IY)=IOR(ISCR(IW,IY),IONES)
            ELSE
              DO 103 IB=1,NFPW
                IT=IAND(ISHIFT(ISCR(IW,IY),2*(1-IB)),3)
                IF (IT.EQ.1) THEN
                  IV=3
                  ISCR(IW,IY)=IOR(ISCR(IW,IY),ISHIFT(IV,2*(IB-1)))
                ELSE
                  IF (IV.NE.0.AND.IT.NE.3)
     +                  ISCR(IW,IY)=IOR(ISCR(IW,IY),ISHIFT(IV,2*(IB-1)))
                  IF (IT.NE.0) IV=0
                END IF
  103         CONTINUE
            END IF
  104     CONTINUE
        END IF
  105 CONTINUE
C
      DO 107 IY=1,NY
        DO 106 IW=1,LX
          ISCA(IW,IY)=IOR(ISCA(IW,IY),ISCR(IW,IY))
          ISCR(IW,IY)=0
  106   CONTINUE
  107 CONTINUE
C
      RETURN
C
      END

      PROGRAM CCPEZCT
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
      
      PARAMETER (M=50, N=50)
      REAL ZREG(M,N)
C      
C Get some data
C
      CALL MKDAT (3,ZREG, M, N)
C 
C Open GKS, open and activate a workstation.
C 
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C 
C Call CPEZCT
C 
      CALL CPEZCT (ZREG, M, N)
C 
C Deactivate and close workstation, close GKS.
C 
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C      
C Quit
C
      STOP
      END
      
      SUBROUTINE MKDAT(NCTFR,ZDAT,M,N)
C 
C Create some data to contour
C 
      REAL ZDAT(M,N)
C 
C NCTFR is used to generate a random number, ZDAT is the data array
C 
      CALL GGDINI (0.,1.,NCTFR,.9)
      ZMIN= 1.E36
      ZMAX=-1.E36
      DO 10 I=1,M
         RLON=.017453292519943*(-180.+360.*REAL(I-1)/REAL(M-1))
         DO 20 J=1,N
            RLAT=.017453292519943*(-90.+180.*REAL(J-1)/REAL(N-1))
            ZDAT(I,J)=GGDPNT(RLAT,RLON)+.5*COS(4.*RLAT)
            ZMIN=MIN(ZMIN,ZDAT(I,J))
            ZMAX=MAX(ZMAX,ZDAT(I,J))
 20      CONTINUE
 10   CONTINUE
      DO 30 I=1,M
         DO 40 J=1,N
            ZDAT(I,J)=((ZDAT(I,J)-ZMIN)/(ZMAX-ZMIN))*130.-50.
 40      CONTINUE
 30   CONTINUE
      
      RETURN
      END

C
C	$Id: conran.f,v 1.5 2008-07-27 00:16:55 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CONRAN (XD,YD,ZD,NDP,WK,IWK,SCRARR)
C
C    SUBROUTINE CONRAN(XD,YD,ZD,NDP,WK,IWK,SCRARR)
C    Standard and smooth versions of CONRAN
C
C          DIMENSION OF  XD(NDP),YD(NDP),ZD(NDP),WK(13*NDP)
C             ARGUMENTS  IWK((27+NCP)*NDP),SCRARR(RESOLUTION**2)
C                        where NCP = 4 and RESOLUTION = 40 by
C                        default.
C
C              OVERVIEW  CONRAN  performs  contouring  of  irregularly
C                        distributed  data.   It is the standard and
C                        smooth members of the CONRAN family. This
C                        version  will  plot contours; smooth them using
C                        splines  under  tension (if the package DASHSMTH
C                        is loaded); plot a perimeter or grid; title the
C                        plot; print a message giving the contour intervals
C                        below the map; plot the input data on the map;
C                        and label the contour lines.
C
C               PURPOSE  CONRAN  plots  contour  lines  using  random,
C                        sparse  or  irregular data sets.  The data is
C                        triangulated and then contoured.   Contouring
C                        is  performed using interpolation of the tri-
C                        angulated data.  There are two methods of
C                        interpolation:  C1 surfaces and linear.
C
C                 USAGE  CALL CONRAN(XD,YD,ZD,NDP,WK,IWK,SCRARR)
C                        An option setting routine  can  also  be  in-
C                        voked,  see  writeup  below.   FRAME  must be
C                        called by the user.
C
C                        If different colors (or intensities) are to be
C                        used for normal intensity, low intensity or
C                        text output, then the values in common block
C                        RANINT should be changed:
C
C                        IRANMJ  Color index for normal (major) intensity
C                                lines.
C                        IRANMN  Color index for low intensity lines
C                        IRANTX  Color index for text (labels)
C
C
C             ARGUMENTS
C
C              ON INPUT  XD
C                            Array of dimension NDP containing the  X-
C                            coordinates of the data points.
C
C                        YD
C                            Array of dimension NDP containing the  Y-
C                            coordinates of the data points.
C
C                        ZD
C                            Array of  dimension  NDP  containing  the
C                            data values at the points.
C
C                        NDP
C                            Number of  data  points  (must  be  4  or
C                            greater) to be contoured.
C
C                        WK
C                            Real work array  of  dimension  at  least
C                            13*NDP
C
C                        IWK
C                            Integer work array.  When using C1 surfaces
C                            the array must be at least IWK((27+NCP)*NDP).
C                            When using linear interpolation the array
C                            must be at least IWK((27+4)*NDP).
C
C                        SCRARR
C                            Real work array  of  dimension  at  least
C                            (RESOLUTION**2)   where   RESOLUTION   is
C                            described in the SSZ option below.  RESO-
C                            LUTION is 40 by default.
C
C             ON OUTPUT  All arguments  remain  unchanged  except  the
C                        scratch arrays IWK, WK, and SCRARR which have
C                        been written into.  If making  multiple  runs
C                        on  the same triangulation IWK and WK must be
C                        saved and returned to the next invocation  of
C                        CONRAN.
C
C          ENTRY POINTS  CONRAN, CONDET, CONINT, CONCAL, CONLOC, CONTNG,
C                        CONDRW, CONCLS, CONSTP, CONBDN, CONBDNX,
C                        CONTLK, CONPDV, CONOP1, CONOP2, CONOP3, CONOP4,
C                        CONXCH, CONREO, CONCOM, CONCLD, CONPMM,
C                        CONGEN, CONLOD, CONECD, CONOUT, CONOT2,
C                        CONSLD, CONLCM, CONLIN, CONDSD, CONSSD
C
C         COMMON BLOCKS  CONRA1, CONRA2, CONRA3, CONRA4, CONRA5, CONRA6,
C                        CONR18, CONR19, CONRA9, CONR10, CONR20, CONR12,
C                        CONR13, CONR14, CONR15, CONR16, CONR17, RANINT
C                        INTPR from the DASH package
C
C                   I/O  Plots the contour map and, via  the ERPRT77
C                        package,  outputs  messages  to  the message
C                        output  unit; at  NCAR  this  unit  is  the
C                        printer.  The option values are all listed on
C                        standard ERPRT77 output unit; at NCAR this
C                        unit is the printer.
C
C             PRECISION  Single
C
C      REQUIRED LIBRARY  Standard version: DASHCHAR, which at NCAR is
C              ROUTINES  loaded by default.
C                        Smooth version: DASHSMTH which must be
C                        requested at NCAR.
C                        Both versions require CONCOM, CONTERP, GRIDAL
C                        the ERPRT77 package, and the SPPS.
C
C    REQUIRED GKS LEVEL  0A
C
C              LANGUAGE  FORTRAN77
C
C               HISTORY
C
C             ALGORITHM  The sparse data is triangulated and a virtual
C                        grid  is  laid  over  the  triangulated area.
C                        Each virtual grid point receives an  interpo-
C                        lated  value.   The  grid is scanned once for
C                        each contour level and all contours  at  that
C                        level are plotted.
C                        There are two methods of interpolation. The
C                        first is a smooth data interpolation
C                        scheme based  on  Lawson's  C1
C                        surface  interpolation  algorithm,  which has
C                        been refined  by  Hirosha  Akima.   Parts  of
C                        Akima's  algorithm  are used in this package.
C                        See the "REFERENCE" section below.
C                        The second is a linear interpolation scheme.
C                        When data is sparse it is usually better to
C                        use the C1 interpolation.  If you have dense
C                        data (over 100 points) then the linear
C                        interpolation will give the better results.
C
C           PORTABILITY  ANSI FORTRAN
C
C
C             OPERATION  CALL CONRAN (XD,YD,ZD,NDP,WK,IWK,SCRARR)
C
C                        FRAME must be called by the user.
C
C                        CONRAN has many options, each of which may
C                        be changed by calling one of the four
C                        subroutines CONOP1, CONOP2, CONOP3, or
C                        CONOP4.  The number of arguments to each
C                        CONOP routine is the same as the final
C                        suffix character in the routine's name.
C
C                        The CONOP routines are called before CONRAN
C                        is called, and values set by these calls
C                        continue to be in effect until they are
C                        changed by another call to a CONOP routine.
C
C                        All the CONOP routines have as their first
C                        argument a character string to identify the
C                        option being changed.  This is the only
C                        argument to CONOP1.  CONOP2 has an integer
C                        second argument.  CONOP3 has a real array (or
C                        constant) as its second argument and an
C                        integer (usually the dimension of the
C                        array) as its third argument.  CONOP4 has a
C                        character string as its second argument and
C                        integers for the third and fourth arguments.
C
C                        Only the first two characters on each side of
C                        the equal sign are scanned.  Therefore only 2
C                        characters  for  each  option are required on
C                        input to CONOP (i.e.  'SCA=PRI'  and  'SC=PR'
C                        are equivalent.)
C
C                        Remember, there must be at least 4 data points.
C                        This is equal to  the  default  number of
C                        data points to be used for estimation of par-
C                        tial derivatives at  each  data  point.
C                        The estimated partial derivatives  are
C                        used  for the construction of the interpolat-
C                        ing polynomial's coefficients.
C
C                        Listed below are options which can enhance
C                        your plot.  An example of an appropriate
C                        CONOP call is given for each option.  A
C                        complete list of default settings follows
C                        the last option.
C
C               OPTIONS
C
C                   CHL  This flag determines how  the  high  and  low
C                        contour values are set.  These contour values
C                        may be set by the program or by the user.  If
C                        CHL=OFF,  the program examines the user's in-
C                        put data and determines both the high and low
C                        values.  If CHL=ON, the user must specify the
C                        desired high (HI) and low (FLO) values.
C                        The default is CHL=OFF.
C
C                        If program set:   CALL CONOP3('CHL=OFF',0.,0)
C
C                        If user set:  CALL CONOP3('CHL=ON',ARRAY,2)
C                                where ARRAY(1)=HI, ARRAY(2)=FLO
C
C                        Note: The values supplied for contour  incre-
C                        ment  and contour high and low values assumes
C                        the unscaled data values.  See the SDC  flag,
C                        below.
C
C                        Example:  CALL   CONOP3('CHL=ON',ARRAY,2)
C                                  where  ARRAY(1)=5020. (the desired
C                                  high contour value) and ARRAY(2)=
C                                  2000 (the desired low contour value).
C                                  These are floating point numbers.
C
C                   CIL  This flag determines how the  contour  incre-
C                        ment  (CINC) is set.  The increment is either
C                        calculated by the program (CIL=OFF) using the
C                        range  of high and low values from the user's
C                        input data, or set by the user (CIL=ON). The
C                        default is CIL=OFF.
C
C                        If program set:   CALL CONOP3('CIL=OFF',0.,0)
C
C                        If user set:      CALL CONOP3('CIL=ON',CINC,1)
C
C                        Note: By default,  the  program  will examine
C                        the user's input data and determine the contour
C                        interval (CINC)  at some appropriate range between
C                        the level of high and low values supplied, usually
C                        generating between 15 and 20 contour levels.
C
C                        Example:          CALL CONOP3('CIL=ON',15.,1)
C                                          where  15.  represents  the
C                                          contour  increment  desired
C                                          by the user.
C
C                   CON  This flag determines how the  contour  levels
C                        are  set.   If  CON=ON, the user must specify
C                        the array of contour values and the number of
C                        contour levels.  A  maximum of 30 contour (NCL)
C                        levels is permitted.  If CON=OFF,  default
C                        values  are  used.  In this case, the program
C                        will calculate the values for the  array  and
C                        NCL using input data.  The default is OFF.
C
C                        If program set:   CALL CONOP3('CON=OFF',0.,0)
C
C                        If user set:   CALL CONOP3('CON=ON',ARRAY,NCL)
C
C                        Note: The array (ARRAY) contains the  contour
C                        levels  (floating  point only) and NCL is the
C                        number of levels.  The maximum number of con-
C                        tour levels allowed is 30.  When assigning
C                        the array of contour values, the values must
C                        be ordered from smallest to largest.
C
C                        Example:
C                         DATA RLIST(1),...,RLIST(5)/1.,2.,3.,10.,12./
C
C                                  CALL CONOP3('CON=ON',RLIST,5) where
C                                  'RLIST' contains the user specified
C                                  contour levels, and 5  is  the
C                                  number  of  user  specified contour
C                                  levels (NCL).
C
C                        Warning on contour options:
C                        It is illegal to use the CON option when
C                        either  CIL  or  CHL  are activated.  If
C                        this is done, the option call that detected
C                        the error will not be executed.
C
C                   DAS  This  flag  determines  which  contours   are
C                        represented  by  dashed lines.  The user sets
C                        the dashed line pattern.  The user may speci-
C                        fy  that  dashed  lines  be used for contours
C                        whose  value  is  less  than,  equal  to,  or
C                        greater than the dash pattern breakpoint (see
C                        the DBP option below), which is zero by
C                        default.  If DAS=OFF (the default value), all
C                        solid lines are used.
C
C                        All solid lines: CALL CONOP4('DAS=OFF',' ',0,0)
C
C                        If greater:      CALL CONOP4('DAS=GTR',PAT,0,0)
C
C                        If equal:        CALL CONOP4('DAS=EQU',PAT,0,0)
C
C                        If less:         CALL CONOP4('DAS=LSS',PAT,0,0)
C
C                        If all same:     CALL CONOP4('DAS=ALL',PAT,0,0)
C
C                        Note: Pat must be a ten character
C                        string with a dollar sign ($) for solid and a
C                        single quote (') for blank.  Recall that in
C                        FORTRAN 77, in a quoted string a single quote
C                        is represented by two single quotes ('').
C
C                        Example:
C                          CALL CONOP4('DAS=GTR','$$$$$''$$$$',0,0)
C
C                   DBP  This flag determines  how  the  dash  pattern
C                        break point (BP) is set.  If DBP=ON, BP  must
C                        be set by the  user  by  specifying  BP.   If
C                        DBP=OFF  the  program  will set BP to the
C                        default value which is zero.
C
C                        If program set:   CALL CONOP3('DBP=OFF',0.,0)
C
C                        If user set:      CALL CONOP3('DBP=ON',BP,1)
C
C                        Note: BP is a floating point number where the
C                        break  for  GTR and LSS contour dash patterns
C                        are defined.  BP is assumed to be given rela-
C                        tive to the untransformed contours.
C
C                        Example:          CALL CONOP3('DBP=ON',5.,1)
C                                          where 5. is the user speci-
C                                          fied break point.
C
C                   DEF  Reset flags to  default  values.   Activating
C                        this  option  sets  all  flags to the default
C                        value.  DEF has no 'ON' or 'OFF' states.
C
C                        To activate:   CALL CONOP1('DEF')
C
C                   EXT  Flag to set extrapolation. Normally all
C                        CONRAN versions will  only plot the boundaries
C                        of the convex hull defined by the user's data.
C                        To have the contours fill the rectangular
C                        area of the frame, set the EXT switch ON.
C                        The default is OFF.
C
C                        To turn on:    CALL CONOP1('EXT=ON')
C
C                        To turn off:   CALL CONOP1('EXT=OFF')
C
C                   FMT  Flag for the format of the plotted input data
C                        values.   If  FMT=OFF, the default values for
C                        FT, L, and IF are used.  The  default  values
C                        are:
C
C                        FT = '(G10.3)'
C                        L  = 7  characters including the parentheses
C                        IF = 10 characters printed in the output
C                             field by the format
C
C                        If FMT=ON, the user must specify  values  for
C                        FT,  L,  and  IF.   All user specified values
C                        must be given in the correct format.
C
C                        If program set:  CALL CONOP4('FMT=OFF',' ',0,0)
C
C                        If user set:  CALL CONOP4('FMT=ON',FT,L,IF)
C
C                        Note: FT is a character string containing the
C                        format.   The  format  must  be  enclosed  in
C                        parentheses.  Any  format, up to 10 characters
C                        which is  allowed  at  your installation will be
C                        accepted.  L is the number of  characters  in
C                        FT.  IF is the length of the field created by
C                        the format.
C
C                        Example:  CALL CONOP4('FMT=ON','(G30.2)',7,30)
C
C                        Warning: CONRAN will not  test  for  a  valid
C                        format.  The format is only allowed to be
C                        10 characters long.
C
C                   GRI  Flag to display the grid. GRI is OFF by default.
C
C                        To turn on:    CALL CONOP1('GRI=ON')
C
C                        To turn off:   CALL CONOP1('GRI=OFF')
C
C                        Note: If GRI is ON, the virtual grid will
C                        be superimposed over the contour plot.
C                        The X and Y tick intervals will be displayed
C                        under the map only if PER=ON.  (see PER)
C
C                   INT  Flag to determine the intensities of the con-
C                        tour  lines  and other parts of the plot.  If
C                        INT=OFF,  all intensities are set to the default
C                        values.  If INT=ALL, all intensities are set
C                        to the given value, IVAL.  If INT is set to
C                        one of the other possible options (MAJ, MIN,
C                        LAB or DAT), the intensity level for that
C                        option is set to the given value, IVAL.
C
C                        If program set:   CALL CONOP2('INT=OFF',0)
C
C                        All the same:     CALL  CONOP2('INT=ALL',IVAL)
C
C                        Major lines:      CALL CONOP2('INT=MAJ',IVAL)
C
C                        Minor lines:      CALL CONOP2('INT=MIN',IVAL)
C
C                        Title and message:
C                                          CALL  CONOP2('INT=LAB',IVAL)
C
C                        Data values:      CALL  CONOP2('INT=DAT',IVAL)
C
C                        Note: 'INT=DAT' relates to the plotted data
C                        values and the plotted maximums and minimums.
C
C                        Note: IVAL is the intensity desired.  IVAL
C                        values range from 0 to 255 or the character
C                        strings 'LO' and 'HI'.  The default is 'HI'
C                        except for INT=MIN which is set to 'LO'.
C
C                        Example:           CALL CONOP2('INT=ALL',110)
C
C                   ITP  Set the interpolation scheme.
C                        There are two schemes--C1 surfaces and linear.
C                        The C1 method takes longer but will give the
C                        best results when the data is sparse (less
C                        than 100 points).  The linear method will
C                        produce a better plot when there is a dense
C                        data set.  The default is C1 surface.
C
C                        For C1 surface   CALL CONOP1('ITP=C1')
C
C                        For linear       CALL CONOP1('ITP=LIN')
C
C                   LAB  This flag can be set to either label the con-
C                        tours (LAB=ON) or not (LAB=OFF).  The default
C                        value is LAB=ON.
C
C                        To turn on:    CALL CONOP1('LAB=ON')
C
C                        To turn off:   CALL CONOP1('LAB=OFF')
C
C                   LOT  Flag to list options on the printer.  The de-
C                        fault  value  is  set  to OFF, and no options
C                        will be displayed.
C
C                        To turn on:    CALL CONOP1('LOT=ON')
C
C                        To turn off:   CALL CONOP1('LOT=OFF')
C
C                        Note: If  users  want  to  print  the  option
C                        values, they should turn this option ON.  The
C                        option values will be sent  to  the  standard
C                        output  unit  as  defined by the support
C                        routine I1MACH.
C
C                   LSZ  This flag  determines  the  label  size.   If
C                        LSZ=OFF,  the  default ISZLSZ value will be
C                        used.  If LSZ=ON,  the  user  should  specify
C                        ISZLSZ.   The  default value is 9 plotter
C                        address units.
C
C                        If program set:   CALL CONOP2('LSZ=OFF',0)
C
C                        If user set:   CALL CONOP2('LSZ=ON',ISZLSZ)
C
C                        Note: ISZLSZ  is  the  requested  character
C                        size in plotter address units.
C
C                        Example:          CALL CONOP2('LSZ=ON',4)
C                                          where 4 is the user desired
C                                          integer plotter address
C                                          units.
C
C                   MES  Flag to plot a message. The default is ON.
C
C                        To turn on:    CALL CONOP1('MES=ON')
C
C                        To turn off:   CALL CONOP1('MES=OFF')
C
C                        Note: If MES=ON, a message is  printed   below
C                        the  plot giving contour intervals and execu-
C                        tion time in seconds.  If PER or GRI is  ON,
C                        the  message  also  contains the X and Y tick
C                        intervals.
C
C                   NCP  Flag to indicate the number of data points
C                        used for the partial derivative
C                        estimation.   If NCP=OFF, NUM is set to
C                        4, which is the default  value.   If  NCP=ON,
C                        the  user  must  specify  NUM greater than or
C                        equal to 2.
C
C                        If program set:   CALL CONOP2('NCP=OFF',0)
C
C                        If user set:      CALL CONOP2('NCP=ON',NUM)
C
C                        Note: NUM = number of data  points  used  for
C                        estimation.   Changing this value effects the
C                        contours produced and the size of input array
C                        IWK.
C
C                        Example:          CALL CONOP2('NCP=ON',3)
C
C                   PDV  Flag to plot the input data values.  The
C                        default value is PDV=OFF.
C
C                        To turn on:    CALL CONOP1('PDV=ON')
C
C                        To turn off:   CALL CONOP1('PDV=OFF')
C
C                        Note: If PDV=ON, the input  data  values  are
C                        plotted  relative  to  their  location on the
C                        contour map.  If you only wish to see the
C                        locations  and  not the values, set PDV=ON and
C                        change FMT to produce an asterisk (*) such as
C                        (I1).
C
C                   PER  Flag to set the perimeter.  The default value
C                        is  PER=ON,  which  causes  a perimeter to be
C                        drawn around the contour plot.
C
C                        To turn on:    CALL CONOP1('PER=ON')
C
C                        To turn off:   CALL CONOP1('PER=OFF')
C
C                        Note: If MES is ON, the X and Y tick intervals
C                        will  be given.  These are the intervals in user
C                        coordinates that each tick mark represents.
C
C                   PMM  Flag to plot relative minimums and maximums.
C                        This flag is OFF by default.
C
C                        To turn off:      CALL CONOP1('PMM=OFF')
C
C                        To turn on:       CALL CONOP1('PMM=ON')
C
C                   PSL  Flag which sets the plot shield option.
C                        The outline of the shield will be drawn on
C                        the same frame as the contour plot.
C                        By default this option is OFF.
C                        (see SLD option).
C
C                        Draw the shield:  CALL CONOP1('PSL=ON')
C
C                        Don't draw it:    CALL CONOP1('PSL=OFF')
C
C                   REP  Flag indicating the use of the same data in
C                        a new execution.  The default value is OFF.
C
C                        To turn on:    CALL CONOP1('REP=ON')
C
C                        To turn off:   CALL CONOP1('REP=OFF')
C
C                        Note: If REP=ON, the same X-Y data and triangu-
C                        lation  are  to  be  used but it is assumed
C                        the user has changed contour values or resolution
C                        for this run.  Scratch arrays WK and IWK must
C                        remain unchanged.
C
C                   SCA  Flag for scaling of the plot on a frame.
C                        This flag is ON by default.
C
C                        User scaling:     CALL CONOP1('SCA=OFF')
C
C                        Program scaling:  CALL CONOP1('SCA=ON')
C
C                        Prior window:     CALL CONOP1('SCA=PRI')
C
C                        Note:  With  SCA=OFF,  plotting  instructions
C                        will be issued using the user's input coordi-
C                        nates, unless they are transformed via FX and
C                        FY  transformations.   Users will find an
C                        extended discussion in the "INTERFACING WITH
C                        OTHER GRAPHICS ROUTINES" section below.  The SCA
C                        option  assumes  that all input data falls into
C                        the current window setting.  With SCA=ON, the
C                        entry point will establish a viewport so that
C                        the user's plot will fit into the  center  90
C                        percent of the frame.  When SCA=PRI, the
C                        program  maps the user's plot instructions  into
C                        the  portion of the frame defined by the
C                        current normalization transformation.  SCA=OFF
C                        should be used to interface with EZMAP.
C
C                   SDC  Flag to determine how to scale  the  data  on
C                        the contours.  If SDC=OFF, the floating point
C                        value is given by scale.  If SDC=ON, the user
C                        may specify SCALE.  The default value for SCALE
C                        is 1.
C
C                        If program set:   CALL CONOP3('SDC=OFF',0.,0)
C
C                        If user set:      CALL CONOP3('SDC=ON',SCALE,1)
C
C                        Note: The data plotted on contour  lines  and
C                        the  data  plotted  for relative minimums and
C                        maximums will be scaled by the floating point
C                        value  given  by SCALE.  Typical SCALE values
C                        are 10., 100., 1000., etc.  The original data
C                        values are multiplied by SCALE.  SCALE must be
C                        a floating point number and is displayed in the
C                        message  (see  MES).
C
C                        Example:          CALL CONOP2('SDC=ON',100.,1)
C
C                   SLD  Activate or deactivate the shielding option.
C                        When this option is activated,  only those
C                        contours within the shield are drawn. The shield
C                        is a polygon specified by the user which must
C                        be given in the same coordinate range as the
C                        the data. It must define only one polygon.
C
C                        To activate the shield:
C                               CALL CONOP3('SLD=ON',ARRAY,ICSD)
C
C                        To deactivate the shield:
C                               CALL CONOP3('SLD=OFF',0.,0)
C
C                        Note:  ARRAY is a real array ICSD elements long.
C                        The first ICSD/2 elements are X coordinates and
C                        the second ICSD/2 elements are Y coordinates.
C                        ICSD is the length of entire array, the
C                        number of (X + Y) shield coords. The polygon
C                        must be closed, that is the first and last
C                        points describing it must be the same.
C
C                        Example:       DIMENSION SHLD
C                                       DATA SHLD/ 7.,10.,10.,7.,7.,
C                                      1           7.,7.,10.,10.,7./
C                                       CALL CONOP3 (6HSLD=ON,SHLD,10)
C
C
C                   SML  Flag to determine the  size  of  minimum  and
C                        maximum contour labels.  If SML=OFF, the
C                        ISZSML default value of  15 is  used.
C                        If SML=ON, the user must specify ISZSML.
C
C                        If program set:   CALL CONOP2('SML=OFF',0)
C
C                        If user set:  CALL CONOP2('SML=ON',ISZSML)
C
C                        Note: ISZSML is an integer number which  is
C                        the size of labels in plotter address units
C                        as defined in the SPPS entry WTSTR.
C
C                        Example:      CALL CONOP2('SML=ON',12)
C
C                   SPD  Flag for the size of the plotted  input  data
C                        values.  If SPD=OFF, the value of ISZSPD is
C                        8, which is the default.  If SPD=ON, the user
C                        must specify ISZSPD.
C
C                        If program set:   CALL CONOP2('SPD=OFF',0)
C
C                        If user set:   CALL CONOP2('SPD=ON',ISZSPD)
C
C                        Note: ISZSPD is an integer number giving the
C                        size to plot the data values in plotter address
C                        units as defined in the SPPS entry WTSTR.    .
C
C                        Example:          CALL CONOP2('SPD=ON',6)
C
C                   SSZ  Flag to determine the resolution  (number  of
C                        steps  in  each  direction).   If SSZ=ON, the
C                        user sets ISTEP, or, if SSZ=OFF, the  program
C                        will  automatically  set ISTEP at the default
C                        value of 40.
C
C                        If program set:   CALL CONOP2('SSZ=OFF',0)
C
C                        If user set:      CALL CONOP2('SSZ=ON',ISTEP)
C
C                        Note: ISTEP is an integer specifying the density
C                        of the virtual grid. In most cases, the default
C                        value of 40 produces pleasing contours.   For
C                        coarser   but  quicker  contours,  lower  the
C                        value.  For smoother contours at
C                        the expense of taking a longer  time,  raise
C                        the  value.   Note:   For  step sizes greater
C                        than 200 in CONRAN, the arrays  PV  in  common
C                        CONRA1  and ITLOC in common CONRA9,  must be
C                        expanded to about 10 more than ISTEP.
C                        See CONRA1 and CONRA9 comments below for more
C                        information.
C
C                        Example:          CALL    CONOP2('SSZ=ON',25)
C                                          This  ISTEP value will pro-
C                                          duce a coarse contour.
C
C                   STL  Flag to determine  the  size  of  the  title.
C                        ISZSTL  may be set by the user (STL=ON), or
C                        the program will set it to the  default  size
C                        of 16 plotter address units (STL=OFF).
C
C                        If program set:   CALL CONOP2('STL=OFF',0)
C
C                        If user set:  CALL  CONOP2('STL=ON',ISZSTL)
C
C                        Note: When 30 or 40 characters are  used  for
C                        the title, the default size of 16 plotter
C                        address units works well.  For longer titles,
C                        a smaller title size is required.
C
C                        Example:          CALL CONOP2('STL=ON',13)
C
C                   TEN  Flag to determine the tension factor  applied
C                        when  smoothing  contour lines.  The user may
C                        set TENS or allow  the  program  to  set  the
C                        value.   If  user set, TENS must have a value
C                        greater than zero and less than or  equal  to
C                        30.  The default value is 2.5.
C
C                        If program set:   CALL CONOP3('TEN=OFF',0.,0)
C
C                        If user set:      CALL CONOP3('TEN=ON',TENS,1)
C
C                        Note: TENS is not available in the standard
C                        version of CONRAN.
C                        Smoothing of contour  lines  is  accomplished
C                        with  splines  under  tension.  To adjust the
C                        amount of smoothing applied, adjust the  ten-
C                        sion  factor.   Setting TENS very large
C                        (i.e. 30.), effectively shuts off smoothing.
C
C                        Example:          CALL CONOP3('TEN=ON',14.,1)
C
C                   TFR  Flag to advance the frame before triangulation.
C                        The default value is TFR=ON, which means that
C                        the contours and the triangles will be plotted
C                        on separate frames.
C
C                        If program set:   CALL CONOP1('TFR=ON')
C
C                        To turn off:      CALL CONOP1('TFR=OFF')
C
C                        Note: Triangles are plotted  after  the  con-
C                        touring  is completed.  To see the triangles
C                        over  the  contours,  turn this switch off.
C
C                   TLE  Flag to place a title at the top of the plot.
C                        If  TLE=ON,  the user must specify CHARS and
C                        INUM.  CHARS  is the character string containing
C                        the title.  INUM is the number of characters
C                        in CHARS.  The default value is  OFF.
C
C                        To turn on: CALL CONOP4('TLE=ON',CHARS,INUM,0)
C
C                        To turn off:   CALL CONOP4('TLE=OFF',' ',0,0)
C
C                        Note: If longer than 64-character titles are
C                        desired, the character variable ISTRNG found
C                        in CONR18 must be increased appropriately.
C
C                        Example: CALL CONOP4('TLE=ON','VECTOR REVIEW'
C                                       ,13,0)
C
C                   TOP  Flag to plot only the triangles.
C
C                        To turn off:   CALL CONOP1('TOP=OFF')
C
C                        To turn on:    CALL CONOP1('TOP=ON')
C
C                        Note: The user may wish to overlay the trian-
C                        gles on some other plot.  'TOP=ON' will
C                        allow  that.   This  option  when   activated
C                        (TOP=ON),  will  set TRI=ON, and TFR=OFF.  If
C                        the user wants TFR=ON, it should be set after
C                        TOP is set.  If the user sets TOP=OFF it will
C                        set TRI=OFF and TFR=ON. If the user wants TRI
C                        or  TFR  different, set them after the
C                        TOP call.
C
C                   TRI  Flag to plot the triangulation.  The default is
C                        OFF and therefore the triangles are not drawn.
C
C                        To turn on:    CALL CONOP1('TRI=ON')
C
C                        To turn off:   CALL CONOP1('TRI=OFF')
C
C                        Note: Plotting the triangles will indicate to
C                        the  user where good and bad points of inter-
C                        polation are occurring in  the  contour  map.
C                        Equilateral  triangles are optimal for inter-
C                        polation.  Quality degrades as triangles
C                        approach  a  long and narrow shape.  The convex
C                        hull of the  triangulation  is  also  a  poor
C                        point of interpolation.
C
C        OPTION DEFAULT  Below are  listed  the  default
C                VALUES  values  for  the various options given above.
C                        Unless the user  specifies  otherwise,  these
C                        values will be used in execution of the vari-
C                        ous options.
C
C                           CHL=OFF  LOT=OFF  SLD=OFF  TRI=OFF
C                           CIL=OFF  LSZ=OFF  SML=OFF
C                           CON=OFF  MES=ON   SPD=OFF
C                           DAS=OFF  NCP=OFF  SPT=OFF
C                           DBP=OFF  PDV=OFF  SSZ=OFF
C                           EXT=OFF  PER=ON   STL=OFF
C                           FMT=OFF  PMM=OFF  TEN=OFF
C                           GRI=OFF  REP=OFF  TFR=ON
C                           ITP=C1   SCA=ON   TLE=OFF
C                           LAB=ON   SDC=OFF  TOP=OFF
C
C    DEFAULT VALUES FOR  The option default  values  given  above,  if
C        USER SPECIFIED  used, will set default values for the follow-
C            PARAMETERS  ing parameters:
C
C                        PARAMETER    DEFAULT
C                        ---------    -------
C
C                        ARRAY        Up to 30 contour levels allowed.
C                                     Values  are computed by the
C                                     program, based on input.
C
C                        BP           0.
C
C                        CINC         Computed by the program based on the
C                                     range of HI and LO values of the
C                                     input data.
C
C                        FLO          Computed by the program based on the
C                                     lowest unscaled input data.
C
C                        FT           (G10.3)  Parentheses must be
C                                     included.
C
C                        HI           Computed by the program based on the
C                                     highest unscaled input data.
C
C                        CHARS        No title
C
C                        IF           10 characters
C
C                        INUM         No title
C
C                        IPAT         '$$$$$$$$$$'  (This is a 10 character
C                                     string.)
C
C                        ISZLSZ       9 plotter address units
C
C                        ISZSML       15 plotter address units
C
C                        ISZSPD       8 plotter address units
C
C                        ISZSTL       16 plotter address units
C
C                        ISTEP        40
C
C                        IVAL         'HI' for all except  minor  con-
C                                     tour   lines   which  are  'LO'.
C
C                        L            7  characters  (including   both
C                                     parentheses)
C
C                        NCL          Computed by the program based on
C                                     input data.  Up to 30 contour
C                                     levels are permitted.
C
C                        NUM          4 data points
C
C                        SCALE        1. (no scaling performed)
C
C                        TENS         2.5
C
C                        ICSD         0 (no shield)
C
C         OPTIONS WHICH  The shape of the contours may be modified by
C            EFFECT THE  changing NCP  and SSZ.  NCP controls the
C              CONTOURS  number of data points to be used in the
C                        interpolation.  Increasing NCP causes more
C                        of the  surrounding  data  to influence the
C                        point of interpolation.  Some  datasets cause
C                        difficulty  when  trying  to produce meaningful
C                        contours (triangles which are long and  narrow).
C                        By modifying NCP a user can fine-tune a
C                        plot.   Increasing  ISTEP, the density of the
C                        virtual grid, will  smooth out the contour
C                        lines and pick up  more  detail  (new  contours
C                        will appear as ISTEP increases and old ones will
C                        sometimes break into more  distinct units).
C                        ISTEP is changed by the SSD option.
C
C                  NOTE  If NCP.GT.25, arrays DSQ0 and IPC0 in CONDET
C                        must  be adjusted accordingly.  Also NCPSZ in
C                        CONBDNX (25 by default), must be increased to
C                        NCP.   The  default  value of NCP, which is 4,
C                        produces pleasing  pictures  in  most  cases.
C                        However, fine-tuning of the interpolation can
C                        be obtained by increasing the  size  of  NCP,
C                        with  a corresponding linear increase in work
C                        space.
C
C                        The interpolation method used will also cause
C                        different looking contours.  The C1 method
C                        is recommended when the data is sparse.  It
C                        will smooth the data and add trends (false
C                        hills and valleys).  The linear method is
C                        recommended when data is dense (GT 50 to 100)
C                        it will not smooth the data or add trends.
C
C      INTERFACING WITH  Normally the scaling factor will be set to OFF.
C        OTHER GRAPHICS  In most cases mapping can be performed before
C              ROUTINES  calling the CONRAN entry point, thus saving the
C                        user from  modifying the file.  If reasonable
C                        results cannot be obtained, the statement
C                        functions, FX and FY, will have to be replaced.
C                        The routines having these statement functions
C                        are:
C
C                           CONDRW, CONPDV, CONTLK, CONPMS, CONGEN
C
C            REFERENCES  Akima, Hirosha
C                           A Method of Bivariate Interpolation and
C                           Smooth Surface Fitting for Irregularly
C                           Distributed Data Points.
C                           ACM Transactions on Mathematical Software
C                           vol 4, no. 2, June 1978, pages 148-159
C                        Lawson, C.L.
C                           Software for C1 Surface Interpolation
C                           JPL Publication 77-30
C                           August 15, 1977
C
C     CONRAN ERROR  ERROR  ROUTINE               MESSAGE
C       MESSAGES
C                    1      CONRAN         INPUT PARAMETER NDP LT NCP
C                    2      CONRAN         NCP GT MAX SIZE OR LT 2
C                    3      CONTNG         ALL COLINEAR DATA POINTS
C                    4      CONTNG         IDENTICAL INPUT DATA POINTS
C                                          FOUND
C                    5      CONOP          UNDEFINED OPTION
C                    6      CONCLS         CONSTANT INPUT FIELD
C                    7      CONOP          INCORRECT CONOP CALL USED
C                    8      CONOP          ILLEGAL USE OF CON OPTION
C                                          WITH CIL OR CHL OPTIONS
C                    9      CONOP          NUMBER OF CONTOUR LEVELS
C                                          EXCEEDS 30
C                    10     CONDRW         CONTOUR STORAGE EXHAUSTED
C                                          This error is trapped and
C                                          nullified by CONRAN.  It
C                                          serves to signal the user
C                                          that a contour level may not
C                                          be complete.
C                    11     CONSTP         ASPECT RATIO OF X AND Y
C                                          GREATER THAN 5 TO 1.
C                                          (This error may cause a poor
C                                          quality plot.  Usually this
C                                          can be fixed by multiplying
C                                          X or Y by a constant factor.
C                                          If this solution is
C                                          unacceptable then increasing
C                                          SSZ to a very large value
C                                          may help.  Note:  This can be
C                                          expensive.)
C
C                     The errors listed above are defined as recoverable
C                     errors should the user wish to use them in that
C                     fashion.  The documentation on the ERPRT77 package
C                     explains how to recover from an error.
C
C
C Note:  The common blocks listed include all the common used by
C        the entire CONRAN family.  Not all members will use all
C        the common variables.
C
C   CONRA1
C       CL-array of contour levels
C       NCL-number of contour levels
C       OLDZ-Z value of left neighbor to current location
C       PV-array of previous row values
C       HI-largest contour plotted
C       FLO-lowest contour plotted
C       FINC-increment level between equally spaced contours
C   CONRA2
C       REPEAT-flag to triangulate and draw or just draw
C       EXTRAP-plot data outside of convex data hull
C       PER-put perimeter around plot
C       MESS-flag to indicate message output
C       ISCALE-scaling switch
C       LOOK-plot triangles flag
C       PLDVLS-plot the data values flag
C       GRD-plot grid flag
C       CON-user set or program set contours flag
C       CINC-user or program set increment flag
C       CHILO-user or program set hi low contours
C       LABON-flag to control labeling of contours
C       PMIMX-flag to control the plotting of min's
C             and max's
C       SCALE-the scale factor for contour line values
C             and min, max plotted values
C       FRADV-advance frame before plotting triangulation
C       EXTRI-only plot triangulation
C       BPSIZ-breakpoint size for dashpatterns
C       LISTOP-list options on UNIT6 flag
C   CONRA3
C       IRED-ERPRT77 recoverable error flag
C   CONRA4
C       NCP-number of data points used at each point for
C           polynomial construction.
C       NCPSZ-max size allowed for NCP
C   CONRA5
C       NIT-flag to indicate status of search data base
C       ITIPV-last triangle interpolation occurred in
C  CONRA6
C       XST-X coordinate start point for contouring
C       YST-Y coordinate start point for contouring
C       XED-X coordinate end point for contouring
C       YED-Y coordinate end point for contouring
C       STPSZ-step size for X,Y change when contouring
C       IGRAD-number of graduations for contouring (step size)
C       IG-reset value for IGRAD
C       XRG-X range of coordinates
C       YRG-Y range of coordinates
C       BORD-percent of frame used for contour plot
C       PXST-X plotter start address for contours
C       PYST-Y plotter start address for contours
C       PXED-X plotter end address for contours
C       PYED-Y plotter end address for contours
C       ITICK-number of tick marks for grids and perimeters
C CONR18
C       TITLE-switch to indicate if title option ON or OFF
C       ISTRNG-character string containing the title
C       ICNT-character count of ISTRNG
C       ITLSIZ-size of title in PWRIT units
C CONR19
C       IHIGH-default intensity setting
C       INMAJ-contour Level intensity for major lines
C       INMIN-contour Level intensity for minor lines
C       INLAB-title and message intensity
C       INDAT-data value intensity
C       FORM-the format for plotting the data values
C       LEN-the number of characters in the format
C       IFMT-size of the format field
C       LEND-default format length
C       IFMTD-default format field size
C       ISIZEP-size of the plotted data values
C  CONRA9
C       X-array of X coordinates of contours drawn at current contour
C          level
C       Y-array of Y coordinates of contours drawn at current contour
C          level
C       NP-count in X and Y
C       MXXY-size of X and Y
C       TR-top right corner value of current cell
C       BR-bottom right corner value of current cell
C       TL-top left corner value of current cell
C       BL-bottom left corner value of current cell
C       CONV-current contour value
C       XN-X position where contour is being drawn
C       YN-Y position where contour is being drawn
C       ITLL-triangle where top left corner of current cell lies
C       IBLL-triangle of bottom left corner
C       ITRL-triangle of top right corner
C       IBRL-triangle of bottom right corner
C       XC-X coordinate of current cell
C       YC-Y coordinate of current cell
C       ITLOC-in conjunction with PV stores the triangle where PV
C             value came from
C CONR10
C       NT-number of triangles generated
C       NL-number of line segments
C       NTNL-NT+NL
C       JWIPT-pointer into IWK where where triangle point numbers
C             are stored
C       JWIWL-in IWK the location of a scratch space
C       JWIWP-in IWK the location of a scratch space
C       JWIPL-in IWK the location of end points for border line
C             segments
C       IPR-in WK the location of the partial derivatives at each
C           data point
C       ITPV-the triangle where the previous value came from
C CONR20
C       NREP-number of repetitions of dash pattern before a label
C       NCRT-number of CRT units for a dash mark or blank
C       ISIZEL-size of contour line labels
C       NDASH-array containing the negative valued contour dash
C             pattern
C       MINGAP-number of unlabeled lines between each labeled one
C       IDASH-positive valued contour dash pattern
C       ISIZEM-size of plotted minimums and maximums
C       EDASH-equal valued contour dash pattern
C       TENS-default tension setting for smoothing
C CONR12
C       IXMAX,IYMAX-maximum X and Y coordinates relative to the
C                 scratch array, SCRARR
C       XMAX,YMAX-maximum X and Y coordinates relative to users
C                 coordinate space
C CONR13
C       XVS-array of the X coordinates for shielding
C       YVS-array of the Y coordinates for shielding
C       IXVST-pointer to the users X array for shielding
C       IYVST-pointer to the users Y array for shielding
C       ICOUNT-count of the shield elements
C       SPVAL-special value used to halt contouring at the shield
C               boundary
C       SHIELD-logical flag to signal status of shielding
C       SLDPLT-logical flag to indicate status of shield plotting
C CONR14
C       LINEAR-C1 linear interpolating flag
C CONR15
C       ISTRNG-title of the plot
C CONR16
C       FORM-Format used for data
C CONR17
C       NDASH-Dash pattern used for contour lines less than BP
C       IDASH-Dash pattern used for contour lines greater than BP
C       EDASH-Dash pattern used for contour lines equal to the BP
C RANINT
C       IRANMJ-color index for normal (major) intensity lines
C       IRANMN-color index for low intensity lines
C       IRANMJ-color index for text (labels)
C
C
      DIMENSION       LNGTHS(4)  ,HOLD(4)
        CHARACTER*110   IWORK
        CHARACTER*13    ENCSCR,  ENSCRY
        CHARACTER*1     ICHAR
        CHARACTER*500   DPAT
        REAL            WIND(4),VIEW(4),NWIND(4),NVIEW(4),RECT(4)
      DIMENSION       XD(*)      ,YD(*)      ,ZD(*)      ,WK(*)      ,
     1                IWK(*)     ,SCRARR(*)
C
C
      COMMON /CONRA1/ CL(30)     ,NCL        ,OLDZ       ,PV(210)    ,
     1                FINC       ,HI         ,FLO
      COMMON /CONRA2/ REPEAT     ,EXTRAP     ,PER        ,MESS       ,
     1                ISCALE     ,LOOK       ,PLDVLS     ,GRD        ,
     2                CINC       ,CHILO      ,CON        ,LABON      ,
     3                PMIMX      ,SCALE      ,FRADV      ,EXTRI      ,
     4                BPSIZ      ,LISTOP
      COMMON /CONRA3/ IREC
      COMMON /CONRA4/ NCP        ,NCPSZ
      COMMON /CONRA5/ NIT        ,ITIPV
      COMMON /CONRA6/ XST        ,YST        ,XED        ,YED        ,
     1                STPSZ      ,IGRAD      ,IG         ,XRG        ,
     2                YRG        ,BORD       ,PXST       ,PYST       ,
     3                PXED       ,PYED       ,ITICK
      COMMON /CONR18/ TITLE      ,ICNT   ,ITLSIZ
      COMMON /CONR19/ IHIGH      ,INMAJ      ,INLAB      ,INDAT      ,
     1              LEN      ,IFMT       ,LEND       ,
     2                IFMTD      ,ISIZEP     ,INMIN
      COMMON /CONRA9/ ICOORD(500),NP         ,MXXY       ,TR         ,
     1                BR         ,TL         ,BL         ,CONV       ,
     2                XN         ,YN         ,ITLL       ,IBLL       ,
     3                ITRL       ,IBRL       ,XC         ,YC         ,
     4                ITLOC(210) ,JX         ,JY         ,ILOC       ,
     5                ISHFCT     ,XO         ,YO         ,IOC        ,NC
      COMMON /CONR10/ NT         ,NL         ,NTNL       ,JWIPT      ,
     1                JWIWL      ,JWIWP      ,JWIPL      ,IPR        ,
     2                ITPV
      COMMON /CONR20/ NREP       ,NCRT       ,ISIZEL     ,
     1                MINGAP     ,ISIZEM         ,
     2                TENS
      COMMON /CONR12/ IXMAX      ,IYMAX      ,XMAX       ,YMAX
      LOGICAL         REPEAT     ,EXTRAP     ,PER        ,MESS       ,
     1                LOOK       ,PLDVLS     ,GRD        ,LABON      ,
     2                PMIMX      ,FRADV      ,EXTRI      ,CINC       ,
     3                TITLE      ,LISTOP     ,CHILO      ,CON
      COMMON /CONR13/XVS(50),YVS(50),ICOUNT,SPVAL,SHIELD,
     1               SLDPLT
      LOGICAL SHIELD,SLDPLT
      COMMON /CONR14/LINEAR
      LOGICAL LINEAR
      COMMON /CONR15/ ISTRNG
        CHARACTER*64 ISTRNG
        COMMON /CONR16/ FORM
        CHARACTER*10 FORM
        COMMON /CONR17/ NDASH, IDASH, EDASH
        CHARACTER*10 NDASH, IDASH, EDASH
        COMMON /RANINT/ IRANMJ, IRANMN, IRANTX
        INTEGER OPLASF, OTXASF, LASF(13), OCOLI, OTEXCI
        SAVE
C
C
        DATA LNGTHS(1),LNGTHS(2),LNGTHS(3),LNGTHS(4)/13,4,21,6/
C
C ICONV CONVERT FORM 0-32767 TO 1-1024
C
        DATA ICONV/32/
C
C IABOVE AMOUNT TITLE IS PLACED ABOVE PLOT
C IBELOW, IBEL2 AMOUNT MESSAGE IS BELOW PLOT
C
        DATA IABOVE,IBELOW,IBEL2/30,-30,-45/
C
C
C  Do a call forcing a BLOCKDATA to be loaded from a binary library.
C
      CALL CONBDN
C
C  THE FOLLOWING CALL IS FOR MONITORING LIBRARY USE AT NCAR
C
      CALL Q8QST4 ('NSSL','CONRAN','CONRAN','VERSION 01')
C
C  LIST THE OPTION VALUES IF REQUESTED
C
      IF (LISTOP) CALL CONOUT (2)
C
C  SET SWITCH TO MAP TRIANGLES, IN CONLOC, FOR QUICK SEARCHES
C
      NIT = 0
C
C  TEST TO SEE IF ENOUGH INPUT DATA
C
      IF (NDP.GE.NCP) GO TO    10
      CALL SETER (' CONRAN - INPUT PARAMETER NDP LESS THAN NCP',1,
     1             IREC)
      RETURN
C
   10 IF (NCPSZ.GE.NCP .AND. NCP.GE.2) GO TO    20
      CALL SETER (' CONRAN - NCP LT 2 OR GT NCPSZ',2,IREC)
C
   20 IWK(1) = NDP
      IWK(2) = NCP
      IWK(3) = 1
C
C  SET POLYLINE COLOR ASF TO INDIVIDUAL
C
        CALL GQASF(IERR,LASF)
        OPLASF = LASF(3)
        LASF(3) = 1
        OTXASF = LASF(10)
        LASF(10) = 1
        CALL GSASF(LASF)
C
C  INQUIRE CURRENT POLYLINE AND TEXT COLOR
C
        CALL GQPLCI(IERR,OCOLI)
        CALL GQTXCI(IERR,OTEXCI)
C
C  SET POLYLINE AND TEXT COLOR TO VALUE IN COMMON
C
        CALL GSPLCI(IRANMJ)
      CALL GSTXCI(IRANTX)
C
C CONSTRUCTION OF WORK SPACE POINTERS
C
C TRIANGLE POINT NUMBERS
C
      JWIPT = 16
C
C SCRATCH SPACE
C
      JWIWL = 6*NDP + 1
C
C  END POINTS OF BORDER LINE SEGMENTS AND TRIANGLE NUMBER
C
      JWIPL = 24*NDP + 1
C
C  POINT NUMBERS WHERE THE NCP DATA POINTS AROUND EACH POINT
C
      JWIPC = 27*NDP + 1
C
C  SCRATCH SPACE
C
      JWIWP = 30*NDP + 1
C
C  PARTIAL DERIVATIVES AT EACH DATA POINT
C
      IPR = 8*NDP + 1
C
C  TEST IF REPEAT (JUST NEW CONTOURS OF INTERPOLATED DATA)
C  OR NO REPEAT (TRIANGULATE AND CONTOUR)
C
      IF (REPEAT) GO TO    30
C
C TRIANGULATES THE X-Y PLANE.
C
      CALL CONTNG (NDP,XD,YD,NT,IWK(JWIPT),NL,IWK(JWIPL),IWK(JWIWL),
     1             IWK(JWIWP),WK)
      IF (NERRO(ITEMP).NE.0) RETURN
C
      IWK(5) = NT
      IWK(6) = NL
      NTNL = NT+NL
C
C  SKIP IF NOT LINEAR INTERPOLATION
C
      IF (.NOT.LINEAR) GO TO 25
C
C  FIND THE COEFICENTS FOR LINER INTERPOLATION OF EACH TRIANGLE
C
      CALL CONLIN(XD,YD,ZD,NT,IWK(JWIPT),WK(IPR))
      GO TO 35
C
C
C DETERMINES NCP POINTS CLOSEST TO EACH DATA POINT.
C
 25   CALL CONDET (NDP,XD,YD,NCP,IWK(JWIPC))
C
C  ESTIMATE THE PARTIAL DERIVATIVES AT ALL DATA POINTS
C
      CALL CONINT (NDP,XD,YD,ZD,NCP,IWK(JWIPC),WK(IPR))
C
C  VERIFY DATA VALUES VALID
C
   30 NT = IWK(5)
      NL = IWK(6)
      NTNL = NT+NL
C
C  COMPUTE STEP SIZE FOR CONTOURING
C
 35   CALL CONSTP (XD,YD,NDP)
C
C  Save the current clipping state and get current SET parameters.
C
      CALL GQCLIP (IERR,ICLP,RECT)
      CALL GSCLIP (0)
      CALL GETSET (VIEW(1),VIEW(2),VIEW(3),VIEW(4),
     +             WIND(1),WIND(2),WIND(3),WIND(4),IOLLS)
      RX1 = VIEW(1)
      RX2 = VIEW(2)
      RY1 = VIEW(3)
      RY2 = VIEW(4)
C
      ISC = ISCALE+1
      GO TO (   40,   60,   50),ISC
C
C  CONRAN SETS SCALING FACTOR
C
   40 CALL SET(PXST,PXED,PYST,PYED,XST,XED,YST,YED,1)
      GO TO 60
C
C  CONRAN PLOTS WITHIN USERS BOUNDARIES
C
   50 CALL SET(RX1,RX2,RY1,RY2,XST,XED,YST,YED,1)
C
C  IF TRIANGULATION PLOT ONLY BRANCH
C
   60 IF (EXTRI) GO TO   390
C
C  GENERATE CONTOURS IF NONE SUPPLIED BY USER
C
      CALL CONCLS (ZD,NDP)
      IF (NERRO(ITEMP).NE.0) RETURN
C
C  REORDER THE CONTOUR LINES FOR CORRECT PATTERN DISPLAY
C
      MAJLNS = 0
      IF (LABON) CALL CONREO (MAJLNS)
C
C  MAKE SURE INTEGER COORDINATES IN 1-1024 RANGE
C
      CALL SETUSV('XF',10)
      CALL SETUSV('YF',10)
C
C  SET THE DASH PATTERNS TO DEFAULT IF THEY HAVE NOT BEEN SET
C
C
      IF (IDASH(1:1).NE.' ') GO TO        80
C
C  SET POSITIVE CONTOUR VALUE TO DEFAULT
C
        IDASH = '$$$$$$$$$$'
   80 IF (NDASH(1:1).NE.' ') GO TO       100
C
C  SET NEGATIVE CONTOUR DASH PATTERN TO DEFAULT
C
        NDASH = '$$$$$$$$$$'
  100 IF (EDASH(1:1).NE.' ') GO TO   120
C
C  SET EQUAL CONTOUR DASH PATTERN TO DEFAULT
C
        EDASH = '$$$$$$$$$$'
C
C  INITIALIZE THE CONTOURING DATA STRUCTURE
C
  120 IF (.NOT.EXTRAP) YST = YST+STPSZ
C
C  LOAD THE SCRATCH SPACE
C
      CALL CONLOD (XD,YD,ZD,NDP,WK,IWK,SCRARR)
C
C  PERFORM SHIELDING IF SO REQUESTED
C
      IF (SHIELD) CALL CONSLD(SCRARR)
C
C  *******************************************************
C  *                                                     *
C  * IF THE USER NEEDS TO DIVIDE THE PROGRAM UP          *
C  * THIS IS THE BREAK POINT.  ALL SUBROUTINES CALLED    *
C  * PRIOR TO THIS MESSAGE ARE NOT USED AGAIN AND        *
C  * ALL ROUTINES AFTER THIS MESSAGE ARE NOT USED        *
C  * ANY EARLIER.  NOTE THIS ONLY REFEARS TO ENTRY POINTS*
C  * WHICH ARE PART OF THE CONRAN PACKAGE.               *
C  * ALL DATA STRUCTURES AND VARIABLES MUST BE RETAINED. *
C  *******************************************************
C
C
C  PLOT RELATIVE MINIMUMS AND MAXIMUMS IF REQUESTED
C
      IF (PMIMX) CALL CONPMM (SCRARR)
C
C
      LENDAS = NREP*10
C
C  SET THE ERROR MODE TO RECOVERY FOR THE CONTOURING STORAGE ERROR
C
      CALL ENTSR (IROLD,1)
C
C  DRAW THE CONTOURS
C
      DO   250 I=1,NCL
C
          CONV = CL(I)
          IF (CONV.GE.BPSIZ) GO TO   150
C
C  SET UP NEGATIVE CONTOUR PATTERN
C
              DO   140 J=1,10
                ICHAR = NDASH(J:J)
                  DO   130 K=1,NREP
                DPAT( J+( 10*(K-1) ): J+( 10*(K-1)) ) = ICHAR
  130             CONTINUE
  140         CONTINUE
          GO TO   210
C
C  SET UP POSITIVE CONTOUR DASH PATTERN
C
  150     IF (CONV.EQ.BPSIZ) GO TO   180
              DO   170 J=1,10
                ICHAR = IDASH(J:J)
                  DO   160 K=1,NREP
                  DPAT( J+( 10*(K-1) ): J+( 10*(K-1)) ) = ICHAR
  160             CONTINUE
  170         CONTINUE
          GO TO   210
C
C  SET UP EQUAL CONTOUR DASH PATTERN
C
  180         DO   200 J=1,10
                ICHAR = EDASH(J:J)
                  DO   190 K=1,NREP
                DPAT( J+( 10*(K-1) ): J+( 10*(K-1)) ) = ICHAR
  190             CONTINUE
  200         CONTINUE
C
  210     IF (I.GT.MAJLNS) GO TO   230
C
C  SET UP MAJOR LINES
C
          CALL GSPLCI (IRANMJ)
          CALL CONECD (CONV,IWORK,NCUSED)
          NCHAR = LENDAS + NCUSED
        DPAT(LENDAS+1:NCHAR) = IWORK(1:NCUSED)
          GO TO   240
C
C  SET UP MINOR LINES
C
  230     NCHAR = 10
      CALL GSPLCI (IRANMN)
C
C  PROCESS FOR ALL CONTOURS
C
  240     CALL DASHDC (DPAT(1:NCHAR),NCRT,ISIZEL)
C
C  DRAW ALL CONTOURS AT THIS LEVEL
C
          CALL CONDRW (SCRARR)
C
C  GET NEXT CONTOUR LEVEL
C
  250     CONTINUE
C
C  CONTOURING COMPLETED CHECK FOR OPTIONAL OUTPUTS ON PLOT
C
C  FIRST SET ERROR MODE BACK TO USERS VALUE
C
      CALL RETSR (IROLD)
C
C  GET PLOT BOUNDARIES FOR TITLING AND MESSAGE POSITIONING
C
      CALL GQCNTN(IER,ICN)
        CALL GQNT(ICN,IER,NWIND,NVIEW)
        XST = NWIND(1)
        XED = NWIND(2)
        YST = NWIND(3)
        YED = NWIND(4)
C
C
C  RESET POLYLINE COLOR INDEX TO MAJOR (NORMAL)
C
        CALL GSPLCI (IRANMJ)
C
C  DRAW SHIELD ON PLOT IF REQUESTED
C
      IF(SLDPLT.AND.SHIELD) CALL CONDSD
C
C  DRAW PERIMETER ARROUND PLOT IF DESIRED
C
      IF (PER) CALL PERIM (ITICK,0,ITICK,0)
C
C  DRAW GRID IF REQUESTED
C
      IF (GRD) CALL GRID (ITICK,0,ITICK,0)
C
C  PLOT THE DATA VALUES IF REQUESTED
C
      IF (.NOT.PLDVLS) GO TO   260
      CALL CONPDV (XD,YD,ZD,NDP)
C
C  OUTPUT TITLE IF REQUESTED
C
  260 IF (.NOT.TITLE) GO TO   270
        CALL GSTXCI (IRANTX)
      CALL FL2INT (XED,YED,MX,MY)
      MY = (MY/ICONV)+IABOVE
        ILAST = 64
        DO 261 I = 64,1,-1
            IF (ISTRNG(I:I) .NE. ' ')THEN
                  ILAST = I + 1
                  GOTO 262
            ENDIF
  261 CONTINUE
  262 CONTINUE
C
C  POSITION STRINGS PROPERLY IF COORDS ARE IN PAU'S
C
C
C
      XC = CFUX((NVIEW(1)+NVIEW(2))/2.)
      YC = CPUY(MY)
      CALL WTSTR(XC,YC,ISTRNG(1:ILAST),ITLSIZ,0,0)
C
C
C
C  OUTPUT MESSAGE IF REQUESTED
C
  270 IF (.NOT.MESS) GO TO   390
C
        CALL GSTXCI(IRANTX)
      CALL FL2INT (XST,YST,MX,MY)
      MY = (MY/ICONV)
C
C  IF PERIMETER OR GRID PUT OUT TICK INTERVAL
C
        IMSZ = 0
      IF (.NOT.PER .AND. .NOT.GRD) GO TO   300
        IWORK(1:36) = 'X INTERVAL=              Y INTERVAL='
        WRITE(ENCSCR,'(G13.5)')XRG
        WRITE(ENSCRY,'(G13.5)')YRG
        IWORK(12:24) = ENCSCR
        IWORK(37:49) = ENSCRY
        IMSZ = 50
  300 IF (SCALE .EQ. 1.) GOTO 330
            IWORK(IMSZ:IMSZ+10) = ' SCALED BY '
            WRITE(ENCSCR,'(G13.5)')SCALE
            IWORK(IMSZ+11:IMSZ+23) = ENCSCR
            IMSZ = 73
  330 IF (IMSZ .NE. 0) THEN
        ILAST = IMSZ
        DO 291 I = IMSZ,1,-1
            IF (IWORK(I:I) .NE. ' ')THEN
                  ILAST = I + 1
                  GOTO 292
            ENDIF
  291 CONTINUE
  292 CONTINUE
C
C  POSITION STRINGS PROPERLY IF COORDS ARE IN PAU'S
C
C
C
      XC = CFUX((NVIEW(1)+NVIEW(2))/2.)
      YC = CPUY(MY+IBEL2)
      CALL WTSTR(XC,YC,IWORK(1:ILAST),8,0,0)
C
        ENDIF
C
C  PRODUCE CONTOUR INFO
C
      IWORK(1:42) = 'CONTOUR FROM              TO              '
      IWORK(43:77) = 'CONTOUR INTERVAL OF                '
      HOLD(1) = FLO
      HOLD(2) = HI
      HOLD(3) = FINC
        WRITE(ENCSCR,'(G13.5)')HOLD(1)
        IWORK(13:25) = ENCSCR
        WRITE(ENCSCR,'(G13.5)')HOLD(2)
        IWORK(29:41) = ENCSCR
        WRITE(ENCSCR,'(G13.5)')HOLD(3)
        IWORK(62:74) = ENCSCR
C
C  IF IRREGULAR SPACED CONTOURS MODIFY CONTOUR INTERVAL STATEMENT
C
      IF (FINC.GE.0.) GO TO   380
      NC = 62
          IWORK(NC:NC+15) = ' IRREGULAR      '
C
        ILAST = 77
  380 DO 381 I = 77,1,-1
            IF (IWORK(I:I) .NE. ' ')THEN
                  ILAST = I + 1
                  GOTO 382
            ENDIF
  381 CONTINUE
  382 CONTINUE
C
C  POSITION STRINGS PROPERLY IF COORDS ARE IN PAU'S
C
C
C
      XC = CFUX((NVIEW(1)+NVIEW(2))/2.)
      YC = CPUY(MY+IBELOW)
      CALL WTSTR(XC,YC,IWORK(1:ILAST),8,0,0)
C
C
C
C
C  PLOT TRIANGLES IF REQUESTED
C
  390 IF (LOOK) THEN
          CALL GSPLCI(IRANMN)
          CALL CONTLK (XD,YD,NDP,IWK(JWIPT))
          CALL GSPLCI(IRANMJ)
      ENDIF
C
C  Restore the original clipping state.
C
      CALL GSCLIP (ICLP)
C
C  RESTORE ORIGINAL COLOR AND POLYLINE COLOR ASPECT SOURCE FLAGS
C
      CALL GSPLCI(OCOLI)
      CALL GSTXCI(OTEXCI)
C
        LASF(10) = OTXASF
        LASF(3) = OPLASF
        CALL GSASF(LASF)
      RETURN
      END

C
C $Id: pakdsp.f,v 1.5 2008-07-27 00:17:09 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE PAKDSP (PAK,SGNA,DEGS,MINS,SECS)
C
C SUBROUTINE TO CONVERT PACKED DMS TO UNPACKED DMS ANGLE.
C
C SGNA : SIGN OF ANGLE
C DEGS : DEGREES PORTION OF ANGLE
C MINS : MINUTES PORTION OF ANGLE
C SECS : SECONDS PORTION OF ANGLE
C
      IMPLICIT REAL (A-Z)
      REAL SECS
      INTEGER DEGS,MINS
      CHARACTER*1 SGNA,IBLANK,NEG
      DATA ZERO,CON1,CON2 /0.0E0,1000000.0E0,1000.0E0/
      DATA TOL /1.0E-4/
      DATA IBLANK,NEG /' ','-'/
C
      SGNA = IBLANK
      IF (PAK .LT. ZERO) SGNA = NEG
      CON = ABS (PAK)
      DEGS = INT ((CON / CON1) + TOL)
      CON = MOD ( CON , CON1)
      MINS = INT ((CON / CON2) + TOL)
      SECS = MOD (CON , CON2)
      RETURN
C
      END

C
C $Id:$
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
C NOTE: If you make any changes to this software, please remember to
C make the same changes to the corresponding double precision routine.
C
      subroutine curvpp (n,x,y,p,d,isw,s,eps,ys,ysp,sigma,
     *                   td,tsd1,hd,hsd1,hsd2,rd,rsd1,rsd2,
     *                   rnm1,rn,v,ierr)
C
      integer n,isw,ierr
      real x(n),y(n),p,d(n),s,eps,ys(n),ysp(n),sigma,td(n),
     *     tsd1(n),hd(n),hsd1(n),hsd2(n),rd(n),rsd1(n),
     *     rsd2(n),rnm1(n),rn(n),v(n)
c
c                                 coded by alan kaylor cline
c                              from fitpack -- april 8, 1991
c                        a curve and surface fitting package
c                      a product of pleasant valley software
c                  8603 altus cove, austin, texas 78759, usa
c
c this subroutine determines the parameters necessary to
c compute a periodic smoothing spline under tension. for a
c given increasing sequence of abscissae (x(i)), i = 1,...,n
c and associated ordinates (y(i)), i = 1,...,n, letting p be
c the period, x(n+1) = x(1)+p, and y(n+1) = y(1), the
c function determined minimizes the summation from i = 1 to
c n of the square of the second derivative of f plus sigma
c squared times the difference of the first derivative of f
c and (f(x(i+1))-f(x(i)))/(x(i+1)-x(i)) squared, over all
c functions f with period p and two continuous derivatives
c such that the summation of the square of
c (f(x(i))-y(i))/d(i) is less than or equal to a given
c constant s, where (d(i)), i = 1,...,n are a given set of
c observation weights. the function determined is a periodic
c spline under tension with third derivative discontinuities
c at (x(i)) i = 1,...,n (and all periodic translations of
c these values). for actual computation of points on the
c curve it is necessary to call the function curvp2.
c
c on input--
c
c   n is the number of values to be smoothed (n.ge.2).
c
c   x is an array of the n increasing abscissae of the
c   values to be smoothed.
c
c   y is an array of the n ordinates of the values to be
c   smoothed, (i. e. y(k) is the functional value
c   corresponding to x(k) ).
c
c   p is the period (p .gt. x(n)-x(1)).
c
c   d is a parameter containing the observation weights.
c   this may either be an array of length n or a scalar
c   (interpreted as a constant). the value of d
c   corresponding to the observation (x(k),y(k)) should
c   be an approximation to the standard deviation of error.
c
c   isw contains a switch indicating whether the parameter
c   d is to be considered a vector or a scalar,
c          = 0 if d is an array of length n,
c          = 1 if d is a scalar.
c
c   s contains the value controlling the smoothing. this
c   must be non-negative. for s equal to zero, the
c   subroutine does interpolation, larger values lead to
c   smoother funtions. if parameter d contains standard
c   deviation estimates, a reasonable value for s is
c   float(n).
c
c   eps contains a tolerance on the relative precision to
c   which s is to be interpreted. this must be greater than
c   or equal to zero and less than equal or equal to one. a
c   reasonable value for eps is sqrt(2./float(n)).
c
c   ys is an array of length at least n.
c
c   ysp is an array of length at least n.
c
c   sigma contains the tension factor. this value indicates
c   the degree to which the first derivative part of the
c   smoothing functional is emphasized. if sigma is nearly
c   zero (e. g. .001) the resulting curve is approximately a
c   cubic spline. if sigma is large (e. g. 50.) the
c   resulting curve is nearly a polygonal line. if sigma
c   equals zero a cubic spline results. a standard value for
c   sigma is approximately 1.
c
c and
c
c   td, tsd1, hd, hsd1, hsd2, rd, rsd1, rsd2, rnm1, rn, and
c   v are arrays of length at least n which are used for
c   scratch storage.
c
c on output--
c
c   ys contains the smoothed ordinate values.
c
c   ysp contains the values of the second derivative of the
c   smoothed curve at the given nodes.
c
c   ierr contains an error flag,
c        = 0 for normal return,
c        = 1 if n is less than 2,
c        = 2 if s is negative,
c        = 3 if eps is negative or greater than one,
c        = 4 if x-values are not strictly increasing,
c        = 5 if a d-value is non-positive,
c        = 6 if p is less than or equal to x(n)-x(1).
c
c and
c
c   n, x, y, d, isw, s, eps, and sigma are unaltered.
c
c this subroutine references package modules ftstore, terms,
c and snhcsh.
c
c-----------------------------------------------------------
c
      if (n .lt. 2) go to 25
      if (s .lt. 0.) go to 26
      if (eps .lt. 0. .or. eps .gt. 1.) go to 27
      if (p .le. x(n)-x(1)) go to 30
      ierr = 0
      q = 0.
      rsd1(1) = 0.
      rsd2(1) = 0.
      rsd2(2) = 0.
      rsd1(n-1) = 0.
      rsd2(n-1) = 0.
      rsd2(n) = 0.
c
c denormalize tension factor
c
      sigmap = abs(sigma)*float(n)/p
c
c form t matrix and second differences of y into ys
c
      nm1 = n-1
      nm2 = n-2
      nm3 = n-3
      delxi1 = x(1)+p-x(n)
      delyi1 = (y(1)-y(n))/delxi1
      call terms (dim1,tsd1(1),sigmap,delxi1)
      hsd1(1) = 1./delxi1
      do 1 i = 1,n
        ip1 = i+1
        if (i .eq. n) ip1 = 1
        delxi = x(ip1)-x(i)
        if (i .eq. n) delxi = x(1)+p-x(n)
        if (delxi .le. 0.) go to 28
        delyi = (y(ip1)-y(i))/delxi
        ys(i) = delyi-delyi1
        call terms (di,tsd1(ip1),sigmap,delxi)
        td(i) = di+dim1
        hd(i) = -(1./delxi+1./delxi1)
        hsd1(ip1) = 1./delxi
        delxi1 = delxi
        delyi1 = delyi
    1   dim1 = di
      hsd11 = hsd1(1)
      if (n .ge. 3) go to 2
      tsd1(2) = tsd1(1)+tsd1(2)
      tsd1(1) = 0.
      hsd1(2) = hsd1(1)+hsd1(2)
      hsd1(1) = 0.
c
c calculate lower and upper tolerances
c
    2 sl = s*(1.-eps)
      su = s*(1.+eps)
      if (d(1) .le. 0.) go to 29
      if (isw .eq. 1) go to 5
c
c form h matrix - d array
c
      betapp = hsd1(n)*d(n)*d(n)
      betap = hsd1(1)*d(1)*d(1)
      alphap = hd(n)*d(n)*d(n)
      im1 = n
      sumd = 0.
      sumy = 0.
      do 3 i = 1,n
        disq = d(i)*d(i)
        sumd = sumd+1./disq
        sumy = sumy+y(i)/disq
        ip1 = i+1
        if (i .eq. n) ip1 = 1
        alpha = hd(i)*disq
        if (d(ip1) .le. 0.) go to 29
        hsd1ip = hsd1(ip1)
        if (i .eq. n) hsd1ip = hsd11
        beta = hsd1ip*d(ip1)*d(ip1)
        hd(i) = (hsd1(i)*d(im1))**2+alpha*hd(i)
     *                             +beta*hsd1ip
        hsd2(i) = hsd1(i)*betapp
        hsd1(i) = hsd1(i)*(alpha+alphap)
        im1 = i
        alphap = alpha
        betapp = betap
    3   betap = beta
      if (n .eq. 3) hsd1(3) = hsd1(3)+hsd2(2)
c
c test for straight line fit
c
      con = sumy/sumd
      sum = 0.
      do 4 i = 1,n
    4   sum = sum+((y(i)-con)/d(i))**2
      if (sum .le. su) go to 23
      go to 8
c
c form h matrix - d constant
c
    5 sl = d(1)*d(1)*sl
      su = d(1)*d(1)*su
      hsd1p = hsd1(n)
      hdim1 = hd(n)
      sumy = 0.
      do 6 i = 1,n
        sumy = sumy+y(i)
        hsd1ip = hsd11
        if (i .lt. n) hsd1ip = hsd1(i+1)
        hdi = hd(i)
        hd(i) = hsd1(i)*hsd1(i)+hdi*hdi+hsd1ip*hsd1ip
        hsd2(i) = hsd1(i)*hsd1p
        hsd1p = hsd1(i)
        hsd1(i) = hsd1p*(hdi+hdim1)
    6   hdim1 = hdi
      if (n .eq. 3) hsd1(3) = hsd1(3)+hsd2(2)
c
c test for straight line fit
c
      con = sumy/float(n)
      sum = 0.
      do 7 i = 1,n
    7   sum = sum+(y(i)-con)**2
      if (sum .le. su) go to 23
c
c top of iteration
c cholesky factorization of q*t+h into r
c
c
c i = 1
c
    8 rd(1) = 1./(q*td(1)+hd(1))
      rnm1(1) = hsd2(1)
      yspnm1 = ys(nm1)
      rn(1) = q*tsd1(1)+hsd1(1)
      yspn = ys(n)
      ysp(1) = ys(1)
      rsd1i = q*tsd1(2)+hsd1(2)
      rsd1(2) = rsd1i*rd(1)
      sumnm1 = 0.
      sum2 = 0.
      sumn = 0.
      if (n .eq. 3) go to 11
      if (n .eq. 2) go to 12
c
c i = 2
c
      rd(2) = 1./(q*td(2)+hd(2)-rsd1i*rsd1(2))
      rnm1(2) = -rnm1(1)*rsd1(2)
      rn(2) = hsd2(2)-rn(1)*rsd1(2)
      ysp(2) = ys(2)-rsd1(2)*ysp(1)
      if (n .eq. 4) go to 10
      do 9 i = 3,nm2
        rsd2i = hsd2(i)
        rsd1i = q*tsd1(i)+hsd1(i)-rsd2i*rsd1(i-1)
        rsd2(i) = rsd2i*rd(i-2)
        rsd1(i) = rsd1i*rd(i-1)
        rd(i) = 1./(q*td(i)+hd(i)-rsd1i*rsd1(i)
     *                           -rsd2i*rsd2(i))
        rnm1(i) = -rnm1(i-2)*rsd2(i)-rnm1(i-1)*rsd1(i)
        rnm1t = rnm1(i-2)*rd(i-2)
        sumnm1 = sumnm1+rnm1t*rnm1(i-2)
        rnm1(i-2) = rnm1t
        sum2 = sum2+rnm1t*rn(i-2)
        yspnm1 = yspnm1-rnm1t*ysp(i-2)
        rn(i) = -rn(i-2)*rsd2(i)-rn(i-1)*rsd1(i)
        rnt = rn(i-2)*rd(i-2)
        sumn = sumn+rnt*rn(i-2)
        rn(i-2) = rnt
        yspn = yspn-rnt*ysp(i-2)
    9   ysp(i) = ys(i)-rsd1(i)*ysp(i-1)-rsd2(i)*ysp(i-2)
c
c i = n-3
c
   10 rnm1(nm3) = hsd2(nm1)+rnm1(nm3)
      rnm1(nm2) = rnm1(nm2)-hsd2(nm1)*rsd1(nm2)
      rnm1t = rnm1(nm3)*rd(nm3)
      sumnm1 = sumnm1+rnm1t*rnm1(nm3)
      rnm1(nm3) = rnm1t
      sum2 = sum2+rnm1t*rn(nm3)
      yspnm1 = yspnm1-rnm1t*ysp(nm3)
      rnt = rn(nm3)*rd(nm3)
      sumn = sumn+rnt*rn(nm3)
      rn(nm3) = rnt
      yspn = yspn-rnt*ysp(nm3)
c
c i = n-2
c
   11 rnm1(nm2) = q*tsd1(nm1)+hsd1(nm1)+rnm1(nm2)
      rnm1t = rnm1(nm2)*rd(nm2)
      sumnm1 = sumnm1+rnm1t*rnm1(nm2)
      rnm1(nm2) = rnm1t
      rn(nm2) = hsd2(n)+rn(nm2)
      sum2 = sum2+rnm1t*rn(nm2)
      yspnm1 = yspnm1-rnm1t*ysp(nm2)
      rnt = rn(nm2)*rd(nm2)
      sumn = sumn+rnt*rn(nm2)
      rn(nm2) = rnt
      yspn = yspn-rnt*ysp(nm2)
c
c i = n-1
c
   12 rd(nm1) = 1./(q*td(nm1)+hd(nm1)-sumnm1)
      ysp(nm1) = yspnm1
      rn(nm1) = q*tsd1(n)+hsd1(n)-sum2
      rnt = rn(nm1)*rd(nm1)
      sumn = sumn+rnt*rn(nm1)
      rn(nm1) = rnt
      yspn = yspn-rnt*ysp(nm1)
c
c i = n
c
      rdn = q*td(n)+hd(n)-sumn
      rd(n) = 0.
c
c Modified test based on communication with Alan Cline, 21-May-2002.
c Problems with the original test (rdn .gt. 0.) surfaced in a demo
c example run on a Linux system.
c
      if (rdn .gt. 0. .and. q .ne. 0.) rd(n) = 1./rdn
      ysp(n) = yspn
c
c back solve of r(transpose)* r * ysp = ys
c
      ysp(n) = rd(n)*ysp(n)
      ysp(nm1) = rd(nm1)*ysp(nm1)-rn(nm1)*ysp(n)
      if (n .eq. 2) go to 14
      yspn = ysp(n)
      yspnm1 = ysp(nm1)
      do 13 ibak = 1,nm2
        i = nm1-ibak
   13   ysp(i) = rd(i)*ysp(i)-rsd1(i+1)*ysp(i+1)
     *                  -rsd2(i+2)*ysp(i+2)-rnm1(i)*yspnm1
     *                  -rn(i)*yspn
   14 sum = 0.
      delyi1 = (ysp(1)-ysp(n))/(x(1)+p-x(n))
      if (isw .eq. 1) go to 16
c
c calculation of residual norm
c  - d array
c
      do 15 i = 1,nm1
        delyi = (ysp(i+1)-ysp(i))/(x(i+1)-x(i))
        v(i) = (delyi-delyi1)*d(i)*d(i)
        sum = sum+v(i)*(delyi-delyi1)
   15   delyi1 = delyi
      delyi = (ysp(1)-ysp(n))/(x(1)+p-x(n))
      v(n) = (delyi-delyi1)*d(n)*d(n)
      go to 18
c
c calculation of residual norm
c  - d constant
c
   16 do 17 i = 1,nm1
        delyi = (ysp(i+1)-ysp(i))/(x(i+1)-x(i))
        v(i) = delyi-delyi1
        sum = sum+v(i)*(delyi-delyi1)
   17   delyi1 = delyi
      delyi = (ysp(1)-ysp(n))/(x(1)+p-x(n))
      v(n) = delyi-delyi1
   18   sum = sum+v(n)*(delyi-delyi1)
c
c test for convergence
c
      if (sum .le. su) go to 21
c
c calculation of newton correction
c
      f = 0.
      g = 0.
      rnm1sm = 0.
      rnsm = 0.
      im1 = n
      if (n .eq. 2) go to 20
      wim2 = 0.
      wim1 = 0.
      do 19 i = 1,nm2
        tui = tsd1(i)*ysp(im1)+td(i)*ysp(i)
     *                        +tsd1(i+1)*ysp(i+1)
        wi = tui-rsd1(i)*wim1-rsd2(i)*wim2
        rnm1sm = rnm1sm-rnm1(i)*wi
        rnsm = rnsm-rn(i)*wi
        f = f+tui*ysp(i)
        g = g+wi*wi*rd(i)
        im1 = i
        wim2 = wim1
   19   wim1 = wi
   20 tui = tsd1(nm1)*ysp(im1)+td(nm1)*ysp(nm1)
     *      +tsd1(n)*ysp(n)
      wi = tui+rnm1sm
      f = f+tui*ysp(nm1)
      g = g+wi*wi*rd(nm1)
      tui = tsd1(n)*ysp(nm1)+td(n)*ysp(n)
     *      +tsd1(1)*ysp(1)
      wi = tui+rnsm-rn(nm1)*wi
      f = f+tui*ysp(n)
      g = g+wi*wi*rd(n)
      h = f-q*g
      if (h .le. 0.) go to 21
c
c update q - newton step
c
      step = (sum-sqrt(sum*sl))/h
      if (sl .ne. 0.) step = step*sqrt(sum/sl)
      if (ftstore(q+step) .eq. q) go to 21
      q = q+step
      go to 8
c
c store smoothed y-values and second derivatives
c
   21 do 22 i = 1,n
        ys(i) = y(i)-v(i)
   22   ysp(i) = q*ysp(i)
      return
c
c store constant ys and zero ysp
c
   23 do 24 i = 1,n
        ys(i) = con
   24   ysp(i) = 0.
      return
c
c n less than 2
c
   25 ierr = 1
      return
c
c s negative
c
   26 ierr = 2
      return
c
c eps negative or greater than 1
c
   27 ierr = 3
      return
c
c x-values not strictly increasing
c
   28 ierr = 4
      return
c
c weight non-positive
c
   29 ierr = 5
      return
c
c incorrect period
c
   30 ierr = 6
      return
      end

C
C $Id: slgclr.f,v 1.4 2008-07-27 00:17:26 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE SLGCLR (ICLR,FRED,FGRN,FBLU)
C
C Given a color index ICLR, SLGCLR returns to the caller the RGB
C components of the color that STITLE associates with that index.
C
C The common block SLCOMN holds all of the internal parameters of
C the package STITLE except for color-table parameters.
C
        COMMON /SLCOMN/ GPSZ,IBGC,IBGF,ICOP,IDOT,IFGC,IFGF,IJMP,IMAP,
     +                  INCU,IWLU,IWRK,IWWI,IXND,IXST,OORV,PCSZ,RNFS,
     +                  RVPB,RVPL,RVPR,RVPT,TFIN,TFOU,TGP1,TGP2,TGP3
        SAVE   /SLCOMN/
C
C The common block SLCLRS holds color-table parameters.
C
        COMMON /SLCLRS/ CRED(256),CGRN(256),CBLU(256),LOCI(256),NOCI
        SAVE   /SLCLRS/
C
C If it wasn't done yet, get the ID of the first active workstation.
C
        IF (IWRK.LT.0) THEN
          CALL SLGWID
          IF (ICFELL('SLGCLR',1).NE.0) RETURN
        END IF
C
C Look for the color index in the current list of color indices.  If
C it's there, just return the RGB components associated with it.
C
        DO 101 I=1,NOCI
          IF (LOCI(I).EQ.ICLR) THEN
            FRED=CRED(I)
            FGRN=CGRN(I)
            FBLU=CBLU(I)
            RETURN
          END IF
  101   CONTINUE
C
C The desired color index is not in the current list.  If the list is
C not full, create an entry for the color index and initialize the RGB
C components associated with it, using values returned by GQCR.  If
C GQCR doesn't return good values, use all 0s for color index 0 and
C all 1s for any other color index.  In any case, return the desired
C RGB components to the caller.
C
        IF (NOCI.LT.256) THEN
          NOCI=NOCI+1
          LOCI(NOCI)=ICLR
          CALL GQCR (IWRK,ICLR,0,IERR,FRED,FGRN,FBLU)
          IF (IERR.NE.0) THEN
            FRED=REAL(MAX(0,MIN(1,ICLR)))
            FGRN=REAL(MAX(0,MIN(1,ICLR)))
            FBLU=REAL(MAX(0,MIN(1,ICLR)))
          END IF
          CRED(NOCI)=FRED
          CGRN(NOCI)=FGRN
          CBLU(NOCI)=FBLU
        ELSE
          CALL SETER ('SLGCLR - TOO MANY COLORS DEFINED',2,1)
          RETURN
        END IF
C
C Done.
C
        RETURN
C
      END

      SUBROUTINE ZHEEVR( JOBZ, RANGE, UPLO, N, A, LDA, VL, VU, IL, IU,
     $                   ABSTOL, M, W, Z, LDZ, ISUPPZ, WORK, LWORK,
     $                   RWORK, LRWORK, IWORK, LIWORK, INFO )
*
*  -- LAPACK driver routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     March 20, 2000
*
*     .. Scalar Arguments ..
      CHARACTER          JOBZ, RANGE, UPLO
      INTEGER            IL, INFO, IU, LDA, LDZ, LIWORK, LRWORK, LWORK,
     $                   M, N
      DOUBLE PRECISION   ABSTOL, VL, VU
*     ..
*     .. Array Arguments ..
      INTEGER            ISUPPZ( * ), IWORK( * )
      DOUBLE PRECISION   RWORK( * ), W( * )
      COMPLEX*16         A( LDA, * ), WORK( * ), Z( LDZ, * )
*     ..
*
*  Purpose
*  =======
*
*  ZHEEVR computes selected eigenvalues and, optionally, eigenvectors
*  of a complex Hermitian matrix T.  Eigenvalues and eigenvectors can
*  be selected by specifying either a range of values or a range of
*  indices for the desired eigenvalues.
*
*  Whenever possible, ZHEEVR calls ZSTEGR to compute the
*  eigenspectrum using Relatively Robust Representations.  ZSTEGR
*  computes eigenvalues by the dqds algorithm, while orthogonal
*  eigenvectors are computed from various "good" L D L^T representations
*  (also known as Relatively Robust Representations). Gram-Schmidt
*  orthogonalization is avoided as far as possible. More specifically,
*  the various steps of the algorithm are as follows. For the i-th
*  unreduced block of T,
*     (a) Compute T - sigma_i = L_i D_i L_i^T, such that L_i D_i L_i^T
*          is a relatively robust representation,
*     (b) Compute the eigenvalues, lambda_j, of L_i D_i L_i^T to high
*         relative accuracy by the dqds algorithm,
*     (c) If there is a cluster of close eigenvalues, "choose" sigma_i
*         close to the cluster, and go to step (a),
*     (d) Given the approximate eigenvalue lambda_j of L_i D_i L_i^T,
*         compute the corresponding eigenvector by forming a
*         rank-revealing twisted factorization.
*  The desired accuracy of the output can be specified by the input
*  parameter ABSTOL.
*
*  For more details, see "A new O(n^2) algorithm for the symmetric
*  tridiagonal eigenvalue/eigenvector problem", by Inderjit Dhillon,
*  Computer Science Division Technical Report No. UCB//CSD-97-971,
*  UC Berkeley, May 1997.
*
*
*  Note 1 : ZHEEVR calls ZSTEGR when the full spectrum is requested
*  on machines which conform to the ieee-754 floating point standard.
*  ZHEEVR calls DSTEBZ and ZSTEIN on non-ieee machines and
*  when partial spectrum requests are made.
*
*  Normal execution of ZSTEGR may create NaNs and infinities and
*  hence may abort due to a floating point exception in environments
*  which do not handle NaNs and infinities in the ieee standard default
*  manner.
*
*  Arguments
*  =========
*
*  JOBZ    (input) CHARACTER*1
*          = 'N':  Compute eigenvalues only;
*          = 'V':  Compute eigenvalues and eigenvectors.
*
*  RANGE   (input) CHARACTER*1
*          = 'A': all eigenvalues will be found.
*          = 'V': all eigenvalues in the half-open interval (VL,VU]
*                 will be found.
*          = 'I': the IL-th through IU-th eigenvalues will be found.
********** For RANGE = 'V' or 'I' and IU - IL < N - 1, DSTEBZ and
********** ZSTEIN are called
*
*  UPLO    (input) CHARACTER*1
*          = 'U':  Upper triangle of A is stored;
*          = 'L':  Lower triangle of A is stored.
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  A       (input/output) COMPLEX*16 array, dimension (LDA, N)
*          On entry, the Hermitian matrix A.  If UPLO = 'U', the
*          leading N-by-N upper triangular part of A contains the
*          upper triangular part of the matrix A.  If UPLO = 'L',
*          the leading N-by-N lower triangular part of A contains
*          the lower triangular part of the matrix A.
*          On exit, the lower triangle (if UPLO='L') or the upper
*          triangle (if UPLO='U') of A, including the diagonal, is
*          destroyed.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(1,N).
*
*  VL      (input) DOUBLE PRECISION
*  VU      (input) DOUBLE PRECISION
*          If RANGE='V', the lower and upper bounds of the interval to
*          be searched for eigenvalues. VL < VU.
*          Not referenced if RANGE = 'A' or 'I'.
*
*  IL      (input) INTEGER
*  IU      (input) INTEGER
*          If RANGE='I', the indices (in ascending order) of the
*          smallest and largest eigenvalues to be returned.
*          1 <= IL <= IU <= N, if N > 0; IL = 1 and IU = 0 if N = 0.
*          Not referenced if RANGE = 'A' or 'V'.
*
*  ABSTOL  (input) DOUBLE PRECISION
*          The absolute error tolerance for the eigenvalues.
*          An approximate eigenvalue is accepted as converged
*          when it is determined to lie in an interval [a,b]
*          of width less than or equal to
*
*                  ABSTOL + EPS *   max( |a|,|b| ) ,
*
*          where EPS is the machine precision.  If ABSTOL is less than
*          or equal to zero, then  EPS*|T|  will be used in its place,
*          where |T| is the 1-norm of the tridiagonal matrix obtained
*          by reducing A to tridiagonal form.
*
*          See "Computing Small Singular Values of Bidiagonal Matrices
*          with Guaranteed High Relative Accuracy," by Demmel and
*          Kahan, LAPACK Working Note #3.
*
*          If high relative accuracy is important, set ABSTOL to
*          DLAMCH( 'Safe minimum' ).  Doing so will guarantee that
*          eigenvalues are computed to high relative accuracy when
*          possible in future releases.  The current code does not
*          make any guarantees about high relative accuracy, but
*          furutre releases will. See J. Barlow and J. Demmel,
*          "Computing Accurate Eigensystems of Scaled Diagonally
*          Dominant Matrices", LAPACK Working Note #7, for a discussion
*          of which matrices define their eigenvalues to high relative
*          accuracy.
*
*  M       (output) INTEGER
*          The total number of eigenvalues found.  0 <= M <= N.
*          If RANGE = 'A', M = N, and if RANGE = 'I', M = IU-IL+1.
*
*  W       (output) DOUBLE PRECISION array, dimension (N)
*          The first M elements contain the selected eigenvalues in
*          ascending order.
*
*  Z       (output) COMPLEX*16 array, dimension (LDZ, max(1,M))
*          If JOBZ = 'V', then if INFO = 0, the first M columns of Z
*          contain the orthonormal eigenvectors of the matrix A
*          corresponding to the selected eigenvalues, with the i-th
*          column of Z holding the eigenvector associated with W(i).
*          If JOBZ = 'N', then Z is not referenced.
*          Note: the user must ensure that at least max(1,M) columns are
*          supplied in the array Z; if RANGE = 'V', the exact value of M
*          is not known in advance and an upper bound must be used.
*
*  LDZ     (input) INTEGER
*          The leading dimension of the array Z.  LDZ >= 1, and if
*          JOBZ = 'V', LDZ >= max(1,N).
*
*  ISUPPZ  (output) INTEGER ARRAY, dimension ( 2*max(1,M) )
*          The support of the eigenvectors in Z, i.e., the indices
*          indicating the nonzero elements in Z. The i-th eigenvector
*          is nonzero only in elements ISUPPZ( 2*i-1 ) through
*          ISUPPZ( 2*i ).
********** Implemented only for RANGE = 'A' or 'I' and IU - IL = N - 1
*
*  WORK    (workspace/output) COMPLEX*16 array, dimension (LWORK)
*          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*
*  LWORK   (input) INTEGER
*          The length of the array WORK.  LWORK >= max(1,2*N).
*          For optimal efficiency, LWORK >= (NB+1)*N,
*          where NB is the max of the blocksize for ZHETRD and for
*          ZUNMTR as returned by ILAENV.
*
*          If LWORK = -1, then a workspace query is assumed; the routine
*          only calculates the optimal size of the WORK array, returns
*          this value as the first entry of the WORK array, and no error
*          message related to LWORK is issued by XERBLA.
*
*  RWORK   (workspace/output) DOUBLE PRECISION array, dimension (LRWORK)
*          On exit, if INFO = 0, RWORK(1) returns the optimal
*          (and minimal) LRWORK.
*
* LRWORK  (input) INTEGER
*         The length of the array RWORK.  LRWORK >= max(1,24*N).
*
*         If LRWORK = -1, then a workspace query is assumed; the routine
*         only calculates the optimal size of the RWORK array, returns
*         this value as the first entry of the RWORK array, and no error
*         message related to LRWORK is issued by XERBLA.
*
*  IWORK   (workspace/output) INTEGER array, dimension (LIWORK)
*          On exit, if INFO = 0, IWORK(1) returns the optimal
*          (and minimal) LIWORK.
*
* LIWORK  (input) INTEGER
*         The dimension of the array IWORK.  LIWORK >= max(1,10*N).
*
*         If LIWORK = -1, then a workspace query is assumed; the
*         routine only calculates the optimal size of the IWORK array,
*         returns this value as the first entry of the IWORK array, and
*         no error message related to LIWORK is issued by XERBLA.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*          > 0:  Internal error
*
*  Further Details
*  ===============
*
*  Based on contributions by
*     Inderjit Dhillon, IBM Almaden, USA
*     Osni Marques, LBNL/NERSC, USA
*     Ken Stanley, Computer Science Division, University of
*       California at Berkeley, USA
*
* =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO, ONE
      PARAMETER          ( ZERO = 0.0D+0, ONE = 1.0D+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            ALLEIG, INDEIG, LOWER, LQUERY, VALEIG, WANTZ
      CHARACTER          ORDER
      INTEGER            I, IEEEOK, IINFO, IMAX, INDIBL, INDIFL, INDISP,
     $                   INDIWO, INDRD, INDRDD, INDRE, INDREE, INDRWK,
     $                   INDTAU, INDWK, INDWKN, ISCALE, ITMP1, J, JJ,
     $                   LIWMIN, LLWORK, LLWRKN, LRWMIN, LWKOPT, LWMIN,
     $                   NB, NSPLIT
      DOUBLE PRECISION   ABSTLL, ANRM, BIGNUM, EPS, RMAX, RMIN, SAFMIN,
     $                   SIGMA, SMLNUM, TMP1, VLL, VUU
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            ILAENV
      DOUBLE PRECISION   DLAMCH, ZLANSY
      EXTERNAL           LSAME, ILAENV, DLAMCH, ZLANSY
*     ..
*     .. External Subroutines ..
      EXTERNAL           DCOPY, DSCAL, DSTEBZ, DSTERF, XERBLA, ZDSCAL,
     $                   ZHETRD, ZSTEGR, ZSTEIN, ZSWAP, ZUNMTR
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          DBLE, MAX, MIN, SQRT
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      IEEEOK = ILAENV( 10, 'ZHEEVR', 'N', 1, 2, 3, 4 )
*
      LOWER = LSAME( UPLO, 'L' )
      WANTZ = LSAME( JOBZ, 'V' )
      ALLEIG = LSAME( RANGE, 'A' )
      VALEIG = LSAME( RANGE, 'V' )
      INDEIG = LSAME( RANGE, 'I' )
*
      LQUERY = ( ( LWORK.EQ.-1 ) .OR. ( LRWORK.EQ.-1 ) .OR.
     $         ( LIWORK.EQ.-1 ) )
*
      LRWMIN = MAX( 1, 24*N )
      LIWMIN = MAX( 1, 10*N )
      LWMIN = MAX( 1, 2*N )
*
      INFO = 0
      IF( .NOT.( WANTZ .OR. LSAME( JOBZ, 'N' ) ) ) THEN
         INFO = -1
      ELSE IF( .NOT.( ALLEIG .OR. VALEIG .OR. INDEIG ) ) THEN
         INFO = -2
      ELSE IF( .NOT.( LOWER .OR. LSAME( UPLO, 'U' ) ) ) THEN
         INFO = -3
      ELSE IF( N.LT.0 ) THEN
         INFO = -4
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -6
      ELSE
         IF( VALEIG ) THEN
            IF( N.GT.0 .AND. VU.LE.VL )
     $         INFO = -8
         ELSE IF( INDEIG ) THEN
            IF( IL.LT.1 .OR. IL.GT.MAX( 1, N ) ) THEN
               INFO = -9
            ELSE IF( IU.LT.MIN( N, IL ) .OR. IU.GT.N ) THEN
               INFO = -10
            END IF
         END IF
      END IF
      IF( INFO.EQ.0 ) THEN
         IF( LDZ.LT.1 .OR. ( WANTZ .AND. LDZ.LT.N ) ) THEN
            INFO = -15
         ELSE IF( LWORK.LT.LWMIN .AND. .NOT.LQUERY ) THEN
            INFO = -18
         ELSE IF( LRWORK.LT.LRWMIN .AND. .NOT.LQUERY ) THEN
            INFO = -20
         ELSE IF( LIWORK.LT.LIWMIN .AND. .NOT.LQUERY ) THEN
            INFO = -22
         END IF
      END IF
*
      IF( INFO.EQ.0 ) THEN
         NB = ILAENV( 1, 'ZHETRD', UPLO, N, -1, -1, -1 )
         NB = MAX( NB, ILAENV( 1, 'ZUNMTR', UPLO, N, -1, -1, -1 ) )
         LWKOPT = MAX( ( NB+1 )*N, LWMIN )
         WORK( 1 ) = LWKOPT
         RWORK( 1 ) = LRWMIN
         IWORK( 1 ) = LIWMIN
      END IF
*
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'ZHEEVR', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         RETURN
      END IF
*
*     Quick return if possible
*
      M = 0
      IF( N.EQ.0 ) THEN
         WORK( 1 ) = 1
         RETURN
      END IF
*
      IF( N.EQ.1 ) THEN
         WORK( 1 ) = 7
         IF( ALLEIG .OR. INDEIG ) THEN
            M = 1
            W( 1 ) = DBLE( A( 1, 1 ) )
         ELSE
            IF( VL.LT.DBLE( A( 1, 1 ) ) .AND. VU.GE.DBLE( A( 1, 1 ) ) )
     $           THEN
               M = 1
               W( 1 ) = DBLE( A( 1, 1 ) )
            END IF
         END IF
         IF( WANTZ )
     $      Z( 1, 1 ) = ONE
         RETURN
      END IF
*
*     Get machine constants.
*
      SAFMIN = DLAMCH( 'Safe minimum' )
      EPS = DLAMCH( 'Precision' )
      SMLNUM = SAFMIN / EPS
      BIGNUM = ONE / SMLNUM
      RMIN = SQRT( SMLNUM )
      RMAX = MIN( SQRT( BIGNUM ), ONE / SQRT( SQRT( SAFMIN ) ) )
*
*     Scale matrix to allowable range, if necessary.
*
      ISCALE = 0
      ABSTLL = ABSTOL
      VLL = VL
      VUU = VU
      ANRM = ZLANSY( 'M', UPLO, N, A, LDA, RWORK )
      IF( ANRM.GT.ZERO .AND. ANRM.LT.RMIN ) THEN
         ISCALE = 1
         SIGMA = RMIN / ANRM
      ELSE IF( ANRM.GT.RMAX ) THEN
         ISCALE = 1
         SIGMA = RMAX / ANRM
      END IF
      IF( ISCALE.EQ.1 ) THEN
         IF( LOWER ) THEN
            DO 10 J = 1, N
               CALL ZDSCAL( N-J+1, SIGMA, A( J, J ), 1 )
   10       CONTINUE
         ELSE
            DO 20 J = 1, N
               CALL ZDSCAL( J, SIGMA, A( 1, J ), 1 )
   20       CONTINUE
         END IF
         IF( ABSTOL.GT.0 )
     $      ABSTLL = ABSTOL*SIGMA
         IF( VALEIG ) THEN
            VLL = VL*SIGMA
            VUU = VU*SIGMA
         END IF
      END IF
*
*     Call ZHETRD to reduce Hermitian matrix to tridiagonal form.
*
      INDTAU = 1
      INDWK = INDTAU + N
*
      INDRE = 1
      INDRD = INDRE + N
      INDREE = INDRD + N
      INDRDD = INDREE + N
      INDRWK = INDRDD + N
      LLWORK = LWORK - INDWK + 1
      CALL ZHETRD( UPLO, N, A, LDA, RWORK( INDRD ), RWORK( INDRE ),
     $             WORK( INDTAU ), WORK( INDWK ), LLWORK, IINFO )
*
*     If all eigenvalues are desired
*     then call DSTERF or ZSTEGR and ZUNMTR.
*
      IF( ( ALLEIG .OR. ( INDEIG .AND. IL.EQ.1 .AND. IU.EQ.N ) ) .AND.
     $    IEEEOK.EQ.1 ) THEN
         IF( .NOT.WANTZ ) THEN
            CALL DCOPY( N, RWORK( INDRD ), 1, W, 1 )
            CALL DCOPY( N-1, RWORK( INDRE ), 1, RWORK( INDREE ), 1 )
            CALL DSTERF( N, W, RWORK( INDREE ), INFO )
         ELSE
            CALL DCOPY( N-1, RWORK( INDRE ), 1, RWORK( INDREE ), 1 )
            CALL DCOPY( N, RWORK( INDRD ), 1, RWORK( INDRDD ), 1 )
*
            CALL ZSTEGR( JOBZ, 'A', N, RWORK( INDRDD ),
     $                   RWORK( INDREE ), VL, VU, IL, IU, ABSTOL, M, W,
     $                   Z, LDZ, ISUPPZ, RWORK( INDRWK ), LWORK, IWORK,
     $                   LIWORK, INFO )
*
*
*
*        Apply unitary matrix used in reduction to tridiagonal
*        form to eigenvectors returned by ZSTEIN.
*
            IF( WANTZ .AND. INFO.EQ.0 ) THEN
               INDWKN = INDWK
               LLWRKN = LWORK - INDWKN + 1
               CALL ZUNMTR( 'L', UPLO, 'N', N, M, A, LDA,
     $                      WORK( INDTAU ), Z, LDZ, WORK( INDWKN ),
     $                      LLWRKN, IINFO )
            END IF
         END IF
*
*
         IF( INFO.EQ.0 ) THEN
            M = N
            GO TO 30
         END IF
         INFO = 0
      END IF
*
*     Otherwise, call DSTEBZ and, if eigenvectors are desired, ZSTEIN.
*     Also call DSTEBZ and ZSTEIN if CSTEGR fails.
*
      IF( WANTZ ) THEN
         ORDER = 'B'
      ELSE
         ORDER = 'E'
      END IF
      INDIFL = 1
      INDIBL = INDIFL + N
      INDISP = INDIBL + N
      INDIWO = INDISP + N
      CALL DSTEBZ( RANGE, ORDER, N, VLL, VUU, IL, IU, ABSTLL,
     $             RWORK( INDRD ), RWORK( INDRE ), M, NSPLIT, W,
     $             IWORK( INDIBL ), IWORK( INDISP ), RWORK( INDRWK ),
     $             IWORK( INDIWO ), INFO )
*
      IF( WANTZ ) THEN
         CALL ZSTEIN( N, RWORK( INDRD ), RWORK( INDRE ), M, W,
     $                IWORK( INDIBL ), IWORK( INDISP ), Z, LDZ,
     $                RWORK( INDRWK ), IWORK( INDIWO ), IWORK( INDIFL ),
     $                INFO )
*
*        Apply unitary matrix used in reduction to tridiagonal
*        form to eigenvectors returned by ZSTEIN.
*
         INDWKN = INDWK
         LLWRKN = LWORK - INDWKN + 1
         CALL ZUNMTR( 'L', UPLO, 'N', N, M, A, LDA, WORK( INDTAU ), Z,
     $                LDZ, WORK( INDWKN ), LLWRKN, IINFO )
      END IF
*
*     If matrix was scaled, then rescale eigenvalues appropriately.
*
   30 CONTINUE
      IF( ISCALE.EQ.1 ) THEN
         IF( INFO.EQ.0 ) THEN
            IMAX = M
         ELSE
            IMAX = INFO - 1
         END IF
         CALL DSCAL( IMAX, ONE / SIGMA, W, 1 )
      END IF
*
*     If eigenvalues are not in order, then sort them, along with
*     eigenvectors.
*
      IF( WANTZ ) THEN
         DO 50 J = 1, M - 1
            I = 0
            TMP1 = W( J )
            DO 40 JJ = J + 1, M
               IF( W( JJ ).LT.TMP1 ) THEN
                  I = JJ
                  TMP1 = W( JJ )
               END IF
   40       CONTINUE
*
            IF( I.NE.0 ) THEN
               ITMP1 = IWORK( INDIBL+I-1 )
               W( I ) = W( J )
               IWORK( INDIBL+I-1 ) = IWORK( INDIBL+J-1 )
               W( J ) = TMP1
               IWORK( INDIBL+J-1 ) = ITMP1
               CALL ZSWAP( N, Z( 1, I ), 1, Z( 1, J ), 1 )
            END IF
   50    CONTINUE
      END IF
*
*     Set WORK(1) to optimal workspace size.
*
      WORK( 1 ) = LWKOPT
      RWORK( 1 ) = LRWMIN
      IWORK( 1 ) = LIWMIN
*
      RETURN
*
*     End of ZHEEVR
*
      END

C
C $Id: tdctab.f,v 1.4 2008-07-27 00:17:32 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE TDCTAB (RTRI,MTRI,NTRI,UMIN,VMIN,WMIN,UMAX,VMAX,WMAX)
C
        DIMENSION RTRI(10,MTRI)
C
C This routine is called to clip the last triangle in the triangle list
C against the box defined by UMIN, VMIN, WMIN, UMAX, VMAX, and WMAX.
C
C First, save the number of triangles that we had on entry.
C
        NTRE=NTRI
C
C Clip the final triangle in the list against the plane U=UMIN.
C
        ITRI=NTRE
C
        CALL TDCTAP (RTRI,MTRI,NTRI,ITRI,-1., 0., 0., UMIN)
C
C Clip any resulting triangles against the planes U=UMAX, V=VMIN,
C V=VMAX, W=WMIN, and W=WMAX.  Note: DO loops cannot be used here
C because it is possible that TDCTAP may modify ITRI.
C
        ITRI=NTRE
C
  101   IF (ITRI.LE.NTRI) THEN
          CALL TDCTAP (RTRI,MTRI,NTRI,ITRI, 1., 0., 0.,-UMAX)
          ITRI=ITRI+1
          GO TO 101
        END IF
C
        ITRI=NTRE
C
  102   IF (ITRI.LE.NTRI) THEN
          CALL TDCTAP (RTRI,MTRI,NTRI,ITRI, 0.,-1., 0., VMIN)
          ITRI=ITRI+1
          GO TO 102
        END IF
C
        ITRI=NTRE
C
  103   IF (ITRI.LE.NTRI) THEN
          CALL TDCTAP (RTRI,MTRI,NTRI,ITRI, 0., 1., 0.,-VMAX)
          ITRI=ITRI+1
          GO TO 103
        END IF
C
        ITRI=NTRE
C
  104   IF (ITRI.LE.NTRI) THEN
          CALL TDCTAP (RTRI,MTRI,NTRI,ITRI, 0., 0.,-1., WMIN)
          ITRI=ITRI+1
          GO TO 104
        END IF
C
        ITRI=NTRE
C
  105   IF (ITRI.LE.NTRI) THEN
          CALL TDCTAP (RTRI,MTRI,NTRI,ITRI, 0., 0., 1.,-WMAX)
          ITRI=ITRI+1
          GO TO 105
        END IF
C
C Done.
C
        RETURN
C
      END

C NCLFORTSTART
      SUBROUTINE DZREGR1(N,M,M2,Y,YMSG,X,XMSG,C,RESID,CON,CNORM,WK,YY,
     +                   COV,XSD,XMEAN,A,AINV,S)
      IMPLICIT NONE
      INTEGER  N,M,M2
      DOUBLE PRECISION Y(N),X(N,M),C(M),CNORM(M),RESID(N),XMSG,YMSG,CON 
      DOUBLE PRECISION WK(M,M2)
      DOUBLE PRECISION YY(N),COV(M,M),XSD(M),XMEAN(M)
      DOUBLE PRECISION A(M,M),AINV(M,M),S(M)
C NCLEND

C NCL:    C = reg_multlin (y[*], x[*][*], opt)

C Nomenclature:
C .   C      - the raw partial correlation coef
C .   CNORM  - the standardized partial correlation coef
C
C The WK array used to be allocated inside the DZREGR2 subroutine,
C but this caused a problem for some compilers. The C wrapper for
C this function is now allocating this array and passing it in.
C Same issue for YY, COV, XSD, and XMEAN.
C
C ADJUSTABLE ARRAYS (LOCAL)  (the adj arrays were moved to the driver routine)
      INTEGER I,J,IERROR,NPTUSED,IER
      DOUBLE PRECISION VAR,YSD,YMEAN
      DATA   IERROR /1/

C IF ANY X HAS A MISSING VALUES THEN SET THE CORRESPONDING Y to YMSG
C .   THIS ELIMINATES ANY X/Y MISSING VALUES FROM THE COMPUTATIONS.

      DO I=1,N
         YY(I) = Y(I)
        DO J=1,M
           IF (X(I,J).EQ.XMSG) THEN
               YY(I) = YMSG
               GO TO 10
           END IF
        END DO
   10    CONTINUE
      END DO

C RESID ARE CALCULATED USING THE RAW PARTIAL REGRESSION COEF

      CALL DZREGR2(IERROR,N,M,M2,YY,YMSG,X,C,RESID,COV,WK,A,AINV,S)

C CALCULATE THE CONSTANT TERM
C .   CON = YMEAN - c(1)*XMEAN_1 - c(2)*XMEAN_2 - ... -c(J)*XMEAN_J
      
      CALL DSTAT2(YY,N,YMSG,YMEAN,VAR,YSD,NPTUSED,IER)

      CON  = YMEAN
      DO J = 1,M
          CALL DSTAT2(X(1,J),N,XMSG,XMEAN(J),VAR,XSD(J),NPTUSED,IER)
          CON       = CON - C(J)*XMEAN(J)
          CNORM(J)  = C(J)*XSD(J)/YSD  
      END DO

      RETURN
      END
C --------------------------------------------------------
      SUBROUTINE DZREGR2(IERROR,N,M,M2,T,TMSG,F,C,RESID,COV,WK,
     +                   A,AINV,S)
      IMPLICIT NONE
      INTEGER  IERROR,N,M,M2
      DOUBLE PRECISION T(N),F(N,M),C(M),RESID(N),COV(M,M),TMSG
      DOUBLE PRECISION WK(M,M2)
      DOUBLE PRECISION A(M,M),AINV(M,M),S(M)

C The modelled regession time series T(I) (I=1,2,...,N) is given by
C (see vector notation on the RIGHT):
C                           M
C                   T(I) = SUM C(J)*F(I,J)        <== T=FC         (1)
C                          J=1
C where C(J)=regression coefficient for J-th input surrogate time
C series F(I,J)
C
C Method: Least squares analysis applied to (1) yields the following
C linear matrix equation:
C                         AC = S                  <==> (F'F)C=F'T  (2)
C
C where C = model coefficient vector to be solved and S = data source
C vector.  It follows that
C                           N
C                   S(J) = SUM T(I)*F(I,J)        <== F'T          (3)
C                          I=1
C and                         N
C                   A(J,K) = SUM F(I,J)*F(I,K)    <== F'F          (4)
C                            I=1
C NOTE(s): The solution is (in vector notation):
C                               -1        -1
C                       C = (F'F)  F'T = A  S                      (5)
C
C The covariance matrix of the C coefficients is:
C                                     2    -1
C                          COV = sigma (F'F)                       (6)
C where
C                            2    1   N             2
C                       sigma  = --- SUM Residual(I)               (7)
C                                N-M I=1
C with Residual(I) being the original time series T(I) MINUS the time
C series T(I) modelled by (1) above.  Under the null hypothesis
C (all cross correlations between the coefficients are zero) that
C Var(T|F)=sigma**2 I, where I is the N X N unit matrix.
C
C Input Data:
C   IERROR = Error flag. If set to 1, standard error analysis is
C            performed for the coefficient vector C. Setting IERROR
C            to any other integer SKIPS this
C   N = Time series length
C   M = Number of surrogate series F applied in (1)
C   T(N) = measured time series being modelled

C   TMSG has replaced TMIN, TMAX for NCL reasons
C   TMIN,TMAX = Values of input series T that are less than TMIN
C          or greater than TMAX will NOT be included in the
C          regression (these are the flagging values)

C   F(N,M) = J-th (J=1,2,..,M) surrogate series, each of length N

C Output Data:
C   C(M) = solved coefficient vector
C   RESID(N) = Residual error time series (Original series T(I)
C              MINUS the modelled T(I) from (1) above)
C   COV(M,M) = Covariance matrix for coefficients C (SKIPPED if
C              IERROR is not equal to 1)
C EXAMPLE:
C      PARAMETER(IERROR=1,TMIN=-1.1,TMAX=1.1)
C      PARAMETER(N=20,M=7)
C      REAL T(N),F(N,M),WK(M,2*M),A(M,M),AINV(M,M),S(M),C(M),
C     & RESID(N),COV(M,M)
C
C      DO I=1,N
C        T(I)=COS(2.*I)
C        F(I,1)=1.0
C        F(I,2)=COS(2.05*I)
C        F(I,3)=SIN(0.4*I)
C        F(I,4)=COS(0.6*I)
C        F(I,5)=SIN(0.8*I)
C        F(I,6)=COS(0.3*I)
C        F(I,7)=SIN(0.9*I)
C      ENDDO
C      CALL ZREGR(IERROR,N,M,T,TMIN,TMAX,F,WK,A,AINV,S,C,RESID,COV)
C      WRITE(*,*)'I,T(I),T_model(I)'
C      DO I=1,N
C        WRITE(*,*) I,T(I),T(I)-RESID(I)
C      ENDDO
C
C      STOP
C      END
C
C Address questions/comments to:
C   Dr. Jerry Ziemke
C   NASA/Goddard Space Flight Center            PH: (301) 614-6034
C   Code 916                                   FAX: (301) 614-5903
C   Greenbelt, MD  20771
C   (Affil: UMBC GEST, Baltimore, MD)
C   e-mail: ziemke@jwocky.gsfc.nasa.gov
C
C Source is from:
C   http://code916.gsfc.nasa.gov/Data_services/cloud_slice/regress.html


C local ... some are adjustable arrays (had to move these to the driver routine)
      INTEGER NGOOD,I,J,K,L,IPRINT,ICHECK
      DOUBLE PRECISION U,SSUM,SIGSQR

      NGOOD = 0
      DO I = 1,N
C C C   IF ((T(I).GT.TMIN).AND.(T(I).LT.TMAX)) NGOOD=NGOOD+1
          IF (T(I).NE.TMSG) NGOOD = NGOOD + 1
      END DO

      DO J = 1,M
          S(J) = 0.D0
          DO I = 1,N
C C C     IF ((T(I).GT.TMIN).AND.(T(I).LT.TMAX)) THEN
              IF (T(I).NE.TMSG) THEN
C                                          ! <== S=F'T
                  S(J) = S(J) + T(I)*F(I,J)
              END IF
          END DO
      END DO

C     !Construct matrix A:
      DO K = 1,M
          DO J = 1,M
              A(J,K) = 0.D0
              DO I = 1,N
C C C       IF ((T(I).GT.TMIN).AND.(T(I).LT.TMAX)) THEN
                  IF (T(I).NE.TMSG) THEN
C                                         ! <== A=F'F
                      A(J,K) = A(J,K) + F(I,J)*F(I,K)
                  END IF
              END DO
          END DO
      END DO

C               ! ==> If 1, print out solution each CALL
      IPRINT = 0
C               ! ==> If 1, print out error analysis each CALL
      ICHECK = 0

C     !Solve for coef vector C:
      DO I = 1,M
          DO J = 1,M
              WK(I,J) = A(I,J)
          END DO
      END DO

      DO I = 1,M
          DO J = M + 1,2*M
              IF (M+I.EQ.J) THEN
                  WK(I,J) = 1.0D0
              ELSE
                  WK(I,J) = 0.0D0
              END IF
          END DO
      END DO

      DO K = 1,M
          DO I = 1,M
              IF (I.NE.K) THEN
                  IF (WK(K,K).EQ.0.0D0) THEN
                      L = 1
   30                 IF (WK(L,K).EQ.0.0D0) THEN
                          L = L + 1
                          GO TO 30
                      END IF
                      DO J = K,2*M
                          WK(K,J) = WK(K,J) + WK(L,J)
                      END DO
                  END IF
                  U = -WK(I,K)/WK(K,K)
                  DO J = K + 1,2*M
                      WK(I,J) = WK(I,J) + U*WK(K,J)
                  END DO
              END IF
          END DO
      END DO

      DO J = 1,M
          DO I = 1,M
              AINV(I,J) = WK(I,J+M)/WK(I,I)
          END DO
      END DO

      IF (IPRINT.EQ.1) THEN
          DO J = 1,M
              WRITE (*,FMT='(1X,A7,I3,A19)') 'Column ',J,
     +          ' of inverse matrix:'
              DO I = 1,M
                  WRITE (*,FMT=*) A(I,J)
              END DO
          END DO
      END IF

      IF (ICHECK.EQ.1) THEN
          WRITE (*,FMT=*)
     +      '-----------------------------------------------'
          WRITE (*,FMT=*) 'Simple error check by multiplying A by AINV:'
          WRITE (*,FMT=*)
     +      '(this should ideally yield the identity matrix)'
          DO J = 1,M
              WRITE (*,FMT='(1X,A7,I3,A27)') 'Column ',J,
     +          ' of product matrix A*AINV:'
              DO I = 1,M
                  SSUM = 0.0D0
                  DO K = 1,M
                      SSUM = SSUM + A(I,K)*AINV(K,J)
                  END DO
                  WRITE (*,FMT=*) SSUM
              END DO
          END DO
      END IF

C     !Coefficient vector solution:
      DO I = 1,M
          C(I) = 0.D0
          DO J = 1,M
              C(I) = C(I) + AINV(I,J)*S(J)
          END DO
      END DO

      IF (IERROR.EQ.1) THEN
          DO I = 1,N
C C C     IF ((T(I).GT.TMIN).AND.(T(I).LT.TMAX)) THEN
              IF (T(I).NE.TMSG) THEN
                  SSUM = 0.D0
                  DO J = 1,M
                      SSUM = SSUM + C(J)*F(I,J)
                  END DO
                  RESID(I) = T(I) - SSUM
              ELSE
                  RESID(I) = TMSG
              END IF
          END DO

          SSUM = 0.D0
          DO I = 1,N
C C C     IF ((T(I).GT.TMIN).AND.(T(I).LT.TMAX)) SSUM=SSUM+RESID(I)**2
              IF (T(I).NE.TMSG) SSUM = SSUM + RESID(I)**2
          END DO

          SIGSQR = SSUM/ (NGOOD-M)

          DO K = 1,M
              DO J = 1,M
                  COV(J,K) = SIGSQR*AINV(J,K)
              END DO
          END DO
      END IF

      RETURN
      END

C
C	$Id: gqclip.f,v 1.5 2008-07-27 00:20:59 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GQCLIP(ERRIND,CLSW,CLRECT)
C
C  INQUIRE CLIPPING INDICATOR
C
      include 'gkscom.h'
C
      INTEGER ERRIND,CLSW
      REAL CLRECT(4)
C
C  Check if GKS is in the proper state.
C
      CALL GZCKST(8,-1,ERRIND)
      IF (ERRIND .EQ. 0) THEN
        CLSW = CCLIP
        INT = CNT+1
        CLRECT(1) = NTVP(INT,1)
        CLRECT(2) = NTVP(INT,2)
        CLRECT(3) = NTVP(INT,3)
        CLRECT(4) = NTVP(INT,4)
      ELSE
        CLSW = -1
        CLRECT(1) = -1.
        CLRECT(2) = -1.
        CLRECT(3) = -1.
        CLRECT(4) = -1.
      ENDIF
C
      RETURN
      END

C
C	$Id: gwibkd.f,v 1.10 2008-07-27 00:21:07 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GWIBKD
C
C Calling this do-nothing subroutine forces "ld" to load the following
C block data routine (but only if they are in the same ".f" file).
C
        RETURN
C
      END
CNOSPLIT
      BLOCKDATA GWIBKDX
C
C  BLOCKDATA module for workstation driver type 3 (WISS).
C
      include 'gwiwsl.h'
      include 'gwiwdt.h'
      include 'gwiins.h'
      include 'gwiadf.h'
      include 'gwiadc.h'
      include 'gwiopc.h'
      include 'gwienu.h'
C
C  Workstation state list.
C
C  Workstation type and category.
C
      DATA LWTYPE,LWKCAT/3,3/
C
C  Internal constants.
C
C
C  Last function code, last continuation flag.
C
      DATA  MCODES/0/,  MCONTS/0/
C
C  VDC, color index, direct color component field widths.
C
      DATA  MVDCFW/16/,  MCIXFW/ 8/,  MDCCFW/ 8/
      DATA  MIXFW /16/,  MINTFW/16/,  MEFW  /16/
C
C  2**MDCCFW - 1
C
      DATA  MDCCRG/255/
C
C  Min AND Max VDC address limits in X and Y directions,
C  the VDC extent (the two concepts should be separated later).
C
      DATA  MINXVD/0/,  MAXXVD/32767/,  MINYVD/0/,  MAXYVD/32767/
C
C  NDC tO VDC mapping coefficients, X and Y directions.
C
      DATA  MXOFF/0/,  MXSCAL/32767/,  MYOFF/0/,  MYSCAL/32767/
C
C  Precision (in bits) of the two components of the representation
C  of real numbers in the segment.
C
      DATA  MCFPP/16/
C
C  Default attribute context.
C
C
C  Polyline index, linetype, line color index, linewidth scale.
C
      DATA  MDPLIX/1/,  MDLTYP/1/,  MDPLCI/1/,  ADLWSC/1.0/
C
C  Polymarker index, marker type, marker color index, marker scale.
C
      DATA  MDPMIX/1/,  MDMTYP/3/,  MDPMCI/1/,  ADMSZS/1.0/
C
C  Text index, text path, text alignment, text font.
C
      DATA  MDTXIX/1/,  MDTXP/0/,  MDTXAL/0,0/,  MDTXFO/1/
C
C  Text precision, text color index, character height.
C
      DATA  MDTXPR/0/,  MDTXCI/1/,  MDCHH/328/
C
C  Character orientation vectors.
C
      DATA  MDCHOV/0,328,328,0/
C
C  Character expansion factor, character spacing.
C
      DATA  ADCHXP/1.0/,  ADCHSP/0.0/
C
C  Fill area index, pattern size, pattern ref point.
C
      DATA  MDFAIX/1/,  MDPASZ/0,32767,32767,0/,  MDPARF/0,0/
C
C  Fill area interior style, style index, color index.
C
      DATA  MDFAIS/0/,  MDFASI/1/,  MDFACI/1/
C
C  ASF values.
C
      DATA  MDASF/13*0/
C
C  Pointers into attribute structure, VALCHG variables.
C
      DATA  IVPLIX/ 1/,  IVLTYP/ 2/,  IVLWSC/ 3/,  IVPLCI/ 4/
      DATA  IVPMIX/ 5/,  IVMTYP/ 6/,  IVMSZS/ 7/,  IVPMCI/ 8/
      DATA  IVTXIX/ 9/,  IVTXP /10/,  IVTXAL/11/,  IVCHH /12/
      DATA  IVCHOV/13/,  IVTXFO/14/,  IVTXPR/15/,  IVCHXP/16/
      DATA  IVCHSP/17/,  IVTXCI/18/,  IVFAIX/19/,  IVPASZ/20/
      DATA  IVPARF/21/,  IVFAIS/22/,  IVFASI/23/,  IVFACI/24/
      DATA  IVASF /25/
C
C  Pointers into attribute equivalencing arrays.
C
      DATA  IP2AEA/  1,  2, -3,  4,  5,  6, -7,  8,  9, 10, 11, 13, 14,        
     +              18, 19,-20,-21, 22, 23, 24, 28, 30, 31, 32, 33, 46/        
C
C  Pointers into ASF arrays.
C
      DATA  IALTYP/ 1/,  IALWSC/ 2/,  IAPLCI/ 3/,  IAMTYP/ 4/
      DATA  IAMSZS/ 5/,  IAPMCI/ 6/,  IATXFP/ 7/,  IACHXP/ 8/
      DATA  IACHSP/ 9/,  IATXCI/10/,  IAFAIS/11/,  IAFASI/12/
      DATA  IAFACI/13/
C
C  Number of CGM and GKS ASFs, GKS to CGM mapping array.
C
      DATA  NCGASF/18/,  NGKASF/13/
      DATA  MASMAP/1,2,3,4,5,6,7,7,8,9,10,11,13,12,12,0,0,0/
C
C  GKS enumeratives.
C
      DATA  GNO   /0/,     GYES/1/,   GCONDI/0/,   GALWAY/1/
      DATA  GINACT/0/,   GACTIV/1/,   GNEMPT/0/,   GEMPTY/1/
      DATA  GNPEND/0/,    GPEND/1/,    GCLIP/1/,   GNCLIP/0/
C
C  CGM opcodes, class and id codes.
C
      DATA  IDNOOP/0/,   IDBEGM/1/,   IDENDM/2/,   IDBEGP/3/
      DATA  IDBGPB/4/,   IDENDP/5/,   IDMVER/1/,   IDMELT/11/
      DATA  IDDREP/12/,  IDCSEL/2/,   IDVEXT/6/,   IDVINT/1/
      DATA  IDCREC/5/,   IDCLIN/6/,   IDPLIN/1/,   IDPMRK/3/
      DATA  IDTEXT/4/,   IDPGON/7/,   IDCARY/9/,   IDGDP/10/
      DATA  IDLBIX/1/,   IDLTYP/2/,   IDLWID/3/,   IDLCLR/4/
      DATA  IDMBIX/5/,   IDMTYP/6/,   IDMSIZ/7/,   IDMCLR/8/
      DATA  IDTBIX/9/,   IDTFON/10/,  IDTPRE/11/,  IDCHEX/12/
      DATA  IDCHSP/13/,  IDTCLR/14/,  IDCHHT/15/,  IDCHOR/16/
      DATA  IDTXPA/17/,  IDTXAL/18/,  IDFBIX/21/,  IDINTS/22/
      DATA  IDFCLR/23/,  IDHAIX/24/,  IDPTIX/25/,  IDFRPT/31/
      DATA  IDPTBL/32/,  IDPTSZ/33/,  IDCTBL/34/,  IDASFS/35/
      DATA  IDESC/1/,    IDMESS/1/,   IDAPLD/2/,   IDBKGC/7/
      DATA  IDDSCR/2/,   IDFLST/13/
      DATA  CLDELM/0/,   CLMDES/1/,   CLPDES/2/,   CLCNTL/3/
      DATA  CLPRIM/4/,   CLPRAT/5/,   CLESCE/6/,   CLEXTE/7/
C
      END

C
C $Id: mlfnsp.f,v 1.5 2008-07-27 00:17:09 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      REAL FUNCTION MLFNSP (E0,E1,E2,E3,PHI)
C
C This function computes the constant M.
C
      IMPLICIT REAL (A-Z)
      DATA TWO,FOUR,SIX /2.0E0,4.0E0,6.0E0/
C
      MLFNSP = E0 * PHI - E1 * SIN (TWO * PHI) + E2 * SIN (FOUR * PHI)
     * - E3 * SIN (SIX * PHI)
C
      RETURN
      END

C
C $Id: mdrgfp.f,v 1.8 2008-09-18 00:42:18 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MDRGFP (XCRA,YCRA,NCRA,ITYP)
C
        DIMENSION XCRA(NCRA),YCRA(NCRA)
C
C Declare required EZMAP common blocks.
C
        COMMON /MAPRGD/  ICOL(5),ICSF(5),IDPF,LCRA,NILN,NILT,OLAT,OLON
        INTEGER          ICOL,ICSF,IDPF,LCRA,NILN,NILT
        REAL             OLAT,OLON
        SAVE   /MAPRGD/
C
        IF (NCRA.GT.2.AND.ITYP.GT.0) THEN
          IF (ICSF(ITYP).GE.0) THEN
            NCRM=0
            DO 101 I=1,NCRA
              CALL MAPTRN (OLAT+YCRA(I),OLON+XCRA(I),UVAL,VVAL)
              IF (UVAL.NE.1.E12) THEN
                NCRM=NCRM+1
                XCRA(NCRM)=UVAL
                YCRA(NCRM)=VVAL
              END IF
  101       CONTINUE
            IF (NCRM.GT.2) THEN
              CALL GSFACI (ICSF(ITYP))
              CALL GFA    (NCRM,XCRA,YCRA)
            END IF
          END IF
        END IF
C
        RETURN
C
      END

c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by UCAR                 .
c  .                                                             .
c  .       University Corporation for Atmospheric Research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                         SPHEREPACK                       .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c
c
c ... file sfvpgs.f
c
c     this file includes documentation and code for
c     subroutine sfvpgs          i
c
c ... files which must be loaded with sfvpgs.f
c
c     sphcom.f, hrfft.f, vhags.f, shsgs.f, gaqd.f
c
c
c     subroutine sfvpgs(nlat,nlon,isym,nt,sf,vp,idv,jdv,br,bi,cr,ci,
c    +                   mdb,ndb,wshsgs,lshsgs,work,lwork,ierror)
c
c     given the vector spherical harmonic coefficients br,bi,cr,ci,
c     computed by subroutine vhags for a vector field (v,w), sfvpgs
c     computes a scalar stream function sf and scalar velocity potential
c     vp for (v,w).  (v,w) is expressed in terms of sf and vp by the
c     helmholtz relations (in mathematical spherical coordinates):
c
c          v = -1/sint*d(vp)/dlambda + d(st)/dtheta
c
c          w =  1/sint*d(st)/dlambda + d(vp)/dtheta
c
c     where sint = sin(theta).  w is the east longitudinal and v
c     is the colatitudinal component of the vector field from which
c     br,bi,cr,ci were precomputed.  required associated legendre
c     polynomials are stored rather than recomputed as they are in
c     subroutine sfvpgc. sf(i,j) and vp(i,j) are given at the i(th)
c     gaussian colatitude point theta(i) (see nlat description below)
c     and east longitude lambda(j) = (j-1)*2*pi/nlon on the sphere.
c
c     input parameters
c
c     nlat   the number of points in the gaussian colatitude grid on the
C*PL*ERROR* Comment line too long
c            full sphere. these lie in the interval (0,pi) and are computed
C*PL*ERROR* Comment line too long
c            in radians in theta(1) <...< theta(nlat) by subroutine gaqd.
C*PL*ERROR* Comment line too long
c            if nlat is odd the equator will be included as the grid point
c            theta((nlat+1)/2).  if nlat is even the equator will be
c            excluded as a grid point and will lie half way between
c            theta(nlat/2) and theta(nlat/2+1). nlat must be at least 3.
c            note: on the half sphere, the number of grid points in the
c            colatitudinal direction is nlat/2 if nlat is even or
c            (nlat+1)/2 if nlat is odd.
c
c     nlon   the number of distinct londitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater than
c            3.  the efficiency of the computation is improved when nlon
c            is a product of small prime numbers.
c
c
C*PL*ERROR* Comment line too long
c     isym   a parameter which determines whether the stream function and
c            velocity potential are computed on the full or half sphere
c            as follows:
c
c      = 0
c
c            the symmetries/antsymmetries described in isym=1,2 below
c            do not exist in (v,w) about the equator.  in this case st
c            and vp are not necessarily symmetric or antisymmetric about
c            the equator.  sf and vp are computed on the entire sphere.
c            i.e., in arrays sf(i,j),vp(i,j) for i=1,...,nlat and
c            j=1,...,nlon.
c
c      = 1
c
c            w is antisymmetric and v is symmetric about the equator.
c            in this case sf is symmetric and vp antisymmetric about
c            the equator and are computed for the northern hemisphere
C*PL*ERROR* Comment line too long
c            only.  i.e., if nlat is odd the sf(i,j),vp(i,j) are computed
c            for i=1,...,(nlat+1)/2 and for j=1,...,nlon.  if nlat is
c            even then sf(i,j),vp(i,j) are computed for i=1,...,nlat/2
c            and j=1,...,nlon.
c
c      = 2
c
c            w is symmetric and v is antisymmetric about the equator.
c            in this case sf is antisymmetric and vp symmetric about
c            the equator and are computed for the northern hemisphere
C*PL*ERROR* Comment line too long
c            only.  i.e., if nlat is odd the sf(i,j),vp(i,j) are computed
c            for i=1,...,(nlat+1)/2 and for j=1,...,nlon.  if nlat is
c            even then sf(i,j),vp(i,j) are computed for i=1,...,nlat/2
c            and j=1,...,nlon.
c
c     nt     nt is the number of scalar and vector fields.  some
C*PL*ERROR* Comment line too long
c            computational efficiency is obtained for multiple fields. arrays
C*PL*ERROR* Comment line too long
c            can be three dimensional corresponding to an indexed multiple
c            vector field.  in this case multiple scalar synthesis will
c            be performed to compute sf,vp for each field.  the
c            third index is the synthesis index which assumes the values
c            k=1,...,nt.  for a single synthesis set nt = 1.  the
c            description of the remaining parameters is simplified by
C*PL*ERROR* Comment line too long
c            assuming that nt=1 or that all the arrays are two dimensional.
c
c     idv    the first dimension of the arrays sf,vp as it appears in
c            the program that calls sfvpgs. if isym = 0 then idv
c            must be at least nlat.  if isym = 1 or 2 and nlat is
c            even then idv must be at least nlat/2. if isym = 1 or 2
c            and nlat is odd then idv must be at least (nlat+1)/2.
c
c     jdv    the second dimension of the arrays sf,vp as it appears in
c            the program that calls sfvpgs. jdv must be at least nlon.
c
c     br,bi, two or three dimensional arrays (see input parameter nt)
c     cr,ci  that contain vector spherical harmonic coefficients
c            of the vector field (v,w) as computed by subroutine vhags.
c
c     mdb    the first dimension of the arrays br,bi,cr,ci as it
c            appears in the program that calls sfvpgs. mdb must be at
c            least min0(nlat,nlon/2) if nlon is even or at least
c            min0(nlat,(nlon+1)/2) if nlon is odd.
c
c     ndb    the second dimension of the arrays br,bi,cr,ci as it
c            appears in the program that calls sfvpgs. ndb must be at
c            least nlat.
c
c     wshsgs an array which must be initialized by subroutine shsgsi.
c            once initialized, wshsgs can be used repeatedly by sfvpgs
c            as long as nlon and nlat remain unchanged.  wshsgs must
c            not bel altered between calls of sfvpgs.
c
c
c     lshsgs the dimension of the array wshsgs as it appears in the
c            program that calls sfvpgs. define
c
c               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            then lshsgs must be at least
c
c            nlat*(3*(l1+l2)-2)+(l1-1)*(l2*(2*nlat-l1)-3*l1)/2+nlon+15
c
c
c     work   a work array that does not have to be saved.
c
c     lwork  the dimension of the array work as it appears in the
c            program that calls sfvpgs. define
c
c               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2                    if nlat is even or
c               l2 = (nlat+1)/2                if nlat is odd
c
c            if isym is zero then lwork must be at least
c
c                  nlat*nlon*(nt+1) + nlat*(2*l1*nt + 1)
c
c            if isym is nonzero then lwork must be at least
c
c                  l2*nlon*(nt+1) + nlat*(2*l1*nt + 1)
c
c     **************************************************************
c
c     output parameters
c
c    sf,vp  two or three dimensional arrays (see input parameter nt)
c           that contains the stream function and velocity potential
c           of the vector field (v,w) whose coefficients br,bi,cr,ci
c           where precomputed by subroutine vhags.  sf(i,j),vp(i,j)
c           are given at the i(th) gaussian colatitude point theta(i)
c           and longitude point lambda(j) = (j-1)*2*pi/nlon.  the index
c           ranges are defined above at the input parameter isym.
c
c
c    ierror = 0  no errors
c           = 1  error in the specification of nlat
c           = 2  error in the specification of nlon
c           = 3  error in the specification of isym
c           = 4  error in the specification of nt
c           = 5  error in the specification of idv
c           = 6  error in the specification of jdv
c           = 7  error in the specification of mdb
c           = 8  error in the specification of ndb
c           = 9  error in the specification of lshsgs
c           = 10 error in the specification of lwork
c **********************************************************************
c
      SUBROUTINE DSFVPGS(NLAT,NLON,ISYM,NT,SF,VP,IDV,JDV,BR,BI,CR,CI,
     +                   MDB,NDB,WSHSGS,LSHSGS,WORK,LWORK,IERROR)
      IMPLICIT NONE
      INTEGER NLAT,NLON,ISYM,NT,IDV,JDV,MDB,NDB,LSHSGS,LWORK,IERROR
      DOUBLE PRECISION SF(IDV,JDV,NT),VP(IDV,JDV,NT)
      DOUBLE PRECISION BR(MDB,NDB,NT),BI(MDB,NDB,NT)
      DOUBLE PRECISION CR(MDB,NDB,NT),CI(MDB,NDB,NT)
      DOUBLE PRECISION WSHSGS(LSHSGS),WORK(LWORK)
      INTEGER IMID,LS,MAB,MN,IA,IB,IS,LWK,IWK
      INTEGER LAT,LATE,L1,L2,LP
c
c     check input parameters
c
      IERROR = 1
      IF (NLAT.LT.3) RETURN
      IERROR = 2
      IF (NLON.LT.4) RETURN
      IERROR = 3
      IF (ISYM.LT.0 .OR. ISYM.GT.2) RETURN
      IERROR = 4
      IF (NT.LT.0) RETURN
      IERROR = 5
      IMID = (NLAT+1)/2
      IF ((ISYM.EQ.0.AND.IDV.LT.NLAT) .OR.
     +    (ISYM.GT.0.AND.IDV.LT.IMID)) RETURN
      IERROR = 6
      IF (JDV.LT.NLON) RETURN
      IERROR = 7
      IF (MDB.LT.MIN0(NLAT, (NLON+1)/2)) RETURN
      IERROR = 8
      IF (NDB.LT.NLAT) RETURN
      IERROR = 9
      L1 = MIN0((NLON+2)/2,NLAT)
      LATE = (NLAT+MOD(NLAT,2))/2
      LAT = NLAT
      IF (ISYM.NE.0) LAT = LATE
      L2 = LATE
c     check permanent work space length
      L2 = (NLAT+MOD(NLAT,2))/2
      L1 = MIN0((NLON+2)/2,NLAT)
      LP = NLAT* (3* (L1+L2)-2) + (L1-1)* (L2* (2*NLAT-L1)-3*L1)/2 +
     +     NLON + 15
      IF (LSHSGS.LT.LP) RETURN
c
c     verify unsaved work space
c
      IERROR = 10
      LS = NLAT
      IF (ISYM.GT.0) LS = IMID
c
c     set first dimension for a,b (as requried by shsgs)
c
      MAB = MIN0(NLAT,NLON/2+1)
      MN = MAB*NLAT*NT
      IF (LWORK.LT.LS*NLON+ (NT+1)+NLAT* (2*L1*NT+1)) RETURN

      IERROR = 0
c
c     set work space pointers
c
      IA = 1
      IB = IA + MN
      IS = IB + MN
      IWK = IS + NLAT
      LWK = LWORK - 2*MN - NLAT
      CALL DSTVPGS1(NLAT,NLON,ISYM,NT,SF,VP,IDV,JDV,BR,BI,CR,CI,MDB,NDB,
     +             WORK(IA),WORK(IB),MAB,WORK(IS),WSHSGS,LSHSGS,
     +             WORK(IWK),LWK,IERROR)
      RETURN
      END

      SUBROUTINE DSTVPGS1(NLAT,NLON,ISYM,NT,SF,VP,IDV,JDV,BR,BI,CR,CI,
     +                   MDB,NDB,A,B,MAB,FNN,WSHSGS,LSHSGS,WK,LWK,
     +                   IERROR)
      IMPLICIT NONE
      INTEGER NLAT,NLON,ISYM,NT,IDV,JDV,MDB,NDB,MAB,LSHSGS,LWK,IERROR
      DOUBLE PRECISION SF(IDV,JDV,NT),VP(IDV,JDV,NT)
      DOUBLE PRECISION BR(MDB,NDB,NT),BI(MDB,NDB,NT),CR(MDB,NDB,NT),
     +                 CI(MDB,NDB,NT)
      DOUBLE PRECISION A(MAB,NLAT,NT),B(MAB,NLAT,NT)
      DOUBLE PRECISION WSHSGS(LSHSGS),WK(LWK),FNN(NLAT)
      INTEGER N,M,MMAX,K
c
c     set coefficient multiplyers
c
      DO N = 2,NLAT
          FNN(N) = 1.0D0/SQRT(DBLE(N* (N-1)))
      END DO
      MMAX = MIN0(NLAT, (NLON+1)/2)
c
c     compute st scalar coefficients from cr,ci
c
      DO K = 1,NT
          DO N = 1,NLAT
              DO M = 1,MAB
                  A(M,N,K) = 0.0D0
                  B(M,N,K) = 0.0D0
              END DO
          END DO
c
c     compute m=0 coefficients
c
          DO N = 2,NLAT
              A(1,N,K) = -FNN(N)*CR(1,N,K)
              B(1,N,K) = -FNN(N)*CI(1,N,K)
          END DO
c
c     compute m>0 coefficients using vector spherepack value for mmax
c
          DO M = 2,MMAX
              DO N = M,NLAT
                  A(M,N,K) = -FNN(N)*CR(M,N,K)
                  B(M,N,K) = -FNN(N)*CI(M,N,K)
              END DO
          END DO
      END DO
c
c     synthesize a,b into st
c
      CALL DSHSGS(NLAT,NLON,ISYM,NT,SF,IDV,JDV,A,B,MAB,NLAT,WSHSGS,
     +           LSHSGS,WK,LWK,IERROR)
c
c    set coefficients for vp from br,bi
c
      DO K = 1,NT
          DO N = 1,NLAT
              DO M = 1,MAB
                  A(M,N,K) = 0.0D0
                  B(M,N,K) = 0.0D0
              END DO
          END DO
c
c     compute m=0 coefficients
c
          DO N = 2,NLAT
              A(1,N,K) = FNN(N)*BR(1,N,K)
              B(1,N,K) = FNN(N)*BI(1,N,K)
          END DO
c
c     compute m>0 coefficients using vector spherepack value for mmax
c
          MMAX = MIN0(NLAT, (NLON+1)/2)
          DO M = 2,MMAX
              DO N = M,NLAT
                  A(M,N,K) = FNN(N)*BR(M,N,K)
                  B(M,N,K) = FNN(N)*BI(M,N,K)
              END DO
          END DO
      END DO
c
c     synthesize a,b into vp
c
      CALL DSHSGS(NLAT,NLON,ISYM,NT,VP,IDV,JDV,A,B,MAB,NLAT,WSHSGS,
     +           LSHSGS,WK,LWK,IERROR)
      RETURN
      END

C
C	$Id: gstxfp.f,v 1.5 2008-07-27 00:21:02 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GSTXFP (FONT,PREC)
C
C  SET TEXT FONT AND PRECISION
C
      INTEGER ESTXFP
      PARAMETER (ESTXFP=27)
C
      include 'gkscom.h'
C
      INTEGER FONT,PREC
C
C  Check if GKS is in the proper state.
C
      CALL GZCKST(8,ESTXFP,IER)
      IF (IER .NE. 0) RETURN
C
C  Check that the font is not zero.
C
      IF (FONT .EQ. 0) THEN
        ERS = 1
        CALL GERHND(75,ESTXFP,ERF)
        ERS = 0
        RETURN
      ENDIF
C
C  Check that the precision is valid.
C
      IF (PREC.LT.0 .OR. PREC.GT.2) THEN
        ERS = 1
        CALL GERHND(2000,ESTXFP,ERF)
        ERS = 0
        RETURN
      ENDIF
C
C  Set the current font and precision variables in the GKS state list.
C
      CTXFP(1) = FONT
      CTXFP(2) = PREC
C
C  Invoke the workstation interface.
C
      FCODE = 30
      CONT  = 0
      CALL GZROI(0)
      IL1   = 2
      IL2   = 2
      ID(1) = FONT
      ID(2) = PREC
      CALL GZTOWK
      IF (RERR .NE. 0) THEN
        ERS = 1
        CALL GERHND(RERR,ESTXFP,ERF)
        ERS = 0
      ENDIF
C
      RETURN
      END

C
C $Id: gridal.f,v 1.10 2008-07-27 00:17:14 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GRIDAL (MJRX,MNRX,MJRY,MNRY,IXLB,IYLB,IGPH,XINT,YINT)
C
C Declare the common block containing real and integer parameters.
C
        COMMON /GAREIN/ ICAX,ICLB,ICMJ,ICMN,ILTY,IORX,NCFX,NCFY,RCWX,
     +                  RCWY,RDCX,RDCY,RMJX,RMJY,RMNX,RMNY,RWAX,RWLB,
     +                  RWMJ,RWMN
        SAVE   /GAREIN/
C
C Declare the common block containing character parameters.
C
        COMMON /GACHAR/ FNLX,FNLY
        CHARACTER*10    FNLX,FNLY
        SAVE   /GACHAR/
C
C Declare an array in which to receive the "clipping rectangle".
C
        DIMENSION CLPR(4)
C
C Declare local variables to use in encoding labels.
C
        CHARACTER*10 FNLB
        CHARACTER*24 LABL
C
C Declare some local variables double-precision.  (They are used to
C create labels.)
C
        DOUBLE PRECISION DLBL,EPSI,OPEP,VEPS,VLBL
C
C Initialize the values of EPSI and OPEP so that they will be recomputed
C by the code itself.
C
        SAVE EPSI,OPEP
C
        DATA EPSI,OPEP / 0.D0 , 1.D0 /
C
C Do a call forcing a BLOCKDATA to be loaded from a binary library.
C
        CALL GABLDT
C
C Check for an uncleared prior error.
C
        IF (ICFELL('GRIDAL - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C If it has not been done yet, compute the constants "epsilon" and
C "1+epsilon"; the latter is to be used multiplicatively in rounding
C to get rid of strings of nines in labels.
C
        IF (EPSI.EQ.0.D0) THEN
C
          NSDR=0
C
  101     NSDR=NSDR+1
          CALL GAGTRN (NSDR,TMP1,TMP2,TMP3)
          IF (TMP2.NE.1..AND.TMP2.NE.TMP3.AND.NSDR.LT.100) GO TO 101
C
          EPSI=10.D0**(1-NSDR)
          OPEP=1.D0+EPSI
C
        END IF
C
C Pick up the current definition of the window and the viewport and
C the current x/y linear/log flag.
C
        CALL GETSET (VPLX,VPRX,VPBY,VPTY,WDLX,WDRX,WDBY,WDTY,LILO)
        IF (ICFELL('GRIDAL',2).NE.0) RETURN
C
C Set minimum and maximum values of X and Y.
C
        XMIN=MIN(WDLX,WDRX)
        XMAX=MAX(WDLX,WDRX)
C
        YMIN=MIN(WDBY,WDTY)
        YMAX=MAX(WDBY,WDTY)
C
C Set the linear/log and mirror image flags for the two axes.
C
        ILGX=(LILO-1)/2
C
        IF (WDLX.LT.WDRX) THEN
          IMIX=0
        ELSE
          IMIX=1
        END IF
C
        ILGY=MOD(LILO-1,2)
C
        IF (WDBY.LT.WDTY) THEN
          IMIY=0
        ELSE
          IMIY=1
        END IF
C
C Compute the width and height of the plotter window, in plotter units.
C
        CALL GETSI (IP2X,IP2Y)
        IF (ICFELL('GRIDAL',3).NE.0) RETURN
        WPLO=2.**IP2X-1.
        HPLO=2.**IP2Y-1.
C
C Compute the number of major and minor divisions of each axis, imposing
C limits on the input values in order to keep the code from blowing up.
C
        IF (ILGX.EQ.0) THEN
          NMJX=MAX(1,MIN(10000,MJRX))
          NMNX=MAX(1,MIN(10000,MNRX))
        ELSE
          IPTX=MAX(1,MIN(100,MJRX))
          FPTX=REAL(IPTX)
          NMJX=INT(1.0001*ABS(ALOG10(WDRX/WDLX))/FPTX)
          IF (MNRX.LE.10) THEN
            NMNX=9
          ELSE
            NMNX=1
          END IF
        END IF
C
        IF (ILGY.EQ.0) THEN
          NMJY=MAX(1,MIN(10000,MJRY))
          NMNY=MAX(1,MIN(10000,MNRY))
        ELSE
          IPTY=MAX(1,MIN(100,MJRY))
          FPTY=REAL(IPTY)
          NMJY=INT(1.0001*ABS(ALOG10(WDTY/WDBY))/FPTY)
          IF (MNRY.LE.10) THEN
            NMNY=9
          ELSE
            NMNY=1
          END IF
        END IF
C
C Save the current state of the clipping indicator and then turn it off.
C
        CALL GQCLIP (IGER,ICLP,CLPR)
        IF (IGER.NE.0) THEN
          CALL SETER ('GRIDAL - ERROR EXIT FROM GQCLIP',4,1)
          RETURN
        END IF
        CALL GSCLIP (0)
C
C The following loop runs through the types of items to be drawn.  ITEM
C = 1 implies minor ticks, 2 implies major ticks, 3 implies the axes,
C and 4 implies the labels.
C
        DO 104 ITEM=1,4
C
C Set the color index and line width for the type of item being drawn.
C
          IF (ITEM.EQ.1) THEN
            IF (ICMN.GE.0) THEN
              CALL PLOTIF (0.,0.,2)
              IF (ICFELL('GRIDAL',5).NE.0) RETURN
              CALL GQPLCI (IGER,ICS1)
              IF (IGER.NE.0) THEN
                CALL SETER ('GRIDAL - ERROR EXIT FROM GQPLCI',6,1)
                RETURN
              END IF
              CALL GSPLCI (ICMN)
            END IF
            IF (RWMN.GT.0.) THEN
              CALL PLOTIF (0.,0.,2)
              IF (ICFELL('GRIDAL',7).NE.0) RETURN
              CALL GQLWSC (IGER,SLWS)
              IF (IGER.NE.0) THEN
                CALL SETER ('GRIDAL - ERROR EXIT FROM GQLWSC',8,1)
                RETURN
              END IF
              CALL GSLWSC (RWMN)
            END IF
          ELSE IF (ITEM.EQ.2) THEN
            IF (ICMJ.GE.0) THEN
              CALL PLOTIF (0.,0.,2)
              IF (ICFELL('GRIDAL',9).NE.0) RETURN
              CALL GQPLCI (IGER,ICS1)
              IF (IGER.NE.0) THEN
                CALL SETER ('GRIDAL - ERROR EXIT FROM GQPLCI',10,1)
                RETURN
              END IF
              CALL GSPLCI (ICMJ)
            END IF
            IF (RWMJ.GT.0.) THEN
              CALL PLOTIF (0.,0.,2)
              IF (ICFELL('GRIDAL',11).NE.0) RETURN
              CALL GQLWSC (IGER,SLWS)
              IF (IGER.NE.0) THEN
                CALL SETER ('GRIDAL - ERROR EXIT FROM GQLWSC',12,1)
                RETURN
              END IF
              CALL GSLWSC (RWMJ)
            END IF
          ELSE IF (ITEM.EQ.3) THEN
            IF (ICAX.GE.0) THEN
              CALL PLOTIF (0.,0.,2)
              IF (ICFELL('GRIDAL',13).NE.0) RETURN
              CALL GQPLCI (IGER,ICS1)
              IF (IGER.NE.0) THEN
                CALL SETER ('GRIDAL - ERROR EXIT FROM GQPLCI',14,1)
                RETURN
              END IF
              CALL GSPLCI (ICAX)
            END IF
            IF (RWAX.GT.0.) THEN
              CALL PLOTIF (0.,0.,2)
              IF (ICFELL('GRIDAL',15).NE.0) RETURN
              CALL GQLWSC (IGER,SLWS)
              IF (IGER.NE.0) THEN
                CALL SETER ('GRIDAL - ERROR EXIT FROM GQLWSC',16,1)
                RETURN
              END IF
              CALL GSLWSC (RWAX)
            END IF
          ELSE IF (ITEM.EQ.4) THEN
            IF (ICLB.GE.0) THEN
              CALL GQPLCI (IGER,ICS1)
              IF (IGER.NE.0) THEN
                CALL SETER ('GRIDAL - ERROR EXIT FROM GQPLCI',17,1)
                RETURN
              END IF
              CALL GSPLCI (ICLB)
              CALL GQTXCI (IGER,ICS2)
              IF (IGER.NE.0) THEN
                CALL SETER ('GRIDAL - ERROR EXIT FROM GQTXCI',18,1)
                RETURN
              END IF
              CALL GSTXCI (ICLB)
            END IF
            IF (RWLB.GT.0.) THEN
              CALL PLOTIF (0.,0.,2)
              IF (ICFELL('GRIDAL',19).NE.0) RETURN
              CALL GQLWSC (IGER,SLWS)
              IF (IGER.NE.0) THEN
                CALL SETER ('GRIDAL - ERROR EXIT FROM GQLWSC',20,1)
                RETURN
              END IF
              CALL GSLWSC (RWLB)
            END IF
          END IF
C
C The next loop runs through the four axes.  IAXS = 1 implies the left
C axis, 2 the bottom axis, 3 the right axis, and 4 the top axis.
C
          DO 103 IAXS=1,4
C
C On the first pass through the loop, set up the required parameters
C to do the left axis.
C
            IF (IAXS.EQ.1) THEN
C
C If the left axis isn't being done at all, or if the type of item
C being drawn now isn't present on the left axis, skip it.
C
              IF (IYLB.LT.0) GO TO 103
              IF (ITEM.EQ.1.AND.NMNY.LE.1) GO TO 103
              IF (ITEM.EQ.4.AND.IYLB.LE.0) GO TO 103
C
C Set the linear/log flag.
C
              ILGF=ILGY
C
C Set the mirror-image flag to indicate whether the axis is being drawn
C in the direction from smaller user values to larger user values (0)
C or in the reverse direction (1).
C
              IMIF=1-IMIY
C
C Set the parameters determining the number of major and minor divisions
C of the axis.
C
              NMJD=NMJY
              NMND=NMNY
              IF (ITEM.NE.1) NMND=1
C
C Determine the fractional coordinates of the first point on the axis
C and the x and y increment required to get from each major tick to
C the next.
C
              IF (MOD(IGPH,4)-1.LE.0) THEN
                QMJX=VPLX
              ELSE
                QMJX=CUFX(MAX(XMIN,MIN(XMAX,XINT)))
                IF (ICFELL('GRIDAL',21).NE.0) RETURN
              END IF
              DMJX=0.
              QMJY=VPTY
              DMJY=VPBY-VPTY
              IF (ITEM.NE.3) THEN
                IF (ILGF.EQ.0) THEN
                  DMJY=DMJY/REAL(NMJD)
                ELSE
                  FPTN=FPTY
                  DMJY=DMJY*FPTN/ABS(ALOG10(WDTY/WDBY))
                  IF (IMIF.NE.0) QMJY=VPBY-REAL(NMJD)*DMJY
                END IF
              END IF
C
C Set the coordinates of the points at which we should not draw major
C ticks because they would overlap intersecting axes.
C
              AMJX=QMJX
              AMJY=2.
              BMJX=QMJX
              BMJY=-1.
              IF ((MOD(IGPH,4)-1.LT.0.OR.RMJY.GT.0.).AND.IXLB.GE.0) THEN
                IF (IGPH/4-1.LE.0) THEN
                  AMJY=VPTY
                  BMJY=VPBY
                ELSE
                  AMJY=CUFY(MAX(YMIN,MIN(YMAX,YINT)))
                  IF (ICFELL('GRIDAL',22).NE.0) RETURN
                END IF
              END IF
C
C Compute tick-mark offset parameters.
C
              IF (MOD(IGPH,4)-1.LT.0) THEN
                TMJX=VPRX-VPLX
                TMNX=VPRX-VPLX
              ELSE
                IF (RMJY.GT.-1..AND.RMJY.LT.+1.) THEN
                  TMJX=RMJY
                ELSE
                  TMJX=REAL(INT(RMJY))/WPLO
                END IF
                IF (RMNY.GT.-1..AND.RMNY.LT.+1.) THEN
                  TMNX=RMNY
                ELSE
                  TMNX=REAL(INT(RMNY))/WPLO
                END IF
              END IF
              TMJY=0.
              TMNY=0.
C
C If numeric labels are being done, compute the value of the first one,
C the increment required to get from one to the next, and all other
C local variables required to encode and write the labels.
C
              IF (ITEM.EQ.4) THEN
C
                VLBL=DBLE(WDTY)
                IF (ILGF.EQ.0) THEN
                  DLBL=DBLE(WDBY-WDTY)/DBLE(NMJD)
                  VEPS=EPSI*DBLE(ABS(WDTY-WDBY))
                ELSE
                  DLBL=10.D0**IPTY
                  IF (IMIF.NE.0) DLBL=1.D0/DLBL
                  VEPS=0.D0
                END IF
C
                IF (RDCX.EQ.0.) THEN
                  DLBX=-20./WPLO
                ELSE IF (RDCX.EQ.1.) THEN
                  DLBX=+20./WPLO
                  IF (MOD(IGPH,4)-1.LE.0) DLBX=DLBX+VPRX-VPLX
                ELSE IF (RDCX.LE.-1..OR.RDCX.GE.+1.) THEN
                  DLBX=REAL(INT(-RDCX))/WPLO
                ELSE
                  DLBX=-RDCX
                END IF
                DLBY=0.
C
                FNLB=FNLY
C
                RCHW=RCWY
                IF (RCHW.LE.0..OR.RCHW.GE.1.) THEN
                  ICHW=INT(MAX(0.,RCHW))
                  IF (ICHW.LE.3) ICHW=(8+4*MOD(ICHW,2))*(1+ICHW/2)
                  RCHW=REAL(ICHW)/WPLO
                END IF
                ICHW=MAX(4,INT(RCHW*WPLO))
C
                IORI=0
                ICEN=INT(-SIGN(1.,DLBX))
C
                NCFR=NCFY
                IF (NCFR.NE.0) THEN
                  MLBL=1
                  NLBL=NCFR
                END IF
C
              END IF
C
C On the second pass through the loop, set up the required parameters
C to do the bottom axis.
C
            ELSE IF (IAXS.EQ.2) THEN
C
              IF (IXLB.LT.0) GO TO 103
              IF (ITEM.EQ.1.AND.NMNX.LE.1) GO TO 103
              IF (ITEM.EQ.4.AND.IXLB.LE.0) GO TO 103
C
              ILGF=ILGX
C
              IMIF=IMIX
C
              NMJD=NMJX
              NMND=NMNX
              IF (ITEM.NE.1) NMND=1
C
              QMJX=VPLX
              DMJX=VPRX-VPLX
              IF (ITEM.NE.3) THEN
                IF (ILGF.EQ.0) THEN
                  DMJX=DMJX/REAL(NMJD)
                ELSE
                  FPTN=FPTX
                  DMJX=DMJX*FPTN/ABS(ALOG10(WDRX/WDLX))
                  IF (IMIF.NE.0) QMJX=VPRX-REAL(NMJD)*DMJX
                END IF
              END IF
              IF (IGPH/4-1.LE.0) THEN
                QMJY=VPBY
              ELSE
                QMJY=CUFY(MAX(YMIN,MIN(YMAX,YINT)))
                IF (ICFELL('GRIDAL',23).NE.0) RETURN
              END IF
              DMJY=0.
C
              AMJX=-1.
              AMJY=QMJY
              BMJX=2.
              BMJY=QMJY
              IF ((IGPH/4-1.LT.0.OR.RMJX.GT.0.).AND.IYLB.GE.0) THEN
                IF (MOD(IGPH,4)-1.LE.0) THEN
                  AMJX=VPLX
                  BMJX=VPRX
                ELSE
                  AMJX=CUFX(MAX(XMIN,MIN(XMAX,XINT)))
                  IF (ICFELL('GRIDAL',24).NE.0) RETURN
                END IF
              END IF
C
              TMJX=0.
              TMNX=0.
              IF (IGPH/4-1.LT.0) THEN
                TMJY=VPTY-VPBY
                TMNY=VPTY-VPBY
              ELSE
                IF (RMJX.GT.-1..AND.RMJX.LT.+1.) THEN
                  TMJY=RMJX
                ELSE
                  TMJY=REAL(INT(RMJX))/WPLO
                END IF
                IF (RMNX.GT.-1..AND.RMNX.LT.+1.) THEN
                  TMNY=RMNX
                ELSE
                  TMNY=REAL(INT(RMNX))/WPLO
                END IF
              END IF
C
              IF (ITEM.EQ.4) THEN
C
                VLBL=DBLE(WDLX)
                IF (ILGF.EQ.0) THEN
                  DLBL=DBLE(WDRX-WDLX)/DBLE(NMJD)
                  VEPS=EPSI*DBLE(ABS(WDRX-WDLX))
                ELSE
                  DLBL=10.D0**IPTX
                  IF (IMIF.NE.0) DLBL=1.D0/DLBL
                  VEPS=0.D0
                END IF
C
                DLBX=0.
                IF (RDCY.EQ.0.) THEN
                  DLBY=-20./HPLO
                ELSE IF (RDCY.EQ.1.) THEN
                  DLBY=+20./HPLO
                  IF (IGPH/4-1.LE.0) DLBY=DLBY+VPTY-VPBY
                ELSE IF (RDCY.LE.-1..OR.RDCY.GE.+1.) THEN
                  DLBY=REAL(INT(-RDCY))/HPLO
                ELSE
                  DLBY=-RDCY
                END IF
C
                FNLB=FNLX
C
                RCHW=RCWX
                IF (RCHW.LE.0..OR.RCHW.GE.1.) THEN
                  ICHW=INT(MAX(0.,RCHW))
                  IF (ICHW.LE.3) ICHW=(8+4*MOD(ICHW,2))*(1+ICHW/2)
                  RCHW=REAL(ICHW)/WPLO
                END IF
                ICHW=MAX(4,INT(RCHW*WPLO))
C
                IF (IORX.EQ.0) THEN
                  IORI=0
                  ICEN=0
                  DLBY=DLBY+SIGN(RCHW,DLBY)
                ELSE
                  IORI=90
                  ICEN=INT(-SIGN(1.,DLBY))
                END IF
C
                NCFR=NCFX
                IF (NCFR.NE.0) THEN
                  MLBL=1
                  NLBL=NCFR
                END IF
C
              END IF
C
C On the third pass through the loop, set up the required parameters
C to do the right axis.
C
            ELSE IF (IAXS.EQ.3) THEN
C
              IF (IYLB.LT.0) GO TO 103
              IF (ITEM.EQ.1.AND.NMNY.LE.1) GO TO 103
              IF (ITEM.EQ.4) GO TO 103
              IF ((ITEM.EQ.1.OR.ITEM.EQ.2).AND.
     +                                     MOD(IGPH,4)-1.NE.0) GO TO 103
C
              ILGF=ILGY
C
              IMIF=IMIY
C
              NMJD=NMJY
              NMND=NMNY
              IF (ITEM.NE.1) NMND=1
C
              IF (MOD(IGPH,4)-1.LE.0) THEN
                QMJX=VPRX
              ELSE
                QMJX=CUFX(MAX(XMIN,MIN(XMAX,XINT)))
                IF (ICFELL('GRIDAL',25).NE.0) RETURN
              END IF
              DMJX=0.
              QMJY=VPBY
              DMJY=VPTY-VPBY
              IF (ITEM.NE.3) THEN
                IF (ILGF.EQ.0) THEN
                  DMJY=DMJY/REAL(NMJD)
                ELSE
                  FPTN=FPTY
                  DMJY=DMJY*FPTN/ABS(ALOG10(WDTY/WDBY))
                  IF (IMIF.NE.0) QMJY=VPTY-REAL(NMJD)*DMJY
                END IF
              END IF
C
              AMJX=QMJX
              AMJY=-1.
              BMJX=QMJX
              BMJY=2.
              IF (RMJY.GT.0..AND.IXLB.GE.0) THEN
                IF (IGPH/4-1.LE.0) THEN
                  AMJY=VPBY
                  BMJY=VPTY
                ELSE
                  AMJY=CUFY(MAX(YMIN,MIN(YMAX,YINT)))
                  IF (ICFELL('GRIDAL',26).NE.0) RETURN
                END IF
              END IF
C
              IF (RMJY.GT.-1..AND.RMJY.LT.+1.) THEN
                TMJX=-RMJY
              ELSE
                TMJX=-REAL(INT(RMJY))/WPLO
              END IF
              IF (RMNY.GT.-1..AND.RMNY.LT.+1.) THEN
                TMNX=-RMNY
              ELSE
                TMNX=-REAL(INT(RMNY))/WPLO
              END IF
              TMJY=0.
              TMNY=0.
C
C On the fourth pass through the loop, set up the required parameters
C to do the top axis.
C
            ELSE IF (IAXS.EQ.4) THEN
C
              IF (IXLB.LT.0) GO TO 103
              IF (ITEM.EQ.1.AND.NMNX.LE.1) GO TO 103
              IF ((ITEM.EQ.1.OR.ITEM.EQ.2).AND.IGPH/4-1.NE.0) GO TO 103
              IF (ITEM.EQ.4) GO TO 103
C
              ILGF=ILGX
C
              IMIF=1-IMIX
C
              NMJD=NMJX
              NMND=NMNX
              IF (ITEM.NE.1) NMND=1
C
              QMJX=VPRX
              DMJX=VPLX-VPRX
              IF (ITEM.NE.3) THEN
                IF (ILGF.EQ.0) THEN
                  DMJX=DMJX/REAL(NMJD)
                ELSE
                  FPTN=FPTX
                  DMJX=DMJX*FPTN/ABS(ALOG10(WDRX/WDLX))
                  IF (IMIF.NE.0) QMJX=VPLX-REAL(NMJD)*DMJX
                END IF
              END IF
              IF (IGPH/4-1.LE.0) THEN
                QMJY=VPTY
              ELSE
                QMJY=CUFY(MAX(YMIN,MIN(YMAX,YINT)))
                IF (ICFELL('GRIDAL',27).NE.0) RETURN
              END IF
              DMJY=0.
C
              AMJX=2.
              AMJY=QMJY
              BMJX=-1.
              BMJY=QMJY
              IF (RMJX.GT.0..AND.IYLB.GE.0) THEN
                IF (MOD(IGPH,4)-1.LE.0) THEN
                  AMJX=VPRX
                  BMJX=VPLX
                ELSE
                  AMJX=CUFX(MAX(XMIN,MIN(XMAX,XINT)))
                  IF (ICFELL('GRIDAL',28).NE.0) RETURN
                END IF
              END IF
C
              TMJX=0.
              TMNX=0.
              IF (RMJX.GT.-1..AND.RMJX.LT.+1.) THEN
                TMJY=-RMJX
              ELSE
                TMJY=-REAL(INT(RMJX))/WPLO
              END IF
              IF (RMNX.GT.-1..AND.RMNX.LT.+1.) THEN
                TMNY=-RMNX
              ELSE
                TMNY=-REAL(INT(RMNX))/WPLO
              END IF
C
            END IF
C
C See if the item being drawn requires looping through the tick mark
C positions along the axis.
C
            IF (ITEM.NE.3) THEN
C
C Initialize the counter which controls whether we draw major ticks or
C minor ticks and the flag which determines in which direction we draw
C the ticks.
C
              IMND=0
              IFLP=0
C
C Loop through the positions at which tick marks and/or labels need to
C be drawn.
C
              DO 102 IMRK=1,NMJD*NMND+1
                IF (IMND.EQ.0) THEN
                  PMJX=QMJX
                  PMJY=QMJY
                  QMJX=QMJX+DMJX
                  QMJY=QMJY+DMJY
                  IF (ITEM.EQ.2) THEN
                    IF (ABS(PMJX-AMJX+PMJY-AMJY).GT..0001.AND.
     +                  ABS(PMJX-BMJX+PMJY-BMJY).GT..0001) THEN
                      IFLP=1-IFLP
                      IF (IFLP.EQ.0) THEN
                        CALL PLOTIF (PMJX,     PMJY     ,0)
                        IF (ICFELL('GRIDAL',29).NE.0) RETURN
                        CALL PLOTIF (PMJX+TMJX,PMJY+TMJY,1)
                        IF (ICFELL('GRIDAL',30).NE.0) RETURN
                      ELSE
                        CALL PLOTIF (PMJX+TMJX,PMJY+TMJY,0)
                        IF (ICFELL('GRIDAL',31).NE.0) RETURN
                        CALL PLOTIF (PMJX,     PMJY     ,1)
                        IF (ICFELL('GRIDAL',32).NE.0) RETURN
                      END IF
                    END IF
                  END IF
                  IF (ITEM.EQ.4) THEN
                    IF (FNLB(2:2).NE.'I'.AND.FNLB(2:2).NE.'i') THEN
                      VNCD=REAL(VLBL*OPEP)
                      IF (ABS(VLBL).LT.VEPS) VNCD=0.
                      WRITE (LABL,FNLB) VNCD
                    ELSE
                      ILBL=NINT(VLBL)
                      WRITE (LABL,FNLB) ILBL
                    END IF
                    IF (NCFR.EQ.0) CALL GALBEX (LABL,MLBL,NLBL)
                    IF (ILTY.EQ.0) THEN
                      XDUM=CFUX(PMJX+DLBX)
                      IF (ICFELL('GRIDAL',33).NE.0) RETURN
                      YDUM=CFUY(PMJY+DLBY)
                      IF (ICFELL('GRIDAL',34).NE.0) RETURN
                      CALL WTSTR  (XDUM,YDUM,LABL(MLBL:NLBL),
     +                             ICHW,IORI,ICEN)
                      IF (ICFELL('GRIDAL',35).NE.0) RETURN
                    ELSE IF (ILTY.EQ.1) THEN
                      XDUM=CFUX(PMJX+DLBX)
                      IF (ICFELL('GRIDAL',36).NE.0) RETURN
                      YDUM=CFUY(PMJY+DLBY)
                      IF (ICFELL('GRIDAL',37).NE.0) RETURN
                      CALL PLCHHQ (XDUM,YDUM,LABL(MLBL:NLBL),
     +                             RCHW,REAL(IORI),REAL(ICEN))
                      IF (ICFELL('GRIDAL',38).NE.0) RETURN
                    ELSE
                      XDUM=CFUX(PMJX+DLBX)
                      IF (ICFELL('GRIDAL',36).NE.0) RETURN
                      YDUM=CFUY(PMJY+DLBY)
                      IF (ICFELL('GRIDAL',37).NE.0) RETURN
                      CALL GAPLCH (XDUM,YDUM,LABL(MLBL:NLBL),
     +                             RCHW,REAL(IORI),REAL(ICEN))
                      IF (ICFELL('GRIDAL',38).NE.0) RETURN
                    END IF
                    IF (ILGF.EQ.0) THEN
                      VLBL=VLBL+DLBL
                    ELSE
                      VLBL=VLBL*DLBL
                    END IF
                  END IF
                ELSE
                  IF (ILGF.EQ.0) THEN
                    PMNX=PMJX+(QMJX-PMJX)*REAL(IMND)/REAL(NMND)
                    PMNY=PMJY+(QMJY-PMJY)*REAL(IMND)/REAL(NMND)
                  ELSE
                    IF (IMIF.EQ.0) THEN
                      PMNX=PMJX+(QMJX-PMJX)*ALOG10(REAL(IMND+1))/FPTN
                      PMNY=PMJY+(QMJY-PMJY)*ALOG10(REAL(IMND+1))/FPTN
                    ELSE
                      PMNX=QMJX+(PMJX-QMJX)*ALOG10(REAL(NMND-IMND+1))
     +                                                             /FPTN
                      PMNY=QMJY+(PMJY-QMJY)*ALOG10(REAL(NMND-IMND+1))
     +                                                             /FPTN
                    END IF
                  END IF
                  IFLP=1-IFLP
                  IF (IFLP.EQ.0) THEN
                    CALL PLOTIF (PMNX,     PMNY     ,0)
                    IF (ICFELL('GRIDAL',39).NE.0) RETURN
                    CALL PLOTIF (PMNX+TMNX,PMNY+TMNY,1)
                    IF (ICFELL('GRIDAL',40).NE.0) RETURN
                  ELSE
                    CALL PLOTIF (PMNX+TMNX,PMNY+TMNY,0)
                    IF (ICFELL('GRIDAL',41).NE.0) RETURN
                    CALL PLOTIF (PMNX,     PMNY     ,1)
                    IF (ICFELL('GRIDAL',42).NE.0) RETURN
                  END IF
                END IF
                IMND=MOD(IMND+1,NMND)
  102         CONTINUE
            ELSE
C
C Draw the axis.
C
              CALL PLOTIF (QMJX,QMJY,0)
              IF (ICFELL('GRIDAL',43).NE.0) RETURN
              CALL PLOTIF (QMJX+DMJX,QMJY+DMJY,1)
              IF (ICFELL('GRIDAL',44).NE.0) RETURN
C
            END IF
C
  103     CONTINUE
C
C Reset the polyline and text color indices.
C
          IF ((ITEM.EQ.1.AND.ICMN.GE.0).OR.
     +        (ITEM.EQ.2.AND.ICMJ.GE.0).OR.
     +        (ITEM.EQ.3.AND.ICAX.GE.0).OR.
     +        (ITEM.EQ.4.AND.ICLB.GE.0)) THEN
            CALL PLOTIF (0.,0.,2)
            IF (ICFELL('GRIDAL',45).NE.0) RETURN
            CALL GSPLCI (ICS1)
          END IF
C
          IF (ITEM.EQ.4.AND.ICLB.GE.0) THEN
            CALL GSTXCI (ICS2)
          END IF
C
C Reset the line width scale factor.
C
          IF ((ITEM.EQ.1.AND.RWMN.GT.0.).OR.
     +        (ITEM.EQ.2.AND.RWMJ.GT.0.).OR.
     +        (ITEM.EQ.3.AND.RWAX.GT.0.).OR.
     +        (ITEM.EQ.4.AND.RWLB.GT.0.)) THEN
            CALL PLOTIF (0.,0.,2)
            IF (ICFELL('GRIDAL',46).NE.0) RETURN
            CALL GSLWSC (SLWS)
          END IF
C
  104   CONTINUE
C
C Flush the SPPS pen-move buffer.
C
        CALL PLOTIF (0.,0.,2)
        IF (ICFELL('GRIDAL',47).NE.0) RETURN
C
C Restore the original state of the clipping indicator.
C
        CALL GSCLIP (ICLP)
C
C Done.
C
        RETURN
C
      END

C
C	$Id: gzclrwk.f,v 1.5 2008-07-27 00:21:03 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GZCLRWK(WKID,COFL)
C
C  CLEAR WORKSTATION
C
      INTEGER ECLRWK
      PARAMETER (ECLRWK=6)
C
      include 'gkscom.h'
C
      INTEGER WKID,COFL,FCODEO,CONTO
C
C  Check that GKS is in the proper state.
C
      CALL GZCKST(6,ECLRWK,IER)
      IF (IER .NE. 0) RETURN
C
C  Check if workstation identifier is valid.
C
      CALL GZCKWK(20,ECLRWK,WKID,IDUM,IER)
      IF (IER .NE. 0) RETURN
C
C  Check if the specified workstation is open.
C
      CALL GZCKWK(25,ECLRWK,WKID,IDUM,IER)
      IF (IER .NE. 0) RETURN
C
C  Check on workstation category.
C
      CALL GQWKC(WKID,IER,ICONID,ITYPE)
      IF (IER .NE. 0) THEN
        ERS = 1
        CALL GERHND(IER,ECLRWK,ERF)
        ERS = 0
        RETURN
      ENDIF
      CALL GQWKCA(ITYPE,IER,ICAT)
      IF (IER .NE. 0) THEN
        ERS = 1
        CALL GERHND(IER,ECLRWK,ERF)
        ERS = 0
        RETURN
      ENDIF
      IF (ICAT .EQ. GMI) THEN
        IER = 33
        ERS = 1
        CALL GERHND(IER,ECLRWK,ERF)
        ERS = 0
        RETURN
      ELSE IF (ICAT .EQ. GINPUT) THEN
        IER = 35
        ERS = 1
        CALL GERHND(IER,ECLRWK,ERF)
        ERS = 0
        RETURN
      ENDIF
C
C  Put out new picture initialization if CGM and the picture is empty.        
C
      IF (ITYPE .EQ. GCGM) THEN
        IF (NOPICT .LE. 0) THEN
          FCODEO = FCODE
          CONTO  = CONT
          FCODE = 91
          CONT  =  0
          CALL GZROI(0)
          CALL G01WDR(WKID,' ')
          FCODE  = FCODEO
          CONT   = CONTO
          NOPICT = 1
        ENDIF
      ENDIF
C
C  Invoke the workstation interface.
C
C  Set the flag CUFLAG to indicate that the interface call should go
C  only to the specifically designated workstation.
C
      CUFLAG = WKID
      FCODE = 1
      CONT  = 0
      CALL GZROI(0)
      IL1 = 2
      IL2 = 2
      ID(1) = WKID
      ID(2) = COFL
      CALL GZTOWK
      IF (RERR.NE.0) THEN
        ERS = 1
        CALL GERHND(RERR,ECLRWK,ERF)
        ERS = 0
      ENDIF
      CUFLAG = -1
C
C  Set flag to indicate that the current picture is empty if CGM.
C
      IF (ITYPE .EQ. GCGM) NOPICT = 0
C
      RETURN
      END

      SUBROUTINE SLARFB( SIDE, TRANS, DIRECT, STOREV, M, N, K, V, LDV,
     $                   T, LDT, C, LDC, WORK, LDWORK )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     February 29, 1992
*
*     .. Scalar Arguments ..
      CHARACTER          DIRECT, SIDE, STOREV, TRANS
      INTEGER            K, LDC, LDT, LDV, LDWORK, M, N
*     ..
*     .. Array Arguments ..
      REAL               C( LDC, * ), T( LDT, * ), V( LDV, * ),
     $                   WORK( LDWORK, * )
*     ..
*
*  Purpose
*  =======
*
*  SLARFB applies a real block reflector H or its transpose H' to a
*  real m by n matrix C, from either the left or the right.
*
*  Arguments
*  =========
*
*  SIDE    (input) CHARACTER*1
*          = 'L': apply H or H' from the Left
*          = 'R': apply H or H' from the Right
*
*  TRANS   (input) CHARACTER*1
*          = 'N': apply H (No transpose)
*          = 'T': apply H' (Transpose)
*
*  DIRECT  (input) CHARACTER*1
*          Indicates how H is formed from a product of elementary
*          reflectors
*          = 'F': H = H(1) H(2) . . . H(k) (Forward)
*          = 'B': H = H(k) . . . H(2) H(1) (Backward)
*
*  STOREV  (input) CHARACTER*1
*          Indicates how the vectors which define the elementary
*          reflectors are stored:
*          = 'C': Columnwise
*          = 'R': Rowwise
*
*  M       (input) INTEGER
*          The number of rows of the matrix C.
*
*  N       (input) INTEGER
*          The number of columns of the matrix C.
*
*  K       (input) INTEGER
*          The order of the matrix T (= the number of elementary
*          reflectors whose product defines the block reflector).
*
*  V       (input) REAL array, dimension
*                                (LDV,K) if STOREV = 'C'
*                                (LDV,M) if STOREV = 'R' and SIDE = 'L'
*                                (LDV,N) if STOREV = 'R' and SIDE = 'R'
*          The matrix V. See further details.
*
*  LDV     (input) INTEGER
*          The leading dimension of the array V.
*          If STOREV = 'C' and SIDE = 'L', LDV >= max(1,M);
*          if STOREV = 'C' and SIDE = 'R', LDV >= max(1,N);
*          if STOREV = 'R', LDV >= K.
*
*  T       (input) REAL array, dimension (LDT,K)
*          The triangular k by k matrix T in the representation of the
*          block reflector.
*
*  LDT     (input) INTEGER
*          The leading dimension of the array T. LDT >= K.
*
*  C       (input/output) REAL array, dimension (LDC,N)
*          On entry, the m by n matrix C.
*          On exit, C is overwritten by H*C or H'*C or C*H or C*H'.
*
*  LDC     (input) INTEGER
*          The leading dimension of the array C. LDA >= max(1,M).
*
*  WORK    (workspace) REAL array, dimension (LDWORK,K)
*
*  LDWORK  (input) INTEGER
*          The leading dimension of the array WORK.
*          If SIDE = 'L', LDWORK >= max(1,N);
*          if SIDE = 'R', LDWORK >= max(1,M).
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ONE
      PARAMETER          ( ONE = 1.0E+0 )
*     ..
*     .. Local Scalars ..
      CHARACTER          TRANST
      INTEGER            I, J
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           SCOPY, SGEMM, STRMM
*     ..
*     .. Executable Statements ..
*
*     Quick return if possible
*
      IF( M.LE.0 .OR. N.LE.0 )
     $   RETURN
*
      IF( LSAME( TRANS, 'N' ) ) THEN
         TRANST = 'T'
      ELSE
         TRANST = 'N'
      END IF
*
      IF( LSAME( STOREV, 'C' ) ) THEN
*
         IF( LSAME( DIRECT, 'F' ) ) THEN
*
*           Let  V =  ( V1 )    (first K rows)
*                     ( V2 )
*           where  V1  is unit lower triangular.
*
            IF( LSAME( SIDE, 'L' ) ) THEN
*
*              Form  H * C  or  H' * C  where  C = ( C1 )
*                                                  ( C2 )
*
*              W := C' * V  =  (C1'*V1 + C2'*V2)  (stored in WORK)
*
*              W := C1'
*
               DO 10 J = 1, K
                  CALL SCOPY( N, C( J, 1 ), LDC, WORK( 1, J ), 1 )
   10          CONTINUE
*
*              W := W * V1
*
               CALL STRMM( 'Right', 'Lower', 'No transpose', 'Unit', N,
     $                     K, ONE, V, LDV, WORK, LDWORK )
               IF( M.GT.K ) THEN
*
*                 W := W + C2'*V2
*
                  CALL SGEMM( 'Transpose', 'No transpose', N, K, M-K,
     $                        ONE, C( K+1, 1 ), LDC, V( K+1, 1 ), LDV,
     $                        ONE, WORK, LDWORK )
               END IF
*
*              W := W * T'  or  W * T
*
               CALL STRMM( 'Right', 'Upper', TRANST, 'Non-unit', N, K,
     $                     ONE, T, LDT, WORK, LDWORK )
*
*              C := C - V * W'
*
               IF( M.GT.K ) THEN
*
*                 C2 := C2 - V2 * W'
*
                  CALL SGEMM( 'No transpose', 'Transpose', M-K, N, K,
     $                        -ONE, V( K+1, 1 ), LDV, WORK, LDWORK, ONE,
     $                        C( K+1, 1 ), LDC )
               END IF
*
*              W := W * V1'
*
               CALL STRMM( 'Right', 'Lower', 'Transpose', 'Unit', N, K,
     $                     ONE, V, LDV, WORK, LDWORK )
*
*              C1 := C1 - W'
*
               DO 30 J = 1, K
                  DO 20 I = 1, N
                     C( J, I ) = C( J, I ) - WORK( I, J )
   20             CONTINUE
   30          CONTINUE
*
            ELSE IF( LSAME( SIDE, 'R' ) ) THEN
*
*              Form  C * H  or  C * H'  where  C = ( C1  C2 )
*
*              W := C * V  =  (C1*V1 + C2*V2)  (stored in WORK)
*
*              W := C1
*
               DO 40 J = 1, K
                  CALL SCOPY( M, C( 1, J ), 1, WORK( 1, J ), 1 )
   40          CONTINUE
*
*              W := W * V1
*
               CALL STRMM( 'Right', 'Lower', 'No transpose', 'Unit', M,
     $                     K, ONE, V, LDV, WORK, LDWORK )
               IF( N.GT.K ) THEN
*
*                 W := W + C2 * V2
*
                  CALL SGEMM( 'No transpose', 'No transpose', M, K, N-K,
     $                        ONE, C( 1, K+1 ), LDC, V( K+1, 1 ), LDV,
     $                        ONE, WORK, LDWORK )
               END IF
*
*              W := W * T  or  W * T'
*
               CALL STRMM( 'Right', 'Upper', TRANS, 'Non-unit', M, K,
     $                     ONE, T, LDT, WORK, LDWORK )
*
*              C := C - W * V'
*
               IF( N.GT.K ) THEN
*
*                 C2 := C2 - W * V2'
*
                  CALL SGEMM( 'No transpose', 'Transpose', M, N-K, K,
     $                        -ONE, WORK, LDWORK, V( K+1, 1 ), LDV, ONE,
     $                        C( 1, K+1 ), LDC )
               END IF
*
*              W := W * V1'
*
               CALL STRMM( 'Right', 'Lower', 'Transpose', 'Unit', M, K,
     $                     ONE, V, LDV, WORK, LDWORK )
*
*              C1 := C1 - W
*
               DO 60 J = 1, K
                  DO 50 I = 1, M
                     C( I, J ) = C( I, J ) - WORK( I, J )
   50             CONTINUE
   60          CONTINUE
            END IF
*
         ELSE
*
*           Let  V =  ( V1 )
*                     ( V2 )    (last K rows)
*           where  V2  is unit upper triangular.
*
            IF( LSAME( SIDE, 'L' ) ) THEN
*
*              Form  H * C  or  H' * C  where  C = ( C1 )
*                                                  ( C2 )
*
*              W := C' * V  =  (C1'*V1 + C2'*V2)  (stored in WORK)
*
*              W := C2'
*
               DO 70 J = 1, K
                  CALL SCOPY( N, C( M-K+J, 1 ), LDC, WORK( 1, J ), 1 )
   70          CONTINUE
*
*              W := W * V2
*
               CALL STRMM( 'Right', 'Upper', 'No transpose', 'Unit', N,
     $                     K, ONE, V( M-K+1, 1 ), LDV, WORK, LDWORK )
               IF( M.GT.K ) THEN
*
*                 W := W + C1'*V1
*
                  CALL SGEMM( 'Transpose', 'No transpose', N, K, M-K,
     $                        ONE, C, LDC, V, LDV, ONE, WORK, LDWORK )
               END IF
*
*              W := W * T'  or  W * T
*
               CALL STRMM( 'Right', 'Lower', TRANST, 'Non-unit', N, K,
     $                     ONE, T, LDT, WORK, LDWORK )
*
*              C := C - V * W'
*
               IF( M.GT.K ) THEN
*
*                 C1 := C1 - V1 * W'
*
                  CALL SGEMM( 'No transpose', 'Transpose', M-K, N, K,
     $                        -ONE, V, LDV, WORK, LDWORK, ONE, C, LDC )
               END IF
*
*              W := W * V2'
*
               CALL STRMM( 'Right', 'Upper', 'Transpose', 'Unit', N, K,
     $                     ONE, V( M-K+1, 1 ), LDV, WORK, LDWORK )
*
*              C2 := C2 - W'
*
               DO 90 J = 1, K
                  DO 80 I = 1, N
                     C( M-K+J, I ) = C( M-K+J, I ) - WORK( I, J )
   80             CONTINUE
   90          CONTINUE
*
            ELSE IF( LSAME( SIDE, 'R' ) ) THEN
*
*              Form  C * H  or  C * H'  where  C = ( C1  C2 )
*
*              W := C * V  =  (C1*V1 + C2*V2)  (stored in WORK)
*
*              W := C2
*
               DO 100 J = 1, K
                  CALL SCOPY( M, C( 1, N-K+J ), 1, WORK( 1, J ), 1 )
  100          CONTINUE
*
*              W := W * V2
*
               CALL STRMM( 'Right', 'Upper', 'No transpose', 'Unit', M,
     $                     K, ONE, V( N-K+1, 1 ), LDV, WORK, LDWORK )
               IF( N.GT.K ) THEN
*
*                 W := W + C1 * V1
*
                  CALL SGEMM( 'No transpose', 'No transpose', M, K, N-K,
     $                        ONE, C, LDC, V, LDV, ONE, WORK, LDWORK )
               END IF
*
*              W := W * T  or  W * T'
*
               CALL STRMM( 'Right', 'Lower', TRANS, 'Non-unit', M, K,
     $                     ONE, T, LDT, WORK, LDWORK )
*
*              C := C - W * V'
*
               IF( N.GT.K ) THEN
*
*                 C1 := C1 - W * V1'
*
                  CALL SGEMM( 'No transpose', 'Transpose', M, N-K, K,
     $                        -ONE, WORK, LDWORK, V, LDV, ONE, C, LDC )
               END IF
*
*              W := W * V2'
*
               CALL STRMM( 'Right', 'Upper', 'Transpose', 'Unit', M, K,
     $                     ONE, V( N-K+1, 1 ), LDV, WORK, LDWORK )
*
*              C2 := C2 - W
*
               DO 120 J = 1, K
                  DO 110 I = 1, M
                     C( I, N-K+J ) = C( I, N-K+J ) - WORK( I, J )
  110             CONTINUE
  120          CONTINUE
            END IF
         END IF
*
      ELSE IF( LSAME( STOREV, 'R' ) ) THEN
*
         IF( LSAME( DIRECT, 'F' ) ) THEN
*
*           Let  V =  ( V1  V2 )    (V1: first K columns)
*           where  V1  is unit upper triangular.
*
            IF( LSAME( SIDE, 'L' ) ) THEN
*
*              Form  H * C  or  H' * C  where  C = ( C1 )
*                                                  ( C2 )
*
*              W := C' * V'  =  (C1'*V1' + C2'*V2') (stored in WORK)
*
*              W := C1'
*
               DO 130 J = 1, K
                  CALL SCOPY( N, C( J, 1 ), LDC, WORK( 1, J ), 1 )
  130          CONTINUE
*
*              W := W * V1'
*
               CALL STRMM( 'Right', 'Upper', 'Transpose', 'Unit', N, K,
     $                     ONE, V, LDV, WORK, LDWORK )
               IF( M.GT.K ) THEN
*
*                 W := W + C2'*V2'
*
                  CALL SGEMM( 'Transpose', 'Transpose', N, K, M-K, ONE,
     $                        C( K+1, 1 ), LDC, V( 1, K+1 ), LDV, ONE,
     $                        WORK, LDWORK )
               END IF
*
*              W := W * T'  or  W * T
*
               CALL STRMM( 'Right', 'Upper', TRANST, 'Non-unit', N, K,
     $                     ONE, T, LDT, WORK, LDWORK )
*
*              C := C - V' * W'
*
               IF( M.GT.K ) THEN
*
*                 C2 := C2 - V2' * W'
*
                  CALL SGEMM( 'Transpose', 'Transpose', M-K, N, K, -ONE,
     $                        V( 1, K+1 ), LDV, WORK, LDWORK, ONE,
     $                        C( K+1, 1 ), LDC )
               END IF
*
*              W := W * V1
*
               CALL STRMM( 'Right', 'Upper', 'No transpose', 'Unit', N,
     $                     K, ONE, V, LDV, WORK, LDWORK )
*
*              C1 := C1 - W'
*
               DO 150 J = 1, K
                  DO 140 I = 1, N
                     C( J, I ) = C( J, I ) - WORK( I, J )
  140             CONTINUE
  150          CONTINUE
*
            ELSE IF( LSAME( SIDE, 'R' ) ) THEN
*
*              Form  C * H  or  C * H'  where  C = ( C1  C2 )
*
*              W := C * V'  =  (C1*V1' + C2*V2')  (stored in WORK)
*
*              W := C1
*
               DO 160 J = 1, K
                  CALL SCOPY( M, C( 1, J ), 1, WORK( 1, J ), 1 )
  160          CONTINUE
*
*              W := W * V1'
*
               CALL STRMM( 'Right', 'Upper', 'Transpose', 'Unit', M, K,
     $                     ONE, V, LDV, WORK, LDWORK )
               IF( N.GT.K ) THEN
*
*                 W := W + C2 * V2'
*
                  CALL SGEMM( 'No transpose', 'Transpose', M, K, N-K,
     $                        ONE, C( 1, K+1 ), LDC, V( 1, K+1 ), LDV,
     $                        ONE, WORK, LDWORK )
               END IF
*
*              W := W * T  or  W * T'
*
               CALL STRMM( 'Right', 'Upper', TRANS, 'Non-unit', M, K,
     $                     ONE, T, LDT, WORK, LDWORK )
*
*              C := C - W * V
*
               IF( N.GT.K ) THEN
*
*                 C2 := C2 - W * V2
*
                  CALL SGEMM( 'No transpose', 'No transpose', M, N-K, K,
     $                        -ONE, WORK, LDWORK, V( 1, K+1 ), LDV, ONE,
     $                        C( 1, K+1 ), LDC )
               END IF
*
*              W := W * V1
*
               CALL STRMM( 'Right', 'Upper', 'No transpose', 'Unit', M,
     $                     K, ONE, V, LDV, WORK, LDWORK )
*
*              C1 := C1 - W
*
               DO 180 J = 1, K
                  DO 170 I = 1, M
                     C( I, J ) = C( I, J ) - WORK( I, J )
  170             CONTINUE
  180          CONTINUE
*
            END IF
*
         ELSE
*
*           Let  V =  ( V1  V2 )    (V2: last K columns)
*           where  V2  is unit lower triangular.
*
            IF( LSAME( SIDE, 'L' ) ) THEN
*
*              Form  H * C  or  H' * C  where  C = ( C1 )
*                                                  ( C2 )
*
*              W := C' * V'  =  (C1'*V1' + C2'*V2') (stored in WORK)
*
*              W := C2'
*
               DO 190 J = 1, K
                  CALL SCOPY( N, C( M-K+J, 1 ), LDC, WORK( 1, J ), 1 )
  190          CONTINUE
*
*              W := W * V2'
*
               CALL STRMM( 'Right', 'Lower', 'Transpose', 'Unit', N, K,
     $                     ONE, V( 1, M-K+1 ), LDV, WORK, LDWORK )
               IF( M.GT.K ) THEN
*
*                 W := W + C1'*V1'
*
                  CALL SGEMM( 'Transpose', 'Transpose', N, K, M-K, ONE,
     $                        C, LDC, V, LDV, ONE, WORK, LDWORK )
               END IF
*
*              W := W * T'  or  W * T
*
               CALL STRMM( 'Right', 'Lower', TRANST, 'Non-unit', N, K,
     $                     ONE, T, LDT, WORK, LDWORK )
*
*              C := C - V' * W'
*
               IF( M.GT.K ) THEN
*
*                 C1 := C1 - V1' * W'
*
                  CALL SGEMM( 'Transpose', 'Transpose', M-K, N, K, -ONE,
     $                        V, LDV, WORK, LDWORK, ONE, C, LDC )
               END IF
*
*              W := W * V2
*
               CALL STRMM( 'Right', 'Lower', 'No transpose', 'Unit', N,
     $                     K, ONE, V( 1, M-K+1 ), LDV, WORK, LDWORK )
*
*              C2 := C2 - W'
*
               DO 210 J = 1, K
                  DO 200 I = 1, N
                     C( M-K+J, I ) = C( M-K+J, I ) - WORK( I, J )
  200             CONTINUE
  210          CONTINUE
*
            ELSE IF( LSAME( SIDE, 'R' ) ) THEN
*
*              Form  C * H  or  C * H'  where  C = ( C1  C2 )
*
*              W := C * V'  =  (C1*V1' + C2*V2')  (stored in WORK)
*
*              W := C2
*
               DO 220 J = 1, K
                  CALL SCOPY( M, C( 1, N-K+J ), 1, WORK( 1, J ), 1 )
  220          CONTINUE
*
*              W := W * V2'
*
               CALL STRMM( 'Right', 'Lower', 'Transpose', 'Unit', M, K,
     $                     ONE, V( 1, N-K+1 ), LDV, WORK, LDWORK )
               IF( N.GT.K ) THEN
*
*                 W := W + C1 * V1'
*
                  CALL SGEMM( 'No transpose', 'Transpose', M, K, N-K,
     $                        ONE, C, LDC, V, LDV, ONE, WORK, LDWORK )
               END IF
*
*              W := W * T  or  W * T'
*
               CALL STRMM( 'Right', 'Lower', TRANS, 'Non-unit', M, K,
     $                     ONE, T, LDT, WORK, LDWORK )
*
*              C := C - W * V
*
               IF( N.GT.K ) THEN
*
*                 C1 := C1 - W * V1
*
                  CALL SGEMM( 'No transpose', 'No transpose', M, N-K, K,
     $                        -ONE, WORK, LDWORK, V, LDV, ONE, C, LDC )
               END IF
*
*              W := W * V2
*
               CALL STRMM( 'Right', 'Lower', 'No transpose', 'Unit', M,
     $                     K, ONE, V( 1, N-K+1 ), LDV, WORK, LDWORK )
*
*              C1 := C1 - W
*
               DO 240 J = 1, K
                  DO 230 I = 1, M
                     C( I, N-K+J ) = C( I, N-K+J ) - WORK( I, J )
  230             CONTINUE
  240          CONTINUE
*
            END IF
*
         END IF
      END IF
*
      RETURN
*
*     End of SLARFB
*
      END

C
C       $Id: curvs1dp.f,v 1.3 2008-07-27 03:10:11 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
C NOTE: If you make any changes to this software, please remember to
C make the same changes to the corresponding single precision routine.
C
      SUBROUTINE CURVS1DP(N,X,Y,D,ISW,S,EPS,PARAM,XS,YS,XSP,YSP,SIGMA,
     +                    TEMP,IERR)
      DOUBLE PRECISION TSM
      DOUBLE PRECISION SM
C
C  This subroutine determines the parameters necessary to
C  compute a smoothing spline under tension from data values
C  in the plane.  In general the curve will not pass through
C  the original data points.  For actual computation of points
C  on the C  curve it is necessary to call the subroutine CURVS2DP.
C
C  On input:
C
C    N
C      The number of points to be interpolated (N .GE. 2).
C
C    X
C      An array containing N X-coordinates of the input data.
C
C    Y
C      An array containing N Y-coordinates of the
C      input data. (adjacent X-Y pairs must be distinct, i.e.
C      either X(I) .NE. X(I+1) or Y(I) .NE. Y(I+1), for
C      I = 1,...,N-1.)
C
C    D
C      A parameter containing the observation weights.
C      this may either be an array of length N or a scalar
C      (interpreted as a constant).  The value of D
C      corresponding to the observation (X(K),Y(K)) should
C      be an approximation to the standard deviation of error.
C      Effectively the value of D controls how close the smoothed
C      curve comes to the input data points. If D is small
C      then the interpolated curve will pass close to the input data.
C      The larger the value of D, the more freedom the smooth curve
C      has in how close it comes to the input data values.
C
C    ISW
C      A switch indicating whether the parameter D is to be
C      considered a vector or a scalar,
C
C          = 0 if D is an array of length N,
C          = 1 if D is a scalar.
C
C    S
C      The value controlling the smoothing. this
C      must be non-negative.  For S equal to zero, the
C      subroutine does interpolation, larger values lead to
C      smoother funtions.  If parameter D contains standard
C      deviation estimates, a reasonable value for S is
C      FLOAT(N).
C
C    EPS
C      Contains a tolerance on the relative precision to
C      which S is to be interpreted. this must be greater than
C      or equal to zero and less than or equal to one.  A
C      reasonable value for EPS is SQRT(2./FLOAT(N)).
C
C    PARAM
C      An array of length at least N.
C
C    XS
C      An array of length at least N.
C
C    XSP
C      An array of length at least N.
C
C    YS
C      An array of length at least N.
C
C    YSP
C      An array of length at least N.
C
C    SIGMA
C      The tension factor.  This value indicates
C      the degree to which the first derivative part of the
C      smoothing functional is emphasized.  If SIGMA is nearly
C      zero (e.g. 0.001), the resulting curve is approximately a
C      cubic spline.  If SIGMA is large (e.g. 50.), the
C      resulting curve is nearly a polygonal line.  If sigma
C      equals zero a cubic spline results.  A standard value for
C      SIGMA is approximately 1.
C
C    TEMP
C      An array of length at least 19*N which is used
C      for scratch storage.
C
C
C  On output:
C
C    PARAM
C      PARAM(I) is the arc length of the curve up through
C      point (X(I),Y(I)), divided by the total arc length.
C
C    XS
C      The smoothed X-coordinate values.
C
C    XSP
C      The values of the second derivative of the
C      smoothed X-coordinate values at the given nodes.
C
C    YS
C      The smoothed Y-coordinate values.
C
C    YSP
C      The values of the second derivative of the
C      smoothed Y-coordinate values at the given nodes.
C
C    IERR
C      An error flag,
C         = 0 for normal return,
C         = 1 if N is less than 2,
C         = 2 if S is negative,
C         = 3 if EPS is negative or greater than one,
C         = 5 if a D-value is non-positive.
C
C  and
C
C    N, X, Y, D, ISW, S, EPS, and SIGMA are unaltered.
C
C this subroutine references package module CURVSDP.
C
      DOUBLE PRECISION X(N),Y(N),D(N),S,EPS,PARAM(N),XS(N),YS(N),XSP(N),
     +                 YSP(N),SIGMA,TEMP(N,20)
C
C  Calculate the arc length of each polygonal segment.
C
      TEMP(1,1) = 0.D0
      DO 10 I = 2,N
          IM1 = I - 1
          TEMP(I,1) = SQRT((X(I)-X(IM1))**2+ (Y(I)-Y(IM1))**2)
   10 CONTINUE
C
C  Calculate the total arc length.
C
      TSM = 0
      DO 5 I = 1,N
          TSM = TSM + TEMP(I,1)
    5 CONTINUE
C
C  Calculate the arc length parameter values at the input points.
C
      PARAM(1) = 0.D0
      DO 20 I = 2,N
          SM = 0
          DO 30 J = 1,I
              SM = SM + TEMP(J,1)
   30     CONTINUE
          PARAM(I) = SM/TSM
   20 CONTINUE
C
C  Get the smoothing coordinates for both X and Y.
C
      CALL CURVSDP(N,PARAM,X,D,ISW,S,EPS,XS,XSP,SIGMA,TEMP(1,2),IERR)
      CALL CURVSDP(N,PARAM,Y,D,ISW,S,EPS,YS,YSP,SIGMA,TEMP(1,11),IERR)
C
      RETURN
      END

C
C $Id: mdrgdp.f,v 1.9 2008-09-18 00:42:18 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MDRGDP (XCRA,YCRA,NCRA,ITYP)
C
        DIMENSION XCRA(NCRA),YCRA(NCRA)
C
C Declare required EZMAP common blocks.
C
        COMMON /MAPRGD/  ICOL(5),ICSF(5),IDPF,LCRA,NILN,NILT,OLAT,OLON
        INTEGER          ICOL,ICSF,IDPF,LCRA,NILN,NILT
        REAL             OLAT,OLON
        SAVE   /MAPRGD/
C
        IF (NCRA.GT.1.AND.ITYP.GT.0) THEN
          IF (ICOL(ITYP).GE.0) THEN
            NCRM=0
            DO 101 I=1,NCRA
              CALL MAPTRN (OLAT+YCRA(I),OLON+XCRA(I),UVAL,VVAL)
              IF (UVAL.NE.1.E12) THEN
                NCRM=NCRM+1
                XCRA(NCRM)=UVAL
                YCRA(NCRM)=VVAL
              END IF
  101       CONTINUE
            IF (NCRM.GT.1) THEN
              CALL SFLUSH
              CALL GSPLCI (ICOL(ITYP))
              CALL GPL    (NCRM,XCRA,YCRA)
            END IF
          END IF
        END IF
C
        RETURN
C
      END

C
C	$Id: gca.f,v 1.7 2008-07-27 00:20:56 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GCA(PX,PY,QX,QY,DIMX,DIMY,NCS,NRS,DX,DY,COLIA)
C
C  CELL ARRAY
C
      INTEGER ECA
      PARAMETER (ECA=16)
C
      include 'gkscom.h'
C
      INTEGER DIMX,DIMY,DX,DY,COLIA(DIMX,*)
      REAL PX,PY,QX,QY
C
C  Check if GKS is in the proper state.
C
      CALL GZCKST(5,ECA,IER)
      IF (IER .NE. 0) RETURN
C
C  Check that the indices of the color array are valid.
C
      IF (DIMX.LE.0 .OR. DIMY.LE.0 .OR. NRS+DY-1.GT.DIMY .OR. 
     +    NCS+DX-1  .GT. DIMX) THEN
        ERS = 1
        CALL GERHND(91,ECA,ERF)
        ERS = 0
        RETURN
      ENDIF
C
      PXN = PX
      PYN = PY
      QXN = QX
      QYN = QY
C
C  Find a third corner.
C
      OXN = QXN
      OYN = PYN
C
C  Convert the corners to NDC space.
C
      CALL GZW2NX(1,OXN,OXP)
      CALL GZW2NX(1,PXN,PXP)
      CALL GZW2NX(1,QXN,QXP)
      CALL GZW2NY(1,OYN,OYP)
      CALL GZW2NY(1,PYN,PYP)
      CALL GZW2NY(1,QYN,QYP)
C
C  Make the interface calls.
C
      FCODE = 15
      CALL GZROI(0)
      IL1   =  2
      IL2   =  2
      ID(1) =  DX
      ID(2) =  DY
      RL1   =   3
      RL2   =   3
      RX(1) = PXP
      RY(1) = PYP
      RX(2) = QXP
      RY(2) = QYP
      RX(3) = OXP
      RY(3) = OYP
      STRL1 = 0
      STRL2 = 0
C
      N = DX*DY
      J = (N-1)/128
      IC1 = N
      IF (J .EQ. 0) THEN
C
C  Case where there is no continuation.
C
        CONT = 0
        IC2  = N
        INDX = 0
        DO 200 K=1,DY
          DO 201 I=1,DX
            INDX  = INDX+1
            IC(INDX) = COLIA(NCS+I-1,NRS+K-1)
  201     CONTINUE
  200   CONTINUE
        CALL GZTOWK
        IF (RERR.NE.0) THEN
          ERS = 1
          CALL GERHND(RERR,ECA,ERF)
          ERS = 0
          RETURN
        ENDIF
      ELSE
C
C  Case with continuation.
C
        CONT = 1
        IC1 = N
        IC2 = 128
        INDX = 0
        IFRST = 0
        DO 202 M=1,DY
          DO 203 L=1,DX
            INDX = INDX+1
            JM = MOD(INDX,128)
            IF (JM.EQ.0 .AND. INDX.LT.N) THEN
              IC(128) = COLIA(NCS+L-1,NRS+M-1)
              IF (IFRST .GT .0) THEN
                IL2 = 0
                RL2 = 0
              ENDIF
              CALL GZTOWK
              IFRST = IFRST+1
              CALL GZROI(1)
              IF (RERR.NE.0) THEN
                ERS = 1
                CALL GERHND(RERR,ECA,ERF)
                ERS = 0
                RETURN
              ENDIF
            ELSE IF (JM.NE.0  .AND.  INDX.LT.N) THEN
              IC(JM) = COLIA(NCS+L-1,NRS+M-1)
            ELSE
C
C  Final case where INDX=N.
C
              CONT = 0
              IF (JM .EQ. 0) THEN
                IC(128) = COLIA(NCS+L-1,NRS+M-1)
                IF (IFRST .GT .0) THEN
                  IL2 = 0
                  RL2 = 0
                ENDIF
                CALL GZTOWK
                IFRST = IFRST+1
                CALL GZROI(1)
                IF (RERR .NE. 0) THEN
                  ERS = 1
                  CALL GERHND(RERR,ECA,ERF)
                  ERS = 0
                  RETURN
                ENDIF
              ELSE
                IC(JM) = COLIA(NCS+L-1,NRS+M-1)
                IC2 = MOD(N,128)
                IF (IFRST .GT .0) THEN
                  IL2 = 0
                  RL2 = 0
                ENDIF
                CALL GZTOWK
                IFRST = IFRST+1
                CALL GZROI(1)
                IF (RERR .NE. 0) THEN
                  ERS = 1
                  CALL GERHND(RERR,ECA,ERF)
                  ERS = 0
                  RETURN
                ENDIF
              ENDIF
            ENDIF
  203     CONTINUE
  202   CONTINUE
      ENDIF
C
      RETURN
      END

C
C $Id: mdinch.f,v 1.8 2008-09-18 00:42:17 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MDINCH (INUM,CHRS,NCHR)
C
C This routine, when given an integer INUM (which should be in the
C range from 0 to 999, inclusive) and a character buffer CHRS already
C containing NCHS characters, adds the character representation of
C the integer to the buffer.
C
        INTEGER       INUM
        CHARACTER*(*) CHRS
        INTEGER       NCHR
C
C Declare local variables.
C
        INTEGER       IDIG,ITMP
C
C Don't trust the user ... :-)
C
        ITMP=MAX(0,MIN(999,ABS(INUM)))
C
C Decide whether 3, 2, or 1 characters will be generated and increment
C NCHR appropriately.
C
        IF (ITMP.GE.100) THEN
          NCHR=NCHR+3
        ELSE IF (ITMP.GE.10) THEN
          NCHR=NCHR+2
        ELSE
          NCHR=NCHR+1
        END IF
C
C Generate the characters (in reverse order) and store them.
C
        IDIG=0
C
  101   CHRS(NCHR-IDIG:NCHR-IDIG)=CHAR(ICHAR('0')+MOD(ITMP,10))
        ITMP=ITMP/10
        IDIG=IDIG+1
        IF (ITMP.NE.0) GO TO 101
C
C Done.
C
        RETURN
C
      END

C
C	$Id: conloc.f,v 1.5 2008-07-27 00:16:57 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CONLOC (NDP,XD,YD,NT,IPT,NL,IPL,XII,YII,ITI,IWK,WK)
C
C THIS SUBROUTINE LOCATES A POINT, I.E., DETERMINES TO WHAT TRI-
C ANGLE A GIVEN POINT (XII,YII) BELONGS.  WHEN THE GIVEN POINT
C DOES NOT LIE INSIDE THE DATA AREA, THIS SUBROUTINE DETERMINES
C THE BORDER LINE SEGMENT WHEN THE POINT LIES IN AN OUTSIDE
C RECTANGULAR AREA, AND TWO BORDER LINE SEGMENTS WHEN THE POINT
C LIES IN AN OUTSIDE TRIANGULAR AREA.
C THE INPUT PARAMETERS ARE
C     NDP = NUMBER OF DATA POINTS,
C     XD,YD = ARRAYS OF DIMENSION NDP CONTAINING THE X AND Y
C           COORDINATES OF THE DATA POINTS,
C     NT  = NUMBER OF TRIANGLES,
C     IPT = INTEGER ARRAY OF DIMENSION 3*NT CONTAINING THE
C           POINT NUMBERS OF THE VERTEXES OF THE TRIANGLES,
C     NL  = NUMBER OF BORDER LINE SEGMENTS,
C     IPL = INTEGER ARRAY OF DIMENSION 3*NL CONTAINING THE
C           POINT NUMBERS OF THE END POINTS OF THE BORDER
C           LINE SEGMENTS AND THEIR RESPECTIVE TRIANGLE
C           NUMBERS,
C     XII,YII = X AND Y COORDINATES OF THE POINT TO BE
C           LOCATED.
C THE OUTPUT PARAMETER IS
C     ITI = TRIANGLE NUMBER, WHEN THE POINT IS INSIDE THE
C           DATA AREA, OR
C           TWO BORDER LINE SEGMENT NUMBERS, IL1 AND IL2,
C           CODED TO IL1*(NT+NL)+IL2, WHEN THE POINT IS
C           OUTSIDE THE DATA AREA.
C THE OTHER PARAMETERS ARE
C     IWK = INTEGER ARRAY OF DIMENSION 18*NDP USED INTER-
C           NALLY AS A WORK AREA,
C     WK  = ARRAY OF DIMENSION 8*NDP USED INTERNALLY AS A
C           WORK AREA.
C DECLARATION STATEMENTS
C
      DIMENSION       XD(1)      ,YD(1)      ,IPT(1)     ,IPL(1)     ,
     1                IWK(1)     ,WK(1)
C
C
C
      DIMENSION       NTSC(9)    ,IDSC(9)
      COMMON /CONRA5/ NIT        ,ITIPV
C
        SAVE
C
C STATEMENT FUNCTIONS
C
      SIDE(U1,V1,U2,V2,U3,V3) = (U1-U3)*(V2-V3)-(V1-V3)*(U2-U3)
      SPDT(U1,V1,U2,V2,U3,V3) = (U1-U2)*(U3-U2)+(V1-V2)*(V3-V2)
C
C PRELIMINARY PROCESSING
C
      NT0 = NT
      NL0 = NL
      NTL = NT0+NL0
      X0 = XII
      Y0 = YII
C
C PROCESSING FOR A NEW SET OF DATA POINTS
C
      IF (NIT .NE. 0) GO TO  170
      NIT = 1
C
C - DIVIDES THE X-Y PLANE INTO NINE RECTANGULAR SECTIONS.
C
      XMN = XD(1)
      XMX = XMN
      YMN = YD(1)
      YMX = YMN
      DO  100 IDP=2,NDP
         XI = XD(IDP)
         YI = YD(IDP)
         XMN = MIN(XI,XMN)
         XMX = MAX(XI,XMX)
         YMN = MIN(YI,YMN)
         YMX = MAX(YI,YMX)
  100 CONTINUE
      XS1 = (XMN+XMN+XMX)/3.0
      XS2 = (XMN+XMX+XMX)/3.0
      YS1 = (YMN+YMN+YMX)/3.0
      YS2 = (YMN+YMX+YMX)/3.0
C
C - DETERMINES AND STORES IN THE IWK ARRAY TRIANGLE NUMBERS OF
C - THE TRIANGLES ASSOCIATED WITH EACH OF THE NINE SECTIONS.
C
      DO  110 ISC=1,9
         NTSC(ISC) = 0
         IDSC(ISC) = 0
  110 CONTINUE
      IT0T3 = 0
      JWK = 0
      DO  160 IT0=1,NT0
         IT0T3 = IT0T3+3
         I1 = IPT(IT0T3-2)
         I2 = IPT(IT0T3-1)
         I3 = IPT(IT0T3)
         XMN = MIN(XD(I1),XD(I2),XD(I3))
         XMX = MAX(XD(I1),XD(I2),XD(I3))
         YMN = MIN(YD(I1),YD(I2),YD(I3))
         YMX = MAX(YD(I1),YD(I2),YD(I3))
         IF (YMN .GT. YS1) GO TO  120
         IF (XMN .LE. XS1) IDSC(1) = 1
         IF (XMX.GE.XS1 .AND. XMN.LE.XS2) IDSC(2) = 1
         IF (XMX .GE. XS2) IDSC(3) = 1
  120    IF (YMX.LT.YS1 .OR. YMN.GT.YS2) GO TO  130
         IF (XMN .LE. XS1) IDSC(4) = 1
         IF (XMX.GE.XS1 .AND. XMN.LE.XS2) IDSC(5) = 1
         IF (XMX .GE. XS2) IDSC(6) = 1
  130    IF (YMX .LT. YS2) GO TO  140
         IF (XMN .LE. XS1) IDSC(7) = 1
         IF (XMX.GE.XS1 .AND. XMN.LE.XS2) IDSC(8) = 1
         IF (XMX .GE. XS2) IDSC(9) = 1
  140    DO  150 ISC=1,9
            IF (IDSC(ISC) .EQ. 0) GO TO  150
            JIWK = 9*NTSC(ISC)+ISC
            IWK(JIWK) = IT0
            NTSC(ISC) = NTSC(ISC)+1
            IDSC(ISC) = 0
  150    CONTINUE
C
C - STORES IN THE WK ARRAY THE MINIMUM AND MAXIMUM OF THE X AND
C - Y COORDINATE VALUES FOR EACH OF THE TRIANGLE.
C
         JWK = JWK+4
         WK(JWK-3) = XMN
         WK(JWK-2) = XMX
         WK(JWK-1) = YMN
         WK(JWK) = YMX
  160 CONTINUE
      GO TO  200
C
C CHECKS IF IN THE SAME TRIANGLE AS PREVIOUS.
C
  170 IT0 = ITIPV
      IF (IT0 .GT. NT0) GO TO  180
      IT0T3 = IT0*3
      IP1 = IPT(IT0T3-2)
      X1 = XD(IP1)
      Y1 = YD(IP1)
      IP2 = IPT(IT0T3-1)
      X2 = XD(IP2)
      Y2 = YD(IP2)
      IF (SIDE(X1,Y1,X2,Y2,X0,Y0) .LT. 0.0) GO TO  200
      IP3 = IPT(IT0T3)
      X3 = XD(IP3)
      Y3 = YD(IP3)
      IF (SIDE(X2,Y2,X3,Y3,X0,Y0) .LT. 0.0) GO TO  200
      IF (SIDE(X3,Y3,X1,Y1,X0,Y0) .LT. 0.0) GO TO  200
      GO TO  260
C
C CHECKS IF ON THE SAME BORDER LINE SEGMENT.
C
  180 IL1 = IT0/NTL
      IL2 = IT0-IL1*NTL
      IL1T3 = IL1*3
      IP1 = IPL(IL1T3-2)
      X1 = XD(IP1)
      Y1 = YD(IP1)
      IP2 = IPL(IL1T3-1)
      X2 = XD(IP2)
      Y2 = YD(IP2)
      IF (IL2 .NE. IL1) GO TO  190
      IF (SPDT(X1,Y1,X2,Y2,X0,Y0) .LT. 0.0) GO TO  200
      IF (SPDT(X2,Y2,X1,Y1,X0,Y0) .LT. 0.0) GO TO  200
      IF (SIDE(X1,Y1,X2,Y2,X0,Y0) .GT. 0.0) GO TO  200
      GO TO  260
C
C CHECKS IF BETWEEN THE SAME TWO BORDER LINE SEGMENTS.
C
  190 IF (SPDT(X1,Y1,X2,Y2,X0,Y0) .GT. 0.0) GO TO  200
      IP3 = IPL(3*IL2-1)
      X3 = XD(IP3)
      Y3 = YD(IP3)
      IF (SPDT(X3,Y3,X2,Y2,X0,Y0) .LE. 0.0) GO TO  260
C
C LOCATES INSIDE THE DATA AREA.
C - DETERMINES THE SECTION IN WHICH THE POINT IN QUESTION LIES.
C
  200 ISC = 1
      IF (X0 .GE. XS1) ISC = ISC+1
      IF (X0 .GE. XS2) ISC = ISC+1
      IF (Y0 .GE. YS1) ISC = ISC+3
      IF (Y0 .GE. YS2) ISC = ISC+3
C
C - SEARCHES THROUGH THE TRIANGLES ASSOCIATED WITH THE SECTION.
C
      NTSCI = NTSC(ISC)
      IF (NTSCI .LE. 0) GO TO  220
      JIWK = -9+ISC
      DO  210 ITSC=1,NTSCI
         JIWK = JIWK+9
         IT0 = IWK(JIWK)
         JWK = IT0*4
         IF (X0 .LT. WK(JWK-3)) GO TO  210
         IF (X0 .GT. WK(JWK-2)) GO TO  210
         IF (Y0 .LT. WK(JWK-1)) GO TO  210
         IF (Y0 .GT. WK(JWK)) GO TO  210
         IT0T3 = IT0*3
         IP1 = IPT(IT0T3-2)
         X1 = XD(IP1)
         Y1 = YD(IP1)
         IP2 = IPT(IT0T3-1)
         X2 = XD(IP2)
         Y2 = YD(IP2)
         IF (SIDE(X1,Y1,X2,Y2,X0,Y0) .LT. 0.0) GO TO  210
         IP3 = IPT(IT0T3)
         X3 = XD(IP3)
         Y3 = YD(IP3)
         IF (SIDE(X2,Y2,X3,Y3,X0,Y0) .LT. 0.0) GO TO  210
         IF (SIDE(X3,Y3,X1,Y1,X0,Y0) .LT. 0.0) GO TO  210
         GO TO  260
  210 CONTINUE
C
C LOCATES OUTSIDE THE DATA AREA.
C
  220 DO  240 IL1=1,NL0
         IL1T3 = IL1*3
         IP1 = IPL(IL1T3-2)
         X1 = XD(IP1)
         Y1 = YD(IP1)
         IP2 = IPL(IL1T3-1)
         X2 = XD(IP2)
         Y2 = YD(IP2)
         IF (SPDT(X2,Y2,X1,Y1,X0,Y0) .LT. 0.0) GO TO  240
         IF (SPDT(X1,Y1,X2,Y2,X0,Y0) .LT. 0.0) GO TO  230
         IF (SIDE(X1,Y1,X2,Y2,X0,Y0) .GT. 0.0) GO TO  240
         IL2 = IL1
         GO TO  250
  230    IL2 = MOD(IL1,NL0)+1
         IP3 = IPL(3*IL2-1)
         X3 = XD(IP3)
         Y3 = YD(IP3)
         IF (SPDT(X3,Y3,X2,Y2,X0,Y0) .LE. 0.0) GO TO  250
  240 CONTINUE
      IT0 = 1
      GO TO  260
  250 IT0 = IL1*NTL+IL2
C
C NORMAL EXIT
C
  260 ITI = IT0
      ITIPV = IT0
      RETURN
      END

C
C	$Id: gzname.f,v 1.5 2008-07-27 00:21:04 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GZNAME(FCTID,FNAME)
C
C  This subroutine takes the GKS function id in the integer variable
C  FCTID (as per the codes assigned in the Fortran binding) and returns 
C  the function name in the CHARACTER*6 variable FNAME.  The name in 
C  FNAME is left justiifed and blank padded.
C
      include 'gkscom.h'
C
      CHARACTER*6 FNAME
      INTEGER FCTID
C
      FNAME = GNAM(FCTID+1)
      RETURN
      END

C
C	$Id: pnt.f,v 1.4 2008-07-27 00:59:05 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE PNT(IOS,STATUS)
C
C  SET UP THE POINTS MODE DATA
C
C  OUTPUT
C       IOS- THE I/O STATUS VALID WHEN STATUS SET TO AN I/O ERROR
C       STATUS-THE ERROR STATUS DEFINED BY COMMON TRERO
C
      COMMON/TREROR/ ALLOK, MFRCHK, MTOPER, METRDC, REDERR, TYPCHG
     1             ,INVTYP, MINVLD, TYPERR, FRMEND, ENCINT, IVDCDT
     2             ,GCOERR, GCRERR, GCCERR, FCOERR, FCRERR, FCCERR
     3             ,PLIDXG, PMIDXG, TXIDXG, PGIDXG, INVLMT, CELERR
     4             ,COIERR, COLNRM, UNKNOW, UNKOPC, ENDMTF, VNEROR
     5             ,BADRSZ, DEVOUT, NOVERS, BADFNT, PGMERR, FASERR
     6             ,HINERR, VDWERR, RDWERR, RIXLIM
      INTEGER        ALLOK, MFRCHK, MTOPER, METRDC, REDERR, TYPCHG
     1             ,INVTYP, MINVLD, TYPERR, FRMEND, ENCINT, IVDCDT
     2             ,GCOERR, GCRERR, GCCERR, FCOERR, FCRERR, FCCERR
     3             ,PLIDXG, PMIDXG, TXIDXG, PGIDXG, INVLMT, CELERR
     4             ,COIERR, COLNRM, UNKNOW, UNKOPC, ENDMTF, VNEROR
     5             ,BADRSZ, DEVOUT, NOVERS, BADFNT, PGMERR, FASERR
     6             ,HINERR, VDWERR, RDWERR, RIXLIM
      COMMON /TRINST/ OPCL, OPID, LEN, CONT
      INTEGER OPCL, OPID, LEN
      LOGICAL CONT
      COMMON /TRMTYP/ FOURBT, MULTBT, TWOBT, PTSFLG, CURCOL, IPWRIT,
     1                IFRAME, ISETOP, IRANG, IPTS, ICAS, IINT, IORNT,
     2                ISIZE, IFONT, IPAT, ISSIZ, ICENT, ICOLR,
     3                MCENT, MSIZE, MOR, OLDX, OLDY, MCASE, MINTEN,
     4                MFONT, MDASH, MSPOT, MCOLOR, MLIMIT, PTSYM,
     5                SAVX, SAVY
      INTEGER FOURBT, MULTBT, TWOBT, PTSFLG, CURCOL, IPWRIT,
     1                IFRAME, ISETOP, IRANG, IPTS, ICAS, IINT, IORNT,
     2                ISIZE, IFONT, IPAT, ISSIZ, ICENT, ICOLR,
     3                MCENT, MSIZE, MOR, OLDX, OLDY, MCASE, MINTEN,
     4                MFONT, MDASH, MSPOT, MCOLOR(3), MLIMIT(4), PTSYM,
     5                SAVX, SAVY
C
      INTEGER IOS, STATUS
      INTEGER BYTE8, W16
C
C  DEFINE THE BYTE SIZE FOR COUNT AND OPTION CODE
C
      DATA BYTE8/8/,W16/16/
C
C  INITIALIZE THE STATUS FIELD TO ALL OK
C
      STATUS = ALLOK
C
C  SKIP THE NEXT BYTE
C
      CALL MNINST(BYTE8,IOS,STATUS)
C
C  READ IN THE POINTS FLAG
C
      CALL MNINST(BYTE8,IOS,STATUS)
      PTSFLG = OPCL
      IF (STATUS.NE.ALLOK) RETURN
C
C   READ IN THE POINTS SYMBOL
C
      CALL MNINST(BYTE8,IOS,STATUS)
      PTSYM = OPCL
C
      RETURN
      END

      PROGRAM CTLLG3
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.  Use one
C of the following:
C
C       PARAMETER (IERF=6,LUNI=2,IWTY=1 ,IWID=1)  !  NCGM
C       PARAMETER (IERF=6,LUNI=2,IWTY=8 ,IWID=1)  !  X Windows
C       PARAMETER (IERF=6,LUNI=2,IWTY=20,IWID=1)  !  PostScript
C       PARAMETER (IERF=6,LUNI=2,IWTY=11,IWID=1)  !  PDF, Portrait
C       PARAMETER (IERF=6,LUNI=2,IWTY=12,IWID=1)  !  PDF, Landscape
C
        PARAMETER (IERF=6,LUNI=2,IWTYPE=1,IWTY=IWTYPE,IWID=1)
C
C The object of this program is to produce a set of plots illustrating
C the use of a simple, closed, lat/lon grid on the surface of the globe.
C The triangular mesh is created from the rectangular grid by calling
C the CONPACKT routine CTTMRG.
C
C Selected frames are drawn for each of four different viewpoints.  If
C (CLAT,CLON) is the approximate position of the "center point" of the
C mesh (which is defined somewhat arbitrarily for certain meshes), the
C four viewpoints used are as follows: (CLAT+45,CLON), (CLAT-45,CLON),
C (CLAT+45,CLON+180), and (CLAT-45,CLON+180).
C
C At each of the four viewpoints, up to six different frames are drawn:
C
C   1) A frame that attempts to show how the original rectangular
C      grid is mapped onto the globe.  A little reference image of
C      the rectangular grid appears in the lower left corner of the
C      frame and a large image of the grid wrapped around the globe
C      appears in the middle of the frame.  Each image is colored using
C      a 10x10 rectangular array of different colors and, on each, the
C      corner points, the midpoints of the edges and the midpoint of
C      the whole grid are marked.  This frame is drawn only if the
C      parameter IMSH = 1, 3, 5, or 7.
C
C   2) A frame showing the original rectangular grid on the globe.
C      This frame is drawn only if the parameter IMSH = 2, 3, 6, or 7.
C
C   3) A frame showing the triangular mesh on the globe.  This frame
C      is drawn only if the parameter IMSH = 4, 5, 6, or 7.
C
C   4) A frame showing simple contours on the globe.  This frame is
C      drawn only if the parameter ICON is non-zero.
C
C   5) A frame showing color-filled contour bands on the globe, drawn
C      using filled areas.  This frame is drawn only if the parameter
C      ICOL is non-zero.
C
C   6) A frame showing color-filled contour bands on the globe, drawn
C      using a cell array.  This frame is drawn only if the parameter
C      ICAP is non-zero.
C
C Define the parameter that says which frames showing the rectangular
C grid and/or the triangular mesh are to be drawn (frames 1 through 3):
C
C       PARAMETER (IMSH=0)  !  none of the three
C       PARAMETER (IMSH=1)  !  colored rectangular grid only
C       PARAMETER (IMSH=2)  !  simple rectangular grid only
C       PARAMETER (IMSH=3)  !  colored and simple rectangular grids
C       PARAMETER (IMSH=4)  !  triangular only
C       PARAMETER (IMSH=5)  !  colored rectangular and triangular
C       PARAMETER (IMSH=6)  !  simple rectangular and triangular
C       PARAMETER (IMSH=7)  !  all three
C
        PARAMETER (IMSH=7)
C
C Define the parameter that says whether or not to draw simple contours
C (frame 4):
C
C       PARAMETER (ICON=0)  !  contours not drawn
C       PARAMETER (ICON=1)  !  contours drawn
C
        PARAMETER (ICON=1)
C
C Define the parameter that says whether or not to draw color-filled
C contours (frame 5):
C
C       PARAMETER (ICOL=0)  !  no color fill done
C       PARAMETER (ICOL=1)  !  color fill done
C
        PARAMETER (ICOL=1)
C
C Define the parameter that says whether or not to draw a cell array
C plot (frame 6):
C
C       PARAMETER (ICAP=0)  !  cell array plot not drawn
C       PARAMETER (ICAP=1)  !  cell array plot drawn
C
        PARAMETER (ICAP=1)
C
C To represent the triangular mesh, we use three singly-dimensioned
C arrays: RPNT holds points, IEDG holds edges, and ITRI holds triangles.
C The elements of each array form "nodes" having lengths as follows:
C
        PARAMETER (LOPN=5)
C
C The five elements of a point node are
C
C   1. the X coordinate of the point;
C   2. the Y coordinate of the point;
C   3. the Z coordinate of the point;
C   4. the field value at the point;
C   5. any additional value desired by the user.
C
        PARAMETER (LOEN=5)
C
C The five elements of an edge node are
C
C   1. the base index, in RPNT, of point 1 of the edge;
C   2. the base index, in RPNT, of point 2 of the edge;
C   3. the index, in ITRI, of the pointer to the edge in the triangle to
C      the left of the edge (-1 if there is no triangle to the left);
C   4. the index, in ITRI, of the pointer to the edge in the triangle to
C      the right of the edge (-1 if there is no triangle to the right);
C   5. a utility flag for use by algorithms that scan the structure.
C
C The "left" and "right" sides of an edge are defined as they would be
C by an observer standing on the globe at point 1 of the edge, looking
C toward point 2 of the edge.  It is possible, if there are "holes" in
C the mesh, that there will be no triangle to the left or to the right
C of an edge, but there must be a triangle on one side or the other.
C
        PARAMETER (LOTN=4)
C
C The four elements of a triangle node are
C
C   1. the base index, in IEDG, of edge 1 of the triangle;
C   2. the base index, in IEDG, of edge 2 of the triangle;
C   3. the base index, in IEDG, of edge 3 of the triangle;
C   4. a flag set non-zero to block use of the triangle, effectively
C      removing it from the mesh.
C
C The "base index" of a point node, an edge node, or a triangle node is
C always a multiple of the length of the node, to which can be added an
C offset to get the index of a particular element of the node.  For
C example, if I is the base index of a triangle of interest, ITRI(I+1)
C is its first element (the base index of its first edge).  Similarly,
C IEDG(ITRI(I+1)+2) is the base index of the second point of the first
C edge of the triangle with base index I, and RPNT(IEDG(ITRI(I+1)+2)+3)
C is the third (Z) coordinate of the second point of the first edge of
C the triangle with base index I.
C
C It is the pointers from the edge nodes back to the triangle nodes that
C allow CONPACKT to navigate the mesh, moving from triangle to triangle
C as it follows a contour line, but these pointers are tricky to define:
C if IPTE is the base index of an edge node and IEDG(IPTE+3) is zero or
C more, saying that there is a triangle to the left of the edge, then
C IEDG(IPTE+3) is the actual index of that element of the triangle node
C that points to the edge node; i.e., ITRI(IEDG(IPTE+3))=IPTE.  The base
C index of the triangle node defining that triangle is IPTT, where
C IPTT=LOTN*((IEDG(IPTE+3)-1)/LOTN), and the index of the pointer to
C the edge within the triangle node is IPTI=IEDG(IPTE+3)-IPTT, so that
C ITRI(IPTT+IPTI)=IPTE.  Similar comments apply to element 4 of an edge
C node, which points into the triangle node defining the triangle to the
C right of the edge.
C
C The maximum numbers of points, edges, and triangles in a triangular
C mesh can be computed in the following manner:  Since the triangular
C mesh is created from a rectangular one by splitting each rectangular
C cell in half, we can declare the largest values we expect to use for
C the dimensions of that mesh:
C
        PARAMETER (IDIM=181,JDIM=91,IDM1=IDIM-1,JDM1=JDIM-1)
C
C and then compute from those values the maximum number of points,
C edges, and triangles that the triangular mesh arrays will need to
C hold.  The computed values will be exactly as required if no points
C or edges of the rectangular grid are repeated in it; if there are
C repeating points or edges, space for slightly fewer points and edges
C will be needed:
C
        PARAMETER (MNOP=IDIM*JDIM)
        PARAMETER (MNOE=3*IDM1*JDM1+IDM1+JDM1)
        PARAMETER (MNOT=2*IDM1*JDM1)
C
C Once we know how many points, edges, and triangles we're going to use
C (at most), we can set parameters defining the space reserved for the
C triangular mesh:
C
        PARAMETER (MPNT=MNOP*LOPN)
        PARAMETER (MEDG=MNOE*LOEN)
        PARAMETER (MTRI=MNOT*LOTN)
C
C Declare the arrays to hold the point nodes, edge nodes, and triangle
C nodes defining the triangular mesh.
C
        DIMENSION RPNT(MPNT),IEDG(MEDG),ITRI(MTRI)
C
C Declare real and integer workspaces needed by CONPACKT.
C
        PARAMETER (LRWK=10000,LIWK=1000)
C
        DIMENSION RWRK(LRWK),IWRK(LIWK)
C
C Declare the area map array needed to do solid fill.
C
        PARAMETER (LAMA=200000)
C
        DIMENSION IAMA(LAMA)
C
C Declare workspace arrays to be used in calls to ARSCAM.
C
        PARAMETER (NCRA=LAMA/10,NGPS=2)
C
        DIMENSION XCRA(NCRA),YCRA(NCRA),IAAI(NGPS),IAGI(NGPS)
C
C Declare arrays in which to generate a cell array picture of the
C data on the triangular mesh.
C
C       PARAMETER (ICAM=1024,ICAN=1024)
        PARAMETER (ICAM= 512,ICAN= 512)
C
        DIMENSION ICRA(ICAM,ICAN)
C
C Declare arrays to hold color components for colors to be used at the
C four corners of an illustrative drawing of the rectangular grid.
C
        DIMENSION CCLL(3),CCLR(3),CCUL(3),CCUR(3)
C
C Declare external the routine that draws masked contour lines.
C
        EXTERNAL DRWMCL
C
C Declare external the routine that does color fill of contour bands.
C
        EXTERNAL DCFOCB
C
C Define a common block in which to keep track of the maximum space used
C in the arrays XCRA and YCRA.
C
        COMMON /COMONA/ MAXN
C
C Define the out-of-range flag.
C
        DATA OORV / 1.E12 /
C
C Define the tension on the splines to be used in smoothing contours.
C
C       DATA T2DS / 0.0 /  !  smoothing off
C       DATA T2DS / 2.5 /  !  smoothing on
C
        DATA T2DS / 0.0 /
C
C Define the distance between points on smoothed contour lines.
C
        DATA RSSL / .002 /
C
C Define the amount of real workspace to be used in drawing contours.
C
        DATA IRWC / 500 /
C
C Define the label-positioning flag.
C
C       DATA ILLP / 0 /  !  no labels
C       DATA ILLP / 1 /  !  dash-package writes labels
C       DATA ILLP / 2 /  !  regular scheme
C       DATA ILLP / 3 /  !  penalty scheme
C
        DATA ILLP / 2 /
C
C Define the high/low search radius.
C
        DATA HLSR / .075 /
C
C Define the high/low label overlap flag.
C
        DATA IHLO / 11 /
C
C Define the hachuring flag, hachure length, and hachure spacing.
C
C       DATA IHCF,HCHL,HCHS /  0 , +.004 , .010 /  !  off
C       DATA IHCF,HCHL,HCHS / +1 , -.004 , .020 /  !  on, all, uphill
C
        DATA IHCF,HCHL,HCHS /  0 , +.004 , .010 /
C
C Define the colors to be used in the lower left, lower right, upper
C left, and upper right corners of the rectangular grid when a drawing
C of it is made for the purpose of illustrating how it is wrapped around
C the globe.
C
        DATA CCLL / 0.2 , 0.2 , 0.2 /
        DATA CCLR / 1.0 , 0.0 , 1.0 /
        DATA CCUL / 0.0 , 1.0 , 1.0 /
        DATA CCUR / 1.0 , 1.0 , 0.0 /
C
C Define a constant to convert from radians to degrees.
C
        DATA RTOD / 57.2957795130823 /
C
C Create data and generate the required triangular mesh.
C
        PRINT * , ' '
        PRINT * , 'CREATING TRIANGULAR MESH:'
C
        CALL GTLLG3 (RPNT,MPNT,NPNT,LOPN,
     +               IEDG,MEDG,NEDG,LOEN,
     +               ITRI,MTRI,NTRI,LOTN,
     +               CLAT,CLON)
C
C Print the number of points, edges, and triangles.
C
        PRINT * , '  NUMBER OF POINTS:    ',NPNT/LOPN
        PRINT * , '  NUMBER OF EDGES:     ',NEDG/LOEN
        PRINT * , '  NUMBER OF TRIANGLES: ',NTRI/LOTN
C
C Write the contents of the point list, the edge list, and the triangle
C list to "fort.11" in a readable form.
C
c       WRITE (11,'(''P'',I8,5F10.4)')
c    +        (I,RPNT(I+1),RPNT(I+2),RPNT(I+3),RPNT(I+4),RPNT(I+5),
c    +                                               I=0,NPNT-LOPN,LOPN)
c       WRITE (11,'(''E'',I8,5I10)')
c    +        (I,IEDG(I+1),IEDG(I+2),IEDG(I+3),IEDG(I+4),IEDG(I+5),
c    +                                               I=0,NEDG-LOEN,LOEN)
c       WRITE (11,'(''T'',I8,4I10)')
c    +        (I,ITRI(I+1),ITRI(I+2),ITRI(I+3),ITRI(I+4),
c    +                                               I=0,NTRI-LOTN,LOTN)
C
C Open GKS.
C
        PRINT * , 'OPENING AND INITIALIZING GKS'
C
        CALL GOPKS (IERF,0)
        CALL GOPWK (IWID,LUNI,IWTY)
        CALL GACWK (IWID)
C
C Turn off the clipping indicator.
C
        CALL GSCLIP (0)
C
C Define a basic set of colors (0 = white, background; 1 = black,
C foreground; 2 = yellow; 3 = magenta; 4 = red; 5 = cyan; 6 = green;
C 7 = blue; 8 = darker light gray; 9 = lighter light gray; 10 = dark
C yellow; 11 = dark gray; 12 = medium gray; 13 = light red, for
C geographic lines; 14 = light blue, for lat/lon lines).
C
        CALL GSCR   (IWID, 0,1.,1.,1.)
        CALL GSCR   (IWID, 1,0.,0.,0.)
        CALL GSCR   (IWID, 2,1.,1.,0.)
        CALL GSCR   (IWID, 3,1.,0.,1.)
        CALL GSCR   (IWID, 4,1.,0.,0.)
        CALL GSCR   (IWID, 5,0.,1.,1.)
        CALL GSCR   (IWID, 6,0.,1.,0.)
        CALL GSCR   (IWID, 7,0.,0.,1.)
        CALL GSCR   (IWID, 8,.5,.5,.5)
        CALL GSCR   (IWID, 9,.8,.8,.8)
        CALL GSCR   (IWID,10,.3,.3,0.)
        CALL GSCR   (IWID,11,.3,.3,.3)
        CALL GSCR   (IWID,12,.5,.5,.5)
        CALL GSCR   (IWID,13,.8,.5,.5)
        CALL GSCR   (IWID,14,.5,.5,.8)
C
C Define 100 colors, associated with color indices 51 through 150, to
C be used in making an illustrative drawing of the rectangular grid.
C
        CALL DCFGRD (IWID,51,10,10,CCLL,CCLR,CCUL,CCUR)
C
C Define 100 colors, associated with color indices 151 through 250, to
C be used for color-filled contour bands and in cell arrays, ranging
C from blue to red.
C
        CALL DFCLRS (IWID,151,250,0.,0.,1.,1.,0.,0.)
C
C Set parameters in the utilities.
C
        PRINT * , 'SETTING PARAMETERS IN CONPACKT, EZMAP, AND PLOTCHAR'
C
C Set the mapping flag.
C
        CALL CTSETI ('MAP - MAPPING FLAG',1)
C
C Set the out-of-range flag value.
C
        CALL CTSETR ('ORV - OUT-OF-RANGE VALUE',OORV)
C
C Turn on the drawing of the mesh edge and set the area identifier for
C areas outside the mesh.
C
        CALL CTSETI ('PAI - PARAMETER ARRAY INDEX',-1)
        CALL CTSETI ('CLU - CONTOUR LEVEL USE FLAG',1)
        CALL CTSETI ('AIA - AREA IDENTIFIER FOR AREA',1001)
C
C Set the area identifier for areas in "out-of-range" areas.
C
C       CALL CTSETI ('PAI',-2)
C       CALL CTSETI ('AIA - AREA IDENTIFIER FOR AREA',1002)
C
C Set the 2D smoother flag.
C
        CALL CTSETR ('T2D - TENSION ON 2D SPLINES',T2DS)
C
C Set the distance between points on smoothed lines.
C
        CALL CTSETR ('SSL - SMOOTHED SEGMENT LENGTH',RSSL)
C
C Set the amount of real workspace to be used in drawing contours.
C
        CALL CTSETI ('RWC - REAL WORKSPACE FOR CONTOURS',IRWC)
C
C Set the label-positioning flag.
C
        CALL CTSETI ('LLP - LINE LABEL POSITIONING FLAG',ILLP)
C
C Set the high/low search radius.
C
        CALL CTSETR ('HLR - HIGH/LOW SEARCH RADIUS',HLSR)
C
C Set the high/low label overlap flag.
C
        CALL CTSETI ('HLO - HIGH/LOW LABEL OVERLAP FLAG',IHLO)
C
C Set the hachuring flag, hachure length, and hachure spacing.
C
        CALL CTSETI ('HCF - HACHURING FLAG',IHCF)
        CALL CTSETR ('HCL - HACHURE LENGTH',HCHL)
        CALL CTSETR ('HCS - HACHURE SPACING',HCHS)
C
C Set the cell array flag.
C
        CALL CTSETI ('CAF - CELL ARRAY FLAG',-1)
C
C Tell CONPACKT not to do its own call to SET, since EZMAP will have
C done it.
C
        CALL CTSETI ('SET - DO-SET-CALL FLAG', 0)
C
C Move the informational label up a little.
C
        CALL CTSETR ('ILY - INFORMATIONAL LABEL Y POSITION',-.005)
C
C Tell EZMAP not to draw the perimeter.
C
        CALL MPSETI ('PE',0)
C
C Tell EZMAP to use solid lat/lon lines.
C
        CALL MPSETI ('DA',65535)
C
C Tell PLOTCHAR to use one of the filled fonts and to outline each
C character.
C
        CALL PCSETI ('FN',25)
        CALL PCSETI ('OF',1)
C
C Tell PLOTCHAR to expect a character other than a colon as the
C function-control signal character.
C
        CALL PCSETC ('FC','|')
C
C Loop through four different viewing angles.
C
        DO 104 IDIR=1,4
C
          PRINT * , ' '
          PRINT * , 'VIEW FROM DIRECTION NUMBER: ',IDIR
C
C Tell EZMAP what projection to use and what its limits are.
C
          IF      (IDIR.EQ.1) THEN
            CALL MAPROJ ('OR',CLAT+45.,CLON,      0.)
          ELSE IF (IDIR.EQ.2) THEN
            CALL MAPROJ ('OR',CLAT-45.,CLON,      0.)
          ELSE IF (IDIR.EQ.3) THEN
            CALL MAPROJ ('OR',CLAT+45.,CLON+180., 0.)
          ELSE IF (IDIR.EQ.4) THEN
            CALL MAPROJ ('OR',CLAT-45.,CLON+180., 0.)
          END IF
C
          CALL MAPSET ('MA',0.,0.,0.,0.)
C
C Initialize EZMAP.
C
          CALL MAPINT
C
C If the rectangular grid and/or the triangular mesh are to be drawn,
C do it.
C
          IF (IMSH.NE.0) THEN
C
            PRINT * , 'DRAWING MESHES'
C
C Colored rectangular grid:
C
            IF (MOD(IMSH,2).NE.0) THEN
C
              PRINT * , 'DRAWING COLORED RECTANGULAR GRID'
C
              CALL DCLLG3
C
C Label the first frame.
C
              CALL PLCHHQ (CFUX(.03),CFUY(.946),'LAT/LON GRID',
     +                                                      .024,0.,-1.)
              CALL PLCHHQ (CFUX(.03),CFUY(.910),'(COMPLETELY CLOSED)',
     +                                                      .012,0.,-1.)
              IF      (IDIR.EQ.1) THEN
                CALL PLCHHQ (CFUX(.52),CFUY(.91),
     +                     'Both the left and right edges of',
     +                                                      .010,0.,-1.)
                CALL PLCHHQ (CFUX(.52),CFUY(.89),
     +                     'the grid map into a "seam" along',
     +                                                      .010,0.,-1.)
                CALL PLCHHQ (CFUX(.52),CFUY(.87),
     +                     'the International Date Line.',
     +                                                      .010,0.,-1.)
                CALL PLCHHQ (CFUX(.48),CFUY(.79),
     +                       'The entire top edge of the grid',
     +                                                       .010,0.,1.)
                CALL PLCHHQ (CFUX(.48),CFUY(.77),
     +                       'maps to a point at the North Pole.',
     +                                                       .010,0.,1.)
              ELSE IF (IDIR.EQ.2) THEN
                CALL PLCHHQ (CFUX(.52),CFUY(.13),
     +                     'Both the left and right edges of',
     +                                                      .010,0.,-1.)
                CALL PLCHHQ (CFUX(.52),CFUY(.11),
     +                       'the grid map into a "seam" along',
     +                                                      .010,0.,-1.)
                CALL PLCHHQ (CFUX(.52),CFUY(.09),
     +                       'the International Date Line.',
     +                                                      .010,0.,-1.)
                CALL PLCHHQ (CFUX(.52),CFUY(.23),
     +                       'The entire bottom edge of the grid',
     +                                                      .010,0.,-1.)
                CALL PLCHHQ (CFUX(.52),CFUY(.21),
     +                       'maps to a point at the South Pole.',
     +                                                      .010,0.,-1.)
              ELSE IF (IDIR.EQ.3) THEN
                CALL PLCHHQ (CFUX(.53),CFUY(.22),
     +                       'Both the left and right edges of',
     +                                                      .010,0.,-1.)
                CALL PLCHHQ (CFUX(.53),CFUY(.20),
     +                       'the grid map into a "seam" along',
     +                                                      .010,0.,-1.)
                CALL PLCHHQ (CFUX(.53),CFUY(.18),
     +                       'the International Date Line.',
     +                                                      .010,0.,-1.)
                CALL PLCHHQ (CFUX(.48),CFUY(.79),
     +                       'The entire top edge of the grid',
     +                                                       .010,0.,1.)
                CALL PLCHHQ (CFUX(.48),CFUY(.77),
     +                       'maps to a point at the North Pole.',
     +                                                       .010,0.,1.)
              ELSE IF (IDIR.EQ.4) THEN
                CALL PLCHHQ (CFUX(.53),CFUY(.85),
     +                       'Both the left and right edges of',
     +                                                      .010,0.,-1.)
                CALL PLCHHQ (CFUX(.53),CFUY(.83),
     +                       'the grid map into a "seam" along',
     +                                                      .010,0.,-1.)
                CALL PLCHHQ (CFUX(.53),CFUY(.81),
     +                       'the International Date Line.',
     +                                                      .010,0.,-1.)
                CALL PLCHHQ (CFUX(.48),CFUY(.23),
     +                       'The entire bottom edge of the grid',
     +                                                       .010,0.,1.)
                CALL PLCHHQ (CFUX(.48),CFUY(.21),
     +                       'maps to a point at the South Pole.',
     +                                                       .010,0.,1.)
              END IF
C
              IF      (IDIR.EQ.1) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 1',
     +                                                      .012,0.,-1.)
              ELSE IF (IDIR.EQ.2) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 2',
     +                                                      .012,0.,-1.)
              ELSE IF (IDIR.EQ.3) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 3',
     +                                                      .012,0.,-1.)
              ELSE IF (IDIR.EQ.4) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 4',
     +                                                      .012,0.,-1.)
              END IF
C
              CALL PLCHHQ (CFUX(.97),CFUY(.950),'MAPPING OF THE GRID',
     +                                                       .012,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.926),'ONTO THE GLOBE',
     +                                                       .012,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.904),'(Color swatches, bold'
     +                                                      ,.010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.884),'edges, and big dots',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.864),'are all intended',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.844),'to clarify the',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.824),'mapping.)',
     +                                                       .010,0.,1.)
C
              CALL PLCHHQ (CFUX(.97),CFUY(.060),'Shorelines are blue.',
     +                                                       .012,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.036),'Parallels/meridians are
     + red.',.012,0.,1.)
C
C Advance the frame.
C
              CALL FRAME
C
            END IF
C
C Simple rectangular grid:
C
            IF (MOD(IMSH/2,2).NE.0) THEN
C
              PRINT * , 'DRAWING SIMPLE RECTANGULAR GRID'
C
              CALL DSLLG3
C
C Label the second frame.
C
              CALL PLCHHQ (CFUX(.03),CFUY(.946),'LAT/LON GRID',
     +                                                      .024,0.,-1.)
              CALL PLCHHQ (CFUX(.03),CFUY(.910),'(COMPLETELY CLOSED)',
     +                                                      .012,0.,-1.)
C
              IF (     IDIR.EQ.1) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 1',
     +                                                      .012,0.,-1.)
              ELSE IF (IDIR.EQ.2) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 2',
     +                                                      .012,0.,-1.)
              ELSE IF (IDIR.EQ.3) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 3',
     +                                                      .012,0.,-1.)
              ELSE IF (IDIR.EQ.4) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 4',
     +                                                      .012,0.,-1.)
              END IF
C
              CALL PLCHHQ (CFUX(.97),CFUY(.950),'ORIGINAL RECTANGULAR GR
     +ID',.012,0.,1.)
C
              CALL PLCHHQ (CFUX(.03),CFUY(.084),'Grid is gray.',
     +                                                      .012,0.,-1.)
              CALL PLCHHQ (CFUX(.03),CFUY(.060),'Shorelines are blue.',
     +                                                      .012,0.,-1.)
              CALL PLCHHQ (CFUX(.03),CFUY(.036),'Parallels/meridians are
     + red.',.012,0.,-1.)
C
C Advance the frame.
C
              CALL FRAME
C
            END IF
C
C Triangular mesh (with edges between blocked triangles somewhat fainter
C than the rest):
C
            IF (MOD(IMSH/4,2).NE.0) THEN
C
              PRINT * , 'DRAWING TRIANGULAR MESH'
C
              DO 101 IPTE=0,NEDG-LOEN,LOEN
C
                IFLL=0
C
                IF (IEDG(IPTE+3).GE.0) THEN
                  IF (ITRI(LOTN*((IEDG(IPTE+3)-1)/LOTN)+4).EQ.0) IFLL=1
                END IF
C
                IFLR=0
C
                IF (IEDG(IPTE+4).GE.0) THEN
                  IF (ITRI(LOTN*((IEDG(IPTE+4)-1)/LOTN)+4).EQ.0) IFLR=1
                END IF
C
                IF (IFLL.NE.0.OR.IFLR.NE.0) THEN
                  CALL PLOTIT (0,0,2)
                  CALL GSPLCI (8)
                ELSE
                  CALL PLOTIT (0,0,2)
                  CALL GSPLCI (9)
                END IF
C
                ALAT=RTOD*ASIN(RPNT(IEDG(IPTE+1)+3))
C
                IF (RPNT(IEDG(IPTE+1)+1).EQ.0..AND.
     +              RPNT(IEDG(IPTE+1)+2).EQ.0.) THEN
                  ALON=0.
                ELSE
                  ALON=RTOD*ATAN2(RPNT(IEDG(IPTE+1)+2),
     +                            RPNT(IEDG(IPTE+1)+1))
                END IF
C
                BLAT=RTOD*ASIN(RPNT(IEDG(IPTE+2)+3))
C
                IF (RPNT(IEDG(IPTE+2)+1).EQ.0..AND.
     +              RPNT(IEDG(IPTE+2)+2).EQ.0.) THEN
                  BLON=0.
                ELSE
                  BLON=RTOD*ATAN2(RPNT(IEDG(IPTE+2)+2),
     +                            RPNT(IEDG(IPTE+2)+1))
                END IF
C
                CALL DRSGCR (ALAT,ALON,BLAT,BLON)
C
  101         CONTINUE
C
              CALL PLOTIT (0,0,2)
              CALL GSPLCI (13)
              CALL MAPGRD
              CALL PLOTIT (0,0,2)
              CALL GSPLCI (14)
              CALL MAPLOT
C
C Label the third frame.
C
              CALL PLCHHQ (CFUX(.03),CFUY(.946),'LAT/LON GRID',
     +                                                      .024,0.,-1.)
              CALL PLCHHQ (CFUX(.03),CFUY(.910),'(COMPLETELY CLOSED)',
     +                                                      .012,0.,-1.)
C
              IF (     IDIR.EQ.1) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 1',
     +                                                      .012,0.,-1.)
              ELSE IF (IDIR.EQ.2) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 2',
     +                                                      .012,0.,-1.)
              ELSE IF (IDIR.EQ.3) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 3',
     +                                                      .012,0.,-1.)
              ELSE IF (IDIR.EQ.4) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 4',
     +                                                      .012,0.,-1.)
              END IF
C
              CALL PLCHHQ (CFUX(.97),CFUY(.950),'DERIVED TRIANGULAR MESH
     +',.012,0.,1.)
C
              CALL PLCHHQ (CFUX(.03),CFUY(.084),'Mesh is gray.',
     +                                                      .012,0.,-1.)
              CALL PLCHHQ (CFUX(.03),CFUY(.060),'Shorelines are blue.',
     +                                                      .012,0.,-1.)
              CALL PLCHHQ (CFUX(.03),CFUY(.036),'Parallels/meridians are
     + red.',.012,0.,-1.)
C
C Advance the frame.
C
              CALL FRAME
C
            END IF
C
          END IF
C
C If a frame showing simple contours is to be drawn, do it next (adding
C an overlay of lat/lon lines and continental outlines in light gray).
C
          IF (ICON.NE.0) THEN
C
            PRINT * , 'DRAWING PLOT SHOWING SIMPLE CONTOURS'
C
C Initialize CONPACKT.
C
            PRINT * , 'CALLING CTMESH'
C
            CALL CTMESH (RPNT,NPNT,LOPN,
     +                   IEDG,NEDG,LOEN,
     +                   ITRI,NTRI,LOTN,
     +                   RWRK,LRWK,
     +                   IWRK,LIWK)
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (1)
C
C Proceed as implied by the setting of the label-positioning flag.
C
            IF (ABS(ILLP).EQ.1) THEN
C
C Draw the contour lines with labels generated by the dash package.
C
              PRINT * , 'CALLING CTCLDR'
              CALL CTCLDR (RPNT,IEDG,ITRI,RWRK,IWRK)
C
C Add the informational and high/low labels.
C
              PRINT * , 'CALLING CTLBDR'
              CALL CTLBDR (RPNT,IEDG,ITRI,RWRK,IWRK)
C
            ELSE IF (ABS(ILLP).GT.1) THEN
C
C Create an area map for masking of labels.
C
              MAXN=0
C
              PRINT * , 'CALLING ARINAM'
              CALL ARINAM (IAMA,LAMA)
C
              PRINT * , 'CALLING CTLBAM'
              CALL CTLBAM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA)
C
C Draw the contour lines masked by the area map.
C
              PRINT * , 'CALLING CTCLDM'
              CALL CTCLDM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA,DRWMCL)
C
              PRINT * , 'AREA MAP SPACE REQUIRED:         ',
     +                                         IAMA(1)-IAMA(6)+IAMA(5)+1
C
              PRINT * , 'NUMBER OF POINTS IN LONGEST LINE:',MAXN
C
C Draw all the labels.
C
              PRINT * , 'CALLING CTLBDR'
              CALL CTLBDR (RPNT,IEDG,ITRI,RWRK,IWRK)
C
            END IF
C
            CALL CTGETI ('IWU - INTEGER WORKSPACE USED',IIWU)
            PRINT * , 'INTEGER WORKSPACE REQUIRED:      ',IIWU
C
            CALL CTGETI ('RWU -    REAL WORKSPACE USED',IRWU)
            PRINT * , 'REAL WORKSPACE REQUIRED:         ',IRWU
C
C Add lat/lon lines and continental outlines.
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (13)
            CALL MAPGRD
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (14)
            CALL MAPLOT
C
C Label the fourth frame.
C
            CALL PLCHHQ (CFUX(.03),CFUY(.946),'LAT/LON GRID',
     +                                                      .024,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.910),'(COMPLETELY CLOSED)',
     +                                                      .012,0.,-1.)
C
            IF (     IDIR.EQ.1) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 1',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.2) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 2',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.3) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 3',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.4) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 4',
     +                                                      .012,0.,-1.)
            END IF
C
            CALL PLCHHQ (CFUX(.97),CFUY(.950),'SIMPLE CONTOURS ON',
     +                                                       .012,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.926),'TRIANGULAR MESH',
     +                                                       .012,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.904),
     +                   '(For a simple function',
     +                                                       .010,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.884),
     +                   'of latitude and',
     +                                                       .010,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.864),
     +                   'longitude.)',
     +                                                       .010,0.,1.)
C
            CALL PLCHHQ (CFUX(.03),CFUY(.060),'Shorelines are blue.',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.036),'Parallels/meridians are r
     +ed.',.012,0.,-1.)
C
C Advance the frame.
C
            CALL FRAME
C
          END IF
C
C If a frame showing color-filled contours is to be drawn, do it next.
C
          IF (ICOL.NE.0) THEN
C
            PRINT * , 'DRAWING PLOT SHOWING COLOR-FILLED CONTOURS'
C
            PRINT * , 'CALLING CTMESH'
C
            CALL CTMESH (RPNT,NPNT,LOPN,
     +                   IEDG,NEDG,LOEN,
     +                   ITRI,NTRI,LOTN,
     +                   RWRK,LRWK,
     +                   IWRK,LIWK)
C
            MAXN=0
C
            PRINT * , 'CALLING CTPKCL'
            CALL CTPKCL (RPNT,IEDG,ITRI,RWRK,IWRK)
C
            PRINT * , 'CALLING ARINAM'
            CALL ARINAM (IAMA,LAMA)
C
            PRINT * , 'CALLING CTCLAM'
            CALL CTCLAM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA)
C
C           PRINT * , 'CALLING CTLBAM'
C           CALL CTLBAM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA)
C
            PRINT * , 'CALLING ARSCAM'
            CALL ARSCAM (IAMA,XCRA,YCRA,NCRA,IAAI,IAGI,NGPS,DCFOCB)
C
            PRINT * , 'SPACE REQUIRED IN AREA MAP:      ',
     +                                         IAMA(1)-IAMA(6)+IAMA(5)+1
C
            PRINT * , 'NUMBER OF POINTS IN LARGEST AREA:',MAXN
C
            CALL CTGETI ('IWU - INTEGER WORKSPACE USED',IIWU)
            PRINT * , 'INTEGER WORKSPACE REQUIRED:      ',IIWU
C
            CALL CTGETI ('RWU -    REAL WORKSPACE USED',IRWU)
            PRINT * , 'REAL WORKSPACE REQUIRED:         ',IRWU
C
            CALL GSFACI (1)
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (13)
            CALL MAPGRD
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (14)
            CALL MAPLOT
C
C Label the fifth frame.
C
            CALL PLCHHQ (CFUX(.03),CFUY(.946),'LAT/LON GRID',
     +                                                      .024,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.910),'(COMPLETELY CLOSED)',
     +                                                      .012,0.,-1.)
C
            IF (     IDIR.EQ.1) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 1',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.2) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 2',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.3) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 3',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.4) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 4',
     +                                                      .012,0.,-1.)
            END IF
C
            CALL PLCHHQ (CFUX(.97),CFUY(.950),'COLORED CONTOUR BANDS ON'
     +,.012,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.926),'TRIANGULAR MESH',
     +                                                       .012,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.904),
     +                   '(For a simple function',
     +                                                       .010,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.884),
     +                   'of latitude and',
     +                                                       .010,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.864),
     +                   'longitude.)',
     +                                                       .010,0.,1.)
C
            CALL PLCHHQ (CFUX(.03),CFUY(.132),'Off-mesh',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.108),'areas of the',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.084),'globe are yellow.',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.060),'Shorelines are blue.',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.036),'Parallels/meridians are r
     +ed.',.012,0.,-1.)
C
C Advance the frame.
C
            CALL FRAME
C
          END IF
C
C If the flag for it is set, do a cell array plot.
C
          IF (ICAP.NE.0) THEN
C
            PRINT * , 'DRAWING CELL-ARRAY PLOT OF DATA VALUES'
C
            PRINT * , 'CALLING CTMESH'
C
            CALL CTMESH (RPNT,NPNT,LOPN,
     +                   IEDG,NEDG,LOEN,
     +                   ITRI,NTRI,LOTN,
     +                   RWRK,LRWK,
     +                   IWRK,LIWK)
C
            CALL GETSET (XVPL,XVPR,YVPB,YVPT,XWDL,XWDR,YWDB,YWDT,LNLG)
C
            PRINT * , 'CALLING CTCICA'
            CALL CTCICA (RPNT,IEDG,ITRI,RWRK,IWRK,ICRA,ICAM,ICAM,ICAN,
     +                                            XVPL,YVPB,XVPR,YVPT)
C
            PRINT * , 'CALLING GCA'
            CALL GCA (XWDL,YWDB,XWDR,YWDT,ICAM,ICAN,1,1,ICAM,ICAN,ICRA)
C
            CALL CTGETI ('IWU - INTEGER WORKSPACE USED',IIWU)
            PRINT * , 'INTEGER WORKSPACE REQUIRED:      ',IIWU
C
            CALL CTGETI ('RWU -    REAL WORKSPACE USED',IRWU)
            PRINT * , 'REAL WORKSPACE REQUIRED:         ',IRWU
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (13)
            CALL MAPGRD
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (14)
            CALL MAPLOT
C
C Label the sixth frame.
C
            CALL PLCHHQ (CFUX(.03),CFUY(.946),'LAT/LON GRID',
     +                                                      .024,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.910),'(COMPLETELY CLOSED)',
     +                                                      .012,0.,-1.)
C
            IF (     IDIR.EQ.1) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 1',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.2) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 2',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.3) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 3',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.4) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 4',
     +                                                      .012,0.,-1.)
            END IF
C
            CALL PLCHHQ (CFUX(.97),CFUY(.950),'CELL ARRAY DERIVED FROM',
     +.012,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.926),'TRIANGULAR MESH',
     +                                                       .012,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.904),
     +                   '(For a simple function',
     +                                                       .010,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.884),
     +                   'of latitude and',
     +                                                       .010,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.864),
     +                   'longitude.)',
     +                                                       .010,0.,1.)
C
            CALL PLCHHQ (CFUX(.03),CFUY(.132),'Off-mesh',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.108),'areas of the',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.084),'globe are yellow.',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.060),'Shorelines are blue.',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.036),'Parallels/meridians are r
     +ed.',.012,0.,-1.)
C
C Advance the frame.
C
            CALL FRAME
C
          END IF
C
  104   CONTINUE
C
C Close GKS.
C
        CALL GDAWK (IWID)
        CALL GCLWK (IWID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END


      SUBROUTINE DFCLRS (IWID,IOFC,IOLC,REDF,GRNF,BLUF,REDL,GRNL,BLUL)
C
C This routine defines color indices IOFC through IOLC on workstation
C IWID by interpolating values from REDF/GRNF/BLUF to REDL/GRNL/BLUL.
C
        DO 101 I=IOFC,IOLC
          P=REAL(IOLC-I)/REAL(IOLC-IOFC)
          Q=REAL(I-IOFC)/REAL(IOLC-IOFC)
          CALL GSCR (IWID,I,P*REDF+Q*REDL,P*GRNF+Q*GRNL,P*BLUF+Q*BLUL)
  101   CONTINUE
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE DRWMCL (XCRA,YCRA,NCRA,IAAI,IAGI,NGPS)
C
        DIMENSION XCRA(*),YCRA(*),IAAI(*),IAGI(*)
C
C This routine draws the curve defined by the points (XCRA(I),YCRA(I)),
C for I = 1 to NCRA, if and only if none of the area identifiers for the
C area containing the polyline are negative.  It calls either CURVE or
C CURVED to do the drawing, depending on the value of the internal
C parameter 'DPU'.
C
C It keeps track of the maximum value used for NCRA in a common block.
C
        COMMON /COMONA/ MAXN
C
        MAXN=MAX(MAXN,NCRA)
C
C Retrieve the value of the internal parameter 'DPU'.
C
        CALL CTGETI ('DPU - DASH PACKAGE USED',IDUF)
C
C Turn on drawing.
C
        IDRW=1
C
C If any area identifier is negative, turn off drawing.
C
        DO 101 I=1,NGPS
          IF (IAAI(I).LT.0) IDRW=0
  101   CONTINUE
C
C If drawing is turned on, draw the polyline.
C
        IF (IDRW.NE.0) THEN
          IF (IDUF.EQ.0) THEN
            CALL CURVE  (XCRA,YCRA,NCRA)
          ELSE IF (IDUF.LT.0) THEN
            CALL DPCURV (XCRA,YCRA,NCRA)
          ELSE
            CALL CURVED (XCRA,YCRA,NCRA)
          END IF
        END IF
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE DCFOCB (XCRA,YCRA,NCRA,IAAI,IAGI,NGPS)
C
C This routine fills the area defined by the points (XCRA(I),YCRA(I)),
C for I = 1 to NCRA, if and only if none of the area identifiers for
C the area are negative.  The color used is determined from the area
C identifier of the area relative to group 3; it is assumed that 100
C colors are defined having color indices 151 through 250.
C
        DIMENSION XCRA(*),YCRA(*),IAAI(*),IAGI(*)
C
C It keeps track of the maximum value used for NCRA in a common block.
C
        COMMON /COMONA/ MAXN
C
        MAXN=MAX(MAXN,NCRA)
C
C Retrieve the number of contour levels being used.
C
        CALL CTGETI ('NCL - NUMBER OF CONTOUR LEVELS',NOCL)
C
C If the number of contour levels is non-zero and the area has more
C than two points, fill it.
C
        IF (NOCL.NE.0.AND.NCRA.GT.2) THEN
C
          IAI3=-1
C
          DO 101 I=1,NGPS
            IF (IAGI(I).EQ.3) IAI3=IAAI(I)
  101     CONTINUE
C
          IF (IAI3.GE.1.AND.IAI3.LE.NOCL+1) THEN
            CALL GSFACI (151+INT(((REAL(IAI3)-.5)/REAL(NOCL+1))*100.))
            CALL GFA    (NCRA,XCRA,YCRA)
          ELSE IF (IAI3.EQ.1001) THEN
            CALL GSFACI (2)
            CALL GFA    (NCRA,XCRA,YCRA)
          ELSE IF (IAI3.EQ.1002) THEN
            CALL GSFACI (3)
            CALL GFA    (NCRA,XCRA,YCRA)
          END IF
C
        END IF
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE GTLLG3 (RPNT,MPNT,NPNT,LOPN,
     +                   IEDG,MEDG,NEDG,LOEN,
     +                   ITRI,MTRI,NTRI,LOTN,
     +                             CLAT,CLON)
C
        DIMENSION RPNT(MPNT),IEDG(MEDG),ITRI(MTRI)
C
C A simple lat/lon grid is a rectangular array, at each point of which
C we have latitude, longitude, and a data value.  From this rectangular
C grid, we construct a triangular mesh to test the contouring algorithm.
C
        PARAMETER (IDIM=181,JDIM=91)
C
C Declare arrays to receive the grid data.  XLAT is the array of
C latitudes, XLON the array of longitudes, and ZDAT the array of
C field values.
C
        COMMON /CMLLG3/ XLAT(IDIM,JDIM),XLON(IDIM,JDIM),ZDAT(IDIM,JDIM)
        SAVE   /CMLLG3/
C
C Each cell of the rectangular grid for which data is available at all
C four corners is split in half along one of its diagonals; resulting
C triangles form the triangular mesh.  As we create the triangular mesh,
C we have to keep track of where the points and edges of the rectangular
C grid were put (so as to avoid the problem of duplicating points and
C edges in the structure).  The array ISCR is used for this.
C
        DIMENSION ISCR(4,IDIM,JDIM)
C
C Declare external a routine to tell CTTMRG about points of overlap on
C the lat/lon grid.
C
        EXTERNAL MILLG3
C
C Define a constant used to convert from degrees to radians.
C
        DATA DTOR / .017453292519943 /
C
C Define the data directly.
C
        DO 102 I=1,IDIM
          DO 101 J=1,JDIM
            XLAT(I,J)= -90.+(REAL(J-1)/REAL(JDIM-1))*180.
            XLON(I,J)=-180.+(REAL(I-1)/REAL(IDIM-1))*360.
            ZDAT(I,J)=COS(3.*DTOR*XLAT(I,J))*COS(3.*DTOR*XLON(I,J))
  101     CONTINUE
  102   CONTINUE
C
C Call a general-purpose subroutine that accepts a rectangular grid
C mapped onto the surface of the globe and returns a triangular mesh
C equivalent to it.
C
        CALL CTTMRG (IDIM,JDIM,XLAT,XLON,ZDAT,ISCR,SVAL,MILLG3,
     +               RPNT,MPNT,NPNT,LOPN,
     +               IEDG,MEDG,NEDG,LOEN,
     +               ITRI,MTRI,NTRI,LOTN)
C
C Return the latitude and longitude of the approximate center point of
C the mesh on the globe.
C
        CLAT=XLAT(IDIM/2,JDIM/2)
        CLON=XLON(IDIM/2,JDIM/2)
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE MILLG3 (IDIM,JDIM,IINI,JINI,IINO,JINO)
C
C Given the dimensions, IDIM and JDIM, of a simple lat/lon grid on the
C globe, and the indices, IINI and JINI, of a point on the grid, this
C routine returns the indices, IINO and JINO, of that coincident point
C on the grid which is to be used to represent it.  This version assumes
C that the first and last rows of the grid each map into a single point
C (perhaps the south pole and the north pole, respectively) and that
C the right and left edges of the grid lie on top of each other.
C
        IF (JINI.EQ.1) THEN
          IINO=1
          JINO=1
        ELSE IF (JINI.EQ.JDIM) THEN
          IINO=1
          JINO=JDIM
        ELSE IF (IINI.EQ.IDIM) THEN
          IINO=1
          JINO=JINI
        ELSE
          IINO=IINI
          JINO=JINI
        END IF
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE DSLLG3
C
C Draw the simple lat/lon grid, using data passed in a common block.
C
        PARAMETER (IDIM=181,JDIM=91,IDM1=IDIM-1,JDM1=JDIM-1)
C
        COMMON /CMLLG3/ XLAT(IDIM,JDIM),XLON(IDIM,JDIM),ZDAT(IDIM,JDIM)
        SAVE   /CMLLG3/
C
C Draw the grid.
C
        CALL PLOTIT (0,0,2)
        CALL GSPLCI (8)
C
        DO 102 I=1,IDM1
          DO 101 J=1,JDM1
            CALL DRSGCR (XLAT(I,J),XLON(I,J),XLAT(I,J+1),XLON(I,J+1))
  101     CONTINUE
  102   CONTINUE
C
        DO 104 J=2,JDM1
          DO 103 I=1,IDM1
            CALL DRSGCR (XLAT(I,J),XLON(I,J),XLAT(I+1,J),XLON(I+1,J))
  103     CONTINUE
  104   CONTINUE
C
C Draw the continental outlines and lat/lon grid.
C
        CALL PLOTIT (0,0,2)
        CALL GSPLCI (13)
        CALL MAPGRD
        CALL PLOTIT (0,0,2)
        CALL GSPLCI (14)
        CALL MAPLOT
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE DCLLG3
C
C Draw the simple lat/lon grid, using data passed in a common block.
C
        PARAMETER (IDIM=181,JDIM=91,IDM1=IDIM-1,JDM1=JDIM-1)
C
        COMMON /CMLLG3/ XLAT(IDIM,JDIM),XLON(IDIM,JDIM),ZDAT(IDIM,JDIM)
        SAVE   /CMLLG3/
C
        COMMON /CMGRID/ IWID,IFCI,MCOL,NCOL
        SAVE   /CMGRID/
C
C Declare arrays to use for solid fill.
C
        DIMENSION XBOX(4),YBOX(4)
C
C Define the major and minor axes of the ellipses that mark selected
C points on the grid.
C
        DATA RADA,RADB / .010,.010 /
C
C Define a constant to convert from degrees to radians.
C
        DATA DTOR / .017453292519943 /
C
C Fill the grid box by box.
C
        DO 102 I=1,IDM1
          ICOL=INT(10.*REAL(I-1)/REAL(IDM1))
          DO 101 J=1,JDM1
            JCOL=INT(10.*REAL(J-1)/REAL(JDM1))
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (51+10*ICOL+JCOL)
            CALL GSFACI (51+10*ICOL+JCOL)
            XCOA=COS(DTOR*XLAT(I  ,J  ))*COS(DTOR*XLON(I  ,J  ))
            YCOA=COS(DTOR*XLAT(I  ,J  ))*SIN(DTOR*XLON(I  ,J  ))
            ZCOA=SIN(DTOR*XLAT(I  ,J  ))
            CALL CTMXYZ (1,XCOA,YCOA,ZCOA,XBOX(1),YBOX(1))
            IF (XBOX(1).EQ.1.E12.OR.YBOX(1).EQ.1.E12) GO TO 101
            XCOA=COS(DTOR*XLAT(I+1,J  ))*COS(DTOR*XLON(I+1,J  ))
            YCOA=COS(DTOR*XLAT(I+1,J  ))*SIN(DTOR*XLON(I+1,J  ))
            ZCOA=SIN(DTOR*XLAT(I+1,J  ))
            CALL CTMXYZ (1,XCOA,YCOA,ZCOA,XBOX(2),YBOX(2))
            IF (XBOX(2).EQ.1.E12.OR.YBOX(2).EQ.1.E12) GO TO 101
            XCOA=COS(DTOR*XLAT(I+1,J+1))*COS(DTOR*XLON(I+1,J+1))
            YCOA=COS(DTOR*XLAT(I+1,J+1))*SIN(DTOR*XLON(I+1,J+1))
            ZCOA=SIN(DTOR*XLAT(I+1,J+1))
            CALL CTMXYZ (1,XCOA,YCOA,ZCOA,XBOX(3),YBOX(3))
            IF (XBOX(3).EQ.1.E12.OR.YBOX(3).EQ.1.E12) GO TO 101
            XCOA=COS(DTOR*XLAT(I  ,J+1))*COS(DTOR*XLON(I  ,J+1))
            YCOA=COS(DTOR*XLAT(I  ,J+1))*SIN(DTOR*XLON(I  ,J+1))
            ZCOA=SIN(DTOR*XLAT(I  ,J+1))
            CALL CTMXYZ (1,XCOA,YCOA,ZCOA,XBOX(4),YBOX(4))
            IF (XBOX(4).EQ.1.E12.OR.YBOX(4).EQ.1.E12) GO TO 101
            CALL GFA (4,XBOX,YBOX)
  101     CONTINUE
  102   CONTINUE
C
C Draw the continental outlines and lat/lon grid.
C
        CALL PLOTIT (0,0,2)
        CALL GSPLCI (13)
        CALL MAPGRD
        CALL PLOTIT (0,0,2)
        CALL GSPLCI (14)
        CALL MAPLOT
C
C In gray, draw those interior lines of the grid that separate boxes of
C different colors.
C
        CALL PLOTIT (0,0,2)
        CALL GSPLCI (11)
C
        DO 104 I=2,IDM1
          DO 103 J=1,JDM1
            IF (INT(10.*REAL(I-1)/REAL(IDM1)).EQ.
     +          INT(10.*REAL(I-2)/REAL(IDM1))) GO TO 103
            CALL DRSGCR (XLAT(I,J),XLON(I,J),XLAT(I,J+1),XLON(I,J+1))
  103     CONTINUE
  104   CONTINUE
C
        DO 106 J=2,JDM1
          DO 105 I=1,IDM1
            IF (INT(10.*REAL(J-1)/REAL(JDM1)).EQ.
     +          INT(10.*REAL(J-2)/REAL(JDM1))) GO TO 105
            CALL DRSGCR (XLAT(I,J),XLON(I,J),XLAT(I+1,J),XLON(I+1,J))
  105     CONTINUE
  106   CONTINUE
C
C In the foreground color, outline the grid (using a thickened line).
C
        CALL PLOTIT (0,0,2)
        CALL GSPLCI (1)
        CALL GSLWSC (2.)
C
        DO 108 I=1,IDIM,IDIM-1
          DO 107 J=1,JDM1
            CALL DRSGCR (XLAT(I,J),XLON(I,J),XLAT(I,J+1),XLON(I,J+1))
  107     CONTINUE
  108   CONTINUE
C
        DO 110 J=1,JDIM,JDIM-1
          DO 109 I=1,IDM1
            CALL DRSGCR (XLAT(I,J),XLON(I,J),XLAT(I+1,J),XLON(I+1,J))
  109     CONTINUE
  110   CONTINUE
C
        CALL PLOTIT (0,0,2)
        CALL GSLWSC (1.)
C
C Mark the four corner points and the center of the grid.
C
        CALL PLOTIT (0,0,2)
        CALL GSPLCI (1)
        CALL GSFACI (1)
C
        CALL MAPTRA (XLAT(1,JDIM),XLON(1,JDIM),XVAL,YVAL)
        IF (XVAL.NE.1.E12.AND.YVAL.NE.1.E12) THEN
          CALL ELLIPS (CUFX(XVAL),CUFY(YVAL),RADA,RADB,0.,4.)
        END IF
C
        CALL MAPTRA (XLAT(IDIM,JDIM),XLON(IDIM,JDIM),XVAL,YVAL)
        IF (XVAL.NE.1.E12.AND.YVAL.NE.1.E12) THEN
          CALL ELLIPS (CUFX(XVAL),CUFY(YVAL),RADA,RADB,0.,4.)
        END IF
C
        CALL MAPTRA (XLAT(1,1),XLON(1,1),XVAL,YVAL)
        IF (XVAL.NE.1.E12.AND.YVAL.NE.1.E12) THEN
          CALL ELLIPS (CUFX(XVAL),CUFY(YVAL),RADA,RADB,0.,4.)
        END IF
C
        CALL MAPTRA (XLAT(IDIM,1),XLON(IDIM,1),XVAL,YVAL)
        IF (XVAL.NE.1.E12.AND.YVAL.NE.1.E12) THEN
          CALL ELLIPS (CUFX(XVAL),CUFY(YVAL),RADA,RADB,0.,4.)
        END IF
C
C       CALL PLOTIT (0,0,2)
C       CALL GSPLCI (1)
C       CALL GSFACI (0)
C
C       IF (MOD(IDIM,2).EQ.0) THEN
C         CALL FPSGCR (XLAT(IDIM/2  ,JDIM),XLON(IDIM/2  ,JDIM),
C    +                 XLAT(IDIM/2+1,JDIM),XLON(IDIM/2+1,JDIM),
C    +                                                     .5,CLAT,CLON)
C       ELSE
C         CLAT=XLAT(IDIM/2+1,JDIM)
C         CLON=XLON(IDIM/2+1,JDIM)
C       END IF
C       CALL MAPTRA (CLAT,CLON,XVAL,YVAL)
C       IF (XVAL.NE.1.E12.AND.YVAL.NE.1.E12) THEN
C         CALL ELLIPS (CUFX(XVAL),CUFY(YVAL),RADA,RADB,0.,4.)
C       END IF
C
C       IF (MOD(JDIM,2).EQ.0) THEN
C         CALL FPSGCR (XLAT(1,JDIM/2  ),XLON(1,JDIM/2  ),
C    +                 XLAT(1,JDIM/2+1),XLON(1,JDIM/2+1),
C    +                                                     .5,CLAT,CLON)
C       ELSE
C         CLAT=XLAT(1,JDIM/2+1)
C         CLON=XLON(1,JDIM/2+1)
C       END IF
C       CALL MAPTRA (CLAT,CLON,XVAL,YVAL)
C       IF (XVAL.NE.1.E12.AND.YVAL.NE.1.E12) THEN
C         CALL ELLIPS (CUFX(XVAL),CUFY(YVAL),RADA,RADB,0.,4.)
C       END IF
C
C       IF (MOD(JDIM,2).EQ.0) THEN
C         CALL FPSGCR (XLAT(IDIM,JDIM/2  ),XLON(IDIM,JDIM/2  ),
C    +                 XLAT(IDIM,JDIM/2+1),XLON(IDIM,JDIM/2+1),
C    +                                                     .5,CLAT,CLON)
C       ELSE
C         CLAT=XLAT(IDIM,JDIM/2+1)
C         CLON=XLON(IDIM,JDIM/2+1)
C       END IF
C       CALL MAPTRA (CLAT,CLON,XVAL,YVAL)
C       IF (XVAL.NE.1.E12.AND.YVAL.NE.1.E12) THEN
C         CALL ELLIPS (CUFX(XVAL),CUFY(YVAL),RADA,RADB,0.,4.)
C       END IF
C
C       IF (MOD(IDIM,2).EQ.0) THEN
C         CALL FPSGCR (XLAT(IDIM/2  ,1),XLON(IDIM/2  ,1),
C    +                 XLAT(IDIM/2+1,1),XLON(IDIM/2+1,1),
C    +                                                     .5,CLAT,CLON)
C       ELSE
C         CLAT=XLAT(IDIM/2+1,1)
C         CLON=XLON(IDIM/2+1,1)
C       END IF
C       CALL MAPTRA (CLAT,CLON,XVAL,YVAL)
C       IF (XVAL.NE.1.E12.AND.YVAL.NE.1.E12) THEN
C         CALL ELLIPS (CUFX(XVAL),CUFY(YVAL),RADA,RADB,0.,4.)
C       END IF
C
        CALL PLOTIT (0,0,2)
        CALL GSPLCI (1)
        CALL GSFACI (4)
C
        IF (MOD(IDIM,2).EQ.0) THEN
          IF (MOD(JDIM,2).EQ.0) THEN
            CALL IPIQOS(XLAT(IDIM/2  ,JDIM/2  ),XLON(IDIM/2  ,JDIM/2  ),
     +                  XLAT(IDIM/2+1,JDIM/2  ),XLON(IDIM/2+1,JDIM/2  ),
     +                  XLAT(IDIM/2  ,JDIM/2+1),XLON(IDIM/2  ,JDIM/2+1),
     +                  XLAT(IDIM/2+1,JDIM/2+1),XLON(IDIM/2+1,JDIM/2+1),
     +                                                  .5,.5,CLAT,CLON)
          ELSE
            CALL FPSGCR(XLAT(IDIM/2  ,JDIM/2+1),XLON(IDIM/2  ,JDIM/2+1),
     +                  XLAT(IDIM/2+1,JDIM/2+1),XLON(IDIM/2+1,JDIM/2+1),
     +                                                     .5,CLAT,CLON)
          END IF
        ELSE
          IF (MOD(JDIM,2).EQ.0) THEN
            CALL FPSGCR(XLAT(IDIM/2+1,JDIM/2  ),XLON(IDIM/2+1,JDIM/2  ),
     +                  XLAT(IDIM/2+1,JDIM/2+1),XLON(IDIM/2+1,JDIM/2+1),
     +                                                    .5,CLAT,CLON)
          ELSE
           CLAT=XLAT(IDIM/2+1,JDIM/2+1)
           CLON=XLON(IDIM/2+1,JDIM/2+1)
          END IF
        END IF
        CALL MAPTRA (CLAT,CLON,XVAL,YVAL)
        IF (XVAL.NE.1.E12.AND.YVAL.NE.1.E12) THEN
          CALL ELLIPS (CUFX(XVAL),CUFY(YVAL),RADA,RADB,0.,4.)
        END IF
C
C Draw a shaded reference grid in the lower left corner of the frame.
C
        CALL SHDGRD (.03,.33,.03,.18,IDM1,JDM1,3,5)
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE DRSGCR (ALAT,ALON,BLAT,BLON)
C
C (DRSGCR = DRaw Shortest Great Circle Route)
C
C This routine draws the shortest great circle route joining two points
C on the globe.  Note that MPTS = INT(180./SIZE) + 1.
C
        PARAMETER (MPTS=181,SIZE=1.)
C
        DIMENSION QLAT(MPTS),QLON(MPTS)
C
        NPTS=MAX(1,MIN(MPTS,INT(ADSGCR(ALAT,ALON,BLAT,BLON)/SIZE)))
C
        CALL MAPGCI (ALAT,ALON,BLAT,BLON,NPTS,QLAT,QLON)
C
        CALL MAPIT (ALAT,ALON,0)
C
        DO 101 I=1,NPTS
          CALL MAPIT (QLAT(I),QLON(I),1)
  101   CONTINUE
C
        CALL MAPIT (BLAT,BLON,2)
C
        CALL MAPIQ
C
        RETURN
C
      END


      FUNCTION ADSGCR (ALAT,ALON,BLAT,BLON)
C
C (ADSGCR = Angle in Degrees along Shortest Great Circle Route)
C
C This function returns the shortest great circle distance, in degrees,
C between two points, A and B, on the surface of the globe.
C
        DATA DTOR / .017453292519943 /
        DATA RTOD / 57.2957795130823 /
C
        XCOA=COS(DTOR*ALAT)*COS(DTOR*ALON)
        YCOA=COS(DTOR*ALAT)*SIN(DTOR*ALON)
        ZCOA=SIN(DTOR*ALAT)
C
        XCOB=COS(DTOR*BLAT)*COS(DTOR*BLON)
        YCOB=COS(DTOR*BLAT)*SIN(DTOR*BLON)
        ZCOB=SIN(DTOR*BLAT)
C
        ADSGCR=2.*RTOD*ASIN(SQRT((XCOA-XCOB)**2+
     +                           (YCOA-YCOB)**2+
     +                           (ZCOA-ZCOB)**2)/2.)
C
        RETURN
C
      END


      SUBROUTINE DCFGRD (IAR1,IAR2,IAR3,IAR4,CCLL,CCLR,CCUL,CCUR)
C
        DIMENSION CCLL(3),CCLR(3),CCUL(3),CCUR(3),CCGC(3)
C
C This routine defines the colors to be used by SHDGRD.  CCLL, CCLR,
C CCUL, and CCUR define the RGB color components for the lower-left
C corner, the lower-right corner, the upper-left corner, and the
C upper-right corner, respectively, of the grid.  Other colors to be
C used are defined by interpolation.
C
        COMMON /CMGRID/ IWID,IFCI,MCOL,NCOL
        SAVE   /CMGRID/
C
C Transfer first four arguments to common block shared with SHDGRD.
C
        IWID=IAR1
        IFCI=IAR2
        MCOL=IAR3
        NCOL=IAR4
C
        DO 103 I=0,MCOL-1
          P=REAL(I)/REAL(MCOL-1)
          DO 102 J=0,NCOL-1
            Q=REAL(J)/REAL(NCOL-1)
            DO 101 K=1,3
              CCGC(K)=(1.-P)*((1.-Q)*CCLL(K)+Q*CCUL(K))+
     +                    P *((1.-Q)*CCLR(K)+Q*CCUR(K))
  101       CONTINUE
            CALL GSCR (IWID,IFCI+NCOL*I+J,
     +                 MAX(0.,MIN(1.,CCGC(1))),
     +                 MAX(0.,MIN(1.,CCGC(2))),
     +                 MAX(0.,MIN(1.,CCGC(3))))
  102     CONTINUE
  103   CONTINUE
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE SHDGRD (XVPL,XVPR,YVPB,YVPT,IMAX,JMAX,ITYP,IMRK)
C
C This routine draws a representation of a grid of IMAX by JMAX boxes
C (having IMAX+1 vertical lines and JMAX+1 horizontal lines) in the part
C of the plotter frame specified by XVPL, XVPR, YVPB, and YVPT.  Colors
C used are those specified by a superimposed grid of MCOL by NCOL colors
C with indices IFCI through IFCI+MCOL*NCOL-1.  If ITYP is 0, the grid
C is drawn, but not filled.  If ITYP is 1, the grid is filled.  If ITYP
C is 2, the grid is filled and then outlined in the foreground color.
C If ITYP is 3, the grid is filled, some of the interior grid lines (the
C ones between boxes of different colors) are drawn in gray, and then
C the grid is outlined in the foreground color.  If ITYP is 4, the grid
C is filled, all of the interior grid lines are drawn in gray, and then
C the grid is outlined in the foreground color.  If IMRK is 0, no points
C of the grid are marked with filled circles; if IMRK is 1, the corner
C points are marked with black-filled circles; if IMRK is 2, the edge
C points are marked with white-filled black circles; if IMRK is 4, the
C center point is marked with a red-filled black circle; sums of these
C values can be used to get combinations of behaviors.
C
        COMMON /CMGRID/ IWID,IFCI,MCOL,NCOL
        SAVE   /CMGRID/
C
        DIMENSION XBOX(5),YBOX(5)
C
C Define the major and minor axes of the ellipses that mark selected
C points on the grid.
C
        DATA RADA,RADB / .005,.005 /
C
C Save the current SET call.
C
        CALL GETSET (EVPL,EVPR,EVPB,EVPT,EWDL,EWDR,EWDB,EWDT,LNLG)
C
C Compute the coordinates of the center of the viewport in which the
C grid is to be drawn, its half-height, and its half-width.
C
        XVPC=(XVPR+XVPL)/2.
        YVPC=(YVPB+YVPT)/2.
        HVPW=(XVPR-XVPL)/2.
        HVPH=(YVPT-YVPB)/2.
C
C Compute values defining the exact viewport in which the grid is to
C be drawn and redo the set call appropriately.
C
        IF (REAL(IMAX)/REAL(JMAX).LE.(XVPR-XVPL)/(YVPT-YVPB)) THEN
          SVPL=XVPC-HVPH*(REAL(IMAX)/REAL(JMAX))
          SVPR=XVPC+HVPH*(REAL(IMAX)/REAL(JMAX))
          SVPB=YVPB
          SVPT=YVPT
        ELSE
          SVPL=XVPL
          SVPR=XVPR
          SVPB=YVPC-HVPW*(REAL(JMAX)/REAL(IMAX))
          SVPT=YVPC+HVPW*(REAL(JMAX)/REAL(IMAX))
        END IF
C
        CALL SET (SVPL,SVPR,SVPB,SVPT,0.,REAL(IMAX),0.,REAL(JMAX),1)
C
C If the lines are to be drawn in different colors ...
C
        IF (ITYP.EQ.0) THEN
C
C ... do it.
C
          DO 102 I=0,IMAX-1
            ICOL=INT(REAL(MCOL)*REAL(I)/REAL(IMAX))
            DO 101 J=0,JMAX-1
              JCOL=INT(REAL(NCOL)*REAL(J)/REAL(JMAX))
              CALL PLOTIT (0,0,2)
              CALL GSPLCI (IFCI+NCOL*ICOL+JCOL)
              XBOX(1)=REAL(I)
              XBOX(2)=REAL(I+1)
              XBOX(3)=REAL(I+1)
              XBOX(4)=REAL(I)
              XBOX(5)=REAL(I)
              YBOX(1)=REAL(J)
              YBOX(2)=REAL(J)
              YBOX(3)=REAL(J+1)
              YBOX(4)=REAL(J+1)
              YBOX(5)=REAL(J)
              CALL GPL (5,XBOX,YBOX)
  101       CONTINUE
  102     CONTINUE
C
C Otherwise, the boxes are to be filled in different colors, so ...
C
        ELSE
C
C ... do it.
C
          DO 104 I=0,IMAX-1
            ICOL=INT(REAL(MCOL)*REAL(I)/REAL(IMAX))
            DO 103 J=0,JMAX-1
              JCOL=INT(REAL(NCOL)*REAL(J)/REAL(JMAX))
              CALL GSFACI (IFCI+NCOL*ICOL+JCOL)
              XBOX(1)=REAL(I)
              XBOX(2)=REAL(I+1)
              XBOX(3)=REAL(I+1)
              XBOX(4)=REAL(I)
              YBOX(1)=REAL(J)
              YBOX(2)=REAL(J)
              YBOX(3)=REAL(J+1)
              YBOX(4)=REAL(J+1)
              CALL GFA (4,XBOX,YBOX)
  103       CONTINUE
  104     CONTINUE
C
C In addition, if specified, draw lines on the grid ...
C
          IF (ITYP.GT.1) THEN
C
C ... either just the border ...
C
            IF (ITYP.GT.2) THEN
C
C ... or all the lines ...
C
              CALL PLOTIT (0,0,2)
              CALL GSPLCI (11)
C
              DO 105 I=1,IMAX-1
                IF (ITYP.GT.3.OR.
     +              INT(REAL(MCOL)*REAL(I-1)/REAL(IMAX)).NE.
     +              INT(REAL(MCOL)*REAL(I  )/REAL(IMAX)))
     +            CALL LINE (REAL(I),0.,REAL(I),REAL(JMAX))
  105         CONTINUE
C
              DO 106 J=1,JMAX-1
                IF (ITYP.GT.3.OR.
     +              INT(REAL(NCOL)*REAL(J-1)/REAL(JMAX)).NE.
     +              INT(REAL(NCOL)*REAL(J  )/REAL(JMAX)))
     +          CALL LINE (0.,REAL(J),REAL(IMAX),REAL(J))
  106         CONTINUE
C
            END IF
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (1)
            CALL GSLWSC (2.)
C
            CALL LINE (        0.,        0.,REAL(IMAX),        0.)
            CALL LINE (REAL(IMAX),        0.,REAL(IMAX),REAL(JMAX))
            CALL LINE (REAL(IMAX),REAL(JMAX),        0.,REAL(JMAX))
            CALL LINE (        0.,REAL(JMAX),        0.,        0.)
C
            CALL PLOTIT (0,0,2)
            CALL GSLWSC (1.)
C
          END IF
C
        END IF
C
C If specified, mark a selected subset of nine different points of
C reference on the grid.
C
        IF (MOD(IMRK,2).NE.0) THEN
C
          CALL PLOTIT (0,0,2)
          CALL GSPLCI (1)
          CALL GSFACI (1)
C
          CALL ELLIPS (SVPL,SVPT,RADA,RADB,0.,4.)
          CALL ELLIPS (SVPR,SVPT,RADA,RADB,0.,4.)
          CALL ELLIPS (SVPL,SVPB,RADA,RADB,0.,4.)
          CALL ELLIPS (SVPR,SVPB,RADA,RADB,0.,4.)
C
        END IF
C
        IF (MOD(IMRK/2,2).NE.0) THEN
C
          CALL PLOTIT (0,0,2)
          CALL GSPLCI (1)
          CALL GSFACI (0)
C
          CALL ELLIPS (.5*(SVPL+SVPR),SVPT,RADA,RADB,0.,4.)
          CALL ELLIPS (SVPL,.5*(SVPB+SVPT),RADA,RADB,0.,4.)
          CALL ELLIPS (SVPR,.5*(SVPB+SVPT),RADA,RADB,0.,4.)
          CALL ELLIPS (.5*(SVPL+SVPR),SVPB,RADA,RADB,0.,4.)
C
        END IF
C
        IF (MOD(IMRK/4,2).NE.0) THEN
C
          CALL PLOTIT (0,0,2)
          CALL GSPLCI (1)
          CALL GSFACI (4)
C
          CALL ELLIPS (.5*(SVPL+SVPR),.5*(SVPB+SVPT),RADA,RADB,0.,4.)
C
        END IF
C
        CALL GSFACI (1)
C
C Label the bottom of the grid.
C
        CALL PLCHHQ (CFUX(.5*(SVPL+SVPR)),CFUY(SVPB-.018),
     +                                                'I-->',.012,0.,0.)
C
C Label the left edge of the grid.
C
        CALL PLCHHQ (CFUX(SVPL-.018),CFUY(.5*(SVPB+SVPT)),
     +                                               'J-->',.012,90.,0.)
C
C Restore the original SET call.
C
        CALL SET (EVPL,EVPR,EVPB,EVPT,EWDL,EWDR,EWDB,EWDT,LNLG)
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE ELLIPS (XCFR,YCFR,RADA,RADB,ROTD,DSTP)
C
C This routine fills an ellipse.  The arguments are as follows:
C
C   XCFR and YCFR are the coordinates of the center of the ellipse, in
C   the fractional coordinate system.
C
C   RADA is the length of the semimajor axis of the ellipse (i.e., the
C   distance from the center of the ellipse to one of the two points on
C   the ellipse which are furthest from the center).  This is a distance
C   in the fractional coordinate system.
C
C   RADB is the length of the semiminor axis of the ellipse (i.e., the
C   distance from the center of the ellipse to one of the two points on
C   the ellipse which are nearest to the center).  This is a distance in
C   the fractional coordinate system.
C
C   ROTD is a rotation angle, in degrees.  If ROTD is 0, the major axis
C   of the ellipse is horizontal.  If ROTD is 90, the major axis is
C   vertical.
C
C   DSTP is the step size, in degrees, between any two consecutive
C   points used to draw the ellipse.  The actual value used will be
C   limited to the range from .1 degrees (3600 points used to draw
C   the ellipse) to 90 degrees (4 points used to draw the ellipse).
C
C Declare work arrays to hold the coordinates.
C
        DIMENSION XCRA(3601),YCRA(3601)
C
C DTOR is pi over 180, used to convert an angle from degrees to radians.
C
        DATA DTOR / .017453292519943 /
C
C Get the rotation angle in radians.
C
        ROTR=DTOR*ROTD
C
C Compute the number of steps to be used to draw the ellipse and the
C actual number of degrees for each step.
C
        NSTP=MAX(4,MIN(3600,INT(360./MAX(.1,MIN(90.,DSTP)))))
        RSTP=360./NSTP
C
C Compute coordinates for the ellipse (just some trigonometry).
C
        DO 101 ISTP=0,NSTP
          ANGL=DTOR*REAL(ISTP)*RSTP
          XTMP=RADA*COS(ANGL)
          YTMP=RADB*SIN(ANGL)
          XCRA(ISTP+1)=CFUX(XCFR+XTMP*COS(ROTR)-YTMP*SIN(ROTR))
          YCRA(ISTP+1)=CFUY(YCFR+XTMP*SIN(ROTR)+YTMP*COS(ROTR))
  101   CONTINUE
C
C Fill it.
C
        CALL GFA (NSTP+1,XCRA,YCRA)
C
C Draw it.
C
        CALL GPL (NSTP+1,XCRA,YCRA)
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE IPIQOS (ALAT,ALON,BLAT,BLON,CLAT,CLON,DLAT,DLON,
     +                                       XFRA,YFRA,ELAT,ELON)
C
C (IPIQOS = Interpolate Point In Quadrilateral on Sphere)
C
C This routine, given the latitudes and longitudes of four points (A, B,
C C, and D) forming a "quadrilateral" on the globe and two interpolation
C fractions (XFRA and YFRA, each between 0 and 1, inclusive), finds the
C point E defined by the following diagram and returns its latitude and
C longitude.
C
C                              C------Q----D
C                              |      |    |
C                              |      E    |
C                              |      |    |
C                              |      |    |
C                              A------P----B
C
C P and Q are positioned such that AP/AB = CQ/CD = XFRA and then E is
C positioned such that PE/PQ = YFRA (where "XY" is interpreted to mean
C "the shortest great circle distance from X to Y").
C
C It is assumed that the "quadrilateral" ABDC is "convex" (a working
C definition of which might be that none of the four great circles
C defined by its edges - the ones through A and B, B and D, D and C,
C and C and A - cross it anywhere.  However, this is not verified.
C
C The code is easy:
C
        CALL FPSGCR (ALAT,ALON,BLAT,BLON,XFRA,PLAT,PLON)
        CALL FPSGCR (CLAT,CLON,DLAT,DLON,XFRA,QLAT,QLON)
        CALL FPSGCR (PLAT,PLON,QLAT,QLON,YFRA,ELAT,ELON)
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE FPSGCR (ALAT,ALON,BLAT,BLON,FRCT,FLAT,FLON)
C
C (FPSGCR = Find Point on Shortest Great Circle Route)
C
        REAL    ALAT,ALON,BLAT,BLON,FRCT,FLAT,FLON
C
C This routine, given the latitudes and longitudes of two points A and
C B on the surface of the globe and a fraction FRCT, between 0. and 1.,
C interpolates a point F along the shortest great circle route joining
C A to B such that the distance from A to F, divided by the distance
C from A to B, is equal to FRCT, and returns its latitude and longitude
C in FLAT and FLON.
C
C Define the constants used to convert from degrees to radians and
C vice-versa.
C
        DATA DTOR / .017453292519943 /
        DATA RTOD / 57.2957795130823 /
C
C Compute the X, Y, and Z coordinates (on a unit sphere) of the point B.
C
        CALL LLPXYZ (BLAT,BLON,XCPB,YCPB,ZCPB)
C
C Rotating about the Z axis by the angle -ALON would carry A into the XZ
C plane.
C
        CALL ROTXYZ (3,-ALON,XCPB,YCPB,ZCPB)
C
C Then, rotating about the Y axis by the angle ALAT would carry A into
C the point on the X axis with coordinates (1,0,0).
C
        CALL ROTXYZ (2,ALAT,XCPB,YCPB,ZCPB)
C
C Then, rotating about the X axis by the angle ALPH = -ATAN(ZCPB/YCPB)
C would leave the position of A unchanged but carry B into a point in
C the XY plane.
C
        IF (ZCPB.NE.0..OR.YCPB.NE.0.) THEN
          ALPH=-RTOD*ATAN2(ZCPB,YCPB)
        ELSE
          ALPH=0.
        END IF
C
        CALL ROTXYZ (1,ALPH,XCPB,YCPB,ZCPB)
C
C The angle BETA from A to B can now be computed easily.
C
        IF (XCPB.NE.0..OR.YCPB.NE.0.) THEN
          BETA=ATAN2(YCPB,XCPB)
        ELSE
          BETA=0.
        END IF
C
C Interpolate a point at the desired position between the points A and
C B, map it back to its original position on the great circle route from
C A to B, and get its latitude and longitude to return to the caller.
C
        GAMA=FRCT*BETA
C
        XCPF=COS(GAMA)
        YCPF=SIN(GAMA)
        ZCPF=0.
C
        CALL ROTXYZ (1,-ALPH,XCPF,YCPF,ZCPF)
        CALL ROTXYZ (2,-ALAT,XCPF,YCPF,ZCPF)
        CALL ROTXYZ (3, ALON,XCPF,YCPF,ZCPF)
C
        CALL XYZLLP (XCPF,YCPF,ZCPF,FLAT,FLON)
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE LLPXYZ (RLAT,RLON,RVOX,RVOY,RVOZ)
C
C (LLPXYZ = Lat/Lon Position to XYZ coordinates)
C
C Given the latitude and longitude of a point on the globe, return its
C X, Y, and Z coordinates.
C
        DATA DTOR / .017453292519943 /
C
        RVOX=COS(DTOR*RLAT)*COS(DTOR*RLON)
        RVOY=COS(DTOR*RLAT)*SIN(DTOR*RLON)
        RVOZ=SIN(DTOR*RLAT)
C
        RETURN
C
      END


      SUBROUTINE XYZLLP (RVOX,RVOY,RVOZ,RLAT,RLON)
C
C (XYZLLP = XYZ coordinates to Lat/Lon Position)
C
C Given the X, Y, and Z coordinates of a point on the globe, return its
C latitude and longitude.
C
        DATA RTOD / 57.2957795130823 /
C
        RLAT=RTOD*ASIN(RVOZ)
C
        IF (RVOX.NE.0.OR.RVOY.NE.0.) THEN
          RLON=RTOD*ATAN2(RVOY,RVOX)
        ELSE
          RLON=0.
        END IF
C
        RETURN
C
      END


      SUBROUTINE ROTXYZ (IAXS,ANGL,XCRD,YCRD,ZCRD)
C
C (ROTXYZ = ROTate a point defined by its X, Y, and Z coordinates)
C
C This is a modified version of a routine in the NCAR Graphics package,
C which is used in some of the examples.  It rotates the point having
C coordinates (XCRD,YCRD,ZCRD) by an angle ANGL about the axis specified
C by IAXS (1 for the X axis, 2 for the Y axis, 3 for the Z axis).
C
C One assumes a right-handed system with X, Y, and Z axes.  Rotating by
C an angle "a" about the X axis maps the point (x,y,z) into the point
C (x',y',z'), where
C
C       x' = x
C       y' = y cos(a) - z sin(a)
C       z' = z cos(a) + y sin(a)
C
C A positive value of "a" represents rotation in the direction from the
C Y axis to the Z axis.
C
C Similarly, rotating by an angle "a" about the Y axis maps the point
C (x,y,z) into the point (x',y',z'), where
C
C       x' = x cos(a) + z sin(a)
C       y' = y
C       z' = z cos(a) - x sin(a)
C
C A positive value of "a" represents rotation in the direction from the
C Z axis to the X axis.
C
C Rotating by an angle "a" about the Z axis maps the point (x,y,z) into
C the point (x',y',z'), where
C
C       x' = x cos(a) - y sin(a)
C       y' = y cos(a) + x sin(a)
C       y' = y
C
C A positive value of "a" represents rotation in the direction from the
C X axis to the Y axis.
C
C Define a multiplicative constant to convert from degrees to radians.
C
        DATA DTOR / .017453292519943 /
C
C Trigonometry.
C
        SINA=SIN(DTOR*ANGL)
        COSA=COS(DTOR*ANGL)
C
        XTMP=XCRD
        YTMP=YCRD
        ZTMP=ZCRD
C
        IF (IAXS.EQ.1) THEN
          YCRD=YTMP*COSA-ZTMP*SINA
          ZCRD=ZTMP*COSA+YTMP*SINA
        ELSE IF (IAXS.EQ.2) THEN
          XCRD=XTMP*COSA+ZTMP*SINA
          ZCRD=ZTMP*COSA-XTMP*SINA
        ELSE
          XCRD=XTMP*COSA-YTMP*SINA
          YCRD=YTMP*COSA+XTMP*SINA
        END IF
C
        RETURN
C
      END


      SUBROUTINE CTSCAE (ICRA,ICA1,ICAM,ICAN,XCPF,YCPF,XCQF,YCQF,
     +                                       IND1,IND2,ICAF,IAID)
        DIMENSION ICRA(ICA1,*)
C
C This routine is called by CTCICA when the internal parameter 'CAF' is
C given a negative value.  Each call is intended to create a particular
C element in the user's cell array.  The arguments are as follows:
C
C ICRA is the user's cell array.
C
C ICA1 is the first dimension of the FORTRAN array ICRA.
C
C ICAM and ICAN are the first and second dimensions of the cell array
C stored in ICRA.
C
C (XCPF,YCPF) is the point at that corner of the rectangular area
C into which the cell array maps that corresponds to the cell (1,1).
C The coordinates are given in the fractional coordinate system (unlike
C what is required in a call to GCA, in which the coordinates of the
C point P are in the world coordinate system).
C
C (XCQF,YCQF) is the point at that corner of the rectangular area into
C which the cell array maps that corresponds to the cell (ICAM,ICAN).
C The coordinates are given in the fractional coordinate system (unlike
C what is required in a call to GCA, in which the coordinates of the
C point Q are in the world coordinate system).
C
C IND1 is the 1st index of the cell that is to be updated.
C
C IND2 is the 2nd index of the cell that is to be updated.
C
C ICAF is the current value of the internal parameter 'CAF'.  This
C value will always be an integer which is less than zero (because
C when 'CAF' is zero or greater, this routine is not called).
C
C IAID is the area identifier associated with the cell.  It will have
C been given one of the values from the internal parameter array 'AIA'
C (the one for 'PAI' = -2 if the cell lies in an out-of-range area, the
C one for 'PAI' = -1 if the cell lies off the data grid, or the one for
C some value of 'PAI' between 1 and 'NCL' if the cell lies on the data
C grid).  The value zero may occur if the cell falls in an out-of-range
C area and the value of 'AIA' for 'PAI' = -2 is 0 or if the cell lies
C off the data grid and the value of 'AIA' for 'PAI' = -1 is 0, or if
C the cell falls on the data grid, but no contour level below the cell
C has a non-zero 'AIA' and no contour level above the cell has a
C non-zero 'AIB'.  Note that, if the values of 'AIA' for 'PAI' = -1
C and -2 are given non-zero values, IAID can only be given a zero
C value in one way.
C
C The default behavior of CTSCAE is as follows:  If the area identifier
C is non-negative, it is treated as a color index, to be stored in the
C appropriate cell in the cell array; but if the area identifier is
C negative, a zero is stored for the color index.  The user may supply
C a version of CTSCAE that does something different; it may simply map
C the area identifiers into color indices or it may somehow modify the
C existing cell array element to incorporate the information provided
C by the area identifier.
C
C       ICRA(IND1,IND2)=MAX(0,IAID)
C
C What follows is not the default behavior; instead, it is the behavior
C expected by many of the example programs for CONPACKT.
C
        CALL CTGETI ('NCL - NUMBER OF CONTOUR LEVELS',NOCL)
C
        IF (IAID.GE.1.AND.IAID.LE.NOCL+1) THEN
          ICRA(IND1,IND2)=151+INT(((REAL(IAID)-.5)/REAL(NOCL+1))*100.)
        ELSE IF (IAID.EQ.1001) THEN
          ICRA(IND1,IND2)=2
        ELSE IF (IAID.EQ.1002) THEN
          ICRA(IND1,IND2)=3
        END IF
C
        RETURN
C
      END

      SUBROUTINE CHPEVD( JOBZ, UPLO, N, AP, W, Z, LDZ, WORK, LWORK,
     $                   RWORK, LRWORK, IWORK, LIWORK, INFO )
*
*  -- LAPACK driver routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          JOBZ, UPLO
      INTEGER            INFO, LDZ, LIWORK, LRWORK, LWORK, N
*     ..
*     .. Array Arguments ..
      INTEGER            IWORK( * )
      REAL               RWORK( * ), W( * )
      COMPLEX            AP( * ), WORK( * ), Z( LDZ, * )
*     ..
*
*  Purpose
*  =======
*
*  CHPEVD computes all the eigenvalues and, optionally, eigenvectors of
*  a complex Hermitian matrix A in packed storage.  If eigenvectors are
*  desired, it uses a divide and conquer algorithm.
*
*  The divide and conquer algorithm makes very mild assumptions about
*  floating point arithmetic. It will work on machines with a guard
*  digit in add/subtract, or on those binary machines without guard
*  digits which subtract like the Cray X-MP, Cray Y-MP, Cray C-90, or
*  Cray-2. It could conceivably fail on hexadecimal or decimal machines
*  without guard digits, but we know of none.
*
*  Arguments
*  =========
*
*  JOBZ    (input) CHARACTER*1
*          = 'N':  Compute eigenvalues only;
*          = 'V':  Compute eigenvalues and eigenvectors.
*
*  UPLO    (input) CHARACTER*1
*          = 'U':  Upper triangle of A is stored;
*          = 'L':  Lower triangle of A is stored.
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  AP      (input/output) COMPLEX array, dimension (N*(N+1)/2)
*          On entry, the upper or lower triangle of the Hermitian matrix
*          A, packed columnwise in a linear array.  The j-th column of A
*          is stored in the array AP as follows:
*          if UPLO = 'U', AP(i + (j-1)*j/2) = A(i,j) for 1<=i<=j;
*          if UPLO = 'L', AP(i + (j-1)*(2*n-j)/2) = A(i,j) for j<=i<=n.
*
*          On exit, AP is overwritten by values generated during the
*          reduction to tridiagonal form.  If UPLO = 'U', the diagonal
*          and first superdiagonal of the tridiagonal matrix T overwrite
*          the corresponding elements of A, and if UPLO = 'L', the
*          diagonal and first subdiagonal of T overwrite the
*          corresponding elements of A.
*
*  W       (output) REAL array, dimension (N)
*          If INFO = 0, the eigenvalues in ascending order.
*
*  Z       (output) COMPLEX array, dimension (LDZ, N)
*          If JOBZ = 'V', then if INFO = 0, Z contains the orthonormal
*          eigenvectors of the matrix A, with the i-th column of Z
*          holding the eigenvector associated with W(i).
*          If JOBZ = 'N', then Z is not referenced.
*
*  LDZ     (input) INTEGER
*          The leading dimension of the array Z.  LDZ >= 1, and if
*          JOBZ = 'V', LDZ >= max(1,N).
*
*  WORK    (workspace/output) COMPLEX array, dimension (LWORK)
*          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*
*  LWORK   (input) INTEGER
*          The dimension of array WORK.
*          If N <= 1,               LWORK must be at least 1.
*          If JOBZ = 'N' and N > 1, LWORK must be at least N.
*          If JOBZ = 'V' and N > 1, LWORK must be at least 2*N.
*
*          If LWORK = -1, then a workspace query is assumed; the routine
*          only calculates the optimal size of the WORK array, returns
*          this value as the first entry of the WORK array, and no error
*          message related to LWORK is issued by XERBLA.
*
*  RWORK   (workspace/output) REAL array,
*                                         dimension (LRWORK)
*          On exit, if INFO = 0, RWORK(1) returns the optimal LRWORK.
*
*  LRWORK  (input) INTEGER
*          The dimension of array RWORK.
*          If N <= 1,               LRWORK must be at least 1.
*          If JOBZ = 'N' and N > 1, LRWORK must be at least N.
*          If JOBZ = 'V' and N > 1, LRWORK must be at least
*                    1 + 5*N + 2*N**2.
*
*          If LRWORK = -1, then a workspace query is assumed; the
*          routine only calculates the optimal size of the RWORK array,
*          returns this value as the first entry of the RWORK array, and
*          no error message related to LRWORK is issued by XERBLA.
*
*  IWORK   (workspace/output) INTEGER array, dimension (LIWORK)
*          On exit, if INFO = 0, IWORK(1) returns the optimal LIWORK.
*
*  LIWORK  (input) INTEGER
*          The dimension of array IWORK.
*          If JOBZ  = 'N' or N <= 1, LIWORK must be at least 1.
*          If JOBZ  = 'V' and N > 1, LIWORK must be at least 3 + 5*N.
*
*          If LIWORK = -1, then a workspace query is assumed; the
*          routine only calculates the optimal size of the IWORK array,
*          returns this value as the first entry of the IWORK array, and
*          no error message related to LIWORK is issued by XERBLA.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value.
*          > 0:  if INFO = i, the algorithm failed to converge; i
*                off-diagonal elements of an intermediate tridiagonal
*                form did not converge to zero.
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ZERO, ONE
      PARAMETER          ( ZERO = 0.0E+0, ONE = 1.0E+0 )
      COMPLEX            CONE
      PARAMETER          ( CONE = ( 1.0E+0, 0.0E+0 ) )
*     ..
*     .. Local Scalars ..
      LOGICAL            LQUERY, WANTZ
      INTEGER            IINFO, IMAX, INDE, INDRWK, INDTAU, INDWRK,
     $                   ISCALE, LIWMIN, LLRWK, LLWRK, LRWMIN, LWMIN
      REAL               ANRM, BIGNUM, EPS, RMAX, RMIN, SAFMIN, SIGMA,
     $                   SMLNUM
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      REAL               CLANHP, SLAMCH
      EXTERNAL           LSAME, CLANHP, SLAMCH
*     ..
*     .. External Subroutines ..
      EXTERNAL           CHPTRD, CSSCAL, CSTEDC, CUPMTR, SSCAL, SSTERF,
     $                   XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          SQRT
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      WANTZ = LSAME( JOBZ, 'V' )
      LQUERY = ( LWORK.EQ.-1 .OR. LRWORK.EQ.-1 .OR. LIWORK.EQ.-1 )
*
      INFO = 0
      IF( N.LE.1 ) THEN
         LWMIN = 1
         LIWMIN = 1
         LRWMIN = 1
      ELSE
         IF( WANTZ ) THEN
            LWMIN = 2*N
            LRWMIN = 1 + 5*N + 2*N**2
            LIWMIN = 3 + 5*N
         ELSE
            LWMIN = N
            LRWMIN = N
            LIWMIN = 1
         END IF
      END IF
      IF( .NOT.( WANTZ .OR. LSAME( JOBZ, 'N' ) ) ) THEN
         INFO = -1
      ELSE IF( .NOT.( LSAME( UPLO, 'L' ) .OR. LSAME( UPLO, 'U' ) ) )
     $          THEN
         INFO = -2
      ELSE IF( N.LT.0 ) THEN
         INFO = -3
      ELSE IF( LDZ.LT.1 .OR. ( WANTZ .AND. LDZ.LT.N ) ) THEN
         INFO = -7
      ELSE IF( LWORK.LT.LWMIN .AND. .NOT.LQUERY ) THEN
         INFO = -9
      ELSE IF( LRWORK.LT.LRWMIN .AND. .NOT.LQUERY ) THEN
         INFO = -11
      ELSE IF( LIWORK.LT.LIWMIN .AND. .NOT.LQUERY ) THEN
         INFO = -13
      END IF
*
      IF( INFO.EQ.0 ) THEN
         WORK( 1 ) = LWMIN
         RWORK( 1 ) = LRWMIN
         IWORK( 1 ) = LIWMIN
      END IF
*
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'CHPEVD', -INFO )
         RETURN 
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
*
      IF( N.EQ.1 ) THEN
         W( 1 ) = AP( 1 )
         IF( WANTZ )
     $      Z( 1, 1 ) = CONE
         RETURN 
      END IF
*
*     Get machine constants.
*
      SAFMIN = SLAMCH( 'Safe minimum' )
      EPS = SLAMCH( 'Precision' )
      SMLNUM = SAFMIN / EPS
      BIGNUM = ONE / SMLNUM
      RMIN = SQRT( SMLNUM )
      RMAX = SQRT( BIGNUM )
*
*     Scale matrix to allowable range, if necessary.
*
      ANRM = CLANHP( 'M', UPLO, N, AP, RWORK )
      ISCALE = 0
      IF( ANRM.GT.ZERO .AND. ANRM.LT.RMIN ) THEN
         ISCALE = 1
         SIGMA = RMIN / ANRM
      ELSE IF( ANRM.GT.RMAX ) THEN
         ISCALE = 1
         SIGMA = RMAX / ANRM
      END IF
      IF( ISCALE.EQ.1 ) THEN
         CALL CSSCAL( ( N*( N+1 ) ) / 2, SIGMA, AP, 1 )
      END IF
*
*     Call CHPTRD to reduce Hermitian packed matrix to tridiagonal form.
*
      INDE = 1
      INDTAU = 1
      INDRWK = INDE + N
      INDWRK = INDTAU + N
      LLWRK = LWORK - INDWRK + 1
      LLRWK = LRWORK - INDRWK + 1
      CALL CHPTRD( UPLO, N, AP, W, RWORK( INDE ), WORK( INDTAU ),
     $             IINFO )
*
*     For eigenvalues only, call SSTERF.  For eigenvectors, first call
*     CUPGTR to generate the orthogonal matrix, then call CSTEDC.
*
      IF( .NOT.WANTZ ) THEN
         CALL SSTERF( N, W, RWORK( INDE ), INFO )
      ELSE
         CALL CSTEDC( 'I', N, W, RWORK( INDE ), Z, LDZ, WORK( INDWRK ),
     $                LLWRK, RWORK( INDRWK ), LLRWK, IWORK, LIWORK,
     $                INFO )
         CALL CUPMTR( 'L', UPLO, 'N', N, N, AP, WORK( INDTAU ), Z, LDZ,
     $                WORK( INDWRK ), IINFO )
      END IF
*
*     If matrix was scaled, then rescale eigenvalues appropriately.
*
      IF( ISCALE.EQ.1 ) THEN
         IF( INFO.EQ.0 ) THEN
            IMAX = N
         ELSE
            IMAX = INFO - 1
         END IF
         CALL SSCAL( IMAX, ONE / SIGMA, W, 1 )
      END IF
*
      WORK( 1 ) = LWMIN
      RWORK( 1 ) = LRWMIN
      IWORK( 1 ) = LIWMIN
      RETURN
*
*     End of CHPEVD
*
      END

C
C	$Id: cstrfind.f,v 1.8 2008-07-27 03:10:08 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CSTRFIND (NST,P,N,X,Y,Z,LIST,LPTR,LEND, B1,
     .                   B2,B3,I1,I2,I3)
      INTEGER NST, N, LIST(*), LPTR(*), LEND(N), I1, I2, I3
      DOUBLE PRECISION P(3), X(N), Y(N), Z(N), B1, B2, B3
C
C***********************************************************
C
C                                              From STRIPACK
C                                            Robert J. Renka
C                                  Dept. of Computer Science
C                                       Univ. of North Texas
C                                           renka@cs.unt.edu
C                                                   11/30/99
C
C   This subroutine locates a point P relative to a triangu-
C lation created by Subroutine CSTRMESH.  If P is contained in
C a triangle, the three vertex indexes and barycentric coor-
C dinates are returned.  Otherwise, the indexes of the
C visible boundary nodes are returned.
C
C
C On input:
C
C       NST = Index of a node at which CSTRFIND begins its
C             search.  Search time depends on the proximity
C             of this node to P.
C
C       P = Array of length 3 containing the x, y, and z
C           coordinates (in that order) of the point P to be
C           located.
C
C       N = Number of nodes in the triangulation.  N .GE. 3.
C
C       X,Y,Z = Arrays of length N containing the Cartesian
C               coordinates of the triangulation nodes (unit
C               vectors).  (X(I),Y(I),Z(I)) defines node I
C               for I = 1 to N.
C
C       LIST,LPTR,LEND = Data structure defining the trian-
C                        gulation.  Refer to Subroutine
C                        CSTRMESH.
C
C Input parameters are not altered by this routine.
C
C On output:
C
C       B1,B2,B3 = Unnormalized barycentric coordinates of
C                  the central projection of P onto the un-
C                  derlying planar triangle if P is in the
C                  convex hull of the nodes.  These parame-
C                  ters are not altered if I1 = 0.
C
C       I1,I2,I3 = Counterclockwise-ordered vertex indexes
C                  of a triangle containing P if P is con-
C                  tained in a triangle.  If P is not in the
C                  convex hull of the nodes, I1 and I2 are
C                  the rightmost and leftmost (boundary)
C                  nodes that are visible from P, and
C                  I3 = 0.  (If all boundary nodes are vis-
C                  ible from P, then I1 and I2 coincide.)
C                  I1 = I2 = I3 = 0 if P and all of the
C                  nodes are coplanar (lie on a common great
C                  circle.
C
C Modules required by CSTRFIND:  CSJRAND, CSLSTPTR, CSSTORE
C
C Intrinsic function called by CSTRFIND:  ABS
C
C***********************************************************
C
      INTEGER CSJRAND, CSLSTPTR
      INTEGER IX, IY, IZ, LP, N0, N1, N1S, N2, N2S, N3, N4,
     .        NEXT, NF, NL
      DOUBLE PRECISION CSSTORE
      DOUBLE PRECISION DET, EPS, PTN1, PTN2, Q(3), S12, TOL,
     .                 XP, YP, ZP
      DOUBLE PRECISION X0, X1, X2, Y0, Y1, Y2, Z0, Z1, Z2
C
      SAVE    IX, IY, IZ
      DATA    IX/1/, IY/2/, IZ/3/
C
C Local parameters:
C
C EPS =      Machine precision
C IX,IY,IZ = Integer seeds for CSJRAND
C LP =       LIST pointer
C N0,N1,N2 = Nodes in counterclockwise order defining a
C              cone (with vertex N0) containing P, or end-
C              points of a boundary edge such that P Right
C              N1->N2
C N1S,N2S =  Initially-determined values of N1 and N2
C N3,N4 =    Nodes opposite N1->N2 and N2->N1, respectively
C NEXT =     Candidate for I1 or I2 when P is exterior
C NF,NL =    First and last neighbors of N0, or first
C              (rightmost) and last (leftmost) nodes
C              visible from P when P is exterior to the
C              triangulation
C PTN1 =     Scalar product <P,N1>
C PTN2 =     Scalar product <P,N2>
C Q =        (N2 X N1) X N2  or  N1 X (N2 X N1) -- used in
C              the boundary traversal when P is exterior
C S12 =      Scalar product <N1,N2>
C TOL =      Tolerance (multiple of EPS) defining an upper
C              bound on the magnitude of a negative bary-
C              centric coordinate (B1 or B2) for P in a
C              triangle -- used to avoid an infinite number
C              of restarts with 0 <= B3 < EPS and B1 < 0 or
C              B2 < 0 but small in magnitude
C XP,YP,ZP = Local variables containing P(1), P(2), and P(3)
C X0,Y0,Z0 = Dummy arguments for DET
C X1,Y1,Z1 = Dummy arguments for DET
C X2,Y2,Z2 = Dummy arguments for DET
C
C Statement function:
C
C DET(X1,...,Z0) .GE. 0 if and only if (X0,Y0,Z0) is in the
C                       (closed) left hemisphere defined by
C                       the plane containing (0,0,0),
C                       (X1,Y1,Z1), and (X2,Y2,Z2), where
C                       left is defined relative to an ob-
C                       server at (X1,Y1,Z1) facing
C                       (X2,Y2,Z2).
C
      DET (X1,Y1,Z1,X2,Y2,Z2,X0,Y0,Z0) = X0*(Y1*Z2-Y2*Z1)
     .     - Y0*(X1*Z2-X2*Z1) + Z0*(X1*Y2-X2*Y1)
C
C Initialize variables.
C
      XP = P(1)
      YP = P(2)
      ZP = P(3)
      N0 = NST
      IF (N0 .LT. 1  .OR.  N0 .GT. N)
     .  N0 = CSJRAND(N, IX,IY,IZ )
C
C Compute the relative machine precision EPS and TOL.
C
      EPS = 1.D0
    1 EPS = EPS/2.D0
        IF (CSSTORE(EPS+1.D0) .GT. 1.D0) GO TO 1
      EPS = 2.D0*EPS
      TOL = 4.D0*EPS
C
C Set NF and NL to the first and last neighbors of N0, and
C   initialize N1 = NF.
C
    2 LP = LEND(N0)
      NL = LIST(LP)
      LP = LPTR(LP)
      NF = LIST(LP)
      N1 = NF
C
C Find a pair of adjacent neighbors N1,N2 of N0 that define
C   a wedge containing P:  P CSLEFT N0->N1 and P RIGHT N0->N2.
C
      IF (NL .GT. 0) THEN
C
C   N0 is an interior node.  Find N1.
C
    3   IF ( DET(X(N0),Y(N0),Z(N0),X(N1),Y(N1),Z(N1),
     .           XP,YP,ZP) .LT. 0.D0 ) THEN
          LP = LPTR(LP)
          N1 = LIST(LP)
          IF (N1 .EQ. NL) GO TO 6
          GO TO 3
        ENDIF
      ELSE
C
C   N0 is a boundary node.  Test for P exterior.
C
        NL = -NL
        IF ( DET(X(N0),Y(N0),Z(N0),X(NF),Y(NF),Z(NF),
     .           XP,YP,ZP) .LT. 0.D0 ) THEN
C
C   P is to the right of the boundary edge N0->NF.
C
          N1 = N0
          N2 = NF
          GO TO 9
        ENDIF
        IF ( DET(X(NL),Y(NL),Z(NL),X(N0),Y(N0),Z(N0),
     .           XP,YP,ZP) .LT. 0.D0 ) THEN
C
C   P is to the right of the boundary edge NL->N0.
C
          N1 = NL
          N2 = N0
          GO TO 9
        ENDIF
      ENDIF
C
C P is to the left of arcs N0->N1 and NL->N0.  Set N2 to the
C   next neighbor of N0 (following N1).
C
    4 LP = LPTR(LP)
        N2 = ABS(LIST(LP))
        IF ( DET(X(N0),Y(N0),Z(N0),X(N2),Y(N2),Z(N2),
     .           XP,YP,ZP) .LT. 0.D0 ) GO TO 7
        N1 = N2
        IF (N1 .NE. NL) GO TO 4
      IF ( DET(X(N0),Y(N0),Z(N0),X(NF),Y(NF),Z(NF),
     .         XP,YP,ZP) .LT. 0.D0 ) GO TO 6
C
C P is left of or on arcs N0->NB for all neighbors NB
C   of N0.  Test for P = +/-N0.
C
      IF (CSSTORE(ABS(X(N0)*XP + Y(N0)*YP + Z(N0)*ZP))
     .   .LT. 1.D0-4.D0*EPS) THEN
C
C   All points are collinear iff P Left NB->N0 for all
C     neighbors NB of N0.  Search the neighbors of N0.
C     Note:  N1 = NL and LP points to NL.
C
    5   IF ( DET(X(N1),Y(N1),Z(N1),X(N0),Y(N0),Z(N0),
     .           XP,YP,ZP) .GE. 0.D0 ) THEN
          LP = LPTR(LP)
          N1 = ABS(LIST(LP))
          IF (N1 .EQ. NL) GO TO 14
          GO TO 5
        ENDIF
      ENDIF
C
C P is to the right of N1->N0, or P = +/-N0.  Set N0 to N1
C   and start over.
C
      N0 = N1
      GO TO 2
C
C P is between arcs N0->N1 and N0->NF.
C
    6 N2 = NF
C
C P is contained in a wedge defined by geodesics N0-N1 and
C   N0-N2, where N1 is adjacent to N2.  Save N1 and N2 to
C   test for cycling.
C
    7 N3 = N0
      N1S = N1
      N2S = N2
C
C Top of edge-hopping loop:
C
    8 B3 = DET(X(N1),Y(N1),Z(N1),X(N2),Y(N2),Z(N2),XP,YP,ZP)
      IF (B3 .LT. 0.D0) THEN
C
C   Set N4 to the first neighbor of N2 following N1 (the
C     node opposite N2->N1) unless N1->N2 is a boundary arc.
C
        LP = CSLSTPTR(LEND(N2),N1,LIST,LPTR)
        IF (LIST(LP) .LT. 0) GO TO 9
        LP = LPTR(LP)
        N4 = ABS(LIST(LP))
C
C   Define a new arc N1->N2 which intersects the geodesic
C     N0-P.
C
        IF ( DET(X(N0),Y(N0),Z(N0),X(N4),Y(N4),Z(N4),
     .           XP,YP,ZP) .LT. 0.D0 ) THEN
          N3 = N2
          N2 = N4
          N1S = N1
          IF (N2 .NE. N2S  .AND.  N2 .NE. N0) GO TO 8
        ELSE
          N3 = N1
          N1 = N4
          N2S = N2
          IF (N1 .NE. N1S  .AND.  N1 .NE. N0) GO TO 8
        ENDIF
C
C   The starting node N0 or edge N1-N2 was encountered
C     again, implying a cycle (infinite loop).  Restart
C     with N0 randomly selected.
C
        N0 = CSJRAND(N, IX,IY,IZ )
        GO TO 2
      ENDIF
C
C P is in (N1,N2,N3) unless N0, N1, N2, and P are collinear
C   or P is close to -N0.
C
      IF (B3 .GE. EPS) THEN
C
C   B3 .NE. 0.
C
        B1 = DET(X(N2),Y(N2),Z(N2),X(N3),Y(N3),Z(N3),
     .           XP,YP,ZP)
        B2 = DET(X(N3),Y(N3),Z(N3),X(N1),Y(N1),Z(N1),
     .           XP,YP,ZP)
        IF (B1 .LT. -TOL  .OR.  B2 .LT. -TOL) THEN
C
C   Restart with N0 randomly selected.
C
          N0 = CSJRAND(N, IX,IY,IZ )
          GO TO 2
        ENDIF
      ELSE
C
C   B3 = 0 and thus P lies on N1->N2. Compute
C     B1 = Det(P,N2 X N1,N2) and B2 = Det(P,N1,N2 X N1).
C
        B3 = 0.D0
        S12 = X(N1)*X(N2) + Y(N1)*Y(N2) + Z(N1)*Z(N2)
        PTN1 = XP*X(N1) + YP*Y(N1) + ZP*Z(N1)
        PTN2 = XP*X(N2) + YP*Y(N2) + ZP*Z(N2)
        B1 = PTN1 - S12*PTN2
        B2 = PTN2 - S12*PTN1
        IF (B1 .LT. -TOL  .OR.  B2 .LT. -TOL) THEN
C
C   Restart with N0 randomly selected.
C
          N0 = CSJRAND(N, IX,IY,IZ )
          GO TO 2
        ENDIF
      ENDIF
C
C P is in (N1,N2,N3).
C
      I1 = N1
      I2 = N2
      I3 = N3
      IF (B1 .LT. 0.0) B1 = 0.0
      IF (B2 .LT. 0.0) B2 = 0.0
      RETURN
C
C P Right N1->N2, where N1->N2 is a boundary edge.
C   Save N1 and N2, and set NL = 0 to indicate that
C   NL has not yet been found.
C
    9 N1S = N1
      N2S = N2
      NL = 0
C
C           Counterclockwise Boundary Traversal:
C
   10 LP = LEND(N2)
      LP = LPTR(LP)
      NEXT = LIST(LP)
      IF ( DET(X(N2),Y(N2),Z(N2),X(NEXT),Y(NEXT),Z(NEXT),
     .         XP,YP,ZP) .GE. 0.D0 ) THEN
C
C   N2 is the rightmost visible node if P Forward N2->N1
C     or NEXT Forward N2->N1.  Set Q to (N2 X N1) X N2.
C
        S12 = X(N1)*X(N2) + Y(N1)*Y(N2) + Z(N1)*Z(N2)
        Q(1) = X(N1) - S12*X(N2)
        Q(2) = Y(N1) - S12*Y(N2)
        Q(3) = Z(N1) - S12*Z(N2)
        IF (XP*Q(1) + YP*Q(2) + ZP*Q(3) .GE. 0.D0) GO TO 11
        IF (X(NEXT)*Q(1) + Y(NEXT)*Q(2) + Z(NEXT)*Q(3)
     .      .GE. 0.D0) GO TO 11
C
C   N1, N2, NEXT, and P are nearly collinear, and N2 is
C     the leftmost visible node.
C
        NL = N2
      ENDIF
C
C Bottom of counterclockwise loop:
C
      N1 = N2
      N2 = NEXT
      IF (N2 .NE. N1S) GO TO 10
C
C All boundary nodes are visible from P.
C
      I1 = N1S
      I2 = N1S
      I3 = 0
      RETURN
C
C N2 is the rightmost visible node.
C
   11 NF = N2
      IF (NL .EQ. 0) THEN
C
C Restore initial values of N1 and N2, and begin the search
C   for the leftmost visible node.
C
        N2 = N2S
        N1 = N1S
C
C           Clockwise Boundary Traversal:
C
   12   LP = LEND(N1)
        NEXT = -LIST(LP)
        IF ( DET(X(NEXT),Y(NEXT),Z(NEXT),X(N1),Y(N1),Z(N1),
     .           XP,YP,ZP) .GE. 0.D0 ) THEN
C
C   N1 is the leftmost visible node if P or NEXT is
C     forward of N1->N2.  Compute Q = N1 X (N2 X N1).
C
          S12 = X(N1)*X(N2) + Y(N1)*Y(N2) + Z(N1)*Z(N2)
          Q(1) = X(N2) - S12*X(N1)
          Q(2) = Y(N2) - S12*Y(N1)
          Q(3) = Z(N2) - S12*Z(N1)
          IF (XP*Q(1) + YP*Q(2) + ZP*Q(3) .GE. 0.D0)
     .      GO TO 13
          IF (X(NEXT)*Q(1) + Y(NEXT)*Q(2) + Z(NEXT)*Q(3)
     .        .GE. 0.D0) GO TO 13
C
C   P, NEXT, N1, and N2 are nearly collinear and N1 is the
C     rightmost visible node.
C
          NF = N1
        ENDIF
C
C Bottom of clockwise loop:
C
        N2 = N1
        N1 = NEXT
        IF (N1 .NE. N1S) GO TO 12
C
C All boundary nodes are visible from P.
C
        I1 = N1
        I2 = N1
        I3 = 0
        RETURN
C
C N1 is the leftmost visible node.
C
   13   NL = N1
      ENDIF
C
C NF and NL have been found.
C
      I1 = NF
      I2 = NL
      I3 = 0
      RETURN
C
C All points are collinear (coplanar).
C
   14 I1 = 0
      I2 = 0
      I3 = 0
      RETURN
      END

C     
C     $Id: mp06f.f,v 1.4 2010-03-15 22:49:24 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C                Copyright (C)  1999                                   C
C        University Corporation for Atmospheric Research               C
C                All Rights Reserved                                   C
C                                                                      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C
C      File:            mp06f.f
C
C      Author:          Mary Haley
C                       National Center for Atmospheric Research
C                       PO 3000, Boulder, Colorado
C
C      Date:            Mon Dec 13 16:19:54 MST 1999
C
C   Description:  Shows how to draw county lines in the US.
C
      external NhlFAppClass
      external NhlFCairoWindowWorkstationClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFMapPlotClass

      integer appid,wid,mapid
      integer rlist
      character*7  wks_type
C
C List of Florida counties.
C
      character*50 fl_counties(69)
      data fl_counties/'Florida . Alachua','Florida . Baker',
     +'Florida . Bay','Florida . Bradford','Florida . Brevard',
     +'Florida . Broward','Florida . Calhoun','Florida . Charlotte',
     +'Florida . Citrus','Florida . Clay','Florida . Collier',
     +'Florida . Columbia','Florida . De Soto','Florida . Dixie',
     +'Florida . Duval','Florida . Escambia','Florida . Flagler',
     +'Florida . Franklin','Florida . Gadsden','Florida . Gilchrist',
     +'Florida . Glades','Florida . Gulf','Florida . Hamilton',
     +'Florida . Hardee','Florida . Hendry','Florida . Hernando',
     +'Florida . Highlands','Florida . Hillsborough',
     +'Florida . Holmes','Florida . Indian River',
     +'Florida . Jackson','Florida . Jefferson','Florida . Keys',
     +'Florida . Lafayette','Florida . Lake',
     +'Florida . Lee','Florida . Leon','Florida . Levy',
     +'Florida . Liberty','Florida . Madison','Florida . Manatee',
     +'Florida . Marion','Florida . Martin','Florida . Miami-Dade',
     +'Florida . Monroe','Florida . Nassau','Florida . Okaloosa',
     +'Florida . Okeechobee','Florida . Orange','Florida . Osceola',
     +'Florida . Palm Beach','Florida . Pasco','Florida . Pinellas',
     +'Florida . Polk','Florida . Putnam','Florida . Saint Johns',
     +'Florida . Saint Lucie','Florida . Saint Vincent Island',
     +'Florida . Santa Rosa','Florida . Sarasota',
     +'Florida . Seminole','Florida . Sumter','Florida . Suwannee',
     +'Florida . Taylor','Florida . Union','Florida . Volusia',
     +'Florida . Wakulla','Florida . Walton','Florida . Washington'/

C
C Default is to display output to an X workstation
C
      wks_type = "x11"
C
C Initialize the high level utility library
C
      call NhlFInitialize
C
C Create an application object.
C
      call NhlFRLCreate(rlist,'SETRL')
      call NhlFRLClear(rlist)
      call NhlFRLSetstring(rlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'mp06',NhlFAppClass,0,rlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkMetaName','./mp06f.ncgm',ierr)
         call NhlFCreate(wid,'mp06Work',NhlFNcgmWorkstationClass,0,
     1        rlist,ierr)
      else  if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X workstation
C
         call NhlFRLClear(rlist)
         call NhlFRLSetinteger(rlist,'wkPause',1,ierr)
         call NhlFCreate(wid,'mp06Work',
     1     NhlFCairoWindowWorkstationClass,0,
     1     rlist,ierr)
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PostScript workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPSFileName','./mp06f.ps',ierr)
         call NhlFCreate(wid,'mp06Work',NhlFPSWorkstationClass,0,
     1        rlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPDFFileName','./mp06f.pdf',ierr)
         call NhlFCreate(wid,'mp06Work',NhlFPDFWorkstationClass,0,
     1        rlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF object.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetstring(rlist,'wkFileName','./mp06f',ierr)
         call NhlFCreate(wid,'mp06Work',
     1        NhlFCairoPSPDFWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG object.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetstring(rlist,'wkFileName','./mp06f',ierr)
         call NhlFCreate(wid,'mp06Work',
     1        NhlFCairoImageWorkstationClass,0,rlist,ierr)
      endif

C
C Create and draw a map with all mainland US counties outlined.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetFloat(rlist,'vpWidthF',  0.90,ierr)
      call NhlFRLSetFloat(rlist,'vpHeightF', 0.90,ierr)
      call NhlFRLSetFloat(rlist,'vpXF',      0.05,ierr)
      call NhlFRLSetFloat(rlist,'vpYF',      0.95,ierr)

      call NhlFRLSetString(rlist,'mpOutlineBoundarySets', 
     +     'AllBoundaries',ierr)

      call NhlFRLSetFloat(rlist,'mpMinLatF',   25.,ierr)
      call NhlFRLSetFloat(rlist,'mpMaxLatF',   50.,ierr)
      call NhlFRLSetFloat(rlist,'mpMinLonF', -130.,ierr)
      call NhlFRLSetFloat(rlist,'mpMaxLonF',  -60. ,ierr)

      call NhlFRLSetString(rlist,'tiMainString',
     +     ':F22:US with all counties outlined',ierr)

      call NhlFCreate(mapid,'mp06',NhlFMapPlotClass,wid,rlist,ierr)

      call NhlFDraw(mapid,ierr)
      call NhlFFrame(wid,ierr)
C
C Draw all counties in the United States that have the name
C "Adams".
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'mpOutlineBoundarySets',
     +     'GeophysicalAndUSStates',ierr)
      call NhlFRLSetString(rlist,'mpOutlineSpecifiers','Adams',ierr)
      call NhlFRLSetString(rlist,'tiMainString',
     +     ':F22:US with Adams counties outlined',ierr)

      call NhlFSetValues(mapid,rlist,ierr)

      call NhlFDraw(mapid,ierr)
      call NhlFFrame(wid,ierr)
C
C By putting the string "Florida . " in front of each county name, only
C those counties in Florida will get drawn. Otherwise, if any of these
C counties existed in other states, those counties would get drawn as
C well.
C
      call NhlFRLClear(rlist)

      call NhlFRLSetStringArray(rlist,'mpOutlineSpecifiers',
     +     fl_counties,69,ierr)
      call NhlFRLSetFloat(rlist,'vpWidthF',   0.90,ierr)
      call NhlFRLSetFloat(rlist,'vpHeightF',  0.90,ierr)
      call NhlFRLSetFloat(rlist,'vpXF',       0.05,ierr)
      call NhlFRLSetFloat(rlist,'vpYF',       0.95,ierr)
      call NhlFRLSetFloat(rlist,'mpMinLatF',    25.,ierr)
      call NhlFRLSetFloat(rlist,'mpMaxLatF',    32.,ierr)
      call NhlFRLSetFloat(rlist,'mpMinLonF',   -90.,ierr)
      call NhlFRLSetFloat(rlist,'mpMaxLonF',   -80. ,ierr)
      call NhlFRLSetString(rlist,'tiMainString',
     +     ':F22:Florida and its counties outlined',ierr)

      call NhlFSetValues(mapid,rlist,ierr)

      call NhlFDraw(mapid,ierr)
      call NhlFFrame(wid,ierr)
C
C Destroy the objects created, close the HLU library and exit.
C
      call NhlFDestroy(wid,ierr)
      call NhlFClose
      stop
      end

C NCLFORTSTART
      subroutine dpsortdriver(dx, ndim, iperm, kflag, ier)
C NCL: iperm = dim_pqsort (dx, kflag)
C      iperm same size as dx

      implicit none
c input
      integer  ndim, kflag, ier
      double   precision dx(ndim)
c output
      integer  iperm(ndim)
C NCLEND

c local
      integer  n

      call dpsort(dx, ndim, iperm, kflag, ier)

      if (ier.eq.0) then
c generate zero based indices for return to ncl
          do n=1,ndim
             iperm(n) = iperm(n)-1
          end do
      end if

      return
      end
c ----------------------------------------------------------
      SUBROUTINE DPSORT(DX, N, IPERM, KFLAG, IER)


C***BEGIN PROLOGUE  DPSORT
C***PURPOSE  Return the permutation vector generated by sorting a given
C            array and, optionally, rearrange the elements of the array.
C            The array may be sorted in increasing or decreasing order.
C            A slightly modified quicksort algorithm is used.
C***LIBRARY   SLATEC
C***CATEGORY  N6A1B, N6A2B
C***TYPE      DOUBLE PRECISION (SPSORT-S, DPSORT-D, IPSORT-I, HPSORT-H)
C***KEYWORDS  NUMBER SORTING, PASSIVE SORTING, SINGLETON QUICKSORT, SORT
C***AUTHOR  Jones, R. E., (SNLA)
C           Rhoads, G. S., (NBS)
C           Wisniewski, J. A., (SNLA)
C***DESCRIPTION
C
C   DPSORT returns the permutation vector IPERM generated by sorting
C   the array DX and, optionally, rearranges the values in DX.  DX may
C   be sorted in increasing or decreasing order.  A slightly modified
C   quicksort algorithm is used.
C
C   IPERM is such that DX(IPERM(I)) is the Ith value in the
C   rearrangement of DX.  IPERM may be applied to another array by
C   calling IPPERM, SPPERM, DPPERM or HPPERM.
C
C   The main difference between DPSORT and its active sorting equivalent
C   DSORT is that the data are referenced indirectly rather than
C   directly.  Therefore, DPSORT should require approximately twice as
C   long to execute as DSORT.  However, DPSORT is more general.
C
C   Description of Parameters
C      DX - input/output -- double precision array of values to be
C           sorted.  If ABS(KFLAG) = 2, then the values in DX will be
C           rearranged on output; otherwise, they are unchanged.
C      N  - input -- number of values in array DX to be sorted.
C      IPERM - output -- permutation array such that IPERM(I) is the
C              index of the value in the original order of the
C              DX array that is in the Ith location in the sorted
C              order.
C      KFLAG - input -- control parameter:
C            =  2  means return the permutation vector resulting from
C                  sorting DX in increasing order and sort DX also.
C            =  1  means return the permutation vector resulting from
C                  sorting DX in increasing order and do not sort DX.
C            = -1  means return the permutation vector resulting from
C                  sorting DX in decreasing order and do not sort DX.
C            = -2  means return the permutation vector resulting from
C                  sorting DX in decreasing order and sort DX also.
C      IER - output -- error indicator:
C          =  0  if no error,
C          =  1  if N is zero or negative,
C          =  2  if KFLAG is not 2, 1, -1, or -2.
C***REFERENCES  R. C. Singleton, Algorithm 347, An efficient algorithm
C                 for sorting with minimal storage, Communications of
C                 the ACM, 12, 3 (1969), pp. 185-187.
C***REVISION HISTORY  (YYMMDD)
C   761101  DATE WRITTEN
C   761118  Modified by John A. Wisniewski to use the Singleton
C           quicksort algorithm.
C   870423  Modified by Gregory S. Rhoads for passive sorting with the
C           option for the rearrangement of the original data.
C   890619  Double precision version of SPSORT created by D. W. Lozier.
C   890620  Algorithm for rearranging the data vector corrected by R.
C           Boisvert.
C   890622  Prologue upgraded to Version 4.0 style by D. Lozier.
C   891128  Error when KFLAG.LT.0 and N=1 corrected by R. Boisvert.
C   920507  Modified by M. McClain to revise prologue text.
C   920818  Declarations section rebuilt and code restructured to use
C           IF-THEN-ELSE-ENDIF.  (SMR, WRB)
C***END PROLOGUE  DPSORT
C     .. Scalar Arguments ..
      INTEGER    IER, KFLAG, N
C     .. Array Arguments ..
      DOUBLE PRECISION    DX(*)
      INTEGER    IPERM(*)

C     .. Local Scalars ..
      DOUBLE PRECISION    R, TEMP
      INTEGER    I, IJ, INDX, INDX0, ISTRT, J, K, KK, L, LM, LMT, M, NN
C     .. Local Arrays ..
      INTEGER    IL(21), IU(21)
C     .. External Subroutines ..
C DJS EXTERNAL    XERMSG
C     .. Intrinsic Functions ..
      INTRINSIC    ABS, INT
C***FIRST EXECUTABLE STATEMENT  DPSORT
      IER = 0
      NN = N
      IF (NN .LT. 1) THEN
         IER = 1
C DJS    CALL XERMSG ('SLATEC', 'DPSORT', 
C DJS1      'The number of values to be sorted, N, is not positive.', 
C DJS2      IER, 1)
         
         RETURN 
      ENDIF
C
      KK = ABS(KFLAG)
      IF (KK.NE.1 .AND. KK.NE.2) THEN
         IER = 2
C DJS    CALL XERMSG ('SLATEC', 'DPSORT', 
C DJS1      'The sort control parameter, KFLAG, is not 2, 1, -1, or -2.'
C DJS2      , IER, 1)
         RETURN 
      ENDIF
C
C     Initialize permutation vector
C
      DO I = 1, NN
         IPERM(I) = I
      END DO
C
C     Return if only one value is to be sorted
C
      IF (NN .EQ. 1) RETURN 
C
C     Alter array DX to get decreasing order if needed
C
      IF (KFLAG .LE. (-1)) THEN
         DO I = 1, NN
            DX(I) = -DX(I)
         END DO
      ENDIF
C
C     Sort DX only
C
      M = 1
      I = 1
      J = NN
      R = .375D0
C
   30 CONTINUE
      IF (I .EQ. J) GO TO 80
      IF (R .LE. 0.5898437D0) THEN
         R = R + 3.90625D-2
      ELSE
         R = R - 0.21875D0
      ENDIF
C
   40 CONTINUE
      K = I
C
C     Select a central element of the array and save it in location L
C
      IJ = I + INT((J - I)*R)
      LM = IPERM(IJ)
C
C     If first element of array is greater than LM, interchange with LM
C
      IF (DX(IPERM(I)) .GT. DX(LM)) THEN
         IPERM(IJ) = IPERM(I)
         IPERM(I) = LM
         LM = IPERM(IJ)
      ENDIF
      L = J
C
C     If last element of array is less than LM, interchange with LM
C
      IF (DX(IPERM(J)) .LT. DX(LM)) THEN
         IPERM(IJ) = IPERM(J)
         IPERM(J) = LM
         LM = IPERM(IJ)
C
C        If first element of array is greater than LM, interchange
C        with LM
C
         IF (DX(IPERM(I)) .GT. DX(LM)) THEN
            IPERM(IJ) = IPERM(I)
            IPERM(I) = LM
            LM = IPERM(IJ)
         ENDIF
      ENDIF
      GO TO 60
   50 CONTINUE
      LMT = IPERM(L)
      IPERM(L) = IPERM(K)
      IPERM(K) = LMT
C
C     Find an element in the second half of the array which is smaller
C     than LM
C
   60 CONTINUE
      L = L - 1
      IF (DX(IPERM(L)) .GT. DX(LM)) GO TO 60
C
C     Find an element in the first half of the array which is greater
C     than LM
C
   70 CONTINUE
      K = K + 1
      IF (DX(IPERM(K)) .LT. DX(LM)) GO TO 70
C
C     Interchange these elements
C
      IF (K .LE. L) GO TO 50
C
C     Save upper and lower subscripts of the array yet to be sorted
C
      IF (L - I .GT. J-K) THEN
         IL(M) = I
         IU(M) = L
         I = K
         M = M + 1
      ELSE
         IL(M) = K
         IU(M) = J
         J = L
         M = M + 1
      ENDIF
      GO TO 90
C
C     Begin again on another portion of the unsorted array
C
   80 CONTINUE
      M = M - 1
      IF (M .EQ. 0) GO TO 120
      I = IL(M)
      J = IU(M)
C
   90 CONTINUE
      IF (J - I .GE. 1) GO TO 40
      IF (I .EQ. 1) GO TO 30
      I = I - 1
C
  100 CONTINUE
      I = I + 1
      IF (I .EQ. J) GO TO 80
      LM = IPERM(I+1)
      IF (DX(IPERM(I)) .LE. DX(LM)) GO TO 100
      K = I
C
  110 CONTINUE
      IPERM(K+1) = IPERM(K)
      K = K - 1
      IF (DX(LM) .LT. DX(IPERM(K))) GO TO 110
      IPERM(K+1) = LM
      GO TO 100
C
C     Clean up
C
  120 CONTINUE
      IF (KFLAG .LE. (-1)) THEN
         DO I = 1, NN
            DX(I) = -DX(I)
         END DO
      ENDIF
C
C     Rearrange the values of DX if desired
C
      IF (KK .EQ. 2) THEN
C
C        Use the IPERM vector as a flag.
C        If IPERM(I) < 0, then the I-th value is in correct location
C
         DO ISTRT = 1, NN
            IF (IPERM(ISTRT) .GE. 0) THEN
               INDX = ISTRT
               INDX0 = INDX
               TEMP = DX(ISTRT)
  140          CONTINUE
               IF (IPERM(INDX) .GT. 0) THEN
                  DX(INDX) = DX(IPERM(INDX))
                  INDX0 = INDX
                  IPERM(INDX) = -IPERM(INDX)
                  INDX = ABS(IPERM(INDX))
                  GO TO 140
               ENDIF
               DX(INDX0) = TEMP
            ENDIF
         END DO
C
C        Revert the signs of the IPERM values
C
         DO I = 1, NN
            IPERM(I) = -IPERM(I)
         END DO
C
      ENDIF
C
      RETURN 
      END 

C
C	$Id: gceldc.f,v 1.5 2008-07-27 00:20:57 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GCELDC(OPRNS,OPNLEN,COUNT,IOS,STATUS)
C
C  This subroutine will extract the requested number of operands from
C  the segment and decode them according to the required format.
C  It will cross partition boundries without intervention from a 
C  higher level.
C
C  The LEN variable which higher level routines utilize for knowlage of
C  the size and remainder in the partition is modified.
C
C  INPUT
C    OPNLEN --  Length of each operand in bits.
C    COUNT  --  Number of operands to fetch.
C
C  OUTPUT
C    OPRNS  --  Array of operands in proper format.
C
      include 'trinst.h'
C
      INTEGER OPNLEN, COUNT, OPRNS(COUNT), IOS, STATUS
      INTEGER BYTSIZ, ZERO, BCOUNT, TCOUNT, SCOUNT, BYTLFT, TOMANY
C
C  Define the 8 bit byte size.
C
      DATA BYTSIZ/8/,ZERO/0/
C
      TOMANY = 100
      STATUS = 0
C
      BYTLFT = (OPNLEN*COUNT)/BYTSIZ
      BCOUNT = 1
      TCOUNT = COUNT
 10   CONTINUE
C
C  Determine the number of bytes left in the partition.
C
      IF (BYTLFT .GT. LEN) THEN
C
C  Not enough room left in the partition.
C
        SCOUNT = LEN/(OPNLEN/BYTSIZ)
        TCOUNT = TCOUNT - SCOUNT
        LEN = 0
      ELSE
C
C  Room for all the remaining operands.
C
        SCOUNT = TCOUNT
        TCOUNT = ZERO
        LEN = LEN -(SCOUNT*(OPNLEN/BYTSIZ))
      END IF
C
C  Get the operands.
C
      CALL GOPDEC(OPRNS(BCOUNT),OPNLEN,SCOUNT,IOS,STATUS)
      IF (STATUS .NE. 0) RETURN
C
C  Get the next instruction partition if necessary.
C
      IF (TCOUNT .NE. ZERO) THEN
        IF (CNTINU) THEN
          CALL GNPART(IOS,STATUS)
          IF (STATUS .NE. 0) RETURN
        ELSE
          STATUS = TOMANY
          RETURN
        END IF
C
        BCOUNT = BCOUNT + SCOUNT
        BYTLFT = (OPNLEN*TCOUNT)/BYTSIZ
        GO TO 10
      END IF
C
      RETURN
      END

C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CSA1S (NI,XI,YI,KNOTS,NO,XO,YO,NWRK,WORK,IER)
C
      DIMENSION XI(NI),YI(NI),XO(NO),YO(NO),WORK(NWRK)
C
C  Check on the number of knots.
C

      IF (KNOTS .LT. 4) THEN
        CALL CFAERR (202,' CSA1S - must have at least four knots',38)       
        IER = 202
        RETURN
      ENDIF
C
C  Check on the size of the workspace.
C
      IF (NWRK .LT. KNOTS*(KNOTS+3)) THEN
        CALL CFAERR (203,' CSA1S - workspace too small',28)
        IER = 203
        RETURN
      ENDIF
C
C  Call the expanded entry.
C
      WTS = -1.
      SSMTH = 0.
      NDERIV = 0
      CALL CSA1XS (NI,XI,YI,WTS,KNOTS,SSMTH,NDERIV,NO,XO,YO,
     +             NWRK,WORK,IER)
C
      RETURN
      END

C
C $Id: mdrgof.f,v 1.9 2008-09-18 00:42:18 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MDRGOF (IRGL,ICAT,ICEL,IRIM)
C
        INTEGER IRGL,ICAT,ICEL,IRIM
C
C This routine is called to open the files containing RANGS/GSHHS data
C at a specified resolution level IRGL.  The file descriptors come back
C in ICAT, ICEL, and IRIM.
C
C FLNM is a character variable in which to build the names of files to
C be opened by a call to NGOFRO.
C
        CHARACTER*1025 FLNM
C
C NCAT, NCEL, and NRIM hold the names of the catalog file, the cell
C file, and the rim data file to be read.
C
        CHARACTER*13  NCAT,NCEL,NRIM
C
C Declare other local variables.
C
        INTEGER       I,INAM,ISTA
C
C Get the name of the directory the RANGS/GSHHS files are in.
C
        CALL MDRGDI (FLNM)
        IF (ICFELL('MDRGOF',1).NE.0) RETURN
C
        DO 101 I=1,LEN(FLNM)-17
          IF (FLNM(I:I).EQ.' '.OR.FLNM(I:I).EQ.CHAR(0)) THEN
            INAM=I
            IF (I.NE.1) THEN
              IF (FLNM(I-1:I-1).NE.'/') THEN
                FLNM(I:I)='/'
                INAM=I+1
              END IF
            END IF
            GO TO 102
          END IF
  101   CONTINUE
C
        CALL SETER ('MDRGOF - MDRGDI RETURNED BAD DIRECTORY NAME',2,1)
C
C Define the names of the data files to be read.
C
  102   NCAT = 'rangs('//CHAR(ICHAR('0')+IRGL)//').cat'//CHAR(0)
        NCEL = 'rangs('//CHAR(ICHAR('0')+IRGL)//').cel'//CHAR(0)
        NRIM = 'gshhs('//CHAR(ICHAR('0')+IRGL)//').rim'//CHAR(0)
C
C Open all the data files.
C
        FLNM(INAM:INAM+12)=NCAT
        CALL NGOFRO (FLNM,ICAT,ISTA)
C
        IF (ISTA.NE.0) THEN
          CALL SETER ('MDRGOF - ERROR OPENING RANGS/GSHHS CAT FILE',3,1)
          RETURN
        END IF
C
        FLNM(INAM:INAM+12)=NCEL
        CALL NGOFRO (FLNM,ICEL,ISTA)
C
        IF (ISTA.NE.0) THEN
          CALL SETER ('MDRGOF - ERROR OPENING RANGS/GSHHS CEL FILE',4,1)
          CALL NGCLFI (ICAT)
          RETURN
        END IF
C
        FLNM(INAM:INAM+12)=NRIM
        CALL NGOFRO (FLNM,IRIM,ISTA)
C
        IF (ISTA.NE.0) THEN
          CALL SETER ('MDRGOF - ERROR OPENING RANGS/GSHHS RIM FILE',5,1)
          CALL NGCLFI (ICAT)
          CALL NGCLFI (ICEL)
          RETURN
        END IF
C
C Done.
C
        RETURN
C
      END

C
C $Id: gasetr.f,v 1.8 2008-07-27 00:17:14 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GASETR (PNAM,RVAL)
C
        CHARACTER*(*) PNAM
C
C The subroutine GASETR may be used to set GRIDAL parameters which have
C values of type REAL.
C
C Declare the common block containing real and integer parameters.
C
        COMMON /GAREIN/ ICAX,ICLB,ICMJ,ICMN,ILTY,IORX,NCFX,NCFY,RCWX,
     +                  RCWY,RDCX,RDCY,RMJX,RMJY,RMNX,RMNY,RWAX,RWLB,
     +                  RWMJ,RWMN
        SAVE   /GAREIN/
C
C Do a call forcing a BLOCKDATA to be loaded from a binary library.
C
        CALL GABLDT
C
C Check for an uncleared prior error.
C
        IF (ICFELL('GASETR - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C Set the selected parameter.
C
        IF      (PNAM(1:3).EQ.'CAX'.OR.PNAM(1:3).EQ.'cax') THEN
          ICAX=INT(RVAL)
        ELSE IF (PNAM(1:3).EQ.'CLB'.OR.PNAM(1:3).EQ.'clb') THEN
          ICLB=INT(RVAL)
        ELSE IF (PNAM(1:3).EQ.'CMJ'.OR.PNAM(1:3).EQ.'cmj') THEN
          ICMJ=INT(RVAL)
        ELSE IF (PNAM(1:3).EQ.'CMN'.OR.PNAM(1:3).EQ.'cmn') THEN
          ICMN=INT(RVAL)
        ELSE IF (PNAM(1:3).EQ.'LTY'.OR.PNAM(1:3).EQ.'lty') THEN
          ILTY=MAX(0,MIN(2,INT(RVAL)))
        ELSE IF (PNAM(1:3).EQ.'WAX'.OR.PNAM(1:3).EQ.'wax') THEN
          RWAX=RVAL
        ELSE IF (PNAM(1:3).EQ.'WLB'.OR.PNAM(1:3).EQ.'wlb') THEN
          RWLB=RVAL
        ELSE IF (PNAM(1:3).EQ.'WMJ'.OR.PNAM(1:3).EQ.'wmj') THEN
          RWMJ=RVAL
        ELSE IF (PNAM(1:3).EQ.'WMN'.OR.PNAM(1:3).EQ.'wmn') THEN
          RWMN=RVAL
        ELSE IF (PNAM(1:3).EQ.'XLL'.OR.PNAM(1:3).EQ.'xll') THEN
          NCFX=INT(RVAL)
        ELSE IF (PNAM(1:3).EQ.'XLO'.OR.PNAM(1:3).EQ.'xlo') THEN
          RDCY=RVAL
        ELSE IF (PNAM(1:3).EQ.'XLS'.OR.PNAM(1:3).EQ.'xls') THEN
          RCWX=RVAL
        ELSE IF (PNAM(1:3).EQ.'XMJ'.OR.PNAM(1:3).EQ.'xmj') THEN
          RMJX=RVAL
        ELSE IF (PNAM(1:3).EQ.'XMN'.OR.PNAM(1:3).EQ.'xmn') THEN
          RMNX=RVAL
        ELSE IF (PNAM(1:3).EQ.'XOR'.OR.PNAM(1:3).EQ.'xor') THEN
          IORX=INT(RVAL)
        ELSE IF (PNAM(1:3).EQ.'YLL'.OR.PNAM(1:3).EQ.'yll') THEN
          NCFY=INT(RVAL)
        ELSE IF (PNAM(1:3).EQ.'YLO'.OR.PNAM(1:3).EQ.'ylo') THEN
          RDCX=RVAL
        ELSE IF (PNAM(1:3).EQ.'YLS'.OR.PNAM(1:3).EQ.'yls') THEN
          RCWY=RVAL
        ELSE IF (PNAM(1:3).EQ.'YMJ'.OR.PNAM(1:3).EQ.'ymj') THEN
          RMJY=RVAL
        ELSE IF (PNAM(1:3).EQ.'YMN'.OR.PNAM(1:3).EQ.'ymn') THEN
          RMNY=RVAL
        ELSE
          CALL SETER ('GASETR - UNRECOGNIZED PARAMETER NAME',2,1)
        END IF
C
C Done.
C
        RETURN
C
      END

C
C $Id: mdrggc.f,v 1.9 2008-09-18 00:42:18 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MDRGGC (JCOL,JCSF)
C
C This routine may be called to get the values of two arrays in EZMAP,
C one of which determines the colors to be used for outline maps drawn
C using the RANGS/GSHHS data, and the other of which determines the
C colors to be used for solid-filled maps drawn using that data.
C
        INTEGER JCOL(5),JCSF(5)
C
C Declare required common blocks.  See MAPBDX for descriptions of these
C common blocks and the variables in them.
C
        COMMON /MAPRGD/  ICOL(5),ICSF(5),IDPF,LCRA,NILN,NILT,OLAT,OLON
        INTEGER          ICOL,ICSF,IDPF,LCRA,NILN,NILT
        REAL             OLAT,OLON
        SAVE   /MAPRGD/
C
C Declare local variables.
C
        INTEGER          I
C
C Check for an uncleared prior error.
C
        IF (ICFELL('MDRGGC - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C Transfer contents of color-index internal arrays to argument arrays.
C
        DO 101 I=1,5
          JCOL(I)=ICOL(I)
          JCSF(I)=ICSF(I)
  101   CONTINUE
C
C Done.
C
        RETURN
C
      END

        PROGRAM EEZMPA
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
        PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Define the array that holds the area map.  It is put in a labeled
C common block only because, on some machines, having a local array
C that large causes problems.
C
        COMMON /CLRCMN/ IAM(400000)
C
C Dimension the arrays needed by ARSCAM for edges.
C
        DIMENSION XCS(10000),YCS(10000)
C
C Dimension the arrays needed by ARSCAM and ARDRLN for area and group
C ids.
C
        DIMENSION IAI(10),IAG(10)
C
C Define an array for RGB triples.
C
        DIMENSION RGB(3,14)
C
C Define an array for indices determining the ordering of the colors.
C
        DIMENSION IOC(14)
C
C Define an array for aspect source flags.
C
        DIMENSION IF(13)
C
C Declare the routine which will color the areas and the one which
C will draw the lines of latitude and longitude over water.
C
        EXTERNAL COLRAM,COLRLN
C
C Define the required RGB triples and indices.
C
        DATA RGB / 0.70,0.70,0.70 , 0.75,0.50,1.00 , 0.50,0.00,1.00 ,
     +             0.00,0.00,1.00 , 0.00,0.50,1.00 , 0.00,1.00,1.00 ,
     +             0.00,1.00,0.60 , 0.00,1.00,0.00 , 0.70,1.00,0.00 ,
     +             1.00,1.00,0.00 , 1.00,0.75,0.00 , 1.00,0.38,0.38 ,
     +             1.00,0.00,0.38 , 1.00,0.00,0.00 /
C
        DATA IOC / 6,2,5,12,10,11,1,3,4,8,9,7,13,14 /
C
C Open GKS.
C
        CALL GOPKS (IERRF, ISZDM)
        CALL GOPWK (IWKID, LUNIT, IWTYPE)
        CALL GACWK (IWKID)
C
C Re-set certain aspect source flags to "individual".
C
        CALL GQASF (IE,IF)
        IF(11)=1
        IF(12)=1
        CALL GSASF (IF)
C
C Force solid fill.
C
        CALL GSFAIS (1)
C
C Define 15 different color indices.  The first 14 are spaced through
C the color spectrum and the final one is black.
C
        DO 101 J=1,14
          I=IOC(J)
          CALL GSCR(IWKID,J,RGB(1,I),RGB(2,I),RGB(3,I))
  101   CONTINUE
C
        CALL GSCR(IWKID,15,0.,0.,0.)
C
C Set up EZMAP, but don't draw anything.
C
        CALL MAPSTC ('OU','PO')
        CALL MAPROJ ('ME',0.,0.,0.)
        CALL MAPSET ('MA',0.,0.,0.,0.)
C
C Set the number of vertical strips and the group identifiers to
C be used by MAPBLA.
C
        CALL MAPSTI ('VS',150)
        CALL MAPSTI ('G1',1)
        CALL MAPSTI ('G2',2)
C
C Initialize EZMAP.
C
        CALL MAPINT
C
C Initialize the area map.
C
        CALL ARINAM (IAM,400000)
C
C Add edges to the area map.
C
        CALL MAPBLA (IAM)
C
C Pre-process the area map.
C
        CALL ARPRAM (IAM,0,0,0)
C
C Compute and print the amount of space used in the area map.
C
        ISU=400000-(IAM(6)-IAM(5)-1)
        PRINT * , 'SPACE USED IN AREA MAP IS ',ISU
C
C Set the background color.
C
        CALL GSCR (IWKID,0,1.,1.,1.)
C
C Color the map.
C
        CALL ARSCAM (IAM,XCS,YCS,10000,IAI,IAG,10,COLRAM)
C
C In black, draw a perimeter and outline all the countries.  We turn
C off the labels (since they seem to detract from the appearance of
C the plot) and we reduce the minimum vector length so as to include
C all of the points in the boundaries.
C
C Flush PLOTIT's buffers and set polyline color index to black.
C
        CALL PLOTIT(0,0,0)
        CALL GSPLCI(15)
C
        CALL MAPSTI ('LA',0)
        CALL MAPSTI ('MV',1)
        CALL MAPLBL
        CALL MAPLOT
C
C Draw lines of latitude and longitude over water.  They will be in
C black because of the GSPLCI call above.
C
        CALL MAPGRM (IAM,XCS,YCS,10000,IAI,IAG,10,COLRLN)
C
C Advance the frame.
C
        CALL FRAME
C
C Close GKS.
C
        CALL GDAWK (IWKID)
        CALL GCLWK (IWKID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END
C
      SUBROUTINE COLRAM (XCS,YCS,NCS,IAI,IAG,NAI)
      DIMENSION XCS(*),YCS(*),IAI(*),IAG(*)
C
C For each area, one gets a set of points (using normalized device
C coordinates), two group identifiers and their associated area
C identifiers.  If both of the area identifiers are zero or negative,
C the area need not be color-filled; otherwise, it is filled with
C a color obtained from MAPACI.  If the area is defined by more than
C 150 points, we'd like to know about it.  (I'm assuming that the
C device being used won't handle polygons defined by more points than
C that.)
C
        IF (IAI(1).GE.0.AND.IAI(2).GE.0) THEN
          ITM=MAX(IAI(1),IAI(2))
          IF (ITM.GT.0) THEN
            IF (NCS.GT.150) PRINT * , 'COLRAM - NCS TOO BIG - ',NCS
C
C Set area fill color index.
C
            CALL GSFACI(MAPACI(ITM))
C
            CALL GFA (NCS-1,XCS,YCS)
          END IF
        END IF
C
C Done.
C
        RETURN
C
      END
C
      SUBROUTINE COLRLN (XCS,YCS,NCS,IAI,IAG,NAI)
      DIMENSION XCS(*),YCS(*),IAI(*),IAG(*)
C
C For each line segment, one gets a set of points (using normalized
C device coordinates), two group identifiers and their associated
C area identifiers.  If both of the area identifiers are zero or
C negative, the segment is not drawn; otherwise, we use MAPACI to
C see if the segment is over water and, if so, we draw the segment.
C If the segment is defined by more than 150 points, we'd like to
C know about it.
C
        IF (IAI(1).GE.0.AND.IAI(2).GE.0) THEN
          ITM=MAX(IAI(1),IAI(2))
          IF (MAPACI(ITM).EQ.1) THEN
            IF (NCS.GT.150) PRINT * , 'COLRLN - NCS TOO BIG - ',NCS
            CALL GPL (NCS,XCS,YCS)
          END IF
        END IF
C
C Done.
C
        RETURN
C
      END

      PROGRAM WMEX13
C
C  An example of using the tools in the weather map library to
C  create a grayscale weather map.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=26,  IWKID=1)
C
      INTEGER WMGTLN
C
C  The MERGCM common block is used elsewhere in this code, but
C  can be used for scratch space here in the main driver.
C
      COMMON /MERGCM/ XTMP(9999),YTMP(9999),NDUM
C
C  Set up all of the coordinate data for the fronts, temperature regions,
C  cities, etc.
C
      PARAMETER (ICDIM=6000)
      DIMENSION USX(ICDIM),USY(ICDIM)
C
C  Weather front arrays.
C
C   NUMF    - the number of fronts.
C   NUMFP   - the maximum number of control points for any front.
C   LIMITF  - the defined number of control points for each region.
C   FRNSUX  - X user coordinates for fronts.
C   FRNSUY  - Y user coordinates for fronts.
C
      PARAMETER(NUMF=4,NUMFP=6)
      DIMENSION LIMITF(NUMFP),
     +          FRNSUX(NUMFP,NUMF),FRNSUY(NUMFP,NUMF),
     +          FRNSWX(NUMFP),FRNSWY(NUMFP)
C
C  Temperature and weather region arrays.
C
C   NUMR    - the number of regions
C   NUMRP   - the maximum number of control points for any region.
C   LIMITS  - the defined number of control points for each region.
C   IRTYPE  - the type of region.
C   RGNSUX  - X user coordinates for regions.
C   RGNSUY  - Y user coordinates for regions.
C
      PARAMETER(NUMR=13,NUMRP=35)
      CHARACTER*13 IRTYPE(NUMRP)
      DIMENSION LIMITS(NUMRP),RGNSUX(NUMRP,NUMR),RGNSUY(NUMRP,NUMR),
     +          RGNSWX(NUMRP),RGNSWY(NUMRP)
C
C  Regional weather labels.
C
C   NUMWL   - the number of labels.
C   CNDSUX  - X user coordinates for labels.
C   CNDSUY  - Y user coordinates for labels.
C   ICNDSL  - Labels.
C
      PARAMETER(NUMWL=5)
      DIMENSION CNDSUX(NUMWL),CNDSUY(NUMWL)
      CHARACTER*6 ICNDSL(NUMWL)
C
C  LOW/HIGH arrays.
C
C   NUML    - the number of lows and highs to plot.
C   FRNSUX  - X user coordinates for symbols.
C   FRNSUY  - Y user coordinates for symbols.
C   LOWHI   - Array of Low/High flags (0=low; 1=hi).
C
      PARAMETER(NUML=5)
      DIMENSION RLOHUX(NUML),RLOHUY(NUML),LOWHI(NUML)
C
C  City names, locations, daily hi/low labels.
C
C   NUMC    - the number of cities.
C   ICITYS  - City names.
C   IDLYTS  - Daily hi/low labels for cities.
C   CITYUX  - X user coordinates for city locations.
C   CITYUY  - Y user coordinates for city locations.
C   TEMPUX  - X user coordinates for daily hi/low locations.
C   TEMPUY  - Y user coordinates for daily hi/low locations.
C
      PARAMETER(NUMC=14)
      DIMENSION CITYUX(NUMC),CITYUY(NUMC),TEMPUX(NUMC),TEMPUY(NUMC)
      CHARACTER*13 ICITYS(NUMC)
      CHARACTER* 7 IDLYTS(NUMC)
C
C  Front data.
C
C  Front from Calif. to N. Dakota.
      DATA LIMITF(1)/4/
      DATA (FRNSUX(II,1),II=1,NUMFP)/ 
     +    41.0,   42.5,   44.5,   49.0,   00.0,   00.0 /
      DATA (FRNSUY(II,1),II=1,NUMFP)/ 
     +  -121.5, -111.0, -104.0, -098.0,   00.0,   00.0 /
C
C  Front from N. Dakota to Virginia.
      DATA LIMITF(2)/6/
      DATA (FRNSUX(II,2),II=1,NUMFP)/ 
     +    49.0,   47.0,   45.0,   42.0,   38.8,   38.5 /
      DATA (FRNSUY(II,2),II=1,NUMFP)/ 
     +  -098.0, -096.0, -095.0, -093.0, -088.3, -080.5 /
C
C  Front from Virginia out into the Atlantic.
      DATA LIMITF(3)/3/
      DATA (FRNSUX(II,3),II=1,NUMFP)/ 
     +    38.5,   39.0,   37.5,   00.0,   00.0,   00.0 /
      DATA (FRNSUY(II,3),II=1,NUMFP)/ 
     +  -080.5, -077.0, -071.0,   00.0,   00.0,   00.0 /
C
C  Front from Virginia into Canada.
      DATA LIMITF(4)/3/
      DATA (FRNSUX(II,4),II=1,NUMFP)/ 
     +    38.5,   43.0,   49.0,   00.0,   00.0,   00.0 /
      DATA (FRNSUY(II,4),II=1,NUMFP)/ 
     +  -080.5, -077.5, -077.0,   00.0,   00.0,   00.0 /
C
C  Region data.
C
C  90s in the south and west.
      DATA LIMITS(1),IRTYPE(1)/32,'INDEX4'/
      DATA (RGNSUX(II,1),II=1,NUMRP)/ 
     +    32.7,   34.5,   38.0,   42.0,   45.0,   47.5,   46.0,   
     +    43.0,   39.5,   38.3,   40.0,   37.5,   35.5,   32.7,   
     +    36.0,   41.0,   42.0,   44.5,   47.0,   48.0,   46.0,   
     +    42.0,   39.0,   36.0,   37.3,   33.0,   37.5,   29.0,   
     +    24.0,   20.0,   29.0,   32.7,   00.0,   00.0,   00.0 /
      DATA (RGNSUY(II,1),II=1,NUMRP)/ 
     +  -116.0, -117.0, -120.5, -122.7, -122.0, -118.0, -115.3, 
     +  -113.0, -107.5, -109.0, -115.0, -114.0, -111.5, -109.0, 
     +  -106.0, -105.0, -104.0, -107.0, -109.7, -104.0, -098.0, 
     +  -095.5, -096.0, -093.0, -088.5, -083.0, -076.0, -075.0, 
     +  -080.0, -097.0, -115.0, -116.0,   00.0,   00.0,   00.0 /
C
C 100s in Okla./Texas
      DATA LIMITS(2),IRTYPE(2)/5,'INDEX0'/
      DATA (RGNSUX(II,2),II=1,NUMRP)/ 
     +    35.0,   33.0,   31.5,   33.0,   35.0,   00.0,   00.0,   
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0 /
      DATA (RGNSUY(II,2),II=1,NUMRP)/ 
     +  -097.5, -096.5, -097.5, -098.5, -097.5,   00.0,  000.0, 
     +  -080.0, -097.0, -115.0, -116.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0 /
C
C  70s in Calif. and NW.
      DATA LIMITS(3),IRTYPE(3)/25,'INDEX4'/
      DATA (RGNSUX(II,3),II=1,NUMRP)/ 
     +    35.0,   36.0,   38.0,   40.0,   43.0,   46.5,   48.5, 
     +    47.0,   44.0,   44.5,   46.0,   47.0,   49.0,   53.0, 
     +    48.0,   46.0,   42.8,   40.0,   37.0,   35.5,   35.0, 
     +    33.0,   28.0,   30.0,   32.7,   35.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0 /
      DATA (RGNSUY(II,3),II=1,NUMRP)/ 
     +  -118.7, -120.0, -121.5, -122.7, -123.1, -121.8, -118.0, 
     +  -114.5, -112.0, -110.5, -112.0, -113.2, -114.0, -122.0, 
     +  -123.5, -123.0, -123.5, -123.0, -121.5, -120.5, -120.9, 
     +  -122.0, -120.0, -116.0, -116.5, -118.7,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0 /
C
C  70s in Gt. Lakes area
      DATA LIMITS(4),IRTYPE(4)/7,'INDEX4'/
      DATA (RGNSUX(II,4),II=1,NUMRP)/ 
     +    49.0,   45.5,   46.0,   50.0,   53.0,   51.5,   49.0, 
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0 /
      DATA (RGNSUY(II,4),II=1,NUMRP)/ 
     +  -096.0, -090.5, -084.0, -082.0, -089.0, -095.0, -096.0, 
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0 /
C
C  70s in New England.
      DATA LIMITS(5),IRTYPE(5)/7,'INDEX4'/
      DATA (RGNSUX(II,5),II=1,NUMRP)/ 
     +    45.0,   43.2,   41.5,   43.0,   47.0,   49.0,   45.0, 
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0 /
      DATA (RGNSUY(II,5),II=1,NUMRP)/ 
     +  -073.3, -072.5, -070.5, -066.0, -065.0, -071.0, -073.3, 
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0 /
C
C  100s in Calif./Arizona
      DATA LIMITS(6),IRTYPE(6)/8,'INDEX0'/
      DATA (RGNSUX(II,6),II=1,NUMRP)/ 
     +    32.7,   35.0,   36.0,   35.3,   33.0,   31.3,   30.0, 
     +    32.7,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0 /
      DATA (RGNSUY(II,6),II=1,NUMRP)/ 
     +  -115.0, -116.0, -115.3, -114.0, -111.0, -111.0, -113.0, 
     +  -115.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0 /
C
C  T-storms in the southwest.
      DATA LIMITS(7),IRTYPE(7)/14,'THUNDERSTORMS'/
      DATA (RGNSUX(II,7),II=1,NUMRP)/
     +    33.5,   35.5,   37.2,   38.5,   39.5,   39.5,   38.0,
     +    36.0,   34.5,   33.0,   30.0,   30.0,   31.0,   33.5,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0 /
      DATA (RGNSUY(II,7),II=1,NUMRP)/
     +  -110.2, -111.5, -113.0, -111.5, -108.5, -106.3, -105.5,
     +  -106.0, -107.5, -108.0, -108.3, -109.6, -110.2, -110.2,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0 /
C
C  T-storms in N. Minn.
      DATA LIMITS(8),IRTYPE(8)/8,'THUNDERSTORMS'/
      DATA (RGNSUX(II,8),II=1,NUMRP)/
     +    49.0,   50.5,   49.0,   47.0,   45.0,   45.0,   47.0,
     +    49.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0 /
      DATA (RGNSUY(II,8),II=1,NUMRP)/
     +  -097.0, -094.0, -090.0, -089.3, -091.5, -093.5, -096.0,
     +  -097.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0 /
C
C  T-storms in California.
      DATA LIMITS(9),IRTYPE(9)/5,'THUNDERSTORMS'/
      DATA (RGNSUX(II,9),II=1,NUMRP)/
     +    39.0,   38.0,   35.3,   37.0,   39.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0 /
      DATA (RGNSUY(II,9),II=1,NUMRP)/
     +  -120.0, -118.0, -116.5, -119.0, -120.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0 /
C
C  Showers in Montana.
      DATA LIMITS(10),IRTYPE(10)/8,'SHOWERS'/
      DATA (RGNSUX(II,10),II=1,NUMRP)/
     +    50.0,   49.0,   48.0,   47.0,   46.7,   48.0,   50.0,
     +    50.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0 /
      DATA (RGNSUY(II,10),II=1,NUMRP)/
     +  -105.0, -105.0, -106.0, -108.0, -110.7, -110.0, -106.5,
     +  -105.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0 /
C
C  T-storms in southeast
      DATA LIMITS(11),IRTYPE(11)/12,'THUNDERSTORMS'/
      DATA (RGNSUX(II,11),II=1,NUMRP)/
     +    36.7,   35.0,   32.0,   31.0,   31.6,   32.2,   32.8,
     +    32.2,   32.2,   34.0,   36.0,   36.7,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0 /
      DATA (RGNSUY(II,11),II=1,NUMRP)/
     +  -076.0, -078.0, -081.5, -084.0, -088.0, -089.5, -088.0,
     +  -085.0, -083.0, -080.4, -078.0, -076.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0 /
C
C  T-storms from Missouri to New York.
      DATA LIMITS(12),IRTYPE(12)/20,'THUNDERSTORMS'/
      DATA (RGNSUX(II,12),II=1,NUMRP)/
     +    35.0,   36.5,   36.5,   37.7,   38.5,   41.0,   45.0,
     +    47.0,   49.0,   48.5,   47.0,   44.0,   42.8,   41.5,
     +    40.0,   38.0,   36.0,   34.5,   34.5,   35.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0 /
      DATA (RGNSUY(II,12),II=1,NUMRP)/
     +  -094.0, -092.0, -089.0, -084.0, -079.0, -077.0, -076.0,
     +  -076.0, -075.7, -074.5, -073.3, -071.5, -070.3, -070.5,
     +  -074.0, -077.5, -081.0, -087.0, -092.0, -094.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0 /
C
C  Showers in extreme northeast
      DATA LIMITS(13),IRTYPE(13)/8,'SHOWERS'/
      DATA (RGNSUX(II,13),II=1,NUMRP)/
     +    49.5,   49.0,   47.0,   44.0,   44.0,   47.0,   48.5,
     +    49.5,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0 /
      DATA (RGNSUY(II,13),II=1,NUMRP)/
     +  -073.8, -071.0, -069.5, -069.0, -071.0, -073.0, -074.0,
     +  -073.8,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0 /
C
C  LOWs and HIs.
C
      DATA (RLOHUX(II),II=1,NUML) /  49.0,  38.5,  47.5,  44.0,  26.5 /
      DATA (RLOHUY(II),II=1,NUML) /-099.0,-080.5,-127.0,-089.0,-088.0 /       
      DATA ( LOWHI(II),II=1,NUML) / 0, 0, 1, 1, 1 /
C
C  Labels of regional conditions.
C
      DATA (CNDSUX(II),II=1,NUMWL) /  45.5,  41.5,  31.5,  33.0,  45.5 /
      DATA (CNDSUY(II),II=1,NUMWL) /-113.0,-099.0,-095.5,-113.2,-082.0 /       
      DATA (ICNDSL(II),II=1,NUMWL) / 
     +  'BREEZY','HOT','STEAMY','HUMID','NICE'/
C
C  Data on city locations and daily temperature labels.
C
      DATA (ICITYS(II),II=1,NUMC)/
     +           'NCAR',       'Seattle', 'San Francisco',                
     +    'Los Angeles',      'Billings',       'El Paso',
     +        'Houston',   'Kansas City',   'Minneapolis',
     +        'Chicago',       'Detroit',       'Atlanta',
     +          'Miami',      'New York'                    /
      DATA (CITYUX(II),II=1,NUMC)/ 
     +    40.0,   47.6,   37.8,   34.1,   45.8,   31.8,   29.8, 
     +    39.1,   45.0,   41.9,   42.3,   33.8,   25.8,   40.8 /
      DATA (CITYUY(II),II=1,NUMC)/ 
     +  -105.0, -122.3, -122.4, -118.3, -108.5, -106.5, -095.3, 
     +  -094.6, -093.8, -087.6, -083.1, -084.4, -080.2, -074.0 /
      DATA (TEMPUX(II),II=1,NUMC)/ 
     +    38.8,   46.9,   38.6,   35.0,   46.0,   32.2,   28.8, 
     +    37.7,   46.0,   40.7,   43.7,   32.4,   27.2,   40.5 /
      DATA (TEMPUY(II),II=1,NUMC)/ 
     +  -103.2, -119.6, -120.3, -116.0, -105.6, -104.2, -097.4, 
     +  -092.4, -091.2, -085.2, -082.8, -084.6, -081.3, -071.5 /
      DATA (IDLYTS(II),II=1,NUMC)/
     + '92/58', '80/58', '68/54', '80/64', '91/58', '96/70', '98/76', 
     + '88/70', '84/67', '84/66', '84/63', '90/72', '92/80', '83/70' /        
C
C  Set up color indices to use for temperature regions.
C
      DATA IC60S,IC70S,IC80S,IC90S,IC100S/0,4,0,4,0/
C
C Open GKS.
C
      CALL GOPKS (IERRF, ISZDM)
C
C  Calls to position the output (applicable only to PostScript output).
C
      CALL NGSETI('LX',-90)
      CALL NGSETI('UX',710)
      CALL NGSETI('LY',-15)
      CALL NGSETI('UY',785)
C
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
      CALL GSCR(IWKID,0,1.,1.,1.)
      CALL GSCR(IWKID,1,0.,0.,0.)
      CALL GSCR(IWKID,2,1.,0.,0.)
      CALL GSCR(IWKID,3,0.,0.,1.)
      CALL GSCR(IWKID,4,.85,.85,.85)
      CALL GSCR(IWKID,5,.60,.60,.60)
C
C  Get world coordinates for the U.S. continental boundary and store
C  the U.S. state map in flash buffer 1.  This takes some execution
C  time.
C
      CALL GOPWK(9,8,3)
      CALL WMTINT(1,ICDIM,USX,USY,NO)
C
      CALL GSFAIS(1)
      CALL GSFACI(5)
C
C  Get world coordinate extents, and plot a shaded offset of the
C  continental U.S. boundary.
C     
      CALL TSTEXT(XEXT,YEXT)
      DO 70 I=1,NO
        XTMP(I) = USX(I)-.01*XEXT
        YTMP(I) = USY(I)-.012*YEXT
   70 CONTINUE
      CALL GFA(NO,XTMP,YTMP)
      CALL GSFACI(0)
      CALL GFA(NO,USX,USY)
C
C-------------------------------
C  Plot temperature regions.   |
C-------------------------------
C
      DO 50 I=1,NUMR
        INDXMX = LIMITS(I)
        DO 60 J=1,INDXMX
          CALL MAPTRN(RGNSUX(J,I),RGNSUY(J,I),RGNSWX(J),RGNSWY(J))
   60   CONTINUE
        CALL WMDRRG(LIMITS(I),RGNSWX,RGNSWY,IRTYPE(I),NO,USX,USY)
   50 CONTINUE
C
C------------------
C   U.S. Map      |
C------------------
C
      CALL GFLAS3(1)
C
C----------------------------
C  Plot the weather fronts. |
C----------------------------
C
      DO 10 I=1,LIMITF(1)
        CALL MAPTRN(FRNSUX(I,1),FRNSUY(I,1),FRNSWX(I),FRNSWY(I))
   10 CONTINUE
      CALL WMSETC('FRO','COLD')
      CALL WMSETR('END',.040)
      CALL WMDRFT(LIMITF(1),FRNSWX,FRNSWY)
      CALL WMDFLT
C
C   Convert to world coordinates.
      DO 20 I=1,LIMITF(2)
        CALL MAPTRN(FRNSUX(I,2),FRNSUY(I,2),FRNSWX(I),FRNSWY(I))
   20 CONTINUE
C
C   Define the type and direction of each symbol.
      CALL WMSETI('PAI', 1)
      CALL WMSETI('STY',-2)
      CALL WMSETI('PAI', 2)
      CALL WMSETI('STY',-2)
      CALL WMSETI('PAI', 3)
      CALL WMSETI('STY', 1)
      CALL WMSETI('PAI', 4)
      CALL WMSETI('STY',-2)
      CALL WMSETI('PAI', 5)
      CALL WMSETI('STY', 1)
C
C   Define spacings.
      CALL WMSETR('BEG',.03)
      CALL WMSETR('END',.035)
      CALL WMSETR('BET',.04)
C
C   Draw front.
      CALL WMDRFT(LIMITF(2),FRNSWX,FRNSWY)
C
C   Reset parameters to default values.
      CALL WMDFLT
C
      DO 30 I=1,LIMITF(3)
        CALL MAPTRN(FRNSUX(I,3),FRNSUY(I,3),FRNSWX(I),FRNSWY(I))
   30 CONTINUE
      CALL WMSETC('FRO','STA')
      CALL WMSETR('BEG',.040)
      CALL WMSETI('REV',1)
      CALL WMDRFT(LIMITF(3),FRNSWX,FRNSWY)
      CALL WMDFLT
C
      DO 40 I=1,LIMITF(4)
        CALL MAPTRN(FRNSUX(I,4),FRNSUY(I,4),FRNSWX(I),FRNSWY(I))
   40 CONTINUE
      CALL WMSETC('FRO','COLD')
      CALL WMSETR('BEG',.040)
      CALL WMSETR('BET',.030)
      CALL WMDRFT(LIMITF(4),FRNSWX,FRNSWY)
      CALL WMDFLT
C
C----------------
C  LOs and HIs  |
C----------------
C
      CALL GSCLIP(0)
      DO 80 I=1,NUML
        CALL MAPTRN(RLOHUX(I),RLOHUY(I),XO,YO)
        IF (LOWHI(I) .EQ. 0) THEN
          CALL WMLABS(XO,YO,'LOW')
        ELSE
          CALL WMLABS(XO,YO,'HI')
        ENDIF
   80 CONTINUE
C
C-------------------------------
C  Regional condition labels.  |
C-------------------------------
C  
      DO 90 I=1,NUMWL
        CALL MAPTRN(CNDSUX(I),CNDSUY(I),XO,YO)
        LL = WMGTLN(ICNDSL(I),LEN(ICNDSL(I)),0)
        CALL WMLABW(XO,YO,ICNDSL(I)(1:LL))
   90 CONTINUE
C  
C-----------------------------
C  Cities and temperatures.  |
C-----------------------------
C
C   NUMC    - the number of cities.
C   ICITYS  - City names.
C   IDLYTS  - Daily hi/low labels for cities.
C   CITYUX  - X user coordinates for city locations.
C   CITYUY  - Y user coordinates for city locations.
C   TEMPUX  - X user coordinates for daily hi/low locations.
C   TEMPUY  - Y user coordinates for daily hi/low locations.

      DO 110 I=1,NUMC
        CALL MAPTRN(CITYUX(I),CITYUY(I),XO,YO)
        CALL WMLABS(XO,YO,'D')
        CALL MAPTRN(TEMPUX(I),TEMPUY(I),XO,YO)
        LL = WMGTLN(ICITYS(I),LEN(ICITYS(I)),0)
        MM = WMGTLN(IDLYTS(I),LEN(IDLYTS(I)),0)
        CALL WMLABC(XO,YO,ICITYS(I)(1:LL),IDLYTS(I)(1:MM))
  110 CONTINUE
C
C---------------------------------
C  Regional temperature labels.  |
C---------------------------------
C
C   S. Ariz.
      CALL MAPTRN(32.,-112.,XO,YO)
      CALL WMLABT(XO,YO,'100s',2)
C   S. Calif.
      CALL WMGETR('ARD',AANGO)
      CALL WMGETR('ARL',ARLNO)
      CALL WMSETR('ARD',65.)
      CALL WMSETR('ARL',1.2)
      CALL MAPTRN(34.9,-120.,XO,YO)
      CALL WMLABS(XO,YO,'ARROW')
      CALL WMSETR('ARD',AANGO)
      CALL WMSETR('ARL',ARLNO)
      CALL MAPTRN(32.8,-116.9,XO,YO)
      CALL WMLABT(XO,YO,'70s',1)
C   Oregon Pacific coast.
      CALL MAPTRN(43.,-123.9,XO,YO)
      CALL WMLABT(XO,YO,'60s',11)
C   Idaho
      CALL MAPTRN(48.25,-114.75,XO,YO)
      CALL WMLABT(XO,YO,'70s',8)
C   Gt. Lakes
      CALL MAPTRN(47.7,-87.,XO,YO)
      CALL WMLABT(XO,YO,'70s',8)
C   N. Carolina
      CALL MAPTRN(35.0,-78.,XO,YO)
      CALL WMLABT(XO,YO,'90s',6)
C   Maine
      CALL MAPTRN(46.5,-68.5,XO,YO)
      CALL WMLABT(XO,YO,'70s',9)
C   S. Dakota
      CALL MAPTRN(44.5,-100.0,XO,YO)
      CALL WMSETI('RBS',IC90S)
      CALL WMLABT(XO,YO,'90s',0)
C   Miss.
      CALL MAPTRN(33.4,-89.6,XO,YO)
      CALL WMSETI('RBS',IC90S)
      CALL WMLABT(XO,YO,'90s',0)
C   Texas
      CALL MAPTRN(31.25,-100.50,XO,YO)
      CALL WMSETI('RBS',IC90S)
      CALL WMLABT(XO,YO,'90s',0)
C   S. of Okla.
      CALL MAPTRN(34.3,-97.5,XO,YO)
      CALL WMSETI('RBS',IC90S)
      CALL WMLABT(XO,YO,'100s',11)
C   N. Ariz./New Mexico
      CALL MAPTRN(36.0,-109.0,XO,YO)
      CALL WMSETI('RBS',IC80S)
      CALL WMLABT(XO,YO,'80s',0)
C   Oregon
      CALL MAPTRN(43.7,-120.5,XO,YO)
      CALL WMSETI('RBS',IC90S)
      CALL WMLABT(XO,YO,'90s',0)
C   Colo/Utah
      CALL MAPTRN(40.0,-110.6,XO,YO)
      CALL WMSETI('RBS',IC90S)
      CALL WMLABT(XO,YO,'90s',0)
C   N. Montana.
      CALL MAPTRN(48.0,-111.,XO,YO)
      CALL WMSETI('RBS',IC80S)
      CALL WMLABT(XO,YO,'80s',0)
C   Iowa/Ill.
      CALL MAPTRN(41.5,-89.6,XO,YO)
      CALL WMSETI('RBS',IC80S)
      CALL WMLABT(XO,YO,'80s',0)
C   Tenn.
      CALL MAPTRN(35.7,-83.,XO,YO)
      CALL WMSETI('RBS',IC80S)
      CALL WMLABT(XO,YO,'80s',0)
C   New York
      CALL MAPTRN(42.7,-75.0,XO,YO)
      CALL WMSETI('RBS',IC80S)
      CALL WMLABT(XO,YO,'80s',0)
C
C-----------------
C   Main title.  |
C-----------------
C
      CALL MAPTRN(53.,-98.0,XO,YO)
      CALL WMSETI('RFC',1)
      CALL WMSETI('RBS',-1)
      CALL WMSETI('RLS',0)
      CALL WMLABT(XO,YO,'July 18, 1994',0)
C
C--------------
C   Legends.  |
C--------------
C
      CALL GQCNTN(IER,NTRO)
      CALL GSELNT(0)
      CALL WMLGND(.05,0.16,1,6,1)
      CALL WMLGND(.45,0.15,3,0,0)
      CALL WMLGND(.90,0.15,2,0,0)
      CALL GSELNT(NTRO)
C
      CALL FRAME
C
C Close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK(9)
      CALL GCLWK (IWKID)
      CALL GCLKS
      STOP
C
      END
      SUBROUTINE WMTINT(IBNUM,N,USX,USY,NO)
C
C  Does some initialization.  Stores a map of the U.S. state outlines
C  in Flash buffer number IBNUM, and returns world coordinate values
C  for the boundary of the U.S. in (USX(I),USY(I),I=1,NO).  USX and
C  USY are dimensioned for N and NO is returned as the actual number
C  of coordinates in the dataset.  N should be at least 6000.
C
C  This routine also initializes the EZMAP parameters.
C
C  Define space for the area map that is used to obtain the
C  coordinates for the boundary of the continental U.S.  Set up some 
C  arrays to be used by areas in obtaining the U.S. continental outline.
C  The merged polygons from Areas are stored in common MERGCM.
C  RTPTAR is a subroutine used by Areas to process the areas.
C
      DIMENSION USX(N),USY(N)
C
      COMMON /MEODCM/IEODF
      PARAMETER (LAMA=100000)
      DIMENSION IAMA(LAMA)
      DIMENSION XCRA(10000),YCRA(10000),IAAI(10),IAGI(10)
      COMMON /MERGCM/ XCMP(9999),YCMP(9999),NCMP
      SAVE   /MERGCM/
      EXTERNAL RTPTAR
C
C  Set up the parameters for drawing the U.S. state outlines.
C
C   Position the plot.
C     CALL MAPPOS(0.05, 0.95, 0.05, 0.95)
C
C   Specify U.S. state outlines.
      CALL MAPSTC('OU','US')
C
C   Choose Lambert conformal projection with two standard parallels.
      CALL MAPROJ('LC',30.,-100.,45.)
C
C   Reduce the value of 'MV' to make what MAPDRW produces match what
C   comes out of MAPBLA/ARSCAM.
      CALL MAPSTI ('MV',1)
C
C   Specify the corner points of the plot as lat/lon pairs.
      CALL MAPSET('CO',22.6,-120.,46.9,-64.2)
C
C   Initialize the transformations.
      CALL MAPINT()
C
C  Set the flag for MAPEOD to just consider boundary lines.
C
      CALL GFLAS1(IBNUM)
      IEODF = 1
      CALL MAPLOT
C
C Initialize the area map, and put selected outlines in the area map.
C (A version of MAPEOD is supplied which causes anything not part of 
C the outer boundary of the U.S. to be omitted).
C
      CALL ARINAM (IAMA,LAMA)
      CALL MAPBLA (IAMA)
      NCMP=0
C
C Scan the area map using RTPTAR to fill all the polygons representing 
C the U.S.  Merge the polygons into a single polygon in MERGCM.
C
      CALL ARSCAM (IAMA,XCRA,YCRA,10000,IAAI,IAGI,10,RTPTAR)
C
C Convert to world coordinates.
C
        DO 101 I=1,NCMP
          USX(I)=CFUX(XCMP(I))
          USY(I)=CFUY(YCMP(I))
  101   CONTINUE
      IEODF = 0
      CALL MAPLOT
      CALL GFLAS2
      NO = NCMP
C
      RETURN
      END
      SUBROUTINE MAPEOD (NOUT,NSEG,IDLS,IDRS,NPTS,PNTS)
C
      DIMENSION PNTS(*)
C
      COMMON /MEODCM/IEODF
C
C  This version of MAPEOD omits all parts of the 'US' outline dataset
C  which are strictly internal, saving only those which are part of
C  the external boundary.  (The "border" has area identifier "223";
C  we omit anything that is not on the "border".)
C
      IF (IEODF .EQ. 1) THEN
        IF (IDLS.NE.223 .AND. IDRS.NE.223) NPTS=0
      ELSE
        RETURN
      ENDiF
C
      END
      SUBROUTINE RTPTAR (XCRA,YCRA,NCRA,IAAI,IAGI,NOFG)
C
C  Calls MERGPO to merge all such polygons into one polygon.
C
      DIMENSION XCRA(*),YCRA(*),IAAI(*),IAGI(*)
C
C  Find the area identifier of the area relative to group 1.
C
      IAG1=-1
C
      DO 101 I=1,NOFG
        IF (IAGI(I).EQ.1) IAG1=IAAI(I)
  101 CONTINUE
C
C  If the index of the area relative to group 1 is positive and not 223,
C  fill it.
C
      IF (IAG1.GT.0 .AND. IAG1.NE.223) THEN
        CALL MERGPO (XCRA,YCRA,NCRA)
      END IF
C
      RETURN
      END
      SUBROUTINE MERGPO (XCRA,YCRA,NCRA)
C
      DIMENSION XCRA(*),YCRA(*)
C
C  This routine merges polygons into a single polygon.
C
C  Merge polygons are formed in the common block MERGCM:
C
      COMMON /MERGCM/ XCMP(9999),YCMP(9999),NCMP
      SAVE   /MERGCM/
C
C  Copy the coordinates of the latest polygon into the merge polygon
C  coordinate arrays and, if the polygon is not the first of the group,
C  repeat the first point of the first polygon.  (Actually, the code
C  below does something a little more complicated: if necessary, it
C  interpolates points to ensure that the connecting lines between
C  polygons consist of horizontal and/or vertical steps; this tends
C  to prevent problems caused by deficiencies in the fill algorithms
C  on some devices.)
C
C  The following statement is a quick-and-dirty patch to leave out all
C  the off-shore islands, since they seem to cause some problems.
C
      IF (NCRA.LT.100) RETURN
C
      NTMP=NCMP
C
      IF (NTMP+NCRA+4.LE.9999) THEN
        IF (NCMP.NE.0) THEN
          IF (XCMP(NTMP).NE.XCRA(1).AND.YCMP(NTMP).NE.YCRA(1)) THEN
            IF (YCMP(NTMP).LT.YCRA(1)) THEN
              NTMP=NTMP+1
              XCMP(NTMP)=XCRA(1)
              YCMP(NTMP)=YCMP(NTMP-1)
            ELSE
              NTMP=NTMP+1
              XCMP(NTMP)=XCMP(NTMP-1)
              YCMP(NTMP)=YCRA(1)
            END IF
          END IF
          NTMP=NTMP+1
          XCMP(NTMP)=XCRA(1)
          YCMP(NTMP)=YCRA(1)
        END IF
        DO 102 ICRA=1,NCRA
          XCMP(NTMP+ICRA)=XCRA(ICRA)
          YCMP(NTMP+ICRA)=YCRA(ICRA)
  102   CONTINUE
        NTMP=NTMP+NCRA
        IF (NCMP.NE.0) THEN
          IF (XCMP(NTMP).NE.XCMP(1).AND.YCMP(NTMP).NE.YCMP(1)) THEN
            IF (YCMP(NTMP).LT.YCMP(1)) THEN
              NTMP=NTMP+1
              XCMP(NTMP)=XCMP(1)
              YCMP(NTMP)=YCMP(NTMP-1)
            ELSE
              NTMP=NTMP+1
              XCMP(NTMP)=XCMP(NTMP-1)
              YCMP(NTMP)=YCMP(1)
            END IF
          END IF
          NTMP=NTMP+1
          XCMP(NTMP)=XCMP(1)
          YCMP(NTMP)=YCMP(1)
        END IF
      ELSE
        NTMP=10000
      END IF
C
      NCMP=NTMP
C
      RETURN
      END
      SUBROUTINE TSTEXT(XEXT,YEXT)
C
C  Calculate the world coordinate extents.
C
      REAL WINDOW(4),VIEWPT(4)
C
      CALL GQCNTN(IER,NTR)
      CALL GQNT(NTR,IER,WINDOW,VIEWPT)
      XEXT = WINDOW(2)-WINDOW(1)
      YEXT = WINDOW(4)-WINDOW(3)
C
      RETURN
      END

      SUBROUTINE CLAQSP( UPLO, N, AP, S, SCOND, AMAX, EQUED )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     February 29, 1992
*
*     .. Scalar Arguments ..
      CHARACTER          EQUED, UPLO
      INTEGER            N
      REAL               AMAX, SCOND
*     ..
*     .. Array Arguments ..
      REAL               S( * )
      COMPLEX            AP( * )
*     ..
*
*  Purpose
*  =======
*
*  CLAQSP equilibrates a symmetric matrix A using the scaling factors
*  in the vector S.
*
*  Arguments
*  =========
*
*  UPLO    (input) CHARACTER*1
*          Specifies whether the upper or lower triangular part of the
*          symmetric matrix A is stored.
*          = 'U':  Upper triangular
*          = 'L':  Lower triangular
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  AP      (input/output) COMPLEX array, dimension (N*(N+1)/2)
*          On entry, the upper or lower triangle of the symmetric matrix
*          A, packed columnwise in a linear array.  The j-th column of A
*          is stored in the array AP as follows:
*          if UPLO = 'U', AP(i + (j-1)*j/2) = A(i,j) for 1<=i<=j;
*          if UPLO = 'L', AP(i + (j-1)*(2n-j)/2) = A(i,j) for j<=i<=n.
*
*          On exit, the equilibrated matrix:  diag(S) * A * diag(S), in
*          the same storage format as A.
*
*  S       (input) REAL array, dimension (N)
*          The scale factors for A.
*
*  SCOND   (input) REAL
*          Ratio of the smallest S(i) to the largest S(i).
*
*  AMAX    (input) REAL
*          Absolute value of largest matrix entry.
*
*  EQUED   (output) CHARACTER*1
*          Specifies whether or not equilibration was done.
*          = 'N':  No equilibration.
*          = 'Y':  Equilibration was done, i.e., A has been replaced by
*                  diag(S) * A * diag(S).
*
*  Internal Parameters
*  ===================
*
*  THRESH is a threshold value used to decide if scaling should be done
*  based on the ratio of the scaling factors.  If SCOND < THRESH,
*  scaling is done.
*
*  LARGE and SMALL are threshold values used to decide if scaling should
*  be done based on the absolute size of the largest matrix element.
*  If AMAX > LARGE or AMAX < SMALL, scaling is done.
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ONE, THRESH
      PARAMETER          ( ONE = 1.0E+0, THRESH = 0.1E+0 )
*     ..
*     .. Local Scalars ..
      INTEGER            I, J, JC
      REAL               CJ, LARGE, SMALL
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      REAL               SLAMCH
      EXTERNAL           LSAME, SLAMCH
*     ..
*     .. Executable Statements ..
*
*     Quick return if possible
*
      IF( N.LE.0 ) THEN
         EQUED = 'N'
         RETURN
      END IF
*
*     Initialize LARGE and SMALL.
*
      SMALL = SLAMCH( 'Safe minimum' ) / SLAMCH( 'Precision' )
      LARGE = ONE / SMALL
*
      IF( SCOND.GE.THRESH .AND. AMAX.GE.SMALL .AND. AMAX.LE.LARGE ) THEN
*
*        No equilibration
*
         EQUED = 'N'
      ELSE
*
*        Replace A by diag(S) * A * diag(S).
*
         IF( LSAME( UPLO, 'U' ) ) THEN
*
*           Upper triangle of A is stored.
*
            JC = 1
            DO 20 J = 1, N
               CJ = S( J )
               DO 10 I = 1, J
                  AP( JC+I-1 ) = CJ*S( I )*AP( JC+I-1 )
   10          CONTINUE
               JC = JC + J
   20       CONTINUE
         ELSE
*
*           Lower triangle of A is stored.
*
            JC = 1
            DO 40 J = 1, N
               CJ = S( J )
               DO 30 I = J, N
                  AP( JC+I-J ) = CJ*S( I )*AP( JC+I-J )
   30          CONTINUE
               JC = JC + N - J + 1
   40       CONTINUE
         END IF
         EQUED = 'Y'
      END IF
*
      RETURN
*
*     End of CLAQSP
*
      END

      SUBROUTINE SLASY2( LTRANL, LTRANR, ISGN, N1, N2, TL, LDTL, TR,
     $                   LDTR, B, LDB, SCALE, X, LDX, XNORM, INFO )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     October 31, 1992
*
*     .. Scalar Arguments ..
      LOGICAL            LTRANL, LTRANR
      INTEGER            INFO, ISGN, LDB, LDTL, LDTR, LDX, N1, N2
      REAL               SCALE, XNORM
*     ..
*     .. Array Arguments ..
      REAL               B( LDB, * ), TL( LDTL, * ), TR( LDTR, * ),
     $                   X( LDX, * )
*     ..
*
*  Purpose
*  =======
*
*  SLASY2 solves for the N1 by N2 matrix X, 1 <= N1,N2 <= 2, in
*
*         op(TL)*X + ISGN*X*op(TR) = SCALE*B,
*
*  where TL is N1 by N1, TR is N2 by N2, B is N1 by N2, and ISGN = 1 or
*  -1.  op(T) = T or T', where T' denotes the transpose of T.
*
*  Arguments
*  =========
*
*  LTRANL  (input) LOGICAL
*          On entry, LTRANL specifies the op(TL):
*             = .FALSE., op(TL) = TL,
*             = .TRUE., op(TL) = TL'.
*
*  LTRANR  (input) LOGICAL
*          On entry, LTRANR specifies the op(TR):
*            = .FALSE., op(TR) = TR,
*            = .TRUE., op(TR) = TR'.
*
*  ISGN    (input) INTEGER
*          On entry, ISGN specifies the sign of the equation
*          as described before. ISGN may only be 1 or -1.
*
*  N1      (input) INTEGER
*          On entry, N1 specifies the order of matrix TL.
*          N1 may only be 0, 1 or 2.
*
*  N2      (input) INTEGER
*          On entry, N2 specifies the order of matrix TR.
*          N2 may only be 0, 1 or 2.
*
*  TL      (input) REAL array, dimension (LDTL,2)
*          On entry, TL contains an N1 by N1 matrix.
*
*  LDTL    (input) INTEGER
*          The leading dimension of the matrix TL. LDTL >= max(1,N1).
*
*  TR      (input) REAL array, dimension (LDTR,2)
*          On entry, TR contains an N2 by N2 matrix.
*
*  LDTR    (input) INTEGER
*          The leading dimension of the matrix TR. LDTR >= max(1,N2).
*
*  B       (input) REAL array, dimension (LDB,2)
*          On entry, the N1 by N2 matrix B contains the right-hand
*          side of the equation.
*
*  LDB     (input) INTEGER
*          The leading dimension of the matrix B. LDB >= max(1,N1).
*
*  SCALE   (output) REAL
*          On exit, SCALE contains the scale factor. SCALE is chosen
*          less than or equal to 1 to prevent the solution overflowing.
*
*  X       (output) REAL array, dimension (LDX,2)
*          On exit, X contains the N1 by N2 solution.
*
*  LDX     (input) INTEGER
*          The leading dimension of the matrix X. LDX >= max(1,N1).
*
*  XNORM   (output) REAL
*          On exit, XNORM is the infinity-norm of the solution.
*
*  INFO    (output) INTEGER
*          On exit, INFO is set to
*             0: successful exit.
*             1: TL and TR have too close eigenvalues, so TL or
*                TR is perturbed to get a nonsingular equation.
*          NOTE: In the interests of speed, this routine does not
*                check the inputs for errors.
*
* =====================================================================
*
*     .. Parameters ..
      REAL               ZERO, ONE
      PARAMETER          ( ZERO = 0.0E+0, ONE = 1.0E+0 )
      REAL               TWO, HALF, EIGHT
      PARAMETER          ( TWO = 2.0E+0, HALF = 0.5E+0, EIGHT = 8.0E+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            BSWAP, XSWAP
      INTEGER            I, IP, IPIV, IPSV, J, JP, JPSV, K
      REAL               BET, EPS, GAM, L21, SGN, SMIN, SMLNUM, TAU1,
     $                   TEMP, U11, U12, U22, XMAX
*     ..
*     .. Local Arrays ..
      LOGICAL            BSWPIV( 4 ), XSWPIV( 4 )
      INTEGER            JPIV( 4 ), LOCL21( 4 ), LOCU12( 4 ),
     $                   LOCU22( 4 )
      REAL               BTMP( 4 ), T16( 4, 4 ), TMP( 4 ), X2( 2 )
*     ..
*     .. External Functions ..
      INTEGER            ISAMAX
      REAL               SLAMCH
      EXTERNAL           ISAMAX, SLAMCH
*     ..
*     .. External Subroutines ..
      EXTERNAL           SCOPY, SSWAP
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, MAX
*     ..
*     .. Data statements ..
      DATA               LOCU12 / 3, 4, 1, 2 / , LOCL21 / 2, 1, 4, 3 / ,
     $                   LOCU22 / 4, 3, 2, 1 /
      DATA               XSWPIV / .FALSE., .FALSE., .TRUE., .TRUE. /
      DATA               BSWPIV / .FALSE., .TRUE., .FALSE., .TRUE. /
*     ..
*     .. Executable Statements ..
*
*     Do not check the input parameters for errors
*
      INFO = 0
*
*     Quick return if possible
*
      IF( N1.EQ.0 .OR. N2.EQ.0 )
     $   RETURN
*
*     Set constants to control overflow
*
      EPS = SLAMCH( 'P' )
      SMLNUM = SLAMCH( 'S' ) / EPS
      SGN = ISGN
*
      K = N1 + N1 + N2 - 2
      GO TO ( 10, 20, 30, 50 )K
*
*     1 by 1: TL11*X + SGN*X*TR11 = B11
*
   10 CONTINUE
      TAU1 = TL( 1, 1 ) + SGN*TR( 1, 1 )
      BET = ABS( TAU1 )
      IF( BET.LE.SMLNUM ) THEN
         TAU1 = SMLNUM
         BET = SMLNUM
         INFO = 1
      END IF
*
      SCALE = ONE
      GAM = ABS( B( 1, 1 ) )
      IF( SMLNUM*GAM.GT.BET )
     $   SCALE = ONE / GAM
*
      X( 1, 1 ) = ( B( 1, 1 )*SCALE ) / TAU1
      XNORM = ABS( X( 1, 1 ) )
      RETURN
*
*     1 by 2:
*     TL11*[X11 X12] + ISGN*[X11 X12]*op[TR11 TR12]  = [B11 B12]
*                                       [TR21 TR22]
*
   20 CONTINUE
*
      SMIN = MAX( EPS*MAX( ABS( TL( 1, 1 ) ), ABS( TR( 1, 1 ) ),
     $       ABS( TR( 1, 2 ) ), ABS( TR( 2, 1 ) ), ABS( TR( 2, 2 ) ) ),
     $       SMLNUM )
      TMP( 1 ) = TL( 1, 1 ) + SGN*TR( 1, 1 )
      TMP( 4 ) = TL( 1, 1 ) + SGN*TR( 2, 2 )
      IF( LTRANR ) THEN
         TMP( 2 ) = SGN*TR( 2, 1 )
         TMP( 3 ) = SGN*TR( 1, 2 )
      ELSE
         TMP( 2 ) = SGN*TR( 1, 2 )
         TMP( 3 ) = SGN*TR( 2, 1 )
      END IF
      BTMP( 1 ) = B( 1, 1 )
      BTMP( 2 ) = B( 1, 2 )
      GO TO 40
*
*     2 by 1:
*          op[TL11 TL12]*[X11] + ISGN* [X11]*TR11  = [B11]
*            [TL21 TL22] [X21]         [X21]         [B21]
*
   30 CONTINUE
      SMIN = MAX( EPS*MAX( ABS( TR( 1, 1 ) ), ABS( TL( 1, 1 ) ),
     $       ABS( TL( 1, 2 ) ), ABS( TL( 2, 1 ) ), ABS( TL( 2, 2 ) ) ),
     $       SMLNUM )
      TMP( 1 ) = TL( 1, 1 ) + SGN*TR( 1, 1 )
      TMP( 4 ) = TL( 2, 2 ) + SGN*TR( 1, 1 )
      IF( LTRANL ) THEN
         TMP( 2 ) = TL( 1, 2 )
         TMP( 3 ) = TL( 2, 1 )
      ELSE
         TMP( 2 ) = TL( 2, 1 )
         TMP( 3 ) = TL( 1, 2 )
      END IF
      BTMP( 1 ) = B( 1, 1 )
      BTMP( 2 ) = B( 2, 1 )
   40 CONTINUE
*
*     Solve 2 by 2 system using complete pivoting.
*     Set pivots less than SMIN to SMIN.
*
      IPIV = ISAMAX( 4, TMP, 1 )
      U11 = TMP( IPIV )
      IF( ABS( U11 ).LE.SMIN ) THEN
         INFO = 1
         U11 = SMIN
      END IF
      U12 = TMP( LOCU12( IPIV ) )
      L21 = TMP( LOCL21( IPIV ) ) / U11
      U22 = TMP( LOCU22( IPIV ) ) - U12*L21
      XSWAP = XSWPIV( IPIV )
      BSWAP = BSWPIV( IPIV )
      IF( ABS( U22 ).LE.SMIN ) THEN
         INFO = 1
         U22 = SMIN
      END IF
      IF( BSWAP ) THEN
         TEMP = BTMP( 2 )
         BTMP( 2 ) = BTMP( 1 ) - L21*TEMP
         BTMP( 1 ) = TEMP
      ELSE
         BTMP( 2 ) = BTMP( 2 ) - L21*BTMP( 1 )
      END IF
      SCALE = ONE
      IF( ( TWO*SMLNUM )*ABS( BTMP( 2 ) ).GT.ABS( U22 ) .OR.
     $    ( TWO*SMLNUM )*ABS( BTMP( 1 ) ).GT.ABS( U11 ) ) THEN
         SCALE = HALF / MAX( ABS( BTMP( 1 ) ), ABS( BTMP( 2 ) ) )
         BTMP( 1 ) = BTMP( 1 )*SCALE
         BTMP( 2 ) = BTMP( 2 )*SCALE
      END IF
      X2( 2 ) = BTMP( 2 ) / U22
      X2( 1 ) = BTMP( 1 ) / U11 - ( U12 / U11 )*X2( 2 )
      IF( XSWAP ) THEN
         TEMP = X2( 2 )
         X2( 2 ) = X2( 1 )
         X2( 1 ) = TEMP
      END IF
      X( 1, 1 ) = X2( 1 )
      IF( N1.EQ.1 ) THEN
         X( 1, 2 ) = X2( 2 )
         XNORM = ABS( X( 1, 1 ) ) + ABS( X( 1, 2 ) )
      ELSE
         X( 2, 1 ) = X2( 2 )
         XNORM = MAX( ABS( X( 1, 1 ) ), ABS( X( 2, 1 ) ) )
      END IF
      RETURN
*
*     2 by 2:
*     op[TL11 TL12]*[X11 X12] +ISGN* [X11 X12]*op[TR11 TR12] = [B11 B12]
*       [TL21 TL22] [X21 X22]        [X21 X22]   [TR21 TR22]   [B21 B22]
*
*     Solve equivalent 4 by 4 system using complete pivoting.
*     Set pivots less than SMIN to SMIN.
*
   50 CONTINUE
      SMIN = MAX( ABS( TR( 1, 1 ) ), ABS( TR( 1, 2 ) ),
     $       ABS( TR( 2, 1 ) ), ABS( TR( 2, 2 ) ) )
      SMIN = MAX( SMIN, ABS( TL( 1, 1 ) ), ABS( TL( 1, 2 ) ),
     $       ABS( TL( 2, 1 ) ), ABS( TL( 2, 2 ) ) )
      SMIN = MAX( EPS*SMIN, SMLNUM )
      BTMP( 1 ) = ZERO
      CALL SCOPY( 16, BTMP, 0, T16, 1 )
      T16( 1, 1 ) = TL( 1, 1 ) + SGN*TR( 1, 1 )
      T16( 2, 2 ) = TL( 2, 2 ) + SGN*TR( 1, 1 )
      T16( 3, 3 ) = TL( 1, 1 ) + SGN*TR( 2, 2 )
      T16( 4, 4 ) = TL( 2, 2 ) + SGN*TR( 2, 2 )
      IF( LTRANL ) THEN
         T16( 1, 2 ) = TL( 2, 1 )
         T16( 2, 1 ) = TL( 1, 2 )
         T16( 3, 4 ) = TL( 2, 1 )
         T16( 4, 3 ) = TL( 1, 2 )
      ELSE
         T16( 1, 2 ) = TL( 1, 2 )
         T16( 2, 1 ) = TL( 2, 1 )
         T16( 3, 4 ) = TL( 1, 2 )
         T16( 4, 3 ) = TL( 2, 1 )
      END IF
      IF( LTRANR ) THEN
         T16( 1, 3 ) = SGN*TR( 1, 2 )
         T16( 2, 4 ) = SGN*TR( 1, 2 )
         T16( 3, 1 ) = SGN*TR( 2, 1 )
         T16( 4, 2 ) = SGN*TR( 2, 1 )
      ELSE
         T16( 1, 3 ) = SGN*TR( 2, 1 )
         T16( 2, 4 ) = SGN*TR( 2, 1 )
         T16( 3, 1 ) = SGN*TR( 1, 2 )
         T16( 4, 2 ) = SGN*TR( 1, 2 )
      END IF
      BTMP( 1 ) = B( 1, 1 )
      BTMP( 2 ) = B( 2, 1 )
      BTMP( 3 ) = B( 1, 2 )
      BTMP( 4 ) = B( 2, 2 )
*
*     Perform elimination
*
      DO 100 I = 1, 3
         XMAX = ZERO
         DO 70 IP = I, 4
            DO 60 JP = I, 4
               IF( ABS( T16( IP, JP ) ).GE.XMAX ) THEN
                  XMAX = ABS( T16( IP, JP ) )
                  IPSV = IP
                  JPSV = JP
               END IF
   60       CONTINUE
   70    CONTINUE
         IF( IPSV.NE.I ) THEN
            CALL SSWAP( 4, T16( IPSV, 1 ), 4, T16( I, 1 ), 4 )
            TEMP = BTMP( I )
            BTMP( I ) = BTMP( IPSV )
            BTMP( IPSV ) = TEMP
         END IF
         IF( JPSV.NE.I )
     $      CALL SSWAP( 4, T16( 1, JPSV ), 1, T16( 1, I ), 1 )
         JPIV( I ) = JPSV
         IF( ABS( T16( I, I ) ).LT.SMIN ) THEN
            INFO = 1
            T16( I, I ) = SMIN
         END IF
         DO 90 J = I + 1, 4
            T16( J, I ) = T16( J, I ) / T16( I, I )
            BTMP( J ) = BTMP( J ) - T16( J, I )*BTMP( I )
            DO 80 K = I + 1, 4
               T16( J, K ) = T16( J, K ) - T16( J, I )*T16( I, K )
   80       CONTINUE
   90    CONTINUE
  100 CONTINUE
      IF( ABS( T16( 4, 4 ) ).LT.SMIN )
     $   T16( 4, 4 ) = SMIN
      SCALE = ONE
      IF( ( EIGHT*SMLNUM )*ABS( BTMP( 1 ) ).GT.ABS( T16( 1, 1 ) ) .OR.
     $    ( EIGHT*SMLNUM )*ABS( BTMP( 2 ) ).GT.ABS( T16( 2, 2 ) ) .OR.
     $    ( EIGHT*SMLNUM )*ABS( BTMP( 3 ) ).GT.ABS( T16( 3, 3 ) ) .OR.
     $    ( EIGHT*SMLNUM )*ABS( BTMP( 4 ) ).GT.ABS( T16( 4, 4 ) ) ) THEN
         SCALE = ( ONE / EIGHT ) / MAX( ABS( BTMP( 1 ) ),
     $           ABS( BTMP( 2 ) ), ABS( BTMP( 3 ) ), ABS( BTMP( 4 ) ) )
         BTMP( 1 ) = BTMP( 1 )*SCALE
         BTMP( 2 ) = BTMP( 2 )*SCALE
         BTMP( 3 ) = BTMP( 3 )*SCALE
         BTMP( 4 ) = BTMP( 4 )*SCALE
      END IF
      DO 120 I = 1, 4
         K = 5 - I
         TEMP = ONE / T16( K, K )
         TMP( K ) = BTMP( K )*TEMP
         DO 110 J = K + 1, 4
            TMP( K ) = TMP( K ) - ( TEMP*T16( K, J ) )*TMP( J )
  110    CONTINUE
  120 CONTINUE
      DO 130 I = 1, 3
         IF( JPIV( 4-I ).NE.4-I ) THEN
            TEMP = TMP( 4-I )
            TMP( 4-I ) = TMP( JPIV( 4-I ) )
            TMP( JPIV( 4-I ) ) = TEMP
         END IF
  130 CONTINUE
      X( 1, 1 ) = TMP( 1 )
      X( 2, 1 ) = TMP( 2 )
      X( 1, 2 ) = TMP( 3 )
      X( 2, 2 ) = TMP( 4 )
      XNORM = MAX( ABS( TMP( 1 ) )+ABS( TMP( 3 ) ),
     $        ABS( TMP( 2 ) )+ABS( TMP( 4 ) ) )
      RETURN
*
*     End of SLASY2
*
      END

C
C	$Id: gmflod.f,v 1.5 2008-07-27 00:21:06 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GMFLOD(LIST,BITS,COUNT,GKSERR)
C
C  Load the bit string contiained in the low order part of each word
C  into the metafile.
C
C  INPUT
C    LIST  -- A list of words which have bit strings right justified.
C    BITS  -- The number of bits per word to move.
C    COUNT -- The repitition count (number of words in the list).

C  OUTPUT
C    GKSERR -- An error status.
C
C  All data is type integer unless otherwise indicated.
C
      IMPLICIT INTEGER (A-Z)
      DIMENSION LIST(*)
C
C  Common for metafile buffer.
C
      include 'g01prm.h'
      include 'g01io.h'
C
      DATA  ALLOK/0/
C
      IF (COUNT .LE. 0)  RETURN
      CTEMP = COUNT
      STRT = 1
C
C  Determine the number of packets of size BITS left in buffer.
C
   10 CONTINUE
      BLEFT = (MXBITS-MBFPOS)
      REPLFT = BLEFT/BITS
C
C  Compute how may packets to move into the buffer.
C
      IF (CTEMP .LE. REPLFT) THEN
C
C  Room for all.
C
        CMOVE = CTEMP
        CTEMP = 0
      ELSE
C
C  Not enough room for all bits.
C
        CMOVE = REPLFT
        CTEMP = CTEMP - REPLFT
      END IF
C
C  Move the current bit packets.
C
      CALL SBYTES(MOUTBF,LIST(STRT),MBFPOS,BITS,0,CMOVE)
      MBFPOS = MBFPOS + (BITS * CMOVE)
C
C  Check if more bit packets remain.
C
      IF (CTEMP .NE. 0) THEN
C
C  More remaining, flush the current buffer.
C
        CALL G01FLB(GKSERR)
        IF (GKSERR .NE. ALLOK) RETURN
        STRT = STRT + CMOVE
        GO TO 10
      END IF
C
      RETURN
      END

      PROGRAM AGEX03
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Define the data array.
C
      REAL YDRA(100,2)
C
C Initialize GKS.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Fill the data array.
C
      DO 101 I=1,100
        YDRA(I,1)=COS(3.14159265358979*REAL(I)/25.)*
     +                                    REAL(I)**2
        YDRA(I,2)=COS(3.14159265358979*REAL(I)/25.)*
     +                            10.**(.04*REAL(I))
  101 CONTINUE
C
C Draw a boundary around the edge of the plotter frame.
C
      CALL BNDARY
C
C Draw the graph, using EZMY.
C
      CALL EZMY (YDRA,100,2,100,'EXAMPLE 3 (EZMY)$')
C
C Close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
C
      END
      SUBROUTINE BNDARY
C
C Routine to draw the plotter-frame edge.
C
      CALL PLOTIT (    0,    0,0)
      CALL PLOTIT (32767,    0,1)
      CALL PLOTIT (32767,32767,1)
      CALL PLOTIT (    0,32767,1)
      CALL PLOTIT (    0,    0,1)
      RETURN
      END

C
C	$Id: csunif.f,v 1.5 2008-07-27 03:10:09 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CSUNIF (N,X,Y,Z,F,LIST,LPTR,LEND,IFLGS,SIGMA,
     .                 NROW,NI,NJ,PLAT,PLON,IFLGG, GRAD, FF,
     .                 IER)
      INTEGER N, LIST(*), LPTR(*), LEND(N), IFLGS, NROW, NI,
     .        NJ, IFLGG, IER
      DOUBLE PRECISION X(N), Y(N), Z(N), F(N), SIGMA(*),
     .                 PLAT(NI), PLON(NJ), GRAD(3,N),
     .                 FF(NROW,NJ)
C
C***********************************************************
C
C                                              From SSRFPACK
C                                            Robert J. Renka
C                                  Dept. of Computer Science
C                                       Univ. of North Texas
C                                           renka@cs.unt.edu
C                                                   07/25/96
C
C   Given a Delaunay triangulation of a set of nodes on the
C unit sphere, along with data values and tension factors
C associated with the triangulation arcs, this routine
C interpolates the data values to a uniform grid for such
C applications as contouring.  The interpolant is once con-
C tinuously differentiable.  Extrapolation is performed at
C grid points exterior to the triangulation when the nodes
C do not cover the entire sphere.
C
C On input:
C
C       N = Number of nodes.  N .GE. 3 and N .GE. 7 if
C           IFLAG .NE. 1.
C
C       X,Y,Z = Arrays containing Cartesian coordinates of
C               the nodes.  X(I)**2 + Y(I)**2 + Z(I)**2 = 1
C               for I = 1 to N.
C
C       F = Array containing data values.  F(I) is associ-
C           ated with (X(I),Y(I),Z(I)).
C
C       LIST,LPTR,LEND = Data structure defining the trian-
C                        gulation.  Refer to STRIPACK
C                        Subroutine CSTRMESH.
C
C       IFLGS = Tension factor option:
C               IFLGS .LE. 0 if a single uniform tension
C                            factor is to be used.
C               IFLGS .GE. 1 if variable tension is desired.
C
C       SIGMA = Uniform tension factor (IFLGS .LE. 0), or
C               array containing tension factors associated
C               with arcs in one-to-one correspondence with
C               LIST entries (IFLGS .GE. 1).  Refer to Sub-
C               programs CSGETSIG, CSSIG0, CSSIG1, and CSSIG2.
C
C       NROW = Number of rows in the dimension statement of
C              FF.
C
C       NI,NJ = Number of rows and columns in the uniform
C               grid.  1 .LE. NI .LE. NROW and 1 .LE. NJ.
C
C       PLAT,PLON = Arrays of length NI and NJ, respective-
C                   ly, containing the latitudes and
C                   longitudes of the grid lines.
C
C       IFLGG = Option indicator:
C               IFLGG = 0 if gradient estimates at the ver-
C                         tices of a triangle are to be
C                         recomputed for each grid point in
C                         the triangle and not saved.
C               IFLGG = 1 if gradient estimates are input in
C                         GRAD.
C               IFLGG = 2 if gradient estimates are to be
C                         computed once for each node (by
C                         CSGRADL) and saved in GRAD.
C
C The above parameters are not altered by this routine.
C
C       GRAD = 3 by N array whose columns contain the X, Y,
C              and Z components (in that order) of the grad-
C              ients at the nodes if IFLGG = 1, array of
C              sufficient size if IFLGG = 2, or dummy para-
C              meter if IFLGG = 0.
C
C Gradient estimates may be computed by Subroutines CSGRADL or
C   CSGRADG if IFLGG = 1.
C
C       FF = NROW by NCOL array with NROW .GE. NI and NCOL
C            .GE. NJ.
C
C On output:
C
C       GRAD = Array containing estimated gradients as de-
C              fined above if IFLGG = 2 and IER .GE. 0.
C              GRAD is not altered if IFLGG .NE. 2.
C
C       FF = Interpolated values at the grid points if IER
C            .GE. 0.  FF(I,J) = F(PLAT(I),PLON(J)) for I =
C            1,...,NI and J = 1,...,NJ.
C
C       IER = Error indicator:
C             IER = K if no errors were encountered and K
C                     grid points required extrapolation for
C                     K .GE. 0.
C             IER = -1 if N, NI, NJ, or IFLGG is outside its
C                      valid range.
C             IER = -2 if the nodes are collinear.
C             IER = -3 if extrapolation failed due to the
C                      uniform grid extending too far beyond
C                      the triangulation boundary.
C
C STRIPACK modules required by CSUNIF:  CSGETNP, CSJRAND, CSLSTPTR,
C                                       CSSTORE, CSTRFIND
C
C SSRFPACK modules required by CSUNIF:  CSAPLYR, CSAPLYRT, CSARCINT,
C                                       CSARCLEN, CSCONSTR,
C                                       CSFVAL, CSGIVENS, CSGRADL,
C                                       CSHVAL, CSINTRC1,
C                                       CSROTATE, CSSETUP,
C                                       CSSNHCSH
C
C***********************************************************
C
      INTEGER I, J, IERR, IFL, IST, NEX, NN, NST, NX, NY
      DATA    NST/1/
C
C Local parameters:
C
C I,J =   DO-loop indexes
C IERR =  Error flag for calls to CSGRADL and CSINTRC1
C IFL =   Local copy of IFLGG
C IST =   Parameter for CSINTRC1
C NEX =   Number of grid points exterior to the triangula-
C           tion boundary (number of extrapolated values)
C NN =    Local copy of N
C NST =   Initial value for IST
C NX,NY = Local copies of NI and NJ
C
      NN = N
      NX = NI
      NY = NJ
      IFL = IFLGG
      IF (NX .LT. 1  .OR.  NX .GT. NROW  .OR.  NY .LT. 1
     .   .OR.  IFL .LT. 0  .OR.  IFL .GT. 2) GO TO 4
      IST = NST
      IF (IFL .EQ. 2) THEN
C
C Compute gradient estimates at the nodes.
C
        DO 1 I = 1,NN
          CALL CSGRADL (NN,I,X,Y,Z,F,LIST,LPTR,
     .                LEND, GRAD(1,I),IERR)
          IF (IERR .LT. 0) GO TO 5
    1     CONTINUE
        IFL = 1
      ENDIF
C
C Compute uniform grid points and interpolated values.
C
      NEX = 0
      DO 3 J = 1,NY
        DO 2 I = 1,NX
          CALL CSINTRC1 (NN,PLAT(I),PLON(J),X,Y,Z,F,LIST,LPTR,
     .                 LEND,IFLGS,SIGMA,IFL,
     .                 GRAD, IST, FF(I,J),IERR)
          IF (IERR .LT. 0) GO TO 5
          NEX = NEX + IERR
    2     CONTINUE
    3   CONTINUE
      IER = NEX
      RETURN
C
C NI, NJ, or IFLGG is outside its valid range.
C
    4 IER = -1
      RETURN
C
C Error in CSGRADL or CSINTRC1.
C
    5 IER = IERR
      RETURN
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C   FFTPACK 5.0
C   Copyright (C) 1995-2004, Scientific Computing Division,
C   University Corporation for Atmospheric Research
C   Licensed under the GNU General Public License (GPL)
C
C   Authors:  Paul N. Swarztrauber and Richard A. Valent
C
C   $Id: sintf1.f,v 1.2 2006-11-21 01:10:20 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      SUBROUTINE DSINTF1(N,INC,X,WSAVE,XH,WORK,IER)
      DOUBLE PRECISION WORK
      DOUBLE PRECISION SSQRT3
      DOUBLE PRECISION XHOLD
      DOUBLE PRECISION T1
      DOUBLE PRECISION T2
      DOUBLE PRECISION SFNP1
      DOUBLE PRECISION X(INC,*),WSAVE(*),XH(*)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION DSUM

      IER = 0
      IF (N-2) 200,102,103
  102 SSQRT3 = 1.D0/SQRT(3.D0)
      XHOLD = SSQRT3* (X(1,1)+X(1,2))
      X(1,2) = SSQRT3* (X(1,1)-X(1,2))
      X(1,1) = XHOLD
      GO TO 200
  103 NP1 = N + 1
      NS2 = N/2
      DO 104 K = 1,NS2
          KC = NP1 - K
          T1 = X(1,K) - X(1,KC)
          T2 = WSAVE(K)* (X(1,K)+X(1,KC))
          XH(K+1) = T1 + T2
          XH(KC+1) = T2 - T1
  104 CONTINUE
      MODN = MOD(N,2)
      IF (MODN.EQ.0) GO TO 124
      XH(NS2+2) = 4.D0*X(1,NS2+1)
  124 XH(1) = 0.D0
      LNXH = NP1
      LNSV = NP1 + INT(LOG(DBLE(NP1))) + 4
      LNWK = NP1
C
      CALL DRFFT1F(NP1,1,XH,LNXH,WSAVE(NS2+1),LNSV,WORK,LNWK,IER1)
      IF (IER1.NE.0) THEN
          IER = 20
          CALL DXERFFT('SINTF1',-5)
          GO TO 200
      END IF
C
      IF (MOD(NP1,2).NE.0) GO TO 30
      XH(NP1) = XH(NP1) + XH(NP1)
   30 SFNP1 = 1.D0/DBLE(NP1)
      X(1,1) = .5D0*XH(1)
      DSUM = X(1,1)
      DO 105 I = 3,N,2
          X(1,I-1) = .5D0*XH(I)
          DSUM = DSUM + .5D0*XH(I-1)
          X(1,I) = DSUM
  105 CONTINUE
      IF (MODN.NE.0) GO TO 200
      X(1,N) = .5D0*XH(N+1)
  200 RETURN
      END

      SUBROUTINE ZLAIC1( JOB, J, X, SEST, W, GAMMA, SESTPR, S, C )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      INTEGER            J, JOB
      DOUBLE PRECISION   SEST, SESTPR
      COMPLEX*16         C, GAMMA, S
*     ..
*     .. Array Arguments ..
      COMPLEX*16         W( J ), X( J )
*     ..
*
*  Purpose
*  =======
*
*  ZLAIC1 applies one step of incremental condition estimation in
*  its simplest version:
*
*  Let x, twonorm(x) = 1, be an approximate singular vector of an j-by-j
*  lower triangular matrix L, such that
*           twonorm(L*x) = sest
*  Then ZLAIC1 computes sestpr, s, c such that
*  the vector
*                  [ s*x ]
*           xhat = [  c  ]
*  is an approximate singular vector of
*                  [ L     0  ]
*           Lhat = [ w' gamma ]
*  in the sense that
*           twonorm(Lhat*xhat) = sestpr.
*
*  Depending on JOB, an estimate for the largest or smallest singular
*  value is computed.
*
*  Note that [s c]' and sestpr**2 is an eigenpair of the system
*
*      diag(sest*sest, 0) + [alpha  gamma] * [ conjg(alpha) ]
*                                            [ conjg(gamma) ]
*
*  where  alpha =  conjg(x)'*w.
*
*  Arguments
*  =========
*
*  JOB     (input) INTEGER
*          = 1: an estimate for the largest singular value is computed.
*          = 2: an estimate for the smallest singular value is computed.
*
*  J       (input) INTEGER
*          Length of X and W
*
*  X       (input) COMPLEX*16 array, dimension (J)
*          The j-vector x.
*
*  SEST    (input) DOUBLE PRECISION
*          Estimated singular value of j by j matrix L
*
*  W       (input) COMPLEX*16 array, dimension (J)
*          The j-vector w.
*
*  GAMMA   (input) COMPLEX*16
*          The diagonal element gamma.
*
*  SESTPR  (output) DOUBLE PRECISION
*          Estimated singular value of (j+1) by (j+1) matrix Lhat.
*
*  S       (output) COMPLEX*16
*          Sine needed in forming xhat.
*
*  C       (output) COMPLEX*16
*          Cosine needed in forming xhat.
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO, ONE, TWO
      PARAMETER          ( ZERO = 0.0D0, ONE = 1.0D0, TWO = 2.0D0 )
      DOUBLE PRECISION   HALF, FOUR
      PARAMETER          ( HALF = 0.5D0, FOUR = 4.0D0 )
*     ..
*     .. Local Scalars ..
      DOUBLE PRECISION   ABSALP, ABSEST, ABSGAM, B, EPS, NORMA, S1, S2,
     $                   SCL, T, TEST, TMP, ZETA1, ZETA2
      COMPLEX*16         ALPHA, COSINE, SINE
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, DCONJG, MAX, SQRT
*     ..
*     .. External Functions ..
      DOUBLE PRECISION   DLAMCH
      COMPLEX*16         ZDOTC
      EXTERNAL           DLAMCH, ZDOTC
*     ..
*     .. Executable Statements ..
*
      EPS = DLAMCH( 'Epsilon' )
      ALPHA = ZDOTC( J, X, 1, W, 1 )
*
      ABSALP = ABS( ALPHA )
      ABSGAM = ABS( GAMMA )
      ABSEST = ABS( SEST )
*
      IF( JOB.EQ.1 ) THEN
*
*        Estimating largest singular value
*
*        special cases
*
         IF( SEST.EQ.ZERO ) THEN
            S1 = MAX( ABSGAM, ABSALP )
            IF( S1.EQ.ZERO ) THEN
               S = ZERO
               C = ONE
               SESTPR = ZERO
            ELSE
               S = ALPHA / S1
               C = GAMMA / S1
               TMP = SQRT( S*DCONJG( S )+C*DCONJG( C ) )
               S = S / TMP
               C = C / TMP
               SESTPR = S1*TMP
            END IF
            RETURN
         ELSE IF( ABSGAM.LE.EPS*ABSEST ) THEN
            S = ONE
            C = ZERO
            TMP = MAX( ABSEST, ABSALP )
            S1 = ABSEST / TMP
            S2 = ABSALP / TMP
            SESTPR = TMP*SQRT( S1*S1+S2*S2 )
            RETURN
         ELSE IF( ABSALP.LE.EPS*ABSEST ) THEN
            S1 = ABSGAM
            S2 = ABSEST
            IF( S1.LE.S2 ) THEN
               S = ONE
               C = ZERO
               SESTPR = S2
            ELSE
               S = ZERO
               C = ONE
               SESTPR = S1
            END IF
            RETURN
         ELSE IF( ABSEST.LE.EPS*ABSALP .OR. ABSEST.LE.EPS*ABSGAM ) THEN
            S1 = ABSGAM
            S2 = ABSALP
            IF( S1.LE.S2 ) THEN
               TMP = S1 / S2
               SCL = SQRT( ONE+TMP*TMP )
               SESTPR = S2*SCL
               S = ( ALPHA / S2 ) / SCL
               C = ( GAMMA / S2 ) / SCL
            ELSE
               TMP = S2 / S1
               SCL = SQRT( ONE+TMP*TMP )
               SESTPR = S1*SCL
               S = ( ALPHA / S1 ) / SCL
               C = ( GAMMA / S1 ) / SCL
            END IF
            RETURN
         ELSE
*
*           normal case
*
            ZETA1 = ABSALP / ABSEST
            ZETA2 = ABSGAM / ABSEST
*
            B = ( ONE-ZETA1*ZETA1-ZETA2*ZETA2 )*HALF
            C = ZETA1*ZETA1
            IF( B.GT.ZERO ) THEN
               T = C / ( B+SQRT( B*B+C ) )
            ELSE
               T = SQRT( B*B+C ) - B
            END IF
*
            SINE = -( ALPHA / ABSEST ) / T
            COSINE = -( GAMMA / ABSEST ) / ( ONE+T )
            TMP = SQRT( SINE*DCONJG( SINE )+COSINE*DCONJG( COSINE ) )
            S = SINE / TMP
            C = COSINE / TMP
            SESTPR = SQRT( T+ONE )*ABSEST
            RETURN
         END IF
*
      ELSE IF( JOB.EQ.2 ) THEN
*
*        Estimating smallest singular value
*
*        special cases
*
         IF( SEST.EQ.ZERO ) THEN
            SESTPR = ZERO
            IF( MAX( ABSGAM, ABSALP ).EQ.ZERO ) THEN
               SINE = ONE
               COSINE = ZERO
            ELSE
               SINE = -DCONJG( GAMMA )
               COSINE = DCONJG( ALPHA )
            END IF
            S1 = MAX( ABS( SINE ), ABS( COSINE ) )
            S = SINE / S1
            C = COSINE / S1
            TMP = SQRT( S*DCONJG( S )+C*DCONJG( C ) )
            S = S / TMP
            C = C / TMP
            RETURN
         ELSE IF( ABSGAM.LE.EPS*ABSEST ) THEN
            S = ZERO
            C = ONE
            SESTPR = ABSGAM
            RETURN
         ELSE IF( ABSALP.LE.EPS*ABSEST ) THEN
            S1 = ABSGAM
            S2 = ABSEST
            IF( S1.LE.S2 ) THEN
               S = ZERO
               C = ONE
               SESTPR = S1
            ELSE
               S = ONE
               C = ZERO
               SESTPR = S2
            END IF
            RETURN
         ELSE IF( ABSEST.LE.EPS*ABSALP .OR. ABSEST.LE.EPS*ABSGAM ) THEN
            S1 = ABSGAM
            S2 = ABSALP
            IF( S1.LE.S2 ) THEN
               TMP = S1 / S2
               SCL = SQRT( ONE+TMP*TMP )
               SESTPR = ABSEST*( TMP / SCL )
               S = -( DCONJG( GAMMA ) / S2 ) / SCL
               C = ( DCONJG( ALPHA ) / S2 ) / SCL
            ELSE
               TMP = S2 / S1
               SCL = SQRT( ONE+TMP*TMP )
               SESTPR = ABSEST / SCL
               S = -( DCONJG( GAMMA ) / S1 ) / SCL
               C = ( DCONJG( ALPHA ) / S1 ) / SCL
            END IF
            RETURN
         ELSE
*
*           normal case
*
            ZETA1 = ABSALP / ABSEST
            ZETA2 = ABSGAM / ABSEST
*
            NORMA = MAX( ONE+ZETA1*ZETA1+ZETA1*ZETA2,
     $              ZETA1*ZETA2+ZETA2*ZETA2 )
*
*           See if root is closer to zero or to ONE
*
            TEST = ONE + TWO*( ZETA1-ZETA2 )*( ZETA1+ZETA2 )
            IF( TEST.GE.ZERO ) THEN
*
*              root is close to zero, compute directly
*
               B = ( ZETA1*ZETA1+ZETA2*ZETA2+ONE )*HALF
               C = ZETA2*ZETA2
               T = C / ( B+SQRT( ABS( B*B-C ) ) )
               SINE = ( ALPHA / ABSEST ) / ( ONE-T )
               COSINE = -( GAMMA / ABSEST ) / T
               SESTPR = SQRT( T+FOUR*EPS*EPS*NORMA )*ABSEST
            ELSE
*
*              root is closer to ONE, shift by that amount
*
               B = ( ZETA2*ZETA2+ZETA1*ZETA1-ONE )*HALF
               C = ZETA1*ZETA1
               IF( B.GE.ZERO ) THEN
                  T = -C / ( B+SQRT( B*B+C ) )
               ELSE
                  T = B - SQRT( B*B+C )
               END IF
               SINE = -( ALPHA / ABSEST ) / T
               COSINE = -( GAMMA / ABSEST ) / ( ONE+T )
               SESTPR = SQRT( ONE+T+FOUR*EPS*EPS*NORMA )*ABSEST
            END IF
            TMP = SQRT( SINE*DCONJG( SINE )+COSINE*DCONJG( COSINE ) )
            S = SINE / TMP
            C = COSINE / TMP
            RETURN
*
         END IF
      END IF
      RETURN
*
*     End of ZLAIC1
*
      END

      SUBROUTINE ZLAGS2( UPPER, A1, A2, A3, B1, B2, B3, CSU, SNU, CSV,
     $                   SNV, CSQ, SNQ )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      LOGICAL            UPPER
      DOUBLE PRECISION   A1, A3, B1, B3, CSQ, CSU, CSV
      COMPLEX*16         A2, B2, SNQ, SNU, SNV
*     ..
*
*  Purpose
*  =======
*
*  ZLAGS2 computes 2-by-2 unitary matrices U, V and Q, such
*  that if ( UPPER ) then
*
*            U'*A*Q = U'*( A1 A2 )*Q = ( x  0  )
*                        ( 0  A3 )     ( x  x  )
*  and
*            V'*B*Q = V'*( B1 B2 )*Q = ( x  0  )
*                        ( 0  B3 )     ( x  x  )
*
*  or if ( .NOT.UPPER ) then
*
*            U'*A*Q = U'*( A1 0  )*Q = ( x  x  )
*                        ( A2 A3 )     ( 0  x  )
*  and
*            V'*B*Q = V'*( B1 0  )*Q = ( x  x  )
*                        ( B2 B3 )     ( 0  x  )
*  where
*
*    U = (     CSU      SNU ), V = (     CSV     SNV ),
*        ( -CONJG(SNU)  CSU )      ( -CONJG(SNV) CSV )
*
*    Q = (     CSQ      SNQ )
*        ( -CONJG(SNQ)  CSQ )
*
*  Z' denotes the conjugate transpose of Z.
*
*  The rows of the transformed A and B are parallel. Moreover, if the
*  input 2-by-2 matrix A is not zero, then the transformed (1,1) entry
*  of A is not zero. If the input matrices A and B are both not zero,
*  then the transformed (2,2) element of B is not zero, except when the
*  first rows of input A and B are parallel and the second rows are
*  zero.
*
*  Arguments
*  =========
*
*  UPPER   (input) LOGICAL
*          = .TRUE.: the input matrices A and B are upper triangular.
*          = .FALSE.: the input matrices A and B are lower triangular.
*
*  A1      (input) DOUBLE PRECISION
*  A2      (input) COMPLEX*16
*  A3      (input) DOUBLE PRECISION
*          On entry, A1, A2 and A3 are elements of the input 2-by-2
*          upper (lower) triangular matrix A.
*
*  B1      (input) DOUBLE PRECISION
*  B2      (input) COMPLEX*16
*  B3      (input) DOUBLE PRECISION
*          On entry, B1, B2 and B3 are elements of the input 2-by-2
*          upper (lower) triangular matrix B.
*
*  CSU     (output) DOUBLE PRECISION
*  SNU     (output) COMPLEX*16
*          The desired unitary matrix U.
*
*  CSV     (output) DOUBLE PRECISION
*  SNV     (output) COMPLEX*16
*          The desired unitary matrix V.
*
*  CSQ     (output) DOUBLE PRECISION
*  SNQ     (output) COMPLEX*16
*          The desired unitary matrix Q.
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO, ONE
      PARAMETER          ( ZERO = 0.0D+0, ONE = 1.0D+0 )
*     ..
*     .. Local Scalars ..
      DOUBLE PRECISION   A, AUA11, AUA12, AUA21, AUA22, AVB12, AVB11, 
     $                   AVB21, AVB22, CSL, CSR, D, FB, FC, S1, S2, 
     $                   SNL, SNR, UA11R, UA22R, VB11R, VB22R
      COMPLEX*16         B, C, D1, R, T, UA11, UA12, UA21, UA22, VB11,
     $                   VB12, VB21, VB22
*     ..
*     .. External Subroutines ..
      EXTERNAL           DLASV2, ZLARTG
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, DBLE, DCMPLX, DCONJG, DIMAG
*     ..
*     .. Statement Functions ..
      DOUBLE PRECISION   ABS1
*     ..
*     .. Statement Function definitions ..
      ABS1( T ) = ABS( DBLE( T ) ) + ABS( DIMAG( T ) )
*     ..
*     .. Executable Statements ..
*
      IF( UPPER ) THEN
*
*        Input matrices A and B are upper triangular matrices
*
*        Form matrix C = A*adj(B) = ( a b )
*                                   ( 0 d )
*
         A = A1*B3
         D = A3*B1
         B = A2*B1 - A1*B2
         FB = ABS( B )
*
*        Transform complex 2-by-2 matrix C to real matrix by unitary
*        diagonal matrix diag(1,D1).
*
         D1 = ONE
         IF( FB.NE.ZERO )
     $      D1 = B / FB
*
*        The SVD of real 2 by 2 triangular C
*
*         ( CSL -SNL )*( A B )*(  CSR  SNR ) = ( R 0 )
*         ( SNL  CSL ) ( 0 D ) ( -SNR  CSR )   ( 0 T )
*
         CALL DLASV2( A, FB, D, S1, S2, SNR, CSR, SNL, CSL )
*
         IF( ABS( CSL ).GE.ABS( SNL ) .OR. ABS( CSR ).GE.ABS( SNR ) )
     $        THEN
*
*           Compute the (1,1) and (1,2) elements of U'*A and V'*B,
*           and (1,2) element of |U|'*|A| and |V|'*|B|.
*
            UA11R = CSL*A1
            UA12 = CSL*A2 + D1*SNL*A3
*
            VB11R = CSR*B1
            VB12 = CSR*B2 + D1*SNR*B3
*
            AUA12 = ABS( CSL )*ABS1( A2 ) + ABS( SNL )*ABS( A3 )
            AVB12 = ABS( CSR )*ABS1( B2 ) + ABS( SNR )*ABS( B3 )
*
*           zero (1,2) elements of U'*A and V'*B
*
            IF( ( ABS( UA11R )+ABS1( UA12 ) ).EQ.ZERO ) THEN
               CALL ZLARTG( -DCMPLX( VB11R ), DCONJG( VB12 ), CSQ, SNQ,
     $                      R )
            ELSE IF( ( ABS( VB11R )+ABS1( VB12 ) ).EQ.ZERO ) THEN
               CALL ZLARTG( -DCMPLX( UA11R ), DCONJG( UA12 ), CSQ, SNQ,
     $                      R )
            ELSE IF( AUA12 / ( ABS( UA11R )+ABS1( UA12 ) ).LE.AVB12 /
     $               ( ABS( VB11R )+ABS1( VB12 ) ) ) THEN
               CALL ZLARTG( -DCMPLX( UA11R ), DCONJG( UA12 ), CSQ, SNQ,
     $                      R )
            ELSE
               CALL ZLARTG( -DCMPLX( VB11R ), DCONJG( VB12 ), CSQ, SNQ,
     $                      R )
            END IF
*
            CSU = CSL
            SNU = -D1*SNL
            CSV = CSR
            SNV = -D1*SNR
*
         ELSE
*
*           Compute the (2,1) and (2,2) elements of U'*A and V'*B,
*           and (2,2) element of |U|'*|A| and |V|'*|B|.
*
            UA21 = -DCONJG( D1 )*SNL*A1
            UA22 = -DCONJG( D1 )*SNL*A2 + CSL*A3
*
            VB21 = -DCONJG( D1 )*SNR*B1
            VB22 = -DCONJG( D1 )*SNR*B2 + CSR*B3
*
            AUA22 = ABS( SNL )*ABS1( A2 ) + ABS( CSL )*ABS( A3 )
            AVB22 = ABS( SNR )*ABS1( B2 ) + ABS( CSR )*ABS( B3 )
*
*           zero (2,2) elements of U'*A and V'*B, and then swap.
*
            IF( ( ABS1( UA21 )+ABS1( UA22 ) ).EQ.ZERO ) THEN
               CALL ZLARTG( -DCONJG( VB21 ), DCONJG( VB22 ), CSQ, SNQ,
     $                      R )
            ELSE IF( ( ABS1( VB21 )+ABS( VB22 ) ).EQ.ZERO ) THEN
               CALL ZLARTG( -DCONJG( UA21 ), DCONJG( UA22 ), CSQ, SNQ,
     $                      R )
            ELSE IF( AUA22 / ( ABS1( UA21 )+ABS1( UA22 ) ).LE.AVB22 /
     $               ( ABS1( VB21 )+ABS1( VB22 ) ) ) THEN
               CALL ZLARTG( -DCONJG( UA21 ), DCONJG( UA22 ), CSQ, SNQ,
     $                      R )
            ELSE
               CALL ZLARTG( -DCONJG( VB21 ), DCONJG( VB22 ), CSQ, SNQ,
     $                      R )
            END IF
*
            CSU = SNL
            SNU = D1*CSL
            CSV = SNR
            SNV = D1*CSR
*
         END IF
*
      ELSE
*
*        Input matrices A and B are lower triangular matrices
*
*        Form matrix C = A*adj(B) = ( a 0 )
*                                   ( c d )
*
         A = A1*B3
         D = A3*B1
         C = A2*B3 - A3*B2
         FC = ABS( C )
*
*        Transform complex 2-by-2 matrix C to real matrix by unitary
*        diagonal matrix diag(d1,1).
*
         D1 = ONE
         IF( FC.NE.ZERO )
     $      D1 = C / FC
*
*        The SVD of real 2 by 2 triangular C
*
*         ( CSL -SNL )*( A 0 )*(  CSR  SNR ) = ( R 0 )
*         ( SNL  CSL ) ( C D ) ( -SNR  CSR )   ( 0 T )
*
         CALL DLASV2( A, FC, D, S1, S2, SNR, CSR, SNL, CSL )
*
         IF( ABS( CSR ).GE.ABS( SNR ) .OR. ABS( CSL ).GE.ABS( SNL ) )
     $        THEN
*
*           Compute the (2,1) and (2,2) elements of U'*A and V'*B,
*           and (2,1) element of |U|'*|A| and |V|'*|B|.
*
            UA21 = -D1*SNR*A1 + CSR*A2
            UA22R = CSR*A3
*
            VB21 = -D1*SNL*B1 + CSL*B2
            VB22R = CSL*B3
*
            AUA21 = ABS( SNR )*ABS( A1 ) + ABS( CSR )*ABS1( A2 )
            AVB21 = ABS( SNL )*ABS( B1 ) + ABS( CSL )*ABS1( B2 )
*
*           zero (2,1) elements of U'*A and V'*B.
*
            IF( ( ABS1( UA21 )+ABS( UA22R ) ).EQ.ZERO ) THEN
               CALL ZLARTG( DCMPLX( VB22R ), VB21, CSQ, SNQ, R )
            ELSE IF( ( ABS1( VB21 )+ABS( VB22R ) ).EQ.ZERO ) THEN
               CALL ZLARTG( DCMPLX( UA22R ), UA21, CSQ, SNQ, R )
            ELSE IF( AUA21 / ( ABS1( UA21 )+ABS( UA22R ) ).LE.AVB21 /
     $               ( ABS1( VB21 )+ABS( VB22R ) ) ) THEN
               CALL ZLARTG( DCMPLX( UA22R ), UA21, CSQ, SNQ, R )
            ELSE
               CALL ZLARTG( DCMPLX( VB22R ), VB21, CSQ, SNQ, R )
            END IF
*
            CSU = CSR
            SNU = -DCONJG( D1 )*SNR
            CSV = CSL
            SNV = -DCONJG( D1 )*SNL
*
         ELSE
*
*           Compute the (1,1) and (1,2) elements of U'*A and V'*B,
*           and (1,1) element of |U|'*|A| and |V|'*|B|.
*
            UA11 = CSR*A1 + DCONJG( D1 )*SNR*A2
            UA12 = DCONJG( D1 )*SNR*A3
*
            VB11 = CSL*B1 + DCONJG( D1 )*SNL*B2
            VB12 = DCONJG( D1 )*SNL*B3
*
            AUA11 = ABS( CSR )*ABS( A1 ) + ABS( SNR )*ABS1( A2 )
            AVB11 = ABS( CSL )*ABS( B1 ) + ABS( SNL )*ABS1( B2 )
*
*           zero (1,1) elements of U'*A and V'*B, and then swap.
*
            IF( ( ABS1( UA11 )+ABS1( UA12 ) ).EQ.ZERO ) THEN
               CALL ZLARTG( VB12, VB11, CSQ, SNQ, R )
            ELSE IF( ( ABS1( VB11 )+ABS1( VB12 ) ).EQ.ZERO ) THEN
               CALL ZLARTG( UA12, UA11, CSQ, SNQ, R )
            ELSE IF( AUA11 / ( ABS1( UA11 )+ABS1( UA12 ) ).LE.AVB11 /
     $               ( ABS1( VB11 )+ABS1( VB12 ) ) ) THEN
               CALL ZLARTG( UA12, UA11, CSQ, SNQ, R )
            ELSE
               CALL ZLARTG( VB12, VB11, CSQ, SNQ, R )
            END IF
*
            CSU = SNR
            SNU = DCONJG( D1 )*CSR
            CSV = SNL
            SNV = DCONJG( D1 )*CSL
*
         END IF
*
      END IF
*
      RETURN
*
*     End of ZLAGS2
*
      END

      SUBROUTINE SSYTD2( UPLO, N, A, LDA, D, E, TAU, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     October 31, 1992
*
*     .. Scalar Arguments ..
      CHARACTER          UPLO
      INTEGER            INFO, LDA, N
*     ..
*     .. Array Arguments ..
      REAL               A( LDA, * ), D( * ), E( * ), TAU( * )
*     ..
*
*  Purpose
*  =======
*
*  SSYTD2 reduces a real symmetric matrix A to symmetric tridiagonal
*  form T by an orthogonal similarity transformation: Q' * A * Q = T.
*
*  Arguments
*  =========
*
*  UPLO    (input) CHARACTER*1
*          Specifies whether the upper or lower triangular part of the
*          symmetric matrix A is stored:
*          = 'U':  Upper triangular
*          = 'L':  Lower triangular
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  A       (input/output) REAL array, dimension (LDA,N)
*          On entry, the symmetric matrix A.  If UPLO = 'U', the leading
*          n-by-n upper triangular part of A contains the upper
*          triangular part of the matrix A, and the strictly lower
*          triangular part of A is not referenced.  If UPLO = 'L', the
*          leading n-by-n lower triangular part of A contains the lower
*          triangular part of the matrix A, and the strictly upper
*          triangular part of A is not referenced.
*          On exit, if UPLO = 'U', the diagonal and first superdiagonal
*          of A are overwritten by the corresponding elements of the
*          tridiagonal matrix T, and the elements above the first
*          superdiagonal, with the array TAU, represent the orthogonal
*          matrix Q as a product of elementary reflectors; if UPLO
*          = 'L', the diagonal and first subdiagonal of A are over-
*          written by the corresponding elements of the tridiagonal
*          matrix T, and the elements below the first subdiagonal, with
*          the array TAU, represent the orthogonal matrix Q as a product
*          of elementary reflectors. See Further Details.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(1,N).
*
*  D       (output) REAL array, dimension (N)
*          The diagonal elements of the tridiagonal matrix T:
*          D(i) = A(i,i).
*
*  E       (output) REAL array, dimension (N-1)
*          The off-diagonal elements of the tridiagonal matrix T:
*          E(i) = A(i,i+1) if UPLO = 'U', E(i) = A(i+1,i) if UPLO = 'L'.
*
*  TAU     (output) REAL array, dimension (N-1)
*          The scalar factors of the elementary reflectors (see Further
*          Details).
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value.
*
*  Further Details
*  ===============
*
*  If UPLO = 'U', the matrix Q is represented as a product of elementary
*  reflectors
*
*     Q = H(n-1) . . . H(2) H(1).
*
*  Each H(i) has the form
*
*     H(i) = I - tau * v * v'
*
*  where tau is a real scalar, and v is a real vector with
*  v(i+1:n) = 0 and v(i) = 1; v(1:i-1) is stored on exit in
*  A(1:i-1,i+1), and tau in TAU(i).
*
*  If UPLO = 'L', the matrix Q is represented as a product of elementary
*  reflectors
*
*     Q = H(1) H(2) . . . H(n-1).
*
*  Each H(i) has the form
*
*     H(i) = I - tau * v * v'
*
*  where tau is a real scalar, and v is a real vector with
*  v(1:i) = 0 and v(i+1) = 1; v(i+2:n) is stored on exit in A(i+2:n,i),
*  and tau in TAU(i).
*
*  The contents of A on exit are illustrated by the following examples
*  with n = 5:
*
*  if UPLO = 'U':                       if UPLO = 'L':
*
*    (  d   e   v2  v3  v4 )              (  d                  )
*    (      d   e   v3  v4 )              (  e   d              )
*    (          d   e   v4 )              (  v1  e   d          )
*    (              d   e  )              (  v1  v2  e   d      )
*    (                  d  )              (  v1  v2  v3  e   d  )
*
*  where d and e denote diagonal and off-diagonal elements of T, and vi
*  denotes an element of the vector defining H(i).
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ONE, ZERO, HALF
      PARAMETER          ( ONE = 1.0, ZERO = 0.0, HALF = 1.0 / 2.0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            UPPER
      INTEGER            I
      REAL               ALPHA, TAUI
*     ..
*     .. External Subroutines ..
      EXTERNAL           SAXPY, SLARFG, SSYMV, SSYR2, XERBLA
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      REAL               SDOT
      EXTERNAL           LSAME, SDOT
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters
*
      INFO = 0
      UPPER = LSAME( UPLO, 'U' )
      IF( .NOT.UPPER .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -4
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'SSYTD2', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.LE.0 )
     $   RETURN
*
      IF( UPPER ) THEN
*
*        Reduce the upper triangle of A
*
         DO 10 I = N - 1, 1, -1
*
*           Generate elementary reflector H(i) = I - tau * v * v'
*           to annihilate A(1:i-1,i+1)
*
            CALL SLARFG( I, A( I, I+1 ), A( 1, I+1 ), 1, TAUI )
            E( I ) = A( I, I+1 )
*
            IF( TAUI.NE.ZERO ) THEN
*
*              Apply H(i) from both sides to A(1:i,1:i)
*
               A( I, I+1 ) = ONE
*
*              Compute  x := tau * A * v  storing x in TAU(1:i)
*
               CALL SSYMV( UPLO, I, TAUI, A, LDA, A( 1, I+1 ), 1, ZERO,
     $                     TAU, 1 )
*
*              Compute  w := x - 1/2 * tau * (x'*v) * v
*
               ALPHA = -HALF*TAUI*SDOT( I, TAU, 1, A( 1, I+1 ), 1 )
               CALL SAXPY( I, ALPHA, A( 1, I+1 ), 1, TAU, 1 )
*
*              Apply the transformation as a rank-2 update:
*                 A := A - v * w' - w * v'
*
               CALL SSYR2( UPLO, I, -ONE, A( 1, I+1 ), 1, TAU, 1, A,
     $                     LDA )
*
               A( I, I+1 ) = E( I )
            END IF
            D( I+1 ) = A( I+1, I+1 )
            TAU( I ) = TAUI
   10    CONTINUE
         D( 1 ) = A( 1, 1 )
      ELSE
*
*        Reduce the lower triangle of A
*
         DO 20 I = 1, N - 1
*
*           Generate elementary reflector H(i) = I - tau * v * v'
*           to annihilate A(i+2:n,i)
*
            CALL SLARFG( N-I, A( I+1, I ), A( MIN( I+2, N ), I ), 1,
     $                   TAUI )
            E( I ) = A( I+1, I )
*
            IF( TAUI.NE.ZERO ) THEN
*
*              Apply H(i) from both sides to A(i+1:n,i+1:n)
*
               A( I+1, I ) = ONE
*
*              Compute  x := tau * A * v  storing y in TAU(i:n-1)
*
               CALL SSYMV( UPLO, N-I, TAUI, A( I+1, I+1 ), LDA,
     $                     A( I+1, I ), 1, ZERO, TAU( I ), 1 )
*
*              Compute  w := x - 1/2 * tau * (x'*v) * v
*
               ALPHA = -HALF*TAUI*SDOT( N-I, TAU( I ), 1, A( I+1, I ),
     $                 1 )
               CALL SAXPY( N-I, ALPHA, A( I+1, I ), 1, TAU( I ), 1 )
*
*              Apply the transformation as a rank-2 update:
*                 A := A - v * w' - w * v'
*
               CALL SSYR2( UPLO, N-I, -ONE, A( I+1, I ), 1, TAU( I ), 1,
     $                     A( I+1, I+1 ), LDA )
*
               A( I+1, I ) = E( I )
            END IF
            D( I ) = A( I, I )
            TAU( I ) = TAUI
   20    CONTINUE
         D( N ) = A( N, N )
      END IF
*
      RETURN
*
*     End of SSYTD2
*
      END

C
C $Id: ngwsym.f,v 1.6 2008-07-27 00:17:18 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE NGWSYM(FTYPE,NUM,X,Y,SIZE,ICOLOR,IALT)
C
C  Draw a glyph from the meteorological fonts.
C
C ARGUMENTS
C
C ON INPUT  
C    
C  FTYPE   The meteorological font specification.  FTYPE is a type
C          character variable.  Legal values are:
C
C            'WW' -- Present weather.
C            'C'  -- Cloud types.
C            'CL' -- Low clouds.
C            'CM' -- Medium clouds.
C            'CH' -- High clouds.
C            'W'  -- Past weather.
C            'N'  -- Sky cover.
C            'a'  -- Pressure tendency.
C
C  NUM     The number of the glyph within the given font.  For example,
C          the glyph for haze is number five in the WW font.
C
C  X       The X coordinate position in world coordinates where the 
C          glyph is to be positioned.  This X position marks the 
C          horizontal center of the glyph.
C
C  Y       The Y coordinate position in world coordinates where the 
C          glyph is to be positioned.  This Y position marks the 
C          vertical center of the glyph.
C
C  SIZE    The size of the character in world coordinate Y units.
C
C  ICOLOR  The color index indicating the color that the glyph is to
C          be drawn with.  If you want the default foreground color,
C          set this parameter to "1".
C
C  IALT    If IALT=1, then the alternate glyph for the one specified
C          is drawn.  This applies only to a few glyphs such as
C          numbers 7, 93, 94, 95, 97 in the WW font and number 3 
C          in the W font.
C
C
C
C EXAMPLES
C
C    CALL NGWSYM('N',6,.5,.5,.25,1,0)
C  
C      would plot a circle that is 3/4th filled at position (.5,.5)
C      and height .25 in the foreground color.
C
C    CALL NGWSYM('a',6,.2,.8,.3,1,0)
C
C      would plot the glyph for barometric pressure that is falling 
C      then steady.
C
C    CALL NGWSYM('WW',95,.5,.5,.2,1,1)
C
C      would plot the alternate glyph for slight or moderate 
C      thunderstorm without hail.
C
      CHARACTER*(*) FTYPE
      CHARACTER*2   FTMP
      CHARACTER*1   CCHR
      INTEGER       NUM,ICOLOR,IALT
      REAL          X,Y,SIZE
C
      IF (LEN(FTYPE) .GE. 2) THEN
        FTMP(1:2) = FTYPE(1:2)
      ELSE
        FTMP(1:1) = FTYPE(1:1)
        FTMP(2:2) = ' '
      ENDIF
C
      IF (FTMP.EQ.'WW' .AND. (NUM.GE.0 .AND. NUM.LE.99)) THEN
        IF (NUM.GE.0 .AND. NUM.LE.93) THEN
          MFONT = -36
          IF (IALT .NE. 1) THEN
            CCHR  = CHAR(NUM+33)
          ELSE
            IF (NUM .EQ. 07) THEN
              MFONT = -37 
              CCHR = CHAR(39)
            ELSE IF (NUM .EQ. 93) THEN
              MFONT = -37 
              CCHR = CHAR(40)
            ENDIF
          ENDIF
        ELSE IF (NUM.GE.94 .AND. NUM.LE.99) THEN
          MFONT = -37
          IF (IALT .NE. 1) THEN
            CCHR  = CHAR(NUM-94+33)
          ELSE
            IF (NUM .EQ. 94) THEN
              CCHR = CHAR(41)
            ELSE IF (NUM .EQ. 95) THEN
              CCHR = CHAR(42)
            ELSE IF (NUM .EQ. 97) THEN
              CCHR = CHAR(43)
            ENDIF
          ENDIF 
        ENDIF
      ELSE IF (FTMP.EQ.'C ' .AND. (NUM.GE.0 .AND. NUM.LE.9))THEN
        MFONT = -37
        CCHR  = CHAR(NUM+45)
      ELSE IF (FTMP.EQ.'CL' .AND. (NUM.GE.0 .AND. NUM.LE.9))THEN
        MFONT = -37
        IF (NUM .EQ. 0) THEN
          CCHR = ' '
        ELSE
          CCHR  = CHAR(NUM+54)
        ENDIF
      ELSE IF (FTMP.EQ.'CM' .AND. (NUM.GE.0 .AND. NUM.LE.9))THEN
        MFONT = -37
        IF (NUM .EQ. 0) THEN
          CCHR = ' '
        ELSE
          CCHR  = CHAR(NUM+63)
        ENDIF
      ELSE IF (FTMP.EQ.'CH' .AND. (NUM.GE.0 .AND. NUM.LE.9))THEN
        MFONT = -37
        IF (NUM .EQ. 0) THEN
          CCHR = ' '
        ELSE
          CCHR  = CHAR(NUM+72)
        ENDIF
      ELSE IF (FTMP .EQ. 'W ' .AND. (NUM.GE.0 .AND. NUM.LE.9))THEN
        MFONT = -36
        IF (NUM.GE.0 .AND. NUM.LE.2) THEN
          CCHR = ' '
        ELSE IF (NUM .EQ. 3) THEN
          IF (IALT .NE. 1) THEN
            CCHR = CHAR(64)
          ELSE
            CCHR = CHAR(71)
          ENDIF
        ELSE IF (NUM .EQ. 4) THEN
          CCHR = CHAR(78)
        ELSE IF (NUM .EQ. 5) THEN
          CCHR = CHAR(83)
        ELSE IF (NUM .EQ. 6) THEN
          CCHR = CHAR(93)
        ELSE IF (NUM .EQ. 7) THEN
          CCHR = CHAR(103)
        ELSE IF (NUM .EQ. 8) THEN
          MFONT = -37
          CCHR = CHAR(44)
        ELSE IF (NUM .EQ. 9) THEN
          CCHR = CHAR(50)
        ENDIF
      ELSE IF (FTMP.EQ.'N ' .AND. (NUM.GE.0 .AND. NUM.LE.9))THEN
        MFONT = -37
        CCHR = CHAR(NUM+82)
      ELSE IF (FTMP.EQ.'a ' .AND. (NUM.GE.0 .AND. NUM.LE.9))THEN
        MFONT = -37
        IF (NUM .EQ. 9) THEN
          CCHR = ' '
        ELSE
          CCHR = CHAR(NUM+92)
        ENDIF
      ELSE
        WRITE(6,100) FTMP,NUM
  100   FORMAT(
     +     ' NGWSYM -- Error in font or glyph number specification:',
     +     / '             Font = ',A2,
     +     / '             Glyph number =',I3)
        GO TO 10
      ENDIF
C
      CALL NGPUTG(MFONT,CCHR,X,Y,SIZE,ICOLOR)
C
   10 CONTINUE
C
      RETURN
      END

      PROGRAM TDEX04
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
        PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C This is a modified version of the TDPACK example "tdex01".  The two
C surfaces have been modified to illustrate new capabilities.  The
C color of the simple surface ranges from blue at the bottom to red at
C the top, while the lumpy doughnut that intersects it is shown in
C yellow.  In addition, cyan lines are used to indicate selected planes
C of constant U, V, or W.
C
C Create parameters specifying the maximum sizes of the arrays defining
C data and the arrays required for dealing with the list of triangles.
C
        PARAMETER (IMAX=81,JMAX=81,KMAX=81,MTRI=400000)
C
C Set the desired values of the dimensions of the data arrays.  Note
C that IDIM must not exceed IMAX, that JDIM must not exceed JMAX, and
C that KDIM must not exceed KMAX.  NLYR is the number of vertical
C layers to be used in rendering the simple surface.  There is an
C inverse relationship between the number of layers you use for the
C surface (which determines how many different colors will be used)
C and the number of shades of those colors that you can generate.
C (The shades are used to give a visual sense of the angle between
C the line of sight and the normal to the surface.)
C
        PARAMETER (IDIM=81,JDIM=81,KDIM=81,NLYR=10)
C
C Declare local dimensioned variables to hold data defining a simple
C surface and an isosurface.
C
        DIMENSION U(IMAX),V(JMAX),W(KMAX),S(IMAX,JMAX),F(IMAX,JMAX,KMAX)
C
C Declare a local array to hold the triangle list and a couple of
C temporary variables to be used in sorting the list.
C
        DIMENSION RTRI(10,MTRI),RTWK(MTRI,2),ITWK(MTRI)
C
C Declare variables to hold labels.
C
        CHARACTER*64 UNLB,VNLB,WNLB,UILB,VILB,WILB
C
C Set the desired minimum and maximum values of U, V, and W.
C
        DATA UMIN,VMIN,WMIN,UMAX,VMAX,WMAX / -1.,-1.,-1.,1.,1.,1. /
C
C Set the desired values of parameters determining the eye position.
C ANG1 is a bearing angle, ANG2 is an elevation angle, and RMUL is a
C multiplier of the length of the diagonal of the data box, specifying
C the distance from the center of the box to the eye.
C
        DATA ANG1,ANG2,RMUL / -35.,25.,2.9 /
C
C ISTE is a flag that says whether to do a simple image (ISTE=0),
C a one-frame stereo image (ISTE=-1), or a two-frame stereo image
C (ISTE=+1).
C
        DATA ISTE / -1 /
C       DATA ISTE /  0 /
C       DATA ISTE / +1 /
C
C ASTE is the desired angle (in degrees) between the lines of sight for
C a pair of stereo views.
C
        DATA ASTE / 4. /
C
C WOSW is the width of the stereo windows to be used in one-frame stereo
C images; the width is stated as a fraction of the width of the plotter
C frame.  (The windows are centered vertically; horizontally, they are
C placed as far apart as possible in the plotter frame.)  The value used
C must be positive and non-zero; it may be slightly greater than .5, if
C it is desired that the stereo windows should overlap slightly.
C
        DATA WOSW / .5 /
C
C Set the desired value of the flag that says whether the basic color
C scheme will be white on black (IBOW=0) or black on white (IBOW=1).
C
        DATA IBOW / 1 /
C
C Define the conversion constant from degrees to radians.
C
        DATA DTOR / .017453292519943 /
C
C Define labels for the edges of the box.
C
        DATA UNLB / ' -1 -.8 -.6 -.4 -.2 0 .2 .4 .6 .8 1 ' /
        DATA VNLB / ' -1 -.8 -.6 -.4 -.2 0 .2 .4 .6 .8 1 ' /
        DATA WNLB / ' -1 -.8 -.6 -.4 -.2 0 .2 .4 .6 .8 1 ' /
C
        DATA UILB / 'U Coordinate Values' /
        DATA VILB / 'V Coordinate Values' /
        DATA WILB / 'W Coordinate Values' /
C
C Define the limits for the cyan stripes indicating certain values of
C U, V, or W.
C
C       DATA USMN,USMX /  .44 ,  .46 /
C       DATA VSMN,VSMX / -.56 , -.54 /
C       DATA WSMN,WSMX / -.16 , -.14 /
C
        DATA USMN,USMX / -.01 , +.01 /
        DATA VSMN,VSMX / -.01 , +.01 /
        DATA WSMN,WSMX / -.01 , +.01 /
C
C Open GKS.
C
        CALL GOPKS (IERRF, ISZDM)
        CALL GOPWK (IWKID, LUNIT, IWTYPE)
        CALL GACWK (IWKID)
C
C Turn clipping off.
C
        CALL GSCLIP (0)
C
C Double the line width.
C
        CALL GSLWSC (2.)
C
C Define the background color and the basic foreground color (either
C black and white or white and black).
C
        IF (IBOW.EQ.0) THEN
          CALL GSCR (1,0,0.,0.,0.)
          CALL GSCR (1,1,1.,1.,1.)
        ELSE
          CALL GSCR (1,0,1.,1.,1.)
          CALL GSCR (1,1,0.,0.,0.)
        END IF
C
C Define the primary colors (2 = red; 3 = green; 4 = blue; 5 = cyan;
C 6 = magenta; and 7 = yellow).
C
        CALL GSCR   (1,2,1.,0.,0.)
        CALL GSCR   (1,3,0.,1.,0.)
        CALL GSCR   (1,4,0.,0.,1.)
        CALL GSCR   (1,5,0.,1.,1.)
        CALL GSCR   (1,6,1.,0.,1.)
        CALL GSCR   (1,7,1.,1.,0.)
C
C Now we need a bunch more colors.  Each of the NLYR layers of the
C simple surface is to be a different color and the isosurface is
C to be made yet another color.  Additionally, we want to vary the
C shading of each surface layer and of the isosurface as implied by
C the angle between the line of sight and the local normal.  As we
C define the colors required, we define the required rendering styles
C for TDPACK.  ILCU is the index of the last color used so far.
C
        ILCU=7
C
C NSHD is the largest number of shades of each color that we can
C generate.  (Note the trade-off between the number of levels and
C the number of shades at each level.  With 31 levels, we get about
C 7 shades of each color, which is not really enough.)
C
        NSHD=(256-(ILCU+1))/(NLYR+1)
C
C Generate NSHD shades of each of NLYR+1 colors and use them to
C create NLYR+1 different rendering styles.  Note that I have set
C up the shades to run from the brightest shade down to .2 times
C the brightest shade.  This looks pretty good to my eye, but
C others may prefer something different.
C
        DO 101 I=1,NLYR+1
          IF (I.LE.NLYR) THEN
C           Colors run from blue to red.
            R=REAL(I-1)/REAL(NLYR-1)
            G=0.
            B=1.-R
          ELSE IF (I.EQ.NLYR+1) THEN
C           Colors are all yellow.
            R=1.
            G=1.
            B=0.
          END IF
          CALL TDSTRS (I,1,1,ILCU+1,ILCU+NSHD,-1,-1,0,0.,0.,0.)
          DO 100 J=1,NSHD
            ILCU=ILCU+1
            P=REAL(NSHD-J+1)/REAL(NSHD)
            CALL GSCR (1,ILCU,.2+.8*P*R,.2+.8*P*G,.2+.8*P*B)
  100     CONTINUE
  101   CONTINUE
C
C Define one more rendering style, for the stripes that will be used
C to mark selected planes of constant U, V, or W.  This involves only
C a single color (cyan, color index 5) because we want the stripes to
C really stand out.
C
        CALL TDSTRS (NLYR+2,1,1,5,5,-1,-1,0,0.,0.,0.)
C
C Fill data arrays defining a simple surface and an isosurface.  The
C simple surface is defined by the equation "w=s(u,v)"; the function
C "s" is approximated by the contents of the array S: S(I,J) is the
C value of s(U(I),V(J)), where I goes from 1 to IDIM and J from 1 to
C JDIM.  The isosurface is defined by the equation f(u,v,w)=1.; the
C function f is approximated by the contents of the array F: F(I,J,K)
C is the value of f(U(I),V(J),W(K)), where I goes from 1 to IDIM, J
C from 1 to JDIM, and K from 1 to KDIM.
C
        DO 102 I=1,IDIM
          U(I)=UMIN+(REAL(I-1)/REAL(IDIM-1))*(UMAX-UMIN)
  102   CONTINUE
C
        DO 103 J=1,JDIM
          V(J)=VMIN+(REAL(J-1)/REAL(JDIM-1))*(VMAX-VMIN)
  103   CONTINUE
C
        DO 104 K=1,KDIM
          W(K)=WMIN+(REAL(K-1)/REAL(KDIM-1))*(WMAX-WMIN)
  104   CONTINUE
C
        DO 107 I=1,IDIM
          DO 106 J=1,JDIM
            S(I,J)=2.*EXP(-2.*(U(I)**2+V(J)**2))-1.
            DO 105 K=1,KDIM
              F(I,J,K)=1.25*U(I)**2+1.25*V(J)**2+1.25*W(K)**2
              F(I,J,K)=F(I,J,K)*(1.75+.85*
     +                           SIN(90.*DTOR+5.*ATAN2(V(J),U(I))))
  105       CONTINUE
  106     CONTINUE
  107   CONTINUE
C
C Select font number 25, turn on the outlining of filled fonts, set the
C line width to 1, and turn off the setting of the outline color.
C
        CALL PCSETI ('FN - FONT NUMBER',25)
        CALL PCSETI ('OF - OUTLINE FLAG',1)
        CALL PCSETR ('OL - OUTLINE LINE WIDTH',1.)
        CALL PCSETR ('OC - OUTLINE LINE COLOR',-1.)
C
C Make TDPACK characters a bit bigger.
C
        CALL TDSETR ('CS1',1.25)
C
C Initialize the count of triangles in the triangle list.
C
        NTRI=0
C
C Add to the triangle list triangles representing a simple surface;
C initially, use rendering style 1; later, we will examine all the
C triangles and make the rendering style for each a function of W.
C
        CALL TDSTRI (U,IDIM,V,JDIM,S,IMAX,RTRI,MTRI,NTRI,1)
C
        IF (NTRI.EQ.MTRI) THEN
          PRINT * , 'TRIANGLE LIST OVERFLOW IN TDSTRI'
          STOP
        END IF
C
C Cut all the triangles generated so far into pieces, using planes that
C cut the data box into NLYR slices perpendicular to the vertical axis.
C
        ULYR=(UMAX-UMIN)/REAL(NLYR)
        VLYR=(VMAX-VMIN)/REAL(NLYR)
        WLYR=(WMAX-WMIN)/REAL(NLYR)
C
        DO 108 I=1,NLYR-1
          CALL TDCTRI (RTRI,MTRI,NTRI,3,WMIN+REAL(I)*WLYR)
  108   CONTINUE
C
C Now, add to the triangle list triangles representing an isosurface;
C use rendering style NLYR+1.
C
        CALL TDITRI (U,IDIM,V,JDIM,W,KDIM,F,IMAX,JMAX,1.,
     +                             RTRI,MTRI,NTRI,NLYR+1)
C
        IF (NTRI.EQ.MTRI) THEN
          PRINT * , 'TRIANGLE LIST OVERFLOW IN TDITRI'
          STOP
        END IF
C
C Put some more slices through the triangles, so that we can put some
C cyan stripes on the surfaces for certain values of U, V, and W.
C
        IF (USMN.LT.USMX) THEN
          CALL TDCTRI (RTRI,MTRI,NTRI,1,USMN)
          CALL TDCTRI (RTRI,MTRI,NTRI,1,USMX)
        END IF
C
        IF (VSMN.LT.VSMX) THEN
          CALL TDCTRI (RTRI,MTRI,NTRI,2,VSMN)
          CALL TDCTRI (RTRI,MTRI,NTRI,2,VSMX)
        END IF
C
        IF (WSMN.LT.WSMX) THEN
          CALL TDCTRI (RTRI,MTRI,NTRI,3,WSMN)
          CALL TDCTRI (RTRI,MTRI,NTRI,3,WSMX)
        END IF
C
C Now, examine the triangles; change all those that have a rendering
C style of 1 to instead have a rendering style that increases with
C the third coordinate of the triangle.  However, if the values of
C U, V, or W are in the ranges where we want a cyan stripe, we use
C rendering style NLYR+2.
C
        DO 109 I=1,NTRI
          UPOS=(RTRI(1,I)+RTRI(4,I)+RTRI(7,I))/3.
          VPOS=(RTRI(2,I)+RTRI(5,I)+RTRI(8,I))/3.
          WPOS=(RTRI(3,I)+RTRI(6,I)+RTRI(9,I))/3.
          IF (RTRI(10,I).EQ.1.) THEN
            RTRI(10,I)=REAL(MAX(1,MIN(NLYR,1+INT((WPOS-WMIN)/WLYR))))
          END IF
          IF ((UPOS.GE.USMN.AND.UPOS.LE.USMX).OR.
     +        (VPOS.GE.VSMN.AND.VPOS.LE.VSMX).OR.
     +        (WPOS.GE.WSMN.AND.WPOS.LE.WSMX)) RTRI(10,I)=REAL(NLYR+2)
  109   CONTINUE
C
C Find the midpoint of the data box (to be used as the point looked at).
C
        UMID=.5*(UMIN+UMAX)
        VMID=.5*(VMIN+VMAX)
        WMID=.5*(WMIN+WMAX)
C
C Determine the distance (R) from which the data box will be viewed and,
C given that, the eye position.
C
        R=RMUL*SQRT((UMAX-UMIN)**2+(VMAX-VMIN)**2+(WMAX-WMIN)**2)
C
        UEYE=UMID+R*COS(DTOR*ANG1)*COS(DTOR*ANG2)
        VEYE=VMID+R*SIN(DTOR*ANG1)*COS(DTOR*ANG2)
        WEYE=WMID+R*SIN(DTOR*ANG2)
C
C Initialize the stereo offset argument to do either a single view or
C a left-eye view (whichever is selected by the value of ISTE).
C
        IF (ISTE.EQ.0) THEN
          OTEP=0.
        ELSE
          OTEP=-R*TAN(DTOR*ASTE/2.)
        END IF
C
C Initialize TDPACK.
C
  110   CALL TDINIT (UEYE,VEYE,WEYE,UMID,VMID,WMID,
     +                              UMID,VMID,WMID+R,OTEP)
C
C If stereo views are being done, do the requested thing, either by
C redoing the SET call to put them side by side on the same frame,
C or by calling FRAME to put them on separate frames.
C
        IF (OTEP.NE.0.) THEN
          IF (ISTE.LT.0) THEN
            CALL GETSET (XVPL,XVPR,YVPB,YVPT,XWDL,XWDR,YWDB,YWDT,LNLG)
            IF (OTEP.LT.0.) THEN
              CALL SET  (1.-WOSW,1.,.5-.5*WOSW,.5+.5*WOSW,
     +                           XWDL,XWDR,YWDB,YWDT,LNLG)
            ELSE
              CALL SET  (  0., WOSW,.5-.5*WOSW,.5+.5*WOSW,
     +                           XWDL,XWDR,YWDB,YWDT,LNLG)
            END IF
          ELSE
            IF (OTEP.GT.0.) CALL FRAME
          END IF
        END IF
C
C Order the triangles in the triangle list.
C
        CALL TDOTRI (RTRI,MTRI,NTRI,RTWK,ITWK,1)
C
        IF (NTRI.EQ.MTRI) THEN
          PRINT * , 'TRIANGLE LIST OVERFLOW IN TDOTRI'
          STOP
        END IF
C
C Draw labels for the axes.
C
        CALL TDLBLS (UMIN,VMIN,WMIN,UMAX,VMAX,WMAX,
     +               UNLB,VNLB,WNLB,UILB,VILB,WILB,1)
C
C Draw the sides of the box that could be hidden.
C
        CALL TDGRDS (UMIN,VMIN,WMIN,UMAX,VMAX,WMAX,
     +               .1*(UMAX-UMIN),.1*(VMAX-VMIN),.1*(WMAX-WMIN),
     +                                                       12,1)
C
C Draw the triangles in the triangle list.
C
        CALL TDDTRI (RTRI,MTRI,NTRI,ITWK)
C
C Draw the sides of the box that could not be hidden.
C
        CALL TDGRDS (UMIN,VMIN,WMIN,UMAX,VMAX,WMAX,
     +               .1*(UMAX-UMIN),.1*(VMAX-VMIN),.1*(WMAX-WMIN),
     +                                                       12,0)
C
C If a left-eye view has just been done, loop back for a right-eye view.
C
        IF (OTEP.LT.0.) THEN
          OTEP=-OTEP
          GO TO 110
        END IF
C
C Advance the frame.
C
        CALL FRAME
C
C Close GKS.
C
        CALL GDAWK (IWKID)
        CALL GCLWK (IWKID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END

C
C $Id: agsave.f,v 1.6 2008-07-27 00:14:35 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE AGSAVE (IFNO)
C
C This subroutine is called to save the current state of AUTOGRAPH by
C writing all of its important variables as a record on the file which
C is associated with the unit number IFNO.
C
C The following common block contains the AUTOGRAPH control parameters,
C all of which are real.  If it is changed, all of AUTOGRAPH (especially
C the routine AGSCAN) must be examined for possible side effects.
C
      COMMON /AGCONP/ QFRA,QSET,QROW,QIXY,QWND,QBAC , SVAL(2) ,
     +                XLGF,XRGF,YBGF,YTGF , XLGD,XRGD,YBGD,YTGD , SOGD ,
     +                XMIN,XMAX,QLUX,QOVX,QCEX,XLOW,XHGH ,
     +                YMIN,YMAX,QLUY,QOVY,QCEY,YLOW,YHGH ,
     +                QDAX(4),QSPA(4),PING(4),PINU(4),FUNS(4),QBTD(4),
     +                BASD(4),QMJD(4),QJDP(4),WMJL(4),WMJR(4),QMND(4),
     +                QNDP(4),WMNL(4),WMNR(4),QLTD(4),QLED(4),QLFD(4),
     +                QLOF(4),QLOS(4),DNLA(4),WCLM(4),WCLE(4) ,
     +                QODP,QCDP,WOCD,WODQ,QDSH(26) ,
     +                     QDLB,QBIM,FLLB(10,8),QBAN ,
     +                QLLN,TCLN,QNIM,FLLN(6,16),QNAN ,
     +                XLGW,XRGW,YBGW,YTGW , XLUW,XRUW,YBUW,YTUW ,
     +                XLCW,XRCW,YBCW,YTCW , WCWP,HCWP,SCWP ,
     +                XBGA(4),YBGA(4),UBGA(4),XNDA(4),YNDA(4),UNDA(4),
     +                QBTP(4),BASE(4),QMNT(4),QLTP(4),QLEX(4),QLFL(4),
     +                QCIM(4),QCIE(4),RFNL(4),WNLL(4),WNLR(4),WNLB(4),
     +                WNLE(4),QLUA(4) ,
     +                RBOX(6),DBOX(6,4),SBOX(6,4)
      SAVE /AGCONP/
C
C The following common block contains other AUTOGRAPH variables, both
C real and integer, which are not control parameters.
C
      COMMON /AGORIP/ SMRL , ISLD , MWCL,MWCM,MWCE,MDLA,MWCD,MWDQ ,
     +                INIF
      SAVE /AGORIP/
C
C The following common blocks contain variables which are required for
C the character-storage-and-retrieval scheme of AUTOGRAPH.
C
      COMMON /AGCHR1/ LNIC,INCH(2,50),LNCA,INCA
      SAVE /AGCHR1/
C
      COMMON /AGCHR2/ CHRA(2000)
      CHARACTER*1 CHRA
      SAVE /AGCHR2/
C
C If initialization has not yet been done, do it.
C
      IF (INIF.EQ.0) THEN
        CALL AGINIT
      END IF
C
C Write the record.  Variables from each COMMON block are together, in
C alphabetical order.
C
      WRITE (IFNO,ERR=901)
     1 BASD,BASE,DBOX,DNLA,FLLB,FLLN,FUNS,HCWP,PING,PINU,QBAC,QBAN,QBIM,
     2 QBTD,QBTP,QCDP,QCEX,QCEY,QCIE,QCIM,QDAX,QDLB,QDSH,QFRA,QIXY,QJDP,
     3 QLED,QLEX,QLFD,QLFL,QLLN,QLOF,QLOS,QLTD,QLTP,QLUA,QLUX,QLUY,QMJD,
     4 QMND,QMNT,QNAN,QNDP,QNIM,QODP,QOVX,QOVY,QROW,QSET,QSPA,QWND,RBOX,
     5 RFNL,SBOX,SCWP,SOGD,SVAL,TCLN,UBGA,UNDA,WCLE,WCLM,WCWP,WMJL,WMJR,
     6 WMNL,WMNR,WNLB,WNLE,WNLL,WNLR,WOCD,WODQ,XBGA,XHGH,XLCW,XLGD,XLGF,
     7 XLGW,XLOW,XLUW,XMAX,XMIN,XNDA,XRCW,XRGD,XRGF,XRGW,XRUW,YBCW,YBGA,
     8 YBGD,YBGF,YBGW,YBUW,YHGH,YLOW,YMAX,YMIN,YNDA,YTCW,YTGD,YTGF,YTGW,
     9 YTUW,
     + INIF,ISLD,MDLA,MWCD,MWCE,MWCL,MWCM,MWDQ,SMRL,
     1 INCA,INCH,LNCA,LNIC,
     2 CHRA
C
C Done.
C
      RETURN
C
C Error exit.
C
  901 CALL SETER ('AGSAVE - ERROR ON WRITE',10,2)
C
      END

      PROGRAM CLBLBR
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
      
      CHARACTER*7 LAB1(11), LAB2(13)
      INTEGER IFILL1(11), IFILL2(14)
      
      DATA LAB1 /'.','here','go','can',':G:font','any','in',
     +      'number','or','word','Any'/
      DATA LAB2 /'.','boxes','between','lines','the','or','boxes',
     +      'either','match','can','labels','that','Notice'/
      DATA IFILL1 /11,10,9,8,7,6,5,4,3,2,1/
      DATA IFILL2 /3,4,5,6,7,8,9,10,2,11,12,13,14,15/
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Set up color table
C
      CALL COLOR (IWKID)
C
C Set color fill to be solid
C
      CALL GSFAIS(1)
C
C Draw two vertical label bars.
C
      CALL SFSETR('AN',35.)
      CALL SFSETI('TY',-4)
      CALL LBLBAR(1,.05,.45,.05,.95,11,.3,1.,IFILL1,0,LAB1,11,1)
      CALL SFSETI('TY',0)
      CALL LBLBAR(1,.55,.95,.05,.95,14,.3,1.,IFILL2,1,LAB2,13,2)
C
C Advance frame
C
      CALL FRAME
C
C     DEACTIVATE AND CLOSE WORKSTATION, CLOSE GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS

      STOP
      END

      SUBROUTINE COLOR (IWKID)
C
C BACKGROUND COLOR
C BLACK
C
      CALL GSCR(IWKID,0,0.,0.,0.)
C
C     FORGROUND COLORS
C White
C
      CALL GSCR(IWKID,  1, 1.0, 1.0, 1.0)
C
C Aqua
C
      CALL GSCR(IWKID,  2, 0.0, 0.9, 1.0)
C
C Red
C
      CALL GSCR(IWKID,  3, 0.9, 0.25, 0.0)
C
C OrangeRed
C
      CALL GSCR(IWKID,  4, 1.0, 0.0, 0.2)
C
C Orange
C
      CALL GSCR(IWKID,  5, 1.0, 0.65, 0.0)
C
C Yellow
C
      CALL GSCR(IWKID,  6, 1.0, 1.0, 0.0)
C
C GreenYellow
C
      CALL GSCR(IWKID,  7, 0.7, 1.0, 0.2)
C
C Chartreuse
C
      CALL GSCR(IWKID,  8, 0.5, 1.0, 0.0)
C
C Celeste
C
      CALL GSCR(IWKID,  9, 0.2, 1.0, 0.5)
C
C Green
C
      CALL GSCR(IWKID, 10, 0.2, 0.8, 0.2)
C
C DeepSkyBlue
C
      CALL GSCR(IWKID, 11, 0.0, 0.75, 1.0)
C
C RoyalBlue
C
      CALL GSCR(IWKID, 12, 0.25, 0.45, 0.95)
C
C SlateBlue
C
      CALL GSCR(IWKID, 13, 0.4, 0.35, 0.8)
C
C DarkViolet
C
      CALL GSCR(IWKID, 14, 0.6, 0.0, 0.8)
C
C Orchid
C
      CALL GSCR(IWKID, 15, 0.85, 0.45, 0.8)
C
C Lavender
C
      CALL GSCR(IWKID, 16, 0.8, 0.8, 1.0)
C
C Gray
C
      CALL GSCR(IWKID, 17, 0.7, 0.7, 0.7)
C
C Done.
C
      RETURN
C
      END

C
C $Id: kmpx.f,v 1.7 2008-07-27 00:17:24 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      FUNCTION KMPX (IX)
C
C Given an X coordinate IX in the metacode system, KMPX(IX) is an X
C coordinate in the plotter system.
C
      COMMON /IUTLCM/ LL,MI,MX,MY,IU(96)
      SAVE /IUTLCM/
      KMPX=1+INT((2.**MX-1.)*REAL(IX)/32767.)
      RETURN
      END

C NCLFORTSTART
      SUBROUTINE VINTH2PECMWF(DATI,DATO,HBCOFA,HBCOFB,P0,PLEVI,PLEVO,
     +                         INTYP,ILEV,PSFC,SPVL,KXTRP,IMAX,NLAT,
     +                         NLEVI,NLEVIP1,NLEVO,VARFLG,TBOT,PHIS)
C
C****     THIS ROUTINE INTERPLOATES CCM2/3 HYBRID COORDINATE DATA
C****     TO PRESSURE COORDINATES USING PRESSURE SURFACES AS THE
C****     COORDINATE SURFACE WHERE THE INTERPOLATION IS DONE.  THE
C****     TYPE OF INTERPOLATION IS CURRENTLY A VARIANT OF TRANSFORMED
C****     PRESSURE COORDINATES WITH THE  INTERPOLATION TYPE
C****     SPECIFIED BY INTYP.  ALL HYBRID COORDINATE VALUES ARE
C****     TRANSFORMED TO PRESSURE VALUES. WHERE THE
C****     FORMULA FOR THE PRESSURE OF A HYBRID SURFACE IS;
C****          P(K) = HBCOFA(LEVH,K)*P0 + HBCOFB(LEVH,K)*PSFC
C****     WHERE,
C****          HBCOFA - IS THE "A" OR PRESSURE HYBRID COEF
C****          LEVH   - IS THE LAYER SURFACE (INTERFACE=1 MIDPOINT=2)
C****          P0     - IS THE BASE PRESSURE IN MB
C****          K      - THE LEVEL INDEX (RUNNING FROM TOP TO BOTTOM)
C****          HBCOFB - IS THE "B" OR SIGMA COEFICIENT
C****          P(K)   - IS THE PRESSURE OF A HYBRID SURFACE IN MB.
C****          PSFC   - IS THE SURFACE PRESSURE IN PASCALS
C****                   (MB = .01*PASCALS
C
C****     FOR HYBRID DATA AT LEVEL INTERFACES SINCE THERE IS ONE
C****     MORE VERTICAL LEVEL FOR INTERFACES THAN FOR LEVEL MIDPOINTS
C****     IT IS ASSUNMED THAT THE FIRST INTERFACE LEVEL WITH A DATA
C****     VALUE IS THE SECOND LEVEL FROM THE TOP.
C
C****     ON INPUT-
C****        DATI    - 3 DIMENSIONAL ARRAY (I,J,KI) CONTAINING DATA
C****                  ON HYBRID SURFACES  WHERE I IS LONGTIUDE, J
C****                  IS LATITUDE AND K IS THE VERTICAL HYBRID
C****                  COORDINATE.  THE VERTICAL DATA RUN TOP TO BOTTOM.
C****                  SIGMA DATA WITH THE DATA ORDERED TOP TO BOTTOM.
C****        HBCOFA  - 2 DIMENSIONAL ARRAY CONTAINING "A" OR PRESSURE
C****                  COEFICIENTS FOR COMPUTING PRESSURE AT A LEVEL.
C****                  ARRAY IS 2XNLEVIP1.  THE 1ST INDEX TAKES ON
C****                  THE VALUE OF EITHER
C****                   1 - FOR LEVEL INTERFACES (OR 1/2 LEVELS) OR;
C****                   2 - FOR LEVEL MIDPOINTS  (OR FULL LEVELS WHERE
C****                       VIRTUALLY ALL VARIABLES ARE LOCATED)
C****                  NOTE THAT COEFICIENTS ARE SCALED TO YIELD A
C****                  PRESSURE IN MB.  THEY ARE ORDERED FROM TOP
C****                  OF THE MODEL TO THE BOTTOM.
C****        HBCOFB  - SAME AS HCOFA BUT FOR THE "B" OR SIGMA COEFICIENT
C****        P0      - BASE PRESSURE IN MB FOR COMPUTING PRESSURE
C****                  OF A HYBRID COORDINATE LEVEL
C****        PLEVI -  1 DIMENSIONAL ARRAY TO HOLD PRESSURE VALUES
C****                  OF HYBRID SURFACES FOR A VERTICAL COLUMN
C****                  SLICE
C****        PLEVO   - LIST OF OUTPUT PRESSURE SURFACES IN MB
C****                  LOW TO HIGH PRESSURE
C****        INTYP   - A FLAG INDICATING INTERPOLATION FOR EACH
C****                  FIELD (1 - LINEAR,2 - LOG ,3 - LOG LOG)
C****                  WHERE EACH INTERPOLATION IS DONE IN TRANSFORMED
C****                  PRESSURE COORDINATES.
C****        ILEV    - FLAG TO SHOW WHETHER FIELD IS ON LEVEL INTERFACE
C****                  1/2 LEVEL WHICH HAS A VALUE OF 1 OR A LEVEL
C****                  MIDPOINT A FULL LEVEL (WHERE ALMOST ALL VARIABLES
C****                  ARE LOCATED
C****        PSFC    - MODEL SFC PRESSURE IN PASCALS (WILL BE CONVERTED
C****                  TO MB)
C****        VCOLI   - ARRAY TO STORE A LONGITUDINAL VERTICAL SLICE OF
C****                  INPUT DATA (IMAX BY NLEVI).
C****        VCOLO   - SAME BUT FOR OUTPUT DATA (IMAX BY NLEVO)
C****        IMAX    - LONGITUDINAL DIMENSION OF THE DATA.
C****        NLAT    - LATITUDINAL DIMENSION OF THE DATA.
C****        NLEVI   - NO. OF LEVELS FOR THE HYBRID DATA
C****        NLEVIP1 - NLEVI + 1
C****        NLEVO   - NUMBER OF OUTPUT LEVELS FOR PRESSURE DATA
C****        KXTRP   - FLAG WHICH INDICATES WHETHER OR NOT
C****                  EXTRAPOLATION WILL BE USED WHEN THE OUTPUT
C****                  PRESSURE SURFACE IS BELOW THE LOWEST LEVEL
C****                  OF THE MODEL.
C****                     0 - DON'T EXTRAPOLATE USE SPECIAL VALUE SPVL
C****                     1 - EXTRAPOLATE DATA using ECMWF formulation
c****                         below PSFC
C****        SPVL    - SPECIAL VALUE TO USE WHEN DATA IS NOT
C****                  EXTRAPOLATED
C****        varflg  - flag which indicates the name of the variable
c****                  -1 means geopotential (Z)
c****                  +1 means geopotential (T)
c****                   0 any other variable
c****        tbot    - temperature at level closest to ground
c****        phis    - surface geopotential
C
C****     ON OUTPUT-
C****        DATO  - 3 DIMENSIONAL ARRAY TO HOLD DATA INTERPOLATED
C****                TO PRESSURE SURFACES.
C
      IMPLICIT NONE
      DOUBLE PRECISION SPVL,DATI,DATO,HBCOFA,HBCOFB,PLEVI,PLEVO,PSFC,P0
      DOUBLE PRECISION A2LN,A1
      INTEGER INTYP,ILEV,IMAX,NLAT,NLEVI,NLEVIP1,NLEVO,KXTRP
      INTEGER I,J,K,KP,KPI,IPRINT
C
      DIMENSION DATI(IMAX,NLAT,NLEVI),DATO(IMAX,NLAT,NLEVO),
     +          HBCOFA(NLEVIP1),HBCOFB(NLEVIP1),PLEVI(NLEVIP1),
     +          PLEVO(NLEVO),PSFC(IMAX,NLAT)

      INTEGER VARFLG
      DOUBLE PRECISION TBOT,PHIS,TSTAR,HGT,ALNP,T0,TPLAT,TPRIME0,ALPHA,
     +                 ALPH,PSFCMB
      DIMENSION TBOT(IMAX,NLAT),PHIS(IMAX,NLAT)
C NCLEND

c for ecmwf extrapolation
      DOUBLE PRECISION RD,GINV
      PARAMETER (RD=287.04D0)
      PARAMETER (GINV=1.D0/9.80616D0)
      PARAMETER (ALPHA=0.0065D0*RD*GINV)
C
C
C
C****     STATEMENT FCN. FOR DOUBLE LOG. INTERP ON PRESSURE SURFACES
C****     PRESUMES PRESSURE IS IN MB
C
      A2LN(A1) = LOG(LOG(A1+2.72D0))
C
C****     STATEMENT FCN. FOR DOUBLE LOG. INTERP ON SIGMA SURFACES.
C****     SETS UP ROUGH UPPER BPOUND SIMILAR TO STATEMENT FCN FOR
C****     PRESSURE. I.E.    FIXED VALUE LN(LN(P) = LN(LN(FIXED VAL)
C****     AT .001 SIGMA OR ABOUT 1 MB
C
C     A2LN(A1)=LOG(LOG(A1+1.001))

C****
C
      DO 70 J = 1,NLAT
          DO 60 I = 1,IMAX
c =======================================DJS special case===
              IF (PSFC(I,J).EQ.SPVL) THEN
                  DO K = 1,NLEVO
                      DATO(I,J,K) = SPVL
                  END DO
                  GO TO 60
              END IF
c =========================================================

C
C****     GET PRESSURE VALUES FOR HYBRID SURFACES FOR THIS POINT
C****     AND FOR THE TYPE OF MODEL SURFACE THE DATA IS ON.
C****     INTERFACE DATA STARTS AT THE SECOND INTERFACE LEVEL SO
C****     IF THE DATA IS ON THOSE LEVELS START THE
C
              DO K = 1,NLEVI
                  KPI = K
                  PLEVI(K) = (HBCOFA(KPI)*P0) +
     +                       HBCOFB(KPI)* (PSFC(I,J)*.01D0)
              END DO
C
C****     CALL P2HBD TO PERFORM VERTICAL INTERP. THEN TRANSFER DATA TO
C****     THE OUTPUT ARRAY
C
              DO 50 K = 1,NLEVO
C
C****     CHECK FOR BRACKETING LEVEL KP WILL BE THE INPUT LEVEL THAT
C****     IS THE UPPER PORTION OF 2 INPUT BRACKETING LEVELS.
C
C****     IF BRANCH FOR MODEL TOP
C
                  IF (PLEVO(K).LE.PLEVI(1)) THEN
                      KP = 1
                      GO TO 30
C
C****     IF BRANCH FOR LEVEL BELOW LOWEST HYBRID LEVEL
C
                  ELSE IF (PLEVO(K).GT.PLEVI(NLEVI)) THEN
                      IF (KXTRP.EQ.0) THEN
                          DATO(I,J,K) = SPVL
                          GO TO 40
                      ELSE IF (VARFLG.GT.0) THEN
c Variable is "T" and ECMWF extrapolation is desired
                          PSFCMB = PSFC(I,J)*0.01D0
                          TSTAR = DATI(I,J,NLEVI)*
     +                            (1.D0+ALPHA* (PSFCMB/PLEVI(NLEVI)-1))
                          HGT = PHIS(I,J)*GINV
                          IF (HGT.LT.2000.D0) THEN
                              ALNP = ALPHA*LOG(PLEVO(K)/PSFCMB)
                          ELSE
                              T0 = TSTAR + 0.0065D0*HGT
                              TPLAT = MIN(T0,298.D0)
                              IF (HGT.LE.2500.D0) THEN
                                  TPRIME0 = 0.002D0*
     +                                      ((2500.D0-HGT)*T0+ (HGT-
     +                                      2000.D0)*TPLAT)
                              ELSE
                                  TPRIME0 = TPLAT
                              END IF
                              IF (TPRIME0.LT.TSTAR) THEN
                                  ALNP = 0.D0
                              ELSE
                                  ALNP = RD* (TPRIME0-TSTAR)/PHIS(I,J)*
     +                                   LOG(PLEVO(K)/PSFCMB)
                              END IF
                          END IF
                          DATO(I,J,K) = TSTAR* (1.D0+ALNP+.5D0*ALNP**2+
     +                                  1.D0/6.D0*ALNP**3)
                          GO TO 40

                      ELSE IF (VARFLG.LT.0) THEN
c Variable is "Z" and ECMWF extrapolation is desired
                          PSFCMB = PSFC(I,J)*0.01D0
                          HGT = PHIS(I,J)*GINV
                          TSTAR = TBOT(I,J)* (1.D0+
     +                            ALPHA* (PSFCMB/PLEVI(NLEVI)-1.D0))
                          T0 = TSTAR + 0.0065D0*HGT

                          IF (TSTAR.LE.290.5D0 .AND. T0.GT.290.5D0) THEN
                              ALPH = RD/PHIS(I,J)* (290.5D0-TSTAR)
                          ELSE IF (TSTAR.GT.290.5D0 .AND.
     +                             T0.GT.290.5D0) THEN
                              ALPH = 0
                              TSTAR = 0.5D0* (290.5D0+TSTAR)
                          ELSE
                              ALPH = ALPHA
                          END IF

                          IF (TSTAR.LT.255.D0) THEN
                              TSTAR = 0.5D0* (TSTAR+255.D0)
                          END IF
                          ALNP = ALPH*LOG(PLEVO(K)/PSFCMB)
                          DATO(I,J,K) = HGT - RD*TSTAR*GINV*
     +                                  LOG(PLEVO(K)/PSFCMB)*
     +                                  (1.D0+.5D0*ALNP+
     +                                  1.D0/6.D0*ALNP**2)
                          GO TO 40
                      ELSE
C Use lowest sigma layer
                          DATO(I,J,K) = DATI(I,J,NLEVI)
                          GO TO 40
                      END IF
C
C****     IF BRANCH FOR TO CHECK IF OUTPUT LEVEL IN BETWEEN
C****     2 LOWEST HYBRID LEVELS
C
                  ELSE IF (PLEVO(K).GE.PLEVI(NLEVI-1)) THEN
                      KP = NLEVI - 1
                      GO TO 30
C
C****     IF BRANCH FOR MODEL INTERIOR
C****     LOOP THROUGH INPUT LEVELS TILL YOU ARE BRACKETING
C****     OUTPUT LEVEL
C
                  ELSE
                      KP = 0
   20                 CONTINUE
                      KP = KP + 1
                      IF (PLEVO(K).LE.PLEVI(KP+1)) GO TO 30
                      IF (KP.GT.NLEVI) THEN
                          WRITE (6,FMT=25) KP,NLEVI
   25                     FORMAT (' KP.GT.KLEVI IN P2HBD.  KP,KLEVI= ',
     +                           2I5)
C            CALL DPRNT(' PLEVI',PLEVI,NLEVIP1,1,1,1)
C            CALL DPRNT(' PLEVO',PLEVO,NLEVO,1,1,1)
C            CALL ABORT(' KP.GT.NLEVI IN P2HBD')
                      END IF
                      GO TO 20
                  END IF
   30             CONTINUE
C
C****     LEVEL BRACKETED PICK TYPE OF INTERP.
C
C
C****     LINEAR INTERP.
C
                  IF (INTYP.EQ.1) THEN
                      DATO(I,J,K) = DATI(I,J,KP) +
     +                              (DATI(I,J,KP+1)-DATI(I,J,KP))*
     +                              (PLEVO(K)-PLEVI(KP))/
     +                              (PLEVI(KP+1)-PLEVI(KP))
C
C****     LOG INTERPOLATION.
C
                  ELSE IF (INTYP.EQ.2) THEN
                      IPRINT = 1
C      IF (I.EQ.1.AND.IPRINT.EQ.1) THEN
C         PRINT 101,I,J,K,KP,ILEV
C  101    FORMAT('  IN S2HBD I,J,K,KP,ILEV ',5I3)
C         PRINT 102,DATI(I,J,KP),DATI(I,J,KP+1),PLEVO(K),
C     *             PLEVI(KP),PLEVI(KP+1)
C  102    FORMAT(' DATI(KP),DATI(KP+1),PLEVO(K),',
C     *          'PLEVI(KP),PLEVI(KP+1) ',
C     *          /,1X,1P5E12.5)
C      ENDIF
                      DATO(I,J,K) = DATI(I,J,KP) +
     +                              (DATI(I,J,KP+1)-DATI(I,J,KP))*
     +                              LOG(PLEVO(K)/PLEVI(KP))/
     +                              LOG(PLEVI(KP+1)/PLEVI(KP))
C
C****     FOR LOG LOG INTERP. NOTE A2LN IS A STATEMENT FCN.
C
                  ELSE IF (INTYP.EQ.3) THEN
                      DATO(I,J,K) = DATI(I,J,KP) +
     +                              (DATI(I,J,KP+1)-DATI(I,J,KP))*
     +                              (A2LN(PLEVO(K))-A2LN(PLEVI(KP)))/
     +                              (A2LN(PLEVI(KP+1))-A2LN(PLEVI(KP)))
                  END IF
   40             CONTINUE
C
   50         CONTINUE
   60     CONTINUE
   70 CONTINUE
      RETURN
      END
      SUBROUTINE DPRNT(IFLD,A,IM,JM,IS,JS)
      DOUBLE PRECISION A
      CHARACTER*(*) IFLD
      DIMENSION A(IM,JM)

      PRINT 10,IFLD
   10 FORMAT (1X,/,' FIELD ',A)
      DO 20 J = 1,JM,JS
          PRINT 13,J
   13     FORMAT (' J=',I4)
          PRINT 15, (A(I,J),I=1,IM,IS)
   15     FORMAT (1X,1P,10D12.5)
   20 CONTINUE
      RETURN
      END

C
C $Id: supcon.f,v 1.17 2008-09-18 00:42:18 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE SUPCON (RLAT,RLON,UVAL,VVAL)
        REAL   RLAT,RLON,UVAL,VVAL
        DOUBLE PRECISION DUVL,DVVL
        IF (ICFELL('SUPCON - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
        CALL MDPTRN (DBLE(RLAT),DBLE(RLON),DUVL,DVVL)
        IF (ICFELL('SUPCON',2).NE.0) RETURN
        IF (DUVL.NE.1.D12) THEN
          UVAL=REAL(DUVL)
          VVAL=REAL(DVVL)
        ELSE
          UVAL=1.E12
          VVAL=1.E12
        END IF
        RETURN
      END

C
C $Id: mdpdrw.f,v 1.9 2008-09-18 00:42:17 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MDPDRW
C
C Declare required common blocks.  See MAPBDX for descriptions of these
C common blocks and the variables in them.
C
        COMMON /MAPCM4/  GRDR,GRID,GRLA,GRLO,GRPO,OTOL,PDRE,PLA1,PLA2,
     +                   PLA3,PLA4,PLB1,PLB2,PLB3,PLB4,PLNO,PLTO,ROTA,
     +                   SRCH,XLOW,XROW,YBOW,YTOW,IDOT,IDSH,IDTL,ILCW,
     +                   ILTS,JPRJ,ELPF,INTF,LBLF,PRMF
        DOUBLE PRECISION GRDR,GRID,GRLA,GRLO,GRPO,OTOL,PDRE,PLA1,PLA2,
     +                   PLA3,PLA4,PLB1,PLB2,PLB3,PLB4,PLNO,PLTO,ROTA,
     +                   SRCH,XLOW,XROW,YBOW,YTOW
        INTEGER          IDOT,IDSH,IDTL,ILCW,ILTS,JPRJ
        LOGICAL          ELPF,INTF,LBLF,PRMF
        SAVE   /MAPCM4/
C
C Initialize the package, draw and label the grid, and draw outlines.
C
C Check for an uncleared prior error.
C
        IF (ICFELL('MDPDRW - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C Do the lower-level calls necessary to draw a complete map.
C
        IF (INTF) THEN
          CALL MDPINT
          IF (ICFELL('MDPDRW',2).NE.0) RETURN
        END IF
C
        CALL MDPGRD
        IF (ICFELL('MDPDRW',3).NE.0) RETURN
C
        CALL MDPLBL
        IF (ICFELL('MDPDRW',4).NE.0) RETURN
C
        CALL MDPLOT
        IF (ICFELL('MDPDRW',5).NE.0) RETURN
C
        RETURN
C
      END

C
C $Id: tdseti.f,v 1.4 2008-07-27 00:17:33 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE TDSETI (PNAM,IVAL)
C
      CHARACTER*(*) PNAM
C
C The subroutine TDSETI may be used to set TDPACK parameters which have
C values of type INTEGER.
C
C Check for an uncleared prior error.
C
        IF (ICFELL('TDSETI - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C Just convert it into a call to the routine TDSETR.
C
        CALL TDSETR (PNAM,REAL(IVAL))
        IF (ICFELL('TDSETI',2).NE.0) RETURN
C
C Done.
C
        RETURN
C
      END

C
C	$Id: csseti.f,v 1.7 2008-07-27 03:10:07 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CSSETI (CNP,IVP)
C
      SAVE
C
      CHARACTER*(*) CNP
C
C  This subroutine is called to give an integer value to a specified
C  parameter.
C
C  CNP is the name of the parameter whose value is to be set.
C
C  IVP is an integer variable containing the desired value.
C
C
C  Declare a local character variable in which to form an error message.       
C
      CHARACTER*80 CTM
C
      include 'cscomn.h'
C
C  Do a call forcing a BLOCKDATA to be loaded from a binary library.
C
      CALL CSBLDA
C
C  Check for an uncleared prior error.
C
      IF (ICFELL('CSSETI - Uncleared prior error',1) .NE. 0) RETURN
C
C  Check for a parameter name that is too short.
C
      IF (LEN(CNP) .LT. 3) THEN
        CTM(1:36) = 'CSSETI - Parameter name too short - '
        CTM(37:36+LEN(CNP)) = CNP
        CALL SETER (CTM(1:36+LEN(CNP)), 1, 1)
        GO TO 120
      ENDIF
C
C  Do a crude check to see if IVP is within range (primarily to 
C  make sure that a floating point number has not been supplied).
C
      IF (IVP .GT. 10000000) THEN
        CTM(1:42) = 'CSSETI - Parameter value out of range for '
        CTM(43:45) = CNP(1:3)
        CALL SETER (CTM(1:45), 2, 1)
        GO TO 120
      ENDIF
C
C  NLS - Number of nodes to use in least squares fit.
C
      IF (CNP(1:3).EQ.'NLS' .OR. CNP(1:3).EQ.'nls' .OR.
     +    CNP(1:3).EQ.'Nls') THEN
        NUMLS = IVP
        GO TO 120
C
C  NSG - Maximum number of iterations to use in computing SIGMA array.
C
      ELSE IF (CNP(1:3).EQ.'NSG' .OR. CNP(1:3).EQ.'nsg' .OR.
     +    CNP(1:3).EQ.'Nsg') THEN
        NUMIT = IVP
        GO TO 120
C
C  ISG - Flag to revert to calculating a SIGMA array rather than
C        use a constant SIGMA.  Using a constant SIGMA is effected
C        by setting a value for SIG using CSSETR.  If ICSIG is 0,
C        then a SIGMA array is used, otherwise a constant SIGMA is used.
C
      ELSE IF (CNP(1:3).EQ.'ISG' .OR. CNP(1:3).EQ.'isg' .OR.
     +    CNP(1:3).EQ.'Isg') THEN
         ICSIG = IVP
        GO TO 120
C
C  IGR - Flag to indicate whether local or global gradients should
C        be used.  IGR=1 means use global gradients; IGR=0 means
C        use local gradients.
C
      ELSE IF (CNP(1:3).EQ.'IGR' .OR. CNP(1:3).EQ.'igr' .OR.
     +    CNP(1:3).EQ.'Igr') THEN
         IGFLG = IVP
        GO TO 120
C
C  MVL - Missing value to be used with NCL functions that return arrays.
C        if MVL is set, it will be used as the missing value to be
C        returned.
C
      ELSE IF (CNP(1:3).EQ.'MVL' .OR. CNP(1:3).EQ.'mvl' .OR.
     +         CNP(1:3).EQ.'Mvl') THEN
        RMVAL = DBLE(IVP)
        GO TO 120
      ELSE
        CTM(1:36) = 'CSSETI - Parameter name not known - '
        CTM(37:39) = CNP(1:3)
        CALL SETER (CTM(1:39), 23, 1)
        GO TO 120
      ENDIF
C
  120 CONTINUE
      RETURN
      END

      PROGRAM WMEX07
C
C  Plot icons for daily weather.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C  Positioning coordinates.
C
      PARAMETER (XL1=0.20, XL2=0.50, XL3=0.80, 
     +           Y1 =0.83, Y2 =0.62, Y3 =0.40, Y4 =0.20,
     +           YL1=0.74, YL2=0.52, YL3=0.32, YL4=0.07)
      PARAMETER (SIZLAB=.02)
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C  Define a color table.
C
      CALL GSCR(1, 0, 1.00, 1.00, 1.00)
      CALL GSCR(1, 1, 0.00, 0.00, 0.00)
      CALL GSCR(1, 2, 0.00, 0.00, 1.00)
      CALL GSCR(1, 3, 0.00, 1.00, 0.00)
      CALL GSCR(1, 4, 1.00, 0.00, 0.00)
      CALL GSCR(1, 5, 1.00, 1.00, 0.00)
      CALL GSCR(1, 6, 1.00, 0.65, 0.00)
      CALL GSCR(1, 7, 0.85, 0.85, 0.85)
C
C  Plot title.
C
      CALL PLCHHQ(0.50,0.95,':F26:Icons for daily weather',0.033,0.,0.)       
C
C  Cloudy.
C
      CALL WMSETI('CC1 - cloud interior color ',7)
      CALL WMSETI('CC2 - cloud outline color',1)
      CALL WMSETI('CC3 - cloud shadow color',2)
      CALL WMSETR('SHT - size scale',0.013)
      CALL WMLABS(XL1,Y2-0.025,'C')
      CALL PLCHHQ(XL1,YL2,':F22:Cloudy',SIZLAB,0.,0.)       
C
C  Rain.
C
      CALL WMGETI('COL',ICOLD)
      CALL WMSETI('COL - rain color',1)
      CALL WMSETR('SHT - size scale',0.013)
      CALL WMLABS(XL2,Y2,'R')
      CALL WMSETI('COL - restore default color',ICOLD)
      CALL PLCHHQ(XL2,YL2,':F22:Rain',SIZLAB,0.,0.)       
C
C  T-storms.
C
      CALL WMSETI('LC1 - color of interior of lightening bolt ',5)
      CALL WMSETI('LC2 - outline color of lightening bolt',1)
      CALL WMSETI('LC3 - shadow color for lightening bolt',1)
      CALL WMSETR('SHT - size scale',0.013)
      CALL WMLABS(XL2,Y4,'T')
      CALL PLCHHQ(XL2+.02,YL4,':F22:T-storms',SIZLAB,0.,0.)       
C
C  Snow.
C
      CALL WMSETR('SHT - size scale',0.013)
      CALL WMLABS(XL3,Y2,'SN')
      CALL PLCHHQ(XL3,YL2,':F22:Snow',SIZLAB,0.,0.)       
C
C  Rain and snow.
C
      CALL WMSETR('SHT - size scale',0.013)
      CALL WMLABS(XL3,Y3+0.01,'RS')
      CALL PLCHHQ(XL3,YL3,':F22:Rain and snow',SIZLAB,0.,0.)       
C
C  Wind.
C
      CALL WMSETI('COL',2)
      CALL WMSETR('SHT - size scale',0.016)
      CALL GSLWSC(2.)
      CALL WMLABS(XL2,Y1,'WIND')
      CALL PLCHHQ(XL2,YL1,':F22:Windy',SIZLAB,0.,0.)       
      CALL WMSETI('COL',1)
      CALL GSLWSC(1.)
C
C  Mostly cloudy.
C
      CALL WMSETI('SC1 - color of the sun center',5)
      CALL WMSETI('SC2 - color of the sun star points',6)
      CALL WMSETI('SC3 - color of the sun outlines',1)
      CALL WMSETI('SC4 - sun shadow color',1)
      CALL WMSETR('SHT - size scale',0.013)
      CALL WMLABS(XL1,Y3,'MC')
      CALL PLCHHQ(XL1,YL3,':F22:Mostly cloudy',SIZLAB,0.,0.)       
C
C  Sunny.
C
      CALL WMSETR('SHT - size scale',0.013)
      CALL WMLABS(XL1,Y1,'SU')
      CALL PLCHHQ(XL1,YL1,':F22:Sunny',SIZLAB,0.,0.)       
C
C  Mostly sunny.
C
      CALL WMSETR('SHT - size scale',0.013)
      CALL WMLABS(XL2,Y3,'MS')
      CALL PLCHHQ(XL2,YL3,':F22:Mostly sunny',SIZLAB,0.,0.)       
C
C  Intermittent showers.
C
      CALL WMSETR('SHT - size scale',0.012)
      CALL WMLABS(XL3,Y4+.01,'IS')
      CALL PLCHHQ(XL3+0.02,YL4+0.017,':F22:Intermittent',SIZLAB,0.,0.)       
      CALL PLCHHQ(XL3+0.02,YL4-0.017,':F22:showers',SIZLAB,0.,0.)       
C
C  Sun, possible T-storms.
C
      CALL WMSETR('SHT - size scale',0.012)
      CALL WMLABS(XL1,Y4+.01,'IT')
      CALL PLCHHQ(XL1+0.02,YL4+0.017,':F22:Sun, possible',SIZLAB,0.,0.)       
      CALL PLCHHQ(XL1+0.02,YL4-0.017,':F22:T-storms',
     +            SIZLAB,0.,0.)       
C
C  Ice.
C
      CALL WMSETR('SHT - size scale',0.013)
      CALL WMLABS(XL3,Y1,'IC')
      CALL PLCHHQ(XL3,YL1,':F22:Ice',SIZLAB,0.,0.)       
C
      CALL FRAME
C
      CALL GDAWK(IWKID)
      CALL GCLWK(IWKID)
      CALL GCLKS
      STOP
C
      END

      SUBROUTINE CTRCON( NORM, UPLO, DIAG, N, A, LDA, RCOND, WORK,
     $                   RWORK, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     March 31, 1993 
*
*     .. Scalar Arguments ..
      CHARACTER          DIAG, NORM, UPLO
      INTEGER            INFO, LDA, N
      REAL               RCOND
*     ..
*     .. Array Arguments ..
      REAL               RWORK( * )
      COMPLEX            A( LDA, * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  CTRCON estimates the reciprocal of the condition number of a
*  triangular matrix A, in either the 1-norm or the infinity-norm.
*
*  The norm of A is computed and an estimate is obtained for
*  norm(inv(A)), then the reciprocal of the condition number is
*  computed as
*     RCOND = 1 / ( norm(A) * norm(inv(A)) ).
*
*  Arguments
*  =========
*
*  NORM    (input) CHARACTER*1
*          Specifies whether the 1-norm condition number or the
*          infinity-norm condition number is required:
*          = '1' or 'O':  1-norm;
*          = 'I':         Infinity-norm.
*
*  UPLO    (input) CHARACTER*1
*          = 'U':  A is upper triangular;
*          = 'L':  A is lower triangular.
*
*  DIAG    (input) CHARACTER*1
*          = 'N':  A is non-unit triangular;
*          = 'U':  A is unit triangular.
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  A       (input) COMPLEX array, dimension (LDA,N)
*          The triangular matrix A.  If UPLO = 'U', the leading N-by-N
*          upper triangular part of the array A contains the upper
*          triangular matrix, and the strictly lower triangular part of
*          A is not referenced.  If UPLO = 'L', the leading N-by-N lower
*          triangular part of the array A contains the lower triangular
*          matrix, and the strictly upper triangular part of A is not
*          referenced.  If DIAG = 'U', the diagonal elements of A are
*          also not referenced and are assumed to be 1.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(1,N).
*
*  RCOND   (output) REAL
*          The reciprocal of the condition number of the matrix A,
*          computed as RCOND = 1/(norm(A) * norm(inv(A))).
*
*  WORK    (workspace) COMPLEX array, dimension (2*N)
*
*  RWORK   (workspace) REAL array, dimension (N)
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ONE, ZERO
      PARAMETER          ( ONE = 1.0E+0, ZERO = 0.0E+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            NOUNIT, ONENRM, UPPER
      CHARACTER          NORMIN
      INTEGER            IX, KASE, KASE1
      REAL               AINVNM, ANORM, SCALE, SMLNUM, XNORM
      COMPLEX            ZDUM
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            ICAMAX
      REAL               CLANTR, SLAMCH
      EXTERNAL           LSAME, ICAMAX, CLANTR, SLAMCH
*     ..
*     .. External Subroutines ..
      EXTERNAL           CLACON, CLATRS, CSRSCL, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, AIMAG, MAX, REAL
*     ..
*     .. Statement Functions ..
      REAL               CABS1
*     ..
*     .. Statement Function definitions ..
      CABS1( ZDUM ) = ABS( REAL( ZDUM ) ) + ABS( AIMAG( ZDUM ) )
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      UPPER = LSAME( UPLO, 'U' )
      ONENRM = NORM.EQ.'1' .OR. LSAME( NORM, 'O' )
      NOUNIT = LSAME( DIAG, 'N' )
*
      IF( .NOT.ONENRM .AND. .NOT.LSAME( NORM, 'I' ) ) THEN
         INFO = -1
      ELSE IF( .NOT.UPPER .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = -2
      ELSE IF( .NOT.NOUNIT .AND. .NOT.LSAME( DIAG, 'U' ) ) THEN
         INFO = -3
      ELSE IF( N.LT.0 ) THEN
         INFO = -4
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -6
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'CTRCON', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 ) THEN
         RCOND = ONE
         RETURN
      END IF
*
      RCOND = ZERO
      SMLNUM = SLAMCH( 'Safe minimum' )*REAL( MAX( 1, N ) )
*
*     Compute the norm of the triangular matrix A.
*
      ANORM = CLANTR( NORM, UPLO, DIAG, N, N, A, LDA, RWORK )
*
*     Continue only if ANORM > 0.
*
      IF( ANORM.GT.ZERO ) THEN
*
*        Estimate the norm of the inverse of A.
*
         AINVNM = ZERO
         NORMIN = 'N'
         IF( ONENRM ) THEN
            KASE1 = 1
         ELSE
            KASE1 = 2
         END IF
         KASE = 0
   10    CONTINUE
         CALL CLACON( N, WORK( N+1 ), WORK, AINVNM, KASE )
         IF( KASE.NE.0 ) THEN
            IF( KASE.EQ.KASE1 ) THEN
*
*              Multiply by inv(A).
*
               CALL CLATRS( UPLO, 'No transpose', DIAG, NORMIN, N, A,
     $                      LDA, WORK, SCALE, RWORK, INFO )
            ELSE
*
*              Multiply by inv(A').
*
               CALL CLATRS( UPLO, 'Conjugate transpose', DIAG, NORMIN,
     $                      N, A, LDA, WORK, SCALE, RWORK, INFO )
            END IF
            NORMIN = 'Y'
*
*           Multiply by 1/SCALE if doing so will not cause overflow.
*
            IF( SCALE.NE.ONE ) THEN
               IX = ICAMAX( N, WORK, 1 )
               XNORM = CABS1( WORK( IX ) )
               IF( SCALE.LT.XNORM*SMLNUM .OR. SCALE.EQ.ZERO )
     $            GO TO 20
               CALL CSRSCL( N, SCALE, WORK, 1 )
            END IF
            GO TO 10
         END IF
*
*        Compute the estimate of the reciprocal condition number.
*
         IF( AINVNM.NE.ZERO )
     $      RCOND = ( ONE / ANORM ) / AINVNM
      END IF
*
   20 CONTINUE
      RETURN
*
*     End of CTRCON
*
      END

C
C $Id: mdpusr.f,v 1.8 2008-09-18 00:42:17 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MDPUSR (IPRT)
        INTEGER IPRT
        RETURN
      END

C
C $Id: tdgeti.f,v 1.4 2008-07-27 00:17:32 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE TDGETI (PNAM,IVAL)
C
      CHARACTER*(*) PNAM
C
C The subroutine TDGETI may be used to get TDPACK parameters which have
C values of type INTEGER.
C
C Check for an uncleared prior error.
C
        IF (ICFELL('TDGETI - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C Just convert it into a call to the routine TDGETR.
C
        CALL TDGETR (PNAM,RVAL)
        IF (ICFELL('TDGETI',2).NE.0) RETURN
        IVAL=INT(RVAL)
C
C Done.
C
        RETURN
C
      END

      SUBROUTINE CLASET( UPLO, M, N, ALPHA, BETA, A, LDA )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     October 31, 1992
*
*     .. Scalar Arguments ..
      CHARACTER          UPLO
      INTEGER            LDA, M, N
      COMPLEX            ALPHA, BETA
*     ..
*     .. Array Arguments ..
      COMPLEX            A( LDA, * )
*     ..
*
*  Purpose
*  =======
*
*  CLASET initializes a 2-D array A to BETA on the diagonal and
*  ALPHA on the offdiagonals.
*
*  Arguments
*  =========
*
*  UPLO    (input) CHARACTER*1
*          Specifies the part of the matrix A to be set.
*          = 'U':      Upper triangular part is set. The lower triangle
*                      is unchanged.
*          = 'L':      Lower triangular part is set. The upper triangle
*                      is unchanged.
*          Otherwise:  All of the matrix A is set.
*
*  M       (input) INTEGER
*          On entry, M specifies the number of rows of A.
*
*  N       (input) INTEGER
*          On entry, N specifies the number of columns of A.
*
*  ALPHA   (input) COMPLEX
*          All the offdiagonal array elements are set to ALPHA.
*
*  BETA    (input) COMPLEX
*          All the diagonal array elements are set to BETA.
*
*  A       (input/output) COMPLEX array, dimension (LDA,N)
*          On entry, the m by n matrix A.
*          On exit, A(i,j) = ALPHA, 1 <= i <= m, 1 <= j <= n, i.ne.j;
*                   A(i,i) = BETA , 1 <= i <= min(m,n)
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(1,M).
*
*  =====================================================================
*
*     .. Local Scalars ..
      INTEGER            I, J
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MIN
*     ..
*     .. Executable Statements ..
*
      IF( LSAME( UPLO, 'U' ) ) THEN
*
*        Set the diagonal to BETA and the strictly upper triangular
*        part of the array to ALPHA.
*
         DO 20 J = 2, N
            DO 10 I = 1, MIN( J-1, M )
               A( I, J ) = ALPHA
   10       CONTINUE
   20    CONTINUE
         DO 30 I = 1, MIN( N, M )
            A( I, I ) = BETA
   30    CONTINUE
*
      ELSE IF( LSAME( UPLO, 'L' ) ) THEN
*
*        Set the diagonal to BETA and the strictly lower triangular
*        part of the array to ALPHA.
*
         DO 50 J = 1, MIN( M, N )
            DO 40 I = J + 1, M
               A( I, J ) = ALPHA
   40       CONTINUE
   50    CONTINUE
         DO 60 I = 1, MIN( N, M )
            A( I, I ) = BETA
   60    CONTINUE
*
      ELSE
*
*        Set the array to BETA on the diagonal and ALPHA on the
*        offdiagonal.
*
         DO 80 J = 1, N
            DO 70 I = 1, M
               A( I, J ) = ALPHA
   70       CONTINUE
   80    CONTINUE
         DO 90 I = 1, MIN( M, N )
            A( I, I ) = BETA
   90    CONTINUE
      END IF
*
      RETURN
*
*     End of CLASET
*
      END

C
C $Id: pj18sp.f,v 1.5 2008-07-27 00:17:11 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE PJ18SP (COORD,CRDIO,INDIC)
C
C -- M I L L E R   C Y L I N D R I C A L
C
      IMPLICIT REAL (A-Z)
      INTEGER INDIC
      DIMENSION GEOG(2),PROJ(2),COORD(2),CRDIO(2)
C **** PARAMETERS **** A,LON0,X0,Y0 ************************************
      COMMON /ERRMZ0/ IERR
        INTEGER IERR
      SAVE   /ERRMZ0/
      COMMON /PRINZ0/ IPEMSG,IPELUN,IPPARM,IPPLUN
        INTEGER IPEMSG,IPELUN,IPPARM,IPPLUN
      SAVE   /PRINZ0/
      COMMON /PC18SP/ A,LON0,X0,Y0
      DATA FORTPI /0.78539816339744833E0/
      DATA ZERO,ONEQ,TWOH /0.0E0,1.25E0,2.5E0/
C
C -- F O R W A R D   . . .
C
      IF (INDIC .EQ. 0) THEN
C
         GEOG(1) = COORD(1)
         GEOG(2) = COORD(2)
         IERR = 0
         LON = ADJLSP (GEOG(1) - LON0)
         PROJ(1) = X0 + A * LON
         PROJ(2) = Y0 + A * LOG (TAN (FORTPI + GEOG(2) / TWOH)) * ONEQ
         CRDIO(1) = PROJ(1)
         CRDIO(2) = PROJ(2)
         RETURN
      END IF
C
C -- I N V E R S E   . . .
C
      IF (INDIC .EQ. 1) THEN
C
         PROJ(1) = COORD(1)
         PROJ(2) = COORD(2)
         IERR = 0
         X = PROJ(1) - X0
         Y = PROJ(2) - Y0
         GEOG(1) = ADJLSP (LON0 + X / A)
         GEOG(2) = TWOH * ATAN (EXP (Y / A / ONEQ)) - FORTPI * TWOH
         CRDIO(1) = GEOG(1)
         CRDIO(2) = GEOG(2)
         RETURN
      END IF
C
      END

      PROGRAM CARFILL
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER (LMAP=5000, NMAP=43, NPTS=50, NCNTR=5, NGRPS=2)
      PARAMETER (NWRK=1000)
      
      INTEGER MAP(LMAP), IAREA(NGRPS), IGRP(NGRPS)
      REAL XGEO(NMAP), YGEO(NMAP), X(12), Y(12)
      REAL XCNTR(NPTS), YCNTR1(NPTS), YCNTR2(NPTS), YCNTR3(NPTS)
      REAL YCNTR4(NPTS), YCNTR5(NPTS), XPERIM(5), YPERIM(5)
      REAL XWRK(NWRK), YWRK(NWRK)
      CHARACTER*14 STRING
      
      DATA XGEO / .63, .12, .05, .07, .10, .04, .19, .31, .31, .41,
     +     .39, .47, .64, .63, .70, .66, .67, .69, .76, .92,
     2     .95, .69, .64, .53, .53, .60, .63, .63, .72, .74,
     3     .79, .75, .75, .80, .75, .70, .68, .64, .63, .55,
     4     .55, .63, .63/
      DATA YGEO / .94, .95, .92, .85, .83, .78, .84, .75, .69, .58,
     +     .64, .55, .47, .37, .30, .05, .03, .05, .13, .26,
     2     .38, .52, .50, .57, .63, .63, .59, .64, .72, .71,
     3     .75, .75, .77, .78, .85, .83, .86, .86, .77, .80,
     4     .86, .90, .94/
      DATA XPERIM /0.0, 1.0, 1.0, 0.0, 0.0/
      DATA YPERIM /0.0, 0.0, 1.0, 1.0, 0.0/
      DATA X /.10, .22, .25, .25, .25, .50,
     +     .30, .47, .50, .77, .75, .68/
      DATA Y /.98, .70, .55, .38, .18, .18,
     +     .90, .85, .70, .35, .18, .05/
      
      EXTERNAL FILL
      
      XCNTR(1) = 0.0
      YCNTR1(1) = 0.25
      YCNTR2(1) = 0.40
      YCNTR3(1) = 0.60
      YCNTR4(1) = 0.80
      YCNTR5(1) = 0.95
      DO 10 J=2,NPTS
         DIST = REAL(J)/REAL(NPTS)
         XCNTR(J) = DIST
         YCNTR1(J) = .1*COS(REAL(4*3.14*DIST))+.15
         YCNTR2(J) = .1*COS(REAL(4*3.14*DIST))+.30
         YCNTR3(J) = .1*COS(REAL(4*3.14*DIST))+.50
         YCNTR4(J) = .1*COS(REAL(4*3.14*DIST))+.70
         YCNTR5(J) = .1*COS(REAL(4*3.14*DIST))+.85
 10   CONTINUE

C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)

      CALL COLOR(IWKID)
C
C Set the fill area option to solid
C
      CALL GSFAIS(1)
C
C Initialize Areas
C
      CALL ARINAM (MAP,LMAP)
C
C Add continents to area map in group 1.
C
      CALL AREDAM (MAP, XGEO, YGEO, NMAP, 1, 2, 1)
C
C Add contours and perimeter to area map in group 3.
C
      CALL AREDAM (MAP, XCNTR, YCNTR1, NPTS, 3, 2, 1)
      CALL AREDAM (MAP, XCNTR, YCNTR2, NPTS, 3, 3, 2)
      CALL AREDAM (MAP, XCNTR, YCNTR3, NPTS, 3, 4, 3)
      CALL AREDAM (MAP, XCNTR, YCNTR4, NPTS, 3, 5, 4)
      CALL AREDAM (MAP, XCNTR, YCNTR5, NPTS, 3, 6, 5)
C
C Fill water blue and contour lines according to area id.
C
      CALL ARSCAM(MAP,XWRK,YWRK,NWRK,IAREA,IGRP,NGRPS,FILL)
C
C Write out area and group identifiers for each area, using red for
C geographic identifiers, and green for contour identifiers.
C
      CALL SFLUSH
      CALL GSPLCI(0)
      DO 20 I=1,12
         CALL ARGTAI(MAP, X(I), Y(I), IAREA, IGRP, NGRPS, NAI, 0)
         DO 30 J=1,2
            IF ((I.LE.6).OR.(I.EQ.12)) CALL GSPLCI(3)
            IF (I.EQ.7) CALL GSPLCI(0)
            IF (I.EQ.8) CALL GSPLCI(3)
            IF (I.EQ.9) CALL GSPLCI(6)
            IF (I.EQ.10) CALL GSPLCI(0)
            IF (I.EQ.11) CALL GSPLCI(3)
            WRITE (STRING,11) J,IAREA(J),J,IGRP(J)
            IF (IGRP(J).EQ.1) THEN
               CALL PLCHHQ (X(I), Y(I), STRING, .01, 0., 0.)
            ENDIF
            IF (IGRP(J).EQ.3) THEN
               CALL PLCHHQ (X(I), Y(I)-.02, STRING, .01, 0., 0.)
            ENDIF
 30      CONTINUE
 20   CONTINUE
C
C Draw contours and perimeter in white
C
      CALL GSPLCI (6)
      CALL CURVE (XCNTR,YCNTR1,NPTS)
      CALL CURVE (XCNTR,YCNTR2,NPTS)
      CALL CURVE (XCNTR,YCNTR3,NPTS)
      CALL CURVE (XCNTR,YCNTR4,NPTS)
      CALL CURVE (XCNTR,YCNTR5,NPTS)
      CALL CURVE (XPERIM,YPERIM,5)
      
      CALL FRAME
C
C Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
C Write out amount of space needed for the area map
C
      ISPACE = MAP(1) - MAP(6) + MAP(5)
      WRITE (6,*) 'Area Map Space Used: ',ISPACE
      
 11   FORMAT ('A(',I1,')=',I1,' G(',I1,')=',I1)
      STOP
      END
      
      SUBROUTINE COLOR(IWKID)
C
C Define color table
C
C Background is black
C
      CALL GSCR(IWKID,0,0.,0.,0.)
C
C Red
C
      CALL GSCR(IWKID,1,1.,0.,0.)
C
C Green
C
      CALL GSCR(IWKID,2,0.,1.,0.)
C
C Yellow
C
      CALL GSCR(IWKID,3,1.,1.,0.)
C
C Blue
C
      CALL GSCR(IWKID,4,0.,0.,1.)
C
C Magenta
C
      CALL GSCR(IWKID,5,1.,0.,1.)
C
C White
C
      CALL GSCR(IWKID,6,1.,1.,1.)
C
C Aqua
C
      CALL GSCR(IWKID,7,0.,1.,1.)

      RETURN
      END

      SUBROUTINE FILL(XWRK,YWRK,NWRK,IAREA,IGRP,NGRPS)

      INTEGER IAREA(NGRPS),IGRP(NGRPS),IDGEO,IDCNTR
      REAL XWRK(NWRK),YWRK(NWRK)

      IDGEO=-1
      IDCNTR=-1
C
C Retrieve geographic and contour area identifier info
C
      DO 10, I=1,NGRPS
         IF (IGRP(I).EQ.1) IDGEO=IAREA(I)
         IF (IGRP(I).EQ.3) IDCNTR=IAREA(I)
 10   CONTINUE
C
C If the contour segment is over water, then fill it in aquamarine
C
      IF (IDGEO .EQ. 1) THEN
         CALL GSFACI(7)
         CALL GFA(NWRK,XWRK,YWRK)
C
C If the contour band is over land, then fill it according to it's 
C area identifier info.
C
      ELSE IF ((IDGEO .EQ. 2) .AND. (IDCNTR .GE. 1)) THEN
         CALL GSFACI(IDCNTR)
         CALL GFA(NWRK,XWRK,YWRK)
      ENDIF

      RETURN
      END

C
C	$Id: gwisas.f,v 1.4 2008-07-27 00:21:08 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GWISAS (IPRIM, RERR)
C
C  Send aspect source flags.
C
      INTEGER  IPRIM, RERR
C
      include 'gwiins.h'
      include 'gwiadc.h'
      include 'gwiarq.h'
      include 'gwiast.h'
      include 'gwiopc.h'
C
      INTEGER  IX, MIX, NCHANG, ASPAIR(2), NBYTES
C
C  Count the number of changed (CGM) ASFs first.
C
      NCHANG = 0
      DO 10 IX=1,NCGASF
C
C  Get the index of the associated GKS ASF.
C
        MIX = MASMAP(IX)
        IF (MIX.GT.0)  THEN
          IF (ASFCHG(MIX))  NCHANG = NCHANG + 1
        END IF
   10 CONTINUE
      IF (NCHANG .EQ. 0) GO TO 30
C
C  Compute byte length of instruction, put out opcode/length.
C
      NBYTES = 1 + (NCHANG*2*MEFW-1)/8
      CALL GWPTNI (CLASFS, IDASFS, NBYTES, RERR)
      IF (RERR .NE. 0)  GO TO 777
C
C  Put out each changed ASF.
C
      DO 20 IX=1,NCGASF
        MIX = MASMAP(IX)
        IF (MIX.GT.0)  THEN
          IF (ASFCHG(MIX))  THEN
C
C  Form index/value pair for changed ASF, send it.
C
            ASPAIR(1)   = IX - 1
            ASPAIR(2)   = MRASF(MIX)
            CALL GWPTPR (ASPAIR, MEFW, 2, RERR)
            IF (RERR .NE. 0)  RETURN
          END IF
        END IF
 20   CONTINUE
C
C  Copy requested (GKS) ASF to sent, clear the change flag.
C
      DO 40 IX=1,NCGASF
        MIX = MASMAP(IX)
        IF (MIX .GT. 0) THEN
          IF (ASFCHG(MIX)) THEN
            MSASF(MIX)  = MRASF(MIX)
            ASFCHG(MIX) = .FALSE.
          ENDIF
        ENDIF
   40 CONTINUE
C
C  Clear aggregate ASF change indicator.
C
   30 CONTINUE
      ANYASF = .FALSE.
C
 777  CONTINUE
C
      RETURN
      END

C
C $Id: mputfs.f,v 1.6 2008-07-27 00:17:09 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MPUTFS (RLAT,RLON,UVAL,VVAL)
        REAL RLAT,RLON,UVAL,VVAL
        CALL MDUTFS (RLAT,RLON,UVAL,VVAL)
        RETURN
      END

      PROGRAM TSOFTF
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C OPEN GKS, OPEN WORKSTATION OF TYPE 1, ACTIVATE WORKSTATION
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C INVOKE DEMO DRIVER
C
      CALL SOFTF(IERR,IWKID)
C
C DEACTIVATE AND CLOSE WORKSTATION, CLOSE GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END
C
      SUBROUTINE SOFTF (IERR,IWKID)
C
C LATEST REVISION       July, 1989
C
C PURPOSE               To provide a simple demonstration of software
C                       fill of polygons using the SOFTFILL package.
C
C USAGE                 CALL SOFTF (IERR,IWKID)
C
C ARGUMENTS (OUTPUT)    IERR
C
C                         An integer variable
C                         = 0, if the test was successful
C                         = 1, otherwise
C
C I/O                   If the test is successful, the message "SOFTFILL
C                       TEST EXECUTED--SEE PLOT TO CERTIFY" is printed
C                       on unit 6.  In addition, a frame is produced on
C                       the graphics device.  In order to determine if
C                       the test was successful, it is necessary to
C                       examine this frame.
C
C PRECISION             Single.
C
C LANGUAGE              FORTRAN 77.
C
C REQUIRED ROUTINES     SOFTFILL package.
C
C REQUIRED GKS LEVEL    0A.
C
C ALGORITHM             Nine circles are filled in various ways, using
C                       routines in the package.
C
C
C Declare required dimensioned arrays.
C
        DIMENSION XRA(106),YRA(106),DST(126),IND(146),XSV(101),YSV(101)
        DIMENSION ID1(8,8),ID2(8,8),ID3(8,8),ID4(8,8)
C
C Define four different dot patterns.
C
        DATA ID1 / 1,1,0,0,0,0,1,1,
     +             1,1,0,1,1,0,1,1,
     +             0,0,0,1,1,0,0,0,
     +             0,1,1,1,1,1,1,0,
     +             0,1,1,1,1,1,1,0,
     +             0,0,0,1,1,0,0,0,
     +             1,1,0,1,1,0,1,1,
     +             1,1,0,0,0,0,1,1/
        DATA ID2 / 0,0,0,0,0,0,0,0,
     +             0,1,1,1,1,1,1,0,
     +             0,1,1,1,1,1,1,0,
     +             0,1,1,0,0,1,1,0,
     +             0,1,1,0,0,1,1,0,
     +             0,1,1,1,1,1,1,0,
     +             0,1,1,1,1,1,1,0,
     +             0,0,0,0,0,0,0,0/
        DATA ID3 / 0,0,0,0,0,0,0,0,
     +             0,0,0,0,1,0,0,0,
     +             0,0,0,1,1,1,0,0,
     +             0,1,0,0,1,0,0,1,
     +             0,0,1,1,1,1,1,0,
     +             0,0,0,0,1,0,0,0,
     +             0,0,0,1,0,1,0,0,
     +             0,1,1,0,0,0,1,1/
        DATA ID4 / 0,0,0,0,0,0,0,0,
     +             0,1,1,0,0,1,1,1,
     +             0,1,1,0,0,1,1,0,
     +             0,1,1,0,1,1,0,0,
     +             0,1,1,1,1,0,0,0,
     +             0,1,1,0,1,1,0,0,
     +             0,1,1,0,0,1,1,0,
     +             0,1,1,0,0,1,1,1/
C
C Initialize the error parameter.
C
        IERR=0
C
C Double the size of the GKS dot.
C
        CALL GSMKSC (2.)
C
C Force solid fill.
C
        CALL GSFAIS (1)
C
C Turn off the clipping indicator.
C
        CALL GSCLIP (0)
C
C Define a bunch of color indices.
C
        CALL SFCLRS(IWKID)
C
C Do a set call allowing us to use X and Y coordinates in the range
C from 0 to 4.
C
        CALL SET (0.,1.,0.,1.,0.,4.,0.,4.,1)
C
C Put a label at the top of the frame.
C
        CALL PLCHLQ(2.,3.75,'DEMONSTRATION PLOT FOR SOFTFILL',16.,0.,0.)
C
C Return the basic internal parameters to their default values.
C
        CALL SFSETI ('AN',0)
        CALL SFSETI ('CH',0)
        CALL SFSETI ('DO',0)
        CALL SFSETR ('SP',.00125)
        CALL SFSETI ('TY',0)
C
C The following code creates a single frame showing nine circles filled
C in various ways.  The DO-loop variable I says which row of circles
C we're working on (1 => top, 2 => middle, 3 => bottom).  The DO-loop
C variable J says which column of circles we're working C on (1 =>
C left, 2 => center, 3 => right).  The variable K gives the number of
C the circle currently being drawn and is used in a computed GO TO to
C determine which block of code is executed.
C
        DO 112 I=1,3
C
          YCN=REAL(4-I)
C
          DO 111 J=1,3
C
            XCN=REAL(J)
C
            K=3*(I-1)+J
C
C Generate the coordinates defining the circle.  Two sets of arrays are
C used, one set for use in calling the fill routines, which transform
C the contents of the arrays, and one set for use in drawing the circle.
C
            DO 100 L=1,101
              XRA(L)=XCN+.48*SIN(.062831853071796*REAL(L))
              XSV(L)=XRA(L)
              YRA(L)=YCN+.48*COS(.062831853071796*REAL(L))
              YSV(L)=YRA(L)
  100       CONTINUE
C
C Jump to the proper piece of code to fill the circle.
C
            GO TO (101,102,103,104,105,106,107,108,109) , K
C
C Fill the first circle in color number 5.
C
  101       CALL SFSETI ('TYPE OF FILL',0)
            CALL SFSGFA (XRA,YRA,100,DST,126,IND,146,5)
            GO TO 110
C
C Add a diamond-shaped hole to the circle and fill it in color number
C 9, using lines in two directions to effect the fill.
C
  102       XRA(101)=2.00
            YRA(101)=3.24
            XRA(102)=1.76
            YRA(102)=3.00
            XRA(103)=2.00
            YRA(103)=2.76
            XRA(104)=2.24
            YRA(104)=3.00
            XRA(105)=XRA(101)
            YRA(105)=YRA(101)
            XRA(106)=XRA(100)
            YRA(106)=YRA(100)
            CALL SFSETI ('TYPE OF FILL',2)
            CALL SFSGFA (XRA,YRA,106,DST,126,IND,146,9)
            GO TO 110
C
C Create a more complicated hole in the third circle and fill it with
C pattern number 11 of the 20 or so that can be created using 'TY'=-4.
C
  103       XRA(101)=XRA( 40)
            YRA(101)=YRA( 40)
            XRA(102)=XRA( 80)
            YRA(102)=YRA( 80)
            XRA(103)=XRA( 20)
            YRA(103)=YRA( 20)
            XRA(104)=XRA( 60)
            YRA(104)=YRA( 60)
            XRA(105)=XRA(100)
            YRA(105)=YRA(100)
            CALL SFSETI ('TYPE OF FILL',-4)
            CALL SFSGFA (XRA,YRA,105,DST,126,IND,146,11)
            CALL SFSETI ('ANGLE OF FILL LINES',15)
            GO TO 110
C
C Fill the fourth circle with the default dot pattern, increasing the
C inter-dot spacing considerably.
C
  104       CALL SFSETR ('SPACING OF FILL LINES',.005)
            CALL SFSETI ('ANGLE OF FILL LINES',0)
            CALL SFSETI ('DOT-FILL FLAG',1)
            CALL SFWRLD (XRA,YRA,100,DST,126,IND,146)
            GO TO 110
C
C Fill the fifth circle with a combination of lines and dots.
C
  105       CALL SFSETR ('SPACING OF FILL LINES',.012)
            CALL SFSETI ('DOT-FILL FLAG',0)
            CALL SFWRLD (XRA,YRA,100,DST,126,IND,146)
            CALL SFSETR ('SPACING OF FILL LINES',.006)
            CALL SFSETI ('DOT-FILL FLAG',1)
            CALL SFNORM (XRA,YRA,100,DST,126,IND,146)
            GO TO 110
C
C Fill the sixth circle with a specified dot pattern.
C
  106       CALL SFSETR ('SPACING OF FILL LINES',.004)
            CALL SFSETP (ID1)
            CALL SFWRLD (XRA,YRA,100,DST,126,IND,146)
            GO TO 110
C
C Fill the seventh circle with a different dot pattern, tilted at an
C angle.
C
  107       CALL SFSETI ('ANGLE OF FILL LINES',45)
            CALL SFSETP (ID2)
            CALL SFWRLD (XRA,YRA,100,DST,126,IND,146)
            GO TO 110
C
C Fill the eighth circle with a different dot pattern, using characters.
C
  108       CALL GSCHH  (.004)
            CALL SFSETR ('SPACING OF FILL LINES',.006)
            CALL SFSETI ('ANGLE OF FILL LINES',0)
            CALL SFSETC ('CHARACTER SPECIFIER','O')
            CALL SFSETP (ID3)
            CALL SFWRLD (XRA,YRA,100,DST,126,IND,146)
            GO TO 110
C
C Fill the last circle with K's, both large and small.
C
  109       CALL GSCHH  (.008)
            CALL SFSETR ('SPACING OF FILL LINES',.012)
            CALL SFSETC ('CHARACTER SPECIFIER','K')
            CALL SFSETP (ID4)
            CALL SFWRLD (XRA,YRA,100,DST,126,IND,146)
            GO TO 110
C
C Draw the circle.
C
  110       CALL CURVE (XSV,YSV,101)
C
  111     CONTINUE
C
  112   CONTINUE
C
C Advance the frame.
C
        CALL FRAME
C
C Log execution message and return to caller.
C
        WRITE (6,1001)
        RETURN
C
 1001   FORMAT (' SOFTFILL TEST EXECUTED--SEE PLOT TO CERTIFY')
C
      END


      SUBROUTINE SFCLRS(IWKID)
C
C Define a set of RGB color triples for colors 1 through 15.
C
        DIMENSION RGBV(3,15)
C
C Define the RGB color triples needed below.
C
        DATA RGBV / 1.00 , 1.00 , 1.00 ,
     +              0.70 , 0.70 , 0.70 ,
     +              0.75 , 0.50 , 1.00 ,
     +              0.50 , 0.00 , 1.00 ,
     +              0.00 , 0.00 , 1.00 ,
     +              0.00 , 0.50 , 1.00 ,
     +              0.00 , 1.00 , 1.00 ,
     +              0.00 , 1.00 , 0.60 ,
     +              0.00 , 1.00 , 0.00 ,
     +              0.70 , 1.00 , 0.00 ,
     +              1.00 , 1.00 , 0.00 ,
     +              1.00 , 0.75 , 0.00 ,
     +              1.00 , 0.38 , 0.38 ,
     +              1.00 , 0.00 , 0.38 ,
     +              1.00 , 0.00 , 0.00 /
C
C Define 16 different color indices, for indices 0 through 15.  The
C color corresponding to index 0 is black and the color corresponding
C to index 1 is white.
C
        CALL GSCR (IWKID,0,0.,0.,0.)
C
        DO 101 I=1,15
          CALL GSCR (IWKID,I,RGBV(1,I),RGBV(2,I),RGBV(3,I))
  101   CONTINUE
C
C Done.
C
        RETURN
C
      END

C
C $Id: agmini.f,v 1.6 2008-07-27 00:14:35 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      FUNCTION AGMINI (SVAL,ZLOW,ZDRA,NVIZ,IIVZ,NEVZ,IIEZ)
C
      DIMENSION ZDRA(1)
C
C The routine AGMINI returns the mimimum value of the elements in ZDRA
C specified by NVIZ, IIVZ, NEVZ, and IIEZ, skipping elements having the
C special value SVAL (or less than ZLOW, if ZLOW is not equal to SVAL).
C
C -- NVIZ is the number of vectors of data stored in ZDRA.
C
C -- IIVZ is the index increment from one data vector to the next.
C
C -- NEVZ is the number of elements per vector to be examined.
C
C -- IIEZ is the index increment from one vector element to the next.
C    If IIEZ is 0, the array is ignored and 1. is returned.
C
      AGMINI=1.
      IF (IIEZ.EQ.0) RETURN
C
      AGMINI=SVAL
      INDZ=1-IIEZ
C
      DO 103 I=1,NVIZ
        IF (ZLOW.EQ.SVAL) THEN
          DO 101 J=1,NEVZ
            INDZ=INDZ+IIEZ
            IF (ZDRA(INDZ).EQ.SVAL) GO TO 101
            IF (AGMINI.EQ.SVAL) AGMINI=ZDRA(INDZ)
            AGMINI=MIN(AGMINI,ZDRA(INDZ))
  101     CONTINUE
        ELSE
          DO 102 J=1,NEVZ
            INDZ=INDZ+IIEZ
            IF (ZDRA(INDZ).EQ.SVAL.OR.ZDRA(INDZ).LT.ZLOW) GO TO 102
            IF (AGMINI.EQ.SVAL) AGMINI=ZDRA(INDZ)
            AGMINI=MIN(AGMINI,ZDRA(INDZ))
  102     CONTINUE
        END IF
        INDZ=INDZ-NEVZ*IIEZ+IIVZ
  103 CONTINUE
C
      RETURN
C
      END

C
C	$Id: pcrbin.f,v 1.5 2008-07-27 01:04:31 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C

      PROGRAM PCRBIN
C
C Because of the difficulty of porting a binary file, the database
C for the PWRITX package is supplied on the distribution tape in
C the four card-image files
C
C   PWRITXC1
C   PWRITXC2
C   PWRITXD1
C   PWRITXD2
C
C PWRITX  uses a binary file as its database.  This program (PCRBIN),
C converts the four card-image files mentioned above into one binary
C file having four records.
C
C After  PCRBIN  has created the desired binary file, it calls two
C short test routines to make sure that accessing of all records
C works correctly.  A message is printed as to the success or
C failure of the test routines.
C
C This program uses the support routines ISHIFT, IAND, and IOR which
C are required locally-implemented support routines for the NCAR
C GKS package.  Also, the entry SETER of the error package ERPRT77
C is invoked.
C
C Before executing PCRBIN the implementation-dependent canstants in
C the BLOCKDATA DPORTX must be set.  Also, make the four files
C PWRITXC1, PWRITXC2, PWRITXD1, and PWRITXD2 available on the
C units specified in BLOCKDATA DPORTX.  Ready the unit specified
C in BLOCKDATA DPORTX to receive the created binary output file
C (the file which will ultimately be used by PWRITX.)
C
C **********************************************************************
C
C          D E C L A R A T I O N S
C
C **********************************************************************
C
C Note that the sizes of IDD, IND, and IWORK may have to be modified
C to contain the number of elements equal to the values of IDDLEN and
C INDLEN as computed in the code below.
C
      COMMON/PWRC0/IDD(8626),IND(789)
      COMMON/IDC0/LENWOR,IWORK(8626)
C
C FOR INITIALIZATION OF CONSTANTS IN CREBIN
C
      COMMON/IDC2/MASK15(15)
C
C FOR INITIALIZATION OF CONSTANTS IN CREBIN AND CREB15
C
      COMMON/IDC1/NBWD,IZERO,MA15
C
C FOR INITIALIZATION OF MACHINE DEPENDENT CONSTANTS
C
      COMMON/PINIT2/FLAG
      LOGICAL FLAG
C
C CONSTANTS DEFINED IN BLOCK DATA DPORTX.
C
      COMMON /IDC3/ IU1,IU2,IU3,IU4,IOUT,ICNUM1,ICNUM2,IDDLEN,INDLEN
C
C  Do a call forcing a BLOCKDATA to be loaded from a binary library.
C
      CALL DPORT
C
C CHECK IF IMPLEMENTATION DEPENDENT CONSTANTS ARE INITIALIZED.
C
      IF (IU1.NE.0) GO TO 1
      CALL SETER(' PCRBIN - MACHINE DEPENDENT CONSTANSTS NOT SET',1,2)
    1 CONTINUE
C
C Open all required datasets.
C
      OPEN (UNIT= IU1,STATUS='OLD',FILE= 'pwritxc1',ERR=901)
      OPEN (UNIT= IU2,STATUS='OLD',FILE= 'pwritxc2',ERR=902)
      OPEN (UNIT= IU3,STATUS='OLD',FILE= 'pwritxd1',ERR=903)
      OPEN (UNIT= IU4,STATUS='OLD',FILE= 'pwritxd2',ERR=904)
      OPEN (UNIT=IOUT,STATUS='NEW',FILE='pwritdata',ERR=905,
     +                                   FORM='UNFORMATTED')
      GO TO 906
  901 PRINT * , 'ERROR OPENING INPUT UNIT (pwritxc1).'
      STOP
  902 PRINT * , 'ERROR OPENING INPUT UNIT (pwritxc2).'
      STOP
  903 PRINT * , 'ERROR OPENING INPUT UNIT (pwritxd1).'
      STOP
  904 PRINT * , 'ERROR OPENING INPUT UNIT (pwritxd2).'
      STOP
  905 PRINT * , 'ERROR OPENING OUTPUT UNIT (pwritdata).'
      STOP
  906 CONTINUE
C
C
C            INITIALIZATION  PASS
C
C CHECK IF DONE
C
      IF (FLAG) GO TO 9000
      FLAG = .TRUE.
C
C GET NUMBER OF BITS PER WORD
C
      NBWD = I1MACH(5)
C
C FIND THE NUMBER OF 15 BIT PARCELS PER WORD
C
      NUM15 = NBWD/15
C
C CALCULATE THE LENGTH OF ARRAYS IWORK,IDD,IND REQUIRED ON THIS
C MACHINE.
C
      LENWOR = (ICNUM2*16*15-1)/NBWD +1
      IDDLEN = LENWOR
      INDLEN = (ICNUM1*16-1)/NUM15+1
C
C GENERATE MASKS FOR THE LEFTMOST 1-15 BITS IN A WORD
C
      MASK = 1
      MASK = ISHIFT(MASK,(NBWD-1))
      MASK15(1) = 0
      DO 1000 I = 2,15
      MASK15(I) = ISHIFT(MASK15(I-1),-1)
      MASK15(I) = IOR(MASK,MASK15(I))
 1000 CONTINUE
C
C
C  END INITIALIZATION
C
C
 9000 CONTINUE
C
C
C
C FOR DIGITIZATION OF COMPLEX CHARACTER SET.
C
C
C CREATE 1 BINARY RECORD ON FILE IOUT CONTAINING THE CONTENTS OF THE
C ARRAY IND IN PWRITX.
C
      CALL CREB15(IU1,IOUT,ICNUM1,IWORK,LENWOR)
C
C
C CREATE 1 BINARY RECORD ON FILE IOUT CONTAINING THE CONTENTS OF THE
C ARRAY IDD IN PWRITX.
C
      CALL CREBIN(IU2,IOUT,ICNUM2,IWORK,LENWOR)
C
C
C FOR DIGITIZATION OF DUPLEX CHARACTER SET.
C
C
C CREATE 1 BINARY RECORD ON FILE IOUT CONTAINING THE CONTENTS OF THE
C ARRAY IND IN PWRITX.
C
      CALL CREB15(IU3,IOUT,ICNUM1,IWORK,LENWOR)
C
C
C CREATE 1 BINARY RECORD ON FILE IOUT CONTAINING THE CONTENTS OF THE
C ARRAY IDD IN PWRITX.
C
      CALL CREBIN(IU4,IOUT,ICNUM2,IWORK,LENWOR)
C
      WRITE(I1MACH(2),101)
 101  FORMAT (1X,' PCRBIN - BINARY FILE CREATED')
C
C Close the output unit and reopen it for input.  It should not be
C necessary to do this, but UNICOS I/O had a problem with just
C rewinding the unit and reading it.
C
      CLOSE (UNIT=IOUT)
C
      OPEN (UNIT=IOUT,STATUS='OLD',FILE='pwritdata',ERR=907,
     +                                   FORM='UNFORMATTED')
      GO TO 908
  907 PRINT * , 'ERROR OPENING INPUT UNIT (pwritdata).'
      STOP
  908 CONTINUE
C
C
C READ THE 2 RECORDS REPRESENTING THE COMPLEX CHARACTER SET.
C
      REWIND IOUT
      READ(IOUT) (IND(I),I=1,INDLEN)
      READ(IOUT) (IDD(I),I=1,IDDLEN)
      REWIND IOUT
C
C TEST THE ACCESSING OF THE COMPLEX CHARACTER SET.
C
      CALL CCHECK(IERR)
C
C PRINT THE TEST RESULTS.
C
      WRITE(I1MACH(2),102)
 102  FORMAT(1X,' PCRBIN - TEST COMPLEX SET')
C
      IF (IERR .NE. 0) GOTO 2
      WRITE(I1MACH(2),103)
 103  FORMAT(1X,' PCRBIN - TEST WAS SUCCESSFUL')
      GOTO 10
C
    2 CONTINUE
      IF (IERR .NE. 1) GOTO 3
      WRITE(I1MACH(2),104)
 104  FORMAT(1X,' TEST SUCCESSFUL FOR 12 BIT BUT NOT FOR 6 BIT UNITS')
      GOTO 10
C
    3 CONTINUE
      IF (IERR .NE. 2) GOTO 4
      WRITE(I1MACH(2),105)
 105  FORMAT(1X,' TEST SUCCESSFUL FOR 6 BIT BUT NOT FOR 12 BIT UNITS')
      GOTO 10
C
    4 CONTINUE
      WRITE(I1MACH(2),106)
 106  FORMAT(1X,' PCRBIN - TEST NOT SUCCESSFUL')
C
C
   10 CONTINUE
C
C
C LOAD THE 2 RECORDS REPRESENTING THE DUPLEX CHARACTER SET.
C
      REWIND IOUT
      READ(IOUT) DUMREA
      READ(IOUT) DUMREA
      READ(IOUT) (IND(I),I=1,INDLEN)
      READ(IOUT) (IDD(I),I=1,IDDLEN)
      REWIND IOUT
C
C TEST ACCESSING OF DUPLEX CHARACTER SET.
C
      CALL DCHECK(IERR)
C
C PRINT THE TEST RESULTS.
C
      WRITE(I1MACH(2),200)
 200  FORMAT(1X,' PCRBIN - TEST DUPLEX SET')
C
      IF (IERR .NE. 0) GOTO 11
      WRITE(I1MACH(2),201)
 201  FORMAT(1X,' PCRBIN - TEST WAS SUCCESSFUL')
      GOTO 20
C
   11 CONTINUE
      IF (IERR .NE. 1) GOTO 12
      WRITE(I1MACH(2),202)
 202  FORMAT(1X,' TEST SUCCESSFUL FOR 12 BIT BUT NOT FOR 6 BIT UNITS')
      GOTO 20
C
   12 CONTINUE
      IF (IERR .NE. 2) GOTO 13
      WRITE(I1MACH(2),203)
 203  FORMAT(1X,' TEST SUCCESSFUL FOR 6 BIT BUT NOT FOR 12 BIT UNITS')
      GOTO 20
C
   13 CONTINUE
      WRITE(I1MACH(2),204)
 204  FORMAT(1X,' PCRBIN - TEST NOT SUCCESSFUL')
C
C
   20 CONTINUE
C
      STOP
C
      END

C
C	$Id: g01ctb.f,v 1.7 2008-07-27 00:21:05 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
        SUBROUTINE G01CTB
C
C  Set color representation (define color table entry).
C
      include 'g01prm.h'
      include 'gksin.h'
      include 'g01wsl.h'
      include 'g01ins.h'
      include 'g01opc.h'
      include 'gksenu.h'
C
      INTEGER  NCIX, NBYTES, I, IPTR
C
C  Store the flag indicatiing if a color table entry should
C  be written to the metafile.  Do not write a color table
C  entry if the picture is umpty.
C
      IWRITE = ID(2)
C
C  Scan the color table to see if the index already exists;
C  Find its position in the table otherwise (binary search
C  should be used here).
C
      NCIX = IC(1)
      DO 10 I=1,MOL
        IPTR = I
        IF (MCOLI(I)-NCIX)  10, 20, 15
   10 CONTINUE
C
C  Fall thru means that the index not defined yet and it is
C  higher than the highest defined index.
C
      IPTR = MOL + 1
C
C  Index is undefined -- it belongs at position IPTR in the table.
C  Test for room in the table, move table down.
C
   15 CONTINUE
      IF (MOL .GE. MOLMAX) THEN
C
C  Error -- table is full, set error, mark overflow, and return.
C
        RERR = 93
        MCOVFL = 1
        RETURN
      ELSE
C
C  Move table down, increment count of defined indices.
C
        DO 18 I=MOL,IPTR,-1
          MCOLI(I+1)  = MCOLI(I)
          SRED(I+1)   = SRED(I)
          SGREEN(I+1) = SGREEN(I)
          SBLUE(I+1)  = SBLUE(I)
   18   CONTINUE
        MOL = MOL + 1
      END IF
C
C  Insert/replace new color table entry.
C
   20 CONTINUE
      MCOLI(IPTR)  = NCIX
      SRED(IPTR)   = RX(1)
      SGREEN(IPTR) = RX(2)
      SBLUE(IPTR)  = RX(3)
C
C  Mark change to color table.  mark background color change 
C  if appropriate.
C
      MCTCHG = GYES
      IF (NCIX .EQ. 0)  MBCCHG = GYES
C
C  Normalize real components to integer range.
C
      ID(1) = RX(1)*MDCCRG
      ID(2) = RX(2)*MDCCRG
      ID(3) = RX(3)*MDCCRG
C
C  Write out a color table entry only if the current picture is
C  not empty.  If the current picture is empty, then the color table
C  will ultimately be put out by G01SNP.
C
      IF (IWRITE .EQ. 1) THEN
C
C  Generate metafile element with new entry.
C
C  Compute parameter list length -- number of bytes to hold
C       START INDEX + RED + GREEN + BLUE
C
        NBYTES = 1 + (3*MDCCFW + MCIXFW - 1)/8
C
C  Put out opcode (class and ID) and length.
C
        CALL GPUTNI (CLCTBL, IDCTBL, NBYTES, RERR)
        IF (RERR .NE. 0)  RETURN
C
C  Put out color index.
C
        CALL GPUTPR (NCIX, MCIXFW, 1, RERR)
        IF (RERR .NE. 0)  RETURN
C
C  Put out three color components.
C
        CALL GPUTPR (ID, MDCCFW, 3, RERR)
      ENDIF
C
      RETURN
      END

      SUBROUTINE STPRFS( UPLO, TRANS, DIAG, N, NRHS, AP, B, LDB, X, LDX,
     $                   FERR, BERR, WORK, IWORK, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER          DIAG, TRANS, UPLO
      INTEGER            INFO, LDB, LDX, N, NRHS
*     ..
*     .. Array Arguments ..
      INTEGER            IWORK( * )
      REAL               AP( * ), B( LDB, * ), BERR( * ), FERR( * ),
     $                   WORK( * ), X( LDX, * )
*     ..
*
*  Purpose
*  =======
*
*  STPRFS provides error bounds and backward error estimates for the
*  solution to a system of linear equations with a triangular packed
*  coefficient matrix.
*
*  The solution matrix X must be computed by STPTRS or some other
*  means before entering this routine.  STPRFS does not do iterative
*  refinement because doing so cannot improve the backward error.
*
*  Arguments
*  =========
*
*  UPLO    (input) CHARACTER*1
*          = 'U':  A is upper triangular;
*          = 'L':  A is lower triangular.
*
*  TRANS   (input) CHARACTER*1
*          Specifies the form of the system of equations:
*          = 'N':  A * X = B  (No transpose)
*          = 'T':  A**T * X = B  (Transpose)
*          = 'C':  A**H * X = B  (Conjugate transpose = Transpose)
*
*  DIAG    (input) CHARACTER*1
*          = 'N':  A is non-unit triangular;
*          = 'U':  A is unit triangular.
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  NRHS    (input) INTEGER
*          The number of right hand sides, i.e., the number of columns
*          of the matrices B and X.  NRHS >= 0.
*
*  AP      (input) REAL array, dimension (N*(N+1)/2)
*          The upper or lower triangular matrix A, packed columnwise in
*          a linear array.  The j-th column of A is stored in the array
*          AP as follows:
*          if UPLO = 'U', AP(i + (j-1)*j/2) = A(i,j) for 1<=i<=j;
*          if UPLO = 'L', AP(i + (j-1)*(2*n-j)/2) = A(i,j) for j<=i<=n.
*          If DIAG = 'U', the diagonal elements of A are not referenced
*          and are assumed to be 1.
*
*  B       (input) REAL array, dimension (LDB,NRHS)
*          The right hand side matrix B.
*
*  LDB     (input) INTEGER
*          The leading dimension of the array B.  LDB >= max(1,N).
*
*  X       (input) REAL array, dimension (LDX,NRHS)
*          The solution matrix X.
*
*  LDX     (input) INTEGER
*          The leading dimension of the array X.  LDX >= max(1,N).
*
*  FERR    (output) REAL array, dimension (NRHS)
*          The estimated forward error bound for each solution vector
*          X(j) (the j-th column of the solution matrix X).
*          If XTRUE is the true solution corresponding to X(j), FERR(j)
*          is an estimated upper bound for the magnitude of the largest
*          element in (X(j) - XTRUE) divided by the magnitude of the
*          largest element in X(j).  The estimate is as reliable as
*          the estimate for RCOND, and is almost always a slight
*          overestimate of the true error.
*
*  BERR    (output) REAL array, dimension (NRHS)
*          The componentwise relative backward error of each solution
*          vector X(j) (i.e., the smallest relative change in
*          any element of A or B that makes X(j) an exact solution).
*
*  WORK    (workspace) REAL array, dimension (3*N)
*
*  IWORK   (workspace) INTEGER array, dimension (N)
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ZERO
      PARAMETER          ( ZERO = 0.0E+0 )
      REAL               ONE
      PARAMETER          ( ONE = 1.0E+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            NOTRAN, NOUNIT, UPPER
      CHARACTER          TRANST
      INTEGER            I, J, K, KASE, KC, NZ
      REAL               EPS, LSTRES, S, SAFE1, SAFE2, SAFMIN, XK
*     ..
*     .. External Subroutines ..
      EXTERNAL           SAXPY, SCOPY, SLACON, STPMV, STPSV, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, MAX
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      REAL               SLAMCH
      EXTERNAL           LSAME, SLAMCH
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      UPPER = LSAME( UPLO, 'U' )
      NOTRAN = LSAME( TRANS, 'N' )
      NOUNIT = LSAME( DIAG, 'N' )
*
      IF( .NOT.UPPER .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = -1
      ELSE IF( .NOT.NOTRAN .AND. .NOT.LSAME( TRANS, 'T' ) .AND. .NOT.
     $         LSAME( TRANS, 'C' ) ) THEN
         INFO = -2
      ELSE IF( .NOT.NOUNIT .AND. .NOT.LSAME( DIAG, 'U' ) ) THEN
         INFO = -3
      ELSE IF( N.LT.0 ) THEN
         INFO = -4
      ELSE IF( NRHS.LT.0 ) THEN
         INFO = -5
      ELSE IF( LDB.LT.MAX( 1, N ) ) THEN
         INFO = -8
      ELSE IF( LDX.LT.MAX( 1, N ) ) THEN
         INFO = -10
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'STPRFS', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 .OR. NRHS.EQ.0 ) THEN
         DO 10 J = 1, NRHS
            FERR( J ) = ZERO
            BERR( J ) = ZERO
   10    CONTINUE
         RETURN
      END IF
*
      IF( NOTRAN ) THEN
         TRANST = 'T'
      ELSE
         TRANST = 'N'
      END IF
*
*     NZ = maximum number of nonzero elements in each row of A, plus 1
*
      NZ = N + 1
      EPS = SLAMCH( 'Epsilon' )
      SAFMIN = SLAMCH( 'Safe minimum' )
      SAFE1 = NZ*SAFMIN
      SAFE2 = SAFE1 / EPS
*
*     Do for each right hand side
*
      DO 250 J = 1, NRHS
*
*        Compute residual R = B - op(A) * X,
*        where op(A) = A or A', depending on TRANS.
*
         CALL SCOPY( N, X( 1, J ), 1, WORK( N+1 ), 1 )
         CALL STPMV( UPLO, TRANS, DIAG, N, AP, WORK( N+1 ), 1 )
         CALL SAXPY( N, -ONE, B( 1, J ), 1, WORK( N+1 ), 1 )
*
*        Compute componentwise relative backward error from formula
*
*        max(i) ( abs(R(i)) / ( abs(op(A))*abs(X) + abs(B) )(i) )
*
*        where abs(Z) is the componentwise absolute value of the matrix
*        or vector Z.  If the i-th component of the denominator is less
*        than SAFE2, then SAFE1 is added to the i-th components of the
*        numerator and denominator before dividing.
*
         DO 20 I = 1, N
            WORK( I ) = ABS( B( I, J ) )
   20    CONTINUE
*
         IF( NOTRAN ) THEN
*
*           Compute abs(A)*abs(X) + abs(B).
*
            IF( UPPER ) THEN
               KC = 1
               IF( NOUNIT ) THEN
                  DO 40 K = 1, N
                     XK = ABS( X( K, J ) )
                     DO 30 I = 1, K
                        WORK( I ) = WORK( I ) + ABS( AP( KC+I-1 ) )*XK
   30                CONTINUE
                     KC = KC + K
   40             CONTINUE
               ELSE
                  DO 60 K = 1, N
                     XK = ABS( X( K, J ) )
                     DO 50 I = 1, K - 1
                        WORK( I ) = WORK( I ) + ABS( AP( KC+I-1 ) )*XK
   50                CONTINUE
                     WORK( K ) = WORK( K ) + XK
                     KC = KC + K
   60             CONTINUE
               END IF
            ELSE
               KC = 1
               IF( NOUNIT ) THEN
                  DO 80 K = 1, N
                     XK = ABS( X( K, J ) )
                     DO 70 I = K, N
                        WORK( I ) = WORK( I ) + ABS( AP( KC+I-K ) )*XK
   70                CONTINUE
                     KC = KC + N - K + 1
   80             CONTINUE
               ELSE
                  DO 100 K = 1, N
                     XK = ABS( X( K, J ) )
                     DO 90 I = K + 1, N
                        WORK( I ) = WORK( I ) + ABS( AP( KC+I-K ) )*XK
   90                CONTINUE
                     WORK( K ) = WORK( K ) + XK
                     KC = KC + N - K + 1
  100             CONTINUE
               END IF
            END IF
         ELSE
*
*           Compute abs(A')*abs(X) + abs(B).
*
            IF( UPPER ) THEN
               KC = 1
               IF( NOUNIT ) THEN
                  DO 120 K = 1, N
                     S = ZERO
                     DO 110 I = 1, K
                        S = S + ABS( AP( KC+I-1 ) )*ABS( X( I, J ) )
  110                CONTINUE
                     WORK( K ) = WORK( K ) + S
                     KC = KC + K
  120             CONTINUE
               ELSE
                  DO 140 K = 1, N
                     S = ABS( X( K, J ) )
                     DO 130 I = 1, K - 1
                        S = S + ABS( AP( KC+I-1 ) )*ABS( X( I, J ) )
  130                CONTINUE
                     WORK( K ) = WORK( K ) + S
                     KC = KC + K
  140             CONTINUE
               END IF
            ELSE
               KC = 1
               IF( NOUNIT ) THEN
                  DO 160 K = 1, N
                     S = ZERO
                     DO 150 I = K, N
                        S = S + ABS( AP( KC+I-K ) )*ABS( X( I, J ) )
  150                CONTINUE
                     WORK( K ) = WORK( K ) + S
                     KC = KC + N - K + 1
  160             CONTINUE
               ELSE
                  DO 180 K = 1, N
                     S = ABS( X( K, J ) )
                     DO 170 I = K + 1, N
                        S = S + ABS( AP( KC+I-K ) )*ABS( X( I, J ) )
  170                CONTINUE
                     WORK( K ) = WORK( K ) + S
                     KC = KC + N - K + 1
  180             CONTINUE
               END IF
            END IF
         END IF
         S = ZERO
         DO 190 I = 1, N
            IF( WORK( I ).GT.SAFE2 ) THEN
               S = MAX( S, ABS( WORK( N+I ) ) / WORK( I ) )
            ELSE
               S = MAX( S, ( ABS( WORK( N+I ) )+SAFE1 ) /
     $             ( WORK( I )+SAFE1 ) )
            END IF
  190    CONTINUE
         BERR( J ) = S
*
*        Bound error from formula
*
*        norm(X - XTRUE) / norm(X) .le. FERR =
*        norm( abs(inv(op(A)))*
*           ( abs(R) + NZ*EPS*( abs(op(A))*abs(X)+abs(B) ))) / norm(X)
*
*        where
*          norm(Z) is the magnitude of the largest component of Z
*          inv(op(A)) is the inverse of op(A)
*          abs(Z) is the componentwise absolute value of the matrix or
*             vector Z
*          NZ is the maximum number of nonzeros in any row of A, plus 1
*          EPS is machine epsilon
*
*        The i-th component of abs(R)+NZ*EPS*(abs(op(A))*abs(X)+abs(B))
*        is incremented by SAFE1 if the i-th component of
*        abs(op(A))*abs(X) + abs(B) is less than SAFE2.
*
*        Use SLACON to estimate the infinity-norm of the matrix
*           inv(op(A)) * diag(W),
*        where W = abs(R) + NZ*EPS*( abs(op(A))*abs(X)+abs(B) )))
*
         DO 200 I = 1, N
            IF( WORK( I ).GT.SAFE2 ) THEN
               WORK( I ) = ABS( WORK( N+I ) ) + NZ*EPS*WORK( I )
            ELSE
               WORK( I ) = ABS( WORK( N+I ) ) + NZ*EPS*WORK( I ) + SAFE1
            END IF
  200    CONTINUE
*
         KASE = 0
  210    CONTINUE
         CALL SLACON( N, WORK( 2*N+1 ), WORK( N+1 ), IWORK, FERR( J ),
     $                KASE )
         IF( KASE.NE.0 ) THEN
            IF( KASE.EQ.1 ) THEN
*
*              Multiply by diag(W)*inv(op(A)').
*
               CALL STPSV( UPLO, TRANST, DIAG, N, AP, WORK( N+1 ), 1 )
               DO 220 I = 1, N
                  WORK( N+I ) = WORK( I )*WORK( N+I )
  220          CONTINUE
            ELSE
*
*              Multiply by inv(op(A))*diag(W).
*
               DO 230 I = 1, N
                  WORK( N+I ) = WORK( I )*WORK( N+I )
  230          CONTINUE
               CALL STPSV( UPLO, TRANS, DIAG, N, AP, WORK( N+1 ), 1 )
            END IF
            GO TO 210
         END IF
*
*        Normalize error.
*
         LSTRES = ZERO
         DO 240 I = 1, N
            LSTRES = MAX( LSTRES, ABS( X( I, J ) ) )
  240    CONTINUE
         IF( LSTRES.NE.ZERO )
     $      FERR( J ) = FERR( J ) / LSTRES
*
  250 CONTINUE
*
      RETURN
*
*     End of STPRFS
*
      END

C
C $Id: aggetr.f,v 1.6 2008-07-27 00:14:34 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE AGGETR (TPID,FUSR)
C
      CHARACTER*(*) TPID
      DIMENSION FURA(1)
C
C The routine AGGETR may be used to get the real (floating-point) value
C of any single AUTOGRAPH control parameter.
C
      CALL AGGETP (TPID,FURA,1)
      FUSR=FURA(1)
      RETURN
C
      END

C
C $Id: plotif.f,v 1.11 2008-07-27 00:17:24 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE PLOTIF (FX,FY,IP)
C
C Move the pen to the point (FX,FY), in the fractional cooordinate
C system.  If IP is zero, do a pen-up move.  If IP is one, do a pen-down
C move.  If IP is two, flush the buffer.
C
C The variable IU(5), in the labelled common block IUTLCM, specifies
C the size of the pen-move buffer (between 2 and 50).
C
      COMMON /IUTLCM/ IU(100)
      SAVE /IUTLCM/
C
C The common block VCTSEQ contains variables implementing the buffering
C of pen moves.
C
      COMMON /VCTSEQ/ NQ,QX(50),QY(50),NF,IF(25)
      SAVE /VCTSEQ/
C
C In the common block PLTCM are recorded the coordinates of the last
C pen position, in the metacode coordinate system, for MXMY.
C
      COMMON /PLTCM/ JX,JY
      SAVE /PLTCM/
C
C VP and WD hold viewport and window parameters obtained, when needed,
C from GKS.
C
      DIMENSION VP(4),WD(4)
C
C  Do a call forcing a BLOCKDATA to be loaded from a binary library.
C
      CALL UTILBD
C
C Check for an uncleared prior error.
C
      IF (ICFELL('PLOTIF - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C Check for out-of-range values of the pen parameter.
C
      IF (IP.LT.0.OR.IP.GT.2) THEN
        CALL SETER ('PLOTIF - ILLEGAL VALUE FOR IPEN',2,1)
        RETURN
      END IF
C
C If a buffer flush is requested, jump.
C
      IF (IP.EQ.2) GO TO 101
C
C A pen-up move to the current point (whether the pen is up or down) is
C simply ignored, since it cannot possibly have any effect but to put
C extra pen-up moves in the buffer.
C
      IF (IP.EQ.0.AND.FX.EQ.QX(NQ).AND.FY.EQ.QY(NQ)) RETURN
C
C Set JX and JY for a possible call to MXMY.
C
      JX=KFMX(FX)
      JY=KFMY(FY)
C
C If the current move is a pen-down move, or if the last one was, bump
C the pointer into the coordinate arrays and, if the current move is
C a pen-up move, make a new entry in the array IF, which records the
C positions of the pen-up moves.  Note that we never get two pen-up
C moves in a row, which means that IF need be dimensioned only half as
C large as QX and QY.
C
      IF (IP.NE.0.OR.IF(NF).NE.NQ) THEN
        NQ=NQ+1
        IF (IP.EQ.0) THEN
          NF=NF+1
          IF(NF)=NQ
        END IF
      END IF
C
C Save the coordinates of the point, in the fractional coordinate
C system.
C
      QX(NQ)=FX
      QY(NQ)=FY
C
C If the point-coordinate buffer is full, dump the buffers; otherwise,
C return.
C
      IF (NQ.LT.IU(5)) RETURN
C
C Dump the buffers.  If NQ is one, there's nothing to dump.  All that's
C there is a single pen-up move.
C
  101 IF (NQ.LE.1) RETURN
C
C Get NT, the number of the current transformation, and, if it is not
C zero, modify the current transformation so that we can use fractional
C coordinates (normalized device coordinates, in GKS terms).
C
      CALL GQCNTN (IE,NT)
      IF (IE.NE.0) THEN
        CALL SETER ('PLOTIF - ERROR EXIT FROM GQCNTN',3,1)
        RETURN
      END IF
      IF (NT.NE.0) THEN
        CALL GQNT (NT,IE,WD,VP)
        IF (IE.NE.0) THEN
          CALL SETER ('PLOTIF - ERROR EXIT FROM GQNT',4,1)
          RETURN
        END IF
        CALL GSWN (NT,VP(1),VP(2),VP(3),VP(4))
      END IF
C
C Dump out a series of polylines, each one defined by a pen-up move and
C a series of pen-down moves.
C
      DO 102 I=1,NF-1
        CALL GPL (IF(I+1)-IF(I),QX(IF(I)),QY(IF(I)))
  102 CONTINUE
      IF (IF(NF).NE.NQ) CALL GPL (NQ-IF(NF)+1,QX(IF(NF)),QY(IF(NF)))
C
C Put the current transformation back the way it was.
C
      IF (NT.NE.0) THEN
        CALL GSWN (NT,WD(1),WD(2),WD(3),WD(4))
      END IF
C
C Move the last pen position to the beginning of the buffer and pretend
C there was a pen-up move to that position.
C
      QX(1)=QX(NQ)
      QY(1)=QY(NQ)
      NQ=1
      IF(1)=1
      NF=1
C
C Done.
C
      RETURN
C
      END

C
C $Id: bcgeti.f,v 1.4 2008-07-27 00:17:29 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE BCGETI(PA,IVAL)
C
C Retrieve integer-valued parameters for the Bezier curve package.
C
C Arguments
C     Input
C             PA       Character string indicating parameter.
C
C     Output
C             IVAL     An integer value giving the current setting
C                      of the specified parameter.
C

      CHARACTER*(*) PA
      CHARACTER*3   CTMP
C
      include 'bccom.h'
C
      CTMP = PA(1:3)
C
      IF (CTMP.EQ.'NPC' .OR. CTMP.EQ.'npc') THEN
C
C  Get flag indicating the number of points per curve.
C
        IVAL = NPPC
      ELSE
        WRITE(I1MACH(4),500) CTMP
      ENDIF
C
      RETURN
C
  500 FORMAT(' NTGETI -- Invalid keyword = ',A3,', no action taken')
C
      END

      SUBROUTINE DSYGVX( ITYPE, JOBZ, RANGE, UPLO, N, A, LDA, B, LDB,
     $                   VL, VU, IL, IU, ABSTOL, M, W, Z, LDZ, WORK,
     $                   LWORK, IWORK, IFAIL, INFO )
*
*  -- LAPACK driver routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          JOBZ, RANGE, UPLO
      INTEGER            IL, INFO, ITYPE, IU, LDA, LDB, LDZ, LWORK, M, N
      DOUBLE PRECISION   ABSTOL, VL, VU
*     ..
*     .. Array Arguments ..
      INTEGER            IFAIL( * ), IWORK( * )
      DOUBLE PRECISION   A( LDA, * ), B( LDB, * ), W( * ), WORK( * ),
     $                   Z( LDZ, * )
*     ..
*
*  Purpose
*  =======
*
*  DSYGVX computes selected eigenvalues, and optionally, eigenvectors
*  of a real generalized symmetric-definite eigenproblem, of the form
*  A*x=(lambda)*B*x,  A*Bx=(lambda)*x,  or B*A*x=(lambda)*x.  Here A
*  and B are assumed to be symmetric and B is also positive definite.
*  Eigenvalues and eigenvectors can be selected by specifying either a
*  range of values or a range of indices for the desired eigenvalues.
*
*  Arguments
*  =========
*
*  ITYPE   (input) INTEGER
*          Specifies the problem type to be solved:
*          = 1:  A*x = (lambda)*B*x
*          = 2:  A*B*x = (lambda)*x
*          = 3:  B*A*x = (lambda)*x
*
*  JOBZ    (input) CHARACTER*1
*          = 'N':  Compute eigenvalues only;
*          = 'V':  Compute eigenvalues and eigenvectors.
*
*  RANGE   (input) CHARACTER*1
*          = 'A': all eigenvalues will be found.
*          = 'V': all eigenvalues in the half-open interval (VL,VU]
*                 will be found.
*          = 'I': the IL-th through IU-th eigenvalues will be found.
*
*  UPLO    (input) CHARACTER*1
*          = 'U':  Upper triangle of A and B are stored;
*          = 'L':  Lower triangle of A and B are stored.
*
*  N       (input) INTEGER
*          The order of the matrix pencil (A,B).  N >= 0.
*
*  A       (input/output) DOUBLE PRECISION array, dimension (LDA, N)
*          On entry, the symmetric matrix A.  If UPLO = 'U', the
*          leading N-by-N upper triangular part of A contains the
*          upper triangular part of the matrix A.  If UPLO = 'L',
*          the leading N-by-N lower triangular part of A contains
*          the lower triangular part of the matrix A.
*
*          On exit, the lower triangle (if UPLO='L') or the upper
*          triangle (if UPLO='U') of A, including the diagonal, is
*          destroyed.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(1,N).
*
*  B       (input/output) DOUBLE PRECISION array, dimension (LDA, N)
*          On entry, the symmetric matrix B.  If UPLO = 'U', the
*          leading N-by-N upper triangular part of B contains the
*          upper triangular part of the matrix B.  If UPLO = 'L',
*          the leading N-by-N lower triangular part of B contains
*          the lower triangular part of the matrix B.
*
*          On exit, if INFO <= N, the part of B containing the matrix is
*          overwritten by the triangular factor U or L from the Cholesky
*          factorization B = U**T*U or B = L*L**T.
*
*  LDB     (input) INTEGER
*          The leading dimension of the array B.  LDB >= max(1,N).
*
*  VL      (input) DOUBLE PRECISION
*  VU      (input) DOUBLE PRECISION
*          If RANGE='V', the lower and upper bounds of the interval to
*          be searched for eigenvalues. VL < VU.
*          Not referenced if RANGE = 'A' or 'I'.
*
*  IL      (input) INTEGER
*  IU      (input) INTEGER
*          If RANGE='I', the indices (in ascending order) of the
*          smallest and largest eigenvalues to be returned.
*          1 <= IL <= IU <= N, if N > 0; IL = 1 and IU = 0 if N = 0.
*          Not referenced if RANGE = 'A' or 'V'.
*
*  ABSTOL  (input) DOUBLE PRECISION
*          The absolute error tolerance for the eigenvalues.
*          An approximate eigenvalue is accepted as converged
*          when it is determined to lie in an interval [a,b]
*          of width less than or equal to
*
*                  ABSTOL + EPS *   max( |a|,|b| ) ,
*
*          where EPS is the machine precision.  If ABSTOL is less than
*          or equal to zero, then  EPS*|T|  will be used in its place,
*          where |T| is the 1-norm of the tridiagonal matrix obtained
*          by reducing A to tridiagonal form.
*
*          Eigenvalues will be computed most accurately when ABSTOL is
*          set to twice the underflow threshold 2*DLAMCH('S'), not zero.
*          If this routine returns with INFO>0, indicating that some
*          eigenvectors did not converge, try setting ABSTOL to
*          2*DLAMCH('S').
*
*  M       (output) INTEGER
*          The total number of eigenvalues found.  0 <= M <= N.
*          If RANGE = 'A', M = N, and if RANGE = 'I', M = IU-IL+1.
*
*  W       (output) DOUBLE PRECISION array, dimension (N)
*          On normal exit, the first M elements contain the selected
*          eigenvalues in ascending order.
*
*  Z       (output) DOUBLE PRECISION array, dimension (LDZ, max(1,M))
*          If JOBZ = 'N', then Z is not referenced.
*          If JOBZ = 'V', then if INFO = 0, the first M columns of Z
*          contain the orthonormal eigenvectors of the matrix A
*          corresponding to the selected eigenvalues, with the i-th
*          column of Z holding the eigenvector associated with W(i).
*          The eigenvectors are normalized as follows:
*          if ITYPE = 1 or 2, Z**T*B*Z = I;
*          if ITYPE = 3, Z**T*inv(B)*Z = I.
*
*          If an eigenvector fails to converge, then that column of Z
*          contains the latest approximation to the eigenvector, and the
*          index of the eigenvector is returned in IFAIL.
*          Note: the user must ensure that at least max(1,M) columns are
*          supplied in the array Z; if RANGE = 'V', the exact value of M
*          is not known in advance and an upper bound must be used.
*
*  LDZ     (input) INTEGER
*          The leading dimension of the array Z.  LDZ >= 1, and if
*          JOBZ = 'V', LDZ >= max(1,N).
*
*  WORK    (workspace/output) DOUBLE PRECISION array, dimension (LWORK)
*          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*
*  LWORK   (input) INTEGER
*          The length of the array WORK.  LWORK >= max(1,8*N).
*          For optimal efficiency, LWORK >= (NB+3)*N,
*          where NB is the blocksize for DSYTRD returned by ILAENV.
*
*          If LWORK = -1, then a workspace query is assumed; the routine
*          only calculates the optimal size of the WORK array, returns
*          this value as the first entry of the WORK array, and no error
*          message related to LWORK is issued by XERBLA.
*
*  IWORK   (workspace) INTEGER array, dimension (5*N)
*
*  IFAIL   (output) INTEGER array, dimension (N)
*          If JOBZ = 'V', then if INFO = 0, the first M elements of
*          IFAIL are zero.  If INFO > 0, then IFAIL contains the
*          indices of the eigenvectors that failed to converge.
*          If JOBZ = 'N', then IFAIL is not referenced.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*          > 0:  DPOTRF or DSYEVX returned an error code:
*             <= N:  if INFO = i, DSYEVX failed to converge;
*                    i eigenvectors failed to converge.  Their indices
*                    are stored in array IFAIL.
*             > N:   if INFO = N + i, for 1 <= i <= N, then the leading
*                    minor of order i of B is not positive definite.
*                    The factorization of B could not be completed and
*                    no eigenvalues or eigenvectors were computed.
*
*  Further Details
*  ===============
*
*  Based on contributions by
*     Mark Fahey, Department of Mathematics, Univ. of Kentucky, USA
*
* =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ONE
      PARAMETER          ( ONE = 1.0D+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            ALLEIG, INDEIG, LQUERY, UPPER, VALEIG, WANTZ
      CHARACTER          TRANS
      INTEGER            LOPT, LWKOPT, NB
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            ILAENV
      EXTERNAL           LSAME, ILAENV
*     ..
*     .. External Subroutines ..
      EXTERNAL           DPOTRF, DSYEVX, DSYGST, DTRMM, DTRSM, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      UPPER = LSAME( UPLO, 'U' )
      WANTZ = LSAME( JOBZ, 'V' )
      ALLEIG = LSAME( RANGE, 'A' )
      VALEIG = LSAME( RANGE, 'V' )
      INDEIG = LSAME( RANGE, 'I' )
      LQUERY = ( LWORK.EQ.-1 )
*
      INFO = 0
      IF( ITYPE.LT.0 .OR. ITYPE.GT.3 ) THEN
         INFO = -1
      ELSE IF( .NOT.( WANTZ .OR. LSAME( JOBZ, 'N' ) ) ) THEN
         INFO = -2
      ELSE IF( .NOT.( ALLEIG .OR. VALEIG .OR. INDEIG ) ) THEN
         INFO = -3
      ELSE IF( .NOT.( UPPER .OR. LSAME( UPLO, 'L' ) ) ) THEN
         INFO = -4
      ELSE IF( N.LT.0 ) THEN
         INFO = -5
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -7
      ELSE IF( LDB.LT.MAX( 1, N ) ) THEN
         INFO = -9
      ELSE IF( VALEIG .AND. N.GT.0 ) THEN
         IF( VU.LE.VL )
     $      INFO = -11
      ELSE IF( INDEIG .AND. IL.LT.1 ) THEN
         INFO = -12
      ELSE IF( INDEIG .AND. ( IU.LT.MIN( N, IL ) .OR. IU.GT.N ) ) THEN
         INFO = -13
      ELSE IF( LDZ.LT.1 .OR. ( WANTZ .AND. LDZ.LT.N ) ) THEN
         INFO = -18
      ELSE IF( LWORK.LT.MAX( 1, 8*N ) .AND. .NOT.LQUERY ) THEN
         INFO = -20
      END IF
*
      IF( INFO.EQ.0 ) THEN
         NB = ILAENV( 1, 'DSYTRD', UPLO, N, -1, -1, -1 )
         LWKOPT = ( NB+3 )*N
         WORK( 1 ) = LWKOPT
      END IF
*
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DSYGVX', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         RETURN
      END IF
*
*     Quick return if possible
*
      M = 0
      IF( N.EQ.0 ) THEN
         WORK( 1 ) = 1
         RETURN
      END IF
*
*     Form a Cholesky factorization of B.
*
      CALL DPOTRF( UPLO, N, B, LDB, INFO )
      IF( INFO.NE.0 ) THEN
         INFO = N + INFO
         RETURN
      END IF
*
*     Transform problem to standard eigenvalue problem and solve.
*
      CALL DSYGST( ITYPE, UPLO, N, A, LDA, B, LDB, INFO )
      CALL DSYEVX( JOBZ, RANGE, UPLO, N, A, LDA, VL, VU, IL, IU, ABSTOL,
     $             M, W, Z, LDZ, WORK, LWORK, IWORK, IFAIL, INFO )
      LOPT = WORK( 1 )
*
      IF( WANTZ ) THEN
*
*        Backtransform eigenvectors to the original problem.
*
         IF( INFO.GT.0 )
     $      M = INFO - 1
         IF( ITYPE.EQ.1 .OR. ITYPE.EQ.2 ) THEN
*
*           For A*x=(lambda)*B*x and A*B*x=(lambda)*x;
*           backtransform eigenvectors: x = inv(L)'*y or inv(U)*y
*
            IF( UPPER ) THEN
               TRANS = 'N'
            ELSE
               TRANS = 'T'
            END IF
*
            CALL DTRSM( 'Left', UPLO, TRANS, 'Non-unit', N, M, ONE, B,
     $                  LDB, Z, LDZ )
*
         ELSE IF( ITYPE.EQ.3 ) THEN
*
*           For B*A*x=(lambda)*x;
*           backtransform eigenvectors: x = L*y or U'*y
*
            IF( UPPER ) THEN
               TRANS = 'T'
            ELSE
               TRANS = 'N'
            END IF
*
            CALL DTRMM( 'Left', UPLO, TRANS, 'Non-unit', N, M, ONE, B,
     $                  LDB, Z, LDZ )
         END IF
      END IF
*
*     Set WORK(1) to optimal workspace size.
*
      WORK( 1 ) = LWKOPT
*
      RETURN
*
*     End of DSYGVX
*
      END

C
C	$Id: guwk.f,v 1.5 2008-07-27 00:21:03 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GUWK(WKID,REGFL)
C
C  UPDATE WORKSTATION
C
      INTEGER EUWK
      PARAMETER (EUWK=8)
C
      include 'gkscom.h'
C
      INTEGER WKID,REGFL
C
C  Check if GKS is in the proper state.
C
      CALL GZCKST(7,EUWK,IER)
      IF (IER .NE. 0) RETURN
C
C  Check if workstation identifier is valid.
C
      CALL GZCKWK(20,EUWK,WKID,IDUM,IER)
      IF (IER .NE. 0) RETURN
C
C  Check if the specified workstation is open.
C
      CALL GZCKWK(25,EUWK,WKID,IDUM,IER)
      IF (IER .NE. 0) RETURN
C
C  Check if REGFL is in bounds.
C
      IF (REGFL.LT.0 .OR. REGFL.GT.1) THEN
        ERS = 1
        CALL GERHND(2000,EUWK,ERF)
        ERS = 0
        RETURN
      ENDIF
C
C  Invoke the workstation interface.
C
C  Set the flag CUFLAG to indicate that the interface call should go
C  only to the specifically designated workstation.
C
      CUFLAG = WKID
      FCODE = 3
      CONT  = 0
      CALL GZROI(0)
      IL1 = 2
      IL2 = 2
      ID(1) = WKID
      ID(2) = REGFL
      CALL GZTOWK
      CUFLAG = -1
      IF (RERR .NE. 0) THEN
        ERS = 1
        CALL GERHND(RERR,EUWK,ERF)
        ERS = 0
      ENDIF
C
      RETURN
      END

      PROGRAM FAGOVRVW
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER (NPTS=200)
      PARAMETER (NCURVE=4)
      REAL YDRA(NPTS,NCURVE),XDRA(NPTS)

      DO 10 I=1,NPTS
        XDRA(I  )=I*0.1
        DO 10 J=1,NCURVE
            YDRA(I,J)=SIN(XDRA(I)+0.2*J)*EXP(-0.01*XDRA(I)*J**2)
  10  CONTINUE

C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)

      CALL DEFCLR (IWKID)

      CALL AGSETF('DASH/SELECTOR.',-1.0)

      CALL AGSETC('LABEL/NAME.','B')
      CALL AGSETI('LINE/NUMBER.',-100)
      CALL AGSETC('LINE/TEXT.','TIME (SECONDS)$')

      CALL AGSETC('LABEL/NAME.','L')
      CALL AGSETI('LINE/NUMBER.',100)
      CALL AGSETC('LINE/TEXT.','POSITION (METERS)$')

      CALL AGSETF('Y/MINIMUM.',-1.4)
      CALL AGSETF('Y/MAXIMUM.', 1.4)
      CALL AGSETF('Y/NICE.',    0.0)

      CALL EZMXY (XDRA,YDRA,NPTS,NCURVE,NPTS,'X-Y PLOT CAPABILITIES$')

C
C  Deactivate and close the workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS

      STOP
      END

      SUBROUTINE DEFCLR (IWKID)
      CALL GSCR(IWKID, 0, 0.0, 0.0, 0.0)
      CALL GSCR(IWKID, 1, 1.0, 1.0, 1.0)
      CALL GSCR(IWKID, 2, 1.0, 0.0, 0.0)
      CALL GSCR(IWKID, 3, 0.0, 1.0, 0.0)
      CALL GSCR(IWKID, 4, 0.4, 0.7, 0.9)
      CALL GSCR(IWKID, 5, 0.7, 0.4, 0.7)
      CALL GSCR(IWKID, 6, 0.9, 0.7, 0.4)
      CALL GSCR(IWKID, 7, 0.4, 0.9, 0.7)
      RETURN
      END

      SUBROUTINE AGCHAX(IFLG,IAXS,IPRT,VILS)
      CALL PLOTIF (0.,0.,2)
      IF (IFLG .EQ. 0) THEN
        CALL GSPLCI( 2 )
        CALL GSTXCI( 3 )
      ELSE
        CALL GSPLCI(1)
        CALL GSTXCI(1)
      ENDIF
      RETURN
      END

      SUBROUTINE AGCHCU(IFLG,KDSH)
      CALL PLOTIF (0.,0.,2)
      IF (IFLG .EQ. 0) THEN
         CALL GSPLCI( ABS(KDSH)+3 )
         CALL GSTXCI( ABS(KDSH)+3 )
      ELSE
         CALL GSPLCI(1)
         CALL GSTXCI(1)
      ENDIF
      RETURN
      END

      SUBROUTINE AGCHIL(IFLG,LBNM,LNNO)
      CALL PLOTIF (0.,0.,2)
      IF (IFLG .EQ. 0) THEN
         CALL GSTXCI( 4 )
      ELSE
         CALL GSTXCI( 1 )
      ENDIF
      RETURN
      END

      PROGRAM FTEX07
C
C  This program illustrates the use of curvs1 and curvs2 to
C  interpolate a smoothing tension spline for data in the plane.
C
C  Numeber of input data points and interpolation points.
C
      PARAMETER(NUM_IN=4,NUM_OUT=101)
C
C  GKS parameters.
C
      PARAMETER(IERRF=6, LUNIT=2, IWTYPE=1, IWKID=1)
C
C  Declare arrays.
C
      DIMENSION X(NUM_IN),Y(NUM_IN)
      DIMENSION XS(NUM_IN),YS(NUM_IN),XSP(NUM_IN),YSP(NUM_IN)
      DIMENSION TEMP(NUM_IN,19),PARAM(NUM_IN),XL(2),YL(2)
      DIMENSION XO(NUM_OUT),YO(NUM_OUT),XOO(NUM_OUT),YOO(NUM_OUT)
C
C  Specify the original data points in the plane.
C
      DATA X/0.5, -1.5,  0.5,  1.5/
      DATA Y/1.5,  0.0, -2.5, -1.0/
C
C  Tension factor.
C
      SIGMA = 1.0
C
C  Specify a uniform observational weight (the interpolated
C  curve can be this far away from the original data points)..
C
      ISW   = 1
      D     = 0.2
C
C  Smoothing factor (larger values result in smoother curves).
C
      S     = REAL(NUM_IN)
C
C  Computational tolerance value.
C
      EPS   = SQRT(2./S)
C
C  Call CURVS1 and CURVS2 to calculate the smoothing spline.
C
      CALL CURVS1(NUM_IN,X,Y,D,ISW,S,EPS,PARAM,XS,YS,XSP,YSP,
     +            SIGMA,TEMP,IERR)
C
      XINC = 1./REAL(NUM_OUT-1)
      DO 10 I=1,NUM_OUT
        T = REAL(I-1)*XINC
        CALL CURVS2(T,NUM_IN,PARAM,XS,YS,XSP,YSP,SIGMA,XO(I),YO(I))
   10 CONTINUE
C
C  Not use CURVS1 and CURVS2 to compute an interpolating tension 
C  spline by setting the smoothing parameter to zero.
C
      S   = 0.
      EPS = 0.
      CALL CURVS1(NUM_IN,X,Y,D,ISW,S,EPS,PARAM,XS,YS,XSP,YSP,
     +            SIGMA,TEMP,IERR)
C
      DO 20 I=1,NUM_OUT
        T = REAL(I-1)*XINC
        CALL CURVS2(T,NUM_IN,PARAM,XS,YS,XSP,YSP,SIGMA,XOO(I),YOO(I))
   20 CONTINUE
C
C  Plot the two curves.
C
      CALL GOPKS (6,IBUF)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C  Define colors.
C
      CALL GSCR(IWKID,0,1.,1.,1.)
      CALL GSCR(IWKID,1,0.,0.,0.)
      CALL GSCR(IWKID,2,1.,0.,0.)
      CALL GSCR(IWKID,3,0.,0.,1.)
C
C  Main title.
C
      CALL PCSETI('FN',25)
      CALL PLCHHQ(0.5,0.95,'Demo for CURVS1/CURVS2',25.,0.,0.)
      CALL SET(0.1, 0.95, 0.2, 0.90, -2., 3., -3., 2., 1)
C
C  Background grid.
C
      CALL GASETI('LTY',1)
      CALL PCSETI('FN',21)
      CALL GSPLCI(1)
      CALL LABMOD('(F4.1)','(F4.1)',4,4,20,20,0,0,0)
      CALL HALFAX(5, 4, 5, 4, -2., -3., 1,1)
C
C  Plot the smoothing spline in red, and its informational label.
C
      CALL GSLWSC(3.)
      CALL GSPLCI(2)
      CALL GPL(NUM_OUT,XO,YO)
      XL(1) = 0.250
      XL(2) = 0.750
      YL(1) = 0.625
      YL(2) = 0.625
      CALL GPL(2,XL,YL)
      CALL PLCHHQ(0.875,0.625,'Smoothing spline',24.,0.,-1.)
C
C  Plot the tension spline in blue, and its informational label.
C
      CALL GSPLCI(3)
      CALL GPL(NUM_OUT,XOO,YOO)
      XL(1) = 0.250
      XL(2) = 0.750
      YL(1) = 0.125
      YL(2) = 0.125
      CALL GPL(2,XL,YL)
      CALL PLCHHQ(0.875,0.125,'Tension spline',24.,0.,-1.)
C
C  Mark the original data with black dots, and label.
C
      CALL NGDOTS(X,Y,NUM_IN,0.13,1)
      CALL NGDOTS(0.500,-0.375,1,0.13,1)
      CALL PLCHHQ(0.875,-0.375,'Original data points',24.,0.,-1.)
C
      CALL FRAME()
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS ()
C
      STOP
      END

C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CSA3LXS (NI,XI,UI,WTS,KNOTS,SSMTH,NDERIV,
     +                    NO,XO,YO,ZO,UO,NWRK,WORK,IER)
C
C  Alternate entry where the output points are specified as a list.
C
      DIMENSION XI(3,NI),UI(NI),WTS(*),KNOTS(3),XO(NO),YO(NO),
     +          ZO(NO),UO(NO),WORK(NWRK)
      DIMENSION XMN(3),XMX(3),XV(3),NDERIV(3)
C
C  Check on the number of knots.
C
      NTOT = KNOTS(1)*KNOTS(2)*KNOTS(3)
C
      DO 20 I=1,3
        IF (KNOTS(I) .LT. 4) THEN
          CALL CFAERR (202,' CSA3LXS - must have at least four knots in 
     +every coordinate direction',70)       
          IER = 202
          RETURN
        ENDIF
   20 CONTINUE
C
C  Check on the size of the workspace.
C
      IF (NWRK .LT. NTOT*(NTOT+3)) THEN
        CALL CFAERR (203,' CSA3LXS - workspace too small',30)
        IER = 203
        RETURN
      ENDIF
C
C  Calculate the min and max for the knots as the minimum value of
C  the input data and output data and the maximum of the input and
C  output data.
C
      DO 30 J=1,3
        XMN(J) = XI(J,1)
        XMX(J) = XI(J,1)
        DO 10 I=2,NI
          XMN(J) = MIN(XMN(J),XI(J,I))
          XMX(J) = MAX(XMX(J),XI(J,I))
   10   CONTINUE
   30 CONTINUE
C
      DO 70 I=1,NO
        XMN(1) = MIN(XMN(1),XO(I))
        XMN(2) = MIN(XMN(2),YO(I))
        XMN(3) = MIN(XMN(3),ZO(I))
        XMX(1) = MAX(XMX(1),XO(I))
        XMX(2) = MAX(XMX(2),YO(I))
        XMX(3) = MAX(XMX(3),ZO(I))
   70 CONTINUE
C
C  Find the coefficients.
C
      CALL SPLCW(3,XI,3,UI,WTS,NI,XMN,XMX,KNOTS,SSMTH,WORK,NTOT,       
     +           WORK(NTOT+1),NWRK-NTOT,IERR)
      IF (IERR .NE. 0) RETURN
C
C  Calculate the approximated values (coefficients are stored at
C  the beginnig of WORK).
C
      DO 60 I=1,NO
        XV(1) = XO(I)
        XV(2) = YO(I)
        XV(3) = ZO(I)
        UO(I) = SPLDE(3,XV,NDERIV,WORK,XMN,XMX,KNOTS,IER)
        IF (IERR .NE. 0) RETURN
   60 CONTINUE
C
      RETURN
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C   FFTPACK 5.0
C   Copyright (C) 1995-2004, Scientific Computing Division,
C   University Corporation for Atmospheric Research
C   Licensed under the GNU General Public License (GPL)
C
C   Authors:  Paul N. Swarztrauber and Richard A. Valent
C
C   $Id: rfftf1.f,v 1.2 2006-11-21 01:10:19 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      SUBROUTINE DRFFTF1(N,IN,C,CH,WA,FAC)
      DOUBLE PRECISION SN
      DOUBLE PRECISION TSN
      DOUBLE PRECISION TSNM
      DOUBLE PRECISION CH(*),C(IN,*),WA(N),FAC(15)
C
      NF = FAC(2)
      NA = 1
      L2 = N
      IW = N
      DO 111 K1 = 1,NF
          KH = NF - K1
          IP = FAC(KH+3)
          L1 = L2/IP
          IDO = N/L2
          IDL1 = IDO*L1
          IW = IW - (IP-1)*IDO
          NA = 1 - NA
          IF (IP.NE.4) GO TO 102
          IX2 = IW + IDO
          IX3 = IX2 + IDO
          IF (NA.NE.0) GO TO 101
          CALL DR1F4KF(IDO,L1,C,IN,CH,1,WA(IW),WA(IX2),WA(IX3))
          GO TO 110
  101     CALL DR1F4KF(IDO,L1,CH,1,C,IN,WA(IW),WA(IX2),WA(IX3))
          GO TO 110
  102     IF (IP.NE.2) GO TO 104
          IF (NA.NE.0) GO TO 103
          CALL DR1F2KF(IDO,L1,C,IN,CH,1,WA(IW))
          GO TO 110
  103     CALL DR1F2KF(IDO,L1,CH,1,C,IN,WA(IW))
          GO TO 110
  104     IF (IP.NE.3) GO TO 106
          IX2 = IW + IDO
          IF (NA.NE.0) GO TO 105
          CALL DR1F3KF(IDO,L1,C,IN,CH,1,WA(IW),WA(IX2))
          GO TO 110
  105     CALL DR1F3KF(IDO,L1,CH,1,C,IN,WA(IW),WA(IX2))
          GO TO 110
  106     IF (IP.NE.5) GO TO 108
          IX2 = IW + IDO
          IX3 = IX2 + IDO
          IX4 = IX3 + IDO
          IF (NA.NE.0) GO TO 107
          CALL DR1F5KF(IDO,L1,C,IN,CH,1,WA(IW),WA(IX2),WA(IX3),WA(IX4))
          GO TO 110
  107     CALL DR1F5KF(IDO,L1,CH,1,C,IN,WA(IW),WA(IX2),WA(IX3),WA(IX4))
          GO TO 110
  108     IF (IDO.EQ.1) NA = 1 - NA
          IF (NA.NE.0) GO TO 109
          CALL DR1FGKF(IDO,IP,L1,IDL1,C,C,C,IN,CH,CH,1,WA(IW))
          NA = 1
          GO TO 110
  109     CALL DR1FGKF(IDO,IP,L1,IDL1,CH,CH,CH,1,C,C,IN,WA(IW))
          NA = 0
  110     L2 = L1
  111 CONTINUE
      SN = 1.D0/N
      TSN = 2.D0/N
      TSNM = -TSN
      MODN = MOD(N,2)
      NL = N - 2
      IF (MODN.NE.0) NL = N - 1
      IF (NA.NE.0) GO TO 120
      C(1,1) = SN*CH(1)
      DO 118 J = 2,NL,2
          C(1,J) = TSN*CH(J)
          C(1,J+1) = TSNM*CH(J+1)
  118 CONTINUE
      IF (MODN.NE.0) RETURN
      C(1,N) = SN*CH(N)
      RETURN
  120 C(1,1) = SN*C(1,1)
      DO 122 J = 2,NL,2
          C(1,J) = TSN*C(1,J)
          C(1,J+1) = TSNM*C(1,J+1)
  122 CONTINUE
      IF (MODN.NE.0) RETURN
      C(1,N) = SN*C(1,N)
      RETURN
      END

      SUBROUTINE CGELSY( M, N, NRHS, A, LDA, B, LDB, JPVT, RCOND, RANK,
     $                   WORK, LWORK, RWORK, INFO )
*
*  -- LAPACK driver routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      INTEGER            INFO, LDA, LDB, LWORK, M, N, NRHS, RANK
      REAL               RCOND
*     ..
*     .. Array Arguments ..
      INTEGER            JPVT( * )
      REAL               RWORK( * )
      COMPLEX            A( LDA, * ), B( LDB, * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  CGELSY computes the minimum-norm solution to a complex linear least
*  squares problem:
*      minimize || A * X - B ||
*  using a complete orthogonal factorization of A.  A is an M-by-N
*  matrix which may be rank-deficient.
*
*  Several right hand side vectors b and solution vectors x can be
*  handled in a single call; they are stored as the columns of the
*  M-by-NRHS right hand side matrix B and the N-by-NRHS solution
*  matrix X.
*
*  The routine first computes a QR factorization with column pivoting:
*      A * P = Q * [ R11 R12 ]
*                  [  0  R22 ]
*  with R11 defined as the largest leading submatrix whose estimated
*  condition number is less than 1/RCOND.  The order of R11, RANK,
*  is the effective rank of A.
*
*  Then, R22 is considered to be negligible, and R12 is annihilated
*  by unitary transformations from the right, arriving at the
*  complete orthogonal factorization:
*     A * P = Q * [ T11 0 ] * Z
*                 [  0  0 ]
*  The minimum-norm solution is then
*     X = P * Z' [ inv(T11)*Q1'*B ]
*                [        0       ]
*  where Q1 consists of the first RANK columns of Q.
*
*  This routine is basically identical to the original xGELSX except
*  three differences:
*    o The permutation of matrix B (the right hand side) is faster and
*      more simple.
*    o The call to the subroutine xGEQPF has been substituted by the
*      the call to the subroutine xGEQP3. This subroutine is a Blas-3
*      version of the QR factorization with column pivoting.
*    o Matrix B (the right hand side) is updated with Blas-3.
*
*  Arguments
*  =========
*
*  M       (input) INTEGER
*          The number of rows of the matrix A.  M >= 0.
*
*  N       (input) INTEGER
*          The number of columns of the matrix A.  N >= 0.
*
*  NRHS    (input) INTEGER
*          The number of right hand sides, i.e., the number of
*          columns of matrices B and X. NRHS >= 0.
*
*  A       (input/output) COMPLEX array, dimension (LDA,N)
*          On entry, the M-by-N matrix A.
*          On exit, A has been overwritten by details of its
*          complete orthogonal factorization.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(1,M).
*
*  B       (input/output) COMPLEX array, dimension (LDB,NRHS)
*          On entry, the M-by-NRHS right hand side matrix B.
*          On exit, the N-by-NRHS solution matrix X.
*
*  LDB     (input) INTEGER
*          The leading dimension of the array B. LDB >= max(1,M,N).
*
*  JPVT    (input/output) INTEGER array, dimension (N)
*          On entry, if JPVT(i) .ne. 0, the i-th column of A is permuted
*          to the front of AP, otherwise column i is a free column.
*          On exit, if JPVT(i) = k, then the i-th column of A*P
*          was the k-th column of A.
*
*  RCOND   (input) REAL
*          RCOND is used to determine the effective rank of A, which
*          is defined as the order of the largest leading triangular
*          submatrix R11 in the QR factorization with pivoting of A,
*          whose estimated condition number < 1/RCOND.
*
*  RANK    (output) INTEGER
*          The effective rank of A, i.e., the order of the submatrix
*          R11.  This is the same as the order of the submatrix T11
*          in the complete orthogonal factorization of A.
*
*  WORK    (workspace/output) COMPLEX array, dimension (LWORK)
*          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*
*  LWORK   (input) INTEGER
*          The dimension of the array WORK.
*          The unblocked strategy requires that:
*            LWORK >= MN + MAX( 2*MN, N+1, MN+NRHS )
*          where MN = min(M,N).
*          The block algorithm requires that:
*            LWORK >= MN + MAX( 2*MN, NB*(N+1), MN+MN*NB, MN+NB*NRHS )
*          where NB is an upper bound on the blocksize returned
*          by ILAENV for the routines CGEQP3, CTZRZF, CTZRQF, CUNMQR,
*          and CUNMRZ.
*
*          If LWORK = -1, then a workspace query is assumed; the routine
*          only calculates the optimal size of the WORK array, returns
*          this value as the first entry of the WORK array, and no error
*          message related to LWORK is issued by XERBLA.
*
*  RWORK   (workspace) REAL array, dimension (2*N)
*
*  INFO    (output) INTEGER
*          = 0: successful exit
*          < 0: if INFO = -i, the i-th argument had an illegal value
*
*  Further Details
*  ===============
*
*  Based on contributions by
*    A. Petitet, Computer Science Dept., Univ. of Tenn., Knoxville, USA
*    E. Quintana-Orti, Depto. de Informatica, Universidad Jaime I, Spain
*    G. Quintana-Orti, Depto. de Informatica, Universidad Jaime I, Spain
*
*  =====================================================================
*
*     .. Parameters ..
      INTEGER            IMAX, IMIN
      PARAMETER          ( IMAX = 1, IMIN = 2 )
      REAL               ZERO, ONE
      PARAMETER          ( ZERO = 0.0E+0, ONE = 1.0E+0 )
      COMPLEX            CZERO, CONE
      PARAMETER          ( CZERO = ( 0.0E+0, 0.0E+0 ),
     $                   CONE = ( 1.0E+0, 0.0E+0 ) )
*     ..
*     .. Local Scalars ..
      LOGICAL            LQUERY
      INTEGER            I, IASCL, IBSCL, ISMAX, ISMIN, J, LWKOPT, MN,
     $                   NB, NB1, NB2, NB3, NB4
      REAL               ANRM, BIGNUM, BNRM, SMAX, SMAXPR, SMIN, SMINPR,
     $                   SMLNUM, WSIZE
      COMPLEX            C1, C2, S1, S2
*     ..
*     .. External Subroutines ..
      EXTERNAL           CCOPY, CGEQP3, CLAIC1, CLASCL, CLASET, CTRSM,
     $                   CTZRZF, CUNMQR, CUNMRZ, SLABAD, XERBLA
*     ..
*     .. External Functions ..
      INTEGER            ILAENV
      REAL               CLANGE, SLAMCH
      EXTERNAL           CLANGE, ILAENV, SLAMCH
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, MAX, MIN, REAL, CMPLX
*     ..
*     .. Executable Statements ..
*
      MN = MIN( M, N )
      ISMIN = MN + 1
      ISMAX = 2*MN + 1
*
*     Test the input arguments.
*
      INFO = 0
      NB1 = ILAENV( 1, 'CGEQRF', ' ', M, N, -1, -1 )
      NB2 = ILAENV( 1, 'CGERQF', ' ', M, N, -1, -1 )
      NB3 = ILAENV( 1, 'CUNMQR', ' ', M, N, NRHS, -1 )
      NB4 = ILAENV( 1, 'CUNMRQ', ' ', M, N, NRHS, -1 )
      NB = MAX( NB1, NB2, NB3, NB4 )
      LWKOPT = MAX( 1, MN+2*N+NB*(N+1), 2*MN+NB*NRHS )
      WORK( 1 ) = CMPLX( LWKOPT )
      LQUERY = ( LWORK.EQ.-1 )
      IF( M.LT.0 ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( NRHS.LT.0 ) THEN
         INFO = -3
      ELSE IF( LDA.LT.MAX( 1, M ) ) THEN
         INFO = -5
      ELSE IF( LDB.LT.MAX( 1, M, N ) ) THEN
         INFO = -7
      ELSE IF( LWORK.LT.( MN+MAX( 2*MN, N+1, MN+NRHS ) ) .AND.
     $   .NOT.LQUERY ) THEN
         INFO = -12
      END IF
*
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'CGELSY', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( MIN( M, N, NRHS ).EQ.0 ) THEN
         RANK = 0
         RETURN
      END IF
*
*     Get machine parameters
*
      SMLNUM = SLAMCH( 'S' ) / SLAMCH( 'P' )
      BIGNUM = ONE / SMLNUM
      CALL SLABAD( SMLNUM, BIGNUM )
*
*     Scale A, B if max entries outside range [SMLNUM,BIGNUM]
*
      ANRM = CLANGE( 'M', M, N, A, LDA, RWORK )
      IASCL = 0
      IF( ANRM.GT.ZERO .AND. ANRM.LT.SMLNUM ) THEN
*
*        Scale matrix norm up to SMLNUM
*
         CALL CLASCL( 'G', 0, 0, ANRM, SMLNUM, M, N, A, LDA, INFO )
         IASCL = 1
      ELSE IF( ANRM.GT.BIGNUM ) THEN
*
*        Scale matrix norm down to BIGNUM
*
         CALL CLASCL( 'G', 0, 0, ANRM, BIGNUM, M, N, A, LDA, INFO )
         IASCL = 2
      ELSE IF( ANRM.EQ.ZERO ) THEN
*
*        Matrix all zero. Return zero solution.
*
         CALL CLASET( 'F', MAX( M, N ), NRHS, CZERO, CZERO, B, LDB )
         RANK = 0
         GO TO 70
      END IF
*
      BNRM = CLANGE( 'M', M, NRHS, B, LDB, RWORK )
      IBSCL = 0
      IF( BNRM.GT.ZERO .AND. BNRM.LT.SMLNUM ) THEN
*
*        Scale matrix norm up to SMLNUM
*
         CALL CLASCL( 'G', 0, 0, BNRM, SMLNUM, M, NRHS, B, LDB, INFO )
         IBSCL = 1
      ELSE IF( BNRM.GT.BIGNUM ) THEN
*
*        Scale matrix norm down to BIGNUM
*
         CALL CLASCL( 'G', 0, 0, BNRM, BIGNUM, M, NRHS, B, LDB, INFO )
         IBSCL = 2
      END IF
*
*     Compute QR factorization with column pivoting of A:
*        A * P = Q * R
*
      CALL CGEQP3( M, N, A, LDA, JPVT, WORK( 1 ), WORK( MN+1 ),
     $             LWORK-MN, RWORK, INFO )
      WSIZE = MN + REAL( WORK( MN+1 ) )
*
*     complex workspace: MN+NB*(N+1). real workspace 2*N.
*     Details of Householder rotations stored in WORK(1:MN).
*
*     Determine RANK using incremental condition estimation
*
      WORK( ISMIN ) = CONE
      WORK( ISMAX ) = CONE
      SMAX = ABS( A( 1, 1 ) )
      SMIN = SMAX
      IF( ABS( A( 1, 1 ) ).EQ.ZERO ) THEN
         RANK = 0
         CALL CLASET( 'F', MAX( M, N ), NRHS, CZERO, CZERO, B, LDB )
         GO TO 70
      ELSE
         RANK = 1
      END IF
*
   10 CONTINUE
      IF( RANK.LT.MN ) THEN
         I = RANK + 1
         CALL CLAIC1( IMIN, RANK, WORK( ISMIN ), SMIN, A( 1, I ),
     $                A( I, I ), SMINPR, S1, C1 )
         CALL CLAIC1( IMAX, RANK, WORK( ISMAX ), SMAX, A( 1, I ),
     $                A( I, I ), SMAXPR, S2, C2 )
*
         IF( SMAXPR*RCOND.LE.SMINPR ) THEN
            DO 20 I = 1, RANK
               WORK( ISMIN+I-1 ) = S1*WORK( ISMIN+I-1 )
               WORK( ISMAX+I-1 ) = S2*WORK( ISMAX+I-1 )
   20       CONTINUE
            WORK( ISMIN+RANK ) = C1
            WORK( ISMAX+RANK ) = C2
            SMIN = SMINPR
            SMAX = SMAXPR
            RANK = RANK + 1
            GO TO 10
         END IF
      END IF
*
*     complex workspace: 3*MN.
*
*     Logically partition R = [ R11 R12 ]
*                             [  0  R22 ]
*     where R11 = R(1:RANK,1:RANK)
*
*     [R11,R12] = [ T11, 0 ] * Y
*
      IF( RANK.LT.N )
     $   CALL CTZRZF( RANK, N, A, LDA, WORK( MN+1 ), WORK( 2*MN+1 ),
     $                LWORK-2*MN, INFO )
*
*     complex workspace: 2*MN.
*     Details of Householder rotations stored in WORK(MN+1:2*MN)
*
*     B(1:M,1:NRHS) := Q' * B(1:M,1:NRHS)
*
      CALL CUNMQR( 'Left', 'Conjugate transpose', M, NRHS, MN, A, LDA,
     $             WORK( 1 ), B, LDB, WORK( 2*MN+1 ), LWORK-2*MN, INFO )
      WSIZE = MAX( WSIZE, 2*MN+REAL( WORK( 2*MN+1 ) ) )
*
*     complex workspace: 2*MN+NB*NRHS.
*
*     B(1:RANK,1:NRHS) := inv(T11) * B(1:RANK,1:NRHS)
*
      CALL CTRSM( 'Left', 'Upper', 'No transpose', 'Non-unit', RANK,
     $            NRHS, CONE, A, LDA, B, LDB )
*
      DO 40 J = 1, NRHS
         DO 30 I = RANK + 1, N
            B( I, J ) = CZERO
   30    CONTINUE
   40 CONTINUE
*
*     B(1:N,1:NRHS) := Y' * B(1:N,1:NRHS)
*
      IF( RANK.LT.N ) THEN
         CALL CUNMRZ( 'Left', 'Conjugate transpose', N, NRHS, RANK,
     $                N-RANK, A, LDA, WORK( MN+1 ), B, LDB,
     $                WORK( 2*MN+1 ), LWORK-2*MN, INFO )
      END IF
*
*     complex workspace: 2*MN+NRHS.
*
*     B(1:N,1:NRHS) := P * B(1:N,1:NRHS)
*
      DO 60 J = 1, NRHS
         DO 50 I = 1, N
            WORK( JPVT( I ) ) = B( I, J )
   50    CONTINUE
         CALL CCOPY( N, WORK( 1 ), 1, B( 1, J ), 1 )
   60 CONTINUE
*
*     complex workspace: N.
*
*     Undo scaling
*
      IF( IASCL.EQ.1 ) THEN
         CALL CLASCL( 'G', 0, 0, ANRM, SMLNUM, N, NRHS, B, LDB, INFO )
         CALL CLASCL( 'U', 0, 0, SMLNUM, ANRM, RANK, RANK, A, LDA,
     $                INFO )
      ELSE IF( IASCL.EQ.2 ) THEN
         CALL CLASCL( 'G', 0, 0, ANRM, BIGNUM, N, NRHS, B, LDB, INFO )
         CALL CLASCL( 'U', 0, 0, BIGNUM, ANRM, RANK, RANK, A, LDA,
     $                INFO )
      END IF
      IF( IBSCL.EQ.1 ) THEN
         CALL CLASCL( 'G', 0, 0, SMLNUM, BNRM, N, NRHS, B, LDB, INFO )
      ELSE IF( IBSCL.EQ.2 ) THEN
         CALL CLASCL( 'G', 0, 0, BIGNUM, BNRM, N, NRHS, B, LDB, INFO )
      END IF
*
   70 CONTINUE
      WORK( 1 ) = CMPLX( LWKOPT )
*
      RETURN
*
*     End of CGELSY
*
      END

C
C $Id: dpgetr.f,v 1.7 2008-07-27 00:16:59 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE DPGETR (PNAM,RVAL)
C
C This routine is used to get the real value of an internal parameter
C of type INTEGER or REAL.
C
        CHARACTER*(*) PNAM
C
C Declare the real/integer common block.
C
        COMMON /DPCMRI/ ANGF,DBPI,EPSI,IDPI,IDPS,ILTL,INDP,IPCF,ISBF,
     +                  ISCF,LCDP,RLS1,RLS2,RMFS,TENS,WCHR,WGAP,WSLD
        SAVE   /DPCMRI/
C
C Declare a temporary variable in which to form error messages.
C
        CHARACTER*39 CTMP
C
C Do a call forcing a BLOCKDATA to be loaded from a binary library.
C
        CALL DPBLDA
C
C Check for an uncleared prior error.
C
        IF (ICFELL('DPGETR - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C Get the specified parameter or log an error.
C
        IF (LEN(PNAM).LT.3) THEN
          CTMP='DPGETR - PARAMETER NAME TOO SHORT - '//PNAM
          CALL SETER (CTMP(1:38),2,1)
          RETURN
        ELSE IF (PNAM(1:3).EQ.'DPL'.OR.PNAM(1:3).EQ.'dpl') THEN
          RVAL=REAL(LCDP)
        ELSE IF (PNAM(1:3).EQ.'DPS'.OR.PNAM(1:3).EQ.'dps') THEN
          RVAL=REAL(IDPS)
        ELSE IF (PNAM(1:3).EQ.'DPT'.OR.PNAM(1:3).EQ.'dpt') THEN
          RVAL=REAL(INDP)
        ELSE IF (PNAM(1:3).EQ.'EPS'.OR.PNAM(1:3).EQ.'eps') THEN
          RVAL=EPSI
        ELSE IF (PNAM(1:3).EQ.'LS1'.OR.PNAM(1:3).EQ.'ls1') THEN
          RVAL=RLS1
        ELSE IF (PNAM(1:3).EQ.'LS2'.OR.PNAM(1:3).EQ.'ls2') THEN
          RVAL=RLS2
        ELSE IF (PNAM(1:3).EQ.'LTL'.OR.PNAM(1:3).EQ.'ltl') THEN
          RVAL=REAL(ILTL)
        ELSE IF (PNAM(1:3).EQ.'MFS'.OR.PNAM(1:3).EQ.'mfs') THEN
          RVAL=RMFS
        ELSE IF (PNAM(1:3).EQ.'PCF'.OR.PNAM(1:3).EQ.'pcf') THEN
          RVAL=REAL(IPCF)
        ELSE IF (PNAM(1:3).EQ.'SAF'.OR.PNAM(1:3).EQ.'saf') THEN
          RVAL=ANGF
        ELSE IF (PNAM(1:3).EQ.'SBF'.OR.PNAM(1:3).EQ.'sbf') THEN
          RVAL=REAL(ISBF)
        ELSE IF (PNAM(1:3).EQ.'SCF'.OR.PNAM(1:3).EQ.'scf') THEN
          RVAL=REAL(ISCF)
        ELSE IF (PNAM(1:3).EQ.'SSL'.OR.PNAM(1:3).EQ.'ssl') THEN
          RVAL=DBPI
        ELSE IF (PNAM(1:3).EQ.'TCS'.OR.PNAM(1:3).EQ.'tcs') THEN
          RVAL=TENS
        ELSE IF (PNAM(1:3).EQ.'WOC'.OR.PNAM(1:3).EQ.'woc') THEN
          RVAL=WCHR
        ELSE IF (PNAM(1:3).EQ.'WOG'.OR.PNAM(1:3).EQ.'wog') THEN
          RVAL=WGAP
        ELSE IF (PNAM(1:3).EQ.'WOS'.OR.PNAM(1:3).EQ.'wos') THEN
          RVAL=WSLD
        ELSE
          CTMP='DPGETR - PARAMETER NAME NOT KNOWN - '//PNAM
          CALL SETER (CTMP(1:39),3,1)
          RETURN
        END IF
C
C Done.
C
        RETURN
C
      END

C
C $Id: vect3.f,v 1.6 2008-07-27 00:17:34 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE VECT3 (U,V,W)
      CALL TRN32T (U,V,W,X,Y,ZDUM,2)
      IIX = 32*INT(X)
      IIY = 32*INT(Y)
      CALL PLOTIT  (IIX,IIY,1)
      RETURN
      END

C
C $Id: plchlq.f,v 1.12 2008-07-27 00:17:20 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE PLCHLQ (XPOS,YPOS,CHRS,SIZE,ANGD,CNTR)
C
C This is the low-quality character-drawing routine.
C
C
C D E C L A R A T I O N S
C
C
      CHARACTER*(*) CHRS
C
C The COMMON block PCPFLQ contains internal parameters that affect the
C behavior of routines besides PLCHHQ.
C
      COMMON /PCPFLQ/ IMAP,OORV,RHTW
      SAVE   /PCPFLQ/
C
C Define arrays in which to save the current viewport and window.
C
      DIMENSION VPRT(4),WNDW(4)
C
C Do a call forcing a BLOCKDATA to be loaded from a binary library.
C
      CALL PCBLDA
C
C Check for an uncleared prior error.
C
      IF (ICFELL('PLCHLQ - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C Compute the coordinates of (XPOS,YPOS) in the fractional coordinate
C system (normalized device coordinates XFRA and YFRA).
C
      IF (IMAP.LE.0) THEN
        XFRA=CUFX(XPOS)
        IF (ICFELL('PLCHLQ',2).NE.0) RETURN
        YFRA=CUFY(YPOS)
        IF (ICFELL('PLCHLQ',3).NE.0) RETURN
      ELSE
        CALL PCMPXY (IMAP,XPOS,YPOS,XTMP,YTMP)
        IF (ICFELL('PLCHLQ',4).NE.0) RETURN
        IF (OORV.NE.0..AND.XTMP.EQ.OORV) RETURN
        XFRA=CUFX(XTMP)
        IF (ICFELL('PLCHLQ',5).NE.0) RETURN
        YFRA=CUFY(YTMP)
        IF (ICFELL('PLCHLQ',6).NE.0) RETURN
      END IF
C
C Determine the resolution of the plotter, as declared by default or
C by the user.
C
      CALL GETUSV ('XF',IRSX)
      IF (ICFELL('PLCHLQ',7).NE.0) RETURN
      RSLN=2.**IRSX-1.
C
C Determine a character height which will make the characters have the
C width requested by the user (and decide at what angle to write them).
C First, compute the same multiplier we would use for PLCHHQ (except
C for the adjustment factor SIZA) ...
C
      IF (IMAP.LE.0) THEN
        IF (SIZE.LE.0.) THEN
          SIZM=ABS(SIZE)/1023.
        ELSE IF (SIZE.LT.1.) THEN
          SIZM=SIZE/16.
        ELSE
          SIZM=(SIZE/RSLN)/16.
        END IF
        ANGV=ANGD
      ELSE
        SINA=SIN(.017453292519943*ANGD)
        COSA=COS(.017453292519943*ANGD)
        CALL PCMPXY (IMAP,XPOS-.5*SIZE*COSA,YPOS-.5*SIZE*SINA,XTM1,YTM1)
        IF (ICFELL('PLCHLQ',8).NE.0) RETURN
        CALL PCMPXY (IMAP,XPOS+.5*SIZE*COSA,YPOS+.5*SIZE*SINA,XTM2,YTM2)
        IF (ICFELL('PLCHLQ',9).NE.0) RETURN
        IF (OORV.NE.0..AND.(XTM1.EQ.OORV.OR.XTM2.EQ.OORV)) RETURN
        XTM1=CUFX(XTM1)
        IF (ICFELL('PLCHLQ',10).NE.0) RETURN
        YTM1=CUFY(YTM1)
        IF (ICFELL('PLCHLQ',11).NE.0) RETURN
        XTM2=CUFX(XTM2)
        IF (ICFELL('PLCHLQ',12).NE.0) RETURN
        YTM2=CUFY(YTM2)
        IF (ICFELL('PLCHLQ',13).NE.0) RETURN
        IF (XTM1.EQ.XTM2.AND.YTM1.EQ.YTM2) RETURN
        SIZM=SQRT((XTM2-XTM1)*(XTM2-XTM1)+(YTM2-YTM1)*(YTM2-YTM1))/16.
        ANGV=57.2957795130823*ATAN2(YTM2-YTM1,XTM2-XTM1)
      END IF
C
C ... and then compute from that the desired character height.
C
      CHRH=16.*SIZM
C
C Save the current character height, text path, character up vector,
C and text alignment.
C
      CALL GQCHH (IERR,HGTO)
      IF (IERR.NE.0) THEN
        CALL SETER ('PLCHLQ - ERROR EXIT FROM GQCHH',14,1)
        RETURN
      END IF
C
      CALL GQTXP (IERR,ITPO)
      IF (IERR.NE.0) THEN
        CALL SETER ('PLCHLQ - ERROR EXIT FROM GQTXP',15,1)
        RETURN
      END IF
C
      CALL GQCHUP (IERR,CUXO,CUYO)
      IF (IERR.NE.0) THEN
        CALL SETER ('PLCHLQ - ERROR EXIT FROM GQCHUP',16,1)
        RETURN
      END IF
C
      CALL GQTXAL (IERR,ITAX,ITAY)
      IF (IERR.NE.0) THEN
        CALL SETER ('PLCHLQ - ERROR EXIT FROM GQTXAL',17,1)
        RETURN
      END IF
C
C Set the desired character height.
C
      CALL GSCHH (CHRH)
C
C Set the desired text path.
C
      CALL GSTXP (0)
C
C Define the character up vector, being careful to generate exact values
C for exact multiples of 90 degrees.
C
      ANGM=MOD(ANGV,360.)
C
      IF (ANGM.EQ.0.) THEN
        CALL GSCHUP (0.,1.)
      ELSE IF (ANGM.EQ.90.) THEN
        CALL GSCHUP (-1.,0.)
      ELSE IF (ANGM.EQ.180.) THEN
        CALL GSCHUP (0.,-1.)
      ELSE IF (ANGM.EQ.270.) THEN
        CALL GSCHUP (1.,0.)
      ELSE IF (ANGM.GT.0..AND.ANGM.LT.180.) THEN
        CALL GSCHUP (-1.,1./TAN(.017453292519943*ANGM))
      ELSE
        CALL GSCHUP (1.,-1./TAN(.017453292519943*ANGM))
      END IF
C
C Define the text alignment.
C
      IF (CNTR.LT.0.) THEN
        ICNT=1
      ELSE IF (CNTR.EQ.0.) THEN
        ICNT=2
      ELSE
        ICNT=3
      END IF
C
      CALL GSTXAL (ICNT,3)
C
C Flush the pen-move buffer.
C
      CALL PLOTIF (0.,0.,2)
      IF (ICFELL('PLCHLQ',18).NE.0) RETURN
C
C Save the current window and, if necessary, redefine it so that we can
C use normalized device coordinates.
C
      CALL GQCNTN (IERR,NRMT)
      IF (IERR.NE.0) THEN
        CALL SETER ('PLCHLQ - ERROR EXIT FROM GQCNTN',19,1)
        RETURN
      END IF
      IF (NRMT.NE.0) THEN
        CALL GQNT (NRMT,IERR,WNDW,VPRT)
        IF (IERR.NE.0) THEN
          CALL SETER ('PLCHLQ - ERROR EXIT FROM GQNT',20,1)
          RETURN
        END IF
        CALL GSWN (NRMT,VPRT(1),VPRT(2),VPRT(3),VPRT(4))
      END IF
C
C Plot the characters.
C
      CALL GTX (XFRA,YFRA,CHRS)
C
C Restore the window definition.
C
      IF (NRMT.NE.0) THEN
        CALL GSWN (NRMT,WNDW(1),WNDW(2),WNDW(3),WNDW(4))
      END IF
C
C Restore all the original text attributes.
C
      CALL GSCHH  (HGTO)
      CALL GSTXP  (ITPO)
      CALL GSCHUP (CUXO,CUYO)
      CALL GSTXAL (ITAX,ITAY)
C
C Update the pen position.
C
      CALL PLOTIF (XFRA,YFRA,0)
      IF (ICFELL('PLCHLQ',21).NE.0) RETURN
C
C Done.
C
      RETURN
C
      END

C
C $Id: ngritd.f,v 1.4 2008-07-27 00:17:18 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE NGRITD (IAXS,ANGL,UCRD,VCRD,WCRD)
C
C Define a multiplicative constant to convert from degrees to radians.
C
        DATA DTOR / .017453292519943 /
C
C This routine rotates the point with coordinates (UCRD,VCRD,WCRD) by
C the angle ANGL about the axis specified by IAXS (1 for the U axis,
C 2 for the V axis, 3 for the W axis).  A right-handed coordinate
C system is assumed.
C
        SINA=SIN(DTOR*ANGL)
        COSA=COS(DTOR*ANGL)
C
        UTMP=UCRD
        VTMP=VCRD
        WTMP=WCRD
C
        IF (IAXS.EQ.1) THEN
          VCRD=VTMP*COSA-WTMP*SINA
          WCRD=WTMP*COSA+VTMP*SINA
        ELSE IF (IAXS.EQ.2) THEN
          UCRD=UTMP*COSA+WTMP*SINA
          WCRD=WTMP*COSA-UTMP*SINA
        ELSE
          UCRD=UTMP*COSA-VTMP*SINA
          VCRD=VTMP*COSA+UTMP*SINA
        END IF
C
        RETURN
C
      END

C
C	$Id: csinsert.f,v 1.5 2008-07-27 03:10:07 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CSINSERT (K,LP, LIST,LPTR,LNEW )
      INTEGER K, LP, LIST(*), LPTR(*), LNEW
C
C***********************************************************
C
C                                              From STRIPACK
C                                            Robert J. Renka
C                                  Dept. of Computer Science
C                                       Univ. of North Texas
C                                           renka@cs.unt.edu
C                                                   07/17/96
C
C   This subroutine inserts K as a neighbor of N1 following
C N2, where LP is the LIST pointer of N2 as a neighbor of
C N1.  Note that, if N2 is the last neighbor of N1, K will
C become the first neighbor (even if N1 is a boundary node).
C
C   This routine is identical to the similarly named routine
C in TRIPACK.
C
C
C On input:
C
C       K = Index of the node to be inserted.
C
C       LP = LIST pointer of N2 as a neighbor of N1.
C
C The above parameters are not altered by this routine.
C
C       LIST,LPTR,LNEW = Data structure defining the trian-
C                        gulation.  Refer to Subroutine
C                        CSTRMESH.
C
C On output:
C
C       LIST,LPTR,LNEW = Data structure updated with the
C                        addition of node K.
C
C Modules required by CSINSERT:  None
C
C***********************************************************
C
      INTEGER LSAV
C
      LSAV = LPTR(LP)
      LPTR(LP) = LNEW
      LIST(LNEW) = K
      LPTR(LNEW) = LSAV
      LNEW = LNEW + 1
      RETURN
      END

C
C	$Id: gksbd.f,v 1.38 2010-04-02 16:38:00 brownrig Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GKSBD
C
C Calling this do-nothing subroutine forces "ld" to load the following
C block data routine (but only if they are in the same ".f" file).
C
        RETURN
C
      END
CNOSPLIT
      BLOCKDATA GKSBDX
C
      include 'gkscom.h'
C
C
C     DESCRIPTION OF ALL GKS COMMON BLOCKS
C
C-----------------------------------------------------------------------
C
C     GKINTR:  GKS INTERNAL VARIABLES
C
C       NOPWK   -- NUMBER OF CURRENTLY OPEN WORKSTATIONS
C       NACWK   -- NUMBER OF CURRENTLY ACTIVE WORKSTATIONS
C       WCONID  -- CONNECTION IDENTIFIER FOR WISS
C       NUMSEG  -- NUMBER OF SEGMENTS CURRENTLY IN USE
C       SEGS    -- SET OF SEGMENT NAMES CURRENTLY IN USE
C       CURSEG  -- NAME OF CURRENT SEGMENT
C       SEGLEN  -- LENGTH (IN NUMBER OF RECORDS) OF THE ASSOCIATED
C                  SEGMENTS.
C       MXSREC  -- THE NUMBER OF RECORDS IN THE SEGMENT TO PROCESS
C                  IN A COPY TO A WORKSTATION
C       SEGT    -- AN ARRAY OF SEGMENT TRANSFORMATION MATRICES
C       CURTM   -- THE CURRENT SEGMET TRANSFORMATION WHEN COPYING A
C                  SEGMENT
C       SEGDEL  -- FLAG TO INDICATE WHETHER ALL SEGMENTS SHOULD BE
C                  REMOVED AT CLOSE GKS TIME (0 = NO; 1 = YES)
C       RWKSP   -- REAL WORKSPACE ARRAY
C       GKSCLP  -- FLAG TO INDICATE WHETHER GKS CLIPPING IS ON
C                  (0 = NO; 1 = YES)
C-----------------------------------------------------------------------
C
C     GKOPDT:  OPERATING STATE AND DESCRIPTION TABLE VARIABLES
C
C       OPS    --  THE GKS OPERATING STATE
C       KSLEV  --  LEVEL OF GKS
C       WK     --  NUMBER OF AVAILABLE WORKSTATION TYPES
C       LSWK   --  LIST OF AVAILABLE WORKSTATION TYPES
C       MOPWK  --  MAXIMUM NUMBER OF SIMULTANEOUSLY OPEN WORKSTATIONS
C       MACWK  --  MAXIMUM NUMBER OF SIMULTANEOUSLY ACTIVE WORKSTATIONS
C       MNT    --  MAXIMUM NORMALIZATION TRANSFORMATION NUMBER
C-----------------------------------------------------------------------
C
C     GKSTAT: GKS STATE LIST VARIABLES--
C       SOPWK  -- SET OF OPEN WORKSTATIONS
C       SACWK  -- SET OF ACTIVE WORKSTATIONS
C       CPLI   -- CURRENT POLYLINE INDEX
C       CLN    -- CURRENT LINETYPE
C       CLWSC  -- CURRENT LINEWIDTH SCALE FACTOR
C       CPLCI  -- CURRENT POLYLINE COLOR INDEX
C       CLNA   -- CURRENT LINETYPE ASF
C       CLWSCA -- CURRENT LINEWIDTH SCALE FACTOR ASF
C       CPLCIA -- CURRENT POLYLINE COLOR INDEX ASF
C       CPMI   -- CURRENT POLYMARKER INDEX
C       CMK    -- CURRENT MARKER TYPE
C       CMKS   -- CURRENT MARKER SIZE SCALE FACTOR
C       CPMCI  -- CURRENT POLYMARKER COLOR INDEX
C       CMKA   -- CURRENT MARKER TYPE ASPECT SOURCE FLAG
C       CMKSA  -- CURRENT MARKER SIZE SCALE FACTOR ASF
C       CPMCIA -- CURRENT POLYMARKER COLOR INDEX ASF
C       CTXI   -- CURRENT TEXT INDEX
C       CTXFP  -- CURRENT TEXT FONT AND PRECISION
C       CCHXP  -- CURRENT CHARACTER EXPANSION FACTOR
C       CCHSP  -- CURRENT CHARACTER SPACING
C       CTXCI  -- CURRENT TEXT COLOR INDEX
C       CTXFPA -- CURRENT TEXT FONT AND PRECISION ASF
C       CCHXPA -- CURRENT CHARACTER EXPANSION FACTOR ASF
C       CCHSPA -- CURRENT CHARACTER SPACING ASF
C       CTXCIA -- CURRENT TEXT COLOR INDEX ASF
C       CCHH   -- CURRENT CHARACTER HEIGHT
C       CCHUP  -- CURRENT CHARACTER UP VECTOR
C       CTXP   -- CURRENT TEXT PATH
C       CTXAL  -- CURRENT TEXT ALIGNMENT
C       CFAI   -- CURRENT FILL AREA INDEX
C       CFAIS  -- CURRENT FILL AREA INTERIOR STYLE
C       CFASI  -- CURRENT FILL AREA STYLE INDEX
C       CFACI  -- CURRENT FILL AREA COLOR INDEX
C       CFAISA -- CURRENT FILL AREA INTERIOR STYLE ASF
C       CFASIA -- CURRENT FILL AREA STYLE INDEX ASF
C       CFACIA -- CURRENT FILL AREA COLOR INDEX ASF
C       CPA    -- CURRENT PATTERN SIZE
C       CPARF  -- CURRENT PATTERN REFERENCE POINT
C       CNT    -- CURRENT NORMALIZATION TRANSFORMATION NUMBER
C       LSNT   -- LIST OF NORMALIZATION TRANSFORMATIONS (ORDERED
C                 BY VIEWPORT INPUT PRIORITY)
C       NTWN   -- NORMALIZATION TRANSFORMATION WINDOWS
C       NTVP   -- NORMALIZATION TRANSFORMATION VIEWPORTS
C       CCLIP  -- CURRENT CLIPPING INDICATOR
C       SWKTP  -- SET OF WORKSTATION TYPES ASSOCIATED WITH THE
C                 OPEN WORKSTATIONS
C       NOPICT -- FLAG TO INDICATE NO PICTURE ELEMENTS HAVE BEEN
C                 ISSUED FOR THE CURRENT PICTURE
C       NWKTP  -- WORKSTATION TYPE
C       LXWKID -- LOCAL X WINDOW WKID RETRIEVED FROM THE X DRIVER
C                 AT OPEN WORKSTATION TIME
C       ECONID -- THE WINDOW ID FOR WORKSTATIONS OF TYPE GXWE (EXISTING
C                 X WINDOW).  THIS VALUE IS SUPPLIED VIA THE CONNECTION
C                 ID AT OPEN WORKSTATION TIME.
C       CLLX   -- LOWER LEFT X COORDINATE FOR POSITIONING PICTURE ON PAGE
C       CLLY   -- LOWER LEFT Y COORDINATE FOR POSITIONING PICTURE ON PAGE
C       CURX   -- UPPER RIGHT X COORDINATE FOR POSITIONING PICTURE ON PAGE
C       CURY   -- UPPER RIGHT Y COORDINATE FOR POSITIONING PICTURE ON PAGE
C       CPSCL  -- SCALE FACTOR FOR POSTSCRIPT WORKSTATIONS
C       CCMDL  -- Flag for CMYK color model or RGB color model
C       CSUPR  -- Flag for suppressing background color and/or bounding
C                 box for PS output.
C       CPTLD  -- Flag for portrait PS mode (=0), or landscape (non-zero)
C       COLMOD -- Color Model for X color allocation
C       PDFHGT -- Height of PDF to be specified in the MediaBox
C       PDFWTH -- Width of PDF to be specified in the MediaBox
C       PSHGT  -- Height of PS paper to be specified in the setpagedevice
C       PSWTH  -- Width of PS paper to be specified in the setpagedevice
C-----------------------------------------------------------------------
C
C     GKEROR:  GKS ERROR STATE LIST
C       ERS    --  ERROR STATE
C       ERF    --  ERROR FILE
C       CUFLAG --  A UTILITY FLAG THAT IS USED TO MARK THAT A PARTICULAR
C                  WORKSTATION IS BEING ADDRESSED IN THE INTERFACE.  IF
C                  CUFLAG IS POSITIVE, THEN IT IS EQUAL TO THE
C                  WORKSTATION ID OF THE PARTICULAR WORKSTATION FOR
C                  WHICH INSTRUCTIONS ARE TARGETED; IF CUFLAG = -1, THEN
C                  INSTRUCTIONS SHOULD GO TO ALL APPROPRIAT WORKSTATIONS.
C       MXERMG --  MAXIMUM NUMBER OF ERROR MESSAGES TO ISSUE BEFORE ABORT
C
C-----------------------------------------------------------------------
C
C     GKETBI:
C       IERNMS --  AN ARRAY CONTAINING THE NCAR GKS ERROR NUMERS
C     GKETBC:
C       ERMSGS --  AN ARRAY CONTAINING THE NCAR GKS ERROR MESSAGE STRINGS
C-----------------------------------------------------------------------
C
C     GKENUM: GKS ENUMERATION TYPE VARIABLES
C       GBUNDL -- BUNDLED
C       GINDIV -- INDIVIDUAL
C       GGKCL  -- GKS CLOSED
C       GGKOP  -- GKS OPEN
C       GWSOP  -- WORKSTATION OPEN
C       GWSAC  -- WORKSTATION ACTIVE
C       GSGOP  -- SEGMENT OPEN
C       GOUTPT -- OUTPUT WORKSTATION
C       GINPUT -- INPUT WORKSTATION
C       GOUTIN -- OUTPUT/INPUT WORKSTATION
C       GWISS  -- WORKSTATION INDEPENDENT SEGMENT STORAGE
C       GMO    -- METAFILE OUTPUT WORKSTATION
C       GMI    -- METAFILE INPUT WORKSTATION
C       GCGM   -- WORKSTATION TYPE CGM
C       GCROMIN -- MINIMUM TYPE FOR THE cairo DRIVERS
C       GCROMAX -- MAXIMUM TYPE FOR THE cairo DRIVERS
C       GWSS   -- WORKSTATION TYPE WISS
C       GXWE   -- WORKSTATION TYPE EXISTING COLOUR X WINDOW
C       GXWC   -- WORKSTATION TYPE COLOUR X WINDOW
C       GPIX   -- Workstation type for PIX map.
C       GPSMIN -- MINIMUM TYPE FOR THE POSTSCRIPT DRIVERS
C       GPSMAX -- MAXIMUM TYPE FOR THE POSTSCRIPT DRIVERS
C       GPDFP  -- Workstation type for PDF portrait.
C       GPDFL  -- Workstation type for PDF landscape.
C
C-----------------------------------------------------------------------
C
C     GKSNAM: NAMES
C
C       GNAM   -- ARRAY OF GKS FUNCTION NAMES IS AS PER THE BINDING
C       SEGNAM -- FILE NAMES ASSOCIATED WITH THE SEGMENT NUMBERS IN
C                 VARIABLE SEGS
C       GFNAME -- FILENAME FOR MO WORKSTATIONS
C       GSEGRT -- ROOT NAME FOR SEGMENT FILE NAMES
C
C-----------------------------------------------------------------------
C
C     GKSIN1 & GKSIN2: WORKSTATION INTERFACE COMMON BLOCKS
C
C       FCODE  -- FUNCTION CODE FOR THE CURRENT INSTRUCTION
C       CONT   -- CONTINUATION FLAG (1 MEANS MORE TO COME; 0 MEANS LAST)
C       IL1    -- TOTAL NUMBER OF ELEMENTS TO BE PASSED IN THE ID
C                 ARRAY FOR THE CURRENT INSTRUCTION
C       IL2    -- NUMBER OF ELEMENTS IN THE ID ARRAY FOR THE GIVEN
C                 WORKSTATION INTERFACE INVOCATION
C       ID     -- ARRAY FOR PASSING INTEGERS
C       IC1    -- TOTAL NUMBER OF ELEMENTS TO BE PASSED IN THE IC
C                 ARRAY FOR THE CURRENT INSTRUCTION
C       IC2    -- NUMBER OF ELEMENTS IN THE IC ARRAY FOR THE GIVEN
C                 WORKSTATION INTERFACE INVOCATION
C       IC     -- ARRAY FOR PASSING COLOR INDICES
C       RL1    -- TOTAL NUMBER OF ELEMENTS TO BE PASSED IN THE RX AND
C                 RY ARRAYS FOR THE CURRENT INSTRUCTION
C       RL2    -- NUMBER OF ELEMENTS IN THE RX AND RY ARRAYS FOR THE
C                 GIVEN WORKSTATION INTERFACE INVOCATION
C       RX     -- ARRAY FOR PASSING REAL X COORDINATE VALUES
C       RY     -- ARRAY FOR PASSING REAL Y COORDINATE VALUES
C       STRL1  -- TOTAL NUMBER OF CHARACTERS TO BE PASSED IN THE
C                 CHARACTER VARIABLE STR FOR THE CURRENT INSTRUCTION
C       STRL2  -- NUMBER OF CHARACTERS IN THE CHARACTER VARIABLE STR
C                 FOR THE CURRENT INVOCATION OF THE WORKSTATION
C                 INTERFACE
C       RERR   -- RETURN VARIABLE FOR ERROR INDICATOR
C       STR    -- CHARACTER VARIABLE FOR PASSING CHARACTERS
C
C-----------------------------------------------------------------------
      DATA KSLEV,WK/0, 28/
C**************************************************************************
C******** Be sure and change the dimension of LSWK in gkscom.h when    ****
C******** adding a new workstation type (as well as changing the value ****
C******** of WK above to the same number).                              ****
C**************************************************************************
      DATA LSWK/1,3,7,8,9,10,11,12,20,21,22,23,24,25,26,27,28,29,30,31,
     +          40,41,42,43,44,45,46,47/
C**************************************************************************
      DATA MOPWK,MACWK,MNT
     +    /   15,   15,  1/
      DATA OPS/0/
      DATA ERS,ERF,CUFLAG,MXERMG/0,6,-1,10/
      DATA GBUNDL,GINDIV/0,1/
      DATA GGKCL,GGKOP,GWSOP,GWSAC,GSGOP/0,1,2,3,4/
      DATA GOUTPT,GINPUT,GOUTIN,GWISS,GMO,GMI/0,1,2,3,4,5/
      DATA GCGM,GWSS,GXWE,GXWC,GPIX, GDMP,GPDFP,GPDFL,GPSMIN,GPSMAX
     +    /   1,   3,   7,   8,   9,   10,   11,   12,    20,    31/
      DATA GCROMIN, GCROMAX
     +    /     40,      50/
      DATA NOPWK,NACWK,NUMSEG,CURSEG,SEGDEL,GKSCLP/0,0,0,-1,1,1/
      DATA NOPICT/-1/
      DATA GFNAME/'DEFAULT'/
      DATA GSEGRT/'GSEG'/
      DATA CLLX,CLLY,CURX,CURY,CPSCL/-9999,-9999,-9999,-9999,-1/
      DATA CCMDL/1/
      DATA CSUPR/0/
      DATA CPTLD/1/
      DATA COLMOD/-1/
      DATA PDFHGT/792/
      DATA PDFWTH/612/
      DATA PSHGT/792/
      DATA PSWTH/612/
C
      DATA IERNMS/    1,    2,    3,    4,    5,    6,    7,    8,
     +               20,   21,   22,   23,   24,   25,   26,   27,
     +               28,   29,   30,   32,   33,   34,   35,   36,
     +               38,   50,   51,   52,   53,   54,   60,   63,
     +               65,   66,   69,   72,   75,   77,   78,   79,
     +               80,   84,   85,   87,   91,   92,   93,   96,
     +              100,  101,  102,  103,  120,  121,  122,  124,
     +              160,  161,  162,  163,  165,  166,  167,  168,
     +              180,  182,  300,  302,  303,  304,  305,  306,
     +              307,  308, 2000, 2001, 2002, 2003, -100, -101,
     +             -102, -103, -105, -106, -107, -108, -109, -110,
     +             -111, -112, -200, -201, -202, -203, -204, -205,
     +             -206, -207, -208, -209, -210, -211, -212, -213,
     +             -214, -215, -216, -300, -301, -302, -303, -217,
     +             -218, -219, -220, -221, 2200, 2201, 2202, 2203,
     +             2204,   90, -113, -400, -401, -402, -403, -404,
     +             -405, -406, -350, -351, -352, -353, -450, -451,
     +             -452, -453, -354, -501, -502, -355, -356, -503,
     *             -504/
C  Error 1
      DATA ERMSGS(  1)/' --GKS NOT IN PROPER STATE: GKS SHALL BE IN STAT
     +E GKCL'/
C  Error 2
      DATA ERMSGS(  2)/' --GKS NOT IN PROPER STATE: GKS SHALL BE IN STAT
     +E GKOP'/
C  Error 3
      DATA ERMSGS(  3)/' --GKS NOT IN PROPER STATE: GKS SHALL BE IN STAT
     +E WSAC'/
C  Error 4
      DATA ERMSGS(  4)/' --GKS NOT IN PROPER STATE: GKS SHALL BE IN STAT
     +E SGOP'/
C  Error 5
      DATA ERMSGS(  5)/' --GKS NOT IN PROPER STATE: GKS SHALL BE EITHER
     +IN THE STATE WSAC OR IN THE STATE SGOP'/
C  Error 6
      DATA ERMSGS(  6)/' --GKS NOT IN PROPER STATE: GKS SHALL BE EITHER
     +IN THE STATE WSOP OR IN THE STATE WSAC'/
C  Error 7
      DATA ERMSGS(  7)/' --GKS NOT IN PROPER STATE: GKS SHALL BE IN ONE
     +OF THE STATES  WSOP, WSAC, OR SGOP'/
C  Error 8
      DATA ERMSGS(  8)/' --GKS NOT IN PROPER STATE: GKS SHALL BE IN ONE
     +OF THE STATES  GKOP, WSOP, WSAC, OR SGOP'/
C  Error 20
      DATA ERMSGS(  9)/' --SPECIFIED WORKSTATION IDENTIFIER IS INVALID
     +'/
C  Error 21
      DATA ERMSGS( 10)/' --SPECIFIED CONNECTION IDENTIFIER IS INVALID'/
C  Error 22
      DATA ERMSGS( 11)/' --SPECIFIED WORKSTATION TYPE IS INVALID'/
C  Error 23
      DATA ERMSGS( 12)/' --SPECIFIED WORKSTATION TYPE DOES NOT EXIST'/
C  Error 24
      DATA ERMSGS( 13)/' --SPECIFIED WORKSTATION IS OPEN'/
C  Error 25
      DATA ERMSGS( 14)/' --SPECIFIED WORKSTATION IS NOT OPEN'/
C  Error 26
      DATA ERMSGS( 15)/' --SPECIFIED WORKSTATION CANNOT BE OPENED'/
C  Error 27
      DATA ERMSGS( 16)/' --WORKSTATION INDEPENDENT SEGMENT STORAGE IS NO
     +T OPEN'/
C  Error 28
      DATA ERMSGS( 17)/' --WORKSTATION INDEPENDENT SEGMENT STORAGE IS AL
     +READY OPEN'/
C  Error 29
      DATA ERMSGS( 18)/' --SPECIFIED WORKSTATION IS ACTIVE'/
C  Error 30
      DATA ERMSGS( 19)/' --SPECIFIED WORKSTATION IS NOT ACTIVE'/
C  Error 32
      DATA ERMSGS( 20)/' --SPECIFIED WORKSTATION IS NOT OF CATEGORY MO'/
C  Error 33
      DATA ERMSGS( 21)/' --SPECIFIED WORKSTATION IS OF CATEGORY MI'/
C  Error 34
      DATA ERMSGS( 22)/' --SPECIFIED WORKSTATION IS NOT OF CATEGORY MI'/
C  Error 35
      DATA ERMSGS( 23)/' --SPECIFIED WORKSTATION IS OF CATEGORY INPUT'/
C  Error 36
      DATA ERMSGS( 24)/' --SPECIFIED WORKSTATION IS WORKSTATION INDEPEND
     +ENT SEGMENT STORAGE'/
C  Error 38
      DATA ERMSGS( 25)/' --SPECIFIED WORKSTATION IS NEITHER OF CATEGORY
     +INPUT NOR OF CATEGORY OUTIN'/
C  Error 50
      DATA ERMSGS( 26)/' --TRANSFORMATION NUMBER IS INVALID'/
C  Error 51
      DATA ERMSGS( 27)/' --RECTANGLE DEFINITION IS INVALID'/
C  Error 52
      DATA ERMSGS( 28)/' --VIEWPORT IS NOT WITHIN THE NORMALIZED DEVICE
     +COORDINATE UNIT SQUARE'/
C  Error 53
      DATA ERMSGS( 29)/' --WORKSTATION WINDOW IS NOT WITHIN THE NORMALIZ
     +ED DEVICE COORDINATE UNIT SQUARE'/
C  Error 54
      DATA ERMSGS( 30)/' --WORKSTATION VIEWPORT IS NOT WITHIN THE DISPLA
     +Y SPACE'/
C  Error 60
      DATA ERMSGS( 31)/' --POLYLINE INDEX IS INVALID'/
C  Error 63
      DATA ERMSGS( 32)/' --LINETYPE IS LESS THAN OR EQUAL TO ZERO'/
C  Error 65
      DATA ERMSGS( 33)/' --LINEWIDTH SCALE FACTOR IS LESS THAN ZERO'/
C  Error 66
      DATA ERMSGS( 34)/' --POLYMARKER INDEX IS INVALID'/
C  Error 69
      DATA ERMSGS( 35)/' --MARKER TYPE IS LESS THAN OR EQUAL TO ZERO'/
C  Error 72
      DATA ERMSGS( 36)/' --TEXT INDEX IS INVALID'/
C  Error 75
      DATA ERMSGS( 37)/' --TEXT FONT IS EQUAL TO ZERO'/
C  Error 77
      DATA ERMSGS( 38)/' --CHARACTER EXPANSION FACTOR IS LESS THAN OR EQ
     +UAL TO ZERO'/
C  Error 78
      DATA ERMSGS( 39)/' --CHARACTER HEIGHT IS LESS THAN OR EQUAL TO ZER
     +O'/
C  Error 79
      DATA ERMSGS( 40)/' --LENGTH OF CHARACTER UP VECTOR IS ZERO'/
C  Error 80
      DATA ERMSGS( 41)/' --FILL AREA INDEX IS INVALID'/
C  Error 84
      DATA ERMSGS( 42)/' --STYLE (PATTERN OR HATCH) INDEX IS LESS THAN O
     +R EQUAL TO ZERO'/
C  Error 85
      DATA ERMSGS( 43)/' --SPECIFIED PATTERN INDEX IS INVALID'/
C  Error 87
      DATA ERMSGS( 44)/' --PATTERN SIZE VALUE IS NOT POSITIVE'/
C  Error 91
      DATA ERMSGS( 45)/' --DIMENSIONS OF COLOR ARRAY ARE INVALID'/
C  Error 92
      DATA ERMSGS( 46)/' --COLOR INDEX IS LESS THAN ZERO'/
C  Error 93
      DATA ERMSGS( 47)/' --COLOR INDEX IS INVALID'/
C  Error 96
      DATA ERMSGS( 48)/' --COLOR IS OUTSIDE RANGE ZERO TO ONE INCLUSIVE'
     +/
C  Error 100
      DATA ERMSGS( 49)/' --NUMBER OF POINTS IS INVALID'/
C  Error 101
      DATA ERMSGS( 50)/' --INVALID CODE IN STRING'/
C  Error 102
      DATA ERMSGS( 51)/' --GENERALIZED DRAWING PRIMITIVE IDENTIFIER IS I
     +NVALID'/
C  Error 103
      DATA ERMSGS( 52)/' --CONTENT OF GENERALIZED DRAWING PRIMITIVE DATA
     + RECORD IS INVALID'/
C  Error 120
      DATA ERMSGS( 53)/' --SPECIFIED SEGMENT NAME IS INVALID'/
C  Error 121
      DATA ERMSGS( 54)/' --SPECIFIED SEGMENT NAME IS ALREADY IN USE'/
C  Error 122
      DATA ERMSGS( 55)/' --SPECIFIED SEGMENT DOES NOT EXIST'/
C  Error 124
      DATA ERMSGS( 56)/' --SPECIFIED SEGMENT DOES NOT EXIST ON WORKSTATI
     +ON INDEPENDENT SEGMENT STORAGE'/
C  Error 160
      DATA ERMSGS( 57)/' --ITEM TYPE IS NOT ALLOWED FOR USER ITEMS'/
C  Error 161
      DATA ERMSGS( 58)/' --ITEM LENGTH IS INVALID'/
C  Error 162
      DATA ERMSGS( 59)/' --NO ITEM IS LEFT IN GKS METAFILE INPUT'/
C  Error 163
      DATA ERMSGS( 60)/' --METAFILE ITEM IS INVALID'/
C  Error 165
      DATA ERMSGS( 61)/' --CONTENT OF ITEM DATA RECORD IS INVALID FOR TH
     +E SPECIFIED ITEM TYPE'/
C  Error 166
      DATA ERMSGS( 62)/' --MAXIMUM ITEM DATA RECORD LENGTH IS INVALID'/
C  Error 167
      DATA ERMSGS( 63)/' --USER ITEM CANNOT BE INTERPRETED'/
C  Error 168
      DATA ERMSGS( 64)/' --SPECIFIED FUNCTION IS NOT SUPPORTED IN THIS L
     +EVEL OF GKS'/
C  Error 180
      DATA ERMSGS( 65)/' --SPECIFIED ESCAPE FUNCTION IS NOT SUPPORTED'/
C  Error 182
      DATA ERMSGS( 66)/' --CONTENTS OF ESCAPE DATA RECORD ARE INVALID'/
C  Error 300
      DATA ERMSGS( 67)/' --STORAGE OVERFLOW HAS OCCURRED IN GKS'/
C  Error 302
      DATA ERMSGS( 68)/' --INPUT/OUTPUT ERROR HAS OCCURRED WHILE READING
     +'/
C  Error 303
      DATA ERMSGS( 69)/' --INPUT/OUTPUT ERROR HAS OCCURRED WHILE WRITING
     +'/
C  Error 304
      DATA ERMSGS( 70)/' --INPUT/OUTPUT ERROR HAS OCCURRED WHILE SENDING
     + DATA TO A WORKSTATION'/
C  Error 305
      DATA ERMSGS( 71)/' --INPUT/OUTPUT ERROR HAS OCCURRED WHILE RECEIVI
     +NG DATA FROM A WORKSTATION'/
C  Error 306
      DATA ERMSGS( 72)/' --INPUT/OUTPUT ERROR HAS OCCURRED DURING PROGRA
     +M LIBRARY MANAGEMENT'/
C  Error 307
      DATA ERMSGS( 73)/' --INPUT/OUTPUT ERROR HAS OCCURRED WHILE READING
     + WORKSTATION DESCRIPTION TABLE'/
C  Error 308
      DATA ERMSGS( 74)/' --ARITHMETIC ERROR HAS OCCURRED'/
C  Error 2000
      DATA ERMSGS( 75)/' --ENUMERATION TYPE OUT OF RANGE'/
C  Error 2001
      DATA ERMSGS( 76)/' --OUTPUT PARAMETER SIZE INSUFFICIENT'/
C  Error 2002
      DATA ERMSGS( 77)/' --LIST OR SET ELEMENT NOT AVAILABLE'/
C  Error 2003
      DATA ERMSGS( 78)/' --INVALID DATA RECORD'/
C  Error -100
      DATA ERMSGS( 79)/' --UNKNOWN ERROR CODE'/
C  Error -101
      DATA ERMSGS( 80)/' --NO ADDITIONAL WORKSTATIONS MAY BE ACTIVATED'/
C  Error -102
      DATA ERMSGS( 81)/' --GKS SYSTEM ERROR--IMPROPER CONTINUATION SEQUE
     +NCE'/
C  Error -103
      DATA ERMSGS( 82)/' --THE NCAR GKS IMPLEMENTATION REQUIRES THAT WIS
     +S BE ACTIVE BEFORE A SEGMENT IS CREATED'/
C  Error -105
      DATA ERMSGS( 83)/' --ERROR OPENING DISK FILE'/
C  Error -106
      DATA ERMSGS( 84)/' --LOGICAL UNIT NUMBER FOR SEGMENT STORAGE CANNO
     +T BE THE SAME AS THAT FOR METAFILE OUTPUT'/
C  Error -107
      DATA ERMSGS( 85)/' --MAXIMUM NUMBER OF ERROR MESSAGES EXCEEDED'/
C  Error -108
      DATA ERMSGS( 86)/' --ILLEGAL PLACEMENT OF A CALL TO ASSIGN A PICTU
     +RE NAME'/
C  Error -109
      DATA ERMSGS( 87)/' --THIS FUNCTION NOT YET IMPLEMENTED FOR WORKSTA
     +TIONS OF CATEGORY OUTPUT'/
C  Error -110
      DATA ERMSGS( 88)/' --CHARACTER STRING TOO LARGE'/
C  Error -111
      DATA ERMSGS( 89)/' --SYSTEM ERROR'/
C  Error -112
      DATA ERMSGS( 90)/' --ONLY ONE METAFILE WORKSTATION CAN BE OPEN AT
     +A TIME'/
C  Error -200
      DATA ERMSGS( 91)/' --X driver error: memory allocation in processi
     +ng a character from a fontcap'/
C  Error -201
      DATA ERMSGS( 92)/' --X driver error: error opening fontcap'/
C  Error -202
      DATA ERMSGS( 93)/' --X driver error: error reading fontcap'/
C  Error -203
      DATA ERMSGS( 94)/' --X driver warning: invalid font index, using t
     +he default font'/
C  Error -204
      DATA ERMSGS( 95)/' --X driver error: memory allocation error in cr
     +eating device table'/
C  Error -205
      DATA ERMSGS( 96)/' --X driver error: too many open devices'/
C  Error -206
      DATA ERMSGS( 97)/' --X driver error: error in internal memory mana
     +gement'/
C  Error -207
      DATA ERMSGS( 98)/' --X driver error: error in allocating memory fo
     +r device dependent table'/
C  Error -208
      DATA ERMSGS( 99)/' --X driver error: DISPLAY environment variable
     +not set'/
C  Error -209
      DATA ERMSGS(100)/' --X driver error: error opening display'/
C  Error -210
      DATA ERMSGS(101)/' --X driver error: error getting window attribut
     +es'/
C  Error -211
      DATA ERMSGS(102)/' --X driver error: error creating pixmap'/
C  Error -212
      DATA ERMSGS(103)/' --X driver error: cell array has zero width or
     +height'/
C  Error -213
      DATA ERMSGS(104)/' --X driver error: memory allocation error in pr
     +ocessing cell array'/
C  Error -214
      DATA ERMSGS(105)/' --X driver error: error creating X image'/
C  Error -215
      DATA ERMSGS(106)/' --X driver error: memory allocation error in cr
     +eating X image'/
C  Error -216
      DATA ERMSGS(107)/' --X driver error: pixel size must be byte multi
     +ple'/
C  Error -300
      DATA ERMSGS(108)/' --PostScript error: Encapsulated PostScript can
     + have only one page'/
C  Error -301
      DATA ERMSGS(109)/' --PostScript error: error in allocating memory
     +for device dependent table'/
C  Error -302
      DATA ERMSGS(110)/' --PostScript error: error opening output file'/
C  Error -303
      DATA ERMSGS(111)/' --PostScript warning: requested character not a
     +vailable, asterisk plotted, use Plotchar'/
C  Error -217
      DATA ERMSGS(112)/' --X driver error: error in retrieving fontcap n
     +ame'/
C  Error -218
      DATA ERMSGS(113)/' --X driver error: invalid index into GKS workst
     +ation identifiers'/
C  Error -219
      DATA ERMSGS(114)/' --X driver error: color index exceeds maximum a
     +llowed'/
C  Error -220
      DATA ERMSGS(115)/' --X driver warning: color allocated is differen
     +t from the color requested'/
C  Error -221
      DATA ERMSGS(116)/' --X driver warning: unable to change color mode
     +l'/
C  Error 2200
      DATA ERMSGS(117)/' --C-binding specific error: buffer overflow in
     +input or inquiry function'/
C  Error 2201
      DATA ERMSGS(118)/' --C-binding specific error: start index out of
     +range'/
C  Error 2202
      DATA ERMSGS(119)/' --C-binding specific error: enumeration type ou
     +t of range'/
C  Error 2203
      DATA ERMSGS(120)/' --C-binding specific error: length of list is n
     +egative'/
C  Error 2204
      DATA ERMSGS(121)/' --C-binding specific error: cannot allocate mem
     +ory'/
C  Error 90
      DATA ERMSGS(122)/' --INTERIOR STYLE PATTERN IS NOT SUPPORTED ON TH
     +IS WORKSTATION'/
C  Error -113
      DATA ERMSGS(123)/' --Warning:  XMIN > XMAX or YMIN > YMAX in windo
     +w (non-standard NCAR extension of GKS)'/
C  Error -400
      DATA ERMSGS(124)/' --temporary file termination applies only to me
     +tafile workstations'/
C  Error -401
      DATA ERMSGS(125)/' --Invalid workstation identifier in metafile re
     +open'/
C  Error -402
      DATA ERMSGS(126)/' --Invalid connection identifier in metafile reo
     +pen'/
C  Error -403
      DATA ERMSGS(127)/' --Invalid workstation type in metafile reopen'/
C  Error -404
      DATA ERMSGS(128)/' --Workstation identifier already open in metafi
     +le reopen'/
C  Error -405
      DATA ERMSGS(129)/' --Maximum number of open workstations exceeded
     +in metafile reopen'/
C  Error -406
      DATA ERMSGS(130)/' --cannot have more than one NCAR CGM open at a
     +given time'/
C  Error -350
      DATA ERMSGS(131)/' --PDF error: error in allocating memory for dev
     +ice dependent table'/
C  Error -351
      DATA ERMSGS(132)/' --PDF error: error opening output file'/
C  Error -352
      DATA ERMSGS(133)/' --PDF warning: requested character not availab
     +le, asterisk plotted, use Plotchar'/
C  Error -353
      DATA ERMSGS(134)/' -- Only one PDF workstation can be open at a ti
     +me'/
C  Error -450
      DATA ERMSGS(135)/' -- Error opening xwd output file'/
C  Error -451
      DATA ERMSGS(136)/' -- Error opening PNG output file'/
C  Error -452
      DATA ERMSGS(137)/' -- Error reading pixmap for PNG output'/
C  Error -453
      DATA ERMSGS(138)/' -- Unsupported pixmap depth for PNG output'/
C  Error -354
      DATA ERMSGS(139)/' -- A dummy version of the interface function gg
     +kwdr has been called, most likely as a result of requesting output
     + other than an NCGM while having specified the -noX11 option.'/
C  Error -501
      DATA ERMSGS(140)/' -- cairo driver error: error in allocating memo
     +ry for device dependent table'/
C  Error -502
      DATA ERMSGS(141)/' -- cairo driver error: error opening output fil
     +e'/
C  Error -355
      DATA ERMSGS(142)/' -- PDF driver error, incorrect paper width speci
     +fication.'/
C  Error -356
      DATA ERMSGS(143)/' -- PDF driver error, incorrect paper height spec
     +ification.'/
C  Error -503
      DATA ERMSGS(144)/' -- cairo driver error, null or invalid argument
     + passed to function.'/
C  Error -504
      DATA ERMSGS(145)/' -- cairo driver error, unable to rename output
     *file.'/
C
      DATA GNAM(001),GNAM(002),GNAM(003)/'GOPKS' ,'GCLKS' ,'GOPWK' /
      DATA GNAM(004),GNAM(005),GNAM(006)/'GCLWK' ,'GACWK' ,'GDAWK' /
      DATA GNAM(007),GNAM(008),GNAM(009)/'GCLRWK','GRSGWK','GUWK'  /
      DATA GNAM(010),GNAM(011),GNAM(012)/'GSDS'  ,'GMSG'  ,'GESC'  /
      DATA GNAM(013),GNAM(014),GNAM(015)/'GPL'   ,'GPM'   ,'GTX'   /
      DATA GNAM(016),GNAM(017),GNAM(018)/'GFA'   ,'GCA'   ,'GGDP'  /
      DATA GNAM(019),GNAM(020),GNAM(021)/'GSPLI' ,'GSLN'  ,'GLSWSC'/
      DATA GNAM(022),GNAM(023),GNAM(024)/'GSPLCI','GSPMI' ,'GSMK'  /
      DATA GNAM(025),GNAM(026),GNAM(027)/'GSMKSC','GSPMCI','GSTXI' /
      DATA GNAM(028),GNAM(029),GNAM(030)/'GSTXFP','GSCHXP','GSCHSP'/
      DATA GNAM(031),GNAM(032),GNAM(033)/'GSTXCI','GSCHH' ,'GSCHUP'/
      DATA GNAM(034),GNAM(035),GNAM(036)/'GSTXP' ,'GSTXAL','GSFAI' /
      DATA GNAM(037),GNAM(038),GNAM(039)/'GSFAIS','GSFASI','GSFACI'/
      DATA GNAM(040),GNAM(041),GNAM(042)/'GSPA'  ,'GSPARF','GSASF' /
      DATA GNAM(043),GNAM(044),GNAM(045)/'GSPKID','GSPLR' ,'GSPMR' /
      DATA GNAM(046),GNAM(047),GNAM(048)/'GSTXR' ,'GSFAR' ,'GSPAR' /
      DATA GNAM(049),GNAM(050),GNAM(051)/'GSCR'  ,'GSWN'  ,'GSVP'  /
      DATA GNAM(052),GNAM(053),GNAM(054)/'GSVPIP','GSELNT','GSCLIP'/
      DATA GNAM(055),GNAM(056),GNAM(057)/'GSWKWN','GSWKVP','GCRSG' /
      DATA GNAM(058),GNAM(059),GNAM(060)/'GCLSG' ,'GRENSG','GDSG'  /
      DATA GNAM(061),GNAM(062),GNAM(063)/'GDSGWK','GASGWK','GCSGWK'/
      DATA GNAM(064),GNAM(065),GNAM(066)/'GINSG' ,'GSSGT' ,'GSVIS' /
      DATA GNAM(067),GNAM(068),GNAM(069)/'GSHLIT','GSSGP' ,'GSDTEC'/
      DATA GNAM(070),GNAM(071),GNAM(072)/'GINLC' ,'GINSK' ,'GINVL' /
      DATA GNAM(073),GNAM(074),GNAM(075)/'GINCH' ,'GINPK' ,'GINST' /
      DATA GNAM(076),GNAM(077),GNAM(078)/'GSLCM' ,'GSSKM' ,'GSVLM' /
      DATA GNAM(079),GNAM(080),GNAM(081)/'GSCHM' ,'GSPKM' ,'GSSTM' /
      DATA GNAM(082),GNAM(083),GNAM(084)/'GRQLC' ,'GRQSK' ,'GRQVL' /
      DATA GNAM(085),GNAM(086),GNAM(087)/'GRQCH' ,'GRQPK' ,'GRQST' /
      DATA GNAM(088),GNAM(089),GNAM(090)/'GSMLC' ,'GSMSK' ,'GSMVL' /
      DATA GNAM(091),GNAM(092),GNAM(093)/'GSMCH' ,'GSMPK' ,'GSMST' /
      DATA GNAM(094),GNAM(095),GNAM(096)/'GWAIT' ,'GFLUSH','GGTLC' /
      DATA GNAM(097),GNAM(098),GNAM(099)/'GGTSK' ,'GGTVL' ,'GGTCH' /
      DATA GNAM(100),GNAM(101),GNAM(102)/'GGTPK' ,'GGTST' ,'GWITM' /
      DATA GNAM(103),GNAM(104),GNAM(105)/'GGTITM','GRDITM','GIITM' /
      DATA GNAM(106),GNAM(107),GNAM(108)/'GEVTM' ,'GACTM' ,'GPREC' /
      DATA GNAM(109)                    /'GUREC'                   /
      END

      SUBROUTINE SLAEDA( N, TLVLS, CURLVL, CURPBM, PRMPTR, PERM, GIVPTR,
     $                   GIVCOL, GIVNUM, Q, QPTR, Z, ZTEMP, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      INTEGER            CURLVL, CURPBM, INFO, N, TLVLS
*     ..
*     .. Array Arguments ..
      INTEGER            GIVCOL( 2, * ), GIVPTR( * ), PERM( * ),
     $                   PRMPTR( * ), QPTR( * )
      REAL               GIVNUM( 2, * ), Q( * ), Z( * ), ZTEMP( * )
*     ..
*
*  Purpose
*  =======
*
*  SLAEDA computes the Z vector corresponding to the merge step in the
*  CURLVLth step of the merge process with TLVLS steps for the CURPBMth
*  problem.
*
*  Arguments
*  =========
*
*  N      (input) INTEGER
*         The dimension of the symmetric tridiagonal matrix.  N >= 0.
*
*  TLVLS  (input) INTEGER
*         The total number of merging levels in the overall divide and
*         conquer tree.
*
*  CURLVL (input) INTEGER
*         The current level in the overall merge routine,
*         0 <= curlvl <= tlvls.
*
*  CURPBM (input) INTEGER
*         The current problem in the current level in the overall
*         merge routine (counting from upper left to lower right).
*
*  PRMPTR (input) INTEGER array, dimension (N lg N)
*         Contains a list of pointers which indicate where in PERM a
*         level's permutation is stored.  PRMPTR(i+1) - PRMPTR(i)
*         indicates the size of the permutation and incidentally the
*         size of the full, non-deflated problem.
*
*  PERM   (input) INTEGER array, dimension (N lg N)
*         Contains the permutations (from deflation and sorting) to be
*         applied to each eigenblock.
*
*  GIVPTR (input) INTEGER array, dimension (N lg N)
*         Contains a list of pointers which indicate where in GIVCOL a
*         level's Givens rotations are stored.  GIVPTR(i+1) - GIVPTR(i)
*         indicates the number of Givens rotations.
*
*  GIVCOL (input) INTEGER array, dimension (2, N lg N)
*         Each pair of numbers indicates a pair of columns to take place
*         in a Givens rotation.
*
*  GIVNUM (input) REAL array, dimension (2, N lg N)
*         Each number indicates the S value to be used in the
*         corresponding Givens rotation.
*
*  Q      (input) REAL array, dimension (N**2)
*         Contains the square eigenblocks from previous levels, the
*         starting positions for blocks are given by QPTR.
*
*  QPTR   (input) INTEGER array, dimension (N+2)
*         Contains a list of pointers which indicate where in Q an
*         eigenblock is stored.  SQRT( QPTR(i+1) - QPTR(i) ) indicates
*         the size of the block.
*
*  Z      (output) REAL array, dimension (N)
*         On output this vector contains the updating vector (the last
*         row of the first sub-eigenvector matrix and the first row of
*         the second sub-eigenvector matrix).
*
*  ZTEMP  (workspace) REAL array, dimension (N)
*
*  INFO   (output) INTEGER
*          = 0:  successful exit.
*          < 0:  if INFO = -i, the i-th argument had an illegal value.
*
*  Further Details
*  ===============
*
*  Based on contributions by
*     Jeff Rutter, Computer Science Division, University of California
*     at Berkeley, USA
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ZERO, HALF, ONE
      PARAMETER          ( ZERO = 0.0E0, HALF = 0.5E0, ONE = 1.0E0 )
*     ..
*     .. Local Scalars ..
      INTEGER            BSIZ1, BSIZ2, CURR, I, K, MID, PSIZ1, PSIZ2,
     $                   PTR, ZPTR1
*     ..
*     .. External Subroutines ..
      EXTERNAL           SCOPY, SGEMV, SROT, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          INT, REAL, SQRT
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
*
      IF( N.LT.0 ) THEN
         INFO = -1
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'SLAEDA', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
*
*     Determine location of first number in second half.
*
      MID = N / 2 + 1
*
*     Gather last/first rows of appropriate eigenblocks into center of Z
*
      PTR = 1
*
*     Determine location of lowest level subproblem in the full storage
*     scheme
*
      CURR = PTR + CURPBM*2**CURLVL + 2**( CURLVL-1 ) - 1
*
*     Determine size of these matrices.  We add HALF to the value of
*     the SQRT in case the machine underestimates one of these square
*     roots.
*
      BSIZ1 = INT( HALF+SQRT( REAL( QPTR( CURR+1 )-QPTR( CURR ) ) ) )
      BSIZ2 = INT( HALF+SQRT( REAL( QPTR( CURR+2 )-QPTR( CURR+1 ) ) ) )
      DO 10 K = 1, MID - BSIZ1 - 1
         Z( K ) = ZERO
   10 CONTINUE
      CALL SCOPY( BSIZ1, Q( QPTR( CURR )+BSIZ1-1 ), BSIZ1,
     $            Z( MID-BSIZ1 ), 1 )
      CALL SCOPY( BSIZ2, Q( QPTR( CURR+1 ) ), BSIZ2, Z( MID ), 1 )
      DO 20 K = MID + BSIZ2, N
         Z( K ) = ZERO
   20 CONTINUE
*
*     Loop thru remaining levels 1 -> CURLVL applying the Givens
*     rotations and permutation and then multiplying the center matrices
*     against the current Z.
*
      PTR = 2**TLVLS + 1
      DO 70 K = 1, CURLVL - 1
         CURR = PTR + CURPBM*2**( CURLVL-K ) + 2**( CURLVL-K-1 ) - 1
         PSIZ1 = PRMPTR( CURR+1 ) - PRMPTR( CURR )
         PSIZ2 = PRMPTR( CURR+2 ) - PRMPTR( CURR+1 )
         ZPTR1 = MID - PSIZ1
*
*       Apply Givens at CURR and CURR+1
*
         DO 30 I = GIVPTR( CURR ), GIVPTR( CURR+1 ) - 1
            CALL SROT( 1, Z( ZPTR1+GIVCOL( 1, I )-1 ), 1,
     $                 Z( ZPTR1+GIVCOL( 2, I )-1 ), 1, GIVNUM( 1, I ),
     $                 GIVNUM( 2, I ) )
   30    CONTINUE
         DO 40 I = GIVPTR( CURR+1 ), GIVPTR( CURR+2 ) - 1
            CALL SROT( 1, Z( MID-1+GIVCOL( 1, I ) ), 1,
     $                 Z( MID-1+GIVCOL( 2, I ) ), 1, GIVNUM( 1, I ),
     $                 GIVNUM( 2, I ) )
   40    CONTINUE
         PSIZ1 = PRMPTR( CURR+1 ) - PRMPTR( CURR )
         PSIZ2 = PRMPTR( CURR+2 ) - PRMPTR( CURR+1 )
         DO 50 I = 0, PSIZ1 - 1
            ZTEMP( I+1 ) = Z( ZPTR1+PERM( PRMPTR( CURR )+I )-1 )
   50    CONTINUE
         DO 60 I = 0, PSIZ2 - 1
            ZTEMP( PSIZ1+I+1 ) = Z( MID+PERM( PRMPTR( CURR+1 )+I )-1 )
   60    CONTINUE
*
*        Multiply Blocks at CURR and CURR+1
*
*        Determine size of these matrices.  We add HALF to the value of
*        the SQRT in case the machine underestimates one of these
*        square roots.
*
         BSIZ1 = INT( HALF+SQRT( REAL( QPTR( CURR+1 )-QPTR( CURR ) ) ) )
         BSIZ2 = INT( HALF+SQRT( REAL( QPTR( CURR+2 )-QPTR( CURR+
     $           1 ) ) ) )
         IF( BSIZ1.GT.0 ) THEN
            CALL SGEMV( 'T', BSIZ1, BSIZ1, ONE, Q( QPTR( CURR ) ),
     $                  BSIZ1, ZTEMP( 1 ), 1, ZERO, Z( ZPTR1 ), 1 )
         END IF
         CALL SCOPY( PSIZ1-BSIZ1, ZTEMP( BSIZ1+1 ), 1, Z( ZPTR1+BSIZ1 ),
     $               1 )
         IF( BSIZ2.GT.0 ) THEN
            CALL SGEMV( 'T', BSIZ2, BSIZ2, ONE, Q( QPTR( CURR+1 ) ),
     $                  BSIZ2, ZTEMP( PSIZ1+1 ), 1, ZERO, Z( MID ), 1 )
         END IF
         CALL SCOPY( PSIZ2-BSIZ2, ZTEMP( PSIZ1+BSIZ2+1 ), 1,
     $               Z( MID+BSIZ2 ), 1 )
*
         PTR = PTR + 2**( TLVLS-K )
   70 CONTINUE
*
      RETURN
*
*     End of SLAEDA
*
      END

C
C	$Id: pwrzos.f,v 1.4 2008-07-27 00:17:22 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE PWRZOS (JCHAR,INDEX,NSIZE)
C
C THIS ROUTINE SORTS JCHAR WHICH IS NSIZE IN LENGTH.  THE RELATIONSHIP
C BETWEEN JCHAR AND INDEX IS MAINTAINED.  A BUBBLE SORT IS USED.
C JCHAR IS SORTED IN ASCENDING ORDER.
C
      SAVE
      CHARACTER*1     JCHAR(NSIZE)     ,JTEMP     ,KTEMP
      DIMENSION       INDEX(NSIZE)
      LOGICAL         LDONE
C
      ISTART = 1
      ISTOP = NSIZE
      ISTEP = 1
C
C AT MOST NSIZE PASSES ARE NEEDED.
C
      DO 104 NPASS=1,NSIZE
       LDONE = .TRUE.
       I = ISTART
  101  ISUB = I+ISTEP
       IF (ISTEP*(ICHAR(JCHAR(I))-ICHAR(JCHAR(ISUB)))) 103,103,102
C
C THEY NEED TO BE SWITCHED.
C
  102  LDONE = .FALSE.
       JTEMP = JCHAR(I)
       KTEMP = JCHAR(ISUB)
       JCHAR(I) = KTEMP
       JCHAR(ISUB) = JTEMP
       ITEMP = INDEX(I)
       INDEX(I) = INDEX(ISUB)
       INDEX(ISUB) = ITEMP
C
C THEY DO NOT NEED TO BE SWITCHED.
C
  103  I = I+ISTEP
       IF (I .NE. ISTOP) GO TO 101
C
C IF NONE WERE SWITCHED DURING THIS PASS, WE CAN QUIT.
C
       IF (LDONE) RETURN
C
C SET UP FOR THE NEXT PASS IN THE OTHER DIRECTION.
C
       ISTEP = -ISTEP
       ITEMP = ISTART
       ISTART = ISTOP+ISTEP
       ISTOP = ITEMP
  104 CONTINUE
      RETURN
      END

C
C $Id: fcurv2.f,v 1.7 2008-07-27 03:10:11 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
C NOTE: If you make any changes to this software, please remember to
C make the same changes to the corresponding double precision routine.
C
      SUBROUTINE FCURV2(N,XI,YI,YP,SIGMA,M,XO,YO)
C
      DIMENSION XI(N),YI(N),YP(N),XO(M),YO(M)
C
      DO 10 I=1,M
        YO(I) = CURV2(XO(I),N,XI,YI,YP,SIGMA)
   10 CONTINUE
C
      RETURN
      END
      SUBROUTINE FCURVD(N,XI,YI,YP,SIGMA,M,XO,YO)
C
      DIMENSION XI(N),YI(N),YP(N),XO(M),YO(M)
C
      DO 10 I=1,M
        YO(I) = CURVD(XO(I),N,XI,YI,YP,SIGMA)
   10 CONTINUE
C
      RETURN
      END
      SUBROUTINE FCURVI(XL,XR,N,XI,YI,YP,SIGMA,FINT)
C
      DIMENSION XI(N),YI(N),YP(N)
C
      FINT = CURVI(XL,XR,N,XI,YI,YP,SIGMA)
C
      RETURN
      END
      SUBROUTINE FCURVP2(N,XI,YI,YP,P,SIGMA,M,XO,YO)
C
      DIMENSION XI(N),YI(N),YP(N),XO(M),YO(M)
C
      DO 10 I=1,M
        YO(I) = CURVP2(XO(I),N,XI,YI,P,YP,SIGMA)
   10 CONTINUE
C
      RETURN
      END
      SUBROUTINE FCURVPI(XL,XR,P,N,XI,YI,YP,SIGMA,FINT)
C
      DIMENSION XI(N),YI(N),YP(N)
C
      FINT = CURVPI(XL,XR,N,XI,YI,P,YP,SIGMA)
C
      RETURN
      END
      SUBROUTINE FKURV2(N,XI,YI,M,T,XO,YO,XP,YP,S,SIGMA)
C
      DIMENSION XI(N),YI(N),YP(N),S(N),T(M),XO(M),YO(M)
C
      DO 10 I=1,M
        CALL KURV2(T(I),XO(I),YO(I),N,XI,YI,XP,YP,S,SIGMA)
   10 CONTINUE
C
      RETURN
      END
      SUBROUTINE FKURVP2(N,XI,YI,M,T,XO,YO,XP,YP,S,SIGMA)
C
      DIMENSION XI(N),YI(N),YP(N),S(N),T(M),XO(M),YO(M)
C
      DO 10 I=1,M
        CALL KURVP2(T(I),XO(I),YO(I),N,XI,YI,XP,YP,S,SIGMA)
   10 CONTINUE
C
      RETURN
      END
      SUBROUTINE FKURVD(N,XI,YI,M,T,XO,YO,XD,YD,XDD,YDD,XP,YP,S,SIGMA)       
C
      DIMENSION XI(N),YI(N),YP(N),S(N),T(M),XO(M),YO(M),
     +          XD(M),YD(M),XDD(M),YDD(M)
C
      DO 10 I=1,M
        CALL KURVD(T(I),XO(I),YO(I),XD(I),YD(I),XDD(I),YDD(I),N,XI,YI,
     +             XP,YP,S,SIGMA)
   10 CONTINUE
C
      RETURN
      END
      SUBROUTINE FKURVPD(N,XI,YI,M,T,XO,YO,XD,YD,XDD,YDD,XP,YP,S,SIGMA)       
C
      DIMENSION XI(N),YI(N),YP(N),S(N),T(M),XO(M),YO(M),
     +          XD(M),YD(M),XDD(M),YDD(M)
C
      DO 10 I=1,M
        CALL KURVPD(T(I),XO(I),YO(I),XD(I),YD(I),XDD(I),YDD(I),N,XI,YI,       
     +             XP,YP,S,SIGMA)
   10 CONTINUE
C
      RETURN
      END
      SUBROUTINE FSURF2(SVALUE,XO,YO,M,N,XI,YI,ZI,IZ,ZP,SIGMA)
C
      DIMENSION XI(M),YI(N),ZI(IZ,N),ZP(M,N,3)
C
      SVALUE = SURF2(XO,YO,M,N,XI,YI,ZI,IZ,ZP,SIGMA)
C
      RETURN
      END
      SUBROUTINE FCURVS2(N,PARAM,XI,YI,XS,XSP,YS,YSP,SIGMA,
     +                   M,XL,XR,XO,YO)
C
      DIMENSION PARAM(N),XI(N),YI(N),XS(N),XSP(N),YS(N),YSP(N),
     +          XO(M),YO(M)
C
      XINC = (XR-XL)/REAL(M-1)
      DO 10 I=1,M
        CALL CURVS2(REAL(I-1)*XINC,N,PARAM,XS,YS,
     +              XSP,YSP,SIGMA,XO(I),YO(I))
   10 CONTINUE
C
      RETURN
      END

C
C	$Id: g01pl.f,v 1.9 2008-07-27 00:21:05 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE G01PL
C
C  Process POLYLINE elements.
C
      include 'g01prm.h'
      include 'gksin.h'
      include 'g01io.h'
      include 'g01ins.h'
      include 'g01wsl.h'
      include 'g01rqa.h'
      include 'g01ast.h'
      include 'g01adc.h'
      include 'g01opc.h'
      include 'gksenu.h'
C
      INTEGER  KALL, IPRIM, NBYTES, NUMO, K, INDX1, INDX2
      DIMENSION NUMO(2)
      SAVE KALL
C
      DATA KALL/0/ , IPRIM/1/
C
      KALL = KALL+1
      IF  (KALL .EQ. 1) THEN
C
C  Set the picture-empty flag to "not empty".
C
        MDEMPT = GNEMPT
C
C  Process pending attributes.
C
        IF (AGPEND(IPRIM)) THEN
C
C  Some changes are pending.
C
          IF (VALCHG(IVPLIX)) THEN
C
C  Send bundle index.
C
            NBYTES = 1+(MIXFW-1)/8
            CALL GPUTNI (CLLBIX,  IDLBIX,  NBYTES,  RERR)
            CALL GPUTPR (MRPLIX, MIXFW,  1, RERR)
            IF (RERR .NE. 0) RETURN
C
C  Set sent value to requested, clear change flag.
C
            MSPLIX         = MRPLIX
            VALCHG(IVPLIX) = .FALSE.
          END IF
          IF (VALCHG(IVLTYP)) THEN
C
C  LINETYPE
C
            NBYTES = 1+(MIXFW-1)/8
            CALL GPUTNI (CLLTYP,  IDLTYP,  NBYTES,  RERR)
            CALL GPUTPR (MRLTYP, MIXFW,  1, RERR)
            IF (RERR .NE. 0) RETURN
            MSLTYP = MRLTYP
            VALCHG(IVLTYP) = .FALSE.
          ENDIF
          IF (VALCHG(IVLWSC)) THEN
C
C  LINEWIDTH SCALE FACTOR
C
            NBYTES = 1+(2*MCFPP-1)/8
            CALL GPUTNI (CLLWID,  IDLWID,  NBYTES,  RERR)
            CALL GFLCNV (ARLWSC,NUMO)
            CALL GPUTPR (NUMO, MCFPP,  2, RERR)
            IF (RERR .NE. 0) RETURN
C
C  Set sent value to requested, clear change flag.
C
            ASLWSC         = ARLWSC
            VALCHG(IVLWSC) = .FALSE.
          ENDIF
          IF (VALCHG(IVPLCI)) THEN
C
C  Line color index.
C
            NBYTES = 1+(MCIXFW-1)/8
            CALL GPUTNI (CLLCLR, IDLCLR, NBYTES,  RERR)
            CALL GPUTPR (MRPLCI, MCIXFW,  1, RERR)
            IF (RERR .NE. 0) RETURN
C
C  Set sent value to requested, clear change flag.
C
            MSPLCI         = MRPLCI
            VALCHG(IVPLCI) = .FALSE.
          ENDIF
          IF (ANYASF) THEN
C
C  Some ASF has changed.
C
            CALL G01SAS (IPRIM, RERR)
            IF (RERR.NE.0)  RETURN
          END IF
C
C  Clear aggregate change variable.
C
          AGPEND(IPRIM) = .FALSE.
        ENDIF
C
C  Treat first call, put out opcode, and points
C
C  Put out opcode (class and ID) and total length.
C
        NBYTES = 1+(2*RL1*MVDCFW-1)/8
        CALL GPUTNI (CLPLIN,  IDPLIN,  NBYTES,  RERR)
        IF (RERR .NE. 0) RETURN
C
C  Put out first points array.
C
C  Truncate points to limits of NDC unit square, convert to VDC,
C  and store in MPXPY.
C
        DO 30 K=1,RL2
          INDX1 = 2*K-1
          INDX2 = INDX1+1
          MPXPY(INDX1) = MXOFF + INT(REAL(MXSCAL)*
     +                   (MAX(0.,MIN(1.0,RX(K)))))
          MPXPY(INDX2) = MYOFF + INT(REAL(MYSCAL)*
     +                   (MAX(0.,MIN(1.0,RY(K)))))
   30   CONTINUE
C
C Send out points.
C
        CALL GPUTPR (MPXPY,  MVDCFW,     2*RL2, RERR)
        IF (RERR .NE. 0) RETURN
C
C  If there is to be no continuation, reset the parameter "KALL".
C
        IF (CONT .EQ. 0) THEN
          KALL = 0
          RETURN
        ENDIF
      ENDIF
C
C  Treat the continuation calls.
C
      IF (KALL .GT. 1) THEN
C
C  Truncate points to limits of NDC unit square, convert to VDC,
C  and store in MPXPY.
C
        DO 40 K=1,RL2
          INDX1 = 2*K-1
          INDX2 = INDX1+1
          MPXPY(INDX1) = MXOFF + INT(REAL(MXSCAL)*
     +                   (MAX(0.,MIN(1.0,RX(K)))))
          MPXPY(INDX2) = MYOFF + INT(REAL(MYSCAL)*
     +                 (MAX(0.,MIN(1.0,RY(K)))))
   40   CONTINUE
        IF (CONT .EQ. 0) THEN
          CALL GPUTPR (MPXPY,  MVDCFW,     2*RL2, RERR)
          IF (RERR .NE. 0) RETURN
          KALL = 0
        ELSE
          CALL GPUTPR (MPXPY,  MVDCFW,     2*RL2, RERR)
          IF (RERR .NE. 0) RETURN
        ENDIF
      ENDIF
C
      RETURN
      END

      PROGRAM FSPLINE
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C This is an example program which demonstrates how to use
C the NCAR Graphics LINE routine.  The program draws a
C simple flow diagram and labels the diagram objects.
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Set up a color table
C
      CALL GSCR (IWKID,0,1.,1.,1.)
C
C Black foreground
C
      CALL GSCR (IWKID,1,0.,0.,0.)
C
C Red
C
      CALL GSCR (IWKID,2,1.,0.,0.)
C
C Green
C
      CALL GSCR (IWKID,3,0.,1.,0.)
C
C Blue
C
      CALL GSCR (IWKID,4,0.,0.,1.)
C
C Set the line color
C 
      CALL GSPLCI(2)
C
C Set the plotter mapping space
C
      CALL SET (0.,1.,0.,1.,0.,20., 0.,20.,1)
C
C Set the line width
C
      CALL GSLWSC(4.)
C
C
C Draw a box
C 
      CALL LINE(2.,8.,2.,10.)
      CALL LINE(2.,10.,5.,10.)
      CALL LINE(5.,10.,5.,8.)
      CALL LINE(5.,8.,2.,8.)
C
C Add text
C
      CALL PLCHLQ(3.5,9.,'Read I',15.,0.,0.)
C
C Draw a diamond
C
      CALL LINE(8.,9.,9.5,11.)
      CALL LINE(9.5,11.,11.,9.)
      CALL LINE(11.,9.,9.5,7.)
      CALL LINE(9.5,7.,8.,9.)
C
C Add text in Diamond
C
      CALL PLCHLQ(9.5,9.,'Is I<3?',15.,0.,0.)
      CALL PLCHLQ(10.,11.5,'yes',15.,0.,0.)
      CALL PLCHLQ(9.9,6.5,'no',15.,0.,0.)
C
C Draw a box
C 
      CALL LINE(15.,13.,18.,13.)
      CALL LINE(18.,13.,18.,11.)
      CALL LINE(18.,11.,15.,11.)
      CALL LINE(15.,11.,15.,13.)
C
C Add text in box
C
      CALL PLCHLQ(16.5,12.,'I = I+1',15.,0.,0.)
C
C Draw a box
C 
      CALL LINE(15.,7.,18.,7.)
      CALL LINE(18.,7.,18.,5.)
      CALL LINE(18.,5.,15.,5.)
      CALL LINE(15.,5.,15.,7.)
C
C Add text in box
C
      CALL PLCHLQ(16.5,6.,'I = I-1',15.,0.,0.)
C
C Set the line width
C
      CALL GSLWSC(2.)
C
C Set the line color
C
      CALL GSPLCI(4)
C
C Connect the objects
C
      CALL LINE(5.,9.,8.,9.)
      CALL LINE(9.5,11.,9.5,12.)
      CALL LINE(9.5,12.,15.,12.)
      CALL LINE(9.5,7.,9.5,6.)
      CALL LINE(9.5,6.,15.,6.)
C
C Label top of plot
C
      CALL PLCHHQ(10.,15.,'Decision Flow Chart',25.,0.,0.)
C
C Draw a boundary around plotter frame
C
      CALL LINE(0.,0.,20.,0.)
      CALL LINE(20.,0.,20.,20.)
      CALL LINE(20.,20.,0.,20.)
      CALL LINE(0.,20.,0.,0.)

      CALL FRAME
C
C Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      STOP

      END

C
C	$Id: concls.f,v 1.5 2008-07-27 00:16:56 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CONCLS (ZD,NDP)
C
C  GENERATE CONTOUR LEVELS BASED ON THE INPUT DATA
C
      DIMENSION       ZD(1)
C
C
      COMMON /CONRA1/ CL(30)     ,NCL        ,OLDZ       ,PV(210)    ,
     1                FINC       ,HI         ,FLO
      COMMON /CONRA2/ REPEAT     ,EXTRAP     ,PER        ,MESS       ,
     1                ISCALE     ,LOOK       ,PLDVLS     ,GRD        ,
     2                CINC       ,CHILO      ,CON        ,LABON      ,
     3                PMIMX      ,SCALE      ,FRADV      ,EXTRI      ,
     4                BPSIZ      ,LISTOP
      COMMON /CONRA3/ IREC
      COMMON /CONRA4/ NCP        ,NCPSZ
      COMMON /CONRA5/ NIT        ,ITIPV
      COMMON /CONRA6/ XST        ,YST        ,XED        ,YED        ,
     1                STPSZ      ,IGRAD      ,IG         ,XRG        ,
     2                YRG        ,BORD       ,PXST       ,PYST       ,
     3                PXED       ,PYED       ,ITICK
      COMMON /CONR18/ TITLE      ,ICNT   ,ITLSIZ
      COMMON /CONR19/ IHIGH      ,INMAJ      ,INLAB      ,INDAT      ,
     1              LEN      ,IFMT       ,LEND       ,
     2                IFMTD      ,ISIZEP     ,INMIN
      COMMON /CONRA9/ ICOORD(500),NP         ,MXXY       ,TR         ,
     1                BR         ,TL         ,BL         ,CONV       ,
     2                XN         ,YN         ,ITLL       ,IBLL       ,
     3                ITRL       ,IBRL       ,XC         ,YC         ,
     4                ITLOC(210) ,JX         ,JY         ,ILOC       ,
     5                ISHFCT     ,XO         ,YO         ,IOC        ,NC
      COMMON /CONR10/ NT         ,NL         ,NTNL       ,JWIPT      ,
     1                JWIWL      ,JWIWP      ,JWIPL      ,IPR        ,
     2                ITPV
      COMMON /CONR20/ NREP       ,NCRT       ,ISIZEL     ,
     1                MINGAP     ,ISIZEM         ,
     2                TENS
      COMMON /CONR12/ IXMAX      ,IYMAX      ,XMAX       ,YMAX
      LOGICAL         REPEAT     ,EXTRAP     ,PER        ,MESS       ,
     1                LOOK       ,PLDVLS     ,GRD        ,LABON      ,
     2                PMIMX      ,FRADV      ,EXTRI      ,CINC       ,
     3                TITLE      ,LISTOP     ,CHILO      ,CON
      COMMON /CONR15/ ISTRNG
        CHARACTER*64 ISTRNG
        COMMON /CONR16/ FORM
        CHARACTER*10 FORM
        COMMON /CONR17/ NDASH, IDASH, EDASH
        CHARACTER*10 NDASH, IDASH, EDASH
C
C
      SAVE
C
C  IF NOT USER SET COMPUTE CONTOUR LEVELS
C
      IF (.NOT.CON) GO TO  150
C
C  OTHERWISE GET HI AND LOW CONTOURS FOR MESSAGE
C
      HI = CL(1)
      FLO = CL(1)
      DO  110 I=1,NCL
         IF (HI .GE. CL(I)) GO TO  100
         HI = CL(I)
         GO TO  110
  100    IF (FLO .LE. CL(I)) GO TO  110
         FLO = CL(I)
  110 CONTINUE
C
C GET INCREMENT IF EQUAL SPACED CONTOURS
C
      IF (NCL .NE. 1) GO TO  120
      FINC = 0.
      RETURN
  120 FINC = ABS(CL(1)-CL(2))
      IF (NCL .EQ. 2) RETURN
      DO  130 I=3,NCL
         IF (FINC .NE. ABS(CL(I-1)-CL(I))) GO TO  140
  130 CONTINUE
      RETURN
  140 FINC = -1.
      RETURN
C
C  FIND HIGHEST AND LOWEST INPUT VALUES
C
  150 IF (CHILO) GO TO  180
      FLO = ZD(1)
      HI = ZD(1)
      DO  170 I=2,NDP
         IF (FLO .LE. ZD(I)) GO TO  160
         FLO = ZD(I)
         GO TO  170
  160    IF (HI .GE. ZD(I)) GO TO  170
         HI = ZD(I)
  170 CONTINUE
C
C  CALCULATE THE CONTOUR LEVEL INTERVAL
C
  180 IF (CINC) GO TO  200
      FINC = (HI-FLO)/15.
      IF (FINC .NE. 0.) GO TO  190
      CALL SETER (' CONCLS - CONSTANT INPUT FIELD',1,1)
      RETURN
C
C  ROUND FINC TO NICE NUMBER
C
  190 P = 10.**(INT(ALOG10(FINC)+500.)-500)
      FINC = REAL(INT(FINC/P+0.1))*P
C
C  ROUND THE LOW VALUE TO START AT A NICE NUMBER
C
  200 IF (CHILO) GO TO  210
      FLO = REAL(INT(FLO/FINC))*FINC
C
C  COMPUTE THE CONTOUR LEVELS
C
C  TEST IF BREAK POINT WITHIN RANGE OF HI TO FLO
C
  210 IF (BPSIZ.GE.FLO .AND. BPSIZ.LE.HI) GO TO  240
C
C  BREAK POINT OUT OF RANGE SO GENERATE CONTOURS BASED ON FLO
C
      DO  220 I=1,30
         CV = FLO+REAL(I-1)*FINC
         ICUR = I
         CL(I) = CV
         IF (CV .GE. HI) GO TO  230
  220 CONTINUE
  230 NCL = ICUR
      HI = CV
      RETURN
C
C  BREAK POINT WITHIN RANGE SO BASE CONTOURS ON IT
C
  240 DO  250 I=1,30
         CV = BPSIZ-REAL(I-1)*FINC
         IND = (30-I)+1
         CL(IND) = CV
         ICUR = I
         IF (CV .LE. FLO) GO TO  260
  250 CONTINUE
C
C  PUT THE CONTOURS IN THE CORRECT ORDER
C
  260 DO  270 I=1,ICUR
         IND = (30-ICUR)+I
         CL(I) = CL(IND)
  270 CONTINUE
C
C  ADD THE GREATER THAN BREAK POINT CONTOURS
C
      IEND = 30-ICUR
      ISAV = ICUR+1
      DO  280 I=1,IEND
         CV = BPSIZ+REAL(I)*FINC
         CL(ISAV) = CV
         ISAV = ISAV+1
         IF (CV .GE. HI) GO TO  290
  280 CONTINUE
C
C  SET NUMBER OF CONTOUR LEVELS AND UPDATE THE HIGH VALUE
C
  290 NCL = ISAV-1
      HI = CV
      RETURN
      END

C NCLFORTSTART
      SUBROUTINE DWVBETAP1(MLON,NLAT,KLEV,P,X,XMSG,PSFC,IPUNIT,
     +                     IOPT,PTOP,PBOT,XVB,IER)
      IMPLICIT NONE

C     NCL:    x_wva =  wgtVertBeta (p, x, psfc, ipunit, iopt)

C                                                 INPUT
      INTEGER MLON,NLAT,KLEV,IPUNIT,IOPT,IER
      DOUBLE PRECISION P(KLEV),X(MLON,NLAT,KLEV),PSFC(MLON,NLAT),XMSG,
     +                 PTOP,PBOT
C                                                 OUTPUT
      DOUBLE PRECISION XVB(MLON,NLAT)
C NCLEND

C WEIGHTED VERTICAL SUM or AVERAGE USING BETA FACTORS
c nomenclature:
c .   p      - pressure levels
c .   x      - quantity to be weighted by pressure interval
c .   klev   - number of levels
c .   xmsg   - missing data
c .   psfc   - surface pressure
c .   ipunit - units flag for pressure:   0={mb,hPa}  1={Pa}
c .   wva    - result
c .   ier    - error code
c                                                 local
c -------------------------------------------------------------------
c Reference:
c Climate Diagnostics from Global Analyses: Conservation of Mass ....
c Kevin Trenberth
c July, 1991,  pp 707-
c -------------------------------------------------------------------
      INTEGER ML,NL,KL,PFLAG,KK,KLVL
      DOUBLE PRECISION PWRK(KLEV),XWRK(KLEV)
c                                                 initialize return
      DO NL = 1,NLAT
          DO ML = 1,MLON
              XVB(ML,NL) = XMSG
          END DO
      END DO
c                                     top-to-bot (+1) or bot-to-top (-1)
      PFLAG = 1
      IF (P(2).LT.P(1)) PFLAG = -1

      DO NL = 1,NLAT
          DO ML = 1,MLON
              KLVL = 0
c                                              ensure top to bot order
c                                              strip missing levels
              IF (PFLAG.EQ.1) THEN
                  DO KL = 1,KLEV
                      IF (X(ML,NL,KL).NE.XMSG) THEN
                          KLVL = KLVL + 1
                          PWRK(KLVL) = P(KL)
                          XWRK(KLVL) = X(ML,NL,KL)
                      END IF
                  END DO
              ELSE
                  DO KL = 1,KLEV
                      IF (X(ML,NL,KLEV+1-KL).NE.XMSG) THEN
                          KLVL = KLVL + 1
                          PWRK(KLVL) = P(KLEV+1-KL)
                          XWRK(KLVL) = X(ML,NL,KLEV+1-KL)
                      END IF
                  END DO
              END IF

              IF (KLVL.GE.2) THEN
                  CALL DWVBETAP(KLVL,PWRK,XWRK,PSFC(ML,NL),IPUNIT,IOPT,
     +                          PTOP,PBOT,XVB(ML,NL),IER)
              END IF

          END DO
      END DO

      RETURN
      END
C     ===================
C NCLFORTSTART
      SUBROUTINE DWVBETAP3(MLON,NLAT,KLEV,P,X,XMSG,PSFC,IPUNIT,
     +                     IOPT,PTOP,PBOT,XVB,IER)
      IMPLICIT NONE

C     NCL:    x_wva =  wgtVertBeta (p, x, psfc, ipunit, iopt)

C                                                 INPUT
      INTEGER MLON,NLAT,KLEV,IPUNIT,IOPT,IER
      DOUBLE PRECISION P(MLON,NLAT,KLEV),X(MLON,NLAT,KLEV),
     +                 PSFC(MLON,NLAT),XMSG,PTOP,PBOT
C                                                 OUTPUT
      DOUBLE PRECISION XVB(MLON,NLAT)
C NCLEND

      INTEGER ML,NL,KL,PFLAG,KK,KLVL
      DOUBLE PRECISION PWRK(KLEV),XWRK(KLEV)
c                                                 initialize return
      DO NL = 1,NLAT
          DO ML = 1,MLON
              XVB(ML,NL) = XMSG
          END DO
      END DO
c                                    top-to-bot (+1) or bot-to-top (-1)
      PFLAG = 1
      IF (P(1,2,2).LT.P(1,1,1)) PFLAG = -1

      DO NL = 1,NLAT
          DO ML = 1,MLON
              KLVL = 0
c                                            ensure top to bot order
c                                            strip missing levels
              IF (PFLAG.EQ.1) THEN
                  DO KL = 1,KLEV
                      IF (X(ML,NL,KL).NE.XMSG) THEN
                          KLVL = KLVL + 1
                          PWRK(KLVL) = P(ML,NL,KL)
                          XWRK(KLVL) = X(ML,NL,KL)
                      END IF
                  END DO
              ELSE
                  DO KL = 1,KLEV
                      IF (X(ML,NL,KLEV+1-KL).NE.XMSG) THEN
                          KLVL = KLVL + 1
                          PWRK(KLVL) = P(ML,NL,KLEV+1-KL)
                          XWRK(KLVL) = X(ML,NL,KLEV+1-KL)
                      END IF
                  END DO
              END IF

              IF (KLVL.GE.3) THEN
                  CALL DWVBETAP(KLVL,PWRK,XWRK,PSFC(ML,NL),IPUNIT,IOPT,
     +                          PTOP,PBOT,XVB(ML,NL),IER)
              END IF

          END DO
      END DO

      RETURN
      END
C     ===================
      SUBROUTINE DWVBETAP(KLVL,P,XP,PSFC,IPUNIT,IOPT,PTOP,PBOT,XVB,KER)
      IMPLICIT NONE
C                                                 arguments
      INTEGER KLVL,IPUNIT,IOPT,KER
      DOUBLE PRECISION P(KLVL),XP(KLVL),PSFC,PBOT,PTOP,XVB
C                                                 local
      INTEGER KL,KK,KLMAX
      DOUBLE PRECISION PP(0:2*KLVL),XPP(0:2*KLVL),DPP(0:2*KLVL),
     +                 BETA(0:2*KLVL),WSUM,PTOPF,PBOTF,PBOTX


      KER = 0
C                                                 fixed  limits
      PTOPF = 0.0D0
      PBOTF = 1100.D0
      IF (IPUNIT.GT.0) THEN
          PBOTF = PBOTF*100.D0
      END IF

      KK = 0
      KLMAX = 2*KLVL
      PP(0) = PTOPF
      XPP(0) = XP(1)
      DO KL = 1,KLMAX - 1,2
          KK = KK + 1
          PP(KL) = P(KK)
          XPP(KL) = XP(KK)
      END DO
      PP(KLMAX) = PBOTF
      XPP(KLMAX) = XP(KLVL)
c                                      xpp(2,4,..,klmax-2) not used
      DO KL = 2,KLMAX - 2,2
          PP(KL) = (PP(KL-1)+PP(KL+1))*0.5D0
          XPP(KL) = (XPP(KL-1)+XPP(KL+1))*0.5D0
      END DO
C                                                  fixed layer thickness
      DPP(0) = PP(2)
      DO KL = 1,KLMAX - 1
          DPP(KL) = PP(KL+1) - PP(KL-1)
      END DO
      DPP(KLMAX) = PBOTF - PP(KLMAX-1)

      DO KL = 1,KLMAX
          BETA(KL) = 0.0D0
      END DO

      PBOTX = PSFC
      IF (PBOT.LT.PSFC) PBOTX = PBOT

      DO KL = 1,KLMAX - 1,2
          IF (PBOTX.LT.PP(KL+1) .AND. PBOTX.GE.PP(KL-1)) THEN
              BETA(KL) = (PBOTX-PP(KL-1))/ (PP(KL+1)-PP(KL-1))

          ELSE IF (PTOP.GT.PP(KL-1) .AND. PTOP.LE.PP(KL+1)) THEN
              BETA(KL) = (PTOP-PP(KL-1))/ (PP(KL+1)-PP(KL-1))

          ELSE IF (PP(KL).LT.PBOTX .AND. PP(KL).GE.PTOP) THEN
              BETA(KL) = 1.0D0
          END IF

      END DO

c calculate the weghted sum [integration] or weighted average
c only odd levels are used

      XVB = 0.0D0
      WSUM = 0.0D0
      DO KL = 1,KLMAX,2
          XVB = XVB + XPP(KL)*BETA(KL)*DPP(KL)
          WSUM = WSUM + BETA(KL)*DPP(KL)
      END DO

      IF (IOPT.EQ.1) THEN
          IF (WSUM.GT.0.D0) THEN
              XVB = XVB/WSUM
          END IF
      END IF

      RETURN
      END

C
C      $Id: xy17f.f,v 1.9 2010-03-15 22:49:25 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                     C
C                Copyright (C)  1996                                  C
C        University Corporation for Atmospheric Research              C
C                All Rights Reserved                                  C
C                                                                     C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C  File:       xy17f.f
C
C  Author:     Bob Lackman
C              National Center for Atmospheric Research
C              PO 3000, Boulder, Colorado
C
C  Date:       24 Jan 1996
C
C  Description:    Reads an ASCII file with 4 variables:
C                  lon, u, v, and t.  u, v, and t are plotted
C                  with 3 stacked y axes.
C

      external NhlFAppClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFCairoWindowWorkstationClass
      external NhlFXyPlotClass
      external NhlFCoordArraysClass

      parameter (ncurve=3, npts=129) 

      CHARACTER*7  wks_type

      integer i, rlist, wks, appid, field1, field2, field3
      integer xy1, xy2, xy3, grlist
      integer num_dspec
      data num_dspec /1/

C
C  Create variables to contain data.
C

      real a,b,c,d
      real y (ncurve,npts), lon (npts), u (npts), v (npts), t (npts)
      real y1val (5), y2val (6), y3val(5)
      data y1val /-90.0 , -80.0, -70.0, -60.0, -50.0/
      data y2val /10.0, 20.0, 30.0, 40.0, 50.0, 60.0/
      data y3val /-20.0, -10.0, 0.0, 10.0, 20.0/
 
      character*5 y1lab(5), y2lab(6), y3lab(5)
      data y1lab /'-90.', '-80.', '-70.', '-60.', '-50.'/
      data y2lab /'10.', '20.', '30.', '40.', '50.', '60.'/
      data y3lab /'-20.', '-10.', '0.', '10.', '20.'/


C
C Define the workstation type
C
      wks_type = "x11"
C
C  Read ASCII file xy.asc
C
      open(unit=10,file='xy.asc',status='old',form='formatted',err=105)

C
C   xy.asc has 4 vars of length 129 longitudes, lon, u, v, t
C
C     The data is taken at 43N latitude.  Longitude is an index
C     1-129 standing for 0 deg - 360 deg in steps of 360/128?
C     u and v are in m/s, and t is in deg K.
C

      do 100 i=1,npts,1
         read (10,101,END=103,ERR=103) a,b,c,d
         lon(i)=a
         u(i)=b
         v(i)=c
         t(i)=d
  100 continue
  101 FORMAT (4X,F6.2,5X,F5.2,4X,F6.2,4X,F6.2)

  103 close (10)

      do 104 i=1,npts,1
         lon (i) = (lon(i)- 1.0) * 360.0/128.0
         t (i) =  (t(i) - 273.15) * 9 / 5 + 32.0
         y (1,i) = u(i)
         y (2,i) = v(i)
         y (3,i) = (t(i) - 273.15) * 9.0 / 5.0 + 32.0
 104  continue

      call NhlFInitialize
      call NhlFRLCreate (rlist,'setrl')

C
C  Create Application object.  The Application object name is used to
C  determine the name of the resource file, which is "xy17.res" in this
C  case. 
C
 
      call NhlFRLClear (rlist)
      call NhlFRLSetString (rlist, 'appDefaultParent', 'True', ierr)
      call NhlFRLSetString (rlist, 'appUsrDir', './', ierr)
      call NhlFCreate (appid, 'xy17', NhlFAppClass, 0, rlist, ierr)

C
C  If NCGM=1, then open NCGM workstation. 
C

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
         call NhlFRLClear (rlist)
         call NhlFRLSetString (rlist, 'wkMetaName', 
     +                         'xy17f.ncgm', ierr)
         call NhlFCreate (wks, 'xy17Work', NhlFNcgmWorkstationClass, 0,
     +                    rlist, ierr)

      endif

C
C  Create an X workstation. 
C

      if (wks_type.eq."x11".or.wks_type.eq."X11") then
         call NhlFRLClear (rlist)
         call NhlFRLSetString (rlist, 'wkPause', 'True', ierr)
         call NhlFCreate (wks, 'xy17Work', 
     +                    NhlFCairoWindowWorkstationClass,
     +                    0, rlist, ierr)
      endif

C
C  Open PS workstation. 
C
      if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
         call NhlFRLClear (rlist)
         call NhlFRLSetString (rlist, 'wkPSFileName', 
     +                         'xy17f.ps', ierr)
         call NhlFCreate (wks, 'xy17Work', NhlFPSWorkstationClass, 
     +                    0, rlist, ierr)
      endif
C
C  Open PDF workstation. 
C
      if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
         call NhlFRLClear (rlist)
         call NhlFRLSetString (rlist, 'wkPDFFileName', 
     +                         'xy17f.pdf', ierr)
         call NhlFCreate (wks, 'xy17Work', NhlFPDFWorkstationClass, 
     +                    0, rlist, ierr)
      endif
C
C  Open cairo PS/PDF workstation. 
C
      if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +    wks_type.eq."ps".or.wks_type.eq."PS") then
         call NhlFRLClear (rlist)
         call NhlFRLSetString (rlist, 'wkFileName', 
     +                         'xy17f', ierr)
         call NhlFRLSetString (rlist, 'wkFormat',wks_type,ierr) 
         call NhlFCreate (wks,'xy17Work',
     +                    NhlFCairoPSPDFWorkstationClass, 
     +                    0, rlist, ierr)
      endif
C
C  Open cairo PNG workstation. 
C
      if (wks_type.eq."png".or.wks_type.eq."PNG") then
         call NhlFRLClear (rlist)
         call NhlFRLSetString (rlist, 'wkFileName', 
     +                         'xy17f', ierr)
         call NhlFRLSetString (rlist, 'wkFormat',wks_type,ierr) 
         call NhlFCreate (wks,'xy17Work',
     +                    NhlFCairoImageWorkstationClass, 
     +                    0, rlist, ierr)
      endif

C
C  Create a coordarrays data object and configure its extents missing
C  values and at the same time convert it from Degrees K to Degrees F  
C

      call NhlFRLClear (rlist)
      call NhlFRLSetFloatArray (rlist, 'caXArray', lon, npts, ierr)
      call NhlFRLSetFloatArray (rlist, 'caYArray', t, npts, ierr)
      call NhlFCreate (field1, 'field1', NhlFcoordArraysClass, appid,
     +                 rlist, ierr)

C
C  Create a coordarrays data object and configure its extents missing
C  values and at the same time convert it from Degrees K to Degrees F
C

      call NhlFRLClear (rlist)
      call NhlFRLSetFloatArray (rlist, 'caXArray', lon, npts, ierr)
      call NhlFRLSetFloatArray (rlist, 'caYArray', u, npts, ierr)
      call NhlFCreate (field2, 'field2', NhlFcoordArraysClass, appid, 
     +                 rlist, ierr)

C
C  Create a coordarrays data object and configure its extents missing
C  values and at the same time convert it from Degrees K to Degrees F
C

      call NhlFRLClear (rlist)
      call NhlFRLSetFloatArray (rlist, 'caXArray', lon, npts, ierr)
      call NhlFRLSetFloatArray (rlist, 'caYArray', v, npts, ierr)
      call NhlFCreate (field3, 'field3', NhlFcoordArraysClass, appid,
     +                 rlist, ierr)

C
C  Create XyPlot object for curve 1 and assign data to it
C

      call NhlFRLClear (rlist)
      call NhlFRLSetFloat   (rlist, 'vpXF', 0.20, ierr)
      call NhlFRLSetFloat   (rlist, 'vpYF', 0.80, ierr)
      call NhlFRLSetFloat   (rlist, 'vpWidthF', 0.6, ierr)
      call NhlFRLSetFloat   (rlist, 'vpHeightF', 0.2, ierr)
      call NhlFRLSetInteger (rlist, 'xyCoordData', field1, ierr)
      call NhlFRLSetString  (rlist, 'trYReverse', 'False', ierr)
      call NhlFRLSetFloat   (rlist, 'trYMaxF',  -50.0, ierr)
      call NhlFRLSetFloat   (rlist, 'trYMinF',  -90.0, ierr)
      call NhlFRLSetFloat   (rlist, 'trXMaxF',  360.0, ierr)
      call NhlFRLSetFloat   (rlist, 'trXMinF',   0.0, ierr)
      call NhlFRLSetString  (rlist, 'tmYROn', 'False', ierr)
      call NhlFRLSetString  (rlist, 'tmYUseLeft', 'False', ierr)
      call NhlFRLSetString  (rlist, 'tmXMajorGrid', 'True', ierr)
      call NhlFRLSetString  (rlist, 'tmXBLabelsOn', 'False', ierr)
      call NhlFRLSetString  (rlist, 'tmYLLabelsOn', 'True', ierr)
      call NhlFRLSetFloat   (rlist, 'tmYLMajorLengthF', 0.01, ierr)
      call NhlFRLSetFloat   (rlist, 'tmYLMajorOutwardLengthF', 
     +                       0.0,ierr)
      call NhlFRLSetString  (rlist, 'tmYLMode', 'Explicit', ierr)
      call NhlFRLSetFloatArray  (rlist, 'tmYLValues', y1val, 5, ierr)
      call NhlFRLSetStringArray (rlist, 'tmYLLabels', y1lab, 5, ierr)
      call NhlFRLSetString  (rlist, 'tmYLLabelsOn', 'True', ierr)
      call NhlFRLSetString (rlist, 'tmYLLabelFontColor','red', ierr)
      call NhlFRLSetString  (rlist, 'tiMainString', 
     +                       'Temperature, U, V Stacked Plots', ierr)
      call NhlFRLSetString  (rlist, 'tiYAxisString', 
     +                       'Temp (Deg C)', ierr)
      call NhlFRLSetFloat   (rlist, 'tiXAxisFontHeightF', 0.02, ierr)
      call NhlFRLSetFloat   (rlist, 'tiYAxisFontHeightF', 0.02, ierr)
      call NhlFRLSetString  (rlist, 'tiXAxisFont', 
     +                       'helvetica-bold', ierr)
      call NhlFRLSetString  (rlist, 'tiYAxisFont', 
     +                       'helvetica-bold', ierr)
      call NhlFRLSetString (rlist, 'tiYAxisFontColor','red', ierr)
      call NhlFRLSetString  (rlist, 'tmYRMinorOn', 'False', ierr)
      call NhlFRLSetString  (rlist, 'tmYLMinorOn', 'False', ierr)
      call NhlFCreate(xy1, 'xy1', NhlFxyPlotClass, wks, rlist, ierr)

C
C  Create XyPlot object for curve 2 and assign data to it
C

      call NhlFRLClear (rlist)
      call NhlFRLSetFloat   (rlist, 'vpXF', 0.20, ierr)
      call NhlFRLSetFloat   (rlist, 'vpYF', 0.60, ierr)
      call NhlFRLSetFloat   (rlist, 'vpWidthF', 0.6, ierr)
      call NhlFRLSetFloat   (rlist, 'vpHeightF', 0.2, ierr)
      call NhlFRLSetInteger (rlist, 'xyCoordData', field2, ierr)
      call NhlFRLSetString  (rlist, 'trYReverse', 'False', ierr)
      call NhlFRLSetFloat   (rlist, 'trYMaxF',   60.0, ierr)
      call NhlFRLSetFloat   (rlist, 'trYMinF',   10.0, ierr)
      call NhlFRLSetFloat   (rlist, 'trXMaxF',  360.0, ierr)
      call NhlFRLSetFloat   (rlist, 'trXMinF',   0.0, ierr)
      call NhlFRLSetString  (rlist, 'tmYROn', 'True', ierr)
      call NhlFRLSetString  (rlist, 'tmYLOn', 'False', ierr)
      call NhlFRLSetString  (rlist, 'tmYUseLeft', 'False', ierr)
      call NhlFRLSetString  (rlist, 'tmXMajorGrid', 'True', ierr)
      call NhlFRLSetString  (rlist, 'tmYLLabelsOn', 'False', ierr)
      call NhlFRLSetString  (rlist, 'tmYRLabelsOn', 'True', ierr)
      call NhlFRLSetString  (rlist, 'tmYRMode', 'Explicit', ierr)
      call NhlFRLSetFloatArray  (rlist, 'tmYRValues', y2val, 6, ierr)
      call NhlFRLSetStringArray (rlist, 'tmYRLabels', y2lab, 6, ierr)
      call NhlFRLSetString  (rlist, 'tmXBLabelsOn', 'False', ierr)
      call NhlFRLSetString (rlist, 'tmYRLabelFontColor','green', ierr)
      call NhlFRLSetString  (rlist, 'tiYAxisString', 'U (m/s)', ierr)
      call NhlFRLSetFloat   (rlist, 'tiXAxisFontHeightF', 0.02, ierr)
      call NhlFRLSetFloat   (rlist, 'tiYAxisFontHeightF', 0.02, ierr)
      call NhlFRLSetString  (rlist, 'tiXAxisFont',
     +                       'helvetica-bold', ierr)
      call NhlFRLSetString  (rlist, 'tiYAxisFont',
     +                       'helvetica-bold', ierr)
      call NhlFRLSetString (rlist, 'tiYAxisFontColor','green', ierr)
      call NhlFRLSetString  (rlist, 'tmYRMinorOn', 'False', ierr)
      call NhlFRLSetString  (rlist, 'tmYLMinorOn', 'False', ierr)
      call NhlFCreate(xy2, 'xy2', NhlFxyPlotClass, wks, rlist, ierr)

C
C  Create XyPlot object for curve 3 and assign data to it
C
C  Increase the veiwport so the right scale will be about .15 NDC
C  right of the other grids.  Plot only the right vertical axis.
C  .5NDC = 360 deg lon, thus .65NDC = 360+108 deg lon.
C

      call NhlFRLClear (rlist)
      call NhlFRLSetFloat   (rlist,'vpXF', 0.20, ierr)
      call NhlFRLSetFloat   (rlist,'vpYF', 0.40, ierr)
      call NhlFRLSetFloat   (rlist,'vpWidthF', 0.6, ierr)
      call NhlFRLSetFloat   (rlist,'vpHeightF', 0.2, ierr)
      call NhlFRLSetInteger (rlist,'xyCoordData', field3, ierr)
      call NhlFRLSetString  (rlist,'trYReverse', 'False', ierr)
      call NhlFRLSetFloat   (rlist,'trYMaxF',   20.0, ierr)
      call NhlFRLSetFloat   (rlist,'trYMinF',  -20.0, ierr)
      call NhlFRLSetFloat   (rlist,'trXMaxF',  360.0, ierr)
      call NhlFRLSetFloat   (rlist,'trXMinF',   0.0, ierr)
      call NhlFRLSetString  (rlist,'tmYROn', 'False', ierr)
      call NhlFRLSetString  (rlist,'tmYUseLeft', 'False', ierr)
      call NhlFRLSetString  (rlist,'tmYLLabelsOn', 'True', ierr)
      call NhlFRLSetString  (rlist,'tmXBLabelsOn', 'True', ierr)
      call NhlFRLSetString  (rlist,'tmXMajorGrid', 'True', ierr)
      call NhlFRLSetFloat   (rlist,'tmYLMajorLengthF',0.01,ierr)
      call NhlFRLSetFloat   (rlist,'tmYLMajorOutwardLengthF', 
     +                       0.0, ierr)
      call NhlFRLSetString  (rlist,'tmYLMode', 'Explicit', ierr)
      call NhlFRLSetString  (rlist,'tmYLLabelsOn', 'True', ierr)
      call NhlFRLSetString (rlist,'tmYLLabelFontColor','blue', ierr)
      call NhlFRLSetString  (rlist,'tiYAxisString','V (m/s)',ierr)
      call NhlFRLSetString  (rlist,'tiXAxisString', 
     +                      'Longitude (Degs)', ierr)
      call NhlFRLSetFloat   (rlist,'tiXAxisFontHeightF',0.02,ierr)
      call NhlFRLSetFloat   (rlist,'tiYAxisFontHeightF',0.02,ierr)
      call NhlFRLSetString  (rlist,'tiXAxisFont','helvetica-bold',
     +                       ierr)
      call NhlFRLSetString  (rlist,'tiYAxisFont','helvetica-bold',
     +                       ierr)
      call NhlFRLSetString (rlist,'tiYAxisFontColor','blue', ierr)
      call NhlFRLSetString  (rlist,'tmYRMinorOn', 'False', ierr)
      call NhlFRLSetString  (rlist,'tmYLMinorOn', 'False', ierr)
      call NhlFRLSetFloatArray  (rlist,'tmYLValues',y3val,5,ierr)
      call NhlFRLSetStringArray (rlist,'tmYLLabels',y3lab,5,ierr)
      call NhlFCreate(xy3,'xy3',NhlFxyPlotClass,wks,rlist,ierr)



      call NhlFRLCreate (grlist,'getrl')
      call NhlFRLClear (grlist)
      call NhlFRLGetIntegerArray(grlist, 'xyCoordDataSpec', dspec,
     +                           num_dspec, ierr)
      call NhlFGetValues(xy1, grlist, ierr)

      call NhlFRLClear (rlist)
      call NhlFRLSetString (rlist, 'xyMonoLineColor', 'True', ierr)
      call NhlFRLSetString (rlist, 'xyLineColor','red', ierr)
      call NhlFSetValues (dspec, rlist, ierr)

      call NhlFRLClear (grlist)
      call NhlFRLGetIntegerArray(grlist, 'xyCoordDataSpec', dspec,
     +                           num_dspec, ierr)
      call NhlFGetValues(xy2, grlist, ierr)

      call NhlFRLClear (rlist)
      call NhlFRLSetString (rlist, 'xyMonoLineColor', 'True', ierr)
      call NhlFRLSetString (rlist, 'xyLineColor','green', ierr)
      call NhlFSetValues (dspec, rlist, ierr)

      call NhlFRLClear (grlist)
      call NhlFRLGetIntegerArray (grlist, 'xyCoordDataSpec', dspec,
     +                            num_dspec, ierr)
      call NhlFGetValues(xy3, grlist, ierr)

      call NhlFRLClear (rlist)
      call NhlFRLSetString (rlist, 'xyMonoLineColor', 'True', ierr)
      call NhlFRLSetString (rlist, 'xyLineColor', 'blue', ierr)
      call NhlFSetValues (dspec, rlist, ierr)

      call NhlFDraw(xy1, ierr)
      call NhlFDraw(xy2, ierr)
      call NhlFDraw(xy3, ierr)
      call NhlFFrame(wks, ierr)

      call NhlFDestroy (wks, ierr)
      call NhlFClose

      stop
 105  write  (6,*) 'error in opening file xy.asc'
      end

        PROGRAM CPEX07
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
        PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Declare required data arrays and workspace arrays.
C
        DIMENSION ZDAT(23,14),RWRK(1000),IWRK(1000),IAMA(12000)
        DIMENSION IASF(13)
        DIMENSION XCRA(1000),YCRA(1000)
        DIMENSION IAIA(10),IGIA(10)
C
C Declare arrays to hold the list of indices and the list of labels
C required by the label-bar routine.
C
        DIMENSION LIND(14)
        CHARACTER*10 LLBS(15)
C
C Declare the routine which will color the areas.
C
        EXTERNAL COLRAM
C
C Define an array for GKS aspect source flags.
C
        DATA IASF / 13*1 /
C
C Define the list of indices required by the label-bar routine.
C
        DATA LIND / 2,3,4,5,6,7,8,9,10,11,12,13,14,15 /
C
C Open GKS.
C
        CALL GOPKS (IERRF, ISZDM)
        CALL GOPWK (IWKID, LUNIT, IWTYPE)
        CALL GACWK (IWKID)
C
C Turn off the clipping indicator.
C
        CALL GSCLIP (0)
C
C Set all aspect source flags to "individual".
C
        CALL GSASF (IASF)
C
C Force solid fill.
C
        CALL GSFAIS (1)
C
C Define color indices.
C
        CALL DFCLRS(IWKID)
C
C Generate an array of test data.
C
        CALL GENDAT (ZDAT,23,23,14,20,20,-136.148,451.834)
C
C Force the plot into the upper portion of the frame.
C
        CALL CPSETR ('VPB - VIEWPORT BOTTOM',.25)
C
C Disallow the trimming of trailing zeroes.
C
        CALL CPSETI ('NOF - NUMERIC OMISSION FLAGS',0)
C
C Tell CONPACK to use 13 contour levels, splitting the range into 14
C equal bands, one for each of the 14 colors available.
C
        CALL CPSETI ('CLS - CONTOUR LEVEL SELECTOR',-13)
C
C Initialize the drawing of the contour plot.
C
        CALL CPRECT (ZDAT,23,23,14,RWRK,1000,IWRK,1000)
C
C Initialize the area map and put the contour lines into it.
C
        CALL ARINAM (IAMA,12000)
        CALL CPCLAM (ZDAT,RWRK,IWRK,IAMA)
C
C Color the map.
C
        CALL ARSCAM (IAMA,XCRA,YCRA,1000,IAIA,IGIA,10,COLRAM)
C
C Put black contour lines over the colored map.
C
        CALL GSPLCI (0)
        CALL CPCLDR (ZDAT,RWRK,IWRK)
        CALL GSPLCI (1)
C
C Draw a label bar for the plot, relating colors to values.
C
        CALL CPGETR ('ZMN',ZMIN)
        CALL CPGETR ('ZMX',ZMAX)
C
        DO 102 I=1,15
          CALL CPSETR ('ZDV - Z DATA VALUE',
     +                 ZMIN+REAL(I-1)*(ZMAX-ZMIN)/14.)
          CALL CPGETC ('ZDV - Z DATA VALUE',LLBS(I))
  102   CONTINUE
C
        CALL LBSETI ('CBL - COLOR OF BOX LINES',0)
        CALL LBLBAR (0,.05,.95,.15,.25,14,1.,.5,LIND,0,LLBS,15,1)
C
C Compute and print statistics for the plot, label it, and put a
C boundary line at the edge of the plotter frame.
C
        CALL CAPSAP ('EXAMPLE 7',IAMA,12000)
        CALL LABTOP ('EXAMPLE 7',.017)
        CALL BNDARY
C
C Advance the frame.
C
        CALL FRAME
C
C Close GKS.
C
        CALL GDAWK (IWKID)
        CALL GCLWK (IWKID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END


      SUBROUTINE COLRAM (XCRA,YCRA,NCRA,IAIA,IGIA,NAIA)
C
        DIMENSION XCRA(*),YCRA(*),IAIA(*),IGIA(*)
C
C The arrays XCRA and YCRA, for indices 1 to NCRA, contain the X and Y
C coordinates of points defining a polygon.  The area identifiers in
C the array IAIA, each with an associated group identifier in the array
C IGIA, tell us whether the polygon is to be color-filled or not.
C
C
C Assume the polygon will be filled until we find otherwise.
C
        IFLL=1
C
C If any of the area identifiers is negative, don't fill the polygon.
C
        DO 101 I=1,NAIA
          IF (IAIA(I).LT.0) IFLL=0
  101   CONTINUE
C
C Otherwise, fill the polygon in the color implied by its area
C identifier relative to edge group 3 (the contour-line group).
C
        IF (IFLL.NE.0) THEN
          IFLL=0
          DO 102 I=1,NAIA
            IF (IGIA(I).EQ.3) IFLL=IAIA(I)
  102     CONTINUE
          IF (IFLL.GT.0.AND.IFLL.LT.15) THEN
            CALL GSFACI (IFLL+1)
            CALL GFA (NCRA-1,XCRA,YCRA)
          END IF
        END IF
C
C Done.
C
        RETURN
C
      END

C
C $Id: setusv.f,v 1.8 2008-07-27 00:17:25 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE SETUSV (VN,IV)
      CHARACTER*(*) VN
C
C This subroutine sets the values of various utility state variables.
C VN is the name of the variable and IV is its value.
C
C The labelled common block IUTLCM contains all of the utility state
C variables.
C
      COMMON /IUTLCM/ IU(100)
      SAVE /IUTLCM/
C
C Define an array in which to get the GKS aspect source flags.
C
      DIMENSION LF(13)
C
C Check for an uncleared prior error.
C
      IF (ICFELL('SETUSV - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C Check for the linear-log scaling variable, which can take on these
C values:
C
C     1 = X linear, Y linear
C     2 = X linear, Y log
C     3 = X log   , Y linear
C     4 = X log   , Y log
C
      IF (VN(1:2).EQ.'LS') THEN
        IF (IV.LT.1.OR.IV.GT.4) THEN
          CALL SETER ('SETUSV - LOG SCALE VALUE OUT OF RANGE',2,1)
          RETURN
        END IF
        IU(1)=IV
C
C Check for the mirror-imaging variable, which can take on these
C values:
C
C     1 = X normal  , Y normal
C     2 = X normal  , Y reversed
C     3 = X reversed, Y normal
C     4 = X reversed, Y reversed
C
      ELSE IF (VN(1:2).EQ.'MI') THEN
        IF (IV.LT.1.OR.IV.GT.4) THEN
          CALL SETER ('SETUSV - MIRROR-IMAGING VALUE OUT OF RANGE',3,1)
          RETURN
        END IF
        IU(2)=IV
C
C Check for the scale factor setting the resolution of the plotter in
C the x direction.
C
      ELSE IF (VN(1:2).EQ.'XF') THEN
        IF (IV.LT.1.OR.IV.GT.15) THEN
          CALL SETER ('SETUSV - X RESOLUTION OUT OF RANGE',4,1)
          RETURN
        END IF
        IU(3)=IV
C
C Check for the scale factor setting the resolution of the plotter in
C the y direction.
C
      ELSE IF (VN(1:2).EQ.'YF') THEN
        IF (IV.LT.1.OR.IV.GT.15) THEN
          CALL SETER ('SETUSV - Y RESOLUTION OUT OF RANGE',5,1)
          RETURN
        END IF
        IU(4)=IV
C
C Check for the variable specifying the size of the pen-move buffer.
C
      ELSE IF (VN(1:2).EQ.'PB') THEN
        IF (IV.LT.2.OR.IV.GT.50) THEN
          CALL SETER ('SETUSV - PEN-MOVE BUFFER SIZE OUT OF RANGE',6,1)
          RETURN
        END IF
        CALL PLOTIF (0.,0.,2)
        IF (ICFELL('SETUSV',7).NE.0) RETURN
        IU(5)=IV
C
C Check for a metacode unit number.
C
      ELSE IF (VN(1:2).EQ.'MU') THEN
        IF (IV.LE.0) THEN
          CALL SETER ('SETUSV - METACODE UNIT NUMBER ILLEGAL',8,1)
          RETURN
        END IF
C
C What is done depends on whether OPNGKS has been called or not.  In
C either case, we end up with a new metacode unit.
C
        IF (IU(6).LT.0) THEN
          CALL GDAWK (1)
          CALL GCLWK (1)
          CALL GOPWK (1,IV,1)
          CALL GACWK (1)
          IU(6)=-IV
        ELSE
          IU(6)=IV
        END IF
C
C Check for one of the variables setting color and intensity.
C
      ELSE IF (VN(1:2).EQ.'IR') THEN
        IF (IV.LT.0) THEN
          CALL SETER ('SETUSV - ILLEGAL VALUE OF RED INTENSITY',9,1)
          RETURN
        END IF
        IU(7)=IV
C
      ELSE IF (VN(1:2).EQ.'IG') THEN
        IF (IV.LT.0) THEN
          CALL SETER ('SETUSV - ILLEGAL VALUE OF GREEN INTENSITY',10,1)
          RETURN
        END IF
        IU(8)=IV
C
      ELSE IF (VN(1:2).EQ.'IB') THEN
        IF (IV.LT.0) THEN
          CALL SETER ('SETUSV - ILLEGAL VALUE OF BLUE INTENSITY',11,1)
          RETURN
        END IF
        IU(9)=IV
C
      ELSE IF (VN(1:2).EQ.'IN') THEN
        IF (IV.LT.0.OR.IV.GT.10000) THEN
          CALL SETER ('SETUSV - ILLEGAL VALUE OF INTENSITY',12,1)
          RETURN
        END IF
        IU(10)=IV
C
C Assign the intensity-controlling variables to local variables with
C simple, meaningful names.
C
        IR=IU(7)
        IG=IU(8)
        IB=IU(9)
        IN=IU(10)
        II=IU(11)
        IM=IU(12)
C
C Compute the floating-point red, green, and blue intensities.
C
        FR=REAL(IR)/REAL(MAX(IR,IG,IB,1))*REAL(IN)/10000.
        FG=REAL(IG)/REAL(MAX(IR,IG,IB,1))*REAL(IN)/10000.
        FB=REAL(IB)/REAL(MAX(IR,IG,IB,1))*REAL(IN)/10000.
C
C Dump the pen-move buffer before changing anything.
C
        CALL PLOTIF (0.,0.,2)
        IF (ICFELL('SETUSV',13).NE.0) RETURN
C
C Set the aspect source flags for all the color indices to "individual".
C
        CALL GQASF (IE,LF)
        IF (IE.NE.0) THEN
          CALL SETER ('SETUSV - ERROR EXIT FROM GQASF',14,1)
          RETURN
        END IF
        LF( 3)=1
        LF( 6)=1
        LF(10)=1
        LF(13)=1
        CALL GSASF (LF)
C
C Pick a new color index and use it for polylines, polymarkers, text,
C and areas.
C
        II=MOD(II,IM)+1
        IU(11)=II
        CALL GSPLCI (II)
        CALL GSPMCI (II)
        CALL GSTXCI (II)
        CALL GSFACI (II)
C
C Now, redefine the color for that color index on each open workstation.
C
        CALL GQOPWK (0,IE,NO,ID)
        IF (IE.NE.0) THEN
          CALL SETER ('SETUSV - ERROR EXIT FROM GQOPWK',15,1)
          RETURN
        END IF
C
        DO 103 I=1,NO
          CALL GQOPWK (I,IE,NO,ID)
          IF (IE.NE.0) THEN
            CALL SETER ('SETUSV - ERROR EXIT FROM GQOPWK',16,1)
            RETURN
          END IF
          CALL GSCR (ID,II,FR,FG,FB)
  103   CONTINUE
C
C Check for variable resetting the color index.
C
      ELSE IF (VN(1:2).EQ.'II') THEN
C       IF (IV.LT.1.OR.IV.GT.IU(12)) THEN
        IF (IV.LT.0) THEN
          CALL SETER ('SETUSV - ILLEGAL COLOR INDEX',17,1)
          RETURN
        END IF
        IU(11)=IV
C
        CALL PLOTIF (0.,0.,2)
        IF (ICFELL('SETUSV',18).NE.0) RETURN
C
        CALL GQASF (IE,LF)
        IF (IE.NE.0) THEN
          CALL SETER ('SETUSV - ERROR EXIT FROM GQASF',19,1)
          RETURN
        END IF
        LF( 3)=1
        LF( 6)=1
        LF(10)=1
        LF(13)=1
        CALL GSASF (LF)
C
        CALL GSPLCI (IV)
        CALL GSPMCI (IV)
        CALL GSTXCI (IV)
        CALL GSFACI (IV)
C
C Check for the variable limiting the values of color index used.
C
      ELSE IF (VN(1:2).EQ.'IM') THEN
        IF (IV.LT.1) THEN
          CALL SETER ('SETUSV - ILLEGAL MAXIMUM COLOR INDEX',20,1)
          RETURN
        END IF
        IU(12)=IV
C
C Check for the variable setting the current line width scale factor.
C
      ELSE IF (VN(1:2).EQ.'LW') THEN
        IF (IV.LT.0) THEN
          CALL SETER ('SETUSV - ILLEGAL LINE WIDTH SCALE FACTOR',21,1)
          RETURN
        END IF
        IU(13)=IV
C
C Dump the pen-move buffer before changing anything.
C
        CALL PLOTIF (0.,0.,2)
        IF (ICFELL('SETUSV',22).NE.0) RETURN
C
C Set the aspect source flag for linewidth scale factor to "individual".
C
        CALL GQASF (IE,LF)
        IF (IE.NE.0) THEN
          CALL SETER ('SETUSV - ERROR EXIT FROM GQASF',23,1)
          RETURN
        END IF
        LF(2)=1
        CALL GSASF (LF)
C
C Redefine the line width scale factor.
C
        CALL GSLWSC (REAL(IV)/1000.)
C
C Check for the variable setting the current marker size scale factor.
C
      ELSE IF (VN(1:2).EQ.'MS') THEN
        IF (IV.LT.0) THEN
          CALL SETER ('SETUSV - ILLEGAL MARKER SIZE SCALE FACTOR',24,1)
          RETURN
        END IF
        IU(14)=IV
C
C Set aspect source flag for marker size scale factor to "individual".
C
        CALL GQASF (IE,LF)
        IF (IE.NE.0) THEN
          CALL SETER ('SETUSV - ERROR EXIT FROM GQASF',25,1)
          RETURN
        END IF
        LF(5)=1
        CALL GSASF (LF)
C
C Redefine the marker size scale factor.
C
        CALL GSMKSC (REAL(IV)/1000.)
C
C Otherwise, the variable name is unknown.
C
      ELSE
        CALL SETER ('SETUSV - UNKNOWN VARIABLE NAME IN CALL',26,1)
        RETURN
C
      ENDIF
C
      RETURN
C
      END

C
C $Id: hstmed.f,v 1.7 2008-07-27 00:17:15 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
C *****************************************************
C
      SUBROUTINE HSTMED(DATARR,NPTS2,WRK2,MED)
C
C *****************************************************
C
C  FINDS MEDIAN OF ALL DATA POINTS USING SHELL SORT
C
      REAL DATARR(NPTS2), WRK2(NPTS2), MED, TEMP
      INTEGER FLAG, D, HALFN
C
C  COPY DATA ARRAY TO WORK ARRAY
C
        DO 790 I = 1,NPTS2
  790     WRK2(I) = DATARR(I)
C
C  DO SHELL SORT
C
        HALFN = NPTS2/2
        D = NPTS2
  810   D = (D+1)/2
        FLAG = 0
        DO 830 I=1, NPTS2-D
          IF(WRK2(I) .GT. WRK2(I+D)) THEN
            TEMP = WRK2(I)
            WRK2(I) = WRK2(I+D)
            WRK2(I+D) = TEMP
            FLAG = 1
          ENDIF
  830   CONTINUE
        IF (FLAG .EQ. 1 .OR. D .GT. 1)GOTO 810
C
  850 IF (REAL(NPTS2)/2. .GT. REAL(HALFN)) THEN
        MED = WRK2(MIN(HALFN + 1,NPTS2))
      ELSE
        MED = (WRK2(MAX(1,HALFN)) + WRK2(MIN(HALFN + 1,NPTS2)))/2.
      ENDIF
      RETURN
      END

C
C $Id: tdctap.f,v 1.4 2008-07-27 00:17:32 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE TDCTAP (RTRI,MTRI,NTRI,ITRI,A,B,C,D)
C
        DIMENSION RTRI(10,MTRI)
C
C This routine is called to clip triangle number ITRI in the triangle
C list against the plane A*U+B*V+C*W+D=0.  The portion of the triangle
C where A*U+B*V+C*W+D is greater than zero is the portion to be clipped.
C
C Declare required arithmetic statement functions.
C
        SIDE(U,V,W)=A*U+B*V+C*W+D
C
        DNOM(U1,V1,W1,U2,V2,W2)=A*(U2-U1)+B*(V2-V1)+C*(W2-W1)
C
C There are eight possible cases, depending on which side of the plane
C the points are on.
C
        IF (SIDE(RTRI(1,ITRI),RTRI(2,ITRI),RTRI(3,ITRI)).LT.0.) THEN
C
          IF (SIDE(RTRI(4,ITRI),RTRI(5,ITRI),RTRI(6,ITRI)).LT.0.) THEN
C
            IF (SIDE(RTRI(7,ITRI),RTRI(8,ITRI),RTRI(9,ITRI)).LT.0.) THEN
C
C Point 1 in, point 2 in, point 3 in.
C
              RETURN
C
            ELSE
C
C Point 1 in, point 2 in, point 3 out.
C
              IF (NTRI.LT.MTRI) THEN
                JTRI=ITRI+1
                NTRI=NTRI+1
                IF (NTRI.NE.JTRI) THEN
                  RTRI(1,NTRI)=RTRI(1,JTRI)
                  RTRI(2,NTRI)=RTRI(2,JTRI)
                  RTRI(3,NTRI)=RTRI(3,JTRI)
                  RTRI(4,NTRI)=RTRI(4,JTRI)
                  RTRI(5,NTRI)=RTRI(5,JTRI)
                  RTRI(6,NTRI)=RTRI(6,JTRI)
                  RTRI(7,NTRI)=RTRI(7,JTRI)
                  RTRI(8,NTRI)=RTRI(8,JTRI)
                  RTRI(9,NTRI)=RTRI(9,JTRI)
                  RTRI(10,NTRI)=RTRI(10,JTRI)
                END IF
                T=-SIDE(RTRI(7,ITRI),RTRI(8,ITRI),RTRI(9,ITRI))/
     +             DNOM(RTRI(7,ITRI),RTRI(8,ITRI),RTRI(9,ITRI),
     +                  RTRI(4,ITRI),RTRI(5,ITRI),RTRI(6,ITRI))
                RTRI(1,JTRI)=RTRI(7,ITRI)+(RTRI(4,ITRI)-RTRI(7,ITRI))*T
                RTRI(2,JTRI)=RTRI(8,ITRI)+(RTRI(5,ITRI)-RTRI(8,ITRI))*T
                RTRI(3,JTRI)=RTRI(9,ITRI)+(RTRI(6,ITRI)-RTRI(9,ITRI))*T
                T=-SIDE(RTRI(7,ITRI),RTRI(8,ITRI),RTRI(9,ITRI))/
     +             DNOM(RTRI(7,ITRI),RTRI(8,ITRI),RTRI(9,ITRI),
     +                  RTRI(1,ITRI),RTRI(2,ITRI),RTRI(3,ITRI))
                RTRI(4,JTRI)=RTRI(7,ITRI)+(RTRI(1,ITRI)-RTRI(7,ITRI))*T
                RTRI(5,JTRI)=RTRI(8,ITRI)+(RTRI(2,ITRI)-RTRI(8,ITRI))*T
                RTRI(6,JTRI)=RTRI(9,ITRI)+(RTRI(3,ITRI)-RTRI(9,ITRI))*T
                RTRI(7,JTRI)=RTRI(1,ITRI)
                RTRI(8,JTRI)=RTRI(2,ITRI)
                RTRI(9,JTRI)=RTRI(3,ITRI)
                RTRI(10,JTRI)=RTRI(10,ITRI)
                RTRI(7,ITRI)=RTRI(1,JTRI)
                RTRI(8,ITRI)=RTRI(2,JTRI)
                RTRI(9,ITRI)=RTRI(3,JTRI)
                ITRI=JTRI
              END IF
C
            END IF
C
          ELSE
C
            IF (SIDE(RTRI(7,ITRI),RTRI(8,ITRI),RTRI(9,ITRI)).LT.0.) THEN
C
C Point 1 in, point 2 out, point 3 in.
C
              IF (NTRI.LT.MTRI) THEN
                JTRI=ITRI+1
                NTRI=NTRI+1
                IF (NTRI.NE.JTRI) THEN
                  RTRI(1,NTRI)=RTRI(1,JTRI)
                  RTRI(2,NTRI)=RTRI(2,JTRI)
                  RTRI(3,NTRI)=RTRI(3,JTRI)
                  RTRI(4,NTRI)=RTRI(4,JTRI)
                  RTRI(5,NTRI)=RTRI(5,JTRI)
                  RTRI(6,NTRI)=RTRI(6,JTRI)
                  RTRI(7,NTRI)=RTRI(7,JTRI)
                  RTRI(8,NTRI)=RTRI(8,JTRI)
                  RTRI(9,NTRI)=RTRI(9,JTRI)
                  RTRI(10,NTRI)=RTRI(10,JTRI)
                END IF
                T=-SIDE(RTRI(4,ITRI),RTRI(5,ITRI),RTRI(6,ITRI))/
     +             DNOM(RTRI(4,ITRI),RTRI(5,ITRI),RTRI(6,ITRI),
     +                  RTRI(1,ITRI),RTRI(2,ITRI),RTRI(3,ITRI))
                RTRI(1,JTRI)=RTRI(4,ITRI)+(RTRI(1,ITRI)-RTRI(4,ITRI))*T
                RTRI(2,JTRI)=RTRI(5,ITRI)+(RTRI(2,ITRI)-RTRI(5,ITRI))*T
                RTRI(3,JTRI)=RTRI(6,ITRI)+(RTRI(3,ITRI)-RTRI(6,ITRI))*T
                T=-SIDE(RTRI(4,ITRI),RTRI(5,ITRI),RTRI(6,ITRI))/
     +             DNOM(RTRI(4,ITRI),RTRI(5,ITRI),RTRI(6,ITRI),
     +                  RTRI(7,ITRI),RTRI(8,ITRI),RTRI(9,ITRI))
                RTRI(4,JTRI)=RTRI(4,ITRI)+(RTRI(7,ITRI)-RTRI(4,ITRI))*T
                RTRI(5,JTRI)=RTRI(5,ITRI)+(RTRI(8,ITRI)-RTRI(5,ITRI))*T
                RTRI(6,JTRI)=RTRI(6,ITRI)+(RTRI(9,ITRI)-RTRI(6,ITRI))*T
                RTRI(7,JTRI)=RTRI(7,ITRI)
                RTRI(8,JTRI)=RTRI(8,ITRI)
                RTRI(9,JTRI)=RTRI(9,ITRI)
                RTRI(10,JTRI)=RTRI(10,ITRI)
                RTRI(4,ITRI)=RTRI(1,JTRI)
                RTRI(5,ITRI)=RTRI(2,JTRI)
                RTRI(6,ITRI)=RTRI(3,JTRI)
                ITRI=JTRI
              END IF
C
            ELSE
C
C Point 1 in, point 2 out, point 3 out.
C
              T=-SIDE(RTRI(1,ITRI),RTRI(2,ITRI),RTRI(3,ITRI))/
     +           DNOM(RTRI(1,ITRI),RTRI(2,ITRI),RTRI(3,ITRI),
     +                RTRI(4,ITRI),RTRI(5,ITRI),RTRI(6,ITRI))
              RTRI(4,ITRI)=RTRI(1,ITRI)+(RTRI(4,ITRI)-RTRI(1,ITRI))*T
              RTRI(5,ITRI)=RTRI(2,ITRI)+(RTRI(5,ITRI)-RTRI(2,ITRI))*T
              RTRI(6,ITRI)=RTRI(3,ITRI)+(RTRI(6,ITRI)-RTRI(3,ITRI))*T
              T=-SIDE(RTRI(1,ITRI),RTRI(2,ITRI),RTRI(3,ITRI))/
     +           DNOM(RTRI(1,ITRI),RTRI(2,ITRI),RTRI(3,ITRI),
     +                RTRI(7,ITRI),RTRI(8,ITRI),RTRI(9,ITRI))
              RTRI(7,ITRI)=RTRI(1,ITRI)+(RTRI(7,ITRI)-RTRI(1,ITRI))*T
              RTRI(8,ITRI)=RTRI(2,ITRI)+(RTRI(8,ITRI)-RTRI(2,ITRI))*T
              RTRI(9,ITRI)=RTRI(3,ITRI)+(RTRI(9,ITRI)-RTRI(3,ITRI))*T
C
            END IF
C
          END IF
C
        ELSE
C
          IF (SIDE(RTRI(4,ITRI),RTRI(5,ITRI),RTRI(6,ITRI)).LT.0.) THEN
C
            IF (SIDE(RTRI(7,ITRI),RTRI(8,ITRI),RTRI(9,ITRI)).LT.0.) THEN
C
C Point 1 out, point 2 in, point 3 in.
C
              IF (NTRI.LT.MTRI) THEN
                JTRI=ITRI+1
                NTRI=NTRI+1
                IF (NTRI.NE.JTRI) THEN
                  RTRI(1,NTRI)=RTRI(1,JTRI)
                  RTRI(2,NTRI)=RTRI(2,JTRI)
                  RTRI(3,NTRI)=RTRI(3,JTRI)
                  RTRI(4,NTRI)=RTRI(4,JTRI)
                  RTRI(5,NTRI)=RTRI(5,JTRI)
                  RTRI(6,NTRI)=RTRI(6,JTRI)
                  RTRI(7,NTRI)=RTRI(7,JTRI)
                  RTRI(8,NTRI)=RTRI(8,JTRI)
                  RTRI(9,NTRI)=RTRI(9,JTRI)
                  RTRI(10,NTRI)=RTRI(10,JTRI)
                END IF
                T=-SIDE(RTRI(1,ITRI),RTRI(2,ITRI),RTRI(3,ITRI))/
     +             DNOM(RTRI(1,ITRI),RTRI(2,ITRI),RTRI(3,ITRI),
     +                  RTRI(7,ITRI),RTRI(8,ITRI),RTRI(9,ITRI))
                RTRI(1,JTRI)=RTRI(1,ITRI)+(RTRI(7,ITRI)-RTRI(1,ITRI))*T
                RTRI(2,JTRI)=RTRI(2,ITRI)+(RTRI(8,ITRI)-RTRI(2,ITRI))*T
                RTRI(3,JTRI)=RTRI(3,ITRI)+(RTRI(9,ITRI)-RTRI(3,ITRI))*T
                T=-SIDE(RTRI(1,ITRI),RTRI(2,ITRI),RTRI(3,ITRI))/
     +             DNOM(RTRI(1,ITRI),RTRI(2,ITRI),RTRI(3,ITRI),
     +                  RTRI(4,ITRI),RTRI(5,ITRI),RTRI(6,ITRI))
                RTRI(4,JTRI)=RTRI(1,ITRI)+(RTRI(4,ITRI)-RTRI(1,ITRI))*T
                RTRI(5,JTRI)=RTRI(2,ITRI)+(RTRI(5,ITRI)-RTRI(2,ITRI))*T
                RTRI(6,JTRI)=RTRI(3,ITRI)+(RTRI(6,ITRI)-RTRI(3,ITRI))*T
                RTRI(7,JTRI)=RTRI(4,ITRI)
                RTRI(8,JTRI)=RTRI(5,ITRI)
                RTRI(9,JTRI)=RTRI(6,ITRI)
                RTRI(10,JTRI)=RTRI(10,ITRI)
                RTRI(1,ITRI)=RTRI(1,JTRI)
                RTRI(2,ITRI)=RTRI(2,JTRI)
                RTRI(3,ITRI)=RTRI(3,JTRI)
                ITRI=JTRI
              END IF
C
            ELSE
C
C Point 1 out, point 2 in, point 3 out.
C
              T=-SIDE(RTRI(4,ITRI),RTRI(5,ITRI),RTRI(6,ITRI))/
     +           DNOM(RTRI(4,ITRI),RTRI(5,ITRI),RTRI(6,ITRI),
     +                RTRI(1,ITRI),RTRI(2,ITRI),RTRI(3,ITRI))
              RTRI(1,ITRI)=RTRI(4,ITRI)+(RTRI(1,ITRI)-RTRI(4,ITRI))*T
              RTRI(2,ITRI)=RTRI(5,ITRI)+(RTRI(2,ITRI)-RTRI(5,ITRI))*T
              RTRI(3,ITRI)=RTRI(6,ITRI)+(RTRI(3,ITRI)-RTRI(6,ITRI))*T
              T=-SIDE(RTRI(4,ITRI),RTRI(5,ITRI),RTRI(6,ITRI))/
     +           DNOM(RTRI(4,ITRI),RTRI(5,ITRI),RTRI(6,ITRI),
     +                RTRI(7,ITRI),RTRI(8,ITRI),RTRI(9,ITRI))
              RTRI(7,ITRI)=RTRI(4,ITRI)+(RTRI(7,ITRI)-RTRI(4,ITRI))*T
              RTRI(8,ITRI)=RTRI(5,ITRI)+(RTRI(8,ITRI)-RTRI(5,ITRI))*T
              RTRI(9,ITRI)=RTRI(6,ITRI)+(RTRI(9,ITRI)-RTRI(6,ITRI))*T
C
            END IF
C
          ELSE
C
            IF (SIDE(RTRI(7,ITRI),RTRI(8,ITRI),RTRI(9,ITRI)).LT.0.) THEN
C
C Point 1 out, point 2 out, point 3 in.
C
              T=-SIDE(RTRI(7,ITRI),RTRI(8,ITRI),RTRI(9,ITRI))/
     +           DNOM(RTRI(7,ITRI),RTRI(8,ITRI),RTRI(9,ITRI),
     +                RTRI(1,ITRI),RTRI(2,ITRI),RTRI(3,ITRI))
              RTRI(1,ITRI)=RTRI(7,ITRI)+(RTRI(1,ITRI)-RTRI(7,ITRI))*T
              RTRI(2,ITRI)=RTRI(8,ITRI)+(RTRI(2,ITRI)-RTRI(8,ITRI))*T
              RTRI(3,ITRI)=RTRI(9,ITRI)+(RTRI(3,ITRI)-RTRI(9,ITRI))*T
              T=-SIDE(RTRI(7,ITRI),RTRI(8,ITRI),RTRI(9,ITRI))/
     +           DNOM(RTRI(7,ITRI),RTRI(8,ITRI),RTRI(9,ITRI),
     +                RTRI(4,ITRI),RTRI(5,ITRI),RTRI(6,ITRI))
              RTRI(4,ITRI)=RTRI(7,ITRI)+(RTRI(4,ITRI)-RTRI(7,ITRI))*T
              RTRI(5,ITRI)=RTRI(8,ITRI)+(RTRI(5,ITRI)-RTRI(8,ITRI))*T
              RTRI(6,ITRI)=RTRI(9,ITRI)+(RTRI(6,ITRI)-RTRI(9,ITRI))*T
C
            ELSE
C
C Point 1 out, point 2 out, point 3 out.
C
              IF (ITRI.NE.NTRI) THEN
                RTRI(1,ITRI)=RTRI(1,NTRI)
                RTRI(2,ITRI)=RTRI(2,NTRI)
                RTRI(3,ITRI)=RTRI(3,NTRI)
                RTRI(4,ITRI)=RTRI(4,NTRI)
                RTRI(5,ITRI)=RTRI(5,NTRI)
                RTRI(6,ITRI)=RTRI(6,NTRI)
                RTRI(7,ITRI)=RTRI(7,NTRI)
                RTRI(8,ITRI)=RTRI(8,NTRI)
                RTRI(9,ITRI)=RTRI(9,NTRI)
                RTRI(10,ITRI)=RTRI(10,NTRI)
              END IF
C
              ITRI=ITRI-1
              NTRI=NTRI-1
C
            END IF
C
          END IF
C
        END IF
C
C Done.
C
        RETURN
C
      END

        PROGRAM CPEX03
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
        PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Declare an array to hold the data to be contoured.
C
        DIMENSION ZDAT(33,33)
C
C Declare the required real and integer workspaces.
C
        DIMENSION RWRK(5000),IWRK(1000)
C
C Declare an array to hold an area map.
C
        DIMENSION IAMA(20000)
C
C Declare the arrays needed by ARSCAM for x/y coordinates.
C
        DIMENSION XCRA(1000),YCRA(1000)
C
C Declare the arrays needed by ARSCAM for area and group identifiers.
C
        DIMENSION IARA(10),IGRA(10)
C
C Declare an array to hold the GKS "aspect source flags".
C
        DIMENSION IASF(13)
C
C Declare the routine which will draw contour lines, avoiding labels.
C
        EXTERNAL DRAWCL
C
C Declare the routine which does the shading.
C
        EXTERNAL SHADER
C
C Dimension a character variable to hold plot labels.
C
        CHARACTER*11 LABL
C
C Declare common blocks required for communication with CPMPXY.
C
        COMMON /CPMPC1/ XFOI(33),YFOJ(33)
        COMMON /CPMPC2/ XFIJ(33,33),YFIJ(33,33)
C
C Initialize the values in the aspect-source-flag array.
C
        DATA IASF / 13*1 /
C
C Open GKS.
C
        CALL GOPKS (IERRF, ISZDM)
        CALL GOPWK (IWKID, LUNIT, IWTYPE)
        CALL GACWK (IWKID)
C
C Turn off the clipping indicator.
C
        CALL GSCLIP (0)
C
C Set all the GKS aspect source flags to "individual".
C
        CALL GSASF (IASF)
C
C Turn on the positioning of labels by the penalty scheme and provide a
C little more room for X and Y coordinates defining contour lines, so
C as not to have labels right next to each other on a contour line.
C
        CALL CPSETI ('LLP - LINE LABEL POSITIONING',3)
        CALL CPSETI ('RWC - REAL WORKSPACE FOR CONTOURS',200)
C
C Turn on the drawing of the high and low label boxes.
C
        CALL CPSETI ('HLB - HIGH/LOW LABEL BOX FLAG',1)
C
C Tell CONPACK to delete high/low labels which overlap the informational
C label or another high/low label, but to move those which overlap the
C edge inward a little.
C
        CALL CPSETI ('HLO - HIGH/LOW LABEL OVERLAP FLAG',11)
C
C Make all CONPACK-written characters a little bigger.
C
        CALL CPSETR ('CWM - CHARACTER WIDTH MULTIPLIER',1.25)
C
C Turn on the drawing of the grid edge ("contour line number -1") and
C thicken it somewhat.
C
        CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',-1)
        CALL CPSETI ('CLU - CONTOUR LEVEL USE FLAG',1)
        CALL CPSETR ('CLL - CONTOUR LEVEL LINE WIDTH',2.)
C
C Tell CONPACK to do no SET call.
C
        CALL CPSETI ('SET - DO-SET-CALL FLAG',0)
C
C Turn on the special-value feature and the outlining of special-value
C areas ("contour line number -2"), using a double-width line.
C
        CALL CPSETR ('SPV - SPECIAL VALUE',1.E36)
        CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',-2)
        CALL CPSETI ('CLU - CONTOUR LEVEL USE FLAG',1)
        CALL CPSETR ('CLL - CONTOUR LEVEL LINE WIDTH',2.)
C
C Generate an array of test data.
C
        CALL GENDAT (ZDAT,33,33,33,20,20,-1.,1.)
C
C Put special values in a roughly circular area.
C
        DO 102 I=1,33
          DO 101 J=1,33
            IF (REAL(I-20)**2+REAL(J-10)**2.LT.25) ZDAT(I,J)=1.E36
  101     CONTINUE
  102   CONTINUE
C
C Do four different plots, one in each quadrant.
C
        DO 108 IPLT=1,4
C
C Compute viewport parameters.
C
          XVPL=.0250+.5000*REAL(MOD(IPLT-1,2))
          XVPR=.4750+.5000*REAL(MOD(IPLT-1,2))
          YVPB=.0250+.5000*REAL((4-IPLT)/2)
          YVPT=.4750+.5000*REAL((4-IPLT)/2)
C
C For each of the four plots, use a different mapping function and
C create a different background.
C
          CALL CPSETI ('MAP - MAPPING FUNCTION',IPLT)
C
C EZMAP.
C
          IF (IPLT.EQ.1) THEN
            CALL MAPSTI ('GR - GRID INTERVAL',30)
            CALL MAPSTC ('OU - OUTLINE DATASET','CO')
            CALL MAPSTI ('DO - DOTTING OF OUTLINES',1)
            CALL MAPPOS (XVPL,XVPR,YVPB,YVPT)
            CALL MAPROJ ('OR - ORTHOGRAPHIC',40.,-95.,0.)
            CALL MAPSET ('MA - MAXIMAL AREA',0.,0.,0.,0.)
            CALL MAPDRW
            CALL CPSETR ('XC1 - LONGITUDE AT I = 1',-160.)
            CALL CPSETR ('XCM - LONGITUDE AT I = M',-30.)
            CALL CPSETR ('YC1 - LATITUDE AT J = 1',-10.)
            CALL CPSETR ('YCN - LATITUDE AT J = N',70.)
C
C Polar coordinates.
C
          ELSE IF (IPLT.EQ.2) THEN
            CALL CPSETR ('XC1 - RHO AT I = 1',.1)
            CALL CPSETR ('XCM - RHO AT I = M',1.)
            CALL CPSETR ('YC1 - THETA AT J = 1',0.)
            CALL CPSETR ('YCN - THETA AT J = N',90.)
            CALL SET    (XVPL,XVPR,YVPB,YVPT,0.,1.,0.,1.,1)
C
C Rectangular, irregularly-spaced.
C
          ELSE IF (IPLT.EQ.3) THEN
            CALL CPSETR ('XC1 - X COORDINATE AT I = 1',1.)
            CALL CPSETR ('XCM - X COORDINATE AT I = M',33.)
            CALL CPSETR ('YC1 - Y COORDINATE AT J = 1',1.)
            CALL CPSETR ('YCN - Y COORDINATE AT J = N',33.)
            CALL SET    (XVPL,XVPR,YVPB,YVPT,0.,1.,0.,1.,1)
            DO 103 I=1,33
              XFOI(I)=ALOG10(1.+9.*REAL(I-1)/32.)
  103       CONTINUE
            DO 104 J=1,33
              YFOJ(J)=ALOG10(1.+9.*REAL(J-1)/32.)
  104       CONTINUE
C
C Parameterized distortion.
C
          ELSE IF (IPLT.EQ.4) THEN
            CALL CPSETR ('XC1 - X COORDINATE AT I = 1',1.)
            CALL CPSETR ('XCM - X COORDINATE AT I = M',33.)
            CALL CPSETR ('YC1 - Y COORDINATE AT J = 1',1.)
            CALL CPSETR ('YCN - Y COORDINATE AT J = N',33.)
            CALL SET    (XVPL,XVPR,YVPB,YVPT,0.,1.,0.,1.,1)
            DO 106 I=1,33
              DO 105 J=1,33
                XFIJ(I,J)=REAL(I-1)/32.+(REAL(17-I)/64.)*
     +                                          (REAL(16-ABS(J-17))/16.)
                YFIJ(I,J)=REAL(J-1)/32.+(REAL(17-J)/64.)*
     +                                          (REAL(16-ABS(I-17))/16.)
  105         CONTINUE
  106       CONTINUE
C
          END IF
C
C Initialize the drawing of the contour plot.
C
          CALL CPRECT (ZDAT,33,33,33,RWRK,5000,IWRK,1000)
C
C Force the selection of contour levels, so that associated quantities
C may be tweaked.
C
          CALL CPPKCL (ZDAT,RWRK,IWRK)
C
C Increase the line width for labelled levels and turn off the area
C identifiers for all levels.
C
          CALL CPGETI ('NCL - NUMBER OF CONTOUR LEVELS',NCLV)
C
          DO 107 ICLV=1,NCLV
            CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',ICLV)
            CALL CPGETI ('CLU - CONTOUR LEVEL USE FLAG',ICLU)
            IF (ICLU.EQ.3) THEN
              CALL CPSETI ('CLL - CONTOUR-LINE LINE WIDTH',2)
            END IF
            CALL CPSETI ('AIA - AREA IDENTIFIER ABOVE LEVEL',0)
            CALL CPSETI ('AIB - AREA IDENTIFIER BELOW LEVEL',0)
  107     CONTINUE
C
C Add two new levels for which no contour lines are to be drawn, but
C between which shading is to be done.
C
          NCLV=NCLV+2
          CALL CPSETI ('NCL - NUMBER OF CONTOUR LEVELS',NCLV)
C
          CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',NCLV-1)
          CALL CPSETR ('CLV - CONTOUR LEVEL VALUE',-.15)
          CALL CPSETI ('CLU - CONTOUR LEVEL USE FLAG',0)
          CALL CPSETI ('AIA - AREA IDENTIFIER ABOVE LEVEL',1)
          CALL CPSETI ('AIB - AREA IDENTIFIER BELOW LEVEL',2)
          CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',NCLV)
          CALL CPSETR ('CLV - CONTOUR LEVEL VALUE',+.15)
          CALL CPSETI ('CLU - CONTOUR LEVEL USE FLAG',0)
          CALL CPSETI ('AIA - AREA IDENTIFIER ABOVE LEVEL',3)
          CALL CPSETI ('AIB - AREA IDENTIFIER BELOW LEVEL',1)
C
C Draw the contour plot.
C
          CALL ARINAM (IAMA,20000)
          CALL CPLBAM (ZDAT,RWRK,IWRK,IAMA)
          CALL CPCLDM (ZDAT,RWRK,IWRK,IAMA,DRAWCL)
          CALL CPLBDR (ZDAT,RWRK,IWRK)
          CALL CPCLAM (ZDAT,RWRK,IWRK,IAMA)
          CALL ARSCAM (IAMA,XCRA,YCRA,1000,IARA,IGRA,10,SHADER)
C
C Compute and print statistics for the plot and label it.
C
          LABL='EXAMPLE 3-'//CHAR(ICHAR('0')+IPLT)
          CALL CAPSAP (LABL,IAMA,20000)
          CALL LABTOP (LABL,.017)
C
  108   CONTINUE
C
C Put a boundary line at the edge of the plotter frame.
C
        CALL BNDARY
C
C Advance the frame.
C
        CALL FRAME
C
C Close GKS.
C
        CALL GDAWK (IWKID)
        CALL GCLWK (IWKID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END


      SUBROUTINE CPMPXY (IMAP,XINP,YINP,XOTP,YOTP)
C
C This version of CPMPXY implements four different mappings:
C
C   IMAP = 1 implies an EZMAP mapping.  XINP and YINP are assumed to be
C   the longitude and latitude, in degrees, of a point on the globe.
C
C   IMAP = 2 implies a polar coordinate mapping.  XINP and YINP are
C   assumed to be values of rho and theta (in degrees).
C
C   IMAP = 3 implies an orthogonal, but unequally-spaced mapping.  XINP
C   is assumed to lie in the range from 1 to M, YINP in the range from
C   1 to N, where M and N are the dimensions of the grid.  The common
C   block CPMPC1 contains arrays XFOI and YFOJ giving the X coordinates
C   associated with I = 1 to M and the Y coordinates associated with
C   J = 1 to N.
C
C   IMAP = 4 implies a generalized distortion.  XINP is assumed to lie
C   in the range from 1 to M, YINP in the range from 1 to N, where M
C   and N are the dimensions of the grid.  The common block CPMPC2
C   contains arrays XFIJ and YFIJ, giving the X and Y coordinates
C   associated with index pairs (I,J).
C
C Declare common blocks.
C
        COMMON /CPMPC1/ XFOI(33),YFOJ(33)
        COMMON /CPMPC2/ XFIJ(33,33),YFIJ(33,33)
C
C Do the mapping.
C
        IF (IMAP.EQ.1) THEN
          CALL MAPTRN (YINP,XINP,XOTP,YOTP)
        ELSE IF (IMAP.EQ.2) THEN
          XOTP=XINP*COS(.017453292519943*YINP)
          YOTP=XINP*SIN(.017453292519943*YINP)
        ELSE IF (IMAP.EQ.3) THEN
          I=MAX(1,MIN(32,INT(XINP)))
          J=MAX(1,MIN(32,INT(YINP)))
          XOTP=(REAL(I+1)-XINP)*XFOI(I)+(XINP-REAL(I))*XFOI(I+1)
          YOTP=(REAL(J+1)-YINP)*YFOJ(J)+(YINP-REAL(J))*YFOJ(J+1)
        ELSE IF (IMAP.EQ.4) THEN
          I=MAX(1,MIN(32,INT(XINP)))
          J=MAX(1,MIN(32,INT(YINP)))
          XOTP=(REAL(J+1)-YINP)*
     +    ((REAL(I+1)-XINP)*XFIJ(I,J  )+(XINP-REAL(I))*XFIJ(I+1,J  ))
     +    +(YINP-REAL(J))*
     +    ((REAL(I+1)-XINP)*XFIJ(I,J+1)+(XINP-REAL(I))*XFIJ(I+1,J+1))
          YOTP=(REAL(J+1)-YINP)*
     +    ((REAL(I+1)-XINP)*YFIJ(I,J  )+(XINP-REAL(I))*YFIJ(I+1,J  ))
     +    +(YINP-REAL(J))*
     +    ((REAL(I+1)-XINP)*YFIJ(I,J+1)+(XINP-REAL(I))*YFIJ(I+1,J+1))
        ELSE
          XOTP=XINP
          YOTP=YINP
        END IF
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE DRAWCL (XCS,YCS,NCS,IAI,IAG,NAI)
C
C This version of DRAWCL draws the polyline defined by the points
C ((XCS(I),YCS(I)),I=1,NCS) if and only if none of the area identifiers
C for the area containing the polyline are negative.  The dash package
C routine CURVED is called to do the drawing.
C
        DIMENSION XCS(*),YCS(*),IAI(*),IAG(*)
C
C Turn on drawing.
C
        IDR=1
C
C If any area identifier is negative, turn off drawing.
C
        DO 101 I=1,NAI
          IF (IAI(I).LT.0) IDR=0
  101   CONTINUE
C
C If drawing is turned on, draw the polyline.
C
        IF (IDR.NE.0) CALL CURVED (XCS,YCS,NCS)
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE SHADER (XCS,YCS,NCS,IAI,IAG,NAI)
C
C This version of SHADER shades the polygon whose edge is defined by
C the points ((XCS(I),YCS(I)),I=1,NCS) if and only, relative to edge
C group 3, its area identifier is a 1.  The package SOFTFILL is used
C to do the shading.
C
        DIMENSION XCS(*),YCS(*),IAI(*),IAG(*)
C
C Define workspaces for the shading routine.
C
        DIMENSION DST(1100),IND(1200)
C
C Turn off shading.
C
        ISH=0
C
C If the area identifier for group 3 is a 1, turn on shading.
C
        DO 101 I=1,NAI
          IF (IAG(I).EQ.3.AND.IAI(I).EQ.1) ISH=1
  101   CONTINUE
C
C If shading is turned on, shade the area.  The last point of the
C edge is redundant and may be omitted.
C
        IF (ISH.NE.0) THEN
          CALL SFSETI ('ANGLE',45)
          CALL SFSETR ('SPACING',.006)
          CALL SFWRLD (XCS,YCS,NCS-1,DST,1100,IND,1200)
          CALL SFSETI ('ANGLE',135)
          CALL SFNORM (XCS,YCS,NCS-1,DST,1100,IND,1200)
        END IF
C
C Done.
C
        RETURN
C
      END

C
C	$Id: gqcr.f,v 1.5 2008-07-27 00:20:59 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GQCR(WKID,COLI,TYPE,ERRIND,RED,GREEN,BLUE)
C
C  INQUIRE COLOUR REPRESENTATION
C
      include 'gkscom.h'
C
      INTEGER WKID,COLI,TYPE,ERRIND
      REAL    RED,GREEN,BLUE
C
C  Check if GKS is in the proper state.
C
      CALL GZCKST(7,-1,ERRIND)
      IF (ERRIND .NE. 0) GOTO 100
C
C  Check on workstation ID.
C
      CALL GZCKWK(20,-1,WKID,IDUM,ERRIND)
      IF (ERRIND .GT. 0) GOTO 100
C
C  Check if the specified workstation is open.
C
      CALL GZCKWK(25,-1,WKID,IDUM,ERRIND)
      IF (ERRIND .GT. 0) GOTO 100
C
C  Check on the range of the TYPE parameter.
C
      IF (TYPE.LT.0 .OR. TYPE.GT.1) THEN
        ERRIND = 2000
        GO TO 100
      ENDIF
C
C  Check for invalid workstation categories.
C
      CALL GQWKC(WKID,ERRIND,ICONID,ITYPE)
      IF (ERRIND .NE. 0) GO TO 100
      CALL GQWKCA(ITYPE,ERRIND,ICAT)
      IF (ERRIND .NE. 0) GO TO 100
      IF (ICAT .EQ. GMI) THEN
        ERRIND = 33
        GO TO 100
      ELSE IF (ICAT .EQ. GINPUT) THEN
        ERRIND = 35
        GO TO 100
      ELSE IF (ICAT .EQ. GWISS) THEN
        ERRIND = 36
        GO TO 100
      ENDIF
C
C  Check on color index.
C
      IF (COLI.LT.0) THEN
        ERRIND = 93
        GO TO 100
      ENDIF
C
C  Invoke the workstation interface routine.
C
      FCODE = -256
      CONT  = 0
      CALL GZROI(0)
      IL1   = 3
      IL2   = 3
      ID(1) = WKID
      ID(2) = COLI
      ID(3) = TYPE
      CALL GZIQWK(ITYPE,WKID)
      IF (RERR.NE.0) THEN
        ERRIND = RERR
        GOTO 100
      ENDIF
      RED   = RX(1)
      GREEN = RX(2)
      BLUE  = RX(3)
      RETURN
C
  100 CONTINUE
      RED   = -1.
      GREEN = -1.
      BLUE  = -1.
C
      RETURN
      END

C
C      $Id: cn08f.f,v 1.8 2010-03-15 22:49:23 haley Exp $
C
C***********************************************************************
C                                                                      *
C                Copyright (C)  1995                                   *
C        University Corporation for Atmospheric Research               *
C     The use of this Software is governed by a License Agreement      *
C                                                                      *
C***********************************************************************
C
C  File:       cn08f.f
C
C  Author:     Ethan Alpert (converted to Fortran by Mary Haley)
C          National Center for Atmospheric Research
C          PO 3000, Boulder, Colorado
C
C  Date:       Thu Sep 28 11:51:33 MDT 1995
C
C  Description:    Draws a vertical profile of temperature for
C                  longitudes separated by 5 degrees.
C
      external NhlFAppClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFCairoWindowWorkstationClass
      external NhlFScalarFieldClass
      external NhlFContourPlotClass
      parameter(NCOLORS=23)
C
C Declare variables for the HLU routine calls.
C
      integer appid, workid, field1, con1
      integer srlist, i, j, k
      real   cmap(3,NCOLORS)
C
C Declare variables for getting information from netCDF file.
C
      integer  ncid, lon_id, lat_id, level_id, temp_id
      real temp(33,10), spv
      real lon(36), lat(33), level(10)
      real min_lat, min_level, max_lat, max_level
      integer start(4), count(4), lonlen, latlen, levellen
      character*256 filename
      character*50 string
      character*50 recname
      character*7  wks_type
C
C Default is to create an NCGM file.
C
      wks_type = "ncgm"

C
C Initialize the HLU library and set up resource template.
C
      call NhlFInitialize
      call NhlFRLCreate(srlist,'setrl')
      call NhlFRLClear(srlist)
      call NhlFRLSetString(srlist,'appDefaultParent','True',ierr)
      call NhlFRLSetString(srlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'cn08',NhlFAppClass,0,srlist,ierr)

      cmap(1,1) = 0.0
      cmap(2,1) = 0.0
      cmap(3,1) = 0.0
      cmap(1,2) = 1.0
      cmap(2,2) = 1.0
      cmap(3,2) = 1.0
      cmap(1,3) = 1.0
      cmap(2,3) = 1.0
      cmap(3,3) = 1.0
      cmap(1,4) = 1.0
      cmap(2,4) = 0.0
      cmap(3,4) = 0.0
      cmap(1,5) = 0.0
      cmap(2,5) = 1.0
      cmap(3,5) = 0.0
      cmap(1,6) = 0.0
      cmap(2,6) = 0.0
      cmap(3,6) = 1.0
      cmap(1,7) = 1.0
      cmap(2,7) = 1.0
      cmap(3,7) = 0.0
      cmap(1,8) = 0.0
      cmap(2,8) = 1.0
      cmap(3,8) = 1.0
      cmap(1,9) = 1.0
      cmap(2,9) = 0.0
      cmap(3,9) = 1.0
      cmap(1,10) = 0.5
      cmap(2,10) = 0.0
      cmap(3,10) = 0.0
      cmap(1,11) = 0.5
      cmap(2,11) = 1.0
      cmap(3,11) = 1.0
      cmap(1,12) = 0.0
      cmap(2,12) = 0.0
      cmap(3,12) = 0.5
      cmap(1,13) = 1.0
      cmap(2,13) = 1.0
      cmap(3,13) = 0.5
      cmap(1,14) = 0.5
      cmap(2,14) = 0.0
      cmap(3,14) = 1.0
      cmap(1,15) = 1.0
      cmap(2,15) = 0.5
      cmap(3,15) = 0.0
      cmap(1,16) = 0.0
      cmap(2,16) = 0.5
      cmap(3,16) = 1.0
      cmap(1,17) = 0.5
      cmap(2,17) = 1.0
      cmap(3,17) = 0.0
      cmap(1,18) = 0.5
      cmap(2,18) = 0.0
      cmap(3,18) = 0.5
      cmap(1,19) = 0.5
      cmap(2,19) = 1.0
      cmap(3,19) = 0.5
      cmap(1,20) = 1.0
      cmap(2,20) = 0.5
      cmap(3,20) = 1.0
      cmap(1,21) = 0.0
      cmap(2,21) = 0.5
      cmap(3,21) = 0.0
      cmap(1,22) = 0.5
      cmap(2,22) = 0.5
      cmap(3,22) = 1.0
      cmap(1,23) = 1.0
      cmap(2,23) = 0.0
      cmap(3,23) = 0.5

      count(1) = 3
      count(2) = NCOLORS
      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetMDFloatArray(srlist,'wkColorMap',cmap,2,count,
     +        ierr)
         call NhlFRLSetString(srlist,'wkMetaName','./cn08f.ncgm',ierr)
         call NhlFCreate(workid,'cn08Work',
     +        NhlFNcgmWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X11 workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetMDFloatArray(srlist,'wkColorMap',cmap,2,count,
     +        ierr)
         call NhlFRLSetString(srlist,'wkPause','True',ierr)
         call NhlFCreate(workid,'cn08Work',
     +        NhlFCairoWindowWorkstationClass,
     +        0,srlist,ierr)
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PostScript workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetMDFloatArray(srlist,'wkColorMap',cmap,2,count,
     +        ierr)
         call NhlFRLSetString(srlist,'wkPSFileName','./cn08f.ps',ierr)
         call NhlFCreate(workid,'cn08Work',
     +        NhlFPSWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetMDFloatArray(srlist,'wkColorMap',cmap,2,count,
     +        ierr)
         call NhlFRLSetString(srlist,'wkPDFFileName','./cn08f.pdf',ierr)
         call NhlFCreate(workid,'cn08Work',
     +        NhlFPDFWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetMDFloatArray(srlist,'wkColorMap',cmap,2,count,
     +        ierr)
         call NhlFRLSetString(srlist,'wkFileName','./cn08f',ierr)
         call NhlFRLSetString(srlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(workid,'cn08Work',
     +        NhlFCairoPSPDFWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetMDFloatArray(srlist,'wkColorMap',cmap,2,count,
     +        ierr)
         call NhlFRLSetString(srlist,'wkFileName','./cn08f',ierr)
         call NhlFRLSetString(srlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(workid,'cn08Work',
     +        NhlFCairoImageWorkstationClass,0,srlist,ierr)
      endif
C
C  Open data file containing grid of global temperatures.
C
      call gngpat(filename,'data',ierr)
      do 10 i=1,256
         if( filename(i:i).eq.char(0) ) then
            filename(i:i+15)='/cdf/contour.cdf'
            goto 15
         endif
 10   continue
C      
C The second argument to 'ncopn' should be NCNOWRIT, but since we
C can't include 'netcdf.inc', we are using the value '0' instead.
C
 15   ncid = ncopn(filename,0,ierr)
C
C Get the lat/lon/level dimensions.
C
      lat_id = ncdid(ncid,'lat',ierr)
      lon_id = ncdid(ncid,'lon',ierr)
      level_id = ncdid(ncid,'level',ierr)
      call ncdinq(ncid,lat_id,recname,latlen,ierr)
      call ncdinq(ncid,lon_id,recname,lonlen,ierr)
      call ncdinq(ncid,level_id,recname,levellen,ierr)
C
C Read in temperature values and convert from degrees F to degrees K.
C
      temp_id = ncvid(ncid,'T',ierr)
      start(1) = 1
      start(2) = 1
      start(3) = 1
      start(4) = 1
      count(1) = 1
      count(2) = latlen
      count(3) = levellen
      count(4) = 1
      call ncvgt(ncid,temp_id,start,count,temp,ierr)
      call ncagt(ncid,temp_id,'_FillValue',spv,ierr)
      do 30 j = 1,levellen
         do 20 k=1,latlen
            temp(k,j) = (temp(k,j) - 273.15) * 9./5. + 32.
 20      continue
 30   continue
C
C Read in lat/lon/level values.
C
      lat_id = ncvid(ncid,'lat',ierr)
      count(1) = latlen
      call ncvgt(ncid,lat_id,start,count,lat,ierr)

      lon_id = ncvid(ncid,'lon',ierr)
      count(1) = lonlen
      call ncvgt(ncid,lon_id,start,count,lon,ierr)

      level_id = ncvid(ncid,'level',ierr)
      count(1) = levellen
      call ncvgt(ncid,level_id,start,count,level,ierr)
C
C Set up initial scalar field with longitude of temperature data.
C
      count(1) = latlen
      count(2) = levellen
      call NhlFRLClear(srlist)
      call NhlFRLSetMDFloatArray(srlist,'sfDataArray',temp,2,count,
     +     ierr)
      call NhlFRLSetFloat(srlist,'sfMissingValueV',spv,ierr)
      call NhlFRLSetFloat(srlist,'sfXCStartV',lat(1),ierr)
      call NhlFRLSetFloat(srlist,'sfXCEndV',lat(latlen),ierr)
      call NhlFRLSetFloatArray(srlist,'sfXArray',lat,latlen,ierr)
      call NhlFRLSetFloatArray(srlist,'sfYArray',level,levellen,ierr)
      call NhlFCreate(field1,'field1',NhlFscalarFieldClass,appid,srlist,
     +     ierr)
C
C Determine extents of grid
C
      if (lat(1) .lt. lat(latlen)) then
         min_lat = lat(1)
         max_lat = lat(latlen)
      else
         max_lat = lat(1)
         min_lat = lat(latlen)
      endif
      if(level(1) .lt. level(levellen)) then
         min_level = level(1)
         max_level = level(levellen)
      else
         max_level = level(1)
         min_level = level(levellen)
      endif
C
C Create contour using manual spacing.
C
      call NhlFRLClear(srlist)
      call NhlFRLSetFloat(srlist,'vpXF',.2,ierr)
      call NhlFRLSetFloat(srlist,'vpYF',.8,ierr)
      call NhlFRLSetFloat(srlist,'vpWidthF',.6,ierr)
      call NhlFRLSetFloat(srlist,'vpHeightF',.6,ierr)
      call NhlFRLSetString(srlist,'cnFillOn','True',ierr)
      call NhlFRLSetInteger(srlist,'cnScalarFieldData',field1,ierr)
      call NhlFRLSetString(srlist,'cnLevelSelectionMode','ManualLevels',
     +     ierr)
      call NhlFRLSetInteger(srlist,'cnMaxLevelCount',25,ierr)
      call NhlFRLSetFloat(srlist,'cnMinLevelValF',-80.0,ierr)
      call NhlFRLSetFloat(srlist,'cnMaxLevelValF',110.0,ierr)
      call NhlFRLSetFloat(srlist,'cnLevelSpacingF',10.0,ierr)
      call NhlFRLSetFloat(srlist,'trXMinF',min_lat,ierr)
      call NhlFRLSetFloat(srlist,'trXMaxF',max_lat,ierr)
      call NhlFRLSetFloat(srlist,'trYMinF',min_level,ierr)
      call NhlFRLSetFloat(srlist,'trYMaxF',max_level,ierr)
      call NhlFRLSetString(srlist,'trYReverse','True',ierr)
      write(string,55)lon(1)
 55   format('Longitude ',f6.1,' Degrees')
      call NhlFRLSetString(srlist,'tiMainString',string,ierr)
      call NhlFCreate(con1,'con1',NhlFcontourPlotClass,workid,srlist,
     +     ierr)
C
C Draw first step
C
      call NhlFDraw(con1,ierr)
      call NhlFFrame(workid,ierr)
C
C Loop on remaining longitude values and reset the title every iteration.
C
      do 60 i = 2,lonlen
C
C Read in temperature values and convert from degrees F to degrees K.
C
         temp_id = ncvid(ncid,'T',ierr)
         start(1) = i
         start(2) = 1
         start(3) = 1
         start(4) = 1
         count(1) = 1
         count(2) = latlen
         count(3) = levellen
         count(4) = 1
         call ncvgt(ncid,temp_id,start,count,temp,ierr)
         do 70 j = 1,levellen
            do 65 k=1,latlen
               temp(k,j) = (temp(k,j) - 273.15) * 9./5. + 32.
 65         continue
 70      continue
         call NhlFRLClear(srlist)
         count(1) = latlen
         count(2) = levellen
         call NhlFRLSetMDFloatArray(srlist,'sfDataArray',temp,2,count,
     +        ierr)
C
C Create new scalar field.
C
         call NhlFSetValues(field1,srlist,ierr)
         call NhlFRLClear(srlist)
         write(string,75)lon(i)
 75      format('Longitude ',f6.1,' Degrees')
         call NhlFRLSetString(srlist,'tiMainString',string,ierr)
         call NhlFSetValues(con1,srlist,ierr)
         call NhlFDraw(con1,ierr)
         call NhlFFrame(workid,ierr)
 60   continue
C
C Close the netCDF file.
C
      call ncclos(ncid,ierr)
C
C NhlFDestroy destroys the given id and all of its children.
C
      call NhlFRLDestroy(srlist)
      call NhlFDestroy(appid,ierr)
C
C Restores state.
C
      call NhlFClose
      stop
      end

      PROGRAM MIEX01
C
C  Demonstrate the usage of the logo subroutines NGLOGO and NGEZLOGO.
C
C  Define the error file, the Fortran unit number, the workstation type,
C  and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C  Open GKS, open workstation, activate workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C  Set up a color table.
C
      CALL GSCR(IWKID,0,1.,1.,1.)
      CALL GSCR(IWKID,1,0.,0.,0.)
      CALL GSCR(IWKID,2,0.,0.,1.)
      CALL GSCR(IWKID,3,1.,0.,0.)
C
C  Main title.
C
      CALL PLCHHQ(0.5,0.90,":F26:Logos",0.05,0.,0.)
C
C  Change the Plotchar function code control character from
C  its default value of a colon, since we want to produce a colon
C  in calls to PLCHHQ.
C
      CALL PCSETC('FC','#')
C
C  Use Helvetica for the label font.
C
      CALL PCSETC('FN','HELVETICA')
C
C  Put out examples of the five logo types.
C
C   Type 1 - an NCAR logo that will be full-color for
C            PostScript output and single color otherwise.
C
      PSIZE = 0.04
      PXPOS = 0.23
      XLPOS = 0.67
      YLPOS = 0.75
      SIZEL = 0.10
      YINC  = 0.14
      CALL PLCHHQ(PXPOS, YLPOS, "Type 1:", PSIZE, 0.,-1.)
      CALL NGLOGO(IWKID, XLPOS, YLPOS, SIZEL, 1, 1, 1)
C
C   Type 2 - the UCAR star logo in red.
C
      YLPOS = YLPOS-YINC
      CALL PLCHHQ(PXPOS, YLPOS, "Type 2:", PSIZE, 0.,-1.)
      CALL NGLOGO(IWKID, XLPOS, YLPOS, SIZEL, 2, 3, 1)
C
C   Type 3 - the text string "NCAR" in Bell Gothic font.
C
      YLPOS = YLPOS-YINC
      CALL PLCHHQ(PXPOS, YLPOS, "Type 3:", PSIZE, 0.,-1.)
      CALL NGLOGO(IWKID, XLPOS, YLPOS, 0.6*SIZEL, 3, 1, 1)
C
C   Type 4 - the text string "UCAR" in Bell Gothic font.
C
      YLPOS = YLPOS-YINC
      CALL PLCHHQ(PXPOS, YLPOS, "Type 4:", PSIZE, 0.,-1.)
      CALL NGLOGO(IWKID, XLPOS, YLPOS, 0.6*SIZEL, 4, 1, 1)
C
C   Type 5 - the UCAR star logo in blue with the text "UCAR" in red.
C
      YLPOS = YLPOS-YINC
      CALL PLCHHQ(PXPOS, YLPOS, "Type 5:", PSIZE, 0.,-1.)
      CALL NGLOGO(IWKID, XLPOS-0.1, YLPOS, SIZEL, 5, 2, 3)
C
C  Put an NCAR logo at the lower right using NGEZLOGO.
C
      CALL NGEZLOGO()
C
      CALL FRAME
C
      CALL GDAWK(IWKID)
      CALL GCLWK(IWKID)
      CALL GCLKS
C
      STOP
      END

C
C     $Id: cn01f.f,v 1.12 2010-03-15 22:49:23 haley Exp $
C
C***********************************************************************
C                                                                      *
C                            Copyright (C)  1995                       *
C                 University Corporation for Atmospheric Research      *
C                            All Rights Reserved                       *
C                                                                      *
C***********************************************************************
C
C      File:            cn01f.f
C
C      Author:          Dave Brown (converted to Fortran by Mary Haley)
C                       National Center for Atmospheric Research
C                       PO 3000, Boulder, Colorado
C
C      Date:            Tue Jan 24 09:34:23 MST 1995
C
C      Description:     Given a simple mathematically generated data 
C                       set, demonstrates ContourPlot with all resources 
C                       (other thancnScalarFieldData) set to their 
C                       default value.
C
C
C Extern declarations for Types of objects that will be used
C
      external NhlFAppClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFCairoWindowWorkstationClass
      external nhlfscalarfieldclass
      external nhlfcontourplotclass

      parameter(M=25,N=25)
      parameter(PI=3.14159)

      real  t(625)
      integer len_dims(2)
      integer appid,wid,dataid,cnid
      integer srlist
      real  x,y
      integer i,j
      character*7  wks_type
C
C Default is to display output to an X workstation
C
      wks_type = "x11"
C
C Create a simple bull's eye pattern test data set
C     
      ii = 1
      do 20 i = -N/2,N/2
         do 10 j = -M/2,M/2
            x = 8.0 * i
            y = 8.0 * j
            t(ii) = 100.0 - sqrt(x*x + y*y)
            ii = ii + 1
 10      continue
 20   continue
C
C Initialize the high level utility library
C
      call NhlFInitialize
C
C Create an application context. Set the app dir to the current dir
C so the application looks for a resource file in the working directory.
C In this example the resource file supplies the plot title only.
C
      call NhlFRLCreate(srlist,'SETRL')
      call NhlFRLClear(srlist)
      call NhlFRLSetstring(srlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'cn01',NhlFAppClass,0,srlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetstring(srlist,'wkMetaName','./cn01f.ncgm',ierr)
         call NhlFCreate(wid,'cn01Work',NhlFNcgmWorkstationClass,
     1     0,srlist,ierr)
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetstring(srlist,'wkPause','True',ierr)
         call NhlFCreate(wid,'cn01Work',
     +        NhlFCairoWindowWorkstationClass,
     1        0,srlist,ierr) 
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PostScript workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetstring(srlist,'wkPSFileName','./cn01f.ps',ierr)
         call NhlFCreate(wid,'cn01Work',NhlFPSWorkstationClass,
     1     0,srlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetstring(srlist,'wkPDFFileName','./cn01f.pdf',ierr)
         call NhlFCreate(wid,'cn01Work',NhlFPDFWorkstationClass,
     1     0,srlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF object.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetstring(srlist,'wkFileName','./cn01f',ierr)
         call NhlFRLSetstring(srlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(wid,'cn01Work',NhlFCairoPSPDFWorkstationClass,
     1     0,srlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG object.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetstring(srlist,'wkFileName','./cn01f',ierr)
         call NhlFRLSetstring(srlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(wid,'cn01Work',NhlFCairoImageWorkstationClass,
     1     0,srlist,ierr)
      endif
C
C Create a ScalarField data object using the data set defined above.
C By default the array bounds will define the data boundaries
C (zero-based, as in C language conventions)
C
      call NhlFRLClear(srlist)
      len_dims(1) = N
      len_dims(2) = M
      call NhlFRLSetmdfloatarray(srlist,'sfDataArray',t,2,len_dims,ierr)
      call NhlFCreate(dataid,'bullseye',nhlfscalarfieldclass,
     1      appid, srlist,ierr)
C
C Create a ContourPlot object, supplying the ScalarField object as data
C
      call NhlFRLClear(srlist)
      call NhlFRLSetinteger(srlist,'cnScalarFieldData',dataid,ierr)
      call NhlFCreate(cnid,'ContourPlot1',nhlfcontourplotclass,
     1      wid,srlist,ierr)
C
C Draw a plot illustrating the basic default behavior of
C the ContourPlot object. The contours appear as solid lines with 
C unboxed labels in a linear coordinate system with the origin at 
C the lower left. Tickmarks with labels show the data coordinate 
C range, and an informational label at the lower right gives the 
C minimum and maximum data values and the contour interval spacing.
C
      call NhlFDraw(cnid,ierr)
      call NhlFFrame(wid,ierr)
C
C Destroy the objects created, close the HLU library and exit.
C
      call NhlFDestroy(dataid,ierr)
      call NhlFDestroy(cnid,ierr)
      call NhlFDestroy(wid,ierr)
      call NhlFDestroy(appid,ierr)

      call NhlFClose
      stop
      end

C
C $Id: gagetr.f,v 1.7 2008-07-27 00:17:13 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GAGETR (PNAM,RVAL)
C
      CHARACTER*(*) PNAM
C
C The subroutine GAGETR may be used to get GRIDAL parameters which have
C values of type REAL.
C
C Declare the common block containing real and integer parameters.
C
        COMMON /GAREIN/ ICAX,ICLB,ICMJ,ICMN,ILTY,IORX,NCFX,NCFY,RCWX,
     +                  RCWY,RDCX,RDCY,RMJX,RMJY,RMNX,RMNY,RWAX,RWLB,
     +                  RWMJ,RWMN
        SAVE   /GAREIN/
C
C Do a call forcing a BLOCKDATA to be loaded from a binary library.
C
        CALL GABLDT
C
C Check for an uncleared prior error.
C
        IF (ICFELL('GAGETR - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C Get the selected parameter.
C
        IF      (PNAM(1:3).EQ.'CAX'.OR.PNAM(1:3).EQ.'cax') THEN
          RVAL=REAL(ICAX)
        ELSE IF (PNAM(1:3).EQ.'CLB'.OR.PNAM(1:3).EQ.'clb') THEN
          RVAL=REAL(ICLB)
        ELSE IF (PNAM(1:3).EQ.'CMJ'.OR.PNAM(1:3).EQ.'cmj') THEN
          RVAL=REAL(ICMJ)
        ELSE IF (PNAM(1:3).EQ.'CMN'.OR.PNAM(1:3).EQ.'cmn') THEN
          RVAL=REAL(ICMN)
        ELSE IF (PNAM(1:3).EQ.'LTY'.OR.PNAM(1:3).EQ.'lty') THEN
          RVAL=REAL(ILTY)
        ELSE IF (PNAM(1:3).EQ.'WAX'.OR.PNAM(1:3).EQ.'wax') THEN
          RVAL=RWAX
        ELSE IF (PNAM(1:3).EQ.'WLB'.OR.PNAM(1:3).EQ.'wlb') THEN
          RVAL=RWLB
        ELSE IF (PNAM(1:3).EQ.'WMJ'.OR.PNAM(1:3).EQ.'wmj') THEN
          RVAL=RWMJ
        ELSE IF (PNAM(1:3).EQ.'WMN'.OR.PNAM(1:3).EQ.'wmn') THEN
          RVAL=RWMN
        ELSE IF (PNAM(1:3).EQ.'XLL'.OR.PNAM(1:3).EQ.'xll') THEN
          RVAL=REAL(NCFX)
        ELSE IF (PNAM(1:3).EQ.'XLO'.OR.PNAM(1:3).EQ.'xlo') THEN
          RVAL=RDCY
        ELSE IF (PNAM(1:3).EQ.'XLS'.OR.PNAM(1:3).EQ.'xls') THEN
          RVAL=RCWX
        ELSE IF (PNAM(1:3).EQ.'XMJ'.OR.PNAM(1:3).EQ.'xmj') THEN
          RVAL=RMJX
        ELSE IF (PNAM(1:3).EQ.'XMN'.OR.PNAM(1:3).EQ.'xmn') THEN
          RVAL=RMNX
        ELSE IF (PNAM(1:3).EQ.'XOR'.OR.PNAM(1:3).EQ.'xor') THEN
          RVAL=REAL(IORX)
        ELSE IF (PNAM(1:3).EQ.'YLL'.OR.PNAM(1:3).EQ.'yll') THEN
          RVAL=REAL(NCFY)
        ELSE IF (PNAM(1:3).EQ.'YLO'.OR.PNAM(1:3).EQ.'ylo') THEN
          RVAL=RDCX
        ELSE IF (PNAM(1:3).EQ.'YLS'.OR.PNAM(1:3).EQ.'yls') THEN
          RVAL=RCWY
        ELSE IF (PNAM(1:3).EQ.'YMJ'.OR.PNAM(1:3).EQ.'ymj') THEN
          RVAL=RMJY
        ELSE IF (PNAM(1:3).EQ.'YMN'.OR.PNAM(1:3).EQ.'ymn') THEN
          RVAL=RMNY
        ELSE
          CALL SETER ('GAGETR - UNRECOGNIZED PARAMETER NAME',2,1)
        END IF
C
C Done.
C
        RETURN
C
      END

C
C $Id: surf1dp.f,v 1.3 2008-07-27 03:10:12 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
C NOTE: If you make any changes to this software, please remember to
C make the same changes to the corresponding single precision routine.
C
      SUBROUTINE SURF1DP(M,N,X,Y,Z,IZ,ZX1,ZXM,ZY1,ZYN,ZXY11,ZXYM1,ZXY1N,
     +                 ZXYMN,ISLPSW,ZP,TEMP,SIGMA,IERR)
      DOUBLE PRECISION SIGMAY
      DOUBLE PRECISION DELY1
      DOUBLE PRECISION DELY2
      DOUBLE PRECISION C1
      DOUBLE PRECISION C2
      DOUBLE PRECISION C3
      DOUBLE PRECISION DELYN
      DOUBLE PRECISION DELYNM
      DOUBLE PRECISION SIGMAX
      DOUBLE PRECISION DELX1
      DOUBLE PRECISION DELX2
      DOUBLE PRECISION ZXY1NS
      DOUBLE PRECISION DELXM
      DOUBLE PRECISION DELXMM
      DOUBLE PRECISION ZXYMNS
      DOUBLE PRECISION DEL1
      DOUBLE PRECISION DELI
      DOUBLE PRECISION DIAG1
      DOUBLE PRECISION SDIAG1
      DOUBLE PRECISION DIAGI
      DOUBLE PRECISION DEL2
      DOUBLE PRECISION DIAG2
      DOUBLE PRECISION SDIAG2
      DOUBLE PRECISION DIAGIN
      DOUBLE PRECISION T
c
      INTEGER M,N,IZ,ISLPSW,IERR
      DOUBLE PRECISION X(M),Y(N),Z(IZ,N),ZX1(N),ZXM(N),ZY1(M),ZYN(M),
     +                 ZXY11,ZXYM1,ZXY1N,ZXYMN,ZP(M,N,3),TEMP(1),SIGMA
c
c                                 coded by alan kaylor cline
c                           from fitpack -- january 26, 1987
c                        a curve and surface fitting package
c                      a product of pleasant valley software
c                  8603 altus cove, austin, texas 78759, usa
c
c this subroutine determines the parameters necessary to
c compute an interpolatory surface passing through a rect-
c angular grid of functional values. the surface determined
c can be represented as the tensor product of splines under
c tension. the x- and y-partial derivatives around the
c boundary and the x-y-partial derivatives at the four
c corners may be specified or omitted. for actual mapping
c of points onto the surface it is necessary to call the
c function surf2.
c
c on input--
c
c   m is the number of grid lines in the x-direction, i. e.
c   lines parallel to the y-axis (m .ge. 2).
c
c   n is the number of grid lines in the y-direction, i. e.
c   lines parallel to the x-axis (n .ge. 2).
c
c   x is an array of the m x-coordinates of the grid lines
c   in the x-direction. these should be strictly increasing.
c
c   y is an array of the n y-coordinates of the grid lines
c   in the y-direction. these should be strictly increasing.
c
c   z is an array of the m * n functional values at the grid
c   points, i. e. z(i,j) contains the functional value at
c   (x(i),y(j)) for i = 1,...,m and j = 1,...,n.
c
c   iz is the row dimension of the matrix z used in the
c   calling program (iz .ge. m).
c
c   zx1 and zxm are arrays of the m x-partial derivatives
c   of the function along the x(1) and x(m) grid lines,
c   respectively. thus zx1(j) and zxm(j) contain the x-part-
c   ial derivatives at the points (x(1),y(j)) and
c   (x(m),y(j)), respectively, for j = 1,...,n. either of
c   these parameters will be ignored (and approximations
c   supplied internally) if islpsw so indicates.
c
c   zy1 and zyn are arrays of the n y-partial derivatives
c   of the function along the y(1) and y(n) grid lines,
c   respectively. thus zy1(i) and zyn(i) contain the y-part-
c   ial derivatives at the points (x(i),y(1)) and
c   (x(i),y(n)), respectively, for i = 1,...,m. either of
c   these parameters will be ignored (and estimations
c   supplied internally) if islpsw so indicates.
c
c   zxy11, zxym1, zxy1n, and zxymn are the x-y-partial
c   derivatives of the function at the four corners,
c   (x(1),y(1)), (x(m),y(1)), (x(1),y(n)), and (x(m),y(n)),
c   respectively. any of the parameters will be ignored (and
c   estimations supplied internally) if islpsw so indicates.
c
c   islpsw contains a switch indicating which boundary
c   derivative information is user-supplied and which
c   should be estimated by this subroutine. to determine
c   islpsw, let
c        i1 = 0 if zx1 is user-supplied (and = 1 otherwise),
c        i2 = 0 if zxm is user-supplied (and = 1 otherwise),
c        i3 = 0 if zy1 is user-supplied (and = 1 otherwise),
c        i4 = 0 if zyn is user-supplied (and = 1 otherwise),
c        i5 = 0 if zxy11 is user-supplied
c                                       (and = 1 otherwise),
c        i6 = 0 if zxym1 is user-supplied
c                                       (and = 1 otherwise),
c        i7 = 0 if zxy1n is user-supplied
c                                       (and = 1 otherwise),
c        i8 = 0 if zxymn is user-supplied
c                                       (and = 1 otherwise),
c   then islpsw = i1 + 2*i2 + 4*i3 + 8*i4 + 16*i5 + 32*i6
c                   + 64*i7 + 128*i8
c   thus islpsw = 0 indicates all derivative information is
c   user-supplied and islpsw = 255 indicates no derivative
c   information is user-supplied. any value between these
c   limits is valid.
c
c   zp is an array of at least 3*m*n locations.
c
c   temp is an array of at least n+n+m locations which is
c   used for scratch storage.
c
c and
c
c   sigma contains the tension factor. this value indicates
c   the curviness desired. if abs(sigma) is nearly zero
c   (e. g. .001) the resulting surface is approximately the
c   tensor product of cubic splines. if abs(sigma) is large
c   (e. g. 50.) the resulting surface is approximately
c   bi-linear. if sigma equals zero tensor products of
c   cubic splines result. a standard value for sigma is
c   approximately 1. in absolute value.
c
c on output--
c
c   zp contains the values of the xx-, yy-, and xxyy-partial
c   derivatives of the surface at the given nodes.
c
c   ierr contains an error flag,
c        = 0 for normal return,
c        = 1 if n is less than 2 or m is less than 2,
c        = 2 if the x-values or y-values are not strictly
c            increasing.
c
c and
c
c   m, n, x, y, z, iz, zx1, zxm, zy1, zyn, zxy11, zxym1,
c   zxy1n, zxymn, islpsw, and sigma are unaltered.
c
c this subroutine references package modules ceez, terms,
c and snhcsh.
c
c-----------------------------------------------------------
c
      MM1 = M - 1
      MP1 = M + 1
      NM1 = N - 1
      NP1 = N + 1
      NPM = N + M
      IERR = 0
      IF (N.LE.1 .OR. M.LE.1) GO TO 46
      IF (Y(N).LE.Y(1)) GO TO 47
c
c denormalize tension factor in y-direction
c
      SIGMAY = ABS(SIGMA)*DBLE(N-1)/ (Y(N)-Y(1))
c
c obtain y-partial derivatives along y = y(1)
c
      IF ((ISLPSW/8)*2.NE. (ISLPSW/4)) GO TO 2
      DO 1 I = 1,M
    1 ZP(I,1,1) = ZY1(I)
      GO TO 5
    2 DELY1 = Y(2) - Y(1)
      DELY2 = DELY1 + DELY1
      IF (N.GT.2) DELY2 = Y(3) - Y(1)
      IF (DELY1.LE.0.D0 .OR. DELY2.LE.DELY1) GO TO 47
      CALL CEEZDP(DELY1,DELY2,SIGMAY,C1,C2,C3,N)
      DO 3 I = 1,M
    3 ZP(I,1,1) = C1*Z(I,1) + C2*Z(I,2)
      IF (N.EQ.2) GO TO 5
      DO 4 I = 1,M
    4 ZP(I,1,1) = ZP(I,1,1) + C3*Z(I,3)
c
c obtain y-partial derivatives along y = y(n)
c
    5 IF ((ISLPSW/16)*2.NE. (ISLPSW/8)) GO TO 7
      DO 6 I = 1,M
          NPI = N + I
    6 TEMP(NPI) = ZYN(I)
      GO TO 10
    7 DELYN = Y(N) - Y(NM1)
      DELYNM = DELYN + DELYN
      IF (N.GT.2) DELYNM = Y(N) - Y(N-2)
      IF (DELYN.LE.0.D0 .OR. DELYNM.LE.DELYN) GO TO 47
      CALL CEEZDP(-DELYN,-DELYNM,SIGMAY,C1,C2,C3,N)
      DO 8 I = 1,M
          NPI = N + I
    8 TEMP(NPI) = C1*Z(I,N) + C2*Z(I,NM1)
      IF (N.EQ.2) GO TO 10
      DO 9 I = 1,M
          NPI = N + I
    9 TEMP(NPI) = TEMP(NPI) + C3*Z(I,N-2)
   10 IF (X(M).LE.X(1)) GO TO 47
c
c denormalize tension factor in x-direction
c
      SIGMAX = ABS(SIGMA)*DBLE(M-1)/ (X(M)-X(1))
c
c obtain x-partial derivatives along x = x(1)
c
      IF ((ISLPSW/2)*2.NE.ISLPSW) GO TO 12
      DO 11 J = 1,N
   11 ZP(1,J,2) = ZX1(J)
      IF ((ISLPSW/32)*2.EQ. (ISLPSW/16) .AND.
     +    (ISLPSW/128)*2.EQ. (ISLPSW/64)) GO TO 15
   12 DELX1 = X(2) - X(1)
      DELX2 = DELX1 + DELX1
      IF (M.GT.2) DELX2 = X(3) - X(1)
      IF (DELX1.LE.0.D0 .OR. DELX2.LE.DELX1) GO TO 47
      CALL CEEZDP(DELX1,DELX2,SIGMAX,C1,C2,C3,M)
      IF ((ISLPSW/2)*2.EQ.ISLPSW) GO TO 15
      DO 13 J = 1,N
   13 ZP(1,J,2) = C1*Z(1,J) + C2*Z(2,J)
      IF (M.EQ.2) GO TO 15
      DO 14 J = 1,N
   14 ZP(1,J,2) = ZP(1,J,2) + C3*Z(3,J)
c
c obtain x-y-partial derivative at (x(1),y(1))
c
   15 IF ((ISLPSW/32)*2.NE. (ISLPSW/16)) GO TO 16
      ZP(1,1,3) = ZXY11
      GO TO 17
   16 ZP(1,1,3) = C1*ZP(1,1,1) + C2*ZP(2,1,1)
      IF (M.GT.2) ZP(1,1,3) = ZP(1,1,3) + C3*ZP(3,1,1)
c
c obtain x-y-partial derivative at (x(1),y(n))
c
   17 IF ((ISLPSW/128)*2.NE. (ISLPSW/64)) GO TO 18
      ZXY1NS = ZXY1N
      GO TO 19
   18 ZXY1NS = C1*TEMP(N+1) + C2*TEMP(N+2)
      IF (M.GT.2) ZXY1NS = ZXY1NS + C3*TEMP(N+3)
c
c obtain x-partial derivative along x = x(m)
c
   19 IF ((ISLPSW/4)*2.NE. (ISLPSW/2)) GO TO 21
      DO 20 J = 1,N
          NPMPJ = NPM + J
   20 TEMP(NPMPJ) = ZXM(J)
      IF ((ISLPSW/64)*2.EQ. (ISLPSW/32) .AND.
     +    (ISLPSW/256)*2.EQ. (ISLPSW/128)) GO TO 24
   21 DELXM = X(M) - X(MM1)
      DELXMM = DELXM + DELXM
      IF (M.GT.2) DELXMM = X(M) - X(M-2)
      IF (DELXM.LE.0.D0 .OR. DELXMM.LE.DELXM) GO TO 47
      CALL CEEZDP(-DELXM,-DELXMM,SIGMAX,C1,C2,C3,M)
      IF ((ISLPSW/4)*2.EQ. (ISLPSW/2)) GO TO 24
      DO 22 J = 1,N
          NPMPJ = NPM + J
   22 TEMP(NPMPJ) = C1*Z(M,J) + C2*Z(MM1,J)
      IF (M.EQ.2) GO TO 24
      DO 23 J = 1,N
          NPMPJ = NPM + J
   23 TEMP(NPMPJ) = TEMP(NPMPJ) + C3*Z(M-2,J)
c
c obtain x-y-partial derivative at (x(m),y(1))
c
   24 IF ((ISLPSW/64)*2.NE. (ISLPSW/32)) GO TO 25
      ZP(M,1,3) = ZXYM1
      GO TO 26
   25 ZP(M,1,3) = C1*ZP(M,1,1) + C2*ZP(MM1,1,1)
      IF (M.GT.2) ZP(M,1,3) = ZP(M,1,3) + C3*ZP(M-2,1,1)
c
c obtain x-y-partial derivative at (x(m),y(n))
c
   26 IF ((ISLPSW/256)*2.NE. (ISLPSW/128)) GO TO 27
      ZXYMNS = ZXYMN
      GO TO 28
   27 ZXYMNS = C1*TEMP(NPM) + C2*TEMP(NPM-1)
      IF (M.GT.2) ZXYMNS = ZXYMNS + C3*TEMP(NPM-2)
c
c set up right hand sides and tridiagonal system for y-grid
c perform forward elimination
c
   28 DEL1 = Y(2) - Y(1)
      IF (DEL1.LE.0.D0) GO TO 47
      DELI = 1.D0/DEL1
      DO 29 I = 1,M
   29 ZP(I,2,1) = DELI* (Z(I,2)-Z(I,1))
      ZP(1,2,3) = DELI* (ZP(1,2,2)-ZP(1,1,2))
      ZP(M,2,3) = DELI* (TEMP(NPM+2)-TEMP(NPM+1))
      CALL TERMSDP(DIAG1,SDIAG1,SIGMAY,DEL1)
      DIAGI = 1.D0/DIAG1
      DO 30 I = 1,M
   30 ZP(I,1,1) = DIAGI* (ZP(I,2,1)-ZP(I,1,1))
      ZP(1,1,3) = DIAGI* (ZP(1,2,3)-ZP(1,1,3))
      ZP(M,1,3) = DIAGI* (ZP(M,2,3)-ZP(M,1,3))
      TEMP(1) = DIAGI*SDIAG1
      IF (N.EQ.2) GO TO 34
      DO 33 J = 2,NM1
          JM1 = J - 1
          JP1 = J + 1
          NPMPJ = NPM + J
          DEL2 = Y(JP1) - Y(J)
          IF (DEL2.LE.0.D0) GO TO 47
          DELI = 1.D0/DEL2
          DO 31 I = 1,M
   31     ZP(I,JP1,1) = DELI* (Z(I,JP1)-Z(I,J))
          ZP(1,JP1,3) = DELI* (ZP(1,JP1,2)-ZP(1,J,2))
          ZP(M,JP1,3) = DELI* (TEMP(NPMPJ+1)-TEMP(NPMPJ))
          CALL TERMSDP(DIAG2,SDIAG2,SIGMAY,DEL2)
          DIAGIN = 1.D0/ (DIAG1+DIAG2-SDIAG1*TEMP(JM1))
          DO 32 I = 1,M
   32     ZP(I,J,1) = DIAGIN* (ZP(I,JP1,1)-ZP(I,J,1)-SDIAG1*ZP(I,JM1,1))
          ZP(1,J,3) = DIAGIN* (ZP(1,JP1,3)-ZP(1,J,3)-SDIAG1*ZP(1,JM1,3))
          ZP(M,J,3) = DIAGIN* (ZP(M,JP1,3)-ZP(M,J,3)-SDIAG1*ZP(M,JM1,3))
          TEMP(J) = DIAGIN*SDIAG2
          DIAG1 = DIAG2
   33 SDIAG1 = SDIAG2
   34 DIAGIN = 1.D0/ (DIAG1-SDIAG1*TEMP(NM1))
      DO 35 I = 1,M
          NPI = N + I
   35 ZP(I,N,1) = DIAGIN* (TEMP(NPI)-ZP(I,N,1)-SDIAG1*ZP(I,NM1,1))
      ZP(1,N,3) = DIAGIN* (ZXY1NS-ZP(1,N,3)-SDIAG1*ZP(1,NM1,3))
      TEMP(N) = DIAGIN* (ZXYMNS-ZP(M,N,3)-SDIAG1*ZP(M,NM1,3))
c
c perform back substitution
c
      DO 37 J = 2,N
          JBAK = NP1 - J
          JBAKP1 = JBAK + 1
          T = TEMP(JBAK)
          DO 36 I = 1,M
   36     ZP(I,JBAK,1) = ZP(I,JBAK,1) - T*ZP(I,JBAKP1,1)
          ZP(1,JBAK,3) = ZP(1,JBAK,3) - T*ZP(1,JBAKP1,3)
   37 TEMP(JBAK) = ZP(M,JBAK,3) - T*TEMP(JBAKP1)
c
c set up right hand sides and tridiagonal system for x-grid
c perform forward elimination
c
      DEL1 = X(2) - X(1)
      IF (DEL1.LE.0.D0) GO TO 47
      DELI = 1.D0/DEL1
      DO 38 J = 1,N
          ZP(2,J,2) = DELI* (Z(2,J)-Z(1,J))
   38 ZP(2,J,3) = DELI* (ZP(2,J,1)-ZP(1,J,1))
      CALL TERMSDP(DIAG1,SDIAG1,SIGMAX,DEL1)
      DIAGI = 1.D0/DIAG1
      DO 39 J = 1,N
          ZP(1,J,2) = DIAGI* (ZP(2,J,2)-ZP(1,J,2))
   39 ZP(1,J,3) = DIAGI* (ZP(2,J,3)-ZP(1,J,3))
      TEMP(N+1) = DIAGI*SDIAG1
      IF (M.EQ.2) GO TO 43
      DO 42 I = 2,MM1
          IM1 = I - 1
          IP1 = I + 1
          NPI = N + I
          DEL2 = X(IP1) - X(I)
          IF (DEL2.LE.0.D0) GO TO 47
          DELI = 1.D0/DEL2
          DO 40 J = 1,N
              ZP(IP1,J,2) = DELI* (Z(IP1,J)-Z(I,J))
   40     ZP(IP1,J,3) = DELI* (ZP(IP1,J,1)-ZP(I,J,1))
          CALL TERMSDP(DIAG2,SDIAG2,SIGMAX,DEL2)
          DIAGIN = 1.D0/ (DIAG1+DIAG2-SDIAG1*TEMP(NPI-1))
          DO 41 J = 1,N
              ZP(I,J,2) = DIAGIN* (ZP(IP1,J,2)-ZP(I,J,2)-
     +                    SDIAG1*ZP(IM1,J,2))
   41     ZP(I,J,3) = DIAGIN* (ZP(IP1,J,3)-ZP(I,J,3)-SDIAG1*ZP(IM1,J,3))
          TEMP(NPI) = DIAGIN*SDIAG2
          DIAG1 = DIAG2
   42 SDIAG1 = SDIAG2
   43 DIAGIN = 1.D0/ (DIAG1-SDIAG1*TEMP(NPM-1))
      DO 44 J = 1,N
          NPMPJ = NPM + J
          ZP(M,J,2) = DIAGIN* (TEMP(NPMPJ)-ZP(M,J,2)-SDIAG1*ZP(MM1,J,2))
   44 ZP(M,J,3) = DIAGIN* (TEMP(J)-ZP(M,J,3)-SDIAG1*ZP(MM1,J,3))
c
c perform back substitution
c
      DO 45 I = 2,M
          IBAK = MP1 - I
          IBAKP1 = IBAK + 1
          NPIBAK = N + IBAK
          T = TEMP(NPIBAK)
          DO 45 J = 1,N
              ZP(IBAK,J,2) = ZP(IBAK,J,2) - T*ZP(IBAKP1,J,2)
   45 ZP(IBAK,J,3) = ZP(IBAK,J,3) - T*ZP(IBAKP1,J,3)
      RETURN
c
c too few points
c
   46 IERR = 1
      RETURN
c
c points not strictly increasing
c
   47 IERR = 2
      RETURN
      END

      SUBROUTINE DLAQTR( LTRAN, LREAL, N, T, LDT, B, W, SCALE, X, WORK,
     $                   INFO )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      LOGICAL            LREAL, LTRAN
      INTEGER            INFO, LDT, N
      DOUBLE PRECISION   SCALE, W
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   B( * ), T( LDT, * ), WORK( * ), X( * )
*     ..
*
*  Purpose
*  =======
*
*  DLAQTR solves the real quasi-triangular system
*
*               op(T)*p = scale*c,               if LREAL = .TRUE.
*
*  or the complex quasi-triangular systems
*
*             op(T + iB)*(p+iq) = scale*(c+id),  if LREAL = .FALSE.
*
*  in real arithmetic, where T is upper quasi-triangular.
*  If LREAL = .FALSE., then the first diagonal block of T must be
*  1 by 1, B is the specially structured matrix
*
*                 B = [ b(1) b(2) ... b(n) ]
*                     [       w            ]
*                     [           w        ]
*                     [              .     ]
*                     [                 w  ]
*
*  op(A) = A or A', A' denotes the conjugate transpose of
*  matrix A.
*
*  On input, X = [ c ].  On output, X = [ p ].
*                [ d ]                  [ q ]
*
*  This subroutine is designed for the condition number estimation
*  in routine DTRSNA.
*
*  Arguments
*  =========
*
*  LTRAN   (input) LOGICAL
*          On entry, LTRAN specifies the option of conjugate transpose:
*             = .FALSE.,    op(T+i*B) = T+i*B,
*             = .TRUE.,     op(T+i*B) = (T+i*B)'.
*
*  LREAL   (input) LOGICAL
*          On entry, LREAL specifies the input matrix structure:
*             = .FALSE.,    the input is complex
*             = .TRUE.,     the input is real
*
*  N       (input) INTEGER
*          On entry, N specifies the order of T+i*B. N >= 0.
*
*  T       (input) DOUBLE PRECISION array, dimension (LDT,N)
*          On entry, T contains a matrix in Schur canonical form.
*          If LREAL = .FALSE., then the first diagonal block of T mu
*          be 1 by 1.
*
*  LDT     (input) INTEGER
*          The leading dimension of the matrix T. LDT >= max(1,N).
*
*  B       (input) DOUBLE PRECISION array, dimension (N)
*          On entry, B contains the elements to form the matrix
*          B as described above.
*          If LREAL = .TRUE., B is not referenced.
*
*  W       (input) DOUBLE PRECISION
*          On entry, W is the diagonal element of the matrix B.
*          If LREAL = .TRUE., W is not referenced.
*
*  SCALE   (output) DOUBLE PRECISION
*          On exit, SCALE is the scale factor.
*
*  X       (input/output) DOUBLE PRECISION array, dimension (2*N)
*          On entry, X contains the right hand side of the system.
*          On exit, X is overwritten by the solution.
*
*  WORK    (workspace) DOUBLE PRECISION array, dimension (N)
*
*  INFO    (output) INTEGER
*          On exit, INFO is set to
*             0: successful exit.
*               1: the some diagonal 1 by 1 block has been perturbed by
*                  a small number SMIN to keep nonsingularity.
*               2: the some diagonal 2 by 2 block has been perturbed by
*                  a small number in DLALN2 to keep nonsingularity.
*          NOTE: In the interests of speed, this routine does not
*                check the inputs for errors.
*
* =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO, ONE
      PARAMETER          ( ZERO = 0.0D+0, ONE = 1.0D+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            NOTRAN
      INTEGER            I, IERR, J, J1, J2, JNEXT, K, N1, N2
      DOUBLE PRECISION   BIGNUM, EPS, REC, SCALOC, SI, SMIN, SMINW,
     $                   SMLNUM, SR, TJJ, TMP, XJ, XMAX, XNORM, Z
*     ..
*     .. Local Arrays ..
      DOUBLE PRECISION   D( 2, 2 ), V( 2, 2 )
*     ..
*     .. External Functions ..
      INTEGER            IDAMAX
      DOUBLE PRECISION   DASUM, DDOT, DLAMCH, DLANGE
      EXTERNAL           IDAMAX, DASUM, DDOT, DLAMCH, DLANGE
*     ..
*     .. External Subroutines ..
      EXTERNAL           DAXPY, DLADIV, DLALN2, DSCAL
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, MAX
*     ..
*     .. Executable Statements ..
*
*     Do not test the input parameters for errors
*
      NOTRAN = .NOT.LTRAN
      INFO = 0
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
*
*     Set constants to control overflow
*
      EPS = DLAMCH( 'P' )
      SMLNUM = DLAMCH( 'S' ) / EPS
      BIGNUM = ONE / SMLNUM
*
      XNORM = DLANGE( 'M', N, N, T, LDT, D )
      IF( .NOT.LREAL )
     $   XNORM = MAX( XNORM, ABS( W ), DLANGE( 'M', N, 1, B, N, D ) )
      SMIN = MAX( SMLNUM, EPS*XNORM )
*
*     Compute 1-norm of each column of strictly upper triangular
*     part of T to control overflow in triangular solver.
*
      WORK( 1 ) = ZERO
      DO 10 J = 2, N
         WORK( J ) = DASUM( J-1, T( 1, J ), 1 )
   10 CONTINUE
*
      IF( .NOT.LREAL ) THEN
         DO 20 I = 2, N
            WORK( I ) = WORK( I ) + ABS( B( I ) )
   20    CONTINUE
      END IF
*
      N2 = 2*N
      N1 = N
      IF( .NOT.LREAL )
     $   N1 = N2
      K = IDAMAX( N1, X, 1 )
      XMAX = ABS( X( K ) )
      SCALE = ONE
*
      IF( XMAX.GT.BIGNUM ) THEN
         SCALE = BIGNUM / XMAX
         CALL DSCAL( N1, SCALE, X, 1 )
         XMAX = BIGNUM
      END IF
*
      IF( LREAL ) THEN
*
         IF( NOTRAN ) THEN
*
*           Solve T*p = scale*c
*
            JNEXT = N
            DO 30 J = N, 1, -1
               IF( J.GT.JNEXT )
     $            GO TO 30
               J1 = J
               J2 = J
               JNEXT = J - 1
               IF( J.GT.1 ) THEN
                  IF( T( J, J-1 ).NE.ZERO ) THEN
                     J1 = J - 1
                     JNEXT = J - 2
                  END IF
               END IF
*
               IF( J1.EQ.J2 ) THEN
*
*                 Meet 1 by 1 diagonal block
*
*                 Scale to avoid overflow when computing
*                     x(j) = b(j)/T(j,j)
*
                  XJ = ABS( X( J1 ) )
                  TJJ = ABS( T( J1, J1 ) )
                  TMP = T( J1, J1 )
                  IF( TJJ.LT.SMIN ) THEN
                     TMP = SMIN
                     TJJ = SMIN
                     INFO = 1
                  END IF
*
                  IF( XJ.EQ.ZERO )
     $               GO TO 30
*
                  IF( TJJ.LT.ONE ) THEN
                     IF( XJ.GT.BIGNUM*TJJ ) THEN
                        REC = ONE / XJ
                        CALL DSCAL( N, REC, X, 1 )
                        SCALE = SCALE*REC
                        XMAX = XMAX*REC
                     END IF
                  END IF
                  X( J1 ) = X( J1 ) / TMP
                  XJ = ABS( X( J1 ) )
*
*                 Scale x if necessary to avoid overflow when adding a
*                 multiple of column j1 of T.
*
                  IF( XJ.GT.ONE ) THEN
                     REC = ONE / XJ
                     IF( WORK( J1 ).GT.( BIGNUM-XMAX )*REC ) THEN
                        CALL DSCAL( N, REC, X, 1 )
                        SCALE = SCALE*REC
                     END IF
                  END IF
                  IF( J1.GT.1 ) THEN
                     CALL DAXPY( J1-1, -X( J1 ), T( 1, J1 ), 1, X, 1 )
                     K = IDAMAX( J1-1, X, 1 )
                     XMAX = ABS( X( K ) )
                  END IF
*
               ELSE
*
*                 Meet 2 by 2 diagonal block
*
*                 Call 2 by 2 linear system solve, to take
*                 care of possible overflow by scaling factor.
*
                  D( 1, 1 ) = X( J1 )
                  D( 2, 1 ) = X( J2 )
                  CALL DLALN2( .FALSE., 2, 1, SMIN, ONE, T( J1, J1 ),
     $                         LDT, ONE, ONE, D, 2, ZERO, ZERO, V, 2,
     $                         SCALOC, XNORM, IERR )
                  IF( IERR.NE.0 )
     $               INFO = 2
*
                  IF( SCALOC.NE.ONE ) THEN
                     CALL DSCAL( N, SCALOC, X, 1 )
                     SCALE = SCALE*SCALOC
                  END IF
                  X( J1 ) = V( 1, 1 )
                  X( J2 ) = V( 2, 1 )
*
*                 Scale V(1,1) (= X(J1)) and/or V(2,1) (=X(J2))
*                 to avoid overflow in updating right-hand side.
*
                  XJ = MAX( ABS( V( 1, 1 ) ), ABS( V( 2, 1 ) ) )
                  IF( XJ.GT.ONE ) THEN
                     REC = ONE / XJ
                     IF( MAX( WORK( J1 ), WORK( J2 ) ).GT.
     $                   ( BIGNUM-XMAX )*REC ) THEN
                        CALL DSCAL( N, REC, X, 1 )
                        SCALE = SCALE*REC
                     END IF
                  END IF
*
*                 Update right-hand side
*
                  IF( J1.GT.1 ) THEN
                     CALL DAXPY( J1-1, -X( J1 ), T( 1, J1 ), 1, X, 1 )
                     CALL DAXPY( J1-1, -X( J2 ), T( 1, J2 ), 1, X, 1 )
                     K = IDAMAX( J1-1, X, 1 )
                     XMAX = ABS( X( K ) )
                  END IF
*
               END IF
*
   30       CONTINUE
*
         ELSE
*
*           Solve T'*p = scale*c
*
            JNEXT = 1
            DO 40 J = 1, N
               IF( J.LT.JNEXT )
     $            GO TO 40
               J1 = J
               J2 = J
               JNEXT = J + 1
               IF( J.LT.N ) THEN
                  IF( T( J+1, J ).NE.ZERO ) THEN
                     J2 = J + 1
                     JNEXT = J + 2
                  END IF
               END IF
*
               IF( J1.EQ.J2 ) THEN
*
*                 1 by 1 diagonal block
*
*                 Scale if necessary to avoid overflow in forming the
*                 right-hand side element by inner product.
*
                  XJ = ABS( X( J1 ) )
                  IF( XMAX.GT.ONE ) THEN
                     REC = ONE / XMAX
                     IF( WORK( J1 ).GT.( BIGNUM-XJ )*REC ) THEN
                        CALL DSCAL( N, REC, X, 1 )
                        SCALE = SCALE*REC
                        XMAX = XMAX*REC
                     END IF
                  END IF
*
                  X( J1 ) = X( J1 ) - DDOT( J1-1, T( 1, J1 ), 1, X, 1 )
*
                  XJ = ABS( X( J1 ) )
                  TJJ = ABS( T( J1, J1 ) )
                  TMP = T( J1, J1 )
                  IF( TJJ.LT.SMIN ) THEN
                     TMP = SMIN
                     TJJ = SMIN
                     INFO = 1
                  END IF
*
                  IF( TJJ.LT.ONE ) THEN
                     IF( XJ.GT.BIGNUM*TJJ ) THEN
                        REC = ONE / XJ
                        CALL DSCAL( N, REC, X, 1 )
                        SCALE = SCALE*REC
                        XMAX = XMAX*REC
                     END IF
                  END IF
                  X( J1 ) = X( J1 ) / TMP
                  XMAX = MAX( XMAX, ABS( X( J1 ) ) )
*
               ELSE
*
*                 2 by 2 diagonal block
*
*                 Scale if necessary to avoid overflow in forming the
*                 right-hand side elements by inner product.
*
                  XJ = MAX( ABS( X( J1 ) ), ABS( X( J2 ) ) )
                  IF( XMAX.GT.ONE ) THEN
                     REC = ONE / XMAX
                     IF( MAX( WORK( J2 ), WORK( J1 ) ).GT.( BIGNUM-XJ )*
     $                   REC ) THEN
                        CALL DSCAL( N, REC, X, 1 )
                        SCALE = SCALE*REC
                        XMAX = XMAX*REC
                     END IF
                  END IF
*
                  D( 1, 1 ) = X( J1 ) - DDOT( J1-1, T( 1, J1 ), 1, X,
     $                        1 )
                  D( 2, 1 ) = X( J2 ) - DDOT( J1-1, T( 1, J2 ), 1, X,
     $                        1 )
*
                  CALL DLALN2( .TRUE., 2, 1, SMIN, ONE, T( J1, J1 ),
     $                         LDT, ONE, ONE, D, 2, ZERO, ZERO, V, 2,
     $                         SCALOC, XNORM, IERR )
                  IF( IERR.NE.0 )
     $               INFO = 2
*
                  IF( SCALOC.NE.ONE ) THEN
                     CALL DSCAL( N, SCALOC, X, 1 )
                     SCALE = SCALE*SCALOC
                  END IF
                  X( J1 ) = V( 1, 1 )
                  X( J2 ) = V( 2, 1 )
                  XMAX = MAX( ABS( X( J1 ) ), ABS( X( J2 ) ), XMAX )
*
               END IF
   40       CONTINUE
         END IF
*
      ELSE
*
         SMINW = MAX( EPS*ABS( W ), SMIN )
         IF( NOTRAN ) THEN
*
*           Solve (T + iB)*(p+iq) = c+id
*
            JNEXT = N
            DO 70 J = N, 1, -1
               IF( J.GT.JNEXT )
     $            GO TO 70
               J1 = J
               J2 = J
               JNEXT = J - 1
               IF( J.GT.1 ) THEN
                  IF( T( J, J-1 ).NE.ZERO ) THEN
                     J1 = J - 1
                     JNEXT = J - 2
                  END IF
               END IF
*
               IF( J1.EQ.J2 ) THEN
*
*                 1 by 1 diagonal block
*
*                 Scale if necessary to avoid overflow in division
*
                  Z = W
                  IF( J1.EQ.1 )
     $               Z = B( 1 )
                  XJ = ABS( X( J1 ) ) + ABS( X( N+J1 ) )
                  TJJ = ABS( T( J1, J1 ) ) + ABS( Z )
                  TMP = T( J1, J1 )
                  IF( TJJ.LT.SMINW ) THEN
                     TMP = SMINW
                     TJJ = SMINW
                     INFO = 1
                  END IF
*
                  IF( XJ.EQ.ZERO )
     $               GO TO 70
*
                  IF( TJJ.LT.ONE ) THEN
                     IF( XJ.GT.BIGNUM*TJJ ) THEN
                        REC = ONE / XJ
                        CALL DSCAL( N2, REC, X, 1 )
                        SCALE = SCALE*REC
                        XMAX = XMAX*REC
                     END IF
                  END IF
                  CALL DLADIV( X( J1 ), X( N+J1 ), TMP, Z, SR, SI )
                  X( J1 ) = SR
                  X( N+J1 ) = SI
                  XJ = ABS( X( J1 ) ) + ABS( X( N+J1 ) )
*
*                 Scale x if necessary to avoid overflow when adding a
*                 multiple of column j1 of T.
*
                  IF( XJ.GT.ONE ) THEN
                     REC = ONE / XJ
                     IF( WORK( J1 ).GT.( BIGNUM-XMAX )*REC ) THEN
                        CALL DSCAL( N2, REC, X, 1 )
                        SCALE = SCALE*REC
                     END IF
                  END IF
*
                  IF( J1.GT.1 ) THEN
                     CALL DAXPY( J1-1, -X( J1 ), T( 1, J1 ), 1, X, 1 )
                     CALL DAXPY( J1-1, -X( N+J1 ), T( 1, J1 ), 1,
     $                           X( N+1 ), 1 )
*
                     X( 1 ) = X( 1 ) + B( J1 )*X( N+J1 )
                     X( N+1 ) = X( N+1 ) - B( J1 )*X( J1 )
*
                     XMAX = ZERO
                     DO 50 K = 1, J1 - 1
                        XMAX = MAX( XMAX, ABS( X( K ) )+
     $                         ABS( X( K+N ) ) )
   50                CONTINUE
                  END IF
*
               ELSE
*
*                 Meet 2 by 2 diagonal block
*
                  D( 1, 1 ) = X( J1 )
                  D( 2, 1 ) = X( J2 )
                  D( 1, 2 ) = X( N+J1 )
                  D( 2, 2 ) = X( N+J2 )
                  CALL DLALN2( .FALSE., 2, 2, SMINW, ONE, T( J1, J1 ),
     $                         LDT, ONE, ONE, D, 2, ZERO, -W, V, 2,
     $                         SCALOC, XNORM, IERR )
                  IF( IERR.NE.0 )
     $               INFO = 2
*
                  IF( SCALOC.NE.ONE ) THEN
                     CALL DSCAL( 2*N, SCALOC, X, 1 )
                     SCALE = SCALOC*SCALE
                  END IF
                  X( J1 ) = V( 1, 1 )
                  X( J2 ) = V( 2, 1 )
                  X( N+J1 ) = V( 1, 2 )
                  X( N+J2 ) = V( 2, 2 )
*
*                 Scale X(J1), .... to avoid overflow in
*                 updating right hand side.
*
                  XJ = MAX( ABS( V( 1, 1 ) )+ABS( V( 1, 2 ) ),
     $                 ABS( V( 2, 1 ) )+ABS( V( 2, 2 ) ) )
                  IF( XJ.GT.ONE ) THEN
                     REC = ONE / XJ
                     IF( MAX( WORK( J1 ), WORK( J2 ) ).GT.
     $                   ( BIGNUM-XMAX )*REC ) THEN
                        CALL DSCAL( N2, REC, X, 1 )
                        SCALE = SCALE*REC
                     END IF
                  END IF
*
*                 Update the right-hand side.
*
                  IF( J1.GT.1 ) THEN
                     CALL DAXPY( J1-1, -X( J1 ), T( 1, J1 ), 1, X, 1 )
                     CALL DAXPY( J1-1, -X( J2 ), T( 1, J2 ), 1, X, 1 )
*
                     CALL DAXPY( J1-1, -X( N+J1 ), T( 1, J1 ), 1,
     $                           X( N+1 ), 1 )
                     CALL DAXPY( J1-1, -X( N+J2 ), T( 1, J2 ), 1,
     $                           X( N+1 ), 1 )
*
                     X( 1 ) = X( 1 ) + B( J1 )*X( N+J1 ) +
     $                        B( J2 )*X( N+J2 )
                     X( N+1 ) = X( N+1 ) - B( J1 )*X( J1 ) -
     $                          B( J2 )*X( J2 )
*
                     XMAX = ZERO
                     DO 60 K = 1, J1 - 1
                        XMAX = MAX( ABS( X( K ) )+ABS( X( K+N ) ),
     $                         XMAX )
   60                CONTINUE
                  END IF
*
               END IF
   70       CONTINUE
*
         ELSE
*
*           Solve (T + iB)'*(p+iq) = c+id
*
            JNEXT = 1
            DO 80 J = 1, N
               IF( J.LT.JNEXT )
     $            GO TO 80
               J1 = J
               J2 = J
               JNEXT = J + 1
               IF( J.LT.N ) THEN
                  IF( T( J+1, J ).NE.ZERO ) THEN
                     J2 = J + 1
                     JNEXT = J + 2
                  END IF
               END IF
*
               IF( J1.EQ.J2 ) THEN
*
*                 1 by 1 diagonal block
*
*                 Scale if necessary to avoid overflow in forming the
*                 right-hand side element by inner product.
*
                  XJ = ABS( X( J1 ) ) + ABS( X( J1+N ) )
                  IF( XMAX.GT.ONE ) THEN
                     REC = ONE / XMAX
                     IF( WORK( J1 ).GT.( BIGNUM-XJ )*REC ) THEN
                        CALL DSCAL( N2, REC, X, 1 )
                        SCALE = SCALE*REC
                        XMAX = XMAX*REC
                     END IF
                  END IF
*
                  X( J1 ) = X( J1 ) - DDOT( J1-1, T( 1, J1 ), 1, X, 1 )
                  X( N+J1 ) = X( N+J1 ) - DDOT( J1-1, T( 1, J1 ), 1,
     $                        X( N+1 ), 1 )
                  IF( J1.GT.1 ) THEN
                     X( J1 ) = X( J1 ) - B( J1 )*X( N+1 )
                     X( N+J1 ) = X( N+J1 ) + B( J1 )*X( 1 )
                  END IF
                  XJ = ABS( X( J1 ) ) + ABS( X( J1+N ) )
*
                  Z = W
                  IF( J1.EQ.1 )
     $               Z = B( 1 )
*
*                 Scale if necessary to avoid overflow in
*                 complex division
*
                  TJJ = ABS( T( J1, J1 ) ) + ABS( Z )
                  TMP = T( J1, J1 )
                  IF( TJJ.LT.SMINW ) THEN
                     TMP = SMINW
                     TJJ = SMINW
                     INFO = 1
                  END IF
*
                  IF( TJJ.LT.ONE ) THEN
                     IF( XJ.GT.BIGNUM*TJJ ) THEN
                        REC = ONE / XJ
                        CALL DSCAL( N2, REC, X, 1 )
                        SCALE = SCALE*REC
                        XMAX = XMAX*REC
                     END IF
                  END IF
                  CALL DLADIV( X( J1 ), X( N+J1 ), TMP, -Z, SR, SI )
                  X( J1 ) = SR
                  X( J1+N ) = SI
                  XMAX = MAX( ABS( X( J1 ) )+ABS( X( J1+N ) ), XMAX )
*
               ELSE
*
*                 2 by 2 diagonal block
*
*                 Scale if necessary to avoid overflow in forming the
*                 right-hand side element by inner product.
*
                  XJ = MAX( ABS( X( J1 ) )+ABS( X( N+J1 ) ),
     $                 ABS( X( J2 ) )+ABS( X( N+J2 ) ) )
                  IF( XMAX.GT.ONE ) THEN
                     REC = ONE / XMAX
                     IF( MAX( WORK( J1 ), WORK( J2 ) ).GT.
     $                   ( BIGNUM-XJ ) / XMAX ) THEN
                        CALL DSCAL( N2, REC, X, 1 )
                        SCALE = SCALE*REC
                        XMAX = XMAX*REC
                     END IF
                  END IF
*
                  D( 1, 1 ) = X( J1 ) - DDOT( J1-1, T( 1, J1 ), 1, X,
     $                        1 )
                  D( 2, 1 ) = X( J2 ) - DDOT( J1-1, T( 1, J2 ), 1, X,
     $                        1 )
                  D( 1, 2 ) = X( N+J1 ) - DDOT( J1-1, T( 1, J1 ), 1,
     $                        X( N+1 ), 1 )
                  D( 2, 2 ) = X( N+J2 ) - DDOT( J1-1, T( 1, J2 ), 1,
     $                        X( N+1 ), 1 )
                  D( 1, 1 ) = D( 1, 1 ) - B( J1 )*X( N+1 )
                  D( 2, 1 ) = D( 2, 1 ) - B( J2 )*X( N+1 )
                  D( 1, 2 ) = D( 1, 2 ) + B( J1 )*X( 1 )
                  D( 2, 2 ) = D( 2, 2 ) + B( J2 )*X( 1 )
*
                  CALL DLALN2( .TRUE., 2, 2, SMINW, ONE, T( J1, J1 ),
     $                         LDT, ONE, ONE, D, 2, ZERO, W, V, 2,
     $                         SCALOC, XNORM, IERR )
                  IF( IERR.NE.0 )
     $               INFO = 2
*
                  IF( SCALOC.NE.ONE ) THEN
                     CALL DSCAL( N2, SCALOC, X, 1 )
                     SCALE = SCALOC*SCALE
                  END IF
                  X( J1 ) = V( 1, 1 )
                  X( J2 ) = V( 2, 1 )
                  X( N+J1 ) = V( 1, 2 )
                  X( N+J2 ) = V( 2, 2 )
                  XMAX = MAX( ABS( X( J1 ) )+ABS( X( N+J1 ) ),
     $                   ABS( X( J2 ) )+ABS( X( N+J2 ) ), XMAX )
*
               END IF
*
   80       CONTINUE
*
         END IF
*
      END IF
*
      RETURN
*
*     End of DLAQTR
*
      END

C
C	$Id: gaspar.f,v 1.5 2008-07-27 00:20:56 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GASPAR(IOS,STATUS)
C
C  Parse the ASPECT SOURCE FLAG elements.
C
      include 'trstat.h'
      include 'trpars.h'
      include 'trinst.h'
C
      INTEGER IOS, STATUS
      PARAMETER (ICVMAX=15)
      INTEGER TMPASF(2), ASFCNT, II, ICONV(ICVMAX)
      DATA ICONV/1,2,3,4,5,6,7,7,8,9,10,11,13,12,12/
C
C  Compute the number of aspect source flags defined.
C
      ASFCNT = (LEN / (MENCPR/BYTSIZ)) / 2
C
C  Extract the ASF pointer and value (since the ASFs are stored in
C  the segments as CGM elements, the values are reversed, so 
C  complement them here).
C
      DO 10 II = 1,ASFCNT
        CALL GOPDEC(TMPASF,MENCPR,2,IOS,STATUS)
        IF (TMPASF(1).GE.0 .AND. TMPASF(1).LT.ASFMAX) THEN
          IF(II .LE. ICVMAX) GASFSF(ICONV(II)) = 1-TMPASF(2)
        END IF
 10   CONTINUE
      CALL GSASF(GASFSF)
C
      RETURN
      END

      PROGRAM CCPCIS
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER (K=40,N=40,LRWK=1000,LIWK=1000)
      REAL Z(K,N), RWRK(LRWK)
      INTEGER M, IWRK(LIWK)
      
      CALL GETDAT (Z, K, M, N) 
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Change Contour levels to come at increments of 15
C Draw labels at every other contour level.
C
      CALL CPSETR ('CIS - CONTOUR INTERVAL SPECIFIER',15.)
      CALL CPSETI ('LIS - LABEL INTERVAL SPECIFIER',2)
      CALL CPSETR ('CMN - CONTOUR MINIMUM',-5.)
      CALL CPSETR ('CMX - CONTOUR MAXIMUM',75.)
C
C Initialize Conpack
C
      CALL CPRECT(Z,K,M,N,RWRK,LRWK,IWRK,LIWK)
C
C Draw perimeter
C
      CALL CPBACK(Z, RWRK, IWRK)
C
C Draw Contours
C
      CALL CPCLDR(Z,RWRK,IWRK)
C
C Close frame
C
      CALL FRAME
C
C Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      
      STOP
      END
      
      SUBROUTINE GETDAT (Z, K, M, N)
      INTEGER I,J,K,M,N
      REAL Z(K,N)
      
      M=K
      DO 10, I=1,M
         DO 20, J=1,N
            Z(I,J)= 10.E-5*(-16.*REAL(I**2*J) +
     1           34*REAL(I*J**2) - REAL(6*I) + 93.)
 20      CONTINUE
 10   CONTINUE
      
      RETURN
      END

      PROGRAM TEZMPA
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Open GKS, open workstation of type 1, activate workstation.
C
      CALL GOPKS (IERRF,ISZDM)
      CALL GOPWK (IWKID,LUNIT,IWTYPE)
      CALL GACWK (IWKID)
C
C Invoke demo driver.
C
      CALL EZMPA (IERR,IWKID)
C
C Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
C
      END

      SUBROUTINE EZMPA (IERR,IWKID)
C
C PURPOSE                To provide a simple demonstration of the use
C                        of EZMAPA.
C
C USAGE                  CALL EZMPA (IERR,IWKID)
C
C ARGUMENTS
C
C ON OUTPUT              IERR
C
C                          an error parameter
C                          = 0, if the test is successful,
C                          = 1, otherwise
C
C I/O                    If the test is successful, the message
C
C                          EZMAPA TEST EXECUTED--SEE PLOTS TO CERTIFY
C
C                        is written on unit 6.
C
C PRECISION              Single.
C
C REQUIRED LIBRARY       EZMAP, EZMAPA, AREAS, SPPS
C FILES
C
C REQUIRED GKS LEVEL     0A
C
C LANGUAGE               FORTRAN
C
C HISTORY                Written in June, 1987.
C
C ALGORITHM              TEZMPA draws a solid-color map of a portion
C                        of Europe.
C
C PORTABILITY            FORTRAN 77
C
C
C Define an array in which to construct the area map.
C
        DIMENSION IAMA(25000)
C
C Dimension the arrays needed by ARSCAM and ARDRLN for x/y coordinates.
C
        DIMENSION XCRA(210),YCRA(210)
C
C Dimension the arrays needed by ARSCAM and ARDRLN for area and group
C identifiers.
C
        DIMENSION IAAI(2),IAGI(2)
C
C Define the RGB color triples needed below.
C
        DIMENSION RGB(3,14)
C
C Define a set of indices to order the colors.
C
        DIMENSION IOC(14)
C
C Declare the routine which will color the areas.
C
        EXTERNAL COLRAM
C
C Declare the routine which will draw lines of latitude and longitude
C over water.
C
        EXTERNAL COLRLN
C
        DATA IOC / 6,2,5,12,10,11,1,3,4,8,9,7,13,14 /
C
        DATA RGB / 0.70 , 0.70 , 0.70 ,
     +             0.75 , 0.50 , 1.00 ,
     +             0.50 , 0.00 , 1.00 ,
     +             0.00 , 0.00 , 1.00 ,
     +             0.00 , 0.50 , 1.00 ,
     +             0.00 , 1.00 , 1.00 ,
     +             0.00 , 1.00 , 0.60 ,
     +             0.00 , 1.00 , 0.00 ,
     +             0.70 , 1.00 , 0.00 ,
     +             1.00 , 1.00 , 0.00 ,
     +             1.00 , 0.75 , 0.00 ,
     +             1.00 , 0.38 , 0.38 ,
     +             1.00 , 0.00 , 0.38 ,
     +             1.00 , 0.00 , 0.00 /
C
C Force solid fill.
C
        CALL GSFAIS (1)
C
C Define 15 different color indices.  The first 14 are spaced through
C the color spectrum and the final one is black.
C
        DO 101 J=1,14
          I=IOC(J)
          CALL GSCR (IWKID,J,RGB(1,I),RGB(2,I),RGB(3,I))
  101   CONTINUE
C
C Set color index 15 to black.
C
        CALL GSCR (IWKID,15,0.,0.,0.)
C
C Set up EZMAP.
C
        CALL MAPSTI ('MV',1)
        CALL MAPSTC ('OU','PO')
        CALL MAPROJ ('ME',0.,0.,0.)
        CALL MAPSET ('CO',30.,-15.,60.,30.)
C
C Make MAPBLA use 1 and 2 as the group identifiers.
C
        CALL MAPSTI ('G1',1)
        CALL MAPSTI ('G2',2)
C
C Use 5 vertical strips to reduce the number of points defining the
C sub-areas.
C
        CALL MAPSTI ('VS',5)
C
C Initialize EZMAP.
C
        CALL MAPINT
C
C Initialize the area map.
C
        CALL ARINAM (IAMA,25000)
C
C Add edges to the area map.
C
        CALL MAPBLA (IAMA)
C
C Pre-process the area map.
C
        CALL ARPRAM (IAMA,0,0,0)
C
C Compute and print the amount of space used in the area map.
C
        ISU=IAMA(1)-(IAMA(6)-IAMA(5)-1)
        PRINT * , 'SPACE USED IN AREA MAP IS ',ISU
C
C Color the map.
C
        CALL ARSCAM (IAMA,XCRA,YCRA,210,IAAI,IAGI,2,COLRAM)
C
C Flush PLOTIT's buffers and set polyline color index to black.
C
        CALL PLOTIT (0,0,0)
        CALL GSPLCI (15)
C
C In black, draw a perimeter and outline all the countries.
C
        CALL MAPSTI ('LA',0)
        CALL MAPSTI ('MV',1)
        CALL MAPLBL
        CALL MAPLOT
C
C Draw lines of latitude and longitude over water.
C
        CALL MAPGRM (IAMA,XCRA,YCRA,210,IAAI,IAGI,2,COLRLN)
C
C Advance the frame.
C
        CALL FRAME
C
C Done.
C
        IERR=0
        WRITE (6,1001)
C
        RETURN
C
 1001   FORMAT ('  EZMAPA TEST EXECUTED--SEE PLOTS TO CERTIFY')
C
      END



      SUBROUTINE COLRAM (XCRA,YCRA,NCRA,IAAI,IAGI,NGPS)
C
        DIMENSION XCRA(*),YCRA(*),IAAI(*),IAGI(*)
C
C This is the routine that color-fills the areas defined by the area map.
C First, ITMP is set non-zero if and only if no area identifiers for the
C area are negative.
C
        ITMP=1
C
        DO 101 I=1,NGPS
          IF (IAAI(I).LT.0) ITMP=0
  101   CONTINUE
C
C Then, if ITMP is non-zero (which says that we really do want to color-
C fill the area) ...
C
        IF (ITMP.NE.0) THEN
C
C set ITMP to equal to the value of the area identifier for the area
C relative to group 1 and ...
C
          ITMP=0
C
          DO 102 I=1,NGPS
            IF (IAGI(I).EQ.1) ITMP=IAAI(I)
  102     CONTINUE
C
C if that area identifier is greater than zero, ...
C
          IF (ITMP.GT.0) THEN
C
C find the index of the suggested color for the area, set the fill area
C color index, and fill the area.
C
            CALL GSFACI (MAPACI(ITMP))
C
            CALL GFA (NCRA-1,XCRA,YCRA)
C
          END IF
C
        END IF
C
        RETURN
C
      END



      SUBROUTINE COLRLN (XCRA,YCRA,NCRA,IAAI,IAGI,NGPS)
C
        DIMENSION XCRA(*),YCRA(*),IAAI(*),IAGI(*)
C
C This is the routine that draws lines of latitude and longitude over
C water only.  First, ITMP is set non-zero if and only if no area
C identifiers for the area are negative.
C
        ITMP=1
C
        DO 101 I=1,NGPS
          IF (IAAI(I).LT.0) ITMP=0
  101   CONTINUE
C
C Then, if ITMP is non-zero (which says that we really do want to draw
C things in the area) ...
C
        IF (ITMP.NE.0) THEN
C
C set ITMP to equal to the value of the area identifier for the area
C relative to group 1 (EZMAP lines) ...
C
          ITMP=0
C
          DO 102 I=1,NGPS
            IF (IAGI(I).EQ.1) ITMP=IAAI(I)
  102     CONTINUE
C
C if the suggested color for the area implies that it is over water
C (the color index 1 is used only for water) ...
C
          IF (MAPACI(ITMP).EQ.1) THEN
C
C flush PLOTIT's buffers, set the polyline color index to black, and
C draw the line.
C
            CALL PLOTIT (0,0,0)
            CALL GSPLCI (15)
C
            CALL GPL (NCRA,XCRA,YCRA)
C
          END IF
C
        END IF
C
        RETURN
C
      END

C
C	$Id: gflas3.f,v 1.6 2008-07-27 00:17:13 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GFLAS3(INAME)
C
C_BEGIN PROLOGUE GFLAS3
C
C_PURPOSE
C    A call to this subroutine will insert all plotting instructions
C    saved in a previous GFLAS1/GFLAS2 sequence (with identifier
C    INAME) into the output pipeline.
C
C_DESCRIPTION
C    A call to this subroutine will insert all plotting instructions
C    saved in a previous GFLAS1/GFLAS2 sequence (with identifier
C    INAME) into the output pipeline.  The plotting instructions
C    saved in the previous GFLAS1/GFLAS2 sequence are displayed
C    exactly as they were created.
C
C_ARGUMENTS
C
C INAME   (INPUT,SINGLE,VARIABLE)  An integer variable in the range
C         [0,99] which is used as a user-defined identifier for the
C         dataset of graphics instructions to be inserted into the
C         output pipeline.  This identifier must be an identifier
C         which was used either as an argument to a previous GFLAS1
C         call, or, if one is using the NCAR GKS package, a previous
C         GFLAS4 call.
C
C_I/O
C    GFLAS3 writes the plotting instructions saved in a previous
C    GFLAS1/GFLAS2 sequence to all active worksations.  If one is
C    using the NCAR GKS package, this results in opening the file
C    created by GFLAS1, reading all records from that file and 
C    writing them to the output files, and closing the input file.
C
C_ROUTINES CALLED
C    PLOTIT, SETER
C
C_COMMON BLOCKS
C    GFLASH
C
C_MAXIMUM GKS LEVEL
C    2A
C
C_LANGUAGE
C    FORTRAN
C
C_REVISION DATE
C    890117 (YYMMDD)
C
C_HISTORY
C    This subroutine was coded at NCAR by Fred Clare.  Its purpose
C    is to duplicate the functionality of the previous NCAR System
C    Plot Package entry FLASH3 in a GKS environment.
C
C_REFERENCES
C    "The System Plot Package", NCAR Technical Note number
C    NCAR-TN/162+IA, May, 1983.
C
C    "NCAR Graphics User's Guide", Version 2.00, NCAR Technical Note
C    number NCAR/TN-283+IA, August, 1987.
C
C_LONG DESCRIPTION
C    A call to GFLAS3 will insert all the instructions saved in
C    a previous GFLAS1/GFLAS2 sequence into the output pipeline.
C    The instructions are an exact snapshot of what would have
C    been sent to an active workstation if it had been active
C    during the GFLAS1/GFLAS2 sequence.  A call to GFLAS3 is not
C    affected by the clipping rectangle in effect at the time
C    GFLAS3 is called, nor does a call to GFLAS3 have any effect
C    on the currently active clipping rectangle.  Similarly, a
C    call to GFLAS3 has no effect on the current state of GKS
C    attributes.
C
C_EXAMPLES
C    Example 1 --  Save a text string in a flash buffer and insert
C                  it into the output pipeline.
C          SUBROUTINE SVTXT
C          CALL GFLAS1(9)
C          CALL GTX(.5,.5,'STRING')
C          CALL GFLAS2
C          CALL GFLAS3(9)
C          RETURN
C          END
C
C_END PROLOGUE GFLAS3
C
C---------------------------------------------------------------
C
C  Common for FLASH package.
C
      COMMON /GFLASH/MODEF,IOPWKS(100),IOACT(100),NUMOP,IWISSI
C
C     CHARACTER*80 IDR(1),ODR(1)
C
      SAVE
C
C  Check on proper mode value.
C
      IF (MODEF .LT. 2) GO TO 101
C
C  Set mode flag.
C
      MODEF = 3
C
C  Copy the named segment to all currently active workstations of
C  type output, output/input, or metafile output.
C
      CALL GQACWK(1,IER,IAL,ID)
      DO 20 I=1,IAL
      CALL GQACWK(I,IER,IAL,ID)
      CALL GQWKC(ID,IER,ICON,IT)
      CALL GQWKCA(IT,IER,ICAT)
      IF (ICAT.EQ.0 .OR. ICAT.EQ.2 .OR. ICAT.EQ.4) THEN
C
C  Force a new picture initialization if necessary.
C
C       WRITE(IDR(1),110) ID
C 110   FORMAT('2',I8)
C       IFID = -1394
        CALL PLOTIT(0,0,2)
C       CALL GESC(IFID,1,IDR,1,IDUM,ODR)
        CALL GCSGWK(ID,INAME)
        CALL PLOTIT(0,0,2)
      ENDIF
   20 CONTINUE
      RETURN
C
  101 CONTINUE
      CALL GECLKS
      CALL SETER(' GFLAS3 -- GFLAS3 CALLED WITHOUT CALLING GFLAS2 OR GFL
     -AS4',7,2)
      STOP
C
      END

C
C	$Id: wmlgnd.f,v 1.7 2008-07-27 00:17:37 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE WMLGND(X,Y,NTYPE,IROWS,ICOLS)
C
C  Subroutine for producing legends. NTYPE specifies what legends 
C  are to be drawn:
C
C    NTYPE = 1  Plot the legend for the weather types.  There are 
C               six weather types: showers; T-storms; rain; flurries; 
C               snow; ice.  The coordinate (X,Y) for this type
C               specifies the lower left corner of the legend.
C          = 2  Plot the legend for the front types.  There are 
C               three front types: cold; warm; stationary.  The
C               (X,Y) coordinate for this legend specifies the
C               lower right corner of the legend.
C          = 3  Plot the explanatory legend.  The (X,Y) coordinate
C               for this legend specifies the bottom center of the
C               legend.
C
C  IROWS and ICOLS specify how many rows and columns there should
C  be in displaying the weather types, these values are significant
C  only when NTYPE=1.  Choices for IROWSxICOLS are: 1x6, 2x3, 3x2,
C  and 6x1.
C
      include 'wmcomn.h'
C
      DIMENSION XB(5),YB(5),XF(5),YF(5),IFNT(6),ICHR(6)
      CHARACTER*8  LBSW(6)
      CHARACTER*10 LBSF(3)
      INTEGER WMGTLN
      DATA XB/0.0, 3.0, 3.0, 0.0, 0.0/
      DATA YB/0.0, 0.0, 1.3, 1.3, 0.0/
      DATA IFNT/ 37, 37, 37, 37, 37, 37/
      DATA ICHR/102,101,103,106,104,105/
      DATA LBSW/'T-storms','Showers','Rain','Flurries','Snow','Ice'/
      DATA LBSF/'Stationary','Warm','Cold'/
C
C  Convert the input coordinate to NDC.
C
      IF (IROWS .EQ. 0) THEN
        NROWS = 6
        NCOLS = 1
      ELSE
        NROWS = IROWS
        NCOLS = ICOLS
      ENDIF
C
      CALL WMW2NX(1,X,XN)
      CALL WMW2NY(1,Y,YN)
C
C  Save the current normalization transformation number, and select
C  transformation 0.
C
      CALL GQCNTN(IER,NTRO)
      CALL GSELNT(0)
      CALL GQPLCI(IER,IPLCO)
      CALL GQFACI(IER,IFACO)
      CALL GQFAIS(IER,ISTOLD)
      CALL GSFAIS(1)
      CALL GSFACI(ICOLOR)
      CALL GSPLCI(ICOLOR)
      CALL PCGETI('FN',IFNO)
      CALL PCSETI('FN',21)
      CALL PCGETI('CC',ICOLD)
      CALL PCSETI('CC',ICOLOR)
C
C  Weather types.
C
      IF (NTYPE.EQ.1) THEN
        DO 30 K=1,NCOLS
          DO 20 J=1,NROWS
            NDX = J+(K-1)*NROWS
            DO 10 I=1,5
              XF(I) = XN+(K-1)*3.2*XB(3)*WSIZEW+WSIZEW*XB(I)
              YF(I) = YN+(J-1)*1.40*YB(3)*WSIZEW+WSIZEW*YB(I)
   10       CONTINUE
            CALL WMRGWT(5,XF,YF,IFNT(NDX),ICHR(NDX))
            CALL GPL(5,XF,YF)
            CALL PLCHHQ(XF(2)+0.01,0.5*(YF(2)+YF(3)),LBSW(NDX),
     +                  0.75*WSIZEW,0.,-1.)
   20     CONTINUE
   30   CONTINUE
      ENDIF
C
C  Fronts.
C
      IF (NTYPE .EQ. 2) THEN
C
C    Top label.
        OFFLB = 6.0*WSIZEW
        YPOS = YN+WSIZEW+4.3*YB(3)*WSIZEW
        CALL PCGETI ('BF - BOX FLAG',IBFO)
        CALL PCGETR ('BM - BOX MARGIN',BMO)
        CALL PCGETI ('BC(2) - BOX COLOR - BOX FILL       ',IBC2)
        CALL PCSETI ('BF - BOX FLAG',2)
        CALL PCSETR ('BM - BOX MARGIN',1.5)
        CALL PCSETI ('BC(2) - BOX COLOR - BOX FILL       ',0)
        CALL PLCHHQ(XN-0.5*OFFLB,YPOS,'Fronts',0.75*WSIZEW,0.,0.)       
        CALL PCSETI ('BF - BOX FLAG',IBFO)
        CALL PCSETR ('BM - BOX MARGIN',BMO)
        CALL PCSETI ('BC(2) - BOX COLOR - BOX FILL       ',IBC2)
C
        CALL WMGETR('SWI',SWIOLD)
        CALL WMGETR('LIN',WLOLD)
        CALL WMGETR('END',ENDO)
        CALL WMGETR('BEG',BEGO)
        CALL WMGETR('BET',BETO)
        CALL WMSETR('SWI',1.2*WSIZEW)
        CALL WMSETR('LIN',0.75*WLOLD)
        CALL WMSETR('END',.006)
        CALL WMSETR('BEG',.006)
        CALL WMSETR('BET',.009)
C
C    Example fronts
        XF(1) = XN-OFFLB
        XF(2) = XN 
        DO 40 I=1,3
          YPOS = YN+WSIZEW+(I-1)*1.5*YB(3)*WSIZEW
          YF(1) = YPOS
          YF(2) = YPOS
          LL = WMGTLN(LBSF(I),LEN(LBSF(1)),0)
          CALL WMSETC('FRO',LBSF(I))
          IF (I.EQ.1 .OR. I.EQ.2) CALL WMSETI('REV',1)
          CALL WMDRFT(2,XF,YF)
          CALL PLCHHQ(XF(1)-0.01,YPOS,LBSF(I)(1:LL),0.75*WSIZEW,0.,1.)       
   40   CONTINUE
        CALL WMSETR('SWI',SWIOLD)
        CALL WMSETR('LIN',WLOLD)
        CALL WMSETR('END',ENDO)
        CALL WMSETR('BEG',BEGO)
        CALL WMSETR('BET',BETO)
      ENDIF
C
C  Explanatory legend.
C
      IF (NTYPE .EQ. 3) THEN
        CALL PLCHHQ(XN,YN+.95*WSIZEW,'Forecast high/low temperatures are       
     + given for selected cities.',0.70*WSIZEW,0.,0.)
        CALL PLCHHQ(XN,YN+2.3*WSIZEW,'precipitation.  Temperature bands 
     +are highs for the day.',0.70*WSIZEW,0.,0.)
        CALL PLCHHQ(XN,YN+3.6*WSIZEW,'Shown are noon positions of weathe
     +r systems and',0.70*WSIZEW,0.,0.)
      ENDIF
C
C  Restore original settings.
C
      CALL GSELNT(NTRO)
      CALL PCSETI('FN',IFNO)
      CALL PCSETI('CC',ICOLD)
      CALL GSFAIS(ISTOLD)
      CALL GSPLCI(IPLCO)
      CALL GSFACI(IFACO)
C
      RETURN
      END

C
C       $Id: vvseti.f,v 1.6.8.1 2010-03-17 20:51:58 brownrig Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
C
C-----------------------------------------------------------------------
C
      SUBROUTINE VVSETI (CNM,IVL)
C
      CHARACTER*(*) CNM
      INTEGER IVL
C
C This subroutine is called to give a specified integer value to a
C specified parameter.
C
C CNM is the name of the parameter whose value is to be set.
C
C IVL is an integer variable containing the new value of the parameter.
C
C RLB 3/2010: Previously the integer parameter was converted to a float
C   and the work was delegated off to VVSETR. This provided a sort
C   of "automatic type conversion", allowing the user to set a real
C   parameter using either vvseti() or vvsetr(), as in:
C        CALL VVSETI ('USV - U Array Special Value',-9999)
C     or
C        CALL VVSETR ('USV - U Array Special Value',-9999.0)
C
C   Color-indices are now either encoded RGBa values, or indices as
C   before. RGBa values are typically large integer values, beyond the
C   precision of floats, and thus this delegation scheme no longer
C   works correctly. The code has been refactored such that the integer
C   cases are now handled directly herein. If no action is found for
C   the CNM, then we delegate over to VVSETR.
C --------------------------------------------------------------------
C
C NOTE:
C Since implicit typing is used for all real and integer variables
C a consistent length convention has been adopted to help clarify the
C significance of the variables encountered in the code for this
C utility. All local variable and subroutine parameter identifiers
C are limited to 1,2,or 3 characters. Four character names identify
C members of common blocks. Five and 6 character variable names
C denote PARAMETER constants or subroutine or function names.
C
C Declare the VV common blocks.
C
C IPLVLS - Maximum number of color threshold level values
C IPAGMX - Maximum number of area groups allowed in the area map
C
      PARAMETER (IPLVLS = 256, IPAGMX = 64)
C
C Integer and real common block variables
C
C
      COMMON /VVCOM/
     +                IUD1       ,IVD1       ,IPD1       ,IXDM       ,
     +                IYDN       ,VLOM       ,VHIM       ,ISET       ,
     +                VRMG       ,VRLN       ,VFRC       ,IXIN       ,
     +                IYIN       ,ISVF       ,UUSV       ,UVSV       ,
     +                UPSV       ,IMSK       ,ICPM       ,UVPS       ,
     +                UVPL       ,UVPR       ,UVPB       ,UVPT       ,
     +                UWDL       ,UWDR       ,UWDB       ,UWDT       ,
     +                UXC1       ,UXCM       ,UYC1       ,UYCN       ,
     +                NLVL       ,IPAI       ,ICTV       ,WDLV       ,
     +                UVMN       ,UVMX       ,PMIN       ,PMAX       ,
     +                RVMN       ,RVMX       ,RDMN       ,RDMX       ,
     +                ISPC       ,RVMD       ,IPLR       ,IVST       ,
     +                IVPO       ,ILBL       ,IDPF       ,IMSG       ,
     +                ICLR(IPLVLS)           ,TVLU(IPLVLS)
C
C Arrow size/shape parameters
C
        COMMON / VVARO /
     +                HDSZ       ,HINF       ,HANG       ,IAST       ,
     +                HSIN       ,HCOS       ,FAMN       ,FAMX       ,
     +                UVMG       ,FAIR       ,FAWR       ,FAWF       ,
     +                FAXR       ,FAXF       ,FAYR       ,FAYF       ,
     +                AROX(8)    ,AROY(8)    ,FXSZ       ,FYSZ       ,
     +                FXRF       ,FXMN       ,FYRF       ,FYMN       ,
     +                FWRF       ,FWMN       ,FIRF       ,FIMN       ,
     +                AXMN       ,AXMX       ,AYMN       ,AYMX       ,
     +                IACM       ,IAFO       ,WBAD       ,WBTF       ,
     +                WBCF       ,WBDF       ,WBSC
C
C
C Text related parameters
C
        COMMON /VVTXP /
     +                FCWM    ,ICSZ    ,
     +                FMNS    ,FMNX    ,FMNY    ,IMNP    ,IMNC  ,
     +                FMXS    ,FMXX    ,FMXY    ,IMXP    ,IMXC  ,
     +                FZFS    ,FZFX    ,FZFY    ,IZFP    ,IZFC  ,
     +                FILS    ,FILX    ,FILY    ,IILP    ,IILC  ,
     +                FLBS    ,ILBC

C
C Character variable declartions
C
      CHARACTER*160 CSTR
      PARAMETER (IPCHSZ=36)
      CHARACTER*(IPCHSZ)  CMNT,CMXT,CZFT,CLBT,CILT
C
C Text string parameters
C
      COMMON /VVCHAR/ CSTR,CMNT,CMXT,CZFT,CLBT,CILT
C
      SAVE /VVCOM/, /VVARO/, /VVTXP/, /VVCHAR/
C
C The mapping common block: made available to user mapping routines
C
      COMMON /VVMAP/
     +                IMAP       ,
     +                XVPL       ,XVPR       ,YVPB       ,YVPT       ,
     +                WXMN       ,WXMX       ,WYMN       ,WYMX       ,
     +                XLOV       ,XHIV       ,YLOV       ,YHIV       ,
     +                SXDC       ,SYDC       ,NXCT       ,NYCT       ,
     +                RLEN       ,LNLG       ,INVX       ,INVY       ,
     +                ITRT       ,IWCT       ,FW2W       ,FH2H       ,
     +                DVMN       ,DVMX       ,RBIG       ,IBIG
C
      SAVE /VVMAP/
C --------------------------------------------------------------------
C
C Check for a parameter name that is too short.
C
      IF (LEN(CNM).LT.3) THEN
        CSTR(1:46)='VVSETI - PARAMETER NAME TOO SHORT - '
        CSTR(47:46+LEN(CNM))=CNM
        CALL SETER (CSTR(1:46+LEN(CNM)),1,1)
        RETURN
      END IF
C
C Check for incorrect use of the index parameter.
C
      IF (CNM(1:3).EQ.'CLR'.OR.CNM(1:3).EQ.'clr') THEN
         IF (IPAI.LT.1.OR.IPAI.GT.IPLVLS) THEN
            CSTR(1:46)='VVSETI - SETTING XXX - PAI INCORRECT'
            CSTR(28:30)=CNM(1:3)
            CALL SETER (CSTR(1:46),2,1)
            RETURN
         END IF
      END IF

C
C Set the appropriate parameter value.
C
C Values in VVCOM
C
      IF (CNM(1:3).EQ.'UD1'.OR. CNM(1:3).EQ.'ud1') THEN
         IUD1=IVL
      ELSE IF (CNM(1:3).EQ.'VD1'.OR. CNM(1:3).EQ.'vd1') THEN
         IVD1=IVL
      ELSE IF (CNM(1:3).EQ.'PD1'.OR. CNM(1:3).EQ.'pd1') THEN
         IPD1=IVL
      ELSE IF (CNM(1:3).EQ.'XDM'.OR. CNM(1:3).EQ.'xdm') THEN
         IXDM=IVL
      ELSE IF (CNM(1:3).EQ.'YDN'.OR. CNM(1:3).EQ.'ydn') THEN
         IYDN=IVL
      ELSE IF (CNM(1:3).EQ.'SET'.OR. CNM(1:3).EQ.'set') THEN
         ISET=IVL
      ELSE IF (CNM(1:3).EQ.'XIN'.OR. CNM(1:3).EQ.'xin') THEN
         IXIN=IVL
      ELSE IF (CNM(1:3).EQ.'YIN'.OR. CNM(1:3).EQ.'yin') THEN
         IYIN=IVL
      ELSE IF (CNM(1:3).EQ.'SVF'.OR. CNM(1:3).EQ.'svf') THEN
         ISVF=IVL
      ELSE IF (CNM(1:3).EQ.'MSK'.OR. CNM(1:3).EQ.'msk') THEN
         IMSK=IVL
      ELSE IF (CNM(1:3).EQ.'CPM'.OR. CNM(1:3).EQ.'cpm') THEN
         ICPM=IVL
      ELSE IF (CNM(1:3).EQ.'NLV'.OR.CNM(1:3).EQ.'nlv') THEN
         NLVL=MIN(IPLVLS,IVL)
      ELSE IF (CNM(1:3).EQ.'PAI'.OR.CNM(1:3).EQ.'pai') THEN
         IF (IVL .LT. 1 .OR. IVL .GT. IPLVLS) GO TO 9800
         IPAI=IVL
      ELSE IF (CNM(1:3).EQ.'CTV'.OR.CNM(1:3).EQ.'ctv') THEN
         ICTV=IVL
C
C UVMN,UVMX, PMIN, PMAX are read-only
C
      ELSE IF (CNM(1:3).EQ.'SPC'.OR. CNM(1:3).EQ.'spc') THEN
         ISPC=IVL
      ELSE IF (CNM(1:3).EQ.'MAP'.OR. CNM(1:3).EQ.'map') THEN
         IMAP=IVL
      ELSE IF (CNM(1:3).EQ.'PLR'.OR. CNM(1:3).EQ.'plr') THEN
         IPLR=IVL
      ELSE IF (CNM(1:3).EQ.'VST'.OR. CNM(1:3).EQ.'vst') THEN
         IVST=IVL
      ELSE IF (CNM(1:3).EQ.'VPO'.OR. CNM(1:3).EQ.'vpo') THEN
         IVPO=IVL
      ELSE IF (CNM(1:3).EQ.'LBL'.OR. CNM(1:3).EQ.'lbl') THEN
         ILBL=IVL
      ELSE IF (CNM(1:3).EQ.'DPF'.OR. CNM(1:3).EQ.'dpf') THEN
         IDPF=IVL
C
C arrow parameters
C
      ELSE IF (CNM(1:3).EQ.'AST'.OR.CNM(1:3).EQ.'ast') THEN
         IAST=IVL
      ELSE IF (CNM(1:3).EQ.'ACM'.OR.CNM(1:3).EQ.'acm') THEN
         IACM=IVL
      ELSE IF (CNM(1:3).EQ.'AFO'.OR.CNM(1:3).EQ.'afo') THEN
         IAFO=IVL
C
C character attributes
C
      ELSE IF (CNM(1:3).EQ.'MNP'.OR. CNM(1:3).EQ.'mnp') THEN
         IMNP=IVL
      ELSE IF (CNM(1:3).EQ.'MNC'.OR. CNM(1:3).EQ.'mnc') THEN
         IMNC=IVL
C
      ELSE IF (CNM(1:3).EQ.'MXP'.OR. CNM(1:3).EQ.'mxp') THEN
         IMXP=IVL
      ELSE IF (CNM(1:3).EQ.'MXC'.OR. CNM(1:3).EQ.'mxc') THEN
         IMXC=IVL
C
      ELSE IF (CNM(1:3).EQ.'ZFP'.OR. CNM(1:3).EQ.'zfp') THEN
         IZFP=IVL
      ELSE IF (CNM(1:3).EQ.'ZFC'.OR. CNM(1:3).EQ.'zfc') THEN
         IZFC=IVL
C
      ELSE IF (CNM(1:3).EQ.'LBC'.OR. CNM(1:3).EQ.'lbc') THEN
         ILBC=IVL
C
      ELSE IF (CNM(1:3).EQ.'ILP'.OR. CNM(1:3).EQ.'ilp') THEN
         IILP=IVL
      ELSE IF (CNM(1:3).EQ.'ILC'.OR. CNM(1:3).EQ.'ilc') THEN
         IILC=IVL
C
C     color field parameters
C
      ELSE IF (CNM(1:3).EQ.'CLR'.OR.CNM(1:3).EQ.'clr') THEN
         ICLR(IPAI)=IVL
      ELSE IF (CNM(1:3).EQ.'TRT'.OR. CNM(1:3).EQ.'trt') THEN
         ITRT=IVL
      ELSE
C        convert to real and delegate
         RVL = REAL(IVL)
         CALL VVSETR(CNM, RVL)
      END IF
C
      GOTO 9900
C
 9800 CONTINUE
C
      CSTR(1:50)='VVSETI - PARAMETER VALUE OUT OF RANGE - '
      CSTR(51:53)=CNM(1:3)
      CALL SETER (CSTR(1:53),4,1)
      RETURN
C
 9900 CONTINUE
C
C Done.
C
      RETURN
      END

C
C $Id: dmspsp.f,v 1.5 2008-07-27 00:17:08 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      REAL FUNCTION DMSPSP (SGNA,DEGS,MINS,SECS)
C
C FUNCTION TO CONVERT UNPACKED DMS TO PACKED DMS ANGLE
C SGNA : SIGN OF ANGLE
C DEGS : DEGREES PORTION OF ANGLE
C MINS : MINUTES PORTION OF ANGLE
C SECS : SECONDS PORTION OF ANGLE
C
      IMPLICIT REAL (A-Z)
      REAL SECS
      INTEGER DEGS,MINS
      CHARACTER*1 SGNA,NEG
      DATA CON1,CON2 /1000000.0E0,1000.0E0/
      DATA NEG /'-'/
C
      CON = DEGS * CON1 + MINS * CON2 + SECS
      IF (SGNA .EQ. NEG) CON = - CON
      DMSPSP = CON
      RETURN
C
      END

C
C $Id: seradp.f,v 1.5 2008-07-27 00:17:12 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE SERADP (FB,FA2,FA4,FC1,FC3,LAM)
C
C     COMPUTES INTEGRAL FUNCTION OF TRANSFORMED LONG. FOR FOURIER
C     CONSTANTS A2, A4, B, C1, AND C3.
C     LAM IS INTEGRAL VALUE OF TRANSFORMED LONG.
C
      IMPLICIT DOUBLE PRECISION (A-Z)
      COMMON /NORMDP/ Q,T,U,W,ES,P22,SA,CA,XJ
      DATA DG1 /0.01745329252D0/
      DATA ONE,TWO /1.0D0,2.0D0/
      LAM=LAM*DG1
      SD=SIN(LAM)
      SDSQ=SD*SD
      S=P22*SA*COS(LAM)*SQRT((ONE+T*SDSQ)/((ONE+W*SDSQ)
     .  *(ONE+Q*SDSQ)))
      H=SQRT((ONE+Q*SDSQ)/(ONE+W*SDSQ))*(((ONE+W*SDSQ)/
     .   ((ONE+Q*SDSQ)**TWO))-P22*CA)
      SQ=SQRT(XJ*XJ+S*S)
      FB=(H*XJ-S*S)/SQ
      FA2=FB*COS(TWO*LAM)
      FA4=FB*COS(4.0D0*LAM)
      FC=S*(H+XJ)/SQ
      FC1=FC*COS(LAM)
      FC3=FC*COS(3.0D0*LAM)
      RETURN
      END

C
C $Id: cmfx.f,v 1.7 2008-07-27 00:17:23 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      FUNCTION CMFX (IX)
C
C Given an X coordinate IX in the metacode system, CMFX(IX) is an X
C coordinate in the fractional system.
C
      CMFX=REAL(IX)/32767.
      RETURN
      END

C
C	$Id: gflas2.f,v 1.5 2008-07-27 00:17:13 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GFLAS2
C
C_BEGIN PROLOGUE GFLAS2
C
C_PURPOSE
C    A call to this subroutine flags termination of output of
C    plotting instructions to Workstation Independent Segment
C    Storage as initiated by a previous call to GFLAS1.
C
C_DESCRIPTION
C    A call to this subroutine flags termination of output of
C    plotting instructions to Workstation Independent Segment
C    Storage (WISS) as initiated by a previous call to GFLAS1.
C
C_ARGUMENTS
C
C (None)
C
C_I/O
C    GFLAS2 terminates output to WISS.  If using the NCAR GKS
C    package, the output file which was opened with GFLAS1 is
C    closed.
C
C_ROUTINES CALLED
C    PLOTIT, SETER
C
C_COMMON BLOCKS
C    GFLASH
C
C_MAXIMUM GKS LEVEL
C    2A
C
C_LANGUAGE
C    FORTRAN
C
C_REVISION DATE
C    890117 (YYMMDD)
C
C_HISTORY
C    This subroutine was coded at NCAR by Fred Clare.  Its purpose
C    is to duplicate the functionality of the previous NCAR System
C    Plot Package entry FLASH2 in a GKS environment.
C
C_REFERENCES
C    "The System Plot Package", NCAR Technical Note number
C    NCAR-TN/162+IA, May, 1983.
C
C    "NCAR Graphics User's Guide", Version 2.00, NCAR Technical Note
C    number NCAR/TN-283+IA, August, 1987.
C
C_LONG DESCRIPTION
C    GFLAS2 deactivates WISS and re-activates all workstations
C    which were active before the call to GFLAS1 which initiated
C    the current GFLAS1/GFLAS2 sequence.  This results in all
C    subsequent plotting instructions being sent to all workstations
C    which were active prior to the current GFLAS1/GFLAS2 sequence.
C    If one is using the NCAR GKS package, the output file GFBNnn
C    is closed (where "nn" is the value of the argument to GFLAS1
C    in the current GFLAS1/GFLAS2 sequence.)
C
C    It is not legal to call FRAME (or clear workstations) between a
C    GFLAS1 call and a GFLAS2 call.
C
C_EXAMPLES
C    Example 1 --  Save a text string in a flash buffer (see GFLAS1
C                  for usage of that subroutine.)
C          SUBROUTINE SVTXT
C          CALL GFLAS1(9)
C          CALL GTX(.5,.5,'STRING')
C          CALL GFLAS2
C          RETURN
C          END
C
C_END PROLOGUE GFLAS2
C
C-------------------------------------------------------------------------
C
C  Common for FLASH package.
C
      COMMON /GFLASH/MODEF,IOPWKS(100),IOACT(100),NUMOP,IWISSI
C     CHARACTER*80 IDR(1),ODR(1)
C
      SAVE
C
C  Check on proper mode value.
C
      IF (MODEF .NE. 1) GO TO 101
      MODEF = 2
C
C  Flush the PLOTIT buffer.
C
      CALL PLOTIT(0,0,0)
C
      CALL GCLSG
C
C  Restore workstation states to what they were before call to
C  GFLAS1.  If WISS was not active, deactivate it since GFLAS1
C  made it active; reactivate all other previously active
C  workstations.
C
C
C  Determine the index of WISS.
C
      DO 20 I=1,NUMOP
      IF (IOPWKS(I) .EQ. IWISSI) THEN
        NWISS = I
        GO TO 30
      ENDIF
   20 CONTINUE
      GO TO 102
   30 CONTINUE
C
C  Deactive WISS if it was not active before call to GFLAS1.
C
      IF (IOACT(NWISS) .EQ. 0) CALL GDAWK(IWISSI)
C
C  Handle non-WISS workstations.
C
      DO 10 I=1,NUMOP
      IF (IOPWKS(I).NE.IWISSI .AND. IOACT(I).EQ.1) CALL GACWK(IOPWKS(I))
   10 CONTINUE
C
C  Inform NCAR GKS that we are finished in GFLAS2
C
C     IDR(1) = '0'
C     IFID = -1394
C     CALL PLOTIT(0,0,2)
C     CALL GESC(IFID,1,IDR,1,IDUM,ODR)
C
      RETURN
C
  101 CONTINUE
      CALL GECLKS
      CALL SETER(' GFLAS2 -- GFLAS2 CALLED WITHOUT CALLING GFLAS1',6,2)
      STOP
  102 CONTINUE
      CALL GECLKS
      CALL SETER(' GFLAS2 -- WISS NOT OPEN AT GFLAS2 TIME',8,2)
      STOP
C
      END

      SUBROUTINE CHBEV( JOBZ, UPLO, N, KD, AB, LDAB, W, Z, LDZ, WORK,
     $                  RWORK, INFO )
*
*  -- LAPACK driver routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          JOBZ, UPLO
      INTEGER            INFO, KD, LDAB, LDZ, N
*     ..
*     .. Array Arguments ..
      REAL               RWORK( * ), W( * )
      COMPLEX            AB( LDAB, * ), WORK( * ), Z( LDZ, * )
*     ..
*
*  Purpose
*  =======
*
*  CHBEV computes all the eigenvalues and, optionally, eigenvectors of
*  a complex Hermitian band matrix A.
*
*  Arguments
*  =========
*
*  JOBZ    (input) CHARACTER*1
*          = 'N':  Compute eigenvalues only;
*          = 'V':  Compute eigenvalues and eigenvectors.
*
*  UPLO    (input) CHARACTER*1
*          = 'U':  Upper triangle of A is stored;
*          = 'L':  Lower triangle of A is stored.
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  KD      (input) INTEGER
*          The number of superdiagonals of the matrix A if UPLO = 'U',
*          or the number of subdiagonals if UPLO = 'L'.  KD >= 0.
*
*  AB      (input/output) COMPLEX array, dimension (LDAB, N)
*          On entry, the upper or lower triangle of the Hermitian band
*          matrix A, stored in the first KD+1 rows of the array.  The
*          j-th column of A is stored in the j-th column of the array AB
*          as follows:
*          if UPLO = 'U', AB(kd+1+i-j,j) = A(i,j) for max(1,j-kd)<=i<=j;
*          if UPLO = 'L', AB(1+i-j,j)    = A(i,j) for j<=i<=min(n,j+kd).
*
*          On exit, AB is overwritten by values generated during the
*          reduction to tridiagonal form.  If UPLO = 'U', the first
*          superdiagonal and the diagonal of the tridiagonal matrix T
*          are returned in rows KD and KD+1 of AB, and if UPLO = 'L',
*          the diagonal and first subdiagonal of T are returned in the
*          first two rows of AB.
*
*  LDAB    (input) INTEGER
*          The leading dimension of the array AB.  LDAB >= KD + 1.
*
*  W       (output) REAL array, dimension (N)
*          If INFO = 0, the eigenvalues in ascending order.
*
*  Z       (output) COMPLEX array, dimension (LDZ, N)
*          If JOBZ = 'V', then if INFO = 0, Z contains the orthonormal
*          eigenvectors of the matrix A, with the i-th column of Z
*          holding the eigenvector associated with W(i).
*          If JOBZ = 'N', then Z is not referenced.
*
*  LDZ     (input) INTEGER
*          The leading dimension of the array Z.  LDZ >= 1, and if
*          JOBZ = 'V', LDZ >= max(1,N).
*
*  WORK    (workspace) COMPLEX array, dimension (N)
*
*  RWORK   (workspace) REAL array, dimension (max(1,3*N-2))
*
*  INFO    (output) INTEGER
*          = 0:  successful exit.
*          < 0:  if INFO = -i, the i-th argument had an illegal value.
*          > 0:  if INFO = i, the algorithm failed to converge; i
*                off-diagonal elements of an intermediate tridiagonal
*                form did not converge to zero.
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ZERO, ONE
      PARAMETER          ( ZERO = 0.0E0, ONE = 1.0E0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            LOWER, WANTZ
      INTEGER            IINFO, IMAX, INDE, INDRWK, ISCALE
      REAL               ANRM, BIGNUM, EPS, RMAX, RMIN, SAFMIN, SIGMA,
     $                   SMLNUM
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      REAL               CLANHB, SLAMCH
      EXTERNAL           LSAME, CLANHB, SLAMCH
*     ..
*     .. External Subroutines ..
      EXTERNAL           CHBTRD, CLASCL, CSTEQR, SSCAL, SSTERF, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          SQRT
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      WANTZ = LSAME( JOBZ, 'V' )
      LOWER = LSAME( UPLO, 'L' )
*
      INFO = 0
      IF( .NOT.( WANTZ .OR. LSAME( JOBZ, 'N' ) ) ) THEN
         INFO = -1
      ELSE IF( .NOT.( LOWER .OR. LSAME( UPLO, 'U' ) ) ) THEN
         INFO = -2
      ELSE IF( N.LT.0 ) THEN
         INFO = -3
      ELSE IF( KD.LT.0 ) THEN
         INFO = -4
      ELSE IF( LDAB.LT.KD+1 ) THEN
         INFO = -6
      ELSE IF( LDZ.LT.1 .OR. ( WANTZ .AND. LDZ.LT.N ) ) THEN
         INFO = -9
      END IF
*
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'CHBEV ', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
*
      IF( N.EQ.1 ) THEN
         IF( LOWER ) THEN
            W( 1 ) = AB( 1, 1 )
         ELSE
            W( 1 ) = AB( KD+1, 1 )
         END IF
         IF( WANTZ )
     $      Z( 1, 1 ) = ONE
         RETURN
      END IF
*
*     Get machine constants.
*
      SAFMIN = SLAMCH( 'Safe minimum' )
      EPS = SLAMCH( 'Precision' )
      SMLNUM = SAFMIN / EPS
      BIGNUM = ONE / SMLNUM
      RMIN = SQRT( SMLNUM )
      RMAX = SQRT( BIGNUM )
*
*     Scale matrix to allowable range, if necessary.
*
      ANRM = CLANHB( 'M', UPLO, N, KD, AB, LDAB, RWORK )
      ISCALE = 0
      IF( ANRM.GT.ZERO .AND. ANRM.LT.RMIN ) THEN
         ISCALE = 1
         SIGMA = RMIN / ANRM
      ELSE IF( ANRM.GT.RMAX ) THEN
         ISCALE = 1
         SIGMA = RMAX / ANRM
      END IF
      IF( ISCALE.EQ.1 ) THEN
         IF( LOWER ) THEN
            CALL CLASCL( 'B', KD, KD, ONE, SIGMA, N, N, AB, LDAB, INFO )
         ELSE
            CALL CLASCL( 'Q', KD, KD, ONE, SIGMA, N, N, AB, LDAB, INFO )
         END IF
      END IF
*
*     Call CHBTRD to reduce Hermitian band matrix to tridiagonal form.
*
      INDE = 1
      CALL CHBTRD( JOBZ, UPLO, N, KD, AB, LDAB, W, RWORK( INDE ), Z,
     $             LDZ, WORK, IINFO )
*
*     For eigenvalues only, call SSTERF.  For eigenvectors, call CSTEQR.
*
      IF( .NOT.WANTZ ) THEN
         CALL SSTERF( N, W, RWORK( INDE ), INFO )
      ELSE
         INDRWK = INDE + N
         CALL CSTEQR( JOBZ, N, W, RWORK( INDE ), Z, LDZ,
     $                RWORK( INDRWK ), INFO )
      END IF
*
*     If matrix was scaled, then rescale eigenvalues appropriately.
*
      IF( ISCALE.EQ.1 ) THEN
         IF( INFO.EQ.0 ) THEN
            IMAX = N
         ELSE
            IMAX = INFO - 1
         END IF
         CALL SSCAL( IMAX, ONE / SIGMA, W, 1 )
      END IF
*
      RETURN
*
*     End of CHBEV
*
      END

C
C $Id: agexus.f,v 1.6 2008-07-27 00:14:34 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE AGEXUS (SVAL,ZMIN,ZMAX,ZLOW,ZHGH,
     +                               ZDRA,NVIZ,IIVZ,NEVZ,IIEZ,UMIN,UMAX)
C
      DIMENSION SVAL(2),ZDRA(1)
C
C The routine AGEXUS is used by AGSTUP to determine tentative values of
C the user-window edge coordinates.  Its arguments are as follows:
C
C -- SVAL is the array of special values.
C
C -- ZMIN and ZMAX are user-supplied minimum and maximum values of the
C    data x (or y) coordinates.
C
C -- ZLOW and ZHGH are, respectively, the smallest and largest data
C    values to be considered in choosing the minimum and maximum, if
C    those values, as given by the user, are null.
C
C -- ZDRA, NVIZ, IIVZ, NEVZ, and IIEZ specify the array of x (or y)
C    data coordinates (see AGMAXI or AGMINI for complete description).
C
C -- UMIN and UMAX are returned with tentative minimum and maximum
C    values for use at the appropriate user-window edges (left/right
C    or bottom/top).
C
C The following common block contains the new variable SMLL, which is
C essentially the smallest positive real number X such that "1.+X" is
C different from "1.".  This is used for some purposes for which the
C variable SMRL was previously used.  (10/21/89)
C
      COMMON /AGORIQ/ SMLL
      SAVE /AGORIQ/
C
C Assume initially that the user has provided actual values to be used.
C
      UMIN=ZMIN
      UMAX=ZMAX
C
C If either of the values is null, replace it by a data-based value.
C
      IF (UMIN.EQ.SVAL(1).OR.UMIN.EQ.SVAL(2))
     +                UMIN=AGMINI(SVAL(1),ZLOW,ZDRA,NVIZ,IIVZ,NEVZ,IIEZ)
      IF (UMAX.EQ.SVAL(1).OR.UMAX.EQ.SVAL(2))
     +                UMAX=AGMAXI(SVAL(1),ZHGH,ZDRA,NVIZ,IIVZ,NEVZ,IIEZ)
C
C Either or both values might still be null (if the user data was null).
C
      IF (UMIN.EQ.SVAL(1)) UMIN=UMAX
      IF (UMAX.EQ.SVAL(1)) UMAX=UMIN
C
C Check the relative values of UMIN and UMAX for problems.  One of the
C guiding principles here is that there should be no fewer than 500
C distinguishable real numbers between the minimum and the maximum.
C (10/20/90)
C
      UTMP=250.*SMLL*(ABS(UMIN)+ABS(UMAX))
      IF (ABS(UMIN-UMAX).LT.UTMP) GO TO 102
      IF (UMAX-UMIN) 101,102,103
  101 IF (ZMIN.NE.SVAL(1).AND.ZMIN.NE.SVAL(2)) UMAX=UMIN
      IF (ZMAX.NE.SVAL(1).AND.ZMAX.NE.SVAL(2)) UMIN=UMAX
C
  102 UAVG=.5*(UMIN+UMAX)
      UMIN=UAVG-.5*UTMP
      UMAX=UAVG+.5*UTMP
      IF (UMIN.NE.UMAX) GO TO 103
      UMIN=-1.
      UMAX=+1.
C
C If the user wanted these values back-stored, do it.
C
  103 IF (ZMIN.EQ.SVAL(2)) ZMIN=UMIN
      IF (ZMAX.EQ.SVAL(2)) ZMAX=UMAX
C
C Done.
C
      RETURN
C
      END

      SUBROUTINE DPTEQR( COMPZ, N, D, E, Z, LDZ, WORK, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     October 31, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          COMPZ
      INTEGER            INFO, LDZ, N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   D( * ), E( * ), WORK( * ), Z( LDZ, * )
*     ..
*
*  Purpose
*  =======
*
*  DPTEQR computes all eigenvalues and, optionally, eigenvectors of a
*  symmetric positive definite tridiagonal matrix by first factoring the
*  matrix using DPTTRF, and then calling DBDSQR to compute the singular
*  values of the bidiagonal factor.
*
*  This routine computes the eigenvalues of the positive definite
*  tridiagonal matrix to high relative accuracy.  This means that if the
*  eigenvalues range over many orders of magnitude in size, then the
*  small eigenvalues and corresponding eigenvectors will be computed
*  more accurately than, for example, with the standard QR method.
*
*  The eigenvectors of a full or band symmetric positive definite matrix
*  can also be found if DSYTRD, DSPTRD, or DSBTRD has been used to
*  reduce this matrix to tridiagonal form. (The reduction to tridiagonal
*  form, however, may preclude the possibility of obtaining high
*  relative accuracy in the small eigenvalues of the original matrix, if
*  these eigenvalues range over many orders of magnitude.)
*
*  Arguments
*  =========
*
*  COMPZ   (input) CHARACTER*1
*          = 'N':  Compute eigenvalues only.
*          = 'V':  Compute eigenvectors of original symmetric
*                  matrix also.  Array Z contains the orthogonal
*                  matrix used to reduce the original matrix to
*                  tridiagonal form.
*          = 'I':  Compute eigenvectors of tridiagonal matrix also.
*
*  N       (input) INTEGER
*          The order of the matrix.  N >= 0.
*
*  D       (input/output) DOUBLE PRECISION array, dimension (N)
*          On entry, the n diagonal elements of the tridiagonal
*          matrix.
*          On normal exit, D contains the eigenvalues, in descending
*          order.
*
*  E       (input/output) DOUBLE PRECISION array, dimension (N-1)
*          On entry, the (n-1) subdiagonal elements of the tridiagonal
*          matrix.
*          On exit, E has been destroyed.
*
*  Z       (input/output) DOUBLE PRECISION array, dimension (LDZ, N)
*          On entry, if COMPZ = 'V', the orthogonal matrix used in the
*          reduction to tridiagonal form.
*          On exit, if COMPZ = 'V', the orthonormal eigenvectors of the
*          original symmetric matrix;
*          if COMPZ = 'I', the orthonormal eigenvectors of the
*          tridiagonal matrix.
*          If INFO > 0 on exit, Z contains the eigenvectors associated
*          with only the stored eigenvalues.
*          If  COMPZ = 'N', then Z is not referenced.
*
*  LDZ     (input) INTEGER
*          The leading dimension of the array Z.  LDZ >= 1, and if
*          COMPZ = 'V' or 'I', LDZ >= max(1,N).
*
*  WORK    (workspace) DOUBLE PRECISION array, dimension (4*N)
*
*  INFO    (output) INTEGER
*          = 0:  successful exit.
*          < 0:  if INFO = -i, the i-th argument had an illegal value.
*          > 0:  if INFO = i, and i is:
*                <= N  the Cholesky factorization of the matrix could
*                      not be performed because the i-th principal minor
*                      was not positive definite.
*                > N   the SVD algorithm failed to converge;
*                      if INFO = N+i, i off-diagonal elements of the
*                      bidiagonal factor did not converge to zero.
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO, ONE
      PARAMETER          ( ZERO = 0.0D0, ONE = 1.0D0 )
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           DBDSQR, DLASET, DPTTRF, XERBLA
*     ..
*     .. Local Arrays ..
      DOUBLE PRECISION   C( 1, 1 ), VT( 1, 1 )
*     ..
*     .. Local Scalars ..
      INTEGER            I, ICOMPZ, NRU
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, SQRT
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
*
      IF( LSAME( COMPZ, 'N' ) ) THEN
         ICOMPZ = 0
      ELSE IF( LSAME( COMPZ, 'V' ) ) THEN
         ICOMPZ = 1
      ELSE IF( LSAME( COMPZ, 'I' ) ) THEN
         ICOMPZ = 2
      ELSE
         ICOMPZ = -1
      END IF
      IF( ICOMPZ.LT.0 ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( ( LDZ.LT.1 ) .OR. ( ICOMPZ.GT.0 .AND. LDZ.LT.MAX( 1,
     $         N ) ) ) THEN
         INFO = -6
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DPTEQR', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
*
      IF( N.EQ.1 ) THEN
         IF( ICOMPZ.GT.0 )
     $      Z( 1, 1 ) = ONE
         RETURN
      END IF
      IF( ICOMPZ.EQ.2 )
     $   CALL DLASET( 'Full', N, N, ZERO, ONE, Z, LDZ )
*
*     Call DPTTRF to factor the matrix.
*
      CALL DPTTRF( N, D, E, INFO )
      IF( INFO.NE.0 )
     $   RETURN
      DO 10 I = 1, N
         D( I ) = SQRT( D( I ) )
   10 CONTINUE
      DO 20 I = 1, N - 1
         E( I ) = E( I )*D( I )
   20 CONTINUE
*
*     Call DBDSQR to compute the singular values/vectors of the
*     bidiagonal factor.
*
      IF( ICOMPZ.GT.0 ) THEN
         NRU = N
      ELSE
         NRU = 0
      END IF
      CALL DBDSQR( 'Lower', N, 0, NRU, 0, D, E, VT, 1, Z, LDZ, C, 1,
     $             WORK, INFO )
*
*     Square the singular values.
*
      IF( INFO.EQ.0 ) THEN
         DO 30 I = 1, N
            D( I ) = D( I )*D( I )
   30    CONTINUE
      ELSE
         INFO = N + INFO
      END IF
*
      RETURN
*
*     End of DPTEQR
*
      END

C
C	$Id: xmopdf.f,v 1.5 2008-07-27 00:59:05 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE XMOPDF
C
C  THIS ROUTINE SETS THE DEFAULT OPERAND SIZES BEFORE ANY PROCESSING
C  OF THE METAFILE
C
C
      COMMON /PTRPARS/  MOPLEN, MCICPR, MCDCPR, MFLCPR, MIXCPR, MWHCPR,
     1                 MOPDLN, MCIDPR, MCDDPR, MFLDPR, MIXDPR, MWHDPR,
     2                 BYTSIZ, CONFLG, MENDPR, MENCPR
      INTEGER MOPCLL, MOPIDL, MSCLEN, MLGFLG, MCOLEN, MLOLEN
      PARAMETER (MOPCLL=4, MOPIDL=7, MCOLEN=1, MSCLEN=5, MLOLEN=15,
     1           MLGFLG=31)
       INTEGER         MOPLEN, MCICPR, MCDCPR, MFLCPR, MIXCPR, MWHCPR,
     1                 MOPDLN, MCIDPR, MCDDPR, MFLDPR, MIXDPR, MWHDPR,
     2                 BYTSIZ, CONFLG, MENDPR, MENCPR
C
C  SET THE DEFAULT OPERAND SIZES
C
      MOPLEN = MOPDLN
      MCICPR = MCIDPR
      MCDCPR = MCDDPR
      MFLCPR = MFLDPR
      MIXCPR = MIXDPR
      MWHCPR = MWHDPR
      MENCPR = MENDPR
C
      RETURN
      END

C
C       $Id: stseti.f,v 1.7.8.1 2010-03-17 20:51:58 brownrig Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
C
C-----------------------------------------------------------------------
C
      SUBROUTINE STSETI (CNM,IVL)
C
      CHARACTER*(*) CNM
      INTEGER IVL
C
C This subroutine is called to give a specified integer value to a
C specified parameter.
C
C CNM is the name of the parameter whose value is to be set.
C
C IVL is an integer variable containing the new value of the parameter.
C ---------------------------------------------------------------------
C
C NOTE:
C Since implicit typing is used for all real and integer variables
C a consistent length convention has been adopted to help clarify the
C significance of the variables encountered in the code for this
C utility. All local variable and subroutine parameter identifiers
C are limited to 1,2,or 3 characters. Four character names identify
C members of common blocks. Five and 6 character variable names
C denote PARAMETER constants or subroutine or function names.
C
C Declare the ST common blocks.
C
      PARAMETER (IPLVLS = 256)
C
C Integer and real common block variables
C
C
      COMMON / STPAR /
     +                IUD1       ,IVD1       ,IPD1       ,
     +                IXD1       ,IXDM       ,IYD1       ,IYDN       ,
     +                IXM1       ,IYM1       ,IXM2       ,IYM2       ,
     +                IWKD       ,IWKU       ,ISET       ,IERR       ,
     +                IXIN       ,IYIN       ,IMSK       ,ICPM       ,
     +                NLVL       ,IPAI       ,ICTV       ,WDLV       ,
     +                UVMN       ,UVMX       ,PMIN       ,PMAX       ,
     +                IPLR       ,ISST       ,
     +                ICLR(IPLVLS)           ,TVLU(IPLVLS)
C
      COMMON / STTRAN /
     +                UVPS       ,
     +                UVPL       ,UVPR       ,UVPB       ,UVPT       ,
     +                UWDL       ,UWDR       ,UWDB       ,UWDT       ,
     +                UXC1       ,UXCM       ,UYC1       ,UYCN
C
C Stream algorithm parameters
C
      COMMON / STSTRM /
     +                ISGD       ,IAGD       ,RARL       ,ICKP       ,
     +                ICKX       ,ITRP       ,ICYK       ,RVNL       ,
     +                ISVF       ,RUSV       ,RVSV       ,RNDA       ,
     +                ISPC       ,RPSV       ,RCDS       ,RSSP       ,
     +                RDFM       ,RSMD       ,RAMD       ,IGBS       ,
     +                ISTM       ,RVRL       ,RVFR       ,RVRM       ,
     +                IVPO       ,RAFR       ,RDMX       ,RDMN
C
C Text related parameters
C Note: graphical text output is not yet implemented for the
C       Streamline utility.
C
      COMMON / STTXP /
     +                FCWM    ,ICSZ    ,
     +                FMNS    ,FMNX    ,FMNY    ,IMNP    ,IMNC  ,
     +                FMXS    ,FMXX    ,FMXY    ,IMXP    ,IMXC  ,
     +                FZFS    ,FZFX    ,FZFY    ,IZFP    ,IZFC  ,
     +                FILS    ,FILX    ,FILY    ,IILP    ,IILC
C
C Character variable declartions
C
      CHARACTER*160 CSTR
      PARAMETER (IPCHSZ=80)
      CHARACTER*(IPCHSZ)  CMNT,CMXT,CZFT,CILT
C
C Text string parameters
C
      COMMON / STCHAR / CSTR,CMNT,CMXT,CZFT,CILT
C
      SAVE /STPAR/, /STTRAN/, /STSTRM/, /STTXP/, /STCHAR/
C
C Internal buffer lengths
C
C IPNPTS - Number of points in the point buffer -- not less than 3
C IPLSTL - Streamline-crossover-check circular list length
C IPGRCT - Number of groups supported for area masking
C
      PARAMETER (IPNPTS = 256, IPLSTL = 750, IPGRCT = 64)
C
C --------------------------------------------------------------------
C
C The mapping common block: made available to user mapping routines
C
      COMMON /STMAP/
     +                IMAP       ,LNLG       ,INVX       ,INVY       ,
     +                XLOV       ,XHIV       ,YLOV       ,YHIV       ,
     +                WXMN       ,WXMX       ,WYMN       ,WYMX       ,
     +                XVPL       ,XVPR       ,YVPB       ,YVPT       ,
     +                XGDS       ,YGDS       ,NXCT       ,NYCT       ,
     +                ITRT       ,FW2W       ,FH2H       ,
     +                DFMG       ,VNML       ,RBIG       ,IBIG
C
      SAVE /STMAP/
C ------------------------------------------------------------------
C RLB 3/2010: Previously the integer parameter was converted to a float
C   and the work was delegated off to STSETR. This provided a sort
C   of "automatic type conversion", allowing the user to set a real
C   parameter using either stseti() or stsetr(), as in:
C        CALL STSETI ('xxx',-9999)
C     or
C        CALL STSETR ('xxx',-9999.0)
C
C   Color-indices are now either encoded RGBa values, or indices as
C   before. RGBa values are typically large integer values, beyond the
C   precision of floats, and thus this delegation scheme no longer
C   works correctly. The code has been refactored such that the integer
C   cases are now handled directly herein. If no action is found for
C   the CNM, then we delegate over to STSETR.
C -------------------------------------------------------
C
C Check for a parameter name that is too short.
C
      IF (LEN(CNM).LT.3) THEN
        CSTR(1:46)='STSETI - PARAMETER NAME TOO SHORT - '
        CSTR(47:46+LEN(CNM))=CNM
        CALL SETER (CSTR(1:46+LEN(CNM)),1,1)
        RETURN
      END IF
C
C Check for incorrect use of the index parameter.
C
      IF (CNM(1:3).EQ.'CLR'.OR.CNM(1:3).EQ.'clr') THEN
         IF (IPAI.LT.1.OR.IPAI.GT.IPLVLS) THEN
            CSTR(1:46)='STSETI - SETTING XXX - PAI INCORRECT'
            CSTR(28:30)=CNM(1:3)
            CALL SETER (CSTR(1:46),2,1)
            RETURN
         END IF
      END IF
C
C Set the appropriate parameter value.
C
C ---------------------------------------------------------------------
C
C Values in STPAR
C
      IF (CNM(1:3).EQ.'UD1'.OR. CNM(1:3).EQ.'ud1') THEN
         IUD1=IVL
      ELSE IF (CNM(1:3).EQ.'VD1'.OR. CNM(1:3).EQ.'vd1') THEN
         IVD1=IVL
      ELSE IF (CNM(1:3).EQ.'PD1'.OR. CNM(1:3).EQ.'pd1') THEN
         IPD1=IVL
      ELSE IF (CNM(1:3).EQ.'XD1'.OR. CNM(1:3).EQ.'xd1') THEN
         IXD1=IVL
      ELSE IF (CNM(1:3).EQ.'XDM'.OR. CNM(1:3).EQ.'xdm') THEN
         IXDM=IVL
      ELSE IF (CNM(1:3).EQ.'YD1'.OR. CNM(1:3).EQ.'yd1') THEN
         IYD1=IVL
      ELSE IF (CNM(1:3).EQ.'YDN'.OR. CNM(1:3).EQ.'ydn') THEN
         IYDN=IVL
      ELSE IF (CNM(1:3).EQ.'WKD'.OR.CNM(1:3).EQ.'wkd') THEN
         IWKD=IVL
      ELSE IF (CNM(1:3).EQ.'WKU'.OR.CNM(1:3).EQ.'wku') THEN
         IWKU=IVL
      ELSE IF (CNM(1:3).EQ.'SET'.OR. CNM(1:3).EQ.'set') THEN
         ISET=IVL
      ELSE IF (CNM(1:3).EQ.'ERR'.OR. CNM(1:3).EQ.'err') THEN
         IERR=IVL
      ELSE IF (CNM(1:3).EQ.'XIN'.OR. CNM(1:3).EQ.'xin') THEN
         IXIN=IVL
      ELSE IF (CNM(1:3).EQ.'YIN'.OR. CNM(1:3).EQ.'yin') THEN
         IYIN=IVL
      ELSE IF (CNM(1:3).EQ.'MSK'.OR. CNM(1:3).EQ.'msk') THEN
         IMSK=IVL
      ELSE IF (CNM(1:3).EQ.'CPM'.OR. CNM(1:3).EQ.'cpm') THEN
         ICPM=IVL
      ELSE IF (CNM(1:3).EQ.'NLV'.OR.CNM(1:3).EQ.'nlv') THEN
         NLVL=IVL
      ELSE IF (CNM(1:3).EQ.'PAI'.OR.CNM(1:3).EQ.'pai') THEN
         IF (IVL .LT. 1 .OR. IVL .GT. IPLVLS) GO TO 9800
         IPAI=IVL
      ELSE IF (CNM(1:3).EQ.'CTV'.OR.CNM(1:3).EQ.'ctv') THEN
         ICTV=IVL
C
C UVMN,UVMX, PMIN, PMAX are read-only
C
      ELSE IF (CNM(1:3).EQ.'THN'.OR. CNM(1:3).EQ.'thn') THEN
         ITHN=IVL
      ELSE IF (CNM(1:3).EQ.'PLR'.OR. CNM(1:3).EQ.'plr') THEN
         IPLR=IVL
      ELSE IF (CNM(1:3).EQ.'SST'.OR. CNM(1:3).EQ.'sst') THEN
         ISST=IVL
      ELSE IF (CNM(1:3).EQ.'CLR'.OR.CNM(1:3).EQ.'clr') THEN
         ICLR(IPAI)=IVL
C
C ---------------------------------------------------------------------
C
C Values in STSTRM
C
      ELSE IF (CNM(1:3).EQ.'SGD'.OR. CNM(1:3).EQ.'sgd') THEN
         ISGD=IVL
      ELSE IF (CNM(1:3).EQ.'AGD'.OR. CNM(1:3).EQ.'agd') THEN
         IAGD=IVL
      ELSE IF (CNM(1:3).EQ.'CKP'.OR. CNM(1:3).EQ.'ckp') THEN
         ICKP=IVL
      ELSE IF (CNM(1:3).EQ.'CKX'.OR. CNM(1:3).EQ.'ckx') THEN
         ICKX=IVL
      ELSE IF (CNM(1:3).EQ.'TRP'.OR. CNM(1:3).EQ.'trp') THEN
         ITRP=IVL
      ELSE IF (CNM(1:3).EQ.'CYK'.OR. CNM(1:3).EQ.'cyk') THEN
         ICYK=IVL
      ELSE IF (CNM(1:3).EQ.'SVF'.OR. CNM(1:3).EQ.'svf') THEN
         ISVF=IVL
      ELSE IF (CNM(1:3).EQ.'SPC'.OR. CNM(1:3).EQ.'spc') THEN
         ISPC=IVL
      ELSE IF (CNM(1:3).EQ.'GBS'.OR. CNM(1:3).EQ.'gbs') THEN
         IGBS=IVL
C
C This parameter is special in that it causes RSSP,RDFM, and RARL
C to be reset.
C
        IF (IGBS .EQ. 0) THEN
           RARL = 0.012
           RDFM = 0.02
           RSSP = 0.015
        ELSE
           RARL = 0.33
           RDFM = 0.33
           RSSP = 0.5
        END IF
C
      ELSE IF (CNM(1:3).EQ.'STM'.OR. CNM(1:3).EQ.'stm') THEN
         ISTM=IVL
      ELSE IF (CNM(1:3).EQ.'VPO'.OR. CNM(1:3).EQ.'vpo') THEN
         IVPO=IVL
C
C ---------------------------------------------------------------------
C
C Values in STTXP
C
C Character attributes
C
C
      ELSE IF (CNM(1:3).EQ.'ZFP'.OR. CNM(1:3).EQ.'zfp') THEN
         IZFP=IVL
      ELSE IF (CNM(1:3).EQ.'ZFC'.OR. CNM(1:3).EQ.'zfc') THEN
         IZFC=IVL
C
C ---------------------------------------------------------------------
C
C Values in STMAP
C
      ELSE IF (CNM(1:3).EQ.'MAP'.OR. CNM(1:3).EQ.'map') THEN
         IMAP=IVL
      ELSE IF (CNM(1:3).EQ.'TRT'.OR. CNM(1:3).EQ.'trt') THEN
         ITRT=IVL
C
C ---------------------------------------------------------------------
C
      ELSE
C       Float the integer value and pass it on to STSETR.
        RVL=REAL(IVL)
        CALL STSETR (CNM,RVL)
      END IF
C
      GOTO 9900
C
 9800 CONTINUE
C
      CSTR(1:50)='STSETI - PARAMETER VALUE OUT OF RANGE - '
      CSTR(51:53)=CNM(1:3)
      CALL SETER (CSTR(1:53),3,1)
      RETURN
C
 9900 CONTINUE
C
C Done.
C
      RETURN
      END

      SUBROUTINE DTBTRS( UPLO, TRANS, DIAG, N, KD, NRHS, AB, LDAB, B,
     $                   LDB, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     March 31, 1993
*
*     .. Scalar Arguments ..
      CHARACTER          DIAG, TRANS, UPLO
      INTEGER            INFO, KD, LDAB, LDB, N, NRHS
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   AB( LDAB, * ), B( LDB, * )
*     ..
*
*  Purpose
*  =======
*
*  DTBTRS solves a triangular system of the form
*
*     A * X = B  or  A**T * X = B,
*
*  where A is a triangular band matrix of order N, and B is an
*  N-by NRHS matrix.  A check is made to verify that A is nonsingular.
*
*  Arguments
*  =========
*
*  UPLO    (input) CHARACTER*1
*          = 'U':  A is upper triangular;
*          = 'L':  A is lower triangular.
*
*  TRANS   (input) CHARACTER*1
*          Specifies the form the system of equations:
*          = 'N':  A * X = B  (No transpose)
*          = 'T':  A**T * X = B  (Transpose)
*          = 'C':  A**H * X = B  (Conjugate transpose = Transpose)
*
*  DIAG    (input) CHARACTER*1
*          = 'N':  A is non-unit triangular;
*          = 'U':  A is unit triangular.
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  KD      (input) INTEGER
*          The number of superdiagonals or subdiagonals of the
*          triangular band matrix A.  KD >= 0.
*
*  NRHS    (input) INTEGER
*          The number of right hand sides, i.e., the number of columns
*          of the matrix B.  NRHS >= 0.
*
*  AB      (input) DOUBLE PRECISION array, dimension (LDAB,N)
*          The upper or lower triangular band matrix A, stored in the
*          first kd+1 rows of AB.  The j-th column of A is stored
*          in the j-th column of the array AB as follows:
*          if UPLO = 'U', AB(kd+1+i-j,j) = A(i,j) for max(1,j-kd)<=i<=j;
*          if UPLO = 'L', AB(1+i-j,j)    = A(i,j) for j<=i<=min(n,j+kd).
*          If DIAG = 'U', the diagonal elements of A are not referenced
*          and are assumed to be 1.
*
*  LDAB    (input) INTEGER
*          The leading dimension of the array AB.  LDAB >= KD+1.
*
*  B       (input/output) DOUBLE PRECISION array, dimension (LDB,NRHS)
*          On entry, the right hand side matrix B.
*          On exit, if INFO = 0, the solution matrix X.
*
*  LDB     (input) INTEGER
*          The leading dimension of the array B.  LDB >= max(1,N).
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*          > 0:  if INFO = i, the i-th diagonal element of A is zero,
*                indicating that the matrix is singular and the
*                solutions X have not been computed.
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO
      PARAMETER          ( ZERO = 0.0D+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            NOUNIT, UPPER
      INTEGER            J
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           DTBSV, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      NOUNIT = LSAME( DIAG, 'N' )
      UPPER = LSAME( UPLO, 'U' )
      IF( .NOT.UPPER .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = -1
      ELSE IF( .NOT.LSAME( TRANS, 'N' ) .AND. .NOT.
     $         LSAME( TRANS, 'T' ) .AND. .NOT.LSAME( TRANS, 'C' ) ) THEN
         INFO = -2
      ELSE IF( .NOT.NOUNIT .AND. .NOT.LSAME( DIAG, 'U' ) ) THEN
         INFO = -3
      ELSE IF( N.LT.0 ) THEN
         INFO = -4
      ELSE IF( KD.LT.0 ) THEN
         INFO = -5
      ELSE IF( NRHS.LT.0 ) THEN
         INFO = -6
      ELSE IF( LDAB.LT.KD+1 ) THEN
         INFO = -8
      ELSE IF( LDB.LT.MAX( 1, N ) ) THEN
         INFO = -10
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DTBTRS', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
*
*     Check for singularity.
*
      IF( NOUNIT ) THEN
         IF( UPPER ) THEN
            DO 10 INFO = 1, N
               IF( AB( KD+1, INFO ).EQ.ZERO )
     $            RETURN
   10       CONTINUE
         ELSE
            DO 20 INFO = 1, N
               IF( AB( 1, INFO ).EQ.ZERO )
     $            RETURN
   20       CONTINUE
         END IF
      END IF
      INFO = 0
*
*     Solve A * X = B  or  A' * X = B.
*
      DO 30 J = 1, NRHS
         CALL DTBSV( UPLO, TRANS, DIAG, N, KD, AB, LDAB, B( 1, J ), 1 )
   30 CONTINUE
*
      RETURN
*
*     End of DTBTRS
*
      END

C NCLFORTSTART
      SUBROUTINE DPRCWATDP(Q,DP,KLVL,QMSG,DPMSG,PRCWAT)
      IMPLICIT NONE
c Input
      INTEGER KLVL
      DOUBLE PRECISION Q(KLVL),DP(KLVL),QMSG,DPMSG
c Output
      DOUBLE PRECISION PRCWAT
C NCLEND

C NCL: prcwat = prcwater_dp (q,dp)

c nomenclature:
c     q      - specific humidity [kg/kg; ie: dimensionless]
c     dp     - layer thickness [Pa]
c     prcwat - precipitable water [kg/m2]

c Local
      INTEGER KL,KNT
      DOUBLE PRECISION G

      G = 9.81D0

      KNT = 0
      PRCWAT = 0.0D0
      DO KL = 1,KLVL
          IF (Q(KL).NE.QMSG .AND. DP(KL).NE.DPMSG) THEN
              KNT = KNT + 1
              PRCWAT = PRCWAT + Q(KL)*ABS(DP(KL))
          END IF
      END DO

      IF (KNT.GT.0) THEN
          PRCWAT = PRCWAT/G
      ELSE
          PRCWAT = QMSG
      END IF

      RETURN
      END

      subroutine strhlp(x)
c
      real x
c
c                                     coded by russell lynch
c                              from fitpack -- april 8, 1991
c                        a curve and surface fitting package
c                      a product of pleasant valley software
c                  8603 altus cove, austin, texas 78759, usa
c
c this subroutine is used by the function ftstore to force the
c storage of a value into a single precision storage cell
c consistant with fortran 66.
c
c on input--
c
c   x is a real variable.
c
c on output--
c
c   v in the common block vcom contains a single precision
c   version of x.
c
c and x is unaltered.
c
c this subroutine requires a common block named vcom.
c
c-------------------------------------------------------------
c
      common/vcom/vc
c
      vc = x
      return
      end

C
C	$Id: gqnt.f,v 1.5 2008-07-27 00:20:59 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GQNT(NTNR,ERRIND,WINDOW,VIEWPT)
C
C  INQUIRE NORMALIZATION TRANSFORMATION
C
      include 'gkscom.h'
C
      INTEGER NTNR,ERRIND
      REAL    WINDOW(4),VIEWPT(4)
C
C  Check that GKS in in the proper state.
C
      CALL GZCKST(8,-1,ERRIND)
      IF (ERRIND .NE. 0) GOTO 100
C
C  Check that the transformation number is in range.
C
      IF (NTNR.LT.0 .OR. NTNR.GT.MNT) THEN
        ERRIND = 50
        GO TO 100
      ENDIF
C
      INDX = NTNR+1
      WINDOW(1) = NTWN(INDX,1)
      WINDOW(2) = NTWN(INDX,2)
      WINDOW(3) = NTWN(INDX,3)
      WINDOW(4) = NTWN(INDX,4)
      VIEWPT(1) = NTVP(INDX,1)
      VIEWPT(2) = NTVP(INDX,2)
      VIEWPT(3) = NTVP(INDX,3)
      VIEWPT(4) = NTVP(INDX,4)
      RETURN
C
  100 CONTINUE
      WINDOW(1) = 0.
      WINDOW(2) = 0.
      WINDOW(3) = 0.
      WINDOW(4) = 0.
      VIEWPT(1) = -1.
      VIEWPT(2) = -1.
      VIEWPT(3) = -1.
      VIEWPT(4) = -1.
      RETURN
      END

C
C $Id: mdpio.f,v 1.12 2008-09-18 00:42:17 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MDPIO (IACT)
C
        INTEGER IACT
C
C This routine performs all positioning and input of the outline dataset
C for MDPLOT.  The argument IACT specifies what is to be done:  1 asks
C that the dataset be positioned at the beginning of the desired "file",
C 2 that the next record be read.
C
C Declare required common blocks.  See MAPBDX for descriptions of these
C common blocks and the variables in them.
C
        COMMON /MAPCM3/  ITPN,NOUT,NPTS,IGID,IDLS,IDRS,BLAG,SLAG,BLOG,
     +                   SLOG,PNTS(200),IDOS(4)
        INTEGER          ITPN,NOUT,NPTS,IGID,IDLS,IDRS,IDOS
        REAL             BLAG,SLAG,BLOG,SLOG,PNTS
        SAVE   /MAPCM3/
C
        COMMON /MAPCM5/  DDCT(5),DDCL(5),LDCT(6),LDCL(6),PDCT(19),
     +                   PDCL(19)
        CHARACTER*2      DDCT,DDCL,LDCT,LDCL,PDCT,PDCL
        SAVE   /MAPCM5/
C
C Declare a variable in which to form the name of an outline data file.
C
        CHARACTER*1024   FLNM
C
C Declare other local variables.
C
        INTEGER          I,IFDE,ISTA
C
C Save the file-descriptor parameter from one call to the next.
C
        SAVE IFDE
C
C Either open the requested dataset ...
C
        IF (IACT.EQ.1) THEN
C
          CALL MPDBDI (FLNM,ISTA)
          IF (ISTA.EQ.-1) GO TO 901
C
          DO 101 I=1,LEN(FLNM)-17
            IF (FLNM(I:I).EQ.CHAR(0)) THEN
              FLNM(I:I+17)='/EzmapOutlines.'//DDCT(NOUT+1)//CHAR(0)
              GO TO 102
            ENDIF
  101     CONTINUE
C
          GO TO 901
C
  102     CALL NGOFRO (FLNM,IFDE,ISTA)
          IF (ISTA.NE.0) GO TO 901
C
          RETURN
C
C ... or read the next record.
C
        ELSE
C
          CALL NGRDIN (IFDE,NPTS,4,ISTA)
C
          IF (ISTA.EQ.4) THEN
            IF (NPTS.LE.1) THEN
              CALL NGCLFI (IFDE)
              NPTS=0
              RETURN
            ELSE
              CALL NGRDFL (IFDE,BLAG,4+NPTS,ISTA)
              IF (ISTA.EQ.4+NPTS) THEN
                NPTS=NPTS/2
                RETURN
              END IF
            END IF
          END IF
C
          CALL NGCLFI (IFDE)
          IF (ISTA.LT.0) GO TO 902
          GO TO 903
C
        END IF
C
C Error exits.
C
  901   CALL SETER ('MDPIO - OUTLINE DATASET IS UNREADABLE',1,1)
        NOUT=0
        RETURN
C
  902   CALL SETER ('MDPIO - ERROR ON READ OF OUTLINE DATASET',2,1)
        NOUT=0
        RETURN
C
  903   CALL SETER ('MDPIO - EOF ENCOUNTERED IN OUTLINE DATASET',3,1)
        NOUT=0
        RETURN
C
      END

C
C $Id: phi1dp.f,v 1.5 2008-07-27 00:17:10 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      DOUBLE PRECISION FUNCTION PHI1DP (ECCENT,QS)
C
C FUNCTION TO COMPUTE LATITUDE ANGLE (PHI-1).
C
      IMPLICIT DOUBLE PRECISION (A-Z)
      INTEGER II,NIT
      COMMON /ERRMZ0/ IERR
        INTEGER IERR
      SAVE   /ERRMZ0/
      COMMON /PRINZ0/ IPEMSG,IPELUN,IPPARM,IPPLUN
        INTEGER IPEMSG,IPELUN,IPPARM,IPPLUN
      SAVE   /PRINZ0/
      DATA HALF,ONE /0.5D0,1.0D0/
      DATA EPSLN,TOL,NIT /1.0D-7,1.0D-10,15/
C
      PHI1DP = ASINDP (HALF * QS)
      IF (ECCENT .LT. EPSLN) RETURN
C
      ECCNTS = ECCENT * ECCENT
      PHI = PHI1DP
      DO 020 II = 1,NIT
      SINPI = SIN (PHI)
      COSPI = COS (PHI)
      CON = ECCENT * SINPI
      COM = ONE - CON * CON
      DPHI = HALF * COM * COM / COSPI * (QS / (ONE - ECCNTS) -
     .       SINPI / COM + HALF / ECCENT * LOG ((ONE - CON) /
     .       (ONE + CON)))
      PHI = PHI + DPHI
      IF (ABS(DPHI) .GT. TOL) GO TO 020
      PHI1DP = PHI
      RETURN
  020 CONTINUE
C
      IF (IPEMSG .EQ. 0) WRITE (IPELUN,2000) NIT,ECCENT,QS
 2000 FORMAT (/' ERROR PHI1DP' /
     .         ' LATITUDE FAILED TO CONVERGE AFTER',I3,' ITERATIONS'/
     .         ' ECCENTRICITY =',E25.16,'   QS =',E25.16)
      IERR = 001
      RETURN
C
      END

C
C	$Id: setrng.f,v 1.4 2008-07-27 00:59:05 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE SETRNG(IOS,STATUS)
C
C  SET THE RANGE INFO IF THE USER WANTS TO USE SOME SCALING OPTION
C
C  OUTPUT
C       IOS- THE I/O STATUS VALID WHEN STATUS SET TO AN I/O ERROR
C       STATUS-THE ERROR STATUS DEFINED BY COMMON TREROR
C
C
C
      COMMON/TREROR/ ALLOK, MFRCHK, MTOPER, METRDC, REDERR, TYPCHG
     1             ,INVTYP, MINVLD, TYPERR, FRMEND, ENCINT, IVDCDT
     2             ,GCOERR, GCRERR, GCCERR, FCOERR, FCRERR, FCCERR
     3             ,PLIDXG, PMIDXG, TXIDXG, PGIDXG, INVLMT, CELERR
     4             ,COIERR, COLNRM, UNKNOW, UNKOPC, ENDMTF, VNEROR
     5             ,BADRSZ, DEVOUT, NOVERS, BADFNT, PGMERR, FASERR
     6             ,HINERR, VDWERR, RDWERR, RIXLIM
      INTEGER        ALLOK, MFRCHK, MTOPER, METRDC, REDERR, TYPCHG
     1             ,INVTYP, MINVLD, TYPERR, FRMEND, ENCINT, IVDCDT
     2             ,GCOERR, GCRERR, GCCERR, FCOERR, FCRERR, FCCERR
     3             ,PLIDXG, PMIDXG, TXIDXG, PGIDXG, INVLMT, CELERR
     4             ,COIERR, COLNRM, UNKNOW, UNKOPC, ENDMTF, VNEROR
     5             ,BADRSZ, DEVOUT, NOVERS, BADFNT, PGMERR, FASERR
     6             ,HINERR, VDWERR, RDWERR, RIXLIM
      COMMON /TRINST/ OPCL, OPID, LEN, CONT
      INTEGER OPCL, OPID, LEN
      LOGICAL CONT
      COMMON /TRMTYP/ FOURBT, MULTBT, TWOBT, PTSFLG, CURCOL, IPWRIT,
     1                IFRAME, ISETOP, IRANG, IPTS, ICAS, IINT, IORNT,
     2                ISIZE, IFONT, IPAT, ISSIZ, ICENT, ICOLR,
     3                MCENT, MSIZE, MOR, OLDX, OLDY, MCASE, MINTEN,
     4                MFONT, MDASH, MSPOT, MCOLOR, MLIMIT, PTSYM,
     5                SAVX, SAVY
      INTEGER FOURBT, MULTBT, TWOBT, PTSFLG, CURCOL, IPWRIT,
     1                IFRAME, ISETOP, IRANG, IPTS, ICAS, IINT, IORNT,
     2                ISIZE, IFONT, IPAT, ISSIZ, ICENT, ICOLR,
     3                MCENT, MSIZE, MOR, OLDX, OLDY, MCASE, MINTEN,
     4                MFONT, MDASH, MSPOT, MCOLOR(3), MLIMIT(4), PTSYM,
     5                SAVX, SAVY
C
      INTEGER IOS, STATUS
      INTEGER BYTE8, W16, K
C
C  DEFINE THE BYTE SIZE FOR COUNT AND OPTION CODE
C
      DATA BYTE8/8/,W16/16/
C
C  INITIALIZE THE STATUS FIELD TO ALL OK
C
      STATUS = ALLOK
C
C  SKIP OVER THE NEXT BYTE THEN READ IN THE NEXT 4 16 BIT PACKETS
C
      CALL MNINST(BYTE8,IOS,STATUS)
      DO 100 K = 1,4
        CALL MNINST(W16,IOS,STATUS)
        MLIMIT(K) = OPCL
        IF (STATUS.NE.ALLOK) RETURN
 100  CONTINUE
C
      RETURN
      END

C
C	$Id: csaplyr.f,v 1.5 2008-07-27 03:10:05 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CSAPLYR (X,Y,Z,CX,SX,CY,SY, XP,YP,ZP)
      DOUBLE PRECISION X, Y, Z, CX, SX, CY, SY, XP, YP, ZP
C
C***********************************************************
C
C                                              From SSRFPACK
C                                            Robert J. Renka
C                                  Dept. of Computer Science
C                                       Univ. of North Texas
C                                           renka@cs.unt.edu
C                                                   05/09/92
C
C   This subroutine applies the rotation R defined by Sub-
C routine CSCONSTR to the unit vector (X Y Z)**T, i,e. (X,Y,Z)
C is rotated to (XP,YP,ZP).  If (XP,YP,ZP) lies in the
C southern hemisphere (ZP < 0), (XP,YP) are set to the
C coordinates of the nearest point of the equator, ZP re-
C maining unchanged.
C
C On input:
C
C       X,Y,Z = Coordinates of a point on the unit sphere.
C
C       CX,SX,CY,SY = Elements of the rotation defined by
C                     Subroutine CSCONSTR.
C
C Input parameters are not altered except as noted below.
C
C On output:
C
C       XP,YP,ZP = Coordinates of the rotated point on the
C                  sphere unless ZP < 0, in which case
C                  (XP,YP,0) is the closest point of the
C                  equator to the rotated point.  Storage
C                  for XP, YP, and ZP may coincide with
C                  storage for X, Y, and Z, respectively,
C                  if the latter need not be saved.
C
C Modules required by CSAPLYR:  None
C
C Intrinsic function called by CSAPLYR:  SQRT
C
C***********************************************************
C
      DOUBLE PRECISION T
C
C Local parameter:
C
C T = Temporary variable
C
      T = SX*Y + CX*Z
      YP = CX*Y - SX*Z
      ZP = SY*X + CY*T
      XP = CY*X - SY*T
      IF (ZP .GE. 0.) RETURN
C
C Move (XP,YP,ZP) to the equator.
C
      T = SQRT(XP*XP + YP*YP)
      IF (T .EQ. 0.) GO TO 1
      XP = XP/T
      YP = YP/T
      RETURN
C
C Move the south pole to an arbitrary point of the equator.
C
    1 XP = 1.
      YP = 0.
      RETURN
      END

      PROGRAM STEX01
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C  Open GKS.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C  Invoke STITLE example.
C
      CALL EXSTL0 (IERROR)
C
C  Close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      END
      SUBROUTINE EXSTL0 (IERROR)
C
C  This subroutine provides a simple example of STITLE usage.
C  It is assumed that GKS has been opened prior to calling
C  this suboutine.
C
      CHARACTER*80    CARDS(12)
C
C  First, set up the CARDS array to specify the text strings, the
C  text sizes, horizontal centering, and vertical coordinate
C  information.  This information is supplied for each line of text.
C  In this example, all the X-coordinates are set to 512, and the
C  horizontal centering is always set to 1, so each line of text will
C  be centered horizontally.  All character sizes will be 1.5 times
C  the default PLOTCHAR character size except the equation supplied
C  in CARD(8) that will be 3.5 times the default PLOTCHAR character
C  size.  Notice that each line has a Y-coordinate specified for it;
C  these coordinates range from 1500 at the top to 200 at the bottom
C  of the scroll.
C
      NCARDS = 12
      CARDS( 1) = '  512 1500    1  1.5The PLOTCHAR'
      CARDS( 2) = '  512 1400    1  1.5utility'
      CARDS( 3) = '  512 1300    1  1.5can be'
      CARDS( 4) = '  512 1200    1  1.5used to'
      CARDS( 5) = '  512 1100    1  1.5write'
      CARDS( 6) = '  512 1000    1  1.5an equation'
      CARDS( 7) = '  512  900    1  1.5like'
      CARDS( 8) = '  512  700    1  3.5C:S:2:N:=A:S:2:N:+B:S:2:N:'
      CARDS( 9) = '  512  500    1  1.5in a'
      CARDS(10) = '  512  400    1  1.5movie title'
      CARDS(11) = '  512  300    1  1.5created by'
      CARDS(12) = '  512  200    1  1.5STITLE'
C
C  Define the remaining inputs for STITLE.
C
C  NYST specifies the Y-coordinate that will be at the vertical center
C  of the frame when scrolling begins.  The value specified (1300)
C  means that the line "can be" will be centered vetically on the
C  first frame and scrolling will proceed from there.
C
      NYST  = 1300
C
C  NYFIN specifies the Y-coordinate that will be at the vertical center
C  of the frame when scrolling is terminated.  The value specified (400)
C  means that the line "movie title" will be centered vertically on
C  the frame when scrolling terminates.
C
      NYFIN = 400
C
C  TST specifies how many seconds  the first frame will remain
C  stationary before scrolling begins.
C
      TST   = 1.0
C
C  Specify the scroll time.  This is the time in seconds that the
C  text will be scrolled from position NYST to NYFIN.
C
      TMV   = 10.0
C
C  Specify how many seconds  the final frame will remain stationary
C  after scrolling stops.
C
      TFIN  =  0.5
C
C  Indicate that this will be a practice run, and not a production
C  run.
C
      MOVIE = 1
C
C  Call SLSETR to indicate that the first frame should be faded
C  in for 2.5 seconds.
C
      CALL SLSETR('FIN',2.5)
C
C  Call SLSETR to indicate that the last frame should be faded
C  out for 2.0 seconds.
C
      CALL SLSETR('FOU',2.0)
C
C  Call STITLE.
C
      CALL STITLE (CARDS,NCARDS,NYST,NYFIN,TST,TMV,TFIN,MOVIE)
C
      RETURN
      END

C
C       $Id: vvinit.f,v 1.17 2008-07-27 00:17:35 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
C-----------------------------------------------------------------------
C
      SUBROUTINE VVINIT (U,LU,V,LV,P,LP,M,N,WRK,LW)
C
C Argument dimensions.
C
      DIMENSION       U(LU,N)    ,V(LV,N)    ,P(LP,N)
      DIMENSION       WRK(LW)
C
C Input parameters
C
C U,V   - 2-d arrays holding the component values of a vector field
C LU,LV - The first dimensions of the U and V arrays, respectively
C P     - A 2-d array containing a scalar data field. The contents
C         of this array may be used to color the vectors.
C LP    - The first dimension of the P array
C M     - The first data dimension (must be less than or equal to
C         MIN(LU,LV) or, if the P array is used, MIN(LU,LV,LP))
C N     - The second data dimension
C WRK   - an internally used work array
C LW    - dimension of the work array (must be at least 2*M*N) 
C
C Output parameters:
C
C None
C
C ---------------------------------------------------------------------
C
C NOTE:
C Since implicit typing is used for all real and integer variables
C a consistent length convention has been adopted to help clarify the
C significance of the variables encountered in the code for this 
C utility. All local variable and subroutine parameter identifiers 
C are limited to 1,2,or 3 characters. Four character names identify  
C members of common blocks. Five and 6 character variable names 
C denote PARAMETER constants or subroutine or function names.
C
C Declare the VV common blocks.
C
C IPLVLS - Maximum number of color threshold level values
C IPAGMX - Maximum number of area groups allowed in the area map
C
      PARAMETER (IPLVLS = 256, IPAGMX = 64)
C
C Integer and real common block variables
C
C
      COMMON /VVCOM/
     +                IUD1       ,IVD1       ,IPD1       ,IXDM       ,
     +                IYDN       ,VLOM       ,VHIM       ,ISET       ,
     +                VRMG       ,VRLN       ,VFRC       ,IXIN       ,
     +                IYIN       ,ISVF       ,UUSV       ,UVSV       ,
     +                UPSV       ,IMSK       ,ICPM       ,UVPS       ,
     +                UVPL       ,UVPR       ,UVPB       ,UVPT       ,
     +                UWDL       ,UWDR       ,UWDB       ,UWDT       ,
     +                UXC1       ,UXCM       ,UYC1       ,UYCN       ,
     +                NLVL       ,IPAI       ,ICTV       ,WDLV       ,
     +                UVMN       ,UVMX       ,PMIN       ,PMAX       ,
     +                RVMN       ,RVMX       ,RDMN       ,RDMX       ,
     +                ISPC       ,RVMD       ,IPLR       ,IVST       ,
     +                IVPO       ,ILBL       ,IDPF       ,IMSG       ,
     +                ICLR(IPLVLS)           ,TVLU(IPLVLS)
C
C Arrow size/shape parameters
C
        COMMON / VVARO /
     +                HDSZ       ,HINF       ,HANG       ,IAST       ,
     +                HSIN       ,HCOS       ,FAMN       ,FAMX       ,
     +                UVMG       ,FAIR       ,FAWR       ,FAWF       ,
     +                FAXR       ,FAXF       ,FAYR       ,FAYF       ,
     +                AROX(8)    ,AROY(8)    ,FXSZ       ,FYSZ       ,
     +                FXRF       ,FXMN       ,FYRF       ,FYMN       ,
     +                FWRF       ,FWMN       ,FIRF       ,FIMN       ,
     +                AXMN       ,AXMX       ,AYMN       ,AYMX       ,
     +                IACM       ,IAFO       ,WBAD       ,WBTF       ,
     +                WBCF       ,WBDF       ,WBSC
C
C
C Text related parameters
C
        COMMON /VVTXP /
     +                FCWM    ,ICSZ    ,
     +                FMNS    ,FMNX    ,FMNY    ,IMNP    ,IMNC  ,
     +                FMXS    ,FMXX    ,FMXY    ,IMXP    ,IMXC  ,
     +                FZFS    ,FZFX    ,FZFY    ,IZFP    ,IZFC  ,
     +                FILS    ,FILX    ,FILY    ,IILP    ,IILC  ,
     +                FLBS    ,ILBC

C
C Character variable declartions
C
      CHARACTER*160 CSTR
      PARAMETER (IPCHSZ=36)
      CHARACTER*(IPCHSZ)  CMNT,CMXT,CZFT,CLBT,CILT
C
C Text string parameters
C
      COMMON /VVCHAR/ CSTR,CMNT,CMXT,CZFT,CLBT,CILT
C
      SAVE /VVCOM/, /VVARO/, /VVTXP/, /VVCHAR/
C
C The mapping common block: made available to user mapping routines
C
      COMMON /VVMAP/
     +                IMAP       ,
     +                XVPL       ,XVPR       ,YVPB       ,YVPT       ,
     +                WXMN       ,WXMX       ,WYMN       ,WYMX       ,
     +                XLOV       ,XHIV       ,YLOV       ,YHIV       ,
     +                SXDC       ,SYDC       ,NXCT       ,NYCT       ,
     +                RLEN       ,LNLG       ,INVX       ,INVY       ,
     +                ITRT       ,IWCT       ,FW2W       ,FH2H       ,
     +                DVMN       ,DVMX       ,RBIG       ,IBIG
C
      SAVE /VVMAP/
C
C Math constants
C
      PARAMETER (PDTOR  = 0.017453292519943,
     +           PRTOD  = 57.2957795130823,
     +           P1XPI  = 3.14159265358979,
     +           P2XPI  = 6.28318530717959,
     +           P1D2PI = 1.57079632679489,
     +           P5D2PI = 7.85398163397448) 
C
C --------------------------------------------------------------------
C
C Do a call forcing a BLOCKDATA to be loaded from a binary library.
C
      CALL VVDATA
C
C ---------------------------------------------------------------------
C
C Write the array sizes into the common block
C 
      IUD1=LU
      IVD1=LV
      IPD1=LP
C
C Error if M > LU or M > LV
C
      IXDM=M
      IYDN=N
      IF (IXDM.GT.IUD1 .OR. IXDM.GT.IVD1) THEN
         CSTR(1:45)='VVINIT - U AND/OR V ARRAY DIMENSIONS EXCEEDED'
         CALL SETER (CSTR(1:45),1,1)
         RETURN
      END IF
      IF (RVMD .GT. 0.0 .AND. LW .LT. 2*IXDM*IYDN) THEN
         CSTR(1:50)='VVINIT - WORK ARRAY TOO SMALL FOR THINNING VECTORS'
         CALL SETER (CSTR(1:45),1,1)
         RETURN
      END IF
C
C Initialize and transfer some arguments to local variables.
C
      IBIG = I1MACH(9)
      RBIG = R1MACH(2)
C
C Decide what the range of values in X and Y should be.
C
      IF (UXC1.EQ.UXCM) THEN
        XLOV=1.
        XHIV=REAL(MAX(IXDM, 2))
      ELSE
        XLOV=UXC1
        XHIV=UXCM
      END IF
C
      IF (UYC1.EQ.UYCN) THEN
        YLOV=1.
        YHIV=REAL(MAX(IYDN,2))
      ELSE
        YLOV=UYC1
        YHIV=UYCN
      END IF
C
      IXIN = MAX(IXIN,1)
      IYIN = MAX(IYIN,1)
C
      NXCT = IXDM/IXIN
      NYCT = IYDN/IYIN
C
C If the user has done a SET call, retrieve the arguments; if he hasn't
C done a SET call, do it for him.
C
      IF (ISET .EQ .0) THEN
C
        CALL GETSET (XVPL,XVPR,YVPB,YVPT,WXMN,WXMX,WYMN,WYMX,LNLG)
C
      ELSE
C
        LNLG=1
C
        IF (UWDL.EQ.UWDR) THEN
          WXMN=XLOV
          WXMX=XHIV
        ELSE
          WXMN=UWDL
          WXMX=UWDR
        END IF
C
        IF (UWDB.EQ.UWDT) THEN
          WYMN=YLOV
          WYMX=YHIV
        ELSE
          WYMN=UWDB
          WYMX=UWDT
        END IF
C
C Determine the viewport based on the setting of the viewport
C shape and viewport extent parameters
C
        IF (UVPS.LT.0.) THEN
          AR=ABS(UVPS)
        ELSE IF (UVPS.EQ.0.) THEN
          AR=(UVPR-UVPL)/(UVPT-UVPB)
        ELSE IF (UVPS.LE.1.) THEN
          AR=ABS((WXMX-WXMN)/(WYMX-WYMN))
          IF (MIN(AR,1./AR).LT.UVPS) AR=(UVPR-UVPL)/(UVPT-UVPB)
        ELSE
          AR=ABS((WXMX-WXMN)/(WYMX-WYMN))
          IF (MAX(AR,1./AR).GT.UVPS) AR=1.
        END IF
C
        IF (AR.LT.(UVPR-UVPL)/(UVPT-UVPB)) THEN
          XVPL=.5*(UVPL+UVPR)-.5*(UVPT-UVPB)*AR
          XVPR=.5*(UVPL+UVPR)+.5*(UVPT-UVPB)*AR
          YVPB=UVPB
          YVPT=UVPT
        ELSE
          XVPL=UVPL
          XVPR=UVPR
          YVPB=.5*(UVPB+UVPT)-.5*(UVPR-UVPL)/AR
          YVPT=.5*(UVPB+UVPT)+.5*(UVPR-UVPL)/AR
        END IF
C
        CALL SET (XVPL,XVPR,YVPB,YVPT,WXMN,WXMX,WYMN,WYMX,LNLG)
C
      END IF
C
C Calculate fraction of VP width to fractional size factor.
C Calculate fraction of VP height to fractional size factor.
C These are for convenience.
C
      FW2W = XVPR - XVPL
      FH2H = YVPT - YVPB
C
C Swap window rectangle if it is inverted, but keep track
C This makes it easier to exclude out-of-bounds points in the
C projection mapping routines
C
      INVX=0
      INVY=0
      IF (WXMN .GT. WXMX) THEN
         T=WXMN
         WXMN=WXMX
         WXMX=T
         INVX=1
      END IF
      IF (WYMN .GT. WYMX) THEN
         T=WYMN
         WYMN=WYMX
         WYMX=T
         INVY=1
      END IF
C
C Calculate a default value for the maximum vector length in
C fractional coordinates. Set minimum length to 0.0.
C
      IXIN = MAX(IXIN, 1)
      IYIN = MAX(IYIN, 1)
      I=MAX(IXDM/IXIN, 1)
      J=MAX(IYDN/IYIN, 1)
C
      TX=(XVPR-XVPL)/REAL(I)
      TY=(YVPT-YVPB)/REAL(J)
      DVMX=SQRT((TX*TX+TY*TY)/2.0)
      DVMN = 0.0
C
C Determine the equivalent maximum length in the user coordinate
C system. Note that if the X axis is non-uniform or if the Y axis
C has a different scaling from the X-Axis, this value may not be 
C meaningful.
C
      RLEN=DVMX*(WXMX-WXMN)/(XVPR-XVPL)
C
C Find the maximum and minimum magnitude vectors.
C If there are no special values use simpler code for efficiency.
C
      UVMN=RBIG
      UVMX=0.0
      IF (ISVF .LE. 0) THEN
C
         DO 111 J=1,IYDN,IYIN
            DO 110 I=1,IXDM,IXIN
               TU=U(I,J)
               TV=V(I,J)
               IF (IPLR.NE.0) THEN
                  UVMN = MIN(UVMN, TU)
                  UVMX = MAX(UVMX, TU)
               ELSE
                  UVMN = MIN(UVMN, TU*TU+TV*TV)
                  UVMX = MAX(UVMX, TU*TU+TV*TV)
               END IF
 110        CONTINUE
 111     CONTINUE
C
      ELSE
C
         DO 116 J=1,IYDN,IYIN
            DO 115 I=1,IXDM,IXIN
               TU=U(I,J)
               TV=V(I,J)
C
               IF (ISVF .EQ. 1) THEN
                  IF (TU .EQ. UUSV) GO TO 115
               ELSE IF (ISVF .EQ. 2) THEN
                  IF (TV .EQ. UVSV) GO TO 115
               ELSE IF (ISVF .EQ. 3) THEN
                  IF (TU .EQ. UUSV .OR. TV .EQ. UVSV) THEN
                     GO TO 115
                  END IF
               ELSE IF (ISVF .EQ. 4) THEN
                  IF (TU .EQ. UUSV .AND. TV .EQ. UVSV) THEN
                     GO TO 115
                  END IF
               END IF
C
               IF (IPLR.NE.0) THEN
                  UVMN = MIN(UVMN, TU)
                  UVMX = MAX(UVMX, TU)
               ELSE
                  UVMN = MIN(UVMN, TU*TU+TV*TV)
                  UVMX = MAX(UVMX, TU*TU+TV*TV)
               END IF
C
 115        CONTINUE
 116     CONTINUE
C
      END IF
C
      IF (IPLR .LE. 0) THEN
         UVMX = SQRT(UVMX)
         UVMN = SQRT(UVMN)
      END IF
C
C Decide how to use the scalar array.
C
      IF (ABS(ICTV).EQ.1) THEN
         PMIN=UVMN
         PMAX=UVMX
         IP=1
      ELSE IF (ICTV.NE.0) THEN
C
C Check for error condition
C
         IF (IPD1 .LT. IXDM) THEN
            CSTR(1:31)='VVINIT - SCALAR ARRAY TOO SMALL'
            CALL SETER (CSTR(1:31),2,1)
            RETURN
         END IF
C
C Find the max and min scalar values when necessary
C
         IF (ICTV.GE.2 .OR. PMIN.EQ.PMAX) THEN
            PMIN=RBIG
            PMAX=-RBIG
            IP=0
            DO 121 J=1,IYDN,IYIN
               DO 120 I=1,IXDM,IXIN
                  IF (ISPC .GE. 0 .AND. P(I,J) .EQ. UPSV) GO TO 120  
                  IP=1
                  PMIN = MIN(PMIN, P(I,J))
                  PMAX = MAX(PMAX, P(I,J))
 120           CONTINUE
 121        CONTINUE
         END IF
C
      END IF
C
C Determine the threshold values. If there were no non-special
C values in the P array, then set all threshold values to the
C maximum possible.
C
      IF (NLVL.GT.0 .AND. ICTV.GT.0) THEN
C
         IF (IP .NE. 0) THEN
            TV=(PMAX-PMIN)/NLVL
            DO 125 I=1,NLVL,1
               TVLU(I)=PMIN+REAL(I)*TV
 125        CONTINUE
         ELSE
            DO 130 I=1,NLVL,1
               TVLU(I)=RBIG
 130        CONTINUE
         END IF
C
      END IF
C
C Copy min/max vector magnitude and NDC size to read-only params.
C
      RVMN=UVMN
      RVMX=UVMX
      RDMN=DVMN
      RDMX=DVMX
C
C Done.
C
      RETURN
C
      END

C
C	$Id: conout.f,v 1.4 2008-07-27 00:16:57 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CONOUT (IVER)
C
C  LIST OUT ALL THE CONRAN OPTION VALUES ON THE LINE PRINTER
C
C  THE VALUE OF IVER DETERMINES WHICH ENTRY POINT CALLED THIS ROUTINE
C
C 1. CONRAQ
C 2. CONRAN
C 3. CONRAS
C
C
C
      COMMON /CONRA1/ CL(30)     ,NCL        ,OLDZ       ,PV(210)    ,
     1                FINC       ,HI         ,FLO
      COMMON /CONRA2/ REPEAT     ,EXTRAP     ,PER        ,MESS       ,
     1                ISCALE     ,LOOK       ,PLDVLS     ,GRD        ,
     2                CINC       ,CHILO      ,CON        ,LABON      ,
     3                PMIMX      ,SCALE      ,FRADV      ,EXTRI      ,
     4                BPSIZ      ,LISTOP
      COMMON /CONRA3/ IREC
      COMMON /CONRA4/ NCP        ,NCPSZ
      COMMON /CONRA5/ NIT        ,ITIPV
      COMMON /CONRA6/ XST        ,YST        ,XED        ,YED        ,
     1                STPSZ      ,IGRAD      ,IG         ,XRG        ,
     2                YRG        ,BORD       ,PXST       ,PYST       ,
     3                PXED       ,PYED       ,ITICK
      COMMON /CONR18/ TITLE      ,ICNT   ,ITLSIZ
      COMMON /CONR19/ IHIGH      ,INMAJ      ,INLAB      ,INDAT      ,
     1              LEN      ,IFMT       ,LEND       ,
     2                IFMTD      ,ISIZEP     ,INMIN
      COMMON /CONRA9/ ICOORD(500),NP         ,MXXY       ,TR         ,
     1                BR         ,TL         ,BL         ,CONV       ,
     2                XN         ,YN         ,ITLL       ,IBLL       ,
     3                ITRL       ,IBRL       ,XC         ,YC         ,
     4                ITLOC(210) ,JX         ,JY         ,ILOC       ,
     5                ISHFCT     ,XO         ,YO         ,IOC        ,NC
      COMMON /CONR10/ NT         ,NL         ,NTNL       ,JWIPT      ,
     1                JWIWL      ,JWIWP      ,JWIPL      ,IPR        ,
     2                ITPV
      COMMON /CONR20/ NREP       ,NCRT       ,ISIZEL     ,
     1                MINGAP     ,ISIZEM         ,
     2                TENS
      COMMON /CONR12/ IXMAX      ,IYMAX      ,XMAX       ,YMAX
      LOGICAL         REPEAT     ,EXTRAP     ,PER        ,MESS       ,
     1                LOOK       ,PLDVLS     ,GRD        ,LABON      ,
     2                PMIMX      ,FRADV      ,EXTRI      ,CINC       ,
     3                TITLE      ,LISTOP     ,CHILO      ,CON
      COMMON /CONR13/XVS(50),YVS(50),ICOUNT,SPVAL,SHIELD,
     1               SLDPLT
      LOGICAL SHIELD,SLDPLT
      COMMON /CONR14/LINEAR
      LOGICAL LINEAR
      COMMON /CONR15/ ISTRNG
        CHARACTER*64 ISTRNG
        COMMON /CONR16/ FORM
        CHARACTER*10 FORM
        COMMON /CONR17/ NDASH, IDASH, EDASH
        CHARACTER*10 NDASH, IDASH, EDASH
C
      SAVE
C
C  GET THE STANDARD OUTPUT UNIT TO WRITE THE OPTION VALUE LIST
C
      IUNIT = I1MACH(2)
C
C  PRINT OUT HEADER AND ALL OPTIONS WHICH APPLY TO CALLING VERSION
C
      GO TO ( 100, 110, 120),IVER
  100 WRITE (IUNIT,1001)
      GO TO  130
  110 WRITE (IUNIT,1002)
      GO TO  130
  120 WRITE (IUNIT,1003)
  130 WRITE (IUNIT,1004)
C
C  PERIMETER
C
      WRITE (IUNIT,1005)
      IF (PER) GO TO  140
      WRITE (IUNIT,1006)
      GO TO  150
  140 WRITE (IUNIT,1007)
C
C  GRID
C
  150 WRITE (IUNIT,1008)
      IF (GRD) GO TO  160
      WRITE (IUNIT,1009)
      GO TO  170
  160 WRITE (IUNIT,1010)
C
C  SCALING OF DATA ON FRAME
C
  170 WRITE (IUNIT,1011)
      GO TO ( 180, 190, 200),ISCALE+1
  180 WRITE (IUNIT,1012)
      GO TO  210
  190 WRITE (IUNIT,1013)
      GO TO  210
  200 WRITE (IUNIT,1014)
C
C  SAME DATA ANOTHER PLOT
C
  210 WRITE (IUNIT,1015)
      IF (REPEAT) GO TO  220
      WRITE (IUNIT,1016)
      GO TO  230
  220 WRITE (IUNIT,1017)
C
C  SHIELDING
C
  230 WRITE(IUNIT,2000)
      IF (SHIELD) GO TO 231
      WRITE(IUNIT,2001)
      GO TO 232
  231 WRITE(IUNIT,2002)
C
C  INTERPOLATION
C
  232 WRITE(IUNIT,2003)
      IF (LINEAR) GO TO 233
      WRITE(IUNIT,2004)
      GO TO 234
  233 WRITE(IUNIT,2005)
C
C  PLOT THE SHIELD
C
  234 WRITE(IUNIT,2006)
      IF (SLDPLT) GO TO 235
      WRITE(IUNIT,2007)
      GO TO 236
  235 WRITE(IUNIT,2008)
C
C  EXTRAPOLATION
C
  236 WRITE (IUNIT,1018)
      IF (EXTRAP) GO TO  240
      WRITE (IUNIT,1019)
      GO TO  250
  240 WRITE (IUNIT,1020)
C
C  STEP SIZE OR RESOLUTION OF THE GRID
C
  250 WRITE (IUNIT,1021) IGRAD
C
C  MESSAGE AT BOTTOM OF PLOT
C
      WRITE (IUNIT,1022)
      IF (MESS) GO TO  260
      WRITE (IUNIT,1023)
      GO TO  270
  260 WRITE (IUNIT,1024)
C
C  TITLE AT TOP OF PLOT
C
  270 WRITE (IUNIT,1025)
      IF (TITLE) GO TO  280
      WRITE (IUNIT,1026)
      GO TO  290
  280 WRITE (IUNIT,1027)
C
C  SIZE OF TITLE
C
  290 WRITE (IUNIT,1028) ITLSIZ
C
C  PRINT TITLE
C
      IF (ICNT.EQ.0 .OR. .NOT.TITLE) GO TO  310
      ICC = 100
      IF (ICC .GT. ICNT) ICC = ICNT
      WRITE (IUNIT,1029) ISTRNG
C
C  DATA POINTS USED FOR PARTIAL DERIVATIVE ESTIMATION
C
  310 WRITE (IUNIT,1030) NCP
C
C  LOOK AT TRIANGLES SWITCH
C
      WRITE (IUNIT,1031)
      IF (LOOK) GO TO  320
      WRITE (IUNIT,1032)
      GO TO  330
  320 WRITE (IUNIT,1033)
C
C  ADVANCE FRAME BEFORE PLOTTING TRIANGULATION
C
  330 WRITE (IUNIT,1034)
      IF (FRADV) GO TO  340
      WRITE (IUNIT,1035)
      GO TO  350
  340 WRITE (IUNIT,1036)
C
C  TRIANGLES ONLY PLOT
C
  350 WRITE (IUNIT,1037)
      IF (EXTRI) GO TO  360
      WRITE (IUNIT,1038)
      GO TO  370
  360 WRITE (IUNIT,1039)
C
C  PLOT THE INPUT DATA VALUES
C
  370 WRITE (IUNIT,1040)
      IF (PLDVLS) GO TO  380
      WRITE (IUNIT,1041)
      GO TO  390
  380 WRITE (IUNIT,1042)
C
C  FORMAT OF THE PLOTTED INPUT DATA
C
  390 WRITE (IUNIT,1043)
      IF (LEN .NE. 0) GO TO  400
      WRITE (IUNIT,1044)
      GO TO  420
  400 WRITE (IUNIT,1045) FORM
C
C  SIZE OF THE PLOTTED DATA VALUES
C
  420 WRITE (IUNIT,1046) ISIZEP
C
C  INTENSITY SETTINGS
C
      WRITE (IUNIT,1047)
      WRITE (IUNIT,1048) INMAJ,INMIN,INLAB,INDAT
C
C  DISTLAY CONTOUR SETTING
C
      WRITE (IUNIT,1049)
      IF (CON) GO TO  430
      WRITE (IUNIT,1050)
      GO TO  440
  430 WRITE (IUNIT,1051) NCL,(CL(I),I=1,NCL)
C
C  CONTOUR INCREMENT
C
  440 WRITE (IUNIT,1052)
      IF (CINC) GO TO  450
      WRITE (IUNIT,1053)
      GO TO  460
  450 WRITE (IUNIT,1054) FINC
C
C  CONTOUR HIGH AND LOW VALUES
C
  460 WRITE (IUNIT,1055)
      IF (CHILO) GO TO  470
      WRITE (IUNIT,1056)
      GO TO  480
  470 WRITE (IUNIT,1057) HI,FLO
C
C  CALL CONOT2 IF NOT QUICK VERSION
C
  480 IF (IVER .NE. 1) CALL CONOT2 (IVER,IUNIT)
C
C  THE ROUTINE CONOT2 WAS GENERATED TO ELIMINATE COMPILER ERRORS
C  RESULTING FROM TOO MANY FORMAT STATEMENTS IN ONE SUBROUTINE
C
      RETURN
C
C
 1001 FORMAT (1X,'CONRAQ')
 1002 FORMAT (1X,'CONRAN')
 1003 FORMAT (1X,'CONRAS')
 1004 FORMAT ('+',6X,'-OPTION VALUE SETTINGS',/
     1        ,7X,'ALL NON-PWRIT VALUES APPLY TO THE UNSCALED DATA')
 1005 FORMAT (5X,'PERIMETER, PER=')
 1006 FORMAT ('+',19X,'OFF')
 1007 FORMAT ('+',19X,'ON')
 1008 FORMAT (5X,'GRID, GRD=')
 1009 FORMAT ('+',14X,'OFF')
 1010 FORMAT ('+',14X,'ON')
 1011 FORMAT (5X,'SCALING OF PLOT ON FRAME, SCA=')
 1012 FORMAT ('+',34X,'ON')
 1013 FORMAT ('+',34X,'OFF')
 1014 FORMAT ('+',34X,'PRI')
 1015 FORMAT (5X,'SAME DATA FOR ANOTHER PLOT, REP=')
 1016 FORMAT ('+',36X,'OFF')
 1017 FORMAT ('+',36X,'ON')
 1018 FORMAT (5X,'EXTRAPOLATION, EXT=')
 1019 FORMAT ('+',23X,'OFF')
 1020 FORMAT ('+',23X,'ON')
 1021 FORMAT (5X,'RESOLUTION, SSZ=',I4)
 1022 FORMAT (5X,'MESSAGE, MES=')
 1023 FORMAT ('+',17X,'OFF')
 1024 FORMAT ('+',17X,'ON')
 1025 FORMAT (5X,'TITLE, TLE=')
 1026 FORMAT ('+',15X,'OFF')
 1027 FORMAT ('+',15X,'ON')
 1028 FORMAT (5X,'TITLE SIZE IN PWRIT UNITS, STL=',I4)
 1029 FORMAT (5X,'TITLE=',A64)
 1030 FORMAT (5X,'DATA POINTS USED FOR PARTIAL DERIVATIVE',
     1' ESTIMATION,  NCP=',I4)
 1031 FORMAT (5X,'LOOK AT TRIANGLES, TRI=')
 1032 FORMAT ('+',27X,'OFF')
 1033 FORMAT ('+',27X,'ON')
 1034 FORMAT (5X,'ADVANCE FRAME BEFORE PLOTTING TRIANGULATION,',
     1' TFR=')
 1035 FORMAT ('+',53X,'OFF')
 1036 FORMAT ('+',53X,'ON')
 1037 FORMAT (5X,'TRIANGULATION ONLY PLOT, TOP=')
 1038 FORMAT ('+',33X,'OFF')
 1039 FORMAT ('+',33X,'ON')
 1040 FORMAT (5X,'PLOT THE INPUT DATA VALUES, PDV=')
 1041 FORMAT ('+',36X,'OFF')
 1042 FORMAT ('+',36X,'ON')
 1043 FORMAT (5X,'FORMAT OF THE PLOTTED INPUT DATA, FMT=')
 1044 FORMAT ('+',42X,'(G10.3)')
 1045 FORMAT ('+',42X,A10)
 1046 FORMAT (5X,'SIZE OF THE PLOTTED DATA VALUES IN PWRIT',
     1' UNITS, SPD=',I4)
 1047 FORMAT (5X,'COLOR (INTENSITY) INDICES FOLLOW.',
     1' FOR CONRAQ MAJOR CONTOURS ARE ONLY USED')
 1048 FORMAT (10X,'MAJOR CONTOUR LINES, MAJ=',I4,/
     1        ,10X,'MINOR CONTOUR LINES, MIN=',I4,/
     2        ,10X,'TITLE AND MESSAGE, LAB=',I4,/
     3        ,10X,'PLOTTED DATA VALUES, DAT=',I4)
 1049 FORMAT (5X,'CONTOUR LEVELS,  CON=')
 1050 FORMAT ('+',25X,'OFF')
 1051 FORMAT ('+',25X,'ON, NCL=',I4,' ARRAY='/(10(2X,F10.3)))
 1052 FORMAT (5X,'CONTOUR INCREMENT, CIL=')
 1053 FORMAT ('+',27X,'OFF')
 1054 FORMAT ('+',27X,'ON, INCREMENT=',G10.3)
 1055 FORMAT (5X,'CONTOUR HIGH AND LOW VALUES, CHL=')
 1056 FORMAT ('+',37X,'OFF')
 1057 FORMAT ('+',37X,'ON, HI=',G10.3,' FLO=',G10.3)
 2000 FORMAT (5X,'SHIELDING, SLD=')
 2001 FORMAT ('+',19X,'OFF')
 2002 FORMAT ('+',19X,'ON')
 2003 FORMAT (5X,'INTERPOLATION, ITP=')
 2004 FORMAT ('+',23X,'C1 SURFACE')
 2005 FORMAT ('+',23X,'LINEAR')
 2006 FORMAT (5X,'PLOT THE SHIELD, SPT=')
 2007 FORMAT ('+',25X,'OFF')
 2008 FORMAT ('+',25X,'ON')
C
      END

C
C      $Id: cn13f.f,v 1.8 2010-03-15 22:49:23 haley Exp $
C
C***********************************************************************
C                                                                      *
C                            Copyright (C)  1995                       *
C                 University Corporation for Atmospheric Research      *
C                            All Rights Reserved                       *
C                                                                      *
C***********************************************************************
C
C  File:       cn13f.f
C
C  Author:     Mary Haley
C          National Center for Atmospheric Research
C          PO 3000, Boulder, Colorado
C
C  Date:       Mon Nov 27 10:23:59 MST 1995
C
C  Description:  This example emulates LLU example "mpex10".  It shows
C                how to do inverse map tranformations and raster contour
C                plots.
C
      external NhlFAppClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFCairoWindowWorkstationClass
      external NhlFScalarFieldClass
      external NhlFContourPlotClass
      external NhlFMapPlotClass

      parameter(NCLS=300,NC=NCLS*NCLS,DTOR=.017453292519943,NCOLORS=66)

      real x(NC), y(NC),rlat(NC), rlon(NC)
      real icra(NCLS,NCLS), dval, oor, miss_val
      data miss_val/1.e12/
      integer count(2)
      integer appid, workid, dataid, cnid, mpid
      integer srlist, i, j, l, status, ierr, ierrx, ierry
C
C Declare variables for defining color map.
C
      integer length(2)
      real   cmap(3,NCOLORS)
      character*7  wks_type
C
C Default is to display to an X11 window.
C
      wks_type = "x11"

C     
C Initialize the HLU library and set up resource template.
C
      call NhlFInitialize
      call NhlFRLCreate(srlist,'SETRL')
C
C Create an application object.
C
      call NhlFRLClear(srlist)
      call NhlFRLSetstring(srlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'cn13',NhlFAppClass,0,srlist,ierr)
C
C Modify the color map. Colors for contour fill areas varying from
C blue to red.
C
      cmap( 1,1) = 0.00
      cmap( 2,1) = 0.00
      cmap( 3,1) = 0.00
      cmap( 1,2) = 1.00
      cmap( 2,2) = 1.00
      cmap( 3,2) = 1.00
      do 10 i = 2,NCOLORS-1
         cmap(1,i+1) = real(i-2)/real(NCOLORS-3)
         cmap(2,i+1) = 0.
         cmap(3,i+1) = real((NCOLORS-2)-(i-1))/real(NCOLORS-3)
 10   continue
                                   
      length(1) = 3
      length(2) = NCOLORS

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetstring(srlist,'wkMetaName','./cn13f.ncgm',ierr)
         call NhlFRLSetMDFloatArray(srlist,'wkColorMap',cmap,2,length,
     +        ierr)
         call NhlFCreate(workid,'cn13Work',NhlFNcgmWorkstationClass,
     +        0,srlist,ierr) 
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetstring(srlist,'wkPause','True',ierr)
         call NhlFRLSetMDFloatArray(srlist,'wkColorMap',cmap,2,length,
     +        ierr)
         call NhlFCreate(workid,'cn13Work',
     +        NhlFCairoWindowWorkstationClass,
     +        0,srlist,ierr) 
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PostScript workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetstring(srlist,'wkPSFileName','./cn13f.ps',ierr)
         call NhlFRLSetMDFloatArray(srlist,'wkColorMap',cmap,2,length,
     +        ierr)
         call NhlFCreate(workid,'cn13Work',NhlFPSWorkstationClass,
     +        0,srlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetstring(srlist,'wkPDFFileName','./cn13f.pdf',ierr)
         call NhlFRLSetMDFloatArray(srlist,'wkColorMap',cmap,2,length,
     +        ierr)
         call NhlFCreate(workid,'cn13Work',NhlFPDFWorkstationClass,
     +        0,srlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF object.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetstring(srlist,'wkFileName','./cn13f',ierr)
         call NhlFRLSetstring(srlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetMDFloatArray(srlist,'wkColorMap',cmap,2,length,
     +        ierr)
         call NhlFCreate(workid,'cn13Work',
     +        NhlFCairoPSPDFWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG object.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetstring(srlist,'wkFileName','./cn13f',ierr)
         call NhlFRLSetstring(srlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetMDFloatArray(srlist,'wkColorMap',cmap,2,length,
     +        ierr)
         call NhlFCreate(workid,'cn13Work',
     +        NhlFCairoImageWorkstationClass,0,srlist,ierr)
      endif
C
C Create a MapPlot object.
C
      call NhlFRLClear(srlist)
      call NhlFRLSetString(srlist,'mpProjection','Orthographic',ierr)
      call NhlFRLSetFloat(srlist,'mpCenterLatF',40.,ierr)
      call NhlFRLSetFloat(srlist,'mpCenterLonF',-105.,ierr)
      call NhlFRLSetFloat(srlist,'mpCenterRotF',0.,ierr)
      call NhlFCreate(mpid,'MapPlot',nhlfmapplotclass,workid,srlist,
     +     ierr)
C
C Calculate nice range of x,y values, and then get their
C corresponding lon,lat values.
C
      l = 1
      do 20 i=1,NCLS
         do 15 j=1,NCLS
            x(l) = .05+.90*(real(i)+.5)/real(NCLS)
            y(l) = .05+.90*(real(j)+.5)/real(NCLS)
            l = l+1
 15      continue
 20   continue
      call NhlFNDCToData(mpid,x,y,NC,rlon,rlat,0.,0.,ierrx,ierry,
     +     status,oor,ierr)
C
C Now create a cell array.
C
      l = 1
      do 30 i=1,NCLS
         do 25 j=1,NCLS
            if (rlat(l) .eq. oor) then
               icra(i,j) = miss_val
            else
               dval=.25*(1.+cos(DTOR*10.*rlat(l)))+
     +              .25*(1.+sin(DTOR*10.*rlon(l)))*cos(DTOR*rlat(l))
               icra(i,j) = 2.+dval*real(NCOLORS-2)
               if( icra(i,j).ne.miss_val) then
                  icra(i,j) = min(real(NCOLORS-1),icra(i,j))
               endif
            endif
            l = l+1
 25      continue
 30   continue
C
C Create a ScalarField object.
C
      count(1) = NCLS
      count(2) = NCLS
      call NhlFRLClear(srlist)
      call NhlFRLSetMDFloatArray(srlist,'sfDataArray',icra,2,count,
     +     ierr)
      call NhlFRLSetFloat(srlist,'sfMissingValueV',miss_val,ierr)
      call NhlFCreate(dataid,'DataItem',nhlfscalarfieldclass,appid,
     +     srlist,ierr)
C
C Create ContourPlot object.
C
      call NhlFRLClear(srlist)
      call NhlFRLSetInteger(srlist,'cnScalarFieldData',dataid,ierr)
      call NhlFCreate(cnid,'ContourPlot',nhlfcontourplotclass,workid,
     +     srlist,ierr)
C
C Draw MapPlot on ContourPlot.
C
      call NhlFDraw(cnid,ierr)
      call NhlFDraw(mpid,ierr)
      call NhlFFrame(workid,ierr)
C
C NhlDestroy destroys the given id and all of its children.
C
      call NhlFRLDestroy(srlist)
      call NhlFDestroy(workid,ierr)
C
C Restores state.
C
      call NhlFClose
      stop
      end

      SUBROUTINE ZGELS( TRANS, M, N, NRHS, A, LDA, B, LDB, WORK, LWORK,
     $                  INFO )
*
*  -- LAPACK driver routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          TRANS
      INTEGER            INFO, LDA, LDB, LWORK, M, N, NRHS
*     ..
*     .. Array Arguments ..
      COMPLEX*16         A( LDA, * ), B( LDB, * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  ZGELS solves overdetermined or underdetermined complex linear systems
*  involving an M-by-N matrix A, or its conjugate-transpose, using a QR
*  or LQ factorization of A.  It is assumed that A has full rank.
*
*  The following options are provided:
*
*  1. If TRANS = 'N' and m >= n:  find the least squares solution of
*     an overdetermined system, i.e., solve the least squares problem
*                  minimize || B - A*X ||.
*
*  2. If TRANS = 'N' and m < n:  find the minimum norm solution of
*     an underdetermined system A * X = B.
*
*  3. If TRANS = 'C' and m >= n:  find the minimum norm solution of
*     an undetermined system A**H * X = B.
*
*  4. If TRANS = 'C' and m < n:  find the least squares solution of
*     an overdetermined system, i.e., solve the least squares problem
*                  minimize || B - A**H * X ||.
*
*  Several right hand side vectors b and solution vectors x can be
*  handled in a single call; they are stored as the columns of the
*  M-by-NRHS right hand side matrix B and the N-by-NRHS solution
*  matrix X.
*
*  Arguments
*  =========
*
*  TRANS   (input) CHARACTER
*          = 'N': the linear system involves A;
*          = 'C': the linear system involves A**H.
*
*  M       (input) INTEGER
*          The number of rows of the matrix A.  M >= 0.
*
*  N       (input) INTEGER
*          The number of columns of the matrix A.  N >= 0.
*
*  NRHS    (input) INTEGER
*          The number of right hand sides, i.e., the number of
*          columns of the matrices B and X. NRHS >= 0.
*
*  A       (input/output) COMPLEX*16 array, dimension (LDA,N)
*          On entry, the M-by-N matrix A.
*            if M >= N, A is overwritten by details of its QR
*                       factorization as returned by ZGEQRF;
*            if M <  N, A is overwritten by details of its LQ
*                       factorization as returned by ZGELQF.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(1,M).
*
*  B       (input/output) COMPLEX*16 array, dimension (LDB,NRHS)
*          On entry, the matrix B of right hand side vectors, stored
*          columnwise; B is M-by-NRHS if TRANS = 'N', or N-by-NRHS
*          if TRANS = 'C'.
*          On exit, B is overwritten by the solution vectors, stored
*          columnwise:
*          if TRANS = 'N' and m >= n, rows 1 to n of B contain the least
*          squares solution vectors; the residual sum of squares for the
*          solution in each column is given by the sum of squares of
*          elements N+1 to M in that column;
*          if TRANS = 'N' and m < n, rows 1 to N of B contain the
*          minimum norm solution vectors;
*          if TRANS = 'C' and m >= n, rows 1 to M of B contain the
*          minimum norm solution vectors;
*          if TRANS = 'C' and m < n, rows 1 to M of B contain the
*          least squares solution vectors; the residual sum of squares
*          for the solution in each column is given by the sum of
*          squares of elements M+1 to N in that column.
*
*  LDB     (input) INTEGER
*          The leading dimension of the array B. LDB >= MAX(1,M,N).
*
*  WORK    (workspace/output) COMPLEX*16 array, dimension (LWORK)
*          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*
*  LWORK   (input) INTEGER
*          The dimension of the array WORK.
*          LWORK >= max( 1, MN + max( MN, NRHS ) ).
*          For optimal performance,
*          LWORK >= max( 1, MN + max( MN, NRHS )*NB ).
*          where MN = min(M,N) and NB is the optimum block size.
*
*          If LWORK = -1, then a workspace query is assumed; the routine
*          only calculates the optimal size of the WORK array, returns
*          this value as the first entry of the WORK array, and no error
*          message related to LWORK is issued by XERBLA.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO, ONE
      PARAMETER          ( ZERO = 0.0D+0, ONE = 1.0D+0 )
      COMPLEX*16         CZERO, CONE
      PARAMETER          ( CZERO = ( 0.0D+0, 0.0D+0 ),
     $                   CONE = ( 1.0D+0, 0.0D+0 ) )
*     ..
*     .. Local Scalars ..
      LOGICAL            LQUERY, TPSD
      INTEGER            BROW, I, IASCL, IBSCL, J, MN, NB, SCLLEN, WSIZE
      DOUBLE PRECISION   ANRM, BIGNUM, BNRM, SMLNUM
*     ..
*     .. Local Arrays ..
      DOUBLE PRECISION   RWORK( 1 )
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            ILAENV
      DOUBLE PRECISION   DLAMCH, ZLANGE
      EXTERNAL           LSAME, ILAENV, DLAMCH, ZLANGE
*     ..
*     .. External Subroutines ..
      EXTERNAL           XERBLA, ZGELQF, ZGEQRF, ZLASCL, ZLASET, ZTRSM,
     $                   ZUNMLQ, ZUNMQR
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          DBLE, MAX, MIN
*     ..
*     .. Executable Statements ..
*
*     Test the input arguments.
*
      INFO = 0
      MN = MIN( M, N )
      LQUERY = ( LWORK.EQ.-1 )
      IF( .NOT.( LSAME( TRANS, 'N' ) .OR. LSAME( TRANS, 'C' ) ) ) THEN
         INFO = -1
      ELSE IF( M.LT.0 ) THEN
         INFO = -2
      ELSE IF( N.LT.0 ) THEN
         INFO = -3
      ELSE IF( NRHS.LT.0 ) THEN
         INFO = -4
      ELSE IF( LDA.LT.MAX( 1, M ) ) THEN
         INFO = -6
      ELSE IF( LDB.LT.MAX( 1, M, N ) ) THEN
         INFO = -8
      ELSE IF( LWORK.LT.MAX( 1, MN+MAX( MN, NRHS ) ) .AND. .NOT.LQUERY )
     $          THEN
         INFO = -10
      END IF
*
*     Figure out optimal block size
*
      IF( INFO.EQ.0 .OR. INFO.EQ.-10 ) THEN
*
         TPSD = .TRUE.
         IF( LSAME( TRANS, 'N' ) )
     $      TPSD = .FALSE.
*
         IF( M.GE.N ) THEN
            NB = ILAENV( 1, 'ZGEQRF', ' ', M, N, -1, -1 )
            IF( TPSD ) THEN
               NB = MAX( NB, ILAENV( 1, 'ZUNMQR', 'LN', M, NRHS, N,
     $              -1 ) )
            ELSE
               NB = MAX( NB, ILAENV( 1, 'ZUNMQR', 'LC', M, NRHS, N,
     $              -1 ) )
            END IF
         ELSE
            NB = ILAENV( 1, 'ZGELQF', ' ', M, N, -1, -1 )
            IF( TPSD ) THEN
               NB = MAX( NB, ILAENV( 1, 'ZUNMLQ', 'LC', N, NRHS, M,
     $              -1 ) )
            ELSE
               NB = MAX( NB, ILAENV( 1, 'ZUNMLQ', 'LN', N, NRHS, M,
     $              -1 ) )
            END IF
         END IF
*
         WSIZE = MAX( 1, MN+MAX( MN, NRHS )*NB )
         WORK( 1 ) = DBLE( WSIZE )
*
      END IF
*
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'ZGELS ', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( MIN( M, N, NRHS ).EQ.0 ) THEN
         CALL ZLASET( 'Full', MAX( M, N ), NRHS, CZERO, CZERO, B, LDB )
         RETURN
      END IF
*
*     Get machine parameters
*
      SMLNUM = DLAMCH( 'S' ) / DLAMCH( 'P' )
      BIGNUM = ONE / SMLNUM
      CALL DLABAD( SMLNUM, BIGNUM )
*
*     Scale A, B if max element outside range [SMLNUM,BIGNUM]
*
      ANRM = ZLANGE( 'M', M, N, A, LDA, RWORK )
      IASCL = 0
      IF( ANRM.GT.ZERO .AND. ANRM.LT.SMLNUM ) THEN
*
*        Scale matrix norm up to SMLNUM
*
         CALL ZLASCL( 'G', 0, 0, ANRM, SMLNUM, M, N, A, LDA, INFO )
         IASCL = 1
      ELSE IF( ANRM.GT.BIGNUM ) THEN
*
*        Scale matrix norm down to BIGNUM
*
         CALL ZLASCL( 'G', 0, 0, ANRM, BIGNUM, M, N, A, LDA, INFO )
         IASCL = 2
      ELSE IF( ANRM.EQ.ZERO ) THEN
*
*        Matrix all zero. Return zero solution.
*
         CALL ZLASET( 'F', MAX( M, N ), NRHS, CZERO, CZERO, B, LDB )
         GO TO 50
      END IF
*
      BROW = M
      IF( TPSD )
     $   BROW = N
      BNRM = ZLANGE( 'M', BROW, NRHS, B, LDB, RWORK )
      IBSCL = 0
      IF( BNRM.GT.ZERO .AND. BNRM.LT.SMLNUM ) THEN
*
*        Scale matrix norm up to SMLNUM
*
         CALL ZLASCL( 'G', 0, 0, BNRM, SMLNUM, BROW, NRHS, B, LDB,
     $                INFO )
         IBSCL = 1
      ELSE IF( BNRM.GT.BIGNUM ) THEN
*
*        Scale matrix norm down to BIGNUM
*
         CALL ZLASCL( 'G', 0, 0, BNRM, BIGNUM, BROW, NRHS, B, LDB,
     $                INFO )
         IBSCL = 2
      END IF
*
      IF( M.GE.N ) THEN
*
*        compute QR factorization of A
*
         CALL ZGEQRF( M, N, A, LDA, WORK( 1 ), WORK( MN+1 ), LWORK-MN,
     $                INFO )
*
*        workspace at least N, optimally N*NB
*
         IF( .NOT.TPSD ) THEN
*
*           Least-Squares Problem min || A * X - B ||
*
*           B(1:M,1:NRHS) := Q' * B(1:M,1:NRHS)
*
            CALL ZUNMQR( 'Left', 'Conjugate transpose', M, NRHS, N, A,
     $                   LDA, WORK( 1 ), B, LDB, WORK( MN+1 ), LWORK-MN,
     $                   INFO )
*
*           workspace at least NRHS, optimally NRHS*NB
*
*           B(1:N,1:NRHS) := inv(R) * B(1:N,1:NRHS)
*
            CALL ZTRSM( 'Left', 'Upper', 'No transpose', 'Non-unit', N,
     $                  NRHS, CONE, A, LDA, B, LDB )
*
            SCLLEN = N
*
         ELSE
*
*           Overdetermined system of equations A' * X = B
*
*           B(1:N,1:NRHS) := inv(R') * B(1:N,1:NRHS)
*
            CALL ZTRSM( 'Left', 'Upper', 'Conjugate transpose',
     $                  'Non-unit', N, NRHS, CONE, A, LDA, B, LDB )
*
*           B(N+1:M,1:NRHS) = ZERO
*
            DO 20 J = 1, NRHS
               DO 10 I = N + 1, M
                  B( I, J ) = CZERO
   10          CONTINUE
   20       CONTINUE
*
*           B(1:M,1:NRHS) := Q(1:N,:) * B(1:N,1:NRHS)
*
            CALL ZUNMQR( 'Left', 'No transpose', M, NRHS, N, A, LDA,
     $                   WORK( 1 ), B, LDB, WORK( MN+1 ), LWORK-MN,
     $                   INFO )
*
*           workspace at least NRHS, optimally NRHS*NB
*
            SCLLEN = M
*
         END IF
*
      ELSE
*
*        Compute LQ factorization of A
*
         CALL ZGELQF( M, N, A, LDA, WORK( 1 ), WORK( MN+1 ), LWORK-MN,
     $                INFO )
*
*        workspace at least M, optimally M*NB.
*
         IF( .NOT.TPSD ) THEN
*
*           underdetermined system of equations A * X = B
*
*           B(1:M,1:NRHS) := inv(L) * B(1:M,1:NRHS)
*
            CALL ZTRSM( 'Left', 'Lower', 'No transpose', 'Non-unit', M,
     $                  NRHS, CONE, A, LDA, B, LDB )
*
*           B(M+1:N,1:NRHS) = 0
*
            DO 40 J = 1, NRHS
               DO 30 I = M + 1, N
                  B( I, J ) = CZERO
   30          CONTINUE
   40       CONTINUE
*
*           B(1:N,1:NRHS) := Q(1:N,:)' * B(1:M,1:NRHS)
*
            CALL ZUNMLQ( 'Left', 'Conjugate transpose', N, NRHS, M, A,
     $                   LDA, WORK( 1 ), B, LDB, WORK( MN+1 ), LWORK-MN,
     $                   INFO )
*
*           workspace at least NRHS, optimally NRHS*NB
*
            SCLLEN = N
*
         ELSE
*
*           overdetermined system min || A' * X - B ||
*
*           B(1:N,1:NRHS) := Q * B(1:N,1:NRHS)
*
            CALL ZUNMLQ( 'Left', 'No transpose', N, NRHS, M, A, LDA,
     $                   WORK( 1 ), B, LDB, WORK( MN+1 ), LWORK-MN,
     $                   INFO )
*
*           workspace at least NRHS, optimally NRHS*NB
*
*           B(1:M,1:NRHS) := inv(L') * B(1:M,1:NRHS)
*
            CALL ZTRSM( 'Left', 'Lower', 'Conjugate transpose',
     $                  'Non-unit', M, NRHS, CONE, A, LDA, B, LDB )
*
            SCLLEN = M
*
         END IF
*
      END IF
*
*     Undo scaling
*
      IF( IASCL.EQ.1 ) THEN
         CALL ZLASCL( 'G', 0, 0, ANRM, SMLNUM, SCLLEN, NRHS, B, LDB,
     $                INFO )
      ELSE IF( IASCL.EQ.2 ) THEN
         CALL ZLASCL( 'G', 0, 0, ANRM, BIGNUM, SCLLEN, NRHS, B, LDB,
     $                INFO )
      END IF
      IF( IBSCL.EQ.1 ) THEN
         CALL ZLASCL( 'G', 0, 0, SMLNUM, BNRM, SCLLEN, NRHS, B, LDB,
     $                INFO )
      ELSE IF( IBSCL.EQ.2 ) THEN
         CALL ZLASCL( 'G', 0, 0, BIGNUM, BNRM, SCLLEN, NRHS, B, LDB,
     $                INFO )
      END IF
*
   50 CONTINUE
      WORK( 1 ) = DBLE( WSIZE )
*
      RETURN
*
*     End of ZGELS
*
      END

C
C	$Id: sfskbk.f,v 1.4 2008-07-27 12:23:42 haley Exp $
C
C			     Copyright (C)  1997
C	     University Corporation for Atmospheric Research
C			     All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
C

      SUBROUTINE SFSKBK(IOS, STATUS)
C
C  Set COMMON variable IPTR to point to the next non-blank
C  character in the file, the current line of which is stored
C  in character array LINE.
C
C  OUTPUT
C       IOS    - The I/O status, this value has meaning only if an 
C                error condition obtains (i.e. only if STATUS .GT. 0).
C       STATUS - Status indicator, see subroutine SFPRCF for details.
C
      include 'fnttab.h'
      include 'fnterr.h'
      include 'fntcom.h'
C
      INTEGER IOS, STATUS
      CHARACTER*1 BLANK
      INTEGER II
C
      DATA BLANK/' '/
C
C  Scan the current line for a non-blank.
C
 10   CONTINUE
      DO 20 II = IPTR,LSIZE
        IF (LINE(II:II) .NE. BLANK) THEN
C
C  Non-blank found.
C
          IPTR = II
          RETURN
        END IF
 20   CONTINUE
C
C  End of current line and no no non-blank has been found,
C  get another line.
C
      CALL CFRDLN (ID1,ID2,STATUS)
C
C  Return if EOF or bad read.
C
      IF (STATUS.NE.ALLOK) RETURN
C
C  Go back and scan this line.
C
      GO TO 10
C
      END

C
C $Id: mlfndp.f,v 1.5 2008-07-27 00:17:09 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      DOUBLE PRECISION FUNCTION MLFNDP (E0,E1,E2,E3,PHI)
C
C This function computes the constant M.
C
      IMPLICIT DOUBLE PRECISION (A-Z)
      DATA TWO,FOUR,SIX /2.0D0,4.0D0,6.0D0/
C
      MLFNDP = E0 * PHI - E1 * SIN (TWO * PHI) + E2 * SIN (FOUR * PHI)
     * - E3 * SIN (SIX * PHI)
C
      RETURN
      END

      SUBROUTINE DGTTRS( TRANS, N, NRHS, DL, D, DU, DU2, IPIV, B, LDB,
     $                   INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          TRANS
      INTEGER            INFO, LDB, N, NRHS
*     ..
*     .. Array Arguments ..
      INTEGER            IPIV( * )
      DOUBLE PRECISION   B( LDB, * ), D( * ), DL( * ), DU( * ), DU2( * )
*     ..
*
*  Purpose
*  =======
*
*  DGTTRS solves one of the systems of equations
*     A*X = B  or  A'*X = B,
*  with a tridiagonal matrix A using the LU factorization computed
*  by DGTTRF.
*
*  Arguments
*  =========
*
*  TRANS   (input) CHARACTER
*          Specifies the form of the system of equations.
*          = 'N':  A * X = B  (No transpose)
*          = 'T':  A'* X = B  (Transpose)
*          = 'C':  A'* X = B  (Conjugate transpose = Transpose)
*
*  N       (input) INTEGER
*          The order of the matrix A.
*
*  NRHS    (input) INTEGER
*          The number of right hand sides, i.e., the number of columns
*          of the matrix B.  NRHS >= 0.
*
*  DL      (input) DOUBLE PRECISION array, dimension (N-1)
*          The (n-1) multipliers that define the matrix L from the
*          LU factorization of A.
*
*  D       (input) DOUBLE PRECISION array, dimension (N)
*          The n diagonal elements of the upper triangular matrix U from
*          the LU factorization of A.
*
*  DU      (input) DOUBLE PRECISION array, dimension (N-1)
*          The (n-1) elements of the first super-diagonal of U.
*
*  DU2     (input) DOUBLE PRECISION array, dimension (N-2)
*          The (n-2) elements of the second super-diagonal of U.
*
*  IPIV    (input) INTEGER array, dimension (N)
*          The pivot indices; for 1 <= i <= n, row i of the matrix was
*          interchanged with row IPIV(i).  IPIV(i) will always be either
*          i or i+1; IPIV(i) = i indicates a row interchange was not
*          required.
*
*  B       (input/output) DOUBLE PRECISION array, dimension (LDB,NRHS)
*          On entry, the matrix of right hand side vectors B.
*          On exit, B is overwritten by the solution vectors X.
*
*  LDB     (input) INTEGER
*          The leading dimension of the array B.  LDB >= max(1,N).
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*
*  =====================================================================
*
*     .. Local Scalars ..
      LOGICAL            NOTRAN
      INTEGER            ITRANS, J, JB, NB
*     ..
*     .. External Functions ..
      INTEGER            ILAENV
      EXTERNAL           ILAENV
*     ..
*     .. External Subroutines ..
      EXTERNAL           DGTTS2, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN
*     ..
*     .. Executable Statements ..
*
      INFO = 0
      NOTRAN = ( TRANS.EQ.'N' .OR. TRANS.EQ.'n' )
      IF( .NOT.NOTRAN .AND. .NOT.( TRANS.EQ.'T' .OR. TRANS.EQ.
     $    't' ) .AND. .NOT.( TRANS.EQ.'C' .OR. TRANS.EQ.'c' ) ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( NRHS.LT.0 ) THEN
         INFO = -3
      ELSE IF( LDB.LT.MAX( N, 1 ) ) THEN
         INFO = -10
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DGTTRS', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 .OR. NRHS.EQ.0 )
     $   RETURN
*
*     Decode TRANS
*
      IF( NOTRAN ) THEN
         ITRANS = 0
      ELSE
         ITRANS = 1
      END IF
*
*     Determine the number of right-hand sides to solve at a time.
*
      IF( NRHS.EQ.1 ) THEN
         NB = 1
      ELSE
         NB = MAX( 1, ILAENV( 1, 'DGTTRS', TRANS, N, NRHS, -1, -1 ) )
      END IF
*
      IF( NB.GE.NRHS ) THEN
         CALL DGTTS2( ITRANS, N, NRHS, DL, D, DU, DU2, IPIV, B, LDB )
      ELSE
         DO 10 J = 1, NRHS, NB
            JB = MIN( NRHS-J+1, NB )
            CALL DGTTS2( ITRANS, N, JB, DL, D, DU, DU2, IPIV, B( 1, J ),
     $                   LDB )
   10    CONTINUE
      END IF
*
*     End of DGTTRS
*
      END

      SUBROUTINE CPPTRS( UPLO, N, NRHS, AP, B, LDB, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER          UPLO
      INTEGER            INFO, LDB, N, NRHS
*     ..
*     .. Array Arguments ..
      COMPLEX            AP( * ), B( LDB, * )
*     ..
*
*  Purpose
*  =======
*
*  CPPTRS solves a system of linear equations A*X = B with a Hermitian
*  positive definite matrix A in packed storage using the Cholesky
*  factorization A = U**H*U or A = L*L**H computed by CPPTRF.
*
*  Arguments
*  =========
*
*  UPLO    (input) CHARACTER*1
*          = 'U':  Upper triangle of A is stored;
*          = 'L':  Lower triangle of A is stored.
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  NRHS    (input) INTEGER
*          The number of right hand sides, i.e., the number of columns
*          of the matrix B.  NRHS >= 0.
*
*  AP      (input) COMPLEX array, dimension (N*(N+1)/2)
*          The triangular factor U or L from the Cholesky factorization
*          A = U**H*U or A = L*L**H, packed columnwise in a linear
*          array.  The j-th column of U or L is stored in the array AP
*          as follows:
*          if UPLO = 'U', AP(i + (j-1)*j/2) = U(i,j) for 1<=i<=j;
*          if UPLO = 'L', AP(i + (j-1)*(2n-j)/2) = L(i,j) for j<=i<=n.
*
*  B       (input/output) COMPLEX array, dimension (LDB,NRHS)
*          On entry, the right hand side matrix B.
*          On exit, the solution matrix X.
*
*  LDB     (input) INTEGER
*          The leading dimension of the array B.  LDB >= max(1,N).
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*
*  =====================================================================
*
*     .. Local Scalars ..
      LOGICAL            UPPER
      INTEGER            I
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           CTPSV, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      UPPER = LSAME( UPLO, 'U' )
      IF( .NOT.UPPER .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( NRHS.LT.0 ) THEN
         INFO = -3
      ELSE IF( LDB.LT.MAX( 1, N ) ) THEN
         INFO = -6
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'CPPTRS', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 .OR. NRHS.EQ.0 )
     $   RETURN
*
      IF( UPPER ) THEN
*
*        Solve A*X = B where A = U'*U.
*
         DO 10 I = 1, NRHS
*
*           Solve U'*X = B, overwriting B with X.
*
            CALL CTPSV( 'Upper', 'Conjugate transpose', 'Non-unit', N,
     $                  AP, B( 1, I ), 1 )
*
*           Solve U*X = B, overwriting B with X.
*
            CALL CTPSV( 'Upper', 'No transpose', 'Non-unit', N, AP,
     $                  B( 1, I ), 1 )
   10    CONTINUE
      ELSE
*
*        Solve A*X = B where A = L*L'.
*
         DO 20 I = 1, NRHS
*
*           Solve L*Y = B, overwriting B with X.
*
            CALL CTPSV( 'Lower', 'No transpose', 'Non-unit', N, AP,
     $                  B( 1, I ), 1 )
*
*           Solve L'*X = Y, overwriting B with X.
*
            CALL CTPSV( 'Lower', 'Conjugate transpose', 'Non-unit', N,
     $                  AP, B( 1, I ), 1 )
   20    CONTINUE
      END IF
*
      RETURN
*
*     End of CPPTRS
*
      END

C
C	$Id: gqopwk.f,v 1.5 2008-07-27 00:21:00 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GQOPWK(N,ERRIND,OL,WKID)
C
C  INQUIRE SET member OF OPEN WORKSTATIONS
C
      include 'gkscom.h'
C
      INTEGER N,ERRIND,OL,WKID
C
C  Check that GKS is in the proper state.
C
      CALL GZCKST(8,-1,ERRIND)
      IF (ERRIND .NE. 0) GOTO 100
C
C  Check if N is in bounds.
C
      IF (N.LT.0 .OR. N.GT.NOPWK) THEN
        ERRIND = 2002
        GOTO 100
      ENDIF
C
      OL   = NOPWK
      IF (N .EQ. 0) RETURN
      WKID = SOPWK(N)
      RETURN
C
  100 CONTINUE
      OL   = NOPWK
      WKID = -1
      RETURN
      END

C
C $Id: mdscal.f,v 1.8 2008-09-18 00:42:18 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      DOUBLE PRECISION FUNCTION MDSCAL (XCOP,YCOP,XCOQ,YCOQ)
C
        REAL XCOP,YCOP,XCOQ,YCOQ
C
C If (XCOP,YCOP) and (XCOQ,YCOQ) are the fractional coordinates of two
C points that are the projections (in a manner specified by the current
C state of EZMAP's internal parameters) of two points, P and Q, on the
C surface of the globe, then the value of
C
C     MDSCAL(XCOP,YCOP,XCOQ,YCOQ)
C
C is the angular distance, in degrees, between P and Q, divided by the
C distance, in the fractional coordinate system, between the points that
C represent P and Q on the map.  This may be used to estimate the scale
C of the map in a particular location and a particular direction.
C
C Note that the scale of a map is a unitless quantity representing the
C ratio of a distance on the map to a distance on the globe.  Because
C EZMAP has no way of knowing at what size a map will be displayed, it
C cannot compute an actual scale.
C
C Note also that this routine calls MDGDDP to compute the angular
C distance from A to B and that that routine assumes a spherical earth.
C
        DOUBLE PRECISION MDGDDP,PLAT,PLON,QLAT,QLON
C
C Pre-set value in case we take an error exit.
C
        MDSCAL=0.D0
C
C Find the latitude and longitude of P.
C
        CALL MDPTRI (DBLE(CFUX(XCOP)),DBLE(CFUY(YCOP)),PLAT,PLON)
C
C Find the latitude and longitude of Q.
C
        CALL MDPTRI (DBLE(CFUX(XCOQ)),DBLE(CFUY(YCOQ)),QLAT,QLON)
C
C Compute the angular distance from P to Q and divide by the distance
C between the points on the map in the fractional system.  If either
C point is not projectable, a zero is returned for the scale.
C
        IF (PLAT.NE.1.D12.AND.QLAT.NE.1.D12)
     +    MDSCAL=MDGDDP(PLAT,PLON,QLAT,QLON)/
     +                         DBLE(SQRT((XCOP-XCOQ)**2+(YCOP-YCOQ)**2))
C
C Done.
C
        RETURN
C
      END

      PROGRAM FGKE02
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C  Define error file, Fortran unit number, and workstation type,
C  and workstation ID.
C
C PURPOSE                To provide a simple demonstration of the
C                        GFLASH package.
C
C I/O                    If there is a normal exit from GFLASH,
C                        the message
C
C                          GFLASH TEST SUCCESSFUL . . . SEE PLOTS TO
C                          VERIFY PERFORMANCE
C
C                        is written on unit 6
C
C NOTE                   The call to GOPWK will have to be modified
C                        when using a non-NCAR GKS package.  The third
C                        argument must be the workstation type for WISS.
C
C
C  Data for the border and two lines.
C
      DIMENSION PERIMX(5),PERIMY(5)
      DATA      PERIMX/0., 1., 1., 0., 0./
      DATA      PERIMY/0., 0., 1., 1., 0./
C
      DIMENSION RLIN1X(2),RLIN1Y(2)
      DATA      RLIN1X/.25,.75/
      DATA      RLIN1Y/.25,.75/
C
      DIMENSION RLIN2X(2),RLIN2Y(2)
      DATA      RLIN2X/.75,.25/
      DATA      RLIN2Y/.25,.75/
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C  Initialize the GFLASH package.  If using a non-NCAR GKS package
C  the final argument in the following call should be replaced with
C  the workstation type for WISS.
C
      CALL GOPWK(9,1,3)
C
C  Establish character height and text alignment.
C
C
C  Put a line with positive slope into flash buffer 1.
C
      CALL GFLAS1(1)
      CALL GPL(2,RLIN1X,RLIN1Y)
      CALL GFLAS2
C
C  Put a line with negative slope into flash buffer 2.
C
      CALL GFLAS1(2)
      CALL GPL(2,RLIN2X,RLIN2Y)
      CALL GFLAS2
C
C  Draw the border.
C
      CALL GPL(5,PERIMX,PERIMY)
C
C  Put the two segments into the picture.
C
      CALL GFLAS3(1)
      CALL GFLAS3(2)
      CALL FRAME
C
C  Close the GFLASH package.
C
      CALL GCLWK(9)
C
C  Deactivate and close the metafile workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      END

C
C $Id: mapgci.f,v 1.18 2008-09-18 00:42:16 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MAPGCI (ALAT,ALON,BLAT,BLON,NOPI,RLTI,RLNI)
C
        INTEGER NOPI
        REAL    ALAT,ALON,BLAT,BLON,RLTI(*),RLNI(*)
C
C This routine, given the latitudes and longitudes of two points A and
C B on the surface of the globe, interpolates NOPI points along the
C great circle route joining A to B and returns the latitudes and
C longitudes of the interpolated points in the arrays RLTI and RLNI.
C
C Rotations about a given axis are used extensively below.  Assume a
C right-handed system with U, V, and W axes.  Rotating by an angle "a"
C about the U axis maps the point (u,v,w) into the point (u',v',w'),
C where
C
C       u' = u
C       v' = v cos(a) - w sin(a)
C       w' = w cos(a) + v sin(a)
C
C A positive value of "a" represents rotation in the direction from the
C V axis to the W axis.
C
C Similarly, rotating by an angle "a" about the V axis maps the point
C (u,v,w) into the point (u',v',w'), where
C
C       u' = u cos(a) + w sin(a)
C       v' = v
C       w' = w cos(a) - u sin(a)
C
C A positive value of "a" represents rotation in the direction from the
C W axis to the U axis.
C
C Rotating by an angle "a" about the W axis maps the point (u,v,w) into
C the point (u',v',w'), where
C
C       u' = u cos(a) - v sin(a)
C       v' = v cos(a) + u sin(a)
C       w' = w
C
C A positive value of "a" represents rotation in the direction from the
C U axis to the V axis.
C
C Declare local variables.
C
        INTEGER          IOPI
C
        REAL             ALPH,BETA,CALN,CALP,CALT,CBLN,CBLT,DTOR,GAMA,
     +                   RTOD,SALN,SALP,SALT,SBLN,SBLT,UCPA,UCPB,UCPD,
     +                   UCPF,UCPG,UCPH,UCPO,UCPP,UCPQ,VCPA,VCPB,VCPD,
     +                   VCPF,VCPG,VCPH,VCPO,VCPP,VCPQ,WCPA,WCPB,WCPD,
     +                   WCPF,WCPG,WCPH,WCPO,WCPP,WCPQ
C
C Define the constants used to convert from degrees to radians and
C vice-versa.
C
        DATA DTOR / .017453292519943 /
        DATA RTOD / 57.2957795130823 /
C
C Check for an uncleared prior error.
C
      IF (ICFELL('MAPGCI - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C Compute the U, V, and W coordinates (on a unit sphere) of the points
C A and B.
C
        CALT=COS(ALAT*DTOR)
        SALT=SIN(ALAT*DTOR)
        CALN=COS(ALON*DTOR)
        SALN=SIN(ALON*DTOR)
C
        CBLT=COS(BLAT*DTOR)
        SBLT=SIN(BLAT*DTOR)
        CBLN=COS(BLON*DTOR)
        SBLN=SIN(BLON*DTOR)
C
        UCPA=CALT*CALN
        VCPA=CALT*SALN
        WCPA=SALT
C
        UCPB=CBLT*CBLN
        VCPB=CBLT*SBLN
        WCPB=SBLT
C
C Rotating the points about the W axis by the angle -ALON carries point
C A into point C, in the UW plane.  It carries point B into point D.
C
C       CDLN=COS((BLON-ALON)*DTOR)
C       SDLN=SIN((BLON-ALON)*DTOR)
C
C       UCPC=CALT
C       VCPC=0.
C       WCPC=SALT
C
        UCPD=UCPB*CALN+VCPB*SALN
        VCPD=VCPB*CALN-UCPB*SALN
        WCPD=WCPB
C
C       UCPD=CBLT*CDLN
C       VCPD=CBLT*SDLN
C       WCPD=SBLT
C
C Rotating the points about the V axis by the angle ALAT carries point
C C into point E, on the U axis.  It carries point D into point F.
C
C       UCPE=1.
C       VCPE=0.
C       WCPE=0.
C
        UCPF=UCPD*CALT+WCPD*SALT
        VCPF=VCPD
        WCPF=WCPD*CALT-UCPD*SALT
C
C       UCPF=CALT*CBLT*CDLN-SALT*SBLT
C       VCPF=CBLT*SDLN
C       WCPF=CALT*SBLT+SALT*CBLT*CDLN
C
C Rotating the points about the U axis by the angle -ATAN(WCPF/VCPF)
C leaves the position of point E unchanged, but carries point F into
C point G, in the UV plane.
C
        IF (WCPF.NE.0..OR.VCPF.NE.0.) THEN
          ALPH=ATAN2(WCPF,VCPF)
        ELSE
          ALPH=0.
        END IF
C
        CALP=COS(ALPH)
        SALP=SIN(ALPH)
C
        UCPG=UCPF
        VCPG=VCPF*CALP+WCPF*SALP
        WCPG=WCPF*CALP-VCPF*SALP
C
C       UCPG=CALT*CBLT*CDLN-SALT*SBLT
C       VCPG=CBLT*SDLN*CALP-CALT*SBLT*SALP-SALT*CBLT*CDLN*SALP
C       WCPG=CALT*SBLT*CALP+SALT*CBLT*CDLN*CALP+CBLT*SDLN*SALP
C
C The angle from E to G (which is the same as the angle from A to B)
C may now be computed easily.
C
        IF (VCPG.NE.0..OR.UCPG.NE.0.) THEN
          BETA=ATAN2(VCPG,UCPG)
        ELSE
          BETA=0.
        END IF
C
C Interpolate points between the points E and G and map them back to
C the great circle route between A and B.
C
        DO 101 IOPI=1,NOPI
          GAMA=(REAL(IOPI)/REAL(NOPI+1))*BETA
          UCPH=COS(GAMA)
          VCPH=SIN(GAMA)
          WCPH=0.
          UCPO=UCPH
          VCPO=VCPH*CALP-WCPH*SALP
          WCPO=WCPH*CALP+VCPH*SALP
          UCPP=UCPO*CALT-WCPO*SALT
          VCPP=VCPO
          WCPP=WCPO*CALT+UCPO*SALT
          UCPQ=UCPP*CALN-VCPP*SALN
          VCPQ=VCPP*CALN+UCPP*SALN
          WCPQ=WCPP
          RLTI(IOPI)=RTOD*ATAN2(WCPQ,SQRT(UCPQ*UCPQ+VCPQ*VCPQ))
          IF (VCPQ.NE.0..OR.UCPQ.NE.0.) THEN
            RLNI(IOPI)=RTOD*ATAN2(VCPQ,UCPQ)
          ELSE
            RLNI(IOPI)=0.
          END IF
  101   CONTINUE
C
C Done.
C
        RETURN
C
      END

      SUBROUTINE ZUNMHR( SIDE, TRANS, M, N, ILO, IHI, A, LDA, TAU, C,
     $                   LDC, WORK, LWORK, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          SIDE, TRANS
      INTEGER            IHI, ILO, INFO, LDA, LDC, LWORK, M, N
*     ..
*     .. Array Arguments ..
      COMPLEX*16         A( LDA, * ), C( LDC, * ), TAU( * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  ZUNMHR overwrites the general complex M-by-N matrix C with
*
*                  SIDE = 'L'     SIDE = 'R'
*  TRANS = 'N':      Q * C          C * Q
*  TRANS = 'C':      Q**H * C       C * Q**H
*
*  where Q is a complex unitary matrix of order nq, with nq = m if
*  SIDE = 'L' and nq = n if SIDE = 'R'. Q is defined as the product of
*  IHI-ILO elementary reflectors, as returned by ZGEHRD:
*
*  Q = H(ilo) H(ilo+1) . . . H(ihi-1).
*
*  Arguments
*  =========
*
*  SIDE    (input) CHARACTER*1
*          = 'L': apply Q or Q**H from the Left;
*          = 'R': apply Q or Q**H from the Right.
*
*  TRANS   (input) CHARACTER*1
*          = 'N': apply Q  (No transpose)
*          = 'C': apply Q**H (Conjugate transpose)
*
*  M       (input) INTEGER
*          The number of rows of the matrix C. M >= 0.
*
*  N       (input) INTEGER
*          The number of columns of the matrix C. N >= 0.
*
*  ILO     (input) INTEGER
*  IHI     (input) INTEGER
*          ILO and IHI must have the same values as in the previous call
*          of ZGEHRD. Q is equal to the unit matrix except in the
*          submatrix Q(ilo+1:ihi,ilo+1:ihi).
*          If SIDE = 'L', then 1 <= ILO <= IHI <= M, if M > 0, and
*          ILO = 1 and IHI = 0, if M = 0;
*          if SIDE = 'R', then 1 <= ILO <= IHI <= N, if N > 0, and
*          ILO = 1 and IHI = 0, if N = 0.
*
*  A       (input) COMPLEX*16 array, dimension
*                               (LDA,M) if SIDE = 'L'
*                               (LDA,N) if SIDE = 'R'
*          The vectors which define the elementary reflectors, as
*          returned by ZGEHRD.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.
*          LDA >= max(1,M) if SIDE = 'L'; LDA >= max(1,N) if SIDE = 'R'.
*
*  TAU     (input) COMPLEX*16 array, dimension
*                               (M-1) if SIDE = 'L'
*                               (N-1) if SIDE = 'R'
*          TAU(i) must contain the scalar factor of the elementary
*          reflector H(i), as returned by ZGEHRD.
*
*  C       (input/output) COMPLEX*16 array, dimension (LDC,N)
*          On entry, the M-by-N matrix C.
*          On exit, C is overwritten by Q*C or Q**H*C or C*Q**H or C*Q.
*
*  LDC     (input) INTEGER
*          The leading dimension of the array C. LDC >= max(1,M).
*
*  WORK    (workspace/output) COMPLEX*16 array, dimension (LWORK)
*          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*
*  LWORK   (input) INTEGER
*          The dimension of the array WORK.
*          If SIDE = 'L', LWORK >= max(1,N);
*          if SIDE = 'R', LWORK >= max(1,M).
*          For optimum performance LWORK >= N*NB if SIDE = 'L', and
*          LWORK >= M*NB if SIDE = 'R', where NB is the optimal
*          blocksize.
*
*          If LWORK = -1, then a workspace query is assumed; the routine
*          only calculates the optimal size of the WORK array, returns
*          this value as the first entry of the WORK array, and no error
*          message related to LWORK is issued by XERBLA.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*
*  =====================================================================
*
*     .. Local Scalars ..
      LOGICAL            LEFT, LQUERY
      INTEGER            I1, I2, IINFO, LWKOPT, MI, NB, NH, NI, NQ, NW
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            ILAENV
      EXTERNAL           LSAME, ILAENV
*     ..
*     .. External Subroutines ..
      EXTERNAL           XERBLA, ZUNMQR
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN
*     ..
*     .. Executable Statements ..
*
*     Test the input arguments
*
      INFO = 0
      NH = IHI - ILO
      LEFT = LSAME( SIDE, 'L' )
      LQUERY = ( LWORK.EQ.-1 )
*
*     NQ is the order of Q and NW is the minimum dimension of WORK
*
      IF( LEFT ) THEN
         NQ = M
         NW = N
      ELSE
         NQ = N
         NW = M
      END IF
      IF( .NOT.LEFT .AND. .NOT.LSAME( SIDE, 'R' ) ) THEN
         INFO = -1
      ELSE IF( .NOT.LSAME( TRANS, 'N' ) .AND. .NOT.LSAME( TRANS, 'C' ) )
     $          THEN
         INFO = -2
      ELSE IF( M.LT.0 ) THEN
         INFO = -3
      ELSE IF( N.LT.0 ) THEN
         INFO = -4
      ELSE IF( ILO.LT.1 .OR. ILO.GT.MAX( 1, NQ ) ) THEN
         INFO = -5
      ELSE IF( IHI.LT.MIN( ILO, NQ ) .OR. IHI.GT.NQ ) THEN
         INFO = -6
      ELSE IF( LDA.LT.MAX( 1, NQ ) ) THEN
         INFO = -8
      ELSE IF( LDC.LT.MAX( 1, M ) ) THEN
         INFO = -11
      ELSE IF( LWORK.LT.MAX( 1, NW ) .AND. .NOT.LQUERY ) THEN
         INFO = -13
      END IF
*
      IF( INFO.EQ.0 ) THEN
         IF( LEFT ) THEN
            NB = ILAENV( 1, 'ZUNMQR', SIDE // TRANS, NH, N, NH, -1 )
         ELSE
            NB = ILAENV( 1, 'ZUNMQR', SIDE // TRANS, M, NH, NH, -1 )
         END IF
         LWKOPT = MAX( 1, NW )*NB
         WORK( 1 ) = LWKOPT
      END IF
*
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'ZUNMHR', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( M.EQ.0 .OR. N.EQ.0 .OR. NH.EQ.0 ) THEN
         WORK( 1 ) = 1
         RETURN
      END IF
*
      IF( LEFT ) THEN
         MI = NH
         NI = N
         I1 = ILO + 1
         I2 = 1
      ELSE
         MI = M
         NI = NH
         I1 = 1
         I2 = ILO + 1
      END IF
*
      CALL ZUNMQR( SIDE, TRANS, MI, NI, NH, A( ILO+1, ILO ), LDA,
     $             TAU( ILO ), C( I1, I2 ), LDC, WORK, LWORK, IINFO )
*
      WORK( 1 ) = LWKOPT
      RETURN
*
*     End of ZUNMHR
*
      END

C
C	$Id: csgetd.f,v 1.7 2008-07-27 03:10:06 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CSGETD (CNP,DVP)
C
      SAVE
C
      CHARACTER*(*) CNP
      DOUBLE PRECISION DVP
C
C  This subroutine is called to retrieve the real value of a specified
C  parameter.
C
C  CNP is the name of the parameter whose value is to be retrieved.
C
C  DVP is a real variable in which the desired value is to be returned
C  by CSGETR.
C
C  Declare a local character variable in which to form an error message.
C
      CHARACTER*80 CTM
C
      include 'cscomn.h'
C
C  Do a call forcing a BLOCKDATA to be loaded from a binary library.
C
      CALL CSBLDA
C
C  Check for an uncleared prior error.
C
      IF (ICFELL('CSGETR - Uncleared prior error',1) .NE. 0) RETURN
C
C Check for a parameter name that is too short.
C
      IF (LEN(CNP) .LT. 2) THEN
        CTM(1:36)='CSGETD - Parameter name too short - '
        CTM(37:36+LEN(CNP)) = CNP
        CALL SETER (CTM(1:36+LEN(CNP)), 1, 1)
        GO TO 110
      ENDIF
C
C Get the appropriate parameter value.
C
      IF (CNP(1:3).EQ.'TOL' .OR. CNP(1:3).EQ.'tol' .OR.
     +    CNP(1:3).EQ.'Tol' .OR. CNP(1:3).EQ.'DTL' .OR.
     +    CNP(1:3).EQ.'dtl' .OR. CNP(1:3).EQ.'Dtl') THEN
        DVP = TOLIC
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'TTF' .OR. CNP(1:3).EQ.'ttf' .OR.
     +         CNP(1:3).EQ.'Ttf' .OR. CNP(1:3).EQ.'TTD' .OR.
     +         CNP(1:3).EQ.'ttd' .OR. CNP(1:3).EQ.'Ttd') THEN
        DVP = TOLSG
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'SIG' .OR. CNP(1:3).EQ.'sig' .OR.
     +         CNP(1:3).EQ.'Sig' .OR. CNP(1:3).EQ.'DSG' .OR.
     +         CNP(1:3).EQ.'dsg' .OR. CNP(1:3).EQ.'Dsg') THEN
        DVP = USSIG
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'MVL' .OR. CNP(1:3).EQ.'mvl' .OR. 
     +         CNP(1:3).EQ.'Mvl' .OR. CNP(1:3).EQ.'DMV' .OR.
     +         CNP(1:3).EQ.'dmv' .OR. CNP(1:3).EQ.'Dmv') THEN
        RVP = RMVAL
        GO TO 110
      ELSE
        CTM(1:36) = 'CSGETD - Parameter name not known - '
        CTM(37:39) = CNP(1:3)
        CALL SETER (CTM(1:39), 2, 1)
        GO TO 110
      ENDIF
C
  110 CONTINUE
      RETURN
      END

C
C $Id: sphdsp.f,v 1.6 2008-07-27 00:17:12 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE SPHDSP (ISPH,PARM)
C
C Subroutine to compute spheroid parameters.  ISPH is a spheroid code,
C as follows:
C
C   0 = Clarke 1866             10 = Modified Everest
C   1 = Clarke 1880             11 = Modified Airy
C   2 = Bessel                  12 = WGS 84
C   3 = New International 1967  13 = Southeast Asia
C   4 = International 1909      14 = Australian National
C   5 = WGS 72                  15 = Krassovsky
C   6 = Everest                 16 = Hough
C   7 = WGS 66                  17 = Mercury 1960
C   8 = GRS 1980                18 = Modified Mercury 1968
C   9 = Airy                    19 = Sphere of radius 6,370,997 meters
C
C PARM is the array of projection parameters; in particular,
C
C   PARM(1) is the semi-major axis
C   PARM(2) is the eccentricity squared
C
C If ISPH is negative, user-specified values of these must be supplied;
C otherwise, the values are returned.
C
      IMPLICIT REAL (A-Z)
      INTEGER ISPH
      DIMENSION PARM(15),AXIS(20),BXIS(20)
C
      COMMON /ELLPSP/ AZ,EZ,ESZ,E0Z,E1Z,E2Z,E3Z,E4Z
      SAVE   /ELLPSP/
C
      COMMON /SPHRSP/ AZZ
      SAVE   /SPHRSP/
C
      COMMON /ERRMZ0/ IERR
        INTEGER IERR
      SAVE   /ERRMZ0/
C
      COMMON /PRINZ0/ IPEMSG,IPELUN,IPPARM,IPPLUN
        INTEGER IPEMSG,IPELUN,IPPARM,IPPLUN
      SAVE   /PRINZ0/
C
      DATA ZERO,ONE,TEN / 0.E0 , 1.E0 , 1.E1 /
C
      DATA AXIS / 6378206.400000E0,6378249.145000E0,6377397.155000E0,
     .            6378157.500000E0,6378388.000000E0,6378135.000000E0,
     .            6377276.345200E0,6378145.000000E0,6378137.000000E0,
     .            6377563.396000E0,6377304.063000E0,6377340.189000E0,
     .            6378137.000000E0,6378155.000000E0,6378160.000000E0,
     .            6378245.000000E0,6378270.000000E0,6378166.000000E0,
     .            6378150.000000E0,6370997.000000E0 /
C
      DATA BXIS / 6356583.800000E0,6356514.869550E0,6356078.962840E0,
     .            6356772.200000E0,6356911.946130E0,6356750.519915E0,
     .            6356075.413300E0,6356759.769356E0,6356752.314140E0,
     .            6356256.910000E0,6356103.039000E0,6356034.448000E0,
     .            6356752.314245E0,6356773.320500E0,6356774.719000E0,
     .            6356863.018800E0,6356794.343479E0,6356784.283666E0,
     .            6356768.337303E0,6370997.000000E0 /
C
C Compute A and B (the lengths of the semi-major and semi-minor axes),
C and ES (the square of the eccentricity).  Note that, if one sets ISPH
C less than zero, one can specify, in PARM(1) and PARM(2), "a" and "0"
C (implying a sphere of radius "a"), "a" and "b" (implying an ellipsoid
C with semi-major and semi-minor axes of lengths "a" and "b", or "a" and
C "e**2" (implying an ellipsoid with a semi-major axis of length "a" and
C eccentricity squared "e**2"); in any of these cases, the numbers can
C be given in either order.  (It is assumed, however, that "a" is not
C less than 1 and that "e**2" is not greater than "a/10".
C
      IF (ISPH.LT.0) THEN
        A=MAX(ABS(PARM(1)),ABS(PARM(2)))
        B=MIN(ABS(PARM(1)),ABS(PARM(2)))
        ES=ONE-(B/A)**2
        IF (A.EQ.ZERO) THEN
          A=AXIS(1)
          B=BXIS(1)
          ES=ONE-(B/A)**2
        ELSE IF (B.EQ.ZERO) then
          B=A
          ES=ZERO
        ELSE IF (B.LT.A/TEN) THEN
          ES=B
          B=A*SQRT(ONE-ES)
        END IF
      ELSE
        A=AXIS(MAX(1,MIN(20,ISPH+1)))
        B=BXIS(MAX(1,MIN(20,ISPH+1)))
        ES=ONE-(B/A)**2
      END IF
C
C Transfer the appropriate values to common blocks.
C
      AZ=A
      AZZ=A
      ESZ=ES
      EZ=SQRT(ES)
      E0Z=E0FNSP(ES)
      E1Z=E1FNSP(ES)
      E2Z=E2FNSP(ES)
      E3Z=E3FNSP(ES)
      E4Z=E4FNSP(EZ)
C
C Pass the length of the semi-major axis and the square of the
C eccentricity back to the caller.
C
      PARM(1)=A
      PARM(2)=ES
C
C Done.
C
      RETURN
C
      END

C
C $Id: tdcone.f,v 1.3 2008-07-27 00:17:31 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE TDCONE (UACC,VACC,WACC,UDCS,VDCS,WDCS,RADI,NPAC,
     +                                       NPCT,UTIP,VTIP,WTIP)
C
C Draw the projection of a cone in 3-space.  The circular base of the
C cone is centered at the point (UACC,VACC,WACC), is perpendicular to
C the vector with direction cosines UDCS, VDCS, and WDCS, has a radius
C of RADI, and is drawn using NPAC equispaced points along the circle;
C NPCT points equispaced along the circle are connected to the tip,
C which is at (UTIP,VTIP,WTIP).
C
        DATA DTOR / .017453292519943 /
        DATA RTOD / 57.2957795130823 /
C
C       RLAT=RTOD*ASIN(WDCS)
C
C       IF (UDCS.NE.0.OR.VDCS.NE.0.) THEN
C         RLON=RTOD*ATAN2(VDCS,UDCS)
C       ELSE
C         RLON=0.
C       END IF
C
C Draw the circular base of the arrowhead.  Essentially, we form the
C circle in the UV plane, perform two rotations (one about the V axis,
C by the angle 90-RLAT, and one about the W axis, by the angle RLON),
C and then translate the circle to its desired final position.  The
C rotations involve sines and cosines of 90-RLAT and of RLON; the code
C is simplified by computing these from the direction cosines.
C
        DNOM=SQRT(UDCS*UDCS+VDCS*VDCS)
C
        DO 101 I=0,NPAC
          UCR1=RADI*COS(DTOR*REAL(I)*(360./REAL(NPAC)))
          UCR2=UCR1*WDCS
          VCR2=RADI*SIN(DTOR*REAL(I)*(360./REAL(NPAC)))
          IF (DNOM.EQ.0.) THEN
            UCR3=UCR2
            VCR3=VCR2
          ELSE
            UCR3=(UCR2*UDCS-VCR2*VDCS)/DNOM
            VCR3=(VCR2*UDCS+UCR2*VDCS)/DNOM
          END IF
          WCR3=-UCR1*SQRT(1.-WDCS*WDCS)
          CALL TDPRPT (UACC+UCR3,VACC+VCR3,WACC+WCR3,XPOS,YPOS)
          CALL PLOTIF (CUFX(XPOS),CUFY(YPOS),MIN(I,1))
  101   CONTINUE
C
C Connect some points along the base of the circle to the tip, using
C very similar code.
C
        CALL TDPRPT (UTIP,VTIP,WTIP,XTIP,YTIP)
C
        XTIP=CUFX(XTIP)
        YTIP=CUFY(YTIP)
C
        DO 102 I=0,NPCT
          CALL PLOTIF (XTIP,YTIP,0)
          UCR1=RADI*COS(DTOR*REAL(I)*(360./REAL(NPCT)))
          UCR2=UCR1*WDCS
          VCR2=RADI*SIN(DTOR*REAL(I)*(360./REAL(NPCT)))
          IF (DNOM.EQ.0.) THEN
            UCR3=UCR2
            VCR3=VCR2
          ELSE
            UCR3=(UCR2*UDCS-VCR2*VDCS)/DNOM
            VCR3=(VCR2*UDCS+UCR2*VDCS)/DNOM
          END IF
          WCR3=-UCR1*SQRT(1.-WDCS*WDCS)
          CALL TDPRPT (UACC+UCR3,VACC+VCR3,WACC+WCR3,XPOS,YPOS)
          CALL PLOTIF (CUFX(XPOS),CUFY(YPOS),1)
  102   CONTINUE
C
C Flush the point-draw buffers.
C
        CALL PLOTIF (0.,0.,2)
C
C Done.
C
        RETURN
C
      END

C
C	$Id: gopks.f,v 1.9 2008-07-27 00:20:58 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GOPKS(ERRFIL,BUFA)
C
C  OPEN GKS
C
C  Force load of all BLOCKDATAs.
C
      COMMON /SECOMI/ IERRU,IERRF,IRECF,LOMSG
      INTEGER EOPKS
      PARAMETER (EOPKS=0)
      INTEGER ERRFIL,BUFA
C
      include 'gkscom.h'
C
C  Do calls forcing BLOCKDATAs to be loaded from a binary library.
C
        CALL GKSBD
        CALL G01BKD
        CALL GWIBKD
        CALL GSEGDT
C
C  Check if GKS is in the proper state.
C
      CALL GZCKST(1,EOPKS,IER)
      IF (IER .NE. 0) RETURN
C
C  Initialize the error state list and local names.
C
      CALL GZINES
C
C  Specify the error file in the GKS error state list.
C
      ERF = ERRFIL
C
C  Also change the error unit for SETER calls if ERRFIL is
C  non-zero.
C
      IF (ERRFIL .NE. 0) IERRU = ERRFIL
C
C  Initialize the GKS state list.
C
      CALL GZINSL
C
C  Set the GKS operating state to GKSOP.
C
      OPS = GGKOP
C
      RETURN
      END

c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by UCAR                 .
c  .                                                             .
c  .       University Corporation for Atmospheric Research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                         SPHEREPACK                          .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c
c
c ... file idvtgc.f
c
c     this file includes documentation and code for
c     subroutine idvtgc         i
c
c ... files which must be loaded with idvtgc.f
c
c     sphcom.f, hrfft.f, vhsgc.f,shagc.f, gaqd.f
c
c
c     subroutine idvtgc(nlat,nlon,isym,nt,v,w,idvw,jdvw,ad,bd,av,bv,
c    +mdab,ndab,wvhsgc,lvhsgc,work,lwork,pertbd,pertbv,ierror)
c
c     given the scalar spherical harmonic coefficients ad,bd precomputed
C*PL*ERROR* Comment line too long
c     by subroutine shagc for the scalar field divg and coefficients av,bv
C*PL*ERROR* Comment line too long
c     precomputed by subroutine shagc for the scalar field vort, subroutine
C*PL*ERROR* Comment line too long
c     idvtgc computes a vector field (v,w) whose divergence is divg - pertbd
C*PL*ERROR* Comment line too long
c     and whose vorticity is vort - pertbv.  w the is east longitude component
C*PL*ERROR* Comment line too long
c     and v is the colatitudinal component of the velocity.  if nt=1 (see nt
C*PL*ERROR* Comment line too long
c     below) pertrbd and pertbv are constants which must be subtracted from
C*PL*ERROR* Comment line too long
c     divg and vort for (v,w) to exist (see the description of pertbd and
C*PL*ERROR* Comment line too long
c     pertrbv below).  usually pertbd and pertbv are zero or small relative
C*PL*ERROR* Comment line too long
c     to divg and vort.  w(i,j) and v(i,j) are the velocity components at
C*PL*ERROR* Comment line too long
c     gaussian colatitude theta(i) (see nlat as input argument) and longitude
c     lambda(j) = (j-1)*2*pi/nlon
c
c     the
c
c            divergence(v(i,j),w(i,j))
c
c         =  [d(sint*v)/dtheta + dw/dlambda]/sint
c
c         =  divg(i,j) - pertbd
c
c     and
c
c            vorticity(v(i,j),w(i,j))
c
c         =  [-dv/dlambda + d(sint*w)/dtheta]/sint
c
c         =  vort(i,j) - pertbv
c
c     where
c
c            sint = cos(theta(i)).
c
c
c     input parameters
c
c     nlat   the number of points in the gaussian colatitude grid on the
C*PL*ERROR* Comment line too long
c            full sphere. these lie in the interval (0,pi) and are computed
C*PL*ERROR* Comment line too long
c            in radians in theta(1) <...< theta(nlat) by subroutine gaqd.
C*PL*ERROR* Comment line too long
c            if nlat is odd the equator will be included as the grid point
c            theta((nlat+1)/2).  if nlat is even the equator will be
c            excluded as a grid point and will lie half way between
c            theta(nlat/2) and theta(nlat/2+1). nlat must be at least 3.
c            note: on the half sphere, the number of grid points in the
c            colatitudinal direction is nlat/2 if nlat is even or
c            (nlat+1)/2 if nlat is odd.
c
c     nlon   the number of distinct londitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater
c            than 3. the axisymmetric case corresponds to nlon=1.
c            the efficiency of the computation is improved when nlon
c            is a product of small prime numbers.
c
c
C*PL*ERROR* Comment line too long
c     isym   isym determines whether (v,w) are computed on the full or half
c            sphere as follows:
c
c      = 0
c            divg,vort are neither pairwise symmetric/antisymmetric nor
c            antisymmetric/symmetric about the equator as described for
C*PL*ERROR* Comment line too long
c            isym = 1 or isym = 2  below.  in this case, the vector field
C*PL*ERROR* Comment line too long
c            (v,w) is computed on the entire sphere.  i.e., in the arrays
c            w(i,j) and v(i,j) i=1,...,nlat and j=1,...,nlon.
c
c      = 1
c
C*PL*ERROR* Comment line too long
c            divg is antisymmetric and vort is symmetric about the equator.
C*PL*ERROR* Comment line too long
c            in this case w is antisymmetric and v is symmetric about the
C*PL*ERROR* Comment line too long
c            equator.  w and v are computed on the northern hemisphere only.
c            if nlat is odd they are computed for i=1,...,(nlat+1)/2
c            and j=1,...,nlon.  if nlat is even they are computed for
c            i=1,...,nlat/2 and j=1,...,nlon.
c
c      = 2
c
C*PL*ERROR* Comment line too long
c            divg is symmetric and vort is antisymmetric about the equator.
C*PL*ERROR* Comment line too long
c            in this case w is symmetric and v is antisymmetric about the
C*PL*ERROR* Comment line too long
c            equator.  w and v are computed on the northern hemisphere only.
c            if nlat is odd they are computed for i=1,...,(nlat+1)/2
c            and j=1,...,nlon.  if nlat is even they are computed for
c            i=1,...,nlat/2 and j=1,...,nlon.
c
c
C*PL*ERROR* Comment line too long
c     nt     in the program that calls idvtgc, nt is the number of scalar
C*PL*ERROR* Comment line too long
c            and vector fields.  some computational efficiency is obtained
C*PL*ERROR* Comment line too long
c            for multiple fields.  the arrays ad,bd,av,bv,u, and v can be
c            three dimensional and pertbd,pertbv can be one dimensional
C*PL*ERROR* Comment line too long
c            corresponding to indexed multiple arrays divg, vort.  in this
c            case, multiple synthesis will be performed to compute each
C*PL*ERROR* Comment line too long
c            vector field.  the third index for ad,bd,av,bv,v,w and first
C*PL*ERROR* Comment line too long
c            pertrbd,pertbv is the synthesis index which assumes the values
C*PL*ERROR* Comment line too long
c            k=1,...,nt.  for a single synthesis set nt=1. the description of
C*PL*ERROR* Comment line too long
c            remaining parameters is simplified by assuming that nt=1 or that
c            ad,bd,av,bv,v,w are two dimensional and pertbd,pertbv are
c            constants.
c
c     idvw   the first dimension of the arrays v,w as it appears in
c            the program that calls idvtgc. if isym = 0 then idvw
c            must be at least nlat.  if isym = 1 or 2 and nlat is
c            even then idvw must be at least nlat/2. if isym = 1 or 2
c            and nlat is odd then idvw must be at least (nlat+1)/2.
c
c     jdvw   the second dimension of the arrays v,w as it appears in
c            the program that calls idvtgc. jdvw must be at least nlon.
c
c     ad,bd  two or three dimensional arrays (see input parameter nt)
c            that contain scalar spherical harmonic coefficients
C*PL*ERROR* Comment line too long
c            of the divergence array divg as computed by subroutine shagc.
c
c     av,bv  two or three dimensional arrays (see input parameter nt)
c            that contain scalar spherical harmonic coefficients
C*PL*ERROR* Comment line too long
c            of the vorticity array vort as computed by subroutine shagc.
C*PL*ERROR* Comment line too long
c     ***    ad,bd,av,bv must be computed by shagc prior to calling idvtgc.
c
c     mdab   the first dimension of the arrays ad,bd,av,bv as it appears
C*PL*ERROR* Comment line too long
c            in the program that calls idvtgc (and shagc). mdab must be at
c            least min0(nlat,(nlon+2)/2) if nlon is even or at least
c            min0(nlat,(nlon+1)/2) if nlon is odd.
c
C*PL*ERROR* Comment line too long
c     ndab   the second dimension of the arrays ad,bd,av,bv as it appears in
c            the program that calls idvtgc (and shagc). ndab must be at
c            least nlat.
c
c  wvhsgc    an array which must be initialized by subroutine vhsgci.
c            wvhsgc can be used repeatedly by idvtgc as long as nlon
c            and nlat remain unchanged.  wvhsgc must not be altered
c            between calls of idvtgc.
c
c
c  lvhsgc    the dimension of the array wvhsgc as it appears in the
c            program that calls idvtgc. define
c
c               l1 = min0(nlat,nlon/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            then lvhsgc must be at least
c
c               4*nlat*l2+3*max0(l1-2,0)*(2*nlat-l1-1)+nlon+15
c
c     work   a work array that does not have to be saved.
c
c     lwork  the dimension of the array work as it appears in the
c            program that calls idvtgc. define
c
c               l2 = nlat/2                    if nlat is even or
c               l2 = (nlat+1)/2                if nlat is odd
c               l1 = min0(nlat,nlon/2)       if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2)   if nlon is odd
c
c
c            if isym = 0 then lwork must be at least
c
c              l2*(2*nt*nlon+max0(6*nlat,nlon))+nlat*(4*nt*l1+1)
c
c            if isym = 1 or 2 then lwork must be at least
c
c              nlat*(2*nt*nlon+max0(6*l2,nlon)+4*nt*l1+1)
c
c
c     **************************************************************
c
c     output parameters
c
c
C*PL*ERROR* Comment line too long
c     v,w   two or three dimensional arrays (see input parameter nt) that
c           contain a vector field whose divergence is divg - pertbd and
C*PL*ERROR* Comment line too long
c           whose vorticity is vort - pertbv.  w(i,j) is the east longitude
C*PL*ERROR* Comment line too long
c           component and v(i,j) is the colatitudinal component of velocity
c           at the colatitude theta(i) = (i-1)*pi/(nlat-1) and longitude
C*PL*ERROR* Comment line too long
c           lambda(j) = (j-1)*2*pi/nlon for i=1,...,nlat and j=1,...,nlon.
c
C*PL*ERROR* Comment line too long
c   pertbd  a nt dimensional array (see input parameter nt and assume nt=1
C*PL*ERROR* Comment line too long
c           for the description that follows).  divg - pertbd is a scalar
c           field which can be the divergence of a vector field (v,w).
c           pertbd is related to the scalar harmonic coefficients ad,bd
c           of divg (computed by shagc) by the formula
c
c                pertbd = ad(1,1)/(2.*sqrt(2.))
c
c           an unperturbed divg can be the divergence of a vector field
c           only if ad(1,1) is zero.  if ad(1,1) is nonzero (flagged by
c           pertbd nonzero) then subtracting pertbd from divg yields a
c           scalar field for which ad(1,1) is zero.  usually pertbd is
c           zero or small relative to divg.
c
C*PL*ERROR* Comment line too long
c   pertbv a nt dimensional array (see input parameter nt and assume nt=1
C*PL*ERROR* Comment line too long
c           for the description that follows).  vort - pertbv is a scalar
c           field which can be the vorticity of a vector field (v,w).
c           pertbv is related to the scalar harmonic coefficients av,bv
c           of vort (computed by shagc) by the formula
c
c                pertbv = av(1,1)/(2.*sqrt(2.))
c
c           an unperturbed vort can be the vorticity of a vector field
c           only if av(1,1) is zero.  if av(1,1) is nonzero (flagged by
c           pertbv nonzero) then subtracting pertbv from vort yields a
c           scalar field for which av(1,1) is zero.  usually pertbv is
c           zero or small relative to vort.
c
c    ierror = 0  no errors
c           = 1  error in the specification of nlat
c           = 2  error in the specification of nlon
c           = 3  error in the specification of isym
c           = 4  error in the specification of nt
c           = 5  error in the specification of idvw
c           = 6  error in the specification of jdvw
c           = 7  error in the specification of mdab
c           = 8  error in the specification of ndab
c           = 9  error in the specification of lvhsgc
c           = 10 error in the specification of lwork
c **********************************************************************
c
c
      SUBROUTINE DIDVTGC(NLAT,NLON,ISYM,NT,V,W,IDVW,JDVW,AD,BD,AV,BV,
     +                  MDAB,NDAB,WVHSGC,LVHSGC,WORK,LWORK,PERTBD,
     +                  PERTBV,IERROR)
      DOUBLE PRECISION V
      DOUBLE PRECISION W
      DOUBLE PRECISION AD
      DOUBLE PRECISION BD
      DOUBLE PRECISION AV
      DOUBLE PRECISION BV
      DOUBLE PRECISION WVHSGC
      DOUBLE PRECISION WORK
      DOUBLE PRECISION PERTBD
      DOUBLE PRECISION PERTBV
      DIMENSION W(IDVW,JDVW,NT),V(IDVW,JDVW,NT),PERTBD(NT),PERTBV(NT)
      DIMENSION AD(MDAB,NDAB,NT),BD(MDAB,NDAB,NT)
      DIMENSION AV(MDAB,NDAB,NT),BV(MDAB,NDAB,NT)
      DIMENSION WVHSGC(LVHSGC),WORK(LWORK)
c
c     check input parameters
c
      IERROR = 1
      IF (NLAT.LT.3) RETURN
      IERROR = 2
      IF (NLON.LT.4) RETURN
      IERROR = 3
      IF (ISYM.LT.0 .OR. ISYM.GT.2) RETURN
      IERROR = 4
      IF (NT.LT.0) RETURN
      IERROR = 5
      IMID = (NLAT+1)/2
      IF ((ISYM.EQ.0.AND.IDVW.LT.NLAT) .OR.
     +    (ISYM.NE.0.AND.IDVW.LT.IMID)) RETURN
      IERROR = 6
      IF (JDVW.LT.NLON) RETURN
      IERROR = 7
      MMAX = MIN0(NLAT, (NLON+1)/2)
      IF (MDAB.LT.MIN0(NLAT, (NLON+2)/2)) RETURN
      IERROR = 8
      IF (NDAB.LT.NLAT) RETURN
      IERROR = 9
      LZZ1 = 2*NLAT*IMID
      LABC = 3* (MAX0(MMAX-2,0)* (NLAT+NLAT-MMAX-1))/2
      IF (LVHSGC.LT.2* (LZZ1+LABC)+NLON+15) RETURN
      IERROR = 10
c
c     verify unsaved work space length
c
      MN = MMAX*NLAT*NT
      IF (ISYM.NE.0 .AND. LWORK.LT.NLAT* (2*NT*NLON+MAX0(6*IMID,NLON))+
     +    4*MN+NLAT) RETURN
      IF (ISYM.EQ.0 .AND. LWORK.LT.IMID* (2*NT*NLON+MAX0(6*NLAT,NLON))+
     +    4*MN+NLAT) RETURN
      IERROR = 0
c
c     set work space pointers
c
      IBR = 1
      IBI = IBR + MN
      ICR = IBI + MN
      ICI = ICR + MN
      IS = ICI + MN
      IWK = IS + NLAT
      LIWK = LWORK - 4*MN - NLAT
      CALL DIDVTGC1(NLAT,NLON,ISYM,NT,V,W,IDVW,JDVW,WORK(IBR),WORK(IBI),
     +             WORK(ICR),WORK(ICI),MMAX,WORK(IS),MDAB,NDAB,AD,BD,AV,
     +             BV,WVHSGC,LVHSGC,WORK(IWK),LIWK,PERTBD,PERTBV,IERROR)
      RETURN
      END

      SUBROUTINE DIDVTGC1(NLAT,NLON,ISYM,NT,V,W,IDVW,JDVW,BR,BI,CR,CI,
     +                   MMAX,SQNN,MDAB,NDAB,AD,BD,AV,BV,WVHSGC,LVHSGC,
     +                   WK,LWK,PERTBD,PERTBV,IERROR)
      DOUBLE PRECISION V
      DOUBLE PRECISION W
      DOUBLE PRECISION BR
      DOUBLE PRECISION BI
      DOUBLE PRECISION CR
      DOUBLE PRECISION CI
      DOUBLE PRECISION SQNN
      DOUBLE PRECISION AD
      DOUBLE PRECISION BD
      DOUBLE PRECISION AV
      DOUBLE PRECISION BV
      DOUBLE PRECISION WVHSGC
      DOUBLE PRECISION WK
      DOUBLE PRECISION PERTBD
      DOUBLE PRECISION PERTBV
      DOUBLE PRECISION FN
      DIMENSION W(IDVW,JDVW,NT),V(IDVW,JDVW,NT)
      DIMENSION BR(MMAX,NLAT,NT),BI(MMAX,NLAT,NT),SQNN(NLAT)
      DIMENSION CR(MMAX,NLAT,NT),CI(MMAX,NLAT,NT)
      DIMENSION AD(MDAB,NDAB,NT),BD(MDAB,NDAB,NT)
      DIMENSION AV(MDAB,NDAB,NT),BV(MDAB,NDAB,NT)
      DIMENSION WVHSGC(LVHSGC),WK(LWK)
      DIMENSION PERTBD(NT),PERTBV(NT)
c
c     preset coefficient multiplyers in vector
c
      DO 1 N = 2,NLAT
          FN = DBLE(N-1)
          SQNN(N) = SQRT(FN* (FN+1.D0))
    1 CONTINUE
c
c     compute multiple vector fields coefficients
c
      DO 2 K = 1,NT
c
c     set divergence,vorticity perturbation constants
c
          PERTBD(K) = AD(1,1,K)/ (2.D0*SQRT(2.D0))
          PERTBV(K) = AV(1,1,K)/ (2.D0*SQRT(2.D0))
c
c     preset br,bi,cr,ci to 0.0
c
          DO 3 N = 1,NLAT
              DO 4 M = 1,MMAX
                  BR(M,N,K) = 0.0D0
                  BI(M,N,K) = 0.0D0
                  CR(M,N,K) = 0.0D0
                  CI(M,N,K) = 0.0D0
    4         CONTINUE
    3     CONTINUE
c
c     compute m=0 coefficients
c
          DO 5 N = 2,NLAT
              BR(1,N,K) = -AD(1,N,K)/SQNN(N)
              BI(1,N,K) = -BD(1,N,K)/SQNN(N)
              CR(1,N,K) = AV(1,N,K)/SQNN(N)
              CI(1,N,K) = BV(1,N,K)/SQNN(N)
    5     CONTINUE
c
c     compute m>0 coefficients
c
          DO 6 M = 2,MMAX
              DO 7 N = M,NLAT
                  BR(M,N,K) = -AD(M,N,K)/SQNN(N)
                  BI(M,N,K) = -BD(M,N,K)/SQNN(N)
                  CR(M,N,K) = AV(M,N,K)/SQNN(N)
                  CI(M,N,K) = BV(M,N,K)/SQNN(N)
    7         CONTINUE
    6     CONTINUE
    2 CONTINUE
c
c     set ityp for vector synthesis without assuming div=0 or curl=0
c
      IF (ISYM.EQ.0) THEN
          ITYP = 0
      ELSE IF (ISYM.EQ.1) THEN
          ITYP = 3
      ELSE IF (ISYM.EQ.2) THEN
          ITYP = 6
      END IF
c
c     sythesize br,bi,cr,ci into the vector field (v,w)
c
      CALL DVHSGC(NLAT,NLON,ITYP,NT,V,W,IDVW,JDVW,BR,BI,CR,CI,MMAX,NLAT,
     +           WVHSGC,LVHSGC,WK,LWK,IERROR)
      RETURN
      END

C
C $Id: e4fndp.f,v 1.5 2008-07-27 00:17:08 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      DOUBLE PRECISION FUNCTION E4FNDP (ECCENT)
C
C This function computes the constant E4.
C
      IMPLICIT DOUBLE PRECISION (A-Z)
      DATA ONE /1.0D0/
C
      CON = ONE + ECCENT
      COM = ONE - ECCENT
      E4FNDP = SQRT ((CON ** CON) * (COM ** COM))
C
      RETURN
      END

C
C      $Id: cn14f.f,v 1.5 2010-03-15 22:49:23 haley Exp $
C
C***********************************************************************
C                                                                      *
C                Copyright (C)  1997                                   *
C        University Corporation for Atmospheric Research               *
C     The use of this Software is governed by a License Agreement      *
C                                                                      *
C***********************************************************************
C
C  File:       cn14f.f
C
C   Author:     Bob Lackman
C               National Center for Atmospheric Research
C               PO 3000, Boulder, Colorado
C
C   Date:       Fri Feb 16, 1996
C
C   Description:    Reads two netCDF variables, U and V winds, and produces
C                   a contour plot of the wind speed.
C
C
      external NhlFAppClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFCairoWindowWorkstationClass
      external NhlFScalarFieldClass
      external NhlFContourPlotClass
      external NhlFMapPlotClass
      parameter(NPTS=73, NCOLORS=16)
C
C Declare variables for the HLU routine calls.
C
      integer appid, workid, cndata, cn_plot, map, srlist
C
C Declare variables for color map
C
      integer length(2)
      real cmap(3,NCOLORS)
C
C Declare variables for contour plot fills.
C
      integer fillcolors(14)
      data fillcolors/15,14,2,3,4,7,6,8,9,10,11,13,12,0/
C
C Declare variables for Tick Mark values.
C
      real xbvalues(7),ylvalues(7)
      character*4 xblabels(7)
      character*3 yllabels(7)
      data xbvalues/-180.,-120.,-60.,0.,60.,120.,180./
      data ylvalues/-90., -60.,-30.,0.,30.,60.,90./
      data xblabels/'180W','120W','60W','0','60E','120E','180E'/
      data yllabels/'90S','60S','30S','EQ','30N','60N','90N'/
C
C Declare variables to hold U, V, and wind speed data.
C
      real u(NPTS,NPTS), v(NPTS,NPTS), spd(NPTS,NPTS)
C
C Declare variables for getting information from netCDF file.
C
      integer  ncid, lon_id, lat_id, uid, vid
      real lon(NPTS), lat(NPTS)
      integer start(3), count(3), lonlen, latlen
      character*256 filename
      character*50 recname
      character*7  wks_type
C
C Define the workstation type
C
      wks_type = "x11"

C
C Generate a color map.
C
      cmap(1,1) = 1.00  ! white
      cmap(2,1) = 1.00
      cmap(3,1) = 1.00
      cmap(1,2) = 0.00  ! black
      cmap(2,2) = 0.00
      cmap(3,2) = 0.00
      cmap(1,3) = 0.00  ! blue
      cmap(2,3) = 0.00
      cmap(3,3) = 1.00
      cmap(1,4) = 0.20  ! sky blue
      cmap(2,4) = 0.56
      cmap(3,4) = 0.80
      cmap(1,5) = 0.00  ! cyan
      cmap(2,5) = 1.00
      cmap(3,5) = 1.00
      cmap(1,6) = 0.50  ! blue magenta
      cmap(2,6) = 0.00
      cmap(3,6) = 1.00
      cmap(1,7) = 0.00  ! green
      cmap(2,7) = 1.00
      cmap(3,7) = 0.00
      cmap(1,8) = 0.14  ! forest green
      cmap(2,8) = 0.56
      cmap(3,8) = 0.14
      cmap(1,9) = 1.00  ! yellow
      cmap(2,9) = 1.00
      cmap(3,9) = 0.00
      cmap(1,10) = 1.00  ! orange
      cmap(2,10) = 0.50
      cmap(3,10) = 0.00
      cmap(1,11) = 1.00 ! magenta
      cmap(2,11) = 0.00
      cmap(3,11) = 1.00
      cmap(1,12) = 1.00 ! red
      cmap(2,12) = 0.00
      cmap(3,12) = 0.00
      cmap(1,13) = 0.65 ! brown
      cmap(2,13) = 0.16
      cmap(3,13) = 0.16
      cmap(1,14) = 0.86 ! tan
      cmap(2,14) = 0.58
      cmap(3,14) = 0.44
      cmap(1,15) = 0.66 ! light gray
      cmap(2,15) = 0.66
      cmap(3,15) = 0.66
      cmap(1,16) = 0.40 ! dark gray
      cmap(2,16) = 0.40
      cmap(3,16) = 0.40
C
C Initialize the HLU library and set up resource template.
C A resource file is not used in this example, but if you did
C want one, it would be called "cn14.res".
C
      call NhlFInitialize
      call NhlFRLCreate(srlist,'setrl')
      call NhlFRLClear(srlist)
      call NhlFRLSetString(srlist,'appDefaultParent','True',ierr)
      call NhlFRLSetString(srlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'cn14',NhlFAppClass,0,srlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkMetaName','./cn14f.ncgm',ierr)
         call NhlFCreate(workid,'cn14Work',
     +        NhlFNcgmWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an XWorkstation object.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkPause','True',ierr)
         call NhlFCreate(workid,'cn14Work',
     +        NhlFCairoWindowWorkstationClass,
     +        0,srlist,ierr)
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PostScript workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkPSFileName','./cn14f.ps',ierr)
         call NhlFCreate(workid,'cn14Work',
     +        NhlFPSWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkPDFFileName','./cn14f.pdf',ierr)
         call NhlFCreate(workid,'cn14Work',
     +        NhlFPDFWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkFileName','./cn14f',ierr)
         call NhlFRLSetString(srlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(workid,'cn14Work',
     +        NhlFCairoPSPDFWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkFileName','./cn14f',ierr)
         call NhlFRLSetString(srlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(workid,'cn14Work',
     +        NhlFCairoImageWorkstationClass,0,srlist,ierr)
      endif
C
C Set color map resource.
C
      length(1) = 3
      length(2) = NCOLORS
      call NhlFRLClear(srlist)
      call NhlFRLSetMDFloatArray(srlist,'wkColorMap',cmap,2,length,
     +     ierr)
      call NhlFSetValues(workid,srlist,ierr)
C
C Read NCL created NetCDF file containing U and V wind components.
C
      call gngpat(filename,'data',ierr)
      do 10 i=1,256
         if( filename(i:i).eq.char(0) ) then
            filename(i:i+17)='/cdf/941110_UV.cdf'
            goto 15
         endif
 10   continue
C      
C The second argument to 'ncopn' should be NCNOWRIT, but since we
C can't include 'netcdf.inc', we are using the value '0' instead.
C
 15   ncid = ncopn(filename,0,ierr)
C
C Get the lat/lon dimensions.
C
      lat_id = ncdid(ncid,'lat',ierr)
      lon_id = ncdid(ncid,'lon',ierr)
      call ncdinq(ncid,lat_id,recname,latlen,ierr)
      call ncdinq(ncid,lon_id,recname,lonlen,ierr)
C
C Read in lat/lon values from netCDF file.
C
      start(1) = 1
      lat_id = ncvid(ncid,'lat',ierr)
      count(1) = latlen
      call ncvgt(ncid,lat_id,start,count,lat,ierr)

      lon_id = ncvid(ncid,'lon',ierr)
      count(1) = lonlen
      call ncvgt(ncid,lon_id,start,count,lon,ierr)
C
C Read in u and v from netCDF file.
C
      uid = ncvid(ncid,'u',ierr)
      vid = ncvid(ncid,'v',ierr)
      start(1) = 1
      start(2) = 1
      count(1) = lonlen
      count(2) = latlen
      call ncvgt(ncid,uid,start,count,u,ierr)
      call ncvgt(ncid,vid,start,count,v,ierr)
C
C Close the netCDF file.
C
      call ncclos(ncid,ierr)
C
C Compute the wind speed.
C
      do i=1,lonlen
         do j=1,latlen
            spd(i,j) = sqrt(u(i,j)**2 + v(i,j)**2)
         enddo
      enddo
C
C Create the ScalarField object needed by ContourPlot.
C
      count(1) = NPTS
      count(2) = NPTS
      call NhlFRLClear(srlist)
      call NhlFRLSetMDFloatArray(srlist,'sfDataArray',spd,2,count,ierr)
      call NhlFRLSetFloat(srlist,'sfXCStartV',lon(1),ierr)
      call NhlFRLSetFloat(srlist,'sfXCEndV',lon(lonlen),ierr)
      call NhlFRLSetFloat(srlist,'sfYCStartV',lat(1),ierr)
      call NhlFRLSetFloat(srlist,'sfYCEndV',lat(latlen),ierr)
      call NhlFCreate(cndata,'cndata',NhlFscalarFieldClass,appid,srlist,
     +     ierr)
C
C Create the ContourPlot object and assign data to it.
C
      call NhlFRLClear(srlist)
      call NhlFRLSetFloat(srlist,'vpXF',.10,ierr)
      call NhlFRLSetFloat(srlist,'vpYF',.80,ierr)
      call NhlFRLSetFloat(srlist,'vpWidthF',.80,ierr)
      call NhlFRLSetFloat(srlist,'vpHeightF',.40,ierr)
      call NhlFRLSetInteger(srlist,'cnScalarFieldData',cndata,ierr)
      call NhlFRLSetString(srlist,'cnFillOn','True',ierr)
      call NhlFRLSetIntegerArray(srlist,'cnFillColors',fillcolors,14,
     +     ierr)
C
C Set the range and spacing of the contour levels.
C
      call NhlFRLSetString(srlist,'cnLevelSelectionMode','ManualLevels',
     +     ierr)
      call NhlFRLSetFloat(srlist,'cnMinLevelValF',2.0,ierr)
      call NhlFRLSetFloat(srlist,'cnMaxLevelValF',28.0,ierr)
      call NhlFRLSetFloat(srlist,'cnLevelSpacingF',3.0,ierr)
C
C Turn off the contour lines and labels.
C
      call NhlFRLSetString(srlist,'cnLinesOn','False',ierr)
      call NhlFRLSetString(srlist,'cnLineLabelsOn','False',ierr)
      call NhlFRLSetString(srlist,'cnHighLabelsOn','False',ierr)
      call NhlFRLSetString(srlist,'cnLowLabelsOn','False',ierr)
      call NhlFRLSetString(srlist,'cnInfoLabelOn','False',ierr)
C
C  Set resources of the inherited Title objects.
C
      call NhlFRLSetString(srlist,'tiXAxisString','Longitude',ierr)
      call NhlFRLSetString(srlist,'tiXAxisFont','helvetica',ierr)
      call NhlFRLSetFloat(srlist,'tiXAxisFontHeightF',.02,ierr)
      call NhlFRLSetString(srlist,'tiYAxisString','Latitude',ierr)
      call NhlFRLSetString(srlist,'tiYAxisFont','helvetica',ierr)
      call NhlFRLSetFloat(srlist,'tiYAxisFontHeightF',.02,ierr)
      call NhlFRLSetString(srlist,'tiMainString','Wind Speed',ierr)
      call NhlFRLSetString(srlist,'tiMainFont','helvetica',ierr)
      call NhlFRLSetFloat(srlist,'tiMainFontHeightF',.03,ierr)
C
C Set resources of the inherited TickMark object.
C
      call NhlFRLSetString(srlist,'tmXBMode','EXPLICIT',ierr)
      call NhlFRLSetFloatArray(srlist,'tmXBValues',xbvalues,7,ierr)
      call NhlFRLSetStringArray(srlist,'tmXBLabels',xblabels,7,ierr)
      call NhlFRLSetFloatArray(srlist,'tmYLValues',ylvalues,7,ierr)
      call NhlFRLSetStringArray(srlist,'tmYLLabels',yllabels,7,ierr)
      call NhlFRLSetString(srlist,'tmYLMode','EXPLICIT',ierr)
      call NhlFRLSetFloat(srlist,'tmXBLabelFontHeightF',.016,ierr)
      call NhlFRLSetFloat(srlist,'tmYLLabelFontHeightF',.016,ierr)
      call NhlFRLSetString(srlist,'tmXBLabelFont','times-roman',ierr)
      call NhlFRLSetString(srlist,'tmYLLabelFont','times-roman',ierr)
      call NhlFRLSetString(srlist,'tmXBMinorOn','False',ierr)
      call NhlFRLSetString(srlist,'tmYLMinorOn','False',ierr)
      call NhlFRLSetString(srlist,'pmLabelBarDisplayMode','ALWAYS',ierr)
      call NhlFRLSetFloat(srlist,'pmLabelBarHeightF',.15,ierr)
      call NhlFRLSetFloat(srlist,'pmLabelBarWidthF',.8,ierr)
      call NhlFRLSetString(srlist,'pmLabelBarSide','bottom',ierr)
      call NhlFRLSetString(srlist,'lbOrientation','horizontal',ierr)
      call NhlFRLSetInteger(srlist,'lbBoxLinesOn',0,ierr)
      call NhlFRLSetString(srlist,'lbLabelsOn','True',ierr)
      call NhlFRLSetString(srlist,'lbPerimOn','False',ierr)
      call NhlFRLSetString(srlist,'lbAutoManage','False',ierr)
      call NhlFRLSetFloat(srlist,'lbLabelFontHeightF',0.015,ierr)
      call NhlFRLSetString(srlist,'lbLabelFont','times-roman',ierr)
      call NhlFCreate(cn_plot,'cn_plot',NhlFcontourPlotClass,workid,
     +     srlist,ierr)
C
C Create a MapPlot object.
C
      call NhlFRLClear(srlist)
      call NhlFRLSetFloat(srlist,'vpXF',.10,ierr)
      call NhlFRLSetFloat(srlist,'vpYF',.80,ierr)
      call NhlFRLSetFloat(srlist,'vpWidthF',.80,ierr)
      call NhlFRLSetFloat(srlist,'vpHeightF',.40,ierr)
      call NhlFRLSetString(srlist,'mpFillOn','True',ierr)
      call NhlFRLSetString(srlist,'mpLandFillColor','Black',ierr)
      call NhlFRLSetString(srlist,'mpOceanFillColor','Transparent',ierr)
      call NhlFRLSetString(srlist,'mpInlandWaterFillColor','Black',ierr)
      call NhlFRLSetString(srlist,'mpGridLineColor','LightGray',ierr)
      call NhlFRLSetString(srlist,'mpGeophysicalLineColor','Black',ierr)
      call NhlFRLSetFloat(srlist,'mpGeophysicalLineThicknessF',1.,ierr)
      call NhlFCreate(map,'map',nhlfmapplotclass,workid,srlist,
     +     ierr)
C
C Notice that we are not doing an overlay here! We are simply drawing
C the ContourPlot first, and then the Map Plot.
C
      call NhlFDraw(cn_plot,ierr)
      call NhlFDraw(map,ierr)
      call NhlFFrame(workid,ierr)
      call NhlFClose
      stop
      end

C
C $Id: issetr.f,v 1.8 2008-07-27 00:17:16 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE ISSETR (IPN,RVL)
C
      CHARACTER*(*) IPN
C
C This subroutine is called to set the real value of a specified
C parameter.
C
C IPN is the name of the parameter whose value is to be set.
C
C RVL is the desired new real value.
C
C Declare the required common blocks.
C
      COMMON /ISCOMN/ BIG,BIGD,DBPI,IDONE,IFILL,IFLIP,IONES,IHSS(1000),
     +                IREF,ISCA(16,256),ISCALE,ISCR(16,256),ISLBT,ISDR,
     +                LHSS,LX,NFPW,NINU,NINV,NINW,NX,NY,R0,RNX,RNY,
     +                SMALL,SVAL,TENSN,U,V,W,XMAX,XMIN,YMAX,YMIN,XVPL,
     +                XVPR,YVPB,YVPT
      SAVE   /ISCOMN/
C
      COMMON /TEMPRX/ RZERO
      SAVE   /TEMPRX/
C
C Define a character temporary to hold an error message.
C
      CHARACTER*48 CTM
C
C Do a call forcing a BLOCKDATA to be loaded from a binary library.
C
      CALL ISBLDA
C
C Check for a parameter name that is too short.
C
      IF (LEN(IPN).LT.2) THEN
        CTM(1:46)='ISSETI OR ISSETR - PARAMETER NAME TOO SHORT - '
        CTM(47:46+LEN(IPN))=IPN
        CALL SETER (CTM(1:46+LEN(IPN)),1,2)
        STOP
      END IF
C
C Set the appropriate parameter value.
C
      IF      (IPN(1:2).EQ.'IU'.OR.IPN(1:2).EQ.'iu') THEN
        NINU=MAX(-10,MIN(10,INT(RVL)))
      ELSE IF (IPN(1:2).EQ.'IV'.OR.IPN(1:2).EQ.'iv') THEN
        NINV=MAX(-10,MIN(10,INT(RVL)))
      ELSE IF (IPN(1:2).EQ.'IW'.OR.IPN(1:2).EQ.'iw') THEN
        NINW=MAX(-10,MIN(10,INT(RVL)))
      ELSE IF (IPN(1:2).EQ.'RF'.OR.IPN(1:2).EQ.'rf') THEN
        IREF=MAX(0,MIN(1,INT(RVL)))
      ELSE IF (IPN(1:2).EQ.'RS'.OR.IPN(1:2).EQ.'rs') THEN
        RZERO=MAX(0.,RVL)
      ELSE IF (IPN(1:2).EQ.'SL'.OR.IPN(1:2).EQ.'sl') THEN
        DBPI=MAX(.0001,MIN(.1,RVL))
      ELSE IF (IPN(1:2).EQ.'SM'.OR.IPN(1:2).EQ.'sm') THEN
        IF (INT(RVL).EQ.0) THEN
          NX=128
          NY=128
        ELSE
          NX=256
          NY=256
        END IF
        IDONE=0
      ELSE IF (IPN(1:2).EQ.'ST'.OR.IPN(1:2).EQ.'st') THEN
        TENSN=MAX(0.,RVL)
      ELSE IF (IPN(1:2).EQ.'SV'.OR.IPN(1:2).EQ.'sv') THEN
        SVAL=RVL
      ELSE IF (IPN(1:2).EQ.'VL'.OR.IPN(1:2).EQ.'vl') THEN
        XVPL=MAX(0.,MIN(1.,RVL))
      ELSE IF (IPN(1:2).EQ.'VR'.OR.IPN(1:2).EQ.'vr') THEN
        XVPR=MAX(0.,MIN(1.,RVL))
      ELSE IF (IPN(1:2).EQ.'VB'.OR.IPN(1:2).EQ.'vb') THEN
        YVPB=MAX(0.,MIN(1.,RVL))
      ELSE IF (IPN(1:2).EQ.'VT'.OR.IPN(1:2).EQ.'vt') THEN
        YVPT=MAX(0.,MIN(1.,RVL))
      ELSE
        CTM(1:46)='ISSETI OR ISSETR - PARAMETER NAME NOT KNOWN - '
        CTM(47:48)=IPN(1:2)
        CALL SETER (CTM(1:48),2,2)
        STOP
      END IF
C
C Done.
C
      RETURN
C
      END

      SUBROUTINE CUNGL2( M, N, K, A, LDA, TAU, WORK, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      INTEGER            INFO, K, LDA, M, N
*     ..
*     .. Array Arguments ..
      COMPLEX            A( LDA, * ), TAU( * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  CUNGL2 generates an m-by-n complex matrix Q with orthonormal rows,
*  which is defined as the first m rows of a product of k elementary
*  reflectors of order n
*
*        Q  =  H(k)' . . . H(2)' H(1)'
*
*  as returned by CGELQF.
*
*  Arguments
*  =========
*
*  M       (input) INTEGER
*          The number of rows of the matrix Q. M >= 0.
*
*  N       (input) INTEGER
*          The number of columns of the matrix Q. N >= M.
*
*  K       (input) INTEGER
*          The number of elementary reflectors whose product defines the
*          matrix Q. M >= K >= 0.
*
*  A       (input/output) COMPLEX array, dimension (LDA,N)
*          On entry, the i-th row must contain the vector which defines
*          the elementary reflector H(i), for i = 1,2,...,k, as returned
*          by CGELQF in the first k rows of its array argument A.
*          On exit, the m by n matrix Q.
*
*  LDA     (input) INTEGER
*          The first dimension of the array A. LDA >= max(1,M).
*
*  TAU     (input) COMPLEX array, dimension (K)
*          TAU(i) must contain the scalar factor of the elementary
*          reflector H(i), as returned by CGELQF.
*
*  WORK    (workspace) COMPLEX array, dimension (M)
*
*  INFO    (output) INTEGER
*          = 0: successful exit
*          < 0: if INFO = -i, the i-th argument has an illegal value
*
*  =====================================================================
*
*     .. Parameters ..
      COMPLEX            ONE, ZERO
      PARAMETER          ( ONE = ( 1.0E+0, 0.0E+0 ),
     $                   ZERO = ( 0.0E+0, 0.0E+0 ) )
*     ..
*     .. Local Scalars ..
      INTEGER            I, J, L
*     ..
*     .. External Subroutines ..
      EXTERNAL           CLACGV, CLARF, CSCAL, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          CONJG, MAX
*     ..
*     .. Executable Statements ..
*
*     Test the input arguments
*
      INFO = 0
      IF( M.LT.0 ) THEN
         INFO = -1
      ELSE IF( N.LT.M ) THEN
         INFO = -2
      ELSE IF( K.LT.0 .OR. K.GT.M ) THEN
         INFO = -3
      ELSE IF( LDA.LT.MAX( 1, M ) ) THEN
         INFO = -5
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'CUNGL2', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( M.LE.0 )
     $   RETURN
*
      IF( K.LT.M ) THEN
*
*        Initialise rows k+1:m to rows of the unit matrix
*
         DO 20 J = 1, N
            DO 10 L = K + 1, M
               A( L, J ) = ZERO
   10       CONTINUE
            IF( J.GT.K .AND. J.LE.M )
     $         A( J, J ) = ONE
   20    CONTINUE
      END IF
*
      DO 40 I = K, 1, -1
*
*        Apply H(i)' to A(i:m,i:n) from the right
*
         IF( I.LT.N ) THEN
            CALL CLACGV( N-I, A( I, I+1 ), LDA )
            IF( I.LT.M ) THEN
               A( I, I ) = ONE
               CALL CLARF( 'Right', M-I, N-I+1, A( I, I ), LDA,
     $                     CONJG( TAU( I ) ), A( I+1, I ), LDA, WORK )
            END IF
            CALL CSCAL( N-I, -TAU( I ), A( I, I+1 ), LDA )
            CALL CLACGV( N-I, A( I, I+1 ), LDA )
         END IF
         A( I, I ) = ONE - CONJG( TAU( I ) )
*
*        Set A(i,1:i-1,i) to zero
*
         DO 30 L = 1, I - 1
            A( I, L ) = ZERO
   30    CONTINUE
   40 CONTINUE
      RETURN
*
*     End of CUNGL2
*
      END

      SUBROUTINE SSYGV( ITYPE, JOBZ, UPLO, N, A, LDA, B, LDB, W, WORK,
     $                  LWORK, INFO )
*
*  -- LAPACK driver routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          JOBZ, UPLO
      INTEGER            INFO, ITYPE, LDA, LDB, LWORK, N
*     ..
*     .. Array Arguments ..
      REAL               A( LDA, * ), B( LDB, * ), W( * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  SSYGV computes all the eigenvalues, and optionally, the eigenvectors
*  of a real generalized symmetric-definite eigenproblem, of the form
*  A*x=(lambda)*B*x,  A*Bx=(lambda)*x,  or B*A*x=(lambda)*x.
*  Here A and B are assumed to be symmetric and B is also
*  positive definite.
*
*  Arguments
*  =========
*
*  ITYPE   (input) INTEGER
*          Specifies the problem type to be solved:
*          = 1:  A*x = (lambda)*B*x
*          = 2:  A*B*x = (lambda)*x
*          = 3:  B*A*x = (lambda)*x
*
*  JOBZ    (input) CHARACTER*1
*          = 'N':  Compute eigenvalues only;
*          = 'V':  Compute eigenvalues and eigenvectors.
*
*  UPLO    (input) CHARACTER*1
*          = 'U':  Upper triangles of A and B are stored;
*          = 'L':  Lower triangles of A and B are stored.
*
*  N       (input) INTEGER
*          The order of the matrices A and B.  N >= 0.
*
*  A       (input/output) REAL array, dimension (LDA, N)
*          On entry, the symmetric matrix A.  If UPLO = 'U', the
*          leading N-by-N upper triangular part of A contains the
*          upper triangular part of the matrix A.  If UPLO = 'L',
*          the leading N-by-N lower triangular part of A contains
*          the lower triangular part of the matrix A.
*
*          On exit, if JOBZ = 'V', then if INFO = 0, A contains the
*          matrix Z of eigenvectors.  The eigenvectors are normalized
*          as follows:
*          if ITYPE = 1 or 2, Z**T*B*Z = I;
*          if ITYPE = 3, Z**T*inv(B)*Z = I.
*          If JOBZ = 'N', then on exit the upper triangle (if UPLO='U')
*          or the lower triangle (if UPLO='L') of A, including the
*          diagonal, is destroyed.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(1,N).
*
*  B       (input/output) REAL array, dimension (LDB, N)
*          On entry, the symmetric positive definite matrix B.
*          If UPLO = 'U', the leading N-by-N upper triangular part of B
*          contains the upper triangular part of the matrix B.
*          If UPLO = 'L', the leading N-by-N lower triangular part of B
*          contains the lower triangular part of the matrix B.
*
*          On exit, if INFO <= N, the part of B containing the matrix is
*          overwritten by the triangular factor U or L from the Cholesky
*          factorization B = U**T*U or B = L*L**T.
*
*  LDB     (input) INTEGER
*          The leading dimension of the array B.  LDB >= max(1,N).
*
*  W       (output) REAL array, dimension (N)
*          If INFO = 0, the eigenvalues in ascending order.
*
*  WORK    (workspace/output) REAL array, dimension (LWORK)
*          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*
*  LWORK   (input) INTEGER
*          The length of the array WORK.  LWORK >= max(1,3*N-1).
*          For optimal efficiency, LWORK >= (NB+2)*N,
*          where NB is the blocksize for SSYTRD returned by ILAENV.
*
*          If LWORK = -1, then a workspace query is assumed; the routine
*          only calculates the optimal size of the WORK array, returns
*          this value as the first entry of the WORK array, and no error
*          message related to LWORK is issued by XERBLA.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*          > 0:  SPOTRF or SSYEV returned an error code:
*             <= N:  if INFO = i, SSYEV failed to converge;
*                    i off-diagonal elements of an intermediate
*                    tridiagonal form did not converge to zero;
*             > N:   if INFO = N + i, for 1 <= i <= N, then the leading
*                    minor of order i of B is not positive definite.
*                    The factorization of B could not be completed and
*                    no eigenvalues or eigenvectors were computed.
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ONE
      PARAMETER          ( ONE = 1.0E+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            LQUERY, UPPER, WANTZ
      CHARACTER          TRANS
      INTEGER            LWKOPT, NB, NEIG
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            ILAENV
      EXTERNAL           ILAENV, LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           SPOTRF, SSYEV, SSYGST, STRMM, STRSM, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      WANTZ = LSAME( JOBZ, 'V' )
      UPPER = LSAME( UPLO, 'U' )
      LQUERY = ( LWORK.EQ.-1 )
*
      INFO = 0
      IF( ITYPE.LT.1 .OR. ITYPE.GT.3 ) THEN
         INFO = -1
      ELSE IF( .NOT.( WANTZ .OR. LSAME( JOBZ, 'N' ) ) ) THEN
         INFO = -2
      ELSE IF( .NOT.( UPPER .OR. LSAME( UPLO, 'L' ) ) ) THEN
         INFO = -3
      ELSE IF( N.LT.0 ) THEN
         INFO = -4
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -6
      ELSE IF( LDB.LT.MAX( 1, N ) ) THEN
         INFO = -8
      ELSE IF( LWORK.LT.MAX( 1, 3*N-1 ) .AND. .NOT.LQUERY ) THEN
         INFO = -11
      END IF
*
      IF( INFO.EQ.0 ) THEN
         NB = ILAENV( 1, 'SSYTRD', UPLO, N, -1, -1, -1 )
         LWKOPT = ( NB+2 )*N
         WORK( 1 ) = LWKOPT
      END IF
*
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'SSYGV ', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
*
*     Form a Cholesky factorization of B.
*
      CALL SPOTRF( UPLO, N, B, LDB, INFO )
      IF( INFO.NE.0 ) THEN
         INFO = N + INFO
         RETURN
      END IF
*
*     Transform problem to standard eigenvalue problem and solve.
*
      CALL SSYGST( ITYPE, UPLO, N, A, LDA, B, LDB, INFO )
      CALL SSYEV( JOBZ, UPLO, N, A, LDA, W, WORK, LWORK, INFO )
*
      IF( WANTZ ) THEN
*
*        Backtransform eigenvectors to the original problem.
*
         NEIG = N
         IF( INFO.GT.0 )
     $      NEIG = INFO - 1
         IF( ITYPE.EQ.1 .OR. ITYPE.EQ.2 ) THEN
*
*           For A*x=(lambda)*B*x and A*B*x=(lambda)*x;
*           backtransform eigenvectors: x = inv(L)'*y or inv(U)*y
*
            IF( UPPER ) THEN
               TRANS = 'N'
            ELSE
               TRANS = 'T'
            END IF
*
            CALL STRSM( 'Left', UPLO, TRANS, 'Non-unit', N, NEIG, ONE,
     $                  B, LDB, A, LDA )
*
         ELSE IF( ITYPE.EQ.3 ) THEN
*
*           For B*A*x=(lambda)*x;
*           backtransform eigenvectors: x = L*y or U'*y
*
            IF( UPPER ) THEN
               TRANS = 'T'
            ELSE
               TRANS = 'N'
            END IF
*
            CALL STRMM( 'Left', UPLO, TRANS, 'Non-unit', N, NEIG, ONE,
     $                  B, LDB, A, LDA )
         END IF
      END IF
*
      WORK( 1 ) = LWKOPT
      RETURN
*
*     End of SSYGV
*
      END

C
C	$Id: gopwk.f,v 1.10 2008-07-27 00:20:58 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GOPWK(WKID,CONID,WTYPE)
C
      INTEGER WKID,CONID,WTYPE
C
      CALL GZOPWK(WKID,CONID,WTYPE)
C
      RETURN
      END

C
C      $Id: nm03f.f,v 1.7 2010-03-15 22:49:24 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                       C
C                Copyright (C)  1997                                    C
C        University Corporation for Atmospheric Research                C
C                All Rights Reserved                                    C
C                                                                       C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C  File:       nm03f.c
C
C  Author:     Mary Haley (taken from one of Fred Clare's examples)
C          National Center for Atmospheric Research
C          PO 3000, Boulder, Colorado
C
C  Date:       Mon Dec 22 11:49:46 MST 1997
C
C  Description: How to compute aspects and slopes.
C
      external NhlFAppClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFCairoWindowWorkstationClass
      external NhlFScalarFieldClass
      external NhlFVectorFieldClass
      external NhlFContourPlotClass
      external NhlFVectorPlotClass

      parameter(NumIn=171,NumXOut=21,NumYOut=21)
      parameter(IDIM=2*NumXOut*NumYOut)
      parameter(RAD2DEG = 57.29578)


      real  xo(NumXOut), yo(NumYOut), zo(NumXOut,NumYOut)
      real rtmp(NumXOut,NumYOut),u(NumXOut,NumYOut),v(NumXOut,NumYOut)
      real x(NumIn),y(NumIn),z(NumIn)

      data x/
     +    1.16,  0.47,  0.29,  0.72,  0.52,  1.12,  0.33,  0.20,  0.30,
     +    0.78,  0.92,  0.52,  0.44,  0.22, -0.10,  0.11,  0.59,  1.13,
     +    0.68,  1.11,  0.93,  0.29,  0.74,  0.43,  0.87,  0.87, -0.10,
     +    0.26,  0.85,  0.00, -0.02,  1.01, -0.12,  0.65,  0.39,  0.96,
     +    0.39,  0.38,  0.94, -0.03, -0.17,  0.00,  0.03,  0.67, -0.06,
     +    0.82, -0.03,  1.08,  0.37,  1.02, -0.11, -0.13,  1.03,  0.61,
     +    0.26,  0.18,  0.62,  0.42,  1.03,  0.72,  0.97,  0.08,  1.18,
     +    0.00,  0.69,  0.10,  0.80,  0.06,  0.82,  0.20,  0.46,  0.37,
     +    1.16,  0.93,  1.09,  0.96,  1.00,  0.80,  0.01,  0.12,  1.01,
     +    0.48,  0.79,  0.04,  0.42,  0.48, -0.18,  1.16,  0.85,  0.97,
     +    0.14,  0.40,  0.78,  1.12,  1.19,  0.68,  0.65,  0.41,  0.90,
     +    0.84, -0.11, -0.01, -0.02, -0.10,  1.04,  0.58,  0.61,  0.12,
     +   -0.02, -0.03,  0.27,  1.17,  1.02,  0.16, -0.17,  1.03,  0.13,
     +    0.04, -0.03,  0.15,  0.00, -0.01,  0.91,  1.20,  0.54, -0.14,
     +    1.03,  0.93,  0.42,  0.36, -0.10,  0.57,  0.22,  0.74,  1.15,
     +    0.40,  0.82,  0.96,  1.09,  0.42,  1.13,  0.24,  0.51,  0.60,
     +    0.06,  0.38,  0.15,  0.59,  0.76,  1.16,  0.02,  0.86,  1.14,
     +    0.37,  0.38,  0.26,  0.26,  0.07,  0.87,  0.90,  0.83,  0.09,
     +    0.03,  0.56, -0.19,  0.51,  1.07, -0.13,  0.99,  0.84,  0.22/
      data y/
     +   -0.11,  1.07,  1.11, -0.17,  0.08,  0.09,  0.91,  0.17, -0.02,
     +    0.83,  1.08,  0.87,  0.46,  0.66,  0.50, -0.14,  0.78,  1.08,
     +    0.65,  0.00,  1.03,  0.06,  0.69, -0.16,  0.02,  0.59,  0.19,
     +    0.54,  0.68,  0.95,  0.30,  0.77,  0.94,  0.76,  0.56,  0.12,
     +    0.05, -0.07,  1.01,  0.61,  1.04, -0.07,  0.46,  1.07,  0.87,
     +    0.11,  0.63,  0.06,  0.53,  0.95,  0.78,  0.48,  0.45,  0.77,
     +    0.78,  0.29,  0.38,  0.85, -0.10,  1.17,  0.35,  1.14, -0.04,
     +    0.34, -0.18,  0.78,  0.17,  0.63,  0.88, -0.12,  0.58, -0.12,
     +    1.00,  0.99,  0.45,  0.86, -0.15,  0.97,  0.99,  0.90,  0.42,
     +    0.61,  0.74,  0.41,  0.44,  1.08,  1.06,  1.18,  0.89,  0.74,
     +    0.74, -0.06,  0.00,  0.99,  0.03,  1.00, -0.04,  0.24,  0.65,
     +    0.12,  0.13, -0.09, -0.05,  1.03,  1.07, -0.02,  1.18,  0.19,
     +    0.03, -0.03,  0.86,  1.12,  0.38,  0.72, -0.20, -0.08, -0.18,
     +    0.32,  0.13, -0.19,  0.93,  0.81,  0.31,  1.09, -0.03,  1.01,
     +   -0.17,  0.84, -0.11,  0.45,  0.18,  0.23,  0.81,  0.39,  1.09,
     +   -0.05,  0.58,  0.53,  0.96,  0.43,  0.48,  0.96, -0.03,  1.13,
     +    1.16,  0.16,  1.15,  0.57,  0.13,  0.71,  0.35,  1.04,  0.62,
     +    1.03,  0.98,  0.31,  0.70,  0.97,  0.87,  1.14,  0.08,  1.19,
     +    0.88,  1.00,  0.51,  0.03,  0.17,  1.01,  0.44,  0.17, -0.11/
C

      dimension iwork(IDIM)
      real xc, yc
      integer ierr
      integer appid,wid,gkswid
      integer srlist, grlist
      integer i,len_dims(2)
      character*7  wks_type
C
C Default is to display output to an NCGM workstation.
C
      wks_type = "ncgm"
C
C Initialize the high level utility library
C
      call NhlFInitialize
C
C Create an application context. Set the app dir to the current directory
C so the application looks for a resource file in the working directory.
C
      call NhlFRLCreate(srlist,'setrl')
      call NhlFRLCreate(grlist,'getrl')

      call NhlFRLClear(srlist)
      call NhlFRLSetString(srlist,'appDefaultParent','True',ierr)
      call NhlFRLSetString(srlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'nm03',NhlFAppClass,0,srlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkMetaName','./nm03f.ncgm',ierr)
         call NhlFCreate(wid,'nm03Work',
     +        NhlFNcgmWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X11 workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkPause','True',ierr)
         call NhlFCreate(wid,'nm03Work',
     +        NhlFCairoWindowWorkstationClass,
     +        0,srlist,ierr)
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PostScript workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkPSFileName','./nm03f.ps',ierr)
         call NhlFCreate(wid,'nm03Work',
     +        NhlFPSWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkPDFFileName','./nm03f.pdf',ierr)
         call NhlFCreate(wid,'nm03Work',
     +        NhlFPDFWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkFileName','./nm03f',ierr)
         call NhlFRLSetString(srlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(wid,'nm03Work',
     +        NhlFCairoPSPDFWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkFileName','./nm03f',ierr)
         call NhlFRLSetString(srlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(wid,'nm03Work',
     +        NhlFCairoImageWorkstationClass,0,srlist,ierr)
      endif
C
C  Define the function values.
C
      do 5 i=1,NumIn
        z(i) = (x(i)-0.25)**2 + (y(i)-0.50)**2
    5 continue
C
C  Define the output grid.
C
      xmin = 0.
      xmax = 1.
      xc = (xmax-xmin)/(NumXOut-1.) 
      do 20 i=1,NumXOut
        xo(i) = xmin+real(i-1) * xc
 20   continue

      ymin = 0.
      ymax = 1.
      yc = (ymax-ymin)/(NumYOut-1.) 
      do 30 i=1,NumYOut
        yo(i) = ymin+real(i-1) * yc
 30   continue

      call nnseti('SDI - compute slopes and aspects',1)
      call nnseti('IGR - use gradient estimates',1)
      call nnseti('RAD - return results in radians',1)
      call natgrids(NumIn, x, y, z, NumXOut, NumYOut, xo, yo, zo, ierr)
C
C Get Workstation ID.
C
      call NhlFRLClear(grlist)
      call NhlFRLGetInteger(grlist,'wkGksWorkId',gkswid,ierr)
      call NhlFGetValues(wid,grlist,ierr)
C
C There's no HLU object for surface plots yet, so we need to call the
C LLUs to get a surface plot.
C
      call gacwk (gkswid)
      call drwsrf(gkswid,NumXOut,NumYOut,xo,yo,zo,10.,-25.,50.,iwork)
      call gdawk (gkswid)
C
C  Get the aspects.
C
      do 60 j=1,NumYOut
        do 65 i=1,NumXOut
          call nngetaspects(i,j,rtmp(i,j),ierr)
   65   continue
   60 continue

      do 100 i=1,NumXOut
        do 101 j=1,NumYOut
          u(i,j) = sin(rtmp(i,j))
          v(i,j) = cos(rtmp(i,j))
  101   continue
  100 continue
C
C Create a VectorField object; then use its id as the value of
C the 'vcVectorFieldData' resource when creating the VectorPlot object.
C
      len_dims(1) = NumXOut
      len_dims(2) = NumYOut

      call NhlFRLClear(srlist)
      call NhlFRLSetMDFloatArray(srlist,'vfUDataArray',u,2,len_dims,
     +     ierr)
      call NhlFRLSetMDFloatArray(srlist,'vfVDataArray',v,2,len_dims,
     +     ierr)
      call NhlFCreate(vfid,'vectorfield',NhlFVectorFieldClass,appid,
     +     srlist,ierr)

      call NhlFRLClear(srlist)
      call NhlFRLSetInteger(srlist,'vcVectorFieldData',vfid,ierr)
      call NhlFCreate(vcid,'VectorPlot',NhlFVectorPlotClass,wid,srlist,
     +     ierr)

      call NhlFDraw(vcid,ierr)
      call NhlFFrame(wid,ierr)
C
C  Get the slopes; convert to degrees.
C
      do 70 i=1,NumXOut
        do 75 j=1,NumYOut
          call nngetslopes(i,j,rtmp(i,j),ierr)
          rtmp(i,j) = RAD2DEG*rtmp(i,j)
   75   continue
   70 continue
C
C Create a ScalarField data object using the data set defined above.
C
      len_dims(1) = NumXOut
      len_dims(2) = NumYOut
      call NhlFRLClear(srlist)
      call NhlFRLSetMDFloatArray(srlist,'sfDataArray',rtmp,2,len_dims,
     +     ierr)
      call NhlFCreate(dataid,'data',NhlFScalarFieldClass,appid,srlist,
     +     ierr)
      call NhlFRLClear(srlist)
      call NhlFRLSetInteger(srlist,'cnScalarFieldData',dataid,ierr)
      call NhlFCreate(cnid,'ContourPlot',NhlFContourPlotClass,wid,
     +     srlist,ierr)

      call NhlFDraw(cnid,ierr)
      call NhlFFrame(wid,ierr)
C
C NhlDestroy destroys the given id and all of its children.
C
      call NhlFDestroy(wid,ierr)
C
C Restores state.
C
      call NhlFClose
      stop
      end

      subroutine drwsrf(wkid,nx,ny,x,y,z,s1,s2,s3,iwk)
C
C  Procedure DRWSRF uses the NCAR Graphics function SRFACE to
C  draw a surface plot of the data values in Z.
C 
C  The point of observation is calculated from the 3D coordinate
C  (S1, S2, S3); the point looked at is the center of the surface.
C 
C   NX     -  Dimension of the X-axis variable X.
C   NY     -  Dimension of the Y-axis variable Y.
C   X      -  An array of X-axis values.
C   Y      -  An array of Y-axis values.
C   Z      -  An array dimensioned for NX x NY containing data
C             values for each (X,Y) coordinate.
C   S1     -  X value for the eye position.
C   S2     -  Y value for the eye position.
C   S3     -  Z value for the eye position.
C   IWK    -  Work space dimensioned for at least 2*NX*NY.
C 
C  
      dimension x(nx),y(ny),z(nx,ny),iwk(*)
      integer wkid
      dimension S(6)
c
c  Find the extreme values.
c
      xmn =  x(1)
      xmx =  x(1)
      ymn =  y(1)
      ymx =  y(1)
      zmn =  z(1,1)
      zmx =  z(1,1)

      do 10 i=2,nx
        xmn = min(xmn,x(i))
        xmx = max(xmx,x(i))
   10 continue

      do 11 i=1,ny
        ymn = min(ymn,y(i))
        ymx = max(ymx,y(i))
   11 continue

      do 12 i=1,nx
        do 13 j=1,ny
          zmn = min(zmn,z(i,j))
          zmx = max(zmx,z(i,j))
   13   continue
   12 continue

      if (s1.eq.0. .and. s2.eq.0. .and. s3.eq.0.) then
        st1 = -3.
        st2 = -1.5
        st3 = 0.75
      else
        st1 = s1
        st2 = s2
        st3 = s3
      endif
      s(1) = 5.*st1*(xmx-xmn)
      s(2) = 5.*st2*(ymx-ymn)
      s(3) = 5.*st3*(zmx-zmn)
      s(4) = 0.5*(xmx-xmn)
      s(5) = 0.5*(ymx-ymn)
      s(6) = 0.5*(zmx-zmn)
C
C Set foreground/background colors
C
      call gscr(wkid, 0, 1.00, 1.00, 1.00)
      call gscr(wkid, 1, 0.00, 0.00, 0.00)
      call gscr(wkid, 2, 0.00, 1.00, 1.00)
      call gscr(wkid, 3, 0.00, 1.00, 0.00)
      call gscr(wkid, 4, 0.70, 1.00, 0.00)
      call gscr(wkid, 5, 1.00, 1.00, 0.00)
      call gscr(wkid, 6, 1.00, 0.75, 0.00)
      call gscr(wkid, 7, 1.00, 0.50, 0.50)
      call gscr(wkid, 8, 1.00, 0.00, 0.00)

      call srface (x,y,z,iwk,nx,nx,ny,s,0.)

      return
      end

C
C	$Id: gkasci.f,v 1.5 2008-07-27 00:21:06 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      INTEGER FUNCTION GKASCI (INCODE)
C
C  Translate native character code, right-justified in INCODE,
C  to ASCII code, right-justified in function value.
C
C  The codes are as would be returned by the FORTRAN 77 ICHAR function.
C
C  This routine simply copies in to out on ASCII computers.
C
      INTEGER  INCODE
C
      GKASCI = INCODE
C
      RETURN
C
      END

C
C       $Id: stsetr.f,v 1.11 2008-07-27 00:17:28 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
C
C-----------------------------------------------------------------------
C
      SUBROUTINE STSETR (CNM,RVL)
C
      CHARACTER*(*) CNM
C
C This subroutine is called to set the real value of a specified
C parameter.
C
C CNM is the name of the parameter whose value is to be set.
C
C RVL is a real variable containing the new value of the parameter.
C
C ---------------------------------------------------------------------
C
C NOTE:
C Since implicit typing is used for all real and integer variables
C a consistent length convention has been adopted to help clarify the
C significance of the variables encountered in the code for this 
C utility. All local variable and subroutine parameter identifiers 
C are limited to 1,2,or 3 characters. Four character names identify  
C members of common blocks. Five and 6 character variable names 
C denote PARAMETER constants or subroutine or function names.
C
C Declare the ST common blocks.
C
      PARAMETER (IPLVLS = 256)
C
C Integer and real common block variables
C
C
      COMMON / STPAR /
     +                IUD1       ,IVD1       ,IPD1       ,
     +                IXD1       ,IXDM       ,IYD1       ,IYDN       ,
     +                IXM1       ,IYM1       ,IXM2       ,IYM2       ,
     +                IWKD       ,IWKU       ,ISET       ,IERR       ,
     +                IXIN       ,IYIN       ,IMSK       ,ICPM       ,
     +                NLVL       ,IPAI       ,ICTV       ,WDLV       ,
     +                UVMN       ,UVMX       ,PMIN       ,PMAX       ,
     +                IPLR       ,ISST       ,
     +                ICLR(IPLVLS)           ,TVLU(IPLVLS)
C
      COMMON / STTRAN /
     +                UVPS       ,
     +                UVPL       ,UVPR       ,UVPB       ,UVPT       ,
     +                UWDL       ,UWDR       ,UWDB       ,UWDT       ,
     +                UXC1       ,UXCM       ,UYC1       ,UYCN 
C
C Stream algorithm parameters
C
      COMMON / STSTRM /
     +                ISGD       ,IAGD       ,RARL       ,ICKP       ,
     +                ICKX       ,ITRP       ,ICYK       ,RVNL       ,
     +                ISVF       ,RUSV       ,RVSV       ,RNDA       ,
     +                ISPC       ,RPSV       ,RCDS       ,RSSP       ,
     +                RDFM       ,RSMD       ,RAMD       ,IGBS       ,
     +                ISTM       ,RVRL       ,RVFR       ,RVRM       ,
     +                IVPO       ,RAFR       ,RDMX       ,RDMN
C
C Text related parameters
C Note: graphical text output is not yet implemented for the
C       Streamline utility.
C
      COMMON / STTXP /
     +                FCWM    ,ICSZ    ,
     +                FMNS    ,FMNX    ,FMNY    ,IMNP    ,IMNC  ,
     +                FMXS    ,FMXX    ,FMXY    ,IMXP    ,IMXC  ,
     +                FZFS    ,FZFX    ,FZFY    ,IZFP    ,IZFC  ,
     +                FILS    ,FILX    ,FILY    ,IILP    ,IILC 
C
C Character variable declartions
C
      CHARACTER*160 CSTR
      PARAMETER (IPCHSZ=80)
      CHARACTER*(IPCHSZ)  CMNT,CMXT,CZFT,CILT
C
C Text string parameters
C
      COMMON / STCHAR / CSTR,CMNT,CMXT,CZFT,CILT
C
      SAVE /STPAR/, /STTRAN/, /STSTRM/, /STTXP/, /STCHAR/
C
C Internal buffer lengths
C
C IPNPTS - Number of points in the point buffer -- not less than 3
C IPLSTL - Streamline-crossover-check circular list length
C IPGRCT - Number of groups supported for area masking
C
      PARAMETER (IPNPTS = 256, IPLSTL = 750, IPGRCT = 64)
C
C --------------------------------------------------------------------
C
C The mapping common block: made available to user mapping routines
C
      COMMON /STMAP/
     +                IMAP       ,LNLG       ,INVX       ,INVY       ,
     +                XLOV       ,XHIV       ,YLOV       ,YHIV       ,
     +                WXMN       ,WXMX       ,WYMN       ,WYMX       ,
     +                XVPL       ,XVPR       ,YVPB       ,YVPT       ,
     +                XGDS       ,YGDS       ,NXCT       ,NYCT       ,
     +                ITRT       ,FW2W       ,FH2H       ,
     +                DFMG       ,VNML       ,RBIG       ,IBIG
C
      SAVE /STMAP/
C
C Math constants
C
      PARAMETER (PDTOR  = 0.017453292519943,
     +           PRTOD  = 57.2957795130823,
     +           P1XPI  = 3.14159265358979,
     +           P2XPI  = 6.28318530717959,
     +           P1D2PI = 1.57079632679489,
     +           P5D2PI = 7.85398163397448) 
C
C ---------------------------------------------------------------------
C
C Check for a parameter name that is too short.
C
      IF (LEN(CNM).LT.3) THEN
        CSTR(1:46)='STSETI OR STSETR - PARAMETER NAME TOO SHORT - '
        CSTR(47:46+LEN(CNM))=CNM
        CALL SETER (CSTR(1:46+LEN(CNM)),1,1)
        RETURN
      END IF
C
C Check for incorrect use of the index parameter.
C
      IF (CNM(1:3).EQ.'CLR'.OR.CNM(1:3).EQ.'clr'
     +    .OR.CNM(1:3).EQ.'TVL'.OR.CNM(1:3).EQ.'tvl') THEN
         IF (IPAI.LT.1.OR.IPAI.GT.IPLVLS) THEN
            CSTR(1:46)='STSETI OR STSETR - SETTING XXX - PAI INCORRECT'
            CSTR(28:30)=CNM(1:3)
            CALL SETER (CSTR(1:46),2,1)
            RETURN
         END IF
      END IF
C
C Set the appropriate parameter value.
C
C ---------------------------------------------------------------------
C
C Values in STPAR
C
      IF (CNM(1:3).EQ.'UD1'.OR. CNM(1:3).EQ.'ud1') THEN
         IUD1=INT(RVL)
      ELSE IF (CNM(1:3).EQ.'VD1'.OR. CNM(1:3).EQ.'vd1') THEN
         IVD1=INT(RVL)
      ELSE IF (CNM(1:3).EQ.'PD1'.OR. CNM(1:3).EQ.'pd1') THEN
         IPD1=INT(RVL)
      ELSE IF (CNM(1:3).EQ.'XD1'.OR. CNM(1:3).EQ.'xd1') THEN
         IXD1=INT(RVL)
      ELSE IF (CNM(1:3).EQ.'XDM'.OR. CNM(1:3).EQ.'xdm') THEN
         IXDM=INT(RVL)
      ELSE IF (CNM(1:3).EQ.'YD1'.OR. CNM(1:3).EQ.'yd1') THEN
         IYD1=INT(RVL)
      ELSE IF (CNM(1:3).EQ.'YDN'.OR. CNM(1:3).EQ.'ydn') THEN
         IYDN=INT(RVL)
      ELSE IF (CNM(1:3).EQ.'WKD'.OR.CNM(1:3).EQ.'wkd') THEN
         IWKD=INT(RVL)
      ELSE IF (CNM(1:3).EQ.'WKU'.OR.CNM(1:3).EQ.'wku') THEN
         IWKU=INT(RVL)
      ELSE IF (CNM(1:3).EQ.'SET'.OR. CNM(1:3).EQ.'set') THEN
         ISET=INT(RVL)
      ELSE IF (CNM(1:3).EQ.'ERR'.OR. CNM(1:3).EQ.'err') THEN
         IERR=INT(RVL)
      ELSE IF (CNM(1:3).EQ.'XIN'.OR. CNM(1:3).EQ.'xin') THEN
         IXIN=INT(RVL)
      ELSE IF (CNM(1:3).EQ.'YIN'.OR. CNM(1:3).EQ.'yin') THEN
         IYIN=INT(RVL)
      ELSE IF (CNM(1:3).EQ.'MSK'.OR. CNM(1:3).EQ.'msk') THEN
         IMSK=INT(RVL)
      ELSE IF (CNM(1:3).EQ.'CPM'.OR. CNM(1:3).EQ.'cpm') THEN
         ICPM=INT(RVL)
      ELSE IF (CNM(1:3).EQ.'NLV'.OR.CNM(1:3).EQ.'nlv') THEN
         NLVL=INT(RVL)
      ELSE IF (CNM(1:3).EQ.'PAI'.OR.CNM(1:3).EQ.'pai') THEN
         IF (RVL .LT. 1.0 .OR. RVL .GT. IPLVLS) GO TO 9800
         IPAI=INT(RVL)
      ELSE IF (CNM(1:3).EQ.'CTV'.OR.CNM(1:3).EQ.'ctv') THEN
         ICTV=INT(RVL)
      ELSE IF (CNM(1:3).EQ.'LWD'.OR.CNM(1:3).EQ.'lwd') THEN
         IF (RVL .LE. 0.0) GO TO 9800
         WDLV=RVL
C
C UVMN,UVMX, PMIN, PMAX are read-only
C
      ELSE IF (CNM(1:3).EQ.'THN'.OR. CNM(1:3).EQ.'thn') THEN
         ITHN=INT(RVL)
      ELSE IF (CNM(1:3).EQ.'PLR'.OR. CNM(1:3).EQ.'plr') THEN
         IPLR=INT(RVL)
      ELSE IF (CNM(1:3).EQ.'SST'.OR. CNM(1:3).EQ.'sst') THEN
         ISST=INT(RVL)
      ELSE IF (CNM(1:3).EQ.'CLR'.OR.CNM(1:3).EQ.'clr') THEN
         ICLR(IPAI)=INT(RVL)
      ELSE IF (CNM(1:3).EQ.'TVL'.OR.CNM(1:3).EQ.'tvl') THEN
         TVLU(IPAI)=RVL
C
C ---------------------------------------------------------------------
C
C Values in STTRAN
C
      ELSE IF (CNM(1:3).EQ.'VPS'.OR. CNM(1:3).EQ.'vps') THEN
         UVPS=RVL
      ELSE IF (CNM(1:3).EQ.'VPL'.OR.CNM(1:3).EQ.'vpl') THEN
         UVPL=MIN(1.0,MAX(0.0,RVL))
      ELSE IF (CNM(1:3).EQ.'VPR'.OR.CNM(1:3).EQ.'vpr') THEN
         UVPR=MIN(1.0,MAX(0.0,RVL))
      ELSE IF (CNM(1:3).EQ.'VPB'.OR.CNM(1:3).EQ.'vpb') THEN
         UVPB=MIN(1.0,MAX(0.0,RVL))
      ELSE IF (CNM(1:3).EQ.'VPT'.OR.CNM(1:3).EQ.'vpt') THEN
         UVPT=MIN(1.0,MAX(0.0,RVL))
      ELSE IF (CNM(1:3).EQ.'WDL'.OR.CNM(1:3).EQ.'wdl') THEN
         UWDL=RVL
      ELSE IF (CNM(1:3).EQ.'WDR'.OR.CNM(1:3).EQ.'wdr') THEN
         UWDR=RVL
      ELSE IF (CNM(1:3).EQ.'WDB'.OR.CNM(1:3).EQ.'wdb') THEN
         UWDB=RVL
      ELSE IF (CNM(1:3).EQ.'WDT'.OR.CNM(1:3).EQ.'wdt') THEN
         UWDT=RVL
      ELSE IF (CNM(1:3).EQ.'XC1'.OR.CNM(1:3).EQ.'xc1') THEN
         UXC1=RVL
      ELSE IF (CNM(1:3).EQ.'XCM'.OR.CNM(1:3).EQ.'xcm') THEN
         UXCM=RVL
      ELSE IF (CNM(1:3).EQ.'YC1'.OR.CNM(1:3).EQ.'yc1') THEN
         UYC1=RVL
      ELSE IF (CNM(1:3).EQ.'YCN'.OR.CNM(1:3).EQ.'ycn') THEN
         UYCN=RVL
C
C ---------------------------------------------------------------------
C
C Values in STSTRM
C
      ELSE IF (CNM(1:3).EQ.'SGD'.OR. CNM(1:3).EQ.'sgd') THEN
         ISGD=INT(RVL)
      ELSE IF (CNM(1:3).EQ.'AGD'.OR. CNM(1:3).EQ.'agd') THEN
         IAGD=INT(RVL)
      ELSE IF (CNM(1:3).EQ.'ARL'.OR. CNM(1:3).EQ.'arl') THEN
         RARL=RVL
      ELSE IF (CNM(1:3).EQ.'CKP'.OR. CNM(1:3).EQ.'ckp') THEN
         ICKP=INT(RVL)
      ELSE IF (CNM(1:3).EQ.'CKX'.OR. CNM(1:3).EQ.'ckx') THEN
         ICKX=INT(RVL)
      ELSE IF (CNM(1:3).EQ.'TRP'.OR. CNM(1:3).EQ.'trp') THEN
         ITRP=INT(RVL)
      ELSE IF (CNM(1:3).EQ.'CYK'.OR. CNM(1:3).EQ.'cyk') THEN
         ICYK=INT(RVL)
      ELSE IF (CNM(1:3).EQ.'VNL'.OR. CNM(1:3).EQ.'vnl') THEN
         RVNL=RVL
      ELSE IF (CNM(1:3).EQ.'SVF'.OR. CNM(1:3).EQ.'svf') THEN
         ISVF=INT(RVL)
      ELSE IF (CNM(1:3).EQ.'USV'.OR. CNM(1:3).EQ.'usv') THEN
         RUSV=RVL
      ELSE IF (CNM(1:3).EQ.'VSV'.OR. CNM(1:3).EQ.'vsv') THEN
         RVSV=RVL
      ELSE IF (CNM(1:3).EQ.'PSV'.OR. CNM(1:3).EQ.'psv') THEN
         RPSV=RVL
      ELSE IF (CNM(1:3).EQ.'SPC'.OR. CNM(1:3).EQ.'spc') THEN
         ISPC=INT(RVL)
      ELSE IF (CNM(1:3).EQ.'CDS'.OR. CNM(1:3).EQ.'cds') THEN
         RCDS=RVL
      ELSE IF (CNM(1:3).EQ.'SSP'.OR. CNM(1:3).EQ.'ssp') THEN
         RSSP=RVL
      ELSE IF (CNM(1:3).EQ.'DFM'.OR. CNM(1:3).EQ.'dfm') THEN
         RDFM=RVL
      ELSE IF (CNM(1:3).EQ.'SMD'.OR. CNM(1:3).EQ.'smd') THEN
         RSMD=RVL
      ELSE IF (CNM(1:3).EQ.'AMD'.OR. CNM(1:3).EQ.'amd') THEN
         RAMD=RVL
      ELSE IF (CNM(1:3).EQ.'GBS'.OR. CNM(1:3).EQ.'gbs') THEN
         IGBS=INT(RVL)
C
C This parameter is special in that it causes RSSP,RDFM, and RARL
C to be reset.
C
        IF (IGBS .EQ. 0) THEN
           RARL = 0.012
           RDFM = 0.02
           RSSP = 0.015
        ELSE
           RARL = 0.33
           RDFM = 0.33
           RSSP = 0.5
        END IF
C
      ELSE IF (CNM(1:3).EQ.'STM'.OR. CNM(1:3).EQ.'stm') THEN
         ISTM=INT(RVL)
      ELSE IF (CNM(1:3).EQ.'VRL'.OR. CNM(1:3).EQ.'vrl') THEN
         RVRL= RVL
      ELSE IF (CNM(1:3).EQ.'VFR'.OR. CNM(1:3).EQ.'vfr') THEN
         RVFR= RVL
      ELSE IF (CNM(1:3).EQ.'VRM'.OR. CNM(1:3).EQ.'vrm') THEN
         RVRM= RVL
      ELSE IF (CNM(1:3).EQ.'VPO'.OR. CNM(1:3).EQ.'vpo') THEN
         IVPO=INT(RVL)
      ELSE IF (CNM(1:3).EQ.'AFR'.OR. CNM(1:3).EQ.'afr') THEN
         RAFR= RVL
C
C ---------------------------------------------------------------------
C
C Values in STTXP
C
C Character attributes
C
C
      ELSE IF (CNM(1:3).EQ.'ZFS'.OR.CNM(1:3).EQ.'zfs') THEN
         FZFS=RVL
      ELSE IF (CNM(1:3).EQ.'ZFX'.OR.CNM(1:3).EQ.'zfx') THEN
         FZFX=RVL
      ELSE IF (CNM(1:3).EQ.'ZFY'.OR.CNM(1:3).EQ.'zfy') THEN
         FZFY=RVL
      ELSE IF (CNM(1:3).EQ.'ZFP'.OR. CNM(1:3).EQ.'zfp') THEN
         IZFP=INT(RVL)
      ELSE IF (CNM(1:3).EQ.'ZFC'.OR. CNM(1:3).EQ.'zfc') THEN
         IZFC=INT(RVL)
C
C ---------------------------------------------------------------------
C
C Values in STMAP
C
      ELSE IF (CNM(1:3).EQ.'MAP'.OR. CNM(1:3).EQ.'map') THEN
         IMAP=INT(RVL)
      ELSE IF (CNM(1:3).EQ.'TRT'.OR. CNM(1:3).EQ.'trt') THEN
         ITRT=INT(RVL)
C
C ---------------------------------------------------------------------
C
      ELSE
        CSTR(1:46)='STSETI OR STSETR - PARAMETER NAME NOT KNOWN - '
        CSTR(47:49)=CNM(1:3)
        CALL SETER (CSTR(1:49),3,1)
        RETURN
      END IF
C
      GOTO 9900
C
 9800 CONTINUE
C
      CSTR(1:50)='STSETI OR STSETR - PARAMETER VALUE OUT OF RANGE - '
      CSTR(51:53)=CNM(1:3)
      CALL SETER (CSTR(1:53),3,1)
      RETURN
C      
 9900 CONTINUE
C
C Done.
C
      RETURN
C
      END

c -------------------------------------------------------------
      SUBROUTINE DREGCOEF(X,Y,NPTS,XMSG,YMSG,RCOEF,TVAL,NPTXY,XAVE,
     +     YAVE,RSTD,YINT,IER)
      IMPLICIT NONE

c NCL:  rcoef = regCoef (x,y)
c NCL:  rcoef = regcoef (x,y,tval,nptxy)
c NCL:  rcoef = regline (x,y,tval,nptxy,xave,yave)

c this routine will calculate the regression coef (trend, slope,..),
c .   x and y averages, the t-statistic and the number of pts used
c .   missing data are allowed.

c .   see: brownlee
c .        statistical theory and methodology
c .        j wiley 1965   pgs: 281-284     QA276  .B77

c arguments :
c .   x,y      - input vectors
c .   npts     - length of vectors x and y
c .   xmsg,ymsg- missing code: if no msg values set to some number
c .                            which will not be encountered.
c .              dmsg will be used to fill missing values
c .   rcoef    - slope (trend ... regression coef)
c .   tval     - t-statistic (null hypothesis: H0: r=0.0)
c .   nptxy    - number of points used
c .   rstd     - standard deviation of the regression coefficient
c .   xave     - average of x
c .   yave     - average of y
c .   yint     - y-intercept
c .   ier      - if (ier.ne.0) an error has occurred

C input
      INTEGER NPTS,NPTXY
C input
      DOUBLE PRECISION X(1:NPTS),Y(1:NPTS),XMSG,YMSG
C output
      INTEGER IER
C output
      DOUBLE PRECISION RCOEF,TVAL,YAVE,XAVE,RSTD,YINT

C local
      LOGICAL REGDBG
      INTEGER N
      DOUBLE PRECISION RNULL,XYN,DF
      DOUBLE PRECISION XSUM,YSUM,X2SUM,Y2SUM,XYSUM,XVAR,YVAR,XYVAR,
     +                 SSQREG,SSQ,VB,SQRTVB

      IER = 0
      TVAL  = YMSG
      RCOEF = YMSG
      RSTD  = YMSG
      IF (NPTS.LT.2) IER = 1
      IF (IER.NE.0) RETURN

C null hypothesis
      RNULL = 0.0D0

      XYN = 0.0D0
      XSUM = 0.d0
      YSUM = 0.d0
      X2SUM = 0.d0
      Y2SUM = 0.d0
      XYSUM = 0.d0
      DO N = 1,NPTS
          IF (X(N).NE.XMSG .AND. Y(N).NE.YMSG) THEN
              XSUM = XSUM + DBLE(X(N))
              YSUM = YSUM + DBLE(Y(N))
              X2SUM = X2SUM + X(N)*X(N)
              Y2SUM = Y2SUM + Y(N)*Y(N)
              XYSUM = XYSUM + X(N)*Y(N)
              XYN = XYN + 1.D0
          END IF
      END DO

      NPTXY = XYN

      IF (XYN.LT.1.D0) THEN
C all msg values
          IER = 5
          RETURN
      ELSE IF (XYN.LT.3.D0) THEN
C not enough data
          IER = 6
          RETURN
      END IF

      XAVE = XSUM/XYN
      YAVE = YSUM/XYN

      XVAR = X2SUM - XSUM*XSUM/DBLE(XYN)
      YVAR = Y2SUM - YSUM*YSUM/DBLE(XYN)
      XYVAR = XYSUM - XSUM*YSUM/DBLE(XYN)

      IF (XVAR.GT.0.D0) then
C regression coef (b in book)
          RCOEF = XYVAR/XVAR
C sum of squares due to regression
          SSQREG = XYVAR* (XYVAR/XVAR)
          SSQ = (YVAR-SSQREG)/DBLE(XYN-2.D0)
C v[b] in book {variance of B}
          VB = SSQ/XVAR
          SQRTVB = DSQRT(VB)
C t-statistic and standard deviation of reg coef
          IF (SQRTVB.GT.0.D0) then
              TVAL = (RCOEF-RNULL)/SQRTVB
              RSTD = SQRTVB
          ELSE
              TVAL = YMSG
          END IF
C degrees of freedom
          DF = XYN - 2.D0
C y-intercept
          YINT = YAVE - RCOEF*XAVE
      ELSE
c XVAR = 0.0
          IER    = 7
          SSQREG = YMSG
          SSQ    = YMSG
          VB     = YMSG
          SQRTVB = YMSG
          TVAL   = YMSG
          RCOEF  = YMSG
          YINT   = YMSG
      END IF

      REGDBG = .false.
      IF (REGDBG) THEN
          WRITE (*,FMT='(///,'' trtest: debug'')')
          WRITE (*,FMT='('' xsum  ='',f12.5)') XSUM
          WRITE (*,FMT='('' ysum  ='',f12.5)') YSUM
          WRITE (*,FMT='('' x2sum ='',f12.5)') X2SUM
          WRITE (*,FMT='('' y2sum ='',f12.5)') Y2SUM
          WRITE (*,FMT='('' xysum ='',f12.5)') XYSUM
          WRITE (*,FMT='('' xvar  ='',f12.5)') XVAR
          WRITE (*,FMT='('' yvar  ='',f12.9)') YVAR
          WRITE (*,FMT='('' xyvar ='',f12.9)') XYVAR
          WRITE (*,FMT='('' ssqreg='',f12.9)') SSQREG
          WRITE (*,FMT='('' ssq   ='',f12.9)') SSQ
          WRITE (*,FMT='('' rcoef ='',f12.9)') RCOEF
          WRITE (*,FMT='('' rnull ='',f12.9)') RNULL
          WRITE (*,FMT='('' vb    ='',f15.9)') VB
          WRITE (*,FMT='('' rstd(=sqrtvb)='',f15.9)') RSTD   
          WRITE (*,FMT='('' tval  ='',f15.9)') TVAL
          WRITE (*,FMT='('' yint  ='',f15.9)') YINT
      END IF

      RETURN
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C                            Copyright (C)  1995                       C
C                 University Corporation for Atmospheric Research      C
C                            All Rights Reserved                       C
C                                                                      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C      File:            tx04f.f
C
C      Author:          Jeff Boote (converted by Ed Stautler)
C                       National Center for Atmospheric Research
C                       PO 3000, Boulder, Colorado
C
C      Date:            Tue Jan 24 10:28:20 MST 1995
C
C      Description:     Demonstrates TextItem object.
C
      external NhlFAppClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFCairoWindowWorkstationClass
      external NhlFMapPlotClass
      external NhlFTextItemClass
      
      integer i,appid,text_item_id,wid,rlist,ierr
      character*7  wks_type
C
C Default output is to an X workstation.
C
      wks_type = "x11"
C     
C  Initialize the high level utility library.
C     
      call NhlFInitialize
C   
C Create an application context.  Set the app dir to the current
C directory so the application looks for the resource file in the
C execution directory.
C   
      call NhlFRLCreate(rlist,'setrl')
      call NhlFRLClear(rlist)
      call NhlFRLSetstring(rlist,'appUsrDir','./',ierr)
      call NhlFRLSetstring(rlist,'appDefaultParent','True',ierr)
      call NhlFCreate(appid, 'tx04',NhlFAppClass,0,rlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkMetaName','./tx04f.ncgm',ierr)
         call NhlFCreate(wid,'tx04Work',NhlFNcgmWorkstationClass,0,
     1        rlist,ierr)
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X Workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetinteger(rlist,'wkPause',1,ierr)
         call NhlFCreate(wid,'tx04Work',
     1        NhlFCairoWindowWorkstationClass,0,
     1        rlist,ierr)
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PostScript workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPSFileName','./tx04f.ps',ierr)
         call NhlFCreate(wid,'tx04Work',NhlFPSWorkstationClass,0,
     1        rlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPDFFileName','./tx04f.pdf',ierr)
         call NhlFCreate(wid,'tx04Work',NhlFPDFWorkstationClass,0,
     1        rlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF object.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetstring(rlist,'wkFileName','./tx04f',ierr)
         call NhlFCreate(wid,'tx04Work',
     1        NhlFCairoPSPDFWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG object.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetstring(rlist,'wkFileName','./tx04f',ierr)
         call NhlFCreate(wid,'tx04Work',
     1        NhlFCairoImageWorkstationClass,0,rlist,ierr)
      endif
C  
C This is the only creation of a text object for this entire program.
C  
      call NhlFRLClear(rlist)
      call NhlFRLSetinteger(rlist,'txJust',4,ierr)
      call NhlFRLSetinteger(rlist,'txFont',25,ierr)
      call NhlFRLSetfloat(rlist,'txFontHeightF',.03,ierr)
      call NhlFRLSetstring(rlist,'txString',
     1     'TextItem - VARIOUS CAPABILITIES',ierr)
      call NhlFRLSetfloat(rlist,'txPosXF',.5,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.95,ierr)
      call NhlFCreate(text_item_id,'Nhl05TextItem',
     1     NhlFTextItemClass,wid,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      call NhlFRLSetfloat(rlist,'txFontHeightF',.015,ierr)
      call NhlFRLSetfloat(rlist,'txPosXF',.7,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.86,ierr)
      call NhlFRLSetstring(rlist,'txString',
     1     'HIGH-QUALITY CHARACTERS USED BELOW',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      call NhlFRLSetfloat(rlist,'txPosXF',.7,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.5,ierr)  
      call NhlFRLSetstring(rlist,'txString',
     1     'MEDIUM-QUALITY CHARACTERS USED BELOW',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      call NhlFRLSetfloat(rlist,'txPosXF',.58,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.81,ierr)   
      call NhlFRLSetstring(rlist,'txString','txString',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      call NhlFRLSetfloat(rlist,'txPosYF',.46,ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      call NhlFRLSetfloat(rlist,'txPosXF',.82,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.81,ierr)        
      call NhlFRLSetstring(rlist,'txString','RESULT',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      call NhlFRLSetfloat(rlist,'txPosYF',.46,ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      call NhlFRLSetfloat(rlist,'txPosXF',.82,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.78,ierr)
      call NhlFRLSetstring(rlist,'txString','------',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      call NhlFRLSetfloat(rlist,'txPosYF',.43,ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      call NhlFRLSetfloat(rlist,'txPosXF',.58,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.78,ierr)
      call NhlFRLSetstring(rlist,'txString','------------',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      call NhlFRLSetfloat(rlist,'txPosYF',.43,ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
C  
C  Below are examples using the function control characters. In each
C  iteration of the loop a new string is set using call NhlFSetValues.
C  In order to demonstrate what the value of 'txString' is, the
C  function code is temporarily changed causing the entire contents of
C  'txString' to be drawn.
C
      do 10 i=0,11
         if (i .eq. 0) then
            call NhlFRLClear(rlist)
            call NhlFRLSetstring(rlist,'txString','~L~A',ierr)
            call NhlFSetValues(text_item_id,rlist,ierr)
         else if (i .eq. 1) then
            call NhlFRLClear(rlist)
            call NhlFRLSetstring(rlist,'txString','~IGL~A',ierr)
            call NhlFSetValues(text_item_id,rlist,ierr)
         else if (i .eq. 2) then
            call NhlFRLClear(rlist)
            call NhlFRLSetstring(rlist,'txString',
     1           'A~S~2~N~+B~S~2~N~',ierr)
            call NhlFSetValues(text_item_id,rlist,ierr)
         else if (i .eq. 3) then
            call NhlFRLClear(rlist)
            call NhlFRLSetstring(rlist,'txString','A~S~B',ierr)
            call NhlFSetValues(text_item_id,rlist,ierr)
         else if (i .eq. 4) then
            call NhlFRLClear(rlist)
            call NhlFRLSetstring(rlist,'txString','A~SPU~B',ierr)
            call NhlFSetValues(text_item_id,rlist,ierr)
         else if (i .eq. 5) then
            call NhlFRLClear(rlist)
            call NhlFRLSetstring(rlist,'txString','~GIU~+',ierr)
            call NhlFSetValues(text_item_id,rlist,ierr)
         else if (i .eq. 6) then
            call NhlFRLClear(rlist)
            call NhlFRLSetstring(rlist,'txString','~1045~',ierr)
            call NhlFSetValues(text_item_id,rlist,ierr)
         else if (i .eq. 7) then
            call NhlFRLClear(rlist)
            call NhlFRLSetstring(rlist,'txString','10~S~10~S~100',ierr)
            call NhlFSetValues(text_item_id,rlist,ierr)
         else if (i .eq. 8) then
            call NhlFRLClear(rlist)
            call NhlFRLSetstring(rlist,'txString',
     1           'X~B1~2~S1~3',ierr)
            call NhlFSetValues(text_item_id,rlist,ierr)
         else if (i .eq. 9) then
            call NhlFRLClear(rlist)
            call NhlFRLSetstring(rlist,'txString',
     1           'X~B1~2~S~3~N~Y~S~2',ierr)
            call NhlFSetValues(text_item_id,rlist,ierr)
         else if (i .eq. 10) then
            call NhlFRLClear(rlist)
            call NhlFRLSetstring(rlist,'txString',
     1           'X~S~A~B~1~NN~ABC',ierr)
            call NhlFSetValues(text_item_id,rlist,ierr)
         else if (i .eq. 11) then
            call NhlFRLClear(rlist)
            call NhlFRLSetstring(rlist,'txString',
     1           '1.3648~L1~410~S~-13',ierr)
            call NhlFSetValues(text_item_id,rlist,ierr)
         end if
C  
C  Change function code so full string will be drawn.
C  
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'txFuncCode','$',ierr)
         call NhlFRLSetfloat(rlist,'txFontHeightF',.01,ierr)
         call NhlFRLSetfloat(rlist,'txPosXF',.58,ierr)
         call NhlFRLSetfloat(rlist,'txPosYF',.78-(i+1)*.02,ierr)
         call NhlFSetValues(text_item_id,rlist,ierr)
         
         call NhlFDraw(text_item_id,ierr)
C  
C  Change function code back so result string will be drawn.
C  
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'txFuncCode','~',ierr)
         call NhlFRLSetfloat(rlist,'txPosXF',.82,ierr)
         call NhlFSetValues(text_item_id,rlist,ierr)
         
         call NhlFDraw(text_item_id,ierr)
C  
C Change to medium font quality and set function code so full string
C will be drawn.
C  
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'txFontQuality','MEDIUM',ierr)
         call NhlFRLSetstring(rlist,'txFuncCode','$',ierr)
         call NhlFRLSetfloat(rlist,'txPosXF',.58,ierr)
         call NhlFRLSetfloat(rlist,'txPosYF',.42-(i+1)*.02,ierr)
         call NhlFSetValues(text_item_id,rlist,ierr)
         
         call NhlFDraw(text_item_id,ierr)
C  
C  Change function code back to get result string to draw.
C  
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'txFuncCode','~',ierr)
         call NhlFRLSetfloat(rlist,'txPosXF',.82,ierr)
         call NhlFSetValues(text_item_id,rlist,ierr)
         
         call NhlFDraw(text_item_id,ierr)
         
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'txFontQuality','HIGH',ierr)
         call NhlFSetValues(text_item_id,rlist,ierr)
 10   continue
C  
C  Examples of setting font height.
C  
      call NhlFRLClear(rlist)
      call NhlFRLSetfloat(rlist,'txPosXF',.25,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.86,ierr)
      call NhlFRLSetfloat(rlist,'txFontHeightF',.01,ierr)
      call NhlFRLSetstring(rlist,'txString','txFontHeightF = .01',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      call NhlFRLSetfloat(rlist,'txPosXF',.25,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.84,ierr)
      call NhlFRLSetfloat(rlist,'txFontHeightF',.015,ierr)
      call NhlFRLSetstring(rlist,'txString','txFontHeightF = .015',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      call NhlFRLSetfloat(rlist,'txPosXF',.25,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.80,ierr)
      call NhlFRLSetfloat(rlist,'txFontHeightF',.02,ierr)
      call NhlFRLSetstring(rlist,'txString','txFontHeightF = .02',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      call NhlFRLSetfloat(rlist,'txPosXF',.25,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.75,ierr)
      call NhlFRLSetfloat(rlist,'txFontHeightF',.025,ierr)
      call NhlFRLSetstring(rlist,'txString','txFontHeightF = .025',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
C  
C  Examples setting the rotation angle of the text.
C  
      call NhlFRLClear(rlist)
      call NhlFRLSetfloat(rlist,'txPosXF',.26,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.47,ierr)
      call NhlFRLSetfloat(rlist,'txFontHeightF',.015,ierr)
      call NhlFRLSetinteger(rlist,'txJust',1,ierr)
      call NhlFRLSetstring(rlist,'txString','txAngleF = 0.0',ierr)
      call NhlFRLSetfloat(rlist,'txAngleF',0.0,ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      call NhlFRLSetfloat(rlist,'txPosXF',.26,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.5,ierr)
      call NhlFRLSetstring(rlist,'txString','txAngleF = 45.0',ierr)
      call NhlFRLSetfloat(rlist,'txAngleF',45.0,ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      call NhlFRLSetfloat(rlist,'txPosXF',.23,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.50,ierr)
      call NhlFRLSetstring(rlist,'txString','txAngleF = 90.0',ierr)
      call NhlFRLSetfloat(rlist,'txAngleF',90.0,ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      
      call NhlFRLSetfloat(rlist,'txPosXF',.20,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.5,ierr)
      call NhlFRLSetstring(rlist,'txString','txAngleF = 135.0',ierr)
      call NhlFRLSetfloat(rlist,'txAngleF',135.0,ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      
      call NhlFRLSetfloat(rlist,'txPosXF',.20,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.47,ierr)
      call NhlFRLSetstring(rlist,'txString','txAngleF = 180.0',ierr)
      call NhlFRLSetfloat(rlist,'txAngleF',180.0,ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      
      call NhlFRLSetfloat(rlist,'txPosXF',.20,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.44,ierr)
      call NhlFRLSetstring(rlist,'txString','txAngleF = 225.0',ierr)
      call NhlFRLSetfloat(rlist,'txAngleF',225.0,ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      
      call NhlFRLSetfloat(rlist,'txPosXF',.23,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.44,ierr)
      call NhlFRLSetstring(rlist,'txString','txAngleF = 270.0',ierr)
      call NhlFRLSetfloat(rlist,'txAngleF',270.0,ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      
      call NhlFRLSetfloat(rlist,'txPosXF',.26,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.44,ierr)
      call NhlFRLSetstring(rlist,'txString','txAngleF = 315.0',ierr)
      call NhlFRLSetfloat(rlist,'txAngleF',315.0,ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      
      call NhlFRLSetfloat(rlist,'txAngleF',0.0,ierr)
      call NhlFRLSetfloat(rlist,'txPosXF',.25,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.15,ierr)
      call NhlFRLSetinteger(rlist,'txJust', 4,ierr)
      call NhlFRLSetstring(rlist,'txString','NhlNtxJust = 4',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      
      call NhlFRLSetfloat(rlist,'txAngleF',0.0,ierr)
      call NhlFRLSetfloat(rlist,'txPosXF',.25,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.18,ierr)
      call NhlFRLSetinteger(rlist,'txJust', 1,ierr)
      call NhlFRLSetstring(rlist,'txString','NhltxJust = 1',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      
      call NhlFRLSetfloat(rlist,'txAngleF',0.0,ierr)
      call NhlFRLSetfloat(rlist,'txPosXF',.25,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.12,ierr)
      call NhlFRLSetinteger(rlist,'txJust', 7,ierr)
      call NhlFRLSetstring(rlist,'txString','NhlNtxJust = 7',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
C  
C  End of first frame.
C  
      call NhlFFrame(wid,ierr)
C  
C  Remainder of calls demonstrate the various fonts available for use
C  with the text item. Note that the 'txString' values demonstrate a
C  mid-string font change
C  
      i = 0
      
      call NhlFRLClear(rlist)
      call NhlFRLSetstring(rlist,'txFuncCode','$',ierr)
      call NhlFRLSetinteger(rlist,'txFont', 0,ierr)
      call NhlFRLSetinteger(rlist,'txJust', 4,ierr)
      call NhlFRLSetfloat(rlist,'txFontHeightF',.02,ierr)
      call NhlFRLSetfloat(rlist,'txPosXF',.5,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.95-i*.027,ierr)
      i = i + 1
      call NhlFRLSetstring(rlist,'txString',
     1     'pwritx database : $F21$txFont = 0',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      
      call NhlFRLSetinteger(rlist,'txFont', 1,ierr)
      call NhlFRLSetfloat(rlist,'txPosXF',.5,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.95-i*.027,ierr)
      i = i + 1
      call NhlFRLSetstring(rlist,'txString',
     1     'default : $F21$txFont = 1',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      
      call NhlFRLSetinteger(rlist,'txFont', 2,ierr)
      call NhlFRLSetfloat(rlist,'txPosXF',.5,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.95 - i * .027,ierr)
      i = i + 1
      call NhlFRLSetstring(rlist,'txString',
     1     'cartographic roman : $F21$txFont = 2',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
      call NhlFRLClear(rlist)
      
      call NhlFRLSetinteger(rlist,'txFont', 3,ierr)
      call NhlFRLSetfloat(rlist,'txPosXF',.5,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.95 - i * .027,ierr)
      i = i + 1
      call NhlFRLSetstring(rlist,'txString',
     1     'cartographic greek : $F21$txFont = 3',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      
      call NhlFRLSetinteger(rlist,'txFont', 4,ierr)
      call NhlFRLSetfloat(rlist,'txPosXF',.5,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.95 - i * .027,ierr)
      i = i + 1
      call NhlFRLSetstring(rlist,'txString',
     1     'simplex roman: $F21$txFont = 4',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      
      call NhlFRLSetinteger(rlist,'txFont', 5,ierr)
      call NhlFRLSetfloat(rlist,'txPosXF',.5,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.95 - i * .027,ierr)
      i = i + 1
      call NhlFRLSetstring(rlist,'txString',
     1     'simplex greek: $F21$txFont = 5',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      
      call NhlFRLSetinteger(rlist,'txFont', 6,ierr)
      call NhlFRLSetfloat(rlist,'txPosXF',.5,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.95 - i * .027,ierr)
      i = i + 1
      call NhlFRLSetstring(rlist,'txString',
     1     'simplex script: $F21$txFont = 6',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      
      call NhlFRLSetinteger(rlist,'txFont', 7,ierr)
      call NhlFRLSetfloat(rlist,'txPosXF',.5,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.95 - i * .027,ierr)
      i = i + 1
      call NhlFRLSetstring(rlist,'txString',
     1     'complex roman: $F21$txFont = 7',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      
      call NhlFRLSetinteger(rlist,'txFont', 8,ierr)
      call NhlFRLSetfloat(rlist,'txPosXF',.5,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.95 - i * .027,ierr)
      i = i + 1
      call NhlFRLSetstring(rlist,'txString',
     1     'complex greek: $F21$txFont = 8',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      
      call NhlFRLSetinteger(rlist,'txFont', 9,ierr)
      call NhlFRLSetfloat(rlist,'txPosXF',.5,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.95 - i * .027,ierr)
      i = i + 1
      call NhlFRLSetstring(rlist,'txString',
     1     'complex script: $F21$txFont = 9',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      
      call NhlFRLSetinteger(rlist,'txFont', 10,ierr)
      call NhlFRLSetfloat(rlist,'txPosXF',.5,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.95 - i * .027,ierr)
      i = i + 1
      call NhlFRLSetstring(rlist,'txString',
     1     'complex script: $F21$txFont = 10',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      
      call NhlFRLSetinteger(rlist,'txFont', 11,ierr)
      call NhlFRLSetfloat(rlist,'txPosXF',.5,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.95 - i * .027,ierr)
      i = i + 1
      call NhlFRLSetstring(rlist,'txString',
     1     'complex cyrillic: $F21$txFont = 11',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      
      call NhlFRLSetinteger(rlist,'txFont', 12,ierr)
      call NhlFRLSetfloat(rlist,'txPosXF',.5,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.95 - i * .027,ierr)
      i = i + 1
      call NhlFRLSetstring(rlist,'txString',
     1     'duplex roman: $F21$txFont = 12',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      
      call NhlFRLSetinteger(rlist,'txFont', 13,ierr)
      call NhlFRLSetfloat(rlist,'txPosXF',.5,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.95 - i * .027,ierr)
      i = i + 1
      call NhlFRLSetstring(rlist,'txString',
     1     'triplex roman: $F21$txFont = 13',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      
      call NhlFRLSetinteger(rlist,'txFont', 14,ierr)
      call NhlFRLSetfloat(rlist,'txPosXF',.5,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.95 - i * .027,ierr)
      i = i + 1
      call NhlFRLSetstring(rlist,'txString',
     1     'triplex italic: $F21$txFont = 14',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      
      call NhlFRLSetinteger(rlist,'txFont', 15,ierr)
      call NhlFRLSetfloat(rlist,'txPosXF',.5,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.95 - i * .027,ierr)
      i = i + 1
      call NhlFRLSetstring(rlist,'txString',
     1     'gothic german: $F21$txFont = 15',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      
      call NhlFRLSetinteger(rlist,'txFont', 16,ierr)
      call NhlFRLSetfloat(rlist,'txPosXF',.5,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.95 - i * .027,ierr)
      i = i + 1
      call NhlFRLSetstring(rlist,'txString',
     1     'gothic english: $F21$txFont = 16',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      
      call NhlFRLSetinteger(rlist,'txFont', 17,ierr)
      call NhlFRLSetfloat(rlist,'txPosXF',.5,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.95 - i * .027,ierr)
      i = i + 1
      call NhlFRLSetstring(rlist,'txString',
     1     'gothic italian: $F21$txFont = 17',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      
      call NhlFRLSetinteger(rlist,'txFont', 18,ierr)
      call NhlFRLSetfloat(rlist,'txPosXF',.5,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.95 - i * .027,ierr)
      i = i + 1
      call NhlFRLSetstring(rlist,'txString',
     1     'math symbols: $F21$txFont = 18',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      
      call NhlFRLSetinteger(rlist,'txFont', 19,ierr)
      call NhlFRLSetfloat(rlist,'txPosXF',.5,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.95 - i * .027,ierr)
      i = i + 1
      call NhlFRLSetstring(rlist,'txString',
     1     'symbols set1: $F21$txFont = 19',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      
      call NhlFRLSetinteger(rlist,'txFont', 20,ierr)
      call NhlFRLSetfloat(rlist,'txPosXF',.5,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.95 - i * .027,ierr)
      i = i + 1
      call NhlFRLSetstring(rlist,'txString',
     1     'symbols set2: $F21$txFont = 20',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      
      call NhlFRLSetinteger(rlist,'txFont', 21,ierr)
      call NhlFRLSetfloat(rlist,'txPosXF',.5,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.95 - i * .027,ierr)
      i = i + 1
      call NhlFRLSetstring(rlist,'txString',
     1     'helvetica: $F21$txFont = 21',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      
      call NhlFRLSetinteger(rlist,'txFont', 22,ierr)
      call NhlFRLSetfloat(rlist,'txPosXF',.5,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.95 - i * .027,ierr)
      i = i + 1
      call NhlFRLSetstring(rlist,'txString',
     1     'helvetica bold: $F21$txFont = 22',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      
      call NhlFRLSetinteger(rlist,'txFont', 25,ierr)
      call NhlFRLSetfloat(rlist,'txPosXF',.5,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.95 - i * .027,ierr)
      i = i + 1
      call NhlFRLSetstring(rlist,'txString',
     1     'times-roman : $F21$txFont = 25',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      
      call NhlFRLSetinteger(rlist,'txFont', 26,ierr)
      call NhlFRLSetfloat(rlist,'txPosXF',.5,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.95 - i * .027,ierr)
      i = i + 1
      call NhlFRLSetstring(rlist,'txString',
     1     'times-roman bold : $F21$txFont = 26',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      
      call NhlFRLSetinteger(rlist,'txFont', 29,ierr)
      call NhlFRLSetfloat(rlist,'txPosXF',.5,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.95 - i * .027,ierr)
      i = i + 1
      call NhlFRLSetstring(rlist,'txString',
     1     'courier : $F21$txFont = 29',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      
      call NhlFRLSetinteger(rlist,'txFont', 30,ierr)
      call NhlFRLSetfloat(rlist,'txPosXF',.5,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.95 - i * .027,ierr)
      i = i + 1
      call NhlFRLSetstring(rlist,'txString',
     1     'courier bold : $F21$txFont = 30',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      
      call NhlFRLSetinteger(rlist,'txFont', 33,ierr)
      call NhlFRLSetfloat(rlist,'txPosXF',.5,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.95 - i * .027,ierr)
      i = i + 1
      call NhlFRLSetstring(rlist,'txString',
     1     'greek : $F21$txFont = 33',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      
      call NhlFRLSetinteger(rlist,'txFont', 34,ierr)
      call NhlFRLSetfloat(rlist,'txPosXF',.5,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.95 - i * .027,ierr)
      i = i + 1
      call NhlFRLSetstring(rlist,'txString',
     1     'math-symbols : $F21$txFont = 34',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      
      call NhlFRLSetinteger(rlist,'txFont', 35,ierr)
      call NhlFRLSetfloat(rlist,'txPosXF',.5,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.95 - i * .027,ierr)
      i = i + 1
      call NhlFRLSetstring(rlist,
     1     'txString','text-symbols : $F21$txFont = 35',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      
      call NhlFRLSetinteger(rlist,'txFont', 36,ierr)
      call NhlFRLSetfloat(rlist,'txPosXF',.5,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.95 - i * .027,ierr)
      i = i + 1
      call NhlFRLSetstring(rlist,'txString',
     1     'weather1 : $F21$txFont = 36',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      call NhlFRLSetinteger(rlist,'txFont', 37,ierr)
      call NhlFRLSetfloat(rlist,'txPosXF',.5,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.95 - i * .027,ierr)
      i = i + 1
      call NhlFRLSetstring(rlist,'txString',
     1     'weather2 : $F21$txFont = 37',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
C  
C  End of second and final frame.
C  
      call NhlFFrame(wid,ierr)
C  
C  Clean up and close hlu library.
C  
      call NhlFDestroy(text_item_id,ierr)
      call NhlFClose
      
      end

C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      FUNCTION SPLDED(NDIM,X,NDERIV,COEF,XMIN,XMAX,NODES,IERROR)
      DOUBLE PRECISION SPLDED
      DOUBLE PRECISION X
      DOUBLE PRECISION COEF
      DOUBLE PRECISION XMIN
      DOUBLE PRECISION XMAX
      DOUBLE PRECISION DX
      DOUBLE PRECISION DXIN
      DOUBLE PRECISION XRNG
      DOUBLE PRECISION SUM
      DOUBLE PRECISION BASM
      DIMENSION X(NDIM),NDERIV(NDIM),COEF(*),XMIN(NDIM),XMAX(NDIM),
     +          NODES(NDIM)
      COMMON /SPLCOMD/DX(4),DXIN(4),MDIM,IB(4),IBMN(4),IBMX(4)
      SAVE
C
C The restriction for NDIM to be .LE. 4 can be eliminated by increasing
C the above dimensions.
C
      IERROR = 0
      MDIM = NDIM
      IF (MDIM.LT.1 .OR. MDIM.GT.4) GO TO 105
      IIBMX = 1
      DO 101 IDIM = 1,MDIM
          NOD = NODES(IDIM)
          IF (NOD.LT.4) GO TO 106
          XRNG = XMAX(IDIM) - XMIN(IDIM)
          IF (XRNG.EQ.0.D0) GO TO 107
          IF (NDERIV(IDIM).LT.0 .OR. NDERIV(IDIM).GT.2) GO TO 108
C
C  DX(IDIM) is the node spacing along the IDIM coordinate.
C
          DX(IDIM) = XRNG/DBLE(NOD-1)
          DXIN(IDIM) = 1.D0/DX(IDIM)
C
C  Compute indices of basis functions which are nonzero at X.
C
          IT = DXIN(IDIM)* (X(IDIM)-XMIN(IDIM))
C
C  IBMN must be in the range 0 to NODES-2.
C
          IBMN(IDIM) = MIN0(MAX0(IT-1,0),NOD-2)
C
C  IBMX must be in the range 1 to NODES-1.
C
          IBMX(IDIM) = MAX0(MIN0(IT+2,NOD-1),1)
          IIBMX = IIBMX* (IBMX(IDIM)-IBMN(IDIM)+1)
          IB(IDIM) = IBMN(IDIM)
  101 CONTINUE
C
      SUM = 0.D0
      IIB = 0
C
C  Begining of basis index loop - traverse all indices corresponding
C  to basis functions which are nonzero at X.
C
  102 IIB = IIB + 1
C
C  The indices are in IB and are passed through common to BASCMP.
C
      CALL BASCMPD(X,NDERIV,XMIN,NODES,ICOF,BASM)
C
C  BASCMP computes ICOF and BASM where BASM is the value at X of the
C  N-dimensional basis function corresponding to COEF(ICOF).
C
      SUM = SUM + COEF(ICOF)*BASM
      IF (IIB.GE.IIBMX) GO TO 104
C
C  Increment the basis indices.
C
      DO 103 IDIM = 1,MDIM
          IB(IDIM) = IB(IDIM) + 1
          IF (IB(IDIM).LE.IBMX(IDIM)) GO TO 102
          IB(IDIM) = IBMN(IDIM)
  103 CONTINUE
C
C  End of basis index loop.
C
  104 SPLDED = SUM
      RETURN
C
C  Errors.
C
  105 CONTINUE
      IERROR = 101
      CALL CFAERR(IERROR,
     +    ' SPLFED or SPLDED - NDIM is less than 1 or greater than 4   '
     +            ,60)
      GO TO 109
  106 CONTINUE
      IERROR = 102
      CALL CFAERR(IERROR,
     +    ' SPLFED or SPLDED - NODES(IDIM) is less than  4for some IDIM'
     +            ,60)
      GO TO 109
  107 CONTINUE
      IERROR = 103
      CALL CFAERR(IERROR,
     +    ' SPLFED or SPLDED - XMIN(IDIM) = XMAX(IDIM) for some IDIM   '
     +            ,60)
      GO TO 109
  108 CONTINUE
      IERROR = 104
      CALL CFAERR(IERROR,
     +' SPLDED - NDERIV(IDIM) IS less than 0 or greater than 2 for some 
     +IDIM  ',70)
C
  109 STOP
      END

C
C	$Id: gputni.f,v 1.5 2008-07-27 00:21:06 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GPUTNI(OPCL, OPID, NBYTES, GKSERR)
C
C  This routine sets up the next instruction to be placed in
C  the metafile.
C
C  After this call the GPUTPR or GPUTPS routines are called to load
C  the operand list.
C
C
C  INPUT
C    OPCL   -- The opcode CLASS of the element.
C    OPID   -- The opcode ID of the element.
C    NBYTES -- The number of bytes in the operand list.
C
C  OUTPUT
C    GKSERR -- An error status return.
C
C  All data is type intege unless otherwise indicated.
C
      IMPLICIT INTEGER (A-Z)
C
      include 'g01prm.h'
      include 'g01ins.h'
C
C  Set the CGM data element partition size.  The partition size 
C  should be a multiple of 256 in order to  make the arithmetic 
C  in other parts of the code come out right.
C
      DATA PARSIZ/32256/
C
C  Load the current opcode CLASS and ID into common.
C
      MCOPCL = OPCL
      MCOPID = OPID
C
C  Set the current partition byte count and the remainder byte count.
C
      IF (NBYTES .GT. PARSIZ) THEN
        MCCBYT = PARSIZ
        MCNBYT = NBYTES - PARSIZ
      ELSE
        MCCBYT = NBYTES
        MCNBYT = 0
      END IF
C
C  Ready the current partition for the operand list.
C
      CALL GINLOD(GKSERR)
C
      RETURN
      END

      PROGRAM STEX02
C
C Example STEX02 demonstrates how both the field flow utilities -
C Vectors and Streamlines - map into the non-uniform coordinate
C systems supported by the NCAR Graphics SET call. Each of the
C five frames display a uniform 45 degree field using a Streamlines
C representation overlaying a Vectors representation. The first four
C frames cycle through all possible settings of the Linear-Log (LL)
C argument to the SET call. The fifth frame shows a user coordinate
C system where the unit X is twice the size of the unit Y.
C
C The example also illustrates use of the compatibility mode parameter
C to allow use of the older interfaces (VELVCT and STRMLN), while
C still accessing post-Version 3.2 capabilities of the field flow
C utilities. Note that use of the old entry-points is discouraged
C other than on a transitional basis. Therefore the comments show the
C code required to create an identical plot using the Version 3.2 
C interfaces.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Open GKS, open workstation of type 1, activate workstation
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
      CALL GSCR(IWKID, 0, 0.0, 0.00, 0.0)
      CALL GSCR(IWKID, 1, 1.0, 1.00, 1.0)
      CALL GSCR(IWKID, 3, 0.0, 1.00, 0.0)
      CALL GSCR(IWKID, 7, 0.5, 0.15, 0.5)
C
C Invoke demo driver
C
      CALL DOST02(IERR)
C
C     Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      STOP
      END
C
      SUBROUTINE DOST02 (IERROR)
C
C
      PARAMETER (M=25,N=25)
      DIMENSION U(M,N), V(M,N)
      DIMENSION WRK(M*N*2)
C
C Specify the NDC coordinates for a plot title.
C
        DATA FX / 0.090909 /, FY / 0.976540 /
C
C Specify VELVCT arguments.
C
      DATA FLO/0./,HI/0./,NSET/0/,LENGTH/0/,ISPV/0/,SPV/0./
C
C Initialize the error parameter.
C
      IERROR = 1
C
C Specify velocity field component arrays U and V.
C
      DO  20 I=1,M
         DO  10 J=1,N
            U(I,J)= 1.0
            V(I,J)= 1.0
   10    CONTINUE
   20 CONTINUE
C
C Generate five frames:
C Frame 1: X-Axis linear, Y-Axis linear, equal units
C Frame 2: X-Axis linear, Y-Axis log
C Frame 3: X-Axis log, Y-Axis linear
C Frame 4: X-Axis log, Y-Axis log
C Frame 5: X-Axis linear, Y-Axis linear, 1 X unit = 2 Y units
C
      DO 100 I = 1,5
C           
         IF (I .EQ. 5) THEN
            XMX=50.0
            LL=1
         ELSE
            XMX=100.0
            LL=I
         ENDIF
C
C Set up the user coordinate system and the data coordinate
C boundaries.
C
         CALL SET(0.05,0.95,0.05,0.95,1.0,XMX,1.0,100.0,LL)
         CALL VVSETR('XC1 -- Lower X Bound', 1.0)
         CALL VVSETR('XCM -- Upper X Bound', XMX)
         CALL VVSETR('YC1 -- Lower X Bound', 1.0)
         CALL VVSETR('YCN -- Upper Y Bound', 100.0)
         CALL STSETR('XC1 -- Lower X Bound', 1.0)
         CALL STSETR('XCM -- Upper X Bound', XMX)
         CALL STSETR('YC1 -- Lower X Bound', 1.0)
         CALL STSETR('YCN -- Upper Y Bound', 100.0)
C
C Set the compatibility mode parameters: 
C (1) negative to allow use of Version 3.2 mapping routines 
C (the old mapping routines, FX and FY, do not support non-uniform 
C coordinates, and in addition, must be custom coded to support the
C data coordinate to user coordinate mapping); 
C (2) to absolute value less than 3 to cause the option input 
C arguments for VELVCT and STRMLN (FLO,HI,NSET,LENGTH,ISPV, and SPV) 
C to override the equivalent Version 3.2 parameters; 
C (3) to an even value, specifying that old common blocks be ignored.
C
C This setting causes the value of the NSET parameter to
C determine whether the utilities perform a SET call. If NSET = 1 
C the utilities do not perform the set call. 
C
C ====================================================================
         CALL VVSETI('CPM -- Compatibility Mode', -2) 
         CALL STSETI('CPM -- Compatibility Mode', -2) 
         NSET=1
         CALL GSPLCI(3)
         CALL VELVCT (U,M,V,M,M,N,FLO,HI,NSET,LENGTH,ISPV,SPV)
         CALL GSPLCI(7)
         CALL STRMLN (U,V,WRK,M,M,N,NSET,IER)
C ====================================================================
C
C To produce the same plot using Version 3.2 interfaces, comment out
C the code between this comment and the preceeding one, and uncomment
C the following code (Note that here CPM is left at its default value
C of 0 and the SET parameter is given the value of 0 to specify that
C the utilities should not perform a SET call):
C
C You could try setting the transformation type parameter, TRT, to 0 
C to see the effect it has on the plot frames.
C
C         CALL VVSETI('TRT - Transfomation Type', 0)
C         CALL STSETI('TRT - Transfomation Type', 0)
C
C ====================================================================
C$$$         IDM=0
C$$$         RDM=0
C$$$         CALL VVSETI('SET - Do-SET-Call Flag', 0)
C$$$         CALL STSETI('SET - Do-SET-Call Flag', 0)
C$$$         CALL GSPLCI(3)
C$$$         CALL VVINIT(U,M,V,M,RDM,IDM,M,N,RDM,IDM)
C$$$         CALL VVECTR(U,V,RDM,IDM,IDM,RDM)
C$$$         CALL GSPLCI(7)
C$$$         CALL STINIT(U,M,V,M,RDM,IDM,M,N,WRK,2*M*N)
C$$$         CALL STREAM(U,V,RDM,IDM,IDM,WRK)
C ====================================================================
C
C Save the current normalization transformation then set it to 0
C
         CALL GQCNTN(IERR,ICN)
         CALL GSELNT(0)
         X = CFUX(FX)
         Y = CFUY(FY)
C
C Call PLCHLQ to write the plot title.
C
         CALL PLCHLQ (X,Y,
     1           'Streamlines Plotted Over a Uniform Vector Field',
     2           16.,0.,-1.)
C
C Restore the normalization transformation
C
         CALL GSELNT(ICN)
         CALL FRAME
C
 100  CONTINUE
C
      IERROR = 0
      RETURN
C
      END

      PROGRAM TPWRZS
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C OPEN GKS, OPEN WORKSTATION OF TYPE 1, ACTIVATE WORKSTATION
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C INVOKE DEMO DRIVER
C
      CALL TPWRZS1(IERR)
C
C DEACTIVATE AND CLOSE WORKSTATION, CLOSE GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END
C
      SUBROUTINE TPWRZS1 (IERROR)
C
C PURPOSE                To provide a simple demonstration of
C                        entry PWRZS with the SRFACE utility.
C
C USAGE                  CALL TPWRZS1 (IERROR)
C
C ARGUMENTS
C
C ON OUTPUT              IERROR
C                          An integer variable
C                          = 0, if the test was successful,
C                          = 1, otherwise
C
C I/O                    If the test is successful, the message
C
C               PWRZS TEST EXECUTED--SEE PLOTS TO CERTIFY
C
C                        is printed on unit 6.  In addition, 1
C                        frame is produced on the machine graphics
C                        device.  In order to determine if the test
C                        was successful, it is necessary to examine
C                        the plot.
C
C PRECISION              Single
C
C REQUIRED ROUTINES      PWRZS, SRFACE
C
C REQUIRED GKS LEVEL     0A
C
C LANGUAGE               FORTRAN 77
C
C ALGORITHM              A function of 2 variables is defined and the
C                        values of the function on a 2-D rectangular
C                        grid are stored in an array.  This routine
C                        calls SRFACE to draw a surface representation
C                        of the array values.  PWRZS is then called 3
C                        times to label the front, side, and back of
C                        the picture.
C
      DIMENSION       Z(20,30)   ,X(20)      ,Y(30)      ,MM(20,30,2),
     1                S(6)
C
C Load the SRFACE common block needed to supress a NEWFM call.
C
      COMMON /SRFIP1/ IFR        ,ISTP       ,IROTS      ,IDRX       ,
     1                IDRY       ,IDRZ       ,IUPPER     ,ISKIRT     ,
     2                NCLA       ,THETA      ,HSKIRT     ,CHI        ,
     3                CLO        ,CINC       ,ISPVAL
C
C Define the center of a plot title string on a square grid of size
C 0. to 1.
C
      DATA TX/0.4375/, TY/0.9667/
C
C Specify grid loop indices and a line of sight.
C
      DATA M/20/, N/30/
      DATA S/4.,5.,3.,0.,0.,0./
C
C Initial the error parameter.
C
      IERROR = 1
C
C Define the function values and store them in the Z array.
C
      DO  10 I=1,M
         X(I) = -1.+REAL(I-1)/REAL(M-1)*2.
   10 CONTINUE
      DO  20 J=1,N
         Y(J) = -1.+REAL(J-1)/REAL(N-1)*2.
   20 CONTINUE
      DO  40 J=1,N
         DO  30 I=1,M
            Z(I,J) = EXP(-2.*SQRT(X(I)**2+Y(J)**2))
   30    CONTINUE
   40 CONTINUE
C
C Set SRFACE parameters to supress the FRAME call and draw contours.
C
      IFR = 0
      IDRZ = 1
C
C Select normalization trans number 0.
C
      CALL GSELNT (0)
C
C Label the plot.
C
      CALL PLCHLQ (TX,TY,'DEMONSTRATION PLOT FOR PWRZS',16.,0.,0.)
C
C Draw the surface plot.
C
      CALL SRFACE (X,Y,Z,MM,M,M,N,S,0.)
C
C Put the PWRZS labels on the picture.
C
      ISIZE = 35
      CALL PWRZS (0.,1.1,0.,'FRONT',5,ISIZE,-1,3,0)
      CALL PWRZS (1.1,0.,0.,'SIDE',4,ISIZE,2,-1,0)
      CALL PWRZS (0.,-1.1,.2,' BACK BACK BACK BACK BACK',25,ISIZE,-1,
     1            3,0)
      CALL FRAME
C
      IERROR = 0
      WRITE (6,1001)
C
C Restore the SRFACE parameters to their default values.
C
      IFR = 1
      IDRZ = 0
C
      RETURN
C
 1001 FORMAT (' PWRZS TEST EXECUTED--SEE PLOT TO CERTIFY')
C
      END

C
C $Id: shgrid.f,v 1.7 2008-07-27 03:10:13 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE SHGRID (N,X,Y,Z,F, NXO,NYO,NZO,XO,YO,ZO,FF, 
     +                   IWK,RWK,IER)
      INTEGER N, NXO, NYO, NZO, IWK(*), IER
      REAL    X(N), Y(N), Z(N), F(N), XO(NXO), YO(NYO), ZO(NZO),
     +        FF(NXO,NYO,NZO),  RWK(*)
C
C***********************************************************
C
C  This subroutine provides a simple interface to the Shepard
C  algortihm interpolation package for 3D interpolation.
C
C  ON INPUT
C
C     N - The number of input data points.
C     X - An array of X coordinate values of the input data points.
C     Y - An array of Y coordinate values of the input data points.
C     Z - An array of Z coordinate values of the input data points.
C     F - The functional value at coordinate (x,y,z).
C   NXO - The dimension of the array xo containing the X coordinate
C         values for the output grid.
C   NYO - The dimension of the array yo containing the Y coordinate
C         values for the output grid.
C   NZO - The dimension of the array zo containing the z coordinate
C         values for the output grid.
C    XO - The array containing the X coordinate values for the output
C         grid (must be monotone increasing, but need not be equally
C         spaced.
C    YO - The array containing the Y coordinate values for the output
C         grid (must be monotone increasing, but need not be equally
C         spaced.
C    ZO - The array containing the Z coordinate values for the output
C         grid (must be monotone increasing, but need not be equally
C         spaced.
C   IWK - An integer workspace dimensioned for at least 2*N.
C   RWK - A real workspace dimensioned for at least 11*N+6.
C
C ON OUTPUT:
C
C    FF - Interpolated values at the grid points if IER
C         .EQ. 0 .  FF(I,J,K) = F(XO(I),YO(J),ZO(K)) 
C         for I=1,...,NXO and J=1,...,NYO and K=1,NZO.
C
C
C    IER - Error indicator
C          = 3 - NQ must be at least 9
C          = 4 - NW must be at least 1
C          = 5 - must have N < NQ < 41
C          = 6 - must have N < NW < 41
C          = 7 - cell grid dimensions must be positive
C          = 8 - duplicate input points encountered
C          = 9 - collinear input, no unique solution
C
C***********************************************************
C
C
C  Define defaults for the parameter values if they have not
C  been set.
C
      COMMON /SHCOMI/ NMLSTQ, NMINFL, NMCELS
C
C  Do a call forcing a BLOCKDATA to be loaded from a binary library.
C
      CALL SHBLDA
C
      IF (NMLSTQ .LT. 0) THEN
        NMLSTQ = MIN(17,N-1)
      ENDIF
C
      IF (NMINFL .LT. 0) THEN
        NMINFL = MIN(32,N-1)
      ENDIF
C
      IF (NMCELS .LT. 0) THEN
        RTMP = (REAL(N)/3.)**(0.333333)
        IF (RTMP-REAL(INT(RTMP)) .NE. 0.) THEN
          NMCELS = INT(RTMP)+1
        ELSE
          NMCELS = INT(RTMP)
        ENDIF
      ENDIF
      CALL SHQSHEP(N,X,Y,Z,F,NMLSTQ,NMINFL,NMCELS,IWK(1),
     +             IWK(N+1),RWK(N+1),RWK(N+4),RMAX,
     +             RWK(N+7),RWK(2*N+7),IER)
C
C  Interpolat at the desired points.
C
      DO 20 I=1,NXO
        DO 30 J=1,NYO
          DO 40 K=1,NZO
            FF(I,J,K) = SH3VAL(XO(I),YO(J),ZO(K),N,X,Y,Z,F,
     +                         NMCELS,IWK(1),IWK(N+1),RWK(N+1),
     +                         RWK(N+4),RMAX,RWK(N+7),RWK(2*N+7))
   40     CONTINUE
   30   CONTINUE
   20 CONTINUE
C
      RETURN
      END

      SUBROUTINE CHBEVD( JOBZ, UPLO, N, KD, AB, LDAB, W, Z, LDZ, WORK,
     $                   LWORK, RWORK, LRWORK, IWORK, LIWORK, INFO )
*
*  -- LAPACK driver routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          JOBZ, UPLO
      INTEGER            INFO, KD, LDAB, LDZ, LIWORK, LRWORK, LWORK, N
*     ..
*     .. Array Arguments ..
      INTEGER            IWORK( * )
      REAL               RWORK( * ), W( * )
      COMPLEX            AB( LDAB, * ), WORK( * ), Z( LDZ, * )
*     ..
*
*  Purpose
*  =======
*
*  CHBEVD computes all the eigenvalues and, optionally, eigenvectors of
*  a complex Hermitian band matrix A.  If eigenvectors are desired, it
*  uses a divide and conquer algorithm.
*
*  The divide and conquer algorithm makes very mild assumptions about
*  floating point arithmetic. It will work on machines with a guard
*  digit in add/subtract, or on those binary machines without guard
*  digits which subtract like the Cray X-MP, Cray Y-MP, Cray C-90, or
*  Cray-2. It could conceivably fail on hexadecimal or decimal machines
*  without guard digits, but we know of none.
*
*  Arguments
*  =========
*
*  JOBZ    (input) CHARACTER*1
*          = 'N':  Compute eigenvalues only;
*          = 'V':  Compute eigenvalues and eigenvectors.
*
*  UPLO    (input) CHARACTER*1
*          = 'U':  Upper triangle of A is stored;
*          = 'L':  Lower triangle of A is stored.
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  KD      (input) INTEGER
*          The number of superdiagonals of the matrix A if UPLO = 'U',
*          or the number of subdiagonals if UPLO = 'L'.  KD >= 0.
*
*  AB      (input/output) COMPLEX array, dimension (LDAB, N)
*          On entry, the upper or lower triangle of the Hermitian band
*          matrix A, stored in the first KD+1 rows of the array.  The
*          j-th column of A is stored in the j-th column of the array AB
*          as follows:
*          if UPLO = 'U', AB(kd+1+i-j,j) = A(i,j) for max(1,j-kd)<=i<=j;
*          if UPLO = 'L', AB(1+i-j,j)    = A(i,j) for j<=i<=min(n,j+kd).
*
*          On exit, AB is overwritten by values generated during the
*          reduction to tridiagonal form.  If UPLO = 'U', the first
*          superdiagonal and the diagonal of the tridiagonal matrix T
*          are returned in rows KD and KD+1 of AB, and if UPLO = 'L',
*          the diagonal and first subdiagonal of T are returned in the
*          first two rows of AB.
*
*  LDAB    (input) INTEGER
*          The leading dimension of the array AB.  LDAB >= KD + 1.
*
*  W       (output) REAL array, dimension (N)
*          If INFO = 0, the eigenvalues in ascending order.
*
*  Z       (output) COMPLEX array, dimension (LDZ, N)
*          If JOBZ = 'V', then if INFO = 0, Z contains the orthonormal
*          eigenvectors of the matrix A, with the i-th column of Z
*          holding the eigenvector associated with W(i).
*          If JOBZ = 'N', then Z is not referenced.
*
*  LDZ     (input) INTEGER
*          The leading dimension of the array Z.  LDZ >= 1, and if
*          JOBZ = 'V', LDZ >= max(1,N).
*
*  WORK    (workspace/output) COMPLEX array, dimension (LWORK)
*          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*
*  LWORK   (input) INTEGER
*          The dimension of the array WORK.
*          If N <= 1,               LWORK must be at least 1.
*          If JOBZ = 'N' and N > 1, LWORK must be at least N.
*          If JOBZ = 'V' and N > 1, LWORK must be at least 2*N**2.
*
*          If LWORK = -1, then a workspace query is assumed; the routine
*          only calculates the optimal size of the WORK array, returns
*          this value as the first entry of the WORK array, and no error
*          message related to LWORK is issued by XERBLA.
*
*  RWORK   (workspace/output) REAL array,
*                                         dimension (LRWORK)
*          On exit, if INFO = 0, RWORK(1) returns the optimal LRWORK.
*
*  LRWORK  (input) INTEGER
*          The dimension of array RWORK.
*          If N <= 1,               LRWORK must be at least 1.
*          If JOBZ = 'N' and N > 1, LRWORK must be at least N.
*          If JOBZ = 'V' and N > 1, LRWORK must be at least
*                        1 + 5*N + 2*N**2.
*
*          If LRWORK = -1, then a workspace query is assumed; the
*          routine only calculates the optimal size of the RWORK array,
*          returns this value as the first entry of the RWORK array, and
*          no error message related to LRWORK is issued by XERBLA.
*
*  IWORK   (workspace/output) INTEGER array, dimension (LIWORK)
*          On exit, if INFO = 0, IWORK(1) returns the optimal LIWORK.
*
*  LIWORK  (input) INTEGER
*          The dimension of array IWORK.
*          If JOBZ = 'N' or N <= 1, LIWORK must be at least 1.
*          If JOBZ = 'V' and N > 1, LIWORK must be at least 3 + 5*N .
*
*          If LIWORK = -1, then a workspace query is assumed; the
*          routine only calculates the optimal size of the IWORK array,
*          returns this value as the first entry of the IWORK array, and
*          no error message related to LIWORK is issued by XERBLA.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit.
*          < 0:  if INFO = -i, the i-th argument had an illegal value.
*          > 0:  if INFO = i, the algorithm failed to converge; i
*                off-diagonal elements of an intermediate tridiagonal
*                form did not converge to zero.
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ZERO, ONE
      PARAMETER          ( ZERO = 0.0E0, ONE = 1.0E0 )
      COMPLEX            CZERO, CONE
      PARAMETER          ( CZERO = ( 0.0E0, 0.0E0 ),
     $                   CONE = ( 1.0E0, 0.0E0 ) )
*     ..
*     .. Local Scalars ..
      LOGICAL            LOWER, LQUERY, WANTZ
      INTEGER            IINFO, IMAX, INDE, INDWK2, INDWRK, ISCALE,
     $                   LIWMIN, LLRWK, LLWK2, LRWMIN, LWMIN
      REAL               ANRM, BIGNUM, EPS, RMAX, RMIN, SAFMIN, SIGMA,
     $                   SMLNUM
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      REAL               CLANHB, SLAMCH
      EXTERNAL           LSAME, CLANHB, SLAMCH
*     ..
*     .. External Subroutines ..
      EXTERNAL           CGEMM, CHBTRD, CLACPY, CLASCL, CSTEDC, SSCAL,
     $                   SSTERF, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          SQRT
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      WANTZ = LSAME( JOBZ, 'V' )
      LOWER = LSAME( UPLO, 'L' )
      LQUERY = ( LWORK.EQ.-1 .OR. LIWORK.EQ.-1 .OR. LRWORK.EQ.-1 )
*
      INFO = 0
      IF( N.LE.1 ) THEN
         LWMIN = 1
         LRWMIN = 1
         LIWMIN = 1
      ELSE
         IF( WANTZ ) THEN
            LWMIN = 2*N**2
            LRWMIN = 1 + 5*N + 2*N**2
            LIWMIN = 3 + 5*N
         ELSE
            LWMIN = N
            LRWMIN = N
            LIWMIN = 1
         END IF
      END IF
      IF( .NOT.( WANTZ .OR. LSAME( JOBZ, 'N' ) ) ) THEN
         INFO = -1
      ELSE IF( .NOT.( LOWER .OR. LSAME( UPLO, 'U' ) ) ) THEN
         INFO = -2
      ELSE IF( N.LT.0 ) THEN
         INFO = -3
      ELSE IF( KD.LT.0 ) THEN
         INFO = -4
      ELSE IF( LDAB.LT.KD+1 ) THEN
         INFO = -6
      ELSE IF( LDZ.LT.1 .OR. ( WANTZ .AND. LDZ.LT.N ) ) THEN
         INFO = -9
      ELSE IF( LWORK.LT.LWMIN .AND. .NOT.LQUERY ) THEN
         INFO = -11
      ELSE IF( LRWORK.LT.LRWMIN .AND. .NOT.LQUERY ) THEN
         INFO = -13
      ELSE IF( LIWORK.LT.LIWMIN .AND. .NOT.LQUERY ) THEN
         INFO = -15
      END IF
*
      IF( INFO.EQ.0 ) THEN
         WORK( 1 ) = LWMIN
         RWORK( 1 ) = LRWMIN
         IWORK( 1 ) = LIWMIN
      END IF
*
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'CHBEVD', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN 
*
      IF( N.EQ.1 ) THEN
         W( 1 ) = AB( 1, 1 )
         IF( WANTZ )
     $      Z( 1, 1 ) = CONE
         RETURN 
      END IF
*
*     Get machine constants.
*
      SAFMIN = SLAMCH( 'Safe minimum' )
      EPS = SLAMCH( 'Precision' )
      SMLNUM = SAFMIN / EPS
      BIGNUM = ONE / SMLNUM
      RMIN = SQRT( SMLNUM )
      RMAX = SQRT( BIGNUM )
*
*     Scale matrix to allowable range, if necessary.
*
      ANRM = CLANHB( 'M', UPLO, N, KD, AB, LDAB, RWORK )
      ISCALE = 0
      IF( ANRM.GT.ZERO .AND. ANRM.LT.RMIN ) THEN
         ISCALE = 1
         SIGMA = RMIN / ANRM
      ELSE IF( ANRM.GT.RMAX ) THEN
         ISCALE = 1
         SIGMA = RMAX / ANRM
      END IF
      IF( ISCALE.EQ.1 ) THEN
         IF( LOWER ) THEN
            CALL CLASCL( 'B', KD, KD, ONE, SIGMA, N, N, AB, LDAB, INFO )
         ELSE
            CALL CLASCL( 'Q', KD, KD, ONE, SIGMA, N, N, AB, LDAB, INFO )
         END IF
      END IF
*
*     Call CHBTRD to reduce Hermitian band matrix to tridiagonal form.
*
      INDE = 1
      INDWRK = INDE + N
      INDWK2 = 1 + N*N
      LLWK2 = LWORK - INDWK2 + 1
      LLRWK = LRWORK - INDWRK + 1
      CALL CHBTRD( JOBZ, UPLO, N, KD, AB, LDAB, W, RWORK( INDE ), Z,
     $             LDZ, WORK, IINFO )
*
*     For eigenvalues only, call SSTERF.  For eigenvectors, call CSTEDC.
*
      IF( .NOT.WANTZ ) THEN
         CALL SSTERF( N, W, RWORK( INDE ), INFO )
      ELSE
         CALL CSTEDC( 'I', N, W, RWORK( INDE ), WORK, N, WORK( INDWK2 ),
     $                LLWK2, RWORK( INDWRK ), LLRWK, IWORK, LIWORK,
     $                INFO )
         CALL CGEMM( 'N', 'N', N, N, N, CONE, Z, LDZ, WORK, N, CZERO,
     $               WORK( INDWK2 ), N )
         CALL CLACPY( 'A', N, N, WORK( INDWK2 ), N, Z, LDZ )
      END IF
*
*     If matrix was scaled, then rescale eigenvalues appropriately.
*
      IF( ISCALE.EQ.1 ) THEN
         IF( INFO.EQ.0 ) THEN
            IMAX = N
         ELSE
            IMAX = INFO - 1
         END IF
         CALL SSCAL( IMAX, ONE / SIGMA, W, 1 )
      END IF
*
      WORK( 1 ) = LWMIN
      RWORK( 1 ) = LRWMIN
      IWORK( 1 ) = LIWMIN
      RETURN
*
*     End of CHBEVD
*
      END

      PROGRAM TEZMPB
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Open GKS, open workstation of type 1, activate workstation.
C
      CALL GOPKS (IERRF,ISZDM)
      CALL GOPWK (IWKID,LUNIT,IWTYPE)
      CALL GACWK (IWKID)
C
C Invoke demo driver.
C
      CALL EZMPB (IERR,IWKID)
C
C Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
C
      END

      SUBROUTINE EZMPB (IERR,IWKID)
C
C PURPOSE                To provide a simple demonstration of the use
C                        of EZMAPB.
C
C USAGE                  CALL EZMPB (IERR,IWKID)
C
C ARGUMENTS
C
C ON OUTPUT              IERR
C
C                          an error parameter
C                          = 0, if the test is successful,
C                          = 1, otherwise
C
C I/O                    If the test is successful, the message
C
C                          EZMAPB TEST EXECUTED--SEE PLOTS TO CERTIFY
C
C                        is written on unit 6.
C
C PRECISION              Single.
C
C REQUIRED LIBRARY       EZMAP, EZMAPA, EZMAPB, AREAS, SPPS
C FILES
C
C REQUIRED GKS LEVEL     0A
C
C LANGUAGE               FORTRAN
C
C HISTORY                Written in May, 1998.
C
C ALGORITHM              TEZMPB draws a solid-color map of a portion
C                        of Europe.
C
C PORTABILITY            FORTRAN 77
C
C
C Define an array in which to construct the area map.
C
        DIMENSION IAMA(100000)
C
C Dimension the arrays needed by ARSCAM and ARDRLN for x/y coordinates.
C
        DIMENSION XCRA(2000),YCRA(2000)
C
C Dimension the arrays needed by ARSCAM and ARDRLN for area and group
C identifiers.
C
        DIMENSION IAAI(2),IAGI(2)
C
C Define the RGB color triples needed below.
C
        DIMENSION RGB(3,14)
C
C Define a set of indices to order the colors.
C
        DIMENSION IOC(14)
C
C Declare the routine which will color the areas.
C
        EXTERNAL COLRAM
C
C Declare the routine which will draw lines of latitude and longitude
C over water.
C
        EXTERNAL COLRLN
C
        DATA IOC / 6,2,5,12,10,11,1,3,4,8,9,7,13,14 /
C
        DATA RGB / 0.70 , 0.70 , 0.70 ,
     +             0.75 , 0.50 , 1.00 ,
     +             0.50 , 0.00 , 1.00 ,
     +             0.00 , 0.00 , 1.00 ,
     +             0.00 , 0.50 , 1.00 ,
     +             0.00 , 1.00 , 1.00 ,
     +             0.00 , 1.00 , 0.60 ,
     +             0.00 , 1.00 , 0.00 ,
     +             0.70 , 1.00 , 0.00 ,
     +             1.00 , 1.00 , 0.00 ,
     +             1.00 , 0.75 , 0.00 ,
     +             1.00 , 0.38 , 0.38 ,
     +             1.00 , 0.00 , 0.38 ,
     +             1.00 , 0.00 , 0.00 /
C
C Force solid fill.
C
        CALL GSFAIS (1)
C
C Define 15 different color indices.  The first 14 are spaced through
C the color spectrum and the final one is black.
C
        DO 101 J=1,14
          I=IOC(J)
          CALL GSCR (IWKID,J,RGB(1,I),RGB(2,I),RGB(3,I))
  101   CONTINUE
C
C Set color index 15 to black.
C
        CALL GSCR (IWKID,15,0.,0.,0.)
C
C Set up EZMAP.
C
        CALL MAPSTI ('MV',1)
        CALL MAPSTC ('OU','PO')
        CALL MAPROJ ('ME',0.,0.,0.)
        CALL MAPSET ('CO',30.,-15.,60.,30.)
C
C Make MPLNAM use 1 and 2 as the group identifiers.
C
        CALL MAPSTI ('G1',1)
        CALL MAPSTI ('G2',2)
C
C Use 5 vertical strips to reduce the number of points defining the
C sub-areas.
C
        CALL MAPSTI ('VS',5)
C
C Initialize EZMAP.
C
        CALL MAPINT
C
C Initialize the area map.
C
        CALL ARINAM (IAMA,100000)
C
C Add edges to the area map.
C
        CALL MPLNAM ('Earth..1',3,IAMA)
C
C Pre-process the area map.
C
        CALL ARPRAM (IAMA,0,0,0)
C
C Compute and print the amount of space used in the area map.
C
        ISU=IAMA(1)-(IAMA(6)-IAMA(5)-1)
        PRINT * , 'SPACE USED IN AREA MAP IS ',ISU
C
C Color the map.
C
        CALL ARSCAM (IAMA,XCRA,YCRA,2000,IAAI,IAGI,2,COLRAM)
C
C Flush PLOTIT's buffers and set polyline color index to black.
C
        CALL PLOTIT (0,0,0)
        CALL GSPLCI (15)
C
C In black, draw a perimeter and outline all the countries.
C
        CALL MAPSTI ('LA',0)
        CALL MAPSTI ('MV',1)
        CALL MAPLBL
        CALL MPLNDR ('Earth..1',3)
C
C Draw lines of latitude and longitude over water.
C
        CALL MAPGRM (IAMA,XCRA,YCRA,2000,IAAI,IAGI,2,COLRLN)
C
C Advance the frame.
C
        CALL FRAME
C
C Done.
C
        IERR=0
        WRITE (6,1001)
C
        RETURN
C
 1001   FORMAT ('  EZMAPB TEST EXECUTED--SEE PLOTS TO CERTIFY')
C
      END



      SUBROUTINE COLRAM (XCRA,YCRA,NCRA,IAAI,IAGI,NGPS)
C
        DIMENSION XCRA(*),YCRA(*),IAAI(*),IAGI(*)
C
C This is the routine that color-fills the areas defined by the area map.
C First, ITMP is set non-zero if and only if no area identifiers for the
C area are negative.
C
        ITMP=1
C
        DO 101 I=1,NGPS
          IF (IAAI(I).LT.0) ITMP=0
  101   CONTINUE
C
C Then, if ITMP is non-zero (which says that we really do want to color-
C fill the area) ...
C
        IF (ITMP.NE.0) THEN
C
C set ITMP to equal to the value of the area identifier for the area
C relative to group 1 and ...
C
          ITMP=0
C
          DO 102 I=1,NGPS
            IF (IAGI(I).EQ.1) ITMP=IAAI(I)
  102     CONTINUE
C
C if that area identifier is greater than zero, ...
C
          IF (ITMP.GT.0) THEN
C
C find the index of the suggested color for the area, set the fill area
C color index, and fill the area.
C
            CALL GSFACI (MPISCI(ITMP))
C
            CALL GFA (NCRA-1,XCRA,YCRA)
C
          END IF
C
        END IF
C
        RETURN
C
      END



      SUBROUTINE COLRLN (XCRA,YCRA,NCRA,IAAI,IAGI,NGPS)
C
        DIMENSION XCRA(*),YCRA(*),IAAI(*),IAGI(*)
C
C This is the routine that draws lines of latitude and longitude over
C water only.  First, ITMP is set non-zero if and only if no area
C identifiers for the area are negative.
C
        ITMP=1
C
        DO 101 I=1,NGPS
          IF (IAAI(I).LT.0) ITMP=0
  101   CONTINUE
C
C Then, if ITMP is non-zero (which says that we really do want to draw
C things in the area) ...
C
        IF (ITMP.NE.0) THEN
C
C set ITMP to equal to the value of the area identifier for the area
C relative to group 1 (EZMAP lines) ...
C
          ITMP=0
C
          DO 102 I=1,NGPS
            IF (IAGI(I).EQ.1) ITMP=IAAI(I)
  102     CONTINUE
C
C if the suggested color for the area implies that it is over water
C (the color index 1 is used only for water) ...
C
          IF (MPISCI(ITMP).EQ.1) THEN
C
C flush PLOTIT's buffers, set the polyline color index to black, and
C draw the line.
C
            CALL PLOTIT (0,0,0)
            CALL GSPLCI (15)
C
            CALL GPL (NCRA,XCRA,YCRA)
C
          END IF
C
        END IF
C
        RETURN
C
      END

C
C $Id: idsfft.f,v 1.6 2008-07-27 00:17:30 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE IDSFFT (MD,NDP,XD,YD,ZD,NXI,NYI,NZI,XI,YI,ZI,IWK,WK)
C
C DIMENSION OF           XD(NDP), YD(NDP), ZD(NDP), XI(NXI),
C ARGUMENTS              YI(NYI), ZI(NZI,NYI), WK(6*NDP),
C                        IWK(31*NDP + NXI*NYI)
C
C PURPOSE                This subroutine performs smooth surface
C                        fitting when the projections of the data
C                        points in the X-Y plane are irregularly
C                        distributed in the plane.
C
C USAGE                  CALL IDSFFT (MD,NDP,XD,YD,ZD,NXI,NYI,NZI,
C                                     XI,YI,ZI,IWK,WK)
C
C ARGUMENTS
C
C ON INPUT               MD
C                          Mode of computation (must be 1, 2, or 3,
C                          else an error return will occur).
C                           = 1 if this is the first call to this
C                               subroutine, or if the value of NDP
C                               has been changed from the previous
C                               call, or if the contents of the XD
C                               or YD arrays have been changed from
C                               the previous call.
C                           = 2 if the values of NDP and the XD and
C                               YD arrays are unchanged from the
C                               previous call, but new values for
C                               XI and YI are being used.  If MD = 2
C                               and NDP has been changed since the
C                               previous call to IDSFFT, an error
C                               return occurs.
C                           = 3 if the values of NDP, NXI, NYI, XD,
C                               YD, XI, and YI are unchanged from the
C                               previous call, i.e., if the only change
C                               on input to IDSFFT is in the ZD array.
C                               If MD = 3 and NDP, NXI, or NYI has been
C                               changed since the previous call to
C                               IDSFFT, an error return occurs.
C
C                           Between the call with MD = 2 or MD = 3 and
C                           the preceding call, the IWK and WK work
C                           arrays should not be disturbed.
C
C                        NDP
C                          Number of data points (must be 4 or
C                          greater, else an error return will occur).
C
C                        XD
C                          Array of dimension NDP containing the X
C                          coordinates of the data points.
C
C                        YD
C                          Array of dimension NDP containing the Y
C                          coordinates of the data points.
C
C                        ZD
C                          Array of dimension NDP containing the Z
C                          coordinates of the data points.
C
C                        NXI
C                          Number of output grid points in the X
C                          direction (must be 1 or greater, else
C                          an error return will occur).
C
C                        NYI
C                          Number of output grid points in the Y
C                          direction (must be 1 or greater, else
C                          an error return will occur).
C
C                        NZI
C                          First dimension of ZI as declared in the
C                          calling program.  NZI must be greater than
C                          or equal to NXI, else an error return will
C                          occur.
C
C                        XI
C                          Array of dimension NXI containing the
C                          X coordinates of the output grid points.
C
C                        YI
C                         Array of dimension NYI containing the
C                         Y coordinates of the output grid points.
C
C                        IWK
C                          Integer work array of dimension at
C                          least 31*NDP + NXI*NYI.
C
C                        WK
C                          Real work array of dimension at least 6*NDP.
C
C ON OUTPUT              ZI
C                           Real, two-dimensional array of dimension
C                           (NZI,NYI), storing the interpolated Z
C                           values at the output grid points.
C
C SPECIAL CONDITIONS     Inadequate work space IWK and WK may cause
C                        incorrect results.
C
C                        The data points must be distinct and their
C                        projections in the X-Y plane must not be
C                        collinear, else an error return occurs.
C
C IDSFFT calls the subroutines IDGRID, IDPDRV, IDPTIP, and IDTANG.
C
C Declaration statements.
C
      DIMENSION XD(NDP),YD(NDP),ZD(NDP),XI(NXI),YI(NYI),ZI(NZI,NYI),
     +          IWK(31*NDP+NXI*NYI),WK(6*NDP)
C
      COMMON /IDPT/ ITPV,DMMY(27)
      SAVE   /IDPT/
C
      COMMON /IDCOMN/ INTY,ITTY,ALSP,BLSP,CLSP,XAVG,YAVG
      SAVE   /IDCOMN/
C
C Check for an uncleared prior error.
C
        IF (ICFELL('IDSFFT (BIVAR) - UNCLEARED PRIOR ERROR',1).NE.0)
     +                                                        RETURN
C
C Check for input errors.
C
      IF (MD.LT.1.OR.MD.GT.3) THEN
        CALL SETER ('IDSFFT (BIVAR) - INPUT VARIABLE MD IS OUT OF RANGE'
     +,2,1)
        RETURN
      END IF
C
      IF (NDP.LT.4) THEN
        CALL SETER ('IDSFFT (BIVAR) - INPUT VARIABLE NDP IS OUT OF RANGE
     +',3,1)
        RETURN
      END IF
C
      IF (NXI.LT.1.OR.NYI.LT.1) THEN
        CALL SETER ('IDSFFT (BIVAR) - INPUT VARIABLE NXI OR NYI IS OUT O
     +F RANGE',4,1)
        RETURN
      END IF
C
      IF (NXI.GT.NZI) THEN
        CALL SETER ('IDSFFT (BIVAR) - INPUT VARIABLE NZI IS LESS THAN NX
     +I',5,1)
        RETURN
      END IF
C
      IF (MD.LE.1) THEN
C
        IWK(1)=NDP
C
      ELSE
C
        NDPPV=IWK(1)
C
        IF (NDP.NE.NDPPV) THEN
          CALL SETER  ('IDSFFT (BIVAR) - MD = 2 OR 3 BUT NDP WAS CHANGED
     + SINCE LAST CALL',6,1)
          RETURN
        END IF
C
      END IF
C
      IF (MD.LE.2) THEN
C
        IWK(2)=INTY
        IWK(3)=NXI
        IWK(4)=NYI
C
      ELSE
C
        INTYPV=IWK(2)
C
        IF (INTY.NE.INTYPV) THEN
          CALL SETER ('IDSFFT (BIVAR) - MD = 3 BUT ITY WAS CHANGED SINCE
     + LAST CALL',7,1)
           RETURN
        END IF
C
        NXIPV=IWK(3)
C
        IF (NXI.NE.NXIPV) THEN
          CALL SETER ('IDSFFT (BIVAR) - MD = 3 BUT NXI WAS CHANGED SINCE
     + LAST CALL',8,1)
           RETURN
        END IF
C
        NYIPV=IWK(4)
C
        IF (NYI.NE.NYIPV) THEN
          CALL SETER ('IDSFFT (BIVAR) - MD = 3 BUT NYI WAS CHANGED SINCE
     + LAST CALL',9,1)
          RETURN
        END IF
C
      END IF
C
C Allocate storage areas in the array IWK.
C
      JWIPT=16
      JWIWL=6*NDP+1
      JWNGP0=JWIWL-1
      JWIPL=24*NDP+1
      JWIWP=30*NDP+1
      JWIGP0=31*NDP
      JWWPD=5*NDP+1
C
C If MD = 1, triangulate the X/Y plane.  (If MD = 2 or 3, this has
C already been done and need not been redone.)
C
      IF (MD.EQ.1) THEN
        CALL IDTANG (NDP,XD,YD,NT,IWK(JWIPT),NL,IWK(JWIPL),IWK(JWIWL),
     +                                                  IWK(JWIWP),WK)
        IF (ICFELL('IDSFFT',10).NE.0) RETURN
        IWK(5)=NT
        IWK(6)=NL
      ELSE
        NT=IWK(5)
        NL=IWK(6)
      END IF
C
      IF (NT.EQ.0) RETURN
C
C If linear interpolation is activated, compute the coefficients of the
C least-squares-fit plane and the mean values of X and Y.
C
      IF (INTY.NE.0) THEN
        CALL IDLSQF (XD,YD,ZD,NDP,ALSP,BLSP,CLSP,XAVG,YAVG)
      END IF
C
C If MD = 1 or 2, sort output grid points in ascending order by the
C number of the containing region (a triangle number or a combined
C pair of border line segment numbers).  (If MD = 3, this has already
C been done and need not be redone.)
C
      IF (MD.LE.2) THEN
        CALL IDGRID (XD,YD,NT,IWK(JWIPT),NL,IWK(JWIPL),NXI,
     +               NYI,XI,YI,IWK(JWNGP0+1),IWK(JWIGP0+1))
        IF (ICFELL('IDSFFT',11).NE.0) RETURN
      END IF
C
C If quintic interpolation is activated, estimate partial derivatives.
C
      IF (INTY.EQ.0) THEN
        CALL IDPDRV (NDP,XD,YD,ZD,NT,IWK(JWIPT),WK,WK(JWWPD))
      END IF
C
C Interpolate to get ZI values.
C
      ITPV=0
      JIG0MX=0
      JIG1MN=NXI*NYI+1
      NNGP=NT+2*NL
C
      DO 105 JNGP=1,NNGP
C
        ITI=JNGP
        IF (JNGP.LE.NT) GO TO 101
        IL1=(JNGP-NT+1)/2
        IL2=(JNGP-NT+2)/2
        IF (IL2.GT.NL) IL2=1
        ITI=IL1*(NT+NL)+IL2
C
  101   JWNGP=JWNGP0+JNGP
        NGP0=IWK(JWNGP)
        IF (NGP0.EQ.0) GO TO 103
        JIG0MN=JIG0MX+1
        JIG0MX=JIG0MX+NGP0
C
        DO 102 JIGP=JIG0MN,JIG0MX
          JWIGP=JWIGP0+JIGP
          IZI=IWK(JWIGP)
          IYI=(IZI-1)/NXI+1
          IXI=IZI-NXI*(IYI-1)
          CALL IDPTIP(XD,YD,ZD,NT,IWK(JWIPT),NL,IWK(JWIPL),WK,
     +                        ITI,XI(IXI),YI(IYI),ZI(IXI,IYI))
  102   CONTINUE
C
  103   JWNGP=JWNGP0+2*NNGP+1-JNGP
        NGP1=IWK(JWNGP)
        IF (NGP1.EQ.0) GO TO 105
        JIG1MX=JIG1MN-1
        JIG1MN=JIG1MN-NGP1
C
        DO 104 JIGP=JIG1MN,JIG1MX
          JWIGP=JWIGP0+JIGP
          IZI=IWK(JWIGP)
          IYI=(IZI-1)/NXI+1
          IXI=IZI-NXI*(IYI-1)
          CALL IDPTIP(XD,YD,ZD,NT,IWK(JWIPT),NL,IWK(JWIPL),WK,
     +                        ITI,XI(IXI),YI(IYI),ZI(IXI,IYI))
  104   CONTINUE
C
  105 CONTINUE
C
C Done.
C
        RETURN
C
      END

C
C $Id: dpdsym.f,v 1.4 2008-07-27 00:16:58 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE DPDSYM (XPSW,YPSW,CSYM,WOSW,ANGD)
C
        CHARACTER*1 CSYM
C
C This routine is called by DPDRAW to draw a symbol at the point
C (XPSW,YPSW) in the world coordinate system.  The symbol to be
C drawn is the one associated with the character CSYM.  Its width
C is to be WOSW, in the world coordinate system, and it is to be
C written at the angle ANGD, in degrees measured counterclockwise
C from a horizontal vector pointing to the right.
C
C Declare coordinate arrays in which to define the mark.
C
        DIMENSION XCRA(37),YCRA(37)
C
C Define a multiplicative constant to convert from degrees to radians.
C
        DATA DTOR / .017453292519943 /
C
C Compute the coordinates of the point defining the mark.  The curious
C constants used in some of this code are intended to make each symbol
C have the same area as that of a circle symbol.
C
        IF (CSYM.EQ.'0'.OR.CSYM.EQ.'5') THEN
C
C The mark is a circle.
C
          DO 101 I=1,37
            ANGR=DTOR*(REAL(I-1)*10.)
            XCRA(I)=XPSW+(WOSW/2.)*COS(ANGR)
            YCRA(I)=YPSW+(WOSW/2.)*SIN(ANGR)
  101     CONTINUE
C
          NCRA=37
C
        ELSE IF (CSYM.EQ.'1'.OR.CSYM.EQ.'6') THEN
C
C The mark is a square.
C
          DO 102 I=1,5
            ANGR=DTOR*(ANGD+45.+REAL(I-1)*90.)
            XCRA(I)=XPSW+1.25331*(WOSW/2.)*COS(ANGR)
            YCRA(I)=YPSW+1.25331*(WOSW/2.)*SIN(ANGR)
  102     CONTINUE
C
          NCRA=5
C
        ELSE IF (CSYM.EQ.'2'.OR.CSYM.EQ.'7') THEN
C
C The mark is a triangle.
C
          DO 103 I=1,4
            ANGR=DTOR*(ANGD+90.+REAL(I-1)*120.)
            XCRA(I)=XPSW+1.55512*(WOSW/2.)*COS(ANGR)
            YCRA(I)=YPSW+1.55512*(WOSW/2.)*SIN(ANGR)
  103     CONTINUE
C
          NCRA=4
C
        ELSE IF (CSYM.EQ.'3'.OR.CSYM.EQ.'8') THEN
C
C The mark is a diamond.
C
          DO 104 I=1,5
            ANGR=DTOR*(ANGD+REAL(I-1)*90.)
            XCRA(I)=XPSW+1.25331*(WOSW/2.)*COS(ANGR)
            YCRA(I)=YPSW+1.25331*(WOSW/2.)*SIN(ANGR)
  104     CONTINUE
C
          NCRA=5
C
        ELSE IF (CSYM.EQ.'4'.OR.CSYM.EQ.'9') THEN
C
C The mark is a star.
C
          DO 105 I=1,11
            ANGR=DTOR*(ANGD+18.+REAL(I-1)*36.)
            IF (MOD(I,2).EQ.0) THEN
              RADI=.381966
            ELSE
              RADI=1.
            END IF
            XCRA(I)=XPSW+1.67289*RADI*(WOSW/2.)*COS(ANGR)
            YCRA(I)=YPSW+1.67289*RADI*(WOSW/2.)*SIN(ANGR)
  105     CONTINUE
C
          NCRA=11

        END IF
C
C Fill or outline the mark.
C
        IF (CSYM.GE.'0'.AND.CSYM.LE.'4') THEN
          CALL GFA (NCRA,XCRA,YCRA)
        ELSE IF (CSYM.GE.'5'.AND.CSYM.LE.'9') THEN
          CALL GPL (NCRA,XCRA,YCRA)
        END IF
C
C Done.
C
        RETURN
C
      END

C
C $Id: gabldt.f,v 1.9 2008-07-27 00:17:13 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GABLDT
C
C Calling this do-nothing subroutine forces "ld" to load the following
C block data routine (but only if they are in the same ".f" file).
C
        RETURN
C
      END
CNOSPLIT
      BLOCKDATA GABLDTX
C
C This "routine" declares default values for all of the GRIDAL
C parameters.
C
C Declare the common block containing real and integer parameters.
C
        COMMON /GAREIN/ ICAX,ICLB,ICMJ,ICMN,ILTY,IORX,NCFX,NCFY,RCWX,
     +                  RCWY,RDCX,RDCY,RMJX,RMJY,RMNX,RMNY,RWAX,RWLB,
     +                  RWMJ,RWMN
        SAVE   /GAREIN/
C
C Declare the common block containing character parameters.
C
        COMMON /GACHAR/ FNLX,FNLY
        CHARACTER*10    FNLX,FNLY
        SAVE   /GACHAR/
C
C Declare default values:
C
C FNLX is the format to be used to generate numeric labels for the X
C axis.
C
        DATA FNLX / '(E10.3)' /
C
C FNLY is the format to be used to generate numeric labels for the Y
C axis.
C
        DATA FNLY / '(E10.3)' /
C
C ICAX, ICLB, ICMJ, and ICMN are color indices for axes, labels, major
C grid line/ticks, and minor grid lines/ticks, respectively.  Values
C which are less than zero imply that no color is to be forced for the
C associated item.
C
        DATA ICAX,ICLB,ICMJ,ICMN / -1,-1,-1,-1 /
C
C ILTY says what type of labels are to be written.  The value 0 says
C that WTSTR is to be called, the value 1 that PLCHHQ is to be called,
C and the value 2 that GAPLCH is to be called (which preprocesses the
C numeric string to force the use of superscript exponents and then
C calls PLCHHQ).
C
        DATA ILTY / 0 /
C
C IORX is the orientation of the labels on the X axis.  The value 0
C means "horizontal", any other value "vertical".
C
        DATA IORX / 0 /
C
C NCFX is the length (number of characters) to be assumed in positioning
C X-axis labels.  The value 0 indicates that the non-blank portion of
C each label should be located and positioned independently of the rest
C of the labels.
C
        DATA NCFX / 0 /
C
C NCFY is the length (number of characters) to be assumed in positioning
C Y-axis labels.  The value 0 indicates that the non-blank portion of
C each label should be located and positioned independently of the rest
C of the labels.
C
        DATA NCFY / 0 /
C
C RCWX is the character width for characters in labels on the X axis.
C
        DATA RCWX / 10. /
C
C RCWY is the character width for characters in labels on the Y axis.
C
        DATA RCWY / 10. /
C
C RDCX is the decrement, in the X direction, from the left edge of
C the grid (or from the vertical axis) to the nearest edge of the
C Y-axis labels.
C
        DATA RDCX / 20. /
C
C RDCY is the decrement, in the Y direction, from the bottom edge of
C the grid (or from the horizontal axis) to the nearest edge of the
C X-axis labels.
C
        DATA RDCY / 20. /
C
C RMJX is the length of major ticks on the X axis.
C
        DATA RMJX / 12. /
C
C RMJY is the length of major ticks on the Y axis.
C
        DATA RMJY / 12. /
C
C RMNX is the length of minor ticks on the X axis.
C
        DATA RMNX / 8. /
C
C RMNY is the length of minor ticks on the Y axis.
C
        DATA RMNY / 8. /
C
C RWAX, RWLB, RWMJ, and RWMN are line widths for axes, labels, major
C grid line/ticks, and minor grid lines/ticks, respectively.  Values
C which are less than or equal to zero imply that no line width is to
C be forced for the associated item.
C
        DATA RWAX,RWLB,RWMJ,RWMN / 0.,0.,0.,0. /
C
      END

C
C $Id: gaseti.f,v 1.6.8.1 2010-03-17 20:51:57 brownrig Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GASETI (PNAM,IVAL)
C
        CHARACTER*(*) PNAM
        INTEGER IVAL
C
C The subroutine GASETI may be used to set GRIDAL parameters which have
C values of type INTEGER.
C
C Declare the common block containing real and integer parameters.
C
        COMMON /GAREIN/ ICAX,ICLB,ICMJ,ICMN,ILTY,IORX,NCFX,NCFY,RCWX,
     +                  RCWY,RDCX,RDCY,RMJX,RMJY,RMNX,RMNY,RWAX,RWLB,
     +                  RWMJ,RWMN
        SAVE   /GAREIN/
C --------------------------------------------------------
C RLB 3/2010: Previously the integer parameter was converted to a float
C   and the work was delegated off to GASETR. This provided a sort
C   of "automatic type conversion", allowing the user to set a real
C   parameter using either gaseti() or gasetr(), as in:
C        CALL GASETI ('xxx',-9999)
C     or
C        CALL GASETR ('xxx',-9999.0)
C
C   Color-indices are now either encoded RGBa values, or indices as
C   before. RGBa values are typically large integer values, beyond the
C   precision of floats, and thus this delegation scheme no longer
C   works correctly. The code has been refactored such that the integer
C   cases are now handled directly herein. If no action is found for
C   the PNAM, then we delegate over to GASETR.
C -------------------------------------------------------
C
C Do a call forcing a BLOCKDATA to be loaded from a binary library.
C
        CALL GABLDT
C
C Check for an uncleared prior error.
C
        IF (ICFELL('GASETI - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C Set the selected parameter.
C
        IF      (PNAM(1:3).EQ.'CAX'.OR.PNAM(1:3).EQ.'cax') THEN
          ICAX=IVAL
        ELSE IF (PNAM(1:3).EQ.'CLB'.OR.PNAM(1:3).EQ.'clb') THEN
          ICLB=IVAL
        ELSE IF (PNAM(1:3).EQ.'CMJ'.OR.PNAM(1:3).EQ.'cmj') THEN
          ICMJ=IVAL
        ELSE IF (PNAM(1:3).EQ.'CMN'.OR.PNAM(1:3).EQ.'cmn') THEN
          ICMN=IVAL
        ELSE IF (PNAM(1:3).EQ.'LTY'.OR.PNAM(1:3).EQ.'lty') THEN
          ILTY=MAX(0,MIN(2,IVAL))
        ELSE IF (PNAM(1:3).EQ.'XLL'.OR.PNAM(1:3).EQ.'xll') THEN
          NCFX=IVAL
        ELSE IF (PNAM(1:3).EQ.'XOR'.OR.PNAM(1:3).EQ.'xor') THEN
          IORX=IVAL
        ELSE IF (PNAM(1:3).EQ.'YLL'.OR.PNAM(1:3).EQ.'yll') THEN
          NCFY=IVAL
        ELSE
C         Delegate the call to GASETR.
          CALL GASETR (PNAM,REAL(IVAL))
          IF (ICFELL('GASETI',2).NE.0) RETURN
        END IF
C
C Done.
C
        RETURN
C
      END

C
C	$Id: cfvld.f,v 1.6 2008-07-27 00:23:03 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CFVLD (IENTRY,IIX,IIY)
C
C CFVLD CONNECTS POINTS WHOSE COORDINATES ARE SUPPLIED IN THE ARGUMENTS,
C ACCORDING TO THE DASH PATTERN WHICH IS PASSED FROM ROUTINE DASHDB
C OR DASHDC IN THE COMMON-BLOCK DASHD1.
C
      CHARACTER*16  IPC(100)
C
      COMMON/INTPR/IPAU,FPART,TENSN,NP,SMALL,L1,ADDLR,ADDTB,MLLINE,
     1    ICLOSE
C
C THE VARIABLES IN DASHD1 AND DASHD2 ARE USED FOR COMMUNICATION WITH
C DASHDC AND DASHDB.
C
      COMMON /DASHD1/  ISL,  L,  ISIZE,  IP(100),  NWDSM1,  IPFLAG(100)
     1                 ,MNCSTR, IGP
      COMMON /DASHD2/  IPC
C
C THE VARIABLES IN DSAVE1 HAVE TO BE SAVED FOR THE NEXT CALL TO CFVLD.
C
      COMMON /DSAVE1/ X,Y,X2,Y2,X3,Y3,M,BTI,IB,IX,IY
C
C THE FLAGS IFSTFL AND IVCTFG ARE INITIALIZED IN THE BLOCK DATA DASHBDX.
C IFSTFL CONTROLS THAT FRSTD IS CALLED BEFORE VECTD IS CALLED.
C IVCTFG IS A FLAG TO INDICATE IF CFVLD IS BEING CALLED FROM VECTD OR
C LASTD.
C
      COMMON /DCFLAG/ IFSTFL
      COMMON /CFFLAG/ IVCTFG
      SAVE
C
C
C CMN IS USED TO DETERMINE WHEN TO STOP DRAWING A LINE SEGMENT
C
      DATA CMN/1.5/
C
C IMPOS IS USED AS AN IMPOSSIBLE PEN POSITION.
C
      DATA IMPOS /-9999/
C
C
C  ISL= -1  ALL BLANK  ) FLAG TO AVOID MOST CALCULATIONS
C        0  DASHED     )   IF PATTERN IS ALL SOLID OR
C        1  ALL SOLID  )   ALL BLANK
C
C     X,IX,Y,IY    CURRENT POSITION
C     X1,Y1        START OF A USER LINE SEGMENT
C     X2,Y2        END OF A USER LINE SEGMENT
C     X3,Y3        START OF A GAP PATTERN SEGMENT
C
C  SYMBOLS,IF PRESENT ARE CENTERED IN AN IMMEDIATLY PRECEEDING
C     GAP SEGMENT, OR DONE AT THE CURRENT POSITION OTHERWISE
C
C  SEGMENT TYPES ARE RECOGNIZED AS FOLLOWS
C     SOLID - WORD IN IP-ARRAY CONTAINS POSITIVE INTEGER, CORRESPONDING
C             ELEMENT IN IPFLAG IS 1.
C     GAP - WORD IN IP-ARRAY CONTAINS POSITIVE INTEGER, CORRESPONDING
C             ELEMENT IN IPFLAG IS -1.
C     SYMBOL - WORD IN IP-ARRAY CONTAINS CHARACTER REPRESENTATIONS.
C             CORRESPONDING ELEMENT IN IPFLAG IS 0.
C             SYMBOL COUNT FOR CHAR STRING IN CHAR NUMBER MNCSTR+1.
C     THE IP ARRAY AND THE IPFLAG ARRAY ARE COMPOSED OF L ELEMENTS.
C
C     BTI - BITS THIS INCREMENT
C     BPBX,BPBY BITS PER BIT X(Y)
C
C
C BRANCH DEPENDING ON FUNCTION TO BE PERFORMED.
C
      GO TO (330,305,350),IENTRY
C
C INITIALIZE VARIABLES (ENTRY FRSTD ONLY)
C
   30 CONTINUE
      X = IX
      Y = IY
      X2 = X
      X3 = X
      Y2 = Y
      Y3 = Y
      M = 1
      IB = IPFLAG(1)
      IF (IPFLAG(1) .NE. 0) GO TO 40
      IB = 0
      BTI = 0
   40 CONTINUE
      BTI = REAL(IP(1))*FPART
      GO TO 300
C
C MAIN LOOP START
C
   50 CONTINUE
         X1 = X2
         Y1 = Y2
         MX = IIX
         MY = IIY
         X2 = MX
         Y2 = MY
         DX = X2-X1
         DY = Y2-Y1
         D = SQRT(DX*DX+DY*DY)
         IF (D .LT. CMN) GO TO 190
   60    BPBX = DX/D
         BPBY = DY/D
         CALL DRAWPV (IX,IY,0)
   70    BTI = BTI-D
         IF (BTI) 100,100,80
C
C LINE SEGMENT WILL FIT IN CURRENT PATTERN ELEMENT
C
   80    X = X2
         Y = Y2
         IX = X2
         IY = Y2
         IF (IB) 200,160,90
   90    CALL DRAWPV (IX,IY,1)
         GO TO 200
C
C LINE SEGMENT WONT FIT IN CURRENT PATTERN ELEMENT
C DO IT TO END OF ELEMENT, SAVE HOW MUCH OF SEGMENT LEFT TO DO (D)
C
  100    BTI = BTI+D
         D = D-BTI
         X = X+BPBX*BTI
         Y = Y+BPBY*BTI
         IX = X+.5
         IY = Y+.5
         IF (IB) 110,160,120
  110    CALL DRAWPV (IX,IY,0)
         GO TO 130
  120    CALL DRAWPV (IX,IY,1)
C
C GET THE NEXT PATTERN ELEMENT
C
  130    M = MOD(M,L)+1
         IB = IPFLAG(M)
         IF (IB) 140,160,150
  140    X3 = X
         Y3 = Y
         BTI = REAL(IP(M))
         GO TO 70
  150    X3 = -1.
         BTI = REAL(IP(M))
         GO TO 70
C
C CHARACTER GENERATION
C
  160    S = 0.
         IF (IGP .NE. 9) GO TO 162
C
         DX = X-X3
         DY = Y-Y3
         GO TO 164
C
  162    CONTINUE
         DX = X - X1
         DY = Y - Y1
  164    CONTINUE
C
         IF (DY) 170,180,170
  170    S = ATAN2(DY,DX)
         IF (ABS(S-.00005) .GT. 1.5708) S = S-SIGN(3.14159,S)
  180    IF (IGP .NE. 9) GO TO 182
C
         MX = X3 + DX*.5
         MY = Y3 + DY*.5
         LIGP = 0
         GO TO 184
C
  182    CONTINUE
         MX = X
         MY = Y
         LIGP = 1
C
  184    CONTINUE
         IS = INT(S*180./3.14 + .5)
         IF (IS .LT. 0) IS = 360+IS
         CALL GETUSV('XF',LXSAVE)
         CALL GETUSV('YF',LYSAVE)
         MX = ISHIFT (MX,LXSAVE-15)
         MY = ISHIFT(MY,LYSAVE-15)
         CALL WTSTR(CPUX(MX),CPUY(MY),IPC(M)(1:IP(M)),ISIZE,IS,LIGP)
         CALL DRAWPV (IMPOS,IMPOS,2)
         CALL DRAWPV (IX,IY,0)
         GO TO 130
  190    X2 = X1
         Y2 = Y1
  200 CONTINUE
C
C EXIT IF CALL WAS TO VECTD.
C
      IF (IVCTFG .NE. 2) GO TO 210
      IVCTFG = 1
      GO TO 300
C
C EXIT IF NOT PLOTTING A GAP
C
  210 IF (IB .GE. 0) GO TO 300
C
C MUST BE IN A GAP AT END OF LASTD. EXIT IF NOT A LABEL GAP.
C
      MO = M
      M = MOD(M,L) + 1
      IF (IPFLAG(M) .NE. 0) GO TO 300
C
C CHECK PREVIOUS PLOTTED ELEMENT. WAS IT A GAP OR A LINE.
C
      MPREV = M - 2
      IF (MPREV .LE. 0) MPREV = MPREV + L
      IB = IPFLAG(MPREV)
      IF (IB .GE. 0) GO TO 250
C
C PREVIOUS ELEMENT WAS A GAP - LOOK FOR NEXT LINE.
C EXIT IF NO LINES IN PATTERN.
C
  230 CONTINUE
  240 M = MOD(M,L)+1
      IF (M .EQ. MO) GO TO 300
      IB = IPFLAG(M)
      IF (IB .EQ. 0) GOTO 245
      BTI = REAL(IP(M))
  245 CONTINUE
C
C IF IP(M) NOT A LINE, CONTINUE LOOKING.
C
      IF (IB) 240,230,280
C
C PREVIOUS ELEMENT WAS A LINE - LOOK FOR NEXT GAP.
C IF NO NON-LABEL GAPS IN PATTERN, GO TO 290.
C
  250 CONTINUE
  260 M = MOD(M,L)+1
      IF (M .EQ. MO) GO TO 290
      IB = IPFLAG(M)
      IF (IB .EQ. 0) GOTO 265
      BTI = REAL(IP(M))
  265 CONTINUE
C
C IF IP(M) NOT A GAP, CONTINUE LOOKING.
C
      IF (IB) 270,250,260
C
C FOUND A GAP. IF ITS A LABEL GAP, GO LOOK FOR NEXT GAP.
C
  270 MT = M
      M = MOD(M,L)+1
      IF (IPFLAG(M) .EQ. 0) GO TO 250
      M = MT
C
C M POINTS TO NEXT ELEMENT TO PLOT. SET UP AND GO PLOT.
C
  280 X1 = X3
      Y1 = Y3
      X = X3
      Y = Y3
      IX = X+0.5
      IY = Y+0.5
      DX = X2-X1
      DY = Y2-Y1
      D = SQRT(DX*DX+DY*DY)
      IF (D .GE. CMN) GO TO 60
      GO TO 300
C
C NO NON-LABEL GAPS IN THE PATTERN - FILL IN WITH SOLID LINE.
C
  290 IX = X3+0.5
      IY = Y3+0.5
      CALL DRAWPV (IX,IY,0)
      IX = X2
      IY = Y2
      CALL DRAWPV (IX,IY,1)
  300 RETURN
C
C *************************************
C
C ENTRY VECTD (XX,YY)
C
  305 CONTINUE
C
C TEST FOR PREVIOUS CALL TO FRSTD.
C
      IF (IFSTFL .EQ. 2) GO TO 310
C
C INFORM USER - NO PREVIOUS CALL TO FRSTD. TREAT CALL AS FRSTD CALL.
C
      CALL SETER ('CFVLD -- VECTD CALL OCCURS BEFORE A CALL TO FRSTD.',
     -             1,1)
      GO TO 330
  310 K = 1
      IVCTFG = 2
      IF (ISL) 300,50,320
  320 IX = IIX
      IY = IIY
      CALL DRAWPV (IX,IY,1)
      GO TO 300
C
C *************************************
C
C     ENTRY FRSTD (FLDX,FLDY)
C
  330 IX = IIX
      IY = IIY
      IFSTFL = 2
C AVOID UNEXPECTED PEN POSITION IF CALLS TO SYSTEM PLOT PACKAGE
C ROUTINES WERE MADE.
      CALL DRAWPV (IMPOS,IMPOS,2)
      IF (ISL) 300,30,340
  340 CALL DRAWPV (IX,IY,0)
      GO TO 300
C
C *************************************
C
C     ENTRY LASTD
C
  350 CONTINUE
C
C TEST FOR PREVIOUS CALL TO FRSTD
C
      IF (IFSTFL .NE. 2) GO TO 300
      IFSTFL = 1
      K = 1
      IF (ISL .NE. 0) GO TO 300
      GO TO 210
      END

      SUBROUTINE ZLAHQR( WANTT, WANTZ, N, ILO, IHI, H, LDH, W, ILOZ,
     $                   IHIZ, Z, LDZ, INFO )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      LOGICAL            WANTT, WANTZ
      INTEGER            IHI, IHIZ, ILO, ILOZ, INFO, LDH, LDZ, N
*     ..
*     .. Array Arguments ..
      COMPLEX*16         H( LDH, * ), W( * ), Z( LDZ, * )
*     ..
*
*  Purpose
*  =======
*
*  ZLAHQR is an auxiliary routine called by ZHSEQR to update the
*  eigenvalues and Schur decomposition already computed by ZHSEQR, by
*  dealing with the Hessenberg submatrix in rows and columns ILO to IHI.
*
*  Arguments
*  =========
*
*  WANTT   (input) LOGICAL
*          = .TRUE. : the full Schur form T is required;
*          = .FALSE.: only eigenvalues are required.
*
*  WANTZ   (input) LOGICAL
*          = .TRUE. : the matrix of Schur vectors Z is required;
*          = .FALSE.: Schur vectors are not required.
*
*  N       (input) INTEGER
*          The order of the matrix H.  N >= 0.
*
*  ILO     (input) INTEGER
*  IHI     (input) INTEGER
*          It is assumed that H is already upper triangular in rows and
*          columns IHI+1:N, and that H(ILO,ILO-1) = 0 (unless ILO = 1).
*          ZLAHQR works primarily with the Hessenberg submatrix in rows
*          and columns ILO to IHI, but applies transformations to all of
*          H if WANTT is .TRUE..
*          1 <= ILO <= max(1,IHI); IHI <= N.
*
*  H       (input/output) COMPLEX*16 array, dimension (LDH,N)
*          On entry, the upper Hessenberg matrix H.
*          On exit, if WANTT is .TRUE., H is upper triangular in rows
*          and columns ILO:IHI, with any 2-by-2 diagonal blocks in
*          standard form. If WANTT is .FALSE., the contents of H are
*          unspecified on exit.
*
*  LDH     (input) INTEGER
*          The leading dimension of the array H. LDH >= max(1,N).
*
*  W       (output) COMPLEX*16 array, dimension (N)
*          The computed eigenvalues ILO to IHI are stored in the
*          corresponding elements of W. If WANTT is .TRUE., the
*          eigenvalues are stored in the same order as on the diagonal
*          of the Schur form returned in H, with W(i) = H(i,i).
*
*  ILOZ    (input) INTEGER
*  IHIZ    (input) INTEGER
*          Specify the rows of Z to which transformations must be
*          applied if WANTZ is .TRUE..
*          1 <= ILOZ <= ILO; IHI <= IHIZ <= N.
*
*  Z       (input/output) COMPLEX*16 array, dimension (LDZ,N)
*          If WANTZ is .TRUE., on entry Z must contain the current
*          matrix Z of transformations accumulated by ZHSEQR, and on
*          exit Z has been updated; transformations are applied only to
*          the submatrix Z(ILOZ:IHIZ,ILO:IHI).
*          If WANTZ is .FALSE., Z is not referenced.
*
*  LDZ     (input) INTEGER
*          The leading dimension of the array Z. LDZ >= max(1,N).
*
*  INFO    (output) INTEGER
*          = 0: successful exit
*          > 0: if INFO = i, ZLAHQR failed to compute all the
*               eigenvalues ILO to IHI in a total of 30*(IHI-ILO+1)
*               iterations; elements i+1:ihi of W contain those
*               eigenvalues which have been successfully computed.
*
*  =====================================================================
*
*     .. Parameters ..
      COMPLEX*16         ZERO, ONE
      PARAMETER          ( ZERO = ( 0.0D+0, 0.0D+0 ),
     $                   ONE = ( 1.0D+0, 0.0D+0 ) )
      DOUBLE PRECISION   RZERO, HALF
      PARAMETER          ( RZERO = 0.0D+0, HALF = 0.5D+0 )
      DOUBLE PRECISION   DAT1
      PARAMETER          ( DAT1 = 0.75D+0 )
*     ..
*     .. Local Scalars ..
      INTEGER            I, I1, I2, ITN, ITS, J, K, L, M, NH, NZ
      DOUBLE PRECISION   H10, H21, RTEMP, S, SMLNUM, T2, TST1, ULP
      COMPLEX*16         CDUM, H11, H11S, H22, SUM, T, T1, TEMP, U, V2,
     $                   X, Y
*     ..
*     .. Local Arrays ..
      DOUBLE PRECISION   RWORK( 1 )
      COMPLEX*16         V( 2 )
*     ..
*     .. External Functions ..
      DOUBLE PRECISION   DLAMCH, ZLANHS
      COMPLEX*16         ZLADIV
      EXTERNAL           DLAMCH, ZLANHS, ZLADIV
*     ..
*     .. External Subroutines ..
      EXTERNAL           ZCOPY, ZLARFG, ZSCAL
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, DBLE, DCONJG, DIMAG, MAX, MIN, SQRT
*     ..
*     .. Statement Functions ..
      DOUBLE PRECISION   CABS1
*     ..
*     .. Statement Function definitions ..
      CABS1( CDUM ) = ABS( DBLE( CDUM ) ) + ABS( DIMAG( CDUM ) )
*     ..
*     .. Executable Statements ..
*
      INFO = 0
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
      IF( ILO.EQ.IHI ) THEN
         W( ILO ) = H( ILO, ILO )
         RETURN
      END IF
*
      NH = IHI - ILO + 1
      NZ = IHIZ - ILOZ + 1
*
*     Set machine-dependent constants for the stopping criterion.
*     If norm(H) <= sqrt(OVFL), overflow should not occur.
*
      ULP = DLAMCH( 'Precision' )
      SMLNUM = DLAMCH( 'Safe minimum' ) / ULP
*
*     I1 and I2 are the indices of the first row and last column of H
*     to which transformations must be applied. If eigenvalues only are
*     being computed, I1 and I2 are set inside the main loop.
*
      IF( WANTT ) THEN
         I1 = 1
         I2 = N
      END IF
*
*     ITN is the total number of QR iterations allowed.
*
      ITN = 30*NH
*
*     The main loop begins here. I is the loop index and decreases from
*     IHI to ILO in steps of 1. Each iteration of the loop works
*     with the active submatrix in rows and columns L to I.
*     Eigenvalues I+1 to IHI have already converged. Either L = ILO, or
*     H(L,L-1) is negligible so that the matrix splits.
*
      I = IHI
   10 CONTINUE
      IF( I.LT.ILO )
     $   GO TO 130
*
*     Perform QR iterations on rows and columns ILO to I until a
*     submatrix of order 1 splits off at the bottom because a
*     subdiagonal element has become negligible.
*
      L = ILO
      DO 110 ITS = 0, ITN
*
*        Look for a single small subdiagonal element.
*
         DO 20 K = I, L + 1, -1
            TST1 = CABS1( H( K-1, K-1 ) ) + CABS1( H( K, K ) )
            IF( TST1.EQ.RZERO )
     $         TST1 = ZLANHS( '1', I-L+1, H( L, L ), LDH, RWORK )
            IF( ABS( DBLE( H( K, K-1 ) ) ).LE.MAX( ULP*TST1, SMLNUM ) )
     $         GO TO 30
   20    CONTINUE
   30    CONTINUE
         L = K
         IF( L.GT.ILO ) THEN
*
*           H(L,L-1) is negligible
*
            H( L, L-1 ) = ZERO
         END IF
*
*        Exit from loop if a submatrix of order 1 has split off.
*
         IF( L.GE.I )
     $      GO TO 120
*
*        Now the active submatrix is in rows and columns L to I. If
*        eigenvalues only are being computed, only the active submatrix
*        need be transformed.
*
         IF( .NOT.WANTT ) THEN
            I1 = L
            I2 = I
         END IF
*
         IF( ITS.EQ.10 .OR. ITS.EQ.20 ) THEN
*
*           Exceptional shift.
*
            S = DAT1*ABS( DBLE( H( I, I-1 ) ) )
            T = S + H( I, I )
         ELSE
*
*           Wilkinson's shift.
*
            T = H( I, I )
            U = H( I-1, I )*DBLE( H( I, I-1 ) )
            IF( U.NE.ZERO ) THEN
               X = HALF*( H( I-1, I-1 )-T )
               Y = SQRT( X*X+U )
               IF( DBLE( X )*DBLE( Y )+DIMAG( X )*DIMAG( Y ).LT.RZERO )
     $            Y = -Y
               T = T - ZLADIV( U, ( X+Y ) )
            END IF
         END IF
*
*        Look for two consecutive small subdiagonal elements.
*
         DO 40 M = I - 1, L + 1, -1
*
*           Determine the effect of starting the single-shift QR
*           iteration at row M, and see if this would make H(M,M-1)
*           negligible.
*
            H11 = H( M, M )
            H22 = H( M+1, M+1 )
            H11S = H11 - T
            H21 = H( M+1, M )
            S = CABS1( H11S ) + ABS( H21 )
            H11S = H11S / S
            H21 = H21 / S
            V( 1 ) = H11S
            V( 2 ) = H21
            H10 = H( M, M-1 )
            TST1 = CABS1( H11S )*( CABS1( H11 )+CABS1( H22 ) )
            IF( ABS( H10*H21 ).LE.ULP*TST1 )
     $         GO TO 50
   40    CONTINUE
         H11 = H( L, L )
         H22 = H( L+1, L+1 )
         H11S = H11 - T
         H21 = H( L+1, L )
         S = CABS1( H11S ) + ABS( H21 )
         H11S = H11S / S
         H21 = H21 / S
         V( 1 ) = H11S
         V( 2 ) = H21
   50    CONTINUE
*
*        Single-shift QR step
*
         DO 100 K = M, I - 1
*
*           The first iteration of this loop determines a reflection G
*           from the vector V and applies it from left and right to H,
*           thus creating a nonzero bulge below the subdiagonal.
*
*           Each subsequent iteration determines a reflection G to
*           restore the Hessenberg form in the (K-1)th column, and thus
*           chases the bulge one step toward the bottom of the active
*           submatrix.
*
*           V(2) is always real before the call to ZLARFG, and hence
*           after the call T2 ( = T1*V(2) ) is also real.
*
            IF( K.GT.M )
     $         CALL ZCOPY( 2, H( K, K-1 ), 1, V, 1 )
            CALL ZLARFG( 2, V( 1 ), V( 2 ), 1, T1 )
            IF( K.GT.M ) THEN
               H( K, K-1 ) = V( 1 )
               H( K+1, K-1 ) = ZERO
            END IF
            V2 = V( 2 )
            T2 = DBLE( T1*V2 )
*
*           Apply G from the left to transform the rows of the matrix
*           in columns K to I2.
*
            DO 60 J = K, I2
               SUM = DCONJG( T1 )*H( K, J ) + T2*H( K+1, J )
               H( K, J ) = H( K, J ) - SUM
               H( K+1, J ) = H( K+1, J ) - SUM*V2
   60       CONTINUE
*
*           Apply G from the right to transform the columns of the
*           matrix in rows I1 to min(K+2,I).
*
            DO 70 J = I1, MIN( K+2, I )
               SUM = T1*H( J, K ) + T2*H( J, K+1 )
               H( J, K ) = H( J, K ) - SUM
               H( J, K+1 ) = H( J, K+1 ) - SUM*DCONJG( V2 )
   70       CONTINUE
*
            IF( WANTZ ) THEN
*
*              Accumulate transformations in the matrix Z
*
               DO 80 J = ILOZ, IHIZ
                  SUM = T1*Z( J, K ) + T2*Z( J, K+1 )
                  Z( J, K ) = Z( J, K ) - SUM
                  Z( J, K+1 ) = Z( J, K+1 ) - SUM*DCONJG( V2 )
   80          CONTINUE
            END IF
*
            IF( K.EQ.M .AND. M.GT.L ) THEN
*
*              If the QR step was started at row M > L because two
*              consecutive small subdiagonals were found, then extra
*              scaling must be performed to ensure that H(M,M-1) remains
*              real.
*
               TEMP = ONE - T1
               TEMP = TEMP / ABS( TEMP )
               H( M+1, M ) = H( M+1, M )*DCONJG( TEMP )
               IF( M+2.LE.I )
     $            H( M+2, M+1 ) = H( M+2, M+1 )*TEMP
               DO 90 J = M, I
                  IF( J.NE.M+1 ) THEN
                     IF( I2.GT.J )
     $                  CALL ZSCAL( I2-J, TEMP, H( J, J+1 ), LDH )
                     CALL ZSCAL( J-I1, DCONJG( TEMP ), H( I1, J ), 1 )
                     IF( WANTZ ) THEN
                        CALL ZSCAL( NZ, DCONJG( TEMP ), Z( ILOZ, J ),
     $                              1 )
                     END IF
                  END IF
   90          CONTINUE
            END IF
  100    CONTINUE
*
*        Ensure that H(I,I-1) is real.
*
         TEMP = H( I, I-1 )
         IF( DIMAG( TEMP ).NE.RZERO ) THEN
            RTEMP = ABS( TEMP )
            H( I, I-1 ) = RTEMP
            TEMP = TEMP / RTEMP
            IF( I2.GT.I )
     $         CALL ZSCAL( I2-I, DCONJG( TEMP ), H( I, I+1 ), LDH )
            CALL ZSCAL( I-I1, TEMP, H( I1, I ), 1 )
            IF( WANTZ ) THEN
               CALL ZSCAL( NZ, TEMP, Z( ILOZ, I ), 1 )
            END IF
         END IF
*
  110 CONTINUE
*
*     Failure to converge in remaining number of iterations
*
      INFO = I
      RETURN
*
  120 CONTINUE
*
*     H(I,I-1) is negligible: one eigenvalue has converged.
*
      W( I ) = H( I, I )
*
*     Decrement number of remaining iterations, and return to start of
*     the main loop with new value of I.
*
      ITN = ITN - ITS
      I = L - 1
      GO TO 10
*
  130 CONTINUE
      RETURN
*
*     End of ZLAHQR
*
      END

C
C	$Id: ngsetr.f,v 1.7 2008-07-27 00:17:18 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE NGSETR (CNP,RVP)
C
      SAVE
C
      CHARACTER*(*) CNP
C
C  This subroutine is called to give a real value to a specified
C  parameter.
C
C  CNP is the name of the parameter whose value is to be set.
C
C  RVP is a real variable containing the desired value.
C
C  Declare a local character variable in which to form an error message.       
C
      CHARACTER*80 CTM
C
      include 'ngcomn.h'
C
C  Input and output data records for ESCAPE function calls.
C
      CHARACTER*80 IDR,CDUM
C
C  Do a call forcing a BLOCKDATA to be loaded from a binary library.
C
      CALL NGBLDA
C
C  Check for an uncleared prior error.
C
      IF (ICFELL('NGSETR - Uncleared prior error',1) .NE. 0) RETURN
C
C  Check for a parameter name that is too short.
C
      IF (LEN(CNP) .LT. 2) THEN
        CTM(1:36) = 'NGSETR - Parameter name too short - '
        CTM(37:36+LEN(CNP)) = CNP
        CALL SETER (CTM(1:36+LEN(CNP)), 1, 1)
        GO TO 120
      ENDIF
C
C  Set the appropriate parameter.
C
      IDR = ' '
C
C  FI - Spacing of fill area lines (in NDC).
C
      IF (CNP(1:2).EQ.'FI' .OR. CNP(1:2).EQ.'fi' .OR.
     +         CNP(1:2).EQ.'Fi') THEN
        IF (IWKID .LT. 0) THEN
          CTM =
     +      'NGSETR - set a workstation ID using WO before setting FI'
          CALL SETER (CTM(1:60), 2, 1)
          GO TO 120
        ENDIF
        WRITE(IDR(1: 5), 500) IWKID
  500   FORMAT(I5)
        IF (RVP.LE.0. .OR. RVP.GT.1.) THEN
          CALL SETER('NGSETR - invalid value for FI', 3, 1)
          GO TO 120
        ELSE
          FILSPC = RVP
        ENDIF
        WRITE(IDR(7:15), 540) FILSPC
  540   FORMAT(F9.7)
        CALL GESC(-1512,1,IDR,1,IDUM,CDUM)
        GO TO 120
C
C  HA - Spacing of hatch lines (in NDC).
C
      ELSE IF (CNP(1:2).EQ.'HA' .OR. CNP(1:2).EQ.'ha' .OR.
     +         CNP(1:2).EQ.'Ha') THEN
        IF (IWKID .LT. 0) THEN
          CTM =
     +      'NGSETR - set a workstation ID using WO before setting HA'
          CALL SETER (CTM(1:60), 4, 1)
          GO TO 120
        ENDIF
        WRITE(IDR(1: 5), 500) IWKID
        IF (RVP.LE.0. .OR. RVP.GT.1.) THEN
          CALL SETER('NGSETR - invalid value for HA', 5, 1)
          GO TO 120
        ELSE
          HATSPC = RVP
        ENDIF
        WRITE(IDR(7:15), 540) HATSPC
        CALL GESC(-1513,1,IDR,1,IDUM,CDUM)
        GO TO 120
C
C  MI - Miter limit.
C
      ELSE IF (CNP(1:2).EQ.'MI' .OR. CNP(1:2).EQ.'mi' .OR.
     +         CNP(1:2).EQ.'Mi') THEN
        IF (IWKID .LT. 0) THEN
          CTM =
     +      'NGSETR - set a workstation ID using WO before setting MI'
          CALL SETER (CTM(1:60), 6, 1)
          GO TO 120
        ENDIF
        WRITE(IDR(1: 5), 500) IWKID
        RMITER = MAX(1., RVP)
        WRITE(IDR(7:15), 550) RMITER
  550   FORMAT(F9.3)
        CALL GESC(-1520,1,IDR,1,IDUM,CDUM)
        GO TO 120
C
C  OX - X NDC coordinate position for logos.
C
      ELSE IF (CNP(1:2).EQ.'OX' .OR. CNP(1:2).EQ.'ox' .OR.
     +         CNP(1:2).EQ.'Ox') THEN
        OXLOGO = RVP
        GO TO 120
C
C  OY - Y NDC coordinate position for logos.
C
      ELSE IF (CNP(1:2).EQ.'OY' .OR. CNP(1:2).EQ.'oy' .OR.
     +         CNP(1:2).EQ.'Oy') THEN
        OYLOGO = RVP
        GO TO 120
C
C  OS - NDC height specification for logos.
C
      ELSE IF (CNP(1:2).EQ.'OS' .OR. CNP(1:2).EQ.'os' .OR.
     +         CNP(1:2).EQ.'Os') THEN
        OLSIZE = RVP
        GO TO 120
C
C  NO - Nominal linewidth.
C
      ELSE IF (CNP(1:2).EQ.'NO' .OR. CNP(1:2).EQ.'no' .OR.
     +         CNP(1:2).EQ.'No') THEN
        IF (IWKID .LT. 0) THEN
          CTM =
     +      'NGSETR - set a workstation ID using WO before setting NO'
          CALL SETER (CTM(1:60), 7, 1)
          GO TO 120
        ENDIF
        WRITE(IDR(1: 5), 500) IWKID
        RNLSCL = MAX(0., RVP)
        WRITE(IDR(7:15), 550) RNLSCL
        CALL GESC(-1516,1,IDR,1,IDUM,CDUM)
        GO TO 120
C
      ELSE
        CTM(1:36) = 'NGSETR - Parameter name not known - '
        CTM(37:38) = CNP(1:2)
        CALL SETER (CTM(1:38), 8, 1)
        GO TO 120
      ENDIF
C
  120 CONTINUE
      RETURN
      END

C
C $Id: labmod.f,v 1.8 2008-07-27 00:17:14 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE LABMOD (FMTX,FMTY,NUMX,NUMY,ISZX,ISZY,IXDC,IYDC,IXOR)
C
        CHARACTER*(*) FMTX,FMTY
C
C Declare the common block containing real and integer parameters.
C
        COMMON /GAREIN/ ICAX,ICLB,ICMJ,ICMN,ILTY,IORX,NCFX,NCFY,RCWX,
     +                  RCWY,RDCX,RDCY,RMJX,RMJY,RMNX,RMNY,RWAX,RWLB,
     +                  RWMJ,RWMN
        SAVE   /GAREIN/
C
C Declare the common block containing character parameters.
C
        COMMON /GACHAR/ FNLX,FNLY
        CHARACTER*10    FNLX,FNLY
        SAVE   /GACHAR/
C
C Do a call forcing a BLOCKDATA to be loaded from a binary library.
C
        CALL GABLDT
C
C Check for an uncleared prior error.
C
        IF (ICFELL('LABMOD - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C Transfer arguments to GRIDAL's common blocks.
C
        FNLX=FMTX
        FNLY=FMTY
        NCFX=NUMX
        NCFY=NUMY
        RCWX=REAL(ISZX)
        RCWY=REAL(ISZY)
        RDCX=REAL(IXDC)
        RDCY=REAL(IYDC)
        IORX=IXOR
C
C Done.
C
      RETURN
C
      END

C
C	$Id: gwiesc.f,v 1.4 2008-07-27 00:21:07 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GWIESC
C
C  Process ESCAPE elements.
C
      include 'gksin.h'
      include 'gwiins.h'
C
      INTEGER  KALL, NBYTES, G01PBL
      SAVE
      DATA KALL/0/
      KALL = KALL+1
C
C  Treat the first call -- put out the opcode, FCTID, and first data
C  record if there is one.
C
      IF (KALL .EQ. 1) THEN
        IF (STRL1 .GT. 0) THEN
          NBYTES = G01PBL(STRL1,1+(MINTFW-1)/8)
        ELSE
          NBYTES = 2
        ENDIF
C
C  Put out class, id, length
C
        CALL GWPTNI (6, 1, NBYTES, RERR)
        IF (RERR .NE. 0)  RETURN
C
C  Put out function identifier (2-byte integer).
C
        CALL GWPTPR (ID(1),MINTFW,1,RERR)
        IF (RERR .NE. 0)  RETURN
C
C  Put out first data record if there is one.
C
        IF (STRL2 .GT. 0) THEN
          CALL GWPTPS (STR, STRL1, 80, 0, RERR)
          IF (RERR .NE. 0)  RETURN
        ENDIF
C
C  If there is to be no continuation, check for consistency, and
C  reset the parameter "KALL".
C
        IF (CONT .EQ. 0) THEN
          IF (MOD(STRL1,80) .EQ. 0) THEN
            KALL = 0
            RETURN
          ELSE
            RERR = 325
            RETURN
          ENDIF
        ENDIF
      ENDIF
C
C  Treat the continuation calls.
C
      IF (KALL .GT. 1) THEN
        IF (CONT .EQ. 0) THEN
          CALL GWPTPS (STR, 80, 80, 1, RERR)
          IF (RERR .NE. 0)  RETURN
          KALL = 0
        ELSE
          CALL GWPTPS (STR, 80, 80, 1, RERR)
          IF (RERR .NE. 0)  RETURN
        ENDIF
      ENDIF
C
      RETURN
      END

      PROGRAM CMPPOS
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Open GKS.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Turn off the clipping indicator.
C
      CALL GSCLIP (0)
C
C Draw map in lower lefthand corner of the window
C
      CALL MAPPOS (0.5, 1.0, 0.0, 0.5)
      CALL MAPDRW
C
C Draw a perimeter around the viewport
C
      CALL GSELNT(0)
      CALL PLOTIF (0.0,0.0,0)
      CALL PLOTIF (1.0,0.0,1)
      CALL PLOTIF (1.0,1.0,1)
      CALL PLOTIF (0.0,1.0,1)
      CALL PLOTIF (0.0,0.0,1)

      CALL FRAME
C
C Deactivate and close the workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      
      STOP
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C   FFTPACK 5.0
C   Copyright (C) 1995-2004, Scientific Computing Division,
C   University Corporation for Atmospheric Research
C   Licensed under the GNU General Public License (GPL)
C
C   Authors:  Paul N. Swarztrauber and Richard A. Valent
C
C   $Id: cosqf1.f,v 1.2 2006-11-21 01:10:16 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      SUBROUTINE DCOSQF1(N,INC,X,WSAVE,WORK,IER)
      DOUBLE PRECISION X
      DOUBLE PRECISION WSAVE
      DOUBLE PRECISION WORK
      DOUBLE PRECISION XIM1
      DIMENSION X(INC,*),WSAVE(*),WORK(*)

      IER = 0
      NS2 = (N+1)/2
      NP2 = N + 2
      DO 101 K = 2,NS2
          KC = NP2 - K
          WORK(K) = X(1,K) + X(1,KC)
          WORK(KC) = X(1,K) - X(1,KC)
  101 CONTINUE
      MODN = MOD(N,2)
      IF (MODN.NE.0) GO TO 301
      WORK(NS2+1) = X(1,NS2+1) + X(1,NS2+1)
  301 DO 102 K = 2,NS2
          KC = NP2 - K
          X(1,K) = WSAVE(K-1)*WORK(KC) + WSAVE(KC-1)*WORK(K)
          X(1,KC) = WSAVE(K-1)*WORK(K) - WSAVE(KC-1)*WORK(KC)
  102 CONTINUE
      IF (MODN.NE.0) GO TO 303
      X(1,NS2+1) = WSAVE(NS2)*WORK(NS2+1)
  303 LENX = INC* (N-1) + 1
      LNSV = N + INT(LOG(DBLE(N))) + 4
      LNWK = N
C
      CALL DRFFT1F(N,INC,X,LENX,WSAVE(N+1),LNSV,WORK,LNWK,IER1)
      IF (IER1.NE.0) THEN
          IER = 20
          CALL DXERFFT('COSQF1',-5)
          GO TO 400
      END IF
C
      DO 103 I = 3,N,2
          XIM1 = .5D0* (X(1,I-1)+X(1,I))
          X(1,I) = .5D0* (X(1,I-1)-X(1,I))
          X(1,I-1) = XIM1
  103 CONTINUE
  400 RETURN
      END

C
C $Id: pcdchk.f,v 1.11 2008-07-27 00:17:19 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE PCDCHK (IERR)
C
C The subroutine PCDCHK does a short test for correctness of the
C duplex character set.
C
C IERR is an output variable, taking on the following values:
C
C   0 if two short tests of the digitization retrieval process
C     were successful.
C   1 if the test was successful for 12-bit digitization units
C     but not successful for 6-bit digitization units.
C   2 if the test was successful for 6-bit digitization units
C     but not successful for 12-bit digitization units.
C   3 if neither of the two tests was successful.
C
C COMMON block declarations.
C
      COMMON /PCSVEM/ ICOD,IDDA(8625),IDDL,RDGU(7000),IDPC(256),IERU,
     +                INDA(789),INDL,INIT,IVCO,IVDU,NBPW,NPPW
      SAVE   /PCSVEM/
C
C LCPC contains the correct digitization of the character '+'.
C
      DIMENSION LCPC(26)
C
C LCOC contains the correct digitization of the character defined by
C octal number 751.
C
      DIMENSION LCOC(30)
C
C The correct digitization of the character '+'.
C
      DATA LCPC / -12,13,0,-7,0,5,-2048,0,1,5,1,-7,-2048,0,6,-1,-5,-1,
     +            -2048,0,-5,0,6,0,-2048,0 /
C
C The correct digitization of the character defined by the octal number
C 751.
C
      DATA LCOC / -9,9,-5,39,-5,0,-5,-39,-2048,0,-4,39,-4,0,-4,-39,
     +            -2048,0,-5,39,6,39,-2048,0,-5,-39,6,-39,-2048,0 /
C
C Initialize the error flags for the two tests.
C
      IER1=0
      IER2=0
C
C Test 1.  Retrieve the digitization of the character '+' and compare
C it to the correct digitization.
C
      CALL PCEXCD (37,2,NDGU)
C
      IF (NDGU.NE.26) THEN
        IER1=1
      ELSE
        DO 101 I=1,26
          IF (I.GE.4) THEN
            IF (MOD(I,2).EQ.0) THEN
              IF (RDGU(I-1).NE.-2048.) RDGU(I)=RDGU(I)+1.5
            END IF
          END IF
          IF (RDGU(I).NE.REAL(LCPC(I))) THEN
            IER1=1
            GO TO 102
          END IF
  101   CONTINUE
      END IF
C
C Test 2.  Retrieve the digitization of the character with octal number
C 751 and compare it to the correct digitization.
C
  102 CALL PCEXCD (489,2,NDGU)
C
      IF (NDGU.NE.30) THEN
        IER2=2
      ELSE
        DO 103 I=1,30
          IF (I.GE.4) THEN
            IF (MOD(I,2).EQ.0) THEN
              IF (RDGU(I-1).NE.-2048.) RDGU(I)=RDGU(I)+1.5
            END IF
          END IF
          IF (RDGU(I).NE.REAL(LCOC(I))) THEN
            IER1=1
            GO TO 104
          END IF
  103   CONTINUE
      END IF
C
C Total error flag is the sum of the flags from tests 1 and 2.
C
  104 IERR=IER1+IER2
C
C Done.
C
      RETURN
C
      END

C
C $Id: surf1.f,v 1.5 2008-07-27 03:10:12 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
C NOTE: If you make any changes to this software, please remember to
C make the same changes to the corresponding double precision routine.
C
      subroutine surf1 (m,n,x,y,z,iz,zx1,zxm,zy1,zyn,zxy11,
     *                  zxym1,zxy1n,zxymn,islpsw,zp,temp,
     *                  sigma,ierr)
c
      integer m,n,iz,islpsw,ierr
      real x(m),y(n),z(iz,n),zx1(n),zxm(n),zy1(m),zyn(m),
     *     zxy11,zxym1,zxy1n,zxymn,zp(m,n,3),temp(1),sigma
c
c                                 coded by alan kaylor cline
c                           from fitpack -- january 26, 1987
c                        a curve and surface fitting package
c                      a product of pleasant valley software
c                  8603 altus cove, austin, texas 78759, usa
c
c this subroutine determines the parameters necessary to
c compute an interpolatory surface passing through a rect-
c angular grid of functional values. the surface determined
c can be represented as the tensor product of splines under
c tension. the x- and y-partial derivatives around the
c boundary and the x-y-partial derivatives at the four
c corners may be specified or omitted. for actual mapping
c of points onto the surface it is necessary to call the
c function surf2.
c
c on input--
c
c   m is the number of grid lines in the x-direction, i. e.
c   lines parallel to the y-axis (m .ge. 2).
c
c   n is the number of grid lines in the y-direction, i. e.
c   lines parallel to the x-axis (n .ge. 2).
c
c   x is an array of the m x-coordinates of the grid lines
c   in the x-direction. these should be strictly increasing.
c
c   y is an array of the n y-coordinates of the grid lines
c   in the y-direction. these should be strictly increasing.
c
c   z is an array of the m * n functional values at the grid
c   points, i. e. z(i,j) contains the functional value at
c   (x(i),y(j)) for i = 1,...,m and j = 1,...,n.
c
c   iz is the row dimension of the matrix z used in the
c   calling program (iz .ge. m).
c
c   zx1 and zxm are arrays of the m x-partial derivatives
c   of the function along the x(1) and x(m) grid lines,
c   respectively. thus zx1(j) and zxm(j) contain the x-part-
c   ial derivatives at the points (x(1),y(j)) and
c   (x(m),y(j)), respectively, for j = 1,...,n. either of
c   these parameters will be ignored (and approximations
c   supplied internally) if islpsw so indicates.
c
c   zy1 and zyn are arrays of the n y-partial derivatives
c   of the function along the y(1) and y(n) grid lines,
c   respectively. thus zy1(i) and zyn(i) contain the y-part-
c   ial derivatives at the points (x(i),y(1)) and
c   (x(i),y(n)), respectively, for i = 1,...,m. either of
c   these parameters will be ignored (and estimations
c   supplied internally) if islpsw so indicates.
c
c   zxy11, zxym1, zxy1n, and zxymn are the x-y-partial
c   derivatives of the function at the four corners,
c   (x(1),y(1)), (x(m),y(1)), (x(1),y(n)), and (x(m),y(n)),
c   respectively. any of the parameters will be ignored (and
c   estimations supplied internally) if islpsw so indicates.
c
c   islpsw contains a switch indicating which boundary
c   derivative information is user-supplied and which
c   should be estimated by this subroutine. to determine
c   islpsw, let
c        i1 = 0 if zx1 is user-supplied (and = 1 otherwise),
c        i2 = 0 if zxm is user-supplied (and = 1 otherwise),
c        i3 = 0 if zy1 is user-supplied (and = 1 otherwise),
c        i4 = 0 if zyn is user-supplied (and = 1 otherwise),
c        i5 = 0 if zxy11 is user-supplied
c                                       (and = 1 otherwise),
c        i6 = 0 if zxym1 is user-supplied
c                                       (and = 1 otherwise),
c        i7 = 0 if zxy1n is user-supplied
c                                       (and = 1 otherwise),
c        i8 = 0 if zxymn is user-supplied
c                                       (and = 1 otherwise),
c   then islpsw = i1 + 2*i2 + 4*i3 + 8*i4 + 16*i5 + 32*i6
c                   + 64*i7 + 128*i8
c   thus islpsw = 0 indicates all derivative information is
c   user-supplied and islpsw = 255 indicates no derivative
c   information is user-supplied. any value between these
c   limits is valid.
c
c   zp is an array of at least 3*m*n locations.
c
c   temp is an array of at least n+n+m locations which is
c   used for scratch storage.
c
c and
c
c   sigma contains the tension factor. this value indicates
c   the curviness desired. if abs(sigma) is nearly zero
c   (e. g. .001) the resulting surface is approximately the
c   tensor product of cubic splines. if abs(sigma) is large
c   (e. g. 50.) the resulting surface is approximately
c   bi-linear. if sigma equals zero tensor products of
c   cubic splines result. a standard value for sigma is
c   approximately 1. in absolute value.
c
c on output--
c
c   zp contains the values of the xx-, yy-, and xxyy-partial
c   derivatives of the surface at the given nodes.
c
c   ierr contains an error flag,
c        = 0 for normal return,
c        = 1 if n is less than 2 or m is less than 2,
c        = 2 if the x-values or y-values are not strictly
c            increasing.
c
c and
c
c   m, n, x, y, z, iz, zx1, zxm, zy1, zyn, zxy11, zxym1,
c   zxy1n, zxymn, islpsw, and sigma are unaltered.
c
c this subroutine references package modules ceez, terms,
c and snhcsh.
c
c-----------------------------------------------------------
c
      mm1 = m-1
      mp1 = m+1
      nm1 = n-1
      np1 = n+1
      npm = n+m
      ierr = 0
      if (n .le. 1 .or. m .le. 1) go to 46
      if (y(n) .le. y(1)) go to 47
c
c denormalize tension factor in y-direction
c
      sigmay = abs(sigma)*float(n-1)/(y(n)-y(1))
c
c obtain y-partial derivatives along y = y(1)
c
      if ((islpsw/8)*2 .ne. (islpsw/4)) go to 2
      do 1 i = 1,m
    1   zp(i,1,1) = zy1(i)
      go to 5
    2 dely1 = y(2)-y(1)
      dely2 = dely1+dely1
      if (n .gt. 2) dely2 = y(3)-y(1)
      if (dely1 .le. 0. .or. dely2 .le. dely1) go to 47
      call ceez (dely1,dely2,sigmay,c1,c2,c3,n)
      do 3 i = 1,m
    3   zp(i,1,1) = c1*z(i,1)+c2*z(i,2)
      if (n .eq. 2) go to 5
      do 4 i = 1,m
    4   zp(i,1,1) = zp(i,1,1)+c3*z(i,3)
c
c obtain y-partial derivatives along y = y(n)
c
    5 if ((islpsw/16)*2 .ne. (islpsw/8)) go to 7
      do 6 i = 1,m
        npi = n+i
    6   temp(npi) = zyn(i)
      go to 10
    7 delyn = y(n)-y(nm1)
      delynm = delyn+delyn
      if (n .gt. 2) delynm = y(n)-y(n-2)
      if (delyn .le. 0. .or. delynm .le. delyn) go to 47
      call ceez (-delyn,-delynm,sigmay,c1,c2,c3,n)
      do 8 i = 1,m
        npi = n+i
    8   temp(npi) = c1*z(i,n)+c2*z(i,nm1)
      if (n .eq. 2) go to 10
      do 9 i = 1,m
        npi = n+i
    9   temp(npi) = temp(npi)+c3*z(i,n-2)
   10 if (x(m) .le. x(1)) go to 47
c
c denormalize tension factor in x-direction
c
      sigmax = abs(sigma)*float(m-1)/(x(m)-x(1))
c
c obtain x-partial derivatives along x = x(1)
c
      if ((islpsw/2)*2 .ne. islpsw) go to 12
      do 11 j = 1,n
   11   zp(1,j,2) = zx1(j)
      if ((islpsw/32)*2 .eq. (islpsw/16) .and.
     *    (islpsw/128)*2  .eq. (islpsw/64)) go to 15
   12 delx1 = x(2)-x(1)
      delx2 = delx1+delx1
      if (m .gt. 2) delx2 = x(3)-x(1)
      if (delx1 .le. 0. .or. delx2 .le. delx1) go to 47
      call ceez (delx1,delx2,sigmax,c1,c2,c3,m)
      if ((islpsw/2)*2 .eq. islpsw) go to 15
      do 13 j = 1,n
   13   zp(1,j,2) = c1*z(1,j)+c2*z(2,j)
      if (m .eq. 2) go to 15
      do 14 j = 1,n
   14   zp(1,j,2) = zp(1,j,2)+c3*z(3,j)
c
c obtain x-y-partial derivative at (x(1),y(1))
c
   15 if ((islpsw/32)*2 .ne. (islpsw/16)) go to 16
      zp(1,1,3) = zxy11
      go to 17
   16 zp(1,1,3) = c1*zp(1,1,1)+c2*zp(2,1,1)
      if (m .gt. 2) zp(1,1,3) = zp(1,1,3)+c3*zp(3,1,1)
c
c obtain x-y-partial derivative at (x(1),y(n))
c
   17 if ((islpsw/128)*2 .ne. (islpsw/64)) go to 18
      zxy1ns = zxy1n
      go to 19
   18 zxy1ns = c1*temp(n+1)+c2*temp(n+2)
      if (m .gt. 2) zxy1ns = zxy1ns+c3*temp(n+3)
c
c obtain x-partial derivative along x = x(m)
c
   19 if ((islpsw/4)*2 .ne. (islpsw/2)) go to 21
      do 20 j = 1,n
        npmpj = npm+j
   20   temp(npmpj) = zxm(j)
      if ((islpsw/64)*2 .eq. (islpsw/32) .and.
     *    (islpsw/256)*2 .eq. (islpsw/128)) go to 24
   21 delxm = x(m)-x(mm1)
      delxmm = delxm+delxm
      if (m .gt. 2) delxmm = x(m)-x(m-2)
      if (delxm .le. 0. .or. delxmm .le. delxm) go to 47
      call ceez (-delxm,-delxmm,sigmax,c1,c2,c3,m)
      if ((islpsw/4)*2 .eq. (islpsw/2)) go to 24
      do 22 j = 1,n
        npmpj = npm+j
   22   temp(npmpj) = c1*z(m,j)+c2*z(mm1,j)
      if (m .eq. 2) go to 24
      do 23 j = 1,n
        npmpj = npm+j
   23   temp(npmpj) = temp(npmpj)+c3*z(m-2,j)
c
c obtain x-y-partial derivative at (x(m),y(1))
c
   24 if ((islpsw/64)*2 .ne. (islpsw/32)) go to 25
      zp(m,1,3) = zxym1
      go to 26
   25 zp(m,1,3) = c1*zp(m,1,1)+c2*zp(mm1,1,1)
      if (m .gt. 2) zp(m,1,3) = zp(m,1,3)+c3*zp(m-2,1,1)
c
c obtain x-y-partial derivative at (x(m),y(n))
c
   26 if ((islpsw/256)*2 .ne. (islpsw/128)) go to 27
      zxymns = zxymn
      go to 28
   27 zxymns = c1*temp(npm)+c2*temp(npm-1)
      if (m .gt. 2) zxymns = zxymns+c3*temp(npm-2)
c
c set up right hand sides and tridiagonal system for y-grid
c perform forward elimination
c
   28 del1 = y(2)-y(1)
      if (del1 .le. 0.) go to 47
      deli = 1./del1
      do 29 i = 1,m
   29   zp(i,2,1) = deli*(z(i,2)-z(i,1))
      zp(1,2,3) = deli*(zp(1,2,2)-zp(1,1,2))
      zp(m,2,3) = deli*(temp(npm+2)-temp(npm+1))
      call terms (diag1,sdiag1,sigmay,del1)
      diagi = 1./diag1
      do 30 i = 1,m
   30   zp(i,1,1) = diagi*(zp(i,2,1)-zp(i,1,1))
      zp(1,1,3) = diagi*(zp(1,2,3)-zp(1,1,3))
      zp(m,1,3) = diagi*(zp(m,2,3)-zp(m,1,3))
      temp(1) = diagi*sdiag1
      if (n .eq. 2) go to 34
      do 33 j = 2,nm1
        jm1 = j-1
        jp1 = j+1
        npmpj = npm+j
        del2 = y(jp1)-y(j)
        if (del2 .le. 0.) go to 47
        deli = 1./del2
        do 31 i = 1,m
   31     zp(i,jp1,1) = deli*(z(i,jp1)-z(i,j))
        zp(1,jp1,3) = deli*(zp(1,jp1,2)-zp(1,j,2))
        zp(m,jp1,3) = deli*(temp(npmpj+1)-temp(npmpj))
        call terms (diag2,sdiag2,sigmay,del2)
        diagin = 1./(diag1+diag2-sdiag1*temp(jm1))
        do 32 i = 1,m
   32     zp(i,j,1) = diagin*(zp(i,jp1,1)-zp(i,j,1)-
     *                        sdiag1*zp(i,jm1,1))
        zp(1,j,3) = diagin*(zp(1,jp1,3)-zp(1,j,3)-
     *                      sdiag1*zp(1,jm1,3))
        zp(m,j,3) = diagin*(zp(m,jp1,3)-zp(m,j,3)-
     *                      sdiag1*zp(m,jm1,3))
        temp(j) = diagin*sdiag2
        diag1 = diag2
   33   sdiag1 = sdiag2
   34 diagin = 1./(diag1-sdiag1*temp(nm1))
      do 35 i = 1,m
        npi = n+i
   35   zp(i,n,1) = diagin*(temp(npi)-zp(i,n,1)-
     *                      sdiag1*zp(i,nm1,1))
      zp(1,n,3) = diagin*(zxy1ns-zp(1,n,3)-
     *                    sdiag1*zp(1,nm1,3))
      temp(n) = diagin*(zxymns-zp(m,n,3)-
     *                  sdiag1*zp(m,nm1,3))
c
c perform back substitution
c
      do 37 j = 2,n
        jbak = np1-j
        jbakp1 = jbak+1
        t = temp(jbak)
        do 36 i = 1,m
   36     zp(i,jbak,1) = zp(i,jbak,1)-t*zp(i,jbakp1,1)
        zp(1,jbak,3) = zp(1,jbak,3)-t*zp(1,jbakp1,3)
   37   temp(jbak) = zp(m,jbak,3)-t*temp(jbakp1)
c
c set up right hand sides and tridiagonal system for x-grid
c perform forward elimination
c
      del1 = x(2)-x(1)
      if (del1 .le. 0.) go to 47
      deli = 1./del1
      do 38 j = 1,n
        zp(2,j,2) = deli*(z(2,j)-z(1,j))
   38   zp(2,j,3) = deli*(zp(2,j,1)-zp(1,j,1))
      call terms (diag1,sdiag1,sigmax,del1)
      diagi = 1./diag1
      do 39 j = 1,n
        zp(1,j,2) = diagi*(zp(2,j,2)-zp(1,j,2))
   39   zp(1,j,3) = diagi*(zp(2,j,3)-zp(1,j,3))
      temp(n+1) = diagi*sdiag1
      if (m  .eq. 2) go to 43
      do 42 i = 2,mm1
        im1 = i-1
        ip1 = i+1
        npi = n+i
        del2 = x(ip1)-x(i)
        if (del2 .le. 0.) go to 47
        deli = 1./del2
        do 40 j = 1,n
          zp(ip1,j,2) = deli*(z(ip1,j)-z(i,j))
   40     zp(ip1,j,3) = deli*(zp(ip1,j,1)-zp(i,j,1))
        call terms (diag2,sdiag2,sigmax,del2)
        diagin = 1./(diag1+diag2-sdiag1*temp(npi-1))
        do 41 j = 1,n
          zp(i,j,2) = diagin*(zp(ip1,j,2)-zp(i,j,2)-
     *                        sdiag1*zp(im1,j,2))
   41     zp(i,j,3) = diagin*(zp(ip1,j,3)-zp(i,j,3)-
     *                        sdiag1*zp(im1,j,3))
        temp(npi) = diagin*sdiag2
        diag1 = diag2
   42   sdiag1 = sdiag2
   43 diagin = 1./(diag1-sdiag1*temp(npm-1))
      do 44 j = 1,n
        npmpj = npm+j
        zp(m,j,2) = diagin*(temp(npmpj)-zp(m,j,2)-
     *                      sdiag1*zp(mm1,j,2))
   44   zp(m,j,3) = diagin*(temp(j)-zp(m,j,3)-
     *                      sdiag1*zp(mm1,j,3))
c
c perform back substitution
c
      do 45 i = 2,m
        ibak = mp1-i
        ibakp1 = ibak+1
        npibak = n+ibak
        t = temp(npibak)
        do 45 j = 1,n
          zp(ibak,j,2) = zp(ibak,j,2)-t*zp(ibakp1,j,2)
   45     zp(ibak,j,3) = zp(ibak,j,3)-t*zp(ibakp1,j,3)
      return
c
c too few points
c
   46 ierr = 1
      return
c
c points not strictly increasing
c
   47 ierr = 2
      return
      end

c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by UCAR                 .
c  .                                                             .
c  .       University Corporation for Atmospheric Research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                         SPHEREPACK                       .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c
c ... file shsec.f
c
c     this file contains code and documentation for subroutines
c     shsec and shseci
c
c ... files which must be loaded with shsec.f
c
c     sphcom.f, hrfft.f
c
c     subroutine shsec(nlat,nlon,isym,nt,g,idg,jdg,a,b,mdab,ndab,
c    +                    wshsec,lshsec,work,lwork,ierror)
c
c     subroutine shsec performs the spherical harmonic synthesis
c     on the arrays a and b and stores the result in the array g.
c     the synthesis is performed on an equally spaced grid.  the
c     associated legendre functions are recomputed rather than stored
c     as they are in subroutine shses.  the synthesis is described
c     below at output parameter g.
c
c     required files from spherepack2
c
c     sphcom.f, hrfft.f
c
c
c     input parameters
c
c     nlat   the number of colatitudes on the full sphere including the
c            poles. for example, nlat = 37 for a five degree grid.
c            nlat determines the grid increment in colatitude as
c            pi/(nlat-1).  if nlat is odd the equator is located at
c            grid point i=(nlat+1)/2. if nlat is even the equator is
c            located half way between points i=nlat/2 and i=nlat/2+1.
c            nlat must be at least 3. note: on the half sphere, the
c            number of grid points in the colatitudinal direction is
c            nlat/2 if nlat is even or (nlat+1)/2 if nlat is odd.
c
c     nlon   the number of distinct londitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater
c            than or equal to 4. the efficiency of the computation is
c            improved when nlon is a product of small prime numbers.
c
c     isym   = 0  no symmetries exist about the equator. the synthesis
c                 is performed on the entire sphere.  i.e. on the
c                 array g(i,j) for i=1,...,nlat and j=1,...,nlon.
c                 (see description of g below)
c
c            = 1  g is antisymmetric about the equator. the synthesis
c                 is performed on the northern hemisphere only.  i.e.
c                 if nlat is odd the synthesis is performed on the
c                 array g(i,j) for i=1,...,(nlat+1)/2 and j=1,...,nlon.
c                 if nlat is even the synthesis is performed on the
c                 array g(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
c
c
c            = 2  g is symmetric about the equator. the synthesis is
c                 performed on the northern hemisphere only.  i.e.
c                 if nlat is odd the synthesis is performed on the
c                 array g(i,j) for i=1,...,(nlat+1)/2 and j=1,...,nlon.
c                 if nlat is even the synthesis is performed on the
c                 array g(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
c
c     nt     the number of syntheses.  in the program that calls shsec,
c            the arrays g,a and b can be three dimensional in which
c            case multiple syntheses will be performed.  the third
c            index is the synthesis index which assumes the values
c            k=1,...,nt.  for a single synthesis set nt=1. the
c            discription of the remaining parameters is simplified
c            by assuming that nt=1 or that the arrays g,a and b
c            have only two dimensions.
c
c     idg    the first dimension of the array g as it appears in the
c            program that calls shsec.  if isym equals zero then idg
c            must be at least nlat.  if isym is nonzero then idg
c            must be at least nlat/2 if nlat is even or at least
c            (nlat+1)/2 if nlat is odd.
c
c     jdg    the second dimension of the array g as it appears in the
c            program that calls shsec.  jdg must be at least nlon.
c
c     a,b    two or three dimensional arrays (see the input parameter
c            nt) that contain the coefficients in the spherical harmonic
c            expansion of g(i,j) given below at the definition of the
c            output parameter g.  a(m,n) and b(m,n) are defined for
c            indices m=1,...,mmax and n=m,...,nlat where mmax is the
c            maximum (plus one) longitudinal wave number given by
c            mmax = min0(nlat,(nlon+2)/2) if nlon is even or
c            mmax = min0(nlat,(nlon+1)/2) if nlon is odd.
c
c     mdab   the first dimension of the arrays a and b as it appears
c            in the program that calls shsec. mdab must be at least
c            min0(nlat,(nlon+2)/2) if nlon is even or at least
c            min0(nlat,(nlon+1)/2) if nlon is odd.
c
c     ndab   the second dimension of the arrays a and b as it appears
c            in the program that calls shsec. ndab must be at least nlat
c
c     wshsec an array which must be initialized by subroutine shseci.
c            once initialized, wshsec can be used repeatedly by shsec
c            as long as nlon and nlat remain unchanged.  wshsec must
c            not be altered between calls of shsec.
c
c     lshsec the dimension of the array wshsec as it appears in the
c            program that calls shsec. define
c
c               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            then lshsec must be at least
c
c            2*nlat*l2+3*((l1-2)*(nlat+nlat-l1-1))/2+nlon+15
c
c
c     work   a work array that does not have to be saved.
c
c     lwork  the dimension of the array work as it appears in the
c            program that calls shsec. define
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            if isym is zero then lwork must be at least
c
c                    nlat*(nt*nlon+max0(3*l2,nlon))
c
c            if isym is not zero then lwork must be at least
c
c                    l2*(nt*nlon+max0(3*nlat,nlon))
c
c     **************************************************************
c
c     output parameters
c
c     g      a two or three dimensional array (see input parameter
c            nt) that contains the spherical harmonic synthesis of
c            the arrays a and b at the colatitude point theta(i) =
c            (i-1)*pi/(nlat-1) and longitude point phi(j) =
c            (j-1)*2*pi/nlon. the index ranges are defined above at
c            at the input parameter isym.  for isym=0, g(i,j) is
c            given by the the equations listed below.  symmetric
c            versions are used when isym is greater than zero.
c
c     the normalized associated legendre functions are given by
c
c     pbar(m,n,theta) = sqrt((2*n+1)*factorial(n-m)/(2*factorial(n+m)))
c                       *sin(theta)**m/(2**n*factorial(n)) times the
c                       (n+m)th derivative of (x**2-1)**n with respect
c                       to x=cos(theta)
c
c     define the maximum (plus one) longitudinal wave number
c     as   mmax = min0(nlat,(nlon+2)/2) if nlon is even or
c          mmax = min0(nlat,(nlon+1)/2) if nlon is odd.
c
c     then g(i,j) = the sum from n=0 to n=nlat-1 of
c
c                   .5*pbar(0,n,theta(i))*a(1,n+1)
c
c              plus the sum from m=1 to m=mmax-1 of
c
c                   the sum from n=m to n=nlat-1 of
c
c              pbar(m,n,theta(i))*(a(m+1,n+1)*cos(m*phi(j))
c                                    -b(m+1,n+1)*sin(m*phi(j)))
c
c
c     ierror = 0  no errors
c            = 1  error in the specification of nlat
c            = 2  error in the specification of nlon
c            = 3  error in the specification of isym
c            = 4  error in the specification of nt
c            = 5  error in the specification of idg
c            = 6  error in the specification of jdg
c            = 7  error in the specification of mdab
c            = 8  error in the specification of ndab
c            = 9  error in the specification of lshsec
c            = 10 error in the specification of lwork
c
c
c ****************************************************************
c     subroutine shseci(nlat,nlon,wshsec,lshsec,dwork,ldwork,ierror)
c
c     subroutine shseci initializes the array wshsec which can then
c     be used repeatedly by subroutine shsec.
c
c     input parameters
c
c     nlat   the number of colatitudes on the full sphere including the
c            poles. for example, nlat = 37 for a five degree grid.
c            nlat determines the grid increment in colatitude as
c            pi/(nlat-1).  if nlat is odd the equator is located at
c            grid point i=(nlat+1)/2. if nlat is even the equator is
c            located half way between points i=nlat/2 and i=nlat/2+1.
c            nlat must be at least 3. note: on the half sphere, the
c            number of grid points in the colatitudinal direction is
c            nlat/2 if nlat is even or (nlat+1)/2 if nlat is odd.
c
c     nlon   the number of distinct londitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater
c            than or equal to 4. the efficiency of the computation is
c            improved when nlon is a product of small prime numbers.
c
c     lshsec the dimension of the array wshsec as it appears in the
c            program that calls shseci. the array wshsec is an output
c            parameter which is described below. define
c
c               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            then lshsec must be at least
c
c            2*nlat*l2+3*((l1-2)*(nlat+nlat-l1-1))/2+nlon+15
c
c     dwork  a double precision work array that does not have to be
c            saved.
c
c     ldwork the dimension of array dwork as it appears in the program
c            that calls shseci.  ldwork must be at least nlat+1.
c
c     output parameters
c
c     wshsec an array which is initialized for use by subroutine shsec.
c            once initialized, wshsec can be used repeatedly by shsec
c            as long as nlon and nlat remain unchanged.  wshsec must
c            not be altered between calls of shsec.
c
c     ierror = 0  no errors
c            = 1  error in the specification of nlat
c            = 2  error in the specification of nlon
c            = 3  error in the specification of lshsec
c            = 4  error in the specification of ldwork
c
c
c ****************************************************************
      SUBROUTINE DSHSEC(NLAT,NLON,ISYM,NT,G,IDG,JDG,A,B,MDAB,NDAB,
     +                  WSHSEC,LSHSEC,WORK,LWORK,IERROR)
      DOUBLE PRECISION G
      DOUBLE PRECISION A
      DOUBLE PRECISION B
      DOUBLE PRECISION WSHSEC
      DOUBLE PRECISION WORK
      DIMENSION G(IDG,JDG,1),A(MDAB,NDAB,1),B(MDAB,NDAB,1),WSHSEC(1),
     +          WORK(1)

      IERROR = 1
      IF (NLAT.LT.3) RETURN
      IERROR = 2
      IF (NLON.LT.4) RETURN
      IERROR = 3
      IF (ISYM.LT.0 .OR. ISYM.GT.2) RETURN
      IERROR = 4
      IF (NT.LT.0) RETURN
      IERROR = 5
      IF ((ISYM.EQ.0.AND.IDG.LT.NLAT) .OR.
     +    (ISYM.NE.0.AND.IDG.LT. (NLAT+1)/2)) RETURN
      IERROR = 6
      IF (JDG.LT.NLON) RETURN
      IERROR = 7
      MMAX = MIN0(NLAT,NLON/2+1)
      IF (MDAB.LT.MMAX) RETURN
      IERROR = 8
      IF (NDAB.LT.NLAT) RETURN
      IERROR = 9
      IMID = (NLAT+1)/2
      LZZ1 = 2*NLAT*IMID
      LABC = 3* ((MMAX-2)* (NLAT+NLAT-MMAX-1))/2
      IF (LSHSEC.LT.LZZ1+LABC+NLON+15) RETURN
      IERROR = 10
      LS = NLAT
      IF (ISYM.GT.0) LS = IMID
      NLN = NT*LS*NLON
      IF (LWORK.LT.NLN+MAX0(LS*NLON,3*NLAT*IMID)) RETURN
      IERROR = 0
      IST = 0
      IF (ISYM.EQ.0) IST = IMID
      IW1 = LZZ1 + LABC + 1
      CALL DSHSEC1(NLAT,ISYM,NT,G,IDG,JDG,A,B,MDAB,NDAB,IMID,LS,NLON,
     +            WORK,WORK(IST+1),WORK(NLN+1),WORK(NLN+1),WSHSEC,
     +            WSHSEC(IW1))
      RETURN
      END
      SUBROUTINE DSHSEC1(NLAT,ISYM,NT,G,IDGS,JDGS,A,B,MDAB,NDAB,IMID,
     +                   IDG,JDG,GE,GO,WORK,PB,WALIN,WHRFFT)
      DOUBLE PRECISION G
      DOUBLE PRECISION A
      DOUBLE PRECISION B
      DOUBLE PRECISION GE
      DOUBLE PRECISION GO
      DOUBLE PRECISION WORK
      DOUBLE PRECISION PB
      DOUBLE PRECISION WALIN
      DOUBLE PRECISION WHRFFT
c
c     whrfft must have at least nlon+15 locations
c     walin must have 3*l*imid + 3*((l-3)*l+2)/2 locations
c     zb must have 3*l*imid locations
c
      DIMENSION G(IDGS,JDGS,1),A(MDAB,NDAB,1),B(MDAB,NDAB,1),
     +          GE(IDG,JDG,1),GO(IDG,JDG,1),PB(IMID,NLAT,3),WALIN(1),
     +          WHRFFT(1),WORK(1)

      LS = IDG
      NLON = JDG
      MMAX = MIN0(NLAT,NLON/2+1)
      MDO = MMAX
      IF (MDO+MDO-1.GT.NLON) MDO = MMAX - 1
      NLP1 = NLAT + 1
      MODL = MOD(NLAT,2)
      IMM1 = IMID
      IF (MODL.NE.0) IMM1 = IMID - 1
      DO 80 K = 1,NT
          DO 80 J = 1,NLON
              DO 80 I = 1,LS
                  GE(I,J,K) = 0.D0
   80 CONTINUE
      IF (ISYM.EQ.1) GO TO 125
      CALL DALIN(2,NLAT,NLON,0,PB,I3,WALIN)
      DO 100 K = 1,NT
          DO 100 NP1 = 1,NLAT,2
              DO 100 I = 1,IMID
                  GE(I,1,K) = GE(I,1,K) + A(1,NP1,K)*PB(I,NP1,I3)
  100 CONTINUE
      NDO = NLAT
      IF (MOD(NLAT,2).EQ.0) NDO = NLAT - 1
      DO 110 MP1 = 2,MDO
          M = MP1 - 1
          CALL DALIN(2,NLAT,NLON,M,PB,I3,WALIN)
          DO 110 NP1 = MP1,NDO,2
              DO 110 K = 1,NT
                  DO 110 I = 1,IMID
                      GE(I,2*MP1-2,K) = GE(I,2*MP1-2,K) +
     +                                  A(MP1,NP1,K)*PB(I,NP1,I3)
                      GE(I,2*MP1-1,K) = GE(I,2*MP1-1,K) +
     +                                  B(MP1,NP1,K)*PB(I,NP1,I3)
  110 CONTINUE
      IF (MDO.EQ.MMAX .OR. MMAX.GT.NDO) GO TO 122
      CALL DALIN(2,NLAT,NLON,MDO,PB,I3,WALIN)
      DO 120 NP1 = MMAX,NDO,2
          DO 120 K = 1,NT
              DO 120 I = 1,IMID
                  GE(I,2*MMAX-2,K) = GE(I,2*MMAX-2,K) +
     +                               A(MMAX,NP1,K)*PB(I,NP1,I3)
  120 CONTINUE
  122 IF (ISYM.EQ.2) GO TO 155
  125 CALL DALIN(1,NLAT,NLON,0,PB,I3,WALIN)
      DO 140 K = 1,NT
          DO 140 NP1 = 2,NLAT,2
              DO 140 I = 1,IMM1
                  GO(I,1,K) = GO(I,1,K) + A(1,NP1,K)*PB(I,NP1,I3)
  140 CONTINUE
      NDO = NLAT
      IF (MOD(NLAT,2).NE.0) NDO = NLAT - 1
      DO 150 MP1 = 2,MDO
          MP2 = MP1 + 1
          M = MP1 - 1
          CALL DALIN(1,NLAT,NLON,M,PB,I3,WALIN)
          DO 150 NP1 = MP2,NDO,2
              DO 150 K = 1,NT
                  DO 150 I = 1,IMM1
                      GO(I,2*MP1-2,K) = GO(I,2*MP1-2,K) +
     +                                  A(MP1,NP1,K)*PB(I,NP1,I3)
                      GO(I,2*MP1-1,K) = GO(I,2*MP1-1,K) +
     +                                  B(MP1,NP1,K)*PB(I,NP1,I3)
  150 CONTINUE
      MP2 = MMAX + 1
      IF (MDO.EQ.MMAX .OR. MP2.GT.NDO) GO TO 155
      CALL DALIN(1,NLAT,NLON,MDO,PB,I3,WALIN)
      DO 152 NP1 = MP2,NDO,2
          DO 152 K = 1,NT
              DO 152 I = 1,IMM1
                  GO(I,2*MMAX-2,K) = GO(I,2*MMAX-2,K) +
     +                               A(MMAX,NP1,K)*PB(I,NP1,I3)
  152 CONTINUE
  155 DO 160 K = 1,NT
          IF (MOD(NLON,2).NE.0) GO TO 157
          DO 156 I = 1,LS
              GE(I,NLON,K) = 2.D0*GE(I,NLON,K)
  156     CONTINUE
  157     CALL DHRFFTB(LS,NLON,GE(1,1,K),LS,WHRFFT,WORK)
  160 CONTINUE
      IF (ISYM.NE.0) GO TO 180
      DO 170 K = 1,NT
          DO 170 J = 1,NLON
              DO 175 I = 1,IMM1
                  G(I,J,K) = .5D0* (GE(I,J,K)+GO(I,J,K))
                  G(NLP1-I,J,K) = .5D0* (GE(I,J,K)-GO(I,J,K))
  175         CONTINUE
              IF (MODL.EQ.0) GO TO 170
              G(IMID,J,K) = .5D0*GE(IMID,J,K)
  170 CONTINUE
      RETURN
  180 DO 185 K = 1,NT
          DO 185 I = 1,IMID
              DO 185 J = 1,NLON
                  G(I,J,K) = .5D0*GE(I,J,K)
  185 CONTINUE
      RETURN
      END
c     subroutine shseci(nlat,nlon,wshsec,lshsec,dwork,ldwork,ierror)
c
c     subroutine shseci initializes the array wshsec which can then
c     be used repeatedly by subroutine shsec.
c
c     input parameters
c
c     nlat   the number of colatitudes on the full sphere including the
c            poles. for example, nlat = 37 for a five degree grid.
c            nlat determines the grid increment in colatitude as
c            pi/(nlat-1).  if nlat is odd the equator is located at
c            grid point i=(nlat+1)/2. if nlat is even the equator is
c            located half way between points i=nlat/2 and i=nlat/2+1.
c            nlat must be at least 3. note: on the half sphere, the
c            number of grid points in the colatitudinal direction is
c            nlat/2 if nlat is even or (nlat+1)/2 if nlat is odd.
c
c     nlon   the number of distinct londitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater
c            than or equal to 4. the efficiency of the computation is
c            improved when nlon is a product of small prime numbers.
c
c     lshsec the dimension of the array wshsec as it appears in the
c            program that calls shseci. the array wshsec is an output
c            parameter which is described below. define
c
c               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            then lshsec must be at least
c
c            2*nlat*l2+3*((l1-2)*(nlat+nlat-l1-1))/2+nlon+15
c
c     dwork  a double precision work array that does not have to be
c            saved.
c
c     ldwork the dimension of array dwork as it appears in the program
c            that calls shseci.  ldwork must be at least nlat+1.
c
c     output parameters
c
c     wshsec an array which is initialized for use by subroutine shsec.
c            once initialized, wshsec can be used repeatedly by shsec
c            as long as nlon and nlat remain unchanged.  wshsec must
c            not be altered between calls of shsec.
c
c     ierror = 0  no errors
c            = 1  error in the specification of nlat
c            = 2  error in the specification of nlon
c            = 3  error in the specification of lshsec
c            = 4  error in the specification of ldwork
c
c
c ****************************************************************
      SUBROUTINE DSHSECI(NLAT,NLON,WSHSEC,LSHSEC,DWORK,LDWORK,IERROR)
      DOUBLE PRECISION WSHSEC
      DIMENSION WSHSEC(*)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION DWORK(LDWORK)

      IERROR = 1
      IF (NLAT.LT.3) RETURN
      IERROR = 2
      IF (NLON.LT.4) RETURN
      IERROR = 3
      IMID = (NLAT+1)/2
      MMAX = MIN0(NLAT,NLON/2+1)
      LZZ1 = 2*NLAT*IMID
      LABC = 3* ((MMAX-2)* (NLAT+NLAT-MMAX-1))/2
      IF (LSHSEC.LT.LZZ1+LABC+NLON+15) RETURN
      IERROR = 4
      IF (LDWORK.LT.NLAT+1) RETURN
      IERROR = 0
      CALL DALINIT(NLAT,NLON,WSHSEC,DWORK)
      IW1 = LZZ1 + LABC + 1
      CALL DHRFFTI(NLON,WSHSEC(IW1))
      RETURN
      END

      PROGRAM AGEX05
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Define the data arrays.
C
      REAL XDRA(401,6),YDRA(401,6)
C
C Initialize GKS.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Compute required constants.
C
      PI=3.14159265358979
      PID200=PI/200.
      PITTWO=2.*PI
      PIT2D3=2.*PI/3.
      PIT4D3=4.*PI/3.
      RADOSC=SQRT(3.)/3.
      RADOLC=SQRT(3.)/2.
      BSSCLL=ATAN(SQRT(12.)/6.)
      BSSCUL=ATAN(SQRT(143.)/7.)
      BSLCLL=ATAN(SQRT(143.)/17.)
      BSLCUL=ATAN(SQRT(2.0))
C
C Fill the data arrays.
C
      DO 101 I=1,401
        THETA=PID200*REAL(I-1)
        XDRA(I,1)=   -.5+RADOSC*COS(THETA)
        YDRA(I,1)=       RADOSC*SIN(THETA)
        IF (ABS(THETA       ).GE.BSSCLL.AND.
     +      ABS(THETA       ).LE.BSSCUL) XDRA(I,1)=1.E36
        IF (ABS(THETA-PITTWO).GE.BSSCLL.AND.
     +      ABS(THETA-PITTWO).LE.BSSCUL) XDRA(I,1)=1.E36
        XDRA(I,2)=    .5+RADOSC*COS(THETA)
        YDRA(I,2)=       RADOSC*SIN(THETA)
        IF (ABS(THETA-PIT2D3).GE.BSSCLL.AND.
     +      ABS(THETA-PIT2D3).LE.BSSCUL) XDRA(I,2)=1.E36
        XDRA(I,3)=       RADOSC*COS(THETA)
        YDRA(I,3)=RADOLC+RADOSC*SIN(THETA)
        IF (ABS(THETA-PIT4D3).GE.BSSCLL.AND.
     +      ABS(THETA-PIT4D3).LE.BSSCUL) XDRA(I,3)=1.E36
        XDRA(I,4)=   -.5+RADOLC*COS(THETA)
        YDRA(I,4)=       RADOLC*SIN(THETA)
        IF (ABS(THETA       ).GE.BSLCLL.AND.
     +      ABS(THETA       ).LE.BSLCUL) XDRA(I,4)=1.E36
        IF (ABS(THETA-PITTWO).GE.BSLCLL.AND.
     +      ABS(THETA-PITTWO).LE.BSLCUL) XDRA(I,4)=1.E36
        XDRA(I,5)=    .5+RADOLC*COS(THETA)
        YDRA(I,5)=       RADOLC*SIN(THETA)
        IF (ABS(THETA-PIT2D3).GE.BSLCLL.AND.
     +      ABS(THETA-PIT2D3).LE.BSLCUL) XDRA(I,5)=1.E36
        XDRA(I,6)=       RADOLC*COS(THETA)
        YDRA(I,6)=RADOLC+RADOLC*SIN(THETA)
        IF (ABS(THETA-PIT4D3).GE.BSLCLL.AND.
     +      ABS(THETA-PIT4D3).LE.BSLCUL) XDRA(I,6)=1.E36
  101 CONTINUE
C
C Specify subscripting of XDRA and YDRA.
C
      CALL AGSETI ('ROW.',2)
C
C Set up grid shape to make 1 unit in x = 1 unit in y.
C
      CALL AGSETF ('GRID/SHAPE.',2.)
C
C Turn off background, then turn labels back on.
C
      CALL AGSETF ('BACKGROUND.',4.)
      CALL AGSETI ('LABEL/CONTROL.',2)
C
C Turn off left label.
C
      CALL AGSETC ('LABEL/NAME.','L')
      CALL AGSETI ('LABEL/SUPPRESSION FLAG.',1)
C
C Change text of bottom label.
C
      CALL AGSETC ('LABEL/NAME.','B')
      CALL AGSETI ('LINE/NUMBER.',-100)
      CALL AGSETC ('LINE/TEXT.','PURITY, BODY, AND FLAVOR$')
C
C Draw a boundary around the edge of the plotter frame.
C
      CALL BNDARY
C
C Draw the graph, using EZMXY.
C
      CALL EZMXY (XDRA,YDRA,401,6,401,'EXAMPLE 5 (EZMXY)$')
C
C Close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
C
      END
      SUBROUTINE BNDARY
C
C Routine to draw the plotter-frame edge.
C
      CALL PLOTIT (    0,    0,0)
      CALL PLOTIT (32767,    0,1)
      CALL PLOTIT (32767,32767,1)
      CALL PLOTIT (    0,32767,1)
      CALL PLOTIT (    0,    0,1)
      RETURN
      END

C
C  This program produces five 9 x 9 color charts.  Blue and green
C  intensities are varied on each chart, and the red intensity is
C  varied between charts.  To produce the charts, color indices
C  1-84 are used.  If plotting on a device with fewer than 84 colors
C  available, unsatisfactory results will obtain.
C
      PROGRAM COEX01
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
      DIMENSION RGB(3,405)
C
C  Open GKS.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C  Set fill area interior style to solid.
C
      CALL GSFAIS(1)
C
C  Define all permutations of RGB's needed.
C
      CALL COLSET(RGB)
C
C  Put out 5 color charts, varying the red value with each frame.
C
      DO 10 NPAGE=1,5
        CALL SETCOL(RGB,NPAGE,IWKID)
        CALL TTLBAR()
        CALL CUBE()
        CALL TITLE(NPAGE,IWKID)
        CALL FRAME
   10 CONTINUE
C
C  Close GKS.
C
      CALL GDAWK(IWKID)
      CALL GCLWK(IWKID)
      CALL GCLKS
C
      END
      SUBROUTINE COLSET(RGB)
C
C  Define the RGB color triples needed.  This is done by filling the
C  RGB array with all 405 permutations for a 9 x 9 color cube in 5
C  plots.  All values are normalized to fall in the range 0 to 1.
C
      DIMENSION RGB(3,405)
      DIMENSION CLRS(9)
C
      DATA CLRS(1),CLRS(2),CLRS(3)/   0.,  32.,  64./
      DATA CLRS(4),CLRS(5),CLRS(6)/  96., 128., 160./
      DATA CLRS(7),CLRS(8),CLRS(9)/ 192., 224., 255./
C
      INDEX = 1
      DO 10 I=1,5
        DO 20 J=1,9
          DO 30 K=1,9
            RGB (1,INDEX) = CLRS(2*I-1)/255.0
            RGB (2,INDEX) = CLRS(J)/255.0
            RGB (3,INDEX) = CLRS(K)/255.0
            INDEX = INDEX + 1
   30     CONTINUE
   20   CONTINUE
   10 CONTINUE
C
      RETURN
      END

      SUBROUTINE SETCOL(RGB,INDEX,IWKID)
C
C  Define color indices 3-84 to contain the desired colors.
C
      DIMENSION RGB(3,405)
      CALL GSCR(IWKID,0,0.,0.,0.)
      CALL GSCR(IWKID,1,1.,1.,1.)
      NDX = 81*(INDEX-1)+1
      DO 10 N=1,81
      CALL GSCR(IWKID,N+2,RGB(1,NDX),RGB(2,NDX),RGB(3,NDX))
      NDX = NDX + 1
   10 CONTINUE
C
      RETURN
      END
      SUBROUTINE CUBE()
C
C  Draw 81 color squares of size DELX x DELY.  Start at position
C  (X1,Y1).  Use blank space of GAPX and GAPY between the squares.
C
      PARAMETER (DELX=0.095, DELY=0.095)
      PARAMETER (GAPX=DELX-0.003, GAPY=DELY-0.003)
      DIMENSION CELLX(4), CELLY(4)
      DATA X1,Y1/0.13, 0.075/
C
C  Set the parameters for the starting point.
C
      X = X1
      Y = Y1
C
C  Start with color index 3 so that the foreground and background
C  color indices are not touched.
C
      INDCOL = 3
C
C  Put out 9 x 9 squares.
C
      DO 10 I=1,9
        DO 20 L=1,9
C
C  Define square.
C
          CELLX(1) = X
          CELLY(1) = Y
          CELLX(2) = X + GAPX
          CELLY(2) = Y
          CELLX(3) = X + GAPX
          CELLY(3) = Y + GAPY
          CELLX(4) = X
          CELLY(4) = Y + GAPY
C
C  Set color to index INDCOL and draw square.
C
          CALL GSFACI(INDCOL)
          CALL GFA(4,CELLX,CELLY)
          X = X + DELX
          INDCOL = INDCOL + 1
   20   CONTINUE
        Y = Y + DELY
        X = X1
   10 CONTINUE
C
      RETURN
      END
      SUBROUTINE TTLBAR()
C
C  Label the chart with the red intensity.
C
      DIMENSION CELLX(4), CELLY(4)
      DATA X1,Y1,XSIDE,YSIDE/ 0.70, 0.93, 0.28, 0.04/
C
C  Define the fill area.
C
      CELLX(1) = X1
      CELLY(1) = Y1
      CELLX(2) = X1 + XSIDE
      CELLY(2) = Y1
      CELLX(3) = X1 + XSIDE
      CELLY(3) = Y1 + YSIDE
      CELLX(4) = X1
      CELLY(4) = Y1 + YSIDE
C
C  Set the color and draw the fill area.
C
      CALL GSFACI(3)
      CALL GFA(4,CELLX,CELLY)
C
      RETURN
      END
      SUBROUTINE TITLE(NPAGE,IWKID)
C
C  Label the chart using white characters..
C
      DIMENSION AX1(3),AY1(3),AX2(3),AY2(3),IL(9)
      CHARACTER RVAL*16,CVAL*3,DVAL*4
      DATA AX1(1),AX1(2),AX1(3)/ .073, .048, .073/
      DATA AY1(1),AY1(2),AY1(3)/ .900, .800, .800/
      DATA AX2(1),AX2(2),AX2(3)/ .960, .860, .860/
      DATA AY2(1),AY2(2),AY2(3)/ .028, .010, .028/
      DATA DELX,DELY/.095,.095/
      DATA IL(1),IL(2),IL(3),IL(4),IL(5),IL(6),IL(7),IL(8),IL(9)
     1    /    3,    2,    2,    2,    1,    1,    1,    1,    1/
C
      CALL GSPLCI(1)
C
C  Print the title of each axis.
C
      CALL PLCHHQ(0.5,0.01,'Blue Axis' ,0.015,0.,0.)
      CALL PLCHHQ(0.05,0.5,'Green Axis',0.015,90.,0.)
C
C  Draw the arrow-line on each axis.
C
      CALL LINE(0.073,0.90,0.073,0.078)
      CALL GSFACI(1)
      CALL GFA(3,AX1,AY1)
C
      CALL LINE(0.15,0.028,0.96,0.028)
      CALL GSFACI(1)
      CALL GFA(3,AX2,AY2)
C
C  Print the red value for the frame at hand.
C
      ITMP = 64*(NPAGE-1)
      IF (NPAGE .EQ. 5) ITMP = 255
      RLV = REAL(ITMP)/255.
      WRITE(RVAL,100) ITMP,RLV
  100 FORMAT('RED = ',I3,' = ',F4.2)
      CALL PLCHHQ(.84,.95,RVAL,.014,0.,0.)
C
C  Print the Green values up the side.
C
      X = 0.10
      Y1 = 0.125
      Y2 = 0.108
      DO 20 I=1,9
        ITMP = 32*(I-1)
        IF (I .EQ. 9) ITMP=255
        WRITE(CVAL,110) ITMP
        RVL = REAL(ITMP)/255.
        WRITE(DVAL,120) RVL
  110   FORMAT(I3)
  120   FORMAT(F4.2)
        CALL PLCHHQ(X,Y1,CVAL(IL(I):3),.008,0.,0.)
        CALL PLCHHQ(X,Y2,DVAL,.008,0.,0.)
        Y1 = Y1+DELY
        Y2 = Y2+DELY
   20 CONTINUE
C
C  Print the Blue values across the bottom.
C
      Y1 = 0.060
      Y2 = 0.043
      X = 0.18
      DO 30 I=1,9
        ITMP = 32*(I-1)
        IF (I .EQ. 9) ITMP=255
        WRITE(CVAL,110) ITMP
        RVL = REAL(ITMP)/255.
        WRITE(DVAL,120) RVL
        CALL PLCHHQ(X,Y1,CVAL(IL(I):3),.008,0.,0.)
        CALL PLCHHQ(X,Y2,DVAL,.008,0.,0.)
        X = X+DELX
   30 CONTINUE
C
      RETURN
      END

C
C	$Id: gsasf.f,v 1.5 2008-07-27 00:21:01 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GSASF(LASF)
C
C  SET ASPECT SOURCE FLAGS
C
      INTEGER ESASF
      PARAMETER (ESASF=41)
C
      include 'gkscom.h'
C
      INTEGER LASF(13)
C
C  Check if GKS is in the proper state.
C
      CALL GZCKST(8,ESASF,IER)
      IF (IER .NE. 0) RETURN
C
C  Check if flags are 0 or 1.
C
      DO 200 I=1,13
      IF (LASF(I).NE.0 .AND. LASF(I).NE.1) THEN
        ERS = 1
        CALL GERHND(2000,ESASF,ERF)
        ERS = 0
      ENDIF
  200 CONTINUE
C
C  Set the current aspect source flags in the GKS state list.
C
      CLNA   = LASF( 1)
      CLWSCA = LASF( 2)
      CPLCIA = LASF( 3)
      CMKA   = LASF( 4)
      CMKSA  = LASF( 5)
      CPMCIA = LASF( 6)
      CTXFPA = LASF( 7)
      CCHXPA = LASF( 8)
      CCHSPA = LASF( 9)
      CTXCIA = LASF(10)
      CFAISA = LASF(11)
      CFASIA = LASF(12)
      CFACIA = LASF(13)
C
C  Invoke the workstation interface.
C
      FCODE = 43
      CONT  = 0
      CALL GZROI(0)
      IL1   = 13
      IL2   = 13
      DO 201 I=1,13
        ID(I) = LASF(I)
  201 CONTINUE
      CALL GZTOWK
      IF (RERR.NE.0 .AND. RERR.NE.-109) THEN
        ERS = 1
        CALL GERHND(RERR,ESASF,ERF)
        ERS = 0
      ENDIF
C
      RETURN
      END

C
C $Id: phi2sp.f,v 1.5 2008-07-27 00:17:10 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      REAL FUNCTION PHI2SP (ECCENT,TS)
C
C FUNCTION TO COMPUTE LATITUDE ANGLE (PHI-2).
C
      IMPLICIT REAL (A-Z)
      INTEGER II,NIT
      COMMON /ERRMZ0/ IERR
        INTEGER IERR
      SAVE   /ERRMZ0/
      COMMON /PRINZ0/ IPEMSG,IPELUN,IPPARM,IPPLUN
        INTEGER IPEMSG,IPELUN,IPPARM,IPPLUN
      SAVE   /PRINZ0/
      DATA HALF,ONE,TWO /0.5E0,1.0E0,2.0E0/
      DATA TOL,NIT /1.0E-10,15/
      DATA HALFPI /1.5707963267948966E0/
C
      ECCNTH = HALF * ECCENT
      PHI = HALFPI - TWO * ATAN (TS)
      DO 020 II = 1,NIT
      SINPI = SIN (PHI)
      CON = ECCENT * SINPI
      DPHI = HALFPI - TWO * ATAN (TS * ((ONE - CON) /
     .       (ONE + CON)) ** ECCNTH) - PHI
      PHI = PHI + DPHI
      IF (ABS(DPHI) .GT. TOL) GO TO 020
      PHI2SP = PHI
      RETURN
  020 CONTINUE
C
      IF (IPEMSG .EQ. 0) WRITE (IPELUN,2000) NIT,ECCENT,TS
 2000 FORMAT (/' ERROR PHI2SP' /
     .         ' LATITUDE FAILED TO CONVERGE AFTER',I3,' ITERATIONS'/
     .         ' ECCENTRICITY =',E25.16,'   TS =',E25.16)
      IERR = 002
      RETURN
C
      END

      PROGRAM TDEX08
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.  Use one
C of the following:
C
C       PARAMETER (IERF=6,LUNI=2,IWTY=1 ,IWID=1)  !  NCGM
C       PARAMETER (IERF=6,LUNI=2,IWTY=8 ,IWID=1)  !  X Windows
C       PARAMETER (IERF=6,LUNI=2,IWTY=20,IWID=1)  !  PostScript
C       PARAMETER (IERF=6,LUNI=2,IWTY=11,IWID=1)  !  PDF, Portrait
C       PARAMETER (IERF=6,LUNI=2,IWTY=12,IWID=1)  !  PDF, Landscape
C
        PARAMETER (IERF=6,LUNI=2,IWTYPE=1,IWTY=IWTYPE,IWID=1)
C
C Declare variables to hold labels.
C
        CHARACTER*64 UNLB,VNLB,WNLB,UILB,VILB,WILB
C
C Set the desired minimum and maximum values of U, V, and W.
C
        DATA UMIN,VMIN,WMIN,UMAX,VMAX,WMAX / -1.,-1.,-1.,1.,1.,1. /
C
C Set the desired values of parameters determining the eye position.
C ANG1 is a bearing angle, ANG2 is an elevation angle, and RMUL is a
C multiplier of the length of the diagonal of the data box, specifying
C the distance from the center of the box to the eye.
C
        DATA ANG1,ANG2,RMUL / -35.,25.,2.9 /
C
C ISTE is a flag that says whether to do a simple image (ISTE=0),
C a one-frame stereo image (ISTE=-1), or a two-frame stereo image
C (ISTE=+1).
C
        DATA ISTE / -1 /
C
C ASTE is the desired angle (in degrees) between the lines of sight for
C a pair of stereo views.
C
        DATA ASTE / 4. /
C
C WOSW is the width of the stereo windows to be used in one-frame stereo
C images; the width is stated as a fraction of the width of the plotter
C frame.  (The windows are centered vertically; horizontally, they are
C placed as far apart as possible in the plotter frame.)  The value used
C must be positive and non-zero; it may be slightly greater than .5, if
C it is desired that the stereo windows should overlap slightly.
C
        DATA WOSW / .5 /
C
C Define the number of points to be used in defining the curve.
C
        PARAMETER (NCRV=1001)
C
C Declare some arrays in which to define the curve.
C
        DIMENSION XCRV(NCRV),YCRV(NCRV),ZCRV(NCRV)
C
C Define the conversion constant from degrees to radians.
C
        DATA DTOR / .017453292519943 /
C
C Define labels for the edges of the box.
C
        DATA UNLB / ' -1 -.8 -.6 -.4 -.2 0 .2 .4 .6 .8 1 ' /
        DATA VNLB / ' -1 -.8 -.6 -.4 -.2 0 .2 .4 .6 .8 1 ' /
        DATA WNLB / ' -1 -.8 -.6 -.4 -.2 0 .2 .4 .6 .8 1 ' /
C
        DATA UILB / 'U Coordinate Values' /
        DATA VILB / 'V Coordinate Values' /
        DATA WILB / 'W Coordinate Values' /
C
C Define the curve.
C
        DO 101 I=1,NCRV
          XCRV(I)=.75*COS(DTOR*(REAL(I-1)/REAL(NCRV-1))*720.)
          YCRV(I)=.75*SIN(DTOR*(REAL(I-1)/REAL(NCRV-1))*720.)
          ZCRV(I)=-.75+1.5*REAL(I-1)/REAL(NCRV-1)
  101   CONTINUE
C
C Open GKS.
C
        CALL GOPKS (IERF,ISZDM)
        CALL GOPWK (IWID,LUNI,IWTY)
        CALL GACWK (IWID)
C
C Turn clipping off.
C
        CALL GSCLIP (0)
C
C Select font number 25, turn on the outlining of filled fonts, set the
C line width to 1, and turn off the setting of the outline color.
C
        CALL PCSETI ('FN - FONT NUMBER',25)
        CALL PCSETI ('OF - OUTLINE FLAG',1)
        CALL PCSETR ('OL - OUTLINE LINE WIDTH',1.)
        CALL PCSETR ('OC - OUTLINE LINE COLOR',-1.)
C
C Use a 25-degree (instead of the default 20-degree) field of view.
C
        CALL TDSETI ('FOV',25)
C
C Make TDPACK characters a bit bigger.
C
        CALL TDSETR ('CS1',1.25)
C
C Find the midpoint of the data box (to be used as the point looked at).
C
        UMID=.5*(UMIN+UMAX)
        VMID=.5*(VMIN+VMAX)
        WMID=.5*(WMIN+WMAX)
C
C Determine the distance (R) from which the data box will be viewed and,
C given that, the eye position.
C
        R=RMUL*SQRT((UMAX-UMIN)**2+(VMAX-VMIN)**2+(WMAX-WMIN)**2)
C
        UEYE=UMID+R*COS(DTOR*ANG1)*COS(DTOR*ANG2)
        VEYE=VMID+R*SIN(DTOR*ANG1)*COS(DTOR*ANG2)
        WEYE=WMID+R*SIN(DTOR*ANG2)
C
C Initialize the stereo offset argument to do either a single view or
C a left-eye view (whichever is selected by the value of ISTE).
C
        IF (ISTE.EQ.0) THEN
          OTEP=0.
        ELSE
          OTEP=-R*TAN(DTOR*ASTE/2.)
        END IF
C
C Initialize TDPACK.
C
  102   CALL TDINIT (UEYE,VEYE,WEYE,UMID,VMID,WMID,
     +                              UMID,VMID,WMID+R,OTEP)
C
C If stereo views are being done, do the requested thing, either by
C redoing the SET call to put them side by side on the same frame,
C or by calling FRAME to put them on separate frames.
C
        IF (OTEP.NE.0.) THEN
          IF (ISTE.LT.0) THEN
            CALL GETSET (XVPL,XVPR,YVPB,YVPT,XWDL,XWDR,YWDB,YWDT,LNLG)
            IF (OTEP.LT.0.) THEN
              CALL SET  (1.-WOSW,1.,.5-.5*WOSW,.5+.5*WOSW,
     +                           XWDL,XWDR,YWDB,YWDT,LNLG)
            ELSE
              CALL SET  (  0., WOSW,.5-.5*WOSW,.5+.5*WOSW,
     +                           XWDL,XWDR,YWDB,YWDT,LNLG)
            END IF
          ELSE
            IF (OTEP.GT.0.) CALL FRAME
          END IF
        END IF
C
C Draw labels for the axes.
C
        CALL TDLBLS (UMIN,VMIN,WMIN,UMAX,VMAX,WMAX,
     +               UNLB,VNLB,WNLB,UILB,VILB,WILB,1)
C
C Draw the sides of the box that could be hidden.
C
        CALL TDGRDS (UMIN,VMIN,WMIN,UMAX,VMAX,WMAX,
     +               .1*(UMAX-UMIN),.1*(VMAX-VMIN),.1*(WMAX-WMIN),
     +                                                       12,1)
C
C Draw the curve in pieces, with an arrowhead on each one.
C
          DO 103 J=1,NCRV,100
C
C Compute the number of points on this piece.
C
            NPTS=MIN(100,NCRV-J+1)
C
C Draw a curve.  The fourth argument says whether or not there is to be
C an arrowhead on the end of the curve and, if so, how many points are
C to be used in drawing its conical base (48, in the third case) and how
C many of those points are to be connected to the tip (12, in the third
C case).
C
C           CALL TDCURV (XCRV(J),YCRV(J),ZCRV(J),NPTS,    0,.2,.1)
C           CALL TDCURV (XCRV(J),YCRV(J),ZCRV(J),NPTS,    1,.2,.1)
            CALL TDCURV (XCRV(J),YCRV(J),ZCRV(J),NPTS,12048,.2,.1)
C
  103     CONTINUE
C
C Draw the sides of the box that could not be hidden.
C
        CALL TDGRDS (UMIN,VMIN,WMIN,UMAX,VMAX,WMAX,
     +               .1*(UMAX-UMIN),.1*(VMAX-VMIN),.1*(WMAX-WMIN),
     +                                                       12,0)
C
C If a left-eye view has just been done, loop back for a right-eye view.
C
        IF (OTEP.LT.0.) THEN
          OTEP=-OTEP
          GO TO 102
        END IF
C
C Advance the frame.
C
        CALL FRAME
C
C Close GKS.
C
        CALL GDAWK (IWID)
        CALL GCLWK (IWID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END

        PROGRAM MPEX11
C
C The object of this EZMAP example is to show off some capabilities of
C new code in EZMAPB (created in April, 1998).  Three different parts of
C the earth are shown at various "levels"; level 1 includes just land
C and water, level 2 includes continents, level 3 includes countries,
C level 4 includes states within the US, and level 5 includes counties
C within the states.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
        PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C LAMA is the length of an area map A for geographical boundaries;
C in general, this value needs to be a bit larger than would have been
C required for the old 'CO', 'PO', 'PS', and 'US' datasets.  The
C geographical boundaries go into edge group 1, but we also put into
C area map A a set of lines carving up the frame into vertical strips
C and some circles carving up the frame into areas within each of which
C we wish to display geographic information differently; the vertical
C strips go into edge group 2 and the circles into edge group 5.
C
        PARAMETER (LAMA=2000000)
C
C LAMB is the length of an area map B into which will be put just the
C circles mentioned above.  This area map will be used to determine
C characteristics of the lines drawn by the call to MPLNDM.
C
        PARAMETER (LAMB=  80000)
C
C MCRA is the required length of the scratch arrays to be used by
C ARSCAM for X/Y coordinates.
C
        PARAMETER (MCRA=  40000)
C
C Declare the area map arrays.
C
        DIMENSION IAMA(LAMA),IAMB(LAMB)
C
C Declare the X/Y scratch arrays and area-identifier-information arrays
C to be used by ARSCAM.
C
        DIMENSION XCRA(MCRA),YCRA(MCRA),IAAI(5),IAGI(5)
C
C Declare the names of some area- and line-processing routines EXTERNAL
C to keep the compiler from interpreting them as REAL variables.
C
        EXTERNAL COLORA,COLORL,COLORS
C
C Declare some arrays in which to put values defining some portions of
C the globe to be looked at.
C
        DIMENSION CLON(4),SLAT(4),SLON(4),BLAT(4),BLON(4)
        CHARACTER*64 LABL(4)
C
C Define the portions of the globe to be looked at.
C
        DATA CLON /  -90. ,  10. , 55. , 110. /
C
        DATA SLAT /   -9. ,  34. , 20. , -16. /
        DATA SLON / -145. , -10. , 20. ,  80. /
        DATA BLAT /   70. ,  65. , 60. ,  40. /
        DATA BLON /  -45. ,  40. , 90. , 140. /
C
        DATA LABL /
     +       'North America (Custer County, Nebraska, in Pink)',
     +       'Northern Europe (Slovakia in Pink)              ',
     +       'Eurasia (Uzbekistan in Pink)'                    ,
     +       'Southeast Asia (Cambodia in Pink)'               /
C
C Open GKS.
C
        CALL GOPKS (IERRF, ISZDM)
        CALL GOPWK (IWKID, LUNIT, IWTYPE)
        CALL GACWK (IWKID)
C
C Turn off clipping by GKS.
C
        CALL GSCLIP (0)
C
C Set the GKS "fill area interior style" to "solid".
C
        CALL GSFAIS (1)
C
C Define some color indices.  (DFCLRS is part of this example; it is
C not an NCAR Graphics library routine.)
C
        CALL DFCLRS (IWKID)
C
C Select PLOTCHAR font number 25, turn on the outlining of filled fonts,
C and turn off the setting of the outline color.
C
        CALL PCSETI ('FN - FONT NUMBER',25)
        CALL PCSETI ('OF - OUTLINE FLAG',1)
        CALL PCSETR ('OC - OUTLINE LINE COLOR',-1.)
C
C Turn on "vertical stripping" by EZMAP.  What this means is that a call
C to MPLNAM will put into an area map not only the geographical boundary
C lines (in edge group 1), but also lines (in edge group 2) defining
C some vertical strips (4, in this case).  This helps to break up the
C areas defined by the geographical boundaries in such a way as to
C reduce the total number of points required for any particular area.
C
        CALL MPSETI ('VS',4)
C
C Loop to depict three different portions of the globe.
C
        DO 105 IVEW=1,4
C
C Tell EZMAP to use a Mercator projection.  CLON(IVEW) is the center
C longitude.
C
          CALL MAPROJ ('ME',0.,CLON(IVEW),0.)
C
C Tell EZMAP to set up the map limits in such a way as to include all
C of a region from some smallest latitude and longitude to some biggest
C latitude and longitude.
C
          CALL MAPSET ('GR',SLAT(IVEW),SLON(IVEW),BLAT(IVEW),BLON(IVEW))
C
C Initialize EZMAP.
C
          CALL MAPINT
C
C Find out what SET call was done by EZMAP, reset the map limits in
C such a way as to make the map square, and then reinitialize.
C
          CALL GETSET (XVPL,XVPR,YVPB,YVPT,XWDL,XWDR,YWDB,YWDT,LNLG)
          XCEN=.5*(XWDL+XWDR)
          YCEN=.5*(YWDB+YWDT)
          HWTH=.5*MAX(XWDR-XWDL,YWDT-YWDB)
          CALL MAPSET ('LI',XCEN-HWTH,XCEN+HWTH,
     +                      YCEN-HWTH,YCEN+HWTH)
          CALL MAPINT
C
C Initialize both of area maps A and B.
C
          CALL ARINAM (IAMA,LAMA)
          CALL ARINAM (IAMB,LAMB)
C
C Put four concentric circles into both of area maps A and B (in edge
C group 5).  The interior of the smallest circle has area identifier 5,
C the ring around it has area identifier 4, the ring around that has
C area identifier 3, the ring around that has area identifier 2, and
C the remainder has area identifier 1.  These area identifiers will be
C used to determine the "level" at which the geographical information
C is to be displayed; level 5 means "counties", level 4 means "states",
C level 3 means "countries", level 2 means "continents", and level 1
C means just "land/water".
C
          DO 102 ICIR=1,4
            DO 101 IANG=1,361
              ANGL=.017453292519943*REAL(MOD(IANG-1,360))
              XCRA(IANG)=CFUX(.5+(.05+.13*REAL(ICIR-1))*COS(ANGL))
              YCRA(IANG)=CFUY(.5+(.05+.13*REAL(ICIR-1))*SIN(ANGL))
  101       CONTINUE
            CALL AREDAM (IAMA,XCRA,YCRA,361,5,6-ICIR,5-ICIR)
            CALL AREDAM (IAMB,XCRA,YCRA,361,5,6-ICIR,5-ICIR)
  102     CONTINUE
C
C Put all the EZMAP boundary lines from the named dataset (down to
C level 5) into area map A.
C
          CALL MPLNAM ('Earth..2',5,IAMA)
C
C Color the map as implied by the contents of area map A.  See the
C "user callback" routine COLORA (elsewhere in this file) to see how
C the area identifiers from groups 1 (geographic), 2 (vertical strips),
C and 5 (circles) are all used to produce the desired effect.
C
          CALL ARSCAM (IAMA,XCRA,YCRA,MCRA,IAAI,IAGI,5,COLORA)
C
C Print some numbers reflecting the amount of space actually used in
C the area map arrays.
C
          PRINT * , ' '
          PRINT * , 'Length of area map A: ',LAMA-IAMA(6)+IAMA(5)+1
          PRINT * , 'Length of area map B: ',LAMB-IAMB(6)+IAMB(5)+1
C
C Draw the EZMAP boundary lines masked by area map B; the lines are
C drawn differently inside each of the areas created by the concentric
C circles.
C
          CALL MPLNDM ('Earth..2',5,IAMB,XCRA,YCRA,MCRA,
     +                                         IAAI,IAGI,5,COLORL)
C
C Draw the concentric circles themselves.
C
          CALL GSLWSC (2.)
          CALL GSPLCI (2)
C
          DO 104 ICIR=1,4
            DO 103 IANG=1,361
              ANGL=.017453292519943*REAL(MOD(IANG-1,360))
              XCRA(IANG)=CFUX(.5+(.05+.13*REAL(ICIR-1))*COS(ANGL))
              YCRA(IANG)=CFUY(.5+(.05+.13*REAL(ICIR-1))*SIN(ANGL))
  103       CONTINUE
            CALL CURVE (XCRA,YCRA,361)
  104     CONTINUE
C
C Put some labels on the plot.
C
          CALL GSLWSC (1.)
          CALL GSPLCI (2)
          CALL GSFACI (2)
C
          CALL PLCHHQ (CFUX(.500),CFUY(.975),
     +                      'The Database "Earth..2" at Various Levels',
     +                                                       .018,0.,0.)
C
          CALL PLCHHQ (CFUX(.500),CFUY(.025),
     +                                 LABL(IVEW)(1:MPILNB(LABL(IVEW))),
     +                                                       .018,0.,0.)
C
          CALL PLCHHQ (CFUX(.142911),CFUY(.142911),'1',.02,0.,0.)
          CALL PLCHHQ (CFUX(.234835),CFUY(.234835),'2',.02,0.,0.)
          CALL PLCHHQ (CFUX(.326759),CFUY(.326759),'3',.02,0.,0.)
          CALL PLCHHQ (CFUX(.418683),CFUY(.418683),'4',.02,0.,0.)
          CALL PLCHHQ (CFUX(.500000),CFUY(.500000),'5',.02,0.,0.)
C
          CALL GSPLCI (1)
          CALL GSFACI (1)
C
C Advance the frame.
C
          CALL FRAME
C
C End of view loop.
C
  105   CONTINUE
C
C Close GKS.
C
        CALL GDAWK (IWKID)
        CALL GCLWK (IWKID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END



      SUBROUTINE DFCLRS (IWKS)
C
C Define some color indices for use in the example "mpex13" (0 = black,
C the background color; 1 = white, the foreground color; 2 = yellow,
C for some labels; 11 = white, for water/land edges; 12 = gray, for
C edges of continents; 13 = gray, for edges of countries; 14 = gray,
C for edges of states; 15 = gray, for edges of counties; 16 = pink,
C for highlighted areas; 101-107 = area colors 1-7).
C
        CALL GSCR (IWKS,  0,0.,0.,0.)
        CALL GSCR (IWKS,  1,1.,1.,1.)
        CALL GSCR (IWKS,  2,1.,1.,0.)
        CALL GSCR (IWKS, 11,1.,1.,1.)
        CALL GSCR (IWKS, 12,1.,1.,1.)
        CALL GSCR (IWKS, 13,1.,1.,1.)
        CALL GSCR (IWKS, 14,1.,1.,1.)
        CALL GSCR (IWKS, 15,.1,.1,.1)
        CALL GSCR (IWKS, 16,1.,.6,.6)
        CALL GSCR (IWKS,101,.2,.2,.8)
        CALL GSCR (IWKS,102,.2,.4,.6)
        CALL GSCR (IWKS,103,.2,.6,.4)
        CALL GSCR (IWKS,104,.2,.8,.2)
        CALL GSCR (IWKS,105,.4,.6,.2)
        CALL GSCR (IWKS,106,.6,.4,.2)
        CALL GSCR (IWKS,107,.6,.6,.6)
C
        RETURN
C
      END



      SUBROUTINE MPCHLN (IFLG,ILTY,IOAL,IOAR,NPTS,PNTS)
C
        DIMENSION PNTS(*)
C
C This version of the "user callback" routine MPCHLN determines some
C characteristics of lines of different types drawn by calls to MPLNDM
C and MPLNDR, as follows:
C
C     Level 1 (land/water boundaries): double thickness, color 11
C     Level 2 (continental boundaries): double thickness, color 12
C     Level 3 (country boundaries): double thickness, color 13
C     Level 4 (state boundaries): single thickness, color 14
C     Level 5 (county boundaries): single thickness, color 15
C
C Flush SPPS pen-move buffers.
C
        CALL PLOTIF (0.,0.,2)
C
C If IFLG is greater than one, a line of type ILTY is about to be
C drawn; set up the desired characteristics.
C
        IF (IFLG.GT.1) THEN
C
          IF      (ILTY.EQ.1) THEN
            CALL GSLWSC (2.)
            CALL GSPLCI (11)
          ELSE IF (ILTY.EQ.2) THEN
            CALL GSLWSC (2.)
            CALL GSPLCI (12)
          ELSE IF (ILTY.EQ.3) THEN
            CALL GSLWSC (2.)
            CALL GSPLCI (13)
          ELSE IF (ILTY.EQ.4) THEN
            CALL GSLWSC (1.)
            CALL GSPLCI (14)
          ELSE IF (ILTY.EQ.5) THEN
            CALL GSLWSC (1.)
            CALL GSPLCI (15)
          END IF
C
C If, on the other hand, IFLG is less than minus one, a line was just
C drawn; reset line characteristics to default values.
C
        ELSE IF (IFLG.LT.-1) THEN
C
          CALL GSLWSC (1.)
          CALL GSPLCI (1)
C
        END IF
C
C Done.
C
        RETURN
C
      END



      SUBROUTINE COLORA (XCRA,YCRA,NCRA,IAAI,IAGI,NGPS)
C
        DIMENSION XCRA(NCRA),YCRA(NCRA),IAAI(NGPS),IAGI(NGPS)
C
C In the example "mpex13", the routine COLORA is called by the AREAS
C routine ARSCAM to fill the areas created by area map A.
C
        CHARACTER*128 MPFNME
C
C Extract the area identifiers of the area relative to groups 1
C (geographic), 2 (vertical stripping), and 5 (concentric circles).
C
        IAI1=-1
        IAI2=-1
        IAI5=-1
C
        DO 101 I=1,NGPS
          IF (IAGI(I).EQ.1) IAI1=IAAI(I)
          IF (IAGI(I).EQ.2) IAI2=IAAI(I)
          IF (IAGI(I).EQ.5) IAI5=IAAI(I)
  101   CONTINUE
C
C If all the area identifiers have valid values, choose a color for the
C area and fill it.  If the full name of it is "Nebraska - Custer",
C "Slovakia", "Uzbekistan", or "Cambodia", it is filled using color 16
C (pink); otherwise, we use the suggested color for the area at the
C level implied by the group-5 area identifier.
C
        IF (IAI1.GE.1) THEN
          IF (IAI2.GE.0) THEN
            IF (IAI5.GE.1) THEN
              IF (MPFNME(IAI1,4).EQ.'Nebraska - Custer'.OR.
     +            MPFNME(IAI1,4).EQ.'Slovakia'.OR.
     +            MPFNME(IAI1,4).EQ.'Uzbekistan'.OR.
     +            MPFNME(IAI1,4).EQ.'Cambodia') THEN
                CALL GSFACI (16)
              ELSE
                CALL GSFACI (100+MPISCI(MPIOSA(IAI1,IAI5)))
              END IF
              CALL GFA (NCRA-1,XCRA,YCRA)
            END IF
          END IF
        END IF
C
C Done.
C
        RETURN
C
      END



      SUBROUTINE COLORS (XCRA,YCRA,NCRA,IAAI,IAGI,NGPS)
C
        DIMENSION XCRA(NCRA),YCRA(NCRA),IAAI(NGPS),IAGI(NGPS)
C
C In the example "mpex11", the routine COLORS is used to color the areas
C on the zoom-in frames.  Only group-1 and group-2 area identifiers are
C examined and the colors suggested by the contents of the EZMAP dataset
C are used.
C
        IAI1=-1
        IAI2=-1
C
        DO 101 I=1,NGPS
          IF (IAGI(I).EQ.1) IAI1=IAAI(I)
          IF (IAGI(I).EQ.2) IAI2=IAAI(I)
  101   CONTINUE
C
        IF (IAI1.GE.1) THEN
          IF (IAI2.GE.0) THEN
            CALL GSFACI (100+MPISCI(IAI1))
            CALL GFA (NCRA-1,XCRA,YCRA)
          END IF
        END IF
C
C Done.
C
        RETURN
C
      END



      SUBROUTINE COLORL (XCRA,YCRA,NCRA,IAAI,IAGI,NGPS)
C
        DIMENSION XCRA(NCRA),YCRA(NCRA),IAAI(NGPS),IAGI(NGPS)
C
C In the example "mpex13", the routine COLORL is called by the EZMAPB
C routine MPLNDM to draw lines masked by the contents of area map B.
C
C Get the value of the line type for the line being drawn.
C
        CALL MPGLTY (ILTY)
C
C Find the area identifier relative to group 5 (the circles).
C
        IAI5=-1
C
        DO 101 I=1,NGPS
          IF (IAGI(I).EQ.5) IAI5=IAAI(I)
  101   CONTINUE
C
C If the group-5 area identifier is valid, draw the line if and only
C if its type is less than or equal to the group-5 area identifier.
C What this means is that all boundary lines (down to the county level)
C are drawn in the inner circle, county lines are omitted in the ring
C surrounding that, state lines are omitted in the ring surrounding
C that, country lines are omitted in the ring surrounding that, and
C continental boundary lines are omitted elsewhere.
C
        IF (IAI5.GE.1) THEN
          IF (ILTY.LE.IAI5) THEN
            CALL GPL (NCRA,XCRA,YCRA)
          END IF
        END IF
C
C Done.
C
        RETURN
C
      END

C
C       $Id: stthin.f,v 1.4 2008-07-27 00:17:28 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE STTHIN (U,V,P,UFR,VFR)
C
C Argument dimensions
C
      DIMENSION U(IUD1,*), V(IVD1,*), P(IPD1,*)
      DIMENSION UFR(IXDM,IYDN),VFR(IXDM,IYDN)
C
C Input parameters
C
C U,V    - 2-d arrays holding the component values of a vector field
C P  - A 2-d array containing a scalar data field. The contents
C          of this array may be used to color the vectors 
C
C Output parameters:
C
C UFR,VFR  - 2-d arrays in which are placed the NDC locations of each
C          vector. After the positions are calculated, for vectors that
C          are not to be drawn, the UFR array element is replaced with
C          the value -1.0.
C
C ---------------------------------------------------------------------
C
C NOTE:
C Since implicit typing is used for all real and integer variables
C a consistent length convention has been adopted to help clarify the
C significance of the variables encountered in the code for this 
C utility. All local variable and subroutine parameter identifiers 
C are limited to 1,2,or 3 characters. Four character names identify  
C members of common blocks. Five and 6 character variable names 
C denote PARAMETER constants or subroutine or function names.
C
C Declare the ST common blocks.
C
      PARAMETER (IPLVLS = 256)
C
C Integer and real common block variables
C
C
      COMMON / STPAR /
     +                IUD1       ,IVD1       ,IPD1       ,
     +                IXD1       ,IXDM       ,IYD1       ,IYDN       ,
     +                IXM1       ,IYM1       ,IXM2       ,IYM2       ,
     +                IWKD       ,IWKU       ,ISET       ,IERR       ,
     +                IXIN       ,IYIN       ,IMSK       ,ICPM       ,
     +                NLVL       ,IPAI       ,ICTV       ,WDLV       ,
     +                UVMN       ,UVMX       ,PMIN       ,PMAX       ,
     +                IPLR       ,ISST       ,
     +                ICLR(IPLVLS)           ,TVLU(IPLVLS)
C
      COMMON / STTRAN /
     +                UVPS       ,
     +                UVPL       ,UVPR       ,UVPB       ,UVPT       ,
     +                UWDL       ,UWDR       ,UWDB       ,UWDT       ,
     +                UXC1       ,UXCM       ,UYC1       ,UYCN 
C
C Stream algorithm parameters
C
      COMMON / STSTRM /
     +                ISGD       ,IAGD       ,RARL       ,ICKP       ,
     +                ICKX       ,ITRP       ,ICYK       ,RVNL       ,
     +                ISVF       ,RUSV       ,RVSV       ,RNDA       ,
     +                ISPC       ,RPSV       ,RCDS       ,RSSP       ,
     +                RDFM       ,RSMD       ,RAMD       ,IGBS       ,
     +                ISTM       ,RVRL       ,RVFR       ,RVRM       ,
     +                IVPO       ,RAFR       ,RDMX       ,RDMN
C
C Text related parameters
C Note: graphical text output is not yet implemented for the
C       Streamline utility.
C
      COMMON / STTXP /
     +                FCWM    ,ICSZ    ,
     +                FMNS    ,FMNX    ,FMNY    ,IMNP    ,IMNC  ,
     +                FMXS    ,FMXX    ,FMXY    ,IMXP    ,IMXC  ,
     +                FZFS    ,FZFX    ,FZFY    ,IZFP    ,IZFC  ,
     +                FILS    ,FILX    ,FILY    ,IILP    ,IILC 
C
C Character variable declartions
C
      CHARACTER*160 CSTR
      PARAMETER (IPCHSZ=80)
      CHARACTER*(IPCHSZ)  CMNT,CMXT,CZFT,CILT
C
C Text string parameters
C
      COMMON / STCHAR / CSTR,CMNT,CMXT,CZFT,CILT
C
      SAVE /STPAR/, /STTRAN/, /STSTRM/, /STTXP/, /STCHAR/
C
C Internal buffer lengths
C
C IPNPTS - Number of points in the point buffer -- not less than 3
C IPLSTL - Streamline-crossover-check circular list length
C IPGRCT - Number of groups supported for area masking
C
      PARAMETER (IPNPTS = 256, IPLSTL = 750, IPGRCT = 64)
C --------------------------------------------------------------------
C
C The mapping common block: made available to user mapping routines
C
      COMMON /STMAP/
     +                IMAP       ,LNLG       ,INVX       ,INVY       ,
     +                XLOV       ,XHIV       ,YLOV       ,YHIV       ,
     +                WXMN       ,WXMX       ,WYMN       ,WYMX       ,
     +                XVPL       ,XVPR       ,YVPB       ,YVPT       ,
     +                XGDS       ,YGDS       ,NXCT       ,NYCT       ,
     +                ITRT       ,FW2W       ,FH2H       ,
     +                DFMG       ,VNML       ,RBIG       ,IBIG
C
      SAVE /STMAP/
C
C Math constants
C
      PARAMETER (PDTOR  = 0.017453292519943,
     +           PRTOD  = 57.2957795130823,
     +           P1XPI  = 3.14159265358979,
     +           P2XPI  = 6.28318530717959,
     +           P1D2PI = 1.57079632679489,
     +           P5D2PI = 7.85398163397448) 
C
C Local variables
C
C
C The following status and count variables are used to gather
C statistics that are not currently available to the user
C
C IST - Status flag returned from the mapping routine
C
C Vector length adjustment
C
C I,J - loop indices for traversing the vector arrays
C UI,VI - local copies of the current vector values
C UVM   - magnitude of the current vector
C XB,XE,YB,XE - the beginning/ending points of the vector in 
C               the fractional system
C X,Y - mapping of the array indices to a coordinate system
C XGV,YGV - X and Y grid value, the scaled distance between each
C           array grid point
C SMD - streamline min distance (NDC): the primary thinning parameter
C ---------------------------------------------------------------------
C
C Calculate the grid interval represented by adjacent array
C elements along each axis
C
      XGV=(XHIV-XLOV)/REAL(MAX(1,IXDM-1))
      YGV=(YHIV-YLOV)/REAL(MAX(1,IYDN-1))
C
C Calculate the vector locations.
C Vectors not to be plotted are marked with the following special codes:
C      -1.0: vector removed by thinning process
C      -2.0: special value
C      -3.0: below minimum magnitude
C      -5.0: zero-length vector
C      -6.0: rejected by mapping routine
C
      DO 201 J=1,IYDN,IYIN
         DO 200 I=1,IXDM,IXIN
C
C Cull out special values
C
            CALL STSVCK(U,V,I,J,IST)
            IF (IST .NE. 0) GO TO 199
C
            UI = U(I,J)
            VI = V(I,J)
C
C            IF (ISVF .GT. 0) THEN
C               IF (UI .EQ. RUSV .OR. VI .EQ. RVSV) GO TO 199
C            END IF
C
C Calculate the vector magnitude or if the polar flag is set
C compute the cartesian component values
C
            IF (IPLR .LE. 0) THEN
               UVM = SQRT(UI*UI+VI*VI)
            ELSE
               UVM = UI
               IF (IPLR .EQ. 1) VI = PDTOR * VI
               UI = UVM * COS(VI)
               VI = UVM * SIN(VI)
            END IF
C
C Bypass vectors that fall outside the user-specified range.
C
            IF (UVM .LT. UVMN) GO TO 196
C
            IF (UVM .LE. 0.0) GO TO 198
C
C Map the vector.
C
C
            X=XLOV+REAL(I-1)*XGV
            Y=YLOV+REAL(J-1)*YGV
            CALL HLUSTMPXY(X,Y,XUS,YUS,IST)
            IF (IST .NE. 0) GO TO 195
            XND = CUFX(XUS)
            YND = CUFY(YUS)
C
            UFR(I,J)=XND
            VFR(I,J)=YND
            GOTO 200
C
 195        CONTINUE
C
C Vectors rejected by mapping routine
C
            UFR(I,J) = -6.0
            GO TO 200
C
 196        CONTINUE
C
C Vectors under minimum magnitude
C
            UFR(I,J) = -3.0
            GO TO 200
C
C Zero length vectors cannot be drawn even if UVMN is 0.0, but
C need to be treated as if they were drawn.
C
 198        CONTINUE
C
            UFR(I,J) = -5.0
            GO TO 200
C
C Special values
C
 199        CONTINUE
            UFR(I,J) = -2.0
C
 200     CONTINUE
 201  CONTINUE
C
C End of location loop.
C
C For each vector determine the vectors nearby that are too close;
C eliminate these vectors      
C
      SMD=RSMD*FW2W
      VSQ = SMD*SMD
      DO 501 J=1,IYDN,IYIN
         DO 500 I=1,IXDM,IXIN
            IF (UFR(I,J) .LT. 0.0) GO TO 500
C
            MXI = I+IXIN
            DO 401 JJ=J,IYDN,IYIN
               IF (MXI.LE.I) THEN
                  GO TO 405
               END IF
               ICM = I
               DO 400 II=I,IXDM,IXIN
                  IF (I.EQ.II .AND. J.EQ.JJ) THEN
                     ICM = I+IXIN
                     GO TO 400
                  END IF
                  IF (UFR(II,JJ).LT.0.0) THEN
                     ICM = II + IXIN
                     GO TO 400
                  END IF
                  UT = UFR(I,J) - UFR(II,JJ)
                  VT = VFR(I,J) - VFR(II,JJ)
                  VLS = UT*UT+VT*VT
                  IF (VLS .LT. VSQ) THEN
                     UFR(II,JJ) = -1.0
                     ICM = II + IXIN
                     GO TO 400
                  ELSE 
                     MXI = ICM
                     GO TO 401
                  END IF
 400           CONTINUE
 401        CONTINUE
C
 405        CONTINUE
C
            JJMX = MIN(JJ,IYDN)
            MNI = I - 2*IXIN
            DO 411 JJ=J+IYIN,JJMX,IYIN
               IF (MNI.GE.I) THEN
                  GO TO 500
               END IF
               ICM = I - IXIN
               DO 410 II = I - IXIN,1,-IXIN
                  IF (UFR(II,JJ).EQ.-1.0) THEN
                     GO TO 411
                  END IF
                  IF (UFR(II,JJ).LT.0.0) THEN
                     ICM = II - IXIN
                     GO TO 410
                  END IF
                  UT = UFR(I,J) - UFR(II,JJ)
                  VT = VFR(I,J) - VFR(II,JJ)
                  VLS = UT*UT+VT*VT
                  IF (VLS .LT. VSQ) THEN
                     UFR(II,JJ) = -1.0
                     ICM = II - IXIN
                     GO TO 410
                  ELSE 
                     MNI = ICM
                     GO TO 411
                  END IF
 410           CONTINUE
 411        CONTINUE
C
 500     CONTINUE
 501  CONTINUE
C
C Check the edge elements backwards in case the grid wraps
C First along the left edge
C
      MXX = (IXDM-1)/IXIN * IXIN + 1
C
      DO 700 J=1,IYDN,IYIN
         IF (UFR(1,J) .LT. 0.0) THEN
            GO TO 700
         END IF
         DO 650 I=1,IXDM,IXIN
            IF (UFR(I,J) .LT. 0.0) THEN
               IF (I.EQ.MXX) GO TO 700
               GO TO 650
            END IF
            GO TO 651
 650     CONTINUE
 651     CONTINUE
C
         MNI = MXX - IXIN
         DO 601 JJ=J,IYDN,IYIN
            IF (MNI.GE.MXX) THEN
               GO TO 700
            END IF
            ICM = MXX
            DO 600 II=MXX,1,-IXIN
               IF (JJ.EQ.J) THEN
                  IF (II.EQ.1) THEN
                     GO TO 601
                  END IF
                  ICM = MXX - IXIN
               END IF
               IF (UFR(II,JJ).LT.0.0) THEN
                  ICM = II - IXIN
                  GO TO 600
               END IF
               UT = UFR(1,J) - UFR(II,JJ)
               VT = VFR(1,J) - VFR(II,JJ)
               VLS = UT*UT+VT*VT
               IF (VLS .LT. VSQ) THEN
                  ICM = II - IXIN
                  UFR(II,JJ) = -1.0
                  GO TO 600
               ELSE IF (II.GT.MNI) THEN
                  GO TO 600
               ELSE
                  MNI = ICM
                  GO TO 601
               END IF
 600        CONTINUE
 601        CONTINUE
C
 700  CONTINUE
C
      MXY = (IYDN-1)/IYIN * IYIN + 1
C
      DO 900 I=  1,IXDM,IXIN
         ITMP = 0
         DO 750 J=1,IYDN,IYIN
            IF (UFR(I,J) .LT. 0.0) THEN
               IF (J.EQ.MXY) GO TO 900
               GO TO 750
            END IF
            GO TO 751
 750     CONTINUE
 751     CONTINUE
C
         MNJ = MXY - IYIN
         DO 801 II=I,IXDM,IXIN
            IF (MNJ.GE.MXY) THEN
               GO TO 900
            END IF
            ICM = MXY
            DO 800 JJ=MXY,1,-IYIN
               IF (II.EQ.I) THEN
                  ICM = MXY - IXIN
                  IF (JJ.EQ.J) THEN
                     GO TO 800
                  END IF
               END IF   
               IF (UFR(II,JJ).LT.0.0) THEN
                  ICM = JJ - IYIN
                  GO TO 800
               END IF
               UT = UFR(I,J) - UFR(II,JJ)
               VT = VFR(I,J) - VFR(II,JJ)
               VLS = UT*UT+VT*VT
               IF (VLS .LT. VSQ) THEN
                  ICM = JJ - IYIN
                  UFR(II,JJ) = -1.0
                  GO TO 800
               ELSE IF (JJ.GE.MNJ) THEN
                  GO TO 801
               ELSE
                  MNJ = ICM
                  GO TO 801
               END IF
 800        CONTINUE
 801        CONTINUE
C
 900  CONTINUE
C
C Done
C
      RETURN
      END
C
      SUBROUTINE STTHND(I,J,UFR,IS)
C
C Argument dimensions
C
      DIMENSION UFR(IXDM,IYDN)
C
C Input parameters
C I,J    - Indexes of grid point
C UFR    - A 2-d array containing the value -1.0 for all vectors 
C          to be thinned from the plot
C Output parameters:
C
C IS     - set to 1 if vector is to be culled, 0 otherwise.
C
C ---------------------------------------------------------------------
C
C NOTE:
C Since implicit typing is used for all real and integer variables
C a consistent length convention has been adopted to help clarify the
C significance of the variables encountered in the code for this 
C utility. All local variable and subroutine parameter identifiers 
C are limited to 1,2,or 3 characters. Four character names identify  
C members of common blocks. Five and 6 character variable names 
C denote PARAMETER constants or subroutine or function names.
C
C Declare the ST common blocks.
C
      PARAMETER (IPLVLS = 256)
C
C Integer and real common block variables
C
C
      COMMON / STPAR /
     +                IUD1       ,IVD1       ,IPD1       ,
     +                IXD1       ,IXDM       ,IYD1       ,IYDN       ,
     +                IXM1       ,IYM1       ,IXM2       ,IYM2       ,
     +                IWKD       ,IWKU       ,ISET       ,IERR       ,
     +                IXIN       ,IYIN       ,IMSK       ,ICPM       ,
     +                NLVL       ,IPAI       ,ICTV       ,WDLV       ,
     +                UVMN       ,UVMX       ,PMIN       ,PMAX       ,
     +                IPLR       ,ISST       ,
     +                ICLR(IPLVLS)           ,TVLU(IPLVLS)
C
      COMMON / STTRAN /
     +                UVPS       ,
     +                UVPL       ,UVPR       ,UVPB       ,UVPT       ,
     +                UWDL       ,UWDR       ,UWDB       ,UWDT       ,
     +                UXC1       ,UXCM       ,UYC1       ,UYCN 
C
C Stream algorithm parameters
C
      COMMON / STSTRM /
     +                ISGD       ,IAGD       ,RARL       ,ICKP       ,
     +                ICKX       ,ITRP       ,ICYK       ,RVNL       ,
     +                ISVF       ,RUSV       ,RVSV       ,RNDA       ,
     +                ISPC       ,RPSV       ,RCDS       ,RSSP       ,
     +                RDFM       ,RSMD       ,RAMD       ,IGBS       ,
     +                ISTM       ,RVRL       ,RVFR       ,RVRM       ,
     +                IVPO       ,RAFR       ,RDMX       ,RDMN
C
C Text related parameters
C Note: graphical text output is not yet implemented for the
C       Streamline utility.
C
      COMMON / STTXP /
     +                FCWM    ,ICSZ    ,
     +                FMNS    ,FMNX    ,FMNY    ,IMNP    ,IMNC  ,
     +                FMXS    ,FMXX    ,FMXY    ,IMXP    ,IMXC  ,
     +                FZFS    ,FZFX    ,FZFY    ,IZFP    ,IZFC  ,
     +                FILS    ,FILX    ,FILY    ,IILP    ,IILC 
C
C Character variable declartions
C
      CHARACTER*160 CSTR
      PARAMETER (IPCHSZ=80)
      CHARACTER*(IPCHSZ)  CMNT,CMXT,CZFT,CILT
C
C Text string parameters
C
      COMMON / STCHAR / CSTR,CMNT,CMXT,CZFT,CILT
C
      SAVE /STPAR/, /STTRAN/, /STSTRM/, /STTXP/, /STCHAR/
C
C Internal buffer lengths
C
C IPNPTS - Number of points in the point buffer -- not less than 3
C IPLSTL - Streamline-crossover-check circular list length
C IPGRCT - Number of groups supported for area masking
C
      PARAMETER (IPNPTS = 256, IPLSTL = 750, IPGRCT = 64)
C
      IF (UFR(I,J) .LE. -1.0) THEN
         IS = 1
      ELSE
         IS = 0
      END IF
C
C Done
C
      RETURN
      END
            

C
C $Id: istr32.f,v 1.6 2008-07-27 00:17:16 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE ISTR32 (UT,VT,WT,XT,YT,ZT,IENT)
C
C This routine implements the 3-space to 2-space transformation by
C Kuber, Szabo and Giulieri, as described in "The Perspective
C Representation of Functions of Two Variables", Journal of the ACM
C 15, 2, 193-204, 1968.
C
C If IENT = 1, the transformation is being defined:
C
C   UT, VT, and WT are the 3-space coordinates of the intersection of
C   the line of sight and the image plane.  This point can be thought
C   of as the point looked at.
C
C   XT, YT, and ZT are the 3-space coordinates of the eye position.
C
C If IENT is 2, a point is being transformed:
C
C   UT, VT, WT are the 3-space coordinates of a point to be transformed.
C
C   XT and YT are the coordinates resulting from the 3-space to 2-space
C   transformation.  When ISCALE is zero, XT and YT are in the same
C   units as U, V, and W.  When ISCALE is non-zero, XT and YT are in
C   the fractional coordinate system.
C
C   ZT is not used.
C
C Due to the nature of this routine, all variables used in it are saved
C from call to call.
C
      SAVE
C
      COMMON /ISCOMN/ BIG,BIGD,DBPI,IDONE,IFILL,IFLIP,IONES,IHSS(1000),
     +                IREF,ISCA(16,256),ISCALE,ISCR(16,256),ISLBT,ISDR,
     +                LHSS,LX,NFPW,NINU,NINV,NINW,NX,NY,R0,RNX,RNY,
     +                SMALL,SVAL,TENSN,U,V,W,XMAX,XMIN,YMAX,YMIN,XVPL,
     +                XVPR,YVPB,YVPT
C
      COMMON /PWRZ1I/ UUMIN,UUMAX,VVMIN,VVMAX,WWMIN,WWMAX,DELCRT,EYEU,
     +                EYEV,EYEW
C
C Define the range of fractional coordinates to be used.
C
      DATA FXL,FXR,FYB,FYT / .0005,.9995,.0005,.9995 /
C
C Define the value of "pi".
C
      DATA PI / 3.14159265358979 /
C
C Decide what kind of call was done.
C
      IF (IENT .NE. 1) GO TO  50
C
C The transformation is to be defined:
C
      AU = UT
      AV = VT
      AW = WT
      EU = XT
      EV = YT
      EW = ZT
C
      DU = AU-EU
      DV = AV-EV
      DW = AW-EW
      D = SQRT(DU*DU+DV*DV+DW*DW)
      COSAL = DU/D
      COSBE = DV/D
      COSGA = DW/D
C
      AL = ATAN(ABS(SQRT(1.-COSAL*COSAL)/COSAL))
      IF (COSAL .LE. 0.) AL = PI-AL
      BE = ATAN(ABS(SQRT(1.-COSBE*COSBE)/COSBE))
      IF (COSBE .LE. 0.) BE = PI-BE
      GA = ATAN(ABS(SQRT(1.-COSGA*COSGA)/COSGA))
      IF (COSGA .LE. 0.) GA = PI-GA
      SINGA = SIN(GA)
C
C The 3-space point looked at is transformed into (0,0) of the 2-space
C plane.  The 3-space W axis is transformed into the 2-space Y axis.
C If the line of sight is almost parallel to the 3-space W axis, the
C 3-space V axis is chosen (instead of the 3-space W axis) to be
C transformed into the 2-space Y axis.
C
      JDONE = 2
      IF (ISCALE)  10, 30, 10
   10 X0 = XMIN
      Y0 = YMIN
      X1 = FXL
      Y1 = FYB
      X2 = FXR-FXL
      Y2 = FYT-FYB
      X3 = X2/(XMAX-XMIN)
      Y3 = Y2/(YMAX-YMIN)
      X4 = FXR
      Y4 = FYT
      FACT = 1.
      IF (BIGD .LE. 0.) GO TO  20
      X0 = -BIGD
      Y0 = -BIGD
      X3 = X2/(2.*BIGD)
      Y3 = Y2/(2.*BIGD)
      FACT = R0/D
   20 DELCRT = X2*32767.
      JDONE = 1
   30 IF (SINGA .LT. 0.0001) GO TO  40
      R = 1./SINGA
      JUMP = 2
      RETURN
   40 SINBE = SIN(BE)
      R = 1./SINBE
      JUMP = 1
      RETURN
C
C A point is to be transformed:
C
   50 UU = UT
      VV = VT
      WW = WT
      Q = D/((UU-EU)*COSAL+(VV-EV)*COSBE+(WW-EW)*COSGA)
      GO TO (60, 70), JUMP
   60 UU = ((EW+Q*(WW-EW)-AW)*COSAL-(EU+Q*(UU-EU)-AU)*COSGA)*R
      VV = (EV+Q*(VV-EV)-AV)*R
      GO TO (80, 90), JDONE
   70 UU = ((EU+Q*(UU-EU)-AU)*COSBE-(EV+Q*(VV-EV)-AV)*COSAL)*R
      VV = (EW+Q*(WW-EW)-AW)*R
      GO TO (80, 90), JDONE
   80 XT = MIN(X4,MAX(X1,X1+X3*(FACT*UU-X0)))
      YT = MIN(Y4,MAX(Y1,Y1+Y3*(FACT*VV-Y0)))
      RETURN
   90 XT = UU
      YT = VV
      RETURN
C
      END

      SUBROUTINE DLAPMT( FORWRD, M, N, X, LDX, K )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     March 31, 1993
*
*     .. Scalar Arguments ..
      LOGICAL            FORWRD
      INTEGER            LDX, M, N
*     ..
*     .. Array Arguments ..
      INTEGER            K( * )
      DOUBLE PRECISION   X( LDX, * )
*     ..
*
*  Purpose
*  =======
*
*  DLAPMT rearranges the columns of the M by N matrix X as specified
*  by the permutation K(1),K(2),...,K(N) of the integers 1,...,N.
*  If FORWRD = .TRUE.,  forward permutation:
*
*       X(*,K(J)) is moved X(*,J) for J = 1,2,...,N.
*
*  If FORWRD = .FALSE., backward permutation:
*
*       X(*,J) is moved to X(*,K(J)) for J = 1,2,...,N.
*
*  Arguments
*  =========
*
*  FORWRD  (input) LOGICAL
*          = .TRUE., forward permutation
*          = .FALSE., backward permutation
*
*  M       (input) INTEGER
*          The number of rows of the matrix X. M >= 0.
*
*  N       (input) INTEGER
*          The number of columns of the matrix X. N >= 0.
*
*  X       (input/output) DOUBLE PRECISION array, dimension (LDX,N)
*          On entry, the M by N matrix X.
*          On exit, X contains the permuted matrix X.
*
*  LDX     (input) INTEGER
*          The leading dimension of the array X, LDX >= MAX(1,M).
*
*  K       (input) INTEGER array, dimension (N)
*          On entry, K contains the permutation vector.
*
*  =====================================================================
*
*     .. Local Scalars ..
      INTEGER            I, II, IN, J
      DOUBLE PRECISION   TEMP
*     ..
*     .. Executable Statements ..
*
      IF( N.LE.1 )
     $   RETURN
*
      DO 10 I = 1, N
         K( I ) = -K( I )
   10 CONTINUE
*
      IF( FORWRD ) THEN
*
*        Forward permutation
*
         DO 50 I = 1, N
*
            IF( K( I ).GT.0 )
     $         GO TO 40
*
            J = I
            K( J ) = -K( J )
            IN = K( J )
*
   20       CONTINUE
            IF( K( IN ).GT.0 )
     $         GO TO 40
*
            DO 30 II = 1, M
               TEMP = X( II, J )
               X( II, J ) = X( II, IN )
               X( II, IN ) = TEMP
   30       CONTINUE
*
            K( IN ) = -K( IN )
            J = IN
            IN = K( IN )
            GO TO 20
*
   40       CONTINUE
*
   50    CONTINUE
*
      ELSE
*
*        Backward permutation
*
         DO 90 I = 1, N
*
            IF( K( I ).GT.0 )
     $         GO TO 80
*
            K( I ) = -K( I )
            J = K( I )
   60       CONTINUE
            IF( J.EQ.I )
     $         GO TO 80
*
            DO 70 II = 1, M
               TEMP = X( II, I )
               X( II, I ) = X( II, J )
               X( II, J ) = TEMP
   70       CONTINUE
*
            K( J ) = -K( J )
            J = K( J )
            GO TO 60
*
   80       CONTINUE
*
   90    CONTINUE
*
      END IF
*
      RETURN
*
*     End of DLAPMT
*
      END

      SUBROUTINE SSYGVX( ITYPE, JOBZ, RANGE, UPLO, N, A, LDA, B, LDB,
     $                   VL, VU, IL, IU, ABSTOL, M, W, Z, LDZ, WORK,
     $                   LWORK, IWORK, IFAIL, INFO )
*
*  -- LAPACK driver routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          JOBZ, RANGE, UPLO
      INTEGER            IL, INFO, ITYPE, IU, LDA, LDB, LDZ, LWORK, M, N
      REAL               ABSTOL, VL, VU
*     ..
*     .. Array Arguments ..
      INTEGER            IFAIL( * ), IWORK( * )
      REAL               A( LDA, * ), B( LDB, * ), W( * ), WORK( * ),
     $                   Z( LDZ, * )
*     ..
*
*  Purpose
*  =======
*
*  SSYGVX computes selected eigenvalues, and optionally, eigenvectors
*  of a real generalized symmetric-definite eigenproblem, of the form
*  A*x=(lambda)*B*x,  A*Bx=(lambda)*x,  or B*A*x=(lambda)*x.  Here A
*  and B are assumed to be symmetric and B is also positive definite.
*  Eigenvalues and eigenvectors can be selected by specifying either a
*  range of values or a range of indices for the desired eigenvalues.
*
*  Arguments
*  =========
*
*  ITYPE   (input) INTEGER
*          Specifies the problem type to be solved:
*          = 1:  A*x = (lambda)*B*x
*          = 2:  A*B*x = (lambda)*x
*          = 3:  B*A*x = (lambda)*x
*
*  JOBZ    (input) CHARACTER*1
*          = 'N':  Compute eigenvalues only;
*          = 'V':  Compute eigenvalues and eigenvectors.
*
*  RANGE   (input) CHARACTER*1
*          = 'A': all eigenvalues will be found.
*          = 'V': all eigenvalues in the half-open interval (VL,VU]
*                 will be found.
*          = 'I': the IL-th through IU-th eigenvalues will be found.
*
*  UPLO    (input) CHARACTER*1
*          = 'U':  Upper triangle of A and B are stored;
*          = 'L':  Lower triangle of A and B are stored.
*
*  N       (input) INTEGER
*          The order of the matrix pencil (A,B).  N >= 0.
*
*  A       (input/output) REAL array, dimension (LDA, N)
*          On entry, the symmetric matrix A.  If UPLO = 'U', the
*          leading N-by-N upper triangular part of A contains the
*          upper triangular part of the matrix A.  If UPLO = 'L',
*          the leading N-by-N lower triangular part of A contains
*          the lower triangular part of the matrix A.
*
*          On exit, the lower triangle (if UPLO='L') or the upper
*          triangle (if UPLO='U') of A, including the diagonal, is
*          destroyed.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(1,N).
*
*  B       (input/output) REAL array, dimension (LDA, N)
*          On entry, the symmetric matrix B.  If UPLO = 'U', the
*          leading N-by-N upper triangular part of B contains the
*          upper triangular part of the matrix B.  If UPLO = 'L',
*          the leading N-by-N lower triangular part of B contains
*          the lower triangular part of the matrix B.
*
*          On exit, if INFO <= N, the part of B containing the matrix is
*          overwritten by the triangular factor U or L from the Cholesky
*          factorization B = U**T*U or B = L*L**T.
*
*  LDB     (input) INTEGER
*          The leading dimension of the array B.  LDB >= max(1,N).
*
*  VL      (input) REAL
*  VU      (input) REAL
*          If RANGE='V', the lower and upper bounds of the interval to
*          be searched for eigenvalues. VL < VU.
*          Not referenced if RANGE = 'A' or 'I'.
*
*  IL      (input) INTEGER
*  IU      (input) INTEGER
*          If RANGE='I', the indices (in ascending order) of the
*          smallest and largest eigenvalues to be returned.
*          1 <= IL <= IU <= N, if N > 0; IL = 1 and IU = 0 if N = 0.
*          Not referenced if RANGE = 'A' or 'V'.
*
*  ABSTOL  (input) REAL
*          The absolute error tolerance for the eigenvalues.
*          An approximate eigenvalue is accepted as converged
*          when it is determined to lie in an interval [a,b]
*          of width less than or equal to
*
*                  ABSTOL + EPS *   max( |a|,|b| ) ,
*
*          where EPS is the machine precision.  If ABSTOL is less than
*          or equal to zero, then  EPS*|T|  will be used in its place,
*          where |T| is the 1-norm of the tridiagonal matrix obtained
*          by reducing A to tridiagonal form.
*
*          Eigenvalues will be computed most accurately when ABSTOL is
*          set to twice the underflow threshold 2*DLAMCH('S'), not zero.
*          If this routine returns with INFO>0, indicating that some
*          eigenvectors did not converge, try setting ABSTOL to
*          2*SLAMCH('S').
*
*  M       (output) INTEGER
*          The total number of eigenvalues found.  0 <= M <= N.
*          If RANGE = 'A', M = N, and if RANGE = 'I', M = IU-IL+1.
*
*  W       (output) REAL array, dimension (N)
*          On normal exit, the first M elements contain the selected
*          eigenvalues in ascending order.
*
*  Z       (output) REAL array, dimension (LDZ, max(1,M))
*          If JOBZ = 'N', then Z is not referenced.
*          If JOBZ = 'V', then if INFO = 0, the first M columns of Z
*          contain the orthonormal eigenvectors of the matrix A
*          corresponding to the selected eigenvalues, with the i-th
*          column of Z holding the eigenvector associated with W(i).
*          The eigenvectors are normalized as follows:
*          if ITYPE = 1 or 2, Z**T*B*Z = I;
*          if ITYPE = 3, Z**T*inv(B)*Z = I.
*
*          If an eigenvector fails to converge, then that column of Z
*          contains the latest approximation to the eigenvector, and the
*          index of the eigenvector is returned in IFAIL.
*          Note: the user must ensure that at least max(1,M) columns are
*          supplied in the array Z; if RANGE = 'V', the exact value of M
*          is not known in advance and an upper bound must be used.
*
*  LDZ     (input) INTEGER
*          The leading dimension of the array Z.  LDZ >= 1, and if
*          JOBZ = 'V', LDZ >= max(1,N).
*
*  WORK    (workspace/output) REAL array, dimension (LWORK)
*          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*
*  LWORK   (input) INTEGER
*          The length of the array WORK.  LWORK >= max(1,8*N).
*          For optimal efficiency, LWORK >= (NB+3)*N,
*          where NB is the blocksize for SSYTRD returned by ILAENV.
*
*          If LWORK = -1, then a workspace query is assumed; the routine
*          only calculates the optimal size of the WORK array, returns
*          this value as the first entry of the WORK array, and no error
*          message related to LWORK is issued by XERBLA.
*
*  IWORK   (workspace) INTEGER array, dimension (5*N)
*
*  IFAIL   (output) INTEGER array, dimension (N)
*          If JOBZ = 'V', then if INFO = 0, the first M elements of
*          IFAIL are zero.  If INFO > 0, then IFAIL contains the
*          indices of the eigenvectors that failed to converge.
*          If JOBZ = 'N', then IFAIL is not referenced.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*          > 0:  SPOTRF or SSYEVX returned an error code:
*             <= N:  if INFO = i, SSYEVX failed to converge;
*                    i eigenvectors failed to converge.  Their indices
*                    are stored in array IFAIL.
*             > N:   if INFO = N + i, for 1 <= i <= N, then the leading
*                    minor of order i of B is not positive definite.
*                    The factorization of B could not be completed and
*                    no eigenvalues or eigenvectors were computed.
*
*  Further Details
*  ===============
*
*  Based on contributions by
*     Mark Fahey, Department of Mathematics, Univ. of Kentucky, USA
*
* =====================================================================
*
*     .. Parameters ..
      REAL               ONE
      PARAMETER          ( ONE = 1.0E+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            ALLEIG, INDEIG, LQUERY, UPPER, VALEIG, WANTZ
      CHARACTER          TRANS
      INTEGER            LOPT, LWKOPT, NB
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            ILAENV
      EXTERNAL           ILAENV, LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           SPOTRF, SSYEVX, SSYGST, STRMM, STRSM, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      UPPER = LSAME( UPLO, 'U' )
      WANTZ = LSAME( JOBZ, 'V' )
      ALLEIG = LSAME( RANGE, 'A' )
      VALEIG = LSAME( RANGE, 'V' )
      INDEIG = LSAME( RANGE, 'I' )
      LQUERY = ( LWORK.EQ.-1 )
*
      INFO = 0
      IF( ITYPE.LT.0 .OR. ITYPE.GT.3 ) THEN
         INFO = -1
      ELSE IF( .NOT.( WANTZ .OR. LSAME( JOBZ, 'N' ) ) ) THEN
         INFO = -2
      ELSE IF( .NOT.( ALLEIG .OR. VALEIG .OR. INDEIG ) ) THEN
         INFO = -3
      ELSE IF( .NOT.( UPPER .OR. LSAME( UPLO, 'L' ) ) ) THEN
         INFO = -4
      ELSE IF( N.LT.0 ) THEN
         INFO = -5
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -7
      ELSE IF( LDB.LT.MAX( 1, N ) ) THEN
         INFO = -9
      ELSE IF( VALEIG .AND. N.GT.0 ) THEN
         IF( VU.LE.VL ) INFO = -11
      ELSE IF( INDEIG .AND. IL.LT.1 ) THEN
         INFO = -12
      ELSE IF( INDEIG .AND. ( IU.LT.MIN( N, IL ) .OR. IU.GT.N ) ) THEN
         INFO = -13
      ELSE IF( LDZ.LT.1 .OR. ( WANTZ .AND. LDZ.LT.N ) ) THEN
         INFO = -18
      ELSE IF( LWORK.LT.MAX( 1, 8*N ) .AND. .NOT.LQUERY ) THEN
         INFO = -20
      END IF
*
      IF( INFO.EQ.0 ) THEN
         NB = ILAENV( 1, 'SSYTRD', UPLO, N, -1, -1, -1 )
         LWKOPT = ( NB+3 )*N
         WORK( 1 ) = LWKOPT
      END IF
*
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'SSYGVX', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         RETURN
      END IF
*
*     Quick return if possible
*
      M = 0
      IF( N.EQ.0 ) THEN
         WORK( 1 ) = 1
         RETURN
      END IF
*
*     Form a Cholesky factorization of B.
*
      CALL SPOTRF( UPLO, N, B, LDB, INFO )
      IF( INFO.NE.0 ) THEN
         INFO = N + INFO
         RETURN
      END IF
*
*     Transform problem to standard eigenvalue problem and solve.
*
      CALL SSYGST( ITYPE, UPLO, N, A, LDA, B, LDB, INFO )
      CALL SSYEVX( JOBZ, RANGE, UPLO, N, A, LDA, VL, VU, IL, IU, ABSTOL,
     $             M, W, Z, LDZ, WORK, LWORK, IWORK, IFAIL, INFO )
      LOPT = WORK( 1 )
*
      IF( WANTZ ) THEN
*
*        Backtransform eigenvectors to the original problem.
*
         IF( INFO.GT.0 )
     $      M = INFO - 1
         IF( ITYPE.EQ.1 .OR. ITYPE.EQ.2 ) THEN
*
*           For A*x=(lambda)*B*x and A*B*x=(lambda)*x;
*           backtransform eigenvectors: x = inv(L)'*y or inv(U)*y
*
            IF( UPPER ) THEN
               TRANS = 'N'
            ELSE
               TRANS = 'T'
            END IF
*
            CALL STRSM( 'Left', UPLO, TRANS, 'Non-unit', N, M, ONE, B,
     $                  LDB, Z, LDZ )
*
         ELSE IF( ITYPE.EQ.3 ) THEN
*
*           For B*A*x=(lambda)*x;
*           backtransform eigenvectors: x = L*y or U'*y
*
            IF( UPPER ) THEN
               TRANS = 'T'
            ELSE
               TRANS = 'N'
            END IF
*
            CALL STRMM( 'Left', UPLO, TRANS, 'Non-unit', N, M, ONE, B,
     $                  LDB, Z, LDZ )
         END IF
      END IF
*
*     Set WORK(1) to optimal workspace size.
*
      WORK( 1 ) = LWKOPT
*
      RETURN
*
*     End of SSYGVX
*
      END

C
C     $Id: mp01f.f,v 1.12 2010-03-15 22:49:24 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C                Copyright (C)  1993                                   C
C        University Corporation for Atmospheric Research               C
C                All Rights Reserved                                   C
C                                                                      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C
C      File:            mp01f.f
C
C      Author:          Dave Brown (converted to Fortran by Mary Haley)
C                       National Center for Atmospheric Research
C                       PO 3000, Boulder, Colorado
C
C      Date:            Tue Jan 24 10:08:49 MST 1995
C
C      Description:     Demonstrates basic MapPlot capabilities.
C
      external NhlFAppClass
      external NhlFCairoWindowWorkstationClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFMapPlotClass
      integer appid,wid,mapid
      integer rlist
      character*7  wks_type
C
C Default is to display output to an X workstation
C
      wks_type = "x11"
C
C Initialize the high level utility library
C
      call NhlFInitialize
C
C Create an application context. Set the app dir to the current
C directory so the application looks for a resource file in the working
C directory. The resource file sets most of the Contour resources that
C remain fixed throughout the life of the Contour object.
C
      call NhlFRLCreate(rlist,'SETRL')
      call NhlFRLClear(rlist)
      call NhlFRLSetstring(rlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'mp01',NhlFAppClass,0,rlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkMetaName','./mp01f.ncgm',ierr)
         call NhlFCreate(wid,'mp01Work',NhlFNcgmWorkstationClass,0,
     1        rlist,ierr)
      else  if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X workstation
C
         call NhlFRLClear(rlist)
         call NhlFRLSetinteger(rlist,'wkPause',1,ierr)
         call NhlFCreate(wid,'mp01Work',
     +     NhlFCairoWindowWorkstationClass,0,
     1     rlist,ierr)
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PostScript workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPSFileName','./mp01f.ps',ierr)
         call NhlFCreate(wid,'mp01Work',NhlFPSWorkstationClass,0,
     1        rlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPDFFileName','./mp01f.pdf',ierr)
         call NhlFCreate(wid,'mp01Work',NhlFPDFWorkstationClass,0,
     1        rlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF object.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetstring(rlist,'wkFileName','./mp01f',ierr)
         call NhlFCreate(wid,'mp01Work',
     1        NhlFCairoPSPDFWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG object.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetstring(rlist,'wkFileName','./mp01f',ierr)
         call NhlFCreate(wid,'mp01Work',
     1        NhlFCairoImageWorkstationClass,0,rlist,ierr)
      endif
C
C Draw the default MapPlot object
C
      call NhlFRLClear(rlist)
      call NhlFRLSetstring(rlist,'pmTitleDisplayMode','always',ierr)
      call NhlFRLSetstring(rlist,'tiMainString','mp01f - Frame 1',ierr)
      call NhlFCreate(mapid,'Map0',NhlFMapPlotClass,wid,rlist,ierr)
      call NhlFDraw(mapid,ierr)
      call NhlFFrame(wid,ierr)
C
C Change some projection resources, add color fill, and
C all the outlines (Geophysical, National, and US States).
C
      call NhlFRLClear(rlist)
      call NhlFRLSetstring(rlist,'tiMainString','mp01f - Frame 2',ierr)
      call NhlFRLSetfloat(rlist,'vpYF',0.9,ierr)
      call NhlFRLsetfloat(rlist,'vpHeightF',0.8,ierr)
      call NhlFRLSetstring(rlist,'mpFillOn','TRUE',ierr)
      call NhlFRLSetstring(rlist,'mpOutlineBoundarySets',
     1  'allBoundaries',ierr)
      call NhlFRLSetstring(rlist,'mpProjection','orthographic',ierr)
      call NhlFRLSetString(rlist,'mpPerimOn','true',ierr)
      call NhlFRLSetfloat(rlist,'mpCenterLatF',10.0,ierr)
      call NhlFRLSetfloat(rlist,'mpCenterLonF',-90.0,ierr)
      call NhlFRLSetfloat(rlist,'mpCenterRotF',45.0,ierr)
      call NhlFSetValues(mapid,rlist,ierr)

      call NhlFDraw(mapid,ierr)
      call NhlFFrame(wid,ierr)
C
C Use the national color set and limit the projection, 
C using lat/lon boundaries.
C

      call NhlFRLClear(rlist)
      call NhlFRLSetstring(rlist,'tiMainString','mp01f - Frame 3',ierr)
      call NhlFRLSetstring(rlist,'mpFillBoundarySets','national',ierr)
      call NhlFRLSetstring(rlist,'mpLimitMode','latlon',ierr)
      call NhlFRLSetfloat(rlist,'mpMinLatF',-60.0,ierr)
      call NhlFRLSetfloat(rlist,'mpMaxLatF',60.0,ierr)
      call NhlFRLSetfloat(rlist,'mpMinLonF',-135.0,ierr)
      call NhlFRLSetfloat(rlist,'mpMaxLonF',-45.0,ierr)
      call NhlFSetValues(mapid,rlist,ierr)

      call NhlFDraw(mapid,ierr)
      call NhlFFrame(wid,ierr)
C
C Polar stereographic projection, change the grid spacing to 10 degrees
C

      call NhlFRLClear(rlist)
      call NhlFRLSetstring(rlist,'tiMainString','mp01f - Frame 4',ierr)
      call NhlFRLSetstring(rlist,'mpProjection','stereographic',ierr)
      call NhlFRLSetfloat(rlist,'mpGridSpacingF',10.,ierr)
      call NhlFRLSetfloat(rlist,'mpMinLatF',20.0,ierr)
      call NhlFRLSetfloat(rlist,'mpMaxLatF',90.0,ierr)
      call NhlFRLSetfloat(rlist,'mpMinLonF',0.0,ierr)
      call NhlFRLSetfloat(rlist,'mpMaxLonF',360.0,ierr)
      call NhlFRLSetfloat(rlist,'mpCenterLatF',90.0,ierr)
      call NhlFSetValues(mapid,rlist,ierr)

      call NhlFDraw(mapid,ierr)
      call NhlFFrame(wid,ierr)

C
C Satellite projection using the angle limit method
C color US States only individually.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetstring(rlist,'tiMainString','mp01f - Frame 5',ierr)
      call NhlFRLSetstring(rlist,'mpFillBoundarySets',
     1       'geophysicalAndUSStates',ierr)
      call NhlFRLSetstring(rlist,'mpProjection','satellite',ierr)
      call NhlFRLSetstring(rlist,'mpLimitMode','angles',ierr)
      call NhlFRLSetfloat(rlist,'mpLeftAngleF',45.0,ierr)
      call NhlFRLSetfloat(rlist,'mpRightAngleF',45.0,ierr)
      call NhlFRLSetfloat(rlist,'mpBottomAngleF',45.0,ierr)
      call NhlFRLSetfloat(rlist,'mpTopAngleF',45.0,ierr)
      call NhlFRLSetfloat(rlist,'mpCenterLatF',20.0,ierr)
      call NhlFRLSetfloat(rlist,'mpSatelliteDistF',1.75,ierr)
      call NhlFSetValues(mapid,rlist,ierr)

      call NhlFDraw(mapid,ierr)
      call NhlFFrame(wid,ierr)
C
C Destroy the objects created, close the HLU library and exit.
C
      call NhlFDestroy(mapid,ierr)
      call NhlFDestroy(wid,ierr)
      call NhlFDestroy(appid,ierr)
      call NhlFClose
      stop
      end

C
C       $Id: vvumxy.f,v 1.8 2008-07-27 00:17:35 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
C
C-----------------------------------------------------------------------
C
      SUBROUTINE VVUMXY (X,Y,U,V,UVM,XB,YB,XE,YE,IST)
C
C This is a user modifiable routine that allows custom projections of
C the vector space. X and Y give the vector position within the domain
C of the data space. By default, this space is coincident with the
C grid space (i.e. 1 through dimension lengths of the U and V arrays).
C The vector endpoints are output in fractional coordinates (NDC space).
C Note that this is different from the old MXF and MYF routines, which
C output in 'plotter coordinate' space. It also differs from the 
C Conpack routine CPMPXY, which returns values in user space. 
C 
C VVUMXY (Velocity Vector -- User Map X,Y) is called whenever 
C the internal parameter MAP is set to a value other than 0, 1, or 2.
C
C Based on the magnitude and direction of the vector the start and 
C ending points of the vector are returned in NDC space.
C
C Input parameters:
C
C X,Y   -- vector position in the user coordinate system
C U,V   -- vector components from the U,V arrays for this position
C UVM   -- magnitude of the U,V components (supplied for convenience
C          and efficiency - but note that many mappings do not need 
C          this value)
C
C Output parameters:
C
C XB,YB -- starting point of the vector in fractional coordinates
C          (NDC space), before offset based on the value of the
C          vector positioning parameter, VPO.
C XE,YE -- ending point of the vector in fractional coordinates
C          (NDC space), before offset based on the value of the
C          vector positioning parameter, VPO.
C IST   -- status results of the mapping: 0 indicates success -- any
C          non-zero value causes VVECTR to discard the vector at this
C          location.
C
C
C The mapping common block: made available to user mapping routines
C
      COMMON /VVMAP/
     +                IMAP       ,
     +                XVPL       ,XVPR       ,YVPB       ,YVPT       ,
     +                WXMN       ,WXMX       ,WYMN       ,WYMX       ,
     +                XLOV       ,XHIV       ,YLOV       ,YHIV       ,
     +                SXDC       ,SYDC       ,NXCT       ,NYCT       ,
     +                RLEN       ,LNLG       ,INVX       ,INVY       ,
     +                ITRT       ,IWCT       ,FW2W       ,FH2H       ,
     +                DVMN       ,DVMX       ,RBIG       ,IBIG
C
      SAVE /VVMAP/
C
C Math constants
C
      PARAMETER (PDTOR  = 0.017453292519943,
     +           PRTOD  = 57.2957795130823,
     +           P1XPI  = 3.14159265358979,
     +           P2XPI  = 6.28318530717959,
     +           P1D2PI = 1.57079632679489,
     +           P5D2PI = 7.85398163397448) 
C
C --------------------------------------------------------------------
C
C Description of VVMAP contents:
C
C IMAP                - value of the internal parameter 'MAP'
C XVPL,XVPR,YVPB,YVPT - the currently set viewport values. (GETSET
C                       arguments 1, 2, 3, and 4)
C WXMN,WXMX,WYMN,WYMX - the min and max boundaries of user coordinate
C                       space, (usually but not always equivalent to
C                       window coordinates). WXMN and WYMN are true
C                       minimum values even one or both axes is 
C                       inverted. (i.e. WXMN = MIN of GETSET args 5,6;
C                       WYMN = MIN of GETSET args 7,8)
C XLOV,XHIV,YLOV,YHIV - min and max boundaries of the data space, by
C                       default equivalent to the array grid space.
C                       XLOV and YLOV are not necessarily less than 
C                       XHIV and YHIV respectively.
C SXDC,SYDC           - Scaling factors for converting vector component
C                       values into lengths in NDC space.
C NXCT,NYCT           - Length of each dimension of the U and V 
C                       component arrays.
C RLEN                - Length of the maximum vector in user 
C                       coordinates.
C LNLG                - The linear/log mode (GETSET argument 9)
C INVX,INVY           - User coordinates inversion flags: 
C                       0 - not inverted, 1 - inverted
C ITRT                - value of the internal parameter TRT
C IWCT                - not currently used
C FW2W,FH2H           - scale factors for converting from fraction of
C                       viewport width/height to NDC width/height 
C DVMN,DVMX           - min/max vector lengths in NDC
C RBIG,IBIG           - machine dependent maximum REAL/INTEGER values
C
C --------------------------------------------------------------------
C User-defined common block...
C
C --------------------------------------------------------------------
C
C     IF (IMAP .EQ. =user defined mapping code=) THEN
C
C User defined mapping code....
C
C     ELSE
C
C Default mapping:
C
C Note that the default version of VVUMXY included with
C NCAR Graphics 3.2 incorrectly fails to convert the input X and Y
C location into fractional coordinates (NDC space).
C
         IF (X.LT.WXMN .OR. X.GT.WXMX .OR. 
     +        Y.LT.WYMN .OR. Y.GT.WYMX) THEN
            IST = -1
            RETURN
         END IF
         XB=CUFX(X)
         YB=CUFY(Y)
         XE=XB+U*SXDC
         YE=YB+V*SYDC

C     END IF
C
C Done.
C
      RETURN
C
      END

      SUBROUTINE CTRSNA( JOB, HOWMNY, SELECT, N, T, LDT, VL, LDVL, VR,
     $                   LDVR, S, SEP, MM, M, WORK, LDWORK, RWORK,
     $                   INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER          HOWMNY, JOB
      INTEGER            INFO, LDT, LDVL, LDVR, LDWORK, M, MM, N
*     ..
*     .. Array Arguments ..
      LOGICAL            SELECT( * )
      REAL               RWORK( * ), S( * ), SEP( * )
      COMPLEX            T( LDT, * ), VL( LDVL, * ), VR( LDVR, * ),
     $                   WORK( LDWORK, * )
*     ..
*
*  Purpose
*  =======
*
*  CTRSNA estimates reciprocal condition numbers for specified
*  eigenvalues and/or right eigenvectors of a complex upper triangular
*  matrix T (or of any matrix Q*T*Q**H with Q unitary).
*
*  Arguments
*  =========
*
*  JOB     (input) CHARACTER*1
*          Specifies whether condition numbers are required for
*          eigenvalues (S) or eigenvectors (SEP):
*          = 'E': for eigenvalues only (S);
*          = 'V': for eigenvectors only (SEP);
*          = 'B': for both eigenvalues and eigenvectors (S and SEP).
*
*  HOWMNY  (input) CHARACTER*1
*          = 'A': compute condition numbers for all eigenpairs;
*          = 'S': compute condition numbers for selected eigenpairs
*                 specified by the array SELECT.
*
*  SELECT  (input) LOGICAL array, dimension (N)
*          If HOWMNY = 'S', SELECT specifies the eigenpairs for which
*          condition numbers are required. To select condition numbers
*          for the j-th eigenpair, SELECT(j) must be set to .TRUE..
*          If HOWMNY = 'A', SELECT is not referenced.
*
*  N       (input) INTEGER
*          The order of the matrix T. N >= 0.
*
*  T       (input) COMPLEX array, dimension (LDT,N)
*          The upper triangular matrix T.
*
*  LDT     (input) INTEGER
*          The leading dimension of the array T. LDT >= max(1,N).
*
*  VL      (input) COMPLEX array, dimension (LDVL,M)
*          If JOB = 'E' or 'B', VL must contain left eigenvectors of T
*          (or of any Q*T*Q**H with Q unitary), corresponding to the
*          eigenpairs specified by HOWMNY and SELECT. The eigenvectors
*          must be stored in consecutive columns of VL, as returned by
*          CHSEIN or CTREVC.
*          If JOB = 'V', VL is not referenced.
*
*  LDVL    (input) INTEGER
*          The leading dimension of the array VL.
*          LDVL >= 1; and if JOB = 'E' or 'B', LDVL >= N.
*
*  VR      (input) COMPLEX array, dimension (LDVR,M)
*          If JOB = 'E' or 'B', VR must contain right eigenvectors of T
*          (or of any Q*T*Q**H with Q unitary), corresponding to the
*          eigenpairs specified by HOWMNY and SELECT. The eigenvectors
*          must be stored in consecutive columns of VR, as returned by
*          CHSEIN or CTREVC.
*          If JOB = 'V', VR is not referenced.
*
*  LDVR    (input) INTEGER
*          The leading dimension of the array VR.
*          LDVR >= 1; and if JOB = 'E' or 'B', LDVR >= N.
*
*  S       (output) REAL array, dimension (MM)
*          If JOB = 'E' or 'B', the reciprocal condition numbers of the
*          selected eigenvalues, stored in consecutive elements of the
*          array. Thus S(j), SEP(j), and the j-th columns of VL and VR
*          all correspond to the same eigenpair (but not in general the
*          j-th eigenpair, unless all eigenpairs are selected).
*          If JOB = 'V', S is not referenced.
*
*  SEP     (output) REAL array, dimension (MM)
*          If JOB = 'V' or 'B', the estimated reciprocal condition
*          numbers of the selected eigenvectors, stored in consecutive
*          elements of the array.
*          If JOB = 'E', SEP is not referenced.
*
*  MM      (input) INTEGER
*          The number of elements in the arrays S (if JOB = 'E' or 'B')
*           and/or SEP (if JOB = 'V' or 'B'). MM >= M.
*
*  M       (output) INTEGER
*          The number of elements of the arrays S and/or SEP actually
*          used to store the estimated condition numbers.
*          If HOWMNY = 'A', M is set to N.
*
*  WORK    (workspace) COMPLEX array, dimension (LDWORK,N+1)
*          If JOB = 'E', WORK is not referenced.
*
*  LDWORK  (input) INTEGER
*          The leading dimension of the array WORK.
*          LDWORK >= 1; and if JOB = 'V' or 'B', LDWORK >= N.
*
*  RWORK   (workspace) REAL array, dimension (N)
*          If JOB = 'E', RWORK is not referenced.
*
*  INFO    (output) INTEGER
*          = 0: successful exit
*          < 0: if INFO = -i, the i-th argument had an illegal value
*
*  Further Details
*  ===============
*
*  The reciprocal of the condition number of an eigenvalue lambda is
*  defined as
*
*          S(lambda) = |v'*u| / (norm(u)*norm(v))
*
*  where u and v are the right and left eigenvectors of T corresponding
*  to lambda; v' denotes the conjugate transpose of v, and norm(u)
*  denotes the Euclidean norm. These reciprocal condition numbers always
*  lie between zero (very badly conditioned) and one (very well
*  conditioned). If n = 1, S(lambda) is defined to be 1.
*
*  An approximate error bound for a computed eigenvalue W(i) is given by
*
*                      EPS * norm(T) / S(i)
*
*  where EPS is the machine precision.
*
*  The reciprocal of the condition number of the right eigenvector u
*  corresponding to lambda is defined as follows. Suppose
*
*              T = ( lambda  c  )
*                  (   0    T22 )
*
*  Then the reciprocal condition number is
*
*          SEP( lambda, T22 ) = sigma-min( T22 - lambda*I )
*
*  where sigma-min denotes the smallest singular value. We approximate
*  the smallest singular value by the reciprocal of an estimate of the
*  one-norm of the inverse of T22 - lambda*I. If n = 1, SEP(1) is
*  defined to be abs(T(1,1)).
*
*  An approximate error bound for a computed right eigenvector VR(i)
*  is given by
*
*                      EPS * norm(T) / SEP(i)
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ZERO, ONE
      PARAMETER          ( ZERO = 0.0E+0, ONE = 1.0+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            SOMCON, WANTBH, WANTS, WANTSP
      CHARACTER          NORMIN
      INTEGER            I, IERR, IX, J, K, KASE, KS
      REAL               BIGNUM, EPS, EST, LNRM, RNRM, SCALE, SMLNUM,
     $                   XNORM
      COMPLEX            CDUM, PROD
*     ..
*     .. Local Arrays ..
      COMPLEX            DUMMY( 1 )
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            ICAMAX
      REAL               SCNRM2, SLAMCH
      COMPLEX            CDOTC
      EXTERNAL           LSAME, ICAMAX, SCNRM2, SLAMCH, CDOTC
*     ..
*     .. External Subroutines ..
      EXTERNAL           CLACON, CLACPY, CLATRS, CSRSCL, CTREXC, SLABAD,
     $                   XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, AIMAG, MAX, REAL
*     ..
*     .. Statement Functions ..
      REAL               CABS1
*     ..
*     .. Statement Function definitions ..
      CABS1( CDUM ) = ABS( REAL( CDUM ) ) + ABS( AIMAG( CDUM ) )
*     ..
*     .. Executable Statements ..
*
*     Decode and test the input parameters
*
      WANTBH = LSAME( JOB, 'B' )
      WANTS = LSAME( JOB, 'E' ) .OR. WANTBH
      WANTSP = LSAME( JOB, 'V' ) .OR. WANTBH
*
      SOMCON = LSAME( HOWMNY, 'S' )
*
*     Set M to the number of eigenpairs for which condition numbers are
*     to be computed.
*
      IF( SOMCON ) THEN
         M = 0
         DO 10 J = 1, N
            IF( SELECT( J ) )
     $         M = M + 1
   10    CONTINUE
      ELSE
         M = N
      END IF
*
      INFO = 0
      IF( .NOT.WANTS .AND. .NOT.WANTSP ) THEN
         INFO = -1
      ELSE IF( .NOT.LSAME( HOWMNY, 'A' ) .AND. .NOT.SOMCON ) THEN
         INFO = -2
      ELSE IF( N.LT.0 ) THEN
         INFO = -4
      ELSE IF( LDT.LT.MAX( 1, N ) ) THEN
         INFO = -6
      ELSE IF( LDVL.LT.1 .OR. ( WANTS .AND. LDVL.LT.N ) ) THEN
         INFO = -8
      ELSE IF( LDVR.LT.1 .OR. ( WANTS .AND. LDVR.LT.N ) ) THEN
         INFO = -10
      ELSE IF( MM.LT.M ) THEN
         INFO = -13
      ELSE IF( LDWORK.LT.1 .OR. ( WANTSP .AND. LDWORK.LT.N ) ) THEN
         INFO = -16
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'CTRSNA', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
*
      IF( N.EQ.1 ) THEN
         IF( SOMCON ) THEN
            IF( .NOT.SELECT( 1 ) )
     $         RETURN
         END IF
         IF( WANTS )
     $      S( 1 ) = ONE
         IF( WANTSP )
     $      SEP( 1 ) = ABS( T( 1, 1 ) )
         RETURN
      END IF
*
*     Get machine constants
*
      EPS = SLAMCH( 'P' )
      SMLNUM = SLAMCH( 'S' ) / EPS
      BIGNUM = ONE / SMLNUM
      CALL SLABAD( SMLNUM, BIGNUM )
*
      KS = 1
      DO 50 K = 1, N
*
         IF( SOMCON ) THEN
            IF( .NOT.SELECT( K ) )
     $         GO TO 50
         END IF
*
         IF( WANTS ) THEN
*
*           Compute the reciprocal condition number of the k-th
*           eigenvalue.
*
            PROD = CDOTC( N, VR( 1, KS ), 1, VL( 1, KS ), 1 )
            RNRM = SCNRM2( N, VR( 1, KS ), 1 )
            LNRM = SCNRM2( N, VL( 1, KS ), 1 )
            S( KS ) = ABS( PROD ) / ( RNRM*LNRM )
*
         END IF
*
         IF( WANTSP ) THEN
*
*           Estimate the reciprocal condition number of the k-th
*           eigenvector.
*
*           Copy the matrix T to the array WORK and swap the k-th
*           diagonal element to the (1,1) position.
*
            CALL CLACPY( 'Full', N, N, T, LDT, WORK, LDWORK )
            CALL CTREXC( 'No Q', N, WORK, LDWORK, DUMMY, 1, K, 1, IERR )
*
*           Form  C = T22 - lambda*I in WORK(2:N,2:N).
*
            DO 20 I = 2, N
               WORK( I, I ) = WORK( I, I ) - WORK( 1, 1 )
   20       CONTINUE
*
*           Estimate a lower bound for the 1-norm of inv(C'). The 1st
*           and (N+1)th columns of WORK are used to store work vectors.
*
            SEP( KS ) = ZERO
            EST = ZERO
            KASE = 0
            NORMIN = 'N'
   30       CONTINUE
            CALL CLACON( N-1, WORK( 1, N+1 ), WORK, EST, KASE )
*
            IF( KASE.NE.0 ) THEN
               IF( KASE.EQ.1 ) THEN
*
*                 Solve C'*x = scale*b
*
                  CALL CLATRS( 'Upper', 'Conjugate transpose',
     $                         'Nonunit', NORMIN, N-1, WORK( 2, 2 ),
     $                         LDWORK, WORK, SCALE, RWORK, IERR )
               ELSE
*
*                 Solve C*x = scale*b
*
                  CALL CLATRS( 'Upper', 'No transpose', 'Nonunit',
     $                         NORMIN, N-1, WORK( 2, 2 ), LDWORK, WORK,
     $                         SCALE, RWORK, IERR )
               END IF
               NORMIN = 'Y'
               IF( SCALE.NE.ONE ) THEN
*
*                 Multiply by 1/SCALE if doing so will not cause
*                 overflow.
*
                  IX = ICAMAX( N-1, WORK, 1 )
                  XNORM = CABS1( WORK( IX, 1 ) )
                  IF( SCALE.LT.XNORM*SMLNUM .OR. SCALE.EQ.ZERO )
     $               GO TO 40
                  CALL CSRSCL( N, SCALE, WORK, 1 )
               END IF
               GO TO 30
            END IF
*
            SEP( KS ) = ONE / MAX( EST, SMLNUM )
         END IF
*
   40    CONTINUE
         KS = KS + 1
   50 CONTINUE
      RETURN
*
*     End of CTRSNA
*
      END

      SUBROUTINE SLAQPS( M, N, OFFSET, NB, KB, A, LDA, JPVT, TAU, VN1,
     $                   VN2, AUXV, F, LDF )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      INTEGER            KB, LDA, LDF, M, N, NB, OFFSET
*     ..
*     .. Array Arguments ..
      INTEGER            JPVT( * )
      REAL               A( LDA, * ), AUXV( * ), F( LDF, * ), TAU( * ),
     $                   VN1( * ), VN2( * )
*     ..
*
*  Purpose
*  =======
*
*  SLAQPS computes a step of QR factorization with column pivoting
*  of a real M-by-N matrix A by using Blas-3.  It tries to factorize
*  NB columns from A starting from the row OFFSET+1, and updates all
*  of the matrix with Blas-3 xGEMM.
*
*  In some cases, due to catastrophic cancellations, it cannot
*  factorize NB columns.  Hence, the actual number of factorized
*  columns is returned in KB.
*
*  Block A(1:OFFSET,1:N) is accordingly pivoted, but not factorized.
*
*  Arguments
*  =========
*
*  M       (input) INTEGER
*          The number of rows of the matrix A. M >= 0.
*
*  N       (input) INTEGER
*          The number of columns of the matrix A. N >= 0
*
*  OFFSET  (input) INTEGER
*          The number of rows of A that have been factorized in
*          previous steps.
*
*  NB      (input) INTEGER
*          The number of columns to factorize.
*
*  KB      (output) INTEGER
*          The number of columns actually factorized.
*
*  A       (input/output) REAL array, dimension (LDA,N)
*          On entry, the M-by-N matrix A.
*          On exit, block A(OFFSET+1:M,1:KB) is the triangular
*          factor obtained and block A(1:OFFSET,1:N) has been
*          accordingly pivoted, but no factorized.
*          The rest of the matrix, block A(OFFSET+1:M,KB+1:N) has
*          been updated.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A. LDA >= max(1,M).
*
*  JPVT    (input/output) INTEGER array, dimension (N)
*          JPVT(I) = K <==> Column K of the full matrix A has been
*          permuted into position I in AP.
*
*  TAU     (output) REAL array, dimension (KB)
*          The scalar factors of the elementary reflectors.
*
*  VN1     (input/output) REAL array, dimension (N)
*          The vector with the partial column norms.
*
*  VN2     (input/output) REAL array, dimension (N)
*          The vector with the exact column norms.
*
*  AUXV    (input/output) REAL array, dimension (NB)
*          Auxiliar vector.
*
*  F       (input/output) REAL array, dimension (LDF,NB)
*          Matrix F' = L*Y'*A.
*
*  LDF     (input) INTEGER
*          The leading dimension of the array F. LDF >= max(1,N).
*
*  Further Details
*  ===============
*
*  Based on contributions by
*    G. Quintana-Orti, Depto. de Informatica, Universidad Jaime I, Spain
*    X. Sun, Computer Science Dept., Duke University, USA
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ZERO, ONE
      PARAMETER          ( ZERO = 0.0E+0, ONE = 1.0E+0 )
*     ..
*     .. Local Scalars ..
      INTEGER            ITEMP, J, K, LASTRK, LSTICC, PVT, RK
      REAL               AKK, TEMP, TEMP2
*     ..
*     .. External Subroutines ..
      EXTERNAL           SGEMM, SGEMV, SLARFG, SSWAP
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, MAX, MIN, NINT, REAL, SQRT
*     ..
*     .. External Functions ..
      INTEGER            ISAMAX
      REAL               SNRM2
      EXTERNAL           ISAMAX, SNRM2
*     ..
*     .. Executable Statements ..
*
      LASTRK = MIN( M, N+OFFSET )
      LSTICC = 0
      K = 0
*
*     Beginning of while loop.
*
   10 CONTINUE
      IF( ( K.LT.NB ) .AND. ( LSTICC.EQ.0 ) ) THEN
         K = K + 1
         RK = OFFSET + K
*
*        Determine ith pivot column and swap if necessary
*
         PVT = ( K-1 ) + ISAMAX( N-K+1, VN1( K ), 1 )
         IF( PVT.NE.K ) THEN
            CALL SSWAP( M, A( 1, PVT ), 1, A( 1, K ), 1 )
            CALL SSWAP( K-1, F( PVT, 1 ), LDF, F( K, 1 ), LDF )
            ITEMP = JPVT( PVT )
            JPVT( PVT ) = JPVT( K )
            JPVT( K ) = ITEMP
            VN1( PVT ) = VN1( K )
            VN2( PVT ) = VN2( K )
         END IF
*
*        Apply previous Householder reflectors to column K:
*        A(RK:M,K) := A(RK:M,K) - A(RK:M,1:K-1)*F(K,1:K-1)'.
*
         IF( K.GT.1 ) THEN
            CALL SGEMV( 'No transpose', M-RK+1, K-1, -ONE, A( RK, 1 ),
     $                  LDA, F( K, 1 ), LDF, ONE, A( RK, K ), 1 )
         END IF
*
*        Generate elementary reflector H(k).
*
         IF( RK.LT.M ) THEN
            CALL SLARFG( M-RK+1, A( RK, K ), A( RK+1, K ), 1, TAU( K ) )
         ELSE
            CALL SLARFG( 1, A( RK, K ), A( RK, K ), 1, TAU( K ) )
         END IF
*
         AKK = A( RK, K )
         A( RK, K ) = ONE
*
*        Compute Kth column of F:
*
*        Compute  F(K+1:N,K) := tau(K)*A(RK:M,K+1:N)'*A(RK:M,K).
*
         IF( K.LT.N ) THEN
            CALL SGEMV( 'Transpose', M-RK+1, N-K, TAU( K ),
     $                  A( RK, K+1 ), LDA, A( RK, K ), 1, ZERO,
     $                  F( K+1, K ), 1 )
         END IF
*
*        Padding F(1:K,K) with zeros.
*
         DO 20 J = 1, K
            F( J, K ) = ZERO
   20    CONTINUE
*
*        Incremental updating of F:
*        F(1:N,K) := F(1:N,K) - tau(K)*F(1:N,1:K-1)*A(RK:M,1:K-1)'
*                    *A(RK:M,K).
*
         IF( K.GT.1 ) THEN
            CALL SGEMV( 'Transpose', M-RK+1, K-1, -TAU( K ), A( RK, 1 ),
     $                  LDA, A( RK, K ), 1, ZERO, AUXV( 1 ), 1 )
*
            CALL SGEMV( 'No transpose', N, K-1, ONE, F( 1, 1 ), LDF,
     $                  AUXV( 1 ), 1, ONE, F( 1, K ), 1 )
         END IF
*
*        Update the current row of A:
*        A(RK,K+1:N) := A(RK,K+1:N) - A(RK,1:K)*F(K+1:N,1:K)'.
*
         IF( K.LT.N ) THEN
            CALL SGEMV( 'No transpose', N-K, K, -ONE, F( K+1, 1 ), LDF,
     $                  A( RK, 1 ), LDA, ONE, A( RK, K+1 ), LDA )
         END IF
*
*        Update partial column norms.
*
         IF( RK.LT.LASTRK ) THEN
            DO 30 J = K + 1, N
               IF( VN1( J ).NE.ZERO ) THEN
                  TEMP = ABS( A( RK, J ) ) / VN1( J )
                  TEMP = MAX( ZERO, ( ONE+TEMP )*( ONE-TEMP ) )
                  TEMP2 = ONE + 0.05*TEMP*( VN1( J ) / VN2( J ) )**2
                  IF( TEMP2.EQ.ONE ) THEN
                     VN2( J ) = REAL( LSTICC )
                     LSTICC = J
                  ELSE
                     VN1( J ) = VN1( J )*SQRT( TEMP )
                  END IF
               END IF
   30       CONTINUE
         END IF
*
         A( RK, K ) = AKK
*
*        End of while loop.
*
         GO TO 10
      END IF
      KB = K
      RK = OFFSET + KB
*
*     Apply the block reflector to the rest of the matrix:
*     A(OFFSET+KB+1:M,KB+1:N) := A(OFFSET+KB+1:M,KB+1:N) -
*                         A(OFFSET+KB+1:M,1:KB)*F(KB+1:N,1:KB)'.
*
      IF( KB.LT.MIN( N, M-OFFSET ) ) THEN
         CALL SGEMM( 'No transpose', 'Transpose', M-RK, N-KB, KB, -ONE,
     $               A( RK+1, 1 ), LDA, F( KB+1, 1 ), LDF, ONE,
     $               A( RK+1, KB+1 ), LDA )
      END IF
*
*     Recomputation of difficult columns.
*
   40 CONTINUE
      IF( LSTICC.GT.0 ) THEN
         ITEMP = NINT( VN2( LSTICC ) )
         VN1( LSTICC ) = SNRM2( M-RK, A( RK+1, LSTICC ), 1 )
         VN2( LSTICC ) = VN1( LSTICC )
         LSTICC = ITEMP
         GO TO 40
      END IF
*
      RETURN
*
*     End of SLAQPS
*
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C                            Copyright (C)  1995                       C
C                 University Corporation for Atmospheric Research      C
C                            All Rights Reserved                       C
C                                                                      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C      File:            mp04f.f
C
C      Author:          David Brown (converted to Fortran by Mary Haley)
C                       National Center for Atmospheric Research
C                       PO 3000, Boulder, Colorado
C
C      Date:            Tue Jan 24 10:49:54 MST 1995
C
C     Description:      Illustrates use of AnnoManager objects.    
C
      external NhlFAppClass
      external NhlFNcgmWorkstationClass
      external NhlFCairoWindowWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFMapPlotClass
      external NhlFtextitemClass
      external nhlfannomanagerclass
C
C Define enough frames for a fairly smooth animation.
C
      parameter(IFRAME_COUNT=36,NDIM=25)

      character*50 name(NDIM)
      real lat(NDIM),lon(NDIM)
      integer num_am_ids
      data num_am_ids/NDIM/
      integer am_ids(NDIM), text_ids(NDIM)
      data am_ids/25*-1/

      integer ret
      data ret/-1/
      integer appid,wid,mapid,rlist,grlist
      integer i
      character*7  wks_type

      data name/'Los Angeles','Seattle','Toronto','New York','Miami',
     1 'Mexico City','London','Jakarta','Moscow','New Delhi',
     1 'Rio de Janeiro','Cairo','Buenos Aires','Beijing','Tokyo',
     1 'Lagos','Nairobi','Sydney','Bogota','Lima','Cape Town',
     1 'Calcutta','Shanghai','Bombay','Denver'/

      data lat/34.0,47.6,43.7,40.67,25.75,19.417,51.32,-6.13,55.75,
     1 28.37,-22.883,30.05, -34.67,39.917,35.67,6.45,-1.283,-33.9167,
     1 4.633,-12.1,-33.933,22.583,31.217,18.93,39.716/

      data lon/-118.28,-122.33,-79.4167,-73.83,-80.25,-99.167,-0.1,
     1 106.75,37.7,77.217,-43.283,31.25,-58.4167,116.4167,139.67,3.28,
     1 36.833,151.167,-74.083,-77.05,18.4667,88.35,121.4167,72.85,
     1 -105.017/

C
C Default is to create a metafile.
C
      wks_type = "ncgm"

C
C Initialize the high level utility library
C
      call NhlFInitialize
C
C Create an application context. Set the app dir to the current
C directory so the application looks for a resource file in the
C working directory. The resource file sets most of the Contour
C resources that remain fixed throughout the life of the Contour
C object.
C
      call NhlFRLCreate(rlist,'SETRL')
      call NhlFRLClear(rlist)
      call NhlFRLSetstring(rlist,'appUsrDir','./',ierr)
      call NhlFRLSetstring(rlist,'appDefaultParent','True',ierr)
      call NhlFCreate(appid,'mp04',NhlFAppClass,0,rlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create a meta file workstation
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkMetaName','./mp04f.ncgm',ierr)
         call NhlFCreate(wid,'mp04Work',NhlFNcgmWorkstationClass,
     1        0,rlist,ierr)
      else  if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X workstation
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPause','True',ierr)
         call NhlFCreate(wid,'mp04Work',
     1        NhlFCairoWindowWorkstationClass,0,
     1        rlist,ierr)
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PostScript workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPSFileName','./mp04f.ps',ierr)
         call NhlFCreate(wid,'mp04Work',NhlFPSWorkstationClass,
     1        0,rlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPDFFileName','./mp04f.pdf',ierr)
         call NhlFCreate(wid,'mp04Work',NhlFPDFWorkstationClass,
     1        0,rlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF object.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetstring(rlist,'wkFileName','./mp04f',ierr)
         call NhlFCreate(wid,'mp04Work',
     1        NhlFCairoPSPDFWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG object.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetstring(rlist,'wkFileName','./mp04f',ierr)
         call NhlFCreate(wid,'mp04Work',
     1        NhlFCairoImageWorkstationClass,0,rlist,ierr)
      endif
C
C AnnoManager objects allow the PlotManager to manipulate any View class
C object as an annotation a uniform fashion. They allow
C the user to set the View object's size and location relative to
C the viewport of a Plot. They may be located relative to one
C of the viewport sides, or, as in this example, aligned with the 
C plot's data space (amTrackData is set True in the resource file).
C
C Create a TextItem for each place name to be included on the map.
C Collect the object ids into an array.
C
      do 10 i = 1,NDIM
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'txString',name(i),ierr)
         call NhlFCreate(text_ids(i),name(i),NhlFtextitemClass,wid,
     1    rlist,ierr)
 10   continue
C
C Since the MapPlot object is by default a PlotManager, you can
C make each TextItem View object into an annotation simply by setting
C the pmAnnoViews resource with the array of TextItem ids. 
C
      call NhlFRLClear(rlist)
      call NhlFRLSetintegerarray(rlist,'pmAnnoViews',text_ids,NDIM,ierr)
      call NhlFCreate(mapid,'Map0',NhlFMapPlotClass,wid,rlist,ierr)
C
C Retrieve the ids of the AnnoManager objects created by the PlotManager
C and then set their location in data coordinate space. The AnnoManager
C objects are arranged in the same order as the TextItems in the
C pmAnnoViews resource.
C
      call NhlFRLCreate(grlist,'GETRL')
      call NhlFRLClear(grlist)
      call NhlFRLGetintegerarray(grlist,'pmAnnoManagers',am_ids,
     +                           num_am_ids,ierr)
      call NhlFGetValues(mapid,grlist,ierr)

      do 20 i=1,num_am_ids
         call NhlFRLClear(rlist)
         call NhlFRLSetfloat(rlist,'amDataXF',lon(i),ierr)
         call NhlFRLSetfloat(rlist,'amDataYF',lat(i),ierr)
         call NhlFSetValues(am_ids(i),rlist,ierr)
 20   continue
C
C Create IFRAME_COUNT plots, varying the center longitude by an equal
C amount each time.
C
      do 30 i = IFRAME_COUNT,1,-1
         call NhlFRLClear(rlist)
         call NhlFRLSetfloat(rlist,'mpCenterLonF',i*360.0/IFRAME_COUNT,
     1    ierr)
         call NhlFSetValues(mapid,rlist,ierr)
         call NhlFDraw(mapid,ierr)
         call NhlFFrame(wid,ierr)
 30   continue
C
C Destroy the objects created, close the HLU library and exit.
C
      do 40 i=1,NDIM
         call NhlFDestroy(text_ids(i),ierr)
 40   continue
      call NhlFDestroy(mapid,ierr)
      call NhlFDestroy(wid,ierr)
      call NhlFDestroy(appid,ierr)
      call NhlFClose
      stop
      end

C NCLFORTSTART
      SUBROUTINE TRIPLE2GRID2D(X,Y,Z,KPTS,ZMSG,DISTMX,MOPT,LAT2D,LON2D,
     +                         ZGRID,NDIM,MDIM)
      IMPLICIT NONE
      INTEGER KPTS,NDIM,MDIM,MOPT
      DOUBLE PRECISION X(KPTS),Y(KPTS),Z(KPTS),ZMSG,DISTMX
      DOUBLE PRECISION LAT2D(MDIM,NDIM),LON2D(MDIM,NDIM),
     +                 ZGRID(MDIM,NDIM)
C NCLEND

C untested

c          SET EACH GRID POINT TO THE NEAREST OBSERVATION.
c .   The user can set distmx to some value. Setting to
c .   some very large value basically means that all grid
c .   points will be filled. Otherwise, only observations within
c .   distmx will be used.
c
c mopt   option for which distance formula to be used
c .      =  0 ; use pythag approx to calculate distance
c .             (quick/less-general]
c .      =  1 ; use great circle formula to calculate distance (slower)
c
c distmx any x/y observation .le. distmx will be used.
c .      Set to some very large number [ 1.e20 ] if all grid points
c .      are to be returned with some value.
c .      Observations .gt. distmx will be ignored. If distmx is set
c .        small than it is possible that some grid points will be 
c .        filled with missing values.

C NCL    zgrid = triple2grid2d (x,y,z, lon2d,lat2d, opt)

c                      local: re: rad earth (km) [only for mopt=1]
      INTEGER N,M,K
      DOUBLE PRECISION DIST(KPTS),DMIN,RE,RLAT,RAD,ATMP
      DATA RE/6371.2200D0/

      RAD = 4.D0*ATAN(1.0D0)/180.D0

      DO N = 1,NDIM
         DO M = 1,MDIM
            ZGRID(M,N) = ZMSG
c           do separately for optimization reasons
            IF (MOPT.EQ.0) THEN
               DO K = 1,KPTS
                  DIST(K) = SQRT((X(K)-LON2D(M,N))**2+
     +                 (Y(K)-LAT2D(M,N))**2)
               END DO
            ELSE
               RLAT = LAT2D(M,N)*RAD
               DO K = 1,KPTS
C
C The ATMP variable is necessary to make sure the
C value passed to ACOS is between -1 and 1.
C (Otherwise, you might get "NaN".)
C
                  ATMP = SIN(RLAT)*SIN(Y(K)*RAD)
     +                   + COS(RLAT)*COS(Y(K)*RAD)*
     +                     COS((X(K)-LON2D(M,N))*RAD)
                  ATMP  = MIN(1.D0,MAX(-1.D0,ATMP))
                  DIST(K) = ACOS(ATMP)*RE
               END DO
            END IF
c     assign z(k) to nearest grid point
            DMIN = 1.D+36
            DO K = 1,KPTS
               IF (Z(K).NE.ZMSG) THEN
                  IF (DIST(K).LT.DMIN .AND. DIST(K).LT.DISTMX) THEN
                     DMIN = DIST(K)
                     ZGRID(M,N) = Z(K)
                  END IF
               END IF
            END DO

         END DO
      END DO

      RETURN
      END

C
C	$Id: gtflt.f,v 1.4 2008-07-27 12:23:43 haley Exp $
C                                                                      
C			     Copyright (C)  1997
C	     University Corporation for Atmospheric Research
C			     All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C

      SUBROUTINE GTFLT(STRING, STRMAX, STRSIZ, IOS, STATUS)
C
C  Get a string of floating point values from the input file.
C
C  INPUT
C       STRMAX  --  The maximum number of floating point values
C                   to transfer.
C
C  OUTPUT
C       STRING  --  The array of floating point values.
C       STRSIZ  --  The number of floating point values
C                   actually transfered.
C       IOS     --  I/O status flag.  This flag is valid only
C                   if STATUS indicates an error.
C       STATUS  --  The error status as defined in COMMON CAPERR.
C
      COMMON /CAPERR/ ALLOK, EOFFL, INTERR, MAXINT, PLBERR, PMBERR,
     1                FABERR, TXBERR, FLTERR, MAXFLT, NOTINT, SIZERR,
     2                UNDASC, DEVERR, DOCERR, TBLERR , STSZER, ENTERR,
     3                TABERR, TABSER, PRSFIL
      INTEGER ALLOK, EOFFL, INTERR, MAXINT, PLBERR, PMBERR,
     1        FABERR, TXBERR, FLTERR, MAXFLT, NOTINT, SIZERR, UNDASC,
     2        DEVERR, DOCERR, STSZER, ENTERR, TABERR, TABSER, TBLERR,
     3        PRSFIL
      COMMON /CAPIOB/ UNIT, IPTR, LSIZE, NFST, NFLG
      COMMON /CAPIO2/ LINE, GRNM
      INTEGER LNMAX
      PARAMETER (LNMAX=80)
      CHARACTER*80 LINE
      CHARACTER*80 GRNM
      INTEGER UNIT, IPTR, LSIZE, NFST, NFLG
C
C  FLTMX specifies the maximum number of characters allowed in any
C  floating point number occuring in the input file.  If FLTMX is
C  changed, then a corresponding change will have to be made in the
C  format statement at statement lebel 80.
C
      INTEGER FLTMX
      PARAMETER (FLTMX=10)
C
      INTEGER STRMAX, STRSIZ, IOS, STATUS
      INTEGER II, TPTR, NUMSZ
      REAL STRING(STRMAX)
      CHARACTER*1 DECPT, MINUS, ZERO, NINE
      CHARACTER*1 BUF1(FLTMX),BLANK
      CHARACTER*(FLTMX) BUF2
C
      DATA DECPT, MINUS, ZERO, NINE /'.', '-', '0', '9'/
      DATA BLANK/' '/
C
C  Set STRING size to null.
C
      STRSIZ = 0
C
C  Skip blanks.
C
 10   CONTINUE
      CALL SKPBLK(IOS, STATUS)
      IF (STATUS .NE. ALLOK) RETURN
C
C  Check for a numeric string.
C
      IF (LINE(IPTR:IPTR).NE.DECPT.AND.LINE(IPTR:IPTR).NE.MINUS .AND.
     1   (LINE(IPTR:IPTR).LT.ZERO .OR. LINE(IPTR:IPTR).GT.NINE))
     1  RETURN
C
C  Extract characters from the floating-point input string until
C  a blank or end-of-line is encountered.
C
      NUMSZ = 0
      DO 50 II = IPTR, LSIZE
        IF (LINE(II:II) .NE. BLANK) THEN
                NUMSZ = NUMSZ + 1
C
C  NUMSZ exceeds the maximum number of digits allowed, set error
C  condition and return.
C
                IF (NUMSZ .GT. FLTMX) THEN
                        STATUS = MAXFLT
                        RETURN
                END IF
                BUF1(NUMSZ) = LINE(II:II)
                TPTR = II + 1
        ELSE
C
C  End of number.
C
                GO TO 55
        END IF
 50   CONTINUE
C
C  Set the buffer pointer to the current location.
C
 55   CONTINUE
      IPTR = TPTR
C
C  Zero out the conversion buffer.
C
      DO 60 II = 1,FLTMX
        BUF2(II:II) = ZERO
 60   CONTINUE
C
C  Move the input string to the conversion buffer.
C
       DO 70 II = 1,NUMSZ
        BUF2((FLTMX-II+1):(FLTMX-II+1)) = BUF1((NUMSZ-II)+1)
 70    CONTINUE
C
C  Convert to a floating value and store in STRING.
C
      STRSIZ = STRSIZ + 1
      READ(BUF2,80,ERR=1000) STRING(STRSIZ)
 80   FORMAT(F10.6)
C
C  If the requested number of values has been extracted, return.
C
      IF (STRSIZ .GE. STRMAX) RETURN
C
C  Continue to get next number.
C
      GO TO 10
C
C  Formatting error.
C
 1000 CONTINUE
      STATUS = FLTERR
      RETURN
      END

C
C	$Id: gtxtat.f,v 1.6 2008-07-27 00:21:03 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
        SUBROUTINE GTXTAT(IOS,STATUS)
C
C  Set the TEXT attributes.
C
C  Valid attributes:
C    TEXT INDEX BUNDLE
C    TEXT FONT INDEX
C    TEXT PRECISION
C    CHARACTER EXPANSION FACTOR
C    CHARACTER SPACING
C    TEXT COLOR
C    CHARACTER HEIGHT
C    CHARACTER ORIENTATION
C    CHARACTER PATH
C    TEXT ALIGNMENT
C
      include 'trstat.h'
      include 'trpars.h'
      include 'trinst.h'
      include 'trcode.h'
      include 'gkscom.h'
C
      INTEGER IOS, STATUS
      INTEGER TEMP
C
      IF (OPID .EQ. ATELTI) THEN
C
C  TEXT BUNDLE INDEX
C
        CALL GOPDEC(TXTIDX,MIXCPR,1,IOS,STATUS)
        CALL GSTXI(TXTIDX)
      ELSE IF (OPID .EQ. ATELTF) THEN
C
C  FONT INDEX
C
        CALL GOPDEC(TEMP,MIXCPR,1,IOS,STATUS)
        CALL GENNEG(TEMP,FINDEX)
        IF (FINDEX .LE. 0) FINDEX = 1
C
C  Set the font index to point to the appropriate internal font table.
C
        CALL GQTXFP(IER,IFNT,IPREC)
        CALL GSTXFP(FINDEX,IPREC)
C
      ELSE IF (OPID .EQ. ATELTP) THEN
C
C  TEXT PRECISION
C
        CALL GOPDEC(TXTPRE,MENCPR,1,IOS,STATUS)
        CALL GQTXFP(IER,IFNT,IPREC)
        CALL GSTXFP(IFNT,TXTPRE)
      ELSE IF (OPID .EQ. ATELCE) THEN
C
C  CHARACTER EXPANSION FACTOR
C
        CALL GTFLT(CEXPN,MFLCPR,IOS,STATUS)
        CALL GSCHXP(CEXPN)
      ELSE IF (OPID .EQ. ATELCS) THEN
C
C  CHARACTER SPACING
C
        CALL GTFLT(CSPACE,MFLCPR,IOS,STATUS)
        CALL GSCHSP(CSPACE)
      ELSE IF (OPID .EQ. ATELTC) THEN
C
C  Set the text color.
C
        CALL GOPDEC(TXTCOL,MCICPR,1,IOS,STATUS)
        CALL GSTXCI(TXTCOL)
      ELSE IF (OPID .EQ. ATELCH) THEN
C
C  CHARACTER HEIGHT
C
        CALL GOPDEC(CHIGHT,MOPLEN,1,IOS,STATUS)
        XHIGHT = REAL(CHIGHT)/32767.
C
C  Scale the character height by the original scale factor in the
C  Y direction.  Take a vactor (0,XHIGHT), transform it with the
C  current transformation matrix, then find the length of the
C  transformed vector.
C
        YSCALE = SQRT(CURTM(1,2)*CURTM(1,2)+CURTM(2,2)*CURTM(2,2))
        HN = XHIGHT*YSCALE
        IF (HN .LT. 0.00004) HN = 0.00004
        CALL GSCHH(HN)
      ELSE IF (OPID .EQ. ATELCO) THEN
C
C  CHARACTER ORIENTATION (given as up and base vectors).
C
        CALL GOPDEC(TEMP,MOPLEN,1,IOS,STATUS)
        CALL GENNEG(TEMP,XU)
        IF (STATUS .NE. 0) RETURN
        CALL GOPDEC(TEMP,MOPLEN,1,IOS,STATUS)
        CALL GENNEG(TEMP,YU)
        IF (STATUS .NE. 0) RETURN
        CALL GOPDEC(TEMP,MOPLEN,1,IOS,STATUS)
        CALL GENNEG(TEMP,XB)
        IF (STATUS .NE. 0) RETURN
        CALL GOPDEC(TEMP,MOPLEN,1,IOS,STATUS)
        CALL GENNEG(TEMP,YB)
C
C  Modify the up vector by the current segment transformation.
C
        RXUT = CURTM(1,1)*REAL(XU)+CURTM(1,2)*REAL(YU)
        RYUT = CURTM(2,1)*REAL(XU)+CURTM(2,2)*REAL(YU)
C
C  If the modified values are both zero, then the transformation 
C  scaling is such as to make the character orientation of no 
C  observable consequence, so set it to horizontal.
C
        IF (RXUT.EQ.0. .AND. RYUT.EQ.0.) THEN
          RXUT = 0.
          RYUT = 1.
        ENDIF
        CALL GSCHUP(RXUT,RYUT)
      ELSE IF (OPID.EQ.ATELTH) THEN
C
C  TEXT PATH
C
        CALL GOPDEC(PATH,MENCPR,1,IOS,STATUS)
        CALL GSTXP(PATH)
      ELSE IF (OPID .EQ. ATELTA) THEN
C
C  TEXT ALIGNMENT
C
        CALL GOPDEC(HORIZ,MENCPR,1,IOS,STATUS)
        IF (STATUS .NE. 0) RETURN
        CALL GOPDEC(VERT,MENCPR,1,IOS,STATUS)
        CALL GSTXAL(HORIZ,VERT)
C
C  Skip over the rest of the alignment information.
C
        CALL GSKPOP(8,LEN-(MENCPR*2/8),IOS,STATUS)
      END IF
C
      RETURN
      END

      PROGRAM CTWNG2
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.  Use one
C of the following:
C
C       PARAMETER (IERF=6,LUNI=2,IWTY=1 ,IWID=1)  !  NCGM
C       PARAMETER (IERF=6,LUNI=2,IWTY=8 ,IWID=1)  !  X Windows
C       PARAMETER (IERF=6,LUNI=2,IWTY=20,IWID=1)  !  PostScript
C       PARAMETER (IERF=6,LUNI=2,IWTY=11,IWID=1)  !  PDF, Portrait
C       PARAMETER (IERF=6,LUNI=2,IWTY=12,IWID=1)  !  PDF, Landscape
C
        PARAMETER (IERF=6,LUNI=2,IWTYPE=1,IWTY=IWTYPE,IWID=1)
C
C The object of this program is to produce a set of plots illustrating
C the use of a triangular mesh derived from a SEAM grid on the surface
C of the globe (obtained from Houjun Wang):  Each face of a cube is
C divided into a 3-by-3 grid of rectangles and some of those rectangles
C are further divided to form a network of 112 quadrilaterals covering
C the globe, each of which is split into two triangles to form the
C triangular mesh.  Routines developed for use with the geodesic mesh
C (method 2) are also used for this mesh.
C
C Selected frames are drawn for each of four different viewpoints.  If
C (CLAT,CLON) is the approximate position of the "center point" of the
C mesh (which is defined somewhat arbitrarily for certain meshes), the
C four viewpoints used are as follows: (CLAT+45,CLON), (CLAT-45,CLON),
C (CLAT+45,CLON+180), and (CLAT-45,CLON+180).
C
C At each of the four viewpoints, up to five different frames are drawn:
C
C   1) A frame showing the original rectangular grid on the globe.
C      This frame is drawn only if the parameter IMSH = 1 or 3.
C
C   2) A frame showing the triangular mesh on the globe.  This frame
C      is drawn only if the parameter IMSH = 2 or 3.
C
C   3) A frame showing simple contours on the globe.  This frame is
C      drawn only if the parameter ICON is non-zero.
C
C   4) A frame showing color-filled contour bands on the globe, drawn
C      using filled areas.  This frame is drawn only if the parameter
C      ICOL is non-zero.
C
C   5) A frame showing color-filled contour bands on the globe, drawn
C      using a cell array.  This frame is drawn only if the parameter
C      ICAP is non-zero.
C
C Define the parameter that says which frames showing the rectangular
C grid and/or the triangular mesh are to be drawn (frames 1 and 2):
C
C       PARAMETER (IMSH=0)  !  neither grid nor mesh
C       PARAMETER (IMSH=1)  !  simple rectangular grid only
C       PARAMETER (IMSH=2)  !  triangular mesh only
C       PARAMETER (IMSH=3)  !  both
C
        PARAMETER (IMSH=3)
C
C Define the parameter that says whether or not to draw simple contours
C (frame 3):
C
C       PARAMETER (ICON=0)  !  contours not drawn
C       PARAMETER (ICON=1)  !  contours drawn
C
        PARAMETER (ICON=1)
C
C Define the parameter that says whether or not to draw color-filled
C contours (frame 4):
C
C       PARAMETER (ICOL=0)  !  no color fill done
C       PARAMETER (ICOL=1)  !  color fill done
C
        PARAMETER (ICOL=1)
C
C Define the parameter that says whether or not to draw a cell array
C plot (frame 5):
C
C       PARAMETER (ICAP=0)  !  cell array plot not drawn
C       PARAMETER (ICAP=1)  !  cell array plot drawn
C
        PARAMETER (ICAP=1)
C
C To represent the triangular mesh, we use three singly-dimensioned
C arrays: RPNT holds points, IEDG holds edges, and ITRI holds triangles.
C The elements of each array form "nodes" having lengths as follows:
C
        PARAMETER (LOPN=5)
C
C The five elements of a point node are
C
C   1. the X coordinate of the point;
C   2. the Y coordinate of the point;
C   3. the Z coordinate of the point;
C   4. the field value at the point;
C   5. any additional value desired by the user.
C
        PARAMETER (LOEN=5)
C
C The five elements of an edge node are
C
C   1. the base index, in RPNT, of point 1 of the edge;
C   2. the base index, in RPNT, of point 2 of the edge;
C   3. the index, in ITRI, of the pointer to the edge in the triangle to
C      the left of the edge (-1 if there is no triangle to the left);
C   4. the index, in ITRI, of the pointer to the edge in the triangle to
C      the right of the edge (-1 if there is no triangle to the right);
C   5. a utility flag for use by algorithms that scan the structure.
C
C The "left" and "right" sides of an edge are defined as they would be
C by an observer standing on the globe at point 1 of the edge, looking
C toward point 2 of the edge.  It is possible, if there are "holes" in
C the mesh, that there will be no triangle to the left or to the right
C of an edge, but there must be a triangle on one side or the other.
C
        PARAMETER (LOTN=4)
C
C The four elements of a triangle node are
C
C   1. the base index, in IEDG, of edge 1 of the triangle;
C   2. the base index, in IEDG, of edge 2 of the triangle;
C   3. the base index, in IEDG, of edge 3 of the triangle;
C   4. a flag set non-zero to block use of the triangle, effectively
C      removing it from the mesh.
C
C The "base index" of a point node, an edge node, or a triangle node is
C always a multiple of the length of the node, to which can be added an
C offset to get the index of a particular element of the node.  For
C example, if I is the base index of a triangle of interest, ITRI(I+1)
C is its first element (the base index of its first edge).  Similarly,
C IEDG(ITRI(I+1)+2) is the base index of the second point of the first
C edge of the triangle with base index I, and RPNT(IEDG(ITRI(I+1)+2)+3)
C is the third (Z) coordinate of the second point of the first edge of
C the triangle with base index I.
C
C It is the pointers from the edge nodes back to the triangle nodes that
C allow CONPACKT to navigate the mesh, moving from triangle to triangle
C as it follows a contour line, but these pointers are tricky to define:
C if IPTE is the base index of an edge node and IEDG(IPTE+3) is zero or
C more, saying that there is a triangle to the left of the edge, then
C IEDG(IPTE+3) is the actual index of that element of the triangle node
C that points to the edge node; i.e., ITRI(IEDG(IPTE+3))=IPTE.  The base
C index of the triangle node defining that triangle is IPTT, where
C IPTT=LOTN*((IEDG(IPTE+3)-1)/LOTN), and the index of the pointer to
C the edge within the triangle node is IPTI=IEDG(IPTE+3)-IPTT, so that
C ITRI(IPTT+IPTI)=IPTE.  Similar comments apply to element 4 of an edge
C node, which points into the triangle node defining the triangle to the
C right of the edge.
C
C The numbers of points, edges, and triangles in the triangular mesh are
C as follows (obtained from a run in which the numbers were set larger
C than this):
C
        PARAMETER (MNOP=1406)
        PARAMETER (MNOE=4212)
        PARAMETER (MNOT=2808)
C
C Once we know how many points, edges, and triangles we're going to use
C (at most), we can set parameters defining the space reserved for the
C triangular mesh:
C
        PARAMETER (MPNT=MNOP*LOPN)
        PARAMETER (MEDG=MNOE*LOEN)
        PARAMETER (MTRI=MNOT*LOTN)
C
C Declare the arrays to hold the point nodes, edge nodes, and triangle
C nodes defining the triangular mesh.
C
        DIMENSION RPNT(MPNT),IEDG(MEDG),ITRI(MTRI)
C
C Declare sort arrays to be used in GTWNG2 to keep track of where points
C and edges were put in the structure defining the triangular mesh.
C
        DIMENSION IPPP(3,MNOP),IPPE(2,MNOE)
C
C Declare real and integer workspaces needed by CONPACKT.
C
        PARAMETER (LRWK=10000,LIWK=1000)
C
        DIMENSION RWRK(LRWK),IWRK(LIWK)
C
C Declare the area map array needed to do solid fill.
C
        PARAMETER (LAMA=400000)
C
        DIMENSION IAMA(LAMA)
C
C Declare workspace arrays to be used in calls to ARSCAM.
C
        PARAMETER (NCRA=LAMA/10,NGPS=2)
C
        DIMENSION XCRA(NCRA),YCRA(NCRA),IAAI(NGPS),IAGI(NGPS)
C
C Declare arrays in which to generate a cell array picture of the
C data on the triangular mesh.
C
C       PARAMETER (ICAM=1024,ICAN=1024)
        PARAMETER (ICAM= 512,ICAN= 512)
C
        DIMENSION ICRA(ICAM,ICAN)
C
C Declare arrays to hold color components for colors to be used at the
C four corners of an illustrative drawing of the rectangular grid.
C
        DIMENSION CCLL(3),CCLR(3),CCUL(3),CCUR(3)
C
C Declare external the routine that draws masked contour lines.
C
        EXTERNAL DRWMCL
C
C Declare external the routine that does color fill of contour bands.
C
        EXTERNAL DCFOCB
C
C Define a common block in which to keep track of the maximum space used
C in the arrays XCRA and YCRA.
C
        COMMON /COMONA/ MAXN
C
C Define the out-of-range flag.
C
        DATA OORV / 1.E12 /
C
C Define the tension on the splines to be used in smoothing contours.
C
C       DATA T2DS / 0.0 /  !  smoothing off
C       DATA T2DS / 2.5 /  !  smoothing on
C
        DATA T2DS / 0.0 /
C
C Define the distance between points on smoothed contour lines.
C
        DATA RSSL / .002 /
C
C Define the amount of real workspace to be used in drawing contours.
C
        DATA IRWC / 500 /
C
C Define the label-positioning flag.
C
C       DATA ILLP / 0 /  !  no labels
C       DATA ILLP / 1 /  !  dash-package writes labels
C       DATA ILLP / 2 /  !  regular scheme
C       DATA ILLP / 3 /  !  penalty scheme
C
        DATA ILLP / 2 /
C
C Define the high/low search radius.
C
        DATA HLSR / .075 /
C
C Define the high/low label overlap flag.
C
        DATA IHLO / 11 /
C
C Define the hachuring flag, hachure length, and hachure spacing.
C
C       DATA IHCF,HCHL,HCHS /  0 , +.004 , .010 /  !  off
C       DATA IHCF,HCHL,HCHS / +1 , -.004 , .020 /  !  on, all, uphill
C
        DATA IHCF,HCHL,HCHS /  0 , +.004 , .010 /
C
C Define the colors to be used in the lower left, lower right, upper
C left, and upper right corners of the rectangular grid when a drawing
C of it is made for the purpose of illustrating how it is wrapped around
C the globe.
C
        DATA CCLL / 0.2 , 0.2 , 0.2 /
        DATA CCLR / 1.0 , 0.0 , 1.0 /
        DATA CCUL / 0.0 , 1.0 , 1.0 /
        DATA CCUR / 1.0 , 1.0 , 0.0 /
C
C Define a constant to convert from radians to degrees.
C
        DATA RTOD / 57.2957795130823 /
C
C Read data and generate the required triangular mesh.
C
        PRINT * , ' '
        PRINT * , 'CREATING TRIANGULAR MESH:'
C
        CALL GTWNG2 (RPNT,MPNT,NPNT,LOPN,
     +               IEDG,MEDG,NEDG,LOEN,
     +               ITRI,MTRI,NTRI,LOTN,
     +               IPPP,IPPE,CLAT,CLON)
C
C Print the number of points, edges, and triangles.
C
        PRINT * , '  NUMBER OF POINTS:    ',NPNT/LOPN
        PRINT * , '  NUMBER OF EDGES:     ',NEDG/LOEN
        PRINT * , '  NUMBER OF TRIANGLES: ',NTRI/LOTN
C
C Write the contents of the point list, the edge list, and the triangle
C list to "fort.11" in a readable form.
C
c       WRITE (11,'(''P'',I8,5F10.4)')
c    +        (I,RPNT(I+1),RPNT(I+2),RPNT(I+3),RPNT(I+4),RPNT(I+5),
c    +                                               I=0,NPNT-LOPN,LOPN)
c       WRITE (11,'(''E'',I8,5I10)')
c    +        (I,IEDG(I+1),IEDG(I+2),IEDG(I+3),IEDG(I+4),IEDG(I+5),
c    +                                               I=0,NEDG-LOEN,LOEN)
c       WRITE (11,'(''T'',I8,4I10)')
c    +        (I,ITRI(I+1),ITRI(I+2),ITRI(I+3),ITRI(I+4),
c    +                                               I=0,NTRI-LOTN,LOTN)
C
C Open GKS.
C
        PRINT * , 'OPENING AND INITIALIZING GKS'
C
        CALL GOPKS (IERF,0)
        CALL GOPWK (IWID,LUNI,IWTY)
        CALL GACWK (IWID)
C
C Turn off the clipping indicator.
C
        CALL GSCLIP (0)
C
C Define a basic set of colors (0 = white, background; 1 = black,
C foreground; 2 = yellow; 3 = magenta; 4 = red; 5 = cyan; 6 = green;
C 7 = blue; 8 = darker light gray; 9 = lighter light gray; 10 = dark
C yellow; 11 = dark gray; 12 = medium gray; 13 = light red, for
C geographic lines; 14 = light blue, for lat/lon lines).
C
        CALL GSCR   (IWID, 0,1.,1.,1.)
        CALL GSCR   (IWID, 1,0.,0.,0.)
        CALL GSCR   (IWID, 2,1.,1.,0.)
        CALL GSCR   (IWID, 3,1.,0.,1.)
        CALL GSCR   (IWID, 4,1.,0.,0.)
        CALL GSCR   (IWID, 5,0.,1.,1.)
        CALL GSCR   (IWID, 6,0.,1.,0.)
        CALL GSCR   (IWID, 7,0.,0.,1.)
        CALL GSCR   (IWID, 8,.5,.5,.5)
        CALL GSCR   (IWID, 9,.8,.8,.8)
        CALL GSCR   (IWID,10,.3,.3,0.)
        CALL GSCR   (IWID,11,.3,.3,.3)
        CALL GSCR   (IWID,12,.5,.5,.5)
        CALL GSCR   (IWID,13,.8,.5,.5)
        CALL GSCR   (IWID,14,.5,.5,.8)
C
C Define 100 colors, associated with color indices 151 through 250, to
C be used for color-filled contour bands and in cell arrays, ranging
C from blue to red.
C
        CALL DFCLRS (IWID,151,250,0.,0.,1.,1.,0.,0.)
C
C Set parameters in the utilities.
C
        PRINT * , 'SETTING PARAMETERS IN CONPACKT, EZMAP, AND PLOTCHAR'
C
C Set the mapping flag.
C
        CALL CTSETI ('MAP - MAPPING FLAG',1)
C
C Set the out-of-range flag value.
C
        CALL CTSETR ('ORV - OUT-OF-RANGE VALUE',OORV)
C
C Turn on the drawing of the mesh edge and set the area identifier for
C areas outside the mesh.
C
        CALL CTSETI ('PAI - PARAMETER ARRAY INDEX',-1)
        CALL CTSETI ('CLU - CONTOUR LEVEL USE FLAG',1)
        CALL CTSETI ('AIA - AREA IDENTIFIER FOR AREA',1001)
C
C Set the point-interpolation flag for contours.  This is done because
C the grid is quite coarse, resulting in rather large triangles in the
C triangular mesh; this, in turn, leads to contour lines being drawn
C with rather long line segments.  On viewpoint 3, near the edge of the
C globe, this causes one contour line to cross another.  With 'PIT' set
C to .01, points are interpolated along the contour lines in such a way
C as to prevent any projected segment from having a length of more than
C .01 times the width of the user window, so contour lines are projected
C onto the map using more points, which prevents them from crossing one
C another.
C
        CALL CTSETR ('PIT - MAPPING FLAG',.01)
C
C Set the area identifier for areas in "out-of-range" areas.
C
C       CALL CTSETI ('PAI',-2)
C       CALL CTSETI ('AIA - AREA IDENTIFIER FOR AREA',1002)
C
C Set the 2D smoother flag.
C
        CALL CTSETR ('T2D - TENSION ON 2D SPLINES',T2DS)
C
C Set the distance between points on smoothed lines.
C
        CALL CTSETR ('SSL - SMOOTHED SEGMENT LENGTH',RSSL)
C
C Set the amount of real workspace to be used in drawing contours.
C
        CALL CTSETI ('RWC - REAL WORKSPACE FOR CONTOURS',IRWC)
C
C Set the label-positioning flag.
C
        CALL CTSETI ('LLP - LINE LABEL POSITIONING FLAG',ILLP)
C
C Set the high/low search radius.
C
        CALL CTSETR ('HLR - HIGH/LOW SEARCH RADIUS',HLSR)
C
C Set the high/low label overlap flag.
C
        CALL CTSETI ('HLO - HIGH/LOW LABEL OVERLAP FLAG',IHLO)
C
C Set the hachuring flag, hachure length, and hachure spacing.
C
        CALL CTSETI ('HCF - HACHURING FLAG',IHCF)
        CALL CTSETR ('HCL - HACHURE LENGTH',HCHL)
        CALL CTSETR ('HCS - HACHURE SPACING',HCHS)
C
C Set the cell array flag.
C
        CALL CTSETI ('CAF - CELL ARRAY FLAG',-1)
C
C Tell CONPACKT not to do its own call to SET, since EZMAP will have
C done it.
C
        CALL CTSETI ('SET - DO-SET-CALL FLAG', 0)
C
C Move the informational label up a little.
C
        CALL CTSETR ('ILY - INFORMATIONAL LABEL Y POSITION',-.005)
C
C Tell EZMAP not to draw the perimeter.
C
        CALL MPSETI ('PE',0)
C
C Tell EZMAP to use solid lat/lon lines.
C
        CALL MPSETI ('DA',65535)
C
C Tell PLOTCHAR to use one of the filled fonts and to outline each
C character.
C
        CALL PCSETI ('FN',25)
        CALL PCSETI ('OF',1)
C
C Tell PLOTCHAR to expect a character other than a colon as the
C function-control signal character.
C
        CALL PCSETC ('FC','|')
C
C Loop through four different viewing angles.
C
        DO 104 IDIR=1,4
C
          PRINT * , ' '
          PRINT * , 'VIEW FROM DIRECTION NUMBER: ',IDIR
C
C Tell EZMAP what projection to use and what its limits are.
C
          IF      (IDIR.EQ.1) THEN
            CALL MAPROJ ('OR',CLAT+45.,CLON,      0.)
          ELSE IF (IDIR.EQ.2) THEN
            CALL MAPROJ ('OR',CLAT-45.,CLON,      0.)
          ELSE IF (IDIR.EQ.3) THEN
            CALL MAPROJ ('OR',CLAT+45.,CLON+180., 0.)
          ELSE IF (IDIR.EQ.4) THEN
            CALL MAPROJ ('OR',CLAT-45.,CLON+180., 0.)
          END IF
C
          CALL MAPSET ('MA',0.,0.,0.,0.)
C
C Initialize EZMAP.
C
          CALL MAPINT
C
C If the rectangular grid and/or the triangular mesh are to be drawn,
C do it.
C
          IF (IMSH.NE.0) THEN
C
            PRINT * , 'DRAWING MESHES'
C
C Simple rectangular grid:
C
            IF (MOD(IMSH,2).NE.0) THEN
C
              PRINT * , 'DRAWING SIMPLE RECTANGULAR GRID'
C
              CALL DSWNG2
C
C Label the first frame.
C
              CALL PLCHHQ (CFUX(.03),CFUY(.946),'SEAM GRID',
     +                                                      .024,0.,-1.)
              CALL PLCHHQ (CFUX(.03),CFUY(.906),'(EXAMPLE 2)',
     +                                                      .016,0.,-1.)
C
              IF (     IDIR.EQ.1) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 1',
     +                                                      .012,0.,-1.)
              ELSE IF (IDIR.EQ.2) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 2',
     +                                                      .012,0.,-1.)
              ELSE IF (IDIR.EQ.3) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 3',
     +                                                      .012,0.,-1.)
              ELSE IF (IDIR.EQ.4) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 4',
     +                                                      .012,0.,-1.)
              END IF
C
              CALL PLCHHQ (CFUX(.97),CFUY(.950),'ORIGINAL RECTANGULAR GR
     +ID',.012,0.,1.)
C
              CALL PLCHHQ (CFUX(.97),CFUY(.928),
     +                     'This grid is developed from a cube.',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.908),
     +                     'The numbers label 156 separate',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.888),
     +                     'elements, each of which is',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.868),
     +                     'a quadrilateral patch:',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.848),
     +                     'some patches come',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.828),
     +                     'from 1/16th of a',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.808),
     +                     'cube face and',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.788),
     +                     'others from',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.768),
     +                     'portions',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.748),
     +                     'thereof.',
     +                                                       .010,0.,1.)
C
              CALL PLCHHQ (CFUX(.03),CFUY(.084),'Grid is gray.',
     +                                                      .012,0.,-1.)
              CALL PLCHHQ (CFUX(.03),CFUY(.060),'Shorelines are blue.',
     +                                                      .012,0.,-1.)
              CALL PLCHHQ (CFUX(.03),CFUY(.036),'Parallels/meridians are
     + red.',.012,0.,-1.)
C
C Advance the frame.
C
              CALL FRAME
C
            END IF
C
C Triangular mesh (with edges between blocked triangles somewhat fainter
C than the rest):
C
            IF (MOD(IMSH/2,2).NE.0) THEN
C
              PRINT * , 'DRAWING TRIANGULAR MESH'
C
              DO 101 IPTE=0,NEDG-LOEN,LOEN
C
                IFLL=0
C
                IF (IEDG(IPTE+3).GE.0) THEN
                  IF (ITRI(LOTN*((IEDG(IPTE+3)-1)/LOTN)+4).EQ.0) IFLL=1
                END IF
C
                IFLR=0
C
                IF (IEDG(IPTE+4).GE.0) THEN
                  IF (ITRI(LOTN*((IEDG(IPTE+4)-1)/LOTN)+4).EQ.0) IFLR=1
                END IF
C
                IF (IFLL.NE.0.OR.IFLR.NE.0) THEN
                  CALL PLOTIT (0,0,2)
                  CALL GSPLCI (8)
                ELSE
                  CALL PLOTIT (0,0,2)
                  CALL GSPLCI (9)
                END IF
C
                ALAT=RTOD*ASIN(RPNT(IEDG(IPTE+1)+3))
C
                IF (RPNT(IEDG(IPTE+1)+1).EQ.0..AND.
     +              RPNT(IEDG(IPTE+1)+2).EQ.0.) THEN
                  ALON=0.
                ELSE
                  ALON=RTOD*ATAN2(RPNT(IEDG(IPTE+1)+2),
     +                            RPNT(IEDG(IPTE+1)+1))
                END IF
C
                BLAT=RTOD*ASIN(RPNT(IEDG(IPTE+2)+3))
C
                IF (RPNT(IEDG(IPTE+2)+1).EQ.0..AND.
     +              RPNT(IEDG(IPTE+2)+2).EQ.0.) THEN
                  BLON=0.
                ELSE
                  BLON=RTOD*ATAN2(RPNT(IEDG(IPTE+2)+2),
     +                            RPNT(IEDG(IPTE+2)+1))
                END IF
C
                CALL DRSGCR (ALAT,ALON,BLAT,BLON)
C
  101         CONTINUE
C
              CALL PLOTIT (0,0,2)
              CALL GSPLCI (13)
              CALL MAPGRD
              CALL PLOTIT (0,0,2)
              CALL GSPLCI (14)
              CALL MAPLOT
C
C Label the second frame.
C
              CALL PLCHHQ (CFUX(.03),CFUY(.946),'SEAM GRID',
     +                                                      .024,0.,-1.)
              CALL PLCHHQ (CFUX(.03),CFUY(.906),'(EXAMPLE 2)',
     +                                                      .016,0.,-1.)
C
              IF (     IDIR.EQ.1) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 1',
     +                                                      .012,0.,-1.)
              ELSE IF (IDIR.EQ.2) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 2',
     +                                                      .012,0.,-1.)
              ELSE IF (IDIR.EQ.3) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 3',
     +                                                      .012,0.,-1.)
              ELSE IF (IDIR.EQ.4) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 4',
     +                                                      .012,0.,-1.)
              END IF
C
              CALL PLCHHQ (CFUX(.97),CFUY(.950),'DERIVED TRIANGULAR MESH
     +',.012,0.,1.)
C
              CALL PLCHHQ (CFUX(.97),CFUY(.928),
     +                     'Each quadrilateral of the grid',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.908),
     +                     'is split into nine smaller',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.888),
     +                     'quadrilaterals; each',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.868),
     +                     'of those is then',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.848),
     +                     'split into two',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.828),
     +                     'triangles.',
     +                                                       .010,0.,1.)
C
              CALL PLCHHQ (CFUX(.03),CFUY(.084),'Mesh is gray.',
     +                                                      .012,0.,-1.)
              CALL PLCHHQ (CFUX(.03),CFUY(.060),'Shorelines are blue.',
     +                                                      .012,0.,-1.)
              CALL PLCHHQ (CFUX(.03),CFUY(.036),'Parallels/meridians are
     + red.',.012,0.,-1.)
C
C Advance the frame.
C
              CALL FRAME
C
            END IF
C
          END IF
C
C If a frame showing simple contours is to be drawn, do it next (adding
C an overlay of lat/lon lines and continental outlines in light gray).
C
          IF (ICON.NE.0) THEN
C
            PRINT * , 'DRAWING PLOT SHOWING SIMPLE CONTOURS'
C
C Initialize CONPACKT.
C
            PRINT * , 'CALLING CTMESH'
C
            CALL CTMESH (RPNT,NPNT,LOPN,
     +                   IEDG,NEDG,LOEN,
     +                   ITRI,NTRI,LOTN,
     +                   RWRK,LRWK,
     +                   IWRK,LIWK)
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (1)
C
C Proceed as implied by the setting of the label-positioning flag.
C
            IF (ABS(ILLP).EQ.1) THEN
C
C Draw the contour lines with labels generated by the dash package.
C
              PRINT * , 'CALLING CTCLDR'
              CALL CTCLDR (RPNT,IEDG,ITRI,RWRK,IWRK)
C
C Add the informational and high/low labels.
C
              PRINT * , 'CALLING CTLBDR'
              CALL CTLBDR (RPNT,IEDG,ITRI,RWRK,IWRK)
C
            ELSE IF (ABS(ILLP).GT.1) THEN
C
C Create an area map for masking of labels.
C
              MAXN=0
C
              PRINT * , 'CALLING ARINAM'
              CALL ARINAM (IAMA,LAMA)
C
              PRINT * , 'CALLING CTLBAM'
              CALL CTLBAM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA)
C
C Draw the contour lines masked by the area map.
C
              PRINT * , 'CALLING CTCLDM'
              CALL CTCLDM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA,DRWMCL)
C
              PRINT * , 'AREA MAP SPACE REQUIRED:         ',
     +                                         IAMA(1)-IAMA(6)+IAMA(5)+1
C
              PRINT * , 'NUMBER OF POINTS IN LONGEST LINE:',MAXN
C
C Draw all the labels.
C
              PRINT * , 'CALLING CTLBDR'
              CALL CTLBDR (RPNT,IEDG,ITRI,RWRK,IWRK)
C
            END IF
C
            CALL CTGETI ('IWU - INTEGER WORKSPACE USED',IIWU)
            PRINT * , 'INTEGER WORKSPACE REQUIRED:      ',IIWU
C
            CALL CTGETI ('RWU -    REAL WORKSPACE USED',IRWU)
            PRINT * , 'REAL WORKSPACE REQUIRED:         ',IRWU
C
C Add lat/lon lines and continental outlines.
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (13)
            CALL MAPGRD
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (14)
            CALL MAPLOT
C
C Label the third frame.
C
            CALL PLCHHQ (CFUX(.03),CFUY(.946),'SEAM GRID',.024,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.906),'(EXAMPLE 2)',.016,0.,-1.)
C
            IF (     IDIR.EQ.1) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 1',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.2) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 2',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.3) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 3',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.4) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 4',
     +                                                      .012,0.,-1.)
            END IF
C
            CALL PLCHHQ (CFUX(.97),CFUY(.950),'SIMPLE CONTOURS ON',
     +                                                       .012,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.926),'TRIANGULAR MESH',
     +                                                       .012,0.,1.)
C
            CALL PLCHHQ (CFUX(.97),CFUY(.904),'Dummy data are used.',
     +                                                       .010,0.,1.)
C
            CALL PLCHHQ (CFUX(.03),CFUY(.060),'Shorelines are blue.',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.036),'Parallels/meridians are r
     +ed.',.012,0.,-1.)
C
C Advance the frame.
C
            CALL FRAME
C
          END IF
C
C If a frame showing color-filled contours is to be drawn, do it next.
C
          IF (ICOL.NE.0) THEN
C
            PRINT * , 'DRAWING PLOT SHOWING COLOR-FILLED CONTOURS'
C
            PRINT * , 'CALLING CTMESH'
C
            CALL CTMESH (RPNT,NPNT,LOPN,
     +                   IEDG,NEDG,LOEN,
     +                   ITRI,NTRI,LOTN,
     +                   RWRK,LRWK,
     +                   IWRK,LIWK)
C
            MAXN=0
C
            PRINT * , 'CALLING CTPKCL'
            CALL CTPKCL (RPNT,IEDG,ITRI,RWRK,IWRK)
C
            PRINT * , 'CALLING ARINAM'
            CALL ARINAM (IAMA,LAMA)
C
            PRINT * , 'CALLING CTCLAM'
            CALL CTCLAM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA)
C
C           PRINT * , 'CALLING CTLBAM'
C           CALL CTLBAM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA)
C
            PRINT * , 'CALLING ARSCAM'
            CALL ARSCAM (IAMA,XCRA,YCRA,NCRA,IAAI,IAGI,NGPS,DCFOCB)
C
            PRINT * , 'SPACE REQUIRED IN AREA MAP:      ',
     +                                         IAMA(1)-IAMA(6)+IAMA(5)+1
C
            PRINT * , 'NUMBER OF POINTS IN LARGEST AREA:',MAXN
C
            CALL CTGETI ('IWU - INTEGER WORKSPACE USED',IIWU)
            PRINT * , 'INTEGER WORKSPACE REQUIRED:      ',IIWU
C
            CALL CTGETI ('RWU -    REAL WORKSPACE USED',IRWU)
            PRINT * , 'REAL WORKSPACE REQUIRED:         ',IRWU
C
            CALL GSFACI (1)
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (13)
            CALL MAPGRD
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (14)
            CALL MAPLOT
C
C Label the fourth frame.
C
            CALL PLCHHQ (CFUX(.03),CFUY(.946),'SEAM GRID',.024,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.906),'(EXAMPLE 2)',.016,0.,-1.)
C
            IF (     IDIR.EQ.1) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 1',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.2) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 2',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.3) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 3',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.4) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 4',
     +                                                      .012,0.,-1.)
            END IF
C
            CALL PLCHHQ (CFUX(.97),CFUY(.950),'COLORED CONTOUR BANDS ON'
     +,.012,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.926),'TRIANGULAR MESH',
     +                                                       .012,0.,1.)
C
            CALL PLCHHQ (CFUX(.97),CFUY(.904),'Dummy data are used.',
     +                                                       .010,0.,1.)
C
            CALL PLCHHQ (CFUX(.03),CFUY(.132),'Off-mesh',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.108),'areas of the',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.084),'globe are yellow.',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.060),'Shorelines are blue.',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.036),'Parallels/meridians are r
     +ed.',.012,0.,-1.)
C
C Advance the frame.
C
            CALL FRAME
C
          END IF
C
C If the flag for it is set, do a cell array plot.
C
          IF (ICAP.NE.0) THEN
C
            PRINT * , 'DRAWING CELL-ARRAY PLOT OF DATA VALUES'
C
            PRINT * , 'CALLING CTMESH'
C
            CALL CTMESH (RPNT,NPNT,LOPN,
     +                   IEDG,NEDG,LOEN,
     +                   ITRI,NTRI,LOTN,
     +                   RWRK,LRWK,
     +                   IWRK,LIWK)
C
            CALL GETSET (XVPL,XVPR,YVPB,YVPT,XWDL,XWDR,YWDB,YWDT,LNLG)
C
            PRINT * , 'CALLING CTCICA'
            CALL CTCICA (RPNT,IEDG,ITRI,RWRK,IWRK,ICRA,ICAM,ICAM,ICAN,
     +                                            XVPL,YVPB,XVPR,YVPT)
C
            PRINT * , 'CALLING GCA'
            CALL GCA (XWDL,YWDB,XWDR,YWDT,ICAM,ICAN,1,1,ICAM,ICAN,ICRA)
C
            CALL CTGETI ('IWU - INTEGER WORKSPACE USED',IIWU)
            PRINT * , 'INTEGER WORKSPACE REQUIRED:      ',IIWU
C
            CALL CTGETI ('RWU -    REAL WORKSPACE USED',IRWU)
            PRINT * , 'REAL WORKSPACE REQUIRED:         ',IRWU
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (13)
            CALL MAPGRD
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (14)
            CALL MAPLOT
C
C Label the fifth frame.
C
            CALL PLCHHQ (CFUX(.03),CFUY(.946),'SEAM GRID',.024,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.906),'(EXAMPLE 2)',.016,0.,-1.)
C
            IF (     IDIR.EQ.1) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 1',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.2) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 2',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.3) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 3',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.4) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 4',
     +                                                      .012,0.,-1.)
            END IF
C
            CALL PLCHHQ (CFUX(.97),CFUY(.950),'CELL ARRAY DERIVED FROM',
     +.012,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.926),'TRIANGULAR MESH',
     +                                                       .012,0.,1.)
C
            CALL PLCHHQ (CFUX(.97),CFUY(.904),'Dummy data are used.',
     +                                                       .010,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.073),'Yellow patches on the lim
     +b',.010,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.053),'are caused by a glitch in
     + CTCICA.',.010,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.033),'Using a finer grid allevi
     +ates the problem.',.010,0.,1.)
C
            CALL PLCHHQ (CFUX(.03),CFUY(.132),'Off-mesh',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.108),'areas of the',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.084),'globe are yellow.',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.060),'Shorelines are blue.',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.036),'Parallels/meridians are r
     +ed.',.012,0.,-1.)
C
C Advance the frame.
C
            CALL FRAME
C
          END IF
C
  104   CONTINUE
C
C Close GKS.
C
        CALL GDAWK (IWID)
        CALL GCLWK (IWID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END


      SUBROUTINE DFCLRS (IWID,IOFC,IOLC,REDF,GRNF,BLUF,REDL,GRNL,BLUL)
C
C This routine defines color indices IOFC through IOLC on workstation
C IWID by interpolating values from REDF/GRNF/BLUF to REDL/GRNL/BLUL.
C
        DO 101 I=IOFC,IOLC
          P=REAL(IOLC-I)/REAL(IOLC-IOFC)
          Q=REAL(I-IOFC)/REAL(IOLC-IOFC)
          CALL GSCR (IWID,I,P*REDF+Q*REDL,P*GRNF+Q*GRNL,P*BLUF+Q*BLUL)
  101   CONTINUE
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE DRWMCL (XCRA,YCRA,NCRA,IAAI,IAGI,NGPS)
C
        DIMENSION XCRA(*),YCRA(*),IAAI(*),IAGI(*)
C
C This routine draws the curve defined by the points (XCRA(I),YCRA(I)),
C for I = 1 to NCRA, if and only if none of the area identifiers for the
C area containing the polyline are negative.  It calls either CURVE or
C CURVED to do the drawing, depending on the value of the internal
C parameter 'DPU'.
C
C It keeps track of the maximum value used for NCRA in a common block.
C
        COMMON /COMONA/ MAXN
C
        MAXN=MAX(MAXN,NCRA)
C
C Retrieve the value of the internal parameter 'DPU'.
C
        CALL CTGETI ('DPU - DASH PACKAGE USED',IDUF)
C
C Turn on drawing.
C
        IDRW=1
C
C If any area identifier is negative, turn off drawing.
C
        DO 101 I=1,NGPS
          IF (IAAI(I).LT.0) IDRW=0
  101   CONTINUE
C
C If drawing is turned on, draw the polyline.
C
        IF (IDRW.NE.0) THEN
          IF (IDUF.EQ.0) THEN
            CALL CURVE  (XCRA,YCRA,NCRA)
          ELSE IF (IDUF.LT.0) THEN
            CALL DPCURV (XCRA,YCRA,NCRA)
          ELSE
            CALL CURVED (XCRA,YCRA,NCRA)
          END IF
        END IF
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE DCFOCB (XCRA,YCRA,NCRA,IAAI,IAGI,NGPS)
C
C This routine fills the area defined by the points (XCRA(I),YCRA(I)),
C for I = 1 to NCRA, if and only if none of the area identifiers for
C the area are negative.  The color used is determined from the area
C identifier of the area relative to group 3; it is assumed that 100
C colors are defined having color indices 151 through 250.
C
        DIMENSION XCRA(*),YCRA(*),IAAI(*),IAGI(*)
C
C It keeps track of the maximum value used for NCRA in a common block.
C
        COMMON /COMONA/ MAXN
C
        MAXN=MAX(MAXN,NCRA)
C
C Retrieve the number of contour levels being used.
C
        CALL CTGETI ('NCL - NUMBER OF CONTOUR LEVELS',NOCL)
C
C If the number of contour levels is non-zero and the area has more
C than two points, fill it.
C
        IF (NOCL.NE.0.AND.NCRA.GT.2) THEN
C
          IAI3=-1
C
          DO 101 I=1,NGPS
            IF (IAGI(I).EQ.3) IAI3=IAAI(I)
  101     CONTINUE
C
          IF (IAI3.GE.1.AND.IAI3.LE.NOCL+1) THEN
            CALL GSFACI (151+INT(((REAL(IAI3)-.5)/REAL(NOCL+1))*100.))
            CALL GFA    (NCRA,XCRA,YCRA)
          ELSE IF (IAI3.EQ.1001) THEN
            CALL GSFACI (2)
            CALL GFA    (NCRA,XCRA,YCRA)
          ELSE IF (IAI3.EQ.1002) THEN
            CALL GSFACI (3)
            CALL GFA    (NCRA,XCRA,YCRA)
          END IF
C
        END IF
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE GTWNG2 (RPNT,MPNT,NPNT,LOPN,
     +                   IEDG,MEDG,NEDG,LOEN,
     +                   ITRI,MTRI,NTRI,LOTN,
     +                   IPPP,IPPE,CLAT,CLON)
C
        DIMENSION RPNT(MPNT),IEDG(MEDG),ITRI(MTRI),IPPP(3,*),IPPE(2,*)
C
C Construct a triangular mesh using SEAM data from Houjun Wang,
C using a routine (CTTMTX) that makes it easy to create an arbitrary
C triangular mesh.  The "quicksorts" used by this method are very
C inefficient for objects that are partially ordered, so, as the
C triangles of the mesh are generated, they are stored in a triangle
C buffer from which they can be dumped in random order by calls to
C the routine CTTMTX.
C
C Declare the array to use as the buffer for the triangles, so that the
C order in which they are processed can be somewhat randomized.  Up to
C a point, making this buffer larger will result in more randomization
C of the triangles and speed up the process.  MBUF is the number of
C triangles that will fit in the buffer at once, and KBUF is the number
C of those that are dumped whenever the buffer is found to be full; it
C turns out that it's better to dump more than 1 at a time (I suppose
C because the call and loop set-up time for CTTMTX are non-trivial, so
C it's better to dump a few triangles while you're there).  So ... use
C MBUF > KBUF > 1.
C
        PARAMETER (MBUF=5021,KBUF=173,MBM1=MBUF-1)
C
        DIMENSION TBUF(12,MBUF)
C
C Declare arrays to receive Houjun's original data.  For I from 1 to
C NQDR, INUM(I) is an integer from 1 to 6, inclusive, saying which face
C of a cube a particular quadrilateral lies on; XCRD and YCRD hold the
C coordinates of the quadrilateral's corner points on that face.
C
        PARAMETER (MQDR=156)
C
        DIMENSION INUM(MQDR),XCRD(4,MQDR),YCRD(4,MQDR)
C
C Declare arrays in which to define the U, V, and W coordinates of the
C centers of the six faces of a cube and the U, V, and W components of
C unit vectors in two orthogonal directions on those faces.
C
        DIMENSION UCEN(6),VCEN(6),WCEN(6)
        DIMENSION UCOX(6),VCOX(6),WCOX(6)
        DIMENSION UCOY(6),VCOY(6),WCOY(6)
C
C Declare arrays in which to compute the U, V, and W coordinates of the
C four corner points of a quadrilateral.
C
        DIMENSION UCRD(4),VCRD(4),WCRD(4)
C
C Declare arrays to receive lat/lon coordinate data computed from
C Houjun's data file.
C
        COMMON /CMWNG2/ RLAT(4,MQDR),RLON(4,MQDR),NQDR
C
C Define the U, V and W coordinates of the centers of the six faces of
C a cube and the U, V, and W components of unit vectors in orthogonal
C directions on those faces.
C
        DATA UCEN(1),VCEN(1),WCEN(1) /  1., 0., 0. /
        DATA UCEN(2),VCEN(2),WCEN(2) /  0., 1., 0. /
        DATA UCEN(3),VCEN(3),WCEN(3) / -1., 0., 0. /
        DATA UCEN(4),VCEN(4),WCEN(4) /  0.,-1., 0. /
        DATA UCEN(5),VCEN(5),WCEN(5) /  0., 0., 1. /
        DATA UCEN(6),VCEN(6),WCEN(6) /  0., 0.,-1. /
C
        DATA UCOX(1),VCOX(1),WCOX(1) /  0., 1., 0. /
        DATA UCOX(2),VCOX(2),WCOX(2) / -1., 0., 0. /
        DATA UCOX(3),VCOX(3),WCOX(3) /  0.,-1., 0. /
        DATA UCOX(4),VCOX(4),WCOX(4) /  1., 0., 0. /
        DATA UCOX(5),VCOX(5),WCOX(5) /  0., 1., 0. /
        DATA UCOX(6),VCOX(6),WCOX(6) /  0., 1., 0. /
C
        DATA UCOY(1),VCOY(1),WCOY(1) /  0., 0., 1. /
        DATA UCOY(2),VCOY(2),WCOY(2) /  0., 0., 1. /
        DATA UCOY(3),VCOY(3),WCOY(3) /  0., 0., 1. /
        DATA UCOY(4),VCOY(4),WCOY(4) /  0., 0., 1. /
        DATA UCOY(5),VCOY(5),WCOY(5) / -1., 0., 0. /
        DATA UCOY(6),VCOY(6),WCOY(6) /  1., 0., 0. /
C
C Define the dimensions of the grid within each quadrilateral.
C
        DATA NOPX,NOPY / 3,3 /
C
C Define the value of an epsilon to be used by CTTMTX in testing
C coordinate values for equality.
C
        DATA EPST / 1.E-5 /
C
C Read the data.
C
        NQDR=0
C
        OPEN (11,FILE='ctwng2.dat',STATUS='OLD',FORM='FORMATTED')
C
  101   IF (NQDR.GT.MQDR) GO TO 102
C
        NQDR=NQDR+1
C
        READ (11,*,END=102) IDUM,INUM(NQDR)
C
        IF (IDUM.NE.NQDR) THEN
          PRINT * , 'GTWNG2 - STOP - DATA INCORRECT'
          STOP
        END IF
C
        READ (11,*) XCRD(1,NQDR),YCRD(1,NQDR)
        READ (11,*) XCRD(2,NQDR),YCRD(2,NQDR)
        READ (11,*) XCRD(3,NQDR),YCRD(3,NQDR)
        READ (11,*) XCRD(4,NQDR),YCRD(4,NQDR)
C
        GO TO 101
C
  102   CLOSE (11)
C
        NQDR=NQDR-1
C
C Build structures forming the triangular mesh.  First, initialize the
C variables used to keep track of items in the sort arrays for points
C and edges, in the triangle buffer, and in the triangle list.
C
        MPPP=MPNT/LOPN
        NPPP=0
C
        MPPE=MEDG/LOEN
        NPPE=0
C
        NBUF=0
C
        NTRI=0
C
C Loop through the quadrilaterals of Houjun's SEAM grid.
C
        DO 106 J=1,NQDR
C
C Compute the latitudes and longitudes of the four corner points of
C the quadrilateral and perturb the coordinates a little.
C
          DO 103 I=1,4
            UCRD(I)=UCEN(INUM(J))+XCRD(I,J)*UCOX(INUM(J))+
     +                            YCRD(I,J)*UCOY(INUM(J))+PRTURB(1.E-6)
            VCRD(I)=VCEN(INUM(J))+XCRD(I,J)*VCOX(INUM(J))+
     +                            YCRD(I,J)*VCOY(INUM(J))+PRTURB(1.E-6)
            WCRD(I)=WCEN(INUM(J))+XCRD(I,J)*WCOX(INUM(J))+
     +                            YCRD(I,J)*WCOY(INUM(J))+PRTURB(1.E-6)
            DTMP=SQRT(UCRD(I)**2+VCRD(I)**2+WCRD(I)**2)
            UCRD(I)=UCRD(I)/DTMP
            VCRD(I)=VCRD(I)/DTMP
            WCRD(I)=WCRD(I)/DTMP
            CALL XYZLLP (UCRD(I),VCRD(I),WCRD(I),RLAT(I,J),RLON(I,J))
  103     CONTINUE
C
C Loop to split each quadrilateral into NOPX x NOPY pieces.
C
          DO 105 INDX=1,NOPX
C
            P1=REAL(INDX-1)/REAL(NOPX)
            R1=REAL(NOPX-INDX+1)/REAL(NOPX)
            P2=REAL(INDX)/REAL(NOPX)
            R2=REAL(NOPX-INDX)/REAL(NOPX)
C
            DO 104 INDY=1,NOPY
C
              Q1=REAL(INDY-1)/REAL(NOPY)
              S1=REAL(NOPY-INDY+1)/REAL(NOPY)
              Q2=REAL(INDY)/REAL(NOPY)
              S2=REAL(NOPY-INDY)/REAL(NOPY)
C
C Compute the coordinates of the corners of this piece.
C
              UCP1=R1*S1*UCRD(1)+P1*S1*UCRD(2)+
     +             P1*Q1*UCRD(3)+R1*Q1*UCRD(4)
              VCP1=R1*S1*VCRD(1)+P1*S1*VCRD(2)+
     +             P1*Q1*VCRD(3)+R1*Q1*VCRD(4)
              WCP1=R1*S1*WCRD(1)+P1*S1*WCRD(2)+
     +             P1*Q1*WCRD(3)+R1*Q1*WCRD(4)
C
              UCP2=R2*S1*UCRD(1)+P2*S1*UCRD(2)+
     +             P2*Q1*UCRD(3)+R2*Q1*UCRD(4)
              VCP2=R2*S1*VCRD(1)+P2*S1*VCRD(2)+
     +             P2*Q1*VCRD(3)+R2*Q1*VCRD(4)
              WCP2=R2*S1*WCRD(1)+P2*S1*WCRD(2)+
     +             P2*Q1*WCRD(3)+R2*Q1*WCRD(4)
C
              UCP3=R2*S2*UCRD(1)+P2*S2*UCRD(2)+
     +             P2*Q2*UCRD(3)+R2*Q2*UCRD(4)
              VCP3=R2*S2*VCRD(1)+P2*S2*VCRD(2)+
     +             P2*Q2*VCRD(3)+R2*Q2*VCRD(4)
              WCP3=R2*S2*WCRD(1)+P2*S2*WCRD(2)+
     +             P2*Q2*WCRD(3)+R2*Q2*WCRD(4)
C
              UCP4=R1*S2*UCRD(1)+P1*S2*UCRD(2)+
     +             P1*Q2*UCRD(3)+R1*Q2*UCRD(4)
              VCP4=R1*S2*VCRD(1)+P1*S2*VCRD(2)+
     +             P1*Q2*VCRD(3)+R1*Q2*VCRD(4)
              WCP4=R1*S2*WCRD(1)+P1*S2*WCRD(2)+
     +             P1*Q2*WCRD(3)+R1*Q2*WCRD(4)
C
C Project the coordinates out onto the surface of the globe.
C
              DTMP=SQRT(UCP1**2+VCP1**2+WCP1**2)
C
              UCP1=UCP1/DTMP
              VCP1=VCP1/DTMP
              WCP1=WCP1/DTMP
C
              DTMP=SQRT(UCP2**2+VCP2**2+WCP2**2)
C
              UCP2=UCP2/DTMP
              VCP2=VCP2/DTMP
              WCP2=WCP2/DTMP
C
              DTMP=SQRT(UCP3**2+VCP3**2+WCP3**2)
C
              UCP3=UCP3/DTMP
              VCP3=VCP3/DTMP
              WCP3=WCP3/DTMP
C
              DTMP=SQRT(UCP4**2+VCP4**2+WCP4**2)
C
              UCP4=UCP4/DTMP
              VCP4=VCP4/DTMP
              WCP4=WCP4/DTMP
C
C If the triangle buffer is almost full, dump a few randomly-chosen
C triangles from it to make room for two new ones.
C
              IF (NBUF.GE.MBM1) THEN
                CALL CTTMTX (KBUF,TBUF,MBUF,NBUF,
     +                       EPST,
     +                       IPPP,MPPP,NPPP,
     +                       IPPE,MPPE,NPPE,
     +                       RPNT,MPNT,NPNT,LOPN,
     +                       IEDG,MEDG,NEDG,LOEN,
     +                       ITRI,MTRI,NTRI,LOTN)
              END IF
C
C Put two new triangles in the triangle buffer.
C
              NBUF=NBUF+1
C
              TBUF( 1,NBUF)=UCP1
              TBUF( 2,NBUF)=VCP1
              TBUF( 3,NBUF)=WCP1
              TBUF( 4,NBUF)=0.
C
              TBUF( 5,NBUF)=UCP2
              TBUF( 6,NBUF)=VCP2
              TBUF( 7,NBUF)=WCP2
              TBUF( 8,NBUF)=0.
C
              TBUF( 9,NBUF)=UCP3
              TBUF(10,NBUF)=VCP3
              TBUF(11,NBUF)=WCP3
              TBUF(12,NBUF)=0.
C
              NBUF=NBUF+1
C
              TBUF( 1,NBUF)=UCP3
              TBUF( 2,NBUF)=VCP3
              TBUF( 3,NBUF)=WCP3
              TBUF( 4,NBUF)=0.
C
              TBUF( 5,NBUF)=UCP4
              TBUF( 6,NBUF)=VCP4
              TBUF( 7,NBUF)=WCP4
              TBUF( 8,NBUF)=0.
C
              TBUF( 9,NBUF)=UCP1
              TBUF(10,NBUF)=VCP1
              TBUF(11,NBUF)=WCP1
              TBUF(12,NBUF)=0.
C
  104       CONTINUE
C
  105     CONTINUE
C
  106   CONTINUE
C
C Output all triangles remaining in the buffer.
C
        IF (NBUF.NE.0) THEN
          CALL CTTMTX (NBUF,TBUF,MBUF,NBUF,
     +                 EPST,
     +                 IPPP,MPPP,NPPP,
     +                 IPPE,MPPE,NPPE,
     +                 RPNT,MPNT,NPNT,LOPN,
     +                 IEDG,MEDG,NEDG,LOEN,
     +                 ITRI,MTRI,NTRI,LOTN)
        END IF
C
C Initialize the dummy-data generator and get data values for all the
C points of the mesh.
C
        CALL TDGDIN (-1.,1.,-1.,1.,-1.,1.,21,21)
C
        DO 107 I=0,NPNT-LOPN,LOPN
          RPNT(I+4)=TDGDVA(RPNT(I+1),RPNT(I+2),RPNT(I+3))
  107   CONTINUE
C
C Return the latitude and longitude of the approximate center point of
C the mesh on the globe.
C
        CLAT=0.
        CLON=-90.
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE DSWNG2
C
C Draw the quadrilaterals of Houjun's grid, using data passed in a
C common block.
C
        PARAMETER (MQDR=156)
        COMMON /CMWNG2/ RLAT(4,MQDR),RLON(4,MQDR),NQDR
C
C Declare a character temporary in which to form labels.
C
        CHARACTER*3 CTMP
C
C Draw the grid.
C
        CALL PLOTIT (0,0,2)
        CALL GSPLCI (8)
        CALL GSLWSC (2.)
C
        DO 101 J=1,NQDR
          CALL DRSGCR (RLAT(1,J),RLON(1,J),RLAT(2,J),RLON(2,J))
          CALL DRSGCR (RLAT(2,J),RLON(2,J),RLAT(3,J),RLON(3,J))
          CALL DRSGCR (RLAT(3,J),RLON(3,J),RLAT(4,J),RLON(4,J))
          CALL DRSGCR (RLAT(4,J),RLON(4,J),RLAT(1,J),RLON(1,J))
  101   CONTINUE
C
C Label each quadrilateral with its index (from 1 to NQDR, inclusive).
C
        DO 102 J=1,NQDR
          CALL IPIQOS (RLAT(1,J),RLON(1,J),RLAT(2,J),RLON(2,J),
     +                 RLAT(4,J),RLON(4,J),RLAT(3,J),RLON(3,J),
     +                                         .5,.5,ELAT,ELON)
          CALL MAPTRN (ELAT,ELON,XTMP,YTMP)
          IF (XTMP.NE.1.E12) THEN
            WRITE (CTMP,'(I3)') J
            IBEG=1
            IF (CTMP(1:1).EQ.' ') IBEG=2
            IF (CTMP(2:2).EQ.' ') IBEG=3
            CALL PCSETI ('CC',1)
            CALL PLCHHQ (XTMP,YTMP,CTMP(IBEG:3),.012,0.,0.)
            CALL PCSETI ('CC',-1)
          END IF
  102   CONTINUE
C
C Draw the continental outlines and lat/lon grid.
C
        CALL PLOTIT (0,0,2)
        CALL GSLWSC (1.)
        CALL GSPLCI (13)
        CALL MAPGRD
        CALL PLOTIT (0,0,2)
        CALL GSPLCI (14)
        CALL MAPLOT
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE DRSGCR (ALAT,ALON,BLAT,BLON)
C
C (DRSGCR = DRaw Shortest Great Circle Route)
C
C This routine draws the shortest great circle route joining two points
C on the globe.  Note that MPTS = INT(180./SIZE) + 1.
C
        PARAMETER (MPTS=181,SIZE=1.)
C
        DIMENSION QLAT(MPTS),QLON(MPTS)
C
        NPTS=MAX(1,MIN(MPTS,INT(ADSGCR(ALAT,ALON,BLAT,BLON)/SIZE)))
C
        CALL MAPGCI (ALAT,ALON,BLAT,BLON,NPTS,QLAT,QLON)
C
        CALL MAPIT (ALAT,ALON,0)
C
        DO 101 I=1,NPTS
          CALL MAPIT (QLAT(I),QLON(I),1)
  101   CONTINUE
C
        CALL MAPIT (BLAT,BLON,2)
C
        CALL MAPIQ
C
        RETURN
C
      END


      FUNCTION ADSGCR (ALAT,ALON,BLAT,BLON)
C
C (ADSGCR = Angle in Degrees along Shortest Great Circle Route)
C
C This function returns the shortest great circle distance, in degrees,
C between two points, A and B, on the surface of the globe.
C
        DATA DTOR / .017453292519943 /
        DATA RTOD / 57.2957795130823 /
C
        XCOA=COS(DTOR*ALAT)*COS(DTOR*ALON)
        YCOA=COS(DTOR*ALAT)*SIN(DTOR*ALON)
        ZCOA=SIN(DTOR*ALAT)
C
        XCOB=COS(DTOR*BLAT)*COS(DTOR*BLON)
        YCOB=COS(DTOR*BLAT)*SIN(DTOR*BLON)
        ZCOB=SIN(DTOR*BLAT)
C
        ADSGCR=2.*RTOD*ASIN(SQRT((XCOA-XCOB)**2+
     +                           (YCOA-YCOB)**2+
     +                           (ZCOA-ZCOB)**2)/2.)
C
        RETURN
C
      END


      SUBROUTINE IPIQOS (ALAT,ALON,BLAT,BLON,CLAT,CLON,DLAT,DLON,
     +                                       XFRA,YFRA,ELAT,ELON)
C
C (IPIQOS = Interpolate Point In Quadrilateral on Sphere)
C
C This routine, given the latitudes and longitudes of four points (A, B,
C C, and D) forming a "quadrilateral" on the globe and two interpolation
C fractions (XFRA and YFRA, each between 0 and 1, inclusive), finds the
C point E defined by the following diagram and returns its latitude and
C longitude.
C
C                              C------Q----D
C                              |      |    |
C                              |      E    |
C                              |      |    |
C                              |      |    |
C                              A------P----B
C
C P and Q are positioned such that AP/AB = CQ/CD = XFRA and then E is
C positioned such that PE/PQ = YFRA (where "XY" is interpreted to mean
C "the shortest great circle distance from X to Y").
C
C It is assumed that the "quadrilateral" ABDC is "convex" (a working
C definition of which might be that none of the four great circles
C defined by its edges - the ones through A and B, B and D, D and C,
C and C and A - cross it anywhere.  However, this is not verified.
C
C The code is easy:
C
        CALL FPSGCR (ALAT,ALON,BLAT,BLON,XFRA,PLAT,PLON)
        CALL FPSGCR (CLAT,CLON,DLAT,DLON,XFRA,QLAT,QLON)
        CALL FPSGCR (PLAT,PLON,QLAT,QLON,YFRA,ELAT,ELON)
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE FPSGCR (ALAT,ALON,BLAT,BLON,FRCT,FLAT,FLON)
C
C (FPSGCR = Find Point on Shortest Great Circle Route)
C
        REAL    ALAT,ALON,BLAT,BLON,FRCT,FLAT,FLON
C
C This routine, given the latitudes and longitudes of two points A and
C B on the surface of the globe and a fraction FRCT, between 0. and 1.,
C interpolates a point F along the shortest great circle route joining
C A to B such that the distance from A to F, divided by the distance
C from A to B, is equal to FRCT, and returns its latitude and longitude
C in FLAT and FLON.
C
C Define the constants used to convert from degrees to radians and
C vice-versa.
C
        DATA DTOR / .017453292519943 /
        DATA RTOD / 57.2957795130823 /
C
C Compute the X, Y, and Z coordinates (on a unit sphere) of the point B.
C
        CALL LLPXYZ (BLAT,BLON,XCPB,YCPB,ZCPB)
C
C Rotating about the Z axis by the angle -ALON would carry A into the XZ
C plane.
C
        CALL ROTXYZ (3,-ALON,XCPB,YCPB,ZCPB)
C
C Then, rotating about the Y axis by the angle ALAT would carry A into
C the point on the X axis with coordinates (1,0,0).
C
        CALL ROTXYZ (2,ALAT,XCPB,YCPB,ZCPB)
C
C Then, rotating about the X axis by the angle ALPH = -ATAN(ZCPB/YCPB)
C would leave the position of A unchanged but carry B into a point in
C the XY plane.
C
        IF (ZCPB.NE.0..OR.YCPB.NE.0.) THEN
          ALPH=-RTOD*ATAN2(ZCPB,YCPB)
        ELSE
          ALPH=0.
        END IF
C
        CALL ROTXYZ (1,ALPH,XCPB,YCPB,ZCPB)
C
C The angle BETA from A to B can now be computed easily.
C
        IF (XCPB.NE.0..OR.YCPB.NE.0.) THEN
          BETA=ATAN2(YCPB,XCPB)
        ELSE
          BETA=0.
        END IF
C
C Interpolate a point at the desired position between the points A and
C B, map it back to its original position on the great circle route from
C A to B, and get its latitude and longitude to return to the caller.
C
        GAMA=FRCT*BETA
C
        XCPF=COS(GAMA)
        YCPF=SIN(GAMA)
        ZCPF=0.
C
        CALL ROTXYZ (1,-ALPH,XCPF,YCPF,ZCPF)
        CALL ROTXYZ (2,-ALAT,XCPF,YCPF,ZCPF)
        CALL ROTXYZ (3, ALON,XCPF,YCPF,ZCPF)
C
        CALL XYZLLP (XCPF,YCPF,ZCPF,FLAT,FLON)
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE LLPXYZ (RLAT,RLON,RVOX,RVOY,RVOZ)
C
C (LLPXYZ = Lat/Lon Position to XYZ coordinates)
C
C Given the latitude and longitude of a point on the globe, return its
C X, Y, and Z coordinates.
C
        DATA DTOR / .017453292519943 /
C
        RVOX=COS(DTOR*RLAT)*COS(DTOR*RLON)
        RVOY=COS(DTOR*RLAT)*SIN(DTOR*RLON)
        RVOZ=SIN(DTOR*RLAT)
C
        RETURN
C
      END


      SUBROUTINE XYZLLP (RVOX,RVOY,RVOZ,RLAT,RLON)
C
C (XYZLLP = XYZ coordinates to Lat/Lon Position)
C
C Given the X, Y, and Z coordinates of a point on the globe, return its
C latitude and longitude.
C
        DATA RTOD / 57.2957795130823 /
C
        RLAT=RTOD*ASIN(RVOZ)
C
        IF (RVOX.NE.0.OR.RVOY.NE.0.) THEN
          RLON=RTOD*ATAN2(RVOY,RVOX)
        ELSE
          RLON=0.
        END IF
C
        RETURN
C
      END


      SUBROUTINE ROTXYZ (IAXS,ANGL,XCRD,YCRD,ZCRD)
C
C (ROTXYZ = ROTate a point defined by its X, Y, and Z coordinates)
C
C This is a modified version of a routine in the NCAR Graphics package,
C which is used in some of the examples.  It rotates the point having
C coordinates (XCRD,YCRD,ZCRD) by an angle ANGL about the axis specified
C by IAXS (1 for the X axis, 2 for the Y axis, 3 for the Z axis).
C
C One assumes a right-handed system with X, Y, and Z axes.  Rotating by
C an angle "a" about the X axis maps the point (x,y,z) into the point
C (x',y',z'), where
C
C       x' = x
C       y' = y cos(a) - z sin(a)
C       z' = z cos(a) + y sin(a)
C
C A positive value of "a" represents rotation in the direction from the
C Y axis to the Z axis.
C
C Similarly, rotating by an angle "a" about the Y axis maps the point
C (x,y,z) into the point (x',y',z'), where
C
C       x' = x cos(a) + z sin(a)
C       y' = y
C       z' = z cos(a) - x sin(a)
C
C A positive value of "a" represents rotation in the direction from the
C Z axis to the X axis.
C
C Rotating by an angle "a" about the Z axis maps the point (x,y,z) into
C the point (x',y',z'), where
C
C       x' = x cos(a) - y sin(a)
C       y' = y cos(a) + x sin(a)
C       y' = y
C
C A positive value of "a" represents rotation in the direction from the
C X axis to the Y axis.
C
C Define a multiplicative constant to convert from degrees to radians.
C
        DATA DTOR / .017453292519943 /
C
C Trigonometry.
C
        SINA=SIN(DTOR*ANGL)
        COSA=COS(DTOR*ANGL)
C
        XTMP=XCRD
        YTMP=YCRD
        ZTMP=ZCRD
C
        IF (IAXS.EQ.1) THEN
          YCRD=YTMP*COSA-ZTMP*SINA
          ZCRD=ZTMP*COSA+YTMP*SINA
        ELSE IF (IAXS.EQ.2) THEN
          XCRD=XTMP*COSA+ZTMP*SINA
          ZCRD=ZTMP*COSA-XTMP*SINA
        ELSE
          XCRD=XTMP*COSA-YTMP*SINA
          YCRD=YTMP*COSA+XTMP*SINA
        END IF
C
        RETURN
C
      END


      SUBROUTINE TDGDIN (XMIN,XMAX,YMIN,YMAX,ZMIN,ZMAX,MLOW,MHGH)
C
C This is a routine to generate test data for three-dimensional graphics
C routines.  The function used is a sum of exponentials.
C
C "MLOW" and "MHGH" are each forced to be greater than or equal to 1 and
C less than or equal to 25.
C
        COMMON /TDGDCO/ XRNG,YRNG,ZRNG,NCNT,CCNT(4,50)
        SAVE   /TDGDCO/
C
        XRNG=XMAX-XMIN
        YRNG=YMAX-YMIN
        ZRNG=ZMAX-ZMIN
C
        NLOW=MAX(1,MIN(25,MLOW))
        NHGH=MAX(1,MIN(25,MHGH))
        NCNT=NLOW+NHGH
C
        DO 101 ICNT=1,NCNT
          CCNT(1,ICNT)=XMIN+XRNG*FRAN()
          CCNT(2,ICNT)=YMIN+YRNG*FRAN()
          CCNT(3,ICNT)=ZMIN+ZRNG*FRAN()
          IF (ICNT.LE.NLOW) THEN
            CCNT(4,ICNT)=-1.
          ELSE
            CCNT(4,ICNT)=+1.
          END IF
  101   CONTINUE
C
        RETURN
C
      END


      FUNCTION TDGDVA (XPOS,YPOS,ZPOS)
C
        COMMON /TDGDCO/ XRNG,YRNG,ZRNG,NCNT,CCNT(4,50)
        SAVE   /TDGDCO/
C
        TDGDVA=0.
C
        DO 101 ICNT=1,NCNT
          TEMP=-50.*(((XPOS-CCNT(1,ICNT))/XRNG)**2+
     +               ((YPOS-CCNT(2,ICNT))/YRNG)**2+
     +               ((ZPOS-CCNT(3,ICNT))/YRNG)**2)
          IF (TEMP.GE.-20.) TDGDVA=TDGDVA+CCNT(4,ICNT)*EXP(TEMP)
  101   CONTINUE
C
C Done.
C
        RETURN
C
      END


      FUNCTION FRAN ()
C
C Pseudo-random-number generator.
C
        DOUBLE PRECISION X
        SAVE X
C
        DATA X / 2.718281828459045D0 /
C
        X=MOD(9821.D0*X+.211327D0,1.D0)
        FRAN=REAL(X)
C
        RETURN
C
      END


      FUNCTION PRTURB (RMAG)
C
C Random perturbation on the order of + or - RMAG.
C
        DOUBLE PRECISION X
        SAVE X
C
        DATA X / 2.718281828459045D0 /
C
        X=MOD(9821.D0*X+.211327D0,1.D0)
        PRTURB=2.*RMAG*(REAL(X)-.5)
C
        RETURN
C
      END


      SUBROUTINE CTSCAE (ICRA,ICA1,ICAM,ICAN,XCPF,YCPF,XCQF,YCQF,
     +                                       IND1,IND2,ICAF,IAID)
        DIMENSION ICRA(ICA1,*)
C
C This routine is called by CTCICA when the internal parameter 'CAF' is
C given a negative value.  Each call is intended to create a particular
C element in the user's cell array.  The arguments are as follows:
C
C ICRA is the user's cell array.
C
C ICA1 is the first dimension of the FORTRAN array ICRA.
C
C ICAM and ICAN are the first and second dimensions of the cell array
C stored in ICRA.
C
C (XCPF,YCPF) is the point at that corner of the rectangular area
C into which the cell array maps that corresponds to the cell (1,1).
C The coordinates are given in the fractional coordinate system (unlike
C what is required in a call to GCA, in which the coordinates of the
C point P are in the world coordinate system).
C
C (XCQF,YCQF) is the point at that corner of the rectangular area into
C which the cell array maps that corresponds to the cell (ICAM,ICAN).
C The coordinates are given in the fractional coordinate system (unlike
C what is required in a call to GCA, in which the coordinates of the
C point Q are in the world coordinate system).
C
C IND1 is the 1st index of the cell that is to be updated.
C
C IND2 is the 2nd index of the cell that is to be updated.
C
C ICAF is the current value of the internal parameter 'CAF'.  This
C value will always be an integer which is less than zero (because
C when 'CAF' is zero or greater, this routine is not called).
C
C IAID is the area identifier associated with the cell.  It will have
C been given one of the values from the internal parameter array 'AIA'
C (the one for 'PAI' = -2 if the cell lies in an out-of-range area, the
C one for 'PAI' = -1 if the cell lies off the data grid, or the one for
C some value of 'PAI' between 1 and 'NCL' if the cell lies on the data
C grid).  The value zero may occur if the cell falls in an out-of-range
C area and the value of 'AIA' for 'PAI' = -2 is 0 or if the cell lies
C off the data grid and the value of 'AIA' for 'PAI' = -1 is 0, or if
C the cell falls on the data grid, but no contour level below the cell
C has a non-zero 'AIA' and no contour level above the cell has a
C non-zero 'AIB'.  Note that, if the values of 'AIA' for 'PAI' = -1
C and -2 are given non-zero values, IAID can only be given a zero
C value in one way.
C
C The default behavior of CTSCAE is as follows:  If the area identifier
C is non-negative, it is treated as a color index, to be stored in the
C appropriate cell in the cell array; but if the area identifier is
C negative, a zero is stored for the color index.  The user may supply
C a version of CTSCAE that does something different; it may simply map
C the area identifiers into color indices or it may somehow modify the
C existing cell array element to incorporate the information provided
C by the area identifier.
C
C       ICRA(IND1,IND2)=MAX(0,IAID)
C
C What follows is not the default behavior; instead, it is the behavior
C expected by many of the example programs for CONPACKT.
C
        CALL CTGETI ('NCL - NUMBER OF CONTOUR LEVELS',NOCL)
C
        IF (IAID.GE.1.AND.IAID.LE.NOCL+1) THEN
          ICRA(IND1,IND2)=151+INT(((REAL(IAID)-.5)/REAL(NOCL+1))*100.)
        ELSE IF (IAID.EQ.1001) THEN
          ICRA(IND1,IND2)=2
        ELSE IF (IAID.EQ.1002) THEN
          ICRA(IND1,IND2)=3
        END IF
C
        RETURN
C
      END

C
C $Id: bcgetr.f,v 1.4 2008-07-27 00:17:29 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE BCGETR(PA,RVAL)
C
C Retrieve real-valued parameters for the Bezier curve package.
C
C Arguments
C     Input
C             PA       Character string indicating the parameter.
C
C     Output
C             RVAL     A floating-point number representing the
C                      current setting for the specified parameter.
C

      CHARACTER*(*) PA
      CHARACTER*3   CTMP
C
      include 'bccom.h'
C
      CTMP = PA(1:3)
C
      IF (CTMP.EQ.'FLT' .OR. CTMP.EQ.'flt') THEN
C
C  Get the flatness tolerance limit.
C
        RVAL = FRATIO
      ELSE
        WRITE(I1MACH(4),500) CTMP
      ENDIF
C
      RETURN
C
  500 FORMAT(' BCGETR -- Invalid keyword = ',A3,', no action taken')
C
      END

      PROGRAM CMPITA
C
C Declare fill routine external so compiler will know that it's a
C subroutine instead of a real variable.
C
      EXTERNAL FILL
C
C IGRD specifies the number of degrees between each grid line and the
C next.  IMAP specifies the size of the area-map array.  If you make
C IGRD smaller than shown here, use a value which evenly divides both
C 180 and 360 and remember to put the same value in the PARAMETER
C statement in the routine FILL, below; in this case,  a larger value
C of IMAP will be required and the program will run a lot longer.  For
C IGRD=10, try IMAP=160000; for IGRD=5, try IMAP=220000; for IGRD=3,
C try IMAP=390000; for IGRD=2, try IMAP=520000; for IGRD=1, IMAP=1500000
C was not enough (and the program may have been stuck in a loop).
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C NWRK specifies the sizes of the work arrays XWRK and YWRK, which are
C passed to ARSCAM.
C
      PARAMETER(IGRD=15,IMAP=150000,NWRK=15000)
      PARAMETER(M=180/IGRD,N=360/IGRD)
C
C The global data array ZDAT is put in a common block so that it can be
C accessed from the subroutine FILL.
C
      COMMON /DAT1/ ZDAT(M,N)
C
C Declare the area-map array and the various other arrays required.
C
      INTEGER MAP(IMAP),IGRP(5),IAREA(5)
      REAL XWRK(NWRK),YWRK(NWRK),ZDAT
      REAL PLIM1(2),PLIM2(2),PLIM3(2),PLIM4(2)
C
C Define the contents of the map limits arrays.
C
      DATA PLIM1 /0.,0./
      DATA PLIM2 /0.,0./
      DATA PLIM3 /0.,0./
      DATA PLIM4 /0.,0./
C
C If appropriate, print a warning about how time consuming this
C example can be.
C
      ITMP=IGRD
C
      IF (ITMP.LT.15) THEN
         WRITE (6,*) ' WARNING: This example may take 20 minutes'
         WRITE (6,*) '          to execute on some machines.'
      END IF
C
C Generate some data to base color fill on.  Note that these data are
C unrealistic in that no attempt has been made to achieve continuity
C at the longitudes -180 and +180 or at the poles.
C
      CALL GENDAT(ZDAT,M,M,N,25,25,1.,15.)
C
C Open GKS.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Define the color table.
C
      CALL COLOR(IWKID)
C
C Set the projection-type parameters.
C
      CALL MAPROJ ('CE',0.,0.,0.)
C
C Set the Ezmap "limits" parameters.
C
      CALL MAPSET ('MA',PLIM1,PLIM2,PLIM3,PLIM4)
C
C Change the Ezmap parameter 'MV' to prevent points from being dropped
C when the final outline is drawn.
C
      CALL MPSETI ('MV',1)
C
C Initalize Areas and Ezmap.
C
      CALL ARINAM (MAP,IMAP)
      CALL MAPINT
C
C Add geographic outlines to area map, using only continental outlines.
C
      CALL MAPSTC ('OU - OUTLINE DATASET SELECTOR','CO')
      CALL MAPBLA (MAP)
C
C Add latitude lines to the area map.
C
      DO 102 I=-90,90,IGRD
         DO 101 J=-180,180-IGRD,IGRD
            IDLFT = (I     +91) * 1000 + (J+181)
            IDRGT = (I-IGRD+91) * 1000 + (J+181)
            IF (I.EQ.-90) IDRGT=0
            IF (I.EQ. 90) IDLFT=0
            CALL MAPITA(REAL(I),REAL(J)     ,0,MAP,5,IDLFT,IDRGT)
            CALL MAPITA(REAL(I),REAL(J+IGRD),1,MAP,5,IDLFT,IDRGT)
            CALL MAPIQA(MAP,5,IDLFT,IDRGT)
 101     CONTINUE
 102  CONTINUE

C
C Add longitude lines to the area map.
C
      DO 104 J=-180,180,IGRD
         DO 103 I=-90,90-IGRD,IGRD
            IDLFT = (I+91) * 1000 + (J-IGRD+181)
            IDRGT = (I+91) * 1000 + (J     +181)
            IF (J.EQ.-180) IDLFT=0
            IF (J.EQ. 180) IDRGT=0
            CALL MAPITA(REAL(I),     REAL(J),0,MAP,5,IDLFT,IDRGT)
            CALL MAPITA(REAL(I+IGRD),REAL(J),1,MAP,5,IDLFT,IDRGT)
            CALL MAPIQA(MAP,5,IDLFT,IDRGT)
 103     CONTINUE
 104  CONTINUE
C
C Fill in areas over land with colors.
C
      CALL GSFAIS(1)
      CALL ARSCAM(MAP,XWRK,YWRK,NWRK,IAREA,IGRP,5,FILL)
C
C Draw the perimeter.
C
      CALL MAPSTI('LA - LABEL FLAG',0)
      CALL MAPLBL
C
C Draw a map over the output from Areas, using political outlines.
C
      CALL MAPSTC ('OU - OUTLINE DATASET SELECTOR','PO')
      CALL MAPLOT
C
C Report how much space was used in the area map.
C
      ITMP=MAP(1)-MAP(6)+MAP(5)+1
      WRITE (6,*) 'Area Map Workspace Used: ',ITMP
C
C Put the label at the top of the plot.
C
      CALL GETSET (VPL,VPR,VPB,VPT,WDL,WDR,WDB,WDT,LOG)
      CALL GSLWSC(2.)
      CALL PLCHHQ (CFUX(.5),CFUY(VPT+.02),
     +     'Filling Gridded Data over Landmasses',.017,0.,0.)
C
C Advance the frame.
C
      CALL FRAME
C
C Close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
C Done.
C
      STOP
C
      END

      SUBROUTINE FILL(XWRK,YWRK,NWRK,IAREA,IGRP,NSIZE)
C
      PARAMETER(IGRD=15,M=180/IGRD,N=360/IGRD)
C
C Bring in the data array to define colors.
C
      COMMON /DAT1/ ZDAT(M,N)
C
      REAL XWRK(NWRK),YWRK(NWRK),ZDAT
      INTEGER IAREA(NSIZE),IGRP(NSIZE)
C
C Group 5 is the group containing grid lines and group 1 contains
C continental outlines.
C
      IAREA1=-1
      IAREA5=-1
C
C If there are less than 3 points defining the area, return to ARSCAM.
C
      IF (NWRK.LE.3) RETURN
C
C Check each of the group and area identifiers for the current area.
C
      DO 101 I=1,NSIZE
         IF (IGRP(I).EQ.1) IAREA1=IAREA(I)
         IF (IGRP(I).EQ.5) IAREA5=IAREA(I)
 101  CONTINUE
C
C If the area identifier is over the globe ...
C
      IF (IAREA1.GT.0) THEN
C
C If the color id for the area is 1, then the area is over ocean, so
C we don't fill it; otherwise ...
C
         IF (MAPACI(IAREA1).NE.1.AND.IAREA5.GT.0) THEN
C
C At this point you need to invert your area identifier function to 
C retrieve your latitude and longitude values (or your data array
C indices) so that you can color fill based on them.
C
            LAT = IAREA5/1000
            I = LAT/IGRD + 1
C
            LON = MOD(IAREA5,1000)
            J = LON/IGRD + 1
C
C Our data is predefined to have values between 1 and 15 (chosen
C because we have 15 colors defined in subroutine COLOR).  Color
C index 1 is white, so we set the color index to start at 2.
C
            ICLR = INT(ZDAT(I,J))+1
            CALL GSFACI(ICLR)
            CALL GFA(NWRK-1,XWRK,YWRK)
C
         ENDIF
C
      ENDIF
C
      RETURN
C
      END

      SUBROUTINE GENDAT (DATA,IDIM,M,N,MLOW,MHGH,DLOW,DHGH)
C
C This is a routine to generate test data for two-dimensional graphics
C routines.  Given an array "DATA", dimensioned "IDIM x 1", it fills
C the sub-array ((DATA(I,J),I=1,M),J=1,N) with a two-dimensional field
C of data having approximately "MLOW" lows and "MHGH" highs, a minimum
C value of exactly "DLOW" and a maximum value of exactly "DHGH".
C
C "MLOW" and "MHGH" are each forced to be greater than or equal to 1
C and less than or equal to 25.
C
C The function used is a sum of exponentials.
C
      DIMENSION DATA(IDIM,1),CCNT(3,50)
C
      FOVM=9./REAL(M)
      FOVN=9./REAL(N)
C
      NLOW=MAX(1,MIN(25,MLOW))
      NHGH=MAX(1,MIN(25,MHGH))
      NCNT=NLOW+NHGH
C
      DO 101 K=1,NCNT
         CCNT(1,K)=1.+(REAL(M)-1.)*FRAN()
         CCNT(2,K)=1.+(REAL(N)-1.)*FRAN()
         IF (K.LE.NLOW) THEN
            CCNT(3,K)=-1.
         ELSE
            CCNT(3,K)=+1.
         END IF
 101  CONTINUE
C
      DMIN=+1.E36
      DMAX=-1.E36
      DO 104 J=1,N
         DO 103 I=1,M
            DATA(I,J)=.5*(DLOW+DHGH)
            DO 102 K=1,NCNT
               TEMP=-((FOVM*(REAL(I)-CCNT(1,K)))**2+
     +              (FOVN*(REAL(J)-CCNT(2,K)))**2)
               IF (TEMP.GE.-20.) DATA(I,J)=DATA(I,J)+
     +              .5*(DHGH-DLOW)*CCNT(3,K)*EXP(TEMP)
 102        CONTINUE
            DMIN=MIN(DMIN,DATA(I,J))
            DMAX=MAX(DMAX,DATA(I,J))
 103     CONTINUE
 104  CONTINUE
C
      DO 106 J=1,N
         DO 105 I=1,M
            DATA(I,J)=(DATA(I,J)-DMIN)/(DMAX-DMIN)*(DHGH-DLOW)+DLOW
 105     CONTINUE
 106  CONTINUE
C
      RETURN
C
      END

      FUNCTION FRAN ()
      DIMENSION RSEQ (100)
      SAVE ISEQ
      DATA RSEQ / .749,.973,.666,.804,.081,.483,.919,.903,.951,.960 ,
     +     .039,.269,.270,.756,.222,.478,.621,.063,.550,.798 ,
     +     .027,.569,.149,.697,.451,.738,.508,.041,.266,.249 ,
     +     .019,.191,.266,.625,.492,.940,.508,.406,.972,.311 ,
     +     .757,.378,.299,.536,.619,.844,.342,.295,.447,.499 ,
     +     .688,.193,.225,.520,.954,.749,.997,.693,.217,.273 ,
     +     .961,.948,.902,.104,.495,.257,.524,.100,.492,.347 ,
     +     .981,.019,.225,.806,.678,.710,.235,.600,.994,.758 ,
     +     .682,.373,.009,.469,.203,.730,.588,.603,.213,.495 ,
     +     .884,.032,.185,.127,.010,.180,.689,.354,.372,.429 /
      DATA ISEQ / 0 /
      ISEQ=MOD(ISEQ,100)+1
      FRAN=RSEQ(ISEQ)
      RETURN
      END

      SUBROUTINE COLOR(IWKID)
C
C Background color (black):
C
      CALL GSCR(1,0,0.,0.,0.)
C
C Foreground colors
C
C White
C
      CALL GSCR (IWKID,  1, 1.00, 1.00, 1.00)
C
C Red
C
      CALL GSCR (IWKID,  2, 0.90, 0.25, 0.00)
C
C OrangeRed
C
      CALL GSCR (IWKID,  3, 1.00, 0.00, 0.20)
C
C Orange
C
      CALL GSCR (IWKID,  4, 1.00, 0.65, 0.00)
C
C Yellow
C
      CALL GSCR (IWKID,  5, 1.00, 1.00, 0.00)
C
C GreenYellow
C
      CALL GSCR (IWKID,  6, 0.70, 1.00, 0.20)
C
C Chartreuse
C
      CALL GSCR (IWKID,  7, 0.50, 1.00, 0.00)
C
C Celeste
C
      CALL GSCR (IWKID,  8, 0.20, 1.00, 0.50)
C
C Green
C
      CALL GSCR (IWKID,  9, 0.20, 0.80, 0.20)
C
C Aqua
C
      CALL GSCR (IWKID, 10, 0.00, 0.90, 1.00)
C
C DeepSkyBlue
C
      CALL GSCR (IWKID, 11, 0.00, 0.75, 1.00)
C
C RoyalBlue
C
      CALL GSCR (IWKID, 12, 0.25, 0.45, 0.95)
C
C SlateBlue
C
      CALL GSCR (IWKID, 13, 0.40, 0.35, 0.80)
C
C DarkViolet
C
      CALL GSCR (IWKID, 14, 0.60, 0.00, 0.80)
C
C Orchid
C
      CALL GSCR (IWKID, 15, 0.85, 0.45, 0.80)
C
C Lavender
C
      CALL GSCR (IWKID, 16, 0.80, 0.80, 1.00)
C
C Gray
C
      CALL GSCR (IWKID, 17, 0.70, 0.70, 0.70)
C
C Done.
C
      RETURN
C
      END

      PROGRAM BNCHMK
C
C     This program produces plots illustrating non-trivial
C     usage of the NCAR Utilities.  This program is an
C     exact copy of an implementation that runs on a UNIX
C     machine at NCAR.  To implement this program on another
C     machine only the following steps should be required:
C
C       1.)  Modify the OPEN to the EZMAP dataset that
C            appears in the main program.
C
C       2.)  Modify the OPEN to the file of random numbers
C            RANFDAT in subroutine RANDNO.
C
C     The utilities AUTOGRPH, VELVCT, CONREC, EZMAP, GRIDAL,
C     and DASHCHAR are required.  Since CONREC and VELVCT plots
C     are overlaid on EZMAP, the arithmetic statement functions
C     for FX and FY in these two utilities should be changed
C     to the statement:
C
C      EXTERNAL FX,FY
C
C     This will force the functions FX and FY supplied in this
C     package to be loaded.  The documentation for FX explains
C     the transformations provided.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
      PARAMETER ( M=70 , N=150 , NPR=155)
      PARAMETER (PI=3.14159 , TWOPI=2.*PI , EPS=PI/6.)
      DIMENSION A(M,NPR),B(M,N)
      EQUIVALENCE (A(1,5),B(1,1))
      COMMON  /TRANS/  MA,NA,ITRANS,A1,A2,D1,D2,ALNMN,ALNMX,ALTMN,ALTMX
      CHARACTER*1  ZERO
      CHARACTER*16 LDASH(1)
      DATA  LDASH(1) /'$$''$$''$$''$$''$$''$'/
C
C Modification for UNIX Version.
C       OPEN statement removed.
C End of modification for UNIX Version.
C
C     Open GKS, open workstation, activate workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
      ZERO = CHAR(0)
C
C     Generate the input array.
C
      CALL GENARA(B,A,M,N)
C
C     Frame 1 -- three curves on same plot using AUTOGRAPH.
C
      CALL AGSETI('DASH/LENGTH.',16)
      CALL DISPLA(2,0,1)
      DO 160 J=1,3
      YT = 0.3*REAL(J)
      YB = 0.3*REAL(J-1)+.05
      CALL SET(.1,.9,YB,YT,0.,1.,0.,1.,1)
      CALL ANOTAT(ZERO,ZERO,3,2,1,LDASH)
      CALL EZY(A(1,3*J),60,' $')
  160 CONTINUE
      CALL FRAME
C
C     Frame 2 -- CONREC plot with polar coordinate transformation.
C
      ITRANS = 1
      D1 = 20.
      MA = 30
      NA = 70
      CALL GENARA(B,A,MA,NA+12)
      XMIN = -60.
      XMAX =  60.
      YMIN = -80.
      YMAX =  80.
      CALL SET(.1,.9,.1,.9,XMIN,XMAX,YMIN,YMAX,1)
      CALL LABMOD ('(F5.0)','(F5.0)',5,5,0,0,0,0,0)
      CALL PERIML(6,2,6,2)
      D2 = 30.
      A1 = EPS
      A2 = TWOPI-.5*A1
      DELX = 1.25*(D1+D2)
      DELY = 1.50*(D1+D2)
      CALL SET(.05,.95,.05,.95,-DELX,DELX,-DELY,DELY,1)
      CALL CONREC (A(1,4),MA,MA,NA,0.,0.,0.,1,-1,0)
      CALL FRAME
C
C     Frame 3 -- CONREC overlaid on EZMAP.
C
      MA = 55
      NA = 45
      CALL GENARA(B,A,MA,NA)
      ITRANS = 2
      CALL SUPMAP (2,40.,-90.,0.,0.,0.,0.,0.,1,20,4,0,IERS)
      ALNMN = -160.
      ALNMX = -20.
      ALTMN = 0.
      ALTMX = 60.
      CALL CONREC (A,MA,MA,NA,0.,0.,0.,1,0,-585)
      CALL FRAME
C
C     Frame 4 -- CONREC overlaid on EZMAP.
C
      MA = 55
      NA = 45
      CALL GENARA(B,A,MA,NA)
      ITRANS = 2
      CALL SUPMAP (3,45.,-100.,45.,50.,-130.,20.,-75.,2,10,3,1,IERS)
      ALNMN = -120.
      ALNMX = -75.
      ALTMN = 25.
      ALTMX = 50.
      CALL CONREC (A,MA,MA,NA,0.,0.,0.,1,-1,1)
      CALL FRAME
C
C     Frame 5 --  CONREC with modified background.
C
      ITRANS = 0
      CALL GENARA(B,A,40,40)
      CALL SET(.1,.9,.1,.9,-1.,1.,-2.,2.,1)
      CALL LABMOD ('(F3.0)','(F3.0)',3,3,0,0,0,0,0)
      CALL PERIML(2,10,4,5)
      CALL CONREC(A(1,1),40,40,40,-1.,1.,.5,-1,-1,-682)
      CALL FRAME
C
C     Frame 6 -- VELVCT overlaid on EZMAP.
C
      CALL GENARA(B,A,60,60)
      ITRANS = 2
      CALL SUPMAP (3,45.,-100.,45.,50.,-130.,20.,-75.,2,15,3,0,IERS)
      ALNMN = -120.
      ALNMX = -75.
      ALTMN = 25.
      ALTMX = 50.
      CALL VVSETI('MAP -- Mapping Mode', 1)
      CALL VVSETI('SET -- Do SET Call Flag', 0)
      CALL VVSETR('XC1 -- Lower X Bound', -120.0)
      CALL VVSETR('XCM -- Upper X Bound', -75.0)
      CALL VVSETR('YC1 -- Lower Y Bound', 25.0)
      CALL VVSETR('YCN -- Upper Y Bound', 50.0)
      MA = 25
      NA = 25
      IDM=0
      CALL VVINIT (A(1,10),60,A(1,25),60,IDM,IDM,MA,NA,IDM,IDM)
      CALL VVECTR (A(1,10),A(1,25),IDM,IDM,IDM,IDM)
      CALL FRAME
C
C     Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      STOP
      END

      SUBROUTINE GENARA (A,B,ID,JD)
C
C     This subroutine generates a smooth array in output array B.
C     The array is dependent on the random number function RANDNO.
C     RANDNO can be replaced by a random number generator on a
C     given machine, or for consistency across machines, the
C     supplied function RANDNO may be used.  RANDNO reads its random
C     numbers from the file RANFDAT.
C
      DIMENSION A(ID,JD), B(ID,JD)
C
      DO 1 I=1,ID
      DO 1 J=1,JD
    1 A(I,J)=0.
C
      NN=(ID+JD)/10
      AA=1.
      DI=ID-4
      DJ=JD-4
C
    2 DO 5 K=1,NN
      II=3.+DI*RANDNO()
      JJ=3.+DJ*RANDNO()
      DO 4 J=1,JD
      JE=ABS(J-JJ)
      DO 3 I=1,ID
      IE=ABS(I-II)
      EE=MAX(IE,JE)
      A(I,J)=A(I,J)+AA*(.8**EE)
    3 CONTINUE
    4 CONTINUE
    5 CONTINUE
C
      IF (AA.NE.1.) GO TO 6
      AA=-1.
      GO TO 2
C
    6 DO 8 J=1,JD
      JM1=MAX(1,J-1)
      JP1=MIN(JD,J+1)
      DO 7 I=1,ID
      IM1=MAX(1,I-1)
      IP1=MIN(ID,I+1)
      B(I,J)=(4.*A(I,J)+2.*(A(I,JM1)+A(IM1,J)+A(IP1,J)+A(I,JP1))
     1                 +A(IM1,JM1)+A(IP1,JM1)+A(IM1,JP1)+A(IP1,JP1))/16.
    7 CONTINUE
    8 CONTINUE
      RETURN
      END

       SUBROUTINE OPENR (IUNIT)
       CHARACTER*128 FILENM
       SAVE IOPEN
       DATA IOPEN / 0 /
       IF (IOPEN.EQ.0) THEN
           CALL GNGPAT (FILENM,"database",ISTATUS)
           IF (ISTATUS .NE. -1) THEN
               DO 101 I=1,120
                   IF (FILENM(I:I).EQ.CHAR(0)) THEN
                       FILENM(I:I+8)='/ranfdata'
                       GO TO 102
                   END IF
  101          CONTINUE
               GO TO 104
           ELSE 
               GO TO 103
           ENDIF
 102       OPEN (UNIT=IUNIT,FILE=FILENM,STATUS='OLD',FORM='FORMATTED',
     +                                                       ERR=104)
          IOPEN=1
      END IF
      RETURN
 103  WRITE (6,*) FILENM
      GO TO 105
 104  WRITE (6,*) 'ERROR IN OPENING FILE OF RANDOM NUMBERS: ',FILENM
 105  CONTINUE
      STOP
      END

      FUNCTION RANDNO()
C
C     This function is used to produce random numbers for the
C     GENARA calls.  The random numbers are read from file
C     RANFDAT, and in this way consistency is maintained across
C     machines (the results on one machine should be the same
C     as on another.)  If consistency is not required, the
C     function RANDNO can be replaced by a local random number
C     generator.  RANFDAT contains 2000 random numbers in
C     250 card-image lines in format 8F10.8 .
C
      SAVE ICNT,A
      DIMENSION A(2000)
      DATA ICNT/0/
C
      ICNT = ICNT+1
C
C     Read in random numbers if this is the first function call.
C
      IF (ICNT .EQ. 1) THEN
C Modification for UNIX Version.
	CALL OPENR(8)
C End of modification for UNIX Version.
        DO 3 I=1,250
        INDX = 8*(I-1)+1
        JNDX = INDX+7
        READ(8,501) (A(LL),LL=INDX,JNDX)
    3   CONTINUE
      END IF
C
      RANDNO = A(ICNT)
      RETURN
C
  500 FORMAT(' RANDNO--ERROR IN READ')
  501 FORMAT(8F10.8)
C
      END

      FUNCTION FX(X,Y)
C
      COMMON  /TRANS/  MA,NA,ITRANS,A1,A2,D1,D2,ALNMN,ALNMX,ALTMN,ALTMX
C
C     This function implements three transformations on the input
C     coordinate pair (X,Y) .  The coordinate (X,Y) is assumed to
C     be contained in the rectangle 1 to MA by 1 to NA.  The
C     transformation selected depends on the value of ITRANS:
C
C       ITRANS=0     The identity transformation is used.
C
C       ITRANS=1     Polar transformation.  The rectangular region
C                    bounded by the corner points (1,1), (MA,1),
C                    (MA,NA), (1,NA)  is transfomed onto the region
C                    in polar coordinates bounded by the polar
C                    coordinates (D1,A1), (D1,A2), (D2,A2), (D1,A2)
C                    where the angles A1 and A1 are expressed in radians.
C
C       ITRANS=2     Provides a linear mapping of the rectangular
C                    input array onto the region  ALNMN  to  ALNMX
C                    by  ALTMN  to  ALTMX.  The four parameters
C                    ALNMN, ALMNX, ALTMN, and ALTMX are assumed
C                    to specify two longitudes (ALNMN--minimum
C                    longitude; ALNMX--maximum longitude) and
C                    and two latitudes (ALTMN--minimum latitude;
C                    ALTMX--maximum latitude.)  The latitudes and
C                    longitudes in the transformed space are then
C                    projected onto the plot using the current
C                    EZMAP projection (hence EZMAP must be called
C                    prior to calling FX with ITRANS=2.)
C
      GOTO (10,20,30)  ITRANS+1
C
C     Identity transformation.
C
10    CONTINUE
      FX = X
      RETURN
C
C     Polar coordinate transformation.
C
20    CONTINUE
      FX=(D1+D2*(X-1.)/(REAL(MA)-1.))*COS(A1+A2*(Y-1.)/(REAL(NA)-1.))
      RETURN
C
C     EZMAP overlaying.
C
30    CONTINUE
      XLON = ALNMN + (X-1.)*(ALNMX-ALNMN)/(REAL(MA)-1.)
      YLAT = ALTMN + (Y-1.)*(ALTMX-ALTMN)/(REAL(NA)-1.)
      CALL MAPTRN (YLAT, XLON, FXLON, YDUM)
      FX = FXLON
      RETURN
      END
      
      FUNCTION FY(X,Y)
C
      COMMON  /TRANS/  MA,NA,ITRANS,A1,A2,D1,D2,ALNMN,ALNMX,ALTMN,ALTMX
C
C     The function FY behaves in an analagous manner to FX as
C     described above.
C
      GOTO (10,20,30)  ITRANS+1
C
C     The identity transformation.
C
10    CONTINUE
      FY = Y
      RETURN
C
C     Polar coordinate transformation.
C
20    CONTINUE
      FY=(D1+D2*(X-1.)/(REAL(MA)-1.))*SIN(A1+A2*(Y-1.)/(REAL(NA)-1.))
      RETURN
C
C     EZMAP overlaying.
C
30    CONTINUE
      XLON = ALNMN + (X-1.)*(ALNMX-ALNMN)/(REAL(MA)-1.)
      YLAT = ALTMN + (Y-1.)*(ALTMX-ALTMN)/(REAL(NA)-1.)
      CALL MAPTRN(YLAT,XLON,XDUM,FYLAT)
      FY = FYLAT
      RETURN
      END

      SUBROUTINE DGEES( JOBVS, SORT, SELECT, N, A, LDA, SDIM, WR, WI,
     $                  VS, LDVS, WORK, LWORK, BWORK, INFO )
*
*  -- LAPACK driver routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          JOBVS, SORT
      INTEGER            INFO, LDA, LDVS, LWORK, N, SDIM
*     ..
*     .. Array Arguments ..
      LOGICAL            BWORK( * )
      DOUBLE PRECISION   A( LDA, * ), VS( LDVS, * ), WI( * ), WORK( * ),
     $                   WR( * )
*     ..
*     .. Function Arguments ..
      LOGICAL            SELECT
      EXTERNAL           SELECT
*     ..
*
*  Purpose
*  =======
*
*  DGEES computes for an N-by-N real nonsymmetric matrix A, the
*  eigenvalues, the real Schur form T, and, optionally, the matrix of
*  Schur vectors Z.  This gives the Schur factorization A = Z*T*(Z**T).
*
*  Optionally, it also orders the eigenvalues on the diagonal of the
*  real Schur form so that selected eigenvalues are at the top left.
*  The leading columns of Z then form an orthonormal basis for the
*  invariant subspace corresponding to the selected eigenvalues.
*
*  A matrix is in real Schur form if it is upper quasi-triangular with
*  1-by-1 and 2-by-2 blocks. 2-by-2 blocks will be standardized in the
*  form
*          [  a  b  ]
*          [  c  a  ]
*
*  where b*c < 0. The eigenvalues of such a block are a +- sqrt(bc).
*
*  Arguments
*  =========
*
*  JOBVS   (input) CHARACTER*1
*          = 'N': Schur vectors are not computed;
*          = 'V': Schur vectors are computed.
*
*  SORT    (input) CHARACTER*1
*          Specifies whether or not to order the eigenvalues on the
*          diagonal of the Schur form.
*          = 'N': Eigenvalues are not ordered;
*          = 'S': Eigenvalues are ordered (see SELECT).
*
*  SELECT  (input) LOGICAL FUNCTION of two DOUBLE PRECISION arguments
*          SELECT must be declared EXTERNAL in the calling subroutine.
*          If SORT = 'S', SELECT is used to select eigenvalues to sort
*          to the top left of the Schur form.
*          If SORT = 'N', SELECT is not referenced.
*          An eigenvalue WR(j)+sqrt(-1)*WI(j) is selected if
*          SELECT(WR(j),WI(j)) is true; i.e., if either one of a complex
*          conjugate pair of eigenvalues is selected, then both complex
*          eigenvalues are selected.
*          Note that a selected complex eigenvalue may no longer
*          satisfy SELECT(WR(j),WI(j)) = .TRUE. after ordering, since
*          ordering may change the value of complex eigenvalues
*          (especially if the eigenvalue is ill-conditioned); in this
*          case INFO is set to N+2 (see INFO below).
*
*  N       (input) INTEGER
*          The order of the matrix A. N >= 0.
*
*  A       (input/output) DOUBLE PRECISION array, dimension (LDA,N)
*          On entry, the N-by-N matrix A.
*          On exit, A has been overwritten by its real Schur form T.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(1,N).
*
*  SDIM    (output) INTEGER
*          If SORT = 'N', SDIM = 0.
*          If SORT = 'S', SDIM = number of eigenvalues (after sorting)
*                         for which SELECT is true. (Complex conjugate
*                         pairs for which SELECT is true for either
*                         eigenvalue count as 2.)
*
*  WR      (output) DOUBLE PRECISION array, dimension (N)
*  WI      (output) DOUBLE PRECISION array, dimension (N)
*          WR and WI contain the real and imaginary parts,
*          respectively, of the computed eigenvalues in the same order
*          that they appear on the diagonal of the output Schur form T.
*          Complex conjugate pairs of eigenvalues will appear
*          consecutively with the eigenvalue having the positive
*          imaginary part first.
*
*  VS      (output) DOUBLE PRECISION array, dimension (LDVS,N)
*          If JOBVS = 'V', VS contains the orthogonal matrix Z of Schur
*          vectors.
*          If JOBVS = 'N', VS is not referenced.
*
*  LDVS    (input) INTEGER
*          The leading dimension of the array VS.  LDVS >= 1; if
*          JOBVS = 'V', LDVS >= N.
*
*  WORK    (workspace/output) DOUBLE PRECISION array, dimension (LWORK)
*          On exit, if INFO = 0, WORK(1) contains the optimal LWORK.
*
*  LWORK   (input) INTEGER
*          The dimension of the array WORK.  LWORK >= max(1,3*N).
*          For good performance, LWORK must generally be larger.
*
*          If LWORK = -1, then a workspace query is assumed; the routine
*          only calculates the optimal size of the WORK array, returns
*          this value as the first entry of the WORK array, and no error
*          message related to LWORK is issued by XERBLA.
*
*  BWORK   (workspace) LOGICAL array, dimension (N)
*          Not referenced if SORT = 'N'.
*
*  INFO    (output) INTEGER
*          = 0: successful exit
*          < 0: if INFO = -i, the i-th argument had an illegal value.
*          > 0: if INFO = i, and i is
*             <= N: the QR algorithm failed to compute all the
*                   eigenvalues; elements 1:ILO-1 and i+1:N of WR and WI
*                   contain those eigenvalues which have converged; if
*                   JOBVS = 'V', VS contains the matrix which reduces A
*                   to its partially converged Schur form.
*             = N+1: the eigenvalues could not be reordered because some
*                   eigenvalues were too close to separate (the problem
*                   is very ill-conditioned);
*             = N+2: after reordering, roundoff changed values of some
*                   complex eigenvalues so that leading eigenvalues in
*                   the Schur form no longer satisfy SELECT=.TRUE.  This
*                   could also be caused by underflow due to scaling.
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO, ONE
      PARAMETER          ( ZERO = 0.0D0, ONE = 1.0D0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            CURSL, LASTSL, LQUERY, LST2SL, SCALEA, WANTST,
     $                   WANTVS
      INTEGER            HSWORK, I, I1, I2, IBAL, ICOND, IERR, IEVAL,
     $                   IHI, ILO, INXT, IP, ITAU, IWRK, K, MAXB,
     $                   MAXWRK, MINWRK
      DOUBLE PRECISION   ANRM, BIGNUM, CSCALE, EPS, S, SEP, SMLNUM
*     ..
*     .. Local Arrays ..
      INTEGER            IDUM( 1 )
      DOUBLE PRECISION   DUM( 1 )
*     ..
*     .. External Subroutines ..
      EXTERNAL           DCOPY, DGEBAK, DGEBAL, DGEHRD, DHSEQR, DLACPY,
     $                   DLASCL, DORGHR, DSWAP, DTRSEN, XERBLA
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            ILAENV
      DOUBLE PRECISION   DLAMCH, DLANGE
      EXTERNAL           LSAME, ILAENV, DLAMCH, DLANGE
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN, SQRT
*     ..
*     .. Executable Statements ..
*
*     Test the input arguments
*
      INFO = 0
      LQUERY = ( LWORK.EQ.-1 )
      WANTVS = LSAME( JOBVS, 'V' )
      WANTST = LSAME( SORT, 'S' )
      IF( ( .NOT.WANTVS ) .AND. ( .NOT.LSAME( JOBVS, 'N' ) ) ) THEN
         INFO = -1
      ELSE IF( ( .NOT.WANTST ) .AND. ( .NOT.LSAME( SORT, 'N' ) ) ) THEN
         INFO = -2
      ELSE IF( N.LT.0 ) THEN
         INFO = -4
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -6
      ELSE IF( LDVS.LT.1 .OR. ( WANTVS .AND. LDVS.LT.N ) ) THEN
         INFO = -11
      END IF
*
*     Compute workspace
*      (Note: Comments in the code beginning "Workspace:" describe the
*       minimal amount of workspace needed at that point in the code,
*       as well as the preferred amount for good performance.
*       NB refers to the optimal block size for the immediately
*       following subroutine, as returned by ILAENV.
*       HSWORK refers to the workspace preferred by DHSEQR, as
*       calculated below. HSWORK is computed assuming ILO=1 and IHI=N,
*       the worst case.)
*
      MINWRK = 1
      IF( INFO.EQ.0 .AND. ( LWORK.GE.1 .OR. LQUERY ) ) THEN
         MAXWRK = 2*N + N*ILAENV( 1, 'DGEHRD', ' ', N, 1, N, 0 )
         MINWRK = MAX( 1, 3*N )
         IF( .NOT.WANTVS ) THEN
            MAXB = MAX( ILAENV( 8, 'DHSEQR', 'SN', N, 1, N, -1 ), 2 )
            K = MIN( MAXB, N, MAX( 2, ILAENV( 4, 'DHSEQR', 'SN', N, 1,
     $          N, -1 ) ) )
            HSWORK = MAX( K*( K+2 ), 2*N )
            MAXWRK = MAX( MAXWRK, N+HSWORK, 1 )
         ELSE
            MAXWRK = MAX( MAXWRK, 2*N+( N-1 )*
     $               ILAENV( 1, 'DORGHR', ' ', N, 1, N, -1 ) )
            MAXB = MAX( ILAENV( 8, 'DHSEQR', 'EN', N, 1, N, -1 ), 2 )
            K = MIN( MAXB, N, MAX( 2, ILAENV( 4, 'DHSEQR', 'EN', N, 1,
     $          N, -1 ) ) )
            HSWORK = MAX( K*( K+2 ), 2*N )
            MAXWRK = MAX( MAXWRK, N+HSWORK, 1 )
         END IF
         WORK( 1 ) = MAXWRK
      END IF
      IF( LWORK.LT.MINWRK .AND. .NOT.LQUERY ) THEN
         INFO = -13
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DGEES ', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 ) THEN
         SDIM = 0
         RETURN
      END IF
*
*     Get machine constants
*
      EPS = DLAMCH( 'P' )
      SMLNUM = DLAMCH( 'S' )
      BIGNUM = ONE / SMLNUM
      CALL DLABAD( SMLNUM, BIGNUM )
      SMLNUM = SQRT( SMLNUM ) / EPS
      BIGNUM = ONE / SMLNUM
*
*     Scale A if max element outside range [SMLNUM,BIGNUM]
*
      ANRM = DLANGE( 'M', N, N, A, LDA, DUM )
      SCALEA = .FALSE.
      IF( ANRM.GT.ZERO .AND. ANRM.LT.SMLNUM ) THEN
         SCALEA = .TRUE.
         CSCALE = SMLNUM
      ELSE IF( ANRM.GT.BIGNUM ) THEN
         SCALEA = .TRUE.
         CSCALE = BIGNUM
      END IF
      IF( SCALEA )
     $   CALL DLASCL( 'G', 0, 0, ANRM, CSCALE, N, N, A, LDA, IERR )
*
*     Permute the matrix to make it more nearly triangular
*     (Workspace: need N)
*
      IBAL = 1
      CALL DGEBAL( 'P', N, A, LDA, ILO, IHI, WORK( IBAL ), IERR )
*
*     Reduce to upper Hessenberg form
*     (Workspace: need 3*N, prefer 2*N+N*NB)
*
      ITAU = N + IBAL
      IWRK = N + ITAU
      CALL DGEHRD( N, ILO, IHI, A, LDA, WORK( ITAU ), WORK( IWRK ),
     $             LWORK-IWRK+1, IERR )
*
      IF( WANTVS ) THEN
*
*        Copy Householder vectors to VS
*
         CALL DLACPY( 'L', N, N, A, LDA, VS, LDVS )
*
*        Generate orthogonal matrix in VS
*        (Workspace: need 3*N-1, prefer 2*N+(N-1)*NB)
*
         CALL DORGHR( N, ILO, IHI, VS, LDVS, WORK( ITAU ), WORK( IWRK ),
     $                LWORK-IWRK+1, IERR )
      END IF
*
      SDIM = 0
*
*     Perform QR iteration, accumulating Schur vectors in VS if desired
*     (Workspace: need N+1, prefer N+HSWORK (see comments) )
*
      IWRK = ITAU
      CALL DHSEQR( 'S', JOBVS, N, ILO, IHI, A, LDA, WR, WI, VS, LDVS,
     $             WORK( IWRK ), LWORK-IWRK+1, IEVAL )
      IF( IEVAL.GT.0 )
     $   INFO = IEVAL
*
*     Sort eigenvalues if desired
*
      IF( WANTST .AND. INFO.EQ.0 ) THEN
         IF( SCALEA ) THEN
            CALL DLASCL( 'G', 0, 0, CSCALE, ANRM, N, 1, WR, N, IERR )
            CALL DLASCL( 'G', 0, 0, CSCALE, ANRM, N, 1, WI, N, IERR )
         END IF
         DO 10 I = 1, N
            BWORK( I ) = SELECT( WR( I ), WI( I ) )
   10    CONTINUE
*
*        Reorder eigenvalues and transform Schur vectors
*        (Workspace: none needed)
*
         CALL DTRSEN( 'N', JOBVS, BWORK, N, A, LDA, VS, LDVS, WR, WI,
     $                SDIM, S, SEP, WORK( IWRK ), LWORK-IWRK+1, IDUM, 1,
     $                ICOND )
         IF( ICOND.GT.0 )
     $      INFO = N + ICOND
      END IF
*
      IF( WANTVS ) THEN
*
*        Undo balancing
*        (Workspace: need N)
*
         CALL DGEBAK( 'P', 'R', N, ILO, IHI, WORK( IBAL ), N, VS, LDVS,
     $                IERR )
      END IF
*
      IF( SCALEA ) THEN
*
*        Undo scaling for the Schur form of A
*
         CALL DLASCL( 'H', 0, 0, CSCALE, ANRM, N, N, A, LDA, IERR )
         CALL DCOPY( N, A, LDA+1, WR, 1 )
         IF( CSCALE.EQ.SMLNUM ) THEN
*
*           If scaling back towards underflow, adjust WI if an
*           offdiagonal element of a 2-by-2 block in the Schur form
*           underflows.
*
            IF( IEVAL.GT.0 ) THEN
               I1 = IEVAL + 1
               I2 = IHI - 1
               CALL DLASCL( 'G', 0, 0, CSCALE, ANRM, ILO-1, 1, WI,
     $                      MAX( ILO-1, 1 ), IERR )
            ELSE IF( WANTST ) THEN
               I1 = 1
               I2 = N - 1
            ELSE
               I1 = ILO
               I2 = IHI - 1
            END IF
            INXT = I1 - 1
            DO 20 I = I1, I2
               IF( I.LT.INXT )
     $            GO TO 20
               IF( WI( I ).EQ.ZERO ) THEN
                  INXT = I + 1
               ELSE
                  IF( A( I+1, I ).EQ.ZERO ) THEN
                     WI( I ) = ZERO
                     WI( I+1 ) = ZERO
                  ELSE IF( A( I+1, I ).NE.ZERO .AND. A( I, I+1 ).EQ.
     $                     ZERO ) THEN
                     WI( I ) = ZERO
                     WI( I+1 ) = ZERO
                     IF( I.GT.1 )
     $                  CALL DSWAP( I-1, A( 1, I ), 1, A( 1, I+1 ), 1 )
                     IF( N.GT.I+1 )
     $                  CALL DSWAP( N-I-1, A( I, I+2 ), LDA,
     $                              A( I+1, I+2 ), LDA )
                     CALL DSWAP( N, VS( 1, I ), 1, VS( 1, I+1 ), 1 )
                     A( I, I+1 ) = A( I+1, I )
                     A( I+1, I ) = ZERO
                  END IF
                  INXT = I + 2
               END IF
   20       CONTINUE
         END IF
*
*        Undo scaling for the imaginary part of the eigenvalues
*
         CALL DLASCL( 'G', 0, 0, CSCALE, ANRM, N-IEVAL, 1,
     $                WI( IEVAL+1 ), MAX( N-IEVAL, 1 ), IERR )
      END IF
*
      IF( WANTST .AND. INFO.EQ.0 ) THEN
*
*        Check if reordering successful
*
         LASTSL = .TRUE.
         LST2SL = .TRUE.
         SDIM = 0
         IP = 0
         DO 30 I = 1, N
            CURSL = SELECT( WR( I ), WI( I ) )
            IF( WI( I ).EQ.ZERO ) THEN
               IF( CURSL )
     $            SDIM = SDIM + 1
               IP = 0
               IF( CURSL .AND. .NOT.LASTSL )
     $            INFO = N + 2
            ELSE
               IF( IP.EQ.1 ) THEN
*
*                 Last eigenvalue of conjugate pair
*
                  CURSL = CURSL .OR. LASTSL
                  LASTSL = CURSL
                  IF( CURSL )
     $               SDIM = SDIM + 2
                  IP = -1
                  IF( CURSL .AND. .NOT.LST2SL )
     $               INFO = N + 2
               ELSE
*
*                 First eigenvalue of conjugate pair
*
                  IP = 1
               END IF
            END IF
            LST2SL = LASTSL
            LASTSL = CURSL
   30    CONTINUE
      END IF
*
      WORK( 1 ) = MAXWRK
      RETURN
*
*     End of DGEES
*
      END

      SUBROUTINE ZLALS0( ICOMPQ, NL, NR, SQRE, NRHS, B, LDB, BX, LDBX,
     $                   PERM, GIVPTR, GIVCOL, LDGCOL, GIVNUM, LDGNUM,
     $                   POLES, DIFL, DIFR, Z, K, C, S, RWORK, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     December 1, 1999
*
*     .. Scalar Arguments ..
      INTEGER            GIVPTR, ICOMPQ, INFO, K, LDB, LDBX, LDGCOL,
     $                   LDGNUM, NL, NR, NRHS, SQRE
      DOUBLE PRECISION   C, S
*     ..
*     .. Array Arguments ..
      INTEGER            GIVCOL( LDGCOL, * ), PERM( * )
      DOUBLE PRECISION   DIFL( * ), DIFR( LDGNUM, * ),
     $                   GIVNUM( LDGNUM, * ), POLES( LDGNUM, * ),
     $                   RWORK( * ), Z( * )
      COMPLEX*16         B( LDB, * ), BX( LDBX, * )
*     ..
*
*  Purpose
*  =======
*
*  ZLALS0 applies back the multiplying factors of either the left or the
*  right singular vector matrix of a diagonal matrix appended by a row
*  to the right hand side matrix B in solving the least squares problem
*  using the divide-and-conquer SVD approach.
*
*  For the left singular vector matrix, three types of orthogonal
*  matrices are involved:
*
*  (1L) Givens rotations: the number of such rotations is GIVPTR; the
*       pairs of columns/rows they were applied to are stored in GIVCOL;
*       and the C- and S-values of these rotations are stored in GIVNUM.
*
*  (2L) Permutation. The (NL+1)-st row of B is to be moved to the first
*       row, and for J=2:N, PERM(J)-th row of B is to be moved to the
*       J-th row.
*
*  (3L) The left singular vector matrix of the remaining matrix.
*
*  For the right singular vector matrix, four types of orthogonal
*  matrices are involved:
*
*  (1R) The right singular vector matrix of the remaining matrix.
*
*  (2R) If SQRE = 1, one extra Givens rotation to generate the right
*       null space.
*
*  (3R) The inverse transformation of (2L).
*
*  (4R) The inverse transformation of (1L).
*
*  Arguments
*  =========
*
*  ICOMPQ (input) INTEGER
*         Specifies whether singular vectors are to be computed in
*         factored form:
*         = 0: Left singular vector matrix.
*         = 1: Right singular vector matrix.
*
*  NL     (input) INTEGER
*         The row dimension of the upper block. NL >= 1.
*
*  NR     (input) INTEGER
*         The row dimension of the lower block. NR >= 1.
*
*  SQRE   (input) INTEGER
*         = 0: the lower block is an NR-by-NR square matrix.
*         = 1: the lower block is an NR-by-(NR+1) rectangular matrix.
*
*         The bidiagonal matrix has row dimension N = NL + NR + 1,
*         and column dimension M = N + SQRE.
*
*  NRHS   (input) INTEGER
*         The number of columns of B and BX. NRHS must be at least 1.
*
*  B      (input/output) COMPLEX*16 array, dimension ( LDB, NRHS )
*         On input, B contains the right hand sides of the least
*         squares problem in rows 1 through M. On output, B contains
*         the solution X in rows 1 through N.
*
*  LDB    (input) INTEGER
*         The leading dimension of B. LDB must be at least
*         max(1,MAX( M, N ) ).
*
*  BX     (workspace) COMPLEX*16 array, dimension ( LDBX, NRHS )
*
*  LDBX   (input) INTEGER
*         The leading dimension of BX.
*
*  PERM   (input) INTEGER array, dimension ( N )
*         The permutations (from deflation and sorting) applied
*         to the two blocks.
*
*  GIVPTR (input) INTEGER
*         The number of Givens rotations which took place in this
*         subproblem.
*
*  GIVCOL (input) INTEGER array, dimension ( LDGCOL, 2 )
*         Each pair of numbers indicates a pair of rows/columns
*         involved in a Givens rotation.
*
*  LDGCOL (input) INTEGER
*         The leading dimension of GIVCOL, must be at least N.
*
*  GIVNUM (input) DOUBLE PRECISION array, dimension ( LDGNUM, 2 )
*         Each number indicates the C or S value used in the
*         corresponding Givens rotation.
*
*  LDGNUM (input) INTEGER
*         The leading dimension of arrays DIFR, POLES and
*         GIVNUM, must be at least K.
*
*  POLES  (input) DOUBLE PRECISION array, dimension ( LDGNUM, 2 )
*         On entry, POLES(1:K, 1) contains the new singular
*         values obtained from solving the secular equation, and
*         POLES(1:K, 2) is an array containing the poles in the secular
*         equation.
*
*  DIFL   (input) DOUBLE PRECISION array, dimension ( K ).
*         On entry, DIFL(I) is the distance between I-th updated
*         (undeflated) singular value and the I-th (undeflated) old
*         singular value.
*
*  DIFR   (input) DOUBLE PRECISION array, dimension ( LDGNUM, 2 ).
*         On entry, DIFR(I, 1) contains the distances between I-th
*         updated (undeflated) singular value and the I+1-th
*         (undeflated) old singular value. And DIFR(I, 2) is the
*         normalizing factor for the I-th right singular vector.
*
*  Z      (input) DOUBLE PRECISION array, dimension ( K )
*         Contain the components of the deflation-adjusted updating row
*         vector.
*
*  K      (input) INTEGER
*         Contains the dimension of the non-deflated matrix,
*         This is the order of the related secular equation. 1 <= K <=N.
*
*  C      (input) DOUBLE PRECISION
*         C contains garbage if SQRE =0 and the C-value of a Givens
*         rotation related to the right null space if SQRE = 1.
*
*  S      (input) DOUBLE PRECISION
*         S contains garbage if SQRE =0 and the S-value of a Givens
*         rotation related to the right null space if SQRE = 1.
*
*  RWORK  (workspace) DOUBLE PRECISION array, dimension
*         ( K*(1+NRHS) + 2*NRHS )
*
*  INFO   (output) INTEGER
*          = 0:  successful exit.
*          < 0:  if INFO = -i, the i-th argument had an illegal value.
*
*  Further Details
*  ===============
*
*  Based on contributions by
*     Ming Gu and Ren-Cang Li, Computer Science Division, University of
*       California at Berkeley, USA
*     Osni Marques, LBNL/NERSC, USA
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ONE, ZERO, NEGONE
      PARAMETER          ( ONE = 1.0D0, ZERO = 0.0D0, NEGONE = -1.0D0 )
*     ..
*     .. Local Scalars ..
      INTEGER            I, J, JCOL, JROW, M, N, NLP1
      DOUBLE PRECISION   DIFLJ, DIFRJ, DJ, DSIGJ, DSIGJP, TEMP
*     ..
*     .. External Subroutines ..
      EXTERNAL           DGEMV, XERBLA, ZCOPY, ZDROT, ZDSCAL, ZLACPY,
     $                   ZLASCL
*     ..
*     .. External Functions ..
      DOUBLE PRECISION   DLAMC3, DNRM2
      EXTERNAL           DLAMC3, DNRM2
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          DBLE, DCMPLX, DIMAG
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
*
      IF( ( ICOMPQ.LT.0 ) .OR. ( ICOMPQ.GT.1 ) ) THEN
         INFO = -1
      ELSE IF( NL.LT.1 ) THEN
         INFO = -2
      ELSE IF( NR.LT.1 ) THEN
         INFO = -3
      ELSE IF( ( SQRE.LT.0 ) .OR. ( SQRE.GT.1 ) ) THEN
         INFO = -4
      END IF
*
      N = NL + NR + 1
*
      IF( NRHS.LT.1 ) THEN
         INFO = -5
      ELSE IF( LDB.LT.N ) THEN
         INFO = -7
      ELSE IF( LDBX.LT.N ) THEN
         INFO = -9
      ELSE IF( GIVPTR.LT.0 ) THEN
         INFO = -11
      ELSE IF( LDGCOL.LT.N ) THEN
         INFO = -13
      ELSE IF( LDGNUM.LT.N ) THEN
         INFO = -15
      ELSE IF( K.LT.1 ) THEN
         INFO = -20
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'ZLALS0', -INFO )
         RETURN
      END IF
*
      M = N + SQRE
      NLP1 = NL + 1
*
      IF( ICOMPQ.EQ.0 ) THEN
*
*        Apply back orthogonal transformations from the left.
*
*        Step (1L): apply back the Givens rotations performed.
*
         DO 10 I = 1, GIVPTR
            CALL ZDROT( NRHS, B( GIVCOL( I, 2 ), 1 ), LDB,
     $                  B( GIVCOL( I, 1 ), 1 ), LDB, GIVNUM( I, 2 ),
     $                  GIVNUM( I, 1 ) )
   10    CONTINUE
*
*        Step (2L): permute rows of B.
*
         CALL ZCOPY( NRHS, B( NLP1, 1 ), LDB, BX( 1, 1 ), LDBX )
         DO 20 I = 2, N
            CALL ZCOPY( NRHS, B( PERM( I ), 1 ), LDB, BX( I, 1 ), LDBX )
   20    CONTINUE
*
*        Step (3L): apply the inverse of the left singular vector
*        matrix to BX.
*
         IF( K.EQ.1 ) THEN
            CALL ZCOPY( NRHS, BX, LDBX, B, LDB )
            IF( Z( 1 ).LT.ZERO ) THEN
               CALL ZDSCAL( NRHS, NEGONE, B, LDB )
            END IF
         ELSE
            DO 100 J = 1, K
               DIFLJ = DIFL( J )
               DJ = POLES( J, 1 )
               DSIGJ = -POLES( J, 2 )
               IF( J.LT.K ) THEN
                  DIFRJ = -DIFR( J, 1 )
                  DSIGJP = -POLES( J+1, 2 )
               END IF
               IF( ( Z( J ).EQ.ZERO ) .OR. ( POLES( J, 2 ).EQ.ZERO ) )
     $              THEN
                  RWORK( J ) = ZERO
               ELSE
                  RWORK( J ) = -POLES( J, 2 )*Z( J ) / DIFLJ /
     $                         ( POLES( J, 2 )+DJ )
               END IF
               DO 30 I = 1, J - 1
                  IF( ( Z( I ).EQ.ZERO ) .OR.
     $                ( POLES( I, 2 ).EQ.ZERO ) ) THEN
                     RWORK( I ) = ZERO
                  ELSE
                     RWORK( I ) = POLES( I, 2 )*Z( I ) /
     $                            ( DLAMC3( POLES( I, 2 ), DSIGJ )-
     $                            DIFLJ ) / ( POLES( I, 2 )+DJ )
                  END IF
   30          CONTINUE
               DO 40 I = J + 1, K
                  IF( ( Z( I ).EQ.ZERO ) .OR.
     $                ( POLES( I, 2 ).EQ.ZERO ) ) THEN
                     RWORK( I ) = ZERO
                  ELSE
                     RWORK( I ) = POLES( I, 2 )*Z( I ) /
     $                            ( DLAMC3( POLES( I, 2 ), DSIGJP )+
     $                            DIFRJ ) / ( POLES( I, 2 )+DJ )
                  END IF
   40          CONTINUE
               RWORK( 1 ) = NEGONE
               TEMP = DNRM2( K, RWORK, 1 )
*
*              Since B and BX are complex, the following call to DGEMV
*              is performed in two steps (real and imaginary parts).
*
*              CALL DGEMV( 'T', K, NRHS, ONE, BX, LDBX, WORK, 1, ZERO,
*    $                     B( J, 1 ), LDB )
*
               I = K + NRHS*2
               DO 60 JCOL = 1, NRHS
                  DO 50 JROW = 1, K
                     I = I + 1
                     RWORK( I ) = DBLE( BX( JROW, JCOL ) )
   50             CONTINUE
   60          CONTINUE
               CALL DGEMV( 'T', K, NRHS, ONE, RWORK( 1+K+NRHS*2 ), K,
     $                     RWORK( 1 ), 1, ZERO, RWORK( 1+K ), 1 )
               I = K + NRHS*2
               DO 80 JCOL = 1, NRHS
                  DO 70 JROW = 1, K
                     I = I + 1
                     RWORK( I ) = DIMAG( BX( JROW, JCOL ) )
   70             CONTINUE
   80          CONTINUE
               CALL DGEMV( 'T', K, NRHS, ONE, RWORK( 1+K+NRHS*2 ), K,
     $                     RWORK( 1 ), 1, ZERO, RWORK( 1+K+NRHS ), 1 )
               DO 90 JCOL = 1, NRHS
                  B( J, JCOL ) = DCMPLX( RWORK( JCOL+K ),
     $                           RWORK( JCOL+K+NRHS ) )
   90          CONTINUE
               CALL ZLASCL( 'G', 0, 0, TEMP, ONE, 1, NRHS, B( J, 1 ),
     $                      LDB, INFO )
  100       CONTINUE
         END IF
*
*        Move the deflated rows of BX to B also.
*
         IF( K.LT.MAX( M, N ) )
     $      CALL ZLACPY( 'A', N-K, NRHS, BX( K+1, 1 ), LDBX,
     $                   B( K+1, 1 ), LDB )
      ELSE
*
*        Apply back the right orthogonal transformations.
*
*        Step (1R): apply back the new right singular vector matrix
*        to B.
*
         IF( K.EQ.1 ) THEN
            CALL ZCOPY( NRHS, B, LDB, BX, LDBX )
         ELSE
            DO 180 J = 1, K
               DSIGJ = POLES( J, 2 )
               IF( Z( J ).EQ.ZERO ) THEN
                  RWORK( J ) = ZERO
               ELSE
                  RWORK( J ) = -Z( J ) / DIFL( J ) /
     $                         ( DSIGJ+POLES( J, 1 ) ) / DIFR( J, 2 )
               END IF
               DO 110 I = 1, J - 1
                  IF( Z( J ).EQ.ZERO ) THEN
                     RWORK( I ) = ZERO
                  ELSE
                     RWORK( I ) = Z( J ) / ( DLAMC3( DSIGJ, -POLES( I+1,
     $                            2 ) )-DIFR( I, 1 ) ) /
     $                            ( DSIGJ+POLES( I, 1 ) ) / DIFR( I, 2 )
                  END IF
  110          CONTINUE
               DO 120 I = J + 1, K
                  IF( Z( J ).EQ.ZERO ) THEN
                     RWORK( I ) = ZERO
                  ELSE
                     RWORK( I ) = Z( J ) / ( DLAMC3( DSIGJ, -POLES( I,
     $                            2 ) )-DIFL( I ) ) /
     $                            ( DSIGJ+POLES( I, 1 ) ) / DIFR( I, 2 )
                  END IF
  120          CONTINUE
*
*              Since B and BX are complex, the following call to DGEMV
*              is performed in two steps (real and imaginary parts).
*
*              CALL DGEMV( 'T', K, NRHS, ONE, B, LDB, WORK, 1, ZERO,
*    $                     BX( J, 1 ), LDBX )
*
               I = K + NRHS*2
               DO 140 JCOL = 1, NRHS
                  DO 130 JROW = 1, K
                     I = I + 1
                     RWORK( I ) = DBLE( B( JROW, JCOL ) )
  130             CONTINUE
  140          CONTINUE
               CALL DGEMV( 'T', K, NRHS, ONE, RWORK( 1+K+NRHS*2 ), K,
     $                     RWORK( 1 ), 1, ZERO, RWORK( 1+K ), 1 )
               I = K + NRHS*2
               DO 160 JCOL = 1, NRHS
                  DO 150 JROW = 1, K
                     I = I + 1
                     RWORK( I ) = DIMAG( B( JROW, JCOL ) )
  150             CONTINUE
  160          CONTINUE
               CALL DGEMV( 'T', K, NRHS, ONE, RWORK( 1+K+NRHS*2 ), K,
     $                     RWORK( 1 ), 1, ZERO, RWORK( 1+K+NRHS ), 1 )
               DO 170 JCOL = 1, NRHS
                  BX( J, JCOL ) = DCMPLX( RWORK( JCOL+K ),
     $                            RWORK( JCOL+K+NRHS ) )
  170          CONTINUE
  180       CONTINUE
         END IF
*
*        Step (2R): if SQRE = 1, apply back the rotation that is
*        related to the right null space of the subproblem.
*
         IF( SQRE.EQ.1 ) THEN
            CALL ZCOPY( NRHS, B( M, 1 ), LDB, BX( M, 1 ), LDBX )
            CALL ZDROT( NRHS, BX( 1, 1 ), LDBX, BX( M, 1 ), LDBX, C, S )
         END IF
         IF( K.LT.MAX( M, N ) )
     $      CALL ZLACPY( 'A', N-K, NRHS, B( K+1, 1 ), LDB, BX( K+1, 1 ),
     $                   LDBX )
*
*        Step (3R): permute rows of B.
*
         CALL ZCOPY( NRHS, BX( 1, 1 ), LDBX, B( NLP1, 1 ), LDB )
         IF( SQRE.EQ.1 ) THEN
            CALL ZCOPY( NRHS, BX( M, 1 ), LDBX, B( M, 1 ), LDB )
         END IF
         DO 190 I = 2, N
            CALL ZCOPY( NRHS, BX( I, 1 ), LDBX, B( PERM( I ), 1 ), LDB )
  190    CONTINUE
*
*        Step (4R): apply back the Givens rotations performed.
*
         DO 200 I = GIVPTR, 1, -1
            CALL ZDROT( NRHS, B( GIVCOL( I, 2 ), 1 ), LDB,
     $                  B( GIVCOL( I, 1 ), 1 ), LDB, GIVNUM( I, 2 ),
     $                  -GIVNUM( I, 1 ) )
  200    CONTINUE
      END IF
*
      RETURN
*
*     End of ZLALS0
*
      END

      subroutine rdsstoi (nyrstrt,nyrlast,mlon,nlat,info,sst)

c read one month/week/whatever grid at a time

c     The monthly optimum interpolation (OI) fields are derived by a linear
c     interpolation of the weekly OI fields to daily fields then averaging
c     the daily values over a month. The monthly fields are in the same
c     format and spatial resolution as the weekly fields.

      integer nyrstrt, nyrlast          ! input  (used to select data)
      integer mlon, nlat                ! input  (used to error check)
      real    sst(360,180)              ! output                    
      integer info(9)                   ! output (date info + error)
                                        !         info(9) has error info

c     Program to read WEEKLY, MONTHLY compocp site, and CLIMATOLOGY grids.
c     All grids are 1x1, (360,180), (longitude,latitude).
c
c     Each global grid is preceeded by a single header record.  The table
c     below shows the meaning of the header record variables for each of
c     the three SST data products.
c
c              IYRST IMST IDST       IYREND IMEND IDEND     NDAYS    INDEX
c           -----------------------  -------------------    ------    ----
c    WEEKLY (start date, yr/mn/day) (end date, yr/mn/day)      7        ??
c    MONTHLY    (yr/mn/1)              (yr/mn/day)          days/mn     ??
c    CLIM.      (99/mn/1)              (99/mn/day)          days/mn      0
c           --------------------------------------------------------------
c           Note: numeric constants denote fixed place-holder values
c   
c
c  Following the header are integer SST values in degrees C time 100, with
c  format (20I4).
c  These data are read into integer array ISST, converted to degree C, and 
c  placed into real array SST.
c
c  The geo-location of the SST array elements are:
c    SST(1,1)     = 179.5W, 89.5S
c    SST(1,2)     = 179.5W, 88.5S
c    SST(2,1)     = 178.5W, 89.5S
c    SST(360,180) = 179.5E, 89.5N
c
c  NOTES: 
c     1) all values less than or equal to -1.78 C are ice
c     2) a land/sea mask should be used to mask out OI SST analyzed values
c        not located in the ocean, e.g. program ls.f and data file ls.dat

      integer isst(360,180)             ! local
      character*80 fil, dir

      integer igrd
      data    igrd /0/
      save    igrd

      if (igrd.eq.0) then
          open  (unit=10,file='SSTOI'
     +          ,access='sequential',form='formatted')
      endif

      if (mlon.ne.360 .or. nlat.ne.180) then
          write (*,'('' RDSSTOI: BAD MLON, NLAT='',2i8)') mlon, nlat
          stop
      endif

c     read the header and a grid
100   read(10,'(8i5)',end=200) iyrst,imst,idst,iyrend
     +                        ,imend,idend,ndays,index
      read(10,'(20i4)',end=200) isst

      if (iyrst .lt.nyrstrt) go to 100
      if (iyrend.gt.nyrlast) then      ! no sense reading more
          do i=1,9
             info(i) = -999            ! error code -999
          enddo
          return
      endif

      do i=1,360
        do j=1,180
          sst(i,j) = 0.01*float(isst(i,j))
        enddo
      enddo

      igrd = igrd + 1

c      if (igrd.le.10) print 7,igrd,
c     * iyrst,imst,idst,iyrend,imend,idend,sst(70,80)
c    7  format ('RDSSTOI: igrd =',i3,3x,'dates =',3i3,' - ',3i3,3x
c     *        ,'sst (110.5w,10.5s) =',f6.2)

      info(1) = iyrst
      info(2) = imst
      info(3) = idst
      info(4) = iyrend
      info(5) = imend
      info(6) = idend
      info(7) = ndays
      info(8) = index
      info(9) = 0           ! use for error code
      return                                                    

  200 continue
c     write (*,'('' RDSSTOI: EOF encountered'')') 

      igrd    = 0
      info(9) = 999         ! eof
      close (10)

      return
      end       
c ---------------------------------------------------------------
      subroutine wrsstoi (sstg,ilon,jlat,nmos,nyrs
     +                   ,nyrstrt,nyrlast,twave,ier)

c write the gaussian sst grids via fortran binary write

      integer ilon,jlat,nmos,nyrs,nyrstrt,nyrlast,twave
      real sstg(ilon,jlat,nmos,nyrs)
      character*80 fil, dir

      ier  = 0
      nyr1 = nyrstrt-1900
      nyr2 = nyrlast-1900
      
      dir  = '/fs/cgd/data0/shea/ncldata_output/$'
      ldir = index (dir,'$')-1
      write (fil,'(''sstoi_'',i2,i2,''_T'',i2,''$'')') nyr1,nyr2,twave  
      lfil = index (fil,'$')-1
 
      open  (unit=10,file=dir(1:ldir) // fil(1:lfil)
     +              ,access='sequential',form='unformatted', iostat=ios)
      if (ios.ne.0) then
          write (*,'(''FORTRAN: wrsstoi: open: ios='',i4)') ios
          ier = 1
          return 
      endif

      do nyr=1,nyrs
         nyear = nyr+nyrstrt-1
        do nmo=1,nmos
           write (10) ((sstg(il,jl,nmo,nyr),il=1,ilon),jl=1,jlat)
        enddo
      enddo

      close (10)

      return
      end
         

C
C $Id: agcurv.f,v 1.9 2008-07-27 00:14:33 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE AGCURV (XVEC,IIEX,YVEC,IIEY,NEXY,KDSH)
C
      DIMENSION XVEC(1),YVEC(1)
C
C AGCURV plots the curve defined by the points ((X(I),Y(I)),I=1,NEXY),
C where, if the primary parameter 'INVERT.' is zero,
C
C    X(I)=XVEC(1+(I-1)*IIEX) (unless IIEX=0, in which case X(I)=I), and
C    Y(I)=YVEC(1+(I-1)*IIEY) (unless IIEY=0, in which case Y(I)=I).
C
C If 'INVERT.' is non-zero, the definitions are interchanged, so that
C
C    X(I)=YVEC(1+(I-1)*IIEY) (unless IIEY=0, in which case X(I)=I), and
C    Y(I)=XVEC(1+(I-1)*IIEX) (unless IIEX=0, in which case Y(I)=I).
C
C If, for some I, X(I)=SVAL or Y(I)=SVAL, curve line segments having
C (X(I),Y(I)) as an endpoint are omitted.
C
C If the primary parameter 'WINDOW.' is zero, AGKURV is called; it does
C no windowing.  If 'WINDOW.' is non-zero, AGQURV is called; it omits
C portions of the curve which fall outside the current curve window.
C
C The argument KDSH specifies the dash pattern to be used.  If KDSH is
C negative, the function MOD(ABS(KDSH),26) is used to select a solid
C line interrupted by one of the alphabetic characters.  If KDSH is
C zero, the user is assumed to have done his own DASHD call.  If KDSH
C is positive, the function MOD(KDSH,NODP) is used to select one of the
C dash patterns in the parameter group 'DASH/PATTERNS.'.
C
C The following common block contains the AUTOGRAPH control parameters,
C all of which are real.  If it is changed, all of AUTOGRAPH (especially
C the routine AGSCAN) must be examined for possible side effects.
C
      COMMON /AGCONP/ QFRA,QSET,QROW,QIXY,QWND,QBAC , SVAL(2) ,
     +                XLGF,XRGF,YBGF,YTGF , XLGD,XRGD,YBGD,YTGD , SOGD ,
     +                XMIN,XMAX,QLUX,QOVX,QCEX,XLOW,XHGH ,
     +                YMIN,YMAX,QLUY,QOVY,QCEY,YLOW,YHGH ,
     +                QDAX(4),QSPA(4),PING(4),PINU(4),FUNS(4),QBTD(4),
     +                BASD(4),QMJD(4),QJDP(4),WMJL(4),WMJR(4),QMND(4),
     +                QNDP(4),WMNL(4),WMNR(4),QLTD(4),QLED(4),QLFD(4),
     +                QLOF(4),QLOS(4),DNLA(4),WCLM(4),WCLE(4) ,
     +                QODP,QCDP,WOCD,WODQ,QDSH(26) ,
     +                     QDLB,QBIM,FLLB(10,8),QBAN ,
     +                QLLN,TCLN,QNIM,FLLN(6,16),QNAN ,
     +                XLGW,XRGW,YBGW,YTGW , XLUW,XRUW,YBUW,YTUW ,
     +                XLCW,XRCW,YBCW,YTCW , WCWP,HCWP,SCWP ,
     +                XBGA(4),YBGA(4),UBGA(4),XNDA(4),YNDA(4),UNDA(4),
     +                QBTP(4),BASE(4),QMNT(4),QLTP(4),QLEX(4),QLFL(4),
     +                QCIM(4),QCIE(4),RFNL(4),WNLL(4),WNLR(4),WNLB(4),
     +                WNLE(4),QLUA(4) ,
     +                RBOX(6),DBOX(6,4),SBOX(6,4)
      SAVE /AGCONP/
C
C DASH receives alphabetic dash patterns.
C
      CHARACTER*10 DASH
C
C ALPH contains an alphabet.
C
      CHARACTER*26 ALPH
C
      DATA ALPH / 'ABCDEFGHIJKLMNOPQRSTUVWXYZ' /
C
C Do a call forcing a BLOCKDATA to be loaded from a binary library.
C
      CALL AGDFLT
C
C Check for an alphabetic dash pattern.
C
      IF (KDSH.LT.0) THEN
        IDSH=MOD(-KDSH-1,26)+1
        IPSN=MOD(3*IDSH-1,10)+1
        DASH='$$$$$$$$$$'
        DASH(IPSN:IPSN)=ALPH(IDSH:IDSH)
        CALL AGSTCH (DASH,10,IDCS)
        CALL AGDASH (REAL(IDCS),WODQ,WOCD,SCWP)
        CALL AGDLCH (IDCS)
C
C Check for a dash pattern from the group "DASH/PATTERNS."
C
      ELSE IF (KDSH.GT.0) THEN
        IDSH=MOD(KDSH-1,INT(QODP))+1
        CALL AGDASH (QDSH(IDSH),WODQ,WOCD,SCWP)
C
      END IF
C
C Now that the dash pattern is determined, do the SET call.
C
      CALL PLOTIT (0,0,2)
      CALL SET (XLCW,XRCW,YBCW,YTCW,XLUW,XRUW,YBUW,YTUW,
     +                            1+ABS(INT(QLUX))*2+ABS(INT(QLUY)))
C
C Give the user a chance to modify the curve (by changing line style,
C color, etc.).
C
      CALL AGCHCU (0,KDSH)
C
C Decide whether AGKURV or AGQURV is to draw the curve.
C
      IF (QWND.EQ.0.) THEN
C
C No windowing requested - AGKURV is used.
C
        IF (QIXY.EQ.0.) THEN
          CALL AGKURV (XVEC,IIEX,YVEC,IIEY,NEXY,SVAL(1))
        ELSE
          CALL AGKURV (YVEC,IIEY,XVEC,IIEX,NEXY,SVAL(1))
        END IF
C
      ELSE
C
C Windowing requested - AGQURV is used.
C
        IF (QIXY.EQ.0.) THEN
          CALL AGQURV (XVEC,IIEX,YVEC,IIEY,NEXY,SVAL(1))
        ELSE
          CALL AGQURV (YVEC,IIEY,XVEC,IIEX,NEXY,SVAL(1))
        END IF
C
      END IF
C
C Give the user a chance to change back what he changed above.
C
      CALL AGCHCU (1,KDSH)
C
C Done.
C
      RETURN
C
      END

C
C $Id: aggetp.f,v 1.6 2008-07-27 00:14:34 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE AGGETP (TPID,FURA,LURA)
C
      CHARACTER*(*) TPID
      DIMENSION FURA(1)
C
C The routine AGGETP returns to the user the AUTOGRAPH parameter(s)
C specified by the parameter identifier TPID.  The arguments are as
C follows:
C
C -- TPID is the parameter identifier, a string of keywords separated
C    from each other by slashes and followed by a period.
C
C -- FURA is the user array which is to receive the desired parameter(s)
C    specified by TPID.
C
C -- LURA is the length of the user array FURA.
C
C The following common block contains the AUTOGRAPH control parameters,
C all of which are real.  If it is changed, all of AUTOGRAPH (especially
C the routine AGSCAN) must be examined for possible side effects.
C
      COMMON /AGCONP/ QFRA,QSET,QROW,QIXY,QWND,QBAC , SVAL(2) ,
     +                XLGF,XRGF,YBGF,YTGF , XLGD,XRGD,YBGD,YTGD , SOGD ,
     +                XMIN,XMAX,QLUX,QOVX,QCEX,XLOW,XHGH ,
     +                YMIN,YMAX,QLUY,QOVY,QCEY,YLOW,YHGH ,
     +                QDAX(4),QSPA(4),PING(4),PINU(4),FUNS(4),QBTD(4),
     +                BASD(4),QMJD(4),QJDP(4),WMJL(4),WMJR(4),QMND(4),
     +                QNDP(4),WMNL(4),WMNR(4),QLTD(4),QLED(4),QLFD(4),
     +                QLOF(4),QLOS(4),DNLA(4),WCLM(4),WCLE(4) ,
     +                QODP,QCDP,WOCD,WODQ,QDSH(26) ,
     +                     QDLB,QBIM,FLLB(10,8),QBAN ,
     +                QLLN,TCLN,QNIM,FLLN(6,16),QNAN ,
     +                XLGW,XRGW,YBGW,YTGW , XLUW,XRUW,YBUW,YTUW ,
     +                XLCW,XRCW,YBCW,YTCW , WCWP,HCWP,SCWP ,
     +                XBGA(4),YBGA(4),UBGA(4),XNDA(4),YNDA(4),UNDA(4),
     +                QBTP(4),BASE(4),QMNT(4),QLTP(4),QLEX(4),QLFL(4),
     +                QCIM(4),QCIE(4),RFNL(4),WNLL(4),WNLR(4),WNLB(4),
     +                WNLE(4),QLUA(4) ,
     +                RBOX(6),DBOX(6,4),SBOX(6,4)
      SAVE /AGCONP/
C
C The following common block contains other AUTOGRAPH variables, both
C real and integer, which are not control parameters.
C
      COMMON /AGORIP/ SMRL , ISLD , MWCL,MWCM,MWCE,MDLA,MWCD,MWDQ ,
     +                INIF
      SAVE /AGORIP/
C
C Define the array DUMI, which allows access to the parameter list as
C an array.
C
      DIMENSION DUMI(485)
      EQUIVALENCE (QFRA,DUMI)
C
C If initialization has not yet been done, do it.
C
      IF (INIF.EQ.0) THEN
        CALL AGINIT
      END IF
C
C The routine AGSCAN is called to scan the parameter identifier and to
C return three quantities describing the AUTOGRAPH parameters desired.
C
      CALL AGSCAN (TPID,LOPA,NIPA,IIPA)
C
C Determine the number of elements to transfer.
C
      NURA=MAX(1,MIN(LURA,NIPA))
C
C Transfer the desired parameters to the user array.
C
      IDMI=LOPA-IIPA
C
      DO 101 IURA=1,NURA
        IDMI=IDMI+IIPA
        FURA(IURA)=DUMI(IDMI)
  101 CONTINUE
C
C If the current label name is being gotten, return its identifier.
C
      CALL AGSCAN ('LABE/NAME.',LOLN,NILN,IILN)
      IF (LOPA.EQ.LOLN.AND.NIPA.EQ.NILN.AND.QBAN.NE.0.) THEN
        LBAN=INT(QBAN)
        FURA(1)=FLLB(1,LBAN)
      END IF
C
C Done.
C
      RETURN
C
      END

      SUBROUTINE DGBTRF( M, N, KL, KU, AB, LDAB, IPIV, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     February 29, 1992
*
*     .. Scalar Arguments ..
      INTEGER            INFO, KL, KU, LDAB, M, N
*     ..
*     .. Array Arguments ..
      INTEGER            IPIV( * )
      DOUBLE PRECISION   AB( LDAB, * )
*     ..
*
*  Purpose
*  =======
*
*  DGBTRF computes an LU factorization of a real m-by-n band matrix A
*  using partial pivoting with row interchanges.
*
*  This is the blocked version of the algorithm, calling Level 3 BLAS.
*
*  Arguments
*  =========
*
*  M       (input) INTEGER
*          The number of rows of the matrix A.  M >= 0.
*
*  N       (input) INTEGER
*          The number of columns of the matrix A.  N >= 0.
*
*  KL      (input) INTEGER
*          The number of subdiagonals within the band of A.  KL >= 0.
*
*  KU      (input) INTEGER
*          The number of superdiagonals within the band of A.  KU >= 0.
*
*  AB      (input/output) DOUBLE PRECISION array, dimension (LDAB,N)
*          On entry, the matrix A in band storage, in rows KL+1 to
*          2*KL+KU+1; rows 1 to KL of the array need not be set.
*          The j-th column of A is stored in the j-th column of the
*          array AB as follows:
*          AB(kl+ku+1+i-j,j) = A(i,j) for max(1,j-ku)<=i<=min(m,j+kl)
*
*          On exit, details of the factorization: U is stored as an
*          upper triangular band matrix with KL+KU superdiagonals in
*          rows 1 to KL+KU+1, and the multipliers used during the
*          factorization are stored in rows KL+KU+2 to 2*KL+KU+1.
*          See below for further details.
*
*  LDAB    (input) INTEGER
*          The leading dimension of the array AB.  LDAB >= 2*KL+KU+1.
*
*  IPIV    (output) INTEGER array, dimension (min(M,N))
*          The pivot indices; for 1 <= i <= min(M,N), row i of the
*          matrix was interchanged with row IPIV(i).
*
*  INFO    (output) INTEGER
*          = 0: successful exit
*          < 0: if INFO = -i, the i-th argument had an illegal value
*          > 0: if INFO = +i, U(i,i) is exactly zero. The factorization
*               has been completed, but the factor U is exactly
*               singular, and division by zero will occur if it is used
*               to solve a system of equations.
*
*  Further Details
*  ===============
*
*  The band storage scheme is illustrated by the following example, when
*  M = N = 6, KL = 2, KU = 1:
*
*  On entry:                       On exit:
*
*      *    *    *    +    +    +       *    *    *   u14  u25  u36
*      *    *    +    +    +    +       *    *   u13  u24  u35  u46
*      *   a12  a23  a34  a45  a56      *   u12  u23  u34  u45  u56
*     a11  a22  a33  a44  a55  a66     u11  u22  u33  u44  u55  u66
*     a21  a32  a43  a54  a65   *      m21  m32  m43  m54  m65   *
*     a31  a42  a53  a64   *    *      m31  m42  m53  m64   *    *
*
*  Array elements marked * are not used by the routine; elements marked
*  + need not be set on entry, but are required by the routine to store
*  elements of U because of fill-in resulting from the row interchanges.
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ONE, ZERO
      PARAMETER          ( ONE = 1.0D+0, ZERO = 0.0D+0 )
      INTEGER            NBMAX, LDWORK
      PARAMETER          ( NBMAX = 64, LDWORK = NBMAX+1 )
*     ..
*     .. Local Scalars ..
      INTEGER            I, I2, I3, II, IP, J, J2, J3, JB, JJ, JM, JP,
     $                   JU, K2, KM, KV, NB, NW
      DOUBLE PRECISION   TEMP
*     ..
*     .. Local Arrays ..
      DOUBLE PRECISION   WORK13( LDWORK, NBMAX ),
     $                   WORK31( LDWORK, NBMAX )
*     ..
*     .. External Functions ..
      INTEGER            IDAMAX, ILAENV
      EXTERNAL           IDAMAX, ILAENV
*     ..
*     .. External Subroutines ..
      EXTERNAL           DCOPY, DGBTF2, DGEMM, DGER, DLASWP, DSCAL,
     $                   DSWAP, DTRSM, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN
*     ..
*     .. Executable Statements ..
*
*     KV is the number of superdiagonals in the factor U, allowing for
*     fill-in
*
      KV = KU + KL
*
*     Test the input parameters.
*
      INFO = 0
      IF( M.LT.0 ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( KL.LT.0 ) THEN
         INFO = -3
      ELSE IF( KU.LT.0 ) THEN
         INFO = -4
      ELSE IF( LDAB.LT.KL+KV+1 ) THEN
         INFO = -6
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DGBTRF', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( M.EQ.0 .OR. N.EQ.0 )
     $   RETURN
*
*     Determine the block size for this environment
*
      NB = ILAENV( 1, 'DGBTRF', ' ', M, N, KL, KU )
*
*     The block size must not exceed the limit set by the size of the
*     local arrays WORK13 and WORK31.
*
      NB = MIN( NB, NBMAX )
*
      IF( NB.LE.1 .OR. NB.GT.KL ) THEN
*
*        Use unblocked code
*
         CALL DGBTF2( M, N, KL, KU, AB, LDAB, IPIV, INFO )
      ELSE
*
*        Use blocked code
*
*        Zero the superdiagonal elements of the work array WORK13
*
         DO 20 J = 1, NB
            DO 10 I = 1, J - 1
               WORK13( I, J ) = ZERO
   10       CONTINUE
   20    CONTINUE
*
*        Zero the subdiagonal elements of the work array WORK31
*
         DO 40 J = 1, NB
            DO 30 I = J + 1, NB
               WORK31( I, J ) = ZERO
   30       CONTINUE
   40    CONTINUE
*
*        Gaussian elimination with partial pivoting
*
*        Set fill-in elements in columns KU+2 to KV to zero
*
         DO 60 J = KU + 2, MIN( KV, N )
            DO 50 I = KV - J + 2, KL
               AB( I, J ) = ZERO
   50       CONTINUE
   60    CONTINUE
*
*        JU is the index of the last column affected by the current
*        stage of the factorization
*
         JU = 1
*
         DO 180 J = 1, MIN( M, N ), NB
            JB = MIN( NB, MIN( M, N )-J+1 )
*
*           The active part of the matrix is partitioned
*
*              A11   A12   A13
*              A21   A22   A23
*              A31   A32   A33
*
*           Here A11, A21 and A31 denote the current block of JB columns
*           which is about to be factorized. The number of rows in the
*           partitioning are JB, I2, I3 respectively, and the numbers
*           of columns are JB, J2, J3. The superdiagonal elements of A13
*           and the subdiagonal elements of A31 lie outside the band.
*
            I2 = MIN( KL-JB, M-J-JB+1 )
            I3 = MIN( JB, M-J-KL+1 )
*
*           J2 and J3 are computed after JU has been updated.
*
*           Factorize the current block of JB columns
*
            DO 80 JJ = J, J + JB - 1
*
*              Set fill-in elements in column JJ+KV to zero
*
               IF( JJ+KV.LE.N ) THEN
                  DO 70 I = 1, KL
                     AB( I, JJ+KV ) = ZERO
   70             CONTINUE
               END IF
*
*              Find pivot and test for singularity. KM is the number of
*              subdiagonal elements in the current column.
*
               KM = MIN( KL, M-JJ )
               JP = IDAMAX( KM+1, AB( KV+1, JJ ), 1 )
               IPIV( JJ ) = JP + JJ - J
               IF( AB( KV+JP, JJ ).NE.ZERO ) THEN
                  JU = MAX( JU, MIN( JJ+KU+JP-1, N ) )
                  IF( JP.NE.1 ) THEN
*
*                    Apply interchange to columns J to J+JB-1
*
                     IF( JP+JJ-1.LT.J+KL ) THEN
*
                        CALL DSWAP( JB, AB( KV+1+JJ-J, J ), LDAB-1,
     $                              AB( KV+JP+JJ-J, J ), LDAB-1 )
                     ELSE
*
*                       The interchange affects columns J to JJ-1 of A31
*                       which are stored in the work array WORK31
*
                        CALL DSWAP( JJ-J, AB( KV+1+JJ-J, J ), LDAB-1,
     $                              WORK31( JP+JJ-J-KL, 1 ), LDWORK )
                        CALL DSWAP( J+JB-JJ, AB( KV+1, JJ ), LDAB-1,
     $                              AB( KV+JP, JJ ), LDAB-1 )
                     END IF
                  END IF
*
*                 Compute multipliers
*
                  CALL DSCAL( KM, ONE / AB( KV+1, JJ ), AB( KV+2, JJ ),
     $                        1 )
*
*                 Update trailing submatrix within the band and within
*                 the current block. JM is the index of the last column
*                 which needs to be updated.
*
                  JM = MIN( JU, J+JB-1 )
                  IF( JM.GT.JJ )
     $               CALL DGER( KM, JM-JJ, -ONE, AB( KV+2, JJ ), 1,
     $                          AB( KV, JJ+1 ), LDAB-1,
     $                          AB( KV+1, JJ+1 ), LDAB-1 )
               ELSE
*
*                 If pivot is zero, set INFO to the index of the pivot
*                 unless a zero pivot has already been found.
*
                  IF( INFO.EQ.0 )
     $               INFO = JJ
               END IF
*
*              Copy current column of A31 into the work array WORK31
*
               NW = MIN( JJ-J+1, I3 )
               IF( NW.GT.0 )
     $            CALL DCOPY( NW, AB( KV+KL+1-JJ+J, JJ ), 1,
     $                        WORK31( 1, JJ-J+1 ), 1 )
   80       CONTINUE
            IF( J+JB.LE.N ) THEN
*
*              Apply the row interchanges to the other blocks.
*
               J2 = MIN( JU-J+1, KV ) - JB
               J3 = MAX( 0, JU-J-KV+1 )
*
*              Use DLASWP to apply the row interchanges to A12, A22, and
*              A32.
*
               CALL DLASWP( J2, AB( KV+1-JB, J+JB ), LDAB-1, 1, JB,
     $                      IPIV( J ), 1 )
*
*              Adjust the pivot indices.
*
               DO 90 I = J, J + JB - 1
                  IPIV( I ) = IPIV( I ) + J - 1
   90          CONTINUE
*
*              Apply the row interchanges to A13, A23, and A33
*              columnwise.
*
               K2 = J - 1 + JB + J2
               DO 110 I = 1, J3
                  JJ = K2 + I
                  DO 100 II = J + I - 1, J + JB - 1
                     IP = IPIV( II )
                     IF( IP.NE.II ) THEN
                        TEMP = AB( KV+1+II-JJ, JJ )
                        AB( KV+1+II-JJ, JJ ) = AB( KV+1+IP-JJ, JJ )
                        AB( KV+1+IP-JJ, JJ ) = TEMP
                     END IF
  100             CONTINUE
  110          CONTINUE
*
*              Update the relevant part of the trailing submatrix
*
               IF( J2.GT.0 ) THEN
*
*                 Update A12
*
                  CALL DTRSM( 'Left', 'Lower', 'No transpose', 'Unit',
     $                        JB, J2, ONE, AB( KV+1, J ), LDAB-1,
     $                        AB( KV+1-JB, J+JB ), LDAB-1 )
*
                  IF( I2.GT.0 ) THEN
*
*                    Update A22
*
                     CALL DGEMM( 'No transpose', 'No transpose', I2, J2,
     $                           JB, -ONE, AB( KV+1+JB, J ), LDAB-1,
     $                           AB( KV+1-JB, J+JB ), LDAB-1, ONE,
     $                           AB( KV+1, J+JB ), LDAB-1 )
                  END IF
*
                  IF( I3.GT.0 ) THEN
*
*                    Update A32
*
                     CALL DGEMM( 'No transpose', 'No transpose', I3, J2,
     $                           JB, -ONE, WORK31, LDWORK,
     $                           AB( KV+1-JB, J+JB ), LDAB-1, ONE,
     $                           AB( KV+KL+1-JB, J+JB ), LDAB-1 )
                  END IF
               END IF
*
               IF( J3.GT.0 ) THEN
*
*                 Copy the lower triangle of A13 into the work array
*                 WORK13
*
                  DO 130 JJ = 1, J3
                     DO 120 II = JJ, JB
                        WORK13( II, JJ ) = AB( II-JJ+1, JJ+J+KV-1 )
  120                CONTINUE
  130             CONTINUE
*
*                 Update A13 in the work array
*
                  CALL DTRSM( 'Left', 'Lower', 'No transpose', 'Unit',
     $                        JB, J3, ONE, AB( KV+1, J ), LDAB-1,
     $                        WORK13, LDWORK )
*
                  IF( I2.GT.0 ) THEN
*
*                    Update A23
*
                     CALL DGEMM( 'No transpose', 'No transpose', I2, J3,
     $                           JB, -ONE, AB( KV+1+JB, J ), LDAB-1,
     $                           WORK13, LDWORK, ONE, AB( 1+JB, J+KV ),
     $                           LDAB-1 )
                  END IF
*
                  IF( I3.GT.0 ) THEN
*
*                    Update A33
*
                     CALL DGEMM( 'No transpose', 'No transpose', I3, J3,
     $                           JB, -ONE, WORK31, LDWORK, WORK13,
     $                           LDWORK, ONE, AB( 1+KL, J+KV ), LDAB-1 )
                  END IF
*
*                 Copy the lower triangle of A13 back into place
*
                  DO 150 JJ = 1, J3
                     DO 140 II = JJ, JB
                        AB( II-JJ+1, JJ+J+KV-1 ) = WORK13( II, JJ )
  140                CONTINUE
  150             CONTINUE
               END IF
            ELSE
*
*              Adjust the pivot indices.
*
               DO 160 I = J, J + JB - 1
                  IPIV( I ) = IPIV( I ) + J - 1
  160          CONTINUE
            END IF
*
*           Partially undo the interchanges in the current block to
*           restore the upper triangular form of A31 and copy the upper
*           triangle of A31 back into place
*
            DO 170 JJ = J + JB - 1, J, -1
               JP = IPIV( JJ ) - JJ + 1
               IF( JP.NE.1 ) THEN
*
*                 Apply interchange to columns J to JJ-1
*
                  IF( JP+JJ-1.LT.J+KL ) THEN
*
*                    The interchange does not affect A31
*
                     CALL DSWAP( JJ-J, AB( KV+1+JJ-J, J ), LDAB-1,
     $                           AB( KV+JP+JJ-J, J ), LDAB-1 )
                  ELSE
*
*                    The interchange does affect A31
*
                     CALL DSWAP( JJ-J, AB( KV+1+JJ-J, J ), LDAB-1,
     $                           WORK31( JP+JJ-J-KL, 1 ), LDWORK )
                  END IF
               END IF
*
*              Copy the current column of A31 back into place
*
               NW = MIN( I3, JJ-J+1 )
               IF( NW.GT.0 )
     $            CALL DCOPY( NW, WORK31( 1, JJ-J+1 ), 1,
     $                        AB( KV+KL+1-JJ+J, JJ ), 1 )
  170       CONTINUE
  180    CONTINUE
      END IF
*
      RETURN
*
*     End of DGBTRF
*
      END

C
C $Id: hlumpchln.f,v 1.10 2008-07-27 00:17:06 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE HLUMPCHLN (IFLG,ILTY,IOAL,IOAR,NPTS,PNTS)
C
        INTEGER IFLG,ILTY,IOAL,IOAR,NPTS
        REAL    PNTS(*)
C
C This routine is called by MDLNAM, MDLNDM, and MDLNDR before and after
C processing each line defined by a dataset.  IFLG is positive if a line
C is about to be processed, negative if a line was just processed; its
C absolute value is 1 if the call comes from MDLNAM, 2 if the call comes
C from MDLNDM, and 3 if the call comes from MDLNDR.  ILTY is the type of
C the line, IOAL is the identifier of the area to its left, and IOAR is
C the identifier of the area to its right.  NPTS is the number of points
C defining the line, and the array PNTS contains the lat/lon coordinates
C of the points.  HLUMPCHLN is meant to be replaced by an HLU developer;
C it may set line width and color and it may change the values of IOAL
C and IOAR; if it sets NPTS to zero, the line is deleted.
C
C Call MPCHLN, which is replaceable by an LLU user.
C
        CALL MPCHLN (IFLG,ILTY,IOAL,IOAR,NPTS,PNTS)
C
        RETURN
C
      END

C
C	$Id: conop4.f,v 1.4 2008-07-27 00:16:57 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CONOP4 (IOPT,ARRAY,ISIZE,IFORT)
C
C SET THE CONTRAN OPTIONS
C
C INPUT
C     IOPT  --  CHARACTER STRING OF OPTION VALUE
C     ARRAY --  CHARACTER INPUT DATA
C     ISIZE --  INTEGER INPUT
C     IFORT --  INTEGER.  THIS VALUE IS USED ONLY WHEN IOPT IS
C               "FMT=ON".  IN THIS CASE, IFORT IS THE TOTAL NUMBER
C               OF CHARACTERS TO BE PROCESSED BY THE FORMAT
C               STATEMENT.  FOR EXAMPLE, FOR THE FORMAT "F10.3",
C               IFORT SHOULD BE SET TO 10.
C
C  SET COMMON DATA EQUAL TO INPUT DATA
C
C
C
      COMMON /CONRA1/ CL(30)     ,NCL        ,OLDZ       ,PV(210)    ,
     1                FINC       ,HI         ,FLO
      COMMON /CONRA2/ REPEAT     ,EXTRAP     ,PER        ,MESS       ,
     1                ISCALE     ,LOOK       ,PLDVLS     ,GRD        ,
     2                CINC       ,CHILO      ,CON        ,LABON      ,
     3                PMIMX      ,SCALE      ,FRADV      ,EXTRI      ,
     4                BPSIZ      ,LISTOP
      COMMON /CONRA3/ IREC
      COMMON /CONRA4/ NCP        ,NCPSZ
      COMMON /CONRA5/ NIT        ,ITIPV
      COMMON /CONRA6/ XST        ,YST        ,XED        ,YED        ,
     1                STPSZ      ,IGRAD      ,IG         ,XRG        ,
     2                YRG        ,BORD       ,PXST       ,PYST       ,
     3                PXED       ,PYED       ,ITICK
      COMMON /CONR18/ TITLE      ,ICNT   ,ITLSIZ
      COMMON /CONR19/ IHIGH      ,INMAJ      ,INLAB      ,INDAT      ,
     1              LEN      ,IFMT       ,LEND       ,
     2                IFMTD      ,ISIZEP     ,INMIN
      COMMON /CONRA9/ ICOORD(500),NP         ,MXXY       ,TR         ,
     1                BR         ,TL         ,BL         ,CONV       ,
     2                XN         ,YN         ,ITLL       ,IBLL       ,
     3                ITRL       ,IBRL       ,XC         ,YC         ,
     4                ITLOC(210) ,JX         ,JY         ,ILOC       ,
     5                ISHFCT     ,XO         ,YO         ,IOC        ,NC
      COMMON /CONR10/ NT         ,NL         ,NTNL       ,JWIPT      ,
     1                JWIWL      ,JWIWP      ,JWIPL      ,IPR        ,
     2                ITPV
      COMMON /CONR20/ NREP       ,NCRT       ,ISIZEL     ,
     1                MINGAP     ,ISIZEM         ,
     2                TENS
      COMMON /CONR12/ IXMAX      ,IYMAX      ,XMAX       ,YMAX
      LOGICAL         REPEAT     ,EXTRAP     ,PER        ,MESS       ,
     1                LOOK       ,PLDVLS     ,GRD        ,LABON      ,
     2                PMIMX      ,FRADV      ,EXTRI      ,CINC       ,
     3                TITLE      ,LISTOP     ,CHILO      ,CON
      COMMON /CONR13/XVS(50),YVS(50),ICOUNT,SPVAL,SHIELD,
     1               SLDPLT
      LOGICAL SHIELD,SLDPLT
      COMMON /CONR14/LINEAR
      LOGICAL LINEAR
      COMMON /CONR15/ ISTRNG
        CHARACTER*64 ISTRNG
        COMMON /CONR16/ FORM
        CHARACTER*10 FORM
        COMMON /CONR17/ NDASH, IDASH, EDASH
        CHARACTER*10 NDASH, IDASH, EDASH
C
C
C
C  INTPR IS THE DASH PACKAGE COMMON BLOCK INTERFACE
C  NP11 IS NP IN ALL OTHER INTPR DEFINITIONS; NAME CHANGE BECAUSE OF
C  CONFLICT
C
      COMMON /INTPR/  IPAU       ,FPART      ,TENSN      ,NP11       ,
     1                SMALL      ,L1         ,ADDLR      ,ADDTB      ,
     2                MLLINE     ,ICLOSE
        CHARACTER*(*)  ARRAY
        CHARACTER*7  IOPT
        CHARACTER*2  TAG, OPT
C
        SAVE
C
C  DETERMINE THE OPTION DESIRED
C
      TAG = IOPT(1:2)
        IF (IOPT(3:3) .EQ. '=') THEN
            OPT = IOPT(4:5)
        ELSE
            OPT = IOPT(5:6)
        ENDIF
C
C  TITLE OPTION GET VALUE OF SWITCH
C
      IF (TAG .EQ. 'TL') THEN
C
C  SWITCH ON GET TITLE AND COUNT FROM INPUT
C
            IF (OPT .EQ. 'ON') THEN
              TITLE = .TRUE.
                ISTRNG = ARRAY
                  ICNT = ISIZE
              RETURN
C
C  SWITCH OFF OPTION DEACTIVATED
C
            ELSEIF (OPT .EQ. 'OF') THEN
              TITLE = .FALSE.
              RETURN
          ELSE
                  GOTO 120
            ENDIF
C
C  CHANGE DATA VALUE FORMAT
C
      ELSEIF (TAG .EQ. 'FM') THEN
C
C  SWITCH ON GET USER FORMAT
C
          IF (OPT .EQ. 'ON') THEN
                FORM = ARRAY
              LEN = ISIZE
              IFMT = IFORT
              RETURN
C
C SWITCH OFF SET FORMAT TO DEFAULT
C
            ELSEIF (OPT .EQ. 'OF') THEN
                FORM = '(G10.3)'
                  LEN = LEND
              IFMT = IFMTD
              RETURN
          ELSE
                  GOTO 120
            ENDIF
C
C  DASH PATTERN OPTION GET VALUE OF SWITCH
C
      ELSEIF (TAG .EQ. 'DA') THEN
C
C  SWITCH OFF DEFAULT PATTERNS
C
          IF (OPT .EQ. 'OF') THEN
                  NDASH = '$$$$$$$$$$'
                  EDASH = '$$$$$$$$$$'
                  IDASH = '$$$$$$$$$$'
                  RETURN
C
C  SWITCH ALL SET GTR,LSS,AND EQU TO SAME VALUE
C
          ELSEIF (OPT .EQ. 'AL') THEN
                  IDASH = ARRAY
                  EDASH = ARRAY
                  NDASH = ARRAY
                  RETURN
C
C  SWITCH SET TO POS CHANGE POS DASH PATTERN
C
          ELSEIF (OPT .EQ. 'GT') THEN
                  IDASH = ARRAY
                  RETURN
C
C  SWITCH SET TO NEG SET NEG DASH PATTERN
C
          ELSEIF (OPT .EQ. 'LS') THEN
                  NDASH = ARRAY
                  RETURN
C
C  SWITCH SET TO EQU SET EQUAL DASH PATTERN
C
          ELSEIF (OPT .EQ. 'EQ') THEN
                EDASH = ARRAY
                RETURN
          ELSE
                  GOTO 120
            ENDIF
        ELSE
            GOTO 120
        ENDIF
C
C  ERROR UNDEFINED OPTION DETECTED
C
  120 CALL SETER (' CONOP4-UNDEFINED OPTION',1,1)
      RETURN
        END

C
C $Id: mpiola.f,v 1.6 2008-07-27 00:17:07 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      INTEGER FUNCTION MPIOLA (IAID,ILVL)
        INTEGER IAID,ILVL
        MPIOLA=MDIOLA(IAID,ILVL)
        RETURN
      END

C
C $Id: gacolr.f,v 1.8 2008-07-27 00:17:13 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GACOLR (KAXS,KLBL,KMJT,KMNT)
C
C Declare the common block containing real and integer parameters.
C
        COMMON /GAREIN/ ICAX,ICLB,ICMJ,ICMN,ILTY,IORX,NCFX,NCFY,RCWX,
     +                  RCWY,RDCX,RDCY,RMJX,RMJY,RMNX,RMNY,RWAX,RWLB,
     +                  RWMJ,RWMN
        SAVE   /GAREIN/
C
C Do a call forcing a BLOCKDATA to be loaded from a binary library.
C
        CALL GABLDT
C
C Check for an uncleared prior error.
C
        IF (ICFELL('GACOLR - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C Transfer the arguments to GRIDAL's common block.
C
        ICAX=KAXS
        ICLB=KLBL
        ICMJ=KMJT
        ICMN=KMNT
C
C Done.
C
        RETURN
C
      END

      SUBROUTINE PASSF3(IDO,L1,CC,CH,WA1,WA2)
      DOUBLE PRECISION CC
      DOUBLE PRECISION CH
      DOUBLE PRECISION WA1
      DOUBLE PRECISION WA2
      DOUBLE PRECISION TAUR
      DOUBLE PRECISION TAUI
      DOUBLE PRECISION TR2
      DOUBLE PRECISION CR2
      DOUBLE PRECISION TI2
      DOUBLE PRECISION CI2
      DOUBLE PRECISION CR3
      DOUBLE PRECISION CI3
      DOUBLE PRECISION DR2
      DOUBLE PRECISION DR3
      DOUBLE PRECISION DI2
      DOUBLE PRECISION DI3
      DIMENSION CC(IDO,3,L1),CH(IDO,L1,3),WA1(*),WA2(*)
      DATA TAUR,TAUI/-.5D0,-.866025403784439D0/

      IF (IDO.NE.2) GO TO 102
      DO 101 K = 1,L1
          TR2 = CC(1,2,K) + CC(1,3,K)
          CR2 = CC(1,1,K) + TAUR*TR2
          CH(1,K,1) = CC(1,1,K) + TR2
          TI2 = CC(2,2,K) + CC(2,3,K)
          CI2 = CC(2,1,K) + TAUR*TI2
          CH(2,K,1) = CC(2,1,K) + TI2
          CR3 = TAUI* (CC(1,2,K)-CC(1,3,K))
          CI3 = TAUI* (CC(2,2,K)-CC(2,3,K))
          CH(1,K,2) = CR2 - CI3
          CH(1,K,3) = CR2 + CI3
          CH(2,K,2) = CI2 + CR3
          CH(2,K,3) = CI2 - CR3
  101 CONTINUE
      RETURN
  102 DO 104 K = 1,L1
          DO 103 I = 2,IDO,2
              TR2 = CC(I-1,2,K) + CC(I-1,3,K)
              CR2 = CC(I-1,1,K) + TAUR*TR2
              CH(I-1,K,1) = CC(I-1,1,K) + TR2
              TI2 = CC(I,2,K) + CC(I,3,K)
              CI2 = CC(I,1,K) + TAUR*TI2
              CH(I,K,1) = CC(I,1,K) + TI2
              CR3 = TAUI* (CC(I-1,2,K)-CC(I-1,3,K))
              CI3 = TAUI* (CC(I,2,K)-CC(I,3,K))
              DR2 = CR2 - CI3
              DR3 = CR2 + CI3
              DI2 = CI2 + CR3
              DI3 = CI2 - CR3
              CH(I,K,2) = WA1(I-1)*DI2 - WA1(I)*DR2
              CH(I-1,K,2) = WA1(I-1)*DR2 + WA1(I)*DI2
              CH(I,K,3) = WA2(I-1)*DI3 - WA2(I)*DR3
              CH(I-1,K,3) = WA2(I-1)*DR3 + WA2(I)*DI3
  103     CONTINUE
  104 CONTINUE
      RETURN
      END

C
C $Id: agctko.f,v 1.6 2008-07-27 00:14:33 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE AGCTKO (XBGA,YBGA,XDCA,YDCA,CFAX,CFAY,CSFA,JAOR,NMMT,
     +                   QMDP,WMML,WMMR,FNLL,FNLR,MM12,MM34,XMMT,YMMT)
C
      DIMENSION XMMT(4),YMMT(4)
C
C The routine AGCTKO is used to compute the x and y offsets to the end-
C points of the left-of-label and right-of-label portions of the major
C and minor tick marks.  See AGAXIS for definitions of the arguments.
C
C A note about WMML and WMMR:  Each is a positive number, of the form
C (E) or (1+E), where E (=EPSILON) is .LT. 1. and is expressed as a
C fraction of the smaller side of the curve window.  If the form (E) is
C used, it implies just a tick of length E; if the form (1+E) is used,
C it implies a tick long enough to reach the edge of the curve window,
C plus the length E.
C
C If the tick-mark count NMMT .EQ. 0 or the tick-mark dash pattern QMDP
C .EQ. 0 or both the left-of-axis and right-of-axis tick-mark lengths
C WMML and WMMR .EQ. 0, then no tick marks are to be drawn.
C
      IF (NMMT.EQ.0.OR.QMDP.EQ.0..OR.(WMML.EQ.0..AND.WMMR.EQ.0.))
     *                                                         GO TO 115
C
C Compute the distances of the tick mark ends from the axis as fractions
C of the axis length, using only the (EPSILON) portion of WMML and WMMR.
C
      FMML=-CSFA*MOD(WMML,1.)
      FMMR=+CSFA*MOD(WMMR,1.)
C
C If the labels overlap the axis and the (EPSILON) form was used for
C WMML or WMMR, move the tick mark to the end of the label.
C
      IF (FNLL*FNLR.GE.0.) GO TO 101
C
      IF (WMML.LT.1.) FMML=FMML+FNLL
C
      IF (WMMR.LT.1.) FMMR=FMMR+FNLR
C
C Compute the x and y offsets to the ends of the tick mark.
C
  101 XMML=+CFAX*FMML*YDCA
      YMML=-CFAY*FMML*XDCA
      XMMR=+CFAX*FMMR*YDCA
      YMMR=-CFAY*FMMR*XDCA
C
C If the (1+EPSILON) form was used for WMML or WMMR, adjust XMML, YMML,
C XMMR, and YMMR as implied by the current axis orientation.
C
      IF (WMML.LT.1.) GO TO 107
C
      GO TO (102,103,104,105) , JAOR
C
C Axis at 0 degrees (left to right).
C
  102 YMML=YMML+1.-YBGA
      GO TO 106
C
C Axis at 90 degrees (bottom to top).
C
  103 XMML=XMML-XBGA
      GO TO 106
C
C Axis at 180 degrees (right to left).
C
  104 YMML=YMML-YBGA
      GO TO 106
C
C Axis at 270 degrees (top to bottom).
C
  105 XMML=XMML+1.-XBGA
C
  106 FMML=(XMML+YMML)/(CFAX*YDCA-CFAY*XDCA)
C
  107 IF (WMMR.LT.1.) GO TO 113
C
      GO TO (108,109,110,111) , JAOR
C
C Axis at 0 degrees (left to right).
C
  108 YMMR=YMMR-YBGA
      GO TO 112
C
C Axis at 90 degrees (bottom to top).
C
  109 XMMR=XMMR+1.-XBGA
      GO TO 112
C
C Axis at 180 degrees (right to left).
C
  110 YMMR=YMMR+1.-YBGA
      GO TO 112
C
C Axis at 270 degrees (top to bottom).
C
  111 XMMR=XMMR-XBGA
C
  112 FMMR=(XMMR+YMMR)/(CFAX*YDCA-CFAY*XDCA)
C
C Now split the tick mark into two portions - one to the left, and one
C to the right, of the numeric label space.
C
  113 XMMT(1)=XMML
      YMMT(1)=YMML
      XMMT(2)=XMMR
      YMMT(2)=YMMR
      MM12=1
      MM34=0
      IF (FMMR.LE.FNLL.OR.FNLL.GE.FNLR) RETURN
C
      MM12=0
      IF (FMML.GE.FNLL) GO TO 114
      MM12=1
      XMMT(2)=+CFAX*(FNLL-.005*CSFA)*YDCA
      YMMT(2)=-CFAY*(FNLL-.005*CSFA)*XDCA
C
  114 IF (FMMR.LE.FNLR) RETURN
C
      MM34=1
      XMMT(4)=XMMR
      YMMT(4)=YMMR
      XMMT(3)=XMML
      YMMT(3)=YMML
C
      IF (FMML.GE.FNLR) RETURN
      XMMT(3)=+CFAX*(FNLR+.005*CSFA)*YDCA
      YMMT(3)=-CFAY*(FNLR+.005*CSFA)*XDCA
      RETURN
C
C No ticks to be drawn - zero the flags MM12 and MM34 to indicate this.
C
  115 MM12=0
      MM34=0
      RETURN
C
      END

      PROGRAM TDASHL
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C OPEN GKS, OPEN WORKSTATION OF TYPE 1, ACTIVATE WORKSTATION
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C INVOKE DEMO DRIVER
C
      CALL DASHL(IERR)
C
C DEACTIVATE AND CLOSE WORKSTATION, CLOSE GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END
C
      SUBROUTINE DASHL (IERROR)
C
C PURPOSE                To provide a simple demonstration of DASHLINE
C
C USAGE                  CALL DASHL (IERROR)
C
C ARGUMENTS
C
C ON OUTPUT              IERROR
C                          An integer variable
C                          = 0, if the test was successful,
C                          = 1, otherwise
C
C I/O                    If the test is successful, the message
C
C               DASHLINE TEST EXECUTED--SEE PLOT TO CERTIFY
C
C                        is printed on unit 6.  In addition, 1
C                        frame is produced on the machine graphics
C                        device.  In order to determine if the test
C                        was successful, it is necessary to examine
C                        the plot.
C
C PRECISION              Single
C
C REQUIRED ROUTINES      DASHLINE
C
C REQUIRED GKS LEVEL     0A
C
C LANGUAGE               FORTRAN 77
C
C ALGORITHM              TDASHL utilizes the software DASHLINE
C                        routines DASHDB, DASHDC, FRSTD, VECTD,
C                        LINED, and CURVED to draw 5 curves on 1
C                        picture using 5 different DASHLINE patterns.
C                        Each curve is centered about solid axis
C                        lines and labelled with the binary
C                        representation of the DASHLINE pattern used.
C
C X contains the abscissae and Y the ordinates of the curve to be plotted.
C
      DIMENSION       X(31)      ,Y(31)      ,IPAT(5)
C
C Select normalization transformation 0.
C
      CALL GSELNT(0)
C
C Set a solid dash pattern,  1111111111111111 (BINARY).
C Boolean operations (using locally-implemented support
C routines) are used to support porting to hosts with 16
C bit integers.
C
      ISOLID = IOR (ISHIFT (32767,1), 1)
C
C Array IPAT contains 5 different 16-BIT dash patterns.  The patterns
C are constructed with boolean operations as shown above.
C The binary representations of the patterns are
C        0001110001111111
C        1111000011110000
C        1111110011111100
C        1111111100000000
C        1111111111111100
C
      IPAT(1) = IOR (ISHIFT ( 3647,1), 1)
      IPAT(2) = ISHIFT (30840,1)
      IPAT(3) = ISHIFT (32382,1)
      IPAT(4) = ISHIFT (32640,1)
      IPAT(5) = ISHIFT (32766,1)
C
      DO  70 K=1,5
         CALL DASHDB (ISOLID)
         ORG =1.07-0.195*K
C
C Draw the central axis for each curve.
C
         CALL FRSTD (.50,ORG-0.03)
         CALL VECTD (.50,ORG+0.03)
         CALL LINED (.109,ORG,.891,ORG)
         CALL DASHDB (IPAT(K))
C
C Compute the curve coordinates and draw the curve.
C
         DO  10 I=1,31
            THETA = REAL(I-1)*3.1415926535897932/15.
            X(I) = 0.5+.4*COS(THETA)
            Y(I) = ORG+.075*SIN(REAL(K)*THETA)
   10    CONTINUE
         CALL CURVED (X,Y,31)
C
C Label each curve with the appropriate binary representation of the
C DASHLINE pattern.
C
C Locate the string at the left end, but vertically centered.
C
      CALL GSTXAL(1,3)
C
C Set the character height.
C
      CALL GSCHH(.012)
C
         ORY = ORG+.09
         GO TO ( 20, 30, 40, 50, 60),K
   20    CALL GTX (.1,ORY,'IPAT=0001110001111111')
         GO TO  70
   30    CALL GTX (.1,ORY,'IPAT=1111000011110000')
         GO TO  70
   40    CALL GTX (.1,ORY,'IPAT=1111110011111100')
         GO TO  70
   50    CALL GTX (.1,ORY,'IPAT=1111111100000000')
         GO TO  70
   60    CALL GTX (.1,ORY,'IPAT=1111111111111100')
C
   70 CONTINUE
C
      CALL GSTXAL(2,3)
      CALL GTX (.5,.985,'DEMONSTRATION PLOT FOR DASHLINE')
      CALL FRAME
C
      IERROR = 0
      WRITE (6,1001)
C
      RETURN
 1001 FORMAT (' DASHLINE TEST EXECUTED--SEE PLOT TO CERTIFY')
C
      END

      SUBROUTINE ZSPCON( UPLO, N, AP, IPIV, ANORM, RCOND, WORK, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     March 31, 1993
*
*     .. Scalar Arguments ..
      CHARACTER          UPLO
      INTEGER            INFO, N
      DOUBLE PRECISION   ANORM, RCOND
*     ..
*     .. Array Arguments ..
      INTEGER            IPIV( * )
      COMPLEX*16         AP( * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  ZSPCON estimates the reciprocal of the condition number (in the
*  1-norm) of a complex symmetric packed matrix A using the
*  factorization A = U*D*U**T or A = L*D*L**T computed by ZSPTRF.
*
*  An estimate is obtained for norm(inv(A)), and the reciprocal of the
*  condition number is computed as RCOND = 1 / (ANORM * norm(inv(A))).
*
*  Arguments
*  =========
*
*  UPLO    (input) CHARACTER*1
*          Specifies whether the details of the factorization are stored
*          as an upper or lower triangular matrix.
*          = 'U':  Upper triangular, form is A = U*D*U**T;
*          = 'L':  Lower triangular, form is A = L*D*L**T.
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  AP      (input) COMPLEX*16 array, dimension (N*(N+1)/2)
*          The block diagonal matrix D and the multipliers used to
*          obtain the factor U or L as computed by ZSPTRF, stored as a
*          packed triangular matrix.
*
*  IPIV    (input) INTEGER array, dimension (N)
*          Details of the interchanges and the block structure of D
*          as determined by ZSPTRF.
*
*  ANORM   (input) DOUBLE PRECISION
*          The 1-norm of the original matrix A.
*
*  RCOND   (output) DOUBLE PRECISION
*          The reciprocal of the condition number of the matrix A,
*          computed as RCOND = 1/(ANORM * AINVNM), where AINVNM is an
*          estimate of the 1-norm of inv(A) computed in this routine.
*
*  WORK    (workspace) COMPLEX*16 array, dimension (2*N)
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ONE, ZERO
      PARAMETER          ( ONE = 1.0D+0, ZERO = 0.0D+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            UPPER
      INTEGER            I, IP, KASE
      DOUBLE PRECISION   AINVNM
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           XERBLA, ZLACON, ZSPTRS
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      UPPER = LSAME( UPLO, 'U' )
      IF( .NOT.UPPER .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( ANORM.LT.ZERO ) THEN
         INFO = -5
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'ZSPCON', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      RCOND = ZERO
      IF( N.EQ.0 ) THEN
         RCOND = ONE
         RETURN
      ELSE IF( ANORM.LE.ZERO ) THEN
         RETURN
      END IF
*
*     Check that the diagonal matrix D is nonsingular.
*
      IF( UPPER ) THEN
*
*        Upper triangular storage: examine D from bottom to top
*
         IP = N*( N+1 ) / 2
         DO 10 I = N, 1, -1
            IF( IPIV( I ).GT.0 .AND. AP( IP ).EQ.ZERO )
     $         RETURN
            IP = IP - I
   10    CONTINUE
      ELSE
*
*        Lower triangular storage: examine D from top to bottom.
*
         IP = 1
         DO 20 I = 1, N
            IF( IPIV( I ).GT.0 .AND. AP( IP ).EQ.ZERO )
     $         RETURN
            IP = IP + N - I + 1
   20    CONTINUE
      END IF
*
*     Estimate the 1-norm of the inverse.
*
      KASE = 0
   30 CONTINUE
      CALL ZLACON( N, WORK( N+1 ), WORK, AINVNM, KASE )
      IF( KASE.NE.0 ) THEN
*
*        Multiply by inv(L*D*L') or inv(U*D*U').
*
         CALL ZSPTRS( UPLO, N, 1, AP, IPIV, WORK, N, INFO )
         GO TO 30
      END IF
*
*     Compute the estimate of the reciprocal condition number.
*
      IF( AINVNM.NE.ZERO )
     $   RCOND = ( ONE / AINVNM ) / ANORM
*
      RETURN
*
*     End of ZSPCON
*
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C   FFTPACK 5.0
C   Copyright (C) 1995-2004, Scientific Computing Division,
C   University Corporation for Atmospheric Research
C   Licensed under the GNU General Public License (GPL)
C
C   Authors:  Paul N. Swarztrauber and Richard A. Valent
C
C   $Id: sint1i.f,v 1.2 2006-11-21 01:10:20 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      SUBROUTINE DSINT1I(N,WSAVE,LENSAV,IER)
      DOUBLE PRECISION PI
      DOUBLE PRECISION DT
      INTEGER N,LENSAV,IER
      DOUBLE PRECISION WSAVE(LENSAV)
C
      IER = 0
C
      IF (LENSAV.LT.N/2+N+INT(LOG(DBLE(N)))+4) THEN
          IER = 2
          CALL DXERFFT('SINT1I',3)
          GO TO 300
      END IF
C
      PI = 4.D0*ATAN(1.D0)
      IF (N.LE.1) RETURN
      NS2 = N/2
      NP1 = N + 1
      DT = PI/DBLE(NP1)
      DO 101 K = 1,NS2
          WSAVE(K) = 2.D0*SIN(K*DT)
  101 CONTINUE
      LNSV = NP1 + INT(LOG(DBLE(NP1))) + 4
      CALL DRFFT1I(NP1,WSAVE(NS2+1),LNSV,IER1)
      IF (IER1.NE.0) THEN
          IER = 20
          CALL DXERFFT('SINT1I',-5)
      END IF
C
  300 CONTINUE
      RETURN
      END

C
C	$Id: wmseti.f,v 1.18 2010-01-05 03:52:14 fred Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE WMSETI (CNP,IVP)
C
      SAVE
C
      CHARACTER*(*) CNP
C
C  This subroutine is called to give an integer value to a specified
C  parameter.
C
C  CNP is the name of the parameter whose value is to be set.
C
C  IVP is an integer variable containing the desired value.
C
C
C  Declare a local character variable in which to form an error message.       
C
      CHARACTER*80 CTM
C
      include 'wmcomn.h'
C
C  Do a call forcing a BLOCKDATA to be loaded from a binary library.
C
      CALL WMBLDA
C
C  Check for an uncleared prior error.
C
      IF (ICFELL('WMSETI - Uncleared prior error',1) .NE. 0) RETURN
C
C  Check for a parameter name that is too short.
C
      IF (LEN(CNP) .LT. 3) THEN
        CTM(1:36) = 'WMSETI - Parameter name too short - '
        CTM(37:36+LEN(CNP)) = CNP
        CALL SETER (CTM(1:36+LEN(CNP)), 1, 1)
        GO TO 120
      ENDIF
C
C  Do a crude check to see if IVP is within range (primarily to 
C  make sure that a floating point number has not been supplied).
C
      IF (IVP .GT. 10000000) THEN
        CTM(1:42) = 'WMSETI - Parameter value out of range for '
        CTM(43:45) = CNP(1:3)
        CALL SETER (CTM(1:45), 2, 1)
        GO TO 120
      ENDIF
C
C  MXS - Maximum number of symbols to allow on a front line.
C
      IF (CNP(1:3).EQ.'MXS' .OR. CNP(1:3).EQ.'mxs' .OR.
     +    CNP(1:3).EQ.'Mxs') THEN
        IF (IVP .GT. ISDIM) THEN
          CTM(1:42) = 'WMSETI - Parameter value out of range for '
          CTM(43:45) = CNP(1:3)
          CALL SETER (CTM(1:45), 2, 1)
          GO TO 120
        ENDIF
        MAXSYM = IVP
        GO TO 120
C
C  NMS - force a certain number of symbols on a front line (if > 0).
C
      ELSE IF (CNP(1:3).EQ.'NMS' .OR. CNP(1:3).EQ.'nms' .OR.
     +    CNP(1:3).EQ.'Nms') THEN
        NUMSYO = IVP
        GO TO 120
C
C  PAI - current parameter array index.
C
      ELSE IF (CNP(1:3).EQ.'PAI' .OR. CNP(1:3).EQ.'pai' .OR.
     +    CNP(1:3).EQ.'Pai') THEN
        IF (IVP .GT. ISDIM) THEN
          CTM(1:42) = 'WMSETI - Parameter value out of range for '
          CTM(43:45) = CNP(1:3)
          CALL SETER (CTM(1:45), 2, 1)
          GO TO 120
        ENDIF
        IARNDX = IVP
        GO TO 120
C
C  WTY - flag to indicate how line widths are to be implemented 
C        (0=use GKS linewidths; 1=use internal routines WMDRFL).
C
      ELSE IF (CNP(1:3).EQ.'WTY' .OR. CNP(1:3).EQ.'wty' .OR.
     +    CNP(1:3).EQ.'Wty') THEN
        IF (ABS(IVP) .GE. 1) THEN
          IWDTYP = 1
        ELSE
          IWDTYP = 0
        ENDIF
        GO TO 120
C
C  STY - symbol type (uses PAI to determine position on line).
C
      ELSE IF (CNP(1:3).EQ.'STY' .OR. CNP(1:3).EQ.'sty' .OR.
     +    CNP(1:3).EQ.'Sty') THEN
        IF (ABS(IVP).GT.2 .OR. IVP.EQ.0) THEN
          CTM(1:42) = 'WMSETI - Parameter value out of range for '
          CTM(43:45) = CNP(1:3)
          CALL SETER (CTM(1:45), 2, 1)
          GO TO 120
        ENDIF
        ISTYPE(IARNDX) = IVP
        GO TO 120
C
C  SLF - slope flag (0=use SL1 & SL2; 1=use SL1 only; 2=use SL2 only;
C        3=use neither SL1 or SL2).
C
      ELSE IF (CNP(1:3).EQ.'SLF' .OR. CNP(1:3).EQ.'slf' .OR.
     +    CNP(1:3).EQ.'Slf') THEN
        IF (ABS(IVP).GT.3 .OR. IVP.LT.0) THEN
          ISLFLG = 3
        ELSE
          ISLFLG = IVP
        ENDIF
        GO TO 120
C
C  ALO - flag for surface or aloft.
C
      ELSE IF (CNP(1:3).EQ.'ALO' .OR. CNP(1:3).EQ.'alo' .OR.
     +    CNP(1:3).EQ.'Alo') THEN
        IF (IVP .NE. 0) THEN
          IALOFT = 1
        ELSE
          IALOFT = 0
        ENDIF
        GO TO 120
C
C  COL - specify color index to be used for all objects that require 
C        only a single color setting.
C
      ELSE IF (CNP(1:3).EQ.'COL' .OR. CNP(1:3).EQ.'col' .OR.
     +    CNP(1:3).EQ.'Col') THEN
        ICOLOR = IVP
        GO TO 120
C
C  CBC - specify color index to be used for backgrounds of city and
C        dalily high/low labels.
C
      ELSE IF (CNP(1:3).EQ.'CBC' .OR. CNP(1:3).EQ.'cbc' .OR.
     +    CNP(1:3).EQ.'Cbc') THEN
        IBGCTY = IVP
        GO TO 120
C
C  RFC - specify color index to be used for foreground of regional
C        temperature labels and cities.
C
      ELSE IF (CNP(1:3).EQ.'RFC' .OR. CNP(1:3).EQ.'rfc' .OR.
     +    CNP(1:3).EQ.'Rbc') THEN
        IFGTRG = IVP
        GO TO 120
C
C  RLS - shadow color index for regional temperature labels.
C
      ELSE IF (CNP(1:3).EQ.'RLS' .OR. CNP(1:3).EQ.'rls' .OR.
     +    CNP(1:3).EQ.'Rls') THEN
        IRLLSC = IVP
        GO TO 120
C
C  EZF - EZMAP flag.  Flags if the NCL entries WMBARB, WMDRFT, and
C        WMLABS are being used in conjunction with EZMAP, in which
C        case the input coordinates are assumed to be in degrees
C        latitude and longitude.
C
      ELSE IF (CNP(1:3).EQ.'EZF' .OR. CNP(1:3).EQ.'ezf' .OR.
     +    CNP(1:3).EQ.'Ezf') THEN
        IEZFLG = IVP
        GO TO 120
C
C  ROS - outline color index for regional temperature labels.
C
      ELSE IF (CNP(1:3).EQ.'ROS' .OR. CNP(1:3).EQ.'ros' .OR.
     +    CNP(1:3).EQ.'Ros') THEN
        IRLOUC = IVP
        GO TO 120
C
C  RBS -  color index for background box for regional temperature labels.
C
      ELSE IF (CNP(1:3).EQ.'RBS' .OR. CNP(1:3).EQ.'rbs' .OR.
     +    CNP(1:3).EQ.'Rbs') THEN
        IRLBKC = IVP
        GO TO 120
C
C  DTC - specify color index to be used for the dots marking cities.
C
      ELSE IF (CNP(1:3).EQ.'DTC' .OR. CNP(1:3).EQ.'dtc' .OR.
     +    CNP(1:3).EQ.'dtc') THEN
        IDOTCO = IVP
        GO TO 120
C
C  DBC - specify color background color for dot symbols.
C
      ELSE IF (CNP(1:3).EQ.'DBC' .OR. CNP(1:3).EQ.'dbc' .OR.
     +    CNP(1:3).EQ.'dbc') THEN
        IDOTBG = IVP
        GO TO 120
C
C  NBZ - number of points to use in Bezier curves for warm front
C        symbols.
C
      ELSE IF (CNP(1:3).EQ.'NBZ' .OR. CNP(1:3).EQ.'nbz' .OR.
     +    CNP(1:3).EQ.'Nbz') THEN
        NPTSBZ = MAX(IVP,7)
        GO TO 120
C
C  REV - Reverses the directions that the symbols point.
C
      ELSE IF (CNP(1:3).EQ.'REV' .OR. CNP(1:3).EQ.'rev' .OR.
     +    CNP(1:3).EQ.'Rev') THEN
        DO 10 I=1,MAXSYM
          ISTYPE(I) = -ISTYPE(I)
   10   CONTINUE   
        GO TO 120
C
C  WBF - Flag indicating whether the base of a wind barb should
C        be drawn to allow for the sky cover circle at its base.
C
      ELSE IF (CNP(1:3).EQ.'WBF' .OR. CNP(1:3).EQ.'wbf' .OR.
     +    CNP(1:3).EQ.'Wbf') THEN
        IWBBAS = IVP
        GO TO 120
C
C  WDF - Flag indicating wind barb direction.  The default (=0)
C        means plot the barb shaft away from the wind (which is
C        is not the meteorological convention) and WDF non-zero
C        means plot the barb shaft in the direction of the wind
C        (the meteorological convention). 
C
      ELSE IF (CNP(1:3).EQ.'WDF' .OR. CNP(1:3).EQ.'wdf' .OR.
     +    CNP(1:3).EQ.'Wdf') THEN
        IWBDIR = IVP
        GO TO 120
C
C  SC1 - color index for center of sun symbol.
C
      ELSE IF (CNP(1:3).EQ.'SC1' .OR. CNP(1:3).EQ.'sc1' .OR.
     +    CNP(1:3).EQ.'Sc1') THEN
        ISUNC1 = IVP
        GO TO 120
C
C  SC2 - color index for the points of the sun symbol.
C
      ELSE IF (CNP(1:3).EQ.'SC2' .OR. CNP(1:3).EQ.'sc2' .OR.
     +    CNP(1:3).EQ.'Sc2') THEN
        ISUNC2 = IVP
        GO TO 120
C
C  SC3 - color index for the outline of the sun symbol.
C
      ELSE IF (CNP(1:3).EQ.'SC3' .OR. CNP(1:3).EQ.'sc3' .OR.
     +    CNP(1:3).EQ.'Sc3') THEN
        ISUNC3 = IVP
        GO TO 120
C
C  SC4 - color index for shadow of the sun symbol.
C
      ELSE IF (CNP(1:3).EQ.'SC4' .OR. CNP(1:3).EQ.'sc4' .OR.
     +    CNP(1:3).EQ.'Sc4') THEN
        ISUNC4 = IVP
        GO TO 120
C
C  CC1 - color index for interior of the cloud symbol.
C
      ELSE IF (CNP(1:3).EQ.'CC1' .OR. CNP(1:3).EQ.'cc1' .OR.
     +    CNP(1:3).EQ.'Cc1') THEN
        ICLDC1 = IVP
        GO TO 120
C
C  CC2 - color index for the outline of the cloud symbol.
C
      ELSE IF (CNP(1:3).EQ.'CC2' .OR. CNP(1:3).EQ.'cc2' .OR.
     +    CNP(1:3).EQ.'Cc2') THEN
        ICLDC2 = IVP
        GO TO 120
C
C  CC3 - color index for shadow of the cloud symbol.
C
      ELSE IF (CNP(1:3).EQ.'CC3' .OR. CNP(1:3).EQ.'cc3' .OR.
     +    CNP(1:3).EQ.'Cc3') THEN
        ICLDC3 = IVP
        GO TO 120
C
C  LC1 - color index for the interior of the lightening bolt symbol.
C
      ELSE IF (CNP(1:3).EQ.'LC1' .OR. CNP(1:3).EQ.'lc1' .OR.
     +    CNP(1:3).EQ.'Lc1') THEN
        ILTNC1 = IVP
        GO TO 120
C
C  LC2 - color index for the outline of the lightening bolt symbol.
C
      ELSE IF (CNP(1:3).EQ.'LC2' .OR. CNP(1:3).EQ.'lc2' .OR.
     +    CNP(1:3).EQ.'Lc2') THEN
        ILTNC2 = IVP
        GO TO 120
C
C  LC3 - color index for the shadow of the lightening bolt symbol.
C
      ELSE IF (CNP(1:3).EQ.'LC3' .OR. CNP(1:3).EQ.'lc3' .OR.
     +    CNP(1:3).EQ.'Lc3') THEN
        ILTNC3 = IVP
        GO TO 120
C
C  WFC - color index for warm front symbols.
C
      ELSE IF (CNP(1:3).EQ.'WFC' .OR. CNP(1:3).EQ.'wfc' .OR.
     +    CNP(1:3).EQ.'Wfc') THEN
        IWARMC = IVP
        GO TO 120
C
C  CFC - color index for cold front symbols.
C
      ELSE IF (CNP(1:3).EQ.'CFC' .OR. CNP(1:3).EQ.'cfc' .OR.
     +    CNP(1:3).EQ.'Cfc') THEN
        ICOLDC = IVP
        GO TO 120
C
C  T1C - color index for alternate colors of tropical front.
C
      ELSE IF (CNP(1:3).EQ.'T1C' .OR. CNP(1:3).EQ.'t1c' .OR.
     +    CNP(1:3).EQ.'T1c') THEN
        ITRO1C = IVP
        GO TO 120
C
C  T2C - another color index for alternate colors of tropical front.
C
      ELSE IF (CNP(1:3).EQ.'T2C' .OR. CNP(1:3).EQ.'t2c' .OR.
     +    CNP(1:3).EQ.'T2c') THEN
        ITRO2C = IVP
        GO TO 120
C
C  HIS - shadow color for high symbols.
C
      ELSE IF (CNP(1:3).EQ.'HIS' .OR. CNP(1:3).EQ.'his' .OR.
     +    CNP(1:3).EQ.'His') THEN
        IHIGC1 = IVP
        GO TO 120
C
C  HIF - symbol color for high symbols.
C
      ELSE IF (CNP(1:3).EQ.'HIF' .OR. CNP(1:3).EQ.'hif' .OR.
     +    CNP(1:3).EQ.'Hif') THEN
        IHIGC3 = IVP
        GO TO 120
C
C  HIB - character background color for high symbols.
C
      ELSE IF (CNP(1:3).EQ.'HIB' .OR. CNP(1:3).EQ.'hib' .OR.
     +    CNP(1:3).EQ.'Hib') THEN
        IHIGC2 = IVP
        GO TO 120
C
C  HIC - color of circumscribed circle.
C
      ELSE IF (CNP(1:3).EQ.'HIC' .OR. CNP(1:3).EQ.'hic' .OR.
     +    CNP(1:3).EQ.'Hic') THEN
        IHIGC4 = IVP
        GO TO 120
C
C  LOS - shadow color for low symbols.
C
      ELSE IF (CNP(1:3).EQ.'LOS' .OR. CNP(1:3).EQ.'los' .OR.
     +    CNP(1:3).EQ.'Los') THEN
        ILOWC1 = IVP
        GO TO 120
C
C  LOF - symbol color for low symbols.
C
      ELSE IF (CNP(1:3).EQ.'LOF' .OR. CNP(1:3).EQ.'lof' .OR.
     +    CNP(1:3).EQ.'Lof') THEN
        ILOWC3 = IVP
        GO TO 120
C
C  LOB - character background color for low symbols.
C
      ELSE IF (CNP(1:3).EQ.'LOB' .OR. CNP(1:3).EQ.'lob' .OR.
     +    CNP(1:3).EQ.'Lob') THEN
        ILOWC2 = IVP
        GO TO 120
C
C  LOC - color of circumscribed circle.
C
      ELSE IF (CNP(1:3).EQ.'LOC' .OR. CNP(1:3).EQ.'loc' .OR.
     +    CNP(1:3).EQ.'Loc') THEN
        ILOWC4 = IVP
        GO TO 120
C
C  RC1 - box outline color for regional weather labels.
C
      ELSE IF (CNP(1:3).EQ.'RC1' .OR. CNP(1:3).EQ.'rc1' .OR.
     +    CNP(1:3).EQ.'Rc1') THEN
        IRGLC1 = IVP
        GO TO 120
C
C  RC2 - background color for regional weather labels.
C
      ELSE IF (CNP(1:3).EQ.'RC2' .OR. CNP(1:3).EQ.'rc2' .OR.
     +    CNP(1:3).EQ.'Rc2') THEN
        IRGLC2 = IVP
        GO TO 120
C
C  RC3 - shadow color for regional weather labels.
C
      ELSE IF (CNP(1:3).EQ.'RC3' .OR. CNP(1:3).EQ.'rc3' .OR.
     +    CNP(1:3).EQ.'Rc3') THEN
        IRGLC3 = IVP
        GO TO 120
C
C  RC4 - character color for regional weather labels.
C
      ELSE IF (CNP(1:3).EQ.'RC4' .OR. CNP(1:3).EQ.'rc4' .OR.
     +    CNP(1:3).EQ.'Rc4') THEN
        IRGLC4 = IVP
        GO TO 120
C
C  RC5 - character outline color for regional weather labels.
C
      ELSE IF (CNP(1:3).EQ.'RC5' .OR. CNP(1:3).EQ.'rc5' .OR.
     +    CNP(1:3).EQ.'Rc5') THEN
        IRGLC5 = IVP
        GO TO 120
C
C  AWC - arrow color.
C
      ELSE IF (CNP(1:3).EQ.'AWC' .OR. CNP(1:3).EQ.'awc' .OR.
     +    CNP(1:3).EQ.'Awc') THEN
        IAROWC = IVP
        GO TO 120
C
C  SMF - Flags whether interpolation (=0) or smoothing (=1) is done.
C
      ELSE IF (CNP(1:3).EQ.'SMF' .OR. CNP(1:3).EQ.'smf' .OR.
     +    CNP(1:3).EQ.'Smf') THEN
        ISMOTH = IVP
        GO TO 120
C
C  ASC - arrow shadow color.
C
      ELSE IF (CNP(1:3).EQ.'ASC' .OR. CNP(1:3).EQ.'asc' .OR.
     +    CNP(1:3).EQ.'Asc') THEN
        IARSHC = IVP
        GO TO 120
C
C  AOC - arrow outline color.
C
      ELSE IF (CNP(1:3).EQ.'AOC' .OR. CNP(1:3).EQ.'aoc' .OR.
     +    CNP(1:3).EQ.'Aoc') THEN
        IAROUC = IVP
        GO TO 120
C
C  UNT - flags whether to use imperial units (as described in the
C        NOAA chart), or metric units as per:
C          http://weather.unisys.com/wxp/Appendices/Formats/SYNOP.html
C
      ELSE IF (CNP(1:3).EQ.'UNT' .OR. CNP(1:3).EQ.'unt' .OR.
     +    CNP(1:3).EQ.'Unt') THEN
        IUNITS = IVP
        GO TO 120
C
C  VCC - color index for vectors.
C
      ELSE IF (CNP(1:3).EQ.'VCC' .OR. CNP(1:3).EQ.'vcc' .OR.
     +    CNP(1:3).EQ.'Vcc') THEN
        VCCOLR = IVP
        GO TO 120
C
C  VLF - Foreground color for vector label box.
C
      ELSE IF (CNP(1:3).EQ.'VLF' .OR. CNP(1:3).EQ.'vlf' .OR.
     +         CNP(1:3).EQ.'Vlf') THEN
        VLBLFC = IVP
        GO TO 120
C
C  VLB - Background color for vector label box.
C
      ELSE IF (CNP(1:3).EQ.'VLB' .OR. CNP(1:3).EQ.'vlb' .OR.
     +         CNP(1:3).EQ.'Vlb') THEN
        VLBLBC = IVP
        GO TO 120
C
C  VVC - Flags whether to plot the visibility parameter VV as the
C        raw two-character SYNOP codes.
C
      ELSE IF (CNP(1:3).EQ.'VVC' .OR. CNP(1:3).EQ.'vvc' .OR.
     +         CNP(1:3).EQ.'Vvc') THEN
        IVVCOD = IVP
        GO TO 120
      ELSE
        CTM(1:36) = 'WMSETI - Parameter name not known - '
        CTM(37:39) = CNP(1:3)
        CALL SETER (CTM(1:39), 23, 1)
        GO TO 120
      ENDIF
C
  120 CONTINUE
      RETURN
      END

      SUBROUTINE DSTEVR( JOBZ, RANGE, N, D, E, VL, VU, IL, IU, ABSTOL,
     $                   M, W, Z, LDZ, ISUPPZ, WORK, LWORK, IWORK,
     $                   LIWORK, INFO )
*
*  -- LAPACK driver routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     March 20, 2000
*
*     .. Scalar Arguments ..
      CHARACTER          JOBZ, RANGE
      INTEGER            IL, INFO, IU, LDZ, LIWORK, LWORK, M, N
      DOUBLE PRECISION   ABSTOL, VL, VU
*     ..
*     .. Array Arguments ..
      INTEGER            ISUPPZ( * ), IWORK( * )
      DOUBLE PRECISION   D( * ), E( * ), W( * ), WORK( * ), Z( LDZ, * )
*     ..
*
*  Purpose
*  =======
*
*  DSTEVR computes selected eigenvalues and, optionally, eigenvectors
*  of a real symmetric tridiagonal matrix T.  Eigenvalues and
*  eigenvectors can be selected by specifying either a range of values
*  or a range of indices for the desired eigenvalues.
*
*  Whenever possible, DSTEVR calls SSTEGR to compute the
*  eigenspectrum using Relatively Robust Representations.  DSTEGR
*  computes eigenvalues by the dqds algorithm, while orthogonal
*  eigenvectors are computed from various "good" L D L^T representations
*  (also known as Relatively Robust Representations). Gram-Schmidt
*  orthogonalization is avoided as far as possible. More specifically,
*  the various steps of the algorithm are as follows. For the i-th
*  unreduced block of T,
*     (a) Compute T - sigma_i = L_i D_i L_i^T, such that L_i D_i L_i^T
*          is a relatively robust representation,
*     (b) Compute the eigenvalues, lambda_j, of L_i D_i L_i^T to high
*         relative accuracy by the dqds algorithm,
*     (c) If there is a cluster of close eigenvalues, "choose" sigma_i
*         close to the cluster, and go to step (a),
*     (d) Given the approximate eigenvalue lambda_j of L_i D_i L_i^T,
*         compute the corresponding eigenvector by forming a
*         rank-revealing twisted factorization.
*  The desired accuracy of the output can be specified by the input
*  parameter ABSTOL.
*
*  For more details, see "A new O(n^2) algorithm for the symmetric
*  tridiagonal eigenvalue/eigenvector problem", by Inderjit Dhillon,
*  Computer Science Division Technical Report No. UCB//CSD-97-971,
*  UC Berkeley, May 1997.
*
*
*  Note 1 : DSTEVR calls SSTEGR when the full spectrum is requested
*  on machines which conform to the ieee-754 floating point standard.
*  DSTEVR calls SSTEBZ and SSTEIN on non-ieee machines and
*  when partial spectrum requests are made.
*
*  Normal execution of DSTEGR may create NaNs and infinities and
*  hence may abort due to a floating point exception in environments
*  which do not handle NaNs and infinities in the ieee standard default
*  manner.
*
*  Arguments
*  =========
*
*  JOBZ    (input) CHARACTER*1
*          = 'N':  Compute eigenvalues only;
*          = 'V':  Compute eigenvalues and eigenvectors.
*
*  RANGE   (input) CHARACTER*1
*          = 'A': all eigenvalues will be found.
*          = 'V': all eigenvalues in the half-open interval (VL,VU]
*                 will be found.
*          = 'I': the IL-th through IU-th eigenvalues will be found.
********** For RANGE = 'V' or 'I' and IU - IL < N - 1, DSTEBZ and
********** DSTEIN are called
*
*  N       (input) INTEGER
*          The order of the matrix.  N >= 0.
*
*  D       (input/output) DOUBLE PRECISION array, dimension (N)
*          On entry, the n diagonal elements of the tridiagonal matrix
*          A.
*          On exit, D may be multiplied by a constant factor chosen
*          to avoid over/underflow in computing the eigenvalues.
*
*  E       (input/output) DOUBLE PRECISION array, dimension (N)
*          On entry, the (n-1) subdiagonal elements of the tridiagonal
*          matrix A in elements 1 to N-1 of E; E(N) need not be set.
*          On exit, E may be multiplied by a constant factor chosen
*          to avoid over/underflow in computing the eigenvalues.
*
*  VL      (input) DOUBLE PRECISION
*  VU      (input) DOUBLE PRECISION
*          If RANGE='V', the lower and upper bounds of the interval to
*          be searched for eigenvalues. VL < VU.
*          Not referenced if RANGE = 'A' or 'I'.
*
*  IL      (input) INTEGER
*  IU      (input) INTEGER
*          If RANGE='I', the indices (in ascending order) of the
*          smallest and largest eigenvalues to be returned.
*          1 <= IL <= IU <= N, if N > 0; IL = 1 and IU = 0 if N = 0.
*          Not referenced if RANGE = 'A' or 'V'.
*
*  ABSTOL  (input) DOUBLE PRECISION
*          The absolute error tolerance for the eigenvalues.
*          An approximate eigenvalue is accepted as converged
*          when it is determined to lie in an interval [a,b]
*          of width less than or equal to
*
*                  ABSTOL + EPS *   max( |a|,|b| ) ,
*
*          where EPS is the machine precision.  If ABSTOL is less than
*          or equal to zero, then  EPS*|T|  will be used in its place,
*          where |T| is the 1-norm of the tridiagonal matrix obtained
*          by reducing A to tridiagonal form.
*
*          See "Computing Small Singular Values of Bidiagonal Matrices
*          with Guaranteed High Relative Accuracy," by Demmel and
*          Kahan, LAPACK Working Note #3.
*
*          If high relative accuracy is important, set ABSTOL to
*          DLAMCH( 'Safe minimum' ).  Doing so will guarantee that
*          eigenvalues are computed to high relative accuracy when
*          possible in future releases.  The current code does not
*          make any guarantees about high relative accuracy, but
*          future releases will. See J. Barlow and J. Demmel,
*          "Computing Accurate Eigensystems of Scaled Diagonally
*          Dominant Matrices", LAPACK Working Note #7, for a discussion
*          of which matrices define their eigenvalues to high relative
*          accuracy.
*
*  M       (output) INTEGER
*          The total number of eigenvalues found.  0 <= M <= N.
*          If RANGE = 'A', M = N, and if RANGE = 'I', M = IU-IL+1.
*
*  W       (output) DOUBLE PRECISION array, dimension (N)
*          The first M elements contain the selected eigenvalues in
*          ascending order.
*
*  Z       (output) DOUBLE PRECISION array, dimension (LDZ, max(1,M) )
*          If JOBZ = 'V', then if INFO = 0, the first M columns of Z
*          contain the orthonormal eigenvectors of the matrix A
*          corresponding to the selected eigenvalues, with the i-th
*          column of Z holding the eigenvector associated with W(i).
*          Note: the user must ensure that at least max(1,M) columns are
*          supplied in the array Z; if RANGE = 'V', the exact value of M
*          is not known in advance and an upper bound must be used.
*
*  LDZ     (input) INTEGER
*          The leading dimension of the array Z.  LDZ >= 1, and if
*          JOBZ = 'V', LDZ >= max(1,N).
*
*  ISUPPZ  (output) INTEGER array, dimension ( 2*max(1,M) )
*          The support of the eigenvectors in Z, i.e., the indices
*          indicating the nonzero elements in Z. The i-th eigenvector
*          is nonzero only in elements ISUPPZ( 2*i-1 ) through
*          ISUPPZ( 2*i ).
********** Implemented only for RANGE = 'A' or 'I' and IU - IL = N - 1
*
*  WORK    (workspace/output) DOUBLE PRECISION array, dimension (LWORK)
*          On exit, if INFO = 0, WORK(1) returns the optimal (and
*          minimal) LWORK.
*
*  LWORK   (input) INTEGER
*          The dimension of the array WORK.  LWORK >= 20*N.
*
*          If LWORK = -1, then a workspace query is assumed; the routine
*          only calculates the optimal size of the WORK array, returns
*          this value as the first entry of the WORK array, and no error
*          message related to LWORK is issued by XERBLA.
*
*  IWORK   (workspace/output) INTEGER array, dimension (LIWORK)
*          On exit, if INFO = 0, IWORK(1) returns the optimal (and
*          minimal) LIWORK.
*
*  LIWORK  (input) INTEGER
*          The dimension of the array IWORK.  LIWORK >= 10*N.
*
*          If LIWORK = -1, then a workspace query is assumed; the
*          routine only calculates the optimal size of the IWORK array,
*          returns this value as the first entry of the IWORK array, and
*          no error message related to LIWORK is issued by XERBLA.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*          > 0:  Internal error
*
*  Further Details
*  ===============
*
*  Based on contributions by
*     Inderjit Dhillon, IBM Almaden, USA
*     Osni Marques, LBNL/NERSC, USA
*     Ken Stanley, Computer Science Division, University of
*       California at Berkeley, USA
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO, ONE
      PARAMETER          ( ZERO = 0.0D+0, ONE = 1.0D+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            ALLEIG, INDEIG, LQUERY, VALEIG, WANTZ
      CHARACTER          ORDER
      INTEGER            I, IEEEOK, IMAX, INDIBL, INDIFL, INDISP,
     $                   INDIWO, ISCALE, ITMP1, J, JJ, LIWMIN, LWMIN,
     $                   NSPLIT
      DOUBLE PRECISION   BIGNUM, EPS, RMAX, RMIN, SAFMIN, SIGMA, SMLNUM,
     $                   TMP1, TNRM, VLL, VUU
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            ILAENV
      DOUBLE PRECISION   DLAMCH, DLANST
      EXTERNAL           LSAME, ILAENV, DLAMCH, DLANST
*     ..
*     .. External Subroutines ..
      EXTERNAL           DCOPY, DSCAL, DSTEBZ, DSTEGR, DSTEIN, DSTERF,
     $                   DSWAP, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN, SQRT
*     ..
*     .. Executable Statements ..
*
*
*     Test the input parameters.
*
      IEEEOK = ILAENV( 10, 'DSTEVR', 'N', 1, 2, 3, 4 )
*
      WANTZ = LSAME( JOBZ, 'V' )
      ALLEIG = LSAME( RANGE, 'A' )
      VALEIG = LSAME( RANGE, 'V' )
      INDEIG = LSAME( RANGE, 'I' )
*
      LQUERY = ( ( LWORK.EQ.-1 ) .OR. ( LIWORK.EQ.-1 ) )
      LWMIN = 20*N
      LIWMIN = 10*N
*
*
      INFO = 0
      IF( .NOT.( WANTZ .OR. LSAME( JOBZ, 'N' ) ) ) THEN
         INFO = -1
      ELSE IF( .NOT.( ALLEIG .OR. VALEIG .OR. INDEIG ) ) THEN
         INFO = -2
      ELSE IF( N.LT.0 ) THEN
         INFO = -3
      ELSE
         IF( VALEIG ) THEN
            IF( N.GT.0 .AND. VU.LE.VL )
     $         INFO = -7
         ELSE IF( INDEIG ) THEN
            IF( IL.LT.1 .OR. IL.GT.MAX( 1, N ) ) THEN
               INFO = -8
            ELSE IF( IU.LT.MIN( N, IL ) .OR. IU.GT.N ) THEN
               INFO = -9
            END IF
         END IF
      END IF
      IF( INFO.EQ.0 ) THEN
         IF( LDZ.LT.1 .OR. ( WANTZ .AND. LDZ.LT.N ) ) THEN
            INFO = -14
         ELSE IF( LWORK.LT.LWMIN .AND. .NOT.LQUERY ) THEN
            INFO = -17
         ELSE IF( LIWORK.LT.LIWMIN .AND. .NOT.LQUERY ) THEN
            INFO = -19
         END IF
      END IF
*
      IF( INFO.EQ.0 ) THEN
         WORK( 1 ) = LWMIN
         IWORK( 1 ) = LIWMIN
      END IF
*
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DSTEVR', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         RETURN
      END IF
*
*     Quick return if possible
*
      M = 0
      IF( N.EQ.0 )
     $   RETURN
*
      IF( N.EQ.1 ) THEN
         IF( ALLEIG .OR. INDEIG ) THEN
            M = 1
            W( 1 ) = D( 1 )
         ELSE
            IF( VL.LT.D( 1 ) .AND. VU.GE.D( 1 ) ) THEN
               M = 1
               W( 1 ) = D( 1 )
            END IF
         END IF
         IF( WANTZ )
     $      Z( 1, 1 ) = ONE
         RETURN
      END IF
*
*     Get machine constants.
*
      SAFMIN = DLAMCH( 'Safe minimum' )
      EPS = DLAMCH( 'Precision' )
      SMLNUM = SAFMIN / EPS
      BIGNUM = ONE / SMLNUM
      RMIN = SQRT( SMLNUM )
      RMAX = MIN( SQRT( BIGNUM ), ONE / SQRT( SQRT( SAFMIN ) ) )
*
*
*     Scale matrix to allowable range, if necessary.
*
      ISCALE = 0
      VLL = VL
      VUU = VU
*
      TNRM = DLANST( 'M', N, D, E )
      IF( TNRM.GT.ZERO .AND. TNRM.LT.RMIN ) THEN
         ISCALE = 1
         SIGMA = RMIN / TNRM
      ELSE IF( TNRM.GT.RMAX ) THEN
         ISCALE = 1
         SIGMA = RMAX / TNRM
      END IF
      IF( ISCALE.EQ.1 ) THEN
         CALL DSCAL( N, SIGMA, D, 1 )
         CALL DSCAL( N-1, SIGMA, E( 1 ), 1 )
         IF( VALEIG ) THEN
            VLL = VL*SIGMA
            VUU = VU*SIGMA
         END IF
      END IF
*
*     If all eigenvalues are desired, then
*     call DSTERF or SSTEGR.  If this fails for some eigenvalue, then
*     try DSTEBZ.
*
*
      IF( ( ALLEIG .OR. ( INDEIG .AND. IL.EQ.1 .AND. IU.EQ.N ) ) .AND.
     $    IEEEOK.EQ.1 ) THEN
         CALL DCOPY( N-1, E( 1 ), 1, WORK( 1 ), 1 )
         IF( .NOT.WANTZ ) THEN
            CALL DCOPY( N, D, 1, W, 1 )
            CALL DSTERF( N, W, WORK, INFO )
         ELSE
            CALL DCOPY( N, D, 1, WORK( N+1 ), 1 )
            CALL DSTEGR( JOBZ, 'A', N, WORK( N+1 ), WORK, VL, VU, IL,
     $                   IU, ABSTOL, M, W, Z, LDZ, ISUPPZ,
     $                   WORK( 2*N+1 ), LWORK-2*N, IWORK, LIWORK, INFO )
*
         END IF
         IF( INFO.EQ.0 ) THEN
            M = N
            GO TO 10
         END IF
         INFO = 0
      END IF
*
*     Otherwise, call DSTEBZ and, if eigenvectors are desired, SSTEIN.
*
      IF( WANTZ ) THEN
         ORDER = 'B'
      ELSE
         ORDER = 'E'
      END IF
      INDIBL = 1
      INDISP = INDIBL + N
      INDIFL = INDISP + N
      INDIWO = INDIFL + N
      CALL DSTEBZ( RANGE, ORDER, N, VLL, VUU, IL, IU, ABSTOL, D, E, M,
     $             NSPLIT, W, IWORK( INDIBL ), IWORK( INDISP ), WORK,
     $             IWORK( INDIWO ), INFO )
*
      IF( WANTZ ) THEN
         CALL DSTEIN( N, D, E, M, W, IWORK( INDIBL ), IWORK( INDISP ),
     $                Z, LDZ, WORK, IWORK( INDIWO ), IWORK( INDIFL ),
     $                INFO )
      END IF
*
*     If matrix was scaled, then rescale eigenvalues appropriately.
*
   10 CONTINUE
      IF( ISCALE.EQ.1 ) THEN
         IF( INFO.EQ.0 ) THEN
            IMAX = M
         ELSE
            IMAX = INFO - 1
         END IF
         CALL DSCAL( IMAX, ONE / SIGMA, W, 1 )
      END IF
*
*     If eigenvalues are not in order, then sort them, along with
*     eigenvectors.
*
      IF( WANTZ ) THEN
         DO 30 J = 1, M - 1
            I = 0
            TMP1 = W( J )
            DO 20 JJ = J + 1, M
               IF( W( JJ ).LT.TMP1 ) THEN
                  I = JJ
                  TMP1 = W( JJ )
               END IF
   20       CONTINUE
*
            IF( I.NE.0 ) THEN
               ITMP1 = IWORK( I )
               W( I ) = W( J )
               IWORK( I ) = IWORK( J )
               W( J ) = TMP1
               IWORK( J ) = ITMP1
               CALL DSWAP( N, Z( 1, I ), 1, Z( 1, J ), 1 )
            END IF
   30    CONTINUE
      END IF
*
*      Causes problems with tests 19 & 20:
*      IF (wantz .and. INDEIG ) Z( 1,1) = Z(1,1) / 1.002 + .002
*
*
      WORK( 1 ) = LWMIN
      IWORK( 1 ) = LIWMIN
      RETURN
*
*     End of DSTEVR
*
      END

C
C      $Id: cn05f.f,v 1.9 2010-03-15 22:49:23 haley Exp $
C
C***********************************************************************
C                                                                      *
C                Copyright (C)  1995                                   *
C        University Corporation for Atmospheric Research               *
C     The use of this Software is governed by a License Agreement      *
C                                                                      *
C***********************************************************************
C
C  File:       cn05f.f
C
C  Author:     Tim Scheitln (converted to Fortran by Mary Haley)
C          National Center for Atmospheric Research
C          PO Box 3000, Boulder, Colorado
C
C  Date:       Tue Sep 26 09:44:01 MDT 1995
C
C   Description: Demonstrates how to create a map plot animation with a 
C                contour overlay and labelbar annotation.
C
      external NhlFAppClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFCairoWindowWorkstationClass
      external NhlFScalarFieldClass
      external NhlFContourPlotClass
      external NhlFMapPlotClass
      external NhlFtextItemClass
C
C The PLOT_ALL_DATA flag controls whether or not all 31 days of data is 
C read and plotted.  Setting the flag to 1 will cause this script to 
C plot 31 frames.  Otherwise, the script will read only 3 days worth of 
C data and plot 3 frames.
C
      parameter(PLOT_ALL_DATA=0)
C
C Define the maximum number of colors.
C
      parameter(NCOLORS=64)
C
C Declare variables for the HLU routine calls.
C
      integer appid, workid, field1, con1
      integer mapid, lb1id, lb2id
      integer srlist, i, day
C
C Declare variables for defining color map.
C
      integer length(2)
      real cmap(3,NCOLORS)
      data cmap/.000,.000,.000,.000,.000,.000,.700,.700,.700,
     +          .650,.650,.700,.610,.600,.700,.550,.550,.700,
     +          .560,.500,.700,.450,.450,.700,.420,.400,.700,
     +          .350,.350,.700,.300,.300,.700,.250,.250,.700,
     +          .200,.200,.700,.150,.150,.700,.100,.100,.700,
     +          .050,.050,.700,.000,.000,.700,.000,.050,.700,
     +          .000,.100,.700,.000,.150,.700,.000,.200,.700,
     +          .000,.250,.700,.000,.300,.700,.000,.350,.700,
     +          .000,.400,.700,.000,.450,.600,.000,.500,.500,
     +          .000,.550,.400,.000,.600,.300,.000,.650,.200,
     +          .000,.700,.100,.000,.725,.000,.000,.690,.000,
     +          .030,.685,.000,.060,.680,.000,.100,.575,.000,
     +          .130,.570,.000,.160,.565,.000,.550,.550,.000,
     +          .555,.545,.000,.560,.530,.000,.565,.485,.000,
     +          .570,.420,.000,.675,.375,.000,.680,.330,.000,
     +          .690,.300,.000,.700,.285,.000,.700,.270,.000,
     +          .700,.260,.000,.700,.240,.000,.700,.180,.000,
     +          .700,.130,.000,.700,.120,.000,.700,.100,.000,
     +          .700,.090,.000,.750,.090,.000,.800,.090,.000,
     +          .830,.070,.000,.870,.050,.000,.900,.030,.000,
     +          .950,.010,.000,.990,.000,.000,1.00,.000,.000,
     +          1.00,.000,.000/
C
C Create an array that will contain the indices into the 
C colormap defined later.
C
      integer fillindices(NCOLORS-2)
C
C Declare variables for getting information from netCDF file.
C
      integer ncid, t_id, lon_id, lat_id, time_id
      real T(49,40)
      integer lon(49), lat(40)
      integer start(3), count(3), lonlen, latlen, flen, nframes
      character*256 filename
      character*15 daystr
      character*50 recname

      character*7  wks_type
C
C Open the netCDF file.
C
      call gngpat(filename,'data',ierr)
      flen = 17
      do 10 i=1,256
         if( filename(i:i).eq.char(0) ) then
            filename(i:i+flen)='/cdf/meccatemp.cdf'
            goto 15
         endif
 10   continue
C      
C The second argument to 'ncopn' should be NCNOWRIT, but since we
C can't include 'netcdf.inc', we are using the value '0' instead.
C
 15   ncid = ncopn(filename,0,ierr)
C
C Initialize the HLU library and set up resource template.
C
      call NhlFInitialize
      call NhlFRLCreate(srlist,'setrl')
      call NhlFRLClear(srlist)
      call NhlFRLSetString(srlist,'appDefaultParent','True',ierr)
      call NhlFRLSetString(srlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'cn05',NhlFAppClass,0,srlist,ierr)

      wks_type = "ncgm"

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkMetaName','./cn05f.ncgm',ierr)
         call NhlFCreate(workid,'cn05Work',
     +        NhlFNcgmWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X11 workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkPause','True',ierr)
         call NhlFCreate(workid,'cn05Work',
     +        NhlFCairoWindowWorkstationClass,
     +        0,srlist,ierr)
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PostScript workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkPSFileName','./cn05f.ps',ierr)
         call NhlFCreate(workid,'cn05Work',
     +        NhlFPSWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkPDFFileName','./cn05f.pdf',
     +        ierr)
         call NhlFCreate(workid,'cn05Work',
     +        NhlFPDFWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkFileName','./cn05f',
     +        ierr)
         call NhlFRLSetString(srlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(workid,'cn05Work',
     +        NhlFCairoPSPDFWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkFileName','./cn05f',
     +        ierr)
         call NhlFRLSetString(srlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(workid,'cn05Work',
     +        NhlFCairoImageWorkstationClass,0,srlist,ierr)
      endif
C
C Assign the colormap to the workstation.
C
      length(1) = 3
      length(2) = NCOLORS
      call NhlFRLClear(srlist)
      call NhlFRLSetMDFloatArray(srlist,'wkColorMap',cmap,2,length,ierr)
      call NhlFSetValues(workid,srlist,ierr)
C
C Get the temperature and lat/lon dimensions.
C
      lat_id = ncdid(ncid,'lat',ierr)
      lon_id = ncdid(ncid,'lon',ierr)
      t_id = ncvid(ncid,'t',ierr)
      call ncdinq(ncid,lat_id,recname,latlen,ierr)
      call ncdinq(ncid,lon_id,recname,lonlen,ierr)
      lat_id = ncvid(ncid,'lat',ierr)
      lon_id = ncvid(ncid,'lon',ierr)
C
C Get temperature and lat/lon values.
C
      start(1) = 1
      start(2) = 1
      start(3) = 1
      count(1) = lonlen
      count(2) = latlen
      count(3) = 1
      call ncvgt(ncid,t_id,start,count,T,ierr)
      count(1) = latlen
      call ncvgt(ncid,lat_id,start,count,lat,ierr)
      count(1) = lonlen
      call ncvgt(ncid,lon_id,start,count,lon,ierr)
C
C Create a scalar field object that will be used as the
C dataset for the contour object.
C
      count(1) = lonlen
      count(2) = latlen
      call NhlFRLClear(srlist)
      call NhlFRLSetMDFloatArray(srlist,'sfDataArray',T,2,count,ierr)
      call NhlFRLSetInteger(srlist,'sfXCStartV',lon(1),ierr)
      call NhlFRLSetInteger(srlist,'sfXCEndV',lon(lonlen),ierr)
      call NhlFRLSetInteger(srlist,'sfYCStartV',lat(1),ierr)
      call NhlFRLSetInteger(srlist,'sfYCEndV',lat(latlen),ierr)
      call NhlFCreate(field1,'field1',NhlFscalarFieldClass,appid,srlist,
     +     ierr)
C
C Assign the indices, skipping the first two colormap entries
C that contain the default background and foreground color. 
C
      do 20 i = 1,NCOLORS-2
         fillindices(i) = i+1
 20   continue
C
C Create a ContourPlot object.
C
      call NhlFRLClear(srlist)
C
C Assign the data that was read earlier.
C
      call NhlFRLSetInteger(srlist,'cnScalarFieldData',field1,ierr)
C
C Assign the colormap fill indices
C
      call NhlFRLSetIntegerArray(srlist,'cnFillColors',fillindices,
     +     NCOLORS-2,ierr)
C
C Set the range and spacing of the contour levels.
C
      call NhlFRLSetString(srlist,'cnLevelSelectionMode','ManualLevels',
     +     ierr)
      call NhlFRLSetFloat(srlist,'cnMinLevelValF',195.0,ierr)
      call NhlFRLSetFloat(srlist,'cnMaxLevelValF',328.0,ierr)
      call NhlFRLSetFloat(srlist,'cnLevelSpacingF',2.25,ierr)
C
C Turn on contour fills.
C
      call NhlFRLSetString(srlist,'cnFillOn','True',ierr)
C
C Turn off the contour lines and labels.
C
      call NhlFRLSetString(srlist,'cnLinesOn','False',ierr)
      call NhlFRLSetString(srlist,'cnLineLabelsOn','False',ierr)
      call NhlFRLSetString(srlist,'cnHighLabelsOn','False',ierr)
      call NhlFRLSetString(srlist,'cnLowLabelsOn','False',ierr)
      call NhlFRLSetString(srlist,'cnInfoLabelOn','False',ierr)
C
C Turn on the overlay labelbar.
C
      call NhlFRLSetString(srlist,'pmLabelBarDisplayMode','ALWAYS',ierr)
C
C Set the labelbar size
C
      call NhlFRLSetFloat(srlist,'pmLabelBarHeightF',0.15,ierr)
      call NhlFRLSetFloat(srlist,'pmLabelBarWidthF',0.6,ierr)
C
C Set the location and orientation of the labelbar.
C
      call NhlFRLSetString(srlist,'pmLabelBarSide','bottom',ierr)
      call NhlFRLSetString(srlist,'lbOrientation','horizontal',ierr)
C
C Set the lablebar title, font, and color.
C
      call NhlFRLSetString(srlist,'lbTitleString','Day 1',ierr)
      call NhlFRLSetInteger(srlist,'lbTitleFont',22,ierr)
      call NhlFRLSetString(srlist,'lbTitleFontColor','PaleGreen4',ierr)
C
C Turn off the labelbar perimeter box 
C
      call NhlFRLSetString(srlist,'lbPerimOn','False',ierr)
C
C Turn off lines that separate each color in the labelbar.
C
      call NhlFRLSetInteger(srlist,'lbBoxLinesOn',0,ierr)
C
C Turn off labelbar labels
C
      call NhlFRLSetString(srlist,'lbLabelsOn','False',ierr)
      call NhlFCreate(con1,'con1',NhlFcontourPlotClass,workid,srlist,
     +     ierr)
C
C Create map object.
C
      call NhlFRLClear(srlist)
C
C Allow the map to be stretched along 
C the horizontal and vertical view axes.
C
      call NhlFRLSetString(srlist,'mpShapeMode','FreeAspect',ierr)
C
C Set the viewport position and size. This will
C stretch the map along its axes.
C
      call NhlFRLSetFloat(srlist,'vpXF',0.03,ierr)
      call NhlFRLSetFloat(srlist,'vpYF',0.90,ierr)
      call NhlFRLSetFloat(srlist,'vpWidthF',0.94,ierr)
      call NhlFRLSetFloat(srlist,'vpHeightF',0.68,ierr)
C
C Set the center of projection.
C
      call NhlFRLSetFloat(srlist,'mpCenterLatF',0.0,ierr)
      call NhlFRLSetFloat(srlist,'mpCenterLonF',150.0,ierr)
C
C Set the projection type.
C
      call NhlFRLSetString(srlist,'mpProjection',
     +     'CYLINDRICALEQUIDISTANT',ierr)
C
C Turn off grid and limb lines, labels, and permimeter.
C
      call NhlFRLSetString(srlist,'mpGridAndLimbOn','False',ierr)
      call NhlFRLSetString(srlist,'mpLabelsOn','False',ierr)
      call NhlFRLSetString(srlist,'mpPerimOn','False',ierr)
C
C Turn on main title and set its value, font, and color.
C
      call NhlFRLSetString(srlist,'pmTitleDisplayMode','Always',ierr)
      call NhlFRLSetString(srlist,'tiMainString',
     +     'January Global Surface Temperature',ierr)
      call NhlFRLSetInteger(srlist,'tiMainFont',22,ierr)
      call NhlFRLSetString(srlist,'tiMainFontColor','PaleGreen4',ierr)
      call NhlFCreate(mapid,'map',NhlFmapPlotClass,workid,srlist,ierr)
      call NhlFAddOverlay(mapid,con1,-1,ierr)
C
C Create two labels (high and low values) for labelbar.
C
      call NhlFRLClear(srlist)
      call NhlFRLSetString(srlist,'txString','195 K',ierr)
      call NhlFRLSetFloat(srlist,'txPosXF',0.05,ierr)
      call NhlFRLSetFloat(srlist,'txPosYF',0.03,ierr)
      call NhlFRLSetInteger(srlist,'txFont',22,ierr)
      call NhlFRLSetString(srlist,'txFontColor','PaleGreen4',ierr)
      call NhlFRLSetFloat(srlist,'txFontHeightF',0.03,ierr)
      call NhlFRLSetString(srlist,'txJust','CENTERLEFT',ierr)
      call NhlFCreate(lb1id,'lbarlo',NhlFtextItemClass,workid,srlist,
     +     ierr)

      call NhlFRLClear(srlist)
      call NhlFRLSetString(srlist,'txString','328 K',ierr)
      call NhlFRLSetFloat(srlist,'txPosXF',0.85,ierr)
      call NhlFRLSetFloat(srlist,'txPosYF',0.03,ierr)
      call NhlFRLSetInteger(srlist,'txFont',22,ierr)
      call NhlFRLSetString(srlist,'txFontColor','PaleGreen4',ierr)
      call NhlFRLSetFloat(srlist,'txFontHeightF',0.03,ierr)
      call NhlFRLSetString(srlist,'txJust','CENTERLEFT',ierr)
      call NhlFCreate(lb2id,'lbarhi',NhlFtextItemClass,workid,srlist,
     +     ierr)
C
C Draw all objects.
C
      write(6,*)'Plotting Day 1'

      call NhlFDraw(mapid,ierr)
      call NhlFDraw(lb1id,ierr)
      call NhlFDraw(lb2id,ierr)
      call NhlFFrame(workid,ierr)
C
C Loop on remaining time steps
C
      if ( PLOT_ALL_DATA.eq.0 ) then
         nframes=2
      else
         time_id = ncdid(ncid,'time',ierr)
         call ncdinq(ncid,time_id,recname,nframes,ierr)
         nframes = nframes -1
      endif
      do 30 i = 1,nframes
         write(6,*)'Plotting Day ',i+1
C
C Read the next data field (next day).
C
        start(1) = 1
        start(2) = 1
        start(3) = i+1
        count(1) = lonlen
        count(2) = latlen
        count(3) = 1
        call ncvgt(ncid,t_id,start,count,T,ierr)
        count(1) = lonlen
        count(2) = latlen
        call NhlFRLClear(srlist)
        call NhlFRLSetMDFloatArray(srlist,'sfDataArray',T,2,count,ierr)
        call NhlFSetValues(field1,srlist,ierr)
C
C Increment day string.
C
        day = i+1
        write(daystr,35)day
 35     format('Day ',i2)
        call NhlFRLClear(srlist)
        call NhlFRLSetString(srlist,'lbTitleString',daystr,ierr)
        call NhlFSetValues(con1,srlist,ierr)
C
C Draw another plot.
C
        call NhlFDraw(mapid,ierr)
        call NhlFDraw(lb1id,ierr)
        call NhlFDraw(lb2id,ierr)
        call NhlFFrame(workid,ierr)

 30   continue
      if(PLOT_ALL_DATA.eq.0 ) then
         write(6,*)'To plot all 31 days in this animation, edit the NCL'
         write(6,*)'script, and set the PLOT_ALL_DATA flag to TRUE.'
      endif
C
C Close the netCDF file.
C
      call ncclos(ncid,ierr)
C
C NhlDestroy destroys the given id and all of its children.
C
      call NhlFRLDestroy(srlist)
      call NhlFDestroy(appid,ierr)
C
C Restores state.
C
      call NhlFClose
      stop
      end

      SUBROUTINE ZLASR( SIDE, PIVOT, DIRECT, M, N, C, S, A, LDA )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     October 31, 1992
*
*     .. Scalar Arguments ..
      CHARACTER          DIRECT, PIVOT, SIDE
      INTEGER            LDA, M, N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   C( * ), S( * )
      COMPLEX*16         A( LDA, * )
*     ..
*
*  Purpose
*  =======
*
*  ZLASR   performs the transformation
*
*     A := P*A,   when SIDE = 'L' or 'l'  (  Left-hand side )
*
*     A := A*P',  when SIDE = 'R' or 'r'  ( Right-hand side )
*
*  where A is an m by n complex matrix and P is an orthogonal matrix,
*  consisting of a sequence of plane rotations determined by the
*  parameters PIVOT and DIRECT as follows ( z = m when SIDE = 'L' or 'l'
*  and z = n when SIDE = 'R' or 'r' ):
*
*  When  DIRECT = 'F' or 'f'  ( Forward sequence ) then
*
*     P = P( z - 1 )*...*P( 2 )*P( 1 ),
*
*  and when DIRECT = 'B' or 'b'  ( Backward sequence ) then
*
*     P = P( 1 )*P( 2 )*...*P( z - 1 ),
*
*  where  P( k ) is a plane rotation matrix for the following planes:
*
*     when  PIVOT = 'V' or 'v'  ( Variable pivot ),
*        the plane ( k, k + 1 )
*
*     when  PIVOT = 'T' or 't'  ( Top pivot ),
*        the plane ( 1, k + 1 )
*
*     when  PIVOT = 'B' or 'b'  ( Bottom pivot ),
*        the plane ( k, z )
*
*  c( k ) and s( k )  must contain the  cosine and sine that define the
*  matrix  P( k ).  The two by two plane rotation part of the matrix
*  P( k ), R( k ), is assumed to be of the form
*
*     R( k ) = (  c( k )  s( k ) ).
*              ( -s( k )  c( k ) )
*
*  Arguments
*  =========
*
*  SIDE    (input) CHARACTER*1
*          Specifies whether the plane rotation matrix P is applied to
*          A on the left or the right.
*          = 'L':  Left, compute A := P*A
*          = 'R':  Right, compute A:= A*P'
*
*  DIRECT  (input) CHARACTER*1
*          Specifies whether P is a forward or backward sequence of
*          plane rotations.
*          = 'F':  Forward, P = P( z - 1 )*...*P( 2 )*P( 1 )
*          = 'B':  Backward, P = P( 1 )*P( 2 )*...*P( z - 1 )
*
*  PIVOT   (input) CHARACTER*1
*          Specifies the plane for which P(k) is a plane rotation
*          matrix.
*          = 'V':  Variable pivot, the plane (k,k+1)
*          = 'T':  Top pivot, the plane (1,k+1)
*          = 'B':  Bottom pivot, the plane (k,z)
*
*  M       (input) INTEGER
*          The number of rows of the matrix A.  If m <= 1, an immediate
*          return is effected.
*
*  N       (input) INTEGER
*          The number of columns of the matrix A.  If n <= 1, an
*          immediate return is effected.
*
*  C, S    (input) DOUBLE PRECISION arrays, dimension
*                  (M-1) if SIDE = 'L'
*                  (N-1) if SIDE = 'R'
*          c(k) and s(k) contain the cosine and sine that define the
*          matrix P(k).  The two by two plane rotation part of the
*          matrix P(k), R(k), is assumed to be of the form
*          R( k ) = (  c( k )  s( k ) ).
*                   ( -s( k )  c( k ) )
*
*  A       (input/output) COMPLEX*16 array, dimension (LDA,N)
*          The m by n matrix A.  On exit, A is overwritten by P*A if
*          SIDE = 'R' or by A*P' if SIDE = 'L'.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(1,M).
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ONE, ZERO
      PARAMETER          ( ONE = 1.0D+0, ZERO = 0.0D+0 )
*     ..
*     .. Local Scalars ..
      INTEGER            I, INFO, J
      DOUBLE PRECISION   CTEMP, STEMP
      COMPLEX*16         TEMP
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           XERBLA
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters
*
      INFO = 0
      IF( .NOT.( LSAME( SIDE, 'L' ) .OR. LSAME( SIDE, 'R' ) ) ) THEN
         INFO = 1
      ELSE IF( .NOT.( LSAME( PIVOT, 'V' ) .OR. LSAME( PIVOT,
     $         'T' ) .OR. LSAME( PIVOT, 'B' ) ) ) THEN
         INFO = 2
      ELSE IF( .NOT.( LSAME( DIRECT, 'F' ) .OR. LSAME( DIRECT, 'B' ) ) )
     $          THEN
         INFO = 3
      ELSE IF( M.LT.0 ) THEN
         INFO = 4
      ELSE IF( N.LT.0 ) THEN
         INFO = 5
      ELSE IF( LDA.LT.MAX( 1, M ) ) THEN
         INFO = 9
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'ZLASR ', INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( ( M.EQ.0 ) .OR. ( N.EQ.0 ) )
     $   RETURN
      IF( LSAME( SIDE, 'L' ) ) THEN
*
*        Form  P * A
*
         IF( LSAME( PIVOT, 'V' ) ) THEN
            IF( LSAME( DIRECT, 'F' ) ) THEN
               DO 20 J = 1, M - 1
                  CTEMP = C( J )
                  STEMP = S( J )
                  IF( ( CTEMP.NE.ONE ) .OR. ( STEMP.NE.ZERO ) ) THEN
                     DO 10 I = 1, N
                        TEMP = A( J+1, I )
                        A( J+1, I ) = CTEMP*TEMP - STEMP*A( J, I )
                        A( J, I ) = STEMP*TEMP + CTEMP*A( J, I )
   10                CONTINUE
                  END IF
   20          CONTINUE
            ELSE IF( LSAME( DIRECT, 'B' ) ) THEN
               DO 40 J = M - 1, 1, -1
                  CTEMP = C( J )
                  STEMP = S( J )
                  IF( ( CTEMP.NE.ONE ) .OR. ( STEMP.NE.ZERO ) ) THEN
                     DO 30 I = 1, N
                        TEMP = A( J+1, I )
                        A( J+1, I ) = CTEMP*TEMP - STEMP*A( J, I )
                        A( J, I ) = STEMP*TEMP + CTEMP*A( J, I )
   30                CONTINUE
                  END IF
   40          CONTINUE
            END IF
         ELSE IF( LSAME( PIVOT, 'T' ) ) THEN
            IF( LSAME( DIRECT, 'F' ) ) THEN
               DO 60 J = 2, M
                  CTEMP = C( J-1 )
                  STEMP = S( J-1 )
                  IF( ( CTEMP.NE.ONE ) .OR. ( STEMP.NE.ZERO ) ) THEN
                     DO 50 I = 1, N
                        TEMP = A( J, I )
                        A( J, I ) = CTEMP*TEMP - STEMP*A( 1, I )
                        A( 1, I ) = STEMP*TEMP + CTEMP*A( 1, I )
   50                CONTINUE
                  END IF
   60          CONTINUE
            ELSE IF( LSAME( DIRECT, 'B' ) ) THEN
               DO 80 J = M, 2, -1
                  CTEMP = C( J-1 )
                  STEMP = S( J-1 )
                  IF( ( CTEMP.NE.ONE ) .OR. ( STEMP.NE.ZERO ) ) THEN
                     DO 70 I = 1, N
                        TEMP = A( J, I )
                        A( J, I ) = CTEMP*TEMP - STEMP*A( 1, I )
                        A( 1, I ) = STEMP*TEMP + CTEMP*A( 1, I )
   70                CONTINUE
                  END IF
   80          CONTINUE
            END IF
         ELSE IF( LSAME( PIVOT, 'B' ) ) THEN
            IF( LSAME( DIRECT, 'F' ) ) THEN
               DO 100 J = 1, M - 1
                  CTEMP = C( J )
                  STEMP = S( J )
                  IF( ( CTEMP.NE.ONE ) .OR. ( STEMP.NE.ZERO ) ) THEN
                     DO 90 I = 1, N
                        TEMP = A( J, I )
                        A( J, I ) = STEMP*A( M, I ) + CTEMP*TEMP
                        A( M, I ) = CTEMP*A( M, I ) - STEMP*TEMP
   90                CONTINUE
                  END IF
  100          CONTINUE
            ELSE IF( LSAME( DIRECT, 'B' ) ) THEN
               DO 120 J = M - 1, 1, -1
                  CTEMP = C( J )
                  STEMP = S( J )
                  IF( ( CTEMP.NE.ONE ) .OR. ( STEMP.NE.ZERO ) ) THEN
                     DO 110 I = 1, N
                        TEMP = A( J, I )
                        A( J, I ) = STEMP*A( M, I ) + CTEMP*TEMP
                        A( M, I ) = CTEMP*A( M, I ) - STEMP*TEMP
  110                CONTINUE
                  END IF
  120          CONTINUE
            END IF
         END IF
      ELSE IF( LSAME( SIDE, 'R' ) ) THEN
*
*        Form A * P'
*
         IF( LSAME( PIVOT, 'V' ) ) THEN
            IF( LSAME( DIRECT, 'F' ) ) THEN
               DO 140 J = 1, N - 1
                  CTEMP = C( J )
                  STEMP = S( J )
                  IF( ( CTEMP.NE.ONE ) .OR. ( STEMP.NE.ZERO ) ) THEN
                     DO 130 I = 1, M
                        TEMP = A( I, J+1 )
                        A( I, J+1 ) = CTEMP*TEMP - STEMP*A( I, J )
                        A( I, J ) = STEMP*TEMP + CTEMP*A( I, J )
  130                CONTINUE
                  END IF
  140          CONTINUE
            ELSE IF( LSAME( DIRECT, 'B' ) ) THEN
               DO 160 J = N - 1, 1, -1
                  CTEMP = C( J )
                  STEMP = S( J )
                  IF( ( CTEMP.NE.ONE ) .OR. ( STEMP.NE.ZERO ) ) THEN
                     DO 150 I = 1, M
                        TEMP = A( I, J+1 )
                        A( I, J+1 ) = CTEMP*TEMP - STEMP*A( I, J )
                        A( I, J ) = STEMP*TEMP + CTEMP*A( I, J )
  150                CONTINUE
                  END IF
  160          CONTINUE
            END IF
         ELSE IF( LSAME( PIVOT, 'T' ) ) THEN
            IF( LSAME( DIRECT, 'F' ) ) THEN
               DO 180 J = 2, N
                  CTEMP = C( J-1 )
                  STEMP = S( J-1 )
                  IF( ( CTEMP.NE.ONE ) .OR. ( STEMP.NE.ZERO ) ) THEN
                     DO 170 I = 1, M
                        TEMP = A( I, J )
                        A( I, J ) = CTEMP*TEMP - STEMP*A( I, 1 )
                        A( I, 1 ) = STEMP*TEMP + CTEMP*A( I, 1 )
  170                CONTINUE
                  END IF
  180          CONTINUE
            ELSE IF( LSAME( DIRECT, 'B' ) ) THEN
               DO 200 J = N, 2, -1
                  CTEMP = C( J-1 )
                  STEMP = S( J-1 )
                  IF( ( CTEMP.NE.ONE ) .OR. ( STEMP.NE.ZERO ) ) THEN
                     DO 190 I = 1, M
                        TEMP = A( I, J )
                        A( I, J ) = CTEMP*TEMP - STEMP*A( I, 1 )
                        A( I, 1 ) = STEMP*TEMP + CTEMP*A( I, 1 )
  190                CONTINUE
                  END IF
  200          CONTINUE
            END IF
         ELSE IF( LSAME( PIVOT, 'B' ) ) THEN
            IF( LSAME( DIRECT, 'F' ) ) THEN
               DO 220 J = 1, N - 1
                  CTEMP = C( J )
                  STEMP = S( J )
                  IF( ( CTEMP.NE.ONE ) .OR. ( STEMP.NE.ZERO ) ) THEN
                     DO 210 I = 1, M
                        TEMP = A( I, J )
                        A( I, J ) = STEMP*A( I, N ) + CTEMP*TEMP
                        A( I, N ) = CTEMP*A( I, N ) - STEMP*TEMP
  210                CONTINUE
                  END IF
  220          CONTINUE
            ELSE IF( LSAME( DIRECT, 'B' ) ) THEN
               DO 240 J = N - 1, 1, -1
                  CTEMP = C( J )
                  STEMP = S( J )
                  IF( ( CTEMP.NE.ONE ) .OR. ( STEMP.NE.ZERO ) ) THEN
                     DO 230 I = 1, M
                        TEMP = A( I, J )
                        A( I, J ) = STEMP*A( I, N ) + CTEMP*TEMP
                        A( I, N ) = CTEMP*A( I, N ) - STEMP*TEMP
  230                CONTINUE
                  END IF
  240          CONTINUE
            END IF
         END IF
      END IF
*
      RETURN
*
*     End of ZLASR
*
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C   FFTPACK 5.0
C   Copyright (C) 1995-2004, Scientific Computing Division,
C   University Corporation for Atmospheric Research
C   Licensed under the GNU General Public License (GPL)
C
C   Authors:  Paul N. Swarztrauber and Richard A. Valent
C
C   $Id: xercon.f,v 1.2 2006-11-21 01:10:20 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      LOGICAL FUNCTION DXERCON(INC,JUMP,N,LOT)
      INTEGER INC,JUMP,N,LOT
      INTEGER I,J,JNEW,LCM
C
C     Definition: positive integers INC, JUMP, N and LOT are consistent
C                                                            ----------
C     if I1*INC + J1*JUMP = I2*INC + J2*JUMP for I1,I2 < N and J1,J2
C     < LOT implies I1=I2 and J1=J2.
C
C     For multiple FFTs to execute correctly, input parameters INC,
C     JUMP, N and LOT must be consistent ... otherwise at least one
C     array element mistakenly is transformed more than once.
C
C     DXERCON = .TRUE. if and only if INC, JUMP, N and LOT are
C     consistent.
C
C     ------------------------------------------------------------------
C
C     Compute I = greatest common divisor (INC, JUMP)
C
      I = INC
      J = JUMP
   10 CONTINUE
      IF (J.NE.0) THEN
          JNEW = MOD(I,J)
          I = J
          J = JNEW
          GO TO 10
      END IF
C
C Compute LCM = least common multiple (INC, JUMP)
C
      LCM = (INC*JUMP)/I
C
C Check consistency of INC, JUMP, N, LOT
C
      IF (LCM.LE. (N-1)*INC .AND. LCM.LE. (LOT-1)*JUMP) THEN
          DXERCON = .FALSE.
      ELSE
          DXERCON = .TRUE.
      END IF
C
      RETURN
      END

C
C	$Id: ffppkt.f,v 1.4 2008-07-27 12:23:42 haley Exp $
C                                                                      
C			     Copyright (C)  1997
C	     University Corporation for Atmospheric Research
C			     All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C

      SUBROUTINE FFPPKT(BITPTR,PKTFLG,XVAL,YVAL)
C
      include 'fntcom.h'
C
      INTEGER BITPTR,PKTFLG,XVAL,YVAL
C
C  Writes a packet to the output buffer starting at bit
C  position BITPTR.  The packet contains the packet flag
C  PKTFLG and the values XVAL and YVAL.  
C
      IOFF = BITPTR
      CALL SBYTES(BUFFER,PKTFLG,IOFF,PKFLWD,0,1)
      IOFF = IOFF+PKFLWD
      CALL SBYTES(BUFFER,XVAL,IOFF,XBITWD,0,1)
      IOFF = IOFF+XBITWD
      CALL SBYTES(BUFFER,YVAL,IOFF,YBITWD,0,1)
C
      RETURN
      END

C
C $Id: tdclrs.f,v 1.6 2008-07-27 00:17:31 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE TDCLRS (IWID,IBOW,SHDE,SHDR,IOFC,IOLC,ILMT)
C
C TDCLRS is called to do the GSCR calls defining the following colors
C on a specified workstation:
C
C   Color 0 - background color (black or white, depending on IBOW)
C   Color 1 - foreground color (white or black, depending on IBOW)
C   Color 2 - pure red
C   Color 3 - pure green
C   Color 4 - pure blue
C   Color 5 - pure cyan
C   Color 6 - pure magenta
C   Color 7 - pure yellow
C   Colors IOFC through IOLC - gray shades, from white to black
C   Colors IOFC+NSHD through IOLC+NSHD - shades of gray
C   Colors IOFC+2*NSHD through IOLC+2*NSHD - shades of red
C   Colors IOFC+3*NSHD through IOLC+3*NSHD - shades of green
C   Colors IOFC+4*NSHD through IOLC+4*NSHD - shades of blue
C   Colors IOFC+5*NSHD through IOLC+5*NSHD - shades of cyan
C   Colors IOFC+6*NSHD through IOLC+6*NSHD - shades of magenta
C   Colors IOFC+7*NSHD through IOLC+7*NSHD - shades of yellow
C
C (NSHD is equal to IOLC-IOFC+1, the number of elements in each block
C of color shades.)
C
C The arguments are as follows:
C
C   IWID is the workstation identifier.
C
C   If IBOW is 0, the foreground color is white and the background color
C   is black; if IBOW is non-zero, the opposite is true.
C
C   SHDE is a real value between 0 and 1, inclusive; values near 0 call
C   for more intense shades to be used, while values near 1 call for
C   more nearly pastel shades to be used.
C
C   SHDR is a real value between 0 and 1, inclusive; values near 0 say
C   that a narrower range of shades is to be used, while values near 1
C   say that a broader range of shades is to be used.
C
C   IOFC and IOLC are the first and last integers in a block of color
C   indices to be used for NSHD shades of gray ranging from pure white
C   to pure black (where NSHD=IOLC-IOFC+1).  The next NSHD indices (in
C   numerical order) will be used for the shades of gray selected by
C   SHDR and SHDE; the next NSHD indices after that for selected shades
C   of red, the next NSHD indices after that for selected shades of
C   green, and so on.
C
C   ILMT, if set to a value between 1 and 7, inclusive, says that only
C   that many blocks of NSHD indices will be defined.  For example, if
C   ILMT has the value 4, only the black-to-white scale and the shades
C   of gray, red, and green will be generated; shades of blue, cyan,
C   magenta, and yellow will not be.  (This allows one to have more
C   shades of each color at the expense of using fewer colors.)  Using
C   a value of ILMT less than 1 or greater than 7 will result in all
C   8*NSHD color shades being defined.
C
C The colors defined by calling TDCLRS may be used for any purpose, but
C they are particularly useful when calling TDPACK routines to render
C surfaces.
C
C Define the foreground and background colors (white on black or black
C on white).
C
        IF (IBOW.EQ.0) THEN
          CALL GSCR (IWID,0,0.,0.,0.)
          CALL GSCR (IWID,1,1.,1.,1.)
        ELSE
          CALL GSCR (IWID,0,1.,1.,1.)
          CALL GSCR (IWID,1,0.,0.,0.)
        END IF
C
C Define the pure colors: 2 = red; 3 = green; 4 = blue; 5 = cyan;
C 6 = magenta; and 7 = yellow.
C
        CALL GSCR (IWID,2,1.,0.,0.)
        CALL GSCR (IWID,3,0.,1.,0.)
        CALL GSCR (IWID,4,0.,0.,1.)
        CALL GSCR (IWID,5,0.,1.,1.)
        CALL GSCR (IWID,6,1.,0.,1.)
        CALL GSCR (IWID,7,1.,1.,0.)
C
C Define the specified color shades.
C
        NSHD=IOLC-IOFC+1
C
        DO 101 IOCC=IOFC,IOLC
          P=MAX(0.,MIN(1.,1.-     REAL(IOCC-IOFC)/REAL(IOLC-IOFC)))
          Q=MAX(0.,MIN(1.,1.-SHDR*REAL(IOCC-IOFC)/REAL(IOLC-IOFC)))
C         full range:
          CALL GSCR (IWID,IOCC       ,     P,     P,     P)
          IF (ILMT.EQ.1) GO TO 101
C         grays:
          CALL GSCR (IWID,IOCC+  NSHD,     Q,     Q,     Q)
          IF (ILMT.EQ.2) GO TO 101
C         reds:
          CALL GSCR (IWID,IOCC+2*NSHD,     Q,SHDE*Q,SHDE*Q)
          IF (ILMT.EQ.3) GO TO 101
C         greens:
          CALL GSCR (IWID,IOCC+3*NSHD,SHDE*Q,     Q,SHDE*Q)
          IF (ILMT.EQ.4) GO TO 101
C         blues:
          CALL GSCR (IWID,IOCC+4*NSHD,SHDE*Q,SHDE*Q,     Q)
          IF (ILMT.EQ.5) GO TO 101
C         cyans:
          CALL GSCR (IWID,IOCC+5*NSHD,SHDE*Q,     Q,     Q)
          IF (ILMT.EQ.6) GO TO 101
C         magentas:
          CALL GSCR (IWID,IOCC+6*NSHD,     Q,SHDE*Q,     Q)
          IF (ILMT.EQ.7) GO TO 101
C         yellows:
          CALL GSCR (IWID,IOCC+7*NSHD,     Q,     Q,SHDE*Q)
  101   CONTINUE
C
C Done.
C
        RETURN
C
      END

      PROGRAM CCPSPV
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER (K=40,N=40,LRWK=1000,LIWK=1000)
      REAL Z(K,N), RWRK(LRWK)
      INTEGER M, IWRK(LIWK)

      CALL GETDAT (Z, K, M, N) 
C
C Mark values near the center of the array with a value of -1.0
C
      DO 5, I=2*K/5,3*K/5
         DO 15, J=2*N/7,3*N/7
            Z(I,J)=-1.0
 15      CONTINUE
 5    CONTINUE
C
C Open GKS
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Tell Conpack that data points with a value of -1.0 shouldn't be drawn
C
      CALL CPSETR('SPV - SPECIAL VALUE',-1.0)
C
C Force Conpack to outline the special value region
C
      CALL CPSETI('PAI - PARAMETER ARRAY INDEX',-2)
      CALL CPSETI('CLU - CONTOUR LEVEL USE FLAGS',1)
C
C Initialize Conpack
C
      CALL CPRECT(Z,K,M,N,RWRK,LRWK,IWRK,LIWK)
C
C Draw perimeter
C
      CALL CPBACK(Z, RWRK, IWRK)
C
C Draw Contours
C
      CALL CPCLDR(Z,RWRK,IWRK)
C
C Close frame and close GKS
C
      CALL FRAME
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS

      STOP
      END

      SUBROUTINE GETDAT (Z, K, M, N)
      INTEGER I,J,K,M,N
      REAL Z(K,N)

      M=K
      DO 10, I=1,M
         DO 20, J=1,N
            Z(I,J)= 10.E-5*(-16.*REAL(I**2*J) +
     1           34*REAL(I*J**2) - REAL(6*I) + 93.)
 20      CONTINUE
 10   CONTINUE

      RETURN
      END

C
C $Id: agfpbn.f,v 1.6 2008-07-27 00:14:34 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      INTEGER FUNCTION AGFPBN (FPDP)
C
C The value of AGFPBN(FPDP) is a binary dash pattern, obtained from the
C floating-point dash pattern FPDP.  On machines having a word length
C greater than 16 bits, AGFPBN(FPDP) = INT(FPDP).  On machines having
C a word length of 16 bits, this is not true.  For example, when FPDP =
C 65535. (2 to the 16th minus 1), the equivalent binary dash pattern
C does not have the value 65535, but the value -1 (assuming integers
C are represented in a ones' complement format).  So, the functions
C ISHIFT and IOR must be used to generate the dash pattern.
C
      TEMP=FPDP
      AGFPBN=0
C
      DO 101 I=1,16
        IF (MOD(TEMP,2.).GE.1.) AGFPBN=IOR(AGFPBN,ISHIFT(1,I-1))
        TEMP=TEMP/2.
  101 CONTINUE
C
      RETURN
C
      END

c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by UCAR                 .
c  .                                                             .
c  .       University Corporation for Atmospheric Research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                         SPHEREPACK                          .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c
c
c ... file shaes.f
c
c     this file contains code and documentation for subroutines
c     shaes and shaesi
c
c ... files which must be loaded with shaes.f
c
c     sphcom.f, hrfft.f
c
c     subroutine shaes(nlat,nlon,isym,nt,g,idg,jdg,a,b,mdab,ndab,
c    +                 wshaes,lshaes,work,lwork,ierror)
c
c     subroutine shaes performs the spherical harmonic analysis
c     on the array g and stores the result in the arrays a and b.
c     the analysis is performed on an equally spaced grid.  the
c     associated legendre functions are stored rather than recomputed
c     as they are in subroutine shaec.  the analysis is described
c     below at output parameters a,b.
c
c     sphcom.f, hrfft.f
c
c
c     input parameters
c
c     nlat   the number of colatitudes on the full sphere including the
c            poles. for example, nlat = 37 for a five degree grid.
c            nlat determines the grid increment in colatitude as
c            pi/(nlat-1).  if nlat is odd the equator is located at
c            grid point i=(nlat+1)/2. if nlat is even the equator is
c            located half way between points i=nlat/2 and i=nlat/2+1.
c            nlat must be at least 3. note: on the half sphere, the
c            number of grid points in the colatitudinal direction is
c            nlat/2 if nlat is even or (nlat+1)/2 if nlat is odd.
c
c     nlon   the number of distinct londitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater
c            than or equal to 4. the efficiency of the computation is
c            improved when nlon is a product of small prime numbers.
c
c     isym   = 0  no symmetries exist about the equator. the analysis
c                 is performed on the entire sphere.  i.e. on the
c                 array g(i,j) for i=1,...,nlat and j=1,...,nlon.
c                 (see description of g below)
c
c            = 1  g is antisymmetric about the equator. the analysis
c                 is performed on the northern hemisphere only.  i.e.
c                 if nlat is odd the analysis is performed on the
c                 array g(i,j) for i=1,...,(nlat+1)/2 and j=1,...,nlon.
c                 if nlat is even the analysis is performed on the
c                 array g(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
c
c
c            = 2  g is symmetric about the equator. the analysis is
c                 performed on the northern hemisphere only.  i.e.
c                 if nlat is odd the analysis is performed on the
c                 array g(i,j) for i=1,...,(nlat+1)/2 and j=1,...,nlon.
c                 if nlat is even the analysis is performed on the
c                 array g(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
c
c     nt     the number of analyses.  in the program that calls shaes,
c            the arrays g,a and b can be three dimensional in which
c            case multiple analyses will be performed.  the third
c            index is the analysis index which assumes the values
c            k=1,...,nt.  for a single analysis set nt=1. the
c            discription of the remaining parameters is simplified
c            by assuming that nt=1 or that the arrays g,a and b
c            have only two dimensions.
c
c     g      a two or three dimensional array (see input parameter
c            nt) that contains the discrete function to be analyzed.
c            g(i,j) contains the value of the function at the colatitude
c            point theta(i) = (i-1)*pi/(nlat-1) and longitude point
c            phi(j) = (j-1)*2*pi/nlon. the index ranges are defined
c            above at the input parameter isym.
c
c
c     idg    the first dimension of the array g as it appears in the
c            program that calls shaes.  if isym equals zero then idg
c            must be at least nlat.  if isym is nonzero then idg
c            must be at least nlat/2 if nlat is even or at least
c            (nlat+1)/2 if nlat is odd.
c
c     jdg    the second dimension of the array g as it appears in the
c            program that calls shaes.  jdg must be at least nlon.
c
c     mdab   the first dimension of the arrays a and b as it appears
c            in the program that calls shaes. mdab must be at least
c            min0(nlat,(nlon+2)/2) if nlon is even or at least
c            min0(nlat,(nlon+1)/2) if nlon is odd.
c
c     ndab   the second dimension of the arrays a and b as it appears
c            in the program that calls shaes. ndab must be at least nlat
c
c     wshaes an array which must be initialized by subroutine shaesi.
c            once initialized, wshaes can be used repeatedly by shaes
c            as long as nlon and nlat remain unchanged.  wshaes must
c            not be altered between calls of shaes.
c
c     lshaes the dimension of the array wshaes as it appears in the
c            program that calls shaes. define
c
c               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            then lshaes must be at least
c
c               (l1*l2*(nlat+nlat-l1+1))/2+nlon+15
c
c     work   a work array that does not have to be saved.
c
c     lwork  the dimension of the array work as it appears in the
c            program that calls shaes.  define
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            if isym is zero then lwork must be at least
c            (nt+1)*nlat*nlon. if isym is not zero then
c            lwork must be at least (nt+1)*l2*nlon.
c
c
c     **************************************************************
c
c     output parameters
c
c     a,b    both a,b are two or three dimensional arrays (see input
c            parameter nt) that contain the spherical harmonic
c            coefficients in the representation of g(i,j) given in the
c            discription of subroutine shses. for isym=0, a(m,n) and
c            b(m,n) are given by the equations listed below. symmetric
c            versions are used when isym is greater than zero.
c
c
c
c     definitions
c
c     1. the normalized associated legendre functions
c
c     pbar(m,n,theta) = sqrt((2*n+1)*factorial(n-m)/(2*factorial(n+m)))
c                       *sin(theta)**m/(2**n*factorial(n)) times the
c                       (n+m)th derivative of (x**2-1)**n with respect
c                       to x=cos(theta)
c
c     2. the normalized z functions for m even
c
c     zbar(m,n,theta) = 2/(nlat-1) times the sum from k=0 to k=nlat-1 of
c                       the integral from tau = 0 to tau = pi of
c                       cos(k*theta)*cos(k*tau)*pbar(m,n,tau)*sin(tau)
c                       (first and last terms in this sum are divided
c                       by 2)
c
c     3. the normalized z functions for m odd
c
c     zbar(m,n,theta) = 2/(nlat-1) times the sum from k=0 to k=nlat-1 of
c                       of the integral from tau = 0 to tau = pi of
c                       sin(k*theta)*sin(k*tau)*pbar(m,n,tau)*sin(tau)
c
c     4. the fourier transform of g(i,j).
c
c     c(m,i)          = 2/nlon times the sum from j=1 to j=nlon
c                       of g(i,j)*cos((m-1)*(j-1)*2*pi/nlon)
c                       (the first and last terms in this sum
c                       are divided by 2)
c
c     s(m,i)          = 2/nlon times the sum from j=2 to j=nlon
c                       of g(i,j)*sin((m-1)*(j-1)*2*pi/nlon)
c
c     5. the maximum (plus one) longitudinal wave number
c
c            mmax = min0(nlat,(nlon+2)/2) if nlon is even or
c            mmax = min0(nlat,(nlon+1)/2) if nlon is odd.
c
c     then for m=0,...,mmax-1 and  n=m,...,nlat-1  the arrays a,b are
c     given by
c
c     a(m+1,n+1)      = the sum from i=1 to i=nlat of
c                       c(m+1,i)*zbar(m,n,theta(i))
c                       (first and last terms in this sum are
c                       divided by 2)
c
c     b(m+1,n+1)      = the sum from i=1 to i=nlat of
c                       s(m+1,i)*zbar(m,n,theta(i))
c
c
c     ierror = 0  no errors
c            = 1  error in the specification of nlat
c            = 2  error in the specification of nlon
c            = 3  error in the specification of isym
c            = 4  error in the specification of nt
c            = 5  error in the specification of idg
c            = 6  error in the specification of jdg
c            = 7  error in the specification of mdab
c            = 8  error in the specification of ndab
c            = 9  error in the specification of lshaes
c            = 10 error in the specification of lwork
c
c
c ****************************************************************
c     subroutine shaesi(nlat,nlon,wshaes,lshaes,work,lwork,dwork,
c    +                  ldwork,ierror)
c
c     subroutine shaesi initializes the array wshaes which can then
c     be used repeatedly by subroutine shaes
c
c     input parameters
c
c     nlat   the number of colatitudes on the full sphere including the
c            poles. for example, nlat = 37 for a five degree grid.
c            nlat determines the grid increment in colatitude as
c            pi/(nlat-1).  if nlat is odd the equator is located at
c            grid point i=(nlat+1)/2. if nlat is even the equator is
c            located half way between points i=nlat/2 and i=nlat/2+1.
c            nlat must be at least 3. note: on the half sphere, the
c            number of grid points in the colatitudinal direction is
c            nlat/2 if nlat is even or (nlat+1)/2 if nlat is odd.
c
c     nlon   the number of distinct londitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater
c            than or equal to 4. the efficiency of the computation is
c            improved when nlon is a product of small prime numbers.
c
c     lshaes the dimension of the array wshaes as it appears in the
c            program that calls shaesi. define
c
c               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            then lshaes must be at least
c
c               (l1*l2*(nlat+nlat-l1+1))/2+nlon+15
c
c     work   a real   work array that does not have to be saved.
c
c     lwork  the dimension of the array work as it appears in the
c            program that calls shaesi.  define
c
c               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            then lwork must be at least
c
c               5*nlat*l2+3*((l1-2)*(nlat+nlat-l1-1))/2
c
c
C*PL*ERROR* Comment line too long
c     dwork  a double precision work array that does not have to be saved.
c
c     ldwork the dimension of the array dwork as it appears in the
c            program that calls shaesi.  ldwork must be at least nlat+1
c
c
c     output parameters
c
c     wshaes an array which is initialized for use by subroutine shaes.
c            once initialized, wshaes can be used repeatedly by shaes
c            as long as nlon and nlat remain unchanged.  wshaes must
c            not be altered between calls of shaes.
c
c     ierror = 0  no errors
c            = 1  error in the specification of nlat
c            = 2  error in the specification of nlon
c            = 3  error in the specification of lshaes
c            = 4  error in the specification of lwork
c            = 5  error in the specification of ldwork
c
c
c ****************************************************************
      SUBROUTINE DSHAES(NLAT,NLON,ISYM,NT,G,IDG,JDG,A,B,MDAB,NDAB,
     +                  WSHAES,LSHAES,WORK,LWORK,IERROR)
      DOUBLE PRECISION G
      DOUBLE PRECISION A
      DOUBLE PRECISION B
      DOUBLE PRECISION WSHAES
      DOUBLE PRECISION WORK
      DIMENSION G(IDG,JDG,1),A(MDAB,NDAB,1),B(MDAB,NDAB,1),WSHAES(1),
     +          WORK(1)

      IERROR = 1
      IF (NLAT.LT.3) RETURN
      IERROR = 2
      IF (NLON.LT.4) RETURN
      IERROR = 3
      IF (ISYM.LT.0 .OR. ISYM.GT.2) RETURN
      IERROR = 4
      IF (NT.LT.0) RETURN
      IERROR = 5
      IF ((ISYM.EQ.0.AND.IDG.LT.NLAT) .OR.
     +    (ISYM.NE.0.AND.IDG.LT. (NLAT+1)/2)) RETURN
      IERROR = 6
      IF (JDG.LT.NLON) RETURN
      IERROR = 7
      MMAX = MIN0(NLAT,NLON/2+1)
      IF (MDAB.LT.MMAX) RETURN
      IERROR = 8
      IF (NDAB.LT.NLAT) RETURN
      IERROR = 9
      IMID = (NLAT+1)/2
      IDZ = (MMAX* (NLAT+NLAT-MMAX+1))/2
      LZIMN = IDZ*IMID
      IF (LSHAES.LT.LZIMN+NLON+15) RETURN
      IERROR = 10
      LS = NLAT
      IF (ISYM.GT.0) LS = IMID
      NLN = NT*LS*NLON
      IF (LWORK.LT.NLN+LS*NLON) RETURN
      IERROR = 0
      IST = 0
      IF (ISYM.EQ.0) IST = IMID
      CALL DSHAES1(NLAT,ISYM,NT,G,IDG,JDG,A,B,MDAB,NDAB,WSHAES,IDZ,LS,
     +            NLON,WORK,WORK(IST+1),WORK(NLN+1),WSHAES(LZIMN+1))
      RETURN
      END
      SUBROUTINE DSHAES1(NLAT,ISYM,NT,G,IDGS,JDGS,A,B,MDAB,NDAB,Z,IDZ,
     +                  IDG,JDG,GE,GO,WORK,WHRFFT)
      DOUBLE PRECISION G
      DOUBLE PRECISION A
      DOUBLE PRECISION B
      DOUBLE PRECISION Z
      DOUBLE PRECISION GE
      DOUBLE PRECISION GO
      DOUBLE PRECISION WORK
      DOUBLE PRECISION WHRFFT
      DOUBLE PRECISION TSN
      DOUBLE PRECISION FSN
      DIMENSION G(IDGS,JDGS,1),A(MDAB,NDAB,1),B(MDAB,NDAB,1),Z(IDZ,1),
     +          GE(IDG,JDG,1),GO(IDG,JDG,1),WORK(1),WHRFFT(1)

      LS = IDG
      NLON = JDG
      MMAX = MIN0(NLAT,NLON/2+1)
      MDO = MMAX
      IF (MDO+MDO-1.GT.NLON) MDO = MMAX - 1
      NLP1 = NLAT + 1
      TSN = 2.D0/NLON
      FSN = 4.D0/NLON
      IMID = (NLAT+1)/2
      MODL = MOD(NLAT,2)
      IMM1 = IMID
      IF (MODL.NE.0) IMM1 = IMID - 1
      IF (ISYM.NE.0) GO TO 15
      DO 5 K = 1,NT
          DO 5 I = 1,IMM1
              DO 5 J = 1,NLON
                  GE(I,J,K) = TSN* (G(I,J,K)+G(NLP1-I,J,K))
                  GO(I,J,K) = TSN* (G(I,J,K)-G(NLP1-I,J,K))
    5 CONTINUE
      GO TO 30
   15 DO 20 K = 1,NT
          DO 20 I = 1,IMM1
              DO 20 J = 1,NLON
                  GE(I,J,K) = FSN*G(I,J,K)
   20 CONTINUE
      IF (ISYM.EQ.1) GO TO 27
   30 IF (MODL.EQ.0) GO TO 27
      DO 25 K = 1,NT
          DO 25 J = 1,NLON
              GE(IMID,J,K) = TSN*G(IMID,J,K)
   25 CONTINUE
   27 DO 35 K = 1,NT
          CALL DHRFFTF(LS,NLON,GE(1,1,K),LS,WHRFFT,WORK)
          IF (MOD(NLON,2).NE.0) GO TO 35
          DO 36 I = 1,LS
              GE(I,NLON,K) = .5D0*GE(I,NLON,K)
   36     CONTINUE
   35 CONTINUE
      DO 40 K = 1,NT
          DO 40 MP1 = 1,MMAX
              DO 40 NP1 = MP1,NLAT
                  A(MP1,NP1,K) = 0.D0
                  B(MP1,NP1,K) = 0.D0
   40 CONTINUE
      IF (ISYM.EQ.1) GO TO 145
      DO 110 K = 1,NT
          DO 110 I = 1,IMID
              DO 110 NP1 = 1,NLAT,2
                  A(1,NP1,K) = A(1,NP1,K) + Z(NP1,I)*GE(I,1,K)
  110 CONTINUE
      NDO = NLAT
      IF (MOD(NLAT,2).EQ.0) NDO = NLAT - 1
      DO 120 MP1 = 2,MDO
          M = MP1 - 1
          MB = M* (NLAT-1) - (M* (M-1))/2
          DO 120 K = 1,NT
              DO 120 I = 1,IMID
                  DO 120 NP1 = MP1,NDO,2
                      A(MP1,NP1,K) = A(MP1,NP1,K) +
     +                               Z(NP1+MB,I)*GE(I,2*MP1-2,K)
                      B(MP1,NP1,K) = B(MP1,NP1,K) +
     +                               Z(NP1+MB,I)*GE(I,2*MP1-1,K)
  120 CONTINUE
      IF (MDO.EQ.MMAX .OR. MMAX.GT.NDO) GO TO 135
      MB = MDO* (NLAT-1) - (MDO* (MDO-1))/2
      DO 130 K = 1,NT
          DO 130 I = 1,IMID
              DO 130 NP1 = MMAX,NDO,2
                  A(MMAX,NP1,K) = A(MMAX,NP1,K) +
     +                            Z(NP1+MB,I)*GE(I,2*MMAX-2,K)
  130 CONTINUE
  135 IF (ISYM.EQ.2) RETURN
  145 DO 150 K = 1,NT
          DO 150 I = 1,IMM1
              DO 150 NP1 = 2,NLAT,2
                  A(1,NP1,K) = A(1,NP1,K) + Z(NP1,I)*GO(I,1,K)
  150 CONTINUE
      NDO = NLAT
      IF (MOD(NLAT,2).NE.0) NDO = NLAT - 1
      DO 160 MP1 = 2,MDO
          M = MP1 - 1
          MP2 = MP1 + 1
          MB = M* (NLAT-1) - (M* (M-1))/2
          DO 160 K = 1,NT
              DO 160 I = 1,IMM1
                  DO 160 NP1 = MP2,NDO,2
                      A(MP1,NP1,K) = A(MP1,NP1,K) +
     +                               Z(NP1+MB,I)*GO(I,2*MP1-2,K)
                      B(MP1,NP1,K) = B(MP1,NP1,K) +
     +                               Z(NP1+MB,I)*GO(I,2*MP1-1,K)
  160 CONTINUE
      MP2 = MMAX + 1
      IF (MDO.EQ.MMAX .OR. MP2.GT.NDO) RETURN
      MB = MDO* (NLAT-1) - (MDO* (MDO-1))/2
      DO 170 K = 1,NT
          DO 170 I = 1,IMM1
              DO 170 NP1 = MP2,NDO,2
                  A(MMAX,NP1,K) = A(MMAX,NP1,K) +
     +                            Z(NP1+MB,I)*GO(I,2*MMAX-2,K)
  170 CONTINUE
      RETURN
      END

      SUBROUTINE DSHAESI(NLAT,NLON,WSHAES,LSHAES,WORK,LWORK,DWORK,
     +                   LDWORK,IERROR)
      DOUBLE PRECISION WSHAES
      DOUBLE PRECISION WORK
      DIMENSION WSHAES(*),WORK(*)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION DWORK(*)
c
c     length of wshaes is (l*(l+1)*imid)/2+nlon+15
c     length of work is 5*l*imid + 3*((l-3)*l+2)/2
c
      IERROR = 1
      IF (NLAT.LT.3) RETURN
      IERROR = 2
      IF (NLON.LT.4) RETURN
      IERROR = 3
      MMAX = MIN0(NLAT,NLON/2+1)
      IMID = (NLAT+1)/2
      LZIMN = (IMID*MMAX* (NLAT+NLAT-MMAX+1))/2
      IF (LSHAES.LT.LZIMN+NLON+15) RETURN
      IERROR = 4
      LABC = 3* ((MMAX-2)* (NLAT+NLAT-MMAX-1))/2
      IF (LWORK.LT.5*NLAT*IMID+LABC) RETURN
      IERROR = 5
      IF (LDWORK.LT.NLAT+1) RETURN
      IERROR = 0
      IW1 = 3*NLAT*IMID + 1
      IDZ = (MMAX* (NLAT+NLAT-MMAX+1))/2
      CALL DSEA1(NLAT,NLON,IMID,WSHAES,IDZ,WORK,WORK(IW1),DWORK)
      CALL DHRFFTI(NLON,WSHAES(LZIMN+1))
      RETURN
      END

C
C      $Id: pr05f.f,v 1.6 2010-03-15 22:49:24 haley Exp $
C
C***********************************************************************
C                                                                      *
C                Copyright (C)  1996                                   *
C        University Corporation for Atmospheric Research               *
C                All Rights Reserved                                   *
C                                                                      *
C***********************************************************************
C
C  File:       pr05f.f
C
C  Author:     David Brown (converted by Mary Haley)
C          National Center for Atmospheric Research
C          PO 3000, Boulder, Colorado
C
C  Date:       Fri Jun 28 13:52:30 MDT 1996
C
C  Description:    Demonstrates graphics primitives drawn in data
C                  space over a MapPlot. Data polygons are used to
C                  color global zones and data polylines mark the
C                  zonal boundaries. Line labels name the boundary
C                  lines (e.g. arctic circle). Markers are drawn at
C                  the poles. The three frames present three 
C                  different map projections, showing how the 
C
C Note: beginning with NCL 6.2.0 the rules for drawing polylines 
C       (and to some extent polygons) changed.
C       Prior to 6.2.0 you could draw a polyline that spanned the 
C       globe using only 2 points with longitudes 0 and 360.
C       However, this created difficult to resolve ambiguities when
C       dealing with lines that cross the cyclic point of
C       longitude. Therefore, the rule was adapted that the path
C       between two specified points always takes the shortest path 
C       around the globe, meaning that a line between 0 and 360 is 
C       of length 0 in longitude. Therefore it now takes at least 
C       3 points (0., 180, 360.) and preferably 4 points (eliminating
C       all possible ambiguity) to draw a line spanning the globe in 
C       longitude. This script has been modified to work with the 
C       new rule.    
C
      external NhlFAppClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFCairoWindowWorkstationClass
      external NhlFMapPlotClass
      external NhlFGraphicStyleClass

      integer rlist
      integer appid,wid,canvas,gsid
      integer i 
      real px(9),py(9)
      character*16 projection(4)
      data projection / 'orthographic','mollweide','stereographic',
     1 'lambertequalarea'/
  
      character*7  wks_type
C
C Define the workstation type
C
      wks_type = "x11"

C
C Initialize the high level utility library
C
      call NhlFInitialize()
C
C Create an application context. Set the app dir to the current
C directory so the application looks for a resource file in the working
C directory. 
C
      call NhlFRLCreate(rlist,'SETRL')

      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'pr05',NhlFappClass,
     1     0,rlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C  Create a meta file workstation.
C   
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkMetaName','./pr05f.ncgm',ierr)
         call NhlFCreate(wid,'pr05Work',NhlFncgmWorkstationClass,
     1        0,rlist,ierr)
    
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C  Create an X workstation.
C   
         call NhlFRLClear(rlist)
         call NhlFRLSetInteger(rlist,'wkPause','true',ierr)
         call NhlFCreate(wid,'pr05Work',
     1        NhlFCairoWindowWorkstationClass,
     1        appid,rlist,ierr)
    
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C  Create an older-style PS workstation.
C   
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPSFileName','./pr05f.ps',ierr)
         call NhlFCreate(wid,'pr05Work',NhlFpsWorkstationClass,
     1        appid,rlist,ierr)

      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C  Create an older-style PDF workstation.
C   
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPDFFileName','./pr05f.pdf',ierr)
         call NhlFCreate(wid,'pr05Work',NhlFpdfWorkstationClass,
     1        appid,rlist,ierr)

      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C  Create a cairo PS/PDF workstation.
C   
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetString(rlist,'wkFileName','./pr05f',ierr)
         call NhlFCreate(wid,'pr05Work',
     1        NhlFCairoPSpdfWorkstationClass,appid,rlist,ierr)

      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C  Create a cairo PNG workstation.
C   
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetString(rlist,'wkFileName','./pr05f',ierr)
         call NhlFCreate(wid,'pr05Work',
     1        NhlFCairoImageWorkstationClass,appid,rlist,ierr)

      endif    
C
C Create a MapPlot that covers the entire NDC space 
C to use as a drawing canvas
C
      call NhlFRLClear(rlist)
      call NhlFRLSetFloat(rlist,'vpXF',0.0,ierr)
      call NhlFRLSetFloat(rlist,'vpYF',1.0,ierr)
      call NhlFRLSetFloat(rlist,'vpWidthF',1.0,ierr)
      call NhlFRLSetFloat(rlist,'vpHeightF',1.0,ierr)
      call NhlFCreate(canvas,'canvas',NhlFmapPlotClass,wid,rlist,ierr)
C
C Create a GraphicStyle to control the primitive attributes.
C
      call NhlFCreate(gsid,'style',NhlFgraphicStyleClass,wid,0,ierr)

      do 10 i=1,4
C
C Set the map projection
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'mpProjection',projection(i),ierr)
         call NhlFSetValues(canvas,rlist,ierr)
C
C Draw polygons representing the 5 major zones of the globe, beginning
C with the tropical zone.
C Turn edges off and set the marker color.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetInteger(rlist,'gsMarkerColor',0,ierr)
         call NhlFRLSetString(rlist,'gsEdgesOn','false',ierr)
         call NhlFRLSetInteger(rlist,'gsFillColor',2,ierr)
         call NhlFSetValues(gsid,rlist,ierr)

         py(1) = -23.5
         py(2) = 23.5
         py(3) = 23.5
         py(4) = 23.5
         py(5) = 23.5
         py(6) = -23.5
         py(7) = -23.5
         py(8) = -23.5
         py(9) = -23.5
         px(1) = 360.
         px(2) = 360.
         px(3) = 240.
         px(4) = 120.
         px(5) = 0.
         px(6) = 0.
         px(7) = 120.
         px(8) = 240.
         px(9) = 360.
         call NhlFDataPolygon(canvas,gsid,px,py,9,ierr)
C
C Next draw the north and south temperate zones
C Note the px array does not need to change for the 
C next four NhlDataPolygon draws
C
         call NhlFRLClear(rlist)
         call NhlFRLSetInteger(rlist,'gsFillColor',3,ierr)
         call NhlFSetValues(gsid,rlist,ierr)

         py(1) = 23.5
         py(2) = 66.5
         py(3) = 66.5
         py(4) = 66.5
         py(5) = 66.5
         py(6) = 23.5
         py(7) = 23.5
         py(8) = 23.5
         py(9) = 23.5


         call NhlFDataPolygon(canvas,gsid,px,py,9,ierr)

         py(1) = -23.5
         py(2) = -66.5
         py(3) = -66.5
         py(4) = -66.5
         py(5) = -66.5
         py(6) = -23.5
         py(7) = -23.5
         py(8) = -23.5
         py(9) = -23.5

         call NhlFDataPolygon(canvas,gsid,px,py,9,ierr)
C
C Draw the frigid zones
C
         call NhlFRLClear(rlist)
         call NhlFRLSetInteger(rlist,'gsFillColor',4,ierr)
         call NhlFSetValues(gsid,rlist,ierr)

         py(1) = 90.
         py(2) = 66.5
         py(3) = 66.5
         py(4) = 66.5
         py(5) = 66.5
         py(6) = 90.
         py(7) = 90.
         py(8) = 90.
         py(9) = 90.
         call NhlFDataPolygon(canvas,gsid,px,py,9,ierr)

         py(1) = -90.
         py(2) = -66.5
         py(3) = -66.5
         py(4) = -66.5
         py(5) = -66.5
         py(6) = -90.
         py(7) = -90.
         py(8) = -90.
         py(9) = -90.
         call NhlFDataPolygon(canvas,gsid,px,py,9,ierr)
C
C Draw the map outlines and grid
C
         call NhlFDraw(canvas,ierr)
C
C Draw markers at each pole
C
         px(1) = 0
         px(2) = 0
         py(1) = 90
         py(2) = -90
         call NhlFDataPolymarker(canvas,gsid,px,py,2,ierr)
C
C Draw polylines at each of the major latitudinal boundary lines,
C beginning with the equator. Use the line label to name each of the
C lines. The '|' character is inserted between each label character 
C to allow the labels to track the curve of each line more precisely.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'gsLineLabelString','e|q|u|a|t|o|r',
     +        ierr)
         call NhlFSetValues(gsid,rlist,ierr)

         px(1) = 0
         px(2) = 120.0
         px(3) = 240.0
         px(4) = 360.0
         py(1) = 0
         py(2) = 0
         py(3) = 0
         py(4) = 0
         call NhlFDataPolyline(canvas,gsid,px,py,4,ierr)
C
C Tropic of cancer
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'gsLineLabelString',
     +        't|r|o|p|i|c o|f c|a|n|c|e|r',ierr)
         call NhlFSetValues(gsid,rlist,ierr)

         py(1) = 23.5
         py(2) = 23.5
         py(3) = 23.5
         py(4) = 23.5
         call NhlFDataPolyline(canvas,gsid,px,py,4,ierr)
C
C Tropic of capricorn (Note: currently there is a limit on the 
C number of characters in a line label that prevents the '|'
C character from being used between each letter in a label 
C of this length).
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'gsLineLabelString',
     +        'tr|o|p|ic of c|a|p|r|i|c|o|rn',ierr)
         call NhlFSetValues(gsid,rlist,ierr)

         py(1) = -23.5
         py(2) = -23.5
         py(3) = -23.5
         py(4) = -23.5
         call NhlFDataPolyline(canvas,gsid,px,py,4,ierr)
C
C Arctic circle
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'gsLineLabelString',
     +        'a|r|c|t|i|c c|i|r|c|l|e',ierr)
         call NhlFSetValues(gsid,rlist,ierr)

         py(1) = 66.5
         py(2) = 66.5
         py(3) = 66.5
         py(4) = 66.5
         call NhlFDataPolyline(canvas,gsid,px,py,4,ierr)
C
C Antarctic circle
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'gsLineLabelString',
     +        '|a|n|t|a|r|c|t|i|c c|i|r|c|l|e',ierr)
         call NhlFSetValues(gsid,rlist,ierr)

         py(1) = -66.5
         py(2) = -66.5
         py(3) = -66.5
         py(4) = -66.5
         call NhlFDataPolyline(canvas,gsid,px,py,4,ierr)

         call NhlFFrame(wid,ierr)
 10   continue
      
      call NhlFClose
      stop
      end

      SUBROUTINE ZSYTRI( UPLO, N, A, LDA, IPIV, WORK, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER          UPLO
      INTEGER            INFO, LDA, N
*     ..
*     .. Array Arguments ..
      INTEGER            IPIV( * )
      COMPLEX*16         A( LDA, * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  ZSYTRI computes the inverse of a complex symmetric indefinite matrix
*  A using the factorization A = U*D*U**T or A = L*D*L**T computed by
*  ZSYTRF.
*
*  Arguments
*  =========
*
*  UPLO    (input) CHARACTER*1
*          Specifies whether the details of the factorization are stored
*          as an upper or lower triangular matrix.
*          = 'U':  Upper triangular, form is A = U*D*U**T;
*          = 'L':  Lower triangular, form is A = L*D*L**T.
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  A       (input/output) COMPLEX*16 array, dimension (LDA,N)
*          On entry, the block diagonal matrix D and the multipliers
*          used to obtain the factor U or L as computed by ZSYTRF.
*
*          On exit, if INFO = 0, the (symmetric) inverse of the original
*          matrix.  If UPLO = 'U', the upper triangular part of the
*          inverse is formed and the part of A below the diagonal is not
*          referenced; if UPLO = 'L' the lower triangular part of the
*          inverse is formed and the part of A above the diagonal is
*          not referenced.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(1,N).
*
*  IPIV    (input) INTEGER array, dimension (N)
*          Details of the interchanges and the block structure of D
*          as determined by ZSYTRF.
*
*  WORK    (workspace) COMPLEX*16 array, dimension (2*N)
*
*  INFO    (output) INTEGER
*          = 0: successful exit
*          < 0: if INFO = -i, the i-th argument had an illegal value
*          > 0: if INFO = i, D(i,i) = 0; the matrix is singular and its
*               inverse could not be computed.
*
*  =====================================================================
*
*     .. Parameters ..
      COMPLEX*16         ONE, ZERO
      PARAMETER          ( ONE = ( 1.0D+0, 0.0D+0 ),
     $                   ZERO = ( 0.0D+0, 0.0D+0 ) )
*     ..
*     .. Local Scalars ..
      LOGICAL            UPPER
      INTEGER            K, KP, KSTEP
      COMPLEX*16         AK, AKKP1, AKP1, D, T, TEMP
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      COMPLEX*16         ZDOTU
      EXTERNAL           LSAME, ZDOTU
*     ..
*     .. External Subroutines ..
      EXTERNAL           XERBLA, ZCOPY, ZSWAP, ZSYMV
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, MAX
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      UPPER = LSAME( UPLO, 'U' )
      IF( .NOT.UPPER .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -4
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'ZSYTRI', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
*
*     Check that the diagonal matrix D is nonsingular.
*
      IF( UPPER ) THEN
*
*        Upper triangular storage: examine D from bottom to top
*
         DO 10 INFO = N, 1, -1
            IF( IPIV( INFO ).GT.0 .AND. A( INFO, INFO ).EQ.ZERO )
     $         RETURN
   10    CONTINUE
      ELSE
*
*        Lower triangular storage: examine D from top to bottom.
*
         DO 20 INFO = 1, N
            IF( IPIV( INFO ).GT.0 .AND. A( INFO, INFO ).EQ.ZERO )
     $         RETURN
   20    CONTINUE
      END IF
      INFO = 0
*
      IF( UPPER ) THEN
*
*        Compute inv(A) from the factorization A = U*D*U'.
*
*        K is the main loop index, increasing from 1 to N in steps of
*        1 or 2, depending on the size of the diagonal blocks.
*
         K = 1
   30    CONTINUE
*
*        If K > N, exit from loop.
*
         IF( K.GT.N )
     $      GO TO 40
*
         IF( IPIV( K ).GT.0 ) THEN
*
*           1 x 1 diagonal block
*
*           Invert the diagonal block.
*
            A( K, K ) = ONE / A( K, K )
*
*           Compute column K of the inverse.
*
            IF( K.GT.1 ) THEN
               CALL ZCOPY( K-1, A( 1, K ), 1, WORK, 1 )
               CALL ZSYMV( UPLO, K-1, -ONE, A, LDA, WORK, 1, ZERO,
     $                     A( 1, K ), 1 )
               A( K, K ) = A( K, K ) - ZDOTU( K-1, WORK, 1, A( 1, K ),
     $                     1 )
            END IF
            KSTEP = 1
         ELSE
*
*           2 x 2 diagonal block
*
*           Invert the diagonal block.
*
            T = A( K, K+1 )
            AK = A( K, K ) / T
            AKP1 = A( K+1, K+1 ) / T
            AKKP1 = A( K, K+1 ) / T
            D = T*( AK*AKP1-ONE )
            A( K, K ) = AKP1 / D
            A( K+1, K+1 ) = AK / D
            A( K, K+1 ) = -AKKP1 / D
*
*           Compute columns K and K+1 of the inverse.
*
            IF( K.GT.1 ) THEN
               CALL ZCOPY( K-1, A( 1, K ), 1, WORK, 1 )
               CALL ZSYMV( UPLO, K-1, -ONE, A, LDA, WORK, 1, ZERO,
     $                     A( 1, K ), 1 )
               A( K, K ) = A( K, K ) - ZDOTU( K-1, WORK, 1, A( 1, K ),
     $                     1 )
               A( K, K+1 ) = A( K, K+1 ) -
     $                       ZDOTU( K-1, A( 1, K ), 1, A( 1, K+1 ), 1 )
               CALL ZCOPY( K-1, A( 1, K+1 ), 1, WORK, 1 )
               CALL ZSYMV( UPLO, K-1, -ONE, A, LDA, WORK, 1, ZERO,
     $                     A( 1, K+1 ), 1 )
               A( K+1, K+1 ) = A( K+1, K+1 ) -
     $                         ZDOTU( K-1, WORK, 1, A( 1, K+1 ), 1 )
            END IF
            KSTEP = 2
         END IF
*
         KP = ABS( IPIV( K ) )
         IF( KP.NE.K ) THEN
*
*           Interchange rows and columns K and KP in the leading
*           submatrix A(1:k+1,1:k+1)
*
            CALL ZSWAP( KP-1, A( 1, K ), 1, A( 1, KP ), 1 )
            CALL ZSWAP( K-KP-1, A( KP+1, K ), 1, A( KP, KP+1 ), LDA )
            TEMP = A( K, K )
            A( K, K ) = A( KP, KP )
            A( KP, KP ) = TEMP
            IF( KSTEP.EQ.2 ) THEN
               TEMP = A( K, K+1 )
               A( K, K+1 ) = A( KP, K+1 )
               A( KP, K+1 ) = TEMP
            END IF
         END IF
*
         K = K + KSTEP
         GO TO 30
   40    CONTINUE
*
      ELSE
*
*        Compute inv(A) from the factorization A = L*D*L'.
*
*        K is the main loop index, increasing from 1 to N in steps of
*        1 or 2, depending on the size of the diagonal blocks.
*
         K = N
   50    CONTINUE
*
*        If K < 1, exit from loop.
*
         IF( K.LT.1 )
     $      GO TO 60
*
         IF( IPIV( K ).GT.0 ) THEN
*
*           1 x 1 diagonal block
*
*           Invert the diagonal block.
*
            A( K, K ) = ONE / A( K, K )
*
*           Compute column K of the inverse.
*
            IF( K.LT.N ) THEN
               CALL ZCOPY( N-K, A( K+1, K ), 1, WORK, 1 )
               CALL ZSYMV( UPLO, N-K, -ONE, A( K+1, K+1 ), LDA, WORK, 1,
     $                     ZERO, A( K+1, K ), 1 )
               A( K, K ) = A( K, K ) - ZDOTU( N-K, WORK, 1, A( K+1, K ),
     $                     1 )
            END IF
            KSTEP = 1
         ELSE
*
*           2 x 2 diagonal block
*
*           Invert the diagonal block.
*
            T = A( K, K-1 )
            AK = A( K-1, K-1 ) / T
            AKP1 = A( K, K ) / T
            AKKP1 = A( K, K-1 ) / T
            D = T*( AK*AKP1-ONE )
            A( K-1, K-1 ) = AKP1 / D
            A( K, K ) = AK / D
            A( K, K-1 ) = -AKKP1 / D
*
*           Compute columns K-1 and K of the inverse.
*
            IF( K.LT.N ) THEN
               CALL ZCOPY( N-K, A( K+1, K ), 1, WORK, 1 )
               CALL ZSYMV( UPLO, N-K, -ONE, A( K+1, K+1 ), LDA, WORK, 1,
     $                     ZERO, A( K+1, K ), 1 )
               A( K, K ) = A( K, K ) - ZDOTU( N-K, WORK, 1, A( K+1, K ),
     $                     1 )
               A( K, K-1 ) = A( K, K-1 ) -
     $                       ZDOTU( N-K, A( K+1, K ), 1, A( K+1, K-1 ),
     $                       1 )
               CALL ZCOPY( N-K, A( K+1, K-1 ), 1, WORK, 1 )
               CALL ZSYMV( UPLO, N-K, -ONE, A( K+1, K+1 ), LDA, WORK, 1,
     $                     ZERO, A( K+1, K-1 ), 1 )
               A( K-1, K-1 ) = A( K-1, K-1 ) -
     $                         ZDOTU( N-K, WORK, 1, A( K+1, K-1 ), 1 )
            END IF
            KSTEP = 2
         END IF
*
         KP = ABS( IPIV( K ) )
         IF( KP.NE.K ) THEN
*
*           Interchange rows and columns K and KP in the trailing
*           submatrix A(k-1:n,k-1:n)
*
            IF( KP.LT.N )
     $         CALL ZSWAP( N-KP, A( KP+1, K ), 1, A( KP+1, KP ), 1 )
            CALL ZSWAP( KP-K-1, A( K+1, K ), 1, A( KP, K+1 ), LDA )
            TEMP = A( K, K )
            A( K, K ) = A( KP, KP )
            A( KP, KP ) = TEMP
            IF( KSTEP.EQ.2 ) THEN
               TEMP = A( K, K-1 )
               A( K, K-1 ) = A( KP, K-1 )
               A( KP, K-1 ) = TEMP
            END IF
         END IF
*
         K = K - KSTEP
         GO TO 50
   60    CONTINUE
      END IF
*
      RETURN
*
*     End of ZSYTRI
*
      END

      PROGRAM TPLTCH
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C OPEN GKS, OPEN WORKSTATION OF TYPE 1, ACTIVATE WORKSTATION
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C INVOKE DEMO DRIVER
C
      CALL PLTCH(IERR)
C
C DEACTIVATE AND CLOSE WORKSTATION, CLOSE GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END
C
      SUBROUTINE PLTCH (IERR)
C
C LATEST REVISION        November, 1992.
C
C PURPOSE                To provide a minimal demo and test of routines
C                        in the package PLOTCHAR.
C
C USAGE                  CALL PLTCH (IERR)
C
C ARGUMENTS
C
C ON OUTPUT              IERR
C                          An integer variable
C                          = 0, if the test is successful,
C                          = 1, otherwise
C
C I/O                    If the test is successful, the message
C
C                        PLOTCHAR TEST EXECUTED--SEE PLOTS TO CERTIFY
C
C                        is written on unit 6.
C
C                        In addition, one frame is produced.  To
C                        determine if the test is successful, it is
C                        necessary to examine that frame.
C
C PRECISION              Single
C
C REQUIRED PACKAGES      PLOTCHAR, SPPS
C
C REQUIRED GKS LEVEL     0A
C
C LANGUAGE               FORTRAN
C
C ALGORITHM              TPLTCH just writes a simple message on a
C                        single frame.  For a more complex example
C                        of the use of PLOTCHAR, see the example
C                        named "epltch".
C
      CHARACTER*53 MSG(5)
C
      DATA MSG /'This is the graphical output from the example named'  ,
     +          '"tpltch".  It demonstrates minimal functioning of the',
     +          'package PLOTCHAR.  For a more complete demonstration' ,
     +          'of the capabilities of PLOTCHAR, run the example'     ,
     +          'named "epltch".'                                      /
C
C Do a call to SET which allows the use of fractional coordinates.
C
      CALL SET (0.,1.,0.,1.,0.,1.,0.,1.,1)
C
C Write a single frame, using calls to PLCHHQ, PLCHMQ, and PLCHLQ.
C
      CALL PLCHMQ (.5,.95,'PLOTCHAR DEMONSTRATION',16.,0.,0.)
C
      CALL PLCHHQ (.5,.77,'DEMONSTRATING THE USE OF CALLS TO PLCHHQ',
     +                                                     16.,0.,0.)
C
      DO 101 I=1,5
	CALL PLCHHQ (.1025,.75-.03*REAL(I),MSG(I),.015,0.,-1.)
  101 CONTINUE
C
      CALL PLCHMQ (.5,.52,'DEMONSTRATING THE USE OF CALLS TO PLCHMQ',
     +                                                     16.,0.,0.)
C
      DO 102 I=1,5
	CALL PLCHMQ (.1025,.50-.03*REAL(I),MSG(I),.015,0.,-1.)
  102 CONTINUE
C
      CALL PLCHLQ (.5,.27,'DEMONSTRATING THE USE OF CALLS TO PLCHLQ',
     +                                                     16.,0.,0.)
C
      DO 103 I=1,5
	CALL PLCHLQ (.1025,.25-.03*REAL(I),MSG(I),.015,0.,-1.)
  103 CONTINUE
C
C Advance the frame.
C
      CALL FRAME
C
C Zero the error flag.
C
      IERR=0
C
C Write the log message.
C
      WRITE (6,1001)
C
C Quit.
C
      RETURN
C
C Format.
C
 1001 FORMAT (' PLOTCHAR TEST EXECUTED--SEE PLOTS TO CERTIFY')
C
      END

      SUBROUTINE SSTEQR( COMPZ, N, D, E, Z, LDZ, WORK, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER          COMPZ
      INTEGER            INFO, LDZ, N
*     ..
*     .. Array Arguments ..
      REAL               D( * ), E( * ), WORK( * ), Z( LDZ, * )
*     ..
*
*  Purpose
*  =======
*
*  SSTEQR computes all eigenvalues and, optionally, eigenvectors of a
*  symmetric tridiagonal matrix using the implicit QL or QR method.
*  The eigenvectors of a full or band symmetric matrix can also be found
*  if SSYTRD or SSPTRD or SSBTRD has been used to reduce this matrix to
*  tridiagonal form.
*
*  Arguments
*  =========
*
*  COMPZ   (input) CHARACTER*1
*          = 'N':  Compute eigenvalues only.
*          = 'V':  Compute eigenvalues and eigenvectors of the original
*                  symmetric matrix.  On entry, Z must contain the
*                  orthogonal matrix used to reduce the original matrix
*                  to tridiagonal form.
*          = 'I':  Compute eigenvalues and eigenvectors of the
*                  tridiagonal matrix.  Z is initialized to the identity
*                  matrix.
*
*  N       (input) INTEGER
*          The order of the matrix.  N >= 0.
*
*  D       (input/output) REAL array, dimension (N)
*          On entry, the diagonal elements of the tridiagonal matrix.
*          On exit, if INFO = 0, the eigenvalues in ascending order.
*
*  E       (input/output) REAL array, dimension (N-1)
*          On entry, the (n-1) subdiagonal elements of the tridiagonal
*          matrix.
*          On exit, E has been destroyed.
*
*  Z       (input/output) REAL array, dimension (LDZ, N)
*          On entry, if  COMPZ = 'V', then Z contains the orthogonal
*          matrix used in the reduction to tridiagonal form.
*          On exit, if INFO = 0, then if  COMPZ = 'V', Z contains the
*          orthonormal eigenvectors of the original symmetric matrix,
*          and if COMPZ = 'I', Z contains the orthonormal eigenvectors
*          of the symmetric tridiagonal matrix.
*          If COMPZ = 'N', then Z is not referenced.
*
*  LDZ     (input) INTEGER
*          The leading dimension of the array Z.  LDZ >= 1, and if
*          eigenvectors are desired, then  LDZ >= max(1,N).
*
*  WORK    (workspace) REAL array, dimension (max(1,2*N-2))
*          If COMPZ = 'N', then WORK is not referenced.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*          > 0:  the algorithm has failed to find all the eigenvalues in
*                a total of 30*N iterations; if INFO = i, then i
*                elements of E have not converged to zero; on exit, D
*                and E contain the elements of a symmetric tridiagonal
*                matrix which is orthogonally similar to the original
*                matrix.
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ZERO, ONE, TWO, THREE
      PARAMETER          ( ZERO = 0.0E0, ONE = 1.0E0, TWO = 2.0E0,
     $                   THREE = 3.0E0 )
      INTEGER            MAXIT
      PARAMETER          ( MAXIT = 30 )
*     ..
*     .. Local Scalars ..
      INTEGER            I, ICOMPZ, II, ISCALE, J, JTOT, K, L, L1, LEND,
     $                   LENDM1, LENDP1, LENDSV, LM1, LSV, M, MM, MM1,
     $                   NM1, NMAXIT
      REAL               ANORM, B, C, EPS, EPS2, F, G, P, R, RT1, RT2,
     $                   S, SAFMAX, SAFMIN, SSFMAX, SSFMIN, TST
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      REAL               SLAMCH, SLANST, SLAPY2
      EXTERNAL           LSAME, SLAMCH, SLANST, SLAPY2
*     ..
*     .. External Subroutines ..
      EXTERNAL           SLAE2, SLAEV2, SLARTG, SLASCL, SLASET, SLASR,
     $                   SLASRT, SSWAP, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, MAX, SIGN, SQRT
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
*
      IF( LSAME( COMPZ, 'N' ) ) THEN
         ICOMPZ = 0
      ELSE IF( LSAME( COMPZ, 'V' ) ) THEN
         ICOMPZ = 1
      ELSE IF( LSAME( COMPZ, 'I' ) ) THEN
         ICOMPZ = 2
      ELSE
         ICOMPZ = -1
      END IF
      IF( ICOMPZ.LT.0 ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( ( LDZ.LT.1 ) .OR. ( ICOMPZ.GT.0 .AND. LDZ.LT.MAX( 1,
     $         N ) ) ) THEN
         INFO = -6
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'SSTEQR', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
*
      IF( N.EQ.1 ) THEN
         IF( ICOMPZ.EQ.2 )
     $      Z( 1, 1 ) = ONE
         RETURN
      END IF
*
*     Determine the unit roundoff and over/underflow thresholds.
*
      EPS = SLAMCH( 'E' )
      EPS2 = EPS**2
      SAFMIN = SLAMCH( 'S' )
      SAFMAX = ONE / SAFMIN
      SSFMAX = SQRT( SAFMAX ) / THREE
      SSFMIN = SQRT( SAFMIN ) / EPS2
*
*     Compute the eigenvalues and eigenvectors of the tridiagonal
*     matrix.
*
      IF( ICOMPZ.EQ.2 )
     $   CALL SLASET( 'Full', N, N, ZERO, ONE, Z, LDZ )
*
      NMAXIT = N*MAXIT
      JTOT = 0
*
*     Determine where the matrix splits and choose QL or QR iteration
*     for each block, according to whether top or bottom diagonal
*     element is smaller.
*
      L1 = 1
      NM1 = N - 1
*
   10 CONTINUE
      IF( L1.GT.N )
     $   GO TO 160
      IF( L1.GT.1 )
     $   E( L1-1 ) = ZERO
      IF( L1.LE.NM1 ) THEN
         DO 20 M = L1, NM1
            TST = ABS( E( M ) )
            IF( TST.EQ.ZERO )
     $         GO TO 30
            IF( TST.LE.( SQRT( ABS( D( M ) ) )*SQRT( ABS( D( M+
     $          1 ) ) ) )*EPS ) THEN
               E( M ) = ZERO
               GO TO 30
            END IF
   20    CONTINUE
      END IF
      M = N
*
   30 CONTINUE
      L = L1
      LSV = L
      LEND = M
      LENDSV = LEND
      L1 = M + 1
      IF( LEND.EQ.L )
     $   GO TO 10
*
*     Scale submatrix in rows and columns L to LEND
*
      ANORM = SLANST( 'I', LEND-L+1, D( L ), E( L ) )
      ISCALE = 0
      IF( ANORM.EQ.ZERO )
     $   GO TO 10
      IF( ANORM.GT.SSFMAX ) THEN
         ISCALE = 1
         CALL SLASCL( 'G', 0, 0, ANORM, SSFMAX, LEND-L+1, 1, D( L ), N,
     $                INFO )
         CALL SLASCL( 'G', 0, 0, ANORM, SSFMAX, LEND-L, 1, E( L ), N,
     $                INFO )
      ELSE IF( ANORM.LT.SSFMIN ) THEN
         ISCALE = 2
         CALL SLASCL( 'G', 0, 0, ANORM, SSFMIN, LEND-L+1, 1, D( L ), N,
     $                INFO )
         CALL SLASCL( 'G', 0, 0, ANORM, SSFMIN, LEND-L, 1, E( L ), N,
     $                INFO )
      END IF
*
*     Choose between QL and QR iteration
*
      IF( ABS( D( LEND ) ).LT.ABS( D( L ) ) ) THEN
         LEND = LSV
         L = LENDSV
      END IF
*
      IF( LEND.GT.L ) THEN
*
*        QL Iteration
*
*        Look for small subdiagonal element.
*
   40    CONTINUE
         IF( L.NE.LEND ) THEN
            LENDM1 = LEND - 1
            DO 50 M = L, LENDM1
               TST = ABS( E( M ) )**2
               IF( TST.LE.( EPS2*ABS( D( M ) ) )*ABS( D( M+1 ) )+
     $             SAFMIN )GO TO 60
   50       CONTINUE
         END IF
*
         M = LEND
*
   60    CONTINUE
         IF( M.LT.LEND )
     $      E( M ) = ZERO
         P = D( L )
         IF( M.EQ.L )
     $      GO TO 80
*
*        If remaining matrix is 2-by-2, use SLAE2 or SLAEV2
*        to compute its eigensystem.
*
         IF( M.EQ.L+1 ) THEN
            IF( ICOMPZ.GT.0 ) THEN
               CALL SLAEV2( D( L ), E( L ), D( L+1 ), RT1, RT2, C, S )
               WORK( L ) = C
               WORK( N-1+L ) = S
               CALL SLASR( 'R', 'V', 'B', N, 2, WORK( L ),
     $                     WORK( N-1+L ), Z( 1, L ), LDZ )
            ELSE
               CALL SLAE2( D( L ), E( L ), D( L+1 ), RT1, RT2 )
            END IF
            D( L ) = RT1
            D( L+1 ) = RT2
            E( L ) = ZERO
            L = L + 2
            IF( L.LE.LEND )
     $         GO TO 40
            GO TO 140
         END IF
*
         IF( JTOT.EQ.NMAXIT )
     $      GO TO 140
         JTOT = JTOT + 1
*
*        Form shift.
*
         G = ( D( L+1 )-P ) / ( TWO*E( L ) )
         R = SLAPY2( G, ONE )
         G = D( M ) - P + ( E( L ) / ( G+SIGN( R, G ) ) )
*
         S = ONE
         C = ONE
         P = ZERO
*
*        Inner loop
*
         MM1 = M - 1
         DO 70 I = MM1, L, -1
            F = S*E( I )
            B = C*E( I )
            CALL SLARTG( G, F, C, S, R )
            IF( I.NE.M-1 )
     $         E( I+1 ) = R
            G = D( I+1 ) - P
            R = ( D( I )-G )*S + TWO*C*B
            P = S*R
            D( I+1 ) = G + P
            G = C*R - B
*
*           If eigenvectors are desired, then save rotations.
*
            IF( ICOMPZ.GT.0 ) THEN
               WORK( I ) = C
               WORK( N-1+I ) = -S
            END IF
*
   70    CONTINUE
*
*        If eigenvectors are desired, then apply saved rotations.
*
         IF( ICOMPZ.GT.0 ) THEN
            MM = M - L + 1
            CALL SLASR( 'R', 'V', 'B', N, MM, WORK( L ), WORK( N-1+L ),
     $                  Z( 1, L ), LDZ )
         END IF
*
         D( L ) = D( L ) - P
         E( L ) = G
         GO TO 40
*
*        Eigenvalue found.
*
   80    CONTINUE
         D( L ) = P
*
         L = L + 1
         IF( L.LE.LEND )
     $      GO TO 40
         GO TO 140
*
      ELSE
*
*        QR Iteration
*
*        Look for small superdiagonal element.
*
   90    CONTINUE
         IF( L.NE.LEND ) THEN
            LENDP1 = LEND + 1
            DO 100 M = L, LENDP1, -1
               TST = ABS( E( M-1 ) )**2
               IF( TST.LE.( EPS2*ABS( D( M ) ) )*ABS( D( M-1 ) )+
     $             SAFMIN )GO TO 110
  100       CONTINUE
         END IF
*
         M = LEND
*
  110    CONTINUE
         IF( M.GT.LEND )
     $      E( M-1 ) = ZERO
         P = D( L )
         IF( M.EQ.L )
     $      GO TO 130
*
*        If remaining matrix is 2-by-2, use SLAE2 or SLAEV2
*        to compute its eigensystem.
*
         IF( M.EQ.L-1 ) THEN
            IF( ICOMPZ.GT.0 ) THEN
               CALL SLAEV2( D( L-1 ), E( L-1 ), D( L ), RT1, RT2, C, S )
               WORK( M ) = C
               WORK( N-1+M ) = S
               CALL SLASR( 'R', 'V', 'F', N, 2, WORK( M ),
     $                     WORK( N-1+M ), Z( 1, L-1 ), LDZ )
            ELSE
               CALL SLAE2( D( L-1 ), E( L-1 ), D( L ), RT1, RT2 )
            END IF
            D( L-1 ) = RT1
            D( L ) = RT2
            E( L-1 ) = ZERO
            L = L - 2
            IF( L.GE.LEND )
     $         GO TO 90
            GO TO 140
         END IF
*
         IF( JTOT.EQ.NMAXIT )
     $      GO TO 140
         JTOT = JTOT + 1
*
*        Form shift.
*
         G = ( D( L-1 )-P ) / ( TWO*E( L-1 ) )
         R = SLAPY2( G, ONE )
         G = D( M ) - P + ( E( L-1 ) / ( G+SIGN( R, G ) ) )
*
         S = ONE
         C = ONE
         P = ZERO
*
*        Inner loop
*
         LM1 = L - 1
         DO 120 I = M, LM1
            F = S*E( I )
            B = C*E( I )
            CALL SLARTG( G, F, C, S, R )
            IF( I.NE.M )
     $         E( I-1 ) = R
            G = D( I ) - P
            R = ( D( I+1 )-G )*S + TWO*C*B
            P = S*R
            D( I ) = G + P
            G = C*R - B
*
*           If eigenvectors are desired, then save rotations.
*
            IF( ICOMPZ.GT.0 ) THEN
               WORK( I ) = C
               WORK( N-1+I ) = S
            END IF
*
  120    CONTINUE
*
*        If eigenvectors are desired, then apply saved rotations.
*
         IF( ICOMPZ.GT.0 ) THEN
            MM = L - M + 1
            CALL SLASR( 'R', 'V', 'F', N, MM, WORK( M ), WORK( N-1+M ),
     $                  Z( 1, M ), LDZ )
         END IF
*
         D( L ) = D( L ) - P
         E( LM1 ) = G
         GO TO 90
*
*        Eigenvalue found.
*
  130    CONTINUE
         D( L ) = P
*
         L = L - 1
         IF( L.GE.LEND )
     $      GO TO 90
         GO TO 140
*
      END IF
*
*     Undo scaling if necessary
*
  140 CONTINUE
      IF( ISCALE.EQ.1 ) THEN
         CALL SLASCL( 'G', 0, 0, SSFMAX, ANORM, LENDSV-LSV+1, 1,
     $                D( LSV ), N, INFO )
         CALL SLASCL( 'G', 0, 0, SSFMAX, ANORM, LENDSV-LSV, 1, E( LSV ),
     $                N, INFO )
      ELSE IF( ISCALE.EQ.2 ) THEN
         CALL SLASCL( 'G', 0, 0, SSFMIN, ANORM, LENDSV-LSV+1, 1,
     $                D( LSV ), N, INFO )
         CALL SLASCL( 'G', 0, 0, SSFMIN, ANORM, LENDSV-LSV, 1, E( LSV ),
     $                N, INFO )
      END IF
*
*     Check for no convergence to an eigenvalue after a total
*     of N*MAXIT iterations.
*
      IF( JTOT.LT.NMAXIT )
     $   GO TO 10
      DO 150 I = 1, N - 1
         IF( E( I ).NE.ZERO )
     $      INFO = INFO + 1
  150 CONTINUE
      GO TO 190
*
*     Order eigenvalues and eigenvectors.
*
  160 CONTINUE
      IF( ICOMPZ.EQ.0 ) THEN
*
*        Use Quick Sort
*
         CALL SLASRT( 'I', N, D, INFO )
*
      ELSE
*
*        Use Selection Sort to minimize swaps of eigenvectors
*
         DO 180 II = 2, N
            I = II - 1
            K = I
            P = D( I )
            DO 170 J = II, N
               IF( D( J ).LT.P ) THEN
                  K = J
                  P = D( J )
               END IF
  170       CONTINUE
            IF( K.NE.I ) THEN
               D( K ) = D( I )
               D( I ) = P
               CALL SSWAP( N, Z( 1, I ), 1, Z( 1, K ), 1 )
            END IF
  180    CONTINUE
      END IF
*
  190 CONTINUE
      RETURN
*
*     End of SSTEQR
*
      END

C
C $Id: isinit.f,v 1.5 2008-07-27 00:17:16 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE ISINIT
C
C Initialize machine-dependent constants.
C
      COMMON /ISCOMN/ BIG,BIGD,DBPI,IDONE,IFILL,IFLIP,IONES,IHSS(1000),
     +                IREF,ISCA(16,256),ISCALE,ISCR(16,256),ISLBT,ISDR,
     +                LHSS,LX,NFPW,NINU,NINV,NINW,NX,NY,R0,RNX,RNY,
     +                SMALL,SVAL,TENSN,U,V,W,XMAX,XMIN,YMAX,YMIN,XVPL,
     +                XVPR,YVPB,YVPT
      SAVE   /ISCOMN/
C
C Determine how many 2-bit flags to put in each word of the screen
C models.
C
      NFPW=NX/LX
C
C Make sure that the value of NFPW is not too large.
C
      IF (NFPW.GT.I1MACH(5)/2) THEN
        CALL SETER ('ISINIT - INSTALLATION OF ISOSRF IMPROPERLY DONE - S
     +EE DIRECTIONS IN CODE',1,2)
        STOP
      END IF
C
C Compute the values of RNX and RNY, which are used to change fractional
C coordinates into indices on a screen model.
C
      RNX=REAL(NX-1)
      RNY=REAL(NY-1)
C
C Get the biggest real number.
C
      BIG = R1MACH(2)
C
C Generate a bit pattern containing 2*NFPW 1's.
C
      IONES=0
C
      DO 101 I=1,NFPW
        IONES=IOR(ISHIFT(IONES,2),3)
  101 CONTINUE
C
C Done.
C
      RETURN
C
      END

      PROGRAM PGKEX04
C
C  Illustrate normalization transformations.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER (ILD=121)
      DIMENSION PLX(ILD),PLY(ILD)
      DATA  RADC/.0174532/
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C  Define color indices, color index 0 defines the background color.
C
      CALL GSCR(IWKID, 0, 1.0, 1.0, 1.0)
      CALL GSCR(IWKID, 1, 0.0, 0.0, 1.0)
      CALL GSCR(IWKID, 2, 1.0, 0.0, 0.2)
      CALL GSCR(IWKID, 3, 0.4, 0.0, 0.4)
C
C  Create the data for a spiral in the world coordinate square
C  bounded by (-10.,-10.) and (10.,10.) .
C
      J = 0
      DO 10 I=0,720,6
        SCALE = REAL(I)/75.
        J = J+1
        PLX(J) = SCALE*COS(REAL(I-1)*RADC)
        PLY(J) = SCALE*SIN(REAL(I-1)*RADC)
   10 CONTINUE
C
C  Define a normalization transformation that does not preserve
C  aspect ratio.  Draw the transformed spiral with a box bounding
C  the viewport.
C
      XL = -10.
      XR =  10.
      YB = -10.
      YT =  10.
      CALL GSVP(1,.55,.95,.4,.65)
      CALL GSWN(1,XL,XR,YB,YT)
      CALL GSELNT(1)
      CALL GSPLCI(1)
      CALL GPL(121,PLX,PLY)
      CALL BOX(XL,XR,YB,YT)
C
C  Draw an image representing the window to the left of the viewport.
C
      CALL GSVP(1,.05,.45,.3,.70)
      CALL GSWN(1,XL,XR,YB,YT)
      CALL GSELNT(1)
      CALL GSPLCI(1)
      CALL GPL(121,PLX,PLY)
      CALL BOX(XL,XR,YB,YT)
C
C  Draw dashed lines between the outlines.
C
      CALL DLINE(.05,.30,.55,.40)
      CALL DLINE(.45,.30,.95,.40)
      CALL DLINE(.05,.70,.55,.65)
      CALL DLINE(.45,.70,.95,.65)
C
C  Label the plot using Plotchar.
C
      CALL PCSETI('FN',25)
      CALL PCSETI('CC',3)
      CALL PLCHHQ(.5,.83,'Normalization transformation',.035,0.,0.)
C
      CALL PCSETI('FN',21)
      CALL PCSETI('CC',3)
      CALL PLCHHQ(.07,.650,'Window',.022,0.,-1.)
      CALL PLCHHQ(.57,.625,'Viewport',.022,0.,-1.)
C
      CALL PCSETI('FN',9)
      CALL PCSETI('CC',2)
      CALL PLCHHQ(.5,.22,'Normalization transformation defined by',
     +            .0275,0.,0.)
C
      CALL PCSETI('FN',29)
      CALL PCSETI('CC',3)
      CALL PLCHHQ(.50,.15,'CALL GSWN(1,-10., 10.,-10., 10.)',
     -            .015,0.,0.)
      CALL PLCHHQ(.50,.10,'CALL GSVP(1, .55, .95, .40, .65)',
     -            .015,0.,0.)
C
      CALL FRAME
C
C  Deactivate and close the workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END
      SUBROUTINE BOX(XL,XR,YB,YT)
C
C  Draw a box with corner points (XL,YB) and (XR,YT).
C
      DIMENSION XA(5),YA(5)
C
      XA(1) = XL
      YA(1) = YB
      XA(2) = XR
      YA(2) = YB
      XA(3) = XR
      YA(3) = YT
      XA(4) = XL
      YA(4) = YT
      XA(5) = XA(1)
      YA(5) = YA(1)
C
      CALL GSPLCI(1)
      CALL GPL(5,XA,YA)
C
      RETURN
      END
      SUBROUTINE DLINE (X1,Y1,X2,Y2)
      DIMENSION XA(2),YA(2)
C
C  Draw a dashed line with color index 2 between the coordinates
C  (X1,Y1) and (X2,Y2) .
C
      CALL GSELNT(0)
      CALL GSPLCI(2)
      CALL GSLN(2)
      XA(1) = X1
      YA(1) = Y1
      XA(2) = X2
      YA(2) = Y2
      CALL GPL(2,XA,YA)
      CALL GSLN(1)
C
      RETURN
      END

C
C       $Id: vvrset.f,v 1.14 2008-07-27 00:17:35 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
C
C-----------------------------------------------------------------------
C
      SUBROUTINE VVRSET
C
C This subroutine may be called to reset all variables which have
C default values to those values.
C
C ---------------------------------------------------------------------
C
C NOTE:
C Since implicit typing is used for all real and integer variables
C a consistent length convention has been adopted to help clarify the
C significance of the variables encountered in the code for this 
C utility. All local variable and subroutine parameter identifiers 
C are limited to 1,2,or 3 characters. Four character names identify  
C members of common blocks. Five and 6 character variable names 
C denote PARAMETER constants or subroutine or function names.
C
C Declare the VV common blocks.
C
C IPLVLS - Maximum number of color threshold level values
C IPAGMX - Maximum number of area groups allowed in the area map
C
      PARAMETER (IPLVLS = 256, IPAGMX = 64)
C
C Integer and real common block variables
C
C
      COMMON /VVCOM/
     +                IUD1       ,IVD1       ,IPD1       ,IXDM       ,
     +                IYDN       ,VLOM       ,VHIM       ,ISET       ,
     +                VRMG       ,VRLN       ,VFRC       ,IXIN       ,
     +                IYIN       ,ISVF       ,UUSV       ,UVSV       ,
     +                UPSV       ,IMSK       ,ICPM       ,UVPS       ,
     +                UVPL       ,UVPR       ,UVPB       ,UVPT       ,
     +                UWDL       ,UWDR       ,UWDB       ,UWDT       ,
     +                UXC1       ,UXCM       ,UYC1       ,UYCN       ,
     +                NLVL       ,IPAI       ,ICTV       ,WDLV       ,
     +                UVMN       ,UVMX       ,PMIN       ,PMAX       ,
     +                RVMN       ,RVMX       ,RDMN       ,RDMX       ,
     +                ISPC       ,RVMD       ,IPLR       ,IVST       ,
     +                IVPO       ,ILBL       ,IDPF       ,IMSG       ,
     +                ICLR(IPLVLS)           ,TVLU(IPLVLS)
C
C Arrow size/shape parameters
C
        COMMON / VVARO /
     +                HDSZ       ,HINF       ,HANG       ,IAST       ,
     +                HSIN       ,HCOS       ,FAMN       ,FAMX       ,
     +                UVMG       ,FAIR       ,FAWR       ,FAWF       ,
     +                FAXR       ,FAXF       ,FAYR       ,FAYF       ,
     +                AROX(8)    ,AROY(8)    ,FXSZ       ,FYSZ       ,
     +                FXRF       ,FXMN       ,FYRF       ,FYMN       ,
     +                FWRF       ,FWMN       ,FIRF       ,FIMN       ,
     +                AXMN       ,AXMX       ,AYMN       ,AYMX       ,
     +                IACM       ,IAFO       ,WBAD       ,WBTF       ,
     +                WBCF       ,WBDF       ,WBSC
C
C
C Text related parameters
C
        COMMON /VVTXP /
     +                FCWM    ,ICSZ    ,
     +                FMNS    ,FMNX    ,FMNY    ,IMNP    ,IMNC  ,
     +                FMXS    ,FMXX    ,FMXY    ,IMXP    ,IMXC  ,
     +                FZFS    ,FZFX    ,FZFY    ,IZFP    ,IZFC  ,
     +                FILS    ,FILX    ,FILY    ,IILP    ,IILC  ,
     +                FLBS    ,ILBC

C
C Character variable declartions
C
      CHARACTER*160 CSTR
      PARAMETER (IPCHSZ=36)
      CHARACTER*(IPCHSZ)  CMNT,CMXT,CZFT,CLBT,CILT
C
C Text string parameters
C
      COMMON /VVCHAR/ CSTR,CMNT,CMXT,CZFT,CLBT,CILT
C
      SAVE /VVCOM/, /VVARO/, /VVTXP/, /VVCHAR/
C
C The mapping common block: made available to user mapping routines
C
      COMMON /VVMAP/
     +                IMAP       ,
     +                XVPL       ,XVPR       ,YVPB       ,YVPT       ,
     +                WXMN       ,WXMX       ,WYMN       ,WYMX       ,
     +                XLOV       ,XHIV       ,YLOV       ,YHIV       ,
     +                SXDC       ,SYDC       ,NXCT       ,NYCT       ,
     +                RLEN       ,LNLG       ,INVX       ,INVY       ,
     +                ITRT       ,IWCT       ,FW2W       ,FH2H       ,
     +                DVMN       ,DVMX       ,RBIG       ,IBIG
C
      SAVE /VVMAP/
C
C Math constants
C
      PARAMETER (PDTOR  = 0.017453292519943,
     +           PRTOD  = 57.2957795130823,
     +           P1XPI  = 3.14159265358979,
     +           P2XPI  = 6.28318530717959,
     +           P1D2PI = 1.57079632679489,
     +           P5D2PI = 7.85398163397448) 
C
C --------------------------------------------------------------------
C
C Reset individual parameters.
C
C Common block VVCOM
C
      IUD1 = -1
      IVD1 = -1
      IPD1 = -1
      IXDM = -1
      IYDN = -1
      VLOM = 0.0
      VHIM = 0.0
      ISET = 1
      VRMG = 0.0
      VRLN = 0.0
      VFRC = 0.0
      IXIN = 1
      IYIN = 1
      ISVF = 0
      UUSV = 0.0
      UVSV = 0.0
      UPSV = 0.0
      IMSK = 0
      ICPM = 0
      UVPS = 0.25
      UVPL = 0.05
      UVPR = 0.95
      UVPB = 0.05
      UVPT = 0.95
      UWDL = 0.0
      UWDR = 0.0
      UWDB = 0.0
      UWDT = 0.0
      UXC1 = 0.0
      UXCM = 0.0
      UYC1 = 0.0
      UYCN = 0.0
      NLVL = 0
      IPAI = 1
      ICTV = 0
      WDLV = 1.0
      UVMN = 0.0
      UVMX = 0.0
      PMIN = 0.0
      PMAX = 0.0
      RVMN = 0.0
      RVMX = 0.0
      RDMN = 0.0
      RDMX = 0.0
      ISPC = -1
      RVMD = 0.0
      IMAP = 0
      IPLR = 0
      IVST = 0
      IVPO = 0
      ILBL = 0
      IDPF = 1
C
C Parameter arrays
C
      DO 101 I=1,IPLVLS,1
         ICLR(I) = 1
         TVLU(I) = 0.0
 101  CONTINUE
C
C -------------------------------------------------------------------
C
C VVARO values
C
      HDSZ = 0.25
      HINF = 0.5
      HANG = 22.5
      FAMN = 0.005
      FAMX = 0.05
      IAST = 0
      UVMG = 0.0
      FAIR = 0.33
      FAWR = 0.1
      FAWF = 0.25
      FAXR = 0.36
      FAXF = 0.25
      FAYR = 0.12
      FAYF = 0.25
      IACM = 0
      IAFO = 1
      WBAD = 62.0
      WBTF = 0.33
      WBCF = 0.25
      WBDF = 0.1
      WBSC = 1.0
C
C ---------------------------------------------------------------------
C
C VVTXP values
C
      FCWM = 1.0
      ICSZ = IPCHSZ
      FMNS = 0.0075
      FMNX = 0.475
      FMNY = -0.01
      IMNP = 4
      IMNC = -1
      FMXS = 0.0075
      FMXX = 0.525
      FMXY = -0.01
      IMXP = 2
      IMXC = -1
      FZFS = 0.033
      FZFX = 0.5
      FZFY = 0.5
      IZFP = 0
      IZFC = -1
      FILS = 0.05
      FILX = 0.0
      FILY = 0.0
      IILP = -1
      IILC = -1
      FLBS = 0.007
      ILBC = -1
C
C ---------------------------------------------------------------------
C
C VVCHAR values
C
      CMNT = 'Minimum Vector'
      CMXT = 'Maximum Vector'
      CZFT = 'ZERO FIELD'
      CILT = 'Vector Field Map' 
C
C ---------------------------------------------------------------------
C
C VVMAP values
C
      IMAP = 0
      RLEN = 0.0
      ITRT = 1
      SXDC = 1.0
      SYDC = 1.0
      DVMN = 0.0
      DVMX = 0.0
      IBIG = I1MACH(9)
      RBIG = R1MACH(2)
C
C ---------------------------------------------------------------------
C
C Done
C
      RETURN
C
      END

C
C	$Id: g01pm.f,v 1.9 2008-07-27 00:21:05 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE G01PM
C
C  Process POLYMARKER element.
C
      include 'gksin.h'
      include 'g01io.h'
      include 'g01ins.h'
      include 'g01wsl.h'
      include 'g01rqa.h'
      include 'g01ast.h'
      include 'g01adc.h'
      include 'g01opc.h'
      include 'gksenu.h'
C
      INTEGER  KALL, IPRIM, NBYTES, NUMO, K, INDX1, INDX2
      DIMENSION NUMO(2)
      SAVE KALL
      DATA KALL/0/ , IPRIM/2/
C
      KALL = KALL+1
      IF  (KALL .EQ. 1) THEN
C
C  Set the WSL entry "DISPLAY SURFACE EMPTY" to "NOT EMPTY".
C
        MDEMPT = GNEMPT
C
C  Process pending attributes.
C
        IF (AGPEND(IPRIM)) THEN
C
C  Some changes are pending.
C
          IF (VALCHG(IVPLIX))  THEN
C
C  Send bundle index.
C
            NBYTES = 1+(MIXFW-1)/8
            CALL GPUTNI (CLMBIX, IDMBIX, NBYTES,  RERR)
            CALL GPUTPR (MRPMIX, MIXFW,  1, RERR)
            IF (RERR .NE. 0) RETURN
C
C  Set sent value to requested.  Clear change flag.
C
            MSPMIX         = MRPMIX
            VALCHG(IVPMIX) = .FALSE.
          END IF
          IF (VALCHG(IVMTYP)) THEN
C
C  MARKER TYPE
C
            NBYTES = 1+(MIXFW-1)/8
            CALL GPUTNI (CLMTYP, IDMTYP,  NBYTES,  RERR)
            CALL GPUTPR (MRMTYP, MIXFW,  1, RERR)
            IF (RERR .NE. 0) RETURN
C
C  Set sent value to requested.  Clear change flag.
C
            MSMTYP         = MRMTYP
            VALCHG(IVMTYP) = .FALSE.
          END IF
          IF (VALCHG(IVMSZS))  THEN
C
C  MARKER SIZE
C
            NBYTES = 1+(2*MCFPP-1)/8
            CALL GPUTNI (CLMSIZ, IDMSIZ, NBYTES,  RERR)
            CALL GFLCNV (ARMSZS,NUMO)
            CALL GPUTPR (NUMO, MCFPP,  2, RERR)
            IF (RERR .NE. 0) RETURN
C
C  Set sent value to requested.  Clear change flag.
C
            ASMSZS         = ARMSZS
            VALCHG(IVMSZS) = .FALSE.
          END IF
          IF (VALCHG(IVPMCI))  THEN
C
C  MARKER COLOR
C
            NBYTES = 1+(MCIXFW-1)/8
            CALL GPUTNI (CLMCLR, IDMCLR, NBYTES,  RERR)
            CALL GPUTPR (MRPMCI, MCIXFW,  1, RERR)
            IF (RERR .NE. 0) RETURN
C
C  Set sent value to requested.  Clear change flag.
C
            MSPMCI         = MRPMCI
            VALCHG(IVPMCI) = .FALSE.
          ENDIF
          IF (ANYASF)  THEN
C
C  Some ASF has changed.
C
            CALL G01SAS (IPRIM, RERR)
            IF (RERR.NE.0)  RETURN
          END IF
C
C  Clear aggregate change variable.
C
          AGPEND(IPRIM) = .FALSE.
        ENDIF
C
C  Treat first call, put out OPCODE, and points.
C
C  Put out opcode (CLASS and ID) and total LENGTH.
C
        NBYTES = 1+(2*RL1*MVDCFW-1)/8
        CALL GPUTNI (CLPMRK, IDPMRK, NBYTES, RERR)
C
C  Put out first points array.
C
C  Truncate points to limits of the NDC unit square, convert to VDC,
C  and store in MPXPY.
C
        DO 30 K=1,RL2
          INDX1 = 2*K-1
          INDX2 = INDX1+1
          MPXPY(INDX1) = MXOFF + INT(REAL(MXSCAL)*
     +                   (MAX(0.,MIN(1.0,RX(K)))))
          MPXPY(INDX2) = MYOFF + INT(REAL(MYSCAL)*
     +                   (MAX(0.,MIN(1.0,RY(K)))))
   30   CONTINUE
C
C  Send out points.
C
        CALL GPUTPR (MPXPY,  MVDCFW,     2*RL2, RERR)
        IF (RERR .NE. 0) RETURN
C
C  If there is to be no continuation, reset the parameter "KALL".
C
        IF (CONT .EQ. 0) THEN
          KALL = 0
          RETURN
        ENDIF
      ENDIF
C
C  Treat the continuation calls.
C
      IF (KALL .GT. 1) THEN
C
C  Truncate points to the limits of the NDC unit square, convert to 
C  VDC, and store in MPXPY.
C
        DO 40 K=1,RL2
          INDX1 = 2*K-1
          INDX2 = INDX1+1
          MPXPY(INDX1) = MXOFF + INT(REAL(MXSCAL)*
     +                   (MAX(0.,MIN(1.0,RX(K)))))
          MPXPY(INDX2) = MYOFF + INT(REAL(MYSCAL)*
     +                   (MAX(0.,MIN(1.0,RY(K)))))
   40   CONTINUE
        IF (CONT .EQ. 0) THEN
          CALL GPUTPR (MPXPY,  MVDCFW,     2*RL2, RERR)
          IF (RERR .NE. 0) RETURN
          KALL = 0
        ELSE
          CALL GPUTPR (MPXPY,  MVDCFW,     2*RL2, RERR)
          IF (RERR .NE. 0) RETURN
        ENDIF
      ENDIF
      RETURN
C
      END

      PROGRAM CCPCLC
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER (K=40,N=40,LRWK=1000,LIWK=1000)
      REAL Z(K,N), RWRK(LRWK)
      INTEGER I, M, IWRK(LIWK)
      
      CALL GETDAT (Z, K, M, N) 
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Set up color table
C
      CALL COLOR(IWKID)
C     
C Call conpack normally
C
      CALL CPRECT(Z,K,M,N,RWRK,LRWK,IWRK,LIWK)
      CALL CPPKCL(Z, RWRK, IWRK)
C
C Set line color to red if it's negative, green if it's zero, 
C and blue if it's positive.
C
      CALL CPGETI('NCL - NUMBER OF CONTOUR LEVELS',NCON)
      DO 11, I=1,NCON
         CALL CPSETI('PAI - PARAMETER ARRAY INDEX',I)
         CALL CPGETR('CLV - CONTOUR LEVEL VALUES',CVAL)
         IF (CVAL .LT. 0.0) THEN
            CALL CPSETI('CLC - CONTOUR LINE COLOR INDEX',1)
         ELSE IF (CVAL .EQ. 0.0) THEN
            CALL CPSETI('CLC - CONTOUR LINE COLOR INDEX',2)
         ELSE
            CALL CPSETI('CLC - CONTOUR LINE COLOR INDEX',3)
         ENDIF
 11   CONTINUE
      
      CALL CPBACK(Z, RWRK, IWRK)
      CALL CPCLDR(Z,RWRK,IWRK)
C     
C Close frame
C
      CALL FRAME
C
C Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      
      STOP
      END
      
      SUBROUTINE GETDAT (Z, K, M, N)
      INTEGER I,J,K,M,N
      REAL Z(K,N)
      
      M=K
      DO 10, I=1,M
         DO 20, J=1,N
            Z(I,J)= 10.E-5*(-16.*REAL(I**2*J) +
     1           34*REAL(I*J**2) - REAL(6*I) + 93.)
 20      CONTINUE
 10   CONTINUE
      
      RETURN
      END
      
      SUBROUTINE COLOR(IWKID)
      
      CALL GSCR (IWKID,0,1.,1.,1.)
      CALL GSCR (IWKID,1,1.,0.,0.)
      CALL GSCR (IWKID,2,0.,1.,0.)
      CALL GSCR (IWKID,3,0.,0.,1.)
      
      RETURN
      END

C
C $Id: tick4.f,v 1.8 2008-07-27 00:17:14 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE TICK4 (LMJX,LMNX,LMJY,LMNY)
C
C Declare the common block containing real and integer parameters.
C
        COMMON /GAREIN/ ICAX,ICLB,ICMJ,ICMN,ILTY,IORX,NCFX,NCFY,RCWX,
     +                  RCWY,RDCX,RDCY,RMJX,RMJY,RMNX,RMNY,RWAX,RWLB,
     +                  RWMJ,RWMN
        SAVE   /GAREIN/
C
C Do a call forcing a BLOCKDATA to be loaded from a binary library.
C
        CALL GABLDT
C
C Check for an uncleared prior error.
C
        IF (ICFELL('TICK4 - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C Transfer the arguments to GRIDAL's common block.
C
        RMJX=REAL(LMJX)
        RMNX=REAL(LMNX)
        RMJY=REAL(LMJY)
        RMNY=REAL(LMNY)
C
C Done.
C
      RETURN
C
      END

      PROGRAM TLBLBA
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C OPEN GKS, OPEN WORKSTATION OF TYPE 1, ACTIVATE WORKSTATION
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C INVOKE DEMO DRIVER
C
      CALL LBLBA(IERR,IWKID)
C
C DEACTIVATE AND CLOSE WORKSTATION, CLOSE GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END
C
      SUBROUTINE LBLBA (IERR,IWKID)
C
C LATEST REVISION       July, 1989
C
C PURPOSE               To provide a simple demonstration of the use of
C                       LABELBAR to draw various kinds of labelled bars.
C
C USAGE                 CALL LBLBA (IERR,IWKID)
C
C ARGUMENTS (OUTPUT)    IERR
C
C                         An integer variable
C                         = 0, if the test was successful,
C                         = 1, otherwise
C
C I/O                   If the test is successful, the message "LABELBAR
C                       TEST EXECUTED--SEE PLOTS TO CERTIFY" is printed
C                       on unit 6.  In addition, a single frame is drawn
C                       on the graphics device.  In order to determine
C                       if the test was successful, it is necessary to
C                       examine this frame.
C
C PRECISION             Single.
C
C LANGUAGE              FORTRAN 77.
C
C REQUIRED ROUTINES     LABELBAR, SOFTFILL, and PLOTCHAR packages.
C
C REQUIRED GKS LEVEL    0A.
C
C ALGORITHM             Three simple label bars are drawn.
C
C Declare an array to hold the GKS "aspect source flags".
C
        DIMENSION IASF(13)
C
C Declare the arrays to hold the list of indices and the lists of labels
C required by the label-bar routine.
C
        DIMENSION LND1(20),LND2(16),LND3(16)
C
        CHARACTER*12 LLB1(20)
        CHARACTER*10 LLB2(17)
        CHARACTER*1  LLB3(16)
C
C Initialize the values in the aspect-source-flag array.
C
        DATA IASF / 13*1 /
C
C Define the list of indices required by the label-bar routine.
C
        DATA LND1 / 1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20 /
        DATA LND2 / 0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15 /
        DATA LND3 / 12,13,14,15,8,9,10,11,4,5,6,7,0,1,2,3 /
C
C Define labels for various bars.
C
        DATA LLB1 /   '0 to 5:H2Q', '5 to 10:H1Q','10 to 15:H1Q',
     +              '15 to 20:H1Q','20 to 25:H1Q','25 to 30:H1Q',
     +              '30 to 35:H1Q','35 to 40:H1Q','40 to 45:H1Q',
     +              '45 to 50:H1Q','50 to 55:H1Q','55 to 60:H1Q',
     +              '60 to 65:H1Q','65 to 70:H1Q','70 to 75:H1Q',
     +              '75 to 80:H1Q','80 to 85:H1Q','85 to 90:H1Q',
     +              '90 to 95:H1Q','95 to 100'   /
C
        DATA LLB2 / '-2000 feet',' Sea level',' 2000 feet',
     +              ' 4000 feet',' 6000 feet',' 8000 feet',
     +              '10000 feet','12000 feet','14000 feet',
     +              '16000 feet','18000 feet','20000 feet',
     +              '22000 feet','24000 feet','26000 feet',
     +              '28000 feet','30000 feet'/
C
        DATA LLB3 / 'M','N','O','P','I','J','K','L','E','F','G','H',
     +              'A','B','C','D'/
C
C Turn off the clipping indicator.
C
        CALL GSCLIP (0)
C
C Set all the GKS aspect source flags to "individual".
C
        CALL GSASF (IASF)
C
C Force solid fill.
C
        CALL GSFAIS (1)
C
C Define color indices.
C
        CALL LBCLRS(IWKID)
C
C Force PLOTCHAR to use constant spacing of characters.
C
        CALL PCSETR ('CS - CONSTANT SPACING',1.25)
C
C Set some parameter values.
C
        CALL LBSETR ('WBL - WIDTH OF BOX LINES',4.)
        CALL LBSETR ('WFL - WIDTH OF FILL LINES',2.)
        CALL LBSETR ('WLB - WIDTH OF LABEL LINES',2.)
C
C Put the first label bar vertically along the left edge of the plotter
C frame.  Use patterns.
C
        CALL SFSETI ('ANGLE OF FILL LINES',15)
        CALL SFSETI ('TYPE OF FILL',-4)
        CALL LBLBAR (1,.05,.30,.05,.95,20,.3333,1.,LND1,0,LLB1,20,2)
C
C Put the second label bar vertically along the right edge.  Use solid
C color fill.
C
        CALL SFSETI ('TYPE OF FILL',0)
        CALL LBLBAR (1,.70,.95,.05,.95,16,.3333,1.,LND2,0,LLB2,17,1)
C
C The remaining label bars are arranged horizontally in such a way as
C to form a rectangular key for color indices 1 through 12.  The
C default version of LBFILL is used.
C
        CALL LBLBAR (0,.35,.65,.05,.20,4,.5,.5,LND3( 1),1,LLB3( 1),4,1)
        CALL LBLBAR (0,.35,.65,.20,.35,4,.5,.5,LND3( 5),1,LLB3( 5),4,1)
        CALL LBLBAR (0,.35,.65,.35,.50,4,.5,.5,LND3( 9),1,LLB3( 9),4,1)
        CALL LBLBAR (0,.35,.65,.50,.65,4,.5,.5,LND3(13),1,LLB3(13),4,1)
C
C Put a title on the plot.  We must first call SET to define the ranges
C of the X and Y coordinates to be used.  The constant spacing feature
C is turned off so that the title will look normal.
C
        CALL SET (0.,1.,0.,1.,0.,1.,0.,1.,1)
        CALL PLCHLQ  (.5,.90,'THREE',24.,0.,0.)
        CALL PLCHLQ  (.5,.85,'LABELBAR',24.,0.,0.)
        CALL PLCHLQ  (.5,.80,'EXAMPLES',24.,0.,0.)
C
C Advance the frame.
C
        CALL FRAME
C
C Log a successful-completion message and return to the caller.
C
        WRITE (6,1001)
C
        RETURN
C
 1001 FORMAT (' LABELBAR TEST EXECUTED--SEE PLOTS TO CERTIFY')
C
      END
      SUBROUTINE LBCLRS(IWKID)
C
C Define a set of RGB color triples for colors 1 through 15.
C
        DIMENSION RGBV(3,15)
C
C Define the RGB color triples needed below.
C
        DATA RGBV / 1.00 , 1.00 , 1.00 ,
     +              0.70 , 0.70 , 0.70 ,
     +              0.75 , 0.50 , 1.00 ,
     +              0.50 , 0.00 , 1.00 ,
     +              0.00 , 0.00 , 1.00 ,
     +              0.00 , 0.50 , 1.00 ,
     +              0.00 , 1.00 , 1.00 ,
     +              0.00 , 1.00 , 0.60 ,
     +              0.00 , 1.00 , 0.00 ,
     +              0.70 , 1.00 , 0.00 ,
     +              1.00 , 1.00 , 0.00 ,
     +              1.00 , 0.75 , 0.00 ,
     +              1.00 , 0.38 , 0.38 ,
     +              1.00 , 0.00 , 0.38 ,
     +              1.00 , 0.00 , 0.00 /
C
C Define 16 different color indices, for indices 0 through 15.  The
C color corresponding to index 0 is black and the color corresponding
C to index 1 is white.
C
        CALL GSCR (IWKID,0,0.,0.,0.)
C
        DO 101 I=1,15
          CALL GSCR (IWKID,I,RGBV(1,I),RGBV(2,I),RGBV(3,I))
  101   CONTINUE
C
C Done.
C
        RETURN
C
      END

      SUBROUTINE CLASWP( N, A, LDA, K1, K2, IPIV, INCX )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      INTEGER            INCX, K1, K2, LDA, N
*     ..
*     .. Array Arguments ..
      INTEGER            IPIV( * )
      COMPLEX            A( LDA, * )
*     ..
*
*  Purpose
*  =======
*
*  CLASWP performs a series of row interchanges on the matrix A.
*  One row interchange is initiated for each of rows K1 through K2 of A.
*
*  Arguments
*  =========
*
*  N       (input) INTEGER
*          The number of columns of the matrix A.
*
*  A       (input/output) COMPLEX array, dimension (LDA,N)
*          On entry, the matrix of column dimension N to which the row
*          interchanges will be applied.
*          On exit, the permuted matrix.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.
*
*  K1      (input) INTEGER
*          The first element of IPIV for which a row interchange will
*          be done.
*
*  K2      (input) INTEGER
*          The last element of IPIV for which a row interchange will
*          be done.
*
*  IPIV    (input) INTEGER array, dimension (M*abs(INCX))
*          The vector of pivot indices.  Only the elements in positions
*          K1 through K2 of IPIV are accessed.
*          IPIV(K) = L implies rows K and L are to be interchanged.
*
*  INCX    (input) INTEGER
*          The increment between successive values of IPIV.  If IPIV
*          is negative, the pivots are applied in reverse order.
*
*  Further Details
*  ===============
*
*  Modified by
*   R. C. Whaley, Computer Science Dept., Univ. of Tenn., Knoxville, USA
*
* =====================================================================
*
*     .. Local Scalars ..
      INTEGER            I, I1, I2, INC, IP, IX, IX0, J, K, N32
      COMPLEX            TEMP
*     ..
*     .. Executable Statements ..
*
*     Interchange row I with row IPIV(I) for each of rows K1 through K2.
*
      IF( INCX.GT.0 ) THEN
         IX0 = K1
         I1 = K1
         I2 = K2
         INC = 1
      ELSE IF( INCX.LT.0 ) THEN
         IX0 = 1 + ( 1-K2 )*INCX
         I1 = K2
         I2 = K1
         INC = -1
      ELSE
         RETURN
      END IF
*
      N32 = ( N / 32 )*32
      IF( N32.NE.0 ) THEN
         DO 30 J = 1, N32, 32
            IX = IX0
            DO 20 I = I1, I2, INC
               IP = IPIV( IX )
               IF( IP.NE.I ) THEN
                  DO 10 K = J, J + 31
                     TEMP = A( I, K )
                     A( I, K ) = A( IP, K )
                     A( IP, K ) = TEMP
   10             CONTINUE
               END IF
               IX = IX + INCX
   20       CONTINUE
   30    CONTINUE
      END IF
      IF( N32.NE.N ) THEN
         N32 = N32 + 1
         IX = IX0
         DO 50 I = I1, I2, INC
            IP = IPIV( IX )
            IF( IP.NE.I ) THEN
               DO 40 K = N32, N
                  TEMP = A( I, K )
                  A( I, K ) = A( IP, K )
                  A( IP, K ) = TEMP
   40          CONTINUE
            END IF
            IX = IX + INCX
   50    CONTINUE
      END IF
*
      RETURN
*
*     End of CLASWP
*
      END

      REAL             FUNCTION CLANHS( NORM, N, A, LDA, WORK )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     October 31, 1992
*
*     .. Scalar Arguments ..
      CHARACTER          NORM
      INTEGER            LDA, N
*     ..
*     .. Array Arguments ..
      REAL               WORK( * )
      COMPLEX            A( LDA, * )
*     ..
*
*  Purpose
*  =======
*
*  CLANHS  returns the value of the one norm,  or the Frobenius norm, or
*  the  infinity norm,  or the  element of  largest absolute value  of a
*  Hessenberg matrix A.
*
*  Description
*  ===========
*
*  CLANHS returns the value
*
*     CLANHS = ( max(abs(A(i,j))), NORM = 'M' or 'm'
*              (
*              ( norm1(A),         NORM = '1', 'O' or 'o'
*              (
*              ( normI(A),         NORM = 'I' or 'i'
*              (
*              ( normF(A),         NORM = 'F', 'f', 'E' or 'e'
*
*  where  norm1  denotes the  one norm of a matrix (maximum column sum),
*  normI  denotes the  infinity norm  of a matrix  (maximum row sum) and
*  normF  denotes the  Frobenius norm of a matrix (square root of sum of
*  squares).  Note that  max(abs(A(i,j)))  is not a  matrix norm.
*
*  Arguments
*  =========
*
*  NORM    (input) CHARACTER*1
*          Specifies the value to be returned in CLANHS as described
*          above.
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.  When N = 0, CLANHS is
*          set to zero.
*
*  A       (input) COMPLEX array, dimension (LDA,N)
*          The n by n upper Hessenberg matrix A; the part of A below the
*          first sub-diagonal is not referenced.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(N,1).
*
*  WORK    (workspace) REAL array, dimension (LWORK),
*          where LWORK >= N when NORM = 'I'; otherwise, WORK is not
*          referenced.
*
* =====================================================================
*
*     .. Parameters ..
      REAL               ONE, ZERO
      PARAMETER          ( ONE = 1.0E+0, ZERO = 0.0E+0 )
*     ..
*     .. Local Scalars ..
      INTEGER            I, J
      REAL               SCALE, SUM, VALUE
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           CLASSQ
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, MAX, MIN, SQRT
*     ..
*     .. Executable Statements ..
*
      IF( N.EQ.0 ) THEN
         VALUE = ZERO
      ELSE IF( LSAME( NORM, 'M' ) ) THEN
*
*        Find max(abs(A(i,j))).
*
         VALUE = ZERO
         DO 20 J = 1, N
            DO 10 I = 1, MIN( N, J+1 )
               VALUE = MAX( VALUE, ABS( A( I, J ) ) )
   10       CONTINUE
   20    CONTINUE
      ELSE IF( ( LSAME( NORM, 'O' ) ) .OR. ( NORM.EQ.'1' ) ) THEN
*
*        Find norm1(A).
*
         VALUE = ZERO
         DO 40 J = 1, N
            SUM = ZERO
            DO 30 I = 1, MIN( N, J+1 )
               SUM = SUM + ABS( A( I, J ) )
   30       CONTINUE
            VALUE = MAX( VALUE, SUM )
   40    CONTINUE
      ELSE IF( LSAME( NORM, 'I' ) ) THEN
*
*        Find normI(A).
*
         DO 50 I = 1, N
            WORK( I ) = ZERO
   50    CONTINUE
         DO 70 J = 1, N
            DO 60 I = 1, MIN( N, J+1 )
               WORK( I ) = WORK( I ) + ABS( A( I, J ) )
   60       CONTINUE
   70    CONTINUE
         VALUE = ZERO
         DO 80 I = 1, N
            VALUE = MAX( VALUE, WORK( I ) )
   80    CONTINUE
      ELSE IF( ( LSAME( NORM, 'F' ) ) .OR. ( LSAME( NORM, 'E' ) ) ) THEN
*
*        Find normF(A).
*
         SCALE = ZERO
         SUM = ONE
         DO 90 J = 1, N
            CALL CLASSQ( MIN( N, J+1 ), A( 1, J ), 1, SCALE, SUM )
   90    CONTINUE
         VALUE = SCALE*SQRT( SUM )
      END IF
*
      CLANHS = VALUE
      RETURN
*
*     End of CLANHS
*
      END

C
C $Id: mdutis.f,v 1.3 2008-07-27 00:17:09 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MDUTIS (UVAL,VVAL,RLAT,RLON)
C
C Given UVAL and VVAL, in meters, return RLAT and RLON, in degrees.
C
        REAL UVAL,VVAL,RLAT,RLON
C
C Declare common blocks required to communicate with USGS code.
C
        COMMON /ERRMZ0/ IERR
        SAVE   /ERRMZ0/
C
        COMMON /USGSC1/  UTPA(15),UUMN,UUMX,UVMN,UVMX,IPRF
        DOUBLE PRECISION UTPA,UUMN,UUMX,UVMN,UVMX
        INTEGER IPRF
        SAVE   /USGSC1/
C
C Declare required coordinate arrays.
C
        DIMENSION CRDI(2),CRDO(2),CRDT(2)
C
C Define a couple of conversion constants.
C
        DATA DTOR / .017453292519943E0 /
        DATA RTOD / 57.2957795130823E0 /
C
C Do a call forcing a BLOCKDATA to be loaded from a binary library.
C
        CALL GTPZBD
C
C If the USGS package is initialized, zero the error flag; otherwise,
C take an error exit.
C
        IF (IPRF.GE.3.AND.IPRF.LE.23) THEN
          IERR=0
        ELSE
          IERR=1
          RLAT=1.E12
          RLON=1.E12
          RETURN
        END IF
C
C Generate coordinates for projection routine.
C
        CRDI(1)=UVAL
        CRDI(2)=VVAL
C
        GO TO (        103,104,105,106,107,108,109,110,
     +         111,112,113,114,115,116,117,118,119,120,
     +         121,122,123                             ) , IPRF-2
C
  103   CALL PJ03SP (CRDI,CRDO,1)
        IF (IERR.EQ.0) CALL PJ03SP (CRDO,CRDT,0)
        GO TO 201
C
  104   CALL PJ04SP (CRDI,CRDO,1)
        IF (IERR.EQ.0) CALL PJ04SP (CRDO,CRDT,0)
        GO TO 201
C
  105   CALL PJ05SP (CRDI,CRDO,1)
        IF (IERR.EQ.0) CALL PJ05SP (CRDO,CRDT,0)
        GO TO 201
C
  106   CALL PJ06SP (CRDI,CRDO,1)
        IF (IERR.EQ.0) CALL PJ06SP (CRDO,CRDT,0)
        GO TO 201
C
  107   CALL PJ07SP (CRDI,CRDO,1)
        IF (IERR.EQ.0) CALL PJ07SP (CRDO,CRDT,0)
        GO TO 201
C
  108   CALL PJ08SP (CRDI,CRDO,1)
        IF (IERR.EQ.0) CALL PJ08SP (CRDO,CRDT,0)
        GO TO 201
C
  109   CALL PJ09SP (CRDI,CRDO,1)
        IF (IERR.EQ.0) CALL PJ09SP (CRDO,CRDT,0)
        GO TO 201
C
  110   CALL PJ10SP (CRDI,CRDO,1)
        IF (IERR.EQ.0) CALL PJ10SP (CRDO,CRDT,0)
        GO TO 201
C
  111   CALL PJ11SP (CRDI,CRDO,1)
        IF (IERR.EQ.0) CALL PJ11SP (CRDO,CRDT,0)
        GO TO 201
C
  112   CALL PJ12SP (CRDI,CRDO,1)
        IF (IERR.EQ.0) CALL PJ12SP (CRDO,CRDT,0)
        GO TO 201
C
  113   CALL PJ13SP (CRDI,CRDO,1)
        IF (IERR.EQ.0) CALL PJ13SP (CRDO,CRDT,0)
        GO TO 201
C
  114   CALL PJ14SP (CRDI,CRDO,1)
        IF (IERR.EQ.0) CALL PJ14SP (CRDO,CRDT,0)
        GO TO 201
C
  115   CALL PJ15SP (CRDI,CRDO,1)
        IF (IERR.EQ.0) CALL PJ15SP (CRDO,CRDT,0)
        GO TO 201
C
  116   CALL PJ16SP (CRDI,CRDO,1)
        IF (IERR.EQ.0) CALL PJ16SP (CRDO,CRDT,0)
        GO TO 201
C
  117   CALL PJ17SP (CRDI,CRDO,1)
        IF (IERR.EQ.0) CALL PJ17SP (CRDO,CRDT,0)
        GO TO 201
C
  118   CALL PJ18SP (CRDI,CRDO,1)
        IF (IERR.EQ.0) CALL PJ18SP (CRDO,CRDT,0)
        GO TO 201
C
  119   CALL PJ19SP (CRDI,CRDO,1)
        IF (IERR.EQ.0) CALL PJ19SP (CRDO,CRDT,0)
        GO TO 201
C
  120   CALL PJ20SP (CRDI,CRDO,1)
        IF (IERR.EQ.0) CALL PJ20SP (CRDO,CRDT,0)
        GO TO 201
C
  121   IF (CRDI(1).GE.-3.096982037908766*REAL(UTPA(1)).AND.
     +      CRDI(1).LE.+3.096982037908766*REAL(UTPA(1)).AND.
     +      CRDI(2).GE.-1.570796326793281*REAL(UTPA(1)).AND.
     +      CRDI(2).LE.+1.570796326793281*REAL(UTPA(1))) THEN
          CALL PJ21SP (CRDI,CRDO,1)
          IF (IERR.EQ.0) CALL PJ21SP (CRDO,CRDT,0)
        ELSE
          IERR=1
        END IF
C
        GO TO 201
C
  122   CALL PJ22SP (CRDI,CRDO,1)
        IF (IERR.EQ.0) CALL PJ22SP (CRDO,CRDT,0)
        GO TO 201
C
  123   CALL PJ23SP (CRDI,CRDO,1)
        IF (IERR.EQ.0) CALL PJ23SP (CRDO,CRDT,0)
        GO TO 201
C
  201   IF (IERR.EQ.0) THEN
          IF (ABS(CRDT(1)-CRDI(1)).LT.1.E-5*REAL(UUMX-UUMN).AND.
     +        ABS(CRDT(2)-CRDI(2)).LT.1.E-5*REAL(UVMX-UVMN)) THEN
            RLAT=RTOD*CRDO(2)
            RLON=RTOD*CRDO(1)
          ELSE
            RLAT=1.E12
            RLON=1.E12
            IERR=1
          END IF
        ELSE
          RLAT=1.E12
          RLON=1.E12
          IERR=2
        END IF
C
        RETURN
C
      END

C
C	$Id: gspmci.f,v 1.5 2008-07-27 00:21:02 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GSPMCI (COLI)
C
C  SET POLYMARKER COLOUR INDEX
C
      INTEGER ESPMCI
      PARAMETER (ESPMCI=25)
C
      include 'gkscom.h'
C
      INTEGER COLI
C
C  Check if GKS is in the proper state.
C
      CALL GZCKST(8,ESPMCI,IER)
      IF (IER .NE. 0) RETURN
C
C  Check that the index is valid.
C
      IF (COLI .LT. 0) THEN
        ERS = 1
        CALL GERHND(92,ESPMCI,ERF)
        ERS = 0
        RETURN
      ENDIF
C
C  Set the current color index in the GKS state list.
C
      CPMCI = COLI
C
C  Invoke the workstation interface.
C
      FCODE = 28
      CONT  = 0
      CALL GZROI(0)
      IC1   = 1
      IC2   = 1
      IC(1) = COLI
      CALL GZTOWK
      IF (RERR .NE. 0) THEN
        ERS = 1
        CALL GERHND(RERR,ESPMCI,ERF)
        ERS = 0
      ENDIF
C
      RETURN
      END

C
C $Id: gageti.f,v 1.6 2008-07-27 00:17:13 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GAGETI (PNAM,IVAL)
C
        CHARACTER*(*) PNAM
C
C The subroutine GAGETI may be used to get GRIDAL parameters which have
C values of type INTEGER.
C
C Check for an uncleared prior error.
C
        IF (ICFELL('GAGETI - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C Just convert the call into a call to the routine GAGETR.
C
        CALL GAGETR (PNAM,RVAL)
        IF (ICFELL('GAGETI',2).NE.0) RETURN
        IVAL=INT(RVAL)
C
C Done.
C
        RETURN
C
      END

      REAL             FUNCTION CLANTR( NORM, UPLO, DIAG, M, N, A, LDA,
     $                 WORK )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     October 31, 1992
*
*     .. Scalar Arguments ..
      CHARACTER          DIAG, NORM, UPLO
      INTEGER            LDA, M, N
*     ..
*     .. Array Arguments ..
      REAL               WORK( * )
      COMPLEX            A( LDA, * )
*     ..
*
*  Purpose
*  =======
*
*  CLANTR  returns the value of the one norm,  or the Frobenius norm, or
*  the  infinity norm,  or the  element of  largest absolute value  of a
*  trapezoidal or triangular matrix A.
*
*  Description
*  ===========
*
*  CLANTR returns the value
*
*     CLANTR = ( max(abs(A(i,j))), NORM = 'M' or 'm'
*              (
*              ( norm1(A),         NORM = '1', 'O' or 'o'
*              (
*              ( normI(A),         NORM = 'I' or 'i'
*              (
*              ( normF(A),         NORM = 'F', 'f', 'E' or 'e'
*
*  where  norm1  denotes the  one norm of a matrix (maximum column sum),
*  normI  denotes the  infinity norm  of a matrix  (maximum row sum) and
*  normF  denotes the  Frobenius norm of a matrix (square root of sum of
*  squares).  Note that  max(abs(A(i,j)))  is not a  matrix norm.
*
*  Arguments
*  =========
*
*  NORM    (input) CHARACTER*1
*          Specifies the value to be returned in CLANTR as described
*          above.
*
*  UPLO    (input) CHARACTER*1
*          Specifies whether the matrix A is upper or lower trapezoidal.
*          = 'U':  Upper trapezoidal
*          = 'L':  Lower trapezoidal
*          Note that A is triangular instead of trapezoidal if M = N.
*
*  DIAG    (input) CHARACTER*1
*          Specifies whether or not the matrix A has unit diagonal.
*          = 'N':  Non-unit diagonal
*          = 'U':  Unit diagonal
*
*  M       (input) INTEGER
*          The number of rows of the matrix A.  M >= 0, and if
*          UPLO = 'U', M <= N.  When M = 0, CLANTR is set to zero.
*
*  N       (input) INTEGER
*          The number of columns of the matrix A.  N >= 0, and if
*          UPLO = 'L', N <= M.  When N = 0, CLANTR is set to zero.
*
*  A       (input) COMPLEX array, dimension (LDA,N)
*          The trapezoidal matrix A (A is triangular if M = N).
*          If UPLO = 'U', the leading m by n upper trapezoidal part of
*          the array A contains the upper trapezoidal matrix, and the
*          strictly lower triangular part of A is not referenced.
*          If UPLO = 'L', the leading m by n lower trapezoidal part of
*          the array A contains the lower trapezoidal matrix, and the
*          strictly upper triangular part of A is not referenced.  Note
*          that when DIAG = 'U', the diagonal elements of A are not
*          referenced and are assumed to be one.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(M,1).
*
*  WORK    (workspace) REAL array, dimension (LWORK),
*          where LWORK >= M when NORM = 'I'; otherwise, WORK is not
*          referenced.
*
* =====================================================================
*
*     .. Parameters ..
      REAL               ONE, ZERO
      PARAMETER          ( ONE = 1.0E+0, ZERO = 0.0E+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            UDIAG
      INTEGER            I, J
      REAL               SCALE, SUM, VALUE
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           CLASSQ
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, MAX, MIN, SQRT
*     ..
*     .. Executable Statements ..
*
      IF( MIN( M, N ).EQ.0 ) THEN
         VALUE = ZERO
      ELSE IF( LSAME( NORM, 'M' ) ) THEN
*
*        Find max(abs(A(i,j))).
*
         IF( LSAME( DIAG, 'U' ) ) THEN
            VALUE = ONE
            IF( LSAME( UPLO, 'U' ) ) THEN
               DO 20 J = 1, N
                  DO 10 I = 1, MIN( M, J-1 )
                     VALUE = MAX( VALUE, ABS( A( I, J ) ) )
   10             CONTINUE
   20          CONTINUE
            ELSE
               DO 40 J = 1, N
                  DO 30 I = J + 1, M
                     VALUE = MAX( VALUE, ABS( A( I, J ) ) )
   30             CONTINUE
   40          CONTINUE
            END IF
         ELSE
            VALUE = ZERO
            IF( LSAME( UPLO, 'U' ) ) THEN
               DO 60 J = 1, N
                  DO 50 I = 1, MIN( M, J )
                     VALUE = MAX( VALUE, ABS( A( I, J ) ) )
   50             CONTINUE
   60          CONTINUE
            ELSE
               DO 80 J = 1, N
                  DO 70 I = J, M
                     VALUE = MAX( VALUE, ABS( A( I, J ) ) )
   70             CONTINUE
   80          CONTINUE
            END IF
         END IF
      ELSE IF( ( LSAME( NORM, 'O' ) ) .OR. ( NORM.EQ.'1' ) ) THEN
*
*        Find norm1(A).
*
         VALUE = ZERO
         UDIAG = LSAME( DIAG, 'U' )
         IF( LSAME( UPLO, 'U' ) ) THEN
            DO 110 J = 1, N
               IF( ( UDIAG ) .AND. ( J.LE.M ) ) THEN
                  SUM = ONE
                  DO 90 I = 1, J - 1
                     SUM = SUM + ABS( A( I, J ) )
   90             CONTINUE
               ELSE
                  SUM = ZERO
                  DO 100 I = 1, MIN( M, J )
                     SUM = SUM + ABS( A( I, J ) )
  100             CONTINUE
               END IF
               VALUE = MAX( VALUE, SUM )
  110       CONTINUE
         ELSE
            DO 140 J = 1, N
               IF( UDIAG ) THEN
                  SUM = ONE
                  DO 120 I = J + 1, M
                     SUM = SUM + ABS( A( I, J ) )
  120             CONTINUE
               ELSE
                  SUM = ZERO
                  DO 130 I = J, M
                     SUM = SUM + ABS( A( I, J ) )
  130             CONTINUE
               END IF
               VALUE = MAX( VALUE, SUM )
  140       CONTINUE
         END IF
      ELSE IF( LSAME( NORM, 'I' ) ) THEN
*
*        Find normI(A).
*
         IF( LSAME( UPLO, 'U' ) ) THEN
            IF( LSAME( DIAG, 'U' ) ) THEN
               DO 150 I = 1, M
                  WORK( I ) = ONE
  150          CONTINUE
               DO 170 J = 1, N
                  DO 160 I = 1, MIN( M, J-1 )
                     WORK( I ) = WORK( I ) + ABS( A( I, J ) )
  160             CONTINUE
  170          CONTINUE
            ELSE
               DO 180 I = 1, M
                  WORK( I ) = ZERO
  180          CONTINUE
               DO 200 J = 1, N
                  DO 190 I = 1, MIN( M, J )
                     WORK( I ) = WORK( I ) + ABS( A( I, J ) )
  190             CONTINUE
  200          CONTINUE
            END IF
         ELSE
            IF( LSAME( DIAG, 'U' ) ) THEN
               DO 210 I = 1, N
                  WORK( I ) = ONE
  210          CONTINUE
               DO 220 I = N + 1, M
                  WORK( I ) = ZERO
  220          CONTINUE
               DO 240 J = 1, N
                  DO 230 I = J + 1, M
                     WORK( I ) = WORK( I ) + ABS( A( I, J ) )
  230             CONTINUE
  240          CONTINUE
            ELSE
               DO 250 I = 1, M
                  WORK( I ) = ZERO
  250          CONTINUE
               DO 270 J = 1, N
                  DO 260 I = J, M
                     WORK( I ) = WORK( I ) + ABS( A( I, J ) )
  260             CONTINUE
  270          CONTINUE
            END IF
         END IF
         VALUE = ZERO
         DO 280 I = 1, M
            VALUE = MAX( VALUE, WORK( I ) )
  280    CONTINUE
      ELSE IF( ( LSAME( NORM, 'F' ) ) .OR. ( LSAME( NORM, 'E' ) ) ) THEN
*
*        Find normF(A).
*
         IF( LSAME( UPLO, 'U' ) ) THEN
            IF( LSAME( DIAG, 'U' ) ) THEN
               SCALE = ONE
               SUM = MIN( M, N )
               DO 290 J = 2, N
                  CALL CLASSQ( MIN( M, J-1 ), A( 1, J ), 1, SCALE, SUM )
  290          CONTINUE
            ELSE
               SCALE = ZERO
               SUM = ONE
               DO 300 J = 1, N
                  CALL CLASSQ( MIN( M, J ), A( 1, J ), 1, SCALE, SUM )
  300          CONTINUE
            END IF
         ELSE
            IF( LSAME( DIAG, 'U' ) ) THEN
               SCALE = ONE
               SUM = MIN( M, N )
               DO 310 J = 1, N
                  CALL CLASSQ( M-J, A( MIN( M, J+1 ), J ), 1, SCALE,
     $                         SUM )
  310          CONTINUE
            ELSE
               SCALE = ZERO
               SUM = ONE
               DO 320 J = 1, N
                  CALL CLASSQ( M-J+1, A( J, J ), 1, SCALE, SUM )
  320          CONTINUE
            END IF
         END IF
         VALUE = SCALE*SQRT( SUM )
      END IF
*
      CLANTR = VALUE
      RETURN
*
*     End of CLANTR
*
      END

C
C	$Id: fndchr.f,v 1.4 2008-07-27 12:23:43 haley Exp $
C                                                                      
C			     Copyright (C)  1997
C	     University Corporation for Atmospheric Research
C			     All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C

      LOGICAL FUNCTION FNDCHR (CHAR)
C
C  Test the current position in the input buffer for a match with
C  CHAR.  If a match is found, FNDCHR is set to .TRUE. and the
C  buffer pointer is bumped by one; if no match is found, FNDCHR
C  is set to .FALSE. and the buffer pointer is unchanged.  No
C  reloading of the input buffer is done. As a special condition,
C  a match is found if CHAR is blank and the buffer is at the
C  end-of-line.
C
C  OUTPUT
C       FNDCHR  --  Logical value indicating whether a match was found.
C
      COMMON /CAPIOB/ UNIT, IPTR, LSIZE, NFST, NFLG
      COMMON /CAPIO2/ LINE, GRNM
      INTEGER LNMAX
      PARAMETER (LNMAX=80)
      CHARACTER*80 LINE
      CHARACTER*80 GRNM
      INTEGER UNIT, IPTR, LSIZE, NFST, NFLG
C
      CHARACTER*1 CHAR
      CHARACTER*1 BLANK
      DATA BLANK/' '/
C
C  If at END-OF-LINE and CHAR is blank, then set match.
C
      IF (IPTR.GT.LSIZE .AND. CHAR.EQ.BLANK) THEN
        FNDCHR = .TRUE.
        IPTR = IPTR + 1
        RETURN
      END IF
C
C  Check for a match.
C
      IF (LINE(IPTR:IPTR) .EQ. CHAR) THEN
        FNDCHR = .TRUE.
        IPTR = IPTR + 1
        RETURN
      END IF
C
C  No match.
C
      FNDCHR = .FALSE.
      RETURN
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C   FFTPACK 5.0
C   Copyright (C) 1995-2004, Scientific Computing Division,
C   University Corporation for Atmospheric Research
C   Licensed under the GNU General Public License (GPL)
C
C   Authors:  Paul N. Swarztrauber and Richard A. Valent
C
C   $Id: r1f2kf.f,v 1.2 2006-11-21 01:10:18 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      SUBROUTINE DR1F2KF(IDO,L1,CC,IN1,CH,IN2,WA1)
      DOUBLE PRECISION CH(IN2,IDO,2,L1),CC(IN1,IDO,L1,2),WA1(IDO)
C
      DO 101 K = 1,L1
          CH(1,1,1,K) = CC(1,1,K,1) + CC(1,1,K,2)
          CH(1,IDO,2,K) = CC(1,1,K,1) - CC(1,1,K,2)
  101 CONTINUE
      IF (IDO-2) 107,105,102
  102 IDP2 = IDO + 2
      DO 104 K = 1,L1
          DO 103 I = 3,IDO,2
              IC = IDP2 - I
              CH(1,I,1,K) = CC(1,I,K,1) +
     +                      (WA1(I-2)*CC(1,I,K,2)-WA1(I-1)*
     +                      CC(1,I-1,K,2))
              CH(1,IC,2,K) = (WA1(I-2)*CC(1,I,K,2)-
     +                       WA1(I-1)*CC(1,I-1,K,2)) - CC(1,I,K,1)
              CH(1,I-1,1,K) = CC(1,I-1,K,1) +
     +                        (WA1(I-2)*CC(1,I-1,K,2)+WA1(I-1)*
     +                        CC(1,I,K,2))
              CH(1,IC-1,2,K) = CC(1,I-1,K,1) -
     +                         (WA1(I-2)*CC(1,I-1,K,2)+WA1(I-1)*
     +                         CC(1,I,K,2))
  103     CONTINUE
  104 CONTINUE
      IF (MOD(IDO,2).EQ.1) RETURN
  105 DO 106 K = 1,L1
          CH(1,1,2,K) = -CC(1,IDO,K,2)
          CH(1,IDO,1,K) = CC(1,IDO,K,1)
  106 CONTINUE
  107 RETURN
      END

C
C	$Id: gflsbd.f,v 1.5 2008-07-27 00:17:13 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GFLSBD
C
C Calling this do-nothing subroutine forces "ld" to load the following
C block data routine (but only if they are in the same ".f" file).
C
        RETURN
C
      END
CNOSPLIT
      BLOCKDATA GFLSBDX
      COMMON /GFLASH/MODEF,IOPWKS(100),IOACT(100),NUMOP,IWISSI
C
      DATA MODEF/0/
      END

      PROGRAM CTGEO2
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.  Use one
C of the following:
C
C       PARAMETER (IERF=6,LUNI=2,IWTY=1 ,IWID=1)  !  NCGM
C       PARAMETER (IERF=6,LUNI=2,IWTY=8 ,IWID=1)  !  X Windows
C       PARAMETER (IERF=6,LUNI=2,IWTY=20,IWID=1)  !  PostScript
C       PARAMETER (IERF=6,LUNI=2,IWTY=11,IWID=1)  !  PDF, Portrait
C       PARAMETER (IERF=6,LUNI=2,IWTY=12,IWID=1)  !  PDF, Landscape
C
        PARAMETER (IERF=6,LUNI=2,IWTYPE=1,IWTY=IWTYPE,IWID=1)
C
C The object of this program is to produce a set of plots illustrating
C the use of a geodesic mesh (which is inherently a triangular mesh) on
C the surface of the globe.  The method used here is slower than that
C used in CTGEO1, but it yields triangles of more nearly consistent
C size; it divides each face of the icosahedron into little triangles
C in a series of steps that depend on the prime factorization of NDIV
C and projects them onto the surface of the circumsphere to form the
C triangular mesh.  The method also involves some very useful routines
C that can be used to create the structures required by CONPACKT from
C an arbitrary collection of triangles forming a triangular mesh.
C
C Selected frames are drawn for each of four different viewpoints.  If
C (CLAT,CLON) is the approximate position of the "center point" of the
C mesh (which is defined somewhat arbitrarily for certain meshes), the
C four viewpoints used are as follows: (CLAT+45,CLON), (CLAT-45,CLON),
C (CLAT+45,CLON+180), and (CLAT-45,CLON+180).
C
C At each of the four viewpoints, up to four different frames may be
C drawn:
C
C   1) A frame showing the triangular mesh on the globe.  This frame
C      is drawn only if the parameter IMSH is non-zero.
C
C   2) A frame showing simple contours on the globe.  This frame is
C      drawn only if the parameter ICON is non-zero.
C
C   3) A frame showing color-filled contour bands on the globe, drawn
C      using filled areas.  This frame is drawn only if the parameter
C      ICOL is non-zero.
C
C   4) A frame showing color-filled contour bands on the globe, drawn
C      using a cell array.  This frame is drawn only if the parameter
C      ICAP is non-zero.
C
C Define the parameter that says which frames showing the rectangular
C grid and/or the triangular mesh are to be drawn (frame 1):
C
C       PARAMETER (IMSH=0)  !  triangular mesh not drawn
C       PARAMETER (IMSH=1)  !  triangular mesh drawn
C
        PARAMETER (IMSH=1)
C
C Define the parameter that says whether or not to draw simple contours
C (frame 2):
C
C       PARAMETER (ICON=0)  !  contours not drawn
C       PARAMETER (ICON=1)  !  contours drawn
C
        PARAMETER (ICON=1)
C
C Define the parameter that says whether or not to draw color-filled
C contours (frame 3):
C
C       PARAMETER (ICOL=0)  !  no color fill done
C       PARAMETER (ICOL=1)  !  color fill done
C
        PARAMETER (ICOL=1)
C
C Define the parameter that says whether or not to draw a cell array
C plot (frame 4):
C
C       PARAMETER (ICAP=0)  !  cell array plot not drawn
C       PARAMETER (ICAP=1)  !  cell array plot drawn
C
        PARAMETER (ICAP=1)
C
C Define a parameter saying how many pieces each edge of an icosahedron
C is to be broken into in forming the geodesic mesh.
C
C       PARAMETER (NDIV=75)
C       PARAMETER (NDIV=36)
C       PARAMETER (NDIV=24)
        PARAMETER (NDIV=16)
C
C To represent the triangular mesh, we use three singly-dimensioned
C arrays: RPNT holds points, IEDG holds edges, and ITRI holds triangles.
C The elements of each array form "nodes" having lengths as follows:
C
        PARAMETER (LOPN=5)
C
C The five elements of a point node are
C
C   1. the X coordinate of the point;
C   2. the Y coordinate of the point;
C   3. the Z coordinate of the point;
C   4. the field value at the point;
C   5. any additional value desired by the user.
C
        PARAMETER (LOEN=5)
C
C The five elements of an edge node are
C
C   1. the base index, in RPNT, of point 1 of the edge;
C   2. the base index, in RPNT, of point 2 of the edge;
C   3. the index, in ITRI, of the pointer to the edge in the triangle to
C      the left of the edge (-1 if there is no triangle to the left);
C   4. the index, in ITRI, of the pointer to the edge in the triangle to
C      the right of the edge (-1 if there is no triangle to the right);
C   5. a utility flag for use by algorithms that scan the structure.
C
C The "left" and "right" sides of an edge are defined as they would be
C by an observer standing on the globe at point 1 of the edge, looking
C toward point 2 of the edge.  It is possible, if there are "holes" in
C the mesh, that there will be no triangle to the left or to the right
C of an edge, but there must be a triangle on one side or the other.
C
        PARAMETER (LOTN=4)
C
C The four elements of a triangle node are
C
C   1. the base index, in IEDG, of edge 1 of the triangle;
C   2. the base index, in IEDG, of edge 2 of the triangle;
C   3. the base index, in IEDG, of edge 3 of the triangle;
C   4. a flag set non-zero to block use of the triangle, effectively
C      removing it from the mesh.
C
C The "base index" of a point node, an edge node, or a triangle node is
C always a multiple of the length of the node, to which can be added an
C offset to get the index of a particular element of the node.  For
C example, if I is the base index of a triangle of interest, ITRI(I+1)
C is its first element (the base index of its first edge).  Similarly,
C IEDG(ITRI(I+1)+2) is the base index of the second point of the first
C edge of the triangle with base index I, and RPNT(IEDG(ITRI(I+1)+2)+3)
C is the third (Z) coordinate of the second point of the first edge of
C the triangle with base index I.
C
C It is the pointers from the edge nodes back to the triangle nodes that
C allow CONPACKT to navigate the mesh, moving from triangle to triangle
C as it follows a contour line, but these pointers are tricky to define:
C if IPTE is the base index of an edge node and IEDG(IPTE+3) is zero or
C more, saying that there is a triangle to the left of the edge, then
C IEDG(IPTE+3) is the actual index of that element of the triangle node
C that points to the edge node; i.e., ITRI(IEDG(IPTE+3))=IPTE.  The base
C index of the triangle node defining that triangle is IPTT, where
C IPTT=LOTN*((IEDG(IPTE+3)-1)/LOTN), and the index of the pointer to
C the edge within the triangle node is IPTI=IEDG(IPTE+3)-IPTT, so that
C ITRI(IPTT+IPTI)=IPTE.  Similar comments apply to element 4 of an edge
C node, which points into the triangle node defining the triangle to the
C right of the edge.
C
C The maximum number of points, edges, and triangles in a geodesic mesh
C can be computed from the parameter NDIV, which determines the order of
C the geodesic mesh:
C
        PARAMETER (MNOP=10*NDIV*NDIV+2)
        PARAMETER (MNOE=30*NDIV*NDIV)
        PARAMETER (MNOT=20*NDIV*NDIV)
C
C Once we know how many points, edges, and triangles we're going to use
C (at most), we can set parameters defining the space reserved for the
C triangular mesh:
C
        PARAMETER (MPNT=MNOP*LOPN)
        PARAMETER (MEDG=MNOE*LOEN)
        PARAMETER (MTRI=MNOT*LOTN)
C
C Declare the arrays to hold the point nodes, edge nodes, and triangle
C nodes defining the triangular mesh.
C
        DIMENSION RPNT(MPNT),IEDG(MEDG),ITRI(MTRI)
C
C Declare sort arrays to be used to keep track of where points and
C edges were put in the structure defining the triangular mesh.
C
        DIMENSION IPPP(2,MNOP),IPPE(2,MNOE)
C
C Declare real and integer workspaces needed by CONPACKT.
C
        PARAMETER (LRWK=10000,LIWK=1000)
C
        DIMENSION RWRK(LRWK),IWRK(LIWK)
C
C Declare the area map array needed to do solid fill.
C
        PARAMETER (LAMA=200000)
C
        DIMENSION IAMA(LAMA)
C
C Declare workspace arrays to be used in calls to ARSCAM.
C
        PARAMETER (NCRA=LAMA/10,NGPS=2)
C
        DIMENSION XCRA(NCRA),YCRA(NCRA),IAAI(NGPS),IAGI(NGPS)
C
C Declare arrays in which to generate a cell array picture of the
C data on the triangular mesh.
C
C       PARAMETER (ICAM=1024,ICAN=1024)
        PARAMETER (ICAM= 512,ICAN= 512)
C
        DIMENSION ICRA(ICAM,ICAN)
C
C Declare arrays to hold color components for colors to be used at the
C four corners of an illustrative drawing of the rectangular grid.
C
        DIMENSION CCLL(3),CCLR(3),CCUL(3),CCUR(3)
C
C Declare external the routine that draws masked contour lines.
C
        EXTERNAL DRWMCL
C
C Declare external the routine that does color fill of contour bands.
C
        EXTERNAL DCFOCB
C
C Define a common block in which to keep track of the maximum space used
C in the arrays XCRA and YCRA.
C
        COMMON /COMONA/ MAXN
C
C Define the out-of-range flag.
C
        DATA OORV / 1.E12 /
C
C Define the tension on the splines to be used in smoothing contours.
C
C       DATA T2DS / 0.0 /  !  smoothing off
C       DATA T2DS / 2.5 /  !  smoothing on
C
        DATA T2DS / 0.0 /
C
C Define the distance between points on smoothed contour lines.
C
        DATA RSSL / .002 /
C
C Define the amount of real workspace to be used in drawing contours.
C
        DATA IRWC / 500 /
C
C Define the label-positioning flag.
C
C       DATA ILLP / 0 /  !  no labels
C       DATA ILLP / 1 /  !  dash-package writes labels
C       DATA ILLP / 2 /  !  regular scheme
C       DATA ILLP / 3 /  !  penalty scheme
C
        DATA ILLP / 2 /
C
C Define the high/low search radius.
C
        DATA HLSR / .075 /
C
C Define the high/low label overlap flag.
C
        DATA IHLO / 11 /
C
C Define the hachuring flag, hachure length, and hachure spacing.
C
C       DATA IHCF,HCHL,HCHS /  0 , +.004 , .010 /  !  off
C       DATA IHCF,HCHL,HCHS / +1 , -.004 , .020 /  !  on, all, uphill
C
        DATA IHCF,HCHL,HCHS /  0 , +.004 , .010 /
C
C Define the colors to be used in the lower left, lower right, upper
C left, and upper right corners of the rectangular grid when a drawing
C of it is made for the purpose of illustrating how it is wrapped around
C the globe.
C
        DATA CCLL / 0.2 , 0.2 , 0.2 /
        DATA CCLR / 1.0 , 0.0 , 1.0 /
        DATA CCUL / 0.0 , 1.0 , 1.0 /
        DATA CCUR / 1.0 , 1.0 , 0.0 /
C
C Define a constant to convert from radians to degrees.
C
        DATA RTOD / 57.2957795130823 /
C
C Create data and generate the required triangular mesh.
C
        PRINT * , ' '
        PRINT * , 'CREATING TRIANGULAR MESH:'
C
        CALL GTGEO2 (RPNT,MPNT,NPNT,LOPN,
     +               IEDG,MEDG,NEDG,LOEN,
     +               ITRI,MTRI,NTRI,LOTN,
     +               IPPP,IPPE,NDIV,CLAT,CLON)
C
C Print the number of points, edges, and triangles.
C
        PRINT * , '  NUMBER OF POINTS:    ',NPNT/LOPN
        PRINT * , '  NUMBER OF EDGES:     ',NEDG/LOEN
        PRINT * , '  NUMBER OF TRIANGLES: ',NTRI/LOTN
C
C Write the contents of the point list, the edge list, and the triangle
C list to "fort.11" in a readable form.
C
c       WRITE (11,'(''P'',I8,5F10.4)')
c    +        (I,RPNT(I+1),RPNT(I+2),RPNT(I+3),RPNT(I+4),RPNT(I+5),
c    +                                               I=0,NPNT-LOPN,LOPN)
c       WRITE (11,'(''E'',I8,5I10)')
c    +        (I,IEDG(I+1),IEDG(I+2),IEDG(I+3),IEDG(I+4),IEDG(I+5),
c    +                                               I=0,NEDG-LOEN,LOEN)
c       WRITE (11,'(''T'',I8,4I10)')
c    +        (I,ITRI(I+1),ITRI(I+2),ITRI(I+3),ITRI(I+4),
c    +                                               I=0,NTRI-LOTN,LOTN)
C
C Open GKS.
C
        PRINT * , 'OPENING AND INITIALIZING GKS'
C
        CALL GOPKS (IERF,0)
        CALL GOPWK (IWID,LUNI,IWTY)
        CALL GACWK (IWID)
C
C Turn off the clipping indicator.
C
        CALL GSCLIP (0)
C
C Define a basic set of colors (0 = white, background; 1 = black,
C foreground; 2 = yellow; 3 = magenta; 4 = red; 5 = cyan; 6 = green;
C 7 = blue; 8 = darker light gray; 9 = lighter light gray; 10 = dark
C yellow; 11 = dark gray; 12 = medium gray; 13 = light red, for
C geographic lines; 14 = light blue, for lat/lon lines).
C
        CALL GSCR   (IWID, 0,1.,1.,1.)
        CALL GSCR   (IWID, 1,0.,0.,0.)
        CALL GSCR   (IWID, 2,1.,1.,0.)
        CALL GSCR   (IWID, 3,1.,0.,1.)
        CALL GSCR   (IWID, 4,1.,0.,0.)
        CALL GSCR   (IWID, 5,0.,1.,1.)
        CALL GSCR   (IWID, 6,0.,1.,0.)
        CALL GSCR   (IWID, 7,0.,0.,1.)
        CALL GSCR   (IWID, 8,.5,.5,.5)
        CALL GSCR   (IWID, 9,.8,.8,.8)
        CALL GSCR   (IWID,10,.3,.3,0.)
        CALL GSCR   (IWID,11,.3,.3,.3)
        CALL GSCR   (IWID,12,.5,.5,.5)
        CALL GSCR   (IWID,13,.8,.5,.5)
        CALL GSCR   (IWID,14,.5,.5,.8)
C
C Define 100 colors, associated with color indices 151 through 250, to
C be used for color-filled contour bands and in cell arrays, ranging
C from blue to red.
C
        CALL DFCLRS (IWID,151,250,0.,0.,1.,1.,0.,0.)
C
C Set parameters in the utilities.
C
        PRINT * , 'SETTING PARAMETERS IN CONPACKT, EZMAP, AND PLOTCHAR'
C
C Set the mapping flag.
C
        CALL CTSETI ('MAP - MAPPING FLAG',1)
C
C Set the out-of-range flag value.
C
        CALL CTSETR ('ORV - OUT-OF-RANGE VALUE',OORV)
C
C Turn on the drawing of the mesh edge and set the area identifier for
C areas outside the mesh.
C
        CALL CTSETI ('PAI - PARAMETER ARRAY INDEX',-1)
        CALL CTSETI ('CLU - CONTOUR LEVEL USE FLAG',1)
        CALL CTSETI ('AIA - AREA IDENTIFIER FOR AREA',1001)
C
C Set the area identifier for areas in "out-of-range" areas.
C
C       CALL CTSETI ('PAI',-2)
C       CALL CTSETI ('AIA - AREA IDENTIFIER FOR AREA',1002)
C
C Set the 2D smoother flag.
C
        CALL CTSETR ('T2D - TENSION ON 2D SPLINES',T2DS)
C
C Set the distance between points on smoothed lines.
C
        CALL CTSETR ('SSL - SMOOTHED SEGMENT LENGTH',RSSL)
C
C Set the amount of real workspace to be used in drawing contours.
C
        CALL CTSETI ('RWC - REAL WORKSPACE FOR CONTOURS',IRWC)
C
C Set the label-positioning flag.
C
        CALL CTSETI ('LLP - LINE LABEL POSITIONING FLAG',ILLP)
C
C Set the high/low search radius.
C
        CALL CTSETR ('HLR - HIGH/LOW SEARCH RADIUS',HLSR)
C
C Set the high/low label overlap flag.
C
        CALL CTSETI ('HLO - HIGH/LOW LABEL OVERLAP FLAG',IHLO)
C
C Set the hachuring flag, hachure length, and hachure spacing.
C
        CALL CTSETI ('HCF - HACHURING FLAG',IHCF)
        CALL CTSETR ('HCL - HACHURE LENGTH',HCHL)
        CALL CTSETR ('HCS - HACHURE SPACING',HCHS)
C
C Set the cell array flag.
C
        CALL CTSETI ('CAF - CELL ARRAY FLAG',-1)
C
C Tell CONPACKT not to do its own call to SET, since EZMAP will have
C done it.
C
        CALL CTSETI ('SET - DO-SET-CALL FLAG', 0)
C
C Move the informational label up a little.
C
        CALL CTSETR ('ILY - INFORMATIONAL LABEL Y POSITION',-.005)
C
C Tell EZMAP not to draw the perimeter.
C
        CALL MPSETI ('PE',0)
C
C Tell EZMAP to use solid lat/lon lines.
C
        CALL MPSETI ('DA',65535)
C
C Tell PLOTCHAR to use one of the filled fonts and to outline each
C character.
C
        CALL PCSETI ('FN',25)
        CALL PCSETI ('OF',1)
C
C Tell PLOTCHAR to expect a character other than a colon as the
C function-control signal character.
C
        CALL PCSETC ('FC','|')
C
C Loop through four different viewing angles.
C
        DO 104 IDIR=1,4
C
          PRINT * , ' '
          PRINT * , 'VIEW FROM DIRECTION NUMBER: ',IDIR
C
C Tell EZMAP what projection to use and what its limits are.
C
          IF      (IDIR.EQ.1) THEN
            CALL MAPROJ ('OR',CLAT+45.,CLON,      0.)
          ELSE IF (IDIR.EQ.2) THEN
            CALL MAPROJ ('OR',CLAT-45.,CLON,      0.)
          ELSE IF (IDIR.EQ.3) THEN
            CALL MAPROJ ('OR',CLAT+45.,CLON+180., 0.)
          ELSE IF (IDIR.EQ.4) THEN
            CALL MAPROJ ('OR',CLAT-45.,CLON+180., 0.)
          END IF
C
          CALL MAPSET ('MA',0.,0.,0.,0.)
C
C Initialize EZMAP.
C
          CALL MAPINT
C
C If the triangular mesh is to be drawn, do it.
C
          IF (IMSH.NE.0) THEN
C
            PRINT * , 'DRAWING TRIANGULAR MESH'
C
            DO 101 IPTE=0,NEDG-LOEN,LOEN
C
              IFLL=0
C
              IF (IEDG(IPTE+3).GE.0) THEN
                IF (ITRI(LOTN*((IEDG(IPTE+3)-1)/LOTN)+4).EQ.0) IFLL=1
              END IF
C
              IFLR=0
C
              IF (IEDG(IPTE+4).GE.0) THEN
                IF (ITRI(LOTN*((IEDG(IPTE+4)-1)/LOTN)+4).EQ.0) IFLR=1
              END IF
C
              IF (IFLL.NE.0.OR.IFLR.NE.0) THEN
                CALL PLOTIT (0,0,2)
                CALL GSPLCI (8)
              ELSE
                CALL PLOTIT (0,0,2)
                CALL GSPLCI (9)
              END IF
C
              ALAT=RTOD*ASIN(RPNT(IEDG(IPTE+1)+3))
C
              IF (RPNT(IEDG(IPTE+1)+1).EQ.0..AND.
     +            RPNT(IEDG(IPTE+1)+2).EQ.0.) THEN
                ALON=0.
              ELSE
                ALON=RTOD*ATAN2(RPNT(IEDG(IPTE+1)+2),
     +                          RPNT(IEDG(IPTE+1)+1))
              END IF
C
              BLAT=RTOD*ASIN(RPNT(IEDG(IPTE+2)+3))
C
              IF (RPNT(IEDG(IPTE+2)+1).EQ.0..AND.
     +            RPNT(IEDG(IPTE+2)+2).EQ.0.) THEN
                BLON=0.
              ELSE
                BLON=RTOD*ATAN2(RPNT(IEDG(IPTE+2)+2),
     +                          RPNT(IEDG(IPTE+2)+1))
              END IF
C
              CALL DRSGCR (ALAT,ALON,BLAT,BLON)
C
  101       CONTINUE
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (13)
            CALL MAPGRD
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (14)
            CALL MAPLOT
C
C Draw the edges and vertices of the generating icosahedron.
C
            CALL DRGEAV
C
C Label the first frame.
C
            CALL PLCHHQ (CFUX(.03),CFUY(.946),'GEODESIC',.024,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.906),'(METHOD 2)',.016,0.,-1.)
C
            IF (     IDIR.EQ.1) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 1',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.2) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 2',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.3) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 3',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.4) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 4',
     +                                                      .012,0.,-1.)
            END IF
C
            CALL PLCHHQ (CFUX(.97),CFUY(.950),'DERIVED TRIANGULAR MESH',
     +.012,0.,1.)
C
            CALL PLCHHQ (CFUX(.97),CFUY(.928),
     +                   'This mesh is created by subdividing',
     +                                                       .010,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.908),
     +                   'the faces of an icosahedron into',
     +                                                       .010,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.888),
     +                   'N x N equilateral triangles',
     +                                                       .010,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.868),
     +                   'and projecting those',
     +                                                       .010,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.848),
     +                   'onto the surface',
     +                                                       .010,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.828),
     +                   'of the globe',
     +                                                       .010,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.808),
     +                   '(shown for',
     +                                                       .010,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.788),
     +                   'N=16).',
     +                                                       .010,0.,1.)
C
            CALL PLCHHQ (CFUX(.97),CFUY(.163),
     +                   'Small triangles',
     +                                                       .010,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.143),
     +                   'are formed in a set',
     +                                                       .010,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.123),
     +                   'of steps that depend',
     +                                                       .010,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.103),
     +                   'on prime factors of N.',
     +                                                       .010,0.,1.)
C
            CALL PLCHHQ (CFUX(.97),CFUY(.073),
     +                   'Projections of the edges and',
     +                                                       .010,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.053),
     +                   'vertices of the original icosahedron',
     +                                                       .010,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.033),
     +                   'are drawn using bold black lines and dots.',
     +                                                       .010,0.,1.)
C
            CALL PLCHHQ (CFUX(.03),CFUY(.084),'Mesh is gray.',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.060),'Shorelines are blue.',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.036),'Parallels/meridians are r
     +ed.',.012,0.,-1.)
C
C Advance the frame.
C
            CALL FRAME
C
          END IF
C
C If a frame showing simple contours is to be drawn, do it next (adding
C an overlay of lat/lon lines and continental outlines in light gray).
C
          IF (ICON.NE.0) THEN
C
            PRINT * , 'DRAWING PLOT SHOWING SIMPLE CONTOURS'
C
C Initialize CONPACKT.
C
            PRINT * , 'CALLING CTMESH'
C
            CALL CTMESH (RPNT,NPNT,LOPN,
     +                   IEDG,NEDG,LOEN,
     +                   ITRI,NTRI,LOTN,
     +                   RWRK,LRWK,
     +                   IWRK,LIWK)
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (1)
C
C Proceed as implied by the setting of the label-positioning flag.
C
            IF (ABS(ILLP).EQ.1) THEN
C
C Draw the contour lines with labels generated by the dash package.
C
              PRINT * , 'CALLING CTCLDR'
              CALL CTCLDR (RPNT,IEDG,ITRI,RWRK,IWRK)
C
C Add the informational and high/low labels.
C
              PRINT * , 'CALLING CTLBDR'
              CALL CTLBDR (RPNT,IEDG,ITRI,RWRK,IWRK)
C
            ELSE IF (ABS(ILLP).GT.1) THEN
C
C Create an area map for masking of labels.
C
              MAXN=0
C
              PRINT * , 'CALLING ARINAM'
              CALL ARINAM (IAMA,LAMA)
C
              PRINT * , 'CALLING CTLBAM'
              CALL CTLBAM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA)
C
C Draw the contour lines masked by the area map.
C
              PRINT * , 'CALLING CTCLDM'
              CALL CTCLDM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA,DRWMCL)
C
              PRINT * , 'AREA MAP SPACE REQUIRED:         ',
     +                                         IAMA(1)-IAMA(6)+IAMA(5)+1
C
              PRINT * , 'NUMBER OF POINTS IN LONGEST LINE:',MAXN
C
C Draw all the labels.
C
              PRINT * , 'CALLING CTLBDR'
              CALL CTLBDR (RPNT,IEDG,ITRI,RWRK,IWRK)
C
            END IF
C
            CALL CTGETI ('IWU - INTEGER WORKSPACE USED',IIWU)
            PRINT * , 'INTEGER WORKSPACE REQUIRED:      ',IIWU
C
            CALL CTGETI ('RWU -    REAL WORKSPACE USED',IRWU)
            PRINT * , 'REAL WORKSPACE REQUIRED:         ',IRWU
C
C Add lat/lon lines and continental outlines.
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (13)
            CALL MAPGRD
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (14)
            CALL MAPLOT
C
C Label the second frame.
C
            CALL PLCHHQ (CFUX(.03),CFUY(.946),'GEODESIC',.024,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.906),'(METHOD 2)',.016,0.,-1.)
C
            IF (     IDIR.EQ.1) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 1',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.2) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 2',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.3) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 3',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.4) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 4',
     +                                                      .012,0.,-1.)
            END IF
C
            CALL PLCHHQ (CFUX(.97),CFUY(.950),'SIMPLE CONTOURS ON',
     +                                                       .012,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.926),'TRIANGULAR MESH',
     +                                                       .012,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.904),'Dummy data are used.',
     +                                                       .010,0.,1.)
C
            CALL PLCHHQ (CFUX(.03),CFUY(.060),'Shorelines are blue.',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.036),'Parallels/meridians are r
     +ed.',.012,0.,-1.)
C
C Advance the frame.
C
            CALL FRAME
C
          END IF
C
C If a frame showing color-filled contours is to be drawn, do it next.
C
          IF (ICOL.NE.0) THEN
C
            PRINT * , 'DRAWING PLOT SHOWING COLOR-FILLED CONTOURS'
C
            PRINT * , 'CALLING CTMESH'
C
            CALL CTMESH (RPNT,NPNT,LOPN,
     +                   IEDG,NEDG,LOEN,
     +                   ITRI,NTRI,LOTN,
     +                   RWRK,LRWK,
     +                   IWRK,LIWK)
C
            MAXN=0
C
            PRINT * , 'CALLING CTPKCL'
            CALL CTPKCL (RPNT,IEDG,ITRI,RWRK,IWRK)
C
            PRINT * , 'CALLING ARINAM'
            CALL ARINAM (IAMA,LAMA)
C
            PRINT * , 'CALLING CTCLAM'
            CALL CTCLAM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA)
C
C           PRINT * , 'CALLING CTLBAM'
C           CALL CTLBAM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA)
C
            PRINT * , 'CALLING ARSCAM'
            CALL ARSCAM (IAMA,XCRA,YCRA,NCRA,IAAI,IAGI,NGPS,DCFOCB)
C
            PRINT * , 'SPACE REQUIRED IN AREA MAP:      ',
     +                                         IAMA(1)-IAMA(6)+IAMA(5)+1
C
            PRINT * , 'NUMBER OF POINTS IN LARGEST AREA:',MAXN
C
            CALL CTGETI ('IWU - INTEGER WORKSPACE USED',IIWU)
            PRINT * , 'INTEGER WORKSPACE REQUIRED:      ',IIWU
C
            CALL CTGETI ('RWU -    REAL WORKSPACE USED',IRWU)
            PRINT * , 'REAL WORKSPACE REQUIRED:         ',IRWU
C
            CALL GSFACI (1)
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (13)
            CALL MAPGRD
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (14)
            CALL MAPLOT
C
C Label the third frame.
C
            CALL PLCHHQ (CFUX(.03),CFUY(.946),'GEODESIC',.024,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.906),'(METHOD 2)',.016,0.,-1.)
C
            IF (     IDIR.EQ.1) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 1',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.2) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 2',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.3) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 3',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.4) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 4',
     +                                                      .012,0.,-1.)
            END IF
C
            CALL PLCHHQ (CFUX(.97),CFUY(.950),'COLORED CONTOUR BANDS ON'
     +,.012,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.926),'TRIANGULAR MESH',
     +                                                       .012,0.,1.)
C
            CALL PLCHHQ (CFUX(.97),CFUY(.904),'Dummy data are used.',
     +                                                       .010,0.,1.)
C
            CALL PLCHHQ (CFUX(.03),CFUY(.132),'Off-mesh',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.108),'areas of the',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.084),'globe are yellow.',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.060),'Shorelines are blue.',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.036),'Parallels/meridians are r
     +ed.',.012,0.,-1.)
C
C Advance the frame.
C
            CALL FRAME
C
          END IF
C
C If the flag for it is set, do a cell array plot.
C
          IF (ICAP.NE.0) THEN
C
            PRINT * , 'DRAWING CELL-ARRAY PLOT OF DATA VALUES'
C
            PRINT * , 'CALLING CTMESH'
C
            CALL CTMESH (RPNT,NPNT,LOPN,
     +                   IEDG,NEDG,LOEN,
     +                   ITRI,NTRI,LOTN,
     +                   RWRK,LRWK,
     +                   IWRK,LIWK)
C
            CALL GETSET (XVPL,XVPR,YVPB,YVPT,XWDL,XWDR,YWDB,YWDT,LNLG)
C
            PRINT * , 'CALLING CTCICA'
            CALL CTCICA (RPNT,IEDG,ITRI,RWRK,IWRK,ICRA,ICAM,ICAM,ICAN,
     +                                            XVPL,YVPB,XVPR,YVPT)
C
            PRINT * , 'CALLING GCA'
            CALL GCA (XWDL,YWDB,XWDR,YWDT,ICAM,ICAN,1,1,ICAM,ICAN,ICRA)
C
            CALL CTGETI ('IWU - INTEGER WORKSPACE USED',IIWU)
            PRINT * , 'INTEGER WORKSPACE REQUIRED:      ',IIWU
C
            CALL CTGETI ('RWU -    REAL WORKSPACE USED',IRWU)
            PRINT * , 'REAL WORKSPACE REQUIRED:         ',IRWU
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (13)
            CALL MAPGRD
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (14)
            CALL MAPLOT
C
C Label the fourth frame.
C
            CALL PLCHHQ (CFUX(.03),CFUY(.946),'GEODESIC',.024,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.906),'(METHOD 2)',.016,0.,-1.)
C
            IF (     IDIR.EQ.1) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 1',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.2) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 2',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.3) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 3',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.4) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 4',
     +                                                      .012,0.,-1.)
            END IF
C
            CALL PLCHHQ (CFUX(.97),CFUY(.950),'CELL ARRAY DERIVED FROM',
     +.012,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.926),'TRIANGULAR MESH',
     +                                                       .012,0.,1.)
C
            CALL PLCHHQ (CFUX(.97),CFUY(.904),'Dummy data are used.',
     +                                                       .010,0.,1.)
C
            CALL PLCHHQ (CFUX(.03),CFUY(.132),'Off-mesh',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.108),'areas of the',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.084),'globe are yellow.',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.060),'Shorelines are blue.',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.036),'Parallels/meridians are r
     +ed.',.012,0.,-1.)
C
C Advance the frame.
C
            CALL FRAME
C
          END IF
C
  104   CONTINUE
C
C Close GKS.
C
        CALL GDAWK (IWID)
        CALL GCLWK (IWID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END


      SUBROUTINE DFCLRS (IWID,IOFC,IOLC,REDF,GRNF,BLUF,REDL,GRNL,BLUL)
C
C This routine defines color indices IOFC through IOLC on workstation
C IWID by interpolating values from REDF/GRNF/BLUF to REDL/GRNL/BLUL.
C
        DO 101 I=IOFC,IOLC
          P=REAL(IOLC-I)/REAL(IOLC-IOFC)
          Q=REAL(I-IOFC)/REAL(IOLC-IOFC)
          CALL GSCR (IWID,I,P*REDF+Q*REDL,P*GRNF+Q*GRNL,P*BLUF+Q*BLUL)
  101   CONTINUE
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE DRWMCL (XCRA,YCRA,NCRA,IAAI,IAGI,NGPS)
C
        DIMENSION XCRA(*),YCRA(*),IAAI(*),IAGI(*)
C
C This routine draws the curve defined by the points (XCRA(I),YCRA(I)),
C for I = 1 to NCRA, if and only if none of the area identifiers for the
C area containing the polyline are negative.  It calls either CURVE or
C CURVED to do the drawing, depending on the value of the internal
C parameter 'DPU'.
C
C It keeps track of the maximum value used for NCRA in a common block.
C
        COMMON /COMONA/ MAXN
C
        MAXN=MAX(MAXN,NCRA)
C
C Retrieve the value of the internal parameter 'DPU'.
C
        CALL CTGETI ('DPU - DASH PACKAGE USED',IDUF)
C
C Turn on drawing.
C
        IDRW=1
C
C If any area identifier is negative, turn off drawing.
C
        DO 101 I=1,NGPS
          IF (IAAI(I).LT.0) IDRW=0
  101   CONTINUE
C
C If drawing is turned on, draw the polyline.
C
        IF (IDRW.NE.0) THEN
          IF (IDUF.EQ.0) THEN
            CALL CURVE  (XCRA,YCRA,NCRA)
          ELSE IF (IDUF.LT.0) THEN
            CALL DPCURV (XCRA,YCRA,NCRA)
          ELSE
            CALL CURVED (XCRA,YCRA,NCRA)
          END IF
        END IF
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE DCFOCB (XCRA,YCRA,NCRA,IAAI,IAGI,NGPS)
C
C This routine fills the area defined by the points (XCRA(I),YCRA(I)),
C for I = 1 to NCRA, if and only if none of the area identifiers for
C the area are negative.  The color used is determined from the area
C identifier of the area relative to group 3; it is assumed that 100
C colors are defined having color indices 151 through 250.
C
        DIMENSION XCRA(*),YCRA(*),IAAI(*),IAGI(*)
C
C It keeps track of the maximum value used for NCRA in a common block.
C
        COMMON /COMONA/ MAXN
C
        MAXN=MAX(MAXN,NCRA)
C
C Retrieve the number of contour levels being used.
C
        CALL CTGETI ('NCL - NUMBER OF CONTOUR LEVELS',NOCL)
C
C If the number of contour levels is non-zero and the area has more
C than two points, fill it.
C
        IF (NOCL.NE.0.AND.NCRA.GT.2) THEN
C
          IAI3=-1
C
          DO 101 I=1,NGPS
            IF (IAGI(I).EQ.3) IAI3=IAAI(I)
  101     CONTINUE
C
          IF (IAI3.GE.1.AND.IAI3.LE.NOCL+1) THEN
            CALL GSFACI (151+INT(((REAL(IAI3)-.5)/REAL(NOCL+1))*100.))
            CALL GFA    (NCRA,XCRA,YCRA)
          ELSE IF (IAI3.EQ.1001) THEN
            CALL GSFACI (2)
            CALL GFA    (NCRA,XCRA,YCRA)
          ELSE IF (IAI3.EQ.1002) THEN
            CALL GSFACI (3)
            CALL GFA    (NCRA,XCRA,YCRA)
          END IF
C
        END IF
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE DRGEAV
C
C Draw the edges and vertices of the icosahedron used to generate a
C geodesic grid.
C
C Declare arrays to hold information describing an icosahedron.
C
        DIMENSION JEDG(2,30),XCVI(12),YCVI(12),ZCVI(12)
C
C Declare arrays to hold the latitudes and longitudes of the vertices
C (to be computed).
C
        DIMENSION RLAT(12),RLON(12)
C
C Define the thirty edges of the icosahedron (pointers to vertices).
C
        DATA JEDG(1, 1),JEDG(2, 1) /  1, 3 /
        DATA JEDG(1, 2),JEDG(2, 2) /  1, 5 /
        DATA JEDG(1, 3),JEDG(2, 3) /  1, 7 /
        DATA JEDG(1, 4),JEDG(2, 4) /  1, 9 /
        DATA JEDG(1, 5),JEDG(2, 5) /  1,11 /
        DATA JEDG(1, 6),JEDG(2, 6) /  2, 4 /
        DATA JEDG(1, 7),JEDG(2, 7) /  2, 6 /
        DATA JEDG(1, 8),JEDG(2, 8) /  2, 8 /
        DATA JEDG(1, 9),JEDG(2, 9) /  2,10 /
        DATA JEDG(1,10),JEDG(2,10) /  2,12 /
        DATA JEDG(1,11),JEDG(2,11) /  3, 5 /
        DATA JEDG(1,12),JEDG(2,12) /  3, 8 /
        DATA JEDG(1,13),JEDG(2,13) /  3,10 /
        DATA JEDG(1,14),JEDG(2,14) /  3,11 /
        DATA JEDG(1,15),JEDG(2,15) /  4, 6 /
        DATA JEDG(1,16),JEDG(2,16) /  4, 7 /
        DATA JEDG(1,17),JEDG(2,17) /  4, 9 /
        DATA JEDG(1,18),JEDG(2,18) /  4,12 /
        DATA JEDG(1,19),JEDG(2,19) /  5, 7 /
        DATA JEDG(1,20),JEDG(2,20) /  5,10 /
        DATA JEDG(1,21),JEDG(2,21) /  5,12 /
        DATA JEDG(1,22),JEDG(2,22) /  6, 8 /
        DATA JEDG(1,23),JEDG(2,23) /  6, 9 /
        DATA JEDG(1,24),JEDG(2,24) /  6,11 /
        DATA JEDG(1,25),JEDG(2,25) /  7, 9 /
        DATA JEDG(1,26),JEDG(2,26) /  7,12 /
        DATA JEDG(1,27),JEDG(2,27) /  8,10 /
        DATA JEDG(1,28),JEDG(2,28) /  8,11 /
        DATA JEDG(1,29),JEDG(2,29) /  9,11 /
        DATA JEDG(1,30),JEDG(2,30) / 10,12 /
C
C Define the 12 vertices of the icosahedron (note radius less than one).
C
        DATA XCVI / .0000000000000 ,  .0000000000000 , -.8506508083520 ,
     +              .8506508083520 , -.2628655560596 ,  .2628655560596 ,
     +              .6881909602356 , -.6881909602356 ,  .6881909602356 ,
     +             -.6881909602356 , -.2628655560595 ,  .2628655560596 /
        DATA YCVI / .0000000000000 ,  .0000000000000 ,  .0000000000000 ,
     +              .0000000000000 , -.8090169943749 ,  .8090169943749 ,
     +             -.5000000000000 ,  .5000000000000 ,  .5000000000000 ,
     +             -.5000000000000 ,  .8090169943749 , -.8090169943749 /
        DATA ZCVI / .9510565162952 , -.9510565162951 ,  .4253254041760 ,
     +             -.4253254041760 ,  .4253254041760 , -.4253254041760 ,
     +              .4253254041760 , -.4253254041760 ,  .4253254041760 ,
     +             -.4253254041760 ,  .4253254041760 , -.4253254041760 /
C
C Define a constant to convert from radians to degrees.
C
        DATA RTOD / 57.2957795130823 /
C
C Enlarge the icosahedron to have a radius of one and compute lat/lon
C coordinates of the points.
C
        DO 101 I=1,12
          DNOM=SQRT(XCVI(I)**2+YCVI(I)**2+ZCVI(I)**2)
          XCVI(I)=XCVI(I)/DNOM
          YCVI(I)=YCVI(I)/DNOM
          ZCVI(I)=ZCVI(I)/DNOM
          RLAT(I)=RTOD*ASIN(ZCVI(I))
          IF (XCVI(I).EQ.0..AND.YCVI(I).EQ.0.) THEN
            RLON(I)=0.
          ELSE
            RLON(I)=RTOD*ATAN2(YCVI(I),XCVI(I))
          END IF
  101   CONTINUE
C
C Draw the edges of the icosahedron, projected outwards onto the surface
C of the sphere.
C
        CALL PLOTIF (0.,0.,2)
        CALL GSLWSC (2.)
        CALL GSPLCI (1)
        CALL GSFACI (1)
C
        DO 102 I=1,30
          CALL DRSGCR (RLAT(JEDG(1,I)),RLON(JEDG(1,I)),
     +                 RLAT(JEDG(2,I)),RLON(JEDG(2,I)))
  102   CONTINUE
C
        CALL PLOTIF (0.,0.,2)
        CALL GSLWSC (1.)
C
C Mark the vertices of the icosahedron.
C
        DO 103 I=1,12
          CALL MAPTRA (RLAT(I),RLON(I),XVAL,YVAL)
          IF (XVAL.NE.1.E12.AND.YVAL.NE.1.E12) THEN
            CALL ELLIPS (CUFX(XVAL),CUFY(YVAL),.0075,.0075,0.,4.)
          END IF
  103   CONTINUE
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE GTGEO2 (RPNT,MPNT,NPNT,LOPN,
     +                   IEDG,MEDG,NEDG,LOEN,
     +                   ITRI,MTRI,NTRI,LOTN,
     +                   IPPP,IPPE,NDIV,CLAT,CLON)
C
        DIMENSION RPNT(MPNT),IEDG(MEDG),ITRI(MTRI),IPPP(2,*),IPPE(2,*)
C
C Construct a triangular mesh representing a geodesic sphere as an
C exercise to demonstrate its feasibility and to see how the timing
C varies as a function of the resolution of the mesh.  This version
C is of particular interest for two reasons: 1) The way in which
C the faces of the icosahedron are subdivided is based on the prime
C decomposition of NDIV; when NDIV is a power of 2, the resulting
C mesh exactly matches what Ross Heikes uses.  2) It uses a method
C that makes it "easy", if somewhat inefficient, to construct the
C mesh; the method provides routines that take care of looking for
C duplicate points and edges and setting up the pointers defining
C the adjacency of the triangles.
C
C GTGEO2 calls a routine (CTTMTL) that make it easy to create an
C arbitrary triangular mesh.  The "tree-sorts" used by this method
C are very inefficient for objects that are partially ordered, so,
C as the triangles of the mesh are generated, they are stored in a
C triangle buffer from which they can be dumped in random order by
C calls to the routine CTTMTL.
C
C Declare an array in which to get the prime factors of an integer.
C
        DIMENSION IFOI(32)
C
C Declare arrays to hold information describing an icosahedron.
C
        DIMENSION IFCE(3,20),XCVI(12),YCVI(12),ZCVI(12)
C
C Declare arrays in which to put information about triangles resulting
C from elaboration of the icosahedron.  They have dimensions equal to
C the maximum number of triangles, plus one.
C
        PARAMETER (LTRI=112501)
C
        DIMENSION XTRI(3,LTRI),YTRI(3,LTRI),ZTRI(3,LTRI)
C
C Declare an array to use as a buffer for the triangles, so that the
C order in which they are processed can be somewhat randomized.  Up to
C a point, making this buffer larger will result in more randomization
C of the triangles and speed up the process.  MBUF is the number of
C triangles that will fit in the buffer at once, and KBUF is the number
C of those that are dumped whenever the buffer is found to be full; it
C turns out that it's better to dump more than 1 at a time (I suppose
C because the call and loop set-up time for CTTMTL are non-trivial, so
C it's better to dump a few triangles while you're there).  So ... use
C MBUF > KBUF > 1.
C
        PARAMETER (MBUF=  5021,KBUF= 173)
C
        DIMENSION TBUF(12,MBUF)
C
C Define the 20 faces of an icosahedron, using pointers to vertices.
C
        DATA IFCE(1, 1),IFCE(2, 1),IFCE(3, 1) /  1, 3, 5 /
        DATA IFCE(1, 2),IFCE(2, 2),IFCE(3, 2) /  1, 5, 7 /
        DATA IFCE(1, 3),IFCE(2, 3),IFCE(3, 3) /  1, 7, 9 /
        DATA IFCE(1, 4),IFCE(2, 4),IFCE(3, 4) /  1, 9,11 /
        DATA IFCE(1, 5),IFCE(2, 5),IFCE(3, 5) /  1,11, 3 /
        DATA IFCE(1, 6),IFCE(2, 6),IFCE(3, 6) /  3,11, 8 /
        DATA IFCE(1, 7),IFCE(2, 7),IFCE(3, 7) /  3, 8,10 /
        DATA IFCE(1, 8),IFCE(2, 8),IFCE(3, 8) /  3,10, 5 /
        DATA IFCE(1, 9),IFCE(2, 9),IFCE(3, 9) /  5,10,12 /
        DATA IFCE(1,10),IFCE(2,10),IFCE(3,10) /  5,12, 7 /
        DATA IFCE(1,11),IFCE(2,11),IFCE(3,11) /  4, 7,12 /
        DATA IFCE(1,12),IFCE(2,12),IFCE(3,12) /  4, 9, 7 /
        DATA IFCE(1,13),IFCE(2,13),IFCE(3,13) /  4, 6, 9 /
        DATA IFCE(1,14),IFCE(2,14),IFCE(3,14) /  6,11, 9 /
        DATA IFCE(1,15),IFCE(2,15),IFCE(3,15) /  6, 8,11 /
        DATA IFCE(1,16),IFCE(2,16),IFCE(3,16) /  2, 8, 6 /
        DATA IFCE(1,17),IFCE(2,17),IFCE(3,17) /  2, 6, 4 /
        DATA IFCE(1,18),IFCE(2,18),IFCE(3,18) /  2, 4,12 /
        DATA IFCE(1,19),IFCE(2,19),IFCE(3,19) /  2,12,10 /
        DATA IFCE(1,20),IFCE(2,20),IFCE(3,20) /  2,10, 8 /
C
C Define the 12 vertices of the icosahedron (note radius less than one).
C
        DATA XCVI / .0000000000000 ,  .0000000000000 , -.8506508083520 ,
     +              .8506508083520 , -.2628655560596 ,  .2628655560596 ,
     +              .6881909602356 , -.6881909602356 ,  .6881909602356 ,
     +             -.6881909602356 , -.2628655560595 ,  .2628655560596 /
        DATA YCVI / .0000000000000 ,  .0000000000000 ,  .0000000000000 ,
     +              .0000000000000 , -.8090169943749 ,  .8090169943749 ,
     +             -.5000000000000 ,  .5000000000000 ,  .5000000000000 ,
     +             -.5000000000000 ,  .8090169943749 , -.8090169943749 /
        DATA ZCVI / .9510565162952 , -.9510565162951 ,  .4253254041760 ,
     +             -.4253254041760 ,  .4253254041760 , -.4253254041760 ,
     +              .4253254041760 , -.4253254041760 ,  .4253254041760 ,
     +             -.4253254041760 ,  .4253254041760 , -.4253254041760 /
C
C Check array sizes to see if we have enough space.
C
        IF ((10*NDIV*NDIV+2)*LOPN.GT.MPNT) THEN
          PRINT * , ' '
          PRINT * , 'GTGEO2 - STOP - POINT ARRAY TOO SMALL'
          STOP
        END IF
C
        IF (30*NDIV*NDIV*LOEN.GT.MEDG) THEN
          PRINT * , ' '
          PRINT * , 'GTGEO2 - STOP - EDGE ARRAY TOO SMALL'
          STOP
        END IF
C
        IF (20*NDIV*NDIV*LOTN.GT.MTRI) THEN
          PRINT * , ' '
          PRINT * , 'GTGEO2 - STOP - TRIANGLE ARRAY TOO SMALL'
          STOP
        END IF
C
        IF (20*NDIV*NDIV+1.GT.LTRI) THEN
          PRINT * , ' '
          PRINT * , 'GTGEO2 - STOP - LOCAL TRIANGLE ARRAY TOO SMALL'
          STOP
        END IF
C
C Project the vertices of the icosahedron out onto the surface of a
C sphere of radius 1.
C
        DO 101 I=1,12
          DNOM=SQRT(XCVI(I)*XCVI(I)+YCVI(I)*YCVI(I)+ZCVI(I)*ZCVI(I))
          XCVI(I)=XCVI(I)/DNOM
          YCVI(I)=YCVI(I)/DNOM
          ZCVI(I)=ZCVI(I)/DNOM
  101   CONTINUE
C
C Define the twenty initial triangles of the icosahedron, which will be
C subdivided in a series of steps that depend on the prime factors of
C the number NDIV.
C
        KTRI=0
C
        DO 102 I=1,20
          KTRI=KTRI+1
          XTRI(1,KTRI)=XCVI(IFCE(1,I))
          YTRI(1,KTRI)=YCVI(IFCE(1,I))
          ZTRI(1,KTRI)=ZCVI(IFCE(1,I))
          XTRI(2,KTRI)=XCVI(IFCE(2,I))
          YTRI(2,KTRI)=YCVI(IFCE(2,I))
          ZTRI(2,KTRI)=ZCVI(IFCE(2,I))
          XTRI(3,KTRI)=XCVI(IFCE(3,I))
          YTRI(3,KTRI)=YCVI(IFCE(3,I))
          ZTRI(3,KTRI)=ZCVI(IFCE(3,I))
  102   CONTINUE
C
C Get the prime factors of the number NDIV, which says how many segments
C each edge of the icosahedron will be divided into.
C
        CALL FACTOR (NDIV,IFOI,NFOI)
C
C Generate all the triangles in the arrays XTRI, YTRI, and ZTRI.
C
        PRINT * , 'GENERATING TRIANGLES ON ICOSAHEDRON'
C
        DO 106 I=1,NFOI
C
          PRINT '(''   PRIME FACTOR:'',I4)' , IFOI(I)
C
          DO 105 J=1,KTRI
C
            DO 104 K=0,IFOI(I)-1
C
              DO 103 L=0,2*(IFOI(I)-K-1)
C
                KTRI=KTRI+1
C
                IF (MOD(L,2).EQ.0) THEN
C
                  XTRI(1,KTRI)=
     +                     (REAL(IFOI(I)-K-L/2  )/REAL(IFOI(I)-K  ))*
     +                    ((REAL(IFOI(I)-K  )/REAL(IFOI(I)))*XTRI(1,J)+
     +                     (REAL(        K  )/REAL(IFOI(I)))*XTRI(3,J))+
     +                     (REAL(          L/2  )/REAL(IFOI(I)-K  ))*
     +                    ((REAL(IFOI(I)-K  )/REAL(IFOI(I)))*XTRI(2,J)+
     +                     (REAL(        K  )/REAL(IFOI(I)))*XTRI(3,J))
                  YTRI(1,KTRI)=
     +                     (REAL(IFOI(I)-K-L/2  )/REAL(IFOI(I)-K  ))*
     +                    ((REAL(IFOI(I)-K  )/REAL(IFOI(I)))*YTRI(1,J)+
     +                     (REAL(        K  )/REAL(IFOI(I)))*YTRI(3,J))+
     +                     (REAL(          L/2  )/REAL(IFOI(I)-K  ))*
     +                    ((REAL(IFOI(I)-K  )/REAL(IFOI(I)))*YTRI(2,J)+
     +                     (REAL(        K  )/REAL(IFOI(I)))*YTRI(3,J))
                  ZTRI(1,KTRI)=
     +                     (REAL(IFOI(I)-K-L/2  )/REAL(IFOI(I)-K  ))*
     +                    ((REAL(IFOI(I)-K  )/REAL(IFOI(I)))*ZTRI(1,J)+
     +                     (REAL(        K  )/REAL(IFOI(I)))*ZTRI(3,J))+
     +                     (REAL(          L/2  )/REAL(IFOI(I)-K  ))*
     +                    ((REAL(IFOI(I)-K  )/REAL(IFOI(I)))*ZTRI(2,J)+
     +                     (REAL(        K  )/REAL(IFOI(I)))*ZTRI(3,J))
C
                  XTRI(2,KTRI)=
     +                     (REAL(IFOI(I)-K-L/2-1)/REAL(IFOI(I)-K  ))*
     +                    ((REAL(IFOI(I)-K  )/REAL(IFOI(I)))*XTRI(1,J)+
     +                     (REAL(        K  )/REAL(IFOI(I)))*XTRI(3,J))+
     +                     (REAL(          L/2+1)/REAL(IFOI(I)-K  ))*
     +                    ((REAL(IFOI(I)-K  )/REAL(IFOI(I)))*XTRI(2,J)+
     +                     (REAL(        K  )/REAL(IFOI(I)))*XTRI(3,J))
                  YTRI(2,KTRI)=
     +                     (REAL(IFOI(I)-K-L/2-1)/REAL(IFOI(I)-K  ))*
     +                    ((REAL(IFOI(I)-K  )/REAL(IFOI(I)))*YTRI(1,J)+
     +                     (REAL(        K  )/REAL(IFOI(I)))*YTRI(3,J))+
     +                     (REAL(          L/2+1)/REAL(IFOI(I)-K  ))*
     +                    ((REAL(IFOI(I)-K  )/REAL(IFOI(I)))*YTRI(2,J)+
     +                     (REAL(        K  )/REAL(IFOI(I)))*YTRI(3,J))
                  ZTRI(2,KTRI)=
     +                     (REAL(IFOI(I)-K-L/2-1)/REAL(IFOI(I)-K  ))*
     +                    ((REAL(IFOI(I)-K  )/REAL(IFOI(I)))*ZTRI(1,J)+
     +                     (REAL(        K  )/REAL(IFOI(I)))*ZTRI(3,J))+
     +                     (REAL(          L/2+1)/REAL(IFOI(I)-K  ))*
     +                    ((REAL(IFOI(I)-K  )/REAL(IFOI(I)))*ZTRI(2,J)+
     +                     (REAL(        K  )/REAL(IFOI(I)))*ZTRI(3,J))
C
                  IF (IFOI(I)-K-1.NE.0) THEN
C
                    XTRI(3,KTRI)=
     +                     (REAL(IFOI(I)-K-L/2-1)/REAL(IFOI(I)-K-1))*
     +                    ((REAL(IFOI(I)-K-1)/REAL(IFOI(I)))*XTRI(1,J)+
     +                     (REAL(        K+1)/REAL(IFOI(I)))*XTRI(3,J))+
     +                     (REAL(          L/2  )/REAL(IFOI(I)-K-1))*
     +                    ((REAL(IFOI(I)-K-1)/REAL(IFOI(I)))*XTRI(2,J)+
     +                     (REAL(        K+1)/REAL(IFOI(I)))*XTRI(3,J))
                    YTRI(3,KTRI)=
     +                     (REAL(IFOI(I)-K-L/2-1)/REAL(IFOI(I)-K-1))*
     +                    ((REAL(IFOI(I)-K-1)/REAL(IFOI(I)))*YTRI(1,J)+
     +                     (REAL(        K+1)/REAL(IFOI(I)))*YTRI(3,J))+
     +                     (REAL(          L/2  )/REAL(IFOI(I)-K-1))*
     +                    ((REAL(IFOI(I)-K-1)/REAL(IFOI(I)))*YTRI(2,J)+
     +                     (REAL(        K+1)/REAL(IFOI(I)))*YTRI(3,J))
                    ZTRI(3,KTRI)=
     +                     (REAL(IFOI(I)-K-L/2-1)/REAL(IFOI(I)-K-1))*
     +                    ((REAL(IFOI(I)-K-1)/REAL(IFOI(I)))*ZTRI(1,J)+
     +                     (REAL(        K+1)/REAL(IFOI(I)))*ZTRI(3,J))+
     +                     (REAL(          L/2  )/REAL(IFOI(I)-K-1))*
     +                    ((REAL(IFOI(I)-K-1)/REAL(IFOI(I)))*ZTRI(2,J)+
     +                     (REAL(        K+1)/REAL(IFOI(I)))*ZTRI(3,J))
C
                  ELSE
C
                    XTRI(3,KTRI)=XTRI(3,J)
                    YTRI(3,KTRI)=YTRI(3,J)
                    ZTRI(3,KTRI)=ZTRI(3,J)
C
                  END IF
C
                ELSE
C
                  XTRI(2,KTRI)=
     +                     (REAL(IFOI(I)-K-L/2-1)/REAL(IFOI(I)-K-1))*
     +                    ((REAL(IFOI(I)-K-1)/REAL(IFOI(I)))*XTRI(1,J)+
     +                     (REAL(        K+1)/REAL(IFOI(I)))*XTRI(3,J))+
     +                     (REAL(          L/2  )/REAL(IFOI(I)-K-1))*
     +                    ((REAL(IFOI(I)-K-1)/REAL(IFOI(I)))*XTRI(2,J)+
     +                     (REAL(        K+1)/REAL(IFOI(I)))*XTRI(3,J))
                  YTRI(2,KTRI)=
     +                     (REAL(IFOI(I)-K-L/2-1)/REAL(IFOI(I)-K-1))*
     +                    ((REAL(IFOI(I)-K-1)/REAL(IFOI(I)))*YTRI(1,J)+
     +                     (REAL(        K+1)/REAL(IFOI(I)))*YTRI(3,J))+
     +                     (REAL(          L/2  )/REAL(IFOI(I)-K-1))*
     +                    ((REAL(IFOI(I)-K-1)/REAL(IFOI(I)))*YTRI(2,J)+
     +                     (REAL(        K+1)/REAL(IFOI(I)))*YTRI(3,J))
                  ZTRI(2,KTRI)=
     +                     (REAL(IFOI(I)-K-L/2-1)/REAL(IFOI(I)-K-1))*
     +                    ((REAL(IFOI(I)-K-1)/REAL(IFOI(I)))*ZTRI(1,J)+
     +                     (REAL(        K+1)/REAL(IFOI(I)))*ZTRI(3,J))+
     +                     (REAL(          L/2  )/REAL(IFOI(I)-K-1))*
     +                    ((REAL(IFOI(I)-K-1)/REAL(IFOI(I)))*ZTRI(2,J)+
     +                     (REAL(        K+1)/REAL(IFOI(I)))*ZTRI(3,J))
C
                  XTRI(1,KTRI)=
     +                     (REAL(IFOI(I)-K-L/2-2)/REAL(IFOI(I)-K-1))*
     +                    ((REAL(IFOI(I)-K-1)/REAL(IFOI(I)))*XTRI(1,J)+
     +                     (REAL(        K+1)/REAL(IFOI(I)))*XTRI(3,J))+
     +                     (REAL(          L/2+1)/REAL(IFOI(I)-K-1))*
     +                    ((REAL(IFOI(I)-K-1)/REAL(IFOI(I)))*XTRI(2,J)+
     +                     (REAL(        K+1)/REAL(IFOI(I)))*XTRI(3,J))
                  YTRI(1,KTRI)=
     +                     (REAL(IFOI(I)-K-L/2-2)/REAL(IFOI(I)-K-1))*
     +                    ((REAL(IFOI(I)-K-1)/REAL(IFOI(I)))*YTRI(1,J)+
     +                     (REAL(        K+1)/REAL(IFOI(I)))*YTRI(3,J))+
     +                     (REAL(          L/2+1)/REAL(IFOI(I)-K-1))*
     +                    ((REAL(IFOI(I)-K-1)/REAL(IFOI(I)))*YTRI(2,J)+
     +                     (REAL(        K+1)/REAL(IFOI(I)))*YTRI(3,J))
                  ZTRI(1,KTRI)=
     +                     (REAL(IFOI(I)-K-L/2-2)/REAL(IFOI(I)-K-1))*
     +                    ((REAL(IFOI(I)-K-1)/REAL(IFOI(I)))*ZTRI(1,J)+
     +                     (REAL(        K+1)/REAL(IFOI(I)))*ZTRI(3,J))+
     +                     (REAL(          L/2+1)/REAL(IFOI(I)-K-1))*
     +                    ((REAL(IFOI(I)-K-1)/REAL(IFOI(I)))*ZTRI(2,J)+
     +                     (REAL(        K+1)/REAL(IFOI(I)))*ZTRI(3,J))
C
                  XTRI(3,KTRI)=
     +                     (REAL(IFOI(I)-K-L/2-1)/REAL(IFOI(I)-K  ))*
     +                    ((REAL(IFOI(I)-K  )/REAL(IFOI(I)))*XTRI(1,J)+
     +                     (REAL(        K  )/REAL(IFOI(I)))*XTRI(3,J))+
     +                     (REAL(          L/2+1)/REAL(IFOI(I)-K  ))*
     +                    ((REAL(IFOI(I)-K  )/REAL(IFOI(I)))*XTRI(2,J)+
     +                     (REAL(        K  )/REAL(IFOI(I)))*XTRI(3,J))
                  YTRI(3,KTRI)=
     +                     (REAL(IFOI(I)-K-L/2-1)/REAL(IFOI(I)-K  ))*
     +                    ((REAL(IFOI(I)-K  )/REAL(IFOI(I)))*YTRI(1,J)+
     +                     (REAL(        K  )/REAL(IFOI(I)))*YTRI(3,J))+
     +                     (REAL(          L/2+1)/REAL(IFOI(I)-K  ))*
     +                    ((REAL(IFOI(I)-K  )/REAL(IFOI(I)))*YTRI(2,J)+
     +                     (REAL(        K  )/REAL(IFOI(I)))*YTRI(3,J))
                  ZTRI(3,KTRI)=
     +                     (REAL(IFOI(I)-K-L/2-1)/REAL(IFOI(I)-K  ))*
     +                    ((REAL(IFOI(I)-K  )/REAL(IFOI(I)))*ZTRI(1,J)+
     +                     (REAL(        K  )/REAL(IFOI(I)))*ZTRI(3,J))+
     +                     (REAL(          L/2+1)/REAL(IFOI(I)-K  ))*
     +                    ((REAL(IFOI(I)-K  )/REAL(IFOI(I)))*ZTRI(2,J)+
     +                     (REAL(        K  )/REAL(IFOI(I)))*ZTRI(3,J))
C
                END IF
C
                DNOM=SQRT(XTRI(1,KTRI)*XTRI(1,KTRI)+
     +                    YTRI(1,KTRI)*YTRI(1,KTRI)+
     +                    ZTRI(1,KTRI)*ZTRI(1,KTRI))
                XTRI(1,KTRI)=XTRI(1,KTRI)/DNOM
                YTRI(1,KTRI)=YTRI(1,KTRI)/DNOM
                ZTRI(1,KTRI)=ZTRI(1,KTRI)/DNOM
C
                DNOM=SQRT(XTRI(2,KTRI)*XTRI(2,KTRI)+
     +                    YTRI(2,KTRI)*YTRI(2,KTRI)+
     +                    ZTRI(2,KTRI)*ZTRI(2,KTRI))
                XTRI(2,KTRI)=XTRI(2,KTRI)/DNOM
                YTRI(2,KTRI)=YTRI(2,KTRI)/DNOM
                ZTRI(2,KTRI)=ZTRI(2,KTRI)/DNOM
C
                DNOM=SQRT(XTRI(3,KTRI)*XTRI(3,KTRI)+
     +                    YTRI(3,KTRI)*YTRI(3,KTRI)+
     +                    ZTRI(3,KTRI)*ZTRI(3,KTRI))
     +
                XTRI(3,KTRI)=XTRI(3,KTRI)/DNOM
                YTRI(3,KTRI)=YTRI(3,KTRI)/DNOM
                ZTRI(3,KTRI)=ZTRI(3,KTRI)/DNOM
C
  103         CONTINUE
C
  104       CONTINUE
C
            XTRI(1,J)=XTRI(1,KTRI)
            YTRI(1,J)=YTRI(1,KTRI)
            ZTRI(1,J)=ZTRI(1,KTRI)
            XTRI(2,J)=XTRI(2,KTRI)
            YTRI(2,J)=YTRI(2,KTRI)
            ZTRI(2,J)=ZTRI(2,KTRI)
            XTRI(3,J)=XTRI(3,KTRI)
            YTRI(3,J)=YTRI(3,KTRI)
            ZTRI(3,J)=ZTRI(3,KTRI)
            KTRI=KTRI-1
C
  105     CONTINUE
C
  106   CONTINUE
C
C Build structures forming the triangular mesh.  First, initialize the
C variables used to keep track of items in the sort arrays for points
C and edges, in the triangle buffer, and in the triangle list.
C
        MPPP=MPNT/LOPN
        NPPP=0
C
        MPPE=MEDG/LOEN
        NPPE=0
C
        NBUF=0
C
        NTRI=0
C
C Loop through the triangles of the elaborated icosahedron.
C
        DO 107 I=1,KTRI
C
C If the triangle buffer is full, dump a few randomly-chosen triangles
C from it to make room for the new one.
C
          IF (NBUF.EQ.MBUF) THEN
            CALL CTTMTL (KBUF,TBUF,MBUF,NBUF,
     +                   IPPP,MPPP,NPPP,
     +                   IPPE,MPPE,NPPE,
     +                   RPNT,MPNT,NPNT,LOPN,
     +                   IEDG,MEDG,NEDG,LOEN,
     +                   ITRI,MTRI,NTRI,LOTN)
          END IF
C
C Put the new triangle in the triangle buffer.
C
          NBUF=NBUF+1

          TBUF( 1,NBUF)=XTRI(1,I)
          TBUF( 2,NBUF)=YTRI(1,I)
          TBUF( 3,NBUF)=ZTRI(1,I)
          TBUF( 4,NBUF)=0.
C
          TBUF( 5,NBUF)=XTRI(2,I)
          TBUF( 6,NBUF)=YTRI(2,I)
          TBUF( 7,NBUF)=ZTRI(2,I)
          TBUF( 8,NBUF)=0.
C
          TBUF( 9,NBUF)=XTRI(3,I)
          TBUF(10,NBUF)=YTRI(3,I)
          TBUF(11,NBUF)=ZTRI(3,I)
          TBUF(12,NBUF)=0.
C
  107   CONTINUE
C
C Output all triangles remaining in the buffer.
C
        IF (NBUF.NE.0) THEN
          CALL CTTMTL (NBUF,TBUF,MBUF,NBUF,
     +                 IPPP,MPPP,NPPP,
     +                 IPPE,MPPE,NPPE,
     +                 RPNT,MPNT,NPNT,LOPN,
     +                 IEDG,MEDG,NEDG,LOEN,
     +                 ITRI,MTRI,NTRI,LOTN)
        END IF
C
C Set the pointers that tell the caller how many points and edges were
C created.
C
        NPNT=NPPP*LOPN
        NEDG=NPPE*LOEN
C
C Initialize the dummy-data generator and get data values for all the
C points of the mesh.
C
        CALL TDGDIN (-1.,1.,-1.,1.,-1.,1.,21,21)
C
        DO 108 I=0,NPNT-LOPN,LOPN
          RPNT(I+4)=TDGDVA(RPNT(I+1),RPNT(I+2),RPNT(I+3))
  108   CONTINUE
C
C Return the latitude and longitude of the approximate center point of
C the mesh on the globe.
C
        CLAT=0.
        CLON=0.
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE FACTOR (ITBF,IFOI,NFOI)
C
        DIMENSION IFOI(32)
C
C Move the absolute value of the number to be factored to a local
C variable we can modify.
C
        NTBF=ABS(ITBF)
C
C Handle the values 1, 2, and 3 specially.
C
        IF (NTBF.LE.3) GO TO 103
C
C Zero the count of factors found.
C
        NFOI=0
C
C Look for prime factors.
C
        ILIM=INT(SQRT(REAL(NTBF)+.5))
C
        DO 102 I=2,ILIM
  101     IF (MOD(NTBF,I).EQ.0) THEN
            IF (NFOI.LT.32) THEN
              NFOI=NFOI+1
              IFOI(NFOI)=I
            END IF
            NTBF=NTBF/I
            IF (NTBF.EQ.1) RETURN
            GO TO 101
          END IF
  102   CONTINUE
C
C Output the remaining factor.
C
  103   IF (NFOI.LT.32) THEN
          NFOI=NFOI+1
          IFOI(NFOI)=NTBF
        END IF
C
        RETURN
C
      END


      SUBROUTINE DRSGCR (ALAT,ALON,BLAT,BLON)
C
C (DRSGCR = DRaw Shortest Great Circle Route)
C
C This routine draws the shortest great circle route joining two points
C on the globe.  Note that MPTS = INT(180./SIZE) + 1.
C
        PARAMETER (MPTS=181,SIZE=1.)
C
        DIMENSION QLAT(MPTS),QLON(MPTS)
C
        NPTS=MAX(1,MIN(MPTS,INT(ADSGCR(ALAT,ALON,BLAT,BLON)/SIZE)))
C
        CALL MAPGCI (ALAT,ALON,BLAT,BLON,NPTS,QLAT,QLON)
C
        CALL MAPIT (ALAT,ALON,0)
C
        DO 101 I=1,NPTS
          CALL MAPIT (QLAT(I),QLON(I),1)
  101   CONTINUE
C
        CALL MAPIT (BLAT,BLON,2)
C
        CALL MAPIQ
C
        RETURN
C
      END


      FUNCTION ADSGCR (ALAT,ALON,BLAT,BLON)
C
C (ADSGCR = Angle in Degrees along Shortest Great Circle Route)
C
C This function returns the shortest great circle distance, in degrees,
C between two points, A and B, on the surface of the globe.
C
        DATA DTOR / .017453292519943 /
        DATA RTOD / 57.2957795130823 /
C
        XCOA=COS(DTOR*ALAT)*COS(DTOR*ALON)
        YCOA=COS(DTOR*ALAT)*SIN(DTOR*ALON)
        ZCOA=SIN(DTOR*ALAT)
C
        XCOB=COS(DTOR*BLAT)*COS(DTOR*BLON)
        YCOB=COS(DTOR*BLAT)*SIN(DTOR*BLON)
        ZCOB=SIN(DTOR*BLAT)
C
        ADSGCR=2.*RTOD*ASIN(SQRT((XCOA-XCOB)**2+
     +                           (YCOA-YCOB)**2+
     +                           (ZCOA-ZCOB)**2)/2.)
C
        RETURN
C
      END


      SUBROUTINE TDGDIN (XMIN,XMAX,YMIN,YMAX,ZMIN,ZMAX,MLOW,MHGH)
C
C This is a routine to generate test data for three-dimensional graphics
C routines.  The function used is a sum of exponentials.
C
C "MLOW" and "MHGH" are each forced to be greater than or equal to 1 and
C less than or equal to 25.
C
        COMMON /TDGDCO/ XRNG,YRNG,ZRNG,NCNT,CCNT(4,50)
        SAVE   /TDGDCO/
C
        XRNG=XMAX-XMIN
        YRNG=YMAX-YMIN
        ZRNG=ZMAX-ZMIN
C
        NLOW=MAX(1,MIN(25,MLOW))
        NHGH=MAX(1,MIN(25,MHGH))
        NCNT=NLOW+NHGH
C
        DO 101 ICNT=1,NCNT
          CCNT(1,ICNT)=XMIN+XRNG*FRAN()
          CCNT(2,ICNT)=YMIN+YRNG*FRAN()
          CCNT(3,ICNT)=ZMIN+ZRNG*FRAN()
          IF (ICNT.LE.NLOW) THEN
            CCNT(4,ICNT)=-1.
          ELSE
            CCNT(4,ICNT)=+1.
          END IF
  101   CONTINUE
C
        RETURN
C
      END


      FUNCTION TDGDVA (XPOS,YPOS,ZPOS)
C
        COMMON /TDGDCO/ XRNG,YRNG,ZRNG,NCNT,CCNT(4,50)
        SAVE   /TDGDCO/
C
        TDGDVA=0.
C
        DO 101 ICNT=1,NCNT
          TEMP=-50.*(((XPOS-CCNT(1,ICNT))/XRNG)**2+
     +               ((YPOS-CCNT(2,ICNT))/YRNG)**2+
     +               ((ZPOS-CCNT(3,ICNT))/YRNG)**2)
          IF (TEMP.GE.-20.) TDGDVA=TDGDVA+CCNT(4,ICNT)*EXP(TEMP)
  101   CONTINUE
C
C Done.
C
        RETURN
C
      END


      FUNCTION FRAN ()
C
C Pseudo-random-number generator.
C
        DOUBLE PRECISION X
        SAVE X
C
        DATA X / 2.718281828459045D0 /
C
        X=MOD(9821.D0*X+.211327D0,1.D0)
        FRAN=REAL(X)
C
        RETURN
C
      END


      SUBROUTINE ELLIPS (XCFR,YCFR,RADA,RADB,ROTD,DSTP)
C
C This routine fills an ellipse.  The arguments are as follows:
C
C   XCFR and YCFR are the coordinates of the center of the ellipse, in
C   the fractional coordinate system.
C
C   RADA is the length of the semimajor axis of the ellipse (i.e., the
C   distance from the center of the ellipse to one of the two points on
C   the ellipse which are furthest from the center).  This is a distance
C   in the fractional coordinate system.
C
C   RADB is the length of the semiminor axis of the ellipse (i.e., the
C   distance from the center of the ellipse to one of the two points on
C   the ellipse which are nearest to the center).  This is a distance in
C   the fractional coordinate system.
C
C   ROTD is a rotation angle, in degrees.  If ROTD is 0, the major axis
C   of the ellipse is horizontal.  If ROTD is 90, the major axis is
C   vertical.
C
C   DSTP is the step size, in degrees, between any two consecutive
C   points used to draw the ellipse.  The actual value used will be
C   limited to the range from .1 degrees (3600 points used to draw
C   the ellipse) to 90 degrees (4 points used to draw the ellipse).
C
C Declare work arrays to hold the coordinates.
C
        DIMENSION XCRA(3601),YCRA(3601)
C
C DTOR is pi over 180, used to convert an angle from degrees to radians.
C
        DATA DTOR / .017453292519943 /
C
C Get the rotation angle in radians.
C
        ROTR=DTOR*ROTD
C
C Compute the number of steps to be used to draw the ellipse and the
C actual number of degrees for each step.
C
        NSTP=MAX(4,MIN(3600,INT(360./MAX(.1,MIN(90.,DSTP)))))
        RSTP=360./NSTP
C
C Compute coordinates for the ellipse (just some trigonometry).
C
        DO 101 ISTP=0,NSTP
          ANGL=DTOR*REAL(ISTP)*RSTP
          XTMP=RADA*COS(ANGL)
          YTMP=RADB*SIN(ANGL)
          XCRA(ISTP+1)=CFUX(XCFR+XTMP*COS(ROTR)-YTMP*SIN(ROTR))
          YCRA(ISTP+1)=CFUY(YCFR+XTMP*SIN(ROTR)+YTMP*COS(ROTR))
  101   CONTINUE
C
C Fill it.
C
        CALL GFA (NSTP+1,XCRA,YCRA)
C
C Draw it.
C
        CALL GPL (NSTP+1,XCRA,YCRA)
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE CTSCAE (ICRA,ICA1,ICAM,ICAN,XCPF,YCPF,XCQF,YCQF,
     +                                       IND1,IND2,ICAF,IAID)
        DIMENSION ICRA(ICA1,*)
C
C This routine is called by CTCICA when the internal parameter 'CAF' is
C given a negative value.  Each call is intended to create a particular
C element in the user's cell array.  The arguments are as follows:
C
C ICRA is the user's cell array.
C
C ICA1 is the first dimension of the FORTRAN array ICRA.
C
C ICAM and ICAN are the first and second dimensions of the cell array
C stored in ICRA.
C
C (XCPF,YCPF) is the point at that corner of the rectangular area
C into which the cell array maps that corresponds to the cell (1,1).
C The coordinates are given in the fractional coordinate system (unlike
C what is required in a call to GCA, in which the coordinates of the
C point P are in the world coordinate system).
C
C (XCQF,YCQF) is the point at that corner of the rectangular area into
C which the cell array maps that corresponds to the cell (ICAM,ICAN).
C The coordinates are given in the fractional coordinate system (unlike
C what is required in a call to GCA, in which the coordinates of the
C point Q are in the world coordinate system).
C
C IND1 is the 1st index of the cell that is to be updated.
C
C IND2 is the 2nd index of the cell that is to be updated.
C
C ICAF is the current value of the internal parameter 'CAF'.  This
C value will always be an integer which is less than zero (because
C when 'CAF' is zero or greater, this routine is not called).
C
C IAID is the area identifier associated with the cell.  It will have
C been given one of the values from the internal parameter array 'AIA'
C (the one for 'PAI' = -2 if the cell lies in an out-of-range area, the
C one for 'PAI' = -1 if the cell lies off the data grid, or the one for
C some value of 'PAI' between 1 and 'NCL' if the cell lies on the data
C grid).  The value zero may occur if the cell falls in an out-of-range
C area and the value of 'AIA' for 'PAI' = -2 is 0 or if the cell lies
C off the data grid and the value of 'AIA' for 'PAI' = -1 is 0, or if
C the cell falls on the data grid, but no contour level below the cell
C has a non-zero 'AIA' and no contour level above the cell has a
C non-zero 'AIB'.  Note that, if the values of 'AIA' for 'PAI' = -1
C and -2 are given non-zero values, IAID can only be given a zero
C value in one way.
C
C The default behavior of CTSCAE is as follows:  If the area identifier
C is non-negative, it is treated as a color index, to be stored in the
C appropriate cell in the cell array; but if the area identifier is
C negative, a zero is stored for the color index.  The user may supply
C a version of CTSCAE that does something different; it may simply map
C the area identifiers into color indices or it may somehow modify the
C existing cell array element to incorporate the information provided
C by the area identifier.
C
C       ICRA(IND1,IND2)=MAX(0,IAID)
C
C What follows is not the default behavior; instead, it is the behavior
C expected by many of the example programs for CONPACKT.
C
        CALL CTGETI ('NCL - NUMBER OF CONTOUR LEVELS',NOCL)
C
        IF (IAID.GE.1.AND.IAID.LE.NOCL+1) THEN
          ICRA(IND1,IND2)=151+INT(((REAL(IAID)-.5)/REAL(NOCL+1))*100.)
        ELSE IF (IAID.EQ.1001) THEN
          ICRA(IND1,IND2)=2
        ELSE IF (IAID.EQ.1002) THEN
          ICRA(IND1,IND2)=3
        END IF
C
        RETURN
C
      END

c nclfortstart
      SUBROUTINE PALEOOUTLINE (MASK,ZDAT,LAT,LON,NLAT,NLON,JM,IM,
     +                         IWRK,LIWK,NAME,MSKVAL)
C
        INTEGER NLAT,NLON
        INTEGER IM,JM,LIWK
        REAL LAT1,LATN,LON1,LONN
        DOUBLE PRECISION MASK(NLON,NLAT),LAT(NLAT),LON(NLON)
        REAL ZDAT(IM,JM),MSKVAL
        CHARACTER*(*) NAME
        INTEGER IWRK(LIWK)
c nclend
        INTEGER I,J
C
C The object of this routine is to generate the map database files
C required by EZMAP to represent the land/water boundaries defined by
C a given "mask" array.  It does this using a routine called SVBLED
C (which was originally written for Pat Behling) and it makes use of
C this routine in a particular way; certain restrictions on the nature
C of the the input data are assumed.  (It could perhaps be modified to
C ease some of these restrictions, but that has not been done.)
C
C The arguments of PALEOOUTLINE are as follows:
C
C   MASK is an array, dimensioned NLONxNLAT, in which a value equal to
C   MSKVAL represents a land element and a value not equal to MSKVAL
C   represents a water element.
C
C   ZDAT is a scratch array, dimensioned IMxJM.
C
C   LAT is an array of latitudes, dimensioned NLAT, and LON is an array
C   of longitudes, dimensioned NLON.  The value of MASK(I,J) represents
C   the nature of the point on the earth with lat/lon coordinates
C   (LAT(J),LON(I)).  Note, however, that SVBLED assumes that both the
C   latitude values and the longitude values are evenly spaced.  Note
C   also that there should be no points of overlap in the longitudinal
C   direction.
C
C   JM is the second dimension of ZDAT and must be equal to 2*NLAT+1.
C
C   IM is the first dimension of ZDAT and must be equal to 2*NLON+1.
C
C   IWRK is an integer scratch array, dimensioned LIWK.
C
C   LIWK is the size of IWRK; its size depends on both the size and
C   the complexity of the array MASK.
C
C   NAME is of type CHARACTER and is the base name of the files to be
C   created.
C
C   MSKVAL is the value that, when used in the array MASK, represents
C   land.
C
C Each dimension of SVBLED's input array "ZDAT" is required to have
C one more than twice as many elements as the corresponding dimension
C of the original mask array ("MASK").  The elements of MASK are
C embedded in ZDAT, using only even values of its subscripts.
C
        DO 102 I=1,IM
          DO 101 J=1,JM
            ZDAT(I,J)=1.-MSKVAL
  101     CONTINUE
  102   CONTINUE
C
        DO 104 I=1,NLON
          DO 103 J=1,NLAT
            ZDAT(2*I,2*J)=REAL(MASK(I,J))
  103     CONTINUE
  104   CONTINUE
C
C We have to tell SVBLED what the latitude is corresponding to values
C of the second subscript equal to 2 and 2*NLAT.  The latitudes for
C other values of the second subscript will be inferred from these by
C assuming a linear mapping.
C
        IBOT=2
        LAT1=REAL(LAT(1))
C
        ITOP=2*NLAT
        LATN=REAL(LAT(NLAT))
C
C Similarly, we have to tell SVBLED what longitudes correspond to
C values of the first subscript equal to 2 and 2*NLON.  The longitudes
C for other values of the first subscript will be inferred from these
C by assuming a linear mapping.
C
        ILFT=2
        LON1=REAL(LON(1))
C
        IRGT=2*NLON
        LONN=REAL(LON(NLON))
C
C Call SVBLED to finish the job.
C
        CALL SVBLED (ZDAT,IM,JM,IWRK,LIWK,MSKVAL,ILFT,LON1,IRGT,LONN,
     +               IBOT,LAT1,ITOP,LATN,'Land','Water',NAME)
C
C Done.
C
      RETURN
C
      END


      SUBROUTINE SVBLED (ZDAT,IDIM,JDIM,IWRK,LIWK,SVAL,ILFT,XLFT,
     +                   IRGT,XRGT,JBOT,YBOT,JTOP,YTOP,NAML,NAMR,FLNM)
C
C This routine is adapted from the CONPACK routine CPTRES, which traces
C the edge of the special-value area in a contour field.  (The mnemonic
C SVBLED stands for "Special Value Boundary Line to Ezmap Dataset".)
C The boundary of the special-value area is generated in such a way
C that special values are to the left and non-special values are to the
C right.  SVBLED has the following arguments: ZDAT is an array of data,
C dimensioned IDIM by JDIM.  IWRK is an integer scratch array of length
C LIWK.  SVAL is the "special value".  The "special value" area of the
C data array is considered to be the union of all grid boxes having a
C special value at one or more of their corners.  XLFT is the longitude
C associated with a first subscript of ILFT and XRGT the longitude
C associated with a first subscript of IRGT.  YBOT is the latitude
C associated with a second subscript of JBOT and YTOP the latitude
C associated with a second subscript of JTOP.  NAML and NAMR are the
C names of the areas to the left and right, respectively, of the
C boundary lines.  FLNM is the base name of the two files to which the
C EZMAP data are to be written.
C
C Declare argument dimensions and sizes.
C
        DIMENSION ZDAT(IDIM,JDIM),IWRK(LIWK)
C
        CHARACTER*(*) NAML,NAMR,FLNM
C
C Declare local variables used in the tracing algorithm.
C
        DIMENSION INCX(8),JNCY(8)
C
C Declare local file-name variables.
C
        CHARACTER*128 FNM1,FNM2
C
C Declare arrays from which the data are to be written to the line
C data file.
C
        DIMENSION INTS(4),FLTS(204)
C
C Declare an array to use as an output buffer to the name data file.
C
        CHARACTER*1 CHRS(1024)
C
C Define vectors pointing in eight different directions for use in the
C tracing algorithm.
C
        DATA INCX / -1 , -1 ,  0 ,  1 ,  1 ,  1 ,  0 , -1 /
        DATA JNCY /  0 ,  1 ,  1 ,  1 ,  0 , -1 , -1 , -1 /
C
C Form the names of the two files to be written - the line data file
C and the name data file.
C
        LFNM=IOLNBC(FLNM)
C
        FNM1=FLNM(1:LFNM)//'.lines'//CHAR(0)
        FNM2=FLNM(1:LFNM)//'.names'//CHAR(0)
C
C Open the file to which the line data will be written.
C
        CALL NGOFWO (FNM1(1:LFNM+7),IFDE,ISTA)
C
        IF (ISTA.NE.0) THEN
          PRINT * , 'SVBLED - FAILED TO OPEN LINE DATA FILE'
          STOP
        END IF
C
        INTS(1)=0
        INTS(2)=1
        INTS(3)=1
        INTS(4)=2
C
        NHSS=0
C
        DO 107 I=1,IDIM-1
          DO 106 J=1,JDIM-1
            IF (J.EQ.1) THEN
              IF (ZDAT(I  ,1  ).EQ.SVAL.OR.
     +            ZDAT(I+1,1  ).EQ.SVAL.OR.
     +            ZDAT(I  ,2  ).EQ.SVAL.OR.
     +            ZDAT(I+1,2  ).EQ.SVAL) GO TO 101
            ELSE
              IF (ZDAT(I  ,J-1).NE.SVAL.AND.
     +            ZDAT(I+1,J-1).NE.SVAL.AND.
     +            ZDAT(I  ,J  ).NE.SVAL.AND.
     +            ZDAT(I+1,J  ).NE.SVAL.AND.
     +           (ZDAT(I  ,J+1).EQ.SVAL.OR.
     +            ZDAT(I+1,J+1).EQ.SVAL)) GO TO 101
            END IF
            GO TO 106
  101       IPXY=JDIM*I+J
            DO 102 K=1,NHSS
              IF (IPXY.EQ.IWRK(K)) GO TO 106
  102       CONTINUE
            IF (NHSS.GE.LIWK) THEN
              PRINT * , 'SVBLED - INTEGER WORKSPACE OVERFLOW'
              STOP
            END IF
            NHSS=NHSS+1
            IWRK(NHSS)=IPXY
            INTS(1)=0
            XCES=XLFT+(REAL(I-ILFT)/REAL(IRGT-ILFT))*(XRGT-XLFT)
            YCES=YBOT+(REAL(J-JBOT)/REAL(JTOP-JBOT))*(YTOP-YBOT)
            INSX=I
            JNSY=J
            INOX=I
            JNOY=J
            INDX=I+1
            JNDY=J
            IDIR=5
  103       XCSS=XCES
            YCSS=YCES
            XCES=XLFT+(REAL(INDX-ILFT)/REAL(IRGT-ILFT))*(XRGT-XLFT)
            YCES=YBOT+(REAL(JNDY-JBOT)/REAL(JTOP-JBOT))*(YTOP-YBOT)
            IDRW=1
            IF (INDX.EQ.INOX) THEN
              IF ((REAL(IDIM-1)/REAL(IRGT-ILFT))*(XRGT-XLFT).GT.359.99)
     +                                                              THEN
                IF (INDX.EQ.1) THEN
                  IF (ZDAT(IDIM  ,JNDY).EQ.SVAL.OR.
     +                ZDAT(IDIM-1,JNDY).EQ.SVAL.OR.
     +                ZDAT(IDIM  ,JNOY).EQ.SVAL.OR.
     +                ZDAT(IDIM-1,JNOY).EQ.SVAL) IDRW=0
                ELSE IF (INDX.EQ.IDIM) THEN
                  IF (ZDAT(1,JNDY).EQ.SVAL.OR.
     +                ZDAT(2,JNDY).EQ.SVAL.OR.
     +                ZDAT(1,JNOY).EQ.SVAL.OR.
     +                ZDAT(2,JNOY).EQ.SVAL) IDRW=0
                END IF
              END IF
            ELSE IF (JNDY.EQ.JNOY.AND.ABS(ABS(YCES)-90.).LT..01) THEN
              IDRW=0
            END IF
            IF (IDRW.EQ.0) THEN
              IF (INTS(1).NE.0) THEN
                CALL WTEMLR (IFDE,INTS,FLTS)
                INTS(1)=0
              END IF
            ELSE
              IF (INTS(1).EQ.0) THEN
                INTS(1)=2
                FLTS(5)=YCSS
                FLTS(6)=XCSS
              END IF
              IF (INTS(1).EQ.200) CALL WTEMLR (IFDE,INTS,FLTS)
              INTS(1)=INTS(1)+2
              FLTS(3+INTS(1))=YCES
              FLTS(4+INTS(1))=XCES
            END IF
            IF (INDX.EQ.INSX.AND.JNDY.EQ.JNSY) THEN
              IF (INTS(1).NE.0) THEN
                CALL WTEMLR (IFDE,INTS,FLTS)
                INTS(1)=0
              END IF
              GO TO 106
            END IF
            INOX=INDX
            JNOY=JNDY
            IDIR=MOD(IDIR+1,8)+1
            DO 104 K=1,3
              IF (IDIR.EQ.5) THEN
                IF (INOX.NE.IDIM.AND.JNOY.NE.JDIM) THEN
                  IF (JNOY.EQ.1) THEN
                    IF (ZDAT(INOX  ,JNOY  ).EQ.SVAL.OR.
     +                  ZDAT(INOX+1,JNOY  ).EQ.SVAL.OR.
     +                  ZDAT(INOX  ,JNOY+1).EQ.SVAL.OR.
     +                  ZDAT(INOX+1,JNOY+1).EQ.SVAL) GO TO 105
                  ELSE
                    IF (ZDAT(INOX  ,JNOY-1).NE.SVAL.AND.
     +                  ZDAT(INOX+1,JNOY-1).NE.SVAL.AND.
     +                  ZDAT(INOX  ,JNOY  ).NE.SVAL.AND.
     +                  ZDAT(INOX+1,JNOY  ).NE.SVAL.AND.
     +                 (ZDAT(INOX  ,JNOY+1).EQ.SVAL.OR.
     +                  ZDAT(INOX+1,JNOY+1).EQ.SVAL)) GO TO 105
                  END IF
                END IF
              ELSE IF (IDIR.EQ.3) THEN
                IF (INOX.NE.1.AND.JNOY.NE.JDIM) THEN
                  IF (INOX.EQ.IDIM) THEN
                    IF (ZDAT(INOX  ,JNOY  ).EQ.SVAL.OR.
     +                  ZDAT(INOX  ,JNOY+1).EQ.SVAL.OR.
     +                  ZDAT(INOX-1,JNOY  ).EQ.SVAL.OR.
     +                  ZDAT(INOX-1,JNOY+1).EQ.SVAL) GO TO 105
                  ELSE
                    IF (ZDAT(INOX+1,JNOY  ).NE.SVAL.AND.
     +                  ZDAT(INOX+1,JNOY+1).NE.SVAL.AND.
     +                  ZDAT(INOX  ,JNOY  ).NE.SVAL.AND.
     +                  ZDAT(INOX  ,JNOY+1).NE.SVAL.AND.
     +                 (ZDAT(INOX-1,JNOY  ).EQ.SVAL.OR.
     +                  ZDAT(INOX-1,JNOY+1).EQ.SVAL)) GO TO 105
                  END IF
                END IF
              ELSE IF (IDIR.EQ.1) THEN
                IF (INOX.NE.1.AND.JNOY.NE.1) THEN
                  IF (JNOY.EQ.JDIM) THEN
                    IF (ZDAT(INOX  ,JNOY  ).EQ.SVAL.OR.
     +                  ZDAT(INOX-1,JNOY  ).EQ.SVAL.OR.
     +                  ZDAT(INOX  ,JNOY-1).EQ.SVAL.OR.
     +                  ZDAT(INOX-1,JNOY-1).EQ.SVAL) GO TO 105
                  ELSE
                    IF (ZDAT(INOX  ,JNOY+1).NE.SVAL.AND.
     +                  ZDAT(INOX-1,JNOY+1).NE.SVAL.AND.
     +                  ZDAT(INOX  ,JNOY  ).NE.SVAL.AND.
     +                  ZDAT(INOX-1,JNOY  ).NE.SVAL.AND.
     +                 (ZDAT(INOX  ,JNOY-1).EQ.SVAL.OR.
     +                  ZDAT(INOX-1,JNOY-1).EQ.SVAL)) GO TO 105
                  END IF
                END IF
              ELSE
                IF (INOX.NE.IDIM.AND.JNOY.NE.1) THEN
                  IF (INOX.EQ.1) THEN
                    IF (ZDAT(INOX  ,JNOY  ).EQ.SVAL.OR.
     +                  ZDAT(INOX  ,JNOY-1).EQ.SVAL.OR.
     +                  ZDAT(INOX+1,JNOY  ).EQ.SVAL.OR.
     +                  ZDAT(INOX+1,JNOY-1).EQ.SVAL) GO TO 105
                  ELSE
                    IF (ZDAT(INOX-1,JNOY  ).NE.SVAL.AND.
     +                  ZDAT(INOX-1,JNOY-1).NE.SVAL.AND.
     +                  ZDAT(INOX  ,JNOY  ).NE.SVAL.AND.
     +                  ZDAT(INOX  ,JNOY-1).NE.SVAL.AND.
     +                 (ZDAT(INOX+1,JNOY  ).EQ.SVAL.OR.
     +                  ZDAT(INOX+1,JNOY-1).EQ.SVAL)) GO TO 105
                  END IF
                END IF
              END IF
              IDIR=MOD(IDIR+5,8)+1
  104       CONTINUE
            PRINT * , 'SVBLED - EDGE-FOLLOWING ALGORITHM FAILURE'
            STOP
  105       INDX=INOX+INCX(IDIR)
            JNDY=JNOY+JNCY(IDIR)
            IF (IDIR.EQ.5) THEN
              IF (NHSS.GE.LIWK) THEN
                PRINT * , 'SVBLED - INTEGER WORKSPACE OVERFLOW'
                STOP
              END IF
              NHSS=NHSS+1
              IWRK(NHSS)=JDIM*INOX+JNOY
            END IF
            GO TO 103
  106     CONTINUE
  107   CONTINUE
C
C Write a final logical record to the line data file.
C
        INTS(1)=0
        INTS(2)=0
        INTS(3)=0
        INTS(4)=0
C
        CALL WTEMLR (IFDE,INTS,FLTS)
C
C Close the line data file.
C
        CALL NGCLFI (IFDE)
C
C Open the name data file, write the required items to it, and close it.
C
        CALL NGOFWO (FNM2(1:LFNM+7),IFDE,ISTA)
C
        IF (ISTA.NE.0) THEN
          PRINT * , 'SVBLED - FAILED TO OPEN NAME DATA FILE'
          STOP
        END IF
C
        NCHR=0
C
        CALL WRCHAR (IFDE,CHRS,1024,NCHR, ' ')
        CALL WRNUMB (IFDE,CHRS,1024,NCHR,   1)  !  index of 1st area
        CALL WRCHAR (IFDE,CHRS,1024,NCHR, ' ')
        CALL WRNUMB (IFDE,CHRS,1024,NCHR,   1)  !  type of 1st area
        CALL WRCHAR (IFDE,CHRS,1024,NCHR, ' ')
        CALL WRNUMB (IFDE,CHRS,1024,NCHR,   2)  !  color of 1st area
        CALL WRCHAR (IFDE,CHRS,1024,NCHR, ' ')
        CALL WRNUMB (IFDE,CHRS,1024,NCHR,   0)  !  parent of 1st area
        CALL WRCHAR (IFDE,CHRS,1024,NCHR, ' ')
        IBEG=IOFNBC(NAML)
        IEND=IOLNBC(NAML)
        CALL WRNUMB (IFDE,CHRS,1024,NCHR,IEND-IBEG+1)  !  name length
        CALL WRCHAR (IFDE,CHRS,1024,NCHR,        ' ')
        DO 108 I=IBEG,IEND
          CALL WRCHAR (IFDE,CHRS,1024,NCHR,NAML(I:I))  !  name of area
  108   CONTINUE
        CALL WRCHAR (IFDE,CHRS,1024,NCHR, ' ')
        CALL WRNUMB (IFDE,CHRS,1024,NCHR,   2)  !  index of 2nd area
        CALL WRCHAR (IFDE,CHRS,1024,NCHR, ' ')
        CALL WRNUMB (IFDE,CHRS,1024,NCHR,   1)  !  type of 2nd area
        CALL WRCHAR (IFDE,CHRS,1024,NCHR, ' ')
        CALL WRNUMB (IFDE,CHRS,1024,NCHR,   1)  !  color of 2nd area
        CALL WRCHAR (IFDE,CHRS,1024,NCHR, ' ')
        CALL WRNUMB (IFDE,CHRS,1024,NCHR,   0)  !  parent of 2nd area
        CALL WRCHAR (IFDE,CHRS,1024,NCHR, ' ')
        IBEG=IOFNBC(NAMR)
        IEND=IOLNBC(NAMR)
        CALL WRNUMB (IFDE,CHRS,1024,NCHR,IEND-IBEG+1)  !  name length
        CALL WRCHAR (IFDE,CHRS,1024,NCHR,        ' ')
        DO 109 I=IBEG,IEND
          CALL WRCHAR (IFDE,CHRS,1024,NCHR,NAMR(I:I))  !  name of area
  109   CONTINUE
C
        IF (NCHR.GT.0) THEN
          CALL NGWRCH (IFDE,CHRS,NCHR,ISTA)
          IF (ISTA.LE.0) THEN
            PRINT * , 'SVBLED - ERROR WRITING CHARS TO NAME DATA FILE'
            STOP
          END IF
        END IF
C
        CALL NGCLFI (IFDE)
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE WTEMLR (IFDE,INTS,FLTS)
C
C Write a logical record to the EZMAP line data file.
C
        DIMENSION INTS(4),FLTS(204)
C
        CALL NGWRIN (IFDE,INTS,4,ISTA)
C
        IF (ISTA.NE.4) THEN
          PRINT * , 'WTEMLR - ERROR WRITING INTEGERS TO LINE DATA FILE'
          STOP
        END IF
C
        IF (INTS(1).NE.0) THEN
C
          FLTS(1)=FLTS(5)
          FLTS(2)=FLTS(5)
          FLTS(3)=FLTS(6)
          FLTS(4)=FLTS(6)
C
          DO 101 I=7,3+INTS(1),2
            FLTS(1)=MAX(FLTS(1),FLTS(I  ))
            FLTS(2)=MIN(FLTS(2),FLTS(I  ))
            FLTS(3)=MAX(FLTS(3),FLTS(I+1))
            FLTS(4)=MIN(FLTS(4),FLTS(I+1))
  101     CONTINUE
C
          CALL NGWRFL (IFDE,FLTS,4+INTS(1),ISTA)
C
          IF (ISTA.NE.4+INTS(1)) THEN
            PRINT * , 'WTEMLR - ERROR WRITING REALS TO LINE DATA FILE'
            STOP
          END IF
C
          FLTS(5)=FLTS(3+INTS(1))
          FLTS(6)=FLTS(4+INTS(1))
C
          INTS(1)=2
C
        END IF
C
        RETURN
C
      END


      SUBROUTINE WRNUMB (IFDE,CHRS,MCHR,NCHR,INUM)
C
        CHARACTER*1 CHRS(MCHR)
C
C Translate the integer INUM to a character form and put it in the
C buffer CHRS.
C
        CHARACTER*1 CTMP(20)
C
C Copy the integer to a local variable.
C
        ITMP=INUM
C
C Generate digits from right to left in the temporary buffer CTMP.
C
        NDGT=0
C
  101   NDGT=NDGT+1
C
        IF (NDGT.GT.20) THEN
          PRINT * , 'WRNUMB - INTEGER TOO BIG - STOP'
          STOP
        END IF
C
        CTMP(NDGT)=CHAR(ICHAR('0')+MOD(ITMP,10))
C
        ITMP=ITMP/10
        IF (ITMP.NE.0) GO TO 101
C
C Send the digits to the output buffer in correct order.
C
        DO 102 IDGT=NDGT,1,-1
          CALL WRCHAR (IFDE,CHRS,MCHR,NCHR,CTMP(IDGT))
  102   CONTINUE
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE WRCHAR (IFDE,CHRS,MCHR,NCHR,ICHR)
C
        CHARACTER*1 CHRS(MCHR),ICHR
C
C Put the character ICHR in the buffer CHRS.
C
        NCHR=NCHR+1
        CHRS(NCHR)=ICHR
C
C If the buffer is now full, dump it to the file specified by IFDE.
C
        IF (NCHR.GE.MCHR) THEN
          CALL NGWRCH (IFDE,CHRS,NCHR,ISTA)
          IF (ISTA.LE.0) THEN
            PRINT * , 'WRCHAR - BAD STATUS FROM NGWRCH = ',ISTA
            STOP
          END IF
          NCHR=0
        END IF
C
C Done.
C
        RETURN
C
      END


      INTEGER FUNCTION IOFNBC (CHRS)
C
        CHARACTER*(*) CHRS
C
C The value of IOFNBC(CHRS) is the index of the first non-blank in the
C character string CHRS.
C
        DO 101 I=1,LEN(CHRS)
          IF (CHRS(I:I).NE.' ') THEN
            IOFNBC=I
            RETURN
          END IF
  101   CONTINUE
C
        IOFNBC=1
C
        RETURN
C
      END


      INTEGER FUNCTION IOLNBC (CHRS)
C
        CHARACTER*(*) CHRS
C
C The value of IOLNBC(CHRS) is the index of the last non-blank in the
C character string CHRS.
C
        DO 101 I=LEN(CHRS),1,-1
          IF (CHRS(I:I).NE.' ') THEN
            IOLNBC=I
            RETURN
          END IF
  101   CONTINUE
C
        IOLNBC=1
C
        RETURN
C
      END

C     
C     $Id: mp07f.f,v 1.4 2010-03-15 22:49:24 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C                Copyright (C)  2002                                   C
C        University Corporation for Atmospheric Research               C
C                All Rights Reserved                                   C
C                                                                      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C
C      File:            mp07f.f
C
C      Author:          Mary Haley
C                       National Center for Atmospheric Research
C                       PO 3000, Boulder, Colorado
C
C      Date:            Mon Mar  4 14:08:54 MST 2002
C
C   Description: Shows how to draw high-resolution coastlines using the
C   RANGS (Regionally Accessible Nested Global Shorelines), developed
C   by Rainer Feistel from Wessel and Smith's GSHHS (Global
C   Self-consistent Hierarchical High-resolution Shoreline) database.
C   To access the RANGS/GSHHS database, you must first download it from
C   Rainer Feistel's web site at
C   http://www.io-warnemuende.de/homepages/rfeistel/index.html.  Right
C   before the section entitled "Some WWW Links", you should see a
C   little table with ten *.zip files to download:
C
C     rangs(0).zip         gshhs(0).zip
C     rangs(1).zip         gshhs(1).zip
C     rangs(2).zip         gshhs(2).zip
C     rangs(3).zip         gshhs(3).zip
C     rangs(4).zip         gshhs(4).zip
C
C   You must download all ten of these files, unzip them, and either
C   put them in the default directory
C   "$NCARG_ROOT/lib/ncarg/database/rangs", or put them somewhere else
C   and set the environment variable NCARG_RANGS to this directory. The
C   files take up about 140 megabytes, unzipped. Once you have the
C   files in the appropriate location, then set the mpDataBaseVersion
C   resource to "RANGS_GSHHS" to create maps using this database. You
C   should not use this database to plot maximal area plots, because 1)
C   you will get horizontal lines through your plot, and 2) it takes a
C   long time.
C
      external NhlFAppClass
      external NhlFCairoWindowWorkstationClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFMapPlotClass

      integer appid,wks,mapid
      integer rlist
      character*7  wks_type
C
C Default is to display output to an X workstation
C
      wks_type = "x11"
C
C Initialize the high level utility library
C
      call NhlFInitialize
C
C Create an application object.
C
      call NhlFRLCreate(rlist,'SETRL')
      call NhlFRLClear(rlist)
      call NhlFRLSetstring(rlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'mp07',NhlFAppClass,0,rlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkMetaName','./mp07f.ncgm',ierr)
         call NhlFCreate(wks,'mp07Work',NhlFNcgmWorkstationClass,0,
     1        rlist,ierr)
      else  if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X workstation
C
         call NhlFRLClear(rlist)
         call NhlFCreate(wks,'mp07Work',
     1     NhlFCairoWindowWorkstationClass,0,
     1     rlist,ierr)
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PostScript workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPSFileName','./mp07f.ps',ierr)
         call NhlFCreate(wks,'mp07Work',NhlFPSWorkstationClass,0,
     1        rlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPDFFileName','./mp07f.pdf',ierr)
         call NhlFCreate(wks,'mp07Work',NhlFPDFWorkstationClass,0,
     1        rlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF object.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetstring(rlist,'wkFileName','./mp07f',ierr)
         call NhlFCreate(wks,'mp07Work',
     1        NhlFCairoPSPDFWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG object.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetstring(rlist,'wkFileName','./mp07f',ierr)
         call NhlFCreate(wks,'mp07Work',
     1        NhlFCairoImageWorkstationClass,0,rlist,ierr)
      endif

C
C Create and draw a map with the default databse.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetFloat(rlist,'vpWidthF',  0.80,ierr)
      call NhlFRLSetFloat(rlist,'vpHeightF', 0.80,ierr)
      call NhlFRLSetFloat(rlist,'vpXF',      0.15,ierr)
      call NhlFRLSetFloat(rlist,'vpYF',      0.90,ierr)
      call NhlFRLSetString(rlist,'mpProjection', 
     1     'CylindricalEquidistant',ierr)
C
C "LowRes" is the default database, also sometimes known as "Ncarg4_0".
C
      call NhlFRLSetString(rlist,'mpDataBaseVersion', 
     1     'LowRes',ierr)
C 
C Zoom in on part of the map.
C
      call NhlFRLSetString(rlist,'mpLimitMode','LatLon',ierr)
      call NhlFRLSetFloat(rlist,'mpMinLatF',   30.,ierr)
      call NhlFRLSetFloat(rlist,'mpMaxLatF',   60.,ierr)
      call NhlFRLSetFloat(rlist,'mpMinLonF',  -15.,ierr)
      call NhlFRLSetFloat(rlist,'mpMaxLonF',   15. ,ierr)
C
C Turn on the labeling of lat/lon lines.
C
      call NhlFRLSetString(rlist,'pmTickMarkDisplayMode', 
     1     'Always',ierr)
      call NhlFCreate(mapid,'mp07',NhlFMapPlotClass,wks,rlist,ierr)
C
C Draw map and advance the frame.
C
      call NhlFDraw(mapid,ierr)
      call NhlFFrame(wks,ierr)
C
C Set the resource indicating you want to use the high-resolution
C RANGS/GSHHS database.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'mpDataBaseVersion','RANGS_GSHHS',
     1     ierr)
      call NhlFSetValues(mapid,rlist,ierr)
C
C Draw map and advance the frame.
C
      call NhlFDraw(mapid,ierr)
      call NhlFFrame(wks,ierr)

      call NhlFDestroy(wks,ierr)
      call NhlFClose
      stop
      end

C NCLFORTSTART
      SUBROUTINE DRELHUMW(P,TK,QW, RH)
      IMPLICIT NONE
C NCL: qw = relhum_water(p:numeric,tk:numeric,qw:numeric)

C  Calculate rel hum with respect to water
C  Same constants as mixhum_ptrh  reversible calculation

c input
      DOUBLE PRECISION P,TK,QW
c output
      DOUBLE PRECISION RH
c NCLEND

c computes rh (relative humidity) from p, t and qw (mixing ratio)

c definition of mixing ratio
c if,
c    es  - is the saturation mixing ratio
c    ep  - is the ratio of the molecular weights of water vapor to
c          dry air
c    p   - is the atmospheric pressure
c    rh  - is the relative humidity (given as a percent)

c    rh =  100*  q / ( (ep*es)/(p-es) )

c input-
c    p      - pressure (Pa) (this function was originally written for 
c             hPa/mb, so we have to do conversion below)
c    tk     - temperature (k)
c    qw     - mixing ratio (kg/kg)

c output-
c    rh     - relative humidity as %

c local
      DOUBLE PRECISION T0,EP,ONEMEP,ES0,A,B,EST,QST
      DATA T0,EP,ONEMEP,ES0,A,B/273.15D0,0.622D0,0.378D0,6.11D0,
     +     17.269D0,35.86D0/

      EST = ES0*EXP((A* (TK-T0))/ (TK-B))
      QST = (EP*EST)/ ((P*0.01D0)-ONEMEP*EST)
c                                    mix ratio
      RH =  100* (QW / QST)

      RETURN
      END

C
C	$Id: gurec.f,v 1.5 2008-07-27 00:21:03 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GUREC(LDR,DATREC,IIL,IRL,ISL,ERRIND,
     +                 IL,IA,RL,RA,SL,LSTR,STR)
C
C  UNPACK DATA RECORD
C
      INTEGER EUREC
      PARAMETER (EUREC=108)
      DIMENSION IA(*),RA(*),LSTR(*)
      INTEGER RL,SL,ERRIND
      CHARACTER*80 DATREC(LDR)
      CHARACTER*(*) STR(*)
      DATA NCE/1/
C
C  This subroutine unpacks the data records that were packed using
C  the subroutine GPREC.
C
C  Read in  IL,RL,SL,NTL,NIL,NRL,NSL,MAXSL:
C
C  IL    -- Number of integers to be read
C  RL    -- Number of reals to be read
C  SL    -- Number of distinct character variables to be read
C  NTL   -- Number of data records used to store LSTR
C  NIL   -- Number of data records used to store the integers
C  NRL   -- Number of data records used to store the reals
C  NSL   -- Number of data records used to store the character 
C           variables
C  MAXSL -- Maximum character length of any of the character
C           variables
C
      READ (DATREC(1),501) IL,RL,SL,NTL,NIL,NRL,NSL,MAXSL
C
C  Do parameter checking
C
      ILDR = NTL+NIL+NRL+NSL+1
      IF (IIL.LT.IL .OR. IRL.LT.RL .OR. 
     +    ISL.LT.SL .OR. LDR.LT.ILDR) THEN
        ERRIND = 2001
        RETURN
      ENDIF
C
C  Read the LSTR array if there are any characters
C
      NPER = 8
      IF (SL .GT. 0) THEN
        INDX1 = SL/NPER
        INDX2 = MOD(SL,NPER)
        IF (INDX1 .EQ. 0) THEN
          READ (DATREC(2),501) (LSTR(LL),LL=1,SL)
        ELSE
          DO 200 I=1,INDX1
            IPNT1 = NPER*(I-1)+1
            IPNT2 = NPER*I
            READ (DATREC(I+1),501) (LSTR(LL),LL=IPNT1,IPNT2)
  200     CONTINUE
          IF (INDX2 .NE. 0) THEN
            NPNT1 = NPER*INDX1+1
            NPNT2 = NPER*INDX1+INDX2
            READ (DATREC(INDX1+2),501) (LSTR(LL),LL=NPNT1,NPNT2)
          ENDIF
        ENDIF
      ENDIF
C
C  Read the integer array
C
      NPER = 4
      IF (IL .GT. 0) THEN
        INDX1 = IL/NPER
        INDX2 = MOD(IL,NPER)
        IF (INDX1 .EQ. 0) THEN
          READ (DATREC(NTL+2),502) (IA(LL),LL=1,IL)
        ELSE
          DO 201 I=1,INDX1
            IPNT1 = NPER*(I-1)+1
            IPNT2 = NPER*I
            READ (DATREC(NTL+I+1),502) (IA(LL),LL=IPNT1,IPNT2)
  201     CONTINUE
          IF (INDX2 .NE. 0) THEN
            NPNT1 = NPER*INDX1+1
            NPNT2 = NPER*INDX1+INDX2
            READ (DATREC(NTL+INDX1+2),502) (IA(LL),LL=NPNT1,NPNT2)
          ENDIF
        ENDIF
      ENDIF
C
C  Read the real array.
C
      NPER = 4
      IF (RL .GT. 0) THEN
        INDX1 = RL/NPER
        INDX2 = MOD(RL,NPER)
        IF (INDX1 .EQ. 0) THEN
          READ (DATREC(NTL+NIL+2),503) (RA(LL),LL=1,RL)
        ELSE
          DO 202 I=1,INDX1
            IPNT1 = NPER*(I-1)+1
            IPNT2 = NPER*I
            READ (DATREC(NTL+NIL+I+1),503) (RA(LL),LL=IPNT1,IPNT2)
  202     CONTINUE
          IF (INDX2 .NE. 0) THEN
            NPNT1 = NPER*INDX1+1
            NPNT2 = NPER*INDX1+INDX2
            READ (DATREC(NTL+NIL+INDX1+2),503) (RA(LL),LL=NPNT1,NPNT2)
          ENDIF
        ENDIF
      ENDIF
C
C  Read the character arrays
C
      IF (MAXSL .NE. 0) THEN
        NCE = 80/MAXSL
        IF (NCE.LE.1) THEN
          NCE = 1
        ENDIF
      ENDIF
      NPER = NCE
      IF (SL .GT. 0) THEN
        IF (NPER .GT. 1) THEN
          INDX1 = SL/NPER
          INDX2 = MOD(SL,NPER)
          IF (INDX1 .EQ. 0) THEN
            DO 203 I=1,SL
              IPNT1 = (I-1)*MAXSL+1
              IPNT2 = IPNT1+LSTR(I)-1
              STR(I)(1:LSTR(I)) = DATREC(NTL+NIL+NRL+2)(IPNT1:IPNT2)
  203       CONTINUE
          ELSE
            DO 204 I=1,INDX1
              DO 205 J=1,NCE
                JPNT1 = (J-1)*MAXSL+1
                NDX = NPER*(I-1)+J
                JPNT2 = JPNT1+LSTR(NDX)-1
                STR(NDX) (1:LSTR(NDX)) = 
     ~                 DATREC(NTL+NIL+NRL+I+1)(JPNT1:JPNT2)
  205         CONTINUE
  204       CONTINUE
            IF (INDX2 .NE. 0) THEN
              DO 206 J=1,INDX2
                JPNT1 = (J-1)*MAXSL+1
                NDX = NPER*INDX1+J
                JPNT2 = JPNT1+LSTR(NDX)-1
                STR(NDX) (1:LSTR(NDX)) = 
     +                  DATREC(NTL+NIL+NRL+INDX1+2)(JPNT1:JPNT2)
  206         CONTINUE
            ENDIF
          ENDIF
        ELSE
          JNDX = 0
          DO 207 I=1,SL
            INDX1 = LSTR(I)/80
            INDX2 = MOD(LSTR(I),80)
            IF (INDX1 .EQ. 0) THEN
              JNDX = JNDX+1
              STR(I)(1:INDX2) = DATREC(NTL+NIL+NRL+JNDX+1)
            ELSE
              DO 208 J=1,INDX1
                JNDX = JNDX+1
                STR(I) (80*(J-1)+1:80*J) = DATREC(NTL+NIL+NRL+JNDX+1)
  208         CONTINUE
              IF (INDX2 .NE. 0) THEN
                JNDX = JNDX+1
                STR(I) (80*INDX1+1:80*INDX1+INDX2) =
     +                 DATREC(NTL+NIL+NRL+JNDX+1) (1:INDX2)
              ENDIF
            ENDIF
  207     CONTINUE
        ENDIF
      ENDIF
C
  501 FORMAT(8I10)
  502 FORMAT(4I20)
  503 FORMAT(4E20.13)
C
      RETURN
      END

C
C $Id: pj21dp.f,v 1.5 2008-07-27 00:17:11 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE PJ21DP (COORD,CRDIO,INDIC)
C
C -- R O B I N S O N
C
      IMPLICIT DOUBLE PRECISION (A-Z)
      INTEGER IP1,NN
      INTEGER INDIC
      DIMENSION GEOG(2),PROJ(2),COORD(2),CRDIO(2),
     . PR(20),XLR(20)
C **** PARAMETERS **** A,LON0,X0,Y0 ************************************
      COMMON /ERRMZ0/ IERR
        INTEGER IERR
      SAVE   /ERRMZ0/
      COMMON /PRINZ0/ IPEMSG,IPELUN,IPPARM,IPPLUN
        INTEGER IPEMSG,IPELUN,IPPARM,IPPLUN
      SAVE   /PRINZ0/
      COMMON /PC21DP/ A,LON0,X0,Y0,PR,XLR
      DATA DG1 /0.01745329252D0/
      DATA PI /3.14159265358979323846D0/
      DATA EPSLN /1.0D-10/
C
C -- F O R W A R D   . . .
C
      IF (INDIC .EQ. 0) THEN
C
         GEOG(1) = COORD(1)
         GEOG(2) = COORD(2)
         IERR = 0
         LON = ADJLDP (GEOG(1) - LON0)
         P2=ABS(GEOG(2)/5.0D0/DG1)
         IP1=INT(P2-EPSLN)
C
C        STIRLING'S INTERPOLATION FORMULA (USING 2ND DIFF.)
C            USED WITH LOOKUP TABLE TO COMPUTE RECTANGULAR COORDINATES
C            FROM LAT/LONG.
C
         P2=P2-IP1
         X=A*(XLR(IP1+2)+P2*(XLR(IP1+3)-XLR(IP1+1))/2.0D0
     .     +P2*P2*(XLR(IP1+3)-2.0D0*XLR(IP1+2)+XLR(IP1+1))/2.0D0)*LON
         Y=A*(PR(IP1+2)+P2*(PR(IP1+3)-PR(IP1+1))/2.0D0
     .     +P2*P2*(PR(IP1+3)-2.0D0*PR(IP1+2)+PR(IP1+1))/2.0D0)*PI/2.0D0
     .     *SIGN(1.0D0,GEOG(2))
         PROJ(1) = X0 + X
         PROJ(2) = Y0 + Y
         CRDIO(1) = PROJ(1)
         CRDIO(2) = PROJ(2)
         RETURN
      END IF
C
C -- I N V E R S E   . . .
C
      IF (INDIC .EQ. 1) THEN
C
         PROJ(1) = COORD(1)
         PROJ(2) = COORD(2)
         IERR = 0
         X = PROJ(1) - X0
         Y = PROJ(2) - Y0
         YY = 2.0D0 * Y / PI / A
         PHID = YY * 90.0D0
         P2 = ABS(PHID / 5.0D0)
         IP1 = INT(P2 - EPSLN)
         IF (IP1.EQ.0) IP1 = 1
         NN = 0
C
C     STIRLING'S INTERPOLATION FORMULA AS USED IN FORWARD TRANSFORMATION
C     IS REVERSED FOR FIRST ESTIMATION OF LAT. FROM RECTANGULAR
C     COORDINATES.  LAT. IS THEN ADJUSTED BY ITERATION UNTIL USE OF
C     FORWARD SERIES PROVIDES CORRECT VALUE OF Y WITHIN TOLERANCE.
C
  230    U = PR(IP1 + 3) - PR(IP1 + 1)
         V = PR(IP1 + 3) - 2.0D0 * PR(IP1 + 2) + PR(IP1 + 1)
         T = 2.0D0 * (ABS(YY) - PR(IP1 + 2))/ U
         C = V / U
         P2 = T * (1.0D0 - C * T * (1.0D0 - 2.0D0 * C * T))
         IF (P2.LT.0.0D0.AND.IP1.NE.1) GO TO 240
         PHID = SIGN((P2 + IP1) * 5.0D0, Y)
  235    P2 = ABS(PHID / 5.0D0)
         IP1 = INT(P2 - EPSLN)
         P2 = P2 - IP1
         Y1=A*(PR(IP1+2)+P2*(PR(IP1+3)-PR(IP1+1))/2.0D0
     .     +P2*P2*(PR(IP1+3)-2.0D0*PR(IP1+2)+PR(IP1+1))/2.0D0)*PI/2.0D0
     .     * SIGN(1.0D0,Y)
         PHID = PHID - 180.0D0* (Y1 - Y) / PI / A
         NN = NN + 1
         IF (NN.LE.20) GO TO 237
         IF (IPEMSG .EQ. 0) WRITE (IPELUN,245)
         IERR = 214
         RETURN
  237    IF (ABS(Y1 - Y).GT.0.00001D0) GO TO 235
         GO TO 250
  240    IP1 = IP1 - 1
         GO TO 230
  245    FORMAT (/' ERROR PJ21DP'/
     .            ' TOO MANY ITERATIONS FOR INVERSE ROBINSON')
  250    GEOG(2) = PHID * DG1
C
C        CALCULATE LONG. USING FINAL LAT. WITH TRANSPOSED FORWARD
C        STIRLING'S INTERPOLATION FORMULA.
C
         GEOG(1)=LON0+X/A/(XLR(IP1+2)+P2*(XLR(IP1+3)-XLR(IP1+1))/2.0D0
     .     +P2*P2*(XLR(IP1+3)-2.0D0*XLR(IP1+2)+XLR(IP1+1))/2.0D0)
         GEOG(1) = ADJLDP(GEOG(1))
         CRDIO(1) = GEOG(1)
         CRDIO(2) = GEOG(2)
         RETURN
      END IF
C
      END

C
C       $Id: stream.f,v 1.15 2008-07-27 00:17:28 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE STREAM (U,V,P,IAM,STUMSL,WRK)
C
      DIMENSION  U(IUD1,*), V(IVD1,*), P(IPD1,*), IAM(*), WRK(*)
C
      EXTERNAL STUMSL
C
C Input parameters:
C
C U,V    - arrays containing vector field data
C P      - 2-d scalar data array. (dummy - not implemented yet)
C IAM    - An area map array, may be dummied if 'MSK' is zero
C STUMSL - User modifiable masked drawing function; also may
C          be dummied if 'MSK is zero
C WRK    - workspace 
C
C ---------------------------------------------------------------------
C
C NOTE:
C Since implicit typing is used for all real and integer variables
C a consistent length convention has been adopted to help clarify the
C significance of the variables encountered in the code for this 
C utility. All local variable and subroutine parameter identifiers 
C are limited to 1,2,or 3 characters. Four character names identify  
C members of common blocks. Five and 6 character variable names 
C denote PARAMETER constants or subroutine or function names.
C
C Declare the ST common blocks.
C
      PARAMETER (IPLVLS = 256)
C
C Integer and real common block variables
C
C
      COMMON / STPAR /
     +                IUD1       ,IVD1       ,IPD1       ,
     +                IXD1       ,IXDM       ,IYD1       ,IYDN       ,
     +                IXM1       ,IYM1       ,IXM2       ,IYM2       ,
     +                IWKD       ,IWKU       ,ISET       ,IERR       ,
     +                IXIN       ,IYIN       ,IMSK       ,ICPM       ,
     +                NLVL       ,IPAI       ,ICTV       ,WDLV       ,
     +                UVMN       ,UVMX       ,PMIN       ,PMAX       ,
     +                IPLR       ,ISST       ,
     +                ICLR(IPLVLS)           ,TVLU(IPLVLS)
C
      COMMON / STTRAN /
     +                UVPS       ,
     +                UVPL       ,UVPR       ,UVPB       ,UVPT       ,
     +                UWDL       ,UWDR       ,UWDB       ,UWDT       ,
     +                UXC1       ,UXCM       ,UYC1       ,UYCN 
C
C Stream algorithm parameters
C
      COMMON / STSTRM /
     +                ISGD       ,IAGD       ,RARL       ,ICKP       ,
     +                ICKX       ,ITRP       ,ICYK       ,RVNL       ,
     +                ISVF       ,RUSV       ,RVSV       ,RNDA       ,
     +                ISPC       ,RPSV       ,RCDS       ,RSSP       ,
     +                RDFM       ,RSMD       ,RAMD       ,IGBS       ,
     +                ISTM       ,RVRL       ,RVFR       ,RVRM       ,
     +                IVPO       ,RAFR       ,RDMX       ,RDMN
C
C Text related parameters
C Note: graphical text output is not yet implemented for the
C       Streamline utility.
C
      COMMON / STTXP /
     +                FCWM    ,ICSZ    ,
     +                FMNS    ,FMNX    ,FMNY    ,IMNP    ,IMNC  ,
     +                FMXS    ,FMXX    ,FMXY    ,IMXP    ,IMXC  ,
     +                FZFS    ,FZFX    ,FZFY    ,IZFP    ,IZFC  ,
     +                FILS    ,FILX    ,FILY    ,IILP    ,IILC 
C
C Character variable declartions
C
      CHARACTER*160 CSTR
      PARAMETER (IPCHSZ=80)
      CHARACTER*(IPCHSZ)  CMNT,CMXT,CZFT,CILT
C
C Text string parameters
C
      COMMON / STCHAR / CSTR,CMNT,CMXT,CZFT,CILT
C
      SAVE /STPAR/, /STTRAN/, /STSTRM/, /STTXP/, /STCHAR/
C
C Internal buffer lengths
C
C IPNPTS - Number of points in the point buffer -- not less than 3
C IPLSTL - Streamline-crossover-check circular list length
C IPGRCT - Number of groups supported for area masking
C
      PARAMETER (IPNPTS = 256, IPLSTL = 750, IPGRCT = 64)
C
C --------------------------------------------------------------------
C
C The mapping common block: made available to user mapping routines
C
      COMMON /STMAP/
     +                IMAP       ,LNLG       ,INVX       ,INVY       ,
     +                XLOV       ,XHIV       ,YLOV       ,YHIV       ,
     +                WXMN       ,WXMX       ,WYMN       ,WYMX       ,
     +                XVPL       ,XVPR       ,YVPB       ,YVPT       ,
     +                XGDS       ,YGDS       ,NXCT       ,NYCT       ,
     +                ITRT       ,FW2W       ,FH2H       ,
     +                DFMG       ,VNML       ,RBIG       ,IBIG
C
      SAVE /STMAP/
C
C Math constants
C
      PARAMETER (PDTOR  = 0.017453292519943,
     +           PRTOD  = 57.2957795130823,
     +           P1XPI  = 3.14159265358979,
     +           P2XPI  = 6.28318530717959,
     +           P1D2PI = 1.57079632679489,
     +           P5D2PI = 7.85398163397448) 
C
C -----------------------------------------------------------------
C
C Check for valid area map and area group overflow if masking is enabled
C
      IF (IMSK.GT.0) THEN
         IF (IAM(7).GT.IPGRCT) THEN
            CSTR(1:29)='STREAM - TOO MANY AREA GROUPS'
            CALL SETER (CSTR(1:29),1,1)
            RETURN
         END IF
         IF (IAM(7).LE.0) THEN
            CSTR(1:25)='STREAM - INVALID AREA MAP'
            CALL SETER (CSTR(1:29),2,1)
            RETURN
         END IF
      END IF
C
C Save the line color, text color and linewidth.
C Then set up the new linewidth values
C 
      CALL GQPLCI(IER,IOC)
      CALL GQTXCI(IER,IOT)
      CALL GQLWSC(IER,ROW)
      CALL GSLWSC(WDLV)
C
C Calculation of NDC sizing values varies based on whether grid 
C relative sizing is in effect.
C
      IF (IGBS .EQ. 0) THEN
         RNDA=RARL*FW2W
         DFMG=RDFM*FW2W
      ELSE
         RNDA=RARL*FW2W/REAL(IXDM)
         DFMG=RDFM*FW2W/REAL(IXDM)
      END IF
C
C If not using the FX,FY routines, then the vector normalization
C value is fixed. 
C
      IF (ICPM.LT.1) THEN
         VNML=0.3333333
      ELSE
         VNML=RVNL
      END IF
C
C Set up the indexes into the work array. The first 2 sections hold
C the normalized vector values. If coloring by magnitude the next
C section holds the magnitudes, and if thinning the final two sections
C hold the thinning data.
C
      IU = 1
      IV = IXDM*IYDN+1
      IF (ABS(ICTV) .EQ. 1) THEN
         IM = 2*IXDM*IYDN+1
         IF (RSMD .GT. 0.0) THEN
            IT = 3*IXDM*IYDN+1
         ELSE
            IT = 1
         END IF
      ELSE IF (RSMD .GT. 0.0) THEN
         IT = 2*IXDM*IYDN+1
      ELSE
         IT = 1
      END IF
C
C
C Draw the streamlines.
C Break the work array into parts.
C If capatability mode is enabled use STDRCM (ST DRaw CoMpatible).
C If mode is curly vector use STCRCV (ST Draw Curly Vector)
C Otherwise use STDRAW
C If coloring by magnitude, the magnitudes are stored in the
C third part of the work array.
C
      IF (ICPM .GT. 0) THEN
         CALL STDRCM(U,V,WRK(IU),WRK(IV),IAM,STUMSL)
      ELSE IF (ISTM .EQ. 1) THEN
         IF (ABS(ICTV) .EQ. 1) THEN
            CALL STDRCV(U,V,WRK(IU),WRK(IV),WRK(IM),WRK(IT),IAM,STUMSL)
         ELSE
            CALL STDRCV(U,V,WRK(IU),WRK(IV),P,WRK(IT),IAM,STUMSL)
         END IF
      ELSE IF (ABS(ICTV) .EQ. 1) THEN
         CALL STDRAW(U,V,WRK(IU),WRK(IV),WRK(IM),WRK(IT),IAM,STUMSL)
      ELSE
         CALL STDRAW (U,V,WRK(IU),WRK(IV),P,WRK(IT),IAM,STUMSL)
      END IF
C
C Reset the polyline color, text color, and the linewidth
C
      CALL GSPLCI(IOC)
      CALL GSLWSC(ROW)
      CALL GSTXCI(IOT)
C
      RETURN
      END

C
C $Id: cpfy.f,v 1.7 2008-07-27 00:17:23 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      FUNCTION CPFY (IY)
C
C Given a Y coordinate IY in the plotter system, CPFY(IY) is a Y
C coordinate in the fractional system.
C
      COMMON /IUTLCM/ LL,MI,MX,MY,IU(96)
      SAVE /IUTLCM/
      CPFY=REAL(IY-1)/(2.**MY-1.)
      RETURN
      END

C
C	$Id: pcgneg.f,v 1.5 2008-07-27 00:17:19 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE PCGNEG (NUMIN,NUMOUT)
C
C  Where NUMIN has a 2's complement number in the low-order 16 bits,
C  this subroutine returns the equivalent number in the representation
C  of the host machine.
C
      NUMOUT = 0
      ISGN = IAND(ISHIFT(NUMIN,-15),1)
C
C  If input is a positive number, set output to input.
C
      IF (ISGN .EQ. 0) THEN
        NUMOUT = NUMIN
        RETURN
      ELSE
C
C  Set NUMOUT from 1's complement plus 1.
C
        NUMTMP = IAND(32767,NUMIN)
        NUMTMP = 32767-NUMTMP
        NUMOUT = -(NUMTMP+1)
      ENDIF
      RETURN
C
      END

      function ftstore(x)
c
      real x
c
c                                     coded by russell lynch
c                              from fitpack -- april 8, 1991
c                        a curve and surface fitting package
c                      a product of pleasant valley software
c                  8603 altus cove, austin, texas 78759, usa
c
c this function forces the placement of the value of its input
c to be placed in a single precision storage cell consistant
c with fortran 66. it is useful for comparing values nearly
c equal with respect to the precision of the computer.
c
c on input--
c
c   x is a real variable.
c
c on output--
c
c   store is a single precision version of x.
c
c and x is unaltered.
c
c this function references module strhlp and requires a
c common block named vcom.
c
c-------------------------------------------------------------
c
c
      common/vcom/vc
      call strhlp(x)
      ftstore = vc
      return
      end

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C   FFTPACK 5.0
C   Copyright (C) 1995-2004, Scientific Computing Division,
C   University Corporation for Atmospheric Research
C   Licensed under the GNU General Public License (GPL)
C
C   Authors:  Paul N. Swarztrauber and Richard A. Valent
C
C   $Id: mcstb1.f,v 1.2 2006-11-21 01:10:17 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      SUBROUTINE DMCSTB1(LOT,JUMP,N,INC,X,WSAVE,DSUM,WORK,IER)
      DOUBLE PRECISION WORK
      DOUBLE PRECISION X1H
      DOUBLE PRECISION X1P3
      DOUBLE PRECISION X2
      DOUBLE PRECISION T1
      DOUBLE PRECISION T2
      DOUBLE PRECISION FNM1S2
      DOUBLE PRECISION FNM1S4
      DOUBLE PRECISION XI
      DOUBLE PRECISION X(INC,*),WSAVE(*)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION DSUM(*)

      IER = 0
      NM1 = N - 1
      NP1 = N + 1
      NS2 = N/2
      LJ = (LOT-1)*JUMP + 1
      IF (N-2) 106,101,102
  101 DO 111 M = 1,LJ,JUMP
          X1H = X(M,1) + X(M,2)
          X(M,2) = X(M,1) - X(M,2)
          X(M,1) = X1H
  111 CONTINUE
      RETURN
  102 IF (N.GT.3) GO TO 103
      DO 112 M = 1,LJ,JUMP
          X1P3 = X(M,1) + X(M,3)
          X2 = X(M,2)
          X(M,2) = X(M,1) - X(M,3)
          X(M,1) = X1P3 + X2
          X(M,3) = X1P3 - X2
  112 CONTINUE
      RETURN
  103 DO 118 M = 1,LJ,JUMP
          X(M,1) = X(M,1) + X(M,1)
          X(M,N) = X(M,N) + X(M,N)
  118 CONTINUE
      M1 = 0
      DO 113 M = 1,LJ,JUMP
          M1 = M1 + 1
          DSUM(M1) = X(M,1) - X(M,N)
          X(M,1) = X(M,1) + X(M,N)
  113 CONTINUE
      DO 104 K = 2,NS2
          M1 = 0
          DO 114 M = 1,LJ,JUMP
              M1 = M1 + 1
              KC = NP1 - K
              T1 = X(M,K) + X(M,KC)
              T2 = X(M,K) - X(M,KC)
              DSUM(M1) = DSUM(M1) + WSAVE(KC)*T2
              T2 = WSAVE(K)*T2
              X(M,K) = T1 - T2
              X(M,KC) = T1 + T2
  114     CONTINUE
  104 CONTINUE
      MODN = MOD(N,2)
      IF (MODN.EQ.0) GO TO 124
      DO 123 M = 1,LJ,JUMP
          X(M,NS2+1) = X(M,NS2+1) + X(M,NS2+1)
  123 CONTINUE
  124 CONTINUE
      LENX = (LOT-1)*JUMP + INC* (NM1-1) + 1
      LNSV = NM1 + INT(LOG(DBLE(NM1))) + 4
      LNWK = LOT*NM1
C
      CALL DRFFTMF(LOT,JUMP,NM1,INC,X,LENX,WSAVE(N+1),LNSV,WORK,LNWK,
     +            IER1)
      IF (IER1.NE.0) THEN
          IER = 20
          CALL DXERFFT('MCSTB1',-5)
          GO TO 106
      END IF
C
      FNM1S2 = DBLE(NM1)/2.D0
      M1 = 0
      DO 10 M = 1,LJ,JUMP
          M1 = M1 + 1
          DSUM(M1) = .5D0*DSUM(M1)
          X(M,1) = FNM1S2*X(M,1)
   10 CONTINUE
      IF (MOD(NM1,2).NE.0) GO TO 30
      DO 20 M = 1,LJ,JUMP
          X(M,NM1) = X(M,NM1) + X(M,NM1)
   20 CONTINUE
   30 FNM1S4 = DBLE(NM1)/4.D0
      DO 105 I = 3,N,2
          M1 = 0
          DO 115 M = 1,LJ,JUMP
              M1 = M1 + 1
              XI = FNM1S4*X(M,I)
              X(M,I) = FNM1S4*X(M,I-1)
              X(M,I-1) = DSUM(M1)
              DSUM(M1) = DSUM(M1) + XI
  115     CONTINUE
  105 CONTINUE
      IF (MODN.NE.0) RETURN
      M1 = 0
      DO 116 M = 1,LJ,JUMP
          M1 = M1 + 1
          X(M,N) = DSUM(M1)
  116 CONTINUE
  106 CONTINUE
      RETURN
      END

C
C       $Id: ngmftc.f,v 1.4 2008-07-27 00:17:18 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE NGMFTC(WKID)
C
C Effects a temporaty close in metafile output allowing for subsequent 
C reopening for appending using NGREOP.  The metafile output may be 
C suspended at any time, and not necessarily at a picture break.
C
C ARGUMENTS
C
C ON INPUT  
C    
C   WKID  An integer argument indicating the workstation ID of the
C         workstation to temporarily close.
C
      INTEGER WKID
      CHARACTER*80 IDR(1),ODR(1)
C
      WRITE(IDR(1)(1:5),500) WKID
  500 FORMAT(I5)
      CALL SFLUSH
      CALL GESC(-1387,1,IDR,1,1,ODR)
C
      RETURN
      END

      SUBROUTINE CGEQRF( M, N, A, LDA, TAU, WORK, LWORK, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      INTEGER            INFO, LDA, LWORK, M, N
*     ..
*     .. Array Arguments ..
      COMPLEX            A( LDA, * ), TAU( * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  CGEQRF computes a QR factorization of a complex M-by-N matrix A:
*  A = Q * R.
*
*  Arguments
*  =========
*
*  M       (input) INTEGER
*          The number of rows of the matrix A.  M >= 0.
*
*  N       (input) INTEGER
*          The number of columns of the matrix A.  N >= 0.
*
*  A       (input/output) COMPLEX array, dimension (LDA,N)
*          On entry, the M-by-N matrix A.
*          On exit, the elements on and above the diagonal of the array
*          contain the min(M,N)-by-N upper trapezoidal matrix R (R is
*          upper triangular if m >= n); the elements below the diagonal,
*          with the array TAU, represent the unitary matrix Q as a
*          product of min(m,n) elementary reflectors (see Further
*          Details).
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(1,M).
*
*  TAU     (output) COMPLEX array, dimension (min(M,N))
*          The scalar factors of the elementary reflectors (see Further
*          Details).
*
*  WORK    (workspace/output) COMPLEX array, dimension (LWORK)
*          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*
*  LWORK   (input) INTEGER
*          The dimension of the array WORK.  LWORK >= max(1,N).
*          For optimum performance LWORK >= N*NB, where NB is
*          the optimal blocksize.
*
*          If LWORK = -1, then a workspace query is assumed; the routine
*          only calculates the optimal size of the WORK array, returns
*          this value as the first entry of the WORK array, and no error
*          message related to LWORK is issued by XERBLA.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*
*  Further Details
*  ===============
*
*  The matrix Q is represented as a product of elementary reflectors
*
*     Q = H(1) H(2) . . . H(k), where k = min(m,n).
*
*  Each H(i) has the form
*
*     H(i) = I - tau * v * v'
*
*  where tau is a complex scalar, and v is a complex vector with
*  v(1:i-1) = 0 and v(i) = 1; v(i+1:m) is stored on exit in A(i+1:m,i),
*  and tau in TAU(i).
*
*  =====================================================================
*
*     .. Local Scalars ..
      LOGICAL            LQUERY
      INTEGER            I, IB, IINFO, IWS, K, LDWORK, LWKOPT, NB,
     $                   NBMIN, NX
*     ..
*     .. External Subroutines ..
      EXTERNAL           CGEQR2, CLARFB, CLARFT, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN
*     ..
*     .. External Functions ..
      INTEGER            ILAENV
      EXTERNAL           ILAENV
*     ..
*     .. Executable Statements ..
*
*     Test the input arguments
*
      INFO = 0
      NB = ILAENV( 1, 'CGEQRF', ' ', M, N, -1, -1 )
      LWKOPT = N*NB
      WORK( 1 ) = LWKOPT
      LQUERY = ( LWORK.EQ.-1 )
      IF( M.LT.0 ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( LDA.LT.MAX( 1, M ) ) THEN
         INFO = -4
      ELSE IF( LWORK.LT.MAX( 1, N ) .AND. .NOT.LQUERY ) THEN
         INFO = -7
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'CGEQRF', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         RETURN
      END IF
*
*     Quick return if possible
*
      K = MIN( M, N )
      IF( K.EQ.0 ) THEN
         WORK( 1 ) = 1
         RETURN
      END IF
*
      NBMIN = 2
      NX = 0
      IWS = N
      IF( NB.GT.1 .AND. NB.LT.K ) THEN
*
*        Determine when to cross over from blocked to unblocked code.
*
         NX = MAX( 0, ILAENV( 3, 'CGEQRF', ' ', M, N, -1, -1 ) )
         IF( NX.LT.K ) THEN
*
*           Determine if workspace is large enough for blocked code.
*
            LDWORK = N
            IWS = LDWORK*NB
            IF( LWORK.LT.IWS ) THEN
*
*              Not enough workspace to use optimal NB:  reduce NB and
*              determine the minimum value of NB.
*
               NB = LWORK / LDWORK
               NBMIN = MAX( 2, ILAENV( 2, 'CGEQRF', ' ', M, N, -1,
     $                 -1 ) )
            END IF
         END IF
      END IF
*
      IF( NB.GE.NBMIN .AND. NB.LT.K .AND. NX.LT.K ) THEN
*
*        Use blocked code initially
*
         DO 10 I = 1, K - NX, NB
            IB = MIN( K-I+1, NB )
*
*           Compute the QR factorization of the current block
*           A(i:m,i:i+ib-1)
*
            CALL CGEQR2( M-I+1, IB, A( I, I ), LDA, TAU( I ), WORK,
     $                   IINFO )
            IF( I+IB.LE.N ) THEN
*
*              Form the triangular factor of the block reflector
*              H = H(i) H(i+1) . . . H(i+ib-1)
*
               CALL CLARFT( 'Forward', 'Columnwise', M-I+1, IB,
     $                      A( I, I ), LDA, TAU( I ), WORK, LDWORK )
*
*              Apply H' to A(i:m,i+ib:n) from the left
*
               CALL CLARFB( 'Left', 'Conjugate transpose', 'Forward',
     $                      'Columnwise', M-I+1, N-I-IB+1, IB,
     $                      A( I, I ), LDA, WORK, LDWORK, A( I, I+IB ),
     $                      LDA, WORK( IB+1 ), LDWORK )
            END IF
   10    CONTINUE
      ELSE
         I = 1
      END IF
*
*     Use unblocked code to factor the last or only block.
*
      IF( I.LE.K )
     $   CALL CGEQR2( M-I+1, N-I+1, A( I, I ), LDA, TAU( I ), WORK,
     $                IINFO )
*
      WORK( 1 ) = IWS
      RETURN
*
*     End of CGEQRF
*
      END

C
C $Id: idlctn.f,v 1.5 2008-07-27 00:17:30 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE IDLCTN (NDP,XD,YD,NT,IPT,NL,IPL,XII,YII,ITI,IWK,WK)
C
C This subroutine locates a point, i.e., it determines to what triangle
C a given point (XII,YII) belongs.  If the given point does not lie
C inside the data area and quintic interpolation is selected, IDLCTN
C determines which border line segment defines the semi-infinite
C rectangular area containing the point or, alternatively, which pair
C of border line segments defines the semi-infinite triangular area
C containing the point.  If the point lies outside the data area but
C linear interpolation is selected, IDLCTN determines which border line
C segment defines the semi-infinite quadrangular area containing the
C point.
C
C The input arguments are as follows:
C
C   NDP      number of data points.
C
C   XD,YD    arrays of dimension NDP containing the X and Y
C            coordinates of the data points.
C
C   NT       number of triangles.
C
C   IPT      integer array of dimension 3*NT containing the
C            point numbers of the vertices of the triangles.
C
C   NL       number of border line segments.
C
C   IPL      integer array of dimension 3*NL containing the
C            point numbers of the end points of the border
C            line segments and their respective triangle
C            numbers.
C
C   XII,YII  X and Y coordinates of the point to be located.
C
C The output argument is as follows:
C
C   ITI      triangle number, when the point is inside the
C            data area, or two border line segment numbers,
C            IL1 and IL2, coded to IL1*(NT+NL)+IL2, when the
C            point is outside the data area.
C
C The other arguments are as follows:
C
C   IWK      integer array of dimension 18*NDP used internally
C            as a work area.
C
C   WK       array of dimension 8*NDP used internally as a
C            work area.
C
C Declaration statements.

      DIMENSION XD(NDP),YD(NDP),IPT(3*NT),IPL(3*NL),IWK(18*NDP),
     +          WK(8*NDP),IDSC(9)
C
      COMMON /IDLC/ ITIPV,XS1,XS2,YS1,YS2,NTSC(9)
      SAVE   /IDLC/
C
      COMMON /IDCOMN/ INTY,ITTY,ALSP,BLSP,CLSP,XAVG,YAVG
      SAVE   /IDCOMN/
C
C Statement functions.
C
      SPDT(U1,V1,U2,V2,U3,V3)=(U1-U2)*(U3-U2)+(V1-V2)*(V3-V2)
      VPDT(U1,V1,U2,V2,U3,V3)=(U1-U3)*(V2-V3)-(V1-V3)*(U2-U3)
C
C Preliminary processing.
C
      NTL=NT+NL
      X0=XII
      Y0=YII
C
C Jump if processing the same set of data as in the previous call.
C
      IF (ITIPV.NE.0) GO TO 108
C
C Divide the X-Y plane into nine rectangular sections.
C
      XMN=XD(1)
      XMX=XMN
      YMN=YD(1)
      YMX=YMN
C
      DO 101 IDP=2,NDP
        XMN=MIN(XD(IDP),XMN)
        XMX=MAX(XD(IDP),XMX)
        YMN=MIN(YD(IDP),YMN)
        YMX=MAX(YD(IDP),YMX)
  101 CONTINUE
C
      XS1=(XMN+XMN+XMX)/3.0
      XS2=(XMN+XMX+XMX)/3.0
      YS1=(YMN+YMN+YMX)/3.0
      YS2=(YMN+YMX+YMX)/3.0
C
C Determine and store in the array IWK triangle numbers of the triangles
C associated with each of the nine sections and in the array WK the
C minimum and maximum of the X and Y coordinate values for each of the
C triangles.
C
      DO 102 ISC=1,9
        NTSC(ISC)=0
        IDSC(ISC)=0
  102 CONTINUE
C
      IT0T3=0
      JWK=0
C
      DO 107 IT0=1,NT
C
        IT0T3=IT0T3+3
        I1=IPT(IT0T3-2)
        I2=IPT(IT0T3-1)
        I3=IPT(IT0T3)
        XMN=MIN(XD(I1),XD(I2),XD(I3))
        XMX=MAX(XD(I1),XD(I2),XD(I3))
        YMN=MIN(YD(I1),YD(I2),YD(I3))
        YMX=MAX(YD(I1),YD(I2),YD(I3))
        IF (YMN.GT.YS1)                   GO TO 103
        IF (XMN.LE.XS1)                   IDSC(1)=1
        IF (XMX.GE.XS1.AND.XMN.LE.XS2)    IDSC(2)=1
        IF (XMX.GE.XS2)                   IDSC(3)=1
  103   IF (YMX.LT.YS1.OR.YMN.GT.YS2)     GO TO 104
        IF (XMN.LE.XS1)                   IDSC(4)=1
        IF (XMX.GE.XS1.AND.XMN.LE.XS2)    IDSC(5)=1
        IF (XMX.GE.XS2)                   IDSC(6)=1
  104   IF (YMX.LT.YS2)                   GO TO 105
        IF (XMN.LE.XS1)                   IDSC(7)=1
        IF (XMX.GE.XS1.AND.XMN.LE.XS2)    IDSC(8)=1
        IF (XMX.GE.XS2)                   IDSC(9)=1
C
  105   DO 106 ISC=1,9
          IF (IDSC(ISC).EQ.0) GO TO 106
          JIWK=9*NTSC(ISC)+ISC
          IWK(JIWK)=IT0
          NTSC(ISC)=NTSC(ISC)+1
          IDSC(ISC)=0
  106   CONTINUE
C
        JWK=JWK+4
C
        WK(JWK-3)=XMN
        WK(JWK-2)=XMX
        WK(JWK-1)=YMN
        WK(JWK)  =YMX
C
  107 CONTINUE
C
      GO TO 111
C
C Check if in the same triangle as previously.
C
  108 IT0=ITIPV
      IF (IT0.GT.NT) GO TO 109
      IT0T3=IT0*3
      IP1=IPT(IT0T3-2)
      X1=XD(IP1)
      Y1=YD(IP1)
      IP2=IPT(IT0T3-1)
      X2=XD(IP2)
      Y2=YD(IP2)
      IF (VPDT(X1,Y1,X2,Y2,X0,Y0).LT.0.) GO TO 111
      IP3=IPT(IT0T3)
      X3=XD(IP3)
      Y3=YD(IP3)
      IF (VPDT(X2,Y2,X3,Y3,X0,Y0).LT.0.) GO TO 111
      IF (VPDT(X3,Y3,X1,Y1,X0,Y0).LT.0.) GO TO 111
      GO TO 117
C
C Check if on the same border line segment.
C
  109 IL1=IT0/NTL
      IL2=IT0-IL1*NTL
      IL1T3=IL1*3
      IP1=IPL(IL1T3-2)
      X1=XD(IP1)
      Y1=YD(IP1)
      IP2=IPL(IL1T3-1)
      X2=XD(IP2)
      Y2=YD(IP2)
C
      IF (IL2.NE.IL1) GO TO 110
C
      IF (VPDT(X1,Y1,X2,Y2,X0,Y0).GT.0.) GO TO 111
C
      IF (INTY.EQ.0) THEN
        IF (SPDT(X1,Y1,X2,Y2,X0,Y0).LT.0.) GO TO 111
        IF (SPDT(X2,Y2,X1,Y1,X0,Y0).LT.0.) GO TO 111
      ELSE
        IF (VPDT(XAVG,YAVG,X1,Y1,X0,Y0).LT.0.) GO TO 111
        IF (VPDT(XAVG,YAVG,X2,Y2,X0,Y0).GT.0.) GO TO 111
      END IF
C
      GO TO 117
C
C Check if between the same two border line segments.
C
  110 IF (SPDT(X1,Y1,X2,Y2,X0,Y0).GT.0.) GO TO 111
      IP3=IPL(3*IL2-1)
      X3=XD(IP3)
      Y3=YD(IP3)
      IF (SPDT(X3,Y3,X2,Y2,X0,Y0).LE.0.) GO TO 117
C
C Locate inside the data area.  Determine the section in which
C the point in question lies.
C
  111 ISC=1
      IF (X0.GE.XS1) ISC=ISC+1
      IF (X0.GE.XS2) ISC=ISC+1
      IF (Y0.GE.YS1) ISC=ISC+3
      IF (Y0.GE.YS2) ISC=ISC+3
C
C Search through the triangles associated with the section.
C
      NTSCI=NTSC(ISC)
      IF (NTSCI.LE.0) GO TO 113
C
      JIWK=-9+ISC
C
      DO 112 ITSC=1,NTSCI
        JIWK=JIWK+9
        IT0=IWK(JIWK)
        JWK=IT0*4
        IF (X0.LT.WK(JWK-3)) GO TO 112
        IF (X0.GT.WK(JWK-2)) GO TO 112
        IF (Y0.LT.WK(JWK-1)) GO TO 112
        IF (Y0.GT.WK(JWK))   GO TO 112
        IT0T3=IT0*3
        IP1=IPT(IT0T3-2)
        X1=XD(IP1)
        Y1=YD(IP1)
        IP2=IPT(IT0T3-1)
        X2=XD(IP2)
        Y2=YD(IP2)
        IF (VPDT(X1,Y1,X2,Y2,X0,Y0).LT.0.) GO TO 112
        IP3=IPT(IT0T3)
        X3=XD(IP3)
        Y3=YD(IP3)
        IF (VPDT(X2,Y2,X3,Y3,X0,Y0).LT.0.) GO TO 112
        IF (VPDT(X3,Y3,X1,Y1,X0,Y0).LT.0.) GO TO 112
        GO TO 117
  112 CONTINUE
C
C Locate outside the data area.
C
  113 DO 115 IL1=1,NL
        IL1T3=IL1*3
        IP1=IPL(IL1T3-2)
        X1=XD(IP1)
        Y1=YD(IP1)
        IP2=IPL(IL1T3-1)
        X2=XD(IP2)
        Y2=YD(IP2)
        IF (INTY.EQ.0) THEN
          IF (SPDT(X2,Y2,X1,Y1,X0,Y0).LT.0.) GO TO 115
          IF (SPDT(X1,Y1,X2,Y2,X0,Y0).LT.0.) GO TO 114
          IF (VPDT(X1,Y1,X2,Y2,X0,Y0).GT.0.) GO TO 115
          IL2=IL1
          GO TO 116
  114     IL2=MOD(IL1,NL)+1
          IP3=IPL(3*IL2-1)
          X3=XD(IP3)
          Y3=YD(IP3)
          IF (SPDT(X3,Y3,X2,Y2,X0,Y0).LE.0.) GO TO 116
        ELSE
          IF (VPDT(X1  ,Y1  ,X2,Y2,X0,Y0).GT.0.) GO TO 115
          IF (VPDT(XAVG,YAVG,X1,Y1,X0,Y0).LT.0.) GO TO 115
          IF (VPDT(XAVG,YAVG,X2,Y2,X0,Y0).GT.0.) GO TO 115
          IL2=IL1
          GO TO 116
        END IF
  115 CONTINUE
C
      IT0=1
      GO TO 117
C
  116 IT0=IL1*NTL+IL2
C
C Normal exit.
C
  117 ITI=IT0
      ITIPV=IT0
C
      RETURN
C
      END

      PROGRAM FDLDASHD
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C INVOKE DEMO DRIVER
C
      CALL LINEEX (IWKID)
C
C DEACTIVATE AND CLOSE WORKSTATION, CLOSE GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      STOP
      END
C
      SUBROUTINE LINEEX (IWKID)
C
C PURPOSE                To provide a simple demonstration of 
C                        how to set line dash patterns. 
C
C USAGE                  CALL LINEEX (IWKID)
C
C ARGUMENTS
C
C ON INPUT               IWKID
C                          Workstation id
C
C LANGUAGE               FORTRAN
C
C PORTABILITY            FORTRAN 77
C
C NOTE                   The call to GOPWK will have to be modified
C                        when using a non-NCAR GKS package.  The third
C                        argument must be the workstation type for WISS.
C
C
      CHARACTER STR*60
      REAL XCOORD(360), YCOORD(360)
C
C  Data for the graphical objects.
C
      DATA    TWOPI/6.283185/
C
C Establish the viewport and window.
C
      CALL SET(.01,.99,0.01,.99,0.,1.,0.,1.,1)
C
C Turn buffering off
C
      CALL SETUSV('PB',2)
C
C Set up a color table
C
C White background
C
      CALL GSCR (IWKID,0,1.,1.,1.)
C
C Black foreground
C
      CALL GSCR (IWKID,1,0.,0.,0.)
C
C Red
C
      CALL GSCR (IWKID,2,1.,0.,0.)
C
C Green
C
      CALL GSCR (IWKID,3,0.,1.,0.)
C
C Blue
C
      CALL GSCR (IWKID,4,0.,0.,1.)
C
C Create and Plot 2 Sine Curves
C
C Set the dash pattern
C
      STR = '$''$''Line''drawn''with''VECTD$''$''$''$'''
      CALL DASHDC(STR,15,20)
C
C Move plotter pen
C
      CALL FRSTD(0.,.60)
      DO 22 I=1,360
         Y = (SIN(REAL(I)*(TWOPI/360.)) * .25) + .60
         CALL VECTD(REAL(I)/360.,Y)
 22   CONTINUE
C
C Set the Dash pattern
C
      STR = '$$$$$$Line''drawn''with''CURVED$$$$$$$$$$$$'
      CALL DASHDC(STR,15,20)
      CALL GSLWSC(3.)
      DO 23 I=1,360
         XCOORD(I) = REAL(I)/360.
         YCOORD(I) = (SIN(REAL(I)*(TWOPI/360.)) * .25) + .45
 23   CONTINUE
C
C Draw the second curve
C
      CALL CURVED(XCOORD, YCOORD, 360)
C
C Draw a straight line
C
      CALL GSLWSC(4.)
C
C 1111100110011111 binary  = 63903 decimal
C
      CALL DASHDB(63903)
      CALL LINED(0.1,.15, .9,.15)
C
C Label the line
C
      CALL PLCHLQ(0.5,0.10,'Line drawn with LINED',20.,0.,0.)
C
C  Create a background perimeter 
C
      CALL GSPLCI(1)
      CALL FRSTPT( 0.0, 0.0)
      CALL VECTOR( 1.0, 0.0)
      CALL VECTOR( 1.0, 1.0)
      CALL VECTOR( 0.0, 1.0)
      CALL VECTOR( 0.0, 0.0)
C
C  Label the plot
C
      CALL PLCHLQ(0.7,0.90,'Setting Dash Patterns',25.,0.,0.)
      CALL PLCHLQ(0.7,0.81,'with DASHDB and DASHDC',25.,0.,0.)
      CALL FRAME
C
      END

C
C	$Id: setop.f,v 1.6 2008-07-27 00:59:05 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE SETOP(IOS,STATUS)
C
C  SET THE REQUESTED OPTION VALUE
C
C  OUTPUT
C       IOS- THE I/O STATUS VALID IF STATUS SET TO AN I/O ERROR
C       STATUS-THE ERROR STATUS DEFINED BY COMMON TREROR
C
      COMMON/TREROR/ ALLOK, MFRCHK, MTOPER, METRDC, REDERR, TYPCHG
     1             ,INVTYP, MINVLD, TYPERR, FRMEND, ENCINT, IVDCDT
     2             ,GCOERR, GCRERR, GCCERR, FCOERR, FCRERR, FCCERR
     3             ,PLIDXG, PMIDXG, TXIDXG, PGIDXG, INVLMT, CELERR
     4             ,COIERR, COLNRM, UNKNOW, UNKOPC, ENDMTF, VNEROR
     5             ,BADRSZ, DEVOUT, NOVERS, BADFNT, PGMERR, FASERR
     6             ,HINERR, VDWERR, RDWERR, RIXLIM
      INTEGER        ALLOK, MFRCHK, MTOPER, METRDC, REDERR, TYPCHG
     1             ,INVTYP, MINVLD, TYPERR, FRMEND, ENCINT, IVDCDT
     2             ,GCOERR, GCRERR, GCCERR, FCOERR, FCRERR, FCCERR
     3             ,PLIDXG, PMIDXG, TXIDXG, PGIDXG, INVLMT, CELERR
     4             ,COIERR, COLNRM, UNKNOW, UNKOPC, ENDMTF, VNEROR
     5             ,BADRSZ, DEVOUT, NOVERS, BADFNT, PGMERR, FASERR
     6             ,HINERR, VDWERR, RDWERR, RIXLIM
      COMMON/TRINOT/ IPTR, MBUFOT, MAXBYT, DEVUNT, METUNT,
     1          METIPT, ERRUNT, FNTUNT
      INTEGER MAXCNT
      PARAMETER (MAXCNT=200)
      INTEGER IPTR, MBUFOT(MAXCNT), MAXBYT, DEVUNT, METUNT, ERRUNT,
     1        FNTUNT
      LOGICAL METIPT
      COMMON /TRINST/ OPCL, OPID, LEN, CONT
      INTEGER OPCL, OPID, LEN
      LOGICAL CONT
      COMMON /PGKSCOM/ CLPDAT, CLPFLG, POLIDX, LINTYP, LINWTH, LINCOL,
     1                LINRGB, MARIDX, MARSIZ, MARCOL, MARRGB, TXTIDX,
     2                INTSTL, PATIDX, FILCOL, FILRGB, MARTYP, HORIZ ,
     3                VERT  , PATH  , CHIGHT, XU    , YU    , XB    ,
     4                YB    , TXTCOL, FINDEX, CEXPN , CSPACE, CURIDX,
     5                CURIMP, CURINT, COLMOD, FILIDX, TXTRGB, PROPN ,
     6                FIRSTX, FIRSTY, LASTX , LASTY , TRATIO, CBV   ,
     7                CUV   , CHP   , CVP   , CCSPAC, CHHORZ, CDV   ,
     8                PMRSIZ, CLPX  , CLPY  , CLPP  , DEFREP, DEFLEN,
     9                VDCECR, TRANVN, TXTPRE, HATIDX, FILRPT, ASFSRF,
     A                ASFSDF, MAPMOD, VERSOK, PCBFST, CPGLEN, CLPNUL,
     B                MTDLEN
      INTEGER         CMPMAX, ASFMAX
      PARAMETER      (CMPMAX=256    , ASFMAX=18)
      LOGICAL         CLPFLG, PROPN , CHHORZ, DEFREP, CLPNUL, MAPMOD,
     1                VERSOK, PCBFST
      REAL            LINWTH, MARSIZ, CEXPN , CSPACE, TRATIO, CBV(2),
     1                CUV(2), CDV(2), CCSPAC
      INTEGER         CLPDAT(4)     , POLIDX, LINTYP, LINCOL, LINRGB(3),
     1                MARIDX, MARCOL, MARRGB(3)     , TXTIDX, INTSTL,
     2                PATIDX, FILCOL, FILRGB(3)     , MARTYP, HORIZ ,
     3                VERT  , PATH  , XU    , YU    , XB    , YB    ,
     4                TXTCOL, FINDEX, CURIMP(CMPMAX), CURINT(CMPMAX*3),
     5                CHIGHT, COLMOD, FILIDX, TXTRGB(3)     , CURIDX,
     6                FIRSTX, FIRSTY, LASTX , LASTY , CHP   , CVP   ,
     7                PMRSIZ, CLPX  , CLPY  , CLPP  , DEFLEN, TRANVN,
     8                TXTPRE, HATIDX, FILRPT(2)     , VDCECR(4)     ,
     9                ASFSRF(ASFMAX), ASFSDF(ASFMAX), CPGLEN, MTDLEN
      COMMON /GKSCHR/ MTDESC
      CHARACTER*80    MTDESC
      COMMON /TRMTYP/ FOURBT, MULTBT, TWOBT, PTSFLG, CURCOL, IPWRIT,
     1                IFRAME, ISETOP, IRANG, IPTS, ICAS, IINT, IORNT,
     2                ISIZE, IFONT, IPAT, ISSIZ, ICENT, ICOLR,
     3                MCENT, MSIZE, MOR, OLDX, OLDY, MCASE, MINTEN,
     4                MFONT, MDASH, MSPOT, MCOLOR, MLIMIT, PTSYM,
     5                SAVX, SAVY
      INTEGER FOURBT, MULTBT, TWOBT, PTSFLG, CURCOL, IPWRIT,
     1                IFRAME, ISETOP, IRANG, IPTS, ICAS, IINT, IORNT,
     2                ISIZE, IFONT, IPAT, ISSIZ, ICENT, ICOLR,
     3                MCENT, MSIZE, MOR, OLDX, OLDY, MCASE, MINTEN,
     4                MFONT, MDASH, MSPOT, MCOLOR(3), MLIMIT(4), PTSYM,
     5                SAVX, SAVY
      COMMON /CAPLIN/ PLAVBL, LDSSTR, LDSSIZ, LDTSTR, LDTSIZ,
     1                LMSSTR, LMSSIZ, LMTSTR, LMTSIZ, LCSSTR,
     2                LCSSIZ, LCTSTR, LCTSIZ, LINFIN, LINFMT,
     3                LWSSTR, LWSSIZ, LWTSTR, LWTSIZ, LWTFIN,
     4                LWTFMT, LWTRNG, LWTSCF, LBSSTR, LBSSIZ,
     5                LBTSTR, LBTSIZ, LPSSTR, LPSSIZ, LPTSTR,
     6                LPTSIZ
      INTEGER         LDSMAX, LDTMAX, LMSMAX, LMTMAX, LCSMAX,
     1                LCTMAX, LVCFMX, LWSMAX, LWTMAX, LWTFMX,
     2                LBSMAX, LBTMAX, LPSMAX, LPTMAX
      PARAMETER   (LDSMAX=30, LDTMAX=15, LMSMAX=30, LMTMAX=15,
     1             LCSMAX=30, LCTMAX=15, LVCFMX=8,  LWSMAX=30,
     2             LWTMAX=15, LWTFMX=8 , LBSMAX=30, LBTMAX=15,
     3             LPSMAX=20, LPTMAX=20)
      INTEGER         LDSSTR(LDSMAX), LDSSIZ, LDTSTR(LDTMAX),
     1                LDTSIZ, LMSSTR(LMSMAX), LMSSIZ,
     2                LMTSTR(LMTMAX), LMTSIZ, LCSSTR(LCSMAX),
     3                LCSSIZ, LCTSTR(LCTMAX), LCTSIZ, LINFIN(8),
     4                LINFMT(LVCFMX,4)      , LWSSTR(LWSMAX),
     5                LWSSIZ, LWTSTR(LWTMAX), LWTSIZ, LWTFIN(8),
     6                LWTFMT(LWTFMX,4)      , LWTRNG(2)     ,
     7                LBSSTR(LBSMAX), LBSSIZ, LBTSTR(LBTMAX),
     8                LBTSIZ, LPSSTR(LPSMAX), LPSSIZ,
     9                LPTSTR(LPTMAX), LPTSIZ
      LOGICAL         PLAVBL
      REAL            LWTSCF,LINRIN(8),LWTRIN(8)
      INTEGER         LENLIN
      PARAMETER   (LENLIN=1+LDSMAX+1+LDTMAX+1+LMSMAX+1+
     1             LMTMAX+1+LCSMAX+1+LCTMAX+1+8+LVCFMX*4+
     2             LWSMAX+1+LWTMAX+1+8+LWTFMX*4+2+1+LBSMAX+
     3             1+LBTMAX+1+LPSMAX+1+LPTMAX+1)
      EQUIVALENCE (LINFIN,LINRIN), (LWTFIN,LWTRIN)
      COMMON /CINFO/COLVLS,INTS,NUMI
      DIMENSION COLVLS(3,256),INTS(256)
C
      INTEGER IOS, STATUS
      INTEGER BYTE8, W16, OCOUNT, OPCODE, NSKIP, K
C
      REAL RGBV(3,16)
      CHARACTER*1 CINT(10)
      CHARACTER*3 CINDX,CVAL(16)
      INTEGER CUSED(16)
      SAVE
      DATA CINT /'0','1','2','3','4','5','6','7','8','9'/
      DATA CVAL /'BLA','WHI','RED','GRE','BLU','CYA','MAG','YEL',
     -           'ORA','GRA','VIO','TAN','BRO','GOL','PIN','TUR'/
      DATA RGBV(1, 1),RGBV(2, 1),RGBV(3, 1) /0.00, 0.00, 0.00/
      DATA RGBV(1, 2),RGBV(2, 2),RGBV(3, 2) /1.00, 1.00, 1.00/
      DATA RGBV(1, 3),RGBV(2, 3),RGBV(3, 3) /1.00, 0.00, 0.00/
      DATA RGBV(1, 4),RGBV(2, 4),RGBV(3, 4) /0.00, 1.00, 0.00/
      DATA RGBV(1, 5),RGBV(2, 5),RGBV(3, 5) /0.00, 0.00, 1.00/
      DATA RGBV(1, 6),RGBV(2, 6),RGBV(3, 6) /0.00, 1.00, 1.00/
      DATA RGBV(1, 7),RGBV(2, 7),RGBV(3, 7) /1.00, 0.00, 1.00/
      DATA RGBV(1, 8),RGBV(2, 8),RGBV(3, 8) /1.00, 1.00, 0.00/
      DATA RGBV(1, 9),RGBV(2, 9),RGBV(3, 9) /1.00, 0.50, 0.00/
      DATA RGBV(1,10),RGBV(2,10),RGBV(3,10) /0.75, 0.75, 0.75/
      DATA RGBV(1,11),RGBV(2,11),RGBV(3,11) /0.31, 0.18, 0.31/
      DATA RGBV(1,12),RGBV(2,12),RGBV(3,12) /0.86, 0.58, 0.44/
      DATA RGBV(1,13),RGBV(2,13),RGBV(3,13) /0.65, 0.16, 0.16/
      DATA RGBV(1,14),RGBV(2,14),RGBV(3,14) /0.80, 0.50, 0.20/
      DATA RGBV(1,15),RGBV(2,15),RGBV(3,15) /0.74, 0.56, 0.56/
      DATA RGBV(1,16),RGBV(2,16),RGBV(3,16) /0.68, 0.92, 0.92/
      DATA CUSED/16*0/
C
C  DEFINE THE BYTE SIZE FOR COUNT AND OPTION CODE
C
      DATA BYTE8/8/ , W16/16/
C
C  INITIALIZE THE STATUS FIELD TO ALL OK
C
      STATUS = ALLOK
C
C  GET THE COUNT FIELD NO ERROR CHECKING REQUIRED
C
      CALL MNINST(BYTE8,IOS,STATUS)
      OCOUNT = OPCL
C
C  GET THE OPTION CODE
C
      CALL MNINST(BYTE8,IOS,STATUS)
      OPCODE = OPCL
      IF ( STATUS .NE. ALLOK) RETURN
C
C  SELECT THE PROPER OPTION TO SET
C
      IF (OPCODE .EQ. ICAS) THEN
C
C       ICAS MEANS SET UPPER OR LOWER CASE.
C
        CALL MNINST(BYTE8,IOS,STATUS)
        MCASE = OPCL
C
      ELSE IF (OPCODE .EQ. IINT) THEN
C
C       IINT MEANS SET INTENSITY
C
        CALL MNINST(BYTE8,IOS,STATUS)
        MINTEN = OPCL
C
C       PUT THE INTENSITY VALUE IN THE VALID RANGE
C
        ITMP = MAX(0,MINTEN)
        ITMP = MIN(255,ITMP)
C
C       DO NOT RE-DEFINE COLOR INDICES 0 OR 1.
C
        IF (ITMP .EQ. 204) THEN
          ICNDX = 1
          GO TO 30
        ELSE IF (ITMP .EQ. 0) THEN
          ICNDX = 0
          GO TO 30
        ENDIF
        IF (NUMI .GT. 1) THEN
          DO 10 I=2,NUMI
          IF (INTS(I) .EQ. ITMP) THEN
            ICNDX = I
            GO TO 30
          ENDIF
   10     CONTINUE
        ENDIF
        NUMI = NUMI+1
        INTS(NUMI) = ITMP
        ICNDX = NUMI
        RGB = REAL(ITMP)/255.
        COLVLS(1,NUMI) = RGB
        COLVLS(2,NUMI) = RGB
        COLVLS(3,NUMI) = RGB
        CALL GSCR(1,ICNDX,RGB,RGB,RGB)
   30   CONTINUE
        CALL PLOTIT(0,0,2)
        CURCOL = ICNDX
C
        CALL PLOTIT(0,0,2)
        CALL GSPLCI(ICNDX)
        CALL GSTXCI(ICNDX)
        CALL GSPMCI(ICNDX)
C
      ELSE IF (OPCODE .EQ. IORNT) THEN
C
C       IORNT MEANS SET CHARACTER ORIENTATION.
C       FIRST SKIP OVER A NULL BIT
        CALL MNINST(BYTE8,IOS,STATUS)
C
C       GET THE ORIENTATION VALUE
C
        CALL MNINST(W16,IOS,STATUS)
        MOR = OPCL
C
      ELSE IF (OPCODE .EQ. ISIZE) THEN
C
C       ISIZE MEANS TO SET THE CHARACTER SIZE
C       FIRST SKIP OVER A NULL BIT
        CALL MNINST(BYTE8,IOS,STATUS)
C
C       GET THE CHARACTER SIZE
C
        CALL MNINST(W16,IOS,STATUS)
        MSIZE = OPCL
C
      ELSE IF (OPCODE .EQ. IFONT) THEN
C
C       IFONT MEANS TO SET THE CHARACTER FONT (THE DEFAULT FONT IS
C       ALWAYS USED).
C
        CALL MNINST(BYTE8,IOS,STATUS)
        MFONT = 1
C
      ELSE IF (OPCODE .EQ. IPAT) THEN
C
C       IPAT MEANS TO SET THE DASH PATTERN
C       FIRST SKIP OVER A NULL BIT
        CALL MNINST(BYTE8,IOS,STATUS)
C
C       GET THE DASH PATTERN AND SET IT
C
        CALL MNINST(W16,IOS,STATUS)
        MDASH = OPCL
        CALL PLOTIT(0,0,2)
        CALL PATSET(MDASH)
C
      ELSE IF (OPCODE .EQ. ISSIZ) THEN
C
C       ISSIZ MEANS TO SET THE SPOT SIZE
C       FIRST SKIP OVER A NULL BIT
        CALL MNINST(BYTE8,IOS,STATUS)
C
C       GET THE SPOT SIZE CONVERT TO SCALE FACTOR AND SEND TO LINE WIDTH
C       PROCESSOR
C
        CALL MNINST(W16,IOS,STATUS)
        LINWTH = MAX(1.,FLOAT(OPCL) / 8.0)
        CALL PLOTIT(0,0,2)
        CALL GSLWSC(LINWTH)
C
      ELSE IF (OPCODE .EQ. ICENT) THEN
C
C       ICENT MEANS GET THE CHARACTER CENTERING OPTION
C       GET THE CENTERING OPTION
C
        CALL MNINST(BYTE8,IOS,STATUS)
        MCENT = OPCL
C
      ELSE IF (OPCODE .EQ.ICOLR) THEN
C
C       ICOLR MEANS SET THE COLOR OPTION
C
C       The color option has three bytes of information.
C
        CALL MNINST(BYTE8,IOS,STATUS)
        MCOLOR(1) = OPCL
        CALL MNINST(BYTE8,IOS,STATUS)
        MCOLOR(2) = OPCL
        CALL MNINST(BYTE8,IOS,STATUS)
        MCOLOR(3) = OPCL
C
C  First check to see if the three bytes describe a color index in the
C  range 000 to 999.  If so, set the current color index to that value.
C
        DO 110 I=1,3
C
C  Convert blanks to zeros.
C
          IF (CHAR(MCOLOR(I)) .EQ. ' ') MCOLOR(I) = ICHAR('0')
          DO 120 J=1,10
            IF (CHAR(MCOLOR(I)) .EQ. CINT(J)) THEN
              CINDX(I:I) = CHAR(MCOLOR(I))
              GO TO 110
            ENDIF
  120     CONTINUE
          GO TO 150
  110   CONTINUE
        READ(CINDX,501) CURCOL
        GO TO 160
C
C  Check if the color matches a pre-defined one.
C
  150   CONTINUE
        DO 130 I=1,3
          CINDX(I:I) = CHAR(MCOLOR(I))
  130   CONTINUE
        DO 140 I=1,16
          IF (CINDX .EQ. CVAL(I)) THEN
C
C  Check if this color has been previously used.
C
            IF (CUSED(I) .EQ. 0) THEN
C
C             Not used, define new color index.
C
              NUMI = NUMI+1
              CUSED(I) = NUMI
              COLVLS(1,NUMI) = RGBV(1,I)
              COLVLS(2,NUMI) = RGBV(2,I)
              COLVLS(3,NUMI) = RGBV(3,I)
              CALL GSCR(1,NUMI,RGBV(1,I),RGBV(2,I),RGBV(3,I))
              CURCOL = NUMI
            ELSE
              CURCOL = CUSED(I)
            ENDIF
            GO TO 160
          ENDIF
  140   CONTINUE
C
C  No match, default to foreground color.
C
        CURCOL = 1
C
C       SET COLORS
C
  160   CONTINUE
        CALL PLOTIT(0,0,2)
        CALL GSTXCI(CURCOL)
        CALL GSPLCI(CURCOL)
        CALL GSPMCI(CURCOL)
C
      ELSE
C
C       UNDEFINED OPCODE
C
        WRITE(6,'('' Unknown option in OPTN call'')')
C
C       READ IN REMAINDER OF OPCODES OPERANDS
C
        NSKIP = (OCOUNT-1)/2
        CALL MNINST(BYTE8,IOS,STATUS)
        IF (NSKIP.EQ.0) GO TO 500
        DO 200 K=1,NSKIP
                CALL MNINST(W16,IOS,STATUS)
                IF (STATUS.NE.ALLOK) RETURN
  200   CONTINUE
C
  500   CONTINUE
      END IF
C
      RETURN
C
  501 FORMAT(I3)
C
      END

C
C       $Id: velvec.f,v 1.6 2008-07-27 00:17:34 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE VELVEC (U,LU,V,LV,M,N,FLO,HI,NSET,ISPV,SPV)
C
C THIS ROUTINE SUPPORTS USERS OF THE OLD VERSION OF THIS PACKAGE.
C
      DIMENSION       U(LU,N)    ,V(LV,N)    ,SPV(2)
C
      CALL VELVCT (U,LU,V,LV,M,N,FLO,HI,NSET,0,ISPV,SPV)
C
      RETURN
      END

      SUBROUTINE DGBSVX( FACT, TRANS, N, KL, KU, NRHS, AB, LDAB, AFB,
     $                   LDAFB, IPIV, EQUED, R, C, B, LDB, X, LDX,
     $                   RCOND, FERR, BERR, WORK, IWORK, INFO )
*
*  -- LAPACK driver routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          EQUED, FACT, TRANS
      INTEGER            INFO, KL, KU, LDAB, LDAFB, LDB, LDX, N, NRHS
      DOUBLE PRECISION   RCOND
*     ..
*     .. Array Arguments ..
      INTEGER            IPIV( * ), IWORK( * )
      DOUBLE PRECISION   AB( LDAB, * ), AFB( LDAFB, * ), B( LDB, * ),
     $                   BERR( * ), C( * ), FERR( * ), R( * ),
     $                   WORK( * ), X( LDX, * )
*     ..
*
*  Purpose
*  =======
*
*  DGBSVX uses the LU factorization to compute the solution to a real
*  system of linear equations A * X = B, A**T * X = B, or A**H * X = B,
*  where A is a band matrix of order N with KL subdiagonals and KU
*  superdiagonals, and X and B are N-by-NRHS matrices.
*
*  Error bounds on the solution and a condition estimate are also
*  provided.
*
*  Description
*  ===========
*
*  The following steps are performed by this subroutine:
*
*  1. If FACT = 'E', real scaling factors are computed to equilibrate
*     the system:
*        TRANS = 'N':  diag(R)*A*diag(C)     *inv(diag(C))*X = diag(R)*B
*        TRANS = 'T': (diag(R)*A*diag(C))**T *inv(diag(R))*X = diag(C)*B
*        TRANS = 'C': (diag(R)*A*diag(C))**H *inv(diag(R))*X = diag(C)*B
*     Whether or not the system will be equilibrated depends on the
*     scaling of the matrix A, but if equilibration is used, A is
*     overwritten by diag(R)*A*diag(C) and B by diag(R)*B (if TRANS='N')
*     or diag(C)*B (if TRANS = 'T' or 'C').
*
*  2. If FACT = 'N' or 'E', the LU decomposition is used to factor the
*     matrix A (after equilibration if FACT = 'E') as
*        A = L * U,
*     where L is a product of permutation and unit lower triangular
*     matrices with KL subdiagonals, and U is upper triangular with
*     KL+KU superdiagonals.
*
*  3. If some U(i,i)=0, so that U is exactly singular, then the routine
*     returns with INFO = i. Otherwise, the factored form of A is used
*     to estimate the condition number of the matrix A.  If the
*     reciprocal of the condition number is less than machine precision,
*     INFO = N+1 is returned as a warning, but the routine still goes on
*     to solve for X and compute error bounds as described below.
*
*  4. The system of equations is solved for X using the factored form
*     of A.
*
*  5. Iterative refinement is applied to improve the computed solution
*     matrix and calculate error bounds and backward error estimates
*     for it.
*
*  6. If equilibration was used, the matrix X is premultiplied by
*     diag(C) (if TRANS = 'N') or diag(R) (if TRANS = 'T' or 'C') so
*     that it solves the original system before equilibration.
*
*  Arguments
*  =========
*
*  FACT    (input) CHARACTER*1
*          Specifies whether or not the factored form of the matrix A is
*          supplied on entry, and if not, whether the matrix A should be
*          equilibrated before it is factored.
*          = 'F':  On entry, AFB and IPIV contain the factored form of
*                  A.  If EQUED is not 'N', the matrix A has been
*                  equilibrated with scaling factors given by R and C.
*                  AB, AFB, and IPIV are not modified.
*          = 'N':  The matrix A will be copied to AFB and factored.
*          = 'E':  The matrix A will be equilibrated if necessary, then
*                  copied to AFB and factored.
*
*  TRANS   (input) CHARACTER*1
*          Specifies the form of the system of equations.
*          = 'N':  A * X = B     (No transpose)
*          = 'T':  A**T * X = B  (Transpose)
*          = 'C':  A**H * X = B  (Transpose)
*
*  N       (input) INTEGER
*          The number of linear equations, i.e., the order of the
*          matrix A.  N >= 0.
*
*  KL      (input) INTEGER
*          The number of subdiagonals within the band of A.  KL >= 0.
*
*  KU      (input) INTEGER
*          The number of superdiagonals within the band of A.  KU >= 0.
*
*  NRHS    (input) INTEGER
*          The number of right hand sides, i.e., the number of columns
*          of the matrices B and X.  NRHS >= 0.
*
*  AB      (input/output) DOUBLE PRECISION array, dimension (LDAB,N)
*          On entry, the matrix A in band storage, in rows 1 to KL+KU+1.
*          The j-th column of A is stored in the j-th column of the
*          array AB as follows:
*          AB(KU+1+i-j,j) = A(i,j) for max(1,j-KU)<=i<=min(N,j+kl)
*
*          If FACT = 'F' and EQUED is not 'N', then A must have been
*          equilibrated by the scaling factors in R and/or C.  AB is not
*          modified if FACT = 'F' or 'N', or if FACT = 'E' and
*          EQUED = 'N' on exit.
*
*          On exit, if EQUED .ne. 'N', A is scaled as follows:
*          EQUED = 'R':  A := diag(R) * A
*          EQUED = 'C':  A := A * diag(C)
*          EQUED = 'B':  A := diag(R) * A * diag(C).
*
*  LDAB    (input) INTEGER
*          The leading dimension of the array AB.  LDAB >= KL+KU+1.
*
*  AFB     (input or output) DOUBLE PRECISION array, dimension (LDAFB,N)
*          If FACT = 'F', then AFB is an input argument and on entry
*          contains details of the LU factorization of the band matrix
*          A, as computed by DGBTRF.  U is stored as an upper triangular
*          band matrix with KL+KU superdiagonals in rows 1 to KL+KU+1,
*          and the multipliers used during the factorization are stored
*          in rows KL+KU+2 to 2*KL+KU+1.  If EQUED .ne. 'N', then AFB is
*          the factored form of the equilibrated matrix A.
*
*          If FACT = 'N', then AFB is an output argument and on exit
*          returns details of the LU factorization of A.
*
*          If FACT = 'E', then AFB is an output argument and on exit
*          returns details of the LU factorization of the equilibrated
*          matrix A (see the description of AB for the form of the
*          equilibrated matrix).
*
*  LDAFB   (input) INTEGER
*          The leading dimension of the array AFB.  LDAFB >= 2*KL+KU+1.
*
*  IPIV    (input or output) INTEGER array, dimension (N)
*          If FACT = 'F', then IPIV is an input argument and on entry
*          contains the pivot indices from the factorization A = L*U
*          as computed by DGBTRF; row i of the matrix was interchanged
*          with row IPIV(i).
*
*          If FACT = 'N', then IPIV is an output argument and on exit
*          contains the pivot indices from the factorization A = L*U
*          of the original matrix A.
*
*          If FACT = 'E', then IPIV is an output argument and on exit
*          contains the pivot indices from the factorization A = L*U
*          of the equilibrated matrix A.
*
*  EQUED   (input or output) CHARACTER*1
*          Specifies the form of equilibration that was done.
*          = 'N':  No equilibration (always true if FACT = 'N').
*          = 'R':  Row equilibration, i.e., A has been premultiplied by
*                  diag(R).
*          = 'C':  Column equilibration, i.e., A has been postmultiplied
*                  by diag(C).
*          = 'B':  Both row and column equilibration, i.e., A has been
*                  replaced by diag(R) * A * diag(C).
*          EQUED is an input argument if FACT = 'F'; otherwise, it is an
*          output argument.
*
*  R       (input or output) DOUBLE PRECISION array, dimension (N)
*          The row scale factors for A.  If EQUED = 'R' or 'B', A is
*          multiplied on the left by diag(R); if EQUED = 'N' or 'C', R
*          is not accessed.  R is an input argument if FACT = 'F';
*          otherwise, R is an output argument.  If FACT = 'F' and
*          EQUED = 'R' or 'B', each element of R must be positive.
*
*  C       (input or output) DOUBLE PRECISION array, dimension (N)
*          The column scale factors for A.  If EQUED = 'C' or 'B', A is
*          multiplied on the right by diag(C); if EQUED = 'N' or 'R', C
*          is not accessed.  C is an input argument if FACT = 'F';
*          otherwise, C is an output argument.  If FACT = 'F' and
*          EQUED = 'C' or 'B', each element of C must be positive.
*
*  B       (input/output) DOUBLE PRECISION array, dimension (LDB,NRHS)
*          On entry, the right hand side matrix B.
*          On exit,
*          if EQUED = 'N', B is not modified;
*          if TRANS = 'N' and EQUED = 'R' or 'B', B is overwritten by
*          diag(R)*B;
*          if TRANS = 'T' or 'C' and EQUED = 'C' or 'B', B is
*          overwritten by diag(C)*B.
*
*  LDB     (input) INTEGER
*          The leading dimension of the array B.  LDB >= max(1,N).
*
*  X       (output) DOUBLE PRECISION array, dimension (LDX,NRHS)
*          If INFO = 0 or INFO = N+1, the N-by-NRHS solution matrix X
*          to the original system of equations.  Note that A and B are
*          modified on exit if EQUED .ne. 'N', and the solution to the
*          equilibrated system is inv(diag(C))*X if TRANS = 'N' and
*          EQUED = 'C' or 'B', or inv(diag(R))*X if TRANS = 'T' or 'C'
*          and EQUED = 'R' or 'B'.
*
*  LDX     (input) INTEGER
*          The leading dimension of the array X.  LDX >= max(1,N).
*
*  RCOND   (output) DOUBLE PRECISION
*          The estimate of the reciprocal condition number of the matrix
*          A after equilibration (if done).  If RCOND is less than the
*          machine precision (in particular, if RCOND = 0), the matrix
*          is singular to working precision.  This condition is
*          indicated by a return code of INFO > 0.
*
*  FERR    (output) DOUBLE PRECISION array, dimension (NRHS)
*          The estimated forward error bound for each solution vector
*          X(j) (the j-th column of the solution matrix X).
*          If XTRUE is the true solution corresponding to X(j), FERR(j)
*          is an estimated upper bound for the magnitude of the largest
*          element in (X(j) - XTRUE) divided by the magnitude of the
*          largest element in X(j).  The estimate is as reliable as
*          the estimate for RCOND, and is almost always a slight
*          overestimate of the true error.
*
*  BERR    (output) DOUBLE PRECISION array, dimension (NRHS)
*          The componentwise relative backward error of each solution
*          vector X(j) (i.e., the smallest relative change in
*          any element of A or B that makes X(j) an exact solution).
*
*  WORK    (workspace/output) DOUBLE PRECISION array, dimension (3*N)
*          On exit, WORK(1) contains the reciprocal pivot growth
*          factor norm(A)/norm(U). The "max absolute element" norm is
*          used. If WORK(1) is much less than 1, then the stability
*          of the LU factorization of the (equilibrated) matrix A
*          could be poor. This also means that the solution X, condition
*          estimator RCOND, and forward error bound FERR could be
*          unreliable. If factorization fails with 0<INFO<=N, then
*          WORK(1) contains the reciprocal pivot growth factor for the
*          leading INFO columns of A.
*
*  IWORK   (workspace) INTEGER array, dimension (N)
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*          > 0:  if INFO = i, and i is
*                <= N:  U(i,i) is exactly zero.  The factorization
*                       has been completed, but the factor U is exactly
*                       singular, so the solution and error bounds
*                       could not be computed. RCOND = 0 is returned.
*                = N+1: U is nonsingular, but RCOND is less than machine
*                       precision, meaning that the matrix is singular
*                       to working precision.  Nevertheless, the
*                       solution and error bounds are computed because
*                       there are a number of situations where the
*                       computed solution can be more accurate than the
*                       value of RCOND would suggest.
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO, ONE
      PARAMETER          ( ZERO = 0.0D+0, ONE = 1.0D+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            COLEQU, EQUIL, NOFACT, NOTRAN, ROWEQU
      CHARACTER          NORM
      INTEGER            I, INFEQU, J, J1, J2
      DOUBLE PRECISION   AMAX, ANORM, BIGNUM, COLCND, RCMAX, RCMIN,
     $                   ROWCND, RPVGRW, SMLNUM
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      DOUBLE PRECISION   DLAMCH, DLANGB, DLANTB
      EXTERNAL           LSAME, DLAMCH, DLANGB, DLANTB
*     ..
*     .. External Subroutines ..
      EXTERNAL           DCOPY, DGBCON, DGBEQU, DGBRFS, DGBTRF, DGBTRS,
     $                   DLACPY, DLAQGB, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, MAX, MIN
*     ..
*     .. Executable Statements ..
*
      INFO = 0
      NOFACT = LSAME( FACT, 'N' )
      EQUIL = LSAME( FACT, 'E' )
      NOTRAN = LSAME( TRANS, 'N' )
      IF( NOFACT .OR. EQUIL ) THEN
         EQUED = 'N'
         ROWEQU = .FALSE.
         COLEQU = .FALSE.
      ELSE
         ROWEQU = LSAME( EQUED, 'R' ) .OR. LSAME( EQUED, 'B' )
         COLEQU = LSAME( EQUED, 'C' ) .OR. LSAME( EQUED, 'B' )
         SMLNUM = DLAMCH( 'Safe minimum' )
         BIGNUM = ONE / SMLNUM
      END IF
*
*     Test the input parameters.
*
      IF( .NOT.NOFACT .AND. .NOT.EQUIL .AND. .NOT.LSAME( FACT, 'F' ) )
     $     THEN
         INFO = -1
      ELSE IF( .NOT.NOTRAN .AND. .NOT.LSAME( TRANS, 'T' ) .AND. .NOT.
     $         LSAME( TRANS, 'C' ) ) THEN
         INFO = -2
      ELSE IF( N.LT.0 ) THEN
         INFO = -3
      ELSE IF( KL.LT.0 ) THEN
         INFO = -4
      ELSE IF( KU.LT.0 ) THEN
         INFO = -5
      ELSE IF( NRHS.LT.0 ) THEN
         INFO = -6
      ELSE IF( LDAB.LT.KL+KU+1 ) THEN
         INFO = -8
      ELSE IF( LDAFB.LT.2*KL+KU+1 ) THEN
         INFO = -10
      ELSE IF( LSAME( FACT, 'F' ) .AND. .NOT.
     $         ( ROWEQU .OR. COLEQU .OR. LSAME( EQUED, 'N' ) ) ) THEN
         INFO = -12
      ELSE
         IF( ROWEQU ) THEN
            RCMIN = BIGNUM
            RCMAX = ZERO
            DO 10 J = 1, N
               RCMIN = MIN( RCMIN, R( J ) )
               RCMAX = MAX( RCMAX, R( J ) )
   10       CONTINUE
            IF( RCMIN.LE.ZERO ) THEN
               INFO = -13
            ELSE IF( N.GT.0 ) THEN
               ROWCND = MAX( RCMIN, SMLNUM ) / MIN( RCMAX, BIGNUM )
            ELSE
               ROWCND = ONE
            END IF
         END IF
         IF( COLEQU .AND. INFO.EQ.0 ) THEN
            RCMIN = BIGNUM
            RCMAX = ZERO
            DO 20 J = 1, N
               RCMIN = MIN( RCMIN, C( J ) )
               RCMAX = MAX( RCMAX, C( J ) )
   20       CONTINUE
            IF( RCMIN.LE.ZERO ) THEN
               INFO = -14
            ELSE IF( N.GT.0 ) THEN
               COLCND = MAX( RCMIN, SMLNUM ) / MIN( RCMAX, BIGNUM )
            ELSE
               COLCND = ONE
            END IF
         END IF
         IF( INFO.EQ.0 ) THEN
            IF( LDB.LT.MAX( 1, N ) ) THEN
               INFO = -16
            ELSE IF( LDX.LT.MAX( 1, N ) ) THEN
               INFO = -18
            END IF
         END IF
      END IF
*
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DGBSVX', -INFO )
         RETURN
      END IF
*
      IF( EQUIL ) THEN
*
*        Compute row and column scalings to equilibrate the matrix A.
*
         CALL DGBEQU( N, N, KL, KU, AB, LDAB, R, C, ROWCND, COLCND,
     $                AMAX, INFEQU )
         IF( INFEQU.EQ.0 ) THEN
*
*           Equilibrate the matrix.
*
            CALL DLAQGB( N, N, KL, KU, AB, LDAB, R, C, ROWCND, COLCND,
     $                   AMAX, EQUED )
            ROWEQU = LSAME( EQUED, 'R' ) .OR. LSAME( EQUED, 'B' )
            COLEQU = LSAME( EQUED, 'C' ) .OR. LSAME( EQUED, 'B' )
         END IF
      END IF
*
*     Scale the right hand side.
*
      IF( NOTRAN ) THEN
         IF( ROWEQU ) THEN
            DO 40 J = 1, NRHS
               DO 30 I = 1, N
                  B( I, J ) = R( I )*B( I, J )
   30          CONTINUE
   40       CONTINUE
         END IF
      ELSE IF( COLEQU ) THEN
         DO 60 J = 1, NRHS
            DO 50 I = 1, N
               B( I, J ) = C( I )*B( I, J )
   50       CONTINUE
   60    CONTINUE
      END IF
*
      IF( NOFACT .OR. EQUIL ) THEN
*
*        Compute the LU factorization of the band matrix A.
*
         DO 70 J = 1, N
            J1 = MAX( J-KU, 1 )
            J2 = MIN( J+KL, N )
            CALL DCOPY( J2-J1+1, AB( KU+1-J+J1, J ), 1,
     $                  AFB( KL+KU+1-J+J1, J ), 1 )
   70    CONTINUE
*
         CALL DGBTRF( N, N, KL, KU, AFB, LDAFB, IPIV, INFO )
*
*        Return if INFO is non-zero.
*
         IF( INFO.NE.0 ) THEN
            IF( INFO.GT.0 ) THEN
*
*              Compute the reciprocal pivot growth factor of the
*              leading rank-deficient INFO columns of A.
*
               ANORM = ZERO
               DO 90 J = 1, INFO
                  DO 80 I = MAX( KU+2-J, 1 ),
     $                    MIN( N+KU+1-J, KL+KU+1 )
                     ANORM = MAX( ANORM, ABS( AB( I, J ) ) )
   80             CONTINUE
   90          CONTINUE
               RPVGRW = DLANTB( 'M', 'U', 'N', INFO,
     $                  MIN( INFO-1, KL+KU ), AFB( MAX( 1,
     $                  KL+KU+2-INFO ), 1 ), LDAFB, WORK )
               IF( RPVGRW.EQ.ZERO ) THEN
                  RPVGRW = ONE
               ELSE
                  RPVGRW = ANORM / RPVGRW
               END IF
               WORK( 1 ) = RPVGRW
               RCOND = ZERO
            END IF
            RETURN
         END IF
      END IF
*
*     Compute the norm of the matrix A and the
*     reciprocal pivot growth factor RPVGRW.
*
      IF( NOTRAN ) THEN
         NORM = '1'
      ELSE
         NORM = 'I'
      END IF
      ANORM = DLANGB( NORM, N, KL, KU, AB, LDAB, WORK )
      RPVGRW = DLANTB( 'M', 'U', 'N', N, KL+KU, AFB, LDAFB, WORK )
      IF( RPVGRW.EQ.ZERO ) THEN
         RPVGRW = ONE
      ELSE
         RPVGRW = DLANGB( 'M', N, KL, KU, AB, LDAB, WORK ) / RPVGRW
      END IF
*
*     Compute the reciprocal of the condition number of A.
*
      CALL DGBCON( NORM, N, KL, KU, AFB, LDAFB, IPIV, ANORM, RCOND,
     $             WORK, IWORK, INFO )
*
*     Set INFO = N+1 if the matrix is singular to working precision.
*
      IF( RCOND.LT.DLAMCH( 'Epsilon' ) )
     $   INFO = N + 1
*
*     Compute the solution matrix X.
*
      CALL DLACPY( 'Full', N, NRHS, B, LDB, X, LDX )
      CALL DGBTRS( TRANS, N, KL, KU, NRHS, AFB, LDAFB, IPIV, X, LDX,
     $             INFO )
*
*     Use iterative refinement to improve the computed solution and
*     compute error bounds and backward error estimates for it.
*
      CALL DGBRFS( TRANS, N, KL, KU, NRHS, AB, LDAB, AFB, LDAFB, IPIV,
     $             B, LDB, X, LDX, FERR, BERR, WORK, IWORK, INFO )
*
*     Transform the solution matrix X to a solution of the original
*     system.
*
      IF( NOTRAN ) THEN
         IF( COLEQU ) THEN
            DO 110 J = 1, NRHS
               DO 100 I = 1, N
                  X( I, J ) = C( I )*X( I, J )
  100          CONTINUE
  110       CONTINUE
            DO 120 J = 1, NRHS
               FERR( J ) = FERR( J ) / COLCND
  120       CONTINUE
         END IF
      ELSE IF( ROWEQU ) THEN
         DO 140 J = 1, NRHS
            DO 130 I = 1, N
               X( I, J ) = R( I )*X( I, J )
  130       CONTINUE
  140    CONTINUE
         DO 150 J = 1, NRHS
            FERR( J ) = FERR( J ) / ROWCND
  150    CONTINUE
      END IF
*
      WORK( 1 ) = RPVGRW
      RETURN
*
*     End of DGBSVX
*
      END

      SUBROUTINE SGTTRS( TRANS, N, NRHS, DL, D, DU, DU2, IPIV, B, LDB,
     $                   INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          TRANS
      INTEGER            INFO, LDB, N, NRHS
*     ..
*     .. Array Arguments ..
      INTEGER            IPIV( * )
      REAL               B( LDB, * ), D( * ), DL( * ), DU( * ), DU2( * )
*     ..
*
*  Purpose
*  =======
*
*  SGTTRS solves one of the systems of equations
*     A*X = B  or  A'*X = B,
*  with a tridiagonal matrix A using the LU factorization computed
*  by SGTTRF.
*
*  Arguments
*  =========
*
*  TRANS   (input) CHARACTER
*          Specifies the form of the system of equations.
*          = 'N':  A * X = B  (No transpose)
*          = 'T':  A'* X = B  (Transpose)
*          = 'C':  A'* X = B  (Conjugate transpose = Transpose)
*
*  N       (input) INTEGER
*          The order of the matrix A.
*
*  NRHS    (input) INTEGER
*          The number of right hand sides, i.e., the number of columns
*          of the matrix B.  NRHS >= 0.
*
*  DL      (input) REAL array, dimension (N-1)
*          The (n-1) multipliers that define the matrix L from the
*          LU factorization of A.
*
*  D       (input) REAL array, dimension (N)
*          The n diagonal elements of the upper triangular matrix U from
*          the LU factorization of A.
*
*  DU      (input) REAL array, dimension (N-1)
*          The (n-1) elements of the first super-diagonal of U.
*
*  DU2     (input) REAL array, dimension (N-2)
*          The (n-2) elements of the second super-diagonal of U.
*
*  IPIV    (input) INTEGER array, dimension (N)
*          The pivot indices; for 1 <= i <= n, row i of the matrix was
*          interchanged with row IPIV(i).  IPIV(i) will always be either
*          i or i+1; IPIV(i) = i indicates a row interchange was not
*          required.
*
*  B       (input/output) REAL array, dimension (LDB,NRHS)
*          On entry, the matrix of right hand side vectors B.
*          On exit, B is overwritten by the solution vectors X.
*
*  LDB     (input) INTEGER
*          The leading dimension of the array B.  LDB >= max(1,N).
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*
*  =====================================================================
*
*     .. Local Scalars ..
      LOGICAL            NOTRAN
      INTEGER            ITRANS, J, JB, NB
*     ..
*     .. External Functions ..
      INTEGER            ILAENV
      EXTERNAL           ILAENV
*     ..
*     .. External Subroutines ..
      EXTERNAL           SGTTS2, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN
*     ..
*     .. Executable Statements ..
*
      INFO = 0
      NOTRAN = ( TRANS.EQ.'N' .OR. TRANS.EQ.'n' )
      IF( .NOT.NOTRAN .AND. .NOT.( TRANS.EQ.'T' .OR. TRANS.EQ.
     $    't' ) .AND. .NOT.( TRANS.EQ.'C' .OR. TRANS.EQ.'c' ) ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( NRHS.LT.0 ) THEN
         INFO = -3
      ELSE IF( LDB.LT.MAX( N, 1 ) ) THEN
         INFO = -10
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'SGTTRS', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 .OR. NRHS.EQ.0 )
     $   RETURN
*
*     Decode TRANS
*
      IF( NOTRAN ) THEN
         ITRANS = 0
      ELSE
         ITRANS = 1
      END IF
*
*     Determine the number of right-hand sides to solve at a time.
*
      IF( NRHS.EQ.1 ) THEN
         NB = 1
      ELSE
         NB = MAX( 1, ILAENV( 1, 'SGTTRS', TRANS, N, NRHS, -1, -1 ) )
      END IF
*
      IF( NB.GE.NRHS ) THEN
         CALL SGTTS2( ITRANS, N, NRHS, DL, D, DU, DU2, IPIV, B, LDB )
      ELSE
         DO 10 J = 1, NRHS, NB
            JB = MIN( NRHS-J+1, NB )
            CALL SGTTS2( ITRANS, N, JB, DL, D, DU, DU2, IPIV, B( 1, J ),
     $                   LDB )
   10    CONTINUE
      END IF
*
*     End of SGTTRS
*
      END

      PROGRAM CCPCLD
C 
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER (K=40,N=40,LRWK=1000,LIWK=1000)
      REAL Z(K,N), RWRK(LRWK)
      INTEGER I, M, IWRK(LIWK),IBTS (16,7)
      
      DATA IBTS / 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 1, 
     1     1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0,
     2     1, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 0,
     3     1, 1, 1, 0, 1, 1, 1, 0, 1, 1, 1, 0, 1, 1, 1, 0,
     4     1, 1, 1, 1, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0,
     5     1, 1, 1, 1, 0, 1, 1, 1, 0, 0, 1, 1, 0, 0, 0, 1,
     6     1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 /
      
      CALL GETDAT (Z, K, M, N) 
C 
C Open GKS, open and activate a workstation.
C 
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Choose the number of contour levels
C
      CALL CPSETI('CLS - CONTOUR LEVEL SELECTION FLAG',-7)
      
C Call conpack normally
      CALL CPRECT(Z,K,M,N,RWRK,LRWK,IWRK,LIWK)
      CALL CPPKCL(Z, RWRK, IWRK)
C Set a different dash pattern for each contour line
      CALL CPGETI('NCL - NUMBER OF CONTOUR LEVELS',NOCL)
      DO 11, I=1,NOCL 
         CALL CPSETI('PAI - PARAMETER ARRAY INDEX',I)
         CALL CPSETI('CLD - CONTOUR LINE DASH PATTERN',
     +        IPAT(IBTS(1,I)))
 11   CONTINUE
      
      CALL CPBACK(Z, RWRK, IWRK)
      CALL CPCLDR(Z,RWRK,IWRK)
C      
C Close frame and close GKS
C
      CALL FRAME
C 
C Deactivate and close workstation, close GKS.
C 
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      
      STOP
      END
      
      SUBROUTINE GETDAT (Z, K, M, N)
      INTEGER I,J,K,M,N
      REAL Z(K,N)
      
      M=K
      DO 10, I=1,M
         DO 20, J=1,N
            Z(I,J)= 10.E-5*(-16.*REAL(I**2*J) +
     +           34*REAL(I*J**2) - REAL(6*I) + 93.)
 20      CONTINUE
 10   CONTINUE
      
      RETURN
      END
      
      INTEGER FUNCTION IPAT (IBTS)
      DIMENSION IBTS(16)
      
      IPAT=0
      DO 101 I=1,16
         IPAT=IOR(ISHIFT(IPAT,1),IBTS(I))
 101  CONTINUE
      
      RETURN
      END

      SUBROUTINE ZLAED8( K, N, QSIZ, Q, LDQ, D, RHO, CUTPNT, Z, DLAMDA,
     $                   Q2, LDQ2, W, INDXP, INDX, INDXQ, PERM, GIVPTR,
     $                   GIVCOL, GIVNUM, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Oak Ridge National Lab, Argonne National Lab,
*     Courant Institute, NAG Ltd., and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      INTEGER            CUTPNT, GIVPTR, INFO, K, LDQ, LDQ2, N, QSIZ
      DOUBLE PRECISION   RHO
*     ..
*     .. Array Arguments ..
      INTEGER            GIVCOL( 2, * ), INDX( * ), INDXP( * ),
     $                   INDXQ( * ), PERM( * )
      DOUBLE PRECISION   D( * ), DLAMDA( * ), GIVNUM( 2, * ), W( * ),
     $                   Z( * )
      COMPLEX*16         Q( LDQ, * ), Q2( LDQ2, * )
*     ..
*
*  Purpose
*  =======
*
*  ZLAED8 merges the two sets of eigenvalues together into a single
*  sorted set.  Then it tries to deflate the size of the problem.
*  There are two ways in which deflation can occur:  when two or more
*  eigenvalues are close together or if there is a tiny element in the
*  Z vector.  For each such occurrence the order of the related secular
*  equation problem is reduced by one.
*
*  Arguments
*  =========
*
*  K      (output) INTEGER
*         Contains the number of non-deflated eigenvalues.
*         This is the order of the related secular equation.
*
*  N      (input) INTEGER
*         The dimension of the symmetric tridiagonal matrix.  N >= 0.
*
*  QSIZ   (input) INTEGER
*         The dimension of the unitary matrix used to reduce
*         the dense or band matrix to tridiagonal form.
*         QSIZ >= N if ICOMPQ = 1.
*
*  Q      (input/output) COMPLEX*16 array, dimension (LDQ,N)
*         On entry, Q contains the eigenvectors of the partially solved
*         system which has been previously updated in matrix
*         multiplies with other partially solved eigensystems.
*         On exit, Q contains the trailing (N-K) updated eigenvectors
*         (those which were deflated) in its last N-K columns.
*
*  LDQ    (input) INTEGER
*         The leading dimension of the array Q.  LDQ >= max( 1, N ).
*
*  D      (input/output) DOUBLE PRECISION array, dimension (N)
*         On entry, D contains the eigenvalues of the two submatrices to
*         be combined.  On exit, D contains the trailing (N-K) updated
*         eigenvalues (those which were deflated) sorted into increasing
*         order.
*
*  RHO    (input/output) DOUBLE PRECISION
*         Contains the off diagonal element associated with the rank-1
*         cut which originally split the two submatrices which are now
*         being recombined. RHO is modified during the computation to
*         the value required by DLAED3.
*
*  CUTPNT (input) INTEGER
*         Contains the location of the last eigenvalue in the leading
*         sub-matrix.  MIN(1,N) <= CUTPNT <= N.
*
*  Z      (input) DOUBLE PRECISION array, dimension (N)
*         On input this vector contains the updating vector (the last
*         row of the first sub-eigenvector matrix and the first row of
*         the second sub-eigenvector matrix).  The contents of Z are
*         destroyed during the updating process.
*
*  DLAMDA (output) DOUBLE PRECISION array, dimension (N)
*         Contains a copy of the first K eigenvalues which will be used
*         by DLAED3 to form the secular equation.
*
*  Q2     (output) COMPLEX*16 array, dimension (LDQ2,N)
*         If ICOMPQ = 0, Q2 is not referenced.  Otherwise,
*         Contains a copy of the first K eigenvectors which will be used
*         by DLAED7 in a matrix multiply (DGEMM) to update the new
*         eigenvectors.
*
*  LDQ2   (input) INTEGER
*         The leading dimension of the array Q2.  LDQ2 >= max( 1, N ).
*
*  W      (output) DOUBLE PRECISION array, dimension (N)
*         This will hold the first k values of the final
*         deflation-altered z-vector and will be passed to DLAED3.
*
*  INDXP  (workspace) INTEGER array, dimension (N)
*         This will contain the permutation used to place deflated
*         values of D at the end of the array. On output INDXP(1:K)
*         points to the nondeflated D-values and INDXP(K+1:N)
*         points to the deflated eigenvalues.
*
*  INDX   (workspace) INTEGER array, dimension (N)
*         This will contain the permutation used to sort the contents of
*         D into ascending order.
*
*  INDXQ  (input) INTEGER array, dimension (N)
*         This contains the permutation which separately sorts the two
*         sub-problems in D into ascending order.  Note that elements in
*         the second half of this permutation must first have CUTPNT
*         added to their values in order to be accurate.
*
*  PERM   (output) INTEGER array, dimension (N)
*         Contains the permutations (from deflation and sorting) to be
*         applied to each eigenblock.
*
*  GIVPTR (output) INTEGER
*         Contains the number of Givens rotations which took place in
*         this subproblem.
*
*  GIVCOL (output) INTEGER array, dimension (2, N)
*         Each pair of numbers indicates a pair of columns to take place
*         in a Givens rotation.
*
*  GIVNUM (output) DOUBLE PRECISION array, dimension (2, N)
*         Each number indicates the S value to be used in the
*         corresponding Givens rotation.
*
*  INFO   (output) INTEGER
*          = 0:  successful exit.
*          < 0:  if INFO = -i, the i-th argument had an illegal value.
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   MONE, ZERO, ONE, TWO, EIGHT
      PARAMETER          ( MONE = -1.0D0, ZERO = 0.0D0, ONE = 1.0D0,
     $                   TWO = 2.0D0, EIGHT = 8.0D0 )
*     ..
*     .. Local Scalars ..
      INTEGER            I, IMAX, J, JLAM, JMAX, JP, K2, N1, N1P1, N2
      DOUBLE PRECISION   C, EPS, S, T, TAU, TOL
*     ..
*     .. External Functions ..
      INTEGER            IDAMAX
      DOUBLE PRECISION   DLAMCH, DLAPY2
      EXTERNAL           IDAMAX, DLAMCH, DLAPY2
*     ..
*     .. External Subroutines ..
      EXTERNAL           DCOPY, DLAMRG, DSCAL, XERBLA, ZCOPY, ZDROT,
     $                   ZLACPY
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, MAX, MIN, SQRT
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
*
      IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( QSIZ.LT.N ) THEN
         INFO = -3
      ELSE IF( LDQ.LT.MAX( 1, N ) ) THEN
         INFO = -5
      ELSE IF( CUTPNT.LT.MIN( 1, N ) .OR. CUTPNT.GT.N ) THEN
         INFO = -8
      ELSE IF( LDQ2.LT.MAX( 1, N ) ) THEN
         INFO = -12
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'ZLAED8', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
*
      N1 = CUTPNT
      N2 = N - N1
      N1P1 = N1 + 1
*
      IF( RHO.LT.ZERO ) THEN
         CALL DSCAL( N2, MONE, Z( N1P1 ), 1 )
      END IF
*
*     Normalize z so that norm(z) = 1
*
      T = ONE / SQRT( TWO )
      DO 10 J = 1, N
         INDX( J ) = J
   10 CONTINUE
      CALL DSCAL( N, T, Z, 1 )
      RHO = ABS( TWO*RHO )
*
*     Sort the eigenvalues into increasing order
*
      DO 20 I = CUTPNT + 1, N
         INDXQ( I ) = INDXQ( I ) + CUTPNT
   20 CONTINUE
      DO 30 I = 1, N
         DLAMDA( I ) = D( INDXQ( I ) )
         W( I ) = Z( INDXQ( I ) )
   30 CONTINUE
      I = 1
      J = CUTPNT + 1
      CALL DLAMRG( N1, N2, DLAMDA, 1, 1, INDX )
      DO 40 I = 1, N
         D( I ) = DLAMDA( INDX( I ) )
         Z( I ) = W( INDX( I ) )
   40 CONTINUE
*
*     Calculate the allowable deflation tolerance
*
      IMAX = IDAMAX( N, Z, 1 )
      JMAX = IDAMAX( N, D, 1 )
      EPS = DLAMCH( 'Epsilon' )
      TOL = EIGHT*EPS*ABS( D( JMAX ) )
*
*     If the rank-1 modifier is small enough, no more needs to be done
*     -- except to reorganize Q so that its columns correspond with the
*     elements in D.
*
      IF( RHO*ABS( Z( IMAX ) ).LE.TOL ) THEN
         K = 0
         DO 50 J = 1, N
            PERM( J ) = INDXQ( INDX( J ) )
            CALL ZCOPY( QSIZ, Q( 1, PERM( J ) ), 1, Q2( 1, J ), 1 )
   50    CONTINUE
         CALL ZLACPY( 'A', QSIZ, N, Q2( 1, 1 ), LDQ2, Q( 1, 1 ), LDQ )
         RETURN
      END IF
*
*     If there are multiple eigenvalues then the problem deflates.  Here
*     the number of equal eigenvalues are found.  As each equal
*     eigenvalue is found, an elementary reflector is computed to rotate
*     the corresponding eigensubspace so that the corresponding
*     components of Z are zero in this new basis.
*
      K = 0
      GIVPTR = 0
      K2 = N + 1
      DO 60 J = 1, N
         IF( RHO*ABS( Z( J ) ).LE.TOL ) THEN
*
*           Deflate due to small z component.
*
            K2 = K2 - 1
            INDXP( K2 ) = J
            IF( J.EQ.N )
     $         GO TO 100
         ELSE
            JLAM = J
            GO TO 70
         END IF
   60 CONTINUE
   70 CONTINUE
      J = J + 1
      IF( J.GT.N )
     $   GO TO 90
      IF( RHO*ABS( Z( J ) ).LE.TOL ) THEN
*
*        Deflate due to small z component.
*
         K2 = K2 - 1
         INDXP( K2 ) = J
      ELSE
*
*        Check if eigenvalues are close enough to allow deflation.
*
         S = Z( JLAM )
         C = Z( J )
*
*        Find sqrt(a**2+b**2) without overflow or
*        destructive underflow.
*
         TAU = DLAPY2( C, S )
         T = D( J ) - D( JLAM )
         C = C / TAU
         S = -S / TAU
         IF( ABS( T*C*S ).LE.TOL ) THEN
*
*           Deflation is possible.
*
            Z( J ) = TAU
            Z( JLAM ) = ZERO
*
*           Record the appropriate Givens rotation
*
            GIVPTR = GIVPTR + 1
            GIVCOL( 1, GIVPTR ) = INDXQ( INDX( JLAM ) )
            GIVCOL( 2, GIVPTR ) = INDXQ( INDX( J ) )
            GIVNUM( 1, GIVPTR ) = C
            GIVNUM( 2, GIVPTR ) = S
            CALL ZDROT( QSIZ, Q( 1, INDXQ( INDX( JLAM ) ) ), 1,
     $                  Q( 1, INDXQ( INDX( J ) ) ), 1, C, S )
            T = D( JLAM )*C*C + D( J )*S*S
            D( J ) = D( JLAM )*S*S + D( J )*C*C
            D( JLAM ) = T
            K2 = K2 - 1
            I = 1
   80       CONTINUE
            IF( K2+I.LE.N ) THEN
               IF( D( JLAM ).LT.D( INDXP( K2+I ) ) ) THEN
                  INDXP( K2+I-1 ) = INDXP( K2+I )
                  INDXP( K2+I ) = JLAM
                  I = I + 1
                  GO TO 80
               ELSE
                  INDXP( K2+I-1 ) = JLAM
               END IF
            ELSE
               INDXP( K2+I-1 ) = JLAM
            END IF
            JLAM = J
         ELSE
            K = K + 1
            W( K ) = Z( JLAM )
            DLAMDA( K ) = D( JLAM )
            INDXP( K ) = JLAM
            JLAM = J
         END IF
      END IF
      GO TO 70
   90 CONTINUE
*
*     Record the last eigenvalue.
*
      K = K + 1
      W( K ) = Z( JLAM )
      DLAMDA( K ) = D( JLAM )
      INDXP( K ) = JLAM
*
  100 CONTINUE
*
*     Sort the eigenvalues and corresponding eigenvectors into DLAMDA
*     and Q2 respectively.  The eigenvalues/vectors which were not
*     deflated go into the first K slots of DLAMDA and Q2 respectively,
*     while those which were deflated go into the last N - K slots.
*
      DO 110 J = 1, N
         JP = INDXP( J )
         DLAMDA( J ) = D( JP )
         PERM( J ) = INDXQ( INDX( JP ) )
         CALL ZCOPY( QSIZ, Q( 1, PERM( J ) ), 1, Q2( 1, J ), 1 )
  110 CONTINUE
*
*     The deflated eigenvalues and their corresponding vectors go back
*     into the last N - K slots of D and Q respectively.
*
      IF( K.LT.N ) THEN
         CALL DCOPY( N-K, DLAMDA( K+1 ), 1, D( K+1 ), 1 )
         CALL ZLACPY( 'A', QSIZ, N-K, Q2( 1, K+1 ), LDQ2, Q( 1, K+1 ),
     $                LDQ )
      END IF
*
      RETURN
*
*     End of ZLAED8
*
      END

C
C	$Id: tlocal32.f,v 1.5 2008-07-27 00:59:03 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      PROGRAM TLOCAL
C
C +-----------------------------------------------------------------+
C |                                                                 |
C |                Copyright (C) 1987 by UCAR                       |
C |        University Corporation for Atmospheric Research          |
C |                    All Rights Reserved                          |
C |                                                                 |
C |                 NCARGRAPHICS  Version 2.00                      |
C |                                                                 |
C +-----------------------------------------------------------------+
C
C     Test program for locally implemented support routines
C     IAND, IOR, ISHIFT, GBYTES, SBYTES
C
      INTEGER BYTLNG,WRDLNG
      DIMENSION MASK0(64)
      DIMENSION MASK1(65)
      DIMENSION ISCR(190)
C
C     This is a test package designed to test the locally
C     implemented routines for the NCAR GKS-based graphics
C     package.   Although the tests are not exhaustive,
C     they give a fairly  good idea whether a routine works
C     or not.
C
C     Appropriate messages are printed when a routine passes or
C     fails a test.  The test package is written in FORTRAN 77
C     with the following machine assumptions:  non-negative
C     integers must be stored in binary format, in one machine word--
C     hence, a word of all 0 bits is zero; a word with only the
C     rightmost bit set is one, etc.
C
C     The test package consists of a main program and various
C     subroutines.  To run the test package, compile it as FORTRAN,
C     and load and execute it with your locally written routines.
C     Certain information must be supplied to the main program
C     before the test.  This is most conveniently supplied by
C     changing certain data statements at the beginning of the main
C     program.  Below are 8 groups of comments.  Each group
C     describes the information required in the data statements
C     which follow it.  Read the directions and modify the data
C     statements as required.
C
C
C 1.  IOUT.  IOUT is an integer variable containing the unit
C     number on which the test package is to output all messages.
C     It is used, for example, in statements like
C
C                  WRITE (IOUT,9999)
C
C     IOUT has been initialized to 6, but you should reset IOUT so
C     that messages come to your line printer.  The test
C     assumes at least 72 columns per line including carriage
C     control.  There are no read statements.
C
      DATA IOUT/6/
C
C
C 2.  WRDLNG.     WRDLNG is an integer variable which contains the
C     number of bits in a machine word in your computer,
C        e.g.   For an ibm 360/370,  wrdlng = 32;
C               for a CRAY-1,  WRDLNG = 64 .
C     WRDLNG must be at least 16 bits and at most 64 bits.
C

      DATA WRDLNG/32/

C
C
C 3.  INLNGA and INLNGC.
C
C     INLNGA is an integer variable specifying the number of
C     contiguous low-order bits transferred from J to I by the
C     FORTRAN assignment statement
C
C         I=J
C
C     INLNGC is an integer variable specifying the number of
C     contiguous low-order bits actually participating in the
C     comparison performed by a FORTRAN statement like
C
C          IF (I.NE.J) GO TO 10
C
C     These parameters are used to determine the highest-order
C     bit that the test package can use in integer operations.
C     If either is less that WRDLNG, the routines IAND, IOR, and
C     ISHIFT are not fully tested.  If either is less than 16,
C     no testing can be done, and the package probably cannot be
C     made to run.
C
C

      DATA INLNGA /32/
      DATA INLNGC /32/


C
C
C 4.  MASK0.  MASK0 is an integer array of WRDLNG elements.
C     Each element contains all zero bits except for 1 one bit.
C     In element I, the one bit is I-1 bits from the right.  Hence,
C     MASK0(1) has the rightmost bit set, MASK0(WRDLNG) has the
C     leftmost bit set.  In terms of integers, MASK0(I) = 2**(I-1).
C     The test program comes with 64 data statements initializing
C     MASK0.  However, on most computers overflow will cause some of
C     our supplied values to be invalid.  You should begin by
C     removing the last 64-WRDLNG data statements, since these are for
C     word sizes larger than yours.  There should be WRDLNG data
C     statements remaining.  You should then change the last few of
C     these data statements to eliminate overflow, and generate the
C     proper values as defined above.  You may want to use octal or
C     hex constants.  The test program cannot check that MASK0 has
C     been initialized properly, but it is crucial that it be set
C     correctly.
C
C
      DATA	
     +  MASK0(1)	/	z'00000001'/,
     +  MASK0(2)	/	z'00000002'/,
     +  MASK0(3)	/	z'00000004'/,
     +  MASK0(4)	/	z'00000008'/,
     +  MASK0(5)	/	z'00000010'/,
     +  MASK0(6)	/	z'00000020'/,
     +  MASK0(7)	/	z'00000040'/,
     +  MASK0(8)	/	z'00000080'/,
     +  MASK0(9)	/	z'00000100'/,
     +  MASK0(10)	/	z'00000200'/,
     +  MASK0(11)	/	z'00000400'/,
     +  MASK0(12)	/	z'00000800'/,
     +  MASK0(13)	/	z'00001000'/,
     +  MASK0(14)	/	z'00002000'/,
     +  MASK0(15)	/	z'00004000'/,
     +  MASK0(16)	/	z'00008000'/

      DATA	
     +  MASK0(17)	/	z'00010000'/,
     +  MASK0(18)	/	z'00020000'/,
     +  MASK0(19)	/	z'00040000'/,
     +  MASK0(20)	/	z'00080000'/,
     +  MASK0(21)	/	z'00100000'/,
     +  MASK0(22)	/	z'00200000'/,
     +  MASK0(23)	/	z'00400000'/,
     +  MASK0(24)	/	z'00800000'/,
     +  MASK0(25)	/	z'01000000'/,
     +  MASK0(26)	/	z'02000000'/,
     +  MASK0(27)	/	z'04000000'/,
     +  MASK0(28)	/	z'08000000'/,
     +  MASK0(29)	/	z'10000000'/,
     +  MASK0(30)	/	z'20000000'/,
     +  MASK0(31)	/	z'40000000'/,
     +  MASK0(32)	/	z'80000000'/
	
C
C
C 5.  MSK0DM.  MSK0DM is an integer variable containing the
C     dimension of MASK0.  It must be at least WRDLNG.  The
C     dimension statement for MASK0 is at the beginning of the main
C     program.  You may leave it unchanged, or if you are cramped
C     for space, lower it to WRDLNG.
C
C

      DATA MSK0DM /32/

C
C 6.  MASK1.  MASK1 is an integer array of WRDLNG+1 elements.
C     Element I has the lower I-1 bits set, the other bits are
C     zero, hence, MASK1(1) = 0, MASK1(2) =1,
C                  MASK1(3) = 3, ..., MASK1(WRDLNG+1) is all ones.
C     In terms of integers MASK1(I) = (2**(I-1))-1 .
C     The test program comes with 65 data statements initializing
C     MASK1.  However on most computers overflow will cause some of
C     these to be invalid.  Begin by removing the last 64-WRDLNG
C     data statements.  You should have WRDLNG+1 remaining data
C     statements.  Change the last few of these to eliminate
C     overflow and generate the values as defined above.  You may
C     want to use octal or hex constants.  It is crucial that
C     MASK1 be initialized properly, even though the test program
C     cannot check for this.
C     WARNING.  On one's complement machines, MASK1(WRDLNG+1) = -0.
C
C
C
      DATA	
     +  MASK1(1)	/	z'00000000'/,
     +  MASK1(2)	/	z'00000001'/,
     +  MASK1(3)	/	z'00000003'/,
     +  MASK1(4)	/	z'00000007'/,
     +  MASK1(5)	/	z'0000000f'/,
     +  MASK1(6)	/	z'0000001f'/,
     +  MASK1(7)	/	z'0000003f'/,
     +  MASK1(8)	/	z'0000007f'/,
     +  MASK1(9)	/	z'000000ff'/,
     +  MASK1(10)	/	z'000001ff'/,
     +  MASK1(11)	/	z'000003ff'/,
     +  MASK1(12)	/	z'000007ff'/,
     +  MASK1(13)	/	z'00000fff'/,
     +  MASK1(14)	/	z'00001fff'/,
     +  MASK1(15)	/	z'00003fff'/,
     +  MASK1(16)	/	z'00007fff'/

      DATA
     +  MASK1(17)	/	z'0000ffff'/,
     +  MASK1(18)	/	z'0001ffff'/,
     +  MASK1(19)	/	z'0003ffff'/,
     +  MASK1(20)	/	z'0007ffff'/,
     +  MASK1(21)	/	z'000fffff'/,
     +  MASK1(22)	/	z'001fffff'/,
     +  MASK1(23)	/	z'003fffff'/,
     +  MASK1(24)	/	z'007fffff'/,
     +  MASK1(25)	/	z'00ffffff'/,
     +  MASK1(26)	/	z'01ffffff'/,
     +  MASK1(27)	/	z'03ffffff'/,
     +  MASK1(28)	/	z'07ffffff'/,
     +  MASK1(29)	/	z'0fffffff'/,
     +  MASK1(30)	/	z'1fffffff'/,
     +  MASK1(31)	/	z'3fffffff'/,
     +  MASK1(32)	/	z'7fffffff'/,
     +  MASK1(33)	/	z'ffffffff'/

C
C 7.  MSK1DM.  MSK1DM is an integer variable containing the
C     dimension of MASK1.  It must be at least WRDLNG+1.  The
C     dimension statement for MASK1 is at the beginning of the main
C     program.  You may leave it unchanged, or if you are cramped
C     for space, lower it to WRDLNG+1.
C

      DATA MSK1DM /33/

C
C
C     ISCRDM.  ISCRDM is an integer variable containing the
C     dimension of ISCR.  You may ignore this step unless you are
C     cramped for space.  ISCR is an array used for scratch.  Its
C     length depends on the word length of your machine.  The test
C     package comes with ISCR dimensioned to 190 .  This is large
C     enough for all word sizes of 1-64 bits, but if you want to
C     lower it, the following formula gives the minimum required.
C     Let LCM stand for the least common multiple.  Then the
C     dimension of ISCR must be at least
C          2*( LCM(WRDLNG,16)/16 + 2*LCM(WRDLNG,16)/WRDLNG ) .
C
      DATA ISCRDM /190/
C
C
C
C     End of information that you are required to supply.
C
C
C
      DATA BYTLNG /16/
      WRITE (IOUT,112)
      WRITE (IOUT,113)
      WRITE (IOUT,114) WRDLNG,INLNGA,INLNGC,MSK0DM,MSK1DM,ISCRDM
      IER=0
      INTLNG=MIN0(INLNGC,INLNGA)
      IF (WRDLNG.LT.BYTLNG .OR. WRDLNG.GT.64) GOTO 107
  101 WRDLNG=MAX0(WRDLNG,BYTLNG)
  102 IF (INLNGA.LT.BYTLNG .OR. INLNGA.GT.WRDLNG) GO TO 108
      IF (INLNGC.LT.BYTLNG .OR. INLNGC.GT.WRDLNG) GO TO 108
  103 IF (MSK1DM.LE.WRDLNG) GOTO 109
  104 IF (MSK0DM.LT.WRDLNG) GOTO 110
  105 NMBRB=2*LCM(WRDLNG,BYTLNG)/BYTLNG
      LPAKD=NMBRB*BYTLNG/WRDLNG
      NEEDED=NMBRB+2*LPAKD
      IF (ISCRDM.LT.NEEDED) GOTO 111
  106 IF (IER.NE.0) STOP
      WRITE (IOUT,115)
      CALL TIOR(MASK1,MSK1DM,WRDLNG,INTLNG,IOUT,IER)
      IERIOR=IER
      CALL TIAND(MASK1,MSK1DM,WRDLNG,INTLNG,IOUT,IER)
      IERAND=IER
      CALL TSHIFT (MASK0,MSK0DM,MASK1(2),MSK1DM-1,IERAND,WRDLNG,INTLNG,
     1                                                         IOUT,IER)
      IERSHF=IER
      CALL TGBYTE (MASK0,MSK0DM,MASK1,MSK1DM,ISCR,ISCRDM,WRDLNG,INTLNG,
     1                                           IERAND,IERSHF,IOUT,IER)
      IERGBY=IER
      CALL TSBYTE (MASK0,MSK0DM,MASK1,MSK1DM,ISCR,ISCRDM,WRDLNG,INTLNG,
     1                                   IERAND,IERIOR,IERSHF,IOUT,IER)
      IERSBY=IER
      WRITE (IOUT,116) IERIOR,IERAND,IERSHF,IERGBY,IERSBY
      STOP
  107 WRITE (IOUT,117) BYTLNG
      IER=1
      GOTO 101
  108 WRITE (IOUT,118) BYTLNG
      IER=1
      GOTO 103
  109 WRITE (IOUT,119)
      IER=1
      GOTO 104
  110 WRITE (IOUT,120)
      IER=1
       GOTO 105
  111 WRITE (IOUT,121) NEEDED
      IER=1
       GOTO 106
  112 FORMAT ('1TEST PACKAGE EXECUTING.  THIS LINE SHOULD BE PRINTED.')
  113 FORMAT ('0WE WILL FIRST TEST THE INFORMATION YOU HAVE PROVIDED',
     1        ' IN CERTAIN DATA'/
     2        ' STATEMENTS AT THE BEGINNING OF THIS PROGRAM.  IF ANY',
     3        ' ERROR IS FOUND,'/
     4        ' EXECUTION WILL TERMINATE--NO ROUTINES WILL BE TESTED.')
  114 FORMAT ('0YOU HAVE PROVIDED THE FOLLOWING CONSTANTS.'/' '/
     1        6X,'NUMBER OF BITS IN A WORD                ',I21/
     2        6X,'NUMBER OF BITS IN AN INTEGER ASSIGNMENT ',I21/
     3        6X,'NUMBER OF BITS IN AN INTEGER COMPARISON ',I21/
     4        6X,'THE DIMENSION OF THE ARRAY MASK0        ',I21/
     5        6X,'THE DIMENSION OF THE ARRAY MASK1        ',I21/
     6        6X,'THE DIMENSION OF THE ARRAY ISCR         ',I21)
  115 FORMAT ('0THE ABOVE DATA APPEARS TO BE CORRECT.  WE WILL NOW',
     1        ' BEGIN TESTING THE'/
     2        ' SUPPORT ROUTINES YOU HAVE PROVIDED FOR USE WITH THE',
     3        ' PLOT PACKAGE.'/
     4        '0A MESSAGE WILL BE PRINTED BEFORE EACH TEST BEGINS,',
     5        ' WHENEVER AN ERROR IS'/
     6        ' FOUND, AND AT THE SUCCESSFUL CONCLUSION OF A TEST. ',
     7        ' A SUMMARY OF THE'/
     8        ' TEST RESULTS WILL BE PRINTED AT THE END.  NOTE THAT',
     9        ' AN ERROR FOUND IN'/
     +        ' ONE ROUTINE MAY SUSPEND TESTING OF ONE OR MORE',
     1        ' SUBSEQUENT ROUTINES.')
  116 FORMAT ('1FOLLOWING IS A SUMMARY OF THE TEST RESULTS SO FAR. ',
     1        ' THE INTEGER WHICH'/
     2        ' FOLLOWS THE ROUTINE NAME IS A COUNT OF ERRORS FOUND',
     3        ' WHILE TESTING THE'/
     4        ' ROUTINE.  (-1 INDICATES THAT THE ROUTINE WAS NOT',
     5        ' TESTED AT ALL.)'/' '/
     6        10X,'IOR       ',I2/
     7        10X,'IAND      ',I2/
     8        10X,'ISHIFT    ',I2/
     9        10X,'GBYTES    ',I2/
     +        10X,'SBYTES    ',I2/
     1        '0IN ANY CASE, ALL PRECEDING OUTPUT SHOULD BE CAREFULLY',
     2        ' EXAMINED.')
  117 FORMAT ('0ERROR.  THE SYSTEM PLOT PACKAGE NEEDS AT LEAST ',I2,
     1     ' BITS IN A WORD.'/
     2     ' THE TEST PACKAGE IS DESIGNED FOR A 64 BITS/WORD MAXIMUM.')
  118 FORMAT ('0ERROR.  THE NUMBER OF LOW ORDER BITS TAKING PART IN ',
     1     'INTEGER COMPARISONS'/
     2     ' AND ASSIGNMENTS MUST BE .LE. WORD SIZE AND .GE. ',I2,'.')
  119 FORMAT ('0ERROR.  THE NUMBER OF ONES MASKS MUST BE .GT. ',
     1     'THE WORD LENGTH.  KEEP'/
     2     ' IN MIND THAT THE KTH ELEMENT HAS K-1 CONTIGUOUS ONES IN ',
     3     'THE LOW ORDER'/
     4     ' BITS.  HENCE MASK1(1) SHOULD BE ZERO, MASK1(WRDLNG+1) ',
     5     'SHOULD BE ALL'/
     6     ' ONES.')
  120 FORMAT('0ERROR.  THE NUMBER OF ONE-WITH-ZEROES MASKS MUST ',
     1     'BE .GE. THE WORD'/
     2     ' LENGTH.  KEEP IN MIND THAT THE KTH ELEMENT HAS BIT K-1 ',
     3     'SET (COUNTING'/
     4     ' BIT 0 AS THE RIGHTMOST) WITH THE REST ZEROS.  HENCE ',
     5     'MASK0(1) SHOULD BE'/
     6     ' 1, AND MASK0(WRDLNG) SHOULD HAVE A ONE IN THE LEFTMOST ',
     7     'BIT, AND THE'/
     8     ' REST ZEROS.')
  121 FORMAT ('0ERROR.  WITH THE GIVEN WORD SIZE, THE SCRATCH ARRAY ',
     1     'MUST BE AT LEAST'/
     2     1X,I16,' ELEMENTS LONG.')
      END

C
C	$Id: hsvrgb.f,v 1.5 2008-07-27 00:16:53 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE HSVRGB ( H, S, V, R, G, B )
C
C_BEGIN PROLOGUE HSVRGB
C
C_PURPOSE
C    This subroutine converts a color specification given in
C    the Hue, Saturation, and Value color space to
C    Red, Green, and Blue intensity values in the RGB color
C    space.
C
C_DESCRIPTION
C    This subroutine converts color values given in the
C    Hue, Saturation, and Value (HSV) color space to color values
C    in the Red, Green, and Blue (RGB) color space.
C    The input value H is a floating point number in the
C    range [0.,360.); a value of H=0. in the input space
C    will result in a full red (green and blue values of 0.)
C    in the RGB space.  The input value V is in the range
C    [0.,1.];  the input value S is
C    in the range [0.,1.];  saturation is a measure of the
C    mixture of white light with a pure fully-saturated hue--
C    S=0. will result in R=G=B=V.  The output values
C    R, G, and B are red, green, and blue intensities
C    in the range [0.,1.] .
C
C_ARGUMENTS
C
C H       (INPUT,SINGLE,VARIABLE)  A real variable in the range
C         [0.,360.) which represents the hue of the input color
C         in HSV color space.
C
C S       (INPUT,SINGLE,VARIABLE)  A real variable in the range
C         [0.,1.] which represents the saturation value of the
C         input color in HSV color space.  Saturation is a measure
C         of how much white light is mixed with the color. Saturation
C         values of 0. represent greys (with a grey value equal to
C         the value V).  Saturation values of 1. are fully
C         saturated colors.  The hue is undefined when S=0.  The
C         fully saturated pure hues occur when S=1. and V=1.
C
C V       (INPUT,SINGLE,VARIABLE)  A real variable in the range
C         [0.,1.] which represents the value of the
C         input color in HSV color space.
C
C R       (OUTPUT,SINGLE,VARIABLE)  A real variable in the range
C         [0.,1.] which represents the red intensity component
C         of the output color in RGB color space.
C
C G       (OUTPUT,SINGLE,VARIABLE)  A real variable in the range
C         [0.,1.] which represents the green intensity component
C         of the output color in RGB color space.
C
C B       (OUTPUT,SINGLE,VARIABLE)  A real variable in the range
C         [0.,1.] which represents the blue intensity component
C         of the output color in RGB color space.
C
C_I/O
C    (NONE)
C
C_ROUTINES CALLED
C    SIGPLC
C
C_COMMON BLOCKS
C    (NONE)
C
C_MAXIMUM GKS LEVEL
C    (NONE)
C
C_LANGUAGE
C    FORTRAN
C
C_REVISION DATE
C    880511 (YYMMDD)
C
C_HISTORY
C    This subroutine was originally coded and prepared for the
C    NCAR Graphics package by Fred Clare based on algorithms
C    in Foley and van Dam (see REFERENCES below).
C
C_REFERENCES
C    Foley, James D. and van Dam, Andries,"Fundamentals of Interactive
C    Computer Graphics",Addison-Wesley Publishing Company, 1982.
C
C    Smith, A.R.,"Color Gamut Transformation Pairs",SIGGRAPH '78
C    Proceedings, published as Computer Graphics, 12(3),August 1978,
C    pp.12-19.
C
C_LONG DESCRIPTION
C    The idea of the algorithm can be understood if one were to
C    plot the red output values vs. hue with S=1. and V=1.  The red
C    values so plotted form a piecewise linear curve.  The blue
C    and green values plotted in the same way form the same
C    piecewise linear curve except shifted.  Decreasing the
C    saturation pushes the curves toward the input value V,,
C    and varying the value, V, introduces an amplitude scale
C    factor.  Drawing plots of the red, green, and blue output
C    values vs. hue for selected values of S, and V should
C    provide an intuitive feel for the algorithm.
C
C_EXAMPLES
C    Example 1 --  Pure hue in HSV to green in RGB.
C          SUBROUTINE HSV2
C          REAL    R,G,B,EPS
C          PARAMETER (EPS=0.00001)
C          CALL HSVRGB(120.,1.,1.,R,G,B)
C          IF ( (ABS(R-0.) .GT. EPS) .OR. (ABS(G-1.) .GT. EPS) .OR.
C         *     (ABS(B-0.) .GT. EPS) ) THEN
C            IUN = I1MACH(4)
C            WRITE(IUN,10)
C          ENDIF
C          RETURN
C       10 FORMAT(' HSV2 returned incorrect values')
C          END
C
C_END PROLOGUE HSVRGB
C
      REAL   H,HH,S,V,R,G,B,SM1,SIGPLC
C
C  Check on the input values.
C
C_FIRST EXECUTABLE STATEMENT HSVRGB
      HH = MOD(H,360.)
      IF (HH .LT. 0.) HH = HH+360.
      IF (S.LT.0. .OR. S.GT.1.)
     *      CALL SETER(' HSVRGB - S out of range',1,1)
      IF (V.LT.0. .OR. V.GT.1.)
     *      CALL SETER(' HSVRGB - V out of range',1,1)
C
      IF (S .EQ. 0.0) THEN
C
C  Achromatic case; RGB value is a grey equal to V;
C  H is not defined.
C
         R = V
         G = V
         B = V
      ELSE
C
C  Calculate RGB values.
C
         SM1 = (1.-S)*V
         R = SIGPLC(SM1,V,HH+120.)
         G = SIGPLC(SM1,V,HH+  0.)
         B = SIGPLC(SM1,V,HH+240.)
      ENDIF
      RETURN
      END

C
C	$Id: tgks0a.f,v 1.4 2008-07-27 00:59:03 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      PROGRAM TGKS0A
C
C  GKS sample program, level 0A.
C
C  Puts out sample POLYLINE, POLYMARKER, TEXT, FILL AREA and CELL ARRAY.
C
C  (Knowledge of device and environment assumed -- normal inquiry and
C   error checking are omitted from the sample program).
C
C
      REAL     ZZX(9), ZZYL(9),  ZZYM(9),  CIRX(9),  CIRY(9)
      INTEGER  ICELLS(24,12)
C
      DATA  ZZX / -9.0, -8.0, -7.0, -6.0, -5.0, -4.0, -3.0, -2.0, -1.0/
      DATA  ZZYL/  6.5,  8.5,  6.5,  8.5,  6.5,  8.5,  6.5,  8.5,  6.5/
      DATA  ZZYM/  1.5,  3.5,  1.5,  3.5,  1.5,  3.5,  1.5,  3.5,  1.5/
      DATA CIRX / 6.15, 5.26, 4.25, 3.59, 3.59, 4.25, 5.26, 6.15, 6.50/
      DATA CIRY / 8.46, 8.98, 8.80, 8.01, 6.99, 6.20, 6.02, 6.54, 7.50/
C
      DATA ISZ/0/
C
C
C                                Open GKS w/ logical unit 6 for errors.
      CALL GOPKS (6,ISZ)
C                                Open a wkstn of type 1, assigning 1
C                                for its id, 2 for connection id.
      CALL GOPWK (1, 2, 1)
C                                Activate the workstation.
      CALL GACWK (1)
C
C
C                                Define normalization transformation 1.
C                                Window in World Coordinates.
      CALL GSWN   (1, -10.0, 10.0, -10.0, 10.0)
C                                Viewport in Normalized Device Coords.
      CALL GSVP   (1, 0.1, 0.9, 0.1, 0.9)
C                                Select just-defined transformation.
      CALL GSELNT (1)
C
C
C                                Draw a zig-zag POLYLINE.
      CALL GPL (9, ZZX, ZZYL)
C
C
C               "+"              Set marker type.
      CALL GSMK (2)
C                                Draw a POLYMARKER.
      CALL GPM (9, ZZX, ZZYM)
C
C
C                solid           Set fill area interior style.
      CALL GSFAIS (1)
C                                Draw a solid circle w/FILL AREA.
      CALL GFA (9, CIRX, CIRY)
C
C
C                                Define 24x12 foreground/background
C                                checkerboard pattern.
      DO 25 IX=1,24
      JX = MOD(IX,2)
      DO 20 IY=1,12
      JY = MOD(IY,2)
      IF ((JX.EQ.1 .AND. JY.EQ.1) .OR. (JX.EQ.0 .AND. JY.EQ.0)) THEN
      ICELLS (IX,IY) = 1
      ELSE
      ICELLS (IX,IY) = 0
      ENDIF
20    CONTINUE
25    CONTINUE
C                                Draw the checkerboard w/ CELL ARRAY.
      CALL GCA (2.,1.5,8.,4.0, 24, 12, 1, 1, 24, 12, ICELLS)
C
C
C                                Set chr hgt to 2% of screen (.02*20).
      CALL GSCHH (0.4)
C                cen,hlf         Set alignment to center string on posn.
      CALL GSTXAL (2, 3)
      XPOS = 0.0
      YPOS = -5.0
C                                 Draw the text string.
      CALL GTX (XPOS, YPOS, 'Example string, centered in the center')
C                                 Flush metacode buffer.
      CALL GCLRWK(1,1)
C                                 Deactivate the workstation.
      CALL GDAWK (1)
C                                 Close the workstation.
      CALL GCLWK (1)
C                                 Close GKS
      CALL GCLKS
C
C
      STOP
      END

C
C $Id: hlumapusr.f,v 1.13 2008-09-18 00:42:16 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE HLUMAPUSR (IPRT)
        INTEGER IPRT
        CALL MAPUSR (IPRT)
        RETURN
      END

      PROGRAM FGKGPM
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C  Illustrate polymarkers.
C
      PARAMETER (ID=50)
      DIMENSION XM1(ID),YM1(ID),XM2(ID),YM2(ID),XM3(ID),YM3(ID)
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C  Define the necessary color indices.
C
      CALL GSCR(IWKID,0,1.,1.,1.)
      CALL GSCR(IWKID,1,0.,0.,0.)
      CALL GSCR(IWKID,2,1.,1.,0.)
      CALL GSCR(IWKID,3,0.,1.,0.)
      CALL GSCR(IWKID,4,1.,1.,0.)
      CALL GSCR(IWKID,5,0.,1.,1.)
      CALL GSCR(IWKID,6,1.,0.,1.)
C
C  Marker 1, dot (fill a large circular dot with markers of type 1).
C
C
C   Position and radius of the dot outline.
C
      X0 = .5
      Y0 = .7
      R  = .08
      JL = 8
      AINC = R/REAL(JL)
      CALL GSMK(1)
      DO 10 J=0,JL
      Y = Y0+REAL(J)*AINC
      XE = X0+SQRT(MAX(R**2-(Y-Y0)**2,0.))
      X = X0
   20 CONTINUE
C
C   Fill the circle with dot markers using symmetries.
C	
      CALL GPM(1,X,Y)
      CALL GSPMCI(1)
      CALL GPM(1,X,2*Y0-Y)
      CALL GPM(1,2*X0-X,2*Y0-Y)
      CALL GPM(1,2*X0-X,Y)
      X = X+AINC
      IF (X .GT. XE) GO TO 10
      GO TO 20
   10 CONTINUE
C
C   Label the dot.
C
      CALL PCSETI('CD',1)
      CALL GSPLCI(1)
      CALL PLCHHQ(X0,Y0+R+.05,'Marker 1 (dots)',.018,0.,0.)
C
C  Marker 2, plus (make a plus from the plus markers.)
C
C
C   Center of big plus.
C
      X0 = .83
      Y0 = .5
      R  = .1
      JL = 7
      AINC = R/REAL(JL)
      DO 30 J=-JL,JL,1
      Y = Y0+REAL(J)*AINC
      IDX = J+JL+1
      XM1(IDX) = X0
      YM1(IDX) = Y
      X = X0+REAL(J)*AINC
      XM2(IDX) = X
      YM2(IDX) = Y0
   30 CONTINUE
      CALL GSMK(2)
      CALL GSPMCI(1)
C
C  Put plus markers along the two axes of the big plus.
C
      CALL GPM(2*JL+1,XM1,YM1)
      CALL GPM(2*JL+1,XM2,YM2)
C
C   Label the big plus.
C
      CALL PCSETI('CD',1)
      CALL GSPLCI(1)
      CALL PLCHHQ(X0,Y0+R+.05,'Marker 2 (plus signs)',.018,0.,0.)
C
C  Marker 3, asterisk (make an asterisk from the asterisk markers.)
C
      X0 = .7
      Y0 = .15
      R  = .1
      JL = 5
      AINC = R/REAL(JL)
      DO 40 J=-JL,JL,1
      Y = Y0+REAL(J)*AINC
      IDX = J+JL+1
      XM1(IDX) = X0
      YM1(IDX) = Y
      P = 0.5*SQRT(2.)*(Y-Y0)
      IF (Y .GE. 0.) THEN
        XM2(IDX) = X0+P
        YM2(IDX) = Y0+P
        XM3(IDX) = X0-P
        YM3(IDX) = Y0+P
      ELSE
        XM2(IDX) = X0-P
        YM2(IDX) = Y0-P
        XM3(IDX) = X0+P
        YM3(IDX) = Y0-P
      ENDIF
   40 CONTINUE
      CALL GSMK(3)
      CALL GSPMCI(1)
C
c Put asterisk markers along the axes of the big asterisk.
C
      CALL GPM(2*JL+1,XM1,YM1)
      CALL GPM(2*JL+1,XM2,YM2)
      CALL GPM(2*JL+1,XM3,YM3)
C
C   Label the big asterisk.
C
      CALL PCSETI('CD',1)
      CALL GSPLCI(1)
      CALL PLCHHQ(X0,Y0+R+.05,'Marker 3 (asterisks)',.018,0.,0.)
C
C  Marker 4, circle (make a big circle from the circle markers.)
C
      X0 = .3
      Y0 = .15
      R  = .1
      JL = 50
      RADINC = 2.*3.1415926/REAL(JL)
      DO 50 J=1,JL
      X = X0+R*COS(REAL(J)*RADINC)
      Y = Y0+R*SIN(REAL(J)*RADINC)
      XM1(J) = X
      YM1(J) = Y
   50 CONTINUE
      CALL GSMK(4)
      CALL GSPMCI(1)
      CALL GSMKSC(2.)
      CALL GPM(JL,XM1,YM1)
C
C   Label the big circle.
C
      CALL PCSETI('CD',1)
      CALL GSPLCI(1)
      CALL PLCHHQ(X0,Y0+R+.05,'Marker 4 (circles)',.018,0.,0.)
C
C  Marker 5, cross (make a big cross from the cross markers.)
C
      X0 = .17
      Y0 = .5
      R  = .1
      JL = 5
      AINC = R/REAL(JL)
      DO 60 J=-JL,JL,1
      Y = Y0+REAL(J)*AINC
      IDX = J+JL+1
      P = 0.5*SQRT(2.)*(Y-Y0)
      IF (Y .GE. 0.) THEN
        XM2(IDX) = X0+P
        YM2(IDX) = Y0+P
        XM3(IDX) = X0-P
        YM3(IDX) = Y0+P
      ELSE
        XM2(IDX) = X0-P
        YM2(IDX) = Y0-P
        XM3(IDX) = X0+P
        YM3(IDX) = Y0-P
      ENDIF
   60 CONTINUE
      CALL GSMK(5)
      CALL GSPMCI(1)
C
C  Plot cross markers along the axes of the big cross.
C
      CALL GSMKSC(1.)
      CALL GPM(2*JL+1,XM2,YM2)
      CALL GPM(2*JL+1,XM3,YM3)
C
C   Label the big cross.
C
      CALL PCSETI('CD',1)
      CALL GSPLCI(1)
      CALL PLCHHQ(X0,Y0+R+.05,'Marker 5 (crosses)',.018,0.,0.)
C
C  Draw a big circle in the center by applying a large marker size
C  scale factor to the circle marker.
C
      X0 = .5
      Y0 = .46
      CALL GSMK(4)
      CALL GSPMCI(1)
      CALL GSMKSC(15.)
      CALL GPM(1,X0,Y0)
      CALL PCSETI('CD',1)
      CALL GSPLCI(1)
      CALL PLCHHQ(X0,Y0+.028,'Circle',.015,0.,0.)
      CALL PLCHHQ(X0,Y0     ,'Scaled',.015,0.,0.)
      CALL PLCHHQ(X0,Y0-.028,'by 15.',.015,0.,0.)
C
C  Label the plot (PLOTCHAR strokes its characters with lines, so the
C  PLOTCHAR character attributes are controlled by the GKS polyline 
C  attributes).
C
      CALL GSPLCI(1)
      CALL PCSETI('CD',1)
      CALL GSLWSC(2.)
      CALL PLCHHQ(.5,.915,'Polymarkers',.025,0.,0.)
C
      CALL FRAME
C
C  Deactivate and close the workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END

C
C	$Id: gsegrd.f,v 1.4 2008-07-27 00:21:01 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GSEGRD(IOS,STATUS)
C
C  Read a record from the segment.
C
      include 'trbufr.h'
      include '../bwi/g01io.h'
      include 'gkscom.h'
C
      PARAMETER (MYBITS=11520)
C
      INTEGER IOS, STATUS
      INTEGER TEMP, IER
      CHARACTER*1 DNAME
C
      STATUS = 0
      MOBFSZ = 1 + (MYBITS-1)/I1MACH(5)
C
C  Read in a record.
C
      MRCNMO = MRECNM
      MRECNM = METREC 
      IF (METREC .GT. MXSREC) THEN
        METREC = MRECNM
        MRECNM = MRCNMO
        STATUS = -1
        RETURN
      ENDIF
      CALL G01MIO (4, MCONID, DNAME, MBUFER, MOBFSZ, IER)
      IF (IER .NE. 0) GO TO 1000
      MRECNM = MRCNMO
      METREC = METREC + 1
C
C  Reset the bit pointer.
C
      METBIT = MBITST
C
C  Get the useful data count and convert from 8 bit bytes to bits.
C
      CALL GBYTES(MBUFER,TEMP,RECLOC,RECSIZ,0,1)
      MRECLN = TEMP * 8 + MBUFOF
C
C  If the bit count is out of range, then set error and return.
C
      IF (MRECLN.LE.MBUFOF .OR. MRECLN.GT.1440*8) THEN
        STATUS = 302
        RETURN
      END IF
C
C  Normal exit.
C
      RETURN
C
C  Error exit.
C
 1000 CONTINUE
      STATUS = IER
C
      RETURN
      END

C NCLFORTSTART 
      SUBROUTINE BINDATAAVG(NZ,ZLON,ZLAT,Z,ZMSG,MLON,NLAT,GLON,GLAT 
     +                     ,GBINKNT,IOPT,IER)
      IMPLICIT NONE
c                                             ; INPUT
      INTEGER NLAT,MLON,NZ,IOPT,IER
      DOUBLE PRECISION ZLON(NZ),ZLAT(NZ),Z(NZ),ZMSG
      DOUBLE PRECISION GLON(MLON),GLAT(NLAT)
c                                             ; OUTPUT
      DOUBLE PRECISION GBINKNT(MLON,NLAT,2)
C NCLEND

c NCL:   function bin_avg(zlon[*],zlat[*],z[*], glon[*], glat[*], opt )

      INTEGER K,NL,ML,IFLAG
      DOUBLE PRECISION DLAT,DLON
      DOUBLE PRECISION GLATBND1,GLATBND2
      DOUBLE PRECISION GLONBND1,GLONBND2

      IER = 0

c                            ; monotonically {in/de}creasing
      DLAT = GLAT(2)-GLAT(1)
      IF (DLAT.GT.0.0D0) THEN
          IFLAG = 1
      ELSEIF (DLAT.LT.0.0D0) THEN
          IFLAG = -1
      ELSE
          IER = 1
      END IF
      DLAT = ABS(DLAT)

c                            check for equal lat spacing
      DO NL = 1,NLAT - 1
          IF (ABS(GLAT(NL+1)-GLAT(NL)).NE.DLAT) THEN
              IER = IER + 10
              GO TO 10
          END IF
      END DO
   10 CONTINUE

c                            check for equal lon spacing
      DLON = GLON(2)-GLON(1)
      IF (DLON.LE.0.0D0) THEN
          IER = 1
      END IF

      DO ML = 1,MLON - 1
          IF (ABS(GLON(ML+1)-GLON(ML)).NE.DLON) THEN
              IER = IER + 100
              GO TO 20
          END IF
      END DO
   20 CONTINUE
c                            set all msg if error
      IF (IER.NE.0) THEN
          DO NL = 1,NLAT
              DO ML = 1,MLON
                  GBINKNT(ML,NL,1) = ZMSG
                  GBINKNT(ML,NL,2) = ZMSG
              END DO
          END DO
          RETURN
      END IF
c                            initialize
      DO NL = 1,NLAT
          DO ML = 1,MLON
              GBINKNT(ML,NL,1) = 0.0D0
              GBINKNT(ML,NL,2) = 0.0D0
          END DO
      END DO

      GLATBND1 = MIN(GLAT(1),GLAT(NLAT)) - DLAT/2
      GLATBND2 = MAX(GLAT(1),GLAT(NLAT)) + DLAT/2
      GLONBND1 = GLON(1)    - DLON/2
      GLONBND2 = GLON(MLON) + DLON/2

      DO K = 1,NZ
          IF (Z(K).NE.ZMSG .AND.
     +       (ZLAT(K).GE.GLATBND1 .AND. ZLAT(K).LE.GLATBND2)  .AND.
     +       (ZLON(K).GE.GLONBND1 .AND. ZLON(K).LE.GLONBND2)) THEN
              ML = ABS((ZLON(K)-GLONBND1)/DLON) + 1
              NL = ABS((ZLAT(K)-GLATBND1)/DLAT) + 1
              IF (IFLAG.EQ.-1) NL = NLAT-NL+1
c c c         IF (NL.GT.0 .AND. NL.LE.NLAT .AND. ML.GT.0 .AND.
c c c             ML.LE.MLON) THEN
                  GBINKNT(ML,NL,1) = GBINKNT(ML,NL,1) + Z(K)
                  GBINKNT(ML,NL,2) = GBINKNT(ML,NL,2) + 1
c c c         END IF
          END IF
      END DO
c                                     compute bin average
      DO NL = 1,NLAT
          DO ML = 1,MLON
              IF (GBINKNT(ML,NL,2).GT.0.0D0) THEN
                  GBINKNT(ML,NL,1) = GBINKNT(ML,NL,1)/GBINKNT(ML,NL,2)
              ELSE
                  GBINKNT(ML,NL,1) = ZMSG
              END IF
          END DO
      END DO

      RETURN
      END

        PROGRAM MPEX12
C
C This example produces no graphical output.  Instead, it produces
C print output demonstrating the use of some of the EZMAPB routines
C allowing one to retrieve information from the a map database.
C
C Declare the types of a couple of EZMAPB functions and a temporary
C character variable to be used below.
C
        CHARACTER*64 MPNAME
        CHARACTER*128 MPFNME,CTMP
C
C Read name information from the EZMAP database.
C
        CALL MPLNRI ('Earth..1')
C
C Do a simple check of some information-returning routines.  First, find
C the area in the database with a particular short name.
C
        WRITE (*,'('' '')')
        WRITE (*,'(''Test routines that return area information:'')')
        WRITE (*,'('' '')')
        WRITE (*,'(''  Search map database for Madeline Island.'')')
C
        DO 101 I=1,10000
          IF (MPIATY(I).NE.0) THEN
            CTMP=MPNAME(I)
            IF (CTMP(1:15).EQ.'Madeline Island') THEN
              IAID=I
              WRITE (*,'('' '')')
              WRITE (*,'(''  Madeline Island has area identifier IAID ='
     +',I4)') IAID
              GO TO 102
            END IF
          ELSE
            WRITE (*,'('' '')')
            WRITE (*,'(''  Madeline Island not found in database.'')')
            GO TO 103
          END IF
  101   CONTINUE
C
C Search failure.
C
        WRITE (*,'('' '')')
        WRITE (*,'(''  Search failure - too many names in database.'')')
        GO TO 103
C
C Write out simple information for the area.
C
  102   WRITE (*,'(''  Its area type is MPIATY(IAID) =          '',I5)')
     +                                                      MPIATY(IAID)
        WRITE (*,'(''  Its suggested color is MPISCI(IAID) =    '',I5)')
     +                                                      MPISCI(IAID)
        WRITE (*,'(''  Its parent identifier is MPIPAR(IAID) =  '',I5)')
     +                                                      MPIPAR(IAID)
        CTMP=MPNAME(IAID)
        WRITE (*,'(''  Its short name is MPNAME(IAID) = '',A)')
     +                                            CTMP(1:MPILNB(CTMP))
C
        WRITE (*,'('' '')')
        WRITE (*,'(''  Short name of smallest containing area at various
     + display levels:'')')
        WRITE (*,'('' '')')
C
        CTMP=MPNAME(MPIOSA(IAID,5))
        WRITE (*,'(''    MPNAME(MPIOSA(IAID,5)) = '',A)')
     +                                              CTMP(1:MPILNB(CTMP))
        CTMP=MPNAME(MPIOSA(IAID,4))
        WRITE (*,'(''    MPNAME(MPIOSA(IAID,4)) = '',A)')
     +                                              CTMP(1:MPILNB(CTMP))
        CTMP=MPNAME(MPIOSA(IAID,3))
        WRITE (*,'(''    MPNAME(MPIOSA(IAID,3)) = '',A)')
     +                                              CTMP(1:MPILNB(CTMP))
        CTMP=MPNAME(MPIOSA(IAID,2))
        WRITE (*,'(''    MPNAME(MPIOSA(IAID,2)) = '',A)')
     +                                              CTMP(1:MPILNB(CTMP))
        CTMP=MPNAME(MPIOSA(IAID,1))
        WRITE (*,'(''    MPNAME(MPIOSA(IAID,1)) = '',A)')
     +                                              CTMP(1:MPILNB(CTMP))
C
        WRITE (*,'('' '')')
        WRITE (*, '(''  Short name of largest containing area at various
     + display levels:'')')
        WRITE (*,'('' '')')
C
        CTMP=MPNAME(MPIOLA(IAID,5))
        WRITE (*,'(''    MPNAME(MPIOLA(IAID,5)) = '',A)')
     +                                              CTMP(1:MPILNB(CTMP))
        CTMP=MPNAME(MPIOLA(IAID,4))
        WRITE (*,'(''    MPNAME(MPIOLA(IAID,4)) = '',A)')
     +                                              CTMP(1:MPILNB(CTMP))
        CTMP=MPNAME(MPIOLA(IAID,3))
        WRITE (*,'(''    MPNAME(MPIOLA(IAID,3)) = '',A)')
     +                                              CTMP(1:MPILNB(CTMP))
        CTMP=MPNAME(MPIOLA(IAID,2))
        WRITE (*,'(''    MPNAME(MPIOLA(IAID,2)) = '',A)')
     +                                              CTMP(1:MPILNB(CTMP))
        CTMP=MPNAME(MPIOLA(IAID,1))
        WRITE (*,'(''    MPNAME(MPIOLA(IAID,1)) = '',A)')
     +                                              CTMP(1:MPILNB(CTMP))
C
        WRITE (*,'('' '')')
        WRITE (*,'(''  Suggested color at various display levels:'')')
        WRITE (*,'('' '')')
C
        WRITE (*,'(''    MPISCI(MPIOSA(IAID,5)) = '',I1)')
     +                                            MPISCI(MPIOSA(IAID,5))
        WRITE (*,'(''    MPISCI(MPIOSA(IAID,4)) = '',I1)')
     +                                            MPISCI(MPIOSA(IAID,4))
        WRITE (*,'(''    MPISCI(MPIOSA(IAID,3)) = '',I1)')
     +                                            MPISCI(MPIOSA(IAID,3))
        WRITE (*,'(''    MPISCI(MPIOSA(IAID,2)) = '',I1)')
     +                                            MPISCI(MPIOSA(IAID,2))
        WRITE (*,'(''    MPISCI(MPIOSA(IAID,1)) = '',I1)')
     +                                            MPISCI(MPIOSA(IAID,1))
C
        WRITE (*,'('' '')')
        WRITE (*,'(''  Full name at various display levels:'')')
        WRITE (*,'('' '')')
C
        CTMP=MPFNME(MPIOSA(IAID,5),5)
        WRITE (*,'(''    MPFNME(MPIOSA(IAID,5),5) = '',A)')
     +                                              CTMP(1:MPILNB(CTMP))
        CTMP=MPFNME(MPIOSA(IAID,4),4)
        WRITE (*,'(''    MPFNME(MPIOSA(IAID,4),4) = '',A)')
     +                                              CTMP(1:MPILNB(CTMP))
        CTMP=MPFNME(MPIOSA(IAID,3),3)
        WRITE (*,'(''    MPFNME(MPIOSA(IAID,3),3) = '',A)')
     +                                              CTMP(1:MPILNB(CTMP))
        CTMP=MPFNME(MPIOSA(IAID,2),2)
        WRITE (*,'(''    MPFNME(MPIOSA(IAID,2),2) = '',A)')
     +                                              CTMP(1:MPILNB(CTMP))
        CTMP=MPFNME(MPIOSA(IAID,1),1)
        WRITE (*,'(''    MPFNME(MPIOSA(IAID,1),1) = '',A)')
     +                                              CTMP(1:MPILNB(CTMP))
C
        WRITE (*,'('' '')')
        WRITE (*,'(''  Full name from a specified level down:'')')
        WRITE (*,'('' '')')
C
        CTMP=MPFNME(IAID,5)
        LCTM=MPILNB(CTMP)
        WRITE (*,'(''    MPFNME(IAID,5) = '',A)') CTMP( 1:MIN( 58,LCTM))
        IF (LCTM.GT.58)
     +  WRITE (*,'(''                     '',A)') CTMP(59:MIN(116,LCTM))
        CTMP=MPFNME(IAID,4)
        LCTM=MPILNB(CTMP)
        WRITE (*,'(''    MPFNME(IAID,4) = '',A)') CTMP( 1:MIN( 58,LCTM))
        IF (LCTM.GT.58)
     +  WRITE (*,'(''                     '',A)') CTMP(59:MIN(116,LCTM))
        CTMP=MPFNME(IAID,3)
        LCTM=MPILNB(CTMP)
        WRITE (*,'(''    MPFNME(IAID,3) = '',A)') CTMP( 1:MIN( 58,LCTM))
        IF (LCTM.GT.58)
     +  WRITE (*,'(''                     '',A)') CTMP(59:MIN(116,LCTM))
        CTMP=MPFNME(IAID,2)
        LCTM=MPILNB(CTMP)
        WRITE (*,'(''    MPFNME(IAID,2) = '',A)') CTMP( 1:MIN( 58,LCTM))
        IF (LCTM.GT.58)
     +  WRITE (*,'(''                     '',A)') CTMP(59:MIN(116,LCTM))
        CTMP=MPFNME(IAID,1)
        LCTM=MPILNB(CTMP)
        WRITE (*,'(''    MPFNME(IAID,1) = '',A)') CTMP( 1:MIN( 58,LCTM))
        IF (LCTM.GT.58)
     +  WRITE (*,'(''                     '',A)') CTMP(59:MIN(116,LCTM))
C
C Done.
C
  103   STOP
C
      END

C
C	$Id: gtlog.f,v 1.4 2008-07-27 12:23:44 haley Exp $
C                                                                      
C			     Copyright (C)  1997
C	     University Corporation for Atmospheric Research
C			     All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C

      SUBROUTINE GTLOG(STRING, STRMAX, STRSIZ, IOS, STATUS)
C
C  Get a string of logical values from the input file.
C
C  INPUT
C       STRMAX  --  Maximum number of logical values to transfer.
C
C  OUTPUT
C       STRING  --  The array of logical values.
C       STRSIZ  --  The number of logical values actually transfered.
C       IOS     --  I/O status flag.  This flag is valid only
C                   if STATUS indicates an error.
C       STATUS  --  The error status as defined in COMMON CAPERR.
C
      COMMON /CAPERR/ ALLOK, EOFFL, INTERR, MAXINT, PLBERR, PMBERR,
     1                FABERR, TXBERR, FLTERR, MAXFLT, NOTINT, SIZERR,
     2                UNDASC, DEVERR, DOCERR, TBLERR , STSZER, ENTERR,
     3                TABERR, TABSER, PRSFIL
      INTEGER ALLOK, EOFFL, INTERR, MAXINT, PLBERR, PMBERR,
     1        FABERR, TXBERR, FLTERR, MAXFLT, NOTINT, SIZERR, UNDASC,
     2        DEVERR, DOCERR, STSZER, ENTERR, TABERR, TABSER, TBLERR,
     3        PRSFIL
      COMMON /CAPIOB/ UNIT, IPTR, LSIZE, NFST, NFLG
      COMMON /CAPIO2/ LINE, GRNM
      INTEGER LNMAX
      PARAMETER (LNMAX=80)
      CHARACTER*80 LINE
      CHARACTER*80 GRNM
      INTEGER UNIT, IPTR, LSIZE, NFST, NFLG
C
      INTEGER STRMAX, STRSIZ, IOS, STATUS
      LOGICAL STRING(STRMAX)
      INTEGER LL, II
      LOGICAL TEMP
      CHARACTER*1 T(4),F(5)
C
C  Define the true and false strings.
C
      DATA T /'T','R','U','E'/
      DATA F /'F','A','L','S','E'/
C
C  Set STRING size to null.
C
      STRSIZ = 0
C
C  Skip blanks.
C
 10   CONTINUE
      CALL SKPBLK(IOS, STATUS)
      IF (STATUS .NE. ALLOK) RETURN
      LL = 1
C
C  Test for a true.
C
      DO 20 II = IPTR,LSIZE
        IF (LINE(II:II) .NE. T(LL)) GO TO 30
        LL = LL + 1
        IF (LL .EQ. 5) THEN
C
C  True found.
C
                TEMP = .TRUE.
                IPTR = II + 1
                GO TO 40
        END IF
 20   CONTINUE
C
C  Test for a false.
C
 30   CONTINUE
      LL = 1
      DO 35 II = IPTR,LSIZE
        IF (LINE(II:II) .NE. F(LL)) RETURN
        LL = LL + 1
        IF (LL .EQ. 6) THEN
C
C  False found.
C
                TEMP = .FALSE.
                IPTR = II + 1
                GO TO 40
        END IF
 35   CONTINUE
C
C  Store the value found in STRING.
C
 40   CONTINUE
      STRSIZ = STRSIZ + 1
      STRING(STRSIZ) = TEMP
      IF (STRSIZ .GE. STRMAX) RETURN
      GO TO 10
      END

      PROGRAM WMEX01
C
C  Example of weather fronts.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
      DIMENSION X(2),Y(2)
      DATA X/ 0.40, 0.90/
      DATA Y/ 0.85, 0.85/
      DATA DELY,XP,ALSIZ/0.09,0.375,0.024/
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C  Define a color table.
C
      CALL GSCR(IWKID, 0, 1.0, 1.0, 1.0)
      CALL GSCR(IWKID, 1, 0.0, 0.0, 0.0)
      CALL GSCR(IWKID, 2, 1.0, 0.0, 0.0)
      CALL GSCR(IWKID, 3, 0.5, 0.0, 0.7)
      CALL GSCR(IWKID, 4, 0.0, 1.0, 0.0)
      CALL GSCR(IWKID, 5, 1.0, 0.5, 0.0)
      CALL GSCR(IWKID, 6, 0.0, 0.0, 1.0)
C
C  Plot title.
C
      CALL PLCHHQ(0.50,0.95,':F26:Front Types',0.035,0.,0.)
C
C  Define some parameters.
C
      CALL WMSETR('LIN - line widths of warm/cold front lines',3.)
      CALL WMSETR('BEG - space before first front symbol',0.02)
      CALL WMSETR('END - space after last front symbol',0.02)
      CALL WMSETR('BET - space between front symbols',.03)
      CALL WMSETR('SWI - size of symbols on front line',.04)
      CALL WMSETI('WFC - color for warm front symbols',2)
      CALL WMSETI('CFC - color for cold front symbols',6)
C
C  Warm front.
C
      CALL WMSETC('FRO - front type','WARM')
      CALL WMSETI('REV - reverse the direction of the symbols',1)
      CALL WMDRFT(2,X,Y)      
      CALL PLCHHQ(XP,Y(1),':F22:Warm',ALSIZ,0.,1.)
C
C  Warm front, aloft.
C
      Y(1) = Y(1)-DELY
      Y(2) = Y(1)
      CALL WMSETC('FRO - fornt type','WARM')
      CALL WMSETI('ALO - specify aloft',1)
      CALL WMSETI('REV - reverse the direction of the symbols',1)
      CALL WMDRFT(2,X,Y)      
      CALL PLCHHQ(XP,Y(1),':F22:Warm, aloft',ALSIZ,0.,1.)
      CALL WMSETI('ALO - deactivate aloft flag',0)
C
C  Cold front.
C
      Y(1) = Y(1)-DELY
      Y(2) = Y(1)
      CALL WMSETC('FRO - front type','COLD')
      CALL WMSETI('REV - reverse the direction of the symbols',1)
      CALL WMDRFT(2,X,Y)      
      CALL PLCHHQ(XP,Y(1),':F22:Cold',ALSIZ,0.,1.)
C
C  Cold front, aloft.
C
      Y(1) = Y(1)-DELY
      Y(2) = Y(1)
      CALL WMSETC('FRO - front type','COLD')
      CALL WMSETI('ALO - specify aloft',1)
      CALL WMSETI('REV - reverse the direction of the symbols',1)
      CALL WMDRFT(2,X,Y)      
      CALL PLCHHQ(XP,Y(1),':F22:Cold, aloft',ALSIZ,0.,1.)
      CALL WMSETI('ALO - deactivate aloft flag',0)
C
C  Stationary front.
C
      Y(1) = Y(1)-DELY
      Y(2) = Y(1)
      CALL WMSETC('FRO - front type','STATIONARY')
      CALL WMSETI('REV - reverse the direction of the symbols',1)
      CALL WMDRFT(2,X,Y)      
      CALL PLCHHQ(XP,Y(1),':F22:Stationary',ALSIZ,0.,1.)
C
C  Stationary front, aloft.
C
      Y(1) = Y(1)-DELY
      Y(2) = Y(1)
      CALL WMSETC('FRO - front type','STATIONARY')
      CALL WMSETI('REV - reverse the direction of the symbols',1)
      CALL WMSETI('ALO - specify aloft',1)
      CALL WMDRFT(2,X,Y)      
      CALL PLCHHQ(XP,Y(1),':F22:Stationary, aloft',ALSIZ,0.,1.)
      CALL WMSETI('ALO - deactivate aloft flag',0)
C
C  Occluded front.
C
      Y(1) = Y(1)-DELY
      Y(2) = Y(1)
      CALL WMSETI('WFC - color for warm front symbols',3)
      CALL WMSETI('CFC - color for cold front symbols',3)
      CALL WMSETC('FRO - front type','OCCLUDED')
      CALL WMSETI('REV - reverse the direction of the symbols',1)
      CALL WMDRFT(2,X,Y)      
      CALL PLCHHQ(XP,Y(1),':F22:Occluded',ALSIZ,0.,1.)
C
C     CALL WMDFLT
      CALL WMSETR('DWD - line widths for fronts with no symbols',3.)
C
C  Convergence line
C
      Y(1) = Y(1)-DELY
      Y(2) = Y(1)
      CALL WMSETC('FRO - front type','CONVERGENCE')
      CALL WMSETI('COL - convergence lines are orange',5)
      CALL WMDRFT(2,X,Y)      
      CALL PLCHHQ(XP,Y(1),':F22:Convergence line',ALSIZ,0.,1.)
C
C  Instability line.
C
      Y(1) = Y(1)-DELY
      Y(2) = Y(1)
      CALL WMSETC('FRO - front type','SQUALL')
      CALL WMSETI('COL - instability line drawn in black',1)
      CALL WMDRFT(2,X,Y)      
      CALL PLCHHQ(XP,Y(1),':F22:Instability line',ALSIZ,0.,1.)
C
C  Intertropical front.
C
      Y(1) = Y(1)-0.9*DELY
      Y(2) = Y(1)
      CALL WMSETI('T1C - one color for alternating dash pattern',2) 
      CALL WMSETI('T2C - second color for dash pattern',4) 
      CALL WMSETC('FRO front type','TROPICAL')
      CALL WMDRFT(2,X,Y)      
      CALL PLCHHQ(XP,Y(1),':F22:Intertropical',ALSIZ,0.,1.)
C
      CALL FRAME
C
      CALL GDAWK(IWKID)
      CALL GCLWK(IWKID)
      CALL GCLKS
      STOP
C
      END

C
C       $Id: stmpxy.f,v 1.13 2008-07-27 00:17:28 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
C ---------------------------------------------------------------------
C
      SUBROUTINE STMPXY(XDA,YDA,XUS,YUS,IST)
C
C Transform a point in data coordinate space to user space
C
C Input parameters:
C
C XDA,YDA - Point in data coordinate space
C
C Output parameters:
C
C XUS,YUS - Point in user coordinate space
C IST     - Status code indicating success or failure
C
C --------------------------------------------------------------------
C
C The mapping common block: made available to user mapping routines
C
      COMMON /STMAP/
     +                IMAP       ,LNLG       ,INVX       ,INVY       ,
     +                XLOV       ,XHIV       ,YLOV       ,YHIV       ,
     +                WXMN       ,WXMX       ,WYMN       ,WYMX       ,
     +                XVPL       ,XVPR       ,YVPB       ,YVPT       ,
     +                XGDS       ,YGDS       ,NXCT       ,NYCT       ,
     +                ITRT       ,FW2W       ,FH2H       ,
     +                DFMG       ,VNML       ,RBIG       ,IBIG
C
      SAVE /STMAP/
C
C Math constants
C
      PARAMETER (PDTOR  = 0.017453292519943,
     +           PRTOD  = 57.2957795130823,
     +           P1XPI  = 3.14159265358979,
     +           P2XPI  = 6.28318530717959,
     +           P1D2PI = 1.57079632679489,
     +           P5D2PI = 7.85398163397448) 
C
C -------------------------------------------------------------
C
      IST=0
      IF (IMAP .EQ. 0) THEN
         XUS=XDA
         YUS=YDA
      ELSE IF (IMAP .EQ. 1) THEN
         CALL MAPTRA(YDA,XDA,XUS,YUS)
      ELSE IF (IMAP .EQ. 2) THEN
         XUS=XDA*COS(PDTOR*YDA)
         YUS=XDA*SIN(PDTOR*YDA)
      ELSE
         CALL STUMXY(XDA,YDA,XUS,YUS,IST)
      END IF
C
      IF (XUS.LT.WXMN .OR. XUS.GT.WXMX
     +     .OR. YUS.LT.WYMN .OR. YUS.GT.WYMX) THEN
         IST=-1
      END IF
C
C Done
C
      RETURN
      END
C
C ---------------------------------------------------------------------
C
      SUBROUTINE STIMXY(XUS,YUS,XDA,YDA,IST)
C
C Inversely transform a point in user coordinate space to data space
C
C Input parameters:
C
C XUS,YUS - Point in user coordinate space
C
C Output parameters:
C
C XDA,YDA - Point in data coordinate space
C IST     - Status code indicating success or failure
C
C --------------------------------------------------------------------
C
C The mapping common block: made available to user mapping routines
C
      COMMON /STMAP/
     +                IMAP       ,LNLG       ,INVX       ,INVY       ,
     +                XLOV       ,XHIV       ,YLOV       ,YHIV       ,
     +                WXMN       ,WXMX       ,WYMN       ,WYMX       ,
     +                XVPL       ,XVPR       ,YVPB       ,YVPT       ,
     +                XGDS       ,YGDS       ,NXCT       ,NYCT       ,
     +                ITRT       ,FW2W       ,FH2H       ,
     +                DFMG       ,VNML       ,RBIG       ,IBIG
C
      SAVE /STMAP/
C
C Math constants
C
      PARAMETER (PDTOR  = 0.017453292519943,
     +           PRTOD  = 57.2957795130823,
     +           P1XPI  = 3.14159265358979,
     +           P2XPI  = 6.28318530717959,
     +           P1D2PI = 1.57079632679489,
     +           P5D2PI = 7.85398163397448) 
C
C ---------------------------------------------------------------------
C
      IST=0
      IF (IMAP .EQ. 0) THEN
         XDA=XUS
         YDA=YUS
      ELSE IF (IMAP .EQ. 1) THEN
         CALL MAPTRI(XUS,YUS,YDA,XDA)
         IF (XDA .EQ. 1.E12 .OR. YDA .EQ. 1.E12) THEN
            IST = -1
            RETURN
         ENDIF
C
C MAPTRI always returns longitudes in the ranges -180. to +180.
C However, the user is allowed to express the data boundaries
C anywhere within the range -540. to +540. Therefore, the
C longitudinal values returned by MAPTRI may need adjustment.
C Latitudes are not adjusted, however.
C
         TLO = MIN(XLOV,XHIV)
         THI = MAX(XLOV,XHIV)
         IF (XDA .LT. TLO) THEN
            XDA = XDA + 360.0
            IF (XDA .GT. THI .OR. XDA .LT. TLO) THEN
               IST = -1
               RETURN
            END IF
         ELSE IF (XDA .GT. THI) THEN
            XDA = XDA - 360.0
            IF (XDA .LT. TLO .OR. XDA .GT. THI) THEN
               IST = -1
               RETURN
            ENDIF
         ENDIF
C
         IF (YDA.LT.MIN(YLOV,YHIV) .OR. YDA.GT.MAX(YLOV,YHIV)) THEN
            IST = -1
            RETURN
         ENDIF
C
       ELSE IF (IMAP .EQ. 2) THEN
         XDA=SQRT(XUS*XUS+YUS*YUS)
         YDA=PRTOD*ATAN2(YUS,XUS)
C
C Polar mapping has special bounds checking requirements.
C If YDA is less than YLOV, it is possible the user intends
C to treat some or all of quandrant 3 and 4 as positive angles
C (unlike ATAN2). Add 360 in this case.
C
         IF (YDA.LT.YLOV) YDA=YDA+360.0
C
      ELSE
         CALL STUIXY(XUS,YUS,XDA,YDA,IST)
      END IF
C
C Check for out of bound conditions
C
      IF (XDA.LT.MIN(XLOV,XHIV) .OR. XDA.GT.MAX(XHIV,XLOV)
     +     .OR. YDA.LT.MIN(YLOV,YHIV) .OR. YDA.GT.MAX(YHIV,YLOV)) THEN
         IST=-1
      END IF
C
C Done
C
      RETURN
      END
C
C ---------------------------------------------------------------------
C
      SUBROUTINE STMPTA(XDA,YDA,XUS,YUS,XND,YND,DU,DV,TA,IST)
C
C Map tangent angle to normalized device coordinate space.
C
C Input parameters:
C
C XDA,YDA - Point in data coordinate space
C XUS,YUS - Point in user coordinate space
C XND,YND - Point in NDC space
C DU,DV   - Differential vector components in data space
C
C Output parameters:
C
C TA      - Streamline tangent angle in NDC space
C IST     - Status code indicating success or failure
C
C In general the distance over which the angle is measured is 
C iteratively adjusted until it is becomes a small (but not too small)
C fraction of the fixed (in NDC space) increment distance.
C The transformation type parameter is implemented for the polar
C mapping only.
C
C --------------------------------------------------------------------
C
C The mapping common block: made available to user mapping routines
C
      COMMON /STMAP/
     +                IMAP       ,LNLG       ,INVX       ,INVY       ,
     +                XLOV       ,XHIV       ,YLOV       ,YHIV       ,
     +                WXMN       ,WXMX       ,WYMN       ,WYMX       ,
     +                XVPL       ,XVPR       ,YVPB       ,YVPT       ,
     +                XGDS       ,YGDS       ,NXCT       ,NYCT       ,
     +                ITRT       ,FW2W       ,FH2H       ,
     +                DFMG       ,VNML       ,RBIG       ,IBIG
C
      SAVE /STMAP/
C
C Math constants
C
      PARAMETER (PDTOR  = 0.017453292519943,
     +           PRTOD  = 57.2957795130823,
     +           P1XPI  = 3.14159265358979,
     +           P2XPI  = 6.28318530717959,
     +           P1D2PI = 1.57079632679489,
     +           P5D2PI = 7.85398163397448) 
C
C ---------------------------------------------------------------------
C
C Local parameters:
C
C PRCFAC - Precision factor used to resolve float equality within
C            the precision of a 4 byte REAL
C PVFRAC - Initial fraction of the vector magnitude used to
C            determine the differential increment
C IPMXCT - Number of times to allow the differential to increase
C PDUVML - Multiplier when the differential is increased
C PCSTST - Test value for closeness to 90 degree latitude
C
      PARAMETER (PRCFAC=1E5,
     +           PVFRAC=0.1,
     +           IPMXCT=40,
     +           PDUVML=2.0,
     +           PCSTST=PRCFAC*90.0)
C
C Local variables:
C
C XE,YE   - Current end of the temporary vector
C DV1     - First vector magnitude
C SGN     - Sign factor applied to differential
C DUV     - Incremental magnitude multiplier
C ICT     - Count of iterations
C XT,YT   - Temporary X,Y coordinates (User space)
C XTF,YTF - Temporary X,Y coordinates (NDC space)
C DV2     - Second vector magnitude
C CLT     - Cosine of the latitude
C DTX,DTY - Diffential values after accounting for the latitude
C DNX,DNY - Trial incremental values
C TH      - Angle theta
C
C ---------------------------------------------------------------------
C
      IST=0
C
      If (IMAP .EQ. 0) THEN
C
         XE=XND+DU
         YE=YND+DV
C
C If space mapping then more code is required
C
         IF (ITRT.GE.1) THEN
C
            DV1=SQRT((XE-XND)*(XE-XND)+(YE-YND)*(YE-YND))
C
C Set up an initial increment factor
C
            DUV=PVFRAC/VNML
            SGN=1.0
            ICT=0
C     
 10         CONTINUE
C
C Bail out if it's not working
C     
            IF (ICT .GT. IPMXCT) THEN
               IST = -3
               RETURN
            END IF
C
C Calculate the incremental end points, then check to see if 
C they take us out of the user coordinate boundaries. If they
C do, try incrementing in the other direction
C
            XT=XUS+SGN*DU*DUV
            YT=YUS+SGN*DV*DUV
            IF (XT .LT. WXMN .OR. XT .GT. WXMX .OR.
     +           YT .LT. WYMN .OR. YT .GT. WYMX) THEN
               IF (SGN.EQ.1.0) THEN
                  SGN = -1.0
                  GO TO 10
               ELSE
                  IST=-4
                  RETURN
               ENDIF
            END IF
C
C Convert to fractional coordinates and find the incremental
C distance in the fractional system. To ensure that this distance
C is meaningful, we require that it be between 1E3 and 1E4
C times smaller than the maximum vector length.
C 
            XTF=CUFX(XT)
            YTF=CUFY(YT)
            DV2=SQRT((XTF-XND)*(XTF-XND)+(YTF-YND)*(YTF-YND))
            IF (DV2*1E1 .GT. DFMG) THEN
               ICT=ICT+1
               DUV=DUV/PDUVML
               GO TO 10
            ELSE IF (DV2*1E2 .LT. DFMG) THEN
               ICT=ICT+1
               DUV=DUV*PDUVML
               GO TO 10
            END IF
C
C The actual endpoints are found using the ratio of the incremental
C distance to the actual distance times the fractional component
C length
            XE=XND+SGN*(XTF-XND)*DV1/DV2
            YE=YND+SGN*(YTF-YND)*DV1/DV2
C
         END IF
C
C Calculate the angle
C
         TA=ATAN2((YE-YND),(XE-XND))
C
C EZMAP overlay
C
      ELSE IF (IMAP .EQ. 1) THEN
C
C X is longitude, Y is latitude
C If Y is 90 degrees, can't compute a direction
C
         IF (INT(ABS(YDA)*PRCFAC+0.5) .GE. INT(PCSTST)) THEN
            IST=-1
            RETURN
         END IF
C
         SGN=1.0
         DUV=PVFRAC/VNML
         CLT=COS(YDA*PDTOR)
         DTX=DU/CLT
         DTY=DV
         ICT=0
C
 20      CONTINUE
C
         DNX=DTX*DUV
         DNY=DTY*DUV
C
C Bail out if it's not working
C     
         IF (ICT .GT. IPMXCT) THEN
            IST = -3
            RETURN
         END IF
C
C Calculate the incremental end points, then check to see if 
C they take us out of the user coordinate boundaries. If they
C do, try incrementing in the other direction
C
         CALL MAPTRA(YDA+SGN*DNY,XDA+SGN*DNX,XT,YT)
C
         IF (XT .LT. WXMN .OR. XT .GT. WXMX .OR.
     +        YT .LT. WYMN .OR. YT .GT. WYMX) THEN
            IF (SGN .EQ. 1) THEN
               SGN=-1.0
               GO TO 20
            ELSE
               IST=-4
               RETURN
            ENDIF
         END IF
C
C Convert to fractional coordinates and find the incremental
C distance in the fractional system. To ensure that this distance
C is meaningful, we require that it be between 1E3 and 1E4
C times smaller than the maximum vector length.
C 
         XTF=CUFX(XT)
         YTF=CUFY(YT)
         DV2=SQRT((XTF-XND)*(XTF-XND)+(YTF-YND)*(YTF-YND))
         IF (DV2*1E1 .GT. DFMG) THEN
            ICT=ICT+1
            DUV=DUV/PDUVML
            GO TO 20
         ELSE IF (DV2*1E2 .LT. DFMG) THEN
            ICT=ICT+1
            DUV=DUV*PDUVML
            GO TO 20
         END IF
C
         TA=ATAN2((SGN*(YTF-YND)),(SGN*(XTF-XND)))
C
      ELSE IF (IMAP .EQ. 2) THEN
C
C ... the polar coordinate case ...
C
         TA=ATAN2(DV,DU)
C
         IF (ITRT.GE.1) THEN
            TH=PDTOR*YDA
            TA=TH+TA
         END IF
C
C ... and everything else.
C
      ELSE
C
         CALL STUMTA(XDA,YDA,XUS,YUS,XND,YND,DU,DV,TA,IST)
C
      END IF
C
C Done.
C
      RETURN
C
      END

C
C	$Id: ffinfo.f,v 1.4 2008-07-27 12:23:41 haley Exp $
C                                                                      
C			     Copyright (C)  1997
C	     University Corporation for Atmospheric Research
C			     All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C

      SUBROUTINE FFINFO(IER)
C
C  Fill in the values for the initial technical information of
C  the fontcap.
C
      include 'fntcom.h'
C
C  Number of bits per integer; number of bytes per word.
C
      NBPERI = I1MACH(5)
      NBYPWD = NBPERI/8
C
C  Type flag.
C
      IS = 1
      TYPFLG = 0
      DO 10 I=1,16
        TYPFLG = IOR(TYPFLG,ISHIFT(IS,I-1))
   10 CONTINUE
C
C  Index table pointer (2*NUMNTR bytes, plus 40 bytes for the font
C  name, plus two bytes for the pointer to the last byte).
C
      TABPNT = NBYPWD*((2*NUMNTR+40+2-1)/NBYPWD)+NBYPWD
C
C  X bit width.
C
      MXF = MAX(IABS(FLLX),IABS(FLLY))
      IXWD = FRIGHT+MXF
      DO 20 I=1,16
        IF (IXWD .LT. 2**I) THEN
          XBITWD = I
          GO TO 30
        ENDIF
   20 CONTINUE
      IER = EXWD
      RETURN
   30 CONTINUE
C
C  Y bit width (must accommodate for the character width being stored`
C  in a Y coordinate position).
C
      IYWD = FRIGHT+MXF
      DO 40 I=1,16
        IF (IYWD .LT. 2**I) THEN
          YBITWD = I
          GO TO 50
        ENDIF
   40 CONTINUE
      IER = EYWD
      RETURN
   50 CONTINUE
C
C  X bias.
C
      IF (FLLEX .LT. 0) THEN
        XBIAS = IABS(FLLEX)
      ELSE
        XBIAS = -FLLEX
      ENDIF
C
C  Y bias.
C
      IF (FLLEY .LT. 0) THEN
        YBIAS = IABS(FLLEY)
      ELSE
        YBIAS = -FLLEY
      ENDIF
C
C  Special value flag field width.
C
      DO 60 I=1,16
        IF (SVNUM .LT. 2**I) THEN
          PKFLWD = I
          GO TO 70
        ENDIF
   60 CONTINUE
      IER = ESWD
      RETURN
   70 CONTINUE
C
C  Packet width.
C
      PKWID = PKFLWD+XBITWD+YBITWD
C
      RETURN
      END

C
C $Id: ezy.f,v 1.8 2008-07-27 00:14:36 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE EZY (YDRA,NPTS,LABG)
C
      REAL XDRA(1),YDRA(*)
C
      CHARACTER*(*) LABG
C
C The subroutine EZY draws one curve through the points (I,YDRA(I)), for
C I = 1, 2, ... NPTS.
C
      CALL AGGETI ('SET .',ISET)
      CALL AGGETI ('FRAM.',IFRA)
C
      CALL AGEZSU (1,XDRA,YDRA,NPTS,1,NPTS,LABG,IIVX,IIEX,IIVY,IIEY)
      CALL AGBACK
C
      IF (ISET.GE.0) CALL AGCURV (XDRA,0,YDRA,1,NPTS,1)
C
      IF (IFRA.EQ.1) CALL FRAME
C
      RETURN
C
      END

C
C $Id: qsfnsp.f,v 1.5 2008-07-27 00:17:12 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      REAL FUNCTION QSFNSP (ECCENT,SINPHI,COSPHI)
C
C FUNCTION TO COMPUTE CONSTANT (SMALL Q).
C
      IMPLICIT REAL (A-Z)
      DATA HALF,ONE,TWO /0.5E0,1.0E0,2.0E0/
      DATA EPSLN /1.0E-7/
C
      IF (ECCENT .LT. EPSLN) GO TO 020
      CON = ECCENT * SINPHI
      QSFNSP = (ONE - ECCENT * ECCENT) * (SINPHI / (ONE - CON * CON) -
     .         (HALF / ECCENT) * LOG ((ONE - CON) / (ONE + CON)))
      RETURN
C
  020 QSFNSP = TWO * SINPHI
      RETURN
      END

C
C $Id: ngritd.f,v 1.4 2008-07-27 00:17:18 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
C This is a modified version of ngritd.f that was generated using
C nag_apt to convert from single to double precision.
C
      SUBROUTINE DNGRITD (IAXS,ANGL,UCRD,VCRD,WCRD)
      DOUBLE PRECISION ANGL
      DOUBLE PRECISION UCRD
      DOUBLE PRECISION VCRD
      DOUBLE PRECISION WCRD
      DOUBLE PRECISION DTOR
      DOUBLE PRECISION SINA
      DOUBLE PRECISION COSA
      DOUBLE PRECISION UTMP
      DOUBLE PRECISION VTMP
      DOUBLE PRECISION WTMP
C
C Define a multiplicative constant to convert from degrees to radians.
C
        DATA DTOR / .017453292519943D0 /
C
C This routine rotates the point with coordinates (UCRD,VCRD,WCRD) by
C the angle ANGL about the axis specified by IAXS (1 for the U axis,
C 2 for the V axis, 3 for the W axis).  A right-handed coordinate
C system is assumed.
C
        SINA=SIN(DTOR*ANGL)
        COSA=COS(DTOR*ANGL)
C
        UTMP=UCRD
        VTMP=VCRD
        WTMP=WCRD
C
        IF (IAXS.EQ.1) THEN
          VCRD=VTMP*COSA-WTMP*SINA
          WCRD=WTMP*COSA+VTMP*SINA
        ELSE IF (IAXS.EQ.2) THEN
          UCRD=UTMP*COSA+WTMP*SINA
          WCRD=WTMP*COSA-UTMP*SINA
        ELSE
          UCRD=UTMP*COSA-VTMP*SINA
          VCRD=VTMP*COSA+UTMP*SINA
        END IF
C
        RETURN
C
      END

C NCLFORTSTART
      SUBROUTINE DRUNAVE(X,NPTS,NAVE,KOPT,XMSG,WORK,LWORK,IER)

C NCL function: x = runave (x,nave,kopt)

      INTEGER NPTS,NAVE,KOPT,IER
      DOUBLE PRECISION X(NPTS),XMSG
C NCLEND

      INTEGER LWORK
      DOUBLE PRECISION WORK(LWORK)

      NHALF = NAVE/2
      LWORK = NPTS + 2*NHALF

      CALL DRUNAVX77(X,NPTS,NAVE,KOPT,XMSG,WORK,LWORK,IER)

C NCL return (runave[x])
      RETURN
      END
C ---------------------------------------------------------
      SUBROUTINE DRUNAVX77(X,NPTS,NAVE,KOPT,XMSG,WORK,LW,IER)
      DOUBLE PRECISION XMSG
      DOUBLE PRECISION WGT
      DOUBLE PRECISION SUM

c same as runavx: slightly faster but larger memory for work

c this routine will perform a running average on x
c .   the end points may be treated in three different ways

c nomenclature:
c .   x         - on input the series to be smoothed
c .               on output the smoothed series
c .   npts      - no of pts in x
c .   nave     - no. of pts to be utilized in the running average
c .   kopt      - end-point option [prefer an odd number]
c .               kopt < 0 : utilize cyclic conditions
c .                          e.g.,  nave=3 at n=1 and n=npts
c .                          x(1)    = (x(npts)+x(1)+x(2)) / 3.
c .                          x(npts) = (x(npts-1)+x(npts)+x(1)) / 3.
c .                          e.g.,  nave=4 at n=1 and n=npts
c .                          x(1)    = (x(npts)+x(1)+x(2)+x(3)) / 4.
C*PL*ERROR* Comment line too long
c .                          x(npts) = (x(npts-2)+x(npts-1)+x(npts)+x(1)) / 4.
C*PL*ERROR* Comment line too long
c .               kopt = 0 : set unsmoothed beginning and end pts to xmsg
C*PL*ERROR* Comment line too long
c .                          e.g.,  nave=3 , x(1) = xmsg and x(npts) = xmsg
C*PL*ERROR* Comment line too long
c .                          e.g.,  nave=4 , x(1) = xmsg and x(2) = xmsg and
c .                                          x(npts) = xmsg
c .               kopt > 0 : utilize reflective (symmetric) conditions
c .                          e.g.,  nave=3 at n=1 and n=npts
c .                          x(1)    = (x(2)+x(1)+x(2)) / 3.
c .                          x(npts) = (x(npts-1)+x(npts)+x(npts-1)) /3.
c .                          e.g.,  nave=4 at n=1 and n=npts
c .                          x(1)    = (x(3)+x(2)+x(1)+x(2)) / 4.
C*PL*ERROR* Comment line too long
c .                          x(npts) = (x(npts-2)+x(npts-1)+x(npts)+x(npts-1)) /4.
c .   xmsg      - missing/special value
c .               also; if kopt=0 set end points to this special value
c .   work      - work vector
c .   lw        - length of work (=npts+2*N where N=nave/2)
c .   ier       - error flag
c .               ier = 0 : no errors
c .               ier = -11 : npts @ 0
c .               ier = -12 : npts < nave
c .               ier = -13 : nave is not odd

C do not need work this large
      DOUBLE PRECISION X(1:NPTS),WORK(LW)

      IER = 0
      IF (NPTS.LT.1) IER = -11
      IF (NAVE.GT.NPTS) IER = -12
      IF (IER.LT.0) RETURN

      IF (NAVE.LE.1) THEN
          DO N = 1,NPTS
C historical reasons
              WORK(N) = X(N)
          END DO
          RETURN
      END IF

      NAV = NAVE
      NAV2 = NAVE/2
      WGT = 1.D0/DBLE(NAV)
      LWORK = NPTS + 2*NAV2
C odd-even offset used below
      NOE = 0
      IF (MOD(NAVE,2).EQ.0) NOE = 1

      DO N = 1,LWORK
C preset to xmsg
          WORK(N) = XMSG
      END DO

      DO N = 1,NPTS
C stuff x into middle of work
          WORK(NAV2+N) = X(N)
      END DO
C pad work with appropriate values

      IF (KOPT.GT.0) THEN
          DO N = 1,NAV2
c c c        print *,"(nav2+1-n), (npts+nav2+n)=",
c c c+                (nav2+1-n), (npts+nav2+n)
              WORK(NAV2+1-N) = X(N+1)
              WORK(NPTS+NAV2+N) = X(NPTS-N)
          END DO
      ELSE IF (KOPT.LT.0) THEN
          DO N = 1,NAV2
c c c        print *,"(nav2+1-n), (npts+nav2+n)=",
c c c+                (nav2+1-n), (npts+nav2+n)
              WORK(NAV2+1-N) = X(NPTS+1-N)
              WORK(NPTS+NAV2+N) = X(N)
          END DO
      END IF

      IF (MOD(NAVE,2).EQ.0) THEN
c          print *," "
c          do n=1,lwork
c             write (*,"(' runavx77: ',3i4,3f8.2))") kopt,nav2,n,work(n)
c          end do
      END IF

      DO N = 1,NPTS
          KMSG = 0
          SUM = 0.D0
          NMID = N + NAV2 + NOE
          MSTRT = NMID - NAV2
          MLAST = MSTRT + NAV - 1
          DO M = MSTRT,MLAST
              IF (WORK(M).NE.XMSG) THEN
                  SUM = SUM + WORK(M)
              ELSE
                  KMSG = KMSG + 1
              END IF
          END DO

          IF (KMSG.EQ.0) THEN
C all values
              X(N) = SUM*WGT
          ELSE
C msg values encountered
              X(N) = XMSG
          END IF
      END DO

CDIR$ IVDEP
C return x in work(1 => npts)
c     do n=1,npts
C for historical reasons
c        work(n) = work(nav2+n)
c     enddo

      RETURN
      END

      PROGRAM CTTERR
C
C
C D E S C R I P T I O N ------------------------------------------------
C
C
C This example illustrates the use of CONPACKT to draw contours on a
C simple triangular mesh derived from a rectangular grid in the plane
C and it shows, in great detail, how the mesh was constructed.  If you
C want to learn how to do that, this is the best example to study; if
C not, you may find one of the other examples somewhat easier to follow,
C since, in general, those examples use one of the two canned routines
C in CONPACKT to construct a triangular mesh.
C
C
C D E C L A R A T I O N S ----------------------------------------------
C
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.  Use one
C of the following:
C
C       PARAMETER (IERF=6,LUNI=2,IWTY=1 ,IWID=1)  !  NCGM
C       PARAMETER (IERF=6,LUNI=2,IWTY=8 ,IWID=1)  !  X Windows
C       PARAMETER (IERF=6,LUNI=2,IWTY=20,IWID=1)  !  PostScript
C       PARAMETER (IERF=6,LUNI=2,IWTY=11,IWID=1)  !  PDF, Portrait
C       PARAMETER (IERF=6,LUNI=2,IWTY=12,IWID=1)  !  PDF, Landscape
C
        PARAMETER (IERF=6,LUNI=2,IWTYPE=1,IWTY=IWTYPE,IWID=1)
C
C Assume we have a regular rectangular grid, dimensioned IDIM x JDIM,
C where IDIM is the number of points in a horizontal row and JDIM is
C the number of rows.
C
        PARAMETER (IDIM=4000,JDIM=62,IDM1=IDIM-1,JDM1=JDIM-1)
C
C We will read data from some user datasets into these arrays:
C
        DIMENSION IXDT(IDIM,JDIM),IYDT(IDIM,JDIM),IZDT(IDIM,JDIM)
C
C and recreate the original data in these:
C
        DIMENSION XDAT(IDIM,JDIM),YDAT(IDIM,JDIM),ZDAT(IDIM,JDIM)
C
C We derive a triangular mesh from the rectangular grid by dividing
C each rectangular cell in half along one of its diagonals (from lower
C left to upper right in half of them and from upper left to lower right
C in the other half).  To represent the triangular mesh, we use three
C singly-dimensioned arrays: RPNT holds information about points; IEDG,
C information about edges; and ITRI, information about triangles.  The
C elements of each array form "nodes" having lengths as follows:
C
        PARAMETER (LOPN=4)
        PARAMETER (LOEN=5)
        PARAMETER (LOTN=4)
C
C The four elements of a point node, in RPNT, are
C
C   1. the X coordinate of the point;
C   2. the Y coordinate of the point;
C   3. the Z coordinate of the point (always 0 in this example);
C   4. the field value at the point;
C
C The five elements of an edge node, in IEDG, are
C
C   1. the "base index", in RPNT, of point 1 of the edge;
C   2. the "base index", in RPNT, of point 2 of the edge;
C   3. the index, in ITRI, of the pointer to the edge in the node for
C      the triangle to its left (-1 if there is no triangle there);
C   4. the index, in ITRI, of the pointer to the edge in the node for
C      the triangle to its right (-1 if there is no triangle there);
C   5. a utility flag for use by algorithms that scan the structure.
C
C (The "left" and "right" sides of an edge are defined as they would be
C by an observer standing at point 1 of the edge, looking toward point
C 2 of the edge.  It is possible, if there are "holes" in the mesh, that
C there will be no triangle to the left or to the right of an edge, but
C there must be a triangle on one side or the other.)
C
C The four elements of a triangle node, in ITRI, are
C
C   1. the "base index", in IEDG, of edge 1 of the triangle;
C   2. the "base index", in IEDG, of edge 2 of the triangle;
C   3. the "base index", in IEDG, of edge 3 of the triangle;
C   4. a flag set non-zero to block use of the triangle, effectively
C      removing it from the mesh.
C
C The edges pointed to by a triangle node must be in counterclockwise
C order, as viewed from above the mesh.
C
C The "base index" of a point node, an edge node, or a triangle node is
C a non-negative multiple of the length of the node, to which can be
C added an offset to get the index of a particular element of the node.
C Suppose I is the base index of a triangle node; then ITRI(I+1) is
C the triangle node's first element, whose value is the base index of
C the node in IEDG that describes the first edge of the triangle.  So
C IEDG(ITRI(I+1)+2) is the second element of that edge node (whose value
C is the base index of the node describing the second point of the first
C edge of the triangle with base index I.  Similarly, then, we see that
C RPNT(IEDG(ITRI(I+1)+2)+3) is the third (Z) coordinate of the second
C point of the first edge of the triangle with base index I.
C
C The pointers from edge nodes back to triangle nodes (elements 3 and 4)
C allow CONPACKT to navigate the mesh, moving from triangle to triangle
C as it follows a contour line; the pointers are a bit trickily defined:
C if IPTE is the base index of an edge node and IEDG(IPTE+3) is zero or
C more, saying that there is a triangle to the left of the edge, then
C IEDG(IPTE+3) is the actual index of that element of the triangle node
C that points to the edge node; i.e., ITRI(IEDG(IPTE+3))=IPTE.  The base
C index of the triangle node is IPTL, where IPTL is the largest multiple
C of LOTN which is less than IEDG(IPTE+3), as defined by the formula
C IPTL=LOTN*((IEDG(IPTE+3)-1)/LOTN), and the index of the pointer to
C the edge within the triangle node is IPIL=IEDG(IPTE+3)-IPTL (which
C will have the value 1, 2, or 3); observe that IEDG(IPTL+IPIL)=IPTE.
C Similar comments apply to element 4 of an edge node, which, if zero or
C more, points into the triangle node defining the triangle to the right
C of the edge: ITRI(IEDG(IPTE+4))=IPTE; the base index of the node for
C the triangle to the right is IPTR=LOTN*((IEDG(IPTE+4)-1)/LOTN); the
C index of the pointer to the edge within the triangle node is IPIR=
C IEDG(IPTE+4)-IPTR; and, again, observe that IEDG(IPTR+IPIR)=IPTE.
C
C Compute the number of point nodes, edge nodes, and triangle nodes that
C the triangular mesh arrays will need to hold.  The formulas for the
C numbers of point nodes and triangle nodes ought to be quite obvious.
C The one for the number of edge nodes may not be quite so obvious; it
C is based on the facts that each cell of the rectangular grid contains
C one horizontal edge, one vertical edge, and one diagonal edge; that
C there are IDM1 more horizontal edges along the top of the grid; and
C that there are JDM1 more vertical edges along the right edge of the
C grid.
C
        PARAMETER (NOPN=IDIM*JDIM)
        PARAMETER (NOEN=3*IDM1*JDM1+IDM1+JDM1)
        PARAMETER (NOTN=2*IDM1*JDM1)
C
C Now, compute the amount of space we will need in the arrays.  Each
C quantity is a number of nodes multiplied by the length of a node.
C
        PARAMETER (NPNT=NOPN*LOPN)
        PARAMETER (NEDG=NOEN*LOEN)
        PARAMETER (NTRI=NOTN*LOTN)
C
C Declare the arrays to hold the point nodes, edge nodes, and triangle
C nodes defining the triangular mesh.
C
        DIMENSION RPNT(NPNT),IEDG(NEDG),ITRI(NTRI)
C
C Declare real and integer workspaces needed by CONPACKT.
C
        PARAMETER (LRWK=10000,LIWK=1000)
C
        DIMENSION RWRK(LRWK),IWRK(LIWK)
C
C Declare the area map array needed to do solid fill.
C
        PARAMETER (LAMA=6000000)
C
        DIMENSION IAMA(LAMA)
C
C Declare workspace arrays to be used in calls to the AREAS routine
C ARSCAM.
C
        PARAMETER (NCRA=LAMA/10,NGPS=2)
C
        DIMENSION XCRA(NCRA),YCRA(NCRA),IAAI(NGPS),IAGI(NGPS)
C
C Declare arrays in which to generate a cell array picture of the data
C on the triangular mesh.
C
        PARAMETER (ICAM=512,ICAN=512)
C
        DIMENSION ICRA(ICAM,ICAN)
C
C Declare external the routine that does color fill of contour bands.
C
        EXTERNAL DCFOCB
C
C
C A R I T H M E T I C   S T A T E M E N T   F U N C T I O N S ----------
C
C
C The arithmetic statement functions are used to enumerate the points,
C edges, and triangles of the rectangular mesh, so that we can assign
C each of them to a unique position in the arrays defining the point
C nodes, the edge nodes, and the triangle nodes of the triangular mesh.
C (The first frame produced by this program shows the enumerations of
C the points, edges, and triangles, as determined by the functions,
C and will be helpful while reading their descriptions.)
C
C The value of the function INPT(I,J) is a unique integer between 1 and
C IDIM*JDIM, to be assigned to the point of the rectangular mesh having
C indices (I,J).  INPT enumerates the IDIM*JDIM points of the mesh, row
C by row, from bottom to top, and, within each row, from left to right.
C
        INPT(I,J)=(J-1)*IDIM+I
C
C The value of the function INE1(I,J) is a unique integer between 1 and
C IDM1*JDIM, to be assigned to the horizontal edge of the rectangular
C mesh whose left end point has indices (I,J) and whose right end point
C has indices (I+1,J).  INE1 enumerates the IDM1*JDIM horizontal edges
C of the mesh, row by row, from bottom to top, and, within each row,
C from left to right.
C
        INE1(I,J)=(J-1)*IDM1+I
C
C The value of the function INE2(I,J) is a unique integer between
C IDM1*JDIM+1 and IDM1*JDIM+IDIM*JDM1, to be assigned to the vertical
C edge of the rectangular mesh whose bottom end point has indices (I,J)
C and whose top end point has indices (I,J+1).  INE2 enumerates the
C IDIM*JDM1 vertical edges of the mesh, row by row, from bottom to top,
C and, within each row, from left to right.
C
        INE2(I,J)=(J-1)*IDIM+I+IDM1*JDIM
C
C The value of the function INE3(I,J) is a unique integer between
C IDM1*JDIM+IDIM*JDM1+1 and IDM1*JDIM+IDIM*JDM1+IDM1*JDM1, to be
C assigned to a diagonal of the cell of the rectangular mesh with
C lower left corner at indices (I,J).  INE3 enumerates the IDM1*JDM1
C diagonal edges of the mesh, row by row, from bottom to top, and,
C within each row, from left to right.
C
        INE3(I,J)=(J-1)*IDM1+I+IDM1*JDIM+IDIM*JDM1
C
C The value of the function INTR(I,J,K) is a unique integer between 1
C and 2*IDM1*JDM1, to be assigned to triangle K (where K is a 1 or a 2)
C in the cell of the rectangular mesh with lower left corner at indices
C (I,J).  INTR enumerates the triangles of the mesh, row by row, from
C bottom to top; within each row, from left to right; and within each
C cell of the rectangular mesh, from one half to the other.
C
        INTR(I,J,K)=2*((J-1)*IDM1+I-1)+K
C
C Each of the functions IBPT(I,J), IBE1(I,J), IBE2(I,J), IBE3(I,J), and
C IBTR(I,J,K) generates the base index of a point node, an edge node,
C or a triangle node of a particular type.  In each case, we use the
C ordinal number of the node, minus one, times the length of the node.
C
        IBPT(I,J  )=(INPT(I,J  )-1)*LOPN
        IBE1(I,J  )=(INE1(I,J  )-1)*LOEN
        IBE2(I,J  )=(INE2(I,J  )-1)*LOEN
        IBE3(I,J  )=(INE3(I,J  )-1)*LOEN
        IBTR(I,J,K)=(INTR(I,J,K)-1)*LOTN
C
C
C R E A D   T H E   U S E R   D A T A ----------------------------------
C
C
C XDAT, YDAT, and ZDAT were read from "x_terrain.dat", "y_terrain.dat",
C and "z_terrain.dat", respectively.
C
C       OPEN (11,FILE='x_terrain.dat',STATUS='OLD',FORM='FORMATTED')
C       READ (11,*) XDAT
C       CLOSE (11)
C
C       OPEN (11,FILE='y_terrain.dat',STATUS='OLD',FORM='FORMATTED')
C       READ (11,*) YDAT
C       CLOSE (11)
C
C       OPEN (11,FILE='z_terrain.dat',STATUS='OLD',FORM='FORMATTED')
C       READ (11,*) ZDAT
C       CLOSE (11)
C
C In the interest of saving file space, the numbers were converted to
C integers, which can be read from the file "ctterr.dat" and converted
C back into reals.
C
        OPEN (11,FILE='ctterr.dat',STATUS='OLD',FORM='FORMATTED')
        READ (11,'(2E16.0)') XMIN,XMAX,YMIN,YMAX,ZMIN,ZMAX
        READ (11,'(13I6)') IXDT,IYDT,IZDT
        CLOSE (11)
C
        DO 100 I=1,IDIM
        DO 100 J=1,JDIM
          XDAT(I,J)=XMIN+(XMAX-XMIN)*(REAL(IXDT(I,J)/999999.))
          YDAT(I,J)=YMIN+(YMAX-YMIN)*(REAL(IYDT(I,J)/999999.))
          ZDAT(I,J)=ZMIN+(ZMAX-ZMIN)*(REAL(IZDT(I,J)/999999.))
  100   CONTINUE
C
C
C C R E A T E   A   T R I A N G U L A R   M E S H ----------------------
C
C
C Define the points of the mesh.  There are IDIM points per row on each
C of JDIM rows.  The point with indices (I,J) in the rectangular mesh
C is assigned to the point node with base index IBPT(I,J).  Its X and Y
C coordinates are taken from the array XDAT and YDAT, respectively, and
C it is given a data value from the array ZDAT.
C
        DO 102 I=1,IDIM
          DO 101 J=1,JDIM
            IBIP=IBPT(I,J)
            RPNT(IBIP+1)=XDAT(I,J)
            RPNT(IBIP+2)=YDAT(I,J)
            RPNT(IBIP+3)=0.
            RPNT(IBIP+4)=ZDAT(I,J)
  101     CONTINUE
  102   CONTINUE
C
C Define the edges of the mesh, each of which joins two adjacent points
C of it, in three groups.
C
C The first group of edges are horizontal; there are IDIM-1 per row on
C each of JDIM rows.  Each joins two points with rectangular indices
C (I,J) and (I+1,J), for some I in [1,IDIM-1] and some J in [1,JDIM],
C and is assigned to the edge node with base index IBE1(I,J).  Its first
C two elements are base indices of the points that it joins; its third
C and fourth elements indicate that there are no triangles to its left
C and right, respectively (which may change when we define the triangle
C list); and its fifth element is initialized to zero.
C
C NOTE (03/09/2006): For procedural reasons, I need to remove all the
C exclamation-point comments from the following code.  That makes the
C code much harder to follow, so, in several places, I'm putting in
C two copies of the code, the first of which has C's in column 1 and
C the second of which has the exclamation-point comments removed.
C
C Original version (easier to follow, but commented out):
C
C       DO 104 I=1,IDM1
C         DO 103 J=1,JDIM
C           IBIE=IBE1(I,J)
C           IEDG(IBIE+1)=IBPT(I  ,J  )   ! 1st end point
C           IEDG(IBIE+2)=IBPT(I+1,J  )   ! 2nd end point (right of 1st)
C           IEDG(IBIE+3)=-1              ! no triangle on left
C           IEDG(IBIE+4)=-1              ! no triangle on right
C           IEDG(IBIE+5)=0               ! utility flag unset
C 103     CONTINUE
C 104   CONTINUE
C
C Version with exclamation-point comments removed (for compiler):
C
        DO 104 I=1,IDM1
          DO 103 J=1,JDIM
            IBIE=IBE1(I,J)
            IEDG(IBIE+1)=IBPT(I  ,J  )
            IEDG(IBIE+2)=IBPT(I+1,J  )
            IEDG(IBIE+3)=-1
            IEDG(IBIE+4)=-1
            IEDG(IBIE+5)=0
  103     CONTINUE
  104   CONTINUE
C
C The second group of edges are vertical; there are IDIM per row on
C each of JDIM-1 rows.  Each joins two points with rectangular indices
C (I,J) and (I,J+1), for some I in [1,IDIM] and some J in [1,JDIM-1],
C and is assigned to the edge node with base index IBE2(I,J).  Its first
C two elements are base indices of the points that it joins; its third
C and fourth elements indicate that there are no triangles to its left
C and right, respectively (which may change when we define the triangle
C list); and its fifth element is initialized to zero.
C
C Original version (easier to follow, but commented out):
C
C       DO 106 I=1,IDIM
C         DO 105 J=1,JDM1
C           IBIE=IBE2(I,J)
C           IEDG(IBIE+1)=IBPT(I  ,J  )   ! 1st end point
C           IEDG(IBIE+2)=IBPT(I  ,J+1)   ! 2nd end point (above 1st)
C           IEDG(IBIE+3)=-1              ! no triangle on left
C           IEDG(IBIE+4)=-1              ! no triangle on right
C           IEDG(IBIE+5)=0               ! utility flag unset
C 105     CONTINUE
C 106   CONTINUE
C
C Version with exclamation-point comments removed (for compiler):
C
        DO 106 I=1,IDIM
          DO 105 J=1,JDM1
            IBIE=IBE2(I,J)
            IEDG(IBIE+1)=IBPT(I  ,J  )
            IEDG(IBIE+2)=IBPT(I  ,J+1)
            IEDG(IBIE+3)=-1
            IEDG(IBIE+4)=-1
            IEDG(IBIE+5)=0
  105     CONTINUE
  106   CONTINUE
C
C The third group of edges are diagonals; there are IDIM-1 per row on
C each of JDIM-1 rows.  Each joins two points with rectangular indices
C (I,J) and (I+1,J+1), if the sum of I and J is even, or (I,J+1) and
C (I+1,J), if the sum of I and J is odd, for some I in [1,IDIM-1] and
C some J in [1,JDIM-1], and is assigned to the edge node with base index
C IBE3(I,J).  Its first two elements are base indices of the points that
C it joins; its third and fourth elements indicate that there are no
C triangles to its left and right, respectively (which may change when
C we define the triangle list); and its fifth element is initialized to
C zero.  (Using different diagonals in a checkerboard fashion yields a
C more pleasant pattern to look at than always using the same diagonal
C would.)
C
C Original version (easier to follow, but commented out):
C
C       DO 108 I=1,IDM1
C         DO 107 J=1,JDM1
C           IBIE=IBE3(I,J)
C           IF (MOD(I+J,2).EQ.0)
C    +      THEN  !  diagonal is from lower left to upper right
C             IEDG(IBIE+1)=IBPT(I  ,J  ) ! 1st end point lower left
C             IEDG(IBIE+2)=IBPT(I+1,J+1) ! 2nd end point upper right
C             IEDG(IBIE+3)=-1            ! no triangle on left
C             IEDG(IBIE+4)=-1            ! no triangle on right
C             IEDG(IBIE+5)=0             ! utility flag unset
C           ELSE  !  diagonal is from upper left to lower right
C             IEDG(IBIE+1)=IBPT(I  ,J+1) ! 1st end point upper left
C             IEDG(IBIE+2)=IBPT(I+1,J  ) ! 2nd end point lower right
C             IEDG(IBIE+3)=-1            ! no triangle on left
C             IEDG(IBIE+4)=-1            ! no triangle on right
C             IEDG(IBIE+5)=0             ! utility flag unset
C           END IF
C 107     CONTINUE
C 108   CONTINUE
C
C Version with exclamation-point comments removed (for compiler):
C
        DO 108 I=1,IDM1
          DO 107 J=1,JDM1
            IBIE=IBE3(I,J)
            IF (MOD(I+J,2).EQ.0)
     +      THEN
              IEDG(IBIE+1)=IBPT(I  ,J  )
              IEDG(IBIE+2)=IBPT(I+1,J+1)
              IEDG(IBIE+3)=-1
              IEDG(IBIE+4)=-1
              IEDG(IBIE+5)=0
            ELSE
              IEDG(IBIE+1)=IBPT(I  ,J+1)
              IEDG(IBIE+2)=IBPT(I+1,J  )
              IEDG(IBIE+3)=-1
              IEDG(IBIE+4)=-1
              IEDG(IBIE+5)=0
            END IF
  107     CONTINUE
  108   CONTINUE
C
C Finally, we define the triangles of the mesh.  The following diagrams
C should be useful in understanding the code that follows:
C
C   CASE 1:  MOD(I+J,2)=0
C
C   +-----a-----+
C   |         . |   In this case, triangles 1 and 2 are in the lower
C   |  2    .   |   right and upper left corners of the rectangular
C   b     c     b   cell, respectively.  The edges of each are labeled
C   |   .    1  |   a (a horizontal edge), b (a vertical edge), and c
C   | .         |   (a diagonal edge).
C   +-----a-----+
C
C   CASE 2:  MOD(I+J,2)=1
C
C   +-----b-----+
C   | .         |   In this case, triangles 1 and 2 are in the lower
C   |   .    2  |   left and upper right corners of the rectangular
C   a     c     a   cell, respectively.  The edges of each are labeled
C   |  1    .   |   a (a vertical edge), b (a horizontal edge), and c
C   |         . |   (a diagonal edge).
C   +-----b-----+
C
C There are JDIM-1 rows of rectangles, with IDIM-1 rectangles in each
C row; each rectangle gives rise to two triangles.  A triangle node
C has the base index IBTR(I,J,K), where I and J specify the lower left
C corner of a cell of the rectangular mesh and K is 1 or 2 for the lower
C and upper triangles in the cell, respectively.  Elements 1, 2, and 3
C of the triangle node are base indices of the edge nodes for the edges
C of the triangle; these are arranged in the order "abc" to ensure that
C they are given in counterclockwise order, as required by CONPACKT.
C Element 4 of the triangle node is a zero, indicating that the triangle
C is not "blocked".  (Later, certain triangles will be blocked as an
C illustration of the capability.)
C
C As each triangle is defined, we also modify element 3 or element 4,
C as appropriate, in each of the edge nodes defining its edges so as
C to point back into the triangle node.  It becomes important, in doing
C this, to remember that the ordering of the points used to define the
C edges is such that the horizontal edges "point" from left to right,
C the vertical edges from bottom to top, and the diagonal edges from
C lower left to upper right (when K=1) or from upper left to lower
C right (when K=2); these conventions tell us whether a given triangle
C is to the left or to the right of a given edge.
C
C Original version (easier to follow, but commented out):
C
C       DO 111 I=1,IDM1
C         DO 110 J=1,JDM1
C           DO 109 K=1,2
C             IBIT=IBTR(I,J,K)
C             IF (MOD(I+J,2).EQ.0)
C    +        THEN  !  diagonal is from lower left to upper right
C               IF (K.EQ.1) THEN              ! lower right triangle
C                 ITRI(IBIT+1)=IBE1(I  ,J  )  ! edge a
C                 ITRI(IBIT+2)=IBE2(I+1,J  )  ! edge b
C                 ITRI(IBIT+3)=IBE3(I  ,J  )  ! edge c
C                 ITRI(IBIT+4)=0              ! triangle unblocked
C                 IEDG(ITRI(IBIT+1)+3)=IBIT+1 ! triangle left of edge a
C                 IEDG(ITRI(IBIT+2)+3)=IBIT+2 ! triangle left of edge b
C                 IEDG(ITRI(IBIT+3)+4)=IBIT+3 ! triangle right of edge c
C               ELSE                          ! upper left triangle
C                 ITRI(IBIT+1)=IBE1(I  ,J+1)  ! edge a
C                 ITRI(IBIT+2)=IBE2(I  ,J  )  ! edge b
C                 ITRI(IBIT+3)=IBE3(I  ,J  )  ! edge c
C                 ITRI(IBIT+4)=0              ! triangle unblocked
C                 IEDG(ITRI(IBIT+1)+4)=IBIT+1 ! triangle right of edge a
C                 IEDG(ITRI(IBIT+2)+4)=IBIT+2 ! triangle right of edge b
C                 IEDG(ITRI(IBIT+3)+3)=IBIT+3 ! triangle left of edge c
C               END IF
C             ELSE  !  diagonal is from upper left to lower right
C               IF (K.EQ.1) THEN              ! lower left triangle
C                 ITRI(IBIT+1)=IBE2(I  ,J  )  ! edge a
C                 ITRI(IBIT+2)=IBE1(I  ,J  )  ! edge b
C                 ITRI(IBIT+3)=IBE3(I  ,J  )  ! edge c
C                 ITRI(IBIT+4)=0              ! triangle unblocked
C                 IEDG(ITRI(IBIT+1)+4)=IBIT+1 ! triangle right of edge a
C                 IEDG(ITRI(IBIT+2)+3)=IBIT+2 ! triangle left of edge b
C                 IEDG(ITRI(IBIT+3)+4)=IBIT+3 ! triangle right of edge c
C               ELSE                          ! upper right triangle
C                 ITRI(IBIT+1)=IBE2(I+1,J  )  ! edge a
C                 ITRI(IBIT+2)=IBE1(I  ,J+1)  ! edge b
C                 ITRI(IBIT+3)=IBE3(I  ,J  )  ! edge c
C                 ITRI(IBIT+4)=0              ! triangle unblocked
C                 IEDG(ITRI(IBIT+1)+3)=IBIT+1 ! triangle left of edge a
C                 IEDG(ITRI(IBIT+2)+4)=IBIT+2 ! triangle right of edge b
C                 IEDG(ITRI(IBIT+3)+3)=IBIT+3 ! triangle left of edge c
C               END IF
C             END IF
C 109       CONTINUE
C 110     CONTINUE
C 111   CONTINUE
C
C Version with exclamation-point comments removed (for compiler):
C
        DO 111 I=1,IDM1
          DO 110 J=1,JDM1
            DO 109 K=1,2
              IBIT=IBTR(I,J,K)
              IF (MOD(I+J,2).EQ.0)
     +        THEN
                IF (K.EQ.1) THEN
                  ITRI(IBIT+1)=IBE1(I  ,J  )
                  ITRI(IBIT+2)=IBE2(I+1,J  )
                  ITRI(IBIT+3)=IBE3(I  ,J  )
                  ITRI(IBIT+4)=0
                  IEDG(ITRI(IBIT+1)+3)=IBIT+1
                  IEDG(ITRI(IBIT+2)+3)=IBIT+2
                  IEDG(ITRI(IBIT+3)+4)=IBIT+3
                ELSE
                  ITRI(IBIT+1)=IBE1(I  ,J+1)
                  ITRI(IBIT+2)=IBE2(I  ,J  )
                  ITRI(IBIT+3)=IBE3(I  ,J  )
                  ITRI(IBIT+4)=0
                  IEDG(ITRI(IBIT+1)+4)=IBIT+1
                  IEDG(ITRI(IBIT+2)+4)=IBIT+2
                  IEDG(ITRI(IBIT+3)+3)=IBIT+3
                END IF
              ELSE
                IF (K.EQ.1) THEN
                  ITRI(IBIT+1)=IBE2(I  ,J  )
                  ITRI(IBIT+2)=IBE1(I  ,J  )
                  ITRI(IBIT+3)=IBE3(I  ,J  )
                  ITRI(IBIT+4)=0
                  IEDG(ITRI(IBIT+1)+4)=IBIT+1
                  IEDG(ITRI(IBIT+2)+3)=IBIT+2
                  IEDG(ITRI(IBIT+3)+4)=IBIT+3
                ELSE
                  ITRI(IBIT+1)=IBE2(I+1,J  )
                  ITRI(IBIT+2)=IBE1(I  ,J+1)
                  ITRI(IBIT+3)=IBE3(I  ,J  )
                  ITRI(IBIT+4)=0
                  IEDG(ITRI(IBIT+1)+3)=IBIT+1
                  IEDG(ITRI(IBIT+2)+4)=IBIT+2
                  IEDG(ITRI(IBIT+3)+3)=IBIT+3
                END IF
              END IF
  109       CONTINUE
  110     CONTINUE
  111   CONTINUE
C
C
C O P E N   A N D   I N I T I A L I Z E   G K S ------------------------
C
C
C Open GKS.
C
        CALL GOPKS (IERF,0)
        CALL GOPWK (IWID,LUNI,IWTY)
        CALL GACWK (IWID)
C
C Turn off the clipping indicator.
C
        CALL GSCLIP (0)
C
C Define a basic set of colors (0 = white, background; 1 = black,
C foreground; 2 = yellow; 3 = magenta; 4 = red; 5 = cyan; 6 = green;
C 7 = blue; 8 = a yellow for unblocked portions of the mesh; and 9 =
C a yellow for blocked portions of the mesh).
C
        CALL GSCR   (IWID, 0,1.,1.,1.)
        CALL GSCR   (IWID, 1,0.,0.,0.)
        CALL GSCR   (IWID, 2,1.,1.,0.)
        CALL GSCR   (IWID, 3,1.,0.,1.)
        CALL GSCR   (IWID, 4,1.,0.,0.)
        CALL GSCR   (IWID, 5,0.,1.,1.)
        CALL GSCR   (IWID, 6,0.,1.,0.)
        CALL GSCR   (IWID, 7,0.,0.,1.)
        CALL GSCR   (IWID, 8,.8,.8,0.)
        CALL GSCR   (IWID, 9,1.,1.,0.)
C
C Define 100 colors, associated with color indices 151 through 250, to
C be used for color-filled contour bands and in cell arrays, ranging
C from blue to red.
C
        CALL DFCLRS (IWID,151,250,0.,0.,1.,1.,0.,0.)
C
C
C S E T   I N T E R N A L   P A R A M E T E R S ------------------------
C
C
C Tell PLOTCHAR to use one of the filled fonts and to outline each
C character.
C
        CALL PCSETI ('FN',25)
        CALL PCSETI ('OF',1)
C
C Tell CONPACKT to use a smaller viewport, to match what is used in
C drawing the picture of the triangular mesh.
C
        CALL CTSETR ('VPL - VIEWPORT LEFT  ',.1)
        CALL CTSETR ('VPR - VIEWPORT RIGHT ',.9)
        CALL CTSETR ('VPB - VIEWPORT TOP   ',.1)
        CALL CTSETR ('VPT - VIEWPORT BOTTOM',.9)
C
C Tell CONPACKT to draw the mesh's outer boundary in red.
C
        CALL CTSETI ('PAI - PARAMETER ARRAY INDEX',-1)
        CALL CTSETI ('CLU - CONTOUR LEVEL USE FLAG',1)
        CALL CTSETI ('CLC - CONTOUR LEVEL COLOR INDEX',4)
C
C Tell CONPACKT to use bigger labels on contours drawn by the dash
C package and to put them a little closer together.
C
        CALL CTSETR ('DPS - DASH PATTERN SIZE (CHARACTERS)',.015)
        CALL CTSETR ('DPV - DASH PATTERN VECTOR LENGTH',.0025)
C
C Set the cell array flag in CONPACKT.
C
        CALL CTSETI ('CAF - CELL ARRAY FLAG',-1)
C
C Tell CONPACKT to use more than the usual number of contours.
C
        CALL CTSETI ('CLS - CONTOUR LEVEL SELECTION FLAG',64)
C
C Tell CONPACKT to call DASHPACK instead of DASHCHAR.
C
        CALL CTSETI ('DPU - DASH PATTERN USE FLAG',-3)
C
C Initialize CONPACKT.
C
        CALL CTMESH (RPNT,NPNT,LOPN,
     +               IEDG,NEDG,LOEN,
     +               ITRI,NTRI,LOTN,
     +               RWRK,LRWK,
     +               IWRK,LIWK)
C
C
C D R A W   A   S I M P L E   C O N T O U R   P L O T ------------------
C
C
C Label the frame.
C
        CALL PLCHHQ (CFUX(.5),CFUY(.950), 'Contours on Triangular Mesh',
     +.018,0.,0.)
C
C Draw the mesh in two shades of yellow, to distinguish blocked portions
C of it from unblocked portions.
C
c       CALL DRWMSH (RPNT,NPNT,LOPN,
c    +               IEDG,NEDG,LOEN,
c    +               ITRI,NTRI,LOTN,
c    +               8,9)
C
C Draw contour lines with labels written by the dash package.
C
        CALL CTCLDR (RPNT,IEDG,ITRI,RWRK,IWRK)
C
C Add informational and high/low labels.
C
        CALL CTLBDR (RPNT,IEDG,ITRI,RWRK,IWRK)
C
C Advance the frame.
C
        CALL FRAME
C
C
C D R A W   A   C O L O R - F I L L E D   C O N T O U R   P L O T ------
C
C
C Label the frame.
C
        CALL PLCHHQ (CFUX(.5),CFUY(.950), 'Colored Contour Bands on Tria
     +ngular Mesh',.018,0.,0.)
C
C Initialize an area map.
C
        CALL ARINAM (IAMA,LAMA)
C
C Put contour lines in the area map.
C
        CALL CTCLAM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA)
C
C Scan the area map and deliver the areas defined by it to the routine
C DCFOCB.
C
        CALL ARSCAM (IAMA,XCRA,YCRA,NCRA,IAAI,IAGI,NGPS,DCFOCB)
C
C Advance the frame.
C
        CALL FRAME
C
C Reset the fill color to the default.  (Otherwise, characters on the
C next plot are filled in red.)
C
        CALL GSFACI (1)
C
C
C D R A W   A   C E L L - A R R A Y   C O N T O U R   P L O T ----------
C
C
C Label the frame.
C
        CALL PLCHHQ (CFUX(.5),CFUY(.950), 'Cell-Array Plot of Triangular
     + Mesh',.018,0.,0.)
C
        CALL GETSET (XVPL,XVPR,YVPB,YVPT,XWDL,XWDR,YWDB,YWDT,LNLG)
C
        CALL CTCICA (RPNT,IEDG,ITRI,RWRK,IWRK,ICRA,ICAM,ICAM,ICAN,
     +                                        XVPL,YVPB,XVPR,YVPT)
C
        CALL GCA (XWDL,YWDB,XWDR,YWDT,ICAM,ICAN,1,1,ICAM,ICAN,ICRA)
C
C Advance the frame.
C
        CALL FRAME
C
C
C C L O S E   G K S   A N D   Q U I T ----------------------------------
C
C
C Close GKS.
C
        CALL GDAWK (IWID)
        CALL GCLWK (IWID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END


      SUBROUTINE DFCLRS (IWID,IOFC,IOLC,REDF,GRNF,BLUF,REDL,GRNL,BLUL)
C
C This routine defines color indices IOFC through IOLC on workstation
C IWID by interpolating values from REDF/GRNF/BLUF to REDL/GRNL/BLUL.
C
        DO 101 I=IOFC,IOLC
          P=REAL(IOLC-I)/REAL(IOLC-IOFC)
          Q=REAL(I-IOFC)/REAL(IOLC-IOFC)
          CALL GSCR (IWID,I,P*REDF+Q*REDL,P*GRNF+Q*GRNL,P*BLUF+Q*BLUL)
  101   CONTINUE
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE DRWMSH (RPNT,NPNT,LOPN,
     +                   IEDG,NEDG,LOEN,
     +                   ITRI,NTRI,LOTN,
     +                   ICI1,ICI2)
C
        DIMENSION RPNT(NPNT),IEDG(NEDG),ITRI(NTRI)
C
C Draw the edges of the triangular mesh defined by the arguments.  Use
C color index ICI1 to draw edges in areas that are unblocked and color
C index ICI2 to draw edges in areas that are blocked.
C
        ICPC=-1

        DO 101 IPTE=0,NEDG-LOEN,LOEN
C
          IFLL=0
C
          IF (IEDG(IPTE+3).GE.0) THEN
            IF (ITRI(LOTN*((IEDG(IPTE+3)-1)/LOTN)+4).EQ.0) IFLL=1
          END IF
C
          IFLR=0
C
          IF (IEDG(IPTE+4).GE.0) THEN
            IF (ITRI(LOTN*((IEDG(IPTE+4)-1)/LOTN)+4).EQ.0) IFLR=1
          END IF
C
          IF (IFLL.NE.0.OR.IFLR.NE.0) THEN
            IDPC=ICI1
          ELSE
            IDPC=ICI2
          END IF
C
          IF (ICPC.NE.IDPC) THEN
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (IDPC)
            ICPC=IDPC
          END IF
C
          CALL LINE   (RPNT(IEDG(IPTE+1)+1),RPNT(IEDG(IPTE+1)+2),
     +                 RPNT(IEDG(IPTE+2)+1),RPNT(IEDG(IPTE+2)+2))
C
  101   CONTINUE
C
        CALL PLOTIT (0,0,2)
        CALL GSPLCI (1)
C
        RETURN
C
      END


      SUBROUTINE DCFOCB (XCRA,YCRA,NCRA,IAAI,IAGI,NGPS)
C
C This routine fills the area defined by the points (XCRA(I),YCRA(I)),
C for I = 1 to NCRA, if and only if none of the area identifiers for
C the area are negative.  The color used is determined from the area
C identifier of the area relative to group 3; we assume that 100 colors
C are defined having color indices 151 through 250 and interpolate to
C determine which of these colors to use.
C
        DIMENSION XCRA(*),YCRA(*),IAAI(*),IAGI(*)
C
C Retrieve the number of contour levels being used.
C
        CALL CTGETI ('NCL - NUMBER OF CONTOUR LEVELS',NOCL)
C
C If the number of contour levels is non-zero and the area has more
C than two points, fill it.
C
        IF (NOCL.NE.0.AND.NCRA.GT.2) THEN
C
          IAI3=-1
C
          DO 101 I=1,NGPS
            IF (IAGI(I).EQ.3) IAI3=IAAI(I)
  101     CONTINUE
C
          IF (IAI3.GE.1.AND.IAI3.LE.NOCL+1) THEN
            CALL GSFACI (151+INT(((REAL(IAI3)-.5)/REAL(NOCL+1))*100.))
            CALL GFA    (NCRA,XCRA,YCRA)
          ELSE IF (IAI3.EQ.1001) THEN
            CALL GSFACI (2)
            CALL GFA    (NCRA,XCRA,YCRA)
          ELSE IF (IAI3.EQ.1002) THEN
            CALL GSFACI (3)
            CALL GFA    (NCRA,XCRA,YCRA)
          END IF
C
        END IF
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE CTSCAE (ICRA,ICA1,ICAM,ICAN,XCPF,YCPF,XCQF,YCQF,
     +                                       IND1,IND2,ICAF,IAID)
        DIMENSION ICRA(ICA1,*)
C
C This routine is called by CTCICA when the internal parameter 'CAF' is
C given a negative value.  Each call is intended to create a particular
C element in the user's cell array.  The arguments are as follows:
C
C ICRA is the user's cell array.
C
C ICA1 is the first dimension of the FORTRAN array ICRA.
C
C ICAM and ICAN are the first and second dimensions of the cell array
C stored in ICRA.
C
C (XCPF,YCPF) is the point at that corner of the rectangular area
C into which the cell array maps that corresponds to the cell (1,1).
C The coordinates are given in the fractional coordinate system (unlike
C what is required in a call to GCA, in which the coordinates of the
C point P are in the world coordinate system).
C
C (XCQF,YCQF) is the point at that corner of the rectangular area into
C which the cell array maps that corresponds to the cell (ICAM,ICAN).
C The coordinates are given in the fractional coordinate system (unlike
C what is required in a call to GCA, in which the coordinates of the
C point Q are in the world coordinate system).
C
C IND1 is the 1st index of the cell that is to be updated.
C
C IND2 is the 2nd index of the cell that is to be updated.
C
C ICAF is the current value of the internal parameter 'CAF'.  This
C value will always be an integer which is less than zero (because
C when 'CAF' is zero or greater, this routine is not called).
C
C IAID is the area identifier associated with the cell.  It will have
C been given one of the values from the internal parameter array 'AIA'
C (the one for 'PAI' = -2 if the cell lies in an out-of-range area, the
C one for 'PAI' = -1 if the cell lies off the data grid, or the one for
C some value of 'PAI' between 1 and 'NCL' if the cell lies on the data
C grid).  The value zero may occur if the cell falls in an out-of-range
C area and the value of 'AIA' for 'PAI' = -2 is 0 or if the cell lies
C off the data grid and the value of 'AIA' for 'PAI' = -1 is 0, or if
C the cell falls on the data grid, but no contour level below the cell
C has a non-zero 'AIA' and no contour level above the cell has a
C non-zero 'AIB'.  Note that, if the values of 'AIA' for 'PAI' = -1
C and -2 are given non-zero values, IAID can only be given a zero
C value in one way.
C
C The default behavior of CTSCAE is as follows:  If the area identifier
C is non-negative, it is treated as a color index, to be stored in the
C appropriate cell in the cell array; but if the area identifier is
C negative, a zero is stored for the color index.  The user may supply
C a version of CTSCAE that does something different; it may simply map
C the area identifiers into color indices or it may somehow modify the
C existing cell array element to incorporate the information provided
C by the area identifier.
C
C       ICRA(IND1,IND2)=MAX(0,IAID)
C
C What follows is not the default behavior; instead, it is the behavior
C expected by many of the example programs for CONPACKT.
C
        CALL CTGETI ('NCL - NUMBER OF CONTOUR LEVELS',NOCL)
C
        IF (IAID.GE.1.AND.IAID.LE.NOCL+1) THEN
          ICRA(IND1,IND2)=151+INT(((REAL(IAID)-.5)/REAL(NOCL+1))*100.)
        ELSE IF (IAID.EQ.1001) THEN
          ICRA(IND1,IND2)=2
        ELSE IF (IAID.EQ.1002) THEN
          ICRA(IND1,IND2)=3
        END IF
C
        RETURN
C
      END

      SUBROUTINE CPBTF2( UPLO, N, KD, AB, LDAB, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     February 29, 1992
*
*     .. Scalar Arguments ..
      CHARACTER          UPLO
      INTEGER            INFO, KD, LDAB, N
*     ..
*     .. Array Arguments ..
      COMPLEX            AB( LDAB, * )
*     ..
*
*  Purpose
*  =======
*
*  CPBTF2 computes the Cholesky factorization of a complex Hermitian
*  positive definite band matrix A.
*
*  The factorization has the form
*     A = U' * U ,  if UPLO = 'U', or
*     A = L  * L',  if UPLO = 'L',
*  where U is an upper triangular matrix, U' is the conjugate transpose
*  of U, and L is lower triangular.
*
*  This is the unblocked version of the algorithm, calling Level 2 BLAS.
*
*  Arguments
*  =========
*
*  UPLO    (input) CHARACTER*1
*          Specifies whether the upper or lower triangular part of the
*          Hermitian matrix A is stored:
*          = 'U':  Upper triangular
*          = 'L':  Lower triangular
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  KD      (input) INTEGER
*          The number of super-diagonals of the matrix A if UPLO = 'U',
*          or the number of sub-diagonals if UPLO = 'L'.  KD >= 0.
*
*  AB      (input/output) COMPLEX array, dimension (LDAB,N)
*          On entry, the upper or lower triangle of the Hermitian band
*          matrix A, stored in the first KD+1 rows of the array.  The
*          j-th column of A is stored in the j-th column of the array AB
*          as follows:
*          if UPLO = 'U', AB(kd+1+i-j,j) = A(i,j) for max(1,j-kd)<=i<=j;
*          if UPLO = 'L', AB(1+i-j,j)    = A(i,j) for j<=i<=min(n,j+kd).
*
*          On exit, if INFO = 0, the triangular factor U or L from the
*          Cholesky factorization A = U'*U or A = L*L' of the band
*          matrix A, in the same storage format as A.
*
*  LDAB    (input) INTEGER
*          The leading dimension of the array AB.  LDAB >= KD+1.
*
*  INFO    (output) INTEGER
*          = 0: successful exit
*          < 0: if INFO = -k, the k-th argument had an illegal value
*          > 0: if INFO = k, the leading minor of order k is not
*               positive definite, and the factorization could not be
*               completed.
*
*  Further Details
*  ===============
*
*  The band storage scheme is illustrated by the following example, when
*  N = 6, KD = 2, and UPLO = 'U':
*
*  On entry:                       On exit:
*
*      *    *   a13  a24  a35  a46      *    *   u13  u24  u35  u46
*      *   a12  a23  a34  a45  a56      *   u12  u23  u34  u45  u56
*     a11  a22  a33  a44  a55  a66     u11  u22  u33  u44  u55  u66
*
*  Similarly, if UPLO = 'L' the format of A is as follows:
*
*  On entry:                       On exit:
*
*     a11  a22  a33  a44  a55  a66     l11  l22  l33  l44  l55  l66
*     a21  a32  a43  a54  a65   *      l21  l32  l43  l54  l65   *
*     a31  a42  a53  a64   *    *      l31  l42  l53  l64   *    *
*
*  Array elements marked * are not used by the routine.
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ONE, ZERO
      PARAMETER          ( ONE = 1.0E+0, ZERO = 0.0E+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            UPPER
      INTEGER            J, KLD, KN
      REAL               AJJ
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           CHER, CLACGV, CSSCAL, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN, REAL, SQRT
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      UPPER = LSAME( UPLO, 'U' )
      IF( .NOT.UPPER .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( KD.LT.0 ) THEN
         INFO = -3
      ELSE IF( LDAB.LT.KD+1 ) THEN
         INFO = -5
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'CPBTF2', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
*
      KLD = MAX( 1, LDAB-1 )
*
      IF( UPPER ) THEN
*
*        Compute the Cholesky factorization A = U'*U.
*
         DO 10 J = 1, N
*
*           Compute U(J,J) and test for non-positive-definiteness.
*
            AJJ = REAL( AB( KD+1, J ) )
            IF( AJJ.LE.ZERO ) THEN
               AB( KD+1, J ) = AJJ
               GO TO 30
            END IF
            AJJ = SQRT( AJJ )
            AB( KD+1, J ) = AJJ
*
*           Compute elements J+1:J+KN of row J and update the
*           trailing submatrix within the band.
*
            KN = MIN( KD, N-J )
            IF( KN.GT.0 ) THEN
               CALL CSSCAL( KN, ONE / AJJ, AB( KD, J+1 ), KLD )
               CALL CLACGV( KN, AB( KD, J+1 ), KLD )
               CALL CHER( 'Upper', KN, -ONE, AB( KD, J+1 ), KLD,
     $                    AB( KD+1, J+1 ), KLD )
               CALL CLACGV( KN, AB( KD, J+1 ), KLD )
            END IF
   10    CONTINUE
      ELSE
*
*        Compute the Cholesky factorization A = L*L'.
*
         DO 20 J = 1, N
*
*           Compute L(J,J) and test for non-positive-definiteness.
*
            AJJ = REAL( AB( 1, J ) )
            IF( AJJ.LE.ZERO ) THEN
               AB( 1, J ) = AJJ
               GO TO 30
            END IF
            AJJ = SQRT( AJJ )
            AB( 1, J ) = AJJ
*
*           Compute elements J+1:J+KN of column J and update the
*           trailing submatrix within the band.
*
            KN = MIN( KD, N-J )
            IF( KN.GT.0 ) THEN
               CALL CSSCAL( KN, ONE / AJJ, AB( 2, J ), 1 )
               CALL CHER( 'Lower', KN, -ONE, AB( 2, J ), 1,
     $                    AB( 1, J+1 ), KLD )
            END IF
   20    CONTINUE
      END IF
      RETURN
*
   30 CONTINUE
      INFO = J
      RETURN
*
*     End of CPBTF2
*
      END

C
C $Id: curvp1dp.f,v 1.3 2008-07-27 03:10:10 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
C NOTE: If you make any changes to this software, please remember to
C make the same changes to the corresponding single precision routine.
C
      SUBROUTINE CURVP1DP(N,X,Y,P,YP,TEMP,SIGMA,IERR)
      DOUBLE PRECISION SIGMAP
      DOUBLE PRECISION DELX1
      DOUBLE PRECISION DX1
      DOUBLE PRECISION DIAG1
      DOUBLE PRECISION SDIAG1
      DOUBLE PRECISION DELX2
      DOUBLE PRECISION DX2
      DOUBLE PRECISION DIAG2
      DOUBLE PRECISION SDIAG2
      DOUBLE PRECISION DIAG
      DOUBLE PRECISION YPN
c
      INTEGER N,IERR
      DOUBLE PRECISION X(N),Y(N),P,YP(N),TEMP(1),SIGMA
c
c                                 coded by alan kaylor cline
c                           from fitpack -- january 26, 1987
c                        a curve and surface fitting package
c                      a product of pleasant valley software
c                  8603 altus cove, austin, texas 78759, usa
c
c this subroutine determines the parameters necessary to
c compute a periodic interpolatory spline under tension
c through a sequence of functional values. for actual ends
c of the curve may be specified or omitted.  for actual
c computation of points on the curve it is necessary to call
c the function curvp2.
c
c on input--
c
c   n is the number of values to be interpolated (n.ge.2).
c
c   x is an array of the n increasing abscissae of the
c   functional values.
c
c   y is an array of the n ordinates of the values, (i. e.
c   y(k) is the functional value corresponding to x(k) ).
c
c   p is the period (p .gt. x(n)-x(1)).
c
c   yp is an array of length at least n.
c
c   temp is an array of length at least 2*n which is used
c   for scratch storage.
c
c and
c
c   sigma contains the tension factor.  this value indicates
c   the curviness desired. if abs(sigma) is nearly zero
c   (e.g. .001) the resulting curve is approximately a
c   cubic spline. if abs(sigma) is large (e.g. 50.) the
c   resulting curve is nearly a polygonal line. if sigma
c   equals zero a cubic spline results.  a standard value
c   for sigma is approximately 1. in absolute value.
c
c on output--
c
c   yp contains the values of the second derivative of the
c   curve at the given nodes.
c
c   ierr contains an error flag,
c        = 0 for normal return,
c        = 1 if n is less than 2,
c        = 2 if p is less than or equal to x(n)-x(1),
c        = 3 if x-values are not strictly increasing.
c
c and
c
c  n, x, y, and sigma are unaltered.
c
c this subroutine references package modules terms and
c snhcsh.
c
c-----------------------------------------------------------
c
      NM1 = N - 1
      NP1 = N + 1
      IERR = 0
      IF (N.LE.1) GO TO 6
      IF (P.LE.X(N)-X(1) .OR. P.LE.0.D0) GO TO 7
c
c denormalize tension factor
c
      SIGMAP = ABS(SIGMA)*DBLE(N)/P
c
c set up right hand side and tridiagonal system for yp and
c perform forward elimination
c
      DELX1 = P - (X(N)-X(1))
      DX1 = (Y(1)-Y(N))/DELX1
      CALL TERMSDP(DIAG1,SDIAG1,SIGMAP,DELX1)
      DELX2 = X(2) - X(1)
      IF (DELX2.LE.0.D0) GO TO 8
      DX2 = (Y(2)-Y(1))/DELX2
      CALL TERMSDP(DIAG2,SDIAG2,SIGMAP,DELX2)
      DIAG = DIAG1 + DIAG2
      YP(1) = (DX2-DX1)/DIAG
      TEMP(NP1) = -SDIAG1/DIAG
      TEMP(1) = SDIAG2/DIAG
      DX1 = DX2
      DIAG1 = DIAG2
      SDIAG1 = SDIAG2
      IF (N.EQ.2) GO TO 2
      DO 1 I = 2,NM1
          NPI = N + I
          DELX2 = X(I+1) - X(I)
          IF (DELX2.LE.0.D0) GO TO 8
          DX2 = (Y(I+1)-Y(I))/DELX2
          CALL TERMSDP(DIAG2,SDIAG2,SIGMAP,DELX2)
          DIAG = DIAG1 + DIAG2 - SDIAG1*TEMP(I-1)
          YP(I) = (DX2-DX1-SDIAG1*YP(I-1))/DIAG
          TEMP(NPI) = -TEMP(NPI-1)*SDIAG1/DIAG
          TEMP(I) = SDIAG2/DIAG
          DX1 = DX2
          DIAG1 = DIAG2
    1 SDIAG1 = SDIAG2
    2 DELX2 = P - (X(N)-X(1))
      DX2 = (Y(1)-Y(N))/DELX2
      CALL TERMSDP(DIAG2,SDIAG2,SIGMAP,DELX2)
      YP(N) = DX2 - DX1
      TEMP(NM1) = TEMP(2*N-1) - TEMP(NM1)
      IF (N.EQ.2) GO TO 4
c
c perform first step of back substitution
c
      DO 3 I = 3,N
          IBAK = NP1 - I
          NPIBAK = N + IBAK
          YP(IBAK) = YP(IBAK) - TEMP(IBAK)*YP(IBAK+1)
    3 TEMP(IBAK) = TEMP(NPIBAK) - TEMP(IBAK)*TEMP(IBAK+1)
    4 YP(N) = (YP(N)-SDIAG2*YP(1)-SDIAG1*YP(NM1))/
     +        (DIAG1+DIAG2+SDIAG2*TEMP(1)+SDIAG1*TEMP(NM1))
c
c perform second step of back substitution
c
      YPN = YP(N)
      DO 5 I = 1,NM1
    5 YP(I) = YP(I) + TEMP(I)*YPN
      RETURN
c
c too few points
c
    6 IERR = 1
      RETURN
c
c period too small
c
    7 IERR = 2
      RETURN
c
c x-values not strictly increasing
c
    8 IERR = 3
      RETURN
      END

C
C	$Id: ngpswk.f,v 1.7 2008-07-27 00:17:18 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      INTEGER FUNCTION NGPSWK(PSTYPE, ORIENT, COLOR)
C
C  This function returns the workstation type for the PostScript
C  workstation, in NCAR GKS, whose attributes are specified in the 
C  arguments:
C
C    PSTYPE - of type CHARACTER and specifies the type of the PostScript 
C             file.  It can be one of:
C
C               'PS'   - regular PostScript
C               'EPS'  - Encapsulated PostScript (can have only a 
C                        single picture).
C               'EPSI' - Encapsulated PostScript Interchange format
C                        (an EPS file containing a preview bitmap).
C
C             The value 'PS' is used and a warning is issued if the 
C             argument is unrecognized.
C
C    ORIENT - of type CHARACTER and specifies the orientation of the
C             output plot.  It can be one of:
C  
C               'PORTRAIT'  - portrait orietation (long side of page
C                             is vertical).
C               'LANDSCAPE' - landscape orientation (long side of
C                             the page is horizontal).
C
C             The value 'PORTRAIT' is used and a warning is issued if the 
C             argument is unrecognized.
C
C    COLOR  - of type CHARACTER and specifies whether the plot will be
C             color or monochrome.  It can be one of:
C  
C               'MONOCHROME' - plot with be plotted with all graphics
C                              objects being plotted using the foreground
C                              color.
C               'COLOR'      - plot will be plotted using color, if
C                              available, or intensities obtained from
C                              the NTSC color to black and white intensity
C                              mapping if gray scale is available.
C
C             The value 'COLOR' is used and a warning is issued if the 
C             argument is unrecognized.
C
C  In specifying the arguments, only enough characters need be entered
C  so that the values can be differentiated.  For example, to
C  specify color, using 'C' as the third argument would be sufficient.
C  Either upper case or lower case is accepted.
C
      CHARACTER PSTYPE*(*), ORIENT*(*), COLOR*(*) 
      CHARACTER IFMT*80
C
      DIMENSION ITYPES(3,2,2)
      DATA ITYPES/20, 21, 22, 26, 27, 28, 23, 24, 25, 29, 30, 31/
C
C  Check for an uncleared prior error.
C
      IF (ICFELL('NGPSWK - Uncleared prior error',1) .NE. 0) RETURN
C
C  Handle the PostScript type argument.
C
      ILEN = LEN(PSTYPE)
      IF (ILEN .LT. 1) THEN
        CALL SETER (
     +   'NGPSWK - first argument too short, defaulted to ''PS''', 
     +   1, 1)
        IPST = 1
        GO TO 200
      ENDIF
      IF (PSTYPE(1:1).EQ.'P' .OR. PSTYPE(1:1).EQ.'p') THEN
        IPST = 1
        GO TO 200
      ELSE IF (ILEN .EQ. 3) THEN
        IF (PSTYPE(1:3).EQ.'EPS' .OR. PSTYPE(1:3).EQ.'eps') THEN
          IPST = 2
          GO TO 200
        ELSE
          WRITE (I1MACH(4),500) PSTYPE(1:3)
  500     FORMAT(
     +      'NGPSWK - ''',A3,''' unrecognized, defaulted to ''PS''')
          IPST = 1
          GO TO 200
        ENDIF
      ELSE IF (ILEN .GT. 3) THEN
        IF (PSTYPE(1:4).EQ.'EPS ' .OR. PSTYPE(1:4).EQ.'eps ') THEN 
          IPST = 2
          GO TO 200
        ELSE IF (PSTYPE(1:4).EQ.'EPSI' .OR. PSTYPE(1:4).EQ.'epsi') THEN
          IPST = 3
          GO TO 200
        ELSE
          ILEN = LEN(PSTYPE)
          WRITE(IFMT,660) ILEN
  660     FORMAT('(''NGPSWK - '''''',A',I3,','''''' unrecognized, defaul
     +ted to ''''PS'''''')')
          WRITE (I1MACH(4),IFMT) PSTYPE(1:ILEN)
          IPST = 1
          GO TO 200
        ENDIF
      ELSE
        ILEN = LEN(PSTYPE)
        WRITE(IFMT,650) ILEN
  650   FORMAT('(''NGPSWK - '''''',A',I3,','''''' unrecognized, defaulte
     +d to ''''PS'''''')')
        WRITE (I1MACH(4),IFMT) PSTYPE(1:ILEN)
        IPST = 1
        GO TO 200
      ENDIF
  200 CONTINUE
C
C  Handle the orientation argument.
C
      IF (ORIENT(1:1).EQ.'P' .OR. ORIENT(1:1).EQ.'p') THEN
        IORN = 1
        GO TO 210
      ELSE IF (ORIENT(1:1).EQ.'L' .OR. ORIENT(1:1).EQ.'l') THEN 
        IORN = 2
        GO TO 210
      ELSE
        ILEN = LEN(ORIENT)
        WRITE(IFMT,670) ILEN
  670   FORMAT('(''NGPSWK - '''''',A',I3,','''''' unrecognized, defaulte
     +d to ''''PORTRAIT'''''')')
        WRITE (I1MACH(4),IFMT) ORIENT(1:ILEN)
        IORN = 1
        GO TO 210
      ENDIF
  210 CONTINUE
C
C  Handle the color argument.
C
      IF (COLOR(1:1).EQ.'C' .OR. COLOR(1:1).EQ.'c') THEN
        ICLR = 1
        GO TO 220
      ELSE IF (COLOR(1:1).EQ.'M' .OR. COLOR(1:1).EQ.'m') THEN 
        ICLR = 2
        GO TO 220
      ELSE
        ILEN = LEN(COLOR)
        WRITE(IFMT,680) ILEN
  680   FORMAT('(''NGPSWK - '''''',A',I3,','''''' unrecognized, defaulte
     +d to ''''COLOR'''''')')
        WRITE (I1MACH(4),IFMT) COLOR(1:ILEN)
        ICLR = 1
        GO TO 220
      ENDIF
  220 CONTINUE
C
      NGPSWK = ITYPES(IPST, IORN, ICLR)
      RETURN
      END

C
C	$Id: gtnlen.f,v 1.7 2008-07-27 00:21:06 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
        SUBROUTINE GTNLEN(FNAME,ILEN,IER)
C
C  Determine the length of the name in FNAME.  The length is the
C  longest initial character sequence without a blank or null.
C  Maximum length is 1023.  IER is returned as 0 if the length is
C  less than 1024; IER is returned as 1 otherwise.
C
        CHARACTER*(*) FNAME
C
        IER  = 0
        ILEN = 0
        DO 10 I=1,1024
        IF (FNAME(I:I).EQ.' ' .OR. FNAME(I:I).EQ.CHAR(0)) THEN
          ILEN = I-1
          RETURN
        ENDIF
   10   CONTINUE
        IER = 1
        RETURN
        END

C
C $Id: curv1.f,v 1.5 2008-07-27 03:10:10 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
C NOTE: If you make any changes to this software, please remember to
C make the same changes to the corresponding double precision routine.
C
      subroutine curv1 (n,x,y,slp1,slpn,islpsw,yp,temp,
     *                  sigma,ierr)
c
      integer n,islpsw,ierr
      real x(n),y(n),slp1,slpn,yp(n),temp(n),sigma
c
c                                 coded by alan kaylor cline
c                           from fitpack -- january 26, 1987
c                        a curve and surface fitting package
c                      a product of pleasant valley software
c                  8603 altus cove, austin, texas 78759, usa
c
c this subroutine determines the parameters necessary to
c compute an interpolatory spline under tension through
c a sequence of functional values. the slopes at the two
c ends of the curve may be specified or omitted.  for actual
c computation of points on the curve it is necessary to call
c the function curv2.
c
c on input--
c
c   n is the number of values to be interpolated (n.ge.2).
c
c   x is an array of the n increasing abscissae of the
c   functional values.
c
c   y is an array of the n ordinates of the values, (i. e.
c   y(k) is the functional value corresponding to x(k) ).
c
c   slp1 and slpn contain the desired values for the first
c   derivative of the curve at x(1) and x(n), respectively.
c   the user may omit values for either or both of these
c   parameters and signal this with islpsw.
c
c   islpsw contains a switch indicating which slope data
c   should be used and which should be estimated by this
c   subroutine,
c          = 0 if slp1 and slpn are to be used,
c          = 1 if slp1 is to be used but not slpn,
c          = 2 if slpn is to be used but not slp1,
c          = 3 if both slp1 and slpn are to be estimated
c              internally.
c
c   yp is an array of length at least n.
c
c   temp is an array of length at least n which is used for
c   scratch storage.
c
c and
c
c   sigma contains the tension factor. this value indicates
c   the curviness desired. if abs(sigma) is nearly zero
c   (e.g. .001) the resulting curve is approximately a
c   cubic spline. if abs(sigma) is large (e.g. 50.) the
c   resulting curve is nearly a polygonal line. if sigma
c   equals zero a cubic spline results.  a standard value
c   for sigma is approximately 1. in absolute value.
c
c on output--
c
c   yp contains the values of the second derivative of the
c   curve at the given nodes.
c
c   ierr contains an error flag,
c        = 0 for normal return,
c        = 1 if n is less than 2,
c        = 2 if x-values are not strictly increasing.
c
c and
c
c   n, x, y, slp1, slpn, islpsw and sigma are unaltered.
c
c this subroutine references package modules ceez, terms,
c and snhcsh.
c
c-----------------------------------------------------------
c
      nm1 = n-1
      np1 = n+1
      ierr = 0
      if (n .le. 1) go to 8
      if (x(n) .le. x(1)) go to 9
c
c denormalize tension factor
c
      sigmap = abs(sigma)*float(n-1)/(x(n)-x(1))
c
c approximate end slopes
c
      if (islpsw .ge. 2) go to 1
      slpp1 = slp1
      go to 2
    1 delx1 = x(2)-x(1)
      delx2 = delx1+delx1
      if (n .gt. 2) delx2 = x(3)-x(1)
      if (delx1 .le. 0. .or. delx2 .le. delx1) go to 9
      call ceez (delx1,delx2,sigmap,c1,c2,c3,n)
      slpp1 = c1*y(1)+c2*y(2)
      if (n .gt. 2) slpp1 = slpp1+c3*y(3)
    2 if (islpsw .eq. 1 .or. islpsw .eq. 3) go to 3
      slppn = slpn
      go to 4
    3 delxn = x(n)-x(nm1)
      delxnm = delxn+delxn
      if (n .gt. 2) delxnm = x(n)-x(n-2)
      if (delxn .le. 0. .or. delxnm .le. delxn) go to 9
      call ceez (-delxn,-delxnm,sigmap,c1,c2,c3,n)
      slppn = c1*y(n)+c2*y(nm1)
      if (n .gt. 2) slppn = slppn+c3*y(n-2)
c
c set up right hand side and tridiagonal system for yp and
c perform forward elimination
c
    4 delx1 = x(2)-x(1)
      if (delx1 .le. 0.) go to 9
      dx1 = (y(2)-y(1))/delx1
      call terms (diag1,sdiag1,sigmap,delx1)
      yp(1) = (dx1-slpp1)/diag1
      temp(1) = sdiag1/diag1
      if (n .eq. 2) go to 6
      do 5 i = 2,nm1
        delx2 = x(i+1)-x(i)
        if (delx2 .le. 0.) go to 9
        dx2 = (y(i+1)-y(i))/delx2
        call terms (diag2,sdiag2,sigmap,delx2)
        diag = diag1+diag2-sdiag1*temp(i-1)
        yp(i) = (dx2-dx1-sdiag1*yp(i-1))/diag
        temp(i) = sdiag2/diag
        dx1 = dx2
        diag1 = diag2
    5   sdiag1 = sdiag2
    6 diag = diag1-sdiag1*temp(nm1)
      yp(n) = (slppn-dx1-sdiag1*yp(nm1))/diag
c
c perform back substitution
c
      do 7 i = 2,n
        ibak = np1-i
    7   yp(ibak) = yp(ibak)-temp(ibak)*yp(ibak+1)
      return
c
c too few points
c
    8 ierr = 1
      return
c
c x-values not strictly increasing
c
    9 ierr = 2
      return
      end

C
C	$Id: multi.f,v 1.4 2008-07-27 00:59:04 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MULTI(IOS,STATUS)
C
C  PROCESS THE MULTIBYTE INSTRUCTIONS
C
C  OUTPUT
C       IOS-THE I/O STATUS VALID IF STATUS SET TO AN I/O ERROR
C       STATUS-THE ERROR STATUS DEFINED BY COMMON TREROR
C
      COMMON/TREROR/ ALLOK, MFRCHK, MTOPER, METRDC, REDERR, TYPCHG
     1             ,INVTYP, MINVLD, TYPERR, FRMEND, ENCINT, IVDCDT
     2             ,GCOERR, GCRERR, GCCERR, FCOERR, FCRERR, FCCERR
     3             ,PLIDXG, PMIDXG, TXIDXG, PGIDXG, INVLMT, CELERR
     4             ,COIERR, COLNRM, UNKNOW, UNKOPC, ENDMTF, VNEROR
     5             ,BADRSZ, DEVOUT, NOVERS, BADFNT, PGMERR, FASERR
     6             ,HINERR, VDWERR, RDWERR, RIXLIM
      INTEGER        ALLOK, MFRCHK, MTOPER, METRDC, REDERR, TYPCHG
     1             ,INVTYP, MINVLD, TYPERR, FRMEND, ENCINT, IVDCDT
     2             ,GCOERR, GCRERR, GCCERR, FCOERR, FCRERR, FCCERR
     3             ,PLIDXG, PMIDXG, TXIDXG, PGIDXG, INVLMT, CELERR
     4             ,COIERR, COLNRM, UNKNOW, UNKOPC, ENDMTF, VNEROR
     5             ,BADRSZ, DEVOUT, NOVERS, BADFNT, PGMERR, FASERR
     6             ,HINERR, VDWERR, RDWERR, RIXLIM
      COMMON/TRINOT/ IPTR, MBUFOT, MAXBYT, DEVUNT, METUNT,
     1          METIPT, ERRUNT, FNTUNT
      INTEGER MAXCNT
      PARAMETER (MAXCNT=200)
      INTEGER IPTR, MBUFOT(MAXCNT), MAXBYT, DEVUNT, METUNT, ERRUNT,
     1        FNTUNT
      LOGICAL METIPT
      COMMON /TRINST/ OPCL, OPID, LEN, CONT
      INTEGER OPCL, OPID, LEN
      LOGICAL CONT
      COMMON /TRMTYP/ FOURBT, MULTBT, TWOBT, PTSFLG, CURCOL, IPWRIT,
     1                IFRAME, ISETOP, IRANG, IPTS, ICAS, IINT, IORNT,
     2                ISIZE, IFONT, IPAT, ISSIZ, ICENT, ICOLR,
     3                MCENT, MSIZE, MOR, OLDX, OLDY, MCASE, MINTEN,
     4                MFONT, MDASH, MSPOT, MCOLOR, MLIMIT, PTSYM,
     5                SAVX, SAVY
      INTEGER FOURBT, MULTBT, TWOBT, PTSFLG, CURCOL, IPWRIT,
     1                IFRAME, ISETOP, IRANG, IPTS, ICAS, IINT, IORNT,
     2                ISIZE, IFONT, IPAT, ISSIZ, ICENT, ICOLR,
     3                MCENT, MSIZE, MOR, OLDX, OLDY, MCASE, MINTEN,
     4                MFONT, MDASH, MSPOT, MCOLOR(3), MLIMIT(4), PTSYM,
     5                SAVX, SAVY
C
      INTEGER IOS, STATUS
      INTEGER OPLN, CTLN
C
C  DEFINE THE OPCODE AND COUNT FIELD LENGTHS
C
      DATA OPLN,CTLN/6,8/
C
C  INITIALIZE THE ERROR STATUS
C
      STATUS = ALLOK
C
C  GET THE OPCODE, NO NEED FOR BUFFER ERROR TESTING
C  THE OPCODE AND COUNT ARE IN THE 16 BIT PACKET THAT IS STARTED
C
      CALL MNINST(OPLN,IOS,STATUS)
C
C  PARSE THE OPCODE
C
      IF (OPCL .EQ. IPWRIT) THEN
C
C       PWRIT OPCODE
C
        CALL PWT(IOS,STATUS)
C
      ELSE IF (OPCL .EQ. IFRAME) THEN
C
C       FRAME CALL RESET DEVICE TO DEFAULT
C
        CALL FRM(IOS,STATUS)
C
      ELSE IF (OPCL .EQ. ISETOP) THEN
C
C       OPTION SETTING INSTRUCTION
C
        CALL SETOP(IOS,STATUS)
C
      ELSE IF (OPCL .EQ. IRANG) THEN
C
C       RANGE INSTRUCTION
C
        CALL SETRNG(IOS,STATUS)
C
      ELSE IF (OPCL .EQ. IPTS) THEN
C
C       POINT SYMBOL MODE INSTRUCTION
C
        CALL PNT(IOS,STATUS)
C
      ELSE
C
C       UNKNOWN OPCODE SET ERROR MESSAGE
C
        WRITE(6,'('' Unknown opcode ='',I6)') OPCL
        CALL ALOVER(IOS,STATUS)
      END IF
C
      RETURN
      END

C
C $Id: draws.f,v 1.6 2008-07-27 00:17:25 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE DRAWS (MX1,MY1,MX2,MY2,IDRAW,IMARK)
C
C THIS ROUTINE DRAWS THE VISIBLE PART OF THE LINE CONNECTING
C (MX1,MY1) AND (MX2,MY2).  IF IDRAW .NE. 0, THE LINE IS DRAWN.
C IF IMARK .NE. 0, THE VISIBILITY ARRAY IS MARKED.
C
      LOGICAL         VIS1       ,VIS2
      DIMENSION       PXS(2)     ,PYS(2)
      COMMON /SRFBLK/ LIMU(1024) ,LIML(1024) ,CL(41)     ,NCL        ,
     1                LL         ,FACT       ,IROT       ,NDRZ       ,
     2                NUPPER     ,NRSWT      ,BIGD       ,UMIN       ,
     3                UMAX       ,VMIN       ,VMAX       ,RZERO      ,
     4                IOFFP      ,NSPVAL     ,SPVAL      ,BIGEST
      DATA STEEP/5./
      DATA MX,MY/0,0/
C
C  Do a call forcing a BLOCKDATA to be loaded from a binary library.
C
      CALL SRFABD
C
C MAKE LINE LEFT TO RIGHT.
C
      MMX1 = MX1
      MMY1 = MY1
      MMX2 = MX2
      MMY2 = MY2
      IF (MMX1.EQ.NSPVAL .OR. MMX2.EQ.NSPVAL) RETURN
      IF (MMX1 .GT. MMX2) GO TO  10
      NX1 = MMX1
      NY1 = MMY1
      NX2 = MMX2
      NY2 = MMY2
      GO TO  20
   10 NX1 = MMX2
      NY1 = MMY2
      NX2 = MMX1
      NY2 = MMY1
   20 IF (NUPPER .LT. 0) GO TO 180
C
C CHECK UPPER VISIBILITY.
C
      VIS1 = NY1 .GE. (LIMU(NX1)-1)
      VIS2 = NY2 .GE. (LIMU(NX2)-1)
C
C VIS1 AND VIS2 TRUE MEANS VISIBLE.
C
      IF (VIS1 .AND. VIS2) GO TO 120
C
C VIS1 AND VIS2 FALSE MEANS INVISIBLE.
C
      IF (.NOT.(VIS1 .OR. VIS2)) GO TO 180
C
C FIND CHANGE POINT.
C
      IF (NX1 .EQ. NX2) GO TO 110
      DY = REAL(NY2-NY1)/REAL(NX2-NX1)
      NX1P1 = NX1+1
      FNY1 = NY1
      IF (VIS1) GO TO  60
      DO  30 K=NX1P1,NX2
         MX = K
         MY = FNY1+REAL(K-NX1)*DY
         IF (MY .GT. LIMU(K)) GO TO  40
   30 CONTINUE
   40 IF (ABS(DY) .GE. STEEP) GO TO  90
   50 NX1 = MX
      NY1 = MY
      GO TO 120
   60 DO  70 K=NX1P1,NX2
         MX = K
         MY = FNY1+REAL(K-NX1)*DY
         IF (MY .LE. LIMU(K)) GO TO  80
   70 CONTINUE
   80 IF (ABS(DY) .GE. STEEP) GO TO 100
   81 NX2 = MX-1
      NY2 = MY
      GO TO 120
   90 IF (LIMU(MX) .EQ. 0) GO TO  50
      NX1 = MX
      NY1 = LIMU(NX1)
      GO TO 120
  100 IF (LIMU(MX-1).EQ.0) GO TO 81
      NX2 = MX-1
      NY2 = LIMU(NX2)
      GO TO 120
  110 IF (VIS1) NY2 = MIN(LIMU(NX1),LIMU(NX2))
      IF (VIS2) NY1 = MIN(LIMU(NX1),LIMU(NX2))
  120 IF (IDRAW .EQ. 0) GO TO 150
C
C DRAW VISIBLE PART OF LINE.
C
      IF (IROT) 130,140,130
  130 CONTINUE
      PXS(1) = REAL(NY1)
      PXS(2) = REAL(NY2)
      PYS(1) = REAL(1024-NX1)
      PYS(2) = REAL(1024-NX2)
      CALL GPL (2,PXS,PYS)
      GO TO 150
  140 CONTINUE
      PXS(1) = REAL(NX1)
      PXS(2) = REAL(NX2)
      PYS(1) = REAL(NY1)
      PYS(2) = REAL(NY2)
      CALL GPL (2,PXS,PYS)
  150 IF (IMARK .EQ. 0) GO TO 180
      IF (NX1 .EQ. NX2) GO TO 170
      DY = REAL(NY2-NY1)/REAL(NX2-NX1)
      FNY1 = NY1
      DO 160 K=NX1,NX2
         LTEMP = FNY1+REAL(K-NX1)*DY
         IF (LTEMP .GT. LIMU(K)) LIMU(K) = LTEMP
  160 CONTINUE
      GO TO 180
  170 LTEMP = MAX(NY1,NY2)
      IF (LTEMP .GT. LIMU(NX1)) LIMU(NX1) = LTEMP
  180 IF (NUPPER) 190,190,370
C
C SAME IDEA AS ABOVE, BUT FOR LOWER SIDE.
C
  190 IF (MMX1 .GT. MMX2) GO TO 200
      NX1 = MMX1
      NY1 = MMY1
      NX2 = MMX2
      NY2 = MMY2
      GO TO 210
  200 NX1 = MMX2
      NY1 = MMY2
      NX2 = MMX1
      NY2 = MMY1
  210 VIS1 = NY1 .LE. (LIML(NX1)+1)
      VIS2 = NY2 .LE. (LIML(NX2)+1)
      IF (VIS1 .AND. VIS2) GO TO 310
      IF (.NOT.(VIS1 .OR. VIS2)) GO TO 370
      IF (NX1 .EQ. NX2) GO TO 300
      DY = REAL(NY2-NY1)/REAL(NX2-NX1)
      NX1P1 = NX1+1
      FNY1 = NY1
      IF (VIS1) GO TO 250
      DO 220 K=NX1P1,NX2
         MX = K
         MY = FNY1+REAL(K-NX1)*DY
         IF (MY .LT. LIML(K)) GO TO 230
  220 CONTINUE
  230 IF (ABS(DY) .GE. STEEP) GO TO 280
  240 NX1 = MX
      NY1 = MY
      GO TO 310
  250 DO 260 K=NX1P1,NX2
         MX = K
         MY = FNY1+REAL(K-NX1)*DY
         IF (MY .GE. LIML(K)) GO TO 270
  260 CONTINUE
  270 IF (ABS(DY) .GE. STEEP) GO TO 290
  271 NX2 = MX-1
      NY2 = MY
      GO TO 310
  280 IF (LIML(MX) .EQ. 1024) GO TO 240
      NX1 = MX
      NY1 = LIML(NX1)
      GO TO 310
  290 IF (LIML(MX-1).EQ.1024) GO TO 271
      NX2 = MX-1
      NY2 = LIML(NX2)
      GO TO 310
  300 IF (VIS1) NY2 = MAX(LIML(NX1),LIML(NX2))
      IF (VIS2) NY1 = MAX(LIML(NX1),LIML(NX2))
  310 IF (IDRAW .EQ. 0) GO TO 340
      IF (IROT) 320,330,320
  320 CONTINUE
      PXS(1) = REAL(NY1)
      PXS(2) = REAL(NY2)
      PYS(1) = REAL(1024-NX1)
      PYS(2) = REAL(1024-NX2)
      CALL GPL (2,PXS,PYS)
      GO TO 340
  330 CONTINUE
      PXS(1) = REAL(NX1)
      PXS(2) = REAL(NX2)
      PYS(1) = REAL(NY1)
      PYS(2) = REAL(NY2)
      CALL GPL (2,PXS,PYS)
  340 IF (IMARK .EQ. 0) GO TO 370
      IF (NX1 .EQ. NX2) GO TO 360
      DY = REAL(NY2-NY1)/REAL(NX2-NX1)
      FNY1 = NY1
      DO 350 K=NX1,NX2
         LTEMP = FNY1+REAL(K-NX1)*DY
         IF (LTEMP .LT. LIML(K)) LIML(K) = LTEMP
  350 CONTINUE
      RETURN
  360 LTEMP = MIN(NY1,NY2)
      IF (LTEMP .LT. LIML(NX1)) LIML(NX1) = LTEMP
  370 RETURN
      END

      SUBROUTINE ZGESDD( JOBZ, M, N, A, LDA, S, U, LDU, VT, LDVT, WORK,
     $                   LWORK, RWORK, IWORK, INFO )
*
*  -- LAPACK driver routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     October 31, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          JOBZ
      INTEGER            INFO, LDA, LDU, LDVT, LWORK, M, N
*     ..
*     .. Array Arguments ..
      INTEGER            IWORK( * )
      DOUBLE PRECISION   RWORK( * ), S( * )
      COMPLEX*16         A( LDA, * ), U( LDU, * ), VT( LDVT, * ),
     $                   WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  ZGESDD computes the singular value decomposition (SVD) of a complex
*  M-by-N matrix A, optionally computing the left and/or right singular
*  vectors, by using divide-and-conquer method. The SVD is written
*
*       A = U * SIGMA * conjugate-transpose(V)
*
*  where SIGMA is an M-by-N matrix which is zero except for its
*  min(m,n) diagonal elements, U is an M-by-M unitary matrix, and
*  V is an N-by-N unitary matrix.  The diagonal elements of SIGMA
*  are the singular values of A; they are real and non-negative, and
*  are returned in descending order.  The first min(m,n) columns of
*  U and V are the left and right singular vectors of A.
*
*  Note that the routine returns VT = V**H, not V.
*
*  The divide and conquer algorithm makes very mild assumptions about
*  floating point arithmetic. It will work on machines with a guard
*  digit in add/subtract, or on those binary machines without guard
*  digits which subtract like the Cray X-MP, Cray Y-MP, Cray C-90, or
*  Cray-2. It could conceivably fail on hexadecimal or decimal machines
*  without guard digits, but we know of none.
*
*  Arguments
*  =========
*
*  JOBZ    (input) CHARACTER*1
*          Specifies options for computing all or part of the matrix U:
*          = 'A':  all M columns of U and all N rows of V**H are
*                  returned in the arrays U and VT;
*          = 'S':  the first min(M,N) columns of U and the first
*                  min(M,N) rows of V**H are returned in the arrays U
*                  and VT;
*          = 'O':  If M >= N, the first N columns of U are overwritten
*                  on the array A and all rows of V**H are returned in
*                  the array VT;
*                  otherwise, all columns of U are returned in the
*                  array U and the first M rows of V**H are overwritten
*                  in the array VT;
*          = 'N':  no columns of U or rows of V**H are computed.
*
*  M       (input) INTEGER
*          The number of rows of the input matrix A.  M >= 0.
*
*  N       (input) INTEGER
*          The number of columns of the input matrix A.  N >= 0.
*
*  A       (input/output) COMPLEX*16 array, dimension (LDA,N)
*          On entry, the M-by-N matrix A.
*          On exit,
*          if JOBZ = 'O',  A is overwritten with the first N columns
*                          of U (the left singular vectors, stored
*                          columnwise) if M >= N;
*                          A is overwritten with the first M rows
*                          of V**H (the right singular vectors, stored
*                          rowwise) otherwise.
*          if JOBZ .ne. 'O', the contents of A are destroyed.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(1,M).
*
*  S       (output) DOUBLE PRECISION array, dimension (min(M,N))
*          The singular values of A, sorted so that S(i) >= S(i+1).
*
*  U       (output) COMPLEX*16 array, dimension (LDU,UCOL)
*          UCOL = M if JOBZ = 'A' or JOBZ = 'O' and M < N;
*          UCOL = min(M,N) if JOBZ = 'S'.
*          If JOBZ = 'A' or JOBZ = 'O' and M < N, U contains the M-by-M
*          unitary matrix U;
*          if JOBZ = 'S', U contains the first min(M,N) columns of U
*          (the left singular vectors, stored columnwise);
*          if JOBZ = 'O' and M >= N, or JOBZ = 'N', U is not referenced.
*
*  LDU     (input) INTEGER
*          The leading dimension of the array U.  LDU >= 1; if
*          JOBZ = 'S' or 'A' or JOBZ = 'O' and M < N, LDU >= M.
*
*  VT      (output) COMPLEX*16 array, dimension (LDVT,N)
*          If JOBZ = 'A' or JOBZ = 'O' and M >= N, VT contains the
*          N-by-N unitary matrix V**H;
*          if JOBZ = 'S', VT contains the first min(M,N) rows of
*          V**H (the right singular vectors, stored rowwise);
*          if JOBZ = 'O' and M < N, or JOBZ = 'N', VT is not referenced.
*
*  LDVT    (input) INTEGER
*          The leading dimension of the array VT.  LDVT >= 1; if
*          JOBZ = 'A' or JOBZ = 'O' and M >= N, LDVT >= N;
*          if JOBZ = 'S', LDVT >= min(M,N).
*
*  WORK    (workspace/output) COMPLEX*16 array, dimension (LWORK)
*          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*
*  LWORK   (input) INTEGER
*          The dimension of the array WORK. LWORK >= 1.
*          if JOBZ = 'N', LWORK >= 2*min(M,N)+max(M,N).
*          if JOBZ = 'O',
*                LWORK >= 2*min(M,N)*min(M,N)+2*min(M,N)+max(M,N).
*          if JOBZ = 'S' or 'A',
*                LWORK >= min(M,N)*min(M,N)+2*min(M,N)+max(M,N).
*          For good performance, LWORK should generally be larger.
*          If LWORK < 0 but other input arguments are legal, WORK(1)
*          returns the optimal LWORK.
*
*  RWORK   (workspace) DOUBLE PRECISION array, dimension (LRWORK)
*          If JOBZ = 'N', LRWORK >= 7*min(M,N).
*          Otherwise, LRWORK >= 5*min(M,N)*min(M,N) + 5*min(M,N)
*
*  IWORK   (workspace) INTEGER array, dimension (8*min(M,N))
*
*  INFO    (output) INTEGER
*          = 0:  successful exit.
*          < 0:  if INFO = -i, the i-th argument had an illegal value.
*          > 0:  The updating process of DBDSDC did not converge.
*
*  Further Details
*  ===============
*
*  Based on contributions by
*     Ming Gu and Huan Ren, Computer Science Division, University of
*     California at Berkeley, USA
*
*  =====================================================================
*
*     .. Parameters ..
      COMPLEX*16         CZERO, CONE
      PARAMETER          ( CZERO = ( 0.0D0, 0.0D0 ),
     $                   CONE = ( 1.0D0, 0.0D0 ) )
      DOUBLE PRECISION   ZERO, ONE
      PARAMETER          ( ZERO = 0.0D0, ONE = 1.0D0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            LQUERY, WNTQA, WNTQAS, WNTQN, WNTQO, WNTQS
      INTEGER            BLK, CHUNK, I, IE, IERR, IL, IR, IRU, IRVT,
     $                   ISCL, ITAU, ITAUP, ITAUQ, IU, IVT, LDWKVT,
     $                   LDWRKL, LDWRKR, LDWRKU, MAXWRK, MINMN, MINWRK,
     $                   MNTHR1, MNTHR2, NRWORK, NWORK, WRKBL
      DOUBLE PRECISION   ANRM, BIGNUM, EPS, SMLNUM
*     ..
*     .. Local Arrays ..
      INTEGER            IDUM( 1 )
      DOUBLE PRECISION   DUM( 1 )
*     ..
*     .. External Subroutines ..
      EXTERNAL           DBDSDC, DLASCL, XERBLA, ZGEBRD, ZGELQF, ZGEMM, 
     $                   ZGEQRF, ZLACP2, ZLACPY, ZLACRM, ZLARCM, ZLASCL, 
     $                   ZLASET, ZUNGBR, ZUNGLQ, ZUNGQR, ZUNMBR
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            ILAENV
      DOUBLE PRECISION   DLAMCH, ZLANGE
      EXTERNAL           DLAMCH, ILAENV, LSAME, ZLANGE
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          INT, MAX, MIN, SQRT
*     ..
*     .. Executable Statements ..
*
*     Test the input arguments
*
      INFO = 0
      MINMN = MIN( M, N )
      MNTHR1 = INT( MINMN*17.0D0 / 9.0D0 )
      MNTHR2 = INT( MINMN*5.0D0 / 3.0D0 )
      WNTQA = LSAME( JOBZ, 'A' )
      WNTQS = LSAME( JOBZ, 'S' )
      WNTQAS = WNTQA .OR. WNTQS
      WNTQO = LSAME( JOBZ, 'O' )
      WNTQN = LSAME( JOBZ, 'N' )
      MINWRK = 1
      MAXWRK = 1
      LQUERY = ( LWORK.EQ.-1 )
*
      IF( .NOT.( WNTQA .OR. WNTQS .OR. WNTQO .OR. WNTQN ) ) THEN
         INFO = -1
      ELSE IF( M.LT.0 ) THEN
         INFO = -2
      ELSE IF( N.LT.0 ) THEN
         INFO = -3
      ELSE IF( LDA.LT.MAX( 1, M ) ) THEN
         INFO = -5
      ELSE IF( LDU.LT.1 .OR. ( WNTQAS .AND. LDU.LT.M ) .OR.
     $         ( WNTQO .AND. M.LT.N .AND. LDU.LT.M ) ) THEN
         INFO = -8
      ELSE IF( LDVT.LT.1 .OR. ( WNTQA .AND. LDVT.LT.N ) .OR.
     $         ( WNTQS .AND. LDVT.LT.MINMN ) .OR.
     $         ( WNTQO .AND. M.GE.N .AND. LDVT.LT.N ) ) THEN
         INFO = -10
      END IF
*
*     Compute workspace
*      (Note: Comments in the code beginning "Workspace:" describe the
*       minimal amount of workspace needed at that point in the code,
*       as well as the preferred amount for good performance.
*       CWorkspace refers to complex workspace, and RWorkspace to
*       real workspace. NB refers to the optimal block size for the
*       immediately following subroutine, as returned by ILAENV.)
*
      IF( INFO.EQ.0 .AND. M.GT.0 .AND. N.GT.0 ) THEN
         IF( M.GE.N ) THEN
*
*           There is no complex work space needed for bidiagonal SVD
*           The real work space needed for bidiagonal SVD is BDSPAC,
*           BDSPAC = 3*N*N + 4*N
*
            IF( M.GE.MNTHR1 ) THEN
               IF( WNTQN ) THEN
*
*                 Path 1 (M much larger than N, JOBZ='N')
*
                  WRKBL = N + N*ILAENV( 1, 'ZGEQRF', ' ', M, N, -1,
     $                    -1 )
                  WRKBL = MAX( WRKBL, 2*N+2*N*
     $                    ILAENV( 1, 'ZGEBRD', ' ', N, N, -1, -1 ) )
                  MAXWRK = WRKBL
                  MINWRK = 3*N
               ELSE IF( WNTQO ) THEN
*
*                 Path 2 (M much larger than N, JOBZ='O')
*
                  WRKBL = N + N*ILAENV( 1, 'ZGEQRF', ' ', M, N, -1, -1 )
                  WRKBL = MAX( WRKBL, N+N*ILAENV( 1, 'ZUNGQR', ' ', M,
     $                    N, N, -1 ) )
                  WRKBL = MAX( WRKBL, 2*N+2*N*
     $                    ILAENV( 1, 'ZGEBRD', ' ', N, N, -1, -1 ) )
                  WRKBL = MAX( WRKBL, 2*N+N*
     $                    ILAENV( 1, 'ZUNMBR', 'QLN', N, N, N, -1 ) )
                  WRKBL = MAX( WRKBL, 2*N+N*
     $                    ILAENV( 1, 'ZUNMBR', 'PRC', N, N, N, -1 ) )
                  MAXWRK = M*N + N*N + WRKBL
                  MINWRK = 2*N*N + 3*N
               ELSE IF( WNTQS ) THEN
*
*                 Path 3 (M much larger than N, JOBZ='S')
*
                  WRKBL = N + N*ILAENV( 1, 'ZGEQRF', ' ', M, N, -1, -1 )
                  WRKBL = MAX( WRKBL, N+N*ILAENV( 1, 'ZUNGQR', ' ', M,
     $                    N, N, -1 ) )
                  WRKBL = MAX( WRKBL, 2*N+2*N*
     $                    ILAENV( 1, 'ZGEBRD', ' ', N, N, -1, -1 ) )
                  WRKBL = MAX( WRKBL, 2*N+N*
     $                    ILAENV( 1, 'ZUNMBR', 'QLN', N, N, N, -1 ) )
                  WRKBL = MAX( WRKBL, 2*N+N*
     $                    ILAENV( 1, 'ZUNMBR', 'PRC', N, N, N, -1 ) )
                  MAXWRK = N*N + WRKBL
                  MINWRK = N*N + 3*N
               ELSE IF( WNTQA ) THEN
*
*                 Path 4 (M much larger than N, JOBZ='A')
*
                  WRKBL = N + N*ILAENV( 1, 'ZGEQRF', ' ', M, N, -1, -1 )
                  WRKBL = MAX( WRKBL, N+M*ILAENV( 1, 'ZUNGQR', ' ', M,
     $                    M, N, -1 ) )
                  WRKBL = MAX( WRKBL, 2*N+2*N*
     $                    ILAENV( 1, 'ZGEBRD', ' ', N, N, -1, -1 ) )
                  WRKBL = MAX( WRKBL, 2*N+N*
     $                    ILAENV( 1, 'ZUNMBR', 'QLN', N, N, N, -1 ) )
                  WRKBL = MAX( WRKBL, 2*N+N*
     $                    ILAENV( 1, 'ZUNMBR', 'PRC', N, N, N, -1 ) )
                  MAXWRK = N*N + WRKBL
                  MINWRK = N*N + 2*N + M
               END IF
            ELSE IF( M.GE.MNTHR2 ) THEN
*
*              Path 5 (M much larger than N, but not as much as MNTHR1)
*
               MAXWRK = 2*N + ( M+N )*ILAENV( 1, 'ZGEBRD', ' ', M, N,
     $                  -1, -1 )
               MINWRK = 2*N + M
               IF( WNTQO ) THEN
                  MAXWRK = MAX( MAXWRK, 2*N+N*
     $                     ILAENV( 1, 'ZUNGBR', 'P', N, N, N, -1 ) )
                  MAXWRK = MAX( MAXWRK, 2*N+N*
     $                     ILAENV( 1, 'ZUNGBR', 'Q', M, N, N, -1 ) )
                  MAXWRK = MAXWRK + M*N
                  MINWRK = MINWRK + N*N
               ELSE IF( WNTQS ) THEN
                  MAXWRK = MAX( MAXWRK, 2*N+N*
     $                     ILAENV( 1, 'ZUNGBR', 'P', N, N, N, -1 ) )
                  MAXWRK = MAX( MAXWRK, 2*N+N*
     $                     ILAENV( 1, 'ZUNGBR', 'Q', M, N, N, -1 ) )
               ELSE IF( WNTQA ) THEN
                  MAXWRK = MAX( MAXWRK, 2*N+N*
     $                     ILAENV( 1, 'ZUNGBR', 'P', N, N, N, -1 ) )
                  MAXWRK = MAX( MAXWRK, 2*N+M*
     $                     ILAENV( 1, 'ZUNGBR', 'Q', M, M, N, -1 ) )
               END IF
            ELSE
*
*              Path 6 (M at least N, but not much larger)
*
               MAXWRK = 2*N + ( M+N )*ILAENV( 1, 'ZGEBRD', ' ', M, N,
     $                  -1, -1 )
               MINWRK = 2*N + M
               IF( WNTQO ) THEN
                  MAXWRK = MAX( MAXWRK, 2*N+N*
     $                     ILAENV( 1, 'ZUNMBR', 'PRC', N, N, N, -1 ) )
                  MAXWRK = MAX( MAXWRK, 2*N+N*
     $                     ILAENV( 1, 'ZUNMBR', 'QLN', M, N, N, -1 ) )
                  MAXWRK = MAXWRK + M*N
                  MINWRK = MINWRK + N*N
               ELSE IF( WNTQS ) THEN
                  MAXWRK = MAX( MAXWRK, 2*N+N*
     $                     ILAENV( 1, 'ZUNMBR', 'PRC', N, N, N, -1 ) )
                  MAXWRK = MAX( MAXWRK, 2*N+N*
     $                     ILAENV( 1, 'ZUNMBR', 'QLN', M, N, N, -1 ) )
               ELSE IF( WNTQA ) THEN
                  MAXWRK = MAX( MAXWRK, 2*N+N*
     $                     ILAENV( 1, 'ZUNGBR', 'PRC', N, N, N, -1 ) )
                  MAXWRK = MAX( MAXWRK, 2*N+M*
     $                     ILAENV( 1, 'ZUNGBR', 'QLN', M, M, N, -1 ) )
               END IF
            END IF
         ELSE
*
*           There is no complex work space needed for bidiagonal SVD
*           The real work space needed for bidiagonal SVD is BDSPAC,
*           BDSPAC = 3*M*M + 4*M
*
            IF( N.GE.MNTHR1 ) THEN
               IF( WNTQN ) THEN
*
*                 Path 1t (N much larger than M, JOBZ='N')
*
                  MAXWRK = M + M*ILAENV( 1, 'ZGELQF', ' ', M, N, -1,
     $                     -1 )
                  MAXWRK = MAX( MAXWRK, 2*M+2*M*
     $                     ILAENV( 1, 'ZGEBRD', ' ', M, M, -1, -1 ) )
                  MINWRK = 3*M
               ELSE IF( WNTQO ) THEN
*
*                 Path 2t (N much larger than M, JOBZ='O')
*
                  WRKBL = M + M*ILAENV( 1, 'ZGELQF', ' ', M, N, -1, -1 )
                  WRKBL = MAX( WRKBL, M+M*ILAENV( 1, 'ZUNGLQ', ' ', M,
     $                    N, M, -1 ) )
                  WRKBL = MAX( WRKBL, 2*M+2*M*
     $                    ILAENV( 1, 'ZGEBRD', ' ', M, M, -1, -1 ) )
                  WRKBL = MAX( WRKBL, 2*M+M*
     $                    ILAENV( 1, 'ZUNMBR', 'PRC', M, M, M, -1 ) )
                  WRKBL = MAX( WRKBL, 2*M+M*
     $                    ILAENV( 1, 'ZUNMBR', 'QLN', M, M, M, -1 ) )
                  MAXWRK = M*N + M*M + WRKBL
                  MINWRK = 2*M*M + 3*M
               ELSE IF( WNTQS ) THEN
*
*                 Path 3t (N much larger than M, JOBZ='S')
*
                  WRKBL = M + M*ILAENV( 1, 'ZGELQF', ' ', M, N, -1, -1 )
                  WRKBL = MAX( WRKBL, M+M*ILAENV( 1, 'ZUNGLQ', ' ', M,
     $                    N, M, -1 ) )
                  WRKBL = MAX( WRKBL, 2*M+2*M*
     $                    ILAENV( 1, 'ZGEBRD', ' ', M, M, -1, -1 ) )
                  WRKBL = MAX( WRKBL, 2*M+M*
     $                    ILAENV( 1, 'ZUNMBR', 'PRC', M, M, M, -1 ) )
                  WRKBL = MAX( WRKBL, 2*M+M*
     $                    ILAENV( 1, 'ZUNMBR', 'QLN', M, M, M, -1 ) )
                  MAXWRK = M*M + WRKBL
                  MINWRK = M*M + 3*M
               ELSE IF( WNTQA ) THEN
*
*                 Path 4t (N much larger than M, JOBZ='A')
*
                  WRKBL = M + M*ILAENV( 1, 'ZGELQF', ' ', M, N, -1, -1 )
                  WRKBL = MAX( WRKBL, M+N*ILAENV( 1, 'ZUNGLQ', ' ', N,
     $                    N, M, -1 ) )
                  WRKBL = MAX( WRKBL, 2*M+2*M*
     $                    ILAENV( 1, 'ZGEBRD', ' ', M, M, -1, -1 ) )
                  WRKBL = MAX( WRKBL, 2*M+M*
     $                    ILAENV( 1, 'ZUNMBR', 'PRC', M, M, M, -1 ) )
                  WRKBL = MAX( WRKBL, 2*M+M*
     $                    ILAENV( 1, 'ZUNMBR', 'QLN', M, M, M, -1 ) )
                  MAXWRK = M*M + WRKBL
                  MINWRK = M*M + 2*M + N
               END IF
            ELSE IF( N.GE.MNTHR2 ) THEN
*
*              Path 5t (N much larger than M, but not as much as MNTHR1)
*
               MAXWRK = 2*M + ( M+N )*ILAENV( 1, 'ZGEBRD', ' ', M, N,
     $                  -1, -1 )
               MINWRK = 2*M + N
               IF( WNTQO ) THEN
                  MAXWRK = MAX( MAXWRK, 2*M+M*
     $                     ILAENV( 1, 'ZUNGBR', 'P', M, N, M, -1 ) )
                  MAXWRK = MAX( MAXWRK, 2*M+M*
     $                     ILAENV( 1, 'ZUNGBR', 'Q', M, M, N, -1 ) )
                  MAXWRK = MAXWRK + M*N
                  MINWRK = MINWRK + M*M
               ELSE IF( WNTQS ) THEN
                  MAXWRK = MAX( MAXWRK, 2*M+M*
     $                     ILAENV( 1, 'ZUNGBR', 'P', M, N, M, -1 ) )
                  MAXWRK = MAX( MAXWRK, 2*M+M*
     $                     ILAENV( 1, 'ZUNGBR', 'Q', M, M, N, -1 ) )
               ELSE IF( WNTQA ) THEN
                  MAXWRK = MAX( MAXWRK, 2*M+N*
     $                     ILAENV( 1, 'ZUNGBR', 'P', N, N, M, -1 ) )
                  MAXWRK = MAX( MAXWRK, 2*M+M*
     $                     ILAENV( 1, 'ZUNGBR', 'Q', M, M, N, -1 ) )
               END IF
            ELSE
*
*              Path 6t (N greater than M, but not much larger)
*
               MAXWRK = 2*M + ( M+N )*ILAENV( 1, 'ZGEBRD', ' ', M, N,
     $                  -1, -1 )
               MINWRK = 2*M + N
               IF( WNTQO ) THEN
                  MAXWRK = MAX( MAXWRK, 2*M+M*
     $                     ILAENV( 1, 'ZUNMBR', 'PRC', M, N, M, -1 ) )
                  MAXWRK = MAX( MAXWRK, 2*M+M*
     $                     ILAENV( 1, 'ZUNMBR', 'QLN', M, M, N, -1 ) )
                  MAXWRK = MAXWRK + M*N
                  MINWRK = MINWRK + M*M
               ELSE IF( WNTQS ) THEN
                  MAXWRK = MAX( MAXWRK, 2*M+M*
     $                     ILAENV( 1, 'ZUNGBR', 'PRC', M, N, M, -1 ) )
                  MAXWRK = MAX( MAXWRK, 2*M+M*
     $                     ILAENV( 1, 'ZUNGBR', 'QLN', M, M, N, -1 ) )
               ELSE IF( WNTQA ) THEN
                  MAXWRK = MAX( MAXWRK, 2*M+N*
     $                     ILAENV( 1, 'ZUNGBR', 'PRC', N, N, M, -1 ) )
                  MAXWRK = MAX( MAXWRK, 2*M+M*
     $                     ILAENV( 1, 'ZUNGBR', 'QLN', M, M, N, -1 ) )
               END IF
            END IF
         END IF
         MAXWRK = MAX( MAXWRK, MINWRK )
         WORK( 1 ) = MAXWRK
      END IF
*
      IF( LWORK.LT.MINWRK .AND. .NOT.LQUERY ) THEN
         INFO = -13
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'ZGESDD', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( M.EQ.0 .OR. N.EQ.0 ) THEN
         IF( LWORK.GE.1 )
     $      WORK( 1 ) = ONE
         RETURN
      END IF
*
*     Get machine constants
*
      EPS = DLAMCH( 'P' )
      SMLNUM = SQRT( DLAMCH( 'S' ) ) / EPS
      BIGNUM = ONE / SMLNUM
*
*     Scale A if max element outside range [SMLNUM,BIGNUM]
*
      ANRM = ZLANGE( 'M', M, N, A, LDA, DUM )
      ISCL = 0
      IF( ANRM.GT.ZERO .AND. ANRM.LT.SMLNUM ) THEN
         ISCL = 1
         CALL ZLASCL( 'G', 0, 0, ANRM, SMLNUM, M, N, A, LDA, IERR )
      ELSE IF( ANRM.GT.BIGNUM ) THEN
         ISCL = 1
         CALL ZLASCL( 'G', 0, 0, ANRM, BIGNUM, M, N, A, LDA, IERR )
      END IF
*
      IF( M.GE.N ) THEN
*
*        A has at least as many rows as columns. If A has sufficiently
*        more rows than columns, first reduce using the QR
*        decomposition (if sufficient workspace available)
*
         IF( M.GE.MNTHR1 ) THEN
*
            IF( WNTQN ) THEN
*
*              Path 1 (M much larger than N, JOBZ='N')
*              No singular vectors to be computed
*
               ITAU = 1
               NWORK = ITAU + N
*
*              Compute A=Q*R
*              (CWorkspace: need 2*N, prefer N+N*NB)
*              (RWorkspace: need 0)
*
               CALL ZGEQRF( M, N, A, LDA, WORK( ITAU ), WORK( NWORK ),
     $                      LWORK-NWORK+1, IERR )
*
*              Zero out below R
*
               CALL ZLASET( 'L', N-1, N-1, CZERO, CZERO, A( 2, 1 ),
     $                      LDA )
               IE = 1
               ITAUQ = 1
               ITAUP = ITAUQ + N
               NWORK = ITAUP + N
*
*              Bidiagonalize R in A
*              (CWorkspace: need 3*N, prefer 2*N+2*N*NB)
*              (RWorkspace: need N)
*
               CALL ZGEBRD( N, N, A, LDA, S, RWORK( IE ), WORK( ITAUQ ),
     $                      WORK( ITAUP ), WORK( NWORK ), LWORK-NWORK+1,
     $                      IERR )
               NRWORK = IE + N
*
*              Perform bidiagonal SVD, compute singular values only
*              (CWorkspace: 0)
*              (RWorkspace: need BDSPAC)
*
               CALL DBDSDC( 'U', 'N', N, S, RWORK( IE ), DUM, 1, DUM, 1,
     $                      DUM, IDUM, RWORK( NRWORK ), IWORK, INFO )
*
            ELSE IF( WNTQO ) THEN
*
*              Path 2 (M much larger than N, JOBZ='O')
*              N left singular vectors to be overwritten on A and
*              N right singular vectors to be computed in VT
*
               IU = 1
*
*              WORK(IU) is N by N
*
               LDWRKU = N
               IR = IU + LDWRKU*N
               IF( LWORK.GE.M*N+N*N+3*N ) THEN
*
*                 WORK(IR) is M by N
*
                  LDWRKR = M
               ELSE
                  LDWRKR = ( LWORK-N*N-3*N ) / N
               END IF
               ITAU = IR + LDWRKR*N
               NWORK = ITAU + N
*
*              Compute A=Q*R
*              (CWorkspace: need N*N+2*N, prefer M*N+N+N*NB)
*              (RWorkspace: 0)
*
               CALL ZGEQRF( M, N, A, LDA, WORK( ITAU ), WORK( NWORK ),
     $                      LWORK-NWORK+1, IERR )
*
*              Copy R to WORK( IR ), zeroing out below it
*
               CALL ZLACPY( 'U', N, N, A, LDA, WORK( IR ), LDWRKR )
               CALL ZLASET( 'L', N-1, N-1, CZERO, CZERO, WORK( IR+1 ),
     $                      LDWRKR )
*
*              Generate Q in A
*              (CWorkspace: need 2*N, prefer N+N*NB)
*              (RWorkspace: 0)
*
               CALL ZUNGQR( M, N, N, A, LDA, WORK( ITAU ),
     $                      WORK( NWORK ), LWORK-NWORK+1, IERR )
               IE = 1
               ITAUQ = ITAU
               ITAUP = ITAUQ + N
               NWORK = ITAUP + N
*
*              Bidiagonalize R in WORK(IR)
*              (CWorkspace: need N*N+3*N, prefer M*N+2*N+2*N*NB)
*              (RWorkspace: need N)
*
               CALL ZGEBRD( N, N, WORK( IR ), LDWRKR, S, RWORK( IE ),
     $                      WORK( ITAUQ ), WORK( ITAUP ), WORK( NWORK ),
     $                      LWORK-NWORK+1, IERR )
*
*              Perform bidiagonal SVD, computing left singular vectors
*              of R in WORK(IRU) and computing right singular vectors
*              of R in WORK(IRVT)
*              (CWorkspace: need 0)
*              (RWorkspace: need BDSPAC)
*
               IRU = IE + N
               IRVT = IRU + N*N
               NRWORK = IRVT + N*N
               CALL DBDSDC( 'U', 'I', N, S, RWORK( IE ), RWORK( IRU ),
     $                      N, RWORK( IRVT ), N, DUM, IDUM,
     $                      RWORK( NRWORK ), IWORK, INFO )
*
*              Copy real matrix RWORK(IRU) to complex matrix WORK(IU)
*              Overwrite WORK(IU) by the left singular vectors of R
*              (CWorkspace: need 2*N*N+3*N, prefer M*N+N*N+2*N+N*NB)
*              (RWorkspace: 0)
*
               CALL ZLACP2( 'F', N, N, RWORK( IRU ), N, WORK( IU ),
     $                      LDWRKU )
               CALL ZUNMBR( 'Q', 'L', 'N', N, N, N, WORK( IR ), LDWRKR,
     $                      WORK( ITAUQ ), WORK( IU ), LDWRKU,
     $                      WORK( NWORK ), LWORK-NWORK+1, IERR )
*
*              Copy real matrix RWORK(IRVT) to complex matrix VT
*              Overwrite VT by the right singular vectors of R
*              (CWorkspace: need N*N+3*N, prefer M*N+2*N+N*NB)
*              (RWorkspace: 0)
*
               CALL ZLACP2( 'F', N, N, RWORK( IRVT ), N, VT, LDVT )
               CALL ZUNMBR( 'P', 'R', 'C', N, N, N, WORK( IR ), LDWRKR,
     $                      WORK( ITAUP ), VT, LDVT, WORK( NWORK ),
     $                      LWORK-NWORK+1, IERR )
*
*              Multiply Q in A by left singular vectors of R in
*              WORK(IU), storing result in WORK(IR) and copying to A
*              (CWorkspace: need 2*N*N, prefer N*N+M*N)
*              (RWorkspace: 0)
*
               DO 10 I = 1, M, LDWRKR
                  CHUNK = MIN( M-I+1, LDWRKR )
                  CALL ZGEMM( 'N', 'N', CHUNK, N, N, CONE, A( I, 1 ),
     $                        LDA, WORK( IU ), LDWRKU, CZERO,
     $                        WORK( IR ), LDWRKR )
                  CALL ZLACPY( 'F', CHUNK, N, WORK( IR ), LDWRKR,
     $                         A( I, 1 ), LDA )
   10          CONTINUE
*
            ELSE IF( WNTQS ) THEN
*
*              Path 3 (M much larger than N, JOBZ='S')
*              N left singular vectors to be computed in U and
*              N right singular vectors to be computed in VT
*
               IR = 1
*
*              WORK(IR) is N by N
*
               LDWRKR = N
               ITAU = IR + LDWRKR*N
               NWORK = ITAU + N
*
*              Compute A=Q*R
*              (CWorkspace: need N*N+2*N, prefer N*N+N+N*NB)
*              (RWorkspace: 0)
*
               CALL ZGEQRF( M, N, A, LDA, WORK( ITAU ), WORK( NWORK ),
     $                      LWORK-NWORK+1, IERR )
*
*              Copy R to WORK(IR), zeroing out below it
*
               CALL ZLACPY( 'U', N, N, A, LDA, WORK( IR ), LDWRKR )
               CALL ZLASET( 'L', N-1, N-1, CZERO, CZERO, WORK( IR+1 ),
     $                      LDWRKR )
*
*              Generate Q in A
*              (CWorkspace: need 2*N, prefer N+N*NB)
*              (RWorkspace: 0)
*
               CALL ZUNGQR( M, N, N, A, LDA, WORK( ITAU ),
     $                      WORK( NWORK ), LWORK-NWORK+1, IERR )
               IE = 1
               ITAUQ = ITAU
               ITAUP = ITAUQ + N
               NWORK = ITAUP + N
*
*              Bidiagonalize R in WORK(IR)
*              (CWorkspace: need N*N+3*N, prefer N*N+2*N+2*N*NB)
*              (RWorkspace: need N)
*
               CALL ZGEBRD( N, N, WORK( IR ), LDWRKR, S, RWORK( IE ),
     $                      WORK( ITAUQ ), WORK( ITAUP ), WORK( NWORK ),
     $                      LWORK-NWORK+1, IERR )
*
*              Perform bidiagonal SVD, computing left singular vectors
*              of bidiagonal matrix in RWORK(IRU) and computing right
*              singular vectors of bidiagonal matrix in RWORK(IRVT)
*              (CWorkspace: need 0)
*              (RWorkspace: need BDSPAC)
*
               IRU = IE + N
               IRVT = IRU + N*N
               NRWORK = IRVT + N*N
               CALL DBDSDC( 'U', 'I', N, S, RWORK( IE ), RWORK( IRU ),
     $                      N, RWORK( IRVT ), N, DUM, IDUM,
     $                      RWORK( NRWORK ), IWORK, INFO )
*
*              Copy real matrix RWORK(IRU) to complex matrix U
*              Overwrite U by left singular vectors of R
*              (CWorkspace: need N*N+3*N, prefer N*N+2*N+N*NB)
*              (RWorkspace: 0)
*
               CALL ZLACP2( 'F', N, N, RWORK( IRU ), N, U, LDU )
               CALL ZUNMBR( 'Q', 'L', 'N', N, N, N, WORK( IR ), LDWRKR,
     $                      WORK( ITAUQ ), U, LDU, WORK( NWORK ),
     $                      LWORK-NWORK+1, IERR )
*
*              Copy real matrix RWORK(IRVT) to complex matrix VT
*              Overwrite VT by right singular vectors of R
*              (CWorkspace: need N*N+3*N, prefer N*N+2*N+N*NB)
*              (RWorkspace: 0)
*
               CALL ZLACP2( 'F', N, N, RWORK( IRVT ), N, VT, LDVT )
               CALL ZUNMBR( 'P', 'R', 'C', N, N, N, WORK( IR ), LDWRKR,
     $                      WORK( ITAUP ), VT, LDVT, WORK( NWORK ),
     $                      LWORK-NWORK+1, IERR )
*
*              Multiply Q in A by left singular vectors of R in
*              WORK(IR), storing result in U
*              (CWorkspace: need N*N)
*              (RWorkspace: 0)
*
               CALL ZLACPY( 'F', N, N, U, LDU, WORK( IR ), LDWRKR )
               CALL ZGEMM( 'N', 'N', M, N, N, CONE, A, LDA, WORK( IR ),
     $                     LDWRKR, CZERO, U, LDU )
*
            ELSE IF( WNTQA ) THEN
*
*              Path 4 (M much larger than N, JOBZ='A')
*              M left singular vectors to be computed in U and
*              N right singular vectors to be computed in VT
*
               IU = 1
*
*              WORK(IU) is N by N
*
               LDWRKU = N
               ITAU = IU + LDWRKU*N
               NWORK = ITAU + N
*
*              Compute A=Q*R, copying result to U
*              (CWorkspace: need 2*N, prefer N+N*NB)
*              (RWorkspace: 0)
*
               CALL ZGEQRF( M, N, A, LDA, WORK( ITAU ), WORK( NWORK ),
     $                      LWORK-NWORK+1, IERR )
               CALL ZLACPY( 'L', M, N, A, LDA, U, LDU )
*
*              Generate Q in U
*              (CWorkspace: need N+M, prefer N+M*NB)
*              (RWorkspace: 0)
*
               CALL ZUNGQR( M, M, N, U, LDU, WORK( ITAU ),
     $                      WORK( NWORK ), LWORK-NWORK+1, IERR )
*
*              Produce R in A, zeroing out below it
*
               CALL ZLASET( 'L', N-1, N-1, CZERO, CZERO, A( 2, 1 ),
     $                      LDA )
               IE = 1
               ITAUQ = ITAU
               ITAUP = ITAUQ + N
               NWORK = ITAUP + N
*
*              Bidiagonalize R in A
*              (CWorkspace: need 3*N, prefer 2*N+2*N*NB)
*              (RWorkspace: need N)
*
               CALL ZGEBRD( N, N, A, LDA, S, RWORK( IE ), WORK( ITAUQ ),
     $                      WORK( ITAUP ), WORK( NWORK ), LWORK-NWORK+1,
     $                      IERR )
               IRU = IE + N
               IRVT = IRU + N*N
               NRWORK = IRVT + N*N
*
*              Perform bidiagonal SVD, computing left singular vectors
*              of bidiagonal matrix in RWORK(IRU) and computing right
*              singular vectors of bidiagonal matrix in RWORK(IRVT)
*              (CWorkspace: need 0)
*              (RWorkspace: need BDSPAC)
*
               CALL DBDSDC( 'U', 'I', N, S, RWORK( IE ), RWORK( IRU ),
     $                      N, RWORK( IRVT ), N, DUM, IDUM,
     $                      RWORK( NRWORK ), IWORK, INFO )
*
*              Copy real matrix RWORK(IRU) to complex matrix WORK(IU)
*              Overwrite WORK(IU) by left singular vectors of R
*              (CWorkspace: need N*N+3*N, prefer N*N+2*N+N*NB)
*              (RWorkspace: 0)
*
               CALL ZLACP2( 'F', N, N, RWORK( IRU ), N, WORK( IU ),
     $                      LDWRKU )
               CALL ZUNMBR( 'Q', 'L', 'N', N, N, N, A, LDA,
     $                      WORK( ITAUQ ), WORK( IU ), LDWRKU,
     $                      WORK( NWORK ), LWORK-NWORK+1, IERR )
*
*              Copy real matrix RWORK(IRVT) to complex matrix VT
*              Overwrite VT by right singular vectors of R
*              (CWorkspace: need 3*N, prefer 2*N+N*NB)
*              (RWorkspace: 0)
*
               CALL ZLACP2( 'F', N, N, RWORK( IRVT ), N, VT, LDVT )
               CALL ZUNMBR( 'P', 'R', 'C', N, N, N, A, LDA,
     $                      WORK( ITAUP ), VT, LDVT, WORK( NWORK ),
     $                      LWORK-NWORK+1, IERR )
*
*              Multiply Q in U by left singular vectors of R in
*              WORK(IU), storing result in A
*              (CWorkspace: need N*N)
*              (RWorkspace: 0)
*
               CALL ZGEMM( 'N', 'N', M, N, N, CONE, U, LDU, WORK( IU ),
     $                     LDWRKU, CZERO, A, LDA )
*
*              Copy left singular vectors of A from A to U
*
               CALL ZLACPY( 'F', M, N, A, LDA, U, LDU )
*
            END IF
*
         ELSE IF( M.GE.MNTHR2 ) THEN
*
*           MNTHR2 <= M < MNTHR1
*
*           Path 5 (M much larger than N, but not as much as MNTHR1)
*           Reduce to bidiagonal form without QR decomposition, use
*           ZUNGBR and matrix multiplication to compute singular vectors
*
            IE = 1
            NRWORK = IE + N
            ITAUQ = 1
            ITAUP = ITAUQ + N
            NWORK = ITAUP + N
*
*           Bidiagonalize A
*           (CWorkspace: need 2*N+M, prefer 2*N+(M+N)*NB)
*           (RWorkspace: need N)
*
            CALL ZGEBRD( M, N, A, LDA, S, RWORK( IE ), WORK( ITAUQ ),
     $                   WORK( ITAUP ), WORK( NWORK ), LWORK-NWORK+1,
     $                   IERR )
            IF( WNTQN ) THEN
*
*              Compute singular values only
*              (Cworkspace: 0)
*              (Rworkspace: need BDSPAC)
*
               CALL DBDSDC( 'U', 'N', N, S, RWORK( IE ), DUM, 1, DUM, 1,
     $                      DUM, IDUM, RWORK( NRWORK ), IWORK, INFO )
            ELSE IF( WNTQO ) THEN
               IU = NWORK
               IRU = NRWORK
               IRVT = IRU + N*N
               NRWORK = IRVT + N*N
*
*              Copy A to VT, generate P**H
*              (Cworkspace: need 2*N, prefer N+N*NB)
*              (Rworkspace: 0)
*
               CALL ZLACPY( 'U', N, N, A, LDA, VT, LDVT )
               CALL ZUNGBR( 'P', N, N, N, VT, LDVT, WORK( ITAUP ),
     $                      WORK( NWORK ), LWORK-NWORK+1, IERR )
*
*              Generate Q in A
*              (CWorkspace: need 2*N, prefer N+N*NB)
*              (RWorkspace: 0)
*
               CALL ZUNGBR( 'Q', M, N, N, A, LDA, WORK( ITAUQ ),
     $                      WORK( NWORK ), LWORK-NWORK+1, IERR )
*
               IF( LWORK.GE.M*N+3*N ) THEN
*
*                 WORK( IU ) is M by N
*
                  LDWRKU = M
               ELSE
*
*                 WORK(IU) is LDWRKU by N
*
                  LDWRKU = ( LWORK-3*N ) / N
               END IF
               NWORK = IU + LDWRKU*N
*
*              Perform bidiagonal SVD, computing left singular vectors
*              of bidiagonal matrix in RWORK(IRU) and computing right
*              singular vectors of bidiagonal matrix in RWORK(IRVT)
*              (CWorkspace: need 0)
*              (RWorkspace: need BDSPAC)
*
               CALL DBDSDC( 'U', 'I', N, S, RWORK( IE ), RWORK( IRU ),
     $                      N, RWORK( IRVT ), N, DUM, IDUM,
     $                      RWORK( NRWORK ), IWORK, INFO )
*
*              Multiply real matrix RWORK(IRVT) by P**H in VT,
*              storing the result in WORK(IU), copying to VT
*              (Cworkspace: need 0)
*              (Rworkspace: need 3*N*N)
*
               CALL ZLARCM( N, N, RWORK( IRVT ), N, VT, LDVT,
     $                      WORK( IU ), LDWRKU, RWORK( NRWORK ) )
               CALL ZLACPY( 'F', N, N, WORK( IU ), LDWRKU, VT, LDVT )
*
*              Multiply Q in A by real matrix RWORK(IRU), storing the
*              result in WORK(IU), copying to A
*              (CWorkspace: need N*N, prefer M*N)
*              (Rworkspace: need 3*N*N, prefer N*N+2*M*N)
*
               NRWORK = IRVT
               DO 20 I = 1, M, LDWRKU
                  CHUNK = MIN( M-I+1, LDWRKU )
                  CALL ZLACRM( CHUNK, N, A( I, 1 ), LDA, RWORK( IRU ),
     $                         N, WORK( IU ), LDWRKU, RWORK( NRWORK ) )
                  CALL ZLACPY( 'F', CHUNK, N, WORK( IU ), LDWRKU,
     $                         A( I, 1 ), LDA )
   20          CONTINUE
*
            ELSE IF( WNTQS ) THEN
*
*              Copy A to VT, generate P**H
*              (Cworkspace: need 2*N, prefer N+N*NB)
*              (Rworkspace: 0)
*
               CALL ZLACPY( 'U', N, N, A, LDA, VT, LDVT )
               CALL ZUNGBR( 'P', N, N, N, VT, LDVT, WORK( ITAUP ),
     $                      WORK( NWORK ), LWORK-NWORK+1, IERR )
*
*              Copy A to U, generate Q
*              (Cworkspace: need 2*N, prefer N+N*NB)
*              (Rworkspace: 0)
*
               CALL ZLACPY( 'L', M, N, A, LDA, U, LDU )
               CALL ZUNGBR( 'Q', M, N, N, U, LDU, WORK( ITAUQ ),
     $                      WORK( NWORK ), LWORK-NWORK+1, IERR )
*
*              Perform bidiagonal SVD, computing left singular vectors
*              of bidiagonal matrix in RWORK(IRU) and computing right
*              singular vectors of bidiagonal matrix in RWORK(IRVT)
*              (CWorkspace: need 0)
*              (RWorkspace: need BDSPAC)
*
               IRU = NRWORK
               IRVT = IRU + N*N
               NRWORK = IRVT + N*N
               CALL DBDSDC( 'U', 'I', N, S, RWORK( IE ), RWORK( IRU ),
     $                      N, RWORK( IRVT ), N, DUM, IDUM,
     $                      RWORK( NRWORK ), IWORK, INFO )
*
*              Multiply real matrix RWORK(IRVT) by P**H in VT,
*              storing the result in A, copying to VT
*              (Cworkspace: need 0)
*              (Rworkspace: need 3*N*N)
*
               CALL ZLARCM( N, N, RWORK( IRVT ), N, VT, LDVT, A, LDA,
     $                      RWORK( NRWORK ) )
               CALL ZLACPY( 'F', N, N, A, LDA, VT, LDVT )
*
*              Multiply Q in U by real matrix RWORK(IRU), storing the
*              result in A, copying to U
*              (CWorkspace: need 0)
*              (Rworkspace: need N*N+2*M*N)
*
               NRWORK = IRVT
               CALL ZLACRM( M, N, U, LDU, RWORK( IRU ), N, A, LDA,
     $                      RWORK( NRWORK ) )
               CALL ZLACPY( 'F', M, N, A, LDA, U, LDU )
            ELSE
*
*              Copy A to VT, generate P**H
*              (Cworkspace: need 2*N, prefer N+N*NB)
*              (Rworkspace: 0)
*
               CALL ZLACPY( 'U', N, N, A, LDA, VT, LDVT )
               CALL ZUNGBR( 'P', N, N, N, VT, LDVT, WORK( ITAUP ),
     $                      WORK( NWORK ), LWORK-NWORK+1, IERR )
*
*              Copy A to U, generate Q
*              (Cworkspace: need 2*N, prefer N+N*NB)
*              (Rworkspace: 0)
*
               CALL ZLACPY( 'L', M, N, A, LDA, U, LDU )
               CALL ZUNGBR( 'Q', M, M, N, U, LDU, WORK( ITAUQ ),
     $                      WORK( NWORK ), LWORK-NWORK+1, IERR )
*
*              Perform bidiagonal SVD, computing left singular vectors
*              of bidiagonal matrix in RWORK(IRU) and computing right
*              singular vectors of bidiagonal matrix in RWORK(IRVT)
*              (CWorkspace: need 0)
*              (RWorkspace: need BDSPAC)
*
               IRU = NRWORK
               IRVT = IRU + N*N
               NRWORK = IRVT + N*N
               CALL DBDSDC( 'U', 'I', N, S, RWORK( IE ), RWORK( IRU ),
     $                      N, RWORK( IRVT ), N, DUM, IDUM,
     $                      RWORK( NRWORK ), IWORK, INFO )
*
*              Multiply real matrix RWORK(IRVT) by P**H in VT,
*              storing the result in A, copying to VT
*              (Cworkspace: need 0)
*              (Rworkspace: need 3*N*N)
*
               CALL ZLARCM( N, N, RWORK( IRVT ), N, VT, LDVT, A, LDA,
     $                      RWORK( NRWORK ) )
               CALL ZLACPY( 'F', N, N, A, LDA, VT, LDVT )
*
*              Multiply Q in U by real matrix RWORK(IRU), storing the
*              result in A, copying to U
*              (CWorkspace: 0)
*              (Rworkspace: need 3*N*N)
*
               NRWORK = IRVT
               CALL ZLACRM( M, N, U, LDU, RWORK( IRU ), N, A, LDA,
     $                      RWORK( NRWORK ) )
               CALL ZLACPY( 'F', M, N, A, LDA, U, LDU )
            END IF
*
         ELSE
*
*           M .LT. MNTHR2
*
*           Path 6 (M at least N, but not much larger)
*           Reduce to bidiagonal form without QR decomposition
*           Use ZUNMBR to compute singular vectors
*
            IE = 1
            NRWORK = IE + N
            ITAUQ = 1
            ITAUP = ITAUQ + N
            NWORK = ITAUP + N
*
*           Bidiagonalize A
*           (CWorkspace: need 2*N+M, prefer 2*N+(M+N)*NB)
*           (RWorkspace: need N)
*
            CALL ZGEBRD( M, N, A, LDA, S, RWORK( IE ), WORK( ITAUQ ),
     $                   WORK( ITAUP ), WORK( NWORK ), LWORK-NWORK+1,
     $                   IERR )
            IF( WNTQN ) THEN
*
*              Compute singular values only
*              (Cworkspace: 0)
*              (Rworkspace: need BDSPAC)
*
               CALL DBDSDC( 'U', 'N', N, S, RWORK( IE ), DUM, 1, DUM, 1,
     $                      DUM, IDUM, RWORK( NRWORK ), IWORK, INFO )
            ELSE IF( WNTQO ) THEN
               IU = NWORK
               IRU = NRWORK
               IRVT = IRU + N*N
               NRWORK = IRVT + N*N
               IF( LWORK.GE.M*N+3*N ) THEN
*
*                 WORK( IU ) is M by N
*
                  LDWRKU = M
               ELSE
*
*                 WORK( IU ) is LDWRKU by N
*
                  LDWRKU = ( LWORK-3*N ) / N
               END IF
               NWORK = IU + LDWRKU*N
*
*              Perform bidiagonal SVD, computing left singular vectors
*              of bidiagonal matrix in RWORK(IRU) and computing right
*              singular vectors of bidiagonal matrix in RWORK(IRVT)
*              (CWorkspace: need 0)
*              (RWorkspace: need BDSPAC)
*
               CALL DBDSDC( 'U', 'I', N, S, RWORK( IE ), RWORK( IRU ),
     $                      N, RWORK( IRVT ), N, DUM, IDUM,
     $                      RWORK( NRWORK ), IWORK, INFO )
*
*              Copy real matrix RWORK(IRVT) to complex matrix VT
*              Overwrite VT by right singular vectors of A
*              (Cworkspace: need 2*N, prefer N+N*NB)
*              (Rworkspace: need 0)
*
               CALL ZLACP2( 'F', N, N, RWORK( IRVT ), N, VT, LDVT )
               CALL ZUNMBR( 'P', 'R', 'C', N, N, N, A, LDA,
     $                      WORK( ITAUP ), VT, LDVT, WORK( NWORK ),
     $                      LWORK-NWORK+1, IERR )
*
               IF( LWORK.GE.M*N+3*N ) THEN
*
*              Copy real matrix RWORK(IRU) to complex matrix WORK(IU)
*              Overwrite WORK(IU) by left singular vectors of A, copying
*              to A
*              (Cworkspace: need M*N+2*N, prefer M*N+N+N*NB)
*              (Rworkspace: need 0)
*
                  CALL ZLASET( 'F', M, N, CZERO, CZERO, WORK( IU ),
     $                         LDWRKU )
                  CALL ZLACP2( 'F', N, N, RWORK( IRU ), N, WORK( IU ),
     $                         LDWRKU )
                  CALL ZUNMBR( 'Q', 'L', 'N', M, N, N, A, LDA,
     $                         WORK( ITAUQ ), WORK( IU ), LDWRKU,
     $                         WORK( NWORK ), LWORK-NWORK+1, IERR )
                  CALL ZLACPY( 'F', M, N, WORK( IU ), LDWRKU, A, LDA )
               ELSE
*
*                 Generate Q in A
*                 (Cworkspace: need 2*N, prefer N+N*NB)
*                 (Rworkspace: need 0)
*
                  CALL ZUNGBR( 'Q', M, N, N, A, LDA, WORK( ITAUQ ),
     $                         WORK( NWORK ), LWORK-NWORK+1, IERR )
*
*                 Multiply Q in A by real matrix RWORK(IRU), storing the
*                 result in WORK(IU), copying to A
*                 (CWorkspace: need N*N, prefer M*N)
*                 (Rworkspace: need 3*N*N, prefer N*N+2*M*N)
*
                  NRWORK = IRVT
                  DO 30 I = 1, M, LDWRKU
                     CHUNK = MIN( M-I+1, LDWRKU )
                     CALL ZLACRM( CHUNK, N, A( I, 1 ), LDA,
     $                            RWORK( IRU ), N, WORK( IU ), LDWRKU,
     $                            RWORK( NRWORK ) )
                     CALL ZLACPY( 'F', CHUNK, N, WORK( IU ), LDWRKU,
     $                            A( I, 1 ), LDA )
   30             CONTINUE
               END IF
*
            ELSE IF( WNTQS ) THEN
*
*              Perform bidiagonal SVD, computing left singular vectors
*              of bidiagonal matrix in RWORK(IRU) and computing right
*              singular vectors of bidiagonal matrix in RWORK(IRVT)
*              (CWorkspace: need 0)
*              (RWorkspace: need BDSPAC)
*
               IRU = NRWORK
               IRVT = IRU + N*N
               NRWORK = IRVT + N*N
               CALL DBDSDC( 'U', 'I', N, S, RWORK( IE ), RWORK( IRU ),
     $                      N, RWORK( IRVT ), N, DUM, IDUM,
     $                      RWORK( NRWORK ), IWORK, INFO )
*
*              Copy real matrix RWORK(IRU) to complex matrix U
*              Overwrite U by left singular vectors of A
*              (CWorkspace: need 3*N, prefer 2*N+N*NB)
*              (RWorkspace: 0)
*
               CALL ZLASET( 'F', M, N, CZERO, CZERO, U, LDU )
               CALL ZLACP2( 'F', N, N, RWORK( IRU ), N, U, LDU )
               CALL ZUNMBR( 'Q', 'L', 'N', M, N, N, A, LDA,
     $                      WORK( ITAUQ ), U, LDU, WORK( NWORK ),
     $                      LWORK-NWORK+1, IERR )
*
*              Copy real matrix RWORK(IRVT) to complex matrix VT
*              Overwrite VT by right singular vectors of A
*              (CWorkspace: need 3*N, prefer 2*N+N*NB)
*              (RWorkspace: 0)
*
               CALL ZLACP2( 'F', N, N, RWORK( IRVT ), N, VT, LDVT )
               CALL ZUNMBR( 'P', 'R', 'C', N, N, N, A, LDA,
     $                      WORK( ITAUP ), VT, LDVT, WORK( NWORK ),
     $                      LWORK-NWORK+1, IERR )
            ELSE
*
*              Perform bidiagonal SVD, computing left singular vectors
*              of bidiagonal matrix in RWORK(IRU) and computing right
*              singular vectors of bidiagonal matrix in RWORK(IRVT)
*              (CWorkspace: need 0)
*              (RWorkspace: need BDSPAC)
*
               IRU = NRWORK
               IRVT = IRU + N*N
               NRWORK = IRVT + N*N
               CALL DBDSDC( 'U', 'I', N, S, RWORK( IE ), RWORK( IRU ),
     $                      N, RWORK( IRVT ), N, DUM, IDUM,
     $                      RWORK( NRWORK ), IWORK, INFO )
*
*              Set the right corner of U to identity matrix
*
               CALL ZLASET( 'F', M, M, CZERO, CZERO, U, LDU )
               CALL ZLASET( 'F', M-N, M-N, CZERO, CONE, U( N+1, N+1 ),
     $                      LDU )
*
*              Copy real matrix RWORK(IRU) to complex matrix U
*              Overwrite U by left singular vectors of A
*              (CWorkspace: need 2*N+M, prefer 2*N+M*NB)
*              (RWorkspace: 0)
*
               CALL ZLACP2( 'F', N, N, RWORK( IRU ), N, U, LDU )
               CALL ZUNMBR( 'Q', 'L', 'N', M, M, N, A, LDA,
     $                      WORK( ITAUQ ), U, LDU, WORK( NWORK ),
     $                      LWORK-NWORK+1, IERR )
*
*              Copy real matrix RWORK(IRVT) to complex matrix VT
*              Overwrite VT by right singular vectors of A
*              (CWorkspace: need 3*N, prefer 2*N+N*NB)
*              (RWorkspace: 0)
*
               CALL ZLACP2( 'F', N, N, RWORK( IRVT ), N, VT, LDVT )
               CALL ZUNMBR( 'P', 'R', 'C', N, N, N, A, LDA,
     $                      WORK( ITAUP ), VT, LDVT, WORK( NWORK ),
     $                      LWORK-NWORK+1, IERR )
            END IF
*
         END IF
*
      ELSE
*
*        A has more columns than rows. If A has sufficiently more
*        columns than rows, first reduce using the LQ decomposition
*        (if sufficient workspace available)
*
         IF( N.GE.MNTHR1 ) THEN
*
            IF( WNTQN ) THEN
*
*              Path 1t (N much larger than M, JOBZ='N')
*              No singular vectors to be computed
*
               ITAU = 1
               NWORK = ITAU + M
*
*              Compute A=L*Q
*              (CWorkspace: need 2*M, prefer M+M*NB)
*              (RWorkspace: 0)
*
               CALL ZGELQF( M, N, A, LDA, WORK( ITAU ), WORK( NWORK ),
     $                      LWORK-NWORK+1, IERR )
*
*              Zero out above L
*
               CALL ZLASET( 'U', M-1, M-1, CZERO, CZERO, A( 1, 2 ),
     $                      LDA )
               IE = 1
               ITAUQ = 1
               ITAUP = ITAUQ + M
               NWORK = ITAUP + M
*
*              Bidiagonalize L in A
*              (CWorkspace: need 3*M, prefer 2*M+2*M*NB)
*              (RWorkspace: need M)
*
               CALL ZGEBRD( M, M, A, LDA, S, RWORK( IE ), WORK( ITAUQ ),
     $                      WORK( ITAUP ), WORK( NWORK ), LWORK-NWORK+1,
     $                      IERR )
               NRWORK = IE + M
*
*              Perform bidiagonal SVD, compute singular values only
*              (CWorkspace: 0)
*              (RWorkspace: need BDSPAC)
*
               CALL DBDSDC( 'U', 'N', M, S, RWORK( IE ), DUM, 1, DUM, 1,
     $                      DUM, IDUM, RWORK( NRWORK ), IWORK, INFO )
*
            ELSE IF( WNTQO ) THEN
*
*              Path 2t (N much larger than M, JOBZ='O')
*              M right singular vectors to be overwritten on A and
*              M left singular vectors to be computed in U
*
               IVT = 1
               LDWKVT = M
*
*              WORK(IVT) is M by M
*
               IL = IVT + LDWKVT*M
               IF( LWORK.GE.M*N+M*M+3*M ) THEN
*
*                 WORK(IL) M by N
*
                  LDWRKL = M
                  CHUNK = N
               ELSE
*
*                 WORK(IL) is M by CHUNK
*
                  LDWRKL = M
                  CHUNK = ( LWORK-M*M-3*M ) / M
               END IF
               ITAU = IL + LDWRKL*CHUNK
               NWORK = ITAU + M
*
*              Compute A=L*Q
*              (CWorkspace: need 2*M, prefer M+M*NB)
*              (RWorkspace: 0)
*
               CALL ZGELQF( M, N, A, LDA, WORK( ITAU ), WORK( NWORK ),
     $                      LWORK-NWORK+1, IERR )
*
*              Copy L to WORK(IL), zeroing about above it
*
               CALL ZLACPY( 'L', M, M, A, LDA, WORK( IL ), LDWRKL )
               CALL ZLASET( 'U', M-1, M-1, CZERO, CZERO,
     $                      WORK( IL+LDWRKL ), LDWRKL )
*
*              Generate Q in A
*              (CWorkspace: need M*M+2*M, prefer M*M+M+M*NB)
*              (RWorkspace: 0)
*
               CALL ZUNGLQ( M, N, M, A, LDA, WORK( ITAU ),
     $                      WORK( NWORK ), LWORK-NWORK+1, IERR )
               IE = 1
               ITAUQ = ITAU
               ITAUP = ITAUQ + M
               NWORK = ITAUP + M
*
*              Bidiagonalize L in WORK(IL)
*              (CWorkspace: need M*M+3*M, prefer M*M+2*M+2*M*NB)
*              (RWorkspace: need M)
*
               CALL ZGEBRD( M, M, WORK( IL ), LDWRKL, S, RWORK( IE ),
     $                      WORK( ITAUQ ), WORK( ITAUP ), WORK( NWORK ),
     $                      LWORK-NWORK+1, IERR )
*
*              Perform bidiagonal SVD, computing left singular vectors
*              of bidiagonal matrix in RWORK(IRU) and computing right
*              singular vectors of bidiagonal matrix in RWORK(IRVT)
*              (CWorkspace: need 0)
*              (RWorkspace: need BDSPAC)
*
               IRU = IE + M
               IRVT = IRU + M*M
               NRWORK = IRVT + M*M
               CALL DBDSDC( 'U', 'I', M, S, RWORK( IE ), RWORK( IRU ),
     $                      M, RWORK( IRVT ), M, DUM, IDUM,
     $                      RWORK( NRWORK ), IWORK, INFO )
*
*              Copy real matrix RWORK(IRU) to complex matrix WORK(IU)
*              Overwrite WORK(IU) by the left singular vectors of L
*              (CWorkspace: need N*N+3*N, prefer M*N+2*N+N*NB)
*              (RWorkspace: 0)
*
               CALL ZLACP2( 'F', M, M, RWORK( IRU ), M, U, LDU )
               CALL ZUNMBR( 'Q', 'L', 'N', M, M, M, WORK( IL ), LDWRKL,
     $                      WORK( ITAUQ ), U, LDU, WORK( NWORK ),
     $                      LWORK-NWORK+1, IERR )
*
*              Copy real matrix RWORK(IRVT) to complex matrix WORK(IVT)
*              Overwrite WORK(IVT) by the right singular vectors of L
*              (CWorkspace: need N*N+3*N, prefer M*N+2*N+N*NB)
*              (RWorkspace: 0)
*
               CALL ZLACP2( 'F', M, M, RWORK( IRVT ), M, WORK( IVT ),
     $                      LDWKVT )
               CALL ZUNMBR( 'P', 'R', 'C', M, M, M, WORK( IL ), LDWRKL,
     $                      WORK( ITAUP ), WORK( IVT ), LDWKVT,
     $                      WORK( NWORK ), LWORK-NWORK+1, IERR )
*
*              Multiply right singular vectors of L in WORK(IL) by Q
*              in A, storing result in WORK(IL) and copying to A
*              (CWorkspace: need 2*M*M, prefer M*M+M*N))
*              (RWorkspace: 0)
*
               DO 40 I = 1, N, CHUNK
                  BLK = MIN( N-I+1, CHUNK )
                  CALL ZGEMM( 'N', 'N', M, BLK, M, CONE, WORK( IVT ), M,
     $                        A( 1, I ), LDA, CZERO, WORK( IL ),
     $                        LDWRKL )
                  CALL ZLACPY( 'F', M, BLK, WORK( IL ), LDWRKL,
     $                         A( 1, I ), LDA )
   40          CONTINUE
*
            ELSE IF( WNTQS ) THEN
*
*             Path 3t (N much larger than M, JOBZ='S')
*             M right singular vectors to be computed in VT and
*             M left singular vectors to be computed in U
*
               IL = 1
*
*              WORK(IL) is M by M
*
               LDWRKL = M
               ITAU = IL + LDWRKL*M
               NWORK = ITAU + M
*
*              Compute A=L*Q
*              (CWorkspace: need 2*M, prefer M+M*NB)
*              (RWorkspace: 0)
*
               CALL ZGELQF( M, N, A, LDA, WORK( ITAU ), WORK( NWORK ),
     $                      LWORK-NWORK+1, IERR )
*
*              Copy L to WORK(IL), zeroing out above it
*
               CALL ZLACPY( 'L', M, M, A, LDA, WORK( IL ), LDWRKL )
               CALL ZLASET( 'U', M-1, M-1, CZERO, CZERO,
     $                      WORK( IL+LDWRKL ), LDWRKL )
*
*              Generate Q in A
*              (CWorkspace: need M*M+2*M, prefer M*M+M+M*NB)
*              (RWorkspace: 0)
*
               CALL ZUNGLQ( M, N, M, A, LDA, WORK( ITAU ),
     $                      WORK( NWORK ), LWORK-NWORK+1, IERR )
               IE = 1
               ITAUQ = ITAU
               ITAUP = ITAUQ + M
               NWORK = ITAUP + M
*
*              Bidiagonalize L in WORK(IL)
*              (CWorkspace: need M*M+3*M, prefer M*M+2*M+2*M*NB)
*              (RWorkspace: need M)
*
               CALL ZGEBRD( M, M, WORK( IL ), LDWRKL, S, RWORK( IE ),
     $                      WORK( ITAUQ ), WORK( ITAUP ), WORK( NWORK ),
     $                      LWORK-NWORK+1, IERR )
*
*              Perform bidiagonal SVD, computing left singular vectors
*              of bidiagonal matrix in RWORK(IRU) and computing right
*              singular vectors of bidiagonal matrix in RWORK(IRVT)
*              (CWorkspace: need 0)
*              (RWorkspace: need BDSPAC)
*
               IRU = IE + M
               IRVT = IRU + M*M
               NRWORK = IRVT + M*M
               CALL DBDSDC( 'U', 'I', M, S, RWORK( IE ), RWORK( IRU ),
     $                      M, RWORK( IRVT ), M, DUM, IDUM,
     $                      RWORK( NRWORK ), IWORK, INFO )
*
*              Copy real matrix RWORK(IRU) to complex matrix U
*              Overwrite U by left singular vectors of L
*              (CWorkspace: need M*M+3*M, prefer M*M+2*M+M*NB)
*              (RWorkspace: 0)
*
               CALL ZLACP2( 'F', M, M, RWORK( IRU ), M, U, LDU )
               CALL ZUNMBR( 'Q', 'L', 'N', M, M, M, WORK( IL ), LDWRKL,
     $                      WORK( ITAUQ ), U, LDU, WORK( NWORK ),
     $                      LWORK-NWORK+1, IERR )
*
*              Copy real matrix RWORK(IRVT) to complex matrix VT
*              Overwrite VT by left singular vectors of L
*              (CWorkspace: need M*M+3*M, prefer M*M+2*M+M*NB)
*              (RWorkspace: 0)
*
               CALL ZLACP2( 'F', M, M, RWORK( IRVT ), M, VT, LDVT )
               CALL ZUNMBR( 'P', 'R', 'C', M, M, M, WORK( IL ), LDWRKL,
     $                      WORK( ITAUP ), VT, LDVT, WORK( NWORK ),
     $                      LWORK-NWORK+1, IERR )
*
*              Copy VT to WORK(IL), multiply right singular vectors of L
*              in WORK(IL) by Q in A, storing result in VT
*              (CWorkspace: need M*M)
*              (RWorkspace: 0)
*
               CALL ZLACPY( 'F', M, M, VT, LDVT, WORK( IL ), LDWRKL )
               CALL ZGEMM( 'N', 'N', M, N, M, CONE, WORK( IL ), LDWRKL,
     $                     A, LDA, CZERO, VT, LDVT )
*
            ELSE IF( WNTQA ) THEN
*
*              Path 9t (N much larger than M, JOBZ='A')
*              N right singular vectors to be computed in VT and
*              M left singular vectors to be computed in U
*
               IVT = 1
*
*              WORK(IVT) is M by M
*
               LDWKVT = M
               ITAU = IVT + LDWKVT*M
               NWORK = ITAU + M
*
*              Compute A=L*Q, copying result to VT
*              (CWorkspace: need 2*M, prefer M+M*NB)
*              (RWorkspace: 0)
*
               CALL ZGELQF( M, N, A, LDA, WORK( ITAU ), WORK( NWORK ),
     $                      LWORK-NWORK+1, IERR )
               CALL ZLACPY( 'U', M, N, A, LDA, VT, LDVT )
*
*              Generate Q in VT
*              (CWorkspace: need M+N, prefer M+N*NB)
*              (RWorkspace: 0)
*
               CALL ZUNGLQ( N, N, M, VT, LDVT, WORK( ITAU ),
     $                      WORK( NWORK ), LWORK-NWORK+1, IERR )
*
*              Produce L in A, zeroing out above it
*
               CALL ZLASET( 'U', M-1, M-1, CZERO, CZERO, A( 1, 2 ),
     $                      LDA )
               IE = 1
               ITAUQ = ITAU
               ITAUP = ITAUQ + M
               NWORK = ITAUP + M
*
*              Bidiagonalize L in A
*              (CWorkspace: need M*M+3*M, prefer M*M+2*M+2*M*NB)
*              (RWorkspace: need M)
*
               CALL ZGEBRD( M, M, A, LDA, S, RWORK( IE ), WORK( ITAUQ ),
     $                      WORK( ITAUP ), WORK( NWORK ), LWORK-NWORK+1,
     $                      IERR )
*
*              Perform bidiagonal SVD, computing left singular vectors
*              of bidiagonal matrix in RWORK(IRU) and computing right
*              singular vectors of bidiagonal matrix in RWORK(IRVT)
*              (CWorkspace: need 0)
*              (RWorkspace: need BDSPAC)
*
               IRU = IE + M
               IRVT = IRU + M*M
               NRWORK = IRVT + M*M
               CALL DBDSDC( 'U', 'I', M, S, RWORK( IE ), RWORK( IRU ),
     $                      M, RWORK( IRVT ), M, DUM, IDUM,
     $                      RWORK( NRWORK ), IWORK, INFO )
*
*              Copy real matrix RWORK(IRU) to complex matrix U
*              Overwrite U by left singular vectors of L
*              (CWorkspace: need 3*M, prefer 2*M+M*NB)
*              (RWorkspace: 0)
*
               CALL ZLACP2( 'F', M, M, RWORK( IRU ), M, U, LDU )
               CALL ZUNMBR( 'Q', 'L', 'N', M, M, M, A, LDA,
     $                      WORK( ITAUQ ), U, LDU, WORK( NWORK ),
     $                      LWORK-NWORK+1, IERR )
*
*              Copy real matrix RWORK(IRVT) to complex matrix WORK(IVT)
*              Overwrite WORK(IVT) by right singular vectors of L
*              (CWorkspace: need M*M+3*M, prefer M*M+2*M+M*NB)
*              (RWorkspace: 0)
*
               CALL ZLACP2( 'F', M, M, RWORK( IRVT ), M, WORK( IVT ),
     $                      LDWKVT )
               CALL ZUNMBR( 'P', 'R', 'C', M, M, M, A, LDA,
     $                      WORK( ITAUP ), WORK( IVT ), LDWKVT,
     $                      WORK( NWORK ), LWORK-NWORK+1, IERR )
*
*              Multiply right singular vectors of L in WORK(IVT) by
*              Q in VT, storing result in A
*              (CWorkspace: need M*M)
*              (RWorkspace: 0)
*
               CALL ZGEMM( 'N', 'N', M, N, M, CONE, WORK( IVT ), LDWKVT,
     $                     VT, LDVT, CZERO, A, LDA )
*
*              Copy right singular vectors of A from A to VT
*
               CALL ZLACPY( 'F', M, N, A, LDA, VT, LDVT )
*
            END IF
*
         ELSE IF( N.GE.MNTHR2 ) THEN
*
*           MNTHR2 <= N < MNTHR1
*
*           Path 5t (N much larger than M, but not as much as MNTHR1)
*           Reduce to bidiagonal form without QR decomposition, use
*           ZUNGBR and matrix multiplication to compute singular vectors
*
*
            IE = 1
            NRWORK = IE + M
            ITAUQ = 1
            ITAUP = ITAUQ + M
            NWORK = ITAUP + M
*
*           Bidiagonalize A
*           (CWorkspace: need 2*M+N, prefer 2*M+(M+N)*NB)
*           (RWorkspace: M)
*
            CALL ZGEBRD( M, N, A, LDA, S, RWORK( IE ), WORK( ITAUQ ),
     $                   WORK( ITAUP ), WORK( NWORK ), LWORK-NWORK+1,
     $                   IERR )
*
            IF( WNTQN ) THEN
*
*              Compute singular values only
*              (Cworkspace: 0)
*              (Rworkspace: need BDSPAC)
*
               CALL DBDSDC( 'L', 'N', M, S, RWORK( IE ), DUM, 1, DUM, 1,
     $                      DUM, IDUM, RWORK( NRWORK ), IWORK, INFO )
            ELSE IF( WNTQO ) THEN
               IRVT = NRWORK
               IRU = IRVT + M*M
               NRWORK = IRU + M*M
               IVT = NWORK
*
*              Copy A to U, generate Q
*              (Cworkspace: need 2*M, prefer M+M*NB)
*              (Rworkspace: 0)
*
               CALL ZLACPY( 'L', M, M, A, LDA, U, LDU )
               CALL ZUNGBR( 'Q', M, M, N, U, LDU, WORK( ITAUQ ),
     $                      WORK( NWORK ), LWORK-NWORK+1, IERR )
*
*              Generate P**H in A
*              (Cworkspace: need 2*M, prefer M+M*NB)
*              (Rworkspace: 0)
*
               CALL ZUNGBR( 'P', M, N, M, A, LDA, WORK( ITAUP ),
     $                      WORK( NWORK ), LWORK-NWORK+1, IERR )
*
               LDWKVT = M
               IF( LWORK.GE.M*N+3*M ) THEN
*
*                 WORK( IVT ) is M by N
*
                  NWORK = IVT + LDWKVT*N
                  CHUNK = N
               ELSE
*
*                 WORK( IVT ) is M by CHUNK
*
                  CHUNK = ( LWORK-3*M ) / M
                  NWORK = IVT + LDWKVT*CHUNK
               END IF
*
*              Perform bidiagonal SVD, computing left singular vectors
*              of bidiagonal matrix in RWORK(IRU) and computing right
*              singular vectors of bidiagonal matrix in RWORK(IRVT)
*              (CWorkspace: need 0)
*              (RWorkspace: need BDSPAC)
*
               CALL DBDSDC( 'L', 'I', M, S, RWORK( IE ), RWORK( IRU ),
     $                      M, RWORK( IRVT ), M, DUM, IDUM,
     $                      RWORK( NRWORK ), IWORK, INFO )
*
*              Multiply Q in U by real matrix RWORK(IRVT)
*              storing the result in WORK(IVT), copying to U
*              (Cworkspace: need 0)
*              (Rworkspace: need 2*M*M)
*
               CALL ZLACRM( M, M, U, LDU, RWORK( IRU ), M, WORK( IVT ),
     $                      LDWKVT, RWORK( NRWORK ) )
               CALL ZLACPY( 'F', M, M, WORK( IVT ), LDWKVT, U, LDU )
*
*              Multiply RWORK(IRVT) by P**H in A, storing the
*              result in WORK(IVT), copying to A
*              (CWorkspace: need M*M, prefer M*N)
*              (Rworkspace: need 2*M*M, prefer 2*M*N)
*
               NRWORK = IRU
               DO 50 I = 1, N, CHUNK
                  BLK = MIN( N-I+1, CHUNK )
                  CALL ZLARCM( M, BLK, RWORK( IRVT ), M, A( 1, I ), LDA,
     $                         WORK( IVT ), LDWKVT, RWORK( NRWORK ) )
                  CALL ZLACPY( 'F', M, BLK, WORK( IVT ), LDWKVT,
     $                         A( 1, I ), LDA )
   50          CONTINUE
            ELSE IF( WNTQS ) THEN
*
*              Copy A to U, generate Q
*              (Cworkspace: need 2*M, prefer M+M*NB)
*              (Rworkspace: 0)
*
               CALL ZLACPY( 'L', M, M, A, LDA, U, LDU )
               CALL ZUNGBR( 'Q', M, M, N, U, LDU, WORK( ITAUQ ),
     $                      WORK( NWORK ), LWORK-NWORK+1, IERR )
*
*              Copy A to VT, generate P**H
*              (Cworkspace: need 2*M, prefer M+M*NB)
*              (Rworkspace: 0)
*
               CALL ZLACPY( 'U', M, N, A, LDA, VT, LDVT )
               CALL ZUNGBR( 'P', M, N, M, VT, LDVT, WORK( ITAUP ),
     $                      WORK( NWORK ), LWORK-NWORK+1, IERR )
*
*              Perform bidiagonal SVD, computing left singular vectors
*              of bidiagonal matrix in RWORK(IRU) and computing right
*              singular vectors of bidiagonal matrix in RWORK(IRVT)
*              (CWorkspace: need 0)
*              (RWorkspace: need BDSPAC)
*
               IRVT = NRWORK
               IRU = IRVT + M*M
               NRWORK = IRU + M*M
               CALL DBDSDC( 'L', 'I', M, S, RWORK( IE ), RWORK( IRU ),
     $                      M, RWORK( IRVT ), M, DUM, IDUM,
     $                      RWORK( NRWORK ), IWORK, INFO )
*
*              Multiply Q in U by real matrix RWORK(IRU), storing the
*              result in A, copying to U
*              (CWorkspace: need 0)
*              (Rworkspace: need 3*M*M)
*
               CALL ZLACRM( M, M, U, LDU, RWORK( IRU ), M, A, LDA,
     $                      RWORK( NRWORK ) )
               CALL ZLACPY( 'F', M, M, A, LDA, U, LDU )
*
*              Multiply real matrix RWORK(IRVT) by P**H in VT,
*              storing the result in A, copying to VT
*              (Cworkspace: need 0)
*              (Rworkspace: need M*M+2*M*N)
*
               NRWORK = IRU
               CALL ZLARCM( M, N, RWORK( IRVT ), M, VT, LDVT, A, LDA,
     $                      RWORK( NRWORK ) )
               CALL ZLACPY( 'F', M, N, A, LDA, VT, LDVT )
            ELSE
*
*              Copy A to U, generate Q
*              (Cworkspace: need 2*M, prefer M+M*NB)
*              (Rworkspace: 0)
*
               CALL ZLACPY( 'L', M, M, A, LDA, U, LDU )
               CALL ZUNGBR( 'Q', M, M, N, U, LDU, WORK( ITAUQ ),
     $                      WORK( NWORK ), LWORK-NWORK+1, IERR )
*
*              Copy A to VT, generate P**H
*              (Cworkspace: need 2*M, prefer M+M*NB)
*              (Rworkspace: 0)
*
               CALL ZLACPY( 'U', M, N, A, LDA, VT, LDVT )
               CALL ZUNGBR( 'P', N, N, M, VT, LDVT, WORK( ITAUP ),
     $                      WORK( NWORK ), LWORK-NWORK+1, IERR )
*
*              Perform bidiagonal SVD, computing left singular vectors
*              of bidiagonal matrix in RWORK(IRU) and computing right
*              singular vectors of bidiagonal matrix in RWORK(IRVT)
*              (CWorkspace: need 0)
*              (RWorkspace: need BDSPAC)
*
               IRVT = NRWORK
               IRU = IRVT + M*M
               NRWORK = IRU + M*M
               CALL DBDSDC( 'L', 'I', M, S, RWORK( IE ), RWORK( IRU ),
     $                      M, RWORK( IRVT ), M, DUM, IDUM,
     $                      RWORK( NRWORK ), IWORK, INFO )
*
*              Multiply Q in U by real matrix RWORK(IRU), storing the
*              result in A, copying to U
*              (CWorkspace: need 0)
*              (Rworkspace: need 3*M*M)
*
               CALL ZLACRM( M, M, U, LDU, RWORK( IRU ), M, A, LDA,
     $                      RWORK( NRWORK ) )
               CALL ZLACPY( 'F', M, M, A, LDA, U, LDU )
*
*              Multiply real matrix RWORK(IRVT) by P**H in VT,
*              storing the result in A, copying to VT
*              (Cworkspace: need 0)
*              (Rworkspace: need M*M+2*M*N)
*
               CALL ZLARCM( M, N, RWORK( IRVT ), M, VT, LDVT, A, LDA,
     $                      RWORK( NRWORK ) )
               CALL ZLACPY( 'F', M, N, A, LDA, VT, LDVT )
            END IF
*
         ELSE
*
*           N .LT. MNTHR2
*
*           Path 6t (N greater than M, but not much larger)
*           Reduce to bidiagonal form without LQ decomposition
*           Use ZUNMBR to compute singular vectors
*
            IE = 1
            NRWORK = IE + M
            ITAUQ = 1
            ITAUP = ITAUQ + M
            NWORK = ITAUP + M
*
*           Bidiagonalize A
*           (CWorkspace: need 2*M+N, prefer 2*M+(M+N)*NB)
*           (RWorkspace: M)
*
            CALL ZGEBRD( M, N, A, LDA, S, RWORK( IE ), WORK( ITAUQ ),
     $                   WORK( ITAUP ), WORK( NWORK ), LWORK-NWORK+1,
     $                   IERR )
            IF( WNTQN ) THEN
*
*              Compute singular values only
*              (Cworkspace: 0)
*              (Rworkspace: need BDSPAC)
*
               CALL DBDSDC( 'L', 'N', M, S, RWORK( IE ), DUM, 1, DUM, 1,
     $                      DUM, IDUM, RWORK( NRWORK ), IWORK, INFO )
            ELSE IF( WNTQO ) THEN
               LDWKVT = M
               IVT = NWORK
               IF( LWORK.GE.M*N+3*M ) THEN
*
*                 WORK( IVT ) is M by N
*
                  CALL ZLASET( 'F', M, N, CZERO, CZERO, WORK( IVT ),
     $                         LDWKVT )
                  NWORK = IVT + LDWKVT*N
               ELSE
*
*                 WORK( IVT ) is M by CHUNK
*
                  CHUNK = ( LWORK-3*M ) / M
                  NWORK = IVT + LDWKVT*CHUNK
               END IF
*
*              Perform bidiagonal SVD, computing left singular vectors
*              of bidiagonal matrix in RWORK(IRU) and computing right
*              singular vectors of bidiagonal matrix in RWORK(IRVT)
*              (CWorkspace: need 0)
*              (RWorkspace: need BDSPAC)
*
               IRVT = NRWORK
               IRU = IRVT + M*M
               NRWORK = IRU + M*M
               CALL DBDSDC( 'L', 'I', M, S, RWORK( IE ), RWORK( IRU ),
     $                      M, RWORK( IRVT ), M, DUM, IDUM,
     $                      RWORK( NRWORK ), IWORK, INFO )
*
*              Copy real matrix RWORK(IRU) to complex matrix U
*              Overwrite U by left singular vectors of A
*              (Cworkspace: need 2*M, prefer M+M*NB)
*              (Rworkspace: need 0)
*
               CALL ZLACP2( 'F', M, M, RWORK( IRU ), M, U, LDU )
               CALL ZUNMBR( 'Q', 'L', 'N', M, M, N, A, LDA,
     $                      WORK( ITAUQ ), U, LDU, WORK( NWORK ),
     $                      LWORK-NWORK+1, IERR )
*
               IF( LWORK.GE.M*N+3*M ) THEN
*
*              Copy real matrix RWORK(IRVT) to complex matrix WORK(IVT)
*              Overwrite WORK(IVT) by right singular vectors of A,
*              copying to A
*              (Cworkspace: need M*N+2*M, prefer M*N+M+M*NB)
*              (Rworkspace: need 0)
*
                  CALL ZLACP2( 'F', M, M, RWORK( IRVT ), M, WORK( IVT ),
     $                         LDWKVT )
                  CALL ZUNMBR( 'P', 'R', 'C', M, N, M, A, LDA,
     $                         WORK( ITAUP ), WORK( IVT ), LDWKVT,
     $                         WORK( NWORK ), LWORK-NWORK+1, IERR )
                  CALL ZLACPY( 'F', M, N, WORK( IVT ), LDWKVT, A, LDA )
               ELSE
*
*                 Generate P**H in A
*                 (Cworkspace: need 2*M, prefer M+M*NB)
*                 (Rworkspace: need 0)
*
                  CALL ZUNGBR( 'P', M, N, M, A, LDA, WORK( ITAUP ),
     $                         WORK( NWORK ), LWORK-NWORK+1, IERR )
*
*                 Multiply Q in A by real matrix RWORK(IRU), storing the
*                 result in WORK(IU), copying to A
*                 (CWorkspace: need M*M, prefer M*N)
*                 (Rworkspace: need 3*M*M, prefer M*M+2*M*N)
*
                  NRWORK = IRU
                  DO 60 I = 1, N, CHUNK
                     BLK = MIN( N-I+1, CHUNK )
                     CALL ZLARCM( M, BLK, RWORK( IRVT ), M, A( 1, I ),
     $                            LDA, WORK( IVT ), LDWKVT,
     $                            RWORK( NRWORK ) )
                     CALL ZLACPY( 'F', M, BLK, WORK( IVT ), LDWKVT,
     $                            A( 1, I ), LDA )
   60             CONTINUE
               END IF
            ELSE IF( WNTQS ) THEN
*
*              Perform bidiagonal SVD, computing left singular vectors
*              of bidiagonal matrix in RWORK(IRU) and computing right
*              singular vectors of bidiagonal matrix in RWORK(IRVT)
*              (CWorkspace: need 0)
*              (RWorkspace: need BDSPAC)
*
               IRVT = NRWORK
               IRU = IRVT + M*M
               NRWORK = IRU + M*M
               CALL DBDSDC( 'L', 'I', M, S, RWORK( IE ), RWORK( IRU ),
     $                      M, RWORK( IRVT ), M, DUM, IDUM,
     $                      RWORK( NRWORK ), IWORK, INFO )
*
*              Copy real matrix RWORK(IRU) to complex matrix U
*              Overwrite U by left singular vectors of A
*              (CWorkspace: need 3*M, prefer 2*M+M*NB)
*              (RWorkspace: M*M)
*
               CALL ZLACP2( 'F', M, M, RWORK( IRU ), M, U, LDU )
               CALL ZUNMBR( 'Q', 'L', 'N', M, M, N, A, LDA,
     $                      WORK( ITAUQ ), U, LDU, WORK( NWORK ),
     $                      LWORK-NWORK+1, IERR )
*
*              Copy real matrix RWORK(IRVT) to complex matrix VT
*              Overwrite VT by right singular vectors of A
*              (CWorkspace: need 3*M, prefer 2*M+M*NB)
*              (RWorkspace: M*M)
*
               CALL ZLASET( 'F', M, N, CZERO, CZERO, VT, LDVT )
               CALL ZLACP2( 'F', M, M, RWORK( IRVT ), M, VT, LDVT )
               CALL ZUNMBR( 'P', 'R', 'C', M, N, M, A, LDA,
     $                      WORK( ITAUP ), VT, LDVT, WORK( NWORK ),
     $                      LWORK-NWORK+1, IERR )
            ELSE
*
*              Perform bidiagonal SVD, computing left singular vectors
*              of bidiagonal matrix in RWORK(IRU) and computing right
*              singular vectors of bidiagonal matrix in RWORK(IRVT)
*              (CWorkspace: need 0)
*              (RWorkspace: need BDSPAC)
*
               IRVT = NRWORK
               IRU = IRVT + M*M
               NRWORK = IRU + M*M
*
               CALL DBDSDC( 'L', 'I', M, S, RWORK( IE ), RWORK( IRU ),
     $                      M, RWORK( IRVT ), M, DUM, IDUM,
     $                      RWORK( NRWORK ), IWORK, INFO )
*
*              Copy real matrix RWORK(IRU) to complex matrix U
*              Overwrite U by left singular vectors of A
*              (CWorkspace: need 3*M, prefer 2*M+M*NB)
*              (RWorkspace: M*M)
*
               CALL ZLACP2( 'F', M, M, RWORK( IRU ), M, U, LDU )
               CALL ZUNMBR( 'Q', 'L', 'N', M, M, N, A, LDA,
     $                      WORK( ITAUQ ), U, LDU, WORK( NWORK ),
     $                      LWORK-NWORK+1, IERR )
*
*              Set the right corner of VT to identity matrix
*
               CALL ZLASET( 'F', N-M, N-M, CZERO, CONE, VT( M+1, M+1 ),
     $                      LDVT )
*
*              Copy real matrix RWORK(IRVT) to complex matrix VT
*              Overwrite VT by right singular vectors of A
*              (CWorkspace: need 2*M+N, prefer 2*M+N*NB)
*              (RWorkspace: M*M)
*
               CALL ZLASET( 'F', N, N, CZERO, CZERO, VT, LDVT )
               CALL ZLACP2( 'F', M, M, RWORK( IRVT ), M, VT, LDVT )
               CALL ZUNMBR( 'P', 'R', 'C', N, N, M, A, LDA,
     $                      WORK( ITAUP ), VT, LDVT, WORK( NWORK ),
     $                      LWORK-NWORK+1, IERR )
            END IF
*
         END IF
*
      END IF
*
*     Undo scaling if necessary
*
      IF( ISCL.EQ.1 ) THEN
         IF( ANRM.GT.BIGNUM )
     $      CALL DLASCL( 'G', 0, 0, BIGNUM, ANRM, MINMN, 1, S, MINMN,
     $                   IERR )
         IF( ANRM.LT.SMLNUM )
     $      CALL DLASCL( 'G', 0, 0, SMLNUM, ANRM, MINMN, 1, S, MINMN,
     $                   IERR )
      END IF
*
*     Return optimal workspace in WORK(1)
*
      WORK( 1 ) = MAXWRK
*
      RETURN
*
*     End of ZGESDD
*
      END

C
C $Id: trn32t.f,v 1.6 2008-07-27 00:17:34 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE TRN32T (U,V,W,XT,YT,ZT,IENT)
C
C THIS ROUTINE IMPLEMENTS THE 3-SPACE TO 2-SPACE TRANSFOR-
C MATION BY KUBER, SZABO AND GIULIERI, THE PERSPECTIVE
C REPRESENTATION OF FUNCTIONS OF TWO VARIABLES. J. ACM 15,
C 2, 193-204,1968.
C TRN32T ARGUMENTS
C U,V,W    ARE THE 3-SPACE COORDINATES OF THE INTERSECTION
C          OF THE LINE OF SIGHT AND THE IMAGE PLANE.  THIS
C          POINT CAN BE THOUGHT OF AS THE POINT LOOKED AT.
C XT,YT,ZT ARE THE 3-SPACE COORDINATES OF THE EYE POSITION.
C
C TRN32 ARGUMENTS
C U,V,W    ARE THE 3-SPACE COORDINATES OF A POINT TO BE
C          TRANSFORMED.
C XT,YT    THE RESULTS OF THE 3-SPACE TO 2-SPACE TRANSFOR-
C          MATION.  WHEN ISCALE=0, XT AND YT ANR IN THE SAME
C          UNITS AS U,V, AND W.  WHEN ISCALE'0, XT AND YT
C          ARE IN PLOTTER COORDINATES.
C ZT       NOT USED.
C
C
      SAVE
C
      COMMON /PWRZ1T/ UUMIN      ,UUMAX      ,VVMIN      ,VVMAX      ,
     1                WWMIN      ,WWMAX      ,DELCRT     ,EYEU       ,
     2                EYEV       ,EYEW
      COMMON /SET31/  ISCALE     ,XMIN       ,XMAX       ,YMIN       ,
     1                YMAX       ,BIGD       ,R0         ,NLX        ,
     2                NBY        ,NRX        ,NTY
C
C DECIDE IF SET OR TRANSLATE CALL
C
      IF (IENT .NE. 1) GO TO  50
C
C STORE THE PARAMETERS OF THE SET CALL
C FOR USE WITH THE TRANSLATION CALL
C
      AU = U
      AV = V
      AW = W
      EU = XT
      EV = YT
      EW = ZT
C
C
C
C
C
      DU = AU-EU
      DV = AV-EV
      DW = AW-EW
      D = SQRT(DU*DU+DV*DV+DW*DW)
      COSAL = DU/D
      COSBE = DV/D
      COSGA = DW/D
      AL = ACOS(COSAL)
      BE = ACOS(COSBE)
      GA = ACOS(COSGA)
      SINGA = SIN(GA)
C
C THE 3-SPACE POINT LOOKED AT IS TRANSFORMED INTO (0,0) OF
C THE 2-SPACE.  THE 3-SPACE W AXIS IS TRANSFORMED INTO THE
C 2-SPACE Y AXIS.  IF THE LINE OF SIGHT IS CLOSE TO PARALLEL
C TO THE 3-SPACE W AXIS, THE 3-SPACE V AXIS IS CHOSEN (IN-
C STEAD OF THE 3-SPACE W AXIS) TO BE TRANSFORMED INTO THE
C 2-SPACE Y AXIS.
C
      JDONE = 2
      IF (ISCALE)  10, 30, 10
   10 X0 = XMIN
      Y0 = YMIN
      X1 = NLX
      Y1 = NBY
      X2 = NRX-NLX
      Y2 = NTY-NBY
      X3 = X2/(XMAX-XMIN)
      Y3 = Y2/(YMAX-YMIN)
      X4 = NRX
      Y4 = NTY
      FACT = 1.
      IF (BIGD .LE. 0.) GO TO  20
      X0 = -BIGD
      Y0 = -BIGD
      X3 = X2/(2.*BIGD)
      Y3 = Y2/(2.*BIGD)
      FACT = R0/D
   20 DELCRT = X2
      JDONE = 1
   30 IF (SINGA .LT. 0.0001) GO TO  40
      R = 1./SINGA
      JUMP = 2
      RETURN
   40 SINBE = SIN(BE)
      R = 1./SINBE
      JUMP = 1
      RETURN
C
C********************  ENTRY TRN32  ************************
C     ENTRY TRN32 (U,V,W,XT,YT,ZT)
C
   50 UU = U
      VV = V
      WW = W
      Q = D/((UU-EU)*COSAL+(VV-EV)*COSBE+(WW-EW)*COSGA)
      GO TO (60, 70), JUMP
   60 UU = ((EW+Q*(WW-EW)-AW)*COSAL-(EU+Q*(UU-EU)-AU)*COSGA)*R
      VV = (EV+Q*(VV-EV)-AV)*R
      GO TO (80, 90), JDONE
   70 UU = ((EU+Q*(UU-EU)-AU)*COSBE-(EV+Q*(VV-EV)-AV)*COSAL)*R
      VV = (EW+Q*(WW-EW)-AW)*R
      GO TO (80, 90), JDONE
   80 XT = X1+X3*(FACT*UU-X0)
      YT = Y1+Y3*(FACT*VV-Y0)
      RETURN
   90 XT = UU
      YT = VV
      RETURN
      END

C     
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      FUNCTION SPLFED(NDIM,X,COEF,XMIN,XMAX,NODES,IERROR)
      DOUBLE PRECISION SPLFED
      DOUBLE PRECISION X
      DOUBLE PRECISION COEF
      DOUBLE PRECISION XMIN
      DOUBLE PRECISION XMAX
      DOUBLE PRECISION SPLDED
      DIMENSION X(NDIM),COEF(*),XMIN(NDIM),XMAX(NDIM),NODES(NDIM)
      DIMENSION NDERIV(4)
      SAVE
C
      DATA NDERIV(1),NDERIV(2),NDERIV(3),NDERIV(4)/0,0,0,0/
C
C  The restriction for NDIM to be .LE. 4 can be eliminated by
C  increasing the above dimension and those in SPLDED.
C
      SPLFED = SPLDED(NDIM,X,NDERIV,COEF,XMIN,XMAX,NODES,IERROR)
C
      RETURN
      END

      SUBROUTINE SSTEIN( N, D, E, M, W, IBLOCK, ISPLIT, Z, LDZ, WORK,
     $                   IWORK, IFAIL, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      INTEGER            INFO, LDZ, M, N
*     ..
*     .. Array Arguments ..
      INTEGER            IBLOCK( * ), IFAIL( * ), ISPLIT( * ),
     $                   IWORK( * )
      REAL               D( * ), E( * ), W( * ), WORK( * ), Z( LDZ, * )
*     ..
*
*  Purpose
*  =======
*
*  SSTEIN computes the eigenvectors of a real symmetric tridiagonal
*  matrix T corresponding to specified eigenvalues, using inverse
*  iteration.
*
*  The maximum number of iterations allowed for each eigenvector is
*  specified by an internal parameter MAXITS (currently set to 5).
*
*  Arguments
*  =========
*
*  N       (input) INTEGER
*          The order of the matrix.  N >= 0.
*
*  D       (input) REAL array, dimension (N)
*          The n diagonal elements of the tridiagonal matrix T.
*
*  E       (input) REAL array, dimension (N)
*          The (n-1) subdiagonal elements of the tridiagonal matrix
*          T, in elements 1 to N-1.  E(N) need not be set.
*
*  M       (input) INTEGER
*          The number of eigenvectors to be found.  0 <= M <= N.
*
*  W       (input) REAL array, dimension (N)
*          The first M elements of W contain the eigenvalues for
*          which eigenvectors are to be computed.  The eigenvalues
*          should be grouped by split-off block and ordered from
*          smallest to largest within the block.  ( The output array
*          W from SSTEBZ with ORDER = 'B' is expected here. )
*
*  IBLOCK  (input) INTEGER array, dimension (N)
*          The submatrix indices associated with the corresponding
*          eigenvalues in W; IBLOCK(i)=1 if eigenvalue W(i) belongs to
*          the first submatrix from the top, =2 if W(i) belongs to
*          the second submatrix, etc.  ( The output array IBLOCK
*          from SSTEBZ is expected here. )
*
*  ISPLIT  (input) INTEGER array, dimension (N)
*          The splitting points, at which T breaks up into submatrices.
*          The first submatrix consists of rows/columns 1 to
*          ISPLIT( 1 ), the second of rows/columns ISPLIT( 1 )+1
*          through ISPLIT( 2 ), etc.
*          ( The output array ISPLIT from SSTEBZ is expected here. )
*
*  Z       (output) REAL array, dimension (LDZ, M)
*          The computed eigenvectors.  The eigenvector associated
*          with the eigenvalue W(i) is stored in the i-th column of
*          Z.  Any vector which fails to converge is set to its current
*          iterate after MAXITS iterations.
*
*  LDZ     (input) INTEGER
*          The leading dimension of the array Z.  LDZ >= max(1,N).
*
*  WORK    (workspace) REAL array, dimension (5*N)
*
*  IWORK   (workspace) INTEGER array, dimension (N)
*
*  IFAIL   (output) INTEGER array, dimension (M)
*          On normal exit, all elements of IFAIL are zero.
*          If one or more eigenvectors fail to converge after
*          MAXITS iterations, then their indices are stored in
*          array IFAIL.
*
*  INFO    (output) INTEGER
*          = 0: successful exit.
*          < 0: if INFO = -i, the i-th argument had an illegal value
*          > 0: if INFO = i, then i eigenvectors failed to converge
*               in MAXITS iterations.  Their indices are stored in
*               array IFAIL.
*
*  Internal Parameters
*  ===================
*
*  MAXITS  INTEGER, default = 5
*          The maximum number of iterations performed.
*
*  EXTRA   INTEGER, default = 2
*          The number of iterations performed after norm growth
*          criterion is satisfied, should be at least 1.
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ZERO, ONE, TEN, ODM3, ODM1
      PARAMETER          ( ZERO = 0.0E+0, ONE = 1.0E+0, TEN = 1.0E+1,
     $                   ODM3 = 1.0E-3, ODM1 = 1.0E-1 )
      INTEGER            MAXITS, EXTRA
      PARAMETER          ( MAXITS = 5, EXTRA = 2 )
*     ..
*     .. Local Scalars ..
      INTEGER            B1, BLKSIZ, BN, GPIND, I, IINFO, INDRV1,
     $                   INDRV2, INDRV3, INDRV4, INDRV5, ITS, J, J1,
     $                   JBLK, JMAX, NBLK, NRMCHK
      REAL               CTR, EPS, EPS1, NRM, ONENRM, ORTOL, PERTOL,
     $                   SCL, SEP, STPCRT, TOL, XJ, XJM
*     ..
*     .. Local Arrays ..
      INTEGER            ISEED( 4 )
*     ..
*     .. External Functions ..
      INTEGER            ISAMAX
      REAL               SASUM, SDOT, SLAMCH, SNRM2
      EXTERNAL           ISAMAX, SASUM, SDOT, SLAMCH, SNRM2
*     ..
*     .. External Subroutines ..
      EXTERNAL           SAXPY, SCOPY, SLAGTF, SLAGTS, SLARNV, SSCAL,
     $                   XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, MAX, SQRT
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      DO 10 I = 1, M
         IFAIL( I ) = 0
   10 CONTINUE
*
      IF( N.LT.0 ) THEN
         INFO = -1
      ELSE IF( M.LT.0 .OR. M.GT.N ) THEN
         INFO = -4
      ELSE IF( LDZ.LT.MAX( 1, N ) ) THEN
         INFO = -9
      ELSE
         DO 20 J = 2, M
            IF( IBLOCK( J ).LT.IBLOCK( J-1 ) ) THEN
               INFO = -6
               GO TO 30
            END IF
            IF( IBLOCK( J ).EQ.IBLOCK( J-1 ) .AND. W( J ).LT.W( J-1 ) )
     $           THEN
               INFO = -5
               GO TO 30
            END IF
   20    CONTINUE
   30    CONTINUE
      END IF
*
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'SSTEIN', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 .OR. M.EQ.0 ) THEN
         RETURN
      ELSE IF( N.EQ.1 ) THEN
         Z( 1, 1 ) = ONE
         RETURN
      END IF
*
*     Get machine constants.
*
      EPS = SLAMCH( 'Precision' )
*
*     Initialize seed for random number generator SLARNV.
*
      DO 40 I = 1, 4
         ISEED( I ) = 1
   40 CONTINUE
*
*     Initialize pointers.
*
      INDRV1 = 0
      INDRV2 = INDRV1 + N
      INDRV3 = INDRV2 + N
      INDRV4 = INDRV3 + N
      INDRV5 = INDRV4 + N
*
*     Compute eigenvectors of matrix blocks.
*
      J1 = 1
      DO 160 NBLK = 1, IBLOCK( M )
*
*        Find starting and ending indices of block nblk.
*
         IF( NBLK.EQ.1 ) THEN
            B1 = 1
         ELSE
            B1 = ISPLIT( NBLK-1 ) + 1
         END IF
         BN = ISPLIT( NBLK )
         BLKSIZ = BN - B1 + 1
         IF( BLKSIZ.EQ.1 )
     $      GO TO 60
         GPIND = B1
*
*        Compute reorthogonalization criterion and stopping criterion.
*
         ONENRM = ABS( D( B1 ) ) + ABS( E( B1 ) )
         ONENRM = MAX( ONENRM, ABS( D( BN ) )+ABS( E( BN-1 ) ) )
         DO 50 I = B1 + 1, BN - 1
            ONENRM = MAX( ONENRM, ABS( D( I ) )+ABS( E( I-1 ) )+
     $               ABS( E( I ) ) )
   50    CONTINUE
         ORTOL = ODM3*ONENRM
*
         STPCRT = SQRT( ODM1 / BLKSIZ )
*
*        Loop through eigenvalues of block nblk.
*
   60    CONTINUE
         JBLK = 0
         DO 150 J = J1, M
            IF( IBLOCK( J ).NE.NBLK ) THEN
               J1 = J
               GO TO 160
            END IF
            JBLK = JBLK + 1
            XJ = W( J )
*
*           Skip all the work if the block size is one.
*
            IF( BLKSIZ.EQ.1 ) THEN
               WORK( INDRV1+1 ) = ONE
               GO TO 120
            END IF
*
*           If eigenvalues j and j-1 are too close, add a relatively
*           small perturbation.
*
            IF( JBLK.GT.1 ) THEN
               EPS1 = ABS( EPS*XJ )
               PERTOL = TEN*EPS1
               SEP = XJ - XJM
               IF( SEP.LT.PERTOL )
     $            XJ = XJM + PERTOL
            END IF
*
            ITS = 0
            NRMCHK = 0
*
*           Get random starting vector.
*
            CALL SLARNV( 2, ISEED, BLKSIZ, WORK( INDRV1+1 ) )
*
*           Copy the matrix T so it won't be destroyed in factorization.
*
            CALL SCOPY( BLKSIZ, D( B1 ), 1, WORK( INDRV4+1 ), 1 )
            CALL SCOPY( BLKSIZ-1, E( B1 ), 1, WORK( INDRV2+2 ), 1 )
            CALL SCOPY( BLKSIZ-1, E( B1 ), 1, WORK( INDRV3+1 ), 1 )
*
*           Compute LU factors with partial pivoting  ( PT = LU )
*
            TOL = ZERO
            CALL SLAGTF( BLKSIZ, WORK( INDRV4+1 ), XJ, WORK( INDRV2+2 ),
     $                   WORK( INDRV3+1 ), TOL, WORK( INDRV5+1 ), IWORK,
     $                   IINFO )
*
*           Update iteration count.
*
   70       CONTINUE
            ITS = ITS + 1
            IF( ITS.GT.MAXITS )
     $         GO TO 100
*
*           Normalize and scale the righthand side vector Pb.
*
            SCL = BLKSIZ*ONENRM*MAX( EPS,
     $            ABS( WORK( INDRV4+BLKSIZ ) ) ) /
     $            SASUM( BLKSIZ, WORK( INDRV1+1 ), 1 )
            CALL SSCAL( BLKSIZ, SCL, WORK( INDRV1+1 ), 1 )
*
*           Solve the system LU = Pb.
*
            CALL SLAGTS( -1, BLKSIZ, WORK( INDRV4+1 ), WORK( INDRV2+2 ),
     $                   WORK( INDRV3+1 ), WORK( INDRV5+1 ), IWORK,
     $                   WORK( INDRV1+1 ), TOL, IINFO )
*
*           Reorthogonalize by modified Gram-Schmidt if eigenvalues are
*           close enough.
*
            IF( JBLK.EQ.1 )
     $         GO TO 90
            IF( ABS( XJ-XJM ).GT.ORTOL )
     $         GPIND = J
            IF( GPIND.NE.J ) THEN
               DO 80 I = GPIND, J - 1
                  CTR = -SDOT( BLKSIZ, WORK( INDRV1+1 ), 1, Z( B1, I ),
     $                  1 )
                  CALL SAXPY( BLKSIZ, CTR, Z( B1, I ), 1,
     $                        WORK( INDRV1+1 ), 1 )
   80          CONTINUE
            END IF
*
*           Check the infinity norm of the iterate.
*
   90       CONTINUE
            JMAX = ISAMAX( BLKSIZ, WORK( INDRV1+1 ), 1 )
            NRM = ABS( WORK( INDRV1+JMAX ) )
*
*           Continue for additional iterations after norm reaches
*           stopping criterion.
*
            IF( NRM.LT.STPCRT )
     $         GO TO 70
            NRMCHK = NRMCHK + 1
            IF( NRMCHK.LT.EXTRA+1 )
     $         GO TO 70
*
            GO TO 110
*
*           If stopping criterion was not satisfied, update info and
*           store eigenvector number in array ifail.
*
  100       CONTINUE
            INFO = INFO + 1
            IFAIL( INFO ) = J
*
*           Accept iterate as jth eigenvector.
*
  110       CONTINUE
            SCL = ONE / SNRM2( BLKSIZ, WORK( INDRV1+1 ), 1 )
            JMAX = ISAMAX( BLKSIZ, WORK( INDRV1+1 ), 1 )
            IF( WORK( INDRV1+JMAX ).LT.ZERO )
     $         SCL = -SCL
            CALL SSCAL( BLKSIZ, SCL, WORK( INDRV1+1 ), 1 )
  120       CONTINUE
            DO 130 I = 1, N
               Z( I, J ) = ZERO
  130       CONTINUE
            DO 140 I = 1, BLKSIZ
               Z( B1+I-1, J ) = WORK( INDRV1+I )
  140       CONTINUE
*
*           Save the shift to check eigenvalue spacing at next
*           iteration.
*
            XJM = XJ
*
  150    CONTINUE
  160 CONTINUE
*
      RETURN
*
*     End of SSTEIN
*
      END

C
C	$Id: g01pbl.f,v 1.5 2008-07-27 00:21:05 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      INTEGER FUNCTION G01PBL (NCHARS, NBYTES)
C
C  Return as the value of the function the parameter list length
C  of an element that contains NCHARS characters of string data
C  and NBYTES bytes of other data.
C
C  The length will be either  NCHARS+NBYTES+1 or NCHARS+NBYTES+3,
C  depending upon whether a short form or long form string is
C  called for.
C
      INTEGER  NCHARS, NBYTES, LEN
C
C  For short form.
C
      LEN = 1 + NCHARS + NBYTES
C
C  Short form can handle at most 254 characters in a string.
C
      IF (NCHARS.GT.254)  LEN = LEN + 2
      G01PBL = LEN
C
      RETURN
      END

C
C	$Id: gflcnv.f,v 1.6 2008-07-27 00:21:06 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GFLCNV (FNUM,INUM)
C
C     This subroutine converts the floating-point number in
C     FNUM into two 16-bit integers in the low order bits of
C     INUM.  These two 16-bit quantities are suitable for
C     insertion into the CGM.  The first 16-bit integer is
C     given by the low-order 15 bits resulting from INUM(1)=FUNM.
C     This number is then expressed in 2's complement format.  The
C     second 16-bit integer is the decimal part of FNUM
C     multiplied by 2**16 (65536.)
C
      REAL     FNUM
      INTEGER  INUM(2)
C
      INTEGER  JNUM,JABS
C
C  Find the smallest integer less than or equal to FNUM and store
C  it in JNUM.
C
      JNUM = INT(FNUM)
      IF (FNUM.LT.0. .AND. REAL(JNUM).NE.FNUM) JNUM = JNUM-1
C
C  Find the fractional part.
C
      INUM(2) = 65536.*(FNUM-REAL(JNUM))
C
C  Define 2's complement of whole part.
C
      JABS = ABS(JNUM)
      INUM(1) = IAND(32767,JABS)
      IF (JNUM .LT. 0) THEN
        INUM(1) = (32767-INUM(1))+1
        INUM(1) = IOR(INUM(1),ISHIFT(1,15))
      ENDIF
C
      RETURN
      END

C
C	$Id: gdsg.f,v 1.9 2008-07-27 00:20:57 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GDSG(SGNA)
C
C  DELETE SEGMENT
C
      INTEGER EDSG
      PARAMETER (EDSG=59)
C
      include 'gkscom.h'
C
      INTEGER SGNA
      CHARACTER*80 CSNAME
C
C  This subroutine is here solely as support for the SPPS GFLASn
C  entries.  Full segmentation is not a part of the NCAR GKS
C  package at this time.  The NCAR package is non-standard to the
C  extent that certain segmentation functions are supported, but
C  not all level 1 functions are supported.  This subroutine should
C  be considered a user entry point only by way of the GFLASn
C  calls--it should never be called directly be the user.
C
C  Check if GKS is in the proper state.
C
      CALL GZCKST(7,EDSG,IER)
      IF (IER .NE. 0) RETURN
C
C  Check that the segment name is valid.
C
      IF (SGNA.LT.0 .OR. SGNA.GT.99) THEN
        ERS = 1
        CALL GERHND(120,EDSG,ERF)
        ERS = 0
        RETURN
      ENDIF
C
C  Check if the segment exists.
C
      DO 200 I=1,NUMSEG
        IF (SEGS(I) .EQ. SGNA) GO TO 210
  200 CONTINUE
      ERS = 1
      CALL GERHND(122,EDSG,ERF)
      ERS = 0
      RETURN
  210 CONTINUE
C
C  Check if the segment is open.
C
      IF (SGNA .EQ. CURSEG) THEN
        ERS = 1
        CALL GERHND(125,EDSG,ERF)
        ERS = 0
        RETURN
      ENDIF
C
C  Remove the segment name from the list of segment names in use 
C  and readjust the associated segment description arrays.
C
      IF (NUMSEG .GT. 0) THEN
        DO 201 I=1,NUMSEG
          IF (SEGS(I) .EQ. SGNA) THEN
C
            CSNAME = ' '
            CSNAME = SEGNAM(I)
            IP1 = I+1
            DO 202 J=IP1,NUMSEG
              SEGS(J-1) = SEGS(J)
              SEGNAM(J-1) = SEGNAM(J)
              SEGLEN(J-1) = SEGLEN(J)
              DO 205 IR=1,2
                DO 206 JC=1,3
                  SEGT(J-1,IR,JC) = SEGT(J,IR,JC)
  206           CONTINUE
  205         CONTINUE
  202       CONTINUE
            SEGS(NUMSEG) = 0
            SEGNAM(NUMSEG) = ' '
            SEGLEN(NUMSEG) = 0
            DO 203 IR=1,2
              DO 204 JC=1,3
                SEGT(NUMSEG,IR,JC) = 0.
  204         CONTINUE
  203       CONTINUE
            SEGT(NUMSEG,1,1) = 1.
            SEGT(NUMSEG,2,2) = 1.
            NUMSEG = NUMSEG-1
            GO TO 10
          ENDIF
  201   CONTINUE
      ENDIF
   10 CONTINUE
C
C  Make the interface call.
C
      FCODE = 79
      CALL GZROI(0)
      CONT  = 0
      STRL1 = 80
      STRL2 = 80
      STR = CSNAME
      CALL GZTOWK
      IF (RERR.NE.0) THEN
        ERS = 1
        CALL GERHND(RERR,EDSG,ERF)
        ERS = 0
      ENDIF
C
      RETURN
      END

      SUBROUTINE DGEBD2( M, N, A, LDA, D, E, TAUQ, TAUP, WORK, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     February 29, 1992
*
*     .. Scalar Arguments ..
      INTEGER            INFO, LDA, M, N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), D( * ), E( * ), TAUP( * ),
     $                   TAUQ( * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  DGEBD2 reduces a real general m by n matrix A to upper or lower
*  bidiagonal form B by an orthogonal transformation: Q' * A * P = B.
*
*  If m >= n, B is upper bidiagonal; if m < n, B is lower bidiagonal.
*
*  Arguments
*  =========
*
*  M       (input) INTEGER
*          The number of rows in the matrix A.  M >= 0.
*
*  N       (input) INTEGER
*          The number of columns in the matrix A.  N >= 0.
*
*  A       (input/output) DOUBLE PRECISION array, dimension (LDA,N)
*          On entry, the m by n general matrix to be reduced.
*          On exit,
*          if m >= n, the diagonal and the first superdiagonal are
*            overwritten with the upper bidiagonal matrix B; the
*            elements below the diagonal, with the array TAUQ, represent
*            the orthogonal matrix Q as a product of elementary
*            reflectors, and the elements above the first superdiagonal,
*            with the array TAUP, represent the orthogonal matrix P as
*            a product of elementary reflectors;
*          if m < n, the diagonal and the first subdiagonal are
*            overwritten with the lower bidiagonal matrix B; the
*            elements below the first subdiagonal, with the array TAUQ,
*            represent the orthogonal matrix Q as a product of
*            elementary reflectors, and the elements above the diagonal,
*            with the array TAUP, represent the orthogonal matrix P as
*            a product of elementary reflectors.
*          See Further Details.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(1,M).
*
*  D       (output) DOUBLE PRECISION array, dimension (min(M,N))
*          The diagonal elements of the bidiagonal matrix B:
*          D(i) = A(i,i).
*
*  E       (output) DOUBLE PRECISION array, dimension (min(M,N)-1)
*          The off-diagonal elements of the bidiagonal matrix B:
*          if m >= n, E(i) = A(i,i+1) for i = 1,2,...,n-1;
*          if m < n, E(i) = A(i+1,i) for i = 1,2,...,m-1.
*
*  TAUQ    (output) DOUBLE PRECISION array dimension (min(M,N))
*          The scalar factors of the elementary reflectors which
*          represent the orthogonal matrix Q. See Further Details.
*
*  TAUP    (output) DOUBLE PRECISION array, dimension (min(M,N))
*          The scalar factors of the elementary reflectors which
*          represent the orthogonal matrix P. See Further Details.
*
*  WORK    (workspace) DOUBLE PRECISION array, dimension (max(M,N))
*
*  INFO    (output) INTEGER
*          = 0: successful exit.
*          < 0: if INFO = -i, the i-th argument had an illegal value.
*
*  Further Details
*  ===============
*
*  The matrices Q and P are represented as products of elementary
*  reflectors:
*
*  If m >= n,
*
*     Q = H(1) H(2) . . . H(n)  and  P = G(1) G(2) . . . G(n-1)
*
*  Each H(i) and G(i) has the form:
*
*     H(i) = I - tauq * v * v'  and G(i) = I - taup * u * u'
*
*  where tauq and taup are real scalars, and v and u are real vectors;
*  v(1:i-1) = 0, v(i) = 1, and v(i+1:m) is stored on exit in A(i+1:m,i);
*  u(1:i) = 0, u(i+1) = 1, and u(i+2:n) is stored on exit in A(i,i+2:n);
*  tauq is stored in TAUQ(i) and taup in TAUP(i).
*
*  If m < n,
*
*     Q = H(1) H(2) . . . H(m-1)  and  P = G(1) G(2) . . . G(m)
*
*  Each H(i) and G(i) has the form:
*
*     H(i) = I - tauq * v * v'  and G(i) = I - taup * u * u'
*
*  where tauq and taup are real scalars, and v and u are real vectors;
*  v(1:i) = 0, v(i+1) = 1, and v(i+2:m) is stored on exit in A(i+2:m,i);
*  u(1:i-1) = 0, u(i) = 1, and u(i+1:n) is stored on exit in A(i,i+1:n);
*  tauq is stored in TAUQ(i) and taup in TAUP(i).
*
*  The contents of A on exit are illustrated by the following examples:
*
*  m = 6 and n = 5 (m > n):          m = 5 and n = 6 (m < n):
*
*    (  d   e   u1  u1  u1 )           (  d   u1  u1  u1  u1  u1 )
*    (  v1  d   e   u2  u2 )           (  e   d   u2  u2  u2  u2 )
*    (  v1  v2  d   e   u3 )           (  v1  e   d   u3  u3  u3 )
*    (  v1  v2  v3  d   e  )           (  v1  v2  e   d   u4  u4 )
*    (  v1  v2  v3  v4  d  )           (  v1  v2  v3  e   d   u5 )
*    (  v1  v2  v3  v4  v5 )
*
*  where d and e denote diagonal and off-diagonal elements of B, vi
*  denotes an element of the vector defining H(i), and ui an element of
*  the vector defining G(i).
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO, ONE
      PARAMETER          ( ZERO = 0.0D+0, ONE = 1.0D+0 )
*     ..
*     .. Local Scalars ..
      INTEGER            I
*     ..
*     .. External Subroutines ..
      EXTERNAL           DLARF, DLARFG, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters
*
      INFO = 0
      IF( M.LT.0 ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( LDA.LT.MAX( 1, M ) ) THEN
         INFO = -4
      END IF
      IF( INFO.LT.0 ) THEN
         CALL XERBLA( 'DGEBD2', -INFO )
         RETURN
      END IF
*
      IF( M.GE.N ) THEN
*
*        Reduce to upper bidiagonal form
*
         DO 10 I = 1, N
*
*           Generate elementary reflector H(i) to annihilate A(i+1:m,i)
*
            CALL DLARFG( M-I+1, A( I, I ), A( MIN( I+1, M ), I ), 1,
     $                   TAUQ( I ) )
            D( I ) = A( I, I )
            A( I, I ) = ONE
*
*           Apply H(i) to A(i:m,i+1:n) from the left
*
            CALL DLARF( 'Left', M-I+1, N-I, A( I, I ), 1, TAUQ( I ),
     $                  A( I, I+1 ), LDA, WORK )
            A( I, I ) = D( I )
*
            IF( I.LT.N ) THEN
*
*              Generate elementary reflector G(i) to annihilate
*              A(i,i+2:n)
*
               CALL DLARFG( N-I, A( I, I+1 ), A( I, MIN( I+2, N ) ),
     $                      LDA, TAUP( I ) )
               E( I ) = A( I, I+1 )
               A( I, I+1 ) = ONE
*
*              Apply G(i) to A(i+1:m,i+1:n) from the right
*
               CALL DLARF( 'Right', M-I, N-I, A( I, I+1 ), LDA,
     $                     TAUP( I ), A( I+1, I+1 ), LDA, WORK )
               A( I, I+1 ) = E( I )
            ELSE
               TAUP( I ) = ZERO
            END IF
   10    CONTINUE
      ELSE
*
*        Reduce to lower bidiagonal form
*
         DO 20 I = 1, M
*
*           Generate elementary reflector G(i) to annihilate A(i,i+1:n)
*
            CALL DLARFG( N-I+1, A( I, I ), A( I, MIN( I+1, N ) ), LDA,
     $                   TAUP( I ) )
            D( I ) = A( I, I )
            A( I, I ) = ONE
*
*           Apply G(i) to A(i+1:m,i:n) from the right
*
            CALL DLARF( 'Right', M-I, N-I+1, A( I, I ), LDA, TAUP( I ),
     $                  A( MIN( I+1, M ), I ), LDA, WORK )
            A( I, I ) = D( I )
*
            IF( I.LT.M ) THEN
*
*              Generate elementary reflector H(i) to annihilate
*              A(i+2:m,i)
*
               CALL DLARFG( M-I, A( I+1, I ), A( MIN( I+2, M ), I ), 1,
     $                      TAUQ( I ) )
               E( I ) = A( I+1, I )
               A( I+1, I ) = ONE
*
*              Apply H(i) to A(i+1:m,i+1:n) from the left
*
               CALL DLARF( 'Left', M-I, N-I, A( I+1, I ), 1, TAUQ( I ),
     $                     A( I+1, I+1 ), LDA, WORK )
               A( I+1, I ) = E( I )
            ELSE
               TAUQ( I ) = ZERO
            END IF
   20    CONTINUE
      END IF
      RETURN
*
*     End of DGEBD2
*
      END

C
C	$Id: gzinsl.f,v 1.8 2008-07-27 00:21:04 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GZINSL
C
C  This subroutine initializes the GKS state list.
C
      include 'gkscom.h'
C
      DO 10 I=1,MOPWK
        SOPWK(I) = -1
        LXWKID(I) = -1
   10 CONTINUE
      DO 20 I=1,MACWK
        SACWK(I) = -1
   20 CONTINUE
      DO 30 I=1,MACWK
        SWKTP(I) = -1
   30 CONTINUE
      CTXFP (1)  = 1
      CTXFP (2)  = 0
      CCHUP (1)  = 0.
      CCHUP (2)  = 1.
      CTXAL (1)  = 0
      CTXAL (2)  = 0
      CPA   (1)  = 1.
      CPA   (2)  = 1.
      CPARF (1)  = 0.
      CPARF (2)  = 0.
      LSNT  (1)  = 0
      LSNT  (2)  = 1
      NTWN(1,1)  = 0.
      NTWN(1,2)  = 1.
      NTWN(1,3)  = 0.
      NTWN(1,4)  = 1.
      NTWN(2,1)  = 0.
      NTWN(2,2)  = 1.
      NTWN(2,3)  = 0.
      NTWN(2,4)  = 1.
      NTVP(1,1)  = 0.
      NTVP(1,2)  = 1.
      NTVP(1,3)  = 0.
      NTVP(1,4)  = 1.
      NTVP(2,1)  = 0.
      NTVP(2,2)  = 1.
      NTVP(2,3)  = 0.
      NTVP(2,4)  = 1.
      CPLI       = 1
      CLN        = 1
      CLWSC      = 1.
      CPLCI      = 1
      CLNA       = GINDIV
      CLWSCA     = GINDIV
      CPLCIA     = GINDIV
      CPMI       = 1
      CMK        = 3
      CMKS       = 1.
      CPMCI      = 1
      CMKA       = GINDIV
      CMKSA      = GINDIV
      CPMCIA     = GINDIV
      CTXI       = 1
      CCHXP      = 1.0
      CCHSP      = 0.
      CTXCI      = 1
      CTXFPA     = GINDIV
      CCHXPA     = GINDIV
      CCHSPA     = GINDIV
      CTXCIA     = GINDIV
      CCHH       = .01
      CTXP       = 0
      CFAI       = 1
      CFAIS      = 1
      CFASI      = 1
      CFACI      = 1
      CFAISA     = GINDIV
      CFASIA     = GINDIV
      CFACIA     = GINDIV
      CNT        = 0
      CCLIP      = 1
C
      RETURN
      END

      PROGRAM FNGWSYM
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C  Plots tables of all the weather symbols.
C
      CHARACTER*2 CFNT(7)
      CHARACTER*25 YLAB(2,7)
      INTEGER YLEN(2,7)
      DATA CFNT/'a ','N ','W ','CH','CM','CL','C '/
      DATA YLAB/ 'a','Pressure Tendency ',
     +           'N','Sky Cover         ',
     +           'W','Past Weather      ',
     +           'CH','High Clouds      ',
     +           'CM','Medium Clouds    ',
     +           'CL','Low Clouds       ',
     +           'C','Cloud Types       '/
      DATA YLEN/1,17,
     +          1, 9,
     +          1,12,
     +          2,11,
     +          2,13,
     +          2,10,
     +          1,11/ 
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)

      CALL GSCR(IWKID,0,1.,1.,1.)
      CALL GSCR(IWKID,1,0.,0.,0.)
      CALL GSLWSC(1.)
C
C  Font WW -- Present Weather table.
C
C  Table width.
C
      X1 = .025
      X2 = .975
C
C  Table heights.
C  
      Y1 = 0.
      Y2 = .95
      Y3 = 1.
C
C  Number of columns and rows.
C
      NC = 10
      NR = 10
C
      CALL GSPLCI(1)
      CALL GSTXCI(1)
      CALL DTABLE('WW',NR,NC,X1,Y1,X2,Y2,Y3,1,1,1)
      SIZE = .4*(Y3-Y2)
      YY = .5*(Y2+Y3)
      CALL NPUTS(YY,'WW','Present Weather',SIZE)
      CALL FRAME
C
      NR = 1
      NC = 10
      R = 4.5/12.
      DY = .095
      SPC = 1./7.-(1.+R)*DY
      DO 10 NF=1,7
         YB = (NF-1)*((1.+R)*DY+SPC)
         Y1 = YB
         Y2 = YB+DY
         Y3 = YB+(1+R)*DY
         CALL DTABLE(CFNT(NF),NR,NC,X1,Y1,X2,Y2,Y3,1,1,1)
         YY = .5*(Y2+Y3)
         CALL NPUTS(YY,YLAB(1,NF)(1:YLEN(1,NF)),
     +        YLAB(2,NF)(1:YLEN(2,NF)),.5*(Y3-Y2))
 10   CONTINUE
      CALL FRAME
C
C Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      STOP
      END

      SUBROUTINE DTABLE(FONT,NR,NC,X1,Y1,X2,Y2,Y3,ITX1,ITX2,ILNC)
C
C  Draw table of characters from font FONT with NR rows and NC columns.
C  The boundary of the table in world coordinates is (X1,Y1) to (X2,Y2).
C  The line color index is ILNC and the text color index for the label
C  characters is ITX1 and for the displayed characters is ITX2.
C
      DIMENSION XX(2),YY(2),XC(10),YC(10),XLC(10),YLC(10)
      CHARACTER*(*) FONT
      CHARACTER*2 NLAB
C
C  Change the flag for Plotchar function codes to a non-printing
C  ASCII character since function codes will not be  
C  used and all printing ASCII characters will be used.
C
      CALL PCSETC('FC',CHAR(30))
C
C  Draw table grid and compute the centers of the grid boxes.
C
      CALL GSLWSC(2.)
      CALL GSPLCI(ILNC)
      YINC = (Y2-Y1)/REAL(NR)
      DO 10 J=1,NR+1
         YY(1) = Y1+(J-1)*YINC
         YY(2) = YY(1)
         XX(1) = X1
         XX(2) = X2
         CALL GPL(2,XX,YY)
         IF (J .LE. NR) THEN
            YC(J) = YY(1)+.4*YINC
            YLC(J) = YY(1)+.8*YINC
         ENDIF
 10   CONTINUE
C     
      XINC = (X2-X1)/REAL(NC)
      DO 20 I=1,NC+1
         YY(1) = Y1
         YY(2) = Y2
         XX(1) = X1+(I-1)*XINC
         XX(2) = XX(1)
         CALL GPL(2,XX,YY)
         IF (I .LE. NC) THEN
            XC(I) = XX(1)+.6*XINC
            XLC(I) = XX(1)+.2*XINC
         ENDIF
 20   CONTINUE
      CALL GSLWSC(1.)
C
C  Draw the characters in the boxes.
C
      CALL GSTXAL(2,3)
      CALL GSTXFP(-36,2)
C    
      CALL GSTXCI(ITX2)
      DO 30 J=1,NR
         DO 40 I=1,NC
            NUM = (NR-J)*NC+I-1
            CALL NGWSYM(FONT,NUM,XC(I),YC(J),.43*YINC,1,0)
 40      CONTINUE
 30   CONTINUE
C    
C  Draw the character number in the upper left of the box.
C
      CHGT = .14*YINC
      DO 50 J=1,NR
         DO 60 I=1,NC
            NUM = (NR-J)*NC+I-1
            WRITE(NLAB,500) NUM
 500        FORMAT(I2)
            CALL PCSETI('FN',26)
            CALL PCSETI('CC',ITX1)
            CALL PLCHHQ(XLC(I),YLC(J),NLAB,6.*CHGT/7.,0.,0.)
 60      CONTINUE
 50   CONTINUE
C
      RETURN
      END

      SUBROUTINE NPUTS(YY,STR1,STR2,SIZE)
C
C  Put out STR1, then a dash, then STR2 at size SIZE.
C
      CHARACTER*(*) STR1,STR2
      DIMENSION TX(4),TY(4)
C
      CALL GSTXFP(-22,2)
      CALL GSTXAL(1,3)
      CALL GSCHH(SIZE)
      CALL GQTXX(1,0.,YY,STR1,IER,CPX,CPY,TX,TY)
      DX1 = CPX
      CALL GQTXX(1,0.,YY,STR2,IER,CPX,CPY,TX,TY)
      DX3 = CPX
      CALL GSTXFP(-34,2)
      CALL GQTXX(1,0.,YY,' > ',IER,CPX,CPY,TX,TY)
      DX2 = CPX
      DX = DX1+DX2+DX3
      STRTX = .5-.5*DX
      CALL PCSETI('FN',22)
      CALL PLCHHQ(STRTX,YY,STR1,6.*SIZE/7.,0.,-1.)
      CALL PLCHHQ(STRTX+DX1+DX2,YY,STR2,6.*SIZE/7.,0.,-1.)
      CALL GSTXFP(-34,2)
      CALL PCSETI('FN',34)
      CALL PLCHHQ(STRTX+DX1,YY,' > ',6.*SIZE/7.,0.,-1.)
C
      RETURN
      END

      SUBROUTINE CUPMTR( SIDE, UPLO, TRANS, M, N, AP, TAU, C, LDC, WORK,
     $                   INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER          SIDE, TRANS, UPLO
      INTEGER            INFO, LDC, M, N
*     ..
*     .. Array Arguments ..
      COMPLEX            AP( * ), C( LDC, * ), TAU( * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  CUPMTR overwrites the general complex M-by-N matrix C with
*
*                  SIDE = 'L'     SIDE = 'R'
*  TRANS = 'N':      Q * C          C * Q
*  TRANS = 'C':      Q**H * C       C * Q**H
*
*  where Q is a complex unitary matrix of order nq, with nq = m if
*  SIDE = 'L' and nq = n if SIDE = 'R'. Q is defined as the product of
*  nq-1 elementary reflectors, as returned by CHPTRD using packed
*  storage:
*
*  if UPLO = 'U', Q = H(nq-1) . . . H(2) H(1);
*
*  if UPLO = 'L', Q = H(1) H(2) . . . H(nq-1).
*
*  Arguments
*  =========
*
*  SIDE    (input) CHARACTER*1
*          = 'L': apply Q or Q**H from the Left;
*          = 'R': apply Q or Q**H from the Right.
*
*  UPLO    (input) CHARACTER*1
*          = 'U': Upper triangular packed storage used in previous
*                 call to CHPTRD;
*          = 'L': Lower triangular packed storage used in previous
*                 call to CHPTRD.
*
*  TRANS   (input) CHARACTER*1
*          = 'N':  No transpose, apply Q;
*          = 'C':  Conjugate transpose, apply Q**H.
*
*  M       (input) INTEGER
*          The number of rows of the matrix C. M >= 0.
*
*  N       (input) INTEGER
*          The number of columns of the matrix C. N >= 0.
*
*  AP      (input) COMPLEX array, dimension
*                               (M*(M+1)/2) if SIDE = 'L'
*                               (N*(N+1)/2) if SIDE = 'R'
*          The vectors which define the elementary reflectors, as
*          returned by CHPTRD.  AP is modified by the routine but
*          restored on exit.
*
*  TAU     (input) COMPLEX array, dimension (M-1) if SIDE = 'L'
*                                     or (N-1) if SIDE = 'R'
*          TAU(i) must contain the scalar factor of the elementary
*          reflector H(i), as returned by CHPTRD.
*
*  C       (input/output) COMPLEX array, dimension (LDC,N)
*          On entry, the M-by-N matrix C.
*          On exit, C is overwritten by Q*C or Q**H*C or C*Q**H or C*Q.
*
*  LDC     (input) INTEGER
*          The leading dimension of the array C. LDC >= max(1,M).
*
*  WORK    (workspace) COMPLEX array, dimension
*                                   (N) if SIDE = 'L'
*                                   (M) if SIDE = 'R'
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*
*  =====================================================================
*
*     .. Parameters ..
      COMPLEX            ONE
      PARAMETER          ( ONE = ( 1.0E+0, 0.0E+0 ) )
*     ..
*     .. Local Scalars ..
      LOGICAL            FORWRD, LEFT, NOTRAN, UPPER
      INTEGER            I, I1, I2, I3, IC, II, JC, MI, NI, NQ
      COMPLEX            AII, TAUI
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           CLARF, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          CONJG, MAX
*     ..
*     .. Executable Statements ..
*
*     Test the input arguments
*
      INFO = 0
      LEFT = LSAME( SIDE, 'L' )
      NOTRAN = LSAME( TRANS, 'N' )
      UPPER = LSAME( UPLO, 'U' )
*
*     NQ is the order of Q
*
      IF( LEFT ) THEN
         NQ = M
      ELSE
         NQ = N
      END IF
      IF( .NOT.LEFT .AND. .NOT.LSAME( SIDE, 'R' ) ) THEN
         INFO = -1
      ELSE IF( .NOT.UPPER .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = -2
      ELSE IF( .NOT.NOTRAN .AND. .NOT.LSAME( TRANS, 'C' ) ) THEN
         INFO = -3
      ELSE IF( M.LT.0 ) THEN
         INFO = -4
      ELSE IF( N.LT.0 ) THEN
         INFO = -5
      ELSE IF( LDC.LT.MAX( 1, M ) ) THEN
         INFO = -9
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'CUPMTR', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( M.EQ.0 .OR. N.EQ.0 )
     $   RETURN
*
      IF( UPPER ) THEN
*
*        Q was determined by a call to CHPTRD with UPLO = 'U'
*
         FORWRD = ( LEFT .AND. NOTRAN ) .OR.
     $            ( .NOT.LEFT .AND. .NOT.NOTRAN )
*
         IF( FORWRD ) THEN
            I1 = 1
            I2 = NQ - 1
            I3 = 1
            II = 2
         ELSE
            I1 = NQ - 1
            I2 = 1
            I3 = -1
            II = NQ*( NQ+1 ) / 2 - 1
         END IF
*
         IF( LEFT ) THEN
            NI = N
         ELSE
            MI = M
         END IF
*
         DO 10 I = I1, I2, I3
            IF( LEFT ) THEN
*
*              H(i) or H(i)' is applied to C(1:i,1:n)
*
               MI = I
            ELSE
*
*              H(i) or H(i)' is applied to C(1:m,1:i)
*
               NI = I
            END IF
*
*           Apply H(i) or H(i)'
*
            IF( NOTRAN ) THEN
               TAUI = TAU( I )
            ELSE
               TAUI = CONJG( TAU( I ) )
            END IF
            AII = AP( II )
            AP( II ) = ONE
            CALL CLARF( SIDE, MI, NI, AP( II-I+1 ), 1, TAUI, C, LDC,
     $                  WORK )
            AP( II ) = AII
*
            IF( FORWRD ) THEN
               II = II + I + 2
            ELSE
               II = II - I - 1
            END IF
   10    CONTINUE
      ELSE
*
*        Q was determined by a call to CHPTRD with UPLO = 'L'.
*
         FORWRD = ( LEFT .AND. .NOT.NOTRAN ) .OR.
     $            ( .NOT.LEFT .AND. NOTRAN )
*
         IF( FORWRD ) THEN
            I1 = 1
            I2 = NQ - 1
            I3 = 1
            II = 2
         ELSE
            I1 = NQ - 1
            I2 = 1
            I3 = -1
            II = NQ*( NQ+1 ) / 2 - 1
         END IF
*
         IF( LEFT ) THEN
            NI = N
            JC = 1
         ELSE
            MI = M
            IC = 1
         END IF
*
         DO 20 I = I1, I2, I3
            AII = AP( II )
            AP( II ) = ONE
            IF( LEFT ) THEN
*
*              H(i) or H(i)' is applied to C(i+1:m,1:n)
*
               MI = M - I
               IC = I + 1
            ELSE
*
*              H(i) or H(i)' is applied to C(1:m,i+1:n)
*
               NI = N - I
               JC = I + 1
            END IF
*
*           Apply H(i) or H(i)'
*
            IF( NOTRAN ) THEN
               TAUI = TAU( I )
            ELSE
               TAUI = CONJG( TAU( I ) )
            END IF
            CALL CLARF( SIDE, MI, NI, AP( II ), 1, TAUI, C( IC, JC ),
     $                  LDC, WORK )
            AP( II ) = AII
*
            IF( FORWRD ) THEN
               II = II + NQ - I + 1
            ELSE
               II = II - NQ + I - 2
            END IF
   20    CONTINUE
      END IF
      RETURN
*
*     End of CUPMTR
*
      END

      PROGRAM FFEX04
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
      PARAMETER ( M=20 , N=36 , NPR=155)
      DIMENSION U(M,N),V(M,N)
      DIMENSION WRK(2*M*N)
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
      CALL STSETR('DFM -- Differential Magnitude', 0.01)
C
      CALL STSETI('MAP -- Mapping Mode', 2)
      CALL STSETR('WDL -- Window Left', -20.0)
      CALL STSETR('WDR -- Window Right', 20.0)
      CALL STSETR('WDB -- Window Bottom', -20.0)
      CALL STSETR('WDT -- Window Top', 20.0)
      CALL STSETR('XC1 -- Lower X Bound', 1.0)
      CALL STSETR('XCM -- Upper X Bound', 20.0)
      CALL STSETR('YC1 -- Lower Y Bound', 0.0)
      CALL STSETR('YCN -- Upper Y Bound', 360.0)
C     
      DO 1000 K=1,0,-1
C
         CALL STSETI('TRT -- Transform Type', K)
C
         DO 20 I = 1,M
            DO 10 J = 1,N
               U(I,J)=1.0
               V(I,J)=0.0
 10         CONTINUE
 20      CONTINUE
C
         CALL STINIT(U,M,V,M,IDM,IDM,M,N,WRK,2*M*N)
         CALL STREAM(U,V,IDM,IDM,IDM,WRK)
C
         DO 120 I = 1,M
            DO 110 J = 1,N
               U(I,J)=0.0
               V(I,J)=1.0
 110        CONTINUE
 120     CONTINUE
C
         CALL STINIT(U,M,V,M,IDM,IDM,M,N,WRK,2*M*N)
         CALL STREAM(U,V,IDM,IDM,IDM,WRK)
C
         CALL PERIM(1,0,1,0)
         CALL FRAME
C
 1000 CONTINUE
C
C     Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      STOP
      END

C
C $Id: lblbar.f,v 1.12 2008-07-27 00:17:17 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE LBLBAR (IHOV,XLEB,XREB,YBEB,YTEB,NBOX,WSFB,HSFB,LFIN,
     +                   IFTP,LLBS,NLBS,LBAB)
C
        DIMENSION LFIN(*)
        CHARACTER*(*) LLBS(*)
C
C This routine draws a horizontal or vertical label bar to serve as a
C key for a solid-filled plot.
C
C IHOV is 0 if a horizontal label bar is to be drawn, 1 if a vertical
C label bar is to be drawn.
C
C XLEB is a value between 0 and 1, specifying the position of the left
C edge of the bar.
C
C XREB is a value between 0 and 1, specifying the position of the right
C edge of the bar.
C
C YBEB is a value between 0 and 1, specifying the position of the bottom
C edge of the bar.
C
C YTEB is a value between 0 and 1, specifying the position of the top
C edge of the bar.
C
C ABS(NBOX) is the number of boxes into which the bar is to be divided.
C If NBOX is positive, the boxes will be outlined after being filled;
C if NBOX is negative, this will not be done.
C
C WSFB and HSFB are the width and height, respectively, of each little
C solid-filled box, as fractions of the rectangles resulting from the
C division of the bar into ABS(NBOX) pieces.
C
C LFIN is a list of indices, each of which specifies, in some manner,
C how one of the solid-filled boxes is to be filled.  (For example,
C each may be a color index.)
C
C IFTP specifies the type of solid fill to be used.  If IFTP is zero,
C the routine SFSGFA, in the package SOFTFILL, will be called, with
C an index from LFIN as the value of the argument ICI.  (By default,
C this will result in color fill; the value of the SOFTFILL internal
C parameter 'TY' may be changed to select some other kind of fill by
C SFSGFA.)  If IFTP is non-zero, the user-replaceable routine LBFILL
C will be used to fill the boxes; the default version of this routine
C just does color fill.
C
C LLBS is a list of labels for the solid-filled boxes.
C
C NLBS is the number of labels in the list LLBS.  If NLBS is equal to
C ABS(NBOX)-1, then label I applies to the line separating box I from
C box I+1.  If NLBS is equal to NBOX, then label I applies to box I.  If
C NLBS is equal to ABS(NBOX)+1, then labels 1 and NLBS apply to the left
C and right ends (if IHOV is non-zero, the bottom and top ends) of the
C whole color bar; for values of I not equal to 1 or NLBS, label I
C applies to the line separating box I-1 from box I.
C
C LBAB is a flag having the value 0 if the bar is to be unlabelled, 1
C if the labels are to be below a horizontal bar or to the right of a
C vertical bar, 2 if the labels are to be above a horizontal bar or to
C the left of a vertical bar, 3 if the labels are to be on both sides
C of the bar.
C
C
C Declare the common block where internal parameters are stored.
C
        COMMON /LBCOMN/ ICBL,ICFL,ICLB,WOBL,WOFL,WOLB
        SAVE   /LBCOMN/
C
C Define local arrays to hold X and Y coordinates of boxes.
C
        DIMENSION XCRA(5),YCRA(5)
C
C Define local arrays for use as work arrays by the routine SFSGFA.
C
        DIMENSION RWRK(6),IWRK(8)
C
C Do a call forcing a BLOCKDATA to be loaded from a binary library.
C
        CALL LBBLDA
C
C Check for an uncleared prior error.
C
        IF (ICFELL('LBLBAR - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C Save the current SET parameters and arrange for the use of normalized
C device coordinates.
C
        CALL GETSET (XLVP,XRVP,YBVP,YTVP,XLWD,XRWD,YBWD,YTWD,LNLG)
        IF (ICFELL('LBLBAR',2).NE.0) RETURN
        CALL    SET (  0.,  1.,  0.,  1.,  0.,  1.,  0.,  1.,   1)
        IF (ICFELL('LBLBAR',3).NE.0) RETURN
C
C Compute the width and height of each section of the bar and the
C coordinates of the edges of the first solid-filled box.
C
        IF (IHOV.EQ.0) THEN
          WSOB=(XREB-XLEB)/REAL(ABS(NBOX))
          WINC=WSOB
          HSOB=YTEB-YBEB
          HINC=0.
          XLB1=XLEB+.5*(1.-WSFB)*WSOB
          XRB1=XLB1+WSFB*WSOB
          IF (LBAB.EQ.1) THEN
            YBB1=YTEB-HSFB*HSOB
            YTB1=YTEB
          ELSE IF (LBAB.EQ.2) THEN
            YBB1=YBEB
            YTB1=YBEB+HSFB*HSOB
          ELSE
            YBB1=YBEB+.5*(1.-HSFB)*HSOB
            YTB1=YTEB-.5*(1.-HSFB)*HSOB
          END IF
        ELSE
          WSOB=XREB-XLEB
          WINC=0.
          HSOB=(YTEB-YBEB)/REAL(ABS(NBOX))
          HINC=HSOB
          IF (LBAB.EQ.1) THEN
            XLB1=XLEB
            XRB1=XLEB+WSFB*WSOB
          ELSE IF (LBAB.EQ.2) THEN
            XLB1=XREB-WSFB*WSOB
            XRB1=XREB
          ELSE
            XLB1=XLEB+.5*(1.-WSFB)*WSOB
            XRB1=XREB-.5*(1.-WSFB)*WSOB
          END IF
          YBB1=YBEB+.5*(1.-HSFB)*HSOB
          YTB1=YBB1+HSFB*HSOB
        END IF
C
C Draw the bar by filling all of the individual boxes.
C
        CALL GQFACI (IERR,ISFC)
        IF (IERR.NE.0) THEN
          CALL SETER ('LBLBAR - ERROR EXIT FROM GQFACI',4,1)
          RETURN
        END IF
C
        IF (ICFL.GE.0) THEN
          CALL GQPLCI (IERR,ISPC)
          IF (IERR.NE.0) THEN
            CALL SETER ('LBLBAR - ERROR EXIT FROM GQPLCI',5,1)
            RETURN
          END IF
          CALL GSPLCI (ICFL)
        END IF
C
        IF (WOFL.GT.0.) THEN
          CALL GQLWSC (IERR,STLW)
          IF (IERR.NE.0) THEN
            CALL SETER ('LBLBAR - ERROR EXIT FROM GQLWSC',6,1)
            RETURN
          END IF
          CALL GSLWSC (WOFL)
        END IF
C
        DO 101 I=1,ABS(NBOX)
          XCRA(1)=XLB1+REAL(I-1)*WINC
          YCRA(1)=YBB1+REAL(I-1)*HINC
          XCRA(2)=XRB1+REAL(I-1)*WINC
          YCRA(2)=YCRA(1)
          XCRA(3)=XCRA(2)
          YCRA(3)=YTB1+REAL(I-1)*HINC
          XCRA(4)=XCRA(1)
          YCRA(4)=YCRA(3)
          XCRA(5)=XCRA(1)
          YCRA(5)=YCRA(1)
          IF (IFTP.EQ.0) THEN
            CALL SFSGFA (XCRA,YCRA,4,RWRK,6,IWRK,8,LFIN(I))
            IF (ICFELL('LBLBAR',7).NE.0) RETURN
          ELSE
            CALL LBFILL (IFTP,XCRA,YCRA,5,LFIN(I))
            IF (ICFELL('LBLBAR',8).NE.0) RETURN
          END IF
  101   CONTINUE
C
        CALL GSFACI (ISFC)
        IF (ICFL.GE.0) CALL GSPLCI (ISPC)
        IF (WOFL.GT.0.) CALL GSLWSC (STLW)
C
C If it is to be done, outline the boxes now.
C
        IF (NBOX.GT.0) THEN
C
          IF (ICBL.GE.0) THEN
            CALL GQPLCI (IERR,ISPC)
            IF (IERR.NE.0) THEN
              CALL SETER ('LBLBAR - ERROR EXIT FROM GQPLCI',9,1)
              RETURN
            END IF
            CALL GSPLCI (ICBL)
          END IF
C
          IF (WOBL.GT.0.) THEN
            CALL GQLWSC (IERR,STLW)
            IF (IERR.NE.0) THEN
              CALL SETER ('LBLBAR - ERROR EXIT FROM GQLWSC',10,1)
              RETURN
            END IF
            CALL GSLWSC (WOBL)
          END IF
C
          DO 102 I=1,ABS(NBOX)
            XCRA(1)=XLB1+REAL(I-1)*WINC
            YCRA(1)=YBB1+REAL(I-1)*HINC
            XCRA(2)=XRB1+REAL(I-1)*WINC
            YCRA(2)=YCRA(1)
            XCRA(3)=XCRA(2)
            YCRA(3)=YTB1+REAL(I-1)*HINC
            XCRA(4)=XCRA(1)
            YCRA(4)=YCRA(3)
            XCRA(5)=XCRA(1)
            YCRA(5)=YCRA(1)
            IF (IHOV.EQ.0) THEN
              IF (I.EQ.1.OR.WSFB.NE.1.) THEN
                CALL GPL (5,XCRA,YCRA)
              ELSE
                CALL GPL (4,XCRA,YCRA)
              END IF
            ELSE
              IF (I.EQ.1.OR.HSFB.NE.1.) THEN
                CALL GPL (5,XCRA,YCRA)
              ELSE
                CALL GPL (4,XCRA(2),YCRA(2))
              END IF
            END IF
  102     CONTINUE
C
          IF (ICBL.GE.0) CALL GSPLCI (ISPC)
          IF (WOBL.GT.0.) CALL GSLWSC (STLW)

        END IF
C
C If labelling is to be done at all ...
C
        IF (LBAB.NE.0) THEN
C
C ... save the current setting of the PLOTCHAR "text extent" parameter
C and reset it to force computation of "text extent" quantities.
C
          CALL PCGETI ('TE - TEXT EXTENT FLAG',ITEX)
          IF (ICFELL('LBLBAR',11).NE.0) RETURN
          CALL PCSETI ('TE - TEXT EXTENT FLAG',1)
          IF (ICFELL('LBLBAR',12).NE.0) RETURN
C
C Determine the character width to be used in drawing the labels.  We
C start with a character width of .1, which is much too big, and then
C reduce the value as required to avoid various overlap problems.
C
C RMUL is a real multiplier used to compensate for the fact that labels
C are sometimes put on only one side of the bar and sometimes on both
C sides of the bar.
C
C HMAX ends up expressing the largest vertical dimension of any label
C (including some white space).
C
C XPLL and YPLL are used for the values of X and Y at the center of the
C last label along the label bar, while DRLL and DTLL are distances
C from the center to the right edge or the top edge, respectively, of
C the last label.  (For a horizontal label bar, we use only XPLL and
C DRLL; for a vertical one, we use only YPLL and DTLL.)
C
          WCHR=.1
C
          RMUL=1.+REAL(MAX(0,MIN(3,LBAB))/3)
C
          HMAX=0.
C
          XPLL=0.
          YPLL=0.
          DRLL=0.
          DTLL=0.
C
          IF (NLBS.LT.ABS(NBOX)) THEN
            XPB1=XLB1+WSOB
            YPB1=YBB1+HSOB
          ELSE IF (NLBS.EQ.ABS(NBOX)) THEN
            XPB1=XLB1+WSFB*WSOB/2.
            YPB1=YBB1+HSFB*HSOB/2.
          ELSE
            XPB1=XLB1
            YPB1=YBB1
          END IF
C
          DO 104 I=1,NLBS
            NCLB=LEN(LLBS(I))
  103       IF (LLBS(I)(NCLB:NCLB).EQ.' ') THEN
              NCLB=NCLB-1
              IF (NCLB.GT.0) GO TO 103
            END IF
            IF (NCLB.NE.0) THEN
              WCHO=WCHR
              CALL PLCHHQ (.5,.5,LLBS(I)(1:NCLB),WCHO,360.,0.)
              IF (ICFELL('LBLBAR',13).NE.0) RETURN
              CALL PCGETR ('DL - DISTANCE TO LEFT EDGE'  ,DSTL)
              IF (ICFELL('LBLBAR',14).NE.0) RETURN
              CALL PCGETR ('DR - DISTANCE TO RIGHT EDGE' ,DSTR)
              IF (ICFELL('LBLBAR',15).NE.0) RETURN
              CALL PCGETR ('DB - DISTANCE TO BOTTOM EDGE',DSTB)
              IF (ICFELL('LBLBAR',16).NE.0) RETURN
              CALL PCGETR ('DT - DISTANCE TO TOP EDGE'   ,DSTT)
              IF (ICFELL('LBLBAR',17).NE.0) RETURN
              IF (IHOV.EQ.0) THEN
                IF ((1.-HSFB)*HSOB.LT.RMUL*(DSTB+DSTT+WCHO))
     +          WCHR=WCHO*(((1.-HSFB)*HSOB)/(RMUL*(DSTB+DSTT+WCHO)))
                IF (1.-XPB1.LT.DSTR+WCHO)
     +          WCHR=MIN(WCHR,WCHO*((1.-XPB1)/(DSTR+WCHO)))
                IF (XPB1-XPLL.LT.DRLL+DSTL+2.*WCHO)
     +          WCHR=MIN(WCHR,WCHO*((XPB1-XPLL)/(DRLL+DSTL+2.*WCHO)))
                HMAX=MAX(HMAX,DSTB+DSTT+WCHO)*(WCHR/WCHO)
              ELSE
                IF ((1.-WSFB)*WSOB.LT.RMUL*(DSTL+DSTR+2.*WCHO))
     +          WCHR=WCHO*(((1.-WSFB)*WSOB)/(RMUL*(DSTL+DSTR+2.*WCHO)))
                IF (1.-YPB1.LT.DSTT+.5*WCHO)
     +          WCHR=MIN(WCHR,WCHO*((1.-YPB1)/(DSTT+.5*WCHO)))
                IF (YPB1-YPLL.LT.DTLL+DSTB+WCHO)
     +          WCHR=MIN(WCHR,WCHO*((YPB1-YPLL)/(DTLL+DSTB+WCHO)))
              END IF
              XPLL=XPB1
              YPLL=YPB1
              DRLL=DSTR*(WCHR/WCHO)
              DTLL=DSTT*(WCHR/WCHO)
            END IF
            XPB1=XPB1+WSOB
            YPB1=YPB1+HSOB
  104     CONTINUE
C
C Draw the labels.
C
          CALL GQPLCI (IERR,ISCL)
          IF (IERR.NE.0) THEN
            CALL SETER ('LBLBAR - ERROR EXIT FROM GQPLCI',18,1)
            RETURN
          END IF
C
          CALL GQTXCI (IERR,ISCT)
          IF (IERR.NE.0) THEN
            CALL SETER ('LBLBAR - ERROR EXIT FROM GQTXCI',19,1)
            RETURN
          END IF
C
          IF (ICLB.LT.0) THEN
            CALL GSPLCI (ISCT)
          ELSE
            CALL GSPLCI (ICLB)
            CALL GSTXCI (ICLB)
          END IF
C
          IF (WOLB.GT.0.) THEN
            CALL GQLWSC (IERR,STLW)
            IF (IERR.NE.0) THEN
              CALL SETER ('LBLBAR - ERROR EXIT FROM GQLWSC',20,1)
              RETURN
            END IF
            CALL GSLWSC (WOLB)
          END IF
C
          IF (NLBS.LT.ABS(NBOX)) THEN
            XLB1=XLB1+WINC
            YBB1=YBB1+HINC
          ELSE IF (NLBS.EQ.ABS(NBOX)) THEN
            XLB1=XLB1+WSFB*WINC/2.
            YBB1=YBB1+HSFB*HINC/2.
          END IF
C
          DO 106 I=1,NLBS
            NCLB=LEN(LLBS(I))
  105       IF (LLBS(I)(NCLB:NCLB).EQ.' ') THEN
              NCLB=NCLB-1
              IF (NCLB.GT.0) GO TO 105
            END IF
            IF (NCLB.NE.0) THEN
              IF (IHOV.EQ.0) THEN
                IF (LBAB.EQ.1.OR.LBAB.GE.3)
     +            CALL PLCHHQ (XLB1+REAL(I-1)*WSOB,YBB1-HMAX/2.,
     +                               LLBS(I)(1:NCLB),WCHR,0.,0.)
                  IF (ICFELL('LBLBAR',21).NE.0) RETURN
                IF (LBAB.EQ.2.OR.LBAB.GE.3)
     +            CALL PLCHHQ (XLB1+REAL(I-1)*WSOB,YTB1+HMAX/2.,
     +                               LLBS(I)(1:NCLB),WCHR,0.,0.)
                  IF (ICFELL('LBLBAR',22).NE.0) RETURN
              ELSE
                IF (LBAB.EQ.1.OR.LBAB.GE.3)
     +            CALL PLCHHQ (XRB1+WCHR,YBB1+REAL(I-1)*HSOB,
     +                            LLBS(I)(1:NCLB),WCHR,0.,-1.)
                  IF (ICFELL('LBLBAR',23).NE.0) RETURN
                IF (LBAB.EQ.2.OR.LBAB.GE.3)
     +            CALL PLCHHQ (XLB1-WCHR,YBB1+REAL(I-1)*HSOB,
     +                            LLBS(I)(1:NCLB),WCHR,0.,+1.)
                  IF (ICFELL('LBLBAR',24).NE.0) RETURN
              END IF
            END IF
  106     CONTINUE
C
          CALL GSPLCI (ISCL)
          IF (ICLB.GE.0) CALL GSTXCI (ISCT)
          IF (WOLB.GT.0.) CALL GSLWSC (STLW)
C
C Restore the original setting of the PLOTCHAR text extent flag.
C
  107     CALL PCSETI ('TE - TEXT EXTENT FLAG',ITEX)
          IF (ICFELL('LBLBAR',25).NE.0) RETURN
C
        END IF
C
C Restore the original SET parameters.
C
        CALL SET (XLVP,XRVP,YBVP,YTVP,XLWD,XRWD,YBWD,YTWD,LNLG)
        IF (ICFELL('LBLBAR',26).NE.0) RETURN
C
C Done.
C
        RETURN
C
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C   FFTPACK 5.0
C   Copyright (C) 1995-2004, Scientific Computing Division,
C   University Corporation for Atmospheric Research
C   Licensed under the GNU General Public License (GPL)
C
C   Authors:  Paul N. Swarztrauber and Richard A. Valent
C
C   $Id: tables.f,v 1.2 2006-11-21 01:10:20 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      SUBROUTINE DTABLES(IDO,IP,WA)
      DOUBLE PRECISION TPI
      DOUBLE PRECISION ARGZ
      DOUBLE PRECISION ARG1
      DOUBLE PRECISION ARG2
      DOUBLE PRECISION ARG3
      DOUBLE PRECISION ARG4
      DOUBLE PRECISION WA(IDO,IP-1,2)
C
      TPI = 8.D0*ATAN(1.D0)
      ARGZ = TPI/DBLE(IP)
      ARG1 = TPI/DBLE(IDO*IP)
      DO 110 J = 2,IP
          ARG2 = DBLE(J-1)*ARG1
          DO 100 I = 1,IDO
              ARG3 = DBLE(I-1)*ARG2
              WA(I,J-1,1) = COS(ARG3)
              WA(I,J-1,2) = SIN(ARG3)
  100     CONTINUE
          IF (IP.LE.5) GO TO 110
          ARG4 = DBLE(J-1)*ARGZ
          WA(1,J-1,1) = COS(ARG4)
          WA(1,J-1,2) = SIN(ARG4)
  110 CONTINUE
      RETURN
      END

C
C $Id: hstopl.f,v 1.7 2008-07-27 00:17:15 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
C *************************************************************
C
      SUBROUTINE HSTOPL(IOPT)
C
C *************************************************************
C
C  THESE THREE ROUTINES ARE OPTION ROUTINES TO BE USED WITH
C  THE HISTOGRAM ROUTINE -- HISTGR
C
C  SET THE HISTOGRAM OPTIONS
C
C  INPUT
C     IOPT-CHARACTER STRING OF OPTION VALUE
C
C  SET COMMON DATA EQUAL TO INPUT DATA
C
C
      COMMON /HSTGC1/ HORZNT, PERCNT, MIDVAL, SHADE, MEDIAN, PERIM,
     -       HFRAME, LISTOP, WINDOW, COLORS, HSTFOR, TITLE, LABEL,
     -       FREQNC, HWIND(4), COLSHA, COLREC, COLAXI, COLMED, COLTEX,
     -       COLTIT, COLPER, DRAWL, SPACE, LABMAX, CHARL, HEIGHT,
     -       ORIENT, COLSH2, SETSPA, SETSP2, MVALU, SETMVA, SETEPS,
     -       NMVAL, PMVAL, PERTIT
      LOGICAL HORZNT, PERCNT, MIDVAL, SHADE, MEDIAN, PERIM, HFRAME,
     -        LISTOP, WINDOW, COLORS, HSTFOR, TITLE, LABEL, FREQNC,
     -        DRAWL, SPACE, CHARL, MVALU, NMVAL, PMVAL, PERTIT
      COMMON /HSTGC2/ STRFOR, STRTIT, STRLAB, STRFRE, STRPER, LABTEX
      CHARACTER*96  STRTIT
      CHARACTER*55  STRFOR, STRLAB, STRFRE, STRPER
      CHARACTER*15 LABTEX(30)
      CHARACTER*7  IOPT
      CHARACTER*2  TAG, OPT
      INTEGER  COLSHA, COLREC, COLAXI, COLMED, COLTEX
      INTEGER  COLTIT, COLPER, COLSH2, HEIGHT, ORIENT
C
      NERR = 0
C
C  DETERMINE OPTION AND ITS VALUE
C
      TAG = IOPT(1:2)
      IF (IOPT(3:3) .EQ. '=') THEN
          OPT = IOPT(4:5)
      ELSE
          OPT = IOPT(5:6)
      ENDIF
C
C  'DEF' FLAG,  SET ALL OPTIONS TO DEFAULT VALUES
C
      IF (TAG .EQ. 'DE') THEN
C
C  SET DEFAULT FORMAT
C
        HORZNT = .FALSE.
        PERCNT = .TRUE.
        MIDVAL = .TRUE.
        SPACE = .TRUE.
        SHADE = .TRUE.
        DRAWL = .FALSE.
        MEDIAN = .FALSE.
	MVALU  = .FALSE.
        PERIM = .FALSE.
        HFRAME = .TRUE.
        LISTOP = .FALSE.
        WINDOW = .FALSE.
        HWIND(1) = 0.
        HWIND(2) = 1.
        HWIND(3) = 0.
        HWIND(4) = 1.
        COLORS = .FALSE.
        COLSHA = 1
        COLSH2 = 1
        COLREC = 1
        COLAXI = 1
        COLTEX = 1
        COLMED = 1
        COLTIT = 1
        COLPER = 1
        SETSPA = 2.
        SETSP2 = -1.
	NMVAL = .TRUE.
	PMVAL = .TRUE.
	SETMVA = -999.
	SETEPS = 1.E-10
        HSTFOR = .FALSE.
        STRFOR = '(G10.3)'
	STRTIT = ' '
	STRFRE = 'FREQUENCY'
	STRPER = 'PERCENT OCCURRENCE'
        TITLE = .FALSE.
        LABEL = .FALSE.
        FREQNC = .FALSE.
	PERTIT = .FALSE.
        CHARL = .FALSE.
        HEIGHT = 2
        ORIENT = 0
      RETURN
C
C  HORIZONTAL FLAG
C
      ELSEIF (TAG .EQ. 'HO') THEN
C
C  SWITCH = ON
C
          IF (OPT .EQ. 'ON') THEN
            HORZNT = .TRUE.
            RETURN
C
C  SWITCH = OFF
C
          ELSEIF (OPT .EQ. 'OF') THEN
            HORZNT = .FALSE.
            RETURN
          ELSE
                GOTO 900
          ENDIF
C
C  PERCENT FLAG
C
      ELSEIF (TAG .EQ. 'PE') THEN
C
C  SWITCH = ON
C
          IF (OPT .EQ. 'ON') THEN
            PERCNT = .TRUE.
            RETURN
C
C  SWITCH = OFF
C
          ELSEIF (OPT .EQ. 'OF') THEN
            PERCNT = .FALSE.
            RETURN
          ELSE
                GOTO 900
          ENDIF
C
C  MIDVALUE FLAG
C
      ELSEIF (TAG .EQ. 'MI') THEN
C
C  SWITCH = ON
C
          IF (OPT .EQ. 'ON') THEN
            MIDVAL = .TRUE.
           RETURN
C
C  SWITCH = OFF
C
          ELSEIF (OPT .EQ. 'OF') THEN
           MIDVAL = .FALSE.
           RETURN
          ELSE
                GOTO 900
          ENDIF
C
C  SHADE FLAG
C
      ELSEIF (TAG .EQ. 'SH') THEN
C
C  SWITCH ON
C
          IF (OPT .EQ. 'ON') THEN
            SHADE = .TRUE.
            RETURN
C
C  SWITCH OFF
C
          ELSEIF (OPT .EQ. 'OF') THEN
            SHADE = .FALSE.
            RETURN
          ELSE
                GOTO 900
          ENDIF
C
C  DRAWLINE FLAG
C
      ELSEIF (TAG .EQ. 'DR') THEN
C
C  SWITCH ON
C
          IF (OPT .EQ. 'ON') THEN
            DRAWL = .TRUE.
            RETURN
C
C  SWITCH OFF
C
          ELSEIF (OPT .EQ. 'OF') THEN
            DRAWL = .FALSE.
            RETURN
          ELSE
                GOTO 900
          ENDIF
C
C  MEDIAN FLAG
C
      ELSEIF (TAG .EQ. 'ME') THEN
C
C  SWITCH ON
C
          IF (OPT .EQ. 'ON') THEN
            MEDIAN = .TRUE.
            RETURN
C
C  SWITCH OFF
C
          ELSEIF (OPT .EQ. 'OF') THEN
            MEDIAN = .FALSE.
            RETURN
          ELSE
                GOTO 900
          ENDIF
C
C  PERIMETER FLAG
C
      ELSEIF (TAG .EQ. 'PR') THEN
C
C  SWITCH ON
C
          IF (OPT .EQ. 'ON') THEN
            PERIM = .TRUE.
            RETURN
C
C  SWITCH OFF
C
          ELSEIF (OPT .EQ. 'OF') THEN
            PERIM = .FALSE.
            RETURN
          ELSE
                GOTO 900
          ENDIF
C
C  FRAME FLAG
C
      ELSEIF (TAG .EQ. 'FR') THEN
C
C  SWITCH ON
C
          IF (OPT .EQ. 'ON') THEN
            HFRAME = .TRUE.
            RETURN
C
C  SWITCH OFF
C
          ELSEIF (OPT .EQ. 'OF') THEN
            HFRAME = .FALSE.
            RETURN
          ELSE
                GOTO 900
          ENDIF
C
C  Missing Value normalization flag
C
      ELSEIF (TAG .EQ. 'NM') THEN
C
C  SWITCH ON
C
          IF (OPT .EQ. 'ON') THEN
	    NMVAL = .TRUE.
            RETURN
C
C  SWITCH OFF
C
          ELSEIF (OPT .EQ. 'OF') THEN
	    NMVAL = .FALSE.
            RETURN
          ELSE
                GOTO 900
          ENDIF
C
C  Missing value print flag
C
      ELSEIF (TAG .EQ. 'PM') THEN
C
C  SWITCH ON
C
          IF (OPT .EQ. 'ON') THEN
	    PMVAL = .TRUE.
            RETURN
C
C  SWITCH OFF
C
          ELSEIF (OPT .EQ. 'OF') THEN
	    PMVAL = .FALSE.
            RETURN
          ELSE
                GOTO 900
          ENDIF
C
C  LIST OPTION GET VALUE OF SWITCH
C
      ELSEIF (TAG .EQ. 'LI') THEN
C
C  ON SET LIST OPTIONS FLAG
C
          IF (OPT .EQ. 'ON') THEN
            LISTOP = .TRUE.
              RETURN
C
C  TURN OFF LIST OPTIONS FLAG
C
          ELSEIF (OPT .EQ. 'OF') THEN
            LISTOP = .FALSE.
              RETURN
          ELSE
                GOTO 900
          ENDIF
      ELSE
          GOTO 900
      ENDIF
C
C  ERROR UNDEFINED OPTION DETECTED
C
 900  NERR = NERR + 1
      CALL SETER (' HSTOPL -- UNDEFINED OPTION',NERR,IREC)
      RETURN
C
      END

C
C	$Id: grinit.f,v 1.4 2008-07-27 12:23:43 haley Exp $
C                                                                      
C			     Copyright (C)  1997
C	     University Corporation for Atmospheric Research
C			     All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C

      SUBROUTINE GRINIT
C
C  Initializes COMMON data.
C
      COMMON /CAPIOB/ UNIT, IPTR, LSIZE, NFST, NFLG
      COMMON /CAPIO2/ LINE, GRNM
      INTEGER LNMAX
      PARAMETER (LNMAX=80)
      CHARACTER*80 LINE
      CHARACTER*80 GRNM
      INTEGER UNIT, IPTR, LSIZE, NFST, NFLG
      COMMON /CAPDEV/ DGISTR, DGISIZ, DGESTR, DGESIZ, DTISTR,
     1                DTISIZ, DCDLLX, DCDLLY, DCDURX, DCDURY,
     3                DCOAVL, CORFMT, CORFIN, BATCH , DHCSIZ,
     4                DHCSTR, CORXOF, CORYOF, DASBIT, CORXSC,
     5                CORYSC, VDWLLX, VDWLLY, VDWURX, VDWURY
      INTEGER         DGIMAX, DGEMAX, DTIMAX, DCFTMX, DHCMAX
      PARAMETER   (DGIMAX=300, DGEMAX=150, DTIMAX=100)
      PARAMETER   (DCFTMX=30 , DHCMAX=50)
      INTEGER         DGISTR(DGIMAX), DGISIZ, DGESTR(DGEMAX),
     1                DGESIZ, DTISTR(DTIMAX), DTISIZ, DCDLLX,
     2                DCDLLY, DCDURX, DCDURY, CORFMT(DCFTMX,4),
     3                CORFIN(8)     , DHCSIZ, DHCSTR(DHCMAX),
     4                CORXOF, CORYOF, DASBIT, VDWLLX, VDWLLY,
     5                VDWURX, VDWURY
      REAL            CORXSC, CORYSC, CORRIN(8)
      LOGICAL         DCOAVL, BATCH
C  Size of the COMMON
      INTEGER         LENDEV
      PARAMETER   (LENDEV=DGIMAX+1+DGEMAX+1+DTIMAX+1+4+1+4*DCFTMX+
     1                  8+2+DHCMAX+9)
      EQUIVALENCE (CORFIN,CORRIN)
      COMMON /CAPLIN/ PLAVBL, LDSSTR, LDSSIZ, LDTSTR, LDTSIZ,
     1                LMSSTR, LMSSIZ, LMTSTR, LMTSIZ, LCSSTR,
     2                LCSSIZ, LCTSTR, LCTSIZ, LINFIN, LINFMT,
     3                LWSSTR, LWSSIZ, LWTSTR, LWTSIZ, LWTFIN,
     4                LWTFMT, LWTRNG, LWTSCF, LBSSTR, LBSSIZ,
     5                LBTSTR, LBTSIZ, LPSSTR, LPSSIZ, LPTSTR,
     6                LPTSIZ
      INTEGER         LDSMAX, LDTMAX, LMSMAX, LMTMAX, LCSMAX,
     1                LCTMAX, LVCFMX, LWSMAX, LWTMAX, LWTFMX,
     2                LBSMAX, LBTMAX, LPSMAX, LPTMAX
      PARAMETER   (LDSMAX=30, LDTMAX=15, LMSMAX=30, LMTMAX=15,
     1             LCSMAX=30, LCTMAX=15, LVCFMX=8,  LWSMAX=30,
     2             LWTMAX=15, LWTFMX=8 , LBSMAX=30, LBTMAX=15,
     3             LPSMAX=20, LPTMAX=20)
      INTEGER         LDSSTR(LDSMAX), LDSSIZ, LDTSTR(LDTMAX),
     1                LDTSIZ, LMSSTR(LMSMAX), LMSSIZ,
     2                LMTSTR(LMTMAX), LMTSIZ, LCSSTR(LCSMAX),
     3                LCSSIZ, LCTSTR(LCTMAX), LCTSIZ, LINFIN(8),
     4                LINFMT(LVCFMX,4)      , LWSSTR(LWSMAX),
     5                LWSSIZ, LWTSTR(LWTMAX), LWTSIZ, LWTFIN(8),
     6                LWTFMT(LWTFMX,4)      , LWTRNG(2)     ,
     7                LBSSTR(LBSMAX), LBSSIZ, LBTSTR(LBTMAX),
     8                LBTSIZ, LPSSTR(LPSMAX), LPSSIZ,
     9                LPTSTR(LPTMAX), LPTSIZ
      LOGICAL         PLAVBL
      REAL            LWTSCF,LINRIN(8),LWTRIN(8)
      INTEGER         LENLIN
      PARAMETER   (LENLIN=1+LDSMAX+1+LDTMAX+1+LMSMAX+1+
     1             LMTMAX+1+LCSMAX+1+LCTMAX+1+8+LVCFMX*4+
     2             LWSMAX+1+LWTMAX+1+8+LWTFMX*4+2+1+LBSMAX+
     3             1+LBTMAX+1+LPSMAX+1+LPTMAX+1)
      EQUIVALENCE (LINFIN,LINRIN), (LWTFIN,LWTRIN)
      COMMON /CAPUSR/ UPRSTR, UPRSIZ
      INTEGER    UPRMAX
      PARAMETER (UPRMAX=80)
      INTEGER    UPRSTR(UPRMAX), UPRSIZ
      INTEGER    LENUSR
      PARAMETER (LENUSR=UPRMAX+1)
      COMMON /CAPCOL/ COLINT, COLIDX, IDXCUR, VDMINT, DMPAVL, COLFMT
     1               ,COLFIN, IDXMAX, MSTSTR, MSTSIZ, MTRSTR, DMPMDL
     2               ,MTRSIZ, DMPIDV, DMPFIN, DMPFMT
      INTEGER         MAPMAX, COLMAX, MSTMAX, MTRMAX, DMPMAX
      PARAMETER   (MAPMAX=256, COLMAX=15, MSTMAX=50, MTRMAX=20)
      PARAMETER   (DMPMAX=50)
      INTEGER         COLINT(MAPMAX*3)      , COLIDX(MAPMAX), IDXCUR,
     1                VDMINT, COLFMT(COLMAX,4)      , COLFIN(8)     ,
     2                IDXMAX, MSTSTR(MSTMAX), MSTSIZ, MTRSTR(MTRMAX),
     3                DMPMDL, MTRSIZ, DMPFIN(8)     , DMPFMT(DMPMAX,4)
      LOGICAL         DMPAVL, DMPIDV
      REAL            COLRIN(8),DMPRIN(8)
      INTEGER LENCOL
      PARAMETER   (LENCOL=MAPMAX*3+MAPMAX+1+1+1+COLMAX*4+8+1+MSTMAX+
     1                    1+MTRMAX+1+1+1+8+DMPMAX*4)
      EQUIVALENCE (COLFIN,COLRIN),(DMPFIN,DMPRIN)
      COMMON/CAPBND/PLBTEC, PLIBTB, PLTBTB, PLWBTB, PLCBTB,
     1              PMBTEC, PMIBTB, PMTBTB, PMSBTB, PMCBTB,
     2              TXBTEC, TXIBTB, TXFBTB, TXPBTB, TCXBTB,
     3              TCSBTB, TXCBTB, FABTEC, FAIBTB, FISBTB,
     4              FASBTB, FACBTB
      INTEGER       TBLSIZ
      PARAMETER (TBLSIZ=6)
      INTEGER PLBTEC,PLIBTB(TBLSIZ),PLTBTB(TBLSIZ),PLCBTB(TBLSIZ),
     1        PMBTEC,PMIBTB(TBLSIZ),PMTBTB(TBLSIZ),PMCBTB(TBLSIZ),
     2        TXBTEC,TXIBTB(TBLSIZ),TXFBTB(TBLSIZ),TXPBTB(TBLSIZ),
     3        TXCBTB(TBLSIZ),FACBTB(TBLSIZ),
     4        FABTEC,FAIBTB(TBLSIZ),FISBTB(TBLSIZ),FASBTB(TBLSIZ)
      REAL PLWBTB(TBLSIZ),PMSBTB(TBLSIZ),TCXBTB(TBLSIZ),TCSBTB(TBLSIZ)
      INTEGER LENBND
      PARAMETER (LENBND=4+18*TBLSIZ)
      COMMON /CAPTXT/ TCSSTR, TCSSIZ, TCTSTR, TCTSIZ, TXTFIN, TXTFMT,
     1                TXSSTR, TXSSIZ, TXTSTR, TXTSIZ
      INTEGER         TCSMAX, TCTMAX, TVCFMX, TXSMAX, TXTMAX
      PARAMETER (TCSMAX=10, TCTMAX=10, TVCFMX=5, TXSMAX=20, TXTMAX=20)
      INTEGER         TCSSTR(TCSMAX), TCSSIZ, TCTSTR(TCTMAX), TCTSIZ,
     1                TXTFIN(5)     , TXTFMT(TVCFMX,4)      ,
     2                TXSSTR(TXSMAX), TXSSIZ, TXTSTR(TXTMAX), TXTSIZ
      INTEGER         LENTXT
      PARAMETER (LENTXT=TCSMAX+1+TCTMAX+1+5+TVCFMX*4+TXSMAX+1+
     1                  TXTMAX+1)
      COMMON /CAPSCN/ SCSSTR, SCSSIZ, SCTSTR, SCTSIZ, SCNLLX,
     1                SCNLLY, SCNURX, SCNURY, SCNXOF, SCNYOF,
     2                SCNXSC, SCNYSC, SCNFMT, SCNFIN, SCVFMT,
     3                SCVFIN, SCNSIM
      INTEGER         SCSMAX, SCTMAX, SFMMAX, SFNMAX, SCVFMX,
     1                SCVFIX
      PARAMETER  (SCSMAX=50, SCTMAX=50, SFMMAX=10, SFNMAX=8)
      PARAMETER  (SCVFMX=10, SCVFIX=8)
      INTEGER         SCSSTR(SCSMAX), SCSSIZ, SCTSTR(SCTMAX), SCTSIZ,
     2                SCNLLX, SCNLLY, SCNURX, SCNURY, SCNXOF, SCNYOF,
     3                SCNFMT(SFMMAX,4)      , SCNFIN(SFNMAX),
     4                SCVFMT(SCVFMX,4)      , SCVFIN(SCVFIX)
      REAL            SCNXSC, SCNYSC, SCNRIN(SFNMAX), SCVRIN(SCVFIX)
      LOGICAL         SCNSIM
      INTEGER         LENSCN
      PARAMETER  (LENSCN=SCSMAX+1+SCTMAX+1+1+1+1+1+1+1+1+1+
     1                   (SFMMAX*4)+SFNMAX+(SCVFMX*4)+SCVFIX+1)
      EQUIVALENCE (SCNFIN,SCNRIN), (SCVFIN,SCVRIN)
      COMMON /CAPSPC/ DUMSPC,ENDDSP
      INTEGER     DUMSIZ,DUMSM1
      PARAMETER (DUMSIZ=327, DUMSM1=DUMSIZ-1)
      INTEGER     DUMSPC(DUMSM1),ENDDSP
      COMMON /CAPPLG/ PCSSTR, PCSSIZ, PCTSTR, PCTSIZ, PLSSTR,
     1                PLSSIZ, PLTSTR, PLTSIZ, PBSSTR, PBSSIZ,
     2                PBTSTR, PBTSIZ, PHATSP, PMAXPT, PPSSTR,
     3                PPSSIZ, PPTSTR, PPTSIZ, PLGSIM, PSIMSP,
     4                PSIMTR
      INTEGER         PCSMAX, PCTMAX, PLSMAX, PLTMAX, PBSMAX,
     1                PBTMAX, PPSMAX, PPTMAX
      PARAMETER   (PCSMAX=20, PCTMAX=15, PLSMAX=40, PLTMAX=20)
      PARAMETER   (PBSMAX=30, PBTMAX=15, PPSMAX=20, PPTMAX=20)
      INTEGER         PCSSTR(PCSMAX), PCSSIZ, PCTSTR(PCTMAX), PCTSIZ,
     1                PLSSTR(PLSMAX), PLSSIZ, PLTSTR(PLTMAX), PLTSIZ,
     2                PBSSTR(PBSMAX), PBSSIZ, PBTSTR(PBTMAX), PBTSIZ,
     3                PHATSP, PMAXPT, PPSSTR(PPSMAX), PPSSIZ,
     4                PPTSTR(PPTMAX), PPTSIZ, PSIMSP, PSIMTR
      LOGICAL         PLGSIM
      INTEGER         LENPLG
      PARAMETER   (LENPLG=PCSMAX+1+PCTMAX+1+PLSMAX+1+PLTMAX+1+
     1                    PBSMAX+1+PBTMAX+1+1+1+PPSMAX+1+PPTMAX+
     2                    1+1+1+1)
      COMMON /CAPMAR/ MCSSTR, MCSSIZ, MCTSTR, MCTSIZ, MARFIN, MARFMT,
     1                MRSSTR, MRSSIZ, MRTSTR, MRTSIZ, MDOTSZ
      INTEGER         MCSMAX, MCTMAX, MVCFMX, MRSMAX, MRTMAX
      PARAMETER (MCSMAX=30, MCTMAX=15, MVCFMX=5, MRSMAX=20, MRTMAX=10)
      INTEGER         MCSSTR(MCSMAX), MCSSIZ, MCTSTR(MCTMAX), MCTSIZ,
     1                MARFIN(5)     , MARFMT(MVCFMX,4)      ,
     2                MRSSTR(MRSMAX), MRSSIZ, MRTSTR(MRTMAX), MRTSIZ,
     3                MDOTSZ
      INTEGER         LENMAR
      PARAMETER (LENMAR=MCSMAX+1+MCTMAX+1+5+MVCFMX*4+MRSMAX+1+
     1           MRTMAX+1+1)
C
C  Equivalences for initializing common entries to zero.
C
      INTEGER   ZRODEV(LENDEV)
      INTEGER   ZROLIN(LENLIN)
      INTEGER   ZROUSR(LENUSR)
      INTEGER   ZROCOL(LENCOL)
      INTEGER   ZROTXT(LENTXT)
      INTEGER   ZROMAR(LENMAR)
      INTEGER   ZROPLG(LENPLG)
      INTEGER   ZROBND(LENBND)
      INTEGER   ZROSCN(LENSCN)
      EQUIVALENCE (DGISTR,ZRODEV)
      EQUIVALENCE (PLAVBL,ZROLIN)
      EQUIVALENCE (UPRSTR,ZROUSR)
      EQUIVALENCE (COLINT,ZROCOL)
      EQUIVALENCE (TCSSTR,ZROTXT)
      EQUIVALENCE (MCSSTR,ZROMAR)
      EQUIVALENCE (PCSSTR,ZROPLG)
      EQUIVALENCE (PLBTEC,ZROBND)
      EQUIVALENCE (SCSSTR,ZROSCN)
C
C  Initialize local processor variables.
C
      NFST = 1
      NFLG = 0
      GRNM = ' '
C
C  Zero out commons (REAL and LOGICAL variables will be zeroed out
C  separately after all integers are zeroed.
C
      DO 10 I=1,LENDEV
      ZRODEV(I) = 0
   10 CONTINUE
C
      DO 20 I=1,LENLIN
      ZROLIN(I) = 0
   20 CONTINUE
C
      DO 30 I=1,LENUSR
      ZROUSR(I) = 0
   30 CONTINUE
C
      DO 40 I=1,LENCOL
      ZROCOL(I) = 0
   40 CONTINUE
C
      DO 50 I=1,LENTXT
      ZROTXT(I) = 0
   50 CONTINUE
C
      DO 60 I=1,LENMAR
      ZROMAR(I) = 0
   60 CONTINUE
C
      DO 70 I=1,LENPLG
      ZROPLG(I) = 0
   70 CONTINUE
C
      DO 80 I=1,LENBND
      ZROBND(I) = 0
   80 CONTINUE
C
      DO 90 I=1,LENSCN
      ZROSCN(I) = 0
   90 CONTINUE
C
C  Variables requiring individaul attention in CAPDEV.
C
      DCOAVL = .FALSE.
      BATCH  = .FALSE.
      DASBIT = 100
      CORXSC = 1.0
      CORYSC = 1.0
      VDWLLX =     0
      VDWLLY =     0
      VDWURX = 32767
      VDWURY = 32767
      CORRIN(5) = 0.
      CORRIN(6) = 0.
      CORRIN(7) = 0.
      CORRIN(8) = 0.
C
C  Variables requiring individaul attention in CAPLIN.
C
      PLAVBL = .FALSE.
      LINRIN(5) = 0.
      LINRIN(6) = 0.
      LINRIN(7) = 0.
      LINRIN(8) = 0.
      LWTRNG(1) = 1
      LWTRNG(2) = 1
      LWTSCF    = 1.
C
C  Variables requiring individaul attention in CAPCOL.
C
      DMPAVL = .FALSE.
      COLRIN(5) = 0.
      COLRIN(6) = 0.
      COLRIN(7) = 0.
      COLRIN(8) = 0.
      IDXMAX = -1
      DMPMDL =  1
      DMPIDV = .FALSE.
      DMPRIN(5) = 0.
      DMPRIN(6) = 0.
      DMPRIN(7) = 0.
      DMPRIN(8) = 0.
C
C  Variables requiring individaul attention in CAPPLG.
C
      PHATSP = 300
      PMAXPT = 32767
      PLGSIM = .TRUE.
C
C  Variables requiring individaul attention in CAPBND.
C
      PLBTEC = -1
      PMBTEC = -1
      TXBTEC = -1
      FABTEC = -1
C
C  Variables requiring individaul attention in CAPSCN.
C
      SCNRIN(5) = 0.
      SCNRIN(6) = 0.
      SCNRIN(7) = 0.
      SCNRIN(8) = 0.
      SCVRIN(5) = 0.
      SCVRIN(6) = 0.
      SCVRIN(7) = 0.
      SCVRIN(8) = 0.
      SCNSIM = .FALSE.
      SCNXSC = 1.
      SCNYSC = 1.
C
      RETURN
      END

      PROGRAM CCPSPS2
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER (M=20,N=30,LRWK=3500,LIWK=3500,LZRG=2000)
      REAL X(M), Y(N), Z(M,N), ZREG(LZRG), RWRK(LRWK)
      INTEGER IWRK(LIWK)
      DATA X /  1.,  2.,  3.,  5.,  7., 11., 13., 17., 19., 23.,
     +     29., 31., 37., 41., 43., 47., 53., 59., 61., 67./

      CALL GETDAT (X, Y, Z, M, N) 
C
C Open GKS
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Turn clipping off
C
      CALL GSCLIP(0)
C
C Limit viewport so there's room to mark the data points
C
      CALL CPSETR('VPR',.8)
C
C Initialize Conpack
C
      CALL CPSPS2(X,Y,Z,M,M,N,RWRK,LRWK,IWRK,LIWK,ZREG,LZRG)
C
C Draw perimiter
C
      CALL CPBACK(ZREG, RWRK, IWRK)
C
C Draw Contours
C
      CALL CPCLDR(ZREG,RWRK,IWRK)
C
C Mark data points
C
      CALL MARK (X,Y,M,N)
C
C Close frame and close GKS
C
      CALL FRAME
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS

      STOP
      END

      SUBROUTINE GETDAT (X, Y, Z, M, N)
      INTEGER I,J,M,N
      REAL X(M), Y(N), Z(M,N)
C
C X and Y data locations must be in increasing order.
C
      Y(1)=1.
      DO 10, I=2,N
         Y(I) = 1.1*Y(I-1) + 1./REAL(I)
 10   CONTINUE

      DO 30, I=1,M
         DO 40, J=1,N
            Z(I,J)= 10.E-5*(-16.*REAL(X(I)**2*Y(J)) +
     +            34*REAL(X(I)*Y(J)**2) - REAL(6*X(I)) + 93.)
 40      CONTINUE
 30   CONTINUE

      RETURN
      END

      SUBROUTINE MARK (X, Y, M, N)

      REAL X(M), Y(N)
      INTEGER I, J

      CALL GSMKSC(.5)

      DO 11 I=1,M
         DO 21 J=1,N
            CALL POINTS (X(I), Y(J), 1, -4, 0)
 21      CONTINUE
 11   CONTINUE

      RETURN
      END

C
C $Id: set3.f,v 1.7 2008-07-27 00:17:34 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE SET3 (XA,XB,YA,YB,ULO,UHI,VLO,VHI,WLO,WHI,EYE)
C
C THREE-DIMENSIONAL LINE DRAWING PACKAGE
C
C
C PURPOSE                THREED is a package of subroutines that
C                        provides line drawing capabilities in
C                        three-space.
C
C USAGE                  Each entry point in this package is
C                        described below.
C
C                        SET3 (XA,XB,YA,YB,UC,UD,VC,VD,WC,WD,EYE)
C
C                          XA, XB, YA, YB  define the portion of the
C                          plotting surface into which the user's
C                          plot will be placed.  These values should
C                          be in the range 0. to 1.  For example, if
C                          one wants the plot to occupy the maximum
C                          plotting surface, set XA=0., YA=0., XB=1.,
C                          YB=1.; if one wants the plot to appear in
C                          the lower left corner of the plotting
C                          surface, set XA=0., YA=0., XB=.5, YB=.5 .
C
C                          UC, UD, VC, VD, WC, and WD define a
C                          volume in user-coordinate space which
C                          will be transformed onto the plotting
C                          surface defined by XA, XB, YA, YB.
C
C                          EYE is an array, 3 words long, containing the
C                          U, V, and W coordinates of the EYE position.
C                          All lines in the plot are drawn as viewed
C                          from the EYE.  EYE is specified in user
C                          coordinates and should be outside the box
C                          defined by UC, UD, VC, VD, WC, and WD.
C
C                        CURVE3 (U,V,W,N)
C
C                          Draws a curve through N points.  The
C                          points are defined by the linear arrays
C                          U, V, and W which are dimensioned N or
C                          greater.
C
C                        LINE3 (UA,VA,WA,UB,VB,WB)
C
C                          Draws a line connecting the coordinates
C                          (UA,VA,WA)  and  (UB,VB,WB).
C
C                        FRST3 (U,V,W)
C
C                          Positions the pen to (U,V,W).
C
C                        VECT3 (U,V,W)
C
C                          Draws a line between the current pen
C                          position and the point (U,V,W).  The
C                          current pen position becomes (U,V,W).
C                          Note that a curve can be drawn by using
C                          a FRST3 call followed by a sequence of
C                          VECT3 calls.
C
C                        POINT3 (U,V,W)
C
C                          Plots a point at (U,V,W) .
C
C                        PERIM3 (MAGR1,MINR1,MAGR2,MINR2,IWHICH,VAR)
C
C                          Draws a perimeter with tick marks.
C
C                          IWHICH designates the normal vector to the
C                          perimeter drawn (1=U, 2=V, 3=W).
C
C                          VAR is the value on the axis specified by
C                          IWHICH where the perimeter is to be drawn.
C
C                          MAGR1  and  MAGR2  specify the
C                          number of major tick marks to be drawn in
C                          the two coordinate directions.
C
C                          MINR1  and  MINR2  specify the number
C                          of minor ticks between each major tick.
C
C                          MAGR1, MAGR2, MINR1 and MINR2
C                          are specified by the number
C                          of divisions(holes), not the number of
C                          ticks.  So if MAGR1=1, there would be no
C                          major divisions.
C
C                        TICK43 (MAGU,MINU,MAGV,MINV,MAGW,MINW)
C
C                          TICK43 allows program control of tick
C                          mark length in subroutine PERIM3.
C                          MAGU, MAGV, MAGW specify the length,
C                          in plotter address units of major
C                          division tick marks on the U, V, and W
C                          axes.  MINU, MINV, MINW specify the length,
C                          in plotter address units of minor
C                          division tick marks on the U, V, and
C                          W axes.
C
C                        FENCE3 (U,V,W,N,IOREN,BOT)
C
C                          This entry is used to draw a line in three-
C                          space as well as a "fence" between the
C                          line and a plane normal to one of the
C                          coordinate axes.
C
C                          The arguments U, V, W and N
C                          are the same as for CURVE3, described above.
C
C                          IOREN specifies the direction in which the
C                          fence lines are to be drawn (1 indicates
C                          parallel to the U-axis, 2 indicates parallel
C                          to the V-axis, and 3 indicates parallel to
C                          to the W-axis.)
C
C                          BOT specifies where the bottom of the fence
C                          is to be drawn.
C                          If the fence lines are to be drawn parallel
C                          to the W-axis, and  BOT=2., then the bottom
C                          of the fence would be the plane  W=2.
C
C ON OUTPUT              All arguments are unchanged.
C
C NOTE                   .  For drawing characters in conjunction
C                           with THREED, use the companion routine
C                           PWRZT.
C
C ENTRY POINTS          FENCE3, TRN32T, FRST3, VECT3, LIN3,
C                       POINT3, CURVE3, PSYM3, PERIM3, LINE3W,
C                       DRAWT, TICK43, TICK3, THREBD, THREBDX
C
C COMMON BLOCKS         TEMPRT, SET31, PWRZ1T, TCK31, PRM31, THRINT
C
C REQUIRED LIBRARY      PWRZ and the SPPS
C ROUTINES
C
C REQUIRED GKS LEVEL    0A
C
C HISTORY               Written and standardized in November 1973.
C I/O                   Plots lines.
C
C PRECISION             Single
C
C LANGUAGE              FORTRAN
C
C ACCURACY              + or -.5 plotter address units per call.
C                       There is no cumulative error.
C
C PORTABILITY           ANSI FORTRAN 77
C
C
C
C
C
      SAVE
C
      COMMON /TEMPRT/ RZERO
C
      DIMENSION       EYE(3)
C
      COMMON /SET31/  ISCALE     ,XMIN       ,XMAX       ,YMIN       ,
     1                YMAX       ,BIGD       ,R0         ,NLX        ,
     2                NBY        ,NRX        ,NTY
      COMMON /PWRZ1T/ UUMIN      ,UUMAX      ,VVMIN      ,VVMAX      ,
     1                WWMIN      ,WWMAX      ,DELCRT     ,EYEU       ,
     2                EYEV       ,EYEW
C
      AVE(A,B) = (A+B)*.5
C
C ARITHMETIC STATEMENT FUNCTION FOR SCALING
C
      SU(UTEMP) = UTEMP
      SV(VTEMP) = VTEMP
      SW(WTEMP) = WTEMP
C
C  Do a call forcing a BLOCKDATA to be loaded from a binary library.
C
      CALL THREBD
C
C SET UP FRAME SIZE
C
      NLX = XA*1023.+1.
      NRX = XB*1023.+1.
      NBY = YA*1023.+1.
      NTY = YB*1023.+1.
C
C CONSTANTS FOR PWRZT
C
      UUMIN = ULO
      UUMAX = UHI
      VVMIN = VLO
      VVMAX = VHI
      WWMIN = WLO
      WWMAX = WHI
      EYEU = EYE(1)
      EYEV = EYE(2)
      EYEW = EYE(3)
C
C FIND CORNERS IN 2-SPACE FOR 3-SPACE BOX CONTAINING OBJECT
C
      ISCALE = 0
      ATU = AVE(SU(UUMIN),SU(UUMAX))
      ATV = AVE(SV(VVMIN),SV(VVMAX))
      ATW = AVE(SW(WWMIN),SW(WWMAX))
      BIGD = 0.
      IF (RZERO .LE. 0.) GO TO  10
C
C RELATIVE SIZE FEATURE IN USE.  THIS SECTION OF CODE IS NEVER
C EXECUTED UNLESS RZERO IS SET POSITIVE IN THE CALLING PROGRAM
C VIA COMMON BLOCK TEMPRT.  RZERO  IS THE DISTANCE BETWEEN THE
C OBSERVER AND THE POINT LOOKED AT (CENTER OF THE BOX BY DEFAULT)
C WHEN THE INPUT BOX IS TO FILL THE SCREEN WHEN VIEWED FROM THE
C DIRECTION WHICH MAKES THE BOX BIGGEST.  RZERO  IS THUS TO
C BE USED TO DETERMINE THE SHAPE OF THE OBJECT.   THIS SECTION
C OF CODE IS TO BE USED WHEN IT IS DESIRED TO KEEP THE VIEWED
C OBJECT IN RELATIVE PERSPECTIVE ACROSS FRAMES--E.G. IN MAKING
C MOVIES.
C
      ALPHA = -(VVMIN-ATV)/(UUMIN-ATU)
      VVEYE = -RZERO/SQRT(1.+ALPHA*ALPHA)
      UUEYE = VVEYE*ALPHA
      VVEYE = VVEYE+ATV
      UUEYE = UUEYE+ATU
      WWEYE = ATW
      CALL TRN32T (ATU,ATV,ATW,UUEYE,VVEYE,WWEYE,1)
      CALL TRN32T (UUMIN,VVMIN,ATW,XMIN,DUMM,DUMM,2)
      CALL TRN32T (UUMAX,VVMIN,WWMIN,DUMM,YMIN,DUMM,2)
      CALL TRN32T (UUMAX,VVMAX,ATW,XMAX,DUMM,DUMM,2)
      CALL TRN32T (UUMAX,VVMIN,WWMAX,DUMM,YMAX,DUMM,2)
      BIGD = SQRT((UUMAX-UUMIN)**2+(VVMAX-VVMIN)**2+(WWMAX-WWMIN)**2)*.5
      R0 = RZERO
      GO TO  20
   10 CALL TRN32T (ATU,ATV,ATW,EYE(1),EYE(2),EYE(3),1)
      CALL TRN32T (SU(UUMIN),SV(VVMIN),SW(WWMIN),X1,Y1,DUM,2)
      CALL TRN32T (SU(UUMIN),SV(VVMIN),SW(WWMAX),X2,Y2,DUM,2)
      CALL TRN32T (SU(UUMIN),SV(VVMAX),SW(WWMIN),X3,Y3,DUM,2)
      CALL TRN32T (SU(UUMIN),SV(VVMAX),SW(WWMAX),X4,Y4,DUM,2)
      CALL TRN32T (SU(UUMAX),SV(VVMIN),SW(WWMIN),X5,Y5,DUM,2)
      CALL TRN32T (SU(UUMAX),SV(VVMIN),SW(WWMAX),X6,Y6,DUM,2)
      CALL TRN32T (SU(UUMAX),SV(VVMAX),SW(WWMIN),X7,Y7,DUM,2)
      CALL TRN32T (SU(UUMAX),SV(VVMAX),SW(WWMAX),X8,Y8,DUM,2)
      XMIN = MIN(X1,X2,X3,X4,X5,X6,X7,X8)
      XMAX = MAX(X1,X2,X3,X4,X5,X6,X7,X8)
      YMIN = MIN(Y1,Y2,Y3,Y4,Y5,Y6,Y7,Y8)
      YMAX = MAX(Y1,Y2,Y3,Y4,Y5,Y6,Y7,Y8)
C
C ADD RIGHT AMOUNT TO KEEP PICTURE SQUARE
C
   20 WIDTH = XMAX-XMIN
      HIGHT = YMAX-YMIN
      DIF = .5*(WIDTH-HIGHT)
      IF (DIF)  30, 50, 40
   30 XMIN = XMIN+DIF
      XMAX = XMAX-DIF
      GO TO  50
   40 YMIN = YMIN-DIF
      YMAX = YMAX+DIF
   50 ISCALE = 1
      CALL TRN32T (ATU,ATV,ATW,EYE(1),EYE(2),EYE(3),1)
      RETURN
      END

C
C	$Id: gpolat.f,v 1.4 2008-07-27 00:20:58 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
        SUBROUTINE GPOLAT(IOS,STATUS)
C
C  Set POLYLINE attributes.
C
C  Valid attributes:
C    POLYLINE INDEX
C    LINE TYPE
C    LINE WIDTH
C    LINE COLOR
C
      include 'trcode.h'
      include 'trinst.h'
      include 'trstat.h'
      include 'trpars.h'
C
      INTEGER IOS, STATUS
C
      IF (OPID .EQ. ATELLI) THEN
C
C  POLYLINE BUNDLE INDEX
C
        CALL GOPDEC(POLIDX,MIXCPR,1,IOS,STATUS)
        CALL GSPLI(POLIDX)
      ELSE IF (OPID .EQ. ATELLT) THEN
C
C  LINE TYPE
C
        CALL GOPDEC(LINTYP,MIXCPR,1,IOS,STATUS)
        CALL GSLN(LINTYP)
      ELSE IF (OPID .EQ. ATELLW) THEN
C
C  LINE WIDTH
C
        CALL GTFLT(LINWTH,MFLCPR,IOS,STATUS)
        CALL GSLWSC(LINWTH)
      ELSE IF (OPID .EQ. ATELLC) THEN
C
C  LINE COLOR
C
        CALL GOPDEC(LINCOL,MCICPR,1,IOS,STATUS)
        CALL GSPLCI(LINCOL)
      ENDIF
C
      RETURN
      END

C
C	$Id: gtxdrw.f,v 1.4 2008-07-27 00:21:03 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GTXDRW(IOS,STATUS)
C
C  Process TEXT elements.
C
      include 'trpars.h'
      include 'trinst.h'
      include 'gkscom.h'
C
C  Number of characters used in the text instruction
C
      INTEGER MAXCHR
      PARAMETER (MAXCHR=256)
      INTEGER IOS, STATUS
      INTEGER X, Y, SCHAR(MAXCHR), LLEN, FFLAG, CCONT, CMORE, CLEFT
      CHARACTER*256 ACHAR
C
      CMORE = 0
      STATUS = 0
C
C  Get the text coordinate position.
C
   10 CONTINUE
      CALL GOPDEC(X,MOPLEN,1,IOS,STATUS)
      IF (STATUS .NE. 0) RETURN
      CALL GOPDEC(Y,MOPLEN,1,IOS,STATUS)
      IF (STATUS .NE. 0) RETURN
C
C  Final flag.
C
      CALL GOPDEC(FFLAG,MENCPR,1,IOS,STATUS)
      IF (STATUS .NE. 0) RETURN
      LLEN = LEN - (MOPLEN*2 + MENCPR) / 8
   20 CONTINUE
C
C  20 Loop for string packets
C
C  Read in the character count.
C
      CALL GOPDEC(CCONT,8,1,IOS,STATUS)
      LLEN = LLEN - 1
      IF (CCONT .EQ. 255) THEN
C
C  Long format, read in string continue and string count.
C
        IF (STATUS .NE. 0) RETURN
        CALL GOPDEC(CMORE,1,1,IOS,STATUS)
        IF (STATUS .NE. 0) RETURN
        CALL GOPDEC(CCONT, 15, 1, IOS, STATUS)
        LLEN = LLEN - 2
      END IF
      IF (STATUS .NE. 0) RETURN
C
C  Round characters used, to the size of the internal buffer, SCHAR.
C
      CLEFT = 0
      IF (CCONT .GT. MAXCHR) THEN
        CLEFT = CCONT - MAXCHR
        CCONT = MAXCHR
      END IF
C
C  Read in the character string.
C
      CALL GOPDEC(SCHAR,8,CCONT,IOS,STATUS)
      IF (STATUS .NE. 0) RETURN
      LEN = LLEN - CCONT
C
C  Send out the characters.
C
      IF (CCONT .GT. 0) THEN
C
C  Convert to ASCII characters.
C
        ACHAR = ' '
        DO 30 J=1,CCONT
          ACHAR(J:J) = CHAR(SCHAR(J))
   30   CONTINUE
        XTMP = REAL(X)/32767.
        YTMP = REAL(Y)/32767.
C
C  Transform the text coordinate using the current segment transform.
C
        XN = CURTM(1,1)*XTMP+CURTM(1,2)*YTMP+CURTM(1,3)
        YN = CURTM(2,1)*XTMP+CURTM(2,2)*YTMP+CURTM(2,3)
        CALL GTX(XN,YN,ACHAR(1:CCONT))
      ENDIF
      IF (STATUS.NE.0) RETURN
C
C  Dump any characters left over.
C
      CALL GSKPOP(8, CLEFT, IOS, STATUS)
      IF (STATUS .NE. 0) RETURN
C
C  If string continued get the next packet.
C
      IF (CMORE .EQ. 1) GO TO 20
C
C  If continued, get the next part.
C
      IF (CNTINU) THEN
        CALL GNPART(IOS,STATUS)
        IF (STATUS .NE. 0) RETURN
        GO TO 10
      END IF
C
      RETURN
      END

C
C $Id: cmuy.f,v 1.7 2008-07-27 00:17:23 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      FUNCTION CMUY (IY)
C
C Given a Y coordinate IY in the metacode system, CMUY(IY) is a Y
C coordinate in the user system.
C
      COMMON /IUTLCM/ LL,MI,MX,MY,IU(96)
      SAVE /IUTLCM/
      DIMENSION WD(4),VP(4)
      CALL GQCNTN (IE,NT)
      IF (IE.NE.0) THEN
        CALL SETER ('CMUY - ERROR EXIT FROM GQCNTN',1,1)
        CMUY=0.
        RETURN
      END IF
      CALL GQNT (NT,IE,WD,VP)
      IF (IE.NE.0) THEN
        CALL SETER ('CMUY - ERROR EXIT FROM GQNT',2,1)
        CMUY=0.
        RETURN
      END IF
      I=3
      IF (MI.EQ.2.OR.MI.GE.4) I=4
      CMUY=WD(I)+(REAL(IY)/32767.-VP(3))/(VP(4)-VP(3))*(WD(7-I)-WD(I))
      IF (LL.EQ.2.OR.LL.GE.4) CMUY=10.**CMUY
      RETURN
      END

      PROGRAM WMEX09
C
C  A chart of wind speeds.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER (T1=0.90, T2=0.84)
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
      CALL GSCR(IWKID,0,1.,1.,1.)
      CALL GSCR(IWKID,1,0.,0.,0.)
      CALL GSCR(IWKID,2,.4,0.,.4)
C
C  Example 01 - chart of wind barbs for various speeds.
C
      CALL PERIM(1,1,1,1)
      CALL LINE(0.000, T1+0.005, 1.000, T1+0.005)
      CALL LINE(0.000, T1-0.005, 1.000, T1-0.005)
      CALL LINE(0.000, T2, 1.000, T2)
      CALL LINE(0.495, 0.000, 0.495, T1-0.005)
      CALL LINE(0.505, 0.000, 0.505, T1-0.005)
C
      CALL PLCHHQ(0.5,0.955,':F25:Wind Speeds',.03,0.,0.)
      CALL PCSETI('FN',21)
      XCL = 0.12
      XCC = 0.26
      XCR = 0.40
      DO 10 I=1,2
        XL = XCL+(I-1)*0.5
        XC = XCC+(I-1)*0.5
        XR = XCR+(I-1)*0.5
        CALL PLCHHQ(XL,0.87,'Symbol',0.022,0.,0.) 
        CALL PLCHHQ(XC,0.87,'Knots',0.022,0.,0.) 
        CALL PLCHHQ(XR,0.87,'Miles/hr.',0.022,0.,0.) 
   10 CONTINUE
      FINC = T2/10.
      SIZE = 0.022
      XCL = 0.16
      CALL GSLWSC(3.)
      CALL NGSETI('WO',1)
      CALL NGSETI('CA',0)
C
      P1 = T2-0.75*FINC
      CALL WMSETR('WBS',0.1)
      CALL WMSETI('COL',1)
      CALL WMGETR('WBS',WSLEN)
      CALL WMBARB(XCL-0.5*WSLEN,P1-0.5*SIZE,0.,0.)
      CALL PLCHHQ(XCC,P1,'Calm',SIZE,0.,0.)
      CALL PLCHHQ(XCR,P1,'Calm',SIZE,0.,0.)
C
      P1 = P1-FINC
      CALL WMBARB(XCL,P1-0.5*SIZE,-1.,0.)
      CALL PLCHHQ(XCC,P1,'1-2',SIZE,0.,0.)
      CALL PLCHHQ(XCR,P1,'1-2',SIZE,0.,0.)
C
      P1 = P1-FINC
      CALL WMBARB(XCL,P1-0.5*SIZE,-5.,0.)
      CALL PLCHHQ(XCC,P1,'3-7',SIZE,0.,0.)
      CALL PLCHHQ(XCR,P1,'3-8',SIZE,0.,0.)
C
      P1 = P1-FINC
      CALL WMBARB(XCL,P1-0.5*SIZE,-10.,0.)
      CALL PLCHHQ(XCC,P1,'8-12',SIZE,0.,0.)
      CALL PLCHHQ(XCR,P1,'9-14',SIZE,0.,0.)
C
      P1 = P1-FINC
      CALL WMBARB(XCL,P1-0.5*SIZE,-15.,0.)
      CALL PLCHHQ(XCC,P1,'13-17',SIZE,0.,0.)
      CALL PLCHHQ(XCR,P1,'15-20',SIZE,0.,0.)
C
      P1 = P1-FINC
      CALL WMBARB(XCL,P1-0.5*SIZE,-20.,0.)
      CALL PLCHHQ(XCC,P1,'18-22',SIZE,0.,0.)
      CALL PLCHHQ(XCR,P1,'21-25',SIZE,0.,0.)
C
      P1 = P1-FINC
      CALL WMBARB(XCL,P1-0.5*SIZE,-25.,0.)
      CALL PLCHHQ(XCC,P1,'23-27',SIZE,0.,0.)
      CALL PLCHHQ(XCR,P1,'26-31',SIZE,0.,0.)
C
      P1 = P1-FINC
      CALL WMBARB(XCL,P1-0.5*SIZE,-30.,0.)
      CALL PLCHHQ(XCC,P1,'28-32',SIZE,0.,0.)
      CALL PLCHHQ(XCR,P1,'32-37',SIZE,0.,0.)
C
      P1 = P1-FINC
      CALL WMBARB(XCL,P1-0.5*SIZE,-35.,0.)
      CALL PLCHHQ(XCC,P1,'33-37',SIZE,0.,0.)
      CALL PLCHHQ(XCR,P1,'38-43',SIZE,0.,0.)
C
      XCL = XCL+0.5
      XCC = XCC+0.5
      XCR = XCR+0.5
      P1 = T2-0.75*FINC
      CALL WMBARB(XCL,P1-0.5*SIZE,-40.,0.)
      CALL PLCHHQ(XCC,P1,'38-42',SIZE,0.,0.)
      CALL PLCHHQ(XCR,P1,'44-49',SIZE,0.,0.)
C
      P1 = P1-FINC
      CALL WMBARB(XCL,P1-0.5*SIZE,-45.,0.)
      CALL PLCHHQ(XCC,P1,'43-47',SIZE,0.,0.)
      CALL PLCHHQ(XCR,P1,'50-54',SIZE,0.,0.)
C
      P1 = P1-FINC
      CALL WMBARB(XCL,P1-0.5*SIZE,-50.,0.)
      CALL PLCHHQ(XCC,P1,'48-52',SIZE,0.,0.)
      CALL PLCHHQ(XCR,P1,'55-60',SIZE,0.,0.)
C
      P1 = P1-FINC
      CALL WMBARB(XCL,P1-0.5*SIZE,-55.,0.)
      CALL PLCHHQ(XCC,P1,'53-57',SIZE,0.,0.)
      CALL PLCHHQ(XCR,P1,'61-66',SIZE,0.,0.)
C
      P1 = P1-FINC
      CALL WMBARB(XCL,P1-0.5*SIZE,-60.,0.)
      CALL PLCHHQ(XCC,P1,'58-62',SIZE,0.,0.)
      CALL PLCHHQ(XCR,P1,'67-71',SIZE,0.,0.)
C
      P1 = P1-FINC
      CALL WMBARB(XCL,P1-0.5*SIZE,-65.,0.)
      CALL PLCHHQ(XCC,P1,'63-67',SIZE,0.,0.)
      CALL PLCHHQ(XCR,P1,'72-77',SIZE,0.,0.)
C
      P1 = P1-FINC
      CALL WMBARB(XCL,P1-0.5*SIZE,-70.,0.)
      CALL PLCHHQ(XCC,P1,'68-72',SIZE,0.,0.)
      CALL PLCHHQ(XCR,P1,'78-83',SIZE,0.,0.)
C
      P1 = P1-FINC
      CALL WMBARB(XCL,P1-0.5*SIZE,-75.,0.)
      CALL PLCHHQ(XCC,P1,'73-77',SIZE,0.,0.)
      CALL PLCHHQ(XCR,P1,'84-89',SIZE,0.,0.)
C
      P1 = P1-FINC
      CALL WMBARB(XCL,P1-0.5*SIZE,-105.,0.)
      CALL PLCHHQ(XCC,P1,'103-107',SIZE,0.,0.)
      CALL PLCHHQ(XCR,P1,'119-123',SIZE,0.,0.)
C
      CALL FRAME
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END

C
C $Id: tdlbla.f,v 1.5 2008-07-27 00:17:32 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE TDLBLA (IAXS,ILBL,NLBL,XAT0,XAT1,YAT0,YAT1,ANGD)
C
        CHARACTER*(*) ILBL,NLBL
C
C This routine is called to put labels on a particular edge of a box.
C It is assumed that TDPARA has been called to define a rectangle in
C 3-space lying in one corner of one face of the box being labelled.
C The sides of this rectangle are assumed to be vectors of length 1,
C (that is to say, the rectangle defines a unit square within that
C face of the box).  The arguments are as follows:
C
C   IAXS is an input integer saying which edge of the face is being
C   labelled (1 => left, 2 => right, 3 => bottom, and 4 => top).  The
C   meaning of "left", "right", "bottom", and "top" are defined by the
C   orientation of the rectangle defined by the last call to TDPARA.
C
C   ILBL is an input character string to be used as an informational
C   label.  If the string is blank, no informational label is written.
C
C   NLBL is an input character string containing numeric labels.  The
C   labels need not be in any particular order, but they have to be
C   separated by blanks and each has to be readable using a FORTRAN
C   format of the form "En.0", where "n" is the length of the label.
C   If the string is blank, no informational label is written.
C
C   XAT0 and XAT1 are the real values of "X" associated with the left
C   and right edges of the face being labelled.
C
C   YAT0 and YAT1 are the real values of "Y" associated with the bottom
C   and top edges of the face being labelled.
C
C   ANGD is an input real specifying the angle, in degrees, at which
C   the labels are to be written.  This angle is defined with reference
C   to the parallelogram defined by the last call to TDPARA.
C
C Declare a required TDPACK common block.
C
        COMMON /TDCOM4/ CSM1,CSM2
        SAVE   /TDCOM4/
C
C Declare a variable into which to encode a number-reading format.
C
        CHARACTER*7 FORM
C
C Define various positioning parameters for labels on the four sides
C of the box face.
C
        DIMENSION XPIL(4),YPIL(4),XOIL(4),YOIL(4),PONL(4),OONL(4),
     +            PTKS(4),OTKE(4)
C
        DATA XPIL / 0.000 , 1.000 , 0.500 , 0.500 /
        DATA YPIL / 0.500 , 0.500 , 0.000 , 1.000 /
        DATA XOIL / -.110 , +.110 , 0.000 , 0.000 /
        DATA YOIL / 0.000 , 0.000 , -.110 , +.110 /
        DATA PONL / 0.000 , 1.000 , 0.000 , 1.000 /
        DATA OONL / -.045 , +.045 , -.045 , +.045 /
        DATA PTKS / 0.000 , 1.000 , 0.000 , 1.000 /
        DATA OTKE / -.015 , +.015 , -.015 , +.015 /
C
        XRNG=ABS(XAT1-XAT0)
        YRNG=ABS(YAT1-YAT0)
C
C Output the informational label, if any.
C
        IF (ILBL.NE.' ')
     +    CALL TDPLCH (XPIL(IAXS)*XRNG+XOIL(IAXS)*CSM2,
     +                 YPIL(IAXS)*YRNG+YOIL(IAXS)*CSM2,
     +                 ILBL(1:LNBPCS(ILBL)),.04*CSM2,ANGD,0.)
C
C Output the numeric labels, if any.
C
        IF (NLBL.NE.' ') THEN
          NCHS=LEN(NLBL)
          IF (NLBL(1:1).EQ.' '.OR.NLBL(1:1).EQ.'+'.OR.
     +        NLBL(1:1).EQ.'-'.OR.NLBL(1:1).EQ.'.'.OR.
     +        NLBL(1:1).EQ.'0'.OR.NLBL(1:1).EQ.'1'.OR.
     +        NLBL(1:1).EQ.'2'.OR.NLBL(1:1).EQ.'3'.OR.
     +        NLBL(1:1).EQ.'4'.OR.NLBL(1:1).EQ.'5'.OR.
     +        NLBL(1:1).EQ.'6'.OR.NLBL(1:1).EQ.'7'.OR.
     +        NLBL(1:1).EQ.'8'.OR.NLBL(1:1).EQ.'9'.OR.
     +        NLBL(1:1).EQ.'*') THEN
            IOFC=1
          ELSE
            IOFC=2
          END IF
          IBEG=0
          DO 101 I=IOFC,NCHS
            IF (NLBL(I:I).NE.' '.AND.NLBL(I:I).NE.'*') THEN
              IF (IBEG.EQ.0) IBEG=I
              IEND=I
            END IF
            IF (IBEG.NE.0) THEN
              IF (NLBL(I:I).EQ.' '.OR.
     +            NLBL(I:I).EQ.'*'.OR.I.EQ.NCHS) THEN
                WRITE (FORM,'(''(E'',I2,''.0)'')') IEND-IBEG+1
                READ  (NLBL(IBEG:IEND),FORM) RVAL
                IF (IOFC.NE.1) CALL TDLBLP (NLBL(1:1),RVAL,RVAL)
                IF (IAXS.EQ.1.OR.IAXS.EQ.2) THEN
                  RVAL=(RVAL-YAT0)*SIGN(1.,YAT1-YAT0)
                  CALL TDPLCH (PONL(IAXS)*XRNG+OONL(IAXS)*CSM2,RVAL,
     +                         NLBL(IBEG:IEND),.03*CSM2,ANGD,0.)
                  CALL TDLNPA (PTKS(IAXS)*XRNG                ,RVAL,
     +                         PTKS(IAXS)*XRNG+OTKE(IAXS)*CSM2,RVAL)
                ELSE
                  RVAL=(RVAL-XAT0)*SIGN(1.,XAT1-XAT0)
                  CALL TDPLCH (RVAL,PONL(IAXS)*YRNG+OONL(IAXS)*CSM2,
     +                         NLBL(IBEG:IEND),.03*CSM2,ANGD,0.)
                  CALL TDLNPA (RVAL,PTKS(IAXS)*YRNG                ,
     +                         RVAL,PTKS(IAXS)*YRNG+OTKE(IAXS)*CSM2)
                END IF
                IBEG=0
              END IF
            END IF
  101     CONTINUE
        END IF
C
C Done.
C
        RETURN
C
      END

      PROGRAM FSTREAM
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER (M=21,N=25)
      REAL U(M,N), V(M,N), WRK(2*M*N)
      INTEGER IDM
C
C IDM is a dummy variable for STINIT and STREAM.
C
C Generate some data
C
      CALL MKDAT(U,V,M,N)
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Select normalization transformation 0 (user coordinates are the same
C as NDC coordinates), so that title is drawn at top of plot.
C
      CALL GSELNT (0)
C
C Call PLCHLQ to write the plot title.
C
      CALL PLCHLQ (.5,.9765,'Example Streamlines Plot',16.,
     1     0.,0.)
C
C Define normalization transformation 1, and set up linear scaling.
C
      CALL SET(0.1, 0.9, 0.1, 0.9,1.0, 21., 1.0, 25.,1)
C
C Tell Streamlines that SET has been called, and
C set spacing of stream lines.
C
      CALL STSETI('SET -- Set Call Flag', 0)
      CALL STSETR('SSP -- Stream Spacing', 0.015)
C
C Initialize Streamlines, and draw streamlines
C
      CALL STINIT(U,M,V,M,IDM,IDM,M,N,WRK,2*M*N)
      CALL STREAM(U,V,IDM,IDM,IDM,WRK)
C
C Close Frame
C
      CALL FRAME
C
C Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS

      STOP
      END

      SUBROUTINE MKDAT(U,V,M,N)

      REAL U(M,N),V(M,N)
C
C Specify horizontal and vertical vector components U and V on
C the rectangular grid. And set up a special value area near the
C center.
C
      TPIMX = 2.*3.14/REAL(M)
      TPJMX = 2.*3.14/REAL(N)
      DO  20 J=1,N
         DO  10 I=1,M
            U(I,J) = SIN(TPIMX*(REAL(I)-1.))
            V(I,J) = SIN(TPJMX*(REAL(J)-1.))
  10     CONTINUE
  20  CONTINUE

      RETURN
      END

c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by UCAR                 .
c  .                                                             .
c  .       University Corporation for Atmospheric Research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                         SPHEREPACK                          .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c
c
c ... file shigs.f
c
c     this file contains code and documentation for subroutine shigs
c
c ... files which must be loaded with shigs.f
c
c     sphcom.f, hrfft.f, gaqd.f
c
c     3/6/98
c
c *** shigs is functionally the same as shagsi or shsgsi.  It
c     it included in spherepack3.0 because legacy codes, using
c     the older version of spherepack, call shigs to initialize
c     the saved work space wshigs for either shags or shsgs
c     Its arguments are identical to those of shagsi or shsgsi.
c
c ****************************************************************
c
c     subroutine shigs(nlat,nlon,wshigs,lshigs,work,lwork,dwork,ldwork,
c    +                 ierror)
c
c     subroutine shigs initializes the array wshigs which can then
c     be used repeatedly by subroutines shags,shsgs. it precomputes
c     and stores in wshigs quantities such as gaussian weights,
c     legendre polynomial coefficients, and fft trigonometric tables.
c
c     input parameters
c
c     nlat   the number of points in the gaussian colatitude grid on the
c            full sphere. these lie in the interval (0,pi) and are compu
c            in radians in theta(1),...,theta(nlat) by subroutine gaqd.
c            if nlat is odd the equator will be included as the grid poi
c            theta((nlat+1)/2).  if nlat is even the equator will be
c            excluded as a grid point and will lie half way between
c            theta(nlat/2) and theta(nlat/2+1). nlat must be at least 3.
c            note: on the half sphere, the number of grid points in the
c            colatitudinal direction is nlat/2 if nlat is even or
c            (nlat+1)/2 if nlat is odd.
c
c     nlon   the number of distinct londitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater
c            than or equal to 4. the efficiency of the computation is
c            improved when nlon is a product of small prime numbers.
c
c     wshigs an array which must be initialized by subroutine shigs .
c            once initialized, wshigs can be used repeatedly by shigs
c            as long as nlat and nlon remain unchanged.  wshigs must
c            not be altered between calls of shigs.
c
c     lshigs the dimension of the array wshigs as it appears in the
c            program that calls shigs. define
c
c               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            then lshigs must be at least
c
c            nlat*(3*(l1+l2)-2)+(l1-1)*(l2*(2*nlat-l1)-3*l1)/2+nlon+15
c
c     work   a real work space which need not be saved
c
c     lwork  the dimension of the array work as it appears in the
c            program that calls shigs. lwork must be at least
c            4*nlat*(nlat+2)+2 in the routine calling shigs
c
C*PL*ERROR* Comment line too long
c     dwork   a double precision work array that does not have to be saved.
c
c     ldwork  the length of dwork in the calling routine.  ldwork must
c             be at least nlat*(nlat+4)
c
c     output parameter
c
c     wshags an array which must be initialized before calling shags or
c            once initialized, wshags can be used repeatedly by shags or
c            as long as nlat and nlon remain unchanged.  wshags must not
c            altered between calls of shasc.
c
c     ierror = 0  no errors
c            = 1  error in the specification of nlat
c            = 2  error in the specification of nlon
c            = 3  error in the specification of lshags
c            = 4  error in the specification of lwork
c            = 5  error in the specification of ldwork
c            = 6  failure in gaqd to compute gaussian points
c                 (due to failure in eigenvalue routine)
c
c
c ****************************************************************
c
      SUBROUTINE DSHIGS(NLAT,NLON,WSHIGS,LSHIGS,WORK,LWORK,DWORK,
     +                  LDWORK,IERROR)
      DOUBLE PRECISION WSHIGS
      DOUBLE PRECISION WORK
c
c     this subroutine must be called before calling shags or shsgs with
c     fixed nlat,nlon. it precomputes the gaussian weights, points
c     and all necessary legendre polys and stores them in wshigs.
c     these quantities must be preserved when calling shsgs or shags
c     repeatedly with fixed nlat,nlon.
c
      DIMENSION WSHIGS(LSHIGS),WORK(LWORK)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION DWORK(LDWORK)

      IERROR = 1
      IF (NLAT.LT.3) RETURN
      IERROR = 2
      IF (NLON.LT.4) RETURN
c     set triangular truncation limit for spherical harmonic basis
      L = MIN0((NLON+2)/2,NLAT)
c     set equator or nearest point (if excluded) pointer
      LATE = (NLAT+1)/2
      L1 = L
      L2 = LATE
c     check permanent work space length
      IERROR = 3
      LP = NLAT* (3* (L1+L2)-2) + (L1-1)* (L2* (2*NLAT-L1)-3*L1)/2 +
     +     NLON + 15
      IF (LSHIGS.LT.LP) RETURN
      IERROR = 4
c     check temporary work space
      IF (LWORK.LT.4*NLAT* (NLAT+2)+2) RETURN
c     check temp double precision space
      IERROR = 5
      IF (LDWORK.LT.NLAT* (NLAT+4)) RETURN
      IERROR = 0
C*PL*ERROR* Comment line too long
c     set preliminary quantites needed to compute and store legendre polys
      CALL DSHIGSP(NLAT,NLON,WSHIGS,LSHIGS,DWORK,LDWORK,IERROR)
      IF (IERROR.NE.0) RETURN
c     set legendre poly pointer in wshigs
      IPMNF = NLAT + 2*NLAT*LATE + 3* (L* (L-1)/2+ (NLAT-L)* (L-1)) +
     +        NLON + 16
      CALL DSHIGSS1(NLAT,L,LATE,WSHIGS,WORK,WSHIGS(IPMNF))
      RETURN
      END

      SUBROUTINE DSHIGSS1(NLAT,L,LATE,W,PMN,PMNF)
      DOUBLE PRECISION W
      DOUBLE PRECISION PMN
      DOUBLE PRECISION PMNF
      DIMENSION W(1),PMN(NLAT,LATE,3),PMNF(LATE,1)
c     compute and store legendre polys for i=1,...,late,m=0,...,l-1
c     and n=m,...,l-1
      DO I = 1,NLAT
          DO J = 1,LATE
              DO K = 1,3
                  PMN(I,J,K) = 0.0D0
              END DO
          END DO
      END DO
      DO 100 MP1 = 1,L
          M = MP1 - 1
          MML1 = M* (2*NLAT-M-1)/2
c     compute pmn for n=m,...,nlat-1 and i=1,...,(l+1)/2
          MODE = 0
          CALL DLEGIN(MODE,L,NLAT,M,W,PMN,KM)
c     store above in pmnf
          DO 101 NP1 = MP1,NLAT
              MN = MML1 + NP1
              DO 102 I = 1,LATE
                  PMNF(I,MN) = PMN(NP1,I,KM)
  102         CONTINUE
  101     CONTINUE
  100 CONTINUE
      RETURN
      END
      SUBROUTINE DSHIGSP(NLAT,NLON,WSHIGS,LSHIGS,DWORK,LDWORK,IERROR)
      DOUBLE PRECISION WSHIGS
      DIMENSION WSHIGS(LSHIGS)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION DWORK(LDWORK)

      IERROR = 1
      IF (NLAT.LT.3) RETURN
      IERROR = 2
      IF (NLON.LT.4) RETURN
c     set triangular truncation limit for spherical harmonic basis
      L = MIN0((NLON+2)/2,NLAT)
c     set equator or nearest point (if excluded) pointer
      LATE = (NLAT+MOD(NLAT,2))/2
      L1 = L
      L2 = LATE
      IERROR = 3
c     check permanent work space length
      IF (LSHIGS.LT.NLAT* (2*L2+3*L1-2)+3*L1* (1-L1)/2+NLON+15) RETURN
      IERROR = 4
c     if (lwork.lt.4*nlat*(nlat+2)+2) return
      IF (LDWORK.LT.NLAT* (NLAT+4)) RETURN
      IERROR = 0
c     set pointers
      I1 = 1
      I2 = I1 + NLAT
      I3 = I2 + NLAT*LATE
      I4 = I3 + NLAT*LATE
      I5 = I4 + L* (L-1)/2 + (NLAT-L)* (L-1)
      I6 = I5 + L* (L-1)/2 + (NLAT-L)* (L-1)
      I7 = I6 + L* (L-1)/2 + (NLAT-L)* (L-1)
c     set indices in temp work for double precision gaussian wts and pts
      IDTH = 1
c     idwts = idth+2*nlat
c     iw = idwts+2*nlat
      IDWTS = IDTH + NLAT
      IW = IDWTS + NLAT
      CALL DSHIGSP1(NLAT,NLON,L,LATE,WSHIGS(I1),WSHIGS(I2),WSHIGS(I3),
     +              WSHIGS(I4),WSHIGS(I5),WSHIGS(I6),WSHIGS(I7),
     +              DWORK(IDTH),DWORK(IDWTS),DWORK(IW),IERROR)
      IF (IERROR.NE.0) IERROR = 5
      RETURN
      END

      SUBROUTINE DSHIGSP1(NLAT,NLON,L,LATE,WTS,P0N,P1N,ABEL,BBEL,CBEL,
     +                    WFFT,DTHETA,DWTS,WORK,IER)
      DOUBLE PRECISION WTS
      DOUBLE PRECISION P0N
      DOUBLE PRECISION P1N
      DOUBLE PRECISION ABEL
      DOUBLE PRECISION BBEL
      DOUBLE PRECISION CBEL
      DOUBLE PRECISION WFFT
      DOUBLE PRECISION FN
      DOUBLE PRECISION FM
      DIMENSION WTS(NLAT),P0N(NLAT,LATE),P1N(NLAT,LATE),ABEL(1),BBEL(1),
     +          CBEL(1),WFFT(1),DTHETA(NLAT),DWTS(NLAT)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION PB,DTHETA,DWTS,WORK(*)

      INDX(M,N) = (N-1)* (N-2)/2 + M - 1
      IMNDX(M,N) = L* (L-1)/2 + (N-L-1)* (L-1) + M - 1
      CALL DHRFFTI(NLON,WFFT)
c     compute double precision gaussian points and weights
c     lw = 4*nlat*(nlat+2)
      LW = NLAT* (NLAT+2)
      CALL DGAQD(NLAT,DTHETA,DWTS,WORK,LW,IER)
      IF (IER.NE.0) RETURN
c     store gaussian weights single precision to save computation
c     in inner loops in analysis
      DO 100 I = 1,NLAT
          WTS(I) = DWTS(I)
  100 CONTINUE
c     initialize p0n,p1n using double precision dnlfk,dnlft
      DO 101 NP1 = 1,NLAT
          DO 101 I = 1,LATE
              P0N(NP1,I) = 0.0D0
              P1N(NP1,I) = 0.0D0
  101 CONTINUE
c     compute m=n=0 legendre polynomials for all theta(i)
      NP1 = 1
      N = 0
      M = 0
      CALL DDNLFK(M,N,WORK)
      DO 103 I = 1,LATE
          CALL DDNLFT(M,N,DTHETA(I),WORK,PB)
          P0N(1,I) = PB
  103 CONTINUE
c     compute p0n,p1n for all theta(i) when n.gt.0
      DO 104 NP1 = 2,NLAT
          N = NP1 - 1
          M = 0
          CALL DDNLFK(M,N,WORK)
          DO 105 I = 1,LATE
              CALL DDNLFT(M,N,DTHETA(I),WORK,PB)
              P0N(NP1,I) = PB
  105     CONTINUE
c     compute m=1 legendre polynomials for all n and theta(i)
          M = 1
          CALL DDNLFK(M,N,WORK)
          DO 106 I = 1,LATE
              CALL DDNLFT(M,N,DTHETA(I),WORK,PB)
              P1N(NP1,I) = PB
  106     CONTINUE
  104 CONTINUE
c
c     compute and store swarztrauber recursion coefficients
c     for 2.le.m.le.n and 2.le.n.le.nlat in abel,bbel,cbel
      DO 107 N = 2,NLAT
          FN = DBLE(N)
          MLIM = MIN0(N,L)
          DO 107 M = 2,MLIM
              FM = DBLE(M)
              IMN = INDX(M,N)
              IF (N.GE.L) IMN = IMNDX(M,N)
              ABEL(IMN) = SQRT(((2*FN+1)* (FM+FN-2)* (FM+FN-3))/
     +                    (((2*FN-3)* (FM+FN-1)* (FM+FN))))
              BBEL(IMN) = SQRT(((2*FN+1)* (FN-FM-1)* (FN-FM))/
     +                    (((2*FN-3)* (FM+FN-1)* (FM+FN))))
              CBEL(IMN) = SQRT(((FN-FM+1)* (FN-FM+2))/
     +                    (((FN+FM-1)* (FN+FM))))
  107 CONTINUE
      RETURN
      END

C
C	$Id: gzxid.f,v 1.5 2008-07-27 00:21:04 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GZXID(WKID,XID,IER)
C
C  Return the local X window identifier associated with the
C  WKID supplied.  IER is 0 if success.
C
      include 'gkscom.h'
C
      INTEGER WKID,XID,IER
C
      IER = 0
C
C  Check to make sure that WKID flags an X workstation type.
C
      IF (WKID .LT. 0) THEN
        IER = 20
        RETURN
      ENDIF
C
      CALL GQWKC(WKID,IER,ICONID,ITYPE)
      IF (IER .NE. 0) RETURN
      CALL GQWKCA(ITYPE,IER,ICAT)
      IF (IER .NE. 0) RETURN
C
      DO 10 I=1,NOPWK
        IF (WKID .EQ. SOPWK(I)) THEN
          XID = LXWKID(I)
C**RLB          IF (XID .EQ. -1) IER = 25
          IF (XID .EQ. -1 .and. SWKTP(I).NE.GCGM) IER = 25
          RETURN
        ENDIF
   10 CONTINUE
      IER = 25
C
      RETURN
      END

C
C	$Id: gsvp.f,v 1.6 2008-07-27 00:21:02 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GSVP(TNR,XMIN,XMAX,YMIN,YMAX)
C
C  SET VIEWPORT
C
      INTEGER ESVP
      PARAMETER (ESVP=50)
C
      include 'gkscom.h'
C
      INTEGER TNR
      REAL XMIN,XMAX,YMIN,YMAX
C
C  Check if GKS is in the proper state.
C
      CALL GZCKST(8,ESVP,IER)
      IF (IER .NE. 0) RETURN
C
C  Check that the normalization transformation number is valid.
C
      IF (TNR.LT.1 .OR. TNR.GT.MNT) THEN
        ERS = 1
        CALL GERHND(50,ESVP,ERF)
        ERS = 0
        RETURN
      ENDIF
C
C  Check that the rectangle definition is valid.
C
      IF (XMAX.LE.XMIN .OR. YMAX.LE.YMIN) THEN
        ERS = 1
        CALL GERHND(51,ESVP,ERF)
        ERS = 0
        RETURN
      ENDIF
C
C  Check that viewport lies in NDC space.
C
      IF (XMIN.LT.0. .OR. XMAX.GT.1. .OR.
     +    YMIN.LT.0. .OR. YMAX.GT.1.) THEN
        ERS = 1
        CALL GERHND(52,ESVP,ERF)
        ERS = 0
        RETURN
      ENDIF
C
C  Set the normalization transformation viewport in the GKS state list.
C
      INR = TNR+1
      NTVP(INR,1) = XMIN
      NTVP(INR,2) = XMAX
      NTVP(INR,3) = YMIN
      NTVP(INR,4) = YMAX
C
C  Reestablish character height and up vector, and
C  pattern size and reference point, and clipping rectangle
C  if the normalization number TNR is the current one.
C
      CALL GQCNTN(IER,ICUR)
      IF (TNR .EQ. ICUR) THEN
        CALL GSCHH(CCHH)
        CALL GSCHUP(CCHUP(1),CCHUP(2))
C
C  Pattern size and pattern reference point currently not implemented.
C
C       CALL GSPA(CPA(1),CPA(2))
C       CALL GSPARF(CPARF(1),CPARF(2))
        CALL GSCLIP(CCLIP)
      ENDIF
C
      RETURN
      END

C
C	$Id: cstrlprt.f,v 1.5 2008-07-27 03:10:08 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CSTRLPRT (N,X,Y,Z,IFLAG,NROW,NT,LTRI,LOUT)
      INTEGER N, IFLAG, NROW, NT, LTRI(NROW,NT), LOUT
      DOUBLE PRECISION X(N), Y(N), Z(N)
C
C***********************************************************
C
C                                              From STRIPACK
C                                            Robert J. Renka
C                                  Dept. of Computer Science
C                                       Univ. of North Texas
C                                           renka@cs.unt.edu
C                                                   07/02/98
C
C   This subroutine prints the triangle list created by Sub-
C routine CSTRLIST and, optionally, the nodal coordinates
C (either latitude and longitude or Cartesian coordinates)
C on logical unit LOUT.  The numbers of boundary nodes,
C triangles, and arcs are also printed.
C
C
C On input:
C
C       N = Number of nodes in the triangulation.
C           3 .LE. N .LE. 9999.
C
C       X,Y,Z = Arrays of length N containing the Cartesian
C               coordinates of the nodes if IFLAG = 0, or
C               (X and Y only) arrays of length N containing
C               longitude and latitude, respectively, if
C               IFLAG > 0, or unused dummy parameters if
C               IFLAG < 0.
C
C       IFLAG = Nodal coordinate option indicator:
C               IFLAG = 0 if X, Y, and Z (assumed to contain
C                         Cartesian coordinates) are to be
C                         printed (to 6 decimal places).
C               IFLAG > 0 if only X and Y (assumed to con-
C                         tain longitude and latitude) are
C                         to be printed (to 6 decimal
C                         places).
C               IFLAG < 0 if only the adjacency lists are to
C                         be printed.
C
C       NROW = Number of rows (entries per triangle) re-
C              served for the triangle list LTRI.  The value
C              must be 6 if only the vertex indexes and
C              neighboring triangle indexes are stored, or 9
C              if arc indexes are also stored.
C
C       NT = Number of triangles in the triangulation.
C            1 .LE. NT .LE. 9999.
C
C       LTRI = NROW by NT array whose J-th column contains
C              the vertex nodal indexes (first three rows),
C              neighboring triangle indexes (second three
C              rows), and, if NROW = 9, arc indexes (last
C              three rows) associated with triangle J for
C              J = 1,...,NT.
C
C       LOUT = Logical unit number for output.  If LOUT is
C              not in the range 0 to 99, output is written
C              to unit 6.
C
C Input parameters are not altered by this routine.
C
C On output:
C
C   The triangle list and nodal coordinates (as specified by
C IFLAG) are written to unit LOUT.
C
C Modules required by CSTRLPRT:  None
C
C***********************************************************
C
      INTEGER I, K, LUN, NA, NB, NL, NLMAX, NMAX
      DATA    NMAX/9999/,  NLMAX/58/
C
C Local parameters:
C
C I =     DO-loop, nodal index, and row index for LTRI
C K =     DO-loop and triangle index
C LUN =   Logical unit number for output
C NA =    Number of triangulation arcs
C NB =    Number of boundary nodes
C NL =    Number of lines printed on the current page
C NLMAX = Maximum number of print lines per page (except
C           for the last page which may have two addi-
C           tional lines)
C NMAX =  Maximum value of N and NT (4-digit format)
C
      LUN = LOUT
      IF (LUN .LT. 0  .OR.  LUN .GT. 99) LUN = 6
C
C Print a heading and test for invalid input.
C
      WRITE (LUN,100) N
      NL = 3
      IF (N .LT. 3  .OR.  N .GT. NMAX  .OR.
     .    (NROW .NE. 6  .AND.  NROW .NE. 9)  .OR.
     .    NT .LT. 1  .OR.  NT .GT. NMAX) THEN
C
C Print an error message and exit.
C
        WRITE (LUN,110) N, NROW, NT
        RETURN
      ENDIF
      IF (IFLAG .EQ. 0) THEN
C
C Print X, Y, and Z.
C
        WRITE (LUN,101)
        NL = 6
        DO 1 I = 1,N
          IF (NL .GE. NLMAX) THEN
            WRITE (LUN,108)
            NL = 0
          ENDIF
          WRITE (LUN,103) I, X(I), Y(I), Z(I)
          NL = NL + 1
    1     CONTINUE
      ELSEIF (IFLAG .GT. 0) THEN
C
C Print X (longitude) and Y (latitude).
C
        WRITE (LUN,102)
        NL = 6
        DO 2 I = 1,N
          IF (NL .GE. NLMAX) THEN
            WRITE (LUN,108)
            NL = 0
          ENDIF
          WRITE (LUN,104) I, X(I), Y(I)
          NL = NL + 1
    2     CONTINUE
      ENDIF
C
C Print the triangulation LTRI.
C
      IF (NL .GT. NLMAX/2) THEN
        WRITE (LUN,108)
        NL = 0
      ENDIF
      IF (NROW .EQ. 6) THEN
        WRITE (LUN,105)
      ELSE
        WRITE (LUN,106)
      ENDIF
      NL = NL + 5
      DO 3 K = 1,NT
        IF (NL .GE. NLMAX) THEN
          WRITE (LUN,108)
          NL = 0
        ENDIF
        WRITE (LUN,107) K, (LTRI(I,K), I = 1,NROW)
        NL = NL + 1
    3   CONTINUE
C
C Print NB, NA, and NT (boundary nodes, arcs, and
C   triangles).
C
      NB = 2*N - NT - 2
      IF (NB .LT. 3) THEN
        NB = 0
        NA = 3*N - 6
      ELSE
        NA = NT + N - 1
      ENDIF
      WRITE (LUN,109) NB, NA, NT
      RETURN
C
C Print formats:
C
  100 FORMAT (///18X,'STRIPACK (CSTRLIST) Output,  N = ',I4)
  101 FORMAT (//8X,'Node',10X,'X(Node)',10X,'Y(Node)',10X,
     .        'Z(Node)'//)
  102 FORMAT (//16X,'Node',8X,'Longitude',9X,'Latitude'//)
  103 FORMAT (8X,I4,3D17.6)
  104 FORMAT (16X,I4,2D17.6)
  105 FORMAT (//1X,'Triangle',8X,'Vertices',12X,'Neighbors'/
     .        4X,'KT',7X,'N1',5X,'N2',5X,'N3',4X,'KT1',4X,
     .        'KT2',4X,'KT3'/)
  106 FORMAT (//1X,'Triangle',8X,'Vertices',12X,'Neighbors',
     .        14X,'Arcs'/
     .        4X,'KT',7X,'N1',5X,'N2',5X,'N3',4X,'KT1',4X,
     .        'KT2',4X,'KT3',4X,'KA1',4X,'KA2',4X,'KA3'/)
  107 FORMAT (2X,I4,2X,6(3X,I4),3(2X,I5))
  108 FORMAT (///)
  109 FORMAT (/1X,'NB = ',I4,' Boundary Nodes',5X,
     .        'NA = ',I5,' Arcs',5X,'NT = ',I5,
     .        ' Triangles')
  110 FORMAT (//1X,10X,'*** Invalid Parameter:  N =',I5,
     .        ', NROW =',I5,', NT =',I5,' ***')
      END

      DOUBLE PRECISION FUNCTION D1MACH(I)
      INTEGER I
C
C  DOUBLE-PRECISION MACHINE CONSTANTS
C  D1MACH( 1) = B**(EMIN-1), THE SMALLEST POSITIVE MAGNITUDE.
C  D1MACH( 2) = B**EMAX*(1 - B**(-T)), THE LARGEST MAGNITUDE.
C  D1MACH( 3) = B**(-T), THE SMALLEST RELATIVE SPACING.
C  D1MACH( 4) = B**(1-T), THE LARGEST RELATIVE SPACING.
C  D1MACH( 5) = LOG10(B)
C
      INTEGER SMALL(2)
      INTEGER LARGE(2)
      INTEGER RIGHT(2)
      INTEGER DIVER(2)
      INTEGER LOG10(2)
      INTEGER SC, CRAY1(38), J
      COMMON /D9MACH/ CRAY1
      SAVE SMALL, LARGE, RIGHT, DIVER, LOG10, SC
      DOUBLE PRECISION DMACH(5)
      EQUIVALENCE (DMACH(1),SMALL(1))
      EQUIVALENCE (DMACH(2),LARGE(1))
      EQUIVALENCE (DMACH(3),RIGHT(1))
      EQUIVALENCE (DMACH(4),DIVER(1))
      EQUIVALENCE (DMACH(5),LOG10(1))
C  THIS VERSION ADAPTS AUTOMATICALLY TO MOST CURRENT MACHINES.
C  R1MACH CAN HANDLE AUTO-DOUBLE COMPILING, BUT THIS VERSION OF
C  D1MACH DOES NOT, BECAUSE WE DO NOT HAVE QUAD CONSTANTS FOR
C  MANY MACHINES YET.
C  TO COMPILE ON OLDER MACHINES, ADD A C IN COLUMN 1
C  ON THE NEXT LINE
      DATA SC/0/
C  AND REMOVE THE C FROM COLUMN 1 IN ONE OF THE SECTIONS BELOW.
C  CONSTANTS FOR EVEN OLDER MACHINES CAN BE OBTAINED BY
C          mail netlib@research.bell-labs.com
C          send old1mach from blas
C  PLEASE SEND CORRECTIONS TO dmg OR ehg@bell-labs.com.
C
C     MACHINE CONSTANTS FOR THE HONEYWELL DPS 8/70 SERIES.
C      DATA SMALL(1),SMALL(2) / O402400000000, O000000000000 /
C      DATA LARGE(1),LARGE(2) / O376777777777, O777777777777 /
C      DATA RIGHT(1),RIGHT(2) / O604400000000, O000000000000 /
C      DATA DIVER(1),DIVER(2) / O606400000000, O000000000000 /
C      DATA LOG10(1),LOG10(2) / O776464202324, O117571775714 /, SC/987/
C
C     MACHINE CONSTANTS FOR PDP-11 FORTRANS SUPPORTING
C     32-BIT INTEGERS.
C      DATA SMALL(1),SMALL(2) /    8388608,           0 /
C      DATA LARGE(1),LARGE(2) / 2147483647,          -1 /
C      DATA RIGHT(1),RIGHT(2) /  612368384,           0 /
C      DATA DIVER(1),DIVER(2) /  620756992,           0 /
C      DATA LOG10(1),LOG10(2) / 1067065498, -2063872008 /, SC/987/
C
C     MACHINE CONSTANTS FOR THE UNIVAC 1100 SERIES.
C      DATA SMALL(1),SMALL(2) / O000040000000, O000000000000 /
C      DATA LARGE(1),LARGE(2) / O377777777777, O777777777777 /
C      DATA RIGHT(1),RIGHT(2) / O170540000000, O000000000000 /
C      DATA DIVER(1),DIVER(2) / O170640000000, O000000000000 /
C      DATA LOG10(1),LOG10(2) / O177746420232, O411757177572 /, SC/987/
C
C     ON FIRST CALL, IF NO DATA UNCOMMENTED, TEST MACHINE TYPES.
      IF (SC .NE. 987) THEN
         DMACH(1) = 1.D13
         IF (      SMALL(1) .EQ. 1117925532
     *       .AND. SMALL(2) .EQ. -448790528) THEN
*           *** IEEE BIG ENDIAN ***
            SMALL(1) = 1048576
            SMALL(2) = 0
            LARGE(1) = 2146435071
            LARGE(2) = -1
            RIGHT(1) = 1017118720
            RIGHT(2) = 0
            DIVER(1) = 1018167296
            DIVER(2) = 0
            LOG10(1) = 1070810131
            LOG10(2) = 1352628735
         ELSE IF ( SMALL(2) .EQ. 1117925532
     *       .AND. SMALL(1) .EQ. -448790528) THEN
*           *** IEEE LITTLE ENDIAN ***
            SMALL(2) = 1048576
            SMALL(1) = 0
            LARGE(2) = 2146435071
            LARGE(1) = -1
            RIGHT(2) = 1017118720
            RIGHT(1) = 0
            DIVER(2) = 1018167296
            DIVER(1) = 0
            LOG10(2) = 1070810131
            LOG10(1) = 1352628735
         ELSE IF ( SMALL(1) .EQ. -2065213935
     *       .AND. SMALL(2) .EQ. 10752) THEN
*               *** VAX WITH D_FLOATING ***
            SMALL(1) = 128
            SMALL(2) = 0
            LARGE(1) = -32769
            LARGE(2) = -1
            RIGHT(1) = 9344
            RIGHT(2) = 0
            DIVER(1) = 9472
            DIVER(2) = 0
            LOG10(1) = 546979738
            LOG10(2) = -805796613
         ELSE IF ( SMALL(1) .EQ. 1267827943
     *       .AND. SMALL(2) .EQ. 704643072) THEN
*               *** IBM MAINFRAME ***
            SMALL(1) = 1048576
            SMALL(2) = 0
            LARGE(1) = 2147483647
            LARGE(2) = -1
            RIGHT(1) = 856686592
            RIGHT(2) = 0
            DIVER(1) = 873463808
            DIVER(2) = 0
            LOG10(1) = 1091781651
            LOG10(2) = 1352628735
         ELSE IF ( SMALL(1) .EQ. 1120022684
     *       .AND. SMALL(2) .EQ. -448790528) THEN
*           *** CONVEX C-1 ***
            SMALL(1) = 1048576
            SMALL(2) = 0
            LARGE(1) = 2147483647
            LARGE(2) = -1
            RIGHT(1) = 1019215872
            RIGHT(2) = 0
            DIVER(1) = 1020264448
            DIVER(2) = 0
            LOG10(1) = 1072907283
            LOG10(2) = 1352628735
         ELSE IF ( SMALL(1) .EQ. 815547074
     *       .AND. SMALL(2) .EQ. 58688) THEN
*           *** VAX G-FLOATING ***
            SMALL(1) = 16
            SMALL(2) = 0
            LARGE(1) = -32769
            LARGE(2) = -1
            RIGHT(1) = 15552
            RIGHT(2) = 0
            DIVER(1) = 15568
            DIVER(2) = 0
            LOG10(1) = 1142112243
            LOG10(2) = 2046775455
         ELSE
            DMACH(2) = 1.D27 + 1
            DMACH(3) = 1.D27
            LARGE(2) = LARGE(2) - RIGHT(2)
            IF (LARGE(2) .EQ. 64 .AND. SMALL(2) .EQ. 0) THEN
               CRAY1(1) = 67291416
               DO 10 J = 1, 20
                  CRAY1(J+1) = CRAY1(J) + CRAY1(J)
 10               CONTINUE
               CRAY1(22) = CRAY1(21) + 321322
               DO 20 J = 22, 37
                  CRAY1(J+1) = CRAY1(J) + CRAY1(J)
 20               CONTINUE
               IF (CRAY1(38) .EQ. SMALL(1)) THEN
*                  *** CRAY ***
                  CALL I1MCRY(SMALL(1), J, 8285, 8388608, 0)
                  SMALL(2) = 0
                  CALL I1MCRY(LARGE(1), J, 24574, 16777215, 16777215)
                  CALL I1MCRY(LARGE(2), J, 0, 16777215, 16777214)
                  CALL I1MCRY(RIGHT(1), J, 16291, 8388608, 0)
                  RIGHT(2) = 0
                  CALL I1MCRY(DIVER(1), J, 16292, 8388608, 0)
                  DIVER(2) = 0
                  CALL I1MCRY(LOG10(1), J, 16383, 10100890, 8715215)
                  CALL I1MCRY(LOG10(2), J, 0, 16226447, 9001388)
               ELSE
                  WRITE(*,9000)
                  STOP 779
                  END IF
            ELSE
               WRITE(*,9000)
               STOP 779
               END IF
            END IF
         SC = 987
         END IF
*    SANITY CHECK
      IF (DMACH(4) .GE. 1.0D0) STOP 778
      IF (I .LT. 1 .OR. I .GT. 5) THEN
         WRITE(*,*) 'D1MACH(I): I =',I,' is out of bounds.'
         STOP
         END IF
      D1MACH = DMACH(I)
      RETURN
 9000 FORMAT(/' Adjust D1MACH by uncommenting data statements'/
     *' appropriate for your machine.')
* /* Standard C source for D1MACH -- remove the * in column 1 */
*#include <stdio.h>
*#include <float.h>
*#include <math.h>
*double d1mach_(long *i)
*{
*	switch(*i){
*	  case 1: return DBL_MIN;
*	  case 2: return DBL_MAX;
*	  case 3: return DBL_EPSILON/FLT_RADIX;
*	  case 4: return DBL_EPSILON;
*	  case 5: return log10((double)FLT_RADIX);
*	  }
*	fprintf(stderr, "invalid argument: d1mach(%ld)\n", *i);
*	exit(1); return 0; /* some compilers demand return values */
*}
      END
      SUBROUTINE I1MCRY(A, A1, B, C, D)
**** SPECIAL COMPUTATION FOR OLD CRAY MACHINES ****
      INTEGER A, A1, B, C, D
      A1 = 16777216*B + C
      A = 16777216*A1 + D
      END

C
C $Id: mdpchi.f,v 1.9 2008-09-18 00:42:17 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MDPCHI (IPRT,IDTG,IDPT)
C
        INTEGER IPRT,IDTG,IDPT
C
C MDPCHI is called by various EZMAP routines to reset the color index,
C dotting, and dash pattern before and after drawing parts of a map.
C
C The argument IPRT, if positive, says which part of the map is about
C to be drawn, as follows:
C
C     IPRT    Part of map.
C     ----    ------------
C       1     Perimeter.
C       2     Grid.
C       3     Labelling.
C       4     Limb lines.
C       5     Outline point group, continental.
C       6     Outline point group, U.S.
C       7     Outline point group, country.
C
C A call with IPRT equal to the negative of one of these values asks
C that the color index saved by the last call, with IPRT positive, be
C restored.
C
C When IPRT is positive, IDTG is zero if solid lines are to be used, 1
C if dotted lines are to be used.  If IPRT is negative, IDTG is ignored.
C
C When IPRT is positive and IDTG is zero, IDPT is the dash pattern to be
C used.  If IPRT is negative or IDTG is non-zero, IDPT is ignored.
C
C Declare required common blocks.  See MAPBDX for descriptions of these
C common blocks and the variables in them.
C
        COMMON /MAPCM4/  GRDR,GRID,GRLA,GRLO,GRPO,OTOL,PDRE,PLA1,PLA2,
     +                   PLA3,PLA4,PLB1,PLB2,PLB3,PLB4,PLNO,PLTO,ROTA,
     +                   SRCH,XLOW,XROW,YBOW,YTOW,IDOT,IDSH,IDTL,ILCW,
     +                   ILTS,JPRJ,ELPF,INTF,LBLF,PRMF
        DOUBLE PRECISION GRDR,GRID,GRLA,GRLO,GRPO,OTOL,PDRE,PLA1,PLA2,
     +                   PLA3,PLA4,PLB1,PLB2,PLB3,PLB4,PLNO,PLTO,ROTA,
     +                   SRCH,XLOW,XROW,YBOW,YTOW
        INTEGER          IDOT,IDSH,IDTL,ILCW,ILTS,JPRJ
        LOGICAL          ELPF,INTF,LBLF,PRMF
        SAVE   /MAPCM4/
C
        COMMON /MAPCMQ/  ICIN(8)
        INTEGER          ICIN
        SAVE   /MAPCMQ/
C
C Declare one of the dash-package common blocks, too.
C
        COMMON /SMFLAG/  ISMO
        INTEGER          ISMO
        SAVE   /SMFLAG/
C
C Declare local variables.
C
        INTEGER          IDTS,IGER,IPLS,IPMS,ISMS,ITXS
C
C Certain variables need to be saved between calls.
C
        SAVE IDTS,IPLS,IPMS,ISMS,ITXS
C
C Flush all buffers before changing anything.
C
        CALL MDPIQ
        IF (ICFELL('MDPCHI',1).NE.0) RETURN
C
C Set/reset color index, dotting, and dash pattern.  The user has the
C last word.
C
        IF (IPRT.GT.0) THEN
          ISMS=ISMO
          ISMO=1
          IDTS=IDTL
          IDTL=IDTG
          IF (IDTL.EQ.0) THEN
            CALL DASHDB (IDPT)
            IF (ICFELL('MDPCHI',2).NE.0) RETURN
          END IF
          IF (ICIN(IPRT).GE.0) THEN
            CALL GQPLCI (IGER,IPLS)
            IF (IGER.NE.0) THEN
              CALL SETER ('MDPCHI - ERROR EXIT FROM GQPLCI',3,1)
              RETURN
            END IF
            CALL GQPMCI (IGER,IPMS)
            IF (IGER.NE.0) THEN
              CALL SETER ('MDPCHI - ERROR EXIT FROM GQPMCI',4,1)
              RETURN
            END IF
            CALL GQTXCI (IGER,ITXS)
            IF (IGER.NE.0) THEN
              CALL SETER ('MDPCHI - ERROR EXIT FROM GQTXCI',5,1)
              RETURN
            END IF
            CALL GSPLCI (ICIN(IPRT))
            CALL GSPMCI (ICIN(IPRT))
            CALL GSTXCI (ICIN(IPRT))
          END IF
          CALL HLUMAPUSR (IPRT)
          IF (ICFELL('MDPCHI',6).NE.0) RETURN
        ELSE
          CALL HLUMAPUSR (IPRT)
          IF (ICFELL('MDPCHI',7).NE.0) RETURN
          IF (ICIN(-IPRT).GE.0) THEN
            CALL GSPLCI (IPLS)
            CALL GSPMCI (IPMS)
            CALL GSTXCI (ITXS)
          END IF
          IF (IDTL.EQ.0) THEN
            CALL DASHDB (IOR(ISHIFT(32767,1),1))
            IF (ICFELL('MDPCHI',8).NE.0) RETURN
          END IF
          IDTL=IDTS
          ISMO=ISMS
        END IF
C
C Done.
C
        RETURN
C
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C   FFTPACK 5.0
C   Copyright (C) 1995-2004, Scientific Computing Division,
C   University Corporation for Atmospheric Research
C   Licensed under the GNU General Public License (GPL)
C
C   Authors:  Paul N. Swarztrauber and Richard A. Valent
C
C   $Id: r1fgkf.f,v 1.2 2006-11-21 01:10:19 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      SUBROUTINE DR1FGKF(IDO,IP,L1,IDL1,CC,C1,C2,IN1,CH,CH2,IN2,WA)
      DOUBLE PRECISION TPI
      DOUBLE PRECISION ARG
      DOUBLE PRECISION DCP
      DOUBLE PRECISION DSP
      DOUBLE PRECISION AR1
      DOUBLE PRECISION AI1
      DOUBLE PRECISION AR1H
      DOUBLE PRECISION DC2
      DOUBLE PRECISION DS2
      DOUBLE PRECISION AR2
      DOUBLE PRECISION AI2
      DOUBLE PRECISION AR2H
      DOUBLE PRECISION CH(IN2,IDO,L1,IP),CC(IN1,IDO,IP,L1),
     +                 C1(IN1,IDO,L1,IP),C2(IN1,IDL1,IP),
     +                 CH2(IN2,IDL1,IP),WA(IDO)
C
      TPI = 2.D0*4.D0*ATAN(1.0D0)
      ARG = TPI/DBLE(IP)
      DCP = COS(ARG)
      DSP = SIN(ARG)
      IPPH = (IP+1)/2
      IPP2 = IP + 2
      IDP2 = IDO + 2
      NBD = (IDO-1)/2
      IF (IDO.EQ.1) GO TO 119
      DO 101 IK = 1,IDL1
          CH2(1,IK,1) = C2(1,IK,1)
  101 CONTINUE
      DO 103 J = 2,IP
          DO 102 K = 1,L1
              CH(1,1,K,J) = C1(1,1,K,J)
  102     CONTINUE
  103 CONTINUE
      IF (NBD.GT.L1) GO TO 107
      IS = -IDO
      DO 106 J = 2,IP
          IS = IS + IDO
          IDIJ = IS
          DO 105 I = 3,IDO,2
              IDIJ = IDIJ + 2
              DO 104 K = 1,L1
                  CH(1,I-1,K,J) = WA(IDIJ-1)*C1(1,I-1,K,J) +
     +                            WA(IDIJ)*C1(1,I,K,J)
                  CH(1,I,K,J) = WA(IDIJ-1)*C1(1,I,K,J) -
     +                          WA(IDIJ)*C1(1,I-1,K,J)
  104         CONTINUE
  105     CONTINUE
  106 CONTINUE
      GO TO 111
  107 IS = -IDO
      DO 110 J = 2,IP
          IS = IS + IDO
          DO 109 K = 1,L1
              IDIJ = IS
              DO 108 I = 3,IDO,2
                  IDIJ = IDIJ + 2
                  CH(1,I-1,K,J) = WA(IDIJ-1)*C1(1,I-1,K,J) +
     +                            WA(IDIJ)*C1(1,I,K,J)
                  CH(1,I,K,J) = WA(IDIJ-1)*C1(1,I,K,J) -
     +                          WA(IDIJ)*C1(1,I-1,K,J)
  108         CONTINUE
  109     CONTINUE
  110 CONTINUE
  111 IF (NBD.LT.L1) GO TO 115
      DO 114 J = 2,IPPH
          JC = IPP2 - J
          DO 113 K = 1,L1
              DO 112 I = 3,IDO,2
                  C1(1,I-1,K,J) = CH(1,I-1,K,J) + CH(1,I-1,K,JC)
                  C1(1,I-1,K,JC) = CH(1,I,K,J) - CH(1,I,K,JC)
                  C1(1,I,K,J) = CH(1,I,K,J) + CH(1,I,K,JC)
                  C1(1,I,K,JC) = CH(1,I-1,K,JC) - CH(1,I-1,K,J)
  112         CONTINUE
  113     CONTINUE
  114 CONTINUE
      GO TO 121
  115 DO 118 J = 2,IPPH
          JC = IPP2 - J
          DO 117 I = 3,IDO,2
              DO 116 K = 1,L1
                  C1(1,I-1,K,J) = CH(1,I-1,K,J) + CH(1,I-1,K,JC)
                  C1(1,I-1,K,JC) = CH(1,I,K,J) - CH(1,I,K,JC)
                  C1(1,I,K,J) = CH(1,I,K,J) + CH(1,I,K,JC)
                  C1(1,I,K,JC) = CH(1,I-1,K,JC) - CH(1,I-1,K,J)
  116         CONTINUE
  117     CONTINUE
  118 CONTINUE
      GO TO 121
  119 DO 120 IK = 1,IDL1
          C2(1,IK,1) = CH2(1,IK,1)
  120 CONTINUE
  121 DO 123 J = 2,IPPH
          JC = IPP2 - J
          DO 122 K = 1,L1
              C1(1,1,K,J) = CH(1,1,K,J) + CH(1,1,K,JC)
              C1(1,1,K,JC) = CH(1,1,K,JC) - CH(1,1,K,J)
  122     CONTINUE
  123 CONTINUE
C
      AR1 = 1.D0
      AI1 = 0.D0
      DO 127 L = 2,IPPH
          LC = IPP2 - L
          AR1H = DCP*AR1 - DSP*AI1
          AI1 = DCP*AI1 + DSP*AR1
          AR1 = AR1H
          DO 124 IK = 1,IDL1
              CH2(1,IK,L) = C2(1,IK,1) + AR1*C2(1,IK,2)
              CH2(1,IK,LC) = AI1*C2(1,IK,IP)
  124     CONTINUE
          DC2 = AR1
          DS2 = AI1
          AR2 = AR1
          AI2 = AI1
          DO 126 J = 3,IPPH
              JC = IPP2 - J
              AR2H = DC2*AR2 - DS2*AI2
              AI2 = DC2*AI2 + DS2*AR2
              AR2 = AR2H
              DO 125 IK = 1,IDL1
                  CH2(1,IK,L) = CH2(1,IK,L) + AR2*C2(1,IK,J)
                  CH2(1,IK,LC) = CH2(1,IK,LC) + AI2*C2(1,IK,JC)
  125         CONTINUE
  126     CONTINUE
  127 CONTINUE
      DO 129 J = 2,IPPH
          DO 128 IK = 1,IDL1
              CH2(1,IK,1) = CH2(1,IK,1) + C2(1,IK,J)
  128     CONTINUE
  129 CONTINUE
C
      IF (IDO.LT.L1) GO TO 132
      DO 131 K = 1,L1
          DO 130 I = 1,IDO
              CC(1,I,1,K) = CH(1,I,K,1)
  130     CONTINUE
  131 CONTINUE
      GO TO 135
  132 DO 134 I = 1,IDO
          DO 133 K = 1,L1
              CC(1,I,1,K) = CH(1,I,K,1)
  133     CONTINUE
  134 CONTINUE
  135 DO 137 J = 2,IPPH
          JC = IPP2 - J
          J2 = J + J
          DO 136 K = 1,L1
              CC(1,IDO,J2-2,K) = CH(1,1,K,J)
              CC(1,1,J2-1,K) = CH(1,1,K,JC)
  136     CONTINUE
  137 CONTINUE
      IF (IDO.EQ.1) RETURN
      IF (NBD.LT.L1) GO TO 141
      DO 140 J = 2,IPPH
          JC = IPP2 - J
          J2 = J + J
          DO 139 K = 1,L1
              DO 138 I = 3,IDO,2
                  IC = IDP2 - I
                  CC(1,I-1,J2-1,K) = CH(1,I-1,K,J) + CH(1,I-1,K,JC)
                  CC(1,IC-1,J2-2,K) = CH(1,I-1,K,J) - CH(1,I-1,K,JC)
                  CC(1,I,J2-1,K) = CH(1,I,K,J) + CH(1,I,K,JC)
                  CC(1,IC,J2-2,K) = CH(1,I,K,JC) - CH(1,I,K,J)
  138         CONTINUE
  139     CONTINUE
  140 CONTINUE
      RETURN
  141 DO 144 J = 2,IPPH
          JC = IPP2 - J
          J2 = J + J
          DO 143 I = 3,IDO,2
              IC = IDP2 - I
              DO 142 K = 1,L1
                  CC(1,I-1,J2-1,K) = CH(1,I-1,K,J) + CH(1,I-1,K,JC)
                  CC(1,IC-1,J2-2,K) = CH(1,I-1,K,J) - CH(1,I-1,K,JC)
                  CC(1,I,J2-1,K) = CH(1,I,K,J) + CH(1,I,K,JC)
                  CC(1,IC,J2-2,K) = CH(1,I,K,JC) - CH(1,I,K,J)
  142         CONTINUE
  143     CONTINUE
  144 CONTINUE
      RETURN
      END

      PROGRAM PGKEX09
C
C  A plot illustrating the text extent rectangle.
C
      CHARACTER*13 STRING
      DATA STRING/'NCAR Graphics'/
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C  Open GKS, open and activate a CGM workstation.
C
      CALL GOPKS (IERRF,IDUM)
      CALL GOPWK (IWKID,LUNIT,IWTYPE)
      CALL GACWK (IWKID)
C
C  Specify the text font and color for Plotchar.
C
      CALL PCSETI('FN',21)
      CALL PCSETI('CC',1)
C
C  Calculate the initial X start point to center the string.
C
      CALL PCSETI('TE',1)
      CALL PLCHHQ(0.,.5,STRING,.1*6./7.,360.,-1.)
      CALL PCSETI('TE',0)
      CALL PCGETR('XE',TRIGHT)
      XSTART = .5*(1.-TRIGHT)
C
C  Draw the characters and boxes around the character bodies.
C
      LSTR = LEN(STRING)
      XIN  = XSTART
      YPOS = .475
      DO 10 I=1,LSTR
        CALL DRWBOD(XIN,YPOS,STRING(I:I),.1,XOUT,TOP,BOT)
        XIN = XOUT
   10 CONTINUE
      XEND = XOUT
C
C  Label the plot.
C
      CALL PCSETI('FN',25)
      CALL PLCHHQ(.5,.80,'Text Extent Rectangle',.040,0.,0.)
      CALL PLCHHQ(.5,.72,
     + 'A concatenation of character bodies',.035,0.,0.)
      CALL PCSETI('FN',21)
      CALL PLCHHQ(.5,.64,
     + 'The hatched area shades the text extent rectangle',.025,0.,0.)
      CALL FRAME
C
C  Deactivate and close the workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END
      SUBROUTINE DRWBOD(XIN,Y,CHR,CHGT,XOUT,TOP,BOT)
C
C  Draw the character in CHR left-centered at (XIN,Y) with character
C  height CHGT.  Draw a box around the character body.  Return the 
C  right of the character body in XOUT and the font top and bottom
C  in TOP and BOTTOM.
C
      CHARACTER*1 CHR
      DIMENSION XB(5),YB(5)
C
      CAP =  Y+.5*CHGT
      BASE = Y-.5*CHGT
      HALF = .5*(CAP+BASE)
      TOP = HALF+.7*(CAP-BASE)
      BOT = HALF-.8*(CAP-BASE)
C
C  Convert the character height to width for Plotchar.
C
      CWIDTH = (6./7.)*(CAP-BASE)
C
C  Compute the text extent information.
C
      CALL PCSETI('TE',1)
      CALL PLCHHQ(XIN,HALF,CHR,CWIDTH,360.,-1.)
      CALL PCSETI('TE',0)
      CALL PCGETR('XB',TLEFT)
      CALL PCGETR('XE',TRIGHT)
C
C  Draw a box around the character body limits and hatch the interior.
C
      XB(1) = TLEFT
      XB(2) = TRIGHT
      XB(3) = TRIGHT
      XB(4) = TLEFT
      XB(5) = XB(1)
      YB(1) = BOT
      YB(2) = BOT
      YB(3) = TOP
      YB(4) = TOP
      YB(5) = YB(1)
      CALL GSLWSC(2.)
      CALL GPL(5,XB,YB)
      CALL GSFAIS(3)
      CALL GSFASI(6)
      CALL GFA(5,XB,YB)
      CALL GSLWSC(1.)
      CALL GSFAIS(1)
C
C  Draw the character.
C
      CALL PLCHHQ(XIN,HALF,CHR,CWIDTH,0.,-1.)
C
C  Return the right limit of the character body.
C
      XOUT = TRIGHT
C
      RETURN
      END

C
C $Id: pcloqu.f,v 1.9 2008-07-27 00:17:20 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE PCLOQU (XPOS,YPOS,CHRS,SIZE,ANGD,CNTR)
C
C This routine provides an alternate entry point for the low-quality
C character-drawing routine; the name has the standard prefix "PC".
C
        CHARACTER CHRS*(*)
C
C Check for an uncleared prior error.
C
        IF (ICFELL('PCLOQU - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
        CALL PLCHLQ (XPOS,YPOS,CHRS,SIZE,ANGD,CNTR)
        IF (ICFELL('PCLOQU',2).NE.0) RETURN
C
        RETURN
C
      END

C NCLFORTSTART
      subroutine derrf (x, result)
      implicit none
      double precision x, result
C NCLEND
c ncl result = erf (x)
      double precision erf
c c c external erf
      result = erf(x)
      return
      end

C NCLFORTSTART
      subroutine derrcf (ind, x, result)
      implicit none
      integer  ind
      double precision x, result
C NCLEND
c ncl result = erfc (ind, x)
      double precision erfc1
c c c external errc1
      result = erfc1(ind,x)
      return
      end

C
C $Id: slgetr.f,v 1.7 2008-07-27 00:17:26 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE SLGETR (PNAM,RVAL)
C
C Get in RVAL the real value of the STITLE parameter named PNAM.
C
        CHARACTER*(*) PNAM
C
C The common block SLCOMN holds all of the internal parameters of
C the package STITLE except for color-table parameters.
C
        COMMON /SLCOMN/ GPSZ,IBGC,IBGF,ICOP,IDOT,IFGC,IFGF,IJMP,IMAP,
     +                  INCU,IWLU,IWRK,IWWI,IXND,IXST,OORV,PCSZ,RNFS,
     +                  RVPB,RVPL,RVPR,RVPT,TFIN,TFOU,TGP1,TGP2,TGP3
        SAVE   /SLCOMN/
C
C Define a temporary variable in which to put the first three characters
C of PNAM.
C
        CHARACTER*3 CTMP
C
C Define a character variable in which messages may be formed.
C
        CHARACTER*29 CMSG
C
C Do a call forcing a BLOCKDATA to be loaded from a binary library.
C
        CALL SLBLDA
C
C Check for an uncleared prior error.
C
        IF (ICFELL('SLGETR - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C Extract the first three characters of the parameter name.
C
        CTMP=PNAM
C
C If the parameter name has less than three characters, log an error.
C
        IF (LEN(PNAM).LT.3) GO TO 901
C
C See what the parameter name is ...
C
C ... the flag controlling the output of the alignment frames, ...
C
        IF      (CTMP.EQ.'ALN'.OR.CTMP.EQ.'aln') THEN
C
          RVAL=REAL(IDOT)
C
C ... the blue component of the background color, ...
C
        ELSE IF (CTMP.EQ.'BGB'.OR.CTMP.EQ.'bgb') THEN
C
          CALL SLGCLR (IBGC,DUMI,DUMI,RVAL)
          IF (ICFELL('SLGETR',2).NE.0) RETURN
C
C ... the default background color index ...
C
        ELSE IF (CTMP.EQ.'BGC'.OR.CTMP.EQ.'bgc') THEN
C
          RVAL=REAL(IBGC)
C
C ... the background color fade flag ...
C
        ELSE IF (CTMP.EQ.'BGF'.OR.CTMP.EQ.'bgf') THEN
C
          RVAL=REAL(IBGF)
C
C ... the green component of the background color, ...
C
        ELSE IF (CTMP.EQ.'BGG'.OR.CTMP.EQ.'bgg') THEN
C
          CALL SLGCLR (IBGC,DUMI,RVAL,DUMI)
          IF (ICFELL('SLGETR',3).NE.0) RETURN
C
C ... the red component of the background color, ...
C
        ELSE IF (CTMP.EQ.'BGR'.OR.CTMP.EQ.'bgr') THEN
C
          CALL SLGCLR (IBGC,RVAL,DUMI,DUMI)
          IF (ICFELL('SLGETR',4).NE.0) RETURN
C
C ... the blue component of the foreground color, ...
C
        ELSE IF (CTMP.EQ.'FGB'.OR.CTMP.EQ.'fgb') THEN
C
          CALL SLGPAI (PNAM,4,IPAI)
          IF (IPAI.LE.0) IPAI=IFGC
          CALL SLGCLR (IPAI,DUMI,DUMI,RVAL)
          IF (ICFELL('SLGETR',5).NE.0) RETURN
C
C ... the default foreground color index ...
C
        ELSE IF (CTMP.EQ.'FGC'.OR.CTMP.EQ.'fgc') THEN
C
          RVAL=REAL(IFGC)
C
C ... the foreground color fade flag ...
C
        ELSE IF (CTMP.EQ.'FGF'.OR.CTMP.EQ.'fgf') THEN
C
          RVAL=REAL(IFGF)
C
C ... the green component of the foreground color, ...
C
        ELSE IF (CTMP.EQ.'FGG'.OR.CTMP.EQ.'fgg') THEN
C
          CALL SLGPAI (PNAM,4,IPAI)
          IF (IPAI.LE.0) IPAI=IFGC
          CALL SLGCLR (IPAI,DUMI,RVAL,DUMI)
          IF (ICFELL('SLGETR',6).NE.0) RETURN
C
C ... the red component of the foreground color, ...
C
        ELSE IF (CTMP.EQ.'FGR'.OR.CTMP.EQ.'fgr') THEN
C
          CALL SLGPAI (PNAM,4,IPAI)
          IF (IPAI.LE.0) IPAI=IFGC
          CALL SLGCLR (IPAI,RVAL,DUMI,DUMI)
          IF (ICFELL('SLGETR',7).NE.0) RETURN
C
C ... the fade-in time, ...
C
        ELSE IF (CTMP.EQ.'FIN'.OR.CTMP.EQ.'fin') THEN
C
          RVAL=TFIN
C
C ... the fade-out time, ...
C
        ELSE IF (CTMP.EQ.'FOU'.OR.CTMP.EQ.'fou') THEN
C
          RVAL=TFOU
C
C ... the interline spacing ("gap size"), ...
C
        ELSE IF (CTMP.EQ.'GSZ'.OR.CTMP.EQ.'gsz') THEN
C
          RVAL=GPSZ
C
C ... the centering parameter, ...
C
        ELSE IF (CTMP.EQ.'ICO'.OR.CTMP.EQ.'ico') THEN
C
          RVAL=REAL(ICOP)
C
C ... the FORTRAN logical unit number for "card" input, ...
C
        ELSE IF (CTMP.EQ.'ICU'.OR.CTMP.EQ.'icu') THEN
C
          RVAL=REAL(INCU)
C
C ... the interline spacing for practice runs, ...
C
        ELSE IF (CTMP.EQ.'INC'.OR.CTMP.EQ.'inc') THEN
C
          RVAL=REAL(IJMP)
C
C ... the FORTRAN logical unit number for WISS, ...
C
        ELSE IF (CTMP.EQ.'LOG'.OR.CTMP.EQ.'log') THEN
C
          RVAL=REAL(IWLU)
C
C ... the plotter X coordinate of the left edge of the viewport, ...
C
        ELSE IF (CTMP.EQ.'LX1'.OR.CTMP.EQ.'lx1') THEN
C
          RVAL=32767.*RVPL
C
C ... the plotter X coordinate of the right edge of the viewport, ...
C
        ELSE IF (CTMP.EQ.'LX2'.OR.CTMP.EQ.'lx2') THEN
C
          RVAL=32767.*RVPR
C
C ... the plotter Y coordinate of the bottom edge of the viewport, ...
C
        ELSE IF (CTMP.EQ.'LY1'.OR.CTMP.EQ.'ly1') THEN
C
          RVAL=32767.*RVPB
C
C ... the plotter Y coordinate of the top edge of the viewport, ...
C
        ELSE IF (CTMP.EQ.'LY2'.OR.CTMP.EQ.'ly2') THEN
C
          RVAL=32767.*RVPT
C
C ... the PLOTCHAR mapping flag, ...
C
        ELSE IF (CTMP.EQ.'MAP'.OR.CTMP.EQ.'map') THEN
C
          RVAL=REAL(IMAP)
C
C ... the number of frames per second, ...
C
        ELSE IF (CTMP.EQ.'NFS'.OR.CTMP.EQ.'nfs') THEN
C
          RVAL=RNFS
C
C ... the horizontal scroll end coordinate, ...
C
        ELSE IF (CTMP.EQ.'NXE'.OR.CTMP.EQ.'nxe') THEN
C
          RVAL=REAL(IXND)
C
C ... the horizontal scroll start coordinate, ...
C
        ELSE IF (CTMP.EQ.'NXS'.OR.CTMP.EQ.'nxs') THEN
C
          RVAL=REAL(IXST)
C
C ... the PLOTCHAR out-of-range value, ...
C
        ELSE IF (CTMP.EQ.'ORV'.OR.CTMP.EQ.'orv') THEN
C
          RVAL=OORV
C
C ... the character size, ...
C
        ELSE IF (CTMP.EQ.'PSZ'.OR.CTMP.EQ.'psz') THEN
C
          RVAL=PCSZ
C
C ... the flag controlling suppression of background color during a
C fade-in or fade-out, ...
C
        ELSE IF (CTMP.EQ.'SBK'.OR.CTMP.EQ.'sbk') THEN
C
          IF (IBGF.NE.-1) THEN
            RVAL=0.
          ELSE
            RVAL=1.
          END IF
C
C ... the flag controlling suppression of foreground color during a
C fade-in or fade-out, ...
C
        ELSE IF (CTMP.EQ.'SFG'.OR.CTMP.EQ.'sfg') THEN
C
          IF (IFGF.NE.-1) THEN
            RVAL=0.
          ELSE
            RVAL=1.
          END IF
C
C ... the initial blank-frame count (for FTITLE), ...
C
        ELSE IF (CTMP.EQ.'TM1'.OR.CTMP.EQ.'tm1') THEN
C
          RVAL=TGP1
C
C ... the intermediate blank-frame count (for FTITLE), ...
C
        ELSE IF (CTMP.EQ.'TM2'.OR.CTMP.EQ.'tm2') THEN
C
          RVAL=TGP2
C
C ... the terminal extra blank-frame count (for FTITLE), ...
C
        ELSE IF (CTMP.EQ.'TM3'.OR.CTMP.EQ.'tm3') THEN
C
          RVAL=TGP2
C
C ... the NDC Y coordinate of the bottom edge of the viewport, ...
C
        ELSE IF (CTMP.EQ.'VPB'.OR.CTMP.EQ.'vpb') THEN
C
          RVAL=RVPB
C
C ... the NDC X coordinate of the left edge of the viewport, ...
C
        ELSE IF (CTMP.EQ.'VPL'.OR.CTMP.EQ.'vpl') THEN
C
          RVAL=RVPL
C
C ... the NDC X coordinate of the right edge of the viewport, ...
C
        ELSE IF (CTMP.EQ.'VPR'.OR.CTMP.EQ.'vpr') THEN
C
          RVAL=RVPR
C
C ... the NDC Y coordinate of the top edge of the viewport, ...
C
        ELSE IF (CTMP.EQ.'VPT'.OR.CTMP.EQ.'vpt') THEN
C
          RVAL=RVPT
C
C ... or the workstation identifier for WISS.
C
        ELSE IF (CTMP.EQ.'WID'.OR.CTMP.EQ.'wid') THEN
C
          RVAL=REAL(IWWI)
C
        ELSE
C
C Otherwise, the parameter name is not recognized.
C
          GO TO 901
C
        END IF
C
        RETURN
C
C Error exit.
C
  901   CMSG(1:29)='SLGETR - INVALID KEYWORD: '//CTMP
        CALL SETER (CMSG(1:29),8,1)
        RETURN
C
      END

C
C      $Id: st04f.f,v 1.10 2010-03-15 22:49:24 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C                Copyright (C)  1996                                   C
C        University Corporation for Atmospheric Research               C
C                All Rights Reserved                                   C
C                                                                      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C  File:       st04f.f
C
C  Author:     David Brown (converted by Mary Haley)
C              National Center for Atmospheric Research
C              PO 3000, Boulder, Colorado
C
C  Date:       Thu June 27 16:25:31 MST 1996
C
C  Description: This example shows a StreamlinePlot of 500 mb wind 
C               vector data overlaid on a MapPlot. The streamlines
C               are drawn over a VectorPlot of surface winds colored
C               by surface pressure that in turn is drawn over a filled
C               ContourPlot of surface temperature. Different intervals
C               of the "temp1" colormap are used to color the contour
C               levels and the vectors.
C               The data represents 15 days of weather over North
C               America in January, 1996.
C               The data is extracted from NMC forcast data produced 
C               at 12 hour intervals and converted to netcdf format 
C               by Unidata. Most of the time steps in the files
C               extracted from the original data are taken from the 
C               0 and 6 hour forecast times. However, because some of
C               the original files were lost, certain time steps come
C               from longer range forcasts. Also, several steps had to
C               be excluded from the frame set because the data is 
C               defective. The result is that there is an 
C               apparent discontinuity between some of the frames 
C               when the output is animated.
C
      external NhlFAppClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFCairoWindowWorkstationClass
      external NhlFVectorFieldClass
      external NhlFVectorPlotClass
      external NhlFScalarFieldClass
      external NhlFStreamlinePlotClass
      external NhlFContourPlotClass
      external NhlFTextItemClass
      external NhlFMapPlotClass
C
C Depending on the value of the ITIMESTEPS variable declared below,
C this example example can generate up to 61 frames from the 64
C timesteps in the data files. As shipped, only the first 20 frames 
C are created. To see the complete plot uncomment the second 
C assignment to ITIMESTEPS. Some systems may not have enough physical
C memory to allow all frames to be viewed as an animation.
C
C      parameter(ITIMESTEPS=64)
C
      parameter(ITIMESTEPS=20)
      parameter(NLAT=33,NLON=36)

      character*7  wks_type
      integer i, j, k, d, h
      integer appid, wid, cnid, vcid, stid, txid, amid, mpid, tmid
      integer vfield, vfield2, sfield, sfield2
      integer rlist, len_dims(2)
      integer latlen, lonlen
      integer timelen, timestep(64)
      integer strt(1), cnt(1)
      integer ncid(6), uid, vid, u5id, v5id, pid, tid
      integer latid,lonid
      real lon(NLON), lat(NLAT)
      real X(NLON,NLAT), Y(NLON,NLAT)
      character*2 hour, day
      character*16 mainstring
      character*256 filename
      character*256 dir
      character*8 rftime
      character*50 recname
      character*13 cdffiles(6)
      integer cdflens(6)
      data cdffiles/'Ustorm.cdf','Vstorm.cdf','Pstorm.cdf',
     +              'Tstorm.cdf','U500storm.cdf','V500storm.cdf'/
      data cdflens/10,10,10,10,13,13/
      integer flen

C
C Define the workstation type
C
      wks_type = "ncgm"

C
C Initialize the high level utility library
C
      call NhlFInitialize
C
C Create an application context. Set the app dir to the current
C directory so the application looks for a resource file in the working
C directory. 
C
      call NhlFRLCreate(rlist,'setrl')

      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'appUsrDir','./',ierr)
      call NhlFRLSetString(rlist,'appDefaultParent','True',ierr)
      call NhlFCreate(appid,'st04',NhlFappClass,0,rlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkMetaName','./st04f.ncgm',ierr)
         call NhlFRLSetString(rlist,'wkColorMap','temp1',ierr)
         call NhlFCreate(wid,'st04Work',
     +        NhlFNcgmWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X11 workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPause','True',ierr)
         call NhlFRLSetString(rlist,'wkColorMap','temp1',ierr)
         call NhlFCreate(wid,'st04Work',
     +        NhlFCairoWindowWorkstationClass,
     +        0,rlist,ierr)
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PostScript workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkColorMap','temp1',ierr)
         call NhlFRLSetString(rlist,'wkPSFileName','./st04f.ps',ierr)
         call NhlFCreate(wid,'st04Work',
     +        NhlFPSWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkColorMap','temp1',ierr)
         call NhlFRLSetString(rlist,'wkPDFFileName','./st04f.pdf',ierr)
         call NhlFCreate(wid,'st04Work',
     +        NhlFPDFWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkColorMap','temp1',ierr)
         call NhlFRLSetString(rlist,'wkFileName','./st04f',ierr)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(wid,'st04Work',
     +        NhlFCairoPSPDFWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkColorMap','temp1',ierr)
         call NhlFRLSetString(rlist,'wkFileName','./st04f',ierr)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(wid,'st04Work',
     +        NhlFCairoImageWorkstationClass,0,rlist,ierr)
      endif
C
C Open the netCDF files.
C
      call gngpat(dir,'data',ierr)
      flen = 0
      do 10 i=1,256
          if( dir(i:i).eq.char(0) ) then
              dir(i:i+4) = '/cdf/'
              flen = i+4
              go to 15
          endif
 10   continue
 15   filename(1:flen) = dir
      do 20 j = 1,6
          filename(flen+1:flen+cdflens(j)) = cdffiles(j)
          ncid(j) = ncopn(filename(1:flen+cdflens(j)),0,ierr)
 20   continue
C      
C The second argument to 'ncopn' should be NCNOWRIT, but since we
C can't include 'netcdf.inc', we are using the value '0' instead.
C
C
C Get the lat/lon dimensions (they happen to be the
C same for all files in this case)
C
      latid = ncdid(ncid(1),'lat',ierr)
      lonid = ncdid(ncid(1),'lon',ierr)
      call ncdinq(ncid(1),latid,recname,latlen,ierr)
      call ncdinq(ncid(1),lonid,recname,lonlen,ierr)
      len_dims(1) = lonlen
      len_dims(2) = latlen
C
C Get the variable ids
C
      uid = ncvid(ncid(1),'u',ierr)
      vid = ncvid(ncid(2),'v',ierr)
      pid = ncvid(ncid(3),'p',ierr)
      tid = ncvid(ncid(4),'t',ierr)
      u5id = ncvid(ncid(5),'u',ierr)
      v5id = ncvid(ncid(6),'v',ierr)
      latid = ncvid(ncid(1),'lat',ierr)
      lonid = ncvid(ncid(1),'lon',ierr)
C
C Get lat/lon values (they are the same for all files)
C
      strt(1) = 1
      cnt(1) = latlen
      call ncvgt(ncid(1),latid,strt,cnt,lat,ierr)
      cnt(1) = lonlen
      call ncvgt(ncid(1),lonid,strt,cnt,lon,ierr)
C
C Get U and V data values
C
      call get_2d_array(X,latlen,lonlen,ncid(1),uid,1)
      call get_2d_array(Y,latlen,lonlen,ncid(2),vid,1)
C
C Create a VectorField of the surface wind data
C
      call NhlFRLClear(rlist)
      call NhlFRLSetMDFloatArray(rlist,'vfUDataArray',X,2,len_dims,ierr)
      call NhlFRLSetMDFloatArray(rlist,'vfVDataArray',Y,2,len_dims,ierr)
      call NhlFRLSetFloat(rlist,'vfXCStartV',lon(1),ierr)
      call NhlFRLSetFloat(rlist,'vfYCStartV',lat(1),ierr)
      call NhlFRLSetFloat(rlist,'vfXCEndV', lon(lonlen),ierr)
      call NhlFRLSetFloat(rlist,'vfYCEndV',lat(latlen),ierr)
      call NhlFRLSetFloat(rlist,'vfMissingUValueV',-9999.0,ierr)
      call NhlFCreate(vfield,'VectorField',NhlFvectorFieldClass,appid,
     +     rlist,ierr)
C
C Create a VectorField of 500 millibar wind data
C
C Get U and V values
C
      call get_2d_array(X,latlen,lonlen,ncid(5),u5id,1)
      call get_2d_array(Y,latlen,lonlen,ncid(6),v5id,1)

      call NhlFRLClear(rlist)
      call NhlFRLSetMDFloatArray(rlist,'vfUDataArray',X,2,len_dims,
     +     ierr)
      call NhlFRLSetMDFloatArray(rlist,'vfVDataArray',Y,2,len_dims,
     +     ierr)
      call NhlFRLSetFloat(rlist,'vfXCStartV',lon(1),ierr)
      call NhlFRLSetFloat(rlist,'vfYCStartV',lat(1),ierr)
      call NhlFRLSetFloat(rlist,'vfXCEndV', lon(lonlen),ierr)
      call NhlFRLSetFloat(rlist,'vfYCEndV',lat(latlen),ierr)
      call NhlFRLSetFloat(rlist,'vfMissingUValueV',-9999.0,ierr)
      call NhlFCreate(vfield2,'VectorField',NhlFvectorFieldClass,appid,
     +     rlist,ierr)
C
C Create a ScalarField of surface pressure 
C
C Get P data values
C
      call get_2d_array(X,latlen,lonlen,ncid(3),pid,1)

      do 41 j = 1, latlen
         do 40 i = 1, lonlen
            if( X(i,j) .ne. -9999.0 ) then
               X(i,j) = X(i,j) / 100.
            endif
 40      continue
 41   continue
      
      call NhlFRLClear(rlist)
      call NhlFRLSetMDFloatArray(rlist,'sfDataArray',X,2,len_dims,ierr)
      call NhlFRLSetFloat(rlist,'sfXCStartV',lon(1),ierr)
      call NhlFRLSetFloat(rlist,'sfYCStartV',lat(1),ierr)
      call NhlFRLSetFloat(rlist,'sfXCEndV',lon(lonlen),ierr)
      call NhlFRLSetFloat(rlist,'sfYCEndV',lat(latlen),ierr)
      call NhlFRLSetFloat(rlist,'sfMissingValueV', -9999.0,ierr)
      call NhlFCreate(sfield,'ScalarField',NhlFscalarFieldClass,appid,
     +     rlist,ierr)
C
C Create a ScalarField of surface temperature 
C (convert from Kelvin to Farenheit)
C
C Get T data values
C
      call get_2d_array(X,latlen,lonlen,ncid(4),tid,1)
C
C Convert to Fahrenheit
C
      do 50 j = 1, latlen
         do 49 i = 1, lonlen
            if( X(i,j) .ne. -9999.0) then
               X(i,j) = (X(i,j) - 273.15) * 9.0/5.0 + 32.0
            endif
 49   continue
 50   continue
      
      call NhlFRLClear(rlist)
      call NhlFRLSetMDFloatArray(rlist,'sfDataArray',X,2,len_dims,ierr)
      call NhlFRLSetFloat(rlist,'sfXCStartV',lon(1),ierr)
      call NhlFRLSetFloat(rlist,'sfYCStartV',lat(1),ierr)
      call NhlFRLSetFloat(rlist,'sfXCEndV',lon(lonlen),ierr)
      call NhlFRLSetFloat(rlist,'sfYCEndV',lat(latlen),ierr)
      call NhlFRLSetFloat(rlist,'sfMissingValueV', -9999.0,ierr)
      call NhlFCreate(sfield2,'ScalarField2',NhlFscalarFieldClass,appid,
     +     rlist,ierr)
C
C Create a ContourPlot with surface temperature data
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'cnFillOn','true',ierr)
      call NhlFRLSetString(rlist,'cnLinesOn','false',ierr)
      call NhlFRLSetString(rlist,'cnFillDrawOrder','predraw',ierr)
      call NhlFRLSetInteger(rlist,'cnScalarFieldData',sfield2,ierr)
      call NhlFCreate(cnid,'contourplot',NhlFcontourPlotClass,wid,
     +     rlist,ierr)
C
C Create a VectorPlot with the surface wind and pressure data
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'vcUseScalarArray','true',ierr)
      call NhlFRLSetInteger(rlist,'vcVectorFieldData',vfield,ierr)
      call NhlFRLSetInteger(rlist,'vcScalarFieldData',sfield,ierr)
      call NhlFCreate(vcid,'vectorplot',NhlFvectorPlotClass,wid,rlist,
     +     ierr)
C
C Create a StreamlinePlot with 500 mb wind data
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'pmTitleDisplayMode','always',ierr)
      call NhlFRLSetString(rlist,'tiMainFuncCode','~',ierr)
      call NhlFRLSetInteger(rlist,'stVectorFieldData',vfield2,ierr)
      call NhlFCreate(stid,'streamlineplot',NhlFstreamlinePlotClass,
     +     wid,rlist,ierr)
C
C Create an annotation used to explain the streamline data
C
      call NhlFCreate(txid,'streamlineplotanno',NhlFtextItemClass,wid,0,
     +     ierr)
      call NhlFAddAnnotation(stid,txid,amid)
C
C Create a map object
C
      call NhlFRLClear(rlist)
C      call NhlFRLSetString(rlist,'vpUseSegments','true',ierr)
      call NhlFCreate(mpid,'mapplot',NhlFmapPlotClass,wid,rlist,ierr)
C
C Overlay everything on the MapPlot. The last object overlaid will
C appear on top
C
      call NhlFAddOverlay(mpid,cnid,-1,ierr)
      call NhlFAddOverlay(mpid,vcid,-1,ierr)
      call NhlFAddOverlay(mpid,stid,-1,ierr)
C
C Variables for manipulating the title string
C
      tmid = ncdid(ncid(2),'timestep',ierr)
      call ncdinq(ncid(2),tmid,recname,timelen,ierr)
      tmid = ncvid(ncid(2),'timestep',ierr)

      strt(1) = 1
      cnt(1) = timelen
      call ncvgt(ncid(2),tmid,strt,cnt,timestep,ierr)
      hour = '00'
      day  = '05'
    
      tmid = ncvid(ncid(2),'reftime',ierr)
      strt(1) = 1 
      cnt(1) = 8
      call ncvgtc(ncid(2),tmid,strt,cnt,rftime,8,ierr)

      do 100 i=0,ITIMESTEPS-1
         if (i .ne. 17 .and. i .ne. 36 .and. i .ne. 37) then
C
C Figure out the hour and day from the timestep, convert to strings
C and build the title string
C
            d = timestep(i+1) / 24 + 5
            h = mod(timestep(i+1),24)
            if (h .gt. 9) then
               write(hour,54)h
            else
               write(hour,55)h
            endif
            if (d .gt. 9) then
               write(day,54)d
            else
               write(day,55)d
            endif
 54         format(I2)
 55         format('0',I1)
C     
C Set the new title string
C     
            mainstring = rftime // day // ' ' // hour // ':00'
            print *,mainstring
            call NhlFRLClear(rlist)
            call NhlFRLSetString(rlist,'tiMainString',mainstring,ierr)
            call NhlFSetValues(stid,rlist,ierr)
C
C Modify the data objects with data for the current time step
C
C Get U and V values
C
            call get_2d_array(X,latlen,lonlen,ncid(1),uid,i+1)
            call get_2d_array(Y,latlen,lonlen,ncid(2),vid,i+1)

            call NhlFRLClear(rlist)
            call NhlFRLSetMDFloatArray(rlist,'vfUDataArray',X,2,
     +           len_dims,ierr)
            call NhlFRLSetMDFloatArray(rlist,'vfVDataArray',Y,2,
     +           len_dims,ierr)
            call NhlFSetValues(vfield,rlist,ierr)
C
C Get U and V values
C
            call get_2d_array(X,latlen,lonlen,ncid(5),uid,i+1)
            call get_2d_array(Y,latlen,lonlen,ncid(6),vid,i+1)

            call NhlFRLClear(rlist)
            call NhlFRLSetMDFloatArray(rlist,'vfUDataArray',X,2,
     +           len_dims,ierr)
            call NhlFRLSetMDFloatArray(rlist,'vfVDataArray',Y,2,
     +           len_dims,ierr)
            call NhlFSetValues(vfield2,rlist,ierr)
C
C Get P values
C
            call get_2d_array(X,latlen,lonlen,ncid(3),pid,i+1)

            do 70 j = 1, latlen
               do 60 k = 1, lonlen
                  if( X(k,j) .ne. -9999.0 ) then
                     X(k,j) = X(k,j) / 100.
                  endif
 60            continue
 70         continue

            call NhlFRLClear(rlist)
            call NhlFRLSetMDFloatArray(rlist,'sfDataArray',X,2,len_dims,
     +           ierr)
            call NhlFSetValues(sfield,rlist,ierr)
C
C Get T values
C
            call get_2d_array(X,latlen,lonlen,ncid(4),tid,i+1)
C
C Convert to Fahrenheit
C
            do 90 j = 1, latlen
               do 80 k = 1, lonlen
                  if( X(k,j) .ne. -9999.0) then
                     X(k,j) = (X(k,j) - 273.15) * 9.0/5.0 + 32.0
                  endif
 80            continue
 90         continue
      
            call NhlFRLClear(rlist)
            call NhlFRLSetMDFloatArray(rlist,'sfDataArray',X,2,len_dims,
     +           ierr)
            call NhlFSetValues(sfield2,rlist,ierr)
C
C Draw the plot
C
            call NhlFDraw(mpid,ierr)
            call NhlFFrame(wid,ierr)
         endif
 100  continue
C 
C  Destroy the workstation object and exit.
C
      call NhlFDestroy(wid,ierr)
      call NhlFClose
      stop
      end

      subroutine get_2d_array(X,latlen,lonlen,fid,aid,timestep)
      real X(lonlen,latlen)
      integer latlen, lonlen, fid, aid, timestep
      integer start(3), count(3)

      start(1) = 1
      start(2) = 1
      start(3) = timestep
      count(1) = lonlen
      count(2) = latlen
      count(3) = 1
      call ncvgt(fid,aid,start,count,X,ierr)
      return
      end

      SUBROUTINE ZHEEVX( JOBZ, RANGE, UPLO, N, A, LDA, VL, VU, IL, IU,
     $                   ABSTOL, M, W, Z, LDZ, WORK, LWORK, RWORK,
     $                   IWORK, IFAIL, INFO )
*
*  -- LAPACK driver routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          JOBZ, RANGE, UPLO
      INTEGER            IL, INFO, IU, LDA, LDZ, LWORK, M, N
      DOUBLE PRECISION   ABSTOL, VL, VU
*     ..
*     .. Array Arguments ..
      INTEGER            IFAIL( * ), IWORK( * )
      DOUBLE PRECISION   RWORK( * ), W( * )
      COMPLEX*16         A( LDA, * ), WORK( * ), Z( LDZ, * )
*     ..
*
*  Purpose
*  =======
*
*  ZHEEVX computes selected eigenvalues and, optionally, eigenvectors
*  of a complex Hermitian matrix A.  Eigenvalues and eigenvectors can
*  be selected by specifying either a range of values or a range of
*  indices for the desired eigenvalues.
*
*  Arguments
*  =========
*
*  JOBZ    (input) CHARACTER*1
*          = 'N':  Compute eigenvalues only;
*          = 'V':  Compute eigenvalues and eigenvectors.
*
*  RANGE   (input) CHARACTER*1
*          = 'A': all eigenvalues will be found.
*          = 'V': all eigenvalues in the half-open interval (VL,VU]
*                 will be found.
*          = 'I': the IL-th through IU-th eigenvalues will be found.
*
*  UPLO    (input) CHARACTER*1
*          = 'U':  Upper triangle of A is stored;
*          = 'L':  Lower triangle of A is stored.
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  A       (input/output) COMPLEX*16 array, dimension (LDA, N)
*          On entry, the Hermitian matrix A.  If UPLO = 'U', the
*          leading N-by-N upper triangular part of A contains the
*          upper triangular part of the matrix A.  If UPLO = 'L',
*          the leading N-by-N lower triangular part of A contains
*          the lower triangular part of the matrix A.
*          On exit, the lower triangle (if UPLO='L') or the upper
*          triangle (if UPLO='U') of A, including the diagonal, is
*          destroyed.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(1,N).
*
*  VL      (input) DOUBLE PRECISION
*  VU      (input) DOUBLE PRECISION
*          If RANGE='V', the lower and upper bounds of the interval to
*          be searched for eigenvalues. VL < VU.
*          Not referenced if RANGE = 'A' or 'I'.
*
*  IL      (input) INTEGER
*  IU      (input) INTEGER
*          If RANGE='I', the indices (in ascending order) of the
*          smallest and largest eigenvalues to be returned.
*          1 <= IL <= IU <= N, if N > 0; IL = 1 and IU = 0 if N = 0.
*          Not referenced if RANGE = 'A' or 'V'.
*
*  ABSTOL  (input) DOUBLE PRECISION
*          The absolute error tolerance for the eigenvalues.
*          An approximate eigenvalue is accepted as converged
*          when it is determined to lie in an interval [a,b]
*          of width less than or equal to
*
*                  ABSTOL + EPS *   max( |a|,|b| ) ,
*
*          where EPS is the machine precision.  If ABSTOL is less than
*          or equal to zero, then  EPS*|T|  will be used in its place,
*          where |T| is the 1-norm of the tridiagonal matrix obtained
*          by reducing A to tridiagonal form.
*
*          Eigenvalues will be computed most accurately when ABSTOL is
*          set to twice the underflow threshold 2*DLAMCH('S'), not zero.
*          If this routine returns with INFO>0, indicating that some
*          eigenvectors did not converge, try setting ABSTOL to
*          2*DLAMCH('S').
*
*          See "Computing Small Singular Values of Bidiagonal Matrices
*          with Guaranteed High Relative Accuracy," by Demmel and
*          Kahan, LAPACK Working Note #3.
*
*  M       (output) INTEGER
*          The total number of eigenvalues found.  0 <= M <= N.
*          If RANGE = 'A', M = N, and if RANGE = 'I', M = IU-IL+1.
*
*  W       (output) DOUBLE PRECISION array, dimension (N)
*          On normal exit, the first M elements contain the selected
*          eigenvalues in ascending order.
*
*  Z       (output) COMPLEX*16 array, dimension (LDZ, max(1,M))
*          If JOBZ = 'V', then if INFO = 0, the first M columns of Z
*          contain the orthonormal eigenvectors of the matrix A
*          corresponding to the selected eigenvalues, with the i-th
*          column of Z holding the eigenvector associated with W(i).
*          If an eigenvector fails to converge, then that column of Z
*          contains the latest approximation to the eigenvector, and the
*          index of the eigenvector is returned in IFAIL.
*          If JOBZ = 'N', then Z is not referenced.
*          Note: the user must ensure that at least max(1,M) columns are
*          supplied in the array Z; if RANGE = 'V', the exact value of M
*          is not known in advance and an upper bound must be used.
*
*  LDZ     (input) INTEGER
*          The leading dimension of the array Z.  LDZ >= 1, and if
*          JOBZ = 'V', LDZ >= max(1,N).
*
*  WORK    (workspace/output) COMPLEX*16 array, dimension (LWORK)
*          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*
*  LWORK   (input) INTEGER
*          The length of the array WORK.  LWORK >= max(1,2*N-1).
*          For optimal efficiency, LWORK >= (NB+1)*N,
*          where NB is the max of the blocksize for ZHETRD and for
*          ZUNMTR as returned by ILAENV.
*
*          If LWORK = -1, then a workspace query is assumed; the routine
*          only calculates the optimal size of the WORK array, returns
*          this value as the first entry of the WORK array, and no error
*          message related to LWORK is issued by XERBLA.
*
*  RWORK   (workspace) DOUBLE PRECISION array, dimension (7*N)
*
*  IWORK   (workspace) INTEGER array, dimension (5*N)
*
*  IFAIL   (output) INTEGER array, dimension (N)
*          If JOBZ = 'V', then if INFO = 0, the first M elements of
*          IFAIL are zero.  If INFO > 0, then IFAIL contains the
*          indices of the eigenvectors that failed to converge.
*          If JOBZ = 'N', then IFAIL is not referenced.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*          > 0:  if INFO = i, then i eigenvectors failed to converge.
*                Their indices are stored in array IFAIL.
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO, ONE
      PARAMETER          ( ZERO = 0.0D+0, ONE = 1.0D+0 )
      COMPLEX*16         CONE
      PARAMETER          ( CONE = ( 1.0D+0, 0.0D+0 ) )
*     ..
*     .. Local Scalars ..
      LOGICAL            ALLEIG, INDEIG, LOWER, LQUERY, VALEIG, WANTZ
      CHARACTER          ORDER
      INTEGER            I, IINFO, IMAX, INDD, INDE, INDEE, INDIBL,
     $                   INDISP, INDIWK, INDRWK, INDTAU, INDWRK, ISCALE,
     $                   ITMP1, J, JJ, LLWORK, LOPT, LWKOPT, NB, NSPLIT
      DOUBLE PRECISION   ABSTLL, ANRM, BIGNUM, EPS, RMAX, RMIN, SAFMIN,
     $                   SIGMA, SMLNUM, TMP1, VLL, VUU
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            ILAENV
      DOUBLE PRECISION   DLAMCH, ZLANHE
      EXTERNAL           LSAME, ILAENV, DLAMCH, ZLANHE
*     ..
*     .. External Subroutines ..
      EXTERNAL           DCOPY, DSCAL, DSTEBZ, DSTERF, XERBLA, ZDSCAL,
     $                   ZHETRD, ZLACPY, ZSTEIN, ZSTEQR, ZSWAP, ZUNGTR,
     $                   ZUNMTR
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          DBLE, MAX, MIN, SQRT
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      LOWER = LSAME( UPLO, 'L' )
      WANTZ = LSAME( JOBZ, 'V' )
      ALLEIG = LSAME( RANGE, 'A' )
      VALEIG = LSAME( RANGE, 'V' )
      INDEIG = LSAME( RANGE, 'I' )
      LQUERY = ( LWORK.EQ.-1 )
*
      INFO = 0
      IF( .NOT.( WANTZ .OR. LSAME( JOBZ, 'N' ) ) ) THEN
         INFO = -1
      ELSE IF( .NOT.( ALLEIG .OR. VALEIG .OR. INDEIG ) ) THEN
         INFO = -2
      ELSE IF( .NOT.( LOWER .OR. LSAME( UPLO, 'U' ) ) ) THEN
         INFO = -3
      ELSE IF( N.LT.0 ) THEN
         INFO = -4
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -6
      ELSE
         IF( VALEIG ) THEN
            IF( N.GT.0 .AND. VU.LE.VL )
     $         INFO = -8
         ELSE IF( INDEIG ) THEN
            IF( IL.LT.1 .OR. IL.GT.MAX( 1, N ) ) THEN
               INFO = -9
            ELSE IF( IU.LT.MIN( N, IL ) .OR. IU.GT.N ) THEN
               INFO = -10
            END IF
         END IF
      END IF
      IF( INFO.EQ.0 ) THEN
         IF( LDZ.LT.1 .OR. ( WANTZ .AND. LDZ.LT.N ) ) THEN
            INFO = -15
         ELSE IF( LWORK.LT.MAX( 1, 2*N-1 ) .AND. .NOT.LQUERY ) THEN
            INFO = -17
         END IF
      END IF
*
      IF( INFO.EQ.0 ) THEN
         NB = ILAENV( 1, 'ZHETRD', UPLO, N, -1, -1, -1 )
         NB = MAX( NB, ILAENV( 1, 'ZUNMTR', UPLO, N, -1, -1, -1 ) )
         LWKOPT = ( NB+1 )*N
         WORK( 1 ) = LWKOPT
      END IF
*
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'ZHEEVX', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         RETURN
      END IF
*
*     Quick return if possible
*
      M = 0
      IF( N.EQ.0 ) THEN
         WORK( 1 ) = 1
         RETURN
      END IF
*
      IF( N.EQ.1 ) THEN
         WORK( 1 ) = 1
         IF( ALLEIG .OR. INDEIG ) THEN
            M = 1
            W( 1 ) = A( 1, 1 )
         ELSE IF( VALEIG ) THEN
            IF( VL.LT.DBLE( A( 1, 1 ) ) .AND. VU.GE.DBLE( A( 1, 1 ) ) )
     $           THEN
               M = 1
               W( 1 ) = A( 1, 1 )
            END IF
         END IF
         IF( WANTZ )
     $      Z( 1, 1 ) = CONE
         RETURN
      END IF
*
*     Get machine constants.
*
      SAFMIN = DLAMCH( 'Safe minimum' )
      EPS = DLAMCH( 'Precision' )
      SMLNUM = SAFMIN / EPS
      BIGNUM = ONE / SMLNUM
      RMIN = SQRT( SMLNUM )
      RMAX = MIN( SQRT( BIGNUM ), ONE / SQRT( SQRT( SAFMIN ) ) )
*
*     Scale matrix to allowable range, if necessary.
*
      ISCALE = 0
      ABSTLL = ABSTOL
      VLL = VL
      VUU = VU
      ANRM = ZLANHE( 'M', UPLO, N, A, LDA, RWORK )
      IF( ANRM.GT.ZERO .AND. ANRM.LT.RMIN ) THEN
         ISCALE = 1
         SIGMA = RMIN / ANRM
      ELSE IF( ANRM.GT.RMAX ) THEN
         ISCALE = 1
         SIGMA = RMAX / ANRM
      END IF
      IF( ISCALE.EQ.1 ) THEN
         IF( LOWER ) THEN
            DO 10 J = 1, N
               CALL ZDSCAL( N-J+1, SIGMA, A( J, J ), 1 )
   10       CONTINUE
         ELSE
            DO 20 J = 1, N
               CALL ZDSCAL( J, SIGMA, A( 1, J ), 1 )
   20       CONTINUE
         END IF
         IF( ABSTOL.GT.0 )
     $      ABSTLL = ABSTOL*SIGMA
         IF( VALEIG ) THEN
            VLL = VL*SIGMA
            VUU = VU*SIGMA
         END IF
      END IF
*
*     Call ZHETRD to reduce Hermitian matrix to tridiagonal form.
*
      INDD = 1
      INDE = INDD + N
      INDRWK = INDE + N
      INDTAU = 1
      INDWRK = INDTAU + N
      LLWORK = LWORK - INDWRK + 1
      CALL ZHETRD( UPLO, N, A, LDA, RWORK( INDD ), RWORK( INDE ),
     $             WORK( INDTAU ), WORK( INDWRK ), LLWORK, IINFO )
      LOPT = N + WORK( INDWRK )
*
*     If all eigenvalues are desired and ABSTOL is less than or equal to
*     zero, then call DSTERF or ZUNGTR and ZSTEQR.  If this fails for
*     some eigenvalue, then try DSTEBZ.
*
      IF( ( ALLEIG .OR. ( INDEIG .AND. IL.EQ.1 .AND. IU.EQ.N ) ) .AND.
     $    ( ABSTOL.LE.ZERO ) ) THEN
         CALL DCOPY( N, RWORK( INDD ), 1, W, 1 )
         INDEE = INDRWK + 2*N
         IF( .NOT.WANTZ ) THEN
            CALL DCOPY( N-1, RWORK( INDE ), 1, RWORK( INDEE ), 1 )
            CALL DSTERF( N, W, RWORK( INDEE ), INFO )
         ELSE
            CALL ZLACPY( 'A', N, N, A, LDA, Z, LDZ )
            CALL ZUNGTR( UPLO, N, Z, LDZ, WORK( INDTAU ),
     $                   WORK( INDWRK ), LLWORK, IINFO )
            CALL DCOPY( N-1, RWORK( INDE ), 1, RWORK( INDEE ), 1 )
            CALL ZSTEQR( JOBZ, N, W, RWORK( INDEE ), Z, LDZ,
     $                   RWORK( INDRWK ), INFO )
            IF( INFO.EQ.0 ) THEN
               DO 30 I = 1, N
                  IFAIL( I ) = 0
   30          CONTINUE
            END IF
         END IF
         IF( INFO.EQ.0 ) THEN
            M = N
            GO TO 40
         END IF
         INFO = 0
      END IF
*
*     Otherwise, call DSTEBZ and, if eigenvectors are desired, ZSTEIN.
*
      IF( WANTZ ) THEN
         ORDER = 'B'
      ELSE
         ORDER = 'E'
      END IF
      INDIBL = 1
      INDISP = INDIBL + N
      INDIWK = INDISP + N
      CALL DSTEBZ( RANGE, ORDER, N, VLL, VUU, IL, IU, ABSTLL,
     $             RWORK( INDD ), RWORK( INDE ), M, NSPLIT, W,
     $             IWORK( INDIBL ), IWORK( INDISP ), RWORK( INDRWK ),
     $             IWORK( INDIWK ), INFO )
*
      IF( WANTZ ) THEN
         CALL ZSTEIN( N, RWORK( INDD ), RWORK( INDE ), M, W,
     $                IWORK( INDIBL ), IWORK( INDISP ), Z, LDZ,
     $                RWORK( INDRWK ), IWORK( INDIWK ), IFAIL, INFO )
*
*        Apply unitary matrix used in reduction to tridiagonal
*        form to eigenvectors returned by ZSTEIN.
*
         CALL ZUNMTR( 'L', UPLO, 'N', N, M, A, LDA, WORK( INDTAU ), Z,
     $                LDZ, WORK( INDWRK ), LLWORK, IINFO )
      END IF
*
*     If matrix was scaled, then rescale eigenvalues appropriately.
*
   40 CONTINUE
      IF( ISCALE.EQ.1 ) THEN
         IF( INFO.EQ.0 ) THEN
            IMAX = M
         ELSE
            IMAX = INFO - 1
         END IF
         CALL DSCAL( IMAX, ONE / SIGMA, W, 1 )
      END IF
*
*     If eigenvalues are not in order, then sort them, along with
*     eigenvectors.
*
      IF( WANTZ ) THEN
         DO 60 J = 1, M - 1
            I = 0
            TMP1 = W( J )
            DO 50 JJ = J + 1, M
               IF( W( JJ ).LT.TMP1 ) THEN
                  I = JJ
                  TMP1 = W( JJ )
               END IF
   50       CONTINUE
*
            IF( I.NE.0 ) THEN
               ITMP1 = IWORK( INDIBL+I-1 )
               W( I ) = W( J )
               IWORK( INDIBL+I-1 ) = IWORK( INDIBL+J-1 )
               W( J ) = TMP1
               IWORK( INDIBL+J-1 ) = ITMP1
               CALL ZSWAP( N, Z( 1, I ), 1, Z( 1, J ), 1 )
               IF( INFO.NE.0 ) THEN
                  ITMP1 = IFAIL( I )
                  IFAIL( I ) = IFAIL( J )
                  IFAIL( J ) = ITMP1
               END IF
            END IF
   60    CONTINUE
      END IF
*
*     Set WORK(1) to optimal complex workspace size.
*
      WORK( 1 ) = LWKOPT
*
      RETURN
*
*     End of ZHEEVX
*
      END

      PROGRAM WMEX03
C
C  Examples of controlling slopes at endpoints of fronts.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
      CHARACTER*28 LABEL
C
C  Data for picture two illustrating slope control at end points.
C
      PARAMETER (NV=5)
      DIMENSION XV(NV),YV(NV)
      DATA XV/ 0.10, 0.30, 0.50, 0.70, 0.90 /
      DATA YV/ 1.00, 1.08, 1.00, 0.95, 0.94 /
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C  Define a color table.
C
      CALL GSCR(IWKID, 0, 1.0, 1.0, 1.0)
      CALL GSCR(IWKID, 1, 0.0, 0.0, 0.0)
      CALL GSCR(IWKID, 2, 1.0, 0.0, 0.0)
      CALL GSCR(IWKID, 3, 0.0, 0.0, 1.0)
C
      CALL PCSETI('CC',1)
      CALL PLCHHQ(0.50,0.96,':F26:Slope control at endpoints',
     +            0.03,0.,0.)
C
C  Set some parameter values.
C
      CALL WMSETI('NMS - number of symbols on front line',6)
      CALL WMSETR('SL1 - slope at start of front line if SLF=0 or 1',0.)       
      CALL WMSETR('SL2 - slope at end of front line if SLF=0 or 1',-15.)       
      CALL WMSETI('WFC - color for warm fronts',1)
      CALL WMSETR('LIN - line widths of front lines',3.)
      CALL WMSETI('REV - line widths of front lines',1)
      CALL WMSETI('WFC - color for warm fronts',2)
      CALL PCSETI('CC',3)
      DO 40 I=3,0,-1
        CALL WMSETI('SLF - flags whether slopes are from SL1 and SL2',I)      
        DO 50 J=1,NV
          YV(J) = YV(J)-0.22
   50   CONTINUE
        CALL WMDRFT(NV,XV,YV)
        WRITE(LABEL,500) I
  500   FORMAT(':F22:SLF=',I1,', SL1=0., SL2=-15.')  
        CALL PLCHHQ(.7,YV(1)+.08,LABEL,.024,0.,0.)
   40 CONTINUE
      CALL FRAME
C
      CALL GDAWK(IWKID)
      CALL GCLWK(IWKID)
      CALL GCLKS
      STOP
C
      END

C
C $Id: bcsetr.f,v 1.4 2008-07-27 00:17:29 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE BCSETR(PA,RVAL)
C
C Set real-valued parameters for the Bezier curve package.
C
C Arguments
C     Input   PA       Character string indicating parameter to be set.
C             RVAL     A real number for setting PA.
C

      CHARACTER*(*) PA
      CHARACTER*3   CTMP
C
      include 'bccom.h'
C
      CTMP = PA(1:3)
C
      IF (CTMP.EQ.'FTL' .OR. CTMP.EQ.'ftl') THEN
C
C  Set the flatness tolerance limit (fraction of maximum screen height).
C
        FRATIO = RVAL 
      ELSE
        WRITE(I1MACH(4),500) CTMP
      ENDIF
C
      RETURN
C
  500 FORMAT(' BCSETR -- Invalid keyword = ',A3,', no action taken')
C
      END

      SUBROUTINE CUNGQR( M, N, K, A, LDA, TAU, WORK, LWORK, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      INTEGER            INFO, K, LDA, LWORK, M, N
*     ..
*     .. Array Arguments ..
      COMPLEX            A( LDA, * ), TAU( * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  CUNGQR generates an M-by-N complex matrix Q with orthonormal columns,
*  which is defined as the first N columns of a product of K elementary
*  reflectors of order M
*
*        Q  =  H(1) H(2) . . . H(k)
*
*  as returned by CGEQRF.
*
*  Arguments
*  =========
*
*  M       (input) INTEGER
*          The number of rows of the matrix Q. M >= 0.
*
*  N       (input) INTEGER
*          The number of columns of the matrix Q. M >= N >= 0.
*
*  K       (input) INTEGER
*          The number of elementary reflectors whose product defines the
*          matrix Q. N >= K >= 0.
*
*  A       (input/output) COMPLEX array, dimension (LDA,N)
*          On entry, the i-th column must contain the vector which
*          defines the elementary reflector H(i), for i = 1,2,...,k, as
*          returned by CGEQRF in the first k columns of its array
*          argument A.
*          On exit, the M-by-N matrix Q.
*
*  LDA     (input) INTEGER
*          The first dimension of the array A. LDA >= max(1,M).
*
*  TAU     (input) COMPLEX array, dimension (K)
*          TAU(i) must contain the scalar factor of the elementary
*          reflector H(i), as returned by CGEQRF.
*
*  WORK    (workspace/output) COMPLEX array, dimension (LWORK)
*          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*
*  LWORK   (input) INTEGER
*          The dimension of the array WORK. LWORK >= max(1,N).
*          For optimum performance LWORK >= N*NB, where NB is the
*          optimal blocksize.
*
*          If LWORK = -1, then a workspace query is assumed; the routine
*          only calculates the optimal size of the WORK array, returns
*          this value as the first entry of the WORK array, and no error
*          message related to LWORK is issued by XERBLA.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument has an illegal value
*
*  =====================================================================
*
*     .. Parameters ..
      COMPLEX            ZERO
      PARAMETER          ( ZERO = ( 0.0E+0, 0.0E+0 ) )
*     ..
*     .. Local Scalars ..
      LOGICAL            LQUERY
      INTEGER            I, IB, IINFO, IWS, J, KI, KK, L, LDWORK,
     $                   LWKOPT, NB, NBMIN, NX
*     ..
*     .. External Subroutines ..
      EXTERNAL           CLARFB, CLARFT, CUNG2R, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN
*     ..
*     .. External Functions ..
      INTEGER            ILAENV
      EXTERNAL           ILAENV
*     ..
*     .. Executable Statements ..
*
*     Test the input arguments
*
      INFO = 0
      NB = ILAENV( 1, 'CUNGQR', ' ', M, N, K, -1 )
      LWKOPT = MAX( 1, N )*NB
      WORK( 1 ) = LWKOPT
      LQUERY = ( LWORK.EQ.-1 )
      IF( M.LT.0 ) THEN
         INFO = -1
      ELSE IF( N.LT.0 .OR. N.GT.M ) THEN
         INFO = -2
      ELSE IF( K.LT.0 .OR. K.GT.N ) THEN
         INFO = -3
      ELSE IF( LDA.LT.MAX( 1, M ) ) THEN
         INFO = -5
      ELSE IF( LWORK.LT.MAX( 1, N ) .AND. .NOT.LQUERY ) THEN
         INFO = -8
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'CUNGQR', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.LE.0 ) THEN
         WORK( 1 ) = 1
         RETURN
      END IF
*
      NBMIN = 2
      NX = 0
      IWS = N
      IF( NB.GT.1 .AND. NB.LT.K ) THEN
*
*        Determine when to cross over from blocked to unblocked code.
*
         NX = MAX( 0, ILAENV( 3, 'CUNGQR', ' ', M, N, K, -1 ) )
         IF( NX.LT.K ) THEN
*
*           Determine if workspace is large enough for blocked code.
*
            LDWORK = N
            IWS = LDWORK*NB
            IF( LWORK.LT.IWS ) THEN
*
*              Not enough workspace to use optimal NB:  reduce NB and
*              determine the minimum value of NB.
*
               NB = LWORK / LDWORK
               NBMIN = MAX( 2, ILAENV( 2, 'CUNGQR', ' ', M, N, K, -1 ) )
            END IF
         END IF
      END IF
*
      IF( NB.GE.NBMIN .AND. NB.LT.K .AND. NX.LT.K ) THEN
*
*        Use blocked code after the last block.
*        The first kk columns are handled by the block method.
*
         KI = ( ( K-NX-1 ) / NB )*NB
         KK = MIN( K, KI+NB )
*
*        Set A(1:kk,kk+1:n) to zero.
*
         DO 20 J = KK + 1, N
            DO 10 I = 1, KK
               A( I, J ) = ZERO
   10       CONTINUE
   20    CONTINUE
      ELSE
         KK = 0
      END IF
*
*     Use unblocked code for the last or only block.
*
      IF( KK.LT.N )
     $   CALL CUNG2R( M-KK, N-KK, K-KK, A( KK+1, KK+1 ), LDA,
     $                TAU( KK+1 ), WORK, IINFO )
*
      IF( KK.GT.0 ) THEN
*
*        Use blocked code
*
         DO 50 I = KI + 1, 1, -NB
            IB = MIN( NB, K-I+1 )
            IF( I+IB.LE.N ) THEN
*
*              Form the triangular factor of the block reflector
*              H = H(i) H(i+1) . . . H(i+ib-1)
*
               CALL CLARFT( 'Forward', 'Columnwise', M-I+1, IB,
     $                      A( I, I ), LDA, TAU( I ), WORK, LDWORK )
*
*              Apply H to A(i:m,i+ib:n) from the left
*
               CALL CLARFB( 'Left', 'No transpose', 'Forward',
     $                      'Columnwise', M-I+1, N-I-IB+1, IB,
     $                      A( I, I ), LDA, WORK, LDWORK, A( I, I+IB ),
     $                      LDA, WORK( IB+1 ), LDWORK )
            END IF
*
*           Apply H to rows i:m of current block
*
            CALL CUNG2R( M-I+1, IB, IB, A( I, I ), LDA, TAU( I ), WORK,
     $                   IINFO )
*
*           Set rows 1:i-1 of current block to zero
*
            DO 40 J = I, I + IB - 1
               DO 30 L = 1, I - 1
                  A( L, J ) = ZERO
   30          CONTINUE
   40       CONTINUE
   50    CONTINUE
      END IF
*
      WORK( 1 ) = IWS
      RETURN
*
*     End of CUNGQR
*
      END

C
C $Id: mdlndm.f,v 1.6 2008-07-27 00:17:07 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MDLNDM (FLNM,ILVL,IAMA,XCRA,YCRA,MCRA,IAAI,IAGI,MNOG,
     +                                                           ULPR)
C
        CHARACTER*(*) FLNM
        INTEGER       ILVL,IAMA(*)
        REAL          XCRA(MCRA),YCRA(MCRA)
        INTEGER       MCRA,IAAI(MNOG),IAGI(MNOG),MNOG
C
        PARAMETER (MNAI=8000)
C
C This routine, given the name, FLNM, of a file of map data in the new
C (as of 4/98) format and the level, ILVL, at which those data are to
C be used, draws the map data described by the file, masked by the
C contents of the area map in IAMA, using the arrays XCRA and YCRA, each
C of which is dimensioned MCRA, as scratch arrays for X and Y coordinate
C data and the arrays IAAI and IAGI, each of which is dimensioned MNOG,
C as scratch arrays for area identifiers and group identifiers.  The
C routine ULPR is a user-supplied line-processing routine.
C
C The following COMMON blocks are used to share information with various
C other routines in EZMAPB or in EZMAP proper.
C
        COMMON /MAPCM2/  BLAM,BLOM,PEPS,SLAM,SLOM,UCEN,UMAX,UMIN,UOFF,
     +                   URNG,VCEN,VMAX,VMIN,VOFF,VRNG,ISSL
        DOUBLE PRECISION BLAM,BLOM,PEPS,SLAM,SLOM,UCEN,UMAX,UMIN,UOFF,
     +                   URNG,VCEN,VMAX,VMIN,VOFF,VRNG
        INTEGER          ISSL
        SAVE   /MAPCM2/
C
        COMMON /MAPCMX/  IATY(MNAI),ISCI(MNAI),IPAR(MNAI)
        INTEGER          IATY,ISCI,IPAR
        SAVE   /MAPCMX/
C
        COMMON /MAPCMY/  NAME(MNAI),FLNS
        CHARACTER*64     NAME
        CHARACTER*512    FLNS
        SAVE   /MAPCMY/
C
        COMMON /MAPCMZ/  NNMS,ILTY,IAIL,IAIR,BLAG,SLAG,BLOG,SLOG,
     +                   PNTS(200)
        INTEGER          NNMS,ILTY,IAIL,IAIR
        REAL             BLAG,SLAG,BLOG,SLOG,PNTS
        SAVE   /MAPCMZ/
C
C FLNL and FLND are character variables in which to form the names of
C files to be read (locally or in the NCAR Graphics database directory).
C
        CHARACTER*519    FLNL
        CHARACTER*1024   FLND
C
C CHRS is a buffer used to read name information.
C
        CHARACTER*1      CHRS(512)
C
C IIII is used in the process of mapping line types into color indices.
C
        INTEGER          IIII(4)
C
C SVOU is a character variable in which to save the value of the EZMAP
C internal parameter named 'OU'.
C
        CHARACTER*2      SVOU
C
C Declare other local variables.
C
        INTEGER          I,IAID,IFDE,ILTS,INTF,IOAL,IOAR,ISTA,IWGF,
     +                   LFND,LFNL,LFNM,LONM,MCHR,NCHR,NPTS
C
        DATA IIII / 5 , 7 , 6 , 8 /
C
C Check for an uncleared prior error.
C
        IF (ICFELL('MDLNDM - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C Form the full names of the ".names" file (locally and in the NCAR
C Graphics database directory).
C
        LFNM=MDILNB(FLNM)
        IF (LFNM.GT.512) GO TO 901
C
        FLNL=FLNM(1:LFNM)//'.names'//CHAR(0)
        LFNL=LFNM+7
C
        CALL MPDBDI (FLND,ISTA)
        IF (ISTA.EQ.-1) GO TO 901
        DO 101 I=1,LEN(FLND)-7-LFNM
          IF (FLND(I:I).EQ.CHAR(0)) THEN
            FLND(I:LEN(FLND))='/'//FLNM(1:LFNM)//'.names'//CHAR(0)
            LFND=I+LFNM+7
            GO TO 102
          ENDIF
  101   CONTINUE
        GO TO 901
C
C If the name of the file to be used is not the same as the one last
C time, re-read name information.
C
  102   IF (FLNM.NE.FLNS) THEN
C
C Open the ".names" file.  Look for a local version first; if that one
C can't be found, look for one in the NCAR Graphics database directory.
C
          CALL NGOFRO (FLNL(1:LFNL),IFDE,ISTA)
          IF (ISTA.NE.0) THEN
            CALL NGOFRO (FLND(1:LFND),IFDE,ISTA)
            IF (ISTA.NE.0) GO TO 902
          END IF
C
C Clear the arrays into which the name information is to be read.
C
          DO 103 I=1,MNAI
            IATY(I)=0
            ISCI(I)=0
            IPAR(I)=0
            NAME(I)=' '
  103     CONTINUE
C
C Read and process all the name information.
C
          MCHR=0
          NCHR=0
C
  104     CALL MDRDNM (IFDE,CHRS,512,MCHR,NCHR,IAID)
          IF (MCHR.EQ.0) GO TO 105
          IF (IAID.LT.1.OR.IAID.GT.MNAI) GO TO 903
          CALL MDRDNM (IFDE,CHRS,512,MCHR,NCHR,IATY(IAID))
          IF (MCHR.EQ.0) GO TO 904
          CALL MDRDNM (IFDE,CHRS,512,MCHR,NCHR,ISCI(IAID))
          IF (MCHR.EQ.0) GO TO 904
          CALL MDRDNM (IFDE,CHRS,512,MCHR,NCHR,IPAR(IAID))
          IF (MCHR.EQ.0) GO TO 904
          CALL MDRDNM (IFDE,CHRS,512,MCHR,NCHR,LONM)
          IF (MCHR.EQ.0) GO TO 904
          NAME(IAID)=' '
          CALL MDRDCS (IFDE,CHRS,512,MCHR,NCHR,NAME(IAID)(1:LONM))
          IF (MCHR.EQ.0) GO TO 904
          GO TO 104
C
  105     CALL NGCLFI (IFDE)
C
C Save the file name, so that the read next time can be skipped.
C
          FLNS=FLNM
C
        END IF
C
C If EZMAP needs initialization, do it.
C
        CALL MDGETI ('IN',INTF)
C
        IF (INTF.NE.0) THEN
          CALL MDPINT
          IF (ICFELL('MDLNDM',2).NE.0) RETURN
        END IF
C
C Open the ".lines" file.  Again, look for a local version first and, if
C that one can't be found, look in the NCAR Graphics database directory.
C
        FLNL(LFNL-6:LFNL-1)='.lines'
        CALL NGOFRO (FLNL(1:LFNL),IFDE,ISTA)
        IF (ISTA.NE.0) THEN
          FLND(LFND-6:LFND-1)='.lines'
          CALL NGOFRO (FLND(1:LFND),IFDE,ISTA)
          IF (ISTA.NE.0) GO TO 905
        END IF
C
C Set the flag IWGF to say whether or not the whole globe is shown by
C the current projection.  If so (IWGF=1), there's no need to waste the
C time required to check each outline point group for intersection with
C the window; otherwise, it is worth it and we do so.
C
        IWGF=0
        IF (BLAM-SLAM.GT.179.D0.AND.BLOM-SLOM.GT.359.D0) IWGF=1
C
C ILTS keeps track of changes in the line type, so that the color index
C can be changed when necessary.
C
        ILTS=0
C
C Read and process each of the lines.
C
  106   CALL NGRDIN (IFDE,NNMS,4,ISTA)
        IF (ISTA.NE.4) GO TO 906
C
        IF (NNMS.LE.1) GO TO 108
C
        IOAL=MDIOSA(IAIL,ILVL)
        IOAR=MDIOSA(IAIR,ILVL)
C
        CALL NGRDFL (IFDE,BLAG,4+NNMS,ISTA)
        IF (ISTA.NE.4+NNMS) GO TO 906
C
        IF (IWGF.EQ.0) THEN
          IF (SLAG.GT.BLAM.OR.BLAG.LT.SLAM) GO TO 106
          IF ((SLOG     .GT.BLOM.OR.BLOG     .LT.SLOM).AND.
     +        (SLOG-360..GT.BLOM.OR.BLOG-360..LT.SLOM).AND.
     +        (SLOG+360..GT.BLOM.OR.BLOG+360..LT.SLOM)) GO TO 106
        END IF
C
        IF (ILTY.LE.ILVL) THEN
          NPTS=NNMS/2
          CALL HLUMPCHLN (+2,ILTY,IOAL,IOAR,NPTS,PNTS)
          IF (NPTS.LE.1) GO TO 106
          IF (ILTY.NE.ILTS) THEN
            IF (ILTS.NE.0) THEN
              CALL MDPCHM (-IIII(MAX(2,MIN(5,ILTS))-1),0,
     +                          IAMA,XCRA,YCRA,MCRA,IAAI,IAGI,MNOG,ULPR)
              IF (ICFELL('MDLNDM',3).NE.0) RETURN
            END IF
            CALL MDPCHM (IIII(MAX(2,MIN(5,ILTY))-1),
     +                                           IOR(ISHIFT(32767,1),1),
     +                          IAMA,XCRA,YCRA,MCRA,IAAI,IAGI,MNOG,ULPR)
            IF (ICFELL('MDLNDM',4).NE.0) RETURN
            ILTS=ILTY
          END IF
          CALL MAPITM (PNTS(1),PNTS(2),0,
     +                          IAMA,XCRA,YCRA,MCRA,IAAI,IAGI,MNOG,ULPR)
          IF (ICFELL('MDLNDM',5).NE.0) GO TO 907
          DO 107 I=3,NNMS-3,2
            CALL MAPITM (PNTS(I),PNTS(I+1),1,
     +                          IAMA,XCRA,YCRA,MCRA,IAAI,IAGI,MNOG,ULPR)
            IF (ICFELL('MDLNDM',6).NE.0) GO TO 907
  107     CONTINUE
          CALL MAPITM (PNTS(NNMS-1),PNTS(NNMS),2,
     +                          IAMA,XCRA,YCRA,MCRA,IAAI,IAGI,MNOG,ULPR)
          IF (ICFELL('MDLNDM',7).NE.0) GO TO 907
          CALL MAPIQM (         IAMA,XCRA,YCRA,MCRA,IAAI,IAGI,MNOG,ULPR)
          IF (ICFELL('MDLNDM',8).NE.0) GO TO 907
          CALL HLUMPCHLN (-2,ILTY,IOAL,IOAR,NPTS,PNTS)
        END IF
C
        GO TO 106
C
  108   CALL NGCLFI (IFDE)
C
C Reset the color index, dotting, and dash pattern, if necessary.
C
        IF (ILTS.NE.0) THEN
          CALL MDPCHM (-IIII(MAX(2,MIN(5,ILTS))-1),0,
     +                          IAMA,XCRA,YCRA,MCRA,IAAI,IAGI,MNOG,ULPR)
          IF (ICFELL('MDLNDM',9).NE.0) RETURN
        END IF
C
C Use the EZMAPA routine MAPBLM to draw a perimeter and limb lines (if
C any).
C
        CALL MDGETC ('OU',SVOU)
        CALL MDSETC ('OU','NO')
        CALL MDPBLM (IAMA,XCRA,YCRA,MCRA,IAAI,IAGI,MNOG,ULPR)
        IF (ICFELL('MDLNDM',10).NE.0) RETURN
        CALL MDSETC ('OU',SVOU)
C
C Done.
C
        RETURN
C
C Error exits.
C
  901   CALL SETER ('MDLNDM - Can''t form name of ".names" file',10,1)
        RETURN
C
  902   CALL SETER ('MDLNDM - Can''t open the ".names" file',11,1)
        RETURN
C
  903   CALL SETER ('MDLNDM - Read bad index from ".names" file',12,1)
        CALL NGCLFI (IFDE)
        RETURN
C
  904   CALL SETER ('MDLNDM - Read error on ".names" file',13,1)
        CALL NGCLFI (IFDE)
        RETURN
C
  905   CALL SETER ('MDLNDM - Can''t open the ".lines" file',14,1)
        RETURN
C
  906   CALL SETER ('MDLNDM - Read error on ".lines" file',15,1)
        CALL NGCLFI (IFDE)
        RETURN
C
  907   CALL NGCLFI (IFDE)
        RETURN
C
      END

      SUBROUTINE DTGSYL( TRANS, IJOB, M, N, A, LDA, B, LDB, C, LDC, D,
     $                   LDD, E, LDE, F, LDF, SCALE, DIF, WORK, LWORK,
     $                   IWORK, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          TRANS
      INTEGER            IJOB, INFO, LDA, LDB, LDC, LDD, LDE, LDF,
     $                   LWORK, M, N
      DOUBLE PRECISION   DIF, SCALE
*     ..
*     .. Array Arguments ..
      INTEGER            IWORK( * )
      DOUBLE PRECISION   A( LDA, * ), B( LDB, * ), C( LDC, * ),
     $                   D( LDD, * ), E( LDE, * ), F( LDF, * ),
     $                   WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  DTGSYL solves the generalized Sylvester equation:
*
*              A * R - L * B = scale * C                 (1)
*              D * R - L * E = scale * F
*
*  where R and L are unknown m-by-n matrices, (A, D), (B, E) and
*  (C, F) are given matrix pairs of size m-by-m, n-by-n and m-by-n,
*  respectively, with real entries. (A, D) and (B, E) must be in
*  generalized (real) Schur canonical form, i.e. A, B are upper quasi
*  triangular and D, E are upper triangular.
*
*  The solution (R, L) overwrites (C, F). 0 <= SCALE <= 1 is an output
*  scaling factor chosen to avoid overflow.
*
*  In matrix notation (1) is equivalent to solve  Zx = scale b, where
*  Z is defined as
*
*             Z = [ kron(In, A)  -kron(B', Im) ]         (2)
*                 [ kron(In, D)  -kron(E', Im) ].
*
*  Here Ik is the identity matrix of size k and X' is the transpose of
*  X. kron(X, Y) is the Kronecker product between the matrices X and Y.
*
*  If TRANS = 'T', DTGSYL solves the transposed system Z'*y = scale*b,
*  which is equivalent to solve for R and L in
*
*              A' * R  + D' * L   = scale *  C           (3)
*              R  * B' + L  * E'  = scale * (-F)
*
*  This case (TRANS = 'T') is used to compute an one-norm-based estimate
*  of Dif[(A,D), (B,E)], the separation between the matrix pairs (A,D)
*  and (B,E), using DLACON.
*
*  If IJOB >= 1, DTGSYL computes a Frobenius norm-based estimate
*  of Dif[(A,D),(B,E)]. That is, the reciprocal of a lower bound on the
*  reciprocal of the smallest singular value of Z. See [1-2] for more
*  information.
*
*  This is a level 3 BLAS algorithm.
*
*  Arguments
*  =========
*
*  TRANS   (input) CHARACTER*1
*          = 'N', solve the generalized Sylvester equation (1).
*          = 'T', solve the 'transposed' system (3).
*
*  IJOB    (input) INTEGER
*          Specifies what kind of functionality to be performed.
*           =0: solve (1) only.
*           =1: The functionality of 0 and 3.
*           =2: The functionality of 0 and 4.
*           =3: Only an estimate of Dif[(A,D), (B,E)] is computed.
*               (look ahead strategy IJOB  = 1 is used).
*           =4: Only an estimate of Dif[(A,D), (B,E)] is computed.
*               ( DGECON on sub-systems is used ).
*          Not referenced if TRANS = 'T'.
*
*  M       (input) INTEGER
*          The order of the matrices A and D, and the row dimension of
*          the matrices C, F, R and L.
*
*  N       (input) INTEGER
*          The order of the matrices B and E, and the column dimension
*          of the matrices C, F, R and L.
*
*  A       (input) DOUBLE PRECISION array, dimension (LDA, M)
*          The upper quasi triangular matrix A.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A. LDA >= max(1, M).
*
*  B       (input) DOUBLE PRECISION array, dimension (LDB, N)
*          The upper quasi triangular matrix B.
*
*  LDB     (input) INTEGER
*          The leading dimension of the array B. LDB >= max(1, N).
*
*  C       (input/output) DOUBLE PRECISION array, dimension (LDC, N)
*          On entry, C contains the right-hand-side of the first matrix
*          equation in (1) or (3).
*          On exit, if IJOB = 0, 1 or 2, C has been overwritten by
*          the solution R. If IJOB = 3 or 4 and TRANS = 'N', C holds R,
*          the solution achieved during the computation of the
*          Dif-estimate.
*
*  LDC     (input) INTEGER
*          The leading dimension of the array C. LDC >= max(1, M).
*
*  D       (input) DOUBLE PRECISION array, dimension (LDD, M)
*          The upper triangular matrix D.
*
*  LDD     (input) INTEGER
*          The leading dimension of the array D. LDD >= max(1, M).
*
*  E       (input) DOUBLE PRECISION array, dimension (LDE, N)
*          The upper triangular matrix E.
*
*  LDE     (input) INTEGER
*          The leading dimension of the array E. LDE >= max(1, N).
*
*  F       (input/output) DOUBLE PRECISION array, dimension (LDF, N)
*          On entry, F contains the right-hand-side of the second matrix
*          equation in (1) or (3).
*          On exit, if IJOB = 0, 1 or 2, F has been overwritten by
*          the solution L. If IJOB = 3 or 4 and TRANS = 'N', F holds L,
*          the solution achieved during the computation of the
*          Dif-estimate.
*
*  LDF     (input) INTEGER
*          The leading dimension of the array F. LDF >= max(1, M).
*
*  DIF     (output) DOUBLE PRECISION
*          On exit DIF is the reciprocal of a lower bound of the
*          reciprocal of the Dif-function, i.e. DIF is an upper bound of
*          Dif[(A,D), (B,E)] = sigma_min(Z), where Z as in (2).
*          IF IJOB = 0 or TRANS = 'T', DIF is not touched.
*
*  SCALE   (output) DOUBLE PRECISION
*          On exit SCALE is the scaling factor in (1) or (3).
*          If 0 < SCALE < 1, C and F hold the solutions R and L, resp.,
*          to a slightly perturbed system but the input matrices A, B, D
*          and E have not been changed. If SCALE = 0, C and F hold the
*          solutions R and L, respectively, to the homogeneous system
*          with C = F = 0. Normally, SCALE = 1.
*
*  WORK    (workspace/output) DOUBLE PRECISION array, dimension (LWORK)
*          If IJOB = 0, WORK is not referenced.  Otherwise,
*          on exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*
*  LWORK   (input) INTEGER
*          The dimension of the array WORK. LWORK > = 1.
*          If IJOB = 1 or 2 and TRANS = 'N', LWORK >= 2*M*N.
*
*          If LWORK = -1, then a workspace query is assumed; the routine
*          only calculates the optimal size of the WORK array, returns
*          this value as the first entry of the WORK array, and no error
*          message related to LWORK is issued by XERBLA.
*
*  IWORK   (workspace) INTEGER array, dimension (M+N+6)
*
*  INFO    (output) INTEGER
*            =0: successful exit
*            <0: If INFO = -i, the i-th argument had an illegal value.
*            >0: (A, D) and (B, E) have common or close eigenvalues.
*
*  Further Details
*  ===============
*
*  Based on contributions by
*     Bo Kagstrom and Peter Poromaa, Department of Computing Science,
*     Umea University, S-901 87 Umea, Sweden.
*
*  [1] B. Kagstrom and P. Poromaa, LAPACK-Style Algorithms and Software
*      for Solving the Generalized Sylvester Equation and Estimating the
*      Separation between Regular Matrix Pairs, Report UMINF - 93.23,
*      Department of Computing Science, Umea University, S-901 87 Umea,
*      Sweden, December 1993, Revised April 1994, Also as LAPACK Working
*      Note 75.  To appear in ACM Trans. on Math. Software, Vol 22,
*      No 1, 1996.
*
*  [2] B. Kagstrom, A Perturbation Analysis of the Generalized Sylvester
*      Equation (AR - LB, DR - LE ) = (C, F), SIAM J. Matrix Anal.
*      Appl., 15(4):1045-1060, 1994
*
*  [3] B. Kagstrom and L. Westin, Generalized Schur Methods with
*      Condition Estimators for Solving the Generalized Sylvester
*      Equation, IEEE Transactions on Automatic Control, Vol. 34, No. 7,
*      July 1989, pp 745-751.
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO, ONE
      PARAMETER          ( ZERO = 0.0D+0, ONE = 1.0D+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            LQUERY, NOTRAN
      INTEGER            I, IE, IFUNC, IROUND, IS, ISOLVE, J, JE, JS, K,
     $                   LINFO, LWMIN, MB, NB, P, PPQQ, PQ, Q
      DOUBLE PRECISION   DSCALE, DSUM, SCALE2, SCALOC
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            ILAENV
      EXTERNAL           LSAME, ILAENV
*     ..
*     .. External Subroutines ..
      EXTERNAL           DCOPY, DGEMM, DLACPY, DSCAL, DTGSY2, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          DBLE, MAX, SQRT
*     ..
*     .. Executable Statements ..
*
*     Decode and test input parameters
*
      INFO = 0
      NOTRAN = LSAME( TRANS, 'N' )
      LQUERY = ( LWORK.EQ.-1 )
*
      IF( ( IJOB.EQ.1 .OR. IJOB.EQ.2 ) .AND. NOTRAN ) THEN
         LWMIN = MAX( 1, 2*M*N )
      ELSE
         LWMIN = 1
      END IF
*
      IF( .NOT.NOTRAN .AND. .NOT.LSAME( TRANS, 'T' ) ) THEN
         INFO = -1
      ELSE IF( ( IJOB.LT.0 ) .OR. ( IJOB.GT.4 ) ) THEN
         INFO = -2
      ELSE IF( M.LE.0 ) THEN
         INFO = -3
      ELSE IF( N.LE.0 ) THEN
         INFO = -4
      ELSE IF( LDA.LT.MAX( 1, M ) ) THEN
         INFO = -6
      ELSE IF( LDB.LT.MAX( 1, N ) ) THEN
         INFO = -8
      ELSE IF( LDC.LT.MAX( 1, M ) ) THEN
         INFO = -10
      ELSE IF( LDD.LT.MAX( 1, M ) ) THEN
         INFO = -12
      ELSE IF( LDE.LT.MAX( 1, N ) ) THEN
         INFO = -14
      ELSE IF( LDF.LT.MAX( 1, M ) ) THEN
         INFO = -16
      ELSE IF( LWORK.LT.LWMIN .AND. .NOT.LQUERY ) THEN
         INFO = -20
      END IF
*
      IF( INFO.EQ.0 ) THEN
         WORK( 1 ) = LWMIN
      END IF
*
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DTGSYL', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         RETURN
      END IF
*
*     Determine optimal block sizes MB and NB
*
      MB = ILAENV( 2, 'DTGSYL', TRANS, M, N, -1, -1 )
      NB = ILAENV( 5, 'DTGSYL', TRANS, M, N, -1, -1 )
*
      ISOLVE = 1
      IFUNC = 0
      IF( IJOB.GE.3 .AND. NOTRAN ) THEN
         IFUNC = IJOB - 2
         DO 10 J = 1, N
            CALL DCOPY( M, ZERO, 0, C( 1, J ), 1 )
            CALL DCOPY( M, ZERO, 0, F( 1, J ), 1 )
   10    CONTINUE
      ELSE IF( IJOB.GE.1 .AND. NOTRAN ) THEN
         ISOLVE = 2
      END IF
*
      IF( ( MB.LE.1 .AND. NB.LE.1 ) .OR. ( MB.GE.M .AND. NB.GE.N ) )
     $     THEN
*
         DO 30 IROUND = 1, ISOLVE
*
*           Use unblocked Level 2 solver
*
            DSCALE = ZERO
            DSUM = ONE
            PQ = 0
            CALL DTGSY2( TRANS, IFUNC, M, N, A, LDA, B, LDB, C, LDC, D,
     $                   LDD, E, LDE, F, LDF, SCALE, DSUM, DSCALE,
     $                   IWORK, PQ, INFO )
            IF( DSCALE.NE.ZERO ) THEN
               IF( IJOB.EQ.1 .OR. IJOB.EQ.3 ) THEN
                  DIF = SQRT( DBLE( 2*M*N ) ) / ( DSCALE*SQRT( DSUM ) )
               ELSE
                  DIF = SQRT( DBLE( PQ ) ) / ( DSCALE*SQRT( DSUM ) )
               END IF
            END IF
*
            IF( ISOLVE.EQ.2 .AND. IROUND.EQ.1 ) THEN
               IFUNC = IJOB
               SCALE2 = SCALE
               CALL DLACPY( 'F', M, N, C, LDC, WORK, M )
               CALL DLACPY( 'F', M, N, F, LDF, WORK( M*N+1 ), M )
               DO 20 J = 1, N
                  CALL DCOPY( M, ZERO, 0, C( 1, J ), 1 )
                  CALL DCOPY( M, ZERO, 0, F( 1, J ), 1 )
   20          CONTINUE
            ELSE IF( ISOLVE.EQ.2 .AND. IROUND.EQ.2 ) THEN
               CALL DLACPY( 'F', M, N, WORK, M, C, LDC )
               CALL DLACPY( 'F', M, N, WORK( M*N+1 ), M, F, LDF )
               SCALE = SCALE2
            END IF
   30    CONTINUE
*
         RETURN
      END IF
*
*     Determine block structure of A
*
      P = 0
      I = 1
   40 CONTINUE
      IF( I.GT.M )
     $   GO TO 50
      P = P + 1
      IWORK( P ) = I
      I = I + MB
      IF( I.GE.M )
     $   GO TO 50
      IF( A( I, I-1 ).NE.ZERO )
     $   I = I + 1
      GO TO 40
   50 CONTINUE
*
      IWORK( P+1 ) = M + 1
      IF( IWORK( P ).EQ.IWORK( P+1 ) )
     $   P = P - 1
*
*     Determine block structure of B
*
      Q = P + 1
      J = 1
   60 CONTINUE
      IF( J.GT.N )
     $   GO TO 70
      Q = Q + 1
      IWORK( Q ) = J
      J = J + NB
      IF( J.GE.N )
     $   GO TO 70
      IF( B( J, J-1 ).NE.ZERO )
     $   J = J + 1
      GO TO 60
   70 CONTINUE
*
      IWORK( Q+1 ) = N + 1
      IF( IWORK( Q ).EQ.IWORK( Q+1 ) )
     $   Q = Q - 1
*
      IF( NOTRAN ) THEN
*
         DO 150 IROUND = 1, ISOLVE
*
*           Solve (I, J)-subsystem
*               A(I, I) * R(I, J) - L(I, J) * B(J, J) = C(I, J)
*               D(I, I) * R(I, J) - L(I, J) * E(J, J) = F(I, J)
*           for I = P, P - 1,..., 1; J = 1, 2,..., Q
*
            DSCALE = ZERO
            DSUM = ONE
            PQ = 0
            SCALE = ONE
            DO 130 J = P + 2, Q
               JS = IWORK( J )
               JE = IWORK( J+1 ) - 1
               NB = JE - JS + 1
               DO 120 I = P, 1, -1
                  IS = IWORK( I )
                  IE = IWORK( I+1 ) - 1
                  MB = IE - IS + 1
                  PPQQ = 0
                  CALL DTGSY2( TRANS, IFUNC, MB, NB, A( IS, IS ), LDA,
     $                         B( JS, JS ), LDB, C( IS, JS ), LDC,
     $                         D( IS, IS ), LDD, E( JS, JS ), LDE,
     $                         F( IS, JS ), LDF, SCALOC, DSUM, DSCALE,
     $                         IWORK( Q+2 ), PPQQ, LINFO )
                  IF( LINFO.GT.0 )
     $               INFO = LINFO
*
                  PQ = PQ + PPQQ
                  IF( SCALOC.NE.ONE ) THEN
                     DO 80 K = 1, JS - 1
                        CALL DSCAL( M, SCALOC, C( 1, K ), 1 )
                        CALL DSCAL( M, SCALOC, F( 1, K ), 1 )
   80                CONTINUE
                     DO 90 K = JS, JE
                        CALL DSCAL( IS-1, SCALOC, C( 1, K ), 1 )
                        CALL DSCAL( IS-1, SCALOC, F( 1, K ), 1 )
   90                CONTINUE
                     DO 100 K = JS, JE
                        CALL DSCAL( M-IE, SCALOC, C( IE+1, K ), 1 )
                        CALL DSCAL( M-IE, SCALOC, F( IE+1, K ), 1 )
  100                CONTINUE
                     DO 110 K = JE + 1, N
                        CALL DSCAL( M, SCALOC, C( 1, K ), 1 )
                        CALL DSCAL( M, SCALOC, F( 1, K ), 1 )
  110                CONTINUE
                     SCALE = SCALE*SCALOC
                  END IF
*
*                 Substitute R(I, J) and L(I, J) into remaining
*                 equation.
*
                  IF( I.GT.1 ) THEN
                     CALL DGEMM( 'N', 'N', IS-1, NB, MB, -ONE,
     $                           A( 1, IS ), LDA, C( IS, JS ), LDC, ONE,
     $                           C( 1, JS ), LDC )
                     CALL DGEMM( 'N', 'N', IS-1, NB, MB, -ONE,
     $                           D( 1, IS ), LDD, C( IS, JS ), LDC, ONE,
     $                           F( 1, JS ), LDF )
                  END IF
                  IF( J.LT.Q ) THEN
                     CALL DGEMM( 'N', 'N', MB, N-JE, NB, ONE,
     $                           F( IS, JS ), LDF, B( JS, JE+1 ), LDB,
     $                           ONE, C( IS, JE+1 ), LDC )
                     CALL DGEMM( 'N', 'N', MB, N-JE, NB, ONE,
     $                           F( IS, JS ), LDF, E( JS, JE+1 ), LDE,
     $                           ONE, F( IS, JE+1 ), LDF )
                  END IF
  120          CONTINUE
  130       CONTINUE
            IF( DSCALE.NE.ZERO ) THEN
               IF( IJOB.EQ.1 .OR. IJOB.EQ.3 ) THEN
                  DIF = SQRT( DBLE( 2*M*N ) ) / ( DSCALE*SQRT( DSUM ) )
               ELSE
                  DIF = SQRT( DBLE( PQ ) ) / ( DSCALE*SQRT( DSUM ) )
               END IF
            END IF
            IF( ISOLVE.EQ.2 .AND. IROUND.EQ.1 ) THEN
               IFUNC = IJOB
               SCALE2 = SCALE
               CALL DLACPY( 'F', M, N, C, LDC, WORK, M )
               CALL DLACPY( 'F', M, N, F, LDF, WORK( M*N+1 ), M )
               DO 140 J = 1, N
                  CALL DCOPY( M, ZERO, 0, C( 1, J ), 1 )
                  CALL DCOPY( M, ZERO, 0, F( 1, J ), 1 )
  140          CONTINUE
            ELSE IF( ISOLVE.EQ.2 .AND. IROUND.EQ.2 ) THEN
               CALL DLACPY( 'F', M, N, WORK, M, C, LDC )
               CALL DLACPY( 'F', M, N, WORK( M*N+1 ), M, F, LDF )
               SCALE = SCALE2
            END IF
  150    CONTINUE
*
      ELSE
*
*        Solve transposed (I, J)-subsystem
*             A(I, I)' * R(I, J)  + D(I, I)' * L(I, J)  =  C(I, J)
*             R(I, J)  * B(J, J)' + L(I, J)  * E(J, J)' = -F(I, J)
*        for I = 1,2,..., P; J = Q, Q-1,..., 1
*
         SCALE = ONE
         DO 210 I = 1, P
            IS = IWORK( I )
            IE = IWORK( I+1 ) - 1
            MB = IE - IS + 1
            DO 200 J = Q, P + 2, -1
               JS = IWORK( J )
               JE = IWORK( J+1 ) - 1
               NB = JE - JS + 1
               CALL DTGSY2( TRANS, IFUNC, MB, NB, A( IS, IS ), LDA,
     $                      B( JS, JS ), LDB, C( IS, JS ), LDC,
     $                      D( IS, IS ), LDD, E( JS, JS ), LDE,
     $                      F( IS, JS ), LDF, SCALOC, DSUM, DSCALE,
     $                      IWORK( Q+2 ), PPQQ, LINFO )
               IF( LINFO.GT.0 )
     $            INFO = LINFO
               IF( SCALOC.NE.ONE ) THEN
                  DO 160 K = 1, JS - 1
                     CALL DSCAL( M, SCALOC, C( 1, K ), 1 )
                     CALL DSCAL( M, SCALOC, F( 1, K ), 1 )
  160             CONTINUE
                  DO 170 K = JS, JE
                     CALL DSCAL( IS-1, SCALOC, C( 1, K ), 1 )
                     CALL DSCAL( IS-1, SCALOC, F( 1, K ), 1 )
  170             CONTINUE
                  DO 180 K = JS, JE
                     CALL DSCAL( M-IE, SCALOC, C( IE+1, K ), 1 )
                     CALL DSCAL( M-IE, SCALOC, F( IE+1, K ), 1 )
  180             CONTINUE
                  DO 190 K = JE + 1, N
                     CALL DSCAL( M, SCALOC, C( 1, K ), 1 )
                     CALL DSCAL( M, SCALOC, F( 1, K ), 1 )
  190             CONTINUE
                  SCALE = SCALE*SCALOC
               END IF
*
*              Substitute R(I, J) and L(I, J) into remaining equation.
*
               IF( J.GT.P+2 ) THEN
                  CALL DGEMM( 'N', 'T', MB, JS-1, NB, ONE, C( IS, JS ),
     $                        LDC, B( 1, JS ), LDB, ONE, F( IS, 1 ),
     $                        LDF )
                  CALL DGEMM( 'N', 'T', MB, JS-1, NB, ONE, F( IS, JS ),
     $                        LDF, E( 1, JS ), LDE, ONE, F( IS, 1 ),
     $                        LDF )
               END IF
               IF( I.LT.P ) THEN
                  CALL DGEMM( 'T', 'N', M-IE, NB, MB, -ONE,
     $                        A( IS, IE+1 ), LDA, C( IS, JS ), LDC, ONE,
     $                        C( IE+1, JS ), LDC )
                  CALL DGEMM( 'T', 'N', M-IE, NB, MB, -ONE,
     $                        D( IS, IE+1 ), LDD, F( IS, JS ), LDF, ONE,
     $                        C( IE+1, JS ), LDC )
               END IF
  200       CONTINUE
  210    CONTINUE
*
      END IF
*
      WORK( 1 ) = LWMIN
*
      RETURN
*
*     End of DTGSYL
*
      END

C
C $Id: lbfill.f,v 1.5 2008-07-27 00:17:17 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE LBFILL (IFTP,XCRA,YCRA,NCRA,INDX)
        DIMENSION XCRA(*),YCRA(*)
        CALL GSFACI (INDX)
        CALL GFA (NCRA-1,XCRA,YCRA)
        RETURN
      END

      PROGRAM CCPRWC
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER (K=400,N=400,LRWK=2000,LIWK=2000)
      REAL Z(K,N), RWRK(LRWK)
      INTEGER M, IWRK(LIWK)

      CALL GETDAT (Z, K, M, N) 
C
C Open GKS
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Initialize Conpack
C
      CALL CPRECT(Z,K,M,N,RWRK,LRWK,IWRK,LIWK)
C
C Draw perimeter
C
      CALL CPBACK(Z, RWRK, IWRK)
C
C Turn on line labels for every line
C
      CALL CPPKCL(Z, RWRK, IWRK)
      CALL CPGETI('NCL - NUMBER OF CONTOUR LEVELS',NCL)
      DO 10, I=1,NCL
         CALL CPSETI('PAI - PARAMETER ARRAY INDEX',I)
         CALL CPSETI('CLU - CONTOUR LEVEL USE FLAG',3)
 10   CONTINUE
C
C Set RWC so that labels come out on some lines
C
      CALL CPSETI('RWC - REAL WORKSPACE FOR CONTOURS',125)
C
C Draw Contours
C
      CALL CPCLDR(Z,RWRK,IWRK)
C
C Close frame and close GKS
C
      CALL FRAME
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS

      STOP
      END

      SUBROUTINE GETDAT (Z, K, M, N)
      INTEGER I,J,K,M,N
      REAL Z(K,N)

      M=K
      DO 10, I=1,M
         DO 20, J=1,N
            Z(I,J)= 10.E-8*(-16.*REAL(I**2*J) +
     +            34*REAL(I*J**2) - REAL(6*I) + 93.)
 20      CONTINUE
 10   CONTINUE

      RETURN
      END

C NCLFORTSTART
      subroutine x1pdf77(nx,x,xmsg, nbx, pdf
     *                   ,nbxp1,binxbnd,ipcnt,ier)
      implicit none
      integer  nx, nbx, nbxp1, ipcnt,ier
      double precision x(nx), xmsg, binxbnd(nbxp1)
C                                    ! output
      double precision pdf(nbx)
C NCLEND
      integer n, nb, kx, unit, msgflg 

      ier = 0
      do nb=1,nbx
         pdf(nb) = 0.0d0
      end do

c number of non-missing values

      kx = 0
      do n=1,nx 
         if (x(n).ne.xmsg) kx = kx + 1
      end do

c Valid data check

      if (kx.eq.0) then
          ier = 1
          return
      end if

c Very large arrays can result in slow execution times. 
c .   To minimize unnecessary do loop checks, see if missing
c .   values are present.

      msgflg = 1
      if (kx.eq.nx) msgflg = 0

c Binning

      if (msgflg.eq.1) then
            do nb=1,nbx
              do n=1,nx 
                 if (x(n).ne.xmsg .and.
     *               x(n).ge.binxbnd(nb)  .and. 
     *               x(n).lt.binxbnd(nb+1)) then
                     pdf(nb) = pdf(nb) + 1
                 end if
              end do
            end do
      else
            do nb=1,nbx
              do n=1,nx 
                 if (x(n).ge.binxbnd(nb)  .and. 
     *               x(n).lt.binxbnd(nb+1)) then
                     pdf(nb) = pdf(nb) + 1
                 end if
              end do
            end do
      end if

c special case for last bin

      do n=1,nx 
         if (x(n).eq.binxbnd(nbx+1)) then
             pdf(nbx) = pdf(nbx) + 1
         end if
      end do

c change return units to % if flag set

      unit = 1
      if (ipcnt.eq.1) then
          unit = 100
          do nb=1,nbx
             pdf(nb) = unit*(pdf(nb)/kx)
          end do
      end if

      return
      end

C
C	$Id: conecd.f,v 1.5 2008-07-27 00:16:55 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CONECD (VAL,IOUT,NUSED)
C
C  ENCODE A NUMBER IN THE LEAST AMOUNT OF SPACE
C  ON INPUT
C       VAL THE NUMBER TO BE ENCODED
C  ON OUTPUT
C       IOUT CHARACTER STRING FILLED WITH THE ENCODED RESULT, MUST BE ABLE TO
C            HOLD UP TO 9 CHARACTERS.
C
C     NUSED NUMBER OF CHARACTERS IN IOUT
C
C  VALUE INPUT WILL BE SCALED BY SCALE IN CONRA2
C
C
C
C
      COMMON /CONRA1/ CL(30)     ,NCL        ,OLDZ       ,PV(210)    ,
     1                FINC       ,HI         ,FLO
      COMMON /CONRA2/ REPEAT     ,EXTRAP     ,PER        ,MESS       ,
     1                ISCALE     ,LOOK       ,PLDVLS     ,GRD        ,
     2                CINC       ,CHILO      ,CON        ,LABON      ,
     3                PMIMX      ,SCALE      ,FRADV      ,EXTRI      ,
     4                BPSIZ      ,LISTOP
      COMMON /CONRA3/ IREC
      COMMON /CONRA4/ NCP        ,NCPSZ
      COMMON /CONRA5/ NIT        ,ITIPV
      COMMON /CONRA6/ XST        ,YST        ,XED        ,YED        ,
     1                STPSZ      ,IGRAD      ,IG         ,XRG        ,
     2                YRG        ,BORD       ,PXST       ,PYST       ,
     3                PXED       ,PYED       ,ITICK
      COMMON /CONR18/ TITLE      ,ICNT   ,ITLSIZ
      COMMON /CONR19/ IHIGH      ,INMAJ      ,INLAB      ,INDAT      ,
     1              LEN      ,IFMT       ,LEND       ,
     2                IFMTD      ,ISIZEP     ,INMIN
      COMMON /CONRA9/ ICOORD(500),  NP       ,MXXY       ,TR         ,
     1                BR         ,TL         ,BL         ,CONV       ,
     2                XN         ,YN         ,ITLL       ,IBLL       ,
     3                ITRL       ,IBRL       ,XC         ,YC         ,
     4                ITLOC(210) ,JX         ,JY         ,ILOC       ,
     5                ISHFCT     ,XO         ,YO         ,IOC        ,NC
      COMMON /CONR10/ NT         ,NL         ,NTNL       ,JWIPT      ,
     1                JWIWL      ,JWIWP      ,JWIPL      ,IPR        ,
     2                ITPV
      COMMON /CONR20/ NREP       ,NCRT       ,ISIZEL     ,
     1                MINGAP     ,ISIZEM         ,
     2                TENS
      COMMON /CONR12/ IXMAX      ,IYMAX      ,XMAX       ,YMAX
      LOGICAL         REPEAT     ,EXTRAP     ,PER        ,MESS       ,
     1                LOOK       ,PLDVLS     ,GRD        ,LABON      ,
     2                PMIMX      ,FRADV      ,EXTRI      ,CINC       ,
     3                TITLE      ,LISTOP     ,CHILO      ,CON
      COMMON /CONR15/ ISTRNG
        CHARACTER*64 ISTRNG
        COMMON /CONR16/ FORM
        CHARACTER*10 FORM
        COMMON /CONR17/ NDASH, IDASH, EDASH
        CHARACTER*10 NDASH, IDASH, EDASH
C
C
        CHARACTER*(*)   IOUT
        CHARACTER*9     CHTMP
        CHARACTER*6     IFMT1
        CHARACTER*1     IT
C
        SAVE
C
      V = VAL
C
C  IF VAL EQUALS ZERO EASY PROCESSING
C
      IF (V.NE.0.) GO TO    20
        IOUT = '0.0'
      NUSED = 3
      RETURN
C
C  SCALE VALUE
C
   20 V = V*SCALE
C
C  GET SIZE OF NUMBER
C
      LOG = INT(ALOG10(ABS(V))+.1)
      IF (ABS(LOG).GT.4) GO TO    60
C
C  COMPUTE FLOATING POINT FIELD
C
      NS = ABS(LOG)+3
      ND = 1
      IF (LOG.GT.0) GO TO    40
C
C  LOG = 0 TEST FOR FRACTIONAL PART ONLY
C
      IF (ALOG10( ABS(V) ).GE.0.) GO TO    30
C
C  NUMBER LT 1 BUT GREATER THAN ZERO IN ABSOLUTE VALUE
C
      NS = 4
      ND = 1
      GO TO    40
C
C  NUMBER LESS THAN 10 BUT GE 1
C
   30 ND = 1
      NS = 4
C
C  BUILD THE FORMAT
C
   40 IF (V.LT.0) NS = NS+1
        IFMT1 = '(F . )'
C
C  INSERT THE FLOATING POINT FORMAT SIZE
C
        WRITE(IT,'(I1)')NS
        IFMT1(3:3) = IT
        WRITE(IT,'(I1)')ND
        IFMT1(5:5) = IT
C
C  ENCODE THE DESIRED NUMBER
C
        WRITE(CHTMP,IFMT1)V
        IOUT = CHTMP
      NUSED = NS
      RETURN
C
C  DATA LARGER THAN A NICE SIZE FORCE IT TO BE ENCODED
C
  60  WRITE(CHTMP,'(E8.3)')V
      IOUT = CHTMP
      NUSED = 8
      RETURN
C
C******************************************************************
C*                                                                *
C*                   REVISION HISTORY                             *
C*                                                                *
C*  JUNE 1980   ADDED CONCOM TO ULIB                              *
C*  AUGUST 1980 FIXED BOARDER CONTOUR DETECTION                   *
C*  DECEMBER 1980 FIXED ERROR TRAP, CONTOUR REORDERING ALGORITHM  *
C*                AND ERROR MESSAGE 10                            *
C*  AUGUST 1983 ADDED LINEAR INTERPOLATION AND SHIELDING          *
C*  JULY 1984 CONVERTED TO FORTRAN77 AND GKS                      *
C*  AUGUST 1985 DELETED (MACHINE DEPENDENT) FUNCTION LOC; CHANGED *
C*              COMMON /CONR13/                                   *
C*  JUNE 1988   CHANGED THREE COMMON BLOCK NAMES TO GET RID OF    *
C*              WARNING MESSAGES FROM SEGLDR ON THE CRAY          *
C*                                                                *
C******************************************************************
C
      END

C
C     $Id: sgefa.f,v 1.1 1994-08-11 23:17:32 boote Exp $
C


      SUBROUTINE SGEFA (A,LDA,N,IPVT,INFO)
      INTEGER LDA,N,IPVT(1),INFO
      REAL A(LDA,1)
C
C     SGEFA FACTORS A REAL MATRIX BY GAUSSIAN ELIMINATION.
C
C     SGEFA IS USUALLY CALLED BY SGECO, BUT IT CAN BE CALLED
C     DIRECTLY WITH A SAVING IN TIME IF  RCOND  IS NOT NEEDED.
C     (TIME FOR SGECO) = (1 + 9/N)*(TIME FOR SGEFA) .
C
C     ON ENTRY
C
C        A       REAL(LDA, N)
C                THE MATRIX TO BE FACTORED.
C
C        LDA     INTEGER
C                THE LEADING DIMENSION OF THE ARRAY  A .
C
C        N       INTEGER
C                THE ORDER OF THE MATRIX  A .
C
C     ON RETURN
C
C        A       AN UPPER TRIANGULAR MATRIX AND THE MULTIPLIERS
C                WHICH WERE USED TO OBTAIN IT.
C                THE FACTORIZATION CAN BE WRITTEN  A = L*U  WHERE
C                L  IS A PRODUCT OF PERMUTATION AND UNIT LOWER
C                TRIANGULAR MATRICES AND  U  IS UPPER TRIANGULAR.
C
C        IPVT    INTEGER(N)
C                AN INTEGER VECTOR OF PIVOT INDICES.
C
C        INFO    INTEGER
C                = 0  NORMAL VALUE.
C                = K  IF  U(K,K) .EQ. 0.0 .  THIS IS NOT AN ERROR
C                     CONDITION FOR THIS SUBROUTINE, BUT IT DOES
C                     INDICATE THAT SGESL OR SGEDI WILL DIVIDE BY ZERO
C                     IF CALLED.  USE  RCOND  IN SGECO FOR A RELIABLE
C                     INDICATION OF SINGULARITY.
C
C     LINPACK. THIS VERSION DATED 08/14/78 .
C     CLEVE MOLER, UNIVERSITY OF NEW MEXICO, ARGONNE NATIONAL LAB.
C
C     SUBROUTINES AND FUNCTIONS
C
C     BLAS SAXPY,SSCAL,ISAMAX
C
C     INTERNAL VARIABLES
C
      REAL T
      INTEGER ISAMAX,J,K,KP1,L,NM1
C
C
C
C     GAUSSIAN ELIMINATION WITH PARTIAL PIVOTING
C
      INFO = 0
      NM1 = N - 1
      IF (NM1 .LT. 1) GO TO 70
      DO 60 K = 1, NM1
         KP1 = K + 1
C
C        FIND L = PIVOT INDEX
C
         L = ISAMAX(N-K+1,A(K,K),1) + K - 1
         IPVT(K) = L
C
C        ZERO PIVOT IMPLIES THIS COLUMN ALREADY TRIANGULARIZED
C
         IF (A(L,K) .EQ. 0.0E0) GO TO 40
C
C           INTERCHANGE IF NECESSARY
C
            IF (L .EQ. K) GO TO 10
               T = A(L,K)
               A(L,K) = A(K,K)
               A(K,K) = T
   10       CONTINUE
C
C           COMPUTE MULTIPLIERS
C
            T = -1.0E0/A(K,K)
            CALL SSCAL(N-K,T,A(K+1,K),1)
C
C           ROW ELIMINATION WITH COLUMN INDEXING
C
            DO 30 J = KP1, N
               T = A(L,J)
               IF (L .EQ. K) GO TO 20
                  A(L,J) = A(K,J)
                  A(K,J) = T
   20          CONTINUE
               CALL SAXPY(N-K,T,A(K+1,K),1,A(K+1,J),1)
   30       CONTINUE
         GO TO 50
   40    CONTINUE
            INFO = K
   50    CONTINUE
   60 CONTINUE
   70 CONTINUE
      IPVT(N) = N
      IF (A(N,N) .EQ. 0.0E0) INFO = N
      RETURN
      END

      SUBROUTINE SSPGST( ITYPE, UPLO, N, AP, BP, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     March 31, 1993 
*
*     .. Scalar Arguments ..
      CHARACTER          UPLO
      INTEGER            INFO, ITYPE, N
*     ..
*     .. Array Arguments ..
      REAL               AP( * ), BP( * )
*     ..
*
*  Purpose
*  =======
*
*  SSPGST reduces a real symmetric-definite generalized eigenproblem
*  to standard form, using packed storage.
*
*  If ITYPE = 1, the problem is A*x = lambda*B*x,
*  and A is overwritten by inv(U**T)*A*inv(U) or inv(L)*A*inv(L**T)
*
*  If ITYPE = 2 or 3, the problem is A*B*x = lambda*x or
*  B*A*x = lambda*x, and A is overwritten by U*A*U**T or L**T*A*L.
*
*  B must have been previously factorized as U**T*U or L*L**T by SPPTRF.
*
*  Arguments
*  =========
*
*  ITYPE   (input) INTEGER
*          = 1: compute inv(U**T)*A*inv(U) or inv(L)*A*inv(L**T);
*          = 2 or 3: compute U*A*U**T or L**T*A*L.
*
*  UPLO    (input) CHARACTER
*          = 'U':  Upper triangle of A is stored and B is factored as
*                  U**T*U;
*          = 'L':  Lower triangle of A is stored and B is factored as
*                  L*L**T.
*
*  N       (input) INTEGER
*          The order of the matrices A and B.  N >= 0.
*
*  AP      (input/output) REAL array, dimension (N*(N+1)/2)
*          On entry, the upper or lower triangle of the symmetric matrix
*          A, packed columnwise in a linear array.  The j-th column of A
*          is stored in the array AP as follows:
*          if UPLO = 'U', AP(i + (j-1)*j/2) = A(i,j) for 1<=i<=j;
*          if UPLO = 'L', AP(i + (j-1)*(2n-j)/2) = A(i,j) for j<=i<=n.
*
*          On exit, if INFO = 0, the transformed matrix, stored in the
*          same format as A.
*
*  BP      (input) REAL array, dimension (N*(N+1)/2)
*          The triangular factor from the Cholesky factorization of B,
*          stored in the same format as A, as returned by SPPTRF.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ONE, HALF
      PARAMETER          ( ONE = 1.0, HALF = 0.5 )
*     ..
*     .. Local Scalars ..
      LOGICAL            UPPER
      INTEGER            J, J1, J1J1, JJ, K, K1, K1K1, KK
      REAL               AJJ, AKK, BJJ, BKK, CT
*     ..
*     .. External Subroutines ..
      EXTERNAL           SAXPY, SSCAL, SSPMV, SSPR2, STPMV, STPSV,
     $                   XERBLA
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      REAL               SDOT
      EXTERNAL           LSAME, SDOT
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      UPPER = LSAME( UPLO, 'U' )
      IF( ITYPE.LT.1 .OR. ITYPE.GT.3 ) THEN
         INFO = -1
      ELSE IF( .NOT.UPPER .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = -2
      ELSE IF( N.LT.0 ) THEN
         INFO = -3
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'SSPGST', -INFO )
         RETURN
      END IF
*
      IF( ITYPE.EQ.1 ) THEN
         IF( UPPER ) THEN
*
*           Compute inv(U')*A*inv(U)
*
*           J1 and JJ are the indices of A(1,j) and A(j,j)
*
            JJ = 0
            DO 10 J = 1, N
               J1 = JJ + 1
               JJ = JJ + J
*
*              Compute the j-th column of the upper triangle of A
*
               BJJ = BP( JJ )
               CALL STPSV( UPLO, 'Transpose', 'Nonunit', J, BP,
     $                     AP( J1 ), 1 )
               CALL SSPMV( UPLO, J-1, -ONE, AP, BP( J1 ), 1, ONE,
     $                     AP( J1 ), 1 )
               CALL SSCAL( J-1, ONE / BJJ, AP( J1 ), 1 )
               AP( JJ ) = ( AP( JJ )-SDOT( J-1, AP( J1 ), 1, BP( J1 ),
     $                    1 ) ) / BJJ
   10       CONTINUE
         ELSE
*
*           Compute inv(L)*A*inv(L')
*
*           KK and K1K1 are the indices of A(k,k) and A(k+1,k+1)
*
            KK = 1
            DO 20 K = 1, N
               K1K1 = KK + N - K + 1
*
*              Update the lower triangle of A(k:n,k:n)
*
               AKK = AP( KK )
               BKK = BP( KK )
               AKK = AKK / BKK**2
               AP( KK ) = AKK
               IF( K.LT.N ) THEN
                  CALL SSCAL( N-K, ONE / BKK, AP( KK+1 ), 1 )
                  CT = -HALF*AKK
                  CALL SAXPY( N-K, CT, BP( KK+1 ), 1, AP( KK+1 ), 1 )
                  CALL SSPR2( UPLO, N-K, -ONE, AP( KK+1 ), 1,
     $                        BP( KK+1 ), 1, AP( K1K1 ) )
                  CALL SAXPY( N-K, CT, BP( KK+1 ), 1, AP( KK+1 ), 1 )
                  CALL STPSV( UPLO, 'No transpose', 'Non-unit', N-K,
     $                        BP( K1K1 ), AP( KK+1 ), 1 )
               END IF
               KK = K1K1
   20       CONTINUE
         END IF
      ELSE
         IF( UPPER ) THEN
*
*           Compute U*A*U'
*
*           K1 and KK are the indices of A(1,k) and A(k,k)
*
            KK = 0
            DO 30 K = 1, N
               K1 = KK + 1
               KK = KK + K
*
*              Update the upper triangle of A(1:k,1:k)
*
               AKK = AP( KK )
               BKK = BP( KK )
               CALL STPMV( UPLO, 'No transpose', 'Non-unit', K-1, BP,
     $                     AP( K1 ), 1 )
               CT = HALF*AKK
               CALL SAXPY( K-1, CT, BP( K1 ), 1, AP( K1 ), 1 )
               CALL SSPR2( UPLO, K-1, ONE, AP( K1 ), 1, BP( K1 ), 1,
     $                     AP )
               CALL SAXPY( K-1, CT, BP( K1 ), 1, AP( K1 ), 1 )
               CALL SSCAL( K-1, BKK, AP( K1 ), 1 )
               AP( KK ) = AKK*BKK**2
   30       CONTINUE
         ELSE
*
*           Compute L'*A*L
*
*           JJ and J1J1 are the indices of A(j,j) and A(j+1,j+1)
*
            JJ = 1
            DO 40 J = 1, N
               J1J1 = JJ + N - J + 1
*
*              Compute the j-th column of the lower triangle of A
*
               AJJ = AP( JJ )
               BJJ = BP( JJ )
               AP( JJ ) = AJJ*BJJ + SDOT( N-J, AP( JJ+1 ), 1,
     $                    BP( JJ+1 ), 1 )
               CALL SSCAL( N-J, BJJ, AP( JJ+1 ), 1 )
               CALL SSPMV( UPLO, N-J, ONE, AP( J1J1 ), BP( JJ+1 ), 1,
     $                     ONE, AP( JJ+1 ), 1 )
               CALL STPMV( UPLO, 'Transpose', 'Non-unit', N-J+1,
     $                     BP( JJ ), AP( JJ ), 1 )
               JJ = J1J1
   40       CONTINUE
         END IF
      END IF
      RETURN
*
*     End of SSPGST
*
      END

C
C	$Id: xtch.f,v 1.5 2008-07-27 00:17:21 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
C
      SUBROUTINE XTCH (IPOINT,IPASS,LCNUM)
C
C RETRIEVES CHARACTER DIGITIZATION.
C
C ON ENTRY
C   IND - AN ARRAY CONTAINING 15-BIT UNITS. EACH WORD CONTAINS AS MANY
C         UNITS AS FIT AS A WHOLE INTO ONE WORD ON THIS PARTICULAR
C         IMPLEMENTATION.
C         EACH UNIT REPRESENTS A POINTER INTO THE ARRAY IDD AND AN
C         INDICATION OF THE FORMAT OF THE DATA WHICH CAN BE FOUND THERE.
C         IN EACH UNIT THE 14 BITS TO THE RIGHT REPRESENT THE NUMBER OF
C         THE ENTRY IN THE ARRAY IDD (FOR 60-BIT WORDS) WHERE THE
C         CORRESPONDING DIGITIZATION STARTS.IF THE FIRST BIT TO THE LEFT
C         IS 1 WE EXPECT 12-BIT UNITS IN THE ARRAY IDD, IF IT IS 0 WE
C         EXPECT 6-BIT UNITS IN IDD.
C   IDD-AN ARRAY CONTAINING CHARACTER DIGITIZATIONS. THE DIGITIZATIONS
C       CAN CONSIST OF EITHER 12-BIT OR 6-BIT UNITS. THE DIGITIZATIONS
C       ARE STORED AS A BIT STREAM CROSSING WORD BOUNDARIES IF NECESSARY
C       FOR 60-BIT WORDS THEY START AT THE BEGINNING OF A WORD.
C       THE END OF A DIGITIZATION IS INDICATED BY 2 CONSECUTIVE UNITS
C       WITH ALL BITS 0.
C   IPOINT - AN INTEGER INDICATING THE IPOINT-TH UNIT STORED IN THE
C            ARRAY IND
C   LC - AN ARRAY. ENTRIES CAN HAVE ANY VALUE.
C   IPASS = 2 RETURN DIGITIZATION OF CHARACTER IDENTIFIED BY PARAMETER
C             IPOINT IN ARRAY LC
C         = 1  RETURN ONLY FIRST AND SECOND UNIT OF DIGITIZATION IN
C              LC(1) AND LC(2)
C   LCNUM - ANY VALUE
C
C ON EXIT
C   IDD - UNCHANGED
C   IND - UNCHANGED
C   IPOINT - UNCHANGED
C   IPASS - UNCHANGED
C   LC - IF NO DIGITIZATION FOUND, UNCHANGED
C        OTHERWISE
C        LC(I) CONTAINS THE I-TH UNIT OF THE DIGITIZATION OF THE
C        CHARACTER THAT WE GET WHEN WE RETRIEVE THE IPOIN-TH UNIT IN THE
C        ARRAY IND, INTERPRET THE FIRST BIT TO THE LEFT AS AN INDICATION
C        OF A 12-BIT OR 6-BIT DIGITIZATION AND THE 14 BITS TO THE RIGHT
C        AS THE NUMBER OF THE ENTRY IN THE ARRAY IDD (FOR 60-BIT WORDS)
C        WHERE THE DIGITIZATION OF THE CHARACTER STARTS.
C        NOTICE THAT EACH UNIT GOES THROUGH A TRANSFORMATION BEFORE IT
C        IS STORED IN LC. FROM 6-BIT UNITS 32 IS SUBTRACTED, FROM 12-
C        BIT UNITS 2048 IS SUBTRACTED. ALSO A SPECIAL INDICATOR (-2048)
C        IS PUT INTO LC FOR UNITS WITH ALL BITS ZERO.
C   LCNUM - IF NO DIGITIZATION FOUND, 0
C           OTHERWISE
C           THE NUMBER OF THE ENTRY IN THE ARRAY LC WHICH CONTAINS THE
C           LAST UNIT OF THE DIGITIZATION OF THE CHARACTER.
C           IT CAN ALGORITHMICALLY BE DEFINED AS THE NUMBER OF UNITS
C           WHICH CAN BE ENCOUNTERED BEFORE 2 CONSECUTIVE UNITS WITH
C           ALL 0 UNITS WERE FOUND.  ASSUME THAT THE STARTING POINT WAS
C           FOUND AS DESCRIBED ABOVE WHEN DESCRIBING THE ARRAY LC.
C
C CALLS
C   IAND,ISHIFT,IOR
C
C CALLED BY
C   PWRITX,CCHECK,DCHECK
C
C
C PWRC0 AND PWRC1 ARE FOR COMMUNICATION WITH ROUTINE PWRITX.
C ROUTINE XTCH RECEIVES VALUES IN PWRC0 AND RETURNS VALUES IN PWRC1.
      COMMON /PWRC1/ LC(150)
C
C
C  NOTE THE SIZE OF IDD AND IND MAY BE MODIFED TO CONTAIN THE NUMBER OF
C  ELEMENTS EQUAL TO THE VALUE OF IDDLEN AND INDLEN COMPUTED IN PWRITX.
C
      COMMON/PWRC0/IDD(8625),IND(789)
C
C  MASKING AND OTHER MACHINE DEPENDENT CONSTANTS WHICH MUST BE
C  CALCULATED.
C
      COMMON/PINIT/MASK(4),MASK6(64),MASK12(64),LAST6,LAST12,IBIT15,
     +        MASK14,NUM15U,NBWD
C
C  INITIALIZATION FLAG
C
      COMMON/PINIT1/IFRST
      LOGICAL IFRST
C
C PWRC2 IS FOR COMMUNICATION WITH THE BLOCK DATA.
      COMMON /PWRC2/ INDZER
C
C
C
C MAXUN - ARRAY CONTAINING MAXIMUM NUMBER OF UNITS TO BE RETRIEVED.
      DIMENSION MAXUN(2)
C
C THE NUMBER OF BITS PER POINTER IN THE ARRAY IND.
C
      DATA NBPP /15/
C
C THE NUMBER OF BITS IN A 6-BIT UNIT.
C
      DATA NBPU6 /6/
C
C THE NUMBER OF BITS IN A 12-BIT UNIT.
C
      DATA NBPU12 /12/
C
C FOR 6-BIT UNITS.  LC(I) = I-TH UNIT - IHALF6.
C
      DATA IHALF6 /32/
C
C FOR 12-BIT UNITS.  LC(I) = I-TH UNIT - IHAL12.
C
      DATA IHAL12 /2048/
C
C THE NUMBER OF UNITS TO BE RETRIEVED IF IPASS IS EQUAL TO 1.
C
      DATA MAXUN(1) /2/
C
C THE MAXIMUM NUMBER OF UNITS TO BE RETRIEVED IF IPASS IS 2.
C
      DATA MAXUN(2) /150/
C
C
C
C LOCAL VARIABLES
C
C IDD - ARRAY CONTAINING DIGITIZATIONS OF CHARACTERS.
C IND - ARRAY CONTAINING POINTERS INTO THESE DIGITIZATIONS.
C LC - ARRAY TO CONTAIN THE DIGITIZATION OF 1 CHARACTER, 1 UNIT PER WORD
C IWORD - THE WORD IN THE ARRAY IND CONTAINING THE IPOINT-TH 15 BIT
C         UNIT.
C IPOS - THE IPOS-TH UNIT IN IND(IWORD) IS THE IPOINT-TH UNIT IN THE
C        ARRAY IND.
C IFIFTN - THE IPOINT-TH 15-BIT UNIT.
C IMODE - THE MODE OF THE DIGITIZATION
C         =0  6-BIT MODE
C         =1  12-BIT MODE
C IDIGP - POINTER TO THE START OF THE DIGITIZATION
C NUMMAX - THE MAXIMUM NUMBER OF DIGITIZATION UNITS TO BE RETRIEVED
C BIT - THE NUMBER OF THE BIT IN ARRAY IDD AT WHICH THE DIGITIZATION
C        STARTS
C IDDWOR - WORD IN ARRAY IDD CONTAINING BIT IBIT
C NPOS - POSITION OF BIT IBIT IN WORD IDDWOR
C NRIGHT - NUMBER OF BITS TO THE RIGHT OF BIT NPOS IN WORD + 1
C LCTEM - CONTAINS LEFT PART OF DIGITIZATION UNIT, IF UNIT CROSSES
C         WORD BOUNDARIES
C IDIGP - ENTRY IN THE ARRAY IDD (ASSUMED 60-BIT WORDS) WHERE THE
C         DIGITIZATION STARTS
C         =0  NO DIGITIZATION FOUND
C INDZER - AN INDICATION THAT AN ALL 0 BITS UNIT WAS ENCOUNTERED.
C
C                     INITIALIZATION OF MASKS
C
C  CHECK IF INITIALIZATION ALREADY PERFORMED
C
      IF (IFRST) GO TO 1000
      IFRST = .TRUE.
C
C  GENERATE MASKS AND OTHER MACHINE-DEPENDENT CONSTANTS
C
      CALL MKMSK
C  END INITIALIZATION
 1000 CONTINUE
C
C                  P A R T   1
C FIND IDIGP, ENTRY IN ARRAY IDD WHERE DIGITIZATION OF CHARACTER STARTS.
C FIND IMODE, INDICATION FOR FORMAT OF DIGITIZATION (12-BIT, 6-BIT).
C
C
C INITIALIZE THE NUMBER OF UNITS CONTAINED IN LC TO ZERO.
C
      LCNUM = 0
C
C FIND THE WORD IN THE ARRAY IND WHICH CONTAINS THE IPOINT-TH UNIT.
C
      IWORD = (IPOINT-1)/NUM15U + 1
C
C FIND THE NUMBER OF THE IPOINT-TH UNIT WITHIN THE WORD IWORD.
C
      IPOS = IPOINT - (IWORD-1)*NUM15U
C
C RETRIEVE THE 15-BIT UNIT.
C
      IFIFTN = IAND(MASK(IPOS),IND(IWORD))
C
C SHIFT THE 15-BIT UNIT TO THE RIGHT END OF THE WORD.
C
      IFIFTN = ISHIFT(IFIFTN,IPOS*NBPP-NBWD)
C
C RETRIEVE THE MODE OF THE DIGITIZATION POINTED TO.
C
      IMODE = IAND(IFIFTN,IBIT15)
      IF (IMODE .NE. 0) IMODE = 1
C
C RETRIEVE THE NUMBER OF THE ENTRY IN THE IDD ARRAY WHERE THE
C DIGITIZATION STARTS.
C
      IDIGP = IAND (IFIFTN,MASK14)
C
C RETURN IF NO DIGITIZATION EXISTS FOR THIS POINTER.
C
      IF (IDIGP .EQ. 0) RETURN
C
C                  P A R T   2
C STORE DIGITIZATION OF CHARACTER INTO ARRAY LC, 1 UNIT PER WORD.
C
C
C DEFINE THE MAXIMUM NUMBER OF UNITS TO BE RETRIEVED.
C
      NUMMAX = MAXUN(IPASS)
C
C BRANCH DEPENDING ON FORMAT OF DIGITIZATION.
C
      IMODE = IMODE + 1
      GOTO (1,2), IMODE
C
C 6-BIT FORMAT.
C
    1 CONTINUE
C
C FIND THE BIT WHERE THE DIGITIZATION OF THE CHARACTER STARTS.
      BIT = REAL((IDIGP-1)*60+1)
      IDDWOR = INT(BIT/REAL(NBWD)) + 1
      NPOS = INT(BIT - REAL(IDDWOR-1)*REAL(NBWD))
C
C LOOP FOR MAXIMUM NUMBER OF UNITS OR UNTIL END OF DIGITIZATION REACHED.
      DO 11 I = 1,NUMMAX
C INCREMENT THE NUMBER OF UNITS STORED IN LC.
      LCNUM = LCNUM + 1
C STORE UNIT INTO LC(I), RIGHT JUSTIFIED.
      LC(I) = IAND(IDD(IDDWOR),MASK6(NPOS))
      NRIGHT = NBWD - NPOS + 1
      LC(I) = ISHIFT(LC(I),NBPU6-NRIGHT)
C
C *** THIS PART IS ONLY FOR MACHINES WHERE NBWD CANNOT BE DIVIDED BY 6
      IF (NRIGHT .GE. NBPU6) GOTO 10
      LCTEM = IAND (IDD(IDDWOR),MASK6(NPOS))
      LCTEM = ISHIFT(LCTEM,NBPU6-NRIGHT)
      LC(I) = IAND(IDD(IDDWOR+1),MASK6(1))
      LC(I) = ISHIFT(LC(I),NBPU6-NRIGHT-NBWD)
      LSTORE = NBWD-NBPU6+NRIGHT+1
      LC(I) = IAND(LC(I),MASK6(LSTORE))
      LC(I) = IOR(LC(I),LCTEM)
   10 CONTINUE
C *** END OF PART FOR NBWD NOT DIVIDABLE BY 6
C
      LC(I) = IAND(LAST6,LC(I))
C INTERPRET UNIT AS POSITIVE OR NEGATIVE DISPLACEMENT.
      LC(I) = LC(I) - IHALF6
C IF THIS UNIT HAS ALL ZERO BITS, SET INDICATOR.
      IF (LC(I) .EQ. -IHALF6) LC(I) = INDZER
C THE FOLLOWING CHECK CAN ONLY BE DONE FOR I GREATER THAN 1.
      IF (I .EQ. 1) GOTO 100
C CHECK FOR END OF DIGITIZATION (2 ALL ZERO UNITS IN A ROW).
      IF (LC(I) .EQ. INDZER .AND. LC(I-1) .EQ. INDZER) GOTO 3
C DEFINE THE NEXT DIGITIZATION UNIT.
  100 CONTINUE
      NPOS = NPOS + NBPU6
      IF (NPOS .LT. NBWD) GOTO 101
      IDDWOR = IDDWOR + 1
      NPOS = NPOS - NBWD
  101 CONTINUE
C
   11 CONTINUE
      GOTO 3
C
C
C 12-BIT FORMAT.
C
C ALGORITHM EXACTLY AS FOR 6-BIT FORMAT
    2 CONTINUE
      BIT = REAL((IDIGP-1)*60+1)
      IDDWOR = INT(BIT/REAL(NBWD)) + 1
      NPOS = INT(BIT - REAL(IDDWOR-1)*REAL(NBWD))
      DO 21 I = 1,NUMMAX
      LCNUM = LCNUM + 1
      LC(I) = IAND(IDD(IDDWOR),MASK12(NPOS))
      NRIGHT = NBWD - NPOS + 1
      LC(I) = ISHIFT(LC(I),NBPU12-NRIGHT)
C
C *** THIS PART IS ONLY FOR MACHINES WHERE NBWD CANNOT BE DIVIDED BY 12
      IF (NRIGHT .GE. NBPU12) GOTO 20
      LCTEM = IAND (IDD(IDDWOR),MASK12(NPOS))
      LCTEM = ISHIFT(LCTEM,NBPU12-NRIGHT)
      LC(I) = IAND(IDD(IDDWOR+1),MASK12(1))
      LC(I) = ISHIFT(LC(I),NBPU12-NRIGHT-NBWD)
      LSTORE = NBWD-NBPU12+NRIGHT+1
      LC(I) = IAND(LC(I),MASK12(LSTORE))
      LC(I) = IOR(LC(I),LCTEM)
   20 CONTINUE
C *** END OF PART FOR NBWD NOT DIVIDABLE BY 12 ***
C
      LC(I) = IAND(LAST12,LC(I))
      LC(I) = LC(I) - IHAL12
      IF (LC(I) .EQ. -IHAL12) LC(I) = INDZER
      IF (I .EQ. 1) GOTO 200
      IF (LC(I) .EQ. INDZER .AND. LC(I-1) .EQ. INDZER) GOTO 3
  200 CONTINUE
      NPOS = NPOS + NBPU12
      IF (NPOS .LT. NBWD) GOTO 201
      IDDWOR = IDDWOR + 1
      NPOS = NPOS - NBWD
  201 CONTINUE
   21 CONTINUE
C
C
    3 CONTINUE
C
      RETURN
      END

C
C	$Id: gspmi.f,v 1.5 2008-07-27 00:21:02 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GSPMI (INDEX)
C
C  SET POLYMARKER INDEX
C
      INTEGER ESPMI
      PARAMETER (ESPMI=22)
C
      include 'gkscom.h'
C
      INTEGER INDEX
C
C  Check if GKS is in the proper state.
C
      CALL GZCKST(8,ESPMI,IER)
      IF (IER .NE. 0) RETURN
C
C  Check that the index is valid (level 0A specific).
C
      IF (INDEX.LT.1 .OR. INDEX.GT.5) THEN
        ERS = 1
        CALL GERHND(66,ESPMI,ERF)
        ERS = 0
        RETURN
      ENDIF
C
C  Set the current polymarker index in the GKS state list.
C
      CPMI = INDEX
C
C  Invoke the workstation interface.
C
      FCODE = 25
      CONT  = 0
      CALL GZROI(0)
      IL1   = 1
      IL2   = 1
      ID(1) = INDEX
      CALL GZTOWK
      IF (RERR.NE.0 .AND. RERR.NE.-109) THEN
        ERS = 1
        CALL GERHND(RERR,ESPMI,ERF)
        ERS = 0
      ENDIF
C
      RETURN
      END

C
C	$Id: intzi.f,v 1.4 2008-07-27 00:17:22 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE INTZI (XX,YY,ZZ,LIN3,ITOP)
C
C FORCE STORAGE OF X, Y, AND Z INTO COMMON BLOCK
C
      COMMON /PWRZ2I/ X, Y, Z
      DATA IDUMX,IDUMY,IDUMZ /0, 0, 0/
      X = XX
      Y = YY
      Z = ZZ
      CALL INITZI (IDUMX,IDUMY,IDUMZ,LIN3,ITOP,1)
      RETURN
      END

C
C	$Id: lined.f,v 1.4 2008-07-27 00:16:58 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE LINED (XA,YA,XB,YB)
C USER ENTRY POINT.
C
      DATA IDUMMY /0/
      CALL FL2INT (XA,YA,IXA,IYA)
      CALL FL2INT (XB,YB,IXB,IYB)
C
      CALL CFVLD (1,IXA,IYA)
      CALL CFVLD (2,IXB,IYB)
      CALL CFVLD (3,IDUMMY,IDUMMY)
C
      RETURN
      END

      PROGRAM PGKEX02
C
C  Simple demo of GKS output primitives puts out sample 
C  POLYLINE, POLYMARKER, TEXT, FILL AREA and CELL ARRAY. 
C 
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C 
      REAL     ZZX(9), ZZYL(9), ZZYM(9), CIRX(9), CIRY(9)
      INTEGER  ICELLS(24,12) 
C 
      DATA  ZZX / -9.0, -8.0, -7.0, -6.0, -5.0, -4.0, -3.0, -2.0, -1.0/ 
      DATA  ZZYL/  6.5,  8.5,  6.5,  8.5,  6.5,  8.5,  6.5,  8.5,  6.5/ 
      DATA  ZZYM/ -1.0,  1.0, -1.0,  1.0, -1.0,  1.0, -1.0,  1.0, -1.0/
      DATA CIRX / 6.15, 5.26, 4.25, 3.59, 3.59, 4.25, 5.26, 6.15, 6.50/
      DATA CIRY / 8.46, 8.98, 8.80, 8.01, 6.99, 6.20, 6.02, 6.54, 7.50/
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF,IDUM) 
      CALL GOPWK (IWKID,LUNIT,IWTYPE)
      CALL GACWK (IWKID) 
C 
C  Define normalization transformation 1 and select it.
C
      CALL GSWN   (1, -10.0, 10.0, -10.0, 10.0)
      CALL GSVP   (1, 0.1, 0.9, 0.1, 0.9) 
      CALL GSELNT (1) 
C 
C  Draw a zig-zag POLYLINE. 
C
      CALL GPL (9, ZZX, ZZYL)
C
C  Set the marker type to 2 (plus sign) and draw markers.
C
      CALL GSMK (2)
      CALL GPM (9, ZZX, ZZYM)
C  
C  Set the fill area interior style to 1 (solid fill) and draw a 
C  solid filled nonagon.
C
      CALL GSFAIS (1)
      CALL GFA (9, CIRX, CIRY)
C 
C  Define 24x12 foreground/background checkerboard pattern. 
C
      DO 25 IX=1,24
        JX = MOD(IX,2)
        DO 20 IY=1,12 
          JY = MOD(IY,2)
          IF ((JX.EQ.1 .AND. JY.EQ.1) .OR. (JX.EQ.0 .AND. JY.EQ.0)) THEN
            ICELLS (IX,IY) = 1
          ELSE
            ICELLS (IX,IY) = 0
          ENDIF
   20   CONTINUE 
   25 CONTINUE 
C
C  Draw the checkerboard with CELL ARRAY. 
C
      CALL GCA (1.5,-1.25,8.5,1.25, 24, 12, 1, 1, 24, 12, ICELLS)
C 
C  Set the character height to 3% of the screen (.03*20.)
C
      CALL GSCHH (0.6) 
C
C  Set the text alignment to "center" in the horizontal and "half" in
C  the vertical.
C
      CALL GSTXAL (2, 3)
      XPOS =  0.0
      YPOS = -5.0 
C
C  Draw the text string. 
C
      CALL GTX (0.0, -7., 'Example text string')
C
C  Label the primitives.
C
      CALL GTX(-5.0,5.0,'Polyline')
      CALL GTX( 5.0,5.0,'Fill area')
      CALL GTX(-5.0,-2.5,'Polymarker')
      CALL GTX( 5.0,-2.5,'Cell array')
      CALL GTX( 0.0,-9.5,'Text')
C
      CALL FRAME
C
C  Deactive and close the workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END

      PROGRAM PGKEX17
C
C  Illustrate the various fill area interior styles.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      CHARACTER*7 LABEL
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF,IDUM)
      CALL GOPWK (IWKID,LUNIT,IWTYPE)
      CALL GACWK (IWKID)
C
C  Define colors.
C
      CALL GSCR(IWKID, 0, 1.0, 1.0, 1.0)
      CALL GSCR(IWKID, 1, 0.0, 0.0, 0.0)
      CALL GSCR(IWKID, 2, 0.0, 0.0, 1.0)
      CALL GSCR(IWKID, 3, 0.4, 0.0, 0.4)
      CALL GSCR(IWKID, 4, 1.0, 0.0, 0.0)
C
C  Draw a star with interior style hollow (the style index is
C  a dummy in this call since it is ignored for interior style
C  hollow).
C
      ISTYLE = 0
      ISTNDX = 1
      ICOLOR = 1
      CALL STAR(.35,.79,.09,ISTYLE,ISTNDX,ICOLOR)
C
C  Label the hollow area using Plotchar.
C
      CALL PCSETI('FN',21)
      CALL PCSETI('CC',3)
      CALL GSFAIS(1)
      CALL PLCHHQ(.17,.77,'Hollow',.022,0.,-1.)
C
C  Draw a star with interior style solid (the style index is
C  a dummy in this call since it is ignored for interior style
C  solid).
C
      ISTYLE = 1
      ISTNDX = 1
      ICOLOR = 1
      CALL STAR(.75,.79,.09,ISTYLE,ISTNDX,ICOLOR)
C
C  Label the solid area.
C
      CALL GSFAIS(1)
      CALL PLCHHQ(.60,.77,'Solid',.022,0.,-1.)
C
C  Draw stars with interior style hatch and with the six standardized
C  hatch styles:
C
C    Style index   Fill pattern
C    -----------   ------------
C       1          Horizontal lines
C       2          Vertical lines
C       3          Positive slope lines
C       4          Negative slope lines
C       5          Combined vertical and horizontal lines
C       6          Combined positive slope and negative slope lines
C
      ICOLOR = 2
      DO 10 I=1,6
        X = .2+.3*REAL(MOD(I-1,3))+.02
        Y = .3*REAL(INT((9-I)/3))-.10
        SCL = .15
        ISTYLE = 3
        ISTNDX = I
        CALL STAR(X,Y,SCL,ISTYLE,ISTNDX,ICOLOR)
C
C  Label the hatched areas.
C
        CALL GSFAIS(1)
        CALL PLCHHQ(X-.17,Y-.004,'Hatch,',.018,0.,-1.)
        WRITE(LABEL,100) I
  100   FORMAT('index ',I1)
        CALL GSFAIS(1)
        CALL PLCHHQ(X-.17,Y-.034,LABEL,.018,0.,-1.)
   10 CONTINUE
C
C  Main plot label.
C
      CALL PCSETI('FN',25)
      CALL PCSETI('CC',3)
      CALL GSFAIS(1)
      CALL PLCHHQ(.5,.95,'Fill area interior styles',.035,0.,0.)
C
      CALL FRAME
C
C  Deactivate and close the workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      STOP
      END
      SUBROUTINE STAR(X,Y,SCL,ISTYLE,ISTNDX,ICOLOR)
C
C  Draw a five-pointed star with interior style ISTYLE, style index
C  ISTNDX (if applicable), and colored using the color defined by
C  color index ICOLOR.
C
      PARAMETER (ID=10)
      DIMENSION XS(ID),YS(ID),XD(ID),YD(ID)
C
C  Coordinate data for a five-pointed star.
C
      DATA XS/ 0.00000, -0.22451, -0.95105, -0.36327, -0.58780,
     -         0.00000,  0.58776,  0.36327,  0.95107,  0.22453 /
      DATA YS/ 1.00000,  0.30902,  0.30903, -0.11803, -0.80900,
     -        -0.38197, -0.80903, -0.11805,  0.30898,  0.30901 /
      SAVE
C
      DO 10 I=1,ID
        XD(I) = X+SCL*XS(I)
        YD(I) = Y+SCL*YS(I)
   10 CONTINUE
C
      CALL GSFAIS(ISTYLE)
      CALL GSFACI(ICOLOR)
      CALL GSFASI(ISTNDX)
      CALL GFA(ID,XD,YD)
C
      RETURN
      END

C
C	$Id: vectd.f,v 1.4 2008-07-27 00:23:02 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE VECTD (X,Y)
      SAVE
C USER ENTRY POINT.
      CALL FL2INT (X,Y,IIX,IIY)
      CALL CFVLD (2,IIX,IIY)
      RETURN
      END

c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by UCAR                 .
c  .                                                             .
c  .       University Corporation for Atmospheric Research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                         SPHEREPACK                          .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c
c
c ... file ivrtgs.f
c
c     this file includes documentation and code for
c     subroutine ivrtgs
c
c ... files which must be loaded with ivrtgs.f
c
c     sphcom.f, hrfft.f, vhsgs.f,shags.f, gaqd.f
c
c
c     subroutine ivrtgs(nlat,nlon,isym,nt,v,w,idvw,jdvw,a,b,mdab,ndab,
c    +                  wvhsgs,lvhsgs,work,lwork,pertrb,ierror)
c
C*PL*ERROR* Comment line too long
c     given the scalar spherical harmonic coefficients a and b, precomputed
C*PL*ERROR* Comment line too long
c     by subroutine shags for a scalar array vt, subroutine ivrtgs computes
C*PL*ERROR* Comment line too long
c     a divergence free vector field (v,w) whose vorticity is vt - pertrb.
C*PL*ERROR* Comment line too long
c     w is the east longitude component and v is the colatitudinal component.
c     pertrb is a constant which must be subtracted from vt for (v,w) to
C*PL*ERROR* Comment line too long
c     exist (see the description of pertrb below).  usually pertrb is zero
c     or small relative to vt.  the divergence of (v,w), as computed by
c     ivrtgs, is the zero scalar field.  v(i,j) and w(i,j) are the
c     colatitudinal and east longitude velocity components at gaussian
c     colatitude theta(i) (see nlat as input parameter) and longitude
c     lambda(j) = (j-1)*2*pi/nlon.  the
c
c            vorticity(v(i,j),w(i,j))
c
c         =  [-dv/dlambda + d(sint*w)/dtheta]/sint
c
c         =  vort(i,j) - pertrb
c
c     and
c
c            divergence(v(i,j),w(i,j))
c
c         =  [d(sint*v)/dtheta + dw/dlambda]/sint
c
c         =  0.0
c
C*PL*ERROR* Comment line too long
c     where sint = sin(theta(i)).  required associated legendre polynomials
C*PL*ERROR* Comment line too long
c     are stored rather than recomputed as they are in subroutine ivrtgc.
c
c
c     input parameters
c
c     nlat   the number of points in the gaussian colatitude grid on the
C*PL*ERROR* Comment line too long
c            full sphere. these lie in the interval (0,pi) and are computed
C*PL*ERROR* Comment line too long
c            in radians in theta(1) <...< theta(nlat) by subroutine gaqd.
C*PL*ERROR* Comment line too long
c            if nlat is odd the equator will be included as the grid point
c            theta((nlat+1)/2).  if nlat is even the equator will be
c            excluded as a grid point and will lie half way between
c            theta(nlat/2) and theta(nlat/2+1). nlat must be at least 3.
c            note: on the half sphere, the number of grid points in the
c            colatitudinal direction is nlat/2 if nlat is even or
c            (nlat+1)/2 if nlat is odd.
c
c     nlon   the number of distinct londitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater
c            than 3. the axisymmetric case corresponds to nlon=1.
c            the efficiency of the computation is improved when nlon
c            is a product of small prime numbers.
c
c
c     isym   this has the same value as the isym that was input to
c            subroutine shags to compute the arrays a and b.  isym
c            determines whether (v,w) are computed on the full or half
c            sphere as follows:
c
c      = 0
c            vt is not symmetric about the equator. in this case
c            the vector field (v,w) is computed on the entire sphere.
c            i.e., in the arrays  v(i,j),w(i,j) for i=1,...,nlat and
c            j=1,...,nlon.
c
c      = 1
c
c            vt is symmetric about the equator. in this case w is
c            antiymmetric and v is symmetric about the equator. v
c            and w are computed on the northern hemisphere only.  i.e.,
c            if nlat is odd they are computed for i=1,...,(nlat+1)/2
c            and j=1,...,nlon.  if nlat is even they are computed for
c            i=1,...,nlat/2 and j=1,...,nlon.
c
c       = 2
c
c            vt is antisymmetric about the equator. in this case w is
c            symmetric and v is antisymmetric about the equator. w
c            and v are computed on the northern hemisphere only.  i.e.,
c            if nlat is odd they are computed for i=1,...,(nlat+1)/2
c            and j=1,...,nlon.  if nlat is even they are computed for
c            i=1,...,nlat/2 and j=1,...,nlon.
c
c
C*PL*ERROR* Comment line too long
c     nt     in the program that calls ivrtgs, nt is the number of vorticity
C*PL*ERROR* Comment line too long
c            and vector fields.  some computational efficiency is obtained
c            for multiple fields.  the arrays a,b,v, and w can be three
c            dimensional and pertrb can be one dimensional corresponding
C*PL*ERROR* Comment line too long
c            to an indexed multiple array vt.  in this case, multiple vector
C*PL*ERROR* Comment line too long
c            synthesis will be performed to compute each vector field.  the
C*PL*ERROR* Comment line too long
c            third index for a,b,v,w and first for pertrb is the synthesis
c            index which assumes the values k=1,...,nt.  for a single
C*PL*ERROR* Comment line too long
c            synthesis set nt=1. the description of the remaining parameters
c            is simplified by assuming that nt=1 or that a,b,v,w are two
c            dimensional and pertrb is a constant.
c
c     idvw   the first dimension of the arrays v,w as it appears in
c            the program that calls ivrtgs. if isym = 0 then idvw
c            must be at least nlat.  if isym = 1 or 2 and nlat is
c            even then idvw must be at least nlat/2. if isym = 1 or 2
c            and nlat is odd then idvw must be at least (nlat+1)/2.
c
c     jdvw   the second dimension of the arrays v,w as it appears in
c            the program that calls ivrtgs. jdvw must be at least nlon.
c
c     a,b    two or three dimensional arrays (see input parameter nt)
c            that contain scalar spherical harmonic coefficients
c            of the vorticity array vt as computed by subroutine shags.
c     ***    a,b must be computed by shags prior to calling ivrtgs.
c
c     mdab   the first dimension of the arrays a and b as it appears in
c            the program that calls ivrtgs (and shags). mdab must be at
c            least min0(nlat,(nlon+2)/2) if nlon is even or at least
c            min0(nlat,(nlon+1)/2) if nlon is odd.
c
c     ndab   the second dimension of the arrays a and b as it appears in
c            the program that calls ivrtgs (and shags). ndab must be at
c            least nlat.
c
c
c  wvhsgs    an array which must be initialized by subroutine vhsgsi.
c            once initialized
c            wvhsgs can be used repeatedly by ivrtgs as long as nlon
c            and nlat remain unchanged.  wvhsgs must not be altered
c            between calls of ivrtgs.
c
c
c  lvhsgs    the dimension of the array wvhsgs as it appears in the
c            program that calls ivrtgs. define
c
c               l1 = min0(nlat,nlon/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            then lvhsgs must be at least
c
c               (l1*l2*(nlat+nlat-l1+1))/2+nlon+15
c
c
c     work   a work array that does not have to be saved.
c
c     lwork  the dimension of the array work as it appears in the
c            program that calls ivrtgs. define
c
c               l2 = nlat/2                    if nlat is even or
c               l2 = (nlat+1)/2                if nlat is odd
c               l1 = min0(nlat,nlon/2)         if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2)     if nlon is odd
c
c            if isym = 0 then lwork must be at least
c
c               (2*nt+1)*nlat*nlon + nlat*(2*nt*l1+1)
c
c            if isym = 1 or 2 then lwork must be at least
c
c               (2*nt+1)*l2*nlon + nlat*(2*nt*l1+1)
c
c
c     **************************************************************
c
c     output parameters
c
c
C*PL*ERROR* Comment line too long
c     v,w   two or three dimensional arrays (see input parameter nt) that
c           contain a divergence free vector field whose vorticity is
c           vt - pertrb at the gaussian colatitude point theta(i)
C*PL*ERROR* Comment line too long
c           and longitude point lambda(j)=(j-1)*2*pi/nlon.  w is the east
C*PL*ERROR* Comment line too long
c           longitude component and v is the colatitudinal component.  the
c           indices for v and w are defined at the input parameter isym.
c           the divergence of (v,w) is the zero scalar field.
c
C*PL*ERROR* Comment line too long
c   pertrb  a nt dimensional array (see input parameter nt and assume nt=1
c           for the description that follows).  vt - pertrb is a scalar
c           field which can be the vorticity of a vector field (v,w).
c           pertrb is related to the scalar harmonic coefficients a,b
c           of vt (computed by shags) by the formula
c
c                pertrb = a(1,1)/(2.*sqrt(2.))
c
c           an unperturbed vt can be the vorticity of a vector field
c           only if a(1,1) is zero.  if a(1,1) is nonzero (flagged by
c           pertrb nonzero) then subtracting pertrb from vt yields a
c           scalar field for which a(1,1) is zero.
c
c    ierror = 0  no errors
c           = 1  error in the specification of nlat
c           = 2  error in the specification of nlon
c           = 3  error in the specification of isym
c           = 4  error in the specification of nt
c           = 5  error in the specification of idvw
c           = 6  error in the specification of jdvw
c           = 7  error in the specification of mdab
c           = 8  error in the specification of ndab
c           = 9  error in the specification of lvhsgs
c           = 10 error in the specification of lwork
c **********************************************************************
c
c
      SUBROUTINE DIVRTGS(NLAT,NLON,ISYM,NT,V,W,IDVW,JDVW,A,B,MDAB,NDAB,
     +                  WVHSGS,LVHSGS,WORK,LWORK,PERTRB,IERROR)
      DOUBLE PRECISION V
      DOUBLE PRECISION W
      DOUBLE PRECISION A
      DOUBLE PRECISION B
      DOUBLE PRECISION WVHSGS
      DOUBLE PRECISION WORK
      DOUBLE PRECISION PERTRB
      DIMENSION V(IDVW,JDVW,NT),W(IDVW,JDVW,NT),PERTRB(NT)
      DIMENSION A(MDAB,NDAB,NT),B(MDAB,NDAB,NT)
      DIMENSION WVHSGS(LVHSGS),WORK(LWORK)
c
c     check input parameters
c
      IERROR = 1
      IF (NLAT.LT.3) RETURN
      IERROR = 2
      IF (NLON.LT.4) RETURN
      IERROR = 3
      IF (ISYM.LT.0 .OR. ISYM.GT.2) RETURN
      IERROR = 4
      IF (NT.LT.0) RETURN
      IERROR = 5
      IMID = (NLAT+1)/2
      IF ((ISYM.EQ.0.AND.IDVW.LT.NLAT) .OR.
     +    (ISYM.NE.0.AND.IDVW.LT.IMID)) RETURN
      IERROR = 6
      IF (JDVW.LT.NLON) RETURN
      IERROR = 7
      MMAX = MIN0(NLAT, (NLON+1)/2)
      IF (MDAB.LT.MIN0(NLAT, (NLON+2)/2)) RETURN
      IERROR = 8
      IF (NDAB.LT.NLAT) RETURN
      IERROR = 9
c     lzz1 = 2*nlat*imid
c     labc = 3*(max0(mmax-2,0)*(nlat+nlat-mmax-1))/2
c     if(lvhsgs .lt. 2*(lzz1+labc)+nlon+15) return
      IDZ = (MMAX* (NLAT+NLAT-MMAX+1))/2
      LZIMN = IDZ*IMID
      IF (LVHSGS.LT.LZIMN+LZIMN+NLON+15) RETURN
      IERROR = 10
c
c     verify unsaved work space length
c
      MN = MMAX*NLAT*NT
      IF (ISYM.NE.0 .AND. LWORK.LT.NLAT* (2*NT*NLON+MAX0(6*IMID,NLON))+
     +    2*MN+NLAT) RETURN
      IF (ISYM.EQ.0 .AND. LWORK.LT.IMID* (2*NT*NLON+MAX0(6*NLAT,NLON))+
     +    2*MN+NLAT) RETURN
      IERROR = 0
c
c     set work space pointers
c
      ICR = 1
      ICI = ICR + MN
      IS = ICI + MN
      IWK = IS + NLAT
      LIWK = LWORK - 2*MN - NLAT
      CALL DIVTGS1(NLAT,NLON,ISYM,NT,V,W,IDVW,JDVW,WORK(ICR),WORK(ICI),
     +            MMAX,WORK(IS),MDAB,NDAB,A,B,WVHSGS,LVHSGS,WORK(IWK),
     +            LIWK,PERTRB,IERROR)
      RETURN
      END

      SUBROUTINE DIVTGS1(NLAT,NLON,ISYM,NT,V,W,IDVW,JDVW,CR,CI,MMAX,
     +                   SQNN,MDAB,NDAB,A,B,WSAV,LSAV,WK,LWK,PERTRB,
     +                   IERROR)
      DOUBLE PRECISION V
      DOUBLE PRECISION W
      DOUBLE PRECISION CR
      DOUBLE PRECISION CI
      DOUBLE PRECISION SQNN
      DOUBLE PRECISION A
      DOUBLE PRECISION B
      DOUBLE PRECISION WSAV
      DOUBLE PRECISION WK
      DOUBLE PRECISION PERTRB
      DOUBLE PRECISION FN
      DOUBLE PRECISION BR
      DOUBLE PRECISION BI
      DIMENSION V(IDVW,JDVW,NT),W(IDVW,JDVW,NT),PERTRB(NT)
      DIMENSION CR(MMAX,NLAT,NT),CI(MMAX,NLAT,NT),SQNN(NLAT)
      DIMENSION A(MDAB,NDAB,NT),B(MDAB,NDAB,NT)
      DIMENSION WSAV(LSAV),WK(LWK)
c
c     preset coefficient multiplyers in vector
c
      DO 1 N = 2,NLAT
          FN = DBLE(N-1)
          SQNN(N) = SQRT(FN* (FN+1.D0))
    1 CONTINUE
c
c     compute multiple vector fields coefficients
c
      DO 2 K = 1,NT
c
c     set vorticity field perturbation adjustment
c
          PERTRB(K) = A(1,1,K)/ (2.D0*SQRT(2.D0))
c
c     preset br,bi to 0.0
c
          DO 3 N = 1,NLAT
              DO 4 M = 1,MMAX
                  CR(M,N,K) = 0.0D0
                  CI(M,N,K) = 0.0D0
    4         CONTINUE
    3     CONTINUE
c
c     compute m=0 coefficients
c
          DO 5 N = 2,NLAT
              CR(1,N,K) = A(1,N,K)/SQNN(N)
              CI(1,N,K) = B(1,N,K)/SQNN(N)
    5     CONTINUE
c
c     compute m>0 coefficients
c
          DO 6 M = 2,MMAX
              DO 7 N = M,NLAT
                  CR(M,N,K) = A(M,N,K)/SQNN(N)
                  CI(M,N,K) = B(M,N,K)/SQNN(N)
    7         CONTINUE
    6     CONTINUE
    2 CONTINUE
c
c     set ityp for vector synthesis with divergence=0
c
      IF (ISYM.EQ.0) THEN
          ITYP = 2
      ELSE IF (ISYM.EQ.1) THEN
          ITYP = 5
      ELSE IF (ISYM.EQ.2) THEN
          ITYP = 8
      END IF
c
c     vector sythesize cr,ci into divergence free vector field (v,w)
c
      CALL DVHSGS(NLAT,NLON,ITYP,NT,V,W,IDVW,JDVW,BR,BI,CR,CI,MMAX,NLAT,
     +           WSAV,LSAV,WK,LWK,IERROR)
      RETURN
      END

C
C $Id: pcwb15.f,v 1.4 2008-07-27 01:04:31 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C

      SUBROUTINE PCWB15 (INUN,IOUT,NOIN,ITMP,LTMP)
C
      DIMENSION ITMP(LTMP)
C
C This routine packs a set of 15-bit integers into an integer array and
C writes out the contents of that array.  Each word of the array holds
C only as many of the 15-bit integers as will fit in one word; they are
C left-justified and there may be some unused zero bits on the end.
C
C On entry:
C
C   INUN is the unit number from which may be read NOIN card images.
C   Each card image contains 16 integers, in I5 format.  Each integer
C   represents a positive 15-bit value.
C
C   IOUT is the file descriptor of a file to which output is to be
C   written.  IOUT is assumed to be positioned correctly.
C
C   NOIN is the number of card images on unit INUN.
C
C   ITMP is an array of length LTMP.  Its elements may have any value.
C
C   LTMP must be (NOIN*16-1)/NPPW+1 or bigger, where NPPW is the number
C   of complete 15-bit units which will fit into a word.
C
C On exit:
C
C   The values of INUN, IOUT, and NOIN are unchanged.  The unit INUN
C   has been rewound, but is otherwise unchanged.  ITMP contains the
C   packed integers from INUN, NPPW per word, left-justified.  A
C   binary record has been written to IOUT, consisting of the first
C   (NOIN*16-1)/NPPW+1 words of the array ITMP.
C
C COMMON block declarations.
C
      COMMON /PCCMN2/ NBPW,NPPW
C
C Define temporary storage for a card image.
C
      DIMENSION ICRD(16)
C
C Rewind the input unit.
C
      REWIND INUN
C
C Initialize NWDS and NPAR to say that the last parcel position filled
C was position NPPW in word 0, so that the next one to be filled will
C be position 1 (the leftmost) in word 1.
C
      NWDS=0
      NPAR=NPPW
C
C Read integers from unit INUN and store them in the array ITMP.  The
C index I loops through the card images and the index J loops through
C the integers on each card image.
C
      DO 102 I=1,NOIN
        READ (INUN,'(16I5)') ICRD
        DO 101 J=1,16
          NPAR=NPAR+1
          IF (NPAR.GT.NPPW) THEN
            NWDS=NWDS+1
            NPAR=1
            ITMP(NWDS)=ISHIFT(IAND(ICRD(J),32767),NBPW-15)
          ELSE
            ITMP(NWDS)=IOR(ITMP(NWDS),
     +                     ISHIFT(IAND(ICRD(J),32767),NBPW-NPAR*15))
          END IF
  101   CONTINUE
  102 CONTINUE
C
C Write the integer array into the binary file.
C
      CALL NGWRIN (IOUT,ITMP,NWDS,ISTA)
C
      IF (ISTA.NE.NWDS) THEN
        PRINT * , 'IN PCWB15, ERROR WRITING OUTPUT RECORD'
        STOP
      END IF
C
C Rewind the input unit.
C
      REWIND INUN
C
C Done.
C
      RETURN
C
      END

      SUBROUTINE ZHERK( UPLO, TRANS, N, K, ALPHA, A, LDA, BETA, C, LDC )
*     .. Scalar Arguments ..
      CHARACTER          TRANS, UPLO
      INTEGER            K, LDA, LDC, N
      DOUBLE PRECISION   ALPHA, BETA
*     ..
*     .. Array Arguments ..
      COMPLEX*16         A( LDA, * ), C( LDC, * )
*     ..
*
*  Purpose
*  =======
*
*  ZHERK  performs one of the hermitian rank k operations
*
*     C := alpha*A*conjg( A' ) + beta*C,
*
*  or
*
*     C := alpha*conjg( A' )*A + beta*C,
*
*  where  alpha and beta  are  real scalars,  C is an  n by n  hermitian
*  matrix and  A  is an  n by k  matrix in the  first case and a  k by n
*  matrix in the second case.
*
*  Parameters
*  ==========
*
*  UPLO   - CHARACTER*1.
*           On  entry,   UPLO  specifies  whether  the  upper  or  lower
*           triangular  part  of the  array  C  is to be  referenced  as
*           follows:
*
*              UPLO = 'U' or 'u'   Only the  upper triangular part of  C
*                                  is to be referenced.
*
*              UPLO = 'L' or 'l'   Only the  lower triangular part of  C
*                                  is to be referenced.
*
*           Unchanged on exit.
*
*  TRANS  - CHARACTER*1.
*           On entry,  TRANS  specifies the operation to be performed as
*           follows:
*
*              TRANS = 'N' or 'n'   C := alpha*A*conjg( A' ) + beta*C.
*
*              TRANS = 'C' or 'c'   C := alpha*conjg( A' )*A + beta*C.
*
*           Unchanged on exit.
*
*  N      - INTEGER.
*           On entry,  N specifies the order of the matrix C.  N must be
*           at least zero.
*           Unchanged on exit.
*
*  K      - INTEGER.
*           On entry with  TRANS = 'N' or 'n',  K  specifies  the number
*           of  columns   of  the   matrix   A,   and  on   entry   with
*           TRANS = 'C' or 'c',  K  specifies  the number of rows of the
*           matrix A.  K must be at least zero.
*           Unchanged on exit.
*
*  ALPHA  - DOUBLE PRECISION            .
*           On entry, ALPHA specifies the scalar alpha.
*           Unchanged on exit.
*
*  A      - COMPLEX*16       array of DIMENSION ( LDA, ka ), where ka is
*           k  when  TRANS = 'N' or 'n',  and is  n  otherwise.
*           Before entry with  TRANS = 'N' or 'n',  the  leading  n by k
*           part of the array  A  must contain the matrix  A,  otherwise
*           the leading  k by n  part of the array  A  must contain  the
*           matrix A.
*           Unchanged on exit.
*
*  LDA    - INTEGER.
*           On entry, LDA specifies the first dimension of A as declared
*           in  the  calling  (sub)  program.   When  TRANS = 'N' or 'n'
*           then  LDA must be at least  max( 1, n ), otherwise  LDA must
*           be at least  max( 1, k ).
*           Unchanged on exit.
*
*  BETA   - DOUBLE PRECISION.
*           On entry, BETA specifies the scalar beta.
*           Unchanged on exit.
*
*  C      - COMPLEX*16          array of DIMENSION ( LDC, n ).
*           Before entry  with  UPLO = 'U' or 'u',  the leading  n by n
*           upper triangular part of the array C must contain the upper
*           triangular part  of the  hermitian matrix  and the strictly
*           lower triangular part of C is not referenced.  On exit, the
*           upper triangular part of the array  C is overwritten by the
*           upper triangular part of the updated matrix.
*           Before entry  with  UPLO = 'L' or 'l',  the leading  n by n
*           lower triangular part of the array C must contain the lower
*           triangular part  of the  hermitian matrix  and the strictly
*           upper triangular part of C is not referenced.  On exit, the
*           lower triangular part of the array  C is overwritten by the
*           lower triangular part of the updated matrix.
*           Note that the imaginary parts of the diagonal elements need
*           not be set,  they are assumed to be zero,  and on exit they
*           are set to zero.
*
*  LDC    - INTEGER.
*           On entry, LDC specifies the first dimension of C as declared
*           in  the  calling  (sub)  program.   LDC  must  be  at  least
*           max( 1, n ).
*           Unchanged on exit.
*
*
*  Level 3 Blas routine.
*
*  -- Written on 8-February-1989.
*     Jack Dongarra, Argonne National Laboratory.
*     Iain Duff, AERE Harwell.
*     Jeremy Du Croz, Numerical Algorithms Group Ltd.
*     Sven Hammarling, Numerical Algorithms Group Ltd.
*
*  -- Modified 8-Nov-93 to set C(J,J) to DBLE( C(J,J) ) when BETA = 1.
*     Ed Anderson, Cray Research Inc.
*
*
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          DBLE, DCMPLX, DCONJG, MAX
*     ..
*     .. Local Scalars ..
      LOGICAL            UPPER
      INTEGER            I, INFO, J, L, NROWA
      DOUBLE PRECISION   RTEMP
      COMPLEX*16         TEMP
*     ..
*     .. Parameters ..
      DOUBLE PRECISION   ONE, ZERO
      PARAMETER          ( ONE = 1.0D+0, ZERO = 0.0D+0 )
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      IF( LSAME( TRANS, 'N' ) ) THEN
         NROWA = N
      ELSE
         NROWA = K
      END IF
      UPPER = LSAME( UPLO, 'U' )
*
      INFO = 0
      IF( ( .NOT.UPPER ) .AND. ( .NOT.LSAME( UPLO, 'L' ) ) ) THEN
         INFO = 1
      ELSE IF( ( .NOT.LSAME( TRANS, 'N' ) ) .AND.
     $         ( .NOT.LSAME( TRANS, 'C' ) ) ) THEN
         INFO = 2
      ELSE IF( N.LT.0 ) THEN
         INFO = 3
      ELSE IF( K.LT.0 ) THEN
         INFO = 4
      ELSE IF( LDA.LT.MAX( 1, NROWA ) ) THEN
         INFO = 7
      ELSE IF( LDC.LT.MAX( 1, N ) ) THEN
         INFO = 10
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'ZHERK ', INFO )
         RETURN
      END IF
*
*     Quick return if possible.
*
      IF( ( N.EQ.0 ) .OR. ( ( ( ALPHA.EQ.ZERO ) .OR. ( K.EQ.0 ) ) .AND.
     $    ( BETA.EQ.ONE ) ) )RETURN
*
*     And when  alpha.eq.zero.
*
      IF( ALPHA.EQ.ZERO ) THEN
         IF( UPPER ) THEN
            IF( BETA.EQ.ZERO ) THEN
               DO 20 J = 1, N
                  DO 10 I = 1, J
                     C( I, J ) = ZERO
   10             CONTINUE
   20          CONTINUE
            ELSE
               DO 40 J = 1, N
                  DO 30 I = 1, J - 1
                     C( I, J ) = BETA*C( I, J )
   30             CONTINUE
                  C( J, J ) = BETA*DBLE( C( J, J ) )
   40          CONTINUE
            END IF
         ELSE
            IF( BETA.EQ.ZERO ) THEN
               DO 60 J = 1, N
                  DO 50 I = J, N
                     C( I, J ) = ZERO
   50             CONTINUE
   60          CONTINUE
            ELSE
               DO 80 J = 1, N
                  C( J, J ) = BETA*DBLE( C( J, J ) )
                  DO 70 I = J + 1, N
                     C( I, J ) = BETA*C( I, J )
   70             CONTINUE
   80          CONTINUE
            END IF
         END IF
         RETURN
      END IF
*
*     Start the operations.
*
      IF( LSAME( TRANS, 'N' ) ) THEN
*
*        Form  C := alpha*A*conjg( A' ) + beta*C.
*
         IF( UPPER ) THEN
            DO 130 J = 1, N
               IF( BETA.EQ.ZERO ) THEN
                  DO 90 I = 1, J
                     C( I, J ) = ZERO
   90             CONTINUE
               ELSE IF( BETA.NE.ONE ) THEN
                  DO 100 I = 1, J - 1
                     C( I, J ) = BETA*C( I, J )
  100             CONTINUE
                  C( J, J ) = BETA*DBLE( C( J, J ) )
               ELSE
                  C( J, J ) = DBLE( C( J, J ) )
               END IF
               DO 120 L = 1, K
                  IF( A( J, L ).NE.DCMPLX( ZERO ) ) THEN
                     TEMP = ALPHA*DCONJG( A( J, L ) )
                     DO 110 I = 1, J - 1
                        C( I, J ) = C( I, J ) + TEMP*A( I, L )
  110                CONTINUE
                     C( J, J ) = DBLE( C( J, J ) ) +
     $                           DBLE( TEMP*A( I, L ) )
                  END IF
  120          CONTINUE
  130       CONTINUE
         ELSE
            DO 180 J = 1, N
               IF( BETA.EQ.ZERO ) THEN
                  DO 140 I = J, N
                     C( I, J ) = ZERO
  140             CONTINUE
               ELSE IF( BETA.NE.ONE ) THEN
                  C( J, J ) = BETA*DBLE( C( J, J ) )
                  DO 150 I = J + 1, N
                     C( I, J ) = BETA*C( I, J )
  150             CONTINUE
               ELSE
                  C( J, J ) = DBLE( C( J, J ) )
               END IF
               DO 170 L = 1, K
                  IF( A( J, L ).NE.DCMPLX( ZERO ) ) THEN
                     TEMP = ALPHA*DCONJG( A( J, L ) )
                     C( J, J ) = DBLE( C( J, J ) ) +
     $                           DBLE( TEMP*A( J, L ) )
                     DO 160 I = J + 1, N
                        C( I, J ) = C( I, J ) + TEMP*A( I, L )
  160                CONTINUE
                  END IF
  170          CONTINUE
  180       CONTINUE
         END IF
      ELSE
*
*        Form  C := alpha*conjg( A' )*A + beta*C.
*
         IF( UPPER ) THEN
            DO 220 J = 1, N
               DO 200 I = 1, J - 1
                  TEMP = ZERO
                  DO 190 L = 1, K
                     TEMP = TEMP + DCONJG( A( L, I ) )*A( L, J )
  190             CONTINUE
                  IF( BETA.EQ.ZERO ) THEN
                     C( I, J ) = ALPHA*TEMP
                  ELSE
                     C( I, J ) = ALPHA*TEMP + BETA*C( I, J )
                  END IF
  200          CONTINUE
               RTEMP = ZERO
               DO 210 L = 1, K
                  RTEMP = RTEMP + DCONJG( A( L, J ) )*A( L, J )
  210          CONTINUE
               IF( BETA.EQ.ZERO ) THEN
                  C( J, J ) = ALPHA*RTEMP
               ELSE
                  C( J, J ) = ALPHA*RTEMP + BETA*DBLE( C( J, J ) )
               END IF
  220       CONTINUE
         ELSE
            DO 260 J = 1, N
               RTEMP = ZERO
               DO 230 L = 1, K
                  RTEMP = RTEMP + DCONJG( A( L, J ) )*A( L, J )
  230          CONTINUE
               IF( BETA.EQ.ZERO ) THEN
                  C( J, J ) = ALPHA*RTEMP
               ELSE
                  C( J, J ) = ALPHA*RTEMP + BETA*DBLE( C( J, J ) )
               END IF
               DO 250 I = J + 1, N
                  TEMP = ZERO
                  DO 240 L = 1, K
                     TEMP = TEMP + DCONJG( A( L, I ) )*A( L, J )
  240             CONTINUE
                  IF( BETA.EQ.ZERO ) THEN
                     C( I, J ) = ALPHA*TEMP
                  ELSE
                     C( I, J ) = ALPHA*TEMP + BETA*C( I, J )
                  END IF
  250          CONTINUE
  260       CONTINUE
         END IF
      END IF
*
      RETURN
*
*     End of ZHERK .
*
      END

C
C $Id: mdgdsp.f,v 1.2 2008-07-27 00:17:09 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      REAL FUNCTION MDGDSP (ALAT,ALON,BLAT,BLON)
C
        REAL ALAT,ALON,CALT,SALT,CALN,SALN
        REAL BLAT,BLON,CBLT,SBLT,CBLN,SBLN
C
        REAL XCOA,YCOA,ZCOA
        REAL XCOB,YCOB,ZCOB
C
        REAL DIST
C
        REAL DTOR,RTOD
C
        DATA DTOR / .017453292519943E0 /
        DATA RTOD / 57.2957795130823E0 /
C
        CALT=COS(DTOR*ALAT)
        SALT=SIN(DTOR*ALAT)
        CALN=COS(DTOR*ALON)
        SALN=SIN(DTOR*ALON)
C
        CBLT=COS(DTOR*BLAT)
        SBLT=SIN(DTOR*BLAT)
        CBLN=COS(DTOR*BLON)
        SBLN=SIN(DTOR*BLON)
C
        XCOA=CALT*CALN
        YCOA=CALT*SALN
        ZCOA=SALT
C
        XCOB=CBLT*CBLN
        YCOB=CBLT*SBLN
        ZCOB=SBLT
C
        DIST=SQRT((XCOA-XCOB)**2+(YCOA-YCOB)**2+(ZCOA-ZCOB)**2)
C
        MDGDSP=2.E0*RTOD*ASIN(DIST/2.E0)
C
        RETURN
C
      END

C
C $Id: bcftol.f,v 1.4 2008-07-27 00:17:29 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      REAL FUNCTION BCFTOL(BX,BY)
C
C  Returns the maximum undirected distance that the line connecting 
C  the points  (BX(1),BY(1))  and  (BX(4),BY(4))  is away from the
C  actual Bezier curve whose control points are given in BX and BY.
C
      DIMENSION BX(4),BY(4)
C
      D1 = BCDP2L(BX(2),BY(2),BX(1),BY(1),BX(4),BY(4))
      D2 = BCDP2L(BX(3),BY(3),BX(1),BY(1),BX(4),BY(4))
C 
      BCFTOL = MAX(D1,D2)
C
      RETURN
      END

C
C $Id: paksdp.f,v 1.5 2008-07-27 00:17:10 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      DOUBLE PRECISION FUNCTION PAKSDP (ANG)
C
C FUNCTION TO CONVERT DMS PACKED ANGLE INTO SECONDS OF ARC.
C
      IMPLICIT DOUBLE PRECISION (A-Z)
      INTEGER I
      DIMENSION CODE(2)
      COMMON /ERRMZ0/ IERR
        INTEGER IERR
      SAVE   /ERRMZ0/
      COMMON /PRINZ0/ IPEMSG,IPELUN,IPPARM,IPPLUN
        INTEGER IPEMSG,IPELUN,IPPARM,IPPLUN
      SAVE   /PRINZ0/
      DATA CODE /1000000.0D0,1000.0D0/
      DATA ZERO,ONE /0.0D0,1.0D0/
      DATA C1,C2 /3600.0D0,60.0D0/
      DATA TOL /1.0D-4/
C
C SEPARATE DEGREE FIELD.
C
      FACTOR = ONE
      IF (ANG .LT. ZERO) FACTOR = - ONE
      SEC = ABS(ANG)
      TMP = CODE(1)
      I = INT ((SEC / TMP) + TOL)
      IF (I .GT. 360) GO TO 020
      DEG = I
C
C SEPARATE MINUTES FIELD.
C
      SEC = SEC - DEG * TMP
      TMP = CODE(2)
      I = INT ((SEC / TMP) + TOL)
      IF (I .GT. 60) GO TO 020
      MIN = I
C
C SEPARATE SECONDS FIELD.
C
      SEC = SEC - MIN * TMP
      IF (SEC .GT. C2) GO TO 020
      SEC = FACTOR * (DEG * C1 + MIN * C2 + SEC)
      GO TO 040
C
C ERROR DETECTED IN DMS FORM.
C
  020 WRITE (IPELUN,2000) ANG
 2000 FORMAT (/' ERROR PAKSDP'/
     .         ' ILLEGAL DMS FIELD =',F15.3)
      STOP 16
C
  040 PAKSDP = SEC
C
      RETURN
      END

      SUBROUTINE ZGETC2( N, A, LDA, IPIV, JPIV, INFO )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      INTEGER            INFO, LDA, N
*     ..
*     .. Array Arguments ..
      INTEGER            IPIV( * ), JPIV( * )
      COMPLEX*16         A( LDA, * )
*     ..
*
*  Purpose
*  =======
*
*  ZGETC2 computes an LU factorization, using complete pivoting, of the
*  n-by-n matrix A. The factorization has the form A = P * L * U * Q,
*  where P and Q are permutation matrices, L is lower triangular with
*  unit diagonal elements and U is upper triangular.
*
*  This is a level 1 BLAS version of the algorithm.
*
*  Arguments
*  =========
*
*  N       (input) INTEGER
*          The order of the matrix A. N >= 0.
*
*  A       (input/output) COMPLEX*16 array, dimension (LDA, N)
*          On entry, the n-by-n matrix to be factored.
*          On exit, the factors L and U from the factorization
*          A = P*L*U*Q; the unit diagonal elements of L are not stored.
*          If U(k, k) appears to be less than SMIN, U(k, k) is given the
*          value of SMIN, giving a nonsingular perturbed system.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(1, N).
*
*  IPIV    (output) INTEGER array, dimension (N).
*          The pivot indices; for 1 <= i <= N, row i of the
*          matrix has been interchanged with row IPIV(i).
*
*  JPIV    (output) INTEGER array, dimension (N).
*          The pivot indices; for 1 <= j <= N, column j of the
*          matrix has been interchanged with column JPIV(j).
*
*  INFO    (output) INTEGER
*           = 0: successful exit
*           > 0: if INFO = k, U(k, k) is likely to produce overflow if
*                one tries to solve for x in Ax = b. So U is perturbed
*                to avoid the overflow.
*
*  Further Details
*  ===============
*
*  Based on contributions by
*     Bo Kagstrom and Peter Poromaa, Department of Computing Science,
*     Umea University, S-901 87 Umea, Sweden.
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO, ONE
      PARAMETER          ( ZERO = 0.0D+0, ONE = 1.0D+0 )
*     ..
*     .. Local Scalars ..
      INTEGER            I, IP, IPV, J, JP, JPV
      DOUBLE PRECISION   BIGNUM, EPS, SMIN, SMLNUM, XMAX
*     ..
*     .. External Subroutines ..
      EXTERNAL           ZGERU, ZSWAP
*     ..
*     .. External Functions ..
      DOUBLE PRECISION   DLAMCH
      EXTERNAL           DLAMCH
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, DCMPLX, MAX
*     ..
*     .. Executable Statements ..
*
*     Set constants to control overflow
*
      INFO = 0
      EPS = DLAMCH( 'P' )
      SMLNUM = DLAMCH( 'S' ) / EPS
      BIGNUM = ONE / SMLNUM
      CALL DLABAD( SMLNUM, BIGNUM )
*
*     Factorize A using complete pivoting.
*     Set pivots less than SMIN to SMIN
*
      DO 40 I = 1, N - 1
*
*        Find max element in matrix A
*
         XMAX = ZERO
         DO 20 IP = I, N
            DO 10 JP = I, N
               IF( ABS( A( IP, JP ) ).GE.XMAX ) THEN
                  XMAX = ABS( A( IP, JP ) )
                  IPV = IP
                  JPV = JP
               END IF
   10       CONTINUE
   20    CONTINUE
         IF( I.EQ.1 )
     $      SMIN = MAX( EPS*XMAX, SMLNUM )
*
*        Swap rows
*
         IF( IPV.NE.I )
     $      CALL ZSWAP( N, A( IPV, 1 ), LDA, A( I, 1 ), LDA )
         IPIV( I ) = IPV
*
*        Swap columns
*
         IF( JPV.NE.I )
     $      CALL ZSWAP( N, A( 1, JPV ), 1, A( 1, I ), 1 )
         JPIV( I ) = JPV
*
*        Check for singularity
*
         IF( ABS( A( I, I ) ).LT.SMIN ) THEN
            INFO = I
            A( I, I ) = DCMPLX( SMIN, ZERO )
         END IF
         DO 30 J = I + 1, N
            A( J, I ) = A( J, I ) / A( I, I )
   30    CONTINUE
         CALL ZGERU( N-I, N-I, -DCMPLX( ONE ), A( I+1, I ), 1,
     $               A( I, I+1 ), LDA, A( I+1, I+1 ), LDA )
   40 CONTINUE
*
      IF( ABS( A( N, N ) ).LT.SMIN ) THEN
         INFO = N
         A( N, N ) = DCMPLX( SMIN, ZERO )
      END IF
      RETURN
*
*     End of ZGETC2
*
      END

C
C $Id: mdrgsq.f,v 1.15 2008-09-18 00:42:18 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MDRGSQ (ICAT,ICEL,IRIM,ILAT,ILON,IFLL,XCRA,YCRA,MCRA)
C
        INTEGER ICAT,ICEL,IRIM,ILAT,ILON,IFLL,MCRA
        REAL XCRA(MCRA),YCRA(MCRA)
C
C This routine, given the file identifiers ICAT, ICEL, and IRIM for a
C particular level of the RANGS/GSHHS data, the integer latitude and
C longitude ILAT and ILON (-90.LE.ILAT.LE.89 and 0.LE.ILON.LE.359) of
C the lower left-hand corner of a particular 1-degree square, and a
C flag IFLL, retrieves the polygons within the specified square, maps
C them by calling MDPTRN, and then either fills them (if IFLL is
C non-zero) or just draws them (if IFLL is zero).  The arrays XCRA and
C YCRA are used to hold the coordinates of points defining polygons
C retrieved from the data arrays.
C
C Declare required common blocks.  See MAPBDX for descriptions of these
C common blocks and the variables in them.
C
        COMMON /MAPRGD/  ICOL(5),ICSF(5),IDPF,LCRA,NILN,NILT,OLAT,OLON
        INTEGER          ICOL,ICSF,IDPF,LCRA,NILN,NILT
        REAL             OLAT,OLON
        SAVE   /MAPRGD/
C
C Declare local variables.
C
        INTEGER          I,IBEG,IDIR,IEND,IFLG,IINT,ILEV,IPGB,IPID,IPOS,
     +                   ISGB,ISTA,ITML,ITMP,ITYP,NCRA,NPTS,ISHIFT
C
        DOUBLE PRECISION DLAT,DLON,PLAT,PLON,QLAT,QLON,RLAT,RLON,XCRD,
     +                   XLAT,XLON,YCRD
C
C CTM4 and CTM1 are character temporaries into which we can read a group
C of four bytes or a single byte, respectively.  (Because the data are
C written in a byte-swapped fashion, we cannot read a four-byte quantity
C as if it were an integer; instead, we must read the four bytes and put
C the integer together.)
C
        CHARACTER*4 CTM4
        CHARACTER*1 CTM1
C
C Define an amended version of the FORTRAN function ICHAR that will work
C on machines like the IBM, which sign-extend eight-bit characters.
C
        CHARACTER*1 CARG
C
        ICHARF(CARG)=MOD(ICHAR(CARG)+256,256)
C
C Compute the values of the parameters DLON and DLAT from the values of
C NILN and NILT in COMMON.
C
        DLON=1.D0/DBLE(NILN)
        DLAT=1.D0/DBLE(NILT)
C
C Zero the polygon-level counter and the count of polygon points saved.
C
        ILEV=0
        NCRA=0
C
C Look in the catalog for a pointer to the definition of the desired
C 1-degree square in the cell file.
C
        CALL NGSEEK (ICAT,4*((89-ILAT)*360+ILON),0,ISTA)
C
        IF (ISTA.LT.0) THEN
          CALL SETER ('MDRGSQ - SEEK FAILURE IN CAT FILE',1,1)
          RETURN
        END IF
C
        CALL NGRDCH (ICAT,CTM4,4,ISTA)
C
        IF (ISTA.NE.4) THEN
          CALL SETER ('MDRGSQ - READ FAILURE IN CAT FILE',2,1)
          RETURN
        END IF
C
        IPOS=IOR(ISHIFT(IOR(ISHIFT(IOR(ISHIFT(ICHARF(CTM4(4:4)),8),
     +                                        ICHARF(CTM4(3:3))),8),
     +                                        ICHARF(CTM4(2:2))),8),
     +                                        ICHARF(CTM4(1:1)))-1
C
C Position the cell file to the start of the definition.
C
        CALL NGSEEK (ICEL,IPOS,0,ISTA)
C
        IF (ISTA.LT.0) THEN
          CALL SETER ('MDRGSQ - SEEK FAILURE IN CEL FILE',3,1)
          RETURN
        END IF
C
C Read a new polygon byte.
C
  101   CALL NGRDCH (ICEL,CTM1,1,ISTA)
C
        IF (ISTA.NE.1) THEN
          CALL SETER ('MDRGSQ - READ FAILURE IN CEL FILE',4,1)
          RETURN
        END IF
C
        IPGB = ICHARF(CTM1)
C
C If the polygon byte is non-zero, we are at the start of a new polygon.
C
        IF (IPGB.NE.0) THEN
C
C Bump the value of ILEV by one.  This is done because the definition
C of a polygon is recursive; it can itself include one or more interior
C polygons that form holes in it.  Each polygon begins with a non-zero
C polygon byte and ends with a zero polygon byte; if, when we read for
C a polygon byte, we get a non-zero value, we know that a new level of
C recursion is beginning.
C
          ILEV=ILEV+1
C
C Read the polygon ID.
C
          CALL NGRDCH (ICEL,CTM4,4,ISTA)
C
          IF (ISTA.NE.4) THEN
            CALL SETER ('MDRGSQ - READ FAILURE IN CEL FILE',5,1)
            RETURN
          END IF
C
          IPID=IOR(ISHIFT(IOR(ISHIFT(IOR(ISHIFT(ICHARF(CTM4(4:4)),8),
     +                                          ICHARF(CTM4(3:3))),8),
     +                                          ICHARF(CTM4(2:2))),8),
     +                                          ICHARF(CTM4(1:1)))
C
C Zero IFLG.  It gets set non-zero when we have found the first point
C of the polygon, positive if that point is on the edge of the 1-degree
C cell, negative if otherwise.
C
          IFLG=0
C
C Zero ITMP.  This is done because we save the previous value of ITMP
C in ITML; it prevents ITML from getting a garbage value.
C
          ITMP=0
C
C Read a new segment byte.
C
  102     CALL NGRDCH (ICEL,CTM1,1,ISTA)
C
          IF (ISTA.NE.1) THEN
            CALL SETER ('MDRGSQ - READ FAILURE IN CEL FILE',6,1)
            RETURN
          END IF
C
          ISGB = ICHARF(CTM1)
C
C The low-order three bits of the segment byte tell us what follows.
C Pull them off into ITMP, saving the previous value as ITML.
C
          ITML=ITMP
          ITMP=IAND(ISGB,7)
C
C If ITMP is non-zero, extract a three-bit integer that tells us the
C type of the polygon we're working on (0 => ocean, 1 => land, 2 =>
C lake, 3 => island in lake, 4 => pond on island).
C
          IF (ITMP.NE.0) ITYP=IAND(ISHIFT(ISGB,-4),7)
C
C If ITMP is between 1 and 6, inclusive, it specifies a number of
C points defined by values read from the cell file; each point is
C defined by two 4-byte integers, the first a longitude and the
C second a latitude, in units of millionths of a degree.  All of these
C points are on the edge of the 1-degree cell.
C
          IF (ITMP.GE.1.AND.ITMP.LE.6) THEN
C
            NPTS = ITMP
C
C Loop to read the points.
C
            DO 105 I=1,NPTS
C
C Read a longitude.
C
              CALL NGRDCH (ICEL,CTM4,4,ISTA)
C
              IF (ISTA.NE.4) THEN
                CALL SETER ('MDRGSQ - READ FAILURE IN CEL FILE',7,1)
                RETURN
              END IF
C
              QLON=RLON
C
              RLON=.000001D0*DBLE(IOR(ISHIFT(
     +             IOR(ISHIFT(IOR(ISHIFT(ICHARF(CTM4(4:4)),8),
     +                                   ICHARF(CTM4(3:3))),8),
     +                                   ICHARF(CTM4(2:2))),8),
     +                                   ICHARF(CTM4(1:1))))
C
C Read a latitude.
C
              CALL NGRDCH (ICEL,CTM4,4,ISTA)
C
              IF (ISTA.NE.4) THEN
                CALL SETER ('MDRGSQ - READ FAILURE IN CEL FILE',8,1)
                RETURN
              END IF
C
              QLAT=RLAT
C
              RLAT=.000001D0*DBLE(IOR(ISHIFT(
     +             IOR(ISHIFT(IOR(ISHIFT(ICHARF(CTM4(4:4)),8),
     +                                   ICHARF(CTM4(3:3))),8),
     +                                   ICHARF(CTM4(2:2))),8),
     +                                   ICHARF(CTM4(1:1))))
C
C If we had not yet seen the first point of the polygon (that is to
C say, if IFLG is zero), this is it; save its longitude and latitude
C and set IFLG to say that the first point was on the cell boundary.
C
              IF (IFLG.EQ.0) THEN
                PLON=RLON
                PLAT=RLAT
                IFLG=+1
              END IF
C
C The following code is meant to interpolate points on the cell edges
C and is executed only if we are filling the polygon, in which case it
C helps to prevent the appearance of seams where adjacent polygons meet.
C
              IF (I.NE.1) THEN
C
                IF (IFLL.NE.0) THEN
C
                  IF (RLAT.EQ.QLAT) THEN
C
                    IDIR=INT(SIGN(1.D0,RLON-QLON))
                    IBEG=INT((QLON-DBLE(ILON))/DLON)
                    IEND=INT((RLON-DBLE(ILON))/DLON)
                    IF (IDIR.GT.0) IBEG=IBEG+1
                    IF (IDIR.LT.0) IEND=IEND+1
                    XLAT=RLAT
C
                    DO 103 IINT=IBEG,IEND,IDIR
                      XLON=DBLE(ILON)+DBLE(IINT)*DLON
                      IF ((XLON-RLON)*(QLON-XLON).GT.0.D0) THEN
                        IF (NCRA+1.LT.MCRA) THEN
                          NCRA=NCRA+1
                          CALL MDPTRN (XLAT,XLON,XCRD,YCRD)
                          IF (ICFELL('MDRGSQ',9).NE.0) RETURN
                          XCRA(NCRA)=REAL(XCRD)
                          YCRA(NCRA)=REAL(YCRD)
                          IF (XCRD.EQ.1.D12) NCRA=NCRA-1
                        ELSE
                          CALL SETER
     +                      ('MDRGSQ - COORDINATE BUFFER OVERFLOW',10,1)
                          RETURN
                        END IF
                      END IF
  103               CONTINUE
C
                  ELSE IF (RLON.EQ.QLON) THEN
C
                    IDIR=INT(SIGN(1.D0,RLAT-QLAT))
                    IBEG=INT((QLAT-DBLE(ILAT))/DLAT)
                    IEND=INT((RLAT-DBLE(ILAT))/DLAT)
                    IF (IDIR.GT.0) IBEG=IBEG+1
                    IF (IDIR.LT.0) IEND=IEND+1
                    XLON=RLON
C
                    DO 104 IINT=IBEG,IEND,IDIR
                      XLAT=DBLE(ILAT)+DBLE(IINT)*DLAT
                      IF ((XLAT-RLAT)*(QLAT-XLAT).GT.0.D0) THEN
                        IF (NCRA+1.LT.MCRA) THEN
                          NCRA=NCRA+1
                          CALL MDPTRN (XLAT,XLON,XCRD,YCRD)
                          IF (ICFELL('MDRGSQ',11).NE.0) RETURN
                          XCRA(NCRA)=REAL(XCRD)
                          YCRA(NCRA)=REAL(YCRD)
                          IF (XCRD.EQ.1.D12) NCRA=NCRA-1
                        ELSE
                          CALL SETER
     +                      ('MDRGSQ - COORDINATE BUFFER OVERFLOW',12,1)
                          RETURN
                        END IF
                      END IF
  104               CONTINUE
C
                  END IF
C
                END IF
C
              END IF
C
C If we are filling the polygon or if we are not filling the polygon,
C but the point is the first or last one in a sequence on the cell edge
C (meaning that it is joined to a point in the interior of the cell),
C map it from lat/lon to u/v and insert its coordinates in the list.
C
              IF (IFLL.NE.0.OR.I.EQ.1.OR.I.EQ.NPTS) THEN
                IF (NCRA+1.LT.MCRA) THEN
                  NCRA=NCRA+1
                  CALL MDPTRN (RLAT,RLON,XCRD,YCRD)
                  IF (ICFELL('MDRGSQ',13).NE.0) RETURN
                  XCRA(NCRA)=REAL(XCRD)
                  YCRA(NCRA)=REAL(YCRD)
                  IF (XCRD.EQ.1.D12) NCRA=NCRA-1
                ELSE
                  CALL SETER
     +                      ('MDRGSQ - COORDINATE BUFFER OVERFLOW',14,1)
                  RETURN
                END IF
              END IF
C
C If we are not filling the polygon, but are just drawing its boundary,
C and this point is the first point of a series of points along the cell
C edge, dump out a polyline and clear the point-coordinate buffer.  Note
C that NPTS *can* be equal to 1 in the case of a polygon which touches
C the cell edge at one point and then heads back into the interior;
C that's the reason for the ".AND.NPTS.NE.1" in the IF.
C
              IF (IFLL.EQ.0.AND.I.EQ.1.AND.NPTS.NE.1) THEN
                IF (NCRA.GT.1) THEN
                  IF (ICOL(ITYP+1).GE.0) THEN
                    CALL GSPLCI (ICOL(ITYP+1))
                    CALL GPL (NCRA,XCRA,YCRA)
                  END IF
                END IF
                NCRA=0
              END IF
C
  105       CONTINUE
C
C Go back to read another segment byte.
C
            GO TO 102
C
C If ITMP is a 7, then the next two values in the cell file are 4-byte
C integers, the first of which is a pointer into the rim file and the
C second of which is the number of points to be read from the rim file.
C Each point in the rim file is defined like a point in the cell file,
C by a pair of 4-byte integers, specifying longitude and latitude, in
C millionths of a degree.  All of the points in the rim file are in
C the interior of the 1-degree cell.
C
          ELSE IF (ITMP.EQ.7) THEN
C
C Get the pointer into the rim file.
C
            CALL NGRDCH (ICEL,CTM4,4,ISTA)
C
            IF (ISTA.NE.4) THEN
              CALL SETER ('MDRGSQ - READ FAILURE IN CEL FILE',15,1)
              RETURN
            END IF
C
            IPOS=IOR(ISHIFT(IOR(ISHIFT(IOR(ISHIFT(ICHARF(CTM4(4:4)),8),
     +                                            ICHARF(CTM4(3:3))),8),
     +                                            ICHARF(CTM4(2:2))),8),
     +                                            ICHARF(CTM4(1:1)))-1
C
C Get the number of points to be read from the rim file.
C
            CALL NGRDCH (ICEL,CTM4,4,ISTA)
C
            IF (ISTA.NE.4) THEN
              CALL SETER ('MDRGSQ - READ FAILURE IN CEL FILE',16,1)
              RETURN
            END IF
C
            NPTS=IOR(ISHIFT(IOR(ISHIFT(IOR(ISHIFT(ICHARF(CTM4(4:4)),8),
     +                                            ICHARF(CTM4(3:3))),8),
     +                                            ICHARF(CTM4(2:2))),8),
     +                                            ICHARF(CTM4(1:1)))
C
C If the number of points to be read is non-zero (for some reason, it
C *can* happen that the number is zero), read the points.
C
            IF (NPTS.NE.0) THEN
C
C Position to the start of the list of points in the rim file.
C
              CALL NGSEEK (IRIM,IPOS,0,ISTA)
C
              IF (ISTA.LT.0) THEN
                CALL SETER ('MDRGSQ - SEEK FAILURE IN RIM FILE',17,1)
                RETURN
              END IF
C
C Loop to read the points.
C
              DO 106 I=1,NPTS
C
C Read a longitude.
C
                CALL NGRDCH (IRIM,CTM4,4,ISTA)
C
                IF (ISTA.NE.4) THEN
                  CALL SETER ('MDRGSQ - READ FAILURE IN RIM FILE',18,1)
                  RETURN
                END IF
C
                QLON=RLON
C
                RLON=.000001D0*DBLE(IOR(ISHIFT(
     +               IOR(ISHIFT(IOR(ISHIFT(ICHARF(CTM4(4:4)),8),
     +                                     ICHARF(CTM4(3:3))),8),
     +                                     ICHARF(CTM4(2:2))),8),
     +                                     ICHARF(CTM4(1:1))))
C
C Read a latitude.
C
                CALL NGRDCH (IRIM,CTM4,4,ISTA)
C
                IF (ISTA.NE.4) THEN
                  CALL SETER ('MDRGSQ - READ FAILURE IN RIM FILE',19,1)
                  RETURN
                END IF
C
                QLAT=RLAT
C
                RLAT=.000001D0*DBLE(IOR(ISHIFT(
     +               IOR(ISHIFT(IOR(ISHIFT(ICHARF(CTM4(4:4)),8),
     +                                     ICHARF(CTM4(3:3))),8),
     +                                     ICHARF(CTM4(2:2))),8),
     +                                     ICHARF(CTM4(1:1))))
C
C If we had not yet seen the first point of the polygon (that is to
C say, if IFLG is zero), this is it; save its longitude and latitude
C and set IFLG to say that the first point was not on the cell boundary.
C
                IF (IFLG.EQ.0) THEN
                  PLON=RLON
                  PLAT=RLAT
                  IFLG=-1
                END IF
C
C Since all of these points are interior points, we just map them and
C add the u/v coordinates to the point-coordinate buffers.
C
                IF (NCRA+1.LT.MCRA) THEN
                  NCRA=NCRA+1
                  CALL MDPTRN (RLAT,RLON,XCRD,YCRD)
                  IF (ICFELL('MDRGSQ',20).NE.0) RETURN
                  XCRA(NCRA)=REAL(XCRD)
                  YCRA(NCRA)=REAL(YCRD)
                  IF (XCRD.EQ.1.D12) NCRA=NCRA-1
                ELSE
                  CALL SETER
     +                     ('MDRGSQ - COORDINATE BUFFER OVERFLOW',21,1)
                  RETURN
                END IF
C
  106         CONTINUE
C
            END IF
C
C Go back to read another segment byte.
C
            GO TO 102
C
          END IF
C
C If ITMP is zero, we've reached the end of the polygon.  We must supply
C a closure point (the first point of the polygon) and then either fill
C the polygon or draw the remainder of its boundary.
C
          IF (IFLL.NE.0) THEN
C
C Output the fill area.  First, see if at least one point is defined in
C the buffers.
C
            IF (NCRA.GT.1) THEN
C
C Yes.  The complication here is that, if the last point we saw was on
C the cell edge and the first point of the polygon was also on the cell
C edge, then we have to interpolate points along the cell edge in the
C same way that was done above.
C
              IF (ITML.GE.1.AND.ITML.LE.6.AND.IFLG.GT.0) THEN
C
                QLON=RLON
                QLAT=RLAT
                RLON=PLON
                RLAT=PLAT
C
                IF (RLAT.EQ.QLAT) THEN
C
                  IDIR=INT(SIGN(1.D0,RLON-QLON))
                  IBEG=INT((QLON-DBLE(ILON))/DLON)
                  IEND=INT((RLON-DBLE(ILON))/DLON)
                  IF (IDIR.GT.0) IBEG=IBEG+1
                  IF (IDIR.LT.0) IEND=IEND+1
                  XLAT=RLAT
C
                  DO 107 IINT=IBEG,IEND,IDIR
                    XLON=DBLE(ILON)+DBLE(IINT)*DLON
                    IF ((XLON-RLON)*(QLON-XLON).GT.0.D0) THEN
                      IF (NCRA+1.LT.MCRA) THEN
                        NCRA=NCRA+1
                        CALL MDPTRN (XLAT,XLON,XCRD,YCRD)
                        IF (ICFELL('MDRGSQ',22).NE.0) RETURN
                        XCRA(NCRA)=REAL(XCRD)
                        YCRA(NCRA)=REAL(YCRD)
                        IF (XCRD.EQ.1.D12) NCRA=NCRA-1
                      ELSE
                        CALL SETER
     +                     ('MDRGSQ - COORDINATE BUFFER OVERFLOW',23,1)
                        RETURN
                      END IF
                    END IF
  107             CONTINUE
C
                ELSE IF (RLON.EQ.QLON) THEN
C
                  IDIR=INT(SIGN(1.D0,RLAT-QLAT))
                  IBEG=INT((QLAT-DBLE(ILAT))/DLAT)
                  IEND=INT((RLAT-DBLE(ILAT))/DLAT)
                  IF (IDIR.GT.0) IBEG=IBEG+1
                  IF (IDIR.LT.0) IEND=IEND+1
                  XLON=RLON
C
                  DO 108 IINT=IBEG,IEND,IDIR
                    XLAT=DBLE(ILAT)+DBLE(IINT)*DLAT
                    IF ((XLAT-RLAT)*(QLAT-XLAT).GT.0.D0) THEN
                      IF (NCRA+1.LT.MCRA) THEN
                        NCRA=NCRA+1
                        CALL MDPTRN (XLAT,XLON,XCRD,YCRD)
                        IF (ICFELL('MDRGSQ',24).NE.0) RETURN
                        XCRA(NCRA)=REAL(XCRD)
                        YCRA(NCRA)=REAL(YCRD)
                        IF (XCRD.EQ.1.D12) NCRA=NCRA-1
                      ELSE
                        CALL SETER
     +                     ('MDRGSQ - COORDINATE BUFFER OVERFLOW',25,1)
                        RETURN
                      END IF
                    END IF
  108             CONTINUE
C
                END IF
C
              END IF
C
C Add the mapped coordinates of the closure point to the buffers and
C fill the polygon.  The statement beginning "IF (ILAT.GE.55 ... " is
C necessary to fix an error in the GSHHS/RANGS database.
C
              NCRA=NCRA+1
              CALL MDPTRN (PLAT,PLON,XCRD,YCRD)
              IF (ICFELL('MDRGSQ',26).NE.0) RETURN
              XCRA(NCRA)=REAL(XCRD)
              YCRA(NCRA)=REAL(YCRD)
              IF (XCRD.EQ.1.D12) NCRA=NCRA-1
              IF (ILAT.GE.55.AND.ILAT.LE.57.AND.ILON.EQ.82.AND.
     +                                                 ITYP.EQ.2) ITYP=1
              IF (ICSF(ITYP+1).GE.0.AND.NCRA.GT.2) THEN
                CALL GSFACI (ICSF(ITYP+1))
                CALL GFA (NCRA,XCRA,YCRA)
              END IF
C
            END IF
C
          ELSE
C
C Output the remainder of a polyline.  This time, we make sure that we
C have at least one point so far.
C
            IF (NCRA.GT.0) THEN
C
C Yes.  If the last point was an interior point or if the first point
C of the polygon was an interior point, add the closure point to it.
C
              IF (ITML.EQ.7.OR.IFLG.LT.0) THEN
                NCRA=NCRA+1
                CALL MDPTRN (PLAT,PLON,XCRD,YCRD)
                IF (ICFELL('MDRGSQ',27).NE.0) RETURN
                XCRA(NCRA)=REAL(XCRD)
                YCRA(NCRA)=REAL(YCRD)
                IF (XCRD.EQ.1.D12) NCRA=NCRA-1
              END IF
C
C Now, output the polyline.
C
              IF (NCRA.GT.1) THEN
                IF (ICOL(ITYP+1).GE.0) THEN
                  CALL GSPLCI (ICOL(ITYP+1))
                  CALL GPL (NCRA,XCRA,YCRA)
                END IF
              END IF
C
            END IF
C
          END IF
C
C Zero the count of coordinates in the point-coordinate buffer.
C
          NCRA=0
C
C Go back to read another polygon byte.
C
          GO TO 101
C
C If the polygon byte is zero, it says that we've hit the end of a
C polygon.
C
        ELSE
C
C Reduce the recursion counter by one and, if it's still non-zero, go
C back to read another polygon byte.
C
          ILEV=ILEV-1
          IF (ILEV.NE.0) GO TO 101
C
        END IF
C
C Normal return.
C
        RETURN
C
      END

      SUBROUTINE CSROT( N, CX, INCX, CY, INCY, C, S )
*
*     applies a plane rotation, where the cos and sin (c and s) are real
*     and the vectors cx and cy are complex.
*     jack dongarra, linpack, 3/11/78.
*
*  =====================================================================
*
*     .. Scalar Arguments ..
      INTEGER           INCX, INCY, N
      REAL              C, S
*     ..
*     .. Array Arguments ..
      COMPLEX           CX( * ), CY( * )
*     ..
*     .. Local Scalars ..
      INTEGER           I, IX, IY
      COMPLEX           CTEMP
*     ..
*     .. Executable Statements ..
*
      IF( N.LE.0 )
     $   RETURN
      IF( INCX.EQ.1 .AND. INCY.EQ.1 )
     $   GO TO 20
*
*        code for unequal increments or equal increments not equal
*          to 1
*
      IX = 1
      IY = 1
      IF( INCX.LT.0 )
     $   IX = ( -N+1 )*INCX + 1
      IF( INCY.LT.0 )
     $   IY = ( -N+1 )*INCY + 1
      DO 10 I = 1, N
         CTEMP = C*CX( IX ) + S*CY( IY )
         CY( IY ) = C*CY( IY ) - S*CX( IX )
         CX( IX ) = CTEMP
         IX = IX + INCX
         IY = IY + INCY
   10 CONTINUE
      RETURN
*
*        code for both increments equal to 1
*
   20 DO 30 I = 1, N
         CTEMP = C*CX( I ) + S*CY( I )
         CY( I ) = C*CY( I ) - S*CX( I )
         CX( I ) = CTEMP
   30 CONTINUE
      RETURN
      END

      SUBROUTINE ZHEGVD( ITYPE, JOBZ, UPLO, N, A, LDA, B, LDB, W, WORK,
     $                   LWORK, RWORK, LRWORK, IWORK, LIWORK, INFO )
*
*  -- LAPACK driver routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          JOBZ, UPLO
      INTEGER            INFO, ITYPE, LDA, LDB, LIWORK, LRWORK, LWORK, N
*     ..
*     .. Array Arguments ..
      INTEGER            IWORK( * )
      DOUBLE PRECISION   RWORK( * ), W( * )
      COMPLEX*16         A( LDA, * ), B( LDB, * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  ZHEGVD computes all the eigenvalues, and optionally, the eigenvectors
*  of a complex generalized Hermitian-definite eigenproblem, of the form
*  A*x=(lambda)*B*x,  A*Bx=(lambda)*x,  or B*A*x=(lambda)*x.  Here A and
*  B are assumed to be Hermitian and B is also positive definite.
*  If eigenvectors are desired, it uses a divide and conquer algorithm.
*
*  The divide and conquer algorithm makes very mild assumptions about
*  floating point arithmetic. It will work on machines with a guard
*  digit in add/subtract, or on those binary machines without guard
*  digits which subtract like the Cray X-MP, Cray Y-MP, Cray C-90, or
*  Cray-2. It could conceivably fail on hexadecimal or decimal machines
*  without guard digits, but we know of none.
*
*  Arguments
*  =========
*
*  ITYPE   (input) INTEGER
*          Specifies the problem type to be solved:
*          = 1:  A*x = (lambda)*B*x
*          = 2:  A*B*x = (lambda)*x
*          = 3:  B*A*x = (lambda)*x
*
*  JOBZ    (input) CHARACTER*1
*          = 'N':  Compute eigenvalues only;
*          = 'V':  Compute eigenvalues and eigenvectors.
*
*  UPLO    (input) CHARACTER*1
*          = 'U':  Upper triangles of A and B are stored;
*          = 'L':  Lower triangles of A and B are stored.
*
*  N       (input) INTEGER
*          The order of the matrices A and B.  N >= 0.
*
*  A       (input/output) COMPLEX*16 array, dimension (LDA, N)
*          On entry, the Hermitian matrix A.  If UPLO = 'U', the
*          leading N-by-N upper triangular part of A contains the
*          upper triangular part of the matrix A.  If UPLO = 'L',
*          the leading N-by-N lower triangular part of A contains
*          the lower triangular part of the matrix A.
*
*          On exit, if JOBZ = 'V', then if INFO = 0, A contains the
*          matrix Z of eigenvectors.  The eigenvectors are normalized
*          as follows:
*          if ITYPE = 1 or 2, Z**H*B*Z = I;
*          if ITYPE = 3, Z**H*inv(B)*Z = I.
*          If JOBZ = 'N', then on exit the upper triangle (if UPLO='U')
*          or the lower triangle (if UPLO='L') of A, including the
*          diagonal, is destroyed.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(1,N).
*
*  B       (input/output) COMPLEX*16 array, dimension (LDB, N)
*          On entry, the Hermitian matrix B.  If UPLO = 'U', the
*          leading N-by-N upper triangular part of B contains the
*          upper triangular part of the matrix B.  If UPLO = 'L',
*          the leading N-by-N lower triangular part of B contains
*          the lower triangular part of the matrix B.
*
*          On exit, if INFO <= N, the part of B containing the matrix is
*          overwritten by the triangular factor U or L from the Cholesky
*          factorization B = U**H*U or B = L*L**H.
*
*  LDB     (input) INTEGER
*          The leading dimension of the array B.  LDB >= max(1,N).
*
*  W       (output) DOUBLE PRECISION array, dimension (N)
*          If INFO = 0, the eigenvalues in ascending order.
*
*  WORK    (workspace/output) COMPLEX*16 array, dimension (LWORK)
*          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*
*  LWORK   (input) INTEGER
*          The length of the array WORK.
*          If N <= 1,                LWORK >= 1.
*          If JOBZ  = 'N' and N > 1, LWORK >= N + 1.
*          If JOBZ  = 'V' and N > 1, LWORK >= 2*N + N**2.
*
*          If LWORK = -1, then a workspace query is assumed; the routine
*          only calculates the optimal size of the WORK array, returns
*          this value as the first entry of the WORK array, and no error
*          message related to LWORK is issued by XERBLA.
*
*  RWORK   (workspace/output) DOUBLE PRECISION array, dimension (LRWORK)
*          On exit, if INFO = 0, RWORK(1) returns the optimal LRWORK.
*
*  LRWORK  (input) INTEGER
*          The dimension of the array RWORK.
*          If N <= 1,                LRWORK >= 1.
*          If JOBZ  = 'N' and N > 1, LRWORK >= N.
*          If JOBZ  = 'V' and N > 1, LRWORK >= 1 + 5*N + 2*N**2.
*
*          If LRWORK = -1, then a workspace query is assumed; the
*          routine only calculates the optimal size of the RWORK array,
*          returns this value as the first entry of the RWORK array, and
*          no error message related to LRWORK is issued by XERBLA.
*
*  IWORK   (workspace/output) INTEGER array, dimension (LIWORK)
*          On exit, if INFO = 0, IWORK(1) returns the optimal LIWORK.
*
*  LIWORK  (input) INTEGER
*          The dimension of the array IWORK.
*          If N <= 1,                LIWORK >= 1.
*          If JOBZ  = 'N' and N > 1, LIWORK >= 1.
*          If JOBZ  = 'V' and N > 1, LIWORK >= 3 + 5*N.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*          > 0:  ZPOTRF or ZHEEVD returned an error code:
*             <= N:  if INFO = i, ZHEEVD failed to converge;
*                    i off-diagonal elements of an intermediate
*                    tridiagonal form did not converge to zero;
*             > N:   if INFO = N + i, for 1 <= i <= N, then the leading
*                    minor of order i of B is not positive definite.
*                    The factorization of B could not be completed and
*                    no eigenvalues or eigenvectors were computed.
*
*  Further Details
*  ===============
*
*  Based on contributions by
*     Mark Fahey, Department of Mathematics, Univ. of Kentucky, USA
*
*  =====================================================================
*
*     .. Parameters ..
      COMPLEX*16         CONE
      PARAMETER          ( CONE = ( 1.0D+0, 0.0D+0 ) )
*     ..
*     .. Local Scalars ..
      LOGICAL            LQUERY, UPPER, WANTZ
      CHARACTER          TRANS
      INTEGER            LIOPT, LIWMIN, LOPT, LROPT, LRWMIN, LWMIN, NEIG
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           XERBLA, ZHEEVD, ZHEGST, ZPOTRF, ZTRMM, ZTRSM
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          DBLE, MAX
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      WANTZ = LSAME( JOBZ, 'V' )
      UPPER = LSAME( UPLO, 'U' )
      LQUERY = ( LWORK.EQ.-1 .OR. LRWORK.EQ.-1 .OR. LIWORK.EQ.-1 )
*
      INFO = 0
      IF( N.LE.1 ) THEN
         LWMIN = 1
         LRWMIN = 1
         LIWMIN = 1
         LOPT = LWMIN
         LROPT = LRWMIN
         LIOPT = LIWMIN
      ELSE
         IF( WANTZ ) THEN
            LWMIN = 2*N + N*N
            LRWMIN = 1 + 5*N + 2*N*N
            LIWMIN = 3 + 5*N
         ELSE
            LWMIN = N + 1
            LRWMIN = N
            LIWMIN = 1
         END IF
         LOPT = LWMIN
         LROPT = LRWMIN
         LIOPT = LIWMIN
      END IF
      IF( ITYPE.LT.0 .OR. ITYPE.GT.3 ) THEN
         INFO = -1
      ELSE IF( .NOT.( WANTZ .OR. LSAME( JOBZ, 'N' ) ) ) THEN
         INFO = -2
      ELSE IF( .NOT.( UPPER .OR. LSAME( UPLO, 'L' ) ) ) THEN
         INFO = -3
      ELSE IF( N.LT.0 ) THEN
         INFO = -4
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -6
      ELSE IF( LDB.LT.MAX( 1, N ) ) THEN
         INFO = -8
      ELSE IF( LWORK.LT.LWMIN .AND. .NOT.LQUERY ) THEN
         INFO = -11
      ELSE IF( LRWORK.LT.LRWMIN .AND. .NOT.LQUERY ) THEN
         INFO = -13
      ELSE IF( LIWORK.LT.LIWMIN .AND. .NOT.LQUERY ) THEN
         INFO = -15
      END IF
*
      IF( INFO.EQ.0 ) THEN
         WORK( 1 ) = LOPT
         RWORK( 1 ) = LROPT
         IWORK( 1 ) = LIOPT
      END IF
*
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'ZHEGVD', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
*
*     Form a Cholesky factorization of B.
*
      CALL ZPOTRF( UPLO, N, B, LDB, INFO )
      IF( INFO.NE.0 ) THEN
         INFO = N + INFO
         RETURN
      END IF
*
*     Transform problem to standard eigenvalue problem and solve.
*
      CALL ZHEGST( ITYPE, UPLO, N, A, LDA, B, LDB, INFO )
      CALL ZHEEVD( JOBZ, UPLO, N, A, LDA, W, WORK, LWORK, RWORK, LRWORK,
     $             IWORK, LIWORK, INFO )
      LOPT = MAX( DBLE( LOPT ), DBLE( WORK( 1 ) ) )
      LROPT = MAX( DBLE( LROPT ), DBLE( RWORK( 1 ) ) )
      LIOPT = MAX( DBLE( LIOPT ), DBLE( IWORK( 1 ) ) )
*
      IF( WANTZ ) THEN
*
*        Backtransform eigenvectors to the original problem.
*
         NEIG = N
         IF( INFO.GT.0 )
     $      NEIG = INFO - 1
         IF( ITYPE.EQ.1 .OR. ITYPE.EQ.2 ) THEN
*
*           For A*x=(lambda)*B*x and A*B*x=(lambda)*x;
*           backtransform eigenvectors: x = inv(L)'*y or inv(U)*y
*
            IF( UPPER ) THEN
               TRANS = 'N'
            ELSE
               TRANS = 'C'
            END IF
*
            CALL ZTRSM( 'Left', UPLO, TRANS, 'Non-unit', N, NEIG, CONE,
     $                  B, LDB, A, LDA )
*
         ELSE IF( ITYPE.EQ.3 ) THEN
*
*           For B*A*x=(lambda)*x;
*           backtransform eigenvectors: x = L*y or U'*y
*
            IF( UPPER ) THEN
               TRANS = 'C'
            ELSE
               TRANS = 'N'
            END IF
*
            CALL ZTRMM( 'Left', UPLO, TRANS, 'Non-unit', N, NEIG, CONE,
     $                  B, LDB, A, LDA )
         END IF
      END IF
*
      WORK( 1 ) = LOPT
      RWORK( 1 ) = LROPT
      IWORK( 1 ) = LIOPT
*
      RETURN
*
*     End of ZHEGVD
*
      END

C
C	$Id: gskpop.f,v 1.5 2008-07-27 00:21:02 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GSKPOP(OPNLEN,COUNT,IOS,STATUS)
C
C  This subroutine will skip the requested number of operands.
C  It will cross pratition boundries without intervention from a 
C  higher level. The LEN variable which higher level routines utilize
C  for knowlage of the size and remainder in the partition is modified.
C
C  INPUT
C    OPNLEN -- Length of each operand in bits.
C    COUNT  -- Number of operands to skip.
C
      include 'trinst.h'
      include 'trbufr.h'
C
      INTEGER OPNLEN, COUNT,  IOS, STATUS
      INTEGER BYTSIZ, PARBIT, CUR, LEFT  , RL
C       
      DATA BYTSIZ/8/
C
      STATUS = 0
C
C  INITIALIZE THE OPERAND POINTERS
C
      PARBIT = (OPNLEN*COUNT)
C
C  LOOP FOR ALL PARTITIONS
C
 10   CONTINUE
C
      LEFT = MAX((PARBIT-LEN*BYTSIZ),0)
      CUR = MIN(PARBIT, LEN*BYTSIZ)
      LEN = LEN - (CUR/BYTSIZ)
C
C  SKIP THE OPERANDS
C
 20   CONTINUE
C
C       LOOP FOR RECORDS WITHIN A PARTITION
C
        RL = CUR+MOPRST
        CUR = MAX(CUR-(MRECLN-MOPRST),0)
        IF (CUR .GT.0) THEN
                CALL GSEGRD(IOS, STATUS)
                IF (STATUS .NE. 0) RETURN
                MOPRST = METBIT
                GO TO 20
        ELSE
                MOPRST = RL
                METBIT = RL
        END IF
C
C       LOOP IF THERE ARE MORE OPERANDS IN ANOTHER PARTITION
C
        PARBIT = LEFT
        IF (PARBIT .GT. 0) THEN
                CALL GNPART(IOS,STATUS)
                IF (STATUS .NE. 0) RETURN
                GO TO 10
        END IF
C
      RETURN
      END

C
C	$Id: lw2up.f,v 1.4 2008-07-27 00:59:03 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE LW2UP (NM)
C
C  Convert all lower-case letters in NM to upper case.
C
      CHARACTER*(*) NM
C
      LN = LEN(NM)
      DO 10 I=1,LN
      IF (NM(I:I) .EQ. 'a') NM(I:I) = 'A'
      IF (NM(I:I) .EQ. 'b') NM(I:I) = 'B'
      IF (NM(I:I) .EQ. 'c') NM(I:I) = 'C'
      IF (NM(I:I) .EQ. 'd') NM(I:I) = 'D'
      IF (NM(I:I) .EQ. 'e') NM(I:I) = 'E'
      IF (NM(I:I) .EQ. 'f') NM(I:I) = 'F'
      IF (NM(I:I) .EQ. 'g') NM(I:I) = 'G'
      IF (NM(I:I) .EQ. 'h') NM(I:I) = 'H'
      IF (NM(I:I) .EQ. 'i') NM(I:I) = 'I'
      IF (NM(I:I) .EQ. 'j') NM(I:I) = 'J'
      IF (NM(I:I) .EQ. 'k') NM(I:I) = 'K'
      IF (NM(I:I) .EQ. 'l') NM(I:I) = 'L'
      IF (NM(I:I) .EQ. 'm') NM(I:I) = 'M'
      IF (NM(I:I) .EQ. 'n') NM(I:I) = 'N'
      IF (NM(I:I) .EQ. 'o') NM(I:I) = 'O'
      IF (NM(I:I) .EQ. 'p') NM(I:I) = 'P'
      IF (NM(I:I) .EQ. 'q') NM(I:I) = 'Q'
      IF (NM(I:I) .EQ. 'r') NM(I:I) = 'R'
      IF (NM(I:I) .EQ. 's') NM(I:I) = 'S'
      IF (NM(I:I) .EQ. 't') NM(I:I) = 'T'
      IF (NM(I:I) .EQ. 'u') NM(I:I) = 'U'
      IF (NM(I:I) .EQ. 'v') NM(I:I) = 'V'
      IF (NM(I:I) .EQ. 'w') NM(I:I) = 'W'
      IF (NM(I:I) .EQ. 'x') NM(I:I) = 'X'
      IF (NM(I:I) .EQ. 'y') NM(I:I) = 'Y'
      IF (NM(I:I) .EQ. 'z') NM(I:I) = 'Z'
   10 CONTINUE
C
      RETURN
      END

C
C	$Id: g01fa.f,v 1.9 2008-07-27 00:21:05 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE G01FA
C
C  Process GKS FILL AREA instruction, send CGM polygon.
C
      include 'g01prm.h'
      include 'gksin.h'
      include 'g01io.h'
      include 'g01ins.h'
      include 'g01wsl.h'
      include 'g01rqa.h'
      include 'g01ast.h'
      include 'g01adc.h'
      include 'g01opc.h'
      include 'gksenu.h'
C
      INTEGER  KALL, IPRIM, NBYTES, INDX1, INDX2, IX
      SAVE KALL
C
      DATA  KALL/0/, IPRIM/4/
C
      KALL = KALL+1
      IF  (KALL .EQ. 1) THEN
C
C  Set the WSL entry "DISPLAY SURFACE EMPTY" to "NOT EMPTY".
C
        MDEMPT = GNEMPT
C
C  Process pending attributes.
C
        IF (AGPEND(IPRIM)) THEN
C
C  Some changes are pending.
C
          IF (VALCHG(IVFAIX))  THEN
C
C  GKS FILL AREA INDEX, send CGM fill bundle index.
C
            NBYTES = 1+(MIXFW-1)/8
            CALL GPUTNI (CLFBIX, IDFBIX,  NBYTES,  RERR)
            CALL GPUTPR (MRFAIX, MIXFW,  1, RERR)
            IF (RERR .NE. 0) RETURN
C
C  Set sent value to requested, clear change flag.
C
            MSFAIX         = MRFAIX
            VALCHG(IVFAIX) = .FALSE.
          END IF
          IF (VALCHG(IVFAIS))  THEN
C
C  GKS FILL AREA INTERIOR STYLE, send CGM INTERIOR STYLE.
C
            NBYTES = 1+(MEFW-1)/8
            CALL GPUTNI (CLINTS, IDINTS, NBYTES,  RERR)
C  Patch for Jira1667: intercept code for SOLID_TEXT_FILL, replace by SOLID_FILL
            if (MRFAIS .EQ. 4) MRFAIS = 1
            CALL GPUTPR (MRFAIS, MEFW,  1, RERR)
            IF (RERR .NE. 0) RETURN
C
C  Set sent value to requested, clear change flag.
C
            MSFAIS         = MRFAIS
            VALCHG(IVFAIS) = .FALSE.
          END IF
          IF (VALCHG(IVFASI))  THEN
C
C  GKS FILL AREA STYLE INDEX, send only the CGM hatch index since
C  ctrans does not support pattern index.
C
            NBYTES = 1+(MIXFW-1)/8
            CALL GPUTNI (CLHAIX, IDHAIX, NBYTES,  RERR)
            CALL GPUTPR (MRFASI, MIXFW, 1, RERR)
C           CALL GPUTNI (CLPTIX, IDPTIX, NBYTES,  RERR)
C           CALL GPUTPR (MRFASI, MIXFW, 1, RERR)
            IF (RERR .NE. 0) RETURN
C
C  Set sent value to requested, clear change flag.
C
            MSFASI = MRFASI
            VALCHG(IVFASI) = .FALSE.
          END IF
          IF (VALCHG(IVFACI))  THEN
C
C  GKS FILL AREA COLOR INDEX, send CGM fill color.
C
            NBYTES = 1+(MCIXFW-1)/8
            CALL GPUTNI (CLFCLR, IDFCLR, NBYTES, RERR)
            CALL GPUTPR (MRFACI, MCIXFW,  1, RERR)
            IF (RERR .NE. 0) RETURN
C
C  Set sent value to requested, clear change flag.
C
            MSFACI         = MRFACI
            VALCHG(IVFACI) = .FALSE.
          END IF
          IF (VALCHG(IVPASZ)) THEN
C
C  GKS PATTERN SIZE, send CGM pattern size vectors.
C
            NBYTES = 1+(4*MVDCFW-1)/8
            CALL GPUTNI (CLPTSZ, IDPTSZ, NBYTES, RERR)
            CALL GPUTPR (MRPASZ(1) , MVDCFW,  4, RERR)
            IF (RERR .NE. 0) RETURN
C
C  Set sent value to requested, clear change flag.
C
            DO 25 IX=1,4
              MSPASZ(IX) = MRPASZ(IX)
   25       CONTINUE
            VALCHG(IVPASZ) = .FALSE.
          END IF
          IF (VALCHG(IVPARF)) THEN
C
C  GKS PATTERN REFERENCE POINT, send CGM fill reference point.
C
            NBYTES = 1+(2*MVDCFW-1)/8
            CALL GPUTNI (CLFRPT, IDFRPT, NBYTES, RERR)
            CALL GPUTPR (MRPARF(1), MVDCFW, 2, RERR)
            IF (RERR .NE. 0) RETURN
C
C  Set sent value to requested, clear change flag.
C
            MSPARF(1) = MRPARF(1)
            MSPARF(2) = MRPARF(2)
            VALCHG(IVPARF) = .FALSE.
          END IF
          IF (ANYASF) THEN
C
C  Some GKS ASF has changed, send CGM ASFs.
C
            CALL G01SAS (IPRIM, RERR)
            IF (RERR.NE.0)  RETURN
          END IF
C
C  Clear aggregate change variable.
C
          AGPEND(IPRIM) = .FALSE.
        END IF
C
C  Treat first call, put out opcode, and points.
C
C
C  Put out opcode (CLASS AND ID) and total LENGTH.
C
        NBYTES = 1+(2*RL1*MVDCFW-1)/8
        CALL GPUTNI (CLPGON, IDPGON, NBYTES, RERR)
        IF (RERR .NE. 0) RETURN
C
C  Put out first points array.
C
C  Truncate points to limits of NDC unit square, convert to VDC,
C  and store in MPXPY.
C
        DO 30 IX=1,RL2
          INDX1 = 2*IX-1
          INDX2 = INDX1+1
          MPXPY(INDX1) = MXOFF+INT(REAL(MXSCAL)*
     +                   (MAX(0.,MIN(1.0,RX(IX)))))
          MPXPY(INDX2) = MYOFF+INT(REAL(MYSCAL)*
     +                   (MAX(0.,MIN(1.0,RY(IX)))))
   30   CONTINUE
C
C  Send out points.
C
        CALL GPUTPR (MPXPY,  MVDCFW,     2*RL2, RERR)
        IF (RERR .NE. 0) RETURN
C
C  If there is to be no continuation, reset the parameter "KALL".
C
        IF (CONT .EQ. 0) THEN
          KALL = 0
          RETURN
        ENDIF
      ENDIF
C
C  Treat the continuation calls.
C
      IF (KALL .GT. 1) THEN
C
C  Truncate points to limits of the NDC unit square; convert to VDC,
C  and store in MPXPY.
C
        DO 40 IX=1,RL2
          INDX1 = 2*IX-1
          INDX2 = INDX1+1
          MPXPY(INDX1) = MXOFF+INT(REAL(MXSCAL)*
     -                   (MAX(0.,MIN(1.0,RX(IX)))))
          MPXPY(INDX2) = MYOFF+INT(REAL(MYSCAL)*
     -                   (MAX(0.,MIN(1.0,RY(IX)))))
   40   CONTINUE
        IF (CONT .EQ. 0) THEN
          CALL GPUTPR (MPXPY,  MVDCFW,     2*RL2, RERR)
          IF (RERR .NE. 0) RETURN
          KALL = 0
        ELSE
          CALL GPUTPR (MPXPY,  MVDCFW,     2*RL2, RERR)
          IF (RERR .NE. 0) RETURN
        ENDIF
      ENDIF
      RETURN
C
      END

C
C $Id: EzmapDemo.f,v 1.16 2008-09-18 00:38:09 kennison Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C

      PROGRAM EMDEMO
C
C Declarations required to do color fill.
C
        PARAMETER (LAMA=7500000,NCRA=75000,NGPS=10,LRWK=2*NCRA)
C
        DIMENSION IAMA(LAMA),XCRA(NCRA),YCRA(NCRA),IAAI(NGPS),IAGI(NGPS)
C
        DIMENSION RWRK(LRWK)
        EQUIVALENCE (RWRK(1),XCRA(1)),(RWRK(NCRA+1),YCRA(1))
C
        EXTERNAL COLORA,DRAWLA,COLORB,DRAWLB
C
C Declare some internal common blocks so as to be able to retrieve
C various values for the State Plane projection.
C
        COMMON /MAPCM2/  BLAM,BLOM,PEPS,SLAM,SLOM,UCEN,UMAX,UMIN,UOFF,
     +                   URNG,VCEN,VMAX,VMIN,VOFF,VRNG,ISSL
        DOUBLE PRECISION BLAM,BLOM,PEPS,SLAM,SLOM,UCEN,UMAX,UMIN,UOFF,
     +                   URNG,VCEN,VMAX,VMIN,VOFF,VRNG
        INTEGER          ISSL
        SAVE   /MAPCM2/
C
        COMMON /USGSC1/ UTPA(15),UUMN,UUMX,UVMN,UVMX,IPRF
          DOUBLE PRECISION UTPA,UUMN,UUMX,UVMN,UVMX
          INTEGER IPRF
        SAVE   /USGSC1/
C
C Declare a common block in which the directory name will be passed.
C
        COMMON /EDRGDI/ USNM
          CHARACTER*60 USNM
        SAVE   /EDRGDI/
C
C Declare a common block in which to keep track of the largest fill
C polygon generated.
C
        COMMON /RASIZE/ LLPG
        SAVE   /RASIZE/
C
C Declare a couple of variables that determine what projection will be
C used and how the portion of the projection to be shown is selected.
C
        CHARACTER*2 PTYP,LTYP,CTMP
C
C Declare a variable to determine what outline dataset will be used.
C
        CHARACTER*2 ODNM
C
C Declare some two-element arrays to hold values determining what
C portion of the projection is to be shown.
C
        DIMENSION PLM1(2),PLM2(2),PLM3(2),PLM4(2)
C
C Declare a character variable into which to read commands.
C
        CHARACTER*1 COMD
C
C Declare a character variable to hold a plot label.
C
        CHARACTER*60 LABL
C
C Declare a temporary character variable to read labels and names into.
C
        CHARACTER*60 CHRT
C
C Declare the function and variable necessary to deal with area names.
C
        CHARACTER*128 MDFNME,FNME
C
C Declare a couple of arrays in which to define boxes to be filled.
C
        DIMENSION XBOX(4),YBOX(4)
C
C Declare the double-precision parameter array required for initializing
C the USGS transformations.
C
        DOUBLE PRECISION PARA(15)
C
C Declare arrays in which to put State Plane zone-number information.
C
        DIMENSION IZN0(139),IZN8(139)
C
C Declare arrays in which to save the coordinates of zone boundaries.
C
        DIMENSION PLT0(200,139),PLN0(200,139)
        DIMENSION PLT8(200,139),PLN8(200,139)
C
C Declare arrays in which to save the coordinates of zone center points
C (used to position the labels).
C
        DIMENSION CLT0(139),CLN0(139),CLT8(139),CLN8(139)
C
C Declare some double precision temporaries to be used in generating
C the Piet Hein super-ellipses that are used for the zone borders in
C place of rectangles.
C
        DOUBLE PRECISION DBLP,DANG,DSNA,DCSA
C
C Declare arrays to hold color indices to be passed to MDRGSC, defining
C the colors to be used on maps drawn from the RANGS/GSHHS database.
C
        DIMENSION LCOL(5),LCSF(5)
C
C Set the default value of the parameter that says whether or not the
C X workstation will be updated as changes are made.  (When making a
C movie, it's a good idea to set this to zero.)
C
        DATA IUXW / 1 /
C
C Set the default value of the flag that says whether the basic color
C scheme will be white on black (IBOW=0) or black on white (IBOW=1).
C
        DATA IBOW / 0 /
C
C Declare the "style" of plot to be done.
C
        DATA ISTY / 1 /
C
C Set the default values of the variables that position the map on the
C plotter frame.
C
        DATA XVPL,XVPR,YVPB,YVPT / .1,.9,.1,.9 /
C
C Set the default values of the parameters that determine the projection
C to be used.
C
        DATA PTYP,PLAT,PLON,ROTA / 'CE',3*0. /
C
C Set the default values of the parameters that determine what portion
C of the projection is shown.
C
        DATA LTYP,PLM1,PLM2,PLM3,PLM4 / 'MA',8*0. /
C
C Set the default value of the satellite altitude and the angles that
C determine where its camera is pointed.
C
        DATA SALT,SAN1,SAN2 / 3*0. /
C
C Set the default value of the parameter that determines what outline
C dataset will be used.
C
        DATA ODNM / 'CO' /
C
C Set the default value of the parameter saying at what level the new
C database "Earth..1" should be used.
C
        DATA ILVL / 3 /
C
C Set the default value of the parameter saying at what level the new
C RANGS/GSHHS database should be used.
C
        DATA IRGL / 5 /
C
C Set the default value of the miscellaneous minor parameters.
C
        DATA IPER,IELL,ILBL,IDOT,IDBD,GSPC,GSLA,GSLO,GLAT,GLON
     +     /    1,   0,   1,   0,  96,  5.,  0.,  0.,  0., 90. /
C
        DATA IINT,IRPF,SLAT
     +     /   50,   1, -1. /
C
C Set a couple of counters that keep track of how many NCGM and
C PostScript frames have been saved.
C
        DATA NFNG,NFPS / 0 , 0 /
C
C Set the default values of the parameters required to initialize the
C USGS transformations.
C
        DATA IPRJ,IZON,ISPH,PARA / 2 , 4400 , 8 , 15*0.D0 /
C
C Set the default value of the index that can be used to select a
C pre-defined plot.
C
        DATA IPDP / 1 /
C
C Set the default value of the flag that says whether to draw an
C informational label at the bottom of the plot.
C
        DATA ILPT / 1 /
C
C Set the default value of the major label at the top of the plot.
C
        DATA LABL / ' ' /
C
C Define the flag that controls whether or not lat/lon labels are to
C be displayed and the variable that specifies the width of characters
C to use in them.
C
        DATA ILLB,CSLL / -1,.012 /
C
C Define some quantities for the test during which the projection of
C a global spiral is drawn.
C
        DATA ISPC,SPLT,SPLN,NSPT / 5 , 30. , 30. , 400 /
C
C Define some quantities affecting the test during which fields of
C latitude and longitudes generated by using the inverse routines
C are contoured.
C
        DATA ICNC,NCDM / 6 , 501 /
C
C Define a constant that says how nearly rectangular the Piet Hein
C super-ellipses are to be.  (They are used in place of rectangles
C for the State Plane zones.)
C
        DATA DBLP / 10.D0 /
C
C Define a flag that says which set of State Plane zones to display.
C The value "-1" means "neither"; "0" means "NAD1927"; and "8" means
C "NAD1983".  Also define a variable that specifies the width of the
C characters to use in labeling the zones.
C
        DATA ISPG,CHSZ / -1 , .1 /
C
C Define the State Plane zone numbers.
C
        DATA (IZN0(I),IZN8(I),I=1,50)/
     +    0101,0101,0102,0102,5001,5001,5002,5002,5003,5003,
     +    5004,5004,5005,5005,5006,5006,5007,5007,5008,5008,
     +    5009,5009,5010,5010,0201,0201,0202,0202,0203,0203,
     +    0301,0301,0302,0302,0401,0401,0402,0402,0403,0403,
     +    0404,0404,0405,0405,0406,0406,0407,   0,0501,0501,
     +    0502,0502,0503,0503,0600,0600,0700,0700,1901,1901,
     +    0901,0901,0902,0902,0903,0903,1001,1001,1002,1002,
     +    5101,5101,5102,5102,5103,5103,5104,5104,5105,5105,
     +    1101,1101,1102,1102,1103,1103,1201,1201,1202,1202,
     +    1301,1301,1302,1302,1401,1401,1402,1402,1501,1501/
C
        DATA (IZN0(I),IZN8(I),I=51,100)/
     +    1502,1502,1601,1601,1602,1602,1701,1701,1702,1702,
     +    1703,1703,1801,1801,1802,1802,1900,1900,2001,2001,
     +    2002,2002,2101,   0,2102,   0,2103,   0,2111,2111,
     +    2112,2112,2113,2113,2201,2201,2202,2202,2203,2203,
     +    2301,2301,2302,2302,2401,2401,2402,2402,2403,2403,
     +       0,2500,2501,   0,2502,   0,2503,   0,   0,2600,
     +    2601,   0,2602,   0,2701,2701,2702,2702,2703,2703,
     +    2800,2800,2900,2900,3001,3001,3002,3002,3003,3003,
     +    3101,3101,3102,3102,3103,3103,3104,3104,3200,3200,
     +    3301,3301,3302,3302,3401,3401,3402,3402,3501,3501/
C
        DATA (IZN0(I),IZN8(I),I=101,139)/
     +    3502,3502,3601,3601,3602,3602,3701,3701,3702,3702,
     +    3800,3800,   0,3900,3901,   0,3902,   0,4001,4001,
     +    4002,4002,4100,4100,4201,4201,4202,4202,4203,4203,
     +    4204,4204,4205,4205,4301,4301,4302,4302,4303,4303,
     +    4400,4400,4501,4501,4502,4502,4601,4601,4602,4602,
     +    4701,4701,4702,4702,4801,4801,4802,4802,4803,4803,
     +    4901,4901,4902,4902,4903,4903,4904,4904,5201,5200,
     +    5201,5200,5202,5200,5300,   0,5400,   0/
C
C Open GKS.
C
        CALL GOPKS (6,0)
C
C Open and activate an X workstation.
C
        CALL GOPWK (1,0,8)
        CALL GACWK (1)
C
C Open and activate an NCGM workstation.
C
        CALL GOPWK (2,0,1)
        CALL GACWK (2)
C
C Open and activate a PostScript workstation.
C
        CALL GOPWK (3,0,20)
        CALL GACWK (3)
C
C Turn clipping off.
C
        CALL GSCLIP (0)
C
C Select a "fill area interior style" of "solid".
C
        CALL GSFAIS (1)
C
C Define colors on all the workstations.
C
        DO 101 IWID=1,3
          IF (IBOW.EQ.0) THEN
            CALL GSCR (IWID,  0,0.,0.,0.)
            CALL GSCR (IWID,  1,1.,1.,1.)
          ELSE
            CALL GSCR (IWID,  0,1.,1.,1.)
            CALL GSCR (IWID,  1,0.,0.,0.)
          END IF
          CALL GSCR (IWID,  2,1.,0.,0.)
          CALL GSCR (IWID,  3,0.,1.,0.)
          CALL GSCR (IWID,  4,0.,0.,1.)
          CALL GSCR (IWID,  5,0.,1.,1.)
          CALL GSCR (IWID,  6,1.,0.,1.)
          CALL GSCR (IWID,  7,1.,1.,0.)
          CALL GSCR (IWID,  8,.7,.7,0.)
          CALL GSCR (IWID,  9,1.,1.,0.)
          CALL GSCR (IWID, 10,0.,0.,0.)
          CALL GSCR (IWID, 11,1.,1.,.6)
          CALL GSCR (IWID, 12,1.,0.,0.)
          CALL GSCR (IWID,101,.2,.2,.8)
          CALL GSCR (IWID,102,.6,.4,.2)
          CALL GSCR (IWID,103,.2,.6,.4)
          CALL GSCR (IWID,104,.2,.8,.2)
          CALL GSCR (IWID,105,.4,.6,.2)
          CALL GSCR (IWID,106,.2,.4,.6)
          CALL GSCR (IWID,107,.6,.6,.6)
          CALL GSCR (IWID,108,.9,1.,1.)
          CALL GSCR (IWID,201,0.,0.,1.)  !  RANGS/GSHHS - Ocean
          CALL GSCR (IWID,202,0.,1.,0.)  !  RANGS/GSHHS - Land
          CALL GSCR (IWID,203,0.,1.,1.)  !  RANGS/GSHHS - Lake
          CALL GSCR (IWID,204,0.,1.,0.)  !  RANGS/GSHHS - Island in lake
          CALL GSCR (IWID,205,0.,1.,1.)  !  RANGS/GSHHS - Pond on island
          CALL GSCR (IWID,206,1.,1.,1.)  !  RANGS/GSHHS - Outlines
  101   CONTINUE
C
C Deactivate the NCGM and PostScript workstations.
C
        CALL GDAWK (2)
        CALL GDAWK (3)
C
C Put SETER into recovery mode.  No real error recovery is done in
C this program, but attempts to draw a plot that lead to an error
C are detected and the user is given another chance to avoid the
C error by changing parameter values.
C
        CALL ENTSR (IELD,1)
C
C Initialize PLOTCHAR font, character color, outline color, and box
C fill parameters.
C
        CALL PCSETI ('FN - FONT NUMBER',25)
        CALL PCSETI ('CC - CHARACTER COLOR',11)
        CALL PCSETI ('OF - OUTLINE FLAG',1)
        CALL PCSETI ('OC - OUTLINE LINE COLOR',11)
        CALL PCSETI ('BF - BOX FLAG',3)
        CALL PCSETI ('BC(1) - BOX COLOR 1',12)
        CALL PCSETI ('BC(2) - BOX COLOR 2',10)
        CALL PCSETR ('BL - BOX LINE WIDTH',2.)
        CALL PCSETR ('BM - BOX MARGIN WIDTH',.5)
C
C Tell EZMAP what colors to use for the outlines and filled areas
C produced from the RANGS/GSHHS data.
C
        LCOL(1)=206
        LCOL(2)=206
        LCOL(3)=206
        LCOL(4)=206
        LCOL(5)=206
C
        LCSF(1)=201
        LCSF(2)=202
        LCSF(3)=203
        LCSF(4)=204
        LCSF(5)=205
C
        CALL MDRGSC (LCOL,LCSF)
C
C Generate boundary-line data for each of the State Plane zones.
C
        PRINT * , ' '
        PRINT * , 'Generating boundary-line data for State Plane zones.'
C
        CALL MAPROJ ('UT',0.,0.,0.)
C
        DO 104 ISPI=1,139
C
          IF (IZN0(ISPI).NE.0) THEN
C
            CALL ZERODA (PARA,15)
            CALL MPUTIN (2,IZN0(ISPI),0,PARA,0.D0,0.D0,0.D0,0.D0)
C
            EPSI=.001*(UMAX-UMIN)
C
            UMID=(UMIN+UMAX)/2.
            VMID=(VMIN+VMAX)/2.
            UDIF=.999*(UMAX-UMID)
            VDIF=.999*(VMAX-VMID)
C
            CALL MAPTRI (UMID,VMID,CLT0(ISPI),CLN0(ISPI))
C
            DO 102 I=1,200
C
              DANG=1.8D0*DBLE(I-1)*.017453292519943D0
              DSNA=SIN(DANG)
              DCSA=COS(DANG)
              R=1./REAL(((ABS(DCSA)/DBLE(UDIF))**DBLP+
     +                   (ABS(DSNA)/DBLE(VDIF))**DBLP)**(1.D0/DBLP))
              CALL MAPTRI (UMID+R*REAL(DCSA),VMID+R*REAL(DSNA),
     +                     PLT0(I,ISPI),PLN0(I,ISPI))
  102       CONTINUE
C
          END IF
C
          IF (IZN8(ISPI).NE.0) THEN
C
            CALL ZERODA (PARA,15)
            CALL MPUTIN (2,IZN8(ISPI),8,PARA,0.D0,0.D0,0.D0,0.D0)
C
            EPSI=.001*(UMAX-UMIN)
C
            UMID=(UMIN+UMAX)/2.
            VMID=(VMIN+VMAX)/2.
            UDIF=.999*(UMAX-UMID)
            VDIF=.999*(VMAX-VMID)
C
            CALL MAPTRI (UMID,VMID,CLT8(ISPI),CLN8(ISPI))
C
            DO 103 I=1,200
              DANG=1.8D0*DBLE(I-1)*.017453292519943D0
              DSNA=SIN(DANG)
              DCSA=COS(DANG)
              R=1./REAL(((ABS(DCSA)/DBLE(UDIF))**DBLP+
     +                   (ABS(DSNA)/DBLE(VDIF))**DBLP)**(1.D0/DBLP))
              CALL MAPTRI (UMID+R*REAL(DCSA),VMID+R*REAL(DSNA),
     +                     PLT8(I,ISPI),PLN8(I,ISPI))
  103       CONTINUE
C
          END IF
C
  104   CONTINUE
C
C Initialize the variable that will be returned to EZMAP when it asks
C for the name of the directory containing the RANGS/GSHHS data.
C
        USNM=' '
C
C If the X workstation is not to be updated, jump to get user input.
C
  105   IF (IUXW.EQ.0) GO TO 106
C
C Clear the X workstation.
C
        PRINT * , ' '
        PRINT * , 'Clearing the workstation.'
C
        CALL GCLRWK (1,1)
C
C Draw a map.
C
        PRINT * , ' '
        PRINT * , 'Drawing the map.'
C
        CALL MPSETI ('PE',IPER)
        CALL MPSETI ('EL',IELL)
        CALL MPSETI ('LA',ILBL)
        CALL MPSETI ('DO',IDOT)
        CALL MPSETI ('DD',IDBD)
        CALL MPSETR ('GR',GSPC)
        CALL MPSETR ('GT',GSLA)
        CALL MPSETR ('GN',GSLO)
        CALL MPSETR ('GP',1000.*GLAT+GLON)
        CALL MPSETI ('II',1000*IINT+IINT)
        CALL MPSETI ('RP',IRPF)
        CALL MPSETR ('SL',SLAT)
C
        CALL MAPPOS (XVPL,XVPR,YVPB,YVPT)
C
        CALL MAPROJ (PTYP,PLAT,PLON,ROTA)
C
        IF (PTYP.EQ.'SV') THEN
          CALL MPSETR ('SA',SALT)
          CALL MPSETR ('S1',SAN1)
          CALL MPSETR ('S2',SAN2)
        END IF
C
        CALL MAPSET (LTYP,PLM1,PLM2,PLM3,PLM4)
C
        IF (PTYP.NE.'UT') THEN
          CALL MAPINT
        ELSE
          CALL MPUTIN (IPRJ,IZON,ISPH,PARA,0.D0,0.D0,0.D0,0.D0)
        END IF
C
        IF (NERRO(NERR).NE.0) GO TO 901
        CALL GETSET (RVPL,RVPR,RVPB,RVPT,XWDL,XWDR,YWDB,YWDT,LNLG)
        EPSI=1.E-6*MIN(RVPR-RVPL,RVPT-RVPB)
        RVPL=RVPL+EPSI
        RVPR=RVPR-EPSI
        RVPB=RVPB+EPSI
        RVPT=RVPT-EPSI
        PRINT * , ' '
        PRINT * , 'U/V limits used: ', XWDL,XWDR,YWDB,YWDT
        IF (ODNM.EQ.'RG'.AND.IRGL.GE.5) THEN
          CALL MDRGDL (IRGL)
          IRGL=IRGL+5
          PRINT * , ' '
          PRINT * , 'RANGS/GSHHS data level picked:',MOD(IRGL,5)
        END IF
        IF (ISTY.EQ.0) THEN
          CALL MAPGRD
          CALL MAPLBL
          IF (ODNM.EQ.'E1'.OR.ODNM.EQ.'E2'.OR.
     +        ODNM.EQ.'E3'.OR.ODNM.EQ.'E4') THEN
            IF (ODNM.EQ.'E1') CALL MPLNDR ('Earth..1',ILVL)
            IF (ODNM.EQ.'E2') CALL MPLNDR ('Earth..2',ILVL)
            IF (ODNM.EQ.'E3') CALL MPLNDR ('Earth..3',ILVL)
            IF (ODNM.EQ.'E4') CALL MPLNDR ('Earth..4',ILVL)
          ELSE IF (ODNM.EQ.'RG') THEN
            CALL MDRGOL (MOD(IRGL,5),RWRK,LRWK)
            IF (NERRO(NERR).NE.0) GO TO 901
          ELSE
            CALL MAPLOT
            IF (NERRO(NERR).NE.0) GO TO 901
          END IF
          CALL DRSPGD (ISPG,IZN0,PLT0,PLN0,CLT0,CLN0,
     +                      IZN8,PLT8,PLN8,CLT8,CLN8,CHSZ)
        ELSE
          IF (ODNM.EQ.'E1'.OR.ODNM.EQ.'E2'.OR.
     +        ODNM.EQ.'E3'.OR.ODNM.EQ.'E4') THEN
            CALL MPSETI ('VS',20)
            CALL ARINAM (IAMA,LAMA)
            IF (NERRO(NERR).NE.0) GO TO 901
            IF (ODNM.EQ.'E1') CALL MPLNAM ('Earth..1',ILVL,IAMA)
            IF (ODNM.EQ.'E2') CALL MPLNAM ('Earth..2',ILVL,IAMA)
            IF (ODNM.EQ.'E3') CALL MPLNAM ('Earth..3',ILVL,IAMA)
            IF (ODNM.EQ.'E4') CALL MPLNAM ('Earth..4',ILVL,IAMA)
            IF (NERRO(NERR).NE.0) GO TO 901
            LLPG=0
            CALL ARSCAM (IAMA,XCRA,YCRA,NCRA,IAAI,IAGI,NGPS,COLORB)
            IF (NERRO(NERR).NE.0) GO TO 901
            PRINT * , ' '
            PRINT * , 'Area map length: ',LAMA-IAMA(6)+IAMA(5)+1
            PRINT * , 'Longest polygon: ',LLPG
            IF (ODNM.EQ.'E1') CALL MPLNDR ('Earth..1',ILVL)
            IF (ODNM.EQ.'E2') CALL MPLNDR ('Earth..2',ILVL)
            IF (ODNM.EQ.'E3') CALL MPLNDR ('Earth..3',ILVL)
            IF (ODNM.EQ.'E4') CALL MPLNDR ('Earth..4',ILVL)
            CALL MAPGRM (IAMA,XCRA,YCRA,NCRA,IAAI,IAGI,NGPS,DRAWLB)
            IF (NERRO(NERR).NE.0) GO TO 901
            IAIC=IGETAI (IAMA,CFUX(.5),CFUY(.5),IAAI,IAGI,NGPS,NOGU,1)
            PRINT * , ' '
            PRINT * , 'AREA IDENTIFIER AT CENTER: ',IAIC
            FNME=MDFNME(IAIC,1)
            PRINT * , 'NAME OF AREA AT CENTER: ',
     +                                   FNME(MDIFNB(FNME):MDILNB(FNME))
          ELSE IF (ODNM.EQ.'RG') THEN
            CALL MDRGSF (MOD(IRGL,5),RWRK,LRWK,IAMA,LAMA)
            IF (NERRO(NERR).NE.0) GO TO 901
            CALL MAPGRD
            IF (NERRO(NERR).NE.0) GO TO 901
          ELSE
            CALL MPSETC ('OU',ODNM)
            CALL MPSETI ('VS',0)
            CALL ARINAM (IAMA,LAMA)
            CALL MAPBLA (IAMA)
            IF (NERRO(NERR).NE.0) GO TO 901
            LLPG=0
            CALL ARSCAM (IAMA,XCRA,YCRA,NCRA,IAAI,IAGI,NGPS,COLORA)
            IF (NERRO(NERR).NE.0) GO TO 901
            PRINT * , ' '
            PRINT * , 'Area map length: ',LAMA-IAMA(6)+IAMA(5)+1
            PRINT * , 'Longest polygon: ',LLPG
            CALL MAPLOT
            IF (NERRO(NERR).NE.0) GO TO 901
            CALL MAPGRM (IAMA,XCRA,YCRA,NCRA,IAAI,IAGI,NGPS,DRAWLA)
            IF (NERRO(NERR).NE.0) GO TO 901
            IAIC=IGETAI (IAMA,CFUX(.5),CFUY(.5),IAAI,IAGI,NGPS,NOGU,1)
            PRINT * , ' '
            PRINT * , 'AREA IDENTIFIER AT CENTER: ',IAIC
          END IF
          CALL MAPLMB
          CALL MAPLBL
          CALL DRSPGD (ISPG,IZN0,PLT0,PLN0,CLT0,CLN0,
     +                      IZN8,PLT8,PLN8,CLT8,CLN8,CHSZ)
        END IF
        IF (ILLB.NE.0) THEN
          P=REAL(SIGN(1,ILLB))
          CALL PCSETI ('BF - BOX FLAG',0)
          CALL MDLBLT (RVPL,RVPB,RVPL,RVPT,+P*CSLL,    0.,CSLL,0.,-P)
          CALL MDLBLT (RVPR,RVPB,RVPR,RVPT,-P*CSLL,    0.,CSLL,0.,+P)
          CALL MDLBLN (RVPL,RVPB,RVPR,RVPB,0.,+1.5*P*CSLL,CSLL,0.,0.)
          CALL MDLBLN (RVPL,RVPT,RVPR,RVPT,0.,-1.5*P*CSLL,CSLL,0.,0.)
          CALL PCSETI ('BF - BOX FLAG',3)
        END IF
        IF (LABL.NE.' ') CALL PLCHHQ (CFUX(.5),CFUY(.965),
     +                                LABL(1:MPILNB(LABL)),
     +                                          .018,0.,0.)
        IF (ILPT.NE.0) CALL DRPTLB (PTYP,IPRJ,IZON,ISPH,PARA,IPRF,
     +                                                  ODNM,ILVL)
C
C Flush buffers and update the X workstation.
C
        CALL SFLUSH
        CALL GUWK (1,0)
C
C Let the user enter a command.
C
  106   PRINT * , ' '
        PRINT * , 'Enter a command (H for help, Q for quit):'
C
        READ  '(A1)', COMD
C
        IF      (COMD.EQ.'H'.OR.COMD.EQ.'h') THEN
C
          PRINT * , ' '
          PRINT * , 'Possible commands are as follows:'
          PRINT * , ' '
          PRINT * , '  H  =>  Help (this is it)'
          PRINT * , '  C  =>  Change parameters (in several groups)'
          PRINT * , '  P  =>  Plot (specified predefined plots)'
          PRINT * , '  Q  =>  Quit (stop, halt, cease and desist)'
          PRINT * , '  R  =>  Redraw (for use after resizing X window)'
          PRINT * , '  S  =>  Save (to an NCGM or Postscript file)'
          PRINT * , '  T  =>  Tests (of three different kinds)'
          PRINT * , ' '
          PRINT * , 'In user responses, case is ignored.  When a yes'
          PRINT * , 'or no answer is requested, hitting RETURN means'
          PRINT * , 'no.  When a numeric value is requested, hitting'
          PRINT * , 'RETURN implies no change in the current value.'
          PRINT * , ' '
          PRINT * , 'Most EZMAP errors will not result in termination'
          PRINT * , 'of the demo.  It should usually be obvious what'
          PRINT * , 'needs to be changed to avoid the error.'
C
          GO TO 106
C
        ELSE IF (COMD.EQ.'C'.OR.COMD.EQ.'c') THEN
C
          PRINT * , ' '
          PRINT * , 'Changing internal parameter values.'
C
          PRINT * , ' '
          PRINT * , 'Change position of map on plotter frame (Y or N)?'
          READ  '(A1)', COMD
          IF (COMD.EQ.'Y'.OR.COMD.EQ.'y') THEN
            PRINT * , ' '
            PRINT * , 'Current left-edge value:  ',XVPL
            PRINT * , 'Current right-edge value: ',XVPR
            PRINT * , 'Current bottom-edge value:',YVPB
            PRINT * , 'Current top-edge value:   ',YVPT
            PRINT * , ' '
            PRINT * , 'Enter new left-edge value (between 0 and 1):'
            CALL EMRDRN (XVPL,XVPL)
            XVPL=MAX(0.,MIN(1.,XVPL))
            PRINT * , ' '
            PRINT * , 'Enter new right-edge value (between 0 and 1):'
            CALL EMRDRN (XVPR,XVPR)
            XVPR=MAX(0.,MIN(1.,XVPR))
            PRINT * , ' '
            PRINT * , 'Enter new bottom-edge value (between 0 and 1):'
            CALL EMRDRN (YVPB,YVPB)
            YVPB=MAX(0.,MIN(1.,YVPB))
            PRINT * , ' '
            PRINT * , 'Enter new top-edge value (between 0 and 1):'
            CALL EMRDRN (YVPT,YVPT)
            YVPT=MAX(0.,MIN(1.,YVPT))
          END IF
C
          PRINT * , ' '
          PRINT * , 'Change projection type, center, rotation angle,'
          PRINT * , 'other values for USGS transformations (Y or N)?'
          READ  '(A1)', COMD
          IF (COMD.EQ.'Y'.OR.COMD.EQ.'y') THEN
            PRINT * , ' '
            PRINT * , 'These are the possible projection types:'
            PRINT * , ' '
            PRINT * , '  AE => Azimuthal Equidistant'
            PRINT * , '  AI => Aitoff'
            PRINT * , '  CE => Cylindrical Equidistant'
            PRINT * , '  EA => Cylindrical Equal-Area'
            PRINT * , '  ER => Equirectangular'
            PRINT * , '  GN => Gnomonic'
            PRINT * , '  HA => Hammer'
            PRINT * , '  LC => Lambert Conformal Conic'
            PRINT * , '  LE => Lambert Equal-area'
            PRINT * , '  ME => Mercator'
            PRINT * , '  MO => Mollweide'
            PRINT * , '  MT => "Mollweide-type"'
            PRINT * , '  OR => Orthographic'
            PRINT * , '  RM => Rotated Mercator'
            PRINT * , '  RO => Robinson'
            PRINT * , '  ST => Stereographic'
            PRINT * , '  SV => Satellite-View'
            PRINT * , '  UT => USGS Transformations'
            PRINT * , '  WT => Winkel Tripel'
            PRINT * , ' '
            PRINT * , 'Current projection type: ',PTYP
            PRINT * , ' '
            PRINT * , 'Enter new projection type:'
            READ  '(A2)', CTMP
            CALL MUPPER (CTMP)
            IF (CTMP.EQ.'AE'.OR.CTMP.EQ.'AI'.OR.CTMP.EQ.'CE'.OR.
     +          CTMP.EQ.'EA'.OR.CTMP.EQ.'ER'.OR.CTMP.EQ.'GN'.OR.
     +          CTMP.EQ.'HA'.OR.CTMP.EQ.'LC'.OR.CTMP.EQ.'LE'.OR.
     +          CTMP.EQ.'ME'.OR.CTMP.EQ.'MO'.OR.CTMP.EQ.'MT'.OR.
     +          CTMP.EQ.'OR'.OR.CTMP.EQ.'RM'.OR.CTMP.EQ.'RO'.OR.
     +          CTMP.EQ.'ST'.OR.CTMP.EQ.'SV'.OR.CTMP.EQ.'UT'.OR.
     +          CTMP.EQ.'WT') PTYP=CTMP
            IF (PTYP.EQ.'LC') THEN
              PRINT * , ' '
              PRINT * , 'Current central meridian:      ',PLON
              PRINT * , 'Current 1st standard parallel: ',PLAT
              PRINT * , 'Current 2nd standard parallel: ',ROTA
              PRINT * , ' '
              PRINT * , 'Enter new central meridian (between -180 and 18
     +0):'
              CALL EMRDRN (PLON,PLON)
              PLON=MAX(-180.,MIN(180.,PLON))
              PRINT * , ' '
              PRINT * , 'Enter new 1st standard parallel (between -90 an
     +d 90):'
              CALL EMRDRN (PLAT,PLAT)
              PLAT=MAX(-90.,MIN(90.,PLAT))
              PRINT * , ' '
              PRINT * , 'Enter new 2nd standard parallel (between -90 an
     +d 90):'
              CALL EMRDRN (ROTA,ROTA)
              ROTA=MAX(-90.,MIN(90.,ROTA))
            ELSE IF (PTYP.EQ.'RM') THEN
              PRINT * , ' '
              PRINT * , 'Current central meridian:      ',PLON
              PRINT * , 'Current rotation angle:        ',ROTA
              PRINT * , ' '
              PRINT * , 'Enter new central meridian (between -180 and 18
     +0):'
              CALL EMRDRN (PLON,PLON)
              PLON=MAX(-180.,MIN(180.,PLON))
              PRINT * , ' '
              PRINT * , 'Enter new rotation angle (between -180 and 180)
     +:'
              CALL EMRDRN (ROTA,ROTA)
              ROTA=MAX(-180.,MIN(180.,ROTA))
            ELSE IF (PTYP.EQ.'UT') THEN
              PRINT * , ' '
              PRINT * , 'For most of the USGS transformations, one may '
              PRINT * , 'select any one of various "spheroids"; each of'
              PRINT * , 'these is a particular ellipsoid having semi-  '
              PRINT * , 'major and semiminor axes of specified lengths '
              PRINT * , '(in meters).  A couple of the transformations '
              PRINT * , 'require using a particular spheroid and some  '
              PRINT * , 'require a "sphere of reference" with a radius '
              PRINT * , 'equal to the semimajor axis of the selected   '
              PRINT * , 'spheroid.  The possible spheroids are these:  '
              PRINT * , '                                              '
              PRINT * , '  -1 => arbitrary, user-specified             '
              PRINT * , '   0 => Clarke 1866                           '
              PRINT * , '   1 => Clarke 1880                           '
              PRINT * , '   2 => Bessel                                '
              PRINT * , '   3 => New International 1967                '
              PRINT * , '   4 => International 1909                    '
              PRINT * , '   5 => WGS 72                                '
              PRINT * , '   6 => Everest                               '
              PRINT * , '   7 => WGS 66                                '
              PRINT * , '   8 => GRS 1980                              '
              PRINT * , '   9 => Airy                                  '
              PRINT * , '  10 => Modified Everest                      '
              PRINT * , '  11 => Modified Airy                         '
              PRINT * , '  12 => WGS 84                                '
              PRINT * , '  13 => Southeast Asia                        '
              PRINT * , '  14 => Australian National                   '
              PRINT * , '  15 => Krassovsky                            '
              PRINT * , '  16 => Hough                                 '
              PRINT * , '  17 => Mercury 1960                          '
              PRINT * , '  18 => Modified Mercury 1968                 '
              PRINT * , '  19 => Normal Sphere                         '
              PRINT * , ' '
              PRINT * , 'The spheroid currently selected:',ISPH
              PRINT * , ' '
              PRINT * , 'Enter the desired spheroid number:'
              CALL EMRDIN (ISPH,ISPH)
              ISPH=MAX(-1,MIN(19,ISPH))
              IF (ISPH.LT.0) THEN
                PRINT * , ' '
                PRINT * , 'We need the length of the semimajor axis of '
                PRINT * , 'the ellipsoid (the equatorial radius), in   '
                PRINT * , 'meters.  The value must be greater than or  '
                PRINT * , 'equal to 1. (The actual equatorial radius   '
                PRINT * , 'of the earth is about 6,378,000 meters, but '
                PRINT * , 'a smaller value can be used if the scale of '
                PRINT * , 'the map is unimportant.)                    '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(1)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(1)))
                PARA(1)=DBLE(MAX(.1,TEMP))
                PRINT * , ' '
                PRINT * , 'We need the value of the square of the      '
                PRINT * , 'eccentricy of the ellipsoid; it must be     '
                PRINT * , 'less than .1 (generally, it''s much less).  '
                PRINT * , 'A value greater than 1 is treated as the    '
                PRINT * , 'length of the semiminor axis (the polar     '
                PRINT * , 'radius), in meters.  (The actual polar      '
                PRINT * , 'radius of the earth is about 6,357,000      '
                PRINT * , 'meters.)                                    '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(2)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(2)))
                PARA(2)=DBLE(MAX(0.,TEMP))
              END IF
              PRINT * , ' '
              PRINT * , 'Possible USGS transformations are as follows: '
              PRINT * , '                                              '
              PRINT * , '   1 => Universal Transverse Mercator (UTM)   '
              PRINT * , '   2 => State Plane Coordinates               '
              PRINT * , '   3 => Alber''s Equal-Area Conic             '
              PRINT * , '   4 => Lambert Conformal Conic               '
              PRINT * , '   5 => Mercator                              '
              PRINT * , '   6 => Polar Stereographic                   '
              PRINT * , '   7 => Polyconic                             '
              PRINT * , '   8 => Equidistant Conic                     '
              PRINT * , '   9 => Transverse Mercator                   '
              PRINT * , '  10 => Stereographic                         '
              PRINT * , '  11 => Lambert Azimuthal Equal-Area          '
              PRINT * , '  12 => Azimuthal Equidistant                 '
              PRINT * , '  13 => Gnomonic                              '
              PRINT * , '  14 => Orthographic                          '
              PRINT * , '  15 => Perspective                           '
              PRINT * , '  16 => Sinusoidal                            '
              PRINT * , '  17 => Equirectangular                       '
              PRINT * , '  18 => Miller Cylindrical                    '
              PRINT * , '  19 => Van der Grinten I                     '
              PRINT * , '  20 => Oblique Mercator                      '
              PRINT * , '  21 => Robinson                              '
              PRINT * , '  22 => Space Oblique Mercator                '
              PRINT * , '  23 => Modified Stereographic for Alaska     '
              PRINT * , ' '
              PRINT * , 'The transformation currently selected:',IPRJ
              PRINT * , ' '
              PRINT * , 'Enter the desired transformation number:'
              CALL EMRDIN (IPRJ,IPRJ)
              IPRJ=MAX(1,MIN(23,IPRJ))
              IF      (IPRJ.EQ.1) THEN  !  UTM Coordinates
                PRINT * , ' '
                PRINT * , 'The UTM system requires a zone number with  '
                PRINT * , 'an absolute value from 1 to 60, inclusive.  '
                PRINT * , 'Each zone is a strip 6 degrees of longitude '
                PRINT * , 'in width.  Zone 1 is from 180W to 174W, zone'
                PRINT * , '2 from 174W to 168W, and so on; zone 60 is  '
                PRINT * , 'from 174E to 180E.  Positive zone numbers   '
                PRINT * , 'imply the Northern hemisphere and negative  '
                PRINT * , 'ones the Southern hemisphere.               '
                PRINT * , ' '
                PRINT * , 'The zone number currently selected:',IZON
                PRINT * , ' '
                PRINT * , 'Enter the desired zone number:'
                CALL EMRDIN (IZON,IZON)
                IZON=MAX(-60,MIN(60,IZON))
                IF (IZON.EQ.0) IZON=13
              ELSE IF (IPRJ.EQ.2) THEN  !  State Plane Coordinates
                PRINT * , ' '
                PRINT * , 'The older version of the State Plane system '
                PRINT * , 'is based on the North American Datum of 1927'
                PRINT * , '(NAD1927) and the newer one is based on the '
                PRINT * , 'North American Datum of 1983 (NAD1983).  The'
                PRINT * , 'first is selected by using a spheroid with  '
                PRINT * , 'index 0 and the second is selected by using '
                PRINT * , 'a spheroid with index 8.                    '
                PRINT * , ' '
                PRINT * , 'The current spheroid index:',ISPH
                PRINT * , ' '
                PRINT * , 'Enter the desired spheroid index:'
                CALL EMRDIN (ISPH,ISPH)
                IF (ISPH.NE.0.AND.ISPH.NE.8) THEN
                  PRINT * , ' '
                  PRINT * , 'The value entered is invalid; spheroid 8  '
                  PRINT * , 'will be used.                             '
                  ISPH=8
                END IF
                PRINT * , ' '
                PRINT * , 'Each version of the State Plane system uses '
                PRINT * , 'zone numbers to identify a particular state '
                PRINT * , 'or portion of a state.  The zone numbers are'
                PRINT * , 'four digits long; values may be found in the'
                PRINT * , 'on-line documentation and on some predefined'
                PRINT * , 'plots available from this demo program.     '
                PRINT * , ' '
                PRINT * , 'The current zone number:',IZON
                PRINT * , ' '
                PRINT * , 'Enter the desired zone number:'
                CALL EMRDIN (IZON,IZON)
                IF (ISPH.EQ.0) THEN
                  DO 114 I=1,139
                    IF (IZON.EQ.IZN0(I)) GO TO 116
  114             CONTINUE
                ELSE
                  DO 115 I=1,139
                    IF (IZON.EQ.IZN8(I)) GO TO 116
  115             CONTINUE
                END IF
                PRINT * , ' '
                PRINT * , 'The selected zone number is invalid.  The   '
                PRINT * , 'value 2800 (New Hampshire) will be used as  '
                PRINT * , 'an illustration.                            '
                IZON=2800
  116           CONTINUE
              ELSE IF (IPRJ.EQ.3) THEN  !  Alber's Equal-Area Conic
                PRINT * , ' '
                PRINT * , 'We need the latitude of the first standard  '
                PRINT * , 'parallel (between -90 and +90).             '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(3)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(3)))
                PARA(3)=DBLE(MAX(-90.,MIN(90.,TEMP)))
                PRINT * , ' '
                PRINT * , 'We need the latitude of the second standard '
                PRINT * , 'parallel (between -90 and +90).             '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(4)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(4)))
                PARA(4)=DBLE(MAX(-90.,MIN(90.,TEMP)))
                PRINT * , ' '
                PRINT * , 'We need the longitude of the central        '
                PRINT * , 'meridian (between -180 and +180).           '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(5)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(5)))
                PARA(5)=DBLE(MAX(-180.,MIN(180.,TEMP)))
                PRINT * , ' '
                PRINT * , 'We need the latitude of the origin of the   '
                PRINT * , 'projection (between -90 and +90).           '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(6)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(6)))
                PARA(6)=DBLE(MAX(-90.,MIN(90.,TEMP)))
                PRINT * , ' '
                PRINT * , 'We need a false easting (in meters).        '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(7)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(7)))
                PARA(7)=DBLE(TEMP)
                PRINT * , ' '
                PRINT * , 'We need a false northing (in meters).       '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(8)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(8)))
                PARA(8)=DBLE(TEMP)
              ELSE IF (IPRJ.EQ.4) THEN  !  Lambert Conformal Conic
                PRINT * , ' '
                PRINT * , 'We need the latitude of the first standard  '
                PRINT * , 'parallel (between -90 and +90).             '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(3)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(3)))
                PARA(3)=DBLE(MAX(-90.,MIN(90.,TEMP)))
                PRINT * , ' '
                PRINT * , 'We need the latitude of the second standard '
                PRINT * , 'parallel (between -90 and +90).             '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(4)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(4)))
                PARA(4)=DBLE(MAX(-90.,MIN(90.,TEMP)))
                PRINT * , ' '
                PRINT * , 'We need the longitude of the central        '
                PRINT * , 'meridian (between -180 and +180).           '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(5)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(5)))
                PARA(5)=DBLE(MAX(-180.,MIN(180.,TEMP)))
                PRINT * , ' '
                PRINT * , 'We need the latitude of the origin of the   '
                PRINT * , 'projection (between -90 and +90).           '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(6)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(6)))
                PARA(6)=DBLE(MAX(-90.,MIN(90.,TEMP)))
                PRINT * , ' '
                PRINT * , 'We need a false easting (in meters).        '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(7)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(7)))
                PARA(7)=DBLE(TEMP)
                PRINT * , ' '
                PRINT * , 'We need a false northing (in meters).       '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(8)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(8)))
                PARA(8)=DBLE(TEMP)
              ELSE IF (IPRJ.EQ.5) THEN  !  Mercator
                PRINT * , ' '
                PRINT * , 'We need the longitude of the central        '
                PRINT * , 'meridian (between -180 and +180).           '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(5)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(5)))
                PARA(5)=DBLE(MAX(-180.,MIN(180.,TEMP)))
                PRINT * , ' '
                PRINT * , 'We need the latitude of true scale (between '
                PRINT * , '-90 and +90).                               '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(6)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(6)))
                PARA(6)=DBLE(MAX(-90.,MIN(90.,TEMP)))
                PRINT * , ' '
                PRINT * , 'We need a false easting (in meters).        '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(7)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(7)))
                PARA(7)=DBLE(TEMP)
                PRINT * , ' '
                PRINT * , 'We need a false northing (in meters).       '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(8)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(8)))
                PARA(8)=DBLE(TEMP)
              ELSE IF (IPRJ.EQ.6) THEN  !  Polar Stereographic
                PRINT * , ' '
                PRINT * , 'We need the longitude of the central        '
                PRINT * , 'meridian (between -180 and +180).           '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(5)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(5)))
                PARA(5)=DBLE(MAX(-180.,MIN(180.,TEMP)))
                PRINT * , ' '
                PRINT * , 'We need the latitude of true scale (between '
                PRINT * , '-90 and +90).                               '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(6)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(6)))
                PARA(6)=DBLE(MAX(-90.,MIN(90.,TEMP)))
                PRINT * , ' '
                PRINT * , 'We need a false easting (in meters).        '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(7)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(7)))
                PARA(7)=DBLE(TEMP)
                PRINT * , ' '
                PRINT * , 'We need a false northing (in meters).       '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(8)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(8)))
                PARA(8)=DBLE(TEMP)
              ELSE IF (IPRJ.EQ.7) THEN  !  Polyconic
                PRINT * , ' '
                PRINT * , 'We need the longitude of the central        '
                PRINT * , 'meridian (between -180 and +180).           '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(5)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(5)))
                PARA(5)=DBLE(MAX(-180.,MIN(180.,TEMP)))
                PRINT * , ' '
                PRINT * , 'We need the latitude of the origin of the   '
                PRINT * , 'projection (between -90 and +90).           '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(6)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(6)))
                PARA(6)=DBLE(MAX(-90.,MIN(90.,TEMP)))
                PRINT * , ' '
                PRINT * , 'We need a false easting (in meters).        '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(7)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(7)))
                PARA(7)=DBLE(TEMP)
                PRINT * , ' '
                PRINT * , 'We need a false northing (in meters).       '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(8)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(8)))
                PARA(8)=DBLE(TEMP)
              ELSE IF (IPRJ.EQ.8) THEN  !  Equidistant Conic
                PRINT * , ' '
                PRINT * , 'This transformation has a flag which is 0   '
                PRINT * , 'if there is only one standard parallel and  '
                PRINT * , '1 if there are two standard parallels.      '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',INT(PARA(9)
     +)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDIN (ITMP,INT(PARA(9)))
                PARA(9)=DBLE(MAX(0,MIN(1,ITMP)))
                PRINT * , ' '
                IF (PARA(9).EQ.0.D0) THEN
                  PRINT * , 'We need the latitude of the standard      '
                  PRINT * , 'parallel (between -90 and +90).           '
                ELSE
                  PRINT * , 'We need the latitude of the first         '
                  PRINT * , 'standard parallel (between -90 and +90).  '
                END IF
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(3)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(3)))
                PARA(3)=DBLE(MAX(-90.,MIN(90.,TEMP)))
                IF (PARA(9).NE.0.D0) THEN
                  PRINT * , ' '
                  PRINT * , 'We need the latitude of the second        '
                  PRINT * , 'standard parallel (between -90 and +90).  '
                  PRINT * , ' '
                  PRINT * , 'The current value is as follows:',PARA(4)
                  PRINT * , ' '
                  PRINT * , 'Enter the desired new value:'
                  CALL EMRDRN (TEMP,REAL(PARA(4)))
                  PARA(4)=DBLE(MAX(-90.,MIN(90.,TEMP)))
                END IF
                PRINT * , ' '
                PRINT * , 'We need the longitude of the central        '
                PRINT * , 'meridian (between -180 and +180).           '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(5)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(5)))
                PARA(5)=DBLE(MAX(-180.,MIN(180.,TEMP)))
                PRINT * , ' '
                PRINT * , 'We need the latitude of the origin of the   '
                PRINT * , 'projection (between -90 and +90).           '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(6)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(6)))
                PARA(6)=DBLE(MAX(-90.,MIN(90.,TEMP)))
                PRINT * , ' '
                PRINT * , 'We need a false easting (in meters).        '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(7)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(7)))
                PARA(7)=DBLE(TEMP)
                PRINT * , ' '
                PRINT * , 'We need a false northing (in meters).       '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(8)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(8)))
                PARA(8)=DBLE(TEMP)
              ELSE IF (IPRJ.EQ.9) THEN  !  Transverse Mercator
                PRINT * , ' '
                PRINT * , 'We need the scale factor at the central     '
                PRINT * , 'meridian (use a value close to 1).          '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(3)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(3)))
                PARA(3)=DBLE(MAX(.1,MIN(10.,TEMP)))
                PRINT * , ' '
                PRINT * , 'We need the longitude of the central        '
                PRINT * , 'meridian (between -180 and +180).           '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(5)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(5)))
                PARA(5)=DBLE(MAX(-180.,MIN(180.,TEMP)))
                PRINT * , ' '
                PRINT * , 'We need the latitude of the origin (between '
                PRINT * , '-90 and +90).                               '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(6)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(6)))
                PARA(6)=DBLE(MAX(-90.,MIN(90.,TEMP)))
                PRINT * , ' '
                PRINT * , 'We need a false easting (in meters).        '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(7)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(7)))
                PARA(7)=DBLE(TEMP)
                PRINT * , ' '
                PRINT * , 'We need a false northing (in meters).       '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(8)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(8)))
                PARA(8)=DBLE(TEMP)
              ELSE IF (IPRJ.EQ.10) THEN  !  Stereographic
                PRINT * , ' '
                PRINT * , 'The Stereographic projection uses a sphere  '
                PRINT * , 'of reference, rather than an ellipsoid.     '
                PRINT * , ' '
                PRINT * , 'We need the longitude of the center of the  '
                PRINT * , 'projection (between -180 and +180).         '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(5)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(5)))
                PARA(5)=DBLE(MAX(-180.,MIN(180.,TEMP)))
                PRINT * , ' '
                PRINT * , 'We need the latitude of the center of the   '
                PRINT * , 'projection (between -90 and +90).           '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(6)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(6)))
                PARA(6)=DBLE(MAX(-90.,MIN(90.,TEMP)))
                PRINT * , ' '
                PRINT * , 'We need a false easting (in meters).        '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(7)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(7)))
                PARA(7)=DBLE(TEMP)
                PRINT * , ' '
                PRINT * , 'We need a false northing (in meters).       '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(8)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(8)))
                PARA(8)=DBLE(TEMP)
              ELSE IF (IPRJ.EQ.11) THEN  !  Lambert Azimuthal Equal-Area
                PRINT * , ' '
                PRINT * , 'The Lambert Azimuthal Equal-Area projection '
                PRINT * , 'uses a sphere of reference, rather than an  '
                PRINT * , 'ellipsoid.                                  '
                PRINT * , ' '
                PRINT * , 'We need the longitude of the center of the  '
                PRINT * , 'projection (between -180 and +180).         '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(5)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(5)))
                PARA(5)=DBLE(MAX(-180.,MIN(180.,TEMP)))
                PRINT * , ' '
                PRINT * , 'We need the latitude of the center of the   '
                PRINT * , 'projection (between -90 and +90).           '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(6)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(6)))
                PARA(6)=DBLE(MAX(-90.,MIN(90.,TEMP)))
                PRINT * , ' '
                PRINT * , 'We need a false easting (in meters).        '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(7)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(7)))
                PARA(7)=DBLE(TEMP)
                PRINT * , ' '
                PRINT * , 'We need a false northing (in meters).       '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(8)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(8)))
                PARA(8)=DBLE(TEMP)
              ELSE IF (IPRJ.EQ.12) THEN  !  Azimuthal Equidistant
                PRINT * , ' '
                PRINT * , 'The Azimuthal Equidistant projection uses   '
                PRINT * , 'a sphere of reference, rather than an       '
                PRINT * , 'ellipsoid.                                  '
                PRINT * , ' '
                PRINT * , 'We need the longitude of the center of the  '
                PRINT * , 'projection (between -180 and +180).         '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(5)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(5)))
                PARA(5)=DBLE(MAX(-180.,MIN(180.,TEMP)))
                PRINT * , ' '
                PRINT * , 'We need the latitude of the center of the   '
                PRINT * , 'projection (between -90 and +90).           '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(6)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(6)))
                PARA(6)=DBLE(MAX(-90.,MIN(90.,TEMP)))
                PRINT * , ' '
                PRINT * , 'We need a false easting (in meters).        '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(7)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(7)))
                PARA(7)=DBLE(TEMP)
                PRINT * , ' '
                PRINT * , 'We need a false northing (in meters).       '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(8)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(8)))
                PARA(8)=DBLE(TEMP)
              ELSE IF (IPRJ.EQ.13) THEN  !  Gnomonic
                PRINT * , ' '
                PRINT * , 'The Gnomonic projection uses a sphere of    '
                PRINT * , 'reference, rather than an ellipsoid.        '
                PRINT * , ' '
                PRINT * , 'We need the longitude of the center of the  '
                PRINT * , 'projection (between -180 and +180).         '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(5)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(5)))
                PARA(5)=DBLE(MAX(-180.,MIN(180.,TEMP)))
                PRINT * , ' '
                PRINT * , 'We need the latitude of the center of the   '
                PRINT * , 'projection (between -90 and +90).           '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(6)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(6)))
                PARA(6)=DBLE(MAX(-90.,MIN(90.,TEMP)))
                PRINT * , ' '
                PRINT * , 'We need a false easting (in meters).        '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(7)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(7)))
                PARA(7)=DBLE(TEMP)
                PRINT * , ' '
                PRINT * , 'We need a false northing (in meters).       '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(8)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(8)))
                PARA(8)=DBLE(TEMP)
              ELSE IF (IPRJ.EQ.14) THEN  !  Orthographic
                PRINT * , ' '
                PRINT * , 'The Orthographic projection uses a sphere of'
                PRINT * , 'reference, rather than an ellipsoid.        '
                PRINT * , ' '
                PRINT * , 'We need the longitude of the center of the  '
                PRINT * , 'projection (between -180 and +180).         '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(5)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(5)))
                PARA(5)=DBLE(MAX(-180.,MIN(180.,TEMP)))
                PRINT * , ' '
                PRINT * , 'We need the latitude of the center of the   '
                PRINT * , 'projection (between -90 and +90).           '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(6)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(6)))
                PARA(6)=DBLE(MAX(-90.,MIN(90.,TEMP)))
                PRINT * , ' '
                PRINT * , 'We need a false easting (in meters).        '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(7)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(7)))
                PARA(7)=DBLE(TEMP)
                PRINT * , ' '
                PRINT * , 'We need a false northing (in meters).       '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(8)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(8)))
                PARA(8)=DBLE(TEMP)
              ELSE IF (IPRJ.EQ.15) THEN  !  Perspective
                PRINT * , ' '
                PRINT * , 'The Perspective projection uses a sphere of '
                PRINT * , 'reference, rather than an ellipsoid.        '
                PRINT * , ' '
                PRINT * , 'We need the height of the perspective point '
                PRINT * , 'above the surface (in meters).              '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(3)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(3)))
                PARA(3)=DBLE(MAX(0.,TEMP))
                PRINT * , ' '
                PRINT * , 'We need the longitude of the center of the  '
                PRINT * , 'projection (between -180 and +180).         '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(5)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(5)))
                PARA(5)=DBLE(MAX(-180.,MIN(180.,TEMP)))
                PRINT * , ' '
                PRINT * , 'We need the latitude of the center of the   '
                PRINT * , 'projection (between -90 and +90).           '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(6)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(6)))
                PARA(6)=DBLE(MAX(-90.,MIN(90.,TEMP)))
                PRINT * , ' '
                PRINT * , 'We need a false easting (in meters).        '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(7)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(7)))
                PARA(7)=DBLE(TEMP)
                PRINT * , ' '
                PRINT * , 'We need a false northing (in meters).       '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(8)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(8)))
                PARA(8)=DBLE(TEMP)
              ELSE IF (IPRJ.EQ.16) THEN  !  Sinusoidal
                PRINT * , ' '
                PRINT * , 'The Sinusoidal projection uses a sphere of  '
                PRINT * , 'reference, rather than an ellipsoid.        '
                PRINT * , ' '
                PRINT * , 'We need the longitude of the central        '
                PRINT * , 'meridian (between -180 and +180).           '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(5)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(5)))
                PARA(5)=DBLE(MAX(-180.,MIN(180.,TEMP)))
                PRINT * , ' '
                PRINT * , 'We need a false easting (in meters).        '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(7)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(7)))
                PARA(7)=DBLE(TEMP)
                PRINT * , ' '
                PRINT * , 'We need a false northing (in meters).       '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(8)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(8)))
                PARA(8)=DBLE(TEMP)
              ELSE IF (IPRJ.EQ.17) THEN  !  Equirectangular
                PRINT * , ' '
                PRINT * , 'The Equirectangular projection uses a       '
                PRINT * , 'sphere of reference, rather than an         '
                PRINT * , 'ellipsoid.                                  '
                PRINT * , ' '
                PRINT * , 'We need the longitude of the central        '
                PRINT * , 'meridian (between -180 and +180).           '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(5)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(5)))
                PARA(5)=DBLE(MAX(-180.,MIN(180.,TEMP)))
                PRINT * , ' '
                PRINT * , 'We need the latitude of true scale (between '
                PRINT * , '-90 and +90).                               '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(6)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(6)))
                PARA(6)=DBLE(MAX(-90.,MIN(90.,TEMP)))
                PRINT * , ' '
                PRINT * , 'We need a false easting (in meters).        '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(7)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(7)))
                PARA(7)=DBLE(TEMP)
                PRINT * , ' '
                PRINT * , 'We need a false northing (in meters).       '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(8)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(8)))
                PARA(8)=DBLE(TEMP)
              ELSE IF (IPRJ.EQ.18) THEN  !  Miller Cylindrical
                PRINT * , ' '
                PRINT * , 'The Miller Cylindrical projection uses a    '
                PRINT * , 'sphere of reference, rather than an         '
                PRINT * , 'ellipsoid.                                  '
                PRINT * , ' '
                PRINT * , 'We need the longitude of the central        '
                PRINT * , 'meridian (between -180 and +180).           '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(5)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(5)))
                PARA(5)=DBLE(MAX(-180.,MIN(180.,TEMP)))
                PRINT * , ' '
                PRINT * , 'We need a false easting (in meters).        '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(7)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(7)))
                PARA(7)=DBLE(TEMP)
                PRINT * , ' '
                PRINT * , 'We need a false northing (in meters).       '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(8)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(8)))
                PARA(8)=DBLE(TEMP)
              ELSE IF (IPRJ.EQ.19) THEN  !  Van der Grinten I
                PRINT * , ' '
                PRINT * , 'The Van der Grinten projection uses a sphere'
                PRINT * , 'of reference, rather than an ellipsoid.     '
                PRINT * , ' '
                PRINT * , 'We need the longitude of the central        '
                PRINT * , 'meridian (between -180 and +180).           '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(5)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(5)))
                PARA(5)=DBLE(MAX(-180.,MIN(180.,TEMP)))
                PRINT * , ' '
                PRINT * , 'We need a false easting (in meters).        '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(7)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(7)))
                PARA(7)=DBLE(TEMP)
                PRINT * , ' '
                PRINT * , 'We need a false northing (in meters).       '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(8)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(8)))
                PARA(8)=DBLE(TEMP)
              ELSE IF (IPRJ.EQ.20) THEN  !  Oblique Mercator
                PRINT * , ' '
                PRINT * , 'The Oblique Mercator transformation has a   '
                PRINT * , 'flag which is 0 if the azimuth angle is to  '
                PRINT * , 'be specified indirectly and 1 if it is to   '
                PRINT * , 'be specified directly.                      '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',INT(PARA(13
     +))
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDIN (ITMP,INT(PARA(13)))
                PARA(13)=DBLE(MAX(0,MIN(1,ITMP)))
                PRINT * , ' '
                PRINT * , 'We need the scale factor at the center of   '
                PRINT * , 'the projection.                             '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(3)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(3)))
                PARA(3)=DBLE(MAX(.1,MIN(10.,TEMP)))
                IF (PARA(13).EQ.0.D0) THEN
                  PRINT * , ' '
                  PRINT * , 'We need the latitude of the origin of the '
                  PRINT * , 'projection (between -90 and +90).         '
                  PRINT * , ' '
                  PRINT * , 'The current value is as follows:',PARA(6)
                  PRINT * , ' '
                  PRINT * , 'Enter the desired new value:'
                  CALL EMRDRN (TEMP,REAL(PARA(6)))
                  PARA(6)=DBLE(MAX(-90.,MIN(90.,TEMP)))
                  PRINT * , ' '
                  PRINT * , 'We need the longitude of point 1 on a line'
                  PRINT * , 'defining the azimuth angle (between -180  '
                  PRINT * , 'and +180).                                '
                  PRINT * , ' '
                  PRINT * , 'The current value is as follows:',PARA( 9)
                  PRINT * , ' '
                  PRINT * , 'Enter the desired new value:'
                  CALL EMRDRN (TEMP,REAL(PARA( 9)))
                  PARA( 9)=DBLE(MAX(-180.,MIN(180.,TEMP)))
                  PRINT * , ' '
                  PRINT * , 'We need the latitude of point 1 on a line '
                  PRINT * , 'defining the azimuth angle (between -90   '
                  PRINT * , 'and +90).                                 '
                  PRINT * , ' '
                  PRINT * , 'The current value is as follows:',PARA(10)
                  PRINT * , ' '
                  PRINT * , 'Enter the desired new value:'
                  CALL EMRDRN (TEMP,REAL(PARA(10)))
                  PARA(10)=DBLE(MAX(-90.,MIN(90.,TEMP)))
                  PRINT * , ' '
                  PRINT * , 'We need the longitude of point 2 on a line'
                  PRINT * , 'defining the azimuth angle (between -180  '
                  PRINT * , 'and +180).                                '
                  PRINT * , ' '
                  PRINT * , 'The current value is as follows:',PARA(11)
                  PRINT * , ' '
                  PRINT * , 'Enter the desired new value:'
                  CALL EMRDRN (TEMP,REAL(PARA(11)))
                  PARA(11)=DBLE(MAX(-180.,MIN(180.,TEMP)))
                  PRINT * , ' '
                  PRINT * , 'We need the latitude of point 2 on a line '
                  PRINT * , 'defining the azimuth angle (between -90   '
                  PRINT * , 'and +90).                                 '
                  PRINT * , ' '
                  PRINT * , 'The current value is as follows:',PARA(12)
                  PRINT * , ' '
                  PRINT * , 'Enter the desired new value:'
                  CALL EMRDRN (TEMP,REAL(PARA(12)))
                  PARA(12)=DBLE(MAX(-90.,MIN(90.,TEMP)))
                ELSE
                  PRINT * , ' '
                  PRINT * , 'We need the azimuth angle of the center   '
                  PRINT * , 'line, measured east of north (between -180'
                  PRINT * , 'and +180).                                '
                  PRINT * , ' '
                  PRINT * , 'The current value is as follows:',PARA(4)
                  PRINT * , ' '
                  PRINT * , 'Enter the desired new value:'
                  CALL EMRDRN (TEMP,REAL(PARA(4)))
                  PARA(4)=DBLE(MAX(-180.,MIN(180.,TEMP)))
                  PRINT * , ' '
                  PRINT * , 'We need the longitude of the origin of the'
                  PRINT * , 'projection (between -180 and +180).       '
                  PRINT * , ' '
                  PRINT * , 'The current value is as follows:',PARA(5)
                  PRINT * , ' '
                  PRINT * , 'Enter the desired new value:'
                  CALL EMRDRN (TEMP,REAL(PARA(5)))
                  PARA(5)=DBLE(MAX(-180.,MIN(180.,TEMP)))
                  PRINT * , ' '
                  PRINT * , 'We need the latitude of the origin of the '
                  PRINT * , 'projection (between -90 and +90).         '
                  PRINT * , ' '
                  PRINT * , 'The current value is as follows:',PARA(6)
                  PRINT * , ' '
                  PRINT * , 'Enter the desired new value:'
                  CALL EMRDRN (TEMP,REAL(PARA(6)))
                  PARA(6)=DBLE(MAX(-90.,MIN(90.,TEMP)))
                END IF
                PRINT * , ' '
                PRINT * , 'We need a false easting (in meters).        '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(7)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(7)))
                PARA(7)=DBLE(TEMP)
                PRINT * , ' '
                PRINT * , 'We need a false northing (in meters).       '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(8)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(8)))
                PARA(8)=DBLE(TEMP)
              ELSE IF (IPRJ.EQ.21) THEN  !  Robinson
                PRINT * , ' '
                PRINT * , 'The Robinson projection uses a sphere of    '
                PRINT * , 'reference, rather than an ellipsoid.  This  '
                PRINT * , 'projection is much used by the National     '
                PRINT * , 'Geographic Society for world maps.          '
                PRINT * , ' '
                PRINT * , 'We need the longitude of the central        '
                PRINT * , 'meridian (between -180 and +180).           '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(5)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(5)))
                PARA(5)=DBLE(MAX(-180.,MIN(180.,TEMP)))
                PRINT * , ' '
                PRINT * , 'We need a false easting (in meters).        '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(7)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(7)))
                PARA(7)=DBLE(TEMP)
                PRINT * , ' '
                PRINT * , 'We need a false northing (in meters).       '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(8)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(8)))
                PARA(8)=DBLE(TEMP)
              ELSE IF (IPRJ.EQ.22) THEN  !  Space Oblique Mercator
                PRINT * , ' '
                PRINT * , 'The Space Oblique Mercator appears to be    '
                PRINT * , 'set up so that one can specify a particular '
                PRINT * , 'Landsat series and a particular orbit and   '
                PRINT * , 'get a map that shows with minimal distortion'
                PRINT * , 'the part of the earth passed over during    '
                PRINT * , 'that particular orbit.                      '
                PRINT * , ' '
                PRINT * , 'We need a Landsat number (an integer between'
                PRINT * , '1 and 5, inclusive).                        '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',INT(PARA(3)
     +)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDIN (ITMP,INT(PARA(3)))
                PARA(3)=DBLE(MAX(1,MIN(5,ITMP)))
                PRINT * , ' '
                PRINT * , 'We need a path number (an integer between 1 '
                PRINT * , 'and 251, inclusive, for Landsat numbers 1, 2'
                PRINT * , 'and 3, and between 1 and 233, inclusive, for'
                PRINT * , 'Landsat numbers 4 and 5).                   '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',INT(PARA(4)
     +)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDIN (ITMP,INT(PARA(4)))
                IF (INT(PARA(3)).LE.3) THEN
                  PARA(4)=DBLE(MAX(1,MIN(251,ITMP)))
                ELSE
                  PARA(4)=DBLE(MAX(1,MIN(233,ITMP)))
                END IF
                PRINT * , ' '
                PRINT * , 'We need a false easting (in meters).        '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(7)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(7)))
                PARA(7)=DBLE(TEMP)
                PRINT * , ' '
                PRINT * , 'We need a false northing (in meters).       '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(8)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(8)))
                PARA(8)=DBLE(TEMP)
              ELSE IF (IPRJ.EQ.23) THEN  !  Modified Stereographic (AK)
                PRINT * , ' '
                PRINT * , 'The Modified Stereographic projection for   '
                PRINT * , 'Alaska uses the Clarke 1866 spheroid, no    '
                PRINT * , 'matter what.                                '
                PRINT * , ' '
                PRINT * , 'We need a false easting (in meters).        '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(7)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(7)))
                PARA(7)=DBLE(TEMP)
                PRINT * , ' '
                PRINT * , 'We need a false northing (in meters).       '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(8)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(8)))
                PARA(8)=DBLE(TEMP)
              ELSE
                IZON=0
              END IF
            ELSE
              PRINT * , ' '
              PRINT * , 'Current pole latitude:  ',PLAT
              PRINT * , 'Current pole longitude: ',PLON
              PRINT * , 'Current rotation angle: ',ROTA
              PRINT * , ' '
              PRINT * , 'Enter new pole latitude (between -90 and 90):'
              CALL EMRDRN (PLAT,PLAT)
              PLAT=MAX(-90.,MIN(90.,PLAT))
              PRINT * , ' '
              PRINT * , 'Enter new pole longitude (between -180 and 180)
     +:'
              CALL EMRDRN (PLON,PLON)
              PLON=MAX(-180.,MIN(180.,PLON))
              PRINT * , ' '
              PRINT * , 'Enter new rotation angle (between -180 and 180)
     +:'
              CALL EMRDRN (ROTA,ROTA)
              ROTA=MAX(-180.,MIN(180.,ROTA))
            END IF
            IF (PTYP.EQ.'SV') THEN
              PRINT * , ' '
              PRINT * , 'Satellite-view projection will be used.'
              PRINT * , ' '
              PRINT * , 'Current satellite height :',SALT
              PRINT * , 'Current satellite angle 1:',SAN1
              PRINT * , 'Current satellite angle 2:',SAN2
              PRINT * , ' '
              PRINT * , 'Enter new satellite height (measured from'
              PRINT * , 'earth center, 1 or greater):'
              CALL EMRDRN (SALT,SALT)
              IF (SALT.LE.1.) SALT=0.
              PRINT * , ' '
              PRINT * , 'Enter new satellite angle 1 (0 to 180):'
              CALL EMRDRN (SAN1,SAN1)
              SAN1=MAX(0.,MIN(180.,SAN1))
              PRINT * , ' '
              PRINT * , 'Enter new satellite angle 2 (-180 to 180):'
              CALL EMRDRN (SAN2,SAN2)
              SAN2=MAX(-180.,MIN(180.,SAN2))
            ELSE IF (PTYP.EQ.'EA'.OR.PTYP.EQ.'ER'.OR.PTYP.EQ.'WT') THEN
              PRINT * , ' '
              PRINT * , 'The exact nature of this projection depends on'
              PRINT * , 'the position of a "standard parallel", which'
              PRINT * , 'is determined by the value of its latitude.'
              PRINT * , 'The parameter specifying this has the default'
              PRINT * , 'value -1, allowing Ezmap to choose for itself'
              PRINT * , 'where to put the standard parallel.'
              PRINT * , ' '
              PRINT * , 'Current latitude of standard parallel: ',SLAT
              PRINT * , ' '
              PRINT * , 'Be aware that, if you give this parameter a'
              PRINT * , 'non-negative value, it affects the display of'
              PRINT * , 'projections of types CE, EA, ER, and WT.'
              PRINT * , ' '
              PRINT * , 'Enter new value, between -1 and 90 (-1 to allow
     + use of built-in defaults):'
              CALL EMRDRN (SLAT,SLAT)
              SLAT=MAX(-1.,MIN(90.,SLAT))
            END IF
          END IF
C
          PRINT * , ' '
          PRINT * , 'Change limits selecting part of projection shown (Y
     + or N)?'
          READ  '(A1)', COMD
          IF (COMD.EQ.'Y'.OR.COMD.EQ.'y') THEN
  108       PRINT * , ' '
            PRINT * , 'Possible limit selection types:'
            PRINT * , ' '
            PRINT * , '  MA => Maximum useful area'
            PRINT * , '  CO => Corners opposite one another'
            PRINT * , '  PO => Points on the edges'
            PRINT * , '  AN => Angular extents'
            PRINT * , '  LI => Limits in the U/V plane'
            PRINT * , '  GR => Grid of lat/lon values'
            PRINT * , ' '
            PRINT * , 'Current limit selection type: ',LTYP
            PRINT * , ' '
            PRINT * , 'Enter new limit selection type:'
            READ  '(A2)', CTMP
            CALL MUPPER (CTMP)
            IF (PTYP.EQ.'LC'.AND.CTMP.EQ.'AN') THEN
              PRINT * , ' '
              PRINT * , 'Can''t use angular extents with a Lambert confo
     +rmal conic projection.'
              GO TO 108
            END IF
            IF (CTMP.EQ.'MA'.OR.CTMP.EQ.'CO'.OR.CTMP.EQ.'PO'.OR.
     +          CTMP.EQ.'AN'.OR.CTMP.EQ.'LI'.OR.CTMP.EQ.'GR') LTYP=CTMP
            IF (LTYP.EQ.'CO') THEN
              PRINT * , ' '
              PRINT * , 'Current latitude, 1st corner point: ',PLM1(1)
              PRINT * , 'Current longitude, 1st corner point:',PLM2(1)
              PRINT * , 'Current latitude, 2nd corner point: ',PLM3(1)
              PRINT * , 'Current longitude, 2nd corner point:',PLM4(1)
              PRINT * , ' '
              PRINT * , 'Enter new latitude of 1st corner point:'
              CALL EMRDRN (PLM1(1),PLM1(1))
              PRINT * , ' '
              PRINT * , 'Enter new longitude of 1st corner point:'
              CALL EMRDRN (PLM2(1),PLM2(1))
              PRINT * , ' '
              PRINT * , 'Enter new latitude of 2nd corner point:'
              CALL EMRDRN (PLM3(1),PLM3(1))
              PRINT * , ' '
              PRINT * , 'Enter new longitude of 2nd corner point:'
              CALL EMRDRN (PLM4(1),PLM4(1))
              PLM1(2)=0.
              PLM2(2)=0.
              PLM3(2)=0.
              PLM4(2)=0.
            ELSE IF (LTYP.EQ.'PO') THEN
              PRINT * , ' '
              PRINT * , 'Current latitude of 1st edge point: ',PLM1(1)
              PRINT * , 'Current longitude of 1st edge point:',PLM1(2)
              PRINT * , 'Current latitude of 2nd edge point: ',PLM2(1)
              PRINT * , 'Current longitude of 2nd edge point:',PLM2(2)
              PRINT * , 'Current latitude of 3rd edge point: ',PLM3(1)
              PRINT * , 'Current longitude of 3rd edge point:',PLM3(2)
              PRINT * , 'Current latitude of 4th edge point: ',PLM4(1)
              PRINT * , 'Current longitude of 4th edge point:',PLM4(2)
              PRINT * , ' '
              PRINT * , 'Enter new latitude of 1st edge point:'
              CALL EMRDRN (PLM1(1),PLM1(1))
              PRINT * , ' '
              PRINT * , 'Enter new longitude of 1st edge point:'
              CALL EMRDRN (PLM1(2),PLM1(2))
              PRINT * , ' '
              PRINT * , 'Enter new latitude of 2nd edge point:'
              CALL EMRDRN (PLM2(1),PLM2(1))
              PRINT * , ' '
              PRINT * , 'Enter new longitude of 2nd edge point:'
              CALL EMRDRN (PLM2(2),PLM2(2))
              PRINT * , ' '
              PRINT * , 'Enter new latitude of 3rd edge point:'
              CALL EMRDRN (PLM3(1),PLM3(1))
              PRINT * , ' '
              PRINT * , 'Enter new longitude of 3rd edge point:'
              CALL EMRDRN (PLM3(2),PLM3(2))
              PRINT * , ' '
              PRINT * , 'Enter new latitude of 4th edge point:'
              CALL EMRDRN (PLM4(1),PLM4(1))
              PRINT * , ' '
              PRINT * , 'Enter new longitude of 4th edge point:'
              CALL EMRDRN (PLM4(2),PLM4(2))
            ELSE IF (LTYP.EQ.'AN') THEN
              PRINT * , ' '
              PRINT * , 'Current angular distance to left:  ',PLM1(1)
              PRINT * , 'Current angular distance to right: ',PLM2(1)
              PRINT * , 'Current angular distance to bottom:',PLM3(1)
              PRINT * , 'Current angular distance to top:   ',PLM4(1)
              PRINT * , ' '
              PRINT * , 'Enter new angular distance to left:'
              CALL EMRDRN (PLM1(1),PLM1(1))
              PRINT * , ' '
              PRINT * , 'Enter new angular distance to right:'
              CALL EMRDRN (PLM2(1),PLM2(1))
              PRINT * , ' '
              PRINT * , 'Enter new angular distance to bottom:'
              CALL EMRDRN (PLM3(1),PLM3(1))
              PRINT * , ' '
              PRINT * , 'Enter new angular distance to top:'
              CALL EMRDRN (PLM4(1),PLM4(1))
              PLM1(2)=0.
              PLM2(2)=0.
              PLM3(2)=0.
              PLM4(2)=0.
            ELSE IF (LTYP.EQ.'LI') THEN
              PRINT * , ' '
              PRINT * , 'Current U coordinate of left edge:  ',PLM1(1)
              PRINT * , 'Current U coordinate of right edge: ',PLM2(1)
              PRINT * , 'Current V coordinate of bottom edge:',PLM3(1)
              PRINT * , 'Current V coordinate of top edge:   ',PLM4(1)
              PRINT * , ' '
              IF (PTYP.EQ.'LC'.OR.PTYP.EQ.'OR'.OR.PTYP.EQ.'SV') THEN
                PRINT * , 'U and V values should range from -1 to +1.'
              ELSE IF (PTYP.EQ.'ST'.OR.PTYP.EQ.'LE'.OR.PTYP.EQ.'GN')THEN
                PRINT * , 'U and V values should range from -2 to +2.'
              ELSE IF (PTYP.EQ.'AE'.OR.PTYP.EQ.'ME') THEN
                PRINT * , 'U and V values should range from -pi to +pi.'
              ELSE IF (PTYP.EQ.'CE') THEN
                PRINT * , 'U values should range from -180 to +180, V va
     +lues from -90/CSLS to +90/CSLS.'
                PRINT * , '(CSLS is the square of the cosine of the curr
     +ent value of the standard latitude.)'
              ELSE IF (PTYP.EQ.'EA') THEN
                PRINT * , 'U values should range from -pi to +pi, V valu
     +es from -1/CSLT to +1/CSLT.'
                PRINT * , '(CSLT is the cosine of the current value of t
     + he standard latitude.)'
              ELSE IF (PTYP.EQ.'MT') THEN
                PRINT * , 'U values should range from -2 to +2, V values
     + from -1 to +1.'
              ELSE IF (PTYP.EQ.'RO') THEN
                PRINT * , 'U values should range from -1 to +1, V values
     + from -.5072 to +.5072.'
              ELSE IF (PTYP.EQ.'AI') THEN
                PRINT * , 'U values should range from -pi to +pi, V valu
     +es from -pi/2 to +pi/2.'
              ELSE IF (PTYP.EQ.'HA'.OR.PTYP.EQ.'MO') THEN
                PRINT * , 'U values should range from -2*sqrt(2) to +2*s
     +qrt(2), V values from -sqrt(2) to +sqrt(2).'
              ELSE IF (PTYP.EQ.'WT') THEN
                PRINT * , 'U values should range from -(1+pi/2) to +(1+p
     +i/2), V values from -pi/2 to +pi/2.'
                PRINT * , '(The exact range depends on the current value
     + of the standard latitude.)'
              ELSE IF (PTYP.EQ.'UT') THEN
                PRINT * , ' '
                PRINT * , 'The ranges of U and V values will depend on'
                PRINT * , 'the particular USGS transformation chosen;'
                PRINT * , 'UMIN, UMAX, VMIN, and VMAX from the last'
                PRINT * , 'EZMAP initialization were as follows:'
                PRINT * , ' '
                PRINT * , ' ',XWDL,XWDR,YWDB,YWDT
              END IF
              PRINT * , ' '
              PRINT * , 'Enter new U coordinate of left edge:'
              CALL EMRDRN (PLM1(1),PLM1(1))
              PRINT * , ' '
              PRINT * , 'Enter new U coordinate of right edge:'
              CALL EMRDRN (PLM2(1),PLM2(1))
              PRINT * , ' '
              PRINT * , 'Enter new V coordinate of bottom edge:'
              CALL EMRDRN (PLM3(1),PLM3(1))
              PRINT * , ' '
              PRINT * , 'Enter new V coordinate of top edge:'
              CALL EMRDRN (PLM4(1),PLM4(1))
              PLM1(2)=0.
              PLM2(2)=0.
              PLM3(2)=0.
              PLM4(2)=0.
            ELSE IF (LTYP.EQ.'GR') THEN
              PRINT * , ' '
              PRINT * , 'Latitude now at bottom of range: ',PLM1(1)
              PRINT * , 'Longitude now at bottom of range:',PLM2(1)
              PRINT * , 'Latitude now at top of range:    ',PLM3(1)
              PRINT * , 'Longitude now at top of range:   ',PLM4(1)
              PRINT * , ' '
              PRINT * , 'Enter new latitude at bottom of range:'
              CALL EMRDRN (PLM1(1),PLM1(1))
              PRINT * , ' '
              PRINT * , 'Enter new longitude at bottom of range:'
              CALL EMRDRN (PLM2(1),PLM2(1))
              PRINT * , ' '
              PRINT * , 'Enter new latitude at top of range:'
              CALL EMRDRN (PLM3(1),PLM3(1))
              PRINT * , ' '
              PRINT * , 'Enter new longitude at top of range:'
              CALL EMRDRN (PLM4(1),PLM4(1))
              PLM1(2)=0.
              PLM2(2)=0.
              PLM3(2)=0.
              PLM4(2)=0.
            END IF
          END IF
C
          PRINT * , ' '
          PRINT * , 'Change outline dataset parameters (Y or N)?'
          READ  '(A1)', COMD
          IF (COMD.EQ.'Y'.OR.COMD.EQ.'y') THEN
            PRINT * , ' '
            PRINT * , 'Possible outline dataset selectors:'
            PRINT * , ' '
            PRINT * , '  NO => None'
            PRINT * , '  CO => Continental outlines only'
            PRINT * , '  US => US outlines only'
            PRINT * , '  PS => Continental, political, and US outlines'
            PRINT * , '  PO => Continental and political outlines'
            PRINT * , '  E1 => The database "Earth..1"'
            PRINT * , '  E2 => The database "Earth..2"'
            PRINT * , '  E3 => The database "Earth..3"'
            PRINT * , '  E4 => The database "Earth..4"'
            PRINT * , '  RG => The RANGS/GSHHS database'
            PRINT * , ' '
            PRINT * , 'Current outline dataset selector: ',ODNM
            PRINT * , ' '
            PRINT * , 'Enter new outline dataset selector:'
            READ  '(A2)', CTMP
            CALL MUPPER (CTMP)
            IF (CTMP.EQ.'NO'.OR.CTMP.EQ.'CO'.OR.CTMP.EQ.'US'.OR.
     +          CTMP.EQ.'PS'.OR.CTMP.EQ.'PO'.OR.CTMP.EQ.'E1'.OR.
     +          CTMP.EQ.'E2'.OR.CTMP.EQ.'E3'.OR.CTMP.EQ.'E4'.OR.
     +          CTMP.EQ.'RG') ODNM=CTMP
            IF (ODNM.EQ.'E1'.OR.ODNM.EQ.'E2'.OR.
     +          ODNM.EQ.'E3'.OR.ODNM.EQ.'E4') THEN
              PRINT * , ' '
              PRINT * , 'Current database level specifier:',ILVL
              PRINT * , ' '
              PRINT * , 'Enter new database level specifier:'
              CALL EMRDIN (ILVL,ILVL)
            ELSE IF (ODNM.EQ.'RG') THEN
              PRINT * , ' '
              PRINT * , 'Current name of data directory: ',USNM
              PRINT * , ' '
              PRINT * , 'Enter new name of data directory:'
              READ (*,'(A60)') CHRT
              IF (CHRT.NE.' ') USNM=CHRT
              PRINT * , ' '
              PRINT * , 'Current database level specifier:',MIN(5,IRGL)
              PRINT * , ' '
              PRINT * , 'Enter new database level specifier (0 => use'
              PRINT * , 'highest resolution, 1 to 4 => use successively'
              PRINT * , 'lower resolutions, 5 => pick a value for me):'
              CALL EMRDIN (IRGL,IRGL)
              IRGL=MAX(0,MIN(5,IRGL))
              PRINT * , ' '
              PRINT * , 'Change any color-fill flags (Y or N)?'
              READ  '(A1)', COMD
              IF (COMD.EQ.'Y'.OR.COMD.EQ.'y') THEN
                PRINT * , ' '
                IF (LCSF(1).GE.0) THEN
                  PRINT * , 'Ocean will be filled.'
                ELSE
                  PRINT * , 'Ocean will not be filled.'
                END IF
                PRINT * , ' '
                PRINT * , 'Toggle this fill flag (Y or N)?'
                READ  '(A1)', COMD
                IF (COMD.EQ.'Y'.OR.COMD.EQ.'y') LCSF(1)=-LCSF(1)
                PRINT * , ' '
                IF (LCSF(2).GE.0) THEN
                  PRINT * , 'Land will be filled.'
                ELSE
                  PRINT * , 'Land will not be filled.'
                END IF
                PRINT * , ' '
                PRINT * , 'Toggle this fill flag (Y or N)?'
                READ  '(A1)', COMD
                IF (COMD.EQ.'Y'.OR.COMD.EQ.'y') LCSF(2)=-LCSF(2)
                PRINT * , ' '
                IF (LCSF(3).GE.0) THEN
                  PRINT * , 'Lakes will be filled.'
                ELSE
                  PRINT * , 'Lakes will not be filled.'
                END IF
                PRINT * , ' '
                PRINT * , 'Toggle this fill flag (Y or N)?'
                READ  '(A1)', COMD
                IF (COMD.EQ.'Y'.OR.COMD.EQ.'y') LCSF(3)=-LCSF(3)
                PRINT * , ' '
                IF (LCSF(4).GE.0) THEN
                  PRINT * , 'Islands in lakes will be filled.'
                ELSE
                  PRINT * , 'Islands in lakes will not be filled.'
                END IF
                PRINT * , ' '
                PRINT * , 'Toggle this fill flag (Y or N)?'
                READ  '(A1)', COMD
                IF (COMD.EQ.'Y'.OR.COMD.EQ.'y') LCSF(4)=-LCSF(4)
                PRINT * , ' '
                IF (LCSF(5).GE.0) THEN
                  PRINT * , 'Ponds on islands in lakes will be filled.'
                ELSE
                  PRINT * , 'Ponds on islands in lakes will not be fille
     +d.'
                END IF
                PRINT * , ' '
                PRINT * , 'Toggle this fill flag (Y or N)?'
                READ  '(A1)', COMD
                IF (COMD.EQ.'Y'.OR.COMD.EQ.'y') LCSF(5)=-LCSF(5)
                CALL MDRGSC (LCOL,LCSF)
              END IF
            END IF
          END IF
C
C Other parameters to provide access to:
C
C   GD LS
C
          PRINT * , ' '
          PRINT * , 'Change miscellaneous minor EZMAP parameters (Y or N
     +)?'
          READ  '(A1)', COMD
          IF (COMD.EQ.'Y'.OR.COMD.EQ.'y') THEN
            PRINT * , ' '
            PRINT * , 'Current perimeter flag:           ',IPER
            PRINT * , 'Current elliptical-perimeter flag:',IELL
            PRINT * , 'Current labelling flag:           ',ILBL
            PRINT * , 'Current dotted-outline flag:      ',IDOT
            PRINT * , 'Current distance between dots:    ',IDBD
            PRINT * , 'Current grid spacing:             ',GSPC
            PRINT * , 'Current latitude line spacing:    ',GSLA
            PRINT * , 'Current longitude line spacing:   ',GSLO
            PRINT * , 'Current polar latitude control:   ',GLAT
            PRINT * , 'Current polar longitude control:  ',GLON
            PRINT * , 'Current standard latitude:        ',SLAT
            PRINT * , 'Current RG interpolation control: ',IINT
            PRINT * , 'Current RG data processing flag:  ',IRPF
            PRINT * , ' '
            PRINT * , 'Enter new perimeter flag (0 or 1):'
            CALL EMRDIN (IPER,IPER)
            IPER=MAX(0,MIN(1,IPER))
            PRINT * , ' '
            PRINT * , 'Enter new elliptical-perimeter flag (0 or 1):'
            CALL EMRDIN (IELL,IELL)
            IELL=MAX(0,MIN(1,IELL))
            PRINT * , ' '
            PRINT * , 'Enter new labelling flag (0 or 1):'
            CALL EMRDIN (ILBL,ILBL)
            ILBL=MAX(0,MIN(1,ILBL))
            PRINT * , ' '
            PRINT * , 'Enter new dotted-outline flag (0 or 1):'
            CALL EMRDIN (IDOT,IDOT)
            IDOT=MAX(0,MIN(1,IDOT))
            PRINT * , ' '
            PRINT * , 'Enter new distance between dots (out of 32768):'
            CALL EMRDIN (IDBD,IDBD)
            IDBD=MAX(1,IDBD)
            PRINT * , ' '
            PRINT * , 'Enter new grid spacing (0 turns grid off):'
            CALL EMRDRN (GSPC,GSPC)
            IGRD=MAX(0.,MIN(90.,GSPC))
            PRINT * , ' '
            PRINT * ,  'Enter new latitude line spacing (zero if same as
     + grid spacing):'
            CALL EMRDRN (GSLA,GSLA)
            GSLA=MAX(0.,MIN(90.,GSLA))
            PRINT * , ' '
            PRINT * , 'Enter new longitude line spacing (zero if same as
     + grid spacing):'
            CALL EMRDRN (GSLO,GSLO)
            GSLO=MAX(0.,MIN(90.,GSLO))
            PRINT * , ' '
            PRINT * , 'Enter latitude at edge of polar region (integer f
     +rom 0 to 90):'
            CALL EMRDRN (GLAT,GLAT)
            GLAT=MAX(0.,MIN(90.,REAL(INT(GLAT))))
            PRINT * , ' '
            PRINT * , 'Enter polar-region longitude-line spacing (0 to s
     +uppress them at poles):'
            CALL EMRDRN (GLON,GLON)
            GLON=MAX(0.,MIN(90.,GLON))
            PRINT * , ' '
            PRINT * , 'Current latitude of standard parallel: ',SLAT
            PRINT * , ' '
            PRINT * , 'Enter new value, between -1 and 90 (-1 to allow u
     +se of built-in defaults):'
            CALL EMRDRN (SLAT,SLAT)
            SLAT=MAX(-1.,MIN(90.,SLAT))
            PRINT * , ' '
            PRINT * , 'Enter RANGS/GSHHS interpolation flag:'
            CALL EMRDIN (IINT,IINT)
            IINT=MAX(1,MIN(999,IINT))
            PRINT * , ' '
            PRINT * , 'Enter RANGS/GSHHS data processing flag:'
            CALL EMRDIN (IRPF,IRPF)
            IRPF=MAX(0,MIN(2,IRPF))
          END IF
C
          PRINT * , ' '
          PRINT * , 'Change miscellaneous (non-EZMAP) parameters'
          PRINT * , 'within this demo program (Y or N)?'
          READ  '(A1)', COMD
C
          IF (COMD.EQ.'Y'.OR.COMD.EQ.'y') THEN
C
            PRINT * , ' '
            IF (IBOW.EQ.0) THEN
              PRINT * , 'The color scheme flag is 0 (white on black).'
            ELSE
              PRINT * , 'The color scheme flag is 1 (black on white).'
            END IF
            PRINT * , ' '
            PRINT * , 'Enter new color scheme flag (0=>WOB, 1=>BOW):'
            CALL EMRDIN (ITMP,IBOW)
            ITMP=MAX(0,MIN(1,ITMP))
            IF (ITMP.NE.IBOW) THEN
              IBOW=ITMP
              CALL GCLRWK (1,1)
              DO 107 IWID=1,3
                IF (IWID.NE.1) CALL GACWK (IWID)
                IF (IBOW.EQ.0) THEN
                  CALL GSCR (IWID,  0,0.,0.,0.)
                  CALL GSCR (IWID,  1,1.,1.,1.)
                ELSE
                  CALL GSCR (IWID,  0,1.,1.,1.)
                  CALL GSCR (IWID,  1,0.,0.,0.)
                END IF
                CALL GSCR (IWID,  2,1.,0.,0.)
                CALL GSCR (IWID,  3,0.,1.,0.)
                CALL GSCR (IWID,  4,0.,0.,1.)
                CALL GSCR (IWID,  5,0.,1.,1.)
                CALL GSCR (IWID,  6,1.,0.,1.)
                CALL GSCR (IWID,  7,1.,1.,0.)
                CALL GSCR (IWID,  8,.7,.7,0.)
                CALL GSCR (IWID,  9,1.,1.,0.)
                CALL GSCR (IWID, 10,0.,0.,0.)
                CALL GSCR (IWID, 11,1.,1.,.6)
                CALL GSCR (IWID, 12,1.,0.,0.)
                CALL GSCR (IWID,101,.2,.2,.8)
                CALL GSCR (IWID,102,.6,.4,.2)
                CALL GSCR (IWID,103,.2,.6,.4)
                CALL GSCR (IWID,104,.2,.8,.2)
                CALL GSCR (IWID,105,.4,.6,.2)
                CALL GSCR (IWID,106,.2,.4,.6)
                CALL GSCR (IWID,107,.6,.6,.6)
                CALL GSCR (IWID,108,.9,1.,1.)
                IF (IWID.NE.1) CALL GDAWK (IWID)
  107         CONTINUE
            END IF
C
            PRINT * , ' '
            IF (ISTY.EQ.0) THEN
              PRINT * , 'The style flag is 0 (simple map).'
            ELSE
              PRINT * , 'The style flag is 1 (color-filled map).'
            END IF
            PRINT * , ' '
            PRINT * , 'Enter new style flag (0 => simple map, 1 => color
     +-filled map):'
            CALL EMRDIN (ISTY,ISTY)
            ISTY=MAX(0,MIN(1,ISTY))
C
            PRINT * , ' '
            IF (IUXW.EQ.0) THEN
              PRINT * , 'The X-workstation-update flag is 0 (off).'
            ELSE
              PRINT * , 'The X-workstation-update flag is 1 (on).'
            END IF
            PRINT * , ' '
            PRINT * , 'Enter new X-workstation-update flag (0=>off, 1=>o
     +n):'
            CALL EMRDIN (IUXW,IUXW)
            IUXW=MAX(0,MIN(1,IUXW))
C
            PRINT * , ' '
            IF (ILPT.EQ.0) THEN
              PRINT * , 'The informational label flag is 0 (no label).
     +'
            ELSE
              PRINT * , 'The informational label flag is 1 (do label).
     +'
            END IF
            PRINT * , ' '
            PRINT * , 'Enter new informational label flag (0=>off, 1=>on
     +):'
            CALL EMRDIN (ILPT,ILPT)
            ILPT=MAX(0,MIN(1,ILPT))
C
            PRINT * , ' '
            IF (LABL.EQ.' ') THEN
              PRINT * , 'No plot label is currently defined.'
            ELSE
              PRINT * , 'The following plot label is currently defined:'
              WRITE (*,'(2X,A60)') LABL
            END IF
            PRINT * , ' '
            PRINT * , 'Enter one of the following:'
            PRINT * , ' '
            PRINT * , '  A blank line (use the current label)'
            PRINT * , '  A new label (60 or fewer characters)'
            PRINT * , '  The word "NONE" or "none" (no label)'
            PRINT * , ' '
            READ (*,'(A60)') CHRT
            IF (CHRT.EQ.'NONE'.OR.CHRT.EQ.'none') THEN
              LABL=' '
            ELSE IF (CHRT.NE.' ') THEN
              LABL=CHRT
            END IF
C
            PRINT * , ' '
            IF (ILLB.EQ.0) THEN
              PRINT * , 'The lat/lon label flag is 0 (no labels).'
            ELSE IF (ILLB.EQ.-1) THEN
              PRINT * , 'The lat/lon label flag is -1 (labels outside ma
     +p edge).'
            ELSE IF (ILLB.EQ.-1) THEN
              PRINT * , 'The lat/lon label flag is +1 (labels inside map
     + edge.)'
            END IF
            PRINT * , 'Current width of characters in labels: ',CSLL
            PRINT * , ' '
            PRINT * , 'Enter new lat/lon label flag:'
            PRINT * , ' '
            PRINT * , '   0=>no lat/lon labels'
            PRINT * , '  -1=>labels outside map edge'
            PRINT * , '  +1=>labels inside map edge'
            PRINT * , ' '
            CALL EMRDIN (ILLB,ILLB)
            ILLB=MAX(-1,MIN(+1,ILLB))
            PRINT * , ' '
            PRINT * , 'Enter new character width:'
            PRINT * , ' '
            CALL EMRDRN (CSLL,CSLL)
            CSLL=MAX(.001,MIN(.1,CSLL))
C
            PRINT * , ' '
            IF (ISPG.LT.0) THEN
              PRINT * , 'State Plane zones will not be drawn.'
            ELSE IF (ISPG.EQ.0) THEN
              PRINT * , 'State Plane zones for NAD1927 will be drawn.'
            ELSE
              PRINT * , 'State Plane zones for NAD1983 will be drawn.'
            END IF
            PRINT * , ' '
            PRINT * , 'Enter new State Plane zone flag:'
            PRINT * , ' '
            PRINT * , '  -n => off'
            PRINT * , '   0 => NAD1927'
            PRINT * , '  +n => NAD1983'
            CALL EMRDIN (ISPG,ISPG)
            IF (ISPG.LT.0) THEN
              ISPG=-1
            ELSE IF (ISPG.GT.0) THEN
              ISPG=8
            END IF
            IF (ISPG.GE.0) THEN
              PRINT * , ' '
              PRINT * , 'Current value of character width for labels:',
     +CHSZ
              PRINT * , ' '
              PRINT * , 'Enter new character width (from .01 to 10 degre
     +es):'
              CALL EMRDRN (CHSZ,CHSZ)
              CHSZ=MAX(.01,MIN(10.,CHSZ))
            END IF
C
          END IF
C
          GO TO 105
C
        ELSE IF (COMD.EQ.'P'.OR.COMD.EQ.'p') THEN
C
          PRINT * , ' '
          PRINT * , 'Selecting a new predefined example plot.  Enter'
          PRINT * , 'one of the following:'
          PRINT * , ' '
          PRINT * , '  N => next plot in the list'
          PRINT * , '  P => previous plot in the list'
          PRINT * , '  S => specified plot in the list'
          PRINT * , ' '
          PRINT * , '  E => expand current plot into a square'
C
          READ  '(A1)', COMD
C
          IF      (COMD.EQ.'E'.OR.COMD.EQ.'e') THEN
            PRINT * , ' '
            PRINT * , 'Expanding the current plot into a square.'
            LTYP='LI'
            PLM1(1)=.5*(XWDL+XWDR)-.5*MAX(XWDR-XWDL,YWDT-YWDB)
            PLM2(1)=.5*(XWDL+XWDR)+.5*MAX(XWDR-XWDL,YWDT-YWDB)
            PLM3(1)=.5*(YWDB+YWDT)-.5*MAX(XWDR-XWDL,YWDT-YWDB)
            PLM4(1)=.5*(YWDB+YWDT)+.5*MAX(XWDR-XWDL,YWDT-YWDB)
            PLM1(2)=0.
            PLM2(2)=0.
            PLM3(2)=0.
            PLM4(2)=0.
            GO TO 105
          ELSE IF (COMD.EQ.'N'.OR.COMD.EQ.'n') THEN
            PRINT * , ' '
            PRINT * , 'Selected next one in list.'
          ELSE IF (COMD.EQ.'P'.OR.COMD.EQ.'p') THEN
            PRINT * , ' '
            PRINT * , 'Selected previous one in list.'
            IPDP=MOD(IPDP+69,72)+1
          ELSE IF (COMD.EQ.'S'.OR.COMD.EQ.'s') THEN
            PRINT * , ' '
            PRINT * , 'Enter an integer between 1 and 72 (use 1-17 for'
            PRINT * , 'original EZMAP projection types, 18-50 for USGS'
            PRINT * , 'transformations, and 51-72 for State Plane Grid'
            PRINT * , 'plots):'
            PRINT * , ' '
            PRINT * , '  1 => LC      25 => UT-04  49 => UT-22        '
            PRINT * , '  2 => GN      26 => UT-04  50 => UT-23        '
            PRINT * , '  3 => ME      27 => UT-05  51 => SPG-US-NE--27'
            PRINT * , '  4 => ST      28 => UT-06  52 => SPG-US-NE--83'
            PRINT * , '  5 => LE      29 => UT-06  53 => SPG-US-SE--27'
            PRINT * , '  6 => OR      30 => UT-07  54 => SPG-US-SE--83'
            PRINT * , '  7 => SV      31 => UT-08  55 => SPG-US-NEC-27'
            PRINT * , '  8 => AE      32 => UT-08  56 => SPG-US-NEC-83'
            PRINT * , '  9 => RO      33 => UT-08  57 => SPG-US-SEC-27'
            PRINT * , ' 10 => MT      34 => UT-08  58 => SPG-US-SEC-83'
            PRINT * , ' 11 => CE      35 => UT-09  59 => SPG-US-NWC-27'
            PRINT * , ' 12 => EA      36 => UT-10  60 => SPG-US-NWC-83'
            PRINT * , ' 13 => RM      37 => UT-11  61 => SPG-US-SWC-27'
            PRINT * , ' 14 => AI      38 => UT-12  62 => SPG-US-SWC-83'
            PRINT * , ' 15 => HA      39 => UT-13  63 => SPG-US-NW--27'
            PRINT * , ' 16 => MO      40 => UT-14  64 => SPG-US-NW--83'
            PRINT * , ' 17 => WT      41 => UT-15  65 => SPG-US-SW--27'
            PRINT * , ' 18 => UT-01   42 => UT-16  66 => SPG-US-SW--83'
            PRINT * , ' 19 => UT-01   43 => UT-17  67 => SPG-ALASKA-27'
            PRINT * , ' 20 => UT-02   44 => UT-18  68 => SPG-ALASKA-83'
            PRINT * , ' 21 => UT-02   45 => UT-19  69 => SPG-HAWAII-27'
            PRINT * , ' 22 => UT-02   46 => UT-20  70 => SPG-HAWAII-83'
            PRINT * , ' 23 => UT-03   47 => UT-20  71 => SPG-ALL----27'
            PRINT * , ' 24 => UT-03   48 => UT-21  72 => SPG-ALL----83'
            PRINT * , ' '
            CALL EMRDIN (IPDP,IPDP)
            IPDP=MAX(1,MIN(72,IPDP))
          END IF
C
          PRINT * , ' '
          PRINT * , 'Number of predefined example plot selected:',IPDP
C
          CALL INNPDP (IPDP,PTYP,PLAT,PLON,ROTA,LTYP,PLM1,PLM2,PLM3,
     +                 PLM4,IPRJ,IZON,ISPH,PARA,IDSL,ISPG,ODNM,ILVL,
     +                 CHSZ,LABL,ILLB)
C
          GO TO 105
C
        ELSE IF (COMD.EQ.'Q'.OR.COMD.EQ.'q') THEN
C
          CALL GDAWK (1)
          CALL GCLWK (1)
          CALL GCLWK (2)
          IF (NFPS.NE.0) THEN
            CALL GACWK (3)
            CALL GCLRWK (3,1)
            CALL GDAWK (3)
          END IF
          CALL GCLWK (3)
          CALL GCLKS
          STOP
C
        ELSE IF (COMD.EQ.'R'.OR.COMD.EQ.'r') THEN
C
          PRINT * , ' '
          PRINT * , 'Redrawing the picture.'
C
          GO TO 105
C
        ELSE IF (COMD.EQ.'S'.OR.COMD.EQ.'s') THEN
C
          PRINT * , ' '
          PRINT * , 'Save the current frame.  Note that parts of the'
          PRINT * , 'image resulting from "T" commands are not saved.'
          PRINT * , ' '
          PRINT * , 'One may save to an NCGM, to a Postscript file, or'
          PRINT * , 'both.'
          PRINT * , ' '
          PRINT * , 'Do you want to save to an NCAR CGM file (Y or N)?'
          READ  '(A1)', COMD
          IF (COMD.NE.'Y'.AND.COMD.NE.'y') THEN
            ISNG=0
          ELSE
            ISNG=1
            CALL GACWK (2)
            NFNG=NFNG+1
            IF (NFNG.GT.1) CALL GCLRWK (2,1)
          END IF
          PRINT * , ' '
          PRINT * , 'Do you want to save to a PostScript file (Y or N)?'
          READ  '(A1)', COMD
          IF (COMD.NE.'Y'.AND.COMD.NE.'y') THEN
            ISPS=0
          ELSE
            ISPS=1
            CALL GACWK (3)
            NFPS=NFPS+1
            IF (NFPS.GT.1) CALL GCLRWK (3,1)
          END IF
          IF (ISNG.NE.0.OR.ISPS.NE.0) THEN
            CALL GDAWK(1)
            CALL MAPPOS (XVPL,XVPR,YVPB,YVPT)
            CALL MAPROJ (PTYP,PLAT,PLON,ROTA)
            IF (PTYP.EQ.'SV') THEN
              CALL MPSETR ('SA',SALT)
              CALL MPSETR ('S1',SAN1)
              CALL MPSETR ('S2',SAN2)
            END IF
            CALL MAPSET (LTYP,PLM1,PLM2,PLM3,PLM4)
            CALL MPSETI ('PE',IPER)
            CALL MPSETI ('EL',IELL)
            CALL MPSETI ('LA',ILBL)
            CALL MPSETI ('DO',IDOT)
            CALL MPSETI ('DD',IDBD)
            CALL MPSETR ('GR',GSPC)
            CALL MPSETR ('GT',GSLA)
            CALL MPSETR ('GN',GSLO)
            CALL MPSETR ('GP',1000.*GLAT+GLON)
            CALL MPSETI ('II',1000*IINT+IINT)
            CALL MPSETI ('RP',IRPF)
            CALL MPSETR ('SL',SLAT)
            IF (PTYP.NE.'UT') THEN
              CALL MAPINT
            ELSE
              CALL MPUTIN (IPRJ,IZON,ISPH,PARA,0.D0,0.D0,0.D0,0.D0)
            END IF
            IF (ISTY.EQ.0) THEN
              CALL MAPGRD
              CALL MAPLBL
              IF (ODNM.EQ.'E1'.OR.ODNM.EQ.'E2'.OR.
     +            ODNM.EQ.'E3'.OR.ODNM.EQ.'E4') THEN
                IF (ODNM.EQ.'E1') CALL MPLNDR ('Earth..1',ILVL)
                IF (ODNM.EQ.'E2') CALL MPLNDR ('Earth..2',ILVL)
                IF (ODNM.EQ.'E3') CALL MPLNDR ('Earth..3',ILVL)
                IF (ODNM.EQ.'E4') CALL MPLNDR ('Earth..4',ILVL)
              ELSE IF (ODNM.EQ.'RG') THEN
                CALL MDRGOL (MOD(IRGL,5 ),RWRK,LRWK)
              ELSE
                CALL MAPLOT
              END IF
              CALL DRSPGD (ISPG,IZN0,PLT0,PLN0,CLT0,CLN0,
     +                          IZN8,PLT8,PLN8,CLT8,CLN8,CHSZ)
            ELSE
              IF (ODNM.EQ.'E1'.OR.ODNM.EQ.'E2'.OR.
     +            ODNM.EQ.'E3'.OR.ODNM.EQ.'E4') THEN
                CALL MPSETI ('VS',20)
                CALL ARINAM (IAMA,LAMA)
                IF (ODNM.EQ.'E1') CALL MPLNAM ('Earth..1',ILVL,IAMA)
                IF (ODNM.EQ.'E2') CALL MPLNAM ('Earth..2',ILVL,IAMA)
                IF (ODNM.EQ.'E3') CALL MPLNAM ('Earth..3',ILVL,IAMA)
                IF (ODNM.EQ.'E4') CALL MPLNAM ('Earth..4',ILVL,IAMA)
                CALL ARSCAM (IAMA,XCRA,YCRA,NCRA,IAAI,IAGI,NGPS,COLORB)
                IF (ODNM.EQ.'E1') CALL MPLNDR ('Earth..1',ILVL)
                IF (ODNM.EQ.'E2') CALL MPLNDR ('Earth..2',ILVL)
                IF (ODNM.EQ.'E3') CALL MPLNDR ('Earth..3',ILVL)
                IF (ODNM.EQ.'E4') CALL MPLNDR ('Earth..4',ILVL)
                CALL MAPGRM (IAMA,XCRA,YCRA,NCRA,IAAI,IAGI,NGPS,DRAWLB)
              ELSE IF (ODNM.EQ.'RG') THEN
                CALL MDRGSF (MOD(IRGL,5),RWRK,LRWK,IAMA,LAMA)
                CALL MAPGRD
              ELSE
                CALL MPSETC ('OU',ODNM)
                CALL MPSETI ('VS',0)
                CALL ARINAM (IAMA,LAMA)
                CALL MAPBLA (IAMA)
                CALL ARSCAM (IAMA,XCRA,YCRA,NCRA,IAAI,IAGI,NGPS,COLORA)
                CALL MAPLOT
                CALL MAPGRM (IAMA,XCRA,YCRA,NCRA,IAAI,IAGI,NGPS,DRAWLA)
              END IF
              CALL MAPLMB
              CALL MAPLBL
              CALL DRSPGD (ISPG,IZN0,PLT0,PLN0,CLT0,CLN0,
     +                          IZN8,PLT8,PLN8,CLT8,CLN8,CHSZ)
            END IF
            IF (ILLB.NE.0) THEN
              P=REAL(SIGN(1,ILLB))
              CALL PCSETI ('BF - BOX FLAG',0)
              CALL MDLBLT(RVPL,RVPB,RVPL,RVPT,+P*CSLL,    0.,CSLL,0.,-P)
              CALL MDLBLT(RVPR,RVPB,RVPR,RVPT,-P*CSLL,    0.,CSLL,0.,+P)
              CALL MDLBLN(RVPL,RVPB,RVPR,RVPB,0.,+1.5*P*CSLL,CSLL,0.,0.)
              CALL MDLBLN(RVPL,RVPT,RVPR,RVPT,0.,-1.5*P*CSLL,CSLL,0.,0.)
              CALL PCSETI ('BF - BOX FLAG',3)
            END IF
            IF (LABL.NE.' ') CALL PLCHHQ (CFUX(.5),CFUY(.965),
     +                                    LABL(1:MPILNB(LABL)),
     +                                              .018,0.,0.)
            IF (ILPT.NE.0) CALL DRPTLB (PTYP,IPRJ,IZON,ISPH,PARA,IPRF,
     +                                                      ODNM,ILVL)
            CALL SFLUSH
            IF (ISNG.NE.0) CALL GDAWK (2)
            IF (ISPS.NE.0) CALL GDAWK (3)
            CALL GACWK(1)
          END IF
C
          GO TO 106
C
        ELSE IF (COMD.EQ.'T'.OR.COMD.EQ.'t') THEN
C
          PRINT * , ' '
          PRINT * , 'Test some aspect of EZMAP.'
          PRINT * , ' '
          PRINT * , 'Enter one of the following commands:'
          PRINT * , ' '
          PRINT * , '  C  =>  Contour test'
          PRINT * , '  I  =>  Inverse routine test'
          PRINT * , '  S  =>  Spiral test'
C
          READ  '(A1)', COMD
C
          IF (COMD.EQ.'C'.OR.COMD.EQ.'c') THEN
            PRINT * , ' '
            PRINT * , 'This test uses EZMAP''s inverse transformation'
            PRINT * , 'routines to generate large arrays of latitudes'
            PRINT * , 'and longitudes as functions of the fractional'
            PRINT * , 'coordinates of points in the plotter frame.  The'
            PRINT * , 'arrays are contoured.  The contour lines should'
            PRINT * , 'be observed to lie on top of the lat/lon grid'
            PRINT * , 'previously drawn.'
            PRINT * , ' '
            PRINT * , 'As the latitudes and longitudes are computed,'
            PRINT * , 'points where the inverse transformation is not'
            PRINT * , 'defined are marked with little X''s whose color'
            PRINT * , 'implies the reason the inverse was not defined.'
            PRINT * , ' '
            PRINT * , 'One may change the color of the contours and the'
            PRINT * , 'dimensions of the arrays used.  Using larger'
            PRINT * , 'arrays will more accurately duplicate the grid'
            PRINT * , 'line positions, but is time-consuming.'
            PRINT * , ' '
            PRINT * , 'Change contouring parameters (Y or N)?:'
            READ  '(A1)', COMD
            IF (COMD.EQ.'Y'.OR.COMD.EQ.'y') THEN
              PRINT * , ' '
              PRINT * , 'Current contouring color:          ',ICNC
              PRINT * , 'Current dimension of contour array:',NCDM
              PRINT * , ' '
              PRINT * , 'Enter new contouring color (between 0 and 7):'
              PRINT * , ' '
              IF (IBOW.EQ.0) THEN
                PRINT * , '  0 => black'
                PRINT * , '  1 => white'
              ELSE
                PRINT * , '  0 => white'
                PRINT * , '  1 => black'
              END IF
              PRINT * , '  2 => red'
              PRINT * , '  3 => green'
              PRINT * , '  4 => blue'
              PRINT * , '  5 => cyan'
              PRINT * , '  6 => magenta'
              PRINT * , '  7 => yellow'
              CALL EMRDIN (ICNC,ICNC)
              ICNC=MAX(0,MIN(7,ICNC))
              PRINT * , ' '
              PRINT * , 'Enter new contour array dimension (between 51 a
     +nd 501):'
              CALL EMRDIN (NCDM,NCDM)
              NCDM=MAX(51,MIN(501,NCDM))
            END IF
            PRINT * , ' '
            PRINT * , 'Contouring latitudes and longitudes.'
            CALL CONINV (ICNC,NCDM)
            CALL MAPINT
            GO TO 106
          ELSE IF (COMD.EQ.'I'.OR.COMD.EQ.'i') THEN
            IF (ISTY.NE.0.AND.ODNM.NE.'RG') THEN
              CALL GSPLCI (2)
              DO 109 I=0,9
                CALL PLCHMQ (CFUX(REAL(I)/10.+.05),CFUY(.05),
     +                       CHAR(ICHAR('0')+I),.015,0.,0.)
                CALL PLCHMQ (CFUX(.05),CFUY(REAL(I)/10.+.05),
     +                       CHAR(ICHAR('0')+I),.015,0.,0.)
  109         CONTINUE
              PRINT * , ' '
              PRINT * , 'This test allows one to repeatedly select one'
              PRINT * , 'of 100 subsquares of the plotter frame; each'
              PRINT * , 'subsquare so selected is further subdivided'
              PRINT * , 'into 100 subsubsquares and each of those is'
              PRINT * , 'filled with a color.  The color is selected'
              PRINT * , 'by a process that thoroughly tests the EZMAP'
              PRINT * , 'transformation routines (in both directions).'
              PRINT * , 'The effect should be to leave the map colored'
              PRINT * , 'as it was by the initial color fill.'
  110         PRINT * , ' '
              PRINT * , 'Enter X position (0-9, -1 to quit):'
              CALL EMRDIN (IHOR,0)
              IHOR=MAX(-1,MIN(9,IHOR))
              IF (IHOR.EQ.-1) GO TO 106
              PRINT * , ' '
              PRINT * , 'Enter Y position (0-9, -1 to quit):'
              CALL EMRDIN (IVER,0)
              IVER=MAX(-1,MIN(9,IVER))
              IF (IVER.EQ.-1) GO TO 106
              ICSF=1
              DO 113 I=0,99
                DO 112 J=0,99
                  XBOX(1)=CFUX(REAL(IHOR)/10.+REAL(I  )/1000.)
                  YBOX(1)=CFUY(REAL(IVER)/10.+REAL(J  )/1000.)
                  XBOX(2)=CFUX(REAL(IHOR)/10.+REAL(I+1)/1000.)
                  YBOX(2)=CFUY(REAL(IVER)/10.+REAL(J  )/1000.)
                  XBOX(3)=CFUX(REAL(IHOR)/10.+REAL(I+1)/1000.)
                  YBOX(3)=CFUY(REAL(IVER)/10.+REAL(J+1)/1000.)
                  XBOX(4)=CFUX(REAL(IHOR)/10.+REAL(I  )/1000.)
                  YBOX(4)=CFUY(REAL(IVER)/10.+REAL(J+1)/1000.)
                  XPOS=CFUX(REAL(IHOR)/10.+REAL(I  )/1000.+.0005)
                  YPOS=CFUY(REAL(IVER)/10.+REAL(J+1)/1000.+.0005)
                  CALL MAPTRI (XPOS,YPOS,RLAT,RLON)
                  IF (RLAT.NE.1.E12.AND.RLON.NE.1.E12) THEN
                    CALL MAPTRA (RLAT,RLON,XPOS,YPOS)
                    IF (XPOS.NE.1.E12.AND.YPOS.NE.1.E12) THEN
                      CALL ARGTAI (IAMA,XPOS,YPOS,IAAI,IAGI,NGPS,NAIR,
     +                                                           ICSF)
                      ICSF=0
                      IAI1=-1
                      DO 111 IAIR=1,NAIR
                        IF (IAGI(IAIR).EQ.1) IAI1=IAAI(IAIR)
  111                 CONTINUE
                      IF (IAI1.GT.0) THEN
                        IF (ODNM.NE.'E1'.AND.ODNM.NE.'E2'.AND.
     +                      ODNM.NE.'E3'.AND.ODNM.NE.'E4') THEN
                          CALL GSFACI (MAPACI(IAI1)+100)
                        ELSE
                          CALL GSFACI (MPISCI(IAI1)+100)
                        END IF
                        CALL GFA (4,XBOX,YBOX)
                      END IF
                    END IF
                  END IF
  112           CONTINUE
  113         CONTINUE
              CALL PLOTIF (REAL(IHOR  )/10.,REAL(IVER  )/10.,0)
              CALL PLOTIF (REAL(IHOR+1)/10.,REAL(IVER  )/10.,1)
              CALL PLOTIF (REAL(IHOR+1)/10.,REAL(IVER+1)/10.,1)
              CALL PLOTIF (REAL(IHOR  )/10.,REAL(IVER+1)/10.,1)
              CALL PLOTIF (REAL(IHOR  )/10.,REAL(IVER  )/10.,1)
              CALL SFLUSH
              CALL GUWK (1,0)
              GO TO 110
            ELSE
              PRINT * , ' '
              PRINT * , 'Can''t do that test with "style" flag = 0 or'
              PRINT * , 'when using outline dataset selector "RG".'
              GO TO 106
            END IF
          ELSE IF (COMD.EQ.'S'.OR.COMD.EQ.'s') THEN
            PRINT * , ' '
            PRINT * , 'This test allows one to draw the projection of'
            PRINT * , 'a spiral beginning at a specified point on the'
            PRINT * , 'globe and ending at the point exactly opposite'
            PRINT * , 'that initial point.  One may change the color of'
            PRINT * , 'the spiral, the number of complete turns that it'
            PRINT * , 'makes, and the location of its starting point.'
            PRINT * , 'This tests the forward-transformation routines'
            PRINT * , 'and the proper drawing of lines as they appear'
            PRINT * , 'and disappear at the edges of a map.'
            PRINT * , ' '
            PRINT * , 'Change parameters of the spiral (Y or N)?:'
            READ  '(A1)', COMD
            IF (COMD.EQ.'Y'.OR.COMD.EQ.'y') THEN
              PRINT * , ' '
              PRINT * , 'Current spiral color:      ',ISPC
              PRINT * , 'Current number of turns:   ',NSPT
              PRINT * , 'Current latitude at start: ',SPLT
              PRINT * , 'Current longitude at start:',SPLN
              PRINT * , ' '
              PRINT * , 'Enter new spiral color (between 0 and 7):'
              PRINT * , ' '
              IF (IBOW.EQ.0) THEN
                PRINT * , '  0 => black'
                PRINT * , '  1 => white'
              ELSE
                PRINT * , '  0 => white'
                PRINT * , '  1 => black'
              END IF
              PRINT * , '  2 => red'
              PRINT * , '  3 => green'
              PRINT * , '  4 => blue'
              PRINT * , '  5 => cyan'
              PRINT * , '  6 => magenta'
              PRINT * , '  7 => yellow'
              CALL EMRDIN (ISPC,ISPC)
              ISPC=MAX(0,MIN(7,ISPC))
              PRINT * , ' '
              PRINT * , 'Enter new number of turns (between 1 and 1000):
     +'
              CALL EMRDIN (NSPT,NSPT)
              NSPT=MAX(1,MIN(1000,NSPT))
              PRINT * , ' '
              PRINT * , 'Enter new latitude at start (between -90 and 90
     +):'
              CALL EMRDRN (SPLT,SPLT)
              SPLT=MAX(-90.,MIN(90.,SPLT))
              PRINT * , ' '
              PRINT * ,  'Enter new longitude at start (between -180 and
     + 180):'
              CALL EMRDRN (SPLN,SPLN)
              SPLN=MAX(-180.,MIN(180.,SPLN))
            END IF
            PRINT * , ' '
            PRINT * , 'Drawing spiral.'
            CALL DRAWSP (ISPC,SPLT,SPLN,NSPT)
            GO TO 106
          ELSE
            PRINT * , ' '
            PRINT * , 'Illegal test command.'
            GO TO 106
          END IF
C
        ELSE
C
          PRINT * , ' '
          PRINT * , 'Illegal command.  Try again.'
          GO TO 106
C
        END IF
C
C An error occurred in a graphics call.  Inform user and go back to
C let him enter another command.
C
  901   PRINT * , ' '
        PRINT * , 'An error has occurred in a graphics call.  The error'
        PRINT * , 'message was as follows:'
        PRINT * , ' '
        CALL EPRIN
        PRINT * , ' '
        PRINT * , 'You will probably have to change some parameter to'
        PRINT * , 'avoid this error.'
        CALL ERROF
        GO TO 106
C
      END



      SUBROUTINE EMRDIN (IVAL,IDEF)
C
C This routine reads a line of input to get an integer value IVAL.  If
C the line is entirely blank, the default value IDEF is returned.  If
C the line contains an illegal character, another line is obtained.
C
        CHARACTER*128 LINE
C
C Assume the default value will be returned until we find otherwise.
C
        IVAL=IDEF
C
C Get a line from standard input.
C
        READ '(A128)' , LINE
C
        IF (LINE.NE.' ') THEN
          READ (LINE,*) IVAL
        END IF
C
C Done.
C
        RETURN
C
      END



      SUBROUTINE EMRDRN (RVAL,RDEF)
C
C This routine reads a line of input to get a real number RVAL.  If
C the line is entirely blank, the default value RDEF is returned.  If
C the line contains an illegal character, another line is obtained.
C
        CHARACTER*128 LINE
C
C Assume the default value will be returned until we find otherwise.
C
        RVAL=RDEF
C
C Get a line from standard input.
C
        READ '(A128)' , LINE
C
        IF (LINE.NE.' ') THEN
          READ (LINE,*) RVAL
        END IF
C
C Done.
C
        RETURN
C
      END



      SUBROUTINE COLORA (XCRA,YCRA,NCRA,IAAI,IAGI,NGPS)
        DIMENSION XCRA(NCRA),YCRA(NCRA),IAAI(NGPS),IAGI(NGPS)
        COMMON /RASIZE/ LLPG
        SAVE   /RASIZE/
        IAI1=-1
        DO 101 IGRP=1,NGPS
          IF (IAGI(IGRP).EQ.1) IAI1=IAAI(IGRP)
  101   CONTINUE
        IF (IAI1.GT.0) THEN
          CALL GSFACI (MAPACI(IAI1)+100)
          CALL GFA    (NCRA-1,XCRA,YCRA)
          LLPG=MAX(LLPG,NCRA-1)
        END IF
        RETURN
      END



      SUBROUTINE DRAWLA (XCRA,YCRA,NCRA,IAAI,IAGI,NGPS)
        DIMENSION XCRA(NCRA),YCRA(NCRA),IAAI(NGPS),IAGI(NGPS)
        IAI1=-1
        DO 101 IGRP=1,NGPS
          IF (IAGI(IGRP).EQ.1) IAI1=IAAI(IGRP)
  101   CONTINUE
        IF (IAI1.GT.0) THEN
          IF (MAPACI(IAI1).EQ.1) THEN
            CALL GPL    (NCRA,XCRA,YCRA)
          END IF
        END IF
        RETURN
      END



      SUBROUTINE COLORB (XCRA,YCRA,NCRA,IAAI,IAGI,NGPS)
        DIMENSION XCRA(NCRA),YCRA(NCRA),IAAI(NGPS),IAGI(NGPS)
        COMMON /RASIZE/ LLPG
        SAVE   /RASIZE/
        IAI1=-1
        DO 101 IGRP=1,NGPS
          IF (IAGI(IGRP).EQ.1) IAI1=IAAI(IGRP)
  101   CONTINUE
        IF (IAI1.GT.0) THEN
          CALL GSFACI (MPISCI(IAI1)+100)
          CALL GFA    (NCRA-1,XCRA,YCRA)
          LLPG=MAX(LLPG,NCRA-1)
        END IF
        RETURN
      END



      SUBROUTINE DRAWLB (XCRA,YCRA,NCRA,IAAI,IAGI,NGPS)
        DIMENSION XCRA(NCRA),YCRA(NCRA),IAAI(NGPS),IAGI(NGPS)
        IAI1=-1
        DO 101 IGRP=1,NGPS
          IF (IAGI(IGRP).EQ.1) IAI1=IAAI(IGRP)
  101   CONTINUE
        IF (IAI1.GT.0) THEN
          IF (MPIPAN(IAI1,'Water').NE.0) THEN
            CALL GPL    (NCRA,XCRA,YCRA)
          END IF
        END IF
        RETURN
      END



      SUBROUTINE MUPPER (CHRS)
        CHARACTER*(*) CHRS
        CHARACTER*26 LOWR,UPPR
        DATA LOWR / 'abcdefghijklmnopqrstuvwxyz' /
        DATA UPPR / 'ABCDEFGHIJKLMNOPQRSTUVWXYZ' /
        DO 102 I=1,LEN(CHRS)
          DO 101 J=1,26
            IF (CHRS(I:I).EQ.LOWR(J:J)) CHRS(I:I)=UPPR(J:J)
  101     CONTINUE
  102   CONTINUE
        RETURN
      END


      SUBROUTINE ZERODA (DPRA,LNTH)
        DOUBLE PRECISION DPRA(LNTH)
        DO 101 I=1,LNTH
          DPRA(I)=0.D0
  101   CONTINUE
        RETURN
      END


      SUBROUTINE DRSPGD (ISPG,IZN0,PLT0,PLN0,CLT0,CLN0,
     +                        IZN8,PLT8,PLN8,CLT8,CLN8,CHSZ)
C
        DIMENSION IZN0(139)
        DIMENSION PLT0(200,139),PLN0(200,139),CLT0(139),CLN0(139)
        DIMENSION IZN8(139)
        DIMENSION PLT8(200,139),PLN8(200,139),CLT8(139),CLN8(139)
C
C Declare a common block making it possible to set PLOTCHAR's internal
C parameter 'MA' = 4.
C
        COMMON /PCMP04/ PANG,PLAT,PLON
        SAVE   /PCMP04/
C
C Declare a character temporary.
C
        CHARACTER*5 CTMP
C
C Draw NAD1927 zone, if it's selected.
C
        IF (ISPG.EQ.0) THEN
C
          DO 103 ISPI=1,139
            IF (IZN0(ISPI).NE.0) THEN
              CALL SFLUSH
              CALL GSLWSC (6.)
              CALL GSPLCI (10)
              CALL MAPIT (PLT0(1,ISPI),PLN0(1,ISPI),0)
              DO 101 I=2,200
                CALL MAPIT (PLT0(I,ISPI),PLN0(I,ISPI),1)
  101         CONTINUE
              CALL MAPIT (PLT0(1,ISPI),PLN0(1,ISPI),2)
              CALL SFLUSH
              CALL GSLWSC (2.)
              CALL GSPLCI (12)
              CALL MAPIT (PLT0(1,ISPI),PLN0(1,ISPI),0)
              DO 102 I=2,200
                CALL MAPIT (PLT0(I,ISPI),PLN0(I,ISPI),1)
  102         CONTINUE
              CALL MAPIT (PLT0(1,ISPI),PLN0(1,ISPI),2)
            END IF
  103     CONTINUE
C
          CALL SFLUSH
          CALL GSLWSC (1.)
C
          CALL PCSETI ('MA',4)
          CALL PCSETR ('OR',1.E12)
C
          DO 104 ISPI=1,139
            IF (IZN0(ISPI).NE.0.AND.IZN0(ISPI).NE.1901) THEN
              WRITE (CTMP,'(I5)') 10000+IZN0(ISPI)
              PANG=0.
              PLAT=CLT0(ISPI)
              PLON=CLN0(ISPI)
              CALL PLCHHQ (0.,0.,CTMP(2:5),CHSZ,0.,0.)
            END IF
  104     CONTINUE
C
          CALL PCSETI ('MA',0)
          CALL PCSETR ('OR',0.)
C
          CALL SFLUSH
          CALL GSPLCI (1)
C
C Draw NAD1983 zone, if it's selected.
C
        ELSE IF (ISPG.EQ.8) THEN
C
          DO 107 ISPI=1,139
            IF (IZN8(ISPI).NE.0) THEN
              CALL SFLUSH
              CALL GSLWSC (6.)
              CALL GSPLCI (10)
              CALL MAPIT (PLT8(1,ISPI),PLN8(1,ISPI),0)
              DO 105 I=2,200
                CALL MAPIT (PLT8(I,ISPI),PLN8(I,ISPI),1)
  105         CONTINUE
              CALL MAPIT (PLT8(1,ISPI),PLN8(1,ISPI),2)
              CALL SFLUSH
              CALL GSLWSC (2.)
              CALL GSPLCI (12)
              CALL MAPIT (PLT8(1,ISPI),PLN8(1,ISPI),0)
              DO 106 I=2,200
                CALL MAPIT (PLT8(I,ISPI),PLN8(I,ISPI),1)
  106         CONTINUE
              CALL MAPIT (PLT8(1,ISPI),PLN8(1,ISPI),2)
            END IF
  107     CONTINUE
C
          CALL SFLUSH
          CALL GSLWSC (1.)
C
          CALL PCSETI ('MA',4)
          CALL PCSETR ('OR',1.E12)
C
          DO 108 ISPI=1,139
            IF (IZN8(ISPI).NE.0.AND.IZN8(ISPI).NE.1901) THEN
              WRITE (CTMP,'(I5)') 10000+IZN8(ISPI)
              PANG=0.
              PLAT=CLT8(ISPI)
              PLON=CLN8(ISPI)
              CALL PLCHHQ (0.,0.,CTMP(2:5),CHSZ,0.,0.)
            END IF
  108     CONTINUE
C
          CALL PCSETI ('MA',0)
          CALL PCSETR ('OR',0.)
C
          CALL SFLUSH
          CALL GSPLCI (1)
C
        END IF
C
        RETURN
C
      END


      SUBROUTINE INNPDP (IPDP,PTYP,PLAT,PLON,ROTA,LTYP,PLM1,PLM2,PLM3,
     +                   PLM4,IPRJ,IZON,ISPH,PARA,IDSL,ISPG,ODNM,ILVL,
     +                   CHSZ,LABL,ILLB)
C
        CHARACTER*(*) PTYP,LTYP,ODNM,LABL
        DIMENSION PLM1(2),PLM2(2),PLM3(2),PLM4(2)
        DOUBLE PRECISION PARA(15)
C
        PTYP='UT'
C
        PLAT=0.
        PLON=0.
        ROTA=0.
C
        LTYP='MA'
        PLM1(1)=0.
        PLM1(2)=0.
        PLM2(1)=0.
        PLM2(2)=0.
        PLM3(1)=0.
        PLM3(2)=0.
        PLM4(1)=0.
        PLM4(2)=0.
C
        IPRJ=0
        IZON=0
        ISPH=0
C
        IDSL=1
C
        ISPG=-1
C
        LABL=' '
C
        ILLB=0
C
        CALL ZERODA (PARA,15)
C
        PRINT * , ' '
C
        IF      (IPDP.EQ. 1) THEN
          PRINT * , 'Example 1 shows an original EZMAP transformation'
          PRINT * , 'called the Lambert Conformal Conic.'
          PTYP='LC'
          PLAT=55.
          ROTA=85.
        ELSE IF (IPDP.EQ. 2) THEN
          PRINT * , 'Example 2 shows an original EZMAP transformation'
          PRINT * , 'called the Gnomonic.'
          PTYP='GN'
          PLAT=40.
          PLON=-105.
        ELSE IF (IPDP.EQ. 3) THEN
          PRINT * , 'Example 3 shows an original EZMAP transformation'
          PRINT * , 'called the Mercator.'
          PTYP='ME'
          ILLB=-1
        ELSE IF (IPDP.EQ. 4) THEN
          PRINT * , 'Example 4 shows an original EZMAP transformation'
          PRINT * , 'called the Stereographic.'
          PTYP='ST'
        ELSE IF (IPDP.EQ. 5) THEN
          PRINT * , 'Example 5 shows an original EZMAP transformation'
          PRINT * , 'called the Lambert Equal-Area.'
          PTYP='LE'
        ELSE IF (IPDP.EQ. 6) THEN
          PRINT * , 'Example 6 shows an original EZMAP transformation'
          PRINT * , 'called the Orthographic.'
          PTYP='OR'
          PLAT=40.
          PLON=-105.
        ELSE IF (IPDP.EQ. 7) THEN
          PRINT * , 'Example 7 shows an original EZMAP transformation'
          PRINT * , 'called the Satellite View or Perspective.'
          PTYP='SV'
          PLAT=40.
          PLON=-105.
        ELSE IF (IPDP.EQ. 8) THEN
          PRINT * , 'Example 8 shows an original EZMAP transformation'
          PRINT * , 'called the Azimuthal Equidistant.'
          PTYP='AE'
        ELSE IF (IPDP.EQ. 9) THEN
          PRINT * , 'Example 9 shows an original EZMAP transformation'
          PRINT * , 'called the Robinson, which was developed by the'
          PRINT * , 'National Geographic Society for use in world maps.'
          PTYP='RO'
        ELSE IF (IPDP.EQ.10) THEN
          PRINT * , 'Example 10 shows an original EZMAP transformation'
          PRINT * , 'which is characterized as a "Mollweide type".'
          PTYP='MT'
        ELSE IF (IPDP.EQ.11) THEN
          PRINT * , 'Example 11 shows an original EZMAP transformation'
          PRINT * , 'called the Cylindrical Equidistant.'
          PTYP='CE'
          ILLB=-1
        ELSE IF (IPDP.EQ.12) THEN
          PRINT * , 'Example 12 shows an original EZMAP transformation'
          PRINT * , 'called the Cylindrical Equal-Area.'
          PTYP='EA'
          ILLB=-1
        ELSE IF (IPDP.EQ.13) THEN
          PRINT * , 'Example 13 shows an original EZMAP transformation'
          PRINT * , 'called the Rotated Mercator.'
          PTYP='RM'
          ROTA=45.
          LTYP='CO'
          PLM1(1)=   2.
          PLM2(1)=-135.
          PLM3(1)=  37.
          PLM4(1)=  67.
        ELSE IF (IPDP.EQ.14) THEN
          PRINT * , 'Example 14 shows an original EZMAP transformation'
          PRINT * , 'called the Aitoff.'
          PTYP='AI'
        ELSE IF (IPDP.EQ.15) THEN
          PRINT * , 'Example 15 shows an original EZMAP transformation'
          PRINT * , 'called the Hammer.'
          PTYP='HA'
        ELSE IF (IPDP.EQ.16) THEN
          PRINT * , 'Example 16 shows an original EZMAP transformation'
          PRINT * , 'called the Mollweide.'
          PTYP='MO'
        ELSE IF (IPDP.EQ.17) THEN
          PRINT * , 'Example 17 shows an original EZMAP transformation'
          PRINT * , 'called the Winkel tripel.'
          PTYP='WT'
        ELSE IF (IPDP.EQ.18) THEN
          PRINT * , 'Example 18 shows a USGS transformation called the'
          PRINT * , 'UTM system (UTM="Universal Transverse Mercator"),'
          PRINT * , 'in the Northern Hemisphere.  The area shown is'
          PRINT * , 'that for which distortion is minimal, on either'
          PRINT * , 'side of a particular meridian; normally, the UTM'
          PRINT * , 'system is used for large-scale maps which are more'
          PRINT * , 'nearly square.'
          IPRJ=1
          IZON=13
          IDSL=4
        ELSE IF (IPDP.EQ.19) THEN
          PRINT * , 'Example 19 shows a USGS transformation called the'
          PRINT * , 'UTM system (UTM="Universal Transverse Mercator"),'
          PRINT * , 'in the Southern Hemisphere.  The area shown is'
          PRINT * , 'that for which distortion is minimal, on either'
          PRINT * , 'side of a particular meridian; normally, the UTM'
          PRINT * , 'system is used for large-scale maps which are more'
          PRINT * , 'nearly square.'
          IPRJ=1
          IZON=-35
          IDSL=4
        ELSE IF (IPDP.EQ.20) THEN
          PRINT * , 'Example 20 shows a USGS transformation called the'
          PRINT * , 'State Plane coordinate system.  The zone shown is'
          PRINT * , 'that for New Hampshire.'
          IPRJ=2
          IZON=2800
          ISPH=0
          IDSL=4
          ILLB=-1
        ELSE IF (IPDP.EQ.21) THEN
          PRINT * , 'Example 21 shows a USGS transformation called the'
          PRINT * , 'State Plane coordinate system.  The zone shown is'
          PRINT * , 'that for Nebraska.'
          IPRJ=2
          IZON=2600
          ISPH=8
          IDSL=4
          ILLB=-1
        ELSE IF (IPDP.EQ.22) THEN
          PRINT * , 'Example 22 shows a USGS transformation called the'
          PRINT * , 'State Plane coordinate system.  The zone shown is'
          PRINT * , 'that for the Alaskan panhandle.'
          IPRJ=2
          IZON=5001
          ISPH=8
          IDSL=4
          ILLB=-1
        ELSE IF (IPDP.EQ.23) THEN
          PRINT * , 'Example 23 shows a USGS transformation called the'
          PRINT * , 'Alber''s Equal-Area Conic, in the Northern'
          PRINT * , 'Hemisphere.'
          IPRJ=3
          ISPH=-1
          PARA( 1)=          1.D0  !  SEMIMAJOR AXIS OF ELLIPSOID
          PARA( 2)=        .007D0  !  SQUARE OF ELLIPSOID'S ECCENTRICITY
          PARA( 3)=         50.D0  !  LATITUDE OF 1ST STANDARD PARALLEL
          PARA( 4)=         60.D0  !  LATITUDE OF 2ND STANDARD PARALLEL
          PARA( 5)=       -105.D0  !  LONGITUDE OF CENTRAL MERIDIAN
          PARA( 6)=         90.D0  !  LATITUDE OF ORIGIN OF PROJECTION
          PARA( 7)=          0.D0  !  FALSE EASTING
          PARA( 8)=          0.D0  !  FALSE NORTHING
        ELSE IF (IPDP.EQ.24) THEN
          PRINT * , 'Example 24 shows a USGS transformation called the'
          PRINT * , 'Alber''s Equal-Area Conic, in the Southern'
          PRINT * , 'Hemisphere.'
          IPRJ=3
          ISPH=-1
          PARA( 1)=          1.D0  !  SEMIMAJOR AXIS OF ELLIPSOID
          PARA( 2)=        .007D0  !  SQUARE OF ELLIPSOID'S ECCENTRICITY
          PARA( 3)=        -50.D0  !  LATITUDE OF 1ST STANDARD PARALLEL
          PARA( 4)=        -60.D0  !  LATITUDE OF 2ND STANDARD PARALLEL
          PARA( 5)=       -105.D0  !  LONGITUDE OF CENTRAL MERIDIAN
          PARA( 6)=        -90.D0  !  LATITUDE OF ORIGIN OF PROJECTION
          PARA( 7)=          0.D0  !  FALSE EASTING
          PARA( 8)=          0.D0  !  FALSE NORTHING
        ELSE IF (IPDP.EQ.25) THEN
          PRINT * , 'Example 25 shows a USGS transformation called the'
          PRINT * , 'Lambert Conformal Conic, with two standard'
          PRINT * , 'parallels, in the Northern Hemisphere.'
          IPRJ=4
          ISPH=-1
          PARA( 1)=          1.D0  !  SEMIMAJOR AXIS OF ELLIPSOID
          PARA( 2)=        .007D0  !  SQUARE OF ELLIPSOID'S ECCENTRICITY
          PARA( 3)=         50.D0  !  LATITUDE OF 1ST STANDARD PARALLEL
          PARA( 4)=         60.D0  !  LATITUDE OF 2ND STANDARD PARALLEL
          PARA( 5)=       -105.D0  !  LONGITUDE OF CENTRAL MERIDIAN
          PARA( 6)=         55.D0  !  LATITUDE OF ORIGIN OF PROJECTION
          PARA( 7)=          0.D0  !  FALSE EASTING
          PARA( 8)=          0.D0  !  FALSE NORTHING
        ELSE IF (IPDP.EQ.26) THEN
          PRINT * , 'Example 26 shows a USGS transformation called the'
          PRINT * , 'Lambert Conformal Conic, with two standard'
          PRINT * , 'parallels, in the Southern Hemisphere.'
          IPRJ=4
          ISPH=-1
          PARA( 1)=          1.D0  !  SEMIMAJOR AXIS OF ELLIPSOID
          PARA( 2)=        .007D0  !  SQUARE OF ELLIPSOID'S ECCENTRICITY
          PARA( 3)=        -50.D0  !  LATITUDE OF 1ST STANDARD PARALLEL
          PARA( 4)=        -60.D0  !  LATITUDE OF 2ND STANDARD PARALLEL
          PARA( 5)=       -105.D0  !  LONGITUDE OF CENTRAL MERIDIAN
          PARA( 6)=        -55.D0  !  LATITUDE OF ORIGIN OF PROJECTION
          PARA( 7)=          0.D0  !  FALSE EASTING
          PARA( 8)=          0.D0  !  FALSE NORTHING
        ELSE IF (IPDP.EQ.27) THEN
          PRINT * , 'Example 27 shows a USGS transformation called the'
          PRINT * , 'Mercator.'
          IPRJ=5
          ISPH=-1
          PARA( 1)=          1.D0  !  SEMIMAJOR AXIS OF ELLIPSOID
          PARA( 2)=        .007D0  !  SQUARE OF ELLIPSOID'S ECCENTRICITY
          PARA( 5)=       -105.D0  !  LONGITUDE OF CENTRAL MERIDIAN
          PARA( 6)=          0.D0  !  LATITUDE OF TRUE SCALE
          PARA( 7)=          0.D0  !  FALSE EASTING
          PARA( 8)=          0.D0  !  FALSE NORTHING
        ELSE IF (IPDP.EQ.28) THEN
          PRINT * , 'Example 28 shows a USGS transformation called the'
          PRINT * , 'Polar Stereographic, in the Northern Hemisphere.'
          IPRJ=6
          ISPH=-1
          PARA( 1)=          1.D0  !  SEMIMAJOR AXIS OF ELLIPSOID
          PARA( 2)=        .007D0  !  SQUARE OF ELLIPSOID'S ECCENTRICITY
          PARA( 5)=       -105.D0  !  LONGITUDE DOWN FROM NORTH, UP FROM SOUTH
          PARA( 6)=        +45.D0  !  LATITUDE OF TRUE SCALE
          PARA( 7)=          0.D0  !  FALSE EASTING
          PARA( 8)=          0.D0  !  FALSE NORTHING
        ELSE IF (IPDP.EQ.29) THEN
          PRINT * , 'Example 29 shows a USGS transformation called the'
          PRINT * , 'Polar Stereographic, in the Southern Hemisphere.'
          IPRJ=6
          ISPH=-1
          PARA( 1)=          1.D0  !  SEMIMAJOR AXIS OF ELLIPSOID
          PARA( 2)=        .007D0  !  SQUARE OF ELLIPSOID'S ECCENTRICITY
          PARA( 5)=       -105.D0  !  LONGITUDE DOWN FROM NORTH, UP FROM SOUTH
          PARA( 6)=        -45.D0  !  LATITUDE OF TRUE SCALE
          PARA( 7)=          0.D0  !  FALSE EASTING
          PARA( 8)=          0.D0  !  FALSE NORTHING
        ELSE IF (IPDP.EQ.30) THEN
          PRINT * , 'Example 30 shows a USGS transformation called the'
          PRINT * , 'Polyconic.'
          IPRJ=7
          ISPH=-1
          PARA( 1)=          1.D0  !  SEMIMAJOR AXIS OF ELLIPSOID
          PARA( 2)=        .007D0  !  SQUARE OF ELLIPSOID'S ECCENTRICITY
          PARA( 5)=       -105.D0  !  LONGITUDE OF CENTRAL MERIDIAN
          PARA( 6)=          0.D0  !  LATITUDE OF ORIGIN OF PROJECTION
          PARA( 7)=          0.D0  !  FALSE EASTING
          PARA( 8)=          0.D0  !  FALSE NORTHING
        ELSE IF (IPDP.EQ.31) THEN
          PRINT * , 'Example 31 shows a USGS transformation called the'
          PRINT * , 'Equidistant Conic, with one standard parallel, in'
          PRINT * , 'the Northern Hemisphere.'
          IPRJ=8
          ISPH=-1
          PARA( 1)=          1.D0  !  SEMIMAJOR AXIS OF ELLIPSOID
          PARA( 2)=        .007D0  !  SQUARE OF ELLIPSOID'S ECCENTRICITY
          PARA( 3)=         40.D0  !  LATITUDE OF STANDARD PARALLEL
          PARA( 5)=       -105.D0  !  LONGITUDE OF CENTRAL MERIDIAN
          PARA( 6)=         90.D0  !  LATITUDE OF ORIGIN OF PROJECTION
          PARA( 7)=          0.D0  !  FALSE EASTING
          PARA( 8)=          0.D0  !  FALSE NORTHING
          PARA( 9)=          0.D0  !  ZERO
        ELSE IF (IPDP.EQ.32) THEN
          PRINT * , 'Example 32 shows a USGS transformation called the'
          PRINT * , 'Equidistant Conic, with one standard parallel, in'
          PRINT * , 'the Southern Hemisphere.'
          IPRJ=8
          ISPH=-1
          PARA( 1)=          1.D0  !  SEMIMAJOR AXIS OF ELLIPSOID
          PARA( 2)=        .007D0  !  SQUARE OF ELLIPSOID'S ECCENTRICITY
          PARA( 3)=        -40.D0  !  LATITUDE OF STANDARD PARALLEL
          PARA( 5)=       -105.D0  !  LONGITUDE OF CENTRAL MERIDIAN
          PARA( 6)=        -90.D0  !  LATITUDE OF ORIGIN OF PROJECTION
          PARA( 7)=          0.D0  !  FALSE EASTING
          PARA( 8)=          0.D0  !  FALSE NORTHING
          PARA( 9)=          0.D0  !  ZERO
        ELSE IF (IPDP.EQ.33) THEN
          PRINT * , 'Example 33 shows a USGS transformation called the'
          PRINT * , 'Equidistant Conic, with two standard parallels, in'
          PRINT * , 'the Northern Hemisphere.'
          IPRJ=8
          ISPH=-1
          PARA( 1)=          1.D0  !  SEMIMAJOR AXIS OF ELLIPSOID
          PARA( 2)=        .007D0  !  SQUARE OF ELLIPSOID'S ECCENTRICITY
          PARA( 3)=         40.D0  !  LATITUDE OF 1ST STANDARD PARALLEL
          PARA( 4)=         55.D0  !  LATITUDE OF 2ND STANDARD PARALLEL
          PARA( 5)=       -105.D0  !  LONGITUDE OF CENTRAL MERIDIAN
          PARA( 6)=         90.D0  !  LATITUDE OF ORIGIN OF PROJECTION
          PARA( 7)=          0.D0  !  FALSE EASTING
          PARA( 8)=          0.D0  !  FALSE NORTHING
          PARA( 9)=          1.D0  !  NON-ZERO
        ELSE IF (IPDP.EQ.34) THEN
          PRINT * , 'Example 34 shows a USGS transformation called the'
          PRINT * , 'Equidistant Conic, with two standard parallels, in'
          PRINT * , 'the Southern Hemisphere.'
          IPRJ=8
          ISPH=-1
          PARA( 1)=          1.D0  !  SEMIMAJOR AXIS OF ELLIPSOID
          PARA( 2)=        .007D0  !  SQUARE OF ELLIPSOID'S ECCENTRICITY
          PARA( 3)=        -40.D0  !  LATITUDE OF 1ST STANDARD PARALLEL
          PARA( 4)=        -55.D0  !  LATITUDE OF 2ND STANDARD PARALLEL
          PARA( 5)=       -105.D0  !  LONGITUDE OF CENTRAL MERIDIAN
          PARA( 6)=        -90.D0  !  LATITUDE OF ORIGIN OF PROJECTION
          PARA( 7)=          0.D0  !  FALSE EASTING
          PARA( 8)=          0.D0  !  FALSE NORTHING
          PARA( 9)=          1.D0  !  NON-ZERO
        ELSE IF (IPDP.EQ.35) THEN
          PRINT * , 'Example 35 shows a USGS transformation called the'
          PRINT * , 'Transverse Mercator.  The area shown is that for'
          PRINT * , 'which distortion is minimal, on either side of a'
          PRINT * , 'particular meridian; normally, this system is used'
          PRINT * , 'for large-scale maps which are more nearly square.'
          IPRJ=9
          ISPH=-1
          PARA( 1)=   6378206.4D0  !  SEMIMAJOR AXIS OF ELLIPSOID
          PARA( 2)=   6356583.8D0  !  SQUARE OF ELLIPSOID'S ECCENTRICITY
          PARA( 3)=          1.D0  !  SCALE FACTOR AT CENTRAL MERIDIAN
          PARA( 5)=         25.D0  !  LONGITUDE OF CENTRAL MERIDIAN
          PARA( 6)=          0.D0  !  LATITUDE OF ORIGIN
          PARA( 7)=          0.D0  !  FALSE EASTING
          PARA( 8)=          0.D0  !  FALSE NORTHING
        ELSE IF (IPDP.EQ.36) THEN
          PRINT * , 'Example 36 shows a USGS transformation called the'
          PRINT * , 'Stereographic.'
          IPRJ=10
          ISPH=-1
          PARA( 1)=          1.D0  !  RADIUS OF SPHERE OF REFERENCE
          PARA( 5)=       -105.D0  !  LONGITUDE OF CENTER OF PROJECTION
          PARA( 6)=         40.D0  !  LATITUDE OF CENTER OF PROJECTION
          PARA( 7)=          0.D0  !  FALSE EASTING
          PARA( 8)=          0.D0  !  FALSE NORTHING
        ELSE IF (IPDP.EQ.37) THEN
          PRINT * , 'Example 37 shows a USGS transformation called the'
          PRINT * , 'Lambert Azimuthal Equal-Area.'
          IPRJ=11
          ISPH=-1
          PARA( 1)=          1.D0  !  RADIUS OF SPHERE OF REFERENCE
          PARA( 5)=       -105.D0  !  LONGITUDE OF CENTER OF PROJECTION
          PARA( 6)=         40.D0  !  LATITUDE OF CENTER OF PROJECTION
          PARA( 7)=          0.D0  !  FALSE EASTING
          PARA( 8)=          0.D0  !  FALSE NORTHING
        ELSE IF (IPDP.EQ.38) THEN
          PRINT * , 'Example 38 shows a USGS transformation: the'
          PRINT * , 'Azimuthal Equidistant.'
          IPRJ=12
          ISPH=-1
          PARA( 1)=          1.D0  !  RADIUS OF SPHERE OF REFERENCE
          PARA( 5)=       -105.D0  !  LONGITUDE OF CENTER OF PROJECTION
          PARA( 6)=         40.D0  !  LATITUDE OF CENTER OF PROJECTION
          PARA( 7)=          0.D0  !  FALSE EASTING
          PARA( 8)=          0.D0  !  FALSE NORTHING
        ELSE IF (IPDP.EQ.39) THEN
          PRINT * , 'Example 39 shows a USGS transformation called the'
          PRINT * , 'Gnomonic.'
          IPRJ=13
          ISPH=-1
          PARA( 1)=          1.D0  !  RADIUS OF SPHERE OF REFERENCE
          PARA( 5)=       -105.D0  !  LONGITUDE OF CENTER OF PROJECTION
          PARA( 6)=         40.D0  !  LATITUDE OF CENTER OF PROJECTION
          PARA( 7)=          0.D0  !  FALSE EASTING
          PARA( 8)=          0.D0  !  FALSE NORTHING
        ELSE IF (IPDP.EQ.40) THEN
          PRINT * , 'Example 40 shows a USGS transformation called the'
          PRINT * , 'Orthographic.'
          IPRJ=14
          ISPH=-1
          PARA( 1)=          1.D0  !  RADIUS OF SPHERE OF REFERENCE
          PARA( 5)=       -105.D0  !  LONGITUDE OF CENTER OF PROJECTION
          PARA( 6)=         40.D0  !  LATITUDE OF CENTER OF PROJECTION
          PARA( 7)=          0.D0  !  FALSE EASTING
          PARA( 8)=          0.D0  !  FALSE NORTHING
        ELSE IF (IPDP.EQ.41) THEN
          PRINT * , 'Example 41 shows a USGS transformation called the'
          PRINT * , 'Perspective (the same as the Satellite-View, but'
          PRINT * , 'only allows for a vertical view).'
          IPRJ=15
          ISPH=-1
          PARA( 1)=          1.D0  !  RADIUS OF SPHERE OF REFERENCE
          PARA( 3)=          3.D0  !  HEIGHT OF PERSPECTIVE POINT ABOVE SURFACE
          PARA( 5)=       -105.D0  !  LONGITUDE OF CENTER OF PROJECTION
          PARA( 6)=         40.D0  !  LATITUDE OF CENTER OF PROJECTION
          PARA( 7)=          0.D0  !  FALSE EASTING
          PARA( 8)=          0.D0  !  FALSE NORTHING
        ELSE IF (IPDP.EQ.42) THEN
          PRINT * , 'Example 42 shows a USGS transformation called the'
          PRINT * , 'Sinusoidal.'
          IPRJ=16
          ISPH=-1
          PARA( 1)=          1.D0  !  RADIUS OF SPHERE OF REFERENCE
          PARA( 5)=       -105.D0  !  LONGITUDE OF CENTRAL MERIDIAN
          PARA( 7)=          0.D0  !  FALSE EASTING
          PARA( 8)=          0.D0  !  FALSE NORTHING
        ELSE IF (IPDP.EQ.43) THEN
          PRINT * , 'Example 43 shows a USGS transformation called the'
          PRINT * , 'Equirectangular (same as Cylindrical Equidistant).'
          IPRJ=17
          ISPH=-1
          PARA( 1)=          1.D0  !  RADIUS OF SPHERE OF REFERENCE
          PARA( 5)=       -105.D0  !  LONGITUDE OF CENTRAL MERIDIAN
          PARA( 6)=          0.D0  !  LATITUDE OF TRUE SCALE
          PARA( 7)=          0.D0  !  FALSE EASTING
          PARA( 8)=          0.D0  !  FALSE NORTHING
        ELSE IF (IPDP.EQ.44) THEN
          PRINT * , 'Example 44 shows a USGS transformation called the'
          PRINT * , 'Miller Cylindrical.'
          IPRJ=18
          ISPH=-1
          PARA( 1)=          1.D0  !  RADIUS OF SPHERE OF REFERENCE
          PARA( 5)=       -105.D0  !  LONGITUDE OF CENTRAL MERIDIAN
          PARA( 7)=          0.D0  !  FALSE EASTING
          PARA( 8)=          0.D0  !  FALSE NORTHING
        ELSE IF (IPDP.EQ.45) THEN
          PRINT * , 'Example 45 shows a USGS transformation called the'
          PRINT * , 'Van der Grinten I.'
          IPRJ=19
          ISPH=-1
          PARA( 1)=          1.D0  !  RADIUS OF SPHERE OF REFERENCE
          PARA( 5)=       -105.D0  !  LONGITUDE OF CENTRAL MERIDIAN
          PARA( 7)=          0.D0  !  FALSE EASTING
          PARA( 8)=          0.D0  !  FALSE NORTHING
        ELSE IF (IPDP.EQ.46) THEN
          PRINT * , 'Example 46 shows a USGS transformation called the'
          PRINT * , 'Oblique Mercator.  The projection''s center line'
          PRINT * , 'is specified by giving two points that project'
          PRINT * , 'into it.  Currently, there is a bug which prevents'
          PRINT * , 'this specification method from working properly.'
          IPRJ=20
          ISPH=-1
          PARA( 1)=          1.D0  !  SEMIMAJOR AXIS OF ELLIPSOID
          PARA( 2)=        .007D0  !  SQUARE OF ELLIPSOID'S ECCENTRICITY
          PARA( 3)=          1.D0  !  SCALE FACTOR AT CENTER OF PROJECTION
          PARA( 6)=         40.D0  !  LATITUDE OF ORIGIN OF PROJECTION
          PARA( 7)=          0.D0  !  FALSE EASTING
          PARA( 8)=          0.D0  !  FALSE NORTHING
          PARA( 9)=       -100.D0  !  LONGITUDE, POINT 1
          PARA(10)=         30.D0  !  LATITUDE, POINT 1
          PARA(11)=        -80.D0  !  LONGITUDE, POINT 2
          PARA(12)=         50.D0  !  LATITUDE, POINT 2
          PARA(13)=          0.D0  !  ZERO
        ELSE IF (IPDP.EQ.47) THEN
          PRINT * , 'Example 47 shows a USGS transformation called the'
          PRINT * , 'Oblique Mercator.  The projection''s center line'
          PRINT * , 'is specified by specifying its azimuth angle.'
          IPRJ=20
          ISPH=-1
          PARA( 1)=          1.D0  !  SEMIMAJOR AXIS OF ELLIPSOID
          PARA( 2)=        .007D0  !  SQUARE OF ELLIPSOID'S ECCENTRICITY
          PARA( 3)=          1.D0  !  SCALE FACTOR AT CENTER OF PROJECTION
          PARA( 4)=         45.D0  !  AZIMUTH ANGLE OF CENTER LINE (E OF N)
          PARA( 5)=       -105.D0  !  LONGITUDE OF ORIGIN OF PROJECTION
          PARA( 6)=         40.D0  !  LATITUDE OF ORIGIN OF PROJECTION
          PARA( 7)=          0.D0  !  FALSE EASTING
          PARA( 8)=          0.D0  !  FALSE NORTHING
          PARA(13)=          1.D0  !  NON-ZERO
        ELSE IF (IPDP.EQ.48) THEN
          PRINT * , 'Example 48 shows a USGS transformation called the'
          PRINT * , 'Robinson, which was developed by the National'
          PRINT * , 'Geographic Society for use in world maps.'
          IPRJ=21
          ISPH=-1
          PARA( 1)=          1.D0  !  RADIUS OF SPHERE OF REFERENCE
          PARA( 5)=       -105.D0  !  LONGITUDE OF CENTRAL MERIDIAN
          PARA( 7)=          0.D0  !  FALSE EASTING
          PARA( 8)=          0.D0  !  FALSE NORTHING
        ELSE IF (IPDP.EQ.49) THEN
          PRINT * , 'Example 49 shows a USGS transformation called the'
          PRINT * , 'Space Oblique Mercator.  Each of the views that'
          PRINT * , 'one can select shows the area passed over by a'
          PRINT * , 'chosen Landsat satellite during a particular'
          PRINT * , 'orbit.'
          IPRJ=22
          PARA( 1)=          0.D0  !  SEMIMAJOR AXIS OF ELLIPSOID
          PARA( 2)=          0.D0  !  SQUARE OF ELLIPSOID'S ECCENTRICITY
          PARA( 3)=          1.D0  !  LANDSAT NUMBER (1-5)
          PARA( 4)=         84.D0  !  PATH (1-251 for LN 1-3, 1-233 for LN 4-5)
          PARA( 7)=          0.D0  !  FALSE EASTING
          PARA( 8)=          0.D0  !  FALSE NORTHING
        ELSE IF (IPDP.EQ.50) THEN
          PRINT * , 'Example 50 shows a USGS transformation called the'
          PRINT * , 'Modified Stereographic for Alaska.  It is centered'
          PRINT * , 'at Lat 64N, Long 152W and stretched in such a way'
          PRINT * , 'as to allow all of Alaska to be shown on a single'
          PRINT * , 'map with relatively little distortion.'
          IPRJ=23
          PARA( 1)=          0.D0  !  SEMIMAJOR AXIS OF ELLIPSOID
          PARA( 2)=          0.D0  !  SQUARE OF ELLIPSOID'S ECCENTRICITY
          PARA( 7)=          0.D0  !  FALSE EASTING
          PARA( 8)=          0.D0  !  FALSE NORTHING
          IDSL=4
          ILLB=-1
        ELSE IF (IPDP.EQ.51) THEN
          PRINT * , 'Example 51 shows the State Plane zones for the'
          PRINT * , 'northeastern states of the lower 48, using the'
          PRINT * , 'North American Datum of 1927.'
          PTYP='ST'
          PLAT=41.
          PLON=-76.
          LTYP='AN'
          PLM1(1)=8.
          PLM2(1)=8.
          PLM3(1)=8.
          PLM4(1)=8.
          IDSL=4
          ISPG=0
          CHSZ=.24
          LABL='STATE PLANE ZONES - NORTHEAST - NAD1927'
          ILLB=-1
        ELSE IF (IPDP.EQ.52) THEN
          PRINT * , 'Example 52 shows the State Plane zones for the'
          PRINT * , 'northeastern states of the lower 48, using the'
          PRINT * , 'North American Datum of 1983.'
          PTYP='ST'
          PLAT=41.
          PLON=-76.
          LTYP='AN'
          PLM1(1)=8.
          PLM2(1)=8.
          PLM3(1)=8.
          PLM4(1)=8.
          IDSL=4
          ISPG=8
          CHSZ=.24
          LABL='STATE PLANE ZONES - NORTHEAST - NAD1983'
          ILLB=-1
        ELSE IF (IPDP.EQ.53) THEN
          PRINT * , 'Example 53 shows the State Plane zones for the'
          PRINT * , 'southeastern states of the lower 48, using the'
          PRINT * , 'North American Datum of 1927.'
          PTYP='ST'
          PLAT=31.
          PLON=-84.
          LTYP='AN'
          PLM1(1)=8.
          PLM2(1)=8.
          PLM3(1)=8.
          PLM4(1)=8.
          IDSL=4
          ISPG=0
          CHSZ=.24
          LABL='STATE PLANE ZONES - SOUTHEAST - NAD1927'
          ILLB=-1
        ELSE IF (IPDP.EQ.54) THEN
          PRINT * , 'Example 54 shows the State Plane zones for the'
          PRINT * , 'southeastern states of the lower 48, using the'
          PRINT * , 'North American Datum of 1983.'
          PTYP='ST'
          PLAT=31.
          PLON=-84.
          LTYP='AN'
          PLM1(1)=8.
          PLM2(1)=8.
          PLM3(1)=8.
          PLM4(1)=8.
          IDSL=4
          ISPG=8
          CHSZ=.24
          LABL='STATE PLANE ZONES - SOUTHEAST - NAD1983'
          ILLB=-1
        ELSE IF (IPDP.EQ.55) THEN
          PRINT * , 'Example 55 shows the State Plane zones for the'
          PRINT * , 'northeast central states of the lower 48, using'
          PRINT * , 'the North American Datum of 1927.'
          PTYP='ST'
          PLAT=42.
          PLON=-92.
          LTYP='AN'
          PLM1(1)=8.
          PLM2(1)=8.
          PLM3(1)=8.
          PLM4(1)=8.
          IDSL=4
          ISPG=0
          CHSZ=.24
          LABL='STATE PLANE ZONES - NORTHEAST CENTRAL - NAD1927'
          ILLB=-1
        ELSE IF (IPDP.EQ.56) THEN
          PRINT * , 'Example 56 shows the State Plane zones for the'
          PRINT * , 'northeast central states of the lower 48, using'
          PRINT * , 'the North American Datum of 1983.'
          PTYP='ST'
          PLAT=42.
          PLON=-92.
          LTYP='AN'
          PLM1(1)=8.
          PLM2(1)=8.
          PLM3(1)=8.
          PLM4(1)=8.
          IDSL=4
          ISPG=8
          CHSZ=.24
          LABL='STATE PLANE ZONES - NORTHEAST CENTRAL - NAD1983'
          ILLB=-1
        ELSE IF (IPDP.EQ.57) THEN
          PRINT * , 'Example 57 shows the State Plane zones for the'
          PRINT * , 'southeast central states of the lower 48, using'
          PRINT * , 'the North American Datum of 1927.'
          PTYP='ST'
          PLAT=33.
          PLON=-92.
          LTYP='AN'
          PLM1(1)=8.
          PLM2(1)=8.
          PLM3(1)=8.
          PLM4(1)=8.
          IDSL=4
          ISPG=0
          CHSZ=.24
          LABL='STATE PLANE ZONES - SOUTHEAST CENTRAL - NAD1927'
          ILLB=-1
        ELSE IF (IPDP.EQ.58) THEN
          PRINT * , 'Example 58 shows the State Plane zones for the'
          PRINT * , 'southeast central states of the lower 48, using'
          PRINT * , 'the North American Datum of 1983.'
          PTYP='ST'
          PLAT=33.
          PLON=-92.
          LTYP='AN'
          PLM1(1)=8.
          PLM2(1)=8.
          PLM3(1)=8.
          PLM4(1)=8.
          IDSL=4
          ISPG=8
          CHSZ=.24
          LABL='STATE PLANE ZONES - SOUTHEAST CENTRAL - NAD1983'
          ILLB=-1
        ELSE IF (IPDP.EQ.59) THEN
          PRINT * , 'Example 59 shows the State Plane zones for the'
          PRINT * , 'northwest central states of the lower 48, using'
          PRINT * , 'the North American Datum of 1927.'
          PTYP='ST'
          PLAT=42.
          PLON=-104.
          LTYP='AN'
          PLM1(1)=8.
          PLM2(1)=8.
          PLM3(1)=8.
          PLM4(1)=8.
          IDSL=4
          ISPG=0
          CHSZ=.24
          LABL='STATE PLANE ZONES - NORTHWEST CENTRAL - NAD1927'
          ILLB=-1
        ELSE IF (IPDP.EQ.60) THEN
          PRINT * , 'Example 60 shows the State Plane zones for the'
          PRINT * , 'northwest central states of the lower 48, using'
          PRINT * , 'the North American Datum of 1983.'
          PTYP='ST'
          PLAT=42.
          PLON=-104.
          LTYP='AN'
          PLM1(1)=8.
          PLM2(1)=8.
          PLM3(1)=8.
          PLM4(1)=8.
          IDSL=4
          ISPG=8
          CHSZ=.24
          LABL='STATE PLANE ZONES - NORTHWEST CENTRAL - NAD1983'
          ILLB=-1
        ELSE IF (IPDP.EQ.61) THEN
          PRINT * , 'Example 61 shows the State Plane zones for the'
          PRINT * , 'southwest central states of the lower 48, using'
          PRINT * , 'the North American Datum of 1927.'
          PTYP='ST'
          PLAT=33.
          PLON=-104.
          LTYP='AN'
          PLM1(1)=8.
          PLM2(1)=8.
          PLM3(1)=8.
          PLM4(1)=8.
          IDSL=4
          ISPG=0
          CHSZ=.24
          LABL='STATE PLANE ZONES - SOUTHWEST CENTRAL - NAD1927'
          ILLB=-1
        ELSE IF (IPDP.EQ.62) THEN
          PRINT * , 'Example 62 shows the State Plane zones for the'
          PRINT * , 'southwest central states of the lower 48, using'
          PRINT * , 'the North American Datum of 1983.'
          PTYP='ST'
          PLAT=33.
          PLON=-104.
          LTYP='AN'
          PLM1(1)=8.
          PLM2(1)=8.
          PLM3(1)=8.
          PLM4(1)=8.
          IDSL=4
          ISPG=8
          CHSZ=.24
          LABL='STATE PLANE ZONES - SOUTHWEST CENTRAL - NAD1983'
          ILLB=-1
        ELSE IF (IPDP.EQ.63) THEN
          PRINT * , 'Example 63 shows the State Plane zones for the'
          PRINT * , 'northwestern states of the lower 48, using the'
          PRINT * , 'North American Datum of 1927.'
          PTYP='ST'
          PLAT=42.
          PLON=-116.
          LTYP='AN'
          PLM1(1)=8.
          PLM2(1)=8.
          PLM3(1)=8.
          PLM4(1)=8.
          IDSL=4
          ISPG=0
          CHSZ=.24
          LABL='STATE PLANE ZONES - NORTHWEST - NAD1927'
          ILLB=-1
        ELSE IF (IPDP.EQ.64) THEN
          PRINT * , 'Example 64 shows the State Plane zones for the'
          PRINT * , 'northwestern states of the lower 48, using the'
          PRINT * , 'North American Datum of 1983.'
          PTYP='ST'
          PLAT=42.
          PLON=-116.
          LTYP='AN'
          PLM1(1)=8.
          PLM2(1)=8.
          PLM3(1)=8.
          PLM4(1)=8.
          IDSL=4
          ISPG=8
          CHSZ=.24
          LABL='STATE PLANE ZONES - NORTHWEST - NAD1983'
          ILLB=-1
        ELSE IF (IPDP.EQ.65) THEN
          PRINT * , 'Example 65 shows the State Plane zones for the'
          PRINT * , 'southwestern states of the lower 48, using the'
          PRINT * , 'North American Datum of 1927.'
          PTYP='ST'
          PLAT=38.
          PLON=-116.
          LTYP='AN'
          PLM1(1)=8.
          PLM2(1)=8.
          PLM3(1)=8.
          PLM4(1)=8.
          IDSL=4
          ISPG=0
          CHSZ=.24
          LABL='STATE PLANE ZONES - SOUTHWEST - NAD1927'
          ILLB=-1
        ELSE IF (IPDP.EQ.66) THEN
          PRINT * , 'Example 66 shows the State Plane zones for the'
          PRINT * , 'southwestern states of the lower 48, using the'
          PRINT * , 'North American Datum of 1983.'
          PTYP='ST'
          PLAT=38.
          PLON=-116.
          LTYP='AN'
          PLM1(1)=8.
          PLM2(1)=8.
          PLM3(1)=8.
          PLM4(1)=8.
          IDSL=4
          ISPG=8
          CHSZ=.24
          LABL='STATE PLANE ZONES - SOUTHWEST - NAD1983'
          ILLB=-1
        ELSE IF (IPDP.EQ.67) THEN
          PRINT * , 'Example 67 shows the State Plane zones for Alaska,'
          PRINT * , 'using the North American Datum of 1927.'
          PTYP='ST'
          PLAT=64.
          PLON=-152.
          LTYP='AN'
          PLM1(1)=23.
          PLM2(1)=15.
          PLM3(1)=19.
          PLM4(1)=19.
          IDSL=4
          ISPG=0
          CHSZ=.75
          LABL='STATE PLANE ZONES - ALASKA - NAD1927'
          ILLB=-1
        ELSE IF (IPDP.EQ.68) THEN
          PRINT * , 'Example 68 shows the State Plane zones for Alaska,'
          PRINT * , 'using the North American Datum of 1983.'
          PTYP='ST'
          PLAT=64.
          PLON=-152.
          LTYP='AN'
          PLM1(1)=23.
          PLM2(1)=15.
          PLM3(1)=19.
          PLM4(1)=19.
          IDSL=4
          ISPG=8
          CHSZ=.75
          LABL='STATE PLANE ZONES - ALASKA - NAD1983'
          ILLB=-1
        ELSE IF (IPDP.EQ.69) THEN
          PRINT * , 'Example 69 shows the State Plane zones for Hawaii,'
          PRINT * , 'using the North American Datum of 1927.'
          PTYP='ST'
          PLAT=21.
          PLON=-157.5
          LTYP='AN'
          PLM1(1)=3.
          PLM2(1)=3.
          PLM3(1)=3.
          PLM4(1)=3.
          IDSL=4
          ISPG=0
          CHSZ=.075
          LABL='STATE PLANE ZONES - HAWAII - NAD1927'
          ILLB=-1
        ELSE IF (IPDP.EQ.70) THEN
          PRINT * , 'Example 70 shows the State Plane zones for Hawaii,'
          PRINT * , 'using the North American Datum of 1927.'
          PTYP='ST'
          PLAT=21.
          PLON=-157.5
          LTYP='AN'
          PLM1(1)=3.
          PLM2(1)=3.
          PLM3(1)=3.
          PLM4(1)=3.
          IDSL=4
          ISPG=8
          CHSZ=.075
          LABL='STATE PLANE ZONES - HAWAII - NAD1983'
          ILLB=-1
        ELSE IF (IPDP.EQ.71) THEN
          PRINT * , 'Example 71 shows all the State Plane zones, using'
          PRINT * , 'the North American Datum of 1927.'
          PTYP='LE'
          PLAT=40.
          PLON=-140.
          LTYP='AN'
          PLM1(1)=70.
          PLM2(1)=70.
          PLM3(1)=70.
          PLM4(1)=70.
          IDSL=4
          ISPG=0
          CHSZ=1.75
          LABL='STATE PLANE ZONES - ALL - NAD1927'
        ELSE IF (IPDP.EQ.72) THEN
          PRINT * , 'Example 72 shows all the State Plane zones, using'
          PRINT * , 'the North American Datum of 1983.'
          PTYP='LE'
          PLAT=45.
          PLON=-112.
          LTYP='AN'
          PLM1(1)=48.
          PLM2(1)=48.
          PLM3(1)=48.
          PLM4(1)=48.
          IDSL=4
          ISPG=8
          CHSZ=1.7
          LABL='STATE PLANE ZONES - ALL - NAD1983'
        END IF
C
        IF (IPDP.GE.51.AND.IPDP.LE.72) THEN
          PRINT * , ' '
          PRINT * , 'The area for which each of the State Plane zones'
          PRINT * , 'shown is meant to be used is shown as a rectangle'
          PRINT * , 'with rounded corners, so that one can more easily'
          PRINT * , 'sort out how the zones overlap.  Each zone number'
          PRINT * , 'is approximately centered within its zone.'
        END IF
C
        IF (IDSL.EQ.1) THEN
          IF (ODNM.NE.'E1'.AND.ODNM.NE.'E2'.AND.
     +        ODNM.NE.'E3'.AND.ODNM.NE.'E4') THEN
            ODNM='CO'
          ELSE
            ILVL=1
          END IF
        ELSE
          IF (ODNM.NE.'E1'.AND.ODNM.NE.'E2'.AND.
     +        ODNM.NE.'E3'.AND.ODNM.NE.'E4') THEN
            ODNM='PS'
          ELSE
            ILVL=4
          END IF
        END IF
C
        IPDP=MOD(IPDP,72)+1
C
        RETURN
C
      END


      SUBROUTINE DRPTLB (PTYP,IPRJ,IZON,ISPH,PARA,IPRF,ODNM,ILVL)
C
        CHARACTER*(*) PTYP,ODNM
        DOUBLE PRECISION PARA(15)
C
        CHARACTER*82 PTLB
C
        PTLB=' '
C
        IF      (PTYP.EQ.'LC') THEN
          PTLB='LAMBERT CONFORMAL CONIC'
        ELSE IF (PTYP.EQ.'GN') THEN
          PTLB='GNOMONIC'
        ELSE IF (PTYP.EQ.'ME') THEN
          PTLB='MERCATOR'
        ELSE IF (PTYP.EQ.'RM') THEN
          PTLB='ROTATED MERCATOR'
        ELSE IF (PTYP.EQ.'ST') THEN
          PTLB='STEREOGRAPHIC'
        ELSE IF (PTYP.EQ.'LE') THEN
          PTLB='LAMBERT EQUAL-AREA'
        ELSE IF (PTYP.EQ.'OR') THEN
          PTLB='ORTHOGRAPHIC'
        ELSE IF (PTYP.EQ.'SV') THEN
          PTLB='SATELLITE-VIEW'
        ELSE IF (PTYP.EQ.'AE') THEN
          PTLB='AZIMUTHAL EQUIDISTANT'
        ELSE IF (PTYP.EQ.'RO') THEN
          PTLB='ROBINSON'
        ELSE IF (PTYP.EQ.'MT') THEN
          PTLB='"MOLLWEIDE-TYPE"'
        ELSE IF (PTYP.EQ.'CE') THEN
          PTLB='CYLINDRICAL EQUIDISTANT'
        ELSE IF (PTYP.EQ.'ER') THEN
          PTLB='EQUIRECTANGULAR'
        ELSE IF (PTYP.EQ.'EA') THEN
          PTLB='CYLINDRICAL EQUAL-AREA'
        ELSE IF (PTYP.EQ.'AI') THEN
          PTLB='AITOFF'
        ELSE IF (PTYP.EQ.'HA') THEN
          PTLB='HAMMER'
        ELSE IF (PTYP.EQ.'MO') THEN
          PTLB='MOLLWEIDE'
        ELSE IF (PTYP.EQ.'WT') THEN
          PTLB='WINKEL TRIPEL'
        ELSE IF (PTYP.EQ.'UT') THEN
          IF (IPRJ.EQ.1) THEN
            IF (IZON.GT.0) THEN
              PTLB='USGS - UTM COORDINATES - Zone 00 - North'
            ELSE
              PTLB='USGS - UTM COORDINATES - Zone 00 - South'
            END IF
            CALL PUTINT (PTLB(31:32),IZON)
          ELSE IF (IPRJ.EQ.2) THEN
            PTLB( 1:38)='USGS - STATE PLANE COORDINATES (XX) - '
            PTLB(39:57)='NAD0000 - Zone 0000'
            IF (IPRF.EQ.4) THEN
              PTLB(33:34)='LC'
            ELSE IF (IPRF.EQ.7) THEN
              PTLB(33:34)='PC'
            ELSE IF (IPRF.EQ.9) THEN
              PTLB(33:34)='TM'
            ELSE IF (IPRF.EQ.20) THEN
              PTLB(33:34)='OM'
            END IF
            IF (ISPH.EQ.0) THEN
              PTLB(42:45)='1927'
            ELSE
              PTLB(42:45)='1983'
            END IF
            CALL PUTINT (PTLB(54:57),IZON)
          ELSE IF (IPRJ.EQ.3) THEN
            IF (PARA(3)+PARA(4).GT.0.D0) THEN
              PTLB='USGS - ALBER''S EQUAL-AREA CONIC - North'
            ELSE
              PTLB='USGS - ALBER''S EQUAL-AREA CONIC - South'
            END IF
          ELSE IF (IPRJ.EQ.4) THEN
            IF (PARA(3)+PARA(4).GT.0.D0) THEN
                PTLB='USGS - LAMBERT CONFORMAL CONIC - North'
            ELSE
                PTLB='USGS - LAMBERT CONFORMAL CONIC - South'
            END IF
          ELSE IF (IPRJ.EQ.5) THEN
            PTLB='USGS - MERCATOR'
          ELSE IF (IPRJ.EQ.6) THEN
            IF (PARA(6).GT.0.D0) THEN
              PTLB='USGS - POLAR STEREOGRAPHIC - North'
            ELSE
              PTLB='USGS - POLAR STEREOGRAPHIC - South'
            END IF
          ELSE IF (IPRJ.EQ.7) THEN
            PTLB='USGS - POLYCONIC'
          ELSE IF (IPRJ.EQ.8) THEN
            IF (PARA(9).EQ.0.D0) THEN
              IF (PARA(3).GT.0.D0) THEN
                PTLB='USGS - EQUIDISTANT CONIC - Type A - North'
              ELSE
                PTLB='USGS - EQUIDISTANT CONIC - Type A - South'
              END IF
            ELSE
              IF (PARA(3)+PARA(4).GT.0.D0) THEN
                PTLB='USGS - EQUIDISTANT CONIC - Type B - North'
              ELSE
                PTLB='USGS - EQUIDISTANT CONIC - Type B - South'
              END IF
            END IF
          ELSE IF (IPRJ.EQ.9) THEN
            PTLB='USGS - TRANSVERSE MERCATOR'
          ELSE IF (IPRJ.EQ.10) THEN
            PTLB='USGS - STEREOGRAPHIC'
          ELSE IF (IPRJ.EQ.11) THEN
            PTLB='USGS - LAMBERT EQUAL-AREA'
          ELSE IF (IPRJ.EQ.12) THEN
            PTLB='USGS - AZIMUTHAL EQUIDISTANT'
          ELSE IF (IPRJ.EQ.13) THEN
            PTLB='USGS - GNOMONIC'
          ELSE IF (IPRJ.EQ.14) THEN
            PTLB='USGS - ORTHOGRAPHIC'
          ELSE IF (IPRJ.EQ.15) THEN
            PTLB='USGS - PERSPECTIVE'
          ELSE IF (IPRJ.EQ.16) THEN
            PTLB='USGS - SINUSOIDAL'
          ELSE IF (IPRJ.EQ.17) THEN
            PTLB='USGS - EQUIRECTANGULAR'
          ELSE IF (IPRJ.EQ.18) THEN
            PTLB='USGS - MILLER CYLINDRICAL'
          ELSE IF (IPRJ.EQ.19) THEN
            PTLB='USGS - VAN DER GRINTEN I'
          ELSE IF (IPRJ.EQ.20) THEN
            IF (PARA(13).EQ.0.D0) THEN
              PTLB='USGS - OBLIQUE MERCATOR - Type A'
            ELSE
              PTLB='USGS - OBLIQUE MERCATOR - Type B'
            END IF
          ELSE IF (IPRJ.EQ.21) THEN
            PTLB='USGS - ROBINSON'
          ELSE IF (IPRJ.EQ.22) THEN
            PTLB='USGS - SPACE OBLIQUE MERCATOR'
          ELSE IF (IPRJ.EQ.23) THEN
            PTLB='USGS - MODIFIED STEREOGRAPHIC FOR ALASKA'
          END IF
        END IF
C
C Add the dataset specifier.
C
        ILST=MPILNB(PTLB)
        PTLB(ILST+ 1:ILST+12)=' - Database '
        PTLB(ILST+13:ILST+14)=ODNM(1:2)
        ILST=ILST+14
        IF (ODNM.EQ.'E1'.OR.ODNM.EQ.'E2'.OR.
     +      ODNM.EQ.'E3'.OR.ODNM.EQ.'E4') THEN
          PTLB(ILST+1:ILST+10)=' at level '
          CALL PUTINT (PTLB(ILST+11:ILST+11),ILVL)
          ILST=ILST+11
        END IF
C
        IF (PTLB.NE.' ') CALL PLCHHQ (CFUX(.5),CFUY(.05),PTLB(1:ILST),
     +                                                     .012,0.,0.)
C
        RETURN
C
      END


      SUBROUTINE PUTINT (CHRS,IVAL)
        CHARACTER*(*) CHRS
        CHARACTER*10 DGTS
        DATA DGTS / '0123456789' /
        IIII=ABS(IVAL)
        DO 101 I=LEN(CHRS),1,-1
          IDIG=MOD(IIII,10)+1
          CHRS(I:I)=DGTS(IDIG:IDIG)
          IIII=IIII/10
  101   CONTINUE
        RETURN
      END


      SUBROUTINE DRAWSP (ICLR,PLAT,PLON,NOTA)
C
C Draw a spiral, in the color specified by ICLR, which starts at the
C point with latitude PLAT and longitude PLON and ends at the point
C opposite it on the globe.  NOTA is the number of times the spiral
C winds around the globe.
C
        NPTS=720*NOTA-1
C
        RDIV=REAL(NPTS+1)
C
        CALL SFLUSH
        CALL GSPLCI (ICLR)
C
        DO 101 IPNT=0,NPTS+1
          RLAT=-90.+180.*REAL(IPNT)/RDIV
          RLON=.5*REAL(MOD(IPNT,720))
          CALL ROTATE (2,-PLAT-90.,RLAT,RLON)
          CALL ROTATE (3, PLON    ,RLAT,RLON)
          IF (IPNT.EQ.0) THEN
            CALL MAPIT (RLAT,RLON,0)
          ELSE IF (IPNT.LE.NPTS) THEN
            CALL MAPIT (RLAT,RLON,1)
          ELSE
            CALL MAPIT (RLAT,RLON,2)
          END IF
  101   CONTINUE
C
        CALL SFLUSH
        CALL GSPLCI (1)
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE ROTATE (IAXS,ANGL,RLAT,RLON)
C
C Define multiplicative constants to convert from degrees to radians
C and from radians to degrees.
C
        DATA DTOR / .017453292519943 /
        DATA RTOD / 57.2957795130823 /
C
C This routine rotates the point with latitude RLAT and longitude RLON
C by the angle ANGL about the axis specified by IAXS (1 for the U axis,
C 2 for the V axis, 3 for the W axis).  A right-handed coordinate system
C is assumed.
C
        UCRD=COS(DTOR*RLAT)*COS(DTOR*RLON)
        VCRD=COS(DTOR*RLAT)*SIN(DTOR*RLON)
        WCRD=SIN(DTOR*RLAT)
C
        SINA=SIN(DTOR*ANGL)
        COSA=COS(DTOR*ANGL)
C
        UTMP=UCRD
        VTMP=VCRD
        WTMP=WCRD
C
        IF (IAXS.EQ.1) THEN
          VCRD=VTMP*COSA-WTMP*SINA
          WCRD=WTMP*COSA+VTMP*SINA
        ELSE IF (IAXS.EQ.2) THEN
          UCRD=UTMP*COSA+WTMP*SINA
          WCRD=WTMP*COSA-UTMP*SINA
        ELSE
          UCRD=UTMP*COSA-VTMP*SINA
          VCRD=VTMP*COSA+UTMP*SINA
        END IF
C
        RLAT=RTOD*ASIN(WCRD)
        RLON=RTOD*ATAN2(VCRD,UCRD)
C
        RETURN
C
      END


      SUBROUTINE CONINV (ICLR,NPTS)
C
C Declare one of the USGS code's common blocks to gain access to its
C error flag.
C
        COMMON /ERRMZ0/ IERR
        SAVE   /ERRMZ0/
C
C Declare the arrays required for contouring values returned by MAPTRI.
C
        PARAMETER (MPTS=501,LRWK=10000,LIWK=10000)
C
        DIMENSION RLAT(MPTS,MPTS),RLON(MPTS,MPTS),RWRK(LRWK),IWRK(LIWK)
C
        CALL CPSETR ('VPL - VIEWPORT LEFT  ',0.)
        CALL CPSETR ('VPR - VIEWPORT RIGHT ',1.)
        CALL CPSETR ('VPB - VIEWPORT BOTTOM',0.)
        CALL CPSETR ('VPT - VIEWPORT TOP   ',1.)
        CALL CPSETI ('CLS - CONTOUR LEVEL SELECTOR',1)
        CALL CPSETI ('CIS - CONTOUR INTERVAL SELECTOR',5)
        CALL CPSETI ('LIS - LABEL INTERVAL SELECTOR',100)
        CALL CPSETR ('SPV - SPECIAL VALUE',1.E12)
        CALL CPSETI ('RWC - REAL WORKSPACE FOR CONTOURS',5000)
        CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',-2)
        CALL CPSETI ('CLU - CONTOUR LEVEL USE FLAG',1)
C
        CALL SFLUSH
        CALL GSPLCI (ICLR)
        CALL GSTXCI (ICLR)
        CALL GSMKSC (50./REAL(NPTS-1))
C
        DO 102 I=1,NPTS
          XVAL=CFUX(REAL(I-1)/REAL(NPTS-1))
          DO 101 J=1,NPTS
            YVAL=CFUY(REAL(J-1)/REAL(NPTS-1))
            IERR=0
            CALL MAPTRI (XVAL,YVAL,RLAT(I,J),RLON(I,J))
            IF (RLAT(I,J).EQ.1.E12) THEN
              IF (IERR.EQ.0) THEN
                CALL GSPMCI (4)
                CALL GPM (1,XVAL,YVAL)
              ELSE IF (IERR.EQ.1) THEN
                CALL GSPMCI (5)
                CALL GPM (1,XVAL,YVAL)
              ELSE
                CALL GSPMCI (6)
                CALL GPM (1,XVAL,YVAL)
              END IF
            ELSE
              IF (ABS(RLAT(I,J)).GT. 90..OR.ABS(RLON(I,J)).GT.180.) THEN
                RLAT(I,J)=1.E12
                RLON(I,J)=1.E12
                CALL GSPMCI (7)
                CALL GPM (1,XVAL,YVAL)
              END IF
            END IF
  101     CONTINUE
  102   CONTINUE
C
        CALL CPRECT (RLAT,MPTS,NPTS,NPTS,RWRK,LRWK,IWRK,LIWK)
        CALL CPCLDR (RLAT,RWRK,IWRK)
        CALL CPRECT (RLON,MPTS,NPTS,NPTS,RWRK,LRWK,IWRK,LIWK)
        CALL CPCLDR (RLON,RWRK,IWRK)
C
        CALL SFLUSH
        CALL GSPLCI (1)
        CALL GSTXCI (1)
        CALL GSMKSC (1.)
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE MDRGDI (DINM)
C
C This is a user-replaceable routine that returns the name of the
C directory in which the RANGS/GSHHS data files have been placed.
C
        CHARACTER*(*) DINM
C
C Declare a common block in which the directory name will be passed.
C
        COMMON /EDRGDI/ USNM
          CHARACTER*60 USNM
        SAVE   /EDRGDI/
C
C Return the name of the directory.
C
        DINM=USNM
C
C Done.
C
        RETURN
C
      END


      FUNCTION IGETAI (IAMA,XCOP,YCOP,IAAI,IAGI,MNAI,NOAI,IGRP)
C
C This function retrieves from an area map the area identifier, relative
C to group IGRP, of the area containing the point (XCOP,YCOP).
C
        DIMENSION IAAI(MNAI),IAGI(MNAI)
C
        CALL ARGTAI (IAMA,XCOP,YCOP,IAAI,IAGI,MNAI,NOAI,1)
C
        DO 101 I=1,MNAI
          IF (IAGI(I).EQ.IGRP) THEN
            IGETAI=IAAI(I)
            RETURN
          END IF
  101   CONTINUE
C
        IGETAI=-1
        RETURN
C
      END

C
C       $Id: vvgetr.f,v 1.17 2008-07-27 00:17:35 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
C
C-----------------------------------------------------------------------
C
      SUBROUTINE VVGETR (CNM,RVL)
C
      CHARACTER*(*) CNM
C
C This subroutine is called to retrieve the real value of a specified
C parameter.
C
C CNM is the name of the parameter whose value is to be retrieved.
C
C RVL is a real variable in which the desired value is to be returned
C by VVGETR.
C
C ---------------------------------------------------------------------
C
C NOTE:
C Since implicit typing is used for all real and integer variables
C a consistent length convention has been adopted to help clarify the
C significance of the variables encountered in the code for this 
C utility. All local variable and subroutine parameter identifiers 
C are limited to 1,2,or 3 characters. Four character names identify  
C members of common blocks. Five and 6 character variable names 
C denote PARAMETER constants or subroutine or function names.
C
C Declare the VV common blocks.
C
C IPLVLS - Maximum number of color threshold level values
C IPAGMX - Maximum number of area groups allowed in the area map
C
      PARAMETER (IPLVLS = 256, IPAGMX = 64)
C
C Integer and real common block variables
C
C
      COMMON /VVCOM/
     +                IUD1       ,IVD1       ,IPD1       ,IXDM       ,
     +                IYDN       ,VLOM       ,VHIM       ,ISET       ,
     +                VRMG       ,VRLN       ,VFRC       ,IXIN       ,
     +                IYIN       ,ISVF       ,UUSV       ,UVSV       ,
     +                UPSV       ,IMSK       ,ICPM       ,UVPS       ,
     +                UVPL       ,UVPR       ,UVPB       ,UVPT       ,
     +                UWDL       ,UWDR       ,UWDB       ,UWDT       ,
     +                UXC1       ,UXCM       ,UYC1       ,UYCN       ,
     +                NLVL       ,IPAI       ,ICTV       ,WDLV       ,
     +                UVMN       ,UVMX       ,PMIN       ,PMAX       ,
     +                RVMN       ,RVMX       ,RDMN       ,RDMX       ,
     +                ISPC       ,RVMD       ,IPLR       ,IVST       ,
     +                IVPO       ,ILBL       ,IDPF       ,IMSG       ,
     +                ICLR(IPLVLS)           ,TVLU(IPLVLS)
C
C Arrow size/shape parameters
C
        COMMON / VVARO /
     +                HDSZ       ,HINF       ,HANG       ,IAST       ,
     +                HSIN       ,HCOS       ,FAMN       ,FAMX       ,
     +                UVMG       ,FAIR       ,FAWR       ,FAWF       ,
     +                FAXR       ,FAXF       ,FAYR       ,FAYF       ,
     +                AROX(8)    ,AROY(8)    ,FXSZ       ,FYSZ       ,
     +                FXRF       ,FXMN       ,FYRF       ,FYMN       ,
     +                FWRF       ,FWMN       ,FIRF       ,FIMN       ,
     +                AXMN       ,AXMX       ,AYMN       ,AYMX       ,
     +                IACM       ,IAFO       ,WBAD       ,WBTF       ,
     +                WBCF       ,WBDF       ,WBSC
C
C
C Text related parameters
C
        COMMON /VVTXP /
     +                FCWM    ,ICSZ    ,
     +                FMNS    ,FMNX    ,FMNY    ,IMNP    ,IMNC  ,
     +                FMXS    ,FMXX    ,FMXY    ,IMXP    ,IMXC  ,
     +                FZFS    ,FZFX    ,FZFY    ,IZFP    ,IZFC  ,
     +                FILS    ,FILX    ,FILY    ,IILP    ,IILC  ,
     +                FLBS    ,ILBC

C
C Character variable declartions
C
      CHARACTER*160 CSTR
      PARAMETER (IPCHSZ=36)
      CHARACTER*(IPCHSZ)  CMNT,CMXT,CZFT,CLBT,CILT
C
C Text string parameters
C
      COMMON /VVCHAR/ CSTR,CMNT,CMXT,CZFT,CLBT,CILT
C
      SAVE /VVCOM/, /VVARO/, /VVTXP/, /VVCHAR/
C
C The mapping common block: made available to user mapping routines
C
      COMMON /VVMAP/
     +                IMAP       ,
     +                XVPL       ,XVPR       ,YVPB       ,YVPT       ,
     +                WXMN       ,WXMX       ,WYMN       ,WYMX       ,
     +                XLOV       ,XHIV       ,YLOV       ,YHIV       ,
     +                SXDC       ,SYDC       ,NXCT       ,NYCT       ,
     +                RLEN       ,LNLG       ,INVX       ,INVY       ,
     +                ITRT       ,IWCT       ,FW2W       ,FH2H       ,
     +                DVMN       ,DVMX       ,RBIG       ,IBIG
C
      SAVE /VVMAP/
C
C Math constants
C
      PARAMETER (PDTOR  = 0.017453292519943,
     +           PRTOD  = 57.2957795130823,
     +           P1XPI  = 3.14159265358979,
     +           P2XPI  = 6.28318530717959,
     +           P1D2PI = 1.57079632679489,
     +           P5D2PI = 7.85398163397448) 
C
C --------------------------------------------------------------------
C
C Check for a parameter name that is too short.
C
      IF (LEN(CNM).LT.3) THEN
        CSTR(1:46)='VVGETI OR VVGETR - PARAMETER NAME TOO SHORT - '
        CSTR(47:46+LEN(CNM))=CNM
        CALL SETER (CSTR(1:46+LEN(CNM)),1,1)
        RETURN
      END IF
C
C Check for incorrect use of the index parameter.
C
      IF (CNM(1:3).EQ.'CLR'.OR.CNM(1:3).EQ.'clr'
     +    .OR.CNM(1:3).EQ.'TVL'.OR.CNM(1:3).EQ.'tvl') THEN
         IF (IPAI.LT.1.OR.IPAI.GT.NLVL) THEN
            CSTR(1:46)='VVGETI OR VVGETR - GETTING XXX - PAI INCORRECT'
            CSTR(28:30)=CNM(1:3)
            CALL SETER (CSTR(1:46),2,1)
            RETURN
         END IF
      END IF
C
C Get the appropriate parameter value.
C
C Values in VVCOM
C
      IF (CNM(1:3).EQ.'UD1'.OR. CNM(1:3).EQ.'ud1') THEN
         RVL=REAL(IUD1)
      ELSE IF (CNM(1:3).EQ.'VD1'.OR. CNM(1:3).EQ.'vd1') THEN
         RVL=REAL(IVD1)
      ELSE IF (CNM(1:3).EQ.'PD1'.OR. CNM(1:3).EQ.'pd1') THEN
         RVL=REAL(IPD1)
      ELSE IF (CNM(1:3).EQ.'XDM'.OR. CNM(1:3).EQ.'xdm') THEN
         RVL=REAL(IXDM)
      ELSE IF (CNM(1:3).EQ.'YDN'.OR. CNM(1:3).EQ.'ydn') THEN
         RVL=REAL(IYDN)
      ELSE IF (CNM(1:3).EQ.'VLC'.OR.CNM(1:3).EQ.'vlc') THEN
        RVL=VLOM
      ELSE IF (CNM(1:3).EQ.'VHC'.OR.CNM(1:3).EQ.'vhc') THEN
        RVL=VHIM
      ELSE IF (CNM(1:3).EQ.'SET'.OR. CNM(1:3).EQ.'set') THEN
         RVL=REAL(ISET)
      ELSE IF (CNM(1:3).EQ.'VRM'.OR. CNM(1:3).EQ.'vrm') THEN
         RVL=VRMG
      ELSE IF (CNM(1:3).EQ.'VRL'.OR. CNM(1:3).EQ.'vrl') THEN
         RVL=VRLN
      ELSE IF (CNM(1:3).EQ.'VFR'.OR. CNM(1:3).EQ.'vfr') THEN
         RVL=VFRC
      ELSE IF (CNM(1:3).EQ.'XIN'.OR. CNM(1:3).EQ.'xin') THEN
         RVL=REAL(IXIN)
      ELSE IF (CNM(1:3).EQ.'YIN'.OR. CNM(1:3).EQ.'yin') THEN
         RVL=REAL(IYIN)
      ELSE IF (CNM(1:3).EQ.'SVF'.OR. CNM(1:3).EQ.'svf') THEN
         RVL=REAL(ISVF)
      ELSE IF (CNM(1:3).EQ.'USV'.OR.CNM(1:3).EQ.'usv') THEN
         RVL=UUSV
      ELSE IF (CNM(1:3).EQ.'VSV'.OR.CNM(1:3).EQ.'vsv') THEN
         RVL=UVSV
      ELSE IF (CNM(1:3).EQ.'PSV'.OR.CNM(1:3).EQ.'psv') THEN
         RVL=UPSV
      ELSE IF (CNM(1:3).EQ.'CPM'.OR. CNM(1:3).EQ.'cpm') THEN
         RVL=REAL(ICPM)
      ELSE IF (CNM(1:3).EQ.'WML'.OR. CNM(1:3).EQ.'wml') THEN
         RVL=RLEN
      ELSE IF (CNM(1:3).EQ.'MSK'.OR. CNM(1:3).EQ.'msk') THEN
         RVL=REAL(IMSK)
      ELSE IF (CNM(1:3).EQ.'VPS'.OR. CNM(1:3).EQ.'vps') THEN
         RVL=REAL(UVPS)
      ELSE IF (CNM(1:3).EQ.'VPL'.OR.CNM(1:3).EQ.'vpl') THEN
         RVL=UVPL
      ELSE IF (CNM(1:3).EQ.'VPR'.OR.CNM(1:3).EQ.'vpr') THEN
         RVL=UVPR
      ELSE IF (CNM(1:3).EQ.'VPB'.OR.CNM(1:3).EQ.'vpb') THEN
         RVL=UVPB
      ELSE IF (CNM(1:3).EQ.'VPT'.OR.CNM(1:3).EQ.'vpt') THEN
         RVL=UVPT
      ELSE IF (CNM(1:3).EQ.'WDL'.OR.CNM(1:3).EQ.'wdl') THEN
         RVL=UWDL
      ELSE IF (CNM(1:3).EQ.'WDR'.OR.CNM(1:3).EQ.'wdr') THEN
         RVL=UWDR
      ELSE IF (CNM(1:3).EQ.'WDB'.OR.CNM(1:3).EQ.'wdb') THEN
         RVL=UWDB
      ELSE IF (CNM(1:3).EQ.'WDT'.OR.CNM(1:3).EQ.'wdt') THEN
         RVL=UWDT
      ELSE IF (CNM(1:3).EQ.'XC1'.OR.CNM(1:3).EQ.'xc1') THEN
         RVL=UXC1
      ELSE IF (CNM(1:3).EQ.'XCM'.OR.CNM(1:3).EQ.'xcm') THEN
         RVL=UXCM
      ELSE IF (CNM(1:3).EQ.'YC1'.OR.CNM(1:3).EQ.'yc1') THEN
         RVL=UYC1
      ELSE IF (CNM(1:3).EQ.'YCN'.OR.CNM(1:3).EQ.'ycn') THEN
         RVL=UYCN
      ELSE IF (CNM(1:3).EQ.'NLV'.OR.CNM(1:3).EQ.'nlv') THEN
        RVL=REAL(NLVL)
      ELSE IF (CNM(1:3).EQ.'PAI'.OR.CNM(1:3).EQ.'pai') THEN
        RVL=REAL(IPAI)
      ELSE IF (CNM(1:3).EQ.'CTV'.OR.CNM(1:3).EQ.'ctv') THEN
        RVL=REAL(ICTV)
      ELSE IF (CNM(1:3).EQ.'LWD'.OR.CNM(1:3).EQ.'lwd') THEN
        RVL=WDLV
      ELSE IF (CNM(1:3).EQ.'VMN'.OR.CNM(1:3).EQ.'vmn') THEN
        RVL=RVMN
      ELSE IF (CNM(1:3).EQ.'VMX'.OR.CNM(1:3).EQ.'vmx') THEN
        RVL=RVMX
      ELSE IF (CNM(1:3).EQ.'DMN'.OR.CNM(1:3).EQ.'dmn') THEN
        RVL=RDMN
      ELSE IF (CNM(1:3).EQ.'DMX'.OR.CNM(1:3).EQ.'dmx') THEN
        RVL=RDMX
      ELSE IF (CNM(1:3).EQ.'PMN'.OR.CNM(1:3).EQ.'pmn') THEN
        RVL=PMIN
      ELSE IF (CNM(1:3).EQ.'PMX'.OR.CNM(1:3).EQ.'pmx') THEN
        RVL=PMAX
      ELSE IF (CNM(1:3).EQ.'SPC'.OR. CNM(1:3).EQ.'spc') THEN
         RVL=REAL(ISPC)
      ELSE IF (CNM(1:3).EQ.'VMD'.OR. CNM(1:3).EQ.'vmd') THEN
         RVL=RVMD
      ELSE IF (CNM(1:3).EQ.'MAP'.OR. CNM(1:3).EQ.'map') THEN
         RVL=REAL(IMAP)
      ELSE IF (CNM(1:3).EQ.'PLR'.OR. CNM(1:3).EQ.'plr') THEN
         RVL=REAL(IPLR)
      ELSE IF (CNM(1:3).EQ.'VST'.OR. CNM(1:3).EQ.'vst') THEN
         RVL=REAL(IVST)
      ELSE IF (CNM(1:3).EQ.'VPO'.OR. CNM(1:3).EQ.'vpo') THEN
         RVL=REAL(IVPO)
      ELSE IF (CNM(1:3).EQ.'LBL'.OR. CNM(1:3).EQ.'lbl') THEN
         RVL=REAL(ILBL)
      ELSE IF (CNM(1:3).EQ.'DPF'.OR. CNM(1:3).EQ.'dpf') THEN
         RVL=REAL(IDPF)
C
C arrow parameters
C
      ELSE IF (CNM(1:3).EQ.'AMN'.OR.CNM(1:3).EQ.'amn') THEN
         RVL=FAMN
      ELSE IF (CNM(1:3).EQ.'AMX'.OR.CNM(1:3).EQ.'amx') THEN
         RVL=FAMX
      ELSE IF (CNM(1:3).EQ.'AST'.OR.CNM(1:3).EQ.'ast') THEN
         RVL=REAL(IAST)
      ELSE IF (CNM(1:3).EQ.'AIR'.OR.CNM(1:3).EQ.'air') THEN
         RVL=FAIR
      ELSE IF (CNM(1:3).EQ.'AWR'.OR.CNM(1:3).EQ.'awr') THEN
         RVL=FAWR
      ELSE IF (CNM(1:3).EQ.'AWF'.OR.CNM(1:3).EQ.'awf') THEN
         RVL=FAWF
      ELSE IF (CNM(1:3).EQ.'AXR'.OR.CNM(1:3).EQ.'axr') THEN
         RVL=FAXR
      ELSE IF (CNM(1:3).EQ.'AXF'.OR.CNM(1:3).EQ.'axf') THEN
         RVL=FAXF
      ELSE IF (CNM(1:3).EQ.'AYR'.OR.CNM(1:3).EQ.'ayr') THEN
         RVL=FAYR
      ELSE IF (CNM(1:3).EQ.'AYF'.OR.CNM(1:3).EQ.'ayf') THEN
         RVL=FAYF
      ELSE IF (CNM(1:3).EQ.'ACM'.OR.CNM(1:3).EQ.'acm') THEN
         RVL=REAL(IACM)
      ELSE IF (CNM(1:3).EQ.'AFO'.OR.CNM(1:3).EQ.'afo') THEN
         RVL=REAL(IAFO)
C
C wind barb parameters
C
      ELSE IF (CNM(1:3).EQ.'WBA'.OR.CNM(1:3).EQ.'wba') THEN
         RVL=WBAD
      ELSE IF (CNM(1:3).EQ.'WBT'.OR.CNM(1:3).EQ.'wbt') THEN
         RVL=WBTF
      ELSE IF (CNM(1:3).EQ.'WBC'.OR.CNM(1:3).EQ.'wbc') THEN
         RVL=WBCF
      ELSE IF (CNM(1:3).EQ.'WBD'.OR.CNM(1:3).EQ.'wbd') THEN
         RVL=WBDF
      ELSE IF (CNM(1:3).EQ.'WBS'.OR.CNM(1:3).EQ.'wbs') THEN
         RVL=WBSC
C
C character multiplier
C
      ELSE IF (CNM(1:3).EQ.'CWM'.OR.CNM(1:3).EQ.'cwm') THEN
        RVL=FCWM
C
C character attributes
C
      ELSE IF (CNM(1:3).EQ.'MNS'.OR.CNM(1:3).EQ.'mns') THEN
         RVL=FMNS
      ELSE IF (CNM(1:3).EQ.'MNX'.OR.CNM(1:3).EQ.'mnx') THEN
         RVL=FMNX
      ELSE IF (CNM(1:3).EQ.'MNY'.OR.CNM(1:3).EQ.'mny') THEN
         RVL=FMNY
      ELSE IF (CNM(1:3).EQ.'MNP'.OR. CNM(1:3).EQ.'mnp') THEN
         RVL=REAL(IMNP)
      ELSE IF (CNM(1:3).EQ.'MNC'.OR. CNM(1:3).EQ.'mnc') THEN
         RVL=REAL(IMNC)
C
      ELSE IF (CNM(1:3).EQ.'MXS'.OR.CNM(1:3).EQ.'mxs') THEN
         RVL=FMXS
      ELSE IF (CNM(1:3).EQ.'MXX'.OR.CNM(1:3).EQ.'mxx') THEN
         RVL=FMXX
      ELSE IF (CNM(1:3).EQ.'MXY'.OR.CNM(1:3).EQ.'mxy') THEN
         RVL=FMXY
      ELSE IF (CNM(1:3).EQ.'MXP'.OR. CNM(1:3).EQ.'mxp') THEN
         RVL=REAL(IMXP)
      ELSE IF (CNM(1:3).EQ.'MXC'.OR. CNM(1:3).EQ.'mxc') THEN
         RVL=REAL(IMXC)
C
      ELSE IF (CNM(1:3).EQ.'ZFS'.OR.CNM(1:3).EQ.'zfs') THEN
         RVL=FZFS
      ELSE IF (CNM(1:3).EQ.'ZFX'.OR.CNM(1:3).EQ.'zfx') THEN
         RVL=FZFX
      ELSE IF (CNM(1:3).EQ.'ZFY'.OR.CNM(1:3).EQ.'zfy') THEN
         RVL=FZFY
      ELSE IF (CNM(1:3).EQ.'ZFP'.OR. CNM(1:3).EQ.'zfp') THEN
         RVL=REAL(IZFP)
      ELSE IF (CNM(1:3).EQ.'ZFC'.OR. CNM(1:3).EQ.'zfc') THEN
         RVL=REAL(IZFC)
C
      ELSE IF (CNM(1:3).EQ.'LBS'.OR.CNM(1:3).EQ.'lbs') THEN
         RVL=FLBS
      ELSE IF (CNM(1:3).EQ.'LBC'.OR. CNM(1:3).EQ.'lbc') THEN
         RVL=REAL(ILBC)
C
      ELSE IF (CNM(1:3).EQ.'ILS'.OR.CNM(1:3).EQ.'ils') THEN
         RVL=FILS
      ELSE IF (CNM(1:3).EQ.'ILX'.OR.CNM(1:3).EQ.'ilx') THEN
         RVL=FILX
      ELSE IF (CNM(1:3).EQ.'ILY'.OR.CNM(1:3).EQ.'ily') THEN
         RVL=FILY
      ELSE IF (CNM(1:3).EQ.'ILP'.OR. CNM(1:3).EQ.'ilp') THEN
         RVL=REAL(IILP)
      ELSE IF (CNM(1:3).EQ.'ILC'.OR. CNM(1:3).EQ.'ilc') THEN
         RVL=REAL(IILC)
C
C color field parameters
C
      ELSE IF (CNM(1:3).EQ.'CLR'.OR.CNM(1:3).EQ.'clr') THEN
         RVL=REAL(ICLR(IPAI))
      ELSE IF (CNM(1:3).EQ.'TVL'.OR.CNM(1:3).EQ.'tvl') THEN
         RVL=TVLU(IPAI)
      ELSE IF (CNM(1:3).EQ.'TRT'.OR. CNM(1:3).EQ.'trt') THEN
         RVL=REAL(ITRT)
      ELSE
         CSTR(1:46)='VVGETI OR VVGETR - PARAMETER NAME NOT KNOWN - '
         CSTR(47:49)=CNM(1:3)
         CALL SETER (CSTR(1:49),3,1)
         RETURN
      END IF
C
 9900 CONTINUE
C
C Done.
C
      RETURN
C
      END

C
C	$Id: mkmsk.f,v 1.4 2008-07-27 01:04:31 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C

      SUBROUTINE MKMSK
C
C  THIS ROUTINE GENERATES THE MACHINE DEPENDENT DATA VALUES
C  USED BY XTCH.
C
C
      COMMON/PINIT/MASK(4),MASK6(64),MASK12(64),LAST6,LAST12,
     1  IBIT15,MASK14,NUM15U,NBWD
C
C  MASK FOR 15 BIT PARSALS(77777B)
C
      IMSK1 = 32767
C
C
C  FIND THE NUMBER OF BITS PER WORD
C
      NBWD = I1MACH(5)
C
C  COMPUTE THE NUMBER OF 15 BIT PARSALS
C
      NUM15U = NBWD/15
C
C  IPRCT AND IPRCT2 ARE USED TO PREVENT SIGN EXTENSION WHEN DOING LEFT
C  SHIFTS.
C
      ITEMP = ISHIFT(IMSK1,(NBWD-16))
      IPRCT = ITEMP
      IT1 = NUM15U-1
      DO 100 I = 1,IT1
      IPRCT = ISHIFT(IPRCT,-15)
      IPRCT = IOR(ITEMP,IPRCT)
  100 CONTINUE
      IPRCT = IOR(IPRCT,IMSK1)
C
      IPRCT2 = ISHIFT(IPRCT,-14)
C
C  LEFT JUSTIFY
C
      LEFTJS = NBWD-15
      IMSK1 = ISHIFT(IMSK1,LEFTJS)
C
C  GENERATE THE MASKS FOR THE 15 BIT PARSALS
C
C
      DO 10 I = 1 , NUM15U
      MASK(I) = IMSK1
C
C  SHIFT FOR NEXT PARSAL
C
      IMSK1 = ISHIFT(IMSK1,-15)
C
C  PROTECT FROM SIGN EXTENSION(REVELANT ONLY ON FIRST PASS)
C
      IMSK1 = IAND(IMSK1,IPRCT2)
   10 CONTINUE
C
C
C  MASK FOR 6 BIT PARSALS (77B)
C
      IMSK2 = 63
C
C  MASK FOR 12 BIT PARSALS (7777B)
C
      IMSK3 = 4095
C
C  LEFT JUSTIFY
C
      LEFTJS = NBWD-6
      IMSK2 = ISHIFT(IMSK2,LEFTJS)
C
      LEFTJS = NBWD-12
      IMSK3 = ISHIFT(IMSK3,LEFTJS)
C
C  SET UP ALL POSSIBLE 6 AND 12 BIT UNITS
C  NOTE THAT MASKS WILL ALSO BE USED WHEN UNITS CROSS WORD BOUNDRIES
C
C
      DO 20 I = 1 , NBWD
C
C  6 BIT MASKS
C
      MASK6(I) = IMSK2
      IMSK2 = ISHIFT(IMSK2,-1)
C
C PROTECTION FROM SIGN EXTENSION (REVELANT ONLY ON THE FIRST PASS)
C
      IMSK2 = IAND(IMSK2,IPRCT)
C
C  12 BIT MASKS
C
      MASK12(I) = IMSK3
      IMSK3 = ISHIFT(IMSK3,-1)
C
C  PROTECT FROM SIGN EXTENSION (REVELANT ONLY ON THE FIRST PASS)
C
      IMSK3 = IAND(IMSK3,IPRCT)
   20 CONTINUE
C
C
C  MASK FOR 6 BIT RIGHT JUSTIFED UNIT (77B)
C
      LAST6 = 63
C
C  MAST FOR 12 BIT RIGHT JUSTIFED UNIT (7777B)
C
      LAST12 = 4095
C
C  MASK FOR 15-TH BIT FROM THE RIGHT (40000B)
C
      IBIT15 = 16384
C
C  MASK FOR 14 BIT RIGHT JUSTIFED UNIT (37777B)
C
      MASK14 = 16383
      RETURN
      END

C
C $Id: mputis.f,v 1.6 2008-07-27 00:17:09 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MPUTIS (UVAL,VVAL,RLAT,RLON)
        REAL UVAL,VVAL,RLAT,RLON
        CALL MDUTIS (UVAL,VVAL,RLAT,RLON)
        RETURN
      END

      SUBROUTINE GAQDNCL(NLAT,THETA,WTS,WORK,LWORK,IERROR)
C     SUBROUTINE GAQDNCL COMPUTES GAUSSIAN POINTS (IN RADIANS) AND WEIGHTS
C     ON THE SPHERE IN THE INTERVAL (0,PI).  (THESE CAN BE USED IN
C     GAUSSIAN QUADRATURE FOR ESTIMATING INTEGRALS ON THE SPHERE)
C
C
C
C
      DIMENSION WORK(LWORK),THETA(NLAT),WTS(NLAT)
      DOUBLE PRECISION WORK,THETA,WTS,X
      N = NLAT
      IERROR = 1
C     CHECK WORK SPACE LENGTH
      IF (LWORK.LT.4*N*(N+1)+2) RETURN
      IERROR = 2
      IF (N.LE.0) RETURN
      IERROR = 0
      IF (N.GT.2) THEN
C     PARTITION WORK SPACE FOR DOUBLE PRECISION EIGENVALUE(VECTOR COMPUTATION)
      I1 = 1
      I2 = I1+2*N
      I3 = I2+2*N
      CALL GAQDNCL1(N,THETA,WTS,WORK(I1),WORK(I2),WORK(I3),IERROR)
      IF (IERROR.NE.0) THEN
      IERROR = 3
      RETURN
      END IF
      RETURN
      ELSE IF (N.EQ.1) THEN
      WTS(1) = 2.0D0
      THETA(1) = DACOS(0.0D0)
      ELSE IF (N.EQ.2) THEN
C     COMPUTE WEIGHTS AND POINTS ANALYTICALLY WHEN N=2
      WTS(1) = 1.0D0
      WTS(2) = 1.0D0
      X = DSQRT(1.0D0/3.0D0)
      THETA(1) = DACOS(X)
      THETA(2) = DACOS(-X)
      RETURN
      END IF
      END
      SUBROUTINE GAQDNCL1(N,THETA,WTS,W,E,WRK,IER)
      DIMENSION THETA(N),WTS(N),W(N),E(N),WRK(1)
      DOUBLE PRECISION THETA,WTS,TEMP,W,E,WRK
C     SET SYMMETRIC TRIDIAGNONAL MATRIX SUBDIAGONAL AND DIAGONAL
C     COEFFICIENTS FOR MATRIX COMING FROM COEFFICIENTS IN THE
C     RECURSION FORMULA FOR LEGENDRE POLYNOMIALS
C     A(N)*P(N-1)+B(N)*P(N)+C(N)*P(N+1) = 0.
      WRK(1)=0.D0
      WRK(N+1) = 0.D0
      W(1)=0.D0
      E(1) = 0.D0
      DO 100 J=2,N
      WRK(J)= (J-1.D0)/DSQRT((2.D0*J-1.D0)*(2.D0*J-3.D0))
      WRK(J+N)=0.D0
      E(J) = WRK(J)
      W(J) = 0.D0
  100 CONTINUE
C     COMPUTE EIGENVALUES  OF MATRIX
      MATZ = 1
      INDX = 2*N+1
      NP1=N+1
      CALL DRSTNCL(N,N,W,E,MATZ,WRK(INDX),IER)
      IF (IER.NE.0) RETURN
C     COMPUTE GAUSSIAN WEIGHTS AND POINTS
      DO 101 J=1,N
      THETA(J) = DACOS(W(J))
C     SET GAUSSIAN WEIGHTS AS 1ST COMPONENTS OF EIGENVECTORS SQUARED
      INDX = (J+1)*N+1
      WTS(J) = 2.0D0*WRK(INDX)**2
  101 CONTINUE
C     REVERSE ORDER OF GAUSSIAN POINTS TO BE
C     MONOTONIC INCREASING IN RADIANS
      N2 = N/2
      DO 102 I=1,N2
      TEMP = THETA(I)
      THETA(I) = THETA(N-I+1)
      THETA(N-I+1) = TEMP
  102 CONTINUE
      RETURN
      END


      SUBROUTINE DRSTNCL(NM,N,W,E,MATZ,Z,IERR)
C     DRSTNCL IS A DOUBLE PRECISION MODIFICATION OF RST OFF EISPACK
C     TO BE USED  TO COMPUTE GAUSSIAN POINTS AND WEIGHTS

C
      INTEGER I,J,N,NM,IERR,MATZ
      DOUBLE PRECISION W(N),E(N),Z(NM,N)

C
C     .......... FIND BOTH EIGENVALUES AND EIGENVECTORS ..........
   20 DO 40 I = 1, N
C
	 DO 30 J = 1, N
	    Z(J,I) = 0.0D0
   30    CONTINUE
C
	 Z(I,I) = 1.0D0
   40 CONTINUE
C
      CALL  DINTQLNCL(NM,N,W,E,Z,IERR)
      RETURN
      END

      SUBROUTINE DINTQLNCL(NM,N,D,E,Z,IERR)
C     DINTQLNCL IS A DOUBLE PRECISION MODIFICATION OF INTQL2 OFF
C     EISPACK TO BE USED BY GAQDNCL IN SPHEREPACK FOR COMPUTING
C     GAUSSIAN WEIGHTS AND POINTS
C
      INTEGER I,J,K,L,M,N,II,NM,MML,IERR
      DOUBLE PRECISION D(N),E(N),Z(NM,N)
      DOUBLE PRECISION B,C,F,G,P,R,S,TST1,TST2,DPYTHANCL
      IERR = 0
      IF (N .EQ. 1) GO TO 1001
C
      DO 100 I = 2, N
  100 E(I-1) = E(I)
C
      E(N) = 0.0D0
C
      DO 240 L = 1, N
	 J = 0
C     .......... LOOK FOR SMALL SUB-DIAGONAL ELEMENT ..........
C   
  105    NM1 = N-1     
         IF(L .GT. NM1) GO TO 111
         DO 110 MDO = L, NM1
            M = MDO
	    TST1 = DABS(D(M)) + DABS(D(M+1))
	    TST2 = TST1 + DABS(E(M))
	    IF (TST2 .EQ. TST1) GO TO 120
  110    CONTINUE
  111    M = N
C
  120    P = D(L)
	 IF (M .EQ. L) GO TO 240
	 IF (J .EQ. 30) GO TO 1000
	 J = J + 1
C     .......... FORM SHIFT ..........
	 G = (D(L+1) - P) / (2.0D0 * E(L))
	 R = DPYTHANCL(G,1.0D0)
	 G = D(M) - P + E(L) / (G + SIGN(R,G))
	 S = 1.0D0
	 C = 1.0D0
	 P = 0.0D0
	 MML = M - L
C     .......... FOR I=M-1 STEP -1 UNTIL L DO -- ..........
	 DO 200 II = 1, MML
	    I = M - II
	    F = S * E(I)
	    B = C * E(I)
	    R = DPYTHANCL(F,G)
	    E(I+1) = R
	    IF (R .EQ. 0.0D0) GO TO 210
	    S = F / R
	    C = G / R
	    G = D(I+1) - P
	    R = (D(I) - G) * S + 2.0D0 * C * B
	    P = S * R
	    D(I+1) = G + P
	    G = C * R - B
C     .......... FORM VECTOR ..........
	    DO 180 K = 1, N
	       F = Z(K,I+1)
	       Z(K,I+1) = S * Z(K,I) + C * F
	       Z(K,I) = C * Z(K,I) - S * F
  180       CONTINUE
C
  200    CONTINUE
C
	 D(L) = D(L) - P
	 E(L) = G
	 E(M) = 0.0D0
	 GO TO 105
C     .......... RECOVER FROM UNDERFLOW ..........
  210    D(I+1) = D(I+1) - P
	 E(M) = 0.0D0
	 GO TO 105
  240 CONTINUE
C     .......... ORDER EIGENVALUES AND EIGENVECTORS ..........
      DO 300 II = 2, N
	 I = II - 1
	 K = I
	 P = D(I)
C
	 DO 260 J = II, N
	    IF (D(J) .GE. P) GO TO 260
	    K = J
	    P = D(J)
  260    CONTINUE
C
	 IF (K .EQ. I) GO TO 300
	 D(K) = D(I)
	 D(I) = P
C
	 DO 280 J = 1, N
	    P = Z(J,I)
	    Z(J,I) = Z(J,K)
	    Z(J,K) = P
  280    CONTINUE
C
  300 CONTINUE
C
      GO TO 1001
C     .......... SET ERROR -- NO CONVERGENCE TO AN
C                EIGENVALUE AFTER 30 ITERATIONS ..........
 1000 IERR = L
 1001 RETURN
      END

      DOUBLE PRECISION FUNCTION DPYTHANCL(A,B)
      DOUBLE PRECISION A,B
C     DPYTHANCL IS A DOUBLE PRECISION MODIFICATION OF PYTHAG OFF EISPACK
C     FOR USE BY DIMTQL

C
C     FINDS SQRT(A**2+B**2) WITHOUT OVERFLOW OR DESTRUCTIVE UNDERFLOW
C
      DOUBLE PRECISION P,R,S,T,U
      P = DABS(A)
      IF (DABS(B).GE.DABS(A)) P = DABS(B)
C     P = AMAX1(DABS(A),DABS(B))
      IF (P .EQ. 0.0D0) GO TO 20
      R = (DABS(A)/P)**2
      IF (DABS(B).LT.DABS(A)) R = (DABS(B)/P)**2
C     R = (AMIN1(DABS(A),DABS(B))/P)**2
   10 CONTINUE
	 T = 4.0D0 + R
	 IF (T .EQ. 4.0D0) GO TO 20
	 S = R/T
	 U = 1.0D0 + 2.0D0*S
	 P = U*P
	 R = (S/U)**2 * R
      GO TO 10
   20 DPYTHANCL = P
      RETURN
      END

C
C	$Id: constp.f,v 1.5 2008-07-27 00:16:57 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CONSTP (XD,YD,NDP)
C
C  COMPUTE STEP SIZE IN X AND Y DIRECTION
C
C
C
      COMMON /CONRA1/ CL(30)     ,NCL        ,OLDZ       ,PV(210)    ,
     1                FINC       ,HI         ,FLO
      COMMON /CONRA2/ REPEAT     ,EXTRAP     ,PER        ,MESS       ,
     1                ISCALE     ,LOOK       ,PLDVLS     ,GRD        ,
     2                CINC       ,CHILO      ,CON        ,LABON      ,
     3                PMIMX      ,SCALE      ,FRADV      ,EXTRI      ,
     4                BPSIZ      ,LISTOP
      COMMON /CONRA3/ IREC
      COMMON /CONRA4/ NCP        ,NCPSZ
      COMMON /CONRA5/ NIT        ,ITIPV
      COMMON /CONRA6/ XST        ,YST        ,XED        ,YED        ,
     1                STPSZ      ,IGRAD      ,IG         ,XRG        ,
     2                YRG        ,BORD       ,PXST       ,PYST       ,
     3                PXED       ,PYED       ,ITICK
      COMMON /CONR18/ TITLE      ,ICNT   ,ITLSIZ
      COMMON /CONR19/ IHIGH      ,INMAJ      ,INLAB      ,INDAT      ,
     1              LEN      ,IFMT       ,LEND       ,
     2                IFMTD      ,ISIZEP     ,INMIN
      COMMON /CONRA9/ ICOORD(500),NP         ,MXXY       ,TR         ,
     1                BR         ,TL         ,BL         ,CONV       ,
     2                XN         ,YN         ,ITLL       ,IBLL       ,
     3                ITRL       ,IBRL       ,XC         ,YC         ,
     4                ITLOC(210) ,JX         ,JY         ,ILOC       ,
     5                ISHFCT     ,XO         ,YO         ,IOC        ,NC
      COMMON /CONR10/ NT         ,NL         ,NTNL       ,JWIPT      ,
     1                JWIWL      ,JWIWP      ,JWIPL      ,IPR        ,
     2                ITPV
      COMMON /CONR20/ NREP       ,NCRT       ,ISIZEL     ,
     1                MINGAP     ,ISIZEM         ,
     2                TENS
      COMMON /CONR12/ IXMAX      ,IYMAX      ,XMAX       ,YMAX
      LOGICAL         REPEAT     ,EXTRAP     ,PER        ,MESS       ,
     1                LOOK       ,PLDVLS     ,GRD        ,LABON      ,
     2                PMIMX      ,FRADV      ,EXTRI      ,CINC       ,
     3                TITLE      ,LISTOP     ,CHILO      ,CON
      COMMON /CONR15/ ISTRNG
        CHARACTER*64 ISTRNG
        COMMON /CONR16/ FORM
        CHARACTER*10 FORM
        COMMON /CONR17/ NDASH, IDASH, EDASH
        CHARACTER*10 NDASH, IDASH, EDASH
C
C
      DIMENSION       XD(1)      ,YD(1)
C
        SAVE
C
C  FIND SMALLEST AND LARGST X AND Y
C
      XST = XD(1)
      XED = XD(1)
      YST = YD(1)
      YED = YD(1)
      DO  130 I=2,NDP
         IF (XST .LE. XD(I)) GO TO  100
         XST = XD(I)
         GO TO  110
  100    IF (XED .GE. XD(I)) GO TO  110
         XED = XD(I)
  110    IF (YST .LE. YD(I)) GO TO  120
         YST = YD(I)
         GO TO  130
  120    IF (YED .GE. YD(I)) GO TO  130
         YED = YD(I)
  130 CONTINUE
C
C  COMPUTE STEP SIZE
C
      XRG = (ABS(XED-XST))
      YRG = (ABS(YED-YST))
      SQRG = XRG
      IF (SQRG .LT. YRG) SQRG = YRG
      STPSZ = SQRG/REAL(IGRAD-1)
C
C  COMPUTE PARAMETERS FOR SET CALL
C
      DIFX = XRG/SQRG
      DIFY = YRG/SQRG
      PXST = .5-(BORD*DIFX)/2.
      PXED = .5+(BORD*DIFX)/2.
      PYST = .5-(BORD*DIFY)/2.
      PYED = .5+(BORD*DIFY)/2.
      XRG = XRG/REAL(ITICK)
      YRG = YRG/REAL(ITICK)
C
C  TEST IF THE ASPECT RATIO FOR THE COORDINATES IS REASONABLE.
C     REASONABLE IS CURRENTLY DEFINED AS 5 TO 1.
C     IF IT IS NOT REASONABLE THEN A POOR PLOT MAY BE GENERATED
C     SO IT IS NICE THE WARN THE USER WHEN THIS HAPPENS.
C
      TEST = XRG/YRG
      IF (TEST.LE.5. .AND. TEST.GE.0.2) RETURN
C
C  WARN THE USER ON THE STANDARD OUTPUT UNIT THAT THE PLOT MAY
C  NOT BE TOO GOOD.
C
C  SET RECOVERY MODE
C
      CALL ENTSR(IROLD,IREC)
C
C  FLAG THE ERROR
C
      CALL SETER(' ASPECT RATIO OF X AND Y GREATER THAN 5 TO 1',
     1           1,1)
C
      CALL EPRIN
C
C  CLEAR THE ERROR
C
      CALL ERROF
C
C  RESET USER ERROR MODE
C
      CALL ENTSR(IDUM,IROLD)
C
      RETURN
      END

      SUBROUTINE CGEQL2( M, N, A, LDA, TAU, WORK, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      INTEGER            INFO, LDA, M, N
*     ..
*     .. Array Arguments ..
      COMPLEX            A( LDA, * ), TAU( * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  CGEQL2 computes a QL factorization of a complex m by n matrix A:
*  A = Q * L.
*
*  Arguments
*  =========
*
*  M       (input) INTEGER
*          The number of rows of the matrix A.  M >= 0.
*
*  N       (input) INTEGER
*          The number of columns of the matrix A.  N >= 0.
*
*  A       (input/output) COMPLEX array, dimension (LDA,N)
*          On entry, the m by n matrix A.
*          On exit, if m >= n, the lower triangle of the subarray
*          A(m-n+1:m,1:n) contains the n by n lower triangular matrix L;
*          if m <= n, the elements on and below the (n-m)-th
*          superdiagonal contain the m by n lower trapezoidal matrix L;
*          the remaining elements, with the array TAU, represent the
*          unitary matrix Q as a product of elementary reflectors
*          (see Further Details).
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(1,M).
*
*  TAU     (output) COMPLEX array, dimension (min(M,N))
*          The scalar factors of the elementary reflectors (see Further
*          Details).
*
*  WORK    (workspace) COMPLEX array, dimension (N)
*
*  INFO    (output) INTEGER
*          = 0: successful exit
*          < 0: if INFO = -i, the i-th argument had an illegal value
*
*  Further Details
*  ===============
*
*  The matrix Q is represented as a product of elementary reflectors
*
*     Q = H(k) . . . H(2) H(1), where k = min(m,n).
*
*  Each H(i) has the form
*
*     H(i) = I - tau * v * v'
*
*  where tau is a complex scalar, and v is a complex vector with
*  v(m-k+i+1:m) = 0 and v(m-k+i) = 1; v(1:m-k+i-1) is stored on exit in
*  A(1:m-k+i-1,n-k+i), and tau in TAU(i).
*
*  =====================================================================
*
*     .. Parameters ..
      COMPLEX            ONE
      PARAMETER          ( ONE = ( 1.0E+0, 0.0E+0 ) )
*     ..
*     .. Local Scalars ..
      INTEGER            I, K
      COMPLEX            ALPHA
*     ..
*     .. External Subroutines ..
      EXTERNAL           CLARF, CLARFG, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          CONJG, MAX, MIN
*     ..
*     .. Executable Statements ..
*
*     Test the input arguments
*
      INFO = 0
      IF( M.LT.0 ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( LDA.LT.MAX( 1, M ) ) THEN
         INFO = -4
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'CGEQL2', -INFO )
         RETURN
      END IF
*
      K = MIN( M, N )
*
      DO 10 I = K, 1, -1
*
*        Generate elementary reflector H(i) to annihilate
*        A(1:m-k+i-1,n-k+i)
*
         ALPHA = A( M-K+I, N-K+I )
         CALL CLARFG( M-K+I, ALPHA, A( 1, N-K+I ), 1, TAU( I ) )
*
*        Apply H(i)' to A(1:m-k+i,1:n-k+i-1) from the left
*
         A( M-K+I, N-K+I ) = ONE
         CALL CLARF( 'Left', M-K+I, N-K+I-1, A( 1, N-K+I ), 1,
     $               CONJG( TAU( I ) ), A, LDA, WORK )
         A( M-K+I, N-K+I ) = ALPHA
   10 CONTINUE
      RETURN
*
*     End of CGEQL2
*
      END

C
C $Id: eprin.f,v 1.7 2008-07-27 00:17:29 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE EPRIN
C
C This routine just prints the current error message, if any.
C
C The common blocks SECOMI and SECOMC are used to hold shared variables
C of types INTEGER and CHARACTER, respectively, for the routine SETER
C and associated routines.  For descriptions of these variables and for
C default values of them, see the block data routine SEBLDAX.
C
        COMMON /SECOMI/ IERRU,IERRF,IRECF,LOMSG
        SAVE   /SECOMI/
C
        COMMON /SECOMC/ ERMSG
          CHARACTER*256 ERMSG
        SAVE   /SECOMC/
C
C Do it.
C
        IF (IERRF.NE.0) WRITE (IERRU,'('' ERROR '',I4,'' IN '',A)')
     +                                              IERRF,ERMSG(1:LOMSG)
C
C Done.
C
        RETURN
C
      END

C
C $Id: rbgdfe.f,v 1.12 2008-09-18 00:42:18 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      DOUBLE PRECISION FUNCTION RBGDFE (RLAT)
C
        DOUBLE PRECISION RLAT
C
C The value of RBGDFE(RLAT) is the signed distance, from the equator,
C of the parallel at latitude RLAT; its magnitude is a fraction of the
C length of the equator.
C
C Declare local variables.
C
        DOUBLE PRECISION FLAT,PDFE(19)
C
        INTEGER          ILAT
C
C Define the contents of PDFE per the definition of the Robinson
C projection.  The values are associated with values of latitude from
C 0 North to 90 North at five-degree intervals.
C
        DATA PDFE( 1) / 0.0000D0 /
        DATA PDFE( 2) / 0.0620D0 /
        DATA PDFE( 3) / 0.1240D0 /
        DATA PDFE( 4) / 0.1860D0 /
        DATA PDFE( 5) / 0.2480D0 /
        DATA PDFE( 6) / 0.3100D0 /
        DATA PDFE( 7) / 0.3720D0 /
        DATA PDFE( 8) / 0.4340D0 /
        DATA PDFE( 9) / 0.4958D0 /
        DATA PDFE(10) / 0.5571D0 /
        DATA PDFE(11) / 0.6176D0 /
        DATA PDFE(12) / 0.6769D0 /
        DATA PDFE(13) / 0.7346D0 /
        DATA PDFE(14) / 0.7903D0 /
        DATA PDFE(15) / 0.8435D0 /
        DATA PDFE(16) / 0.8936D0 /
        DATA PDFE(17) / 0.9394D0 /
        DATA PDFE(18) / 0.9761D0 /
        DATA PDFE(19) / 1.0000D0 /
C
C Determine where the parallel of interest lies relative to the ones
C represented in the tables (between the ones associated with elements
C ILAT and ILAT+1 and a fractional distance FLAT from the former to the
C latter).
C
        ILAT=MAX(1,MIN(18,INT(1.D0+ABS(RLAT)/5.D0)))
C
        FLAT=1.D0+ABS(RLAT)/5.D0-DBLE(ILAT)
C
C Return the desired value.
C
        RBGDFE=.5072D0*SIGN((1.D0-FLAT)*PDFE(ILAT)+
     +                             FLAT*PDFE(ILAT+1),RLAT)
C
C Done.
C
        RETURN
C
      END

C
C      $Id: xy07f.f,v 1.8 2010-03-15 22:49:25 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C                Copyright (C)  1995                                   C
C        University Corporation for Atmospheric Research               C
C                All Rights Reserved                                   C
C                                                                      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C  File:       xy07f.f
C
C  Author:     Mary Haley (converted from example "agex11")
C          National Center for Atmospheric Research
C          PO 3000, Boulder, Colorado
C
C  Date:       Mon Apr 24 11:11:02 MST 1995
C
C  Description:   This example is similar to the ncargex Autograph
C                 example "agex11".  It shows how to draw a "scattergram".
C                 It also shows one way on how to modify the color map
C                 so we can get a different background/foreground color.
C
      external NhlFAppClass
      external NhlFCairoWindowWorkstationClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFCoordArraysClass
      external NhlFXyPlotClass

      parameter(NPTS=250)
C
C Create data arrays for XyPlot object.
C
      real xdra(NPTS), ydra(NPTS)

      integer appid,xworkid,plotid,dataid(2)
      integer i, j, len(2)
      real cmap(3,4)
      character*10 datastr
      CHARACTER*7  wks_type
C
C Define the workstation type
C
      wks_type = "x11"
C
C
C Initialize the HLU library and set up resource template.
C
      call NhlFInitialize
      call NhlFRLCreate(rlist,'setrl')
C
C Change the color map so we can have a white background, a black
C foreground and two colors defined for our markers.  Color '1' is
C the background color and '2' is the foreground color.
C
      cmap(1,1) = 1.
      cmap(2,1) = 1.
      cmap(3,1) = 1.
      cmap(1,2) = 0.
      cmap(2,2) = 0.
      cmap(3,2) = 0.
      cmap(1,3) = 1.
      cmap(2,3) = 0.
      cmap(3,3) = 0.
      cmap(1,4) = 0.
      cmap(2,4) = 0.
      cmap(3,4) = 1.
      len(1) = 3
      len(2) = 4
C
C Create Application object.  The Application object name is used to
C determine the name of the resource file, which is "xy07.res" in
C this case.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'appDefaultParent','True',ierr)
      call NhlFRLSetString(rlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'xy07',NhlFAppClass,0,rlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGMWorkstation object.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkMetaName','./xy07f.ncgm',ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',cmap,2,len,ierr)
         call NhlFCreate(xworkid,'xy07Work',
     +        NhlFNcgmWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an XWorkstation object.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPause','True',ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',cmap,2,len,ierr)
         call NhlFCreate(xworkid,'xy07Work',
     +        NhlFCairoWindowWorkstationClass,
     +        0,rlist,ierr)
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create a PSWorkstation object.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPSFileName','./xy07f.ps',ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',cmap,2,len,ierr)
         call NhlFCreate(xworkid,'xy07Work',
     +        NhlFPSWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create a PDFWorkstation object.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPDFFileName','./xy07f.pdf',ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',cmap,2,len,ierr)
         call NhlFCreate(xworkid,'xy07Work',
     +        NhlFPDFWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFileName','./xy07f',ierr)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',cmap,2,len,ierr)
         call NhlFCreate(xworkid,'xy07Work',
     +        NhlFcairoPSPDFWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFileName','./xy07f',ierr)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',cmap,2,len,ierr)
         call NhlFCreate(xworkid,'xy07Work',
     +        NhlFcairoImageWorkstationClass,0,rlist,ierr)
      endif
C
C Since we have two sets of points that we want to color differently,
C we need to create two Data obects here.
C
      do 20 j = 1,2
C
C Initialize data.
C
         do 10 i = 1, NPTS
            xdra(i)=.5+(2.*(fran()-.5))**5
            ydra(i)=.5+(2.*(fran()-.5))**5
 10     continue
C
C Define a data object.  Note that we are naming each object differently
C so we can distinguish them in the resource file.
C
        call NhlFRLClear(rlist)
        call NhlFRLSetFloatArray(rlist,'caXArray',xdra,NPTS,ierr)
        call NhlFRLSetFloatArray(rlist,'caYArray',ydra,NPTS,ierr)
        write(datastr,30)j-1
        call NhlFCreate(dataid(j),datastr,NhlFcoordArraysClass,0,rlist,
     +                  ierr)
 20   continue
 30   format('xyData',i1)
C
C Create the XyPlot object.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetIntegerArray(rlist,'xyCoordData',dataid,2,ierr)
      call NhlFCreate(plotid,'xyPlot',NhlFxyPlotClass,xworkid,rlist,
     +     ierr)
C
C Draw the plot.
C
      call NhlFDraw(plotid,ierr)
      call NhlFFrame(xworkid,ierr)
C
C NhlDestroy destroys the given id and all of its children
C so destroying xworkwid will also destroy plotid.
C
      call NhlFDestroy(xworkid,ierr)
C
C Restores state.
C
      call NhlFDestroy(appid,ierr)
      call NhlFClose

      stop
      end
      
      function fran()
C
C Pseudo-random-number generator.
C
      double precision x
      save x
      data x / 2.718281828459045 /
      x=mod(9821.d0*x+.211327d0,1.d0)
      fran=real(x)
      return
      end

      PROGRAM FSREZSRF
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C INVOKE DEMO DRIVER
C
      CALL TSRFAC(IWKID,IERR)
C
C Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END
C
      SUBROUTINE TSRFAC (IWKID,IERROR)
C
C PURPOSE                To provide a simple demonstration of EZSRFC.
C
C USAGE                  CALL TSRFAC (IWKID,IERROR)
C
C ARGUMENTS
C
C ON INPUT               IWKID
C                          A workstation id number
C
C ON OUTPUT              IERROR
C                          An integer variable
C                          = 0, if the test was successful,
C                          = 1, the test was not successful.
C
C I/O                    If the test is successful, the message
C
C               SRFACE TEST EXECUTED--SEE PLOT TO CERTIFY
C
C                        is printed on unit 6.  In addition, 1
C                        frame is produced on the machine graphics
C                        device.  In order to determine if the test
C                        was successful, it is necessary to examine
C                        the plot.
C
C PRECISION              Single
C
C LANGUAGE               FORTRAN 77
C
C REQUIRED ROUTINES      EZSRFC
C
C REQUIRED GKS LEVEL     0A
C
C ALGORITHM              The function
C
C                          Z(X,Y) = .25*(X + Y + 1./((X-.1)**2+Y**2+.09)
C                                   -1./((X+.1)**2+Y**2+.09)
C
C                        for X = -1. to +1. in increments of .1, and
C                            Y = -1.2 to +1.2 in increments of .1,
C                        is computed.  Then, entry EZSRFC 
C                        is called to a generate surface plot of Z.
C
C Z contains the Z function values; 
C WORK is a work array;  ANGH contains the angle in degrees in the X-Y
C plane to the line of sight;  and ANGV contains the angle in degrees
C from the X-Y plane to the line of sight.
C
      REAL            Z(21,25),  WORK(1096)
C
      DATA  ANGH/45./, ANGV/15./
C
C Specify coordinates for plot titles.  The values CX and CY
C define the center of the title string in a 0. to 1. range.
C
      DATA CX/.5/, CY/.9/
C
C Initialize the error parameter.
C
      IERROR = 0
C
C Set up a the background and foreground colors
C
C White background
C
      CALL GSCR (IWKID,0,1.,1.,1.)
C
C Blue foreground
C
      CALL GSCR (IWKID,1,0.,0.,1.)
C
C Fill the Z function array.
C
      DO  20 I=1,21
         X = .1*REAL(I-11)
         DO  10 J=1,25
            Y = .1*REAL(J-13)
            Z(I,J) = (X+Y+1./((X-.1)**2+Y**2+.09)-
     1           1./((X+.1)**2+Y**2+.09))*.25
 10      CONTINUE
 20   CONTINUE
C
C Select the normalization transformation 0.
C
      CALL GSELNT(0)
C
C Add the plot title using GKS calls.
C
C Set the text alignment to center the string in horizontal and vertical
C
      CALL GSTXAL(2,3)
C
C Set the character height.
C
      CALL GSCHH(.016)
C
C Write the text.
C
      CALL GTX(CX,CY,'DEMONSTRATION PLOT FOR EZSRFC ENTRY OF SRFACE')
C
C Draw the surface
C
      CALL EZSRFC (Z,21,25,ANGH,ANGV,WORK)
C
C This routine automatically generates frame advances.
C
      RETURN
C
C
      END

      subroutine rndncl(npts, xin, ismsg, xmsg, xout, iopt)
      implicit none
      integer  npts, ismsg, iopt
      double precision xin(npts), xout(npts), xmsg

      integer  n
C
C This is to take care of the case where the user wants the output to
C be returned by integers, and the missing value happens to not be
C an integer, like -9999.9.
C
      if (iopt.eq.3.and.ismsg.eq.1) then
        xmsg = anint(xmsg)
      end if

      do n=1,npts
         if (ismsg.eq.0.or.(ismsg.eq.1.and.xin(n).ne.xmsg)) then 
             xout(n) = anint(xin(n))
         else
             xout(n) = xmsg 
         end if
      end do

      return
      end 

      SUBROUTINE DLARFG( N, ALPHA, X, INCX, TAU )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      INTEGER            INCX, N
      DOUBLE PRECISION   ALPHA, TAU
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   X( * )
*     ..
*
*  Purpose
*  =======
*
*  DLARFG generates a real elementary reflector H of order n, such
*  that
*
*        H * ( alpha ) = ( beta ),   H' * H = I.
*            (   x   )   (   0  )
*
*  where alpha and beta are scalars, and x is an (n-1)-element real
*  vector. H is represented in the form
*
*        H = I - tau * ( 1 ) * ( 1 v' ) ,
*                      ( v )
*
*  where tau is a real scalar and v is a real (n-1)-element
*  vector.
*
*  If the elements of x are all zero, then tau = 0 and H is taken to be
*  the unit matrix.
*
*  Otherwise  1 <= tau <= 2.
*
*  Arguments
*  =========
*
*  N       (input) INTEGER
*          The order of the elementary reflector.
*
*  ALPHA   (input/output) DOUBLE PRECISION
*          On entry, the value alpha.
*          On exit, it is overwritten with the value beta.
*
*  X       (input/output) DOUBLE PRECISION array, dimension
*                         (1+(N-2)*abs(INCX))
*          On entry, the vector x.
*          On exit, it is overwritten with the vector v.
*
*  INCX    (input) INTEGER
*          The increment between elements of X. INCX > 0.
*
*  TAU     (output) DOUBLE PRECISION
*          The value tau.
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ONE, ZERO
      PARAMETER          ( ONE = 1.0D+0, ZERO = 0.0D+0 )
*     ..
*     .. Local Scalars ..
      INTEGER            J, KNT
      DOUBLE PRECISION   BETA, RSAFMN, SAFMIN, XNORM
*     ..
*     .. External Functions ..
      DOUBLE PRECISION   DLAMCH, DLAPY2, DNRM2
      EXTERNAL           DLAMCH, DLAPY2, DNRM2
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, SIGN
*     ..
*     .. External Subroutines ..
      EXTERNAL           DSCAL
*     ..
*     .. Executable Statements ..
*
      IF( N.LE.1 ) THEN
         TAU = ZERO
         RETURN
      END IF
*
      XNORM = DNRM2( N-1, X, INCX )
*
      IF( XNORM.EQ.ZERO ) THEN
*
*        H  =  I
*
         TAU = ZERO
      ELSE
*
*        general case
*
         BETA = -SIGN( DLAPY2( ALPHA, XNORM ), ALPHA )
         SAFMIN = DLAMCH( 'S' ) / DLAMCH( 'E' )
         IF( ABS( BETA ).LT.SAFMIN ) THEN
*
*           XNORM, BETA may be inaccurate; scale X and recompute them
*
            RSAFMN = ONE / SAFMIN
            KNT = 0
   10       CONTINUE
            KNT = KNT + 1
            CALL DSCAL( N-1, RSAFMN, X, INCX )
            BETA = BETA*RSAFMN
            ALPHA = ALPHA*RSAFMN
            IF( ABS( BETA ).LT.SAFMIN )
     $         GO TO 10
*
*           New BETA is at most 1, at least SAFMIN
*
            XNORM = DNRM2( N-1, X, INCX )
            BETA = -SIGN( DLAPY2( ALPHA, XNORM ), ALPHA )
            TAU = ( BETA-ALPHA ) / BETA
            CALL DSCAL( N-1, ONE / ( ALPHA-BETA ), X, INCX )
*
*           If ALPHA is subnormal, it may lose relative accuracy
*
            ALPHA = BETA
            DO 20 J = 1, KNT
               ALPHA = ALPHA*SAFMIN
   20       CONTINUE
         ELSE
            TAU = ( BETA-ALPHA ) / BETA
            CALL DSCAL( N-1, ONE / ( ALPHA-BETA ), X, INCX )
            ALPHA = BETA
         END IF
      END IF
*
      RETURN
*
*     End of DLARFG
*
      END

C
C	$Id: hlsrgb.f,v 1.5 2008-07-27 00:16:53 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE HLSRGB ( H, L, S, R, G, B )
C
C_BEGIN PROLOGUE HLSRGB
C
C_PURPOSE
C    This subroutine converts a color specification given in
C    the Hue, Lightness, and Saturation color space to
C    Red, Green, and Blue intensity values in the RGB color
C    space.
C
C_DESCRIPTION
C    This subroutine converts color values given in the
C    Hue, Lightness, Saturation (HLS) color space to color values
C    in the Red, Green, and Blue (RGB) color space.
C    The input value H is a floating point number in the
C    range [0.,360.); a value of H=0. in the input space
C    will result in a full blue (red and green values of 0.)
C    in the RGB space.  The input value L is in the range
C    [0.,100.]; lightness is used to signify the amount of light--
C    L=0. will result in R=G=B=0. and L=1. will result in
C    R=G=B=1. regardless of H and S.  The input value S is
C    in the range [0.,100.];  saturation is a measure of the
C    mixture of white light with a pure fully-saturated hue--
C    S=0. will result in R=G=B=L.  The output values
C    R, G, and B are red, green, and blue intensities
C    in the range 0. to 1. .
C
C_ARGUMENTS
C
C H       (INPUT,SINGLE,VARIABLE)  A real variable in the range
C         [0.,360.) which represents the hue of the input color
C         in HLS color space.  H=0. corresponds to blue.
C
C L       (INPUT,SINGLE,VARIABLE)  A real variable in the range
C         [0.,100.] which represents the lightness value of the
C         input color in HLS color space.  Lightness is a measure
C         of the quantity of light--a lightness of 0. is black,
C         and a lightness of 100. gives white.  The pure hues occur
C         at lightness value 50.
C
C S       (INPUT,SINGLE,VARIABLE)  A real variable in the range
C         [0.,100.] which represents the saturation value of the
C         input color in HLS color space.  Saturation is a measure
C         of how much white light is mixed with the color. Colors
C         having a satuartion value of 0. represent greys
C         with a grey intensity value equal to the lightness L.
C         Colors with a saturation value of 100. are
C         fully saturated colors.  The hue is undefined
C         when S=0.  The fully saturated pure hues occur when S=100.
C         and L=50.
C
C R       (OUTPUT,SINGLE,VARIABLE)  A real variable in the range
C         [0.,1.] which represents the red intensity component
C         of the output color in RGB color space.
C
C G       (OUTPUT,SINGLE,VARIABLE)  A real variable in the range
C         [0.,1.] which represents the green intensity component
C         of the output color in RGB color space.
C
C B       (OUTPUT,SINGLE,VARIABLE)  A real variable in the range
C         [0.,1.] which represents the blue intensity component
C         of the output color in RGB color space.
C
C_I/O
C    (NONE)
C
C_ROUTINES CALLED
C    SIGPLC
C
C_COMMON BLOCKS
C    (NONE)
C
C_MAXIMUM GKS LEVEL
C    (NONE)
C
C_LANGUAGE
C    FORTRAN
C
C_REVISION DATE
C    880511 (YYMMDD)
C
C_HISTORY
C    This subroutine was originally coded at NCAR by Roy Barnes
C    using the algorithm presented in Foley and van Dam (see
C    REFERENCES below); it was prepared for the NCAR Graphics
C    package by Fred Clare.
C
C_REFERENCES
C    Foley, James D. and van Dam, Andries,"Fundamentals of Interactive
C    Computer Graphics",Addison-Wesley Publishing Company, 1982.
C
C    Smith, A.R.,"Color Gamut Transformation Pairs",SIGGRAPH '78
C    Proceedings, published as Computer Graphics, 12(3),August 1978,
C    pp.12-19.
C
C_LONG DESCRIPTION
C    The idea of the algorithm can be understood if one were to
C    plot the red output values vs. hue for S=100. and L=50.  The red
C    values so plotted form a piecewise linear curve.  The blue
C    and green values plotted in the same way form the same
C    piecewise linear curve except shifted.  Decreasing the
C    saturation pushes the curves toward the lightness value,
C    and varying the lightness introduces an amplitude scale
C    factor and vertical offset.
C
C_EXAMPLES
C    Example 1 --  Pure hue to red.
C          SUBROUTINE HLS2
C          REAL    R,G,B,EPS
C          PARAMETER (EPS=0.00001)
C          CALL HLSRGB(120.,50.,100.,R,G,B)
C          IF ( (ABS(R-1.) .GT. EPS) .OR. (ABS(G) .GT. EPS) .OR.
C         *     (ABS(B) .GT. EPS) ) THEN
C            IUN = I1MACH(4)
C            WRITE(IUN,10)
C          ENDIF
C          RETURN
C       10 FORMAT(' HLS2 returned incorrect values')
C          END
C
C_END PROLOGUE HLSRGB
C
      REAL   H,HH,L,S,R,G,B,LL,SS,M1,M2,SIGPLC
C
C  Check on the input values.
C
C_FIRST EXECUTABLE STATEMENT HLSRGB
      HH = MOD(H,360.)
      IF (HH .LT. 0.) HH = HH+360.
      IF (L.LT.0. .OR. L.GT.100.)
     *      CALL SETER(' HLSRGB - L out of range',1,1)
      IF (S.LT.0. .OR. S.GT.100.)
     *      CALL SETER(' HLSRGB - S out of range',1,1)
C
C  Normalize lightness and saturation values.
C
      LL = L/100.
      SS = S/100.
      IF (SS .EQ. 0.0) THEN
C
C  Achromatic case; RGB value is a grey equal to the lightness.
C
         R = LL
         G = LL
         B = LL
      ELSE
C
C  Calculate the max and min of the generic piecewise linear
C  color component function.
C
         IF (LL .LE. 0.5) THEN
             M2 = LL * (1.0 + SS)
         ELSE
             M2 = LL + SS - (LL * SS)
         ENDIF
         M1 = 2.0 * LL - M2
C
C  Compute RGB values.
C
         R = SIGPLC(M1,M2,HH+  0.)
         G = SIGPLC(M1,M2,HH-120.)
         B = SIGPLC(M1,M2,HH+120.)
      ENDIF
      RETURN
      END

      SUBROUTINE DHGEQZ( JOB, COMPQ, COMPZ, N, ILO, IHI, A, LDA, B, LDB,
     $                   ALPHAR, ALPHAI, BETA, Q, LDQ, Z, LDZ, WORK,
     $                   LWORK, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          COMPQ, COMPZ, JOB
      INTEGER            IHI, ILO, INFO, LDA, LDB, LDQ, LDZ, LWORK, N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), ALPHAI( * ), ALPHAR( * ),
     $                   B( LDB, * ), BETA( * ), Q( LDQ, * ), WORK( * ),
     $                   Z( LDZ, * )
*     ..
*
*  Purpose
*  =======
*
*  DHGEQZ implements a single-/double-shift version of the QZ method for
*  finding the generalized eigenvalues
*
*  w(j)=(ALPHAR(j) + i*ALPHAI(j))/BETAR(j)   of the equation
*
*       det( A - w(i) B ) = 0
*
*  In addition, the pair A,B may be reduced to generalized Schur form:
*  B is upper triangular, and A is block upper triangular, where the
*  diagonal blocks are either 1-by-1 or 2-by-2, the 2-by-2 blocks having
*  complex generalized eigenvalues (see the description of the argument
*  JOB.)
*
*  If JOB='S', then the pair (A,B) is simultaneously reduced to Schur
*  form by applying one orthogonal tranformation (usually called Q) on
*  the left and another (usually called Z) on the right.  The 2-by-2
*  upper-triangular diagonal blocks of B corresponding to 2-by-2 blocks
*  of A will be reduced to positive diagonal matrices.  (I.e.,
*  if A(j+1,j) is non-zero, then B(j+1,j)=B(j,j+1)=0 and B(j,j) and
*  B(j+1,j+1) will be positive.)
*
*  If JOB='E', then at each iteration, the same transformations
*  are computed, but they are only applied to those parts of A and B
*  which are needed to compute ALPHAR, ALPHAI, and BETAR.
*
*  If JOB='S' and COMPQ and COMPZ are 'V' or 'I', then the orthogonal
*  transformations used to reduce (A,B) are accumulated into the arrays
*  Q and Z s.t.:
*
*       Q(in) A(in) Z(in)* = Q(out) A(out) Z(out)*
*       Q(in) B(in) Z(in)* = Q(out) B(out) Z(out)*
*
*  Ref: C.B. Moler & G.W. Stewart, "An Algorithm for Generalized Matrix
*       Eigenvalue Problems", SIAM J. Numer. Anal., 10(1973),
*       pp. 241--256.
*
*  Arguments
*  =========
*
*  JOB     (input) CHARACTER*1
*          = 'E': compute only ALPHAR, ALPHAI, and BETA.  A and B will
*                 not necessarily be put into generalized Schur form.
*          = 'S': put A and B into generalized Schur form, as well
*                 as computing ALPHAR, ALPHAI, and BETA.
*
*  COMPQ   (input) CHARACTER*1
*          = 'N': do not modify Q.
*          = 'V': multiply the array Q on the right by the transpose of
*                 the orthogonal tranformation that is applied to the
*                 left side of A and B to reduce them to Schur form.
*          = 'I': like COMPQ='V', except that Q will be initialized to
*                 the identity first.
*
*  COMPZ   (input) CHARACTER*1
*          = 'N': do not modify Z.
*          = 'V': multiply the array Z on the right by the orthogonal
*                 tranformation that is applied to the right side of
*                 A and B to reduce them to Schur form.
*          = 'I': like COMPZ='V', except that Z will be initialized to
*                 the identity first.
*
*  N       (input) INTEGER
*          The order of the matrices A, B, Q, and Z.  N >= 0.
*
*  ILO     (input) INTEGER
*  IHI     (input) INTEGER
*          It is assumed that A is already upper triangular in rows and
*          columns 1:ILO-1 and IHI+1:N.
*          1 <= ILO <= IHI <= N, if N > 0; ILO=1 and IHI=0, if N=0.
*
*  A       (input/output) DOUBLE PRECISION array, dimension (LDA, N)
*          On entry, the N-by-N upper Hessenberg matrix A.  Elements
*          below the subdiagonal must be zero.
*          If JOB='S', then on exit A and B will have been
*             simultaneously reduced to generalized Schur form.
*          If JOB='E', then on exit A will have been destroyed.
*             The diagonal blocks will be correct, but the off-diagonal
*             portion will be meaningless.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max( 1, N ).
*
*  B       (input/output) DOUBLE PRECISION array, dimension (LDB, N)
*          On entry, the N-by-N upper triangular matrix B.  Elements
*          below the diagonal must be zero.  2-by-2 blocks in B
*          corresponding to 2-by-2 blocks in A will be reduced to
*          positive diagonal form.  (I.e., if A(j+1,j) is non-zero,
*          then B(j+1,j)=B(j,j+1)=0 and B(j,j) and B(j+1,j+1) will be
*          positive.)
*          If JOB='S', then on exit A and B will have been
*             simultaneously reduced to Schur form.
*          If JOB='E', then on exit B will have been destroyed.
*             Elements corresponding to diagonal blocks of A will be
*             correct, but the off-diagonal portion will be meaningless.
*
*  LDB     (input) INTEGER
*          The leading dimension of the array B.  LDB >= max( 1, N ).
*
*  ALPHAR  (output) DOUBLE PRECISION array, dimension (N)
*          ALPHAR(1:N) will be set to real parts of the diagonal
*          elements of A that would result from reducing A and B to
*          Schur form and then further reducing them both to triangular
*          form using unitary transformations s.t. the diagonal of B
*          was non-negative real.  Thus, if A(j,j) is in a 1-by-1 block
*          (i.e., A(j+1,j)=A(j,j+1)=0), then ALPHAR(j)=A(j,j).
*          Note that the (real or complex) values
*          (ALPHAR(j) + i*ALPHAI(j))/BETA(j), j=1,...,N, are the
*          generalized eigenvalues of the matrix pencil A - wB.
*
*  ALPHAI  (output) DOUBLE PRECISION array, dimension (N)
*          ALPHAI(1:N) will be set to imaginary parts of the diagonal
*          elements of A that would result from reducing A and B to
*          Schur form and then further reducing them both to triangular
*          form using unitary transformations s.t. the diagonal of B
*          was non-negative real.  Thus, if A(j,j) is in a 1-by-1 block
*          (i.e., A(j+1,j)=A(j,j+1)=0), then ALPHAR(j)=0.
*          Note that the (real or complex) values
*          (ALPHAR(j) + i*ALPHAI(j))/BETA(j), j=1,...,N, are the
*          generalized eigenvalues of the matrix pencil A - wB.
*
*  BETA    (output) DOUBLE PRECISION array, dimension (N)
*          BETA(1:N) will be set to the (real) diagonal elements of B
*          that would result from reducing A and B to Schur form and
*          then further reducing them both to triangular form using
*          unitary transformations s.t. the diagonal of B was
*          non-negative real.  Thus, if A(j,j) is in a 1-by-1 block
*          (i.e., A(j+1,j)=A(j,j+1)=0), then BETA(j)=B(j,j).
*          Note that the (real or complex) values
*          (ALPHAR(j) + i*ALPHAI(j))/BETA(j), j=1,...,N, are the
*          generalized eigenvalues of the matrix pencil A - wB.
*          (Note that BETA(1:N) will always be non-negative, and no
*          BETAI is necessary.)
*
*  Q       (input/output) DOUBLE PRECISION array, dimension (LDQ, N)
*          If COMPQ='N', then Q will not be referenced.
*          If COMPQ='V' or 'I', then the transpose of the orthogonal
*             transformations which are applied to A and B on the left
*             will be applied to the array Q on the right.
*
*  LDQ     (input) INTEGER
*          The leading dimension of the array Q.  LDQ >= 1.
*          If COMPQ='V' or 'I', then LDQ >= N.
*
*  Z       (input/output) DOUBLE PRECISION array, dimension (LDZ, N)
*          If COMPZ='N', then Z will not be referenced.
*          If COMPZ='V' or 'I', then the orthogonal transformations
*             which are applied to A and B on the right will be applied
*             to the array Z on the right.
*
*  LDZ     (input) INTEGER
*          The leading dimension of the array Z.  LDZ >= 1.
*          If COMPZ='V' or 'I', then LDZ >= N.
*
*  WORK    (workspace/output) DOUBLE PRECISION array, dimension (LWORK)
*          On exit, if INFO >= 0, WORK(1) returns the optimal LWORK.
*
*  LWORK   (input) INTEGER
*          The dimension of the array WORK.  LWORK >= max(1,N).
*
*          If LWORK = -1, then a workspace query is assumed; the routine
*          only calculates the optimal size of the WORK array, returns
*          this value as the first entry of the WORK array, and no error
*          message related to LWORK is issued by XERBLA.
*
*  INFO    (output) INTEGER
*          = 0: successful exit
*          < 0: if INFO = -i, the i-th argument had an illegal value
*          = 1,...,N: the QZ iteration did not converge.  (A,B) is not
*                     in Schur form, but ALPHAR(i), ALPHAI(i), and
*                     BETA(i), i=INFO+1,...,N should be correct.
*          = N+1,...,2*N: the shift calculation failed.  (A,B) is not
*                     in Schur form, but ALPHAR(i), ALPHAI(i), and
*                     BETA(i), i=INFO-N+1,...,N should be correct.
*          > 2*N:     various "impossible" errors.
*
*  Further Details
*  ===============
*
*  Iteration counters:
*
*  JITER  -- counts iterations.
*  IITER  -- counts iterations run since ILAST was last
*            changed.  This is therefore reset only when a 1-by-1 or
*            2-by-2 block deflates off the bottom.
*
*  =====================================================================
*
*     .. Parameters ..
*    $                     SAFETY = 1.0E+0 )
      DOUBLE PRECISION   HALF, ZERO, ONE, SAFETY
      PARAMETER          ( HALF = 0.5D+0, ZERO = 0.0D+0, ONE = 1.0D+0,
     $                   SAFETY = 1.0D+2 )
*     ..
*     .. Local Scalars ..
      LOGICAL            ILAZR2, ILAZRO, ILPIVT, ILQ, ILSCHR, ILZ,
     $                   LQUERY
      INTEGER            ICOMPQ, ICOMPZ, IFIRST, IFRSTM, IITER, ILAST,
     $                   ILASTM, IN, ISCHUR, ISTART, J, JC, JCH, JITER,
     $                   JR, MAXIT
      DOUBLE PRECISION   A11, A12, A1I, A1R, A21, A22, A2I, A2R, AD11,
     $                   AD11L, AD12, AD12L, AD21, AD21L, AD22, AD22L,
     $                   AD32L, AN, ANORM, ASCALE, ATOL, B11, B1A, B1I,
     $                   B1R, B22, B2A, B2I, B2R, BN, BNORM, BSCALE,
     $                   BTOL, C, C11I, C11R, C12, C21, C22I, C22R, CL,
     $                   CQ, CR, CZ, ESHIFT, S, S1, S1INV, S2, SAFMAX,
     $                   SAFMIN, SCALE, SL, SQI, SQR, SR, SZI, SZR, T,
     $                   TAU, TEMP, TEMP2, TEMPI, TEMPR, U1, U12, U12L,
     $                   U2, ULP, VS, W11, W12, W21, W22, WABS, WI, WR,
     $                   WR2
*     ..
*     .. Local Arrays ..
      DOUBLE PRECISION   V( 3 )
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      DOUBLE PRECISION   DLAMCH, DLANHS, DLAPY2, DLAPY3
      EXTERNAL           LSAME, DLAMCH, DLANHS, DLAPY2, DLAPY3
*     ..
*     .. External Subroutines ..
      EXTERNAL           DLAG2, DLARFG, DLARTG, DLASET, DLASV2, DROT,
     $                   XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, DBLE, MAX, MIN, SQRT
*     ..
*     .. Executable Statements ..
*
*     Decode JOB, COMPQ, COMPZ
*
      IF( LSAME( JOB, 'E' ) ) THEN
         ILSCHR = .FALSE.
         ISCHUR = 1
      ELSE IF( LSAME( JOB, 'S' ) ) THEN
         ILSCHR = .TRUE.
         ISCHUR = 2
      ELSE
         ISCHUR = 0
      END IF
*
      IF( LSAME( COMPQ, 'N' ) ) THEN
         ILQ = .FALSE.
         ICOMPQ = 1
      ELSE IF( LSAME( COMPQ, 'V' ) ) THEN
         ILQ = .TRUE.
         ICOMPQ = 2
      ELSE IF( LSAME( COMPQ, 'I' ) ) THEN
         ILQ = .TRUE.
         ICOMPQ = 3
      ELSE
         ICOMPQ = 0
      END IF
*
      IF( LSAME( COMPZ, 'N' ) ) THEN
         ILZ = .FALSE.
         ICOMPZ = 1
      ELSE IF( LSAME( COMPZ, 'V' ) ) THEN
         ILZ = .TRUE.
         ICOMPZ = 2
      ELSE IF( LSAME( COMPZ, 'I' ) ) THEN
         ILZ = .TRUE.
         ICOMPZ = 3
      ELSE
         ICOMPZ = 0
      END IF
*
*     Check Argument Values
*
      INFO = 0
      WORK( 1 ) = MAX( 1, N )
      LQUERY = ( LWORK.EQ.-1 )
      IF( ISCHUR.EQ.0 ) THEN
         INFO = -1
      ELSE IF( ICOMPQ.EQ.0 ) THEN
         INFO = -2
      ELSE IF( ICOMPZ.EQ.0 ) THEN
         INFO = -3
      ELSE IF( N.LT.0 ) THEN
         INFO = -4
      ELSE IF( ILO.LT.1 ) THEN
         INFO = -5
      ELSE IF( IHI.GT.N .OR. IHI.LT.ILO-1 ) THEN
         INFO = -6
      ELSE IF( LDA.LT.N ) THEN
         INFO = -8
      ELSE IF( LDB.LT.N ) THEN
         INFO = -10
      ELSE IF( LDQ.LT.1 .OR. ( ILQ .AND. LDQ.LT.N ) ) THEN
         INFO = -15
      ELSE IF( LDZ.LT.1 .OR. ( ILZ .AND. LDZ.LT.N ) ) THEN
         INFO = -17
      ELSE IF( LWORK.LT.MAX( 1, N ) .AND. .NOT.LQUERY ) THEN
         INFO = -19
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DHGEQZ', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.LE.0 ) THEN
         WORK( 1 ) = DBLE( 1 )
         RETURN
      END IF
*
*     Initialize Q and Z
*
      IF( ICOMPQ.EQ.3 )
     $   CALL DLASET( 'Full', N, N, ZERO, ONE, Q, LDQ )
      IF( ICOMPZ.EQ.3 )
     $   CALL DLASET( 'Full', N, N, ZERO, ONE, Z, LDZ )
*
*     Machine Constants
*
      IN = IHI + 1 - ILO
      SAFMIN = DLAMCH( 'S' )
      SAFMAX = ONE / SAFMIN
      ULP = DLAMCH( 'E' )*DLAMCH( 'B' )
      ANORM = DLANHS( 'F', IN, A( ILO, ILO ), LDA, WORK )
      BNORM = DLANHS( 'F', IN, B( ILO, ILO ), LDB, WORK )
      ATOL = MAX( SAFMIN, ULP*ANORM )
      BTOL = MAX( SAFMIN, ULP*BNORM )
      ASCALE = ONE / MAX( SAFMIN, ANORM )
      BSCALE = ONE / MAX( SAFMIN, BNORM )
*
*     Set Eigenvalues IHI+1:N
*
      DO 30 J = IHI + 1, N
         IF( B( J, J ).LT.ZERO ) THEN
            IF( ILSCHR ) THEN
               DO 10 JR = 1, J
                  A( JR, J ) = -A( JR, J )
                  B( JR, J ) = -B( JR, J )
   10          CONTINUE
            ELSE
               A( J, J ) = -A( J, J )
               B( J, J ) = -B( J, J )
            END IF
            IF( ILZ ) THEN
               DO 20 JR = 1, N
                  Z( JR, J ) = -Z( JR, J )
   20          CONTINUE
            END IF
         END IF
         ALPHAR( J ) = A( J, J )
         ALPHAI( J ) = ZERO
         BETA( J ) = B( J, J )
   30 CONTINUE
*
*     If IHI < ILO, skip QZ steps
*
      IF( IHI.LT.ILO )
     $   GO TO 380
*
*     MAIN QZ ITERATION LOOP
*
*     Initialize dynamic indices
*
*     Eigenvalues ILAST+1:N have been found.
*        Column operations modify rows IFRSTM:whatever.
*        Row operations modify columns whatever:ILASTM.
*
*     If only eigenvalues are being computed, then
*        IFRSTM is the row of the last splitting row above row ILAST;
*        this is always at least ILO.
*     IITER counts iterations since the last eigenvalue was found,
*        to tell when to use an extraordinary shift.
*     MAXIT is the maximum number of QZ sweeps allowed.
*
      ILAST = IHI
      IF( ILSCHR ) THEN
         IFRSTM = 1
         ILASTM = N
      ELSE
         IFRSTM = ILO
         ILASTM = IHI
      END IF
      IITER = 0
      ESHIFT = ZERO
      MAXIT = 30*( IHI-ILO+1 )
*
      DO 360 JITER = 1, MAXIT
*
*        Split the matrix if possible.
*
*        Two tests:
*           1: A(j,j-1)=0  or  j=ILO
*           2: B(j,j)=0
*
         IF( ILAST.EQ.ILO ) THEN
*
*           Special case: j=ILAST
*
            GO TO 80
         ELSE
            IF( ABS( A( ILAST, ILAST-1 ) ).LE.ATOL ) THEN
               A( ILAST, ILAST-1 ) = ZERO
               GO TO 80
            END IF
         END IF
*
         IF( ABS( B( ILAST, ILAST ) ).LE.BTOL ) THEN
            B( ILAST, ILAST ) = ZERO
            GO TO 70
         END IF
*
*        General case: j<ILAST
*
         DO 60 J = ILAST - 1, ILO, -1
*
*           Test 1: for A(j,j-1)=0 or j=ILO
*
            IF( J.EQ.ILO ) THEN
               ILAZRO = .TRUE.
            ELSE
               IF( ABS( A( J, J-1 ) ).LE.ATOL ) THEN
                  A( J, J-1 ) = ZERO
                  ILAZRO = .TRUE.
               ELSE
                  ILAZRO = .FALSE.
               END IF
            END IF
*
*           Test 2: for B(j,j)=0
*
            IF( ABS( B( J, J ) ).LT.BTOL ) THEN
               B( J, J ) = ZERO
*
*              Test 1a: Check for 2 consecutive small subdiagonals in A
*
               ILAZR2 = .FALSE.
               IF( .NOT.ILAZRO ) THEN
                  TEMP = ABS( A( J, J-1 ) )
                  TEMP2 = ABS( A( J, J ) )
                  TEMPR = MAX( TEMP, TEMP2 )
                  IF( TEMPR.LT.ONE .AND. TEMPR.NE.ZERO ) THEN
                     TEMP = TEMP / TEMPR
                     TEMP2 = TEMP2 / TEMPR
                  END IF
                  IF( TEMP*( ASCALE*ABS( A( J+1, J ) ) ).LE.TEMP2*
     $                ( ASCALE*ATOL ) )ILAZR2 = .TRUE.
               END IF
*
*              If both tests pass (1 & 2), i.e., the leading diagonal
*              element of B in the block is zero, split a 1x1 block off
*              at the top. (I.e., at the J-th row/column) The leading
*              diagonal element of the remainder can also be zero, so
*              this may have to be done repeatedly.
*
               IF( ILAZRO .OR. ILAZR2 ) THEN
                  DO 40 JCH = J, ILAST - 1
                     TEMP = A( JCH, JCH )
                     CALL DLARTG( TEMP, A( JCH+1, JCH ), C, S,
     $                            A( JCH, JCH ) )
                     A( JCH+1, JCH ) = ZERO
                     CALL DROT( ILASTM-JCH, A( JCH, JCH+1 ), LDA,
     $                          A( JCH+1, JCH+1 ), LDA, C, S )
                     CALL DROT( ILASTM-JCH, B( JCH, JCH+1 ), LDB,
     $                          B( JCH+1, JCH+1 ), LDB, C, S )
                     IF( ILQ )
     $                  CALL DROT( N, Q( 1, JCH ), 1, Q( 1, JCH+1 ), 1,
     $                             C, S )
                     IF( ILAZR2 )
     $                  A( JCH, JCH-1 ) = A( JCH, JCH-1 )*C
                     ILAZR2 = .FALSE.
                     IF( ABS( B( JCH+1, JCH+1 ) ).GE.BTOL ) THEN
                        IF( JCH+1.GE.ILAST ) THEN
                           GO TO 80
                        ELSE
                           IFIRST = JCH + 1
                           GO TO 110
                        END IF
                     END IF
                     B( JCH+1, JCH+1 ) = ZERO
   40             CONTINUE
                  GO TO 70
               ELSE
*
*                 Only test 2 passed -- chase the zero to B(ILAST,ILAST)
*                 Then process as in the case B(ILAST,ILAST)=0
*
                  DO 50 JCH = J, ILAST - 1
                     TEMP = B( JCH, JCH+1 )
                     CALL DLARTG( TEMP, B( JCH+1, JCH+1 ), C, S,
     $                            B( JCH, JCH+1 ) )
                     B( JCH+1, JCH+1 ) = ZERO
                     IF( JCH.LT.ILASTM-1 )
     $                  CALL DROT( ILASTM-JCH-1, B( JCH, JCH+2 ), LDB,
     $                             B( JCH+1, JCH+2 ), LDB, C, S )
                     CALL DROT( ILASTM-JCH+2, A( JCH, JCH-1 ), LDA,
     $                          A( JCH+1, JCH-1 ), LDA, C, S )
                     IF( ILQ )
     $                  CALL DROT( N, Q( 1, JCH ), 1, Q( 1, JCH+1 ), 1,
     $                             C, S )
                     TEMP = A( JCH+1, JCH )
                     CALL DLARTG( TEMP, A( JCH+1, JCH-1 ), C, S,
     $                            A( JCH+1, JCH ) )
                     A( JCH+1, JCH-1 ) = ZERO
                     CALL DROT( JCH+1-IFRSTM, A( IFRSTM, JCH ), 1,
     $                          A( IFRSTM, JCH-1 ), 1, C, S )
                     CALL DROT( JCH-IFRSTM, B( IFRSTM, JCH ), 1,
     $                          B( IFRSTM, JCH-1 ), 1, C, S )
                     IF( ILZ )
     $                  CALL DROT( N, Z( 1, JCH ), 1, Z( 1, JCH-1 ), 1,
     $                             C, S )
   50             CONTINUE
                  GO TO 70
               END IF
            ELSE IF( ILAZRO ) THEN
*
*              Only test 1 passed -- work on J:ILAST
*
               IFIRST = J
               GO TO 110
            END IF
*
*           Neither test passed -- try next J
*
   60    CONTINUE
*
*        (Drop-through is "impossible")
*
         INFO = N + 1
         GO TO 420
*
*        B(ILAST,ILAST)=0 -- clear A(ILAST,ILAST-1) to split off a
*        1x1 block.
*
   70    CONTINUE
         TEMP = A( ILAST, ILAST )
         CALL DLARTG( TEMP, A( ILAST, ILAST-1 ), C, S,
     $                A( ILAST, ILAST ) )
         A( ILAST, ILAST-1 ) = ZERO
         CALL DROT( ILAST-IFRSTM, A( IFRSTM, ILAST ), 1,
     $              A( IFRSTM, ILAST-1 ), 1, C, S )
         CALL DROT( ILAST-IFRSTM, B( IFRSTM, ILAST ), 1,
     $              B( IFRSTM, ILAST-1 ), 1, C, S )
         IF( ILZ )
     $      CALL DROT( N, Z( 1, ILAST ), 1, Z( 1, ILAST-1 ), 1, C, S )
*
*        A(ILAST,ILAST-1)=0 -- Standardize B, set ALPHAR, ALPHAI,
*                              and BETA
*
   80    CONTINUE
         IF( B( ILAST, ILAST ).LT.ZERO ) THEN
            IF( ILSCHR ) THEN
               DO 90 J = IFRSTM, ILAST
                  A( J, ILAST ) = -A( J, ILAST )
                  B( J, ILAST ) = -B( J, ILAST )
   90          CONTINUE
            ELSE
               A( ILAST, ILAST ) = -A( ILAST, ILAST )
               B( ILAST, ILAST ) = -B( ILAST, ILAST )
            END IF
            IF( ILZ ) THEN
               DO 100 J = 1, N
                  Z( J, ILAST ) = -Z( J, ILAST )
  100          CONTINUE
            END IF
         END IF
         ALPHAR( ILAST ) = A( ILAST, ILAST )
         ALPHAI( ILAST ) = ZERO
         BETA( ILAST ) = B( ILAST, ILAST )
*
*        Go to next block -- exit if finished.
*
         ILAST = ILAST - 1
         IF( ILAST.LT.ILO )
     $      GO TO 380
*
*        Reset counters
*
         IITER = 0
         ESHIFT = ZERO
         IF( .NOT.ILSCHR ) THEN
            ILASTM = ILAST
            IF( IFRSTM.GT.ILAST )
     $         IFRSTM = ILO
         END IF
         GO TO 350
*
*        QZ step
*
*        This iteration only involves rows/columns IFIRST:ILAST. We
*        assume IFIRST < ILAST, and that the diagonal of B is non-zero.
*
  110    CONTINUE
         IITER = IITER + 1
         IF( .NOT.ILSCHR ) THEN
            IFRSTM = IFIRST
         END IF
*
*        Compute single shifts.
*
*        At this point, IFIRST < ILAST, and the diagonal elements of
*        B(IFIRST:ILAST,IFIRST,ILAST) are larger than BTOL (in
*        magnitude)
*
         IF( ( IITER / 10 )*10.EQ.IITER ) THEN
*
*           Exceptional shift.  Chosen for no particularly good reason.
*           (Single shift only.)
*
            IF( ( DBLE( MAXIT )*SAFMIN )*ABS( A( ILAST-1, ILAST ) ).LT.
     $          ABS( B( ILAST-1, ILAST-1 ) ) ) THEN
               ESHIFT = ESHIFT + A( ILAST-1, ILAST ) /
     $                  B( ILAST-1, ILAST-1 )
            ELSE
               ESHIFT = ESHIFT + ONE / ( SAFMIN*DBLE( MAXIT ) )
            END IF
            S1 = ONE
            WR = ESHIFT
*
         ELSE
*
*           Shifts based on the generalized eigenvalues of the
*           bottom-right 2x2 block of A and B. The first eigenvalue
*           returned by DLAG2 is the Wilkinson shift (AEP p.512),
*
            CALL DLAG2( A( ILAST-1, ILAST-1 ), LDA,
     $                  B( ILAST-1, ILAST-1 ), LDB, SAFMIN*SAFETY, S1,
     $                  S2, WR, WR2, WI )
*
            TEMP = MAX( S1, SAFMIN*MAX( ONE, ABS( WR ), ABS( WI ) ) )
            IF( WI.NE.ZERO )
     $         GO TO 200
         END IF
*
*        Fiddle with shift to avoid overflow
*
         TEMP = MIN( ASCALE, ONE )*( HALF*SAFMAX )
         IF( S1.GT.TEMP ) THEN
            SCALE = TEMP / S1
         ELSE
            SCALE = ONE
         END IF
*
         TEMP = MIN( BSCALE, ONE )*( HALF*SAFMAX )
         IF( ABS( WR ).GT.TEMP )
     $      SCALE = MIN( SCALE, TEMP / ABS( WR ) )
         S1 = SCALE*S1
         WR = SCALE*WR
*
*        Now check for two consecutive small subdiagonals.
*
         DO 120 J = ILAST - 1, IFIRST + 1, -1
            ISTART = J
            TEMP = ABS( S1*A( J, J-1 ) )
            TEMP2 = ABS( S1*A( J, J )-WR*B( J, J ) )
            TEMPR = MAX( TEMP, TEMP2 )
            IF( TEMPR.LT.ONE .AND. TEMPR.NE.ZERO ) THEN
               TEMP = TEMP / TEMPR
               TEMP2 = TEMP2 / TEMPR
            END IF
            IF( ABS( ( ASCALE*A( J+1, J ) )*TEMP ).LE.( ASCALE*ATOL )*
     $          TEMP2 )GO TO 130
  120    CONTINUE
*
         ISTART = IFIRST
  130    CONTINUE
*
*        Do an implicit single-shift QZ sweep.
*
*        Initial Q
*
         TEMP = S1*A( ISTART, ISTART ) - WR*B( ISTART, ISTART )
         TEMP2 = S1*A( ISTART+1, ISTART )
         CALL DLARTG( TEMP, TEMP2, C, S, TEMPR )
*
*        Sweep
*
         DO 190 J = ISTART, ILAST - 1
            IF( J.GT.ISTART ) THEN
               TEMP = A( J, J-1 )
               CALL DLARTG( TEMP, A( J+1, J-1 ), C, S, A( J, J-1 ) )
               A( J+1, J-1 ) = ZERO
            END IF
*
            DO 140 JC = J, ILASTM
               TEMP = C*A( J, JC ) + S*A( J+1, JC )
               A( J+1, JC ) = -S*A( J, JC ) + C*A( J+1, JC )
               A( J, JC ) = TEMP
               TEMP2 = C*B( J, JC ) + S*B( J+1, JC )
               B( J+1, JC ) = -S*B( J, JC ) + C*B( J+1, JC )
               B( J, JC ) = TEMP2
  140       CONTINUE
            IF( ILQ ) THEN
               DO 150 JR = 1, N
                  TEMP = C*Q( JR, J ) + S*Q( JR, J+1 )
                  Q( JR, J+1 ) = -S*Q( JR, J ) + C*Q( JR, J+1 )
                  Q( JR, J ) = TEMP
  150          CONTINUE
            END IF
*
            TEMP = B( J+1, J+1 )
            CALL DLARTG( TEMP, B( J+1, J ), C, S, B( J+1, J+1 ) )
            B( J+1, J ) = ZERO
*
            DO 160 JR = IFRSTM, MIN( J+2, ILAST )
               TEMP = C*A( JR, J+1 ) + S*A( JR, J )
               A( JR, J ) = -S*A( JR, J+1 ) + C*A( JR, J )
               A( JR, J+1 ) = TEMP
  160       CONTINUE
            DO 170 JR = IFRSTM, J
               TEMP = C*B( JR, J+1 ) + S*B( JR, J )
               B( JR, J ) = -S*B( JR, J+1 ) + C*B( JR, J )
               B( JR, J+1 ) = TEMP
  170       CONTINUE
            IF( ILZ ) THEN
               DO 180 JR = 1, N
                  TEMP = C*Z( JR, J+1 ) + S*Z( JR, J )
                  Z( JR, J ) = -S*Z( JR, J+1 ) + C*Z( JR, J )
                  Z( JR, J+1 ) = TEMP
  180          CONTINUE
            END IF
  190    CONTINUE
*
         GO TO 350
*
*        Use Francis double-shift
*
*        Note: the Francis double-shift should work with real shifts,
*              but only if the block is at least 3x3.
*              This code may break if this point is reached with
*              a 2x2 block with real eigenvalues.
*
  200    CONTINUE
         IF( IFIRST+1.EQ.ILAST ) THEN
*
*           Special case -- 2x2 block with complex eigenvectors
*
*           Step 1: Standardize, that is, rotate so that
*
*                       ( B11  0  )
*                   B = (         )  with B11 non-negative.
*                       (  0  B22 )
*
            CALL DLASV2( B( ILAST-1, ILAST-1 ), B( ILAST-1, ILAST ),
     $                   B( ILAST, ILAST ), B22, B11, SR, CR, SL, CL )
*
            IF( B11.LT.ZERO ) THEN
               CR = -CR
               SR = -SR
               B11 = -B11
               B22 = -B22
            END IF
*
            CALL DROT( ILASTM+1-IFIRST, A( ILAST-1, ILAST-1 ), LDA,
     $                 A( ILAST, ILAST-1 ), LDA, CL, SL )
            CALL DROT( ILAST+1-IFRSTM, A( IFRSTM, ILAST-1 ), 1,
     $                 A( IFRSTM, ILAST ), 1, CR, SR )
*
            IF( ILAST.LT.ILASTM )
     $         CALL DROT( ILASTM-ILAST, B( ILAST-1, ILAST+1 ), LDB,
     $                    B( ILAST, ILAST+1 ), LDA, CL, SL )
            IF( IFRSTM.LT.ILAST-1 )
     $         CALL DROT( IFIRST-IFRSTM, B( IFRSTM, ILAST-1 ), 1,
     $                    B( IFRSTM, ILAST ), 1, CR, SR )
*
            IF( ILQ )
     $         CALL DROT( N, Q( 1, ILAST-1 ), 1, Q( 1, ILAST ), 1, CL,
     $                    SL )
            IF( ILZ )
     $         CALL DROT( N, Z( 1, ILAST-1 ), 1, Z( 1, ILAST ), 1, CR,
     $                    SR )
*
            B( ILAST-1, ILAST-1 ) = B11
            B( ILAST-1, ILAST ) = ZERO
            B( ILAST, ILAST-1 ) = ZERO
            B( ILAST, ILAST ) = B22
*
*           If B22 is negative, negate column ILAST
*
            IF( B22.LT.ZERO ) THEN
               DO 210 J = IFRSTM, ILAST
                  A( J, ILAST ) = -A( J, ILAST )
                  B( J, ILAST ) = -B( J, ILAST )
  210          CONTINUE
*
               IF( ILZ ) THEN
                  DO 220 J = 1, N
                     Z( J, ILAST ) = -Z( J, ILAST )
  220             CONTINUE
               END IF
            END IF
*
*           Step 2: Compute ALPHAR, ALPHAI, and BETA (see refs.)
*
*           Recompute shift
*
            CALL DLAG2( A( ILAST-1, ILAST-1 ), LDA,
     $                  B( ILAST-1, ILAST-1 ), LDB, SAFMIN*SAFETY, S1,
     $                  TEMP, WR, TEMP2, WI )
*
*           If standardization has perturbed the shift onto real line,
*           do another (real single-shift) QR step.
*
            IF( WI.EQ.ZERO )
     $         GO TO 350
            S1INV = ONE / S1
*
*           Do EISPACK (QZVAL) computation of alpha and beta
*
            A11 = A( ILAST-1, ILAST-1 )
            A21 = A( ILAST, ILAST-1 )
            A12 = A( ILAST-1, ILAST )
            A22 = A( ILAST, ILAST )
*
*           Compute complex Givens rotation on right
*           (Assume some element of C = (sA - wB) > unfl )
*                            __
*           (sA - wB) ( CZ   -SZ )
*                     ( SZ    CZ )
*
            C11R = S1*A11 - WR*B11
            C11I = -WI*B11
            C12 = S1*A12
            C21 = S1*A21
            C22R = S1*A22 - WR*B22
            C22I = -WI*B22
*
            IF( ABS( C11R )+ABS( C11I )+ABS( C12 ).GT.ABS( C21 )+
     $          ABS( C22R )+ABS( C22I ) ) THEN
               T = DLAPY3( C12, C11R, C11I )
               CZ = C12 / T
               SZR = -C11R / T
               SZI = -C11I / T
            ELSE
               CZ = DLAPY2( C22R, C22I )
               IF( CZ.LE.SAFMIN ) THEN
                  CZ = ZERO
                  SZR = ONE
                  SZI = ZERO
               ELSE
                  TEMPR = C22R / CZ
                  TEMPI = C22I / CZ
                  T = DLAPY2( CZ, C21 )
                  CZ = CZ / T
                  SZR = -C21*TEMPR / T
                  SZI = C21*TEMPI / T
               END IF
            END IF
*
*           Compute Givens rotation on left
*
*           (  CQ   SQ )
*           (  __      )  A or B
*           ( -SQ   CQ )
*
            AN = ABS( A11 ) + ABS( A12 ) + ABS( A21 ) + ABS( A22 )
            BN = ABS( B11 ) + ABS( B22 )
            WABS = ABS( WR ) + ABS( WI )
            IF( S1*AN.GT.WABS*BN ) THEN
               CQ = CZ*B11
               SQR = SZR*B22
               SQI = -SZI*B22
            ELSE
               A1R = CZ*A11 + SZR*A12
               A1I = SZI*A12
               A2R = CZ*A21 + SZR*A22
               A2I = SZI*A22
               CQ = DLAPY2( A1R, A1I )
               IF( CQ.LE.SAFMIN ) THEN
                  CQ = ZERO
                  SQR = ONE
                  SQI = ZERO
               ELSE
                  TEMPR = A1R / CQ
                  TEMPI = A1I / CQ
                  SQR = TEMPR*A2R + TEMPI*A2I
                  SQI = TEMPI*A2R - TEMPR*A2I
               END IF
            END IF
            T = DLAPY3( CQ, SQR, SQI )
            CQ = CQ / T
            SQR = SQR / T
            SQI = SQI / T
*
*           Compute diagonal elements of QBZ
*
            TEMPR = SQR*SZR - SQI*SZI
            TEMPI = SQR*SZI + SQI*SZR
            B1R = CQ*CZ*B11 + TEMPR*B22
            B1I = TEMPI*B22
            B1A = DLAPY2( B1R, B1I )
            B2R = CQ*CZ*B22 + TEMPR*B11
            B2I = -TEMPI*B11
            B2A = DLAPY2( B2R, B2I )
*
*           Normalize so beta > 0, and Im( alpha1 ) > 0
*
            BETA( ILAST-1 ) = B1A
            BETA( ILAST ) = B2A
            ALPHAR( ILAST-1 ) = ( WR*B1A )*S1INV
            ALPHAI( ILAST-1 ) = ( WI*B1A )*S1INV
            ALPHAR( ILAST ) = ( WR*B2A )*S1INV
            ALPHAI( ILAST ) = -( WI*B2A )*S1INV
*
*           Step 3: Go to next block -- exit if finished.
*
            ILAST = IFIRST - 1
            IF( ILAST.LT.ILO )
     $         GO TO 380
*
*           Reset counters
*
            IITER = 0
            ESHIFT = ZERO
            IF( .NOT.ILSCHR ) THEN
               ILASTM = ILAST
               IF( IFRSTM.GT.ILAST )
     $            IFRSTM = ILO
            END IF
            GO TO 350
         ELSE
*
*           Usual case: 3x3 or larger block, using Francis implicit
*                       double-shift
*
*                                    2
*           Eigenvalue equation is  w  - c w + d = 0,
*
*                                         -1 2        -1
*           so compute 1st column of  (A B  )  - c A B   + d
*           using the formula in QZIT (from EISPACK)
*
*           We assume that the block is at least 3x3
*
            AD11 = ( ASCALE*A( ILAST-1, ILAST-1 ) ) /
     $             ( BSCALE*B( ILAST-1, ILAST-1 ) )
            AD21 = ( ASCALE*A( ILAST, ILAST-1 ) ) /
     $             ( BSCALE*B( ILAST-1, ILAST-1 ) )
            AD12 = ( ASCALE*A( ILAST-1, ILAST ) ) /
     $             ( BSCALE*B( ILAST, ILAST ) )
            AD22 = ( ASCALE*A( ILAST, ILAST ) ) /
     $             ( BSCALE*B( ILAST, ILAST ) )
            U12 = B( ILAST-1, ILAST ) / B( ILAST, ILAST )
            AD11L = ( ASCALE*A( IFIRST, IFIRST ) ) /
     $              ( BSCALE*B( IFIRST, IFIRST ) )
            AD21L = ( ASCALE*A( IFIRST+1, IFIRST ) ) /
     $              ( BSCALE*B( IFIRST, IFIRST ) )
            AD12L = ( ASCALE*A( IFIRST, IFIRST+1 ) ) /
     $              ( BSCALE*B( IFIRST+1, IFIRST+1 ) )
            AD22L = ( ASCALE*A( IFIRST+1, IFIRST+1 ) ) /
     $              ( BSCALE*B( IFIRST+1, IFIRST+1 ) )
            AD32L = ( ASCALE*A( IFIRST+2, IFIRST+1 ) ) /
     $              ( BSCALE*B( IFIRST+1, IFIRST+1 ) )
            U12L = B( IFIRST, IFIRST+1 ) / B( IFIRST+1, IFIRST+1 )
*
            V( 1 ) = ( AD11-AD11L )*( AD22-AD11L ) - AD12*AD21 +
     $               AD21*U12*AD11L + ( AD12L-AD11L*U12L )*AD21L
            V( 2 ) = ( ( AD22L-AD11L )-AD21L*U12L-( AD11-AD11L )-
     $               ( AD22-AD11L )+AD21*U12 )*AD21L
            V( 3 ) = AD32L*AD21L
*
            ISTART = IFIRST
*
            CALL DLARFG( 3, V( 1 ), V( 2 ), 1, TAU )
            V( 1 ) = ONE
*
*           Sweep
*
            DO 290 J = ISTART, ILAST - 2
*
*              All but last elements: use 3x3 Householder transforms.
*
*              Zero (j-1)st column of A
*
               IF( J.GT.ISTART ) THEN
                  V( 1 ) = A( J, J-1 )
                  V( 2 ) = A( J+1, J-1 )
                  V( 3 ) = A( J+2, J-1 )
*
                  CALL DLARFG( 3, A( J, J-1 ), V( 2 ), 1, TAU )
                  V( 1 ) = ONE
                  A( J+1, J-1 ) = ZERO
                  A( J+2, J-1 ) = ZERO
               END IF
*
               DO 230 JC = J, ILASTM
                  TEMP = TAU*( A( J, JC )+V( 2 )*A( J+1, JC )+V( 3 )*
     $                   A( J+2, JC ) )
                  A( J, JC ) = A( J, JC ) - TEMP
                  A( J+1, JC ) = A( J+1, JC ) - TEMP*V( 2 )
                  A( J+2, JC ) = A( J+2, JC ) - TEMP*V( 3 )
                  TEMP2 = TAU*( B( J, JC )+V( 2 )*B( J+1, JC )+V( 3 )*
     $                    B( J+2, JC ) )
                  B( J, JC ) = B( J, JC ) - TEMP2
                  B( J+1, JC ) = B( J+1, JC ) - TEMP2*V( 2 )
                  B( J+2, JC ) = B( J+2, JC ) - TEMP2*V( 3 )
  230          CONTINUE
               IF( ILQ ) THEN
                  DO 240 JR = 1, N
                     TEMP = TAU*( Q( JR, J )+V( 2 )*Q( JR, J+1 )+V( 3 )*
     $                      Q( JR, J+2 ) )
                     Q( JR, J ) = Q( JR, J ) - TEMP
                     Q( JR, J+1 ) = Q( JR, J+1 ) - TEMP*V( 2 )
                     Q( JR, J+2 ) = Q( JR, J+2 ) - TEMP*V( 3 )
  240             CONTINUE
               END IF
*
*              Zero j-th column of B (see DLAGBC for details)
*
*              Swap rows to pivot
*
               ILPIVT = .FALSE.
               TEMP = MAX( ABS( B( J+1, J+1 ) ), ABS( B( J+1, J+2 ) ) )
               TEMP2 = MAX( ABS( B( J+2, J+1 ) ), ABS( B( J+2, J+2 ) ) )
               IF( MAX( TEMP, TEMP2 ).LT.SAFMIN ) THEN
                  SCALE = ZERO
                  U1 = ONE
                  U2 = ZERO
                  GO TO 250
               ELSE IF( TEMP.GE.TEMP2 ) THEN
                  W11 = B( J+1, J+1 )
                  W21 = B( J+2, J+1 )
                  W12 = B( J+1, J+2 )
                  W22 = B( J+2, J+2 )
                  U1 = B( J+1, J )
                  U2 = B( J+2, J )
               ELSE
                  W21 = B( J+1, J+1 )
                  W11 = B( J+2, J+1 )
                  W22 = B( J+1, J+2 )
                  W12 = B( J+2, J+2 )
                  U2 = B( J+1, J )
                  U1 = B( J+2, J )
               END IF
*
*              Swap columns if nec.
*
               IF( ABS( W12 ).GT.ABS( W11 ) ) THEN
                  ILPIVT = .TRUE.
                  TEMP = W12
                  TEMP2 = W22
                  W12 = W11
                  W22 = W21
                  W11 = TEMP
                  W21 = TEMP2
               END IF
*
*              LU-factor
*
               TEMP = W21 / W11
               U2 = U2 - TEMP*U1
               W22 = W22 - TEMP*W12
               W21 = ZERO
*
*              Compute SCALE
*
               SCALE = ONE
               IF( ABS( W22 ).LT.SAFMIN ) THEN
                  SCALE = ZERO
                  U2 = ONE
                  U1 = -W12 / W11
                  GO TO 250
               END IF
               IF( ABS( W22 ).LT.ABS( U2 ) )
     $            SCALE = ABS( W22 / U2 )
               IF( ABS( W11 ).LT.ABS( U1 ) )
     $            SCALE = MIN( SCALE, ABS( W11 / U1 ) )
*
*              Solve
*
               U2 = ( SCALE*U2 ) / W22
               U1 = ( SCALE*U1-W12*U2 ) / W11
*
  250          CONTINUE
               IF( ILPIVT ) THEN
                  TEMP = U2
                  U2 = U1
                  U1 = TEMP
               END IF
*
*              Compute Householder Vector
*
               T = SQRT( SCALE**2+U1**2+U2**2 )
               TAU = ONE + SCALE / T
               VS = -ONE / ( SCALE+T )
               V( 1 ) = ONE
               V( 2 ) = VS*U1
               V( 3 ) = VS*U2
*
*              Apply transformations from the right.
*
               DO 260 JR = IFRSTM, MIN( J+3, ILAST )
                  TEMP = TAU*( A( JR, J )+V( 2 )*A( JR, J+1 )+V( 3 )*
     $                   A( JR, J+2 ) )
                  A( JR, J ) = A( JR, J ) - TEMP
                  A( JR, J+1 ) = A( JR, J+1 ) - TEMP*V( 2 )
                  A( JR, J+2 ) = A( JR, J+2 ) - TEMP*V( 3 )
  260          CONTINUE
               DO 270 JR = IFRSTM, J + 2
                  TEMP = TAU*( B( JR, J )+V( 2 )*B( JR, J+1 )+V( 3 )*
     $                   B( JR, J+2 ) )
                  B( JR, J ) = B( JR, J ) - TEMP
                  B( JR, J+1 ) = B( JR, J+1 ) - TEMP*V( 2 )
                  B( JR, J+2 ) = B( JR, J+2 ) - TEMP*V( 3 )
  270          CONTINUE
               IF( ILZ ) THEN
                  DO 280 JR = 1, N
                     TEMP = TAU*( Z( JR, J )+V( 2 )*Z( JR, J+1 )+V( 3 )*
     $                      Z( JR, J+2 ) )
                     Z( JR, J ) = Z( JR, J ) - TEMP
                     Z( JR, J+1 ) = Z( JR, J+1 ) - TEMP*V( 2 )
                     Z( JR, J+2 ) = Z( JR, J+2 ) - TEMP*V( 3 )
  280             CONTINUE
               END IF
               B( J+1, J ) = ZERO
               B( J+2, J ) = ZERO
  290       CONTINUE
*
*           Last elements: Use Givens rotations
*
*           Rotations from the left
*
            J = ILAST - 1
            TEMP = A( J, J-1 )
            CALL DLARTG( TEMP, A( J+1, J-1 ), C, S, A( J, J-1 ) )
            A( J+1, J-1 ) = ZERO
*
            DO 300 JC = J, ILASTM
               TEMP = C*A( J, JC ) + S*A( J+1, JC )
               A( J+1, JC ) = -S*A( J, JC ) + C*A( J+1, JC )
               A( J, JC ) = TEMP
               TEMP2 = C*B( J, JC ) + S*B( J+1, JC )
               B( J+1, JC ) = -S*B( J, JC ) + C*B( J+1, JC )
               B( J, JC ) = TEMP2
  300       CONTINUE
            IF( ILQ ) THEN
               DO 310 JR = 1, N
                  TEMP = C*Q( JR, J ) + S*Q( JR, J+1 )
                  Q( JR, J+1 ) = -S*Q( JR, J ) + C*Q( JR, J+1 )
                  Q( JR, J ) = TEMP
  310          CONTINUE
            END IF
*
*           Rotations from the right.
*
            TEMP = B( J+1, J+1 )
            CALL DLARTG( TEMP, B( J+1, J ), C, S, B( J+1, J+1 ) )
            B( J+1, J ) = ZERO
*
            DO 320 JR = IFRSTM, ILAST
               TEMP = C*A( JR, J+1 ) + S*A( JR, J )
               A( JR, J ) = -S*A( JR, J+1 ) + C*A( JR, J )
               A( JR, J+1 ) = TEMP
  320       CONTINUE
            DO 330 JR = IFRSTM, ILAST - 1
               TEMP = C*B( JR, J+1 ) + S*B( JR, J )
               B( JR, J ) = -S*B( JR, J+1 ) + C*B( JR, J )
               B( JR, J+1 ) = TEMP
  330       CONTINUE
            IF( ILZ ) THEN
               DO 340 JR = 1, N
                  TEMP = C*Z( JR, J+1 ) + S*Z( JR, J )
                  Z( JR, J ) = -S*Z( JR, J+1 ) + C*Z( JR, J )
                  Z( JR, J+1 ) = TEMP
  340          CONTINUE
            END IF
*
*           End of Double-Shift code
*
         END IF
*
         GO TO 350
*
*        End of iteration loop
*
  350    CONTINUE
  360 CONTINUE
*
*     Drop-through = non-convergence
*
  370 CONTINUE
      INFO = ILAST
      GO TO 420
*
*     Successful completion of all QZ steps
*
  380 CONTINUE
*
*     Set Eigenvalues 1:ILO-1
*
      DO 410 J = 1, ILO - 1
         IF( B( J, J ).LT.ZERO ) THEN
            IF( ILSCHR ) THEN
               DO 390 JR = 1, J
                  A( JR, J ) = -A( JR, J )
                  B( JR, J ) = -B( JR, J )
  390          CONTINUE
            ELSE
               A( J, J ) = -A( J, J )
               B( J, J ) = -B( J, J )
            END IF
            IF( ILZ ) THEN
               DO 400 JR = 1, N
                  Z( JR, J ) = -Z( JR, J )
  400          CONTINUE
            END IF
         END IF
         ALPHAR( J ) = A( J, J )
         ALPHAI( J ) = ZERO
         BETA( J ) = B( J, J )
  410 CONTINUE
*
*     Normal Termination
*
      INFO = 0
*
*     Exit (other than argument error) -- return optimal workspace size
*
  420 CONTINUE
      WORK( 1 ) = DBLE( N )
      RETURN
*
*     End of DHGEQZ
*
      END

      SUBROUTINE ZPTSVX( FACT, N, NRHS, D, E, DF, EF, B, LDB, X, LDX,
     $                   RCOND, FERR, BERR, WORK, RWORK, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          FACT
      INTEGER            INFO, LDB, LDX, N, NRHS
      DOUBLE PRECISION   RCOND
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   BERR( * ), D( * ), DF( * ), FERR( * ),
     $                   RWORK( * )
      COMPLEX*16         B( LDB, * ), E( * ), EF( * ), WORK( * ),
     $                   X( LDX, * )
*     ..
*
*  Purpose
*  =======
*
*  ZPTSVX uses the factorization A = L*D*L**H to compute the solution
*  to a complex system of linear equations A*X = B, where A is an
*  N-by-N Hermitian positive definite tridiagonal matrix and X and B
*  are N-by-NRHS matrices.
*
*  Error bounds on the solution and a condition estimate are also
*  provided.
*
*  Description
*  ===========
*
*  The following steps are performed:
*
*  1. If FACT = 'N', the matrix A is factored as A = L*D*L**H, where L
*     is a unit lower bidiagonal matrix and D is diagonal.  The
*     factorization can also be regarded as having the form
*     A = U**H*D*U.
*
*  2. If the leading i-by-i principal minor is not positive definite,
*     then the routine returns with INFO = i. Otherwise, the factored
*     form of A is used to estimate the condition number of the matrix
*     A.  If the reciprocal of the condition number is less than machine
*     precision, INFO = N+1 is returned as a warning, but the routine
*     still goes on to solve for X and compute error bounds as
*     described below.
*
*  3. The system of equations is solved for X using the factored form
*     of A.
*
*  4. Iterative refinement is applied to improve the computed solution
*     matrix and calculate error bounds and backward error estimates
*     for it.
*
*  Arguments
*  =========
*
*  FACT    (input) CHARACTER*1
*          Specifies whether or not the factored form of the matrix
*          A is supplied on entry.
*          = 'F':  On entry, DF and EF contain the factored form of A.
*                  D, E, DF, and EF will not be modified.
*          = 'N':  The matrix A will be copied to DF and EF and
*                  factored.
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  NRHS    (input) INTEGER
*          The number of right hand sides, i.e., the number of columns
*          of the matrices B and X.  NRHS >= 0.
*
*  D       (input) DOUBLE PRECISION array, dimension (N)
*          The n diagonal elements of the tridiagonal matrix A.
*
*  E       (input) COMPLEX*16 array, dimension (N-1)
*          The (n-1) subdiagonal elements of the tridiagonal matrix A.
*
*  DF      (input or output) DOUBLE PRECISION array, dimension (N)
*          If FACT = 'F', then DF is an input argument and on entry
*          contains the n diagonal elements of the diagonal matrix D
*          from the L*D*L**H factorization of A.
*          If FACT = 'N', then DF is an output argument and on exit
*          contains the n diagonal elements of the diagonal matrix D
*          from the L*D*L**H factorization of A.
*
*  EF      (input or output) COMPLEX*16 array, dimension (N-1)
*          If FACT = 'F', then EF is an input argument and on entry
*          contains the (n-1) subdiagonal elements of the unit
*          bidiagonal factor L from the L*D*L**H factorization of A.
*          If FACT = 'N', then EF is an output argument and on exit
*          contains the (n-1) subdiagonal elements of the unit
*          bidiagonal factor L from the L*D*L**H factorization of A.
*
*  B       (input) COMPLEX*16 array, dimension (LDB,NRHS)
*          The N-by-NRHS right hand side matrix B.
*
*  LDB     (input) INTEGER
*          The leading dimension of the array B.  LDB >= max(1,N).
*
*  X       (output) COMPLEX*16 array, dimension (LDX,NRHS)
*          If INFO = 0 or INFO = N+1, the N-by-NRHS solution matrix X.
*
*  LDX     (input) INTEGER
*          The leading dimension of the array X.  LDX >= max(1,N).
*
*  RCOND   (output) DOUBLE PRECISION
*          The reciprocal condition number of the matrix A.  If RCOND
*          is less than the machine precision (in particular, if
*          RCOND = 0), the matrix is singular to working precision.
*          This condition is indicated by a return code of INFO > 0.
*
*  FERR    (output) DOUBLE PRECISION array, dimension (NRHS)
*          The forward error bound for each solution vector
*          X(j) (the j-th column of the solution matrix X).
*          If XTRUE is the true solution corresponding to X(j), FERR(j)
*          is an estimated upper bound for the magnitude of the largest
*          element in (X(j) - XTRUE) divided by the magnitude of the
*          largest element in X(j).
*
*  BERR    (output) DOUBLE PRECISION array, dimension (NRHS)
*          The componentwise relative backward error of each solution
*          vector X(j) (i.e., the smallest relative change in any
*          element of A or B that makes X(j) an exact solution).
*
*  WORK    (workspace) COMPLEX*16 array, dimension (N)
*
*  RWORK   (workspace) DOUBLE PRECISION array, dimension (N)
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*          > 0:  if INFO = i, and i is
*                <= N:  the leading minor of order i of A is
*                       not positive definite, so the factorization
*                       could not be completed, and the solution has not
*                       been computed. RCOND = 0 is returned.
*                = N+1: U is nonsingular, but RCOND is less than machine
*                       precision, meaning that the matrix is singular
*                       to working precision.  Nevertheless, the
*                       solution and error bounds are computed because
*                       there are a number of situations where the
*                       computed solution can be more accurate than the
*                       value of RCOND would suggest.
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO
      PARAMETER          ( ZERO = 0.0D+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            NOFACT
      DOUBLE PRECISION   ANORM
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      DOUBLE PRECISION   DLAMCH, ZLANHT
      EXTERNAL           LSAME, DLAMCH, ZLANHT
*     ..
*     .. External Subroutines ..
      EXTERNAL           DCOPY, XERBLA, ZCOPY, ZLACPY, ZPTCON, ZPTRFS,
     $                   ZPTTRF, ZPTTRS
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      NOFACT = LSAME( FACT, 'N' )
      IF( .NOT.NOFACT .AND. .NOT.LSAME( FACT, 'F' ) ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( NRHS.LT.0 ) THEN
         INFO = -3
      ELSE IF( LDB.LT.MAX( 1, N ) ) THEN
         INFO = -9
      ELSE IF( LDX.LT.MAX( 1, N ) ) THEN
         INFO = -11
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'ZPTSVX', -INFO )
         RETURN
      END IF
*
      IF( NOFACT ) THEN
*
*        Compute the L*D*L' (or U'*D*U) factorization of A.
*
         CALL DCOPY( N, D, 1, DF, 1 )
         IF( N.GT.1 )
     $      CALL ZCOPY( N-1, E, 1, EF, 1 )
         CALL ZPTTRF( N, DF, EF, INFO )
*
*        Return if INFO is non-zero.
*
         IF( INFO.NE.0 ) THEN
            IF( INFO.GT.0 )
     $         RCOND = ZERO
            RETURN
         END IF
      END IF
*
*     Compute the norm of the matrix A.
*
      ANORM = ZLANHT( '1', N, D, E )
*
*     Compute the reciprocal of the condition number of A.
*
      CALL ZPTCON( N, DF, EF, ANORM, RCOND, RWORK, INFO )
*
*     Set INFO = N+1 if the matrix is singular to working precision.
*
      IF( RCOND.LT.DLAMCH( 'Epsilon' ) )
     $   INFO = N + 1
*
*     Compute the solution vectors X.
*
      CALL ZLACPY( 'Full', N, NRHS, B, LDB, X, LDX )
      CALL ZPTTRS( 'Lower', N, NRHS, DF, EF, X, LDX, INFO )
*
*     Use iterative refinement to improve the computed solutions and
*     compute error bounds and backward error estimates for them.
*
      CALL ZPTRFS( 'Lower', N, NRHS, D, E, DF, EF, B, LDB, X, LDX, FERR,
     $             BERR, WORK, RWORK, INFO )
*
      RETURN
*
*     End of ZPTSVX
*
      END

C
C	$Id: gwiwdr.f,v 1.10 2008-07-27 00:21:08 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GWIWDR(ICNTX,RCNTX)
C
C***********************************************************************
C***********************************************************************
C**                                                                   **
C**                                                                   **
C**            Workstation driver for workstation type 3              **
C**         Workstation Independent Segment Storage  (WISS)           **
C**                                                                   **
C**                                                                   **
C***********************************************************************
C***********************************************************************
C
      IMPLICIT INTEGER (A-Z)
C
C  The current GKS attribut context is passed in via the arrays
C  ICNTX and RCNTX (see GZSRAT in awi for details on the order).
C
      INTEGER ICNTX(*)
      REAL    RCNTX(*)
C
C  Include all COMMONs .
C
      include 'gksin.h'
      include 'gwiwdt.h'
      include 'gwiwsl.h'
      include 'gwiadc.h'
      include 'gwiarq.h'
      include 'gwiast.h'
      include 'gwiadf.h'
      include 'gwiio.h'
      include 'gwiins.h'
      include 'gwiopc.h'
      include 'gwienu.h'
C
      SAVE
C
C  Initialize for this entry.
C
      RERR = 0
C
C  Check FCODE if last invocation indicated continuation.
C
      IF (MCONTS.EQ.1 .AND. FCODE.NE.MCODES)  GOTO 905
C
C  Copy and save function code and continuation flag.
C
        MCODES = FCODE
        MCONTS = CONT
C
C  Branch for function processing.  Testing of code organized to
C  minimize number of tests, by testing for most frequently expected
C  functions first.
C
C
C  Output primitives.
C
C      Code:  11   12   13   14   15   16
      GOTO  (110, 120, 130, 140, 150, 160)  MCODES-10
C
C  Primitive attributes.
C
      IF (MCODES.GE.21 .AND. MCODES.LE.43)  THEN
        CALL GWIPAT
        RETURN
      END IF
C
C  Control and escape functions.
C
C     Code:  -3   -2   -1    0    1
      GOTO (210, 220, 230, 240, 250,
     +      910, 270, 910, 910, 300)  MCODES+4
C     Code:   2    3    4    5    6
C
C
C   Segmentation functions.
C
      GOTO (420, 400, 410) MCODES-78
C
C  Clipping control function(s).
C
      IF (MCODES.EQ.61)  THEN
        CALL GWICLP(0)
        RETURN
      END IF
C
C  Fall through means undefined opcode.
C
        GO TO 910
C
C **********************************************************************
C *                                                                    *
C *          ========== OUTPUT PRIMITIVE PROCESSING ==========         *
C *                                                                    *
C **********************************************************************
C
C  POLYLINE.
C
  110 CONTINUE
      CALL GWIPL
      RETURN
C
C  POLYMARKER.
C
  120 CONTINUE
      CALL GWIPM
      RETURN
C
C  TEXT
C
  130 CONTINUE
      CALL GWITX
      RETURN
C
C  FILL AREA
C
  140 CONTINUE
      CALL GWIFA
      RETURN
C
C  CELL ARRAY
C
  150 CONTINUE
      CALL GWICA
      RETURN
C
C  GDP (Not supported, just generates error).
C
  160 CONTINUE
      RERR = 104
      RETURN
C
C **********************************************************************
C *                                                                    *
C *         ---------- CONTROL FUNCTION PROCESSING ----------          *
C *                                                                    *
C **********************************************************************
C
C  OPEN WORKSTATION
C
  210 CONTINUE
C
C  Mark workstation open in WSL, set connection ID
C
      MOPEN  = GYES
      WSSLUN = ID(2)
      RETURN
C
C  CREATE SEGMENT
C  
  400 CONTINUE
C
C  Initialize record number.
C
      WRECNM = 1
C
C  Open output file.
C
      ILEN = 0
      DO 10 I=1,80
        IF (STR(I:I).EQ.' ' .OR. STR(I:I).EQ.CHAR(0)) THEN
          ILEN = I-1
          GO TO 20
        ENDIF
   10 CONTINUE
   20 CONTINUE
      STR(ILEN+1:ILEN+1) = CHAR(0)
      CALL G01MIO (10, WSSLUN, STR(1:ILEN), WOUTBF, 1, RERR)
      IF (RERR .NE. 0)  RETURN
C
C  Initialize current-buffer-position pointer.
C
      WBFPOS = 32
C
C  Set the number of bits per record.
C
      WXBITS = 11520
C
C  Compute number of integer words needed for output buffer (WOUTBF).
C
      WOBFSZ = 1 + (WXBITS-1)/I1MACH(5)
C
C  Set data type for output records.
C
      WDTYPE = 3
C
C  Initialize workstation state list parameters.
C
      CALL  GWIIWS
C
C  Initialize attribute context.
C
      CALL  GWIIAC
C
C  Put the current attribute context into the segment.
C
      CALL GWIDMP(ICNTX,RCNTX)
C
      RETURN
C
C  Close segment.
C
  410 CONTINUE
      CALL GWIFLB (IER)
      CALL G01MIO (2, WSSLUN, STR, IDUM, 1, RERR)
      IL1 = 1
      IL2 = 1
      ID(1) = WRECNM-1
      RETURN
C
C  Delete segment.
C
  420 CONTINUE
      CALL GTNLEN(STR,ILEN,IER)
      STR(ILEN+1:ILEN+1) = CHAR(0)
      IF (STR(1:4) .EQ. 'GSEG') CALL G01MIO (9, 0, STR, IDUM, 1, RERR)
      RETURN
C
C  Activate workstation.
C
  220 CONTINUE
      MSTATE = GACTIV
      RETURN
C
C  Deactivate workstation.
C
  230 CONTINUE
      MSTATE = GINACT
      RETURN
C
C  Close workstation.
C
  240 CONTINUE
C
C  Mark workstation closed, flush buffer, close the output unit.
C
      MOPEN = GNO
      CALL GWIFLB (IER)
      CALL G01MIO (2, WSSLUN, STR, IDUM, 1, RERR)
      RETURN
C
C  Clear workstation.
C
  250 CONTINUE
      CALL GWICLW
      RETURN
C
C  Update workstation.
C
  270 CONTINUE
C
C  Flush output buffer.
C
      CALL GWIFLB (RERR)
      RETURN
C
C  ESCAPE.
C
  300 CONTINUE
      CALL GWIESC
      RETURN
C
C  New code on 1st WSI call after a call indicating continuation.
C
  905 CONTINUE
      RERR = 325
      RETURN
C
C  Undefined/unsupported opcode.
C
  910 CONTINUE
      RERR = 320
      RETURN
C
      END

      SUBROUTINE DRMVMEAN(X,NPTS,XMSG,IER)
      IMPLICIT NONE

c remove the series mean from a series
c NCL:  xNew = rmv_mean (x)

C input
      INTEGER NPTS,IER
      DOUBLE PRECISION XMSG
C input/output
      DOUBLE PRECISION X(NPTS)

C local
      INTEGER NPTUSE,N
      DOUBLE PRECISION XMEAN,XVAR,XSD

      CALL DSTAT2(X,NPTS,XMSG,XMEAN,XVAR,XSD,NPTUSE,IER)

      IF (IER.EQ.0) THEN
          DO N = 1,NPTS
              IF (X(N).NE.XMSG) X(N) = X(N) - XMEAN
          END DO
      END IF

      RETURN
      END
c -------------------------------------------------------------
      SUBROUTINE DRMVMED(X,WORK,NPTS,XMSG,IER)
      IMPLICIT NONE

c remove the series median from a series
c NCL:  xNew = rmv_median (x)

C input
      INTEGER NPTS,IER
      DOUBLE PRECISION XMSG
C input/output
      DOUBLE PRECISION X(NPTS)
      DOUBLE PRECISION WORK(NPTS)

C local
      INTEGER NPTUSE,N
      DOUBLE PRECISION XMEDIAN,XMRANGE,XRANGE

      CALL DMEDMRNG(X,WORK,NPTS,XMSG,XMEDIAN,XMRANGE,XRANGE,NPTUSE,IER)

      IF (IER.EQ.0) THEN
          DO N = 1,NPTS
              IF (X(N).NE.XMSG) X(N) = X(N) - XMEDIAN
          END DO
      END IF

      RETURN
      END
c -------------------------------------------------------------
      SUBROUTINE DXSTND(X,NPTS,XMSG,IOPT,IER)
      IMPLICIT NONE

c remove the mean from a series and standardize by the
c .   standardize by the standard deviation (sample or pop)

c NCL:  xNew = standardize(x,iopt)

C input
      INTEGER NPTS,IOPT,IER
      DOUBLE PRECISION XMSG
C input/output
      DOUBLE PRECISION X(NPTS)

C local
      INTEGER NPTUSE,N
      DOUBLE PRECISION XMEAN,XVAR,XSD,RN

      CALL DSTAT2(X,NPTS,XMSG,XMEAN,XVAR,XSD,NPTUSE,IER)

      IF (IOPT.EQ.1 .AND. NPTUSE.GT.1) THEN
          RN = NPTUSE
C population std deviation
          XSD = SQRT(((RN-1.D0)*XVAR)/RN)
      END IF

      IF (IER.EQ.0 .AND. XSD.GT.0.) THEN
          DO N = 1,NPTS
              IF (X(N).NE.XMSG) X(N) = (X(N)-XMEAN)/XSD
          END DO
      END IF

      RETURN
      END

C
C       $Id: stumxy.f,v 1.9 2008-07-27 00:17:28 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
C-----------------------------------------------------------------------
C
      SUBROUTINE STUMXY(XDA,YDA,XUS,YUS,IST)
C
C User modifiable routine for mapping data coordinate space to
C user space
C
C
C Input parameters:
C
C XDA,YDA - Point in data coordinate space
C
C Output parameters:
C
C XUS,YUS - Point in user coordinate space
C IST     - Status code indicating success or failure
C
C --------------------------------------------------------------------
C
C The mapping common block: made available to user mapping routines
C
      COMMON /STMAP/
     +                IMAP       ,LNLG       ,INVX       ,INVY       ,
     +                XLOV       ,XHIV       ,YLOV       ,YHIV       ,
     +                WXMN       ,WXMX       ,WYMN       ,WYMX       ,
     +                XVPL       ,XVPR       ,YVPB       ,YVPT       ,
     +                XGDS       ,YGDS       ,NXCT       ,NYCT       ,
     +                ITRT       ,FW2W       ,FH2H       ,
     +                DFMG       ,VNML       ,RBIG       ,IBIG
C
      SAVE /STMAP/
C
C Math constants
C
      PARAMETER (PDTOR  = 0.017453292519943,
     +           PRTOD  = 57.2957795130823,
     +           P1XPI  = 3.14159265358979,
     +           P2XPI  = 6.28318530717959,
     +           P1D2PI = 1.57079632679489,
     +           P5D2PI = 7.85398163397448) 
C
C -------------------------------------------------------------
C
C Identity transformation
C
      IST=0
      XUS=XDA
      YUS=YDA
C
C Done.
C
      RETURN
C
      END
C
C ---------------------------------------------------------------------
C
      SUBROUTINE STUIXY(XUS,YUS,XDA,YDA,IST)
C
C User modifiable routine for inversely transforming
C a point in user coordinate space to data space
C
C Input parameters:
C
C XUS,YUS - Point in user coordinate space
C
C Output parameters:
C
C XDA,YDA - Point in data coordinate space
C IST     - Status code indicating success or failure
C
C --------------------------------------------------------------------
C
C The mapping common block: made available to user mapping routines
C
      COMMON /STMAP/
     +                IMAP       ,LNLG       ,INVX       ,INVY       ,
     +                XLOV       ,XHIV       ,YLOV       ,YHIV       ,
     +                WXMN       ,WXMX       ,WYMN       ,WYMX       ,
     +                XVPL       ,XVPR       ,YVPB       ,YVPT       ,
     +                XGDS       ,YGDS       ,NXCT       ,NYCT       ,
     +                ITRT       ,FW2W       ,FH2H       ,
     +                DFMG       ,VNML       ,RBIG       ,IBIG
C
      SAVE /STMAP/
C
C Math constants
C
      PARAMETER (PDTOR  = 0.017453292519943,
     +           PRTOD  = 57.2957795130823,
     +           P1XPI  = 3.14159265358979,
     +           P2XPI  = 6.28318530717959,
     +           P1D2PI = 1.57079632679489,
     +           P5D2PI = 7.85398163397448) 
C
C ---------------------------------------------------------------------
C
      IST=0
      XDA=XUS
      YDA=YUS
C
C Done
C
      RETURN
      END
C
C ---------------------------------------------------------------------
C
      SUBROUTINE STUMTA(XDA,YDA,XUS,YUS,XND,YND,DU,DV,TA,IST)
C
C User modifiable routine for mapping a tangent angle in data space to 
C normalized device coordinate space.
C
C Input parameters:
C
C XDA,YDA - Point in data coordinate space
C XUS,YUS - Point in user coordinate space
C XND,YND - Point in NDC space
C DU,DV   - Differential vector components in data space
C
C Output parameters:
C
C TA      - Streamline tangent angle in NDC space
C IST     - Status code indicating success or failure
C
C --------------------------------------------------------------------
C
C The mapping common block: made available to user mapping routines
C
      COMMON /STMAP/
     +                IMAP       ,LNLG       ,INVX       ,INVY       ,
     +                XLOV       ,XHIV       ,YLOV       ,YHIV       ,
     +                WXMN       ,WXMX       ,WYMN       ,WYMX       ,
     +                XVPL       ,XVPR       ,YVPB       ,YVPT       ,
     +                XGDS       ,YGDS       ,NXCT       ,NYCT       ,
     +                ITRT       ,FW2W       ,FH2H       ,
     +                DFMG       ,VNML       ,RBIG       ,IBIG
C
      SAVE /STMAP/
C
C Math constants
C
      PARAMETER (PDTOR  = 0.017453292519943,
     +           PRTOD  = 57.2957795130823,
     +           P1XPI  = 3.14159265358979,
     +           P2XPI  = 6.28318530717959,
     +           P1D2PI = 1.57079632679489,
     +           P5D2PI = 7.85398163397448) 
C
C ---------------------------------------------------------------------
C
      IST=0
      TA=ATAN2(DV,DU)
C
C Done.
C
      RETURN
C
      END

C
C $Id: intrvldp.f,v 1.3 2008-07-27 03:10:11 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
C NOTE: If you make any changes to this software, please remember to
C make the same changes to the corresponding single precision routine.
C
      FUNCTION INTRVLDP(T,X,N)
      DOUBLE PRECISION TT
c
      INTEGER N
      DOUBLE PRECISION T,X(N)
c
c                                 coded by alan kaylor cline
c                           from fitpack -- january 26, 1987
c                        a curve and surface fitting package
c                      a product of pleasant valley software
c                  8603 altus cove, austin, texas 78759, usa
c
c this function determines the index of the interval
c (determined by a given increasing sequence) in which
c a given value lies.
c
c on input--
c
c   t is the given value.
c
c   x is a vector of strictly increasing values.
c
c and
c
c   n is the length of x (n .ge. 2).
c
c on output--
c
c   intrvldp returns an integer i such that
c
c          i =  1       if             t .le. x(2)  ,
c          i =  n-1     if x(n-1) .le. t            ,
c          otherwise       x(i)  .le. t .le. x(i+1),
c
c none of the input parameters are altered.
c
c-----------------------------------------------------------
c
      SAVE I
      DATA I/1/
c
      TT = T
c
c check for illegal i
c
      IF (I.GE.N) I = N/2
c
c check old interval and extremes
c
      IF (TT.LT.X(I)) THEN
          IF (TT.LE.X(2)) THEN
              I = 1
              INTRVLDP = 1
              RETURN
          ELSE
              IL = 2
              IH = I
          END IF
      ELSE IF (TT.LE.X(I+1)) THEN
          INTRVLDP = I
          RETURN
      ELSE IF (TT.GE.X(N-1)) THEN
          I = N - 1
          INTRVLDP = N - 1
          RETURN
      ELSE
          IL = I + 1
          IH = N - 1
      END IF
c
c binary search loop
c
    1 I = (IL+IH)/2
      IF (TT.LT.X(I)) THEN
          IH = I
      ELSE IF (TT.GT.X(I+1)) THEN
          IL = I + 1
      ELSE
          INTRVLDP = I
          RETURN
      END IF
      GO TO 1
      END

      SUBROUTINE SGTSV( N, NRHS, DL, D, DU, B, LDB, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     October 31, 1999
*
*     .. Scalar Arguments ..
      INTEGER            INFO, LDB, N, NRHS
*     ..
*     .. Array Arguments ..
      REAL               B( LDB, * ), D( * ), DL( * ), DU( * )
*     ..
*
*  Purpose
*  =======
*
*  SGTSV  solves the equation
*
*     A*X = B,
*
*  where A is an n by n tridiagonal matrix, by Gaussian elimination with
*  partial pivoting.
*
*  Note that the equation  A'*X = B  may be solved by interchanging the
*  order of the arguments DU and DL.
*
*  Arguments
*  =========
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  NRHS    (input) INTEGER
*          The number of right hand sides, i.e., the number of columns
*          of the matrix B.  NRHS >= 0.
*
*  DL      (input/output) REAL array, dimension (N-1)
*          On entry, DL must contain the (n-1) sub-diagonal elements of
*          A.
*
*          On exit, DL is overwritten by the (n-2) elements of the
*          second super-diagonal of the upper triangular matrix U from
*          the LU factorization of A, in DL(1), ..., DL(n-2).
*
*  D       (input/output) REAL array, dimension (N)
*          On entry, D must contain the diagonal elements of A.
*
*          On exit, D is overwritten by the n diagonal elements of U.
*
*  DU      (input/output) REAL array, dimension (N-1)
*          On entry, DU must contain the (n-1) super-diagonal elements
*          of A.
*
*          On exit, DU is overwritten by the (n-1) elements of the first
*          super-diagonal of U.
*
*  B       (input/output) REAL array, dimension (LDB,NRHS)
*          On entry, the N by NRHS matrix of right hand side matrix B.
*          On exit, if INFO = 0, the N by NRHS solution matrix X.
*
*  LDB     (input) INTEGER
*          The leading dimension of the array B.  LDB >= max(1,N).
*
*  INFO    (output) INTEGER
*          = 0: successful exit
*          < 0: if INFO = -i, the i-th argument had an illegal value
*          > 0: if INFO = i, U(i,i) is exactly zero, and the solution
*               has not been computed.  The factorization has not been
*               completed unless i = N.
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ZERO
      PARAMETER          ( ZERO = 0.0E+0 )
*     ..
*     .. Local Scalars ..
      INTEGER            I, J
      REAL               FACT, TEMP
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, MAX
*     ..
*     .. External Subroutines ..
      EXTERNAL           XERBLA
*     ..
*     .. Executable Statements ..
*
      INFO = 0
      IF( N.LT.0 ) THEN
         INFO = -1
      ELSE IF( NRHS.LT.0 ) THEN
         INFO = -2
      ELSE IF( LDB.LT.MAX( 1, N ) ) THEN
         INFO = -7
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'SGTSV ', -INFO )
         RETURN
      END IF
*
      IF( N.EQ.0 )
     $   RETURN
*
      IF( NRHS.EQ.1 ) THEN
         DO 10 I = 1, N - 2
            IF( ABS( D( I ) ).GE.ABS( DL( I ) ) ) THEN
*
*              No row interchange required
*
               IF( D( I ).NE.ZERO ) THEN
                  FACT = DL( I ) / D( I )
                  D( I+1 ) = D( I+1 ) - FACT*DU( I )
                  B( I+1, 1 ) = B( I+1, 1 ) - FACT*B( I, 1 )
               ELSE
                  INFO = I
                  RETURN
               END IF
               DL( I ) = ZERO
            ELSE
*
*              Interchange rows I and I+1
*
               FACT = D( I ) / DL( I )
               D( I ) = DL( I )
               TEMP = D( I+1 )
               D( I+1 ) = DU( I ) - FACT*TEMP
               DL( I ) = DU( I+1 )
               DU( I+1 ) = -FACT*DL( I )
               DU( I ) = TEMP
               TEMP = B( I, 1 )
               B( I, 1 ) = B( I+1, 1 )
               B( I+1, 1 ) = TEMP - FACT*B( I+1, 1 )
            END IF
   10    CONTINUE
         IF( N.GT.1 ) THEN
            I = N - 1
            IF( ABS( D( I ) ).GE.ABS( DL( I ) ) ) THEN
               IF( D( I ).NE.ZERO ) THEN
                  FACT = DL( I ) / D( I )
                  D( I+1 ) = D( I+1 ) - FACT*DU( I )
                  B( I+1, 1 ) = B( I+1, 1 ) - FACT*B( I, 1 )
               ELSE
                  INFO = I
                  RETURN
               END IF
            ELSE
               FACT = D( I ) / DL( I )
               D( I ) = DL( I )
               TEMP = D( I+1 )
               D( I+1 ) = DU( I ) - FACT*TEMP
               DU( I ) = TEMP
               TEMP = B( I, 1 )
               B( I, 1 ) = B( I+1, 1 )
               B( I+1, 1 ) = TEMP - FACT*B( I+1, 1 )
            END IF
         END IF
         IF( D( N ).EQ.ZERO ) THEN
            INFO = N
            RETURN
         END IF
      ELSE
         DO 40 I = 1, N - 2
            IF( ABS( D( I ) ).GE.ABS( DL( I ) ) ) THEN
*
*              No row interchange required
*
               IF( D( I ).NE.ZERO ) THEN
                  FACT = DL( I ) / D( I )
                  D( I+1 ) = D( I+1 ) - FACT*DU( I )
                  DO 20 J = 1, NRHS
                     B( I+1, J ) = B( I+1, J ) - FACT*B( I, J )
   20             CONTINUE
               ELSE
                  INFO = I
                  RETURN
               END IF
               DL( I ) = ZERO
            ELSE
*
*              Interchange rows I and I+1
*
               FACT = D( I ) / DL( I )
               D( I ) = DL( I )
               TEMP = D( I+1 )
               D( I+1 ) = DU( I ) - FACT*TEMP
               DL( I ) = DU( I+1 )
               DU( I+1 ) = -FACT*DL( I )
               DU( I ) = TEMP
               DO 30 J = 1, NRHS
                  TEMP = B( I, J )
                  B( I, J ) = B( I+1, J )
                  B( I+1, J ) = TEMP - FACT*B( I+1, J )
   30          CONTINUE
            END IF
   40    CONTINUE
         IF( N.GT.1 ) THEN
            I = N - 1
            IF( ABS( D( I ) ).GE.ABS( DL( I ) ) ) THEN
               IF( D( I ).NE.ZERO ) THEN
                  FACT = DL( I ) / D( I )
                  D( I+1 ) = D( I+1 ) - FACT*DU( I )
                  DO 50 J = 1, NRHS
                     B( I+1, J ) = B( I+1, J ) - FACT*B( I, J )
   50             CONTINUE
               ELSE
                  INFO = I
                  RETURN
               END IF
            ELSE
               FACT = D( I ) / DL( I )
               D( I ) = DL( I )
               TEMP = D( I+1 )
               D( I+1 ) = DU( I ) - FACT*TEMP
               DU( I ) = TEMP
               DO 60 J = 1, NRHS
                  TEMP = B( I, J )
                  B( I, J ) = B( I+1, J )
                  B( I+1, J ) = TEMP - FACT*B( I+1, J )
   60          CONTINUE
            END IF
         END IF
         IF( D( N ).EQ.ZERO ) THEN
            INFO = N
            RETURN
         END IF
      END IF
*
*     Back solve with the matrix U from the factorization.
*
      IF( NRHS.LE.2 ) THEN
         J = 1
   70    CONTINUE
         B( N, J ) = B( N, J ) / D( N )
         IF( N.GT.1 )
     $      B( N-1, J ) = ( B( N-1, J )-DU( N-1 )*B( N, J ) ) / D( N-1 )
         DO 80 I = N - 2, 1, -1
            B( I, J ) = ( B( I, J )-DU( I )*B( I+1, J )-DL( I )*
     $                  B( I+2, J ) ) / D( I )
   80    CONTINUE
         IF( J.LT.NRHS ) THEN
            J = J + 1
            GO TO 70
         END IF
      ELSE
         DO 100 J = 1, NRHS
            B( N, J ) = B( N, J ) / D( N )
            IF( N.GT.1 )
     $         B( N-1, J ) = ( B( N-1, J )-DU( N-1 )*B( N, J ) ) /
     $                       D( N-1 )
            DO 90 I = N - 2, 1, -1
               B( I, J ) = ( B( I, J )-DU( I )*B( I+1, J )-DL( I )*
     $                     B( I+2, J ) ) / D( I )
   90       CONTINUE
  100    CONTINUE
      END IF
*
      RETURN
*
*     End of SGTSV
*
      END

C
C	$Id: curved.f,v 1.4 2008-07-27 00:16:58 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CURVED (X,Y,N)
C USER ENTRY POINT.
C
      DIMENSION X(N),Y(N)
C
      CALL FRSTD (X(1),Y(1))
      DO 10 I=2,N
         CALL VECTD (X(I),Y(I))
   10 CONTINUE
      CALL LASTD
C
      RETURN
      END

C
C $Id: hstopr.f,v 1.7 2008-07-27 00:17:15 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
C *************************************************************
C
      SUBROUTINE HSTOPR (IOPT,ARRAY,ISIZE)
C
C *************************************************************
C
C SET THE HSTOGRAM OPTIONS FOR WINDOW AND/OR COLOR
C
C INPUT
C     IOPT-CHARACTER STRING OF OPTION VALUE
C     ARRAY-   REAL ARRAY OF DIMENSION ISIZE
C     ISIZE-   SIZE OF ARRAY
C
C  SET COMMON DATA EQUAL TO INPUT DATA
C
C
      COMMON /HSTGC1/ HORZNT, PERCNT, MIDVAL, SHADE, MEDIAN, PERIM,
     -       HFRAME, LISTOP, WINDOW, COLORS, HSTFOR, TITLE, LABEL,
     -       FREQNC, HWIND(4), COLSHA, COLREC, COLAXI, COLMED, COLTEX,
     -       COLTIT, COLPER, DRAWL, SPACE, LABMAX, CHARL, HEIGHT,
     -       ORIENT, COLSH2, SETSPA, SETSP2, MVALU, SETMVA, SETEPS,
     -       NMVAL, PMVAL, PERTIT
      LOGICAL HORZNT, PERCNT, MIDVAL, SHADE, MEDIAN, PERIM, HFRAME,
     -        LISTOP, WINDOW, COLORS, HSTFOR, TITLE, LABEL, FREQNC,
     -        DRAWL, SPACE, CHARL, MVALU, NMVAL, PMVAL, PERTIT
      COMMON /HSTGC2/ STRFOR, STRTIT, STRLAB, STRFRE, STRPER, LABTEX
      CHARACTER*96  STRTIT
      CHARACTER*55  STRFOR, STRLAB, STRFRE, STRPER
      CHARACTER*15 LABTEX(30)
      CHARACTER*7  IOPT
      CHARACTER*2  TAG, OPT
      INTEGER  COLSHA, COLREC, COLAXI, COLMED, COLTEX
      INTEGER  COLTIT, COLPER, COLSH2, HEIGHT, ORIENT
      REAL ARRAY(ISIZE)
C
      NERR = 0
C
C  DETERMINE THE OPTION DESIRED
C
      TAG = IOPT(1:2)
      IF (IOPT(3:3) .EQ. '=') THEN
          OPT = IOPT(4:5)
      ELSE
          OPT = IOPT(5:6)
      ENDIF
C
C  WINDOWING FLAG
C
      IF (TAG .EQ. 'WI') THEN
C
C  SWITCH ON
C
          IF (OPT .EQ. 'ON') THEN
              WINDOW = .TRUE.
              HWIND(1) = ARRAY(1)
              HWIND(2) = ARRAY(2)
              HWIND(3) = ARRAY(3)
              HWIND(4) = ARRAY(4)
              RETURN
C
C  SWITCH OFF
C
          ELSEIF (OPT .EQ. 'OF') THEN
                WINDOW = .FALSE.
              RETURN
          ELSE
                GOTO 120
          ENDIF
C
C Set Spacing FLAG and parameters.
C
      ELSEIF (TAG .EQ. 'SP') THEN
        IF (OPT .EQ. 'ON') THEN
          SPACE = .TRUE.
          SETSPA = ARRAY(1)
          SETSP2 = ARRAY(2)
          IF(SETSPA .GT. 4.0 .OR. SETSPA .LT. 0.0) GOTO 130
          IF(SETSP2 .GT. 4.0 .OR. SETSP2 .LT. -4.0) GOTO 130
          RETURN
        ELSEIF (OPT .EQ. 'OF') THEN
          SPACE = .FALSE.
          RETURN
        ELSE
          GOTO 120
        ENDIF
C
C Set special value flag.
C
      ELSEIF (TAG .EQ. 'MV') THEN
        IF (OPT .EQ. 'ON') THEN
	  MVALU = .TRUE.
	  SETMVA = ARRAY(1)
	  SETEPS = ARRAY(2)
          RETURN
        ELSEIF (OPT .EQ. 'OF') THEN
	  MVALU = .FALSE.
          RETURN
        ELSE
          GOTO 120
        ENDIF
      ELSE
        GOTO 120
      ENDIF
C
C  ERROR UNDEFINED OPTION DETECTED
C
  120 NERR = NERR + 1
      CALL SETER (' HSTOPR -- UNDEFINED OPTION',NERR,IREC)
      RETURN
  130 NERR = NERR + 1
      CALL SETER (' HSTOPR -- INVALID SPACING PARAMETER ',NERR,IREC)
      RETURN
      END

      SUBROUTINE CHGEQZ( JOB, COMPQ, COMPZ, N, ILO, IHI, A, LDA, B, LDB,
     $                   ALPHA, BETA, Q, LDQ, Z, LDZ, WORK, LWORK,
     $                   RWORK, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          COMPQ, COMPZ, JOB
      INTEGER            IHI, ILO, INFO, LDA, LDB, LDQ, LDZ, LWORK, N
*     ..
*     .. Array Arguments ..
      REAL               RWORK( * )
      COMPLEX            A( LDA, * ), ALPHA( * ), B( LDB, * ),
     $                   BETA( * ), Q( LDQ, * ), WORK( * ), Z( LDZ, * )
*     ..
*
*  Purpose
*  =======
*
*  CHGEQZ implements a single-shift version of the QZ
*  method for finding the generalized eigenvalues w(i)=ALPHA(i)/BETA(i)
*  of the equation
*
*       det( A - w(i) B ) = 0
*
*  If JOB='S', then the pair (A,B) is simultaneously
*  reduced to Schur form (i.e., A and B are both upper triangular) by
*  applying one unitary tranformation (usually called Q) on the left and
*  another (usually called Z) on the right.  The diagonal elements of
*  A are then ALPHA(1),...,ALPHA(N), and of B are BETA(1),...,BETA(N).
*
*  If JOB='S' and COMPQ and COMPZ are 'V' or 'I', then the unitary
*  transformations used to reduce (A,B) are accumulated into the arrays
*  Q and Z s.t.:
*
*       Q(in) A(in) Z(in)* = Q(out) A(out) Z(out)*
*       Q(in) B(in) Z(in)* = Q(out) B(out) Z(out)*
*
*  Ref: C.B. Moler & G.W. Stewart, "An Algorithm for Generalized Matrix
*       Eigenvalue Problems", SIAM J. Numer. Anal., 10(1973),
*       pp. 241--256.
*
*  Arguments
*  =========
*
*  JOB     (input) CHARACTER*1
*          = 'E': compute only ALPHA and BETA.  A and B will not
*                 necessarily be put into generalized Schur form.
*          = 'S': put A and B into generalized Schur form, as well
*                 as computing ALPHA and BETA.
*
*  COMPQ   (input) CHARACTER*1
*          = 'N': do not modify Q.
*          = 'V': multiply the array Q on the right by the conjugate
*                 transpose of the unitary tranformation that is
*                 applied to the left side of A and B to reduce them
*                 to Schur form.
*          = 'I': like COMPQ='V', except that Q will be initialized to
*                 the identity first.
*
*  COMPZ   (input) CHARACTER*1
*          = 'N': do not modify Z.
*          = 'V': multiply the array Z on the right by the unitary
*                 tranformation that is applied to the right side of
*                 A and B to reduce them to Schur form.
*          = 'I': like COMPZ='V', except that Z will be initialized to
*                 the identity first.
*
*  N       (input) INTEGER
*          The order of the matrices A, B, Q, and Z.  N >= 0.
*
*  ILO     (input) INTEGER
*  IHI     (input) INTEGER
*          It is assumed that A is already upper triangular in rows and
*          columns 1:ILO-1 and IHI+1:N.
*          1 <= ILO <= IHI <= N, if N > 0; ILO=1 and IHI=0, if N=0.
*
*  A       (input/output) COMPLEX array, dimension (LDA, N)
*          On entry, the N-by-N upper Hessenberg matrix A.  Elements
*          below the subdiagonal must be zero.
*          If JOB='S', then on exit A and B will have been
*             simultaneously reduced to upper triangular form.
*          If JOB='E', then on exit A will have been destroyed.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max( 1, N ).
*
*  B       (input/output) COMPLEX array, dimension (LDB, N)
*          On entry, the N-by-N upper triangular matrix B.  Elements
*          below the diagonal must be zero.
*          If JOB='S', then on exit A and B will have been
*             simultaneously reduced to upper triangular form.
*          If JOB='E', then on exit B will have been destroyed.
*
*  LDB     (input) INTEGER
*          The leading dimension of the array B.  LDB >= max( 1, N ).
*
*  ALPHA   (output) COMPLEX array, dimension (N)
*          The diagonal elements of A when the pair (A,B) has been
*          reduced to Schur form.  ALPHA(i)/BETA(i) i=1,...,N
*          are the generalized eigenvalues.
*
*  BETA    (output) COMPLEX array, dimension (N)
*          The diagonal elements of B when the pair (A,B) has been
*          reduced to Schur form.  ALPHA(i)/BETA(i) i=1,...,N
*          are the generalized eigenvalues.  A and B are normalized
*          so that BETA(1),...,BETA(N) are non-negative real numbers.
*
*  Q       (input/output) COMPLEX array, dimension (LDQ, N)
*          If COMPQ='N', then Q will not be referenced.
*          If COMPQ='V' or 'I', then the conjugate transpose of the
*             unitary transformations which are applied to A and B on
*             the left will be applied to the array Q on the right.
*
*  LDQ     (input) INTEGER
*          The leading dimension of the array Q.  LDQ >= 1.
*          If COMPQ='V' or 'I', then LDQ >= N.
*
*  Z       (input/output) COMPLEX array, dimension (LDZ, N)
*          If COMPZ='N', then Z will not be referenced.
*          If COMPZ='V' or 'I', then the unitary transformations which
*             are applied to A and B on the right will be applied to the
*             array Z on the right.
*
*  LDZ     (input) INTEGER
*          The leading dimension of the array Z.  LDZ >= 1.
*          If COMPZ='V' or 'I', then LDZ >= N.
*
*  WORK    (workspace/output) COMPLEX array, dimension (LWORK)
*          On exit, if INFO >= 0, WORK(1) returns the optimal LWORK.
*
*  LWORK   (input) INTEGER
*          The dimension of the array WORK.  LWORK >= max(1,N).
*
*          If LWORK = -1, then a workspace query is assumed; the routine
*          only calculates the optimal size of the WORK array, returns
*          this value as the first entry of the WORK array, and no error
*          message related to LWORK is issued by XERBLA.
*
*  RWORK   (workspace) REAL array, dimension (N)
*
*  INFO    (output) INTEGER
*          = 0: successful exit
*          < 0: if INFO = -i, the i-th argument had an illegal value
*          = 1,...,N: the QZ iteration did not converge.  (A,B) is not
*                     in Schur form, but ALPHA(i) and BETA(i),
*                     i=INFO+1,...,N should be correct.
*          = N+1,...,2*N: the shift calculation failed.  (A,B) is not
*                     in Schur form, but ALPHA(i) and BETA(i),
*                     i=INFO-N+1,...,N should be correct.
*          > 2*N:     various "impossible" errors.
*
*  Further Details
*  ===============
*
*  We assume that complex ABS works as long as its value is less than
*  overflow.
*
*  =====================================================================
*
*     .. Parameters ..
      COMPLEX            CZERO, CONE
      PARAMETER          ( CZERO = ( 0.0E+0, 0.0E+0 ),
     $                   CONE = ( 1.0E+0, 0.0E+0 ) )
      REAL               ZERO, ONE
      PARAMETER          ( ZERO = 0.0E+0, ONE = 1.0E+0 )
      REAL               HALF
      PARAMETER          ( HALF = 0.5E+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            ILAZR2, ILAZRO, ILQ, ILSCHR, ILZ, LQUERY
      INTEGER            ICOMPQ, ICOMPZ, IFIRST, IFRSTM, IITER, ILAST,
     $                   ILASTM, IN, ISCHUR, ISTART, J, JC, JCH, JITER,
     $                   JR, MAXIT
      REAL               ABSB, ANORM, ASCALE, ATOL, BNORM, BSCALE, BTOL,
     $                   C, SAFMIN, TEMP, TEMP2, TEMPR, ULP
      COMPLEX            ABI22, AD11, AD12, AD21, AD22, CTEMP, CTEMP2,
     $                   CTEMP3, ESHIFT, RTDISC, S, SHIFT, SIGNBC, T,
     $                   U12, X
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      REAL               CLANHS, SLAMCH
      EXTERNAL           LSAME, CLANHS, SLAMCH
*     ..
*     .. External Subroutines ..
      EXTERNAL           CLARTG, CLASET, CROT, CSCAL, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, AIMAG, CMPLX, CONJG, MAX, MIN, REAL, SQRT
*     ..
*     .. Statement Functions ..
      REAL               ABS1
*     ..
*     .. Statement Function definitions ..
      ABS1( X ) = ABS( REAL( X ) ) + ABS( AIMAG( X ) )
*     ..
*     .. Executable Statements ..
*
*     Decode JOB, COMPQ, COMPZ
*
      IF( LSAME( JOB, 'E' ) ) THEN
         ILSCHR = .FALSE.
         ISCHUR = 1
      ELSE IF( LSAME( JOB, 'S' ) ) THEN
         ILSCHR = .TRUE.
         ISCHUR = 2
      ELSE
         ISCHUR = 0
      END IF
*
      IF( LSAME( COMPQ, 'N' ) ) THEN
         ILQ = .FALSE.
         ICOMPQ = 1
      ELSE IF( LSAME( COMPQ, 'V' ) ) THEN
         ILQ = .TRUE.
         ICOMPQ = 2
      ELSE IF( LSAME( COMPQ, 'I' ) ) THEN
         ILQ = .TRUE.
         ICOMPQ = 3
      ELSE
         ICOMPQ = 0
      END IF
*
      IF( LSAME( COMPZ, 'N' ) ) THEN
         ILZ = .FALSE.
         ICOMPZ = 1
      ELSE IF( LSAME( COMPZ, 'V' ) ) THEN
         ILZ = .TRUE.
         ICOMPZ = 2
      ELSE IF( LSAME( COMPZ, 'I' ) ) THEN
         ILZ = .TRUE.
         ICOMPZ = 3
      ELSE
         ICOMPZ = 0
      END IF
*
*     Check Argument Values
*
      INFO = 0
      WORK( 1 ) = MAX( 1, N )
      LQUERY = ( LWORK.EQ.-1 )
      IF( ISCHUR.EQ.0 ) THEN
         INFO = -1
      ELSE IF( ICOMPQ.EQ.0 ) THEN
         INFO = -2
      ELSE IF( ICOMPZ.EQ.0 ) THEN
         INFO = -3
      ELSE IF( N.LT.0 ) THEN
         INFO = -4
      ELSE IF( ILO.LT.1 ) THEN
         INFO = -5
      ELSE IF( IHI.GT.N .OR. IHI.LT.ILO-1 ) THEN
         INFO = -6
      ELSE IF( LDA.LT.N ) THEN
         INFO = -8
      ELSE IF( LDB.LT.N ) THEN
         INFO = -10
      ELSE IF( LDQ.LT.1 .OR. ( ILQ .AND. LDQ.LT.N ) ) THEN
         INFO = -14
      ELSE IF( LDZ.LT.1 .OR. ( ILZ .AND. LDZ.LT.N ) ) THEN
         INFO = -16
      ELSE IF( LWORK.LT.MAX( 1, N ) .AND. .NOT.LQUERY ) THEN
         INFO = -18
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'CHGEQZ', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         RETURN
      END IF
*
*     Quick return if possible
*
c     WORK( 1 ) = CMPLX( 1 )
      IF( N.LE.0 ) THEN
         WORK( 1 ) = CMPLX( 1 )
         RETURN
      END IF
*
*     Initialize Q and Z
*
      IF( ICOMPQ.EQ.3 )
     $   CALL CLASET( 'Full', N, N, CZERO, CONE, Q, LDQ )
      IF( ICOMPZ.EQ.3 )
     $   CALL CLASET( 'Full', N, N, CZERO, CONE, Z, LDZ )
*
*     Machine Constants
*
      IN = IHI + 1 - ILO
      SAFMIN = SLAMCH( 'S' )
      ULP = SLAMCH( 'E' )*SLAMCH( 'B' )
      ANORM = CLANHS( 'F', IN, A( ILO, ILO ), LDA, RWORK )
      BNORM = CLANHS( 'F', IN, B( ILO, ILO ), LDB, RWORK )
      ATOL = MAX( SAFMIN, ULP*ANORM )
      BTOL = MAX( SAFMIN, ULP*BNORM )
      ASCALE = ONE / MAX( SAFMIN, ANORM )
      BSCALE = ONE / MAX( SAFMIN, BNORM )
*
*
*     Set Eigenvalues IHI+1:N
*
      DO 10 J = IHI + 1, N
         ABSB = ABS( B( J, J ) )
         IF( ABSB.GT.SAFMIN ) THEN
            SIGNBC = CONJG( B( J, J ) / ABSB )
            B( J, J ) = ABSB
            IF( ILSCHR ) THEN
               CALL CSCAL( J-1, SIGNBC, B( 1, J ), 1 )
               CALL CSCAL( J, SIGNBC, A( 1, J ), 1 )
            ELSE
               A( J, J ) = A( J, J )*SIGNBC
            END IF
            IF( ILZ )
     $         CALL CSCAL( N, SIGNBC, Z( 1, J ), 1 )
         ELSE
            B( J, J ) = CZERO
         END IF
         ALPHA( J ) = A( J, J )
         BETA( J ) = B( J, J )
   10 CONTINUE
*
*     If IHI < ILO, skip QZ steps
*
      IF( IHI.LT.ILO )
     $   GO TO 190
*
*     MAIN QZ ITERATION LOOP
*
*     Initialize dynamic indices
*
*     Eigenvalues ILAST+1:N have been found.
*        Column operations modify rows IFRSTM:whatever
*        Row operations modify columns whatever:ILASTM
*
*     If only eigenvalues are being computed, then
*        IFRSTM is the row of the last splitting row above row ILAST;
*        this is always at least ILO.
*     IITER counts iterations since the last eigenvalue was found,
*        to tell when to use an extraordinary shift.
*     MAXIT is the maximum number of QZ sweeps allowed.
*
      ILAST = IHI
      IF( ILSCHR ) THEN
         IFRSTM = 1
         ILASTM = N
      ELSE
         IFRSTM = ILO
         ILASTM = IHI
      END IF
      IITER = 0
      ESHIFT = CZERO
      MAXIT = 30*( IHI-ILO+1 )
*
      DO 170 JITER = 1, MAXIT
*
*        Check for too many iterations.
*
         IF( JITER.GT.MAXIT )
     $      GO TO 180
*
*        Split the matrix if possible.
*
*        Two tests:
*           1: A(j,j-1)=0  or  j=ILO
*           2: B(j,j)=0
*
*        Special case: j=ILAST
*
         IF( ILAST.EQ.ILO ) THEN
            GO TO 60
         ELSE
            IF( ABS1( A( ILAST, ILAST-1 ) ).LE.ATOL ) THEN
               A( ILAST, ILAST-1 ) = CZERO
               GO TO 60
            END IF
         END IF
*
         IF( ABS( B( ILAST, ILAST ) ).LE.BTOL ) THEN
            B( ILAST, ILAST ) = CZERO
            GO TO 50
         END IF
*
*        General case: j<ILAST
*
         DO 40 J = ILAST - 1, ILO, -1
*
*           Test 1: for A(j,j-1)=0 or j=ILO
*
            IF( J.EQ.ILO ) THEN
               ILAZRO = .TRUE.
            ELSE
               IF( ABS1( A( J, J-1 ) ).LE.ATOL ) THEN
                  A( J, J-1 ) = CZERO
                  ILAZRO = .TRUE.
               ELSE
                  ILAZRO = .FALSE.
               END IF
            END IF
*
*           Test 2: for B(j,j)=0
*
            IF( ABS( B( J, J ) ).LT.BTOL ) THEN
               B( J, J ) = CZERO
*
*              Test 1a: Check for 2 consecutive small subdiagonals in A
*
               ILAZR2 = .FALSE.
               IF( .NOT.ILAZRO ) THEN
                  IF( ABS1( A( J, J-1 ) )*( ASCALE*ABS1( A( J+1,
     $                J ) ) ).LE.ABS1( A( J, J ) )*( ASCALE*ATOL ) )
     $                ILAZR2 = .TRUE.
               END IF
*
*              If both tests pass (1 & 2), i.e., the leading diagonal
*              element of B in the block is zero, split a 1x1 block off
*              at the top. (I.e., at the J-th row/column) The leading
*              diagonal element of the remainder can also be zero, so
*              this may have to be done repeatedly.
*
               IF( ILAZRO .OR. ILAZR2 ) THEN
                  DO 20 JCH = J, ILAST - 1
                     CTEMP = A( JCH, JCH )
                     CALL CLARTG( CTEMP, A( JCH+1, JCH ), C, S,
     $                            A( JCH, JCH ) )
                     A( JCH+1, JCH ) = CZERO
                     CALL CROT( ILASTM-JCH, A( JCH, JCH+1 ), LDA,
     $                          A( JCH+1, JCH+1 ), LDA, C, S )
                     CALL CROT( ILASTM-JCH, B( JCH, JCH+1 ), LDB,
     $                          B( JCH+1, JCH+1 ), LDB, C, S )
                     IF( ILQ )
     $                  CALL CROT( N, Q( 1, JCH ), 1, Q( 1, JCH+1 ), 1,
     $                             C, CONJG( S ) )
                     IF( ILAZR2 )
     $                  A( JCH, JCH-1 ) = A( JCH, JCH-1 )*C
                     ILAZR2 = .FALSE.
                     IF( ABS1( B( JCH+1, JCH+1 ) ).GE.BTOL ) THEN
                        IF( JCH+1.GE.ILAST ) THEN
                           GO TO 60
                        ELSE
                           IFIRST = JCH + 1
                           GO TO 70
                        END IF
                     END IF
                     B( JCH+1, JCH+1 ) = CZERO
   20             CONTINUE
                  GO TO 50
               ELSE
*
*                 Only test 2 passed -- chase the zero to B(ILAST,ILAST)
*                 Then process as in the case B(ILAST,ILAST)=0
*
                  DO 30 JCH = J, ILAST - 1
                     CTEMP = B( JCH, JCH+1 )
                     CALL CLARTG( CTEMP, B( JCH+1, JCH+1 ), C, S,
     $                            B( JCH, JCH+1 ) )
                     B( JCH+1, JCH+1 ) = CZERO
                     IF( JCH.LT.ILASTM-1 )
     $                  CALL CROT( ILASTM-JCH-1, B( JCH, JCH+2 ), LDB,
     $                             B( JCH+1, JCH+2 ), LDB, C, S )
                     CALL CROT( ILASTM-JCH+2, A( JCH, JCH-1 ), LDA,
     $                          A( JCH+1, JCH-1 ), LDA, C, S )
                     IF( ILQ )
     $                  CALL CROT( N, Q( 1, JCH ), 1, Q( 1, JCH+1 ), 1,
     $                             C, CONJG( S ) )
                     CTEMP = A( JCH+1, JCH )
                     CALL CLARTG( CTEMP, A( JCH+1, JCH-1 ), C, S,
     $                            A( JCH+1, JCH ) )
                     A( JCH+1, JCH-1 ) = CZERO
                     CALL CROT( JCH+1-IFRSTM, A( IFRSTM, JCH ), 1,
     $                          A( IFRSTM, JCH-1 ), 1, C, S )
                     CALL CROT( JCH-IFRSTM, B( IFRSTM, JCH ), 1,
     $                          B( IFRSTM, JCH-1 ), 1, C, S )
                     IF( ILZ )
     $                  CALL CROT( N, Z( 1, JCH ), 1, Z( 1, JCH-1 ), 1,
     $                             C, S )
   30             CONTINUE
                  GO TO 50
               END IF
            ELSE IF( ILAZRO ) THEN
*
*              Only test 1 passed -- work on J:ILAST
*
               IFIRST = J
               GO TO 70
            END IF
*
*           Neither test passed -- try next J
*
   40    CONTINUE
*
*        (Drop-through is "impossible")
*
         INFO = 2*N + 1
         GO TO 210
*
*        B(ILAST,ILAST)=0 -- clear A(ILAST,ILAST-1) to split off a
*        1x1 block.
*
   50    CONTINUE
         CTEMP = A( ILAST, ILAST )
         CALL CLARTG( CTEMP, A( ILAST, ILAST-1 ), C, S,
     $                A( ILAST, ILAST ) )
         A( ILAST, ILAST-1 ) = CZERO
         CALL CROT( ILAST-IFRSTM, A( IFRSTM, ILAST ), 1,
     $              A( IFRSTM, ILAST-1 ), 1, C, S )
         CALL CROT( ILAST-IFRSTM, B( IFRSTM, ILAST ), 1,
     $              B( IFRSTM, ILAST-1 ), 1, C, S )
         IF( ILZ )
     $      CALL CROT( N, Z( 1, ILAST ), 1, Z( 1, ILAST-1 ), 1, C, S )
*
*        A(ILAST,ILAST-1)=0 -- Standardize B, set ALPHA and BETA
*
   60    CONTINUE
         ABSB = ABS( B( ILAST, ILAST ) )
         IF( ABSB.GT.SAFMIN ) THEN
            SIGNBC = CONJG( B( ILAST, ILAST ) / ABSB )
            B( ILAST, ILAST ) = ABSB
            IF( ILSCHR ) THEN
               CALL CSCAL( ILAST-IFRSTM, SIGNBC, B( IFRSTM, ILAST ), 1 )
               CALL CSCAL( ILAST+1-IFRSTM, SIGNBC, A( IFRSTM, ILAST ),
     $                     1 )
            ELSE
               A( ILAST, ILAST ) = A( ILAST, ILAST )*SIGNBC
            END IF
            IF( ILZ )
     $         CALL CSCAL( N, SIGNBC, Z( 1, ILAST ), 1 )
         ELSE
            B( ILAST, ILAST ) = CZERO
         END IF
         ALPHA( ILAST ) = A( ILAST, ILAST )
         BETA( ILAST ) = B( ILAST, ILAST )
*
*        Go to next block -- exit if finished.
*
         ILAST = ILAST - 1
         IF( ILAST.LT.ILO )
     $      GO TO 190
*
*        Reset counters
*
         IITER = 0
         ESHIFT = CZERO
         IF( .NOT.ILSCHR ) THEN
            ILASTM = ILAST
            IF( IFRSTM.GT.ILAST )
     $         IFRSTM = ILO
         END IF
         GO TO 160
*
*        QZ step
*
*        This iteration only involves rows/columns IFIRST:ILAST.  We
*        assume IFIRST < ILAST, and that the diagonal of B is non-zero.
*
   70    CONTINUE
         IITER = IITER + 1
         IF( .NOT.ILSCHR ) THEN
            IFRSTM = IFIRST
         END IF
*
*        Compute the Shift.
*
*        At this point, IFIRST < ILAST, and the diagonal elements of
*        B(IFIRST:ILAST,IFIRST,ILAST) are larger than BTOL (in
*        magnitude)
*
         IF( ( IITER / 10 )*10.NE.IITER ) THEN
*
*           The Wilkinson shift (AEP p.512), i.e., the eigenvalue of
*           the bottom-right 2x2 block of A inv(B) which is nearest to
*           the bottom-right element.
*
*           We factor B as U*D, where U has unit diagonals, and
*           compute (A*inv(D))*inv(U).
*
            U12 = ( BSCALE*B( ILAST-1, ILAST ) ) /
     $            ( BSCALE*B( ILAST, ILAST ) )
            AD11 = ( ASCALE*A( ILAST-1, ILAST-1 ) ) /
     $             ( BSCALE*B( ILAST-1, ILAST-1 ) )
            AD21 = ( ASCALE*A( ILAST, ILAST-1 ) ) /
     $             ( BSCALE*B( ILAST-1, ILAST-1 ) )
            AD12 = ( ASCALE*A( ILAST-1, ILAST ) ) /
     $             ( BSCALE*B( ILAST, ILAST ) )
            AD22 = ( ASCALE*A( ILAST, ILAST ) ) /
     $             ( BSCALE*B( ILAST, ILAST ) )
            ABI22 = AD22 - U12*AD21
*
            T = HALF*( AD11+ABI22 )
            RTDISC = SQRT( T**2+AD12*AD21-AD11*AD22 )
            TEMP = REAL( T-ABI22 )*REAL( RTDISC ) +
     $             AIMAG( T-ABI22 )*AIMAG( RTDISC )
            IF( TEMP.LE.ZERO ) THEN
               SHIFT = T + RTDISC
            ELSE
               SHIFT = T - RTDISC
            END IF
         ELSE
*
*           Exceptional shift.  Chosen for no particularly good reason.
*
            ESHIFT = ESHIFT + CONJG( ( ASCALE*A( ILAST-1, ILAST ) ) /
     $               ( BSCALE*B( ILAST-1, ILAST-1 ) ) )
            SHIFT = ESHIFT
         END IF
*
*        Now check for two consecutive small subdiagonals.
*
         DO 80 J = ILAST - 1, IFIRST + 1, -1
            ISTART = J
            CTEMP = ASCALE*A( J, J ) - SHIFT*( BSCALE*B( J, J ) )
            TEMP = ABS1( CTEMP )
            TEMP2 = ASCALE*ABS1( A( J+1, J ) )
            TEMPR = MAX( TEMP, TEMP2 )
            IF( TEMPR.LT.ONE .AND. TEMPR.NE.ZERO ) THEN
               TEMP = TEMP / TEMPR
               TEMP2 = TEMP2 / TEMPR
            END IF
            IF( ABS1( A( J, J-1 ) )*TEMP2.LE.TEMP*ATOL )
     $         GO TO 90
   80    CONTINUE
*
         ISTART = IFIRST
         CTEMP = ASCALE*A( IFIRST, IFIRST ) -
     $           SHIFT*( BSCALE*B( IFIRST, IFIRST ) )
   90    CONTINUE
*
*        Do an implicit-shift QZ sweep.
*
*        Initial Q
*
         CTEMP2 = ASCALE*A( ISTART+1, ISTART )
         CALL CLARTG( CTEMP, CTEMP2, C, S, CTEMP3 )
*
*        Sweep
*
         DO 150 J = ISTART, ILAST - 1
            IF( J.GT.ISTART ) THEN
               CTEMP = A( J, J-1 )
               CALL CLARTG( CTEMP, A( J+1, J-1 ), C, S, A( J, J-1 ) )
               A( J+1, J-1 ) = CZERO
            END IF
*
            DO 100 JC = J, ILASTM
               CTEMP = C*A( J, JC ) + S*A( J+1, JC )
               A( J+1, JC ) = -CONJG( S )*A( J, JC ) + C*A( J+1, JC )
               A( J, JC ) = CTEMP
               CTEMP2 = C*B( J, JC ) + S*B( J+1, JC )
               B( J+1, JC ) = -CONJG( S )*B( J, JC ) + C*B( J+1, JC )
               B( J, JC ) = CTEMP2
  100       CONTINUE
            IF( ILQ ) THEN
               DO 110 JR = 1, N
                  CTEMP = C*Q( JR, J ) + CONJG( S )*Q( JR, J+1 )
                  Q( JR, J+1 ) = -S*Q( JR, J ) + C*Q( JR, J+1 )
                  Q( JR, J ) = CTEMP
  110          CONTINUE
            END IF
*
            CTEMP = B( J+1, J+1 )
            CALL CLARTG( CTEMP, B( J+1, J ), C, S, B( J+1, J+1 ) )
            B( J+1, J ) = CZERO
*
            DO 120 JR = IFRSTM, MIN( J+2, ILAST )
               CTEMP = C*A( JR, J+1 ) + S*A( JR, J )
               A( JR, J ) = -CONJG( S )*A( JR, J+1 ) + C*A( JR, J )
               A( JR, J+1 ) = CTEMP
  120       CONTINUE
            DO 130 JR = IFRSTM, J
               CTEMP = C*B( JR, J+1 ) + S*B( JR, J )
               B( JR, J ) = -CONJG( S )*B( JR, J+1 ) + C*B( JR, J )
               B( JR, J+1 ) = CTEMP
  130       CONTINUE
            IF( ILZ ) THEN
               DO 140 JR = 1, N
                  CTEMP = C*Z( JR, J+1 ) + S*Z( JR, J )
                  Z( JR, J ) = -CONJG( S )*Z( JR, J+1 ) + C*Z( JR, J )
                  Z( JR, J+1 ) = CTEMP
  140          CONTINUE
            END IF
  150    CONTINUE
*
  160    CONTINUE
*
  170 CONTINUE
*
*     Drop-through = non-convergence
*
  180 CONTINUE
      INFO = ILAST
      GO TO 210
*
*     Successful completion of all QZ steps
*
  190 CONTINUE
*
*     Set Eigenvalues 1:ILO-1
*
      DO 200 J = 1, ILO - 1
         ABSB = ABS( B( J, J ) )
         IF( ABSB.GT.SAFMIN ) THEN
            SIGNBC = CONJG( B( J, J ) / ABSB )
            B( J, J ) = ABSB
            IF( ILSCHR ) THEN
               CALL CSCAL( J-1, SIGNBC, B( 1, J ), 1 )
               CALL CSCAL( J, SIGNBC, A( 1, J ), 1 )
            ELSE
               A( J, J ) = A( J, J )*SIGNBC
            END IF
            IF( ILZ )
     $         CALL CSCAL( N, SIGNBC, Z( 1, J ), 1 )
         ELSE
            B( J, J ) = CZERO
         END IF
         ALPHA( J ) = A( J, J )
         BETA( J ) = B( J, J )
  200 CONTINUE
*
*     Normal Termination
*
      INFO = 0
*
*     Exit (other than argument error) -- return optimal workspace size
*
  210 CONTINUE
      WORK( 1 ) = CMPLX( N )
      RETURN
*
*     End of CHGEQZ
*
      END

C
C $Id: lbsetr.f,v 1.8 2008-07-27 00:17:17 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE LBSETR (WHCH,RVAL)
C
        CHARACTER*(*) WHCH
C
C This subroutine is called to set the real value of a specified
C parameter.
C
C WHCH is the name of the parameter whose value is to be set.
C
C RVAL is a real variable containing the new value of the parameter.
C
C
C Declare the common block where internal parameters are stored.
C
        COMMON /LBCOMN/ ICBL,ICFL,ICLB,WOBL,WOFL,WOLB
        SAVE   /LBCOMN/
C
C Define a character temporary for use in forming error messages.
C
        CHARACTER*39 CTMP
C
C Do a call forcing a BLOCKDATA to be loaded from a binary library.
C
        CALL LBBLDA
C
C Check for an uncleared prior error.
C
        IF (ICFELL('LBSETR - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C Check for a parameter name that is too short.
C
        IF (LEN(WHCH).LT.3) THEN
          CTMP(1:36)='LBSETR - PARAMETER NAME TOO SHORT - '
          CTMP(37:36+LEN(WHCH))=WHCH
          CALL SETER (CTMP(1:36+LEN(WHCH)),2,1)
          RETURN
        END IF
C
C Set the appropriate parameter value.
C
        IF      (WHCH(1:3).EQ.'CBL'.OR.WHCH(1:3).EQ.'cbl') THEN
          ICBL=MAX(-1,INT(RVAL))
        ELSE IF (WHCH(1:3).EQ.'CFL'.OR.WHCH(1:3).EQ.'cfl') THEN
          ICFL=MAX(-1,INT(RVAL))
        ELSE IF (WHCH(1:3).EQ.'CLB'.OR.WHCH(1:3).EQ.'clb') THEN
          ICLB=MAX(-1,INT(RVAL))
        ELSE IF (WHCH(1:3).EQ.'WBL'.OR.WHCH(1:3).EQ.'wbl') THEN
          WOBL=MAX(0.,RVAL)
        ELSE IF (WHCH(1:3).EQ.'WFL'.OR.WHCH(1:3).EQ.'wfl') THEN
          WOFL=MAX(0.,RVAL)
        ELSE IF (WHCH(1:3).EQ.'WLB'.OR.WHCH(1:3).EQ.'wlb') THEN
          WOLB=MAX(0.,RVAL)
        ELSE
          CTMP(1:36)='LBSETR - PARAMETER NAME NOT KNOWN - '
          CTMP(37:39)=WHCH(1:3)
          CALL SETER (CTMP(1:39),3,1)
          RETURN
        END IF
C
C Done.
C
        RETURN
C
      END

C
C $Id: ceezdp.f,v 1.3 2008-07-27 03:10:10 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
C NOTE: If you make any changes to this software, please remember to
C make the same changes to the corresponding single precision routine.
C
      SUBROUTINE CEEZDP(DEL1,DEL2,SIGMA,C1,C2,C3,N)
      DOUBLE PRECISION DEL
      DOUBLE PRECISION DUMMY
      DOUBLE PRECISION COSHM1
      DOUBLE PRECISION COSHM2
      DOUBLE PRECISION DELP
      DOUBLE PRECISION DELM
      DOUBLE PRECISION SINHMP
      DOUBLE PRECISION SINHMM
      DOUBLE PRECISION DENOM
c
      DOUBLE PRECISION DEL1,DEL2,SIGMA,C1,C2,C3
c
c                                 coded by alan kaylor cline
c                           from fitpack -- january 26, 1987
c                        a curve and surface fitting package
c                      a product of pleasant valley software
c                  8603 altus cove, austin, texas 78759, usa
c
c this subroutine determines the coefficients c1, c2, and c3
c used to determine endpoint slopes. specifically, if
c function values y1, y2, and y3 are given at points x1, x2,
c and x3, respectively, the quantity c1*y1 + c2*y2 + c3*y3
c is the value of the derivative at x1 of a spline under
c tension (with tension factor sigma) passing through the
c three points and having third derivative equal to zero at
c x1. optionally, only two values, c1 and c2 are determined.
c
c on input--
c
c   del1 is x2-x1 (.gt. 0.).
c
c   del2 is x3-x1 (.gt. 0.). if n .eq. 2, this parameter is
c   ignored.
c
c   sigma is the tension factor.
c
c and
c
c   n is a switch indicating the number of coefficients to
c   be returned. if n .eq. 2 only two coefficients are
c   returned. otherwise all three are returned.
c
c on output--
c
c   c1, c2, and c3 contain the coefficients.
c
c none of the input parameters are altered.
c
c this subroutine references package module snhcsh.
c
c-----------------------------------------------------------
c
      IF (N.EQ.2) GO TO 2
      IF (SIGMA.NE.0.D0) GO TO 1
      DEL = DEL2 - DEL1
c
c tension .eq. 0.
c
      C1 = - (DEL1+DEL2)/ (DEL1*DEL2)
      C2 = DEL2/ (DEL1*DEL)
      C3 = -DEL1/ (DEL2*DEL)
      RETURN
c
c tension .ne. 0.
c
    1 CALL SNHCSHDP(DUMMY,COSHM1,SIGMA*DEL1,1)
      CALL SNHCSHDP(DUMMY,COSHM2,SIGMA*DEL2,1)
      DELP = SIGMA* (DEL2+DEL1)/2.D0
      DELM = SIGMA* (DEL2-DEL1)/2.D0
      CALL SNHCSHDP(SINHMP,DUMMY,DELP,-1)
      CALL SNHCSHDP(SINHMM,DUMMY,DELM,-1)
      DENOM = COSHM1* (DEL2-DEL1) - 2.D0*DEL1*DELP*DELM* (1.D0+SINHMP)*
     +        (1.D0+SINHMM)
      C1 = 2.D0*DELP*DELM* (1.D0+SINHMP)* (1.D0+SINHMM)/DENOM
      C2 = -COSHM2/DENOM
      C3 = COSHM1/DENOM
      RETURN
c
c two coefficients
c
    2 C1 = -1.D0/DEL1
      C2 = -C1
      RETURN
      END

C NCLFORTSTART
      subroutine dpresplvl(klvl,plevel,ntim,nlat,mlon,psfc,pmsg
     +                    ,ptop,dp,iopt,kflag,ier)
      implicit none
C                                                ! input 
      integer  klvl,ntim,nlat,mlon,iopt,kflag,ier
      double precision     plevel(klvl), psfc(mlon,nlat,ntim),ptop,pmsg
C                                                ! output
      double precision     dp(mlon,nlat,klvl,ntim)
C NCLEND
c     dpres = dpres_plevel(plevel, psfc, ptop, iopt)
c
      integer nt, ml, nl, kl, jer, kloop 
      double precision  dplvl(klvl)
cdebugdouble precision  dpsum, pdif   

      kflag = 0
      kloop = -999

c loop over all grid points

      do nt=1,ntim
        do nl=1,nlat
          do ml=1,mlon

c calculate vertical 'dp' at current grid point

             call dpres1d(klvl,plevel,psfc(ml,nl,nt),pmsg
     +                    ,ptop,dplvl,iopt,kloop,ier)
             if (kloop.eq.1) then
                 kflag = 1
             end if

c transfer to return array

             do kl=1,klvl
                dp(ml,nl,kl,nt) = dplvl(kl)
             end do

cdebug       dpsum = sum(dplvl, 1, dplvl.ne.pmsg)   ! f90 array function
cdebug       pdif  = psfc(ml,nl,nt)-ptop
cdebug       print *,"dpsum=", dpsum,"  pdif=",pdif

          end do
        end do
      end do

      return
      end
c ------------------------------------------------------------------------
C NCLFORTSTART
      subroutine dpres1d(klvl,plevel,psfc,pmsg,ptop,dp,iopt,kflag,ier) 
      implicit none
C                                                ! input 
      integer              klvl, iopt, kflag, ier
      double precision     plevel(klvl), psfc, ptop, pmsg
C                                                ! output
      double precision     dp(klvl)
C NCLEND
c     dpres = dpres_plevel(plevel, psfc, ptop, iopt)
c
c isobaric (constant) pressure level equivalent of dpres_hybrid_ccm
c The returned 'dp' are equivalent to having used  beta factors.
 
C                                                ! local
      integer             mono, kl, klStrt, klLast
      double precision    plvl(klvl), work(klvl)
      double precision    dpsum, pspan, peps, plow, phi

      peps  = 0.001d0
c
c check to see if ptop is reasonable
c .   psfc = pmsg   is not allowed
c .   ptop < 0      is not allowed
c .   ptop > psfcmx is probably due to units difference

      ier    = 0
      if (psfc.eq.pmsg .or. psfc.lt.0.0d0) ier = ier + 100
      if (ptop.lt.0.0d0) ier = ier + 1
      if (ptop.ge.psfc)  ier = ier + 10

c if ier.ne.0; input error with psfc and/or ptop

      if (ier.ne.0) then   
          kflag = 1
          do kl=1,klvl 
             dp(kl)   = pmsg
          end do
          dpsum = pmsg
          return
      end if

c monotonically increasing or decreasing? Code wants top to bottom
c if decreasing pressure make increasing; then flip back 

      if (plevel(2).gt.plevel(1)) then
          mono =  1
          do kl=1,klvl
             plvl(kl) = plevel(kl)
          end do
      else
          mono = -1
          do kl=1,klvl
             plvl(kl) = plevel(klvl-kl+1)
          end do
      end if

c initialize to missing

      do kl=1,klvl
         dp(kl) = pmsg                 
      end do

c calculate 'dp'; check if dpsum.eq.(psfc-ptop) within peps then return

      if (ptop.le.plvl(1) .and. psfc.ge.plvl(klvl)) then
          kflag = 0

          dp(1) = (plvl(1)+plvl(2))*0.5d0 - ptop
          do kl=2,klvl-1 
             dp(kl)= 0.5d0*(plvl(kl+1) - plvl(kl-1))
          end do
          dp(klvl) = psfc -(plvl(klvl)+plvl(klvl-1))*0.5d0

      else 
          kflag  = 1

          klStrt = 1
          if (ptop.ge.plvl(1)) then
             do kl=1,klvl 
                if (ptop.le.plvl(kl)) then
                    klStrt = kl
                    exit
                end if
             end do
          end if

          klLast = klvl
          if (psfc.le.plvl(klvl)) then
             do kl=1,klvl 
                if (psfc.le.plvl(kl)) then
                    klLast = kl-1
                    exit
                end if
             end do
          end if

cdebugprint *,"klStrt=",klStrt," klLast=",klLast," ptop=",ptop
cdebugprint *,"plvl(klStrt)=",plvl(klStrt)," plvl(klLast)=",plvl(klLast)
cdebugprint *,"plvl(klStrt  )=",plvl(klStrt)  
cdebugprint *,"plvl(klStrt+1)=",plvl(klStrt+1)
cdebugprint *,"dp(klStrt)=",dp(klStrt)

          if (klStrt.eq.klLast) then
              dp(klStrt) = psfc-ptop
          elseif (klStrt.lt.klLast) then
              dp(klStrt) = (plvl(klStrt)+plvl(klStrt+1))*0.5d0 - ptop
              do kl=klStrt+1,klLast-1 
                 dp(kl)= 0.5d0*(plvl(kl+1) - plvl(kl-1))
              end do
              dp(klLast) = psfc -(plvl(klLast)+plvl(klLast-1))*0.5d0

c c c     else     ! klStrt>klLast  is a pathological case
c c c              ! plev(?)=500  plev(?+1)=550, psfc=540, ptop=510
c c c              ! both level are *between* levels
          end if

      end if

c error check

c f90 dpsum = sum(dplvl, 1, dplvl.ne.pmsg)  
      dpsum = 0.0d0
      do kl=1,klvl
         if (dp(kl).ne.pmsg) then
             dpsum = dpsum + dp(kl)
         end if
      end do

      pspan = psfc-ptop

      if (dpsum.gt.0.0d0 .and. pspan.ne.dpsum) then
          plow = pspan-peps 
          phi  = pspan+peps 
          if (dpsum.gt.phi .or. dpsum.lt.plow) then
              ier = -1
              do kl=1,klvl
                 dp(kl) = pmsg                 
              end do
          end if
      end if

c if necessary return to original order

      if (mono.lt.0) then
          do kl=1,klvl
             work(kl) = dp(kl)
          end do

          do kl=1,klvl
             dp(kl) = work(klvl-kl+1)
          end do
       end if

      return
      end

C
C $Id: dpvect.f,v 1.6 2008-07-27 00:16:59 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE DPVECT (XCPU,YCPU)
C
C Given the user coordinates of the point (XCPU,YCPU), this routine
C generates the appropriate call to continue a curve to that point;
C it is meant to be used in combination with DPFRST and DPLAST.
C
C Declare the real/integer common block.
C
        COMMON /DPCMRI/ ANGF,DBPI,EPSI,IDPI,IDPS,ILTL,INDP,IPCF,ISBF,
     +                  ISCF,LCDP,RLS1,RLS2,RMFS,TENS,WCHR,WGAP,WSLD
        SAVE   /DPCMRI/
C
C Check for an uncleared prior error.
C
        IF (ICFELL('DPVECT - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C Get the fractional-system coordinates of the point.
C
        XCPF=CUFX(XCPU)
        IF (ICFELL('DPVECT',2).NE.0) RETURN
C
        YCPF=CUFY(YCPU)
        IF (ICFELL('DPVECT',3).NE.0) RETURN
C
C Call the appropriate lower-level routine, depending on whether
C smoothing is turned on or not.
C
        IF (TENS.LT.0.) THEN
          CALL DPDRAW (XCPF,YCPF,1)
          IF (ICFELL('DPVECT',4).NE.0) RETURN
        ELSE
          CALL DPSMTH (XCPF,YCPF,1)
          IF (ICFELL('DPVECT',5).NE.0) RETURN
        END IF
C
C Done.
C
        RETURN
C
      END

      REAL FUNCTION R1MACH(I)
      INTEGER I
C
C  SINGLE-PRECISION MACHINE CONSTANTS
C  R1MACH(1) = B**(EMIN-1), THE SMALLEST POSITIVE MAGNITUDE.
C  R1MACH(2) = B**EMAX*(1 - B**(-T)), THE LARGEST MAGNITUDE.
C  R1MACH(3) = B**(-T), THE SMALLEST RELATIVE SPACING.
C  R1MACH(4) = B**(1-T), THE LARGEST RELATIVE SPACING.
C  R1MACH(5) = LOG10(B)
C
      INTEGER SMALL(2)
      INTEGER LARGE(2)
      INTEGER RIGHT(2)
      INTEGER DIVER(2)
      INTEGER LOG10(2)
C     needs to be (2) for AUTODOUBLE, HARRIS SLASH 6, ...
      INTEGER SC
      SAVE SMALL, LARGE, RIGHT, DIVER, LOG10, SC
      REAL RMACH(5)
      EQUIVALENCE (RMACH(1),SMALL(1))
      EQUIVALENCE (RMACH(2),LARGE(1))
      EQUIVALENCE (RMACH(3),RIGHT(1))
      EQUIVALENCE (RMACH(4),DIVER(1))
      EQUIVALENCE (RMACH(5),LOG10(1))
      INTEGER J, K, L, T3E(3)
      DATA T3E(1) / 9777664 /
      DATA T3E(2) / 5323660 /
      DATA T3E(3) / 46980 /
C  THIS VERSION ADAPTS AUTOMATICALLY TO MOST CURRENT MACHINES,
C  INCLUDING AUTO-DOUBLE COMPILERS.
C  TO COMPILE ON OLDER MACHINES, ADD A C IN COLUMN 1
C  ON THE NEXT LINE
      DATA SC/0/
C  AND REMOVE THE C FROM COLUMN 1 IN ONE OF THE SECTIONS BELOW.
C  CONSTANTS FOR EVEN OLDER MACHINES CAN BE OBTAINED BY
C          mail netlib@research.bell-labs.com
C          send old1mach from blas
C  PLEASE SEND CORRECTIONS TO dmg OR ehg@bell-labs.com.
C
C     MACHINE CONSTANTS FOR THE HONEYWELL DPS 8/70 SERIES.
C      DATA RMACH(1) / O402400000000 /
C      DATA RMACH(2) / O376777777777 /
C      DATA RMACH(3) / O714400000000 /
C      DATA RMACH(4) / O716400000000 /
C      DATA RMACH(5) / O776464202324 /, SC/987/
C
C     MACHINE CONSTANTS FOR PDP-11 FORTRANS SUPPORTING
C     32-BIT INTEGERS (EXPRESSED IN INTEGER AND OCTAL).
C      DATA SMALL(1) /    8388608 /
C      DATA LARGE(1) / 2147483647 /
C      DATA RIGHT(1) /  880803840 /
C      DATA DIVER(1) /  889192448 /
C      DATA LOG10(1) / 1067065499 /, SC/987/
C      DATA RMACH(1) / O00040000000 /
C      DATA RMACH(2) / O17777777777 /
C      DATA RMACH(3) / O06440000000 /
C      DATA RMACH(4) / O06500000000 /
C      DATA RMACH(5) / O07746420233 /, SC/987/
C
C     MACHINE CONSTANTS FOR THE UNIVAC 1100 SERIES.
C      DATA RMACH(1) / O000400000000 /
C      DATA RMACH(2) / O377777777777 /
C      DATA RMACH(3) / O146400000000 /
C      DATA RMACH(4) / O147400000000 /
C      DATA RMACH(5) / O177464202324 /, SC/987/
C
      IF (SC .NE. 987) THEN
*        *** CHECK FOR AUTODOUBLE ***
         SMALL(2) = 0
         RMACH(1) = 1E13
         IF (SMALL(2) .NE. 0) THEN
*           *** AUTODOUBLED ***
            IF (      SMALL(1) .EQ. 1117925532
     *          .AND. SMALL(2) .EQ. -448790528) THEN
*              *** IEEE BIG ENDIAN ***
               SMALL(1) = 1048576
               SMALL(2) = 0
               LARGE(1) = 2146435071
               LARGE(2) = -1
               RIGHT(1) = 1017118720
               RIGHT(2) = 0
               DIVER(1) = 1018167296
               DIVER(2) = 0
               LOG10(1) = 1070810131
               LOG10(2) = 1352628735
            ELSE IF ( SMALL(2) .EQ. 1117925532
     *          .AND. SMALL(1) .EQ. -448790528) THEN
*              *** IEEE LITTLE ENDIAN ***
               SMALL(2) = 1048576
               SMALL(1) = 0
               LARGE(2) = 2146435071
               LARGE(1) = -1
               RIGHT(2) = 1017118720
               RIGHT(1) = 0
               DIVER(2) = 1018167296
               DIVER(1) = 0
               LOG10(2) = 1070810131
               LOG10(1) = 1352628735
            ELSE IF ( SMALL(1) .EQ. -2065213935
     *          .AND. SMALL(2) .EQ. 10752) THEN
*              *** VAX WITH D_FLOATING ***
               SMALL(1) = 128
               SMALL(2) = 0
               LARGE(1) = -32769
               LARGE(2) = -1
               RIGHT(1) = 9344
               RIGHT(2) = 0
               DIVER(1) = 9472
               DIVER(2) = 0
               LOG10(1) = 546979738
               LOG10(2) = -805796613
            ELSE IF ( SMALL(1) .EQ. 1267827943
     *          .AND. SMALL(2) .EQ. 704643072) THEN
*              *** IBM MAINFRAME ***
               SMALL(1) = 1048576
               SMALL(2) = 0
               LARGE(1) = 2147483647
               LARGE(2) = -1
               RIGHT(1) = 856686592
               RIGHT(2) = 0
               DIVER(1) = 873463808
               DIVER(2) = 0
               LOG10(1) = 1091781651
               LOG10(2) = 1352628735
            ELSE
               WRITE(*,9010)
               STOP 777
               END IF
         ELSE
            RMACH(1) = 1234567.
            IF (SMALL(1) .EQ. 1234613304) THEN
*              *** IEEE ***
               SMALL(1) = 8388608
               LARGE(1) = 2139095039
               RIGHT(1) = 864026624
               DIVER(1) = 872415232
               LOG10(1) = 1050288283
            ELSE IF (SMALL(1) .EQ. -1271379306) THEN
*              *** VAX ***
               SMALL(1) = 128
               LARGE(1) = -32769
               RIGHT(1) = 13440
               DIVER(1) = 13568
               LOG10(1) = 547045274
            ELSE IF (SMALL(1) .EQ. 1175639687) THEN
*              *** IBM MAINFRAME ***
               SMALL(1) = 1048576
               LARGE(1) = 2147483647
               RIGHT(1) = 990904320
               DIVER(1) = 1007681536
               LOG10(1) = 1091781651
            ELSE IF (SMALL(1) .EQ. 1251390520) THEN
*              *** CONVEX C-1 ***
               SMALL(1) = 8388608
               LARGE(1) = 2147483647
               RIGHT(1) = 880803840
               DIVER(1) = 889192448
               LOG10(1) = 1067065499
            ELSE
               DO 10 L = 1, 3
                  J = SMALL(1) / 10000000
                  K = SMALL(1) - 10000000*J
                  IF (K .NE. T3E(L)) GO TO 20
                  SMALL(1) = J
 10               CONTINUE
*              *** CRAY T3E ***
               CALL I1MCRA(SMALL, K, 16, 0, 0)
               CALL I1MCRA(LARGE, K, 32751, 16777215, 16777215)
               CALL I1MCRA(RIGHT, K, 15520, 0, 0)
               CALL I1MCRA(DIVER, K, 15536, 0, 0)
               CALL I1MCRA(LOG10, K, 16339, 4461392, 10451455)
               GO TO 30
 20            CALL I1MCRA(J, K, 16405, 9876536, 0)
               IF (SMALL(1) .NE. J) THEN
                  WRITE(*,9020)
                  STOP 777
                  END IF
*              *** CRAY 1, XMP, 2, AND 3 ***
               CALL I1MCRA(SMALL(1), K, 8195, 8388608, 1)
               CALL I1MCRA(LARGE(1), K, 24574, 16777215, 16777214)
               CALL I1MCRA(RIGHT(1), K, 16338, 8388608, 0)
               CALL I1MCRA(DIVER(1), K, 16339, 8388608, 0)
               CALL I1MCRA(LOG10(1), K, 16383, 10100890, 8715216)
               END IF
            END IF
 30      SC = 987
         END IF
*     SANITY CHECK
      IF (RMACH(4) .GE. 1.0) STOP 776
      IF (I .LT. 1 .OR. I .GT. 5) THEN
         WRITE(*,*) 'R1MACH(I): I =',I,' is out of bounds.'
         STOP
         END IF
      R1MACH = RMACH(I)
      RETURN
 9010 FORMAT(/' Adjust autodoubled R1MACH by getting data'/
     *' appropriate for your machine from D1MACH.')
 9020 FORMAT(/' Adjust R1MACH by uncommenting data statements'/
     *' appropriate for your machine.')
* /* C source for R1MACH -- remove the * in column 1 */
*#include <stdio.h>
*#include <float.h>
*#include <math.h>
*float r1mach_(long *i)
*{
*	switch(*i){
*	  case 1: return FLT_MIN;
*	  case 2: return FLT_MAX;
*	  case 3: return FLT_EPSILON/FLT_RADIX;
*	  case 4: return FLT_EPSILON;
*	  case 5: return log10((double)FLT_RADIX);
*	  }
*	fprintf(stderr, "invalid argument: r1mach(%ld)\n", *i);
*	exit(1); return 0; /* else complaint of missing return value */
*}
      END
      SUBROUTINE I1MCRA(A, A1, B, C, D)
**** SPECIAL COMPUTATION FOR CRAY MACHINES ****
      INTEGER A, A1, B, C, D
      A1 = 16777216*B + C
      A = 16777216*A1 + D
      END

C
C	$Id: msntvl.f,v 1.4 2008-07-27 00:17:30 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      FUNCTION MSNTVL (T,X,N)
C
      INTEGER N
      REAL T,X(N)
C
C ---------------------------------------------------------------------
C Note:  This routine comes from a proprietary package called FITPACK.
C It is used in the NCAR graphics package by permission of the author,
C Alan Cline.
C ---------------------------------------------------------------------
C
C                                            CODED BY ALAN KAYLOR CLINE
C                                         FROM FITPACK -- JUNE 22, 1986
C                                   A CURVE AND SURFACE FITTING PACKAGE
C                                 A PRODUCT OF PLEASANT VALLEY SOFTWARE
C                             8603 ALTUS COVE, AUSTIN, TEXAS 78759, USA
C
C ---------------------------------------------------------------------
C
C THIS FUNCTION DETERMINES THE INDEX OF THE INTERVAL
C (DETERMINED BY A GIVEN INCREASING SEQUENCE) IN WHICH
C A GIVEN VALUE LIES.
C
C ON INPUT--
C
C   T IS THE GIVEN VALUE.
C
C   X IS A VECTOR OF STRICTLY INCREASING VALUES.
C
C AND
C
C   N IS THE LENGTH OF X (N .GE. 2).
C
C ON OUTPUT--
C
C   MSNTVL RETURNS AN INTEGER I SUCH THAT
C
C          I = 1       IF             T .LT. X(2)  ,
C          I = N-1     IF X(N-1) .LE. T            ,
C          OTHERWISE       X(I)  .LE. T .LT. X(I+1),
C
C NONE OF THE INPUT PARAMETERS ARE ALTERED.
C
C-----------------------------------------------------------
C
      SAVE I
      DATA I /1/
C
      TT = T
C
C CHECK FOR ILLEGAL I
C
      IF (I .GE. N) I = N/2
C
C CHECK OLD INTERVAL AND EXTREMES
C
      IF (TT .LT. X(I)) THEN
        IF (TT .LE. X(2)) THEN
          I = 1
          MSNTVL = 1
          RETURN
        ELSE
          IL = 2
          IH = I
        END IF
      ELSE IF (TT .LE. X(I+1)) THEN
        MSNTVL = I
        RETURN
      ELSE IF (TT .GE. X(N-1)) THEN
        I = N-1
        MSNTVL = N-1
        RETURN
      ELSE
        IL = I+1
        IH = N-1
      END IF
C
C BINARY SEARCH LOOP
C
    1 I = (IL+IH)/2
      IF (TT .LT. X(I)) THEN
        IH = I
      ELSE IF (TT .GT. X(I+1)) THEN
        IL = I+1
      ELSE
        MSNTVL = I
        RETURN
      END IF
      GO TO 1
      END

C
C	$Id: gwpdvr.f,v 1.5 2008-07-27 00:21:08 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
        SUBROUTINE GWPDVR (RNVAL, IPOINT, IPRIM)
C
C  Update attribute deferral variables for a real-valued attribute.
C
C
C  Parameters:
C
C    INPUT
C      RNVAL   - New value for the attribute item.
C      IPOINT  - Pointer into deferral control variable structures, 
C                and into the index array that gives the start of the
C                primitive in the attribute equivalencing array, 
C                real version.
C      IPRIM   - Output primitive type associated with the attribute 
C                (1=POLYLINE, 2=POLYMARKER, 3=TEXT, 4=FILL AREA).  
C                used to index into other of the control variable 
C                structures.
C
C      OUTPUT
C        Adjustment of attribute deferral control parameters in COMMON.        
C
      include 'gwiarq.h'
      include 'gwiast.h'
      include 'gwiadc.h'
C
      REAL    RNVAL(*)
      INTEGER IPOINT, IPRIM
C
      LOGICAL CHGNS
      INTEGER I, IOFF, LNGVAL
C
      SAVE
C
C  Offset and length of attribute in equivalencing structures.
C
      IOFF   = ABS(IP2AEA(IPOINT))
      LNGVAL = IL2AEA(IPOINT)
C
C  Is the new value different from the last sent?
C
      CHGNS = RNVAL(1).NE.ASAEQV(IOFF)
      DO 10 I=2,LNGVAL
        CHGNS = CHGNS.OR. RNVAL(I).NE.ASAEQV(IOFF+I-1)
   10 CONTINUE
C
      IF (CHGNS) THEN
C
C  New and last sent differ -- set aggregate change-pending parameter.
C
        AGPEND(IPRIM) = .TRUE.
      END IF
C
C  Copy new value to requested.
C
      ARAEQV(IOFF) = RNVAL(1)
      DO 30 I=2,LNGVAL
        ARAEQV(IOFF+I-1) = RNVAL(I)
   30 CONTINUE
C
C  Mark value change.
C
      VALCHG(IPOINT) = CHGNS
C
      RETURN
      END

C
C $Id: mdfnme.f,v 1.4 2008-07-27 00:17:06 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      CHARACTER*128 FUNCTION MDFNME (IAIN,ILVL)
C
        INTEGER       IAIN,ILVL
C
        PARAMETER (MNAI=8000)
C
C The value of MDFNME(IAIN) is the full name of the area with the area
C identifier IAIN, including the names of all its parents up to the
C the level specified by ILVL.
C
C Assume that IHON is the area identifier for the area named "Honshu",
C which has area type 3, meaning that it exists at the third level in
C the dataset; then it is that case that
C
C   MDFNME (IHON,3) = 'Japan - Honshu'
C   MDFNME (IHON,2) = 'Eurasia - Japan - Honshu'
C   MDFNME (IHON,1) = 'Land - Eurasia - Japan - Honshu'
C
        COMMON /MAPCMX/  IATY(MNAI),ISCI(MNAI),IPAR(MNAI)
        INTEGER          IATY,ISCI,IPAR
        SAVE   /MAPCMX/
C
        COMMON /MAPCMY/  NAME(MNAI),FLNS
        CHARACTER*64     NAME
        CHARACTER*512    FLNS
        SAVE   /MAPCMY/
C
C Declare local variables.
C
        INTEGER          ITMP,NSTP
        CHARACTER*128    CTMP
C
        MDFNME=' '
C
        ITMP=IAIN
        NSTP=0
C
  101   IF (ITMP.GE.1.AND.ITMP.LE.MNAI) THEN
          IF (IATY(ITMP).NE.0) THEN
            IF (NAME(ITMP).NE.' ') THEN
              IF (MDFNME.EQ.' ') THEN
                MDFNME=NAME(ITMP)
              ELSE
                CTMP=MDFNME
                MDFNME=NAME(ITMP)(1:MDILNB(NAME(ITMP)))//' - '//CTMP
              END IF
            END IF
            ITMP=IPAR(ITMP)
            IF (ITMP.GE.1.AND.ITMP.LE.MNAI) THEN
              IF (IATY(ITMP).GE.ILVL) THEN
                NSTP=NSTP+1
                IF (NSTP.LT.10) GO TO 101
              END IF
            END IF
          END IF
        END IF
C
        RETURN
C
      END

C
C	$Id: gtstr.f,v 1.4 2008-07-27 12:23:44 haley Exp $
C                                                                      
C			     Copyright (C)  1997
C	     University Corporation for Atmospheric Research
C			     All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C

      SUBROUTINE GTSTR(STRING, STRMAX, STRSIZ, IOS, STATUS)
C
C  Get a string of ASCII data values from the input file.
C  Each legal data value must be terminated by a blank or by an
C  end-of-line.
C
C  INPUT
C       STRMAX  --  Maximum number of characters to transfer.
C
C  OUTPUT
C       STRING  --  An integer array containing the ADE of the
C                   characters transferred.
C       STRSIZ  --  The number of characters actually transferred.
C       IOS     --  I/O status flag.  This flag is valid only
C                   if STATUS indicates an error.
C       STATUS  --  The error status as defined in COMMON CAPERR.
C
      COMMON /CAPERR/ ALLOK, EOFFL, INTERR, MAXINT, PLBERR, PMBERR,
     1                FABERR, TXBERR, FLTERR, MAXFLT, NOTINT, SIZERR,
     2                UNDASC, DEVERR, DOCERR, TBLERR , STSZER, ENTERR,
     3                TABERR, TABSER, PRSFIL
      INTEGER ALLOK, EOFFL, INTERR, MAXINT, PLBERR, PMBERR,
     1        FABERR, TXBERR, FLTERR, MAXFLT, NOTINT, SIZERR, UNDASC,
     2        DEVERR, DOCERR, STSZER, ENTERR, TABERR, TABSER, TBLERR,
     3        PRSFIL
      COMMON /CAPIOB/ UNIT, IPTR, LSIZE, NFST, NFLG
      COMMON /CAPIO2/ LINE, GRNM
      INTEGER LNMAX
      PARAMETER (LNMAX=80)
      CHARACTER*80 LINE
      CHARACTER*80 GRNM
      INTEGER UNIT, IPTR, LSIZE, NFST, NFLG
      COMMON /CAPASC/ ASCTB1, ASCTB2
      INTEGER TBLLE1, TBLWT1, INTVAL, TBLLE2, CORDVL
      PARAMETER (TBLLE1=41, TBLWT1=3, INTVAL=-1, TBLLE2=94, CORDVL=-7)
      CHARACTER*1 ASCTB1(TBLLE1, TBLWT1), ASCTB2(TBLLE2)
      COMMON /CAPASI/ ASCVL1, ASCVL2
      INTEGER ASCVL1(TBLLE1), ASCVL2(TBLLE2)
C
      INTEGER STRMAX, STRING(STRMAX), STRSIZ, IOS, STATUS
C
      INTEGER II,JJ,KK, AV, CURVAL
      CHARACTER*1 BLANK, CURCHR
      DATA BLANK/' '/
C
C  Set STRING size to null.
C
      STRSIZ = 0
C
C  Skip blanks.
C
 10   CONTINUE
      CALL SKPBLK(IOS, STATUS)
      IF (STATUS .NE. ALLOK) RETURN
C
C  Initialize search for an ASCII character (or processor dependent
C  strings, such as XYC, INT, etc.) which is represented
C  by a multi-character string.
C
      JJ = 1
 40   CONTINUE
      KK = 1
      II = IPTR
 50   CONTINUE
      CURCHR = ASCTB1(JJ,KK)
C
C  Search the ASCII definition table.
C
      IF(LINE(II:II).EQ. CURCHR) THEN
C
C  Match found with the current single character;  if we
C  have matched TBLWT1 single characters, then we have
C  an ASCII character match.
C
        IF (KK .EQ. TBLWT1) THEN
                AV = ASCVL1(JJ)
                GO TO 200
        END IF
C
C  Increment the width pointer and get the next character.
C
        KK = KK + 1
        CURCHR = ASCTB1(JJ,KK)
C
C  If the current character extracted from ASCTB1 is a blank, then
C  we must have a multi-character match.
C
        IF (CURCHR .EQ. BLANK) THEN
                AV = ASCVL1(JJ)
                GO TO 200
        END IF
C
C  If end of input line branch to new table entry.
C
        IF (II .LT. LSIZE) THEN
                II = II + 1
                GO TO 50
        END IF
      END IF
C
C  Go to new table entry.
C
      IF (JJ .EQ. TBLLE1) GO TO 100
      JJ = JJ + 1
      GO TO 40
C
C  Initialize the search for an ASCII character which
C  has an ADE between 33 (decimal) and 126 (decimal).
C
 100  CONTINUE
      JJ = 1
      II = IPTR
140   CONTINUE
      CURCHR = ASCTB2(JJ)
C
C  Search the ASCII definition table.
C
      IF(LINE(II:II).EQ. CURCHR) THEN
C
C  The current position is a match.
C
        AV = ASCVL2(JJ)
        GO TO 200
      END IF
C
C  Go to a new table entry.
C
      IF (JJ .EQ. TBLLE2) THEN
C
C  No match, so set the buffer pointer and return.
C
        IPTR = II
        RETURN
      END IF
      JJ = JJ + 1
      GO TO 140
C
C
 200  CONTINUE
C
C  ASCII table match, add value to STRING.
C
      IF (AV .GE. 0) THEN
C
C  Make certain that the next input position is a blank or
C  end-of-line, otherwise we don't really have a match.
C
        II = II + 1
        IF (II .LE.LSIZE) THEN
C
C  Not a match.
C
                IF (LINE(II:II) .NE. BLANK) RETURN
        END IF
C
C  A true (non processor dependent) ASCII character has been matched,
C  put it in STRING and search for another.
C
        CURVAL = AV
        IPTR = II
C
      ELSE IF (AV .EQ. INTVAL) THEN
C
C  INT flag has been matched, so decode the integer value following it.
C
        II = II + 1
        CALL INTCNV(CURVAL,II,IOS,STATUS)
        IF (STATUS.NE.ALLOK) THEN
                IF (STATUS.NE.NOTINT) RETURN
                STATUS = ALLOK
                RETURN
        END IF
      ELSE IF (AV .GE. CORDVL) THEN
C
C  Processor-dependent coordinate indicator has been matched,
C  put it into STRING.
C
        CURVAL = AV
        IPTR = II + 1
      ELSE
C
C   Undefined pattern.
C
                STATUS = UNDASC
      END IF
C
C  Set the current value in the output string if there is room.
C
      IF(STRSIZ.LT.STRMAX) THEN
        STRSIZ = STRSIZ + 1
        STRING(STRSIZ) = CURVAL
        GO TO 10
      END IF
C
C   Error --  No room left in STRING buffer.
C
      STATUS = SIZERR
      RETURN
      END

C
C $Id: phi4dp.f,v 1.5 2008-07-27 00:17:10 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE PHI4DP (ECCNTS,E0,E1,E2,E3,A,B,C,PHI)
C
C SUBROUTINE TO COMPUTE LATITUDE ANGLE (PHI-4).
C
      IMPLICIT DOUBLE PRECISION (A-Z)
      INTEGER II,NIT
      COMMON /ERRMZ0/ IERR
        INTEGER IERR
      SAVE   /ERRMZ0/
      COMMON /PRINZ0/ IPEMSG,IPELUN,IPPARM,IPPLUN
        INTEGER IPEMSG,IPELUN,IPPARM,IPPLUN
      SAVE   /PRINZ0/
      DATA ONE,TWO,FOUR,SIX /1.0D0,2.0D0,4.0D0,6.0D0/
      DATA TOL,NIT /1.0D-10,15/
C
      PHI = A
      DO 020 II = 1,NIT
      SINPHI = SIN (PHI)
      TANPHI = TAN (PHI)
      C = TANPHI * SQRT (ONE - ECCNTS * SINPHI * SINPHI)
      SIN2PH = SIN (TWO * PHI)
      ML = E0 * PHI - E1 * SIN2PH + E2 * SIN (FOUR * PHI)
     .      - E3 * SIN (SIX * PHI)
      MLP = E0 - TWO * E1 * COS (TWO * PHI) + FOUR * E2 *
     .      COS (FOUR * PHI) - SIX * E3 * COS (SIX * PHI)
      CON1 = TWO * ML + C * (ML * ML + B) - TWO * A *
     .       (C * ML + ONE)
      CON2 = ECCNTS * SIN2PH * (ML * ML + B - TWO * A * ML) / (TWO * C)
      CON3 = TWO * (A - ML) * (C * MLP - TWO / SIN2PH) - TWO * MLP
      DPHI = CON1 / (CON2 + CON3)
      PHI = PHI + DPHI
      IF (ABS(DPHI) .GT. TOL) GO TO 020
      RETURN
  020 CONTINUE
C
      IF (IPEMSG .EQ. 0) WRITE (IPELUN,2000) NIT,E0,E1,E2,E3,A,B,C,
     . ECCNTS
 2000 FORMAT (/' ERROR PHI4DP' /
     .         ' LATITUDE FAILED TO CONVERGE AFTER',I3,' ITERATIONS'/
     .         ' E0 =',E25.16,'   E1 =',E25.16/
     .         ' E2 =',E25.16,'   E3 =',E25.16/
     .         ' A  =',E25.16,'   B  =',E25.16/
     .         ' C  =',E25.16/
     .         ' ECCENTRICITY SQUARE =',E25.16)
      IERR = 004
      RETURN
C
      END

      PROGRAM AGDP01
C
C This is a demo program showing how to make AUTOGRAPH use DASHPACK,
C rather than DASHCHAR, to draw dashed lines, and also how to use a
C new feature of DASHPACK - the capability of drawing lines according
C to a pattern that specifies the use of interspersed symbols.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.  Use one
C of the following:
C
C       PARAMETER (IERF=6,LUNI=2,IWTY=1 ,IWID=1)  !  NCGM
C       PARAMETER (IERF=6,LUNI=2,IWTY=8 ,IWID=1)  !  X Windows
C       PARAMETER (IERF=6,LUNI=2,IWTY=20,IWID=1)  !  PostScript
C       PARAMETER (IERF=6,LUNI=2,IWTY=11,IWID=1)  !  PDF, Portrait
C       PARAMETER (IERF=6,LUNI=2,IWTY=12,IWID=1)  !  PDF, Landscape
C
        PARAMETER (IERF=6,LUNI=2,IWTYPE=1,IWTY=IWTYPE,IWID=1)
C
C Dimension arrays in which to define X and Y data for five curves.
C
        DIMENSION XCRA(101),YCRA(101,5)
C
C Declare some needed character variables.
C
        CHARACTER*12 DPT1,DPT2,DPT3,DPT4,DPT5
C
C Open GKS.
C
        CALL GOPKS (IERF,0)
        CALL GOPWK (IWID,LUNI,IWTY)
        CALL GACWK (IWID)
C
C Turn off the clipping indicator.
C
        CALL GSCLIP (0)
C
C Double the line width.
C
        CALL GSLWSC (2.)
C
C Define the data for the curves.
C
        DO 102 I=1,101
          XCRA(I)=REAL(I-1)/100.
          DO 101 J=1,5
            YCRA(I,J)=.02+.05*REAL(5-J)+.78*XCRA(I)**J
     +                                         +.5*(.25-(XCRA(I)-.5)**2)
  101     CONTINUE
  102   CONTINUE
C
C Tell AUTOGRAPH exactly what minimum and maximum values to use on the
C axes.
C
        CALL AGSETR ('X/MIN.',0.)
        CALL AGSETR ('X/MAX.',1.)
        CALL AGSETR ('Y/MIN.',0.)
        CALL AGSETR ('Y/MAX.',1.)
C
C Turn on windowing of curves drawn by AUTOGRAPH.
C
        CALL AGSETI ('WINDOW.',1)
C
C Set DASHPACK's "single character flag", so that strings of characters
C will more closely follow the path of the curve along which they are
C written.
C
        CALL DPSETI ('SCF - SINGLE CHARACTER FLAG',1)
C
C Tell AUTOGRAPH to use characters of somewhat greater than the default
C width in dash patterns.
C
        CALL AGSETR ('DASH/CHARACTER.',.018)
C
C Define five different character dash patterns using selected symbols
C and draw the curves.
C
        CALL AGSETI ('DASH/SELECTOR.',5)
        CALL AGSETI ('DASH/LENGTH.',12)
C
        CALL DPDPWS ('$$0$$0$$0$$0',
     +               '--+--+--+--+',DPT1)
        CALL DPDPWS ('$$1$$1$$1$$1',
     +               '--+--+--+--+',DPT2)
        CALL DPDPWS ('$$2$$2$$2$$2',
     +               '--+--+--+--+',DPT3)
        CALL DPDPWS ('$$3$$3$$3$$3',
     +               '--+--+--+--+',DPT4)
        CALL DPDPWS ('$$4$$4$$4$$4',
     +               '--+--+--+--+',DPT5)
C
        CALL AGSETC ('DASH/PATTERN/ 1.',DPT1)
        CALL AGSETC ('DASH/PATTERN/ 2.',DPT2)
        CALL AGSETC ('DASH/PATTERN/ 3.',DPT3)
        CALL AGSETC ('DASH/PATTERN/ 4.',DPT4)
        CALL AGSETC ('DASH/PATTERN/ 5.',DPT5)
C
        CALL EZMXY  (XCRA,YCRA,101,5,101,'DASH PATTERNS WITH SYMBOLS')
C
C Redefine the character dash patterns and draw the curves again.
C
        CALL AGSETI ('DASH/SELECTOR.',5)
        CALL AGSETI ('DASH/LENGTH.',12)
C
        CALL DPDPWS ('$dot$0$dot$0',
     +               '-----+-----+',DPT1)
        CALL DPDPWS ('$$$$$6$$$$$6',
     +               '-----+-----+',DPT2)
        CALL DPDPWS ('$$$$$7$$$$$7',
     +               '-----+-----+',DPT3)
        CALL DPDPWS ('$$$$$8$$$$$8',
     +               '-----+-----+',DPT4)
        CALL DPDPWS ('$$$$$9$$$$$9',
     +               '-----+-----+',DPT5)
C
        CALL AGSETC ('DASH/PATTERN/ 1.',DPT1)
        CALL AGSETC ('DASH/PATTERN/ 2.',DPT2)
        CALL AGSETC ('DASH/PATTERN/ 3.',DPT3)
        CALL AGSETC ('DASH/PATTERN/ 4.',DPT4)
        CALL AGSETC ('DASH/PATTERN/ 5.',DPT5)
C
        CALL EZMXY  (XCRA,YCRA,101,5,101,'DASH PATTERNS WITH SYMBOLS')
C
C Close GKS.
C
        CALL GDAWK (IWID)
        CALL GCLWK (IWID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END


      SUBROUTINE DASHDB (IPAT)
        CALL DPSETI ('DPS - DASH PATTERN SELECTOR',-16)
        CALL DPSETI ('DPT - DASH PATTERN (INTEGER)',IPAT)
        RETURN
      END


      SUBROUTINE DASHDC (IPAT,JCRT,JSIZ)
        CHARACTER*(*) IPAT
        CALL DPSETI ('DPS - DASH PATTERN SELECTOR',0)
        CALL DPSETC ('DPT - DASH PATTERN (CHARACTER)',IPAT)
        CALL DPSETR ('WOG - WIDTH OF GAP',CPFX(JCRT))
        CALL DPSETR ('WOS - WIDTH OF SOLID',CPFX(JCRT))
        IF (JSIZ.EQ.0) THEN
          ISIZ=8
        ELSE IF (JSIZ.EQ.1) THEN
          ISIZ=12
        ELSE IF (JSIZ.EQ.2) THEN
          ISIZ=16
        ELSE IF (JSIZ.EQ.3) THEN
          ISIZ=24
        ELSE
          ISIZ=JSIZ
        END IF
        CALL DPSETR ('WOC - WIDTH OF CHARACTER',CPFX(ISIZ))
        RETURN
      END


      SUBROUTINE CURVED (XCRA,YCRA,NCRA)
        DIMENSION XCRA(NCRA),YCRA(NCRA)
        CALL DPCURV (XCRA,YCRA,NCRA)
        RETURN
      END


      SUBROUTINE FRSTD (XCOP,YCOP)
        CALL DPFRST (XCOP,YCOP)
        RETURN
      END


      SUBROUTINE VECTD (XCOP,YCOP)
        CALL DPVECT (XCOP,YCOP)
        RETURN
      END


      SUBROUTINE LASTD
        CALL DPLAST
        RETURN
      END

      SUBROUTINE DLAGS2( UPPER, A1, A2, A3, B1, B2, B3, CSU, SNU, CSV,
     $                   SNV, CSQ, SNQ )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      LOGICAL            UPPER
      DOUBLE PRECISION   A1, A2, A3, B1, B2, B3, CSQ, CSU, CSV, SNQ,
     $                   SNU, SNV
*     ..
*
*  Purpose
*  =======
*
*  DLAGS2 computes 2-by-2 orthogonal matrices U, V and Q, such
*  that if ( UPPER ) then
*
*            U'*A*Q = U'*( A1 A2 )*Q = ( x  0  )
*                        ( 0  A3 )     ( x  x  )
*  and
*            V'*B*Q = V'*( B1 B2 )*Q = ( x  0  )
*                        ( 0  B3 )     ( x  x  )
*
*  or if ( .NOT.UPPER ) then
*
*            U'*A*Q = U'*( A1 0  )*Q = ( x  x  )
*                        ( A2 A3 )     ( 0  x  )
*  and
*            V'*B*Q = V'*( B1 0  )*Q = ( x  x  )
*                        ( B2 B3 )     ( 0  x  )
*
*  The rows of the transformed A and B are parallel, where
*
*    U = (  CSU  SNU ), V = (  CSV SNV ), Q = (  CSQ   SNQ )
*        ( -SNU  CSU )      ( -SNV CSV )      ( -SNQ   CSQ )
*
*  Z' denotes the transpose of Z.
*
*
*  Arguments
*  =========
*
*  UPPER   (input) LOGICAL
*          = .TRUE.: the input matrices A and B are upper triangular.
*          = .FALSE.: the input matrices A and B are lower triangular.
*
*  A1      (input) DOUBLE PRECISION
*  A2      (input) DOUBLE PRECISION
*  A3      (input) DOUBLE PRECISION
*          On entry, A1, A2 and A3 are elements of the input 2-by-2
*          upper (lower) triangular matrix A.
*
*  B1      (input) DOUBLE PRECISION
*  B2      (input) DOUBLE PRECISION
*  B3      (input) DOUBLE PRECISION
*          On entry, B1, B2 and B3 are elements of the input 2-by-2
*          upper (lower) triangular matrix B.
*
*  CSU     (output) DOUBLE PRECISION
*  SNU     (output) DOUBLE PRECISION
*          The desired orthogonal matrix U.
*
*  CSV     (output) DOUBLE PRECISION
*  SNV     (output) DOUBLE PRECISION
*          The desired orthogonal matrix V.
*
*  CSQ     (output) DOUBLE PRECISION
*  SNQ     (output) DOUBLE PRECISION
*          The desired orthogonal matrix Q.
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO
      PARAMETER          ( ZERO = 0.0D+0 )
*     ..
*     .. Local Scalars ..
      DOUBLE PRECISION   A, AUA11, AUA12, AUA21, AUA22, AVB11, AVB12,
     $                   AVB21, AVB22, B, C, CSL, CSR, D, R, S1, S2,
     $                   SNL, SNR, UA11, UA11R, UA12, UA21, UA22, UA22R,
     $                   VB11, VB11R, VB12, VB21, VB22, VB22R
*     ..
*     .. External Subroutines ..
      EXTERNAL           DLARTG, DLASV2
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS
*     ..
*     .. Executable Statements ..
*
      IF( UPPER ) THEN
*
*        Input matrices A and B are upper triangular matrices
*
*        Form matrix C = A*adj(B) = ( a b )
*                                   ( 0 d )
*
         A = A1*B3
         D = A3*B1
         B = A2*B1 - A1*B2
*
*        The SVD of real 2-by-2 triangular C
*
*         ( CSL -SNL )*( A B )*(  CSR  SNR ) = ( R 0 )
*         ( SNL  CSL ) ( 0 D ) ( -SNR  CSR )   ( 0 T )
*
         CALL DLASV2( A, B, D, S1, S2, SNR, CSR, SNL, CSL )
*
         IF( ABS( CSL ).GE.ABS( SNL ) .OR. ABS( CSR ).GE.ABS( SNR ) )
     $        THEN
*
*           Compute the (1,1) and (1,2) elements of U'*A and V'*B,
*           and (1,2) element of |U|'*|A| and |V|'*|B|.
*
            UA11R = CSL*A1
            UA12 = CSL*A2 + SNL*A3
*
            VB11R = CSR*B1
            VB12 = CSR*B2 + SNR*B3
*
            AUA12 = ABS( CSL )*ABS( A2 ) + ABS( SNL )*ABS( A3 )
            AVB12 = ABS( CSR )*ABS( B2 ) + ABS( SNR )*ABS( B3 )
*
*           zero (1,2) elements of U'*A and V'*B
*
            IF( ( ABS( UA11R )+ABS( UA12 ) ).NE.ZERO ) THEN
               IF( AUA12 / ( ABS( UA11R )+ABS( UA12 ) ).LE.AVB12 /
     $             ( ABS( VB11R )+ABS( VB12 ) ) ) THEN
                  CALL DLARTG( -UA11R, UA12, CSQ, SNQ, R )
               ELSE
                  CALL DLARTG( -VB11R, VB12, CSQ, SNQ, R )
               END IF
            ELSE
               CALL DLARTG( -VB11R, VB12, CSQ, SNQ, R )
            END IF
*
            CSU = CSL
            SNU = -SNL
            CSV = CSR
            SNV = -SNR
*
         ELSE
*
*           Compute the (2,1) and (2,2) elements of U'*A and V'*B,
*           and (2,2) element of |U|'*|A| and |V|'*|B|.
*
            UA21 = -SNL*A1
            UA22 = -SNL*A2 + CSL*A3
*
            VB21 = -SNR*B1
            VB22 = -SNR*B2 + CSR*B3
*
            AUA22 = ABS( SNL )*ABS( A2 ) + ABS( CSL )*ABS( A3 )
            AVB22 = ABS( SNR )*ABS( B2 ) + ABS( CSR )*ABS( B3 )
*
*           zero (2,2) elements of U'*A and V'*B, and then swap.
*
            IF( ( ABS( UA21 )+ABS( UA22 ) ).NE.ZERO ) THEN
               IF( AUA22 / ( ABS( UA21 )+ABS( UA22 ) ).LE.AVB22 /
     $             ( ABS( VB21 )+ABS( VB22 ) ) ) THEN
                  CALL DLARTG( -UA21, UA22, CSQ, SNQ, R )
               ELSE
                  CALL DLARTG( -VB21, VB22, CSQ, SNQ, R )
               END IF
            ELSE
               CALL DLARTG( -VB21, VB22, CSQ, SNQ, R )
            END IF
*
            CSU = SNL
            SNU = CSL
            CSV = SNR
            SNV = CSR
*
         END IF
*
      ELSE
*
*        Input matrices A and B are lower triangular matrices
*
*        Form matrix C = A*adj(B) = ( a 0 )
*                                   ( c d )
*
         A = A1*B3
         D = A3*B1
         C = A2*B3 - A3*B2
*
*        The SVD of real 2-by-2 triangular C
*
*         ( CSL -SNL )*( A 0 )*(  CSR  SNR ) = ( R 0 )
*         ( SNL  CSL ) ( C D ) ( -SNR  CSR )   ( 0 T )
*
         CALL DLASV2( A, C, D, S1, S2, SNR, CSR, SNL, CSL )
*
         IF( ABS( CSR ).GE.ABS( SNR ) .OR. ABS( CSL ).GE.ABS( SNL ) )
     $        THEN
*
*           Compute the (2,1) and (2,2) elements of U'*A and V'*B,
*           and (2,1) element of |U|'*|A| and |V|'*|B|.
*
            UA21 = -SNR*A1 + CSR*A2
            UA22R = CSR*A3
*
            VB21 = -SNL*B1 + CSL*B2
            VB22R = CSL*B3
*
            AUA21 = ABS( SNR )*ABS( A1 ) + ABS( CSR )*ABS( A2 )
            AVB21 = ABS( SNL )*ABS( B1 ) + ABS( CSL )*ABS( B2 )
*
*           zero (2,1) elements of U'*A and V'*B.
*
            IF( ( ABS( UA21 )+ABS( UA22R ) ).NE.ZERO ) THEN
               IF( AUA21 / ( ABS( UA21 )+ABS( UA22R ) ).LE.AVB21 /
     $             ( ABS( VB21 )+ABS( VB22R ) ) ) THEN
                  CALL DLARTG( UA22R, UA21, CSQ, SNQ, R )
               ELSE
                  CALL DLARTG( VB22R, VB21, CSQ, SNQ, R )
               END IF
            ELSE
               CALL DLARTG( VB22R, VB21, CSQ, SNQ, R )
            END IF
*
            CSU = CSR
            SNU = -SNR
            CSV = CSL
            SNV = -SNL
*
         ELSE
*
*           Compute the (1,1) and (1,2) elements of U'*A and V'*B,
*           and (1,1) element of |U|'*|A| and |V|'*|B|.
*
            UA11 = CSR*A1 + SNR*A2
            UA12 = SNR*A3
*
            VB11 = CSL*B1 + SNL*B2
            VB12 = SNL*B3
*
            AUA11 = ABS( CSR )*ABS( A1 ) + ABS( SNR )*ABS( A2 )
            AVB11 = ABS( CSL )*ABS( B1 ) + ABS( SNL )*ABS( B2 )
*
*           zero (1,1) elements of U'*A and V'*B, and then swap.
*
            IF( ( ABS( UA11 )+ABS( UA12 ) ).NE.ZERO ) THEN
               IF( AUA11 / ( ABS( UA11 )+ABS( UA12 ) ).LE.AVB11 /
     $             ( ABS( VB11 )+ABS( VB12 ) ) ) THEN
                  CALL DLARTG( UA12, UA11, CSQ, SNQ, R )
               ELSE
                  CALL DLARTG( VB12, VB11, CSQ, SNQ, R )
               END IF
            ELSE
               CALL DLARTG( VB12, VB11, CSQ, SNQ, R )
            END IF
*
            CSU = SNR
            SNU = CSR
            CSV = SNL
            SNV = CSL
*
         END IF
*
      END IF
*
      RETURN
*
*     End of DLAGS2
*
      END

C
C	$Id: findg.f,v 1.5 2008-07-27 00:59:02 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      PROGRAM FINDG
C
C  PURPOSE             This program reads an input FORTRAN file
C                      from the standard input and prints out
C                      those lines (along with line numbers)
C                      which contain calls to old plotting
C                      entries from the pre-GKS NCAR plot package.
C                      In conversions to GKS, the user should
C                      examine these calls for possible changes.
C                      Many entries will require no change.
C                      For details on needed changes, see the
C                      UserDoc "Converting from pre-GKS NCAR
C                      Graphics to NCAR Graphics Version 3.00."
C
C                      There are two sets of file names which can
C                      be used for searching.  The default set is
C                      the set which is described in the UserDoc
C                      mentioned above.  This is a core set of entries
C                      that will usually catch most any call that
C                      might possibly need conversion.  If a "$ALL"
C                      is encountered in columns 1 through 4 of any
C                      input card, then the defualt set of search
C                      names is replaced with a complete set.  This
C                      complete set constitutes all possible names
C                      which may need conversion.  Detailed descriptions
C                      for conversion procedures do not exist for all
C                      of the entries in the complete set.
C
C                      If the single character $ is read in column 1
C                      of any input line, then a complete
C                      list of the entry points being searched for
C                      is printed, and execution is terminated.
C
C  USAGE               Compile and execute the program using a FORTRAN
C                      code as input from the standard input.
C
C  ENTRY POINTS        FINDG
C
C  I/O                 Reads from standard input, writes to standard
C                      output.
C
C  LANGUAGE            FORTRAN 77
C
C  HISTORY             Originally written in March, 1984.
C
C  NOTE                All names are converted to uppercase.
C
C
      PARAMETER ( NUM=71 , NUMA=468 )
      COMMON /SUBNMS/SUBNAM,ALLNAM
      CHARACTER*10 SUBNAM(NUM),ALLNAM(NUMA)
      CHARACTER*10 SRCNMS(NUMA)
      CHARACTER*80  STRING
      CHARACTER*66  LINE
      LOGICAL CALLS, NOTFND
      INTEGER COLPOS, CHARS
C
C  Do a call forcing a BLOCKDATA to be loaded from a binary library.
C
      CALL FNGBKD
C
C  Initialize variables.
C
      LCOUNT = 0
      CALLS = .FALSE.
      NOTFND = .TRUE.
      DO 50 I=1,NUMA
        SRCNMS(I) = SUBNAM(I)
   50 CONTINUE
      NUMF = NUM
C
C  Main loop for reading lines.
C
 100  LCOUNT = LCOUNT + 1
      DO 110 I = 1,80
            STRING(I:I) = ' '
 110  CONTINUE
      READ(5,1001,ERR=903,END=902) STRING
C
C  Check for '$' in column 1.  If there is a $ in column 1,
C  then check for a "$ALL".  If $ALL, then reset search names;
C  otherwise print search names and stop.
C
      IF (STRING(1:1).EQ.'$') THEN
        IF (STRING(2:2).EQ.'A' .OR. STRING(2:2).EQ.'a') THEN
          WRITE(6,1002)
          NUMF = NUMA
          DO 120 I = 1,NUMF
            SRCNMS(I) = ALLNAM(I)
  120     CONTINUE
        ELSE
          GO TO 905
        ENDIF
      ENDIF
C
C  Check for comment line.
C
      IF (STRING(1:1).EQ.'C' .OR. STRING(1:1).EQ.'c') GOTO 100
      DO 200 I = 1,72
 200  IF (STRING(I:I) .NE. ' ') GOTO 210
      GOTO 100
 210  CONTINUE
C
C  Compress line by removing all blank characters.
C
      DO 240 I = 1,66
 240  LINE(I:I) = ' '
      NEXTCH = 0
      DO 250 I = 1,72
      IF (STRING(I:I) .NE. ' ') THEN
        NEXTCH = NEXTCH + 1
        LINE(NEXTCH:NEXTCH) = STRING(I:I)
      ENDIF
 250  CONTINUE
      LASTCH = NEXTCH
C
C  Is this a continuation line for a statement having a subroutine
C  call in it?
C
      IF (CALLS) THEN
        COLPOS = 2
        GOTO 410
      ENDIF
C
C  Are there any subroutine calls on this line?
C
      DO 300 J = 1,66
      CALL LW2UP(LINE(J:J+3))
      IF (LINE(J:J+3).EQ.'CALL') GOTO 400
 300  CONTINUE
C
C  No calls, read another line.
C
      GOTO 100
C
C  Current line has a CALL.
C
 400  COLPOS = J + 4
 410  IF (COLPOS .GE. LASTCH) THEN
        CALLS = .TRUE.
        GOTO 100
      ENDIF
C
C  Find the last column position of the name of the
C  subroutine being called.
C
      DO 490 I = COLPOS,LASTCH
      IF (LINE(I:I) .EQ. '(') THEN
        LASTSU = I - 1
        GOTO 495
      ENDIF
 490  CONTINUE
      LASTSU = LASTCH
 495  CHARS = LASTSU + 1 - COLPOS
C
C  Is the called subroutine a graphics subroutine?
C
      DO 500 I = 1,NUMF
C
C  Convert to upper case.
C
      CALL LW2UP(LINE(COLPOS:LASTSU))
C
C  Check for a match.
C
      IF ( LINE(COLPOS:LASTSU).EQ.SRCNMS(I)(1:CHARS)) THEN
         NOTFND = .FALSE.
         WRITE(6,1003) LCOUNT,STRING
         GOTO 600
      ENDIF
 500  CONTINUE
 600  CALLS = .FALSE.
      GOTO 100
C
 902  WRITE(6,'('' END OF FILE '')')
      IF (NOTFND) THEN
        WRITE(6,'('' NO GRAPHICS SUBROUTINES FOUND '')')
      ENDIF
      ICOUNT = LCOUNT - 1
      WRITE(6,1004)ICOUNT
      STOP
C
 903  WRITE(6,'('' ***ERROR IN READ*** '')')
      STOP
C
 905  WRITE(6,1005) (SRCNMS(I),I=1,NUMF)
      STOP
C
1001  FORMAT(A80)
1002  FORMAT(' FINDG -- FULL SET OF SEARCH NAMES SELECTED'/)
1003  FORMAT(' LINE ',I4,':',A66/)
1004  FORMAT(' TOTAL NUMBER LINES READ : ',I4)
1005  FORMAT(' SEARCHING FOR :'//,(6A10))
C
      END

C
C $Id: basic03f.f,v 1.10 1995-06-20 15:19:52 stautler Exp $
C
C***********************************************************************
C                                                                      *
C                            Copyright (C)  1995                       *
C                 University Corporation for Atmospheric Research      *
C                            All Rights Reserved                       *
C                                                                      *
C***********************************************************************
C
C      File:            basic03f.f
C
C      Author:          Tim Scheitlin (converted by Ed Stautler)
C                       National Center for Atmospheric Research
C                       PO 3000, Boulder, Colorado
C
C      Date:            Mon Mar 20 10:43:42 MST 1995
C
C      Description:     This example demonstrates how to:
C                       1. Create a scalar field data object and assign
C                          it to a plot.
C                       2. Set resources using a resource file.
C                       3. Set resources during object creation.
C                       4. Set resources after object creation.
C
      program basic03f
      implicit none

      external NhlFAppClass
      external NhlFNcgmWorkstationClass
      external NhlFCairoWindowWorkstationClass
      external NhlFContourPlotClass
      external NhlFScalarFieldClass

      integer appid1,appid2,wks,wks2,con1,con2,con3,field1,rlist,ierr

      integer data1(5,5) 
      data data1 / 3,4,4,5,5,
     1      2,3,5,5,4,
     2      2,4,5,4,4,
     3      3,4,4,4,3,
     4      3,3,3,3,3 /

      integer dims(2) 
      data dims / 5, 5 /
C
C Initialize the graphics libraries and create a resource list that
C is normally used to assign name/value pairs within objects.  Then
C clear (empty) this list, and create an application object.  This
C object manages multiple resource databases used by separate objects.
C
      call NhlFInitialize
      call NhlFRLCreate(rlist,'SETRL')

      call NhlFRLClear(rlist)
      call NhlFCreate(appid1,"appid1",NhlFAppClass,0,
     1      rlist,ierr)
C
C ###########
C # FRAME 1 #
C ###########
C This frame demonstrates how to create and assign data to a contour
C plot.
C

C
C Create an X workstation.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetstring(rlist,'wkPause','True',ierr)
      call NhlFCreate(wks,"wks",
     +        NhlFCairoWindowWorkstationClass,0,rlist,ierr)
C
C Create a scalar field object that will be used as a data set for a 
C contour object.  The sfDataArray resource is used to assign a data
C array to a scalar field data object.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetMDIntegerArray(rlist,"sfDataArray",data1,2,
     1      dims,ierr)
      call NhlFCreate(field1,"field1",NhlFScalarFieldClass,0,
     1      rlist,ierr)
C
C Create a contour plot object and assign the data using the
C cnScalarFieldData resource.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetInteger(rlist,"cnScalarFieldData",field1,ierr)
      call NhlFCreate(con1,"con1",NhlFContourPlotClass,wks,
     1      rlist,ierr)
C
C Draw the plot. 
C
      call NhlFDraw(con1,ierr)
C
C Update and clear the workstation.
C
      call NhlFFrame(wks,ierr)
C
C ###########
C # FRAME 2 #
C ###########
C This frame demonstrates how to set resources using a resource file.
C
C Resources are read from a resource file called basic03.res because
C the first argument in the create call is "basic03". This resource file
C is only read at the time an application object is created.
C The resource file contains resource assignments that control the
C characteristics of a plot.
C
      call NhlFRLClear(rlist)
      call NhlFCreate(appid2,"basic03",NhlFAppClass,0,
     1      rlist,ierr)
C
C Create another workstation window and make it a child of the
C new application object by using the appid2 variable as the argument
C for the parent id.  By making this a child of the application
C object, the resources that are set in the basic03.res resource
C file will apply to this object and its children.
C
      call NhlFRLClear(rlist)
      call NhlFCreate(wks2,"wks2",NhlFCairoWindowWorkstationClass,
     1      appid2,rlist,ierr)
C
C Create another contour plot object and assign the data.
C Notice that the parent id is wks2, making the contour object
C a child of the new workstation.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetInteger(rlist,"cnScalarFieldData",field1,ierr)
      call NhlFCreate(con2,"con2",NhlFContourPlotClass,wks2,
     1      rlist,ierr)
C
C The contour object is drawn with filled contours because there is
C a resource in basic03.res that specifies that contour fill is on.
C
      call NhlFDraw(con2,ierr)
C
C Updates and clear the workstation.
C
      call NhlFFrame(wks2,ierr)
C
C ###########
C # FRAME 3 #
C ###########
C This frame demonstrates how resources can be set when an object is
C created.  
C
C A variable length list of resource name/value pairs specifies
C a resource and its value.  In this example contour line labels are
C turned off by setting the "cnLineLabelsOn" resource to "False".
C
      call NhlFRLClear(rlist)
      call NhlFRLSetInteger(rlist,"cnScalarFieldData",field1,ierr)
      call NhlFRLSetString(rlist,"cnLineLabelsOn","False",ierr)
      call NhlFCreate(con3,"con3",NhlFContourPlotClass,wks2,
     1      rlist,ierr)
C
C Draw the contour object.
C
      call NhlFDraw (con3,ierr)
C
C Update and clear the workstation.
C
      call NhlFFrame(wks2,ierr)
C
C ###########
C # FRAME 4 #
C ###########
C This frame demonstrates how to use the setvalues expression to set 
C resources for an object that has already been created.
C
C The setvalues expression is used to assign values to the resources
C of a object whose id is given as the first argument in the expression.
C In this example, that argument is "con3."
C
C Any resource that is valid for the con3 object can be set in the
C following expression.  In this example, setting "cnFillOn" to
C "False" turns contour fill off.  By default, cnFillOn is "False",
C but since it is set to "True" in the resource file, we can override
C that value by using the setvalues expression.  
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,"cnFillOn","False",ierr)
      call NhlFSetValues(con3,rlist,ierr)
C
C Draw the contour object.
C
      call NhlFDraw (con3,ierr)
C
C Update and clear the workstation
C
      call NhlFFrame(wks2,ierr)
C
C Clean up (deleting the parent object recursively deletes all of its 
C children).
C
      call NhlFDestroy(wks,ierr)
      call NhlFDestroy(appid1,ierr)
      call NhlFDestroy(appid2,ierr)

      call NhlFClose

      stop
      end

C
C $Id: ftitle.f,v 1.6 2008-07-27 00:17:26 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE FTITLE (MTST)
C
C The routine FTITLE reads from a "card input unit" groups of cards,
C each of which describes a single title frame that is to be displayed
C for a specified number of seconds using characters of a specified
C size.  FTITLE does the call to STITLE which is required to create the
C desired frames.
C
C FTITLE limits the number of lines on a given frame to "MCDS" (by
C default, 120).  If more lines than this are desired, reset the value
C in the following PARAMETER statement:
C
        PARAMETER (MCDS=120)
        CHARACTER*100 CRDS(MCDS)
C
C The common block SLCOMN holds all of the internal parameters of
C the package STITLE except for color-table parameters.
C
        COMMON /SLCOMN/ GPSZ,IBGC,IBGF,ICOP,IDOT,IFGC,IFGF,IJMP,IMAP,
     +                  INCU,IWLU,IWRK,IWWI,IXND,IXST,OORV,PCSZ,RNFS,
     +                  RVPB,RVPL,RVPR,RVPT,TFIN,TFOU,TGP1,TGP2,TGP3
        SAVE   /SLCOMN/
C
C Check for an uncleared prior error.
C
        IF (ICFELL('FTITLE - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C Set TGPN, which is the size of the gap preceding the next title (TGP1
C preceding the first title), and TGPF, which is the size of the final
C gap (zero so that, if no titles are found, we get no gap at all).
C
        TGPN=TGP1
        TGPF=0.
C
C Read up the first card of the next batch (done if end of file or zero
C card count are seen, error if there are too many title lines).
C
  101   NCDS=0
C
        READ (INCU,'(I5,2F5.1)',END=103,ERR=901) NCDS,TIME,SIZE
C
        IF (NCDS.LE.0) GO TO 103
C
        IF (NCDS.GT.MCDS) GO TO 902
C
C Compute the vertical size of a line and of the gap between lines and
C the sum of those.
C
        ISIZ=INT(SIZE*PCSZ)
        IGAP=INT(SIZE*GPSZ)
C
        ISUM=ISIZ+IGAP
C
C Set the X/Y coordinates of the first line.
C
        IXPS=64+448*ICOP
        IYPS=512+((NCDS-1)*ISUM)/2
C
C Set up the CRDS array for input to STITLE.
C
        DO 102 I=1,NCDS
          WRITE (CRDS(I)(1:20),'(3I5,F5.1)') IXPS,IYPS,ICOP,SIZE
          READ (INCU,'(A80)',ERR=902,END=903) CRDS(I)(21:100)
          IYPS=IYPS-ISUM
  102   CONTINUE
C
C Output a gap before calling STITLE.
C
        IF (TGPN.GT.0.) THEN
          CALL SLOGAP (TGPN,MTST)
          IF (ICFELL('FTITLE',2).NE.0) RETURN
        END IF
C
C Call STITLE to actually produce the desired frames.
C
        CALL STITLE (CRDS,NCDS,512,512,0.,TIME,0.,MTST)
        IF (ICFELL('FTITLE',3).NE.0) RETURN
C
C Reset TGPN and TGPF to the appropriate values for the gaps preceding
C the next label and following the last label.
C
        TGPN=TGP2
        TGPF=TGP2+TGP3
C
C Go back to read the next batch of cards.
C
        GO TO 101
C
C End of input detected.  Output a final gap.
C
  103   IF (TGPF.GT.0.) THEN
          CALL SLOGAP (TGPF,MTST)
          IF (ICFELL('FTITLE',4).NE.0) RETURN
        END IF
C
C Normal return.
C
        RETURN
C
C Error exits.
C
  901   CALL SETER ('FTITLE - READ ERROR ON CARD INPUT UNIT',5,1)
        RETURN
C
  902   CALL SETER ('FTITLE - TOO MANY INPUT CARDS IN GROUP',6,1)
        RETURN
C
  903   CALL SETER ('FTITLE - PREMATURE EOF ON CARD INPUT UNIT',7,1)
        RETURN
C
      END

C
C $Id: set.f,v 1.8 2008-07-27 00:17:25 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE SET (VL,VR,VB,VT,WL,WR,WB,WT,LF)
C
C SET allows the user to change the current values of the parameters
C defining the mapping from the user system to the fractional system
C (in GKS terminology, the mapping from world coordinates to normalized
C device coordinates).
C
C VL, VR, VB, and VT define the viewport (in the fractional system), WL,
C WR, WB, and WT the window (in the user system), and LF the nature of
C the mapping, according to the following table:
C
C    1  -  x linear, y linear
C    2  -  x linear, y logarithmic
C    3  -  x logarithmic, y linear
C    4  -  x logarithmic, y logarithmic
C
C Declare the common block containing the linear-log and mirror-imaging
C flags.
C
      COMMON /IUTLCM/ LL,MI,MX,MY,IU(96)
      SAVE /IUTLCM/
C
C Check for an uncleared prior error.
C
      IF (ICFELL('SET - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C Set the GKS viewport for transformation 1.
C
      CALL GSVP (1,VL,VR,VB,VT)
C
C Set the utility state variable controlling linear-log mapping.
C
      LL=MAX(1,MIN(4,LF))
C
C Set the GKS window for transformation 1.
C
      IF (WL.LT.WR) THEN
        MI=1
        QL=WL
        QR=WR
      ELSE
        MI=3
        QL=WR
        QR=WL
      END IF
C
      IF (WB.LT.WT) THEN
        QB=WB
        QT=WT
      ELSE
        MI=MI+1
        QB=WT
        QT=WB
      END IF
C
      IF (LL.EQ.1) THEN
        CALL GSWN (1,QL,QR,QB,QT)
      ELSE IF (LL.EQ.2) THEN
        CALL GSWN (1,QL,QR,ALOG10(QB),ALOG10(QT))
      ELSE IF (LL.EQ.3) THEN
        CALL GSWN (1,ALOG10(QL),ALOG10(QR),QB,QT)
      ELSE
        CALL GSWN (1,ALOG10(QL),ALOG10(QR),ALOG10(QB),ALOG10(QT))
      END IF
C
C Select transformation 1 as the current one.
C
      CALL GSELNT (1)
C
      RETURN
C
      END

      PROGRAM CMPEL
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Open GKS and turn off clipping.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
      CALL GSCLIP (0)
C
C Call the routine which does all the work
C
      CALL TCMPEL
C
C Close GKS, and end program
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS

      STOP
      END

      SUBROUTINE TCMPEL
C
C Satellite-view.
C
C Do this plot in white with Softfill over the water and no lat/lon
C lines
C
      CALL MAPROJ ('SV',40.,10.,0.)
      CALL MAPSTR ('SA - SATELLITE DISTANCE',5.)
      CALL MAPSTC ('OU - OUTLINE DATASET SELECTOR','PO')
      CALL MAPSTI ('PE - PERIMETER FLAG', 0)
      CALL MAPSTI ('EL - ELLIPTICAL-PERIMETER SELECTOR', 1)
      CALL MAPINT
      CALL MAPLBL
      CALL MAPLOT
      CALL FRAME

      RETURN
      END

      subroutine caxpy(n,ca,cx,incx,cy,incy)
c
c     constant times a vector plus a vector.
c     jack dongarra, linpack, 3/11/78.
c     modified 12/3/93, array(1) declarations changed to array(*)
c
      complex cx(*),cy(*),ca
      integer i,incx,incy,ix,iy,n
c
      if(n.le.0)return
      if (abs(real(ca)) + abs(aimag(ca)) .eq. 0.0 ) return
      if(incx.eq.1.and.incy.eq.1)go to 20
c
c        code for unequal increments or equal increments
c          not equal to 1
c
      ix = 1
      iy = 1
      if(incx.lt.0)ix = (-n+1)*incx + 1
      if(incy.lt.0)iy = (-n+1)*incy + 1
      do 10 i = 1,n
        cy(iy) = cy(iy) + ca*cx(ix)
        ix = ix + incx
        iy = iy + incy
   10 continue
      return
c
c        code for both increments equal to 1
c
   20 do 30 i = 1,n
        cy(i) = cy(i) + ca*cx(i)
   30 continue
      return
      end

C
C	$Id: msbsf1.f,v 1.5 2008-07-27 00:17:30 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MSBSF1 (M,N,XMIN,XMAX,YMIN,YMAX,Z,IZ,ZP,TEMP,SIGMA)
C
      DIMENSION Z(IZ,N),ZP(M,N,3),TEMP(1)
C
C ---------------------------------------------------------------------
C Note:  This routine comes from a proprietary package called FITPACK.
C It is used in the NCAR graphics package by permission of the author,
C Alan Cline.
C ---------------------------------------------------------------------
C
C                                            CODED BY ALAN KAYLOR CLINE
C                                         FROM FITPACK -- JUNE 22, 1986
C                                   A CURVE AND SURFACE FITTING PACKAGE
C                                 A PRODUCT OF PLEASANT VALLEY SOFTWARE
C                             8603 ALTUS COVE, AUSTIN, TEXAS 78759, USA
C
C ---------------------------------------------------------------------
C
C THIS SUBROUTINE DETERMINES THE PARAMETERS NECESSARY TO
C COMPUTE AN INTERPOLATORY SURFACE PASSING THROUGH A RECT-
C ANGULAR GRID OF FUNCTIONAL VALUES. THE X AND Y VALUES ARE
C ASSUMED EQUALLY SPACED IN THE GRID. THE SURFACE DETERMINED
C CAN BE REPRESENTED AS THE TENSOR PRODUCT OF SPLINES UNDER
C TENSION. FOR ACTUAL INTERPOLATION AT A GRID OF POINTS
C EQUALLY SPACED IN BOTH X AND Y COORDINATES IT IS NECESSARY
C TO CALL SUBROUTINE MSBSF2.
C
C ON INPUT--
C
C   M IS THE NUMBER OF GRID LINES IN THE X-DIRECTION, I. E.
C   LINES PARALLEL TO THE Y-AXIS (M .GE. 2).
C
C   N IS THE NUMBER OF GRID LINES IN THE Y-DIRECTION, I. E.
C   LINES PARALLEL TO THE X-AXIS (N .GE. 2).
C
C   XMIN AND XMAX ARE THE LOWER AND UPPER LIMITS,
C   RESPECTIVELY, OF THE GRID IN THE X-DIRECTION. XMAX
C   SHOULD BE GREATER THAN XMIN.
C
C   YMIN AND YMAX ARE THE LOWER AND UPPER LIMITS,
C   RESPECTIVELY, OF THE GRID IN THE Y-DIRECTION. YMAX
C   SHOULD BE GREATER THAN YMIN.
C
C   Z IS AN ARRAY OF THE M * N FUNCTIONAL VALUES AT THE GRID
C   POINTS, I. E. Z(I,J) CONTAINS THE FUNCTIONAL VALUE AT
C   (X(I),Y(J)) FOR I = 1,...,M AND J = 1,...,N, WHERE X(I)
C   REPRESENTS THE I-TH EQUISPACED X VALUE, AND Y(J)
C   REPRESENTS THE J-TH EQUISPACED Y VALUE.
C
C   IZ IS THE ROW DIMENSION OF THE MATRIX Z USED IN THE
C   CALLING PROGRAM (IZ .GE. M).
C
C   ZP IS AN ARRAY OF AT LEAST 3*M*N LOCATIONS.
C
C   TEMP IS AN ARRAY OF AT LEAST N+N+M LOCATIONS WHICH IS
C   USED FOR SCRATCH STORAGE.
C
C   SIGMA CONTAINS THE TENSION FACTOR. THIS VALUE INDICATES
C   THE CURVINESS DESIRED. IF ABS(SIGMA) IS NEARLY ZERO
C   (E. G. .001) THE RESULTING SURFACE IS APPROXIMATELY THE
C   TENSOR PRODUCT OF CUBIC SPLINES. IF ABS(SIGMA) IS LARGE
C   (E. G. 50.) THE RESULTING SURFACE IS APPROXIMATELY
C   BI-LINEAR. IF SIGMA EQUALS ZERO TENSOR PRODUCTS OF
C   CUBIC SPLINES RESULT. A STANDARD VALUE FOR SIGMA IS
C   APPROXIMATELY 1. IN ABSOLUTE VALUE.
C
C ON OUTPUT--
C
C   ZP CONTAINS THE VALUES OF THE XX-, YY-, AND XXYY-PARTIAL
C   DERIVATIVES OF THE SURFACE AT THE GIVEN NODES.
C
C   M, N, XMIN, XMAX, YMIN, YMAX, Z, IZ, AND SIGMA ARE
C   UNALTERED.
C
C THIS SUBROUTINE REFERENCES PACKAGE MODULES MSCEEZ, MSTRMS,
C AND MSSHCH.
C
C-----------------------------------------------------------
C
      MM1 = M-1
      MP1 = M+1
      NM1 = N-1
      NP1 = N+1
      NPM = N+M
C
C DENORMALIZE TENSION FACTOR IN Y-DIRECTION
C
      SIGMAY = ABS(SIGMA)*REAL(N-1)/(YMAX-YMIN)
C
C OBTAIN Y-PARTIAL DERIVATIVES ALONG Y = YMIN
C
      DELY1 = (YMAX-YMIN)/REAL(N-1)
      DELY2 = DELY1+DELY1
      CALL MSCEEZ (DELY1,DELY2,SIGMAY,C1,C2,C3,N)
      DO 1 I = 1,M
    1   ZP(I,1,1) = C1*Z(I,1)+C2*Z(I,2)
      IF (N .EQ. 2) GO TO 3
      DO 2 I = 1,M
    2   ZP(I,1,1) = ZP(I,1,1)+C3*Z(I,3)
C
C OBTAIN Y-PARTIAL DERIVATIVES ALONG Y = YMAX
C
    3 C1 = -C1
      C2 = -C2
      IF (N .GT. 2) C3 = -C3
      DO 4 I = 1,M
        NPI = N+I
    4   TEMP(NPI) = C1*Z(I,N)+C2*Z(I,NM1)
      IF (N .EQ. 2) GO TO 6
      DO 5 I = 1,M
        NPI = N+I
    5   TEMP(NPI) = TEMP(NPI)+C3*Z(I,N-2)
C
C DENORMALIZE TENSION FACTOR IN X-DIRECTION
C
    6 SIGMAX = ABS(SIGMA)*REAL(M-1)/(XMAX-XMIN)
C
C OBTAIN X-PARTIAL DERIVATIVES ALONG X = XMIN
C
      DELX1 = (XMAX-XMIN)/REAL(M-1)
      DELX2 = DELX1+DELX1
      CALL MSCEEZ (DELX1,DELX2,SIGMAX,C1,C2,C3,M)
      DO 7 J = 1,N
    7   ZP(1,J,2) = C1*Z(1,J)+C2*Z(2,J)
      IF (M .EQ. 2) GO TO 9
      DO 8 J = 1,N
    8   ZP(1,J,2) = ZP(1,J,2)+C3*Z(3,J)
C
C OBTAIN X-Y-PARTIAL DERIVATIVE AT (XMIN,YMIN)
C
    9 ZP(1,1,3) = C1*ZP(1,1,1)+C2*ZP(2,1,1)
      IF (M .GT. 2) ZP(1,1,3) = ZP(1,1,3)+C3*ZP(3,1,1)
C
C OBTAIN X-Y-PARTIAL DERIVATIVE AT (XMIN,YMAX)
C
      ZXY1NS = C1*TEMP(N+1)+C2*TEMP(N+2)
      IF (M .GT. 2) ZXY1NS = ZXY1NS+C3*TEMP(N+3)
C
C OBTAIN X-PARTIAL DERIVATIVE ALONG X = XMAX
C
      C1 = -C1
      C2 = -C2
      IF (M .GT. 2) C3 = -C3
      DO 10 J = 1,N
        NPMPJ = NPM+J
   10   TEMP(NPMPJ) = C1*Z(M,J)+C2*Z(MM1,J)
      IF (M .EQ. 2) GO TO 12
      DO 11 J = 1,N
        NPMPJ = NPM+J
   11   TEMP(NPMPJ) = TEMP(NPMPJ)+C3*Z(M-2,J)
C
C OBTAIN X-Y-PARTIAL DERIVATIVE AT (XMAX,YMIN)
C
   12 ZP(M,1,3) = C1*ZP(M,1,1)+C2*ZP(MM1,1,1)
      IF (M .GT. 2) ZP(M,1,3) = ZP(M,1,3)+C3*ZP(M-2,1,1)
C
C OBTAIN X-Y-PARTIAL DERIVATIVE AT (XMAX,YMAX)
C
      ZXYMNS = C1*TEMP(NPM)+C2*TEMP(NPM-1)
      IF (M .GT. 2) ZXYMNS = ZXYMNS+C3*TEMP(NPM-2)
C
C SET UP RIGHT HAND SIDES AND TRIDIAGONAL SYSTEM FOR Y-GRID
C PERFORM FORWARD ELIMINATION
C
      DEL1 = DELY1
      DELI = 1./DEL1
      DO 13 I = 1,M
   13   ZP(I,2,1) = DELI*(Z(I,2)-Z(I,1))
      ZP(1,2,3) = DELI*(ZP(1,2,2)-ZP(1,1,2))
      ZP(M,2,3) = DELI*(TEMP(NPM+2)-TEMP(NPM+1))
      CALL MSTRMS (DIAG1,SDIAG1,SIGMAY,DEL1)
      DIAGI = 1./DIAG1
      DO 14 I = 1,M
   14   ZP(I,1,1) = DIAGI*(ZP(I,2,1)-ZP(I,1,1))
      ZP(1,1,3) = DIAGI*(ZP(1,2,3)-ZP(1,1,3))
      ZP(M,1,3) = DIAGI*(ZP(M,2,3)-ZP(M,1,3))
      TEMP(1) = DIAGI*SDIAG1
      IF (N .EQ. 2) GO TO 18
      DO 17 J = 2,NM1
        JM1 = J-1
        JP1 = J+1
        NPMPJ = NPM+J
        DO 15 I = 1,M
   15     ZP(I,JP1,1) = DELI*(Z(I,JP1)-Z(I,J))
        ZP(1,JP1,3) = DELI*(ZP(1,JP1,2)-ZP(1,J,2))
        ZP(M,JP1,3) = DELI*(TEMP(NPMPJ+1)-TEMP(NPMPJ))
        DIAGIN = 1./(DIAG1+DIAG1-SDIAG1*TEMP(JM1))
        DO 16 I = 1,M
   16     ZP(I,J,1) = DIAGIN*(ZP(I,JP1,1)-ZP(I,J,1)-
     *                        SDIAG1*ZP(I,JM1,1))
        ZP(1,J,3) = DIAGIN*(ZP(1,JP1,3)-ZP(1,J,3)-
     *                      SDIAG1*ZP(1,JM1,3))
        ZP(M,J,3) = DIAGIN*(ZP(M,JP1,3)-ZP(M,J,3)-
     *                      SDIAG1*ZP(M,JM1,3))
   17   TEMP(J) = DIAGIN*SDIAG1
   18 DIAGIN = 1./(DIAG1-SDIAG1*TEMP(NM1))
      DO 19 I = 1,M
        NPI = N+I
   19   ZP(I,N,1) = DIAGIN*(TEMP(NPI)-ZP(I,N,1)-
     *                      SDIAG1*ZP(I,NM1,1))
      ZP(1,N,3) = DIAGIN*(ZXY1NS-ZP(1,N,3)-
     *                    SDIAG1*ZP(1,NM1,3))
      TEMP(N) = DIAGIN*(ZXYMNS-ZP(M,N,3)-
     *                  SDIAG1*ZP(M,NM1,3))
C
C PERFORM BACK SUBSTITUTION
C
      DO 21 J = 2,N
        JBAK = NP1-J
        JBAKP1 = JBAK+1
        T = TEMP(JBAK)
        DO 20 I = 1,M
   20     ZP(I,JBAK,1) = ZP(I,JBAK,1)-T*ZP(I,JBAKP1,1)
        ZP(1,JBAK,3) = ZP(1,JBAK,3)-T*ZP(1,JBAKP1,3)
   21   TEMP(JBAK) = ZP(M,JBAK,3)-T*TEMP(JBAKP1)
C
C SET UP RIGHT HAND SIDES AND TRIDIAGONAL SYSTEM FOR X-GRID
C PERFORM FORWARD ELIMINATION
C
      DEL1 = DELX1
      DELI = 1./DEL1
      DO 22 J = 1,N
        ZP(2,J,2) = DELI*(Z(2,J)-Z(1,J))
   22   ZP(2,J,3) = DELI*(ZP(2,J,1)-ZP(1,J,1))
      CALL MSTRMS (DIAG1,SDIAG1,SIGMAX,DEL1)
      DIAGI = 1./DIAG1
      DO 23 J = 1,N
        ZP(1,J,2) = DIAGI*(ZP(2,J,2)-ZP(1,J,2))
   23   ZP(1,J,3) = DIAGI*(ZP(2,J,3)-ZP(1,J,3))
      TEMP(N+1) = DIAGI*SDIAG1
      IF (M  .EQ. 2) GO TO 27
      DO 26 I = 2,MM1
        IM1 = I-1
        IP1 = I+1
        NPI = N+I
        DO 24 J = 1,N
          ZP(IP1,J,2) = DELI*(Z(IP1,J)-Z(I,J))
   24     ZP(IP1,J,3) = DELI*(ZP(IP1,J,1)-ZP(I,J,1))
        DIAGIN = 1./(DIAG1+DIAG1-SDIAG1*TEMP(NPI-1))
        DO 25 J = 1,N
          ZP(I,J,2) = DIAGIN*(ZP(IP1,J,2)-ZP(I,J,2)-
     *                        SDIAG1*ZP(IM1,J,2))
   25     ZP(I,J,3) = DIAGIN*(ZP(IP1,J,3)-ZP(I,J,3)-
     *                        SDIAG1*ZP(IM1,J,3))
   26   TEMP(NPI) = DIAGIN*SDIAG1
   27 DIAGIN = 1./(DIAG1-SDIAG1*TEMP(NPM-1))
      DO 28 J = 1,N
        NPMPJ = NPM+J
        ZP(M,J,2) = DIAGIN*(TEMP(NPMPJ)-ZP(M,J,2)-
     *                      SDIAG1*ZP(MM1,J,2))
   28   ZP(M,J,3) = DIAGIN*(TEMP(J)-ZP(M,J,3)-
     *                      SDIAG1*ZP(MM1,J,3))
C
C PERFORM BACK SUBSTITUTION
C
      DO 29 I = 2,M
        IBAK = MP1-I
        IBAKP1 = IBAK+1
        NPIBAK = N+IBAK
        T = TEMP(NPIBAK)
        DO 29 J = 1,N
          ZP(IBAK,J,2) = ZP(IBAK,J,2)-T*ZP(IBAKP1,J,2)
   29     ZP(IBAK,J,3) = ZP(IBAK,J,3)-T*ZP(IBAKP1,J,3)
      RETURN
C
      END

      SUBROUTINE CPOSVX( FACT, UPLO, N, NRHS, A, LDA, AF, LDAF, EQUED,
     $                   S, B, LDB, X, LDX, RCOND, FERR, BERR, WORK,
     $                   RWORK, INFO )
*
*  -- LAPACK driver routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          EQUED, FACT, UPLO
      INTEGER            INFO, LDA, LDAF, LDB, LDX, N, NRHS
      REAL               RCOND
*     ..
*     .. Array Arguments ..
      REAL               BERR( * ), FERR( * ), RWORK( * ), S( * )
      COMPLEX            A( LDA, * ), AF( LDAF, * ), B( LDB, * ),
     $                   WORK( * ), X( LDX, * )
*     ..
*
*  Purpose
*  =======
*
*  CPOSVX uses the Cholesky factorization A = U**H*U or A = L*L**H to
*  compute the solution to a complex system of linear equations
*     A * X = B,
*  where A is an N-by-N Hermitian positive definite matrix and X and B
*  are N-by-NRHS matrices.
*
*  Error bounds on the solution and a condition estimate are also
*  provided.
*
*  Description
*  ===========
*
*  The following steps are performed:
*
*  1. If FACT = 'E', real scaling factors are computed to equilibrate
*     the system:
*        diag(S) * A * diag(S) * inv(diag(S)) * X = diag(S) * B
*     Whether or not the system will be equilibrated depends on the
*     scaling of the matrix A, but if equilibration is used, A is
*     overwritten by diag(S)*A*diag(S) and B by diag(S)*B.
*
*  2. If FACT = 'N' or 'E', the Cholesky decomposition is used to
*     factor the matrix A (after equilibration if FACT = 'E') as
*        A = U**H* U,  if UPLO = 'U', or
*        A = L * L**H,  if UPLO = 'L',
*     where U is an upper triangular matrix and L is a lower triangular
*     matrix.
*
*  3. If the leading i-by-i principal minor is not positive definite,
*     then the routine returns with INFO = i. Otherwise, the factored
*     form of A is used to estimate the condition number of the matrix
*     A.  If the reciprocal of the condition number is less than machine
*     precision, INFO = N+1 is returned as a warning, but the routine
*     still goes on to solve for X and compute error bounds as
*     described below.
*
*  4. The system of equations is solved for X using the factored form
*     of A.
*
*  5. Iterative refinement is applied to improve the computed solution
*     matrix and calculate error bounds and backward error estimates
*     for it.
*
*  6. If equilibration was used, the matrix X is premultiplied by
*     diag(S) so that it solves the original system before
*     equilibration.
*
*  Arguments
*  =========
*
*  FACT    (input) CHARACTER*1
*          Specifies whether or not the factored form of the matrix A is
*          supplied on entry, and if not, whether the matrix A should be
*          equilibrated before it is factored.
*          = 'F':  On entry, AF contains the factored form of A.
*                  If EQUED = 'Y', the matrix A has been equilibrated
*                  with scaling factors given by S.  A and AF will not
*                  be modified.
*          = 'N':  The matrix A will be copied to AF and factored.
*          = 'E':  The matrix A will be equilibrated if necessary, then
*                  copied to AF and factored.
*
*  UPLO    (input) CHARACTER*1
*          = 'U':  Upper triangle of A is stored;
*          = 'L':  Lower triangle of A is stored.
*
*  N       (input) INTEGER
*          The number of linear equations, i.e., the order of the
*          matrix A.  N >= 0.
*
*  NRHS    (input) INTEGER
*          The number of right hand sides, i.e., the number of columns
*          of the matrices B and X.  NRHS >= 0.
*
*  A       (input/output) COMPLEX array, dimension (LDA,N)
*          On entry, the Hermitian matrix A, except if FACT = 'F' and
*          EQUED = 'Y', then A must contain the equilibrated matrix
*          diag(S)*A*diag(S).  If UPLO = 'U', the leading
*          N-by-N upper triangular part of A contains the upper
*          triangular part of the matrix A, and the strictly lower
*          triangular part of A is not referenced.  If UPLO = 'L', the
*          leading N-by-N lower triangular part of A contains the lower
*          triangular part of the matrix A, and the strictly upper
*          triangular part of A is not referenced.  A is not modified if
*          FACT = 'F' or 'N', or if FACT = 'E' and EQUED = 'N' on exit.
*
*          On exit, if FACT = 'E' and EQUED = 'Y', A is overwritten by
*          diag(S)*A*diag(S).
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(1,N).
*
*  AF      (input or output) COMPLEX array, dimension (LDAF,N)
*          If FACT = 'F', then AF is an input argument and on entry
*          contains the triangular factor U or L from the Cholesky
*          factorization A = U**H*U or A = L*L**H, in the same storage
*          format as A.  If EQUED .ne. 'N', then AF is the factored form
*          of the equilibrated matrix diag(S)*A*diag(S).
*
*          If FACT = 'N', then AF is an output argument and on exit
*          returns the triangular factor U or L from the Cholesky
*          factorization A = U**H*U or A = L*L**H of the original
*          matrix A.
*
*          If FACT = 'E', then AF is an output argument and on exit
*          returns the triangular factor U or L from the Cholesky
*          factorization A = U**H*U or A = L*L**H of the equilibrated
*          matrix A (see the description of A for the form of the
*          equilibrated matrix).
*
*  LDAF    (input) INTEGER
*          The leading dimension of the array AF.  LDAF >= max(1,N).
*
*  EQUED   (input or output) CHARACTER*1
*          Specifies the form of equilibration that was done.
*          = 'N':  No equilibration (always true if FACT = 'N').
*          = 'Y':  Equilibration was done, i.e., A has been replaced by
*                  diag(S) * A * diag(S).
*          EQUED is an input argument if FACT = 'F'; otherwise, it is an
*          output argument.
*
*  S       (input or output) REAL array, dimension (N)
*          The scale factors for A; not accessed if EQUED = 'N'.  S is
*          an input argument if FACT = 'F'; otherwise, S is an output
*          argument.  If FACT = 'F' and EQUED = 'Y', each element of S
*          must be positive.
*
*  B       (input/output) COMPLEX array, dimension (LDB,NRHS)
*          On entry, the N-by-NRHS righthand side matrix B.
*          On exit, if EQUED = 'N', B is not modified; if EQUED = 'Y',
*          B is overwritten by diag(S) * B.
*
*  LDB     (input) INTEGER
*          The leading dimension of the array B.  LDB >= max(1,N).
*
*  X       (output) COMPLEX array, dimension (LDX,NRHS)
*          If INFO = 0 or INFO = N+1, the N-by-NRHS solution matrix X to
*          the original system of equations.  Note that if EQUED = 'Y',
*          A and B are modified on exit, and the solution to the
*          equilibrated system is inv(diag(S))*X.
*
*  LDX     (input) INTEGER
*          The leading dimension of the array X.  LDX >= max(1,N).
*
*  RCOND   (output) REAL
*          The estimate of the reciprocal condition number of the matrix
*          A after equilibration (if done).  If RCOND is less than the
*          machine precision (in particular, if RCOND = 0), the matrix
*          is singular to working precision.  This condition is
*          indicated by a return code of INFO > 0.
*
*  FERR    (output) REAL array, dimension (NRHS)
*          The estimated forward error bound for each solution vector
*          X(j) (the j-th column of the solution matrix X).
*          If XTRUE is the true solution corresponding to X(j), FERR(j)
*          is an estimated upper bound for the magnitude of the largest
*          element in (X(j) - XTRUE) divided by the magnitude of the
*          largest element in X(j).  The estimate is as reliable as
*          the estimate for RCOND, and is almost always a slight
*          overestimate of the true error.
*
*  BERR    (output) REAL array, dimension (NRHS)
*          The componentwise relative backward error of each solution
*          vector X(j) (i.e., the smallest relative change in
*          any element of A or B that makes X(j) an exact solution).
*
*  WORK    (workspace) COMPLEX array, dimension (2*N)
*
*  RWORK   (workspace) REAL array, dimension (N)
*
*  INFO    (output) INTEGER
*          = 0: successful exit
*          < 0: if INFO = -i, the i-th argument had an illegal value
*          > 0: if INFO = i, and i is
*                <= N:  the leading minor of order i of A is
*                       not positive definite, so the factorization
*                       could not be completed, and the solution has not
*                       been computed. RCOND = 0 is returned.
*                = N+1: U is nonsingular, but RCOND is less than machine
*                       precision, meaning that the matrix is singular
*                       to working precision.  Nevertheless, the
*                       solution and error bounds are computed because
*                       there are a number of situations where the
*                       computed solution can be more accurate than the
*                       value of RCOND would suggest.
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ZERO, ONE
      PARAMETER          ( ZERO = 0.0E+0, ONE = 1.0E+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            EQUIL, NOFACT, RCEQU
      INTEGER            I, INFEQU, J
      REAL               AMAX, ANORM, BIGNUM, SCOND, SMAX, SMIN, SMLNUM
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      REAL               CLANHE, SLAMCH
      EXTERNAL           LSAME, CLANHE, SLAMCH
*     ..
*     .. External Subroutines ..
      EXTERNAL           CLACPY, CLAQHE, CPOCON, CPOEQU, CPORFS, CPOTRF,
     $                   CPOTRS, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN
*     ..
*     .. Executable Statements ..
*
      INFO = 0
      NOFACT = LSAME( FACT, 'N' )
      EQUIL = LSAME( FACT, 'E' )
      IF( NOFACT .OR. EQUIL ) THEN
         EQUED = 'N'
         RCEQU = .FALSE.
      ELSE
         RCEQU = LSAME( EQUED, 'Y' )
         SMLNUM = SLAMCH( 'Safe minimum' )
         BIGNUM = ONE / SMLNUM
      END IF
*
*     Test the input parameters.
*
      IF( .NOT.NOFACT .AND. .NOT.EQUIL .AND. .NOT.LSAME( FACT, 'F' ) )
     $     THEN
         INFO = -1
      ELSE IF( .NOT.LSAME( UPLO, 'U' ) .AND. .NOT.LSAME( UPLO, 'L' ) )
     $          THEN
         INFO = -2
      ELSE IF( N.LT.0 ) THEN
         INFO = -3
      ELSE IF( NRHS.LT.0 ) THEN
         INFO = -4
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -6
      ELSE IF( LDAF.LT.MAX( 1, N ) ) THEN
         INFO = -8
      ELSE IF( LSAME( FACT, 'F' ) .AND. .NOT.
     $         ( RCEQU .OR. LSAME( EQUED, 'N' ) ) ) THEN
         INFO = -9
      ELSE
         IF( RCEQU ) THEN
            SMIN = BIGNUM
            SMAX = ZERO
            DO 10 J = 1, N
               SMIN = MIN( SMIN, S( J ) )
               SMAX = MAX( SMAX, S( J ) )
   10       CONTINUE
            IF( SMIN.LE.ZERO ) THEN
               INFO = -10
            ELSE IF( N.GT.0 ) THEN
               SCOND = MAX( SMIN, SMLNUM ) / MIN( SMAX, BIGNUM )
            ELSE
               SCOND = ONE
            END IF
         END IF
         IF( INFO.EQ.0 ) THEN
            IF( LDB.LT.MAX( 1, N ) ) THEN
               INFO = -12
            ELSE IF( LDX.LT.MAX( 1, N ) ) THEN
               INFO = -14
            END IF
         END IF
      END IF
*
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'CPOSVX', -INFO )
         RETURN
      END IF
*
      IF( EQUIL ) THEN
*
*        Compute row and column scalings to equilibrate the matrix A.
*
         CALL CPOEQU( N, A, LDA, S, SCOND, AMAX, INFEQU )
         IF( INFEQU.EQ.0 ) THEN
*
*           Equilibrate the matrix.
*
            CALL CLAQHE( UPLO, N, A, LDA, S, SCOND, AMAX, EQUED )
            RCEQU = LSAME( EQUED, 'Y' )
         END IF
      END IF
*
*     Scale the right hand side.
*
      IF( RCEQU ) THEN
         DO 30 J = 1, NRHS
            DO 20 I = 1, N
               B( I, J ) = S( I )*B( I, J )
   20       CONTINUE
   30    CONTINUE
      END IF
*
      IF( NOFACT .OR. EQUIL ) THEN
*
*        Compute the Cholesky factorization A = U'*U or A = L*L'.
*
         CALL CLACPY( UPLO, N, N, A, LDA, AF, LDAF )
         CALL CPOTRF( UPLO, N, AF, LDAF, INFO )
*
*        Return if INFO is non-zero.
*
         IF( INFO.NE.0 ) THEN
            IF( INFO.GT.0 )
     $         RCOND = ZERO
            RETURN
         END IF
      END IF
*
*     Compute the norm of the matrix A.
*
      ANORM = CLANHE( '1', UPLO, N, A, LDA, RWORK )
*
*     Compute the reciprocal of the condition number of A.
*
      CALL CPOCON( UPLO, N, AF, LDAF, ANORM, RCOND, WORK, RWORK, INFO )
*
*     Set INFO = N+1 if the matrix is singular to working precision.
*
      IF( RCOND.LT.SLAMCH( 'Epsilon' ) )
     $   INFO = N + 1
*
*     Compute the solution matrix X.
*
      CALL CLACPY( 'Full', N, NRHS, B, LDB, X, LDX )
      CALL CPOTRS( UPLO, N, NRHS, AF, LDAF, X, LDX, INFO )
*
*     Use iterative refinement to improve the computed solution and
*     compute error bounds and backward error estimates for it.
*
      CALL CPORFS( UPLO, N, NRHS, A, LDA, AF, LDAF, B, LDB, X, LDX,
     $             FERR, BERR, WORK, RWORK, INFO )
*
*     Transform the solution matrix X to a solution of the original
*     system.
*
      IF( RCEQU ) THEN
         DO 50 J = 1, NRHS
            DO 40 I = 1, N
               X( I, J ) = S( I )*X( I, J )
   40       CONTINUE
   50    CONTINUE
         DO 60 J = 1, NRHS
            FERR( J ) = FERR( J ) / SCOND
   60    CONTINUE
      END IF
*
      RETURN
*
*     End of CPOSVX
*
      END

C
C
C       $Id: interp.f,v 1.1 1994-08-11 23:17:27 boote Exp $
C
C This subprogram is used by subroutines TERP1 and TERP2 in 
C library ncarm.  It is lower-level, i.e. not called by users.
C *************************************************************
      SUBROUTINE INTERP (N,X,F,W,Y,I,INT,TAB,ITAB)
      DIMENSION       X(1)       ,F(1)       ,W(1)       ,TAB(3)
     -                ,ITAB(3)
      SAVE
C
C ARITHMETIC STATEMENT FUNCTION USED TO LOCATE ENTRIES IN F AND W ARRAYS
C
      II(INDEX)=(INDEX-1)*INT+1
C
C PERFORM INTERPOLATION OR EXTRAPOLATION
C
      FLK = X(I+1)-X(I)
      FLP = X(I+1)-Y
      FL0 = Y-X(I)
      I0 = II(I)
      IP = I0+INT
      IF (ITAB(1) .NE. 0) GO TO 101
      GO TO 102
  101 CONTINUE
C
C CALCULATE F(Y)
C
      A = (W(I0)*FLP**3+W(IP)*FL0**3)/(6.*FLK)
      B = (F(IP)/FLK-W(IP)*FLK/6.)*FL0
      C = (F(I0)/FLK-W(I0)*FLK/6.)*FLP
      TAB(1) = A+B+C
  102 CONTINUE
      IF (ITAB(2) .NE. 0) GO TO 103
      GO TO 104
  103 CONTINUE
C
C CALCULATE FIRST DERIVATIVE AT Y
C
      A = (W(IP)*FL0**2-W(I0)*FLP**2)/(2.*FLK)
      B = (F(IP)-F(I0))/FLK
      C = (W(I0)-W(IP))*FLK/6.
      TAB(2) = A+B+C
  104 CONTINUE
      IF (ITAB(3) .NE. 0) GO TO 105
      GO TO 106
  105 CONTINUE
C
C CALCULATE SECOND DERIVATIVE AT Y
C
      TAB(3) = (W(I0)*FLP+W(IP)*FL0)/FLK
  106 CONTINUE
      RETURN
      END

      SUBROUTINE ZSTEGR( JOBZ, RANGE, N, D, E, VL, VU, IL, IU, ABSTOL,
     $                   M, W, Z, LDZ, ISUPPZ, WORK, LWORK, IWORK,
     $                   LIWORK, INFO )
*
*  -- LAPACK computational routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     October 31, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          JOBZ, RANGE
      INTEGER            IL, INFO, IU, LDZ, LIWORK, LWORK, M, N
      DOUBLE PRECISION   ABSTOL, VL, VU
*     ..
*     .. Array Arguments ..
      INTEGER            ISUPPZ( * ), IWORK( * )
      DOUBLE PRECISION   D( * ), E( * ), W( * ), WORK( * )
      COMPLEX*16         Z( LDZ, * )
*     ..
*
*  Purpose
*  =======
*
* ZSTEGR computes selected eigenvalues and, optionally, eigenvectors
* of a real symmetric tridiagonal matrix T.  Eigenvalues and
* eigenvectors can be selected by specifying either a range of values
* or a range of indices for the desired eigenvalues. The eigenvalues
* are computed by the dqds algorithm, while orthogonal eigenvectors are
* computed from various ``good'' L D L^T representations (also known as
* Relatively Robust Representations). Gram-Schmidt orthogonalization is
* avoided as far as possible. More specifically, the various steps of
* the algorithm are as follows. For the i-th unreduced block of T,
*     (a) Compute T - sigma_i = L_i D_i L_i^T, such that L_i D_i L_i^T
*         is a relatively robust representation,
*     (b) Compute the eigenvalues, lambda_j, of L_i D_i L_i^T to high
*         relative accuracy by the dqds algorithm,
*     (c) If there is a cluster of close eigenvalues, "choose" sigma_i
*         close to the cluster, and go to step (a),
*     (d) Given the approximate eigenvalue lambda_j of L_i D_i L_i^T,
*         compute the corresponding eigenvector by forming a
*         rank-revealing twisted factorization.
*  The desired accuracy of the output can be specified by the input
*  parameter ABSTOL.
*
*  For more details, see "A new O(n^2) algorithm for the symmetric
*  tridiagonal eigenvalue/eigenvector problem", by Inderjit Dhillon,
*  Computer Science Division Technical Report No. UCB/CSD-97-971,
*  UC Berkeley, May 1997.
*
*  Note 1 : Currently ZSTEGR is only set up to find ALL the n
*  eigenvalues and eigenvectors of T in O(n^2) time
*  Note 2 : Currently the routine ZSTEIN is called when an appropriate
*  sigma_i cannot be chosen in step (c) above. ZSTEIN invokes modified
*  Gram-Schmidt when eigenvalues are close.
*  Note 3 : ZSTEGR works only on machines which follow ieee-754
*  floating-point standard in their handling of infinities and NaNs.
*  Normal execution of ZSTEGR may create NaNs and infinities and hence
*  may abort due to a floating point exception in environments which
*  do not conform to the ieee standard.
*
*  Arguments
*  =========
*
*  JOBZ    (input) CHARACTER*1
*          = 'N':  Compute eigenvalues only;
*          = 'V':  Compute eigenvalues and eigenvectors.
*
*  RANGE   (input) CHARACTER*1
*          = 'A': all eigenvalues will be found.
*          = 'V': all eigenvalues in the half-open interval (VL,VU]
*                 will be found.
*          = 'I': the IL-th through IU-th eigenvalues will be found.
********** Only RANGE = 'A' is currently supported *********************
*
*  N       (input) INTEGER
*          The order of the matrix.  N >= 0.
*
*  D       (input/output) DOUBLE PRECISION array, dimension (N)
*          On entry, the n diagonal elements of the tridiagonal matrix
*          T. On exit, D is overwritten.
*
*  E       (input/output) DOUBLE PRECISION array, dimension (N)
*          On entry, the (n-1) subdiagonal elements of the tridiagonal
*          matrix T in elements 1 to N-1 of E; E(N) need not be set.
*          On exit, E is overwritten.
*
*  VL      (input) DOUBLE PRECISION
*  VU      (input) DOUBLE PRECISION
*          If RANGE='V', the lower and upper bounds of the interval to
*          be searched for eigenvalues. VL < VU.
*          Not referenced if RANGE = 'A' or 'I'.
*
*  IL      (input) INTEGER
*  IU      (input) INTEGER
*          If RANGE='I', the indices (in ascending order) of the
*          smallest and largest eigenvalues to be returned.
*          1 <= IL <= IU <= N, if N > 0; IL = 1 and IU = 0 if N = 0.
*          Not referenced if RANGE = 'A' or 'V'.
*
*  ABSTOL  (input) DOUBLE PRECISION
*          The absolute error tolerance for the
*          eigenvalues/eigenvectors. IF JOBZ = 'V', the eigenvalues and
*          eigenvectors output have residual norms bounded by ABSTOL,
*          and the dot products between different eigenvectors are
*          bounded by ABSTOL. If ABSTOL is less than N*EPS*|T|, then
*          N*EPS*|T| will be used in its place, where EPS is the
*          machine precision and |T| is the 1-norm of the tridiagonal
*          matrix. The eigenvalues are computed to an accuracy of
*          EPS*|T| irrespective of ABSTOL. If high relative accuracy
*          is important, set ABSTOL to DLAMCH( 'Safe minimum' ).
*          See Barlow and Demmel "Computing Accurate Eigensystems of
*          Scaled Diagonally Dominant Matrices", LAPACK Working Note #7
*          for a discussion of which matrices define their eigenvalues
*          to high relative accuracy.
*
*  M       (output) INTEGER
*          The total number of eigenvalues found.  0 <= M <= N.
*          If RANGE = 'A', M = N, and if RANGE = 'I', M = IU-IL+1.
*
*  W       (output) DOUBLE PRECISION array, dimension (N)
*          The first M elements contain the selected eigenvalues in
*          ascending order.
*
*  Z       (output) COMPLEX*16 array, dimension (LDZ, max(1,M) )
*          If JOBZ = 'V', then if INFO = 0, the first M columns of Z
*          contain the orthonormal eigenvectors of the matrix T
*          corresponding to the selected eigenvalues, with the i-th
*          column of Z holding the eigenvector associated with W(i).
*          If JOBZ = 'N', then Z is not referenced.
*          Note: the user must ensure that at least max(1,M) columns are
*          supplied in the array Z; if RANGE = 'V', the exact value of M
*          is not known in advance and an upper bound must be used.
*
*  LDZ     (input) INTEGER
*          The leading dimension of the array Z.  LDZ >= 1, and if
*          JOBZ = 'V', LDZ >= max(1,N).
*
*  ISUPPZ  (output) INTEGER ARRAY, dimension ( 2*max(1,M) )
*          The support of the eigenvectors in Z, i.e., the indices
*          indicating the nonzero elements in Z. The i-th eigenvector
*          is nonzero only in elements ISUPPZ( 2*i-1 ) through
*          ISUPPZ( 2*i ).
*
*  WORK    (workspace/output) DOUBLE PRECISION array, dimension (LWORK)
*          On exit, if INFO = 0, WORK(1) returns the optimal
*          (and minimal) LWORK.
*
*  LWORK   (input) INTEGER
*          The dimension of the array WORK.  LWORK >= max(1,18*N)
*
*          If LWORK = -1, then a workspace query is assumed; the routine
*          only calculates the optimal size of the WORK array, returns
*          this value as the first entry of the WORK array, and no error
*          message related to LWORK is issued by XERBLA.
*
*  IWORK   (workspace/output) INTEGER array, dimension (LIWORK)
*          On exit, if INFO = 0, IWORK(1) returns the optimal LIWORK.
*
*  LIWORK  (input) INTEGER
*          The dimension of the array IWORK.  LIWORK >= max(1,10*N)
*
*          If LIWORK = -1, then a workspace query is assumed; the
*          routine only calculates the optimal size of the IWORK array,
*          returns this value as the first entry of the IWORK array, and
*          no error message related to LIWORK is issued by XERBLA.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*          > 0:  if INFO = 1, internal error in DLARRE,
*                if INFO = 2, internal error in ZLARRV.
*
*  Further Details
*  ===============
*
*  Based on contributions by
*     Inderjit Dhillon, IBM Almaden, USA
*     Osni Marques, LBNL/NERSC, USA
*     Ken Stanley, Computer Science Division, University of
*       California at Berkeley, USA
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO, ONE
      PARAMETER          ( ZERO = 0.0D0, ONE = 1.0D0 )
      COMPLEX*16         CZERO
      PARAMETER          ( CZERO = ( 0.0D0, 0.0D0 ) )
*     ..
*     .. Local Scalars ..
      LOGICAL            ALLEIG, INDEIG, LQUERY, VALEIG, WANTZ
      INTEGER            I, IBEGIN, IEND, IINDBL, IINDWK, IINFO, IINSPL,
     $                   INDGRS, INDWOF, INDWRK, ITMP, J, JJ, LIWMIN,
     $                   LWMIN, NSPLIT
      DOUBLE PRECISION   BIGNUM, EPS, RMAX, RMIN, SAFMIN, SCALE, SMLNUM,
     $                   THRESH, TMP, TNRM, TOL
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      DOUBLE PRECISION   DLAMCH, DLANST
      EXTERNAL           LSAME, DLAMCH, DLANST
*     ..
*     .. External Subroutines ..
      EXTERNAL           DLARRE, DSCAL, XERBLA, ZLARRV, ZLASET, ZSWAP
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          DBLE, MAX, MIN, SQRT
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      WANTZ = LSAME( JOBZ, 'V' )
      ALLEIG = LSAME( RANGE, 'A' )
      VALEIG = LSAME( RANGE, 'V' )
      INDEIG = LSAME( RANGE, 'I' )
*
      LQUERY = ( ( LWORK.EQ.-1 ) .OR. ( LIWORK.EQ.-1 ) )
      LWMIN = 18*N
      LIWMIN = 10*N
*
      INFO = 0
      IF( .NOT.( WANTZ .OR. LSAME( JOBZ, 'N' ) ) ) THEN
         INFO = -1
      ELSE IF( .NOT.( ALLEIG .OR. VALEIG .OR. INDEIG ) ) THEN
         INFO = -2
*
*     The following two lines need to be removed once the
*     RANGE = 'V' and RANGE = 'I' options are provided.
*
      ELSE IF( VALEIG .OR. INDEIG ) THEN
         INFO = -2
      ELSE IF( N.LT.0 ) THEN
         INFO = -3
      ELSE IF( VALEIG .AND. N.GT.0 .AND. VU.LE.VL ) THEN
         INFO = -7
      ELSE IF( INDEIG .AND. IL.LT.1 ) THEN
         INFO = -8
*     The following change should be made in DSTEVX also, otherwise
*     IL can be specified as N+1 and IU as N.
*     ELSE IF( INDEIG .AND. ( IU.LT.MIN( N, IL ) .OR. IU.GT.N ) ) THEN
      ELSE IF( INDEIG .AND. ( IU.LT.IL .OR. IU.GT.N ) ) THEN
         INFO = -9
      ELSE IF( LDZ.LT.1 .OR. ( WANTZ .AND. LDZ.LT.N ) ) THEN
         INFO = -14
      ELSE IF( LWORK.LT.LWMIN .AND. .NOT.LQUERY ) THEN
         INFO = -17
      ELSE IF( LIWORK.LT.LIWMIN .AND. .NOT.LQUERY ) THEN
         INFO = -19
      END IF
      IF( INFO.EQ.0 ) THEN
         WORK( 1 ) = LWMIN
         IWORK( 1 ) = LIWMIN
      END IF
*
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'ZSTEGR', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         RETURN
      END IF
*
*     Quick return if possible
*
      M = 0
      IF( N.EQ.0 )
     $   RETURN
*
      IF( N.EQ.1 ) THEN
         IF( ALLEIG .OR. INDEIG ) THEN
            M = 1
            W( 1 ) = D( 1 )
         ELSE
            IF( VL.LT.D( 1 ) .AND. VU.GE.D( 1 ) ) THEN
               M = 1
               W( 1 ) = D( 1 )
            END IF
         END IF
         IF( WANTZ )
     $      Z( 1, 1 ) = ONE
         RETURN
      END IF
*
*     Get machine constants.
*
      SAFMIN = DLAMCH( 'Safe minimum' )
      EPS = DLAMCH( 'Precision' )
      SMLNUM = SAFMIN / EPS
      BIGNUM = ONE / SMLNUM
      RMIN = SQRT( SMLNUM )
      RMAX = MIN( SQRT( BIGNUM ), ONE / SQRT( SQRT( SAFMIN ) ) )
*
*     Scale matrix to allowable range, if necessary.
*
      SCALE = ONE
      TNRM = DLANST( 'M', N, D, E )
      IF( TNRM.GT.ZERO .AND. TNRM.LT.RMIN ) THEN
         SCALE = RMIN / TNRM
      ELSE IF( TNRM.GT.RMAX ) THEN
         SCALE = RMAX / TNRM
      END IF
      IF( SCALE.NE.ONE ) THEN
         CALL DSCAL( N, SCALE, D, 1 )
         CALL DSCAL( N-1, SCALE, E, 1 )
         TNRM = TNRM*SCALE
      END IF
      INDGRS = 1
      INDWOF = 2*N + 1
      INDWRK = 3*N + 1
*
      IINSPL = 1
      IINDBL = N + 1
      IINDWK = 2*N + 1
*
      CALL ZLASET( 'Full', N, N, CZERO, CZERO, Z, LDZ )
*
*     Compute the desired eigenvalues of the tridiagonal after splitting
*     into smaller subblocks if the corresponding of-diagonal elements
*     are small
*
      THRESH = EPS*TNRM
      CALL DLARRE( N, D, E, THRESH, NSPLIT, IWORK( IINSPL ), M, W,
     $             WORK( INDWOF ), WORK( INDGRS ), WORK( INDWRK ),
     $             IINFO )
      IF( IINFO.NE.0 ) THEN
         INFO = 1
         RETURN
      END IF
*
      IF( WANTZ ) THEN
*
*        Compute the desired eigenvectors corresponding to the computed
*        eigenvalues
*
         TOL = MAX( ABSTOL, DBLE( N )*THRESH )
         IBEGIN = 1
         DO 20 I = 1, NSPLIT
            IEND = IWORK( IINSPL+I-1 )
            DO 10 J = IBEGIN, IEND
               IWORK( IINDBL+J-1 ) = I
   10       CONTINUE
            IBEGIN = IEND + 1
   20    CONTINUE
*
         CALL ZLARRV( N, D, E, IWORK( IINSPL ), M, W, IWORK( IINDBL ),
     $                WORK( INDGRS ), TOL, Z, LDZ, ISUPPZ,
     $                WORK( INDWRK ), IWORK( IINDWK ), IINFO )
         IF( IINFO.NE.0 ) THEN
            INFO = 2
            RETURN
         END IF
*
      END IF
*
      IBEGIN = 1
      DO 40 I = 1, NSPLIT
         IEND = IWORK( IINSPL+I-1 )
         DO 30 J = IBEGIN, IEND
            W( J ) = W( J ) + WORK( INDWOF+I-1 )
   30    CONTINUE
         IBEGIN = IEND + 1
   40 CONTINUE
*
*     If matrix was scaled, then rescale eigenvalues appropriately.
*
      IF( SCALE.NE.ONE ) THEN
         CALL DSCAL( M, ONE / SCALE, W, 1 )
      END IF
*
*     If eigenvalues are not in order, then sort them, along with
*     eigenvectors.
*
      IF( NSPLIT.GT.1 ) THEN
         DO 60 J = 1, M - 1
            I = 0
            TMP = W( J )
            DO 50 JJ = J + 1, M
               IF( W( JJ ).LT.TMP ) THEN
                  I = JJ
                  TMP = W( JJ )
               END IF
   50       CONTINUE
            IF( I.NE.0 ) THEN
               W( I ) = W( J )
               W( J ) = TMP
               IF( WANTZ ) THEN
                  CALL ZSWAP( N, Z( 1, I ), 1, Z( 1, J ), 1 )
                  ITMP = ISUPPZ( 2*I-1 )
                  ISUPPZ( 2*I-1 ) = ISUPPZ( 2*J-1 )
                  ISUPPZ( 2*J-1 ) = ITMP
                  ITMP = ISUPPZ( 2*I )
                  ISUPPZ( 2*I ) = ISUPPZ( 2*J )
                  ISUPPZ( 2*J ) = ITMP
               END IF
            END IF
   60    CONTINUE
      END IF
*
      WORK( 1 ) = LWMIN
      IWORK( 1 ) = LIWMIN
      RETURN
*
*     End of ZSTEGR
*
      END

      PROGRAM PGKEX20
C 
C  Getting a PostScript plot to fill an entire page.
C
C  Define error file, Fortran unit number, and workstation type,
C  and workstation ID.
C
      PARAMETER (IERRF=6, LUNIT=2, IWKID=1)
      CHARACTER*3 LAB
C
C  Open GKS.
C
      CALL GOPKS (IERRF,IDUM) 
C
C  Specify the output position for the next PostScript workstation to be
C  opened.  These calls must appear before the call to open the workstation.
C
      CALL NGSETI('LX', 50)
      CALL NGSETI('LY', 50)
      CALL NGSETI('UX',742)
      CALL NGSETI('UY',742)
C
C  Open and activate a color PostScript workstation in landscape mode.
C
      CALL GOPWK (IWKID, 2, NGPSWK('PS','LAND','COLOR'))
      CALL GACWK (IWKID) 
C
C  Draw three rows and four columns of square boxes.
C
      NUM = 0
      DO 10 J=1,3
        Y = 0.25*REAL(J-1)
        DO 20 I=1,4
          NUM = NUM+1
          WRITE(LAB,'(I3)') NUM
          X = 0.25*REAL(I-1)
          CALL BOX(X, Y, 0.25, LAB)
   20   CONTINUE
   10 CONTINUE
      CALL FRAME
C
C  Close things out.
C
      CALL GDAWK(IWKID)
      CALL GCLWK(IWKID)
      CALL GCLKS
C
      STOP
      END
      SUBROUTINE BOX(X,Y,SZ,LAB)
C
C  Draw a square box with lower left corner at (X,Y) and size SZ x SZ 
C  and put the label LAB in the center.
C
      CHARACTER*3 LAB
      DIMENSION A(5),B(5)
C
C  Draw box.
C
      A(1) = X
      B(1) = Y
      A(2) = X+SZ
      B(2) = Y
      A(3) = A(2)
      B(3) = Y+SZ
      A(4) = X
      B(4) = B(3)
      A(5) = X
      B(5) = Y
      CALL GPL(5,A,B)
C
C  Write label in box.
C
      CALL GSCHH(0.25*SZ)
      CALL GSTXAL(2,3)
      CALL GTX(X+.5*SZ, Y+.5*SZ, LAB)
C
      RETURN
      END

C
C $Id: rdpndw.f,v 1.8 2008-09-18 00:42:18 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      FUNCTION RDPNDW (DVIN)
C
        DOUBLE PRECISION DVIN
C
C "RDPNDW" stands for "Round Double Precision Number DownWard".  The
C value of RDPNDW(DVIN) is the smallest real number whose value is
C greater than or equal to the value of the double-precision argument
C DVIN.
C
        IF      (DVIN.LT.0.D0) THEN
          RDPNDW=RDPNAZ(DVIN)
        ELSE IF (DVIN.GT.0.D0) THEN
          RDPNDW=RDPNTZ(DVIN)
        ELSE
          RDPNDW=0.
        END IF
C
C Done.
C
        RETURN
C
      END

C
C $Id: pcgetc.f,v 1.16 2008-07-27 00:17:19 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE PCGETC (WHCH,CVAL)
C
      CHARACTER*(*) WHCH,CVAL
C
C The subroutine PCGETC may be used to get PLCHHQ parameters which have
C values of type CHARACTER.
C
C COMMON block declarations.
C
      COMMON /PCPRMS/ ADDS,CONS,DSTB,DSTL,DSTR,DSTT,HPIC(3),IBNU,
     +                IBXC(3),IBXF,ICEN,IORD,IOUC,IOUF,IPCC,IQUF,
     +                ISHC,ISHF,ITEF,JCOD,LSCI(16),NFCC,NODF,RBXL,
     +                RBXM,RBXX,RBXY,ROLW,RPLW,RSLW,SHDX,SHDY,SIZA,
     +                SSIC,SSPR,SUBS,VPIC(3),WPIC(3),XBEG,XCEN,XEND,
     +                XMUL(3),YBEG,YCEN,YEND,YMUL(3),ZINX,ZINY,ZINZ
      SAVE   /PCPRMS/
C
      COMMON /PCFNNO/ LFNO(43),LFNL
      SAVE   /PCFNNO/
C
      COMMON /PCFNNM/ LFNM(43,2)
      CHARACTER*18 LFNM
      SAVE   /PCFNNM/
C
C Do a call forcing a BLOCKDATA to be loaded from a binary library.
C
      CALL PCBLDA
C
C Check for an uncleared prior error.
C
      IF (ICFELL('PCGETC - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C There are only two possibilities:  In the case of the function-code
C character, take into account that what is really stored is the index
C of the character in the local collating sequence; provide for the
C case that the parameter had not been initialized yet.
C
      IF (WHCH(1:2).EQ.'FC'.OR.WHCH(1:2).EQ.'fc') THEN
        IF (NFCC.LT.0) NFCC=ICHAR(':')
        CVAL=CHAR(NFCC)
      ELSE IF (WHCH(1:2).EQ.'FN'.OR.WHCH(1:2).EQ.'fn') THEN
        DO 101 I=1,LFNL
          IF (NODF.EQ.LFNO(I)) THEN
            CVAL=LFNM(I,1)
            GO TO 102
          END IF
  101   CONTINUE
        CVAL='!FONT NOT DEFINED!'
      ELSE
        CALL SETER ('PCGETC - UNRECOGNIZED PARAMETER NAME',2,1)
        RETURN
      END IF
C
C Done.
C
  102 RETURN
C
      END

c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by UCAR                 .
c  .                                                             .
c  .       University Corporation for Atmospheric Research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                         SPHEREPACK                          .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c
c
c ... file ivlapec.f
c
c     this file includes documentation and code for
c     subroutine ivlapec
c
c ... files which must be loaded with ivlapec.f
c
c     sphcom.f, hrfft.f, vhaec.f, vhsec.f
c
c
c
c     subroutine ivlapec(nlat,nlon,ityp,nt,v,w,idvw,jdvw,br,bi,cr,ci,
c    +mdbc,ndbc,wvhsec,lvhsec,work,lwork,ierror)
c
c
c     subroutine ivlapec computes a the vector field (v,w) whose vector
c     laplacian is (vlap,wlap).  w and wlap are east longitudinal
C*PL*ERROR* Comment line too long
c     components of the vectors.  v and vlap are colatitudinal components
C*PL*ERROR* Comment line too long
c     of the vectors.  br,bi,cr, and ci are the vector harmonic coefficients
c     of (vlap,wlap).  these must be precomputed by vhaec and are input
c     parameters to ivlapec.  (v,w) have the same symmetry or lack of
c     symmetry about the about the equator as (vlap,wlap).  the input
c     parameters ityp,nt,mdbc,ndbc must have the same values used by
c     vhaec to compute br,bi,cr, and ci for (vlap,wlap).
c
c
c     input parameters
c
c     nlat   the number of colatitudes on the full sphere including the
c            poles. for example, nlat = 37 for a five degree grid.
c            nlat determines the grid increment in colatitude as
c            pi/(nlat-1).  if nlat is odd the equator is located at
c            grid point i=(nlat+1)/2. if nlat is even the equator is
c            located half way between points i=nlat/2 and i=nlat/2+1.
c            nlat must be at least 3. note: on the half sphere, the
c            number of grid points in the colatitudinal direction is
c            nlat/2 if nlat is even or (nlat+1)/2 if nlat is odd.
c
c     nlon   the number of distinct longitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater
c            than zero. the axisymmetric case corresponds to nlon=1.
c            the efficiency of the computation is improved when nlon
c            is a product of small prime numbers.
c
C*PL*ERROR* Comment line too long
c     ityp   this parameter should have the same value input to subroutine
c            vhaec to compute the coefficients br,bi,cr, and ci for the
c            vector field (vlap,wlap).  ityp is set as follows:
c
C*PL*ERROR* Comment line too long
c            = 0  no symmetries exist in (vlap,wlap) about the equator. (v,w)
C*PL*ERROR* Comment line too long
c                 is computed and stored on the entire sphere in the arrays
C*PL*ERROR* Comment line too long
c                 arrays v(i,j) and w(i,j) for i=1,...,nlat and j=1,...,nlon.
c
C*PL*ERROR* Comment line too long
c            = 1  no symmetries exist in (vlap,wlap) about the equator. (v,w)
C*PL*ERROR* Comment line too long
c                 is computed and stored on the entire sphere in the arrays
C*PL*ERROR* Comment line too long
c                 v(i,j) and w(i,j) for i=1,...,nlat and j=1,...,nlon.  the
C*PL*ERROR* Comment line too long
c                 vorticity of (vlap,wlap) is zero so the coefficients cr and
C*PL*ERROR* Comment line too long
c                 ci are zero and are not used.  the vorticity of (v,w) is
c                 also zero.
c
c
C*PL*ERROR* Comment line too long
c            = 2  no symmetries exist in (vlap,wlap) about the equator. (v,w)
C*PL*ERROR* Comment line too long
c                 is computed and stored on the entire sphere in the arrays
C*PL*ERROR* Comment line too long
c                 w(i,j) and v(i,j) for i=1,...,nlat and j=1,...,nlon.  the
C*PL*ERROR* Comment line too long
c                 divergence of (vlap,wlap) is zero so the coefficients br and
C*PL*ERROR* Comment line too long
c                 bi are zero and are not used.  the divergence of (v,w) is
c                 also zero.
c
c            = 3  wlap is antisymmetric and vlap is symmetric about the
C*PL*ERROR* Comment line too long
c                 equator. consequently w is antisymmetric and v is symmetric.
C*PL*ERROR* Comment line too long
c                 (v,w) is computed and stored on the northern hemisphere
C*PL*ERROR* Comment line too long
c                 only.  if nlat is odd, storage is in the arrays v(i,j),
C*PL*ERROR* Comment line too long
c                 w(i,j) for i=1,...,(nlat+1)/2 and j=1,...,nlon.  if nlat
c                 is even, storage is in the arrays v(i,j),w(i,j) for
c                 i=1,...,nlat/2 and j=1,...,nlon.
c
c            = 4  wlap is antisymmetric and vlap is symmetric about the
C*PL*ERROR* Comment line too long
c                 equator. consequently w is antisymmetric and v is symmetric.
C*PL*ERROR* Comment line too long
c                 (v,w) is computed and stored on the northern hemisphere
C*PL*ERROR* Comment line too long
c                 only.  if nlat is odd, storage is in the arrays v(i,j),
C*PL*ERROR* Comment line too long
c                 w(i,j) for i=1,...,(nlat+1)/2 and j=1,...,nlon.  if nlat
c                 is even, storage is in the arrays v(i,j),w(i,j) for
C*PL*ERROR* Comment line too long
c                 i=1,...,nlat/2 and j=1,...,nlon.  the vorticity of (vlap,
c                 wlap) is zero so the coefficients cr,ci are zero and
c                 are not used. the vorticity of (v,w) is also zero.
c
c            = 5  wlap is antisymmetric and vlap is symmetric about the
C*PL*ERROR* Comment line too long
c                 equator. consequently w is antisymmetric and v is symmetric.
C*PL*ERROR* Comment line too long
c                 (v,w) is computed and stored on the northern hemisphere
C*PL*ERROR* Comment line too long
c                 only.  if nlat is odd, storage is in the arrays w(i,j),
C*PL*ERROR* Comment line too long
c                 v(i,j) for i=1,...,(nlat+1)/2 and j=1,...,nlon.  if nlat
c                 is even, storage is in the arrays w(i,j),v(i,j) for
C*PL*ERROR* Comment line too long
c                 i=1,...,nlat/2 and j=1,...,nlon.  the divergence of (vlap,
c                 wlap) is zero so the coefficients br,bi are zero and
c                 are not used. the divergence of (v,w) is also zero.
c
c
c            = 6  wlap is symmetric and vlap is antisymmetric about the
C*PL*ERROR* Comment line too long
c                 equator. consequently w is symmetric and v is antisymmetric.
C*PL*ERROR* Comment line too long
c                 (v,w) is computed and stored on the northern hemisphere
C*PL*ERROR* Comment line too long
c                 only.  if nlat is odd, storage is in the arrays w(i,j),
C*PL*ERROR* Comment line too long
c                 v(i,j) for i=1,...,(nlat+1)/2 and j=1,...,nlon.  if nlat
c                 is even, storage is in the arrays w(i,j),v(i,j) for
c                 i=1,...,nlat/2 and j=1,...,nlon.
c
c            = 7  wlap is symmetric and vlap is antisymmetric about the
C*PL*ERROR* Comment line too long
c                 equator. consequently w is symmetric and v is antisymmetric.
C*PL*ERROR* Comment line too long
c                 (v,w) is computed and stored on the northern hemisphere
C*PL*ERROR* Comment line too long
c                 only.  if nlat is odd, storage is in the arrays w(i,j),
C*PL*ERROR* Comment line too long
c                 v(i,j) for i=1,...,(nlat+1)/2 and j=1,...,nlon.  if nlat
c                 is even, storage is in the arrays w(i,j),v(i,j) for
C*PL*ERROR* Comment line too long
c                 i=1,...,nlat/2 and j=1,...,nlon.  the vorticity of (vlap,
c                 wlap) is zero so the coefficients cr,ci are zero and
c                 are not used. the vorticity of (v,w) is also zero.
c
c            = 8  wlap is symmetric and vlap is antisymmetric about the
C*PL*ERROR* Comment line too long
c                 equator. consequently w is symmetric and v is antisymmetric.
C*PL*ERROR* Comment line too long
c                 (v,w) is computed and stored on the northern hemisphere
C*PL*ERROR* Comment line too long
c                 only.  if nlat is odd, storage is in the arrays w(i,j),
C*PL*ERROR* Comment line too long
c                 v(i,j) for i=1,...,(nlat+1)/2 and j=1,...,nlon.  if nlat
c                 is even, storage is in the arrays w(i,j),v(i,j) for
C*PL*ERROR* Comment line too long
c                 i=1,...,nlat/2 and j=1,...,nlon.  the divergence of (vlap,
c                 wlap) is zero so the coefficients br,bi are zero and
c                 are not used. the divergence of (v,w) is also zero.
c
c
C*PL*ERROR* Comment line too long
c     nt     nt is the number of vector fields (vlap,wlap). some computational
c            efficiency is obtained for multiple fields.  in the program
c            that calls ivlapec, the arrays v,w,br,bi,cr and ci can be
C*PL*ERROR* Comment line too long
c            three dimensional corresponding to an indexed multiple vector
C*PL*ERROR* Comment line too long
c            field.  in this case multiple vector synthesis will be performed
c            to compute the (v,w) for each field (vlap,wlap).  the third
C*PL*ERROR* Comment line too long
c            index is the synthesis index which assumes the values k=1,...,nt.
c            for a single synthesis set nt=1.  the description of the
c            remaining parameters is simplified by assuming that nt=1 or
c            that all arrays are two dimensional.
c
c   idvw     the first dimension of the arrays w and v as it appears in
C*PL*ERROR* Comment line too long
c            the program that calls ivlapec.  if ityp=0,1, or 2  then idvw
C*PL*ERROR* Comment line too long
c            must be at least nlat.  if ityp > 2 and nlat is even then idvw
C*PL*ERROR* Comment line too long
c            must be at least nlat/2. if ityp > 2 and nlat is odd then idvw
c            must be at least (nlat+1)/2.
c
c   jdvw     the second dimension of the arrays w and v as it appears in
c            the program that calls ivlapec. jdvw must be at least nlon.
c
c
c   br,bi    two or three dimensional arrays (see input parameter nt)
c   cr,ci    that contain vector spherical harmonic coefficients of the
c            vector field (vlap,wlap) as computed by subroutine vhaec.
c            br,bi,cr and ci must be computed by vhaec prior to calling
c            ivlapec.  if ityp=1,4, or 7 then cr,ci are not used and can
c            be dummy arguments.  if ityp=2,5, or 8 then br,bi are not
c            used and can be dummy arguments.
c
c    mdbc    the first dimension of the arrays br,bi,cr and ci as it
c            appears in the program that calls ivlapec.  mdbc must be
c            at least min0(nlat,nlon/2) if nlon is even or at least
c            min0(nlat,(nlon+1)/2) if nlon is odd.
c
c    ndbc    the second dimension of the arrays br,bi,cr and ci as it
c            appears in the program that calls ivlapec. ndbc must be at
c            least nlat.
c
c    wvhsec  an array which must be initialized by subroutine vhseci.
c            once initialized, wvhsec
c            can be used repeatedly by ivlapec as long as nlat and nlon
c            remain unchanged.  wvhsec must not be altered between calls
c            of ivlapec.
c
c    lvhsec  the dimension of the array wvhsec as it appears in the
c            program that calls ivlapec.  let
c
c               l1 = min0(nlat,nlon/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd.
c
c            then lvhsec must be at least
c
c            4*nlat*l2+3*max0(l1-2,0)*(nlat+nlat-l1-1)+nlon+15
c
c     work   a work array that does not have to be saved.
c
c     lwork  the dimension of the array work as it appears in the
c            program that calls ivlapec. define
c
c               l2 = nlat/2                    if nlat is even or
c               l2 = (nlat+1)/2                if nlat is odd
c               l1 = min0(nlat,nlon/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            if ityp .le. 2 then
c
c               nlat*(2*nt*nlon+max0(6*l2,nlon)) + nlat*(4*nt*l1+1)
c
c            or if ityp .gt. 2 let
c
c               l2*(2*nt*nlon+max0(6*nlat,nlon)) + nlat*(4*nt*l1+1)
c
c            will suffice as a minimum length for lwork
c            (see ierror=10 below)
c
c     **************************************************************
c
c     output parameters
c
c
C*PL*ERROR* Comment line too long
c    v,w     two or three dimensional arrays (see input parameter nt) that
C*PL*ERROR* Comment line too long
c            contain a vector field whose vector laplacian is (vlap,wlap).
C*PL*ERROR* Comment line too long
c            w(i,j) is the east longitude and v(i,j) is the colatitudinal
c            component of the vector. v(i,j) and w(i,j) are given on the
c            sphere at the colatitude
c
c                 theta(i) = (i-1)*pi/(nlat-1)
c
c            for i=1,...,nlat and east longitude
c
c                 lambda(j) = (j-1)*2*pi/nlon
c
c            for j=1,...,nlon.
c
C*PL*ERROR* Comment line too long
c            let cost and sint be the cosine and sine at colatitude theta.
C*PL*ERROR* Comment line too long
c            let d( )/dlambda  and d( )/dtheta be the first order partial
C*PL*ERROR* Comment line too long
c            derivatives in longitude and colatitude.  let sf be either v
c            or w.  define:
c
c                 del2s(sf) = [d(sint*d(sf)/dtheta)/dtheta +
c                               2            2
c                              d (sf)/dlambda /sint]/sint
c
c            then the vector laplacian of (v,w) in (vlap,wlap) satisfies
c
c                 vlap = del2s(v) + (2*cost*dw/dlambda - v)/sint**2
c
c            and
c
c                 wlap = del2s(w) - (2*cost*dv/dlambda + w)/sint**2
c
c
C*PL*ERROR* Comment line too long
c  ierror    a parameter which flags errors in input parameters as follows:
c
c            = 0  no errors detected
c
c            = 1  error in the specification of nlat
c
c            = 2  error in the specification of nlon
c
c            = 3  error in the specification of ityp
c
c            = 4  error in the specification of nt
c
c            = 5  error in the specification of idvw
c
c            = 6  error in the specification of jdvw
c
c            = 7  error in the specification of mdbc
c
c            = 8  error in the specification of ndbc
c
c            = 9  error in the specification of lvhsec
c
c            = 10 error in the specification of lwork
c
c
c **********************************************************************
c
c     end of documentation for ivlapec
c
c **********************************************************************
c
      SUBROUTINE DIVLAPEC(NLAT,NLON,ITYP,NT,V,W,IDVW,JDVW,BR,BI,CR,CI,
     +                   MDBC,NDBC,WVHSEC,LVHSEC,WORK,LWORK,IERROR)
      DOUBLE PRECISION V
      DOUBLE PRECISION W
      DOUBLE PRECISION BR
      DOUBLE PRECISION BI
      DOUBLE PRECISION CR
      DOUBLE PRECISION CI
      DOUBLE PRECISION WVHSEC
      DOUBLE PRECISION WORK
      DIMENSION V(IDVW,JDVW,NT),W(IDVW,JDVW,NT)
      DIMENSION BR(MDBC,NDBC,NT),BI(MDBC,NDBC,NT)
      DIMENSION CR(MDBC,NDBC,NT),CI(MDBC,NDBC,NT)
      DIMENSION WVHSEC(LVHSEC),WORK(LWORK)

      IERROR = 1
      IF (NLAT.LT.3) RETURN
      IERROR = 2
      IF (NLON.LT.1) RETURN
      IERROR = 3
      IF (ITYP.LT.0 .OR. ITYP.GT.8) RETURN
      IERROR = 4
      IF (NT.LT.0) RETURN
      IERROR = 5
      IMID = (NLAT+1)/2
      IF ((ITYP.LE.2.AND.IDVW.LT.NLAT) .OR.
     +    (ITYP.GT.2.AND.IDVW.LT.IMID)) RETURN
      IERROR = 6
      IF (JDVW.LT.NLON) RETURN
      IERROR = 7
      MMAX = MIN0(NLAT, (NLON+1)/2)
      IF (MDBC.LT.MMAX) RETURN
      IERROR = 8
      IF (NDBC.LT.NLAT) RETURN
      IERROR = 9
c
c     set minimum and verify saved workspace length
c
      IDZ = (MMAX* (NLAT+NLAT-MMAX+1))/2
      LZIMN = IDZ*IMID
c     lsavmin = lzimn+lzimn+nlon+15
c     if (lvhsec .lt. lsavmin) return
      LZZ1 = 2*NLAT*IMID
      LABC = 3* (MAX0(MMAX-2,0)* (NLAT+NLAT-MMAX-1))/2
      IF (LVHSEC.LT.2* (LZZ1+LABC)+NLON+15) RETURN
c
c     set minimum and verify unsaved work space length
c
      IERROR = 10
      MN = MMAX*NLAT*NT
      IF (ITYP.LT.3) THEN
c     no symmetry
          IF (ITYP.EQ.0) THEN
c       br,bi,cr,ci nonzero
              LWKMIN = NLAT* (2*NT*NLON+MAX0(6*IMID,NLON)+1) + 4*MN
          ELSE
c       br,bi or cr,ci zero
              LWKMIN = NLAT* (2*NT*NLON+MAX0(6*IMID,NLON)+1) + 2*MN
          END IF
      ELSE
c     symmetry
          IF (ITYP.EQ.3 .OR. ITYP.EQ.6) THEN
c       br,bi,cr,ci nonzero
              LWKMIN = IMID* (2*NT*NLON+MAX0(6*NLAT,NLON)) + 4*MN + NLAT
          ELSE
c       br,bi or cr,ci zero
              LWKMIN = IMID* (2*NT*NLON+MAX0(6*NLAT,NLON)) + 2*MN + NLAT
          END IF
      END IF
      IF (LWORK.LT.LWKMIN) RETURN
      IERROR = 0
c
c     set work space pointers for vector laplacian coefficients
c
      IF (ITYP.EQ.0 .OR. ITYP.EQ.3 .OR. ITYP.EQ.6) THEN
          IBR = 1
          IBI = IBR + MN
          ICR = IBI + MN
          ICI = ICR + MN
      ELSE IF (ITYP.EQ.1 .OR. ITYP.EQ.4 .OR. ITYP.EQ.7) THEN
          IBR = 1
          IBI = IBR + MN
          ICR = IBI + MN
          ICI = ICR
      ELSE
          IBR = 1
          IBI = 1
          ICR = IBI + MN
          ICI = ICR + MN
      END IF
      IFN = ICI + MN
      IWK = IFN + NLAT
      IF (ITYP.EQ.0 .OR. ITYP.EQ.3 .OR. ITYP.EQ.6) THEN
          LIWK = LWORK - 4*MN - NLAT
      ELSE
          LIWK = LWORK - 2*MN - NLAT
      END IF
      CALL DIVLAPEC1(NLAT,NLON,ITYP,NT,V,W,IDVW,JDVW,WORK(IBR),
     +               WORK(IBI),WORK(ICR),WORK(ICI),MMAX,WORK(IFN),MDBC,
     +               NDBC,BR,BI,CR,CI,WVHSEC,LVHSEC,WORK(IWK),LIWK,
     +               IERROR)
      RETURN
      END

      SUBROUTINE DIVLAPEC1(NLAT,NLON,ITYP,NT,V,W,IDVW,JDVW,BRVW,BIVW,
     +                    CRVW,CIVW,MMAX,FNN,MDBC,NDBC,BR,BI,CR,CI,
     +                    WSAVE,LWSAV,WK,LWK,IERROR)
      DOUBLE PRECISION V
      DOUBLE PRECISION W
      DOUBLE PRECISION BRVW
      DOUBLE PRECISION BIVW
      DOUBLE PRECISION CRVW
      DOUBLE PRECISION CIVW
      DOUBLE PRECISION FNN
      DOUBLE PRECISION BR
      DOUBLE PRECISION BI
      DOUBLE PRECISION CR
      DOUBLE PRECISION CI
      DOUBLE PRECISION WSAVE
      DOUBLE PRECISION WK
      DOUBLE PRECISION FN
      DIMENSION V(IDVW,JDVW,NT),W(IDVW,JDVW,NT)
      DIMENSION FNN(NLAT),BRVW(MMAX,NLAT,NT),BIVW(MMAX,NLAT,NT)
      DIMENSION CRVW(MMAX,NLAT,NT),CIVW(MMAX,NLAT,NT)
      DIMENSION BR(MDBC,NDBC,NT),BI(MDBC,NDBC,NT)
      DIMENSION CR(MDBC,NDBC,NT),CI(MDBC,NDBC,NT)
      DIMENSION WSAVE(LWSAV),WK(LWK)
c
c     preset coefficient multiplyers
c
      DO 1 N = 2,NLAT
          FN = DBLE(N-1)
          FNN(N) = -1.0D0/ (FN* (FN+1.D0))
    1 CONTINUE
c
c     set (v,w) coefficients from br,bi,cr,ci
c
      IF (ITYP.EQ.0 .OR. ITYP.EQ.3 .OR. ITYP.EQ.6) THEN
c
c     all coefficients needed
c
          DO 2 K = 1,NT
              DO 3 N = 1,NLAT
                  DO 4 M = 1,MMAX
                      BRVW(M,N,K) = 0.0D0
                      BIVW(M,N,K) = 0.0D0
                      CRVW(M,N,K) = 0.0D0
                      CIVW(M,N,K) = 0.0D0
    4             CONTINUE
    3         CONTINUE
              DO 5 N = 2,NLAT
                  BRVW(1,N,K) = FNN(N)*BR(1,N,K)
                  BIVW(1,N,K) = FNN(N)*BI(1,N,K)
                  CRVW(1,N,K) = FNN(N)*CR(1,N,K)
                  CIVW(1,N,K) = FNN(N)*CI(1,N,K)
    5         CONTINUE
              DO 6 M = 2,MMAX
                  DO 7 N = M,NLAT
                      BRVW(M,N,K) = FNN(N)*BR(M,N,K)
                      BIVW(M,N,K) = FNN(N)*BI(M,N,K)
                      CRVW(M,N,K) = FNN(N)*CR(M,N,K)
                      CIVW(M,N,K) = FNN(N)*CI(M,N,K)
    7             CONTINUE
    6         CONTINUE
    2     CONTINUE
      ELSE IF (ITYP.EQ.1 .OR. ITYP.EQ.4 .OR. ITYP.EQ.7) THEN
c
c     vorticity is zero so cr,ci=0 not used
c
          DO 12 K = 1,NT
              DO 13 N = 1,NLAT
                  DO 14 M = 1,MMAX
                      BRVW(M,N,K) = 0.0D0
                      BIVW(M,N,K) = 0.0D0
   14             CONTINUE
   13         CONTINUE
              DO 15 N = 2,NLAT
                  BRVW(1,N,K) = FNN(N)*BR(1,N,K)
                  BIVW(1,N,K) = FNN(N)*BI(1,N,K)
   15         CONTINUE
              DO 16 M = 2,MMAX
                  DO 17 N = M,NLAT
                      BRVW(M,N,K) = FNN(N)*BR(M,N,K)
                      BIVW(M,N,K) = FNN(N)*BI(M,N,K)
   17             CONTINUE
   16         CONTINUE
   12     CONTINUE
      ELSE
c
c     divergence is zero so br,bi=0 not used
c
          DO 22 K = 1,NT
              DO 23 N = 1,NLAT
                  DO 24 M = 1,MMAX
                      CRVW(M,N,K) = 0.0D0
                      CIVW(M,N,K) = 0.0D0
   24             CONTINUE
   23         CONTINUE
              DO 25 N = 2,NLAT
                  CRVW(1,N,K) = FNN(N)*CR(1,N,K)
                  CIVW(1,N,K) = FNN(N)*CI(1,N,K)
   25         CONTINUE
              DO 26 M = 2,MMAX
                  DO 27 N = M,NLAT
                      CRVW(M,N,K) = FNN(N)*CR(M,N,K)
                      CIVW(M,N,K) = FNN(N)*CI(M,N,K)
   27             CONTINUE
   26         CONTINUE
   22     CONTINUE
      END IF
c
c     sythesize coefs into vector field (v,w)
c
      CALL DVHSEC(NLAT,NLON,ITYP,NT,V,W,IDVW,JDVW,BRVW,BIVW,CRVW,CIVW,
     +           MMAX,NLAT,WSAVE,LWSAV,WK,LWK,IERROR)
      RETURN
      END

C
C	$Id: gqewk.f,v 1.5 2008-07-27 00:20:59 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GQEWK(N,ERRIND,NUMBER,WKTYP)
C
C  INQUIRE LIST element OF AVAILABLE WORKSTATION TYPES
C
      include 'gkscom.h'
C
      INTEGER N,ERRIND,NUMBER,WKTYP
C
C  Check if GKS is in the proper state.
C
      CALL GZCKST(8,-1,ERRIND)
      IF (ERRIND .NE. 0) GOTO 100
C
C  Check if N is in bounds.
C
      IF (N.LT.0 .OR. N.GT.WK) THEN
        ERRIND = 2002
        GOTO 100
      ENDIF
      NUMBER = WK
      IF (N .EQ. 0) RETURN
      WKTYP = LSWK(N)
      RETURN
C
  100 CONTINUE
      NUMBER = WK
      WKTYP = -1
      RETURN
      END

C
C	$Id: gceldr.f,v 1.6 2008-07-27 00:20:57 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GCELDR(IOS,STATUS)
C
C  Put out the cell array.  
C
      include 'trpars.h'
      include 'gkscom.h'
C
      INTEGER IOS, STATUS
      INTEGER P(2),Q(2),R(2),PDIM(2)
      INTEGER COLTMP, CELCOP, CELRMD
C
      STATUS = 0
C
C  Get the boundaries of the cell array.  These boundaries 
C  define the lower left point and the upper right point.
C
      CALL GCELDC(P,MOPLEN,2,IOS,STATUS)
      IF (STATUS .NE. 0) RETURN
      CALL GCELDC(Q,MOPLEN,2,IOS,STATUS)
      IF (STATUS .NE. 0) RETURN
      CALL GCELDC(R,MOPLEN,2,IOS,STATUS)
      IF (STATUS .NE. 0) RETURN
C
C  Get the dimension of the virtual pixel array.
C
      CALL GCELDC(PDIM,MWHCPR,2,IOS,STATUS)
      IF (STATUS .NE. 0) RETURN
C
C  Get the cell array color precision.
C
      CALL GCELDC(CELCOP,MWHCPR,1,IOS,STATUS)
      IF (STATUS .NE. 0) RETURN
C
C  Compute the precision size.
C
      IF (CELCOP .EQ. 0) THEN
C
C  Use the color precision in effect.
C
        COLTMP = MCICPR
      ELSE
C
C  Use the color precision given by CELCOP.
C
        COLTMP = CELCOP
      END IF
C
C  Get the cell representation mode.
C
      CALL GCELDC(CELRMD,MENCPR,1,IOS,STATUS)
      IF (STATUS .NE. 0) RETURN
C
C  Set up interface data.
C
      CALL GZROI(0)
      FCODE = 15
      IL1 = 2
      IL2 = 2
      NCOLS = PDIM(1)
      ID(1) = NCOLS
      NROWS = PDIM(2)
      ID(2) = NROWS
      IC1 = ID(1)*ID(2)
      RL1 = 3
      RL2 = 3
      RX(1) = REAL(P(1))/32767.
      RY(1) = REAL(P(2))/32767.
      RX(2) = REAL(Q(1))/32767.
      RY(2) = REAL(Q(2))/32767.
      RX(3) = REAL(R(1))/32767.
      RY(3) = REAL(R(2))/32767.
C
C  Transform the corner points using the current transform matrix.
C
      RX(1) = CURTM(1,1)*RX(1) + CURTM(1,2)*RY(1) + CURTM(1,3)
      RY(1) = CURTM(2,1)*RX(1) + CURTM(2,2)*RY(1) + CURTM(2,3)
      RX(2) = CURTM(1,1)*RX(2) + CURTM(1,2)*RY(2) + CURTM(1,3)
      RY(2) = CURTM(2,1)*RX(2) + CURTM(2,2)*RY(2) + CURTM(2,3)
      RX(3) = CURTM(1,1)*RX(3) + CURTM(1,2)*RY(3) + CURTM(1,3)
      RY(3) = CURTM(2,1)*RX(3) + CURTM(2,2)*RY(3) + CURTM(2,3)
C
      STRL1 = 0
      STRL2 = 0
C
C  Put out color indices.
C
      J = (IC1-1)/128
      IF (J .EQ. 0) THEN
C
C  Case where there is no continuation.
C
        DO 160 I=1,NROWS
          INDX = 1+NCOLS*(I-1)
          CALL GCELDC(IC(INDX),COLTMP,NCOLS,IOS,STATUS)
          IF (MOD(NCOLS,2).NE.0) CALL GCELDC(IDUM,COLTMP,1,IOS,STATUS)
  160   CONTINUE
        CONT = 0
        IC2  = IC1
        CALL GZTOWK
      ELSE
C
C  Case with continuation.
C
        CONT = 1
        IF (NCOLS .LE. 128) THEN
          IC2 = NCOLS
          DO 170 I=1,NROWS
            CALL GCELDC(IC(1),COLTMP,NCOLS,IOS,STATUS)
            IF (I .GT. 1) THEN
              IL2 = 0
              RL2 = 0
            ENDIF
            IF (I .EQ. NROWS) CONT = 0
            CALL GZTOWK
            IF (MOD(NCOLS,2).NE.0) CALL GCELDC(IDUM,COLTMP,1,IOS,STATUS)       
  170     CONTINUE
        ELSE
          JP = NCOLS/128
          JR = MOD(NCOLS,128)
          DO 180 I=1,NROWS
            DO 190 K=1,JP
              CALL GCELDC(IC(1),COLTMP,128,IOS,STATUS)
              IF (I.GT.1 .OR. K.GT.1) THEN
                IL2 = 0
                RL2 = 0
              ENDIF
              IF (K.EQ.JP .AND. I.EQ.NROWS .AND. JR.EQ.0) CONT = 0
              IC2 = 128
              CALL GZTOWK
  190       CONTINUE
            IF (JR .NE. 0) THEN
              CALL GCELDC(IC(1),COLTMP,JR,IOS,STATUS)
              IC2 = JR
              IF (I .EQ. NROWS) CONT = 0
              IL2 = 0
              RL2 = 0
              CALL GZTOWK
            ENDIF
            IF (MOD(NCOLS,2).NE.0) CALL GCELDC(IDUM,COLTMP,1,IOS,STATUS)       
  180     CONTINUE
        ENDIF
      ENDIF
C
      RETURN
      END

      PROGRAM TSTITL
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C OPEN GKS, OPEN WORKSTATION OF TYPE 1, ACTIVATE WORKSTATION
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C INVOKE DEMO DRIVER
C
      CALL STITL(IERR)
C
C DEACTIVATE AND CLOSE WORKSTATION, CLOSE GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END
C
      SUBROUTINE STITL (IERROR)
C
C PURPOSE                To provide a simple demonstration of the
C                        routine STITLE.
C
C USAGE                  CALL STITL (IERROR)
C
C ARGUMENTS
C
C ON OUTPUT              IERROR
C                          An integer variable
C                            = 0  If there is a normal exit from STITLE
C                            = 1  Otherwise
C
C I/O                    If there is a normal exit from STITLE,
C                        the message
C
C                          STITLE TEST SUCCESSFUL . . . SEE PLOTS TO
C                          VERIFY PERFORMANCE
C
C                        is written on unit 6
C
C PRECISION              SINGLE
C
C REQUIRED LIBRARY       STITLE
C FILES
C
C LANGUAGE               FORTRAN
C
C HISTORY                Written  by members of the
C                        Scientific Computing Division of NCAR,
C                        Boulder Colorado
C
C PORTABILITY            FORTRAN 77
C
C
      CHARACTER*80    CARDS(6)
C
C Initialize the error parameter.
C
      IERROR = 1
C
C Store character strings in array CARDS.  These strings contain text,
C plus information regarding character size and location of the text
C on the scroll.
C
      NCARDS = 4
      CARDS(1) = '  512  760    1  1.5Demonstration'
      CARDS(2) = '  512  600    1  1.5Plot'
      CARDS(3) = '  512  440    1  1.0for'
      CARDS(4) = '  512  280    1  1.5STITLE'
C
C Define the remaining inputs to routine STITLE.  Note that the
C output produced (a single frame with no scrolling to appear for
C 6.0 seconds) could equally well have been produced by FTITLE.
C We call STITLE in this demo to avoid reading the input lines.
C
      NYST  = 512
      NYFIN = 512
      TST   = 0.0
      TMV   = 0.0
      TFIN  = 6.0
      MOVIE =   1
C
C Call STITLE.
C
      CALL STITLE (CARDS,NCARDS,NYST,NYFIN,TST,TMV,TFIN,MOVIE)
      IERROR = 0
      WRITE (6,1001)
      RETURN
C
 1001 FORMAT ('     STITLE TEST SUCCESSFUL',24X,
     1        'SEE PLOTS TO VERIFY PERFORMANCE')
C
      END

C
C $Id: pj08dp.f,v 1.5 2008-07-27 00:17:10 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE PJ08DP (COORD,CRDIO,INDIC)
C
C -- E Q U I D I S T A N T   C O N I C
C
      IMPLICIT DOUBLE PRECISION (A-Z)
      INTEGER INDIC
      DIMENSION GEOG(2),PROJ(2),COORD(2),CRDIO(2)
C ** PARAMETERS * A,E,ES,LAT1,LAT2,LON0,LAT0,X0,Y0,E0,E1,E2,E3,NS,GL,RH0
      COMMON /ERRMZ0/ IERR
        INTEGER IERR
      SAVE   /ERRMZ0/
      COMMON /PRINZ0/ IPEMSG,IPELUN,IPPARM,IPPLUN
        INTEGER IPEMSG,IPELUN,IPPARM,IPPLUN
      SAVE   /PRINZ0/
      COMMON /PC08DP/ A,LON0,X0,Y0,E0,E1,E2,E3,GL,NS,RH0
      DATA ZERO,ONE /0.0D0,1.0D0/
      DATA EPSLN /1.0D-10/
C
C -- F O R W A R D   . . .
C
      IF (INDIC .EQ. 0) THEN
C
         GEOG(1) = COORD(1)
         GEOG(2) = COORD(2)
         IERR = 0
         ML = MLFNDP (E0,E1,E2,E3,GEOG(2))
         RH = A * (GL - ML)
         THETA = NS * ADJLDP (GEOG(1) - LON0)
         PROJ(1) = X0 + RH * SIN (THETA)
         PROJ(2) = Y0 + RH0 - RH * COS (THETA)
         CRDIO(1) = PROJ(1)
         CRDIO(2) = PROJ(2)
         RETURN
      END IF
C
C -- I N V E R S E   . . .
C
      IF (INDIC .EQ. 1) THEN
C
         PROJ(1) = COORD(1)
         PROJ(2) = COORD(2)
         IERR = 0
         X = PROJ(1) - X0
         Y = RH0 - PROJ(2) + Y0
         RH = SIGN (SQRT (X * X + Y * Y) , NS)
         THETA = ZERO
         CON = SIGN (ONE , NS)
         IF (RH .NE. ZERO) THETA = ATAN2 (CON * X , CON * Y)
         ML = GL - RH / A
         GEOG(2) = PHI3DP (ML,E0,E1,E2,E3)
         IF (IERR .EQ. 0) GO TO 340
         IERR = 085
         RETURN
  340    GEOG(1) = ADJLDP (LON0 + THETA / NS)
         CRDIO(1) = GEOG(1)
         CRDIO(2) = GEOG(2)
         RETURN
      END IF
C
      END

C
C $Id: sflush.f,v 1.8 2008-07-27 00:17:25 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE SFLUSH
C
C SFLUSH flushes the GKS pen-move buffer as well as executing
C an UPDATE WORKSTATION on all open workstations.  In particular,
C for a CGM workstation, this effects a flush of the system level
C I/O buffers.
C
      INTEGER WKID
C
C Check for an uncleared prior error.
C
      IF (ICFELL('SFLUSH - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C Flush the GKS pen move buffer.
C
      CALL PLOTIF (0.,0.,2)
      IF (ICFELL('SFLUSH',2).NE.0) RETURN
C
C Execute UPDATE WORKSTATION on all open workstations.
C
C If no workstations are open, return.
C
      CALL GQOPWK (1,IE,NO,ID)
      IF (IE.NE.0) THEN
        CALL SETER ('SFLUSH - ERROR EXIT FROM GQOPWK',3,1)
        RETURN
      END IF
      IF (NO .EQ. 0) RETURN
C
C Update all workstations.
C
      DO 200 I=1,NO
        CALL GQOPWK (I,IE,NO,WKID)
        IF (IE.NE.0) THEN
          CALL SETER ('SFLUSH - ERROR EXIT FROM GQOPWK',4,1)
          RETURN
        END IF
        CALL GUWK(WKID,0)
  200 CONTINUE
C
C Done.
C
      RETURN
C
      END

C NCLFORTSTART
      SUBROUTINE DDEWTEMP(TK,RH,TDK)
C     NCL: tdk = dewtemp_trh (tk:numeric, rh:numeric)

c calculate the dew pt temperature [k]:
c input:
c     rh - relative humidty [%]
c     tk - temperature [k]
c output:
c     tdk- dew point temperature
c          equation used is Dutton p274 (6) [k]

      IMPLICIT NONE
      DOUBLE PRECISION RH,TK
      DOUBLE PRECISION TDK
c NCLEND

c local:
c     gc  - gas constant for water vapor [j/{kg-k}]
c           gcx [cal/{g-k}]
c     lhv - latent heat vap (Dutton top p273)

      DOUBLE PRECISION GC,GCX,LHV
      PARAMETER (GC=461.5D0)
      PARAMETER (GCX=GC/ (1000.D0*4.186D0))


      LHV = (597.3D0-0.57D0* (TK-273.D0))/GCX
      TDK = TK*LHV/ (LHV-TK*DLOG(RH*0.01D0))

      RETURN
      END

      SUBROUTINE DLAED3( K, N, N1, D, Q, LDQ, RHO, DLAMDA, Q2, INDX,
     $                   CTOT, W, S, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Oak Ridge National Lab, Argonne National Lab,
*     Courant Institute, NAG Ltd., and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      INTEGER            INFO, K, LDQ, N, N1
      DOUBLE PRECISION   RHO
*     ..
*     .. Array Arguments ..
      INTEGER            CTOT( * ), INDX( * )
      DOUBLE PRECISION   D( * ), DLAMDA( * ), Q( LDQ, * ), Q2( * ),
     $                   S( * ), W( * )
*     ..
*
*  Purpose
*  =======
*
*  DLAED3 finds the roots of the secular equation, as defined by the
*  values in D, W, and RHO, between 1 and K.  It makes the
*  appropriate calls to DLAED4 and then updates the eigenvectors by
*  multiplying the matrix of eigenvectors of the pair of eigensystems
*  being combined by the matrix of eigenvectors of the K-by-K system
*  which is solved here.
*
*  This code makes very mild assumptions about floating point
*  arithmetic. It will work on machines with a guard digit in
*  add/subtract, or on those binary machines without guard digits
*  which subtract like the Cray X-MP, Cray Y-MP, Cray C-90, or Cray-2.
*  It could conceivably fail on hexadecimal or decimal machines
*  without guard digits, but we know of none.
*
*  Arguments
*  =========
*
*  K       (input) INTEGER
*          The number of terms in the rational function to be solved by
*          DLAED4.  K >= 0.
*
*  N       (input) INTEGER
*          The number of rows and columns in the Q matrix.
*          N >= K (deflation may result in N>K).
*
*  N1      (input) INTEGER
*          The location of the last eigenvalue in the leading submatrix.
*          min(1,N) <= N1 <= N/2.
*
*  D       (output) DOUBLE PRECISION array, dimension (N)
*          D(I) contains the updated eigenvalues for
*          1 <= I <= K.
*
*  Q       (output) DOUBLE PRECISION array, dimension (LDQ,N)
*          Initially the first K columns are used as workspace.
*          On output the columns 1 to K contain
*          the updated eigenvectors.
*
*  LDQ     (input) INTEGER
*          The leading dimension of the array Q.  LDQ >= max(1,N).
*
*  RHO     (input) DOUBLE PRECISION
*          The value of the parameter in the rank one update equation.
*          RHO >= 0 required.
*
*  DLAMDA  (input/output) DOUBLE PRECISION array, dimension (K)
*          The first K elements of this array contain the old roots
*          of the deflated updating problem.  These are the poles
*          of the secular equation. May be changed on output by
*          having lowest order bit set to zero on Cray X-MP, Cray Y-MP,
*          Cray-2, or Cray C-90, as described above.
*
*  Q2      (input) DOUBLE PRECISION array, dimension (LDQ2, N)
*          The first K columns of this matrix contain the non-deflated
*          eigenvectors for the split problem.
*
*  INDX    (input) INTEGER array, dimension (N)
*          The permutation used to arrange the columns of the deflated
*          Q matrix into three groups (see DLAED2).
*          The rows of the eigenvectors found by DLAED4 must be likewise
*          permuted before the matrix multiply can take place.
*
*  CTOT    (input) INTEGER array, dimension (4)
*          A count of the total number of the various types of columns
*          in Q, as described in INDX.  The fourth column type is any
*          column which has been deflated.
*
*  W       (input/output) DOUBLE PRECISION array, dimension (K)
*          The first K elements of this array contain the components
*          of the deflation-adjusted updating vector. Destroyed on
*          output.
*
*  S       (workspace) DOUBLE PRECISION array, dimension (N1 + 1)*K
*          Will contain the eigenvectors of the repaired matrix which
*          will be multiplied by the previously accumulated eigenvectors
*          to update the system.
*
*  LDS     (input) INTEGER
*          The leading dimension of S.  LDS >= max(1,K).
*
*  INFO    (output) INTEGER
*          = 0:  successful exit.
*          < 0:  if INFO = -i, the i-th argument had an illegal value.
*          > 0:  if INFO = 1, an eigenvalue did not converge
*
*  Further Details
*  ===============
*
*  Based on contributions by
*     Jeff Rutter, Computer Science Division, University of California
*     at Berkeley, USA
*  Modified by Francoise Tisseur, University of Tennessee.
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ONE, ZERO
      PARAMETER          ( ONE = 1.0D0, ZERO = 0.0D0 )
*     ..
*     .. Local Scalars ..
      INTEGER            I, II, IQ2, J, N12, N2, N23
      DOUBLE PRECISION   TEMP
*     ..
*     .. External Functions ..
      DOUBLE PRECISION   DLAMC3, DNRM2
      EXTERNAL           DLAMC3, DNRM2
*     ..
*     .. External Subroutines ..
      EXTERNAL           DCOPY, DGEMM, DLACPY, DLAED4, DLASET, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, SIGN, SQRT
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
*
      IF( K.LT.0 ) THEN
         INFO = -1
      ELSE IF( N.LT.K ) THEN
         INFO = -2
      ELSE IF( LDQ.LT.MAX( 1, N ) ) THEN
         INFO = -6
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DLAED3', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( K.EQ.0 )
     $   RETURN
*
*     Modify values DLAMDA(i) to make sure all DLAMDA(i)-DLAMDA(j) can
*     be computed with high relative accuracy (barring over/underflow).
*     This is a problem on machines without a guard digit in
*     add/subtract (Cray XMP, Cray YMP, Cray C 90 and Cray 2).
*     The following code replaces DLAMDA(I) by 2*DLAMDA(I)-DLAMDA(I),
*     which on any of these machines zeros out the bottommost
*     bit of DLAMDA(I) if it is 1; this makes the subsequent
*     subtractions DLAMDA(I)-DLAMDA(J) unproblematic when cancellation
*     occurs. On binary machines with a guard digit (almost all
*     machines) it does not change DLAMDA(I) at all. On hexadecimal
*     and decimal machines with a guard digit, it slightly
*     changes the bottommost bits of DLAMDA(I). It does not account
*     for hexadecimal or decimal machines without guard digits
*     (we know of none). We use a subroutine call to compute
*     2*DLAMBDA(I) to prevent optimizing compilers from eliminating
*     this code.
*
      DO 10 I = 1, K
         DLAMDA( I ) = DLAMC3( DLAMDA( I ), DLAMDA( I ) ) - DLAMDA( I )
   10 CONTINUE
*
      DO 20 J = 1, K
         CALL DLAED4( K, J, DLAMDA, W, Q( 1, J ), RHO, D( J ), INFO )
*
*        If the zero finder fails, the computation is terminated.
*
         IF( INFO.NE.0 )
     $      GO TO 120
   20 CONTINUE
*
      IF( K.EQ.1 )
     $   GO TO 110
      IF( K.EQ.2 ) THEN
         DO 30 J = 1, K
            W( 1 ) = Q( 1, J )
            W( 2 ) = Q( 2, J )
            II = INDX( 1 )
            Q( 1, J ) = W( II )
            II = INDX( 2 )
            Q( 2, J ) = W( II )
   30    CONTINUE
         GO TO 110
      END IF
*
*     Compute updated W.
*
      CALL DCOPY( K, W, 1, S, 1 )
*
*     Initialize W(I) = Q(I,I)
*
      CALL DCOPY( K, Q, LDQ+1, W, 1 )
      DO 60 J = 1, K
         DO 40 I = 1, J - 1
            W( I ) = W( I )*( Q( I, J ) / ( DLAMDA( I )-DLAMDA( J ) ) )
   40    CONTINUE
         DO 50 I = J + 1, K
            W( I ) = W( I )*( Q( I, J ) / ( DLAMDA( I )-DLAMDA( J ) ) )
   50    CONTINUE
   60 CONTINUE
      DO 70 I = 1, K
         W( I ) = SIGN( SQRT( -W( I ) ), S( I ) )
   70 CONTINUE
*
*     Compute eigenvectors of the modified rank-1 modification.
*
      DO 100 J = 1, K
         DO 80 I = 1, K
            S( I ) = W( I ) / Q( I, J )
   80    CONTINUE
         TEMP = DNRM2( K, S, 1 )
         DO 90 I = 1, K
            II = INDX( I )
            Q( I, J ) = S( II ) / TEMP
   90    CONTINUE
  100 CONTINUE
*
*     Compute the updated eigenvectors.
*
  110 CONTINUE
*
      N2 = N - N1
      N12 = CTOT( 1 ) + CTOT( 2 )
      N23 = CTOT( 2 ) + CTOT( 3 )
*
      CALL DLACPY( 'A', N23, K, Q( CTOT( 1 )+1, 1 ), LDQ, S, N23 )
      IQ2 = N1*N12 + 1
      IF( N23.NE.0 ) THEN
         CALL DGEMM( 'N', 'N', N2, K, N23, ONE, Q2( IQ2 ), N2, S, N23,
     $               ZERO, Q( N1+1, 1 ), LDQ )
      ELSE
         CALL DLASET( 'A', N2, K, ZERO, ZERO, Q( N1+1, 1 ), LDQ )
      END IF
*
      CALL DLACPY( 'A', N12, K, Q, LDQ, S, N12 )
      IF( N12.NE.0 ) THEN
         CALL DGEMM( 'N', 'N', N1, K, N12, ONE, Q2, N1, S, N12, ZERO, Q,
     $               LDQ )
      ELSE
         CALL DLASET( 'A', N1, K, ZERO, ZERO, Q( 1, 1 ), LDQ )
      END IF
*
*
  120 CONTINUE
      RETURN
*
*     End of DLAED3
*
      END

      PROGRAM CCPILS
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER (M=40,N=40,LRWK=3500,LIWK=4000)
      REAL Z(M,N), RWRK(LRWK)
      INTEGER IWRK(LIWK)
      
      CALL GETDAT (Z, M, M, N)
C 
C Open GKS, open and activate a workstation.
C 
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
      CALL GSCLIP (0)
C
C Turn off the flag that causes CONPACK to look for overlap problems
C as high/low labels are generated.  This will cause the output to
C look as it did when the tutorial was written.  (A bug fix affected
C the output of this example by causing CONPACK to look for overlap;
C prior to that, it had been erroneously failing to do so.)  - DJK
C (03/08/96).
C
      CALL CPSETI('HLO - HIGH/LOW LABEL OVERLAP FLAG',0)
C
C Set label sizes 
C
      CALL CPSETR('HLS - HIGH/LOW LABEL SIZE',.030)
      CALL CPSETR('ILS - INFORMATION LABEL SIZE',.005)
C
C Initialize Conpack
C
      CALL CPRECT(Z, M, M, N, RWRK, LRWK, IWRK, LIWK)
C
C Draw Perimeter
C
      CALL CPBACK(Z, RWRK, IWRK)
C
C Draw Labels
C
      CALL CPLBDR(Z,RWRK,IWRK)
C
C Close frame
C
      CALL FRAME
C 
C Deactivate and close workstation, close GKS.
C 
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      
      STOP
      END
      
      SUBROUTINE GETDAT (Z, K, M, N)
      INTEGER I,J,K,M,N
      REAL Z(K,N)
      
      L=K
      DO 10, I=1,L
         READ (*,*) (Z(I,J),J=1,N)
 10   CONTINUE
      
      RETURN
      END

      PROGRAM CEZMAP1
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Open GKS, Turn Clipping off
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Invoke demo driver
C
      CALL CEZMAP('SV',40.,-50.,0.)
C
C Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS

      STOP
      END

      SUBROUTINE CEZMAP(PROJ,PLAT,PLON,ROTA)

      CHARACTER*2 PROJ
      REAL PLIM1(2), PLIM2(2), PLIM3(2), PLIM4(2)

      DATA PLIM1 /0.,0./
      DATA PLIM2 /0.,0./
      DATA PLIM3 /0.,0./
      DATA PLIM4 /0.,0./
C
C CMPLOT demonstrates MAPLOT drawing continental and political outlines
C
C Set up Maps.
C
C
C Draw Continental, political outlines 
C
      CALL MAPSTC ('OU - OUTLINE DATASET SELECTOR','PO')
C
C Set up projection
C
      CALL MAPROJ (PROJ,PLAT,PLON,ROTA)
C
C If it's a satellite projection, choose a satellite distance
C
      IF (PROJ.EQ.'SV') CALL MAPSTR ('SA - SATELLITE DISTANCE',5.)
C
C Set limits of map
C
      CALL MAPSET ('MA',PLIM1,PLIM2,PLIM3,PLIM4)
C
C Draw map
C
      CALL MAPDRW
C
C Advance the frame.
C
      CALL FRAME
C
C Done.
C
      RETURN
      END

C
C $Id: mddadp.f,v 1.2 2008-07-27 00:17:09 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      DOUBLE PRECISION FUNCTION MDDADP (GEOG)
C
        DOUBLE PRECISION GEOG(2)
C
        DOUBLE PRECISION DTOR,RTOD
C
        DOUBLE PRECISION ALAT,ALON,CALT,SALT,CALN,SALN
        DOUBLE PRECISION BLAT,BLON,CBLT,SBLT,CBLN,SBLN
C
        DOUBLE PRECISION XCOA,YCOA,ZCOA
        DOUBLE PRECISION XCOB,YCOB,ZCOB
C
        DOUBLE PRECISION DIST
C
        DATA DTOR /  .017453292519943D0 /
        DATA RTOD /  57.2957795130823D0 /
C
        DATA ALAT /  1.11701072128000D0 /
        DATA ALON / -2.65290046304000D0 /
C
        BLAT=GEOG(2)
        BLON=GEOG(1)

        CALT=COS(ALAT)
        SALT=SIN(ALAT)
        CALN=COS(ALON)
        SALN=SIN(ALON)
C
        CBLT=COS(BLAT)
        SBLT=SIN(BLAT)
        CBLN=COS(BLON)
        SBLN=SIN(BLON)
C
        XCOA=CALT*CALN
        YCOA=CALT*SALN
        ZCOA=SALT
C
        XCOB=CBLT*CBLN
        YCOB=CBLT*SBLN
        ZCOB=SBLT
C
        DIST=SQRT((XCOA-XCOB)**2+(YCOA-YCOB)**2+(ZCOA-ZCOB)**2)
C
        MDDADP=2.D0*RTOD*ASIN(DIST/2.D0)
C
        RETURN
C
      END

C
C $Id: nggcog.f,v 1.4 2008-07-27 00:17:17 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
C This is a modified version of nggcog.f that was generated using
C nag_apt to convert from single to double precision.
C
      SUBROUTINE DNGGCOG (CLAT,CLON,CRAD,ALAT,ALON,NPTS)
      DOUBLE PRECISION CLAT
      DOUBLE PRECISION CLON
      DOUBLE PRECISION CRAD
      DOUBLE PRECISION ALAT
      DOUBLE PRECISION ALON
      DOUBLE PRECISION DTOR
      DOUBLE PRECISION RTOD
      DOUBLE PRECISION RLAT
      DOUBLE PRECISION RLON
      DOUBLE PRECISION UCRD
      DOUBLE PRECISION VCRD
      DOUBLE PRECISION WCRD
C
C This routine returns, in the arrays ALAT and ALON, the latitudes and
C longitudes of NPTS points on the surface of the globe, all of them at
C the great-circle distance CRAD from the point (CLAT,CLON), defining a
C circle.  The last point returned is a copy of the first.
C
        DIMENSION ALAT(*),ALON(*)
C
C Define multiplicative constants to convert from degrees to radians
C and from radians to degrees.
C
        DATA DTOR / .017453292519943D0 /
        DATA RTOD / 57.2957795130823D0 /
C
C Points on a circle around the North Pole are rotated to lie around
C the point at latitude CLAT and longitude CLON.
C
        RLAT=DTOR*(90.D0-CRAD)
C
        DO 101 IPNT=1,NPTS
          RLON=DTOR*360.D0*(DBLE(IPNT-1)/DBLE(NPTS-1))
          UCRD=COS(RLAT)*COS(RLON)
          VCRD=COS(RLAT)*SIN(RLON)
          WCRD=SIN(RLAT)
          CALL DNGRITD (2,90.D0-CLAT,UCRD,VCRD,WCRD)
          CALL DNGRITD (3,      CLON,UCRD,VCRD,WCRD)
          ALAT(IPNT)=RTOD*ASIN(WCRD)
          ALON(IPNT)=RTOD*ATAN2(VCRD,UCRD)
  101   CONTINUE
C
C Done.
C
        RETURN
C
      END

C
C $Id: pj09dp.f,v 1.5 2008-07-27 00:17:10 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE PJ09DP (COORD,CRDIO,INDIC)
C
C -- T R A N S V E R S E   M E R C A T O R
C
      IMPLICIT DOUBLE PRECISION (A-Z)
      INTEGER I,IND,NIT
      INTEGER INDIC
      DIMENSION GEOG(2),PROJ(2),COORD(2),CRDIO(2)
C **** PARAMETERS ** A,E,ES,KS0,LON0,LAT0,X0,Y0,E0,E1,E2,E3,ESP,ML0,IND
      COMMON /ERRMZ0/ IERR
        INTEGER IERR
      SAVE   /ERRMZ0/
      COMMON /PRINZ0/ IPEMSG,IPELUN,IPPARM,IPPLUN
        INTEGER IPEMSG,IPELUN,IPPARM,IPPLUN
      SAVE   /PRINZ0/
      COMMON /PC09DP/ A,LON0,X0,Y0,ES,ESP,E0,E1,E2,E3,KS0,LAT0,ML0,IND
      DATA ZERO,HALF,ONE,TWO,THREE /0.0D0,0.5D0,1.0D0,2.0D0,3.0D0/
      DATA FOUR,FIVE,SIX,EIGHT,NINE /4.0D0,5.0D0,6.0D0,8.0D0,9.0D0/
      DATA HALFPI /1.5707963267948966D0/
      DATA TEN /10.0D0/
      DATA EPSLN,NIT /1.0D-10,6/
C
C -- F O R W A R D   . . .
C
      IF (INDIC .EQ. 0) THEN
C
         GEOG(1) = COORD(1)
         GEOG(2) = COORD(2)
         IERR = 0
         DLON = ADJLDP (GEOG(1) - LON0)
         LAT = GEOG(2)
         IF (IND .EQ. 0) GO TO 240
         COSPHI = COS (LAT)
         B = COSPHI * SIN (DLON)
         IF (ABS(ABS(B) - ONE) .GT. EPSLN) GO TO 230
         IF (IPEMSG .EQ. 0) WRITE (IPELUN,2020)
 2020    FORMAT (/' ERROR PJ09DP'/
     .            ' POINT PROJECTS INTO INFINITY')
         IERR = 093
         RETURN
  230    PROJ(1) = HALF * A * KS0 * LOG ((ONE + B) / (ONE - B)) + X0
         CON=ACOS(MAX(-ONE,MIN(ONE,COSPHI*COS(DLON)/
     +                                        SQRT(MAX(ZERO,ONE-B*B)))))
         IF (LAT .LT. ZERO) CON =-CON
         PROJ(2) = A * KS0 * (CON - LAT0) + Y0
         CRDIO(1) = PROJ(1)
         CRDIO(2) = PROJ(2)
         RETURN
C
  240    SINPHI = SIN (LAT)
         COSPHI = COS (LAT)
         AL = COSPHI * DLON
         ALS = AL * AL
         C = ESP * COSPHI * COSPHI
         TQ = TAN (LAT)
         T = TQ * TQ
         N = A / SQRT (ONE - ES * SINPHI * SINPHI)
         ML = A * MLFNDP (E0,E1,E2,E3,LAT)
         PROJ(1) = KS0 * N * AL * (ONE + ALS / SIX * (ONE - T + C +
     .             ALS / 20.0D0 * (FIVE - 18.0D0 * T + T * T + 72.0D0 *
     .             C - 58.0D0 * ESP))) + X0
         PROJ(2) = KS0 *(ML - ML0 + N * TQ *(ALS *(HALF + ALS / 24.0D0 *
     .             (FIVE - T + NINE * C + FOUR * C * C + ALS / 30.0D0 *
     .             (61.0D0 - 58.0D0 * T + T * T + 600.0D0 * C -
     .             330.0D0 * ESP))))) + Y0
         CRDIO(1) = PROJ(1)
         CRDIO(2) = PROJ(2)
         RETURN
      END IF
C
C -- I N V E R S E   . . .
C
      IF (INDIC .EQ. 1) THEN
C
         PROJ(1) = COORD(1)
         PROJ(2) = COORD(2)
         IERR = 0
         X = PROJ(1) - X0
         Y = PROJ(2) - Y0
         IF (IND .EQ. 0) GO TO 340
         F = EXP (X / (A * KS0))
         G = HALF * (F - ONE / F)
         TEMP = LAT0 + Y / (A * KS0)
         H = COS (TEMP)
         CON = SQRT ((ONE - H * H) / (ONE + G * G))
         GEOG(2) = ASINDP (CON)
         IF (TEMP .LT. ZERO) GEOG(2) =-GEOG(2)
         IF (G.NE.ZERO .OR. H.NE.ZERO) GO TO 330
         GEOG(1) = LON0
         CRDIO(1) = GEOG(1)
         CRDIO(2) = GEOG(2)
         RETURN
  330    GEOG(1) = ADJLDP (ATAN2 (G,H) + LON0)
         CRDIO(1) = GEOG(1)
         CRDIO(2) = GEOG(2)
         RETURN
C
  340    CON = (ML0 + Y / KS0) / A
         PHI = CON
         DO 360 I = 1,NIT
         DPHI = ((CON + E1 * SIN (TWO * PHI) - E2 * SIN (FOUR * PHI)
     .          + E3 * SIN (SIX * PHI)) / E0) - PHI
         PHI = PHI + DPHI
         IF (ABS(DPHI) .LE. EPSLN) GO TO 380
  360    CONTINUE
         IF (IPEMSG .EQ. 0) WRITE (IPELUN,2030) NIT
 2030    FORMAT (/' ERROR PJ09DP' /
     .            ' LATITUDE FAILED TO CONVERGE AFTER',I3,' ITERATIONS')
         IERR = 095
         RETURN
  380    IF (ABS(PHI) .LT. HALFPI) GO TO 400
         GEOG(2) = SIGN (HALFPI , Y)
         GEOG(1) = LON0
         CRDIO(1) = GEOG(1)
         CRDIO(2) = GEOG(2)
         RETURN
  400    SINPHI = SIN (PHI)
         COSPHI = COS (PHI)
         TANPHI = TAN (PHI)
         C = ESP * COSPHI * COSPHI
         CS = C * C
         T = TANPHI * TANPHI
         TS = T * T
         CON = ONE - ES * SINPHI * SINPHI
         N = A / SQRT (CON)
         R = N * (ONE - ES) / CON
         D = X / (N * KS0)
         DS = D * D
         GEOG(2) = PHI - (N * TANPHI * DS / R) * (HALF - DS / 24.0D0 *
     .             (FIVE + THREE * T + TEN * C - FOUR * CS - NINE * ESP
     .             - DS / 30.0D0 * (61.0D0 + 90.0D0 * T + 298.0D0 * C +
     .             45.0D0 * TS - 252.0D0 * ESP - THREE * CS)))
         GEOG(1) = ADJLDP (LON0 + (D * (ONE - DS / SIX * (ONE + TWO *
     .             T + C - DS / 20.0D0 * (FIVE - TWO * C + 28.0D0 * T -
     .             THREE * CS + EIGHT * ESP + 24.0D0 * TS))) / COSPHI))
         CRDIO(1) = GEOG(1)
         CRDIO(2) = GEOG(2)
         RETURN
      END IF
C
      END

C
C $Id: maproj.f,v 1.21 2008-09-18 00:42:16 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MAPROJ (ARG1,ARG2,ARG3,ARG4)
        CHARACTER*(*) ARG1
        REAL          ARG2,ARG3,ARG4
        IF (ICFELL('MAPROJ - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
        CALL MDPROJ (ARG1,DBLE(ARG2),DBLE(ARG3),DBLE(ARG4))
        IF (ICFELL('MAPROJ',2).NE.0) RETURN
        RETURN
      END

      SUBROUTINE SGEGS( JOBVSL, JOBVSR, N, A, LDA, B, LDB, ALPHAR,
     $                  ALPHAI, BETA, VSL, LDVSL, VSR, LDVSR, WORK,
     $                  LWORK, INFO )
*
*  -- LAPACK driver routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          JOBVSL, JOBVSR
      INTEGER            INFO, LDA, LDB, LDVSL, LDVSR, LWORK, N
*     ..
*     .. Array Arguments ..
      REAL               A( LDA, * ), ALPHAI( * ), ALPHAR( * ),
     $                   B( LDB, * ), BETA( * ), VSL( LDVSL, * ),
     $                   VSR( LDVSR, * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  This routine is deprecated and has been replaced by routine SGGES.
*
*  SGEGS computes for a pair of N-by-N real nonsymmetric matrices A, B:
*  the generalized eigenvalues (alphar +/- alphai*i, beta), the real
*  Schur form (A, B), and optionally left and/or right Schur vectors
*  (VSL and VSR).
*
*  (If only the generalized eigenvalues are needed, use the driver SGEGV
*  instead.)
*
*  A generalized eigenvalue for a pair of matrices (A,B) is, roughly
*  speaking, a scalar w or a ratio  alpha/beta = w, such that  A - w*B
*  is singular.  It is usually represented as the pair (alpha,beta),
*  as there is a reasonable interpretation for beta=0, and even for
*  both being zero.  A good beginning reference is the book, "Matrix
*  Computations", by G. Golub & C. van Loan (Johns Hopkins U. Press)
*
*  The (generalized) Schur form of a pair of matrices is the result of
*  multiplying both matrices on the left by one orthogonal matrix and
*  both on the right by another orthogonal matrix, these two orthogonal
*  matrices being chosen so as to bring the pair of matrices into
*  (real) Schur form.
*
*  A pair of matrices A, B is in generalized real Schur form if B is
*  upper triangular with non-negative diagonal and A is block upper
*  triangular with 1-by-1 and 2-by-2 blocks.  1-by-1 blocks correspond
*  to real generalized eigenvalues, while 2-by-2 blocks of A will be
*  "standardized" by making the corresponding elements of B have the
*  form:
*          [  a  0  ]
*          [  0  b  ]
*
*  and the pair of corresponding 2-by-2 blocks in A and B will
*  have a complex conjugate pair of generalized eigenvalues.
*
*  The left and right Schur vectors are the columns of VSL and VSR,
*  respectively, where VSL and VSR are the orthogonal matrices
*  which reduce A and B to Schur form:
*
*  Schur form of (A,B) = ( (VSL)**T A (VSR), (VSL)**T B (VSR) )
*
*  Arguments
*  =========
*
*  JOBVSL  (input) CHARACTER*1
*          = 'N':  do not compute the left Schur vectors;
*          = 'V':  compute the left Schur vectors.
*
*  JOBVSR  (input) CHARACTER*1
*          = 'N':  do not compute the right Schur vectors;
*          = 'V':  compute the right Schur vectors.
*
*  N       (input) INTEGER
*          The order of the matrices A, B, VSL, and VSR.  N >= 0.
*
*  A       (input/output) REAL array, dimension (LDA, N)
*          On entry, the first of the pair of matrices whose generalized
*          eigenvalues and (optionally) Schur vectors are to be
*          computed.
*          On exit, the generalized Schur form of A.
*          Note: to avoid overflow, the Frobenius norm of the matrix
*          A should be less than the overflow threshold.
*
*  LDA     (input) INTEGER
*          The leading dimension of A.  LDA >= max(1,N).
*
*  B       (input/output) REAL array, dimension (LDB, N)
*          On entry, the second of the pair of matrices whose
*          generalized eigenvalues and (optionally) Schur vectors are
*          to be computed.
*          On exit, the generalized Schur form of B.
*          Note: to avoid overflow, the Frobenius norm of the matrix
*          B should be less than the overflow threshold.
*
*  LDB     (input) INTEGER
*          The leading dimension of B.  LDB >= max(1,N).
*
*  ALPHAR  (output) REAL array, dimension (N)
*  ALPHAI  (output) REAL array, dimension (N)
*  BETA    (output) REAL array, dimension (N)
*          On exit, (ALPHAR(j) + ALPHAI(j)*i)/BETA(j), j=1,...,N, will
*          be the generalized eigenvalues.  ALPHAR(j) + ALPHAI(j)*i,
*          j=1,...,N  and  BETA(j),j=1,...,N  are the diagonals of the
*          complex Schur form (A,B) that would result if the 2-by-2
*          diagonal blocks of the real Schur form of (A,B) were further
*          reduced to triangular form using 2-by-2 complex unitary
*          transformations.  If ALPHAI(j) is zero, then the j-th
*          eigenvalue is real; if positive, then the j-th and (j+1)-st
*          eigenvalues are a complex conjugate pair, with ALPHAI(j+1)
*          negative.
*
*          Note: the quotients ALPHAR(j)/BETA(j) and ALPHAI(j)/BETA(j)
*          may easily over- or underflow, and BETA(j) may even be zero.
*          Thus, the user should avoid naively computing the ratio
*          alpha/beta.  However, ALPHAR and ALPHAI will be always less
*          than and usually comparable with norm(A) in magnitude, and
*          BETA always less than and usually comparable with norm(B).
*
*  VSL     (output) REAL array, dimension (LDVSL,N)
*          If JOBVSL = 'V', VSL will contain the left Schur vectors.
*          (See "Purpose", above.)
*          Not referenced if JOBVSL = 'N'.
*
*  LDVSL   (input) INTEGER
*          The leading dimension of the matrix VSL. LDVSL >=1, and
*          if JOBVSL = 'V', LDVSL >= N.
*
*  VSR     (output) REAL array, dimension (LDVSR,N)
*          If JOBVSR = 'V', VSR will contain the right Schur vectors.
*          (See "Purpose", above.)
*          Not referenced if JOBVSR = 'N'.
*
*  LDVSR   (input) INTEGER
*          The leading dimension of the matrix VSR. LDVSR >= 1, and
*          if JOBVSR = 'V', LDVSR >= N.
*
*  WORK    (workspace/output) REAL array, dimension (LWORK)
*          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*
*  LWORK   (input) INTEGER
*          The dimension of the array WORK.  LWORK >= max(1,4*N).
*          For good performance, LWORK must generally be larger.
*          To compute the optimal value of LWORK, call ILAENV to get
*          blocksizes (for SGEQRF, SORMQR, and SORGQR.)  Then compute:
*          NB  -- MAX of the blocksizes for SGEQRF, SORMQR, and SORGQR
*          The optimal LWORK is  2*N + N*(NB+1).
*
*          If LWORK = -1, then a workspace query is assumed; the routine
*          only calculates the optimal size of the WORK array, returns
*          this value as the first entry of the WORK array, and no error
*          message related to LWORK is issued by XERBLA.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value.
*          = 1,...,N:
*                The QZ iteration failed.  (A,B) are not in Schur
*                form, but ALPHAR(j), ALPHAI(j), and BETA(j) should
*                be correct for j=INFO+1,...,N.
*          > N:  errors that usually indicate LAPACK problems:
*                =N+1: error return from SGGBAL
*                =N+2: error return from SGEQRF
*                =N+3: error return from SORMQR
*                =N+4: error return from SORGQR
*                =N+5: error return from SGGHRD
*                =N+6: error return from SHGEQZ (other than failed
*                                                iteration)
*                =N+7: error return from SGGBAK (computing VSL)
*                =N+8: error return from SGGBAK (computing VSR)
*                =N+9: error return from SLASCL (various places)
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ZERO, ONE
      PARAMETER          ( ZERO = 0.0E0, ONE = 1.0E0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            ILASCL, ILBSCL, ILVSL, ILVSR, LQUERY
      INTEGER            ICOLS, IHI, IINFO, IJOBVL, IJOBVR, ILEFT,
     $                   ILO, IRIGHT, IROWS, ITAU, IWORK, LOPT, LWKMIN,
     $                   LWKOPT, NB, NB1, NB2, NB3
      REAL               ANRM, ANRMTO, BIGNUM, BNRM, BNRMTO, EPS,
     $                   SAFMIN, SMLNUM
*     ..
*     .. External Subroutines ..
      EXTERNAL           SGEQRF, SGGBAK, SGGBAL, SGGHRD, SHGEQZ, SLACPY,
     $                   SLASCL, SLASET, SORGQR, SORMQR, XERBLA
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            ILAENV
      REAL               SLAMCH, SLANGE
      EXTERNAL           ILAENV, LSAME, SLAMCH, SLANGE
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          INT, MAX
*     ..
*     .. Executable Statements ..
*
*     Decode the input arguments
*
      IF( LSAME( JOBVSL, 'N' ) ) THEN
         IJOBVL = 1
         ILVSL = .FALSE.
      ELSE IF( LSAME( JOBVSL, 'V' ) ) THEN
         IJOBVL = 2
         ILVSL = .TRUE.
      ELSE
         IJOBVL = -1
         ILVSL = .FALSE.
      END IF
*
      IF( LSAME( JOBVSR, 'N' ) ) THEN
         IJOBVR = 1
         ILVSR = .FALSE.
      ELSE IF( LSAME( JOBVSR, 'V' ) ) THEN
         IJOBVR = 2
         ILVSR = .TRUE.
      ELSE
         IJOBVR = -1
         ILVSR = .FALSE.
      END IF
*
*     Test the input arguments
*
      LWKMIN = MAX( 4*N, 1 )
      LWKOPT = LWKMIN
      WORK( 1 ) = LWKOPT
      LQUERY = ( LWORK.EQ.-1 )
      INFO = 0
      IF( IJOBVL.LE.0 ) THEN
         INFO = -1
      ELSE IF( IJOBVR.LE.0 ) THEN
         INFO = -2
      ELSE IF( N.LT.0 ) THEN
         INFO = -3
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -5
      ELSE IF( LDB.LT.MAX( 1, N ) ) THEN
         INFO = -7
      ELSE IF( LDVSL.LT.1 .OR. ( ILVSL .AND. LDVSL.LT.N ) ) THEN
         INFO = -12
      ELSE IF( LDVSR.LT.1 .OR. ( ILVSR .AND. LDVSR.LT.N ) ) THEN
         INFO = -14
      ELSE IF( LWORK.LT.LWKMIN .AND. .NOT.LQUERY ) THEN
         INFO = -16
      END IF
*
      IF( INFO.EQ.0 ) THEN
         NB1 = ILAENV( 1, 'SGEQRF', ' ', N, N, -1, -1 )
         NB2 = ILAENV( 1, 'SORMQR', ' ', N, N, N, -1 )
         NB3 = ILAENV( 1, 'SORGQR', ' ', N, N, N, -1 )
         NB = MAX( NB1, NB2, NB3 )
         LOPT = 2*N+N*(NB+1)
         WORK( 1 ) = LOPT
      END IF
*
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'SGEGS ', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
*
*     Get machine constants
*
      EPS = SLAMCH( 'E' )*SLAMCH( 'B' )
      SAFMIN = SLAMCH( 'S' )
      SMLNUM = N*SAFMIN / EPS
      BIGNUM = ONE / SMLNUM
*
*     Scale A if max element outside range [SMLNUM,BIGNUM]
*
      ANRM = SLANGE( 'M', N, N, A, LDA, WORK )
      ILASCL = .FALSE.
      IF( ANRM.GT.ZERO .AND. ANRM.LT.SMLNUM ) THEN
         ANRMTO = SMLNUM
         ILASCL = .TRUE.
      ELSE IF( ANRM.GT.BIGNUM ) THEN
         ANRMTO = BIGNUM
         ILASCL = .TRUE.
      END IF
*
      IF( ILASCL ) THEN
         CALL SLASCL( 'G', -1, -1, ANRM, ANRMTO, N, N, A, LDA, IINFO )
         IF( IINFO.NE.0 ) THEN
            INFO = N + 9
            RETURN
         END IF
      END IF
*
*     Scale B if max element outside range [SMLNUM,BIGNUM]
*
      BNRM = SLANGE( 'M', N, N, B, LDB, WORK )
      ILBSCL = .FALSE.
      IF( BNRM.GT.ZERO .AND. BNRM.LT.SMLNUM ) THEN
         BNRMTO = SMLNUM
         ILBSCL = .TRUE.
      ELSE IF( BNRM.GT.BIGNUM ) THEN
         BNRMTO = BIGNUM
         ILBSCL = .TRUE.
      END IF
*
      IF( ILBSCL ) THEN
         CALL SLASCL( 'G', -1, -1, BNRM, BNRMTO, N, N, B, LDB, IINFO )
         IF( IINFO.NE.0 ) THEN
            INFO = N + 9
            RETURN
         END IF
      END IF
*
*     Permute the matrix to make it more nearly triangular
*     Workspace layout:  (2*N words -- "work..." not actually used)
*        left_permutation, right_permutation, work...
*
      ILEFT = 1
      IRIGHT = N + 1
      IWORK = IRIGHT + N
      CALL SGGBAL( 'P', N, A, LDA, B, LDB, ILO, IHI, WORK( ILEFT ),
     $             WORK( IRIGHT ), WORK( IWORK ), IINFO )
      IF( IINFO.NE.0 ) THEN
         INFO = N + 1
         GO TO 10
      END IF
*
*     Reduce B to triangular form, and initialize VSL and/or VSR
*     Workspace layout:  ("work..." must have at least N words)
*        left_permutation, right_permutation, tau, work...
*
      IROWS = IHI + 1 - ILO
      ICOLS = N + 1 - ILO
      ITAU = IWORK
      IWORK = ITAU + IROWS
      CALL SGEQRF( IROWS, ICOLS, B( ILO, ILO ), LDB, WORK( ITAU ),
     $             WORK( IWORK ), LWORK+1-IWORK, IINFO )
      IF( IINFO.GE.0 )
     $   LWKOPT = MAX( LWKOPT, INT( WORK( IWORK ) )+IWORK-1 )
      IF( IINFO.NE.0 ) THEN
         INFO = N + 2
         GO TO 10
      END IF
*
      CALL SORMQR( 'L', 'T', IROWS, ICOLS, IROWS, B( ILO, ILO ), LDB,
     $             WORK( ITAU ), A( ILO, ILO ), LDA, WORK( IWORK ),
     $             LWORK+1-IWORK, IINFO )
      IF( IINFO.GE.0 )
     $   LWKOPT = MAX( LWKOPT, INT( WORK( IWORK ) )+IWORK-1 )
      IF( IINFO.NE.0 ) THEN
         INFO = N + 3
         GO TO 10
      END IF
*
      IF( ILVSL ) THEN
         CALL SLASET( 'Full', N, N, ZERO, ONE, VSL, LDVSL )
         CALL SLACPY( 'L', IROWS-1, IROWS-1, B( ILO+1, ILO ), LDB,
     $                VSL( ILO+1, ILO ), LDVSL )
         CALL SORGQR( IROWS, IROWS, IROWS, VSL( ILO, ILO ), LDVSL,
     $                WORK( ITAU ), WORK( IWORK ), LWORK+1-IWORK,
     $                IINFO )
         IF( IINFO.GE.0 )
     $      LWKOPT = MAX( LWKOPT, INT( WORK( IWORK ) )+IWORK-1 )
         IF( IINFO.NE.0 ) THEN
            INFO = N + 4
            GO TO 10
         END IF
      END IF
*
      IF( ILVSR )
     $   CALL SLASET( 'Full', N, N, ZERO, ONE, VSR, LDVSR )
*
*     Reduce to generalized Hessenberg form
*
      CALL SGGHRD( JOBVSL, JOBVSR, N, ILO, IHI, A, LDA, B, LDB, VSL,
     $             LDVSL, VSR, LDVSR, IINFO )
      IF( IINFO.NE.0 ) THEN
         INFO = N + 5
         GO TO 10
      END IF
*
*     Perform QZ algorithm, computing Schur vectors if desired
*     Workspace layout:  ("work..." must have at least 1 word)
*        left_permutation, right_permutation, work...
*
      IWORK = ITAU
      CALL SHGEQZ( 'S', JOBVSL, JOBVSR, N, ILO, IHI, A, LDA, B, LDB,
     $             ALPHAR, ALPHAI, BETA, VSL, LDVSL, VSR, LDVSR,
     $             WORK( IWORK ), LWORK+1-IWORK, IINFO )
      IF( IINFO.GE.0 )
     $   LWKOPT = MAX( LWKOPT, INT( WORK( IWORK ) )+IWORK-1 )
      IF( IINFO.NE.0 ) THEN
         IF( IINFO.GT.0 .AND. IINFO.LE.N ) THEN
            INFO = IINFO
         ELSE IF( IINFO.GT.N .AND. IINFO.LE.2*N ) THEN
            INFO = IINFO - N
         ELSE
            INFO = N + 6
         END IF
         GO TO 10
      END IF
*
*     Apply permutation to VSL and VSR
*
      IF( ILVSL ) THEN
         CALL SGGBAK( 'P', 'L', N, ILO, IHI, WORK( ILEFT ),
     $                WORK( IRIGHT ), N, VSL, LDVSL, IINFO )
         IF( IINFO.NE.0 ) THEN
            INFO = N + 7
            GO TO 10
         END IF
      END IF
      IF( ILVSR ) THEN
         CALL SGGBAK( 'P', 'R', N, ILO, IHI, WORK( ILEFT ),
     $                WORK( IRIGHT ), N, VSR, LDVSR, IINFO )
         IF( IINFO.NE.0 ) THEN
            INFO = N + 8
            GO TO 10
         END IF
      END IF
*
*     Undo scaling
*
      IF( ILASCL ) THEN
         CALL SLASCL( 'H', -1, -1, ANRMTO, ANRM, N, N, A, LDA, IINFO )
         IF( IINFO.NE.0 ) THEN
            INFO = N + 9
            RETURN
         END IF
         CALL SLASCL( 'G', -1, -1, ANRMTO, ANRM, N, 1, ALPHAR, N,
     $                IINFO )
         IF( IINFO.NE.0 ) THEN
            INFO = N + 9
            RETURN
         END IF
         CALL SLASCL( 'G', -1, -1, ANRMTO, ANRM, N, 1, ALPHAI, N,
     $                IINFO )
         IF( IINFO.NE.0 ) THEN
            INFO = N + 9
            RETURN
         END IF
      END IF
*
      IF( ILBSCL ) THEN
         CALL SLASCL( 'U', -1, -1, BNRMTO, BNRM, N, N, B, LDB, IINFO )
         IF( IINFO.NE.0 ) THEN
            INFO = N + 9
            RETURN
         END IF
         CALL SLASCL( 'G', -1, -1, BNRMTO, BNRM, N, 1, BETA, N, IINFO )
         IF( IINFO.NE.0 ) THEN
            INFO = N + 9
            RETURN
         END IF
      END IF
*
   10 CONTINUE
      WORK( 1 ) = LWKOPT
*
      RETURN
*
*     End of SGEGS
*
      END

C
C	$Id: gupdva.f,v 1.8 2008-07-27 00:21:06 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GUPDVA
C
C  Update all attribute deferral variables.
C
      include 'g01prm.h'
      include 'gksin.h'
      include 'g01rqa.h'
      include 'g01ast.h'
      include 'g01adc.h'
C
      INTEGER  IPRIM, I, IOFF, JOFF, J
C
C  Copy default attribute context to "SET" context.
C
      CALL G01D2S
C
C  Go through the attribute structures G01RQA and G01AST to
C  reset the attribute context variables.
C
C  POLYLINE attributes.
C
      IPRIM = 1
      AGPEND(IPRIM) = .FALSE.
      DO 100 I=IVPLIX,IVPLCI
        IOFF = ABS(IP2AEA(I))
C
C  Is the requested value different from the sent?
C  The following code reflects the fact that all attribute
C  variables for POLYLINE are stored contiguously.
C
        IF (IP2AEA(I) .GT. 0) THEN
          VALCHG(I) = MSAEQV(IOFF).NE.MRAEQV(IOFF)
        ELSE
          VALCHG(I) = ASAEQV(IOFF).NE.ARAEQV(IOFF)
        ENDIF
C
C  Update aggregate change parameter.
C
        AGPEND(IPRIM) = AGPEND(IPRIM) .OR. VALCHG(I)
  100 CONTINUE
C
C  POLYMARKER attributes.
C
      IPRIM = 2
      AGPEND(IPRIM) = .FALSE.
      DO 140 I=IVPMIX,IVPMCI
        IOFF = ABS(IP2AEA(I))
C
C  IS THE REQUESTED VALUE DIFFERENT FROM THE SENT?
C  THE FOLLOWING CODE REFLECTS THE FACT THAT ALL ATTRIBUTE
C  VARIABLES FOR POLYMARKER ARE STORED CONTIGUOUSLY.
C
        IF (IP2AEA(I) .GT. 0) THEN
          VALCHG(I) = MSAEQV(IOFF).NE.MRAEQV(IOFF)
        ELSE
          VALCHG(I) = ASAEQV(IOFF).NE.ARAEQV(IOFF)
        ENDIF
C
C  UPDATE AGGREGATE CHANGE PARAMETER.
C
        AGPEND(IPRIM) = AGPEND(IPRIM) .OR. VALCHG(I)
C
  140 CONTINUE
C
C     TEXT ATTRIBUTES
C
      IPRIM = 3
      AGPEND(IPRIM) = .FALSE.
      DO 150 I=IVTXIX,IVTXCI
C
         IOFF = ABS(IP2AEA(I))
         JOFF = IOFF + IL2AEA(I) - 1
C
C        IS THE REQUESTED VALUE DIFFERENT FROM THE SENT?
C
         IF (IP2AEA(I) .GT. 0) THEN
            VALCHG(I) = MSAEQV(IOFF).NE.MRAEQV(IOFF)
            DO 110 J=IOFF+1,JOFF
               VALCHG(I) = VALCHG(I) .OR. MSAEQV(J).NE.MRAEQV(J)
  110       CONTINUE
         ELSE
            VALCHG(I) = ASAEQV(IOFF).NE.ARAEQV(IOFF)
            DO 120 J=IOFF+1,JOFF
               VALCHG(I) = VALCHG(I) .OR. ASAEQV(J).NE.ARAEQV(J)
  120       CONTINUE
         ENDIF
C
C        UPDATE AGGREGATE CHANGE PARAMETER.
C
         AGPEND(IPRIM) = AGPEND(IPRIM) .OR. VALCHG(I)
C
  150 CONTINUE
C
C     FILL AREA ATTRIBUTES
C
      IPRIM = 4
      AGPEND(IPRIM) = .FALSE.
      DO 160 I=IVFAIX,IVFACI
C
         IOFF = ABS(IP2AEA(I))
         JOFF = IOFF + IL2AEA(I) - 1
C
C        IS THE REQUESTED VALUE DIFFERENT FROM THE SENT?
C
         IF (IP2AEA(I) .GT. 0) THEN
            VALCHG(I) = MSAEQV(IOFF).NE.MRAEQV(IOFF)
            DO 170 J=IOFF+1,JOFF
               VALCHG(I) = VALCHG(I) .OR. MSAEQV(J).NE.MRAEQV(J)
  170       CONTINUE
         ELSE
            VALCHG(I) = ASAEQV(IOFF).NE.ARAEQV(IOFF)
            DO 180 J=IOFF+1,JOFF
               VALCHG(I) = VALCHG(I) .OR. ASAEQV(J).NE.ARAEQV(J)
  180       CONTINUE
         ENDIF
C
C        UPDATE AGGREGATE CHANGE PARAMETER.
C
         AGPEND(IPRIM) = AGPEND(IPRIM) .OR. VALCHG(I)
  160 CONTINUE
C
C  Update aspect source flag context (ID contains the GKS Aspect
C  Source Flag values which are the complements of the CGM values
C  that MRASF contains).
C
      DO 190 I=1,13
         ID(I) = 1-MRASF(I)
  190 CONTINUE
      CALL GUPASF
C
C     DONE.
C
      RETURN
C
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C   FFTPACK 5.0
C   Copyright (C) 1995-2004, Scientific Computing Division,
C   University Corporation for Atmospheric Research
C   Licensed under the GNU General Public License (GPL)
C
C   Authors:  Paul N. Swarztrauber and Richard A. Valent
C
C   $Id: cmf3kb.f,v 1.2 2006-11-21 01:10:16 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      SUBROUTINE DCMF3KB(LOT,IDO,L1,NA,CC,IM1,IN1,CH,IM2,IN2,WA)
      DOUBLE PRECISION TAUR
      DOUBLE PRECISION TAUI
      DOUBLE PRECISION TR2
      DOUBLE PRECISION CR2
      DOUBLE PRECISION TI2
      DOUBLE PRECISION CI2
      DOUBLE PRECISION CR3
      DOUBLE PRECISION CI3
      DOUBLE PRECISION DR2
      DOUBLE PRECISION DR3
      DOUBLE PRECISION DI2
      DOUBLE PRECISION DI3
      DOUBLE PRECISION CC(2,IN1,L1,IDO,3),CH(2,IN2,L1,3,IDO),WA(IDO,2,2)
      DATA TAUR,TAUI/-.5D0,.866025403784439D0/
C
      M1D = (LOT-1)*IM1 + 1
      M2S = 1 - IM2
      IF (IDO.GT.1 .OR. NA.EQ.1) GO TO 102
      DO 101 K = 1,L1
          DO 101 M1 = 1,M1D,IM1
              TR2 = CC(1,M1,K,1,2) + CC(1,M1,K,1,3)
              CR2 = CC(1,M1,K,1,1) + TAUR*TR2
              CC(1,M1,K,1,1) = CC(1,M1,K,1,1) + TR2
              TI2 = CC(2,M1,K,1,2) + CC(2,M1,K,1,3)
              CI2 = CC(2,M1,K,1,1) + TAUR*TI2
              CC(2,M1,K,1,1) = CC(2,M1,K,1,1) + TI2
              CR3 = TAUI* (CC(1,M1,K,1,2)-CC(1,M1,K,1,3))
              CI3 = TAUI* (CC(2,M1,K,1,2)-CC(2,M1,K,1,3))
              CC(1,M1,K,1,2) = CR2 - CI3
              CC(1,M1,K,1,3) = CR2 + CI3
              CC(2,M1,K,1,2) = CI2 + CR3
              CC(2,M1,K,1,3) = CI2 - CR3
  101 CONTINUE
      RETURN
  102 DO 103 K = 1,L1
          M2 = M2S
          DO 103 M1 = 1,M1D,IM1
              M2 = M2 + IM2
              TR2 = CC(1,M1,K,1,2) + CC(1,M1,K,1,3)
              CR2 = CC(1,M1,K,1,1) + TAUR*TR2
              CH(1,M2,K,1,1) = CC(1,M1,K,1,1) + TR2
              TI2 = CC(2,M1,K,1,2) + CC(2,M1,K,1,3)
              CI2 = CC(2,M1,K,1,1) + TAUR*TI2
              CH(2,M2,K,1,1) = CC(2,M1,K,1,1) + TI2
              CR3 = TAUI* (CC(1,M1,K,1,2)-CC(1,M1,K,1,3))
              CI3 = TAUI* (CC(2,M1,K,1,2)-CC(2,M1,K,1,3))
              CH(1,M2,K,2,1) = CR2 - CI3
              CH(1,M2,K,3,1) = CR2 + CI3
              CH(2,M2,K,2,1) = CI2 + CR3
              CH(2,M2,K,3,1) = CI2 - CR3
  103 CONTINUE
      IF (IDO.EQ.1) RETURN
      DO 105 I = 2,IDO
          DO 104 K = 1,L1
              M2 = M2S
              DO 104 M1 = 1,M1D,IM1
                  M2 = M2 + IM2
                  TR2 = CC(1,M1,K,I,2) + CC(1,M1,K,I,3)
                  CR2 = CC(1,M1,K,I,1) + TAUR*TR2
                  CH(1,M2,K,1,I) = CC(1,M1,K,I,1) + TR2
                  TI2 = CC(2,M1,K,I,2) + CC(2,M1,K,I,3)
                  CI2 = CC(2,M1,K,I,1) + TAUR*TI2
                  CH(2,M2,K,1,I) = CC(2,M1,K,I,1) + TI2
                  CR3 = TAUI* (CC(1,M1,K,I,2)-CC(1,M1,K,I,3))
                  CI3 = TAUI* (CC(2,M1,K,I,2)-CC(2,M1,K,I,3))
                  DR2 = CR2 - CI3
                  DR3 = CR2 + CI3
                  DI2 = CI2 + CR3
                  DI3 = CI2 - CR3
                  CH(2,M2,K,2,I) = WA(I,1,1)*DI2 + WA(I,1,2)*DR2
                  CH(1,M2,K,2,I) = WA(I,1,1)*DR2 - WA(I,1,2)*DI2
                  CH(2,M2,K,3,I) = WA(I,2,1)*DI3 + WA(I,2,2)*DR3
                  CH(1,M2,K,3,I) = WA(I,2,1)*DR3 - WA(I,2,2)*DI3
  104     CONTINUE
  105 CONTINUE
      RETURN
      END

      PROGRAM CCPT2D
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Declare required data arrays and workspace arrays.
C
      PARAMETER(LMAP=100000,LWRK=1000,M=40,N=40)
      REAL ZDAT(M,N),RWRK(LWRK),XCRA(LWRK),YCRA(LWRK)
      INTEGER IWRK(LWRK),IAMA(LMAP), IAREA(2),IGRP(2)
C
C Declare the routine which will color the areas.
C
      EXTERNAL FILL
C
C Open GKS.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Turn off the clipping indicator.
C
      CALL GSCLIP (0)
C
C Force solid fill.
C
      CALL GSFAIS (1)
C
C Define color indices.
C
      CALL COLOR(IWKID)
C
C Retrieve an array of test data.
C
      DO 10, I=1,M
         READ (*,*) (ZDAT(I,J),J=1,N)
 10   CONTINUE
C
C Tell CONPACK to use 12 contour levels, splitting the range into 13
C equal bands, one for each of the 13 colors available.
C
      CALL CPSETI ('CLS - CONTOUR LEVEL SELECTION FLAG',-12)
C
C Draw smoothed plot to the right
C
      CALL CPSETR ('VPL - VIEWPORT LEFT',.51)
      CALL CPSETR ('VPR - VIEWPORT RIGHT',1.0)
C
C Set smoothing so that lines are very smooth
C
      CALL CPSETR ('T2D - TENSION ON 2D SPLINES',.0001)
C
C Initialize the drawing of the contour plot.
C
      CALL CPRECT (ZDAT,M,M,N,RWRK,LWRK,IWRK,LWRK)
C
C Initialize the area map and put the contour lines into it.
C
      CALL ARINAM (IAMA,LMAP)
      CALL CPCLAM (ZDAT,RWRK,IWRK,IAMA)
C
C Color the map.
C
      CALL ARSCAM (IAMA,XCRA,YCRA,LWRK,IAREA,IGRP,2,FILL)
C
C Put black contour lines over the colored map.
C
      CALL GSPLCI (0)
      CALL CPCLDR (ZDAT,RWRK,IWRK)
C
C Draw unsmoothed plot to the left
C
      CALL CPSETR ('VPL - VIEWPORT LEFT',0.0)
      CALL CPSETR ('VPR - VIEWPORT RIGHT',0.49)
C 
C Tell Conpack that we want no smoothing
C
      CALL CPSETR ('T2D - TENSION ON 2D SPLINES',0.)
C
C Initialize the drawing of the contour plot.
C
      CALL CPRECT (ZDAT,M,M,N,RWRK,LWRK,IWRK,LWRK)
C
C Initialize the area map and put the contour lines into it.
C
      CALL ARINAM (IAMA,LMAP)
      CALL CPCLAM (ZDAT,RWRK,IWRK,IAMA)
C
C Color the map.
C
      CALL ARSCAM (IAMA,XCRA,YCRA,LWRK,IAREA,IGRP,2,FILL)
C
C Put black contour lines over the colored map.
C
      CALL GSPLCI (0)
      CALL CPCLDR (ZDAT,RWRK,IWRK)
C
C Draw titles in white
C
      CALL GETSET(VPL,VPR,VPB,VPT,WL,WR,WB,WT,LOG)
      CALL SET(0.,1.,0.,1.,0.,1.,0.,1.,1)
      CALL GSPLCI (1)
      CALL PLCHHQ (.3,VPT+.015,'Unsmoothed Contours',.015,0.,0.)
      CALL PLCHHQ (.75,VPT+.015,'Over Smoothed Contours',.015,0.,0.)
C
C Advance the frame.
C
      CALL FRAME
C
C Close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
C Done.
C
      STOP
C
      END
      SUBROUTINE FILL (XCRA,YCRA,NCRA,IAREA,IGRP,NGRPS)
C
      REAL XCRA(NCRA),YCRA(NCRA)
      INTEGER IAREA(NGRPS),IGRP(NGRPS)
C
C Get area identifiers for contour levels and vertical strips.
C
      IFILL=0
      DO 101 I=1,NGRPS
         IF (IGRP(I).EQ.3) IFILL=IAREA(I)
 101  CONTINUE
C
C Fill 
C
      IF (IFILL.GT.0) THEN
         CALL GSFACI (IFILL+2)
         CALL GFA (NCRA-1,XCRA,YCRA)
      END IF
C
C Done.
C
      RETURN
C
      END

      SUBROUTINE GENDAT (DATA,IDIM,M,N,MLOW,MHGH,DLOW,DHGH)
C
C This is a routine to generate test data for two-dimensional graphics
C routines.  Given an array "DATA", dimensioned "IDIM x 1", it fills
C the sub-array ((DATA(I,J),I=1,M),J=1,N) with a two-dimensional field
C of data having approximately "MLOW" lows and "MHGH" highs, a minimum
C value of exactly "DLOW" and a maximum value of exactly "DHGH".
C
C "MLOW" and "MHGH" are each forced to be greater than or equal to 1
C and less than or equal to 25.
C
C The function used is a sum of exponentials.
C
      DIMENSION DATA(IDIM,1),CCNT(3,50)
C
      FOVM=9./REAL(M)
      FOVN=9./REAL(N)
C
      NLOW=MAX(1,MIN(25,MLOW))
      NHGH=MAX(1,MIN(25,MHGH))
      NCNT=NLOW+NHGH
C
      DO 101 K=1,NCNT
         CCNT(1,K)=1.+(REAL(M)-1.)*FRAN()
         CCNT(2,K)=1.+(REAL(N)-1.)*FRAN()
         IF (K.LE.NLOW) THEN
            CCNT(3,K)=-1.
         ELSE
            CCNT(3,K)=+1.
         END IF
 101  CONTINUE
C
      DMIN=+1.E36
      DMAX=-1.E36
      DO 104 J=1,N
         DO 103 I=1,M
            DATA(I,J)=.5*(DLOW+DHGH)
            DO 102 K=1,NCNT
               TEMP=-((FOVM*(REAL(I)-CCNT(1,K)))**2+
     +              (FOVN*(REAL(J)-CCNT(2,K)))**2)
               IF (TEMP.GE.-20.) DATA(I,J)=DATA(I,J)+
     +              .5*(DHGH-DLOW)*CCNT(3,K)*EXP(TEMP)
 102        CONTINUE
            DMIN=MIN(DMIN,DATA(I,J))
            DMAX=MAX(DMAX,DATA(I,J))
 103     CONTINUE
 104  CONTINUE
C
      DO 106 J=1,N
         DO 105 I=1,M
            DATA(I,J)=(DATA(I,J)-DMIN)/(DMAX-DMIN)*(DHGH-DLOW)+DLOW
 105     CONTINUE
 106  CONTINUE
C
      RETURN
C
      END
      FUNCTION FRAN ()
      DIMENSION RSEQ (100)
      SAVE ISEQ
      DATA RSEQ / .749,.973,.666,.804,.081,.483,.919,.903,.951,.960 ,
     +     .039,.269,.270,.756,.222,.478,.621,.063,.550,.798 ,
     +     .027,.569,.149,.697,.451,.738,.508,.041,.266,.249 ,
     +     .019,.191,.266,.625,.492,.940,.508,.406,.972,.311 ,
     +     .757,.378,.299,.536,.619,.844,.342,.295,.447,.499 ,
     +     .688,.193,.225,.520,.954,.749,.997,.693,.217,.273 ,
     +     .961,.948,.902,.104,.495,.257,.524,.100,.492,.347 ,
     +     .981,.019,.225,.806,.678,.710,.235,.600,.994,.758 ,
     +     .682,.373,.009,.469,.203,.730,.588,.603,.213,.495 ,
     +     .884,.032,.185,.127,.010,.180,.689,.354,.372,.429 /
      DATA ISEQ / 0 /
      ISEQ=MOD(ISEQ,100)+1
      FRAN=RSEQ(ISEQ)
      RETURN
      END
      SUBROUTINE COLOR(IWKID)
C
C Background color
C Black
C
      CALL GSCR(IWKID,0,0.,0.,0.)
C
C Foreground colors
C White
C
      CALL GSCR(IWKID, 1, 1.0, 1.0, 1.0)
C
C Aqua
C
      CALL GSCR(IWKID, 2, 0.0, 0.9, 1.0)
C
C Red1
C
      CALL GSCR(IWKID, 3, 0.9, 0.25, 0.0)
C
C OrangeRed1
C
      CALL GSCR(IWKID, 4, 1.0, 0.0, 0.2)
C
C Orange1
C
      CALL GSCR(IWKID, 5, 1.0, 0.65, 0.0)
C
C Yellow1
C
      CALL GSCR(IWKID, 6, 1.0, 1.0, 0.0)
C
C GreenYellow1
C
      CALL GSCR(IWKID, 7, 0.7, 1.0, 0.2)
C
C Chartreuse1
C
      CALL GSCR(IWKID, 8, 0.5, 1.0, 0.0)
C
C Celeste1
C
      CALL GSCR(IWKID, 9, 0.2, 1.0, 0.5)
C
C Green1
C
      CALL GSCR(IWKID, 10, 0.2, 0.8, 0.2)
C
C DeepSkyBlue1
C
      CALL GSCR(IWKID, 11, 0.0, 0.75, 1.0)
C
C RoyalBlue1
C
      CALL GSCR(IWKID, 12, 0.25, 0.45, 0.95)
C
C SlateBlue1
C
      CALL GSCR(IWKID, 13, 0.4, 0.35, 0.8)
C
C DarkViolet1
C
      CALL GSCR(IWKID, 14, 0.6, 0.0, 0.8)
C
C Orchid1
C
      CALL GSCR(IWKID, 15, 0.85, 0.45, 0.8)

      RETURN
      END

C
C	$Id: gswkwn.f,v 1.5 2008-07-27 00:21:02 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GSWKWN (WKID,XMIN,XMAX,YMIN,YMAX)
C
C  SET WORKSTATION WINDOW
C
      INTEGER ESWKWN
      PARAMETER (ESWKWN=54)
C
      include 'gkscom.h'
C
      INTEGER WKID
C
C  Check if GKS is in the proper state.
C
      CALL GZCKST(7,ESWKWN,IER)
      IF (IER .NE. 0) RETURN
C
C  Check if workstation identifier is valid.
C
      CALL GZCKWK(20,ESWKWN,WKID,IDUM,IER)
      IF (IER .NE. 0) RETURN
C
C  Check if the specified workstation is open.
C
      CALL GZCKWK(25,ESWKWN,WKID,IDUM,IER)
      IF (IER .NE. 0) RETURN
C
C  Check that the rectangle definition is valid.
C
      IF (XMAX.LE.XMIN .OR. YMAX.LE.YMIN) THEN
        ERS = 1
        CALL GERHND(51,ESWKWN,ERF)
        ERS = 0
        RETURN
      ENDIF
C
C  Check that the window lies in NDC space.
C
      IF (XMIN.LT.0. .OR. XMAX.GT.1. .OR.
     +    YMIN.LT.0. .OR. YMAX.GT.1.) THEN
        ERS = 1
        CALL GERHND(53,ESWKWN,ERF)
        ERS = 0
        RETURN
      ENDIF
C
C  Invoke the workstation interface.
C
C  Set the flag CUFLAG to indicate that the interface call should go
C  only to the specifically designated workstation.
C
      CUFLAG = WKID
      FCODE = 71
      CONT  = 0
      CALL GZROI(0)
      IL1  = 1
      IL2  = 1
      ID(1) = WKID
      RL1 = 2
      RL2 = 2
      RX(1) = XMIN
      RX(2) = XMAX
      RY(1) = YMIN
      RY(2) = YMAX
      CONT = 0
      CALL GZTOWK
      CUFLAG = -1
      IF (RERR .NE. 0) THEN
        ERS = 1
        CALL GERHND(RERR,ESWKWN,ERF)
        ERS = 0
      ENDIF
C
      RETURN
      END

C NCLFORTSTART
      SUBROUTINE DWGTAREAAVE2(T,WGT,MX,NY,TMSG,IFLAG,AVE)
      IMPLICIT NONE
      INTEGER MX,NY,IFLAG
      DOUBLE PRECISION T(MX,NY),WGT(MX,NY)
      DOUBLE PRECISION TMSG
      DOUBLE PRECISION AVE
C NCLEND

C NCL: aveX = wgt_AreaAve2(x,wgt,flag)

      INTEGER NL,ML,KMSG
      DOUBLE PRECISION SUMT,SUMW

C compute the weighted area average

C Nomenclature:
C INPUT:
C t      - 2D array
C wgt    - 2D array
C mx     - 1st [faster varying] dimension of "t" [eg, longitude]
C ny     - 2nd [slower varying] dimension of "t" [eg, latitude ]
C tmsg   - msg value
C iflag  - flag
C          =0 compute  average ignoring msg values
C          =1 if any msg data is encountered return as msg
c OUTPUT:
C ave    - area average

      SUMT = 0.0D0
      SUMW = 0.0D0
      KMSG = 0
      AVE = TMSG

      DO NL = 1,NY
          DO ML = 1,MX
              IF (T(ML,NL).NE.TMSG) THEN
                  SUMT = SUMT + T(ML,NL)*WGT(ML,NL)
                  SUMW = SUMW + WGT(ML,NL)
              ELSE
                  KMSG = KMSG + 1
              END IF
          END DO
c                                      return if user desired
          IF (IFLAG.EQ.1 .AND. KMSG.NE.0) RETURN
      END DO
c                                      compute wgted average
      IF (SUMW.NE.0.D0) THEN
          AVE = SUMT/SUMW
      END IF

      RETURN
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C   FFTPACK 5.0
C   Copyright (C) 1995-2004, Scientific Computing Division,
C   University Corporation for Atmospheric Research
C   Licensed under the GNU General Public License (GPL)
C
C   Authors:  Paul N. Swarztrauber and Richard A. Valent
C
C   $Id: mcfti1.f,v 1.2 2006-11-21 01:10:17 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      SUBROUTINE DMCFTI1(N,WA,FNF,FAC)
      DOUBLE PRECISION FNF
      DOUBLE PRECISION WA(*),FAC(*)
C
      CALL DFACTOR(N,NF,FAC)
      FNF = NF
      IW = 1
      L1 = 1
      DO 110 K1 = 1,NF
          IP = FAC(K1)
          L2 = L1*IP
          IDO = N/L2
          CALL DTABLES(IDO,IP,WA(IW))
          IW = IW + (IP-1)* (IDO+IDO)
          L1 = L2
  110 CONTINUE
      RETURN
      END

C
C $Id: pcgptr.f,v 1.10 2008-07-27 00:17:19 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE PCGPTR (KCHR,LCHR,INDX,NLCH,IPNT)
C
C This routine finds the character KCHR in the array LCHR, which has
C been sorted in ascending order, and returns the value of the index,
C from the parallel array INDX, in IPNT.
C
      CHARACTER*1 LCHR(NLCH),KCHR
      DIMENSION   INDX(NLCH)
C
C A binary-halving technique is used.  It is assumed that LCHR is short
C enough so that 10 steps will suffice; if KCHR is not found in that
C many steps, the search is stopped and IPNT, which is used to count
C down the steps, ends up zeroed to indicate what happened.
C
      IBOT=1
      ITOP=NLCH
      IPNT=10
      ITRY=ITOP
      GO TO 102
  101 IF (IPNT.EQ.0) GO TO 106
      IPNT=IPNT-1
      ITRY=(IBOT+ITOP)/2
  102 IF (ICHAR(LCHR(ITRY))-ICHAR(KCHR)) 103,105,104
  103 IBOT=ITRY
      GO TO 101
  104 ITOP=ITRY
      GO TO 101
  105 IPNT=INDX(ITRY)
C
C Done.
C
  106 RETURN
C
      END

C
C  $Id: vc08f.f,v 1.4 2010-03-15 22:49:25 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C               Copyright (C)  1996                                    C
C       University Corporation for Atmospheric Research                C
C               All Rights Reserved                                    C
C                                                                      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C  File:       vc08f.f
C
C   Author:     Bob Lackman
C               National Center for Atmospheric Research
C               PO 3000, Boulder, Colorado
C
C   Date:       Wed Jan 24, 1996
C
C   Description:    Plots wind vectors at a grid stride of 3.
C                   Vectors are colored by wind speed.
C
      external NhlFAppClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFCairoWindowWorkstationClass
      external NhlFVectorPlotClass
      external NhlFVectorFieldClass
      external NhlFMapPlotClass
      external NhlFTextItemClass
      parameter(NLON = 129, NLAT = 64)
      
      character*7  wks_type
      integer appid,wid,vcid,vfield,mapid,txid1,txid2
      integer rlist
      real U(NLON,NLAT),V(NLON,NLAT)
      integer vccolors(14)
      data vccolors/26,28,30,33,36,39,42,45,48,51,54,56,58,60/
C
C Declare variables for getting information from netCDF file.
C
      integer vf, u_id, v_id, lon_id, lat_id
      integer  i, start(4), count(4), lonlen, latlen, flen
      real lon(NLON), lat(NLAT)
      character*256  filename
      character*50 recname
      character*256 title, subtitle, txtstring
C
C Open the netCDF file.
C
      call gngpat(filename,'data',ierr)
      flen = 22
      do 10 i=1,256
         if( filename(i:i).eq.char(0) ) then
            filename(i:i+flen)='/cdf/ex01B1_uv300.hs.nc'
            goto 15
         endif
 10   continue
 15   vf = ncopn(filename,0,ierr)
C
C Initialize the high level utility library
C
C Create an application context. Set the app dir to the current
C directory so the application looks for a resource file in the working
C directory. 
C
      call NhlFInitialize
      call NhlFRLCreate(rlist,'setrl')
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'appDefaultParent','True',ierr)
      call NhlFRLSetString(rlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'vc08',NhlFAppClass,0,rlist,ierr)
C
C Default is to create an X11 window.
C
      wks_type = "x11"

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'wkColorMap','uniform',ierr)
      call NhlFRLSetString(rlist,'wkMetaName','./vc08f.ncgm',ierr)
      call NhlFCreate(wid,'vc08Work',
     +        NhlFNcgmWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X11 workstation.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'wkColorMap','uniform',ierr)
      call NhlFRLSetString(rlist,'wkPause','True',ierr)
      call NhlFCreate(wid,'vc08Work',
     +        NhlFCairoWindowWorkstationClass,
     +        0,rlist,ierr)
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PostScript workstation.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'wkColorMap','uniform',ierr)
      call NhlFRLSetString(rlist,'wkPSFileName','./vc08f.ps',ierr)
      call NhlFCreate(wid,'vc08Work',
     +        NhlFPSWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'wkColorMap','uniform',ierr)
      call NhlFRLSetString(rlist,'wkPDFFileName','./vc08f.pdf',ierr)
      call NhlFCreate(wid,'vc08Work',
     +        NhlFPDFWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF workstation.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'wkColorMap','uniform',ierr)
      call NhlFRLSetString(rlist,'wkFileName','./vc08f',ierr)
      call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
      call NhlFCreate(wid,'vc08Work',
     +        NhlFCairoPSPDFWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG workstation.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'wkColorMap','uniform',ierr)
      call NhlFRLSetString(rlist,'wkFileName','./vc08f',ierr)
      call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
      call NhlFCreate(wid,'vc08Work',
     +        NhlFCairoImageWorkstationClass,0,rlist,ierr)
      endif
C
C Get netCDF file information.
C
      lat_id = ncdid(vf,'latitude',ierr)
      lon_id = ncdid(vf,'longitude',ierr)
      u_id = ncvid(vf,'U',ierr)
      v_id = ncvid(vf,'V',ierr)
      call ncdinq(vf,lat_id,recname,latlen,ierr)
      call ncdinq(vf,lon_id,recname,lonlen,ierr)
C
C Get longitude and latitude values.
C
      start(1) = 1
      lat_id = ncvid(vf,'lat',ierr)
      count(1) = latlen
      call ncvgt(vf,lat_id,start,count,lat,ierr)

      start(1) = 1
      lon_id = ncvid(vf,'lon',ierr)
      count(1) = lonlen
      call ncvgt(vf,lon_id,start,count,lon,ierr)
C
C Get U and V data values.
C
      start(1) = 1
      start(2) = 1
      start(3) = 1
      start(4) = 1
      count(1) = lonlen
      count(2) = latlen
      count(3) = 1
      count(4) = 1
      call ncvgt(vf,u_id,start,count,U,ierr)
      call ncvgt(vf,v_id,start,count,V,ierr)
C
C Get the titles (global attributes).
C
      call ncagtc(vf,0,'title',title,256,ierr)
      call ncagtc(vf,0,'sub_title_rhs',subtitle,256,ierr)
C
C Close the netCDF file.
C
      call ncclos(vf,ierr)
C
C Create a VectorField data object, U and V are 4-D arrays which
C are a function of time, level, latitude and longitude.  Use the
C 1st time & level.
C
      count(1) = lonlen
      count(2) = latlen

      call NhlFRLClear(rlist)
      call NhlFRLSetMDFloatArray(rlist,'vfUDataArray',U,2,
     +     count,ierr)
      call NhlFRLSetMDFloatArray(rlist,'vfVDataArray',V,2,
     +     count,ierr)
      call NhlFRLSetFloat(rlist,'vfXCStartV',lon(1),ierr)
      call NhlFRLSetFloat(rlist,'vfXCEndV', lon(lonlen),ierr)
      call NhlFRLSetFloat(rlist,'vfYCStartV',lat(1),ierr)
      call NhlFRLSetFloat(rlist,'vfYCEndV',lat(latlen),ierr)
C
C Specify a stride of 3 in both dimensions
C
      call NhlFRLSetInteger(rlist,'vfXCStride',3,ierr)
      call NhlFRLSetInteger(rlist,'vfYCStride',3,ierr)
      call NhlFCreate(vfield,'VectorField',NhlFvectorFieldClass,appid,
     +     rlist,ierr)
C
C Create a VectorPlot object "vcid" and connect the data object "vfield".
C
      call NhlFRLClear(rlist)
      call NhlFRLSetInteger(rlist,'vcVectorFieldData',vfield,ierr)
      call NhlFRLSetFloat(rlist,'vcMinFracLengthF',0.33,ierr)
      call NhlFRLSetFloat(rlist,'vcRefLengthF',0.025,ierr)
      call NhlFRLSetString(rlist,'vcRefAnnoString1','$VMG$ '//subtitle,
     +     ierr)
      call NhlFRLSetString(rlist,'vcMonoLineArrowColor','false',ierr)
      call NhlFRLSetString(rlist,'pmLabelBarDisplayMode','always',ierr)
      call NhlFRLSetString(rlist,'pmLabelBarSide','bottom',ierr)
      call NhlFRLSetString(rlist,'lbOrientation','horizontal' ,ierr)
      call NhlFRLSetString(rlist,'lbTitleString',subtitle,ierr)
      call NhlFRLSetIntegerArray(rlist,'vcLevelColors',vccolors,14,ierr)
C     call NhlFRLSetFloat(rlist, 'vcLineArrowThicknessF',1.75,ierr)
      call NhlFCreate(vcid,'vectorplot',NhlFvectorPlotClass,wid,rlist,
     +ierr)
C
C Create a map object.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetFloat(rlist,'vpXF',0.05,ierr)
      call NhlFRLSetFloat(rlist,'vpWidthF',0.9,ierr)
      call NhlFRLSetFloat(rlist,'vpYF',0.85,ierr)
      call NhlFRLSetString(rlist,'mpGridAndLimbDrawOrder','predraw',
     +     ierr)
      call NhlFCreate(mapid,'map',NhlFmapPlotClass,wid,rlist,ierr)

      call NhlFAddOverlay(mapid,vcid, -1,ierr)
      call NhlFDraw(mapid,ierr)
C
C Create a text item object as a main title.
C         
      call NhlFRLClear(rlist)
      call NhlFRLSetFloat(rlist,'txPosXF',0.5,ierr)
      call NhlFRLSetFloat(rlist,'txPosYF',0.85,ierr)
      call NhlFRLSetString(rlist,'txJust','CENTERCENTER',ierr)
      call NhlFRLSetString(rlist,'txString',title,ierr)
      call NhlFRLSetFloat(rlist,'txFontHeightF',.030,ierr)
      call NhlFRLSetInteger(rlist,'txFont',25,ierr)
      call NhlFCreate(txid1,'main',NhlFtextItemClass,wid,rlist,ierr)
C
C Create a subheader text item object.
C
      txtstring = 'Wind                                                 
     +         300mb                                                    
     +   (m/s)'
      call NhlFRLClear(rlist)
      call NhlFRLSetFloat(rlist,'txPosXF',0.5,ierr)
      call NhlFRLSetFloat(rlist,'txPosYF',0.80,ierr)
      call NhlFRLSetString(rlist,'txJust','CENTERCENTER',ierr)
      call NhlFRLSetString(rlist,'txString',txtstring,ierr)
      call NhlFRLSetFloat(rlist,'txFontHeightF',.015,ierr)
      call NhlFRLSetINteger(rlist,'txFont',25,ierr)
      call NhlFCreate(txid2,'text',NhlFtextItemClass,wid,rlist,ierr)
      call NhlFDraw(txid1,ierr)
      call NhlFDraw(txid2,ierr)
      call NhlFFrame(wid,ierr)
C
C Destroy the objects created, close the HLU library and exit.
C
      call NhlFDestroy(wid,ierr)
      call NhlFDestroy(appid,ierr)
      call NhlFClose
      stop
      end

      SUBROUTINE ZHBTRD( VECT, UPLO, N, KD, AB, LDAB, D, E, Q, LDQ,
     $                   WORK, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          UPLO, VECT
      INTEGER            INFO, KD, LDAB, LDQ, N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   D( * ), E( * )
      COMPLEX*16         AB( LDAB, * ), Q( LDQ, * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  ZHBTRD reduces a complex Hermitian band matrix A to real symmetric
*  tridiagonal form T by a unitary similarity transformation:
*  Q**H * A * Q = T.
*
*  Arguments
*  =========
*
*  VECT    (input) CHARACTER*1
*          = 'N':  do not form Q;
*          = 'V':  form Q;
*          = 'U':  update a matrix X, by forming X*Q.
*
*  UPLO    (input) CHARACTER*1
*          = 'U':  Upper triangle of A is stored;
*          = 'L':  Lower triangle of A is stored.
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  KD      (input) INTEGER
*          The number of superdiagonals of the matrix A if UPLO = 'U',
*          or the number of subdiagonals if UPLO = 'L'.  KD >= 0.
*
*  AB      (input/output) COMPLEX*16 array, dimension (LDAB,N)
*          On entry, the upper or lower triangle of the Hermitian band
*          matrix A, stored in the first KD+1 rows of the array.  The
*          j-th column of A is stored in the j-th column of the array AB
*          as follows:
*          if UPLO = 'U', AB(kd+1+i-j,j) = A(i,j) for max(1,j-kd)<=i<=j;
*          if UPLO = 'L', AB(1+i-j,j)    = A(i,j) for j<=i<=min(n,j+kd).
*          On exit, the diagonal elements of AB are overwritten by the
*          diagonal elements of the tridiagonal matrix T; if KD > 0, the
*          elements on the first superdiagonal (if UPLO = 'U') or the
*          first subdiagonal (if UPLO = 'L') are overwritten by the
*          off-diagonal elements of T; the rest of AB is overwritten by
*          values generated during the reduction.
*
*  LDAB    (input) INTEGER
*          The leading dimension of the array AB.  LDAB >= KD+1.
*
*  D       (output) DOUBLE PRECISION array, dimension (N)
*          The diagonal elements of the tridiagonal matrix T.
*
*  E       (output) DOUBLE PRECISION array, dimension (N-1)
*          The off-diagonal elements of the tridiagonal matrix T:
*          E(i) = T(i,i+1) if UPLO = 'U'; E(i) = T(i+1,i) if UPLO = 'L'.
*
*  Q       (input/output) COMPLEX*16 array, dimension (LDQ,N)
*          On entry, if VECT = 'U', then Q must contain an N-by-N
*          matrix X; if VECT = 'N' or 'V', then Q need not be set.
*
*          On exit:
*          if VECT = 'V', Q contains the N-by-N unitary matrix Q;
*          if VECT = 'U', Q contains the product X*Q;
*          if VECT = 'N', the array Q is not referenced.
*
*  LDQ     (input) INTEGER
*          The leading dimension of the array Q.
*          LDQ >= 1, and LDQ >= N if VECT = 'V' or 'U'.
*
*  WORK    (workspace) COMPLEX*16 array, dimension (N)
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*
*  Further Details
*  ===============
*
*  Modified by Linda Kaufman, Bell Labs.
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO
      PARAMETER          ( ZERO = 0.0D+0 )
      COMPLEX*16         CZERO, CONE
      PARAMETER          ( CZERO = ( 0.0D+0, 0.0D+0 ),
     $                   CONE = ( 1.0D+0, 0.0D+0 ) )
*     ..
*     .. Local Scalars ..
      LOGICAL            INITQ, UPPER, WANTQ
      INTEGER            I, I2, IBL, INCA, INCX, IQAEND, IQB, IQEND, J,
     $                   J1, J1END, J1INC, J2, JEND, JIN, JINC, K, KD1,
     $                   KDM1, KDN, L, LAST, LEND, NQ, NR, NRT
      DOUBLE PRECISION   ABST
      COMPLEX*16         T, TEMP
*     ..
*     .. External Subroutines ..
      EXTERNAL           XERBLA, ZLACGV, ZLAR2V, ZLARGV, ZLARTG, ZLARTV,
     $                   ZLASET, ZROT, ZSCAL
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, DBLE, DCONJG, MAX, MIN
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters
*
      INITQ = LSAME( VECT, 'V' )
      WANTQ = INITQ .OR. LSAME( VECT, 'U' )
      UPPER = LSAME( UPLO, 'U' )
      KD1 = KD + 1
      KDM1 = KD - 1
      INCX = LDAB - 1
      IQEND = 1
*
      INFO = 0
      IF( .NOT.WANTQ .AND. .NOT.LSAME( VECT, 'N' ) ) THEN
         INFO = -1
      ELSE IF( .NOT.UPPER .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = -2
      ELSE IF( N.LT.0 ) THEN
         INFO = -3
      ELSE IF( KD.LT.0 ) THEN
         INFO = -4
      ELSE IF( LDAB.LT.KD1 ) THEN
         INFO = -6
      ELSE IF( LDQ.LT.MAX( 1, N ) .AND. WANTQ ) THEN
         INFO = -10
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'ZHBTRD', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
*
*     Initialize Q to the unit matrix, if needed
*
      IF( INITQ )
     $   CALL ZLASET( 'Full', N, N, CZERO, CONE, Q, LDQ )
*
*     Wherever possible, plane rotations are generated and applied in
*     vector operations of length NR over the index set J1:J2:KD1.
*
*     The real cosines and complex sines of the plane rotations are
*     stored in the arrays D and WORK.
*
      INCA = KD1*LDAB
      KDN = MIN( N-1, KD )
      IF( UPPER ) THEN
*
         IF( KD.GT.1 ) THEN
*
*           Reduce to complex Hermitian tridiagonal form, working with
*           the upper triangle
*
            NR = 0
            J1 = KDN + 2
            J2 = 1
*
            AB( KD1, 1 ) = DBLE( AB( KD1, 1 ) )
            DO 90 I = 1, N - 2
*
*              Reduce i-th row of matrix to tridiagonal form
*
               DO 80 K = KDN + 1, 2, -1
                  J1 = J1 + KDN
                  J2 = J2 + KDN
*
                  IF( NR.GT.0 ) THEN
*
*                    generate plane rotations to annihilate nonzero
*                    elements which have been created outside the band
*
                     CALL ZLARGV( NR, AB( 1, J1-1 ), INCA, WORK( J1 ),
     $                            KD1, D( J1 ), KD1 )
*
*                    apply rotations from the right
*
*
*                    Dependent on the the number of diagonals either
*                    ZLARTV or ZROT is used
*
                     IF( NR.GE.2*KD-1 ) THEN
                        DO 10 L = 1, KD - 1
                           CALL ZLARTV( NR, AB( L+1, J1-1 ), INCA,
     $                                  AB( L, J1 ), INCA, D( J1 ),
     $                                  WORK( J1 ), KD1 )
   10                   CONTINUE
*
                     ELSE
                        JEND = J1 + ( NR-1 )*KD1
                        DO 20 JINC = J1, JEND, KD1
                           CALL ZROT( KDM1, AB( 2, JINC-1 ), 1,
     $                                AB( 1, JINC ), 1, D( JINC ),
     $                                WORK( JINC ) )
   20                   CONTINUE
                     END IF
                  END IF
*
*
                  IF( K.GT.2 ) THEN
                     IF( K.LE.N-I+1 ) THEN
*
*                       generate plane rotation to annihilate a(i,i+k-1)
*                       within the band
*
                        CALL ZLARTG( AB( KD-K+3, I+K-2 ),
     $                               AB( KD-K+2, I+K-1 ), D( I+K-1 ),
     $                               WORK( I+K-1 ), TEMP )
                        AB( KD-K+3, I+K-2 ) = TEMP
*
*                       apply rotation from the right
*
                        CALL ZROT( K-3, AB( KD-K+4, I+K-2 ), 1,
     $                             AB( KD-K+3, I+K-1 ), 1, D( I+K-1 ),
     $                             WORK( I+K-1 ) )
                     END IF
                     NR = NR + 1
                     J1 = J1 - KDN - 1
                  END IF
*
*                 apply plane rotations from both sides to diagonal
*                 blocks
*
                  IF( NR.GT.0 )
     $               CALL ZLAR2V( NR, AB( KD1, J1-1 ), AB( KD1, J1 ),
     $                            AB( KD, J1 ), INCA, D( J1 ),
     $                            WORK( J1 ), KD1 )
*
*                 apply plane rotations from the left
*
                  CALL ZLACGV( NR, WORK( J1 ), KD1 )
                  IF( NR.GT.0 ) THEN
                     IF( 2*KD-1.LT.NR ) THEN
*
*                    Dependent on the the number of diagonals either
*                    ZLARTV or ZROT is used
*
                        DO 30 L = 1, KD - 1
                           IF( J2+L.GT.N ) THEN
                              NRT = NR - 1
                           ELSE
                              NRT = NR
                           END IF
                           IF( NRT.GT.0 )
     $                        CALL ZLARTV( NRT, AB( KD-L, J1+L ), INCA,
     $                                     AB( KD-L+1, J1+L ), INCA,
     $                                     D( J1 ), WORK( J1 ), KD1 )
   30                   CONTINUE
                     ELSE
                        J1END = J1 + KD1*( NR-2 )
                        IF( J1END.GE.J1 ) THEN
                           DO 40 JIN = J1, J1END, KD1
                              CALL ZROT( KD-1, AB( KD-1, JIN+1 ), INCX,
     $                                   AB( KD, JIN+1 ), INCX,
     $                                   D( JIN ), WORK( JIN ) )
   40                      CONTINUE
                        END IF
                        LEND = MIN( KDM1, N-J2 )
                        LAST = J1END + KD1
                        IF( LEND.GT.0 )
     $                     CALL ZROT( LEND, AB( KD-1, LAST+1 ), INCX,
     $                                AB( KD, LAST+1 ), INCX, D( LAST ),
     $                                WORK( LAST ) )
                     END IF
                  END IF
*
                  IF( WANTQ ) THEN
*
*                    accumulate product of plane rotations in Q
*
                     IF( INITQ ) THEN
*
*                 take advantage of the fact that Q was
*                 initially the Identity matrix
*
                        IQEND = MAX( IQEND, J2 )
                        I2 = MAX( 0, K-3 )
                        IQAEND = 1 + I*KD
                        IF( K.EQ.2 )
     $                     IQAEND = IQAEND + KD
                        IQAEND = MIN( IQAEND, IQEND )
                        DO 50 J = J1, J2, KD1
                           IBL = I - I2 / KDM1
                           I2 = I2 + 1
                           IQB = MAX( 1, J-IBL )
                           NQ = 1 + IQAEND - IQB
                           IQAEND = MIN( IQAEND+KD, IQEND )
                           CALL ZROT( NQ, Q( IQB, J-1 ), 1, Q( IQB, J ),
     $                                1, D( J ), DCONJG( WORK( J ) ) )
   50                   CONTINUE
                     ELSE
*
                        DO 60 J = J1, J2, KD1
                           CALL ZROT( N, Q( 1, J-1 ), 1, Q( 1, J ), 1,
     $                                D( J ), DCONJG( WORK( J ) ) )
   60                   CONTINUE
                     END IF
*
                  END IF
*
                  IF( J2+KDN.GT.N ) THEN
*
*                    adjust J2 to keep within the bounds of the matrix
*
                     NR = NR - 1
                     J2 = J2 - KDN - 1
                  END IF
*
                  DO 70 J = J1, J2, KD1
*
*                    create nonzero element a(j-1,j+kd) outside the band
*                    and store it in WORK
*
                     WORK( J+KD ) = WORK( J )*AB( 1, J+KD )
                     AB( 1, J+KD ) = D( J )*AB( 1, J+KD )
   70             CONTINUE
   80          CONTINUE
   90       CONTINUE
         END IF
*
         IF( KD.GT.0 ) THEN
*
*           make off-diagonal elements real and copy them to E
*
            DO 100 I = 1, N - 1
               T = AB( KD, I+1 )
               ABST = ABS( T )
               AB( KD, I+1 ) = ABST
               E( I ) = ABST
               IF( ABST.NE.ZERO ) THEN
                  T = T / ABST
               ELSE
                  T = CONE
               END IF
               IF( I.LT.N-1 )
     $            AB( KD, I+2 ) = AB( KD, I+2 )*T
               IF( WANTQ ) THEN
                  CALL ZSCAL( N, DCONJG( T ), Q( 1, I+1 ), 1 )
               END IF
  100       CONTINUE
         ELSE
*
*           set E to zero if original matrix was diagonal
*
            DO 110 I = 1, N - 1
               E( I ) = ZERO
  110       CONTINUE
         END IF
*
*        copy diagonal elements to D
*
         DO 120 I = 1, N
            D( I ) = AB( KD1, I )
  120    CONTINUE
*
      ELSE
*
         IF( KD.GT.1 ) THEN
*
*           Reduce to complex Hermitian tridiagonal form, working with
*           the lower triangle
*
            NR = 0
            J1 = KDN + 2
            J2 = 1
*
            AB( 1, 1 ) = DBLE( AB( 1, 1 ) )
            DO 210 I = 1, N - 2
*
*              Reduce i-th column of matrix to tridiagonal form
*
               DO 200 K = KDN + 1, 2, -1
                  J1 = J1 + KDN
                  J2 = J2 + KDN
*
                  IF( NR.GT.0 ) THEN
*
*                    generate plane rotations to annihilate nonzero
*                    elements which have been created outside the band
*
                     CALL ZLARGV( NR, AB( KD1, J1-KD1 ), INCA,
     $                            WORK( J1 ), KD1, D( J1 ), KD1 )
*
*                    apply plane rotations from one side
*
*
*                    Dependent on the the number of diagonals either
*                    ZLARTV or ZROT is used
*
                     IF( NR.GT.2*KD-1 ) THEN
                        DO 130 L = 1, KD - 1
                           CALL ZLARTV( NR, AB( KD1-L, J1-KD1+L ), INCA,
     $                                  AB( KD1-L+1, J1-KD1+L ), INCA,
     $                                  D( J1 ), WORK( J1 ), KD1 )
  130                   CONTINUE
                     ELSE
                        JEND = J1 + KD1*( NR-1 )
                        DO 140 JINC = J1, JEND, KD1
                           CALL ZROT( KDM1, AB( KD, JINC-KD ), INCX,
     $                                AB( KD1, JINC-KD ), INCX,
     $                                D( JINC ), WORK( JINC ) )
  140                   CONTINUE
                     END IF
*
                  END IF
*
                  IF( K.GT.2 ) THEN
                     IF( K.LE.N-I+1 ) THEN
*
*                       generate plane rotation to annihilate a(i+k-1,i)
*                       within the band
*
                        CALL ZLARTG( AB( K-1, I ), AB( K, I ),
     $                               D( I+K-1 ), WORK( I+K-1 ), TEMP )
                        AB( K-1, I ) = TEMP
*
*                       apply rotation from the left
*
                        CALL ZROT( K-3, AB( K-2, I+1 ), LDAB-1,
     $                             AB( K-1, I+1 ), LDAB-1, D( I+K-1 ),
     $                             WORK( I+K-1 ) )
                     END IF
                     NR = NR + 1
                     J1 = J1 - KDN - 1
                  END IF
*
*                 apply plane rotations from both sides to diagonal
*                 blocks
*
                  IF( NR.GT.0 )
     $               CALL ZLAR2V( NR, AB( 1, J1-1 ), AB( 1, J1 ),
     $                            AB( 2, J1-1 ), INCA, D( J1 ),
     $                            WORK( J1 ), KD1 )
*
*                 apply plane rotations from the right
*
*
*                    Dependent on the the number of diagonals either
*                    ZLARTV or ZROT is used
*
                  CALL ZLACGV( NR, WORK( J1 ), KD1 )
                  IF( NR.GT.0 ) THEN
                     IF( NR.GT.2*KD-1 ) THEN
                        DO 150 L = 1, KD - 1
                           IF( J2+L.GT.N ) THEN
                              NRT = NR - 1
                           ELSE
                              NRT = NR
                           END IF
                           IF( NRT.GT.0 )
     $                        CALL ZLARTV( NRT, AB( L+2, J1-1 ), INCA,
     $                                     AB( L+1, J1 ), INCA, D( J1 ),
     $                                     WORK( J1 ), KD1 )
  150                   CONTINUE
                     ELSE
                        J1END = J1 + KD1*( NR-2 )
                        IF( J1END.GE.J1 ) THEN
                           DO 160 J1INC = J1, J1END, KD1
                              CALL ZROT( KDM1, AB( 3, J1INC-1 ), 1,
     $                                   AB( 2, J1INC ), 1, D( J1INC ),
     $                                   WORK( J1INC ) )
  160                      CONTINUE
                        END IF
                        LEND = MIN( KDM1, N-J2 )
                        LAST = J1END + KD1
                        IF( LEND.GT.0 )
     $                     CALL ZROT( LEND, AB( 3, LAST-1 ), 1,
     $                                AB( 2, LAST ), 1, D( LAST ),
     $                                WORK( LAST ) )
                     END IF
                  END IF
*
*
*
                  IF( WANTQ ) THEN
*
*                    accumulate product of plane rotations in Q
*
                     IF( INITQ ) THEN
*
*                 take advantage of the fact that Q was
*                 initially the Identity matrix
*
                        IQEND = MAX( IQEND, J2 )
                        I2 = MAX( 0, K-3 )
                        IQAEND = 1 + I*KD
                        IF( K.EQ.2 )
     $                     IQAEND = IQAEND + KD
                        IQAEND = MIN( IQAEND, IQEND )
                        DO 170 J = J1, J2, KD1
                           IBL = I - I2 / KDM1
                           I2 = I2 + 1
                           IQB = MAX( 1, J-IBL )
                           NQ = 1 + IQAEND - IQB
                           IQAEND = MIN( IQAEND+KD, IQEND )
                           CALL ZROT( NQ, Q( IQB, J-1 ), 1, Q( IQB, J ),
     $                                1, D( J ), WORK( J ) )
  170                   CONTINUE
                     ELSE
*
                        DO 180 J = J1, J2, KD1
                           CALL ZROT( N, Q( 1, J-1 ), 1, Q( 1, J ), 1,
     $                                D( J ), WORK( J ) )
  180                   CONTINUE
                     END IF
                  END IF
*
                  IF( J2+KDN.GT.N ) THEN
*
*                    adjust J2 to keep within the bounds of the matrix
*
                     NR = NR - 1
                     J2 = J2 - KDN - 1
                  END IF
*
                  DO 190 J = J1, J2, KD1
*
*                    create nonzero element a(j+kd,j-1) outside the
*                    band and store it in WORK
*
                     WORK( J+KD ) = WORK( J )*AB( KD1, J )
                     AB( KD1, J ) = D( J )*AB( KD1, J )
  190             CONTINUE
  200          CONTINUE
  210       CONTINUE
         END IF
*
         IF( KD.GT.0 ) THEN
*
*           make off-diagonal elements real and copy them to E
*
            DO 220 I = 1, N - 1
               T = AB( 2, I )
               ABST = ABS( T )
               AB( 2, I ) = ABST
               E( I ) = ABST
               IF( ABST.NE.ZERO ) THEN
                  T = T / ABST
               ELSE
                  T = CONE
               END IF
               IF( I.LT.N-1 )
     $            AB( 2, I+1 ) = AB( 2, I+1 )*T
               IF( WANTQ ) THEN
                  CALL ZSCAL( N, T, Q( 1, I+1 ), 1 )
               END IF
  220       CONTINUE
         ELSE
*
*           set E to zero if original matrix was diagonal
*
            DO 230 I = 1, N - 1
               E( I ) = ZERO
  230       CONTINUE
         END IF
*
*        copy diagonal elements to D
*
         DO 240 I = 1, N
            D( I ) = AB( 1, I )
  240    CONTINUE
      END IF
*
      RETURN
*
*     End of ZHBTRD
*
      END

      PROGRAM CPEX15
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
        PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C This program demonstrates how user-supplied versions of the "user
C callback" routines CPCHHL and CPCHLL may be used to change various
C aspects of individual high/low labels and contour-line labels on a
C contour plot.  In particular, it shows how to prevent such labels
C from appearing in a portion of the plotter frame where contour lines
C are suppressed (by masking against the contents of an area map).
C
C Declare an array to hold the data to be contoured.
C
        DIMENSION ZDAT(70,70)
C
C Declare the required real and integer workspaces.
C
        DIMENSION RWRK(5000),IWRK(1000)
C
C Declare an array to hold an area map.  Put in a common block so we
C can get at it from the routines CPCHHL and CPCHLL.
C
        COMMON /USRAMA/ IAMA(200000)
C
C Declare the arrays needed by ARSCAM and MAPGRM for x/y coordinates.
C
        DIMENSION XCRA(10000),YCRA(10000)
C
C Declare the arrays needed by ARSCAM and MAPGRM for area and group
C identifiers.
C
        DIMENSION IARA(10),IGRA(10)
C
C Declare the routine that draws contour lines, avoiding labels.
C
        EXTERNAL DRAWCL
C
C Declare the routine that does the shading of a contour band.
C
        EXTERNAL SHADER
C
C Declare the routine that fills the EZMAP background.
C
        EXTERNAL FILLEB
C
C Open GKS.
C
        CALL GOPKS (IERRF,ISZDM)
        CALL GOPWK (IWKID,LUNIT,IWTYPE)
        CALL GACWK (IWKID)
C
C Turn off the clipping indicator.
C
        CALL GSCLIP (0)
C
C Define colors to use for various purposes (0 = black, for the
C background; 1 = white, for the foreground; 2 = light blue, for
C labels; 3 = light yellow, for labels; 4 = light red, for labels;
C 5 = white, for land areas; and 6 = gray, for ocean areas).
C
        CALL GSCR   (IWKID,0,0.,0.,0.)
        CALL GSCR   (IWKID,1,1.,1.,1.)
        CALL GSCR   (IWKID,2,.5,.5,1.)
        CALL GSCR   (IWKID,3,1.,1.,.5)
        CALL GSCR   (IWKID,4,1.,.5,.5)
        CALL GSCR   (IWKID,5,1.,1.,1.)
        CALL GSCR   (IWKID,6,.6,.6,.6)
C
C Generate an array of test data.
C
        CALL GENDAT (ZDAT,70,70,70,21,21,-1.,1.)
C
C Put some labels at the top of the plot.
C
        CALL PLCHHQ (.5,.982,'CONPACK EXAMPLE 15',.018,0.,0.)
C
        CALL PLCHHQ (.5,.952,'The routines CPCHHL and CPCHLL are used be
     +low to suppress labels over land.',.012,0.,0.)
C
        CALL PLCHHQ (.5,.928,'They are also used to modify colors and li
     +ne widths used for the labels.',.012,0.,0.)
C
C Set EZMAP parameters.
C
C       labels (none):
        CALL MAPSTI ('LA - LABELS',0)
C       perimeter (none):
        CALL MAPSTI ('PE - PERIMETER',0)
C       map position:
        CALL MAPPOS (.05,.95,.01,.91)
C       projection:
        CALL MAPROJ ('OR - ORTHOGRAPHIC',40.,-135.,0.)
C       portion of the map to be used:
        CALL MAPSET ('MA - MAXIMAL AREA',0.,0.,0.,0.)
C
C Initialize EZMAP.
C
        CALL MAPINT
C
C Tell CONPACK to do no SET call (EZMAP has done it).
C
        CALL CPSETI ('SET - DO-SET-CALL FLAG',0)
C
C Tell CONPACK to use more contour levels.
C
        CALL CPSETI ('CLS - CONTOUR LEVEL SELECTOR',32)
C
C Tell CONPACK to position labels using the "regular" scheme.
C
        CALL CPSETI ('LLP - LINE LABEL POSITIONING',2)
C
C Tweak constants so as to get more labels on each labeled contour.
C
        CALL CPSETR ('RC1 - REGULAR SCHEME CONSTANT 1',.05)
        CALL CPSETR ('RC2 - REGULAR SCHEME CONSTANT 2',.1)
        CALL CPSETR ('RC3 - REGULAR SCHEME CONSTANT 3',0.)
C
C Provide a little more workspace for X and Y coordinates defining
C contour lines, so as not to have labels right next to each other
C on a contour line.
C
        CALL CPSETI ('RWC - REAL WORKSPACE FOR CONTOURS',200)
C
C Turn on drawing and filling of the high and low label boxes.
C
        CALL CPSETI ('HLB - HIGH/LOW LABEL BOX FLAG',3)
C
C Tell CONPACK to delete high/low labels which overlap the informational
C label or another high/low label, but to move those which overlap the
C edge inward a little.
C
        CALL CPSETI ('HLO - HIGH/LOW LABEL OVERLAP FLAG',11)
C
C Turn on drawing and filling of the contour line label boxes.
C
        CALL CPSETI ('LLB - LINE LABEL BOX FLAG',3)
C
C Make all CONPACK-written characters a little smaller.
C
        CALL CPSETR ('CWM - CHARACTER WIDTH MULTIPLIER',.8)
C
C Turn on the drawing of the grid edge ("contour line number -1") and
C thicken it somewhat.
C
        CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',-1)
        CALL CPSETI ('CLU - CONTOUR LEVEL USE FLAG',1)
        CALL CPSETR ('CLL - CONTOUR LEVEL LINE WIDTH',2.)
C
C Tell CONPACK to use EZMAP for mapping and what the out-of-range
C signal is.
C
        CALL CPSETI ('MAP - MAPPING FUNCTION',1)
        CALL CPSETR ('ORV - OUT-OF-RANGE VALUE',1.E12)
C
C Tell CONPACK what range of coordinates to use.
C
        CALL CPSETR ('XC1 - LONGITUDE AT I = 1',-230.)
        CALL CPSETR ('XCM - LONGITUDE AT I = M',- 40.)
        CALL CPSETR ('YC1 - LATITUDE AT J = 1' ,- 35.)
        CALL CPSETR ('YCN - LATITUDE AT J = N' ,  75.)
C
C Initialize the drawing of the contour plot.
C
        CALL CPRECT (ZDAT,70,70,70,RWRK,5000,IWRK,1000)
C
C Force the selection of contour levels so that associated quantities
C may be tweaked.
C
        CALL CPPKCL (ZDAT,RWRK,IWRK)
C
C Increase the line width for labelled levels and turn off the area
C identifiers for all levels.
C
        CALL CPGETI ('NCL - NUMBER OF CONTOUR LEVELS',NCLV)
C
        DO 101 ICLV=1,NCLV
          CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',ICLV)
          CALL CPGETI ('CLU - CONTOUR LEVEL USE FLAG',ICLU)
          IF (ICLU.EQ.3) THEN
            CALL CPSETI ('CLL - CONTOUR-LINE LINE WIDTH',2)
          END IF
          CALL CPSETI ('AIA - AREA IDENTIFIER ABOVE LEVEL',0)
          CALL CPSETI ('AIB - AREA IDENTIFIER BELOW LEVEL',0)
  101   CONTINUE
C
C Add two new levels for which no contour lines are to be drawn, but
C between which shading is to be done.
C
        NCLV=NCLV+2
        CALL CPSETI ('NCL - NUMBER OF CONTOUR LEVELS',NCLV)
C
        CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',NCLV-1)
        CALL CPSETR ('CLV - CONTOUR LEVEL VALUE',-.15)
        CALL CPSETI ('CLU - CONTOUR LEVEL USE FLAG',0)
        CALL CPSETI ('AIA - AREA IDENTIFIER ABOVE LEVEL',1)
        CALL CPSETI ('AIB - AREA IDENTIFIER BELOW LEVEL',2)
C
        CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',NCLV)
        CALL CPSETR ('CLV - CONTOUR LEVEL VALUE',+.15)
        CALL CPSETI ('CLU - CONTOUR LEVEL USE FLAG',0)
        CALL CPSETI ('AIA - AREA IDENTIFIER ABOVE LEVEL',3)
        CALL CPSETI ('AIB - AREA IDENTIFIER BELOW LEVEL',1)
C
C Initialize the area map.
C
        CALL ARINAM (IAMA,200000)
C
C Put EZMAP boundary lines into the area map (in edge group 1).
C
        CALL MAPBLA (IAMA)
C
C Put label boxes into the area map (in edge group 3).  One of the first
C things this routine does is generate a list of labels (high/low and
C contour line labels).  For each such label, one of the routines CPCHHL
C or CPCHLL is called, giving the user an opportunity to suppress the
C positioning of a label there.  The versions of these routines supplied
C later in this file use the contents of the area map array IAMA to
C suppress labels that are over land areas.
C
        CALL CPLBAM (ZDAT,RWRK,IWRK,IAMA)
C
C Fill land and ocean areas in different shades, avoiding label boxes.
C
        CALL ARSCAM (IAMA,XCRA,YCRA,10000,IARA,IGRA,10,FILLEB)
C
C Set the polyline color index to zero, so that lines drawn from this
C point on will be drawn in black over the filled background.
C
        CALL GSPLCI (0)
C
C Draw the EZMAP grid lines (lines of constant latitude and longitude)
C over the oceans.
C
        CALL MAPGRM (IAMA,XCRA,YCRA,10000,IARA,IGRA,10,DRAWCL)
C
C Put the contour lines at contour levels -.15 and +.15 into the area
C map.
C
        CALL CPCLAM (ZDAT,RWRK,IWRK,IAMA)
C
C Cross-hatch the area between contour levels -.15 and +.15.
C
        CALL ARSCAM (IAMA,XCRA,YCRA,10000,IARA,IGRA,10,SHADER)
C
C Draw contour lines over the oceans.
C
        CALL CPCLDM (ZDAT,RWRK,IWRK,IAMA,DRAWCL)
C
C Draw labels.  Because the versions of the routines CPCHHL and CPCHLL
C supplied later in this file are used instead of the default ones in
C CONPACK, the appearance of the labels is changed in various ways.
C See the commenting in those routines for further information.
C
        CALL CPLBDR (ZDAT,RWRK,IWRK)
C
C Advance the frame.
C
        CALL FRAME
C
C Close GKS.
C
        CALL GDAWK (IWKID)
        CALL GCLWK (IWKID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END



      SUBROUTINE DRAWCL (XCS,YCS,NCS,IAI,IAG,NAI)
C
C This subroutine is used to draw EZMAP grid lines and contour lines
C over the ocean only.  It draws the polyline defined by the points
C ((XCS(I),YCS(I)),I=1,NCS) if and only if none of the area identifiers
C for the area containing the polyline are negative and it's over ocean.
C
C The dash package routine CURVED is called to do the drawing so that
C the grid lines will be properly dashed as specified by internal
C parameters of EZMAP.
C
        DIMENSION XCS(*),YCS(*),IAI(*),IAG(*)
C
C Find the area identifiers of the polyline relative to group 1 (EZMAP
C background) and group 3 (CONPACK-supplied edges).
C
        IA1=-1
        IA3=-1
C
        DO 101 I=1,NAI
          IF (IAG(I).EQ.1) IA1=IAI(I)
          IF (IAG(I).EQ.3) IA3=IAI(I)
  101   CONTINUE
C
C Draw the polyline if and only if neither area identifier is negative
C and it's over the ocean.
C
        IF (IA1.GE.0.AND.IA3.GE.0.AND.MAPACI(IA1).EQ.1)
     +                                         CALL CURVED (XCS,YCS,NCS)
C
C Done.
C
        RETURN
C
      END



      SUBROUTINE FILLEB (XCS,YCS,NCS,IAI,IAG,NAI)
C
C This version of FILLEB fills the polygon whose edge is defined by
C the points ((XCS(I),YCS(I)),I=1,NCS-1) if it's a land area (in which
C case color index 6 is used) or an ocean area (in which case color
C index 7 is used), but it avoids filling areas for which, relative
C to edge group 3, the area identifier is negative (CONPACK label
C boxes).  The GKS routine GFA is used to do the fills.
C
        DIMENSION XCS(*),YCS(*),IAI(*),IAG(*)
C
C Find the area identifiers of the polygon relative to group 1 (EZMAP
C background) and group 3 (CONPACK-supplied edges).
C
        IA1=-1
        IA3=-1
C
        DO 101 I=1,NAI
          IF (IAG(I).EQ.1) IA1=IAI(I)
          IF (IAG(I).EQ.3) IA3=IAI(I)
  101   CONTINUE
C
C Fill land areas in white, using GFA and color index 6.
C
       IF (IA1.GT.0.AND.MAPACI(IA1).EQ.2.AND.IA3.GE.0) THEN
         CALL GSFACI (5)
         CALL GFA    (NCS-1,XCS,YCS)
       END IF
C
C Fill ocean areas in gray, using GFA and color index 7.
C
       IF (IA1.GT.0.AND.MAPACI(IA1).EQ.1.AND.IA3.GE.0) THEN
         CALL GSFACI (6)
         CALL GFA    (NCS-1,XCS,YCS)
       END IF
C
C Done.
C
        RETURN
C
      END



      SUBROUTINE SHADER (XCS,YCS,NCS,IAI,IAG,NAI)
C
C This version of SHADER shades the polygon whose edge is defined by
C the points ((XCS(I),YCS(I)),I=1,NCS-1) if and only if it's over ocean
C and, relative to edge group 3, its area identifier is a 1 (the area
C between contours at levels -.15 and .15).  The package SOFTFILL is
C used to do the shading.
C
        DIMENSION XCS(*),YCS(*),IAI(*),IAG(*)
C
C Define workspaces for the shading routine.
C
        DIMENSION DST(2200),IND(2400)
C
C Find the area identifiers of the polygon relative to group 1 (EZMAP
C background) and group 3 (CONPACK-supplied edges).
C
        IA1=-1
        IA3=-1
C
        DO 101 I=1,NAI
          IF (IAG(I).EQ.1) IA1=IAI(I)
          IF (IAG(I).EQ.3) IA3=IAI(I)
  101   CONTINUE
C
C If appropriate, crosshatch the area.
C
        IF (IA1.GT.0.AND.MAPACI(IA1).EQ.1.AND.IA3.EQ.1) THEN
          CALL SFSETI ('ANGLE',45)
          CALL SFSETR ('SPACING',.003)
          CALL SFWRLD (XCS,YCS,NCS-1,DST,2200,IND,2400)
          CALL SFSETI ('ANGLE',135)
          CALL SFNORM (XCS,YCS,NCS-1,DST,2200,IND,2400)
        END IF
C
C Done.
C
        RETURN
C
      END



      SUBROUTINE GENDAT (DATA,IDIM,M,N,MLOW,MHGH,DLOW,DHGH)
C
C This is a routine to generate test data for two-dimensional graphics
C routines.  Given an array "DATA", dimensioned "IDIM x 1", it fills
C the sub-array ((DATA(I,J),I=1,M),J=1,N) with a two-dimensional field
C of data having approximately "MLOW" lows and "MHGH" highs, a minimum
C value of exactly "DLOW" and a maximum value of exactly "DHGH".
C
C "MLOW" and "MHGH" are each forced to be greater than or equal to 1
C and less than or equal to 25.
C
C The function used is a sum of exponentials.
C
        DIMENSION DATA(IDIM,1),CCNT(3,50)
C
        FOVM=9./REAL(M)
        FOVN=9./REAL(N)
C
        NLOW=MAX(1,MIN(25,MLOW))
        NHGH=MAX(1,MIN(25,MHGH))
        NCNT=NLOW+NHGH
C
        DO 101 K=1,NCNT
          CCNT(1,K)=1.+(REAL(M)-1.)*FRAN()
          CCNT(2,K)=1.+(REAL(N)-1.)*FRAN()
          IF (K.LE.NLOW) THEN
            CCNT(3,K)=-1.
          ELSE
            CCNT(3,K)=+1.
          END IF
  101   CONTINUE
C
        DMIN=+1.E36
        DMAX=-1.E36
        DO 104 J=1,N
          DO 103 I=1,M
            DATA(I,J)=.5*(DLOW+DHGH)
            DO 102 K=1,NCNT
              TEMP=-((FOVM*(REAL(I)-CCNT(1,K)))**2+
     +               (FOVN*(REAL(J)-CCNT(2,K)))**2)
              IF (TEMP.GE.-20.) DATA(I,J)=DATA(I,J)+
     +            .5*(DHGH-DLOW)*CCNT(3,K)*EXP(TEMP)
  102       CONTINUE
            DMIN=MIN(DMIN,DATA(I,J))
            DMAX=MAX(DMAX,DATA(I,J))
  103     CONTINUE
  104   CONTINUE
C
        DO 106 J=1,N
          DO 105 I=1,M
            DATA(I,J)=(DATA(I,J)-DMIN)/(DMAX-DMIN)*(DHGH-DLOW)+DLOW
  105     CONTINUE
  106   CONTINUE
C
        RETURN
C
      END



      FUNCTION FRAN ()
C
C This routine generates "random" numbers for GENDAT.
C
        DIMENSION RSEQ (100)
C
        SAVE ISEQ
C
        DATA RSEQ / .749,.973,.666,.804,.081,.483,.919,.903,.951,.960 ,
     +              .039,.269,.270,.756,.222,.478,.621,.063,.550,.798 ,
     +              .027,.569,.149,.697,.451,.738,.508,.041,.266,.249 ,
     +              .019,.191,.266,.625,.492,.940,.508,.406,.972,.311 ,
     +              .757,.378,.299,.536,.619,.844,.342,.295,.447,.499 ,
     +              .688,.193,.225,.520,.954,.749,.997,.693,.217,.273 ,
     +              .961,.948,.902,.104,.495,.257,.524,.100,.492,.347 ,
     +              .981,.019,.225,.806,.678,.710,.235,.600,.994,.758 ,
     +              .682,.373,.009,.469,.203,.730,.588,.603,.213,.495 ,
     +              .884,.032,.185,.127,.010,.180,.689,.354,.372,.429 /
C
        DATA ISEQ / 0 /
C
        ISEQ=MOD(ISEQ,100)+1
        FRAN=RSEQ(ISEQ)
C
        RETURN
C
      END



      SUBROUTINE CPCHHL (IFLG)
C
C This routine is called just before and just after each action
C involving a high/low label.  A user version may take action to change
C the label.  This version also looks to see if the label is in an
C allowed position and, if not, blanks it out.
C
C IFLG is positive if an action is about to be taken, negative if the
C action has just been completed.  The action in question is implied
C by the absolute value of IFLG, as follows:
C
C   1 - deciding whether to put a high label at a given point
C   2 - filling the box around the label for a high
C   3 - drawing the label for a high
C   4 - outlining the box around the label for a high
C   5 - deciding whether to put a low label at a given point
C   6 - filling the box around the label for a low
C   7 - drawing the label for a low
C   8 - outlining the box around the label for a low
C
C CPCHHL may retrieve the value of the internal parameter 'ZDV', which
C is the value associated with the high or low being labelled.
C
C CPCHHL may retrieve the values of the internal parameters 'LBX' and
C 'LBY', which are the coordinates of the center point of the label,
C in the current user coordinate system.
C
C When IFLG is 1, 3, 5, or 7, CPCHHL is permitted to change the value
C of the internal parameter 'CTM' (a character string); if IFLG is 1 or
C 5 and 'CTM' is made blank, the label is suppressed; otherwise, the
C new value of 'CTM' will replace whatever CONPACK was about to use.
C If this is done for either IFLG = 1 or IFLG = 3, it must be done for
C both, and the same replacement label must be supplied in both cases.
C Similarly, if it is done for either IFLG = 5 or IFLG = 7, it must be
C done for both, and the same replacement label must be specified in
C both cases.
C
C When IFLG = 2, 3, 4, 6, 7, or 8, CPCHHL may make GKS calls to change
C color or line width; during the following call with IFLG = -2, -3,
C -4, -6, -7, or -8, such changes should be undone.
C
C Declare the common block containing the area map array that will be
C used in deciding where labels ought to be suppressed.
C
        COMMON /USRAMA/ IAMA(200000)
C
        DIMENSION IAAI(10),IAGI(10)
C
C Define quantities that will be used to generate the coordinates of
C five points to be tested in making the decision whether a label is
C over land or water.
C
        DIMENSION XSTP(5),YSTP(5)
C
        DATA XSTP / 0., -.01, .01,   0.,  0. /
        DATA YSTP / 0.,   0.,  0., -.01, .01 /
C
C If IFLG = 1, we have to decide whether we want a label at the point
C ('LBX','LBY') or not, and, if not, reset the value of 'CTM' to a
C single blank to signal that fact to the calling routine.  The decision
C is made by looking at an area map previously created in the array
C IAMA to see if the label point is over land or water.  We actually
C test the point itself and four other points around it; it any of
C the five is over land, we suppress the label (by setting 'CTM'=' ').
C
        IF (IFLG.EQ.1.OR.IFLG.EQ.5) THEN
          CALL CPGETR ('LBX',RLBX)
          CALL CPGETR ('LBY',RLBY)
          FLBX=CUFX(RLBX)
          FLBY=CUFY(RLBY)
          DO 102 I=1,5
            CALL ARGTAI (IAMA,CFUX(FLBX+XSTP(I)),CFUY(FLBY+YSTP(I)),
     +                                          IAAI,IAGI,10,NIDS,1)
            IAID=-1
            DO 101 J=1,NIDS
              IF (IAGI(J).EQ.1) IAID=IAAI(J)
  101       CONTINUE
            IF (MAPACI(IAID).EQ.2) THEN
              CALL CPSETC ('CTM - CHARACTER TEMPORARY',' ')
              RETURN
            END IF
  102     CONTINUE
        END IF
C
C Now, if the label box is being filled, make the fill color depend
C on whether the label is for a high or a low.
C
        IF (ABS(IFLG).EQ.2.OR.ABS(IFLG).EQ.6) THEN
          IF (IFLG.GT.0) THEN
            IF (IFLG.EQ.2) THEN
              CALL GSFACI (4)
            ELSE
              CALL GSFACI (2)
            END IF
          ELSE
            CALL GSFACI (1)
          END IF
          RETURN
        END IF
C
C Put the text on the filled background in a contrasting color.
C
        IF (ABS(IFLG).EQ.3.OR.ABS(IFLG).EQ.7) THEN
          IF (IFLG.GT.0) THEN
            IF (IFLG.EQ.3) THEN
              CALL PCSETI ('CC', 0)
            ELSE
              CALL PCSETI ('CC', 1)
            END IF
          ELSE
            CALL PCSETI ('CC',-1)
          END IF
          RETURN
        END IF
C
C If the box is being outlined, do it in a contrasting color and widen
C the lines.
C
        IF (ABS(IFLG).EQ.4.OR.ABS(IFLG).EQ.8) THEN
          IF (IFLG.GT.0) THEN
            IF (IFLG.EQ.4) THEN
C             CALL GSPLCI (2)
              CALL GSPLCI (0)
            ELSE
C             CALL GSPLCI (4)
              CALL GSPLCI (0)
            END IF
            CALL GSLWSC (2.)
          ELSE
            CALL GSPLCI (1)
            CALL GSLWSC (1.)
          END IF
          RETURN
        END IF
C
C In all other cases, just return.
C
        RETURN
C
      END



      SUBROUTINE CPCHLL (IFLG)
C
C This routine is called just before and just after each action
C involving a contour line label.  A user version may take action to
C change the label.  This version also looks to see if the label is
C in an allowed position and, if not, blanks it out.
C
C IFLG is positive if an action is about to be taken, negative if an
C action has just been completed.  The action in question is implied
C by the absolute value of IFLG, as follows:
C
C   1 - deciding whether to put a line label at a given point
C   2 - filling the box around a line label
C   3 - drawing a line label
C   4 - outlining the box around a line label
C
C When CPCHLL is called, the internal parameter 'PAI' will have been
C set to the index of the appropriate contour level.  Thus, parameters
C associated with that level may easily be retrieved by calls to CPGETx.
C
C CPCHLL may retrieve the value of the internal parameter 'ZDV', which
C is the contour level associated with the contour line being labelled.
C
C CPCHLL may retrieve the values of the internal parameters 'LBX' and
C 'LBY', which are the coordinates of the center point of the label,
C in the current user coordinate system.
C
C When IFLG is 1 or 3, CPCHLL is permitted to change the value of the
C internal parameter 'CTM' (a character string); if IFLG is 1 and 'CTM'
C is made blank, the label is suppressed; otherwise, the new value of
C 'CTM' will replace whatever CONPACK was about to use.  If this is
C done for either IFLG = 1 or IFLG = 3, it must be done for both, and
C the same replacement label must be supplied in both cases.
C
C When IFLG = 2, 3, or 4, CPCHLL may make GKS calls to change color
C or line width; during the following call with IFLG = -2, -3, or -4,
C such changes should be undone.
C
C Declare the common block containing the area map array that will be
C used in deciding where labels ought to be suppressed.
C
        COMMON /USRAMA/ IAMA(200000)
C
        DIMENSION IAAI(10),IAGI(10)
C
C Define quantities that will be used to generate the coordinates of
C five points to be tested in making the decision whether a label is
C over land or water.
C
        DIMENSION XSTP(5),YSTP(5)
C
        DATA XSTP / 0., -.01, .01,   0.,  0. /
        DATA YSTP / 0.,   0.,  0., -.01, .01 /
C
C If IFLG = 1, we have to decide whether we want a label at the point
C ('LBX','LBY') or not, and, if not, reset the value of 'CTM' to a
C single blank to signal that fact to the calling routine.  The decision
C is made by looking at an area map previously created in the array
C IAMA to see if the label point is over land or water.  We actually
C test the point itself and four other points around it; it any of
C the five is over land, we suppress the label (by setting the value
C of 'CTM' to ' ').
C
        IF (IFLG.EQ.1) THEN
          CALL CPGETR ('LBX',RLBX)
          CALL CPGETR ('LBY',RLBY)
          FLBX=CUFX(RLBX)
          FLBY=CUFY(RLBY)
          DO 102 I=1,5
            CALL ARGTAI (IAMA,CFUX(FLBX+XSTP(I)),CFUY(FLBY+YSTP(I)),
     +                                          IAAI,IAGI,10,NIDS,1)
            IAID=-1
            DO 101 J=1,NIDS
              IF (IAGI(J).EQ.1) IAID=IAAI(J)
  101       CONTINUE
            IF (MAPACI(IAID).EQ.2) THEN
              CALL CPSETC ('CTM - CHARACTER TEMPORARY',' ')
              RETURN
            END IF
  102     CONTINUE
        END IF
C
C Otherwise, see what the contour value is on the line being labelled
C and, if it's zero, reset the value of 'CTM' to 'Z' so that will be
C used as the label.
C
        CALL CPGETR ('ZDV - Z DATA VALUE',CLEV)
        IF (CLEV.EQ.0.) THEN
          CALL CPSETC ('CTM - CHARACTER TEMPORARY','Z')
        END IF
C
C Now, if the label box is being filled, make the fill color depend
C on the contour level.
C
        IF (ABS(IFLG).EQ.2) THEN
          IF (IFLG.GT.0) THEN
            IF (CLEV.LT.0.) THEN
              CALL GSFACI (2)
            ELSE IF (CLEV.EQ.0.) THEN
              CALL GSFACI (3)
            ELSE
              CALL GSFACI (4)
            END IF
          ELSE
            CALL GSFACI (1)
          END IF
          RETURN
        END IF
C
C Put the text on the filled background in a contrasting color.
C
        IF (ABS(IFLG).EQ.3) THEN
          IF (IFLG.GT.0) THEN
            IF (CLEV.LT.0.) THEN
              CALL PCSETI ('CC', 1)
            ELSE IF (CLEV.EQ.0.) THEN
              CALL PCSETI ('CC', 0)
            ELSE
              CALL PCSETI ('CC', 0)
            END IF
          ELSE
            CALL PCSETI ('CC',-1)
          END IF
          RETURN
        END IF
C
C If the box is being outlined, do it in a contrasting color and widen
C the lines.
C
        IF (ABS(IFLG).EQ.4) THEN
          IF (IFLG.GT.0) THEN
            IF (CLEV.LT.0.) THEN
C             CALL GSPLCI (4)
              CALL GSPLCI (0)
            ELSE IF (CLEV.EQ.0.) THEN
              CALL GSPLCI (0)
            ELSE
C             CALL GSPLCI (2)
              CALL GSPLCI (0)
            END IF
            CALL GSLWSC (2.)
          ELSE
            CALL GSPLCI (1)
            CALL GSLWSC (1.)
          END IF
          RETURN
        END IF
C
C In all other cases, just return.
C
        RETURN
C
      END

      SUBROUTINE ZPPSV( UPLO, N, NRHS, AP, B, LDB, INFO )
*
*  -- LAPACK driver routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     March 31, 1993
*
*     .. Scalar Arguments ..
      CHARACTER          UPLO
      INTEGER            INFO, LDB, N, NRHS
*     ..
*     .. Array Arguments ..
      COMPLEX*16         AP( * ), B( LDB, * )
*     ..
*
*  Purpose
*  =======
*
*  ZPPSV computes the solution to a complex system of linear equations
*     A * X = B,
*  where A is an N-by-N Hermitian positive definite matrix stored in
*  packed format and X and B are N-by-NRHS matrices.
*
*  The Cholesky decomposition is used to factor A as
*     A = U**H* U,  if UPLO = 'U', or
*     A = L * L**H,  if UPLO = 'L',
*  where U is an upper triangular matrix and L is a lower triangular
*  matrix.  The factored form of A is then used to solve the system of
*  equations A * X = B.
*
*  Arguments
*  =========
*
*  UPLO    (input) CHARACTER*1
*          = 'U':  Upper triangle of A is stored;
*          = 'L':  Lower triangle of A is stored.
*
*  N       (input) INTEGER
*          The number of linear equations, i.e., the order of the
*          matrix A.  N >= 0.
*
*  NRHS    (input) INTEGER
*          The number of right hand sides, i.e., the number of columns
*          of the matrix B.  NRHS >= 0.
*
*  AP      (input/output) COMPLEX*16 array, dimension (N*(N+1)/2)
*          On entry, the upper or lower triangle of the Hermitian matrix
*          A, packed columnwise in a linear array.  The j-th column of A
*          is stored in the array AP as follows:
*          if UPLO = 'U', AP(i + (j-1)*j/2) = A(i,j) for 1<=i<=j;
*          if UPLO = 'L', AP(i + (j-1)*(2n-j)/2) = A(i,j) for j<=i<=n.
*          See below for further details.
*
*          On exit, if INFO = 0, the factor U or L from the Cholesky
*          factorization A = U**H*U or A = L*L**H, in the same storage
*          format as A.
*
*  B       (input/output) COMPLEX*16 array, dimension (LDB,NRHS)
*          On entry, the N-by-NRHS right hand side matrix B.
*          On exit, if INFO = 0, the N-by-NRHS solution matrix X.
*
*  LDB     (input) INTEGER
*          The leading dimension of the array B.  LDB >= max(1,N).
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*          > 0:  if INFO = i, the leading minor of order i of A is not
*                positive definite, so the factorization could not be
*                completed, and the solution has not been computed.
*
*  Further Details
*  ===============
*
*  The packed storage scheme is illustrated by the following example
*  when N = 4, UPLO = 'U':
*
*  Two-dimensional storage of the Hermitian matrix A:
*
*     a11 a12 a13 a14
*         a22 a23 a24
*             a33 a34     (aij = conjg(aji))
*                 a44
*
*  Packed storage of the upper triangle of A:
*
*  AP = [ a11, a12, a22, a13, a23, a33, a14, a24, a34, a44 ]
*
*  =====================================================================
*
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           XERBLA, ZPPTRF, ZPPTRS
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      IF( .NOT.LSAME( UPLO, 'U' ) .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( NRHS.LT.0 ) THEN
         INFO = -3
      ELSE IF( LDB.LT.MAX( 1, N ) ) THEN
         INFO = -6
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'ZPPSV ', -INFO )
         RETURN
      END IF
*
*     Compute the Cholesky factorization A = U'*U or A = L*L'.
*
      CALL ZPPTRF( UPLO, N, AP, INFO )
      IF( INFO.EQ.0 ) THEN
*
*        Solve the system A*X = B, overwriting B with X.
*
         CALL ZPPTRS( UPLO, N, NRHS, AP, B, LDB, INFO )
*
      END IF
      RETURN
*
*     End of ZPPSV
*
      END

C
C	$Id: conssd.f,v 1.4 2008-07-27 00:16:55 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CONSSD(X,Y,IC)
C
C  THIS SUBROUTINE SETS THE SHIELDING FLAG AND CONNECTS THE
C  USERS SHIELD ARRAYS TO SOME INTERNAL POINTERS
C
C  INPUT
C       X-X COORDINATE STRING
C       Y-Y COORDINATE STRING
C       IC-NUMBER OF COORDINATES
C
C  NOTE THE USERS ARRAYS CANNOT BE MUCKED WITH DURING EXECUTION
C       THOSE ARRAYS ARE USED DURING CONRAN EXECUTION
C
      DIMENSION X(1),Y(1)
      COMMON /CONR13/XVS(50),YVS(50),ICOUNT,SPVAL,SHIELD,
     1               SLDPLT
      LOGICAL SHIELD,SLDPLT
C
        SAVE
C
C  SET COUNTER
C
      ICOUNT = IC
C
C  CHECK THE DIMENSION OF SHIELD ARRAYS
C
      IERUNT = I1MACH(4)
      IF (ICOUNT .GT. 50) THEN
        CALL SETER (' CONSSD -- NUMBER OF SHIELD POINTS .GT. 50',1,1)
        WRITE(IERUNT,1001)
        ICOUNT = 50
      ENDIF
 1001 FORMAT(' ERROR 1 IN CONSSD -- NUMBER OF SHIELD POINTS .GT. 50')
C
C  SET THE SHIELDING FLAG TO TRUE
C
      SHIELD = .TRUE.
C
C  COMPUTE POINTERS FOR THE USERS SHIELDING ARRAYS
C
      DO 300 I = 1,ICOUNT
        XVS(I) = X(I)
 300  YVS(I) = Y(I)
C
      RETURN
      END

C
C	$Id: shseti.f,v 1.5 2008-07-27 03:10:14 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE SHSETI (CNP,IVP)
C
      SAVE
C
      CHARACTER*(*) CNP
C
C  This subroutine is called to give an integer value to a specified
C  parameter.
C
C  CNP is the name of the parameter whose value is to be set.
C
C  IVP is an integer variable containing the desired value.
C
C
C  Declare a local character variable in which to form an error message.       
C
      CHARACTER*80 CTM
C
      include 'shcomn.h'
C
C  Do a call forcing a BLOCKDATA to be loaded from a binary library.
C
      CALL SHBLDA
C
C  Check for an uncleared prior error.
C
      IF (ICFELL('SHSETI - Uncleared prior error',1) .NE. 0) RETURN
C
C  Check for a parameter name that is too short.
C
      IF (LEN(CNP) .LT. 3) THEN
        CTM(1:36) = 'SHSETI - Parameter name too short - '
        CTM(37:36+LEN(CNP)) = CNP
        CALL SETER (CTM(1:36+LEN(CNP)), 1, 1)
        GO TO 120
      ENDIF
C
C  Do a crude check to see if IVP is within range (primarily to 
C  make sure that a floating point number has not been supplied).
C
      IF (IVP .GT. 10000000) THEN
        CTM(1:42) = 'SHSETI - Parameter value out of range for '
        CTM(43:45) = CNP(1:3)
        CALL SETER (CTM(1:45), 2, 1)
        GO TO 120
      ENDIF
C
C  NFL - Number of nodes within the radius of influence.
C
      IF (CNP(1:3).EQ.'NFL' .OR. CNP(1:3).EQ.'nfl' .OR.
     +    CNP(1:3).EQ.'Nfl') THEN
        IF (IVP .LT. 1) THEN
          CTM(1:42) = 'SHSETI - Parameter value out of range for '
          CTM(43:45) = CNP(1:3)
          CALL SETER (CTM(1:45), 2, 1)
          GO TO 120
        ENDIF
        NMINFL = IVP
        GO TO 120
C
C  NCL - Number of rows, columns, planes in the cell grid.
C
      ELSE IF (CNP(1:3).EQ.'NCL' .OR. CNP(1:3).EQ.'ncl' .OR.
     +    CNP(1:3).EQ.'Ncl') THEN
        IF (IVP .LT. 1) THEN
          CTM(1:42) = 'SHSETI - Parameter value out of range for '
          CTM(43:45) = CNP(1:3)
          CALL SETER (CTM(1:45), 2, 1)
          GO TO 120
        ENDIF
        NMCELS = IVP
        GO TO 120
C
C  NLS - Number of data points used in least squares fit.
C
      ELSE IF (CNP(1:3).EQ.'NLS' .OR. CNP(1:3).EQ.'nls' .OR.
     +    CNP(1:3).EQ.'Nls') THEN
        IF (IVP .LT. 9) THEN
          CTM(1:42) = 'SHSETI - Parameter value out of range for '
          CTM(43:45) = CNP(1:3)
          CALL SETER (CTM(1:45), 2, 1)
          GO TO 120
        ENDIF
        IF (IVP .LT. 9) THEN
           CALL SHERR (2,'SHSETI - NLS must be .GT. 9',27)
        ENDIF
        NMLSTQ = IVP
        GO TO 120
      ELSE
        CTM(1:36) = 'SHSETI - Parameter name not known - '
        CTM(37:39) = CNP(1:3)
        CALL SETER (CTM(1:39), 23, 1)
        GO TO 120
      ENDIF
C
  120 CONTINUE
      RETURN
      END

      SUBROUTINE DCZ2CCM(PS,PHIS,TV,P0,HYAM,HYBM,HYAI,HYBI,MLON,NLAT,
     +                  KLEV,KLEV1,Z2,PMLN,HYPDLN,HYALPH,ZSLICE,HYBA,
     +                  HYBB,PTERM,TV2)
c c c implicit none

C NCL: z2 = cz2ccm (ps,phis,tv,p0,hyam,hybm,hyai,hybi)

      INTEGER MLON,NLAT,KLEV
      DOUBLE PRECISION PS(MLON,NLAT),PHIS(MLON,NLAT),TV(MLON,NLAT,KLEV),
     +                 P0,HYAM(KLEV),HYBM(KLEV),HYAI(KLEV1),HYBI(KLEV1)

C Array to hold 2D tv values
      DOUBLE PRECISION TV2(MLON,KLEV)

C OUTPUT: geopotential at midlayer
      DOUBLE PRECISION Z2(MLON,NLAT,KLEV)

C logs of midpoint pressures
C log p layer thickness
C distance from interface to level
C calculated Z for vertical slice
C Hybrid coord coeffs: =1 interface
C Hybrid coord coeffs: =2 midlayer
C vertical scratch space
      DOUBLE PRECISION PMLN(MLON,KLEV+1),HYPDLN(MLON,KLEV),
     +                 HYALPH(MLON,KLEV),ZSLICE(MLON,KLEV),
     +                 HYBA(2,KLEV+1),HYBB(2,KLEV+1),PTERM(MLON,KLEV)

      DOUBLE PRECISION ZMSG,HPRB
      INTEGER KL,ML,NL

C Scratch arrays

      ZMSG = 1.D+36
C Hybrid base pressure (pascals)
      HPRB = P0

      DO I = 1,KLEV
          DO J = 1,NLAT
              DO K = 1,MLON
C initilize to zero.
                  Z2(K,J,I) = 0.0D0
              END DO
          END DO
      END DO
      DO I = 1,KLEV
          DO K = 1,MLON
              HYPDLN(K,I) = 0.0D0
              HYALPH(K,I) = 0.0D0
              ZSLICE(K,I) = 0.0D0
              PTERM(K,I) = 0.0D0
          END DO
      END DO

      DO I = 1,KLEV + 1
          DO K = 1,2
              HYBA(K,I) = 0.0D0
              HYBB(K,I) = 0.0D0
          END DO
      END DO
C copy to temporary arrays

C required by "cz2"
      DO KL = 1,KLEV + 1
C interface=1
          HYBA(1,KL) = HYAI(KL)
          HYBB(1,KL) = HYBI(KL)
      END DO

      DO KL = 1,KLEV
C mid-points=2
          HYBA(2,KL+1) = HYAM(KL)
          HYBB(2,KL+1) = HYBM(KL)
      END DO

C one vertical slice (mlon,klev) at atime

      DO NL = 1,NLAT
          DO J = 1,KLEV
              DO I = 1,MLON
                  TV2(I,J) = TV(I,NL,J)
              END DO
          END DO

          CALL DCZ2(PS(1,NL),PHIS(1,NL),TV2,HPRB,HYBA,HYBB,KLEV,MLON,
     +             MLON,PMLN,HYPDLN,HYALPH,PTERM,ZSLICE)

          DO KL = 1,KLEV
              DO ML = 1,MLON
                  Z2(ML,NL,KL) = ZSLICE(ML,KL)
              END DO
          END DO
C end nl
      END DO

      RETURN
      END
c +++
      SUBROUTINE DCZ2(PS,PHIS,TV,HPRB,HYBA,HYBB,KMAX,IDIM,IMAX,PMLN,
     +               HYPDLN,HYALPH,PTERM,Z2)
c-----------------------------------------------------------------------
c
c       File:   /u3/ccmproc2/src/src/cz2.F  (7169 bytes)
c       Date:   Wed Oct 25 14:17:31 1995
c       Author: CCM Processor <ccmproc2@sol>
c
c       From:   inderf
c       Calls:  ** none **
c       Blocks: ** none **
c
c-----------------------------------------------------------------------
c
c       Purpose:
c         To compute geopotential height for a CCM2 hybrid coordinate
c         vertical slice.  Since the vertical integration matrix is a
c         function of latitude and longitude, it is not explicitly
c         computed as for sigma coordinates.  The integration algorithm
c         is derived from Boville's mods in the ibm file hybrid 1mods
c         (6/17/88).  All vertical slice arrays are oriented top to
c         bottom as in CCM2.  This field is on full model levels (aka
c         "midpoints") not half levels.
c
c       Equation references are to "Hybrid Coordinates for CCM1"
c
c----------------------------Code History-------------------------------
c
c       Original: Jun 25 1991  L Buja
c       Upgrades: Apr 21 1993  L Buja
c                     Truesdale reports difference from CCM2 Z2.
c                     - Make pterm a scratch array (was automatic)
c                     - Make g0=9.80616 (was 9.81).  This appears to
c                        affect only the lowest layer.
c       Change  : Feb    1999: D Shea
c                     NCL changes + error
c                     - The "Invert vertical loop" has to have
c                        the argument checked for >0.0
c
c-----------------------------------------------------------------------
      IMPLICIT NONE
c-----------------------------Parameters--------------------------------
c
      DOUBLE PRECISION R,G0,RBYG
      PARAMETER (R=287.04D0,G0=9.80616D0,RBYG=R/G0)
c
c-----------------------------Arguments---------------------------------
c
c Input
c
C Longitude dimension
      INTEGER IDIM
C Number of vertical levels
      INTEGER KMAX
C Surface pressure           (pascals)
      DOUBLE PRECISION PS(IDIM)
C Surface geoptential
      DOUBLE PRECISION PHIS(IDIM)
C Virtual temperature, top to bottom
      DOUBLE PRECISION TV(IDIM,KMAX)
C Hybrid base pressure       (pascals)
      DOUBLE PRECISION HPRB
C Hybrid coord coeffs for base pressure
      DOUBLE PRECISION HYBA(2,KMAX+1)
C  ground to top, first subscript:

C  = 1 for layer interfaces

C  = 2 for layer midpoints

C  Lowest level is ground for both layer

C    locations

C Hybrid coord coeffs for surf pressure
      DOUBLE PRECISION HYBB(2,KMAX+1)
C   (in same format as hyba)

C Num of longitude points to compute
      INTEGER IMAX
C vertical slice scratch space used to
      DOUBLE PRECISION PMLN(IDIM,KMAX+1)
C   hold logs of midpoint pressures

C Vertical slice scratch space used to
      DOUBLE PRECISION HYPDLN(IDIM,KMAX)
C   hold log p layer thichkess

C Vertical slice scratch space used to
      DOUBLE PRECISION HYALPH(IDIM,KMAX)
C hold distance from interface to level

C during vertical integration

C Note: These scratch vertical slices

C       are used to improve computaional

C       efficiency

C Vertical scratch space.
      DOUBLE PRECISION PTERM(IDIM,KMAX)
C TEMPORARY
      DOUBLE PRECISION ARG
c
c Output
c
C Geopotential height, top to bottom
      DOUBLE PRECISION Z2(IDIM,KMAX)
c
c--------------------------Local variables------------------------------
c
C indexes
      INTEGER I,K,L,NUM
c
c-----------------------------------------------------------------------
c
      DATA NUM/0/

      NUM = NUM + 1
c
c       All arrays except hyba, hybb are oriented top to bottom

c       Compute intermediate quantities using scratch space
c       pmln(i,k+1) is pressure at the midpoint of layer k

      DO I = 1,IMAX
          PMLN(I,1) = DLOG(HPRB*HYBA(2,KMAX)+PS(I)*HYBB(1,KMAX))
          PMLN(I,KMAX+1) = DLOG(HPRB*HYBA(2,1)+PS(I)*HYBB(1,1))
      END DO

c       Invert vertical loop
c       Compute top only if top interface pressure is nonzero.
c       Implemented by setting loop limit klim
c
c       hyba, hybb are bottom to top, starting at ground.
c       pmln(i,k) is the mid-point pressure of layer k.
c       SHEA MODIFICATION

      DO K = KMAX + 1,1,-1
          DO I = 1,IMAX
c DJS     pmln(i,k) = alog(hprb*hyba(2,kmax-k+2)+ps(i)*hybb(2,kmax-k+2))
              ARG = HPRB*HYBA(2,KMAX-K+2) + PS(I)*HYBB(2,KMAX-K+2)
              IF (ARG.GT.0.D0) THEN
                  PMLN(I,K) = DLOG(ARG)
              ELSE
                  PMLN(I,K) = 0.0D0
              END IF
          END DO
      END DO
c
c       Initialize Z2 to sum of ground height and thickness of
c        top half-layer  (i.e. (phi)sfc in equation 1.14)

c       (Z2(i,1)=top  ->  Z2(i,kmax)=bottom

C*PL*ERROR* Comment line too long
c       Eq 3.a.109.2  where l=K,k<K  h(k,l) = 1/2 * ln [  p(k+1) / p(k) ]

      DO K = 2,KMAX - 1
          DO I = 1,IMAX
              PTERM(I,K) = RBYG*TV(I,K)*0.5D0* (PMLN(I,K+1)-PMLN(I,K-1))
          END DO
      END DO

C 3.a.109.2
      DO K = 1,KMAX - 1
          DO I = 1,IMAX
              Z2(I,K) = PHIS(I)/G0 + RBYG*TV(I,K)*0.5D0*
     +                  (PMLN(I,K+1)-PMLN(I,K))
          END DO
      END DO

c       Eq 3.a.109.5  where l=K,k=K  h(k,l) = ln [ pi / (p(k)) ]

      K = KMAX
C 3.a.109.5
      DO I = 1,IMAX
          Z2(I,K) = PHIS(I)/G0 + RBYG*TV(I,K)*
     +              (DLOG(PS(I)*HYBB(1,1))-PMLN(I,K))

      END DO

c       Eq 3.a.109.4  where l=K,k<K  h(k,l) = 1/2*ln[pi*pi/(p(k-1)*p(k))

C 3.a.109.4
      DO K = 1,KMAX - 1
          L = KMAX
          DO I = 1,IMAX
              Z2(I,K) = Z2(I,K) + RBYG*TV(I,L)*
     +                  (DLOG(PS(I)*HYBB(1,1))-0.5D0*
     +                  (PMLN(I,L-1)+PMLN(I,L)))
          END DO
      END DO

c       Add thickness of the remaining full layers
c        (i.e., integrate from ground to highest layer interface)

c       Eqs 1.14 & 3.a.109.3 where l>K, k<K
c                                h(k,l) = 1/2 * ln [ p(l+1)/p(l-1) ]

C 3.a.109.3
      DO K = 1,KMAX - 2
          DO L = K + 1,KMAX - 1
              DO I = 1,IMAX
                  Z2(I,K) = Z2(I,K) + PTERM(I,L)
              END DO
          END DO
      END DO

      RETURN
      END

      SUBROUTINE ZLAHEF( UPLO, N, NB, KB, A, LDA, IPIV, W, LDW, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER          UPLO
      INTEGER            INFO, KB, LDA, LDW, N, NB
*     ..
*     .. Array Arguments ..
      INTEGER            IPIV( * )
      COMPLEX*16         A( LDA, * ), W( LDW, * )
*     ..
*
*  Purpose
*  =======
*
*  ZLAHEF computes a partial factorization of a complex Hermitian
*  matrix A using the Bunch-Kaufman diagonal pivoting method. The
*  partial factorization has the form:
*
*  A  =  ( I  U12 ) ( A11  0  ) (  I    0   )  if UPLO = 'U', or:
*        ( 0  U22 ) (  0   D  ) ( U12' U22' )
*
*  A  =  ( L11  0 ) (  D   0  ) ( L11' L21' )  if UPLO = 'L'
*        ( L21  I ) (  0  A22 ) (  0    I   )
*
*  where the order of D is at most NB. The actual order is returned in
*  the argument KB, and is either NB or NB-1, or N if N <= NB.
*  Note that U' denotes the conjugate transpose of U.
*
*  ZLAHEF is an auxiliary routine called by ZHETRF. It uses blocked code
*  (calling Level 3 BLAS) to update the submatrix A11 (if UPLO = 'U') or
*  A22 (if UPLO = 'L').
*
*  Arguments
*  =========
*
*  UPLO    (input) CHARACTER*1
*          Specifies whether the upper or lower triangular part of the
*          Hermitian matrix A is stored:
*          = 'U':  Upper triangular
*          = 'L':  Lower triangular
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  NB      (input) INTEGER
*          The maximum number of columns of the matrix A that should be
*          factored.  NB should be at least 2 to allow for 2-by-2 pivot
*          blocks.
*
*  KB      (output) INTEGER
*          The number of columns of A that were actually factored.
*          KB is either NB-1 or NB, or N if N <= NB.
*
*  A       (input/output) COMPLEX*16 array, dimension (LDA,N)
*          On entry, the Hermitian matrix A.  If UPLO = 'U', the leading
*          n-by-n upper triangular part of A contains the upper
*          triangular part of the matrix A, and the strictly lower
*          triangular part of A is not referenced.  If UPLO = 'L', the
*          leading n-by-n lower triangular part of A contains the lower
*          triangular part of the matrix A, and the strictly upper
*          triangular part of A is not referenced.
*          On exit, A contains details of the partial factorization.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(1,N).
*
*  IPIV    (output) INTEGER array, dimension (N)
*          Details of the interchanges and the block structure of D.
*          If UPLO = 'U', only the last KB elements of IPIV are set;
*          if UPLO = 'L', only the first KB elements are set.
*
*          If IPIV(k) > 0, then rows and columns k and IPIV(k) were
*          interchanged and D(k,k) is a 1-by-1 diagonal block.
*          If UPLO = 'U' and IPIV(k) = IPIV(k-1) < 0, then rows and
*          columns k-1 and -IPIV(k) were interchanged and D(k-1:k,k-1:k)
*          is a 2-by-2 diagonal block.  If UPLO = 'L' and IPIV(k) =
*          IPIV(k+1) < 0, then rows and columns k+1 and -IPIV(k) were
*          interchanged and D(k:k+1,k:k+1) is a 2-by-2 diagonal block.
*
*  W       (workspace) COMPLEX*16 array, dimension (LDW,NB)
*
*  LDW     (input) INTEGER
*          The leading dimension of the array W.  LDW >= max(1,N).
*
*  INFO    (output) INTEGER
*          = 0: successful exit
*          > 0: if INFO = k, D(k,k) is exactly zero.  The factorization
*               has been completed, but the block diagonal matrix D is
*               exactly singular.
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO, ONE
      PARAMETER          ( ZERO = 0.0D+0, ONE = 1.0D+0 )
      COMPLEX*16         CONE
      PARAMETER          ( CONE = ( 1.0D+0, 0.0D+0 ) )
      DOUBLE PRECISION   EIGHT, SEVTEN
      PARAMETER          ( EIGHT = 8.0D+0, SEVTEN = 17.0D+0 )
*     ..
*     .. Local Scalars ..
      INTEGER            IMAX, J, JB, JJ, JMAX, JP, K, KK, KKW, KP,
     $                   KSTEP, KW
      DOUBLE PRECISION   ABSAKK, ALPHA, COLMAX, R1, ROWMAX, T
      COMPLEX*16         D11, D21, D22, Z
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            IZAMAX
      EXTERNAL           LSAME, IZAMAX
*     ..
*     .. External Subroutines ..
      EXTERNAL           ZCOPY, ZDSCAL, ZGEMM, ZGEMV, ZLACGV, ZSWAP
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, DBLE, DCONJG, DIMAG, MAX, MIN, SQRT
*     ..
*     .. Statement Functions ..
      DOUBLE PRECISION   CABS1
*     ..
*     .. Statement Function definitions ..
      CABS1( Z ) = ABS( DBLE( Z ) ) + ABS( DIMAG( Z ) )
*     ..
*     .. Executable Statements ..
*
      INFO = 0
*
*     Initialize ALPHA for use in choosing pivot block size.
*
      ALPHA = ( ONE+SQRT( SEVTEN ) ) / EIGHT
*
      IF( LSAME( UPLO, 'U' ) ) THEN
*
*        Factorize the trailing columns of A using the upper triangle
*        of A and working backwards, and compute the matrix W = U12*D
*        for use in updating A11 (note that conjg(W) is actually stored)
*
*        K is the main loop index, decreasing from N in steps of 1 or 2
*
*        KW is the column of W which corresponds to column K of A
*
         K = N
   10    CONTINUE
         KW = NB + K - N
*
*        Exit from loop
*
         IF( ( K.LE.N-NB+1 .AND. NB.LT.N ) .OR. K.LT.1 )
     $      GO TO 30
*
*        Copy column K of A to column KW of W and update it
*
         CALL ZCOPY( K-1, A( 1, K ), 1, W( 1, KW ), 1 )
         W( K, KW ) = DBLE( A( K, K ) )
         IF( K.LT.N ) THEN
            CALL ZGEMV( 'No transpose', K, N-K, -CONE, A( 1, K+1 ), LDA,
     $                  W( K, KW+1 ), LDW, CONE, W( 1, KW ), 1 )
            W( K, KW ) = DBLE( W( K, KW ) )
         END IF
*
         KSTEP = 1
*
*        Determine rows and columns to be interchanged and whether
*        a 1-by-1 or 2-by-2 pivot block will be used
*
         ABSAKK = ABS( DBLE( W( K, KW ) ) )
*
*        IMAX is the row-index of the largest off-diagonal element in
*        column K, and COLMAX is its absolute value
*
         IF( K.GT.1 ) THEN
            IMAX = IZAMAX( K-1, W( 1, KW ), 1 )
            COLMAX = CABS1( W( IMAX, KW ) )
         ELSE
            COLMAX = ZERO
         END IF
*
         IF( MAX( ABSAKK, COLMAX ).EQ.ZERO ) THEN
*
*           Column K is zero: set INFO and continue
*
            IF( INFO.EQ.0 )
     $         INFO = K
            KP = K
            A( K, K ) = DBLE( A( K, K ) )
         ELSE
            IF( ABSAKK.GE.ALPHA*COLMAX ) THEN
*
*              no interchange, use 1-by-1 pivot block
*
               KP = K
            ELSE
*
*              Copy column IMAX to column KW-1 of W and update it
*
               CALL ZCOPY( IMAX-1, A( 1, IMAX ), 1, W( 1, KW-1 ), 1 )
               W( IMAX, KW-1 ) = DBLE( A( IMAX, IMAX ) )
               CALL ZCOPY( K-IMAX, A( IMAX, IMAX+1 ), LDA,
     $                     W( IMAX+1, KW-1 ), 1 )
               CALL ZLACGV( K-IMAX, W( IMAX+1, KW-1 ), 1 )
               IF( K.LT.N ) THEN
                  CALL ZGEMV( 'No transpose', K, N-K, -CONE,
     $                        A( 1, K+1 ), LDA, W( IMAX, KW+1 ), LDW,
     $                        CONE, W( 1, KW-1 ), 1 )
                  W( IMAX, KW-1 ) = DBLE( W( IMAX, KW-1 ) )
               END IF
*
*              JMAX is the column-index of the largest off-diagonal
*              element in row IMAX, and ROWMAX is its absolute value
*
               JMAX = IMAX + IZAMAX( K-IMAX, W( IMAX+1, KW-1 ), 1 )
               ROWMAX = CABS1( W( JMAX, KW-1 ) )
               IF( IMAX.GT.1 ) THEN
                  JMAX = IZAMAX( IMAX-1, W( 1, KW-1 ), 1 )
                  ROWMAX = MAX( ROWMAX, CABS1( W( JMAX, KW-1 ) ) )
               END IF
*
               IF( ABSAKK.GE.ALPHA*COLMAX*( COLMAX / ROWMAX ) ) THEN
*
*                 no interchange, use 1-by-1 pivot block
*
                  KP = K
               ELSE IF( ABS( DBLE( W( IMAX, KW-1 ) ) ).GE.ALPHA*ROWMAX )
     $                   THEN
*
*                 interchange rows and columns K and IMAX, use 1-by-1
*                 pivot block
*
                  KP = IMAX
*
*                 copy column KW-1 of W to column KW
*
                  CALL ZCOPY( K, W( 1, KW-1 ), 1, W( 1, KW ), 1 )
               ELSE
*
*                 interchange rows and columns K-1 and IMAX, use 2-by-2
*                 pivot block
*
                  KP = IMAX
                  KSTEP = 2
               END IF
            END IF
*
            KK = K - KSTEP + 1
            KKW = NB + KK - N
*
*           Updated column KP is already stored in column KKW of W
*
            IF( KP.NE.KK ) THEN
*
*              Copy non-updated column KK to column KP
*
               A( KP, KP ) = DBLE( A( KK, KK ) )
               CALL ZCOPY( KK-1-KP, A( KP+1, KK ), 1, A( KP, KP+1 ),
     $                     LDA )
               CALL ZLACGV( KK-1-KP, A( KP, KP+1 ), LDA )
               CALL ZCOPY( KP-1, A( 1, KK ), 1, A( 1, KP ), 1 )
*
*              Interchange rows KK and KP in last KK columns of A and W
*
               IF( KK.LT.N )
     $            CALL ZSWAP( N-KK, A( KK, KK+1 ), LDA, A( KP, KK+1 ),
     $                        LDA )
               CALL ZSWAP( N-KK+1, W( KK, KKW ), LDW, W( KP, KKW ),
     $                     LDW )
            END IF
*
            IF( KSTEP.EQ.1 ) THEN
*
*              1-by-1 pivot block D(k): column KW of W now holds
*
*              W(k) = U(k)*D(k)
*
*              where U(k) is the k-th column of U
*
*              Store U(k) in column k of A
*
               CALL ZCOPY( K, W( 1, KW ), 1, A( 1, K ), 1 )
               R1 = ONE / DBLE( A( K, K ) )
               CALL ZDSCAL( K-1, R1, A( 1, K ), 1 )
*
*              Conjugate W(k)
*
               CALL ZLACGV( K-1, W( 1, KW ), 1 )
            ELSE
*
*              2-by-2 pivot block D(k): columns KW and KW-1 of W now
*              hold
*
*              ( W(k-1) W(k) ) = ( U(k-1) U(k) )*D(k)
*
*              where U(k) and U(k-1) are the k-th and (k-1)-th columns
*              of U
*
               IF( K.GT.2 ) THEN
*
*                 Store U(k) and U(k-1) in columns k and k-1 of A
*
                  D21 = W( K-1, KW )
                  D11 = W( K, KW ) / DCONJG( D21 )
                  D22 = W( K-1, KW-1 ) / D21
                  T = ONE / ( DBLE( D11*D22 )-ONE )
                  D21 = T / D21
                  DO 20 J = 1, K - 2
                     A( J, K-1 ) = D21*( D11*W( J, KW-1 )-W( J, KW ) )
                     A( J, K ) = DCONJG( D21 )*
     $                           ( D22*W( J, KW )-W( J, KW-1 ) )
   20             CONTINUE
               END IF
*
*              Copy D(k) to A
*
               A( K-1, K-1 ) = W( K-1, KW-1 )
               A( K-1, K ) = W( K-1, KW )
               A( K, K ) = W( K, KW )
*
*              Conjugate W(k) and W(k-1)
*
               CALL ZLACGV( K-1, W( 1, KW ), 1 )
               CALL ZLACGV( K-2, W( 1, KW-1 ), 1 )
            END IF
         END IF
*
*        Store details of the interchanges in IPIV
*
         IF( KSTEP.EQ.1 ) THEN
            IPIV( K ) = KP
         ELSE
            IPIV( K ) = -KP
            IPIV( K-1 ) = -KP
         END IF
*
*        Decrease K and return to the start of the main loop
*
         K = K - KSTEP
         GO TO 10
*
   30    CONTINUE
*
*        Update the upper triangle of A11 (= A(1:k,1:k)) as
*
*        A11 := A11 - U12*D*U12' = A11 - U12*W'
*
*        computing blocks of NB columns at a time (note that conjg(W) is
*        actually stored)
*
         DO 50 J = ( ( K-1 ) / NB )*NB + 1, 1, -NB
            JB = MIN( NB, K-J+1 )
*
*           Update the upper triangle of the diagonal block
*
            DO 40 JJ = J, J + JB - 1
               A( JJ, JJ ) = DBLE( A( JJ, JJ ) )
               CALL ZGEMV( 'No transpose', JJ-J+1, N-K, -CONE,
     $                     A( J, K+1 ), LDA, W( JJ, KW+1 ), LDW, CONE,
     $                     A( J, JJ ), 1 )
               A( JJ, JJ ) = DBLE( A( JJ, JJ ) )
   40       CONTINUE
*
*           Update the rectangular superdiagonal block
*
            CALL ZGEMM( 'No transpose', 'Transpose', J-1, JB, N-K,
     $                  -CONE, A( 1, K+1 ), LDA, W( J, KW+1 ), LDW,
     $                  CONE, A( 1, J ), LDA )
   50    CONTINUE
*
*        Put U12 in standard form by partially undoing the interchanges
*        in columns k+1:n
*
         J = K + 1
   60    CONTINUE
         JJ = J
         JP = IPIV( J )
         IF( JP.LT.0 ) THEN
            JP = -JP
            J = J + 1
         END IF
         J = J + 1
         IF( JP.NE.JJ .AND. J.LE.N )
     $      CALL ZSWAP( N-J+1, A( JP, J ), LDA, A( JJ, J ), LDA )
         IF( J.LE.N )
     $      GO TO 60
*
*        Set KB to the number of columns factorized
*
         KB = N - K
*
      ELSE
*
*        Factorize the leading columns of A using the lower triangle
*        of A and working forwards, and compute the matrix W = L21*D
*        for use in updating A22 (note that conjg(W) is actually stored)
*
*        K is the main loop index, increasing from 1 in steps of 1 or 2
*
         K = 1
   70    CONTINUE
*
*        Exit from loop
*
         IF( ( K.GE.NB .AND. NB.LT.N ) .OR. K.GT.N )
     $      GO TO 90
*
*        Copy column K of A to column K of W and update it
*
         W( K, K ) = DBLE( A( K, K ) )
         IF( K.LT.N )
     $      CALL ZCOPY( N-K, A( K+1, K ), 1, W( K+1, K ), 1 )
         CALL ZGEMV( 'No transpose', N-K+1, K-1, -CONE, A( K, 1 ), LDA,
     $               W( K, 1 ), LDW, CONE, W( K, K ), 1 )
         W( K, K ) = DBLE( W( K, K ) )
*
         KSTEP = 1
*
*        Determine rows and columns to be interchanged and whether
*        a 1-by-1 or 2-by-2 pivot block will be used
*
         ABSAKK = ABS( DBLE( W( K, K ) ) )
*
*        IMAX is the row-index of the largest off-diagonal element in
*        column K, and COLMAX is its absolute value
*
         IF( K.LT.N ) THEN
            IMAX = K + IZAMAX( N-K, W( K+1, K ), 1 )
            COLMAX = CABS1( W( IMAX, K ) )
         ELSE
            COLMAX = ZERO
         END IF
*
         IF( MAX( ABSAKK, COLMAX ).EQ.ZERO ) THEN
*
*           Column K is zero: set INFO and continue
*
            IF( INFO.EQ.0 )
     $         INFO = K
            KP = K
            A( K, K ) = DBLE( A( K, K ) )
         ELSE
            IF( ABSAKK.GE.ALPHA*COLMAX ) THEN
*
*              no interchange, use 1-by-1 pivot block
*
               KP = K
            ELSE
*
*              Copy column IMAX to column K+1 of W and update it
*
               CALL ZCOPY( IMAX-K, A( IMAX, K ), LDA, W( K, K+1 ), 1 )
               CALL ZLACGV( IMAX-K, W( K, K+1 ), 1 )
               W( IMAX, K+1 ) = DBLE( A( IMAX, IMAX ) )
               IF( IMAX.LT.N )
     $            CALL ZCOPY( N-IMAX, A( IMAX+1, IMAX ), 1,
     $                        W( IMAX+1, K+1 ), 1 )
               CALL ZGEMV( 'No transpose', N-K+1, K-1, -CONE, A( K, 1 ),
     $                     LDA, W( IMAX, 1 ), LDW, CONE, W( K, K+1 ),
     $                     1 )
               W( IMAX, K+1 ) = DBLE( W( IMAX, K+1 ) )
*
*              JMAX is the column-index of the largest off-diagonal
*              element in row IMAX, and ROWMAX is its absolute value
*
               JMAX = K - 1 + IZAMAX( IMAX-K, W( K, K+1 ), 1 )
               ROWMAX = CABS1( W( JMAX, K+1 ) )
               IF( IMAX.LT.N ) THEN
                  JMAX = IMAX + IZAMAX( N-IMAX, W( IMAX+1, K+1 ), 1 )
                  ROWMAX = MAX( ROWMAX, CABS1( W( JMAX, K+1 ) ) )
               END IF
*
               IF( ABSAKK.GE.ALPHA*COLMAX*( COLMAX / ROWMAX ) ) THEN
*
*                 no interchange, use 1-by-1 pivot block
*
                  KP = K
               ELSE IF( ABS( DBLE( W( IMAX, K+1 ) ) ).GE.ALPHA*ROWMAX )
     $                   THEN
*
*                 interchange rows and columns K and IMAX, use 1-by-1
*                 pivot block
*
                  KP = IMAX
*
*                 copy column K+1 of W to column K
*
                  CALL ZCOPY( N-K+1, W( K, K+1 ), 1, W( K, K ), 1 )
               ELSE
*
*                 interchange rows and columns K+1 and IMAX, use 2-by-2
*                 pivot block
*
                  KP = IMAX
                  KSTEP = 2
               END IF
            END IF
*
            KK = K + KSTEP - 1
*
*           Updated column KP is already stored in column KK of W
*
            IF( KP.NE.KK ) THEN
*
*              Copy non-updated column KK to column KP
*
               A( KP, KP ) = DBLE( A( KK, KK ) )
               CALL ZCOPY( KP-KK-1, A( KK+1, KK ), 1, A( KP, KK+1 ),
     $                     LDA )
               CALL ZLACGV( KP-KK-1, A( KP, KK+1 ), LDA )
               IF( KP.LT.N )
     $            CALL ZCOPY( N-KP, A( KP+1, KK ), 1, A( KP+1, KP ), 1 )
*
*              Interchange rows KK and KP in first KK columns of A and W
*
               CALL ZSWAP( KK-1, A( KK, 1 ), LDA, A( KP, 1 ), LDA )
               CALL ZSWAP( KK, W( KK, 1 ), LDW, W( KP, 1 ), LDW )
            END IF
*
            IF( KSTEP.EQ.1 ) THEN
*
*              1-by-1 pivot block D(k): column k of W now holds
*
*              W(k) = L(k)*D(k)
*
*              where L(k) is the k-th column of L
*
*              Store L(k) in column k of A
*
               CALL ZCOPY( N-K+1, W( K, K ), 1, A( K, K ), 1 )
               IF( K.LT.N ) THEN
                  R1 = ONE / DBLE( A( K, K ) )
                  CALL ZDSCAL( N-K, R1, A( K+1, K ), 1 )
*
*                 Conjugate W(k)
*
                  CALL ZLACGV( N-K, W( K+1, K ), 1 )
               END IF
            ELSE
*
*              2-by-2 pivot block D(k): columns k and k+1 of W now hold
*
*              ( W(k) W(k+1) ) = ( L(k) L(k+1) )*D(k)
*
*              where L(k) and L(k+1) are the k-th and (k+1)-th columns
*              of L
*
               IF( K.LT.N-1 ) THEN
*
*                 Store L(k) and L(k+1) in columns k and k+1 of A
*
                  D21 = W( K+1, K )
                  D11 = W( K+1, K+1 ) / D21
                  D22 = W( K, K ) / DCONJG( D21 )
                  T = ONE / ( DBLE( D11*D22 )-ONE )
                  D21 = T / D21
                  DO 80 J = K + 2, N
                     A( J, K ) = DCONJG( D21 )*
     $                           ( D11*W( J, K )-W( J, K+1 ) )
                     A( J, K+1 ) = D21*( D22*W( J, K+1 )-W( J, K ) )
   80             CONTINUE
               END IF
*
*              Copy D(k) to A
*
               A( K, K ) = W( K, K )
               A( K+1, K ) = W( K+1, K )
               A( K+1, K+1 ) = W( K+1, K+1 )
*
*              Conjugate W(k) and W(k+1)
*
               CALL ZLACGV( N-K, W( K+1, K ), 1 )
               CALL ZLACGV( N-K-1, W( K+2, K+1 ), 1 )
            END IF
         END IF
*
*        Store details of the interchanges in IPIV
*
         IF( KSTEP.EQ.1 ) THEN
            IPIV( K ) = KP
         ELSE
            IPIV( K ) = -KP
            IPIV( K+1 ) = -KP
         END IF
*
*        Increase K and return to the start of the main loop
*
         K = K + KSTEP
         GO TO 70
*
   90    CONTINUE
*
*        Update the lower triangle of A22 (= A(k:n,k:n)) as
*
*        A22 := A22 - L21*D*L21' = A22 - L21*W'
*
*        computing blocks of NB columns at a time (note that conjg(W) is
*        actually stored)
*
         DO 110 J = K, N, NB
            JB = MIN( NB, N-J+1 )
*
*           Update the lower triangle of the diagonal block
*
            DO 100 JJ = J, J + JB - 1
               A( JJ, JJ ) = DBLE( A( JJ, JJ ) )
               CALL ZGEMV( 'No transpose', J+JB-JJ, K-1, -CONE,
     $                     A( JJ, 1 ), LDA, W( JJ, 1 ), LDW, CONE,
     $                     A( JJ, JJ ), 1 )
               A( JJ, JJ ) = DBLE( A( JJ, JJ ) )
  100       CONTINUE
*
*           Update the rectangular subdiagonal block
*
            IF( J+JB.LE.N )
     $         CALL ZGEMM( 'No transpose', 'Transpose', N-J-JB+1, JB,
     $                     K-1, -CONE, A( J+JB, 1 ), LDA, W( J, 1 ),
     $                     LDW, CONE, A( J+JB, J ), LDA )
  110    CONTINUE
*
*        Put L21 in standard form by partially undoing the interchanges
*        in columns 1:k-1
*
         J = K - 1
  120    CONTINUE
         JJ = J
         JP = IPIV( J )
         IF( JP.LT.0 ) THEN
            JP = -JP
            J = J - 1
         END IF
         J = J - 1
         IF( JP.NE.JJ .AND. J.GE.1 )
     $      CALL ZSWAP( J, A( JP, 1 ), LDA, A( JJ, 1 ), LDA )
         IF( J.GE.1 )
     $      GO TO 120
*
*        Set KB to the number of columns factorized
*
         KB = K - 1
*
      END IF
      RETURN
*
*     End of ZLAHEF
*
      END

C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CSA2XS (NI,XI,UI,WTS,KNOTS,SSMTH,NDERIV,
     +                   NXO,NYO,XO,YO,UO,NWRK,WORK,IER)
C
      DIMENSION XI(2,NI),UI(NI),WTS(*),KNOTS(2),XO(NXO),YO(NYO),
     +          UO(NXO,NYO),WORK(NWRK),NDERIV(2)
      DIMENSION XMN(2),XMX(2),XV(2)
C
C  Check on the number of knots.
C
      NTOT = KNOTS(1)*KNOTS(2)
C
      DO 20 I=1,2
        IF (KNOTS(I) .LT. 4) THEN
          CALL CFAERR (202,' CSA2XS - must have at least four knots in e
     +very coordinate direction',68)       
          IER = 202
          RETURN
        ENDIF
   20 CONTINUE
C
C  Check on the size of the workspace.
C
      IF (NWRK .LT. NTOT*(NTOT+3)) THEN
        CALL CFAERR (203,' CSA2XS - workspace too small',28)
        IER = 203
        RETURN
      ENDIF
C
C  Calculate the min and max for the knots as the minimum value of
C  the input data and output data and the maximum of the input and
C  output data.
C
      DO 30 J=1,2
        XMN(J) = XI(J,1)
        XMX(J) = XI(J,1)
        DO 10 I=2,NI
          XMN(J) = MIN(XMN(J),XI(J,I))
          XMX(J) = MAX(XMX(J),XI(J,I))
   10   CONTINUE
   30 CONTINUE
      XMN(1) = MIN(XMN(1),XO(1))
      XMX(1) = MAX(XMX(1),XO(NXO))
      XMN(2) = MIN(XMN(2),YO(1))
      XMX(2) = MAX(XMX(2),YO(NYO))
C
C  Find the coefficients.
C
      CALL SPLCW(2,XI,2,UI,WTS,NI,XMN,XMX,KNOTS,SSMTH,WORK,NTOT,       
     +           WORK(NTOT+1),NWRK-NTOT,IERR)
      IF (IERR .NE. 0) RETURN
C
C  Calculate the approximated values (coefficients are stored at
C  the beginnig of WORK).
C
      DO 60 I=1,NXO
        XV(1) = XO(I)
        DO 40 J=1,NYO
          XV(2) = YO(J)
          UO(I,J) = SPLDE(2,XV,NDERIV,WORK,XMN,XMX,KNOTS,IER)
          IF (IERR .NE. 0) RETURN
   40   CONTINUE
   60 CONTINUE
C
      RETURN
      END

C
C	$Id: stline.f,v 1.4 2008-07-27 00:16:56 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE STLINE (Z,LL,MM,NN,CONV)
      SAVE
      DIMENSION       Z(LL,NN)
C
C THIS ROUTINE FINDS THE BEGINNINGS OF ALL CONTOUR LINES AT LEVEL CONV.
C FIRST THE EDGES ARE SEARCHED FOR LINES INTERSECTING THE EDGE (OPEN
C LINES) THEN THE INTERIOR IS SEARCHED FOR LINES WHICH DO NOT INTERSECT
C THE EDGE (CLOSED LINES).  BEGINNINGS ARE STORED IN IR TO PREVENT RE-
C TRACING OF LINES.  IF IR IS FILLED, THE SEARCH IS STOPPED FOR THIS
C CONV.
C
      COMMON /CONRE2/ IX         ,IY         ,IDX        ,IDY        ,
     1                IS         ,ISS        ,NP         ,CV         ,
     2                INX(8)     ,INY(8)     ,IR(2000)   ,NR
      COMMON /CONRE3/ IXBITS     ,IYBITS
C
C
C
C
C
C
      IXYPAK(IXX,IYY) = ISHIFT(IXX,IYBITS)+IYY
C
      L = LL
      M = MM
      N = NN
      CV = CONV
      NP = 0
      ISS = 0
      DO 102 IP1=2,M
         I = IP1-1
         IF (Z(I,1).GE.CV .OR. Z(IP1,1).LT.CV) GO TO 101
         IX = IP1
         IY = 1
         IDX = -1
         IDY = 0
         IS = 1
         CALL CRDRLN (Z,L,M,N)
  101    IF (Z(IP1,N).GE.CV .OR. Z(I,N).LT.CV) GO TO 102
         IX = I
         IY = N
         IDX = 1
         IDY = 0
         IS = 5
         CALL CRDRLN (Z,L,M,N)
  102 CONTINUE
      DO 104 JP1=2,N
         J = JP1-1
         IF (Z(M,J).GE.CV .OR. Z(M,JP1).LT.CV) GO TO 103
         IX = M
         IY = JP1
         IDX = 0
         IDY = -1
         IS = 7
         CALL CRDRLN (Z,L,M,N)
  103    IF (Z(1,JP1).GE.CV .OR. Z(1,J).LT.CV) GO TO 104
         IX = 1
         IY = J
         IDX = 0
         IDY = 1
         IS = 3
         CALL CRDRLN (Z,L,M,N)
  104 CONTINUE
      ISS = 1
      DO 108 JP1=3,N
         J = JP1-1
         DO 107 IP1=2,M
            I = IP1-1
            IF (Z(I,J).GE.CV .OR. Z(IP1,J).LT.CV) GO TO 107
            IXY = IXYPAK(IP1,J)
            IF (NP .EQ. 0) GO TO 106
            DO 105 K=1,NP
               IF (IR(K) .EQ. IXY) GO TO 107
  105       CONTINUE
  106       NP = NP+1
            IF (NP .GT. NR) THEN
C
C THIS PRINTS AN ERROR MESSAGE IF THE LOCAL ARRAY IR IN SUBROUTINE
C STLINE HAS AN OVERFLOW
C THIS MESSAGE IS WRITTEN BOTH ON THE FRAME AND ON THE STANDARD ERROR
C UNIT
C
      IUNIT = I1MACH(4)
      WRITE(IUNIT,1000)
 1000 FORMAT(
     1' WARNING FROM ROUTINE STLINE IN CONREC--WORK ARRAY OVERFLOW')
      CALL GETSET(VXA,VXB,VYA,VYB,XA,XB,YA,YB,LTYPE)
      X = (VXB + VXA) / 2.
      Y = (VYB + VYA) / 2.
      CALL PWRIT(CFUX(X),CFUY(Y),
     1'**WARNING--PICTURE INCOMPLETE**',
     2 31,3,0,0)
      Y = Y - .05
      CALL PWRIT(CFUX(X),CFUY(Y),
     1'WORK ARRAY OVERFLOW IN STLINE',
     2 29,3,0,0)
        RETURN
        ENDIF
            IR(NP) = IXY
            IX = IP1
            IY = J
            IDX = -1
            IDY = 0
            IS = 1
            CALL CRDRLN (Z,L,M,N)
  107    CONTINUE
  108 CONTINUE
      RETURN
      END

C
C $Id: idlsqf.f,v 1.4 2008-07-27 00:17:30 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE IDLSQF (X,Y,Z,N,A,B,C,XAVG,YAVG)
C
        DIMENSION X(N),Y(N),Z(N)
C
C IDLSQF fits a plane to the data defined by points (X(I),Y(I),Z(I)),
C for I from 1 to N.  It returns the coefficients A, B, and C in the
C equation "Z=AX+BY+C".  It also returns the average X and average Y.
C
        SA=0.
        SB=0.
        SC=0.
        SD=0.
        SE=0.
        SF=0.
        SG=0.
        SH=0.
C
        DO 101 I=1,N
          SA=SA+X(I)
          SB=SB+Y(I)
          SC=SC+Z(I)
          SD=SD+X(I)*X(I)
          SE=SE+Y(I)*Y(I)
          SF=SF+X(I)*Y(I)
          SG=SG+Y(I)*Z(I)
          SH=SH+X(I)*Z(I)
  101   CONTINUE
C
        RN=REAL(N)
C
        A=((RN*SH-SA*SC)*(RN*SE-SB*SB)-(RN*SF-SA*SB)*(RN*SG-SB*SC))/
     +    ((RN*SD-SA*SA)*(RN*SE-SB*SB)-(RN*SF-SA*SB)*(RN*SF-SA*SB))
        B=((RN*SD-SA*SA)*(RN*SG-SB*SC)-(RN*SF-SA*SB)*(RN*SH-SA*SC))/
     +    ((RN*SD-SA*SA)*(RN*SE-SB*SB)-(RN*SF-SA*SB)*(RN*SF-SA*SB))
        C=(SC-SA*A-SB*B)/RN
C
        XAVG=SA/RN
        YAVG=SB/RN
C
C Done.
C
        RETURN
C
      END

C
C	$Id: gpm.f,v 1.7 2008-07-27 00:20:58 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GPM(N,PX,PY)
C
C  POLYMARKER
C
      INTEGER EPM
      PARAMETER (EPM=13)
C
      include 'gkscom.h'
C
      INTEGER N
      REAL PX(N),PY(N)
C
C  Check if GKS is in the proper state.
C
      CALL GZCKST(5,EPM,IER)
      IF (IER .NE. 0) RETURN
C
C  Check that the number of points is valid.
C
      IF (.NOT.(N.GE.1)) THEN
        ERS = 1
        CALL GERHND(100,EPM,ERF)
        ERS = 0
        RETURN
      ENDIF
C
C  Set function code and put out the real arrays across the
C  workstation interface.  Flag conversion to NDC space.
C
      FCODE = 12
      CALL GZROI(0)
C
      NPTOT = N
      CALL GZPUTR(NPTOT,N,PX,PY,1,IER)
      RERR = IER
      IF (RERR.NE.0) THEN
        ERS = 1
        CALL GERHND(RERR,EPM,ERF)
        ERS = 0
      ENDIF
C
      RETURN
      END

      PROGRAM CTISCP
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.  Use one
C of the following:
C
C       PARAMETER (IERF=6,LUNI=2,IWTY=1 ,IWID=1)  !  NCGM
C       PARAMETER (IERF=6,LUNI=2,IWTY=8 ,IWID=1)  !  X Windows
C       PARAMETER (IERF=6,LUNI=2,IWTY=20,IWID=1)  !  PostScript
C       PARAMETER (IERF=6,LUNI=2,IWTY=11,IWID=1)  !  PDF, Portrait
C       PARAMETER (IERF=6,LUNI=2,IWTY=12,IWID=1)  !  PDF, Landscape
C
        PARAMETER (IERF=6,LUNI=2,IWTYPE=1,IWTY=IWTYPE,IWID=1)
C
C The object of this program is to produce a set of plots illustrating
C the use of a triangular mesh to represent an ISCCP grid on the surface
C of the globe.  The original rectangular grid is of a different nature
C than others: each of 72 latitude bands of equal width is cut into just
C enough pieces so that each of the pieces will have about the same area
C on the globe.  The resulting 6596 little pieces, each of which is a
C rectangle in lat/lon space, form a sort of tiling of the sphere.  The
C triangular mesh is created by using the center points of the pieces as
C vertices and connecting adjacent vertices to form edges which form
C triangles.
C
C Selected frames are drawn for each of four different viewpoints.  If
C (CLAT,CLON) is the approximate position of the "center point" of the
C mesh (which is defined somewhat arbitrarily for this mesh), the four
C viewpoints used are as follows: (CLAT+45,CLON), (CLAT-45,CLON),
C (CLAT+45,CLON+180), and (CLAT-45,CLON+180).
C
C At each of the four viewpoints, up to five different frames are drawn:
C
C   1) A frame showing the original rectangular grid on the globe.
C      This frame is drawn only if the parameter IMSH = 1 or 3.
C
C   2) A frame showing the triangular mesh on the globe.  This frame
C      is drawn only if the parameter IMSH = 2 or 3.
C
C   3) A frame showing simple contours on the globe.  This frame is
C      drawn only if the parameter ICON is non-zero.
C
C   4) A frame showing color-filled contour bands on the globe, drawn
C      using filled areas.  This frame is drawn only if the parameter
C      ICOL is non-zero.
C
C   5) A frame showing color-filled contour bands on the globe, drawn
C      using a cell array.  This frame is drawn only if the parameter
C      ICAP is non-zero.
C
C Define the parameter that says which frames showing the rectangular
C grid and/or the triangular mesh are to be drawn (frames 1 and 2):
C
C       PARAMETER (IMSH=0)  !  neither grid nor mesh
C       PARAMETER (IMSH=1)  !  simple rectangular grid only
C       PARAMETER (IMSH=2)  !  triangular mesh only
C       PARAMETER (IMSH=3)  !  both
C
        PARAMETER (IMSH=3)
C
C Define the parameter that says whether or not to draw simple contours
C (frame 3):
C
C       PARAMETER (ICON=0)  !  contours not drawn
C       PARAMETER (ICON=1)  !  contours drawn
C
        PARAMETER (ICON=1)
C
C Define the parameter that says whether or not to draw color-filled
C contours (frame 4):
C
C       PARAMETER (ICOL=0)  !  no color fill done
C       PARAMETER (ICOL=1)  !  color fill done
C
        PARAMETER (ICOL=1)
C
C Define the parameter that says whether or not to draw a cell array
C plot (frame 5):
C
C       PARAMETER (ICAP=0)  !  cell array plot not drawn
C       PARAMETER (ICAP=1)  !  cell array plot drawn
C
        PARAMETER (ICAP=1)
C
C To represent the triangular mesh, we use three singly-dimensioned
C arrays: RPNT holds points, IEDG holds edges, and ITRI holds triangles.
C The elements of each array form "nodes" having lengths as follows:
C
        PARAMETER (LOPN=5)
C
C The five elements of a point node are
C
C   1. the X coordinate of the point;
C   2. the Y coordinate of the point;
C   3. the Z coordinate of the point;
C   4. the field value at the point;
C   5. any additional value desired by the user.
C
        PARAMETER (LOEN=5)
C
C The five elements of an edge node are
C
C   1. the base index, in RPNT, of point 1 of the edge;
C   2. the base index, in RPNT, of point 2 of the edge;
C   3. the index, in ITRI, of the pointer to the edge in the triangle to
C      the left of the edge (-1 if there is no triangle to the left);
C   4. the index, in ITRI, of the pointer to the edge in the triangle to
C      the right of the edge (-1 if there is no triangle to the right);
C   5. a utility flag for use by algorithms that scan the structure.
C
C The "left" and "right" sides of an edge are defined as they would be
C by an observer standing on the globe at point 1 of the edge, looking
C toward point 2 of the edge.  It is possible, if there are "holes" in
C the mesh, that there will be no triangle to the left or to the right
C of an edge, but there must be a triangle on one side or the other.
C
        PARAMETER (LOTN=4)
C
C The four elements of a triangle node are
C
C   1. the base index, in IEDG, of edge 1 of the triangle;
C   2. the base index, in IEDG, of edge 2 of the triangle;
C   3. the base index, in IEDG, of edge 3 of the triangle;
C   4. a flag set non-zero to block use of the triangle, effectively
C      removing it from the mesh.  Play with the setting of the
C      parameter ISCP (which see, below) to get examples of the use
C      of this feature.
C
C The "base index" of a point node, an edge node, or a triangle node is
C always a multiple of the length of the node, to which can be added an
C offset to get the index of a particular element of the node.  For
C example, if I is the base index of a triangle of interest, ITRI(I+1)
C is its first element (the base index of its first edge).  Similarly,
C IEDG(ITRI(I+1)+2) is the base index of the second point of the first
C edge of the triangle with base index I, and RPNT(IEDG(ITRI(I+1)+2)+3)
C is the third (Z) coordinate of the second point of the first edge of
C the triangle with base index I.
C
C It is the pointers from the edge nodes back to the triangle nodes that
C allow CONPACKT to navigate the mesh, moving from triangle to triangle
C as it follows a contour line, but these pointers are tricky to define:
C if IPTE is the base index of an edge node and IEDG(IPTE+3) is zero or
C more, saying that there is a triangle to the left of the edge, then
C IEDG(IPTE+3) is the actual index of that element of the triangle node
C that points to the edge node; i.e., ITRI(IEDG(IPTE+3))=IPTE.  The base
C index of the triangle node defining that triangle is IPTT, where
C IPTT=LOTN*((IEDG(IPTE+3)-1)/LOTN), and the index of the pointer to
C the edge within the triangle node is IPTI=IEDG(IPTE+3)-IPTT, so that
C ITRI(IPTT+IPTI)=IPTE.  Similar comments apply to element 4 of an edge
C node, which points into the triangle node defining the triangle to the
C right of the edge.
C
C The numbers of points, edges, and triangles in the triangular mesh
C are as follows (obtained from the print output of a run in which the
C numbers were set larger than this):
C
        PARAMETER (MNOP=6596)
        PARAMETER (MNOE=19782)
        PARAMETER (MNOT=13188)
C
C Once we know how many points, edges, and triangles we're going to use
C (at most), we can set parameters defining the space reserved for the
C triangular mesh:
C
        PARAMETER (MPNT=MNOP*LOPN)
        PARAMETER (MEDG=MNOE*LOEN)
        PARAMETER (MTRI=MNOT*LOTN)
C
C Declare the arrays to hold the point nodes, edge nodes, and triangle
C nodes defining the triangular mesh.
C
        DIMENSION RPNT(MPNT),IEDG(MEDG),ITRI(MTRI)
C
C Define a parameter specifying what data to use on the ISCCP grid.  A
C triangle is blocked if and only if more than "n" of its vertices are
C of the type blocked.  For example, when ISCP is 12, "n" is 0, so that
C a triangle is blocked if one or more of its vertices are over land.
C
C       PARAMETER (ISCP=  1) ! ISCCP, topo data, no blocking
C       PARAMETER (ISCP= 21) ! ISCCP, topo data, block ocean, n=0
C       PARAMETER (ISCP=121) ! ISCCP, topo data, block ocean, n=1
C       PARAMETER (ISCP=221) ! ISCCP, topo data, block ocean, n=2
C       PARAMETER (ISCP=  2) ! ISCCP, fractal data, no blocking
C       PARAMETER (ISCP= 12) ! ISCCP, fractal data, block land, n=0 *
C       PARAMETER (ISCP=112) ! ISCCP, fractal data, block land, n=1
C       PARAMETER (ISCP=212) ! ISCCP, fractal data, block land, n=2
C       PARAMETER (ISCP= 22) ! ISCCP, fractal data, block ocean, n=0
C       PARAMETER (ISCP=122) ! ISCCP, fractal data, block ocean, n=1
C       PARAMETER (ISCP=222) ! ISCCP, fractal data, block ocean, n=2 *
C
        PARAMETER (ISCP= 12)
C
C Declare real and integer workspaces needed by CONPACKT.
C
        PARAMETER (LRWK=10000,LIWK=1000)
C
        DIMENSION RWRK(LRWK),IWRK(LIWK)
C
C Declare the area map array needed to do solid fill.
C
        PARAMETER (LAMA=200000)
C
        DIMENSION IAMA(LAMA)
C
C Declare workspace arrays to be used in calls to ARSCAM.
C
        PARAMETER (NCRA=LAMA/10,NGPS=2)
C
        DIMENSION XCRA(NCRA),YCRA(NCRA),IAAI(NGPS),IAGI(NGPS)
C
C Declare arrays in which to generate a cell array picture of the
C data on the triangular mesh.
C
C       PARAMETER (ICAM=1024,ICAN=1024)
        PARAMETER (ICAM= 512,ICAN= 512)
C
        DIMENSION ICRA(ICAM,ICAN)
C
C Declare external the routine that draws masked contour lines.
C
        EXTERNAL DRWMCL
C
C Declare external the routine that does color fill of contour bands.
C
        EXTERNAL DCFOCB
C
C Define a common block in which to keep track of the maximum space used
C in the arrays XCRA and YCRA.
C
        COMMON /COMONA/ MAXN
C
C Define the out-of-range flag.
C
        DATA OORV / 1.E12 /
C
C Define the tension on the splines to be used in smoothing contours.
C
C       DATA T2DS / 0.0 /  !  smoothing off
C       DATA T2DS / 2.5 /  !  smoothing on
C
        DATA T2DS / 0.0 /
C
C Define the distance between points on smoothed contour lines.
C
        DATA RSSL / .002 /
C
C Define the amount of real workspace to be used in drawing contours.
C
        DATA IRWC / 500 /
C
C Define the label-positioning flag.
C
C       DATA ILLP / 0 /  !  no labels
C       DATA ILLP / 1 /  !  dash-package writes labels
C       DATA ILLP / 2 /  !  regular scheme
C       DATA ILLP / 3 /  !  penalty scheme
C
        DATA ILLP / 2 /
C
C Define the high/low search radius.
C
        DATA HLSR / .075 /
C
C Define the high/low label overlap flag.
C
        DATA IHLO / 11 /
C
C Define the hachuring flag, hachure length, and hachure spacing.
C
C       DATA IHCF,HCHL,HCHS /  0 , +.004 , .010 /  !  off
C       DATA IHCF,HCHL,HCHS / +1 , -.004 , .020 /  !  on, all, uphill
C
        DATA IHCF,HCHL,HCHS /  0 , +.004 , .010 /
C
C Define a constant to convert from radians to degrees.
C
        DATA RTOD / 57.2957795130823 /
C
C Read data and generate the required triangular mesh.
C
        PRINT * , ' '
        PRINT * , 'CREATING TRIANGULAR MESH:'
C
        CALL GTISCP (RPNT,MPNT,NPNT,LOPN,
     +               IEDG,MEDG,NEDG,LOEN,
     +               ITRI,MTRI,NTRI,LOTN,
     +               ISCP,CLAT,CLON)
C
C Print the number of points, edges, and triangles.
C
        PRINT * , '  NUMBER OF POINTS:    ',NPNT/LOPN
        PRINT * , '  NUMBER OF EDGES:     ',NEDG/LOEN
        PRINT * , '  NUMBER OF TRIANGLES: ',NTRI/LOTN
C
C Write the contents of the point list, the edge list, and the triangle
C list to "fort.11" in a readable form.
C
c       WRITE (11,'(''P'',I8,5F10.4)')
c    +        (I,RPNT(I+1),RPNT(I+2),RPNT(I+3),RPNT(I+4),RPNT(I+5),
c    +                                               I=0,NPNT-LOPN,LOPN)
c       WRITE (11,'(''E'',I8,5I10)')
c    +        (I,IEDG(I+1),IEDG(I+2),IEDG(I+3),IEDG(I+4),IEDG(I+5),
c    +                                               I=0,NEDG-LOEN,LOEN)
c       WRITE (11,'(''T'',I8,4I10)')
c    +        (I,ITRI(I+1),ITRI(I+2),ITRI(I+3),ITRI(I+4),
c    +                                               I=0,NTRI-LOTN,LOTN)
C
C Open GKS.
C
        PRINT * , 'OPENING AND INITIALIZING GKS'
C
        CALL GOPKS (IERF,0)
        CALL GOPWK (IWID,LUNI,IWTY)
        CALL GACWK (IWID)
C
C Turn off the clipping indicator.
C
        CALL GSCLIP (0)
C
C Define a basic set of colors (0 = white, background; 1 = black,
C foreground; 2 = yellow; 3 = magenta; 4 = red; 5 = cyan; 6 = green;
C 7 = blue; 8 = darker light gray; 9 = lighter light gray; 10 = dark
C yellow; 11 = dark gray; 12 = medium gray; 13 = light red, for
C geographic lines; 14 = light blue, for lat/lon lines).
C
        CALL GSCR   (IWID, 0,1.,1.,1.)
        CALL GSCR   (IWID, 1,0.,0.,0.)
        CALL GSCR   (IWID, 2,1.,1.,0.)
        CALL GSCR   (IWID, 3,1.,0.,1.)
        CALL GSCR   (IWID, 4,1.,0.,0.)
        CALL GSCR   (IWID, 5,0.,1.,1.)
        CALL GSCR   (IWID, 6,0.,1.,0.)
        CALL GSCR   (IWID, 7,0.,0.,1.)
        CALL GSCR   (IWID, 8,.5,.5,.5)
        CALL GSCR   (IWID, 9,.8,.8,.8)
        CALL GSCR   (IWID,10,.3,.3,0.)
        CALL GSCR   (IWID,11,.3,.3,.3)
        CALL GSCR   (IWID,12,.5,.5,.5)
        CALL GSCR   (IWID,13,.8,.5,.5)
        CALL GSCR   (IWID,14,.5,.5,.8)
C
C Define 100 colors, associated with color indices 151 through 250, to
C be used for color-filled contour bands and in cell arrays, ranging
C from blue to red.
C
        CALL DFCLRS (IWID,151,250,0.,0.,1.,1.,0.,0.)
C
C Set parameters in the utilities.
C
        PRINT * , 'SETTING PARAMETERS IN CONPACKT, EZMAP, AND PLOTCHAR'
C
C Set the mapping flag.
C
        CALL CTSETI ('MAP - MAPPING FLAG',1)
C
C Set the out-of-range flag value.
C
        CALL CTSETR ('ORV - OUT-OF-RANGE VALUE',OORV)
C
C Turn on the drawing of the mesh edge and set the area identifier for
C areas outside the mesh.
C
        CALL CTSETI ('PAI - PARAMETER ARRAY INDEX',-1)
        CALL CTSETI ('CLU - CONTOUR LEVEL USE FLAG',1)
        CALL CTSETI ('AIA - AREA IDENTIFIER FOR AREA',1001)
C
C Set the area identifier for areas in "out-of-range" areas.
C
C       CALL CTSETI ('PAI',-2)
C       CALL CTSETI ('AIA - AREA IDENTIFIER FOR AREA',1002)
C
C Set the 2D smoother flag.
C
        CALL CTSETR ('T2D - TENSION ON 2D SPLINES',T2DS)
C
C Set the distance between points on smoothed lines.
C
        CALL CTSETR ('SSL - SMOOTHED SEGMENT LENGTH',RSSL)
C
C Set the amount of real workspace to be used in drawing contours.
C
        CALL CTSETI ('RWC - REAL WORKSPACE FOR CONTOURS',IRWC)
C
C Set the label-positioning flag.
C
        CALL CTSETI ('LLP - LINE LABEL POSITIONING FLAG',ILLP)
C
C Set the high/low search radius.
C
        CALL CTSETR ('HLR - HIGH/LOW SEARCH RADIUS',HLSR)
C
C Set the high/low label overlap flag.
C
        CALL CTSETI ('HLO - HIGH/LOW LABEL OVERLAP FLAG',IHLO)
C
C Set the hachuring flag, hachure length, and hachure spacing.
C
        CALL CTSETI ('HCF - HACHURING FLAG',IHCF)
        CALL CTSETR ('HCL - HACHURE LENGTH',HCHL)
        CALL CTSETR ('HCS - HACHURE SPACING',HCHS)
C
C Set the cell array flag.
C
        CALL CTSETI ('CAF - CELL ARRAY FLAG',-1)
C
C Tell CONPACKT not to do its own call to SET, since EZMAP will have
C done it.
C
        CALL CTSETI ('SET - DO-SET-CALL FLAG', 0)
C
C Move the informational label up a little.
C
        CALL CTSETR ('ILY - INFORMATIONAL LABEL Y POSITION',-.005)
C
C Tell EZMAP not to draw the perimeter.
C
        CALL MPSETI ('PE',0)
C
C Tell EZMAP to use solid lat/lon lines.
C
        CALL MPSETI ('DA',65535)
C
C Tell PLOTCHAR to use one of the filled fonts and to outline each
C character.
C
        CALL PCSETI ('FN',25)
        CALL PCSETI ('OF',1)
C
C Tell PLOTCHAR to expect a character other than a colon as the
C function-control signal character.
C
        CALL PCSETC ('FC','|')
C
C Loop through four different viewing angles.
C
        DO 104 IDIR=1,4
C
          PRINT * , ' '
          PRINT * , 'VIEW FROM DIRECTION NUMBER: ',IDIR
C
C Tell EZMAP what projection to use and what its limits are.
C
          IF      (IDIR.EQ.1) THEN
            CALL MAPROJ ('OR',CLAT+45.,CLON,      0.)
          ELSE IF (IDIR.EQ.2) THEN
            CALL MAPROJ ('OR',CLAT-45.,CLON,      0.)
          ELSE IF (IDIR.EQ.3) THEN
            CALL MAPROJ ('OR',CLAT+45.,CLON+180., 0.)
          ELSE IF (IDIR.EQ.4) THEN
            CALL MAPROJ ('OR',CLAT-45.,CLON+180., 0.)
          END IF
C
          CALL MAPSET ('MA',0.,0.,0.,0.)
C
C Initialize EZMAP.
C
          CALL MAPINT
C
C If the rectangular grid and/or the triangular mesh are to be drawn,
C do it.
C
          IF (IMSH.NE.0) THEN
C
            PRINT * , 'DRAWING MESHES'
C
C Simple rectangular grid:
C
            IF (MOD(IMSH,2).NE.0) THEN
C
              PRINT * , 'DRAWING SIMPLE RECTANGULAR GRID'
C
              CALL DSISCP
C
C Label the first frame.
C
              CALL PLCHHQ (CFUX(.03),CFUY(.946),'ISCCP GRID',
     +                                                      .024,0.,-1.)
C
              IF (     IDIR.EQ.1) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 1',
     +                                                      .012,0.,-1.)
              ELSE IF (IDIR.EQ.2) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 2',
     +                                                      .012,0.,-1.)
              ELSE IF (IDIR.EQ.3) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 3',
     +                                                      .012,0.,-1.)
              ELSE IF (IDIR.EQ.4) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 4',
     +                                                      .012,0.,-1.)
              END IF
C
              CALL PLCHHQ (CFUX(.97),CFUY(.950),'ORIGINAL RECTANGULAR GR
     +ID',.012,0.,1.)
C
              CALL PLCHHQ (CFUX(.97),CFUY(.928),
     +                     'Each of the 72 2.5-degree-wide strips',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.908),
     +                     'is cut into just enough pieces so',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.888),
     +                     'as to make all of the pieces',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.868),
     +                     'have approximately the',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.848),
     +                     'same surface area',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.828),
     +                     'on the globe.',
     +                                                       .010,0.,1.)
C
              CALL PLCHHQ (CFUX(.03),CFUY(.084),'Grid is gray.',
     +                                                      .012,0.,-1.)
              CALL PLCHHQ (CFUX(.03),CFUY(.060),'Shorelines are blue.',
     +                                                      .012,0.,-1.)
              CALL PLCHHQ (CFUX(.03),CFUY(.036),'Parallels/meridians are
     + red.',.012,0.,-1.)
C
C Advance the frame.
C
              CALL FRAME
C
            END IF
C
C Triangular mesh (with edges between blocked triangles somewhat fainter
C than the rest):
C
            IF (MOD(IMSH/2,2).NE.0) THEN
C
              PRINT * , 'DRAWING TRIANGULAR MESH'
C
              DO 101 IPTE=0,NEDG-LOEN,LOEN
C
                IFLL=0
C
                IF (IEDG(IPTE+3).GE.0) THEN
                  IF (ITRI(LOTN*((IEDG(IPTE+3)-1)/LOTN)+4).EQ.0) IFLL=1
                END IF
C
                IFLR=0
C
                IF (IEDG(IPTE+4).GE.0) THEN
                  IF (ITRI(LOTN*((IEDG(IPTE+4)-1)/LOTN)+4).EQ.0) IFLR=1
                END IF
C
                IF (IFLL.NE.0.OR.IFLR.NE.0) THEN
                  CALL PLOTIT (0,0,2)
                  CALL GSPLCI (8)
                ELSE
                  CALL PLOTIT (0,0,2)
                  CALL GSPLCI (9)
                END IF
C
                ALAT=RTOD*ASIN(RPNT(IEDG(IPTE+1)+3))
C
                IF (RPNT(IEDG(IPTE+1)+1).EQ.0..AND.
     +              RPNT(IEDG(IPTE+1)+2).EQ.0.) THEN
                  ALON=0.
                ELSE
                  ALON=RTOD*ATAN2(RPNT(IEDG(IPTE+1)+2),
     +                            RPNT(IEDG(IPTE+1)+1))
                END IF
C
                BLAT=RTOD*ASIN(RPNT(IEDG(IPTE+2)+3))
C
                IF (RPNT(IEDG(IPTE+2)+1).EQ.0..AND.
     +              RPNT(IEDG(IPTE+2)+2).EQ.0.) THEN
                  BLON=0.
                ELSE
                  BLON=RTOD*ATAN2(RPNT(IEDG(IPTE+2)+2),
     +                            RPNT(IEDG(IPTE+2)+1))
                END IF
C
                CALL DRSGCR (ALAT,ALON,BLAT,BLON)
C
  101         CONTINUE
C
              CALL PLOTIT (0,0,2)
              CALL GSPLCI (13)
              CALL MAPGRD
              CALL PLOTIT (0,0,2)
              CALL GSPLCI (14)
              CALL MAPLOT
C
C Label the second frame.
C
              CALL PLCHHQ (CFUX(.03),CFUY(.946),'ISCCP GRID',
     +                                                      .024,0.,-1.)
C
              IF (     IDIR.EQ.1) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 1',
     +                                                      .012,0.,-1.)
              ELSE IF (IDIR.EQ.2) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 2',
     +                                                      .012,0.,-1.)
              ELSE IF (IDIR.EQ.3) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 3',
     +                                                      .012,0.,-1.)
              ELSE IF (IDIR.EQ.4) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 4',
     +                                                      .012,0.,-1.)
              END IF
C
              CALL PLCHHQ (CFUX(.97),CFUY(.950),'DERIVED TRIANGULAR MESH
     +',.012,0.,1.)
C
              CALL PLCHHQ (CFUX(.97),CFUY(.928),
     +                     'Vertices are at centers of rectangles.',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.908),
     +                     'Land portions of the mesh are',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.888),
     +                     '"blocked" and are shown',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.868),
     +                     'in very light gray.',
     +                                                       .010,0.,1.)
C
              CALL PLCHHQ (CFUX(.03),CFUY(.084),'Mesh is gray.',
     +                                                      .012,0.,-1.)
              CALL PLCHHQ (CFUX(.03),CFUY(.060),'Shorelines are blue.',
     +                                                      .012,0.,-1.)
              CALL PLCHHQ (CFUX(.03),CFUY(.036),'Parallels/meridians are
     + red.',.012,0.,-1.)
C
C Advance the frame.
C
              CALL FRAME
C
            END IF
C
          END IF
C
C If a frame showing simple contours is to be drawn, do it next (adding
C an overlay of lat/lon lines and continental outlines in light gray).
C
          IF (ICON.NE.0) THEN
C
            PRINT * , 'DRAWING PLOT SHOWING SIMPLE CONTOURS'
C
C Initialize CONPACKT.
C
            PRINT * , 'CALLING CTMESH'
C
            CALL CTMESH (RPNT,NPNT,LOPN,
     +                   IEDG,NEDG,LOEN,
     +                   ITRI,NTRI,LOTN,
     +                   RWRK,LRWK,
     +                   IWRK,LIWK)
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (1)
C
C Proceed as implied by the setting of the label-positioning flag.
C
            IF (ABS(ILLP).EQ.1) THEN
C
C Draw the contour lines with labels generated by the dash package.
C
              PRINT * , 'CALLING CTCLDR'
              CALL CTCLDR (RPNT,IEDG,ITRI,RWRK,IWRK)
C
C Add the informational and high/low labels.
C
              PRINT * , 'CALLING CTLBDR'
              CALL CTLBDR (RPNT,IEDG,ITRI,RWRK,IWRK)
C
            ELSE IF (ABS(ILLP).GT.1) THEN
C
C Create an area map for masking of labels.
C
              MAXN=0
C
              PRINT * , 'CALLING ARINAM'
              CALL ARINAM (IAMA,LAMA)
C
              PRINT * , 'CALLING CTLBAM'
              CALL CTLBAM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA)
C
C Draw the contour lines masked by the area map.
C
              PRINT * , 'CALLING CTCLDM'
              CALL CTCLDM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA,DRWMCL)
C
              PRINT * , 'AREA MAP SPACE REQUIRED:         ',
     +                                         IAMA(1)-IAMA(6)+IAMA(5)+1
C
              PRINT * , 'NUMBER OF POINTS IN LONGEST LINE:',MAXN
C
C Draw all the labels.
C
              PRINT * , 'CALLING CTLBDR'
              CALL CTLBDR (RPNT,IEDG,ITRI,RWRK,IWRK)
C
            END IF
C
            CALL CTGETI ('IWU - INTEGER WORKSPACE USED',IIWU)
            PRINT * , 'INTEGER WORKSPACE REQUIRED:      ',IIWU
C
            CALL CTGETI ('RWU -    REAL WORKSPACE USED',IRWU)
            PRINT * , 'REAL WORKSPACE REQUIRED:         ',IRWU
C
C Add lat/lon lines and continental outlines.
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (13)
            CALL MAPGRD
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (14)
            CALL MAPLOT
C
C Label the third frame.
C
            CALL PLCHHQ (CFUX(.03),CFUY(.946),'ISCCP GRID',.024,0.,-1.)
C
            IF (     IDIR.EQ.1) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 1',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.2) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 2',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.3) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 3',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.4) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 4',
     +                                                      .012,0.,-1.)
            END IF
C
            CALL PLCHHQ (CFUX(.97),CFUY(.950),'SIMPLE CONTOURS ON',
     +                                                       .012,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.926),'TRIANGULAR MESH',
     +                                                       .012,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.904),'Dummy data are used.',
     +                                                       .010,0.,1.)
C
            CALL PLCHHQ (CFUX(.03),CFUY(.060),'Shorelines are blue.',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.036),'Parallels/meridians are r
     +ed.',.012,0.,-1.)
C
C Advance the frame.
C
            CALL FRAME
C
          END IF
C
C If a frame showing color-filled contours is to be drawn, do it next.
C
          IF (ICOL.NE.0) THEN
C
            PRINT * , 'DRAWING PLOT SHOWING COLOR-FILLED CONTOURS'
C
            PRINT * , 'CALLING CTMESH'
C
            CALL CTMESH (RPNT,NPNT,LOPN,
     +                   IEDG,NEDG,LOEN,
     +                   ITRI,NTRI,LOTN,
     +                   RWRK,LRWK,
     +                   IWRK,LIWK)
C
            MAXN=0
C
            PRINT * , 'CALLING CTPKCL'
            CALL CTPKCL (RPNT,IEDG,ITRI,RWRK,IWRK)
C
            PRINT * , 'CALLING ARINAM'
            CALL ARINAM (IAMA,LAMA)
C
            PRINT * , 'CALLING CTCLAM'
            CALL CTCLAM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA)
C
C           PRINT * , 'CALLING CTLBAM'
C           CALL CTLBAM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA)
C
            PRINT * , 'CALLING ARSCAM'
            CALL ARSCAM (IAMA,XCRA,YCRA,NCRA,IAAI,IAGI,NGPS,DCFOCB)
C
            PRINT * , 'SPACE REQUIRED IN AREA MAP:      ',
     +                                         IAMA(1)-IAMA(6)+IAMA(5)+1
C
            PRINT * , 'NUMBER OF POINTS IN LARGEST AREA:',MAXN
C
            CALL CTGETI ('IWU - INTEGER WORKSPACE USED',IIWU)
            PRINT * , 'INTEGER WORKSPACE REQUIRED:      ',IIWU
C
            CALL CTGETI ('RWU -    REAL WORKSPACE USED',IRWU)
            PRINT * , 'REAL WORKSPACE REQUIRED:         ',IRWU
C
            CALL GSFACI (1)
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (13)
            CALL MAPGRD
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (14)
            CALL MAPLOT
C
C Label the fourth frame.
C
            CALL PLCHHQ (CFUX(.03),CFUY(.946),'ISCCP GRID',.024,0.,-1.)
C
            IF (     IDIR.EQ.1) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 1',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.2) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 2',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.3) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 3',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.4) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 4',
     +                                                      .012,0.,-1.)
            END IF
C
            CALL PLCHHQ (CFUX(.97),CFUY(.950),'COLORED CONTOUR BANDS ON'
     +,.012,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.926),'TRIANGULAR MESH',
     +                                                       .012,0.,1.)
C
            CALL PLCHHQ (CFUX(.97),CFUY(.904),'Dummy data are used.',
     +                                                       .010,0.,1.)
C
            CALL PLCHHQ (CFUX(.03),CFUY(.132),'Off-mesh',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.108),'areas of the',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.084),'globe are yellow.',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.060),'Shorelines are blue.',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.036),'Parallels/meridians are r
     +ed.',.012,0.,-1.)
C
C Advance the frame.
C
            CALL FRAME
C
          END IF
C
C If the flag for it is set, do a cell array plot.
C
          IF (ICAP.NE.0) THEN
C
            PRINT * , 'DRAWING CELL-ARRAY PLOT OF DATA VALUES'
C
            PRINT * , 'CALLING CTMESH'
C
            CALL CTMESH (RPNT,NPNT,LOPN,
     +                   IEDG,NEDG,LOEN,
     +                   ITRI,NTRI,LOTN,
     +                   RWRK,LRWK,
     +                   IWRK,LIWK)
C
            CALL GETSET (XVPL,XVPR,YVPB,YVPT,XWDL,XWDR,YWDB,YWDT,LNLG)
C
            PRINT * , 'CALLING CTCICA'
            CALL CTCICA (RPNT,IEDG,ITRI,RWRK,IWRK,ICRA,ICAM,ICAM,ICAN,
     +                                            XVPL,YVPB,XVPR,YVPT)
C
            PRINT * , 'CALLING GCA'
            CALL GCA (XWDL,YWDB,XWDR,YWDT,ICAM,ICAN,1,1,ICAM,ICAN,ICRA)
C
            CALL CTGETI ('IWU - INTEGER WORKSPACE USED',IIWU)
            PRINT * , 'INTEGER WORKSPACE REQUIRED:      ',IIWU
C
            CALL CTGETI ('RWU -    REAL WORKSPACE USED',IRWU)
            PRINT * , 'REAL WORKSPACE REQUIRED:         ',IRWU
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (13)
            CALL MAPGRD
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (14)
            CALL MAPLOT
C
C Label the fifth frame.
C
            CALL PLCHHQ (CFUX(.03),CFUY(.946),'ISCCP GRID',.024,0.,-1.)
C
            IF (     IDIR.EQ.1) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 1',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.2) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 2',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.3) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 3',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.4) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 4',
     +                                                      .012,0.,-1.)
            END IF
C
            CALL PLCHHQ (CFUX(.97),CFUY(.950),'CELL ARRAY DERIVED FROM',
     +                                                       .012,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.926),'TRIANGULAR MESH',
     +                                                       .012,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.904),'Dummy data are used.',
     +                                                       .010,0.,1.)
C
            CALL PLCHHQ (CFUX(.03),CFUY(.132),'Off-mesh',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.108),'areas of the',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.084),'globe are yellow.',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.060),'Shorelines are blue.',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.036),'Parallels/meridians are r
     +ed.',.012,0.,-1.)
C
C Advance the frame.
C
            CALL FRAME
C
          END IF
C
  104   CONTINUE
C
C Close GKS.
C
        CALL GDAWK (IWID)
        CALL GCLWK (IWID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END


      SUBROUTINE DFCLRS (IWID,IOFC,IOLC,REDF,GRNF,BLUF,REDL,GRNL,BLUL)
C
C This routine defines color indices IOFC through IOLC on workstation
C IWID by interpolating values from REDF/GRNF/BLUF to REDL/GRNL/BLUL.
C
        DO 101 I=IOFC,IOLC
          P=REAL(IOLC-I)/REAL(IOLC-IOFC)
          Q=REAL(I-IOFC)/REAL(IOLC-IOFC)
          CALL GSCR (IWID,I,P*REDF+Q*REDL,P*GRNF+Q*GRNL,P*BLUF+Q*BLUL)
  101   CONTINUE
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE DRWMCL (XCRA,YCRA,NCRA,IAAI,IAGI,NGPS)
C
        DIMENSION XCRA(*),YCRA(*),IAAI(*),IAGI(*)
C
C This routine draws the curve defined by the points (XCRA(I),YCRA(I)),
C for I = 1 to NCRA, if and only if none of the area identifiers for the
C area containing the polyline are negative.  It calls either CURVE or
C CURVED to do the drawing, depending on the value of the internal
C parameter 'DPU'.
C
C It keeps track of the maximum value used for NCRA in a common block.
C
        COMMON /COMONA/ MAXN
C
        MAXN=MAX(MAXN,NCRA)
C
C Retrieve the value of the internal parameter 'DPU'.
C
        CALL CTGETI ('DPU - DASH PACKAGE USED',IDUF)
C
C Turn on drawing.
C
        IDRW=1
C
C If any area identifier is negative, turn off drawing.
C
        DO 101 I=1,NGPS
          IF (IAAI(I).LT.0) IDRW=0
  101   CONTINUE
C
C If drawing is turned on, draw the polyline.
C
        IF (IDRW.NE.0) THEN
          IF (IDUF.EQ.0) THEN
            CALL CURVE  (XCRA,YCRA,NCRA)
          ELSE IF (IDUF.LT.0) THEN
            CALL DPCURV (XCRA,YCRA,NCRA)
          ELSE
            CALL CURVED (XCRA,YCRA,NCRA)
          END IF
        END IF
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE DCFOCB (XCRA,YCRA,NCRA,IAAI,IAGI,NGPS)
C
C This routine fills the area defined by the points (XCRA(I),YCRA(I)),
C for I = 1 to NCRA, if and only if none of the area identifiers for
C the area are negative.  The color used is determined from the area
C identifier of the area relative to group 3; it is assumed that 100
C colors are defined having color indices 151 through 250.
C
        DIMENSION XCRA(*),YCRA(*),IAAI(*),IAGI(*)
C
C It keeps track of the maximum value used for NCRA in a common block.
C
        COMMON /COMONA/ MAXN
C
        MAXN=MAX(MAXN,NCRA)
C
C Retrieve the number of contour levels being used.
C
        CALL CTGETI ('NCL - NUMBER OF CONTOUR LEVELS',NOCL)
C
C If the number of contour levels is non-zero and the area has more
C than two points, fill it.
C
        IF (NOCL.NE.0.AND.NCRA.GT.2) THEN
C
          IAI3=-1
C
          DO 101 I=1,NGPS
            IF (IAGI(I).EQ.3) IAI3=IAAI(I)
  101     CONTINUE
C
          IF (IAI3.GE.1.AND.IAI3.LE.NOCL+1) THEN
            CALL GSFACI (151+INT(((REAL(IAI3)-.5)/REAL(NOCL+1))*100.))
            CALL GFA    (NCRA,XCRA,YCRA)
          ELSE IF (IAI3.EQ.1001) THEN
            CALL GSFACI (2)
            CALL GFA    (NCRA,XCRA,YCRA)
          ELSE IF (IAI3.EQ.1002) THEN
            CALL GSFACI (3)
            CALL GFA    (NCRA,XCRA,YCRA)
          END IF
C
        END IF
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE GTISCP (RPNT,MPNT,NPNT,LOPN,
     +                   IEDG,MEDG,NEDG,LOEN,
     +                   ITRI,MTRI,NTRI,LOTN,
     +                   IDAT,XLAT,XLON)
C
        DIMENSION RPNT(MPNT),IEDG(MEDG),ITRI(MTRI)
C
C The ISCCP grid is an array of rectangles covering the cylindrical
C equidistant projection of the earth, at each center point of which
C we have latitude and longitude.  At each of the center points, we
C have available a topographic elevation, in meters above sea level.
C We can either use that data or generate dummy data at each of the
C specified center points.
C
C Declare variables to be used to read the ISCCP data.  The variable
C LINE just receives each of 6596 lines of data from the input file.
C
        CHARACTER*64 LINE
C
C Each line of data contains information about one of 6596 rectangular
C boxes on a cylindrical equidistant projection of the globe.  For each
C I, ILAT(I) is an integer between 1 and 72, inclusive, specifying
C which of 72 rows box I is a part of.  CLAT(I) and CLON(I) are the
C latitude and longitude, in degrees, of the center point of the
C box.  ZDAT(I) is a dummy field value that we generate to use for test
C purposes.  ITOP(I) is the topographic height of the box, in meters.
C IIPL(I) is the base index of the center point of the box in the point
C list.  For each IROW from 1 to 72, IIOR(IROW) is the index (between
C 1 and 6596, inclusive) of the first box of the row IROW; NBIR(IROW)
C is the number of boxes on that row.
C
        COMMON /CISCCP/ ILAT(6596),CLAT(6596),CLON(6596),ZDAT(6596),
     +                  ITOP(6596),IIPL(6596),IIOR(72),NBIR(72)
C
C Set a tolerance value used in the code that generates the mesh.
C
        DATA EPSI / 1.E-2 /
C
C DTOR is a constant used to convert angles from degrees to radians.
C
        DATA DTOR / .017453292519943 /
C
C Initialize the arrays that keep track of the initial index of each
C row of the ISCCP data and the number of boxes in each row.
C
        DO 101 I=1,72
          IIOR(I)=0
          NBIR(I)=0
  101   CONTINUE
C
C Read the data from the ASCII file "ctiscp.dat", adding field data
C values to be associated with the center points of the rectangles.
C
        OPEN (11,FILE='ctiscp.dat',STATUS='OLD',FORM='FORMATTED')
C
C Initialize the dummy-data generator.
C
        IF (MOD(IDAT,10).NE.1) CALL GGDINI (-1.,1.,1234,.4)
C
C Skip the first two lines of the file.
C
        READ (11,'(A64)') LINE
        READ (11,'(A64)') LINE
C
C Read through the rest of the file, saving certain pieces of data.
C For reference, the data look like this:
C
C  GRD LAT LON SQ1 SQ2     LAT      LON      BOX    %   TOPOG  VEG
C  BOX IND IND IND IND   CENTER   CENTER    AREA  LAND HEIGHT TYPE
C    1   1   1   1  48     1.25    60.00   80949   100   2895   8
C    2   1   2  49  96     1.25   180.00   80949   100   2865   8
C    3   1   3  97 144     1.25   300.00   80949   100   2621   8
C    4   2   1   1  16     3.75    20.00   80862   100   2834   8
C    .   .   .   .   .        .        .       .     .      .   .
C    .   .   .   .   .        .        .       .     .      .   .
C    .   .   .   .   .        .        .       .     .      .   .
C
C 6593  71   9 129 144   176.25   340.00   80862     0      0   0
C 6594  72   1   1  48   178.75    60.00   80949     0      0   0
C 6595  72   2  49  96   178.75   180.00   80949     0      0   0
C 6596  72   3  97 144   178.75   300.00   80949     0      0   0
C
        DO 102 I=1,6596
          READ (11,'(A64)') LINE
          READ (LINE,'(2I4,12X,2E9.0,14X,I7)')
     +                                 J,ILAT(I),CLAT(I),CLON(I),ITOP(I)
          CLAT(I)=CLAT(I)-90.
          IF (J.NE.I) THEN
            PRINT * , 'GTISCP - STOP - DATA FILE CORRUPTED?'
            STOP
          END IF
          IF (MOD(IDAT,10).EQ.1) THEN
            ZDAT(I)=REAL(ITOP(I))
          ELSE
            ZDAT(I)=GGDPNT(CLAT(I),CLON(I))
          END IF
          IF (IIOR(ILAT(I)).EQ.0) IIOR(ILAT(I))=I
          NBIR(ILAT(I))=NBIR(ILAT(I))+1
  102   CONTINUE
C
        CLOSE (11)
C
C Build structures forming the triangular mesh.  First, zero the counts
C of points, edges, and triangles formed.
C
        NPNT=0
        NEDG=0
        NTRI=0
C
C Loop through the 72 rows of the rectangular mesh, dealing with each
C row in turn.
C
        DO 108 IROW=1,72
C
C First, add to the point list the center points of all the boxes in
C the row.  We remember the first base index used in the point list
C for later use in a test to determine the order in which to specify
C the edges of a triangle.
C
          IIFP=NPNT
C
          DO 103 IBOX=IIOR(IROW),IIOR(IROW)+NBIR(IROW)-1
            IF (NPNT+LOPN.GT.MPNT) THEN
              PRINT * , ' '
              PRINT * , 'GTISCP - STOP - POINT ARRAY TOO SMALL'
            ELSE
              IIPL(IBOX)=NPNT
              RPNT(NPNT+1)=COS(DTOR*CLAT(IBOX))*COS(DTOR*CLON(IBOX))
              RPNT(NPNT+2)=COS(DTOR*CLAT(IBOX))*SIN(DTOR*CLON(IBOX))
              RPNT(NPNT+3)=SIN(DTOR*CLAT(IBOX))
              RPNT(NPNT+4)=         ZDAT(IBOX)
              RPNT(NPNT+5)=    REAL(ITOP(IBOX))
              NPNT=NPNT+LOPN
            END IF
  103     CONTINUE
C
C Next, add to the edge list the edges defined by joining all adjacent
C pairs of those center points.  Negate the pointers to the triangles
C to the left and right of the edge.
C
          DO 104 I=1,NBIR(IROW)
            IF (NEDG+LOEN.GT.MEDG) THEN
              PRINT * , ' '
              PRINT * , 'GTISCP - STOP - EDGE ARRAY TOO SMALL'
              STOP
            ELSE
              IEDG(NEDG+1)=IIPL(IIOR(IROW)+MOD(I-1,NBIR(IROW)))
              IEDG(NEDG+2)=IIPL(IIOR(IROW)+MOD(I  ,NBIR(IROW)))
              IEDG(NEDG+3)=-1
              IEDG(NEDG+4)=-1
              IEDG(NEDG+5)=0
              NEDG=NEDG+LOEN
            END IF
  104     CONTINUE
C
C Next, add to the edge list the edges defined by joining points of the
C current row to points of the last row, making sure to add them in the
C proper order.  (These edges form triangles we will need to add to the
C triangle list; we remember the index of the first edge so defined.)
C
          IF (IROW.NE.1) THEN
            IIFE=NEDG
            DO 106 IBOX=IIOR(IROW),IIOR(IROW)+NBIR(IROW)-1
              SLCR=CLON(IBOX)-180./REAL(NBIR(IROW))
              ELCR=CLON(IBOX)+180./REAL(NBIR(IROW))
              JBOX=IIOR(IROW-1)
              JDIR=-1
  105         SLLR=CLON(JBOX)-180./REAL(NBIR(IROW-1))
              ELLR=CLON(JBOX)+180./REAL(NBIR(IROW-1))
              IF (ABS(SLCR-SLLR).GT.180.) THEN
                DLTA=SIGN(360.,SLCR-SLLR)
                SLLR=SLLR+DLTA
                ELLR=ELLR+DLTA
              END IF
              IF (SLCR.LT.ELLR+EPSI.AND.ELCR.GT.SLLR+EPSI) THEN
                IF (JDIR.LT.0) THEN
                  IF (JBOX.EQ.IIOR(IROW-1)) JBOX=JBOX+NBIR(IROW-1)
                  JBOX=JBOX-1
                  GO TO 105
                ELSE
                  JDIR=1
                  IF (NEDG+LOEN.GT.MEDG) THEN
                    PRINT * , ' '
                    PRINT * , 'GTISCP - STOP - EDGE ARRAY TOO SMALL'
                    STOP
                  ELSE
                    IEDG(NEDG+1)=IIPL(IBOX)
                    IEDG(NEDG+2)=IIPL(JBOX)
                    IEDG(NEDG+3)=-1
                    IEDG(NEDG+4)=-1
                    IEDG(NEDG+5)=0
                    NEDG=NEDG+LOEN
                  END IF
                END IF
              ELSE
                IF (JDIR.GT.0) GO TO 106
                JDIR=0
              END IF
              JBOX=JBOX+1
              IF (JBOX.EQ.IIOR(IROW-1)+NBIR(IROW-1)) JBOX=IIOR(IROW-1)
              GO TO 105
  106       CONTINUE
          END IF
C
C Finally, add to the triangle list the triangles created by the edges
C we just added to the edge list and update all the pointers from the
C edge list into the triangle list.
C
          IF (IROW.EQ.1) THEN
            CALL ADDTRI (RPNT,IEDG,LOEN,ITRI,LOTN,MTRI,NTRI,
     +                                    NEDG-LOEN,NEDG-LOEN*2,IDAT/10)
          ELSE
            IIE2=NEDG-LOEN
            DO 107 IIOE=IIFE,NEDG-LOEN,LOEN
              IIE1=IIE2
              IIE2=IIOE
              IF      (IEDG(IIE1+1).EQ.IEDG(IIE2+1).OR.
     +                 IEDG(IIE1+1).EQ.IEDG(IIE2+2)) THEN
                IOCP=IEDG(IIE1+1)
              ELSE IF (IEDG(IIE1+2).EQ.IEDG(IIE2+1).OR.
     +                 IEDG(IIE1+2).EQ.IEDG(IIE2+2)) THEN
                IOCP=IEDG(IIE1+2)
              ELSE
                PRINT * , 'GTISCP - STOP - EDGES DO NOT JOIN'
                STOP
              END IF
              IF (IOCP.LT.IIFP) THEN
                CALL ADDTRI (RPNT,IEDG,LOEN,ITRI,LOTN,MTRI,NTRI,
     +                                                IIE1,IIE2,IDAT/10)
              ELSE
                CALL ADDTRI (RPNT,IEDG,LOEN,ITRI,LOTN,MTRI,NTRI,
     +                                                IIE2,IIE1,IDAT/10)
              END IF
  107       CONTINUE
            IF (IROW.EQ.72) CALL ADDTRI (RPNT,IEDG,LOEN,ITRI,LOTN,MTRI,
     +                               NTRI,IIFE-LOEN*2,IIFE-LOEN,IDAT/10)
          END IF
C
  108   CONTINUE
C
C Return the latitude and longitude of the approximate center point of
C the mesh on the globe.
C
        XLAT=0.
        XLON=0.
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE ADDTRI (RPNT,IEDG,LOEN,ITRI,LOTN,MTRI,NTRI,IIE1,IIE2
     +                                                            ,IDAT)
C
        DIMENSION RPNT(*),IEDG(*),ITRI(*)
C
C This routine is intended to add a triangle to the triangle list.  It
C is given the base indices of two edges of the triangle and must find
C the third edge for itself.  It is also responsible for setting the
C pointers from the edge nodes to the triangle node properly.
C
        IF (IEDG(IIE1+1).EQ.IEDG(IIE2+1)) THEN
          IIP1=IEDG(IIE1+2)
          IIP2=IEDG(IIE1+1)
          IIP3=IEDG(IIE2+2)
        ELSE IF (IEDG(IIE1+1).EQ.IEDG(IIE2+2)) THEN
          IIP1=IEDG(IIE1+2)
          IIP2=IEDG(IIE1+1)
          IIP3=IEDG(IIE2+1)
        ELSE IF (IEDG(IIE1+2).EQ.IEDG(IIE2+1)) THEN
          IIP1=IEDG(IIE1+1)
          IIP2=IEDG(IIE1+2)
          IIP3=IEDG(IIE2+2)
        ELSE IF (IEDG(IIE1+2).EQ.IEDG(IIE2+2)) THEN
          IIP1=IEDG(IIE1+1)
          IIP2=IEDG(IIE1+2)
          IIP3=IEDG(IIE2+1)
        ELSE
          PRINT * , 'ADDTRI - STOP - EDGES DO NOT JOIN'
          STOP
        END IF
C
C Look backwards in the edge list for the third edge of the triangle.
C
        DO 101 I=IIE1,0,-LOEN
          IF ((IEDG(I+1).EQ.IIP1.AND.IEDG(I+2).EQ.IIP3).OR.
     +        (IEDG(I+1).EQ.IIP3.AND.IEDG(I+2).EQ.IIP1)) THEN
            IIE3=I
            GO TO 102
          END IF
  101   CONTINUE
C
        PRINT * , 'ADDTRI - STOP - CANNOT FIND THIRD EDGE'
        STOP
C
C All three edges are now known; generate the triangle.
C
  102   IF (NTRI+LOTN.GT.MTRI) THEN
C
          PRINT * , ' '
          PRINT * , 'ADDTRI - STOP - TRIANGLE ARRAY TOO SMALL'
          STOP
C
        ELSE
C
          ITRI(NTRI+1)=IIE1
          ITRI(NTRI+2)=IIE2
          ITRI(NTRI+3)=IIE3
          ITRI(NTRI+4)=0
C
          IF      (MOD(IDAT,10).EQ.1) THEN
C
C Land is blocked.
C
            NOBV=0
            IF (RPNT(IIP1+5).NE.0.) NOBV=NOBV+1
            IF (RPNT(IIP2+5).NE.0.) NOBV=NOBV+1
            IF (RPNT(IIP3+5).NE.0.) NOBV=NOBV+1
            IF (NOBV.GT.IDAT/10) ITRI(NTRI+4)=1
C
          ELSE IF (MOD(IDAT,10).EQ.2) THEN
C
C Ocean is blocked.
C
            NOBV=0
            IF (RPNT(IIP1+5).EQ.0.) NOBV=NOBV+1
            IF (RPNT(IIP2+5).EQ.0.) NOBV=NOBV+1
            IF (RPNT(IIP3+5).EQ.0.) NOBV=NOBV+1
            IF (NOBV.GT.IDAT/10) ITRI(NTRI+4)=1
C
          END IF
C
          NTRI=NTRI+LOTN
C
        END IF
C
C Update the appropriate pointers in the edge nodes.
C
        IF (IEDG(IIE1+1).EQ.IIP1) THEN
          IEDG(IIE1+3)=NTRI-LOTN+1
        ELSE
          IEDG(IIE1+4)=NTRI-LOTN+1
        END IF
C
        IF (IEDG(IIE2+1).EQ.IIP2) THEN
          IEDG(IIE2+3)=NTRI-LOTN+2
        ELSE
          IEDG(IIE2+4)=NTRI-LOTN+2
        END IF
C
        IF (IEDG(IIE3+1).EQ.IIP3) THEN
          IEDG(IIE3+3)=NTRI-LOTN+3
        ELSE
          IEDG(IIE3+4)=NTRI-LOTN+3
        END IF
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE DSISCP
C
C Draw the original ISCCP grid, using data passed in a common block.
C
        COMMON /CISCCP/ ILAT(6596),CLAT(6596),CLON(6596),ZDAT(6596),
     +                  ITOP(6596),IIPL(6596),IIOR(72),NBIR(72)
C
        CALL PLOTIT (0,0,2)
        CALL GSPLCI (8)
C
        DO 101 I=1,6596
          SLAT=CLAT(I)-1.25
          ELAT=CLAT(I)+1.25
          SLON=CLON(I)-180./REAL(NBIR(ILAT(I)))
          ELON=CLON(I)+180./REAL(NBIR(ILAT(I)))
          IF (ILAT(I).NE.1) CALL DLOCLA (SLAT,SLON,SLAT,ELON)
          CALL DLOCLO (SLAT,SLON,ELAT,SLON)
  101   CONTINUE
C
C Draw the continental outlines and lat/lon grid.
C
        CALL PLOTIT (0,0,2)
        CALL GSPLCI (13)
        CALL MAPGRD
        CALL PLOTIT (0,0,2)
        CALL GSPLCI (14)
        CALL MAPLOT
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE DRSGCR (ALAT,ALON,BLAT,BLON)
C
C (DRSGCR = DRaw Shortest Great Circle Route)
C
C This routine draws the shortest great circle route joining two points
C on the globe.  Note that MPTS = INT(180./SIZE) + 1.
C
        PARAMETER (MPTS=181,SIZE=1.)
C
        DIMENSION QLAT(MPTS),QLON(MPTS)
C
        NPTS=MAX(1,MIN(MPTS,INT(ADSGCR(ALAT,ALON,BLAT,BLON)/SIZE)))
C
        CALL MAPGCI (ALAT,ALON,BLAT,BLON,NPTS,QLAT,QLON)
C
        CALL MAPIT (ALAT,ALON,0)
C
        DO 101 I=1,NPTS
          CALL MAPIT (QLAT(I),QLON(I),1)
  101   CONTINUE
C
        CALL MAPIT (BLAT,BLON,2)
C
        CALL MAPIQ
C
        RETURN
C
      END


      FUNCTION ADSGCR (ALAT,ALON,BLAT,BLON)
C
C (ADSGCR = Angle in Degrees along Shortest Great Circle Route)
C
C This function returns the shortest great circle distance, in degrees,
C between two points, A and B, on the surface of the globe.
C
        DATA DTOR / .017453292519943 /
        DATA RTOD / 57.2957795130823 /
C
        XCOA=COS(DTOR*ALAT)*COS(DTOR*ALON)
        YCOA=COS(DTOR*ALAT)*SIN(DTOR*ALON)
        ZCOA=SIN(DTOR*ALAT)
C
        XCOB=COS(DTOR*BLAT)*COS(DTOR*BLON)
        YCOB=COS(DTOR*BLAT)*SIN(DTOR*BLON)
        ZCOB=SIN(DTOR*BLAT)
C
        ADSGCR=2.*RTOD*ASIN(SQRT((XCOA-XCOB)**2+
     +                           (YCOA-YCOB)**2+
     +                           (ZCOA-ZCOB)**2)/2.)
C
        RETURN
C
      END


      SUBROUTINE ELLIPS (XCFR,YCFR,RADA,RADB,ROTD,DSTP)
C
C This routine fills an ellipse.  The arguments are as follows:
C
C   XCFR and YCFR are the coordinates of the center of the ellipse, in
C   the fractional coordinate system.
C
C   RADA is the length of the semimajor axis of the ellipse (i.e., the
C   distance from the center of the ellipse to one of the two points on
C   the ellipse which are furthest from the center).  This is a distance
C   in the fractional coordinate system.
C
C   RADB is the length of the semiminor axis of the ellipse (i.e., the
C   distance from the center of the ellipse to one of the two points on
C   the ellipse which are nearest to the center).  This is a distance in
C   the fractional coordinate system.
C
C   ROTD is a rotation angle, in degrees.  If ROTD is 0, the major axis
C   of the ellipse is horizontal.  If ROTD is 90, the major axis is
C   vertical.
C
C   DSTP is the step size, in degrees, between any two consecutive
C   points used to draw the ellipse.  The actual value used will be
C   limited to the range from .1 degrees (3600 points used to draw
C   the ellipse) to 90 degrees (4 points used to draw the ellipse).
C
C Declare work arrays to hold the coordinates.
C
        DIMENSION XCRA(3601),YCRA(3601)
C
C DTOR is pi over 180, used to convert an angle from degrees to radians.
C
        DATA DTOR / .017453292519943 /
C
C Get the rotation angle in radians.
C
        ROTR=DTOR*ROTD
C
C Compute the number of steps to be used to draw the ellipse and the
C actual number of degrees for each step.
C
        NSTP=MAX(4,MIN(3600,INT(360./MAX(.1,MIN(90.,DSTP)))))
        RSTP=360./NSTP
C
C Compute coordinates for the ellipse (just some trigonometry).
C
        DO 101 ISTP=0,NSTP
          ANGL=DTOR*REAL(ISTP)*RSTP
          XTMP=RADA*COS(ANGL)
          YTMP=RADB*SIN(ANGL)
          XCRA(ISTP+1)=CFUX(XCFR+XTMP*COS(ROTR)-YTMP*SIN(ROTR))
          YCRA(ISTP+1)=CFUY(YCFR+XTMP*SIN(ROTR)+YTMP*COS(ROTR))
  101   CONTINUE
C
C Fill it.
C
        CALL GFA (NSTP+1,XCRA,YCRA)
C
C Draw it.
C
        CALL GPL (NSTP+1,XCRA,YCRA)
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE IPIQOS (ALAT,ALON,BLAT,BLON,CLAT,CLON,DLAT,DLON,
     +                                       XFRA,YFRA,ELAT,ELON)
C
C (IPIQOS = Interpolate Point In Quadrilateral on Sphere)
C
C This routine, given the latitudes and longitudes of four points (A, B,
C C, and D) forming a "quadrilateral" on the globe and two interpolation
C fractions (XFRA and YFRA, each between 0 and 1, inclusive), finds the
C point E defined by the following diagram and returns its latitude and
C longitude.
C
C                              C------Q----D
C                              |      |    |
C                              |      E    |
C                              |      |    |
C                              |      |    |
C                              A------P----B
C
C P and Q are positioned such that AP/AB = CQ/CD = XFRA and then E is
C positioned such that PE/PQ = YFRA (where "XY" is interpreted to mean
C "the shortest great circle distance from X to Y").
C
C It is assumed that the "quadrilateral" ABDC is "convex" (a working
C definition of which might be that none of the four great circles
C defined by its edges - the ones through A and B, B and D, D and C,
C and C and A - cross it anywhere.  However, this is not verified.
C
C The code is easy:
C
        CALL FPSGCR (ALAT,ALON,BLAT,BLON,XFRA,PLAT,PLON)
        CALL FPSGCR (CLAT,CLON,DLAT,DLON,XFRA,QLAT,QLON)
        CALL FPSGCR (PLAT,PLON,QLAT,QLON,YFRA,ELAT,ELON)
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE FPSGCR (ALAT,ALON,BLAT,BLON,FRCT,FLAT,FLON)
C
C (FPSGCR = Find Point on Shortest Great Circle Route)
C
        REAL    ALAT,ALON,BLAT,BLON,FRCT,FLAT,FLON
C
C This routine, given the latitudes and longitudes of two points A and
C B on the surface of the globe and a fraction FRCT, between 0. and 1.,
C interpolates a point F along the shortest great circle route joining
C A to B such that the distance from A to F, divided by the distance
C from A to B, is equal to FRCT, and returns its latitude and longitude
C in FLAT and FLON.
C
C Define the constants used to convert from degrees to radians and
C vice-versa.
C
        DATA DTOR / .017453292519943 /
        DATA RTOD / 57.2957795130823 /
C
C Compute the X, Y, and Z coordinates (on a unit sphere) of the point B.
C
        CALL LLPXYZ (BLAT,BLON,XCPB,YCPB,ZCPB)
C
C Rotating about the Z axis by the angle -ALON would carry A into the XZ
C plane.
C
        CALL ROTXYZ (3,-ALON,XCPB,YCPB,ZCPB)
C
C Then, rotating about the Y axis by the angle ALAT would carry A into
C the point on the X axis with coordinates (1,0,0).
C
        CALL ROTXYZ (2,ALAT,XCPB,YCPB,ZCPB)
C
C Then, rotating about the X axis by the angle ALPH = -ATAN(ZCPB/YCPB)
C would leave the position of A unchanged but carry B into a point in
C the XY plane.
C
        IF (ZCPB.NE.0..OR.YCPB.NE.0.) THEN
          ALPH=-RTOD*ATAN2(ZCPB,YCPB)
        ELSE
          ALPH=0.
        END IF
C
        CALL ROTXYZ (1,ALPH,XCPB,YCPB,ZCPB)
C
C The angle BETA from A to B can now be computed easily.
C
        IF (XCPB.NE.0..OR.YCPB.NE.0.) THEN
          BETA=ATAN2(YCPB,XCPB)
        ELSE
          BETA=0.
        END IF
C
C Interpolate a point at the desired position between the points A and
C B, map it back to its original position on the great circle route from
C A to B, and get its latitude and longitude to return to the caller.
C
        GAMA=FRCT*BETA
C
        XCPF=COS(GAMA)
        YCPF=SIN(GAMA)
        ZCPF=0.
C
        CALL ROTXYZ (1,-ALPH,XCPF,YCPF,ZCPF)
        CALL ROTXYZ (2,-ALAT,XCPF,YCPF,ZCPF)
        CALL ROTXYZ (3, ALON,XCPF,YCPF,ZCPF)
C
        CALL XYZLLP (XCPF,YCPF,ZCPF,FLAT,FLON)
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE LLPXYZ (RLAT,RLON,RVOX,RVOY,RVOZ)
C
C (LLPXYZ = Lat/Lon Position to XYZ coordinates)
C
C Given the latitude and longitude of a point on the globe, return its
C X, Y, and Z coordinates.
C
        DATA DTOR / .017453292519943 /
C
        RVOX=COS(DTOR*RLAT)*COS(DTOR*RLON)
        RVOY=COS(DTOR*RLAT)*SIN(DTOR*RLON)
        RVOZ=SIN(DTOR*RLAT)
C
        RETURN
C
      END


      SUBROUTINE XYZLLP (RVOX,RVOY,RVOZ,RLAT,RLON)
C
C (XYZLLP = XYZ coordinates to Lat/Lon Position)
C
C Given the X, Y, and Z coordinates of a point on the globe, return its
C latitude and longitude.
C
        DATA RTOD / 57.2957795130823 /
C
        RLAT=RTOD*ASIN(RVOZ)
C
        IF (RVOX.NE.0.OR.RVOY.NE.0.) THEN
          RLON=RTOD*ATAN2(RVOY,RVOX)
        ELSE
          RLON=0.
        END IF
C
        RETURN
C
      END


      SUBROUTINE ROTXYZ (IAXS,ANGL,XCRD,YCRD,ZCRD)
C
C (ROTXYZ = ROTate a point defined by its X, Y, and Z coordinates)
C
C This is a modified version of a routine in the NCAR Graphics package,
C which is used in some of the examples.  It rotates the point having
C coordinates (XCRD,YCRD,ZCRD) by an angle ANGL about the axis specified
C by IAXS (1 for the X axis, 2 for the Y axis, 3 for the Z axis).
C
C One assumes a right-handed system with X, Y, and Z axes.  Rotating by
C an angle "a" about the X axis maps the point (x,y,z) into the point
C (x',y',z'), where
C
C       x' = x
C       y' = y cos(a) - z sin(a)
C       z' = z cos(a) + y sin(a)
C
C A positive value of "a" represents rotation in the direction from the
C Y axis to the Z axis.
C
C Similarly, rotating by an angle "a" about the Y axis maps the point
C (x,y,z) into the point (x',y',z'), where
C
C       x' = x cos(a) + z sin(a)
C       y' = y
C       z' = z cos(a) - x sin(a)
C
C A positive value of "a" represents rotation in the direction from the
C Z axis to the X axis.
C
C Rotating by an angle "a" about the Z axis maps the point (x,y,z) into
C the point (x',y',z'), where
C
C       x' = x cos(a) - y sin(a)
C       y' = y cos(a) + x sin(a)
C       y' = y
C
C A positive value of "a" represents rotation in the direction from the
C X axis to the Y axis.
C
C Define a multiplicative constant to convert from degrees to radians.
C
        DATA DTOR / .017453292519943 /
C
C Trigonometry.
C
        SINA=SIN(DTOR*ANGL)
        COSA=COS(DTOR*ANGL)
C
        XTMP=XCRD
        YTMP=YCRD
        ZTMP=ZCRD
C
        IF (IAXS.EQ.1) THEN
          YCRD=YTMP*COSA-ZTMP*SINA
          ZCRD=ZTMP*COSA+YTMP*SINA
        ELSE IF (IAXS.EQ.2) THEN
          XCRD=XTMP*COSA+ZTMP*SINA
          ZCRD=ZTMP*COSA-XTMP*SINA
        ELSE
          XCRD=XTMP*COSA-YTMP*SINA
          YCRD=YTMP*COSA+XTMP*SINA
        END IF
C
        RETURN
C
      END


      SUBROUTINE DLOCLA (ALAT,ALON,BLAT,BLON)
C
C (DLOCLA = Draw Line Of Constant LAtitude)
C
C This routine draws a line of constant latitude joining two points on
C the globe.
C
        PARAMETER (MPTS=181,SIZE=1.,DTOR=.017453292519943)
C
        NPTS=MAX(0,MIN(MPTS,INT(COS(DTOR*ALAT)*ABS(BLON-ALON)/SIZE)))
C
        CALL MAPIT (ALAT,ALON,0)
C
        DO 101 I=1,NPTS
          CALL MAPIT (ALAT,ALON+(REAL(I)/REAL(NPTS+1))*(BLON-ALON),1)
  101   CONTINUE
C
        CALL MAPIT (BLAT,BLON,2)
C
        CALL MAPIQ
C
        RETURN
C
      END


      SUBROUTINE DLOCLO (ALAT,ALON,BLAT,BLON)
C
C (DLOCLO = Draw Line Of Constant LOngitude)
C
C This routine draws a line of constant longitude joining two points on
C the globe.
C
        PARAMETER (MPTS=181,SIZE=1.)
C
        NPTS=MAX(0,MIN(MPTS,INT(ABS(BLAT-ALAT)/SIZE)))
C
        CALL MAPIT (ALAT,ALON,0)
C
        DO 101 I=1,NPTS
          CALL MAPIT (ALAT+(REAL(I)/REAL(NPTS+1))*(BLAT-ALAT),ALON,1)
  101   CONTINUE
C
        CALL MAPIT (BLAT,BLON,2)
C
        CALL MAPIQ
C
        RETURN
C
      END


      SUBROUTINE GGDINI (DLOW,DHGH,NRND,FRCT)
C
C The routines GGDINI and GGDPNT are used to generate test data on the
C globe, using a method which is essentially fractal and is based on
C successive elaborations of an icosahedron.
C
C To initialize the generation of a particular data field, execute the
C statement
C
C      CALL GGDINI (DLOW,DHGH,NRND,FRCT)
C
C DLOW is the desired minimum value and DHGH the desired maximum value.
C NRND is the number of random numbers (from the function FRAN) to be
C discarded before beginning to generate the field.  FRCT is a fraction
C between -1. and 1. which affects the "roughness" of the generated
C data; values near 0. will give smoother values than values further
C from 0.
C
C After a call to GGDINI, the function GGDPNT returns the value of the
C generated data field at the point (RLAT,RLON); the angles RLAT and
C RLON are given in radians.
C
C Parameters determine how many elaboration steps will be used (NELA)
C and therefore how many faces, edges, and vertices will be used (MFCE,
C MEDG, and MVTX, respectively).  Choose values from the table which
C follows:
C
C     NELA      MFCE      MEDG      MVTX
C     ----      ----      ----      ----
C        0        20        30        12
C        1       100       150        42
C        2       420       630       162
C        3      1700      2550       642
C        4      6820     10230      2562
C        5     27300     40950     10242
C        6    109220    163830     40962
C
C       PARAMETER(NELA=5,MFCE= 27300,MEDG= 40950,MVTX=10242,NELP=NELA+1)
        PARAMETER(NELA=6,MFCE=109220,MEDG=163830,MVTX=40962,NELP=NELA+1)
C
C NOTE:  A COPY OF THE ABOVE PARAMETER STATEMENT MUST BE PLACED IN THE
C FUNCTION GGDPNT, AS WELL.
C
C Information about the structure of the elaborated icosahedron is
C stored in variables in the labelled common block GGDCMN.  Each of
C NFCE entries in IFCE defines a triangular face; it consists of three
C pointers to elements of IEDG plus another element which, if non-zero,
C points to the faces into which that face was broken by the next
C elaboration step.  Each of NEDG entries in IEDG defines an edge;
C the first two elements are pointers to elements of VRTX, and the
C second two elements, if non-zero, are pointers back into IEDG, to
C the two edges into which the edge was broken by the next elaboration
C step.  Each of NVTX entries in VRTX defines a vertex, including the
C position and the data value associated with it.
C
C The arrays LFCE, LEDG, and LVTX point to the beginning and ending of
C the faces, edges, and vertices, respectively, added by the step whose
C number is given by the second index.
C
C RLOW and RHGH are just copies of the user's DLOW and DHGH; RMIN and
C RMAX are the actual minimum and maximum value of the data values
C stored in the array VRTX.
C
        COMMON /GGDCMN/ NFCE,IFCE(4,MFCE),NEDG,IEDG(4,MEDG),
     +                  NVTX,VRTX(4,MVTX),
     +                  LFCE(2,NELP),LEDG(2,NELP),LVTX(2,NELP),
     +                  RLOW,RHGH,RMIN,RMAX
        SAVE   /GGDCMN/
C
C Declare local arrays which are used for initialization.
C
        DIMENSION JFCE(3,20),JEDG(2,30),XCVI(12),YCVI(12),ZCVI(12)
C
C Define the twenty faces of an icosahedron (pointers to edges).
C
        DATA JFCE(1, 1),JFCE(2, 1),JFCE(3, 1) /  1,11, 2 /
        DATA JFCE(1, 2),JFCE(2, 2),JFCE(3, 2) /  2,19, 3 /
        DATA JFCE(1, 3),JFCE(2, 3),JFCE(3, 3) /  3,25, 4 /
        DATA JFCE(1, 4),JFCE(2, 4),JFCE(3, 4) /  4,29, 5 /
        DATA JFCE(1, 5),JFCE(2, 5),JFCE(3, 5) /  1,14, 5 /
        DATA JFCE(1, 6),JFCE(2, 6),JFCE(3, 6) / 12,28,14 /
        DATA JFCE(1, 7),JFCE(2, 7),JFCE(3, 7) / 12,27,13 /
        DATA JFCE(1, 8),JFCE(2, 8),JFCE(3, 8) / 11,20,13 /
        DATA JFCE(1, 9),JFCE(2, 9),JFCE(3, 9) / 20,30,21 /
        DATA JFCE(1,10),JFCE(2,10),JFCE(3,10) / 19,26,21 /
        DATA JFCE(1,11),JFCE(2,11),JFCE(3,11) / 16,18,26 /
        DATA JFCE(1,12),JFCE(2,12),JFCE(3,12) / 16,25,17 /
        DATA JFCE(1,13),JFCE(2,13),JFCE(3,13) / 15,23,17 /
        DATA JFCE(1,14),JFCE(2,14),JFCE(3,14) / 23,29,24 /
        DATA JFCE(1,15),JFCE(2,15),JFCE(3,15) / 22,28,24 /
        DATA JFCE(1,16),JFCE(2,16),JFCE(3,16) /  7, 8,22 /
        DATA JFCE(1,17),JFCE(2,17),JFCE(3,17) /  6,15, 7 /
        DATA JFCE(1,18),JFCE(2,18),JFCE(3,18) /  6,18,10 /
        DATA JFCE(1,19),JFCE(2,19),JFCE(3,19) /  9,30,10 /
        DATA JFCE(1,20),JFCE(2,20),JFCE(3,20) /  8,27, 9 /
C
C Define the thirty edges of the icosahedron (pointers to vertices).
C
        DATA JEDG(1, 1),JEDG(2, 1) /  1, 3 /
        DATA JEDG(1, 2),JEDG(2, 2) /  1, 5 /
        DATA JEDG(1, 3),JEDG(2, 3) /  1, 7 /
        DATA JEDG(1, 4),JEDG(2, 4) /  1, 9 /
        DATA JEDG(1, 5),JEDG(2, 5) /  1,11 /
        DATA JEDG(1, 6),JEDG(2, 6) /  2, 4 /
        DATA JEDG(1, 7),JEDG(2, 7) /  2, 6 /
        DATA JEDG(1, 8),JEDG(2, 8) /  2, 8 /
        DATA JEDG(1, 9),JEDG(2, 9) /  2,10 /
        DATA JEDG(1,10),JEDG(2,10) /  2,12 /
        DATA JEDG(1,11),JEDG(2,11) /  3, 5 /
        DATA JEDG(1,12),JEDG(2,12) /  3, 8 /
        DATA JEDG(1,13),JEDG(2,13) /  3,10 /
        DATA JEDG(1,14),JEDG(2,14) /  3,11 /
        DATA JEDG(1,15),JEDG(2,15) /  4, 6 /
        DATA JEDG(1,16),JEDG(2,16) /  4, 7 /
        DATA JEDG(1,17),JEDG(2,17) /  4, 9 /
        DATA JEDG(1,18),JEDG(2,18) /  4,12 /
        DATA JEDG(1,19),JEDG(2,19) /  5, 7 /
        DATA JEDG(1,20),JEDG(2,20) /  5,10 /
        DATA JEDG(1,21),JEDG(2,21) /  5,12 /
        DATA JEDG(1,22),JEDG(2,22) /  6, 8 /
        DATA JEDG(1,23),JEDG(2,23) /  6, 9 /
        DATA JEDG(1,24),JEDG(2,24) /  6,11 /
        DATA JEDG(1,25),JEDG(2,25) /  7, 9 /
        DATA JEDG(1,26),JEDG(2,26) /  7,12 /
        DATA JEDG(1,27),JEDG(2,27) /  8,10 /
        DATA JEDG(1,28),JEDG(2,28) /  8,11 /
        DATA JEDG(1,29),JEDG(2,29) /  9,11 /
        DATA JEDG(1,30),JEDG(2,30) / 10,12 /
C
C Define the vertices of the icosahedron (note radius less than one).
C
        DATA XCVI / .9510565162952 , -.9510565162951 ,  .4253254041760 ,
     +             -.4253254041760 ,  .4253254041760 , -.4253254041760 ,
     +              .4253254041760 , -.4253254041760 ,  .4253254041760 ,
     +             -.4253254041760 ,  .4253254041760 , -.4253254041760 /
        DATA YCVI / .0000000000000 ,  .0000000000000 ,  .8506508083520 ,
     +             -.8506508083520 ,  .2628655560596 , -.2628655560596 ,
     +             -.6881909602356 ,  .6881909602356 , -.6881909602356 ,
     +              .6881909602356 ,  .2628655560595 , -.2628655560596 /
        DATA ZCVI / .0000000000000 ,  .0000000000000 ,  .0000000000000 ,
     +              .0000000000000 ,  .8090169943749 , -.8090169943749 ,
     +              .5000000000000 , -.5000000000000 , -.5000000000000 ,
     +              .5000000000000 , -.8090169943749 ,  .8090169943749 /
C
C Define constants for converting from degrees to radians and back.
C
        DATA DTOR / .017453292519943 /
        DATA RTOD / 57.2957795130823 /
C
C Spin up the random number generator.
C
        DO 101 I=1,NRND
          TEMP=FRAN()
  101   CONTINUE
C
C Initialize the list of faces.
C
        NFCE=20
C
        DO 102 I=1,NFCE
          IFCE(1,I)=JFCE(1,I)
          IFCE(2,I)=JFCE(2,I)
          IFCE(3,I)=JFCE(3,I)
          IFCE(4,I)=0
  102   CONTINUE
C
C Initialize the list of edges.
C
        NEDG=30
C
        DO 103 I=1,NEDG
          IEDG(1,I)=JEDG(1,I)
          IEDG(2,I)=JEDG(2,I)
          IEDG(3,I)=0
          IEDG(4,I)=0
  103   CONTINUE
C
C Initialize the list of vertices.
C
        NVTX=12
C
        DO 104 I=1,NVTX
          TEMP=SQRT(XCVI(I)**2+YCVI(I)**2+ZCVI(I)**2)
          VRTX(1,I)=XCVI(I)/TEMP
          VRTX(2,I)=YCVI(I)/TEMP
          VRTX(3,I)=ZCVI(I)/TEMP
          VRTX(4,I)=FRAN()
  104   CONTINUE
C
C Define pointers to the existing faces, edges, and vertices.
C
        LFCE(1,1)=1
        LFCE(2,1)=NFCE
C
        LEDG(1,1)=1
        LEDG(2,1)=NEDG
C
        LVTX(1,1)=1
        LVTX(2,1)=NVTX
C
C Define the initial multiplier for the random number generator.
C
        RMUL=1.
C
C Do a number of successive elaboration steps.
C
        DO 108 IELA=2,NELP
C
C Update pointers which will tell us what faces, edges, and vertices
C were added during this step.
C
          LFCE(1,IELA)=NFCE+1
          LEDG(1,IELA)=NEDG+1
          LVTX(1,IELA)=NVTX+1
C
C Change the multiplier for the random number generator.
C
          RMUL=FRCT*RMUL
C
C Add a vertex at the midpoint of each edge added during the last step.
C
          DO 105 I=LEDG(1,IELA-1),LEDG(2,IELA-1)
            NVTX=NVTX+1
            IF (NVTX.GT.MVTX) GO TO 901
            VRTX(1,NVTX)=.5*(VRTX(1,IEDG(1,I))+VRTX(1,IEDG(2,I)))
            VRTX(2,NVTX)=.5*(VRTX(2,IEDG(1,I))+VRTX(2,IEDG(2,I)))
            VRTX(3,NVTX)=.5*(VRTX(3,IEDG(1,I))+VRTX(3,IEDG(2,I)))
            VRTX(4,NVTX)=.5*(VRTX(4,IEDG(1,I))+VRTX(4,IEDG(2,I)))
            TEMP=SQRT(VRTX(1,NVTX)**2+VRTX(2,NVTX)**2+VRTX(3,NVTX)**2)
            VRTX(1,NVTX)=VRTX(1,NVTX)/TEMP
            VRTX(2,NVTX)=VRTX(2,NVTX)/TEMP
            VRTX(3,NVTX)=VRTX(3,NVTX)/TEMP
            NEDG=NEDG+2
            IF (NEDG.GT.MEDG) GO TO 902
            IEDG(3,I)=NEDG-1
            IEDG(4,I)=NEDG
            IEDG(1,NEDG-1)=IEDG(1,I)
            IEDG(2,NEDG-1)=NVTX
            IEDG(3,NEDG-1)=0
            IEDG(4,NEDG-1)=0
            IEDG(1,NEDG  )=NVTX
            IEDG(2,NEDG  )=IEDG(2,I)
            IEDG(3,NEDG  )=0
            IEDG(4,NEDG  )=0
  105     CONTINUE
C
C Modify the data values at each of the vertices of the new object.
C
          DO 106 I=1,NVTX
            VRTX(4,I)=VRTX(4,I)+RMUL*FRAN()
  106     CONTINUE
C
C Break each face from the last step into four new ones and add them
C back into the list.
C
          DO 107 I=LFCE(1,IELA-1),LFCE(2,IELA-1)
            IFCE(4,I)=NFCE+1
            NEDG=NEDG+3
            IF (NEDG.GT.MEDG) GO TO 902
            IEDG(1,NEDG-2)=IEDG(2,IEDG(3,IFCE(1,I)))
            IEDG(2,NEDG-2)=IEDG(2,IEDG(3,IFCE(2,I)))
            IEDG(3,NEDG-2)=0
            IEDG(4,NEDG-2)=0
            IEDG(1,NEDG-1)=IEDG(2,IEDG(3,IFCE(2,I)))
            IEDG(2,NEDG-1)=IEDG(2,IEDG(3,IFCE(3,I)))
            IEDG(3,NEDG-1)=0
            IEDG(4,NEDG-1)=0
            IEDG(1,NEDG  )=IEDG(2,IEDG(3,IFCE(3,I)))
            IEDG(2,NEDG  )=IEDG(2,IEDG(3,IFCE(1,I)))
            IEDG(3,NEDG  )=0
            IEDG(4,NEDG  )=0
            NFCE=NFCE+4
            IF (NFCE.GT.MFCE) GO TO 903
            IF (IEDG(1,IFCE(1,I)).EQ.IEDG(1,IFCE(2,I))) THEN
              IF (IEDG(2,IFCE(1,I)).EQ.IEDG(1,IFCE(3,I))) THEN
                IFCE(1,NFCE-3)=IEDG(3,IFCE(1,I))
                IFCE(2,NFCE-3)=IEDG(3,IFCE(2,I))
                IFCE(3,NFCE-3)=NEDG-2
                IFCE(4,NFCE-3)=0
                IFCE(1,NFCE-2)=IEDG(4,IFCE(2,I))
                IFCE(2,NFCE-2)=IEDG(4,IFCE(3,I))
                IFCE(3,NFCE-2)=NEDG-1
                IFCE(4,NFCE-2)=0
                IFCE(1,NFCE-1)=IEDG(3,IFCE(3,I))
                IFCE(2,NFCE-1)=IEDG(4,IFCE(1,I))
                IFCE(3,NFCE-1)=NEDG
                IFCE(4,NFCE-1)=0
              ELSE
                IFCE(1,NFCE-3)=IEDG(3,IFCE(1,I))
                IFCE(2,NFCE-3)=IEDG(3,IFCE(2,I))
                IFCE(3,NFCE-3)=NEDG-2
                IFCE(4,NFCE-3)=0
                IFCE(1,NFCE-2)=IEDG(3,IFCE(3,I))
                IFCE(2,NFCE-2)=IEDG(4,IFCE(2,I))
                IFCE(3,NFCE-2)=NEDG-1
                IFCE(4,NFCE-2)=0
                IFCE(1,NFCE-1)=IEDG(4,IFCE(1,I))
                IFCE(2,NFCE-1)=IEDG(4,IFCE(3,I))
                IFCE(3,NFCE-1)=NEDG
                IFCE(4,NFCE-1)=0
              END IF
            ELSE IF (IEDG(1,IFCE(1,I)).EQ.IEDG(2,IFCE(2,I))) THEN
              IF (IEDG(2,IFCE(1,I)).EQ.IEDG(1,IFCE(3,I))) THEN
                IFCE(1,NFCE-3)=IEDG(3,IFCE(1,I))
                IFCE(2,NFCE-3)=IEDG(4,IFCE(2,I))
                IFCE(3,NFCE-3)=NEDG-2
                IFCE(4,NFCE-3)=0
                IFCE(1,NFCE-2)=IEDG(3,IFCE(2,I))
                IFCE(2,NFCE-2)=IEDG(4,IFCE(3,I))
                IFCE(3,NFCE-2)=NEDG-1
                IFCE(4,NFCE-2)=0
                IFCE(1,NFCE-1)=IEDG(3,IFCE(3,I))
                IFCE(2,NFCE-1)=IEDG(4,IFCE(1,I))
                IFCE(3,NFCE-1)=NEDG
                IFCE(4,NFCE-1)=0
              ELSE
                IFCE(1,NFCE-3)=IEDG(3,IFCE(1,I))
                IFCE(2,NFCE-3)=IEDG(4,IFCE(2,I))
                IFCE(3,NFCE-3)=NEDG-2
                IFCE(4,NFCE-3)=0
                IFCE(1,NFCE-2)=IEDG(3,IFCE(2,I))
                IFCE(2,NFCE-2)=IEDG(3,IFCE(3,I))
                IFCE(3,NFCE-2)=NEDG-1
                IFCE(4,NFCE-2)=0
                IFCE(1,NFCE-1)=IEDG(4,IFCE(1,I))
                IFCE(2,NFCE-1)=IEDG(4,IFCE(3,I))
                IFCE(3,NFCE-1)=NEDG
                IFCE(4,NFCE-1)=0
              END IF
            ELSE IF (IEDG(1,IFCE(1,I)).EQ.IEDG(1,IFCE(3,I))) THEN
              IF (IEDG(2,IFCE(1,I)).EQ.IEDG(1,IFCE(2,I))) THEN
                IFCE(1,NFCE-3)=IEDG(3,IFCE(2,I))
                IFCE(2,NFCE-3)=IEDG(4,IFCE(1,I))
                IFCE(3,NFCE-3)=NEDG-2
                IFCE(4,NFCE-3)=0
                IFCE(1,NFCE-2)=IEDG(4,IFCE(2,I))
                IFCE(2,NFCE-2)=IEDG(4,IFCE(3,I))
                IFCE(3,NFCE-2)=NEDG-1
                IFCE(4,NFCE-2)=0
                IFCE(1,NFCE-1)=IEDG(3,IFCE(1,I))
                IFCE(2,NFCE-1)=IEDG(3,IFCE(3,I))
                IFCE(3,NFCE-1)=NEDG
                IFCE(4,NFCE-1)=0
              ELSE
                IFCE(1,NFCE-3)=IEDG(4,IFCE(1,I))
                IFCE(2,NFCE-3)=IEDG(4,IFCE(2,I))
                IFCE(3,NFCE-3)=NEDG-2
                IFCE(4,NFCE-3)=0
                IFCE(1,NFCE-2)=IEDG(3,IFCE(2,I))
                IFCE(2,NFCE-2)=IEDG(4,IFCE(3,I))
                IFCE(3,NFCE-2)=NEDG-1
                IFCE(4,NFCE-2)=0
                IFCE(1,NFCE-1)=IEDG(3,IFCE(1,I))
                IFCE(2,NFCE-1)=IEDG(3,IFCE(3,I))
                IFCE(3,NFCE-1)=NEDG
                IFCE(4,NFCE-1)=0
              END IF
            ELSE
              IF (IEDG(2,IFCE(1,I)).EQ.IEDG(1,IFCE(2,I))) THEN
                IFCE(1,NFCE-3)=IEDG(3,IFCE(2,I))
                IFCE(2,NFCE-3)=IEDG(4,IFCE(1,I))
                IFCE(3,NFCE-3)=NEDG-2
                IFCE(4,NFCE-3)=0
                IFCE(1,NFCE-2)=IEDG(3,IFCE(3,I))
                IFCE(2,NFCE-2)=IEDG(4,IFCE(2,I))
                IFCE(3,NFCE-2)=NEDG-1
                IFCE(4,NFCE-2)=0
                IFCE(1,NFCE-1)=IEDG(3,IFCE(1,I))
                IFCE(2,NFCE-1)=IEDG(4,IFCE(3,I))
                IFCE(3,NFCE-1)=NEDG
                IFCE(4,NFCE-1)=0
              ELSE
                IFCE(1,NFCE-3)=IEDG(4,IFCE(1,I))
                IFCE(2,NFCE-3)=IEDG(4,IFCE(2,I))
                IFCE(3,NFCE-3)=NEDG-2
                IFCE(4,NFCE-3)=0
                IFCE(1,NFCE-2)=IEDG(3,IFCE(2,I))
                IFCE(2,NFCE-2)=IEDG(3,IFCE(3,I))
                IFCE(3,NFCE-2)=NEDG-1
                IFCE(4,NFCE-2)=0
                IFCE(1,NFCE-1)=IEDG(3,IFCE(1,I))
                IFCE(2,NFCE-1)=IEDG(4,IFCE(3,I))
                IFCE(3,NFCE-1)=NEDG
                IFCE(4,NFCE-1)=0
              END IF
            END IF
            IFCE(1,NFCE  )=NEDG-2
            IFCE(2,NFCE  )=NEDG-1
            IFCE(3,NFCE  )=NEDG
            IFCE(4,NFCE  )=0
  107     CONTINUE
C
C Update pointers which will tell us what faces, edges, and vertices
C were added during this step.
C
          LFCE(2,IELA)=NFCE
          LEDG(2,IELA)=NEDG
          LVTX(2,IELA)=NVTX
C
C End of elaboration step.
C
  108   CONTINUE
C
C Copy the desired lowest and highest values to COMMON.
C
        RLOW=DLOW
        RHGH=DHGH
C
C Compute the minimum and maximum value in the data.
C
        RMIN=+1.E36
        RMAX=-1.E36
C
        DO 109 I=1,NVTX
          RMIN=MIN(RMIN,VRTX(4,I))
          RMAX=MAX(RMAX,VRTX(4,I))
  109   CONTINUE
C
C Done.
C
        RETURN
C
C Error exits.
C
  901   PRINT * , 'STOP - GGDINI - TOO MANY VERTICES'
        STOP
C
  902   PRINT * , 'STOP - GGDINI - TOO MANY EDGES'
        STOP
C
  903   PRINT * , 'STOP - GGDINI - TOO MANY FACES'
        STOP
C
      END


      FUNCTION GGDPNT (RLAT,RLON)
C
C Following is a copy of the PARAMETER statement from GGDINI.
C
        PARAMETER(NELA=6,MFCE=109220,MEDG=163830,MVTX=40962,NELP=NELA+1)
C
C Define the common block for the package.
C
        COMMON /GGDCMN/ NFCE,IFCE(4,MFCE),NEDG,IEDG(4,MEDG),
     +                  NVTX,VRTX(4,MVTX),
     +                  LFCE(2,NELP),LEDG(2,NELP),LVTX(2,NELP),
     +                  RLOW,RHGH,RMIN,RMAX
        SAVE   /GGDCMN/
C
C Define constants for converting from degrees to radians and back.
C
        DATA DTOR / .017453292519943 /
        DATA RTOD / 57.2957795130823 /
C
C Compute the position of the point on the surface of the unit sphere.
C
        X0=COS(DTOR*RLAT)*COS(DTOR*RLON)
        Y0=COS(DTOR*RLAT)*SIN(DTOR*RLON)
        Z0=SIN(DTOR*RLAT)
C
C Find out what face that point falls above.
C
        IFST=1
        NUMB=20
        ITRY=1
C
  101   CONTINUE
          IPOS=IFST
  102     CONTINUE
            X1=VRTX(1,IEDG(1,IFCE(1,IPOS)))
            Y1=VRTX(2,IEDG(1,IFCE(1,IPOS)))
            Z1=VRTX(3,IEDG(1,IFCE(1,IPOS)))
            W1=VRTX(4,IEDG(1,IFCE(1,IPOS)))
            X2=VRTX(1,IEDG(2,IFCE(1,IPOS)))
            Y2=VRTX(2,IEDG(2,IFCE(1,IPOS)))
            Z2=VRTX(3,IEDG(2,IFCE(1,IPOS)))
            W2=VRTX(4,IEDG(2,IFCE(1,IPOS)))
            IF (IEDG(1,IFCE(2,IPOS)).NE.IEDG(1,IFCE(1,IPOS)).AND.
     +          IEDG(1,IFCE(2,IPOS)).NE.IEDG(2,IFCE(1,IPOS))) THEN
              X3=VRTX(1,IEDG(1,IFCE(2,IPOS)))
              Y3=VRTX(2,IEDG(1,IFCE(2,IPOS)))
              Z3=VRTX(3,IEDG(1,IFCE(2,IPOS)))
              W3=VRTX(4,IEDG(1,IFCE(2,IPOS)))
            ELSE
              X3=VRTX(1,IEDG(2,IFCE(2,IPOS)))
              Y3=VRTX(2,IEDG(2,IFCE(2,IPOS)))
              Z3=VRTX(3,IEDG(2,IFCE(2,IPOS)))
              W3=VRTX(4,IEDG(2,IFCE(2,IPOS)))
            END IF
            A1=Y3*Z2-Y2*Z3
            B1=X2*Z3-X3*Z2
            C1=X3*Y2-X2*Y3
            A2=Y1*Z3-Y3*Z1
            B2=X3*Z1-X1*Z3
            C2=X1*Y3-X3*Y1
            A3=Y2*Z1-Y1*Z2
            B3=X1*Z2-X2*Z1
            C3=X2*Y1-X1*Y2
            IF (ITRY.EQ.1) THEN
              XM=(X1+X2+X3)/3.
              YM=(Y1+Y2+Y3)/3.
              ZM=(Z1+Z2+Z3)/3.
              S1=SIGN(1.,A1*XM+B1*YM+C1*ZM)
              S2=SIGN(1.,A2*XM+B2*YM+C2*ZM)
              S3=SIGN(1.,A3*XM+B3*YM+C3*ZM)
              T1=SIGN(1.,A1*X0+B1*Y0+C1*Z0)
              T2=SIGN(1.,A2*X0+B2*Y0+C2*Z0)
              T3=SIGN(1.,A3*X0+B3*Y0+C3*Z0)
              IF (S1.EQ.T1.AND.S2.EQ.T2.AND.S3.EQ.T3) GO TO 103
            ELSE
              T1=2.*((X0-X2)*(X3-X2)+(Y0-Y2)*(Y3-Y2)+(Z0-Z2)*(Z3-Z2))/
     +              ((X3-X2)*(X3-X2)+(Y3-Y2)*(Y3-Y2)+(Z3-Z2)*(Z3-Z2))
              T1=MAX(0.,MIN(1.,T1))
              D1=(X2-X0+(X3-X2)*T1)**2+(Y2-Y0+(Y3-Y2)*T1)**2+
     +                                 (Z2-Z0+(Z3-Z2)*T1)**2
              T2=2.*((X0-X3)*(X1-X3)+(Y0-Y3)*(Y1-Y3)+(Z0-Z3)*(Z1-Z3))/
     +              ((X1-X3)*(X1-X3)+(Y1-Y3)*(Y1-Y3)+(Z1-Z3)*(Z1-Z3))
              T2=MAX(0.,MIN(1.,T2))
              D2=(X3-X0+(X1-X3)*T2)**2+(Y3-Y0+(Y1-Y3)*T2)**2+
     +                                 (Z3-Z0+(Z1-Z3)*T2)**2
              T3=2.*((X0-X1)*(X2-X1)+(Y0-Y1)*(Y2-Y1)+(Z0-Z1)*(Z2-Z1))/
     +              ((X2-X1)*(X2-X1)+(Y2-Y1)*(Y2-Y1)+(Z2-Z1)*(Z2-Z1))
              T3=MAX(0.,MIN(1.,T3))
              D3=(X1-X0+(X2-X1)*T3)**2+(Y1-Y0+(Y2-Y1)*T3)**2+
     +                                 (Z1-Z0+(Z2-Z1)*T3)**2
              DIST=MIN(D1,D2,D3)
              IF (IBST.EQ.0.OR.DIST.LT.DBST) THEN
                IBST=IPOS
                DBST=DIST
              END IF
            END IF
            IF (IPOS.EQ.IFST+NUMB-1) THEN
              IF (ITRY.EQ.1) THEN
                IPOS=IFST-1
                ITRY=2
                IBST=0
                DBST=0.
              ELSE
                IPOS=IBST
                X1=VRTX(1,IEDG(1,IFCE(1,IPOS)))
                Y1=VRTX(2,IEDG(1,IFCE(1,IPOS)))
                Z1=VRTX(3,IEDG(1,IFCE(1,IPOS)))
                W1=VRTX(4,IEDG(1,IFCE(1,IPOS)))
                X2=VRTX(1,IEDG(2,IFCE(1,IPOS)))
                Y2=VRTX(2,IEDG(2,IFCE(1,IPOS)))
                Z2=VRTX(3,IEDG(2,IFCE(1,IPOS)))
                W2=VRTX(4,IEDG(2,IFCE(1,IPOS)))
                IF (IEDG(1,IFCE(2,IPOS)).NE.IEDG(1,IFCE(1,IPOS)).AND.
     +              IEDG(1,IFCE(2,IPOS)).NE.IEDG(2,IFCE(1,IPOS))) THEN
                  X3=VRTX(1,IEDG(1,IFCE(2,IPOS)))
                  Y3=VRTX(2,IEDG(1,IFCE(2,IPOS)))
                  Z3=VRTX(3,IEDG(1,IFCE(2,IPOS)))
                  W3=VRTX(4,IEDG(1,IFCE(2,IPOS)))
                ELSE
                  X3=VRTX(1,IEDG(2,IFCE(2,IPOS)))
                  Y3=VRTX(2,IEDG(2,IFCE(2,IPOS)))
                  Z3=VRTX(3,IEDG(2,IFCE(2,IPOS)))
                  W3=VRTX(4,IEDG(2,IFCE(2,IPOS)))
                END IF
                GO TO 103
              END IF
            END IF
            IPOS=IPOS+1
          GO TO 102
  103     CONTINUE
          IFST=IFCE(4,IPOS)
          NUMB=4
          ITRY=1
        IF (IFST.NE.0) GO TO 101
C
C Compute a data value at the point.
C
        IF ((X1-X0)**2+(Y1-Y0)**2+(Z1-Z0)**2.LT..000001) THEN
          RVAL=W1
        ELSE
          AP=Y1*(Z3-Z2)+Y2*(Z1-Z3)+Y3*(Z2-Z1)
          BP=X1*(Z2-Z3)+X2*(Z3-Z1)+X3*(Z1-Z2)
          CP=X1*(Y3-Y2)+X2*(Y1-Y3)+X3*(Y2-Y1)
          DP=X1*Y2*Z3-X1*Y3*Z2-X2*Y1*Z3+X3*Y1*Z2+X2*Y3*Z1-X3*Y2*Z1
          TP=-DP/(AP*X0+BP*Y0+CP*Z0)
          X4=TP*X0
          Y4=TP*Y0
          Z4=TP*Z0
          A1=Y3*Z2-Y2*Z3
          B1=X2*Z3-X3*Z2
          C1=X3*Y2-X2*Y3
          TP=-(A1*X1+B1*Y1+C1*Z1)/(A1*(X4-X1)+B1*(Y4-Y1)+C1*(Z4-Z1))
          X5=X1+TP*(X4-X1)
          Y5=Y1+TP*(Y4-Y1)
          Z5=Z1+TP*(Z4-Z1)
          W5=W2+(W3-W2)*SQRT(((X5-X2)**2+(Y5-Y2)**2+(Z5-Z2)**2)/
     +                       ((X3-X2)**2+(Y3-Y2)**2+(Z3-Z2)**2))
          RVAL=W1+(W5-W1)*SQRT(((X4-X1)**2+(Y4-Y1)**2+(Z4-Z1)**2)/
     +                         ((X5-X1)**2+(Y5-Y1)**2+(Z5-Z1)**2))
        END IF
C
C Adjust the value to the desired range.
C
        GGDPNT=RLOW+(RHGH-RLOW)*(RVAL-RMIN)/(RMAX-RMIN)
C
C Done.
C
        RETURN
C
      END


      FUNCTION FRAN ()
C
C Pseudo-random-number generator.
C
        DOUBLE PRECISION X
        SAVE X
C
        DATA X / 2.718281828459045D0 /
C
        X=MOD(9821.D0*X+.211327D0,1.D0)
        FRAN=REAL(X)
C
        RETURN
C
      END


      SUBROUTINE CTSCAE (ICRA,ICA1,ICAM,ICAN,XCPF,YCPF,XCQF,YCQF,
     +                                       IND1,IND2,ICAF,IAID)
        DIMENSION ICRA(ICA1,*)
C
C This routine is called by CTCICA when the internal parameter 'CAF' is
C given a negative value.  Each call is intended to create a particular
C element in the user's cell array.  The arguments are as follows:
C
C ICRA is the user's cell array.
C
C ICA1 is the first dimension of the FORTRAN array ICRA.
C
C ICAM and ICAN are the first and second dimensions of the cell array
C stored in ICRA.
C
C (XCPF,YCPF) is the point at that corner of the rectangular area
C into which the cell array maps that corresponds to the cell (1,1).
C The coordinates are given in the fractional coordinate system (unlike
C what is required in a call to GCA, in which the coordinates of the
C point P are in the world coordinate system).
C
C (XCQF,YCQF) is the point at that corner of the rectangular area into
C which the cell array maps that corresponds to the cell (ICAM,ICAN).
C The coordinates are given in the fractional coordinate system (unlike
C what is required in a call to GCA, in which the coordinates of the
C point Q are in the world coordinate system).
C
C IND1 is the 1st index of the cell that is to be updated.
C
C IND2 is the 2nd index of the cell that is to be updated.
C
C ICAF is the current value of the internal parameter 'CAF'.  This
C value will always be an integer which is less than zero (because
C when 'CAF' is zero or greater, this routine is not called).
C
C IAID is the area identifier associated with the cell.  It will have
C been given one of the values from the internal parameter array 'AIA'
C (the one for 'PAI' = -2 if the cell lies in an out-of-range area, the
C one for 'PAI' = -1 if the cell lies off the data grid, or the one for
C some value of 'PAI' between 1 and 'NCL' if the cell lies on the data
C grid).  The value zero may occur if the cell falls in an out-of-range
C area and the value of 'AIA' for 'PAI' = -2 is 0 or if the cell lies
C off the data grid and the value of 'AIA' for 'PAI' = -1 is 0, or if
C the cell falls on the data grid, but no contour level below the cell
C has a non-zero 'AIA' and no contour level above the cell has a
C non-zero 'AIB'.  Note that, if the values of 'AIA' for 'PAI' = -1
C and -2 are given non-zero values, IAID can only be given a zero
C value in one way.
C
C The default behavior of CTSCAE is as follows:  If the area identifier
C is non-negative, it is treated as a color index, to be stored in the
C appropriate cell in the cell array; but if the area identifier is
C negative, a zero is stored for the color index.  The user may supply
C a version of CTSCAE that does something different; it may simply map
C the area identifiers into color indices or it may somehow modify the
C existing cell array element to incorporate the information provided
C by the area identifier.
C
C       ICRA(IND1,IND2)=MAX(0,IAID)
C
C What follows is not the default behavior; instead, it is the behavior
C expected by many of the example programs for CONPACKT.
C
        CALL CTGETI ('NCL - NUMBER OF CONTOUR LEVELS',NOCL)
C
        IF (IAID.GE.1.AND.IAID.LE.NOCL+1) THEN
          ICRA(IND1,IND2)=151+INT(((REAL(IAID)-.5)/REAL(NOCL+1))*100.)
        ELSE IF (IAID.EQ.1001) THEN
          ICRA(IND1,IND2)=2
        ELSE IF (IAID.EQ.1002) THEN
          ICRA(IND1,IND2)=3
        END IF
C
        RETURN
C
      END

C
C File:   argb2ci.f
C Author: brownrig
C
C Given a color index, returns:
C   i)  index of closest color in color table if index is an argb value
C   ii) the given index
C
C Created on January 11, 2012, 9:27 AM
C

      integer function argb2ci(index)
      implicit none
      include 'g01wsl.h'

      integer index, nearest
      integer i
      integer ARGBMASK, RMASK, GMASK, BMASK
      parameter (ARGBMASK = Z'40000000')
      parameter (RMASK     = Z'00FF0000')
      parameter (GMASK     = Z'0000FF00')
      parameter (BMASK     = Z'000000FF')
      real r, g, b, dist, mindist

      if (iand(index, ARGBMASK).eq.0) then
          argb2ci = index
          return
      end if

C     find the closest match, based upon distance in color space
      mindist = 2e31
      nearest = 0
      do i=1,mol
          r = (iand(index, RMASK) / Z'0000FFFF') / 255.
          g = (iand(index, GMASK) / Z'000000FF') / 255.
          b = (iand(index, BMASK))               / 255.

C         we don't need absolute distance, so forego the sqrt operation...
          dist = (r-sred(i))**2 + (g-sgreen(i))**2 + (b-sblue(i))**2
          if (dist .lt. mindist) then
              mindist = dist
              nearest = mcoli(i)
          end if
      end do

      argb2ci = nearest
      return
      end

C
C	$Id: gtx.f,v 1.9 2008-07-27 00:21:03 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GTX(PX,PY,CHARS)
C
C  TEXT
C
      INTEGER ETX
      PARAMETER (ETX=14)
C
      include 'gkscom.h'
C
      REAL PX,PY
      CHARACTER*(*) CHARS
C
C  Check if GKS is in the proper state.
C
      CALL GZCKST(5,ETX,IER)
      IF (IER .NE. 0) RETURN
C
C  Transform the position coordinates to NDC space and set up
C  the real arrays in the workstation interface common block.
C
      CALL GZROI(0)
C
      RL1 = 1
      RL2 = 1
      CALL GZW2NX(1,PX,PXN)
      RX(1) = PXN
      CALL GZW2NY(1,PY,PYN)
      RY(1) = PYN
C
C  Set the function code and put out the character arrays across the
C  workstation interface.  The continuation flag signals
C  continuation of the character array, the position coordinates
C  are picked up on the first invocation of the workstation
C  interface.
C
      FCODE = 13
      CALL GZPUTS(CHARS,IER)
      RERR = IER
      IF (RERR .NE. 0) THEN
        ERS = 1
        CALL GERHND(RERR,ETX,ERF)
        ERS = 0
      ENDIF
C
      RETURN
      END

C NCLFORTSTART
      SUBROUTINE TDRVPRC(X,NROW,NCOL,NROBS,NCSTA,XMSG,NEVAL,EVAL,EVEC,
     +                   PCVAR,TRACE,IOPT,JOPT,PCRIT,IER,XDATA,XDATAT)
      IMPLICIT NONE

c this operates on the TRANSPOSE of the array "x"
c .   It results in [sometimes, MUCH] faster execution
c Note for NCL: in *this* routine NROBS=NROW, NCSTA=NCOL

      INTEGER          NROW,NCOL,NROBS,NCSTA,NEVAL,IOPT,JOPT,IER
      DOUBLE PRECISION X(NROW,NCOL),EVAL(NEVAL),EVEC(NCOL,NEVAL),
     +                 PCVAR(NEVAL),TRACE,XMSG,PCRIT,XDATA(NROW,NCOL),
     +                 XDATAT(NCSTA,NROW)
C NCLEND

c======== .so info=====================
c SGI/dataproc: WRAPIT -L /usr/lib64 -l complib.sgimath_mp prneofTranspose.f
c Sun/CGD: WRAPIT -L /opt/SUNWspro/lib -l sunmath -l fsu -l fui -lsunperf prneofTranspose.f
c======================================
     

c AUTOMATIC FORTRAN ARRAYS TO HOLD DATA AND DATA STATS
      DOUBLE PRECISION XAVE(NCOL), XVAR(NCOL), XDVAR(NCOL)
               

C LOCAL VARIABLES
      DOUBLE PRECISION PCX, CON, XSD
      INTEGER          KNTX,KER,NR,NC,MCSTA


c strip all grid points that have less that "PCRIT" valid values
c .   create the "XDATA". This may have fewer columns/grid-pts
c .   than the original "X" array if not all columns 
c .   had the minimun number of valid values.

      MCSTA = 0
      DO NC = 1,NCOL

c statistics for this station/grid-point

          CALL DSTAT2(X(1,NC),NROW,XMSG,XAVE(NC),XVAR(NC),XSD,KNTX,KER)

c quick way of eliminating stations/grid-points

          PCX = (DBLE(KNTX)/DBLE(NROW))*100.D0
          IF (PCX.LT.PCRIT .OR. XSD.LE.0.0D0) THEN
              XAVE(NC) = XMSG
          END IF

c possible normalizing for jopt=1

          CON = 1.0D0
          IF (JOPT.EQ.1 .AND. XAVE(NC).NE.XMSG 
     +                  .AND. XSD.GT.0.D0) CON = 1.D0/XSD

c WORK WITH ANOMALIES: XDAVE=0.0 [or standardized anomalies]

          IF (XAVE(NC).NE.XMSG) THEN
              MCSTA = MCSTA + 1

              DO NR = 1,NROW
                  IF (X(NR,NC).NE.XMSG) THEN
                      XDATA(NR,MCSTA) = (X(NR,NC)-XAVE(NC))*CON
c c c                 XDATA(NR,MCSTA) =  X(NR,NC)
                  ELSE
                      XDATA(NR,MCSTA) = XMSG
                  END IF
              END DO

              IF (JOPT.EQ.0) THEN
                  XDVAR(MCSTA) = XVAR(NC)
              ELSE
                  XDVAR(MCSTA) = 1.0D0
              END IF
          END IF

      END DO

c pass the selected data (XDATA) to the EOF driver 

      CALL XRVEOFT(XDATA,XDATAT,NROW,NCOL,NROBS,MCSTA,XMSG,
     +             NEVAL,EVAL,EVEC,PCVAR,TRACE,
     +             XDVAR,XAVE,JOPT,IER)

      RETURN
      END

c ---------------------------------------------------------
      SUBROUTINE XRVEOFT(XDATA,XDATAT,NROW,NCOL,NROBS,NCSTA,
     +                   XMSG,NEVAL,EVAL,EVEC,PCVAR,TRACE,
     +                   XDVAR,XAVE,JOPT,IER)
      IMPLICIT NONE

C **** USES AUTOMATIC ARRAYS SO USE WITH g77 or f90 

c operate on the *TRANSPOSE* OF XDATA: then use matrix stuff to
c .   get the desired eof information.

c Note: NROW=NROBS but, it is possible for  MCSTA<=NCOL
c .                     when some stations/grid_pts do not have enough data

c driver to calculate :
c .   the principal components (eignvalues and eigenvectors)
c .       of the data array XDATA. XDATA may contain
c .       missing observations. If it has msg data, this will
c .       calculate a var-cov matrix but it may not be
c .       positive definite.

c . The eigenvectors and eigenvalues of the *TRANSPOSED* matrix
c .      are used to derive the corresponding eigenvectors
c .      associated with the original matrix.

c .       USES LAPACK/BLAS ROUTINES

c nomenclature :
c .   xdata     - matrix containing the data. it contains n observations
c .               for each of m stations or grid pts.
c .   nrow,ncol - exact row (observation) and column (station) 
c .               dimensions of xdata in the calling routine.
c .   nrobs     - actual number of observations (nrobs <= nrow)
c .   ncsta     - actual number of stations     (ncsta <= ncol)
c .   xmsg      - missing code (if no obs are missing set to some
c .               number which will not be encountered)
c .   neval     - no. of eigenvalues and eigenvectors to be computed.
c .               neval <= min(nrobs,ncsta). 
c .               If not, ncsta eigenvalues and eigenvectors
c .               will be computed and ier = -2.
c .   eval      - vector containing the eigenvalues in DESCENDING order.
c .               eval must be at least neval in length.
c .   evec      - an array which will contains the eigenvector info.
c .               this must be dimensioned at least (ncol,neval) in the
c .               calling routine. There is some normalization done
c .               but I am not sure waht it is.
c .   pcvar     - contains % variance associated with each eigenvalue.
c .               This must be dimensioned at least neval in length.
c .   trace     - trace of the variance - covariance matrix.in the
c .               case of a var-covar matrix , the trace should
c .               equal the sum of all possible eigenvalues.
c .   iopt      - not used; kept for compatibility with old routine
c .   jopt      - =  0 : use var-covar matrix in prncmp
c .                  1 : use correlation matrix in prncmp
c .   ier       - error code

      INTEGER          NROW,NCOL,NROBS,NCSTA,NEVAL,
     +                 LSSM,LWORK,LIWORK,JOPT,IER

      DOUBLE PRECISION XDATA(NROW,NCOL),PCVAR(NEVAL),XMSG,TRACE,
     +                 EVAL(NEVAL), EVEC(NCOL,NEVAL),
     +                 XDATAT(NCSTA,NROW)

c temporary arrays (automatic or passed in via interface)

      DOUBLE PRECISION CSSM(NROW*(NROW+1)/2),
     *                 WORK(8*NROW)
      INTEGER          IWORK(5*NROW)

      DOUBLE PRECISION TEOFPC(NROW,NEVAL),
     +                 WEVAL(NROW),WEVEC(NCSTA,NEVAL),
     +                 W2D(NROW,NEVAL), XAVE(NCOL),XDVAR(NCOL)
      INTEGER          IFAIL(NROBS)

c local
      CHARACTER*16     LABEL
      DOUBLE PRECISION TEMP,TOL,EPSMACH,VLOW,VUP
      INTEGER          N,NE,NR,NC,MEVAL,IPR,IPRFLG,
     +                 MEVOUT,ILOW,IUP,INFO,MCSTA

      DATA IPR/6/
      DATA IPRFLG/0/

c length of various temporary arrays

      LSSM   = NROW* (NROW+1)/2
      LWORK  = 8*NROW
      LIWORK = 5*NROW

c EXPLICITLY INITALIZE

      DO NR = 1,NROW
          WEVAL(NR) = XMSG
      END DO

      DO NE = 1,NEVAL
          EVAL(NE) = XMSG

          DO NC = 1,NCOL
              EVEC(NC,NE)  = XMSG
          END DO

          DO NC = 1,NCSTA 
              WEVEC(NC,NE) = XMSG
          END DO 

          DO NR = 1,NROW 
              W2D(NR,NE)  = XMSG
              TEOFPC(NR,NE) = XMSG
          END DO
      END DO

c create transposed data array

      DO NC=1,NCSTA
          DO NR=1,NROW
              XDATAT(NC,NR) = XDATA(NR,NC)
          END DO
      END DO

c compute the covariance matrix using the transposed data 

      CALL DVCMSSM(XDATAT,NCSTA,NROW,NCSTA,NROW,XMSG,CSSM,LSSM,IER)

      IF (IER.NE.0) THEN
          WRITE (IPR,FMT='(//'' sub drveoft: ier= '',i3
     +   ,'' returned from vcmssm/crmssm'')') IER
          IF (IER.GT.0) RETURN
      END IF

c activate if print of cov/cor matrix [work] is desired

      IF (IPRFLG.EQ.2) THEN
          IF (JOPT.EQ.0) THEN
              LABEL(1:15) = 'DRVEOFT: covar matrix:  '
          ELSE
              LABEL(1:15) = 'DRVEOFT: correl matrix: '
          END IF
          WRITE (IPR,"(//,a15,'sym storage mode')") LABEL(1:15)
          CALL DSSMIOX(CSSM,NROW)
      END IF

c calculate the trace of transposed matrix (TRACE)
c before matrix is destroyed by sspevx

      N = 0
      TRACE = 0.d0
      DO NR = 1,NROW
          N = N + NR
          TRACE = TRACE + CSSM(N)
      END DO
      IF (TRACE.LE.0.d0) THEN
          IER = -88
          WRITE (IPR,FMT='(//'' SUB DRVEOFT: ier,jopt= '',2i3
     +           ,'' trace='',f15.5)') IER,JOPT,TRACE
          RETURN
      END IF


c calculate specified number of eigenvalues and eigenvectors.
c .   make sure that  neval <= nrow (=nrobs)
c
c .   Remember the TEOFPC are the eofs of the *transposed* matrix.
c .   This means they are the principal components of the original data. 

      MEVAL = MIN(NEVAL,NROW)

      TOL   = 10.D0*EPSMACH(IPR)
      VLOW  = 0.0D0
      VUP   = 0.0D0
      ILOW  = MAX(NROBS-MEVAL+1,1)
      IUP   = NROBS
      MEVOUT = 0

      CALL DSPEVX('V','I','U',NROW,CSSM,VLOW,VUP,ILOW,IUP,TOL,MEVOUT,
     +            WEVAL,TEOFPC,NROW,WORK,IWORK,IFAIL,INFO)

      IF (INFO.NE.0) THEN
          IER = IER + INFO
          WRITE (IPR,FMT='(//,'' SUB DRVEOFT: sspevx error: info=''
     +                       ,   i9)') INFO
          WRITE (IPR,FMT='(   '' SUB DRVEOFT: sspevx error: ifail=''
     +      ,   20i5)') (IFAIL(N),N=1,MIN(20,NROBS))
      END IF

c reorder so eigenvalues are in descending order
c .   make sure the asocciated eigenvectors are also reordered

      DO N = 1,MEVAL
          WORK(N) = WEVAL(N)
      END DO

      DO N = 1,MEVAL
          WEVAL(N) = WORK(MEVAL+1-N)
      END DO

      DO N = 1,MEVAL
          DO NR = 1,NROW
              W2D(NR,N) = TEOFPC(NR,N)
          END DO
      END DO

      DO N = 1,MEVAL
          DO NR = 1,NROW
              TEOFPC(NR,N) = W2D(NR,MEVAL+1-N)
          END DO
      END DO

c percent variance explained (PCVAR) of transposed matrix.
c .   Both the eigenvalues (hence, PCVAR) are equivalent
c .   due to "duality" od space/time.

      DO N = 1,MEVAL
          PCVAR(N) = (WEVAL(N)/TRACE)*100.D0
      END DO

c ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
c section to invert from transposed data space to original data space.
c ie: compute the eigenvectors of the original data
c ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

c calculate the SPATIAL eofs from the TEOFPC and XDATAT

      DO N = 1,MEVAL
          DO NC = 1,NCSTA
              WEVEC(NC,N) = 0.0d0

              DO NR = 1,NROW
                  IF (XDATAT(NC,NR).NE.XMSG) THEN
                      WEVEC(NC,N) = WEVEC(NC,N) 
     +                            + TEOFPC(NR,N)*XDATAT(NC,NR)
                  END IF
              END DO

          END DO
      END DO

c normalize spatial eofs to variance=1.0
c normalize the time series [principal components] 

      DO N = 1,MEVAL

          TEMP  = 0.0d0
          DO NC = 1,NCSTA
              TEMP = TEMP + WEVEC(NC,N)*WEVEC(NC,N)
          END DO
          TEMP = DSQRT(TEMP)

          DO NC = 1,NCSTA
              WEVEC(NC,N) = WEVEC(NC,N)/TEMP
          END DO

      END DO

c return only the requested number of eigenvalues

      DO N = 1,NEVAL
          EVAL(N) = WEVAL(N)
          DO NC = 1,NCOL
              EVEC(NC,N) = XMSG
          END DO
      END DO

c return the requested eigenvector
c .   the purpose of the "if" is to reassign to correct locations

      MCSTA = 0
      DO NC = 1,NCOL
          IF (XAVE(NC).NE.XMSG) THEN
              MCSTA = MCSTA + 1
              DO N = 1,NEVAL
                  EVEC(NC,N) = WEVEC(MCSTA,N)
              END DO
          END IF
      END DO

      RETURN
      END

C
C $Id: dpsetr.f,v 1.7 2008-07-27 00:16:59 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE DPSETR (PNAM,RVAL)
C
C This routine, given a real value, sets the value of an internal
C parameter of type INTEGER or REAL to that value.
C
        CHARACTER*(*) PNAM
C
C Declare the real/integer common block.
C
        COMMON /DPCMRI/ ANGF,DBPI,EPSI,IDPI,IDPS,ILTL,INDP,IPCF,ISBF,
     +                  ISCF,LCDP,RLS1,RLS2,RMFS,TENS,WCHR,WGAP,WSLD
        SAVE   /DPCMRI/
C
C Declare a temporary variable in which to form error messages.
C
        CHARACTER*39 CTMP
C
C Do a call forcing a BLOCKDATA to be loaded from a binary library.
C
        CALL DPBLDA
C
C Check for an uncleared prior error.
C
        IF (ICFELL('DPSETR - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C Because most changes in internal parameters of DASHPACK result in
C changing the way in which the current dash pattern is interpreted,
C force a buffer dump before changing anything and ensure that, the
C next time DPDRAW is called, the dash pattern element descriptors
C will be regenerated.
C
        CALL DPSMTH (0.,0.,2)
        IF (ICFELL('DPSETR',2).NE.0) RETURN
C
        IDPI=0
C
C Change the specified parameter or log an error.
C
        IF (LEN(PNAM).LT.3) THEN
          CTMP='DPSETR - PARAMETER NAME TOO SHORT - '//PNAM
          CALL SETER (CTMP(1:38),3,1)
          RETURN
        ELSE IF (PNAM(1:3).EQ.'DPL'.OR.PNAM(1:3).EQ.'dpl') THEN
          LCDP=MAX(1,MIN(256,INT(RVAL)))
        ELSE IF (PNAM(1:3).EQ.'DPS'.OR.PNAM(1:3).EQ.'dps') THEN
          IDPS=MAX(-32,MIN(256,INT(RVAL)))
        ELSE IF (PNAM(1:3).EQ.'DPT'.OR.PNAM(1:3).EQ.'dpt') THEN
          INDP=INT(RVAL)
        ELSE IF (PNAM(1:3).EQ.'EPS'.OR.PNAM(1:3).EQ.'eps') THEN
          EPSI=MAX(0.,RVAL)
        ELSE IF (PNAM(1:3).EQ.'LS1'.OR.PNAM(1:3).EQ.'ls1') THEN
          RLS1=MAX(0.,MIN(10.,RVAL))
        ELSE IF (PNAM(1:3).EQ.'LS2'.OR.PNAM(1:3).EQ.'ls2') THEN
          RLS2=MAX(0.,MIN(10.,RVAL))
        ELSE IF (PNAM(1:3).EQ.'LTL'.OR.PNAM(1:3).EQ.'ltl') THEN
          ILTL=MAX(0,MIN(1,INT(RVAL)))
        ELSE IF (PNAM(1:3).EQ.'MFS'.OR.PNAM(1:3).EQ.'mfs') THEN
          RMFS=MAX(0.,RVAL)
        ELSE IF (PNAM(1:3).EQ.'PCF'.OR.PNAM(1:3).EQ.'pcf') THEN
          IPCF=MAX(0,MIN(2,INT(RVAL)))
        ELSE IF (PNAM(1:3).EQ.'SAF'.OR.PNAM(1:3).EQ.'saf') THEN
          ANGF=MAX(-360.,MIN(360.,RVAL))
        ELSE IF (PNAM(1:3).EQ.'SBF'.OR.PNAM(1:3).EQ.'sbf') THEN
          ISBF=MAX(0,MIN(1,INT(RVAL)))
        ELSE IF (PNAM(1:3).EQ.'SCF'.OR.PNAM(1:3).EQ.'scf') THEN
          ISCF=MAX(0,MIN(1,INT(RVAL)))
        ELSE IF (PNAM(1:3).EQ.'SSL'.OR.PNAM(1:3).EQ.'ssl') THEN
          DBPI=MAX(.000001,MIN(1.,RVAL))
        ELSE IF (PNAM(1:3).EQ.'TCS'.OR.PNAM(1:3).EQ.'tcs') THEN
          TENS=RVAL
        ELSE IF (PNAM(1:3).EQ.'WOC'.OR.PNAM(1:3).EQ.'woc') THEN
          WCHR=MAX(.000001,MIN(1.,RVAL))
        ELSE IF (PNAM(1:3).EQ.'WOG'.OR.PNAM(1:3).EQ.'wog') THEN
          WGAP=MAX(.000001,MIN(1.,RVAL))
        ELSE IF (PNAM(1:3).EQ.'WOS'.OR.PNAM(1:3).EQ.'wos') THEN
          WSLD=MAX(.000001,MIN(1.,RVAL))
        ELSE
          CTMP='DPSETR - PARAMETER NAME NOT KNOWN - '//PNAM
          CALL SETER (CTMP(1:39),4,1)
          RETURN
        END IF
C
C Done.
C
        RETURN
C
      END

C
C	$Id: gqpx.f,v 1.5 2008-07-27 00:21:00 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GQPX(WKID,PX,PY,ERRIND,COLI)
C
C  INQUIRE PIXEL
C
      include 'gkscom.h'
C
      INTEGER WKID,ERRIND,COLI
      REAL    PX,PY
C
C  Check if GKS is in the proper state.
C
      CALL GZCKST(7,-1,ERRIND)
      IF (ERRIND .NE. 0) GOTO 100
C
C  Check that the workstation identifier is valid.
C
      CALL GZCKWK(20,-1,WKID,IDUM,ERRIND)
      IF (ERRIND .NE. 0) GO TO 100
C
C  Check that the workstation is open.
C
      CALL GZCKWK(25,-1,WKID,IDUM,ERRIND)
      IF (ERRIND .NE. 0) GO TO 100
C
C  Check for invalid workstation categories.
C
      CALL GQWKC(WKID,ERRIND,ICONID,ITYPE)
      IF (ERRIND .NE. 0) GO TO 100
      CALL GQWKCA(ITYPE,ERRIND,ICAT)
      IF (ICAT.NE.GOUTPT .AND. ICAT.NE.GOUTIN) THEN
        ERRIND = 39
        GO TO 100
      ENDIF
C
C  Invoke interface.
C
      FCODE = -290
      CONT  = 0
      CALL GZROI(0)
      IL1   = 1
      IL2   = 1
      RL1   = 2
      RL2   = 2
      ID(1) = WKID
      CALL GZW2NX(1,PX,PXD)
      CALL GZW2NY(1,PY,PYD)
      RX(1) = PXD
      RX(2) = PYD
      CALL GZIQWK(ITYPE,WKID)
      IF (RERR.NE.0) THEN
        ERRIND = RERR
        GOTO 100
      ENDIF
      COLI   = ID(2)
      RETURN
C
  100 CONTINUE
      COLI   = -1
      RETURN
      END

C
C       $Id: vvhluint.f,v 1.12 2008-07-27 00:17:35 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
C This module contains interface routines for VectorPlot and VecAnno
C
      SUBROUTINE VVGETARROWBOUND (ARS,XB,YB,XE,YE,VLN,XMN,YMN,XMX,YMX)
C
C Given the beginning and end points of a vector arrow and the vector
C length, returns the bounding box as the minimum and maximum x and y 
C values. ARS is an array of values necessary to put Vectors into the
C proper state to perform the calculations correctly.
C 
      REAL ARS(26)
C
C ---------------------------------------------------------------------
C
C NOTE:
C Since implicit typing is used for all real and integer variables
C a consistent length convention has been adopted to help clarify the
C significance of the variables encountered in the code for this 
C utility. All local variable and subroutine parameter identifiers 
C are limited to 1,2,or 3 characters. Four character names identify  
C members of common blocks. Five and 6 character variable names 
C denote PARAMETER constants or subroutine or function names.
C
C Declare the VV common blocks.
C
C IPLVLS - Maximum number of color threshold level values
C IPAGMX - Maximum number of area groups allowed in the area map
C
      PARAMETER (IPLVLS = 256, IPAGMX = 64)
C
C Integer and real common block variables
C
C
      COMMON /VVCOM/
     +                IUD1       ,IVD1       ,IPD1       ,IXDM       ,
     +                IYDN       ,VLOM       ,VHIM       ,ISET       ,
     +                VRMG       ,VRLN       ,VFRC       ,IXIN       ,
     +                IYIN       ,ISVF       ,UUSV       ,UVSV       ,
     +                UPSV       ,IMSK       ,ICPM       ,UVPS       ,
     +                UVPL       ,UVPR       ,UVPB       ,UVPT       ,
     +                UWDL       ,UWDR       ,UWDB       ,UWDT       ,
     +                UXC1       ,UXCM       ,UYC1       ,UYCN       ,
     +                NLVL       ,IPAI       ,ICTV       ,WDLV       ,
     +                UVMN       ,UVMX       ,PMIN       ,PMAX       ,
     +                RVMN       ,RVMX       ,RDMN       ,RDMX       ,
     +                ISPC       ,RVMD       ,IPLR       ,IVST       ,
     +                IVPO       ,ILBL       ,IDPF       ,IMSG       ,
     +                ICLR(IPLVLS)           ,TVLU(IPLVLS)
C
C Arrow size/shape parameters
C
        COMMON / VVARO /
     +                HDSZ       ,HINF       ,HANG       ,IAST       ,
     +                HSIN       ,HCOS       ,FAMN       ,FAMX       ,
     +                UVMG       ,FAIR       ,FAWR       ,FAWF       ,
     +                FAXR       ,FAXF       ,FAYR       ,FAYF       ,
     +                AROX(8)    ,AROY(8)    ,FXSZ       ,FYSZ       ,
     +                FXRF       ,FXMN       ,FYRF       ,FYMN       ,
     +                FWRF       ,FWMN       ,FIRF       ,FIMN       ,
     +                AXMN       ,AXMX       ,AYMN       ,AYMX       ,
     +                IACM       ,IAFO       ,WBAD       ,WBTF       ,
     +                WBCF       ,WBDF       ,WBSC
C
C
C Text related parameters
C
        COMMON /VVTXP /
     +                FCWM    ,ICSZ    ,
     +                FMNS    ,FMNX    ,FMNY    ,IMNP    ,IMNC  ,
     +                FMXS    ,FMXX    ,FMXY    ,IMXP    ,IMXC  ,
     +                FZFS    ,FZFX    ,FZFY    ,IZFP    ,IZFC  ,
     +                FILS    ,FILX    ,FILY    ,IILP    ,IILC  ,
     +                FLBS    ,ILBC

C
C Character variable declartions
C
      CHARACTER*160 CSTR
      PARAMETER (IPCHSZ=36)
      CHARACTER*(IPCHSZ)  CMNT,CMXT,CZFT,CLBT,CILT
C
C Text string parameters
C
      COMMON /VVCHAR/ CSTR,CMNT,CMXT,CZFT,CLBT,CILT
C
      SAVE /VVCOM/, /VVARO/, /VVTXP/, /VVCHAR/
C
C The mapping common block: made available to user mapping routines
C
      COMMON /VVMAP/
     +                IMAP       ,
     +                XVPL       ,XVPR       ,YVPB       ,YVPT       ,
     +                WXMN       ,WXMX       ,WYMN       ,WYMX       ,
     +                XLOV       ,XHIV       ,YLOV       ,YHIV       ,
     +                SXDC       ,SYDC       ,NXCT       ,NYCT       ,
     +                RLEN       ,LNLG       ,INVX       ,INVY       ,
     +                ITRT       ,IWCT       ,FW2W       ,FH2H       ,
     +                DVMN       ,DVMX       ,RBIG       ,IBIG
C
      SAVE /VVMAP/
C
C Math constants
C
      PARAMETER (PDTOR  = 0.017453292519943,
     +           PRTOD  = 57.2957795130823,
     +           P1XPI  = 3.14159265358979,
     +           P2XPI  = 6.28318530717959,
     +           P1D2PI = 1.57079632679489,
     +           P5D2PI = 7.85398163397448) 
C
C --------------------------------------------------------------------
C
      CHARACTER*1  CDM
      EXTERNAL VVDUMB
C
      IAST = INT(ARS(1))
      UVMX = ARS(2)
      UVMN = ARS(3)
      DVMX = ARS(4)
      DVMN = 0.0
      FW2W = ARS(5)
      UVMG = ARS(6)
      VLOM = ARS(7)
      VHIM = ARS(8)
      VFRC = ARS(9)
      VRLN = ARS(10)
      VRMG = ARS(11)
      FAMN = MIN(1.0,MAX(0.0,ARS(12)))
      FAMX = MIN(1.0,MAX(0.0,ARS(13)))
      FAIR = MIN(1.0,MAX(0.0,ARS(14)))
      FAWR = MIN(1.0,MAX(0.0,ARS(15)))
      FAWF = MIN(1.0,MAX(0.0,ARS(16)))
      FAXR = MIN(2.0,MAX(0.0,ARS(17)))
      FAXF = MIN(1.0,MAX(0.0,ARS(18)))
      FAYR = MIN(1.0,MAX(0.0,ARS(19)))
      FAYF = MIN(1.0,MAX(0.0,ARS(20)))
      IAFO = INT(ARS(21))
      WBAD=MIN(80.0,MAX(-80.0,ARS(22)))
      WBTF=MIN(1.0,MAX(0.001,ARS(23)))
      WBCF=MIN(1.0,MAX(0.001,ARS(24)))
      WBDF=MIN(1.0,MAX(0.001,ARS(25)))
      WBSC=MAX(0.0,ARS(26))
C
      CALL VVILNS(DRL,VFR,IAV)
      VL = -VLN
C
C Call the appropriate drawing routine with the vector length set
C negative in order to simply calculate the height and width of the
C vector arrow.
C
      ISP = IVPO
      IVPO = 1
      IF (IAST.EQ.0) THEN
         CALL VVDRAW(XB,YB,XE,YE,VL,CDM,0,IDM,VVDUMB,0)
      ELSE IF (IAST.EQ.1) THEN
         CALL VVINFA()
         CALL VVDRFL(XB,YB,XE,YE,VL,CDM,0,IDM,VVDUMB,0)
      ELSE
         CALL VVINWB(1)
         CALL VVDRWB(XB,YB,XE,YE,-DVMX,CDM,0,IDM,VVDUMB,0)
      END IF
      IVPO = ISP
C
      XMN = AXMN
      XMX = AXMX
      YMN = AYMN
      YMX = AYMX
C
      RETURN
      END
C
C ---------------------------------------------------------------------
C
      SUBROUTINE VVARROWDRAW (DRS,ARS,XB,YB,XE,YE,VLN)
C
      REAL ARS(26),DRS(11)
C
C ---------------------------------------------------------------------
C
C NOTE:
C Since implicit typing is used for all real and integer variables
C a consistent length convention has been adopted to help clarify the
C significance of the variables encountered in the code for this 
C utility. All local variable and subroutine parameter identifiers 
C are limited to 1,2,or 3 characters. Four character names identify  
C members of common blocks. Five and 6 character variable names 
C denote PARAMETER constants or subroutine or function names.
C
C Declare the VV common blocks.
C
C IPLVLS - Maximum number of color threshold level values
C IPAGMX - Maximum number of area groups allowed in the area map
C
      PARAMETER (IPLVLS = 256, IPAGMX = 64)
C
C Integer and real common block variables
C
C
      COMMON /VVCOM/
     +                IUD1       ,IVD1       ,IPD1       ,IXDM       ,
     +                IYDN       ,VLOM       ,VHIM       ,ISET       ,
     +                VRMG       ,VRLN       ,VFRC       ,IXIN       ,
     +                IYIN       ,ISVF       ,UUSV       ,UVSV       ,
     +                UPSV       ,IMSK       ,ICPM       ,UVPS       ,
     +                UVPL       ,UVPR       ,UVPB       ,UVPT       ,
     +                UWDL       ,UWDR       ,UWDB       ,UWDT       ,
     +                UXC1       ,UXCM       ,UYC1       ,UYCN       ,
     +                NLVL       ,IPAI       ,ICTV       ,WDLV       ,
     +                UVMN       ,UVMX       ,PMIN       ,PMAX       ,
     +                RVMN       ,RVMX       ,RDMN       ,RDMX       ,
     +                ISPC       ,RVMD       ,IPLR       ,IVST       ,
     +                IVPO       ,ILBL       ,IDPF       ,IMSG       ,
     +                ICLR(IPLVLS)           ,TVLU(IPLVLS)
C
C Arrow size/shape parameters
C
        COMMON / VVARO /
     +                HDSZ       ,HINF       ,HANG       ,IAST       ,
     +                HSIN       ,HCOS       ,FAMN       ,FAMX       ,
     +                UVMG       ,FAIR       ,FAWR       ,FAWF       ,
     +                FAXR       ,FAXF       ,FAYR       ,FAYF       ,
     +                AROX(8)    ,AROY(8)    ,FXSZ       ,FYSZ       ,
     +                FXRF       ,FXMN       ,FYRF       ,FYMN       ,
     +                FWRF       ,FWMN       ,FIRF       ,FIMN       ,
     +                AXMN       ,AXMX       ,AYMN       ,AYMX       ,
     +                IACM       ,IAFO       ,WBAD       ,WBTF       ,
     +                WBCF       ,WBDF       ,WBSC
C
C
C Text related parameters
C
        COMMON /VVTXP /
     +                FCWM    ,ICSZ    ,
     +                FMNS    ,FMNX    ,FMNY    ,IMNP    ,IMNC  ,
     +                FMXS    ,FMXX    ,FMXY    ,IMXP    ,IMXC  ,
     +                FZFS    ,FZFX    ,FZFY    ,IZFP    ,IZFC  ,
     +                FILS    ,FILX    ,FILY    ,IILP    ,IILC  ,
     +                FLBS    ,ILBC

C
C Character variable declartions
C
      CHARACTER*160 CSTR
      PARAMETER (IPCHSZ=36)
      CHARACTER*(IPCHSZ)  CMNT,CMXT,CZFT,CLBT,CILT
C
C Text string parameters
C
      COMMON /VVCHAR/ CSTR,CMNT,CMXT,CZFT,CLBT,CILT
C
      SAVE /VVCOM/, /VVARO/, /VVTXP/, /VVCHAR/
C
C The mapping common block: made available to user mapping routines
C
      COMMON /VVMAP/
     +                IMAP       ,
     +                XVPL       ,XVPR       ,YVPB       ,YVPT       ,
     +                WXMN       ,WXMX       ,WYMN       ,WYMX       ,
     +                XLOV       ,XHIV       ,YLOV       ,YHIV       ,
     +                SXDC       ,SYDC       ,NXCT       ,NYCT       ,
     +                RLEN       ,LNLG       ,INVX       ,INVY       ,
     +                ITRT       ,IWCT       ,FW2W       ,FH2H       ,
     +                DVMN       ,DVMX       ,RBIG       ,IBIG
C
      SAVE /VVMAP/
C
C Math constants
C
      PARAMETER (PDTOR  = 0.017453292519943,
     +           PRTOD  = 57.2957795130823,
     +           P1XPI  = 3.14159265358979,
     +           P2XPI  = 6.28318530717959,
     +           P1D2PI = 1.57079632679489,
     +           P5D2PI = 7.85398163397448) 
C
C --------------------------------------------------------------------
C
      CHARACTER*1  CDM
      EXTERNAL VVDUMB
C
      IAST = INT(ARS(1))
      UVMX = ARS(2)
      UVMN = ARS(3)
      DVMX = ARS(4)
      DVMN = 0.0
      FW2W = ARS(5)
      UVMG = ARS(6)
      VLOM = ARS(7)
      VHIM = ARS(8)
      VFRC = ARS(9)
      VRLN = ARS(10)
      VRMG = ARS(11)
      FAMN = MIN(1.0,MAX(0.0,ARS(12)))
      FAMX = MIN(1.0,MAX(0.0,ARS(13)))
      FAIR = MIN(1.0,MAX(0.0,ARS(14)))
      FAWR = MIN(1.0,MAX(0.0,ARS(15)))
      FAWF = MIN(1.0,MAX(0.0,ARS(16)))
      FAXR = MIN(2.0,MAX(0.0,ARS(17)))
      FAXF = MIN(1.0,MAX(0.0,ARS(18)))
      FAYR = MIN(1.0,MAX(0.0,ARS(19)))
      FAYF = MIN(1.0,MAX(0.0,ARS(20)))
      IAFO = INT(ARS(21))
      WBAD=MIN(80.0,MAX(-80.0,ARS(22)))
      WBTF=MIN(1.0,MAX(0.001,ARS(23)))
      WBCF=MIN(1.0,MAX(0.001,ARS(24)))
      WBDF=MIN(1.0,MAX(0.001,ARS(25)))
      WBSC=MAX(0.0,ARS(26))
C
      XVPL = DRS(1)
      XVPR = DRS(2)
      XVPB = DRS(3)
      XVPT = DRS(4)
      WXMN = DRS(5)
      WXMX = DRS(6)
      WYMN = DRS(7)
      WYMX = DRS(8)
      INVX = DRS(9)
      INVY = DRS(10)
      LNLG = DRS(11)
C
      CALL VVILNS(DRL,VFR,IAV)
      VL = VLN
C
C
C Call the appropriate drawing routine with the vector length set
C negative in order to simply calculate the height and width of the
C vector arrow.
C
      ISP = IVPO
      IVPO = 1
      IF (IAST.EQ.0) THEN
         CALL VVDRAW(XB,YB,XE,YE,VL,CDM,0,IDM,VVDUMB,0)
      ELSE IF (IAST.EQ.1) THEN
         CALL VVINFA()
         CALL VVDRFL(XB,YB,XE,YE,VL,CDM,0,IDM,VVDUMB,0)
      ELSE
         CALL VVINWB(1)
         CALL VVDRWB(XB,YB,XE,YE,DVMX,CDM,0,IDM,VVDUMB,0)
      END IF
      IVPO = ISP
C
      RETURN
      END
C
C ---------------------------------------------------------------------
C
      SUBROUTINE VVGETMAPINFO (IMP,ITR,DMX,SXD,SYD,XMN,XMX,YMN,YMX)
C
C The sole purpose of this routine is to make information from the
C mapping common block available to hluvvmpxy
C
C
C The mapping common block: made available to user mapping routines
C
      COMMON /VVMAP/
     +                IMAP       ,
     +                XVPL       ,XVPR       ,YVPB       ,YVPT       ,
     +                WXMN       ,WXMX       ,WYMN       ,WYMX       ,
     +                XLOV       ,XHIV       ,YLOV       ,YHIV       ,
     +                SXDC       ,SYDC       ,NXCT       ,NYCT       ,
     +                RLEN       ,LNLG       ,INVX       ,INVY       ,
     +                ITRT       ,IWCT       ,FW2W       ,FH2H       ,
     +                DVMN       ,DVMX       ,RBIG       ,IBIG
C
      SAVE /VVMAP/
C
C Math constants
C
      PARAMETER (PDTOR  = 0.017453292519943,
     +           PRTOD  = 57.2957795130823,
     +           P1XPI  = 3.14159265358979,
     +           P2XPI  = 6.28318530717959,
     +           P1D2PI = 1.57079632679489,
     +           P5D2PI = 7.85398163397448) 
C
C --------------------------------------------------------------------
C
      IMP = IMAP
      DMX = DVMX
      SXD = SXDC
      SYD = SYDC
      ITR = ITRT
      XMN = WXMN
      XMX = WXMX
      YMN = WYMN
      YMX = WYMX
C
C Done.
C
      RETURN
C
      END

C
C	$Id: gcrsg.f,v 1.6 2008-07-27 00:20:57 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GCRSG(SGNA)
C
C  CREATE SEGMENT
C
      INTEGER ECRSG
      PARAMETER (ECRSG=56)
C
      include 'gkscom.h'
C
      INTEGER SGNA
C
C  This subroutine is here solely as support for the SPPS GFLASn
C  entries.  Full segmentation is not a part of the NCAR GKS
C  package at this time.  The NCAR package is non-standard to the
C  extent that certain segmentation functions are supported, but
C  not all level 1 functions are supported.  This subroutine should
C  be considered a user entry point only by way of the GFLASn
C  calls--it should never be called directly by the user.
C
C
C  Check if GKS iS in the proper state.
C
      CALL GZCKST(3,ECRSG,IER)
      IF (IER .NE. 0) RETURN
C
C  Check that the segment name is valid.
C
      IF (SGNA.LT.0 .OR. SGNA.GT.99) THEN
        ERS = 1
        CALL GERHND(120,ECRSG,ERF)
        ERS = 0
        RETURN
      ENDIF
C
C  Check if the segment name is already in use.
C
      DO 200 I=1,NUMSEG
        IF (SEGS(I) .EQ. SGNA) THEN
          ERS = 1
          CALL GERHND(121,ECRSG,ERF)
          ERS = 0
          RETURN
        ENDIF
  200 CONTINUE
C
C  Check if WISS is active.  Since NCAR GKS stores segments only 
C  in WISS, no segment is stored unless WISS is active.
C
      DO 10 I=1,NACWK
        CALL GQWKC(SACWK(I),IER,ICONID,ITYP)
        IF (ITYP .EQ. GWSS) THEN
          IWKIDX = I
          GO TO 20
        ENDIF
   10 CONTINUE
      ERS = 1
      CALL GERHND(-103,ECRSG,ERF)
      ERS = 0
      RETURN
   20 CONTINUE
C
C  Set GKS state to segment open.
C
      OPS = GSGOP
C
C  Add segment name to those in use; initialize the segment 
C  transformation to the identity.
C
      NUMSEG = NUMSEG+1
      SEGS(NUMSEG) = SGNA
      CURSEG = SGNA
      SEGNAM(NUMSEG) = ' '
      IF (GSEGRT(1:4) .EQ. 'GSEG') THEN
C
C  Construct a temporary file name from the user id and process id.
C
        CALL GZGIDS(IPID,IUID)
        IPID = MOD(IPID,9999)
        IUID = MOD(IUID,9999)
        WRITE(SEGNAM(NUMSEG)(1:4),500)
        WRITE(SEGNAM(NUMSEG)(5:8),501) IUID
        WRITE(SEGNAM(NUMSEG)(9:12),501) IPID
        WRITE(SEGNAM(NUMSEG)(13:15),502) SGNA
  500   FORMAT('GSEG')
  501   FORMAT(I4)
  502   FORMAT('_',I2)
        DO 50 I=1,14
          IF(SEGNAM(NUMSEG)(I:I) .EQ. ' ') SEGNAM(NUMSEG)(I:I) = '0'
   50   CONTINUE
      ELSE
C
C  Construct the user-requested file name.
C
        LLEN = LEN(GSEGRT)
        DO 60 I=1,LLEN
        IF (GSEGRT(I:I).EQ.' ' .OR. GSEGRT(I:I).EQ.CHAR(0)) THEN
          ILEN = I-1
          GO TO 65
        ELSE
          SEGNAM(NUMSEG)(I:I) = GSEGRT(I:I)
        ENDIF
   60   CONTINUE
        ILEN = LLEN
   65   CONTINUE
        WRITE(SEGNAM(NUMSEG)(ILEN+1:ILEN+2),503) SGNA
        SEGNAM(NUMSEG)(ILEN+3:ILEN+3) = CHAR(0)
  503   FORMAT(I2)
        IF (SEGNAM(NUMSEG)(ILEN+1:ILEN+1) .EQ. ' ') THEN
          SEGNAM(NUMSEG)(ILEN+1:ILEN+1) = '0'
        ENDIF
      ENDIF
C
C  Initialize the segment transformation.
C
      DO 30 I=1,2
        DO 40 J=1,3
          SEGT(NUMSEG,I,J) = 0.
   40   CONTINUE
   30 CONTINUE
      SEGT(NUMSEG,1,1) = 1.
      SEGT(NUMSEG,2,2) = 1.
C
C  Invoke workstation interface, set CUFLAG to force consideration of
C  WISS only.
C
      CUFLAG = SACWK(IWKIDX)
      FCODE = 80
      CONT  = 0
      CALL GZROI(0)
      IL1 = 2
      IL2 = 2
      ID(1) = WCONID
      ID(2) = SGNA
      STR = SEGNAM(NUMSEG)
      CALL GZTOWK
      IF (RERR.NE.0) THEN
        ERS = 1
        CALL GERHND(RERR,ECRSG,ERF)
        ERS = 0
      ENDIF
      CUFLAG = -1
C
      RETURN
      END

      SUBROUTINE DLAIC1( JOB, J, X, SEST, W, GAMMA, SESTPR, S, C )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     October 31, 1992
*
*     .. Scalar Arguments ..
      INTEGER            J, JOB
      DOUBLE PRECISION   C, GAMMA, S, SEST, SESTPR
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   W( J ), X( J )
*     ..
*
*  Purpose
*  =======
*
*  DLAIC1 applies one step of incremental condition estimation in
*  its simplest version:
*
*  Let x, twonorm(x) = 1, be an approximate singular vector of an j-by-j
*  lower triangular matrix L, such that
*           twonorm(L*x) = sest
*  Then DLAIC1 computes sestpr, s, c such that
*  the vector
*                  [ s*x ]
*           xhat = [  c  ]
*  is an approximate singular vector of
*                  [ L     0  ]
*           Lhat = [ w' gamma ]
*  in the sense that
*           twonorm(Lhat*xhat) = sestpr.
*
*  Depending on JOB, an estimate for the largest or smallest singular
*  value is computed.
*
*  Note that [s c]' and sestpr**2 is an eigenpair of the system
*
*      diag(sest*sest, 0) + [alpha  gamma] * [ alpha ]
*                                            [ gamma ]
*
*  where  alpha =  x'*w.
*
*  Arguments
*  =========
*
*  JOB     (input) INTEGER
*          = 1: an estimate for the largest singular value is computed.
*          = 2: an estimate for the smallest singular value is computed.
*
*  J       (input) INTEGER
*          Length of X and W
*
*  X       (input) DOUBLE PRECISION array, dimension (J)
*          The j-vector x.
*
*  SEST    (input) DOUBLE PRECISION
*          Estimated singular value of j by j matrix L
*
*  W       (input) DOUBLE PRECISION array, dimension (J)
*          The j-vector w.
*
*  GAMMA   (input) DOUBLE PRECISION
*          The diagonal element gamma.
*
*  SEDTPR  (output) DOUBLE PRECISION
*          Estimated singular value of (j+1) by (j+1) matrix Lhat.
*
*  S       (output) DOUBLE PRECISION
*          Sine needed in forming xhat.
*
*  C       (output) DOUBLE PRECISION
*          Cosine needed in forming xhat.
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO, ONE, TWO
      PARAMETER          ( ZERO = 0.0D0, ONE = 1.0D0, TWO = 2.0D0 )
      DOUBLE PRECISION   HALF, FOUR
      PARAMETER          ( HALF = 0.5D0, FOUR = 4.0D0 )
*     ..
*     .. Local Scalars ..
      DOUBLE PRECISION   ABSALP, ABSEST, ABSGAM, ALPHA, B, COSINE, EPS,
     $                   NORMA, S1, S2, SINE, T, TEST, TMP, ZETA1, ZETA2
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, MAX, SIGN, SQRT
*     ..
*     .. External Functions ..
      DOUBLE PRECISION   DDOT, DLAMCH
      EXTERNAL           DDOT, DLAMCH
*     ..
*     .. Executable Statements ..
*
      EPS = DLAMCH( 'Epsilon' )
      ALPHA = DDOT( J, X, 1, W, 1 )
*
      ABSALP = ABS( ALPHA )
      ABSGAM = ABS( GAMMA )
      ABSEST = ABS( SEST )
*
      IF( JOB.EQ.1 ) THEN
*
*        Estimating largest singular value
*
*        special cases
*
         IF( SEST.EQ.ZERO ) THEN
            S1 = MAX( ABSGAM, ABSALP )
            IF( S1.EQ.ZERO ) THEN
               S = ZERO
               C = ONE
               SESTPR = ZERO
            ELSE
               S = ALPHA / S1
               C = GAMMA / S1
               TMP = SQRT( S*S+C*C )
               S = S / TMP
               C = C / TMP
               SESTPR = S1*TMP
            END IF
            RETURN
         ELSE IF( ABSGAM.LE.EPS*ABSEST ) THEN
            S = ONE
            C = ZERO
            TMP = MAX( ABSEST, ABSALP )
            S1 = ABSEST / TMP
            S2 = ABSALP / TMP
            SESTPR = TMP*SQRT( S1*S1+S2*S2 )
            RETURN
         ELSE IF( ABSALP.LE.EPS*ABSEST ) THEN
            S1 = ABSGAM
            S2 = ABSEST
            IF( S1.LE.S2 ) THEN
               S = ONE
               C = ZERO
               SESTPR = S2
            ELSE
               S = ZERO
               C = ONE
               SESTPR = S1
            END IF
            RETURN
         ELSE IF( ABSEST.LE.EPS*ABSALP .OR. ABSEST.LE.EPS*ABSGAM ) THEN
            S1 = ABSGAM
            S2 = ABSALP
            IF( S1.LE.S2 ) THEN
               TMP = S1 / S2
               S = SQRT( ONE+TMP*TMP )
               SESTPR = S2*S
               C = ( GAMMA / S2 ) / S
               S = SIGN( ONE, ALPHA ) / S
            ELSE
               TMP = S2 / S1
               C = SQRT( ONE+TMP*TMP )
               SESTPR = S1*C
               S = ( ALPHA / S1 ) / C
               C = SIGN( ONE, GAMMA ) / C
            END IF
            RETURN
         ELSE
*
*           normal case
*
            ZETA1 = ALPHA / ABSEST
            ZETA2 = GAMMA / ABSEST
*
            B = ( ONE-ZETA1*ZETA1-ZETA2*ZETA2 )*HALF
            C = ZETA1*ZETA1
            IF( B.GT.ZERO ) THEN
               T = C / ( B+SQRT( B*B+C ) )
            ELSE
               T = SQRT( B*B+C ) - B
            END IF
*
            SINE = -ZETA1 / T
            COSINE = -ZETA2 / ( ONE+T )
            TMP = SQRT( SINE*SINE+COSINE*COSINE )
            S = SINE / TMP
            C = COSINE / TMP
            SESTPR = SQRT( T+ONE )*ABSEST
            RETURN
         END IF
*
      ELSE IF( JOB.EQ.2 ) THEN
*
*        Estimating smallest singular value
*
*        special cases
*
         IF( SEST.EQ.ZERO ) THEN
            SESTPR = ZERO
            IF( MAX( ABSGAM, ABSALP ).EQ.ZERO ) THEN
               SINE = ONE
               COSINE = ZERO
            ELSE
               SINE = -GAMMA
               COSINE = ALPHA
            END IF
            S1 = MAX( ABS( SINE ), ABS( COSINE ) )
            S = SINE / S1
            C = COSINE / S1
            TMP = SQRT( S*S+C*C )
            S = S / TMP
            C = C / TMP
            RETURN
         ELSE IF( ABSGAM.LE.EPS*ABSEST ) THEN
            S = ZERO
            C = ONE
            SESTPR = ABSGAM
            RETURN
         ELSE IF( ABSALP.LE.EPS*ABSEST ) THEN
            S1 = ABSGAM
            S2 = ABSEST
            IF( S1.LE.S2 ) THEN
               S = ZERO
               C = ONE
               SESTPR = S1
            ELSE
               S = ONE
               C = ZERO
               SESTPR = S2
            END IF
            RETURN
         ELSE IF( ABSEST.LE.EPS*ABSALP .OR. ABSEST.LE.EPS*ABSGAM ) THEN
            S1 = ABSGAM
            S2 = ABSALP
            IF( S1.LE.S2 ) THEN
               TMP = S1 / S2
               C = SQRT( ONE+TMP*TMP )
               SESTPR = ABSEST*( TMP / C )
               S = -( GAMMA / S2 ) / C
               C = SIGN( ONE, ALPHA ) / C
            ELSE
               TMP = S2 / S1
               S = SQRT( ONE+TMP*TMP )
               SESTPR = ABSEST / S
               C = ( ALPHA / S1 ) / S
               S = -SIGN( ONE, GAMMA ) / S
            END IF
            RETURN
         ELSE
*
*           normal case
*
            ZETA1 = ALPHA / ABSEST
            ZETA2 = GAMMA / ABSEST
*
            NORMA = MAX( ONE+ZETA1*ZETA1+ABS( ZETA1*ZETA2 ),
     $              ABS( ZETA1*ZETA2 )+ZETA2*ZETA2 )
*
*           See if root is closer to zero or to ONE
*
            TEST = ONE + TWO*( ZETA1-ZETA2 )*( ZETA1+ZETA2 )
            IF( TEST.GE.ZERO ) THEN
*
*              root is close to zero, compute directly
*
               B = ( ZETA1*ZETA1+ZETA2*ZETA2+ONE )*HALF
               C = ZETA2*ZETA2
               T = C / ( B+SQRT( ABS( B*B-C ) ) )
               SINE = ZETA1 / ( ONE-T )
               COSINE = -ZETA2 / T
               SESTPR = SQRT( T+FOUR*EPS*EPS*NORMA )*ABSEST
            ELSE
*
*              root is closer to ONE, shift by that amount
*
               B = ( ZETA2*ZETA2+ZETA1*ZETA1-ONE )*HALF
               C = ZETA1*ZETA1
               IF( B.GE.ZERO ) THEN
                  T = -C / ( B+SQRT( B*B+C ) )
               ELSE
                  T = B - SQRT( B*B+C )
               END IF
               SINE = -ZETA1 / T
               COSINE = -ZETA2 / ( ONE+T )
               SESTPR = SQRT( ONE+T+FOUR*EPS*EPS*NORMA )*ABSEST
            END IF
            TMP = SQRT( SINE*SINE+COSINE*COSINE )
            S = SINE / TMP
            C = COSINE / TMP
            RETURN
*
         END IF
      END IF
      RETURN
*
*     End of DLAIC1
*
      END

C
C $Id: ngezlogo.f,v 1.3 2008-07-27 00:17:17 haley Exp $
C                                                                      
C                Copyright (C)  2002
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE NGEZLOGO()
C
C  Draws a logo at the lower right of the current plot on all 
C  active workstations as per the current user settings.
C 
      SAVE
C
      include 'ngcomn.h'
C
C  Check for an uncleared prior error.
C
      IF (ICFELL('NGEZLOGO - Uncleared prior error',1) .NE. 0) RETURN
C
      CALL GQCNTN(IER,NTNR)
      CALL GETSET(VX1,VX2,VY1,VY2,WX1,WX2,WY1,WY2,ISC)
      CALL SET(0.,1.,0.,1.,0.,1.,0.,1.,1)
C
C  Get the current logo settings.
C
      CALL NGGETI('LT',LTYPE)
      CALL NGGETI('LC',LCOL1)
      CALL NGGETI('LB',LCOL2)
      CALL NGGETR('OX',OLX)
      CALL NGGETR('OY',OLY)
      CALL NGGETR('OS',OLS)
C
C  Adjust the X position.
C
      CALL GQACWK(1,IER,NUMACT,IWK)
      IF (LTYPE .EQ. 1) THEN
        OLYT = OLY
        OLXT = OLX
      ELSE If (LTYPE .EQ. 2) THEN
        OLYT = OLY+0.01
        OLXT = OLX+0.01
      ELSE If (LTYPE .EQ. 3) THEN
        OLYT = OLY+0.015
        OLXT = OLX-0.08
      ELSE If (LTYPE .EQ. 4) THEN
        OLYT = OLY+0.015
        OLXT = OLX-0.08
      ELSE If (LTYPE .EQ. 5) THEN
        OLYT = OLY+0.015
        OLXT = OLX-0.12
      ELSE
        OLYT = OLY
        OLXT = OLX
      ENDIF
C
C  Loop through the active workstations and put out the logo.
C
      DO 10 I=1,NUMACT
        CALL GQACWK(I,IER,NUMACT,IWK)
        CALL NGLOGO(IWK,OLXT,OLYT,OLS,LTYPE,LCOL1,LCOL2)
   10 CONTINUE 
C
C  Restore the SET call and the current normalization transformation.
C
      CALL SET(VX1,VX2,VY1,VY2,WX1,WX2,WY1,WY2,ISC)
      CALL GSELNT(NTNR)
C
      RETURN
      END

C
C      $Id: vc07f.f,v 1.7 2010-03-15 22:49:25 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C                Copyright (C)  1996                                   C
C        University Corporation for Atmospheric Research               C
C                All Rights Reserved                                   C
C                                                                      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C  File:       vc07f.f
C
C  Author:     David Brown (converted by Mary Haley)
C              National Center for Atmospheric Research
C              PO 3000, Boulder, Colorado
C
C  Date:       Wed Jul  3 9:25:32 MST 1996
C
C  Description: This example emulates the LLU example "fcover", overlaying
C               contours and vectors on a map plot.
C
C
      external NhlFAppClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFCairoWindowWorkstationClass
      external NhlFVectorFieldClass
      external NhlFVectorPlotClass
      external NhlFScalarFieldClass
      external NhlFContourPlotClass
      external NhlFMapPlotClass

      parameter(MSIZE=73,NSIZE=73,NROWS=11,NCOLORS=24)

      character*7  wks_type
      integer i, j
      integer appid, wid, cnid, vcid, mpid
      integer vfield, sfield
      integer grlist, rlist, len_dims(2)
      real U(NSIZE,MSIZE),V(NSIZE,MSIZE),P(NSIZE,MSIZE)
      integer ithin(NROWS)
      data ithin /90,15,5,5,4,4,3,3,2,2,2/
      character*256 filename
      integer flen
      real cmap(3,NCOLORS)
      data cmap/1.0,1.0,1.0,
     +          0.0,0.0,0.0,
     +          0.9,0.9,0.9,
     +          0.6,0.6,0.6,
     +          0.3,0.3,0.3,
     +          0.8,0.9,1.0,
     +          0.5,0.0,0.5,
     +          0.0,0.5,0.7,
     +          0.0,0.0,0.0,
     +          0.00000,1.00000,0.00000,
     +          0.14286,1.00000,0.00000,
     +          0.28571,1.00000,0.00000,
     +          0.42857,1.00000,0.00000,
     +          0.57143,1.00000,0.00000,
     +          0.71429,1.00000,0.00000,
     +          0.85714,1.00000,0.00000,
     +          1.00000,1.00000,0.00000,
     +          1.00000,0.85714,0.00000,
     +          1.00000,0.71429,0.00000,
     +          1.00000,0.57143,0.00000,
     +          1.00000,0.42857,0.00000,
     +          1.00000,0.28571,0.00000,
     +          1.00000,0.14286,0.00000,
     +          1.00000,0.00000,0.00000/

      len_dims(1) = 3
      len_dims(2) = NCOLORS

C
C Initialize the high level utility library
C
      call NhlFInitialize
C
C Create an application object.
C
      call NhlFRLCreate(rlist,'setrl')
      call NhlFRLCreate(grlist,'getrl')

      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'appUsrDir','./',ierr)
      call NhlFRLSetString(rlist,'appDefaultParent','True',ierr)
      call NhlFCreate(appid,'vc07',NhlFappClass,0,rlist,ierr)

      wks_type = "x11"

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkMetaName','./vc07f.ncgm',ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',cmap,2,len_dims,
     +        ierr)
         call NhlFCreate(wid,'vc07Work',
     +        NhlFNcgmWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X11 workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPause','True',ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',cmap,2,len_dims,
     +        ierr)
         call NhlFCreate(wid,'vc07Work',
     +        NhlFCairoWindowWorkstationClass,
     +        0,rlist,ierr)
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PostScript workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPSFileName','./vc07f.ps',ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',cmap,2,len_dims,
     +        ierr)
         call NhlFCreate(wid,'vc07Work',
     +        NhlFPSWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPDFFileName','./vc07f.pdf',ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',cmap,2,len_dims,
     +        ierr)
         call NhlFCreate(wid,'vc07Work',
     +        NhlFPDFWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFileName','./vc07f',ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',cmap,2,len_dims,
     +        ierr)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(wid,'vc07Work',
     +        NhlFCairoPSPDFWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFileName','./vc07f',ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',cmap,2,len_dims,
     +        ierr)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(wid,'vc07Work',
     +        NhlFCairoImageWorkstationClass,0,rlist,ierr)
      endif
C
C Read the data file
C
      flen = 10
      call gngpat(filename,'examples',ierr)
      do 10 i=1,256
         if( filename(i:i).eq.char(0) ) then
            filename(i:i+flen) = '/fcover.dat'
            goto 15
         endif
 10   continue
 15   open(unit=10,file=filename,status='old')
      read (10,*) U
      read (10,*) V
      read (10,*) P
C
C Massage the data to eliminate surplus of vectors near the pole
C
      do 50 j=NSIZE,NSIZE-NROWS+1,-1
         do 49 i=1,MSIZE
            if (mod(i,ithin(NSIZE-j+1)).ne.0) then
               u(i,j) = -9999.0
            endif
 49      continue
 50   continue
C
C Create a MapPlot object.
C
      call NhlFCreate(mpid,'mapplot',NhlFmapPlotClass,wid,0,ierr)
C
C Create a ScalarField.
C
      len_dims(1) = NSIZE
      len_dims(2) = MSIZE
      call NhlFRLClear(rlist)
      call NhlFRLSetMDFloatArray(rlist,'sfDataArray',P,2,len_dims,ierr)
      call NhlFRLSetFloat(rlist,'sfXCStartV',-180.,ierr)
      call NhlFRLSetFloat(rlist,'sfYCStartV',-90.,ierr)
      call NhlFRLSetFloat(rlist,'sfXCEndV',180.,ierr)
      call NhlFRLSetFloat(rlist,'sfYCEndV',90.,ierr)
      call NhlFRLSetFloat(rlist,'sfMissingValueV', -9999.0,ierr)
      call NhlFCreate(sfield,'ScalarField',NhlFscalarFieldClass,appid,
     +     rlist,ierr)
C
C Create a VectorField.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetMDFloatArray(rlist,'vfUDataArray',U,2,len_dims,ierr)
      call NhlFRLSetMDFloatArray(rlist,'vfVDataArray',V,2,len_dims,ierr)
      call NhlFRLSetFloat(rlist,'vfXCStartV',-180.,ierr)
      call NhlFRLSetFloat(rlist,'vfYCStartV',-90.,ierr)
      call NhlFRLSetFloat(rlist,'vfXCEndV', 180.,ierr)
      call NhlFRLSetFloat(rlist,'vfYCEndV',90.,ierr)
      call NhlFRLSetFloat(rlist,'vfMissingUValueV',-9999.0,ierr)
      call NhlFRLSetFloat(rlist,'vfMissingVValueV',-9999.0,ierr)
      call NhlFCreate(vfield,'VectorField',NhlFvectorFieldClass,appid,
     +     rlist,ierr)
C
C Create a VectorPlot object.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'vcUseScalarArray','true',ierr)
      call NhlFRLSetInteger(rlist,'vcVectorFieldData',vfield,ierr)
      call NhlFRLSetInteger(rlist,'vcScalarFieldData',sfield,ierr)
      call NhlFCreate(vcid,'vectorplot',NhlFvectorPlotClass,wid,rlist,
     +     ierr)

      call NhlFRLClear(grlist)
      call NhlFRLGetFloat(grlist,'vcMinMagnitudeF',vmin,ierr)
      call NhlFRLGetFloat(grlist,'vcMaxMagnitudeF',vmax,ierr)
      call NhlFGetValues(vcid,grlist,ierr)

      call NhlFRLClear(rlist)
      call NhlFRLSetFloat(rlist,'vcMinMagnitudeF',vmin+0.1*(vmax-vmin),
     +     ierr)
      call NhlFSetValues(vcid,rlist,ierr)
C
C Create a ContourPlot object.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetInteger(rlist,'cnScalarFieldData',sfield,ierr)
      call NhlFCreate(cnid,'contourplot',NhlFcontourPlotClass,wid,
     +     rlist,ierr)
C
C Overlay the vectors and the contours on the map and draw
C everything.
C
      call NhlFDraw(mpid,ierr)
      call NhlFFrame(wid,ierr)

      call NhlFDraw(cnid,ierr)
      call NhlFFrame(wid,ierr)

      call NhlFDraw(vcid,ierr)
      call NhlFFrame(wid,ierr)

      call NhlFAddOverlay(mpid,vcid,-1,ierr)
      call NhlFAddOverlay(mpid,cnid,-1,ierr)
      call NhlFDraw(mpid,ierr)
      call NhlFFrame(wid,ierr)

      call NhlFDestroy(wid,ierr)
      call NhlFClose
      stop
      end

C
C	$Id: gwitx.f,v 1.7 2008-07-27 00:21:08 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GWITX
C
C  Process TEXT instruction.
C
C ************************************************************************
C **                                                                    **
C **     NOTE:  Continuation across character partitions is not         **
C **            implemented.  This limits character strings to          **
C **            lengths less than 32768.                                **
C **                                                                    **
C ************************************************************************
C
      include 'gksin.h'
      include 'gwiio.h'
      include 'gwiins.h'
      include 'gwiwsl.h'
      include 'gwiarq.h'
      include 'gwiast.h'
      include 'gwiadc.h'
      include 'gwiopc.h'
      include 'gwienu.h'
C
      INTEGER  NUMO(2), KALL, IPRIM, NBYTES
      INTEGER  GFINAL, G01PBL
      SAVE
C
      DATA KALL/0/,  IPRIM/3/,  GFINAL/1/
C
      KALL = KALL+1
      IF  (KALL.EQ.1) THEN
C
C  First call of text element.
C
C  If the picture is empty, send the clip indicator and rectangle;
C  set the WSL entry "DISPLAY SURFACE EMPTY" to "NOT EMPTY".
C
        IF (MDEMPT .EQ. GEMPTY) CALL GWICLP(1)
        MDEMPT = GNEMPT
C
C  Process pending attributes.
C
        IF (AGPEND(IPRIM)) THEN
C
C  Some changes are pending.
C
           IF (VALCHG(IVTXIX))  THEN
C
C  TEXT INDEX
C
              NBYTES = 1+(MIXFW-1)/8
              CALL GWPTNI (CLTBIX, IDTBIX, NBYTES, RERR)
              CALL GWPTPR (MRTXIX, MIXFW, 1, RERR)
              IF (RERR .NE. 0) RETURN
C
C  Set sent value to requested, clear change flag.
C
              MSTXIX         = MRTXIX
              VALCHG(IVTXIX) = .FALSE.
           END IF
           IF (VALCHG(IVTXFO))  THEN
C
C  FONT component of text font and precision.
C
              NBYTES = 1+(MEFW-1)/8
              CALL GWPTNI (CLTFON, IDTFON, NBYTES, RERR)
              CALL GWPTPR (MRTXFO, MEFW, 1, RERR)
              IF (RERR .NE. 0) RETURN
C
C  Set sent value to requested, clear change flag.
C
              MSTXFO         = MRTXFO
              VALCHG(IVTXFO) = .FALSE.
           END IF
           IF (VALCHG(IVTXPR)) THEN
C
C  Precision component of text font and precision.
C
              NBYTES         = 1+(MIXFW-1)/8
              CALL GWPTNI (CLTPRE, IDTPRE, NBYTES, RERR)
              CALL GWPTPR (MRTXPR, MIXFW, 1, RERR)
              IF (RERR .NE. 0) RETURN
C
C  Set sent value to requested, clear change flag.
C
              MSTXPR         = MRTXPR
              VALCHG(IVTXPR) = .FALSE.
           END IF
           IF (VALCHG(IVCHXP)) THEN
C
C  Character expansion factor.
C
              NBYTES = 1+(2*MCFPP-1)/8
              CALL GWPTNI (CLCHEX, IDCHEX, NBYTES, RERR)
              CALL GFLCNV (ARCHXP, NUMO)
              CALL GWPTPR (NUMO, MCFPP, 2, RERR)
              IF (RERR .NE. 0) RETURN
C
C  Set sent value to requested, clear change flag.
C
              ASCHXP         = ARCHXP
              VALCHG(IVCHXP) = .FALSE.
           END IF
           IF (VALCHG(IVCHSP)) THEN
C
C  Character spacing.
C
              NBYTES = 1+(2*MCFPP-1)/8
              CALL GWPTNI (CLCHSP, IDCHSP, NBYTES, RERR)
              CALL GFLCNV (ARCHSP, NUMO)
              CALL GWPTPR (NUMO, MCFPP, 2, RERR)
C
C  Set sent value to requested, clear change flag.
C
              ASCHSP         = ARCHSP
              VALCHG(IVCHSP) = .FALSE.
           END IF
           IF (VALCHG(IVTXCI)) THEN
C
C  Text color index.
C
              NBYTES = 1+(MCIXFW-1)/8
              CALL GWPTNI (CLTCLR, IDTCLR, NBYTES, RERR)
              CALL GWPTPR (MRTXCI, MCIXFW, 1, RERR)
              IF (RERR .NE. 0) RETURN
C
C  Set sent value to requested, clear change flag.
C
              MSTXCI         = MRTXCI
              VALCHG(IVTXCI) = .FALSE.
           END IF
           IF (VALCHG(IVTXP)) THEN
C
C  Text path.
C
              NBYTES = 1+(MEFW-1)/8
              CALL GWPTNI (CLTXPA, IDTXPA, NBYTES, RERR)
              CALL GWPTPR (MRTXP , MEFW,  1, RERR)
              IF (RERR .NE. 0) RETURN
C
C  Set sent value to requested, clear change flag.
C
              MSTXP         = MRTXP
              VALCHG(IVTXP) = .FALSE.
           END IF
           IF (VALCHG(IVTXAL)) THEN
C
C  Text alignment.
C
              NBYTES = 1+(2*MEFW + 4*MCFPP - 1)/8
              CALL GWPTNI (CLTXAL, IDTXAL, NBYTES, RERR)
C
C  Put in CGM discrete alignment values.
C
              CALL GWPTPR (MRTXAL, MEFW, 2, RERR)
C
C  Add (unused) CGM continuous parameters.
C
              NUMO(1) = 0
              NUMO(2) = 0
              CALL GWPTPR (NUMO, MCFPP, 2, RERR)
              CALL GWPTPR (NUMO, MCFPP, 2, RERR)
              IF (RERR .NE. 0) RETURN
C
C  Set sent value to requested, clear change flag.
C
              MSTXAL(1)      = MRTXAL(1)
              MSTXAL(2)      = MRTXAL(2)
              VALCHG(IVTXAL) = .FALSE.
           END IF
           IF (VALCHG(IVCHH)) THEN
C
C  Character height.
C
              NBYTES = 1+(MVDCFW-1)/8
              CALL GWPTNI (CLCHHT, IDCHHT, NBYTES, RERR)
              CALL GWPTPR (MRCHH, MVDCFW,  1, RERR)
              IF (RERR .NE. 0) RETURN
C
C  Set sent value to requested, clear change flag.
C
              MSCHH         = MRCHH
              VALCHG(IVCHH) = .FALSE.
           END IF
           IF (VALCHG(IVCHOV)) THEN
C
C  Character up vector.
C
              NBYTES = 1+(4*MVDCFW-1)/8
              CALL GWPTNI (CLCHOR, IDCHOR, NBYTES, RERR)
              CALL GWPTPR (MRCHOV(1) , MVDCFW,  4, RERR)
              IF (RERR .NE. 0) RETURN
C
C  Set sent value to requested, clear change flag.
C
              MSCHOV(1)      = MRCHOV(1)
              MSCHOV(2)      = MRCHOV(2)
              MSCHOV(3)      = MRCHOV(3)
              MSCHOV(4)      = MRCHOV(4)
              VALCHG(IVCHOV) = .FALSE.
           END IF
           IF (ANYASF)  THEN
C
C  Some ASF has changed.
C
              CALL GWISAS (IPRIM, RERR)
              IF (RERR.NE.0)  RETURN
           END IF
C
C  Clear aggregate change variable.
C
           AGPEND(IPRIM) = .FALSE.
        END IF
C
C  Treat first call, put out opcode, and points.
C
C
C  Put out opcode (class and id) and total length.
C
        NBYTES = G01PBL (STRL1, 1+(MEFW+2*MVDCFW-1)/8 )
        CALL GWPTNI (CLTEXT, IDTEXT, NBYTES, RERR)
C
C  Put out starting point.
C
C  Truncate point to limits of NDC unit square, convert to VDC,
C  and store in WPXPY.
C
        WPXPY(1) = MXOFF + INT(REAL(MXSCAL)*
     -                 (MAX(0.,MIN(1.0,RX(1)))))
        WPXPY(2) = MYOFF + INT(REAL(MYSCAL)*
     -                 (MAX(0.,MIN(1.0,RY(1)))))
        CALL GWPTPR (WPXPY, MVDCFW, 2, RERR)
C
C  Put out final flag.
C
        CALL GWPTPR (GFINAL, MEFW, 1, RERR)
C
C  Put out first (and perhaps only) part of character string.
C
        CALL GWPTPS (STR, STRL1, STRL2, 0, RERR)
        IF (RERR .NE. 0) RETURN
C
C  End of processing for first call of element.
C
      ELSE IF (KALL .GT. 1) THEN
C
C  This is a continuation call for the element.
C
        CALL GWPTPS (STR, STRL1, STRL2, 1, RERR)
        IF (RERR .NE. 0) RETURN
      END IF
C
C  If there is to be no continuation, reset the parameter "KALL".
C
      IF (CONT .EQ. 0) THEN
         KALL = 0
      END IF
C
      RETURN
C
      END

C
C	$Id: ffphol.f,v 1.4 2008-07-27 12:23:42 haley Exp $
C                                                                      
C			     Copyright (C)  1997
C	     University Corporation for Atmospheric Research
C			     All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C

      SUBROUTINE FFPHOL(IER)
C
C  Process holes.
C
      include 'fntcom.h'
C
      DIMENSION IVALS(10)
C
C  Put out the begin hole flag.
C
      CALL FFPPKT(BITPNT,BEGINH,0,0)
      BITPNT = BITPNT+PKWID
   40 CONTINUE
      CALL CFRDLN(IDUM1,IDUM2,IER)
      IF (LINE(1:3) .NE. 'END') THEN
C
C  Has to be coordinate data or Bezier control points to get here.
C
        CALL FFTKIN(LINE,NUMI,IVALS,IER)
        IF (IER .NE. 0) GO TO 30
        IF (NUMI .EQ. 2) THEN
C
C  Coordinate data.
C
          IVALS(1) = IVALS(1)+XBIAS
          IVALS(2) = IVALS(2)+YBIAS
          CALL FFPPKT(BITPNT,COORD,IVALS(1),IVALS(2))
          BITPNT = BITPNT+PKWID
          GO TO 40
        ELSE IF (NUMI .EQ. 6) THEN
C
C  Bezier control points.
C

          IVALS(1) = IVALS(1)+XBIAS
          IVALS(2) = IVALS(2)+YBIAS
          CALL FFPPKT(BITPNT,BEZIER,IVALS(1),IVALS(2))
          BITPNT = BITPNT+PKWID
          DO 60 J=2,3
            IX = 2*J-1
            IY = IX+1
            IVALS(IX) = IVALS(IX)+XBIAS
            IVALS(IY) = IVALS(IY)+YBIAS
            CALL FFPPKT(BITPNT,COORD,IVALS(IX),IVALS(IY))
            BITPNT = BITPNT+PKWID
   60     CONTINUE
          GO TO 40
        ELSE
          IER = EORD
          GO TO 30
        ENDIF
      ELSE IF (LINE(1:10) .EQ. 'END_HOLE') THEN
C
C  Put out end hole flag.
C
        CALL FFPPKT(BITPNT,ENDH,0,0)
        BITPNT = BITPNT+PKWID
        RETURN
      ELSE
        IER = EORD
        GO TO 30
      ENDIF
C
   30 CONTINUE
C
      RETURN
      END

C
C $Id: pj20sp.f,v 1.5 2008-07-27 00:17:11 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE PJ20SP (COORD,CRDIO,INDIC)
C
C -- O B L I Q U E   M E R C A T O R   ( H O T I N E )
C
      IMPLICIT REAL (A-Z)
      INTEGER INDIC
      DIMENSION GEOG(2),PROJ(2),COORD(2),CRDIO(2)
C **** PARAMETERS **** A,E,ES,KS0,ALPHA,LONC,LON1,LAT1,LON2,LAT2,LAT0 **
C ********************** X0,Y0,GAMMA,LON0,AL,BL,EL *********************
      COMMON /ERRMZ0/ IERR
        INTEGER IERR
      SAVE   /ERRMZ0/
      COMMON /PRINZ0/ IPEMSG,IPELUN,IPPARM,IPPLUN
        INTEGER IPEMSG,IPELUN,IPPARM,IPPLUN
      SAVE   /PRINZ0/
      COMMON /PC20SP/ LON0,X0,Y0,AL,BL,COSALF,COSGAM,E,EL,SINALF,
     +                SINGAM,U0
      DATA PI /3.14159265358979323846E0/
      DATA HALFPI /1.5707963267948966E0/
      DATA TOL,EPSLN /1.0E-7,1.0E-10/
      DATA ZERO,HALF,ONE /0.0E0,0.5E0,1.0E0/
C
C -- F O R W A R D   . . .
C
      IF (INDIC .EQ. 0) THEN
C
         GEOG(1) = COORD(1)
         GEOG(2) = COORD(2)
         IERR = 0
         SINPHI = SIN (GEOG(2))
         DLON = ADJLSP (GEOG(1) - LON0)
         VL = SIN (BL * DLON)
         IF (ABS(ABS(GEOG(2)) - HALFPI) .GT. EPSLN) GO TO 230
         UL = SINGAM * SIGN (ONE , GEOG(2))
         US = AL * GEOG(2) / BL
         GO TO 250
  230    TS = TSFNSP (E,GEOG(2),SINPHI)
         Q = EL / TS ** BL
         S = HALF * (Q - ONE / Q)
         T = HALF * (Q + ONE / Q)
         UL = (S * SINGAM - VL * COSGAM) / T
         CON = COS (BL * DLON)
         IF (ABS(CON) .LT. TOL) GO TO 240
         US = AL * ATAN ((S * COSGAM + VL * SINGAM) / CON) / BL
         IF (CON .LT. ZERO) US = US + PI * AL / BL
         GO TO 250
  240    US = AL * BL * DLON
         IERR = 204
         RETURN
  250    IF (ABS(ABS(UL) - ONE) .GT. EPSLN) GO TO 255
         IF (IPEMSG .EQ. 0) WRITE (IPELUN,2060)
 2060    FORMAT (/' ERROR PJ20SP'/
     .            ' POINT PROJECTS INTO INFINITY')
         IERR = 205
         RETURN
  255    VS = HALF * AL * LOG ((ONE - UL) / (ONE + UL)) / BL
         US = US - U0
         PROJ(1) = X0 + VS * COSALF + US * SINALF
         PROJ(2) = Y0 + US * COSALF - VS * SINALF
         CRDIO(1) = PROJ(1)
         CRDIO(2) = PROJ(2)
         RETURN
      END IF
C
C -- I N V E R S E   . . .
C
      IF (INDIC .EQ. 1) THEN
C
         PROJ(1) = COORD(1)
         PROJ(2) = COORD(2)
         IERR = 0
         X = PROJ(1) - X0
         Y = PROJ(2) - Y0
         VS = X * COSALF - Y * SINALF
         US = Y * COSALF + X * SINALF
         US = US + U0
         Q = EXP (- BL * VS / AL)
         S = HALF * (Q - ONE / Q)
         T = HALF * (Q + ONE / Q)
         VL = SIN (BL * US / AL)
         UL = (VL * COSGAM + S * SINGAM) / T
         IF (ABS (ABS (UL) - ONE) .GE. EPSLN) GO TO 300
         GEOG(1) = LON0
         GEOG(2) = SIGN (HALFPI , UL)
         CRDIO(1) = GEOG(1)
         CRDIO(2) = GEOG(2)
         RETURN
  300    CON = ONE / BL
         TS = (EL / SQRT ((ONE + UL) / (ONE - UL))) ** CON
         GEOG(2) = PHI2SP (E,TS)
         CON = COS (BL * US / AL)
         LON = LON0 - ATAN2 ((S * COSGAM - VL * SINGAM) , CON) / BL
         GEOG(1) = ADJLSP (LON)
         CRDIO(1) = GEOG(1)
         CRDIO(2) = GEOG(2)
         RETURN
      END IF
C
      END

C
C	$Id: cssig0.f,v 1.5 2008-07-27 03:10:08 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      DOUBLE PRECISION FUNCTION CSSIG0 (N1,N2,N,X,Y,Z,H,LIST,
     .                                LPTR,LEND,GRAD,IFLGB,
     .                                HBND,TOL,IFLGS, SIGMA,
     .                                IER)
      INTEGER N1, N2, N, LIST(*), LPTR(*), LEND(N), IFLGB,
     .        IFLGS, IER
      DOUBLE PRECISION X(N), Y(N), Z(N), H(N), GRAD(3,N),
     .                 HBND, TOL, SIGMA(*)
C
C***********************************************************
C
C                                              From SSRFPACK
C                                            Robert J. Renka
C                                  Dept. of Computer Science
C                                       Univ. of North Texas
C                                           renka@cs.unt.edu
C                                                   11/21/96
C
C   Given a triangulation of a set of nodes on the unit
C sphere, along with data values H and gradients GRAD at the
C nodes, this function determines the smallest tension fac-
C tor CSSIG0 such that the Hermite interpolatory tension
C spline H(A), defined by CSSIG0 and the endpoint values and
C directional derivatives associated with an arc N1-N2, is
C bounded (either above or below) by HBND for all A in
C (A1,A2), where (A1,A2) denotes an interval corresponding
C to the arc and A is the arc-length.
C
C On input:
C
C       N1,N2 = Nodal indexes of the endpoints of an arc for
C               which the tension factor is to be computed.
C               The indexes must be distinct and lie in the
C               range 1 to N, and if IFLGS .GE. 1, they must
C               correspond to adjacent nodes in the triangu-
C               lation.
C
C       N = Number of nodes in the triangulation.  N .GE. 3.
C
C       X,Y,Z = Arrays of length N containing coordinates of
C               the nodes.  X(I)**2 + Y(I)**2 + Z(I)**2 = 1.
C
C       H = Array of length N containing data values at the
C           nodes.  H(I) is associated with (X(I),Y(I),Z(I))
C           for I = 1 to N.
C
C       LIST,LPTR,LEND = Data structure defining the trian-
C                        gulation.  Refer to STRIPACK
C                        Subroutine CSTRMESH.
C
C       GRAD = Array dimensioned 3 by N whose columns con-
C              tain gradients at the nodes.  GRAD( ,J) must
C              be orthogonal to node J:  GRAD(1,J)*X(J) +
C              GRAD(2,J)*Y(J) + GRAD(3,J)*Z(J) = 0.  Refer
C              to Subroutines CSGRADG, CSGRADL, and CSSMSURF.
C
C       IFLGB = Bound option indicator:
C               IFLGB = -1 if HBND is a lower bound on H.
C               IFLGB = 1 if HBND is an upper bound on H.
C
C       HBND = Bound on H.  HBND .LE. min(H1,H2) if IFLGB =
C              -1 and HBND .GE. max(H1,H2) if IFLGB = 1,
C              where H1 and H2 are the data values at the
C              endpoints of the arc N1-N2.
C
C       TOL = Tolerance whose magnitude determines how close
C             CSSIG0 is to its optimal value when nonzero
C             finite tension is necessary and sufficient to
C             satisfy the constraint.  For a lower bound,
C             CSSIG0 is chosen so that HBND .LE. HMIN .LE.
C             HBND + abs(TOL), where HMIN is the minimum
C             value of H on the arc, and for an upper bound,
C             the maximum of H satisfies HBND - abs(TOL)
C             .LE. HMAX .LE. HBND.  Thus, the constraint is
C             satisfied but possibly with more tension than
C             necessary.
C
C       IFLGS = Tension array option indicator:
C               IFLGS .LE. 0 if SIGMA is not to be used.
C               IFLGS .GE. 1 if SIGMA is to be updated by
C                            storing CSSIG0 in the appropriate
C                            locations.
C
C The above parameters are not altered by this function.
C
C       SIGMA = Dummy parameter (IFLGS .LE. 0) or array con-
C               taining tension factors associated with arcs
C               in one-to-one correspondence with LIST
C               entries (IFLGS .GE. 1).  Refer to Subroutine
C               CSGETSIG.
C
C On output:
C
C       SIGMA = Tension factor array updated with the new
C               value if and only if IFLGS .GE. 1 and IER
C               .GE. 0.
C
C       IER = Error indicator:
C             IER = 0 if no errors were encountered and the
C                     constraint can be satisfied with fin-
C                     ite tension.
C             IER = 1 if no errors were encountered but in-
C                     finite tension is required to satisfy
C                     the constraint (e.g., IFLGB = -1, HBND
C                     = H(A1), and the directional deriva-
C                     tive of H at A1 is negative).
C             IER = -1 if N1, N2, N, or IFLGB is outside its
C                      valid range.
C             IER = -2 if nodes N1 and N2 coincide or IFLGS
C                      .GE. 1 and the nodes are not adja-
C                      cent.
C             IER = -3 if HBND is outside its valid range.
C
C       CSSIG0 = Minimum tension factor defined above unless
C              IER < 0, in which case CSSIG0 = -1.  If IER
C              = 1, CSSIG0 is set to 85, resulting in an
C              approximation to the linear interpolant of
C              the endpoint values.
C
C STRIPACK module required by CSSIG0:  CSSTORE
C
C SSRFPACK modules required by CSSIG0:  CSARCLEN, CSSNHCSH
C
C Intrinsic functions called by CSSIG0:  ABS, EXP, LOG, MAX,
C                                        MIN, DBLE, SIGN,
C                                        SQRT
C
C***********************************************************
C
      DOUBLE PRECISION CSARCLEN, CSSTORE
      INTEGER LP1, LP2, LPL, LUN, NIT
      DOUBLE PRECISION A, A0, AA, AL, B, B0, BND, C, C1, C2,
     .                 COSHM, COSHMM, D, D0, D1PD2, D2,
     .                 DMAX, DSIG, E, EMS, F, F0, FMAX,
     .                 FNEG, FTOL, H1, H2, P1(3), P2(3), R,
     .                 RF, RSIG, RTOL, S, S1, S2, SBIG, SCM,
     .                 SIG, SINHM, SNEG, SSINH, SSM, STOL,
     .                 T, T0, T1, T2, TM, UN(3), UNORM
C
      DATA SBIG/85./,  LUN/-1/
      RF = DBLE(IFLGB)
      BND = HBND
C
C Print a heading.
C
      IF (LUN .GE. 0  .AND.  RF .LT. 0.) WRITE (LUN,100) N1,
     .                                   N2, BND
      IF (LUN .GE. 0  .AND.  RF .GT. 0.) WRITE (LUN,110) N1,
     .                                   N2, BND
  100 FORMAT (//1X,'CSSIG0 -- N1 =',I4,', N2 =',I4,
     .        ', LOWER BOUND = ',E15.8)
  110 FORMAT (//1X,'CSSIG0 -- N1 =',I4,', N2 =',I4,
     .        ', UPPER BOUND = ',E15.8)
C
C Test for errors and store local parameters.
C
      IER = -1
      IF (MIN(N1,N2) .LT. 1  .OR.  N1 .EQ. N2  .OR.
     .    MAX(N1,N2,3) .GT. N  .OR.  ABS(RF) .NE. 1.)
     .   GO TO 11
      IER = -2
      IF (IFLGS .GT. 0) THEN
C
C   Set LP1 and LP2 to the pointers to N2 as a neighbor of
C     N1 and N1 as a neighbor of N2, respectively.
C
        LPL = LEND(N1)
        LP1 = LPTR(LPL)
    1   IF (LIST(LP1) .EQ. N2) GO TO 2
          LP1 = LPTR(LP1)
          IF (LP1 .NE. LPL) GO TO 1
        IF (ABS(LIST(LP1)) .NE. N2) GO TO 11
C
    2   LPL = LEND(N2)
        LP2 = LPTR(LPL)
    3   IF (LIST(LP2) .EQ. N1) GO TO 4
          LP2 = LPTR(LP2)
          IF (LP2 .NE. LPL) GO TO 3
        IF (ABS(LIST(LP2)) .NE. N1) GO TO 11
      ENDIF
C
C Store nodal coordinates P1 and P2, compute arc-length AL
C   and unit normal UN = (P1 X P2)/UNORM, and test for
C   coincident nodes.
C
    4 P1(1) = X(N1)
      P1(2) = Y(N1)
      P1(3) = Z(N1)
      P2(1) = X(N2)
      P2(2) = Y(N2)
      P2(3) = Z(N2)
      AL = CSARCLEN(P1,P2)
      UN(1) = P1(2)*P2(3) - P1(3)*P2(2)
      UN(2) = P1(3)*P2(1) - P1(1)*P2(3)
      UN(3) = P1(1)*P2(2) - P1(2)*P2(1)
      UNORM = SQRT(UN(1)*UN(1) + UN(2)*UN(2) + UN(3)*UN(3))
      IF (UNORM .EQ. 0.  .OR.  AL .EQ. 0.) GO TO 11
C
C Store endpoint data values and test for valid constraint.
C
      H1 = H(N1)
      H2 = H(N2)
      IER = -3
      IF ((RF .LT. 0.  .AND.  MIN(H1,H2) .LT. BND)  .OR.
     .    (RF .GT. 0.  .AND.  BND .LT. MAX(H1,H2)))
     .   GO TO 11
C
C Compute scaled directional derivatives S1,S2 at the end-
C   points (for the direction N1->N2) and test for infinite
C   tension required.
C
      S1 = AL*(GRAD(1,N1)*P2(1) + GRAD(2,N1)*P2(2) +
     .         GRAD(3,N1)*P2(3))/UNORM
      S2 = -AL*(GRAD(1,N2)*P1(1) + GRAD(2,N2)*P1(2) +
     .          GRAD(3,N2)*P1(3))/UNORM
      IER = 1
      SIG = SBIG
      IF ((H1 .EQ. BND  .AND.  RF*S1 .GT. 0.)  .OR.
     .    (H2 .EQ. BND  .AND.  RF*S2 .LT. 0.)) GO TO 10
C
C Test for SIG = 0 sufficient.
C
      IER = 0
      SIG = 0.
      IF (RF*S1 .LE. 0.  .AND.  RF*S2 .GE. 0.) GO TO 10
C
C   Compute first difference S and coefficients A0 and B0
C     of the Hermite cubic interpolant H0(A) = H2 - (S2*R +
C     B0*R**2 + (A0/3)*R**3), where R(A) = (A2-A)/AL.
C
      S = H2 - H1
      T0 = 3.*S - S1 - S2
      A0 = 3.*(S-T0)
      B0 = T0 - S2
      D0 = T0*T0 - S1*S2
C
C   H0 has local extrema in (A1,A2) iff S1*S2 < 0 or
C     (T0*(S1+S2) < 0 and D0 .GE. 0).
C
      IF (S1*S2 .GE. 0.  .AND.  (T0*(S1+S2) .GE. 0.  .OR.
     .    D0 .LT. 0.)) GO TO 10
      IF (A0 .EQ. 0.) THEN
C
C   H0 is quadratic and has an extremum at R = -S2/(2*B0).
C     H0(R) = H2 + S2**2/(4*B0).  Note that A0 = 0 implies
C     2*B0 = S1-S2, and S1*S2 < 0 implies B0 .NE. 0.
C     Also, the extremum is a min iff HBND is a lower bound.
C
        F0 = (BND - H2 - S2*S2/(4.*B0))*RF
      ELSE
C
C   A0 .NE. 0 and H0 has extrema at R = (-B0 +/- SQRT(D0))/
C     A0 = S2/(-B0 -/+ SQRT(D0)), where the negative root
C     corresponds to a min.  The expression for R is chosen
C     to avoid cancellation error.  H0(R) = H2 + (S2*B0 +
C     2*D0*R)/(3*A0).
C
        T = -B0 - SIGN(SQRT(D0),B0)
        R = T/A0
        IF (RF*B0 .GT. 0.) R = S2/T
        F0 = (BND - H2 - (S2*B0+2.*D0*R)/(3.*A0))*RF
      ENDIF
C
C   F0 .GE. 0 iff SIG = 0 is sufficient to satisfy the
C     constraint.
C
      IF (F0 .GE. 0.) GO TO 10
C
C Find a zero of F(SIG) = (BND-H(R))*RF where the derivative
C   of H, HP, vanishes at R.  F is a nondecreasing function,
C   F(0) < 0, and F = FMAX for SIG sufficiently large.
C
C Initialize parameters for the secant method.  The method
C   uses three points:  (SG0,F0), (SIG,F), and (SNEG,FNEG),
C   where SG0 and SNEG are defined implicitly by DSIG = SIG
C   - SG0 and DMAX = SIG - SNEG.  SG0 is initially zero and
C   SNEG is initialized to a sufficiently large value that
C   FNEG > 0.  This value is used only if the initial value
C   of F is negative.
C
      FMAX = MAX(1.D-3,MIN(ABS(H1-BND),ABS(H2-BND)))
      T = MAX(ABS(H1-BND),ABS(H2-BND))
      SIG = MAX(ABS(S1),ABS(S2))/T
      DMAX = SIG*(1.-T/FMAX)
      SNEG = SIG - DMAX
      IF (LUN .GE. 0) WRITE (LUN,120) SIG, SNEG, F0, FMAX
  120 FORMAT (1X,8X,'SIG = ',E15.8,', SNEG = ',E15.8/
     .        1X,9X,'F0 = ',E15.8,', FMAX = ',E15.8/)
      DSIG = SIG
      FNEG = FMAX
      D2 = S2 - S
      D1PD2 = S2 - S1
      NIT = 0
C
C Compute an absolute tolerance FTOL = abs(TOL) and a
C   relative tolerance RTOL = 100*Macheps.
C
      FTOL = ABS(TOL)
      RTOL = 1.
    5 RTOL = RTOL/2.
        IF (CSSTORE(RTOL+1.) .GT. 1.) GO TO 5
      RTOL = RTOL*200.
C
C Top of loop:  compute F.
C
    6 EMS = EXP(-SIG)
      IF (SIG .LE. .5) THEN
C
C   Use approximations designed to avoid cancellation error
C     (associated with small SIG) in the modified hyperbolic
C     functions.
C
        CALL CSSNHCSH (SIG, SINHM,COSHM,COSHMM)
        C1 = SIG*COSHM*D2 - SINHM*D1PD2
        C2 = SIG*(SINHM+SIG)*D2 - COSHM*D1PD2
        A = C2 - C1
        AA = A/EMS
        E = SIG*SINHM - COSHMM - COSHMM
      ELSE
C
C   Scale SINHM and COSHM by 2*exp(-SIG) in order to avoid
C     overflow.
C
        TM = 1. - EMS
        SSINH = TM*(1.+EMS)
        SSM = SSINH - 2.*SIG*EMS
        SCM = TM*TM
        C1 = SIG*SCM*D2 - SSM*D1PD2
        C2 = SIG*SSINH*D2 - SCM*D1PD2
        AA = 2.*(SIG*TM*D2 + (TM-SIG)*D1PD2)
        A = EMS*AA
        E = SIG*SSINH - SCM - SCM
      ENDIF
C
C   HP(R) = (S2 - (C1*sinh(SIG*R) - C2*coshm(SIG*R))/E)/DT
C     = 0 for ESR = (-B +/- sqrt(D))/A = C/(-B -/+ sqrt(D))
C     where ESR = exp(SIG*R), A = C2-C1, D = B**2 - A*C, and
C     B and C are defined below.
C
      B = E*S2 - C2
      C = C2 + C1
      D = B*B - A*C
      F = 0.
      IF (AA*C .EQ. 0.  .AND.  B .EQ. 0.) GO TO 7
      F = FMAX
      IF (D .LT. 0.) GO TO 7
      T1 = SQRT(D)
      T = -B - SIGN(T1,B)
      RSIG = 0.
      IF (RF*B .LT. 0.  .AND.  AA .NE. 0.) THEN
        IF (T/AA .GT. 0.) RSIG = SIG + LOG(T/AA)
      ENDIF
      IF ((RF*B .GT. 0.  .OR.  AA .EQ. 0.)  .AND.
     .    C/T .GT. 0.) RSIG = LOG(C/T)
      IF ((RSIG .LE. 0.  .OR.  RSIG .GE. SIG)  .AND.
     .    B .NE. 0.) GO TO 7
C
C   H(R) = H2 - (B*SIG*R + C1 + RF*sqrt(D))/(SIG*E).
C
      F = (BND - H2 + (B*RSIG+C1+RF*T1)/(SIG*E))*RF
C
C   Update the number of iterations NIT.
C
    7 NIT = NIT + 1
      IF (LUN .GE. 0) WRITE (LUN,130) NIT, SIG, F
  130 FORMAT (1X,3X,I2,' -- SIG = ',E15.8,', F = ',
     .        E15.8)
      IF (F0*F .LT. 0.) THEN
C
C   F0*F < 0.  Update (SNEG,FNEG) to (SG0,F0) so that F and
C     FNEG always have opposite signs.  If SIG is closer to
C     SNEG than SG0, then swap (SNEG,FNEG) with (SG0,F0).
C
        T1 = DMAX
        T2 = FNEG
        DMAX = DSIG
        FNEG = F0
        IF (ABS(DSIG) .GT. ABS(T1)) THEN
C
          DSIG = T1
          F0 = T2
        ENDIF
      ENDIF
C
C   Test for convergence.
C
      STOL = RTOL*SIG
      IF (ABS(DMAX) .LE. STOL  .OR.  (F .GE. 0.  .AND.
     .    F .LE. FTOL)  .OR.  ABS(F) .LE. RTOL) GO TO 10
C
C   Test for F0 = F = FMAX or F < 0 on the first iteration.
C
      IF (F0 .NE. F  .AND.  (NIT .GT. 1  .OR.  F .GT. 0.))
     .   GO TO 9
C
C   F*F0 > 0 and either the new estimate would be outside
C     of the bracketing interval of length abs(DMAX) or
C     F < 0 on the first iteration.  Reset (SG0,F0) to
C     (SNEG,FNEG).
C
    8 DSIG = DMAX
      F0 = FNEG
C
C   Compute the change in SIG by linear interpolation
C     between (SG0,F0) and (SIG,F).
C
    9 DSIG = -F*DSIG/(F-F0)
      IF (LUN .GE. 0) WRITE (LUN,140) DSIG
  140 FORMAT (1X,8X,'DSIG = ',E15.8)
      IF ( ABS(DSIG) .GT. ABS(DMAX)  .OR.
     .     DSIG*DMAX .GT. 0. ) GO TO 8
C
C   Restrict the step-size such that abs(DSIG) .GE. STOL/2.
C     Note that DSIG and DMAX have opposite signs.
C
      IF (ABS(DSIG) .LT. STOL/2.) DSIG = -SIGN(STOL/2.,DMAX)
C
C   Bottom of loop:  Update SIG, DMAX, and F0.
C
      SIG = SIG + DSIG
      DMAX = DMAX + DSIG
      F0 = F
      GO TO 6
C
C No errors encountered.
C
   10 CSSIG0 = SIG
      IF (IFLGS .LE. 0) RETURN
      SIGMA(LP1) = SIG
      SIGMA(LP2) = SIG
      RETURN
C
C Error termination.
C
   11 CSSIG0 = -1.
      RETURN
      END

      SUBROUTINE DSBGV( JOBZ, UPLO, N, KA, KB, AB, LDAB, BB, LDBB, W, Z,
     $                  LDZ, WORK, INFO )
*
*  -- LAPACK driver routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER          JOBZ, UPLO
      INTEGER            INFO, KA, KB, LDAB, LDBB, LDZ, N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   AB( LDAB, * ), BB( LDBB, * ), W( * ),
     $                   WORK( * ), Z( LDZ, * )
*     ..
*
*  Purpose
*  =======
*
*  DSBGV computes all the eigenvalues, and optionally, the eigenvectors
*  of a real generalized symmetric-definite banded eigenproblem, of
*  the form A*x=(lambda)*B*x. Here A and B are assumed to be symmetric
*  and banded, and B is also positive definite.
*
*  Arguments
*  =========
*
*  JOBZ    (input) CHARACTER*1
*          = 'N':  Compute eigenvalues only;
*          = 'V':  Compute eigenvalues and eigenvectors.
*
*  UPLO    (input) CHARACTER*1
*          = 'U':  Upper triangles of A and B are stored;
*          = 'L':  Lower triangles of A and B are stored.
*
*  N       (input) INTEGER
*          The order of the matrices A and B.  N >= 0.
*
*  KA      (input) INTEGER
*          The number of superdiagonals of the matrix A if UPLO = 'U',
*          or the number of subdiagonals if UPLO = 'L'. KA >= 0.
*
*  KB      (input) INTEGER
*          The number of superdiagonals of the matrix B if UPLO = 'U',
*          or the number of subdiagonals if UPLO = 'L'. KB >= 0.
*
*  AB      (input/output) DOUBLE PRECISION array, dimension (LDAB, N)
*          On entry, the upper or lower triangle of the symmetric band
*          matrix A, stored in the first ka+1 rows of the array.  The
*          j-th column of A is stored in the j-th column of the array AB
*          as follows:
*          if UPLO = 'U', AB(ka+1+i-j,j) = A(i,j) for max(1,j-ka)<=i<=j;
*          if UPLO = 'L', AB(1+i-j,j)    = A(i,j) for j<=i<=min(n,j+ka).
*
*          On exit, the contents of AB are destroyed.
*
*  LDAB    (input) INTEGER
*          The leading dimension of the array AB.  LDAB >= KA+1.
*
*  BB      (input/output) DOUBLE PRECISION array, dimension (LDBB, N)
*          On entry, the upper or lower triangle of the symmetric band
*          matrix B, stored in the first kb+1 rows of the array.  The
*          j-th column of B is stored in the j-th column of the array BB
*          as follows:
*          if UPLO = 'U', BB(kb+1+i-j,j) = B(i,j) for max(1,j-kb)<=i<=j;
*          if UPLO = 'L', BB(1+i-j,j)    = B(i,j) for j<=i<=min(n,j+kb).
*
*          On exit, the factor S from the split Cholesky factorization
*          B = S**T*S, as returned by DPBSTF.
*
*  LDBB    (input) INTEGER
*          The leading dimension of the array BB.  LDBB >= KB+1.
*
*  W       (output) DOUBLE PRECISION array, dimension (N)
*          If INFO = 0, the eigenvalues in ascending order.
*
*  Z       (output) DOUBLE PRECISION array, dimension (LDZ, N)
*          If JOBZ = 'V', then if INFO = 0, Z contains the matrix Z of
*          eigenvectors, with the i-th column of Z holding the
*          eigenvector associated with W(i). The eigenvectors are
*          normalized so that Z**T*B*Z = I.
*          If JOBZ = 'N', then Z is not referenced.
*
*  LDZ     (input) INTEGER
*          The leading dimension of the array Z.  LDZ >= 1, and if
*          JOBZ = 'V', LDZ >= N.
*
*  WORK    (workspace) DOUBLE PRECISION array, dimension (3*N)
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*          > 0:  if INFO = i, and i is:
*             <= N:  the algorithm failed to converge:
*                    i off-diagonal elements of an intermediate
*                    tridiagonal form did not converge to zero;
*             > N:   if INFO = N + i, for 1 <= i <= N, then DPBSTF
*                    returned INFO = i: B is not positive definite.
*                    The factorization of B could not be completed and
*                    no eigenvalues or eigenvectors were computed.
*
*  =====================================================================
*
*     .. Local Scalars ..
      LOGICAL            UPPER, WANTZ
      CHARACTER          VECT
      INTEGER            IINFO, INDE, INDWRK
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           DPBSTF, DSBGST, DSBTRD, DSTEQR, DSTERF, XERBLA
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      WANTZ = LSAME( JOBZ, 'V' )
      UPPER = LSAME( UPLO, 'U' )
*
      INFO = 0
      IF( .NOT.( WANTZ .OR. LSAME( JOBZ, 'N' ) ) ) THEN
         INFO = -1
      ELSE IF( .NOT.( UPPER .OR. LSAME( UPLO, 'L' ) ) ) THEN
         INFO = -2
      ELSE IF( N.LT.0 ) THEN
         INFO = -3
      ELSE IF( KA.LT.0 ) THEN
         INFO = -4
      ELSE IF( KB.LT.0 .OR. KB.GT.KA ) THEN
         INFO = -5
      ELSE IF( LDAB.LT.KA+1 ) THEN
         INFO = -7
      ELSE IF( LDBB.LT.KB+1 ) THEN
         INFO = -9
      ELSE IF( LDZ.LT.1 .OR. ( WANTZ .AND. LDZ.LT.N ) ) THEN
         INFO = -12
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DSBGV ', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
*
*     Form a split Cholesky factorization of B.
*
      CALL DPBSTF( UPLO, N, KB, BB, LDBB, INFO )
      IF( INFO.NE.0 ) THEN
         INFO = N + INFO
         RETURN
      END IF
*
*     Transform problem to standard eigenvalue problem.
*
      INDE = 1
      INDWRK = INDE + N
      CALL DSBGST( JOBZ, UPLO, N, KA, KB, AB, LDAB, BB, LDBB, Z, LDZ,
     $             WORK( INDWRK ), IINFO )
*
*     Reduce to tridiagonal form.
*
      IF( WANTZ ) THEN
         VECT = 'U'
      ELSE
         VECT = 'N'
      END IF
      CALL DSBTRD( VECT, UPLO, N, KA, AB, LDAB, W, WORK( INDE ), Z, LDZ,
     $             WORK( INDWRK ), IINFO )
*
*     For eigenvalues only, call DSTERF.  For eigenvectors, call SSTEQR.
*
      IF( .NOT.WANTZ ) THEN
         CALL DSTERF( N, W, WORK( INDE ), INFO )
      ELSE
         CALL DSTEQR( JOBZ, N, W, WORK( INDE ), Z, LDZ, WORK( INDWRK ),
     $                INFO )
      END IF
      RETURN
*
*     End of DSBGV
*
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C   FFTPACK 5.0
C   Copyright (C) 1995-2004, Scientific Computing Division,
C   University Corporation for Atmospheric Research
C   Licensed under the GNU General Public License (GPL)
C
C   Authors:  Paul N. Swarztrauber and Richard A. Valent
C
C   $Id: sintb1.f,v 1.2 2006-11-21 01:10:20 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      SUBROUTINE DSINTB1(N,INC,X,WSAVE,XH,WORK,IER)
      DOUBLE PRECISION WORK
      DOUBLE PRECISION SRT3S2
      DOUBLE PRECISION XHOLD
      DOUBLE PRECISION T1
      DOUBLE PRECISION T2
      DOUBLE PRECISION FNP1S4
      DOUBLE PRECISION X(INC,*),WSAVE(*),XH(*)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION DSUM

      IER = 0
      IF (N-2) 200,102,103
  102 SRT3S2 = SQRT(3.D0)/2.D0
      XHOLD = SRT3S2* (X(1,1)+X(1,2))
      X(1,2) = SRT3S2* (X(1,1)-X(1,2))
      X(1,1) = XHOLD
      GO TO 200
  103 NP1 = N + 1
      NS2 = N/2
      DO 104 K = 1,NS2
          KC = NP1 - K
          T1 = X(1,K) - X(1,KC)
          T2 = WSAVE(K)* (X(1,K)+X(1,KC))
          XH(K+1) = T1 + T2
          XH(KC+1) = T2 - T1
  104 CONTINUE
      MODN = MOD(N,2)
      IF (MODN.EQ.0) GO TO 124
      XH(NS2+2) = 4.D0*X(1,NS2+1)
  124 XH(1) = 0.D0
      LNXH = NP1
      LNSV = NP1 + INT(LOG(DBLE(NP1))) + 4
      LNWK = NP1
C
      CALL DRFFT1F(NP1,1,XH,LNXH,WSAVE(NS2+1),LNSV,WORK,LNWK,IER1)
      IF (IER1.NE.0) THEN
          IER = 20
          CALL DXERFFT('SINTB1',-5)
          GO TO 200
      END IF
C
      IF (MOD(NP1,2).NE.0) GO TO 30
      XH(NP1) = XH(NP1) + XH(NP1)
   30 FNP1S4 = DBLE(NP1)/4.D0
      X(1,1) = FNP1S4*XH(1)
      DSUM = X(1,1)
      DO 105 I = 3,N,2
          X(1,I-1) = FNP1S4*XH(I)
          DSUM = DSUM + FNP1S4*XH(I-1)
          X(1,I) = DSUM
  105 CONTINUE
      IF (MODN.NE.0) GO TO 200
      X(1,N) = FNP1S4*XH(N+1)
C
  200 CONTINUE
      RETURN
      END

      SUBROUTINE ZLALSD( UPLO, SMLSIZ, N, NRHS, D, E, B, LDB, RCOND,
     $                   RANK, WORK, RWORK, IWORK, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     October 31, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          UPLO
      INTEGER            INFO, LDB, N, NRHS, RANK, SMLSIZ
      DOUBLE PRECISION   RCOND
*     ..
*     .. Array Arguments ..
      INTEGER            IWORK( * )
      DOUBLE PRECISION   D( * ), E( * ), RWORK( * )
      COMPLEX*16         B( LDB, * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  ZLALSD uses the singular value decomposition of A to solve the least
*  squares problem of finding X to minimize the Euclidean norm of each
*  column of A*X-B, where A is N-by-N upper bidiagonal, and X and B
*  are N-by-NRHS. The solution X overwrites B.
*
*  The singular values of A smaller than RCOND times the largest
*  singular value are treated as zero in solving the least squares
*  problem; in this case a minimum norm solution is returned.
*  The actual singular values are returned in D in ascending order.
*
*  This code makes very mild assumptions about floating point
*  arithmetic. It will work on machines with a guard digit in
*  add/subtract, or on those binary machines without guard digits
*  which subtract like the Cray XMP, Cray YMP, Cray C 90, or Cray 2.
*  It could conceivably fail on hexadecimal or decimal machines
*  without guard digits, but we know of none.
*
*  Arguments
*  =========
*
*  UPLO   (input) CHARACTER*1
*         = 'U': D and E define an upper bidiagonal matrix.
*         = 'L': D and E define a  lower bidiagonal matrix.
*
*  SMLSIZ (input) INTEGER
*         The maximum size of the subproblems at the bottom of the
*         computation tree.
*
*  N      (input) INTEGER
*         The dimension of the  bidiagonal matrix.  N >= 0.
*
*  NRHS   (input) INTEGER
*         The number of columns of B. NRHS must be at least 1.
*
*  D      (input/output) DOUBLE PRECISION array, dimension (N)
*         On entry D contains the main diagonal of the bidiagonal
*         matrix. On exit, if INFO = 0, D contains its singular values.
*
*  E      (input) DOUBLE PRECISION array, dimension (N-1)
*         Contains the super-diagonal entries of the bidiagonal matrix.
*         On exit, E has been destroyed.
*
*  B      (input/output) COMPLEX*16 array, dimension (LDB,NRHS)
*         On input, B contains the right hand sides of the least
*         squares problem. On output, B contains the solution X.
*
*  LDB    (input) INTEGER
*         The leading dimension of B in the calling subprogram.
*         LDB must be at least max(1,N).
*
*  RCOND  (input) DOUBLE PRECISION
*         The singular values of A less than or equal to RCOND times
*         the largest singular value are treated as zero in solving
*         the least squares problem. If RCOND is negative,
*         machine precision is used instead.
*         For example, if diag(S)*X=B were the least squares problem,
*         where diag(S) is a diagonal matrix of singular values, the
*         solution would be X(i) = B(i) / S(i) if S(i) is greater than
*         RCOND*max(S), and X(i) = 0 if S(i) is less than or equal to
*         RCOND*max(S).
*
*  RANK   (output) INTEGER
*         The number of singular values of A greater than RCOND times
*         the largest singular value.
*
*  WORK   (workspace) COMPLEX*16 array, dimension at least
*         (N * NRHS).
*
*  RWORK  (workspace) DOUBLE PRECISION array, dimension at least
*         (9*N + 2*N*SMLSIZ + 8*N*NLVL + 3*SMLSIZ*NRHS + (SMLSIZ+1)**2),
*         where
*         NLVL = MAX( 0, INT( LOG_2( MIN( M,N )/(SMLSIZ+1) ) ) + 1 )
*
*  IWORK  (workspace) INTEGER array, dimension at least
*         (3*N*NLVL + 11*N).
*
*  INFO   (output) INTEGER
*         = 0:  successful exit.
*         < 0:  if INFO = -i, the i-th argument had an illegal value.
*         > 0:  The algorithm failed to compute an singular value while
*               working on the submatrix lying in rows and columns
*               INFO/(N+1) through MOD(INFO,N+1).
*
*  Further Details
*  ===============
*
*  Based on contributions by
*     Ming Gu and Ren-Cang Li, Computer Science Division, University of
*       California at Berkeley, USA
*     Osni Marques, LBNL/NERSC, USA
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO, ONE, TWO
      PARAMETER          ( ZERO = 0.0D0, ONE = 1.0D0, TWO = 2.0D0 )
      COMPLEX*16         CZERO
      PARAMETER          ( CZERO = ( 0.0D0, 0.0D0 ) )
*     ..
*     .. Local Scalars ..
      INTEGER            BX, BXST, C, DIFL, DIFR, GIVCOL, GIVNUM,
     $                   GIVPTR, I, ICMPQ1, ICMPQ2, IRWB, IRWIB, IRWRB,
     $                   IRWU, IRWVT, IRWWRK, IWK, J, JCOL, JIMAG,
     $                   JREAL, JROW, K, NLVL, NM1, NRWORK, NSIZE, NSUB,
     $                   PERM, POLES, S, SIZEI, SMLSZP, SQRE, ST, ST1,
     $                   U, VT, Z
      DOUBLE PRECISION   CS, EPS, ORGNRM, R, SN, TOL
*     ..
*     .. External Functions ..
      INTEGER            IDAMAX
      DOUBLE PRECISION   DLAMCH, DLANST
      EXTERNAL           IDAMAX, DLAMCH, DLANST
*     ..
*     .. External Subroutines ..
      EXTERNAL           DGEMM, DLARTG, DLASCL, DLASDA, DLASDQ, DLASET,
     $                   DLASRT, XERBLA, ZCOPY, ZDROT, ZLACPY, ZLALSA,
     $                   ZLASCL, ZLASET
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, DBLE, DCMPLX, DIMAG, INT, LOG, SIGN
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
*
      IF( N.LT.0 ) THEN
         INFO = -3
      ELSE IF( NRHS.LT.1 ) THEN
         INFO = -4
      ELSE IF( ( LDB.LT.1 ) .OR. ( LDB.LT.N ) ) THEN
         INFO = -8
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'ZLALSD', -INFO )
         RETURN
      END IF
*
      EPS = DLAMCH( 'Epsilon' )
*
*     Set up the tolerance.
*
      IF( ( RCOND.LE.ZERO ) .OR. ( RCOND.GE.ONE ) ) THEN
         RCOND = EPS
      END IF
*
      RANK = 0
*
*     Quick return if possible.
*
      IF( N.EQ.0 ) THEN
         RETURN
      ELSE IF( N.EQ.1 ) THEN
         IF( D( 1 ).EQ.ZERO ) THEN
            CALL ZLASET( 'A', 1, NRHS, CZERO, CZERO, B, LDB )
         ELSE
            RANK = 1
            CALL ZLASCL( 'G', 0, 0, D( 1 ), ONE, 1, NRHS, B, LDB, INFO )
            D( 1 ) = ABS( D( 1 ) )
         END IF
         RETURN
      END IF
*
*     Rotate the matrix if it is lower bidiagonal.
*
      IF( UPLO.EQ.'L' ) THEN
         DO 10 I = 1, N - 1
            CALL DLARTG( D( I ), E( I ), CS, SN, R )
            D( I ) = R
            E( I ) = SN*D( I+1 )
            D( I+1 ) = CS*D( I+1 )
            IF( NRHS.EQ.1 ) THEN
               CALL ZDROT( 1, B( I, 1 ), 1, B( I+1, 1 ), 1, CS, SN )
            ELSE
               RWORK( I*2-1 ) = CS
               RWORK( I*2 ) = SN
            END IF
   10    CONTINUE
         IF( NRHS.GT.1 ) THEN
            DO 30 I = 1, NRHS
               DO 20 J = 1, N - 1
                  CS = RWORK( J*2-1 )
                  SN = RWORK( J*2 )
                  CALL ZDROT( 1, B( J, I ), 1, B( J+1, I ), 1, CS, SN )
   20          CONTINUE
   30       CONTINUE
         END IF
      END IF
*
*     Scale.
*
      NM1 = N - 1
      ORGNRM = DLANST( 'M', N, D, E )
      IF( ORGNRM.EQ.ZERO ) THEN
         CALL ZLASET( 'A', N, NRHS, CZERO, CZERO, B, LDB )
         RETURN
      END IF
*
      CALL DLASCL( 'G', 0, 0, ORGNRM, ONE, N, 1, D, N, INFO )
      CALL DLASCL( 'G', 0, 0, ORGNRM, ONE, NM1, 1, E, NM1, INFO )
*
*     If N is smaller than the minimum divide size SMLSIZ, then solve
*     the problem with another solver.
*
      IF( N.LE.SMLSIZ ) THEN
         IRWU = 1
         IRWVT = IRWU + N*N
         IRWWRK = IRWVT + N*N
         IRWRB = IRWWRK
         IRWIB = IRWRB + N*NRHS
         IRWB = IRWIB + N*NRHS
         CALL DLASET( 'A', N, N, ZERO, ONE, RWORK( IRWU ), N )
         CALL DLASET( 'A', N, N, ZERO, ONE, RWORK( IRWVT ), N )
         CALL DLASDQ( 'U', 0, N, N, N, 0, D, E, RWORK( IRWVT ), N,
     $                RWORK( IRWU ), N, RWORK( IRWWRK ), 1,
     $                RWORK( IRWWRK ), INFO )
         IF( INFO.NE.0 ) THEN
            RETURN
         END IF
*
*        In the real version, B is passed to DLASDQ and multiplied
*        internally by Q'. Here B is complex and that product is
*        computed below in two steps (real and imaginary parts).
*
         J = IRWB - 1
         DO 50 JCOL = 1, NRHS
            DO 40 JROW = 1, N
               J = J + 1
               RWORK( J ) = DBLE( B( JROW, JCOL ) )
   40       CONTINUE
   50    CONTINUE
         CALL DGEMM( 'T', 'N', N, NRHS, N, ONE, RWORK( IRWU ), N,
     $               RWORK( IRWB ), N, ZERO, RWORK( IRWRB ), N )
         J = IRWB - 1
         DO 70 JCOL = 1, NRHS
            DO 60 JROW = 1, N
               J = J + 1
               RWORK( J ) = DIMAG( B( JROW, JCOL ) )
   60       CONTINUE
   70    CONTINUE
         CALL DGEMM( 'T', 'N', N, NRHS, N, ONE, RWORK( IRWU ), N,
     $               RWORK( IRWB ), N, ZERO, RWORK( IRWIB ), N )
         JREAL = IRWRB - 1
         JIMAG = IRWIB - 1
         DO 90 JCOL = 1, NRHS
            DO 80 JROW = 1, N
               JREAL = JREAL + 1
               JIMAG = JIMAG + 1
               B( JROW, JCOL ) = DCMPLX( RWORK( JREAL ),
     $                           RWORK( JIMAG ) )
   80       CONTINUE
   90    CONTINUE
*
         TOL = RCOND*ABS( D( IDAMAX( N, D, 1 ) ) )
         DO 100 I = 1, N
            IF( D( I ).LE.TOL ) THEN
               CALL ZLASET( 'A', 1, NRHS, CZERO, CZERO, B( I, 1 ), LDB )
            ELSE
               CALL ZLASCL( 'G', 0, 0, D( I ), ONE, 1, NRHS, B( I, 1 ),
     $                      LDB, INFO )
               RANK = RANK + 1
            END IF
  100    CONTINUE
*
*        Since B is complex, the following call to DGEMM is performed
*        in two steps (real and imaginary parts). That is for V * B
*        (in the real version of the code V' is stored in WORK).
*
*        CALL DGEMM( 'T', 'N', N, NRHS, N, ONE, WORK, N, B, LDB, ZERO,
*    $               WORK( NWORK ), N )
*
         J = IRWB - 1
         DO 120 JCOL = 1, NRHS
            DO 110 JROW = 1, N
               J = J + 1
               RWORK( J ) = DBLE( B( JROW, JCOL ) )
  110       CONTINUE
  120    CONTINUE
         CALL DGEMM( 'T', 'N', N, NRHS, N, ONE, RWORK( IRWVT ), N,
     $               RWORK( IRWB ), N, ZERO, RWORK( IRWRB ), N )
         J = IRWB - 1
         DO 140 JCOL = 1, NRHS
            DO 130 JROW = 1, N
               J = J + 1
               RWORK( J ) = DIMAG( B( JROW, JCOL ) )
  130       CONTINUE
  140    CONTINUE
         CALL DGEMM( 'T', 'N', N, NRHS, N, ONE, RWORK( IRWVT ), N,
     $               RWORK( IRWB ), N, ZERO, RWORK( IRWIB ), N )
         JREAL = IRWRB - 1
         JIMAG = IRWIB - 1
         DO 160 JCOL = 1, NRHS
            DO 150 JROW = 1, N
               JREAL = JREAL + 1
               JIMAG = JIMAG + 1
               B( JROW, JCOL ) = DCMPLX( RWORK( JREAL ),
     $                           RWORK( JIMAG ) )
  150       CONTINUE
  160    CONTINUE
*
*        Unscale.
*
         CALL DLASCL( 'G', 0, 0, ONE, ORGNRM, N, 1, D, N, INFO )
         CALL DLASRT( 'D', N, D, INFO )
         CALL ZLASCL( 'G', 0, 0, ORGNRM, ONE, N, NRHS, B, LDB, INFO )
*
         RETURN
      END IF
*
*     Book-keeping and setting up some constants.
*
      NLVL = INT( LOG( DBLE( N ) / DBLE( SMLSIZ+1 ) ) / LOG( TWO ) ) + 1
*
      SMLSZP = SMLSIZ + 1
*
      U = 1
      VT = 1 + SMLSIZ*N
      DIFL = VT + SMLSZP*N
      DIFR = DIFL + NLVL*N
      Z = DIFR + NLVL*N*2
      C = Z + NLVL*N
      S = C + N
      POLES = S + N
      GIVNUM = POLES + 2*NLVL*N
      NRWORK = GIVNUM + 2*NLVL*N
      BX = 1
*
      IRWRB = NRWORK
      IRWIB = IRWRB + SMLSIZ*NRHS
      IRWB = IRWIB + SMLSIZ*NRHS
*
      SIZEI = 1 + N
      K = SIZEI + N
      GIVPTR = K + N
      PERM = GIVPTR + N
      GIVCOL = PERM + NLVL*N
      IWK = GIVCOL + NLVL*N*2
*
      ST = 1
      SQRE = 0
      ICMPQ1 = 1
      ICMPQ2 = 0
      NSUB = 0
*
      DO 170 I = 1, N
         IF( ABS( D( I ) ).LT.EPS ) THEN
            D( I ) = SIGN( EPS, D( I ) )
         END IF
  170 CONTINUE
*
      DO 240 I = 1, NM1
         IF( ( ABS( E( I ) ).LT.EPS ) .OR. ( I.EQ.NM1 ) ) THEN
            NSUB = NSUB + 1
            IWORK( NSUB ) = ST
*
*           Subproblem found. First determine its size and then
*           apply divide and conquer on it.
*
            IF( I.LT.NM1 ) THEN
*
*              A subproblem with E(I) small for I < NM1.
*
               NSIZE = I - ST + 1
               IWORK( SIZEI+NSUB-1 ) = NSIZE
            ELSE IF( ABS( E( I ) ).GE.EPS ) THEN
*
*              A subproblem with E(NM1) not too small but I = NM1.
*
               NSIZE = N - ST + 1
               IWORK( SIZEI+NSUB-1 ) = NSIZE
            ELSE
*
*              A subproblem with E(NM1) small. This implies an
*              1-by-1 subproblem at D(N), which is not solved
*              explicitly.
*
               NSIZE = I - ST + 1
               IWORK( SIZEI+NSUB-1 ) = NSIZE
               NSUB = NSUB + 1
               IWORK( NSUB ) = N
               IWORK( SIZEI+NSUB-1 ) = 1
               CALL ZCOPY( NRHS, B( N, 1 ), LDB, WORK( BX+NM1 ), N )
            END IF
            ST1 = ST - 1
            IF( NSIZE.EQ.1 ) THEN
*
*              This is a 1-by-1 subproblem and is not solved
*              explicitly.
*
               CALL ZCOPY( NRHS, B( ST, 1 ), LDB, WORK( BX+ST1 ), N )
            ELSE IF( NSIZE.LE.SMLSIZ ) THEN
*
*              This is a small subproblem and is solved by DLASDQ.
*
               CALL DLASET( 'A', NSIZE, NSIZE, ZERO, ONE,
     $                      RWORK( VT+ST1 ), N )
               CALL DLASET( 'A', NSIZE, NSIZE, ZERO, ONE,
     $                      RWORK( U+ST1 ), N )
               CALL DLASDQ( 'U', 0, NSIZE, NSIZE, NSIZE, 0, D( ST ),
     $                      E( ST ), RWORK( VT+ST1 ), N, RWORK( U+ST1 ),
     $                      N, RWORK( NRWORK ), 1, RWORK( NRWORK ),
     $                      INFO )
               IF( INFO.NE.0 ) THEN
                  RETURN
               END IF
*
*              In the real version, B is passed to DLASDQ and multiplied
*              internally by Q'. Here B is complex and that product is
*              computed below in two steps (real and imaginary parts).
*
               J = IRWB - 1
               DO 190 JCOL = 1, NRHS
                  DO 180 JROW = ST, ST + NSIZE - 1
                     J = J + 1
                     RWORK( J ) = DBLE( B( JROW, JCOL ) )
  180             CONTINUE
  190          CONTINUE
               CALL DGEMM( 'T', 'N', NSIZE, NRHS, NSIZE, ONE,
     $                     RWORK( U+ST1 ), N, RWORK( IRWB ), NSIZE,
     $                     ZERO, RWORK( IRWRB ), NSIZE )
               J = IRWB - 1
               DO 210 JCOL = 1, NRHS
                  DO 200 JROW = ST, ST + NSIZE - 1
                     J = J + 1
                     RWORK( J ) = DIMAG( B( JROW, JCOL ) )
  200             CONTINUE
  210          CONTINUE
               CALL DGEMM( 'T', 'N', NSIZE, NRHS, NSIZE, ONE,
     $                     RWORK( U+ST1 ), N, RWORK( IRWB ), NSIZE,
     $                     ZERO, RWORK( IRWIB ), NSIZE )
               JREAL = IRWRB - 1
               JIMAG = IRWIB - 1
               DO 230 JCOL = 1, NRHS
                  DO 220 JROW = ST, ST + NSIZE - 1
                     JREAL = JREAL + 1
                     JIMAG = JIMAG + 1
                     B( JROW, JCOL ) = DCMPLX( RWORK( JREAL ),
     $                                 RWORK( JIMAG ) )
  220             CONTINUE
  230          CONTINUE
*
               CALL ZLACPY( 'A', NSIZE, NRHS, B( ST, 1 ), LDB,
     $                      WORK( BX+ST1 ), N )
            ELSE
*
*              A large problem. Solve it using divide and conquer.
*
               CALL DLASDA( ICMPQ1, SMLSIZ, NSIZE, SQRE, D( ST ),
     $                      E( ST ), RWORK( U+ST1 ), N, RWORK( VT+ST1 ),
     $                      IWORK( K+ST1 ), RWORK( DIFL+ST1 ),
     $                      RWORK( DIFR+ST1 ), RWORK( Z+ST1 ),
     $                      RWORK( POLES+ST1 ), IWORK( GIVPTR+ST1 ),
     $                      IWORK( GIVCOL+ST1 ), N, IWORK( PERM+ST1 ),
     $                      RWORK( GIVNUM+ST1 ), RWORK( C+ST1 ),
     $                      RWORK( S+ST1 ), RWORK( NRWORK ),
     $                      IWORK( IWK ), INFO )
               IF( INFO.NE.0 ) THEN
                  RETURN
               END IF
               BXST = BX + ST1
               CALL ZLALSA( ICMPQ2, SMLSIZ, NSIZE, NRHS, B( ST, 1 ),
     $                      LDB, WORK( BXST ), N, RWORK( U+ST1 ), N,
     $                      RWORK( VT+ST1 ), IWORK( K+ST1 ),
     $                      RWORK( DIFL+ST1 ), RWORK( DIFR+ST1 ),
     $                      RWORK( Z+ST1 ), RWORK( POLES+ST1 ),
     $                      IWORK( GIVPTR+ST1 ), IWORK( GIVCOL+ST1 ), N,
     $                      IWORK( PERM+ST1 ), RWORK( GIVNUM+ST1 ),
     $                      RWORK( C+ST1 ), RWORK( S+ST1 ),
     $                      RWORK( NRWORK ), IWORK( IWK ), INFO )
               IF( INFO.NE.0 ) THEN
                  RETURN
               END IF
            END IF
            ST = I + 1
         END IF
  240 CONTINUE
*
*     Apply the singular values and treat the tiny ones as zero.
*
      TOL = RCOND*ABS( D( IDAMAX( N, D, 1 ) ) )
*
      DO 250 I = 1, N
*
*        Some of the elements in D can be negative because 1-by-1
*        subproblems were not solved explicitly.
*
         IF( ABS( D( I ) ).LE.TOL ) THEN
            CALL ZLASET( 'A', 1, NRHS, CZERO, CZERO, WORK( BX+I-1 ), N )
         ELSE
            RANK = RANK + 1
            CALL ZLASCL( 'G', 0, 0, D( I ), ONE, 1, NRHS,
     $                   WORK( BX+I-1 ), N, INFO )
         END IF
         D( I ) = ABS( D( I ) )
  250 CONTINUE
*
*     Now apply back the right singular vectors.
*
      ICMPQ2 = 1
      DO 320 I = 1, NSUB
         ST = IWORK( I )
         ST1 = ST - 1
         NSIZE = IWORK( SIZEI+I-1 )
         BXST = BX + ST1
         IF( NSIZE.EQ.1 ) THEN
            CALL ZCOPY( NRHS, WORK( BXST ), N, B( ST, 1 ), LDB )
         ELSE IF( NSIZE.LE.SMLSIZ ) THEN
*
*           Since B and BX are complex, the following call to DGEMM
*           is performed in two steps (real and imaginary parts).
*
*           CALL DGEMM( 'T', 'N', NSIZE, NRHS, NSIZE, ONE,
*    $                  RWORK( VT+ST1 ), N, RWORK( BXST ), N, ZERO,
*    $                  B( ST, 1 ), LDB )
*
            J = BXST - N - 1
            JREAL = IRWB - 1
            DO 270 JCOL = 1, NRHS
               J = J + N
               DO 260 JROW = 1, NSIZE
                  JREAL = JREAL + 1
                  RWORK( JREAL ) = DBLE( WORK( J+JROW ) )
  260          CONTINUE
  270       CONTINUE
            CALL DGEMM( 'T', 'N', NSIZE, NRHS, NSIZE, ONE,
     $                  RWORK( VT+ST1 ), N, RWORK( IRWB ), NSIZE, ZERO,
     $                  RWORK( IRWRB ), NSIZE )
            J = BXST - N - 1
            JIMAG = IRWB - 1
            DO 290 JCOL = 1, NRHS
               J = J + N
               DO 280 JROW = 1, NSIZE
                  JIMAG = JIMAG + 1
                  RWORK( JIMAG ) = DIMAG( WORK( J+JROW ) )
  280          CONTINUE
  290       CONTINUE
            CALL DGEMM( 'T', 'N', NSIZE, NRHS, NSIZE, ONE,
     $                  RWORK( VT+ST1 ), N, RWORK( IRWB ), NSIZE, ZERO,
     $                  RWORK( IRWIB ), NSIZE )
            JREAL = IRWRB - 1
            JIMAG = IRWIB - 1
            DO 310 JCOL = 1, NRHS
               DO 300 JROW = ST, ST + NSIZE - 1
                  JREAL = JREAL + 1
                  JIMAG = JIMAG + 1
                  B( JROW, JCOL ) = DCMPLX( RWORK( JREAL ),
     $                              RWORK( JIMAG ) )
  300          CONTINUE
  310       CONTINUE
         ELSE
            CALL ZLALSA( ICMPQ2, SMLSIZ, NSIZE, NRHS, WORK( BXST ), N,
     $                   B( ST, 1 ), LDB, RWORK( U+ST1 ), N,
     $                   RWORK( VT+ST1 ), IWORK( K+ST1 ),
     $                   RWORK( DIFL+ST1 ), RWORK( DIFR+ST1 ),
     $                   RWORK( Z+ST1 ), RWORK( POLES+ST1 ),
     $                   IWORK( GIVPTR+ST1 ), IWORK( GIVCOL+ST1 ), N,
     $                   IWORK( PERM+ST1 ), RWORK( GIVNUM+ST1 ),
     $                   RWORK( C+ST1 ), RWORK( S+ST1 ),
     $                   RWORK( NRWORK ), IWORK( IWK ), INFO )
            IF( INFO.NE.0 ) THEN
               RETURN
            END IF
         END IF
  320 CONTINUE
*
*     Unscale and sort the singular values.
*
      CALL DLASCL( 'G', 0, 0, ONE, ORGNRM, N, 1, D, N, INFO )
      CALL DLASRT( 'D', N, D, INFO )
      CALL ZLASCL( 'G', 0, 0, ORGNRM, ONE, N, NRHS, B, LDB, INFO )
*
      RETURN
*
*     End of ZLALSD
*
      END

c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by UCAR                 .
c  .                                                             .
c  .       University Corporation for Atmospheric Research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                         SPHEREPACK                          .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c
c ... file trvsph.f
c
c     this file contains documentation and code for subroutine trvsph
c
c ... required files
c
c     sphcom.f, hrfft.f, gaqd.f, vhaec.f, vhsec.f, vhagc.f, vhsgc.f
c
c     subroutine trvsph (intl,igrida,nlona,nlata,iveca,ua,va,
c    +igridb,nlonb,nlatb,ivecb,ub,vb,wsave,lsave,lsvmin,work,
c    +lwork,lwkmin,dwork,ldwork,ier)
c
c *** author
c
c     John C. Adams (NCAR 1997), email: johnad@ncar.ucar.edu
c
c *** purpose
c
C*PL*ERROR* Comment line too long
c     subroutine trvsph transfers vector data given in (ua,va) on a grid on
C*PL*ERROR* Comment line too long
c     the full sphere to vector data in (ub,vb) on a grid on the full sphere.
C*PL*ERROR* Comment line too long
c     the grids on which (ua,va) is given and (ub,vb) is generated can be
C*PL*ERROR* Comment line too long
c     specified independently of each other (see the input arguments igrida,
C*PL*ERROR* Comment line too long
c     igridb,iveca,ivecb).  ua and ub are the east longitudinal components of
C*PL*ERROR* Comment line too long
c     the given and transformed vector fields.  va is either the latitudinal
c     or colatitudinal component of the given vector field (see iveca).
c     vb is either the latitudinal or colatitudinal component of the
C*PL*ERROR* Comment line too long
c     transformed vector field (see ivecb).  for transferring scalar data
c     on the sphere, use subroutine trssph.
c
C*PL*ERROR* Comment line too long
c *   notice that scalar and vector quantities are fundamentally different
C*PL*ERROR* Comment line too long
c     on the sphere.  for example, vectors are discontinuous and multiple
C*PL*ERROR* Comment line too long
c     valued at the poles.  scalars are continuous and single valued at the
C*PL*ERROR* Comment line too long
c     poles. erroneous results would be produced if one attempted to transfer
c     vector fields between grids with subroutine trssph applied to each
c     component of the vector.
c
c *** underlying grid assumptions and a description
c
C*PL*ERROR* Comment line too long
c     discussions with the ncar scd data support group and others indicate
C*PL*ERROR* Comment line too long
c     there is no standard grid for storing observational or model generated
c     data on the sphere.  subroutine trvsph was designed to handle most
C*PL*ERROR* Comment line too long
c     cases likely to be encountered when moving data from one grid format
c     to another.
c
C*PL*ERROR* Comment line too long
c     the grid on which (ua,va) is given must be equally spaced in longitude
c     and either equally spaced or gaussian in latitude (or colatitude).
C*PL*ERROR* Comment line too long
c     longitude, which can be either the first or second dimension of ua,va
C*PL*ERROR* Comment line too long
c     subdivides [0,2pi) excluding the periodic point 2pi.  (co)latitude,
c     which can be the second or first dimension of ua,va, has south
c     to north or north to south orientation with increasing subscript
c     value in ua,va (see the argument igrida).
c
C*PL*ERROR* Comment line too long
c     the grid on which ub,vb is generated must be equally spaced in longitude
c     and either equally spaced or gaussian in latitude (or colatitude).
C*PL*ERROR* Comment line too long
c     longitude, which can be either the first or second dimension of ub,vb
C*PL*ERROR* Comment line too long
c     subdivides [0,2pi) excluding the periodic point 2pi.  (co)latitude,
c     which can be the second or first dimension of ub,vb, has south
c     to north or north to south orientation with increasing subscript
c     value in db (see the argument igridb).
c
c     let nlon be either nlona or nlonb (the number of grid points in
c     longitude.  the longitude grid subdivides [0,2pi) into nlon spaced
c     points
c
c          (j-1)*2.*pi/nlon  (j=1,...,nlon).
c
C*PL*ERROR* Comment line too long
c     it is not necessary to communicate to subroutine trvsph whether the
C*PL*ERROR* Comment line too long
c     underlying grids are in latitude or colatitude.  it is only necessary
C*PL*ERROR* Comment line too long
c     to communicate whether they run south to north or north to south with
C*PL*ERROR* Comment line too long
c     increasing subscripts.  a brief discussion of latitude and colatitude
c     follows.  equally spaced latitude grids are assumed to subdivide
c     [-pi/2,pi/2] with the south pole at -pi/2 and north pole at pi/2.
C*PL*ERROR* Comment line too long
c     equally spaced colatitude grids subdivide [0,pi] with the north pole
C*PL*ERROR* Comment line too long
c     at 0 and south pole at pi.  equally spaced partitions on the sphere
C*PL*ERROR* Comment line too long
c     include both poles.  gaussian latitude grids subdivide (-pi/2,pi/2)
C*PL*ERROR* Comment line too long
c     and gaussian colatitude grids subdivide (0,pi).  gaussian grids do not
C*PL*ERROR* Comment line too long
c     include the poles.  the gaussian grid points are uniquely determined by
c     the size of the partition.  they can be computed in colatitude in
C*PL*ERROR* Comment line too long
c     (0,pi) (north to south) in double precision by the spherepack subroutine
C*PL*ERROR* Comment line too long
c     gaqd.  let nlat be nlata or nlatb if either the ua,va or ub,vb grid is
c     gaussian.  let
c
c        north pole                             south pole
c        ----------                             ----------
c           0.0    <  cth(1) < ... < cth(nlat)  <   pi
c
c
c     be nlat gaussian colatitude points in the interval (0,pi) and let
c
c        south pole                        north pole
c        ----------                        ----------
c           -pi/2  < th(1) < ... < th(nlat) < pi/2
c
C*PL*ERROR* Comment line too long
c     be nlat gaussian latitude points in the open interval (-pi/2,pi/2).
c     these are related by
c
c          th(i) = -pi/2 + cth(i)  (i=1,...,nlat)
c
C*PL*ERROR* Comment line too long
c     if the (ua,va) or (ub,vb) grid is equally spaced in (co)latitude then
c
c          ctht(i) = (i-1)*pi/(nlat-1)
c                                               (i=1,...,nlat)
c          tht(i) = -pi/2 + (i-1)*pi/(nlat-1)
c
C*PL*ERROR* Comment line too long
c     define the equally spaced (north to south) colatitude and (south to
c     north) latitude grids.
c
c *** method (simplified description)
c
c    (1)
c
C*PL*ERROR* Comment line too long
c     the vector field (ua,va) is reformated to a vector field in mathematical
C*PL*ERROR* Comment line too long
c     spherical coordinates using array transpositions, subscript reordering
c     and negation of va as necessary (see arguments igrida,iveca).
c
c     (2)
c
c     a vector harmonic analysis is performed on the result from (1)
c
c     (3)
c
c     a vector harmonic synthesis is performed on the (ub,vb) grid
c     using as many coefficients from (2) as possible (i.e., as
c     as is consistent with the size of the ub,vb grid).
c
c     (4)
c
c     the vector field generated in (3) is transformed from mathematical
c     spherical coordinates to the form flagged by ivecb and igridb in
C*PL*ERROR* Comment line too long
c     (ub,vb) using array transpositions, subscript reordering and negation
c     as necessary
c
c
c *** advantages
c
c     the use of vector spherical harmonics to transfer vector data is
c     highly accurate and preserves properties of vectors on the sphere.
c     the method produces a weighted least squares fit to vector data in
C*PL*ERROR* Comment line too long
c     which waves are resolved uniformly on the full sphere.  high frequencies
C*PL*ERROR* Comment line too long
c     induced by closeness of grid points near the poles (due to computational
C*PL*ERROR* Comment line too long
c     or observational errors) are smoothed.  the method is consistent with
C*PL*ERROR* Comment line too long
c     methods used to generate vector data in numerical spectral models based
C*PL*ERROR* Comment line too long
c     on spherical harmonics.  for more discussion of these and related issues,
c     see "on the spectral approximation of discrete scalar and vector
C*PL*ERROR* Comment line too long
c     functions on the sphere," siam j. numer. anal., vol. 16, december 1979,
c     pp. 934-949, by paul swarztrauber.
c
c
c *** comment
c
C*PL*ERROR* Comment line too long
c     on a nlon by nlat or nlat by nlon grid (gaussian or equally spaced)
c     spherical harmonic analysis generates and synthesis utilizes
c     min0(nlat,(nlon+2)/2)) by nlat coefficients.  consequently, for
c     ua,va and ub,vb,  if either
c
c             min0(nlatb,(nlonb+2)/2) < min0(nlata,(nlona+2)/2)
c
c     or if
c
c             nlatb < nlata
c
C*PL*ERROR* Comment line too long
c     then all the coefficients generated by an analysis of ua,va cannot be
C*PL*ERROR* Comment line too long
c     used in the synthesis which generates ub,vb.  in this case "information"
C*PL*ERROR* Comment line too long
c     can be lost in generating ub,vb.  more precisely, information will be
C*PL*ERROR* Comment line too long
c     lost if the analysis of ua,va yields nonzero coefficients which are
c     outside the coefficient bounds determined by the ub,vb grid. still
c     transference with vector spherical harmonics will yield results
c     consistent with grid resolution and is highly accurate.
c
c *** input arguments
c
c ... intl
c
C*PL*ERROR* Comment line too long
c     an initialization argument which should be zero on an initial call to
c     trvsph.  intl should be one if trvsph is being recalled and
c
c          igrida,nlona,nlata,iveca,igridb,nlonb,nlatb,ivecb
c
C*PL*ERROR* Comment line too long
c     have not changed from the previous call.  if any of these arguments have
C*PL*ERROR* Comment line too long
c     changed intl=0 must be used to avoid undetectable errors.  when allowed,
C*PL*ERROR* Comment line too long
c     calls with intl=1 bypass redundant computation and save time.  it can
c     be used when transferring multiple vector data sets with the same
c     underlying grids.
c
c ... igrida
c
C*PL*ERROR* Comment line too long
c     an integer vector dimensioned two which identifies the underlying grid
c     on the full sphere for the given vector data (ua,va) as follows:
c
c     igrida(1)
c
c     = -1
C*PL*ERROR* Comment line too long
c     if the latitude (or colatitude) grid for ua,va is an equally spaced
c     partition of [-pi/2,pi/2] ( or [0,pi] ) including the poles which
c     runs north to south with increasing subscript value
c
c     = +1
C*PL*ERROR* Comment line too long
c     if the latitude (or colatitude) grid for ua,va is an equally spaced
c     partition of [-pi/2,pi/2] ( or [0,pi] ) including the poles which
c     runs south to north with increasing subscript value
c
c     = -2
C*PL*ERROR* Comment line too long
c     if the latitude (or colatitude) grid for ua,va is a gaussian partition
c     of (-pi/2,pi/2) ( or (0,pi) ) excluding the poles which runs north
c     to south with increasing subscript value
c
c     = +2
C*PL*ERROR* Comment line too long
c     if the latitude (or colatitude) grid for ua,va is a gaussian partition
c     of (-pi/2,pi/2) ( or (0,pi) ) excluding the poles which runs south
c     north with increasing subscript value
c
c     igrida(2)
c
c     = 0 if the underlying grid for ua,va is a nlona by nlata
c
c     = 1 if the underlying grid for ua,va is a nlata by nlona
c
c
c ... nlona
c
C*PL*ERROR* Comment line too long
c     the number of longitude points on the uniform grid which partitions
C*PL*ERROR* Comment line too long
c     [0,2pi) for the given vector (ua,va).  nlona is also the first or second
C*PL*ERROR* Comment line too long
c     dimension of ua,va (see igrida(2)) in the program which calls trvsph.
C*PL*ERROR* Comment line too long
c     nlona determines the grid increment in longitude as 2*pi/nlona. for
C*PL*ERROR* Comment line too long
c     example nlona = 72 for a five degree grid.  nlona must be greater than
c     or equal to 4.  the efficiency of the computation is improved when
c     nlona is a product of small prime numbers
c
c ... nlata
c
c     the number of points in the latitude (or colatitude) grid for the
c     given vector (ua,va).  nlata is also the first or second dimension
c     of ua and va (see igrida(2)) in the program which calls trvsph.
C*PL*ERROR* Comment line too long
c     if nlata is odd then the equator will be located at the (nlata+1)/2
c     gaussian grid point.  if nlata is even then the equator will be
c     located half way between the nlata/2 and nlata/2+1 grid points.
c
c ... iveca
c
c     if iveca=0 is input then va is the latitudinal component of the
c     given vector field. if iveca=1 then va is the colatitudinal
c     compoenent of the given vector field.  in either case, ua must
c     be the east longitudinal component of the given vector field.
c
c *** note:
c     igrida(1)=-1 or igrida(1)=-2, igrida(2)=1, and iveca=1 corresponds
c     to the "usual" mathematical spherical coordinate system required
C*PL*ERROR* Comment line too long
c     by most of the drivers in spherepack2.  igrida(1)=1 or igrida(1)=2,
c     igrida(2)=0, and iveca=0 corresponds to the "usual" geophysical
c     spherical coordinate system.
c
c
c ... ua
c
c     ua is the east longitudinal component of the given vector field.
C*PL*ERROR* Comment line too long
c     ua must be dimensioned nlona by nlata in the program calling trvsph if
C*PL*ERROR* Comment line too long
c     igrida(2) = 0.  ua must be dimensioned nlata by nlona in the program
C*PL*ERROR* Comment line too long
c     calling trvsph if igrida(2) = 1.  if ua is not properly dimensioned
C*PL*ERROR* Comment line too long
c     and if the latitude (colatitude) values do not run south to north or
C*PL*ERROR* Comment line too long
c     north to south as flagged by igrida(1) (this cannot be checked!) then
c     incorrect results will be produced.
c
c
c ... va
c
c     va is either the latitudinal or colatitudinal componenet of the
c     given vector field (see iveca).  va must be dimensioned nlona by
c     nlata in the program calling trvsph if igrida(2)=0.  va must be
c     dimensioned nlata by nlona in the program calling trvsph if
c     igrida(2)=1.  if va is not properly dimensioned or if the latitude
c     (colatitude) values do not run south to north or north to south
c     as flagged by igrida(1) (this cannot be checked!) then incorrect
c     results will be produced.
c
c ... igridb
c
C*PL*ERROR* Comment line too long
c     an integer vector dimensioned two which identifies the underlying grid
c     on the full sphere for the transformed vector (ub,vb) as follows:
c
c     igridb(1)
c
c     = -1
C*PL*ERROR* Comment line too long
c     if the latitude (or colatitude) grid for ub,vb is an equally spaced
c     partition of [-pi/2,pi/2] ( or [0,pi] ) including the poles which
c     north to south
c
c     = +1
C*PL*ERROR* Comment line too long
c     if the latitude (or colatitude) grid for ub,vb is an equally spaced
c     partition of [-pi/2,pi/2] ( or [0,pi] ) including the poles which
c     south to north
c
c     = -2
C*PL*ERROR* Comment line too long
c     if the latitude (or colatitude) grid for ub,vb is a gaussian partition
C*PL*ERROR* Comment line too long
c     of (-pi/2,pi/2) ( or (0,pi) ) excluding the poles which runs north to
c     south
c
c     = +2
C*PL*ERROR* Comment line too long
c     if the latitude (or colatitude) grid for ub,vb is a gaussian partition
C*PL*ERROR* Comment line too long
c     of (-pi/2,pi/2) ( or (0,pi) ) excluding the poles which runs south to
c     north
c
c     igridb(2)
c
c     = 0 if the underlying grid for ub,vb is a nlonb by nlatb
c
c     = 1 if the underlying grid for ub,vb is a nlatb by nlonb
c
c
c ... nlonb
c
C*PL*ERROR* Comment line too long
c     the number of longitude points on the uniform grid which partitions
C*PL*ERROR* Comment line too long
c     [0,2pi) for the transformed vector (ub,vb).  nlonb is also the first or
C*PL*ERROR* Comment line too long
c     second dimension of ub and vb (see igridb(2)) in the program which calls
C*PL*ERROR* Comment line too long
c     trvsph.  nlonb determines the grid increment in longitude as 2*pi/nlonb.
C*PL*ERROR* Comment line too long
c     for example nlonb = 72 for a five degree grid.  nlonb must be greater
C*PL*ERROR* Comment line too long
c     than or equal to 4.  the efficiency of the computation is improved when
c     nlonb is a product of small prime numbers
c
c ... nlatb
c
c     the number of points in the latitude (or colatitude) grid for the
C*PL*ERROR* Comment line too long
c     transformed vector (ub,vb).  nlatb is also the first or second dimension
c     of ub and vb (see igridb(2)) in the program which calls trvsph.
C*PL*ERROR* Comment line too long
c     if nlatb is odd then the equator will be located at the (nlatb+1)/2
c     gaussian grid point.  if nlatb is even then the equator will be
c     located half way between the nlatb/2 and nlatb/2+1 grid points.
c
c ... ivecb
c
c     if ivecb=0 is input then vb is the latitudinal component of the
c     given vector field. if ivecb=1 then vb is the colatitudinal
c     compoenent of the given vector field.  in either case, ub must
c     be the east longitudinal component of the given vector field.
c
c *** note:
c     igridb(1)=-1 or igridb(1)=-2, igridb(2)=1, and ivecb=1 corresponds
c     to the "usual" mathematical spherical coordinate system required
C*PL*ERROR* Comment line too long
c     by most of the drivers in spherepack2.  igridb(1)=1 or igridb(1)=2,
c     igridb(2)=0, and ivecb=0 corresponds to the "usual" geophysical
c     spherical coordinate system.
c
c ... wsave
c
c     a saved work space array that can be utilized repeatedly by trvsph
c     as long as the arguments nlata,nlona,nlatb,nlonb remain unchanged.
C*PL*ERROR* Comment line too long
c     wsave is set by a intl=0 call to trvsph.  wsave must not be altered
c     when trvsph is being recalled with intl=1.
c
c ... lsave
c
c     the dimension of the work space wsave as it appears in the program
c     that calls trvsph.  the minimum required value of lsave for the
C*PL*ERROR* Comment line too long
c     current set of input arguments is set in the output argument lsvmin.
C*PL*ERROR* Comment line too long
c     it can be determined by calling trvsph with lsave=0 and printing lsvmin.
c
c          la1 = min0(nlata,(nlona+1)/2), la2 = (nlata+1)/2
c
c          lb1 = min0(nlatb,(nlonb+1)/2), lb2 = (nlatb+1)/2
c
C*PL*ERROR* Comment line too long
c          lwa = 4*nlata*la2+3*max0(la1-2,0)*(2*nlata-la1-1)+la2+nlona+15
c
c          lwb = 4*nlatb*lb2+3*max0(lb1-2,0)*(2*nlatb-lb1-1)+nlonb+15
c
c      then
c
c          lsvmin = lwa + lwb
c
c      is the minimal required work space length of wsave
c
c
c ... work
c
c     a work array that does not have to be preserved
c
c ... lwork
c
c     the dimension of the array work as it appears in the program that
c     calls trvsph. the minimum required value of lwork for the current
c     set of input arguments is set in the output argument lwkmin.
c     it can be determined by calling trvsph with lwork=0 and printing
C*PL*ERROR* Comment line too long
c     lwkmin.  an estimate for lwork follows.  let nlat = max0(nlata,nlatb),
C*PL*ERROR* Comment line too long
c     nlon = max0(nlona,nlonb) and l1 = min0(nlat,(nlon+2)/2).  with these
c     these definitions, the quantity
c
c            2*nlat*(8*l1 + 4*nlon + 3)
c
c     will suffice as a length for the unsaved work space.  this formula
c     may overestimate the required minimum value for lwork.  the exact
c     minimum value can be predetermined by calling trvsph wtih lwork=0
c     and printout of lwkmin.
c
c ... dwork
c
c     a double precision work array that does not have to be preserved.
c
c ... ldwork
c
c     the length of dwork in the routine calling trvsph
c     Let
c
c       nlat = max0(nlata,nlatb)
c
c     ldwork must be at least 2*nlat*(nlat+1)+1
c
c
c *** output arguments
c
c
c ... ub
c
C*PL*ERROR* Comment line too long
c     a two dimensional array that contains the east longitudinal component
c     of the transformed vector data.  ub
C*PL*ERROR* Comment line too long
c     must be dimensioned nlonb by nlatb in the program calling trvsph if
c     igridb(2)=0.  ub must be dimensioned nlatb by nlonb in the program
c     calling trvsph if igridb(2)=1.  if ub is not properly dimensioned
C*PL*ERROR* Comment line too long
c     and if the latitude (colatitude) values do not run south to north or
C*PL*ERROR* Comment line too long
c     north to south as flagged by igrdb(1) (this cannot be checked!) then
c     incorrect results will be produced.
c
c
c ... vb
c
C*PL*ERROR* Comment line too long
c     a two dimensional array that contains the latitudinal or colatitudinal
c     component of the transformed vector data (see ivecb).
C*PL*ERROR* Comment line too long
c     vb must be dimensioned nlonb by nlatb in the program calling trvsph if
c     igridb(2)=0.  vb must be dimensioned nlatb by nlonb in the program
c     calling trvsph if igridb(2)=1.  if vb is not properly dimensioned
C*PL*ERROR* Comment line too long
c     and if the latitude (colatitude) values do not run south to north or
C*PL*ERROR* Comment line too long
c     north to south as flagged by igrdb(1) (this cannot be checked!) then
c     incorrect results will be produced.
c
c ... lsvmin
c
c     the minimum length of the saved work space in wsave.
c     lsvmin is computed even if lsave < lsvmin (ier = 10).
c
c ... lwkmin
c
c     the minimum length of the unsaved work space in work.
c     lwkmin is computed even if lwork < lwkmin (ier = 11).
c
c
c *** error argument
c
c ... ier = 0  if no errors are detected
c
c         = 1  if intl is not 0 or 1
c
c         = 2  if igrida(1) is not -1 or +1 or -2 or +2
c
c         = 3  if igrida(2) is not 0 or 1
c
c         = 4  if nlona is less than 4
c
c         = 5  if nlata is less than 3
c
c         = 6  if iveca is not 0 or 1
c
c         = 7  if igridb(1) is not -1 or +1 or -2 or +2
c
c         = 8  if igridb(2) is not 0 or 1
c
c         = 9  if nlonb is less than 4
c
c         =10  if nlatb is less than 3
c
c         =11  if ivecb is not 0 or 1
c
C*PL*ERROR* Comment line too long
c         =12  if there is insufficient saved work space (lsave < lsvmin)
c
C*PL*ERROR* Comment line too long
c         =13  if there is insufficient unsaved work space (lwork < lwkmin)
c
c         =14  indicates failure in an eigenvalue routine which computes
c              gaussian weights and points
c
c         =15  if ldwork is too small (insufficient double precision
c              unsaved work space)
c
c *****************************************************
c *****************************************************
c
c     end of argument description ... code follows
c
c *****************************************************
c *****************************************************
c
      SUBROUTINE DTRVSPH(INTL,IGRIDA,NLONA,NLATA,IVECA,UA,VA,IGRIDB,
     +                  NLONB,NLATB,IVECB,UB,VB,WSAVE,LSAVE,LSVMIN,WORK,
     +                  LWORK,LWKMIN,DWORK,LDWORK,IER)
      IMPLICIT NONE
      INTEGER INTL,IGRIDA(2),NLONA,NLATA,IGRIDB(2),NLONB,NLATB
      INTEGER IVECA,IVECB,LSAVE,LSVMIN,LWORK,LWKMIN,LDWORK,IER
      DOUBLE PRECISION UA(*),VA(*),UB(*),VB(*),WSAVE(*),WORK(*)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION DWORK(*)
      INTEGER IG,IGRDA,IGRDB,LA1,LA2,LB1,LB2,LWA,LWB
      INTEGER IABR,IABI,IACR,IACI,IBBR,IBBI,IBCR,IBCI
      INTEGER NLAT,LWK1,LWK2,LW,IW,JB,NT,ITYP
c
C*PL*ERROR* Comment line too long
c     include a save statement to ensure local variables in trvsph, set during
c     an intl=0 call, are preserved if trvsph is recalled with intl=1
c
      SAVE
c
c     check input arguments
c
      IER = 1
      IF (INTL* (INTL-1).NE.0) RETURN
      IER = 2
      IG = IGRIDA(1)
      IF ((IG-1)* (IG+1)* (IG-2)* (IG+2).NE.0) RETURN
      IER = 3
      IG = IGRIDA(2)
      IF (IG* (IG-1).NE.0) RETURN
      IER = 4
      IF (NLONA.LT.4) RETURN
      IER = 5
      IF (NLATA.LT.3) RETURN
      IER = 6
      IF (IVECA* (IVECA-1).NE.0) RETURN
      IER = 7
      IG = IGRIDB(1)
      IF ((IG-1)* (IG+1)* (IG-2)* (IG+2).NE.0) RETURN
      IER = 8
      IG = IGRIDB(2)
      IF (IG* (IG-1).NE.0) RETURN
      IER = 9
      IF (NLONB.LT.4) RETURN
      IER = 10
      IF (NLATB.LT.3) RETURN
      IER = 11
      IF (IVECB* (IVECB-1).NE.0) RETURN
      IER = 0
      IGRDA = IABS(IGRIDA(1))
      IGRDB = IABS(IGRIDB(1))
      IF (INTL.EQ.0) THEN
          LA1 = MIN0(NLATA, (NLONA+1)/2)
          LA2 = (NLATA+1)/2
          LB1 = MIN0(NLATB, (NLONB+1)/2)
          LB2 = (NLATB+1)/2
c
c     saved space for analysis on a grid
c
          LWA = 4*NLATA*LA2 + 3*MAX0(LA1-2,0)* (2*NLATA-LA1-1) + LA2 +
     +          NLONA + 15
c
c     set saved work space length for synthesis on b grid
c
          LWB = 4*NLATB*LB2 + 3*MAX0(LB1-2,0)* (2*NLATB-LB1-1) + NLONB +
     +          15
c
c     set minimum required saved work space length
c
          LSVMIN = LWA + LWB
c
c     set wsave pointer
c
          JB = 1 + LWA
c
c     set pointers for vector spherical harmonic coefs in work
c
          IABR = 1
          IABI = IABR + LA1*NLATA
          IACR = IABI + LA1*NLATA
          IACI = IACR + LA1*NLATA
          IBBR = IACI + LA1*NLATA
          IBBI = IBBR + LB1*NLATB
          IBCR = IBBI + LB1*NLATB
          IBCI = IBCR + LB1*NLATB
c
c     set pointers for remaining work
c
          IW = IBCI + LB1*NLATB
c
c     set remaining work space length in lw
c
          LW = LWORK - IW
c
c     compute unsaved space for analysis and synthesis
c
          LWK1 = 2*NLATA* (2*NLONA+MAX0(6*LA2,NLONA))
          LWK2 = 2*NLATB* (2*NLONB+MAX0(6*LB2,NLONB))
c
c     set minimum unsaved work space required by trvsph
c
          LWKMIN = IW + MAX0(LWK1,LWK2)
c
c     set error flags if saved or unsaved work space is insufficient
c
          IER = 12
          IF (LSAVE.LT.LSVMIN) RETURN
          IER = 13
          IF (LWORK.LT.LWKMIN) RETURN
          IER = 15
          NLAT = MAX0(NLATA,NLATB)
          IF (LDWORK.LT.2*NLAT* (NLAT+1)+1) RETURN
          IER = 0
          IF (IGRDA.EQ.1) THEN
c
c     initialize wsave for equally spaced analysis
c
              CALL DVHAECI(NLATA,NLONA,WSAVE,LWA,DWORK,LDWORK,IER)
          ELSE
c
c     initialize wsave for gaussian analysis
c
              CALL DVHAGCI(NLATA,NLONA,WSAVE,LWA,DWORK,LDWORK,IER)
              IF (IER.NE.0) THEN
c
c     flag failure in spherepack gaussian software
c
                  IER = 14
                  RETURN
              END IF
          END IF

          IF (IGRDB.EQ.2) THEN
c
c     initialize wsave for gaussian synthesis
c
              CALL DVHSGCI(NLATB,NLONB,WSAVE(JB),LWB,DWORK,LDWORK,IER)
              IF (IER.NE.0) THEN
c
c     flag failure in spherepack gaussian software
c
                  IER = 14
                  RETURN
              END IF
          ELSE
c
c     initialize wsave for equally spaced synthesis
c
              CALL DVHSECI(NLATB,NLONB,WSAVE(JB),LWB,DWORK,LDWORK,IER)
          END IF
c
c     end of initialization (intl=0) call
c
      END IF
c
C*PL*ERROR* Comment line too long
c     convert the vector field (ua,va) to mathematical spherical coordinates
c
      IF (IGRIDA(2).EQ.0) THEN
          CALL DTRVPLAT(NLONA,NLATA,UA,WORK)
          CALL DTRVPLAT(NLONA,NLATA,VA,WORK)
      END IF
      IF (IGRIDA(1).GT.0) THEN
          CALL DCOVLAT(NLATA,NLONA,UA)
          CALL DCOVLAT(NLATA,NLONA,VA)
      END IF
      IF (IVECA.EQ.0) THEN
          CALL DNEGV(NLATA,NLONA,VA)
      END IF
      NT = 1
      ITYP = 0
c
c     analyze vector field
c
      IF (IGRDA.EQ.2) THEN
          CALL DVHAGC(NLATA,NLONA,ITYP,NT,VA,UA,NLATA,NLONA,WORK(IABR),
     +               WORK(IABI),WORK(IACR),WORK(IACI),LA1,NLATA,WSAVE,
     +               LWA,WORK(IW),LW,IER)
      ELSE
          CALL DVHAEC(NLATA,NLONA,ITYP,NT,VA,UA,NLATA,NLONA,WORK(IABR),
     +               WORK(IABI),WORK(IACR),WORK(IACI),LA1,NLATA,WSAVE,
     +               LWA,WORK(IW),LW,IER)
      END IF
c
c     transfer a grid coefficients to b grid coefficients
c
      CALL DTRVAB(LA1,NLATA,WORK(IABR),WORK(IABI),WORK(IACR),
     +            WORK(IACI),LB1,NLATB,WORK(IBBR),WORK(IBBI),
     +            WORK(IBCR),WORK(IBCI))
c
c     synthesize on b grid
c
      IF (IGRDB.EQ.1) THEN
          CALL DVHSEC(NLATB,NLONB,ITYP,NT,VB,UB,NLATB,NLONB,WORK(IBBR),
     +               WORK(IBBI),WORK(IBCR),WORK(IBCI),LB1,NLATB,
     +               WSAVE(JB),LWB,WORK(IW),LW,IER)
      ELSE
          CALL DVHSGC(NLATB,NLONB,ITYP,NT,VB,UB,NLATB,NLONB,WORK(IBBR),
     +               WORK(IBBI),WORK(IBCR),WORK(IBCI),LB1,NLATB,
     +               WSAVE(JB),LWB,WORK(IW),LW,IER)
      END IF
c
C*PL*ERROR* Comment line too long
c     restore a grid and b grid vector fields (now in math coordinates) to
c     agree with grid flags in igrida,iveca,igridb,ivecb
c
      IF (IVECA.EQ.0) THEN
          CALL DNEGV(NLATA,NLONA,VA)
      END IF
      IF (IVECB.EQ.0) THEN
          CALL DNEGV(NLATB,NLONB,VB)
      END IF
      IF (IGRIDA(1).GT.0) THEN
          CALL DCOVLAT(NLATA,NLONA,UA)
          CALL DCOVLAT(NLATA,NLONA,VA)
      END IF
      IF (IGRIDB(1).GT.0) THEN
          CALL DCOVLAT(NLATB,NLONB,UB)
          CALL DCOVLAT(NLATB,NLONB,VB)
      END IF
      IF (IGRIDA(2).EQ.0) THEN
          CALL DTRVPLAT(NLATA,NLONA,UA,WORK)
          CALL DTRVPLAT(NLATA,NLONA,VA,WORK)
      END IF
      IF (IGRIDB(2).EQ.0) THEN
          CALL DTRVPLAT(NLATB,NLONB,UB,WORK)
          CALL DTRVPLAT(NLATB,NLONB,VB,WORK)
      END IF
      RETURN
      END
      SUBROUTINE DNEGV(NLAT,NLON,V)
c
c     negate (co)latitudinal vector componenet
c
      IMPLICIT NONE
      INTEGER NLAT,NLON,I,J
      DOUBLE PRECISION V(NLAT,NLON)

      DO J = 1,NLON
          DO I = 1,NLAT
              V(I,J) = -V(I,J)
          END DO
      END DO
      RETURN
      END
      SUBROUTINE DTRVAB(MA,NA,ABR,ABI,ACR,ACI,MB,NB,BBR,BBI,BCR,BCI)
      IMPLICIT NONE
      INTEGER MA,NA,MB,NB,I,J,M,N
      DOUBLE PRECISION ABR(MA,NA),ABI(MA,NA),ACR(MA,NA),ACI(MA,NA)
      DOUBLE PRECISION BBR(MB,NB),BBI(MB,NB),BCR(MB,NB),BCI(MB,NB)
c
c     set coefficients for b grid from coefficients for a grid
c
      M = MIN0(MA,MB)
      N = MIN0(NA,NB)
      DO J = 1,N
          DO I = 1,M
              BBR(I,J) = ABR(I,J)
              BBI(I,J) = ABI(I,J)
              BCR(I,J) = ACR(I,J)
              BCI(I,J) = ACI(I,J)
          END DO
      END DO
c
c     set coefs outside triangle to zero
c
      DO I = M + 1,MB
          DO J = 1,NB
              BBR(I,J) = 0.0D0
              BBI(I,J) = 0.0D0
              BCR(I,J) = 0.0D0
              BCI(I,J) = 0.0D0
          END DO
      END DO
      DO J = N + 1,NB
          DO I = 1,MB
              BBR(I,J) = 0.0D0
              BBI(I,J) = 0.0D0
              BCR(I,J) = 0.0D0
              BCI(I,J) = 0.0D0
          END DO
      END DO
      RETURN
      END
      SUBROUTINE DTRVPLAT(N,M,DATA,WORK)
c
c     transpose the n by m array data to a m by n array data
c     work must be at least n*m words long
c
      IMPLICIT NONE
      INTEGER N,M,I,J,IJ,JI
      DOUBLE PRECISION DATA(*),WORK(*)

      DO J = 1,M
          DO I = 1,N
              IJ = (J-1)*N + I
              WORK(IJ) = DATA(IJ)
          END DO
      END DO
      DO I = 1,N
          DO J = 1,M
              JI = (I-1)*M + J
              IJ = (J-1)*N + I
              DATA(JI) = WORK(IJ)
          END DO
      END DO
      RETURN
      END
      SUBROUTINE DCOVLAT(NLAT,NLON,DATA)
c
c     reverse order of latitude (colatitude) grids
c
      IMPLICIT NONE
      INTEGER NLAT,NLON,NLAT2,I,IB,J
      DOUBLE PRECISION DATA(NLAT,NLON),TEMP

      NLAT2 = NLAT/2
      DO I = 1,NLAT2
          IB = NLAT - I + 1
          DO J = 1,NLON
              TEMP = DATA(I,J)
              DATA(I,J) = DATA(IB,J)
              DATA(IB,J) = TEMP
          END DO
      END DO
      RETURN
      END

      SUBROUTINE DHYI2HYOB(P0,HYAI,HYBI,PSFC,MLON,NLAT,KLEVI,XI,HYAO,
     +                     HYBO,KLEVO,XO,PI,PO,INTFLG, MSGFLG, XMSG)
      IMPLICIT NONE
c NCL: xo = hyi2hyo (p0,hyai,hybi,psfc,xi,hyao,hybo)

c this routine interploates one hybrid level to another
c     formula for the pressure of a hybrid surface is;
c          phy(k) = hya(k)*p0 + hyb(k)*psfc

c     input  ["i" input ... "o" output]
c          hyai   - is the "a" or pressure hybrid coef [input]
c          hybi   - is the "b" or sigma coeficient     [input]
c          p0     - is the base pressure in Pa         [input]
c          psfc   - is the surface pressure Pa         [input]
c          mlon   - longitude dimension
c          nlat   - latitude  dimension
c          klevi  - number of input  levels
c          hyao   - is the "a" or pressure hybrid coef
c          hybo   - is the "b" or sigma coeficient
c          klevo  - number of output levels
c          xmsg   = missing code; if none present set to
c                   some bogus value [eg, 1d20]
c          intflg - if  0 set all values outside of input P to xmsg
c                   if  1 set output values to closest input pressure level
c     output
c          xo     - pressure at hybrid levels [Pa]
c          msgflg - if  0 no missing values upon return
c                   if -1 missing values are present.

c                                                 ! input
      INTEGER MLON,NLAT,KLEVI,KLEVO,INTFLG
      DOUBLE PRECISION P0,HYAI(KLEVI),HYBI(KLEVI),HYAO(KLEVO),
     +                 HYBO(KLEVO),PSFC(MLON,NLAT),XI(MLON,NLAT,KLEVI),
     +                 PI(KLEVI),PO(KLEVO), XMSG
c                                                 ! output
      DOUBLE PRECISION XO(MLON,NLAT,KLEVO)
c                                                 ! local
      INTEGER NL,ML,KI,KO, MSGFLG
      DOUBLE PRECISION PEPS, PILOW
c f77
      PEPS   = 1.0D-3
      MSGFLG = 0

      DO NL = 1,NLAT
          DO ML = 1,MLON
              DO KI = 1,KLEVI
                  PI(KI) = HYAI(KI)*P0 + HYBI(KI)*PSFC(ML,NL)
              END DO
              PILOW = PI(KLEVI) - PEPS

              DO KO = 1,KLEVO
                  PO(KO) = HYAO(KO)*P0 + HYBO(KO)*PSFC(ML,NL)
              END DO

              DO KO = 1,KLEVO
C outlier check: set flag for interface routine and value    
                 IF (PO(KO).LT.PI(1) .OR. PO(KO).GT.PILOW ) THEN
C must be outside input pressure range
                     IF (INTFLG.EQ.0) THEN 
C default is to set to xmsg
                         MSGFLG       = -1
                         XO(ML,NL,KO) = XMSG
                     ELSEIF (INTFLG.EQ.1) THEN 
C set to nearest input value
                         IF (PO(KO).LT.PI(1)) THEN
                             XO(ML,NL,KO) = XI(ML,NL,1) 
                         ELSEIF (PO(KO).GT.PILOW) THEN
                             XO(ML,NL,KO) = XI(ML,NL,KLEVI) 
                         END IF
                     END IF
                 ELSE
C This was the original code
                     DO KI = 1,KLEVI-1
                        IF ((PO(KO).GE.PI(KI) .AND. 
     +                       PO(KO).LT.PI(KI+1)))THEN
                             XO(ML,NL,KO) = XI(ML,NL,KI) +
     +                                  (XI(ML,NL,KI+1)-XI(ML,NL,KI))*
     +                                  (DLOG(PO(KO))-DLOG(PI(KI)))/
     +                                  (DLOG(PI(KI+1))-DLOG(PI(KI)))
                             GO TO 20
                        END IF
                     END DO
                 END IF
   20            CONTINUE
              END DO

          END DO
      END DO

      RETURN
      END

      SUBROUTINE SGGES( JOBVSL, JOBVSR, SORT, SELCTG, N, A, LDA, B, LDB,
     $                  SDIM, ALPHAR, ALPHAI, BETA, VSL, LDVSL, VSR,
     $                  LDVSR, WORK, LWORK, BWORK, INFO )
*
*  -- LAPACK driver routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          JOBVSL, JOBVSR, SORT
      INTEGER            INFO, LDA, LDB, LDVSL, LDVSR, LWORK, N, SDIM
*     ..
*     .. Array Arguments ..
      LOGICAL            BWORK( * )
      REAL               A( LDA, * ), ALPHAI( * ), ALPHAR( * ),
     $                   B( LDB, * ), BETA( * ), VSL( LDVSL, * ),
     $                   VSR( LDVSR, * ), WORK( * )
*     ..
*     .. Function Arguments ..
      LOGICAL            SELCTG
      EXTERNAL           SELCTG
*     ..
*
*  Purpose
*  =======
*
*  SGGES computes for a pair of N-by-N real nonsymmetric matrices (A,B),
*  the generalized eigenvalues, the generalized real Schur form (S,T),
*  optionally, the left and/or right matrices of Schur vectors (VSL and
*  VSR). This gives the generalized Schur factorization
*
*           (A,B) = ( (VSL)*S*(VSR)**T, (VSL)*T*(VSR)**T )
*
*  Optionally, it also orders the eigenvalues so that a selected cluster
*  of eigenvalues appears in the leading diagonal blocks of the upper
*  quasi-triangular matrix S and the upper triangular matrix T.The
*  leading columns of VSL and VSR then form an orthonormal basis for the
*  corresponding left and right eigenspaces (deflating subspaces).
*
*  (If only the generalized eigenvalues are needed, use the driver
*  SGGEV instead, which is faster.)
*
*  A generalized eigenvalue for a pair of matrices (A,B) is a scalar w
*  or a ratio alpha/beta = w, such that  A - w*B is singular.  It is
*  usually represented as the pair (alpha,beta), as there is a
*  reasonable interpretation for beta=0 or both being zero.
*
*  A pair of matrices (S,T) is in generalized real Schur form if T is
*  upper triangular with non-negative diagonal and S is block upper
*  triangular with 1-by-1 and 2-by-2 blocks.  1-by-1 blocks correspond
*  to real generalized eigenvalues, while 2-by-2 blocks of S will be
*  "standardized" by making the corresponding elements of T have the
*  form:
*          [  a  0  ]
*          [  0  b  ]
*
*  and the pair of corresponding 2-by-2 blocks in S and T will have a
*  complex conjugate pair of generalized eigenvalues.
*
*
*  Arguments
*  =========
*
*  JOBVSL  (input) CHARACTER*1
*          = 'N':  do not compute the left Schur vectors;
*          = 'V':  compute the left Schur vectors.
*
*  JOBVSR  (input) CHARACTER*1
*          = 'N':  do not compute the right Schur vectors;
*          = 'V':  compute the right Schur vectors.
*
*  SORT    (input) CHARACTER*1
*          Specifies whether or not to order the eigenvalues on the
*          diagonal of the generalized Schur form.
*          = 'N':  Eigenvalues are not ordered;
*          = 'S':  Eigenvalues are ordered (see SELCTG);
*
*  SELCTG  (input) LOGICAL FUNCTION of three REAL arguments
*          SELCTG must be declared EXTERNAL in the calling subroutine.
*          If SORT = 'N', SELCTG is not referenced.
*          If SORT = 'S', SELCTG is used to select eigenvalues to sort
*          to the top left of the Schur form.
*          An eigenvalue (ALPHAR(j)+ALPHAI(j))/BETA(j) is selected if
*          SELCTG(ALPHAR(j),ALPHAI(j),BETA(j)) is true; i.e. if either
*          one of a complex conjugate pair of eigenvalues is selected,
*          then both complex eigenvalues are selected.
*
*          Note that in the ill-conditioned case, a selected complex
*          eigenvalue may no longer satisfy SELCTG(ALPHAR(j),ALPHAI(j),
*          BETA(j)) = .TRUE. after ordering. INFO is to be set to N+2
*          in this case.
*
*  N       (input) INTEGER
*          The order of the matrices A, B, VSL, and VSR.  N >= 0.
*
*  A       (input/output) REAL array, dimension (LDA, N)
*          On entry, the first of the pair of matrices.
*          On exit, A has been overwritten by its generalized Schur
*          form S.
*
*  LDA     (input) INTEGER
*          The leading dimension of A.  LDA >= max(1,N).
*
*  B       (input/output) REAL array, dimension (LDB, N)
*          On entry, the second of the pair of matrices.
*          On exit, B has been overwritten by its generalized Schur
*          form T.
*
*  LDB     (input) INTEGER
*          The leading dimension of B.  LDB >= max(1,N).
*
*  SDIM    (output) INTEGER
*          If SORT = 'N', SDIM = 0.
*          If SORT = 'S', SDIM = number of eigenvalues (after sorting)
*          for which SELCTG is true.  (Complex conjugate pairs for which
*          SELCTG is true for either eigenvalue count as 2.)
*
*  ALPHAR  (output) REAL array, dimension (N)
*  ALPHAI  (output) REAL array, dimension (N)
*  BETA    (output) REAL array, dimension (N)
*          On exit, (ALPHAR(j) + ALPHAI(j)*i)/BETA(j), j=1,...,N, will
*          be the generalized eigenvalues.  ALPHAR(j) + ALPHAI(j)*i,
*          and  BETA(j),j=1,...,N are the diagonals of the complex Schur
*          form (S,T) that would result if the 2-by-2 diagonal blocks of
*          the real Schur form of (A,B) were further reduced to
*          triangular form using 2-by-2 complex unitary transformations.
*          If ALPHAI(j) is zero, then the j-th eigenvalue is real; if
*          positive, then the j-th and (j+1)-st eigenvalues are a
*          complex conjugate pair, with ALPHAI(j+1) negative.
*
*          Note: the quotients ALPHAR(j)/BETA(j) and ALPHAI(j)/BETA(j)
*          may easily over- or underflow, and BETA(j) may even be zero.
*          Thus, the user should avoid naively computing the ratio.
*          However, ALPHAR and ALPHAI will be always less than and
*          usually comparable with norm(A) in magnitude, and BETA always
*          less than and usually comparable with norm(B).
*
*  VSL     (output) REAL array, dimension (LDVSL,N)
*          If JOBVSL = 'V', VSL will contain the left Schur vectors.
*          Not referenced if JOBVSL = 'N'.
*
*  LDVSL   (input) INTEGER
*          The leading dimension of the matrix VSL. LDVSL >=1, and
*          if JOBVSL = 'V', LDVSL >= N.
*
*  VSR     (output) REAL array, dimension (LDVSR,N)
*          If JOBVSR = 'V', VSR will contain the right Schur vectors.
*          Not referenced if JOBVSR = 'N'.
*
*  LDVSR   (input) INTEGER
*          The leading dimension of the matrix VSR. LDVSR >= 1, and
*          if JOBVSR = 'V', LDVSR >= N.
*
*  WORK    (workspace/output) REAL array, dimension (LWORK)
*          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*
*  LWORK   (input) INTEGER
*          The dimension of the array WORK.  LWORK >= 8*N+16.
*
*          If LWORK = -1, then a workspace query is assumed; the routine
*          only calculates the optimal size of the WORK array, returns
*          this value as the first entry of the WORK array, and no error
*          message related to LWORK is issued by XERBLA.
*
*  BWORK   (workspace) LOGICAL array, dimension (N)
*          Not referenced if SORT = 'N'.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value.
*          = 1,...,N:
*                The QZ iteration failed.  (A,B) are not in Schur
*                form, but ALPHAR(j), ALPHAI(j), and BETA(j) should
*                be correct for j=INFO+1,...,N.
*          > N:  =N+1: other than QZ iteration failed in SHGEQZ.
*                =N+2: after reordering, roundoff changed values of
*                      some complex eigenvalues so that leading
*                      eigenvalues in the Generalized Schur form no
*                      longer satisfy SELCTG=.TRUE.  This could also
*                      be caused due to scaling.
*                =N+3: reordering failed in STGSEN.
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ZERO, ONE
      PARAMETER          ( ZERO = 0.0E+0, ONE = 1.0E+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            CURSL, ILASCL, ILBSCL, ILVSL, ILVSR, LASTSL,
     $                   LQUERY, LST2SL, WANTST
      INTEGER            I, ICOLS, IERR, IHI, IJOBVL, IJOBVR, ILEFT,
     $                   ILO, IP, IRIGHT, IROWS, ITAU, IWRK, MAXWRK,
     $                   MINWRK
      REAL               ANRM, ANRMTO, BIGNUM, BNRM, BNRMTO, EPS, PVSL,
     $                   PVSR, SAFMAX, SAFMIN, SMLNUM
*     ..
*     .. Local Arrays ..
      INTEGER            IDUM( 1 )
      REAL               DIF( 2 )
*     ..
*     .. External Subroutines ..
      EXTERNAL           SGEQRF, SGGBAK, SGGBAL, SGGHRD, SHGEQZ, SLABAD,
     $                   SLACPY, SLASCL, SLASET, SORGQR, SORMQR, STGSEN,
     $                   XERBLA
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            ILAENV
      REAL               SLAMCH, SLANGE
      EXTERNAL           LSAME, ILAENV, SLAMCH, SLANGE
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, SQRT
*     ..
*     .. Executable Statements ..
*
*     Decode the input arguments
*
      IF( LSAME( JOBVSL, 'N' ) ) THEN
         IJOBVL = 1
         ILVSL = .FALSE.
      ELSE IF( LSAME( JOBVSL, 'V' ) ) THEN
         IJOBVL = 2
         ILVSL = .TRUE.
      ELSE
         IJOBVL = -1
         ILVSL = .FALSE.
      END IF
*
      IF( LSAME( JOBVSR, 'N' ) ) THEN
         IJOBVR = 1
         ILVSR = .FALSE.
      ELSE IF( LSAME( JOBVSR, 'V' ) ) THEN
         IJOBVR = 2
         ILVSR = .TRUE.
      ELSE
         IJOBVR = -1
         ILVSR = .FALSE.
      END IF
*
      WANTST = LSAME( SORT, 'S' )
*
*     Test the input arguments
*
      INFO = 0
      LQUERY = ( LWORK.EQ.-1 )
      IF( IJOBVL.LE.0 ) THEN
         INFO = -1
      ELSE IF( IJOBVR.LE.0 ) THEN
         INFO = -2
      ELSE IF( ( .NOT.WANTST ) .AND. ( .NOT.LSAME( SORT, 'N' ) ) ) THEN
         INFO = -3
      ELSE IF( N.LT.0 ) THEN
         INFO = -5
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -7
      ELSE IF( LDB.LT.MAX( 1, N ) ) THEN
         INFO = -9
      ELSE IF( LDVSL.LT.1 .OR. ( ILVSL .AND. LDVSL.LT.N ) ) THEN
         INFO = -15
      ELSE IF( LDVSR.LT.1 .OR. ( ILVSR .AND. LDVSR.LT.N ) ) THEN
         INFO = -17
      END IF
*
*     Compute workspace
*      (Note: Comments in the code beginning "Workspace:" describe the
*       minimal amount of workspace needed at that point in the code,
*       as well as the preferred amount for good performance.
*       NB refers to the optimal block size for the immediately
*       following subroutine, as returned by ILAENV.)
*
      MINWRK = 1
      IF( INFO.EQ.0 .AND. ( LWORK.GE.1 .OR. LQUERY ) ) THEN
         MINWRK = 7*( N+1 ) + 16
         MAXWRK = 7*( N+1 ) + N*ILAENV( 1, 'SGEQRF', ' ', N, 1, N, 0 ) +
     $            16
         IF( ILVSL ) THEN
            MAXWRK = MAX( MAXWRK, 7*( N+1 )+N*
     $               ILAENV( 1, 'SORGQR', ' ', N, 1, N, -1 ) )
         END IF
         WORK( 1 ) = MAXWRK
      END IF
*
      IF( LWORK.LT.MINWRK .AND. .NOT.LQUERY )
     $   INFO = -19
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'SGGES ', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 ) THEN
         SDIM = 0
         RETURN
      END IF
*
*     Get machine constants
*
      EPS = SLAMCH( 'P' )
      SAFMIN = SLAMCH( 'S' )
      SAFMAX = ONE / SAFMIN
      CALL SLABAD( SAFMIN, SAFMAX )
      SMLNUM = SQRT( SAFMIN ) / EPS
      BIGNUM = ONE / SMLNUM
*
*     Scale A if max element outside range [SMLNUM,BIGNUM]
*
      ANRM = SLANGE( 'M', N, N, A, LDA, WORK )
      ILASCL = .FALSE.
      IF( ANRM.GT.ZERO .AND. ANRM.LT.SMLNUM ) THEN
         ANRMTO = SMLNUM
         ILASCL = .TRUE.
      ELSE IF( ANRM.GT.BIGNUM ) THEN
         ANRMTO = BIGNUM
         ILASCL = .TRUE.
      END IF
      IF( ILASCL )
     $   CALL SLASCL( 'G', 0, 0, ANRM, ANRMTO, N, N, A, LDA, IERR )
*
*     Scale B if max element outside range [SMLNUM,BIGNUM]
*
      BNRM = SLANGE( 'M', N, N, B, LDB, WORK )
      ILBSCL = .FALSE.
      IF( BNRM.GT.ZERO .AND. BNRM.LT.SMLNUM ) THEN
         BNRMTO = SMLNUM
         ILBSCL = .TRUE.
      ELSE IF( BNRM.GT.BIGNUM ) THEN
         BNRMTO = BIGNUM
         ILBSCL = .TRUE.
      END IF
      IF( ILBSCL )
     $   CALL SLASCL( 'G', 0, 0, BNRM, BNRMTO, N, N, B, LDB, IERR )
*
*     Permute the matrix to make it more nearly triangular
*     (Workspace: need 6*N + 2*N space for storing balancing factors)
*
      ILEFT = 1
      IRIGHT = N + 1
      IWRK = IRIGHT + N
      CALL SGGBAL( 'P', N, A, LDA, B, LDB, ILO, IHI, WORK( ILEFT ),
     $             WORK( IRIGHT ), WORK( IWRK ), IERR )
*
*     Reduce B to triangular form (QR decomposition of B)
*     (Workspace: need N, prefer N*NB)
*
      IROWS = IHI + 1 - ILO
      ICOLS = N + 1 - ILO
      ITAU = IWRK
      IWRK = ITAU + IROWS
      CALL SGEQRF( IROWS, ICOLS, B( ILO, ILO ), LDB, WORK( ITAU ),
     $             WORK( IWRK ), LWORK+1-IWRK, IERR )
*
*     Apply the orthogonal transformation to matrix A
*     (Workspace: need N, prefer N*NB)
*
      CALL SORMQR( 'L', 'T', IROWS, ICOLS, IROWS, B( ILO, ILO ), LDB,
     $             WORK( ITAU ), A( ILO, ILO ), LDA, WORK( IWRK ),
     $             LWORK+1-IWRK, IERR )
*
*     Initialize VSL
*     (Workspace: need N, prefer N*NB)
*
      IF( ILVSL ) THEN
         CALL SLASET( 'Full', N, N, ZERO, ONE, VSL, LDVSL )
         CALL SLACPY( 'L', IROWS-1, IROWS-1, B( ILO+1, ILO ), LDB,
     $                VSL( ILO+1, ILO ), LDVSL )
         CALL SORGQR( IROWS, IROWS, IROWS, VSL( ILO, ILO ), LDVSL,
     $                WORK( ITAU ), WORK( IWRK ), LWORK+1-IWRK, IERR )
      END IF
*
*     Initialize VSR
*
      IF( ILVSR )
     $   CALL SLASET( 'Full', N, N, ZERO, ONE, VSR, LDVSR )
*
*     Reduce to generalized Hessenberg form
*     (Workspace: none needed)
*
      CALL SGGHRD( JOBVSL, JOBVSR, N, ILO, IHI, A, LDA, B, LDB, VSL,
     $             LDVSL, VSR, LDVSR, IERR )
*
*     Perform QZ algorithm, computing Schur vectors if desired
*     (Workspace: need N)
*
      IWRK = ITAU
      CALL SHGEQZ( 'S', JOBVSL, JOBVSR, N, ILO, IHI, A, LDA, B, LDB,
     $             ALPHAR, ALPHAI, BETA, VSL, LDVSL, VSR, LDVSR,
     $             WORK( IWRK ), LWORK+1-IWRK, IERR )
      IF( IERR.NE.0 ) THEN
         IF( IERR.GT.0 .AND. IERR.LE.N ) THEN
            INFO = IERR
         ELSE IF( IERR.GT.N .AND. IERR.LE.2*N ) THEN
            INFO = IERR - N
         ELSE
            INFO = N + 1
         END IF
         GO TO 40
      END IF
*
*     Sort eigenvalues ALPHA/BETA if desired
*     (Workspace: need 4*N+16 )
*
      SDIM = 0
      IF( WANTST ) THEN
*
*        Undo scaling on eigenvalues before SELCTGing
*
         IF( ILASCL ) THEN
            CALL SLASCL( 'G', 0, 0, ANRMTO, ANRM, N, 1, ALPHAR, N,
     $                   IERR )
            CALL SLASCL( 'G', 0, 0, ANRMTO, ANRM, N, 1, ALPHAI, N,
     $                   IERR )
         END IF
         IF( ILBSCL )
     $      CALL SLASCL( 'G', 0, 0, BNRMTO, BNRM, N, 1, BETA, N, IERR )
*
*        Select eigenvalues
*
         DO 10 I = 1, N
            BWORK( I ) = SELCTG( ALPHAR( I ), ALPHAI( I ), BETA( I ) )
   10    CONTINUE
*
         CALL STGSEN( 0, ILVSL, ILVSR, BWORK, N, A, LDA, B, LDB, ALPHAR,
     $                ALPHAI, BETA, VSL, LDVSL, VSR, LDVSR, SDIM, PVSL,
     $                PVSR, DIF, WORK( IWRK ), LWORK-IWRK+1, IDUM, 1,
     $                IERR )
         IF( IERR.EQ.1 )
     $      INFO = N + 3
*
      END IF
*
*     Apply back-permutation to VSL and VSR
*     (Workspace: none needed)
*
      IF( ILVSL )
     $   CALL SGGBAK( 'P', 'L', N, ILO, IHI, WORK( ILEFT ),
     $                WORK( IRIGHT ), N, VSL, LDVSL, IERR )
*
      IF( ILVSR )
     $   CALL SGGBAK( 'P', 'R', N, ILO, IHI, WORK( ILEFT ),
     $                WORK( IRIGHT ), N, VSR, LDVSR, IERR )
*
*     Check if unscaling would cause over/underflow, if so, rescale 
*     (ALPHAR(I),ALPHAI(I),BETA(I)) so BETA(I) is on the order of 
*     B(I,I) and ALPHAR(I) and ALPHAI(I) are on the order of A(I,I)
*
      IF( ILASCL )THEN
         DO 50 I = 1, N 
            IF( ALPHAI( I ).NE.ZERO ) THEN 
               IF( ( ALPHAR( I )/SAFMAX ).GT.( ANRMTO/ANRM ) .OR.
     $             ( SAFMIN/ALPHAR( I ) ).GT.( ANRM/ANRMTO ) ) THEN
                  WORK( 1 ) = ABS( A( I, I )/ALPHAR( I ) )
                  BETA( I ) = BETA( I )*WORK( 1 )
                  ALPHAR( I ) = ALPHAR( I )*WORK( 1 )
                  ALPHAI( I ) = ALPHAI( I )*WORK( 1 )
               ELSE IF( ( ALPHAI( I )/SAFMAX ).GT.( ANRMTO/ANRM ) .OR.         
     $             ( SAFMIN/ALPHAI( I ) ).GT.( ANRM/ANRMTO ) ) THEN
                  WORK( 1 ) = ABS( A( I, I+1 )/ALPHAI( I ) )
                  BETA( I ) = BETA( I )*WORK( 1 )
                  ALPHAR( I ) = ALPHAR( I )*WORK( 1 )
                  ALPHAI( I ) = ALPHAI( I )*WORK( 1 )
               END IF
            END IF
   50    CONTINUE
      END IF 
*
      IF( ILBSCL )THEN 
         DO 60 I = 1, N
            IF( ALPHAI( I ).NE.ZERO ) THEN
                IF( ( BETA( I )/SAFMAX ).GT.( BNRMTO/BNRM ) .OR.
     $              ( SAFMIN/BETA( I ) ).GT.( BNRM/BNRMTO ) ) THEN
                   WORK( 1 ) = ABS(B( I, I )/BETA( I ))
                   BETA( I ) = BETA( I )*WORK( 1 )
                   ALPHAR( I ) = ALPHAR( I )*WORK( 1 )
                   ALPHAI( I ) = ALPHAI( I )*WORK( 1 )
                END IF 
             END IF
   60    CONTINUE 
      END IF 
*
*     Undo scaling
*
      IF( ILASCL ) THEN
         CALL SLASCL( 'H', 0, 0, ANRMTO, ANRM, N, N, A, LDA, IERR )
         CALL SLASCL( 'G', 0, 0, ANRMTO, ANRM, N, 1, ALPHAR, N, IERR )
         CALL SLASCL( 'G', 0, 0, ANRMTO, ANRM, N, 1, ALPHAI, N, IERR )
      END IF
*
      IF( ILBSCL ) THEN
         CALL SLASCL( 'U', 0, 0, BNRMTO, BNRM, N, N, B, LDB, IERR )
         CALL SLASCL( 'G', 0, 0, BNRMTO, BNRM, N, 1, BETA, N, IERR )
      END IF
*
      IF( WANTST ) THEN
*
*        Check if reordering is correct
*
         LASTSL = .TRUE.
         LST2SL = .TRUE.
         SDIM = 0
         IP = 0
         DO 30 I = 1, N
            CURSL = SELCTG( ALPHAR( I ), ALPHAI( I ), BETA( I ) )
            IF( ALPHAI( I ).EQ.ZERO ) THEN
               IF( CURSL )
     $            SDIM = SDIM + 1
               IP = 0
               IF( CURSL .AND. .NOT.LASTSL )
     $            INFO = N + 2
            ELSE
               IF( IP.EQ.1 ) THEN
*
*                 Last eigenvalue of conjugate pair
*
                  CURSL = CURSL .OR. LASTSL
                  LASTSL = CURSL
                  IF( CURSL )
     $               SDIM = SDIM + 2
                  IP = -1
                  IF( CURSL .AND. .NOT.LST2SL )
     $               INFO = N + 2
               ELSE
*
*                 First eigenvalue of conjugate pair
*
                  IP = 1
               END IF
            END IF
            LST2SL = LASTSL
            LASTSL = CURSL
   30    CONTINUE
*
      END IF
*
   40 CONTINUE
*
      WORK( 1 ) = MAXWRK
*
      RETURN
*
*     End of SGGES
*
      END

C
C	$Id: gtnumb.f,v 1.4 2008-07-27 00:17:21 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
C
C============================================================
C                       GTNUMB
C============================================================
      SUBROUTINE GTNUMB (IDPC,N,II,NUM)
C
C
C EXTRACTS AN OCTAL NUMBER NUM FROM CHARACTER STRING IDPC.
C
C ON ENTRY:
C   IDPC - A CHARACTER STRING
C   N - THE NUMBER OF CHARACTERS IN THE CHARACTER STRING IDPC
C   II - A NUMBER REPRESENTING A POINTER TO THE II-TH CHARACTER IN THE
C        CHARACTER STRING IDPC
C        THE II-TH CHARACTER HAS TO BE A DIGIT BETWEEN 0 AND 7
C   NUM - CAN HAVE ANY VALUE
C
C ON EXIT:
C   IDPC - UNCHANGED
C   N    - UNCHANGED
C   NUM  - 1) IF THE II-TH CHARACTER IN IDPC IS THE FIRST CHARACTER
C             IN A SUBSTRING REPRESENTING AN UNSIGNED INTEGER, THEN THE
C             VALUE OF THIS UNSIGNED INTEGER TAKEN TO THE BASE 8
C            (NOTICE THE DIFFERENCE FROM SUBROUTINE GTNUM)
C          2) OTHERWISE 0
C   II   - 1)IF AN UNSIGNED INTEGER WAS FOUND THEN II REPRESENTS A POINT
C            TO THE CHARACTER SUCCEEDING THE LAST CHARACTER OF THE
C            UNSIGNED INTEGER
C          2) OTHERWISE UNCHANGED
C
C CALLS
C   GTDGTS
C
C CALLED BY
C   PWRITX
C
C
C ASSUMPTION
C   THE REPRESENTATION OF DIGITS IN THE MACHINE IS ORDERED AND COMPACT.
C
C
      CHARACTER IDPC*(*)
C
C
C **********************************************************************
C
C LOCAL VARIABLES
C
C ID - A character representing the base of the number to be extracted
C
C **********************************************************************
C
C
C THE BASE OF THE NUMBER TO BE EXTRACTED.
C
      CHARACTER*1 ID
      ID =  '8'
C
      CALL GTDGTS(IDPC,II,N,ID,NUM)
C                 Convert digit string beginning at II in IDPC
C                 to an integer, base ID.
C
      RETURN
      END

C
C $Id: threbd.f,v 1.6 2008-07-27 00:17:34 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE THREBD
C
C Calling this do-nothing subroutine forces "ld" to load the following
C block data routine (but only if they are in the same ".f" file).
C
        RETURN
C
      END
CNOSPLIT
      BLOCKDATA THREBDX
      COMMON /TEMPRT/ RZERO
      COMMON /SET31/  ISCALE     ,XMIN       ,XMAX       ,YMIN       ,
     1                YMAX       ,BIGD       ,R0         ,NLX        ,
     2                NBY        ,NRX        ,NTY
      COMMON /TCK31/  TMAGU      ,TMINU      ,TMAGV      ,TMINV      ,
     1                TMAGW      ,TMINW
      COMMON /THRINT/ ITHRMJ     ,ITHRMN     ,ITHRTX
      DATA RZERO/0./
      DATA NLX,NBY,NRX,NTY/10,10,1010,1010/
      DATA TMAGU,TMINU,TMAGV,TMINV,TMAGW,TMINW/12.,8.,12.,8.,12.,8./
      DATA ITHRMJ,ITHRMN,ITHRTX/ 1,1,1/
      END

C
C $Id: mxmy.f,v 1.7 2008-07-27 00:17:24 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MXMY (IX,IY)
C
C Return to the user the coordinates of the current pen position, in the
C plotter coordinate system.
C
C In the common block PLTCM are recorded the coordinates of the last
C pen position, in the metacode coordinate system.
C
      COMMON /PLTCM/ JX,JY
      SAVE /PLTCM/
C
C Declare the common block containing the user state variables LL, MI,
C MX, and MY.
C
      COMMON /IUTLCM/ LL,MI,MX,MY,IU(96)
      SAVE /IUTLCM/
C
C Return to the user the plotter-system equivalents of the values in
C the metacode system.
C
      IX=1+INT((2.**MX-1.)*REAL(JX)/32767.)
      IY=1+INT((2.**MY-1.)*REAL(JY)/32767.)
C
C Done.
C
      RETURN
C
      END

C
C	$Id: gqpaf.f,v 1.6 2008-07-27 00:21:00 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GQPAF(WTYPE,ERRIND,NPPAI)
C
C  INQUIRE PATTERN FACILITIES
C
      include 'gkscom.h'
C
      INTEGER WTYPE,ERRIND,NPPAI
C
C  Check if GKS is in the proper state.
C
      CALL GZCKST(8,-1,ERRIND)
      IF (ERRIND .NE. 0) GOTO 100
C
C  Check that the workstation type is valid.
C
      CALL GZCKWK(22,-1,IDUM,WTYPE,ERRIND)
C
C  Check if the workstation category is OUTPUT or OUTIN.
C
      CALL GQWKCA(WTYPE,ERRIND,ICAT)
      IF (ICAT.NE.GOUTPT .AND. ICAT.NE.GOUTIN) THEN
        ERRIND = 39
        GO TO 100
      ENDIF
C
C  Set NPPAI to zero and return.  If and when any driver supports
C  pattern fill, uncomment the remaining section of code.
C
      NPPAI = 0
      RETURN
C     
C     IF (ERRIND .NE. 0) GO TO 100
C     FCODE = -115
C     CONT  = 0
C     CALL GZROI(0)
C     IL1   = 1
C     IL2   = 1
C     ID(1) = WTYPE
C     IWK   = -1
C     CALL GZIQWK(WTYPE,IWK)
C     IF (RERR.NE.0) THEN
C       ERRIND = RERR
C       GOTO 100
C     ENDIF
C     NPPAI = ID(2)
C     RETURN
C
  100 CONTINUE
      NPPAI = -1
      RETURN
      END

      SUBROUTINE DF2FOSHV(UOFF,VOFF,ILON,JLAT,UREG,VREG,JLAT1,WORK,
     +                   LWORK,WSAVE,LSAVE,IOFF,IER)
      DOUBLE PRECISION WORK
      DOUBLE PRECISION WSAVE

c NCL: f2foshv (ureg,vreg,uoff,voff)

c vector: fixed (regular) grid to fixed-offset (equal spaced)

c nomenclature:
c .   goff   - output grid. Data are in a fixed-offset grid
c .            with no wraparound or cyclic pts.
c .            eg: a 5 degree grid ==> goff(72,36)
c .            where ilon=72 and jlat=36.
c .   greg   - input grid. data are on a fixed grid
c .            The output grid will have pole pts.
c .            eg: for a 5 deg grid  greg(72,36).


C input
      INTEGER ILON,JLAT,JLAT1
      DOUBLE PRECISION UOFF(ILON,JLAT),VOFF(ILON,JLAT)
      DOUBLE PRECISION UREG(ILON,JLAT1),VREG(ILON,JLAT1)
C output
      INTEGER IER

      IER = 0
      IF (ILON.LT.4 .OR. JLAT.LT.3) IER = 10
      IF ((JLAT1-JLAT).NE.1) IER = IER + 100
      IF (IER.NE.0) RETURN

      CALL DVSHIFTI(IOFF,ILON,JLAT,LSAVE,WSAVE,IER)
      CALL DVSHIFTE(IOFF,ILON,JLAT,UOFF,VOFF,UREG,VREG,WSAVE,LSAVE,
     +     WORK,LWORK,IER)

      RETURN
      END

      SUBROUTINE ZGGEV( JOBVL, JOBVR, N, A, LDA, B, LDB, ALPHA, BETA,
     $                  VL, LDVL, VR, LDVR, WORK, LWORK, RWORK, INFO )
*
*  -- LAPACK driver routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          JOBVL, JOBVR
      INTEGER            INFO, LDA, LDB, LDVL, LDVR, LWORK, N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   RWORK( * )
      COMPLEX*16         A( LDA, * ), ALPHA( * ), B( LDB, * ),
     $                   BETA( * ), VL( LDVL, * ), VR( LDVR, * ),
     $                   WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  ZGGEV computes for a pair of N-by-N complex nonsymmetric matrices
*  (A,B), the generalized eigenvalues, and optionally, the left and/or
*  right generalized eigenvectors.
*
*  A generalized eigenvalue for a pair of matrices (A,B) is a scalar
*  lambda or a ratio alpha/beta = lambda, such that A - lambda*B is
*  singular. It is usually represented as the pair (alpha,beta), as
*  there is a reasonable interpretation for beta=0, and even for both
*  being zero.
*
*  The right generalized eigenvector v(j) corresponding to the
*  generalized eigenvalue lambda(j) of (A,B) satisfies
*
*               A * v(j) = lambda(j) * B * v(j).
*
*  The left generalized eigenvector u(j) corresponding to the
*  generalized eigenvalues lambda(j) of (A,B) satisfies
*
*               u(j)**H * A = lambda(j) * u(j)**H * B
*
*  where u(j)**H is the conjugate-transpose of u(j).
*
*  Arguments
*  =========
*
*  JOBVL   (input) CHARACTER*1
*          = 'N':  do not compute the left generalized eigenvectors;
*          = 'V':  compute the left generalized eigenvectors.
*
*  JOBVR   (input) CHARACTER*1
*          = 'N':  do not compute the right generalized eigenvectors;
*          = 'V':  compute the right generalized eigenvectors.
*
*  N       (input) INTEGER
*          The order of the matrices A, B, VL, and VR.  N >= 0.
*
*  A       (input/output) COMPLEX*16 array, dimension (LDA, N)
*          On entry, the matrix A in the pair (A,B).
*          On exit, A has been overwritten.
*
*  LDA     (input) INTEGER
*          The leading dimension of A.  LDA >= max(1,N).
*
*  B       (input/output) COMPLEX*16 array, dimension (LDB, N)
*          On entry, the matrix B in the pair (A,B).
*          On exit, B has been overwritten.
*
*  LDB     (input) INTEGER
*          The leading dimension of B.  LDB >= max(1,N).
*
*  ALPHA   (output) COMPLEX*16 array, dimension (N)
*  BETA    (output) COMPLEX*16 array, dimension (N)
*          On exit, ALPHA(j)/BETA(j), j=1,...,N, will be the
*          generalized eigenvalues.
*
*          Note: the quotients ALPHA(j)/BETA(j) may easily over- or
*          underflow, and BETA(j) may even be zero.  Thus, the user
*          should avoid naively computing the ratio alpha/beta.
*          However, ALPHA will be always less than and usually
*          comparable with norm(A) in magnitude, and BETA always less
*          than and usually comparable with norm(B).
*
*  VL      (output) COMPLEX*16 array, dimension (LDVL,N)
*          If JOBVL = 'V', the left generalized eigenvectors u(j) are
*          stored one after another in the columns of VL, in the same
*          order as their eigenvalues.
*          Each eigenvector will be scaled so the largest component
*          will have abs(real part) + abs(imag. part) = 1.
*          Not referenced if JOBVL = 'N'.
*
*  LDVL    (input) INTEGER
*          The leading dimension of the matrix VL. LDVL >= 1, and
*          if JOBVL = 'V', LDVL >= N.
*
*  VR      (output) COMPLEX*16 array, dimension (LDVR,N)
*          If JOBVR = 'V', the right generalized eigenvectors v(j) are
*          stored one after another in the columns of VR, in the same
*          order as their eigenvalues.
*          Each eigenvector will be scaled so the largest component
*          will have abs(real part) + abs(imag. part) = 1.
*          Not referenced if JOBVR = 'N'.
*
*  LDVR    (input) INTEGER
*          The leading dimension of the matrix VR. LDVR >= 1, and
*          if JOBVR = 'V', LDVR >= N.
*
*  WORK    (workspace/output) COMPLEX*16 array, dimension (LWORK)
*          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*
*  LWORK   (input) INTEGER
*          The dimension of the array WORK.  LWORK >= max(1,2*N).
*          For good performance, LWORK must generally be larger.
*
*          If LWORK = -1, then a workspace query is assumed; the routine
*          only calculates the optimal size of the WORK array, returns
*          this value as the first entry of the WORK array, and no error
*          message related to LWORK is issued by XERBLA.
*
*  RWORK   (workspace/output) DOUBLE PRECISION array, dimension (8*N)
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value.
*          =1,...,N:
*                The QZ iteration failed.  No eigenvectors have been
*                calculated, but ALPHA(j) and BETA(j) should be
*                correct for j=INFO+1,...,N.
*          > N:  =N+1: other then QZ iteration failed in DHGEQZ,
*                =N+2: error return from DTGEVC.
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO, ONE
      PARAMETER          ( ZERO = 0.0D0, ONE = 1.0D0 )
      COMPLEX*16         CZERO, CONE
      PARAMETER          ( CZERO = ( 0.0D0, 0.0D0 ),
     $                   CONE = ( 1.0D0, 0.0D0 ) )
*     ..
*     .. Local Scalars ..
      LOGICAL            ILASCL, ILBSCL, ILV, ILVL, ILVR, LQUERY
      CHARACTER          CHTEMP
      INTEGER            ICOLS, IERR, IHI, IJOBVL, IJOBVR, ILEFT, ILO,
     $                   IN, IRIGHT, IROWS, IRWRK, ITAU, IWRK, JC, JR,
     $                   LWKMIN, LWKOPT
      DOUBLE PRECISION   ANRM, ANRMTO, BIGNUM, BNRM, BNRMTO, EPS,
     $                   SMLNUM, TEMP
      COMPLEX*16         X
*     ..
*     .. Local Arrays ..
      LOGICAL            LDUMMA( 1 )
*     ..
*     .. External Subroutines ..
      EXTERNAL           XERBLA, ZGEQRF, ZGGBAK, ZGGBAL, ZGGHRD, ZHGEQZ,
     $                   ZLACPY, ZLASCL, ZLASET, ZTGEVC, ZUNGQR, ZUNMQR
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            ILAENV
      DOUBLE PRECISION   DLAMCH, ZLANGE
      EXTERNAL           LSAME, ILAENV, DLAMCH, ZLANGE
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, DBLE, DIMAG, MAX, SQRT
*     ..
*     .. Statement Functions ..
      DOUBLE PRECISION   ABS1
*     ..
*     .. Statement Function definitions ..
      ABS1( X ) = ABS( DBLE( X ) ) + ABS( DIMAG( X ) )
*     ..
*     .. Executable Statements ..
*
*     Decode the input arguments
*
      IF( LSAME( JOBVL, 'N' ) ) THEN
         IJOBVL = 1
         ILVL = .FALSE.
      ELSE IF( LSAME( JOBVL, 'V' ) ) THEN
         IJOBVL = 2
         ILVL = .TRUE.
      ELSE
         IJOBVL = -1
         ILVL = .FALSE.
      END IF
*
      IF( LSAME( JOBVR, 'N' ) ) THEN
         IJOBVR = 1
         ILVR = .FALSE.
      ELSE IF( LSAME( JOBVR, 'V' ) ) THEN
         IJOBVR = 2
         ILVR = .TRUE.
      ELSE
         IJOBVR = -1
         ILVR = .FALSE.
      END IF
      ILV = ILVL .OR. ILVR
*
*     Test the input arguments
*
      INFO = 0
      LQUERY = ( LWORK.EQ.-1 )
      IF( IJOBVL.LE.0 ) THEN
         INFO = -1
      ELSE IF( IJOBVR.LE.0 ) THEN
         INFO = -2
      ELSE IF( N.LT.0 ) THEN
         INFO = -3
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -5
      ELSE IF( LDB.LT.MAX( 1, N ) ) THEN
         INFO = -7
      ELSE IF( LDVL.LT.1 .OR. ( ILVL .AND. LDVL.LT.N ) ) THEN
         INFO = -11
      ELSE IF( LDVR.LT.1 .OR. ( ILVR .AND. LDVR.LT.N ) ) THEN
         INFO = -13
      END IF
*
*     Compute workspace
*      (Note: Comments in the code beginning "Workspace:" describe the
*       minimal amount of workspace needed at that point in the code,
*       as well as the preferred amount for good performance.
*       NB refers to the optimal block size for the immediately
*       following subroutine, as returned by ILAENV. The workspace is
*       computed assuming ILO = 1 and IHI = N, the worst case.)
*
      LWKMIN = 1
      IF( INFO.EQ.0 .AND. ( LWORK.GE.1 .OR. LQUERY ) ) THEN
         LWKOPT = N + N*ILAENV( 1, 'ZGEQRF', ' ', N, 1, N, 0 )
         LWKMIN = MAX( 1, 2*N )
         WORK( 1 ) = LWKOPT
      END IF
*
      IF( LWORK.LT.LWKMIN .AND. .NOT.LQUERY )
     $   INFO = -15
*
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'ZGGEV ', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         RETURN
      END IF
*
*     Quick return if possible
*
      WORK( 1 ) = LWKOPT
      IF( N.EQ.0 )
     $   RETURN
*
*     Get machine constants
*
      EPS = DLAMCH( 'E' )*DLAMCH( 'B' )
      SMLNUM = DLAMCH( 'S' )
      BIGNUM = ONE / SMLNUM
      CALL DLABAD( SMLNUM, BIGNUM )
      SMLNUM = SQRT( SMLNUM ) / EPS
      BIGNUM = ONE / SMLNUM
*
*     Scale A if max element outside range [SMLNUM,BIGNUM]
*
      ANRM = ZLANGE( 'M', N, N, A, LDA, RWORK )
      ILASCL = .FALSE.
      IF( ANRM.GT.ZERO .AND. ANRM.LT.SMLNUM ) THEN
         ANRMTO = SMLNUM
         ILASCL = .TRUE.
      ELSE IF( ANRM.GT.BIGNUM ) THEN
         ANRMTO = BIGNUM
         ILASCL = .TRUE.
      END IF
      IF( ILASCL )
     $   CALL ZLASCL( 'G', 0, 0, ANRM, ANRMTO, N, N, A, LDA, IERR )
*
*     Scale B if max element outside range [SMLNUM,BIGNUM]
*
      BNRM = ZLANGE( 'M', N, N, B, LDB, RWORK )
      ILBSCL = .FALSE.
      IF( BNRM.GT.ZERO .AND. BNRM.LT.SMLNUM ) THEN
         BNRMTO = SMLNUM
         ILBSCL = .TRUE.
      ELSE IF( BNRM.GT.BIGNUM ) THEN
         BNRMTO = BIGNUM
         ILBSCL = .TRUE.
      END IF
      IF( ILBSCL )
     $   CALL ZLASCL( 'G', 0, 0, BNRM, BNRMTO, N, N, B, LDB, IERR )
*
*     Permute the matrices A, B to isolate eigenvalues if possible
*     (Real Workspace: need 6*N)
*
      ILEFT = 1
      IRIGHT = N + 1
      IRWRK = IRIGHT + N
      CALL ZGGBAL( 'P', N, A, LDA, B, LDB, ILO, IHI, RWORK( ILEFT ),
     $             RWORK( IRIGHT ), RWORK( IRWRK ), IERR )
*
*     Reduce B to triangular form (QR decomposition of B)
*     (Complex Workspace: need N, prefer N*NB)
*
      IROWS = IHI + 1 - ILO
      IF( ILV ) THEN
         ICOLS = N + 1 - ILO
      ELSE
         ICOLS = IROWS
      END IF
      ITAU = 1
      IWRK = ITAU + IROWS
      CALL ZGEQRF( IROWS, ICOLS, B( ILO, ILO ), LDB, WORK( ITAU ),
     $             WORK( IWRK ), LWORK+1-IWRK, IERR )
*
*     Apply the orthogonal transformation to matrix A
*     (Complex Workspace: need N, prefer N*NB)
*
      CALL ZUNMQR( 'L', 'C', IROWS, ICOLS, IROWS, B( ILO, ILO ), LDB,
     $             WORK( ITAU ), A( ILO, ILO ), LDA, WORK( IWRK ),
     $             LWORK+1-IWRK, IERR )
*
*     Initialize VL
*     (Complex Workspace: need N, prefer N*NB)
*
      IF( ILVL ) THEN
         CALL ZLASET( 'Full', N, N, CZERO, CONE, VL, LDVL )
         CALL ZLACPY( 'L', IROWS-1, IROWS-1, B( ILO+1, ILO ), LDB,
     $                VL( ILO+1, ILO ), LDVL )
         CALL ZUNGQR( IROWS, IROWS, IROWS, VL( ILO, ILO ), LDVL,
     $                WORK( ITAU ), WORK( IWRK ), LWORK+1-IWRK, IERR )
      END IF
*
*     Initialize VR
*
      IF( ILVR )
     $   CALL ZLASET( 'Full', N, N, CZERO, CONE, VR, LDVR )
*
*     Reduce to generalized Hessenberg form
*
      IF( ILV ) THEN
*
*        Eigenvectors requested -- work on whole matrix.
*
         CALL ZGGHRD( JOBVL, JOBVR, N, ILO, IHI, A, LDA, B, LDB, VL,
     $                LDVL, VR, LDVR, IERR )
      ELSE
         CALL ZGGHRD( 'N', 'N', IROWS, 1, IROWS, A( ILO, ILO ), LDA,
     $                B( ILO, ILO ), LDB, VL, LDVL, VR, LDVR, IERR )
      END IF
*
*     Perform QZ algorithm (Compute eigenvalues, and optionally, the
*     Schur form and Schur vectors)
*     (Complex Workspace: need N)
*     (Real Workspace: need N)
*
      IWRK = ITAU
      IF( ILV ) THEN
         CHTEMP = 'S'
      ELSE
         CHTEMP = 'E'
      END IF
      CALL ZHGEQZ( CHTEMP, JOBVL, JOBVR, N, ILO, IHI, A, LDA, B, LDB,
     $             ALPHA, BETA, VL, LDVL, VR, LDVR, WORK( IWRK ),
     $             LWORK+1-IWRK, RWORK( IRWRK ), IERR )
      IF( IERR.NE.0 ) THEN
         IF( IERR.GT.0 .AND. IERR.LE.N ) THEN
            INFO = IERR
         ELSE IF( IERR.GT.N .AND. IERR.LE.2*N ) THEN
            INFO = IERR - N
         ELSE
            INFO = N + 1
         END IF
         GO TO 70
      END IF
*
*     Compute Eigenvectors
*     (Real Workspace: need 2*N)
*     (Complex Workspace: need 2*N)
*
      IF( ILV ) THEN
         IF( ILVL ) THEN
            IF( ILVR ) THEN
               CHTEMP = 'B'
            ELSE
               CHTEMP = 'L'
            END IF
         ELSE
            CHTEMP = 'R'
         END IF
*
         CALL ZTGEVC( CHTEMP, 'B', LDUMMA, N, A, LDA, B, LDB, VL, LDVL,
     $                VR, LDVR, N, IN, WORK( IWRK ), RWORK( IRWRK ),
     $                IERR )
         IF( IERR.NE.0 ) THEN
            INFO = N + 2
            GO TO 70
         END IF
*
*        Undo balancing on VL and VR and normalization
*        (Workspace: none needed)
*
         IF( ILVL ) THEN
            CALL ZGGBAK( 'P', 'L', N, ILO, IHI, RWORK( ILEFT ),
     $                   RWORK( IRIGHT ), N, VL, LDVL, IERR )
            DO 30 JC = 1, N
               TEMP = ZERO
               DO 10 JR = 1, N
                  TEMP = MAX( TEMP, ABS1( VL( JR, JC ) ) )
   10          CONTINUE
               IF( TEMP.LT.SMLNUM )
     $            GO TO 30
               TEMP = ONE / TEMP
               DO 20 JR = 1, N
                  VL( JR, JC ) = VL( JR, JC )*TEMP
   20          CONTINUE
   30       CONTINUE
         END IF
         IF( ILVR ) THEN
            CALL ZGGBAK( 'P', 'R', N, ILO, IHI, RWORK( ILEFT ),
     $                   RWORK( IRIGHT ), N, VR, LDVR, IERR )
            DO 60 JC = 1, N
               TEMP = ZERO
               DO 40 JR = 1, N
                  TEMP = MAX( TEMP, ABS1( VR( JR, JC ) ) )
   40          CONTINUE
               IF( TEMP.LT.SMLNUM )
     $            GO TO 60
               TEMP = ONE / TEMP
               DO 50 JR = 1, N
                  VR( JR, JC ) = VR( JR, JC )*TEMP
   50          CONTINUE
   60       CONTINUE
         END IF
      END IF
*
*     Undo scaling if necessary
*
      IF( ILASCL )
     $   CALL ZLASCL( 'G', 0, 0, ANRMTO, ANRM, N, 1, ALPHA, N, IERR )
*
      IF( ILBSCL )
     $   CALL ZLASCL( 'G', 0, 0, BNRMTO, BNRM, N, 1, BETA, N, IERR )
*
   70 CONTINUE
      WORK( 1 ) = LWKOPT
*
      RETURN
*
*     End of ZGGEV
*
      END

C
C $Id: tdgrds.f,v 1.4 2008-07-27 00:17:32 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE TDGRDS (UMIN,VMIN,WMIN,UMAX,VMAX,WMAX,USTP,VSTP,WSTP,
     +                                                      IGRT,IHID)
C
C This routine may be called to draw the edges of the box containing
C a surface.  One may draw just the perimeter, the perimeter with
C inward-pointing tick marks, or the perimeter with a grid of lines.
C
C   UMIN, VMIN, WMIN, UMAX, VMAX, and WMAX are real input values, each
C   of which specifies one of the coordinate values defining the box in
C   3-space.  The names of these should make it clear what they are.
C
C   USTP, VSTP, and WSTP are real input values specifying step sizes
C   between ticks or grid lines in the U direction, the V direction,
C   and the W direction, respectively.
C
C   IGRT is an integer input value of the form 10*IGRN+IGRF, where IGRN
C   is a value specifying what to draw on the near sides of the box and
C   IGRF is a value specifying what to draw on the far sides of the box,
C   where "near" and "far" are defined by the current line of sight.
C   Each of IGRN and IGRF can have one of the values 0 (draw nothing),
C   1 (draw just a perimeter), 2 (draw a perimeter with inward-pointing
C   ticks), or 3 (draw a perimeter with a grid).
C
C   IHID is an integer input value set to 0 to draw only those sides of
C   the box that cannot be hidden by something inside the box or to 1 to
C   draw only those sides of the box that can be hidden by something
C   inside the box.  Standard operating procedure is to call TDGRDS
C   before drawing surfaces inside the box, with IHID set to 1, and
C   then call it again after drawing surfaces inside the box, this time
C   with IHID set to 0.
C
C Declare a required TDPACK common block.
C
        COMMON /TDCOM1/ IH,IT,XM,YM,ZM,XO,YO,ZO,XT,YT,ZT,OE,XE,YE,ZE
        COMMON /TDCOM1/ A1,B1,C1,D1,E1,A2,B2,C2,D2,E2,A3,B3,C3,D3,E3
        COMMON /TDCOM1/ IS,FV,VL,VR,VB,VT,WL,WR,WB,WT
        SAVE   /TDCOM1/
C
C Figure out for what values of U, V, and W ticks and grid lines should
C be drawn.
C
        IF (USTP.GT.0.) THEN
          UEPS=1.E-3*(UMAX-UMIN)
          IST1=INT((UMIN+UEPS)/USTP+.5+SIGN(.5,UMIN+UEPS))
          IST2=INT((UMAX-UEPS)/USTP-.5+SIGN(.5,UMAX-UEPS))
        ELSE
          IST1=1
          IST2=0
        END IF
C
        IF (VSTP.GT.0.) THEN
          VEPS=1.E-3*(VMAX-VMIN)
          JST1=INT((VMIN+VEPS)/VSTP+.5+SIGN(.5,VMIN+VEPS))
          JST2=INT((VMAX-VEPS)/VSTP-.5+SIGN(.5,VMAX-VEPS))
        ELSE
          JST1=1
          JST2=0
        END IF
C
        IF (WSTP.GT.0.) THEN
          WEPS=1.E-3*(WMAX-WMIN)
          KST1=INT((WMIN+WEPS)/WSTP+.5+SIGN(.5,WMIN+WEPS))
          KST2=INT((WMAX-WEPS)/WSTP-.5+SIGN(.5,WMAX-WEPS))
        ELSE
          KST1=1
          KST2=0
        END IF
C
C Sort out the various cases.  In each case, we call TDPARA to define
C the parallelogram in which things will be drawn and then pass the
C buck to the underlying routine TDGRID.
C
        IF ((IHID.EQ.0.AND.XE.LE.UMIN).OR.
     +      (IHID.NE.0.AND.XE.GT.UMIN)) THEN
          IF (XM.LT..5*(UMIN+UMAX)) THEN
            IGRD=MOD(IGRT/10,10)
          ELSE
            IGRD=MOD(IGRT,10)
          END IF
          CALL TDPARA (UMIN,VMIN,WMIN,0.,VMAX-VMIN,0.,0.,0.,WMAX-WMIN)
          CALL TDGRID ((REAL(JST1)*VSTP-VMIN)/(VMAX-VMIN),
     +                 VSTP/(VMAX-VMIN),JST2-JST1+1,
     +                 (REAL(KST1)*WSTP-WMIN)/(WMAX-WMIN),
     +                 WSTP/(WMAX-WMIN),KST2-KST1+1,IGRD)
        END IF
C
        IF ((IHID.NE.0.AND.XE.LE.UMAX).OR.
     +      (IHID.EQ.0.AND.XE.GT.UMAX)) THEN
          IF (XM.GE..5*(UMIN+UMAX)) THEN
            IGRD=MOD(IGRT/10,10)
          ELSE
            IGRD=MOD(IGRT,10)
          END IF
          CALL TDPARA (UMAX,VMIN,WMIN,0.,VMAX-VMIN,0.,0.,0.,WMAX-WMIN)
          CALL TDGRID ((REAL(JST1)*VSTP-VMIN)/(VMAX-VMIN),
     +                 VSTP/(VMAX-VMIN),JST2-JST1+1,
     +                 (REAL(KST1)*WSTP-WMIN)/(WMAX-WMIN),
     +                 WSTP/(WMAX-WMIN),KST2-KST1+1,IGRD)
        END IF
C
        IF ((IHID.EQ.0.AND.YE.LE.VMIN).OR.
     +      (IHID.NE.0.AND.YE.GT.VMIN)) THEN
          IF (YM.LT..5*(VMIN+VMAX)) THEN
            IGRD=MOD(IGRT/10,10)
          ELSE
            IGRD=MOD(IGRT,10)
          END IF
          CALL TDPARA (UMIN,VMIN,WMIN,UMAX-UMIN,0.,0.,0.,0.,WMAX-WMIN)
          CALL TDGRID ((REAL(IST1)*USTP-UMIN)/(UMAX-UMIN),
     +                 USTP/(UMAX-UMIN),IST2-IST1+1,
     +                 (REAL(KST1)*WSTP-WMIN)/(WMAX-WMIN),
     +                 WSTP/(WMAX-WMIN),KST2-KST1+1,IGRD)
        END IF
C
        IF ((IHID.NE.0.AND.YE.LE.VMAX).OR.
     +      (IHID.EQ.0.AND.YE.GT.VMAX)) THEN
          IF (YM.GE..5*(VMIN+VMAX)) THEN
            IGRD=MOD(IGRT/10,10)
          ELSE
            IGRD=MOD(IGRT,10)
          END IF
          CALL TDPARA (UMIN,VMAX,WMIN,UMAX-UMIN,0.,0.,0.,0.,WMAX-WMIN)
          CALL TDGRID ((REAL(IST1)*USTP-UMIN)/(UMAX-UMIN),
     +                 USTP/(UMAX-UMIN),IST2-IST1+1,
     +                 (REAL(KST1)*WSTP-WMIN)/(WMAX-WMIN),
     +                 WSTP/(WMAX-WMIN),KST2-KST1+1,IGRD)
        END IF
C
        IF ((IHID.EQ.0.AND.ZE.LE.WMIN).OR.
     +      (IHID.NE.0.AND.ZE.GT.WMIN)) THEN
          IF (ZM.LT..5*(WMIN+WMAX)) THEN
            IGRD=MOD(IGRT/10,10)
          ELSE
            IGRD=MOD(IGRT,10)
          END IF
          CALL TDPARA (UMIN,VMIN,WMIN,UMAX-UMIN,0.,0.,0.,VMAX-VMIN,0.)
          CALL TDGRID ((REAL(IST1)*USTP-UMIN)/(UMAX-UMIN),
     +                 USTP/(UMAX-UMIN),IST2-IST1+1,
     +                 (REAL(JST1)*VSTP-VMIN)/(VMAX-VMIN),
     +                 VSTP/(VMAX-VMIN),JST2-JST1+1,IGRD)
        END IF
C
        IF ((IHID.NE.0.AND.ZE.LE.WMAX).OR.
     +      (IHID.EQ.0.AND.ZE.GT.WMAX)) THEN
          IF (ZM.GE..5*(WMIN+WMAX)) THEN
            IGRD=MOD(IGRT/10,10)
          ELSE
            IGRD=MOD(IGRT,10)
          END IF
          CALL TDPARA (UMIN,VMIN,WMAX,UMAX-UMIN,0.,0.,0.,VMAX-VMIN,0.)
          CALL TDGRID ((REAL(IST1)*USTP-UMIN)/(UMAX-UMIN),
     +                 USTP/(UMAX-UMIN),IST2-IST1+1,
     +                 (REAL(JST1)*VSTP-VMIN)/(VMAX-VMIN),
     +                 VSTP/(VMAX-VMIN),JST2-JST1+1,IGRD)
        END IF
C
C Force a buffer flush.
C
        CALL PLOTIF (0.,0.,2)
C
C Done.
C
        RETURN
C
      END

      PROGRAM TAUTOG
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C OPEN GKS, OPEN WORKSTATION OF TYPE 1, ACTIVATE WORKSTATION
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C INVOKE DEMO DRIVER
C
      CALL AUTOG(IERR)
C
C DEACTIVATE AND CLOSE WORKSTATION, CLOSE GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END
C
      SUBROUTINE AUTOG (IERROR)
C
C PURPOSE                To provide a simple demonstration of
C                        the AUTOGRPH package.
C
C USAGE                  CALL AUTOG (IERROR)
C
C ARGUMENTS
C
C ON OUTPUT              IERROR
C                          An integer variable
C                          = 0, if the test was successful,
C                          = 1, otherwise
C
C I/O                    If the test is successful, the message
C
C               AUTOGRAPH TEST EXECUTED--SEE PLOTS TO CERTIFY
C
C                        is printed on unit 6.  In addition, 4
C                        frames are produced on the machine graphics
C                        device.  In order to determine if the test
C                        was successful, it is necessary to examine
C                        the plots.
C
C PRECISION              Single
C
C LANGUAGE               FORTRAN 77
C
C REQUIRED ROUTINES      AUTOGRPH, DASHCHAR
C
C REQUIRED GKS LEVEL     0A
C
C HISTORY                Originally written in April, 1979.
C                        Converted to FORTRAN 77 and GKS in Feb., 1985.
C
C ALGORITHM              TAUTOG computes data which is plotted in single
C                        calls to each of the entries
C
C                          EZY, EZXY, EZMY, AND EZMXY.
C
C                        On 3 of the plots, routines AGSETF, AGSETI,
C                        and AGSETP are called to specify Y-axis labels
C                        or to introduce log scaling.
C
      REAL            X(21)      ,Y1D(21)    ,Y2D(21,5)
C
C X contains the abscissae for the plots produced by EZXY and
C EZMXY,  Y1D contains the ordinate values for the plots produced by
C EZXY and EZY,  and Y2D contains the ordinate values for the plots
C produced by EZMY and EZMXY.
C
C
C     Frame 1 -- EZY entry of AUTOGRAPH.
C
C Fill Y1D array for entry EZY.
C
      DO  10 I=1,21
         Y1D(I) = EXP(-.1*REAL(I))*COS(REAL(I)*.5)
   10 CONTINUE
C
C Entry EZY plots Y1D as a function of a set of continuous integers.
C
C       DEMONSTRATING EZY ENTRY OF AUTOGRAPH
C
      CALL EZY (Y1D(1),21,'DEMONSTRATING EZY ENTRY OF AUTOGRAPH$')
C
C     Frame 2 -- EZXY entry of AUTOGRAPH.
C
C Fill X and Y1D arrays for entry EZXY.
C
      DO  20 I=1,21
         X(I) = REAL(I-1)*.314
         Y1D(I) = X(I)+COS(X(I))*2.0
   20 CONTINUE
C
C Set AUTOGRAPH control parameters for Y-axis label   "X+COS(X)*2"
C
      CALL AGSETC('LABEL/NAME.','L')
      CALL AGSETI('LINE/NUMBER.',100)
      CALL AGSETC('LINE/TEXT.','X+COS(X)*2$')
C
C Entry EZXY plots contents of X-array vs. Y1D-array.
C
C       DEMONSTRATING EZXY ENTRY OF AUTOGRAPH
C
      CALL EZXY (X,Y1D,21,'DEMONSTRATING EZXY ENTRY IN AUTOGRAPH$')
C
C     Frame 3 -- EZMY entry of AUTOGRAPH.
C
C Fill Y2D array for entry EZMY.
C
      DO  40 I=1,21
         T = .5*REAL(I-1)
         DO  30 J=1,5
            Y2D(I,J) = EXP(-.5*T)*COS(T)/REAL(J)
   30    CONTINUE
   40 CONTINUE
C
C Set the AUTOGRAPH control parameters for Y-axis label
C         EXP(-X/2)*COS(X)*SCALE
C
      CALL AGSETC('LABEL/NAME.','L')
      CALL AGSETI('LINE/NUMBER.',100)
      CALL AGSETC('LINE/TEXT.','EXP(-X/2)*COS(X)*SCALE$')
C
C Use the AUTOGRAPH control parameter for integers to specify the
C alphabetic set of dashed line patterns.
C
      CALL AGSETI('DASH/SELECTOR.',-1)
C
C Use the AUTOGRAPH control parameter for integers to specify the
C graph drawn is to be logarithmic in the X-axis.
C
      CALL AGSETI('X/LOGARITHMIC.',1)
C
C Entry EZMY plots multiple arrays as a function of continuous integers.
C
C       DEMONSTRATING EZMY ENTRY OF AUTOGRAPH
C
      CALL EZMY (Y2D,21,5,10,'DEMONSTRATING EZMY ENTRY OF AUTOGRAPH$')
C
C     Frame 4 -- EZMXY entry of AUTOGRAPH.
C
C Fill Y2D array for EZMXY.
C
      DO  60 I=1,21
         DO  50 J=1,5
            Y2D(I,J) = X(I)**J+COS(X(I))
   50    CONTINUE
   60 CONTINUE
C
C Set the AUTOGRAPH control parameters for Y-axis label
C         X**J+COS(X)
C
      CALL AGSETC('LABEL/NAME.','L')
      CALL AGSETI('LINE/NUMBER.',100)
      CALL AGSETC('LINE/TEXT.','X**J+COS(X)$')
C
C Use the AUTOGRAPH control parameter for integers to specify the
C alphabetic set of dashed line patterns.
C
      CALL AGSETI('DASH/SELECTOR.',-1)
C
C Use the AUTOGRAPH control parameter for integers to specify the
C graph have a linear X-axis and a logarithmic Y-axis.
C
      CALL AGSETI('X/LOGARITHMIC.',0)
      CALL AGSETI('Y/LOGARITHMIC.',1)
C
C Entry EZMXY plots multiple Y arrays as a function of a single
C or multiple X arrays.
C
C       DEMONSTRATING EZMXY ENTRY OF AUTOGRAPH
C
      CALL EZMXY (X,Y2D,21,5,21,
     +            'DEMONSTRATING EZMXY ENTRY OF AUTOGRAPH$')
C
C Note that AUTOGRAPH makes its own FRAME advance calls.
C
      IERROR = 0
      WRITE (6,1001)
C
      RETURN
C
 1001 FORMAT (' AUTOGRAPH TEST EXECUTED--SEE PLOTS TO CERTIFY')
C
      END

C
C $Id: maplmb.f,v 1.20 2008-09-18 00:42:16 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MAPLMB
        IF (ICFELL('MAPLMB - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
        CALL MDPLMB
        IF (ICFELL('MAPLMB',2).NE.0) RETURN
        RETURN
      END

C
C       $Id: curvs2.f,v 1.3 2008-07-27 03:10:11 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
C NOTE: If you make any changes to this software, please remember to
C make the same changes to the corresponding double precision routine.
C
      SUBROUTINE CURVS2(T,N,PARAM,X,Y,XP,YP,SIGMA,XO,YO)
C
C  This subroutine is a companion to CURV1S which must be
C  called before calling this subroutine.  CURV2S calculates
C  an interpolated value for a smoothing spline under tension 
C  at a given point.  CURVS1 must be called before CURVS2 to 
C  determine certain necessary parameters.
C
C  On input:
C
C    T 
C      A real value to be mapped onto the interpolating curve.
C      Values of T between zero and one interpolate the original
C      data; any values of T outside this range result in
C      extrapolation.
C
C    N 
C      The number of points which were specified to
C      determine the curve.
C
C    PARAM
C      The arc lengths computed by CURVS1.
C
C    X 
C      An array containing the X-coordinate values of the specified points.
C
C    Y 
C      An array containing the Y-coordinate values of the specified points.
C
C    XP 
C      An array of second derivative values as calculated by CURVS1.
C
C    YP 
C      An array of second derivative values as calculated by CURVS1.
C
C    SIGMA 
C      The tension factor (its sign is ignored).
C
C  On output:
C
C    XO
C      The interpolated X value.
C
C    YO
C      The interpolated Y value.
C
C  The parameters N, X, Y, XP, YP, and SIGMA should be input
C  unaltered from the output of CURVS1.
C
      REAL T,PARAM(N),X(N),Y(N),XP(N),YP(N),SIGMA
C
      XO = CURV2(T,N,PARAM,X,XP,SIGMA)
      YO = CURV2(T,N,PARAM,Y,YP,SIGMA)
C     
      RETURN
      END

      PROGRAM FCCE01
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C  This program provides a demonstration of setting up a color table 
C  and specifying colors for the GKS primitives: lines, markers, text, 
C  and filled areas.
C
C  Corrdinate data for polyline and polymarker draws.
C
       DIMENSION X1(5),X2(5),Y(5)
       DATA X1/0.15, 0.35, 0.35, 0.15, 0.15/
       DATA X2/0.65, 0.85, 0.85, 0.65, 0.65/
       DATA Y /0.45, 0.45, 0.65, 0.65, 0.45/
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C  Set up the color table for the CGM workstation:
C    
C    Index  Color
C    -----  -----
C      0    Black (background color)
C      1    White (foreground color)
C      2    Red
C      3    Green
C      4    Yellow
C      5    Cyan
C
      CALL GSCR(IWKID, 0, 0.0, 0.0, 0.0)
      CALL GSCR(IWKID, 1, 1.0, 1.0, 1.0)
      CALL GSCR(IWKID, 2, 1.0, 0.0, 0.0)
      CALL GSCR(IWKID, 3, 0.0, 1.0, 0.0)
      CALL GSCR(IWKID, 4, 1.0, 1.0, 0.0)
      CALL GSCR(IWKID, 5, 0.0, 1.0, 1.0)
C
C  Draw a green rectangle.
C
      CALL GSPLCI(3)
      CALL GPL(5,X1,Y)
C
C  Draw an asterisk scaled by 4. in the foreground color.
C
      CALL GSMKSC(4.)
      CALL GPM(1,.5,.25)
C
C  Draw a text string in yellow.
C
      CALL GSTXCI(4)
      CALL GTX(0.5,0.5,'Text')
C
C  Draw a filled rectangle in cyan.
C
      CALL GSFACI(5)
      CALL GSFAIS(1)
      CALL GFA(5,X2,Y)
C
C  Draw a red asterisk.
C
      CALL GSPMCI(2)
      CALL GPM(1,.5,.75)
C
C Advance the frame.
C
      CALL FRAME
C
C  Terminate the picture, deactivate and close the CGM workstation, 
C  close GKS.
C
      CALL GDAWK(IWKID)
      CALL GCLWK(IWKID)
      CALL GCLKS
C
      END

      SUBROUTINE DSYSV( UPLO, N, NRHS, A, LDA, IPIV, B, LDB, WORK,
     $                  LWORK, INFO )
*
*  -- LAPACK driver routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          UPLO
      INTEGER            INFO, LDA, LDB, LWORK, N, NRHS
*     ..
*     .. Array Arguments ..
      INTEGER            IPIV( * )
      DOUBLE PRECISION   A( LDA, * ), B( LDB, * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  DSYSV computes the solution to a real system of linear equations
*     A * X = B,
*  where A is an N-by-N symmetric matrix and X and B are N-by-NRHS
*  matrices.
*
*  The diagonal pivoting method is used to factor A as
*     A = U * D * U**T,  if UPLO = 'U', or
*     A = L * D * L**T,  if UPLO = 'L',
*  where U (or L) is a product of permutation and unit upper (lower)
*  triangular matrices, and D is symmetric and block diagonal with
*  1-by-1 and 2-by-2 diagonal blocks.  The factored form of A is then
*  used to solve the system of equations A * X = B.
*
*  Arguments
*  =========
*
*  UPLO    (input) CHARACTER*1
*          = 'U':  Upper triangle of A is stored;
*          = 'L':  Lower triangle of A is stored.
*
*  N       (input) INTEGER
*          The number of linear equations, i.e., the order of the
*          matrix A.  N >= 0.
*
*  NRHS    (input) INTEGER
*          The number of right hand sides, i.e., the number of columns
*          of the matrix B.  NRHS >= 0.
*
*  A       (input/output) DOUBLE PRECISION array, dimension (LDA,N)
*          On entry, the symmetric matrix A.  If UPLO = 'U', the leading
*          N-by-N upper triangular part of A contains the upper
*          triangular part of the matrix A, and the strictly lower
*          triangular part of A is not referenced.  If UPLO = 'L', the
*          leading N-by-N lower triangular part of A contains the lower
*          triangular part of the matrix A, and the strictly upper
*          triangular part of A is not referenced.
*
*          On exit, if INFO = 0, the block diagonal matrix D and the
*          multipliers used to obtain the factor U or L from the
*          factorization A = U*D*U**T or A = L*D*L**T as computed by
*          DSYTRF.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(1,N).
*
*  IPIV    (output) INTEGER array, dimension (N)
*          Details of the interchanges and the block structure of D, as
*          determined by DSYTRF.  If IPIV(k) > 0, then rows and columns
*          k and IPIV(k) were interchanged, and D(k,k) is a 1-by-1
*          diagonal block.  If UPLO = 'U' and IPIV(k) = IPIV(k-1) < 0,
*          then rows and columns k-1 and -IPIV(k) were interchanged and
*          D(k-1:k,k-1:k) is a 2-by-2 diagonal block.  If UPLO = 'L' and
*          IPIV(k) = IPIV(k+1) < 0, then rows and columns k+1 and
*          -IPIV(k) were interchanged and D(k:k+1,k:k+1) is a 2-by-2
*          diagonal block.
*
*  B       (input/output) DOUBLE PRECISION array, dimension (LDB,NRHS)
*          On entry, the N-by-NRHS right hand side matrix B.
*          On exit, if INFO = 0, the N-by-NRHS solution matrix X.
*
*  LDB     (input) INTEGER
*          The leading dimension of the array B.  LDB >= max(1,N).
*
*  WORK    (workspace/output) DOUBLE PRECISION array, dimension (LWORK)
*          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*
*  LWORK   (input) INTEGER
*          The length of WORK.  LWORK >= 1, and for best performance
*          LWORK >= N*NB, where NB is the optimal blocksize for
*          DSYTRF.
*
*          If LWORK = -1, then a workspace query is assumed; the routine
*          only calculates the optimal size of the WORK array, returns
*          this value as the first entry of the WORK array, and no error
*          message related to LWORK is issued by XERBLA.
*
*  INFO    (output) INTEGER
*          = 0: successful exit
*          < 0: if INFO = -i, the i-th argument had an illegal value
*          > 0: if INFO = i, D(i,i) is exactly zero.  The factorization
*               has been completed, but the block diagonal matrix D is
*               exactly singular, so the solution could not be computed.
*
*  =====================================================================
*
*     .. Local Scalars ..
      LOGICAL            LQUERY
      INTEGER            LWKOPT, NB
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            ILAENV
      EXTERNAL           LSAME, ILAENV
*     ..
*     .. External Subroutines ..
      EXTERNAL           DSYTRF, DSYTRS, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      LQUERY = ( LWORK.EQ.-1 )
      IF( .NOT.LSAME( UPLO, 'U' ) .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( NRHS.LT.0 ) THEN
         INFO = -3
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -5
      ELSE IF( LDB.LT.MAX( 1, N ) ) THEN
         INFO = -8
      ELSE IF( LWORK.LT.1 .AND. .NOT.LQUERY ) THEN
         INFO = -10
      END IF
*
      IF( INFO.EQ.0 ) THEN
         NB = ILAENV( 1, 'DSYTRF', UPLO, N, -1, -1, -1 )
         LWKOPT = N*NB
         WORK( 1 ) = LWKOPT
      END IF
*
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DSYSV ', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         RETURN
      END IF
*
*     Compute the factorization A = U*D*U' or A = L*D*L'.
*
      CALL DSYTRF( UPLO, N, A, LDA, IPIV, WORK, LWORK, INFO )
      IF( INFO.EQ.0 ) THEN
*
*        Solve the system A*X = B, overwriting B with X.
*
         CALL DSYTRS( UPLO, N, NRHS, A, LDA, IPIV, B, LDB, INFO )
*
      END IF
*
      WORK( 1 ) = LWKOPT
*
      RETURN
*
*     End of DSYSV
*
      END

C
C	$Id: wmw2nx.f,v 1.4 2008-07-27 00:17:37 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE WMW2NX(NPT,P,Q)
C
C  This subroutine takes the NPT points in the real array P,
C  which are assumed to be in world coordinates, and, using
C  the current normalization transformation, converts them
C  into NDC coordinates and stores them in Q.  This subroutine
C  operates on X-coordinates.
C
      INTEGER NPT
      REAL P(NPT),Q(NPT)
      REAL WINDOW(4),VIEWPT(4)
C
      CALL GQCNTN(IER,NTR)
      CALL GQNT(NTR,IER,WINDOW,VIEWPT)
      SCALE = (VIEWPT(2)-VIEWPT(1))/(WINDOW(2)-WINDOW(1))
      DO 20 I=1,NPT
        Q(I) = VIEWPT(1)+(P(I)-WINDOW(1))*SCALE
   20 CONTINUE
C
      RETURN
      END

C
C     $Id: shgeti.f,v 1.5 2008-07-27 03:10:13 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE SHGETI (CNP,IVP)
C
      SAVE
C
      CHARACTER*(*) CNP
C
C  This subroutine is called to retrieve the integer value of a specified
C  parameter.
C
C  CNP is the name of the parameter whose value is to be retrieved.
C
C  IVP is an integer variable in which the desired value is to be
C  returned by SHGETI.
C
C
C  Declare a local character variable in which to form an error message.
C
      CHARACTER*80 CTM
C
      include 'shcomn.h'
C
C  Do a call forcing a BLOCKDATA to be loaded from a binary library.
C
      CALL SHBLDA
C
C  Check for an uncleared prior error.
C
      IF (ICFELL('SHGETI - Uncleared prior error',1).NE.0) RETURN
C
C Check for a parameter name that is too short.
C
      IF (LEN(CNP) .LT. 3) THEN
        CTM(1:36)='SHGETI - Parameter name too short - '
        CTM(37:36+LEN(CNP)) = CNP
        CALL SETER (CTM(1:36+LEN(CNP)), 1, 1)
        GO TO 110
      ENDIF
C
C Get the appropriate parameter value.
C
      IF (CNP(1:3).EQ.'NFL' .OR. CNP(1:3).EQ.'nfl' .OR. 
     +    CNP(1:3).EQ.'Nfl') THEN
        IVP = NMINFL
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'NLS' .OR. CNP(1:3).EQ.'nls' .OR. 
     +    CNP(1:3).EQ.'Nls') THEN
        IVP = NMLSTQ
        GO TO 110
      ELSE IF (CNP(1:3).EQ.'NCL' .OR. CNP(1:3).EQ.'ncl' .OR. 
     +    CNP(1:3).EQ.'Ncl') THEN
        IVP = NMCELS
        GO TO 110
      ELSE
        CTM(1:36) = 'SHGETI - Parameter name not known - '
        CTM(37:39) = CNP(1:3)
        CALL SETER (CTM(1:39), 2, 1)
        GO TO 110
      ENDIF
C
  110 CONTINUE
      RETURN
      END

      PROGRAM PGKEX03
C
C  Use inquiry functions to implement a subroutine (DRWTXT below)
C  that puts out text using Normalized Device Coordinates (NDC) 
C  for positioning.  Invoke Autograph to draw a linear/log plot
C  and then call DRWTXT two times to label the Autograph plot.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      DIMENSION X(100),Y(100)
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDUM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C  Define a small color table.
C
      CALL GSCR(IWKID,0,1.,1.,1.)
      CALL GSCR(IWKID,1,0.,0.,1.)
      CALL GSCR(IWKID,2,1.,0.,0.)
C
C  Generate a straight line with 100 points.
C
      DO 1 I=1,100
        X(I) = I
        Y(I) = 10.*I
  1   CONTINUE
C
C  Use SET to define normalization transformation 1 with linear 
C  scaling in the X direction and log scaling in the Y direction.
C
      CALL SET(.15,.85,.15,.85,1.,100.,10.,1000.,2)
C
C  Set line color to red.
C
      CALL GSPLCI(2)
C
C  Initialize the AUTOGRAPH entry EZXY so that the frame is not 
C  advanced and the Y axis is logarithmic.  Turn off axis labels.
C
      CALL DISPLA(2,0,2)
      CALL ANOTAT(' ',' ',0,0,0,0)
C
C  Output the polyline (X,Y) using EZXY.
C
      CALL EZXY(X,Y,100,' ')
C
C  Put out a couple of labels (DRWTXT uses NDC space).
C
      CALL DRWTXT(.50,.07,'The X axis is linear',-7,.025,0.)
      CALL DRWTXT(.07,.50,'The Y axis is log',-7,.025,90.)
C
C  Terminate the picture, deactivate and close the CGM workstation,
C  and close GKS.
C
      CALL FRAME
      CALL GDAWK(IWKID)
      CALL GCLWK(IWKID)
      CALL GCLKS
C
      STOP
      END
      SUBROUTINE DRWTXT(X,Y,TXT,IFNT,CHGT,ANG)
C
C  This subroutine draws the text string in TXT at position (X,Y) using
C  font IFNT with character height CHGT (specified in NDC) and text 
C  angle ANG degrees.  The position (X,Y) is in NDC. This subroutine 
C  is isolated from any GKS attribute settings in the calling program 
C  by using inquiry functions to save all settings on entry and restore 
C  all settings on exit.  The text is aligned as (center, half) and is 
C  drawn in the foreground color.  
C
      INTEGER   ERRIND
      DIMENSION CLRECT(4)
      CHARACTER*(*) TXT
      DATA PI  /3.1415927/
C
C  Inquire and save the state of all attributes that will be used in
C  this subroutine.  These will be restored on exit.
C
C   Clipping
      CALL GQCLIP(ERRIND,ICLIPO,CLRECT)
C
C   Character up vector.
      CALL GQCHUP(ERRIND,CHUPXO,CHUPYO)
C
C   Text alignment.
      CALL GQTXAL(ERRIND,ILNHO,ILNVO)
C
C   Text font.
      CALL GQTXFP(ERRIND,ITXFO,ITXPO)
C
C   Character height.
      CALL GQCHH(ERRIND,CHHO)
C
C  Get and save the existing normalization transformation information,
C  including the log scaling parameter..
C
      CALL GETSET(XV1,XV2,YV1,YV2,XW1,XW2,YW1,YW2,LS)
C
C  Use NDC space for drawing TXT.
C
      CALL GSELNT(0)
C
C  Define the text font.
C
      CALL GSTXFP(IFNT,2)
C
C  Set the character height.
C
      CALL GSCHH(CHGT)
C
C  Set the text alignment to (center, half).
C
      CALL GSTXAL(2,3)
C
C  Select the foreground color.
C
      CALL GSTXCI(1)
C
C  Define the character up vector in accordance with ANG (recall that
C  the up vector is perpendicular to the text path).
C
      RANG = (ANG+90.)*(2.*PI/360.)
      CALL GSCHUP(COS(RANG),SIN(RANG))
C
C  Draw the text string in TXT.
C
      CALL GTX(X,Y,TXT)
C
C  Restore the original normalization transformation.
C
      CALL SET(XV1,XV2,YV1,YV2,XW1,XW2,YW1,YW2,LS)
C
C  Restore all other attributes.
C
      CALL GSCLIP(ICLIPO)
      CALL GSCHUP(CHUPXO,CHUPYO)
      CALL GSTXAL(ILNHO,ILNVO)
      CALL GSTXFP(ITXFO,ITXPO)
      CALL GSCHH (CHHO)
C
      RETURN
      END

      PROGRAM TAGUPW
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C OPEN GKS, OPEN WORKSTATION OF TYPE 1, ACTIVATE WORKSTATION
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C INVOKE DEMO DRIVER
C
      CALL AGUPW(IERR)
C
C DEACTIVATE AND CLOSE WORKSTATION, CLOSE GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END
C
      SUBROUTINE AGUPW (IERROR)
C
C PURPOSE                To provide a simple demonstration of the use
C                        of AGUPWRTX with AUTOGRAPH.
C
C USAGE                  CALL AGUPW (IERROR)
C
C ARGUMENTS
C
C ON OUTPUT              IERROR
C
C                          an error parameter
C                          = 0, if the test is successful,
C                          = 1, otherwise
C
C I/O                    If the test is successful, the message
C
C                          AGUPWRTX TEST SUCCESSFUL  . . .  SEE PLOTS
C                          TO VERIFY PERFORMANCE
C
C                        is written on unit 6.
C
C                        In addition, four (4) labelled frames
C                        containing the two-dimensional plots are
C                        produced on the machine graphics device.
C                        To determine if the test was successful,
C                        it is necessary to examine these plots.
C
C PRECISION              Single.
C
C REQUIRED LIBRARY       AUTOGRAPH, AGUPWRTX, PWRITX, SPPS
C FILES
C
C REQUIRED GKS LEVEL     0A
C
C LANGUAGE               FORTRAN
C
C HISTORY                Adapted from TAUTOG, in June, 1987.
C
C ALGORITHM              TAGUPW computes data for AUTOGRAPH subroutines
C
C                          EZY, EZXY, EZMY, and EZMXY,
C
C                        and calls each of these routines to produce
C                        one plot each.
C
C                        On three of the plots, TAGUPW uses the
C                        AUTOGRAPH control parameter routines
C                        AGSETF, AGSETI, and AGSETP to specify
C                        Y-axis labels or introduce log scaling.
C
C                        Loading AGUPWRTX with AUTOGRAPH caused the
C                        labels to be written by PWRITX.
C
C PORTABILITY            FORTRAN 77
C
C
C
C Declare the data arrays X, Y1D, and Y2D.  X contains abscissae for
C the plots produced by EZXY and EZMXY,  Y1D contains ordinates for
C the plots produced by EZXY and EZY,  and Y2D contains ordinates for
C the plots produced by EZMY and EZMXY.
C
      REAL X(21),Y1D(21),Y2D(21,5)
C
C
C
C Fill the array Y1D for the call to EZY.
C
      DO  10 I=1,21
         Y1D(I) = EXP(-.1*REAL(I))*COS(REAL(I)*.5)
   10 CONTINUE
C
C Plot the contents of Y1D as a function of the integers.
C
      CALL EZY (Y1D(1),21,'DEMONSTRATING EZY ENTRY OF AUTOGRAPH$')
C
C
C
C Fill the arrays X and Y1D for the call to EZXY.
C
      DO  20 I=1,21
         X(I) = REAL(I-1)*.314
         Y1D(I) = X(I)+COS(X(I))*2.0
   20 CONTINUE
C
C Redefine the Y-axis label.
C
      CALL AGSETC('LABEL/NAME.','L')
      CALL AGSETI('LINE/NUMBER.',100)
      CALL AGSETC('LINE/TEXT.','X+COS(X)*2$')
C
C Plot the array Y1D as a function of the array X.
C
      CALL EZXY (X,Y1D,21,'DEMONSTRATING EZXY ENTRY IN AUTOGRAPH$')
C
C
C
C Fill the array Y2D for the call to EZMY.
C
      DO  40 I=1,21
         T = .5*REAL(I-1)
         DO  30 J=1,5
            Y2D(I,J) = EXP(-.5*T)*COS(T)/REAL(J)
   30    CONTINUE
   40 CONTINUE
C
C Redefine the Y-axis label.
C
      CALL AGSETC('LABEL/NAME.','L')
      CALL AGSETI('LINE/NUMBER.',100)
      CALL AGSETC('LINE/TEXT.','EXP(-X/2)*COS(X)*SCALE$')
C
C Specify that the alphabetic set of dashed line patterns is to be used.
C
      CALL AGSETI('DASH/SELECTOR.',-1)
C
C Specify that the graph drawn is to be logarithmic in X.
C
      CALL AGSETI('X/LOGARITHMIC.',1)
C
C Plot the five curves defined by Y2D as functions of the integers.
C
      CALL EZMY (Y2D,21,5,10,'DEMONSTRATING EZMY ENTRY OF AUTOGRAPH$')
C
C
C
C Fill the array Y2D for the call to EZMXY.
C
      DO  60 I=1,21
         DO  50 J=1,5
            Y2D(I,J) = X(I)**J+COS(X(I))
   50    CONTINUE
   60 CONTINUE
C
C Redefine the Y-axis label.
C
      CALL AGSETC('LABEL/NAME.','L')
      CALL AGSETI('LINE/NUMBER.',100)
      CALL AGSETC('LINE/TEXT.','X**J+COS(X)$')
C
C Specify that the graph is to be linear in X and logarithmic in Y.
C
      CALL AGSETI('X/LOGARITHMIC.',0)
      CALL AGSETI('Y/LOGARITHMIC.',1)
C
C Plot the five curves defined by Y2D as functions of X.
C
      CALL EZMXY (X,Y2D,21,5,21,
     +            'DEMONSTRATING EZMXY ENTRY OF AUTOGRAPH$')
C
C
C
C Done.
C
      IERROR = 0
      WRITE (6,1001)
C
      RETURN
C
C
C
 1001 FORMAT ('  AGUPWRTX TEST SUCCESSFUL',24X,
     1        'SEE PLOTS TO VERIFY PERFORMANCE')
C
      END

      SUBROUTINE ZTREXC( COMPQ, N, T, LDT, Q, LDQ, IFST, ILST, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     March 31, 1993
*
*     .. Scalar Arguments ..
      CHARACTER          COMPQ
      INTEGER            IFST, ILST, INFO, LDQ, LDT, N
*     ..
*     .. Array Arguments ..
      COMPLEX*16         Q( LDQ, * ), T( LDT, * )
*     ..
*
*  Purpose
*  =======
*
*  ZTREXC reorders the Schur factorization of a complex matrix
*  A = Q*T*Q**H, so that the diagonal element of T with row index IFST
*  is moved to row ILST.
*
*  The Schur form T is reordered by a unitary similarity transformation
*  Z**H*T*Z, and optionally the matrix Q of Schur vectors is updated by
*  postmultplying it with Z.
*
*  Arguments
*  =========
*
*  COMPQ   (input) CHARACTER*1
*          = 'V':  update the matrix Q of Schur vectors;
*          = 'N':  do not update Q.
*
*  N       (input) INTEGER
*          The order of the matrix T. N >= 0.
*
*  T       (input/output) COMPLEX*16 array, dimension (LDT,N)
*          On entry, the upper triangular matrix T.
*          On exit, the reordered upper triangular matrix.
*
*  LDT     (input) INTEGER
*          The leading dimension of the array T. LDT >= max(1,N).
*
*  Q       (input/output) COMPLEX*16 array, dimension (LDQ,N)
*          On entry, if COMPQ = 'V', the matrix Q of Schur vectors.
*          On exit, if COMPQ = 'V', Q has been postmultiplied by the
*          unitary transformation matrix Z which reorders T.
*          If COMPQ = 'N', Q is not referenced.
*
*  LDQ     (input) INTEGER
*          The leading dimension of the array Q.  LDQ >= max(1,N).
*
*  IFST    (input) INTEGER
*  ILST    (input) INTEGER
*          Specify the reordering of the diagonal elements of T:
*          The element with row index IFST is moved to row ILST by a
*          sequence of transpositions between adjacent elements.
*          1 <= IFST <= N; 1 <= ILST <= N.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*
*  =====================================================================
*
*     .. Local Scalars ..
      LOGICAL            WANTQ
      INTEGER            K, M1, M2, M3
      DOUBLE PRECISION   CS
      COMPLEX*16         SN, T11, T22, TEMP
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           XERBLA, ZLARTG, ZROT
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          DCONJG, MAX
*     ..
*     .. Executable Statements ..
*
*     Decode and test the input parameters.
*
      INFO = 0
      WANTQ = LSAME( COMPQ, 'V' )
      IF( .NOT.LSAME( COMPQ, 'N' ) .AND. .NOT.WANTQ ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( LDT.LT.MAX( 1, N ) ) THEN
         INFO = -4
      ELSE IF( LDQ.LT.1 .OR. ( WANTQ .AND. LDQ.LT.MAX( 1, N ) ) ) THEN
         INFO = -6
      ELSE IF( IFST.LT.1 .OR. IFST.GT.N ) THEN
         INFO = -7
      ELSE IF( ILST.LT.1 .OR. ILST.GT.N ) THEN
         INFO = -8
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'ZTREXC', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.1 .OR. IFST.EQ.ILST )
     $   RETURN
*
      IF( IFST.LT.ILST ) THEN
*
*        Move the IFST-th diagonal element forward down the diagonal.
*
         M1 = 0
         M2 = -1
         M3 = 1
      ELSE
*
*        Move the IFST-th diagonal element backward up the diagonal.
*
         M1 = -1
         M2 = 0
         M3 = -1
      END IF
*
      DO 10 K = IFST + M1, ILST + M2, M3
*
*        Interchange the k-th and (k+1)-th diagonal elements.
*
         T11 = T( K, K )
         T22 = T( K+1, K+1 )
*
*        Determine the transformation to perform the interchange.
*
         CALL ZLARTG( T( K, K+1 ), T22-T11, CS, SN, TEMP )
*
*        Apply transformation to the matrix T.
*
         IF( K+2.LE.N )
     $      CALL ZROT( N-K-1, T( K, K+2 ), LDT, T( K+1, K+2 ), LDT, CS,
     $                 SN )
         CALL ZROT( K-1, T( 1, K ), 1, T( 1, K+1 ), 1, CS,
     $              DCONJG( SN ) )
*
         T( K, K ) = T22
         T( K+1, K+1 ) = T11
*
         IF( WANTQ ) THEN
*
*           Accumulate transformation in the matrix Q.
*
            CALL ZROT( N, Q( 1, K ), 1, Q( 1, K+1 ), 1, CS,
     $                 DCONJG( SN ) )
         END IF
*
   10 CONTINUE
*
      RETURN
*
*     End of ZTREXC
*
      END

      PROGRAM FSPPONTS
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Create a line plot with connected markers using points.
C
      REAL XDRA(20),YDRA(20)
      REAL X2DRA(20),Y2DRA(20)
      REAL X3DRA(20),Y3DRA(20)

      DATA NPTS/20/
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Set up a color table
C
      CALL DFCLRS (IWKID)
C
C Fill the data arrays.
C
      DO 101 I=1,NPTS
         XDRA(I)=SIN(REAL(I))
         YDRA(I)=COS(REAL(I))
         X2DRA(I)=XDRA(I) * .66
         Y2DRA(I)=YDRA(I) * .66
         X3DRA(I)=XDRA(I) * .3
         Y3DRA(I)=YDRA(I) * .3
 101  CONTINUE
C
C Draw a boundary around the edge of the plotter frame.
C
      CALL BNDARY
C
C Suppress the frame advance.
C
      CALL AGSETI ('FRAME.',2)
C
C Suppress the drawing of curves by the EZ... routines.
C
      CALL AGSETI ('SET.',-1)
C
C Draw the background, using EZXY.
C
      CALL EZXY (XDRA,YDRA,NPTS,'POINTS EXAMPLE$')
C
C Increase the size of the polymarkers
C
      CALL GSMKSC(2.0)
C
C Set the color of the polymarker
C
      CALL GSPLCI(7)
C
C Set the line width of the lines connecting the polymarkers.
C
      CALL GSLWSC(3.0)
C
C Put a plus sign at each of the x-y positions.
C
      CALL POINTS (XDRA,YDRA,NPTS,-2,1)
C
C Set the color of the polymarker
C
      CALL GSPLCI(9)
C
C Put a circle at each of the x2-y2 positions.
C
      CALL POINTS (X2DRA,Y2DRA,NPTS,-4,1)
C
C Put an asterix at each of the x3-y3 positions,
C and do not connect with lines.
C
      CALL POINTS (X3DRA,Y3DRA,NPTS,-3,0)
C
C Advance the frame.
C
      CALL FRAME
C
C Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
C
      END

      SUBROUTINE BNDARY
C
C Routine to draw the plotter-frame edge.
C
      CALL PLOTIT (    0,    0,0)
      CALL PLOTIT (32767,    0,1)
      CALL PLOTIT (32767,32767,1)
      CALL PLOTIT (    0,32767,1)
      CALL PLOTIT (    0,    0,1)
      RETURN
      END

      SUBROUTINE DFCLRS (IWKID)
C
C Define a set of RGB color triples for colors 1 through 15.
C
      DIMENSION RGBV(3,15)
C
C Define the RGB color triples needed below.
C
      DATA RGBV / 0.00 , 0.00 , 0.00 ,
     +     0.70 , 0.70 , 0.70 ,
     +     0.75 , 0.50 , 1.00 ,
     +     0.50 , 0.00 , 1.00 ,
     +     0.00 , 0.00 , 1.00 ,
     +     0.00 , 0.50 , 1.00 ,
     +     0.00 , 1.00 , 1.00 ,
     +     0.00 , 1.00 , 0.60 ,
     +     0.00 , 1.00 , 0.00 ,
     +     0.70 , 1.00 , 0.00 ,
     +     1.00 , 1.00 , 0.00 ,
     +     1.00 , 0.75 , 0.00 ,
     +     1.00 , 0.38 , 0.38 ,
     +     1.00 , 0.00 , 0.38 ,
     +     1.00 , 0.00 , 0.00 /
C
C Define 16 different color indices, for indices 0 through 15.  The
C color corresponding to index 0 is black and the color corresponding
C to index 1 is white.
C
      CALL GSCR (IWKID,0,1.,1.,1.)
C
      DO 101 I=1,15
         CALL GSCR (IWKID,I,RGBV(1,I),RGBV(2,I),RGBV(3,I))
 101  CONTINUE
C
C Done.
C
      RETURN
C
      END

C
C     $Id: ps.bkg_black.f,v 1.5 2008-07-27 00:59:05 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      PROGRAM BKGBLK
C
C  This Fortran code is a filter (reads from standard input, writes
C  to standard output) for PostScript files produced from the NCAR
C  Graphics package.  It forces a black background and bumps all B&W
C  intensity values (values with R=G=B) larger than .79 to 1.0 .
C
      INTEGER      CTFLG,CRFLG
      CHARACTER*80 LIN,LOUT
C
      DATA EPS /0.00001/
   10 CONTINUE
C
C  Read an input line
C
      LIN = ' '
      READ(5,100,END=80) LIN
  100 FORMAT(A80)
C
C  Force background color to black as the first plotting instruction in
C  each frame.
C
      IF (LIN(1:3).EQ.'1 j') THEN
          WRITE(6,525)
  525     FORMAT(' ct 000 [0.0000 0.0000 0.0000] put')
          WRITE(6,530)
  530     FORMAT(' 000 o'/'n'/' 0404 1124 m'/' 4482 1124 l'/
     +           ' 4482 5202 l'/' 0404 5202 l'/' 0404 1124 l'/'f')
      ENDIF
C
C  Determine if this is a color table setting.
C
      CTFLG = 0
      DO 20 I=1,80
      IF (LIN(I:I) .EQ. ' ') THEN
        GO TO 20
      ELSE
        IF (LIN(I:I).EQ.'c' .AND. LIN(I+1:I+1).EQ.'t') THEN
          CTFLG = I
          GO TO 30
        ENDIF
      ENDIF
   20 CONTINUE
   30 CONTINUE
      IF (CTFLG .GT. 0) THEN
C
C  Determine if the color values represent a gray value.
C
        CALL CKGRY(LIN,EPS,CTFLG,CRFLG,IDX,R,G,B)
C
C  Encode the modified color values in LOUT.
C
        IF (CRFLG.NE.0) THEN
          LOUT = ' '
          WRITE(LOUT,500) IDX, R,G,B
  500     FORMAT(' ct ',I3,' [',F5.3,' ',F5.3,' ',F5.3,'] put')
        ELSE
          LOUT = LIN
        ENDIF
      ELSE
          LOUT = LIN
      ENDIF
C
C  Trim blanks and Write to output.
C
      KPOS = 1
      DO 110 I=80,1,-1
        IF (LOUT(I:I) .NE. ' ') THEN
          KPOS = I
          GO TO 120
        ENDIF
  110 CONTINUE
  120 CONTINUE
      WRITE(6,130) (LOUT(LL:LL),LL=1,KPOS)
  130 FORMAT(80A1)
C
      GO TO 10
C
   80 CONTINUE
      STOP
      END
      SUBROUTINE CKGRY(LIN,EPS,JFLG,IFLG,IDX,R,G,B)
C
C  Check if the input line in LIN contains a gray intensity value
C  (within the limits of EPS).  IFLG is 1 if a gray value is found;
C  IFLG is 0 otherwise.  If IFLG is 1, then IDX is the color index,
C  and R, G, and B are the complemented color vlaues.
C
      CHARACTER*80 LIN,CTMP
      REAL         EPS,COLORS(3)
      INTEGER      IFLG
C
      IFLG = 0
C
C  Determine the location of the left bracket.
C
      ICOL = 0
      DO 10 I=1,80
        IF (LIN(I:I) .EQ. '[') THEN
          ICOL = I
          GO TO 20
        ELSE
          IF (I .EQ. 80) GO TO 40
          GO TO 10
        ENDIF
   10 CONTINUE
   20 CONTINUE
C
C  Get the color index.
C
      READ(LIN(JFLG+2:ICOL-2),520) IDX
  520 FORMAT(I4)
C
C  Get the three color values.
C
      JSTRT = ICOL+1
      DO 50 I=1,3
        CTMP = ' '
        K = 0
        DO 60 J=JSTRT,80
          K = K+1
          IF (LIN(J:J).EQ.' ' .OR. LIN(J:J).EQ.']') THEN
            IF (K .GT. 1) THEN
              CTMP(1:K-1) = LIN(JSTRT:J-1)
            ELSE
              GO TO 40
            ENDIF
            GO TO 70
          ELSE
            GO TO 60
          ENDIF
   60   CONTINUE
   70   CONTINUE
        READ(CTMP(1:K-1),500) COLORS(I)
  500   FORMAT(F10.3)
        JSTRT = J+1
   50 CONTINUE
C
C  Determine if we have a gray value.
C
      IFLG = 0
      IF (ABS(COLORS(1)-COLORS(2)).LE.EPS .AND.
     -    ABS(COLORS(2)-COLORS(3)).LE.EPS) IFLG = 1
C
C  Adjust the intensities.
C
      IF (IFLG .EQ. 1) THEN
        DO 90 I =1,3
          IF (COLORS(I) .GT. .79) THEN
            COLORS(I) = 1.
          ENDIF
   90   CONTINUE
        R = COLORS(1)
        G = COLORS(2)
        B = COLORS(3)
      ELSE
        GO TO 40
      ENDIF
C
   40 CONTINUE
      RETURN
      END

C
C $Id: agchcu.f,v 1.6 2008-07-27 00:14:33 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE AGCHCU (IFLG,KDSH)
C
C The routine AGCHCU is called by AGCURV just before and just after each
C curve is drawn.  The default version does nothing.  A user may supply
C a version to change the appearance of the curves.  The arguments are
C as follows:
C
C - IFLG is zero if a curve is about to be drawn, non-zero if a curve
C   has just been drawn.
C
C - KDSH is the last argument of AGCURV, as follows:
C
C      AGCURV called by   Value of KDSH
C      ----------------   ----------------------------------------
C      EZY                1
C      EZXY               1
C      EZMY               "n" or "-n", where n is the curve number
C      EZMXY              "n" or "-n", where n is the curve number
C      the user program   the user value
C
C   The sign of KDSH, when AGCURV is called by EZMY or EZMXY, indicates
C   whether the "user" dash patterns or the "alphabetic" dash patterns
C   were selected for use.
C
C Done.
C
      RETURN
C
      END

C
C	$Id: gsclip.f,v 1.6 2009-04-08 23:18:21 fred Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GSCLIP(CLSW)
C
C  Set clipping indicator.
C
      INTEGER ESCLIP
      PARAMETER (ESCLIP=53)
C
      include 'gkscom.h'
C
      INTEGER CLSW
C
C  Check if GKS is in the proper state.
C
      CALL GZCKST(8,ESCLIP,IER)
      IF (IER .NE. 0) RETURN
C
C  Check that CLSW is in range.
C
      IF (CLSW.LT.0.OR.CLSW.GT.1) THEN
        ERS = 1
        CALL GERHND(2000,ESCLIP,ERF)
        ERS = 0
        RETURN
      ENDIF
C
C  Set clipping indicator in the GKS state list.
C
      CCLIP = CLSW
C
C  Invoke the workstation interface.  Send the clipping indicator
C  in ID(1) and the viewport of the current normalization transformation
C  in RX, RY.
C
      FCODE = 61
      CONT  = 0
      CALL GZROI(0)
C
C  Current transformation number increased by one so it can
C  be used as an index.
C
      ICNT = CNT+1
      IL1 = 2
      IL2 = 2
      ID(1) = CLSW
      ID(2) = CNT
      RL1   = 2
      RL2   = 2
C
C  Current transformation number increased by one so it can
C  be used as an index.
C
      ICNT = CNT+1
      RX(1) = NTVP(ICNT,1)
      RX(2) = NTVP(ICNT,2)
      RY(1) = NTVP(ICNT,3)
      RY(2) = NTVP(ICNT,4)
      CALL GZTOWK
      IF (RERR.NE.0) THEN
        ERS = 1
        CALL GERHND(RERR,ESCLIP,ERF)
        ERS = 0
      ENDIF
C
      RETURN
      END

C-----------------------------------------------------------------------
      SUBROUTINE GDSWIZ(KGDS,IOPT,NPTS,FILL,XPTS,YPTS,RLON,RLAT,NRET,
     &                  LROT,CROT,SROT)
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM:  GDSWIZ     GRID DESCRIPTION SECTION WIZARD
C   PRGMMR: IREDELL       ORG: W/NMC23       DATE: 96-04-10
C
C ABSTRACT: THIS SUBPROGRAM DECODES THE GRIB GRID DESCRIPTION SECTION
C           (PASSED IN INTEGER FORM AS DECODED BY SUBPROGRAM W3FI63)
C           AND RETURNS ONE OF THE FOLLOWING:
C             (IOPT= 0) GRID AND EARTH COORDINATES OF ALL GRID POINTS
C             (IOPT=+1) EARTH COORDINATES OF SELECTED GRID COORDINATES
C             (IOPT=-1) GRID COORDINATES OF SELECTED EARTH COORDINATES
C           THE CURRENT CODE RECOGNIZES THE FOLLOWING PROJECTIONS:
C             (KGDS(1)=000) EQUIDISTANT CYLINDRICAL
C             (KGDS(1)=001) MERCATOR CYLINDRICAL
C             (KGDS(1)=003) LAMBERT CONFORMAL CONICAL
C             (KGDS(1)=004) GAUSSIAN CYLINDRICAL
C             (KGDS(1)=005) POLAR STEREOGRAPHIC AZIMUTHAL
C             (KGDS(1)=201) STAGGERED ROTATED EQUIDISTANT CYLINDRICAL
C             (KGDS(1)=202) ROTATED EQUIDISTANT CYLINDRICAL
C             (KGDS(1)=203) STAGGERED ROTATED EQUIDISTANT CYLINDRICAL 2-D
C           IF THE SELECTED COORDINATES ARE MORE THAN ONE GRIDPOINT
C           BEYOND THE THE EDGES OF THE GRID DOMAIN, THEN THE RELEVANT
C           OUTPUT ELEMENTS ARE SET TO FILL VALUES.  ALSO IF IOPT=0,
C           IF THE NUMBER OF GRID POINTS EXCEEDS THE NUMBER ALLOTTED,
C           THEN ALL THE OUTPUT ELEMENTS ARE SET TO FILL VALUES.
C           THE ACTUAL NUMBER OF VALID POINTS COMPUTED IS RETURNED TOO.
C
C PROGRAM HISTORY LOG:
C   96-04-10  IREDELL
C   98-08-20  BALDWIN  ADD TYPE 203 STAGGERED 2-D ETA GRIDS
C
C USAGE:    CALL GDSWIZ(KGDS,IOPT,NPTS,FILL,XPTS,YPTS,RLON,RLAT,NRET,
C     &                 LROT,CROT,SROT)
C
C   INPUT ARGUMENT LIST:
C     KGDS     - INTEGER (200) GDS PARAMETERS AS DECODED BY W3FI63
C     IOPT     - INTEGER OPTION FLAG
C                ( 0 TO COMPUTE EARTH COORDS OF ALL THE GRID POINTS)
C                (+1 TO COMPUTE EARTH COORDS OF SELECTED GRID COORDS)
C                (-1 TO COMPUTE GRID COORDS OF SELECTED EARTH COORDS)
C     NPTS     - INTEGER MAXIMUM NUMBER OF COORDINATES
C     FILL     - REAL FILL VALUE TO SET INVALID OUTPUT DATA
C                (MUST BE IMPOSSIBLE VALUE; SUGGESTED VALUE: -9999.)
C     XPTS     - REAL (NPTS) GRID X POINT COORDINATES IF IOPT>0
C     YPTS     - REAL (NPTS) GRID Y POINT COORDINATES IF IOPT>0
C     RLON     - REAL (NPTS) EARTH LONGITUDES IN DEGREES E IF IOPT<0
C                (ACCEPTABLE RANGE: -360. TO 360.)
C     RLAT     - REAL (NPTS) EARTH LATITUDES IN DEGREES N IF IOPT<0
C                (ACCEPTABLE RANGE: -90. TO 90.)
C     LROT     - INTEGER FLAG TO RETURN VECTOR ROTATIONS IF 1
C
C   OUTPUT ARGUMENT LIST:
C     XPTS     - REAL (NPTS) GRID X POINT COORDINATES IF IOPT<=0
C     YPTS     - REAL (NPTS) GRID Y POINT COORDINATES IF IOPT<=0
C     RLON     - REAL (NPTS) EARTH LONGITUDES IN DEGREES E IF IOPT>=0
C     RLAT     - REAL (NPTS) EARTH LATITUDES IN DEGREES N IF IOPT>=0
C     NRET     - INTEGER NUMBER OF VALID POINTS COMPUTED
C                (-1 IF PROJECTION UNRECOGNIZED)
C     CROT     - REAL (NPTS) CLOCKWISE VECTOR ROTATION COSINES IF LROT=1
C     SROT     - REAL (NPTS) CLOCKWISE VECTOR ROTATION SINES IF LROT=1
C                (UGRID=CROT*UEARTH-SROT*VEARTH;
C                 VGRID=SROT*UEARTH+CROT*VEARTH)
C
C SUBPROGRAMS CALLED:
C   GDSWIZ00     GDS WIZARD FOR EQUIDISTANT CYLINDRICAL
C   GDSWIZ01     GDS WIZARD FOR MERCATOR CYLINDRICAL
C   GDSWIZ03     GDS WIZARD FOR LAMBERT CONFORMAL CONICAL
C   GDSWIZ04     GDS WIZARD FOR GAUSSIAN CYLINDRICAL
C   GDSWIZ05     GDS WIZARD FOR POLAR STEREOGRAPHIC AZIMUTHAL
C   GDSWIZC9     GDS WIZARD FOR ROTATED EQUIDISTANT CYLINDRICAL
C   GDSWIZCA     GDS WIZARD FOR ROTATED EQUIDISTANT CYLINDRICAL
C   GDSWIZCB     GDS WIZARD FOR ROTATED EQUIDISTANT CYLINDRICAL 2-D
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 77
C
C$$$
      INTEGER KGDS(200)
      REAL XPTS(NPTS),YPTS(NPTS),RLON(NPTS),RLAT(NPTS)
      REAL CROT(NPTS),SROT(NPTS)
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C  COMPUTE GRID COORDINATES FOR ALL GRID POINTS
      IF(IOPT.EQ.0) THEN
        IF(KGDS(1).EQ.201) THEN
          IM=KGDS(7)*2-1
          JM=KGDS(8)
          KSCAN=MOD(KGDS(11)/256,2)
          IF(KSCAN.EQ.0) THEN
            IS1=(JM+1)/2
            NM=(IM/2+1)*JM-JM/2
          ELSE
            IS1=JM/2
            NM=IM/2*JM+JM/2
          ENDIF
        ELSEIF(KGDS(1).EQ.202) THEN
          IM=KGDS(7)
          JM=KGDS(8)
          NM=IM*JM
        ELSEIF(KGDS(1).EQ.203) THEN
          IM=KGDS(2)
          JM=KGDS(3)
          NM=IM*JM
          KSCAN=MOD(KGDS(11)/256,2)
          IF(KSCAN.EQ.0) THEN
            IS1=(JM+1)/2
          ELSE
            IS1=JM/2
          ENDIF
        ELSE
          IM=KGDS(2)
          JM=KGDS(3)
          NM=IM*JM
        ENDIF
        NSCAN=MOD(KGDS(11)/32,2)
        IF(NM.LE.NPTS) THEN
          IF(KGDS(1).EQ.201) THEN
            DO N=1,NM
              NN=2*N-1+KSCAN
              IF(NSCAN.EQ.0) THEN
                J=(NN-1)/IM+1
                I=NN-IM*(J-1)
              ELSE
                I=(NN-1)/JM+1
                J=NN-JM*(I-1)
              ENDIF
              XPTS(N)=IS1+(I-(J-KSCAN))/2
              YPTS(N)=(I+(J-KSCAN))/2
            ENDDO
          ELSEIF(KGDS(1).EQ.203) THEN
            DO N=1,NM
              IF(NSCAN.EQ.0) THEN
                J=(N-1)/IM+1
                I=(N-IM*(J-1))*2-MOD(J+KSCAN,2)
              ELSE
                I=(N-1)/JM+1
                J=(N-JM*(I-1))*2-MOD(I+KSCAN,2)
              ENDIF
              XPTS(N)=IS1+(I-(J-KSCAN))/2
              YPTS(N)=(I+(J-KSCAN))/2
            ENDDO
          ELSE
            DO N=1,NM
              IF(NSCAN.EQ.0) THEN
                J=(N-1)/IM+1
                I=N-IM*(J-1)
              ELSE
                I=(N-1)/JM+1
                J=N-JM*(I-1)
              ENDIF
              XPTS(N)=I
              YPTS(N)=J
            ENDDO
          ENDIF
          DO N=NM+1,NPTS
            XPTS(N)=FILL
            YPTS(N)=FILL
          ENDDO
        ELSE
          DO N=1,NPTS
            XPTS(N)=FILL
            YPTS(N)=FILL
          ENDDO
        ENDIF
        IOPF=1
      ELSE
        IOPF=IOPT
      ENDIF
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C  EQUIDISTANT CYLINDRICAL
      IF(KGDS(1).EQ.000) THEN
        CALL GDSWIZ00(KGDS,IOPF,NPTS,FILL,XPTS,YPTS,RLON,RLAT,NRET,
     &                LROT,CROT,SROT)
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C  MERCATOR CYLINDRICAL
      ELSEIF(KGDS(1).EQ.001) THEN
        CALL GDSWIZ01(KGDS,IOPF,NPTS,FILL,XPTS,YPTS,RLON,RLAT,NRET,
     &                LROT,CROT,SROT)
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C  LAMBERT CONFORMAL CONICAL
      ELSEIF(KGDS(1).EQ.003) THEN
        CALL GDSWIZ03(KGDS,IOPF,NPTS,FILL,XPTS,YPTS,RLON,RLAT,NRET,
     &                LROT,CROT,SROT)
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C  GAUSSIAN CYLINDRICAL
      ELSEIF(KGDS(1).EQ.004) THEN
        CALL GDSWIZ04(KGDS,IOPF,NPTS,FILL,XPTS,YPTS,RLON,RLAT,NRET,
     &                LROT,CROT,SROT)
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C  POLAR STEREOGRAPHIC AZIMUTHAL
      ELSEIF(KGDS(1).EQ.005) THEN
        CALL GDSWIZ05(KGDS,IOPF,NPTS,FILL,XPTS,YPTS,RLON,RLAT,NRET,
     &                LROT,CROT,SROT)
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C  STAGGERED ROTATED EQUIDISTANT CYLINDRICAL
      ELSEIF(KGDS(1).EQ.201) THEN
        CALL GDSWIZC9(KGDS,IOPF,NPTS,FILL,XPTS,YPTS,RLON,RLAT,NRET,
     &                LROT,CROT,SROT)
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C  ROTATED EQUIDISTANT CYLINDRICAL
      ELSEIF(KGDS(1).EQ.202) THEN
        CALL GDSWIZCA(KGDS,IOPF,NPTS,FILL,XPTS,YPTS,RLON,RLAT,NRET,
     &                LROT,CROT,SROT)
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C  STAGGERED ROTATED EQUIDISTANT CYLINDRICAL
      ELSEIF(KGDS(1).EQ.203) THEN
        CALL GDSWIZCB(KGDS,IOPF,NPTS,FILL,XPTS,YPTS,RLON,RLAT,NRET,
     &                LROT,CROT,SROT)
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C  PROJECTION UNRECOGNIZED
      ELSE
        IRET=-1
        IF(IOPT.GE.0) THEN
          DO N=1,NPTS
            RLON(N)=FILL
            RLAT(N)=FILL
          ENDDO
        ENDIF
        IF(IOPT.LE.0) THEN
          DO N=1,NPTS
            XPTS(N)=FILL
            YPTS(N)=FILL
          ENDDO
        ENDIF
      ENDIF
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      END
      SUBROUTINE GDSWIZ00(KGDS,IOPT,NPTS,FILL,XPTS,YPTS,RLON,RLAT,NRET,
     &                    LROT,CROT,SROT)
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM:  GDSWIZ00   GDS WIZARD FOR EQUIDISTANT CYLINDRICAL
C   PRGMMR: IREDELL       ORG: W/NMC23       DATE: 96-04-10
C
C ABSTRACT: THIS SUBPROGRAM DECODES THE GRIB GRID DESCRIPTION SECTION
C           (PASSED IN INTEGER FORM AS DECODED BY SUBPROGRAM W3FI63)
C           AND RETURNS ONE OF THE FOLLOWING:
C             (IOPT=+1) EARTH COORDINATES OF SELECTED GRID COORDINATES
C             (IOPT=-1) GRID COORDINATES OF SELECTED EARTH COORDINATES
C           FOR EQUIDISTANT CYLINDRICAL PROJECTIONS.
C           IF THE SELECTED COORDINATES ARE MORE THAN ONE GRIDPOINT
C           BEYOND THE THE EDGES OF THE GRID DOMAIN, THEN THE RELEVANT
C           OUTPUT ELEMENTS ARE SET TO FILL VALUES.
C           THE ACTUAL NUMBER OF VALID POINTS COMPUTED IS RETURNED TOO.
C
C PROGRAM HISTORY LOG:
C   96-04-10  IREDELL
C
C USAGE:    CALL GDSWIZ00(KGDS,IOPT,NPTS,FILL,XPTS,YPTS,RLON,RLAT,NRET,
C     &                   LROT,CROT,SROT)
C
C   INPUT ARGUMENT LIST:
C     KGDS     - INTEGER (200) GDS PARAMETERS AS DECODED BY W3FI63
C     IOPT     - INTEGER OPTION FLAG
C                (+1 TO COMPUTE EARTH COORDS OF SELECTED GRID COORDS)
C                (-1 TO COMPUTE GRID COORDS OF SELECTED EARTH COORDS)
C     NPTS     - INTEGER MAXIMUM NUMBER OF COORDINATES
C     FILL     - REAL FILL VALUE TO SET INVALID OUTPUT DATA
C                (MUST BE IMPOSSIBLE VALUE; SUGGESTED VALUE: -9999.)
C     XPTS     - REAL (NPTS) GRID X POINT COORDINATES IF IOPT>0
C     YPTS     - REAL (NPTS) GRID Y POINT COORDINATES IF IOPT>0
C     RLON     - REAL (NPTS) EARTH LONGITUDES IN DEGREES E IF IOPT<0
C                (ACCEPTABLE RANGE: -360. TO 360.)
C     RLAT     - REAL (NPTS) EARTH LATITUDES IN DEGREES N IF IOPT<0
C                (ACCEPTABLE RANGE: -90. TO 90.)
C     LROT     - INTEGER FLAG TO RETURN VECTOR ROTATIONS IF 1
C
C   OUTPUT ARGUMENT LIST:
C     XPTS     - REAL (NPTS) GRID X POINT COORDINATES IF IOPT<0
C     YPTS     - REAL (NPTS) GRID Y POINT COORDINATES IF IOPT<0
C     RLON     - REAL (NPTS) EARTH LONGITUDES IN DEGREES E IF IOPT>0
C     RLAT     - REAL (NPTS) EARTH LATITUDES IN DEGREES N IF IOPT>0
C     NRET     - INTEGER NUMBER OF VALID POINTS COMPUTED
C     CROT     - REAL (NPTS) CLOCKWISE VECTOR ROTATION COSINES IF LROT=1
C     SROT     - REAL (NPTS) CLOCKWISE VECTOR ROTATION SINES IF LROT=1
C                (UGRID=CROT*UEARTH-SROT*VEARTH;
C                 VGRID=SROT*UEARTH+CROT*VEARTH)
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 77
C
C$$$
      INTEGER KGDS(200)
      REAL XPTS(NPTS),YPTS(NPTS),RLON(NPTS),RLAT(NPTS)
      REAL CROT(NPTS),SROT(NPTS)
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      IF(KGDS(1).EQ.000) THEN
        IM=KGDS(2)
        JM=KGDS(3)
        RLAT1=KGDS(4)*1.E-3
        RLON1=KGDS(5)*1.E-3
        RLAT2=KGDS(7)*1.E-3
        RLON2=KGDS(8)*1.E-3
        ISCAN=MOD(KGDS(11)/128,2)
        JSCAN=MOD(KGDS(11)/64,2)
        NSCAN=MOD(KGDS(11)/32,2)
        HI=(-1.)**ISCAN
        HJ=(-1.)**(1-JSCAN)
        DLON=HI*(MOD(HI*(RLON2-RLON1)-1+3600,360.)+1)/(IM-1)
        DLAT=(RLAT2-RLAT1)/(JM-1)
        XMIN=0
        XMAX=IM+1
        IF(IM.EQ.NINT(360/ABS(DLON))) XMAX=IM+2
        YMIN=0
        YMAX=JM+1
        NRET=0
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C  TRANSLATE GRID COORDINATES TO EARTH COORDINATES
        IF(IOPT.EQ.0.OR.IOPT.EQ.1) THEN
          DO N=1,NPTS
            IF(XPTS(N).GE.XMIN.AND.XPTS(N).LE.XMAX.AND.
     &         YPTS(N).GE.YMIN.AND.YPTS(N).LE.YMAX) THEN
              RLON(N)=MOD(RLON1+DLON*(XPTS(N)-1)+3600,360.)
              RLAT(N)=MIN(MAX(RLAT1+DLAT*(YPTS(N)-1),-90.),90.)
              NRET=NRET+1
              IF(LROT.EQ.1) THEN
                CROT(N)=1
                SROT(N)=0
              ENDIF
            ELSE
              RLON(N)=FILL
              RLAT(N)=FILL
            ENDIF
          ENDDO
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C  TRANSLATE EARTH COORDINATES TO GRID COORDINATES
        ELSEIF(IOPT.EQ.-1) THEN
          DO N=1,NPTS
            IF(ABS(RLON(N)).LE.360.AND.ABS(RLAT(N)).LE.90) THEN
              XPTS(N)=1+HI*MOD(HI*(RLON(N)-RLON1)+3600,360.)/DLON
              YPTS(N)=1+(RLAT(N)-RLAT1)/DLAT
              IF(XPTS(N).GE.XMIN.AND.XPTS(N).LE.XMAX.AND.
     &           YPTS(N).GE.YMIN.AND.YPTS(N).LE.YMAX) THEN
                NRET=NRET+1
                IF(LROT.EQ.1) THEN
                  CROT(N)=1
                  SROT(N)=0
                ENDIF
              ELSE
                XPTS(N)=FILL
                YPTS(N)=FILL
              ENDIF
            ELSE
              XPTS(N)=FILL
              YPTS(N)=FILL
            ENDIF
          ENDDO
        ENDIF
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C  PROJECTION UNRECOGNIZED
      ELSE
        IRET=-1
        IF(IOPT.GE.0) THEN
          DO N=1,NPTS
            RLON(N)=FILL
            RLAT(N)=FILL
          ENDDO
        ENDIF
        IF(IOPT.LE.0) THEN
          DO N=1,NPTS
            XPTS(N)=FILL
            YPTS(N)=FILL
          ENDDO
        ENDIF
      ENDIF
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      END
      SUBROUTINE GDSWIZ01(KGDS,IOPT,NPTS,FILL,XPTS,YPTS,RLON,RLAT,NRET,
     &                    LROT,CROT,SROT)
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM:  GDSWIZ01   GDS WIZARD FOR MERCATOR CYLINDRICAL
C   PRGMMR: IREDELL       ORG: W/NMC23       DATE: 96-04-10
C
C ABSTRACT: THIS SUBPROGRAM DECODES THE GRIB GRID DESCRIPTION SECTION
C           (PASSED IN INTEGER FORM AS DECODED BY SUBPROGRAM W3FI63)
C           AND RETURNS ONE OF THE FOLLOWING:
C             (IOPT=+1) EARTH COORDINATES OF SELECTED GRID COORDINATES
C             (IOPT=-1) GRID COORDINATES OF SELECTED EARTH COORDINATES
C           FOR MERCATOR CYLINDRICAL PROJECTIONS.
C           IF THE SELECTED COORDINATES ARE MORE THAN ONE GRIDPOINT
C           BEYOND THE THE EDGES OF THE GRID DOMAIN, THEN THE RELEVANT
C           OUTPUT ELEMENTS ARE SET TO FILL VALUES.
C           THE ACTUAL NUMBER OF VALID POINTS COMPUTED IS RETURNED TOO.
C
C PROGRAM HISTORY LOG:
C   96-04-10  IREDELL
C   96-10-01  IREDELL   PROTECTED AGAINST UNRESOLVABLE POINTS
C
C USAGE:    CALL GDSWIZ01(KGDS,IOPT,NPTS,FILL,XPTS,YPTS,RLON,RLAT,NRET,
C     &                   LROT,CROT,SROT)
C
C   INPUT ARGUMENT LIST:
C     KGDS     - INTEGER (200) GDS PARAMETERS AS DECODED BY W3FI63
C     IOPT     - INTEGER OPTION FLAG
C                (+1 TO COMPUTE EARTH COORDS OF SELECTED GRID COORDS)
C                (-1 TO COMPUTE GRID COORDS OF SELECTED EARTH COORDS)
C     NPTS     - INTEGER MAXIMUM NUMBER OF COORDINATES
C     FILL     - REAL FILL VALUE TO SET INVALID OUTPUT DATA
C                (MUST BE IMPOSSIBLE VALUE; SUGGESTED VALUE: -9999.)
C     XPTS     - REAL (NPTS) GRID X POINT COORDINATES IF IOPT>0
C     YPTS     - REAL (NPTS) GRID Y POINT COORDINATES IF IOPT>0
C     RLON     - REAL (NPTS) EARTH LONGITUDES IN DEGREES E IF IOPT<0
C                (ACCEPTABLE RANGE: -360. TO 360.)
C     RLAT     - REAL (NPTS) EARTH LATITUDES IN DEGREES N IF IOPT<0
C                (ACCEPTABLE RANGE: -90. TO 90.)
C     LROT     - INTEGER FLAG TO RETURN VECTOR ROTATIONS IF 1
C
C   OUTPUT ARGUMENT LIST:
C     XPTS     - REAL (NPTS) GRID X POINT COORDINATES IF IOPT<0
C     YPTS     - REAL (NPTS) GRID Y POINT COORDINATES IF IOPT<0
C     RLON     - REAL (NPTS) EARTH LONGITUDES IN DEGREES E IF IOPT>0
C     RLAT     - REAL (NPTS) EARTH LATITUDES IN DEGREES N IF IOPT>0
C     NRET     - INTEGER NUMBER OF VALID POINTS COMPUTED
C     CROT     - REAL (NPTS) CLOCKWISE VECTOR ROTATION COSINES IF LROT=1
C     SROT     - REAL (NPTS) CLOCKWISE VECTOR ROTATION SINES IF LROT=1
C                (UGRID=CROT*UEARTH-SROT*VEARTH;
C                 VGRID=SROT*UEARTH+CROT*VEARTH)
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 77
C
C$$$
      INTEGER KGDS(200)
      REAL XPTS(NPTS),YPTS(NPTS),RLON(NPTS),RLAT(NPTS)
      REAL CROT(NPTS),SROT(NPTS)
      PARAMETER(RERTH=6.3712E6)
      PARAMETER(PI=3.14159265358979,DPR=180./PI)
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      IF(KGDS(1).EQ.001) THEN
        IM=KGDS(2)
        JM=KGDS(3)
        RLAT1=KGDS(4)*1.E-3
        RLON1=KGDS(5)*1.E-3
        RLAT2=KGDS(7)*1.E-3
        RLON2=KGDS(8)*1.E-3
        RLATI=KGDS(9)*1.E-3
        ISCAN=MOD(KGDS(11)/128,2)
        JSCAN=MOD(KGDS(11)/64,2)
        NSCAN=MOD(KGDS(11)/32,2)
        DX=KGDS(12)
        DY=KGDS(13)
        HI=(-1.)**ISCAN
        HJ=(-1.)**(1-JSCAN)
        DLON=HI*(MOD(HI*(RLON2-RLON1)-1+3600,360.)+1)/(IM-1)
        DLAT=HJ*DY/(RERTH*COS(RLATI/DPR))
        YE=1-LOG(TAN((RLAT1+90)/2/DPR))/DLAT
        XMIN=0
        XMAX=IM+1
        IF(IM.EQ.NINT(360/ABS(DLON))) XMAX=IM+2
        YMIN=0
        YMAX=JM+1
        NRET=0
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C  TRANSLATE GRID COORDINATES TO EARTH COORDINATES
        IF(IOPT.EQ.0.OR.IOPT.EQ.1) THEN
          DO N=1,NPTS
            IF(XPTS(N).GE.XMIN.AND.XPTS(N).LE.XMAX.AND.
     &         YPTS(N).GE.YMIN.AND.YPTS(N).LE.YMAX) THEN
              RLON(N)=MOD(RLON1+DLON*(XPTS(N)-1)+3600,360.)
              RLAT(N)=2*ATAN(EXP(DLAT*(YPTS(N)-YE)))*DPR-90
              NRET=NRET+1
              IF(LROT.EQ.1) THEN
                CROT(N)=1
                SROT(N)=0
              ENDIF
            ELSE
              RLON(N)=FILL
              RLAT(N)=FILL
            ENDIF
          ENDDO
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C  TRANSLATE EARTH COORDINATES TO GRID COORDINATES
        ELSEIF(IOPT.EQ.-1) THEN
          DO N=1,NPTS
            IF(ABS(RLON(N)).LE.360.AND.ABS(RLAT(N)).LT.90) THEN
              XPTS(N)=1+HI*MOD(HI*(RLON(N)-RLON1)+3600,360.)/DLON
              YPTS(N)=YE+LOG(TAN((RLAT(N)+90)/2/DPR))/DLAT
              IF(XPTS(N).GE.XMIN.AND.XPTS(N).LE.XMAX.AND.
     &           YPTS(N).GE.YMIN.AND.YPTS(N).LE.YMAX) THEN
                NRET=NRET+1
                IF(LROT.EQ.1) THEN
                  CROT(N)=1
                  SROT(N)=0
                ENDIF
              ELSE
                XPTS(N)=FILL
                YPTS(N)=FILL
              ENDIF
            ELSE
              XPTS(N)=FILL
              YPTS(N)=FILL
            ENDIF
          ENDDO
        ENDIF
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C  PROJECTION UNRECOGNIZED
      ELSE
        IRET=-1
        IF(IOPT.GE.0) THEN
          DO N=1,NPTS
            RLON(N)=FILL
            RLAT(N)=FILL
          ENDDO
        ENDIF
        IF(IOPT.LE.0) THEN
          DO N=1,NPTS
            XPTS(N)=FILL
            YPTS(N)=FILL
          ENDDO
        ENDIF
      ENDIF
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      END
      SUBROUTINE GDSWIZ03(KGDS,IOPT,NPTS,FILL,XPTS,YPTS,RLON,RLAT,NRET,
     &                    LROT,CROT,SROT)
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM:  GDSWIZ03   GDS WIZARD FOR LAMBERT CONFORMAL CONICAL
C   PRGMMR: IREDELL       ORG: W/NMC23       DATE: 96-04-10
C
C ABSTRACT: THIS SUBPROGRAM DECODES THE GRIB GRID DESCRIPTION SECTION
C           (PASSED IN INTEGER FORM AS DECODED BY SUBPROGRAM W3FI63)
C           AND RETURNS ONE OF THE FOLLOWING:
C             (IOPT=+1) EARTH COORDINATES OF SELECTED GRID COORDINATES
C             (IOPT=-1) GRID COORDINATES OF SELECTED EARTH COORDINATES
C           FOR LAMBERT CONFORMAL CONICAL PROJECTIONS.
C           IF THE SELECTED COORDINATES ARE MORE THAN ONE GRIDPOINT
C           BEYOND THE THE EDGES OF THE GRID DOMAIN, THEN THE RELEVANT
C           OUTPUT ELEMENTS ARE SET TO FILL VALUES.
C           THE ACTUAL NUMBER OF VALID POINTS COMPUTED IS RETURNED TOO.
C
C PROGRAM HISTORY LOG:
C   96-04-10  IREDELL
C   96-10-01  IREDELL   PROTECTED AGAINST UNRESOLVABLE POINTS
C 1999-04-27  GILBERT   CORRECTED MINOR ERROR CALCULATING VARIABLE AN
C                       FOR THE SECANT PROJECTION CASE (RLATI1.NE.RLATI2).
C
C USAGE:    CALL GDSWIZ03(KGDS,IOPT,NPTS,FILL,XPTS,YPTS,RLON,RLAT,NRET,
C     &                   LROT,CROT,SROT)
C
C   INPUT ARGUMENT LIST:
C     KGDS     - INTEGER (200) GDS PARAMETERS AS DECODED BY W3FI63
C     IOPT     - INTEGER OPTION FLAG
C                (+1 TO COMPUTE EARTH COORDS OF SELECTED GRID COORDS)
C                (-1 TO COMPUTE GRID COORDS OF SELECTED EARTH COORDS)
C     NPTS     - INTEGER MAXIMUM NUMBER OF COORDINATES
C     FILL     - REAL FILL VALUE TO SET INVALID OUTPUT DATA
C                (MUST BE IMPOSSIBLE VALUE; SUGGESTED VALUE: -9999.)
C     XPTS     - REAL (NPTS) GRID X POINT COORDINATES IF IOPT>0
C     YPTS     - REAL (NPTS) GRID Y POINT COORDINATES IF IOPT>0
C     RLON     - REAL (NPTS) EARTH LONGITUDES IN DEGREES E IF IOPT<0
C                (ACCEPTABLE RANGE: -360. TO 360.)
C     RLAT     - REAL (NPTS) EARTH LATITUDES IN DEGREES N IF IOPT<0
C                (ACCEPTABLE RANGE: -90. TO 90.)
C     LROT     - INTEGER FLAG TO RETURN VECTOR ROTATIONS IF 1
C
C   OUTPUT ARGUMENT LIST:
C     XPTS     - REAL (NPTS) GRID X POINT COORDINATES IF IOPT<0
C     YPTS     - REAL (NPTS) GRID Y POINT COORDINATES IF IOPT<0
C     RLON     - REAL (NPTS) EARTH LONGITUDES IN DEGREES E IF IOPT>0
C     RLAT     - REAL (NPTS) EARTH LATITUDES IN DEGREES N IF IOPT>0
C     NRET     - INTEGER NUMBER OF VALID POINTS COMPUTED
C     CROT     - REAL (NPTS) CLOCKWISE VECTOR ROTATION COSINES IF LROT=1
C     SROT     - REAL (NPTS) CLOCKWISE VECTOR ROTATION SINES IF LROT=1
C                (UGRID=CROT*UEARTH-SROT*VEARTH;
C                 VGRID=SROT*UEARTH+CROT*VEARTH)
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 77
C
C$$$
      INTEGER KGDS(200)
      REAL XPTS(NPTS),YPTS(NPTS),RLON(NPTS),RLAT(NPTS)
      REAL CROT(NPTS),SROT(NPTS)
      PARAMETER(RERTH=6.3712E6)
      PARAMETER(PI=3.14159265358979,DPR=180./PI)
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      IF(KGDS(1).EQ.003) THEN
        IM=KGDS(2)
        JM=KGDS(3)
        RLAT1=KGDS(4)*1.E-3
        RLON1=KGDS(5)*1.E-3
        IROT=MOD(KGDS(6)/8,2)
        ORIENT=KGDS(7)*1.E-3
        DX=KGDS(8)
        DY=KGDS(9)
        IPROJ=MOD(KGDS(10)/128,2)
        ISCAN=MOD(KGDS(11)/128,2)
        JSCAN=MOD(KGDS(11)/64,2)
        NSCAN=MOD(KGDS(11)/32,2)
        RLATI1=KGDS(12)*1.E-3
        RLATI2=KGDS(13)*1.E-3
        H=(-1.)**IPROJ
        HI=(-1.)**ISCAN
        HJ=(-1.)**(1-JSCAN)
        DXS=DX*HI
        DYS=DY*HJ
        IF(RLATI1.EQ.RLATI2) THEN
          AN=SIN(H*RLATI1/DPR)
        ELSE
          AN=LOG(COS(RLATI1/DPR)/COS(RLATI2/DPR))/
     &       LOG(TAN((H*90-RLATI1)/2/DPR)/TAN((H*90-RLATI2)/2/DPR))
        ENDIF
        DE=RERTH*COS(RLATI1/DPR)*TAN((H*RLATI1+90)/2/DPR)**AN/AN
        IF(H*RLAT1.EQ.90) THEN
          XP=1
          YP=1
        ELSE
          DR=DE/TAN((H*RLAT1+90)/2/DPR)**AN
          DLON1=MOD(RLON1-ORIENT+180+3600,360.)-180
          XP=1-H*SIN(AN*DLON1/DPR)*DR/DXS
          YP=1+COS(AN*DLON1/DPR)*DR/DYS
        ENDIF
        ANTR=1/(2*AN)
        DE2=DE**2
        XMIN=0
        XMAX=IM+1
        YMIN=0
        YMAX=JM+1
        NRET=0
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C  TRANSLATE GRID COORDINATES TO EARTH COORDINATES
        IF(IOPT.EQ.0.OR.IOPT.EQ.1) THEN
          DO N=1,NPTS
            IF(XPTS(N).GE.XMIN.AND.XPTS(N).LE.XMAX.AND.
     &         YPTS(N).GE.YMIN.AND.YPTS(N).LE.YMAX) THEN
              DI=(XPTS(N)-XP)*DXS
              DJ=(YPTS(N)-YP)*DYS
              DR2=DI**2+DJ**2
              IF(DR2.LT.DE2*1.E-6) THEN
                RLON(N)=0.
                RLAT(N)=H*90.
              ELSE
                RLON(N)=MOD(ORIENT+H/AN*DPR*ATAN2(DI,-DJ)+3600,360.)
                RLAT(N)=H*(2*DPR*ATAN((DE2/DR2)**ANTR)-90)
              ENDIF
              NRET=NRET+1
              IF(LROT.EQ.1) THEN
                IF(IROT.EQ.1) THEN
                  DLON=MOD(RLON(N)-ORIENT+180+3600,360.)-180
                  CROT(N)=H*COS(AN*DLON/DPR)
                  SROT(N)=SIN(AN*DLON/DPR)
                ELSE
                  CROT(N)=1
                  SROT(N)=0
                ENDIF
              ENDIF
            ELSE
              RLON(N)=FILL
              RLAT(N)=FILL
            ENDIF
          ENDDO
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C  TRANSLATE EARTH COORDINATES TO GRID COORDINATES
        ELSEIF(IOPT.EQ.-1) THEN
          DO N=1,NPTS
            IF(ABS(RLON(N)).LE.360.AND.ABS(RLAT(N)).LE.90.AND.
     &                                 H*RLAT(N).NE.-90) THEN
              DR=DE*TAN((90-H*RLAT(N))/2/DPR)**AN
              DLON=MOD(RLON(N)-ORIENT+180+3600,360.)-180
              XPTS(N)=XP+H*SIN(AN*DLON/DPR)*DR/DXS
              YPTS(N)=YP-COS(AN*DLON/DPR)*DR/DYS
              IF(XPTS(N).GE.XMIN.AND.XPTS(N).LE.XMAX.AND.
     &           YPTS(N).GE.YMIN.AND.YPTS(N).LE.YMAX) THEN
                NRET=NRET+1
                IF(LROT.EQ.1) THEN
                  IF(IROT.EQ.1) THEN
                    CROT(N)=H*COS(AN*DLON/DPR)
                    SROT(N)=SIN(AN*DLON/DPR)
                  ELSE
                    CROT(N)=1
                    SROT(N)=0
                  ENDIF
                ENDIF
              ELSE
                XPTS(N)=FILL
                YPTS(N)=FILL
              ENDIF
            ELSE
              XPTS(N)=FILL
              YPTS(N)=FILL
            ENDIF
          ENDDO
        ENDIF
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C  PROJECTION UNRECOGNIZED
      ELSE
        IRET=-1
        IF(IOPT.GE.0) THEN
          DO N=1,NPTS
            RLON(N)=FILL
            RLAT(N)=FILL
          ENDDO
        ENDIF
        IF(IOPT.LE.0) THEN
          DO N=1,NPTS
            XPTS(N)=FILL
            YPTS(N)=FILL
          ENDDO
        ENDIF
      ENDIF
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      END
      SUBROUTINE GDSWIZ04(KGDS,IOPT,NPTS,FILL,XPTS,YPTS,RLON,RLAT,NRET,
     &                    LROT,CROT,SROT)
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM:  GDSWIZ04   GDS WIZARD FOR GAUSSIAN CYLINDRICAL
C   PRGMMR: IREDELL       ORG: W/NMC23       DATE: 96-04-10
C
C ABSTRACT: THIS SUBPROGRAM DECODES THE GRIB GRID DESCRIPTION SECTION
C           (PASSED IN INTEGER FORM AS DECODED BY SUBPROGRAM W3FI63)
C           AND RETURNS ONE OF THE FOLLOWING:
C             (IOPT=+1) EARTH COORDINATES OF SELECTED GRID COORDINATES
C             (IOPT=-1) GRID COORDINATES OF SELECTED EARTH COORDINATES
C           FOR GAUSSIAN CYLINDRICAL PROJECTIONS.
C           IF THE SELECTED COORDINATES ARE MORE THAN ONE GRIDPOINT
C           BEYOND THE THE EDGES OF THE GRID DOMAIN, THEN THE RELEVANT
C           OUTPUT ELEMENTS ARE SET TO FILL VALUES.
C           THE ACTUAL NUMBER OF VALID POINTS COMPUTED IS RETURNED TOO.
C
C PROGRAM HISTORY LOG:
C   96-04-10  IREDELL
C 1999-04-08  IREDELL  USE SUBROUTINE SPLAT
C
C USAGE:    CALL GDSWIZ04(KGDS,IOPT,NPTS,FILL,XPTS,YPTS,RLON,RLAT,NRET,
C    &                    LROT,CROT,SROT)
C
C   INPUT ARGUMENT LIST:
C     KGDS     - INTEGER (200) GDS PARAMETERS AS DECODED BY W3FI63
C     IOPT     - INTEGER OPTION FLAG
C                (+1 TO COMPUTE EARTH COORDS OF SELECTED GRID COORDS)
C                (-1 TO COMPUTE GRID COORDS OF SELECTED EARTH COORDS)
C     NPTS     - INTEGER MAXIMUM NUMBER OF COORDINATES
C     FILL     - REAL FILL VALUE TO SET INVALID OUTPUT DATA
C                (MUST BE IMPOSSIBLE VALUE; SUGGESTED VALUE: -9999.)
C     XPTS     - REAL (NPTS) GRID X POINT COORDINATES IF IOPT>0
C     YPTS     - REAL (NPTS) GRID Y POINT COORDINATES IF IOPT>0
C     RLON     - REAL (NPTS) EARTH LONGITUDES IN DEGREES E IF IOPT<0
C                (ACCEPTABLE RANGE: -360. TO 360.)
C     RLAT     - REAL (NPTS) EARTH LATITUDES IN DEGREES N IF IOPT<0
C                (ACCEPTABLE RANGE: -90. TO 90.)
C     LROT     - INTEGER FLAG TO RETURN VECTOR ROTATIONS IF 1
C
C   OUTPUT ARGUMENT LIST:
C     XPTS     - REAL (NPTS) GRID X POINT COORDINATES IF IOPT<0
C     YPTS     - REAL (NPTS) GRID Y POINT COORDINATES IF IOPT<0
C     RLON     - REAL (NPTS) EARTH LONGITUDES IN DEGREES E IF IOPT>0
C     RLAT     - REAL (NPTS) EARTH LATITUDES IN DEGREES N IF IOPT>0
C     NRET     - INTEGER NUMBER OF VALID POINTS COMPUTED
C     CROT     - REAL (NPTS) CLOCKWISE VECTOR ROTATION COSINES IF LROT=1
C     SROT     - REAL (NPTS) CLOCKWISE VECTOR ROTATION SINES IF LROT=1
C                (UGRID=CROT*UEARTH-SROT*VEARTH;
C                 VGRID=SROT*UEARTH+CROT*VEARTH)
C
C SUBPROGRAMS CALLED:
C   SPLAT      COMPUTE LATITUDE FUNCTIONS
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 77
C
C$$$
      INTEGER KGDS(200)
      REAL XPTS(NPTS),YPTS(NPTS),RLON(NPTS),RLAT(NPTS)
      REAL CROT(NPTS),SROT(NPTS)
      PARAMETER(PI=3.14159265358979,DPR=180./PI)
      PARAMETER(JGMAX=2000)
      REAL ALAT(0:JGMAX+1),BLAT(JGMAX)
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      IF(KGDS(1).EQ.004.AND.KGDS(10)*2.LE.JGMAX) THEN
        IM=KGDS(2)
        JM=KGDS(3)
        RLAT1=KGDS(4)*1.E-3
        RLON1=KGDS(5)*1.E-3
        RLAT2=KGDS(7)*1.E-3
        RLON2=KGDS(8)*1.E-3
        JG=KGDS(10)*2
        ISCAN=MOD(KGDS(11)/128,2)
        JSCAN=MOD(KGDS(11)/64,2)
        NSCAN=MOD(KGDS(11)/32,2)
        HI=(-1.)**ISCAN
        JH=(-1)**JSCAN
        DLON=HI*(MOD(HI*(RLON2-RLON1)-1+3600,360.)+1)/(IM-1)
        CALL SPLAT(4,JG,ALAT(1),BLAT)
        DO JA=1,JG
          ALAT(JA)=DPR*ASIN(ALAT(JA))
        ENDDO
        ALAT(0)=180.-ALAT(1)
        ALAT(JG+1)=-ALAT(0)
        J1=1
        DOWHILE(J1.LT.JG.AND.RLAT1.LT.(ALAT(J1)+ALAT(J1+1))/2)
          J1=J1+1
        ENDDO
        J2=J1+JH*(JM-1)
        XMIN=0
        XMAX=IM+1
        IF(IM.EQ.NINT(360/ABS(DLON))) XMAX=IM+2
        YMIN=0.5
        YMAX=JM+0.5
        NRET=0
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C  TRANSLATE GRID COORDINATES TO EARTH COORDINATES
        IF(IOPT.EQ.0.OR.IOPT.EQ.1) THEN
          DO N=1,NPTS
            IF(XPTS(N).GE.XMIN.AND.XPTS(N).LE.XMAX.AND.
     &         YPTS(N).GE.YMIN.AND.YPTS(N).LE.YMAX) THEN
              RLON(N)=MOD(RLON1+DLON*(XPTS(N)-1)+3600,360.)
              J=MIN(INT(YPTS(N)),JM)
              RLATA=ALAT(J1+JH*(J-1))
              RLATB=ALAT(J1+JH*J)
              WB=YPTS(N)-J
              RLAT(N)=RLATA+WB*(RLATB-RLATA)
              NRET=NRET+1
              IF(LROT.EQ.1) THEN
                CROT(N)=1
                SROT(N)=0
              ENDIF
            ELSE
              RLON(N)=FILL
              RLAT(N)=FILL
            ENDIF
          ENDDO
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C  TRANSLATE EARTH COORDINATES TO GRID COORDINATES
        ELSEIF(IOPT.EQ.-1) THEN
          DO N=1,NPTS
            XPTS(N)=FILL
            YPTS(N)=FILL
            IF(ABS(RLON(N)).LE.360.AND.ABS(RLAT(N)).LE.90) THEN
              XPTS(N)=1+HI*MOD(HI*(RLON(N)-RLON1)+3600,360.)/DLON
              JA=MIN(INT((JG+1)/180.*(90-RLAT(N))),JG)
              IF(RLAT(N).GT.ALAT(JA)) JA=MAX(JA-2,0)
              IF(RLAT(N).LT.ALAT(JA+1)) JA=MIN(JA+2,JG)
              IF(RLAT(N).GT.ALAT(JA)) JA=JA-1
              IF(RLAT(N).LT.ALAT(JA+1)) JA=JA+1
              YPTSA=1+JH*(JA-J1)
              YPTSB=1+JH*(JA+1-J1)
              WB=(ALAT(JA)-RLAT(N))/(ALAT(JA)-ALAT(JA+1))
              YPTS(N)=YPTSA+WB*(YPTSB-YPTSA)
              IF(XPTS(N).GE.XMIN.AND.XPTS(N).LE.XMAX.AND.
     &           YPTS(N).GE.YMIN.AND.YPTS(N).LE.YMAX) THEN
                NRET=NRET+1
                IF(LROT.EQ.1) THEN
                  CROT(N)=1
                  SROT(N)=0
                ENDIF
              ELSE
                XPTS(N)=FILL
                YPTS(N)=FILL
              ENDIF
            ENDIF
          ENDDO
        ENDIF
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C  PROJECTION UNRECOGNIZED
      ELSE
        IRET=-1
        IF(IOPT.GE.0) THEN
          DO N=1,NPTS
            RLON(N)=FILL
            RLAT(N)=FILL
          ENDDO
        ENDIF
        IF(IOPT.LE.0) THEN
          DO N=1,NPTS
            XPTS(N)=FILL
            YPTS(N)=FILL
          ENDDO
        ENDIF
      ENDIF
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      END
      SUBROUTINE GDSWIZ05(KGDS,IOPT,NPTS,FILL,XPTS,YPTS,RLON,RLAT,NRET,
     &                    LROT,CROT,SROT)
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM:  GDSWIZ05   GDS WIZARD FOR POLAR STEREOGRAPHIC AZIMUTHAL
C   PRGMMR: IREDELL       ORG: W/NMC23       DATE: 96-04-10
C
C ABSTRACT: THIS SUBPROGRAM DECODES THE GRIB GRID DESCRIPTION SECTION
C           (PASSED IN INTEGER FORM AS DECODED BY SUBPROGRAM W3FI63)
C           AND RETURNS ONE OF THE FOLLOWING:
C             (IOPT=+1) EARTH COORDINATES OF SELECTED GRID COORDINATES
C             (IOPT=-1) GRID COORDINATES OF SELECTED EARTH COORDINATES
C           FOR POLAR STEREOGRAPHIC AZIMUTHAL PROJECTIONS.
C           IF THE SELECTED COORDINATES ARE MORE THAN ONE GRIDPOINT
C           BEYOND THE THE EDGES OF THE GRID DOMAIN, THEN THE RELEVANT
C           OUTPUT ELEMENTS ARE SET TO FILL VALUES.
C           THE ACTUAL NUMBER OF VALID POINTS COMPUTED IS RETURNED TOO.
C
C PROGRAM HISTORY LOG:
C   96-04-10  IREDELL
C
C USAGE:    CALL GDSWIZ05(KGDS,IOPT,NPTS,FILL,XPTS,YPTS,RLON,RLAT,NRET,
C     &                   LROT,CROT,SROT)
C
C   INPUT ARGUMENT LIST:
C     KGDS     - INTEGER (200) GDS PARAMETERS AS DECODED BY W3FI63
C     IOPT     - INTEGER OPTION FLAG
C                (+1 TO COMPUTE EARTH COORDS OF SELECTED GRID COORDS)
C                (-1 TO COMPUTE GRID COORDS OF SELECTED EARTH COORDS)
C     NPTS     - INTEGER MAXIMUM NUMBER OF COORDINATES
C     FILL     - REAL FILL VALUE TO SET INVALID OUTPUT DATA
C                (MUST BE IMPOSSIBLE VALUE; SUGGESTED VALUE: -9999.)
C     XPTS     - REAL (NPTS) GRID X POINT COORDINATES IF IOPT>0
C     YPTS     - REAL (NPTS) GRID Y POINT COORDINATES IF IOPT>0
C     RLON     - REAL (NPTS) EARTH LONGITUDES IN DEGREES E IF IOPT<0
C                (ACCEPTABLE RANGE: -360. TO 360.)
C     RLAT     - REAL (NPTS) EARTH LATITUDES IN DEGREES N IF IOPT<0
C                (ACCEPTABLE RANGE: -90. TO 90.)
C     LROT     - INTEGER FLAG TO RETURN VECTOR ROTATIONS IF 1
C
C   OUTPUT ARGUMENT LIST:
C     XPTS     - REAL (NPTS) GRID X POINT COORDINATES IF IOPT<0
C     YPTS     - REAL (NPTS) GRID Y POINT COORDINATES IF IOPT<0
C     RLON     - REAL (NPTS) EARTH LONGITUDES IN DEGREES E IF IOPT>0
C     RLAT     - REAL (NPTS) EARTH LATITUDES IN DEGREES N IF IOPT>0
C     NRET     - INTEGER NUMBER OF VALID POINTS COMPUTED
C     CROT     - REAL (NPTS) CLOCKWISE VECTOR ROTATION COSINES IF LROT=1
C     SROT     - REAL (NPTS) CLOCKWISE VECTOR ROTATION SINES IF LROT=1
C                (UGRID=CROT*UEARTH-SROT*VEARTH;
C                 VGRID=SROT*UEARTH+CROT*VEARTH)
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 77
C
C$$$
      INTEGER KGDS(200)
      REAL XPTS(NPTS),YPTS(NPTS),RLON(NPTS),RLAT(NPTS)
      REAL CROT(NPTS),SROT(NPTS)
      PARAMETER(RERTH=6.3712E6)
      PARAMETER(PI=3.14159265358979,DPR=180./PI)
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      IF(KGDS(1).EQ.005) THEN
        IM=KGDS(2)
        JM=KGDS(3)
        RLAT1=KGDS(4)*1.E-3
        RLON1=KGDS(5)*1.E-3
        IROT=MOD(KGDS(6)/8,2)
        ORIENT=KGDS(7)*1.E-3
        DX=KGDS(8)
        DY=KGDS(9)
        IPROJ=MOD(KGDS(10)/128,2)
        ISCAN=MOD(KGDS(11)/128,2)
        JSCAN=MOD(KGDS(11)/64,2)
        NSCAN=MOD(KGDS(11)/32,2)
        H=(-1.)**IPROJ
        HI=(-1.)**ISCAN
        HJ=(-1.)**(1-JSCAN)
        DXS=DX*HI
        DYS=DY*HJ
        DE=(1.+SIN(60./DPR))*RERTH
        DR=DE*COS(RLAT1/DPR)/(1+H*SIN(RLAT1/DPR))
        XP=1-H*SIN((RLON1-ORIENT)/DPR)*DR/DXS
        YP=1+COS((RLON1-ORIENT)/DPR)*DR/DYS
        DE2=DE**2
        XMIN=0
        XMAX=IM+1
        YMIN=0
        YMAX=JM+1
        NRET=0
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C  TRANSLATE GRID COORDINATES TO EARTH COORDINATES
        IF(IOPT.EQ.0.OR.IOPT.EQ.1) THEN
          DO N=1,NPTS
            IF(XPTS(N).GE.XMIN.AND.XPTS(N).LE.XMAX.AND.
     &         YPTS(N).GE.YMIN.AND.YPTS(N).LE.YMAX) THEN
              DI=(XPTS(N)-XP)*DXS
              DJ=(YPTS(N)-YP)*DYS
              DR2=DI**2+DJ**2
              IF(DR2.LT.DE2*1.E-6) THEN
                RLON(N)=0.
                RLAT(N)=H*90.
              ELSE
                RLON(N)=MOD(ORIENT+H*DPR*ATAN2(DI,-DJ)+3600,360.)
                RLAT(N)=H*DPR*ASIN((DE2-DR2)/(DE2+DR2))
              ENDIF
              NRET=NRET+1
              IF(LROT.EQ.1) THEN
                IF(IROT.EQ.1) THEN
                  CROT(N)=H*COS((RLON(N)-ORIENT)/DPR)
                  SROT(N)=SIN((RLON(N)-ORIENT)/DPR)
                ELSE
                  CROT(N)=1
                  SROT(N)=0
                ENDIF
              ENDIF
            ELSE
              RLON(N)=FILL
              RLAT(N)=FILL
            ENDIF
          ENDDO
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C  TRANSLATE EARTH COORDINATES TO GRID COORDINATES
        ELSEIF(IOPT.EQ.-1) THEN
          DO N=1,NPTS
            IF(ABS(RLON(N)).LE.360.AND.ABS(RLAT(N)).LE.90.AND.
     &                                 H*RLAT(N).NE.-90) THEN
              DR=DE*TAN((90-H*RLAT(N))/2/DPR)
              XPTS(N)=XP+H*SIN((RLON(N)-ORIENT)/DPR)*DR/DXS
              YPTS(N)=YP-COS((RLON(N)-ORIENT)/DPR)*DR/DYS
              IF(XPTS(N).GE.XMIN.AND.XPTS(N).LE.XMAX.AND.
     &           YPTS(N).GE.YMIN.AND.YPTS(N).LE.YMAX) THEN
                NRET=NRET+1
                IF(LROT.EQ.1) THEN
                  IF(IROT.EQ.1) THEN
                    CROT(N)=H*COS((RLON(N)-ORIENT)/DPR)
                    SROT(N)=SIN((RLON(N)-ORIENT)/DPR)
                  ELSE
                    CROT(N)=1
                    SROT(N)=0
                  ENDIF
                ENDIF
              ELSE
                XPTS(N)=FILL
                YPTS(N)=FILL
              ENDIF
            ELSE
              XPTS(N)=FILL
              YPTS(N)=FILL
            ENDIF
          ENDDO
        ENDIF
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C  PROJECTION UNRECOGNIZED
      ELSE
        IRET=-1
        IF(IOPT.GE.0) THEN
          DO N=1,NPTS
            RLON(N)=FILL
            RLAT(N)=FILL
          ENDDO
        ENDIF
        IF(IOPT.LE.0) THEN
          DO N=1,NPTS
            XPTS(N)=FILL
            YPTS(N)=FILL
          ENDDO
        ENDIF
      ENDIF
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      END
      SUBROUTINE GDSWIZC9(KGDS,IOPT,NPTS,FILL,XPTS,YPTS,RLON,RLAT,NRET,
     &                    LROT,CROT,SROT)
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM:  GDSWIZC9   GDS WIZARD FOR ROTATED EQUIDISTANT CYLINDRICAL
C   PRGMMR: IREDELL       ORG: W/NMC23       DATE: 96-04-10
C
C ABSTRACT: THIS SUBPROGRAM DECODES THE GRIB GRID DESCRIPTION SECTION
C           (PASSED IN INTEGER FORM AS DECODED BY SUBPROGRAM W3FI63)
C           AND RETURNS ONE OF THE FOLLOWING:
C             (IOPT=+1) EARTH COORDINATES OF SELECTED GRID COORDINATES
C             (IOPT=-1) GRID COORDINATES OF SELECTED EARTH COORDINATES
C           FOR STAGGERED ROTATED EQUIDISTANT CYLINDRICAL PROJECTIONS.
C           (SEE UNDER THE DESCRIPTION OF KGDS TO DETERMINE WHETHER
C           TO COMPUTE A STAGGERED WIND GRID OR A STAGGERED MASS GRID.)
C           IF THE SELECTED COORDINATES ARE MORE THAN ONE GRIDPOINT
C           BEYOND THE THE EDGES OF THE GRID DOMAIN, THEN THE RELEVANT
C           OUTPUT ELEMENTS ARE SET TO FILL VALUES.
C           THE ACTUAL NUMBER OF VALID POINTS COMPUTED IS RETURNED TOO.
C
C PROGRAM HISTORY LOG:
C   96-04-10  IREDELL
C
C USAGE:    CALL GDSWIZC9(KGDS,IOPT,NPTS,FILL,XPTS,YPTS,RLON,RLAT,NRET,
C     &                   LROT,CROT,SROT)
C
C   INPUT ARGUMENT LIST:
C     KGDS     - INTEGER (200) GDS PARAMETERS AS DECODED BY W3FI63
C                IMPORTANT NOTE: IF THE 9TH BIT (FROM RIGHT) OF KGDS(11)
C                                (SCANNING MODE FLAG) IS 1, THEN THIS
C                                THE GRID IS COMPUTED FOR A WIND FIELD;
C                                OTHERWISE IT IS FOR A MASS FIELD.  THUS
C                                MOD(KGDS(11)/256,2)=0 FOR MASS GRID.
C     IOPT     - INTEGER OPTION FLAG
C                (+1 TO COMPUTE EARTH COORDS OF SELECTED GRID COORDS)
C                (-1 TO COMPUTE GRID COORDS OF SELECTED EARTH COORDS)
C     NPTS     - INTEGER MAXIMUM NUMBER OF COORDINATES
C     FILL     - REAL FILL VALUE TO SET INVALID OUTPUT DATA
C                (MUST BE IMPOSSIBLE VALUE; SUGGESTED VALUE: -9999.)
C     XPTS     - REAL (NPTS) GRID X POINT COORDINATES IF IOPT>0
C     YPTS     - REAL (NPTS) GRID Y POINT COORDINATES IF IOPT>0
C     RLON     - REAL (NPTS) EARTH LONGITUDES IN DEGREES E IF IOPT<0
C                (ACCEPTABLE RANGE: -360. TO 360.)
C     RLAT     - REAL (NPTS) EARTH LATITUDES IN DEGREES N IF IOPT<0
C                (ACCEPTABLE RANGE: -90. TO 90.)
C     LROT     - INTEGER FLAG TO RETURN VECTOR ROTATIONS IF 1
C
C   OUTPUT ARGUMENT LIST:
C     XPTS     - REAL (NPTS) GRID X POINT COORDINATES IF IOPT<0
C     YPTS     - REAL (NPTS) GRID Y POINT COORDINATES IF IOPT<0
C     RLON     - REAL (NPTS) EARTH LONGITUDES IN DEGREES E IF IOPT>0
C     RLAT     - REAL (NPTS) EARTH LATITUDES IN DEGREES N IF IOPT>0
C     NRET     - INTEGER NUMBER OF VALID POINTS COMPUTED
C     CROT     - REAL (NPTS) CLOCKWISE VECTOR ROTATION COSINES IF LROT=1
C     SROT     - REAL (NPTS) CLOCKWISE VECTOR ROTATION SINES IF LROT=1
C                (UGRID=CROT*UEARTH-SROT*VEARTH;
C                 VGRID=SROT*UEARTH+CROT*VEARTH)
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 77
C
C$$$
      INTEGER KGDS(200)
      REAL XPTS(NPTS),YPTS(NPTS),RLON(NPTS),RLAT(NPTS)
      REAL CROT(NPTS),SROT(NPTS)
      PARAMETER(RERTH=6.3712E6)
      PARAMETER(PI=3.14159265358979,DPR=180./PI)
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      IF(KGDS(1).EQ.201) THEN
        RLAT1=KGDS(4)*1.E-3
        RLON1=KGDS(5)*1.E-3
        IROT=MOD(KGDS(6)/8,2)
        IM=KGDS(7)*2-1
        JM=KGDS(8)
        DLON=KGDS(9)*1.E-3
        DLAT=KGDS(10)*1.E-3
        KSCAN=MOD(KGDS(11)/256,2)
        ISCAN=MOD(KGDS(11)/128,2)
        JSCAN=MOD(KGDS(11)/64,2)
        NSCAN=MOD(KGDS(11)/32,2)
        HI=(-1.)**ISCAN
        HJ=(-1.)**(1-JSCAN)
        DLONS=HI*DLON
        DLATS=HJ*DLAT
        RLONR=-(IM-1)/2*DLONS
        RLATR=-(JM-1)/2*DLATS
        SLAT1=SIN(RLAT1/DPR)
        CLAT1=COS(RLAT1/DPR)
        SLONR=SIN(RLONR/DPR)
        CLONR=COS(RLONR/DPR)
        SLATR=SIN(RLATR/DPR)
        CLATR=COS(RLATR/DPR)
        DENOM=1-(CLATR*SLONR)**2
        SLAT0=(SLAT1*CLATR*CLONR-SLATR*SQRT(DENOM-SLAT1**2))/DENOM
        CLAT0=SQRT(1-SLAT0**2)
        RLON0=RLON1+HI*DPR*ACOS((CLAT0*CLATR*CLONR-SLAT0*SLATR)/CLAT1)
C  THE FOLLOWING INDENTED LINES ARE A TEMPORARY FIX OF IMPRECISE GRID.
C  CAUTION: CENTRAL LATITUDE AND LONGITUDE ARE ASSUMED TO BE INTEGERS.
         SLAT0=SIN(NINT(ASIN(SLAT0)*DPR)/DPR)
         CLAT0=SQRT(1-SLAT0**2)
         RLON0=NINT(RLON0)
         HS=SIGN(1.,MOD(RLON1-RLON0+180+3600,360.)-180)
         CLON1=COS((RLON1-RLON0)/DPR)
         SLATR=CLAT0*SLAT1-SLAT0*CLAT1*CLON1
         CLATR=SQRT(1-SLATR**2)
         CLONR=(CLAT0*CLAT1*CLON1+SLAT0*SLAT1)/CLATR
         RLATR=DPR*ASIN(SLATR)
         RLONR=HS*DPR*ACOS(CLONR)
         DLATS=RLATR/(-(JM-1)/2)
         DLONS=RLONR/(-(IM-1)/2)
        IF(KSCAN.EQ.0) THEN
          IS1=(JM+1)/2
        ELSE
          IS1=JM/2
        ENDIF
        XMIN=0
        XMAX=IM+1
        IF(IM.EQ.NINT(360/ABS(DLONS))) XMAX=IM+2
        YMIN=0
        YMAX=JM+1
        NRET=0
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C  TRANSLATE GRID COORDINATES TO EARTH COORDINATES
        IF(IOPT.EQ.0.OR.IOPT.EQ.1) THEN
          DO N=1,NPTS
            XPTF=YPTS(N)+(XPTS(N)-IS1)
            YPTF=YPTS(N)-(XPTS(N)-IS1)+KSCAN
            IF(XPTF.GE.XMIN.AND.XPTF.LE.XMAX.AND.
     &         YPTF.GE.YMIN.AND.YPTF.LE.YMAX) THEN
              HS=HI*SIGN(1.,XPTF-(IM+1)/2)
              RLONR=(XPTF-(IM+1)/2)*DLONS
              RLATR=(YPTF-(JM+1)/2)*DLATS
              CLONR=COS(RLONR/DPR)
              SLATR=SIN(RLATR/DPR)
              CLATR=COS(RLATR/DPR)
              SLAT=CLAT0*SLATR+SLAT0*CLATR*CLONR
              IF(SLAT.LE.-1) THEN
                CLAT=0.
                CLON=COS(RLON0/DPR)
                RLON(N)=0
                RLAT(N)=-90
              ELSEIF(SLAT.GE.1) THEN
                CLAT=0.
                CLON=COS(RLON0/DPR)
                RLON(N)=0
                RLAT(N)=90
              ELSE
                CLAT=SQRT(1-SLAT**2)
                CLON=(CLAT0*CLATR*CLONR-SLAT0*SLATR)/CLAT
                CLON=MIN(MAX(CLON,-1.),1.)
                RLON(N)=MOD(RLON0+HS*DPR*ACOS(CLON)+3600,360.)
                RLAT(N)=DPR*ASIN(SLAT)
              ENDIF
              NRET=NRET+1
              IF(LROT.EQ.1) THEN
                IF(IROT.EQ.1) THEN
                  IF(CLATR.LE.0) THEN
                    CROT(N)=-SIGN(1.,SLATR*SLAT0)
                    SROT(N)=0
                  ELSE
                    SLON=SIN((RLON(N)-RLON0)/DPR)
                    CROT(N)=(CLAT0*CLAT+SLAT0*SLAT*CLON)/CLATR
                    SROT(N)=SLAT0*SLON/CLATR
                  ENDIF
                ELSE
                  CROT(N)=1
                  SROT(N)=0
                ENDIF
              ENDIF
            ELSE
              RLON(N)=FILL
              RLAT(N)=FILL
            ENDIF
          ENDDO
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C  TRANSLATE EARTH COORDINATES TO GRID COORDINATES
        ELSEIF(IOPT.EQ.-1) THEN
          DO N=1,NPTS
            IF(ABS(RLON(N)).LE.360.AND.ABS(RLAT(N)).LE.90) THEN
              HS=SIGN(1.,MOD(RLON(N)-RLON0+180+3600,360.)-180)
              CLON=COS((RLON(N)-RLON0)/DPR)
              SLAT=SIN(RLAT(N)/DPR)
              CLAT=COS(RLAT(N)/DPR)
              SLATR=CLAT0*SLAT-SLAT0*CLAT*CLON
              IF(SLATR.LE.-1) THEN
                CLATR=0.
                RLONR=0
                RLATR=-90
              ELSEIF(SLATR.GE.1) THEN
                CLATR=0.
                RLONR=0
                RLATR=90
              ELSE
                CLATR=SQRT(1-SLATR**2)
                CLONR=(CLAT0*CLAT*CLON+SLAT0*SLAT)/CLATR
                CLONR=MIN(MAX(CLONR,-1.),1.)
                RLONR=HS*DPR*ACOS(CLONR)
                RLATR=DPR*ASIN(SLATR)
              ENDIF
              XPTF=(IM+1)/2+RLONR/DLONS
              YPTF=(JM+1)/2+RLATR/DLATS
              IF(XPTF.GE.XMIN.AND.XPTF.LE.XMAX.AND.
     &           YPTF.GE.YMIN.AND.YPTF.LE.YMAX) THEN
                XPTS(N)=IS1+(XPTF-(YPTF-KSCAN))/2
                YPTS(N)=(XPTF+(YPTF-KSCAN))/2
                NRET=NRET+1
                IF(LROT.EQ.1) THEN
                  IF(IROT.EQ.1) THEN
                    IF(CLATR.LE.0) THEN
                      CROT(N)=-SIGN(1.,SLATR*SLAT0)
                      SROT(N)=0
                    ELSE
                      SLON=SIN((RLON(N)-RLON0)/DPR)
                      CROT(N)=(CLAT0*CLAT+SLAT0*SLAT*CLON)/CLATR
                      SROT(N)=SLAT0*SLON/CLATR
                    ENDIF
                  ELSE
                    CROT(N)=1
                    SROT(N)=0
                  ENDIF
                ENDIF
              ELSE
                XPTS(N)=FILL
                YPTS(N)=FILL
              ENDIF
            ELSE
              XPTS(N)=FILL
              YPTS(N)=FILL
            ENDIF
          ENDDO
        ENDIF
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C  PROJECTION UNRECOGNIZED
      ELSE
        IRET=-1
        IF(IOPT.GE.0) THEN
          DO N=1,NPTS
            RLON(N)=FILL
            RLAT(N)=FILL
          ENDDO
        ENDIF
        IF(IOPT.LE.0) THEN
          DO N=1,NPTS
            XPTS(N)=FILL
            YPTS(N)=FILL
          ENDDO
        ENDIF
      ENDIF
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      END
      SUBROUTINE GDSWIZCA(KGDS,IOPT,NPTS,FILL,XPTS,YPTS,RLON,RLAT,NRET,
     &                    LROT,CROT,SROT)
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM:  GDSWIZCA   GDS WIZARD FOR ROTATED EQUIDISTANT CYLINDRICAL
C   PRGMMR: IREDELL       ORG: W/NMC23       DATE: 96-04-10
C
C ABSTRACT: THIS SUBPROGRAM DECODES THE GRIB GRID DESCRIPTION SECTION
C           (PASSED IN INTEGER FORM AS DECODED BY SUBPROGRAM W3FI63)
C           AND RETURNS ONE OF THE FOLLOWING:
C             (IOPT=+1) EARTH COORDINATES OF SELECTED GRID COORDINATES
C             (IOPT=-1) GRID COORDINATES OF SELECTED EARTH COORDINATES
C           FOR ROTATED EQUIDISTANT CYLINDRICAL PROJECTIONS.
C           IF THE SELECTED COORDINATES ARE MORE THAN ONE GRIDPOINT
C           BEYOND THE THE EDGES OF THE GRID DOMAIN, THEN THE RELEVANT
C           OUTPUT ELEMENTS ARE SET TO FILL VALUES.
C           THE ACTUAL NUMBER OF VALID POINTS COMPUTED IS RETURNED TOO.
C
C PROGRAM HISTORY LOG:
C   96-04-10  IREDELL
C
C USAGE:    CALL GDSWIZCA(KGDS,IOPT,NPTS,FILL,XPTS,YPTS,RLON,RLAT,NRET,
C     &                   LROT,CROT,SROT)
C
C   INPUT ARGUMENT LIST:
C     KGDS     - INTEGER (200) GDS PARAMETERS AS DECODED BY W3FI63
C     IOPT     - INTEGER OPTION FLAG
C                (+1 TO COMPUTE EARTH COORDS OF SELECTED GRID COORDS)
C                (-1 TO COMPUTE GRID COORDS OF SELECTED EARTH COORDS)
C     NPTS     - INTEGER MAXIMUM NUMBER OF COORDINATES
C     FILL     - REAL FILL VALUE TO SET INVALID OUTPUT DATA
C                (MUST BE IMPOSSIBLE VALUE; SUGGESTED VALUE: -9999.)
C     XPTS     - REAL (NPTS) GRID X POINT COORDINATES IF IOPT>0
C     YPTS     - REAL (NPTS) GRID Y POINT COORDINATES IF IOPT>0
C     RLON     - REAL (NPTS) EARTH LONGITUDES IN DEGREES E IF IOPT<0
C                (ACCEPTABLE RANGE: -360. TO 360.)
C     RLAT     - REAL (NPTS) EARTH LATITUDES IN DEGREES N IF IOPT<0
C                (ACCEPTABLE RANGE: -90. TO 90.)
C     LROT     - INTEGER FLAG TO RETURN VECTOR ROTATIONS IF 1
C
C   OUTPUT ARGUMENT LIST:
C     XPTS     - REAL (NPTS) GRID X POINT COORDINATES IF IOPT<0
C     YPTS     - REAL (NPTS) GRID Y POINT COORDINATES IF IOPT<0
C     RLON     - REAL (NPTS) EARTH LONGITUDES IN DEGREES E IF IOPT>0
C     RLAT     - REAL (NPTS) EARTH LATITUDES IN DEGREES N IF IOPT>0
C     NRET     - INTEGER NUMBER OF VALID POINTS COMPUTED
C     CROT     - REAL (NPTS) CLOCKWISE VECTOR ROTATION COSINES IF LROT=1
C     SROT     - REAL (NPTS) CLOCKWISE VECTOR ROTATION SINES IF LROT=1
C                (UGRID=CROT*UEARTH-SROT*VEARTH;
C                 VGRID=SROT*UEARTH+CROT*VEARTH)
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 77
C
C$$$
      INTEGER KGDS(200)
      REAL XPTS(NPTS),YPTS(NPTS),RLON(NPTS),RLAT(NPTS)
      REAL CROT(NPTS),SROT(NPTS)
      PARAMETER(RERTH=6.3712E6)
      PARAMETER(PI=3.14159265358979,DPR=180./PI)
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      IF(KGDS(1).EQ.202) THEN
        RLAT1=KGDS(4)*1.E-3
        RLON1=KGDS(5)*1.E-3
        IROT=MOD(KGDS(6)/8,2)
        IM=KGDS(7)
        JM=KGDS(8)
        DLON=KGDS(9)*1.E-3
        DLAT=KGDS(10)*1.E-3
        ISCAN=MOD(KGDS(11)/128,2)
        JSCAN=MOD(KGDS(11)/64,2)
        NSCAN=MOD(KGDS(11)/32,2)
        HI=(-1.)**ISCAN
        HJ=(-1.)**(1-JSCAN)
        DLONS=HI*DLON
        DLATS=HJ*DLAT
        RLONR=-(IM-1)/2*DLONS
        RLATR=-(JM-1)/2*DLATS
        SLAT1=SIN(RLAT1/DPR)
        CLAT1=COS(RLAT1/DPR)
        SLONR=SIN(RLONR/DPR)
        CLONR=COS(RLONR/DPR)
        SLATR=SIN(RLATR/DPR)
        CLATR=COS(RLATR/DPR)
        DENOM=1-(CLATR*SLONR)**2
        SLAT0=(SLAT1*CLATR*CLONR-SLATR*SQRT(DENOM-SLAT1**2))/DENOM
        CLAT0=SQRT(1-SLAT0**2)
        RLON0=RLON1+HI*DPR*ACOS((CLAT0*CLATR*CLONR-SLAT0*SLATR)/CLAT1)
C  THE FOLLOWING INDENTED LINES ARE A TEMPORARY FIX OF IMPRECISE GRID.
C  CAUTION: CENTRAL LATITUDE AND LONGITUDE ARE ASSUMED TO BE INTEGERS.
         SLAT0=SIN(NINT(ASIN(SLAT0)*DPR)/DPR)
         CLAT0=SQRT(1-SLAT0**2)
         RLON0=NINT(RLON0)
         HS=SIGN(1.,MOD(RLON1-RLON0+180+3600,360.)-180)
         CLON1=COS((RLON1-RLON0)/DPR)
         SLATR=CLAT0*SLAT1-SLAT0*CLAT1*CLON1
         CLATR=SQRT(1-SLATR**2)
         CLONR=(CLAT0*CLAT1*CLON1+SLAT0*SLAT1)/CLATR
         RLATR=DPR*ASIN(SLATR)
         RLONR=HS*DPR*ACOS(CLONR)
         DLATS=RLATR/(-(JM-1)/2)
         DLONS=RLONR/(-(IM-1)/2)
        XMIN=0
        XMAX=IM+1
        IF(IM.EQ.NINT(360/ABS(DLONS))) XMAX=IM+2
        YMIN=0
        YMAX=JM+1
        NRET=0
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C  TRANSLATE GRID COORDINATES TO EARTH COORDINATES
        IF(IOPT.EQ.0.OR.IOPT.EQ.1) THEN
          DO N=1,NPTS
            IF(XPTS(N).GE.XMIN.AND.XPTS(N).LE.XMAX.AND.
     &         YPTS(N).GE.YMIN.AND.YPTS(N).LE.YMAX) THEN
              HS=HI*SIGN(1.,XPTS(N)-(IM+1)/2)
              RLONR=(XPTS(N)-(IM+1)/2)*DLONS
              RLATR=(YPTS(N)-(JM+1)/2)*DLATS
              CLONR=COS(RLONR/DPR)
              SLATR=SIN(RLATR/DPR)
              CLATR=COS(RLATR/DPR)
              SLAT=CLAT0*SLATR+SLAT0*CLATR*CLONR
              IF(SLAT.LE.-1) THEN
                CLAT=0.
                CLON=COS(RLON0/DPR)
                RLON(N)=0
                RLAT(N)=-90
              ELSEIF(SLAT.GE.1) THEN
                CLAT=0.
                CLON=COS(RLON0/DPR)
                RLON(N)=0
                RLAT(N)=90
              ELSE
                CLAT=SQRT(1-SLAT**2)
                CLON=(CLAT0*CLATR*CLONR-SLAT0*SLATR)/CLAT
                CLON=MIN(MAX(CLON,-1.),1.)
                RLON(N)=MOD(RLON0+HS*DPR*ACOS(CLON)+3600,360.)
                RLAT(N)=DPR*ASIN(SLAT)
              ENDIF
              NRET=NRET+1
              IF(LROT.EQ.1) THEN
                IF(IROT.EQ.1) THEN
                  IF(CLATR.LE.0) THEN
                    CROT(N)=-SIGN(1.,SLATR*SLAT0)
                    SROT(N)=0
                  ELSE
                    SLON=SIN((RLON(N)-RLON0)/DPR)
                    CROT(N)=(CLAT0*CLAT+SLAT0*SLAT*CLON)/CLATR
                    SROT(N)=SLAT0*SLON/CLATR
                  ENDIF
                ELSE
                  CROT(N)=1
                  SROT(N)=0
                ENDIF
              ENDIF
            ELSE
              RLON(N)=FILL
              RLAT(N)=FILL
            ENDIF
          ENDDO
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C  TRANSLATE EARTH COORDINATES TO GRID COORDINATES
        ELSEIF(IOPT.EQ.-1) THEN
          DO N=1,NPTS
            IF(ABS(RLON(N)).LE.360.AND.ABS(RLAT(N)).LE.90) THEN
              HS=SIGN(1.,MOD(RLON(N)-RLON0+180+3600,360.)-180)
              CLON=COS((RLON(N)-RLON0)/DPR)
              SLAT=SIN(RLAT(N)/DPR)
              CLAT=COS(RLAT(N)/DPR)
              SLATR=CLAT0*SLAT-SLAT0*CLAT*CLON
              IF(SLATR.LE.-1) THEN
                CLATR=0.
                RLONR=0
                RLATR=-90
              ELSEIF(SLATR.GE.1) THEN
                CLATR=0.
                RLONR=0
                RLATR=90
              ELSE
                CLATR=SQRT(1-SLATR**2)
                CLONR=(CLAT0*CLAT*CLON+SLAT0*SLAT)/CLATR
                CLONR=MIN(MAX(CLONR,-1.),1.)
                RLONR=HS*DPR*ACOS(CLONR)
                RLATR=DPR*ASIN(SLATR)
              ENDIF
              XPTS(N)=(IM+1)/2+RLONR/DLONS
              YPTS(N)=(JM+1)/2+RLATR/DLATS
              IF(XPTS(N).GE.XMIN.AND.XPTS(N).LE.XMAX.AND.
     &           YPTS(N).GE.YMIN.AND.YPTS(N).LE.YMAX) THEN
                NRET=NRET+1
                IF(LROT.EQ.1) THEN
                  IF(IROT.EQ.1) THEN
                    IF(CLATR.LE.0) THEN
                      CROT(N)=-SIGN(1.,SLATR*SLAT0)
                      SROT(N)=0
                    ELSE
                      SLON=SIN((RLON(N)-RLON0)/DPR)
                      CROT(N)=(CLAT0*CLAT+SLAT0*SLAT*CLON)/CLATR
                      SROT(N)=SLAT0*SLON/CLATR
                    ENDIF
                  ELSE
                    CROT(N)=1
                    SROT(N)=0
                  ENDIF
                ENDIF
              ELSE
                XPTS(N)=FILL
                YPTS(N)=FILL
              ENDIF
            ELSE
              XPTS(N)=FILL
              YPTS(N)=FILL
            ENDIF
          ENDDO
        ENDIF
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C  PROJECTION UNRECOGNIZED
      ELSE
        IRET=-1
        IF(IOPT.GE.0) THEN
          DO N=1,NPTS
            RLON(N)=FILL
            RLAT(N)=FILL
          ENDDO
        ENDIF
        IF(IOPT.LE.0) THEN
          DO N=1,NPTS
            XPTS(N)=FILL
            YPTS(N)=FILL
          ENDDO
        ENDIF
      ENDIF
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      END
      SUBROUTINE GDSWIZCB(KGDS,IOPT,NPTS,FILL,XPTS,YPTS,RLON,RLAT,NRET,
     &                    LROT,CROT,SROT)
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM:  GDSWIZCB   GDS WIZARD FOR ROTATED EQUIDISTANT CYLINDRICAL
C   PRGMMR: IREDELL       ORG: W/NMC23       DATE: 96-04-10
C
C ABSTRACT: THIS SUBPROGRAM DECODES THE GRIB GRID DESCRIPTION SECTION
C           (PASSED IN INTEGER FORM AS DECODED BY SUBPROGRAM W3FI63)
C           AND RETURNS ONE OF THE FOLLOWING:
C             (IOPT=+1) EARTH COORDINATES OF SELECTED GRID COORDINATES
C             (IOPT=-1) GRID COORDINATES OF SELECTED EARTH COORDINATES
C           FOR STAGGERED ROTATED EQUIDISTANT CYLINDRICAL PROJECTIONS.
C           (SEE UNDER THE DESCRIPTION OF KGDS TO DETERMINE WHETHER
C           TO COMPUTE A STAGGERED WIND GRID OR A STAGGERED MASS GRID.)
C           IF THE SELECTED COORDINATES ARE MORE THAN ONE GRIDPOINT
C           BEYOND THE THE EDGES OF THE GRID DOMAIN, THEN THE RELEVANT
C           OUTPUT ELEMENTS ARE SET TO FILL VALUES.
C           THE ACTUAL NUMBER OF VALID POINTS COMPUTED IS RETURNED TOO.
C
C PROGRAM HISTORY LOG:
C   96-04-10  IREDELL
C   98-08-19  BALDWIN    MODIFY GDSWIZC9 FOR TYPE 203 ETA GRIDS
C
C USAGE:    CALL GDSWIZCB(KGDS,IOPT,NPTS,FILL,XPTS,YPTS,RLON,RLAT,NRET,
C     &                   LROT,CROT,SROT)
C
C   INPUT ARGUMENT LIST:
C     KGDS     - INTEGER (200) GDS PARAMETERS AS DECODED BY W3FI63
C                IMPORTANT NOTE: IF THE 9TH BIT (FROM RIGHT) OF KGDS(11)
C                                (SCANNING MODE FLAG) IS 1, THEN THIS
C                                THE GRID IS COMPUTED FOR A WIND FIELD;
C                                OTHERWISE IT IS FOR A MASS FIELD.  THUS
C                                MOD(KGDS(11)/256,2)=0 FOR MASS GRID.
C     IOPT     - INTEGER OPTION FLAG
C                (+1 TO COMPUTE EARTH COORDS OF SELECTED GRID COORDS)
C                (-1 TO COMPUTE GRID COORDS OF SELECTED EARTH COORDS)
C     NPTS     - INTEGER MAXIMUM NUMBER OF COORDINATES
C     FILL     - REAL FILL VALUE TO SET INVALID OUTPUT DATA
C                (MUST BE IMPOSSIBLE VALUE; SUGGESTED VALUE: -9999.)
C     XPTS     - REAL (NPTS) GRID X POINT COORDINATES IF IOPT>0
C     YPTS     - REAL (NPTS) GRID Y POINT COORDINATES IF IOPT>0
C     RLON     - REAL (NPTS) EARTH LONGITUDES IN DEGREES E IF IOPT<0
C                (ACCEPTABLE RANGE: -360. TO 360.)
C     RLAT     - REAL (NPTS) EARTH LATITUDES IN DEGREES N IF IOPT<0
C                (ACCEPTABLE RANGE: -90. TO 90.)
C     LROT     - INTEGER FLAG TO RETURN VECTOR ROTATIONS IF 1
C
C   OUTPUT ARGUMENT LIST:
C     XPTS     - REAL (NPTS) GRID X POINT COORDINATES IF IOPT<0
C     YPTS     - REAL (NPTS) GRID Y POINT COORDINATES IF IOPT<0
C     RLON     - REAL (NPTS) EARTH LONGITUDES IN DEGREES E IF IOPT>0
C     RLAT     - REAL (NPTS) EARTH LATITUDES IN DEGREES N IF IOPT>0
C     NRET     - INTEGER NUMBER OF VALID POINTS COMPUTED
C     CROT     - REAL (NPTS) CLOCKWISE VECTOR ROTATION COSINES IF LROT=1
C     SROT     - REAL (NPTS) CLOCKWISE VECTOR ROTATION SINES IF LROT=1
C                (UGRID=CROT*UEARTH-SROT*VEARTH;
C                 VGRID=SROT*UEARTH+CROT*VEARTH)
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 77
C
C$$$
      INTEGER KGDS(200)
      REAL XPTS(NPTS),YPTS(NPTS),RLON(NPTS),RLAT(NPTS)
      REAL CROT(NPTS),SROT(NPTS)
      PARAMETER(RERTH=6.3712E6)
      PARAMETER(PI=3.14159265358979,DPR=180./PI)
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      IF(KGDS(1).EQ.203) THEN
        RLAT1=KGDS(4)*1.E-3
        RLON1=KGDS(5)*1.E-3
        RLAT0=KGDS(7)*1.E-3
        RLON0=KGDS(8)*1.E-3
        IROT=MOD(KGDS(6)/8,2)
        IM=KGDS(2)*2-1
        JM=KGDS(3)
        KSCAN=MOD(KGDS(11)/256,2)
        ISCAN=MOD(KGDS(11)/128,2)
        JSCAN=MOD(KGDS(11)/64,2)
        NSCAN=MOD(KGDS(11)/32,2)
        HI=(-1.)**ISCAN
        HJ=(-1.)**(1-JSCAN)
        SLAT1=SIN(RLAT1/DPR)
        CLAT1=COS(RLAT1/DPR)
        SLAT0=SIN(RLAT0/DPR)
        CLAT0=COS(RLAT0/DPR)
        HS=SIGN(1.,MOD(RLON1-RLON0+180+3600,360.)-180)
        CLON1=COS((RLON1-RLON0)/DPR)
        SLATR=CLAT0*SLAT1-SLAT0*CLAT1*CLON1
        CLATR=SQRT(1-SLATR**2)
        CLONR=(CLAT0*CLAT1*CLON1+SLAT0*SLAT1)/CLATR
        RLATR=DPR*ASIN(SLATR)
        RLONR=HS*DPR*ACOS(CLONR)
        DLATS=RLATR/(-(JM-1)/2)
        DLONS=RLONR/(-(IM-1)/2)
        IF(KSCAN.EQ.0) THEN
          IS1=(JM+1)/2
        ELSE
          IS1=JM/2
        ENDIF
        XMIN=0
        XMAX=IM+1
        IF(IM.EQ.NINT(360/ABS(DLONS))) XMAX=IM+2
        YMIN=0
        YMAX=JM+1
        NRET=0
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C  TRANSLATE GRID COORDINATES TO EARTH COORDINATES
        IF(IOPT.EQ.0.OR.IOPT.EQ.1) THEN
          DO N=1,NPTS
            XPTF=YPTS(N)+(XPTS(N)-IS1)
            YPTF=YPTS(N)-(XPTS(N)-IS1)+KSCAN
            IF(XPTF.GE.XMIN.AND.XPTF.LE.XMAX.AND.
     &         YPTF.GE.YMIN.AND.YPTF.LE.YMAX) THEN
              HS=HI*SIGN(1.,XPTF-(IM+1)/2)
              RLONR=(XPTF-(IM+1)/2)*DLONS
              RLATR=(YPTF-(JM+1)/2)*DLATS
              CLONR=COS(RLONR/DPR)
              SLATR=SIN(RLATR/DPR)
              CLATR=COS(RLATR/DPR)
              SLAT=CLAT0*SLATR+SLAT0*CLATR*CLONR
              IF(SLAT.LE.-1) THEN
                CLAT=0.
                CLON=COS(RLON0/DPR)
                RLON(N)=0
                RLAT(N)=-90
              ELSEIF(SLAT.GE.1) THEN
                CLAT=0.
                CLON=COS(RLON0/DPR)
                RLON(N)=0
                RLAT(N)=90
              ELSE
                CLAT=SQRT(1-SLAT**2)
                CLON=(CLAT0*CLATR*CLONR-SLAT0*SLATR)/CLAT
                CLON=MIN(MAX(CLON,-1.),1.)
                RLON(N)=MOD(RLON0+HS*DPR*ACOS(CLON)+3600,360.)
                RLAT(N)=DPR*ASIN(SLAT)
              ENDIF
              NRET=NRET+1
              IF(LROT.EQ.1) THEN
                IF(IROT.EQ.1) THEN
                  IF(CLATR.LE.0) THEN
                    CROT(N)=-SIGN(1.,SLATR*SLAT0)
                    SROT(N)=0
                  ELSE
                    SLON=SIN((RLON(N)-RLON0)/DPR)
                    CROT(N)=(CLAT0*CLAT+SLAT0*SLAT*CLON)/CLATR
                    SROT(N)=SLAT0*SLON/CLATR
                  ENDIF
                ELSE
                  CROT(N)=1
                  SROT(N)=0
                ENDIF
              ENDIF
            ELSE
              RLON(N)=FILL
              RLAT(N)=FILL
            ENDIF
          ENDDO
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C  TRANSLATE EARTH COORDINATES TO GRID COORDINATES
        ELSEIF(IOPT.EQ.-1) THEN
          DO N=1,NPTS
            IF(ABS(RLON(N)).LE.360.AND.ABS(RLAT(N)).LE.90) THEN
              HS=SIGN(1.,MOD(RLON(N)-RLON0+180+3600,360.)-180)
              CLON=COS((RLON(N)-RLON0)/DPR)
              SLAT=SIN(RLAT(N)/DPR)
              CLAT=COS(RLAT(N)/DPR)
              SLATR=CLAT0*SLAT-SLAT0*CLAT*CLON
              IF(SLATR.LE.-1) THEN
                CLATR=0.
                RLONR=0
                RLATR=-90
              ELSEIF(SLATR.GE.1) THEN
                CLATR=0.
                RLONR=0
                RLATR=90
              ELSE
                CLATR=SQRT(1-SLATR**2)
                CLONR=(CLAT0*CLAT*CLON+SLAT0*SLAT)/CLATR
                CLONR=MIN(MAX(CLONR,-1.),1.)
                RLONR=HS*DPR*ACOS(CLONR)
                RLATR=DPR*ASIN(SLATR)
              ENDIF
              XPTF=(IM+1)/2+RLONR/DLONS
              YPTF=(JM+1)/2+RLATR/DLATS
              IF(XPTF.GE.XMIN.AND.XPTF.LE.XMAX.AND.
     &           YPTF.GE.YMIN.AND.YPTF.LE.YMAX) THEN
                XPTS(N)=IS1+(XPTF-(YPTF-KSCAN))/2
                YPTS(N)=(XPTF+(YPTF-KSCAN))/2
                NRET=NRET+1
                IF(LROT.EQ.1) THEN
                  IF(IROT.EQ.1) THEN
                    IF(CLATR.LE.0) THEN
                      CROT(N)=-SIGN(1.,SLATR*SLAT0)
                      SROT(N)=0
                    ELSE
                      SLON=SIN((RLON(N)-RLON0)/DPR)
                      CROT(N)=(CLAT0*CLAT+SLAT0*SLAT*CLON)/CLATR
                      SROT(N)=SLAT0*SLON/CLATR
                    ENDIF
                  ELSE
                    CROT(N)=1
                    SROT(N)=0
                  ENDIF
                ENDIF
              ELSE
                XPTS(N)=FILL
                YPTS(N)=FILL
              ENDIF
            ELSE
              XPTS(N)=FILL
              YPTS(N)=FILL
            ENDIF
          ENDDO
        ENDIF
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C  PROJECTION UNRECOGNIZED
      ELSE
        IRET=-1
        IF(IOPT.GE.0) THEN
          DO N=1,NPTS
            RLON(N)=FILL
            RLAT(N)=FILL
          ENDDO
        ENDIF
        IF(IOPT.LE.0) THEN
          DO N=1,NPTS
            XPTS(N)=FILL
            YPTS(N)=FILL
          ENDDO
        ENDIF
      ENDIF
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      END
C
C-----------------------------------------------------------------------
      SUBROUTINE SPLAT(IDRT,JMAX,SLAT,WLAT)
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM:  SPLAT      COMPUTE LATITUDE FUNCTIONS
C   PRGMMR: IREDELL       ORG: W/NMC23       DATE: 96-02-20
C
C ABSTRACT: COMPUTES COSINES OF COLATITUDE AND GAUSSIAN WEIGHTS
C           FOR ONE OF THE FOLLOWING SPECIFIC GLOBAL SETS OF LATITUDES.
C             GAUSSIAN LATITUDES (IDRT=4)
C             EQUALLY-SPACED LATITUDES INCLUDING POLES (IDRT=0)
C             EQUALLY-SPACED LATITUDES EXCLUDING POLES (IDRT=256)
C           THE GAUSSIAN LATITUDES ARE LOCATED AT THE ZEROES OF THE
C           LEGENDRE POLYNOMIAL OF THE GIVEN ORDER.  THESE LATITUDES
C           ARE EFFICIENT FOR REVERSIBLE TRANSFORMS FROM SPECTRAL SPACE.
C           (ABOUT TWICE AS MANY EQUALLY-SPACED LATITUDES ARE NEEDED.)
C           THE WEIGHTS FOR THE EQUALLY-SPACED LATITUDES ARE BASED ON
C           ELLSAESSER (JAM,1966).  (NO WEIGHT IS GIVEN THE POLE POINT.)
C           NOTE THAT WHEN ANALYZING GRID TO SPECTRAL IN LATITUDE PAIRS,
C           IF AN EQUATOR POINT EXISTS, ITS WEIGHT SHOULD BE HALVED.
C           THIS VERSION INVOKES THE IBM ESSL MATRIX SOLVER.
C
C PROGRAM HISTORY LOG:
C   96-02-20  IREDELL
C   97-10-20  IREDELL  ADJUST PRECISION
C   98-06-11  IREDELL  GENERALIZE PRECISION USING FORTRAN 90 INTRINSIC
C 1998-12-03  IREDELL  GENERALIZE PRECISION FURTHER
C 1998-12-03  IREDELL  USE BLAS CALLS
C
C USAGE:    CALL SPLAT(IDRT,JMAX,SLAT,WLAT)
C
C   INPUT ARGUMENT LIST:
C     IDRT     - INTEGER GRID IDENTIFIER
C                (IDRT=4 FOR GAUSSIAN GRID,
C                 IDRT=0 FOR EQUALLY-SPACED GRID INCLUDING POLES,
C                 IDRT=256 FOR EQUALLY-SPACED GRID EXCLUDING POLES)
C     JMAX     - INTEGER NUMBER OF LATITUDES.
C
C   OUTPUT ARGUMENT LIST:
C     SLAT     - REAL (JMAX) SINES OF LATITUDE.
C     WLAT     - REAL (JMAX) GAUSSIAN WEIGHTS.
C
C SUBPROGRAMS CALLED:
C   DGEF         MATRIX FACTORIZATION
C   DGES         MATRIX SOLVER
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C
C$$$
      REAL SLAT(JMAX),WLAT(JMAX)
      DOUBLE PRECISION PK(JMAX/2),PKM1(JMAX/2),PKM2(JMAX/2)
      DOUBLE PRECISION  SLATD(JMAX/2),SP,SPMAX,EPS
      PARAMETER(JZ=50)
      REAL BZ(JZ)
      DATA BZ        / 2.4048255577,  5.5200781103,
     $  8.6537279129, 11.7915344391, 14.9309177086, 18.0710639679,
     $ 21.2116366299, 24.3524715308, 27.4934791320, 30.6346064684,
     $ 33.7758202136, 36.9170983537, 40.0584257646, 43.1997917132,
     $ 46.3411883717, 49.4826098974, 52.6240518411, 55.7655107550,
     $ 58.9069839261, 62.0484691902, 65.1899648002, 68.3314693299,
     $ 71.4729816036, 74.6145006437, 77.7560256304, 80.8975558711,
     $ 84.0390907769, 87.1806298436, 90.3221726372, 93.4637187819,
     $ 96.6052679510, 99.7468198587, 102.888374254, 106.029930916,
     $ 109.171489649, 112.313050280, 115.454612653, 118.596176630,
     $ 121.737742088, 124.879308913, 128.020877005, 131.162446275,
     $ 134.304016638, 137.445588020, 140.587160352, 143.728733573,
     $ 146.870307625, 150.011882457, 153.153458019, 156.295034268 /
C      DOUBLE PRECISION DLT
      DOUBLE PRECISION D1
C      DOUBLE PRECISION AWORK((JMAX+1)/2,(JMAX+1)/2), BWORK((JMAX+1)/2)
      INTEGER JHE,JHO,J0,NEXP
C      INTEGER IPVT((JMAX+1)/2)
      PARAMETER(PI=3.14159265358979,C=(1.-(2./PI)**2)*0.25)
      D1 = 1.
      J0 = 0
      NEXP = -48 
      EPS=10.* 2**NEXP
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C  GAUSSIAN LATITUDES
      IF(IDRT.EQ.4) THEN
        JH=JMAX/2
        JHE=(JMAX+1)/2
        R=1./SQRT((JMAX+0.5)**2+C)
        DO J=1,MIN(JH,JZ)
          SLATD(J)=COS(BZ(J)*R)
        ENDDO
        DO J=JZ+1,JH
          SLATD(J)=COS((BZ(JZ)+(J-JZ)*PI)*R)
        ENDDO
        SPMAX=1.
        DO WHILE(SPMAX.GT.EPS)
          SPMAX=0.
          DO J=1,JH
            PKM1(J)=1.
            PK(J)=SLATD(J)
          ENDDO
          DO N=2,JMAX
            DO J=1,JH
              PKM2(J)=PKM1(J)
              PKM1(J)=PK(J)
              PK(J)=((2*N-1)*SLATD(J)*PKM1(J)-(N-1)*PKM2(J))/N
            ENDDO
          ENDDO
          DO J=1,JH
            SP=PK(J)*(1.-SLATD(J)**2)/(JMAX*(PKM1(J)-SLATD(J)*PK(J)))
            SLATD(J)=SLATD(J)-SP
            SPMAX=MAX(SPMAX,ABS(SP))
          ENDDO
        ENDDO
CDIR$ IVDEP
        DO J=1,JH
          SLAT(J)=SLATD(J)
          WLAT(J)=(2.*(1.-SLATD(J)**2))/(JMAX*PKM1(J))**2
          SLAT(JMAX+1-J)=-SLAT(J)
          WLAT(JMAX+1-J)=WLAT(J)
        ENDDO
        IF(JHE.GT.JH) THEN
          SLAT(JHE)=0.
          WLAT(JHE)=2./JMAX**2
          DO N=2,JMAX,2
            WLAT(JHE)=WLAT(JHE)*N**2/(N-1)**2
          ENDDO
        ENDIF
      ENDIF
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      RETURN
      END
C
      SUBROUTINE GAQDNIO(NLAT,THETA,WTS,WORK,LWORK,IERROR)
C     SUBROUTINE GAQDNIO COMPUTES GAUSSIAN POINTS (IN RADIANS) AND WEIGHTS
C     ON THE SPHERE IN THE INTERVAL (0,PI).  (THESE CAN BE USED IN
C     GAUSSIAN QUADRATURE FOR ESTIMATING INTEGRALS ON THE SPHERE)
C
C
C
C
      DIMENSION WORK(LWORK),THETA(NLAT),WTS(NLAT)
      DOUBLE PRECISION WORK,THETA,WTS,X
      N = NLAT
      IERROR = 1
C     CHECK WORK SPACE LENGTH
      IF (LWORK.LT.4*N*(N+1)+2) RETURN
      IERROR = 2
      IF (N.LE.0) RETURN
      IERROR = 0
      IF (N.GT.2) THEN
C     PARTITION WORK SPACE FOR DOUBLE PRECISION EIGENVALUE(VECTOR COMPUTATION)
      I1 = 1
      I2 = I1+2*N
      I3 = I2+2*N
      CALL GAQDNIO1(N,THETA,WTS,WORK(I1),WORK(I2),WORK(I3),IERROR)
      IF (IERROR.NE.0) THEN
      IERROR = 3
      RETURN
      END IF
      RETURN
      ELSE IF (N.EQ.1) THEN
      WTS(1) = 2.0D0
      THETA(1) = DACOS(0.0D0)
      ELSE IF (N.EQ.2) THEN
C     COMPUTE WEIGHTS AND POINTS ANALYTICALLY WHEN N=2
      WTS(1) = 1.0D0
      WTS(2) = 1.0D0
      X = DSQRT(1.0D0/3.0D0)
      THETA(1) = DACOS(X)
      THETA(2) = DACOS(-X)
      RETURN
      END IF
      END
C
      SUBROUTINE GAQDNIO1(N,THETA,WTS,W,E,WRK,IER)
C
      DIMENSION THETA(N),WTS(N),W(N),E(N),WRK(1)
      DOUBLE PRECISION THETA,WTS,TEMP,W,E,WRK
C     SET SYMMETRIC TRIDIAGNONAL MATRIX SUBDIAGONAL AND DIAGONAL
C     COEFFICIENTS FOR MATRIX COMING FROM COEFFICIENTS IN THE
C     RECURSION FORMULA FOR LEGENDRE POLYNOMIALS
C     A(N)*P(N-1)+B(N)*P(N)+C(N)*P(N+1) = 0.
      WRK(1)=0.D0
      WRK(N+1) = 0.D0
      W(1)=0.D0
      E(1) = 0.D0
      DO 100 J=2,N
      WRK(J)= (J-1.D0)/DSQRT((2.D0*J-1.D0)*(2.D0*J-3.D0))
      WRK(J+N)=0.D0
      E(J) = WRK(J)
      W(J) = 0.D0
  100 CONTINUE
C     COMPUTE EIGENVALUES  OF MATRIX
      MATZ = 1
      INDX = 2*N+1
      NP1=N+1
      CALL DRSTNIO(N,N,W,E,MATZ,WRK(INDX),IER)
      IF (IER.NE.0) RETURN
C     COMPUTE GAUSSIAN WEIGHTS AND POINTS
      DO 101 J=1,N
      THETA(J) = DACOS(W(J))
C     SET GAUSSIAN WEIGHTS AS 1ST COMPONENTS OF EIGENVECTORS SQUARED
      INDX = (J+1)*N+1
      WTS(J) = 2.0D0*WRK(INDX)**2
  101 CONTINUE
C     REVERSE ORDER OF GAUSSIAN POINTS TO BE
C     MONOTONIC INCREASING IN RADIANS
      N2 = N/2
      DO 102 I=1,N2
      TEMP = THETA(I)
      THETA(I) = THETA(N-I+1)
      THETA(N-I+1) = TEMP
  102 CONTINUE
      RETURN
      END
C
C
      SUBROUTINE DRSTNIO(NM,N,W,E,MATZ,Z,IERR)
C     DRSTNIO IS A DOUBLE PRECISION MODIFICATION OF RST OFF EISPACK
C     TO BE USED  TO COMPUTE GAUSSIAN POINTS AND WEIGHTS
C
C
      INTEGER I,J,N,NM,IERR,MATZ
      DOUBLE PRECISION W(N),E(N),Z(NM,N)
C
C
C     .......... FIND BOTH EIGENVALUES AND EIGENVECTORS ..........
   20 DO 40 I = 1, N
C
         DO 30 J = 1, N
            Z(J,I) = 0.0D0
   30    CONTINUE
C
         Z(I,I) = 1.0D0
   40 CONTINUE
C
      CALL  DINTQLNIO(NM,N,W,E,Z,IERR)
      RETURN
      END
C
      SUBROUTINE DINTQLNIO(NM,N,D,E,Z,IERR)
C     DINTQLNIO IS A DOUBLE PRECISION MODIFICATION OF INTQL2 OFF
C     EISPACK TO BE USED BY GAQDNIO IN SPHEREPACK FOR COMPUTING
C     GAUSSIAN WEIGHTS AND POINTS
C
      INTEGER I,J,K,L,M,N,II,NM,MML,IERR
      DOUBLE PRECISION D(N),E(N),Z(NM,N)
      DOUBLE PRECISION B,C,F,G,P,R,S,TST1,TST2,DPYTHANIO
      IERR = 0
      IF (N .EQ. 1) GO TO 1001
C
      DO 100 I = 2, N
  100 E(I-1) = E(I)
C
      E(N) = 0.0D0
C
      DO 240 L = 1, N
         J = 0
C     .......... LOOK FOR SMALL SUB-DIAGONAL ELEMENT ..........
C   
  105    NM1 = N-1     
         IF(L .GT. NM1) GO TO 111
         DO 110 MDO = L, NM1
            M = MDO
            TST1 = DABS(D(M)) + DABS(D(M+1))
            TST2 = TST1 + DABS(E(M))
            IF (TST2 .EQ. TST1) GO TO 120
  110    CONTINUE
  111    M = N
C
  120    P = D(L)
         IF (M .EQ. L) GO TO 240
         IF (J .EQ. 30) GO TO 1000
         J = J + 1
C     .......... FORM SHIFT ..........
         G = (D(L+1) - P) / (2.0D0 * E(L))
         R = DPYTHANIO(G,1.0D0)
         G = D(M) - P + E(L) / (G + SIGN(R,G))
         S = 1.0D0
         C = 1.0D0
         P = 0.0D0
         MML = M - L
C     .......... FOR I=M-1 STEP -1 UNTIL L DO -- ..........
         DO 200 II = 1, MML
            I = M - II
            F = S * E(I)
            B = C * E(I)
            R = DPYTHANIO(F,G)
            E(I+1) = R
            IF (R .EQ. 0.0D0) GO TO 210
            S = F / R
            C = G / R
            G = D(I+1) - P
            R = (D(I) - G) * S + 2.0D0 * C * B
            P = S * R
            D(I+1) = G + P
            G = C * R - B
C     .......... FORM VECTOR ..........
            DO 180 K = 1, N
               F = Z(K,I+1)
               Z(K,I+1) = S * Z(K,I) + C * F
               Z(K,I) = C * Z(K,I) - S * F
  180       CONTINUE
C
  200    CONTINUE
C
         D(L) = D(L) - P
         E(L) = G
         E(M) = 0.0D0
         GO TO 105
C     .......... RECOVER FROM UNDERFLOW ..........
  210    D(I+1) = D(I+1) - P
         E(M) = 0.0D0
         GO TO 105
  240 CONTINUE
C     .......... ORDER EIGENVALUES AND EIGENVECTORS ..........
      DO 300 II = 2, N
         I = II - 1
         K = I
         P = D(I)
C
         DO 260 J = II, N
            IF (D(J) .GE. P) GO TO 260
            K = J
            P = D(J)
  260    CONTINUE
C
         IF (K .EQ. I) GO TO 300
         D(K) = D(I)
         D(I) = P
C
         DO 280 J = 1, N
            P = Z(J,I)
            Z(J,I) = Z(J,K)
            Z(J,K) = P
  280    CONTINUE
C
  300 CONTINUE
C
      GO TO 1001
C     .......... SET ERROR -- NO CONVERGENCE TO AN
C                EIGENVALUE AFTER 30 ITERATIONS ..........
 1000 IERR = L
 1001 RETURN
      END
C
      DOUBLE PRECISION FUNCTION DPYTHANIO(A,B)
      DOUBLE PRECISION A,B
C     DPYTHANIO IS A DOUBLE PRECISION MODIFICATION OF PYTHAG OFF EISPACK
C     FOR USE BY DIMTQL
C
C
C     FINDS SQRT(A**2+B**2) WITHOUT OVERFLOW OR DESTRUCTIVE UNDERFLOW
C
      DOUBLE PRECISION P,R,S,T,U
      P = DABS(A)
      IF (DABS(B).GE.DABS(A)) P = DABS(B)
C     P = AMAX1(DABS(A),DABS(B))
      IF (P .EQ. 0.0D0) GO TO 20
      R = (DABS(A)/P)**2
      IF (DABS(B).LT.DABS(A)) R = (DABS(B)/P)**2
C     R = (AMIN1(DABS(A),DABS(B))/P)**2
   10 CONTINUE
         T = 4.0D0 + R
         IF (T .EQ. 4.0D0) GO TO 20
         S = R/T
         U = 1.0D0 + 2.0D0*S
         P = U*P
         R = (S/U)**2 * R
      GO TO 10
   20 DPYTHANIO = P
      RETURN
      END

      PROGRAM FGKE03
C
C  Define error file, Fortran unit number, and workstation type,
C  and workstation ID.
C
      PARAMETER (IERRF=6, LUNIT=2, IWKID=1)
C
C  Illustrate creating multiple metafiles in the same job.
C
      CHARACTER*80 FNAME,CDUM
C
C  Open GKS.
C
      CALL GOPKS (IERRF, ISZDM)
C
C  Open and activate a metafile with the name META01.
C
      FNAME = 'META01'
      CALL GESC(-1391,1,FNAME,1,1,CDUM)
      CALL GOPWK (IWKID, LUNIT, 1)
      CALL GACWK (IWKID)
C
C  Draw a single polymarker in the center of the picture.
C
      CALL GPM(1,.5,.5)
      CALL FRAME
C
C  Deactivate and close the META01 metafile.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
C
C  Open and activate META02.
C
      FNAME = 'META02'
      CALL GESC(-1391,1,FNAME,1,1,CDUM)
      CALL GOPWK (IWKID, LUNIT, 1)
      CALL GACWK (IWKID)
C
C  Draw a single polymarker in the upper half of the picture.
C
      CALL GPM(1,.5,.75)
      CALL FRAME
C
C  Deactivate and close the META02 metafile.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
C
C  Close GKS.
C
      CALL GCLKS
C
      STOP
      END

C
C	$Id: tsbyte.f,v 1.4 2008-07-27 00:59:03 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
       SUBROUTINE TSBYTE(MASK0,MSK0DM,MASK1,MSK1DM,ISCR,ISCRDM,
     +                   WRDLNG,INTLNG,IERAND,IERIOR,IERSHF,IOUT,IER)
       DIMENSION MASK0(MSK0DM),MASK1(MSK1DM),ISCR(ISCRDM)
       INTEGER WRDLNG
C
C Determine whether test can be executed.
C
       IER=-1
       WRITE(IOUT,7)
       IF(WRDLNG.LT.4) THEN
          WRITE(IOUT,8)
          RETURN
       END IF
       IF(IERAND.NE.0 .OR. IERIOR.NE.0 .OR. IERSHF.NE.0) THEN
           WRITE(IOUT,9)
           RETURN
       END IF
C
C Start of test proper.
C
       IER=1
C
C Test one : set the I-th bit in ITEST to 1 where I ranges
C            from 1 to WRDLNG.
C
       IONE = 1
       NBITS = 1
       NSKIP = 0
       ITER = 1
       DO 1 I =1,WRDLNG
          IBIT = WRDLNG-I
          ITEST = 0
          CALL SBYTES(ITEST,IONE,IBIT,NBITS,NSKIP,ITER)
          IF ( ITEST.NE.MASK0(I)) THEN
             WRITE(IOUT,101) I
             RETURN
          END IF
 1     CONTINUE
C
C Test two : set the last INTLNG bits of the Ith word of
C            ISCR to MASK0(I) where I ranges from 1 to INTLG.
C
       DO 2 I =1,ISCRDM
 2     ISCR(I) = 0
       IBIT = WRDLNG - INTLNG
       NBITS = INTLNG
       NSKIP = IBIT
       ITER = INTLNG
       CALL SBYTES(ISCR,MASK0,IBIT,NBITS,NSKIP,ITER)
       DO 3 I =1,INTLNG
          IF (ISCR(I).NE.MASK0(I)) THEN
             WRITE(IOUT,102)
             RETURN
             END IF
 3     CONTINUE
C
C Test three : set the 1st two bits of ISCR(I) and the last two bits
C              of ISCR(I+1). Test the setting of bits crossing word
C              boundary.
C
       DO 4 I =1,ISCRDM
 4     ISCR(I) = 0
       DO 5 I = 1,16
          ISCR(17+I) = I-1
 5     CONTINUE
       IBIT = WRDLNG-2
       NBITS = 4
       NSKIP = WRDLNG-4
       ITER = 16
       CALL SBYTES(ISCR,ISCR(18),IBIT,NBITS,NSKIP,ITER)
       NSKP1 = NSKIP + 1
       NSKM2 = 2 - WRDLNG
       DO 6 I = 1,16
          ISET1 = IAND(ISHIFT(ISCR(I+1),NSKM2),3)
          ISET2 = ISHIFT(IAND(ISCR(I),MASK1(3)),2)
          ISET = IOR(ISET1,ISET2)
          IF(ISET.NE.I-1) THEN
             WRITE(IOUT,103)
             RETURN
          END IF
 6     CONTINUE
       IER = 0
       WRITE(IOUT,104)
       RETURN
C
 7     FORMAT('1NOW TESTING SBYTES.')
 8     FORMAT('0ERROR IN TEST PACKAGE DETECTED IN TSBYTE. THE WORD ',
     1        'LENGTH MUST BE AT',/,
     2        ' LEAST 4.')
 9     FORMAT('0THE ROUTINES IAND, IOR, AND ISHIFT, WHICH ARE ',
     1        'REQUIRED TO TEST SBYTES HAVE',/,' NOT BEEN ',
     2        'VERIFIED. BECAUSE OF THIS, SBYTES CAN NOT BE TESTED.')
 101   FORMAT('0SBYTES DID NOT SUCCESSFULLY SET THE ITH BIT OF ',
     1        'ITEST WHEN I WAS EQUAL TO ',I16,'.')
 102   FORMAT('0SBYTES DID NOT SUCCESSFULLY SET THE LAST INTLNG ',
     1        'BITS IN THE ITH WORD ',/,
     2        'OF ISCR EQUAL TO MASK0(I) WHEN I WAS ',
     3        'EQUAL TO ',I16,'.')
 103   FORMAT('0SBYTES DID NOT SUCCESSFULLY SET A BIT CHUNK ',
     1        'OF LENGTH 4 WHICH',/,
     2        ' CROSSED A WORD BOUNDARY.')
 104   FORMAT('0FINISHED TESTING SBYTES.  SBYTES APPARENTLY WORKS.')
       END

C
C $Id: e3fnsp.f,v 1.5 2008-07-27 00:17:08 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      REAL FUNCTION E3FNSP (ECCNTS)
C
C This function computes the constant E3.
C
      IMPLICIT REAL (A-Z)
C
      E3FNSP = ECCNTS*ECCNTS*ECCNTS*(35.E0/3072.E0)
C
      RETURN
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C   FFTPACK 5.0
C   Copyright (C) 1995-2004, Scientific Computing Division,
C   University Corporation for Atmospheric Research
C   Licensed under the GNU General Public License (GPL)
C
C   Authors:  Paul N. Swarztrauber and Richard A. Valent
C
C   $Id: c1f5kf.f,v 1.2 2006-11-21 01:10:15 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      SUBROUTINE DC1F5KF(IDO,L1,NA,CC,IN1,CH,IN2,WA)
      DOUBLE PRECISION TR11
      DOUBLE PRECISION TI11
      DOUBLE PRECISION TR12
      DOUBLE PRECISION TI12
      DOUBLE PRECISION SN
      DOUBLE PRECISION TI5
      DOUBLE PRECISION TI2
      DOUBLE PRECISION TI4
      DOUBLE PRECISION TI3
      DOUBLE PRECISION TR5
      DOUBLE PRECISION TR2
      DOUBLE PRECISION TR4
      DOUBLE PRECISION TR3
      DOUBLE PRECISION CHOLD1
      DOUBLE PRECISION CHOLD2
      DOUBLE PRECISION CR2
      DOUBLE PRECISION CI2
      DOUBLE PRECISION CR3
      DOUBLE PRECISION CI3
      DOUBLE PRECISION CR5
      DOUBLE PRECISION CI5
      DOUBLE PRECISION CR4
      DOUBLE PRECISION CI4
      DOUBLE PRECISION DR3
      DOUBLE PRECISION DR4
      DOUBLE PRECISION DI3
      DOUBLE PRECISION DI4
      DOUBLE PRECISION DR5
      DOUBLE PRECISION DR2
      DOUBLE PRECISION DI5
      DOUBLE PRECISION DI2
      DOUBLE PRECISION CC(IN1,L1,IDO,5),CH(IN2,L1,5,IDO),WA(IDO,4,2)
      DATA TR11,TI11,TR12,TI12/.3090169943749474D0,-.9510565162951536D0,
     +     -.8090169943749474D0,-.5877852522924731D0/
C
C FFTPACK 5.0 auxiliary routine
C
      IF (IDO.GT.1) GO TO 102
      SN = 1.D0/DBLE(5*L1)
      IF (NA.EQ.1) GO TO 106
      DO 101 K = 1,L1
C rav    DO 101 M1=1,M1D,IM1
          TI5 = CC(2,K,1,2) - CC(2,K,1,5)
          TI2 = CC(2,K,1,2) + CC(2,K,1,5)
          TI4 = CC(2,K,1,3) - CC(2,K,1,4)
          TI3 = CC(2,K,1,3) + CC(2,K,1,4)
          TR5 = CC(1,K,1,2) - CC(1,K,1,5)
          TR2 = CC(1,K,1,2) + CC(1,K,1,5)
          TR4 = CC(1,K,1,3) - CC(1,K,1,4)
          TR3 = CC(1,K,1,3) + CC(1,K,1,4)
          CHOLD1 = SN* (CC(1,K,1,1)+TR2+TR3)
          CHOLD2 = SN* (CC(2,K,1,1)+TI2+TI3)
          CR2 = CC(1,K,1,1) + TR11*TR2 + TR12*TR3
          CI2 = CC(2,K,1,1) + TR11*TI2 + TR12*TI3
          CR3 = CC(1,K,1,1) + TR12*TR2 + TR11*TR3
          CI3 = CC(2,K,1,1) + TR12*TI2 + TR11*TI3
          CC(1,K,1,1) = CHOLD1
          CC(2,K,1,1) = CHOLD2
          CR5 = TI11*TR5 + TI12*TR4
          CI5 = TI11*TI5 + TI12*TI4
          CR4 = TI12*TR5 - TI11*TR4
          CI4 = TI12*TI5 - TI11*TI4
          CC(1,K,1,2) = SN* (CR2-CI5)
          CC(1,K,1,5) = SN* (CR2+CI5)
          CC(2,K,1,2) = SN* (CI2+CR5)
          CC(2,K,1,3) = SN* (CI3+CR4)
          CC(1,K,1,3) = SN* (CR3-CI4)
          CC(1,K,1,4) = SN* (CR3+CI4)
          CC(2,K,1,4) = SN* (CI3-CR4)
          CC(2,K,1,5) = SN* (CI2-CR5)
  101 CONTINUE
      RETURN
  106 DO 107 K = 1,L1
          TI5 = CC(2,K,1,2) - CC(2,K,1,5)
          TI2 = CC(2,K,1,2) + CC(2,K,1,5)
          TI4 = CC(2,K,1,3) - CC(2,K,1,4)
          TI3 = CC(2,K,1,3) + CC(2,K,1,4)
          TR5 = CC(1,K,1,2) - CC(1,K,1,5)
          TR2 = CC(1,K,1,2) + CC(1,K,1,5)
          TR4 = CC(1,K,1,3) - CC(1,K,1,4)
          TR3 = CC(1,K,1,3) + CC(1,K,1,4)
          CH(1,K,1,1) = SN* (CC(1,K,1,1)+TR2+TR3)
          CH(2,K,1,1) = SN* (CC(2,K,1,1)+TI2+TI3)
          CR2 = CC(1,K,1,1) + TR11*TR2 + TR12*TR3
          CI2 = CC(2,K,1,1) + TR11*TI2 + TR12*TI3
          CR3 = CC(1,K,1,1) + TR12*TR2 + TR11*TR3
          CI3 = CC(2,K,1,1) + TR12*TI2 + TR11*TI3
          CR5 = TI11*TR5 + TI12*TR4
          CI5 = TI11*TI5 + TI12*TI4
          CR4 = TI12*TR5 - TI11*TR4
          CI4 = TI12*TI5 - TI11*TI4
          CH(1,K,2,1) = SN* (CR2-CI5)
          CH(1,K,5,1) = SN* (CR2+CI5)
          CH(2,K,2,1) = SN* (CI2+CR5)
          CH(2,K,3,1) = SN* (CI3+CR4)
          CH(1,K,3,1) = SN* (CR3-CI4)
          CH(1,K,4,1) = SN* (CR3+CI4)
          CH(2,K,4,1) = SN* (CI3-CR4)
          CH(2,K,5,1) = SN* (CI2-CR5)
  107 CONTINUE
      RETURN
  102 DO 103 K = 1,L1
          TI5 = CC(2,K,1,2) - CC(2,K,1,5)
          TI2 = CC(2,K,1,2) + CC(2,K,1,5)
          TI4 = CC(2,K,1,3) - CC(2,K,1,4)
          TI3 = CC(2,K,1,3) + CC(2,K,1,4)
          TR5 = CC(1,K,1,2) - CC(1,K,1,5)
          TR2 = CC(1,K,1,2) + CC(1,K,1,5)
          TR4 = CC(1,K,1,3) - CC(1,K,1,4)
          TR3 = CC(1,K,1,3) + CC(1,K,1,4)
          CH(1,K,1,1) = CC(1,K,1,1) + TR2 + TR3
          CH(2,K,1,1) = CC(2,K,1,1) + TI2 + TI3
          CR2 = CC(1,K,1,1) + TR11*TR2 + TR12*TR3
          CI2 = CC(2,K,1,1) + TR11*TI2 + TR12*TI3
          CR3 = CC(1,K,1,1) + TR12*TR2 + TR11*TR3
          CI3 = CC(2,K,1,1) + TR12*TI2 + TR11*TI3
          CR5 = TI11*TR5 + TI12*TR4
          CI5 = TI11*TI5 + TI12*TI4
          CR4 = TI12*TR5 - TI11*TR4
          CI4 = TI12*TI5 - TI11*TI4
          CH(1,K,2,1) = CR2 - CI5
          CH(1,K,5,1) = CR2 + CI5
          CH(2,K,2,1) = CI2 + CR5
          CH(2,K,3,1) = CI3 + CR4
          CH(1,K,3,1) = CR3 - CI4
          CH(1,K,4,1) = CR3 + CI4
          CH(2,K,4,1) = CI3 - CR4
          CH(2,K,5,1) = CI2 - CR5
  103 CONTINUE
      DO 105 I = 2,IDO
          DO 104 K = 1,L1
              TI5 = CC(2,K,I,2) - CC(2,K,I,5)
              TI2 = CC(2,K,I,2) + CC(2,K,I,5)
              TI4 = CC(2,K,I,3) - CC(2,K,I,4)
              TI3 = CC(2,K,I,3) + CC(2,K,I,4)
              TR5 = CC(1,K,I,2) - CC(1,K,I,5)
              TR2 = CC(1,K,I,2) + CC(1,K,I,5)
              TR4 = CC(1,K,I,3) - CC(1,K,I,4)
              TR3 = CC(1,K,I,3) + CC(1,K,I,4)
              CH(1,K,1,I) = CC(1,K,I,1) + TR2 + TR3
              CH(2,K,1,I) = CC(2,K,I,1) + TI2 + TI3
              CR2 = CC(1,K,I,1) + TR11*TR2 + TR12*TR3
              CI2 = CC(2,K,I,1) + TR11*TI2 + TR12*TI3
              CR3 = CC(1,K,I,1) + TR12*TR2 + TR11*TR3
              CI3 = CC(2,K,I,1) + TR12*TI2 + TR11*TI3
              CR5 = TI11*TR5 + TI12*TR4
              CI5 = TI11*TI5 + TI12*TI4
              CR4 = TI12*TR5 - TI11*TR4
              CI4 = TI12*TI5 - TI11*TI4
              DR3 = CR3 - CI4
              DR4 = CR3 + CI4
              DI3 = CI3 + CR4
              DI4 = CI3 - CR4
              DR5 = CR2 + CI5
              DR2 = CR2 - CI5
              DI5 = CI2 - CR5
              DI2 = CI2 + CR5
              CH(1,K,2,I) = WA(I,1,1)*DR2 + WA(I,1,2)*DI2
              CH(2,K,2,I) = WA(I,1,1)*DI2 - WA(I,1,2)*DR2
              CH(1,K,3,I) = WA(I,2,1)*DR3 + WA(I,2,2)*DI3
              CH(2,K,3,I) = WA(I,2,1)*DI3 - WA(I,2,2)*DR3
              CH(1,K,4,I) = WA(I,3,1)*DR4 + WA(I,3,2)*DI4
              CH(2,K,4,I) = WA(I,3,1)*DI4 - WA(I,3,2)*DR4
              CH(1,K,5,I) = WA(I,4,1)*DR5 + WA(I,4,2)*DI5
              CH(2,K,5,I) = WA(I,4,1)*DI5 - WA(I,4,2)*DR5
  104     CONTINUE
  105 CONTINUE
      RETURN
      END

      PROGRAM CSEX01
C
C  This example illustrates the effects of using differing numbers
C  of knots in calls to CSA1S with the same input data.
C
C
C  The dimensionality of the problem.
C
      PARAMETER (NDIM=1)
C
C  The number of input data points.
C
      PARAMETER (NDATA=10) 
C
C  The number of output data points.
C
      PARAMETER (NPTS=101) 
C  
C  The maximum number of knots used in any call.
C
      PARAMETER (NCF=9)
C
C  The size of the workspace.
C
      PARAMETER (NWRK=NCF*(NCF+3))
C
C  Dimension arrays.
C
      DIMENSION XDATA(NDIM,NDATA),YDATA(NDATA),XDATAT(NDATA)
      DIMENSION WORK(NWRK)
      DIMENSION XO(NPTS),YO4(NPTS),YO7(NPTS),YO9(NPTS)
C
C  Define the original data.
C
      DATA XDATA(NDIM,1),XDATA(NDIM,2),XDATA(NDIM,3)/ 0.00, 0.1, 0.2 /       
      DATA XDATA(NDIM,4),XDATA(NDIM,5),XDATA(NDIM,6)/ 0.30, 0.5, 0.6 /
      DATA XDATA(NDIM,7),XDATA(NDIM,8),XDATA(NDIM,9)/ 0.65, 0.8, 0.9 /
      DATA XDATA(NDIM,10)                           / 1.00           /
      DATA YDATA/0.0, 0.8, -0.9, -0.9, 0.9, 1.0, 0.90, -0.8, -0.8, 0./
C
C  Create the output X coordinate array.
C 
      XINC = 1./(NPTS-1)
      DO 10 I=1,NPTS
        XO(I) = (I-1)*XINC
   10 CONTINUE
C
C  Calculate the approximated function values using differing 
C  number of knots.
C
      KNOTS = 4
      CALL CSA1S (NDATA,XDATA,YDATA,KNOTS,NPTS,XO,YO4,NWRK,WORK,IER)       
      IF (IER .NE. 0) THEN
        WRITE(6,520) IER
  520   FORMAT(' Error ',I3,' returned from CSA1S')
        STOP
      ENDIF
C
      KNOTS = 7
      CALL CSA1S (NDATA,XDATA,YDATA,KNOTS,NPTS,XO,YO7,NWRK,WORK,IER)       
      IF (IER .NE. 0) THEN
        WRITE(6,520) IER
        STOP
      ENDIF
C
      KNOTS = 9
      CALL CSA1S (NDATA,XDATA,YDATA,KNOTS,NPTS,XO,YO9,NWRK,WORK,IER)       
      IF (IER .NE. 0) THEN
        WRITE(6,520) IER
        STOP
      ENDIF
C
C  Draw a plot of the approximation functions and mark the original points.
C
      DO 34 I=1,NDATA
        XDATAT(I) = XDATA(1,I)
   34 CONTINUE
C
      CALL DRWFT1(NDATA,XDATAT,YDATA,NPTS,XO,YO4,YO7,YO9)
C
      STOP
      END
      SUBROUTINE DRWFT1(NUMO,X,Y,IO,XO,CURVE1,CURVE2,CURVE3)
C
C  This subroutine uses NCAR Graphics to plot three curves on
C  the same picture showing the results from calling CSA1X with
C  differing number of knots.  The values for the curves are
C  contained in arrays CURVE1, CURVE2, and CURVE3.
C
      DIMENSION XO(IO),CURVE1(IO),CURVE2(IO),CURVE3(IO)
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C  Vertical position for initial curve.
C
      DATA YPOS_TOP/0.88/
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C  Define a color table.
C
      CALL GSCR(IWKID, 0, 1.0, 1.0, 1.0)
      CALL GSCR(IWKID, 1, 0.0, 0.0, 0.0)
      CALL GSCR(IWKID, 2, 1.0, 0.0, 0.0)
      CALL GSCR(IWKID, 3, 0.0, 0.0, 1.0)
      CALL GSCLIP(0)
C
C  Plot the main title.
C
      CALL PLCHHQ(0.50,0.95,':F21:Demo for csa1s',0.035,0.,0.)
C
C  Draw a background grid for the first curve.
C
      YB = -1.2
      YT =  1.2
      CALL BKGFT1(YPOS_TOP,'knots = 4',YB,YT)
      CALL GRIDAL(5,5,4,1,1,1,10,0.0,YB)
C
C  Mark the original data points.
C
      CALL GSMKSC(2.2)
      CALL GSPMCI(3)
      CALL GSLWSC(1.)
      CALL GPM(NUMO,X,Y)
C
C  Graph the approximated function values for KNOTS=4.
C
      CALL GSPLCI(1)
      CALL GPL(IO,XO,CURVE1)
C
C  Graph the approximated function values for KNOTS=7.
C
      CALL BKGFT1(YPOS_TOP-0.3,'knots = 7',YB,YT)
      CALL GRIDAL(5,5,4,1,1,1,10,0.0,YB)
      CALL GPM(NUMO,X,Y)
      CALL GPL(IO,XO,CURVE2)
      CALL GSPLCI(1)
C
C  Graph the approximated function values for KNOTS=9.
C
      CALL BKGFT1(YPOS_TOP-0.6,'knots = 9',YB,YT)
      CALL GRIDAL(5,5,4,1,1,1,10,0.0,YB)
      CALL GPM(NUMO,X,Y)
      CALL GPL(IO,XO,CURVE3)
      CALL GSPLCI(1)
      CALL FRAME
C
      CALL GDAWK(IWKID)
      CALL GCLWK(IWKID)
      CALL GCLKS
C
      RETURN
      END
      SUBROUTINE BKGFT1(YPOS,LABEL,YB,YT)
C
C  This subroutine draws a background grid.
C
      DIMENSION XX(2),YY(2)
      CHARACTER*(*) LABEL
C
      CALL SET(0.,1.,0.,1.,0.,1.,0.,1.,1)
C
C  Plot the curve label using font 21 (Helvetica).
C
      CALL PCSETI('FN',21)
      CALL PLCHHQ(0.25,YPOS - 0.03,LABEL,0.025,0.,-1.)
      CALL SET(0.13,0.93,YPOS-0.2,YPOS,0.0,1., YB, YT, 1)
C
C  Draw a horizontal line at Y=0. using color index 2.
C
      XX(1) = 0.
      XX(2) = 1.
      YY(1) = 0.
      YY(2) = 0.
      CALL GSPLCI(2)
      CALL GPL(2,XX,YY)
      CALL GSPLCI(1)
C
C  Set Gridal parameters. 
C
C
C   Set LTY to indicate that the Plotchar routine PLCHHQ should be used.
C
      CALL GASETI('LTY',1)
C
C   Size and format for X axis labels.
C
      CALL GASETR('XLS',0.02)
      CALL GASETC('XLF','(F3.1)')
C
C   Size and format for Y axis labels.
C
      CALL GASETR('YLS',0.02)
      CALL GASETC('YLF','(F5.1)')
C
C   Length of major tick marks for the X and Y axes.
C
      CALL GASETR('XMJ',0.02)
      CALL GASETR('YMJ',0.02)
C
      RETURN
      END

      PROGRAM CTCBAY
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.  Use one
C of the following:
C
C       PARAMETER (IERF=6,LUNI=2,IWTY=1 ,IWID=1)  !  NCGM
C       PARAMETER (IERF=6,LUNI=2,IWTY=8 ,IWID=1)  !  X Windows
C       PARAMETER (IERF=6,LUNI=2,IWTY=20,IWID=1)  !  PostScript
C       PARAMETER (IERF=6,LUNI=2,IWTY=11,IWID=1)  !  PDF, Portrait
C       PARAMETER (IERF=6,LUNI=2,IWTY=12,IWID=1)  !  PDF, Landscape
C
        PARAMETER (IERF=6,LUNI=2,IWTYPE=1,IWTY=IWTYPE,IWID=1)
C
C The object of this program is to produce a set of plots illustrating
C the use of a triangular mesh derived from a grid on the surface of
C the globe provided by Tom Gross.
C
C Up to four frames are drawn at each selected viewpoint:
C
C   1) A frame showing the triangular mesh on the globe.  This frame
C      is drawn only if the parameter IMSH is non-zero.
C
C   2) A frame showing simple contours on the globe.  This frame is
C      drawn only if the parameter ICON is non-zero.
C
C   3) A frame showing color-filled contour bands on the globe, drawn
C      using filled areas.  This frame is drawn only if the parameter
C      ICOL is non-zero.
C
C   4) A frame showing color-filled contour bands on the globe, drawn
C      using a cell array.  This frame is drawn only if the parameter
C      ICAP is non-zero.
C
C Define the parameter that says whether or not the triangular mesh is
C to be drawn (frame 1):
C
C       PARAMETER (IMSH=0)  !  mesh not drawn
C       PARAMETER (IMSH=1)  !  mesh drawn
C
        PARAMETER (IMSH=1)
C
C Define the parameter that says whether or not to draw simple contours
C (frame 2):
C
C       PARAMETER (ICON=0)  !  contours not drawn
C       PARAMETER (ICON=1)  !  contours drawn
C
        PARAMETER (ICON=1)
C
C Define the parameter that says whether or not to draw color-filled
C contours (frame 3):
C
C       PARAMETER (ICOL=0)  !  no color fill done
C       PARAMETER (ICOL=1)  !  color fill done
C
        PARAMETER (ICOL=1)
C
C Define the parameter that says whether or not to draw a cell array
C plot (frame 4):
C
C       PARAMETER (ICAP=0)  !  cell array plot not drawn
C       PARAMETER (ICAP=1)  !  cell array plot drawn
C
        PARAMETER (ICAP=1)
C
C To represent the triangular mesh, we use three singly-dimensioned
C arrays: RPNT holds points, IEDG holds edges, and ITRI holds triangles.
C The elements of each array form "nodes" having lengths as follows:
C
        PARAMETER (LOPN=5)
C
C The five elements of a point node are
C
C   1. the X coordinate of the point;
C   2. the Y coordinate of the point;
C   3. the Z coordinate of the point;
C   4. the field value at the point;
C   5. any additional value desired by the user.
C
        PARAMETER (LOEN=5)
C
C The five elements of an edge node are
C
C   1. the base index, in RPNT, of point 1 of the edge;
C   2. the base index, in RPNT, of point 2 of the edge;
C   3. the index, in ITRI, of the pointer to the edge in the triangle to
C      the left of the edge (-1 if there is no triangle to the left);
C   4. the index, in ITRI, of the pointer to the edge in the triangle to
C      the right of the edge (-1 if there is no triangle to the right);
C   5. a utility flag for use by algorithms that scan the structure.
C
C The "left" and "right" sides of an edge are defined as they would be
C by an observer standing on the globe at point 1 of the edge, looking
C toward point 2 of the edge.  It is possible, if there are "holes" in
C the mesh, that there will be no triangle to the left or to the right
C of an edge, but there must be a triangle on one side or the other.
C
        PARAMETER (LOTN=4)
C
C The four elements of a triangle node are
C
C   1. the base index, in IEDG, of edge 1 of the triangle;
C   2. the base index, in IEDG, of edge 2 of the triangle;
C   3. the base index, in IEDG, of edge 3 of the triangle;
C   4. a flag set non-zero to block use of the triangle, effectively
C      removing it from the mesh.
C
C The "base index" of a point node, an edge node, or a triangle node is
C always a multiple of the length of the node, to which can be added an
C offset to get the index of a particular element of the node.  For
C example, if I is the base index of a triangle of interest, ITRI(I+1)
C is its first element (the base index of its first edge).  Similarly,
C IEDG(ITRI(I+1)+2) is the base index of the second point of the first
C edge of the triangle with base index I, and RPNT(IEDG(ITRI(I+1)+2)+3)
C is the third (Z) coordinate of the second point of the first edge of
C the triangle with base index I.
C
C It is the pointers from the edge nodes back to the triangle nodes that
C allow CONPACKT to navigate the mesh, moving from triangle to triangle
C as it follows a contour line, but these pointers are tricky to define:
C if IPTE is the base index of an edge node and IEDG(IPTE+3) is zero or
C more, saying that there is a triangle to the left of the edge, then
C IEDG(IPTE+3) is the actual index of that element of the triangle node
C that points to the edge node; i.e., ITRI(IEDG(IPTE+3))=IPTE.  The base
C index of the triangle node defining that triangle is IPTT, where
C IPTT=LOTN*((IEDG(IPTE+3)-1)/LOTN), and the index of the pointer to
C the edge within the triangle node is IPTI=IEDG(IPTE+3)-IPTT, so that
C ITRI(IPTT+IPTI)=IPTE.  Similar comments apply to element 4 of an edge
C node, which points into the triangle node defining the triangle to the
C right of the edge.
C
C The numbers of points, edges, and triangles in the triangular mesh are
C approximately as follows (obtained from a run in which the numbers
C were set larger than this):
C
        PARAMETER (MNOP=10000)
        PARAMETER (MNOE=23000)
        PARAMETER (MNOT=16000)
C
C Once we know how many points, edges, and triangles we're going to use
C (at most), we can set parameters defining the space reserved for the
C points, edges, and triangles of the triangular mesh:
C
        PARAMETER (MPNT=MNOP*LOPN)
        PARAMETER (MEDG=MNOE*LOEN)
        PARAMETER (MTRI=MNOT*LOTN)
C
C Declare the arrays to hold the point nodes, edge nodes, and triangle
C nodes defining the triangular mesh.
C
        DIMENSION RPNT(MPNT),IEDG(MEDG),ITRI(MTRI)
C
C Declare sort arrays to be used in GTCBAY to keep track of where points
C and edges were put in the structure defining the triangular mesh.
C
        DIMENSION IPPP(2,MNOP),IPPE(2,MNOE)
C
C Declare real and integer workspaces needed by CONPACKT.
C
        PARAMETER (LRWK=10000,LIWK=1000)
C
        DIMENSION RWRK(LRWK),IWRK(LIWK)
C
C Declare the area map array needed to do solid fill.
C
        PARAMETER (LAMA=400000)
C
        DIMENSION IAMA(LAMA)
C
C Declare workspace arrays to be used in calls to ARSCAM.
C
        PARAMETER (NCRA=LAMA/10,NGPS=2)
C
        DIMENSION XCRA(NCRA),YCRA(NCRA),IAAI(NGPS),IAGI(NGPS)
C
C Declare arrays in which to generate a cell array picture of the
C data on the triangular mesh.
C
C       PARAMETER (ICAM=1024,ICAN=1024)
        PARAMETER (ICAM= 512,ICAN= 512)
C
        DIMENSION ICRA(ICAM,ICAN)
C
C Declare external the routine that draws masked contour lines.
C
        EXTERNAL DRWMCL
C
C Declare external the routine that does color fill of contour bands.
C
        EXTERNAL DCFOCB
C
C Define a common block in which to keep track of the maximum space used
C in the arrays XCRA and YCRA.
C
        COMMON /COMONA/ MAXN
C
C Define the out-of-range flag.
C
        DATA OORV / 1.E12 /
C
C Define the tension on the splines to be used in smoothing contours.
C
C       DATA T2DS / 0.0 /  !  smoothing off
C       DATA T2DS / 2.5 /  !  smoothing on
C
        DATA T2DS / 0.0 /
C
C Define the distance between points on smoothed contour lines.
C
        DATA RSSL / .002 /
C
C Define the amount of real workspace to be used in drawing contours.
C
        DATA IRWC / 500 /
C
C Define the label-positioning flag.
C
C       DATA ILLP / 0 /  !  no labels
C       DATA ILLP / 1 /  !  dash-package writes labels
C       DATA ILLP / 2 /  !  regular scheme
C       DATA ILLP / 3 /  !  penalty scheme
C
        DATA ILLP / 2 /
C
C Define the high/low search radius.
C
        DATA HLSR / .075 /
C
C Define the high/low label overlap flag.
C
        DATA IHLO / 11 /
C
C Define the hachuring flag, hachure length, and hachure spacing.
C
C       DATA IHCF,HCHL,HCHS /  0 , +.004 , .010 /  !  off
C       DATA IHCF,HCHL,HCHS / +1 , -.004 , .020 /  !  on, all, uphill
C
        DATA IHCF,HCHL,HCHS /  0 , +.004 , .010 /
C
C Define a constant to convert from radians to degrees.
C
        DATA RTOD / 57.2957795130823 /
C
C Read data and generate the required triangular mesh.
C
        PRINT * , ' '
        PRINT * , 'CREATING TRIANGULAR MESH:'
C
        CALL GTCBAY (RPNT,MPNT,NPNT,LOPN,
     +               IEDG,MEDG,NEDG,LOEN,
     +               ITRI,MTRI,NTRI,LOTN,
     +               IPPP,IPPE,CLAT,CLON)
C
C Print the number of points, edges, and triangles.
C
        PRINT * , '  NUMBER OF POINTS:    ',NPNT/LOPN
        PRINT * , '  NUMBER OF EDGES:     ',NEDG/LOEN
        PRINT * , '  NUMBER OF TRIANGLES: ',NTRI/LOTN
C
C Write the contents of the point list, the edge list, and the triangle
C list to "fort.11" in a readable form.
C
C       WRITE (11,'(''P'',I8,5F10.4)')
C    +        (I,RPNT(I+1),RPNT(I+2),RPNT(I+3),RPNT(I+4),RPNT(I+5),
C    +                                               I=0,NPNT-LOPN,LOPN)
C       WRITE (11,'(''E'',I8,5I10)')
C    +        (I,IEDG(I+1),IEDG(I+2),IEDG(I+3),IEDG(I+4),IEDG(I+5),
C    +                                               I=0,NEDG-LOEN,LOEN)
C       WRITE (11,'(''T'',I8,4I10)')
C    +        (I,ITRI(I+1),ITRI(I+2),ITRI(I+3),ITRI(I+4),
C    +                                               I=0,NTRI-LOTN,LOTN)
C
C Open GKS.
C
        PRINT * , 'OPENING AND INITIALIZING GKS'
C
        CALL GOPKS (IERF,0)
        CALL GOPWK (IWID,LUNI,IWTY)
        CALL GACWK (IWID)
C
C Turn off the clipping indicator.
C
        CALL GSCLIP (0)
C
C Define a basic set of colors (0 = white, background; 1 = black,
C foreground; 2 = yellow; 3 = magenta; 4 = red; 5 = cyan; 6 = green;
C 7 = blue; 8 = darker light gray; 9 = lighter light gray; 10 = dark
C yellow; 11 = dark gray; 12 = medium gray; 13 = light red, for
C geographic lines; 14 = light blue, for lat/lon lines).
C
        CALL GSCR   (IWID, 0,1.,1.,1.)
        CALL GSCR   (IWID, 1,0.,0.,0.)
        CALL GSCR   (IWID, 2,1.,1.,0.)
        CALL GSCR   (IWID, 3,1.,0.,1.)
        CALL GSCR   (IWID, 4,1.,0.,0.)
        CALL GSCR   (IWID, 5,0.,1.,1.)
        CALL GSCR   (IWID, 6,0.,1.,0.)
        CALL GSCR   (IWID, 7,0.,0.,1.)
        CALL GSCR   (IWID, 8,.5,.5,.5)
        CALL GSCR   (IWID, 9,.8,.8,.8)
        CALL GSCR   (IWID,10,.3,.3,0.)
        CALL GSCR   (IWID,11,.3,.3,.3)
        CALL GSCR   (IWID,12,.5,.5,.5)
        CALL GSCR   (IWID,13,.8,.5,.5)
        CALL GSCR   (IWID,14,.5,.5,.8)
C
C Define 100 colors, associated with color indices 151 through 250, to
C be used for color-filled contour bands and in cell arrays, ranging
C from blue to red.
C
        CALL DFCLRS (IWID,151,250,0.,0.,1.,1.,0.,0.)
C
C Set parameters in the utilities.
C
        PRINT * , 'SETTING PARAMETERS IN CONPACKT, EZMAP, AND PLOTCHAR'
C
C Set the mapping flag.
C
        CALL CTSETI ('MAP - MAPPING FLAG',1)
C
C Set the out-of-range flag value.
C
        CALL CTSETR ('ORV - OUT-OF-RANGE VALUE',OORV)
C
C Turn on the drawing of the mesh edge and set the area identifier for
C areas outside the mesh.
C
        CALL CTSETI ('PAI - PARAMETER ARRAY INDEX',-1)
        CALL CTSETI ('CLU - CONTOUR LEVEL USE FLAG',1)
C       CALL CTSETI ('AIA - AREA IDENTIFIER FOR AREA',1001)
C
C Set the area identifier for areas in "out-of-range" areas.
C
C       CALL CTSETI ('PAI',-2)
C       CALL CTSETI ('AIA - AREA IDENTIFIER FOR AREA',1002)
C
C Set the 2D smoother flag.
C
        CALL CTSETR ('T2D - TENSION ON 2D SPLINES',T2DS)
C
C Set the distance between points on smoothed lines.
C
        CALL CTSETR ('SSL - SMOOTHED SEGMENT LENGTH',RSSL)
C
C Set the amount of real workspace to be used in drawing contours.
C
        CALL CTSETI ('RWC - REAL WORKSPACE FOR CONTOURS',IRWC)
C
C Set the label-positioning flag.
C
        CALL CTSETI ('LLP - LINE LABEL POSITIONING FLAG',ILLP)
C
C Set the high/low search radius.
C
        CALL CTSETR ('HLR - HIGH/LOW SEARCH RADIUS',HLSR)
C
C Set the high/low label overlap flag.
C
        CALL CTSETI ('HLO - HIGH/LOW LABEL OVERLAP FLAG',IHLO)
C
C Set the hachuring flag, hachure length, and hachure spacing.
C
        CALL CTSETI ('HCF - HACHURING FLAG',IHCF)
        CALL CTSETR ('HCL - HACHURE LENGTH',HCHL)
        CALL CTSETR ('HCS - HACHURE SPACING',HCHS)
C
C Set the cell array flag.
C
        CALL CTSETI ('CAF - CELL ARRAY FLAG',-1)
C
C Tell CONPACKT not to do its own call to SET, since EZMAP will have
C done it.
C
        CALL CTSETI ('SET - DO-SET-CALL FLAG', 0)
C
C Move the informational label up a little.
C
        CALL CTSETR ('ILY - INFORMATIONAL LABEL Y POSITION',-.005)
C
C Tell EZMAP not to draw the perimeter.
C
        CALL MPSETI ('PE',0)
C
C Put lat/lon lines at 1-degree intervals.
C
        CALL MPSETI ('GR',1)
C
C Tell EZMAP to use solid lat/lon lines.
C
C       CALL MPSETI ('DA',65535)
C
C Tell PLOTCHAR to use one of the filled fonts and to outline each
C character.
C
        CALL PCSETI ('FN',25)
        CALL PCSETI ('OF',1)
C
C Tell PLOTCHAR to expect a character other than a colon as the
C function-control signal character.
C
        CALL PCSETC ('FC','|')
C
C Loop through the desired viewing angles.
C
        DO 104 IDIR=1,1
C
          PRINT * , ' '
          PRINT * , 'VIEW FROM DIRECTION NUMBER: ',IDIR
C
C Tell EZMAP what projection to use and what its limits are.  (The ".2"
C added to CLAT is a heuristic modification to compensate for the fact
C that the center of the mesh is pulled down a bit due to the way in
C which I compute it.)
C
          IF      (IDIR.EQ.1) THEN
            CALL MAPROJ ('OR',CLAT+.2,CLON,0.)
          END IF
C
          CALL MAPSET ('AN',1.6,1.6,1.6,1.6)
C
C Initialize EZMAP.
C
          CALL MAPINT
C
C If the triangular mesh is to be drawn, do it.
C
          IF (IMSH.NE.0) THEN
C
            PRINT * , 'DRAWING TRIANGULAR MESH'
C
C Triangular mesh (with edges between blocked triangles somewhat fainter
C than the rest):
C
            DO 101 IPTE=0,NEDG-LOEN,LOEN
C
              IFLL=0
C
              IF (IEDG(IPTE+3).GE.0) THEN
                IF (ITRI(LOTN*((IEDG(IPTE+3)-1)/LOTN)+4).EQ.0) IFLL=1
              END IF
C
              IFLR=0
C
              IF (IEDG(IPTE+4).GE.0) THEN
                IF (ITRI(LOTN*((IEDG(IPTE+4)-1)/LOTN)+4).EQ.0) IFLR=1
              END IF
C
              IF (IFLL.NE.0.OR.IFLR.NE.0) THEN
                CALL PLOTIT (0,0,2)
                CALL GSPLCI (8)
              ELSE
                CALL PLOTIT (0,0,2)
                CALL GSPLCI (9)
              END IF
C
              ALAT=RTOD*ASIN(RPNT(IEDG(IPTE+1)+3))
C
              IF (RPNT(IEDG(IPTE+1)+1).EQ.0..AND.
     +            RPNT(IEDG(IPTE+1)+2).EQ.0.) THEN
                ALON=0.
              ELSE
                ALON=RTOD*ATAN2(RPNT(IEDG(IPTE+1)+2),
     +                          RPNT(IEDG(IPTE+1)+1))
              END IF
C
              BLAT=RTOD*ASIN(RPNT(IEDG(IPTE+2)+3))
C
              IF (RPNT(IEDG(IPTE+2)+1).EQ.0..AND.
     +            RPNT(IEDG(IPTE+2)+2).EQ.0.) THEN
                BLON=0.
              ELSE
                BLON=RTOD*ATAN2(RPNT(IEDG(IPTE+2)+2),
     +                          RPNT(IEDG(IPTE+2)+1))
              END IF
C
              CALL DRSGCR (ALAT,ALON,BLAT,BLON)
C
  101       CONTINUE
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (13)
            CALL MAPGRD
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (14)
            CALL MDLNDR ('Earth..1',1)
C
C Label the first frame.
C
            CALL PLCHHQ (CFUX(.03),CFUY(.946),'CHESAPEAKE BAY',
     +                                                      .024,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.904),'FINITE ELEMENT MESH',
     +                                                      .018,0.,-1.)
C
            CALL PLCHHQ (CFUX(.97),CFUY(.950),'TRIANGULAR MESH',
     +                                                       .012,0.,1.)
C
C Advance the frame.
C
            CALL FRAME
C
          END IF
C
C If a frame showing simple contours is to be drawn, do it next (adding
C an overlay of lat/lon lines and continental outlines in light gray).
C
          IF (ICON.NE.0) THEN
C
            PRINT * , 'DRAWING PLOT SHOWING SIMPLE CONTOURS'
C
C Initialize CONPACKT.
C
            PRINT * , 'CALLING CTMESH'
C
            CALL CTMESH (RPNT,NPNT,LOPN,
     +                   IEDG,NEDG,LOEN,
     +                   ITRI,NTRI,LOTN,
     +                   RWRK,LRWK,
     +                   IWRK,LIWK)
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (1)
C
C Proceed as implied by the setting of the label-positioning flag.
C
            IF (ABS(ILLP).EQ.1) THEN
C
C Draw the contour lines with labels generated by the dash package.
C
              PRINT * , 'CALLING CTCLDR'
              CALL CTCLDR (RPNT,IEDG,ITRI,RWRK,IWRK)
C
C Add the informational and high/low labels.
C
              PRINT * , 'CALLING CTLBDR'
              CALL CTLBDR (RPNT,IEDG,ITRI,RWRK,IWRK)
C
            ELSE IF (ABS(ILLP).GT.1) THEN
C
C Create an area map for masking of labels.
C
              MAXN=0
C
              PRINT * , 'CALLING ARINAM'
              CALL ARINAM (IAMA,LAMA)
C
              PRINT * , 'CALLING CTLBAM'
              CALL CTLBAM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA)
C
C Draw the contour lines masked by the area map.
C
              PRINT * , 'CALLING CTCLDM'
              CALL CTCLDM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA,DRWMCL)
C
              PRINT * , 'AREA MAP SPACE REQUIRED:         ',
     +                                         IAMA(1)-IAMA(6)+IAMA(5)+1
C
              PRINT * , 'NUMBER OF POINTS IN LONGEST LINE:',MAXN
C
C Draw all the labels.
C
              PRINT * , 'CALLING CTLBDR'
              CALL CTLBDR (RPNT,IEDG,ITRI,RWRK,IWRK)
C
            END IF
C
            CALL CTGETI ('IWU - INTEGER WORKSPACE USED',IIWU)
            PRINT * , 'INTEGER WORKSPACE REQUIRED:      ',IIWU
C
            CALL CTGETI ('RWU -    REAL WORKSPACE USED',IRWU)
            PRINT * , 'REAL WORKSPACE REQUIRED:         ',IRWU
C
C Add lat/lon lines and continental outlines.
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (13)
            CALL MAPGRD
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (14)
            CALL MDLNDR ('Earth..1',1)
C
C Label the second frame.
C
            CALL PLCHHQ (CFUX(.03),CFUY(.946),'CHESAPEAKE BAY',
     +                                                      .024,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.904),'FINITE ELEMENT MESH',
     +                                                      .018,0.,-1.)
C
            CALL PLCHHQ (CFUX(.97),CFUY(.950),'SIMPLE CONTOURS ON',
     +                                                       .012,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.926),'TRIANGULAR MESH',
     +                                                       .012,0.,1.)
C
            CALL PLCHHQ (CFUX(.97),CFUY(.904),'Data: temperatures at',
     +                                                       .010,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.884),'time 1, level 1.',
     +                                                       .010,0.,1.)
C
C Advance the frame.
C
            CALL FRAME
C
          END IF
C
C If a frame showing color-filled contours is to be drawn, do it next.
C
          IF (ICOL.NE.0) THEN
C
            PRINT * , 'DRAWING PLOT SHOWING COLOR-FILLED CONTOURS'
C
            PRINT * , 'CALLING CTMESH'
C
            CALL CTMESH (RPNT,NPNT,LOPN,
     +                   IEDG,NEDG,LOEN,
     +                   ITRI,NTRI,LOTN,
     +                   RWRK,LRWK,
     +                   IWRK,LIWK)
C
            MAXN=0
C
            PRINT * , 'CALLING CTPKCL'
            CALL CTPKCL (RPNT,IEDG,ITRI,RWRK,IWRK)
C
            PRINT * , 'CALLING ARINAM'
            CALL ARINAM (IAMA,LAMA)
C
            PRINT * , 'CALLING CTCLAM'
            CALL CTCLAM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA)
C
C           PRINT * , 'CALLING CTLBAM'
C           CALL CTLBAM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA)
C
            PRINT * , 'CALLING ARSCAM'
            CALL ARSCAM (IAMA,XCRA,YCRA,NCRA,IAAI,IAGI,NGPS,DCFOCB)
C
            PRINT * , 'SPACE REQUIRED IN AREA MAP:      ',
     +                                         IAMA(1)-IAMA(6)+IAMA(5)+1
C
            PRINT * , 'NUMBER OF POINTS IN LARGEST AREA:',MAXN
C
            CALL CTGETI ('IWU - INTEGER WORKSPACE USED',IIWU)
            PRINT * , 'INTEGER WORKSPACE REQUIRED:      ',IIWU
C
            CALL CTGETI ('RWU -    REAL WORKSPACE USED',IRWU)
            PRINT * , 'REAL WORKSPACE REQUIRED:         ',IRWU
C
            CALL GSFACI (1)
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (13)
            CALL MAPGRD
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (14)
            CALL MDLNDR ('Earth..1',1)
C
C Label the third frame.
C
            CALL PLCHHQ (CFUX(.03),CFUY(.946),'CHESAPEAKE BAY',
     +                                                      .024,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.904),'FINITE ELEMENT MESH',
     +                                                      .018,0.,-1.)
C
            CALL PLCHHQ (CFUX(.97),CFUY(.950),'COLORED CONTOUR BANDS ON'
     +,.012,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.926),'TRIANGULAR MESH',
     +                                                       .012,0.,1.)
C
            CALL PLCHHQ (CFUX(.97),CFUY(.904),'Data: temperatures at',
     +                                                       .010,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.884),'time 1, level 1.',
     +                                                       .010,0.,1.)
C
C Advance the frame.
C
            CALL FRAME
C
          END IF
C
C If the flag for it is set, do a cell array plot.
C
          IF (ICAP.NE.0) THEN
C
            PRINT * , 'DRAWING CELL-ARRAY PLOT OF DATA VALUES'
C
            PRINT * , 'CALLING CTMESH'
C
            CALL CTMESH (RPNT,NPNT,LOPN,
     +                   IEDG,NEDG,LOEN,
     +                   ITRI,NTRI,LOTN,
     +                   RWRK,LRWK,
     +                   IWRK,LIWK)
C
            CALL GETSET (XVPL,XVPR,YVPB,YVPT,XWDL,XWDR,YWDB,YWDT,LNLG)
C
            PRINT * , 'CALLING CTCICA'
            CALL CTCICA (RPNT,IEDG,ITRI,RWRK,IWRK,ICRA,ICAM,ICAM,ICAN,
     +                                            XVPL,YVPB,XVPR,YVPT)
C
            PRINT * , 'CALLING GCA'
            CALL GCA (XWDL,YWDB,XWDR,YWDT,ICAM,ICAN,1,1,ICAM,ICAN,ICRA)
C
            CALL CTGETI ('IWU - INTEGER WORKSPACE USED',IIWU)
            PRINT * , 'INTEGER WORKSPACE REQUIRED:      ',IIWU
C
            CALL CTGETI ('RWU -    REAL WORKSPACE USED',IRWU)
            PRINT * , 'REAL WORKSPACE REQUIRED:         ',IRWU
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (13)
            CALL MAPGRD
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (14)
            CALL MDLNDR ('Earth..1',1)
C
C Label the fourth frame.
C
            CALL PLCHHQ (CFUX(.03),CFUY(.946),'CHESAPEAKE BAY',
     +                                                      .024,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.904),'FINITE ELEMENT MESH',
     +                                                      .018,0.,-1.)
C
            CALL PLCHHQ (CFUX(.97),CFUY(.950),'CELL ARRAY DERIVED FROM',
     +.012,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.926),'TRIANGULAR MESH',
     +                                                       .012,0.,1.)
C
            CALL PLCHHQ (CFUX(.97),CFUY(.904),'Data: temperatures at',
     +                                                       .010,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.884),'time 1, level 1.',
     +                                                       .010,0.,1.)
C
C Advance the frame.
C
            CALL FRAME
C
          END IF
C
  104   CONTINUE
C
C Close GKS.
C
        CALL GDAWK (IWID)
        CALL GCLWK (IWID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END


      SUBROUTINE DFCLRS (IWID,IOFC,IOLC,REDF,GRNF,BLUF,REDL,GRNL,BLUL)
C
C This routine defines color indices IOFC through IOLC on workstation
C IWID by interpolating values from REDF/GRNF/BLUF to REDL/GRNL/BLUL.
C
        DO 101 I=IOFC,IOLC
          P=REAL(IOLC-I)/REAL(IOLC-IOFC)
          Q=REAL(I-IOFC)/REAL(IOLC-IOFC)
          CALL GSCR (IWID,I,P*REDF+Q*REDL,P*GRNF+Q*GRNL,P*BLUF+Q*BLUL)
  101   CONTINUE
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE DRWMCL (XCRA,YCRA,NCRA,IAAI,IAGI,NGPS)
C
        DIMENSION XCRA(*),YCRA(*),IAAI(*),IAGI(*)
C
C This routine draws the curve defined by the points (XCRA(I),YCRA(I)),
C for I = 1 to NCRA, if and only if none of the area identifiers for the
C area containing the polyline are negative.  It calls either CURVE or
C CURVED to do the drawing, depending on the value of the internal
C parameter 'DPU'.
C
C It keeps track of the maximum value used for NCRA in a common block.
C
        COMMON /COMONA/ MAXN
C
        MAXN=MAX(MAXN,NCRA)
C
C Retrieve the value of the internal parameter 'DPU'.
C
        CALL CTGETI ('DPU - DASH PACKAGE USED',IDUF)
C
C Turn on drawing.
C
        IDRW=1
C
C If any area identifier is negative, turn off drawing.
C
        DO 101 I=1,NGPS
          IF (IAAI(I).LT.0) IDRW=0
  101   CONTINUE
C
C If drawing is turned on, draw the polyline.
C
        IF (IDRW.NE.0) THEN
          IF (IDUF.EQ.0) THEN
            CALL CURVE  (XCRA,YCRA,NCRA)
          ELSE IF (IDUF.LT.0) THEN
            CALL DPCURV (XCRA,YCRA,NCRA)
          ELSE
            CALL CURVED (XCRA,YCRA,NCRA)
          END IF
        END IF
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE DCFOCB (XCRA,YCRA,NCRA,IAAI,IAGI,NGPS)
C
C This routine fills the area defined by the points (XCRA(I),YCRA(I)),
C for I = 1 to NCRA, if and only if none of the area identifiers for
C the area are negative.  The color used is determined from the area
C identifier of the area relative to group 3; it is assumed that 100
C colors are defined having color indices 151 through 250.
C
        DIMENSION XCRA(*),YCRA(*),IAAI(*),IAGI(*)
C
C It keeps track of the maximum value used for NCRA in a common block.
C
        COMMON /COMONA/ MAXN
C
        MAXN=MAX(MAXN,NCRA)
C
C Retrieve the number of contour levels being used.
C
        CALL CTGETI ('NCL - NUMBER OF CONTOUR LEVELS',NOCL)
C
C If the number of contour levels is non-zero and the area has more
C than two points, fill it.
C
        IF (NOCL.NE.0.AND.NCRA.GT.2) THEN
C
          IAI3=-1
C
          DO 101 I=1,NGPS
            IF (IAGI(I).EQ.3) IAI3=IAAI(I)
  101     CONTINUE
C
          IF (IAI3.GE.1.AND.IAI3.LE.NOCL+1) THEN
            CALL GSFACI (151+INT(((REAL(IAI3)-.5)/REAL(NOCL+1))*100.))
            CALL GFA    (NCRA,XCRA,YCRA)
          ELSE IF (IAI3.EQ.1001) THEN
            CALL GSFACI (2)
            CALL GFA    (NCRA,XCRA,YCRA)
          ELSE IF (IAI3.EQ.1002) THEN
            CALL GSFACI (3)
            CALL GFA    (NCRA,XCRA,YCRA)
          END IF
C
        END IF
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE GTCBAY (RPNT,MPNT,NPNT,LOPN,
     +                   IEDG,MEDG,NEDG,LOEN,
     +                   ITRI,MTRI,NTRI,LOTN,
     +                   IPPP,IPPE,CLAT,CLON)
C
        DIMENSION RPNT(MPNT),IEDG(MEDG),ITRI(MTRI),IPPP(2,*),IPPE(2,*)
C
C Construct a triangular mesh using data from Tom Gross, using a routine
C (CTTMTL) that makes it easy to create an arbitrary triangular mesh.
C The "tree-sorts" used by this method are very inefficient for objects
C that are partially ordered, so, as the triangles of the mesh are
C generated, they are stored in a triangle buffer from which they can
C be dumped in random order by calls to the routine CTTMTL.
C
C Declare the array to use as the buffer for the triangles, so that the
C order in which they are processed can be somewhat randomized.  Up to
C a point, making this buffer larger will result in more randomization
C of the triangles and speed up the process.  MBUF is the number of
C triangles that will fit in the buffer at once, and KBUF is the number
C of those that are dumped whenever the buffer is found to be full; it
C turns out that it's better to dump more than 1 at a time (I suppose
C because the call and loop set-up time for CTTMTL are non-trivial, so
C it's better to dump a few triangles while you're there).  So ... use
C MBUF > KBUF > 1.
C
        PARAMETER (MBUF=5021,KBUF=173,DTOR=.017453292519943)
C
        DIMENSION TBUF(12,MBUF)
C
C Include definitions that "NetCDF" needs (now commented out, because
C the data are being read from an ASCII file, instead).
C
C       include 'netcdf.inc'
C
C Declare arrays to receive lat/lon coordinate data, contour field data,
C and triangle vertex indices from Tom's NetCDF data file.
C
C       DIMENSION TLAT(7258),TLON(7258),TDAT(7258,11,25),IELE(3,13044)
C
C Declare arrays to receive lat/lon coordinate data, contour field data,
C and triangle vertex indices from the ASCII file made from Tom's data.
C
        DIMENSION TLAT(7258),TLON(7258),TDAT(7258      ),IELE(3,13044)
C
C The data for this example were originally read from a user's "NetCDF"
C file.  The code used for the purpose follows, but has been commented
C out, as the data are now read from an ASCII file.  This gets around
C certain procedural problems in running the example from "ncargex".
C
C Open the "NetCDF" file.
C
C       ISTA=NF_OPEN('ctcbay.nc',0,NCID)
C
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'ERROR RETURN FROM NF_OPEN: ',ISTA
C         STOP
C       END IF
C
C Read the array of latitudes of point nodes.
C
C       ISTA=NF_INQ_VARID(NCID,'lat',IVID)
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'ERROR RETURN FROM NF_INQ_VARID: ',ISTA
C         STOP
C       END IF
C       ISTA=NF_GET_VAR_REAL(NCID,IVID,TLAT)
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'ERROR RETURN FROM NF_GET_VAR_REAL: ',ISTA
C         STOP
C       END IF
C
C Read the array of longitudes of point nodes.
C
C       ISTA=NF_INQ_VARID(NCID,'lon',IVID)
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'ERROR RETURN FROM NF_INQ_VARID: ',ISTA
C         STOP
C       END IF
C       ISTA=NF_GET_VAR_REAL(NCID,IVID,TLON)
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'ERROR RETURN FROM NF_GET_VAR_REAL: ',ISTA
C         STOP
C       END IF
C
C Read an array of data at the point nodes.
C
C       ISTA=NF_INQ_VARID(NCID,'temp',IVID)
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'ERROR RETURN FROM NF_INQ_VARID: ',ISTA
C         STOP
C       END IF
C       ISTA=NF_GET_VAR_REAL(NCID,IVID,TDAT)
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'ERROR RETURN FROM NF_GET_VAR_REAL: ',ISTA
C         STOP
C       END IF
C
C Read the array of pointers to point triplets.
C
C       ISTA=NF_INQ_VARID(NCID,'ele',IVID)
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'ERROR RETURN FROM NF_INQ_VARID: ',ISTA
C         STOP
C       END IF
C       ISTA=NF_GET_VAR_INT(NCID,IVID,IELE)
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'ERROR RETURN FROM NF_GET_VAR_INT: ',ISTA
C         STOP
C       END IF
C
C Close the "NetCDF" file.
C
C       ISTA=NF_CLOSE(NCID)
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'ERROR RETURN FROM NF_CLOSE: ',ISTA
C         STOP
C       END IF
C
C Write the data to unit 11.  (These statements are commented out; they
C were used to create a "fort.11" which was then renamed "ctcbay.dat".)
C
C       WRITE (11,'(5E16.8)') TLAT
C       WRITE (11,'(5E16.8)') TLON
C       WRITE (11,'(5E16.8)') (TDAT(I,1,1),I=1,7258)
C       WRITE (11,  '(20I4)') IELE
C
C Read the required data from the ASCII file "ctcbay.dat".
C
        OPEN (11,FILE='ctcbay.dat',STATUS='OLD',FORM='FORMATTED')
C
        READ (11,'(5E16.8)') TLAT
        READ (11,'(5E16.8)') TLON
        READ (11,'(5E16.8)') TDAT
        READ (11,  '(20I4)') IELE
C
        CLOSE (11)
C
C Build structures forming the triangular mesh.  First, initialize the
C variables used to keep track of items in the sort arrays for points
C and edges, in the triangle buffer, and in the triangle list.
C
        MPPP=MPNT/LOPN
        NPPP=0
C
        MPPE=MEDG/LOEN
        NPPE=0
C
        NBUF=0
C
        NTRI=0
C
C Loop through the triangles derived from Tom's grid.
C
        DO 101 I=1,13044
C
C If the triangle buffer is almost full, dump a few randomly-chosen
C triangles from it to make room for two new ones.
C
          IF (NBUF.GE.MBUF) THEN
            CALL CTTMTL (KBUF,TBUF,MBUF,NBUF,
     +                   IPPP,MPPP,NPPP,
     +                   IPPE,MPPE,NPPE,
     +                   RPNT,MPNT,NPNT,LOPN,
     +                   IEDG,MEDG,NEDG,LOEN,
     +                   ITRI,MTRI,NTRI,LOTN)
          END IF
C
C Put a new triangle in the triangle buffer.
C
          NBUF=NBUF+1
C
          TBUF( 1,NBUF)=COS(DTOR*TLAT(IELE(1,I)))*
     +                  COS(DTOR*TLON(IELE(1,I)))
          TBUF( 2,NBUF)=COS(DTOR*TLAT(IELE(1,I)))*
     +                  SIN(DTOR*TLON(IELE(1,I)))
          TBUF( 3,NBUF)=SIN(DTOR*TLAT(IELE(1,I)))
C         TBUF( 4,NBUF)=TDAT(IELE(1,I),1,1)
          TBUF( 4,NBUF)=TDAT(IELE(1,I)    )
C
          TBUF( 5,NBUF)=COS(DTOR*TLAT(IELE(2,I)))*
     +                  COS(DTOR*TLON(IELE(2,I)))
          TBUF( 6,NBUF)=COS(DTOR*TLAT(IELE(2,I)))*
     +                  SIN(DTOR*TLON(IELE(2,I)))
          TBUF( 7,NBUF)=SIN(DTOR*TLAT(IELE(2,I)))
C         TBUF( 8,NBUF)=TDAT(IELE(2,I),1,1)
          TBUF( 8,NBUF)=TDAT(IELE(2,I)    )
C
          TBUF( 9,NBUF)=COS(DTOR*TLAT(IELE(3,I)))*
     +                  COS(DTOR*TLON(IELE(3,I)))
          TBUF(10,NBUF)=COS(DTOR*TLAT(IELE(3,I)))*
     +                  SIN(DTOR*TLON(IELE(3,I)))
          TBUF(11,NBUF)=SIN(DTOR*TLAT(IELE(3,I)))
C         TBUF(12,NBUF)=TDAT(IELE(3,I),1,1)
          TBUF(12,NBUF)=TDAT(IELE(3,I)    )
C
  101   CONTINUE
C
C Output all triangles remaining in the buffer.
C
        IF (NBUF.NE.0) THEN
          CALL CTTMTL (NBUF,TBUF,MBUF,NBUF,
     +                 IPPP,MPPP,NPPP,
     +                 IPPE,MPPE,NPPE,
     +                 RPNT,MPNT,NPNT,LOPN,
     +                 IEDG,MEDG,NEDG,LOEN,
     +                 ITRI,MTRI,NTRI,LOTN)
        END IF
C
C Set values telling the caller how many points and edges were created.
C
        NPNT=NPPP*LOPN
        NEDG=NPPE*LOEN
C
C Compute average X, Y, and Z values, from which we can get the
C approximate center point of the mesh.
C
        XSUM=0.
        YSUM=0.
        ZSUM=0.
C
        DO 102 I=0,NPNT-LOPN,LOPN
          XSUM=XSUM+RPNT(I+1)
          YSUM=YSUM+RPNT(I+2)
          ZSUM=ZSUM+RPNT(I+3)
  102   CONTINUE
C
        XAVG=XSUM/REAL(NPPP)
        YAVG=YSUM/REAL(NPPP)
        ZAVG=ZSUM/REAL(NPPP)
C
        DNOM=SQRT(XAVG*XAVG+YAVG*YAVG+ZAVG*ZAVG)
C
        XAVG=XAVG/DNOM
        YAVG=YAVG/DNOM
        ZAVG=ZAVG/DNOM
C
C Return the latitude and longitude of the approximate center point of
C the mesh on the globe.
C
        CLAT=ASIN(ZAVG)/DTOR
        CLON=ATAN2(YAVG,XAVG)/DTOR
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE DRSGCR (ALAT,ALON,BLAT,BLON)
C
C (DRSGCR = DRaw Shortest Great Circle Route)
C
C This routine draws the shortest great circle route joining two points
C on the globe.  Note that MPTS = INT(180./SIZE) + 1.
C
        PARAMETER (MPTS=181,SIZE=1.)
C
        DIMENSION QLAT(MPTS),QLON(MPTS)
C
        NPTS=MAX(1,MIN(MPTS,INT(ADSGCR(ALAT,ALON,BLAT,BLON)/SIZE)))
C
        CALL MAPGCI (ALAT,ALON,BLAT,BLON,NPTS,QLAT,QLON)
C
        CALL MAPIT (ALAT,ALON,0)
C
        DO 101 I=1,NPTS
          CALL MAPIT (QLAT(I),QLON(I),1)
  101   CONTINUE
C
        CALL MAPIT (BLAT,BLON,2)
C
        CALL MAPIQ
C
        RETURN
C
      END


      FUNCTION ADSGCR (ALAT,ALON,BLAT,BLON)
C
C (ADSGCR = Angle in Degrees along Shortest Great Circle Route)
C
C This function returns the shortest great circle distance, in degrees,
C between two points, A and B, on the surface of the globe.
C
        DATA DTOR / .017453292519943 /
        DATA RTOD / 57.2957795130823 /
C
        XCOA=COS(DTOR*ALAT)*COS(DTOR*ALON)
        YCOA=COS(DTOR*ALAT)*SIN(DTOR*ALON)
        ZCOA=SIN(DTOR*ALAT)
C
        XCOB=COS(DTOR*BLAT)*COS(DTOR*BLON)
        YCOB=COS(DTOR*BLAT)*SIN(DTOR*BLON)
        ZCOB=SIN(DTOR*BLAT)
C
        ADSGCR=2.*RTOD*ASIN(SQRT((XCOA-XCOB)**2+
     +                           (YCOA-YCOB)**2+
     +                           (ZCOA-ZCOB)**2)/2.)
C
        RETURN
C
      END


      SUBROUTINE CTSCAE (ICRA,ICA1,ICAM,ICAN,XCPF,YCPF,XCQF,YCQF,
     +                                       IND1,IND2,ICAF,IAID)
        DIMENSION ICRA(ICA1,*)
C
C This routine is called by CTCICA when the internal parameter 'CAF' is
C given a negative value.  Each call is intended to create a particular
C element in the user's cell array.  The arguments are as follows:
C
C ICRA is the user's cell array.
C
C ICA1 is the first dimension of the FORTRAN array ICRA.
C
C ICAM and ICAN are the first and second dimensions of the cell array
C stored in ICRA.
C
C (XCPF,YCPF) is the point at that corner of the rectangular area
C into which the cell array maps that corresponds to the cell (1,1).
C The coordinates are given in the fractional coordinate system (unlike
C what is required in a call to GCA, in which the coordinates of the
C point P are in the world coordinate system).
C
C (XCQF,YCQF) is the point at that corner of the rectangular area into
C which the cell array maps that corresponds to the cell (ICAM,ICAN).
C The coordinates are given in the fractional coordinate system (unlike
C what is required in a call to GCA, in which the coordinates of the
C point Q are in the world coordinate system).
C
C IND1 is the 1st index of the cell that is to be updated.
C
C IND2 is the 2nd index of the cell that is to be updated.
C
C ICAF is the current value of the internal parameter 'CAF'.  This
C value will always be an integer which is less than zero (because
C when 'CAF' is zero or greater, this routine is not called).
C
C IAID is the area identifier associated with the cell.  It will have
C been given one of the values from the internal parameter array 'AIA'
C (the one for 'PAI' = -2 if the cell lies in an out-of-range area, the
C one for 'PAI' = -1 if the cell lies off the data grid, or the one for
C some value of 'PAI' between 1 and 'NCL' if the cell lies on the data
C grid).  The value zero may occur if the cell falls in an out-of-range
C area and the value of 'AIA' for 'PAI' = -2 is 0 or if the cell lies
C off the data grid and the value of 'AIA' for 'PAI' = -1 is 0, or if
C the cell falls on the data grid, but no contour level below the cell
C has a non-zero 'AIA' and no contour level above the cell has a
C non-zero 'AIB'.  Note that, if the values of 'AIA' for 'PAI' = -1
C and -2 are given non-zero values, IAID can only be given a zero
C value in one way.
C
C The default behavior of CTSCAE is as follows:  If the area identifier
C is non-negative, it is treated as a color index, to be stored in the
C appropriate cell in the cell array; but if the area identifier is
C negative, a zero is stored for the color index.  The user may supply
C a version of CTSCAE that does something different; it may simply map
C the area identifiers into color indices or it may somehow modify the
C existing cell array element to incorporate the information provided
C by the area identifier.
C
C       ICRA(IND1,IND2)=MAX(0,IAID)
C
C What follows is not the default behavior; instead, it is the behavior
C expected by many of the example programs for CONPACKT.
C
        CALL CTGETI ('NCL - NUMBER OF CONTOUR LEVELS',NOCL)
C
        IF (IAID.GE.1.AND.IAID.LE.NOCL+1) THEN
          ICRA(IND1,IND2)=151+INT(((REAL(IAID)-.5)/REAL(NOCL+1))*100.)
        ELSE IF (IAID.EQ.1001) THEN
          ICRA(IND1,IND2)=2
        ELSE IF (IAID.EQ.1002) THEN
          ICRA(IND1,IND2)=3
        END IF
C
        RETURN
C
      END

C
C $Id: pcpnwi.f,v 1.7 2008-07-27 00:17:20 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      CHARACTER*16 FUNCTION PCPNWI (WHCH,IPAI)
C
      CHARACTER*(*) WHCH
      CHARACTER*16   CTMP
C
C Given the name (WHCH) of an internal parameter that is really an array
C and the integer value (IPAI) of the desired parameter array index, the
C value of PCPNWI (WHCH,IPAI) is the internal parameter name including
C the index, in the form expected by the routines PCGETR and PCSETR (in
C parentheses following the two-character internal parameter name).
C
      IF (LEN(WHCH).LT.2) THEN
        CALL SETER ('PCPNWI - PARAMETER NAME TOO SHORT',1,1)
        RETURN
      ELSE
        WRITE (CTMP,'(I16)') IPAI
        IBEG=0
        DO 101 I=1,16
          IF (CTMP(I:I).NE.' ') THEN
            IF (IBEG.EQ.0) IBEG=I
            IF (IBEG.NE.0) IEND=I
          END IF
  101   CONTINUE
        IF (IBEG.EQ.0) THEN
          CALL SETER ('PCPNWI - INTERNAL ERROR - SEE CONSULTANT',2,1)
          RETURN
        ELSE
          PCPNWI=WHCH(1:2)//'('//CTMP(IBEG:IEND)//')'//'            '
        END IF
      END IF
C
C Done.
C
      RETURN
C
      END

C
C	$Id: gzputs.f,v 1.5 2008-07-27 00:21:04 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GZPUTS(ST,IER)
C
C  This subroutine fills the string character variable of the 
C  workstation interface common block and invokes the workstation
C  interface subroutine (N is the length of string ST).
C  If an error is returned from the workstation interface,
C  IER is set to that error number and a return is executed.
C
C
      include 'gkscom.h'
C
      CHARACTER*(*) ST
      N = LEN(ST)
      J = (N-1)/80
      STRL1 = N
      IF (J .EQ. 0) THEN
C
C  Case where there is no continuation.
C
        CONT = 0
        STRL2 = N
        STR(1:N) = ST(1:N)
        CALL GZTOWK
        IF (RERR .NE. 0) THEN
          IER = RERR
          RETURN
        ENDIF
      ELSE
C
C  Case with contination.
C
        CONT = 1
        STRL2 = 80
C
C  Loop through parts with continuation flag set.
C
        DO 200 K=1,J
          KPNT = (K-1)*80
          STR(1:80) = ST(KPNT+1:KPNT+80+1)
          IF (K .GT. 1) THEN
            IL2 = 0
            RL2 = 0
            IC2 = 0
          ENDIF
          CALL GZTOWK
          IF (RERR .NE. 0) THEN
            IER = RERR
            RETURN
          ENDIF
  200   CONTINUE
C
C  Put out last part of string with continuation flag set to last.
C
        CONT = 0
        STRL2 = N-J*80
        KPNT = J*80
        STR(1:STRL2) = ST(KPNT+1:KPNT+STRL2+1)
        CALL GZTOWK
      ENDIF
C
      RETURN
      END

C
C	$Id: gqchup.f,v 1.5 2008-07-27 00:20:58 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GQCHUP(ERRIND,CHUX,CHUY)
C
C  INQUIRE CHARACTER UP VECTOR
C
      include 'gkscom.h'
C
      INTEGER ERRIND
      REAL    CHUX,CHUY
C
C  Check if GKS is in the proper state.
C
      CALL GZCKST(8,-1,ERRIND)
      IF (ERRIND .EQ. 0) THEN
        CHUX = CCHUP(1)
        CHUY = CCHUP(2)
      ELSE
        CHUX = 0.
        CHUY = 0.
      ENDIF
C
      RETURN
      END

C
C $Id: mdrdcs.f,v 1.2 2008-07-27 00:17:07 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MDRDCS (IFDE,CHRS,LCHR,MCHR,NCHR,CVAR)
C
        INTEGER       IFDE
        CHARACTER*1   CHRS(LCHR)
        INTEGER       LCHR,MCHR,NCHR
        CHARACTER*(*) CVAR
C
C Given the file descriptor of an open file in IFDE and a character
C buffer CHRS, of length LCHR, having in it MCHR characters read from
C the file, of which NCHR have previously been processed, this routine
C returns the next LEN(CVAR) characters in the character variable CVAR.
C
C Declare local variables.
C
        INTEGER       IICV,ISTA,LOCV
C
C Find the length of the character variable.
C
        LOCV=LEN(CVAR)
C
C Define an index into the character variable.
C
        IICV=0
C
C Transfer LOCV characters to the character variable.
C
  101   NCHR=NCHR+1
C
        IF (NCHR.GT.MCHR) THEN
          CALL NGRDCH (IFDE,CHRS,LCHR,ISTA)
          IF (ISTA.LE.0) THEN
            MCHR=0
            RETURN
          ELSE
            MCHR=ISTA
            NCHR=1
          END IF
        END IF
C
        IICV=IICV+1
        CVAR(IICV:IICV)=CHRS(NCHR)
        IF (IICV.EQ.LOCV) RETURN
C
        GO TO 101
C
      END

C
C $Id: icloem.f,v 1.5 2008-07-27 00:17:30 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      FUNCTION ICLOEM (MESSG)
C
        CHARACTER*(*) MESSG
C
C ICLOEM(MESSG) is the index of the last non-blank character in MESSG.
C
        DO 101 I=LEN(MESSG),1,-1
         IF (MESSG(I:I).NE.' ') THEN
           ICLOEM=I
           RETURN
         END IF
  101   CONTINUE
C
        ICLOEM=1
C
        RETURN
C
      END

C
C $Id: mdpin1.f,v 1.12 2008-09-18 12:19:11 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MDPIN1
C
C Declare required common blocks.  See MAPBDX for descriptions of these
C common blocks and the variables in them.
C
        COMMON /MAPCM0/  COS1,DTOR,DTRH,OOPI,PI,PIOF,PIOT,RTDD,RTOD,
     +                   SROT,SIN1,TOPI,TSRT
        DOUBLE PRECISION COS1,DTOR,DTRH,OOPI,PI,PIOF,PIOT,RTDD,RTOD,
     +                   SROT,SIN1,TOPI,TSRT
        SAVE   /MAPCM0/
C
        COMMON /MAPCM1/  COSO,COSR,SINO,SINR,IPRJ,IROD
        DOUBLE PRECISION COSO,COSR,SINO,SINR
        INTEGER          IPRJ,IROD
        SAVE   /MAPCM1/
C
        COMMON /MAPCM4/  GRDR,GRID,GRLA,GRLO,GRPO,OTOL,PDRE,PLA1,PLA2,
     +                   PLA3,PLA4,PLB1,PLB2,PLB3,PLB4,PLNO,PLTO,ROTA,
     +                   SRCH,XLOW,XROW,YBOW,YTOW,IDOT,IDSH,IDTL,ILCW,
     +                   ILTS,JPRJ,ELPF,INTF,LBLF,PRMF
        DOUBLE PRECISION GRDR,GRID,GRLA,GRLO,GRPO,OTOL,PDRE,PLA1,PLA2,
     +                   PLA3,PLA4,PLB1,PLB2,PLB3,PLB4,PLNO,PLTO,ROTA,
     +                   SRCH,XLOW,XROW,YBOW,YTOW
        INTEGER          IDOT,IDSH,IDTL,ILCW,ILTS,JPRJ
        LOGICAL          ELPF,INTF,LBLF,PRMF
        SAVE   /MAPCM4/
C
        COMMON /MAPCMW/  CSLS,CSLT,SLTD,ISLT
        DOUBLE PRECISION CSLS,CSLT,SLTD
        INTEGER ISLT
        SAVE  /MAPCMW/
C
        COMMON /MAPSAT/  ALFA,BETA,DCSA,DCSB,DSNA,DSNB,SALT,SSMO,SRSS
        DOUBLE PRECISION ALFA,BETA,DCSA,DCSB,DSNA,DSNB,SALT,SSMO,SRSS
        SAVE   /MAPSAT/
C
C Set up alternate names for a couple of variables in common.
C
        DOUBLE PRECISION FLT1,FLT2
        EQUIVALENCE      (PLTO,FLT1),(ROTA,FLT2)
C
C Declare local variables.
C
        DOUBLE PRECISION CHI1,CHI2
        REAL             TST1,TST2,TST3
C
C Do a call forcing a BLOCKDATA to be loaded from a binary library.
C
        CALL MAPBD
C
C Decide whether MAPTRN should use real or double-precision arithmetic.
C The subroutine call is necessary to fool some compilers into storing
C TST1, TST2, and TST3; otherwise, real precision may be used on
C machines on which double precision is necessary.  NOTE: As of 07/2001,
C double precision is being used everywhere except in the USGS routines,
C so the flag IROD is not as important as it was prior to that time.
C
        CALL MDPIN2 (TST1,TST2,TST3)
C
        IF (TST1.NE.TST2.AND.TST2.NE.TST3) THEN
          IROD=0
        ELSE
          IROD=1
        END IF
C
C IPRJ equals JPRJ until we find out if fast-path projections are to be
C used.
C
        IPRJ=JPRJ
C
        IF (IPRJ.EQ.1) THEN
C
C Compute quantities required for the Lambert conformal conic.
C
          SINO=SIGN(1.D0,.5D0*(FLT1+FLT2))
          CHI1=(90.D0-SINO*FLT1)*DTOR
C
          IF (FLT1.EQ.FLT2) THEN
            COSO=COS(CHI1)
          ELSE
            CHI2=(90.D0-SINO*FLT2)*DTOR
            COSO=LOG(SIN(CHI1)/SIN(CHI2))/
     +           LOG(TAN(.5D0*CHI1)/TAN(.5D0*CHI2))
          END IF
C
        ELSE
C
C Set the variables determining the effective standard parallel for
C the cylindrical equidistant, the equirectangular, the cylindrical
C equal-area, and the Winkel tripel projections.
C
          IF (IPRJ.EQ.7.AND.ISLT.EQ.0) THEN
            CSLT=1.D0
            CSLS=1.D0
          ELSE IF (IPRJ.EQ.7.AND.ISLT.NE.0) THEN
            IF (SLTD.GE.0.D0.AND.SLTD.LE.89.999D0) THEN
              CSLT=COS(DTOR*SLTD)
            ELSE
              CSLT=2.D0/PI
            END IF
            CSLS=CSLT*CSLT
          ELSE IF (IPRJ.EQ.11) THEN
            IF (SLTD.GE.0.D0.AND.SLTD.LE.89.999D0) THEN
              CSLT=COS(DTOR*SLTD)
            ELSE
              CSLT=SQRT(3.D0)/2.D0
            END IF
            CSLS=CSLT*CSLT
          ELSE IF (IPRJ.EQ.15) THEN
            IF (SLTD.GE.0.D0.AND.SLTD.LE.90.D0) THEN
              CSLT=COS(DTOR*SLTD)
            ELSE
              CSLT=2.D0/PI
            END IF
              CSLS=CSLT*CSLT
          END IF
C
C See if fast-path transformations can by used (type cylindrical or
C mixed, PLAT=0, and ROTA=0 or 180) and, if so, arrange for it.  If
C not, compute required quantities that depend on PLAT and ROTA.
C
          IF (IPRJ.GE.7.AND.IPRJ.LE.15.AND.
     +         ABS(PLTO).LT.   .000001D0.AND.
     +        (ABS(ROTA).LT.   .000001D0.OR.
     +         ABS(ROTA).GT.179.999999D0)    ) THEN
            IPRJ=IPRJ+9
          ELSE
            SINO=SIN(PLTO*DTOR)
            COSO=COS(PLTO*DTOR)
            SINR=SIN(ROTA*DTOR)
            COSR=COS(ROTA*DTOR)
          END IF
C
        END IF
C
        RETURN
C
      END

C
C $Id: mapit.f,v 1.19 2008-09-18 00:42:16 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MAPIT (XLAT,XLON,IFST)
        REAL    XLAT,XLON
        INTEGER IFST
        IF (ICFELL('MAPIT - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
        CALL MDPIT (DBLE(XLAT),DBLE(XLON),IFST)
        IF (ICFELL('MAPIT',2).NE.0) RETURN
        RETURN
      END

      SUBROUTINE DGESDD( JOBZ, M, N, A, LDA, S, U, LDU, VT, LDVT, WORK,
     $                   LWORK, IWORK, INFO )
*
*  -- LAPACK driver routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     October 31, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          JOBZ
      INTEGER            INFO, LDA, LDU, LDVT, LWORK, M, N
*     ..
*     .. Array Arguments ..
      INTEGER            IWORK( * )
      DOUBLE PRECISION   A( LDA, * ), S( * ), U( LDU, * ),
     $                   VT( LDVT, * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  DGESDD computes the singular value decomposition (SVD) of a real
*  M-by-N matrix A, optionally computing the left and right singular
*  vectors.  If singular vectors are desired, it uses a
*  divide-and-conquer algorithm.
*
*  The SVD is written
*
*       A = U * SIGMA * transpose(V)
*
*  where SIGMA is an M-by-N matrix which is zero except for its
*  min(m,n) diagonal elements, U is an M-by-M orthogonal matrix, and
*  V is an N-by-N orthogonal matrix.  The diagonal elements of SIGMA
*  are the singular values of A; they are real and non-negative, and
*  are returned in descending order.  The first min(m,n) columns of
*  U and V are the left and right singular vectors of A.
*
*  Note that the routine returns VT = V**T, not V.
*
*  The divide and conquer algorithm makes very mild assumptions about
*  floating point arithmetic. It will work on machines with a guard
*  digit in add/subtract, or on those binary machines without guard
*  digits which subtract like the Cray X-MP, Cray Y-MP, Cray C-90, or
*  Cray-2. It could conceivably fail on hexadecimal or decimal machines
*  without guard digits, but we know of none.
*
*  Arguments
*  =========
*
*  JOBZ    (input) CHARACTER*1
*          Specifies options for computing all or part of the matrix U:
*          = 'A':  all M columns of U and all N rows of V**T are
*                  returned in the arrays U and VT;
*          = 'S':  the first min(M,N) columns of U and the first
*                  min(M,N) rows of V**T are returned in the arrays U
*                  and VT;
*          = 'O':  If M >= N, the first N columns of U are overwritten
*                  on the array A and all rows of V**T are returned in
*                  the array VT;
*                  otherwise, all columns of U are returned in the
*                  array U and the first M rows of V**T are overwritten
*                  in the array VT;
*          = 'N':  no columns of U or rows of V**T are computed.
*
*  M       (input) INTEGER
*          The number of rows of the input matrix A.  M >= 0.
*
*  N       (input) INTEGER
*          The number of columns of the input matrix A.  N >= 0.
*
*  A       (input/output) DOUBLE PRECISION array, dimension (LDA,N)
*          On entry, the M-by-N matrix A.
*          On exit,
*          if JOBZ = 'O',  A is overwritten with the first N columns
*                          of U (the left singular vectors, stored
*                          columnwise) if M >= N;
*                          A is overwritten with the first M rows
*                          of V**T (the right singular vectors, stored
*                          rowwise) otherwise.
*          if JOBZ .ne. 'O', the contents of A are destroyed.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(1,M).
*
*  S       (output) DOUBLE PRECISION array, dimension (min(M,N))
*          The singular values of A, sorted so that S(i) >= S(i+1).
*
*  U       (output) DOUBLE PRECISION array, dimension (LDU,UCOL)
*          UCOL = M if JOBZ = 'A' or JOBZ = 'O' and M < N;
*          UCOL = min(M,N) if JOBZ = 'S'.
*          If JOBZ = 'A' or JOBZ = 'O' and M < N, U contains the M-by-M
*          orthogonal matrix U;
*          if JOBZ = 'S', U contains the first min(M,N) columns of U
*          (the left singular vectors, stored columnwise);
*          if JOBZ = 'O' and M >= N, or JOBZ = 'N', U is not referenced.
*
*  LDU     (input) INTEGER
*          The leading dimension of the array U.  LDU >= 1; if
*          JOBZ = 'S' or 'A' or JOBZ = 'O' and M < N, LDU >= M.
*
*  VT      (output) DOUBLE PRECISION array, dimension (LDVT,N)
*          If JOBZ = 'A' or JOBZ = 'O' and M >= N, VT contains the
*          N-by-N orthogonal matrix V**T;
*          if JOBZ = 'S', VT contains the first min(M,N) rows of
*          V**T (the right singular vectors, stored rowwise);
*          if JOBZ = 'O' and M < N, or JOBZ = 'N', VT is not referenced.
*
*  LDVT    (input) INTEGER
*          The leading dimension of the array VT.  LDVT >= 1; if
*          JOBZ = 'A' or JOBZ = 'O' and M >= N, LDVT >= N;
*          if JOBZ = 'S', LDVT >= min(M,N).
*
*  WORK    (workspace/output) DOUBLE PRECISION array, dimension (LWORK)
*          On exit, if INFO = 0, WORK(1) returns the optimal LWORK;
*
*  LWORK   (input) INTEGER
*          The dimension of the array WORK. LWORK >= 1.
*          If JOBZ = 'N',
*            LWORK >= 3*min(M,N) + max(max(M,N),6*min(M,N)).
*          If JOBZ = 'O',
*            LWORK >= 3*min(M,N)*min(M,N) + 
*                     max(max(M,N),5*min(M,N)*min(M,N)+4*min(M,N)).
*          If JOBZ = 'S' or 'A'
*            LWORK >= 3*min(M,N)*min(M,N) +
*                     max(max(M,N),4*min(M,N)*min(M,N)+4*min(M,N)).
*          For good performance, LWORK should generally be larger.
*          If LWORK < 0 but other input arguments are legal, WORK(1)
*          returns the optimal LWORK.
*
*  IWORK   (workspace) INTEGER array, dimension (8*min(M,N))
*
*  INFO    (output) INTEGER
*          = 0:  successful exit.
*          < 0:  if INFO = -i, the i-th argument had an illegal value.
*          > 0:  DBDSDC did not converge, updating process failed.
*
*  Further Details
*  ===============
*
*  Based on contributions by
*     Ming Gu and Huan Ren, Computer Science Division, University of
*     California at Berkeley, USA
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO, ONE
      PARAMETER          ( ZERO = 0.0D0, ONE = 1.0D0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            LQUERY, WNTQA, WNTQAS, WNTQN, WNTQO, WNTQS
      INTEGER            BDSPAC, BLK, CHUNK, I, IE, IERR, IL,
     $                   IR, ISCL, ITAU, ITAUP, ITAUQ, IU, IVT, LDWKVT,
     $                   LDWRKL, LDWRKR, LDWRKU, MAXWRK, MINMN, MINWRK,
     $                   MNTHR, NWORK, WRKBL
      DOUBLE PRECISION   ANRM, BIGNUM, EPS, SMLNUM
*     ..
*     .. Local Arrays ..
      INTEGER            IDUM( 1 )
      DOUBLE PRECISION   DUM( 1 )
*     ..
*     .. External Subroutines ..
      EXTERNAL           DBDSDC, DGEBRD, DGELQF, DGEMM, DGEQRF, DLACPY,
     $                   DLASCL, DLASET, DORGBR, DORGLQ, DORGQR, DORMBR,
     $                   XERBLA
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            ILAENV
      DOUBLE PRECISION   DLAMCH, DLANGE
      EXTERNAL           DLAMCH, DLANGE, ILAENV, LSAME
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          DBLE, INT, MAX, MIN, SQRT
*     ..
*     .. Executable Statements ..
*
*     Test the input arguments
*
      INFO = 0
      MINMN = MIN( M, N )
      MNTHR = INT( MINMN*11.0D0 / 6.0D0 )
      WNTQA = LSAME( JOBZ, 'A' )
      WNTQS = LSAME( JOBZ, 'S' )
      WNTQAS = WNTQA .OR. WNTQS
      WNTQO = LSAME( JOBZ, 'O' )
      WNTQN = LSAME( JOBZ, 'N' )
      MINWRK = 1
      MAXWRK = 1
      LQUERY = ( LWORK.EQ.-1 )
*
      IF( .NOT.( WNTQA .OR. WNTQS .OR. WNTQO .OR. WNTQN ) ) THEN
         INFO = -1
      ELSE IF( M.LT.0 ) THEN
         INFO = -2
      ELSE IF( N.LT.0 ) THEN
         INFO = -3
      ELSE IF( LDA.LT.MAX( 1, M ) ) THEN
         INFO = -5
      ELSE IF( LDU.LT.1 .OR. ( WNTQAS .AND. LDU.LT.M ) .OR.
     $         ( WNTQO .AND. M.LT.N .AND. LDU.LT.M ) ) THEN
         INFO = -8
      ELSE IF( LDVT.LT.1 .OR. ( WNTQA .AND. LDVT.LT.N ) .OR.
     $         ( WNTQS .AND. LDVT.LT.MINMN ) .OR.
     $         ( WNTQO .AND. M.GE.N .AND. LDVT.LT.N ) ) THEN
         INFO = -10
      END IF
*
*     Compute workspace
*      (Note: Comments in the code beginning "Workspace:" describe the
*       minimal amount of workspace needed at that point in the code,
*       as well as the preferred amount for good performance.
*       NB refers to the optimal block size for the immediately
*       following subroutine, as returned by ILAENV.)
*
      IF( INFO.EQ.0 .AND. M.GT.0 .AND. N.GT.0 ) THEN
         IF( M.GE.N ) THEN
*
*           Compute space needed for DBDSDC
*
            IF( WNTQN ) THEN
               BDSPAC = 7*N
            ELSE
               BDSPAC = 3*N*N + 4*N
            END IF
            IF( M.GE.MNTHR ) THEN
               IF( WNTQN ) THEN
*
*                 Path 1 (M much larger than N, JOBZ='N')
*
                  WRKBL = N + N*ILAENV( 1, 'DGEQRF', ' ', M, N, -1,
     $                    -1 )
                  WRKBL = MAX( WRKBL, 3*N+2*N*
     $                    ILAENV( 1, 'DGEBRD', ' ', N, N, -1, -1 ) )
                  MAXWRK = MAX( WRKBL, BDSPAC+N )
                  MINWRK = BDSPAC + N
               ELSE IF( WNTQO ) THEN
*
*                 Path 2 (M much larger than N, JOBZ='O')
*
                  WRKBL = N + N*ILAENV( 1, 'DGEQRF', ' ', M, N, -1, -1 )
                  WRKBL = MAX( WRKBL, N+N*ILAENV( 1, 'DORGQR', ' ', M,
     $                    N, N, -1 ) )
                  WRKBL = MAX( WRKBL, 3*N+2*N*
     $                    ILAENV( 1, 'DGEBRD', ' ', N, N, -1, -1 ) )
                  WRKBL = MAX( WRKBL, 3*N+N*
     $                    ILAENV( 1, 'DORMBR', 'QLN', N, N, N, -1 ) )
                  WRKBL = MAX( WRKBL, 3*N+N*
     $                    ILAENV( 1, 'DORMBR', 'PRT', N, N, N, -1 ) )
                  WRKBL = MAX( WRKBL, BDSPAC+3*N )
                  MAXWRK = WRKBL + 2*N*N
                  MINWRK = BDSPAC + 2*N*N + 3*N
               ELSE IF( WNTQS ) THEN
*
*                 Path 3 (M much larger than N, JOBZ='S')
*
                  WRKBL = N + N*ILAENV( 1, 'DGEQRF', ' ', M, N, -1, -1 )
                  WRKBL = MAX( WRKBL, N+N*ILAENV( 1, 'DORGQR', ' ', M,
     $                    N, N, -1 ) )
                  WRKBL = MAX( WRKBL, 3*N+2*N*
     $                    ILAENV( 1, 'DGEBRD', ' ', N, N, -1, -1 ) )
                  WRKBL = MAX( WRKBL, 3*N+N*
     $                    ILAENV( 1, 'DORMBR', 'QLN', N, N, N, -1 ) )
                  WRKBL = MAX( WRKBL, 3*N+N*
     $                    ILAENV( 1, 'DORMBR', 'PRT', N, N, N, -1 ) )
                  WRKBL = MAX( WRKBL, BDSPAC+3*N )
                  MAXWRK = WRKBL + N*N
                  MINWRK = BDSPAC + N*N + 3*N
               ELSE IF( WNTQA ) THEN
*
*                 Path 4 (M much larger than N, JOBZ='A')
*
                  WRKBL = N + N*ILAENV( 1, 'DGEQRF', ' ', M, N, -1, -1 )
                  WRKBL = MAX( WRKBL, N+M*ILAENV( 1, 'DORGQR', ' ', M,
     $                    M, N, -1 ) )
                  WRKBL = MAX( WRKBL, 3*N+2*N*
     $                    ILAENV( 1, 'DGEBRD', ' ', N, N, -1, -1 ) )
                  WRKBL = MAX( WRKBL, 3*N+N*
     $                    ILAENV( 1, 'DORMBR', 'QLN', N, N, N, -1 ) )
                  WRKBL = MAX( WRKBL, 3*N+N*
     $                    ILAENV( 1, 'DORMBR', 'PRT', N, N, N, -1 ) )
                  WRKBL = MAX( WRKBL, BDSPAC+3*N )
                  MAXWRK = WRKBL + N*N
                  MINWRK = BDSPAC + N*N + 3*N
               END IF
            ELSE
*
*              Path 5 (M at least N, but not much larger)
*
               WRKBL = 3*N + ( M+N )*ILAENV( 1, 'DGEBRD', ' ', M, N, -1,
     $                 -1 )
               IF( WNTQN ) THEN
                  MAXWRK = MAX( WRKBL, BDSPAC+3*N )
                  MINWRK = 3*N + MAX( M, BDSPAC )
               ELSE IF( WNTQO ) THEN
                  WRKBL = MAX( WRKBL, 3*N+N*
     $                    ILAENV( 1, 'DORMBR', 'QLN', M, N, N, -1 ) )
                  WRKBL = MAX( WRKBL, 3*N+N*
     $                    ILAENV( 1, 'DORMBR', 'PRT', N, N, N, -1 ) )
                  WRKBL = MAX( WRKBL, BDSPAC+3*N )
                  MAXWRK = WRKBL + M*N
                  MINWRK = 3*N + MAX( M, N*N+BDSPAC )
               ELSE IF( WNTQS ) THEN
                  WRKBL = MAX( WRKBL, 3*N+N*
     $                    ILAENV( 1, 'DORMBR', 'QLN', M, N, N, -1 ) )
                  WRKBL = MAX( WRKBL, 3*N+N*
     $                    ILAENV( 1, 'DORMBR', 'PRT', N, N, N, -1 ) )
                  MAXWRK = MAX( WRKBL, BDSPAC+3*N )
                  MINWRK = 3*N + MAX( M, BDSPAC )
               ELSE IF( WNTQA ) THEN
                  WRKBL = MAX( WRKBL, 3*N+M*
     $                    ILAENV( 1, 'DORMBR', 'QLN', M, M, N, -1 ) )
                  WRKBL = MAX( WRKBL, 3*N+N*
     $                    ILAENV( 1, 'DORMBR', 'PRT', N, N, N, -1 ) )
                  MAXWRK = MAX( MAXWRK, BDSPAC+3*N )
                  MINWRK = 3*N + MAX( M, BDSPAC )
               END IF
            END IF
         ELSE
*
*           Compute space needed for DBDSDC
*
            IF( WNTQN ) THEN
               BDSPAC = 7*M
            ELSE
               BDSPAC = 3*M*M + 4*M
            END IF
            IF( N.GE.MNTHR ) THEN
               IF( WNTQN ) THEN
*
*                 Path 1t (N much larger than M, JOBZ='N')
*
                  WRKBL = M + M*ILAENV( 1, 'DGELQF', ' ', M, N, -1,
     $                    -1 )
                  WRKBL = MAX( WRKBL, 3*M+2*M*
     $                    ILAENV( 1, 'DGEBRD', ' ', M, M, -1, -1 ) )
                  MAXWRK = MAX( WRKBL, BDSPAC+M )
                  MINWRK = BDSPAC + M
               ELSE IF( WNTQO ) THEN
*
*                 Path 2t (N much larger than M, JOBZ='O')
*
                  WRKBL = M + M*ILAENV( 1, 'DGELQF', ' ', M, N, -1, -1 )
                  WRKBL = MAX( WRKBL, M+M*ILAENV( 1, 'DORGLQ', ' ', M,
     $                    N, M, -1 ) )
                  WRKBL = MAX( WRKBL, 3*M+2*M*
     $                    ILAENV( 1, 'DGEBRD', ' ', M, M, -1, -1 ) )
                  WRKBL = MAX( WRKBL, 3*M+M*
     $                    ILAENV( 1, 'DORMBR', 'QLN', M, M, M, -1 ) )
                  WRKBL = MAX( WRKBL, 3*M+M*
     $                    ILAENV( 1, 'DORMBR', 'PRT', M, M, M, -1 ) )
                  WRKBL = MAX( WRKBL, BDSPAC+3*M )
                  MAXWRK = WRKBL + 2*M*M
                  MINWRK = BDSPAC + 2*M*M + 3*M
               ELSE IF( WNTQS ) THEN
*
*                 Path 3t (N much larger than M, JOBZ='S')
*
                  WRKBL = M + M*ILAENV( 1, 'DGELQF', ' ', M, N, -1, -1 )
                  WRKBL = MAX( WRKBL, M+M*ILAENV( 1, 'DORGLQ', ' ', M,
     $                    N, M, -1 ) )
                  WRKBL = MAX( WRKBL, 3*M+2*M*
     $                    ILAENV( 1, 'DGEBRD', ' ', M, M, -1, -1 ) )
                  WRKBL = MAX( WRKBL, 3*M+M*
     $                    ILAENV( 1, 'DORMBR', 'QLN', M, M, M, -1 ) )
                  WRKBL = MAX( WRKBL, 3*M+M*
     $                    ILAENV( 1, 'DORMBR', 'PRT', M, M, M, -1 ) )
                  WRKBL = MAX( WRKBL, BDSPAC+3*M )
                  MAXWRK = WRKBL + M*M
                  MINWRK = BDSPAC + M*M + 3*M
               ELSE IF( WNTQA ) THEN
*
*                 Path 4t (N much larger than M, JOBZ='A')
*
                  WRKBL = M + M*ILAENV( 1, 'DGELQF', ' ', M, N, -1, -1 )
                  WRKBL = MAX( WRKBL, M+N*ILAENV( 1, 'DORGLQ', ' ', N,
     $                    N, M, -1 ) )
                  WRKBL = MAX( WRKBL, 3*M+2*M*
     $                    ILAENV( 1, 'DGEBRD', ' ', M, M, -1, -1 ) )
                  WRKBL = MAX( WRKBL, 3*M+M*
     $                    ILAENV( 1, 'DORMBR', 'QLN', M, M, M, -1 ) )
                  WRKBL = MAX( WRKBL, 3*M+M*
     $                    ILAENV( 1, 'DORMBR', 'PRT', M, M, M, -1 ) )
                  WRKBL = MAX( WRKBL, BDSPAC+3*M )
                  MAXWRK = WRKBL + M*M
                  MINWRK = BDSPAC + M*M + 3*M
               END IF
            ELSE
*
*              Path 5t (N greater than M, but not much larger)
*
               WRKBL = 3*M + ( M+N )*ILAENV( 1, 'DGEBRD', ' ', M, N, -1,
     $                 -1 )
               IF( WNTQN ) THEN
                  MAXWRK = MAX( WRKBL, BDSPAC+3*M )
                  MINWRK = 3*M + MAX( N, BDSPAC )
               ELSE IF( WNTQO ) THEN
                  WRKBL = MAX( WRKBL, 3*M+M*
     $                    ILAENV( 1, 'DORMBR', 'QLN', M, M, N, -1 ) )
                  WRKBL = MAX( WRKBL, 3*M+M*
     $                    ILAENV( 1, 'DORMBR', 'PRT', M, N, M, -1 ) )
                  WRKBL = MAX( WRKBL, BDSPAC+3*M )
                  MAXWRK = WRKBL + M*N
                  MINWRK = 3*M + MAX( N, M*M+BDSPAC )
               ELSE IF( WNTQS ) THEN
                  WRKBL = MAX( WRKBL, 3*M+M*
     $                    ILAENV( 1, 'DORMBR', 'QLN', M, M, N, -1 ) )
                  WRKBL = MAX( WRKBL, 3*M+M*
     $                    ILAENV( 1, 'DORMBR', 'PRT', M, N, M, -1 ) )
                  MAXWRK = MAX( WRKBL, BDSPAC+3*M )
                  MINWRK = 3*M + MAX( N, BDSPAC )
               ELSE IF( WNTQA ) THEN
                  WRKBL = MAX( WRKBL, 3*M+M*
     $                    ILAENV( 1, 'DORMBR', 'QLN', M, M, N, -1 ) )
                  WRKBL = MAX( WRKBL, 3*M+M*
     $                    ILAENV( 1, 'DORMBR', 'PRT', N, N, M, -1 ) )
                  MAXWRK = MAX( WRKBL, BDSPAC+3*M )
                  MINWRK = 3*M + MAX( N, BDSPAC )
               END IF
            END IF
         END IF
         WORK( 1 ) = MAXWRK
      END IF
*
      IF( LWORK.LT.MINWRK .AND. .NOT.LQUERY ) THEN
         INFO = -12
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DGESDD', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( M.EQ.0 .OR. N.EQ.0 ) THEN
         IF( LWORK.GE.1 )
     $      WORK( 1 ) = ONE
         RETURN
      END IF
*
*     Get machine constants
*
      EPS = DLAMCH( 'P' )
      SMLNUM = SQRT( DLAMCH( 'S' ) ) / EPS
      BIGNUM = ONE / SMLNUM
*
*     Scale A if max element outside range [SMLNUM,BIGNUM]
*
      ANRM = DLANGE( 'M', M, N, A, LDA, DUM )
      ISCL = 0
      IF( ANRM.GT.ZERO .AND. ANRM.LT.SMLNUM ) THEN
         ISCL = 1
         CALL DLASCL( 'G', 0, 0, ANRM, SMLNUM, M, N, A, LDA, IERR )
      ELSE IF( ANRM.GT.BIGNUM ) THEN
         ISCL = 1
         CALL DLASCL( 'G', 0, 0, ANRM, BIGNUM, M, N, A, LDA, IERR )
      END IF
*
      IF( M.GE.N ) THEN
*
*        A has at least as many rows as columns. If A has sufficiently
*        more rows than columns, first reduce using the QR
*        decomposition (if sufficient workspace available)
*
         IF( M.GE.MNTHR ) THEN
*
            IF( WNTQN ) THEN
*
*              Path 1 (M much larger than N, JOBZ='N')
*              No singular vectors to be computed
*
               ITAU = 1
               NWORK = ITAU + N
*
*              Compute A=Q*R
*              (Workspace: need 2*N, prefer N+N*NB)
*
               CALL DGEQRF( M, N, A, LDA, WORK( ITAU ), WORK( NWORK ),
     $                      LWORK-NWORK+1, IERR )
*
*              Zero out below R
*
               CALL DLASET( 'L', N-1, N-1, ZERO, ZERO, A( 2, 1 ), LDA )
               IE = 1
               ITAUQ = IE + N
               ITAUP = ITAUQ + N
               NWORK = ITAUP + N
*
*              Bidiagonalize R in A
*              (Workspace: need 4*N, prefer 3*N+2*N*NB)
*
               CALL DGEBRD( N, N, A, LDA, S, WORK( IE ), WORK( ITAUQ ),
     $                      WORK( ITAUP ), WORK( NWORK ), LWORK-NWORK+1,
     $                      IERR )
               NWORK = IE + N
*
*              Perform bidiagonal SVD, computing singular values only
*              (Workspace: need N+BDSPAC)
*
               CALL DBDSDC( 'U', 'N', N, S, WORK( IE ), DUM, 1, DUM, 1,
     $                      DUM, IDUM, WORK( NWORK ), IWORK, INFO )
*
            ELSE IF( WNTQO ) THEN
*
*              Path 2 (M much larger than N, JOBZ = 'O')
*              N left singular vectors to be overwritten on A and
*              N right singular vectors to be computed in VT
*
               IR = 1
*
*              WORK(IR) is LDWRKR by N
*
               IF( LWORK.GE.LDA*N+N*N+3*N+BDSPAC ) THEN
                  LDWRKR = LDA
               ELSE
                  LDWRKR = ( LWORK-N*N-3*N-BDSPAC ) / N
               END IF
               ITAU = IR + LDWRKR*N
               NWORK = ITAU + N
*
*              Compute A=Q*R
*              (Workspace: need N*N+2*N, prefer N*N+N+N*NB)
*
               CALL DGEQRF( M, N, A, LDA, WORK( ITAU ), WORK( NWORK ),
     $                      LWORK-NWORK+1, IERR )
*
*              Copy R to WORK(IR), zeroing out below it
*
               CALL DLACPY( 'U', N, N, A, LDA, WORK( IR ), LDWRKR )
               CALL DLASET( 'L', N-1, N-1, ZERO, ZERO, WORK( IR+1 ),
     $                      LDWRKR )
*
*              Generate Q in A
*              (Workspace: need N*N+2*N, prefer N*N+N+N*NB)
*
               CALL DORGQR( M, N, N, A, LDA, WORK( ITAU ),
     $                      WORK( NWORK ), LWORK-NWORK+1, IERR )
               IE = ITAU
               ITAUQ = IE + N
               ITAUP = ITAUQ + N
               NWORK = ITAUP + N
*
*              Bidiagonalize R in VT, copying result to WORK(IR)
*              (Workspace: need N*N+4*N, prefer N*N+3*N+2*N*NB)
*
               CALL DGEBRD( N, N, WORK( IR ), LDWRKR, S, WORK( IE ),
     $                      WORK( ITAUQ ), WORK( ITAUP ), WORK( NWORK ),
     $                      LWORK-NWORK+1, IERR )
*
*              WORK(IU) is N by N
*
               IU = NWORK
               NWORK = IU + N*N
*
*              Perform bidiagonal SVD, computing left singular vectors
*              of bidiagonal matrix in WORK(IU) and computing right
*              singular vectors of bidiagonal matrix in VT
*              (Workspace: need N+N*N+BDSPAC)
*
               CALL DBDSDC( 'U', 'I', N, S, WORK( IE ), WORK( IU ), N,
     $                      VT, LDVT, DUM, IDUM, WORK( NWORK ), IWORK,
     $                      INFO )
*
*              Overwrite WORK(IU) by left singular vectors of R
*              and VT by right singular vectors of R
*              (Workspace: need 2*N*N+3*N, prefer 2*N*N+2*N+N*NB)
*
               CALL DORMBR( 'Q', 'L', 'N', N, N, N, WORK( IR ), LDWRKR,
     $                      WORK( ITAUQ ), WORK( IU ), N, WORK( NWORK ),
     $                      LWORK-NWORK+1, IERR )
               CALL DORMBR( 'P', 'R', 'T', N, N, N, WORK( IR ), LDWRKR,
     $                      WORK( ITAUP ), VT, LDVT, WORK( NWORK ),
     $                      LWORK-NWORK+1, IERR )
*
*              Multiply Q in A by left singular vectors of R in
*              WORK(IU), storing result in WORK(IR) and copying to A
*              (Workspace: need 2*N*N, prefer N*N+M*N)
*
               DO 10 I = 1, M, LDWRKR
                  CHUNK = MIN( M-I+1, LDWRKR )
                  CALL DGEMM( 'N', 'N', CHUNK, N, N, ONE, A( I, 1 ),
     $                        LDA, WORK( IU ), N, ZERO, WORK( IR ),
     $                        LDWRKR )
                  CALL DLACPY( 'F', CHUNK, N, WORK( IR ), LDWRKR,
     $                         A( I, 1 ), LDA )
   10          CONTINUE
*
            ELSE IF( WNTQS ) THEN
*
*              Path 3 (M much larger than N, JOBZ='S')
*              N left singular vectors to be computed in U and
*              N right singular vectors to be computed in VT
*
               IR = 1
*
*              WORK(IR) is N by N
*
               LDWRKR = N
               ITAU = IR + LDWRKR*N
               NWORK = ITAU + N
*
*              Compute A=Q*R
*              (Workspace: need N*N+2*N, prefer N*N+N+N*NB)
*
               CALL DGEQRF( M, N, A, LDA, WORK( ITAU ), WORK( NWORK ),
     $                      LWORK-NWORK+1, IERR )
*
*              Copy R to WORK(IR), zeroing out below it
*
               CALL DLACPY( 'U', N, N, A, LDA, WORK( IR ), LDWRKR )
               CALL DLASET( 'L', N-1, N-1, ZERO, ZERO, WORK( IR+1 ),
     $                      LDWRKR )
*
*              Generate Q in A
*              (Workspace: need N*N+2*N, prefer N*N+N+N*NB)
*
               CALL DORGQR( M, N, N, A, LDA, WORK( ITAU ),
     $                      WORK( NWORK ), LWORK-NWORK+1, IERR )
               IE = ITAU
               ITAUQ = IE + N
               ITAUP = ITAUQ + N
               NWORK = ITAUP + N
*
*              Bidiagonalize R in WORK(IR)
*              (Workspace: need N*N+4*N, prefer N*N+3*N+2*N*NB)
*
               CALL DGEBRD( N, N, WORK( IR ), LDWRKR, S, WORK( IE ),
     $                      WORK( ITAUQ ), WORK( ITAUP ), WORK( NWORK ),
     $                      LWORK-NWORK+1, IERR )
*
*              Perform bidiagonal SVD, computing left singular vectors
*              of bidiagoal matrix in U and computing right singular
*              vectors of bidiagonal matrix in VT
*              (Workspace: need N+BDSPAC)
*
               CALL DBDSDC( 'U', 'I', N, S, WORK( IE ), U, LDU, VT,
     $                      LDVT, DUM, IDUM, WORK( NWORK ), IWORK,
     $                      INFO )
*
*              Overwrite U by left singular vectors of R and VT
*              by right singular vectors of R
*              (Workspace: need N*N+3*N, prefer N*N+2*N+N*NB)
*
               CALL DORMBR( 'Q', 'L', 'N', N, N, N, WORK( IR ), LDWRKR,
     $                      WORK( ITAUQ ), U, LDU, WORK( NWORK ),
     $                      LWORK-NWORK+1, IERR )
*
               CALL DORMBR( 'P', 'R', 'T', N, N, N, WORK( IR ), LDWRKR,
     $                      WORK( ITAUP ), VT, LDVT, WORK( NWORK ),
     $                      LWORK-NWORK+1, IERR )
*
*              Multiply Q in A by left singular vectors of R in
*              WORK(IR), storing result in U
*              (Workspace: need N*N)
*
               CALL DLACPY( 'F', N, N, U, LDU, WORK( IR ), LDWRKR )
               CALL DGEMM( 'N', 'N', M, N, N, ONE, A, LDA, WORK( IR ),
     $                     LDWRKR, ZERO, U, LDU )
*
            ELSE IF( WNTQA ) THEN
*
*              Path 4 (M much larger than N, JOBZ='A')
*              M left singular vectors to be computed in U and
*              N right singular vectors to be computed in VT
*
               IU = 1
*
*              WORK(IU) is N by N
*
               LDWRKU = N
               ITAU = IU + LDWRKU*N
               NWORK = ITAU + N
*
*              Compute A=Q*R, copying result to U
*              (Workspace: need N*N+2*N, prefer N*N+N+N*NB)
*
               CALL DGEQRF( M, N, A, LDA, WORK( ITAU ), WORK( NWORK ),
     $                      LWORK-NWORK+1, IERR )
               CALL DLACPY( 'L', M, N, A, LDA, U, LDU )
*
*              Generate Q in U
*              (Workspace: need N*N+2*N, prefer N*N+N+N*NB)
               CALL DORGQR( M, M, N, U, LDU, WORK( ITAU ),
     $                      WORK( NWORK ), LWORK-NWORK+1, IERR )
*
*              Produce R in A, zeroing out other entries
*
               CALL DLASET( 'L', N-1, N-1, ZERO, ZERO, A( 2, 1 ), LDA )
               IE = ITAU
               ITAUQ = IE + N
               ITAUP = ITAUQ + N
               NWORK = ITAUP + N
*
*              Bidiagonalize R in A
*              (Workspace: need N*N+4*N, prefer N*N+3*N+2*N*NB)
*
               CALL DGEBRD( N, N, A, LDA, S, WORK( IE ), WORK( ITAUQ ),
     $                      WORK( ITAUP ), WORK( NWORK ), LWORK-NWORK+1,
     $                      IERR )
*
*              Perform bidiagonal SVD, computing left singular vectors
*              of bidiagonal matrix in WORK(IU) and computing right
*              singular vectors of bidiagonal matrix in VT
*              (Workspace: need N+N*N+BDSPAC)
*
               CALL DBDSDC( 'U', 'I', N, S, WORK( IE ), WORK( IU ), N,
     $                      VT, LDVT, DUM, IDUM, WORK( NWORK ), IWORK,
     $                      INFO )
*
*              Overwrite WORK(IU) by left singular vectors of R and VT
*              by right singular vectors of R
*              (Workspace: need N*N+3*N, prefer N*N+2*N+N*NB)
*
               CALL DORMBR( 'Q', 'L', 'N', N, N, N, A, LDA,
     $                      WORK( ITAUQ ), WORK( IU ), LDWRKU,
     $                      WORK( NWORK ), LWORK-NWORK+1, IERR )
               CALL DORMBR( 'P', 'R', 'T', N, N, N, A, LDA,
     $                      WORK( ITAUP ), VT, LDVT, WORK( NWORK ),
     $                      LWORK-NWORK+1, IERR )
*
*              Multiply Q in U by left singular vectors of R in
*              WORK(IU), storing result in A
*              (Workspace: need N*N)
*
               CALL DGEMM( 'N', 'N', M, N, N, ONE, U, LDU, WORK( IU ),
     $                     LDWRKU, ZERO, A, LDA )
*
*              Copy left singular vectors of A from A to U
*
               CALL DLACPY( 'F', M, N, A, LDA, U, LDU )
*
            END IF
*
         ELSE
*
*           M .LT. MNTHR
*
*           Path 5 (M at least N, but not much larger)
*           Reduce to bidiagonal form without QR decomposition
*
            IE = 1
            ITAUQ = IE + N
            ITAUP = ITAUQ + N
            NWORK = ITAUP + N
*
*           Bidiagonalize A
*           (Workspace: need 3*N+M, prefer 3*N+(M+N)*NB)
*
            CALL DGEBRD( M, N, A, LDA, S, WORK( IE ), WORK( ITAUQ ),
     $                   WORK( ITAUP ), WORK( NWORK ), LWORK-NWORK+1,
     $                   IERR )
            IF( WNTQN ) THEN
*
*              Perform bidiagonal SVD, only computing singular values
*              (Workspace: need N+BDSPAC)
*
               CALL DBDSDC( 'U', 'N', N, S, WORK( IE ), DUM, 1, DUM, 1,
     $                      DUM, IDUM, WORK( NWORK ), IWORK, INFO )
            ELSE IF( WNTQO ) THEN
               IU = NWORK
               IF( LWORK.GE.M*N+3*N+BDSPAC ) THEN
*
*                 WORK( IU ) is M by N
*
                  LDWRKU = M
                  NWORK = IU + LDWRKU*N
                  CALL DLASET( 'F', M, N, ZERO, ZERO, WORK( IU ),
     $                         LDWRKU )
               ELSE
*
*                 WORK( IU ) is N by N
*
                  LDWRKU = N
                  NWORK = IU + LDWRKU*N
*
*                 WORK(IR) is LDWRKR by N
*
                  IR = NWORK
                  LDWRKR = ( LWORK-N*N-3*N ) / N
               END IF
               NWORK = IU + LDWRKU*N
*
*              Perform bidiagonal SVD, computing left singular vectors
*              of bidiagonal matrix in WORK(IU) and computing right
*              singular vectors of bidiagonal matrix in VT
*              (Workspace: need N+N*N+BDSPAC)
*
               CALL DBDSDC( 'U', 'I', N, S, WORK( IE ), WORK( IU ),
     $                      LDWRKU, VT, LDVT, DUM, IDUM, WORK( NWORK ),
     $                      IWORK, INFO )
*
*              Overwrite VT by right singular vectors of A
*              (Workspace: need N*N+2*N, prefer N*N+N+N*NB)
*
               CALL DORMBR( 'P', 'R', 'T', N, N, N, A, LDA,
     $                      WORK( ITAUP ), VT, LDVT, WORK( NWORK ),
     $                      LWORK-NWORK+1, IERR )
*
               IF( LWORK.GE.M*N+3*N+BDSPAC ) THEN
*
*                 Overwrite WORK(IU) by left singular vectors of A
*                 (Workspace: need N*N+2*N, prefer N*N+N+N*NB)
*
                  CALL DORMBR( 'Q', 'L', 'N', M, N, N, A, LDA,
     $                         WORK( ITAUQ ), WORK( IU ), LDWRKU,
     $                         WORK( NWORK ), LWORK-NWORK+1, IERR )
*
*                 Copy left singular vectors of A from WORK(IU) to A
*
                  CALL DLACPY( 'F', M, N, WORK( IU ), LDWRKU, A, LDA )
               ELSE
*
*                 Generate Q in A
*                 (Workspace: need N*N+2*N, prefer N*N+N+N*NB)
*
                  CALL DORGBR( 'Q', M, N, N, A, LDA, WORK( ITAUQ ),
     $                         WORK( NWORK ), LWORK-NWORK+1, IERR )
*
*                 Multiply Q in A by left singular vectors of
*                 bidiagonal matrix in WORK(IU), storing result in
*                 WORK(IR) and copying to A
*                 (Workspace: need 2*N*N, prefer N*N+M*N)
*
                  DO 20 I = 1, M, LDWRKR
                     CHUNK = MIN( M-I+1, LDWRKR )
                     CALL DGEMM( 'N', 'N', CHUNK, N, N, ONE, A( I, 1 ),
     $                           LDA, WORK( IU ), LDWRKU, ZERO,
     $                           WORK( IR ), LDWRKR )
                     CALL DLACPY( 'F', CHUNK, N, WORK( IR ), LDWRKR,
     $                            A( I, 1 ), LDA )
   20             CONTINUE
               END IF
*
            ELSE IF( WNTQS ) THEN
*
*              Perform bidiagonal SVD, computing left singular vectors
*              of bidiagonal matrix in U and computing right singular
*              vectors of bidiagonal matrix in VT
*              (Workspace: need N+BDSPAC)
*
               CALL DLASET( 'F', M, N, ZERO, ZERO, U, LDU )
               CALL DBDSDC( 'U', 'I', N, S, WORK( IE ), U, LDU, VT,
     $                      LDVT, DUM, IDUM, WORK( NWORK ), IWORK,
     $                      INFO )
*
*              Overwrite U by left singular vectors of A and VT
*              by right singular vectors of A
*              (Workspace: need 3*N, prefer 2*N+N*NB)
*
               CALL DORMBR( 'Q', 'L', 'N', M, N, N, A, LDA,
     $                      WORK( ITAUQ ), U, LDU, WORK( NWORK ),
     $                      LWORK-NWORK+1, IERR )
               CALL DORMBR( 'P', 'R', 'T', N, N, N, A, LDA,
     $                      WORK( ITAUP ), VT, LDVT, WORK( NWORK ),
     $                      LWORK-NWORK+1, IERR )
            ELSE IF( WNTQA ) THEN
*
*              Perform bidiagonal SVD, computing left singular vectors
*              of bidiagonal matrix in U and computing right singular
*              vectors of bidiagonal matrix in VT
*              (Workspace: need N+BDSPAC)
*
               CALL DLASET( 'F', M, M, ZERO, ZERO, U, LDU )
               CALL DBDSDC( 'U', 'I', N, S, WORK( IE ), U, LDU, VT,
     $                      LDVT, DUM, IDUM, WORK( NWORK ), IWORK,
     $                      INFO )
*
*              Set the right corner of U to identity matrix
*
               CALL DLASET( 'F', M-N, M-N, ZERO, ONE, U( N+1, N+1 ),
     $                      LDU )
*
*              Overwrite U by left singular vectors of A and VT
*              by right singular vectors of A
*              (Workspace: need N*N+2*N+M, prefer N*N+2*N+M*NB)
*
               CALL DORMBR( 'Q', 'L', 'N', M, M, N, A, LDA,
     $                      WORK( ITAUQ ), U, LDU, WORK( NWORK ),
     $                      LWORK-NWORK+1, IERR )
               CALL DORMBR( 'P', 'R', 'T', N, N, M, A, LDA,
     $                      WORK( ITAUP ), VT, LDVT, WORK( NWORK ),
     $                      LWORK-NWORK+1, IERR )
            END IF
*
         END IF
*
      ELSE
*
*        A has more columns than rows. If A has sufficiently more
*        columns than rows, first reduce using the LQ decomposition (if
*        sufficient workspace available)
*
         IF( N.GE.MNTHR ) THEN
*
            IF( WNTQN ) THEN
*
*              Path 1t (N much larger than M, JOBZ='N')
*              No singular vectors to be computed
*
               ITAU = 1
               NWORK = ITAU + M
*
*              Compute A=L*Q
*              (Workspace: need 2*M, prefer M+M*NB)
*
               CALL DGELQF( M, N, A, LDA, WORK( ITAU ), WORK( NWORK ),
     $                      LWORK-NWORK+1, IERR )
*
*              Zero out above L
*
               CALL DLASET( 'U', M-1, M-1, ZERO, ZERO, A( 1, 2 ), LDA )
               IE = 1
               ITAUQ = IE + M
               ITAUP = ITAUQ + M
               NWORK = ITAUP + M
*
*              Bidiagonalize L in A
*              (Workspace: need 4*M, prefer 3*M+2*M*NB)
*
               CALL DGEBRD( M, M, A, LDA, S, WORK( IE ), WORK( ITAUQ ),
     $                      WORK( ITAUP ), WORK( NWORK ), LWORK-NWORK+1,
     $                      IERR )
               NWORK = IE + M
*
*              Perform bidiagonal SVD, computing singular values only
*              (Workspace: need M+BDSPAC)
*
               CALL DBDSDC( 'U', 'N', M, S, WORK( IE ), DUM, 1, DUM, 1,
     $                      DUM, IDUM, WORK( NWORK ), IWORK, INFO )
*
            ELSE IF( WNTQO ) THEN
*
*              Path 2t (N much larger than M, JOBZ='O')
*              M right singular vectors to be overwritten on A and
*              M left singular vectors to be computed in U
*
               IVT = 1
*
*              IVT is M by M
*
               IL = IVT + M*M
               IF( LWORK.GE.M*N+M*M+3*M+BDSPAC ) THEN
*
*                 WORK(IL) is M by N
*
                  LDWRKL = M
                  CHUNK = N
               ELSE
                  LDWRKL = M
                  CHUNK = ( LWORK-M*M ) / M
               END IF
               ITAU = IL + LDWRKL*M
               NWORK = ITAU + M
*
*              Compute A=L*Q
*              (Workspace: need M*M+2*M, prefer M*M+M+M*NB)
*
               CALL DGELQF( M, N, A, LDA, WORK( ITAU ), WORK( NWORK ),
     $                      LWORK-NWORK+1, IERR )
*
*              Copy L to WORK(IL), zeroing about above it
*
               CALL DLACPY( 'L', M, M, A, LDA, WORK( IL ), LDWRKL )
               CALL DLASET( 'U', M-1, M-1, ZERO, ZERO,
     $                      WORK( IL+LDWRKL ), LDWRKL )
*
*              Generate Q in A
*              (Workspace: need M*M+2*M, prefer M*M+M+M*NB)
*
               CALL DORGLQ( M, N, M, A, LDA, WORK( ITAU ),
     $                      WORK( NWORK ), LWORK-NWORK+1, IERR )
               IE = ITAU
               ITAUQ = IE + M
               ITAUP = ITAUQ + M
               NWORK = ITAUP + M
*
*              Bidiagonalize L in WORK(IL)
*              (Workspace: need M*M+4*M, prefer M*M+3*M+2*M*NB)
*
               CALL DGEBRD( M, M, WORK( IL ), LDWRKL, S, WORK( IE ),
     $                      WORK( ITAUQ ), WORK( ITAUP ), WORK( NWORK ),
     $                      LWORK-NWORK+1, IERR )
*
*              Perform bidiagonal SVD, computing left singular vectors
*              of bidiagonal matrix in U, and computing right singular
*              vectors of bidiagonal matrix in WORK(IVT)
*              (Workspace: need M+M*M+BDSPAC)
*
               CALL DBDSDC( 'U', 'I', M, S, WORK( IE ), U, LDU,
     $                      WORK( IVT ), M, DUM, IDUM, WORK( NWORK ),
     $                      IWORK, INFO )
*
*              Overwrite U by left singular vectors of L and WORK(IVT)
*              by right singular vectors of L
*              (Workspace: need 2*M*M+3*M, prefer 2*M*M+2*M+M*NB)
*
               CALL DORMBR( 'Q', 'L', 'N', M, M, M, WORK( IL ), LDWRKL,
     $                      WORK( ITAUQ ), U, LDU, WORK( NWORK ),
     $                      LWORK-NWORK+1, IERR )
               CALL DORMBR( 'P', 'R', 'T', M, M, M, WORK( IL ), LDWRKL,
     $                      WORK( ITAUP ), WORK( IVT ), M,
     $                      WORK( NWORK ), LWORK-NWORK+1, IERR )
*
*              Multiply right singular vectors of L in WORK(IVT) by Q
*              in A, storing result in WORK(IL) and copying to A
*              (Workspace: need 2*M*M, prefer M*M+M*N)
*
               DO 30 I = 1, N, CHUNK
                  BLK = MIN( N-I+1, CHUNK )
                  CALL DGEMM( 'N', 'N', M, BLK, M, ONE, WORK( IVT ), M,
     $                        A( 1, I ), LDA, ZERO, WORK( IL ), LDWRKL )
                  CALL DLACPY( 'F', M, BLK, WORK( IL ), LDWRKL,
     $                         A( 1, I ), LDA )
   30          CONTINUE
*
            ELSE IF( WNTQS ) THEN
*
*              Path 3t (N much larger than M, JOBZ='S')
*              M right singular vectors to be computed in VT and
*              M left singular vectors to be computed in U
*
               IL = 1
*
*              WORK(IL) is M by M
*
               LDWRKL = M
               ITAU = IL + LDWRKL*M
               NWORK = ITAU + M
*
*              Compute A=L*Q
*              (Workspace: need M*M+2*M, prefer M*M+M+M*NB)
*
               CALL DGELQF( M, N, A, LDA, WORK( ITAU ), WORK( NWORK ),
     $                      LWORK-NWORK+1, IERR )
*
*              Copy L to WORK(IL), zeroing out above it
*
               CALL DLACPY( 'L', M, M, A, LDA, WORK( IL ), LDWRKL )
               CALL DLASET( 'U', M-1, M-1, ZERO, ZERO,
     $                      WORK( IL+LDWRKL ), LDWRKL )
*
*              Generate Q in A
*              (Workspace: need M*M+2*M, prefer M*M+M+M*NB)
*
               CALL DORGLQ( M, N, M, A, LDA, WORK( ITAU ),
     $                      WORK( NWORK ), LWORK-NWORK+1, IERR )
               IE = ITAU
               ITAUQ = IE + M
               ITAUP = ITAUQ + M
               NWORK = ITAUP + M
*
*              Bidiagonalize L in WORK(IU), copying result to U
*              (Workspace: need M*M+4*M, prefer M*M+3*M+2*M*NB)
*
               CALL DGEBRD( M, M, WORK( IL ), LDWRKL, S, WORK( IE ),
     $                      WORK( ITAUQ ), WORK( ITAUP ), WORK( NWORK ),
     $                      LWORK-NWORK+1, IERR )
*
*              Perform bidiagonal SVD, computing left singular vectors
*              of bidiagonal matrix in U and computing right singular
*              vectors of bidiagonal matrix in VT
*              (Workspace: need M+BDSPAC)
*
               CALL DBDSDC( 'U', 'I', M, S, WORK( IE ), U, LDU, VT,
     $                      LDVT, DUM, IDUM, WORK( NWORK ), IWORK,
     $                      INFO )
*
*              Overwrite U by left singular vectors of L and VT
*              by right singular vectors of L
*              (Workspace: need M*M+3*M, prefer M*M+2*M+M*NB)
*
               CALL DORMBR( 'Q', 'L', 'N', M, M, M, WORK( IL ), LDWRKL,
     $                      WORK( ITAUQ ), U, LDU, WORK( NWORK ),
     $                      LWORK-NWORK+1, IERR )
               CALL DORMBR( 'P', 'R', 'T', M, M, M, WORK( IL ), LDWRKL,
     $                      WORK( ITAUP ), VT, LDVT, WORK( NWORK ),
     $                      LWORK-NWORK+1, IERR )
*
*              Multiply right singular vectors of L in WORK(IL) by
*              Q in A, storing result in VT
*              (Workspace: need M*M)
*
               CALL DLACPY( 'F', M, M, VT, LDVT, WORK( IL ), LDWRKL )
               CALL DGEMM( 'N', 'N', M, N, M, ONE, WORK( IL ), LDWRKL,
     $                     A, LDA, ZERO, VT, LDVT )
*
            ELSE IF( WNTQA ) THEN
*
*              Path 4t (N much larger than M, JOBZ='A')
*              N right singular vectors to be computed in VT and
*              M left singular vectors to be computed in U
*
               IVT = 1
*
*              WORK(IVT) is M by M
*
               LDWKVT = M
               ITAU = IVT + LDWKVT*M
               NWORK = ITAU + M
*
*              Compute A=L*Q, copying result to VT
*              (Workspace: need M*M+2*M, prefer M*M+M+M*NB)
*
               CALL DGELQF( M, N, A, LDA, WORK( ITAU ), WORK( NWORK ),
     $                      LWORK-NWORK+1, IERR )
               CALL DLACPY( 'U', M, N, A, LDA, VT, LDVT )
*
*              Generate Q in VT
*              (Workspace: need M*M+2*M, prefer M*M+M+M*NB)
*
               CALL DORGLQ( N, N, M, VT, LDVT, WORK( ITAU ),
     $                      WORK( NWORK ), LWORK-NWORK+1, IERR )
*
*              Produce L in A, zeroing out other entries
*
               CALL DLASET( 'U', M-1, M-1, ZERO, ZERO, A( 1, 2 ), LDA )
               IE = ITAU
               ITAUQ = IE + M
               ITAUP = ITAUQ + M
               NWORK = ITAUP + M
*
*              Bidiagonalize L in A
*              (Workspace: need M*M+4*M, prefer M*M+3*M+2*M*NB)
*
               CALL DGEBRD( M, M, A, LDA, S, WORK( IE ), WORK( ITAUQ ),
     $                      WORK( ITAUP ), WORK( NWORK ), LWORK-NWORK+1,
     $                      IERR )
*
*              Perform bidiagonal SVD, computing left singular vectors
*              of bidiagonal matrix in U and computing right singular
*              vectors of bidiagonal matrix in WORK(IVT)
*              (Workspace: need M+M*M+BDSPAC)
*
               CALL DBDSDC( 'U', 'I', M, S, WORK( IE ), U, LDU,
     $                      WORK( IVT ), LDWKVT, DUM, IDUM,
     $                      WORK( NWORK ), IWORK, INFO )
*
*              Overwrite U by left singular vectors of L and WORK(IVT)
*              by right singular vectors of L
*              (Workspace: need M*M+3*M, prefer M*M+2*M+M*NB)
*
               CALL DORMBR( 'Q', 'L', 'N', M, M, M, A, LDA,
     $                      WORK( ITAUQ ), U, LDU, WORK( NWORK ),
     $                      LWORK-NWORK+1, IERR )
               CALL DORMBR( 'P', 'R', 'T', M, M, M, A, LDA,
     $                      WORK( ITAUP ), WORK( IVT ), LDWKVT,
     $                      WORK( NWORK ), LWORK-NWORK+1, IERR )
*
*              Multiply right singular vectors of L in WORK(IVT) by
*              Q in VT, storing result in A
*              (Workspace: need M*M)
*
               CALL DGEMM( 'N', 'N', M, N, M, ONE, WORK( IVT ), LDWKVT,
     $                     VT, LDVT, ZERO, A, LDA )
*
*              Copy right singular vectors of A from A to VT
*
               CALL DLACPY( 'F', M, N, A, LDA, VT, LDVT )
*
            END IF
*
         ELSE
*
*           N .LT. MNTHR
*
*           Path 5t (N greater than M, but not much larger)
*           Reduce to bidiagonal form without LQ decomposition
*
            IE = 1
            ITAUQ = IE + M
            ITAUP = ITAUQ + M
            NWORK = ITAUP + M
*
*           Bidiagonalize A
*           (Workspace: need 3*M+N, prefer 3*M+(M+N)*NB)
*
            CALL DGEBRD( M, N, A, LDA, S, WORK( IE ), WORK( ITAUQ ),
     $                   WORK( ITAUP ), WORK( NWORK ), LWORK-NWORK+1,
     $                   IERR )
            IF( WNTQN ) THEN
*
*              Perform bidiagonal SVD, only computing singular values
*              (Workspace: need M+BDSPAC)
*
               CALL DBDSDC( 'L', 'N', M, S, WORK( IE ), DUM, 1, DUM, 1,
     $                      DUM, IDUM, WORK( NWORK ), IWORK, INFO )
            ELSE IF( WNTQO ) THEN
               LDWKVT = M
               IVT = NWORK
               IF( LWORK.GE.M*N+3*M+BDSPAC ) THEN
*
*                 WORK( IVT ) is M by N
*
                  CALL DLASET( 'F', M, N, ZERO, ZERO, WORK( IVT ),
     $                         LDWKVT )
                  NWORK = IVT + LDWKVT*N
               ELSE
*
*                 WORK( IVT ) is M by M
*
                  NWORK = IVT + LDWKVT*M
                  IL = NWORK
*
*                 WORK(IL) is M by CHUNK
*
                  CHUNK = ( LWORK-M*M-3*M ) / M
               END IF
*
*              Perform bidiagonal SVD, computing left singular vectors
*              of bidiagonal matrix in U and computing right singular
*              vectors of bidiagonal matrix in WORK(IVT)
*              (Workspace: need M*M+BDSPAC)
*
               CALL DBDSDC( 'L', 'I', M, S, WORK( IE ), U, LDU,
     $                      WORK( IVT ), LDWKVT, DUM, IDUM,
     $                      WORK( NWORK ), IWORK, INFO )
*
*              Overwrite U by left singular vectors of A
*              (Workspace: need M*M+2*M, prefer M*M+M+M*NB)
*
               CALL DORMBR( 'Q', 'L', 'N', M, M, N, A, LDA,
     $                      WORK( ITAUQ ), U, LDU, WORK( NWORK ),
     $                      LWORK-NWORK+1, IERR )
*
               IF( LWORK.GE.M*N+3*M+BDSPAC ) THEN
*
*                 Overwrite WORK(IVT) by left singular vectors of A
*                 (Workspace: need M*M+2*M, prefer M*M+M+M*NB)
*
                  CALL DORMBR( 'P', 'R', 'T', M, N, M, A, LDA,
     $                         WORK( ITAUP ), WORK( IVT ), LDWKVT,
     $                         WORK( NWORK ), LWORK-NWORK+1, IERR )
*
*                 Copy right singular vectors of A from WORK(IVT) to A
*
                  CALL DLACPY( 'F', M, N, WORK( IVT ), LDWKVT, A, LDA )
               ELSE
*
*                 Generate P**T in A
*                 (Workspace: need M*M+2*M, prefer M*M+M+M*NB)
*
                  CALL DORGBR( 'P', M, N, M, A, LDA, WORK( ITAUP ),
     $                         WORK( NWORK ), LWORK-NWORK+1, IERR )
*
*                 Multiply Q in A by right singular vectors of
*                 bidiagonal matrix in WORK(IVT), storing result in
*                 WORK(IL) and copying to A
*                 (Workspace: need 2*M*M, prefer M*M+M*N)
*
                  DO 40 I = 1, N, CHUNK
                     BLK = MIN( N-I+1, CHUNK )
                     CALL DGEMM( 'N', 'N', M, BLK, M, ONE, WORK( IVT ),
     $                           LDWKVT, A( 1, I ), LDA, ZERO,
     $                           WORK( IL ), M )
                     CALL DLACPY( 'F', M, BLK, WORK( IL ), M, A( 1, I ),
     $                            LDA )
   40             CONTINUE
               END IF
            ELSE IF( WNTQS ) THEN
*
*              Perform bidiagonal SVD, computing left singular vectors
*              of bidiagonal matrix in U and computing right singular
*              vectors of bidiagonal matrix in VT
*              (Workspace: need M+BDSPAC)
*
               CALL DLASET( 'F', M, N, ZERO, ZERO, VT, LDVT )
               CALL DBDSDC( 'L', 'I', M, S, WORK( IE ), U, LDU, VT,
     $                      LDVT, DUM, IDUM, WORK( NWORK ), IWORK,
     $                      INFO )
*
*              Overwrite U by left singular vectors of A and VT
*              by right singular vectors of A
*              (Workspace: need 3*M, prefer 2*M+M*NB)
*
               CALL DORMBR( 'Q', 'L', 'N', M, M, N, A, LDA,
     $                      WORK( ITAUQ ), U, LDU, WORK( NWORK ),
     $                      LWORK-NWORK+1, IERR )
               CALL DORMBR( 'P', 'R', 'T', M, N, M, A, LDA,
     $                      WORK( ITAUP ), VT, LDVT, WORK( NWORK ),
     $                      LWORK-NWORK+1, IERR )
            ELSE IF( WNTQA ) THEN
*
*              Perform bidiagonal SVD, computing left singular vectors
*              of bidiagonal matrix in U and computing right singular
*              vectors of bidiagonal matrix in VT
*              (Workspace: need M+BDSPAC)
*
               CALL DLASET( 'F', N, N, ZERO, ZERO, VT, LDVT )
               CALL DBDSDC( 'L', 'I', M, S, WORK( IE ), U, LDU, VT,
     $                      LDVT, DUM, IDUM, WORK( NWORK ), IWORK,
     $                      INFO )
*
*              Set the right corner of VT to identity matrix
*
               CALL DLASET( 'F', N-M, N-M, ZERO, ONE, VT( M+1, M+1 ),
     $                      LDVT )
*
*              Overwrite U by left singular vectors of A and VT
*              by right singular vectors of A
*              (Workspace: need 2*M+N, prefer 2*M+N*NB)
*
               CALL DORMBR( 'Q', 'L', 'N', M, M, N, A, LDA,
     $                      WORK( ITAUQ ), U, LDU, WORK( NWORK ),
     $                      LWORK-NWORK+1, IERR )
               CALL DORMBR( 'P', 'R', 'T', N, N, M, A, LDA,
     $                      WORK( ITAUP ), VT, LDVT, WORK( NWORK ),
     $                      LWORK-NWORK+1, IERR )
            END IF
*
         END IF
*
      END IF
*
*     Undo scaling if necessary
*
      IF( ISCL.EQ.1 ) THEN
         IF( ANRM.GT.BIGNUM )
     $      CALL DLASCL( 'G', 0, 0, BIGNUM, ANRM, MINMN, 1, S, MINMN,
     $                   IERR )
         IF( ANRM.LT.SMLNUM )
     $      CALL DLASCL( 'G', 0, 0, SMLNUM, ANRM, MINMN, 1, S, MINMN,
     $                   IERR )
      END IF
*
*     Return optimal workspace in WORK(1)
*
      WORK( 1 ) = DBLE( MAXWRK )
*
      RETURN
*
*     End of DGESDD
*
      END

C
C $Id: clset.f,v 1.6 2008-07-27 00:17:25 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CLSET (Z,MX,NX,NY,CHI,CLO,CINC,NLA,NLM,CL,NCL,ICNST,
     1                  IOFFP,SPVAL,BIGEST)
      DIMENSION       Z(MX,NY)   ,CL(NLM)
      DATA KK/0/
C
C CLSET PUTS THE VALUS OF THE CONTOUR LEVELS IN CL
C
      ICNST = 0
      GLO = CLO
      HA = CHI
      FANC = CINC
      CRAT = NLA
      IF (HA-GLO)  10, 20, 50
   10 GLO = HA
      HA = CLO
      GO TO  50
   20 GLO = BIGEST
      HA = -GLO
      DO  40 J=1,NY
         DO  30 I=1,NX
            IF (IOFFP.EQ.1 .AND. Z(I,J).EQ.SPVAL) GO TO  30
            GLO = MIN(Z(I,J),GLO)
            HA = MAX(Z(I,J),HA)
   30    CONTINUE
   40 CONTINUE
   50 IF (FANC)  60, 70, 90
   60 CRAT = -FANC
   70 FANC = (HA-GLO)/CRAT
      IF (FANC) 140,140, 80
   80 P = 10.**(INT(ALOG10(FANC)+500.)-500)
      FANC = REAL(INT(FANC/P))*P
   90 IF (CHI-CLO) 110,100,110
  100 GLO = REAL(INT(GLO/FANC))*FANC
      HA = REAL(INT(HA/FANC))*FANC
  110 DO 120 K=1,NLM
         CC = GLO+REAL(K-1)*FANC
         IF (CC .GT. HA) GO TO 130
         KK = K
         CL(K) = CC
  120 CONTINUE
  130 NCL = KK
      RETURN
  140 ICNST = 1
      RETURN
      END

C     SUBROUTINE CFFTI(N,WSAVE)
C
C     SUBROUTINE CFFTI INITIALIZES THE ARRAY WSAVE WHICH IS USED IN
C     BOTH CFFTF AND CFFTB. THE PRIME FACTORIZATION OF N TOGETHER WITH
C     A TABULATION OF THE TRIGONOMETRIC FUNCTIONS ARE COMPUTED AND
C     STORED IN WSAVE.
C
C     INPUT PARAMETER
C
C     N       THE LENGTH OF THE SEQUENCE TO BE TRANSFORMED
C
C     OUTPUT PARAMETER
C
C     WSAVE   A WORK ARRAY WHICH MUST BE DIMENSIONED AT LEAST 4*N+15
C             THE SAME WORK ARRAY CAN BE USED FOR BOTH CFFTF AND CFFTB
C             AS LONG AS N REMAINS UNCHANGED. DIFFERENT WSAVE ARRAYS
C             ARE REQUIRED FOR DIFFERENT VALUES OF N. THE CONTENTS OF
C             WSAVE MUST NOT BE CHANGED BETWEEN CALLS OF CFFTF OR CFFTB.
C
      SUBROUTINE CFFTI(N,WSAVE)
      DOUBLE PRECISION WSAVE
      DIMENSION WSAVE(*)
C
      IF (N.EQ.1) RETURN
      IW1 = N + N + 1
      IW2 = IW1 + N + N
      CALL CFFTI1(N,WSAVE(IW1),WSAVE(IW2))
      RETURN
      END

C
C	$Id: pltclp.f,v 1.5 2008-07-27 00:59:05 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE PLTCLP(X, Y, PEN, IOS, STATUS)
C
C  Send line segments to the device line drawer, clip if necessary.
C
C  INPUT
C    X   - The X VDC
C    Y   - The Y VDC
C    PEN - The MOVE/DRAW flag
C
C  OUTPUT
C    IOS    - The I/O status, valid only if STATUS set to I/O error
C    STATUS - The error status of the request
C
      COMMON /PGKSCOM/ CLPDAT, CLPFLG, POLIDX, LINTYP, LINWTH, LINCOL,
     1                LINRGB, MARIDX, MARSIZ, MARCOL, MARRGB, TXTIDX,
     2                INTSTL, PATIDX, FILCOL, FILRGB, MARTYP, HORIZ ,
     3                VERT  , PATH  , CHIGHT, XU    , YU    , XB    ,
     4                YB    , TXTCOL, FINDEX, CEXPN , CSPACE, CURIDX,
     5                CURIMP, CURINT, COLMOD, FILIDX, TXTRGB, PROPN ,
     6                FIRSTX, FIRSTY, LASTX , LASTY , TRATIO, CBV   ,
     7                CUV   , CHP   , CVP   , CCSPAC, CHHORZ, CDV   ,
     8                PMRSIZ, CLPX  , CLPY  , CLPP  , DEFREP, DEFLEN,
     9                VDCECR, TRANVN, TXTPRE, HATIDX, FILRPT, ASFSRF,
     A                ASFSDF, MAPMOD, VERSOK, PCBFST, CPGLEN, CLPNUL,
     B                MTDLEN
      INTEGER         CMPMAX, ASFMAX
      PARAMETER      (CMPMAX=256    , ASFMAX=18)
      LOGICAL         CLPFLG, PROPN , CHHORZ, DEFREP, CLPNUL, MAPMOD,
     1                VERSOK, PCBFST
      REAL            LINWTH, MARSIZ, CEXPN , CSPACE, TRATIO, CBV(2),
     1                CUV(2), CDV(2), CCSPAC
      INTEGER         CLPDAT(4)     , POLIDX, LINTYP, LINCOL, LINRGB(3),
     1                MARIDX, MARCOL, MARRGB(3)     , TXTIDX, INTSTL,
     2                PATIDX, FILCOL, FILRGB(3)     , MARTYP, HORIZ ,
     3                VERT  , PATH  , XU    , YU    , XB    , YB    ,
     4                TXTCOL, FINDEX, CURIMP(CMPMAX), CURINT(CMPMAX*3),
     5                CHIGHT, COLMOD, FILIDX, TXTRGB(3)     , CURIDX,
     6                FIRSTX, FIRSTY, LASTX , LASTY , CHP   , CVP   ,
     7                PMRSIZ, CLPX  , CLPY  , CLPP  , DEFLEN, TRANVN,
     8                TXTPRE, HATIDX, FILRPT(2)     , VDCECR(4)     ,
     9                ASFSRF(ASFMAX), ASFSDF(ASFMAX), CPGLEN, MTDLEN
      COMMON /GKSCHR/ MTDESC
      CHARACTER*80    MTDESC
      COMMON/TREROR/ ALLOK, MFRCHK, MTOPER, METRDC, REDERR, TYPCHG
     1             ,INVTYP, MINVLD, TYPERR, FRMEND, ENCINT, IVDCDT
     2             ,GCOERR, GCRERR, GCCERR, FCOERR, FCRERR, FCCERR
     3             ,PLIDXG, PMIDXG, TXIDXG, PGIDXG, INVLMT, CELERR
     4             ,COIERR, COLNRM, UNKNOW, UNKOPC, ENDMTF, VNEROR
     5             ,BADRSZ, DEVOUT, NOVERS, BADFNT, PGMERR, FASERR
     6             ,HINERR, VDWERR, RDWERR, RIXLIM
      INTEGER        ALLOK, MFRCHK, MTOPER, METRDC, REDERR, TYPCHG
     1             ,INVTYP, MINVLD, TYPERR, FRMEND, ENCINT, IVDCDT
     2             ,GCOERR, GCRERR, GCCERR, FCOERR, FCRERR, FCCERR
     3             ,PLIDXG, PMIDXG, TXIDXG, PGIDXG, INVLMT, CELERR
     4             ,COIERR, COLNRM, UNKNOW, UNKOPC, ENDMTF, VNEROR
     5             ,BADRSZ, DEVOUT, NOVERS, BADFNT, PGMERR, FASERR
     6             ,HINERR, VDWERR, RDWERR, RIXLIM
      COMMON /TRTYPE/ METMIN, METEXT, METPRT, METHED, MIOPCL, MXOPCL,
     1                MIOPID, MXOPID, ASCDEC, ASCHEX, ASCOCT, BINARY,
     2                GAHNOR, GALEFT, GACENT, GARITE, GAVNOR, GATOP ,
     3                GACAP , GAHALF, GABASE, GABOTT, GRIGHT, GLEFT ,
     4                GUP   ,
     5                GDOWN , CINDEX, CDIRCT, PENUP , PENDN , FLAGVL,
     6                SEPRVL, ASCTEK, TYPRGB, TYPBGR,
     7                TYPHLS, TYPMON, SOLID , DASHED, INVSBL, SOLPAT,
     8                ASFIND, ASFBND, ASFLNT, ASFLNW, ASFLNC, ASFMRT,
     9                ASFMRS, ASFMRC, ASFFIS, ASFFHI, ASFFPI, ASFFCO,
     A                ASFFPT, ASFFPW, ASFFPC, ASFTFI, ASFTPR, ASFTCX,
     B                ASFTCS, ASFTCO, ASCFLT, PHOLLO, PSOLID, PPATTR,
     C                PHATCH, PEMPTY, HHORIZ, HVERTI, HPOSLP, HNESLP,
     D                HHOAVE, HPOANE
      INTEGER         METMIN, METEXT, METPRT, METHED, MIOPCL, MXOPCL,
     1                MIOPID, MXOPID, ASCDEC, ASCHEX, ASCOCT, BINARY,
     2                GAHNOR, GALEFT, GACENT, GARITE, GAVNOR, GATOP ,
     3                GACAP , GAHALF, GABASE, GABOTT, GRIGHT, GLEFT ,
     4                GUP   ,
     5                GDOWN , CINDEX, CDIRCT, PENUP , PENDN , FLAGVL,
     6                SEPRVL, ASCTEK, TYPRGB, TYPBGR,
     7                TYPHLS, TYPMON, SOLID , DASHED, INVSBL, SOLPAT,
     8                ASFIND, ASFBND, ASFLNT, ASFLNW, ASFLNC, ASFMRT,
     9                ASFMRS, ASFMRC, ASFFIS, ASFFHI, ASFFPI, ASFFCO,
     A                ASFFPT, ASFFPW, ASFFPC, ASFTFI, ASFTPR, ASFTCX,
     B                ASFTCS, ASFTCO, ASCFLT, PHOLLO, PSOLID, PPATTR,
     C                PHATCH, PEMPTY, HHORIZ, HVERTI, HPOSLP, HNESLP,
     D                HHOAVE, HPOANE
      COMMON /CAPSPC/ DUMSPC,ENDDSP
      INTEGER     DUMSIZ,DUMSM1
      PARAMETER (DUMSIZ=327, DUMSM1=DUMSIZ-1)
      INTEGER     DUMSPC(DUMSM1),ENDDSP
      COMMON /CAPDEV/ DGISTR, DGISIZ, DGESTR, DGESIZ, DTISTR,
     1                DTISIZ, DCDLLX, DCDLLY, DCDURX, DCDURY,
     3                DCOAVL, CORFMT, CORFIN, BATCH , DHCSIZ,
     4                DHCSTR, CORXOF, CORYOF, DASBIT, CORXSC,
     5                CORYSC, VDWLLX, VDWLLY, VDWURX, VDWURY
      INTEGER         DGIMAX, DGEMAX, DTIMAX, DCFTMX, DHCMAX
      PARAMETER   (DGIMAX=300, DGEMAX=150, DTIMAX=100)
      PARAMETER   (DCFTMX=30 , DHCMAX=50)
      INTEGER         DGISTR(DGIMAX), DGISIZ, DGESTR(DGEMAX),
     1                DGESIZ, DTISTR(DTIMAX), DTISIZ, DCDLLX,
     2                DCDLLY, DCDURX, DCDURY, CORFMT(DCFTMX,4),
     3                CORFIN(8)     , DHCSIZ, DHCSTR(DHCMAX),
     4                CORXOF, CORYOF, DASBIT, VDWLLX, VDWLLY,
     5                VDWURX, VDWURY
      REAL            CORXSC, CORYSC, CORRIN(8)
      LOGICAL         DCOAVL, BATCH
C  Size of the COMMON
      INTEGER         LENDEV
      PARAMETER   (LENDEV=DGIMAX+1+DGEMAX+1+DTIMAX+1+4+1+4*DCFTMX+
     1                  8+2+DHCMAX+9)
      EQUIVALENCE (CORFIN,CORRIN)
C
      INTEGER X, Y, PEN, IOS, STATUS
C
      INTEGER XIN(2), YIN(2), XOUT(2), YOUT(2), OLDCLP(4)
      LOGICAL DRAW
C
C  Test for clipping.
C
      IF (.NOT.CLPFLG) THEN
C
C  Clip to the virtrtual device window.
C
        OLDCLP(1) = CLPDAT(1)
        OLDCLP(2) = CLPDAT(2)
        OLDCLP(3) = CLPDAT(3)
        OLDCLP(4) = CLPDAT(4)
        CLPDAT(1) = VDWLLX
        CLPDAT(2) = VDWLLY
        CLPDAT(3) = VDWURX
        CLPDAT(4) = VDWURY
      ENDIF
C
C  Clipping -- if MOVE, then update pointers and exit.
C
        IF (PEN .EQ. PENUP) THEN
          CLPX = X
          CLPY = Y
          CLPP = PENUP
        ELSE
C
C  Clipping and drawing, so clip the line.
C
          XIN(2) = X
          YIN(2) = Y
          XIN(1) = CLPX
          YIN(1) = CLPY
          CALL CLIPIT (XIN, YIN, XOUT, YOUT, DRAW)
          IF (.NOT. DRAW) THEN
C
C  Not visible, so update segment start and return.
C
            CLPX = X
            CLPY = Y
            CLPP = PENUP
          ELSE
C
C  Some of the clipped line is visible.
C
            IF ((CLPP.EQ.PENUP) .OR.
     1          (CLPX.NE.XOUT(1)) .OR. (CLPY.NE.YOUT(1))) THEN
C
C  Move to the old point.
C
              CALL PLTIT(XOUT(1),YOUT(1),PENUP,IOS,STATUS)
              IF (STATUS.NE.ALLOK) RETURN
C
C  Draw new point.
C
              CALL PLTIT (XOUT(2),YOUT(2),PENDN,IOS,STATUS)
              CLPX = X
              CLPY = Y
              CLPP = PENDN
            ELSE
C
C  No clipping for this segment.
C
              CALL PLTIT (XOUT(2),YOUT(2),PENDN,IOS,STATUS)
              CLPX = X
              CLPY = Y
              CLPP = PENDN
            END IF
          END IF
        END IF
C
C  Restore clipping rectangle to the original if clipping is off.
C
      IF (.NOT.CLPFLG) THEN
C
C  Clip to the virtrtual device window.
C
        CLPDAT(1) = OLDCLP(1)
        CLPDAT(2) = OLDCLP(2)
        CLPDAT(3) = OLDCLP(3)
        CLPDAT(4) = OLDCLP(4)
      ENDIF
C
      RETURN
      END

C
C	$Id: csdelarc.f,v 1.5 2008-07-27 03:10:06 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CSDELARC (N,IO1,IO2, LIST,LPTR,LEND,
     .                   LNEW, IER)
      INTEGER N, IO1, IO2, LIST(*), LPTR(*), LEND(N), LNEW,
     .        IER
C
C***********************************************************
C
C                                              From STRIPACK
C                                            Robert J. Renka
C                                  Dept. of Computer Science
C                                       Univ. of North Texas
C                                           renka@cs.unt.edu
C                                                   07/17/96
C
C   This subroutine deletes a boundary arc from a triangula-
C tion.  It may be used to remove a null triangle from the
C convex hull boundary.  Note, however, that if the union of
C triangles is rendered nonconvex, Subroutines CSDELNOD, CSEDGE,
C and CSTRFIND (and hence CSADDNOD) may fail.  Also, Function
C CSNEARND should not be called following an arc deletion.
C
C   This routine is identical to the similarly named routine
C in TRIPACK.
C
C
C On input:
C
C       N = Number of nodes in the triangulation.  N .GE. 4.
C
C       IO1,IO2 = Indexes (in the range 1 to N) of a pair of
C                 adjacent boundary nodes defining the arc
C                 to be removed.
C
C The above parameters are not altered by this routine.
C
C       LIST,LPTR,LEND,LNEW = Triangulation data structure
C                             created by Subroutine CSTRMESH.
C
C On output:
C
C       LIST,LPTR,LEND,LNEW = Data structure updated with
C                             the removal of arc IO1-IO2
C                             unless IER > 0.
C
C       IER = Error indicator:
C             IER = 0 if no errors were encountered.
C             IER = 1 if N, IO1, or IO2 is outside its valid
C                     range, or IO1 = IO2.
C             IER = 2 if IO1-IO2 is not a boundary arc.
C             IER = 3 if the node opposite IO1-IO2 is al-
C                     ready a boundary node, and thus IO1
C                     or IO2 has only two neighbors or a
C                     deletion would result in two triangu-
C                     lations sharing a single node.
C             IER = 4 if one of the nodes is a neighbor of
C                     the other, but not vice versa, imply-
C                     ing an invalid triangulation data
C                     structure.
C
C Module required by CSDELARC:  CSDELNB, CSLSTPTR
C
C Intrinsic function called by CSDELARC:  ABS
C
C***********************************************************
C
      INTEGER CSLSTPTR
      INTEGER LP, LPH, LPL, N1, N2, N3
C
C Local parameters:
C
C LP =       LIST pointer
C LPH =      LIST pointer or flag returned by CSDELNB
C LPL =      Pointer to the last neighbor of N1, N2, or N3
C N1,N2,N3 = Nodal indexes of a triangle such that N1->N2
C              is the directed boundary edge associated
C              with IO1-IO2
C
      N1 = IO1
      N2 = IO2
C
C Test for errors, and set N1->N2 to the directed boundary
C   edge associated with IO1-IO2:  (N1,N2,N3) is a triangle
C   for some N3.
C
      IF (N .LT. 4  .OR.  N1 .LT. 1  .OR.  N1 .GT. N  .OR.
     .    N2 .LT. 1  .OR.  N2 .GT. N  .OR.  N1 .EQ. N2) THEN
        IER = 1
        RETURN
      ENDIF
C
      LPL = LEND(N2)
      IF (-LIST(LPL) .NE. N1) THEN
        N1 = N2
        N2 = IO1
        LPL = LEND(N2)
        IF (-LIST(LPL) .NE. N1) THEN
          IER = 2
          RETURN
        ENDIF
      ENDIF
C
C Set N3 to the node opposite N1->N2 (the second neighbor
C   of N1), and test for error 3 (N3 already a boundary
C   node).
C
      LPL = LEND(N1)
      LP = LPTR(LPL)
      LP = LPTR(LP)
      N3 = ABS(LIST(LP))
      LPL = LEND(N3)
      IF (LIST(LPL) .LE. 0) THEN
        IER = 3
        RETURN
      ENDIF
C
C Delete N2 as a neighbor of N1, making N3 the first
C   neighbor, and test for error 4 (N2 not a neighbor
C   of N1).  Note that previously computed pointers may
C   no longer be valid following the call to CSDELNB.
C
      CALL CSDELNB (N1,N2,N, LIST,LPTR,LEND,LNEW, LPH)
      IF (LPH .LT. 0) THEN
        IER = 4
        RETURN
      ENDIF
C
C Delete N1 as a neighbor of N2, making N3 the new last
C   neighbor.
C
      CALL CSDELNB (N2,N1,N, LIST,LPTR,LEND,LNEW, LPH)
C
C Make N3 a boundary node with first neighbor N2 and last
C   neighbor N1.
C
      LP = CSLSTPTR(LEND(N3),N1,LIST,LPTR)
      LEND(N3) = LP
      LIST(LP) = -N1
C
C No errors encountered.
C
      IER = 0
      RETURN
      END

C
C	$Id: gswkvp.f,v 1.5 2008-07-27 00:21:02 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GSWKVP (WKID,XMIN,XMAX,YMIN,YMAX)
C
C  SET WORKSTATION VIEWPORT
C
      INTEGER ESWKVP
      PARAMETER (ESWKVP=55)
C
      include 'gkscom.h'
C
      INTEGER WKID
C
C  Check if GKS is in the proper state.
C
      CALL GZCKST(7,ESWKVP,IER)
      IF (IER .NE. 0) RETURN
C
C  Check if workstation identifier is valid.
C
      CALL GZCKWK(20,ESWKVP,WKID,IDUM,IER)
      IF (IER .NE. 0) RETURN
C
C  Check if the specified workstation is open.
C
      CALL GZCKWK(25,ESWKVP,WKID,IDUM,IER)
      IF (IER .NE. 0) RETURN
C
C  Check that the rectangle definition is valid.
C
      IF (XMAX.LE.XMIN .OR. YMAX.LE.YMIN) THEN
        ERS = 1
        CALL GERHND(51,ESWKVP,ERF)
        ERS = 0
        RETURN
      ENDIF
C
C  Invoke the workstation interface.
C
C  Set the flag CUFLAG to indicate that the interface call should go
C  only to the specifically designated workstation.
C
      CUFLAG = WKID
      FCODE = 72
      CONT  = 0
      CALL GZROI(0)
      IL1  = 1
      IL2  = 1
      ID(1) = WKID
      RL1 = 2
      RL2 = 2
      RX(1) = XMIN
      RX(2) = XMAX
      RY(1) = YMIN
      RY(2) = YMAX
      CALL GZTOWK
      CUFLAG = -1
      IF (RERR .NE. 0) THEN
        ERS = 1
        CALL GERHND(RERR,ESWKVP,ERF)
        ERS = 0
      ENDIF
C
      RETURN
      END

      PROGRAM AGEX08
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Define the data arrays.
C
      REAL XDRA(101),YDRA(4,101)
C
C Initialize GKS.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Fill the data arrays.
C
      DO 101 I=1,101
        XDRA(I)=-3.14159265358979+
     +            .062831853071796*REAL(I-1)
  101 CONTINUE
C
      DO 103 I=1,4
        FLTI=I
        BASE=2.*FLTI-1.
        DO 102 J=1,101
          YDRA(I,J)=BASE+.75*SIN(-3.14159265358979+
     +             .062831853071796*FLTI*REAL(J-1))
  102   CONTINUE
  103 CONTINUE
C
C Change the line-end character to a period.
C
      CALL AGSETC ('LINE/END.','.')
C
C Specify labels for x and y axes.
C
      CALL ANOTAT ('SINE FUNCTIONS OF T.','T.',0,0,0,' ')
C
C Use a half-axis background.
C
      CALL AGSETI ('BACKGROUND.',3)
C
C Move x axis to the zero point on the y axis.
C
      CALL AGSETF ('BOTTOM/INTERSECTION/USER.',0.)
C
C Specify base value for spacing of major ticks on x axis.
C
      CALL AGSETF ('BOTTOM/MAJOR/BASE.',1.)
C
C Run major ticks on x axis to edge of curve window.
C
      CALL AGSETF ('BOTTOM/MAJOR/INWARD.',1.)
      CALL AGSETF ('BOTTOM/MAJOR/OUTWARD.',1.)
C
C Position x axis minor ticks.
C
      CALL AGSETI ('BOTTOM/MINOR/SPACING.',9)
C
C Run the y axis backward.
C
      CALL AGSETI ('Y/ORDER.',1)
C
C Run plots full-scale in y.
C
      CALL AGSETI ('Y/NICE.',0)
C
C Have AUTOGRAPH scale x and y data the same.
C
      CALL AGSETF ('GRID/SHAPE.',.01)
C
C Use the alphabetic set of dashed-line patterns.
C
      CALL AGSETI ('DASH/SELECTOR.',-1)
C
C Tell AUTOGRAPH how the data arrays are dimensioned.
C
      CALL AGSETI ('ROW.',-1)
C
C Reverse the roles of the x and y arrays.
C
      CALL AGSETI ('INVERT.',1)
C
C Draw a boundary around the edge of the plotter frame.
C
      CALL BNDARY
C
C Draw the curves.
C
      CALL EZMXY (XDRA,YDRA,4,4,101,'EXAMPLE 8.')
C
C Close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
C
      END
      SUBROUTINE BNDARY
C
C Routine to draw the plotter-frame edge.
C
      CALL PLOTIT (    0,    0,0)
      CALL PLOTIT (32767,    0,1)
      CALL PLOTIT (32767,32767,1)
      CALL PLOTIT (    0,32767,1)
      CALL PLOTIT (    0,    0,1)
      RETURN
      END

      SUBROUTINE SGGLSE( M, N, P, A, LDA, B, LDB, C, D, X, WORK, LWORK,
     $                   INFO )
*
*  -- LAPACK driver routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      INTEGER            INFO, LDA, LDB, LWORK, M, N, P
*     ..
*     .. Array Arguments ..
      REAL               A( LDA, * ), B( LDB, * ), C( * ), D( * ),
     $                   WORK( * ), X( * )
*     ..
*
*  Purpose
*  =======
*
*  SGGLSE solves the linear equality-constrained least squares (LSE)
*  problem:
*
*          minimize || c - A*x ||_2   subject to   B*x = d
*
*  where A is an M-by-N matrix, B is a P-by-N matrix, c is a given
*  M-vector, and d is a given P-vector. It is assumed that
*  P <= N <= M+P, and
*
*           rank(B) = P and  rank( ( A ) ) = N.
*                                ( ( B ) )
*
*  These conditions ensure that the LSE problem has a unique solution,
*  which is obtained using a GRQ factorization of the matrices B and A.
*
*  Arguments
*  =========
*
*  M       (input) INTEGER
*          The number of rows of the matrix A.  M >= 0.
*
*  N       (input) INTEGER
*          The number of columns of the matrices A and B. N >= 0.
*
*  P       (input) INTEGER
*          The number of rows of the matrix B. 0 <= P <= N <= M+P.
*
*  A       (input/output) REAL array, dimension (LDA,N)
*          On entry, the M-by-N matrix A.
*          On exit, A is destroyed.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A. LDA >= max(1,M).
*
*  B       (input/output) REAL array, dimension (LDB,N)
*          On entry, the P-by-N matrix B.
*          On exit, B is destroyed.
*
*  LDB     (input) INTEGER
*          The leading dimension of the array B. LDB >= max(1,P).
*
*  C       (input/output) REAL array, dimension (M)
*          On entry, C contains the right hand side vector for the
*          least squares part of the LSE problem.
*          On exit, the residual sum of squares for the solution
*          is given by the sum of squares of elements N-P+1 to M of
*          vector C.
*
*  D       (input/output) REAL array, dimension (P)
*          On entry, D contains the right hand side vector for the
*          constrained equation.
*          On exit, D is destroyed.
*
*  X       (output) REAL array, dimension (N)
*          On exit, X is the solution of the LSE problem.
*
*  WORK    (workspace/output) REAL array, dimension (LWORK)
*          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*
*  LWORK   (input) INTEGER
*          The dimension of the array WORK. LWORK >= max(1,M+N+P).
*          For optimum performance LWORK >= P+min(M,N)+max(M,N)*NB,
*          where NB is an upper bound for the optimal blocksizes for
*          SGEQRF, SGERQF, SORMQR and SORMRQ.
*
*          If LWORK = -1, then a workspace query is assumed; the routine
*          only calculates the optimal size of the WORK array, returns
*          this value as the first entry of the WORK array, and no error
*          message related to LWORK is issued by XERBLA.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit.
*          < 0:  if INFO = -i, the i-th argument had an illegal value.
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ONE
      PARAMETER          ( ONE = 1.0E+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            LQUERY
      INTEGER            LOPT, LWKOPT, MN, NB, NB1, NB2, NB3, NB4, NR
*     ..
*     .. External Subroutines ..
      EXTERNAL           SAXPY, SCOPY, SGEMV, SGGRQF, SORMQR, SORMRQ,
     $                   STRMV, STRSV, XERBLA
*     ..
*     .. External Functions ..
      INTEGER            ILAENV
      EXTERNAL           ILAENV 
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          INT, MAX, MIN
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters
*
      INFO = 0
      MN = MIN( M, N )
      NB1 = ILAENV( 1, 'SGEQRF', ' ', M, N, -1, -1 )
      NB2 = ILAENV( 1, 'SGERQF', ' ', M, N, -1, -1 )
      NB3 = ILAENV( 1, 'SORMQR', ' ', M, N, P, -1 )
      NB4 = ILAENV( 1, 'SORMRQ', ' ', M, N, P, -1 )
      NB = MAX( NB1, NB2, NB3, NB4 )
      LWKOPT = P + MN + MAX( M, N )*NB
      WORK( 1 ) = LWKOPT
      LQUERY = ( LWORK.EQ.-1 )
      IF( M.LT.0 ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( P.LT.0 .OR. P.GT.N .OR. P.LT.N-M ) THEN
         INFO = -3
      ELSE IF( LDA.LT.MAX( 1, M ) ) THEN
         INFO = -5
      ELSE IF( LDB.LT.MAX( 1, P ) ) THEN
         INFO = -7
      ELSE IF( LWORK.LT.MAX( 1, M+N+P ) .AND. .NOT.LQUERY ) THEN
         INFO = -12
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'SGGLSE', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
*
*     Compute the GRQ factorization of matrices B and A:
*
*            B*Q' = (  0  T12 ) P   Z'*A*Q' = ( R11 R12 ) N-P
*                     N-P  P                  (  0  R22 ) M+P-N
*                                               N-P  P
*
*     where T12 and R11 are upper triangular, and Q and Z are
*     orthogonal.
*
      CALL SGGRQF( P, M, N, B, LDB, WORK, A, LDA, WORK( P+1 ),
     $             WORK( P+MN+1 ), LWORK-P-MN, INFO )
      LOPT = WORK( P+MN+1 )
*
*     Update c = Z'*c = ( c1 ) N-P
*                       ( c2 ) M+P-N
*
      CALL SORMQR( 'Left', 'Transpose', M, 1, MN, A, LDA, WORK( P+1 ),
     $             C, MAX( 1, M ), WORK( P+MN+1 ), LWORK-P-MN, INFO )
      LOPT = MAX( LOPT, INT( WORK( P+MN+1 ) ) )
*
*     Solve T12*x2 = d for x2
*
      CALL STRSV( 'Upper', 'No transpose', 'Non unit', P, B( 1, N-P+1 ),
     $            LDB, D, 1 )
*
*     Update c1
*
      CALL SGEMV( 'No transpose', N-P, P, -ONE, A( 1, N-P+1 ), LDA, D,
     $            1, ONE, C, 1 )
*
*     Sovle R11*x1 = c1 for x1
*
      CALL STRSV( 'Upper', 'No transpose', 'Non unit', N-P, A, LDA, C,
     $            1 )
*
*     Put the solutions in X
*
      CALL SCOPY( N-P, C, 1, X, 1 )
      CALL SCOPY( P, D, 1, X( N-P+1 ), 1 )
*
*     Compute the residual vector:
*
      IF( M.LT.N ) THEN
         NR = M + P - N
         CALL SGEMV( 'No transpose', NR, N-M, -ONE, A( N-P+1, M+1 ),
     $               LDA, D( NR+1 ), 1, ONE, C( N-P+1 ), 1 )
      ELSE
         NR = P
      END IF
      CALL STRMV( 'Upper', 'No transpose', 'Non unit', NR,
     $            A( N-P+1, N-P+1 ), LDA, D, 1 )
      CALL SAXPY( NR, -ONE, D, 1, C( N-P+1 ), 1 )
*
*     Backward transformation x = Q'*x
*
      CALL SORMRQ( 'Left', 'Transpose', N, 1, P, B, LDB, WORK( 1 ), X,
     $             N, WORK( P+MN+1 ), LWORK-P-MN, INFO )
      WORK( 1 ) = P + MN + MAX( LOPT, INT( WORK( P+MN+1 ) ) )
*
      RETURN
*
*     End of SGGLSE
*
      END

      SUBROUTINE CTGSJA( JOBU, JOBV, JOBQ, M, P, N, K, L, A, LDA, B,
     $                   LDB, TOLA, TOLB, ALPHA, BETA, U, LDU, V, LDV,
     $                   Q, LDQ, WORK, NCYCLE, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          JOBQ, JOBU, JOBV
      INTEGER            INFO, K, L, LDA, LDB, LDQ, LDU, LDV, M, N,
     $                   NCYCLE, P
      REAL               TOLA, TOLB
*     ..
*     .. Array Arguments ..
      REAL               ALPHA( * ), BETA( * )
      COMPLEX            A( LDA, * ), B( LDB, * ), Q( LDQ, * ),
     $                   U( LDU, * ), V( LDV, * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  CTGSJA computes the generalized singular value decomposition (GSVD)
*  of two complex upper triangular (or trapezoidal) matrices A and B.
*
*  On entry, it is assumed that matrices A and B have the following
*  forms, which may be obtained by the preprocessing subroutine CGGSVP
*  from a general M-by-N matrix A and P-by-N matrix B:
*
*               N-K-L  K    L
*     A =    K ( 0    A12  A13 ) if M-K-L >= 0;
*            L ( 0     0   A23 )
*        M-K-L ( 0     0    0  )
*
*             N-K-L  K    L
*     A =  K ( 0    A12  A13 ) if M-K-L < 0;
*        M-K ( 0     0   A23 )
*
*             N-K-L  K    L
*     B =  L ( 0     0   B13 )
*        P-L ( 0     0    0  )
*
*  where the K-by-K matrix A12 and L-by-L matrix B13 are nonsingular
*  upper triangular; A23 is L-by-L upper triangular if M-K-L >= 0,
*  otherwise A23 is (M-K)-by-L upper trapezoidal.
*
*  On exit,
*
*         U'*A*Q = D1*( 0 R ),    V'*B*Q = D2*( 0 R ),
*
*  where U, V and Q are unitary matrices, Z' denotes the conjugate
*  transpose of Z, R is a nonsingular upper triangular matrix, and D1
*  and D2 are ``diagonal'' matrices, which are of the following
*  structures:
*
*  If M-K-L >= 0,
*
*                      K  L
*         D1 =     K ( I  0 )
*                  L ( 0  C )
*              M-K-L ( 0  0 )
*
*                     K  L
*         D2 = L   ( 0  S )
*              P-L ( 0  0 )
*
*                 N-K-L  K    L
*    ( 0 R ) = K (  0   R11  R12 ) K
*              L (  0    0   R22 ) L
*
*  where
*
*    C = diag( ALPHA(K+1), ... , ALPHA(K+L) ),
*    S = diag( BETA(K+1),  ... , BETA(K+L) ),
*    C**2 + S**2 = I.
*
*    R is stored in A(1:K+L,N-K-L+1:N) on exit.
*
*  If M-K-L < 0,
*
*                 K M-K K+L-M
*      D1 =   K ( I  0    0   )
*           M-K ( 0  C    0   )
*
*                   K M-K K+L-M
*      D2 =   M-K ( 0  S    0   )
*           K+L-M ( 0  0    I   )
*             P-L ( 0  0    0   )
*
*                 N-K-L  K   M-K  K+L-M
* ( 0 R ) =    K ( 0    R11  R12  R13  )
*            M-K ( 0     0   R22  R23  )
*          K+L-M ( 0     0    0   R33  )
*
*  where
*  C = diag( ALPHA(K+1), ... , ALPHA(M) ),
*  S = diag( BETA(K+1),  ... , BETA(M) ),
*  C**2 + S**2 = I.
*
*  R = ( R11 R12 R13 ) is stored in A(1:M, N-K-L+1:N) and R33 is stored
*      (  0  R22 R23 )
*  in B(M-K+1:L,N+M-K-L+1:N) on exit.
*
*  The computation of the unitary transformation matrices U, V or Q
*  is optional.  These matrices may either be formed explicitly, or they
*  may be postmultiplied into input matrices U1, V1, or Q1.
*
*  Arguments
*  =========
*
*  JOBU    (input) CHARACTER*1
*          = 'U':  U must contain a unitary matrix U1 on entry, and
*                  the product U1*U is returned;
*          = 'I':  U is initialized to the unit matrix, and the
*                  unitary matrix U is returned;
*          = 'N':  U is not computed.
*
*  JOBV    (input) CHARACTER*1
*          = 'V':  V must contain a unitary matrix V1 on entry, and
*                  the product V1*V is returned;
*          = 'I':  V is initialized to the unit matrix, and the
*                  unitary matrix V is returned;
*          = 'N':  V is not computed.
*
*  JOBQ    (input) CHARACTER*1
*          = 'Q':  Q must contain a unitary matrix Q1 on entry, and
*                  the product Q1*Q is returned;
*          = 'I':  Q is initialized to the unit matrix, and the
*                  unitary matrix Q is returned;
*          = 'N':  Q is not computed.
*
*  M       (input) INTEGER
*          The number of rows of the matrix A.  M >= 0.
*
*  P       (input) INTEGER
*          The number of rows of the matrix B.  P >= 0.
*
*  N       (input) INTEGER
*          The number of columns of the matrices A and B.  N >= 0.
*
*  K       (input) INTEGER
*  L       (input) INTEGER
*          K and L specify the subblocks in the input matrices A and B:
*          A23 = A(K+1:MIN(K+L,M),N-L+1:N) and B13 = B(1:L,,N-L+1:N)
*          of A and B, whose GSVD is going to be computed by CTGSJA.
*          See Further details.
*
*  A       (input/output) COMPLEX array, dimension (LDA,N)
*          On entry, the M-by-N matrix A.
*          On exit, A(N-K+1:N,1:MIN(K+L,M) ) contains the triangular
*          matrix R or part of R.  See Purpose for details.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A. LDA >= max(1,M).
*
*  B       (input/output) COMPLEX array, dimension (LDB,N)
*          On entry, the P-by-N matrix B.
*          On exit, if necessary, B(M-K+1:L,N+M-K-L+1:N) contains
*          a part of R.  See Purpose for details.
*
*  LDB     (input) INTEGER
*          The leading dimension of the array B. LDB >= max(1,P).
*
*  TOLA    (input) REAL
*  TOLB    (input) REAL
*          TOLA and TOLB are the convergence criteria for the Jacobi-
*          Kogbetliantz iteration procedure. Generally, they are the
*          same as used in the preprocessing step, say
*              TOLA = MAX(M,N)*norm(A)*MACHEPS,
*              TOLB = MAX(P,N)*norm(B)*MACHEPS.
*
*  ALPHA   (output) REAL array, dimension (N)
*  BETA    (output) REAL array, dimension (N)
*          On exit, ALPHA and BETA contain the generalized singular
*          value pairs of A and B;
*            ALPHA(1:K) = 1,
*            BETA(1:K)  = 0,
*          and if M-K-L >= 0,
*            ALPHA(K+1:K+L) = diag(C),
*            BETA(K+1:K+L)  = diag(S),
*          or if M-K-L < 0,
*            ALPHA(K+1:M)= C, ALPHA(M+1:K+L)= 0
*            BETA(K+1:M) = S, BETA(M+1:K+L) = 1.
*          Furthermore, if K+L < N,
*            ALPHA(K+L+1:N) = 0
*            BETA(K+L+1:N)  = 0.
*
*  U       (input/output) COMPLEX array, dimension (LDU,M)
*          On entry, if JOBU = 'U', U must contain a matrix U1 (usually
*          the unitary matrix returned by CGGSVP).
*          On exit,
*          if JOBU = 'I', U contains the unitary matrix U;
*          if JOBU = 'U', U contains the product U1*U.
*          If JOBU = 'N', U is not referenced.
*
*  LDU     (input) INTEGER
*          The leading dimension of the array U. LDU >= max(1,M) if
*          JOBU = 'U'; LDU >= 1 otherwise.
*
*  V       (input/output) COMPLEX array, dimension (LDV,P)
*          On entry, if JOBV = 'V', V must contain a matrix V1 (usually
*          the unitary matrix returned by CGGSVP).
*          On exit,
*          if JOBV = 'I', V contains the unitary matrix V;
*          if JOBV = 'V', V contains the product V1*V.
*          If JOBV = 'N', V is not referenced.
*
*  LDV     (input) INTEGER
*          The leading dimension of the array V. LDV >= max(1,P) if
*          JOBV = 'V'; LDV >= 1 otherwise.
*
*  Q       (input/output) COMPLEX array, dimension (LDQ,N)
*          On entry, if JOBQ = 'Q', Q must contain a matrix Q1 (usually
*          the unitary matrix returned by CGGSVP).
*          On exit,
*          if JOBQ = 'I', Q contains the unitary matrix Q;
*          if JOBQ = 'Q', Q contains the product Q1*Q.
*          If JOBQ = 'N', Q is not referenced.
*
*  LDQ     (input) INTEGER
*          The leading dimension of the array Q. LDQ >= max(1,N) if
*          JOBQ = 'Q'; LDQ >= 1 otherwise.
*
*  WORK    (workspace) COMPLEX array, dimension (2*N)
*
*  NCYCLE  (output) INTEGER
*          The number of cycles required for convergence.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value.
*          = 1:  the procedure does not converge after MAXIT cycles.
*
*  Internal Parameters
*  ===================
*
*  MAXIT   INTEGER
*          MAXIT specifies the total loops that the iterative procedure
*          may take. If after MAXIT cycles, the routine fails to
*          converge, we return INFO = 1.
*
*  Further Details
*  ===============
*
*  CTGSJA essentially uses a variant of Kogbetliantz algorithm to reduce
*  min(L,M-K)-by-L triangular (or trapezoidal) matrix A23 and L-by-L
*  matrix B13 to the form:
*
*           U1'*A13*Q1 = C1*R1; V1'*B13*Q1 = S1*R1,
*
*  where U1, V1 and Q1 are unitary matrix, and Z' is the conjugate
*  transpose of Z.  C1 and S1 are diagonal matrices satisfying
*
*                C1**2 + S1**2 = I,
*
*  and R1 is an L-by-L nonsingular upper triangular matrix.
*
*  =====================================================================
*
*     .. Parameters ..
      INTEGER            MAXIT
      PARAMETER          ( MAXIT = 40 )
      REAL               ZERO, ONE
      PARAMETER          ( ZERO = 0.0E+0, ONE = 1.0E+0 )
      COMPLEX            CZERO, CONE
      PARAMETER          ( CZERO = ( 0.0E+0, 0.0E+0 ),
     $                   CONE = ( 1.0E+0, 0.0E+0 ) )
*     ..
*     .. Local Scalars ..
*
      LOGICAL            INITQ, INITU, INITV, UPPER, WANTQ, WANTU, WANTV
      INTEGER            I, J, KCYCLE
      REAL               A1, A3, B1, B3, CSQ, CSU, CSV, ERROR, GAMMA,
     $                   RWK, SSMIN
      COMPLEX            A2, B2, SNQ, SNU, SNV
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           CCOPY, CLAGS2, CLAPLL, CLASET, CROT, CSSCAL,
     $                   SLARTG, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, CONJG, MAX, MIN, REAL
*     ..
*     .. Executable Statements ..
*
*     Decode and test the input parameters
*
      INITU = LSAME( JOBU, 'I' )
      WANTU = INITU .OR. LSAME( JOBU, 'U' )
*
      INITV = LSAME( JOBV, 'I' )
      WANTV = INITV .OR. LSAME( JOBV, 'V' )
*
      INITQ = LSAME( JOBQ, 'I' )
      WANTQ = INITQ .OR. LSAME( JOBQ, 'Q' )
*
      INFO = 0
      IF( .NOT.( INITU .OR. WANTU .OR. LSAME( JOBU, 'N' ) ) ) THEN
         INFO = -1
      ELSE IF( .NOT.( INITV .OR. WANTV .OR. LSAME( JOBV, 'N' ) ) ) THEN
         INFO = -2
      ELSE IF( .NOT.( INITQ .OR. WANTQ .OR. LSAME( JOBQ, 'N' ) ) ) THEN
         INFO = -3
      ELSE IF( M.LT.0 ) THEN
         INFO = -4
      ELSE IF( P.LT.0 ) THEN
         INFO = -5
      ELSE IF( N.LT.0 ) THEN
         INFO = -6
      ELSE IF( LDA.LT.MAX( 1, M ) ) THEN
         INFO = -10
      ELSE IF( LDB.LT.MAX( 1, P ) ) THEN
         INFO = -12
      ELSE IF( LDU.LT.1 .OR. ( WANTU .AND. LDU.LT.M ) ) THEN
         INFO = -18
      ELSE IF( LDV.LT.1 .OR. ( WANTV .AND. LDV.LT.P ) ) THEN
         INFO = -20
      ELSE IF( LDQ.LT.1 .OR. ( WANTQ .AND. LDQ.LT.N ) ) THEN
         INFO = -22
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'CTGSJA', -INFO )
         RETURN
      END IF
*
*     Initialize U, V and Q, if necessary
*
      IF( INITU )
     $   CALL CLASET( 'Full', M, M, CZERO, CONE, U, LDU )
      IF( INITV )
     $   CALL CLASET( 'Full', P, P, CZERO, CONE, V, LDV )
      IF( INITQ )
     $   CALL CLASET( 'Full', N, N, CZERO, CONE, Q, LDQ )
*
*     Loop until convergence
*
      UPPER = .FALSE.
      DO 40 KCYCLE = 1, MAXIT
*
         UPPER = .NOT.UPPER
*
         DO 20 I = 1, L - 1
            DO 10 J = I + 1, L
*
               A1 = ZERO
               A2 = CZERO
               A3 = ZERO
               IF( K+I.LE.M )
     $            A1 = REAL( A( K+I, N-L+I ) )
               IF( K+J.LE.M )
     $            A3 = REAL( A( K+J, N-L+J ) )
*
               B1 = REAL( B( I, N-L+I ) )
               B3 = REAL( B( J, N-L+J ) )
*
               IF( UPPER ) THEN
                  IF( K+I.LE.M )
     $               A2 = A( K+I, N-L+J )
                  B2 = B( I, N-L+J )
               ELSE
                  IF( K+J.LE.M )
     $               A2 = A( K+J, N-L+I )
                  B2 = B( J, N-L+I )
               END IF
*
               CALL CLAGS2( UPPER, A1, A2, A3, B1, B2, B3, CSU, SNU,
     $                      CSV, SNV, CSQ, SNQ )
*
*              Update (K+I)-th and (K+J)-th rows of matrix A: U'*A
*
               IF( K+J.LE.M )
     $            CALL CROT( L, A( K+J, N-L+1 ), LDA, A( K+I, N-L+1 ),
     $                       LDA, CSU, CONJG( SNU ) )
*
*              Update I-th and J-th rows of matrix B: V'*B
*
               CALL CROT( L, B( J, N-L+1 ), LDB, B( I, N-L+1 ), LDB,
     $                    CSV, CONJG( SNV ) )
*
*              Update (N-L+I)-th and (N-L+J)-th columns of matrices
*              A and B: A*Q and B*Q
*
               CALL CROT( MIN( K+L, M ), A( 1, N-L+J ), 1,
     $                    A( 1, N-L+I ), 1, CSQ, SNQ )
*
               CALL CROT( L, B( 1, N-L+J ), 1, B( 1, N-L+I ), 1, CSQ,
     $                    SNQ )
*
               IF( UPPER ) THEN
                  IF( K+I.LE.M )
     $               A( K+I, N-L+J ) = CZERO
                  B( I, N-L+J ) = CZERO
               ELSE
                  IF( K+J.LE.M )
     $               A( K+J, N-L+I ) = CZERO
                  B( J, N-L+I ) = CZERO
               END IF
*
*              Ensure that the diagonal elements of A and B are real.
*
               IF( K+I.LE.M )
     $            A( K+I, N-L+I ) = REAL( A( K+I, N-L+I ) )
               IF( K+J.LE.M )
     $            A( K+J, N-L+J ) = REAL( A( K+J, N-L+J ) )
               B( I, N-L+I ) = REAL( B( I, N-L+I ) )
               B( J, N-L+J ) = REAL( B( J, N-L+J ) )
*
*              Update unitary matrices U, V, Q, if desired.
*
               IF( WANTU .AND. K+J.LE.M )
     $            CALL CROT( M, U( 1, K+J ), 1, U( 1, K+I ), 1, CSU,
     $                       SNU )
*
               IF( WANTV )
     $            CALL CROT( P, V( 1, J ), 1, V( 1, I ), 1, CSV, SNV )
*
               IF( WANTQ )
     $            CALL CROT( N, Q( 1, N-L+J ), 1, Q( 1, N-L+I ), 1, CSQ,
     $                       SNQ )
*
   10       CONTINUE
   20    CONTINUE
*
         IF( .NOT.UPPER ) THEN
*
*           The matrices A13 and B13 were lower triangular at the start
*           of the cycle, and are now upper triangular.
*
*           Convergence test: test the parallelism of the corresponding
*           rows of A and B.
*
            ERROR = ZERO
            DO 30 I = 1, MIN( L, M-K )
               CALL CCOPY( L-I+1, A( K+I, N-L+I ), LDA, WORK, 1 )
               CALL CCOPY( L-I+1, B( I, N-L+I ), LDB, WORK( L+1 ), 1 )
               CALL CLAPLL( L-I+1, WORK, 1, WORK( L+1 ), 1, SSMIN )
               ERROR = MAX( ERROR, SSMIN )
   30       CONTINUE
*
            IF( ABS( ERROR ).LE.MIN( TOLA, TOLB ) )
     $         GO TO 50
         END IF
*
*        End of cycle loop
*
   40 CONTINUE
*
*     The algorithm has not converged after MAXIT cycles.
*
      INFO = 1
      GO TO 100
*
   50 CONTINUE
*
*     If ERROR <= MIN(TOLA,TOLB), then the algorithm has converged.
*     Compute the generalized singular value pairs (ALPHA, BETA), and
*     set the triangular matrix R to array A.
*
      DO 60 I = 1, K
         ALPHA( I ) = ONE
         BETA( I ) = ZERO
   60 CONTINUE
*
      DO 70 I = 1, MIN( L, M-K )
*
         A1 = REAL( A( K+I, N-L+I ) )
         B1 = REAL( B( I, N-L+I ) )
*
         IF( A1.NE.ZERO ) THEN
            GAMMA = B1 / A1
*
            IF( GAMMA.LT.ZERO ) THEN
               CALL CSSCAL( L-I+1, -ONE, B( I, N-L+I ), LDB )
               IF( WANTV )
     $            CALL CSSCAL( P, -ONE, V( 1, I ), 1 )
            END IF
*
            CALL SLARTG( ABS( GAMMA ), ONE, BETA( K+I ), ALPHA( K+I ),
     $                   RWK )
*
            IF( ALPHA( K+I ).GE.BETA( K+I ) ) THEN
               CALL CSSCAL( L-I+1, ONE / ALPHA( K+I ), A( K+I, N-L+I ),
     $                      LDA )
            ELSE
               CALL CSSCAL( L-I+1, ONE / BETA( K+I ), B( I, N-L+I ),
     $                      LDB )
               CALL CCOPY( L-I+1, B( I, N-L+I ), LDB, A( K+I, N-L+I ),
     $                     LDA )
            END IF
*
         ELSE
            ALPHA( K+I ) = ZERO
            BETA( K+I ) = ONE
            CALL CCOPY( L-I+1, B( I, N-L+I ), LDB, A( K+I, N-L+I ),
     $                  LDA )
         END IF
   70 CONTINUE
*
*     Post-assignment
*
      DO 80 I = M + 1, K + L
         ALPHA( I ) = ZERO
         BETA( I ) = ONE
   80 CONTINUE
*
      IF( K+L.LT.N ) THEN
         DO 90 I = K + L + 1, N
            ALPHA( I ) = ZERO
            BETA( I ) = ZERO
   90    CONTINUE
      END IF
*
  100 CONTINUE
      NCYCLE = KCYCLE
*
      RETURN
*
*     End of CTGSJA
*
      END

C NCLFORTSTART
      SUBROUTINE DVRFIDF(U,V,GLAT,GLON,MLON,NLAT,XMSG,IOPT,RV,IER)
      IMPLICIT NONE

c relative vorticity via finite differences
c NCL: rv = uv2vr_cfd (u,v,lat,lon,cyclic)

c            xmsg = u@_FillValue
c            nlat,mlon = dimsizes (u)
c            iopt= cyclic

c relative vorticity via centered finite difference approach (rv)
c .  rv = dv/dx-du/dy+(u/a)tan(lat)   where "d" means partial derivitive
c reference: Bluestein p113-114 [was not the original reference]
c            Halt-Martin p314   [ nothing on rv] 

c assumptions:
c .   (1) latitudes  monotonically increasing  [eg: glat(2) > glat(1)]
c .                  latitudes may be unequally spaced
c .   (2) longitudes monotonically increasing  [eg: glon(2) > glon(1)]
c .                  longitudes are assmed to be equally spaced
c .   (3) if iopt=1 then the grids are cyclic in x
c .                  eg: for T42 grid mlon=128, nlat=64
c .                      cyclic point should NOT be included
c .
c                                          ! INPUT
      INTEGER MLON,NLAT
      DOUBLE PRECISION U(MLON,NLAT),V(MLON,NLAT),GLAT(NLAT),GLON(MLON),
     +                 XMSG
      INTEGER IOPT

c                                          ! OUTPUT
      DOUBLE PRECISION RV(MLON,NLAT)
      INTEGER IER
C NCLEND
c                                          ! LOCAL  (dynamic/adjustable)
      DOUBLE PRECISION CLAT(NLAT),DX(NLAT),DLON,DX2(NLAT),DLON2,
     +                 DY2(NLAT),DYTOP,DYBOT,RE,RAD,RCON,
     +                 POLAT,TLATRE(NLAT)
      INTEGER ML,NL,MLSTRT,MLEND,MLM1,MLP1,JOPT

c                                          ! error chk stuff
      IER = 0
      IF (MLON.LT.1 .OR. NLAT.LT.1) THEN
          IER = 1
          RETURN
      END IF
      IF (ABS(GLAT(1)).gt.90.D0 .OR. ABS(GLAT(NLAT)).GT.90.D0) THEN
          IER = 2
          RETURN
      END IF


      RE = 6.37122D06
      RAD = 4.D0*ATAN(1.D0)/180.D0
      RCON = RE*RAD
      JOPT = ABS(IOPT)
c                                 ! pre-compute cos(lat)
      DO NL = 1,NLAT
          CLAT(NL)   = COS(RAD*GLAT(NL))
      END DO
c                                 ! pre-compute tan(lat)/re
c                                 ! pole pts will not be used below
      DO NL = 1,NLAT
         IF (ABS(GLAT(NL)).LT.90.D0) THEN
             TLATRE(NL) = TAN(RAD*GLAT(NL))/RE
         ELSE
             IF (GLAT(NL).EQ.90.D0) THEN
                 POLAT = 0.5*(GLAT(NL)+GLAT(NL-1))
                 TLATRE(NL) = TAN(RAD*POLAT)/RE
             ELSE
                 POLAT = 0.5*(GLAT(NL)+GLAT(NL+1))
                 TLATRE(NL) = TAN(RAD*POLAT)/RE
             END IF
         END IF
      END DO
        
c                                          ! initialize to msg
      DO NL = 1,NLAT
          DO ML = 1,MLON
              RV(ML,NL) = XMSG
          END DO
      END DO
c                                          ! calculate "1/dy" [bot, top]
      DYBOT = 1.D0/ (RCON* (GLAT(2)-GLAT(1)))
      DYTOP = 1.D0/ (RCON* (GLAT(NLAT)-GLAT(NLAT-1)))
c                                          ! calculate "1/(2*dy)"
      DO NL = 2,NLAT - 1
          DY2(NL) = 1.D0/ (RCON* (GLAT(NL+1)-GLAT(NL-1)))
      END DO
c                                       ! calculate "1/dx" [left, right]
c                                       ! and "1/(2*dx)
      DLON = GLON(2) - GLON(1)
      DLON2 = GLON(3) - GLON(1)

      DO NL = 1,NLAT
          IF (ABS(GLAT(NL)).NE.90.D0) THEN
              DX(NL) = 1.D0/ (RCON*DLON*CLAT(NL))
              DX2(NL) = 1.D0/ (RCON*DLON2*CLAT(NL))
          ELSE
              DX(NL) = 0.0D0
              DX2(NL) = 0.0D0
          END IF
      END DO
c                                          ! set subscript range
      IF (JOPT.EQ.1 .OR. JOPT.EQ.3) THEN
          MLSTRT = 1
          MLEND = MLON
      ELSE
          MLSTRT = 2
          MLEND = MLON - 1
      END IF
c                                          ! longitude loop
      DO ML = MLSTRT,MLEND
c                                          ! iopt=0 or 1
          MLM1 = ML - 1
          MLP1 = ML + 1
          IF (ML.EQ.1) MLM1 = MLON
          IF (ML.EQ.MLON) MLP1 = 1
c                                          ! rv in grid body
          DO NL = 2,NLAT - 1
              IF (V(MLP1,NL).NE.XMSG .AND. V(MLM1,NL).NE.XMSG .AND.
     +            U(ML,NL+1).NE.XMSG .AND. U(ML,NL-1).NE.XMSG .AND.
     +            U(ML,NL)  .NE.XMSG) THEN

                  RV(ML,NL) = (V(MLP1,NL)-V(MLM1,NL))*DX2(NL) -
     +                        (U(ML,NL+1)-U(ML,NL-1))*DY2(NL) +
     +                         U(ML,NL)*TLATRE(NL) 

              END IF
          END DO

          IF (JOPT.GE.2) THEN
c                                   ! bottom bound (nl=1)
              IF (V(MLP1,1).NE.XMSG .AND. V(MLM1,1).NE.XMSG .AND.
     +            U(ML,2)  .NE.XMSG .AND. U(ML,1)  .NE.XMSG) THEN

                  RV(ML,1) = (V(MLP1,1)-V(MLM1,1))*DX2(1) -
     +                       (U(ML,2)-U(ML,1))*DYBOT      +
     +                        U(ML,1)*TLATRE(1)
              END IF
c                                   ! top bound   (nl=nlat)
              IF (V(MLP1,NLAT).NE.XMSG .AND. V(MLM1,NLAT).NE.XMSG .AND.
     +            U(ML,NLAT)  .NE.XMSG .AND. U(ML,NLAT-1).NE.XMSG)THEN

                  RV(ML,NLAT) = (V(MLP1,NLAT)-V(MLM1,NLAT))*DX2(NLAT) -
     +                          (U(ML,NLAT)-U(ML,NLAT-1))*DYTOP       +
     +                           U(ML,NLAT)*TLATRE(NLAT)
              END IF
          END IF
      END DO
c                                   ! ?left/right bound?
      IF (JOPT.EQ.2) THEN
          DO NL = 2,NLAT - 1
c                                   ! left bound (ml=1)
              IF (V(2,NL).NE.XMSG   .AND. V(1,NL)  .NE.XMSG .AND.
     +            U(1,NL+1).NE.XMSG .AND. U(1,NL-1).NE.XMSG .AND.
     +            U(1,NL)  .NE.XMSG) THEN

                  RV(1,NL) = (V(2,NL)-V(1,NL))*DX(NL)      -
     +                       (U(1,NL+1)-U(1,NL-1))*DY2(NL) +
     +                        U(1,NL)*TLATRE(NL)
              END IF
c                                   ! right bound (ml=mlon)
              IF (V(MLON,NL)  .NE.XMSG .AND. V(MLON-1,NL).NE.XMSG .AND.
     +            U(MLON,NL+1).NE.XMSG .AND. U(MLON,NL-1).NE.XMSG .AND.
     +            U(MLON,NL)  .NE.XMSG) THEN

                  RV(MLON,NL) = (V(MLON,NL)-V(MLON-1,NL))*DX(NL)    -
     +                          (U(MLON,NL+1)-U(MLON,NL-1))*DY2(NL) +
     +                           U(MLON,NL)*TLATRE(NL)
              END IF
          END DO
      END IF
c                                   ! special at +/-90 use average
      DO NL = 1,NLAT,NLAT - 1
        IF (ABS(GLAT(NL)).EQ.90.D0) CALL DUSEAVE(RV(1,NL),MLON,XMSG)
      END DO
c                                   ! special for corners (jopt=2 only)
c                                   ! use linear extrapolation from
c                                   ! two directions
      IF (JOPT.EQ.2) THEN
          CALL DLNEXTRP(RV,MLON,NLAT,XMSG)
      END IF

      RETURN
      END

c NCLFORTSTART
      SUBROUTINE DDVFIDF(U,V,GLAT,GLON,MLON,NLAT,XMSG,IOPT,DV,IER)
      IMPLICIT NONE

c divergence via centered finite differences
c . div = dv/dy+du/dx-(v/re)*tan(lat)  where "d" ==> partial derivitive
c 
c reference: Bluestein p113-114 
c            Halt-Martin p314   

c NCL: dv = uv2dv_cfd (u,v,lat,lon,cyclic)
c            xmsg = u@_FillValue
c            nlat,mlon = dimsizes (u)
c            iopt= cyclic

c assumptions:
c .   (1) latitudes  monotonically increasing  [eg: glat(2) > glat(1)]
c .                  latitudes may be unequally spaced
c .   (2) longitudes monotonically increasing  [eg: glon(2) > glon(1)]
c .                  longitudes are assmed to be equally spaced
c .   (3) if iopt=1 then the grids are cyclic in x
c .                  eg: for T42 grid mlon=128, nlat=64
c .                      cyclic point should NOT be included
c .

c                                          ! INPUT
      INTEGER MLON,NLAT
      DOUBLE PRECISION U(MLON,NLAT),V(MLON,NLAT),GLAT(NLAT),GLON(MLON),
     +                 XMSG
      INTEGER IOPT

c                                          ! OUTPUT
      DOUBLE PRECISION DV(MLON,NLAT)
      INTEGER IER
C NCLEND
c                                          ! LOCAL  (dynamic/adjustable)
      DOUBLE PRECISION CLAT(NLAT),DX(NLAT),DLON,DX2(NLAT),DLON2,
     +                 DY2(NLAT),DYTOP,DYBOT,RE,RAD,RCON,
     +                 POLAT,TLATRE(NLAT)
      INTEGER ML,NL,MLSTRT,MLEND,MLM1,MLP1,JOPT

c                                          ! error chk stuff
      IER = 0
      IF (MLON.LT.1 .OR. NLAT.LT.1) THEN
          IER = 1
          RETURN
      END IF
      IF (ABS(GLAT(1)).gt.90.D0 .OR. ABS(GLAT(NLAT)).GT.90.D0) THEN
          IER = 2
          RETURN
      END IF

      RE = 6.37122D06
      RAD = 4.D0*ATAN(1.D0)/180.D0
      RCON = RE*RAD
      JOPT = ABS(IOPT)
c                                 ! pre-compute cos(lat)
      DO NL = 1,NLAT
          CLAT(NL)   = COS(RAD*GLAT(NL))
      END DO
c                                 ! pre-compute tan(lat)/re
c                                 ! pole pts will not be used below
      DO NL = 1,NLAT
         IF (ABS(GLAT(NL)).LT.90.D0) THEN
             TLATRE(NL) = TAN(RAD*GLAT(NL))/RE
         ELSE
             IF (GLAT(NL).EQ.90.D0) THEN
                 POLAT = 0.5*(GLAT(NL)+GLAT(NL-1))
                 TLATRE(NL) = TAN(RAD*POLAT)/RE
             ELSE
                 POLAT = 0.5*(GLAT(NL)+GLAT(NL+1))
                 TLATRE(NL) = TAN(RAD*POLAT)/RE
             END IF
         END IF
      END DO
c                                          ! initialize to msg
      DO NL = 1,NLAT
          DO ML = 1,MLON
              DV(ML,NL) = XMSG
          END DO
      END DO
c                                          ! calculate "1/dy" [bot, top]
      DYBOT = 1.D0/ (RCON* (GLAT(2)-GLAT(1)))
      DYTOP = 1.D0/ (RCON* (GLAT(NLAT)-GLAT(NLAT-1)))
c                                          ! calculate "1/(2*dy)"
      DO NL = 2,NLAT - 1
          DY2(NL) = 1.D0/ (RCON* (GLAT(NL+1)-GLAT(NL-1)))
      END DO
c                                       ! calculate "1/dx" [left, right]
c                                       ! and "1/(2*dx)
      DLON = GLON(2) - GLON(1)
      DLON2 = GLON(3) - GLON(1)

      DO NL = 1,NLAT
          IF (ABS(GLAT(NL)).NE.90.D0) THEN
              DX(NL) = 1.D0/ (RCON*DLON*CLAT(NL))
              DX2(NL) = 1.D0/ (RCON*DLON2*CLAT(NL))
          ELSE
              DX(NL) = 0.0D0
              DX2(NL) = 0.0D0
          END IF
      END DO
c                                          ! set subscript range
      IF (JOPT.EQ.1 .OR. JOPT.EQ.3) THEN
          MLSTRT = 1
          MLEND = MLON
      ELSE
          MLSTRT = 2
          MLEND = MLON - 1
      END IF

      DO ML = MLSTRT,MLEND
          MLM1 = ML - 1
          MLP1 = ML + 1
          IF (ML.EQ.1) MLM1 = MLON
          IF (ML.EQ.MLON) MLP1 = 1
c                                          ! dv in grid body
          DO NL = 2,NLAT - 1
              IF (V(ML,NL+1).NE.XMSG .AND. V(ML,NL-1).NE.XMSG .AND.
     +            U(MLP1,NL).NE.XMSG .AND. U(MLM1,NL).NE.XMSG .AND.
     +            V(ML,NL)  .NE.XMSG) THEN

                  DV(ML,NL) = (V(ML,NL+1)-V(ML,NL-1))*DY2(NL) +
     +                        (U(MLP1,NL)-U(MLM1,NL))*DX2(NL) -
     +                         V(ML,NL)*TLATRE(NL) 
              END IF
          END DO
c                                   ! ?bottom/top bound? 
          IF (JOPT.GE.2) THEN
c                                   ! bottom bound (nl=1)
              IF (V(ML,2)  .NE.XMSG .AND. V(ML,1)  .NE.XMSG .AND.
     +            U(MLP1,2).NE.XMSG .AND. U(MLM1,1).NE.XMSG) THEN

                  DV(ML,1) = (V(ML,2)-V(ML,1))*DYBOT      +
     +                       (U(MLP1,1)-U(MLM1,1))*DX2(1) -
     +                        V(ML,1)*TLATRE(1)
              END IF
c                                   ! top bound   (nl=nlat)
              IF (V(ML,NLAT).NE.XMSG   .AND. V(ML,NLAT-1).NE.XMSG .AND.
     +            U(MLP1,NLAT).NE.XMSG .AND. U(MLM1,NLAT).NE.XMSG) THEN

                  DV(ML,NLAT) = (V(ML,NLAT)-V(ML,NLAT-1))*DYTOP      +
     +                          (U(MLP1,NLAT)-U(MLM1,NLAT))*DX2(NLAT)-
     +                           V(ML,NLAT)*TLATRE(NLAT)
              END IF
          END IF
      END DO
c                                   ! ?left/right bound?
      IF (JOPT.EQ.2) THEN
          DO NL = 2,NLAT - 1
c                                   ! left bound (ml=1)
              IF (V(1,NL+1).NE.XMSG .AND. V(1,NL-1).NE.XMSG .AND.
     +            U(2,NL)  .NE.XMSG .AND. U(1,NL)  .NE.XMSG .AND.
     +            V(1,NL)  .NE.XMSG) THEN

                  DV(1,NL) = (V(1,NL+1)-V(1,NL-1))*DY2(NL) +
     +                       (U(2,NL)-U(1,NL))*DX(NL) -
     +                        V(1,NL)*TLATRE(NL)
              END IF
c                                   ! right bound (ml=mlon)
              IF (V(MLON,NL+1).NE.XMSG .AND. V(MLON,NL-1).NE.XMSG .AND.
     +            U(MLON,NL)  .NE.XMSG .AND. U(MLON-1,NL).NE.XMSG .AND.
     +            V(MLON,NL)  .NE.XMSG) THEN

                  DV(MLON,NL) = (V(MLON,NL+1)-V(MLON,NL-1))*DY2(NL) +
     +                          (U(MLON,NL)-U(MLON-1,NL))*DX(NL) -
     +                           V(MLON,NL)*TLATRE(NL)
              END IF
          END DO
      END IF
c                                   ! special at +/-90 use average
      DO NL = 1,NLAT,NLAT - 1
        IF (ABS(GLAT(NL)).EQ.90.D0) CALL DUSEAVE(DV(1,NL),MLON,XMSG)
      END DO
c                                   ! special for corners (jopt=2 only)
c                                   ! use linear extrapolation from
c                                   ! two directions
      IF (JOPT.EQ.2) THEN
          CALL DLNEXTRP(DV,MLON,NLAT,XMSG)
      END IF

      RETURN
      END

      SUBROUTINE DLNEXTRP(X,MLON,NLAT,XMSG)
      IMPLICIT NONE

c linearly extrapolate from two directions [take average]
c .   for the corner pts

      INTEGER MLON,NLAT
      DOUBLE PRECISION X(MLON,NLAT),XMSG

      INTEGER ML,NL

      DO NL = 1,NLAT,NLAT - 1
          DO ML = 1,MLON,MLON - 1
              IF (X(ML,NL).EQ.XMSG) THEN
                  IF (NL.EQ.1 .AND. ML.EQ.1) THEN
                      IF (X(ML,NL+1).NE.XMSG .AND.
     +                    X(ML,NL+2).NE.XMSG .AND.
     +                    X(ML+1,NL).NE.XMSG .AND.
     +                    X(ML+2,NL).NE.XMSG) THEN
                          X(ML,NL) = (2.D0*X(ML,NL+1)-X(ML,NL+2)+
     +                               2.D0*X(ML+1,NL)-X(ML+2,NL))*0.5D0
                      END IF
                  END IF
                  IF (NL.EQ.1 .AND. ML.EQ.MLON) THEN
                      IF (X(ML,NL+1).NE.XMSG .AND.
     +                    X(ML,NL+2).NE.XMSG .AND.
     +                    X(ML-1,NL).NE.XMSG .AND.
     +                    X(ML-2,NL).NE.XMSG) THEN
                          X(ML,NL) = (2.D0*X(ML,NL+1)-X(ML,NL+2)+
     +                               2.D0*X(ML-1,NL)-X(ML-2,NL))*0.5D0
                      END IF
                  END IF
                  IF (NL.EQ.NLAT .AND. ML.EQ.1) THEN
                      IF (X(ML,NL-1).NE.XMSG .AND.
     +                    X(ML,NL-2).NE.XMSG .AND.
     +                    X(ML+1,NL).NE.XMSG .AND.
     +                    X(ML+2,NL).NE.XMSG) THEN
                          X(ML,NL) = (2.D0*X(ML,NL-1)-X(ML,NL-2)+
     +                               2.D0*X(ML+1,NL)-X(ML+2,NL))*0.5D0
                      END IF
                  END IF
                  IF (NL.EQ.NLAT .AND. ML.EQ.MLON) THEN
                      IF (X(ML,NL-1).NE.XMSG .AND.
     +                    X(ML,NL-2).NE.XMSG .AND.
     +                    X(ML-1,NL).NE.XMSG .AND.
     +                    X(ML-2,NL).NE.XMSG) THEN
                          X(ML,NL) = (2.D0*X(ML,NL-1)-X(ML,NL-2)+
     +                               2.D0*X(ML-1,NL)-X(ML-2,NL))*0.5D0
                      END IF
                  END IF
              END IF
          END DO
      END DO

      RETURN
      END

      SUBROUTINE DUSEAVE(X,MLON,XMSG)
      IMPLICIT NONE
c calculate average and use at all input grid points: +/- 90 only
      INTEGER MLON
      DOUBLE PRECISION X(MLON),XMSG
c                                   ! local
      INTEGER ML
      DOUBLE PRECISION AVE,CNT

      AVE = 0.0D0
      CNT = 0.0D0
      DO ML = 1,MLON
          IF (X(ML).NE.XMSG) THEN
              AVE = AVE + X(ML)
              CNT = CNT + 1.0D0
          END IF
      END DO

      IF (CNT.NE.0.0D0) THEN
          AVE = AVE/CNT
          DO ML = 1,MLON
              X(ML) = AVE
          END DO
      END IF

      RETURN
      END

C
C $Id: pj15dp.f,v 1.5 2008-07-27 00:17:11 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE PJ15DP (COORD,CRDIO,INDIC)
C
C -- V E R T I C A L   N E A R - S I D E   P E R S P E C T I V E
C
      IMPLICIT DOUBLE PRECISION (A-Z)
      INTEGER INDIC
      DIMENSION GEOG(2),PROJ(2),COORD(2),CRDIO(2)
C **** PARAMETERS **** A,P,LON0,LAT0,X0,Y0,SINPH0,COSPH0 ***************
      COMMON /ERRMZ0/ IERR
        INTEGER IERR
      SAVE   /ERRMZ0/
      COMMON /PRINZ0/ IPEMSG,IPELUN,IPPARM,IPPLUN
        INTEGER IPEMSG,IPELUN,IPPARM,IPPLUN
      SAVE   /PRINZ0/
      COMMON /PC15DP/ A,LON0,X0,Y0,COSPH0,LAT0,P,SINPH0
      DATA HALFPI /1.5707963267948966D0/
      DATA EPSLN /1.0D-10/
      DATA ZERO,ONE /0.0D0,1.0D0/
C
C -- F O R W A R D   . . .
C
      IF (INDIC .EQ. 0) THEN
C
         GEOG(1) = COORD(1)
         GEOG(2) = COORD(2)
         IERR = 0
         LON = ADJLDP (GEOG(1) - LON0)
         SINPHI = SIN (GEOG(2))
         COSPHI = COS (GEOG(2))
         COSLON = COS (LON)
         G = SINPH0 * SINPHI + COSPH0 * COSPHI * COSLON
         IF (G .GE. (ONE / P)) GO TO 140
         IF (IPEMSG .EQ. 0) WRITE (IPELUN,2020)
 2020    FORMAT (' POINT CANNOT BE PROJECTED')
         IERR = 153
         RETURN
  140    KSP = (P - ONE) / (P - G)
         PROJ(1) = X0 + A * KSP * COSPHI * SIN (LON)
         PROJ(2) = Y0 + A * KSP * (COSPH0 * SINPHI - SINPH0 * COSPHI *
     .             COSLON)
         CRDIO(1) = PROJ(1)
         CRDIO(2) = PROJ(2)
         RETURN
      END IF
C
C -- I N V E R S E   . . .
C
      IF (INDIC .EQ. 1) THEN
C
         PROJ(1) = COORD(1)
         PROJ(2) = COORD(2)
         IERR = 0
         X = PROJ(1) - X0
         Y = PROJ(2) - Y0
         RH = SQRT (X * X + Y * Y)
         R = RH / A
         CON = P - ONE
         COM = P + ONE
         IF (R .LE. SQRT (CON / COM)) GO TO 230
         IF (IPEMSG .EQ. 0) WRITE (IPELUN,2030)
 2030    FORMAT (/' ERROR PJ15DP'/
     .            ' INPUT DATA ERROR')
         IERR = 155
         RETURN
  230    SINZ = (P - SQRT (ONE - R * R * COM / CON)) /
     .          (CON / R + R / CON)
         Z = ASINDP (SINZ)
         SINZ = SIN (Z)
         COSZ = COS (Z)
         GEOG(1) = LON0
         IF (ABS(RH) .GT. EPSLN) GO TO 240
         GEOG(2) = LAT0
         CRDIO(1) = GEOG(1)
         CRDIO(2) = GEOG(2)
         RETURN
  240    GEOG(2) = ASINDP (COSZ * SINPH0 + Y * SINZ * COSPH0 / RH)
         CON = ABS (LAT0) - HALFPI
         IF (ABS (CON) .GT. EPSLN) GO TO 260
         IF (LAT0 .LT. ZERO) GO TO 250
         GEOG(1) = ADJLDP (LON0 + ATAN2 (X , -Y))
         CRDIO(1) = GEOG(1)
         CRDIO(2) = GEOG(2)
         RETURN
  250    GEOG(1) = ADJLDP (LON0 - ATAN2 (-X , Y))
         CRDIO(1) = GEOG(1)
         CRDIO(2) = GEOG(2)
         RETURN
  260    CON = COSZ - SINPH0 * SIN (GEOG(2))
         IF (ABS(CON).LT.EPSLN.AND.ABS(X).LT.EPSLN) RETURN
         GEOG(1) = ADJLDP (LON0 + ATAN2 ((X*SINZ*COSPH0) , (CON*RH)))
         CRDIO(1) = GEOG(1)
         CRDIO(2) = GEOG(2)
         RETURN
      END IF
C
      END

        PROGRAM TDEX06
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
        PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C This example shows how a user can directly generate the list of
C triangles defining a surface and then render the surface using
C TDPACK routines.
C
C Consider the surface defined by the following equations (for values
C of u and v between 0 and 2 pi).
C
C     R (A,U,V) = A * [ COS(U) + COS(U-V) ] + B
C   PHI (A,U,V) = V
C     Z (A,U,V) = A * [ SIN(U) + SIN(U-V) ]
C
C where R, PHI, and Z are the usual cylindrical coordinates (radius,
C angle, and height).
C
C 0 < A < 1 is the range of interest and B is any convenient value
C greater than A.
C
C Define A, B, and the sum of the two for scaling.
C
        PARAMETER (A=1.,B=3.,BMIN=-A-B,BMAX=+A+B)
C
C Define a parameter specifying the maximum size of the array required
C for the list of triangles.
C
        PARAMETER (MTRI=100000)
C
C Define values of pi, two times pi, and pi over 180.
C
        PARAMETER (PI=3.14159265358979323846,TWOPI=2.*PI,DTOR=PI/180.)
C
C Declare a local array to hold the triangle list and a couple of
C temporary variables to be used in sorting the list.
C
        DIMENSION RTRI(10,MTRI),RTWK(MTRI,2),ITWK(MTRI)
C
C Declare variables to hold labels.
C
        CHARACTER*64 XNLB,YNLB,ZNLB,XILB,YILB,ZILB
C
C Set the desired minimum and maximum values of U and V (for the grid
C over which the surface is generated).
C
        DATA UMIN,UMAX /  0. , TWOPI /
        DATA VMIN,VMAX /  0. , TWOPI /
C
C Set the desired minimum and maximum values of X, Y, and Z.
C
        DATA XMIN,XMAX / BMIN , BMAX /
        DATA YMIN,YMAX / BMIN , BMAX /
        DATA ZMIN,ZMAX / BMIN , BMAX /
C
C Set the values determining the resolution of the grid over which the
C surface is generated.  Note that, if each of IDIM and JDIM is one more
C than a multiple of 12, the assignment of rendering styles works out
C best.
C
        DATA IDIM,JDIM / 109 , 109 /
C
C Set the desired values of parameters determining the eye position.
C ANG1 is a bearing angle, ANG2 is an elevation angle, and RMUL is a
C multiplier of the length of the diagonal of the data box, specifying
C the distance from the center of the box to the eye.
C
        DATA ANG1,ANG2,RMUL / 215. , 35. , 2.9 /
C
C ISTE is a flag that says whether to do a simple image (ISTE=0),
C a one-frame stereo image (ISTE=-1), or a two-frame stereo image
C (ISTE=+1).
C
        DATA ISTE / -1 /
C
C ASTE is the desired angle (in degrees) between the lines of sight for
C a pair of stereo views.
C
        DATA ASTE / 4. /
C
C WOSW is the width of the stereo windows to be used in one-frame stereo
C images; the width is stated as a fraction of the width of the plotter
C frame.  (The windows are centered vertically; horizontally, they are
C placed as far apart as possible in the plotter frame.)  The value used
C must be positive and non-zero; it may be slightly greater than .5, if
C it is desired that the stereo windows should overlap slightly.
C
        DATA WOSW / .5 /
C
C Set the desired value of the flag that says whether the basic color
C scheme will be white on black (IBOW=0) or black on white (IBOW=1).
C
        DATA IBOW / 1 /
C
C Set the desired value of the flag that says whether shading of the
C surfaces will be done using gray scales (ICLR=0) or colors (ICLR=1).
C
        DATA ICLR / 1 /
C
C Set the desired values of the shading parameters.  Values of SHDE
C near 0 give brighter colors and values near 1 give pastel shades.
C Values of SHDR near 0 give a narrow range of shades and values near
C 1 give a wide range of shades.
C
        DATA SHDE,SHDR / .1 , .8 /
C
C Define labels for the edges of the box.
C
        DATA XNLB / ' -4 -3 -2 -1 0 1 2 3 4 ' /
        DATA YNLB / ' -4 -3 -2 -1 0 1 2 3 4 ' /
        DATA ZNLB / ' -4 -3 -2 -1 0 1 2 3 4 ' /
C
        DATA XILB / 'X Coordinate Values' /
        DATA YILB / 'Y Coordinate Values' /
        DATA ZILB / 'Z Coordinate Values' /
C
C Define arithmetic statement functions for r, phi, and h as functions
C of U and V.
C
        RVAL(U,V)=A*(COS(U)+COS(U-V))+B
        PVAL(U,V)=V
        HVAL(U,V)=A*(SIN(U)+SIN(U-V))
C
C Define arithmetic statement functions to transform cylindrical
C coordinates into Cartesian coordinates.
C
        XVAL(R,P,H)=R*COS(P)
        YVAL(R,P,H)=R*SIN(P)
        ZVAL(R,P,H)=H
C
C Open GKS.
C
        CALL GOPKS (IERRF, ISZDM)
        CALL GOPWK (IWKID, LUNIT, IWTYPE)
        CALL GACWK (IWKID)
C
C Turn clipping off.
C
        CALL GSCLIP (0)
C
C Double the line width.
C
        CALL GSLWSC (2.)
C
C Define colors to use.
C
        CALL TDCLRS (1,IBOW,SHDE,SHDR,11,26,8)
C
C Select font number 25, turn on the outlining of filled fonts, set the
C line width to 1, and turn off the setting of the outline color.
C
        CALL PCSETI ('FN - FONT NUMBER',25)
        CALL PCSETI ('OF - OUTLINE FLAG',1)
        CALL PCSETR ('OL - OUTLINE LINE WIDTH',1.)
        CALL PCSETR ('OC - OUTLINE LINE COLOR',-1.)
C
C Make TDPACK characters a bit bigger.
C
        CALL TDSETR ('CS1',1.25)
C
C Define TDPACK rendering styles 1 through 7, using black-and-white
C shading or colored shading, whichever is selected.  The indices
C 1-7 can then be used as final arguments in calls to TDITRI, TDSTRI,
C and TDMTRI.
C
        IF (ICLR.EQ.0) THEN
C
C Rendering styles 1-7 are all gray on both sides:
C
          CALL TDSTRS (1,27,42, 27, 42,-1,-1,1,0.,0.,0.)
          CALL TDSTRS (2,27,42, 27, 42,-1,-1,1,0.,0.,0.)
          CALL TDSTRS (3,27,42, 27, 42,-1,-1,1,0.,0.,0.)
          CALL TDSTRS (4,27,42, 27, 42,-1,-1,1,0.,0.,0.)
          CALL TDSTRS (5,27,42, 27, 42,-1,-1,1,0.,0.,0.)
          CALL TDSTRS (6,27,42, 27, 42,-1,-1,1,0.,0.,0.)
          CALL TDSTRS (7,27,42, 27, 42,-1,-1,1,0.,0.,0.)
C
        ELSE
C
C Rendering styles 1-7 are all gray on one side.  The other side is
C 1) gray, 2) red, 3) green, 4) blue, 5) cyan, 6) magenta, 7) yellow.
C
          CALL TDSTRS (1,27,42, 27, 42,-1,-1,1,0.,0.,0.)
          CALL TDSTRS (2,27,42, 43, 58,-1,-1,1,0.,0.,0.)
          CALL TDSTRS (3,27,42, 59, 74,-1,-1,1,0.,0.,0.)
          CALL TDSTRS (4,27,42, 75, 90,-1,-1,1,0.,0.,0.)
          CALL TDSTRS (5,27,42, 91,106,-1,-1,1,0.,0.,0.)
          CALL TDSTRS (6,27,42,107,122,-1,-1,1,0.,0.,0.)
          CALL TDSTRS (7,27,42,123,138,-1,-1,1,0.,0.,0.)
C
        END IF
C
C Initialize the count of triangles in the triangle list.
C
        NTRI=0
C
C For each box on a rectangular grid in the UV plane, generate two
C triangles and add them to the triangle list.  Each triangle is
C transformed from cylindrical coordinates to Cartesian coordinates.
C The rendering style is made a function of the U coordinate; try
C uncommenting the second expression for ISRS to see what happens
C when the rendering style is made a function of the V coordinate.
C
        DO 102 I=1,IDIM-1
          UVMI=UMIN+(REAL(I-1)/REAL(IDIM-1))*(UMAX-UMIN)
          UVMA=UMIN+(REAL(I  )/REAL(IDIM-1))*(UMAX-UMIN)
          IURS=MAX(1,MIN(12,1+INT(12.*((UVMI+UVMA)/2.-UMIN)/
     +                                                    (UMAX-UMIN))))
          DO 101 J=1,JDIM-1
            VVMI=VMIN+(REAL(J-1)/REAL(JDIM-1))*(VMAX-VMIN)
            VVMA=VMIN+(REAL(J  )/REAL(JDIM-1))*(VMAX-VMIN)
            IVRS=MAX(1,MIN(12,1+INT(12.*((VVMI+VVMA)/2.-VMIN)/
     +                                                    (VMAX-VMIN))))
            ISRS=MOD(IURS-1       ,3)+2
C           ISRS=MOD(       IVRS-1,3)+2
C           ISRS=MOD(IURS-1+IVRS-1,3)+2
            RV00=RVAL(UVMI,VVMI)
            PV00=PVAL(UVMI,VVMI)
            HV00=HVAL(UVMI,VVMI)
            RV01=RVAL(UVMI,VVMA)
            PV01=PVAL(UVMI,VVMA)
            HV01=HVAL(UVMI,VVMA)
            RV10=RVAL(UVMA,VVMI)
            PV10=PVAL(UVMA,VVMI)
            HV10=HVAL(UVMA,VVMI)
            RV11=RVAL(UVMA,VVMA)
            PV11=PVAL(UVMA,VVMA)
            HV11=HVAL(UVMA,VVMA)
            IF (NTRI.LT.MTRI) THEN
              NTRI=NTRI+1
              RTRI(1,NTRI)=XVAL(RV10,PV10,HV10)
              RTRI(2,NTRI)=YVAL(RV10,PV10,HV10)
              RTRI(3,NTRI)=ZVAL(RV10,PV10,HV10)
              RTRI(4,NTRI)=XVAL(RV00,PV00,HV00)
              RTRI(5,NTRI)=YVAL(RV00,PV00,HV00)
              RTRI(6,NTRI)=ZVAL(RV00,PV00,HV00)
              RTRI(7,NTRI)=XVAL(RV01,PV01,HV01)
              RTRI(8,NTRI)=YVAL(RV01,PV01,HV01)
              RTRI(9,NTRI)=ZVAL(RV01,PV01,HV01)
              RTRI(10,NTRI)=REAL(ISRS)
            END IF
            IF (NTRI.LT.MTRI) THEN
              NTRI=NTRI+1
              RTRI(1,NTRI)=XVAL(RV01,PV01,HV01)
              RTRI(2,NTRI)=YVAL(RV01,PV01,HV01)
              RTRI(3,NTRI)=ZVAL(RV01,PV01,HV01)
              RTRI(4,NTRI)=XVAL(RV11,PV11,HV11)
              RTRI(5,NTRI)=YVAL(RV11,PV11,HV11)
              RTRI(6,NTRI)=ZVAL(RV11,PV11,HV11)
              RTRI(7,NTRI)=XVAL(RV10,PV10,HV10)
              RTRI(8,NTRI)=YVAL(RV10,PV10,HV10)
              RTRI(9,NTRI)=ZVAL(RV10,PV10,HV10)
              RTRI(10,NTRI)=REAL(ISRS)
            END IF
  101     CONTINUE
  102   CONTINUE
C
C Find the midpoint of the data box (to be used as the point looked at).
C
        XMID=.5*(XMIN+XMAX)
        YMID=.5*(YMIN+YMAX)
        ZMID=.5*(ZMIN+ZMAX)
C
C Determine the distance (R) from which the data box will be viewed and,
C given that, the eye position.
C
        R=RMUL*SQRT((XMAX-XMIN)**2+(YMAX-YMIN)**2+(ZMAX-ZMIN)**2)
C
        XEYE=XMID+R*COS(DTOR*ANG1)*COS(DTOR*ANG2)
        YEYE=YMID+R*SIN(DTOR*ANG1)*COS(DTOR*ANG2)
        ZEYE=ZMID+R*SIN(DTOR*ANG2)
C
C Initialize the stereo offset argument to do either a single view or
C a left-eye view (whichever is selected by the value of ISTE).
C
        IF (ISTE.EQ.0) THEN
          OTEP=0.
        ELSE
          OTEP=-R*TAN(DTOR*ASTE/2.)
        END IF
C
C Initialize TDPACK.
C
  109   CALL TDINIT (XEYE,YEYE,ZEYE,XMID,YMID,ZMID,
     +                              XMID,YMID,ZMID+R,OTEP)
C
C If stereo views are being done, do the requested thing, either by
C redoing the SET call to put them side by side on the same frame,
C or by calling FRAME to put them on separate frames.
C
        IF (OTEP.NE.0.) THEN
          IF (ISTE.LT.0) THEN
            CALL GETSET (XVPL,XVPR,YVPB,YVPT,XWDL,XWDR,YWDB,YWDT,LNLG)
            IF (OTEP.LT.0.) THEN
              CALL SET  (1.-WOSW,1.,.5-.5*WOSW,.5+.5*WOSW,
     +                           XWDL,XWDR,YWDB,YWDT,LNLG)
            ELSE
              CALL SET  (  0., WOSW,.5-.5*WOSW,.5+.5*WOSW,
     +                           XWDL,XWDR,YWDB,YWDT,LNLG)
            END IF
          ELSE
            IF (OTEP.GT.0.) CALL FRAME
          END IF
        END IF
C
C Order the triangles in the triangle list.
C
        CALL TDOTRI (RTRI,MTRI,NTRI,RTWK,ITWK,1)
C
        IF (NTRI.EQ.MTRI) THEN
          PRINT * , 'TRIANGLE LIST OVERFLOW IN TDOTRI'
          STOP
        END IF
C
C Draw labels for the axes.
C
        CALL TDLBLS (XMIN,YMIN,ZMIN,XMAX,YMAX,ZMAX,
     +               XNLB,YNLB,ZNLB,XILB,YILB,ZILB,1)
C
C Draw the sides of the box that could be hidden.
C
        CALL TDGRDS (XMIN,YMIN,ZMIN,XMAX,YMAX,ZMAX,
     +               .1*(XMAX-XMIN),.1*(YMAX-YMIN),.1*(ZMAX-ZMIN),
     +                                                       12,1)
C
C Draw the triangles in the triangle list.
C
        CALL TDDTRI (RTRI,MTRI,NTRI,ITWK)
C
C Draw the sides of the box that could not be hidden.
C
        CALL TDGRDS (XMIN,YMIN,ZMIN,XMAX,YMAX,ZMAX,
     +               .1*(XMAX-XMIN),.1*(YMAX-YMIN),.1*(ZMAX-ZMIN),
     +                                                       12,0)
C
C If a left-eye view has just been done, loop back for a right-eye view.
C
        IF (OTEP.LT.0.) THEN
          OTEP=-OTEP
          GO TO 109
        END IF
C
C Advance the frame.
C
        CALL FRAME
C
C Close GKS.
C
        CALL GDAWK (IWKID)
        CALL GCLWK (IWKID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END

C
C       $Id: stdrcm.f,v 1.3 2008-07-27 00:17:28 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE STDRCM  (U,V,UX,VY,IAM,STUMSL)
C
C This routine draws the streamlines using methods compatible with the
C old STRMLN and EZSTRM entry points (ICPM > 0). Curly vectors and
C colored streamlines are not available.
C
      DIMENSION  U(IUD1,*)             ,V(IVD1,*)
      DIMENSION  UX(IXDM,IYDN)         ,VY(IXDM,IYDN)
      DIMENSION  IAM(*)
      EXTERNAL STUMSL
C
C Input parameters:
C
C U,V    - Vector component arrays
C UX,UY  - Work arrays
C IAM    - Mask array
C STUMSL - User-defined masked streamline drawing routine
C
C The work array has been broken up into two arrays for clarity.  The
C top half of WORK (called UX) will have the normalized (and
C possibly transformed) U components and will be used for book
C keeping.  the lower half of the WORK array (called VY) will
C contain the normalized (and possibly transformed) V components.
C
C ---------------------------------------------------------------------
C
C NOTE:
C Since implicit typing is used for all real and integer variables
C a consistent length convention has been adopted to help clarify the
C significance of the variables encountered in the code for this 
C utility. All local variable and subroutine parameter identifiers 
C are limited to 1,2,or 3 characters. Four character names identify  
C members of common blocks. Five and 6 character variable names 
C denote PARAMETER constants or subroutine or function names.
C
C Declare the ST common blocks.
C
      PARAMETER (IPLVLS = 256)
C
C Integer and real common block variables
C
C
      COMMON / STPAR /
     +                IUD1       ,IVD1       ,IPD1       ,
     +                IXD1       ,IXDM       ,IYD1       ,IYDN       ,
     +                IXM1       ,IYM1       ,IXM2       ,IYM2       ,
     +                IWKD       ,IWKU       ,ISET       ,IERR       ,
     +                IXIN       ,IYIN       ,IMSK       ,ICPM       ,
     +                NLVL       ,IPAI       ,ICTV       ,WDLV       ,
     +                UVMN       ,UVMX       ,PMIN       ,PMAX       ,
     +                IPLR       ,ISST       ,
     +                ICLR(IPLVLS)           ,TVLU(IPLVLS)
C
      COMMON / STTRAN /
     +                UVPS       ,
     +                UVPL       ,UVPR       ,UVPB       ,UVPT       ,
     +                UWDL       ,UWDR       ,UWDB       ,UWDT       ,
     +                UXC1       ,UXCM       ,UYC1       ,UYCN 
C
C Stream algorithm parameters
C
      COMMON / STSTRM /
     +                ISGD       ,IAGD       ,RARL       ,ICKP       ,
     +                ICKX       ,ITRP       ,ICYK       ,RVNL       ,
     +                ISVF       ,RUSV       ,RVSV       ,RNDA       ,
     +                ISPC       ,RPSV       ,RCDS       ,RSSP       ,
     +                RDFM       ,RSMD       ,RAMD       ,IGBS       ,
     +                ISTM       ,RVRL       ,RVFR       ,RVRM       ,
     +                IVPO       ,RAFR       ,RDMX       ,RDMN
C
C Text related parameters
C Note: graphical text output is not yet implemented for the
C       Streamline utility.
C
      COMMON / STTXP /
     +                FCWM    ,ICSZ    ,
     +                FMNS    ,FMNX    ,FMNY    ,IMNP    ,IMNC  ,
     +                FMXS    ,FMXX    ,FMXY    ,IMXP    ,IMXC  ,
     +                FZFS    ,FZFX    ,FZFY    ,IZFP    ,IZFC  ,
     +                FILS    ,FILX    ,FILY    ,IILP    ,IILC 
C
C Character variable declartions
C
      CHARACTER*160 CSTR
      PARAMETER (IPCHSZ=80)
      CHARACTER*(IPCHSZ)  CMNT,CMXT,CZFT,CILT
C
C Text string parameters
C
      COMMON / STCHAR / CSTR,CMNT,CMXT,CZFT,CILT
C
      SAVE /STPAR/, /STTRAN/, /STSTRM/, /STTXP/, /STCHAR/
C
C Internal buffer lengths
C
C IPNPTS - Number of points in the point buffer -- not less than 3
C IPLSTL - Streamline-crossover-check circular list length
C IPGRCT - Number of groups supported for area masking
C
      PARAMETER (IPNPTS = 256, IPLSTL = 750, IPGRCT = 64)
C
C --------------------------------------------------------------------
C
C The mapping common block: made available to user mapping routines
C
      COMMON /STMAP/
     +                IMAP       ,LNLG       ,INVX       ,INVY       ,
     +                XLOV       ,XHIV       ,YLOV       ,YHIV       ,
     +                WXMN       ,WXMX       ,WYMN       ,WYMX       ,
     +                XVPL       ,XVPR       ,YVPB       ,YVPT       ,
     +                XGDS       ,YGDS       ,NXCT       ,NYCT       ,
     +                ITRT       ,FW2W       ,FH2H       ,
     +                DFMG       ,VNML       ,RBIG       ,IBIG
C
      SAVE /STMAP/
C
C Math constants
C
      PARAMETER (PDTOR  = 0.017453292519943,
     +           PRTOD  = 57.2957795130823,
     +           P1XPI  = 3.14159265358979,
     +           P2XPI  = 6.28318530717959,
     +           P1D2PI = 1.57079632679489,
     +           P5D2PI = 7.85398163397448) 
C
C ---------------------------------------------------------------------
C
C Local declarations
C
C Point and list buffers
C
C The XLS and YLS arrays serve as a circular list. they
C are used to prevent lines from crossing one another.
C
      DIMENSION PX(IPNPTS), PY(IPNPTS)
      DIMENSION XLS(IPLSTL), YLS(IPLSTL)
C
C Parameters:
C
C IPZERO, IPONE, IPTWO - the numbers 0,1,2
C PRZERO - the number 0.0
C PTHREE - the number 3.0
C PSMALL - a small floating point number, large enough to be 
C          detectable by any standard processor
C PMXITR - maximum iteration count for figuring when determining
C          the streamline edge
C
      PARAMETER (IPZERO=0, IPONE=1, IPTWO=2, PRZERO=0.0, PTHREE=3.0)
      PARAMETER (PSMALL=0.000001, PMXITR=32)
C
C Local variables
C
C VSM      - A small value in comparison to the normalized vector mag.
C ISK      - Number of bits to skip in bit routines
C IS1      - ISK + 1
C SSP      - Stream spacing value in fractional (ND) coordinates
C CDS      - Critical displacement in fractional (ND) coordinates
C LCT      - Count of streamlines drawn
C ITO      - Total number of points used to draw all the streamlines
C LCU      - Amount of list currently in use
C LCK      - Current list index
C IDR      - drawing direction 0 + direction 1 - direction
C SGN      - multiplier to change sign based on drawing direction
C IPC      - number of points currently in the point buffer
C ICT      - count of iterations in current streamline
C I,J      - Grid indices
C UIJ,VIJ  - individual vector components
C CVF      - component-wise vector normalizing factor
C LST      - flag indicating the last point in a streamline
C IUX      - integer storage for retrieved bits
C ISV, JSV - saved grid indices where stream starts in + direction
C NBX      - count of grid boxes for current streamline
C LBC      - box checking variable
C X, Y     - current X,Y coordinates (grid coordinates
C DU, DV   - Current normalized interpolated vector components
C XDA, YDA - Current position in data coordinates
C XUS, YUS - Current position in user coordinates
C XND, YND - Current position in NDC space
C XNS, YNS - value of XND and YND saved at the start of the streamline 
C                           and after each progress check
C TA       - The tangent angle in NDC space
C LI       - Index into circular crossover checking list
C IZO      - Zero field flag
C SDM      - Dummy array variable 
C ICF      - Saved value of the color flag
C
C --------------------------------------------------------------------
C
C Initialize local variables.
C
C Coloring flag
C
      ICF = ICTV
      ICTV = 0
C
C Bit manipulation values
C
      VSM = R1MACH(3)*VNML
      ISK = I1MACH(5) - 2
      IS1 = ISK + 1
C
C Stream spacing (setting depends on whether grid relative sizing is
C in effect) and critical displacement
C
      IF (IGBS.EQ.0) THEN
         SSP=RSSP*FW2W
      ELSE
         SSP=RSSP*FW2W/REAL(IXDM)
      END IF
      CDS=RCDS*DFMG
      AMD=RAMD*FW2W
C
C Stream and arrow counters
C
      LCT=0
      ITO=0
      IAC=0
C
C Crossover list variables
C
      LCU = 1
      LCK = 1
      XLS(1) = 0.0
      YLS(1) = 0.0
C
C Current streamline variables
C
      IDR = 0
      SGN = 1.0
      IPC = 0
      ICT = 0
      IUC = 0
      JSV = IYD1
C
C
C Compute the X and Y normalized (and possibly transformed)
C displacement components (UX and VY).
C
      IZO = 1
      DO  40 J=IYD1,IYDN
         DO  30 I=IXD1,IXDM
C
            CALL STMPUV(U(I,J),V(I,J),UIJ,VIJ,IST)
            IF (UIJ.NE.0. .OR. VIJ.NE.0.) THEN
               IZO = 0
               CVF = VNML/SQRT(UIJ*UIJ + VIJ*VIJ)
               UIJ = CVF*UIJ
               VIJ = CVF*VIJ
            END IF
C
C Bookkeeping is done in the least significant bits of the UX array.
C When UIJ is exactly zero this can present some problems.
C To get around this problem, set it to a relatively small number.
C
            IF (UIJ.EQ.0.0) UIJ = VSM
C
C Mask out the least significant two bits as flags for each grid box
C A grid box is any region surrounded by four grid points.
C Flag 1 indicates whether any streamline has previously passed
C through this box.
C Flag 2 indicates whether any directional arrow has already
C appeared in this box.
C Judicious use of these flags prevents overcrowding of
C streamlines and directional arrows.
C
            CALL SBYTES(UIJ,IPZERO,ISK,2,0,1)
C
            IF (MOD(I,ISGD).NE.0 .OR. MOD(J,ISGD).NE.0) THEN
               CALL SBYTES(UIJ,IPONE,IS1,1,0,1)
            END IF
            IF (MOD(I,IAGD).NE.0 .OR. MOD(J,IAGD).NE.0) THEN
               CALL SBYTES(UIJ,IPONE,ISK,1,0,1)
            END IF
C
            UX(I,J) = UIJ
            VY(I,J) = VIJ
C
 30      CONTINUE
 40   CONTINUE
C
C If Zero field bail out
C
      IF (IZO .EQ. 1) THEN
         LCT = 0
         ITO = 0
         GO TO 190
      END IF
C
C
C Start a streamline. Experience has shown that a pleasing picture
C will be produced if new streamlines are started only in grid
C boxes that previously have not had other streamlines pass through
C them. As long as a reasonably dense pattern of available boxes
C is initially prescribed, the order of scanning the grid pts. for
C available boxes is immaterial.
C
 50   CONTINUE
C
C First ensure that the point buffer is clear
C
      IF (IPC.GT.1) CALL STLNSG(PX,PY,SDM,IPC,IAM,STUMSL)
C
      LST=0
C
C Find an available box for starting a streamline.
C
      IF (IDR .EQ. 0) THEN
C
         LCT=LCT+1
         ITO = ITO+ICT
         ICT = 0
         DO  70 J=JSV,IYM1
            DO  60 I=IXD1,IXM1
               CALL GBYTES(UX(I,J),IUX,ISK,2,0,1)
               IF (IAND(IUX,IPONE) .EQ. IPZERO) GO TO 80
 60         CONTINUE
 70      CONTINUE
C
C Must be no available boxes for starting a streamline.
C This is the final exit from the streamline drawing loop
C
         GO TO 190
C
 80      CONTINUE
C
C Initialize parameters for starting a streamline.
C Turn the box off for starting a streamline.
C If the special value parameter is turned on, check to see if 
C this box has missing data. If so, find a new starting box.
C
         CALL SBYTES(UX(I,J),IPONE,IS1,1,0,1)
         IF (ISVF .NE. 0) THEN
            CALL STSVCK(U,V,I,J,IST)
            IF (IST .NE. 0) GO TO 50
         END IF
C
         ISV = I
         JSV = J
         IDR = 1
         SGN = +1.0
         IUC = 0
         DST = 0.0
C
      ELSE
C
C Come to here to draw in the opposite direction
C
         IDR = 0
         SGN = -1.
         I = ISV
         J = JSV
         DST = 0.0
         ITO = ITO+ICT
      END IF
C
C Initiate the drawing sequence, resetting counters.
C Start all streamlines in the center of a box.
C Find the initial normalized interpolated vector components.
C
      NBX = 0
      IF (IDR.NE.0) LBC = LCK+1
      IF (LBC.GT.IPLSTL) LBC = 1
      X = REAL(I)+0.5
      Y = REAL(J)+0.5
      CALL  STDUDV(UX,VY,I,J,X,Y,DU,DV)
      XDA=XLOV+(X-1.0)*XGDS
      YDA=YLOV+(Y-1.0)*YGDS
      DU=DU*SGN
      DV=DV*SGN
C
C Get initial point in the various coordinate systems
C and the tangent angle of the stream. If the compatibility flag
C is positive the FX,FY routines must be used.
C
      XUS=FX(X,Y)
      IF (XUS.LT.WXMN .OR. XUS.GT.WXMX) GO TO 50 
      YUS=FY(X,Y)
      IF (YUS.LT.WYMN .OR. YUS.GT.WYMX) GO TO 50 
      XND=CUFX(XUS)
      YND=CUFY(YUS)
      TA=ATAN2(DV,DU)
C
      XNS=XND
      YNS=YND
      ICT=1
      IPC=1
      PX(IPC)=XUS
      PY(IPC)=YUS
C      
C Check grid box directional arrow eligibility
C If a minimum arrow distance is set then the first arrow is not drawn
C
      IF (AMD.LE.0.0) THEN
         CALL GBYTES(UX(I,J),IUX,ISK,2,0,1)
C
         IF (IDR.NE.0 .AND. IAND(IUX,IPTWO).EQ.0) THEN
            IAC=IAC+1
            CALL STARDR(XUS,YUS,XND,YND,TA,1.0,0.0,IAM,STUMSL,IST)
            IF (IST.EQ.0) THEN
               CALL SBYTES(UX(I,J),IPONE,ISK,1,0,1)
            END IF
C
         END IF
      END IF
C
      ADS = 0.0
C
C Loop to this point until streamline ends
C
 110  CONTINUE
C
C Check to see if the streamline has entered a new grid box.
C
      IF (I.EQ.INT(X) .AND. J.EQ.INT(Y)) THEN
C
C Must be in same box --  Clear the point buffer if required
C
         IF (IPC .EQ. IPNPTS) THEN
            CALL STLNSG(PX,PY,SDM,IPNPTS,IAM,STUMSL)
            PX(1)=PX(IPNPTS)
            PY(1)=PY(IPNPTS)
            IPC=1
         ENDIF
C
C Determine the interpolated normalized vector at this point
C
         CALL STDUDV (UX,VY,I,J,X,Y,DU,DV)
         IF (DU.EQ.0.0 .AND. DV.EQ.0.0) GO TO 50
C
C A new point is found in grid space, then transformed into
C user and NDC space. There is no transformation of the tangent
C angle.
         X=X+SGN*DU
         Y=Y+SGN*DV
         XUS=FX(X,Y)
         IF (XUS.LT.WXMN .OR. XUS.GT.WXMX) GO TO 50 
         YUS=FY(X,Y)
         IF (YUS.LT.WYMN .OR. YUS.GT.WYMX) GO TO 50 
         XND=CUFX(XUS)
         YND=CUFY(YUS)
         TA=ATAN2(DV,DU)
C
C Count the point and add it to the point buffer
C
         ICT=ICT+1
         IPC=IPC+1
         PX(IPC)=XUS
         PY(IPC)=YUS
C
C
C Check streamline progress every 'ICKP' iterations.
C
         IF (MOD(ICT,ICKP).EQ.0) THEN
            IF (ABS(XND-XNS).LT.CDS 
     +           .AND. ABS(YND-YNS).LT.CDS) THEN
               GO TO 50
            END IF
            XNS=XND
            YNS=YND
         END IF
C
C If the circular list does not need to be checked for
C streamline crossover, return to the top of the main loop.
C
         IF (ICKX.LT.0 .OR. MOD(ICT,ICKX).NE.0) GO TO 110
C
      ELSE
C
C Must have entered a new grid box  check for the following :
C (1) Are the new points on the grid?
C (2) Check for missing data if msg data flag (ISVF) has been set.
C (3) Is this box eligible for a directional arrow?
C (4) Location of this entry versus other streamline entries
C
         I = INT(X)
         J = INT(Y)
         NBX = NBX+1
C
C Check (1) (Only performed in compatibility mode)
C
         IF (I.LT.IXD1 .OR. I.GT.IXM1 
     +        .OR. J.LT.IYD1 .OR. J.GT.IYM1) THEN
            GO TO  50
         END IF
C
C Check (2)
C
         IF (ISVF.NE.0) THEN
            CALL STSVCK(U,V,I,J,IST)
            IF (IST .NE. 0) GO TO 50
         END IF
C
C Check (3) -- postpone actually drawing the arrow until after the 
C crossover check, if crossover detected the arrow will not be drawn.
C
         IDA = 0
         CALL GBYTES(UX(I,J),IUX,ISK,2,0,1)
         IF (IAND(IUX,IPTWO) .EQ. 0) THEN
            IF (DST-ADS .GT. AMD) THEN
               ADS = DST
               IDA = 1
            END IF
         END IF
C
      END IF
C
C Check (4) (performed any time streamline crossover is checked)
C
      DO 140 LI=1,LCU
         IF (ABS(XND-XLS(LI)) .LE. SSP .AND.
     +        ABS(YND-YLS(LI)) .LE. SSP) THEN
            IF (LBC.LE.LCK .AND.
     +           (LI.LT.LBC .OR. LI.GT.LCK)) THEN
               GO TO 50
            ELSE IF (LBC.GT.LCK .AND. 
     +              (LI.LT.LBC .AND. LI.GT.LCK)) THEN
               GO TO 50
            END IF
         END IF
 140  CONTINUE
C
      LCU = MIN(LCU+1,IPLSTL)
      LCK = LCK+1
      IF (LCK.GT.IPLSTL) LCK = 1
      XLS(LCK) = XND
      YLS(LCK) = YND
      CALL SBYTES(UX(I,J),IPONE,IS1,1,0,1)
      IF (NBX.GE.5) THEN
         LBC = LBC+1
         IF (LBC.GT.IPLSTL) LBC = 1
      END IF
C
      IF (IDA.EQ.1) THEN
         CALL STARDR(XUS,YUS,XND,YND,TA,1.0,0.0,IAM,STUMSL,IST)
         IAC = IAC + 1
         IF (IST .EQ. 0) THEN
            CALL SBYTES(UX(I,J),IPONE,ISK,1,0,1)
         END IF
         IDA = 0
      END IF

C
C Return to top of drawing loop
C
      GO TO 110
C
C
C Final exit
C
  190 CONTINUE
C
      IF (IZO .EQ. 1) THEN
         CALL STZERO
      END IF
C
C Plot statistics
C
      IF (ISST.EQ.1) THEN
         LUN=I1MACH(2)
         WRITE(LUN,*) 'STREAM Statistics'
         WRITE(LUN,*) '                Streamlines plotted:',LCT
         WRITE(LUN,*) '      Total differential step count:',ITO
         WRITE(LUN,*) ' '
      END IF
C
C Set the workspace used parameter
C
      IWKU = 2*IXDM*IYDN
C
C Restore coloring flag
C
      ICTV = ICF
C
      RETURN
      END

        PROGRAM CPEX11
C
C This program demonstrates the use of the new internal parameter 'PIT',
C which was installed in May of 1994.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
        PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Declare the data array and the real and integer workspace arrays.
C
        DIMENSION ZDAT(37,19),RWRK(10000),IWRK(10000)
C
C Define the constant pi/180, used to convert angles from degrees to
C radians.
C
        DATA DTOR / .017453292519943 /
C
C Define a global array of data using a simple function of longitude
C (which is a linear function of the first subscript of the data array)
C and latitude (which is a linear function of the second subscript).
C
        DO 102 I=1,37
          RLON=-180.+10.*REAL(I-1)
          DO 101 J=1,19
            RLAT=-90.+10.*REAL(J-1)
            ZDAT(I,J)=SIN(DTOR*RLON)*COS(DTOR*RLAT)
  101     CONTINUE
  102   CONTINUE
C
C Salt in a few special values.
C
        ZDAT( 1, 8)=1.E36
        ZDAT( 2, 8)=1.E36
        ZDAT( 3, 8)=1.E36
        ZDAT(35, 8)=1.E36
        ZDAT(36, 8)=1.E36
        ZDAT(37, 8)=1.E36
        ZDAT(19, 9)=1.E36
        ZDAT(16,10)=1.E36
        ZDAT(17,10)=1.E36
        ZDAT(18,10)=1.E36
        ZDAT(19,10)=1.E36
        ZDAT(20,10)=1.E36
        ZDAT(21,10)=1.E36
        ZDAT(22,10)=1.E36
        ZDAT(19,11)=1.E36
        ZDAT( 1,12)=1.E36
        ZDAT( 2,12)=1.E36
        ZDAT( 3,12)=1.E36
        ZDAT(35,12)=1.E36
        ZDAT(36,12)=1.E36
        ZDAT(37,12)=1.E36
C
C Open GKS.
C
        CALL GOPKS (IERRF, ISZDM)
        CALL GOPWK (IWKID, LUNIT, IWTYPE)
        CALL GACWK (IWKID)
C
C Turn off clipping by GKS.
C
        CALL GSCLIP (0)
C
C Tell EZMAP what part of the plotter frame to use.
C
        CALL MAPPOS (.05,.95,.01,.91)
C
C Tell EZMAP what projection to use.  This projection maps the entire
C globe to the interior of a circle of radius 2.  Distortion near the
C outer edge of the circle is very great; mapped points from the data
C grid become so widely separated that contour lines wind up crossing
C each other.
C
        CALL MAPROJ ('LE',75.,99.,0.)
C
C Initialize EZMAP.
C
        CALL MAPINT
C
C Tell CONPACK to map its output through CPMPXY, using that value which
C causes the EZMAP routine MAPTRA to be called.
C
        CALL CPSETI ('MAP - MAPPING FLAG',1)
C
C Tell CONPACK what value EZMAP returns for the out-of-range value.
C
        CALL CPSETR ('ORV - OUT-OF-RANGE VALUE',1.E12)
C
C Tell CONPACK not to do a SET call (because EZMAP has already done it).
C
        CALL CPSETI ('SET - DO-SET-CALL FLAG',0)
C
C Tell CONPACK what the special value is.
C
        CALL CPSETR ('SPV - SPECIAL VALUE',1.E36)
C
C Tell CONPACK what values are to be associated with the extreme values
C of each of the subscripts of the data array.
C
        CALL CPSETR ('XC1 - X COORDINATE AT I=1',-180.)
        CALL CPSETR ('XCM - X COORDINATE AT I=M',+180.)
        CALL CPSETR ('YC1 - Y COORDINATE AT J=1', -90.)
        CALL CPSETR ('YCN - Y COORDINATE AT J=N', +90.)
C
C Tell CONPACK to draw the mapped boundary of the data grid.
C
        CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',-1)
        CALL CPSETI ('CLU - CONTOUR LEVEL USE FLAG',1)
C
C Tell CONPACK to draw the mapped boundary of the area filled with
C special values.
C
        CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',-2)
        CALL CPSETI ('CLU - CONTOUR LEVEL USE FLAG',1)
C
C Tell CONPACK to draw a limb line (separating areas that are visible
C under the projection from area that are not visible).
C
        CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',-3)
        CALL CPSETI ('CLU - CONTOUR LEVEL USE FLAG',1)
C
C Tell PLOTCHAR not to interpret colons as function-code signal
C characters.
C
        CALL PCSETC ('FC',CHAR(0))
C
C Tell PLOTCHAR to use one of the filled fonts.
C
        CALL PCSETI ('FN',25)
C
C Tell CONPACK what the dimensions of the data array and the workspace
C arrays are and make it initialize itself.
C
        CALL CPRECT (ZDAT,37,37,19,RWRK,10000,IWRK,10000)
C
C Draw the mapped contour lines, the mapped edges of the grid, the
C mapped edges of the special value area, and the visible/invisible
C boundary of the mapping.
C
        CALL CPCLDR (ZDAT,RWRK,IWRK)
C
C Put a label at the top of the first frame.
C
        CALL PLCHHQ (CFUX(.5),CFUY(.975),
     +  'Using certain mappings can cause a problem like this:  Grid',
     +                                                       .018,0.,0.)
        CALL PLCHHQ (CFUX(.5),CFUY(.939),
     +  'points are spread so far apart that contour lines cross.',
     +                                                       .018,0.,0.)
C
C Advance the frame.
C
        CALL FRAME
C
C Set the value of the parameters 'PIC' and 'PIE' to interpolate points
C on all contour lines and all edge lines.
C
        CALL CPSETI ('PIC - POINT INTERPOLATION ON CONTOURS   ',7)
        CALL CPSETI ('PIE - POINT INTERPOLATION ON OTHER EDGES',7)
C
C Again draw the mapped contour lines, the mapped edges of the grid,
C the mapped edges of the special value area, and the visible/invisible
C boundary of the mapping.
C
        CALL CPCLDR (ZDAT,RWRK,IWRK)
C
C Label the second frame.
C
        CALL PLCHHQ (CFUX(.5),CFUY(.975),
     +  'Using ''PIC'' = ''PIE'' = 7 solves the problem expensively by',
     +                                                       .018,0.,0.)
        CALL PLCHHQ (CFUX(.5),CFUY(.939),
     +  'interpolating seven points on every segment before mapping.',
     +                                                       .018,0.,0.)
C
C Advance the frame.
C
        CALL FRAME
C
C Turn off the interpolation requested by 'PIC' and 'PIE'.
C
        CALL CPSETI ('PIC - POINT INTERPOLATION ON CONTOURS   ',0)
        CALL CPSETI ('PIE - POINT INTERPOLATION ON OTHER EDGES',0)
C
C Set the value of the parameter 'PIT' to .05 to turn on interpolation
C of points only in problem areas (where the X/Y distance between points
C in user space exceeds 5/100ths of the horizontal/vertical dimension
C of the window.
C
        CALL CPSETR ('PIT - POINT INTERPOLATION THRESHOLD',.05)
C
C Again draw the mapped contour lines, the mapped edges of the grid,
C the mapped edges of the special value area, and the visible/invisible
C boundary of the mapping.
C
        CALL CPCLDR (ZDAT,RWRK,IWRK)
C
C Label the third frame.
C
        CALL PLCHHQ (CFUX(.5),CFUY(.975),
     +  'Using ''PIT'' = .05 solves the problem less expensively (and',
     +                                                       .018,0.,0.)
        CALL PLCHHQ (CFUX(.5),CFUY(.939),
     +  'more reliably) by interpolating points only as needed.',
     +                                                       .018,0.,0.)
C
C Advance the frame.
C
        CALL FRAME
C
C Now turn smoothing on, using a value that says to smooth before
C mapping.
C
        CALL CPSETR ('T2D - TENSION ON 2D SMOOTHER',-2.5)
C
C Again draw the mapped contour lines, the mapped edges of the grid,
C the mapped edges of the special value area, and the visible/invisible
C boundary of the mapping.
C
        CALL CPCLDR (ZDAT,RWRK,IWRK)
C
C Label the fourth frame.
C
        CALL PLCHHQ (CFUX(.5),CFUY(.975),
     +  'With ''PIT'' on, you can still smooth: Here, ''T2D'' = -2.5,',
     +                                                       .018,0.,0.)
        CALL PLCHHQ (CFUX(.5),CFUY(.939),
     +  'which causes the smoothing to be done before the mapping.',
     +                                                       .018,0.,0.)
C
C Advance the frame.
C
        CALL FRAME
C
C Now turn smoothing on, using a value that says to smooth after
C mapping.
C
        CALL CPSETR ('T2D - TENSION ON 2D SMOOTHER',2.5)
C
C Again draw the mapped contour lines, the mapped edges of the grid,
C the mapped edges of the special value area, and the visible/invisible
C boundary of the mapping.
C
        CALL CPCLDR (ZDAT,RWRK,IWRK)
C
C Label the fifth frame.
C
        CALL PLCHHQ (CFUX(.5),CFUY(.975),
     +  'With ''PIT'' on, you can still smooth: Here, ''T2D'' = +2.5,',
     +                                                       .018,0.,0.)
        CALL PLCHHQ (CFUX(.5),CFUY(.939),
     +  'which causes the smoothing to be done after the mapping.',
     +                                                       .018,0.,0.)
C
C Advance the frame.
C
        CALL FRAME
C
C Close GKS.
C
        CALL GDAWK (IWKID)
        CALL GCLWK (IWKID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END

C
C $Id: mdutfs.f,v 1.3 2008-07-27 00:17:09 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MDUTFS (RLAT,RLON,UVAL,VVAL)
C
C Given RLAT and RLON, in degrees, return UVAL and VVAL, in meters.
C
        REAL RLAT,RLON,UVAL,VVAL
C
C Declare common blocks required to communicate with USGS code.
C
        COMMON /ERRMZ0/ IERR
        SAVE   /ERRMZ0/
C
        COMMON /USGSC1/  UTPA(15),UUMN,UUMX,UVMN,UVMX,IPRF
        DOUBLE PRECISION UTPA,UUMN,UUMX,UVMN,UVMX
        INTEGER IPRF
        SAVE   /USGSC1/
C
C Declare coordinate arrays.
C
        DIMENSION CRDI(2),CRDO(2),CRDT(2)
C
C Declare a required single-precision function.
C
        REAL MDGDSP
C
C Define a couple of conversion constants.
C
        DATA DTOR / .017453292519943E0 /
        DATA RTOD / 57.2957795130823E0 /
C
C Do a call forcing a BLOCKDATA to be loaded from a binary library.
C
        CALL GTPZBD
C
C If the USGS package is initialized, zero the error flag; otherwise,
C take an error exit.
C
        IF (IPRF.GE.3.AND.IPRF.LE.23) THEN
          IERR=0
        ELSE
          IERR=1
          UVAL=1.E12
          VVAL=1.E12
          RETURN
        END IF
C
C Generate coordinates for projection routine.
C
        CRDI(1)=DTOR*RLON
        CRDI(2)=DTOR*RLAT
C
        GO TO (        103,104,105,106,107,108,109,110,
     +         111,112,113,114,115,116,117,118,119,120,
     +         121,122,123                             ) , IPRF-2
C
  103   CALL PJ03SP (CRDI,CRDO,0)
        GO TO 201
C
  104   CALL PJ04SP (CRDI,CRDO,0)
        GO TO 201
C
  105   CALL PJ05SP (CRDI,CRDO,0)
        GO TO 201
C
  106   CALL PJ06SP (CRDI,CRDO,0)
        GO TO 201
C
  107   DTST=ABS(RLON-REAL(UTPA(5)))
C
        IF (DTST.LE.90..OR.ABS(DTST-360.).LE.90.) THEN
          CALL PJ07SP (CRDI,CRDO,0)
        ELSE
          IERR=1
        END IF
C
        GO TO 201
C
  108   CALL PJ08SP (CRDI,CRDO,0)
        GO TO 201
C
  109   CALL PJ09SP (CRDI,CRDO,0)
        GO TO 201
C
  110   CALL PJ10SP (CRDI,CRDO,0)
        GO TO 201
C
  111   CALL PJ11SP (CRDI,CRDO,0)
        GO TO 201
C
  112   CALL PJ12SP (CRDI,CRDO,0)
        GO TO 201
C
  113   CALL PJ13SP (CRDI,CRDO,0)
        GO TO 201
C
  114   CALL PJ14SP (CRDI,CRDO,0)
        GO TO 201
C
  115   CALL PJ15SP (CRDI,CRDO,0)
        GO TO 201
C
  116   CALL PJ16SP (CRDI,CRDO,0)
        GO TO 201
C
  117   CALL PJ17SP (CRDI,CRDO,0)
        GO TO 201
C
  118   CALL PJ18SP (CRDI,CRDO,0)
        GO TO 201
C
  119   CALL PJ19SP (CRDI,CRDO,0)
        GO TO 201
C
  120   CALL PJ20SP (CRDI,CRDO,0)
        GO TO 201
C
  121   CALL PJ21SP (CRDI,CRDO,0)
        GO TO 201
C
  122   CALL PJ22SP (CRDI,CRDO,0)
        CALL PJ22SP (CRDO,CRDT,1)
C
        IF (IERR.EQ.0) THEN
          IF (MDGDSP(RTOD*CRDI(2),RTOD*CRDI(1),
     +               RTOD*CRDT(2),RTOD*CRDT(1)).GT.1.E-2) THEN
            IERR=1
          END IF
        END IF
C
        GO TO 201
C
  123   CALL PJ23SP (CRDI,CRDO,0)
        GO TO 201
C
  201   IF (IERR.EQ.0) THEN
          UVAL=CRDO(1)
          VVAL=CRDO(2)
        ELSE
          UVAL=1.E12
          VVAL=1.E12
        END IF
C
        RETURN
C
      END

c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by UCAR                 .
c  .                                                             .
c  .       University Corporation for Atmospheric Research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                         SPHEREPACK                       .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c
c
c ... file divgc.f
c
c     this file includes documentation and code for
c     subroutine divgc          i
c
c ... files which must be loaded with divgc.f
c
c     sphcom.f, hrfft.f, vhagc.f, shsgc.f, gaqd.f
c
c
c     subroutine divgc(nlat,nlon,isym,nt,dv,idv,jdv,br,bi,mdb,ndb,
c    +                 wshsgc,lshsgc,work,lwork,ierror)
c
C*PL*ERROR* Comment line too long
c     given the vector spherical harmonic coefficients br and bi, precomputed
c     by subroutine vhagc for a vector field (v,w), subroutine divgc
C*PL*ERROR* Comment line too long
c     computes the divergence of the vector field in the scalar array dv.
C*PL*ERROR* Comment line too long
c     dv(i,j) is the divergence at the gaussian colatitude point theta(i)
c     (see nlat as input parameter) and east longitude
c
c            lambda(j) = (j-1)*2*pi/nlon
c
c     on the sphere.  i.e.
c
C*PL*ERROR* Comment line too long
c            dv(i,j) = 1/sint*[ d(sint*v(i,j))/dtheta + d(w(i,j))/dlambda ]
c
c     where sint = sin(theta(i)).  w is the east longitudinal and v
c     is the colatitudinal component of the vector field from which
c     br,bi were precomputed.  required associated legendre polynomials
c     are recomputed rather than stored as they are in subroutine divgs.
c
c
c     input parameters
c
c     nlat   the number of points in the gaussian colatitude grid on the
C*PL*ERROR* Comment line too long
c            full sphere. these lie in the interval (0,pi) and are computed
C*PL*ERROR* Comment line too long
c            in radians in theta(1) <...< theta(nlat) by subroutine gaqd.
C*PL*ERROR* Comment line too long
c            if nlat is odd the equator will be included as the grid point
c            theta((nlat+1)/2).  if nlat is even the equator will be
c            excluded as a grid point and will lie half way between
c            theta(nlat/2) and theta(nlat/2+1). nlat must be at least 3.
c            note: on the half sphere, the number of grid points in the
c            colatitudinal direction is nlat/2 if nlat is even or
c            (nlat+1)/2 if nlat is odd.
c
c     nlon   the number of distinct londitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater
c            than zero. the axisymmetric case corresponds to nlon=1.
c            the efficiency of the computation is improved when nlon
c            is a product of small prime numbers.
c
c
c     isym   a parameter which determines whether the divergence is
c            computed on the full or half sphere as follows:
c
c      = 0
c
c            the symmetries/antsymmetries described in isym=1,2 below
c            do not exist in (v,w) about the equator.  in this case the
c            divergence is neither symmetric nor antisymmetric about
c            the equator.  the divergence is computed on the entire
c            sphere.  i.e., in the array dv(i,j) for i=1,...,nlat and
c            j=1,...,nlon.
c
c      = 1
c
c            w is antisymmetric and v is symmetric about the equator.
c            in this case the divergence is antisymmetyric about
c            the equator and is computed for the northern hemisphere
c            only.  i.e., if nlat is odd the divergence is computed
c            in the array dv(i,j) for i=1,...,(nlat+1)/2 and for
c            j=1,...,nlon.  if nlat is even the divergence is computed
c            in the array dv(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
c
c      = 2
c            w is symmetric and v is antisymmetric about the equator
c            in this case the divergence is symmetyric about the
c            equator and is computed for the northern hemisphere
c            only.  i.e., if nlat is odd the divergence is computed
c            in the array dv(i,j) for i=1,...,(nlat+1)/2 and for
c            j=1,...,nlon.  if nlat is even the divergence is computed
c            in the array dv(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
c
c
c     nt     nt is the number of scalar and vector fields.  some
c            computational efficiency is obtained for multiple fields.
c            in the program that calls divgc, the arrays br,bi, and dv
C*PL*ERROR* Comment line too long
c            can be three dimensional corresponding to an indexed multiple
c            vector field.  in this case multiple scalar synthesis will
c            be performed to compute the divergence for each field.  the
c            third index is the synthesis index which assumes the values
c            k=1,...,nt.  for a single synthesis set nt = 1.  the
c            description of the remaining parameters is simplified by
C*PL*ERROR* Comment line too long
c            assuming that nt=1 or that all the arrays are two dimensional.
c
c     idv    the first dimension of the array dv as it appears in
c            the program that calls divgc. if isym = 0 then idv
c            must be at least nlat.  if isym = 1 or 2 and nlat is
c            even then idv must be at least nlat/2. if isym = 1 or 2
c            and nlat is odd then idv must be at least (nlat+1)/2.
c
c     jdv    the second dimension of the array dv as it appears in
c            the program that calls divgc. jdv must be at least nlon.
c
c     br,bi  two or three dimensional arrays (see input parameter nt)
c            that contain vector spherical harmonic coefficients
c            of the vector field (v,w) as computed by subroutine vhagc.
c     ***    br and bi must be computed by vhagc prior to calling
c            divgc.
c
c     mdb    the first dimension of the arrays br and bi as it
c            appears in the program that calls divgc. mdb must be at
c            least min0(nlat,nlon/2) if nlon is even or at least
c            min0(nlat,(nlon+1)/2) if nlon is odd.
c
c     ndb    the second dimension of the arrays br and bi as it
c            appears in the program that calls divgc. ndb must be at
c            least nlat.
c
c
c     wshsgc an array which must be initialized by subroutine shsgci
c            once initialized, wshsgc can be used repeatedly by divgc
c            as long as nlon and nlat remain unchanged.  wshsgc must
c            not be altered between calls of divgc.
c
c
c     lshsgc the dimension of the array wshsgc as it appears in the
c            program that calls divgc. define
c
c               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            then lshsgc must be at least
c
c               nlat*(2*l2+3*l1-2)+3*l1*(1-l1)/2+nlon+15
c
c     work   a work array that does not have to be saved.
c
c     lwork  the dimension of the array work as it appears in the
c            program that calls divgc. define
c
c               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2                    if nlat is even or
c               l2 = (nlat+1)/2                if nlat is odd
c
c
c            if isym is zero then lwork must be at least
c
c               nlat*(nlon*nt+max0(3*l2,nlon) + 2*nt*l1+1)
c
c            if isym is not zero then lwork must be at least
c
c               l2*(nlon*nt+max0(3*nlat,nlon)) + nlat*(2*nt*l1+1)
c
c
c     **************************************************************
c
c     output parameters
c
c
c    dv     a two or three dimensional array (see input parameter nt)
c           that contains the divergence of the vector field (v,w)
c           whose coefficients br,bi where computed by subroutine
c           vhagc.  dv(i,j) is the divergence at the gaussian colatitude
C*PL*ERROR* Comment line too long
c           point theta(i) and longitude point lambda(j) = (j-1)*2*pi/nlon.
c           the index ranges are defined above at the input parameter
c           isym.
c
c
c    ierror = 0  no errors
c           = 1  error in the specification of nlat
c           = 2  error in the specification of nlon
c           = 3  error in the specification of isym
c           = 4  error in the specification of nt
c           = 5  error in the specification of idv
c           = 6  error in the specification of jdv
c           = 7  error in the specification of mdb
c           = 8  error in the specification of ndb
c           = 9  error in the specification of lshsgc
c           = 10 error in the specification of lwork
c **********************************************************************
c
c
      SUBROUTINE DDIVGC(NLAT,NLON,ISYM,NT,DV,IDV,JDV,BR,BI,MDB,NDB,
     +                  WSHSGC,LSHSGC,WORK,LWORK,IERROR)
      DOUBLE PRECISION DV
      DOUBLE PRECISION BR
      DOUBLE PRECISION BI
      DOUBLE PRECISION WSHSGC
      DOUBLE PRECISION WORK

      DIMENSION DV(IDV,JDV,NT),BR(MDB,NDB,NT),BI(MDB,NDB,NT)
      DIMENSION WSHSGC(LSHSGC),WORK(LWORK)
c
c     check input parameters
c
      IERROR = 1
      IF (NLAT.LT.3) RETURN
      IERROR = 2
      IF (NLON.LT.4) RETURN
      IERROR = 3
      IF (ISYM.LT.0 .OR. ISYM.GT.2) RETURN
      IERROR = 4
      IF (NT.LT.0) RETURN
      IERROR = 5
      IMID = (NLAT+1)/2
      IF ((ISYM.EQ.0.AND.IDV.LT.NLAT) .OR.
     +    (ISYM.GT.0.AND.IDV.LT.IMID)) RETURN
      IERROR = 6
      IF (JDV.LT.NLON) RETURN
      IERROR = 7
      IF (MDB.LT.MIN0(NLAT, (NLON+1)/2)) RETURN
      MMAX = MIN0(NLAT, (NLON+2)/2)
      IERROR = 8
      IF (NDB.LT.NLAT) RETURN
      IERROR = 9
      IMID = (NLAT+1)/2
      LPIMN = (IMID*MMAX* (NLAT+NLAT-MMAX+1))/2
c     check permanent work space length
      L2 = (NLAT+1)/2
      L1 = MIN0((NLON+2)/2,NLAT)
      IF (LSHSGC.LT.NLAT* (2*L2+3*L1-2)+3*L1* (1-L1)/2+NLON+15) RETURN
      IERROR = 10
c
c     verify unsaved work space (add to what shsgc requires)
c
      LS = NLAT
      IF (ISYM.GT.0) LS = IMID
      NLN = NT*LS*NLON
c
c     set first dimension for a,b (as requried by shsgc)
c
      MAB = MIN0(NLAT,NLON/2+1)
      MN = MAB*NLAT*NT
c     if(lwork.lt. nln+ls*nlon+2*mn+nlat) return
      L1 = MIN0(NLAT, (NLON+2)/2)
      L2 = (NLAT+1)/2
      IF (ISYM.EQ.0) THEN
          LWKMIN = NLAT* (NT*NLON+MAX0(3*L2,NLON)+2*NT*L1+1)
      ELSE
          LWKMIN = L2* (NT*NLON+MAX0(3*NLAT,NLON)) + NLAT* (2*NT*L1+1)
      END IF
      IF (LWORK.LT.LWKMIN) RETURN


      IERROR = 0
c
c     set work space pointers
c
      IA = 1
      IB = IA + MN
      IS = IB + MN
      IWK = IS + NLAT
      LWK = LWORK - 2*MN - NLAT
      CALL DDIVGC1(NLAT,NLON,ISYM,NT,DV,IDV,JDV,BR,BI,MDB,NDB,WORK(IA),
     +            WORK(IB),MAB,WORK(IS),WSHSGC,LSHSGC,WORK(IWK),LWK,
     +            IERROR)
      RETURN
      END

      SUBROUTINE DDIVGC1(NLAT,NLON,ISYM,NT,DV,IDV,JDV,BR,BI,MDB,NDB,A,B,
     +                  MAB,SQNN,WSHSGC,LSHSGC,WK,LWK,IERROR)
      DOUBLE PRECISION DV
      DOUBLE PRECISION BR
      DOUBLE PRECISION BI
      DOUBLE PRECISION A
      DOUBLE PRECISION B
      DOUBLE PRECISION SQNN
      DOUBLE PRECISION WSHSGC
      DOUBLE PRECISION WK
      DOUBLE PRECISION FN
      DIMENSION DV(IDV,JDV,NT),BR(MDB,NDB,NT),BI(MDB,NDB,NT)
      DIMENSION A(MAB,NLAT,NT),B(MAB,NLAT,NT),SQNN(NLAT)
      DIMENSION WSHSGC(LSHSGC),WK(LWK)
c
c     set coefficient multiplyers
c
      DO 1 N = 2,NLAT
          FN = DBLE(N-1)
          SQNN(N) = SQRT(FN* (FN+1.D0))
    1 CONTINUE
c
c     compute divergence scalar coefficients for each vector field
c
      DO 2 K = 1,NT
          DO 3 N = 1,NLAT
              DO 4 M = 1,MAB
                  A(M,N,K) = 0.0D0
                  B(M,N,K) = 0.0D0
    4         CONTINUE
    3     CONTINUE
c
c     compute m=0 coefficients
c
          DO 5 N = 2,NLAT
              A(1,N,K) = -SQNN(N)*BR(1,N,K)
              B(1,N,K) = -SQNN(N)*BI(1,N,K)
    5     CONTINUE
c
c     compute m>0 coefficients using vector spherepack value for mmax
c
          MMAX = MIN0(NLAT, (NLON+1)/2)
          DO 6 M = 2,MMAX
              DO 7 N = M,NLAT
                  A(M,N,K) = -SQNN(N)*BR(M,N,K)
                  B(M,N,K) = -SQNN(N)*BI(M,N,K)
    7         CONTINUE
    6     CONTINUE
    2 CONTINUE
c
c     synthesize a,b into dv
c
      CALL DSHSGC(NLAT,NLON,ISYM,NT,DV,IDV,JDV,A,B,MAB,NLAT,WSHSGC,
     +           LSHSGC,WK,LWK,IERROR)
      RETURN
      END

C
C	$Id: gevtm.f,v 1.6 2008-07-27 00:20:57 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GEVTM(X0,Y0,DX,DY,PHI,SX,SY,SW,MOUT)
C
C  EVALUATE TRANSFORMATION MATRIX
C
      INTEGER EEVTM
      PARAMETER (EEVTM=105)
C
      REAL X0,Y0,DX,DY,PHI,MOUT(2,3)
      INTEGER SW
C
C  Check if GKS is in the proper state.
C
C     CALL GZCKST(8,EEVTM,IER)
C     IF (IER .NE. 0) RETURN
C
C  The transformation takes place in NDC space, so do the
C  appropriate conversions.
C
      IF (SW .EQ. 0) THEN
        CALL GZW2NX(1,X0,XN0)
        CALL GZW2NY(1,Y0,YN0)
        CALL GZW2NX(1,DX,DTX)
        CALL GZW2NX(1,DY,DTY)
        CALL GZW2NX(1,0.,D0X)
        CALL GZW2NX(1,0.,D0Y)
        DNX = DTX - D0X
        DNY = DTY - D0Y
      ELSE
        XN0 = X0
        YN0 = Y0
        DNX = DX
        DNY = DY
      ENDIF        
C
C  Calculate the transformtion matrix.
C
      IF (PHI .EQ. 0.) THEN
        MOUT(1,1) = SX
        MOUT(1,2) = 0.
        MOUT(1,3) = DNX+XN0-XN0*SX
        MOUT(2,1) = 0.
        MOUT(2,2) = SY
        MOUT(2,3) = DNY+YN0-YN0*SY
        GO TO 10
      ELSE
        CPHI = COS(PHI)
        SPHI = SIN(PHI)
C
        MOUT(1,1) =  SX*CPHI
        MOUT(1,2) = -SY*SPHI
        MOUT(1,3) =  DNX+XN0-XN0*SX*CPHI+YN0*SY*SPHI
        MOUT(2,1) =  SX*SPHI
        MOUT(2,2) =  SY*CPHI
        MOUT(2,3) =  DNY+YN0-XN0*SX*SPHI-YN0*SY*CPHI
        GO TO 10
      ENDIF
C
   10 CONTINUE
      RETURN
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C                Copyright (C)  1995                                   C
C        University Corporation for Atmospheric Research               C
C                All Rights Reserved                                   C
C                                                                      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C      File:           tx06f.f
C
C      Author:         Fred Clare (converted to Fortran by 
C                      David Younghans)
C                      National Center for Atmospheric Research
C                      PO 3000, Boulder, Colorado
C                      (translated to Fortran by David Younghans)
C
C      Date:           Mon Nov  27 12:42:08 MST 1995
C
C      Description:    Demonstrates TextItem text justifications.
C
C

      program tx06f
      implicit none
      external NhlFAppClass
      external NhlFNcgmWorkstationClass
      external NhlFCairoWindowWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFTextItemClass

      integer   appid, wid, pid, rlist, ierr
      character*13 labels(9)
      real char_height, Xmarker_height, y_coord
      real bkg_color(3)
      integer just
      real bb_top,bb_bottom,bb_left,bb_right
      character*7  wks_type

      data labels/'Top Left','Center Left','Bottom Left',
     &     'Top Center','Center Center','Bottom Center',
     &     'Top Right','Center Right','Bottom Right'/
      char_height = 0.035
      Xmarker_height = 0.03
      bkg_color(1) = 1.0
      bkg_color(2) = 1.0
      bkg_color(3) = 1.0
C
C Set the display.  Default is to display output to an X workstation.
C
      wks_type = "x11"
C
C  Initialize the high level utility library and create application.
C 
      call NhlFInitialize
      call NhlFRLCreate(rlist,'SETRL')

      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'appUsrDir','./',ierr)
      call NhlFRLSetString(rlist,'appDefaultParent','True',ierr)
      call NhlFCreate(appid,'tx06f',NhlFAppClass,0,rlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create a meta file workstation.
C
        call NhlFRLClear(rlist)
        call NhlFRLSetString(rlist,'wkMetaName','./tx06f.ncgm',ierr)
        call NhlFRLSetFloatArray(rlist,'wkBackgroundColor',
     &       bkg_color,3,ierr)
        call NhlFCreate(wid,'tx06Work',NhlFNcgmWorkstationClass,
     &       0,rlist,ierr)
    
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an XWorkstation object.
C
        call NhlFRLClear(rlist)
        call NhlFRLSetString(rlist,'wkPause','True',ierr)
        call NhlFRLSetFloatArray(rlist,'wkBackgroundColor',
     &       bkg_color,3,ierr)
        call NhlFCreate(wid,'tx06Work',
     &       NhlFCairoWindowWorkstationClass,0,rlist,ierr)

      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PS workstation.
C
        call NhlFRLClear(rlist)
        call NhlFRLSetString(rlist,'wkPSFileName','./tx06f.ps',ierr)
        call NhlFRLSetFloatArray(rlist,'wkBackgroundColor',
     &       bkg_color,3,ierr)
        call NhlFCreate(wid,'tx06Work',NhlFpsWorkstationClass,
     &       0,rlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
        call NhlFRLClear(rlist)
        call NhlFRLSetString(rlist,'wkPDFFileName','./tx06f.pdf',ierr)
        call NhlFRLSetFloatArray(rlist,'wkBackgroundColor',
     &       bkg_color,3,ierr)
        call NhlFCreate(wid,'tx06Work',NhlFpdfWorkstationClass,
     &       0,rlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF workstation.
C
        call NhlFRLClear(rlist)
        call NhlFRLSetString(rlist,'wkFileName','./tx06f',ierr)
        call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
        call NhlFRLSetFloatArray(rlist,'wkBackgroundColor',
     &       bkg_color,3,ierr)
        call NhlFCreate(wid,'tx06Work',
     &       NhlFCairoPSpdfWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG workstation.
C
        call NhlFRLClear(rlist)
        call NhlFRLSetString(rlist,'wkFileName','./tx06f',ierr)
        call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
        call NhlFRLSetFloatArray(rlist,'wkBackgroundColor',
     &       bkg_color,3,ierr)
        call NhlFCreate(wid,'tx06Work',
     &       NhlFCairoImageWorkstationClass,0,rlist,ierr)
      endif
C
C Create a TextItem object.
C
      call NhlFSetColor(wid,1,0.0, 0.0, 1.0,ierr)
      call NhlFSetColor(wid,2,1.0, 0.0, 0.0,ierr)
      call NhlFSetColor(wid,3,0.4, 0.0, 0.4,ierr)

      call NhlFCreate(pid,'TextItem',NhlFtextItemClass,wid,0,ierr)

C
C  Run through the text justifications.
C

      do 100 just=0,8
  
C
C  Set up and draw a text string.
C

      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'txString', labels(just+1),ierr)
      call NhlFRLSetInteger(rlist,'txFontColor', 1,ierr)
      call NhlFRLSetInteger(rlist,'txJust', just,ierr)
      call NhlFRLSetInteger(rlist,'txFont', 22,ierr)
      call NhlFRLSetFloat(rlist,'txFontHeightF', char_height,ierr)
      call NhlFRLSetFloat(rlist,'txPosXF', 0.5,ierr)
      y_coord = 0.08*just+0.1
      if ( (mod(just,3)) .eq. 0) then
         y_coord = y_coord + 0.45*char_height
      
      else if ( (mod(just,3)) .eq. 2) then
         y_coord = y_coord - 0.45*char_height
      
      endif
      call NhlFRLSetFloat(rlist,'txPosYF', y_coord,ierr)
      call NhlFSetValues(pid,rlist,ierr)
      call NhlFDraw(pid,ierr)

C
C  Mark the justification point.
C

      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'txString', 'X',ierr)
      call NhlFRLSetInteger(rlist,'txJust', 4,ierr)
      call NhlFRLSetInteger(rlist,'txFont', 22,ierr)
      call NhlFRLSetFloat(rlist,'txFontHeightF', Xmarker_height,ierr)
      call NhlFRLSetInteger(rlist,'txFontColor', 2,ierr)
      call NhlFSetValues(pid,rlist,ierr)
      call NhlFDraw(pid,ierr)

 100  end do
C
C  Label the plot.
C

      call NhlFRLClear(rlist)
      call NhlFRLSetInteger(rlist,'txFont' ,25,ierr)
      call NhlFRLSetInteger(rlist,'txJust' ,4,ierr)
      call NhlFRLSetInteger(rlist,'txFontColor' ,3,ierr)
      call NhlFRLSetFloat(rlist,'txFontHeightF', 0.045,ierr)
      call NhlFRLSetFloat(rlist,'txPosXF',  0.5,ierr)
      call NhlFRLSetFloat(rlist,'txPosYF',  0.92,ierr)
      call NhlFRLSetString(rlist,'txString', 'Text Justifications',ierr)
      call NhlFSetValues(pid,rlist,ierr)
      call NhlFDraw(pid,ierr)

      call NhlFRLSetFloat(rlist,'txPosXF', 0.5+0.5*char_height,ierr)
      call NhlFRLSetFloat(rlist,'txPosYF', 0.84,ierr)
      call NhlFRLSetString(rlist,'txString', 
     &     ' - Marks the justification point',ierr)
      call NhlFSetValues(pid,rlist,ierr)
      call NhlFDraw(pid,ierr)

      call NhlFGetBB(pid,bb_top,bb_bottom,bb_left,bb_right,ierr)
      call NhlFRLSetInteger(rlist,'txFont' ,22,ierr)
      call NhlFRLSetInteger(rlist,'txFontColor' ,2,ierr)
      call NhlFRLSetFloat(rlist,'txFontHeightF', Xmarker_height,ierr)
      call NhlFRLSetFloat(rlist,'txPosXF',bb_left,ierr)
      call NhlFRLSetFloat(rlist,'txPosYF',  0.837,ierr)
      call NhlFRLSetInteger(rlist,'txJust' ,7,ierr)
      call NhlFRLSetString(rlist,'txString', 'X',ierr)
      call NhlFSetValues(pid,rlist,ierr)
      call NhlFDraw(pid,ierr)

      call NhlFFrame(wid,ierr)

      call NhlFDestroy(pid,ierr)
      call NhlFDestroy(wid,ierr)
      call NhlFClose

      stop
      end

      PROGRAM MPEX14
C
C This program demonstrates how to use EZMAP for various EASE grids.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
        PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Declare stuff required to do color fill.
C
        PARAMETER (LAMA=2000000,NCRA=LAMA/10,NGPS=5)
C
        DIMENSION IAMA(LAMA),XCRA(NCRA),YCRA(NCRA),IAAI(NGPS),IAGI(NGPS)
C
C Declare arrays to use in calls to MAPSET.
C
        DIMENSION PLM1(2),PLM2(2),PLM3(2),PLM4(2)
C
C Set up some equivalences to simplify the passing of limits to MAPSET.
C
        EQUIVALENCE (BLLA,PLM1(1)),(BLLO,PLM2(1))
        EQUIVALENCE (TRLA,PLM3(1)),(TRLO,PLM4(1))
C
        EQUIVALENCE (CLLA,PLM1(1)),(CLLO,PLM1(2))
        EQUIVALENCE (CRLA,PLM2(1)),(CRLO,PLM2(2))
        EQUIVALENCE (BCLA,PLM3(1)),(BCLO,PLM3(2))
        EQUIVALENCE (TCLA,PLM4(1)),(TCLO,PLM4(2))
C
C Declare arrays in which to put labels for the plots.
C
        CHARACTER*14 PLAB(6)
C
C Declare the routines that are used to color the continental map
C backgrounds (one for each of the databases one can use).  COLRCO
C is used with the old continental outlines and COLRE2 with outlines
C from the database "Earth..2".
C
        EXTERNAL COLRCO
        EXTERNAL COLRE2
C
C Choose which continental map background to use.  Set IBKG = 0 for
C the old continental outlines or = 1 for the new outlines from the
C database "Earth..2".
C
        DATA IBKG / 0 /
C       DATA IBKG / 1 /
C
C Define labels to be used on the plots.
C
        DATA PLAB / 'EASE GRID "ML"','EASE GRID "MH"',
     +              'EASE GRID "NL"','EASE GRID "NH"',
     +              'EASE GRID "SL"','EASE GRID "SH"' /
C
C Value of "pi".
C
        DATA PI / 3.14159265358979 /
C
C Conversion constants.
C
        DATA DTOR / .017453292519943 /
        DATA RTOD / 57.2957795130823 /
C
C Radius of the earth, in kilometers.
C
        DATA REKM / 6371.22800000000 /
C
C Forward mapping functions, Northern hemisphere EASE grid (R and S as
C functions of latitude and longitude).
C
        RNOR(XLAT,XLON)=RZRO+2.*(REKM/DCKM)*SIN(XLON)*SIN(PI/4.-XLAT/2.)
        SNOR(XLAT,XLON)=SZRO+2.*(REKM/DCKM)*COS(XLON)*SIN(PI/4.-XLAT/2.)
C
C Forward mapping functions, Southern hemisphere EASE grid (R and S as
C functions of latitude and longitude).
C
        RSOU(XLAT,XLON)=RZRO+2.*(REKM/DCKM)*SIN(XLON)*COS(PI/4.-XLAT/2.)
        SSOU(XLAT,XLON)=SZRO-2.*(REKM/DCKM)*COS(XLON)*COS(PI/4.-XLAT/2.)
C
C Forward mapping functions, global EASE grid (R and S as functions of
C latitude and longitude).
C
        RGLO(XLAT,XLON)=RZRO+(REKM/DCKM)*XLON*(SQRT(3.)/2.)
        SGLO(XLAT,XLON)=SZRO-(REKM/DCKM)*SIN(XLAT)/(SQRT(3.)/2.)
C
C Inverse mapping functions, Northern hemisphere EASE grid (latitude and
C longitude as functions of R and S).
C
        RLAN(RVAL,SVAL)=PI/2.-2.*ASIN(MAX(-1.,MIN(+1.,.5*DCKM*
     +                                      SQRT((RVAL-RZRO)**2+
     +                                           (SVAL-SZRO)**2)/REKM)))
        RLON(RVAL,SVAL)=ATAN2(RVAL-RZRO,SVAL-SZRO)
C
C Inverse mapping functions, Southern hemisphere EASE grid (latitude and
C longitude as functions of R and S).
C
        RLAS(RVAL,SVAL)=PI/2.-2.*ACOS(MAX(-1.,MIN(+1.,.5*DCKM*
     +                                SQRT((RVAL-RZRO)**2+
     +                                     (SVAL-SZRO)**2)/REKM)))
        RLOS(RVAL,SVAL)=ATAN2(RVAL-RZRO,SZRO-SVAL)
C
C Inverse mapping functions, global EASE grid (latitude and longitude as
C functions of R and S).
C
        RLAG(RVAL,SVAL)=ASIN(-(DCKM/REKM)*(SVAL-SZRO)*(SQRT(3.)/2.))
        RLOG(RVAL,SVAL)=      (DCKM/REKM)*(RVAL-RZRO)/(SQRT(3.)/2.)
C
C Open GKS.
C
        CALL GOPKS (IERRF,0)
        CALL GOPWK (IWKID,LUNIT,IWTYPE)
        CALL GACWK (IWKID)
C
C Turn clipping off.
C
        CALL GSCLIP (0)
C
C Define some colors to use (0 = white, the background color; 1 =
C black, the foreground color; 2 is used for oceans; 3 is used for
C land; 4 is used for the grid; and 5 is used for land borders).
C
        CALL GSCR (IWKID,0,1.,1.,1.)
        CALL GSCR (IWKID,1,0.,0.,0.)
        CALL GSCR (IWKID,2,.5,.5,1.)
        CALL GSCR (IWKID,3,.5,1.,.5)
        CALL GSCR (IWKID,4,0.,.6,.6)
        CALL GSCR (IWKID,5,1.,.5,.5)
C
C Tell EZMAP to use a little smaller portion of the plotter frame.
C
        CALL MAPPOS (.1,.9,.5,.9)
C
C Tell PLOTCHAR to use a filled font and to outline the characters.
C
C       CALL PCSETI ('FN',25)
C       CALL PCSETI ('OF',1)
C
C Loop through six possible cases.
C
        DO 103 ICSE=1,6
C
C Set the diameter of a cell, the width and height of the grid, and the
C position of the center of the projection on it.
C
C Case 1: "ML" grid:
C
          IF (ICSE.EQ.1) THEN
C
            PRINT * , ' '
            PRINT * , 'ML GRID:'
            PRINT * , ' '
C
            DCKM=25.06752500000
            WDTH=1383.0
            HGHT= 586.0
            RZRO= 691.0
            SZRO= 292.5
C
            CALL MPSETI ('EL',0)
C
C Case 2: "MH" grid:
C
          ELSE IF (ICSE.EQ.2) THEN
C
            PRINT * , ' '
            PRINT * , 'MH GRID:'
            PRINT * , ' '
C
            DCKM=12.53376250000
            WDTH=2766.0
            HGHT=1171.0
            RZRO=1382.0
            SZRO= 585.0
C
            CALL MPSETI ('EL',0)
C
C Case 3: "NL" grid:
C
          ELSE IF (ICSE.EQ.3) THEN
C
            PRINT * , ' '
            PRINT * , 'NL GRID:'
            PRINT * , ' '
C
            DCKM=25.06752500000
            WDTH= 721.0
            HGHT= 721.0
            RZRO= 360.0
            SZRO= 360.0
C
            CALL MPSETI ('EL',1)
C
C Case 4: "NH" grid:
C
          ELSE IF (ICSE.EQ.4) THEN
C
            PRINT * , ' '
            PRINT * , 'NH GRID:'
            PRINT * , ' '
C
            DCKM=12.53376250000
            WDTH=1441.0
            HGHT=1441.0
            RZRO= 720.0
            SZRO= 720.0
C
            CALL MPSETI ('EL',1)
C
C Case 5: "SL" grid:
C
          ELSE IF (ICSE.EQ.5) THEN
C
            PRINT * , ' '
            PRINT * , 'SL GRID:'
            PRINT * , ' '
C
            DCKM=25.06752500000
            WDTH= 721.0
            HGHT= 721.0
            RZRO= 360.0
            SZRO= 360.0
C
            CALL MPSETI ('EL',1)
C
C Case 6: "SH" grid:
C
          ELSE IF (ICSE.EQ.6) THEN
C
            PRINT * , ' '
            PRINT * , 'SH GRID:'
            PRINT * , ' '
C
            DCKM=12.53376250000
            WDTH=1441.0
            HGHT=1441.0
            RZRO= 720.0
            SZRO= 720.0
C
            CALL MPSETI ('EL',1)
C
          END IF
C
C For cases 1 and 2, compute and print the lat/lon coordinates of the
C corner points of the grid and initialize the cylindrical equal-area
C projection using them.
C
          IF (ICSE.EQ.1.OR.ICSE.EQ.2) THEN
C
            TLLA=RTOD*RLAG(    -.5,    -.5)
            TLLO=RTOD*RLOG(    -.5,    -.5)
            TRLA=RTOD*RLAG(WDTH-.5,    -.5)
            TRLO=RTOD*RLOG(WDTH-.5,    -.5)
            BLLA=RTOD*RLAG(    -.5,HGHT-.5)
            BLLO=RTOD*RLOG(    -.5,HGHT-.5)
            BRLA=RTOD*RLAG(WDTH-.5,HGHT-.5)
            BRLO=RTOD*RLOG(WDTH-.5,HGHT-.5)
C
            PRINT * , 'TOP LEFT LATITUDE:     ',TLLA
            PRINT * , 'TOP LEFT LONGITUDE:    ',TLLO
            PRINT * , 'TOP RIGHT LATITUDE:    ',TRLA
            PRINT * , 'TOP RIGHT LONGITUDE:   ',TRLO
            PRINT * , 'BOTTOM LEFT LATITUDE:  ',BLLA
            PRINT * , 'BOTTOM LEFT LONGITUDE: ',BLLO
            PRINT * , 'BOTTOM RIGHT LATITUDE: ',BRLA
            PRINT * , 'BOTTOM RIGHT LONGITUDE:',BRLO
C
C Initialize EZMAP to use the projection 'EA' and tell it what portion
C of the projection to use.
C
            CALL MAPROJ ('EA',0.,(TLLO+TRLO)/2.,0.)
C
            CALL MAPSET ('CO',PLM1,PLM2,PLM3,PLM4)
C
C For cases 3 and 4, compute and print the lat/lon coordinates of the
C center points of the edges of the grid and initialize the Lambert
C equal-area projection using them, centering it at the North Pole.
C
          ELSE IF (ICSE.EQ.3.OR.ICSE.EQ.4) THEN
C
            TCLA=RTOD*RLAN(.5*WDTH-.5,       -.5)
            TCLO=RTOD*RLON(.5*WDTH-.5,       -.5)
            CLLA=RTOD*RLAN(       -.5,.5*HGHT-.5)
            CLLO=RTOD*RLON(       -.5,.5*HGHT-.5)
            CRLA=RTOD*RLAN(   WDTH-.5,.5*HGHT-.5)
            CRLO=RTOD*RLON(   WDTH-.5,.5*HGHT-.5)
            BCLA=RTOD*RLAN(.5*WDTH-.5,   HGHT-.5)
            BCLO=RTOD*RLON(.5*WDTH-.5,   HGHT-.5)
C
            PRINT * , 'TOP CENTER LATITUDE:    ',TCLA
            PRINT * , 'TOP CENTER LONGITUDE:   ',TCLO
            PRINT * , 'CENTER LEFT LATITUDE:   ',CLLA
            PRINT * , 'CENTER LEFT LONGITUDE:  ',CLLO
            PRINT * , 'CENTER RIGHT LATITUDE:  ',CRLA
            PRINT * , 'CENTER RIGHT LONGITUDE: ',CRLO
            PRINT * , 'BOTTOM CENTER LATITUDE: ',BCLA
            PRINT * , 'BOTTOM CENTER LONGITUDE:',BCLO
C
C Initialize EZMAP to use the projection 'LE', centered at the North
C Pole, and tell it what portion of the projection to use.
C
            CALL MAPROJ ('LE',+90.,0.,0.)
C
            CALL MAPSET ('PO',PLM1,PLM2,PLM3,PLM4)
C
C For cases 5 and 6, compute and print the lat/lon coordinates of the
C center points of the edges of the grid and initialize the Lambert
C equal-area projection using them, centering it at the South Pole.
C
          ELSE
C
            TCLA=RTOD*RLAS(.5*WDTH-.5,       -.5)
            TCLO=RTOD*RLOS(.5*WDTH-.5,       -.5)
            CLLA=RTOD*RLAS(       -.5,.5*HGHT-.5)
            CLLO=RTOD*RLOS(       -.5,.5*HGHT-.5)
            CRLA=RTOD*RLAS(   WDTH-.5,.5*HGHT-.5)
            CRLO=RTOD*RLOS(   WDTH-.5,.5*HGHT-.5)
            BCLA=RTOD*RLAS(.5*WDTH-.5,   HGHT-.5)
            BCLO=RTOD*RLOS(.5*WDTH-.5,   HGHT-.5)
C
            PRINT * , 'TOP CENTER LATITUDE:    ',TCLA
            PRINT * , 'TOP CENTER LONGITUDE:   ',TCLO
            PRINT * , 'CENTER LEFT LATITUDE:   ',CLLA
            PRINT * , 'CENTER LEFT LONGITUDE:  ',CLLO
            PRINT * , 'CENTER RIGHT LATITUDE:  ',CRLA
            PRINT * , 'CENTER RIGHT LONGITUDE: ',CRLO
            PRINT * , 'BOTTOM CENTER LATITUDE: ',BCLA
            PRINT * , 'BOTTOM CENTER LONGITUDE:',BCLO
C
C Initialize EZMAP to use the projection 'LE', centered at the South
C Pole, and tell it what portion of the projection to use.
C
            CALL MAPROJ ('LE',-90.,0.,0.)
C
            CALL MAPSET ('PO',PLM1,PLM2,PLM3,PLM4)
C
          END IF
C
C Write appropriate labels at the top of the frame.
C
          CALL PLCHHQ (CFUX(.5),CFUY(.975),PLAB(ICSE),.015,0.,0.)
          CALL PLCHHQ (CFUX(.5),CFUY(.948),'(Only every 20th grid line i
     +s shown.)',
     +                                                       .015,0.,0.)
C
C Draw a color-filled map.
C
          CALL ARINAM (IAMA,LAMA)
C
          IF (IBKG.EQ.0) THEN
            CALL MDPBLA (IAMA)
            CALL ARSCAM (IAMA,XCRA,YCRA,NCRA,IAAI,IAGI,NGPS,COLRCO)
            CALL GSPLCI (5)
            CALL MDPLOT
          ELSE
            CALL MDLNAM ('Earth..2',2,IAMA)
            CALL ARSCAM (IAMA,XCRA,YCRA,NCRA,IAAI,IAGI,NGPS,COLRE2)
            CALL GSPLCI (5)
            CALL MDLNDR ('Earth..2',2)
          END IF
C
          CALL GSPLCI (1)
C
C         CALL MDPGRD
C
C Overlay a grid.
C
          CALL GSPLCI (4)
C
C Horizontal lines.
C
          SMIN=-.5
          SMAX=HGHT-.5
C
          VMIN=-(DCKM/REKM)*(SMIN-SZRO)
          VMAX=-(DCKM/REKM)*(SMAX-SZRO)
C
          IF (ICSE.EQ.1.OR.ICSE.EQ.2) THEN
            VMIN=2.*VMIN/SQRT(3.)
            VMAX=2.*VMAX/SQRT(3.)
          END IF
C

          DO 101 I=0,INT(WDTH),20
C
            RVAL=REAL(I)-.5
            UVAL=(DCKM/REKM)*(RVAL-RZRO)
C
            IF (ICSE.EQ.1.OR.ICSE.EQ.2) THEN
              UVAL=2.*UVAL/SQRT(3.)
            END IF
C
            CALL LINE (UVAL,VMIN,UVAL,VMAX)
C
  101     CONTINUE
C
C Vertical lines.
C
          RMIN=-.5
          RMAX=WDTH-.5
C
          UMIN=(DCKM/REKM)*(RMIN-RZRO)
          UMAX=(DCKM/REKM)*(RMAX-RZRO)
C
          IF (ICSE.EQ.1.OR.ICSE.EQ.2) THEN
            UMIN=2.*UMIN/SQRT(3.)
            UMAX=2.*UMAX/SQRT(3.)
          END IF
C
          DO 102 J=0,INT(HGHT),20
C
            SVAL=REAL(J)-.5
            VVAL=-(DCKM/REKM)*(SVAL-SZRO)
C
            IF (ICSE.EQ.1.OR.ICSE.EQ.2) THEN
              VVAL=2.*VVAL/SQRT(3.)
            END IF
C
            CALL LINE (UMIN,VVAL,UMAX,VVAL)
C
  102     CONTINUE
C
          CALL GSPLCI (1)
C
C Annotate the plot.
C
          CALL GSFACI (1)
C
          CALL GETSET (XVPL,XVPR,YVPB,YVPT,ULFT,URGT,VBOT,VTOP,LNLG)
C
          CALL DRWAWL (XVPL,YVPT+.02,XVPR,YVPT+.02,'r',.015)
          CALL DRWAWL (XVPL-.02,YVPT,XVPL-.02,YVPB,'s',.015)
          CALL DRWAWL (XVPL,YVPB-.02,XVPR,YVPB-.02,'u',.015)
          CALL DRWAWL (XVPR+.02,YVPB,XVPR+.02,YVPT,'v',.015)
C
          IF (ICSE.EQ.1) THEN
            CALL DRWAWL (XVPL,.5*(YVPB+YVPT),
     +                   XVPR,.5*(YVPB+YVPT),':G:k:R:',.015)
            CALL DRWAWL (.5*(XVPL+XVPR),YVPB,
     +                   .5*(XVPL+XVPR),YVPT,':G:u:R:',.015)
            CALL PLCHHQ (CFUX(.500),CFUY(.450),'r = r:B:0:N:+(sqrt(3)/2)
     +(R/C):G:k:R: and s = s:B:0:N:-(2/sqrt(3))(R/C)sin(:G:u:R:).',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.428),'r runs from -.5 (left) t
     +o 1382.5 (right), s from -.5 (top) to 585.5 (bottom).',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.384), ':G:k:R: and :G:u:R: are
     + longitude and latitude, in radians.  Note that',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.362),':G:k:R: = (2/sqrt(3))(C/
     +R)(r-r:B:0:N:) and :G:u:R: = sin:S:-1:N:((sqrt(3)/2)(C/R)(s-s:B:0:
     +N:)).  :G:k:R: runs from ',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.340),'-180:S:o:N: (left) to 18
     +0:S:o:N: (right), :G:u:R: from -86.7168:S:o:N:(bottom) to 86.7168:
     +S:o:N: (top).',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.296),'EZMAP''s Cylindrical Equ
     +al-area projection maps :G:k:R: and :G:u:R: to u and v, where',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.274),'u = :G:k:R: and v = (4/3
     +)sin(:G:u:R:), which means that',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.252), ':G:k:R: = u and :G:u:R:
     + = sin:S:-1:N:((3/4)v)',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.208),'r = r:B:0:N:+(sqrt(3)/2)
     +(R/C)u and s = s:B:0:N:-(sqrt(3)/2)(R/C)v, so',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.186),'u=(2/sqrt(3))(C/R)(r-r:B
     +:0:N:) and v=-(2/sqrt(3))(C/R)(s-s:B:0:N:).',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.142), 'R = 6371.228 km (radius
     + of Earth),',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.120),'C = 25.067525 km (nomina
     +l cell diameter),',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.098),'r:B:0:N: = 691.0, and s:
     +B:0:N: = 292.5.',
     +                                                       .011,0.,0.)
            CALL PCSETC ('FC','|')
            CALL PLCHHQ (CFUX(.500),CFUY(.025),'For more information, se
     +e "http://nsidc.org/data/ease"',
     +                                                       .011,0.,0.)
            CALL PCSETC ('FC',':')
          ELSE IF (ICSE.EQ.2) THEN
            CALL DRWAWL (XVPL,.5*(YVPB+YVPT),
     +                   XVPR,.5*(YVPB+YVPT),':G:k:R:',.015)
            CALL DRWAWL (.5*(XVPL+XVPR),YVPB,
     +                   .5*(XVPL+XVPR),YVPT,':G:u:R:',.015)
            CALL PLCHHQ (CFUX(.500),CFUY(.450),'r = r:B:0:N:+(sqrt(3)/2)
     +(R/C):G:k:R: and s = s:B:0:N:-(2/sqrt(3))(R/C)sin(:G:u:R:).',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.428),'r runs from -.5 (left) t
     +o 2765.5 (right), s from -.5 (top) to 1170.5 (bottom).',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.384), ':G:k:R: and :G:u:R: are
     + longitude and latitude, in radians.  Note that',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.362),':G:k:R: = (2/sqrt(3))(C/
     +R)(r-r:B:0:N:) and :G:u:R: = sin:S:-1:N:((sqrt(3)/2)(C/R)(s-s:B:0:
     +N:)).  :G:k:R: runs from',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.340),'-179.935:S:o:N: (left) t
     +o 180.065:S:o:N: (right), :G:u:R: from -85.9533:S:o:N:(bottom) to
     +85.9533:S:o:N: (top).',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.296),'EZMAP''s Cylindrical Equ
     +al-area projection maps :G:k:R: and :G:u:R: to u and v, where',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.274),'u = :G:k:R: and v = (4/3
     +)sin(:G:u:R:), which means that',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.252), ':G:k:R: = u and :G:u:R:
     + = sin:S:-1:N:((3/4)v)',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.208),'r = r:B:0:N:+(sqrt(3)/2)
     +(R/C)u and s = s:B:0:N:-(sqrt(3)/2)(R/C)v, so',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.186),'u=(2/sqrt(3))(C/R)(r-r:B
     +:0:N:) and v=-(2/sqrt(3))(C/R)(s-s:B:0:N:).',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.142), 'R = 6371.228 km (radius
     + of Earth),',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.120),'C = 12.5337625 km (nomin
     +al cell diameter),',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.098),'r:B:0:N: = 1382.0, and s
     +:B:0:N: = 585.0.',
     +                                                       .011,0.,0.)
            CALL PCSETC ('FC','|')
            CALL PLCHHQ (CFUX(.500),CFUY(.025),'For more information, se
     +e "http://nsidc.org/data/ease"',
     +                                                       .011,0.,0.)
            CALL PCSETC ('FC',':')
          ELSE IF (ICSE.EQ.3) THEN
            CALL DRWCWL (.5*(XVPL+XVPR),.5*(YVPB+YVPT),.5*(XVPR-XVPL),
     +                   -90.,-50.,-40.,270.,':G:k:R:',.015)
            CALL DRWAWL (.5*(XVPL+XVPR),    YVPB      ,
     +                   .5*(XVPL+XVPR),.5*(YVPB+YVPT),':G:u:R:',.015)
            CALL PLCHHQ (CFUX(.500),CFUY(.450),'r = r:B:0:N:+(2R/C)sin(:
     +G:k:R:)sin(:G:p:R:/4-:G:u:R:/2) and s = s:B:0:N:+(2R/C)cos(:G:k:R:
     +)sin(:G:p:R:/4-:G:u:R:/2).',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.428),'r runs from -.5 (left) t
     +o 720.5 (right), s from -.5 (top) to 720.5 (bottom).',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.384), ':G:k:R: and :G:u:R: are
     + longitude and latitude, in radians.  Note that',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.362),':G:k:R: = tan:S:-1:N:((r
     +-r:B:0:N:)/(s-s:B:0:N:)) and :G:u:R: = :G:p:R:/2-2sin:S:-1:N:((C/2
     +R)sqrt((r-r:B:0:N:):S:2:N:+(s-s:B:0:N:):S:2:N:))',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.340),':G:u:R: runs from -.3383
     +61:S:o:N: at any edge center to 90:S:o:N: at the grid center.',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.296),'EZMAP''s Lambert Equal-a
     +rea projection maps :G:k:R: and :G:u:R: to u and v, where',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.274),'u = 2sin(:G:k:R:)sin(:G:
     +p:R:/4-:G:u:R:/2) and v = -2cos(:G:k:R:)sin(:G:p:R:/4-:G:u:R:/2),
     +which means that',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.252),':G:k:R: = tan:S:-1:N:(-u
     +/v) and :G:u:R: = :G:p:R:/2-2*sin:S:-1:N:(sqrt(u:S:2:N:+v:S:2:N:)/
     +4)',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.208), 'r = r:B:0:N:+(R/C)u and
     + s = s:B:0:N:-(R/C)v, so',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.186), 'u=(C/R)(r-r:B:0:N:) and
     + v=-(C/R)(s-s:B:0:N:).',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.142), 'R = 6371.228 km (radius
     + of Earth),',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.120),'C = 25.067525 km (nomina
     +l cell diameter),',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.098),'r:B:0:N: = 360.0, and s:
     +B:0:N: = 360.0.',
     +                                                       .011,0.,0.)
            CALL PCSETC ('FC','|')
            CALL PLCHHQ (CFUX(.500),CFUY(.025),'For more information, se
     +e "http://nsidc.org/data/ease"',
     +                                                       .011,0.,0.)
            CALL PCSETC ('FC',':')
          ELSE IF (ICSE.EQ.4) THEN
            CALL DRWCWL (.5*(XVPL+XVPR),.5*(YVPB+YVPT),.5*(XVPR-XVPL),
     +                   -90.,-50.,-40.,270.,':G:k:R:',.015)
            CALL DRWAWL (.5*(XVPL+XVPR),    YVPB      ,
     +                   .5*(XVPL+XVPR),.5*(YVPB+YVPT),':G:u:R:',.015)
            CALL PLCHHQ (CFUX(.500),CFUY(.450),'r = r:B:0:N:+(2R/C)sin(:
     +G:k:R:)sin(:G:p:R:/4-:G:u:R:/2) and s = s:B:0:N:+(2R/C)cos(:G:k:R:
     +)sin(:G:p:R:/4-:G:u:R:/2).',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.428),'r runs from -.5 (left) t
     +o 1440.5 (right), s from -.5 (top) to 1440.5 (bottom).',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.384), ':G:k:R: and :G:u:R: are
     + longitude and latitude, in radians.  Note that',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.362),':G:k:R: = tan:S:-1:N:((r
     +-r:B:0:N:)/(s-s:B:0:N:)) and :G:u:R: = :G:p:R:/2-2sin:S:-1:N:((C/2
     +R)sqrt((r-r:B:0:N:):S:2:N:+(s-s:B:0:N:):S:2:N:))',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.340),':G:u:R: runs from -.3383
     +61:S:o:N: at any edge center to 90:S:o:N: at the grid center.',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.296),'EZMAP''s Lambert Equal-a
     +rea projection maps :G:k:R: and :G:u:R: to u and v, where',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.274),'u = 2sin(:G:k:R:)sin(:G:
     +p:R:/4-:G:u:R:/2) and v = -2cos(:G:k:R:)sin(:G:p:R:/4-:G:u:R:/2),
     +which means that',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.252),':G:k:R: = tan:S:-1:N:(-u
     +/v) and :G:u:R: = :G:p:R:/2-2*sin:S:-1:N:(sqrt(u:S:2:N:+v:S:2:N:)/
     +4)',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.208), 'r = r:B:0:N:+(R/C)u and
     + s = s:B:0:N:-(R/C)v, so',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.186), 'u=(C/R)(r-r:B:0:N:) and
     + v=-(C/R)(s-s:B:0:N:).',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.142), 'R = 6371.228 km (radius
     + of Earth),',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.120),'C = 12.5337625 km (nomin
     +al cell diameter),',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.098),'r:B:0:N: = 720.0, and s:
     +B:0:N: = 720.0.',
     +                                                       .011,0.,0.)
            CALL PCSETC ('FC','|')
            CALL PLCHHQ (CFUX(.500),CFUY(.025),'For more information, se
     +e "http://nsidc.org/data/ease"',
     +                                                       .011,0.,0.)
            CALL PCSETC ('FC',':')
          ELSE IF (ICSE.EQ.5) THEN
            CALL DRWCWL (.5*(XVPL+XVPR),.5*(YVPB+YVPT),.5*(XVPR-XVPL),
     +                   90.,50.,40.,-270.,':G:k:R:',.015)
            CALL DRWAWL (.5*(XVPL+XVPR),.5*(YVPB+YVPT),
     +                   .5*(XVPL+XVPR),         YVPT ,':G:u:R:',.015)
            CALL PLCHHQ (CFUX(.500),CFUY(.450),'r = r:B:0:N:+(2R/C)sin(:
     +G:k:R:)cos(:G:p:R:/4-:G:u:R:/2) and s = s:B:0:N:-(2R/C)cos(:G:k:R:
     +)cos(:G:p:R:/4-:G:u:R:/2).',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.428),'r runs from -.5 (left) t
     +o 720.5 (right), s from -.5 (top) to 720.5 (bottom).',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.384), ':G:k:R: and :G:u:R: are
     + longitude and latitude, in radians.  Note that',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.362),':G:k:R: = tan:S:-1:N:(-(
     +r-r:B:0:N:)/(s-s:B:0:N:)) and :G:u:R: = :G:p:R:/2-2cos:S:-1:N:((C/
     +2R)sqrt((r-r:B:0:N:):S:2:N:+(s-s:B:0:N:):S:2:N:))',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.340),':G:u:R: runs from -90:S:
     +o:N: at the grid center to +.338361:S:o:N: at any edge center.',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.296),'EZMAP''s Lambert Equal-a
     +rea projection maps :G:k:R: and :G:u:R: to u and v, where',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.274),'u = 2sin(:G:k:R:)cos(:G:
     +p:R:/4-:G:u:R:/2) and v = 2cos(:G:k:R:)cos(:G:p:R:/4-:G:u:R:/2), w
     +hich means that',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.252),':G:k:R: = tan:S:-1:N:(u/
     +v) and :G:u:R: = :G:p:R:/2-2*cos:S:-1:N:(sqrt(u:S:2:N:+v:S:2:N:)/4
     +)',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.208), 'r = r:B:0:N:+(R/C)u and
     + s = s:B:0:N:-(R/C)v, so',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.186), 'u=(C/R)(r-r:B:0:N:) and
     + v=-(C/R)(s-s:B:0:N:).',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.142), 'R = 6371.228 km (radius
     + of Earth),',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.120),'C = 25.067525 km (nomina
     +l cell diameter),',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.098),'r:B:0:N: = 360.0, and s:
     +B:0:N: = 360.0.',
     +                                                       .011,0.,0.)
            CALL PCSETC ('FC','|')
            CALL PLCHHQ (CFUX(.500),CFUY(.025),'For more information, se
     +e "http://nsidc.org/data/ease"',
     +                                                       .011,0.,0.)
            CALL PCSETC ('FC',':')
          ELSE IF (ICSE.EQ.6) THEN
            CALL DRWCWL (.5*(XVPL+XVPR),.5*(YVPB+YVPT),.5*(XVPR-XVPL),
     +                   90.,50.,40.,-270.,':G:k:R:',.015)
            CALL DRWAWL (.5*(XVPL+XVPR),.5*(YVPB+YVPT),
     +                   .5*(XVPL+XVPR),         YVPT ,':G:u:R:',.015)
            CALL PLCHHQ (CFUX(.500),CFUY(.450),'r = r:B:0:N:+(2R/C)sin(:
     +G:k:R:)cos(:G:p:R:/4-:G:u:R:/2) and s = s:B:0:N:-(2R/C)cos(:G:k:R:
     +)cos(:G:p:R:/4-:G:u:R:/2).',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.428),'r runs from -.5 (left) t
     +o 1440.5 (right), s from -.5 (top) to 1440.5 (bottom).',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.384), ':G:k:R: and :G:u:R: are
     + longitude and latitude, in radians.  Note that',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.362),':G:k:R: = tan:S:-1:N:(-(
     +r-r:B:0:N:)/(s-s:B:0:N:)) and :G:u:R: = :G:p:R:/2-2cos:S:-1:N:((C/
     +2R)sqrt((r-r:B:0:N:):S:2:N:+(s-s:B:0:N:):S:2:N:))',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.340),':G:u:R: runs from -90:S:
     +o:N: at the grid center to .258454:S:o:N: at any edge center.',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.296),'EZMAP''s Lambert Equal-a
     +rea projection maps :G:k:R: and :G:u:R: to u and v, where',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.274),'u = 2sin(:G:k:R:)cos(:G:
     +p:R:/4-:G:u:R:/2) and v = 2cos(:G:k:R:)cos(:G:p:R:/4-:G:u:R:/2), w
     +hich means that',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.252),':G:k:R: = tan:S:-1:N:(u/
     +v) and :G:u:R: = :G:p:R:/2-2*cos:S:-1:N:(sqrt(u:S:2:N:+v:S:2:N:)/4
     +)',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.208), 'r = r:B:0:N:+(R/C)u and
     + s = s:B:0:N:-(R/C)v, so',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.186), 'u=(C/R)(r-r:B:0:N:) and
     + v=-(C/R)(s-s:B:0:N:).',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.142), 'R = 6371.228 km (radius
     + of Earth),',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.120),'C = 12.5337625 km (nomin
     +al cell diameter),',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.098),'r:B:0:N: = 720.0, and s:
     +B:0:N: = 720.0.',
     +                                                       .011,0.,0.)
            CALL PCSETC ('FC','|')
            CALL PLCHHQ (CFUX(.500),CFUY(.025),'For more information, se
     +e "http://nsidc.org/data/ease"',
     +                                                       .011,0.,0.)
            CALL PCSETC ('FC',':')
          END IF
C
C Advance the frame.
C
          CALL FRAME
C
C End of case loop.
C
  103   CONTINUE
C
C Close GKS.
C
        CALL GDAWK (IWKID)
        CALL GCLWK (IWKID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END


      SUBROUTINE COLRCO (XCRA,YCRA,NCRA,IAAI,IAGI,NGPS)
        DIMENSION XCRA(NCRA),YCRA(NCRA),IAAI(NGPS),IAGI(NGPS)
        IAI1=-1
        DO 101 IGRP=1,NGPS
          IF (IAGI(IGRP).EQ.1) IAI1=IAAI(IGRP)
  101   CONTINUE
        IF (IAI1.GT.0) THEN
          IF (MDPACI(IAI1).EQ.1) THEN
C           LAND
            CALL GSFACI (2)
          ELSE
C           LAND
            CALL GSFACI (3)
          END IF
          CALL GFA    (NCRA-1,XCRA,YCRA)
        END IF
        RETURN
      END


      SUBROUTINE COLRE2 (XCRA,YCRA,NCRA,IAAI,IAGI,NGPS)
        DIMENSION XCRA(NCRA),YCRA(NCRA),IAAI(NGPS),IAGI(NGPS)
        IAI1=-1
        DO 101 IGRP=1,NGPS
          IF (IAGI(IGRP).EQ.1) IAI1=IAAI(IGRP)
  101   CONTINUE
        IF (IAI1.GT.0) THEN
          IF (MDIPAN(IAI1,'Water').NE.0) THEN
C           OCEAN
            CALL GSFACI (2)
          ELSE
C           LAND
            CALL GSFACI (3)
          END IF
          CALL GFA    (NCRA-1,XCRA,YCRA)
        END IF
        RETURN
      END


      SUBROUTINE DRWAWL (XBEG,YBEG,XEND,YEND,CHLB,CHSZ)
C
        CHARACTER*(*) CHLB
C
C This routine draws an arrow from the position (XBEG,YBEG) to the
C position (XEND,YEND) and labels it with the single character from
C CHLB, using a width of CHSZ.  The position and size are given in
C the fractional coordinate system.
C
C Double the line width.
C
        CALL PLOTIF (0.,0.,2)
        CALL GSLWSC (2.)
C
C Compute the X and Y differences along the arrow.
C
        XDIF=XEND-XBEG
        YDIF=YEND-YBEG
C
C Compute direction cosines for the arrow.
C
        ALEN=SQRT(XDIF*XDIF+YDIF*YDIF)
C
        XDCS=XDIF/ALEN
        YDCS=YDIF/ALEN
C
C Draw the body of the arrow, leaving a gap for the character label.
C
        CALL PLOTIF (XBEG,YBEG,0)
        CALL PLOTIF (XBEG+.25*XDIF-CHSZ*XDCS,YBEG+.25*YDIF-CHSZ*YDCS,1)
        CALL PLOTIF (XBEG+.25*XDIF+CHSZ*XDCS,YBEG+.25*YDIF+CHSZ*YDCS,0)
        CALL PLOTIF (XEND,YEND,1)
C
C Draw the arrowhead, making it the same size as the character label.
C
        CALL PLOTIF (XEND-CHSZ*XDCS-.5*CHSZ*YDCS,
     +               YEND-CHSZ*YDCS+.5*CHSZ*XDCS,0)
        CALL PLOTIF (XEND,YEND,1)
C
        CALL PLOTIF (XEND-CHSZ*XDCS+.5*CHSZ*YDCS,
     +               YEND-CHSZ*YDCS-.5*CHSZ*XDCS,0)
        CALL PLOTIF (XEND,YEND,1)
C
C Insert the label.
C
        CALL PCSETI ('CE',1)
        CALL PLCHHQ (CFUX(XBEG+.25*XDIF),CFUY(YBEG+.25*YDIF),CHLB,CHSZ,
     +                                                           0.,0.)
        CALL PCSETI ('CE',0)
C
C Reset the line width.
C
        CALL PLOTIF (0.,0.,2)
        CALL GSLWSC (1.)
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE DRWCWL (XCEN,YCEN,RADI,ANG1,ANG2,ANG3,ANG4,CHLB,CHSZ)
C
        CHARACTER*(*) CHLB
C
C This routine draws a circular arc centered at (XCEN,YCEN) and having
C radius RADI.  The arc begins at ANG1 and stops at ANG2, starts again
C at ANG3 and stops at ANG4.  The single character from CHLB is written
C in the gap between ANG2 and ANG3, using a character width of CHSZ.
C An arrow is placed at ANG4.  Positions and size are given in the
C fractional coordinate system, angles are given in degrees.
C
C Conversion constants.
C
        DATA DTOR / .017453292519943 /
        DATA RTOD / 57.2957795130823 /
C
C Double the line width.
C
        CALL PLOTIF (0.,0.,2)
        CALL GSLWSC (2.)
C
C Draw the first arc.
C
        CALL PLOTIF (XCEN+RADI*COS(DTOR*ANG1),
     +               YCEN+RADI*SIN(DTOR*ANG1),0)
C
        NSTP=MAX(0,INT(ABS(ANG2-ANG1)/5)-1)
C
        DO 101 I=1,NSTP
          ANGI=(ANG1*REAL(NSTP-I+1)+ANG2*REAL(I))/REAL(NSTP+1)
          CALL PLOTIF (XCEN+RADI*COS(DTOR*ANGI),
     +                 YCEN+RADI*SIN(DTOR*ANGI),1)
  101   CONTINUE
C
        CALL PLOTIF (XCEN+RADI*COS(DTOR*ANG2),
     +               YCEN+RADI*SIN(DTOR*ANG2),1)
C
C Draw the second arc.
C
        CALL PLOTIF (XCEN+RADI*COS(DTOR*ANG3),
     +               YCEN+RADI*SIN(DTOR*ANG3),0)
C
        NSTP=MAX(0,INT(ABS(ANG4-ANG3)/5)-1)
C
        DO 102 I=1,NSTP
          ANGI=(ANG3*REAL(NSTP-I+1)+ANG4*REAL(I))/REAL(NSTP+1)
          CALL PLOTIF (XCEN+RADI*COS(DTOR*ANGI),
     +                 YCEN+RADI*SIN(DTOR*ANGI),1)
  102   CONTINUE
C
        CALL PLOTIF (XCEN+RADI*COS(DTOR*ANG4),
     +               YCEN+RADI*SIN(DTOR*ANG4),1)
C
C Save the final position of the second arc.
C
        XEND=XCEN+RADI*COS(DTOR*ANG4)
        YEND=YCEN+RADI*SIN(DTOR*ANG4)
C
C Compute direction cosines for the arrowhead.
C
        XDCS=COS(DTOR*(ANG4+SIGN(90.,ANG4-ANG3)))
        YDCS=SIN(DTOR*(ANG4+SIGN(90.,ANG4-ANG3)))
C
C Draw the arrowhead, making it the same size as the character label.
C
        CALL PLOTIF (XEND-CHSZ*XDCS-.5*CHSZ*YDCS,
     +               YEND-CHSZ*YDCS+.5*CHSZ*XDCS,0)
        CALL PLOTIF (XEND,YEND,1)
C
        CALL PLOTIF (XEND-CHSZ*XDCS+.5*CHSZ*YDCS,
     +               YEND-CHSZ*YDCS-.5*CHSZ*XDCS,0)
        CALL PLOTIF (XEND,YEND,1)
C
C Insert the label.
C
        CALL PCSETI ('CE',1)
C
        CALL PLCHHQ (CFUX(XCEN+RADI*COS(.5*DTOR*(ANG2+ANG3))),
     +               CFUY(YCEN+RADI*SIN(.5*DTOR*(ANG2+ANG3))),
     +                                                  CHLB,CHSZ,0.,0.)
C
        CALL PCSETI ('CE',0)
C
C Reset the line width.
C
        CALL PLOTIF (0.,0.,2)
        CALL GSLWSC (1.)
C
C Done.
C
        RETURN
C
      END

C
C $Id: mdprst.f,v 1.10 2008-09-18 12:19:11 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MDPRST (IFNO)
C
        INTEGER IFNO
C
C Declare required common blocks.  See MAPBDX for descriptions of these
C common blocks and the variables in them.
C
        COMMON /MAPCM3/  ITPN,NOUT,NPTS,IGID,IDLS,IDRS,BLAG,SLAG,BLOG,
     +                   SLOG,PNTS(200),IDOS(4)
        INTEGER          ITPN,NOUT,NPTS,IGID,IDLS,IDRS,IDOS
        REAL             BLAG,SLAG,BLOG,SLOG,PNTS
        SAVE   /MAPCM3/
C
        COMMON /MAPCM4/  GRDR,GRID,GRLA,GRLO,GRPO,OTOL,PDRE,PLA1,PLA2,
     +                   PLA3,PLA4,PLB1,PLB2,PLB3,PLB4,PLNO,PLTO,ROTA,
     +                   SRCH,XLOW,XROW,YBOW,YTOW,IDOT,IDSH,IDTL,ILCW,
     +                   ILTS,JPRJ,ELPF,INTF,LBLF,PRMF
        DOUBLE PRECISION GRDR,GRID,GRLA,GRLO,GRPO,OTOL,PDRE,PLA1,PLA2,
     +                   PLA3,PLA4,PLB1,PLB2,PLB3,PLB4,PLNO,PLTO,ROTA,
     +                   SRCH,XLOW,XROW,YBOW,YTOW
        INTEGER          IDOT,IDSH,IDTL,ILCW,ILTS,JPRJ
        LOGICAL          ELPF,INTF,LBLF,PRMF
        SAVE   /MAPCM4/
C
        COMMON /MAPCMA/  DATL,DBTD,DDTS,DPLT,DPSQ,DSCA,DSSQ
        DOUBLE PRECISION DATL,DBTD,DDTS,DPLT,DPSQ,DSCA,DSSQ
        SAVE   /MAPCMA/
C
        COMMON /MAPCMC/  IGI1,IGI2,NCRA,NOVS,XCRA(100),YCRA(100)
        INTEGER          IGI1,IGI2,NCRA,NOVS
        REAL             XCRA,YCRA
        SAVE   /MAPCMC/
C
        COMMON /MAPCMQ/  ICIN(8)
        INTEGER          ICIN
        SAVE   /MAPCMQ/
C
        COMMON /MAPCMW/  CSLS,CSLT,SLTD,ISLT
        DOUBLE PRECISION CSLS,CSLT,SLTD
        INTEGER ISLT
        SAVE   /MAPCMW/
C
        COMMON /MAPRGD/  ICOL(5),ICSF(5),IDPF,LCRA,NILN,NILT,OLAT,OLON
        INTEGER          ICOL,ICSF,IDPF,LCRA,NILN,NILT
        REAL             OLAT,OLON
        SAVE   /MAPRGD/
C
        COMMON /MAPSAT/  ALFA,BETA,DCSA,DCSB,DSNA,DSNB,SALT,SSMO,SRSS
        DOUBLE PRECISION ALFA,BETA,DCSA,DCSB,DSNA,DSNB,SALT,SSMO,SRSS
        SAVE   /MAPSAT/
C
C Check for an uncleared prior error.
C
        IF (ICFELL('MDPRST - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C Read a record of saved parameters.
C
        READ (IFNO,ERR=901,END=902) NOUT,GRDR,GRID,GRLA,GRLO,GRPO,OTOL,
     +                              PLTO,PLNO,PLA1,PLA2,PLA3,PLA4,PLB1,
     +                              PLB2,PLB3,PLB4,PDRE,ROTA,SRCH,XLOW,
     +                              XROW,YBOW,YTOW,IDOT,IDSH,IDTL,ILCW,
     +                              ILTS,JPRJ,ELPF,LBLF,PRMF,DDTS,DPLT,
     +                              IGI1,IGI2,NOVS,ICIN,ALFA,BETA,DCSA,
     +                              DCSB,DSNA,DSNB,SALT,SSMO,SRSS,ICOL,
     +                              ICSF,NILN,NILT,IDPF,CSLT,CSLS,SLTD,
     +                              ISLT
C
C Re-initialize EZMAP.
C
        CALL MDPINT
        IF (ICFELL('MDPRST',2).NE.0) RETURN
C
C Done.
C
        RETURN
C
C Error exits.
C
  901   CALL SETER ('MDPRST - ERROR ON READ',3,1)
        RETURN
C
  902   CALL SETER ('MDPRST - EOF ON READ',4,1)
        RETURN
C
      END

C
C	$Id: condrw.f,v 1.4 2008-07-27 00:16:55 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CONDRW (SCRARR)
C
C  DRAW ALL CONTOURS AT THIS LEVEL
C  IF NOT EXTRAPOLATING
C         SEARCH CONVEX HULL FOR CONTOURS INTERSECTING IT AND DRAW THEM
C         SEARCH INTERIOR AND DRAW ALL REMAINING UNDRAWN CONTOURS
C
C  IF EXTRAPOLATING
C         SEARCH FROM X START TO X END AND Y START TO Y END FOR ALL
C         CONTOURS AT THIS LEVEL
C
C  INPUT
C       SCRARR SCRATCH ARRAY USED FOR FAST CONTOURING
C       VIA COMMON BLOCKS BELOW
C           CONV-THE CURRENT CONTOUR LEVEL
C           ITLOC-THE CONVEX HULL BOUNDRIES RELATIVE TO THE SCRATCH
C                 ARRAY, SCRARR
C           PV-REAL Y COOORDINATES OF THE CONVEX HULL RELATIVE TO THE
C                 USERS COORDINATE SPACE
C           IXMAX,IYMAX-MAXINUM X AND Y COORDINATES RELATIVE TO THE
C                 SCRATCH ARRAY, SCRARR
C           XMAX,YMAX-MAXIMUM X AND Y COORDINATES RELATIVE TO USERS
C                 COORDINATE SPACE
C
C  OUTPUT
C    CONTOUR LINES OUTPUT TO PLOTTER FILE
C
C  NOTE
C       THIS ROUTINE WILL DETECT AND CORRECT FOR CONRAN ERROR 9
C
      DIMENSION       SCRARR(1)
C
C
      COMMON /CONRA1/ CL(30)     ,NCL        ,OLDZ       ,PV(210)    ,
     1                FINC       ,HI         ,FLO
      COMMON /CONRA2/ REPEAT     ,EXTRAP     ,PER        ,MESS       ,
     1                ISCALE     ,LOOK       ,PLDVLS     ,GRD        ,
     2                CINC       ,CHILO      ,CON        ,LABON      ,
     3                PMIMX      ,SCALE      ,FRADV      ,EXTRI      ,
     4                BPSIZ      ,LISTOP
      COMMON /CONRA3/ IREC
      COMMON /CONRA4/ NCP        ,NCPSZ
      COMMON /CONRA5/ NIT        ,ITIPV
      COMMON /CONRA6/ XST        ,YST        ,XED        ,YED        ,
     1                STPSZ      ,IGRAD      ,IG         ,XRG        ,
     2                YRG        ,BORD       ,PXST       ,PYST       ,
     3                PXED       ,PYED       ,ITICK
      COMMON /CONR18/ TITLE      ,ICNT   ,ITLSIZ
      COMMON /CONR19/ IHIGH      ,INMAJ      ,INLAB      ,INDAT      ,
     1              LEN      ,IFMT       ,LEND       ,
     2                IFMTD      ,ISIZEP     ,INMIN
      COMMON /CONRA9/ ICOORD(500),  NP       ,MXXY       ,TR         ,
     1                BR         ,TL         ,BL         ,CONV       ,
     2                XN         ,YN         ,ITLL       ,IBLL       ,
     3                ITRL       ,IBRL       ,XC         ,YC         ,
     4                ITLOC(210) ,JX         ,JY         ,ILOC       ,
     5                ISHFCT     ,XO         ,YO         ,IOC        ,NC
      COMMON /CONR10/ NT         ,NL         ,NTNL       ,JWIPT      ,
     1                JWIWL      ,JWIWP      ,JWIPL      ,IPR        ,
     2                ITPV
      COMMON /CONR20/ NREP       ,NCRT       ,ISIZEL     ,
     1                MINGAP     ,ISIZEM         ,
     2                TENS
      COMMON /CONR12/ IXMAX      ,IYMAX      ,XMAX       ,YMAX
      LOGICAL         REPEAT     ,EXTRAP     ,PER        ,MESS       ,
     1                LOOK       ,PLDVLS     ,GRD        ,LABON      ,
     2                PMIMX      ,FRADV      ,EXTRI      ,CINC       ,
     3                TITLE      ,LISTOP     ,CHILO      ,CON
      COMMON /CONR15/ ISTRNG
        CHARACTER*64 ISTRNG
        COMMON /CONR16/ FORM
        CHARACTER*10 FORM
        COMMON /CONR17/ NDASH, IDASH, EDASH
        CHARACTER*10 NDASH, IDASH, EDASH
C
C
        SAVE
C
C
C  FLAGS TO ALLOW COMPRESSION OF CONTOUR STORAGE IF IT IS EXAUSTED
C
        DATA ICOMP,NOCOMP/1,0/
C
C  STATEMENT FUNCTION TO MAKE ARRAY ACCESS SEEM LIKE MATRIX ACCESS
C
      SCRTCH(IXX,IYY) = SCRARR(IYY+(IXX-1)*IYMAX)
C
C  CLEAR THE CONTOUR STORAGE LIST
C
      NP = 0
C
C  SCAN X BOARDERS FOR INTERSECTIONS
C
      JX = 2
      ICASE = 1
      X = XST+STPSZ
C
C  IF NOT EXTRAPOLATING BRANCH
C
   10 IF (.NOT.EXTRAP) GO TO    20
      JY = 2
      JYE = IYMAX
      Y = YST+STPSZ
      GO TO    30
C
C  NOT EXTRAPOLATING
C
   20 JY = ITLOC(JX*2-1)
      IF (JY.EQ.0) GO TO    60
      JYE = ITLOC(JX*2)+1
      IF (JYE.GT.IYMAX) JYE = IYMAX
      Y = PV(JX*2-1)
      IF (JY.GE.2) GO TO 30
      JY = 2
      Y = YST+STPSZ
   30 TL = SCRTCH(JX-1,JY-1)
      BL = SCRTCH(JX,JY-1)
   40 TR = SCRTCH(JX-1,JY)
      BR = SCRTCH(JX,JY)
      CALL CONGEN (X,Y,NOCOMP,SCRARR,ICASE)
C
C  TEST IF CONTOUR STORAGE EXAUSTED
C
      IF (NERRO(NERR).NE.10) GO TO    50
      CALL EPRIN
      CALL ERROF
      RETURN
C
C  MOVE TO NEW CELL
C
   50 TL = TR
      BL = BR
      JY = JY+1
      Y = Y+STPSZ
      IF (JY.LE.JYE) GO TO    40
   60 IF (JX.EQ.IXMAX) GO TO    70
      JX = IXMAX
      ICASE = 3
      X = XMAX
      GO TO    10
C
C  SCAN Y BOARDERS
C
   70 IPOS = 1
      ICASE = 4
   80 JX = 3
      X = XST+STPSZ+STPSZ
C
C  IF NOT EXTRAPOLATING BRANCH
C
   90 IF (.NOT.EXTRAP) GO TO   100
      JY = 2
      Y = YST+STPSZ
      IF (IPOS.NE.0) GO TO   110
      JY = IYMAX
      Y = YED
      GO TO   110
C
C  NOT EXTRAPOLATING
C
 100    JY = ITLOC(JX*2 - IPOS )
      IF (JY.EQ.0) GO TO   120
        JY = JY + IPOS
      Y = PV(JX*2 - IPOS) + STPSZ*(1*IPOS)
  110 TL = SCRTCH(JX-1,JY-1)
      BL = SCRTCH(JX,JY-1)
      TR = SCRTCH(JX-1,JY)
      BR = SCRTCH(JX,JY)
      CALL CONGEN (X,Y,NOCOMP,SCRARR,ICASE)
C
C  TEST IF CONTOUR STORAGE EXAUSTED
C
      IF (NERRO(NERR).NE.10) GO TO   120
      CALL EPRIN
      CALL ERROF
      RETURN
C
C  MOVE TO NEW CELL
C
  120 JX = JX+1
      X = X+STPSZ
      IF (JX.LE.IXMAX-1) GO TO    90
      IF (IPOS.EQ.0) GO TO   130
      IPOS = 0
      ICASE = 2
      GO TO    80
C
C  BOARDER SEARCH DONE CONTOUR INTERIOR
C
C  INITIALIZE THE SEARCH
C
  130 JX = 3
      ICASE = 0
      X = XST+STPSZ+STPSZ
      JXE = IXMAX-1
C
C  IF EXTRAPOLATING GO FROM BORDER TO BORDER
C
  140 IF (.NOT.EXTRAP) GO TO   150
      JY = 3
      JYE = IYMAX-1
      Y = YST+STPSZ+STPSZ
      GO TO   160
C
C  NOT EXTRAPOLATING STAY IN HULL
C
  150 JY = ITLOC(JX*2 - 1)+2
      IF (JY.EQ.2) GO TO   190
      JYE = ITLOC(JX*2)-1
      Y = PV(JX*2 - 1)+STPSZ+STPSZ
C
  160 IF (JY.GT.JYE) GO TO   190
      TL = SCRTCH(JX-1,JY-1)
      BL = SCRTCH(JX,JY-1)
  170 TR = SCRTCH(JX-1,JY)
      BR = SCRTCH(JX,JY)
      CALL CONGEN (X,Y,ICOMP,SCRARR,ICASE)
C
C  TEST IF CONTOUR STORAGE EXAUSTED
C
      IF (NERRO(NERR).NE.10) GO TO   180
      CALL EPRIN
      CALL ERROF
      RETURN
C
C  MOVE TO NEW CELL
C
  180 JY = JY+1
      Y = Y+STPSZ
      TL = TR
      BL = BR
      IF (JY.LE.JYE) GO TO   170
C
C  PROCESS EACH ROW OF INTERIOR
C
  190 X = X+STPSZ
      JX = JX+1
      IF (JX.LE.JXE) GO TO   140
C
      RETURN
      END

C
C $Id: ezsrfc.f,v 1.5 2008-07-27 00:17:25 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE EZSRFC (Z,M,N,ANGH,ANGV,WORK)
      DIMENSION       Z(M,N)     ,WORK(1)
C
C                      WORK(2*M*N+M+N)
C
C PERSPECTIVE PICTURE OF A SURFACE STORED IN A TWO DIMENSIONAL ARRAY
C VIA A VERY SHORT ARGUMENT LIST.
C
C ASSUMPTIONS--
C     THE ENTIRE ARRAY IS TO BE DRAWN,
C     THE DATA IS EQUALLY SPACED (IN THE X-Y PLANE),
C     NO STEREO PAIRS.
C IF THESE ASSUMPTIONS ARE NOT MET USE SRFACE.
C
C ARGUMENTS--
C     Z    THE 2 DIMENSIONAL ARRAY TO BE DRAWN.
C     M    THE FIRST DIMENSION OF Z.
C     N    THE SECOND DIMENSION OF Z.
C     ANGH ANGLE IN DEGREES IN THE X-Y PLANE TO THE LINE OF SIGHT
C          (COUNTER-CLOCK WISE FROM THE PLUS-X AXIS).
C     ANGV ANGLE IN DEGREES FROM THE X-Y PLANE TO THE LINE OF SIGHT
C          (POSITIVE ANGLES ARE ABOVE THE MIDDLE Z, NEGATIVE BELOW).
C     WORK A SCRATCH STORAGE DIMENSIONED AT LEAST 2*M*N+M+N.
C
      COMMON /SRFBLK/ LIMU(1024) ,LIML(1024) ,CL(41)     ,NCL        ,
     1                LL         ,FACT       ,IROT       ,NDRZ       ,
     2                NUPPER     ,NRSWT      ,BIGD       ,UMIN       ,
     3                UMAX       ,VMIN       ,VMAX       ,RZERO      ,
     4                NOFFP      ,NSPVAL     ,SPV        ,BIGEST
      DIMENSION       S(6)
      DATA S(4),S(5),S(6)/0.0,0.0,0.0/
C
C  FACT1 IS THE PERSPECTIVE RATIO AND IS DEFINED TO BE THE RATIO
C         MAXIMUM(LENGTH,WIDTH)/HEIGHT
C
C  FACT2 IS THE RATIO   (LENGTH OF LINE OF SIGHT)/MAXIMUM(LENGTH,WIDTH)
C
      DATA FACT1,FACT2/2.0,5.0/
      BIGEST = R1MACH(2)
C
C FIND RANGE OF Z
C
      MX = M
      NY = N
      ANG1 = ANGH*3.14159265358979/180.
      ANG2 = ANGV*3.14159265358979/180.
      FLO = BIGEST
      HI = -FLO
      DO  20 J=1,NY
         DO  10 I=1,MX
            IF (NOFFP.EQ.1 .AND. Z(I,J).EQ.SPV) GO TO  10
            HI = MAX(Z(I,J),HI)
            FLO = MIN(Z(I,J),FLO)
   10    CONTINUE
   20 CONTINUE
C
C SET UP LINEAR X AND Y ARRAYS FOR SRFACE
C
      DELTA = (HI-FLO)/(REAL(MAX(MX,NY))-1.)*FACT1
      XMIN = -(REAL(MX/2)*DELTA+REAL(MOD(MX+1,2))*DELTA)
      YMIN = -(REAL(NY/2)*DELTA+REAL(MOD(NY+1,2))*DELTA)
      DO  30 I=1,MX
         WORK(I) = XMIN+REAL(I-1)*DELTA
   30 CONTINUE
      DO  40 J=1,NY
         K = MX+J
         WORK(K) = YMIN+REAL(J-1)*DELTA
   40 CONTINUE
C
C SET UP EYE POSITION
C
      FACTE = (HI-FLO)*FACT1*FACT2
      CANG2 = COS(ANG2)
      S(1) = FACTE*CANG2*COS(ANG1)
      S(2) = FACTE*CANG2*SIN(ANG1)
      S(3) = FACTE*SIN(ANG2)+(FLO+HI)*.5
C
C READY
C
      CALL SRFACE (WORK(1),WORK(MX+1),Z,WORK(K+1),MX,MX,NY,S,0.)
      RETURN
      END

C
C $Id: ispltf.f,v 1.5 2008-07-27 00:17:16 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE ISPLTF (RXN,RYN,IENT)
C
C This routine is ISOSRF's analogue of the SPPS routine PLOTIF; it
C receives the fractional coordinates of points on line to be drawn
C (usually closed contour lines).  When IENT = 1, (RXN,RYN) is the
C first point on such a line; when IENT = 2, (RXN,RYN) is the next
C point on such a line.
C
C ISPLTF draws visible portions of each line as defined by the screen
C model ISCA and marks the entire line on the screen model ISCR.
C
      COMMON /ISCOMN/ BIG,BIGD,DBPI,IDONE,IFILL,IFLIP,IONES,IHSS(1000),
     +                IREF,ISCA(16,256),ISCALE,ISCR(16,256),ISLBT,ISDR,
     +                LHSS,LX,NFPW,NINU,NINV,NINW,NX,NY,R0,RNX,RNY,
     +                SMALL,SVAL,TENSN,U,V,W,XMAX,XMIN,YMAX,YMIN,XVPL,
     +                XVPR,YVPB,YVPT
      SAVE   /ISCOMN/
C
C Certain variables need to be saved from call to call.
C
      SAVE RXO,RYO,IXO,IYO,IBO,IWO,IVO
C
C Arithmetic statement function for taking the average of two reals.
C
      AVE(A,B)=.5*(A+B)
C
      IXN=1+INT(RXN*RNX)
      IYN=1+INT(RYN*RNY)
      IBN=NFPW-MOD(IXN-1,NFPW)
      IWN=(IXN+NFPW-1)/NFPW
      IVN=IAND(ISHIFT(ISCA(IWN,IYN),2*(1-IBN)),3)
C
      IF (IVN.NE.0) THEN
        IF (MOD(RXN*RNX,1.).LT..5) THEN
          IF (IXN.GT.1) THEN
            IF (IAND(ISHIFT(ISCA((IXN+NFPW-2)/NFPW,IYN),
     +                        2*(1+MOD(IXN-2,NFPW)-NFPW)),3).EQ.0) IVN=0
          END IF
        ELSE
          IF (IXN.LT.NX) THEN
            IF (IAND(ISHIFT(ISCA((IXN+NFPW  )/NFPW,IYN),
     +                        2*(1+MOD(IXN  ,NFPW)-NFPW)),3).EQ.0) IVN=0
          END IF
        END IF
      END IF
C
      IF (IVN.NE.0) THEN
        IF (MOD(RYN*RNY,1.).LT..5) THEN
          IF (IYN.GT.1) THEN
            IF (IAND(ISHIFT(ISCA(IWN,IYN-1),2*(1-IBN)),3).EQ.0) IVN=0
          END IF
        ELSE
          IF (IYN.LT.NY) THEN
            IF (IAND(ISHIFT(ISCA(IWN,IYN+1),2*(1-IBN)),3).EQ.0) IVN=0
          END IF
        END IF
      END IF
C
      IF (IENT.EQ.1) THEN
        IF (ISDR.EQ.0.AND.IVN.EQ.0)
     +         CALL PLOTIF (XVPL+(XVPR-XVPL)*RXN,YVPB+(YVPT-YVPB)*RYN,0)
        RXO=RXN
        RYO=RYN
        IXO=IXN
        IYO=IYN
        IBO=IBN
        IWO=IWN
        IVO=IVN
      ELSE
        RXT=RXO
        RYT=RYO
        IF (ISDR.EQ.0) THEN
          NPTI=MAX(ABS(IXN-IXO),ABS(IYN-IYO))-1
          IF (NPTI.GT.0) THEN
            DO 101 IPTI=1,NPTI
              RXI=RXT+(REAL(IPTI)/REAL(NPTI+1))*(RXN-RXT)
              RYI=RYT+(REAL(IPTI)/REAL(NPTI+1))*(RYN-RYT)
              IXI=1+INT(RXI*RNX)
              IYI=1+INT(RYI*RNY)
              IBI=NFPW-MOD(IXI-1,NFPW)
              IWI=(IXI+NFPW-1)/NFPW
              IVI=IAND(ISHIFT(ISCA(IWI,IYI),2*(1-IBI)),3)
C
              IF (IVI.NE.0) THEN
                IF (MOD(RXI*RNX,1.).LT..5) THEN
                  IF (IXI.GT.1) THEN
                    IF (IAND(ISHIFT(ISCA((IXI+NFPW-2)/NFPW,IYI),
     +                        2*(1+MOD(IXI-2,NFPW)-NFPW)),3).EQ.0) IVI=0
                  END IF
                ELSE
                  IF (IXI.LT.NX) THEN
                    IF (IAND(ISHIFT(ISCA((IXI+NFPW  )/NFPW,IYI),
     +                        2*(1+MOD(IXI  ,NFPW)-NFPW)),3).EQ.0) IVI=0
                  END IF
                END IF
              END IF
C
              IF (IVI.NE.0) THEN
                IF (MOD(RYI*RNY,1.).LT..5) THEN
                  IF (IYI.GT.1) THEN
                    IF (IAND(ISHIFT(ISCA(IWI,IYI-1),
     +                                         2*(1-IBI)),3).EQ.0) IVI=0
                  END IF
                ELSE
                  IF (IYI.LT.NY) THEN
                    IF (IAND(ISHIFT(ISCA(IWI,IYI+1),
     +                                         2*(1-IBI)),3).EQ.0) IVI=0
                  END IF
                END IF
              END IF
C
              IF (IVO.EQ.0.AND.IVI.EQ.0)
     +                              CALL PLOTIF (XVPL+(XVPR-XVPL)*RXI,
     +                                           YVPB+(YVPT-YVPB)*RYI,1)
              IF (IVO.EQ.0.AND.IVI.NE.0)
     +                     CALL PLOTIF (XVPL+(XVPR-XVPL)*AVE(RXO,RXI),
     +                                  YVPB+(YVPT-YVPB)*AVE(RYO,RYI),1)
              IF (IVO.NE.0.AND.IVI.EQ.0)
     +                     CALL PLOTIF (XVPL+(XVPR-XVPL)*AVE(RXO,RXI),
     +                                  YVPB+(YVPT-YVPB)*AVE(RYO,RYI),0)
              RXO=RXI
              RYO=RYI
              IVO=IVI
  101       CONTINUE
          END IF
          IF (IVO.EQ.0.AND.IVN.EQ.0)
     +                              CALL PLOTIF (XVPL+(XVPR-XVPL)*RXN,
     +                                           YVPB+(YVPT-YVPB)*RYN,1)
          IF (IVO.EQ.0.AND.IVN.NE.0)
     +                     CALL PLOTIF (XVPL+(XVPR-XVPL)*AVE(RXO,RXN),
     +                                  YVPB+(YVPT-YVPB)*AVE(RYO,RYN),1)
          IF (IVO.NE.0.AND.IVN.EQ.0)
     +                     CALL PLOTIF (XVPL+(XVPR-XVPL)*AVE(RXO,RXN),
     +                                  YVPB+(YVPT-YVPB)*AVE(RYO,RYN),0)
        END IF
        RXO=RXN
        RYO=RYN
        IVO=IVN
        IF (IXN.NE.IXO.OR.IYN.NE.IYO) THEN
          IF (RYN.GT.RYT) THEN
            ISCR(IWO,IYO)=IOR(ISCR(IWO,IYO),ISHIFT(  IFLIP,2*(IBO-1)))
            DO 102 IYI=IYO,IYN-1
              RXI=RXT+((RXN-RXT)/(RYN-RYT))*(REAL(IYI)/RNY-RYT)
              IXI=1+INT(RXI*RNX)
              IBI=NFPW-MOD(IXI-1,NFPW)
              IWI=(IXI+NFPW-1)/NFPW
              ISCR(IWI,IYI  )=IOR(ISCR(IWI,IYI  ),
     +                                      ISHIFT(  IFLIP,2*(IBI-1)))
              ISCR(IWI,IYI+1)=IOR(ISCR(IWI,IYI+1),
     +                                      ISHIFT(  IFLIP,2*(IBI-1)))
  102       CONTINUE
            ISCR(IWN,IYN)=IOR(ISCR(IWN,IYN),ISHIFT(  IFLIP,2*(IBN-1)))
          ELSE IF (RYN.LT.RYT) THEN
            ISCR(IWO,IYO)=IOR(ISCR(IWO,IYO),ISHIFT(3-IFLIP,2*(IBO-1)))
            DO 103 IYI=IYN,IYO-1
              RXI=RXN+((RXT-RXN)/(RYT-RYN))*(REAL(IYI)/RNY-RYN)
              IXI=1+INT(RXI*RNX)
              IBI=NFPW-MOD(IXI-1,NFPW)
              IWI=(IXI+NFPW-1)/NFPW
              ISCR(IWI,IYI  )=IOR(ISCR(IWI,IYI  ),
     +                                      ISHIFT(3-IFLIP,2*(IBI-1)))
              ISCR(IWI,IYI+1)=IOR(ISCR(IWI,IYI+1),
     +                                      ISHIFT(3-IFLIP,2*(IBI-1)))
  103       CONTINUE
            ISCR(IWN,IYN)=IOR(ISCR(IWN,IYN),ISHIFT(3-IFLIP,2*(IBN-1)))
          ELSE
            ISCR(IWO,IYO)=IOR(ISCR(IWO,IYO),ISHIFT(3      ,2*(IBO-1)))
            ISCR(IWN,IYN)=IOR(ISCR(IWN,IYN),ISHIFT(3      ,2*(IBN-1)))
          END IF
          IXO=IXN
          IYO=IYN
          IBO=IBN
          IWO=IWN
        END IF
      END IF
      IFILL=1
      RETURN
      END

C
C $Id: seti.f,v 1.8 2008-07-27 00:17:25 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE SETI (IX,IY)
C
C Allows the user to set the parameters which determine the assumed size
C of the target plotter and therefore determine how user coordinates are
C to be mapped into plotter coordinates.
C
C Declare the common block containing the scaling information.
C
      COMMON /IUTLCM/ LL,MI,MX,MY,IU(96)
      SAVE /IUTLCM/
C
C Check for an uncleared prior error.
C
      IF (ICFELL('SETI - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C Transfer the user's values into the common block.
C
      MX=MAX(1,MIN(15,IX))
      MY=MAX(1,MIN(15,IY))
C
      RETURN
C
      END

      PROGRAM PGKEX21
C
C  Illustrate line joins, caps, and miter limits.
C
C  Define error file, Fortran unit number, and workstation type,
C  and workstation ID.
C
      PARAMETER (IERRF=6, LUNIT=2, IWKID=1)
C
C  Specify certain key points on the plot (indices 1-3 for vertices 
C  of joins; 4-6 for vertices of caps; 7-8 for vertices of miter 
C  limits).
C
      DIMENSION X(8),Y(8)
C
      DATA X/0.20, 0.50, 0.80, 0.28, 0.28, 0.28, 0.75, 0.75/
      DATA Y/0.80, 0.67, 0.80, 0.35, 0.19, 0.03, 0.35, 0.14/
C
C  Open GKS.
C
      CALL GOPKS (IERRF, IDUM)
C
C  Open and activate a color PostScript workstation.
C
      CALL GOPWK (IWKID, 2, NGPSWK('PS','PORT','COLOR'))
      CALL GACWK (IWKID)
C
C  Define color indices.
C
      CALL GSCR(IWKID, 0, 1.0, 1.0, 1.0)
      CALL GSCR(IWKID, 1, 0.0, 0.0, 0.0)
C
C  Set workstation "1" as the one involved in subsequent NGSETI settings.
C
      CALL NGSETI('Workstation',1)
C
C  Line joins.
C
C 
C  Labels.
C
      CALL PCSETI('FN',25)
      CALL PCSETI('CC',1)
      CALL PLCHHQ(.5,Y(1)+0.15,'Line joins',.032,0.,0.)
      CALL PLCHHQ(X(1),Y(1)+0.07,'miter',.025,0.,0.)
      CALL PLCHHQ(X(2),Y(1)+0.07,'round',.025,0.,0.)
      CALL PLCHHQ(X(3),Y(1)+0.07,'bevel',.025,0.,0.)
C
C  Loop through the three types of line join.
C
      DO 10 I=1,3
        CALL NGSETI('Joins',I-1)
        CALL DRAWV(X(I),Y(I),MOD(I-1,2),0,90.,0.7,1,25.)
        CALL DRAWV(X(I),Y(I),MOD(I-1,2),1,90.,0.7,0,1.)
   10 CONTINUE
C
C  Line caps.
C
C 
C  Labels.
C
      CALL PLCHHQ(X(4),Y(4)+0.15,'Line caps',.032,0.,0.)
      CALL PLCHHQ(X(4),Y(4)+0.06,'butt',.025,0.,0.)
      CALL PLCHHQ(X(4),Y(5)+0.06,'round',.025,0.,0.)
      CALL PLCHHQ(X(4),Y(6)+0.06,'square',.025,0.,0.)
C
C  Loop through the three types of line caps.
C
      DO 20 I=4,6
        CALL NGSETI('Caps',I-4)
        CALL DRAWV(X(I),Y(I),0,0,180.,0.75,1,25.)
        CALL DRAWV(X(I),Y(I),0,2,180.,0.75,0,1.)
   20 CONTINUE
C
C  Miter limits.
C 
C  Labels.
C
      CALL PLCHHQ(X(7),Y(7)+0.15,'Miter limits',.032,0.,0.)
      CALL PLCHHQ(X(7),Y(7)+0.07,'default (= 10.)',.025,0.,0.)
      CALL PLCHHQ(X(7),Y(8)+0.04,'limit = 1.',.025,0.,0.)
C
C  Set line join to miter.
C
      CALL NGSETI('Join',0)
C
C  Default.
C
      CALL DRAWV(X(7),Y(7),0,0,35.,0.5,1,20.)
C
C  Limit = 1.
C
      CALL NGSETR('Miter',1.)
      CALL DRAWV(X(8),Y(8),0,0,35.,0.5,1,20.)
C
      CALL FRAME
C
C  Deactivate and close the workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      STOP
      END
      SUBROUTINE DRAWV(X,Y,IORIEN,IDOT,ANG,SCALE,ICOLOR,THICK)
C
C  Draw a "V" where:
C
C       (X,Y)   is the coordinate of the vertex.
C       IORIEN  flags whether the "V" is up (=1) or down (=0).
C       IDOT    flags whether dots are to be drawn at coordinates.
C               = 0 no dots.
C               = 1 dots at all coordinates
C               = 2 dots only at the end points
C       ANG     is the angle (in degrees) at the vertex of the "V".
C       SCALE   scales how big the "V" is.
C       ICOLOR  is the color index to be used for the lines.
C       THICK   is the linewidth scale factor.
C
      DIMENSION XV(3),YV(3)
C
      DATA  RADC,DSIZ/.0174532, 0.25/
C
      CALL GSPLCI(ICOLOR)
      CALL GSLWSC(THICK)
C
      BETA = RADC*(90.-0.5*ANG)
      XOFF = SCALE*DSIZ*COS(BETA)
      YOFF = SCALE*DSIZ*SIN(BETA)
      IF (IORIEN .EQ. 0) THEN
        SIGN =  1.
      ELSE
        SIGN = -1.
      ENDIF
C
      XV(1) = X-XOFF
      XV(2) = X
      XV(3) = X+XOFF
      YV(1) = Y-SIGN*YOFF
      YV(2) = Y
      YV(3) = YV(1)
C
      CALL GPL(3,XV,YV)
C
      IF (IDOT .EQ. 1) THEN
        CALL NGDOTS(XV,YV,3,0.005*THICK,ICOLOR)
      ELSE IF (IDOT .EQ. 2) THEN
        CALL NGDOTS(XV(1),YV(1),1,0.005*THICK,ICOLOR)
        CALL NGDOTS(XV(3),YV(3),1,0.005*THICK,ICOLOR)
      ENDIF
C
      RETURN
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C   FFTPACK 5.0
C   Copyright (C) 1995-2004, Scientific Computing Division,
C   University Corporation for Atmospheric Research
C   Licensed under the GNU General Public License (GPL)
C
C   Authors:  Paul N. Swarztrauber and Richard A. Valent
C
C   $Id: sinqmf.f,v 1.2 2006-11-21 01:10:19 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      SUBROUTINE DSINQMF(LOT,JUMP,N,INC,X,LENX,WSAVE,LENSAV,WORK,
     +                   LENWRK,IER)
      DOUBLE PRECISION XHOLD
      INTEGER LOT,JUMP,N,INC,LENX,LENSAV,LENWRK,IER
      DOUBLE PRECISION X(INC,*),WSAVE(LENSAV),WORK(LENWRK)
      LOGICAL DXERCON
C
      IER = 0
C
      IF (LENX.LT. (LOT-1)*JUMP+INC* (N-1)+1) THEN
          IER = 1
          CALL DXERFFT('SINQMF',6)
          GO TO 300
      ELSE IF (LENSAV.LT.2*N+INT(LOG(DBLE(N)))+4) THEN
          IER = 2
          CALL DXERFFT('SINQMF',8)
          GO TO 300
      ELSE IF (LENWRK.LT.LOT*N) THEN
          IER = 3
          CALL DXERFFT('SINQMF',10)
          GO TO 300
      ELSE IF (.NOT.DXERCON(INC,JUMP,N,LOT)) THEN
          IER = 4
          CALL DXERFFT('SINQMF',-1)
          GO TO 300
      END IF
C
      IF (N.EQ.1) RETURN
      NS2 = N/2
      LJ = (LOT-1)*JUMP + 1
      DO 101 K = 1,NS2
          KC = N - K
          DO 201 M = 1,LJ,JUMP
              XHOLD = X(M,K)
              X(M,K) = X(M,KC+1)
              X(M,KC+1) = XHOLD
  201     CONTINUE
  101 CONTINUE
      CALL DCOSQMF(LOT,JUMP,N,INC,X,LENX,WSAVE,LENSAV,WORK,LENWRK,IER1)
      IF (IER1.NE.0) THEN
          IER = 20
          CALL DXERFFT('SINQMF',-5)
          GO TO 300
      END IF
      DO 102 K = 2,N,2
          DO 202 M = 1,LJ,JUMP
              X(M,K) = -X(M,K)
  202     CONTINUE
  102 CONTINUE
  300 CONTINUE
      RETURN
      END

C
C	$Id: rgbhsv.f,v 1.6 2008-07-27 00:16:54 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE RGBHSV ( R, G, B, H, S, V )
C
C_BEGIN PROLOGUE RGBHSV
C
C_PURPOSE
C    This subroutine converts a color specification given as
C    Red, Green, and Blue intensity values to a color specification
C    in the Hue, Saturation, Value color space.
C
C_DESCRIPTION
C    This subroutine converts color values given in the
C    Red, Green, Blue (RGB) color space to color values
C    in the Hue, Saturation, and Value (HSV) color space.
C    The input Red, Green, and Blue values are intensities
C    in the range [0.,1.]; the output value H is returned
C    as a floating point number in the range [0.,360.) .
C    Full red (green and blue values of 0.) in the
C    input space corresponds to a hue of 0 in the
C    output space; the output value V is returned as a
C    floating point number in the range [0.,1.];
C    the output value S is returned as a floating
C    point number in the range [0.,1.] .
C
C_ARGUMENTS
C
C R       (INPUT,SINGLE,VARIABLE)  A real variable in the range
C         [0.,1.] which represents the red intensity component
C         of the input point in RGB color space.
C
C G       (INPUT,SINGLE,VARIABLE)  A real variable in the range
C         [0.,1.] which represents the green intensity component
C         of the input point in RGB color space.
C
C B       (INPUT,SINGLE,VARIABLE)  A real variable in the range
C         [0.,1.] which represents the blue intensity component
C         of the input point in RGB color space.
C
C H       (OUTPUT,SINGLE,VARIABLE)  A real variable in the range
C         [0.,360.) which represents the hue of the input point
C         in HSV color space.  A value of (R,0.,0.) in the input
C         space will result in a hue of 0. in the output space.
C
C S       (OUTPUT,SINGLE,VARIABLE)  A real variable in the range
C         [0.,1.] which represents the saturation value of the
C         input point in HSV color space.  Saturation is a measure
C         of how much white light is mixed with the color. Saturation
C         values of 0. represent greys (with a grey value equal to
C         V).  Saturation values of 1. are fully saturated colors.
C         The hue is technically undefined when S=0; the code leaves
C         H at its previous value when S=0. (0. initially).  The
C         fully saturated pure hues occur when S=1. and V=1.
C
C V       (OUTPUT,SINGLE,VARIABLE)  A real variable in the range
C         [0.,1.] which represents the value in HSV space.
C
C_I/O
C    (NONE)
C
C_ROUTINES CALLED
C    (NONE)
C
C_COMMON BLOCKS
C    (NONE)
C
C_MAXIMUM GKS LEVEL
C    (NONE)
C
C_LANGUAGE
C    FORTRAN
C
C_REVISION DATE
C    880511 (YYMMDD)
C
C_HISTORY
C    This subroutine was originally coded and prepared for the
C    NCAR Graphics package by Fred Clare based on algorithms
C    in Foley and van Dam (see REFERENCES below).
C
C_REFERENCES
C    Foley, James D. and van Dam, Andries,"Fundamentals of Interactive
C    Computer Graphics",Addison-Wesley Publishing Company, 1982.
C
C    Smith, A.R.,"Color Gamut Transformation Pairs",SIGGRAPH '78
C    Proceedings, published as Computer Graphics, 12(3),August 1978,
C    pp.12-19.
C
C_LONG DESCRIPTION
C    The hues returned can be made to put 0 degrees at blue instead
C    of red by changing the offsets to the computation of H in the
C    code.
C
C_EXAMPLES
C    Example 1 --  Blue to HSV.
C          SUBROUTINE THSV1
C          REAL    H,S,V,EPS
C          PARAMETER (EPS=0.00001)
C          CALL RGBHSV(0.,0.,1.,H,S,V)
C          IF ( (ABS(H-240.) .GT. EPS) .OR. (ABS(S-1.) .GT. EPS) .OR.
C         *     (ABS(V-1.) .GT. EPS) ) THEN
C            IUN = I1MACH(4)
C            WRITE(IUN,10)
C          ENDIF
C          RETURN
C       10 FORMAT(' THSV1 returned incorrect values')
C          END
C
C_END PROLOGUE RGBHSV
C
      REAL R,G,B,H,S,V,HSAV,RMM,MXINTS,MNINTS,MAXMIN,BC,GC,RC
      SAVE HSAV
      DATA HSAV/0./
C
C  Check on input arguments.
C
C_FIRST EXECUTABLE STATEMENT RGBHSV
      IF (R.LT.0. .OR. R.GT.1.)
     *      CALL SETER(' RGBHSV - R out of range',1,1)
      IF (G.LT.0. .OR. G.GT.1.)
     *      CALL SETER(' RGBHSV - G out of range',1,1)
      IF (B.LT.0. .OR. B.GT.1.)
     *      CALL SETER(' RGBHSV - B out of range',1,1)
C
      MXINTS = MAX(R,G,B)
      MNINTS = MIN(R,G,B)
      MAXMIN = MXINTS-MNINTS
C
C  Compute value.
C
      V = MXINTS
C
C  Compute saturation.
C
      IF (MXINTS .EQ. 0.) THEN
        S = 0.
      ELSE
        S = MAXMIN/MXINTS
      ENDIF
C
C  Compute hue.  If the saturation is 0., then do not define the hue--
C  leave it as it was in the previous call as per the suggestion of
C  A.V. Smith (see REFERENCES).
C
      IF (S .GT. 0.) THEN
        RMM = 1./MAXMIN
        RC = (MXINTS-R)*RMM
        GC = (MXINTS-G)*RMM
        BC = (MXINTS-B)*RMM
        IF (R .EQ. MXINTS) THEN
          H = 0.+BC-GC
        ELSE IF (G .EQ. MXINTS) THEN
          H = 2.+RC-BC
        ELSE IF (B .EQ. MXINTS) THEN
          H = 4.+GC-RC
        ENDIF
C
C  Convert H to degrees.
C
        H = H*60.
        IF (H .LT. 0.) H = H+360.
        HSAV = H
      ELSE
        H = HSAV
      ENDIF
C
C  Guarantee saturation and value are in range.
C
      S = MIN(1.,MAX(0.,S))
      V = MIN(1.,MAX(0.,V))
      RETURN
      END

C
C	$Id: ezhftn.f,v 1.4 2008-07-27 00:17:14 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE EZHFTN (Z,M,N)
C
      DIMENSION       Z(M,N)
      SAVE
C
C HALF-TONE PICTURE VIA SHORTEST ARGUMENT LIST.
C ASSUMPTIONS--
C     ALL OF THE ARRAY IS TO BE DRAWN,
C     LOWEST VALUE IN Z WILL BE AT LOWEST INTENSITY ON READER/PRINTER
C     OUTPUT, HIGHEST VALUE IN Z WILL BE AT HIGHEST INTENSITY, VALUES IN
C     BETWEEN WILL APPEAR LINEARLY SPACED, MAXIMUM POSSIBLE NUMBER OF
C     INTENSITIES ARE USED, THE PICTURE WILL HAVE A PERIMETER DRAWN,
C     FRAME WILL BE CALLED AFTER THE PICTURE IS DRAWN, Z IS FILLED WITH
C     NUMBERS THAT SHOULD BE USED (NO UNKNOWN VALUES).
C IF THESE CONDITIONS ARE NOT MET, USE HAFTON.
C EZHFTN ARGUMENTS--
C     Z   2 DIMENSIONAL ARRAY TO BE USED TO GENERATE A HALF-TONE PLOT.
C     M   FIRST DIMENSION OF Z.
C     N   SECOND DIMENSION OF Z.
C
      DATA FLO,HI,NLEV,NOPT,NPRM,ISPV,SPV/0.0,0.0,0,0,0,0,0.0/
C
C THE FOLLOWING CALL IS FOR GATHERING STATISTICS ON LIBRARY USE AT NCAR
C
      CALL Q8QST4 ('GRAPHX','HAFTON','EZHFTN','VERSION  1')
C
      CALL HAFTON (Z,M,M,N,FLO,HI,NLEV,NOPT,NPRM,ISPV,SPV)
      CALL FRAME
      RETURN
      END

C
C	$Id: skpblk.f,v 1.4 2008-07-27 12:23:44 haley Exp $
C                                                                      
C			     Copyright (C)  1997
C	     University Corporation for Atmospheric Research
C			     All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C

      SUBROUTINE SKPBLK(IOS, STATUS)
C
C  Position the buffer pointer to point at the next non-blank
C  character in the file.
C
C
C  OUTPUT
C       IOS     --  I/O status flag.  This flag is valid only
C                   if STATUS indicates an error.
C       STATUS  --  The error status as defined in COMMON CAPERR.
C
C
      COMMON /CAPERR/ ALLOK, EOFFL, INTERR, MAXINT, PLBERR, PMBERR,
     1                FABERR, TXBERR, FLTERR, MAXFLT, NOTINT, SIZERR,
     2                UNDASC, DEVERR, DOCERR, TBLERR , STSZER, ENTERR,
     3                TABERR, TABSER, PRSFIL
      INTEGER ALLOK, EOFFL, INTERR, MAXINT, PLBERR, PMBERR,
     1        FABERR, TXBERR, FLTERR, MAXFLT, NOTINT, SIZERR, UNDASC,
     2        DEVERR, DOCERR, STSZER, ENTERR, TABERR, TABSER, TBLERR,
     3        PRSFIL
      COMMON /CAPIOB/ UNIT, IPTR, LSIZE, NFST, NFLG
      COMMON /CAPIO2/ LINE, GRNM
      INTEGER LNMAX
      PARAMETER (LNMAX=80)
      CHARACTER*80 LINE
      CHARACTER*80 GRNM
      INTEGER UNIT, IPTR, LSIZE, NFST, NFLG
C
      INTEGER IOS, STATUS
      CHARACTER*1 BLANK
      INTEGER II
C
      DATA BLANK/' '/
C
C  Scan the current buffer for a non-blank.
C
 10   CONTINUE
      DO 20 II = IPTR,LSIZE
        IF (LINE(II:II) .NE. BLANK) THEN
C
C  Non-blank found.
C
                IPTR = II
                RETURN
        END IF
 20   CONTINUE
C
C  End of current buffer and no non-blank, get another line.
C
      CALL RDLINE (IOS, STATUS)
C
C  Return if EOF or bad read.
C
      IF (STATUS.NE.ALLOK) RETURN
C
C  Go back and scan this line.
C
      GO TO 10
C
      END

C
C $Id: mdiola.f,v 1.3 2008-07-27 00:17:06 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      INTEGER FUNCTION MDIOLA (IAID,ILVL)
C
        INTEGER IAID,ILVL
C
        PARAMETER (MNAI=8000)
C
C The value of MDIOLA(IAID,ILVL) is the area identifier of the largest
C area, at level ILVL, that contains the area with area identifier IAID.
C
        COMMON /MAPCMX/  IATY(MNAI),ISCI(MNAI),IPAR(MNAI)
        INTEGER          IATY,ISCI,IPAR
        SAVE   /MAPCMX/
C
C Declare local variables.
C
        INTEGER          ITMP,NSTP
C
        ITMP=IAID
        NSTP=0
C
  101   IF (IPAR(ITMP).GE.1.AND.IPAR(ITMP).LE.MNAI) THEN
          IF (IATY(IPAR(ITMP)).GE.ILVL) THEN
            ITMP=IPAR(ITMP)
            NSTP=NSTP+1
            IF (NSTP.LT.10) GO TO 101
          END IF
        END IF
C
        MDIOLA=ITMP
C
        RETURN
C
      END

c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by UCAR                 .
c  .                                                             .
c  .       University Corporation for Atmospheric Research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                         SPHEREPACK                          .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c
c
c ... file vrtgs.f
c
c     this file includes documentation and code for
c     subroutine divgs          i
c
c ... files which must be loaded with vrtgs.f
c
c     sphcom.f, hrfft.f, vhgsc.f, shsgs.f, gaqd.f
c
c     subroutine vrtgs(nlat,nlon,isym,nt,vort,ivrt,jvrt,cr,ci,mdc,ndc,
c    +                 wshsgs,lshsgs,work,lwork,ierror)
c
C*PL*ERROR* Comment line too long
c     given the vector spherical harmonic coefficients cr and ci, precomputed
c     by subroutine vhags for a vector field (v,w), subroutine vrtgs
c     computes the vorticity of the vector field in the scalar array
c     vort.  vort(i,j) is the vorticity at the gaussian colatitude
c     theta(i) (see nlat as input parameter) and longitude
c     lambda(j) = (j-1)*2*pi/nlon on the sphere.  i.e.,
c
c            vort(i,j) =  [-dv/dlambda + d(sint*w)/dtheta]/sint
c
c     where sint = sin(theta(i)).  w is the east longitudinal and v
c     is the colatitudinal component of the vector field from which
c     cr,ci were precomputed.  required associated legendre polynomials
c     are stored rather than recomputed as they are in subroutine vrtgc.
c
c
c     input parameters
c
c     nlat   the number of points in the gaussian colatitude grid on the
C*PL*ERROR* Comment line too long
c            full sphere. these lie in the interval (0,pi) and are computed
C*PL*ERROR* Comment line too long
c            in radians in theta(1) <...< theta(nlat) by subroutine gaqd.
C*PL*ERROR* Comment line too long
c            if nlat is odd the equator will be included as the grid point
c            theta((nlat+1)/2).  if nlat is even the equator will be
c            excluded as a grid point and will lie half way between
c            theta(nlat/2) and theta(nlat/2+1). nlat must be at least 3.
c            note: on the half sphere, the number of grid points in the
c            colatitudinal direction is nlat/2 if nlat is even or
c            (nlat+1)/2 if nlat is odd.
c
c     nlon   the number of distinct londitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater
c            than 3. the axisymmetric case corresponds to nlon=1.
c            the efficiency of the computation is improved when nlon
c            is a product of small prime numbers.
c
c
c     isym   a parameter which determines whether the vorticity is
c            computed on the full or half sphere as follows:
c
c      = 0
c            the symmetries/antsymmetries described in isym=1,2 below
c            do not exist in (v,w) about the equator.  in this case the
c            vorticity is neither symmetric nor antisymmetric about
c            the equator.  the vorticity is computed on the entire
c            sphere.  i.e., in the array vort(i,j) for i=1,...,nlat and
c            j=1,...,nlon.
c
c      = 1
c            w is antisymmetric and v is symmetric about the equator.
c            in this case the vorticity is symmetyric about the
c            equator and is computed for the northern hemisphere
c            only.  i.e., if nlat is odd the vorticity is computed
c            in the array vort(i,j) for i=1,...,(nlat+1)/2 and for
c            j=1,...,nlon.  if nlat is even the vorticity is computed
c            in the array vort(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
c
c      = 2
c            w is symmetric and v is antisymmetric about the equator
c            in this case the vorticity is antisymmetric about the
c            equator and is computed for the northern hemisphere
c            only.  i.e., if nlat is odd the vorticity is computed
c            in the array vort(i,j) for i=1,...,(nlat+1)/2 and for
c            j=1,...,nlon.  if nlat is even the vorticity is computed
c            in the array vort(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
c
c
c      nt    nt is the number of scalar and vector fields.  some
c            computational efficiency is obtained for multiple fields.
c            in the program that calls vrtgs, the arrays cr,ci, and vort
C*PL*ERROR* Comment line too long
c            can be three dimensional corresponding to an indexed multiple
c            vector field.  in this case multiple scalar synthesis will
c            be performed to compute the vorticity for each field.  the
c            third index is the synthesis index which assumes the values
c            k=1,...,nt.  for a single synthesis set nt = 1.  the
c            description of the remaining parameters is simplified by
C*PL*ERROR* Comment line too long
c            assuming that nt=1 or that all the arrays are two dimensional.
c
c     ivrt   the first dimension of the array vort as it appears in
c            the program that calls vrtgs. if isym = 0 then ivrt
c            must be at least nlat.  if isym = 1 or 2 and nlat is
c            even then ivrt must be at least nlat/2. if isym = 1 or 2
c            and nlat is odd then ivrt must be at least (nlat+1)/2.
c
c     jvrt   the second dimension of the array vort as it appears in
c            the program that calls vrtgs. jvrt must be at least nlon.
c
c    cr,ci   two or three dimensional arrays (see input parameter nt)
c            that contain vector spherical harmonic coefficients
c            of the vector field (v,w) as computed by subroutine vhags.
c     ***    cr and ci must be computed by vhags prior to calling
c            vrtgs.
c
c      mdc   the first dimension of the arrays cr and ci as it
c            appears in the program that calls vrtgs. mdc must be at
c            least min0(nlat,nlon/2) if nlon is even or at least
c            min0(nlat,(nlon+1)/2) if nlon is odd.
c
c      ndc   the second dimension of the arrays cr and ci as it
c            appears in the program that calls vrtgs. ndc must be at
c            least nlat.
c
c   wshsgs   an array which must be initialized by subroutine shsgsi.
c            once initialized,
c            wshsgs can be used repeatedly by vrtgs as long as nlon
c            and nlat remain unchanged.  wshsgs must not be altered
c            between calls of vrtgs
c
c   lshsgs   the dimension of the array wshsgs   as it appears in the
c            program that calls vrtgs. define
c
c               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            then lshsgs must be at least
c
c            nlat*(3*(l1+l2)-2)+(l1-1)*(l2*(2*nlat-l1)-3*l1)/2+nlon+15
c
c     work   a work array that does not have to be saved.
c
c    lwork   the dimension of the array work as it appears in the
c            program that calls vrtgs. define
c
c               l1 = min0(nlat,nlon/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd.
c
c            if isym = 0 then lwork must be at least
c
c               nlat*((nt+1)*nlon+2*nt*l1+1)
c
c            if isym > 0 then lwork must be at least
c
c               (nt+1)*l2*nlon+nlat*(2*nt*l1+1)
c
c
c     **************************************************************
c
c     output parameters
c
c
c     vort   a two or three dimensional array (see input parameter nt)
c            that contains the vorticity of the vector field (v,w)
C*PL*ERROR* Comment line too long
c            whose coefficients cr,ci where computed by subroutine vhags.
c            vort(i,j) is the vorticity at the gaussian colatitude point
c            theta(i) and longitude point lambda(j) = (j-1)*2*pi/nlon.
c            the index ranges are defined above at the input parameter
c            isym.
c
c
c   ierror   an error parameter which indicates fatal errors with input
c            parameters when returned positive.
c          = 0  no errors
c          = 1  error in the specification of nlat
c          = 2  error in the specification of nlon
c          = 3  error in the specification of isym
c          = 4  error in the specification of nt
c          = 5  error in the specification of ivrt
c          = 6  error in the specification of jvrt
c          = 7  error in the specification of mdc
c          = 8  error in the specification of ndc
c          = 9  error in the specification of lshsgs
c          = 10 error in the specification of lwork
c **********************************************************************
c
c
      SUBROUTINE DVRTGS(NLAT,NLON,ISYM,NT,VORT,IVRT,JVRT,CR,CI,MDC,NDC,
     +                 WSHSGS,LSHSGS,WORK,LWORK,IERROR)
      DOUBLE PRECISION VORT
      DOUBLE PRECISION CR
      DOUBLE PRECISION CI
      DOUBLE PRECISION WSHSGS
      DOUBLE PRECISION WORK

      DIMENSION VORT(IVRT,JVRT,NT),CR(MDC,NDC,NT),CI(MDC,NDC,NT)
      DIMENSION WSHSGS(LSHSGS),WORK(LWORK)
c
c     check input parameters
c
      IERROR = 1
      IF (NLAT.LT.3) RETURN
      IERROR = 2
      IF (NLON.LT.4) RETURN
      IERROR = 3
      IF (ISYM.LT.0 .OR. ISYM.GT.2) RETURN
      IERROR = 4
      IF (NT.LT.0) RETURN
      IERROR = 5
      IMID = (NLAT+1)/2
      IF ((ISYM.EQ.0.AND.IVRT.LT.NLAT) .OR.
     +    (ISYM.GT.0.AND.IVRT.LT.IMID)) RETURN
      IERROR = 6
      IF (JVRT.LT.NLON) RETURN
      IERROR = 7
      IF (MDC.LT.MIN0(NLAT, (NLON+1)/2)) RETURN
      MMAX = MIN0(NLAT, (NLON+2)/2)
      IERROR = 8
      IF (NDC.LT.NLAT) RETURN
      IERROR = 9
      IMID = (NLAT+1)/2
      LPIMN = (IMID*MMAX* (NLAT+NLAT-MMAX+1))/2
      L2 = (NLAT+MOD(NLAT,2))/2
      L1 = MIN0((NLON+2)/2,NLAT)
      LP = NLAT* (3* (L1+L2)-2) + (L1-1)* (L2* (2*NLAT-L1)-3*L1)/2 +
     +     NLON + 15
      IF (LSHSGS.LT.LP) RETURN
      IERROR = 10
c
c     verify unsaved work space (add to what shses requires, file f3)
c
c
c     set first dimension for a,b (as requried by shses)
c
      MAB = MIN0(NLAT,NLON/2+1)
      MN = MAB*NLAT*NT
      LS = NLAT
      IF (ISYM.GT.0) LS = IMID
      NLN = NT*LS*NLON
      IF (LWORK.LT.NLN+LS*NLON+2*MN+NLAT) RETURN
      IERROR = 0
c
c     set work space pointers
c
      IA = 1
      IB = IA + MN
      IS = IB + MN
      IWK = IS + NLAT
      LWK = LWORK - 2*MN - NLAT
      CALL DVRTGS1(NLAT,NLON,ISYM,NT,VORT,IVRT,JVRT,CR,CI,MDC,NDC,
     +            WORK(IA),WORK(IB),MAB,WORK(IS),WSHSGS,LSHSGS,
     +            WORK(IWK),LWK,IERROR)
      RETURN
      END

      SUBROUTINE DVRTGS1(NLAT,NLON,ISYM,NT,VORT,IVRT,JVRT,CR,CI,MDC,NDC,
     +                  A,B,MAB,SQNN,WSAV,LWSAV,WK,LWK,IERROR)
      DOUBLE PRECISION VORT
      DOUBLE PRECISION CR
      DOUBLE PRECISION CI
      DOUBLE PRECISION A
      DOUBLE PRECISION B
      DOUBLE PRECISION SQNN
      DOUBLE PRECISION WSAV
      DOUBLE PRECISION WK
      DOUBLE PRECISION FN
      DIMENSION VORT(IVRT,JVRT,NT),CR(MDC,NDC,NT),CI(MDC,NDC,NT)
      DIMENSION A(MAB,NLAT,NT),B(MAB,NLAT,NT),SQNN(NLAT)
      DIMENSION WSAV(LWSAV),WK(LWK)
c
c     set coefficient multiplyers
c
      DO 1 N = 2,NLAT
          FN = DBLE(N-1)
          SQNN(N) = SQRT(FN* (FN+1.D0))
    1 CONTINUE
c
c     compute divergence scalar coefficients for each vector field
c
      DO 2 K = 1,NT
          DO 3 N = 1,NLAT
              DO 4 M = 1,MAB
                  A(M,N,K) = 0.0D0
                  B(M,N,K) = 0.0D0
    4         CONTINUE
    3     CONTINUE
c
c     compute m=0 coefficients
c
          DO 5 N = 2,NLAT
              A(1,N,K) = SQNN(N)*CR(1,N,K)
              B(1,N,K) = SQNN(N)*CI(1,N,K)
    5     CONTINUE
c
c     compute m>0 coefficients
c
          MMAX = MIN0(NLAT, (NLON+1)/2)
          DO 6 M = 2,MMAX
              DO 7 N = M,NLAT
                  A(M,N,K) = SQNN(N)*CR(M,N,K)
                  B(M,N,K) = SQNN(N)*CI(M,N,K)
    7         CONTINUE
    6     CONTINUE
    2 CONTINUE
c
c     synthesize a,b into vort
c
      CALL DSHSGS(NLAT,NLON,ISYM,NT,VORT,IVRT,JVRT,A,B,MAB,NLAT,WSAV,
     +           LWSAV,WK,LWK,IERROR)
      RETURN
      END

C
C	$Id: gqplf.f,v 1.5 2008-07-27 00:21:00 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GQPLF(WTYPE,N,ERRIND,NLT,LT,NLW,NOMLW,
     +                 RLWMIN,RLWMAX,NPPLI)
C
C  INQUIRE POLYLINE FACILITIES
C
      include 'gkscom.h'
C
      INTEGER WTYPE,N,ERRIND,NLT,LT,NLW,NPPLI
      REAL    NOMLW,RLWMIN,RLWMAX
C
C  Check if GKS is in the proper state.
C
      CALL GZCKST(8,-1,ERRIND)
      IF (ERRIND .NE. 0) GOTO 100
C
C  Check that the workstation type is valid.
C
      CALL GZCKWK(22,-1,IDUM,WTYPE,ERRIND)
      IF (ERRIND .NE. 0) GO TO 100
C
C  Check if the workstation category is OUTPUT or OUTIN.
C
      CALL GQWKCA(WTYPE,ERRIND,ICAT)
      IF (ICAT.NE.GOUTPT .AND. ICAT.NE.GOUTIN) THEN
        ERRIND = 39
        GO TO 100
      ENDIF
C
C  Check if index non-negative.
C
      IF (N .LT. 0) THEN
        ERRIND = 2002
        GO TO 100
      ENDIF
C
C  Invoke interface.
C
      FCODE = -118
      CONT  = 0
      CALL GZROI(0)
      IL1   = 2
      IL2   = 2
      ID(1) = WTYPE
      ID(2) = N
      IWK   = -1
      CALL GZIQWK(WTYPE,IWK)
      IF (RERR.NE.0) THEN
        ERRIND = RERR
        GOTO 100
      ENDIF
      NLT    = ID(3)
      LT     = ID(4)
      NLW    = ID(5)
      NPPLI  = ID(6)
      NOMLW  = RX(1)
      RLWMIN = RX(2)
      RLWMAX = RX(3)
      RETURN
C
  100 CONTINUE
      NLT    = -1
      LT     = -1
      NLW    = -1
      NPPLI  = -1
      NOMLW  = -1.
      RLWMIN = -1.
      RLWMAX = -1.
      RETURN
      END

      SUBROUTINE SSPR2 ( UPLO, N, ALPHA, X, INCX, Y, INCY, AP )
*     .. Scalar Arguments ..
      REAL               ALPHA
      INTEGER            INCX, INCY, N
      CHARACTER*1        UPLO
*     .. Array Arguments ..
      REAL               AP( * ), X( * ), Y( * )
*     ..
*
*  Purpose
*  =======
*
*  SSPR2  performs the symmetric rank 2 operation
*
*     A := alpha*x*y' + alpha*y*x' + A,
*
*  where alpha is a scalar, x and y are n element vectors and A is an
*  n by n symmetric matrix, supplied in packed form.
*
*  Parameters
*  ==========
*
*  UPLO   - CHARACTER*1.
*           On entry, UPLO specifies whether the upper or lower
*           triangular part of the matrix A is supplied in the packed
*           array AP as follows:
*
*              UPLO = 'U' or 'u'   The upper triangular part of A is
*                                  supplied in AP.
*
*              UPLO = 'L' or 'l'   The lower triangular part of A is
*                                  supplied in AP.
*
*           Unchanged on exit.
*
*  N      - INTEGER.
*           On entry, N specifies the order of the matrix A.
*           N must be at least zero.
*           Unchanged on exit.
*
*  ALPHA  - REAL            .
*           On entry, ALPHA specifies the scalar alpha.
*           Unchanged on exit.
*
*  X      - REAL             array of dimension at least
*           ( 1 + ( n - 1 )*abs( INCX ) ).
*           Before entry, the incremented array X must contain the n
*           element vector x.
*           Unchanged on exit.
*
*  INCX   - INTEGER.
*           On entry, INCX specifies the increment for the elements of
*           X. INCX must not be zero.
*           Unchanged on exit.
*
*  Y      - REAL             array of dimension at least
*           ( 1 + ( n - 1 )*abs( INCY ) ).
*           Before entry, the incremented array Y must contain the n
*           element vector y.
*           Unchanged on exit.
*
*  INCY   - INTEGER.
*           On entry, INCY specifies the increment for the elements of
*           Y. INCY must not be zero.
*           Unchanged on exit.
*
*  AP     - REAL             array of DIMENSION at least
*           ( ( n*( n + 1 ) )/2 ).
*           Before entry with  UPLO = 'U' or 'u', the array AP must
*           contain the upper triangular part of the symmetric matrix
*           packed sequentially, column by column, so that AP( 1 )
*           contains a( 1, 1 ), AP( 2 ) and AP( 3 ) contain a( 1, 2 )
*           and a( 2, 2 ) respectively, and so on. On exit, the array
*           AP is overwritten by the upper triangular part of the
*           updated matrix.
*           Before entry with UPLO = 'L' or 'l', the array AP must
*           contain the lower triangular part of the symmetric matrix
*           packed sequentially, column by column, so that AP( 1 )
*           contains a( 1, 1 ), AP( 2 ) and AP( 3 ) contain a( 2, 1 )
*           and a( 3, 1 ) respectively, and so on. On exit, the array
*           AP is overwritten by the lower triangular part of the
*           updated matrix.
*
*
*  Level 2 Blas routine.
*
*  -- Written on 22-October-1986.
*     Jack Dongarra, Argonne National Lab.
*     Jeremy Du Croz, Nag Central Office.
*     Sven Hammarling, Nag Central Office.
*     Richard Hanson, Sandia National Labs.
*
*
*     .. Parameters ..
      REAL               ZERO
      PARAMETER        ( ZERO = 0.0E+0 )
*     .. Local Scalars ..
      REAL               TEMP1, TEMP2
      INTEGER            I, INFO, IX, IY, J, JX, JY, K, KK, KX, KY
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     .. External Subroutines ..
      EXTERNAL           XERBLA
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      IF     ( .NOT.LSAME( UPLO, 'U' ).AND.
     $         .NOT.LSAME( UPLO, 'L' )      )THEN
         INFO = 1
      ELSE IF( N.LT.0 )THEN
         INFO = 2
      ELSE IF( INCX.EQ.0 )THEN
         INFO = 5
      ELSE IF( INCY.EQ.0 )THEN
         INFO = 7
      END IF
      IF( INFO.NE.0 )THEN
         CALL XERBLA( 'SSPR2 ', INFO )
         RETURN
      END IF
*
*     Quick return if possible.
*
      IF( ( N.EQ.0 ).OR.( ALPHA.EQ.ZERO ) )
     $   RETURN
*
*     Set up the start points in X and Y if the increments are not both
*     unity.
*
      IF( ( INCX.NE.1 ).OR.( INCY.NE.1 ) )THEN
         IF( INCX.GT.0 )THEN
            KX = 1
         ELSE
            KX = 1 - ( N - 1 )*INCX
         END IF
         IF( INCY.GT.0 )THEN
            KY = 1
         ELSE
            KY = 1 - ( N - 1 )*INCY
         END IF
         JX = KX
         JY = KY
      END IF
*
*     Start the operations. In this version the elements of the array AP
*     are accessed sequentially with one pass through AP.
*
      KK = 1
      IF( LSAME( UPLO, 'U' ) )THEN
*
*        Form  A  when upper triangle is stored in AP.
*
         IF( ( INCX.EQ.1 ).AND.( INCY.EQ.1 ) )THEN
            DO 20, J = 1, N
               IF( ( X( J ).NE.ZERO ).OR.( Y( J ).NE.ZERO ) )THEN
                  TEMP1 = ALPHA*Y( J )
                  TEMP2 = ALPHA*X( J )
                  K     = KK
                  DO 10, I = 1, J
                     AP( K ) = AP( K ) + X( I )*TEMP1 + Y( I )*TEMP2
                     K       = K       + 1
   10             CONTINUE
               END IF
               KK = KK + J
   20       CONTINUE
         ELSE
            DO 40, J = 1, N
               IF( ( X( JX ).NE.ZERO ).OR.( Y( JY ).NE.ZERO ) )THEN
                  TEMP1 = ALPHA*Y( JY )
                  TEMP2 = ALPHA*X( JX )
                  IX    = KX
                  IY    = KY
                  DO 30, K = KK, KK + J - 1
                     AP( K ) = AP( K ) + X( IX )*TEMP1 + Y( IY )*TEMP2
                     IX      = IX      + INCX
                     IY      = IY      + INCY
   30             CONTINUE
               END IF
               JX = JX + INCX
               JY = JY + INCY
               KK = KK + J
   40       CONTINUE
         END IF
      ELSE
*
*        Form  A  when lower triangle is stored in AP.
*
         IF( ( INCX.EQ.1 ).AND.( INCY.EQ.1 ) )THEN
            DO 60, J = 1, N
               IF( ( X( J ).NE.ZERO ).OR.( Y( J ).NE.ZERO ) )THEN
                  TEMP1 = ALPHA*Y( J )
                  TEMP2 = ALPHA*X( J )
                  K     = KK
                  DO 50, I = J, N
                     AP( K ) = AP( K ) + X( I )*TEMP1 + Y( I )*TEMP2
                     K       = K       + 1
   50             CONTINUE
               END IF
               KK = KK + N - J + 1
   60       CONTINUE
         ELSE
            DO 80, J = 1, N
               IF( ( X( JX ).NE.ZERO ).OR.( Y( JY ).NE.ZERO ) )THEN
                  TEMP1 = ALPHA*Y( JY )
                  TEMP2 = ALPHA*X( JX )
                  IX    = JX
                  IY    = JY
                  DO 70, K = KK, KK + N - J
                     AP( K ) = AP( K ) + X( IX )*TEMP1 + Y( IY )*TEMP2
                     IX      = IX      + INCX
                     IY      = IY      + INCY
   70             CONTINUE
               END IF
               JX = JX + INCX
               JY = JY + INCY
               KK = KK + N - J + 1
   80       CONTINUE
         END IF
      END IF
*
      RETURN
*
*     End of SSPR2 .
*
      END

      SUBROUTINE SGEBAK( JOB, SIDE, N, ILO, IHI, SCALE, M, V, LDV,
     $                   INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER          JOB, SIDE
      INTEGER            IHI, ILO, INFO, LDV, M, N
*     ..
*     .. Array Arguments ..
      REAL               V( LDV, * ), SCALE( * )
*     ..
*
*  Purpose
*  =======
*
*  SGEBAK forms the right or left eigenvectors of a real general matrix
*  by backward transformation on the computed eigenvectors of the
*  balanced matrix output by SGEBAL.
*
*  Arguments
*  =========
*
*  JOB     (input) CHARACTER*1
*          Specifies the type of backward transformation required:
*          = 'N', do nothing, return immediately;
*          = 'P', do backward transformation for permutation only;
*          = 'S', do backward transformation for scaling only;
*          = 'B', do backward transformations for both permutation and
*                 scaling.
*          JOB must be the same as the argument JOB supplied to SGEBAL.
*
*  SIDE    (input) CHARACTER*1
*          = 'R':  V contains right eigenvectors;
*          = 'L':  V contains left eigenvectors.
*
*  N       (input) INTEGER
*          The number of rows of the matrix V.  N >= 0.
*
*  ILO     (input) INTEGER
*  IHI     (input) INTEGER
*          The integers ILO and IHI determined by SGEBAL.
*          1 <= ILO <= IHI <= N, if N > 0; ILO=1 and IHI=0, if N=0.
*
*  SCALE   (input) REAL array, dimension (N)
*          Details of the permutation and scaling factors, as returned
*          by SGEBAL.
*
*  M       (input) INTEGER
*          The number of columns of the matrix V.  M >= 0.
*
*  V       (input/output) REAL array, dimension (LDV,M)
*          On entry, the matrix of right or left eigenvectors to be
*          transformed, as returned by SHSEIN or STREVC.
*          On exit, V is overwritten by the transformed eigenvectors.
*
*  LDV     (input) INTEGER
*          The leading dimension of the array V. LDV >= max(1,N).
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value.
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ONE
      PARAMETER          ( ONE = 1.0E+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            LEFTV, RIGHTV
      INTEGER            I, II, K
      REAL               S
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           SSCAL, SSWAP, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX
*     ..
*     .. Executable Statements ..
*
*     Decode and Test the input parameters
*
      RIGHTV = LSAME( SIDE, 'R' )
      LEFTV = LSAME( SIDE, 'L' )
*
      INFO = 0
      IF( .NOT.LSAME( JOB, 'N' ) .AND. .NOT.LSAME( JOB, 'P' ) .AND.
     $    .NOT.LSAME( JOB, 'S' ) .AND. .NOT.LSAME( JOB, 'B' ) ) THEN
         INFO = -1
      ELSE IF( .NOT.RIGHTV .AND. .NOT.LEFTV ) THEN
         INFO = -2
      ELSE IF( N.LT.0 ) THEN
         INFO = -3
      ELSE IF( ILO.LT.1 .OR. ILO.GT.MAX( 1, N ) ) THEN
         INFO = -4
      ELSE IF( IHI.LT.MIN( ILO, N ) .OR. IHI.GT.N ) THEN
         INFO = -5
      ELSE IF( M.LT.0 ) THEN
         INFO = -7
      ELSE IF( LDV.LT.MAX( 1, N ) ) THEN
         INFO = -9
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'SGEBAK', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
      IF( M.EQ.0 )
     $   RETURN
      IF( LSAME( JOB, 'N' ) )
     $   RETURN
*
      IF( ILO.EQ.IHI )
     $   GO TO 30
*
*     Backward balance
*
      IF( LSAME( JOB, 'S' ) .OR. LSAME( JOB, 'B' ) ) THEN
*
         IF( RIGHTV ) THEN
            DO 10 I = ILO, IHI
               S = SCALE( I )
               CALL SSCAL( M, S, V( I, 1 ), LDV )
   10       CONTINUE
         END IF
*
         IF( LEFTV ) THEN
            DO 20 I = ILO, IHI
               S = ONE / SCALE( I )
               CALL SSCAL( M, S, V( I, 1 ), LDV )
   20       CONTINUE
         END IF
*
      END IF
*
*     Backward permutation
*
*     For  I = ILO-1 step -1 until 1,
*              IHI+1 step 1 until N do --
*
   30 CONTINUE
      IF( LSAME( JOB, 'P' ) .OR. LSAME( JOB, 'B' ) ) THEN
         IF( RIGHTV ) THEN
            DO 40 II = 1, N
               I = II
               IF( I.GE.ILO .AND. I.LE.IHI )
     $            GO TO 40
               IF( I.LT.ILO )
     $            I = ILO - II
               K = SCALE( I )
               IF( K.EQ.I )
     $            GO TO 40
               CALL SSWAP( M, V( I, 1 ), LDV, V( K, 1 ), LDV )
   40       CONTINUE
         END IF
*
         IF( LEFTV ) THEN
            DO 50 II = 1, N
               I = II
               IF( I.GE.ILO .AND. I.LE.IHI )
     $            GO TO 50
               IF( I.LT.ILO )
     $            I = ILO - II
               K = SCALE( I )
               IF( K.EQ.I )
     $            GO TO 50
               CALL SSWAP( M, V( I, 1 ), LDV, V( K, 1 ), LDV )
   50       CONTINUE
         END IF
      END IF
*
      RETURN
*
*     End of SGEBAK
*
      END

      SUBROUTINE ZPOSV( UPLO, N, NRHS, A, LDA, B, LDB, INFO )
*
*  -- LAPACK driver routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     March 31, 1993
*
*     .. Scalar Arguments ..
      CHARACTER          UPLO
      INTEGER            INFO, LDA, LDB, N, NRHS
*     ..
*     .. Array Arguments ..
      COMPLEX*16         A( LDA, * ), B( LDB, * )
*     ..
*
*  Purpose
*  =======
*
*  ZPOSV computes the solution to a complex system of linear equations
*     A * X = B,
*  where A is an N-by-N Hermitian positive definite matrix and X and B
*  are N-by-NRHS matrices.
*
*  The Cholesky decomposition is used to factor A as
*     A = U**H* U,  if UPLO = 'U', or
*     A = L * L**H,  if UPLO = 'L',
*  where U is an upper triangular matrix and  L is a lower triangular
*  matrix.  The factored form of A is then used to solve the system of
*  equations A * X = B.
*
*  Arguments
*  =========
*
*  UPLO    (input) CHARACTER*1
*          = 'U':  Upper triangle of A is stored;
*          = 'L':  Lower triangle of A is stored.
*
*  N       (input) INTEGER
*          The number of linear equations, i.e., the order of the
*          matrix A.  N >= 0.
*
*  NRHS    (input) INTEGER
*          The number of right hand sides, i.e., the number of columns
*          of the matrix B.  NRHS >= 0.
*
*  A       (input/output) COMPLEX*16 array, dimension (LDA,N)
*          On entry, the Hermitian matrix A.  If UPLO = 'U', the leading
*          N-by-N upper triangular part of A contains the upper
*          triangular part of the matrix A, and the strictly lower
*          triangular part of A is not referenced.  If UPLO = 'L', the
*          leading N-by-N lower triangular part of A contains the lower
*          triangular part of the matrix A, and the strictly upper
*          triangular part of A is not referenced.
*
*          On exit, if INFO = 0, the factor U or L from the Cholesky
*          factorization A = U**H*U or A = L*L**H.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(1,N).
*
*  B       (input/output) COMPLEX*16 array, dimension (LDB,NRHS)
*          On entry, the N-by-NRHS right hand side matrix B.
*          On exit, if INFO = 0, the N-by-NRHS solution matrix X.
*
*  LDB     (input) INTEGER
*          The leading dimension of the array B.  LDB >= max(1,N).
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*          > 0:  if INFO = i, the leading minor of order i of A is not
*                positive definite, so the factorization could not be
*                completed, and the solution has not been computed.
*
*  =====================================================================
*
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           XERBLA, ZPOTRF, ZPOTRS
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      IF( .NOT.LSAME( UPLO, 'U' ) .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( NRHS.LT.0 ) THEN
         INFO = -3
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -5
      ELSE IF( LDB.LT.MAX( 1, N ) ) THEN
         INFO = -7
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'ZPOSV ', -INFO )
         RETURN
      END IF
*
*     Compute the Cholesky factorization A = U'*U or A = L*L'.
*
      CALL ZPOTRF( UPLO, N, A, LDA, INFO )
      IF( INFO.EQ.0 ) THEN
*
*        Solve the system A*X = B, overwriting B with X.
*
         CALL ZPOTRS( UPLO, N, NRHS, A, LDA, B, LDB, INFO )
*
      END IF
      RETURN
*
*     End of ZPOSV
*
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C   FFTPACK 5.0
C   Copyright (C) 1995-2004, Scientific Computing Division,
C   University Corporation for Atmospheric Research
C   Licensed under the GNU General Public License (GPL)
C
C   Authors:  Paul N. Swarztrauber and Richard A. Valent
C
C   $Id: mcsqf1.f,v 1.2 2006-11-21 01:10:17 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      SUBROUTINE DMCSQF1(LOT,JUMP,N,INC,X,WSAVE,WORK,IER)
      DOUBLE PRECISION X
      DOUBLE PRECISION WSAVE
      DOUBLE PRECISION WORK
      DOUBLE PRECISION XIM1
      DIMENSION X(INC,*),WSAVE(*),WORK(LOT,*)

      IER = 0
      LJ = (LOT-1)*JUMP + 1
      NS2 = (N+1)/2
      NP2 = N + 2
      DO 101 K = 2,NS2
          KC = NP2 - K
          M1 = 0
          DO 201 M = 1,LJ,JUMP
              M1 = M1 + 1
              WORK(M1,K) = X(M,K) + X(M,KC)
              WORK(M1,KC) = X(M,K) - X(M,KC)
  201     CONTINUE
  101 CONTINUE
      MODN = MOD(N,2)
      IF (MODN.NE.0) GO TO 301
      M1 = 0
      DO 202 M = 1,LJ,JUMP
          M1 = M1 + 1
          WORK(M1,NS2+1) = X(M,NS2+1) + X(M,NS2+1)
  202 CONTINUE
  301 DO 102 K = 2,NS2
          KC = NP2 - K
          M1 = 0
          DO 302 M = 1,LJ,JUMP
              M1 = M1 + 1
              X(M,K) = WSAVE(K-1)*WORK(M1,KC) + WSAVE(KC-1)*WORK(M1,K)
              X(M,KC) = WSAVE(K-1)*WORK(M1,K) - WSAVE(KC-1)*WORK(M1,KC)
  302     CONTINUE
  102 CONTINUE
      IF (MODN.NE.0) GO TO 303
      M1 = 0
      DO 304 M = 1,LJ,JUMP
          M1 = M1 + 1
          X(M,NS2+1) = WSAVE(NS2)*WORK(M1,NS2+1)
  304 CONTINUE
  303 CONTINUE
      LENX = (LOT-1)*JUMP + INC* (N-1) + 1
      LNSV = N + INT(LOG(DBLE(N))) + 4
      LNWK = LOT*N
C
      CALL DRFFTMF(LOT,JUMP,N,INC,X,LENX,WSAVE(N+1),LNSV,WORK,LNWK,IER1)
      IF (IER1.NE.0) THEN
          IER = 20
          CALL DXERFFT('MCSQF1',-5)
          GO TO 400
      END IF
C
      DO 103 I = 3,N,2
          DO 203 M = 1,LJ,JUMP
              XIM1 = .5D0* (X(M,I-1)+X(M,I))
              X(M,I) = .5D0* (X(M,I-1)-X(M,I))
              X(M,I-1) = XIM1
  203     CONTINUE
  103 CONTINUE
  400 CONTINUE
      RETURN
      END

C
C $Id: idtang.f,v 1.5 2008-07-27 00:17:30 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE IDTANG (NDP,XD,YD,NT,IPT,NL,IPL,IWL,IWP,WK)
C
C This subroutine performs triangulation.  It divides the X-Y
C plane into a number of triangles according to given data
C points in the plane, determines line segments that form the
C border of the data area, and determines the triangle numbers
C corresponding to the border line segments.
C
C At completion, point numbers of the vertices of each triangle
C are listed counter-clockwise.  Point numbers of the end points
C of each border line segment are listed counter-clockwise,
C listing order of the line segments being counter-clockwise.
C
C This subroutine calls the function IDXCHG.
C
C The input arguments are as follows:
C
C   NDP  number of data points.
C
C   XD   array of dimension NDP containing the
C        X coordinates of the data points.
C
C   YD   array of dimension NDP containing the
C        Y coordinates of the data points.
C
C The output arguments are as follows:
C
C   NT    number of triangles.
C
C   IPT  integer array of dimension 6*NDP-15, where the
C        point numbers of the vertices of the (IT)th
C        triangle are to be stored as the (3*IT-2)nd,
C        (3*IT-1)st, and (3*IT)th elements,
C        IT=1,2,...,NT.
C
C   NL   number of border line segments,
C
C   IPL  integer array of dimension 6*NDP, where the
C        point numbers of the end points of the (IL)th
C        border line segment and its respective triangle
C        number are to be stored as the (3*IL-2)nd,
C        (3*IL-1)st, and (3*IL)th elements,
C        IL=1,2,..., NL.
C
C The other arguments are as follows:
C
C   IWL  integer array of dimension 18*NDP used internally as a
C        work area.
C
C   IWP  integer array of dimension NDP used internally as a
C         work area.
C
C   WK   real array of dimension NDP used internally as a
C        work area.
C
C Declaration statements.
C
      DIMENSION XD(NDP),YD(NDP),IPT(6*NDP-15),IPL(6*NDP),IWL(18*NDP),
     +          IWP(NDP),WK(NDP),ITF(2)
C
      DATA EPSLN / 1.E-6 /, NREP / 200 /
C
C Statement functions.
C
      DSQF(U1,V1,U2,V2)=(U2-U1)**2+(V2-V1)**2
      SPDT(U1,V1,U2,V2,U3,V3)=(U2-U1)*(U3-U1)+(V2-V1)*(V3-V1)
      VPDT(U1,V1,U2,V2,U3,V3)=(V3-V1)*(U2-U1)-(U3-U1)*(V2-V1)
C
C Preliminary processing.
C
      IF (NDP.LT.4) THEN
        CALL SETER ('IDTANG (BIVAR) - INPUT PARAMETER NDP OUT OF RANGE',
     +1,1)
        RETURN
      END IF
C
      NDPM1=NDP-1
C
C Determine the closest pair of data points and the midpoint.
C
      DSQMN=DSQF(XD(1),YD(1),XD(2),YD(2))
      IPMN1=1
      IPMN2=2
      DO 102 IP1=1,NDPM1
        X1=XD(IP1)
        Y1=YD(IP1)
        IP1P1=IP1+1
        DO 101 IP2=IP1P1,NDP
          DSQI=DSQF(X1,Y1,XD(IP2),YD(IP2))
          IF (DSQI.EQ.0.) THEN
            CALL SETER ('IDTANG (BIVAR) - TWO OF THE INPUT DATA POINTS A
     +RE IDENTICAL',2,1)
            RETURN
          END IF
          IF (DSQI.GE.DSQMN) GO TO 101
          DSQMN=DSQI
          IPMN1=IP1
          IPMN2=IP2
  101   CONTINUE
  102 CONTINUE
      XDMP=(XD(IPMN1)+XD(IPMN2))/2.0
      YDMP=(YD(IPMN1)+YD(IPMN2))/2.0
C
C Sort the other (NDP-2) data points in ascending order of
C distance from the midpoint and store the sorted data point
C numbers in the IWP array.
C
      JP1=2
C
      DO 103 IP1=1,NDP
        IF (IP1.EQ.IPMN1.OR.IP1.EQ.IPMN2) GO TO 103
        JP1=JP1+1
        IWP(JP1)=IP1
        WK(JP1)=DSQF(XDMP,YDMP,XD(IP1),YD(IP1))
  103 CONTINUE
C
      DO 105 JP1=3,NDPM1
        DSQMN=WK(JP1)
        JPMN=JP1
        DO 104 JP2=JP1,NDP
          IF (WK(JP2).GE.DSQMN) GO TO 104
          DSQMN=WK(JP2)
          JPMN=JP2
  104   CONTINUE
        ITS=IWP(JP1)
        IWP(JP1)=IWP(JPMN)
        IWP(JPMN)=ITS
        WK(JPMN)=WK(JP1)
  105 CONTINUE
C
C If necessary, modify the ordering in such a way that the
C first three data points are not collinear.
C
      X1=XD(IPMN1)
      Y1=YD(IPMN1)
      X2=XD(IPMN2)
      Y2=YD(IPMN2)
C
      DO 106 JP=3,NDP
        IP=IWP(JP)
        SP=SPDT(XD(IP),YD(IP),X1,Y1,X2,Y2)
        VP=VPDT(XD(IP),YD(IP),X1,Y1,X2,Y2)
        IF (ABS(VP).GT.(ABS(SP)*EPSLN)) GO TO 107
  106 CONTINUE
C
      CALL SETER ('IDTANG (BIVAR) - ALL COLLINEAR DATA POINTS',3,1)
      RETURN
C
  107 IF (JP.EQ.3) GO TO 109
      JPMX=JP
C
      DO 108 JPC=4,JPMX
        JP=JPMX+4-JPC
        IWP(JP)=IWP(JP-1)
  108 CONTINUE
C
      IWP(3)=IP
C
C Form the first triangle.  Store point numbers of the vertices
C of the triangle in the IPT array, and store point numbers of
C the border line segments and the triangle number in the IPL
C array.
C
  109 IP1=IPMN1
      IP2=IPMN2
      IP3=IWP(3)
      IF (VPDT(XD(IP1),YD(IP1),XD(IP2),YD(IP2),XD(IP3),YD(IP3))
     +                                        .GE.0.) GO TO 110
      IP1=IPMN2
      IP2=IPMN1
  110 NT0=1
      NTT3=3
      IPT(1)=IP1
      IPT(2)=IP2
      IPT(3)=IP3
      NL0=3
      NLT3=9
      IPL(1)=IP1
      IPL(2)=IP2
      IPL(3)=1
      IPL(4)=IP2
      IPL(5)=IP3
      IPL(6)=1
      IPL(7)=IP3
      IPL(8)=IP1
      IPL(9)=1
C
C Add the remaining (NDP-3) data points, one by one.
C
      DO 130 JP1=4,NDP
C
        IP1=IWP(JP1)
        X1=XD(IP1)
        Y1=YD(IP1)
C
C Determine the first invisible and visible border line segments,
C ILIV and ILVS.
C
        DO 113 IL=1,NL0
          IP2=IPL(3*IL-2)
          IP3=IPL(3*IL-1)
          X2=XD(IP2)
          Y2=YD(IP2)
          X3=XD(IP3)
          Y3=YD(IP3)
          SP=SPDT(X1,Y1,X2,Y2,X3,Y3)
          VP=VPDT(X1,Y1,X2,Y2,X3,Y3)
          IF (IL.NE.1) GO TO 111
          IXVS=0
          IF (VP.LE.(ABS(SP)*(-EPSLN))) IXVS=1
          ILIV=1
          ILVS=1
          GO TO 113
  111     IXVSPV=IXVS
          IF (VP.GT.(ABS(SP)*(-EPSLN))) GO TO 112
          IXVS=1
          IF (IXVSPV.EQ.1) GO TO 113
          ILVS=IL
          IF (ILIV.NE.1) GO TO 114
          GO TO 113
  112     IXVS=0
          IF (IXVSPV.EQ.0) GO TO 113
          ILIV=IL
          IF (ILVS.NE.1) GO TO 114
  113   CONTINUE
C
        IF (ILIV.EQ.1.AND.ILVS.EQ.1) ILVS=NL0
  114   IF (ILVS.LT.ILIV) ILVS=ILVS+NL0
C
C Shifts (rotates) the IPL array to have the invisible border
C line segments contained in the first part of the IPL array.
C
        IF (ILIV.EQ.1) GO TO 117
        NLSH=ILIV-1
        NLSHT3=NLSH*3
C
        DO 115 JL1=1,NLSHT3
          JL2=JL1+NLT3
          IPL(JL2)=IPL(JL1)
  115   CONTINUE
C
        DO 116 JL1=1,NLT3
          JL2=JL1+NLSHT3
          IPL(JL1)=IPL(JL2)
  116   CONTINUE
C
        ILVS=ILVS-NLSH
C
C Add triangles to the IPT array, update border line segments
C in the IPL array, and set flags for the border lines segments
C to be re-examined in the IWL array.
C
  117   JWL=0
C
        DO 121 IL=ILVS,NL0
C
          ILT3=IL*3
          IPL1=IPL(ILT3-2)
          IPL2=IPL(ILT3-1)
          IT  =IPL(ILT3)
C
C Add a triangle to the IPT array.
C
          NT0=NT0+1
          NTT3=NTT3+3
          IPT(NTT3-2)=IPL2
          IPT(NTT3-1)=IPL1
          IPT(NTT3)  =IP1
C
C Update border line segments in the IPL array.
C
          IF (IL.NE.ILVS) GO TO 118
          IPL(ILT3-1)=IP1
          IPL(ILT3)  =NT0
  118     IF (IL.NE.NL0) GO TO 119
          NLN=ILVS+1
          NLNT3=NLN*3
          IPL(NLNT3-2)=IP1
          IPL(NLNT3-1)=IPL(1)
          IPL(NLNT3)  =NT0
C
C Determine the vertex that does not lie on the border
C line segments.
C
  119     ITT3=IT*3
          IPTI=IPT(ITT3-2)
          IF (IPTI.NE.IPL1.AND.IPTI.NE.IPL2) GO TO 120
          IPTI=IPT(ITT3-1)
          IF (IPTI.NE.IPL1.AND.IPTI.NE.IPL2) GO TO 120
          IPTI=IPT(ITT3)
C
C Check if an exchange is necessary.
C
  120     IF (IDXCHG(XD,YD,IP1,IPTI,IPL1,IPL2).EQ.0) GO TO 121
C
C Modify the IPT array when necessary.
C
          IPT(ITT3-2)=IPTI
          IPT(ITT3-1)=IPL1
          IPT(ITT3)  =IP1
          IPT(NTT3-1)=IPTI
          IF (IL.EQ.ILVS)  IPL(ILT3)=IT
          IF (IL.EQ.NL0.AND.IPL(3).EQ.IT) IPL(3)=NT0
C
C Set flags in the IWL array.
C
          JWL=JWL+4
          IWL(JWL-3)=IPL1
          IWL(JWL-2)=IPTI
          IWL(JWL-1)=IPTI
          IWL(JWL)  =IPL2
C
  121   CONTINUE
C
        NL0=NLN
        NLT3=NLNT3
        NLF=JWL/2
        IF (NLF.EQ.0) GO TO 130
C
C Improve triangulation.
C
        NTT3P3=NTT3+3
C
        DO 129 IREP=1,NREP
C
          DO 127 ILF=1,NLF
C
            IPL1=IWL(2*ILF-1)
            IPL2=IWL(2*ILF)
C
C Locate in the IPT array two triangles, one on each side of
C the flagged line segment.
C
            NTF=0
C
            DO 122 ITT3R=3,NTT3,3
              ITT3=NTT3P3-ITT3R
              IPT1=IPT(ITT3-2)
              IPT2=IPT(ITT3-1)
              IPT3=IPT(ITT3)
              IF (IPL1.NE.IPT1.AND.IPL1.NE.IPT2.AND.
     +            IPL1.NE.IPT3) GO TO 122
              IF (IPL2.NE.IPT1.AND.IPL2.NE.IPT2.AND.
     +            IPL2.NE.IPT3) GO TO 122
              NTF=NTF+1
              ITF(NTF)=ITT3/3
              IF (NTF.EQ.2) GO TO 123
  122       CONTINUE
C
            IF (NTF.LT.2) GO TO 127
C
C Determine the vertices of the triangles that do not lie
C on the line segment.
C
  123       IT1T3=ITF(1)*3
            IPTI1=IPT(IT1T3-2)
            IF (IPTI1.NE.IPL1.AND.IPTI1.NE.IPL2) GO TO 124
            IPTI1=IPT(IT1T3-1)
            IF (IPTI1.NE.IPL1.AND.IPTI1.NE.IPL2) GO TO 124
            IPTI1=IPT(IT1T3)
  124       IT2T3=ITF(2)*3
            IPTI2=IPT(IT2T3-2)
            IF (IPTI2.NE.IPL1.AND.IPTI2.NE.IPL2) GO TO 125
            IPTI2=IPT(IT2T3-1)
            IF (IPTI2.NE.IPL1.AND.IPTI2.NE.IPL2) GO TO 125
            IPTI2=IPT(IT2T3)
C
C Check if an exchange is necessary.
C
  125       IF (IDXCHG(XD,YD,IPTI1,IPTI2,IPL1,IPL2).EQ.0) GO TO 127
C
C Modify the IPT array when necessary.
C
            IPT(IT1T3-2)=IPTI1
            IPT(IT1T3-1)=IPTI2
            IPT(IT1T3)  =IPL1
            IPT(IT2T3-2)=IPTI2
            IPT(IT2T3-1)=IPTI1
            IPT(IT2T3)  =IPL2
C
C Set new flags.
C
            JWL=JWL+8
            IWL(JWL-7)=IPL1
            IWL(JWL-6)=IPTI1
            IWL(JWL-5)=IPTI1
            IWL(JWL-4)=IPL2
            IWL(JWL-3)=IPL2
            IWL(JWL-2)=IPTI2
            IWL(JWL-1)=IPTI2
            IWL(JWL)  =IPL1
C
            DO 126 JLT3=3,NLT3,3
              IPLJ1=IPL(JLT3-2)
              IPLJ2=IPL(JLT3-1)
              IF ((IPLJ1.EQ.IPL1.AND.IPLJ2.EQ.IPTI2).OR.
     +            (IPLJ2.EQ.IPL1.AND.IPLJ1.EQ.IPTI2))
     +                                  IPL(JLT3)=ITF(1)
              IF ((IPLJ1.EQ.IPL2.AND.IPLJ2.EQ.IPTI1).OR.
     +            (IPLJ2.EQ.IPL2.AND.IPLJ1.EQ.IPTI1))
     +                                  IPL(JLT3)=ITF(2)
  126       CONTINUE
C
  127     CONTINUE
C
          NLFC=NLF
          NLF=JWL/2
          IF (NLF.EQ.NLFC) GO TO 130
C
C Reset the IWL array for the next round.
C
          JWL1MN=2*NLFC+1
          NLFT2=NLF*2
C
          DO 128 JWL1=JWL1MN,NLFT2
            JWL=JWL1+1-JWL1MN
            IWL(JWL)=IWL(JWL1)
  128     CONTINUE
C
          NLF=JWL/2
C
  129   CONTINUE
C
  130 CONTINUE
C
C Re-arrange the IPT array so that the vertices of each triangle
C are listed counter-clockwise.
C
      DO 131 ITT3=3,NTT3,3
        IP1=IPT(ITT3-2)
        IP2=IPT(ITT3-1)
        IP3=IPT(ITT3)
        IF (VPDT(XD(IP1),YD(IP1),XD(IP2),YD(IP2),XD(IP3),YD(IP3))
     1                                         .GE.0.0) GO TO 131
        IPT(ITT3-2)=IP2
        IPT(ITT3-1)=IP1
  131 CONTINUE
C
      NT=NT0
      NL=NL0
C
      RETURN
C
      END

        PROGRAM TDEX05
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
        PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C This example is an extension of example 1.  It illustrates how one
C can transform the triangles in a triangle list.
C
C Create parameters specifying the maximum sizes of the arrays defining
C data and the arrays required for dealing with the list of triangles.
C
        PARAMETER (IMAX=41,JMAX=41,KMAX=41,MTRI=200000)
C
C Declare local dimensioned variables to hold data defining a simple
C surface and an isosurface.
C
        DIMENSION U(IMAX),V(JMAX),W(KMAX),S(IMAX,JMAX),F(IMAX,JMAX,KMAX)
C
C Declare a local array to hold the triangle list and a couple of
C temporary variables to be used in sorting the list.
C
        DIMENSION RTRI(10,MTRI),RTWK(MTRI,2),ITWK(MTRI)
C
C Declare variables to hold axis labels.
C
        CHARACTER*64 UNLB,VNLB,WNLB,UILB,VILB,WILB
C
C Declare variables to hold plot labels.
C
        CHARACTER*64 LABL(0:3)
C
C Set the desired minimum and maximum values of U, V, and W.
C
        DATA UMIN,VMIN,WMIN,UMAX,VMAX,WMAX / -1.,-1.,-1.,1.,1.,1. /
C
C Set the desired values of the dimensions of the data arrays.  Note
C that IDIM must not exceed IMAX, that JDIM must not exceed JMAX, and
C that KDIM must not exceed KMAX.
C
        DATA IDIM,JDIM,KDIM / 31,31,31 /
C
C Set the desired values of parameters determining the eye position.
C ANG1 is a bearing angle, ANG2 is an elevation angle, and RMUL is a
C multiplier of the length of the diagonal of the data box, specifying
C the distance from the center of the box to the eye.
C
        DATA ANG1,ANG2,RMUL / -35.,25.,2.9 /
C
C ISTE is a flag that says whether to do a simple image (ISTE=0),
C a one-frame stereo image (ISTE=-1), or a two-frame stereo image
C (ISTE=+1).
C
        DATA ISTE / -1 /
C
C ASTE is the desired angle (in degrees) between the lines of sight for
C a pair of stereo views.
C
        DATA ASTE / 4. /
C
C WOSW is the width of the stereo windows to be used in one-frame stereo
C images; the width is stated as a fraction of the width of the plotter
C frame.  (The windows are centered vertically; horizontally, they are
C placed as far apart as possible in the plotter frame.)  The value used
C must be positive and non-zero; it may be slightly greater than .5, if
C it is desired that the stereo windows should overlap slightly.
C
        DATA WOSW / .5 /
C
C Set the desired value of the flag that says whether the basic color
C scheme will be white on black (IBOW=0) or black on white (IBOW=1).
C
        DATA IBOW / 1 /
C
C Set the desired value of the flag that says whether shading of the
C surfaces will be done using gray scales (ICLR=0) or colors (ICLR=1).
C
        DATA ICLR / 1 /
C
C Set the desired values of the shading parameters.  Values of SHDE
C near 0 give brighter colors and values near 1 give pastel shades.
C Values of SHDR near 0 give a narrow range of shades and values near
C 1 give a wide range of shades.
C
        DATA SHDE,SHDR / .1 , .8 /
C
C Set the desired values of the rendering-style indices for the
C isosurface and the simple surface, respectively.
C
        DATA IIRS,ISRS / 2,3 /
C
C Define the conversion constant from degrees to radians.
C
        DATA DTOR / .017453292519943 /
C
C Define labels for the edges of the box.
C
        DATA UNLB / ' -1 -.8 -.6 -.4 -.2 0 .2 .4 .6 .8 1 ' /
        DATA VNLB / ' -1 -.8 -.6 -.4 -.2 0 .2 .4 .6 .8 1 ' /
        DATA WNLB / ' -1 -.8 -.6 -.4 -.2 0 .2 .4 .6 .8 1 ' /
C
        DATA UILB / 'U Coordinate Values' /
        DATA VILB / 'V Coordinate Values' /
        DATA WILB / 'W Coordinate Values' /
C
C Define plot labels.
C
        DATA LABL / 'IMAP = 0' ,
     +              'IMAP = 1'  ,
     +              'IMAP = 2'  ,
     +              'IMAP = 3'  /
C
C Open GKS.
C
        CALL GOPKS (IERRF, ISZDM)
        CALL GOPWK (IWKID, LUNIT, IWTYPE)
        CALL GACWK (IWKID)
C
C Turn clipping off.
C
        CALL GSCLIP (0)
C
C Double the line width.
C
        CALL GSLWSC (2.)
C
C Define colors to use.
C
        CALL TDCLRS (1,IBOW,SHDE,SHDR,11,42,4)
C
C Fill data arrays defining a simple surface and an isosurface.  The
C simple surface is defined by the equation "w=s(u,v)"; the function
C "s" is approximated by the contents of the array S: S(I,J) is the
C value of s(U(I),V(J)), where I goes from 1 to IDIM and J from 1 to
C JDIM.  The isosurface is defined by the equation f(u,v,w)=1.; the
C function f is approximated by the contents of the array F: F(I,J,K)
C is the value of f(U(I),V(J),W(K)), where I goes from 1 to IDIM, J
C from 1 to JDIM, and K from 1 to KDIM.
C
        DO 102 I=1,IDIM
          U(I)=UMIN+(REAL(I-1)/REAL(IDIM-1))*(UMAX-UMIN)
  102   CONTINUE
C
        DO 103 J=1,JDIM
          V(J)=VMIN+(REAL(J-1)/REAL(JDIM-1))*(VMAX-VMIN)
  103   CONTINUE
C
        DO 104 K=1,KDIM
          W(K)=WMIN+(REAL(K-1)/REAL(KDIM-1))*(WMAX-WMIN)
  104   CONTINUE
C
        DO 107 I=1,IDIM
          DO 106 J=1,JDIM
            S(I,J)=2.*EXP(-2.*(U(I)**2+V(J)**2))-1.
            DO 105 K=1,KDIM
              F(I,J,K)=1.25*U(I)**2+1.25*V(J)**2+5.*W(K)**2
  105       CONTINUE
  106     CONTINUE
  107   CONTINUE
C
C Select font number 25, turn on the outlining of filled fonts, set the
C line width to 1, and turn off the setting of the outline color.
C
        CALL PCSETI ('FN - FONT NUMBER',25)
        CALL PCSETI ('OF - OUTLINE FLAG',1)
        CALL PCSETR ('OL - OUTLINE LINE WIDTH',1.)
        CALL PCSETR ('OC - OUTLINE LINE COLOR',-1.)
C
C Make TDPACK characters a bit bigger.
C
        CALL TDSETR ('CS1',1.25)
C
C Define TDPACK rendering styles 1 through 7, using black-and-white
C shading or colored shading, whichever is selected.  The indices
C 1-7 can then be used as final arguments in calls to TDITRI, TDSTRI,
C and TDMTRI.
C
        IF (ICLR.EQ.0) THEN
C
C Rendering styles 1-7 are all gray on both sides:
C
          CALL TDSTRS (1,43,74, 43, 74,-1,-1,1,0.,0.,0.)
          CALL TDSTRS (2,43,74, 43, 74,-1,-1,1,0.,0.,0.)
          CALL TDSTRS (3,43,74, 43, 74,-1,-1,1,0.,0.,0.)
          CALL TDSTRS (4,43,74, 43, 74,-1,-1,1,0.,0.,0.)
          CALL TDSTRS (5,43,74, 43, 74,-1,-1,1,0.,0.,0.)
          CALL TDSTRS (6,43,74, 43, 74,-1,-1,1,0.,0.,0.)
          CALL TDSTRS (7,43,74, 43, 74,-1,-1,1,0.,0.,0.)
C
        ELSE
C
C Rendering styles 1-7 are all gray on one side.  The other side is
C 1) gray, 2) red, 3) green, 4) blue, 5) cyan, 6) magenta, 7) yellow.
C
          CALL TDSTRS (1,43,74, 43, 74,-1,-1,1,0.,0.,0.)
          CALL TDSTRS (2,43,74, 75,106,-1,-1,1,0.,0.,0.)
          CALL TDSTRS (3,43,74,107,138,-1,-1,1,0.,0.,0.)
          CALL TDSTRS (4,43,74,139,170,-1,-1,1,0.,0.,0.)
          CALL TDSTRS (5,43,74,171,202,-1,-1,1,0.,0.,0.)
          CALL TDSTRS (6,43,74,203,234,-1,-1,1,0.,0.,0.)
          CALL TDSTRS (7,43,74,235,266,-1,-1,1,0.,0.,0.)
C
        END IF
C
C Find the midpoint of the data box (to be used as the point looked at).
C
        UMID=.5*(UMIN+UMAX)
        VMID=.5*(VMIN+VMAX)
        WMID=.5*(WMIN+WMAX)
C
C Determine the distance (R) from which the data box will be viewed and,
C given that, the eye position.
C
        R=RMUL*SQRT((UMAX-UMIN)**2+(VMAX-VMIN)**2+(WMAX-WMIN)**2)
C
        UEYE=UMID+R*COS(DTOR*ANG1)*COS(DTOR*ANG2)
        VEYE=VMID+R*SIN(DTOR*ANG1)*COS(DTOR*ANG2)
        WEYE=WMID+R*SIN(DTOR*ANG2)
C
C Initialize the mapping parameter to do no mapping on the first frame.
C
        IMAP=0
C
C Initialize the count of triangles in the triangle list.
C
  108   NTRI=0
C
C Add to the triangle list triangles representing a simple surface.
C
        CALL TDSTRI (U,IDIM,V,JDIM,S,IMAX,RTRI,MTRI,NTRI,ISRS)
C
        IF (NTRI.EQ.MTRI) THEN
          PRINT * , 'TRIANGLE LIST OVERFLOW IN TDSTRI'
          STOP
        END IF
C
C Add to the triangle list triangles representing an isosurface.
C
        CALL TDITRI (U,IDIM,V,JDIM,W,KDIM,F,IMAX,JMAX,1.,
     +                               RTRI,MTRI,NTRI,IIRS)
C
        IF (NTRI.EQ.MTRI) THEN
          PRINT * , 'TRIANGLE LIST OVERFLOW IN TDITRI'
          STOP
        END IF
C
C Apply a mapping to the XYZ coordinates of the vertices of the
C triangles in the triangle list.
C
        CALL TDMXYZ (IMAP,RTRI,MTRI,NTRI)
C
C Initialize the stereo offset argument to do either a single view or
C a left-eye view (whichever is selected by the value of ISTE).
C
        IF (ISTE.EQ.0) THEN
          OTEP=0.
        ELSE
          OTEP=-R*TAN(DTOR*ASTE/2.)
        END IF
C
C Initialize TDPACK.
C
  109   CALL TDINIT (UEYE,VEYE,WEYE,UMID,VMID,WMID,
     +                              UMID,VMID,WMID+R,OTEP)
C
C If stereo views are being done, do the requested thing, either by
C redoing the SET call to put them side by side on the same frame,
C or by calling FRAME to put them on separate frames.
C
        IF (OTEP.NE.0.) THEN
          IF (ISTE.LT.0) THEN
            CALL GETSET (XVPL,XVPR,YVPB,YVPT,XWDL,XWDR,YWDB,YWDT,LNLG)
            IF (OTEP.LT.0.) THEN
              CALL SET  (1.-WOSW,1.,.5-.5*WOSW,.5+.5*WOSW,
     +                           XWDL,XWDR,YWDB,YWDT,LNLG)
            ELSE
              CALL SET  (  0., WOSW,.5-.5*WOSW,.5+.5*WOSW,
     +                           XWDL,XWDR,YWDB,YWDT,LNLG)
            END IF
          ELSE
            IF (OTEP.GT.0.) CALL FRAME
          END IF
        END IF
C
C Order the triangles in the triangle list.
C
        CALL TDOTRI (RTRI,MTRI,NTRI,RTWK,ITWK,1)
C
        IF (NTRI.EQ.MTRI) THEN
          PRINT * , 'TRIANGLE LIST OVERFLOW IN TDOTRI'
          STOP
        END IF
C
C Draw labels for the axes.
C
        CALL TDLBLS (UMIN,VMIN,WMIN,UMAX,VMAX,WMAX,
     +               UNLB,VNLB,WNLB,UILB,VILB,WILB,1)
C
C Draw the sides of the box that could be hidden.
C
        CALL TDGRDS (UMIN,VMIN,WMIN,UMAX,VMAX,WMAX,
     +               .1*(UMAX-UMIN),.1*(VMAX-VMIN),.1*(WMAX-WMIN),
     +                                                       12,1)
C
C Draw the triangles in the triangle list.
C
        CALL TDDTRI (RTRI,MTRI,NTRI,ITWK)
C
C Draw the sides of the box that could not be hidden.
C
        CALL TDGRDS (UMIN,VMIN,WMIN,UMAX,VMAX,WMAX,
     +               .1*(UMAX-UMIN),.1*(VMAX-VMIN),.1*(WMAX-WMIN),
     +                                                       12,0)
C
C Put a label below the box.
C
        IF (ISTE.EQ.0) THEN
          CALL PLCHHQ(0.,-1.9,
     +                LABL(IMAP)(IOFNBC(LABL(IMAP)):IOLNBC(LABL(IMAP))),
     +                                                        .02,0.,0.)
        ELSE
          CALL PLCHHQ(0.,0.,
     +                LABL(IMAP)(IOFNBC(LABL(IMAP)):IOLNBC(LABL(IMAP))),
     +                                                        .02,0.,0.)
        END IF
C
C If a left-eye view has just been done, loop back for a right-eye view.
C
        IF (OTEP.LT.0.) THEN
          OTEP=-OTEP
          GO TO 109
        END IF
C
C Advance the frame.
C
        CALL FRAME
C
C If the last image has not been done, bump the mapping selector and
C loop back for the next.
C
        IF (IMAP.LT.3) THEN
          IMAP=IMAP+1
          GO TO 108
        END IF
C
C Close GKS.
C
        CALL GDAWK (IWKID)
        CALL GCLWK (IWKID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END


      SUBROUTINE TDMXYZ (IMAP,RTRI,MTRI,NTRI)
C
        DIMENSION RTRI(10,MTRI)
C
        DATA PI   / 3.14159265358979323846 /
        DATA PIO2 / 1.57079632679489661923 /
        DATA PIO4 / 0.78539816339744830461 /
C
C This routine can be made to map the XYZ coordinates of the vertices
C of the triangles in a triangle list.  It is not to be viewed as a
C general-purpose routine, but only as an example, illustrating what
C can be done.
C
C Note that the contents of the array RTRI defines NTRI triangles; the
C Ith triangle is defined by the following vertices:
C
C   (RTRI(1,I),RTRI(2,I),RTRI(3,I))
C   (RTRI(4,I),RTRI(5,I),RTRI(6,I))
C   (RTRI(7,I),RTRI(8,I),RTRI(9,I))
C
C RTRI(10,I) is a "rendering style" for the triangle; it should not be
C modified.
C
C Using IMAP = 0 selects the identity mapping - the contents of RTRI
C are not changed.
C
C Using IMAP = 1 sort of turns the object being viewed "upside down".
C Actually, it creates a mirror image of the original; we swap points
C 1 and 2 of each triangle to keep the rendering consistent with that
C of the untransformed object.
C
        IF (IMAP.EQ.1) THEN
C
          DO 101 ITRI=1,NTRI
            RTRI(3,ITRI)=-RTRI(3,ITRI)
            RTRI(6,ITRI)=-RTRI(6,ITRI)
            RTRI(9,ITRI)=-RTRI(9,ITRI)
            XTMP=RTRI(1,ITRI)
            YTMP=RTRI(2,ITRI)
            ZTMP=RTRI(3,ITRI)
            RTRI(1,ITRI)=RTRI(4,ITRI)
            RTRI(2,ITRI)=RTRI(5,ITRI)
            RTRI(3,ITRI)=RTRI(6,ITRI)
            RTRI(4,ITRI)=XTMP
            RTRI(5,ITRI)=YTMP
            RTRI(6,ITRI)=ZTMP
  101     CONTINUE
C
        END IF
C
C Using IMAP = 2 simply maps each each X, Y, and Z coordinate into
C the sine of pi/2 times the value of the coordinate, which carries
C the range [-1,1] back into [-1,1].
C
        IF (IMAP.EQ.2) THEN
C
          DO 103 ITRI=1,NTRI
            DO 102 I=1,9
              RTRI(I,ITRI)=SIN(PIO2*RTRI(I,ITRI))
  102       CONTINUE
  103     CONTINUE
C
        END IF
C
C Using IMAP = 3 causes the X, Y, and Z coordinates to be identified
C with a pseudo-latitude (values from -1 to +1 are interpreted as being
C from 0 degrees to 90 degrees), pseudo-longitude (values from -1 to +1
C are interpreted as being from 0 degrees to 90 degrees), and radius
C (values from -1 to +1 are interpreted as being from .5 to 1),
C respectively.  The resulting X, Y, and Z coordinates are all between
C 0 and 1, so, in a separate step, we scale them to the range from -1
C to 1 in order to get a larger image.  As with IMAP = 1, there is a
C mirror-image effect and we have to swap points 1 and 2 in order to
C render the surfaces in the desired colors.
C
        IF (IMAP.EQ.3) THEN
C
          DO 105 ITRI=1,NTRI
            DO 104 I=0,6,3
              RLAT=(RTRI(I+1,ITRI)+1.)*PIO4
              RLON=(RTRI(I+2,ITRI)+1.)*PIO4
              RADI=(RTRI(I+3,ITRI)+3.)/4.
              RTRI(I+1,ITRI)=RADI*COS(RLAT)*COS(RLON)
              RTRI(I+2,ITRI)=RADI*COS(RLAT)*SIN(RLON)
              RTRI(I+3,ITRI)=RADI*SIN(RLAT)
              RTRI(I+1,ITRI)=2.5*RTRI(I+1,ITRI)-1.
              RTRI(I+2,ITRI)=2.5*RTRI(I+2,ITRI)-1.
              RTRI(I+3,ITRI)=2.5*RTRI(I+3,ITRI)-1.
  104       CONTINUE
            XTMP=RTRI(1,ITRI)
            YTMP=RTRI(2,ITRI)
            ZTMP=RTRI(3,ITRI)
            RTRI(1,ITRI)=RTRI(4,ITRI)
            RTRI(2,ITRI)=RTRI(5,ITRI)
            RTRI(3,ITRI)=RTRI(6,ITRI)
            RTRI(4,ITRI)=XTMP
            RTRI(5,ITRI)=YTMP
            RTRI(6,ITRI)=ZTMP
  105     CONTINUE
C
        END IF
C
C Done.
C
        RETURN
C
      END



      FUNCTION IOFNBC(CHRS)
        CHARACTER*(*) CHRS
        DO 101 I=1,LEN(CHRS)
          IF (CHRS(I:I).NE.' ') THEN
            IOFNBC=I
            RETURN
          END IF
  101   CONTINUE
        IOFNBC=1
        RETURN
      END



      FUNCTION IOLNBC(CHRS)
        CHARACTER*(*) CHRS
        DO 101 I=LEN(CHRS),1,-1
          IF (CHRS(I:I).NE.' ') THEN
            IOLNBC=I
            RETURN
          END IF
  101   CONTINUE
        IOLNBC=1
        RETURN
      END

C
C	$Id: nggetc.f,v 1.6 2008-07-27 00:17:17 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE NGGETC (CNP,CVP)
C
      SAVE
C
      CHARACTER*(*) CNP,CVP
C
C  This subroutine is called to retrieve the character value of a
C  specified parameter.
C
C  CNP is the name of the parameter whose value is to be retrieved.
C
C  CVP is a character variable in which the desired value is to be
C  returned by NGGETC.
C
C Declare a local character variable in which to form an error message.
C
      CHARACTER*38 CTM
C
      include 'ngcomn.h'
C
C  Do a call forcing a BLOCKDATA to be loaded from a binary library.
C
      CALL NGBLDA
C
C Check for an uncleared prior error.
C
      IF (ICFELL('NGGETC - Uncleared prior error',1) .NE. 0) RETURN
C
C Check for a parameter name that is too short.
C
      IF (LEN(CNP) .LT. 2) THEN
        CTM(1:36)='NGGETC - Parameter name too short - '
        CTM(37:36+LEN(CNP)) = CNP
        CALL SETER (CTM(1:36+LEN(CNP)), 1, 1)
        RETURN
      ENDIF
C
C Get the appropriate parameter value.
C
      IF (CNP(1:2).EQ.'ME' .OR. CNP(1:2).EQ.'me' .OR.
     +    CNP(1:2).EQ.'Me') THEN
C
C  Check to see if the length of the supplied string is long enough
C  to hold the result.
C
        ILEN = 0
        DO 10 I=1,256
          IF (CFILNM(I:I).EQ.' ' .OR. CFILNM(I:I).EQ.CHAR(0)) THEN
            ILEN = I-1
            GO TO 20
          ENDIF
   10   CONTINUE
        CALL SETER('NGGETC - file name too long for ME', 2, 1)
        GO TO 110
   20   CONTINUE
        IF (ILEN .GT. LEN(CVP)) THEN
          CALL SETER('NGGETC - supplied string not long enough to receiv       
     +e value for ME', 3, 1)
          GO TO 110
        ENDIF
        CVP = CFILNM(1:ILEN)
        GO TO 110
      ELSE IF (CNP(1:2).EQ.'PI' .OR. CNP(1:2).EQ.'pi' .OR.
     +    CNP(1:2).EQ.'Pi') THEN
C
C  Check to see if the length of the supplied string is long enough
C  to hold the result.
C
        ILEN = 0
        DO 30 I=1,80
          IF (CPICNM(I:I).EQ.' ' .OR. CPICNM(I:I).EQ.CHAR(0)) THEN
            ILEN = I-1
            GO TO 40
          ENDIF
   30   CONTINUE
   40   CONTINUE
        IF (ILEN .GT. LEN(CVP)) THEN
          CALL SETER('NGGETC - supplied string not long enough to receiv       
     +e value for PI', 4, 1)
          GO TO 110
        ENDIF
        CVP = CPICNM(1:ILEN)
        GO TO 110
      ELSE IF (CNP(1:2).EQ.'SE' .OR. CNP(1:2).EQ.'se' .OR.
     +    CNP(1:2).EQ.'Se') THEN
C
C  Check to see if the length of the supplied string is long enough
C  to hold the result.
C
        ILEN = 0
        DO 50 I=1,15
          IF (CSEGNM(I:I).EQ.' ' .OR. CSEGNM(I:I).EQ.CHAR(0)) THEN
            ILEN = I-1
            GO TO 60
          ENDIF
   50   CONTINUE
        ILEN = 15
   60   CONTINUE
        IF (ILEN .GT. LEN(CVP)) THEN
          CALL SETER('NGGETC - supplied string not long enough to receiv       
     +e value for SE', 4, 1)
          GO TO 110
        ENDIF
        CVP = CSEGNM(1:ILEN)
        GO TO 110
      ELSE
        CTM(1:36) = 'NGGETC - Parameter name not known - '
        CTM(37:38) = CNP(1:2)
        CALL SETER (CTM(1:38), 5, 1)
        GO TO 110
      ENDIF
C
  110 CONTINUE
      RETURN
      END

C
C $Id: mdgetc.f,v 1.10 2008-09-18 00:42:17 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MDGETC (WHCH,CVAL)
C
        CHARACTER*(*) WHCH
        CHARACTER*(*) CVAL
C
C Declare required common blocks.  See MAPBDX for descriptions of these
C common blocks and the variables in them.
C
        COMMON /MAPCM3/  ITPN,NOUT,NPTS,IGID,IDLS,IDRS,BLAG,SLAG,BLOG,
     +                   SLOG,PNTS(200),IDOS(4)
        INTEGER          ITPN,NOUT,NPTS,IGID,IDLS,IDRS,IDOS
        REAL             BLAG,SLAG,BLOG,SLOG,PNTS
        SAVE   /MAPCM3/
C
        COMMON /MAPCM4/  GRDR,GRID,GRLA,GRLO,GRPO,OTOL,PDRE,PLA1,PLA2,
     +                   PLA3,PLA4,PLB1,PLB2,PLB3,PLB4,PLNO,PLTO,ROTA,
     +                   SRCH,XLOW,XROW,YBOW,YTOW,IDOT,IDSH,IDTL,ILCW,
     +                   ILTS,JPRJ,ELPF,INTF,LBLF,PRMF
        DOUBLE PRECISION GRDR,GRID,GRLA,GRLO,GRPO,OTOL,PDRE,PLA1,PLA2,
     +                   PLA3,PLA4,PLB1,PLB2,PLB3,PLB4,PLNO,PLTO,ROTA,
     +                   SRCH,XLOW,XROW,YBOW,YTOW
        INTEGER          IDOT,IDSH,IDTL,ILCW,ILTS,JPRJ
        LOGICAL          ELPF,INTF,LBLF,PRMF
        SAVE   /MAPCM4/
C
        COMMON /MAPCM5/  DDCT(5),DDCL(5),LDCT(6),LDCL(6),PDCT(19),
     +                   PDCL(19)
        CHARACTER*2      DDCT,DDCL,LDCT,LDCL,PDCT,PDCL
        SAVE   /MAPCM5/
C
        COMMON /MAPSAT/  ALFA,BETA,DCSA,DCSB,DSNA,DSNB,SALT,SSMO,SRSS
        DOUBLE PRECISION ALFA,BETA,DCSA,DCSB,DSNA,DSNB,SALT,SSMO,SRSS
        SAVE   /MAPSAT/
C
        IF (ICFELL('MDGETC - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
        IF (     WHCH(1:2).EQ.'AR') THEN
          CVAL=LDCT(ILTS)
        ELSE IF (WHCH(1:2).EQ.'OU') THEN
          CVAL=DDCT(NOUT+1)
        ELSE IF (WHCH(1:2).EQ.'PR') THEN
          CVAL=PDCT(JPRJ+1)
          IF (JPRJ.EQ.3.AND.ABS(SALT).GT.1.D0) CVAL=PDCT(17)
        ELSE IF (WHCH(1:2).EQ.'ar') THEN
          CVAL=LDCL(ILTS)
        ELSE IF (WHCH(1:2).EQ.'ou') THEN
          CVAL=DDCL(NOUT+1)
        ELSE IF (WHCH(1:2).EQ.'pr') THEN
          CVAL=PDCL(JPRJ+1)
          IF (JPRJ.EQ.3.AND.ABS(SALT).GT.1.D0) CVAL=PDCL(17)
        ELSE
          GO TO 901
        END IF
C
C Done.
C
        RETURN
C
C Error exits.
C
  901   CALL MDPCEM ('MDGETC - UNKNOWN PARAMETER NAME ',WHCH,2,1)
        CVAL=' '
        RETURN
C
      END

C
C $Id: mdrgsx.f,v 1.14 2008-09-18 00:42:18 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MDRGSX (ICAT,ICEL,IRIM,ILAT,ILON,IFLL,IRGL,
     +                                         IAMA,LAMA,XCRA,YCRA,MCRA)
C
        INTEGER ICAT,ICEL,IRIM,ILAT,ILON,IFLL,IRGL,IAMA(LAMA),LAMA,MCRA
        REAL XCRA(MCRA),YCRA(MCRA)
C
C This routine, given the file identifiers ICAT, ICEL, and IRIM for a
C particular level of the RANGS/GSHHS data, and the integer latitude and
C longitude ILAT and ILON (-90.LE.ILAT.LE.89 and 0.LE.ILON.LE.359) of
C the lower left-hand corner of a particular 1-degree square, retrieves
C the polygons for that square, checks them against a list of polygons
C that self-intersect, edits them if they do, and then does with them
C what is implied by the value of IFLL.  If IFLL is 0, portions of the
C polygon that do not lie on the edges of the 1-degree square are drawn.
C If IFLL is 1, the polygons are filled directly, without going through
C an area map.  If IFLL is 2, the polygons are drawn using an area map,
C which allows for transparency situations that IFLL=1 does not.  IRGL
C is the level at which the RANGS/GSHHS data is being used, required
C here for the call to MDRGED.  The array IAMA is an area map array.
C The arrays XCRA and YCRA are used to hold the coordinates of points
C defining polygons retrieved from the data arrays.
C
C Declare required common blocks.  See MAPBDX for descriptions of these
C common blocks and the variables in them.
C
        COMMON /MAPRGD/  ICOL(5),ICSF(5),IDPF,LCRA,NILN,NILT,OLAT,OLON
        INTEGER          ICOL,ICSF,IDPF,LCRA,NILN,NILT
        REAL             OLAT,OLON
        SAVE   /MAPRGD/
C
C Declare the routine that will fill the areas.
C
        EXTERNAL         MDRGFA
C
C Declare local variables.
C
        INTEGER          I,IAAI(1),IAGI(1),ICWP,IFLG,ILEV,IPGB,IPID,
     +                   IPOS,ISGB,ISTA,ITML,ITMP,ITYP,LNLG,NCRA,NPTS,
     +                   ISHIFT
C
        REAL             XVPL,XVPR,YVPB,YVPT,XWDL,XWDR,YWDB,YWDT
C
        DOUBLE PRECISION PLAT,PLON,QLAT,QLON,RLAT,RLON
C
C CTM4 and CTM1 are character temporaries into which we can read a group
C of four bytes or a single byte, respectively.  (Because the data are
C written in a byte-swapped fashion, we cannot read a four-byte quantity
C as if it were an integer; instead, we must read the four bytes and put
C the integer together.)
C
        CHARACTER*4 CTM4
        CHARACTER*1 CTM1
C
C Define an amended version of the FORTRAN function ICHAR that will work
C on machines like the IBM, which sign-extend eight-bit characters.
C
        CHARACTER*1 CARG
C
        ICHARF(CARG)=MOD(ICHAR(CARG)+256,256)
C
C Copy the specified values of ILAT and ILON to real variables in a
C common block to be passed to the area-fill routine MDRGFA.
C
        OLAT=REAL(ILAT)
        OLON=REAL(ILON)
C
C Copy the value of MCRA to an integer variable in a common block to
C be passed to the routine MDRGIP.
C
        LCRA=MCRA
C
C Initialize the area map.
C
        IF (IFLL.GE.2) CALL ARINAM (IAMA,LAMA)
C
C Save the current SET state and re-do it in a manner allowing for the
C mapping of lat/lon points from the chosen 1-degree square to the whole
C plotter frame.
C
        CALL GETSET (XVPL,XVPR,YVPB,YVPT,XWDL,XWDR,YWDB,YWDT,LNLG)
        CALL SET    (0.,1.,0.,1.,0.,1.,0.,1.,1)
C
C Zero the polygon-level counter and the count of polygon points saved.
C
        ILEV=0
        NCRA=0
C
C Look in the catalog for a pointer to the definition of the desired
C 1-degree square in the cell file.
C
        CALL NGSEEK (ICAT,4*((89-ILAT)*360+ILON),0,ISTA)
C
        IF (ISTA.LT.0) THEN
          CALL SETER ('MDRGSX - SEEK FAILURE IN CAT FILE',1,1)
          RETURN
        END IF
C
        CALL NGRDCH (ICAT,CTM4,4,ISTA)
C
        IF (ISTA.NE.4) THEN
          CALL SETER ('MDRGSX - READ FAILURE IN CAT FILE',2,1)
          RETURN
        END IF
C
        IPOS=IOR(ISHIFT(IOR(ISHIFT(IOR(ISHIFT(ICHARF(CTM4(4:4)),8),
     +                                        ICHARF(CTM4(3:3))),8),
     +                                        ICHARF(CTM4(2:2))),8),
     +                                        ICHARF(CTM4(1:1)))-1
C
C Position the cell file to the start of the definition.
C
        CALL NGSEEK (ICEL,IPOS,0,ISTA)
C
        IF (ISTA.LT.0) THEN
          CALL SETER ('MDRGSX - SEEK FAILURE IN CEL FILE',3,1)
          RETURN
        END IF
C
C Read a new polygon byte.
C
  101   CALL NGRDCH (ICEL,CTM1,1,ISTA)
C
        IF (ISTA.NE.1) THEN
          CALL SETER ('MDRGSX - READ FAILURE IN CEL FILE',4,1)
          RETURN
        END IF
C
        IPGB = ICHARF(CTM1)
C
C If the polygon byte is non-zero, we are at the start of a new polygon.
C
        IF (IPGB.NE.0) THEN
C
C Bump the value of ILEV by one.  This is done because the definition
C of a polygon is recursive; it can itself include one or more interior
C polygons that form holes in it.  Each polygon begins with a non-zero
C polygon byte and ends with a zero polygon byte; if, when we read for
C a polygon byte, we get a non-zero value, we know that a new level of
C recursion is beginning.
C
          ILEV=ILEV+1
C
C Read the polygon ID.
C
          CALL NGRDCH (ICEL,CTM4,4,ISTA)
C
          IF (ISTA.NE.4) THEN
            CALL SETER ('MDRGSX - READ FAILURE IN CEL FILE',5,1)
            RETURN
          END IF
C
          IPID=IOR(ISHIFT(IOR(ISHIFT(IOR(ISHIFT(ICHARF(CTM4(4:4)),8),
     +                                          ICHARF(CTM4(3:3))),8),
     +                                          ICHARF(CTM4(2:2))),8),
     +                                          ICHARF(CTM4(1:1)))
C
C Zero IFLG.  It gets set non-zero when we have found the first point
C of the polygon, positive if that point is on the edge of the 1-degree
C cell, negative if otherwise.
C
          IFLG=0
C
C Zero ITMP.  This is done because we save the previous value of ITMP
C in ITML; it prevents ITML from getting a garbage value.
C
          ITMP=0
C
C Read a new segment byte.
C
  102     CALL NGRDCH (ICEL,CTM1,1,ISTA)
C
          IF (ISTA.NE.1) THEN
            CALL SETER ('MDRGSX - READ FAILURE IN CEL FILE',6,1)
            RETURN
          END IF
C
          ISGB = ICHARF(CTM1)
C
C The low-order three bits of the segment byte tell us what follows.
C Pull them off into ITMP, saving the previous value as ITML.
C
          ITML=ITMP
          ITMP=IAND(ISGB,7)
C
C If ITMP is non-zero, extract a three-bit integer that tells us the
C type of the polygon we're working on (0 => ocean, 1 => land, 2 =>
C lake, 3 => island in lake, 4 => pond on island) and a one-bit integer
C that says whether it is defined in a clockwise or counterclockwise
C direction.
C
          IF (ITMP.NE.0) THEN
            ITYP=IAND(ISHIFT(ISGB,-4),7)
            ICWP=IAND(ISHIFT(ISGB,-3),1)
          END IF
C
C If ITMP is between 1 and 6, inclusive, it specifies a number of
C points defined by values read from the cell file; each point is
C defined by two 4-byte integers, the first a longitude and the
C second a latitude, in units of millionths of a degree.  All of these
C points are on the edge of the 1-degree cell.
C
          IF (ITMP.GE.1.AND.ITMP.LE.6) THEN
C
            NPTS = ITMP
C
C Loop to read the points.
C
            DO 105 I=1,NPTS
C
C Read a longitude.
C
              CALL NGRDCH (ICEL,CTM4,4,ISTA)
C
              IF (ISTA.NE.4) THEN
                CALL SETER ('MDRGSX - READ FAILURE IN CEL FILE',7,1)
                RETURN
              END IF
C
              QLON=RLON
C
              RLON=.000001D0*DBLE(IOR(ISHIFT(IOR(ISHIFT(
     +                       IOR(ISHIFT(ICHARF(CTM4(4:4)),8),
     +                                  ICHARF(CTM4(3:3))),8),
     +                                  ICHARF(CTM4(2:2))),8),
     +                                  ICHARF(CTM4(1:1)))-1000000*ILON)
C
C Read a latitude.
C
              CALL NGRDCH (ICEL,CTM4,4,ISTA)
C
              IF (ISTA.NE.4) THEN
                CALL SETER ('MDRGSX - READ FAILURE IN CEL FILE',8,1)
                RETURN
              END IF
C
              QLAT=RLAT
C
              RLAT=.000001D0*DBLE(IOR(ISHIFT(IOR(ISHIFT(
     +                       IOR(ISHIFT(ICHARF(CTM4(4:4)),8),
     +                                  ICHARF(CTM4(3:3))),8),
     +                                  ICHARF(CTM4(2:2))),8),
     +                                  ICHARF(CTM4(1:1)))-1000000*ILAT)
C
C If we had not yet seen the first point of the polygon (that is to
C say, if IFLG is zero), this is it; save its longitude and latitude
C and set IFLG to say that the first point was on the cell boundary.
C
              IF (IFLG.EQ.0) THEN
                PLON=RLON
                PLAT=RLAT
                IFLG=+1
              END IF
C
C Insert the point in the list.
C
              IF (NCRA+1.LT.MCRA) THEN
                NCRA=NCRA+1
                XCRA(NCRA)=REAL(RLON)
                YCRA(NCRA)=REAL(RLAT)
                IF (NCRA.GT.1) THEN
                  IF (XCRA(NCRA).EQ.XCRA(NCRA-1).AND.
     +                YCRA(NCRA).EQ.YCRA(NCRA-1)) NCRA=NCRA-1
                END IF
              ELSE
                CALL SETER ('MDRGSX - COORDINATE BUFFER OVERFLOW',9,1)
                RETURN
              END IF
C
  105       CONTINUE
C
C Go back to read another segment byte.
C
            GO TO 102
C
C If ITMP is a 7, then the next two values in the cell file are 4-byte
C integers, the first of which is a pointer into the rim file and the
C second of which is the number of points to be read from the rim file.
C Each point in the rim file is defined like a point in the cell file,
C by a pair of 4-byte integers, specifying longitude and latitude, in
C millionths of a degree.  All of the points in the rim file are in
C the interior of the 1-degree cell.
C
          ELSE IF (ITMP.EQ.7) THEN
C
C Get the pointer into the rim file.
C
            CALL NGRDCH (ICEL,CTM4,4,ISTA)
C
            IF (ISTA.NE.4) THEN
              CALL SETER ('MDRGSX - READ FAILURE IN CEL FILE',10,1)
              RETURN
            END IF
C
            IPOS=IOR(ISHIFT(IOR(ISHIFT(IOR(ISHIFT(ICHARF(CTM4(4:4)),8),
     +                                            ICHARF(CTM4(3:3))),8),
     +                                            ICHARF(CTM4(2:2))),8),
     +                                            ICHARF(CTM4(1:1)))-1
C
C Get the number of points to be read from the rim file.
C
            CALL NGRDCH (ICEL,CTM4,4,ISTA)
C
            IF (ISTA.NE.4) THEN
              CALL SETER ('MDRGSX - READ FAILURE IN CEL FILE',11,1)
              RETURN
            END IF
C
            NPTS=IOR(ISHIFT(IOR(ISHIFT(IOR(ISHIFT(ICHARF(CTM4(4:4)),8),
     +                                            ICHARF(CTM4(3:3))),8),
     +                                            ICHARF(CTM4(2:2))),8),
     +                                            ICHARF(CTM4(1:1)))
C
C If the number of points to be read is non-zero (for some reason, it
C *can* happen that the number is zero), read the points.
C
            IF (NPTS.NE.0) THEN
C
C Position to the start of the list of points in the rim file.
C
              CALL NGSEEK (IRIM,IPOS,0,ISTA)
C
              IF (ISTA.LT.0) THEN
                CALL SETER ('MDRGSX - SEEK FAILURE IN RIM FILE',12,1)
                RETURN
              END IF
C
C Loop to read the points.
C
              DO 106 I=1,NPTS
C
C Read a longitude.
C
                CALL NGRDCH (IRIM,CTM4,4,ISTA)
C
                IF (ISTA.NE.4) THEN
                  CALL SETER ('MDRGSX - READ FAILURE IN RIM FILE',13,1)
                  RETURN
                END IF
C
                QLON=RLON
C
                RLON=.000001D0*DBLE(IOR(ISHIFT(IOR(ISHIFT(
     +                       IOR(ISHIFT(ICHARF(CTM4(4:4)),8),
     +                                  ICHARF(CTM4(3:3))),8),
     +                                  ICHARF(CTM4(2:2))),8),
     +                                  ICHARF(CTM4(1:1)))-1000000*ILON)
C
C Read a latitude.
C
                CALL NGRDCH (IRIM,CTM4,4,ISTA)
C
                IF (ISTA.NE.4) THEN
                  CALL SETER ('MDRGSX - READ FAILURE IN RIM FILE',14,1)
                  RETURN
                END IF
C
                QLAT=RLAT
C
                RLAT=.000001D0*DBLE(IOR(ISHIFT(IOR(ISHIFT(
     +                       IOR(ISHIFT(ICHARF(CTM4(4:4)),8),
     +                                  ICHARF(CTM4(3:3))),8),
     +                                  ICHARF(CTM4(2:2))),8),
     +                                  ICHARF(CTM4(1:1)))-1000000*ILAT)
C
C If we had not yet seen the first point of the polygon (that is to
C say, if IFLG is zero), this is it; save its longitude and latitude
C and set IFLG to say that the first point was not on the cell boundary.
C
                IF (IFLG.EQ.0) THEN
                  PLON=RLON
                  PLAT=RLAT
                  IFLG=-1
                END IF
C
C Since all of these points are interior points, we just add their
C coordinates to the point-coordinate buffers.
C
                IF (NCRA+1.LT.MCRA) THEN
                  NCRA=NCRA+1
                  XCRA(NCRA)=REAL(RLON)
                  YCRA(NCRA)=REAL(RLAT)
                  IF (NCRA.GT.1) THEN
                    IF (XCRA(NCRA).EQ.XCRA(NCRA-1).AND.
     +                  YCRA(NCRA).EQ.YCRA(NCRA-1)) NCRA=NCRA-1
                  END IF
                ELSE
                  CALL SETER
     +                      ('MDRGSX - COORDINATE BUFFER OVERFLOW',15,1)
                  RETURN
                END IF
C
  106         CONTINUE
C
            END IF
C
C Go back to read another segment byte.
C
            GO TO 102
C
          END IF
C
C If ITMP is zero, we've reached the end of the polygon.  We must supply
C a closure point (the first point of the polygon) and then fill the
C polygon.  Output the fill area.  First, see if at least one point is
C defined in the buffers.
C
          IF (NCRA.GT.1) THEN
C
C Add the coordinates of the closure point to the buffers, edit the
C polygon, and take the desired action (draw portions of it that lie
C in the interior of the unit square, fill it directly, or send it to
C an area map).  The statement beginning "IF (ILAT.GE.55 ... " is
C necessary to fix an error in the GSHHS/RANGS database.
C
            IF (XCRA(NCRA).NE.REAL(PLON).OR.
     +          YCRA(NCRA).NE.REAL(PLAT)) THEN
              NCRA=NCRA+1
              XCRA(NCRA)=REAL(PLON)
              YCRA(NCRA)=REAL(PLAT)
              IF (NCRA.GT.1) THEN
                IF (XCRA(NCRA).EQ.XCRA(NCRA-1).AND.
     +              YCRA(NCRA).EQ.YCRA(NCRA-1)) NCRA=NCRA-1
              END IF
            END IF
C
            IF (NCRA.GT.1) THEN
              IF (ILAT.GE.55.AND.ILAT.LE.57.AND.ILON.EQ.82.AND.
     +                                                 ITYP.EQ.2) ITYP=1
              CALL MDRGED (IRGL,IPID,ILAT,ILON,ICWP,XCRA,YCRA,NCRA,MCRA)
              IF (IFLL.EQ.0) THEN
                CALL SET (XVPL,XVPR,YVPB,YVPT,XWDL,XWDR,YWDB,YWDT,LNLG)
                CALL MDRGDR (XCRA,YCRA,NCRA,ITYP+1)
                CALL SET    (0.,1.,0.,1.,0.,1.,0.,1.,1)
              ELSE IF (IFLL.EQ.1) THEN
                CALL MDRGIP (XCRA,YCRA,NCRA)
                CALL SET (XVPL,XVPR,YVPB,YVPT,XWDL,XWDR,YWDB,YWDT,LNLG)
                CALL MDRGFP (XCRA,YCRA,NCRA,ITYP+1)
                CALL SET    (0.,1.,0.,1.,0.,1.,0.,1.,1)
              ELSE
                IF (ICWP.NE.0) THEN
                  CALL MDRGAM (IAMA,XCRA,YCRA,NCRA,1,ITYP+1,ITYP)
                ELSE
                  CALL MDRGAM (IAMA,XCRA,YCRA,NCRA,1,ITYP,ITYP+1)
                END IF
              END IF
            END IF
C
          END IF
C
C Zero the count of coordinates in the point-coordinate buffer.
C
          NCRA=0
C
C Go back to read another polygon byte.
C
          GO TO 101
C
C If the polygon byte is zero, it says that we've hit the end of a
C polygon.
C
        ELSE
C
C Reduce the recursion counter by one and, if it's still non-zero, go
C back to read another polygon byte.
C
          ILEV=ILEV-1
          IF (ILEV.NE.0) GO TO 101
C
        END IF
C
C Scan the area map, retrieving polygons from it, mapping them as
C directed by the current state of EZMAP, and filling them.
C
        IF (IFLL.GE.2) THEN
          CALL ARGETI ('RC(1)',IRC1)
          CALL ARSETI ('RC(1)',0)
          CALL ARSCAM (IAMA,XCRA,YCRA,MCRA,IAAI,IAGI,1,MDRGFA)
          CALL ARSETI ('RC(1)',IRC1)
        END IF
C
C Restore the original SET state.
C
        CALL SET (XVPL,XVPR,YVPB,YVPT,XWDL,XWDR,YWDB,YWDT,LNLG)
C
C Normal return.
C
        RETURN
C
      END

C
C	$Id: cstrlist.f,v 1.5 2008-07-27 03:10:08 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CSTRLIST (N,LIST,LPTR,LEND,NROW, NT,LTRI,IER)
      INTEGER N, LIST(*), LPTR(*), LEND(N), NROW, NT,
     .        LTRI(NROW,*), IER
C
C***********************************************************
C
C                                              From STRIPACK
C                                            Robert J. Renka
C                                  Dept. of Computer Science
C                                       Univ. of North Texas
C                                           renka@cs.unt.edu
C                                                   07/20/96
C
C   This subroutine converts a triangulation data structure
C from the linked list created by Subroutine CSTRMESH to a
C triangle list.
C
C On input:
C
C       N = Number of nodes in the triangulation.  N .GE. 3.
C
C       LIST,LPTR,LEND = Linked list data structure defin-
C                        ing the triangulation.  Refer to
C                        Subroutine CSTRMESH.
C
C       NROW = Number of rows (entries per triangle) re-
C              served for the triangle list LTRI.  The value
C              must be 6 if only the vertex indexes and
C              neighboring triangle indexes are to be
C              stored, or 9 if arc indexes are also to be
C              assigned and stored.  Refer to LTRI.
C
C The above parameters are not altered by this routine.
C
C       LTRI = Integer array of length at least NROW*NT,
C              where NT is at most 2N-4.  (A sufficient
C              length is 12N if NROW=6 or 18N if NROW=9.)
C
C On output:
C
C       NT = Number of triangles in the triangulation unless
C            IER .NE. 0, in which case NT = 0.  NT = 2N-NB-2
C            if NB .GE. 3 or 2N-4 if NB = 0, where NB is the
C            number of boundary nodes.
C
C       LTRI = NROW by NT array whose J-th column contains
C              the vertex nodal indexes (first three rows),
C              neighboring triangle indexes (second three
C              rows), and, if NROW = 9, arc indexes (last
C              three rows) associated with triangle J for
C              J = 1,...,NT.  The vertices are ordered
C              counterclockwise with the first vertex taken
C              to be the one with smallest index.  Thus,
C              LTRI(2,J) and LTRI(3,J) are larger than
C              LTRI(1,J) and index adjacent neighbors of
C              node LTRI(1,J).  For I = 1,2,3, LTRI(I+3,J)
C              and LTRI(I+6,J) index the triangle and arc,
C              respectively, which are opposite (not shared
C              by) node LTRI(I,J), with LTRI(I+3,J) = 0 if
C              LTRI(I+6,J) indexes a boundary arc.  Vertex
C              indexes range from 1 to N, triangle indexes
C              from 0 to NT, and, if included, arc indexes
C              from 1 to NA, where NA = 3N-NB-3 if NB .GE. 3
C              or 3N-6 if NB = 0.  The triangles are or-
C              dered on first (smallest) vertex indexes.
C
C       IER = Error indicator.
C             IER = 0 if no errors were encountered.
C             IER = 1 if N or NROW is outside its valid
C                     range on input.
C             IER = 2 if the triangulation data structure
C                     (LIST,LPTR,LEND) is invalid.  Note,
C                     however, that these arrays are not
C                     completely tested for validity.
C
C Modules required by CSTRLIST:  None
C
C Intrinsic function called by CSTRLIST:  ABS
C
C***********************************************************
C
      INTEGER I, I1, I2, I3, ISV, J, KA, KN, KT, LP, LP2,
     .        LPL, LPLN1, N1, N2, N3, NM2
      LOGICAL ARCS
C
C Local parameters:
C
C ARCS =     Logical variable with value TRUE iff are
C              indexes are to be stored
C I,J =      LTRI row indexes (1 to 3) associated with
C              triangles KT and KN, respectively
C I1,I2,I3 = Nodal indexes of triangle KN
C ISV =      Variable used to permute indexes I1,I2,I3
C KA =       Arc index and number of currently stored arcs
C KN =       Index of the triangle that shares arc I1-I2
C              with KT
C KT =       Triangle index and number of currently stored
C              triangles
C LP =       LIST pointer
C LP2 =      Pointer to N2 as a neighbor of N1
C LPL =      Pointer to the last neighbor of I1
C LPLN1 =    Pointer to the last neighbor of N1
C N1,N2,N3 = Nodal indexes of triangle KT
C NM2 =      N-2
C
C
C Test for invalid input parameters.
C
      IF (N .LT. 3  .OR.  (NROW .NE. 6  .AND.  NROW .NE. 9))
     .  GO TO 11
C
C Initialize parameters for loop on triangles KT = (N1,N2,
C   N3), where N1 < N2 and N1 < N3.
C
C   ARCS = TRUE iff arc indexes are to be stored.
C   KA,KT = Numbers of currently stored arcs and triangles.
C   NM2 = Upper bound on candidates for N1.
C
      ARCS = NROW .EQ. 9
      KA = 0
      KT = 0
      NM2 = N-2
C
C Loop on nodes N1.
C
      DO 9 N1 = 1,NM2
C
C Loop on pairs of adjacent neighbors (N2,N3).  LPLN1 points
C   to the last neighbor of N1, and LP2 points to N2.
C
        LPLN1 = LEND(N1)
        LP2 = LPLN1
    1     LP2 = LPTR(LP2)
          N2 = LIST(LP2)
          LP = LPTR(LP2)
          N3 = ABS(LIST(LP))
          IF (N2 .LT. N1  .OR.  N3 .LT. N1) GO TO 8
C
C Add a new triangle KT = (N1,N2,N3).
C
          KT = KT + 1
          LTRI(1,KT) = N1
          LTRI(2,KT) = N2
          LTRI(3,KT) = N3
C
C Loop on triangle sides (I2,I1) with neighboring triangles
C   KN = (I1,I2,I3).
C
          DO 7 I = 1,3
            IF (I .EQ. 1) THEN
              I1 = N3
              I2 = N2
            ELSEIF (I .EQ. 2) THEN
              I1 = N1
              I2 = N3
            ELSE
              I1 = N2
              I2 = N1
            ENDIF
C
C Set I3 to the neighbor of I1 that follows I2 unless
C   I2->I1 is a boundary arc.
C
            LPL = LEND(I1)
            LP = LPTR(LPL)
    2       IF (LIST(LP) .EQ. I2) GO TO 3
              LP = LPTR(LP)
              IF (LP .NE. LPL) GO TO 2
C
C   I2 is the last neighbor of I1 unless the data structure
C     is invalid.  Bypass the search for a neighboring
C     triangle if I2->I1 is a boundary arc.
C
            IF (ABS(LIST(LP)) .NE. I2) GO TO 12
            KN = 0
            IF (LIST(LP) .LT. 0) GO TO 6
C
C   I2->I1 is not a boundary arc, and LP points to I2 as
C     a neighbor of I1.
C
    3       LP = LPTR(LP)
            I3 = ABS(LIST(LP))
C
C Find J such that LTRI(J,KN) = I3 (not used if KN > KT),
C   and permute the vertex indexes of KN so that I1 is
C   smallest.
C
            IF (I1 .LT. I2  .AND.  I1 .LT. I3) THEN
              J = 3
            ELSEIF (I2 .LT. I3) THEN
              J = 2
              ISV = I1
              I1 = I2
              I2 = I3
              I3 = ISV
            ELSE
              J = 1
              ISV = I1
              I1 = I3
              I3 = I2
              I2 = ISV
            ENDIF
C
C Test for KN > KT (triangle index not yet assigned).
C
            IF (I1 .GT. N1) GO TO 7
C
C Find KN, if it exists, by searching the triangle list in
C   reverse order.
C
            DO 4 KN = KT-1,1,-1
              IF (LTRI(1,KN) .EQ. I1  .AND.  LTRI(2,KN) .EQ.
     .            I2  .AND.  LTRI(3,KN) .EQ. I3) GO TO 5
    4         CONTINUE
            GO TO 7
C
C Store KT as a neighbor of KN.
C
    5       LTRI(J+3,KN) = KT
C
C Store KN as a neighbor of KT, and add a new arc KA.
C
    6       LTRI(I+3,KT) = KN
            IF (ARCS) THEN
              KA = KA + 1
              LTRI(I+6,KT) = KA
              IF (KN .NE. 0) LTRI(J+6,KN) = KA
            ENDIF
    7       CONTINUE
C
C Bottom of loop on triangles.
C
    8     IF (LP2 .NE. LPLN1) GO TO 1
    9     CONTINUE
C
C No errors encountered.
C
      NT = KT
      IER = 0
      RETURN
C
C Invalid input parameter.
C
   11 NT = 0
      IER = 1
      RETURN
C
C Invalid triangulation data structure:  I1 is a neighbor of
C   I2, but I2 is not a neighbor of I1.
C
   12 NT = 0
      IER = 2
      RETURN
      END

C
C	$Id: gputpr.f,v 1.6 2008-07-27 00:21:06 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GPUTPR (BUFFER,BITS,COUNT,GKSERR)
C
C  Put the operand string into the metafile buffer.
C
C  INPUT
C    BUFFER -- List of operands to move.
C    BITS   -- Precision of the operands.
C    COUNT  -- Number of operands in the buffer.
C
C  OUTPUT
C    GKSERR -- Error status.
C
C  All data is type integer unless otherwise indicated.
C
      IMPLICIT INTEGER (A-Z)
      DIMENSION BUFFER(*)
C
      include 'g01prm.h'
      include 'g01ins.h'
C
      DATA ALLOK /0/
C
      CTEMP = COUNT
      STRT = 1
C
   10 CONTINUE
C
C  Determine the number of operand words left in the current partition.
C
      WCBYT = (MCCBYT*8)/BITS
C
C  Compute and move the allowed number of operands.
C
      MOVIT = MIN(WCBYT,CTEMP)
      CALL GMFLOD(BUFFER(STRT),BITS,MOVIT,GKSERR)
      IF (GKSERR .NE. ALLOK) RETURN
C
C  Check if another partition has to be started.
C
      CTEMP = CTEMP - MOVIT
      MCCBYT = MCCBYT - (MOVIT*BITS)/8
      IF (CTEMP .NE. 0) THEN
C
C  New partition required, so set up the element.
C
        STRT = STRT + MOVIT
C
C  Take the remainder of bytes left in current partition 
C  (they must be used).
C
        TCBYT = MCNBYT + MCCBYT
        CALL GMPART(TCBYT,GKSERR)
        IF (GKSERR .NE. ALLOK) RETURN
C
C  Move more operands into new partition.
C
        GO TO 10
      END IF
C
      RETURN
      END

C
C	$Id: cutup.f,v 1.6 2008-07-27 00:23:03 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CUTUP (MX1,MY1,MX2,MY2)
C
C THE CONNECTION LINES BETWEEN POINTS PROCESSED WITH DASHSUPR ARE
C SMOOTHED AND THEREFORE MOST LINE SEGMENTS WILL BE VERY SHORT.
C IN CASE ONLY 2 POINTS ARE BEING PROCESSED NO SMOOTHING WILL BE DONE
C AND VERY LONG LINE SEGMENTS CAN OCCUR.
C SUCH LONG LINES ARE DIVIDED UP INTO SHORT SEGMENTS IN THE ROUTINE
C CUTUP, BECAUSE THE ALGORITHM FOR THE REMOVAL OF CROWDED LINES RELIES
C ON SHORT LINE SEGMENTS.
C
      COMMON/INTPR/IPAU,FPART,TENSN,NP,SMALL,L1,ADDLR,ADDTB,MLLINE,
     1    ICLOSE
      SAVE
C
C FOR BETTER ACCURACY CHOOSE LONGER COORDINATE AS BASIS FOR ITERATION.
C
      DX = MX2-MX1
      DY = MY2-MY1
      IF (ABS(DX)-ABS(DY)) 60,50,10
C
C DX IS LONGER THAN DY.
C
   10 SLOPE = DY/DX
      IF (DX .LT. 0.) GO TO 30
C
      CALL CFVLD (1,MX1,MY1)
      DO 20 MX=MX1,MX2,MLLINE
         MY = INT(REAL(MY1)+REAL(MX-MX1)*SLOPE+.5)
         CALL CFVLD (2,MX,MY)
   20 CONTINUE
      CALL CFVLD (1,MX2,MY2)
      GOTO 100
C
   30 CONTINUE
      CALL CFVLD (1,MX2,MY2)
      DO 40 MX=MX2,MX1,MLLINE
         MY = INT(REAL(MY2)+REAL(MX-MX2)*SLOPE+.5)
         CALL CFVLD (2,MX,MY)
   40 CONTINUE
      CALL CFVLD (2,MX1,MY1)
      GOTO 100
C
C DX AND DY HAVE SAME LENGTH.
C
   50 IF (DX .NE. 0.) GO TO 10
      CALL CFVLD (2,MX2,MY2)
      RETURN
C
C DY IS LONGER THAN DX.
C
   60 SLOPE = DX/DY
      IF (DY .LT. 0.) GO TO 80
C
      CALL CFVLD (1,MX1,MY1)
      DO 70 MY=MY1,MY2,MLLINE
         MX = INT(REAL(MX1)+REAL(MY-MY1)*SLOPE+.5)
         CALL CFVLD (2,MX,MY)
   70 CONTINUE
      CALL CFVLD (2,MX2,MY2)
      GOTO 100
C
   80 CONTINUE
C
      CALL CFVLD (1,MX2,MY2)
      DO 90 MY=MY2,MY1,MLLINE
         MX = INT(REAL(MX2)+REAL(MY-MY2)*SLOPE+.5)
         CALL CFVLD (2,MX,MY)
   90 CONTINUE
      CALL CFVLD (2,MX1,MY1)
C
  100 CONTINUE
C
      RETURN
      END

      SUBROUTINE STRTI2( UPLO, DIAG, N, A, LDA, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     February 29, 1992
*
*     .. Scalar Arguments ..
      CHARACTER          DIAG, UPLO
      INTEGER            INFO, LDA, N
*     ..
*     .. Array Arguments ..
      REAL               A( LDA, * )
*     ..
*
*  Purpose
*  =======
*
*  STRTI2 computes the inverse of a real upper or lower triangular
*  matrix.
*
*  This is the Level 2 BLAS version of the algorithm.
*
*  Arguments
*  =========
*
*  UPLO    (input) CHARACTER*1
*          Specifies whether the matrix A is upper or lower triangular.
*          = 'U':  Upper triangular
*          = 'L':  Lower triangular
*
*  DIAG    (input) CHARACTER*1
*          Specifies whether or not the matrix A is unit triangular.
*          = 'N':  Non-unit triangular
*          = 'U':  Unit triangular
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  A       (input/output) REAL array, dimension (LDA,N)
*          On entry, the triangular matrix A.  If UPLO = 'U', the
*          leading n by n upper triangular part of the array A contains
*          the upper triangular matrix, and the strictly lower
*          triangular part of A is not referenced.  If UPLO = 'L', the
*          leading n by n lower triangular part of the array A contains
*          the lower triangular matrix, and the strictly upper
*          triangular part of A is not referenced.  If DIAG = 'U', the
*          diagonal elements of A are also not referenced and are
*          assumed to be 1.
*
*          On exit, the (triangular) inverse of the original matrix, in
*          the same storage format.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(1,N).
*
*  INFO    (output) INTEGER
*          = 0: successful exit
*          < 0: if INFO = -k, the k-th argument had an illegal value
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ONE
      PARAMETER          ( ONE = 1.0E+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            NOUNIT, UPPER
      INTEGER            J
      REAL               AJJ
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           SSCAL, STRMV, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      UPPER = LSAME( UPLO, 'U' )
      NOUNIT = LSAME( DIAG, 'N' )
      IF( .NOT.UPPER .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = -1
      ELSE IF( .NOT.NOUNIT .AND. .NOT.LSAME( DIAG, 'U' ) ) THEN
         INFO = -2
      ELSE IF( N.LT.0 ) THEN
         INFO = -3
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -5
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'STRTI2', -INFO )
         RETURN
      END IF
*
      IF( UPPER ) THEN
*
*        Compute inverse of upper triangular matrix.
*
         DO 10 J = 1, N
            IF( NOUNIT ) THEN
               A( J, J ) = ONE / A( J, J )
               AJJ = -A( J, J )
            ELSE
               AJJ = -ONE
            END IF
*
*           Compute elements 1:j-1 of j-th column.
*
            CALL STRMV( 'Upper', 'No transpose', DIAG, J-1, A, LDA,
     $                  A( 1, J ), 1 )
            CALL SSCAL( J-1, AJJ, A( 1, J ), 1 )
   10    CONTINUE
      ELSE
*
*        Compute inverse of lower triangular matrix.
*
         DO 20 J = N, 1, -1
            IF( NOUNIT ) THEN
               A( J, J ) = ONE / A( J, J )
               AJJ = -A( J, J )
            ELSE
               AJJ = -ONE
            END IF
            IF( J.LT.N ) THEN
*
*              Compute elements j+1:n of j-th column.
*
               CALL STRMV( 'Lower', 'No transpose', DIAG, N-J,
     $                     A( J+1, J+1 ), LDA, A( J+1, J ), 1 )
               CALL SSCAL( N-J, AJJ, A( J+1, J ), 1 )
            END IF
   20    CONTINUE
      END IF
*
      RETURN
*
*     End of STRTI2
*
      END

C
C	$Id: gupasf.f,v 1.7 2008-07-27 00:21:06 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
        SUBROUTINE GUPASF
C
C  Update aspect source flag context.
C
      include 'gksin.h'
      include 'g01rqa.h'
      include 'g01ast.h'
      include 'g01adc.h'
C
      INTEGER  I
C
C  Compute change flags for each GKS ASF;  compute aggregate.
C  The CGM values for ASFs are reversed from those in GKS, so
C  we perform that complement here.
C
      ANYASF = .FALSE.
      DO 435 I=1,NGKASF
        MRASF(I) = 1-ID(I)
        ASFCHG(I) = MRASF(I).NE.MSASF(I)
        ANYASF = ANYASF .OR. ASFCHG(I)
  435 CONTINUE
C
C  Compute polyline aggregrate variable.
C  (Note that the logic relies on ASF pointers being a 
C   contiguous sequence).       
C
      DO 436 I=IALTYP,IAPLCI
        AGPEND(1) = AGPEND(1) .OR. ASFCHG(I)
  436 CONTINUE
C
C  Compute polymarker aggregrate variables.
C  (Note that the logic relies on ASF pointers being a
C   contiguous sequence).
C
      DO 437 I=IAMTYP,IAPMCI
        AGPEND(2) = AGPEND(2) .OR. ASFCHG(I)
  437 CONTINUE
C
C  Compute text aggregrate variables.
C  (Note that the logic relies on ASF pointers being a
C   contiguous sequence).
C
      DO 438 I=IATXFP,IATXCI
        AGPEND(3) = AGPEND(3) .OR. ASFCHG(I)
  438 CONTINUE
C
C  Compute fill area aggregrate variables.
C  (Note that the logic relies on ASF pointers being a
C   contiguous sequence).
C
      DO 439 I=IAFAIS,IAFACI
        AGPEND(4) = AGPEND(4) .OR. ASFCHG(I)
  439 CONTINUE
C
      RETURN
      END

C
C $Id: mdqtra.f,v 1.6 2008-09-18 00:42:18 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MDQTRA (RLAT,RLON,UVAL,VVAL)
C
        DOUBLE PRECISION RLAT,RLON,UVAL,VVAL
C
C Declare a special common block, containing only those variables that
C MDQINI needs to set to make MDQTRA, MDQTRI, and MDQTRN carry out the
C transformation in effect at the time MDQINI was called.
C
        COMMON /MAQCMN/  ALFA,COSO,COSR,CSLS,CSLT,DCSA,DCSB,DSNA,DSNB,
     +                   DTOR,DTRH,OOPI,PLNO,  PI,PIOT,ROTA,RTDD,RTOD,
     +                   SALT,SINO,SINR,SRSS,SSMO,TOPI,UCNM,UMNM,UMXM,
     +                   UOFF,URNM,VCNM,VMNM,VMXM,VOFF,VRNM,UTPA,IPRF,
     +                   IPRJ,IROD,ELPM
        DOUBLE PRECISION ALFA,COSO,COSR,CSLS,CSLT,DCSA,DCSB,DSNA,DSNB,
     +                   DTOR,DTRH,OOPI,PLNO,  PI,PIOT,ROTA,RTDD,RTOD,
     +                   SALT,SINO,SINR,SRSS,SSMO,TOPI,UCNM,UMNM,UMXM,
     +                   UOFF,URNM,VCNM,VMNM,VMXM,VOFF,VRNM,UTPA(15)
C
        INTEGER IPRF,IPRJ,IROD
C
        LOGICAL ELPM
C
        SAVE   /MAQCMN/
C
C Check for an uncleared prior error.
C
        IF (ICFELL('MDQTRA - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C The call to MDQTRA is simply passed on to MDQTRN, but the values
C returned are checked to see if the point lies outside the perimeter;
C if so, the value 1.D12 is substituted for UVAL.
C
        CALL MDQTRN (RLAT,RLON,UVAL,VVAL)
        IF (ICFELL('MDQTRA',2).NE.0) RETURN
C
        IF (ELPM) THEN
          IF (((UVAL-UCNM)/URNM)**2+
     +        ((VVAL-VCNM)/VRNM)**2.GT.1.000002D0) THEN
            UVAL=1.D12
            VVAL=1.D12
          END IF
        ELSE
          IF (UVAL.LT.UMNM.OR.UVAL.GT.UMXM.OR.
     +        VVAL.LT.VMNM.OR.VVAL.GT.VMXM) THEN
            UVAL=1.D12
            VVAL=1.D12
          END IF
        END IF
C
        RETURN
C
      END

C
C
C       $Id: search.f,v 1.2 1997-05-05 21:45:43 boote Exp $
C
C This subprogram is used by subroutines TERP1 and TERP2 in 
C library ncarm.  It is lower-level, i.e. not called by users.
C **********************************************************
      SUBROUTINE SEARCH (XBAR,X,N,I)
      DIMENSION       X(N)
      SAVE
      DATA B/.69314718/
C
C IF XBAR IS OUTSIDE RANGE OF X TABLE EXTRAPOLATE
C
      IF (XBAR .GT. X(2)) GO TO 101
      I = 1
      RETURN
  101 CONTINUE
      IF (XBAR .LT. X(N-1)) GO TO 102
      I = N-1
      RETURN
  102 CONTINUE
C
C FIND MAXIMUM POWER OF TWO LESS THAN N
C
      M = INT((ALOG(FLOAT(N)))/B)
      I = 2**M
      IF (I .GE. N) I = I/2
      K = I
      NM1 = N-1
C
C CONDUCT BINARY SEARCH.
C
  103 CONTINUE
      K = K/2
      IF (XBAR .GE. X(I)) GO TO 104
      I = I-K
      GO TO 103
  104 CONTINUE
      IF (XBAR .LE. X(I+1)) RETURN
      I = MIN0(I+K,NM1)
      GO TO 103
      END

C
C	$Id: gzw2gk.f,v 1.5 2008-07-27 00:21:04 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GZW2GK(WKID,CONID,IER)
C
C  Copy the segment which has been attached to Fortran unit
C  CONID to the workstation WKID by way of parsing the CGM
C  elements in the segment and making the appropriate GKS
C  calls.
C
      include 'gkscom.h'
C
      INTEGER WKID,CONID
      INTEGER IOS,STATUS
      REAL TWIND(4),TVIEW(4)
C
      include 'trbufr.h'
C
C Do a call forcing a BLOCKDATA to be loaded from a binary library.
C
      CALL GSEGDT
C
C  Use normalization transformation 1 set to the identity (we use 1
C  so that the window can be changed for clipping).
C
      CALL GQCNTN(IER,NTOLD)
      CALL GQNT(NTOLD,IER,TWIND,TVIEW)
      CALL GSWN(1,0.,1.,0.,1.)
      CALL GSVP(1,0.,1.,0.,1.)
      CALL GSELNT(1)
C
C  Read in the first record.
C
      MCONID = CONID
      METREC = 1
      CALL GSEGRD(IOS,STATUS)
      IF (STATUS .NE. 0) THEN
        IER = 302
        RETURN
      ENDIF
C
C  Set the default operand lengths before reading any instructions.
C
      CALL GXOPDF
C
C  Set defaults.
C
      CALL GXMDEF
C
C  Loop until we run out of data, or error.
C
      CALL GXLATE(WKID,IOS,STATUS)
      IF (STATUS .EQ. -1) THEN
C
C  Normal exit, restore normalization transformation.
C
        IF (NTOLD .NE. 0) THEN
          CALL GSWN(NTOLD,TWIND(1),TWIND(2),TWIND(3),TWIND(4))
          CALL GSVP(NTOLD,TVIEW(1),TVIEW(2),TVIEW(3),TVIEW(4))
        ENDIF
        CALL GSELNT(NTOLD)
        IER = 0
      ELSE
        IER = STATUS
      ENDIF
C
      RETURN
      END

c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by UCAR                 .
c  .                                                             .
c  .       University Corporation for Atmospheric Research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                         SPHEREPACK                          .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c
c
c ... file dives.f
c
c     this file includes documentation and code for
c     subroutine dives          i
c
c ... files which must be loaded with dives.f
c
c     sphcom.f, hrfft.f, vhaes.f,shses.f
c
c
c     subroutine dives(nlat,nlon,isym,nt,dv,idv,jdv,br,bi,mdb,ndb,
c    +                 wshses,lshses,work,lwork,ierror)
c
C*PL*ERROR* Comment line too long
c     given the vector spherical harmonic coefficients br and bi, precomputed
c     by subroutine vhaes for a vector field (v,w), subroutine dives
C*PL*ERROR* Comment line too long
c     computes the divergence of the vector field in the scalar array dv.
c     dv(i,j) is the divergence at the colatitude
c
c            theta(i) = (i-1)*pi/(nlat-1)
c
c     and east longitude
c
c            lambda(j) = (j-1)*2*pi/nlon
c
c     on the sphere.  i.e.
c
C*PL*ERROR* Comment line too long
c            dv(i,j) = 1/sint*[ d(sint*v(i,j))/dtheta + d(w(i,j))/dlambda ]
c
c     where sint = sin(theta(i)).  w is the east longitudinal and v
c     is the colatitudinal component of the vector field from which
c     br,bi were precomputed.  required associated legendre polynomials
c     are stored rather than recomputed as they are in subroutine divec.
c
c
c     input parameters
c
c     nlat   the number of colatitudes on the full sphere including the
c            poles. for example, nlat = 37 for a five degree grid.
c            nlat determines the grid increment in colatitude as
c            pi/(nlat-1).  if nlat is odd the equator is located at
c            grid point i=(nlat+1)/2. if nlat is even the equator is
c            located half way between points i=nlat/2 and i=nlat/2+1.
c            nlat must be at least 3. note: on the half sphere, the
c            number of grid points in the colatitudinal direction is
c            nlat/2 if nlat is even or (nlat+1)/2 if nlat is odd.
c
c     nlon   the number of distinct londitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater than
c            3.  the efficiency of the computation is improved when nlon
c            is a product of small prime numbers.
c
c
c     isym   a parameter which determines whether the divergence is
c            computed on the full or half sphere as follows:
c
c      = 0
c
c            the symmetries/antsymmetries described in isym=1,2 below
c            do not exist in (v,w) about the equator.  in this case the
c            divergence is neither symmetric nor antisymmetric about
c            the equator.  the divergence is computed on the entire
c            sphere.  i.e., in the array dv(i,j) for i=1,...,nlat and
c            j=1,...,nlon.
c
c      = 1
c
c            w is antisymmetric and v is symmetric about the equator.
c            in this case the divergence is antisymmetyric about
c            the equator and is computed for the northern hemisphere
c            only.  i.e., if nlat is odd the divergence is computed
c            in the array dv(i,j) for i=1,...,(nlat+1)/2 and for
c            j=1,...,nlon.  if nlat is even the divergence is computed
c            in the array dv(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
c
c      = 2
c            w is symmetric and v is antisymmetric about the equator
c            in this case the divergence is symmetyric about the
c            equator and is computed for the northern hemisphere
c            only.  i.e., if nlat is odd the divergence is computed
c            in the array dv(i,j) for i=1,...,(nlat+1)/2 and for
c            j=1,...,nlon.  if nlat is even the divergence is computed
c            in the array dv(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
c
c
c     nt     nt is the number of scalar and vector fields.  some
c            computational efficiency is obtained for multiple fields.
C*PL*ERROR* Comment line too long
c            can be three dimensional corresponding to an indexed multiple
c            vector field.  in this case multiple scalar synthesis will
c            be performed to compute the divergence for each field.  the
c            third index is the synthesis index which assumes the values
c            k=1,...,nt.  for a single synthesis set nt = 1.  the
c            description of the remaining parameters is simplified by
C*PL*ERROR* Comment line too long
c            assuming that nt=1 or that all the arrays are two dimensional.
c
c     idv    the first dimension of the array dv as it appears in
c            the program that calls dives. if isym = 0 then idv
c            must be at least nlat.  if isym = 1 or 2 and nlat is
c            even then idv must be at least nlat/2. if isym = 1 or 2
c            and nlat is odd then idv must be at least (nlat+1)/2.
c
c     jdv    the second dimension of the array dv as it appears in
c            the program that calls dives. jdv must be at least nlon.
c
c     br,bi  two or three dimensional arrays (see input parameter nt)
c            that contain vector spherical harmonic coefficients
c            of the vector field (v,w) as computed by subroutine vhaes.
c     ***    br and bi must be computed by vhaes prior to calling
c            dives.
c
c     mdb    the first dimension of the arrays br and bi as it
c            appears in the program that calls dives. mdb must be at
c            least min0(nlat,nlon/2) if nlon is even or at least
c            min0(nlat,(nlon+1)/2) if nlon is odd.
c
c     ndb    the second dimension of the arrays br and bi as it
c            appears in the program that calls dives. ndb must be at
c            least nlat.
c
c
c     wshses an array which must be initialized by subroutine shsesi
c            once initialized,
c            wshses can be used repeatedly by dives as long as nlon
c            and nlat remain unchanged.  wshses must not be altered
c            between calls of dives.  wdives is identical to the saved
c            work space initialized by subroutine shsesi and can be
c            set by calling that subroutine instead of divesi.
c
c
c     lshses the dimension of the array wshses as it appears in the
c            program that calls dives. define
c
c               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            then lshses must be at least
c
c              (l1*l2*(nlat+nlat-l1+1))/2+nlon+15
c
c
c     work   a work array that does not have to be saved.
c
c     lwork  the dimension of the array work as it appears in the
c            program that calls dives. define
c
c               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2                    if nlat is even or
c               l2 = (nlat+1)/2                if nlat is odd
c
c            if isym = 0 then lwork must be at least
c
c               nlat*((nt+1)*nlon+2*nt*l1+1)
c
c            if isym > 0 then lwork must be at least
c
c               (nt+1)*l2*nlon+nlat*(2*nt*l1+1)
c
c     **************************************************************
c
c     output parameters
c
c
c    dv     a two or three dimensional array (see input parameter nt)
c           that contains the divergence of the vector field (v,w)
c           whose coefficients br,bi where computed by subroutine
c           vhaes.  dv(i,j) is the divergence at the colatitude point
c           theta(i) = (i-1)*pi/(nlat-1) and longitude point
c           lambda(j) = (j-1)*2*pi/nlon. the index ranges are defined
c           above at the input parameter isym.
c
c
c    ierror = 0  no errors
c           = 1  error in the specification of nlat
c           = 2  error in the specification of nlon
c           = 3  error in the specification of isym
c           = 4  error in the specification of nt
c           = 5  error in the specification of idv
c           = 6  error in the specification of jdv
c           = 7  error in the specification of mdb
c           = 8  error in the specification of ndb
c           = 9  error in the specification of lshses
c           = 10 error in the specification of lwork
c **********************************************************************
c
c
      SUBROUTINE DDIVES(NLAT,NLON,ISYM,NT,DV,IDV,JDV,BR,BI,MDB,NDB,
     +                  WSHSES,LSHSES,WORK,LWORK,IERROR)
      DOUBLE PRECISION DV
      DOUBLE PRECISION BR
      DOUBLE PRECISION BI
      DOUBLE PRECISION WSHSES
      DOUBLE PRECISION WORK

      DIMENSION DV(IDV,JDV,NT),BR(MDB,NDB,NT),BI(MDB,NDB,NT)
      DIMENSION WSHSES(LSHSES),WORK(LWORK)
c
c     check input parameters
c
      IERROR = 1
      IF (NLAT.LT.3) RETURN
      IERROR = 2
      IF (NLON.LT.4) RETURN
      IERROR = 3
      IF (ISYM.LT.0 .OR. ISYM.GT.2) RETURN
      IERROR = 4
      IF (NT.LT.0) RETURN
      IERROR = 5
      IMID = (NLAT+1)/2
      IF ((ISYM.EQ.0.AND.IDV.LT.NLAT) .OR.
     +    (ISYM.GT.0.AND.IDV.LT.IMID)) RETURN
      IERROR = 6
      IF (JDV.LT.NLON) RETURN
      IERROR = 7
      IF (MDB.LT.MIN0(NLAT, (NLON+1)/2)) RETURN
      MMAX = MIN0(NLAT, (NLON+2)/2)
      IERROR = 8
      IF (NDB.LT.NLAT) RETURN
      IERROR = 9
c
c     verify save work space (same as shes, file f3)
c
      IMID = (NLAT+1)/2
      LPIMN = (IMID*MMAX* (NLAT+NLAT-MMAX+1))/2
      IF (LSHSES.LT.LPIMN+NLON+15) RETURN
      IERROR = 10
c
c     verify unsaved work space (add to what shses requires, file f3)
c
      LS = NLAT
      IF (ISYM.GT.0) LS = IMID
      NLN = NT*LS*NLON
c
c     set first dimension for a,b (as requried by shses)
c
      MAB = MIN0(NLAT,NLON/2+1)
      MN = MAB*NLAT*NT
      IF (LWORK.LT.NLN+LS*NLON+2*MN+NLAT) RETURN
      IERROR = 0
c
c     set work space pointers
c
      IA = 1
      IB = IA + MN
      IS = IB + MN
      IWK = IS + NLAT
      LWK = LWORK - 2*MN - NLAT
      CALL DDIVES1(NLAT,NLON,ISYM,NT,DV,IDV,JDV,BR,BI,MDB,NDB,WORK(IA),
     +            WORK(IB),MAB,WORK(IS),WSHSES,LSHSES,WORK(IWK),LWK,
     +            IERROR)
      RETURN
      END

      SUBROUTINE DDIVES1(NLAT,NLON,ISYM,NT,DV,IDV,JDV,BR,BI,MDB,NDB,A,B,
     +                  MAB,SQNN,WSHSES,LSHSES,WK,LWK,IERROR)
      DOUBLE PRECISION DV
      DOUBLE PRECISION BR
      DOUBLE PRECISION BI
      DOUBLE PRECISION A
      DOUBLE PRECISION B
      DOUBLE PRECISION SQNN
      DOUBLE PRECISION WSHSES
      DOUBLE PRECISION WK
      DOUBLE PRECISION FN
      DIMENSION DV(IDV,JDV,NT),BR(MDB,NDB,NT),BI(MDB,NDB,NT)
      DIMENSION A(MAB,NLAT,NT),B(MAB,NLAT,NT),SQNN(NLAT)
      DIMENSION WSHSES(LSHSES),WK(LWK)
c
c     set coefficient multiplyers
c
      DO 1 N = 2,NLAT
          FN = DBLE(N-1)
          SQNN(N) = SQRT(FN* (FN+1.D0))
    1 CONTINUE
c
c     compute divergence scalar coefficients for each vector field
c
      DO 2 K = 1,NT
          DO 3 N = 1,NLAT
              DO 4 M = 1,MAB
                  A(M,N,K) = 0.0D0
                  B(M,N,K) = 0.0D0
    4         CONTINUE
    3     CONTINUE
c
c     compute m=0 coefficients
c
          DO 5 N = 2,NLAT
              A(1,N,K) = -SQNN(N)*BR(1,N,K)
              B(1,N,K) = -SQNN(N)*BI(1,N,K)
    5     CONTINUE
c
c     compute m>0 coefficients using vector spherepack value for mmax
c
          MMAX = MIN0(NLAT, (NLON+1)/2)
          DO 6 M = 2,MMAX
              DO 7 N = M,NLAT
                  A(M,N,K) = -SQNN(N)*BR(M,N,K)
                  B(M,N,K) = -SQNN(N)*BI(M,N,K)
    7         CONTINUE
    6     CONTINUE
    2 CONTINUE
c
c     synthesize a,b into dv
c
      CALL DSHSES(NLAT,NLON,ISYM,NT,DV,IDV,JDV,A,B,MAB,NLAT,WSHSES,
     +           LSHSES,WK,LWK,IERROR)
      RETURN
      END

C
C $Id: mdpgrd.f,v 1.11 2008-09-18 00:42:17 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MDPGRD
C
C Declare required common blocks.  See MAPBDX for descriptions of these
C common blocks and the variables in them.
C
        COMMON /MAPCM0/  COS1,DTOR,DTRH,OOPI,PI,PIOF,PIOT,RTDD,RTOD,
     +                   SROT,SIN1,TOPI,TSRT
        DOUBLE PRECISION COS1,DTOR,DTRH,OOPI,PI,PIOF,PIOT,RTDD,RTOD,
     +                   SROT,SIN1,TOPI,TSRT
        SAVE   /MAPCM0/
C
        COMMON /MAPCM1/  COSO,COSR,SINO,SINR,IPRJ,IROD
        DOUBLE PRECISION COSO,COSR,SINO,SINR
        INTEGER          IPRJ,IROD
        SAVE   /MAPCM1/
C
        COMMON /MAPCM2/  BLAM,BLOM,PEPS,SLAM,SLOM,UCEN,UMAX,UMIN,UOFF,
     +                   URNG,VCEN,VMAX,VMIN,VOFF,VRNG,ISSL
        DOUBLE PRECISION BLAM,BLOM,PEPS,SLAM,SLOM,UCEN,UMAX,UMIN,UOFF,
     +                   URNG,VCEN,VMAX,VMIN,VOFF,VRNG
        INTEGER          ISSL
        SAVE   /MAPCM2/
C
        COMMON /MAPCM4/  GRDR,GRID,GRLA,GRLO,GRPO,OTOL,PDRE,PLA1,PLA2,
     +                   PLA3,PLA4,PLB1,PLB2,PLB3,PLB4,PLNO,PLTO,ROTA,
     +                   SRCH,XLOW,XROW,YBOW,YTOW,IDOT,IDSH,IDTL,ILCW,
     +                   ILTS,JPRJ,ELPF,INTF,LBLF,PRMF
        DOUBLE PRECISION GRDR,GRID,GRLA,GRLO,GRPO,OTOL,PDRE,PLA1,PLA2,
     +                   PLA3,PLA4,PLB1,PLB2,PLB3,PLB4,PLNO,PLTO,ROTA,
     +                   SRCH,XLOW,XROW,YBOW,YTOW
        INTEGER          IDOT,IDSH,IDTL,ILCW,ILTS,JPRJ
        LOGICAL          ELPF,INTF,LBLF,PRMF
        SAVE   /MAPCM4/
C
C Declare local variables.
C
        DOUBLE PRECISION BLAT,BLON,DLAT,DLON,GLAT,GLON,OLAT,RLAT,
     +                   RLON,SLAT,SLON,U,V,X,XLAT,XLON
C
C Declare the type of two local arithmetic statement functions and the
C argument used with them.
C
        DOUBLE PRECISION CEIL,FLOR
C
C The arithmetic statement functions FLOR and CEIL give, respectively,
C the "floor" of X - the largest integer less than or equal to X - and
C the "ceiling" of X - the smallest integer greater than or equal to X.
C
        FLOR(X)=DINT(X+1.D4)-1.D4
        CEIL(X)=-FLOR(-X)
C
C Check for an uncleared prior error.
C
        IF (ICFELL('MDPGRD - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C If EZMAP needs initialization, do it.
C
        IF (INTF) THEN
          CALL MDPINT
          IF (ICFELL('MDPGRD',2).NE.0) RETURN
        END IF
C
C If the grid is suppressed, do nothing.
C
        IF (GRID.LE.0.D0) RETURN
C
C Otherwise, set the latitude and longitude grid spacings.
C
        GLAT=GRID
        GLON=GRID
        IF (GRLA.GT.0.D0) GLAT=GRLA
        IF (GRLO.GT.0.D0) GLON=GRLO
C
C Reset the color index, dotting, and dash pattern for the grid.
C
        CALL MDPCHI (2,0,IDSH)
        IF (ICFELL('MDPGRD',3).NE.0) RETURN
C
C Transfer the latitude/longitude limits computed by MAPINT to local,
C modifiable variables.
C
        BLAT=BLAM
        BLON=BLOM
        SLAT=SLAM
        SLON=SLOM
C
C For certain azimuthal projections centered at a pole, the latitude
C limit furthest from the pole needs adjustment to make it projectable
C and visible.  Otherwise, we have trouble with portions of meridians
C disappearing.
C
        IF (IPRJ.EQ.3.OR.IPRJ.EQ.4.OR.IPRJ.EQ.6) THEN
          IF (PLTO.GT.+89.999999D0) THEN
            SLAT=SLAT+SRCH
            IF (IPRJ.EQ.3) SLAT=SLAT+SRCH
          END IF
          IF (PLTO.LT.-89.999999D0) THEN
            BLAT=BLAT-SRCH
            IF (IPRJ.EQ.3) BLAT=BLAT-SRCH
          END IF
        END IF
C
C RLON is the smallest longitude for which a meridian is to be drawn,
C XLON the biggest.  Avoid drawing a given meridian twice.
C
        RLON=GLON*FLOR(SLON/GLON)
        XLON=GLON*CEIL(BLON/GLON)
C
        IF (XLON-RLON.GT.359.999999D0) THEN
          IF (IPRJ.EQ.1) THEN
            RLON=GLON*CEIL((PLNO-179.999999D0)/GLON)
            XLON=GLON*FLOR((PLNO+179.999999D0)/GLON)
          ELSE IF (IPRJ.GE.2.AND.IPRJ.LE.15) THEN
            XLON=XLON-GLON
            IF (XLON-RLON.GT.359.999999D0) XLON=XLON-GLON
          END IF
        END IF
C
C OLAT is the latitude at which meridians that do not extend all the
C way to the poles are to stop.
C
        IF (IPRJ.EQ.16.OR.IPRJ.EQ.17.OR.IPRJ.EQ.19.OR.IPRJ.EQ.20.OR.
     +                                  IPRJ.EQ.24.OR.IPRJ.EQ.25) THEN
          OLAT=90.D0
        ELSE
          IF (DINT(GRPO/1000.D0).EQ.0.D0) THEN
            OLAT=GLAT*FLOR(89.999999D0/GLAT)
          ELSE
            OLAT=GLAT*FLOR(MIN(89.999999D0,DINT(GRPO/1000.D0))/GLAT)
          END IF
        END IF
C
C Draw the meridians.
C
        RLON=RLON-GLON
  101   RLON=RLON+GLON
        XLAT=OLAT
        IF (MOD(GRPO,1000.D0).GT.0.D0) THEN
          IF (MOD(RLON,MOD(GRPO,1000.D0)).EQ.0.D0) XLAT=90.D0
        END IF
        RLAT=MAX(SLAT,-XLAT)
        XLAT=MIN(BLAT, XLAT)
        DLAT=(XLAT-RLAT)/CEIL((XLAT-RLAT)/GRDR)
        CALL MDPIT (RLAT,RLON,0)
        IF (ICFELL('MDPGRD',4).NE.0) RETURN
  102   RLAT=RLAT+DLAT
        CALL MDPIT (RLAT,RLON,1)
        IF (ICFELL('MDPGRD',5).NE.0) RETURN
        IF (RLAT.LT.XLAT-.5D0*DLAT) GO TO 102
        CALL MDPIQ
        IF (ICFELL('MDPGRD',6).NE.0) RETURN
        IF (RLON.LT.XLON-.5D0*GLON) GO TO 101
C
C Round the latitude limits to appropriate multiples of GLAT.
C
        SLAT=GLAT*FLOR(SLAT/GLAT)
        IF (SLAT.LE.-90.D0) SLAT=SLAT+GLAT
        BLAT=GLAT*CEIL(BLAT/GLAT)
        IF (BLAT.GE.+90.D0) BLAT=BLAT-GLAT
C
C If a fast-path cylindrical equidistant or cylindrical equal-area
C projection is in use and either or both of the poles is within the
C (rectangular) perimeter, arrange for the parallels at -90 and/or +90
C to be drawn.
C
        IF (IPRJ.EQ.16.OR.IPRJ.EQ.20) THEN
          CALL MDPTRN (-90.D0,PLNO,U,V)
          IF (ICFELL('MDPGRD',7).NE.0) RETURN
          IF (U.GE.UMIN.AND.U.LE.UMAX.AND.V.GE.VMIN.AND.V.LE.VMAX)
     +                                                    SLAT=SLAT-GLAT
          CALL MDPTRN (+90.D0,PLNO,U,V)
          IF (ICFELL('MDPGRD',8).NE.0) RETURN
          IF (U.GE.UMIN.AND.U.LE.UMAX.AND.V.GE.VMIN.AND.V.LE.VMAX)
     +                                                    BLAT=BLAT+GLAT
        END IF
C
C Draw the parallels.
C
        XLAT=SLAT-GLAT
  103   XLAT=XLAT+GLAT
        RLAT=MAX(-90.D0,MIN(+90.D0,XLAT))
        IF (DINT(GRPO/1000.D0).EQ.0.D0.OR.
     +      ABS(RLAT).LE.DINT(GRPO/1000.D0)) THEN
          RLON=FLOR(SLON)
          XLON=MIN(CEIL(BLON),RLON+360.D0)
          DLON=(XLON-RLON)/CEIL((XLON-RLON)/GRDR)
          CALL MDPIT (RLAT,RLON,0)
          IF (ICFELL('MDPGRD',9).NE.0) RETURN
  104     RLON=RLON+DLON
          CALL MDPIT (RLAT,RLON,1)
          IF (ICFELL('MDPGRD',10).NE.0) RETURN
          IF (RLON.LT.XLON-.5D0*DLON) GO TO 104
          CALL MDPIQ
          IF (ICFELL('MDPGRD',11).NE.0) RETURN
        END IF
        IF (XLAT.LT.BLAT-.5D0*GLAT) GO TO 103
C
C Restore the color index, dotting, and dash pattern.
C
        CALL MDPCHI (-2,0,0)
        IF (ICFELL('MDPGRD',12).NE.0) RETURN
C
C Draw the limb lines.
C
        CALL MDPLMB
        IF (ICFELL('MDPGRD',13).NE.0) RETURN
C
C Done.
C
        RETURN
C
      END

      PROGRAM PGKEX24
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      DIMENSION X(100),Y(100)
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF,IDUM)
      CALL GOPWK (IWKID,LUNIT,IWTYPE)
      CALL GACWK (IWKID)
C
C  Define a small color table for the CGM workstation.
C
      CALL GSCR(IWKID, 0, 1.0, 1.0, 1.0)
      CALL GSCR(IWKID, 1, 0.4, 0.0, 0.4)
      CALL GSCR(IWKID, 2, 0.0, 0.0, 1.0)
C
C  Turn clipping off
C
      CALL GSCLIP(0)
C
C  Generate a straight line of 100 points.
C
      DO 10 I=1,100
        X(I) = I
        Y(I) = 10.*I
   10 CONTINUE
C
C  Use SET to define normalization transformation 1 with linear
C  scaling in the X direction and log scaling in the Y direction.
C
      CALL SET(.15,.85,.15,.85,1.,100.,10.,1000.,2)
C
C  Set line color to blue.
C
      CALL GSPLCI(2)
C
C  Initialize the AUTOGRAPH entry EZXY so that the frame is not 
C  advanced and the Y axis is logarithmic.
C
      CALL DISPLA(2,0,2)
C
C  Output the polyline (X,Y) using EZXY.
C
      CALL EZXY(X,Y,100,' ')
C
C  Establish the identity transformation for character plotting.
C
      CALL SET(0.,1.,0.,1.,0.,1.,0.,1.,1)
C
C  Title the plot using Plotchar.
C
      CALL PCSETI('FN',25)
      CALL PCSETI('CC',2)
      CALL PLCHHQ(.5,.05,'Log Scaling with SPPS',.025,0.,0.)
C
      CALL FRAME
C
C  Deactivate and close the workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END

C
C	$Id: gzfmwk.f,v 1.5 2008-07-27 00:21:03 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GZFMWK
C
C  This subroutine can be a dummy for MO workstations.
C
C
      include 'gkscom.h'
C
      RL2 = 0
      IL2 = 0
      STRL2 = 0
C
      RETURN
      END

C
C	$Id: rdline.f,v 1.4 2008-07-27 12:23:44 haley Exp $
C                                                                      
C			     Copyright (C)  1997
C	     University Corporation for Atmospheric Research
C			     All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C

      SUBROUTINE RDLINE(IOS, STATUS)
C
C  Return the next non-comment line in the file.
C
C
C  OUTPUT
C       IOS     --  I/O status flag.  This flag is valid only
C                   if STATUS indicates an error.
C       STATUS  --  The error status as defined in COMMON CAPERR.
C
C
      COMMON /CAPERR/ ALLOK, EOFFL, INTERR, MAXINT, PLBERR, PMBERR,
     1                FABERR, TXBERR, FLTERR, MAXFLT, NOTINT, SIZERR,
     2                UNDASC, DEVERR, DOCERR, TBLERR , STSZER, ENTERR,
     3                TABERR, TABSER, PRSFIL
      INTEGER ALLOK, EOFFL, INTERR, MAXINT, PLBERR, PMBERR,
     1        FABERR, TXBERR, FLTERR, MAXFLT, NOTINT, SIZERR, UNDASC,
     2        DEVERR, DOCERR, STSZER, ENTERR, TABERR, TABSER, TBLERR,
     3        PRSFIL
      COMMON /CAPIOB/ UNIT, IPTR, LSIZE, NFST, NFLG
      COMMON /CAPIO2/ LINE, GRNM
      INTEGER LNMAX
      PARAMETER (LNMAX=80)
      CHARACTER*80 LINE
      CHARACTER*80 GRNM
      INTEGER UNIT, IPTR, LSIZE, NFST, NFLG
      COMMON /PARTB1/ PART1, KEYSEP, KEYTER, FRMCOM
      COMMON /PARTB2/ PART2, PART3, PART4, PART5, CTSTR, CTLOC
C
C  THE NUMBER OF WORDS IN THE SEARCH PATH MUST BE BIG ENOUGH TO HOLD
C       THE NUMBER OF BITS PER PATH TIMES THE NUMBER OF LEVELS
C
      INTEGER WHSIZE
      PARAMETER (WHSIZE=20)
C
      INTEGER PARTSZ, OTHSZ, NTABLE
      PARAMETER(PARTSZ=3000, OTHSZ=150, NTABLE=50)
      CHARACTER*1 KEYSEP,KEYTER
      CHARACTER*1 FRMCOM(2)
      INTEGER PART2(OTHSZ), PART3(OTHSZ), PART4(NTABLE), PART5(NTABLE*2)
      CHARACTER*1 PART1(PARTSZ)
      INTEGER CTSTR, CTLOC
C
C  CONTROL THE PRINTING OF INPUT LINES
C
      COMMON /CAPSKP/ SKIPIT
      LOGICAL SKIPIT
C
      INTEGER IOS, STATUS
      INTEGER II
      CHARACTER*10 CTMP
C
C  Read in the next buffer from the file.
C
 10   CONTINUE
      CALL CHRRED(UNIT, LNMAX, LINE, IPTR, IOS, STATUS)
C
C  If error, then return.
C
      IF (STATUS.NE. ALLOK) RETURN
C
C  Set the buffer size.
C
      LSIZE = IOS
      IOS = 0
C
C  Echo the line if requested.
C
      IF (.NOT.SKIPIT .AND. LSIZE .NE. 0)
     -        WRITE(6,1)LINE(1:LSIZE)
C
C  Check if this line is big enough to be a comment line.
C
      IF (LSIZE .LT. 2) RETURN
C
C  Check if this line is a special NCAR separator line.
C
      DO 60 I=1,10
      II = IPTR+I-1
      CTMP(I:I) = LINE(II:II)
   60 CONTINUE
      IF (CTMP .EQ. 'NCAR_FILE_') THEN
        WRITE(6,500) LINE(1:LSIZE)
        STOP
      ENDIF
C
C  Check if this line is a comment line.
C
      II = IPTR+1
      IF (FRMCOM(1) .EQ. LINE(IPTR:IPTR) .AND.
     1    FRMCOM(2) .EQ. LINE(II:II) ) THEN
C
C  If this is the first line in the file, attempt to get the
C  graphcap name and set NFLG to flag special graphcaps that
C  require special treatment.
C
C  The special graphcaps and flags are:
C
C          NFLG  graphcap
C          ----  --------
C            1   qms
C
        IF (NFST .EQ. 1) THEN
          NFST = 0
          GRNM = ' '
          DO 20 I=IPTR+2,LSIZE
            IF (LINE(I:I) .EQ. ' ') GO TO 20
            J = I
            K = 1
            DO 30 L=J,LSIZE
              IF (LINE(L:L) .NE. ' ') THEN
                GRNM(K:K) = LINE(L:L)
                K = K+1
              ELSE
                GO TO 40
              ENDIF
   30       CONTINUE
   40       CONTINUE
            IF (GRNM(1:6) .EQ. 'qms800') THEN
              NFLG = 1
            ENDIF
            GO TO 10
   20     CONTINUE
        ENDIF
        GO TO 10
      ENDIF
C
C  Not a comment line, so return.
C
      RETURN
 1    FORMAT(A80)
  500 FORMAT(' READLN -- An NCAR separator line appears in the input, pl
     -ease remove, LINE='/(A80))
      END

C
C	$Id: ngsetc.f,v 1.6 2008-07-27 00:17:18 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE NGSETC (CNP,CVP)
C
      SAVE
C
      CHARACTER*(*) CNP,CVP
C
C  This subroutine is called to give a character value to a specified
C  parameter.
C
C  CNP is the name of the parameter whose value is to be set.
C
C  CVP is a character variable containing the desired value.
C
C  Declare a local character variable in which to form an error message.
C
      CHARACTER*38 CTM
C
      include 'ngcomn.h'
C
C  Input and output data records for ESCAPE function calls.
C
      PARAMETER (IDRLEN=13)
      CHARACTER*80 IDR(IDRLEN),CDUM
C
C  Do a call forcing a BLOCKDATA to be loaded from a binary library.
C
      CALL NGBLDA
C
C  Check for an uncleared prior error.
C
      IF (ICFELL('NGSETC - Uncleared prior error',1) .NE. 0) RETURN
C
C  Check for a parameter name that is too short.
C
      IF (LEN(CNP) .LT. 2) THEN
        CTM(1:36)='NGSETC - Parameter name too short - '
        CTM(37:36+LEN(CNP)) = CNP
        CALL SETER (CTM(1:36+LEN(CNP)), 1, 1)
        GO TO 120
      ENDIF
C
C  Set the appropriate parameter value.
C
      DO 10 I=1,IDRLEN
        IDR(I) = ' '
   10 CONTINUE
C
C  ME - Metafile name.
C
      IF (CNP(1:2).EQ.'ME' .OR. CNP(1:2).EQ.'me' .OR.
     +    CNP(1:2).EQ.'Me') THEN
        LENCVP = LEN(CVP)
        IF (LENCVP .EQ. 0) THEN 
          CALL SETER ('NGSETC - value for ME must not be empty', 2, 1)       
          GO TO 120
        ENDIF
        CFILNM = CVP
        NLEN = ((LENCVP-1)/80) + 1
        DO 20 I=1,NLEN
          IB = 80*(I-1)+1
          IF (I .LT. NLEN) THEN
            IE = IB+79
          ELSE
            IE = IB+MOD(LENCVP-1,80)
          ENDIF
          IDR(I)(1:IE-IB+1) = CVP(IB:IE)
   20   CONTINUE
        CALL GESC(-1391,NLEN,IDR,1,IDUM,CDUM)
        GO TO 120
C
C  PI - Picture name.
C
      ELSE IF (CNP(1:2).EQ.'PI' .OR. CNP(1:2).EQ.'pi' .OR.
     +         CNP(1:2).EQ.'Pi') THEN
        IDR(1) = CVP
        CPICNM = CVP
        CALL GESC(-1393,1,IDR,1,IDUM,CDUM)
        GO TO 120
C
C  SE - Root name for segment file names.
C
      ELSE IF (CNP(1:2).EQ.'SE' .OR. CNP(1:2).EQ.'se' .OR.
     +         CNP(1:2).EQ.'Se') THEN
        IDR(1) = CVP
        CSEGNM = CVP
        CALL GESC(-1394,1,IDR,1,IDUM,CDUM)
        GO TO 120
      ELSE
        CTM(1:36) = 'NGSETC - Parameter name not known - '
        CTM(37:38) = CNP(1:2)
        CALL SETER (CTM(1:38), 3, 1)
        GO TO 120
      ENDIF
C
  120 CONTINUE
      RETURN
      END

      PROGRAM CCPPKCL
C 
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
      
      PARAMETER (K=40,N=40,LRWK=1000,LIWK=1000)
      REAL ZREG(K,N), RWRK(LRWK)
      INTEGER M, NOCL, IWRK(LIWK)
      
      CALL GETDAT (ZREG, K, M, N) 
C     
C Open GKS
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
      
      CALL CPSETI('CLS - CONTOUR LEVEL SELECTION FLAG',-20)
      CALL CPRECT(ZREG,K,M,N,RWRK,LRWK,IWRK,LIWK)
C     
C Force contour lines to be chosen
C
      CALL CPPKCL (ZREG, RWRK, IWRK)
C
C Get the number of contour levels chosen
C
      CALL CPGETI ('NCL - NUMBER OF CONTOUR LEVELS',NOCL)
      CALL CPSETI ('NCL - NUMBER OF CONTOUR LEVELS',NOCL+1)
      CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',NOCL+1)
      CALL CPSETR ('CLV - CONTOUR LEVEL VALUE',0.0)
      
      CALL CPBACK(ZREG, RWRK, IWRK)
      CALL CPCLDR(ZREG,RWRK,IWRK)
C     
C Close frame and close GKS
C
      CALL FRAME
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      
      STOP
      END
      
      SUBROUTINE GETDAT (ZREG, K, M, N)
      INTEGER I,J,K,M,N
      REAL ZREG(K,N)
      
      M=K
      DO 10, I=1,M
         DO 20, J=1,N
            ZREG(I,J)= 10.E-5*(-16.*REAL(I**2*J) +
     +            34*REAL(I*J**2) - REAL(6*I) + 93.)
 20      CONTINUE
 10   CONTINUE
      
      RETURN
      END
      

C
C	$Id: mtchit.f,v 1.4 2008-07-27 12:23:44 haley Exp $
C                                                                      
C			     Copyright (C)  1997
C	     University Corporation for Atmospheric Research
C			     All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C

      SUBROUTINE MTCHIT (WHICH, IOS, STATUS)
C
C  Scan the input buffer for a keyword.
C
C  OUTPUT
C       WHICH   --  Array of flags which serve as an encoding of
C                   the matched keyword; WHICH(1) is returned if
C                   there was no match.
C       IOS     --  The I/O status word.   IOS is valid only if STATUS
C                   is set to an error (non-zero).
C       STATUS  --  The error status, as defined in COMMON CAPERR.
C
C  Note:
C
C  If a match is found, the line buffer pointer IPTR in COMMON CAPIOB
C  is updated to point to the next position after the matched keyword.
C  If no match is found, IPTR is unchanged.
C
      COMMON /CAPIOB/ UNIT, IPTR, LSIZE, NFST, NFLG
      COMMON /CAPIO2/ LINE, GRNM
      INTEGER LNMAX
      PARAMETER (LNMAX=80)
      CHARACTER*80 LINE
      CHARACTER*80 GRNM
      INTEGER UNIT, IPTR, LSIZE, NFST, NFLG
      COMMON /CAPERR/ ALLOK, EOFFL, INTERR, MAXINT, PLBERR, PMBERR,
     1                FABERR, TXBERR, FLTERR, MAXFLT, NOTINT, SIZERR,
     2                UNDASC, DEVERR, DOCERR, TBLERR , STSZER, ENTERR,
     3                TABERR, TABSER, PRSFIL
      INTEGER ALLOK, EOFFL, INTERR, MAXINT, PLBERR, PMBERR,
     1        FABERR, TXBERR, FLTERR, MAXFLT, NOTINT, SIZERR, UNDASC,
     2        DEVERR, DOCERR, STSZER, ENTERR, TABERR, TABSER, TBLERR,
     3        PRSFIL
      COMMON /PARTB1/ PART1, KEYSEP, KEYTER, FRMCOM
      COMMON /PARTB2/ PART2, PART3, PART4, PART5, CTSTR, CTLOC
C
C  THE NUMBER OF WORDS IN THE SEARCH PATH MUST BE BIG ENOUGH TO HOLD
C       THE NUMBER OF BITS PER PATH TIMES THE NUMBER OF LEVELS
C
      INTEGER WHSIZE
      PARAMETER (WHSIZE=20)
C
      INTEGER PARTSZ, OTHSZ, NTABLE
      PARAMETER(PARTSZ=3000, OTHSZ=150, NTABLE=50)
      CHARACTER*1 KEYSEP,KEYTER
      CHARACTER*1 FRMCOM(2)
      INTEGER PART2(OTHSZ), PART3(OTHSZ), PART4(NTABLE), PART5(NTABLE*2)
      CHARACTER*1 PART1(PARTSZ)
      INTEGER CTSTR, CTLOC
C
      INTEGER IOS, STATUS, WHICH(WHSIZE)
C
      CHARACTER*1 BLANK
      INTEGER ROW, II, IPOS, IEND, TPTR, LEVEL, ROWNUM, TBIDX, DIM1
     1       ,DIM2, CHSTRT, RPTR
      LOGICAL FNDCHR
C
      DATA BLANK/' '/
C
C  Initialize WHICH to indicate no match.
C
      WHICH(1) = 0
C
C  Skip over any blanks in the input buffer.
C
      CALL SKPBLK(IOS, STATUS)
      IF (STATUS .NE. ALLOK) RETURN
C
C  Set a temporary buffer pointer.
C
      TPTR = IPTR
C
C  Initialize the keyword level counter.
C
      LEVEL = 0
C
C   Start the search at the first keyword group in PART1.
C
      ROWNUM = 1
C
C   Continue search.
C
 10   CONTINUE
      TBIDX = PART3(ROWNUM)
      CHSTRT = PART4(TBIDX)
      DIM1 = PART5((TBIDX*2)-1)
      DIM2 = PART5(TBIDX*2)
      LEVEL = LEVEL + 1
C
C  Loop through all the keywords in the current group.
C
      DO 100 ROW = 1,DIM1
        IEND = DIM2 * ROW + CHSTRT
        IPOS = DIM2 * (ROW-1) + CHSTRT
C
C  Check for a keyword match starting at the current buffer position.
C
        DO 50 II = TPTR, LSIZE
C
C  Continue as long as the characters match.
C
                IF (LINE(II:II) .NE. PART1(IPOS)) GO TO 100
C
C  Increment the position pointer.
C
                IPOS = IPOS + 1
C
C  If we are at the end of a table entry, then we have a match.
C
                IF (IPOS.GE.IEND .OR. PART1(IPOS).EQ.BLANK) THEN
C
C  Set WHICH for this level to flag the number of the keyword in
C  the current group of keywords and go to the next level (group
C  of keywords) in the parse table.
C
                        WHICH(LEVEL) = ROW
                        TPTR = II
                        GO TO 1000
                END IF
  50    CONTINUE
C
C  No match, check next the next keyword in the current group for a match.
C
 100  CONTINUE
C
C  No match, increment the buffer pointer and return.
C
      WHICH(1) = 0
      IPTR = IPTR + 1
      RETURN
C
C  Match found in the current group of keywords, go to the next
C  level of keywords.
C
 1000 CONTINUE
      ROWNUM = PART2(ROWNUM+ROW-1)
      IF (ROWNUM .EQ. 0) THEN
C
C  End of search, check that the keyword terminates with a blank.
C
        RPTR = IPTR
        IPTR = TPTR + 1
        IF ( FNDCHR(KEYTER) ) THEN
                RETURN
        ELSE
C
C  Fail, so reset buffer pointer to the start, clear WHICH, and return.
C
                IPTR = RPTR
                WHICH(1) = 0
                RETURN
        END IF
      END IF
C
C  Check for a keyword separator.
C
      RPTR = IPTR
      IPTR = TPTR + 1
      IF (FNDCHR(KEYSEP)) THEN
C
C  All OK, so continue.
C
        TPTR = IPTR
        GO TO 10
      ELSE
C
C  Failure.
C
        WHICH(1) = 0
        IPTR = RPTR
        RETURN
      END IF
C
      END

C
C $Id: halfax.f,v 1.7 2008-07-27 00:17:14 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE HALFAX (MJRX,MNRX,MJRY,MNRY,XINT,YINT,IXLB,IYLB)
        IF (ICFELL('HALFAX - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
        CALL GRIDAL (MJRX,MNRX,MJRY,MNRY,IXLB,IYLB,10,XINT,YINT)
        IF (ICFELL('HALFAX',2).NE.0) RETURN
        RETURN
      END

      SUBROUTINE DGEEVX( BALANC, JOBVL, JOBVR, SENSE, N, A, LDA, WR, WI,
     $                   VL, LDVL, VR, LDVR, ILO, IHI, SCALE, ABNRM,
     $                   RCONDE, RCONDV, WORK, LWORK, IWORK, INFO )
*
*  -- LAPACK driver routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          BALANC, JOBVL, JOBVR, SENSE
      INTEGER            IHI, ILO, INFO, LDA, LDVL, LDVR, LWORK, N
      DOUBLE PRECISION   ABNRM
*     ..
*     .. Array Arguments ..
      INTEGER            IWORK( * )
      DOUBLE PRECISION   A( LDA, * ), RCONDE( * ), RCONDV( * ),
     $                   SCALE( * ), VL( LDVL, * ), VR( LDVR, * ),
     $                   WI( * ), WORK( * ), WR( * )
*     ..
*
*  Purpose
*  =======
*
*  DGEEVX computes for an N-by-N real nonsymmetric matrix A, the
*  eigenvalues and, optionally, the left and/or right eigenvectors.
*
*  Optionally also, it computes a balancing transformation to improve
*  the conditioning of the eigenvalues and eigenvectors (ILO, IHI,
*  SCALE, and ABNRM), reciprocal condition numbers for the eigenvalues
*  (RCONDE), and reciprocal condition numbers for the right
*  eigenvectors (RCONDV).
*
*  The right eigenvector v(j) of A satisfies
*                   A * v(j) = lambda(j) * v(j)
*  where lambda(j) is its eigenvalue.
*  The left eigenvector u(j) of A satisfies
*                u(j)**H * A = lambda(j) * u(j)**H
*  where u(j)**H denotes the conjugate transpose of u(j).
*
*  The computed eigenvectors are normalized to have Euclidean norm
*  equal to 1 and largest component real.
*
*  Balancing a matrix means permuting the rows and columns to make it
*  more nearly upper triangular, and applying a diagonal similarity
*  transformation D * A * D**(-1), where D is a diagonal matrix, to
*  make its rows and columns closer in norm and the condition numbers
*  of its eigenvalues and eigenvectors smaller.  The computed
*  reciprocal condition numbers correspond to the balanced matrix.
*  Permuting rows and columns will not change the condition numbers
*  (in exact arithmetic) but diagonal scaling will.  For further
*  explanation of balancing, see section 4.10.2 of the LAPACK
*  Users' Guide.
*
*  Arguments
*  =========
*
*  BALANC  (input) CHARACTER*1
*          Indicates how the input matrix should be diagonally scaled
*          and/or permuted to improve the conditioning of its
*          eigenvalues.
*          = 'N': Do not diagonally scale or permute;
*          = 'P': Perform permutations to make the matrix more nearly
*                 upper triangular. Do not diagonally scale;
*          = 'S': Diagonally scale the matrix, i.e. replace A by
*                 D*A*D**(-1), where D is a diagonal matrix chosen
*                 to make the rows and columns of A more equal in
*                 norm. Do not permute;
*          = 'B': Both diagonally scale and permute A.
*
*          Computed reciprocal condition numbers will be for the matrix
*          after balancing and/or permuting. Permuting does not change
*          condition numbers (in exact arithmetic), but balancing does.
*
*  JOBVL   (input) CHARACTER*1
*          = 'N': left eigenvectors of A are not computed;
*          = 'V': left eigenvectors of A are computed.
*          If SENSE = 'E' or 'B', JOBVL must = 'V'.
*
*  JOBVR   (input) CHARACTER*1
*          = 'N': right eigenvectors of A are not computed;
*          = 'V': right eigenvectors of A are computed.
*          If SENSE = 'E' or 'B', JOBVR must = 'V'.
*
*  SENSE   (input) CHARACTER*1
*          Determines which reciprocal condition numbers are computed.
*          = 'N': None are computed;
*          = 'E': Computed for eigenvalues only;
*          = 'V': Computed for right eigenvectors only;
*          = 'B': Computed for eigenvalues and right eigenvectors.
*
*          If SENSE = 'E' or 'B', both left and right eigenvectors
*          must also be computed (JOBVL = 'V' and JOBVR = 'V').
*
*  N       (input) INTEGER
*          The order of the matrix A. N >= 0.
*
*  A       (input/output) DOUBLE PRECISION array, dimension (LDA,N)
*          On entry, the N-by-N matrix A.
*          On exit, A has been overwritten.  If JOBVL = 'V' or
*          JOBVR = 'V', A contains the real Schur form of the balanced
*          version of the input matrix A.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(1,N).
*
*  WR      (output) DOUBLE PRECISION array, dimension (N)
*  WI      (output) DOUBLE PRECISION array, dimension (N)
*          WR and WI contain the real and imaginary parts,
*          respectively, of the computed eigenvalues.  Complex
*          conjugate pairs of eigenvalues will appear consecutively
*          with the eigenvalue having the positive imaginary part
*          first.
*
*  VL      (output) DOUBLE PRECISION array, dimension (LDVL,N)
*          If JOBVL = 'V', the left eigenvectors u(j) are stored one
*          after another in the columns of VL, in the same order
*          as their eigenvalues.
*          If JOBVL = 'N', VL is not referenced.
*          If the j-th eigenvalue is real, then u(j) = VL(:,j),
*          the j-th column of VL.
*          If the j-th and (j+1)-st eigenvalues form a complex
*          conjugate pair, then u(j) = VL(:,j) + i*VL(:,j+1) and
*          u(j+1) = VL(:,j) - i*VL(:,j+1).
*
*  LDVL    (input) INTEGER
*          The leading dimension of the array VL.  LDVL >= 1; if
*          JOBVL = 'V', LDVL >= N.
*
*  VR      (output) DOUBLE PRECISION array, dimension (LDVR,N)
*          If JOBVR = 'V', the right eigenvectors v(j) are stored one
*          after another in the columns of VR, in the same order
*          as their eigenvalues.
*          If JOBVR = 'N', VR is not referenced.
*          If the j-th eigenvalue is real, then v(j) = VR(:,j),
*          the j-th column of VR.
*          If the j-th and (j+1)-st eigenvalues form a complex
*          conjugate pair, then v(j) = VR(:,j) + i*VR(:,j+1) and
*          v(j+1) = VR(:,j) - i*VR(:,j+1).
*
*  LDVR    (input) INTEGER
*          The leading dimension of the array VR.  LDVR >= 1, and if
*          JOBVR = 'V', LDVR >= N.
*
*  ILO,IHI (output) INTEGER
*          ILO and IHI are integer values determined when A was
*          balanced.  The balanced A(i,j) = 0 if I > J and
*          J = 1,...,ILO-1 or I = IHI+1,...,N.
*
*  SCALE   (output) DOUBLE PRECISION array, dimension (N)
*          Details of the permutations and scaling factors applied
*          when balancing A.  If P(j) is the index of the row and column
*          interchanged with row and column j, and D(j) is the scaling
*          factor applied to row and column j, then
*          SCALE(J) = P(J),    for J = 1,...,ILO-1
*                   = D(J),    for J = ILO,...,IHI
*                   = P(J)     for J = IHI+1,...,N.
*          The order in which the interchanges are made is N to IHI+1,
*          then 1 to ILO-1.
*
*  ABNRM   (output) DOUBLE PRECISION
*          The one-norm of the balanced matrix (the maximum
*          of the sum of absolute values of elements of any column).
*
*  RCONDE  (output) DOUBLE PRECISION array, dimension (N)
*          RCONDE(j) is the reciprocal condition number of the j-th
*          eigenvalue.
*
*  RCONDV  (output) DOUBLE PRECISION array, dimension (N)
*          RCONDV(j) is the reciprocal condition number of the j-th
*          right eigenvector.
*
*  WORK    (workspace/output) DOUBLE PRECISION array, dimension (LWORK)
*          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*
*  LWORK   (input) INTEGER
*          The dimension of the array WORK.   If SENSE = 'N' or 'E',
*          LWORK >= max(1,2*N), and if JOBVL = 'V' or JOBVR = 'V',
*          LWORK >= 3*N.  If SENSE = 'V' or 'B', LWORK >= N*(N+6).
*          For good performance, LWORK must generally be larger.
*
*          If LWORK = -1, then a workspace query is assumed; the routine
*          only calculates the optimal size of the WORK array, returns
*          this value as the first entry of the WORK array, and no error
*          message related to LWORK is issued by XERBLA.
*
*  IWORK   (workspace) INTEGER array, dimension (2*N-2)
*          If SENSE = 'N' or 'E', not referenced.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value.
*          > 0:  if INFO = i, the QR algorithm failed to compute all the
*                eigenvalues, and no eigenvectors or condition numbers
*                have been computed; elements 1:ILO-1 and i+1:N of WR
*                and WI contain eigenvalues which have converged.
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO, ONE
      PARAMETER          ( ZERO = 0.0D0, ONE = 1.0D0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            LQUERY, SCALEA, WANTVL, WANTVR, WNTSNB, WNTSNE,
     $                   WNTSNN, WNTSNV
      CHARACTER          JOB, SIDE
      INTEGER            HSWORK, I, ICOND, IERR, ITAU, IWRK, K, MAXB,
     $                   MAXWRK, MINWRK, NOUT
      DOUBLE PRECISION   ANRM, BIGNUM, CS, CSCALE, EPS, R, SCL, SMLNUM,
     $                   SN
*     ..
*     .. Local Arrays ..
      LOGICAL            SELECT( 1 )
      DOUBLE PRECISION   DUM( 1 )
*     ..
*     .. External Subroutines ..
      EXTERNAL           DGEBAK, DGEBAL, DGEHRD, DHSEQR, DLACPY, DLARTG,
     $                   DLASCL, DORGHR, DROT, DSCAL, DTREVC, DTRSNA,
     $                   XERBLA
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            IDAMAX, ILAENV
      DOUBLE PRECISION   DLAMCH, DLANGE, DLAPY2, DNRM2
      EXTERNAL           LSAME, IDAMAX, ILAENV, DLAMCH, DLANGE, DLAPY2,
     $                   DNRM2
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN, SQRT
*     ..
*     .. Executable Statements ..
*
*     Test the input arguments
*
      INFO = 0
      LQUERY = ( LWORK.EQ.-1 )
      WANTVL = LSAME( JOBVL, 'V' )
      WANTVR = LSAME( JOBVR, 'V' )
      WNTSNN = LSAME( SENSE, 'N' )
      WNTSNE = LSAME( SENSE, 'E' )
      WNTSNV = LSAME( SENSE, 'V' )
      WNTSNB = LSAME( SENSE, 'B' )
      IF( .NOT.( LSAME( BALANC, 'N' ) .OR. LSAME( BALANC,
     $    'S' ) .OR. LSAME( BALANC, 'P' ) .OR. LSAME( BALANC, 'B' ) ) )
     $     THEN
         INFO = -1
      ELSE IF( ( .NOT.WANTVL ) .AND. ( .NOT.LSAME( JOBVL, 'N' ) ) ) THEN
         INFO = -2
      ELSE IF( ( .NOT.WANTVR ) .AND. ( .NOT.LSAME( JOBVR, 'N' ) ) ) THEN
         INFO = -3
      ELSE IF( .NOT.( WNTSNN .OR. WNTSNE .OR. WNTSNB .OR. WNTSNV ) .OR.
     $         ( ( WNTSNE .OR. WNTSNB ) .AND. .NOT.( WANTVL .AND.
     $         WANTVR ) ) ) THEN
         INFO = -4
      ELSE IF( N.LT.0 ) THEN
         INFO = -5
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -7
      ELSE IF( LDVL.LT.1 .OR. ( WANTVL .AND. LDVL.LT.N ) ) THEN
         INFO = -11
      ELSE IF( LDVR.LT.1 .OR. ( WANTVR .AND. LDVR.LT.N ) ) THEN
         INFO = -13
      END IF
*
*     Compute workspace
*      (Note: Comments in the code beginning "Workspace:" describe the
*       minimal amount of workspace needed at that point in the code,
*       as well as the preferred amount for good performance.
*       NB refers to the optimal block size for the immediately
*       following subroutine, as returned by ILAENV.
*       HSWORK refers to the workspace preferred by DHSEQR, as
*       calculated below. HSWORK is computed assuming ILO=1 and IHI=N,
*       the worst case.)
*
      MINWRK = 1
      IF( INFO.EQ.0 .AND. ( LWORK.GE.1 .OR. LQUERY ) ) THEN
         MAXWRK = N + N*ILAENV( 1, 'DGEHRD', ' ', N, 1, N, 0 )
         IF( ( .NOT.WANTVL ) .AND. ( .NOT.WANTVR ) ) THEN
            MINWRK = MAX( 1, 2*N )
            IF( .NOT.WNTSNN )
     $         MINWRK = MAX( MINWRK, N*N+6*N )
            MAXB = MAX( ILAENV( 8, 'DHSEQR', 'SN', N, 1, N, -1 ), 2 )
            IF( WNTSNN ) THEN
               K = MIN( MAXB, N, MAX( 2, ILAENV( 4, 'DHSEQR', 'EN', N,
     $             1, N, -1 ) ) )
            ELSE
               K = MIN( MAXB, N, MAX( 2, ILAENV( 4, 'DHSEQR', 'SN', N,
     $             1, N, -1 ) ) )
            END IF
            HSWORK = MAX( K*( K+2 ), 2*N )
            MAXWRK = MAX( MAXWRK, 1, HSWORK )
            IF( .NOT.WNTSNN )
     $         MAXWRK = MAX( MAXWRK, N*N+6*N )
         ELSE
            MINWRK = MAX( 1, 3*N )
            IF( ( .NOT.WNTSNN ) .AND. ( .NOT.WNTSNE ) )
     $         MINWRK = MAX( MINWRK, N*N+6*N )
            MAXB = MAX( ILAENV( 8, 'DHSEQR', 'SN', N, 1, N, -1 ), 2 )
            K = MIN( MAXB, N, MAX( 2, ILAENV( 4, 'DHSEQR', 'EN', N, 1,
     $          N, -1 ) ) )
            HSWORK = MAX( K*( K+2 ), 2*N )
            MAXWRK = MAX( MAXWRK, 1, HSWORK )
            MAXWRK = MAX( MAXWRK, N+( N-1 )*
     $               ILAENV( 1, 'DORGHR', ' ', N, 1, N, -1 ) )
            IF( ( .NOT.WNTSNN ) .AND. ( .NOT.WNTSNE ) )
     $         MAXWRK = MAX( MAXWRK, N*N+6*N )
            MAXWRK = MAX( MAXWRK, 3*N, 1 )
         END IF
         WORK( 1 ) = MAXWRK
      END IF
      IF( LWORK.LT.MINWRK .AND. .NOT.LQUERY ) THEN
         INFO = -21
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DGEEVX', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
*
*     Get machine constants
*
      EPS = DLAMCH( 'P' )
      SMLNUM = DLAMCH( 'S' )
      BIGNUM = ONE / SMLNUM
      CALL DLABAD( SMLNUM, BIGNUM )
      SMLNUM = SQRT( SMLNUM ) / EPS
      BIGNUM = ONE / SMLNUM
*
*     Scale A if max element outside range [SMLNUM,BIGNUM]
*
      ICOND = 0
      ANRM = DLANGE( 'M', N, N, A, LDA, DUM )
      SCALEA = .FALSE.
      IF( ANRM.GT.ZERO .AND. ANRM.LT.SMLNUM ) THEN
         SCALEA = .TRUE.
         CSCALE = SMLNUM
      ELSE IF( ANRM.GT.BIGNUM ) THEN
         SCALEA = .TRUE.
         CSCALE = BIGNUM
      END IF
      IF( SCALEA )
     $   CALL DLASCL( 'G', 0, 0, ANRM, CSCALE, N, N, A, LDA, IERR )
*
*     Balance the matrix and compute ABNRM
*
      CALL DGEBAL( BALANC, N, A, LDA, ILO, IHI, SCALE, IERR )
      ABNRM = DLANGE( '1', N, N, A, LDA, DUM )
      IF( SCALEA ) THEN
         DUM( 1 ) = ABNRM
         CALL DLASCL( 'G', 0, 0, CSCALE, ANRM, 1, 1, DUM, 1, IERR )
         ABNRM = DUM( 1 )
      END IF
*
*     Reduce to upper Hessenberg form
*     (Workspace: need 2*N, prefer N+N*NB)
*
      ITAU = 1
      IWRK = ITAU + N
      CALL DGEHRD( N, ILO, IHI, A, LDA, WORK( ITAU ), WORK( IWRK ),
     $             LWORK-IWRK+1, IERR )
*
      IF( WANTVL ) THEN
*
*        Want left eigenvectors
*        Copy Householder vectors to VL
*
         SIDE = 'L'
         CALL DLACPY( 'L', N, N, A, LDA, VL, LDVL )
*
*        Generate orthogonal matrix in VL
*        (Workspace: need 2*N-1, prefer N+(N-1)*NB)
*
         CALL DORGHR( N, ILO, IHI, VL, LDVL, WORK( ITAU ), WORK( IWRK ),
     $                LWORK-IWRK+1, IERR )
*
*        Perform QR iteration, accumulating Schur vectors in VL
*        (Workspace: need 1, prefer HSWORK (see comments) )
*
         IWRK = ITAU
         CALL DHSEQR( 'S', 'V', N, ILO, IHI, A, LDA, WR, WI, VL, LDVL,
     $                WORK( IWRK ), LWORK-IWRK+1, INFO )
*
         IF( WANTVR ) THEN
*
*           Want left and right eigenvectors
*           Copy Schur vectors to VR
*
            SIDE = 'B'
            CALL DLACPY( 'F', N, N, VL, LDVL, VR, LDVR )
         END IF
*
      ELSE IF( WANTVR ) THEN
*
*        Want right eigenvectors
*        Copy Householder vectors to VR
*
         SIDE = 'R'
         CALL DLACPY( 'L', N, N, A, LDA, VR, LDVR )
*
*        Generate orthogonal matrix in VR
*        (Workspace: need 2*N-1, prefer N+(N-1)*NB)
*
         CALL DORGHR( N, ILO, IHI, VR, LDVR, WORK( ITAU ), WORK( IWRK ),
     $                LWORK-IWRK+1, IERR )
*
*        Perform QR iteration, accumulating Schur vectors in VR
*        (Workspace: need 1, prefer HSWORK (see comments) )
*
         IWRK = ITAU
         CALL DHSEQR( 'S', 'V', N, ILO, IHI, A, LDA, WR, WI, VR, LDVR,
     $                WORK( IWRK ), LWORK-IWRK+1, INFO )
*
      ELSE
*
*        Compute eigenvalues only
*        If condition numbers desired, compute Schur form
*
         IF( WNTSNN ) THEN
            JOB = 'E'
         ELSE
            JOB = 'S'
         END IF
*
*        (Workspace: need 1, prefer HSWORK (see comments) )
*
         IWRK = ITAU
         CALL DHSEQR( JOB, 'N', N, ILO, IHI, A, LDA, WR, WI, VR, LDVR,
     $                WORK( IWRK ), LWORK-IWRK+1, INFO )
      END IF
*
*     If INFO > 0 from DHSEQR, then quit
*
      IF( INFO.GT.0 )
     $   GO TO 50
*
      IF( WANTVL .OR. WANTVR ) THEN
*
*        Compute left and/or right eigenvectors
*        (Workspace: need 3*N)
*
         CALL DTREVC( SIDE, 'B', SELECT, N, A, LDA, VL, LDVL, VR, LDVR,
     $                N, NOUT, WORK( IWRK ), IERR )
      END IF
*
*     Compute condition numbers if desired
*     (Workspace: need N*N+6*N unless SENSE = 'E')
*
      IF( .NOT.WNTSNN ) THEN
         CALL DTRSNA( SENSE, 'A', SELECT, N, A, LDA, VL, LDVL, VR, LDVR,
     $                RCONDE, RCONDV, N, NOUT, WORK( IWRK ), N, IWORK,
     $                ICOND )
      END IF
*
      IF( WANTVL ) THEN
*
*        Undo balancing of left eigenvectors
*
         CALL DGEBAK( BALANC, 'L', N, ILO, IHI, SCALE, N, VL, LDVL,
     $                IERR )
*
*        Normalize left eigenvectors and make largest component real
*
         DO 20 I = 1, N
            IF( WI( I ).EQ.ZERO ) THEN
               SCL = ONE / DNRM2( N, VL( 1, I ), 1 )
               CALL DSCAL( N, SCL, VL( 1, I ), 1 )
            ELSE IF( WI( I ).GT.ZERO ) THEN
               SCL = ONE / DLAPY2( DNRM2( N, VL( 1, I ), 1 ),
     $               DNRM2( N, VL( 1, I+1 ), 1 ) )
               CALL DSCAL( N, SCL, VL( 1, I ), 1 )
               CALL DSCAL( N, SCL, VL( 1, I+1 ), 1 )
               DO 10 K = 1, N
                  WORK( K ) = VL( K, I )**2 + VL( K, I+1 )**2
   10          CONTINUE
               K = IDAMAX( N, WORK, 1 )
               CALL DLARTG( VL( K, I ), VL( K, I+1 ), CS, SN, R )
               CALL DROT( N, VL( 1, I ), 1, VL( 1, I+1 ), 1, CS, SN )
               VL( K, I+1 ) = ZERO
            END IF
   20    CONTINUE
      END IF
*
      IF( WANTVR ) THEN
*
*        Undo balancing of right eigenvectors
*
         CALL DGEBAK( BALANC, 'R', N, ILO, IHI, SCALE, N, VR, LDVR,
     $                IERR )
*
*        Normalize right eigenvectors and make largest component real
*
         DO 40 I = 1, N
            IF( WI( I ).EQ.ZERO ) THEN
               SCL = ONE / DNRM2( N, VR( 1, I ), 1 )
               CALL DSCAL( N, SCL, VR( 1, I ), 1 )
            ELSE IF( WI( I ).GT.ZERO ) THEN
               SCL = ONE / DLAPY2( DNRM2( N, VR( 1, I ), 1 ),
     $               DNRM2( N, VR( 1, I+1 ), 1 ) )
               CALL DSCAL( N, SCL, VR( 1, I ), 1 )
               CALL DSCAL( N, SCL, VR( 1, I+1 ), 1 )
               DO 30 K = 1, N
                  WORK( K ) = VR( K, I )**2 + VR( K, I+1 )**2
   30          CONTINUE
               K = IDAMAX( N, WORK, 1 )
               CALL DLARTG( VR( K, I ), VR( K, I+1 ), CS, SN, R )
               CALL DROT( N, VR( 1, I ), 1, VR( 1, I+1 ), 1, CS, SN )
               VR( K, I+1 ) = ZERO
            END IF
   40    CONTINUE
      END IF
*
*     Undo scaling if necessary
*
   50 CONTINUE
      IF( SCALEA ) THEN
         CALL DLASCL( 'G', 0, 0, CSCALE, ANRM, N-INFO, 1, WR( INFO+1 ),
     $                MAX( N-INFO, 1 ), IERR )
         CALL DLASCL( 'G', 0, 0, CSCALE, ANRM, N-INFO, 1, WI( INFO+1 ),
     $                MAX( N-INFO, 1 ), IERR )
         IF( INFO.EQ.0 ) THEN
            IF( ( WNTSNV .OR. WNTSNB ) .AND. ICOND.EQ.0 )
     $         CALL DLASCL( 'G', 0, 0, CSCALE, ANRM, N, 1, RCONDV, N,
     $                      IERR )
         ELSE
            CALL DLASCL( 'G', 0, 0, CSCALE, ANRM, ILO-1, 1, WR, N,
     $                   IERR )
            CALL DLASCL( 'G', 0, 0, CSCALE, ANRM, ILO-1, 1, WI, N,
     $                   IERR )
         END IF
      END IF
*
      WORK( 1 ) = MAXWRK
      RETURN
*
*     End of DGEEVX
*
      END

C
C $Id: tdlbls.f,v 1.4 2008-07-27 00:17:32 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE TDLBLS (UMIN,VMIN,WMIN,UMAX,VMAX,WMAX,
     +                   UNLB,VNLB,WNLB,UILB,VILB,WILB,IPCK)
C
        CHARACTER*(*) UILB,VILB,WILB,UNLB,VNLB,WNLB
C
C This routine may be called to label the axes of the box in 3-space
C within which a surface is being drawn.  Its arguments are as follows:
C
C   UMIN, VMIN, WMIN, UMAX, VMAX, and WMAX are real input values, each
C   of which specifies one of the coordinate values defining the box in
C   3-space.  The names of these should make it clear what they are.
C
C   UNLB, VNLB, and WNLB are character strings containing numeric labels
C   to be placed on a U axis, a V axis, or a W axis, respectively.  The
C   labels need not be in any particular order, but they have to be
C   separated by blanks and each has to be readable using a FORTRAN
C   format of the form "En.0", where "n" is the length of the label.
C
C   UILB, VILB, and WILB are character strings containing informational
C   labels for a U axis, a V axis, or a W axis, respectively.
C
C   IPCK is an input integer determining which edges of the box are
C   labelled.  If IPCK is zero, all six outer edges are labelled, but
C   if IPCK is non-zero, only three edges are labelled, one set of
C   three if IPCK is negative, a different set if IPCK is positive.
C
C Declare required TDPACK common blocks.
C
        COMMON /TDCOM1/ IH,IT,XM,YM,ZM,XO,YO,ZO,XT,YT,ZT,OE,XE,YE,ZE
        COMMON /TDCOM1/ A1,B1,C1,D1,E1,A2,B2,C2,D2,E2,A3,B3,C3,D3,E3
        COMMON /TDCOM1/ IS,FV,VL,VR,VB,VT,WL,WR,WB,WT
        SAVE   /TDCOM1/
C
        COMMON /TDCOM4/ CSM1,CSM2
        SAVE   /TDCOM4/
C
C Declare two variables in which to put logical values indicating which
C axes are to be labelled.
C
        LOGICAL IPGZ,IPLZ
C
C Compute logical values indicating which axes are to be labelled.
C
        IPGZ=IPCK.GE.0
        IPLZ=IPCK.LE.0
C
C Compute the coordinates of the center point of the box.
C
        UMID=.5*(UMIN+UMAX)
        VMID=.5*(VMIN+VMAX)
        WMID=.5*(WMIN+WMAX)
C
C Set the combined character size multiplier.  Note that all character
C widths are stated as fractions of the smallest dimension of the box.
C
        CSM2=CSM1*MIN(UMAX-UMIN,VMAX-VMIN,WMAX-WMIN)
C
C Left-handed and right-handed systems need to be treated differently.
C In each case, what we do depends on where the viewpoint (the point
C midway between the eyes in the case of a stereo view) is relative to
C the center of the box.
C
        IF (IH.EQ.0) THEN
          IF      (XM.GT.UMID.AND.YM.GT.VMID.AND.ZM.GT.WMID) THEN
            CALL TDPARA (UMAX,VMIN,WMIN,0.,+1.,0.,-1.,0.,0.)
            IF (IPGZ) CALL TDLBLA (3,VILB,VNLB,VMIN,VMAX,UMAX,UMIN,  0.)
            IF (IPLZ) CALL TDLBLA (2,UILB,UNLB,VMIN,VMAX,UMAX,UMIN, 90.)
            CALL TDPARA (UMIN,VMIN,WMIN,0.,+1.,0.,0.,0.,+1.)
            IF (IPGZ) CALL TDLBLA (2,WILB,WNLB,VMIN,VMAX,WMIN,WMAX, 90.)
            IF (IPLZ) CALL TDLBLA (4,VILB,VNLB,VMIN,VMAX,WMIN,WMAX,  0.)
            CALL TDPARA (UMAX,VMIN,WMIN,-1.,0.,0.,0.,0.,+1.)
            IF (IPGZ) CALL TDLBLA (4,UILB,UNLB,UMAX,UMIN,WMIN,WMAX,  0.)
            IF (IPLZ) CALL TDLBLA (1,WILB,WNLB,UMAX,UMIN,WMIN,WMAX,-90.)
          ELSE IF (XM.LE.UMID.AND.YM.GT.VMID.AND.ZM.GT.WMID) THEN
            CALL TDPARA (UMAX,VMAX,WMIN,-1.,0.,0.,0.,-1.,0.)
            IF (IPGZ) CALL TDLBLA (3,UILB,UNLB,UMAX,UMIN,VMAX,VMIN,  0.)
            IF (IPLZ) CALL TDLBLA (2,VILB,VNLB,UMAX,UMIN,VMAX,VMIN, 90.)
            CALL TDPARA (UMAX,VMIN,WMIN,-1.,0.,0.,0.,0.,+1.)
            IF (IPGZ) CALL TDLBLA (2,WILB,WNLB,UMAX,UMIN,WMIN,WMAX, 90.)
            IF (IPLZ) CALL TDLBLA (4,UILB,UNLB,UMAX,UMIN,WMIN,WMAX,  0.)
            CALL TDPARA (UMAX,VMAX,WMIN,0.,-1.,0.,0.,0.,+1.)
            IF (IPGZ) CALL TDLBLA (4,VILB,VNLB,VMAX,VMIN,WMIN,WMAX,  0.)
            IF (IPLZ) CALL TDLBLA (1,WILB,WNLB,VMAX,VMIN,WMIN,WMAX,-90.)
          ELSE IF (XM.GT.UMID.AND.YM.LE.VMID.AND.ZM.GT.WMID) THEN
            CALL TDPARA (UMIN,VMIN,WMIN,+1.,0.,0.,0.,+1.,0.)
            IF (IPGZ) CALL TDLBLA (3,UILB,UNLB,UMIN,UMAX,VMIN,VMAX,  0.)
            IF (IPLZ) CALL TDLBLA (2,VILB,VNLB,UMIN,UMAX,VMIN,VMAX, 90.)
            CALL TDPARA (UMIN,VMAX,WMIN,+1.,0.,0.,0.,0.,+1.)
            IF (IPGZ) CALL TDLBLA (2,WILB,WNLB,UMIN,UMAX,WMIN,WMAX, 90.)
            IF (IPLZ) CALL TDLBLA (4,UILB,UNLB,UMIN,UMAX,WMIN,WMAX,  0.)
            CALL TDPARA (UMIN,VMIN,WMIN,0.,+1.,0.,0.,0.,+1.)
            IF (IPGZ) CALL TDLBLA (4,VILB,VNLB,VMIN,VMAX,WMIN,WMAX,  0.)
            IF (IPLZ) CALL TDLBLA (1,WILB,WNLB,VMIN,VMAX,WMIN,WMAX,-90.)
          ELSE IF (XM.LE.UMID.AND.YM.LE.VMID.AND.ZM.GT.WMID) THEN
            CALL TDPARA (UMIN,VMAX,WMIN,0.,-1.,0.,+1.,0.,0.)
            IF (IPGZ) CALL TDLBLA (3,VILB,VNLB,VMAX,VMIN,UMIN,UMAX,  0.)
            IF (IPLZ) CALL TDLBLA (2,UILB,UNLB,VMAX,VMIN,UMIN,UMAX, 90.)
            CALL TDPARA (UMAX,VMAX,WMIN,0.,-1.,0.,0.,0.,+1.)
            IF (IPGZ) CALL TDLBLA (2,WILB,WNLB,VMAX,VMIN,WMIN,WMAX, 90.)
            IF (IPLZ) CALL TDLBLA (4,VILB,VNLB,VMAX,VMIN,WMIN,WMAX,  0.)
            CALL TDPARA (UMIN,VMAX,WMIN,+1.,0.,0.,0.,0.,+1.)
            IF (IPGZ) CALL TDLBLA (4,UILB,UNLB,UMIN,UMAX,WMIN,WMAX,  0.)
            IF (IPLZ) CALL TDLBLA (1,WILB,WNLB,UMIN,UMAX,WMIN,WMAX,-90.)
          ELSE IF (XM.GT.UMID.AND.YM.GT.VMID.AND.ZM.LE.WMID) THEN
            CALL TDPARA (UMIN,VMIN,WMAX,0.,+1.,0.,+1.,0.,0.)
            IF (IPLZ) CALL TDLBLA (2,UILB,UNLB,VMIN,VMAX,UMIN,UMAX,-90.)
            IF (IPGZ) CALL TDLBLA (4,VILB,VNLB,VMIN,VMAX,UMIN,UMAX,  0.)
            CALL TDPARA (UMAX,VMIN,WMIN,-1.,0.,0.,0.,0.,+1.)
            IF (IPLZ) CALL TDLBLA (1,WILB,WNLB,UMAX,UMIN,WMIN,WMAX, 90.)
            IF (IPGZ) CALL TDLBLA (3,UILB,UNLB,UMAX,UMIN,WMIN,WMAX,  0.)
            CALL TDPARA (UMIN,VMIN,WMIN,0.,+1.,0.,0.,0.,+1.)
            IF (IPLZ) CALL TDLBLA (3,VILB,VNLB,VMIN,VMAX,WMIN,WMAX,  0.)
            IF (IPGZ) CALL TDLBLA (2,WILB,WNLB,VMIN,VMAX,WMIN,WMAX,-90.)
          ELSE IF (XM.LE.UMID.AND.YM.GT.VMID.AND.ZM.LE.WMID) THEN
            CALL TDPARA (UMAX,VMIN,WMAX,-1.,0.,0.,0.,+1.,0.)
            IF (IPLZ) CALL TDLBLA (2,VILB,VNLB,UMAX,UMIN,VMIN,VMAX,-90.)
            IF (IPGZ) CALL TDLBLA (4,UILB,UNLB,UMAX,UMIN,VMIN,VMAX,  0.)
            CALL TDPARA (UMAX,VMAX,WMIN,0.,-1.,0.,0.,0.,+1.)
            IF (IPLZ) CALL TDLBLA (1,WILB,WNLB,VMAX,VMIN,WMIN,WMAX, 90.)
            IF (IPGZ) CALL TDLBLA (3,VILB,VNLB,VMAX,VMIN,WMIN,WMAX,  0.)
            CALL TDPARA (UMAX,VMIN,WMIN,-1.,0.,0.,0.,0.,+1.)
            IF (IPLZ) CALL TDLBLA (3,UILB,UNLB,UMAX,UMIN,WMIN,WMAX,  0.)
            IF (IPGZ) CALL TDLBLA (2,WILB,WNLB,UMAX,UMIN,WMIN,WMAX,-90.)
          ELSE IF (XM.GT.UMID.AND.YM.LE.VMID.AND.ZM.LE.WMID) THEN
            CALL TDPARA (UMIN,VMAX,WMAX,+1.,0.,0.,0.,-1.,0.)
            IF (IPLZ) CALL TDLBLA (2,VILB,VNLB,UMIN,UMAX,VMAX,VMIN,-90.)
            IF (IPGZ) CALL TDLBLA (4,UILB,UNLB,UMIN,UMAX,VMAX,VMIN,  0.)
            CALL TDPARA (UMIN,VMIN,WMIN,0.,+1.,0.,0.,0.,+1.)
            IF (IPLZ) CALL TDLBLA (1,WILB,WNLB,VMIN,VMAX,WMIN,WMAX, 90.)
            IF (IPGZ) CALL TDLBLA (3,VILB,VNLB,VMIN,VMAX,WMIN,WMAX,  0.)
            CALL TDPARA (UMIN,VMAX,WMIN,+1.,0.,0.,0.,0.,+1.)
            IF (IPLZ) CALL TDLBLA (3,UILB,UNLB,UMIN,UMAX,WMIN,WMAX,  0.)
            IF (IPGZ) CALL TDLBLA (2,WILB,WNLB,UMIN,UMAX,WMIN,WMAX,-90.)
          ELSE IF (XM.LE.UMID.AND.YM.LE.VMID.AND.ZM.LE.WMID) THEN
            CALL TDPARA (UMAX,VMAX,WMAX,0.,-1.,0.,-1.,0.,0.)
            IF (IPLZ) CALL TDLBLA (2,UILB,UNLB,VMAX,VMIN,UMAX,UMIN,-90.)
            IF (IPGZ) CALL TDLBLA (4,VILB,VNLB,VMAX,VMIN,UMAX,UMIN,  0.)
            CALL TDPARA (UMIN,VMAX,WMIN,+1.,0.,0.,0.,0.,+1.)
            IF (IPLZ) CALL TDLBLA (1,WILB,WNLB,UMIN,UMAX,WMIN,WMAX, 90.)
            IF (IPGZ) CALL TDLBLA (3,UILB,UNLB,UMIN,UMAX,WMIN,WMAX,  0.)
            CALL TDPARA (UMAX,VMAX,WMIN,0.,-1.,0.,0.,0.,+1.)
            IF (IPLZ) CALL TDLBLA (3,VILB,VNLB,VMAX,VMIN,WMIN,WMAX,  0.)
            IF (IPGZ) CALL TDLBLA (2,WILB,WNLB,VMAX,VMIN,WMIN,WMAX,-90.)
          END IF
        ELSE
          IF      (XM.GT.UMID.AND.YM.GT.VMID.AND.ZM.GT.WMID) THEN
            CALL TDPARA (UMAX,VMIN,WMIN,-1.,0.,0.,0.,+1.,0.)
            IF (IPLZ) CALL TDLBLA (1,VILB,VNLB,UMAX,UMIN,VMIN,VMAX,-90.)
            IF (IPGZ) CALL TDLBLA (4,UILB,UNLB,UMAX,UMIN,VMIN,VMAX,180.)
            CALL TDPARA (UMIN,VMIN,WMIN,0.,0.,+1.,0.,+1.,0.)
            IF (IPLZ) CALL TDLBLA (4,WILB,WNLB,WMIN,WMAX,VMIN,VMAX,180.)
            IF (IPGZ) CALL TDLBLA (2,VILB,VNLB,WMIN,WMAX,VMIN,VMAX,-90.)
            CALL TDPARA (UMAX,VMIN,WMIN,0.,0.,+1.,-1.,0.,0.)
            IF (IPLZ) CALL TDLBLA (2,UILB,UNLB,WMIN,WMAX,UMAX,UMIN,-90.)
            IF (IPGZ) CALL TDLBLA (3,WILB,WNLB,WMIN,WMAX,UMAX,UMIN,  0.)
          ELSE IF (XM.LE.UMID.AND.YM.GT.VMID.AND.ZM.GT.WMID) THEN
            CALL TDPARA (UMAX,VMAX,WMIN,0.,-1.,0.,-1.,0.,0.)
            IF (IPLZ) CALL TDLBLA (1,UILB,UNLB,VMAX,VMIN,UMAX,UMIN,-90.)
            IF (IPGZ) CALL TDLBLA (4,VILB,VNLB,VMAX,VMIN,UMAX,UMIN,180.)
            CALL TDPARA (UMAX,VMIN,WMIN,0.,0.,+1.,-1.,0.,0.)
            IF (IPLZ) CALL TDLBLA (4,WILB,WNLB,WMIN,WMAX,UMAX,UMIN,180.)
            IF (IPGZ) CALL TDLBLA (2,UILB,UNLB,WMIN,WMAX,UMAX,UMIN,-90.)
            CALL TDPARA (UMAX,VMAX,WMIN,0.,0.,+1.,0.,-1.,0.)
            IF (IPLZ) CALL TDLBLA (2,VILB,VNLB,WMIN,WMAX,VMAX,VMIN,-90.)
            IF (IPGZ) CALL TDLBLA (3,WILB,WNLB,WMIN,WMAX,VMAX,VMIN,  0.)
          ELSE IF (XM.GT.UMID.AND.YM.LE.VMID.AND.ZM.GT.WMID) THEN
            CALL TDPARA (UMIN,VMIN,WMIN,0.,+1.,0.,+1.,0.,0.)
            IF (IPLZ) CALL TDLBLA (1,UILB,UNLB,VMIN,VMAX,UMIN,UMAX,-90.)
            IF (IPGZ) CALL TDLBLA (4,VILB,VNLB,VMIN,VMAX,UMIN,UMAX,180.)
            CALL TDPARA (UMIN,VMAX,WMIN,0.,0.,+1.,+1.,0.,0.)
            IF (IPLZ) CALL TDLBLA (4,WILB,WNLB,WMIN,WMAX,UMIN,UMAX,180.)
            IF (IPGZ) CALL TDLBLA (2,UILB,UNLB,WMIN,WMAX,UMIN,UMAX,-90.)
            CALL TDPARA (UMIN,VMIN,WMIN,0.,0.,+1.,0.,+1.,0.)
            IF (IPLZ) CALL TDLBLA (2,VILB,VNLB,WMIN,WMAX,VMIN,VMAX,-90.)
            IF (IPGZ) CALL TDLBLA (3,WILB,WNLB,WMIN,WMAX,VMIN,VMAX,  0.)
          ELSE IF (XM.LE.UMID.AND.YM.LE.VMID.AND.ZM.GT.WMID) THEN
            CALL TDPARA (UMIN,VMAX,WMIN,+1.,0.,0.,0.,-1.,0.)
            IF (IPLZ) CALL TDLBLA (1,VILB,VNLB,UMIN,UMAX,VMAX,VMIN,-90.)
            IF (IPGZ) CALL TDLBLA (4,UILB,UNLB,UMIN,UMAX,VMAX,VMIN,180.)
            CALL TDPARA (UMAX,VMAX,WMIN,0.,0.,+1.,0.,-1.,0.)
            IF (IPLZ) CALL TDLBLA (4,WILB,WNLB,WMIN,WMAX,VMAX,VMIN,180.)
            IF (IPGZ) CALL TDLBLA (2,VILB,VNLB,WMIN,WMAX,VMAX,VMIN,-90.)
            CALL TDPARA (UMIN,VMAX,WMIN,0.,0.,+1.,+1.,0.,0.)
            IF (IPLZ) CALL TDLBLA (2,UILB,UNLB,WMIN,WMAX,UMIN,UMAX,-90.)
            IF (IPGZ) CALL TDLBLA (3,WILB,WNLB,WMIN,WMAX,UMIN,UMAX,  0.)
          ELSE IF (XM.GT.UMID.AND.YM.GT.VMID.AND.ZM.LE.WMID) THEN
            CALL TDPARA (UMIN,VMIN,WMAX,+1.,0.,0.,0.,+1.,0.)
            IF (IPGZ) CALL TDLBLA (4,UILB,UNLB,UMIN,UMAX,VMIN,VMAX,  0.)
            IF (IPLZ) CALL TDLBLA (2,VILB,VNLB,UMIN,UMAX,VMIN,VMAX,-90.)
            CALL TDPARA (UMAX,VMIN,WMIN,0.,0.,+1.,-1.,0.,0.)
            IF (IPGZ) CALL TDLBLA (3,WILB,WNLB,WMIN,WMAX,UMAX,UMIN,180.)
            IF (IPLZ) CALL TDLBLA (1,UILB,UNLB,WMIN,WMAX,UMAX,UMIN,-90.)
            CALL TDPARA (UMIN,VMIN,WMIN,0.,0.,+1.,0.,+1.,0.)
            IF (IPGZ) CALL TDLBLA (1,VILB,VNLB,WMIN,WMAX,VMIN,VMAX,-90.)
            IF (IPLZ) CALL TDLBLA (4,WILB,WNLB,WMIN,WMAX,VMIN,VMAX,  0.)
          ELSE IF (XM.LE.UMID.AND.YM.GT.VMID.AND.ZM.LE.WMID) THEN
            CALL TDPARA (UMAX,VMIN,WMAX,0.,+1.,0.,-1.,0.,0.)
            IF (IPGZ) CALL TDLBLA (4,VILB,VNLB,VMIN,VMAX,UMAX,UMIN,  0.)
            IF (IPLZ) CALL TDLBLA (2,UILB,UNLB,VMIN,VMAX,UMAX,UMIN,-90.)
            CALL TDPARA (UMAX,VMAX,WMIN,0.,0.,+1.,0.,-1.,0.)
            IF (IPGZ) CALL TDLBLA (3,WILB,WNLB,WMIN,WMAX,VMAX,VMIN,180.)
            IF (IPLZ) CALL TDLBLA (1,VILB,VNLB,WMIN,WMAX,VMAX,VMIN,-90.)
            CALL TDPARA (UMAX,VMIN,WMIN,0.,0.,+1.,-1.,0.,0.)
            IF (IPGZ) CALL TDLBLA (1,UILB,UNLB,WMIN,WMAX,UMAX,UMIN,-90.)
            IF (IPLZ) CALL TDLBLA (4,WILB,WNLB,WMIN,WMAX,UMAX,UMIN,  0.)
          ELSE IF (XM.GT.UMID.AND.YM.LE.VMID.AND.ZM.LE.WMID) THEN
            CALL TDPARA (UMIN,VMAX,WMAX,0.,-1.,0.,+1.,0.,0.)
            IF (IPGZ) CALL TDLBLA (4,VILB,VNLB,VMAX,VMIN,UMIN,UMAX,  0.)
            IF (IPLZ) CALL TDLBLA (2,UILB,UNLB,VMAX,VMIN,UMIN,UMAX,-90.)
            CALL TDPARA (UMIN,VMIN,WMIN,0.,0.,+1.,0.,+1.,0.)
            IF (IPGZ) CALL TDLBLA (3,WILB,WNLB,WMIN,WMAX,VMIN,VMAX,180.)
            IF (IPLZ) CALL TDLBLA (1,VILB,VNLB,WMIN,WMAX,VMIN,VMAX,-90.)
            CALL TDPARA (UMIN,VMAX,WMIN,0.,0.,+1.,+1.,0.,0.)
            IF (IPGZ) CALL TDLBLA (1,UILB,UNLB,WMIN,WMAX,UMIN,UMAX,-90.)
            IF (IPLZ) CALL TDLBLA (4,WILB,WNLB,WMIN,WMAX,UMIN,UMAX,  0.)
          ELSE IF (XM.LE.UMID.AND.YM.LE.VMID.AND.ZM.LE.WMID) THEN
            CALL TDPARA (UMAX,VMAX,WMAX,-1.,0.,0.,0.,-1.,0.)
            IF (IPGZ) CALL TDLBLA (4,UILB,UNLB,UMAX,UMIN,VMAX,VMIN,  0.)
            IF (IPLZ) CALL TDLBLA (2,VILB,VNLB,UMAX,UMIN,VMAX,VMIN,-90.)
            CALL TDPARA (UMIN,VMAX,WMIN,0.,0.,+1.,+1.,0.,0.)
            IF (IPGZ) CALL TDLBLA (3,WILB,WNLB,WMIN,WMAX,UMIN,UMAX,180.)
            IF (IPLZ) CALL TDLBLA (1,UILB,UNLB,WMIN,WMAX,UMIN,UMAX,-90.)
            CALL TDPARA (UMAX,VMAX,WMIN,0.,0.,+1.,0.,-1.,0.)
            IF (IPGZ) CALL TDLBLA (1,VILB,VNLB,WMIN,WMAX,VMAX,VMIN,-90.)
            IF (IPLZ) CALL TDLBLA (4,WILB,WNLB,WMIN,WMAX,VMAX,VMIN,  0.)
          END IF
        END IF
C
C Done.
C
        RETURN
C
      END

      SUBROUTINE ZUNGR2( M, N, K, A, LDA, TAU, WORK, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      INTEGER            INFO, K, LDA, M, N
*     ..
*     .. Array Arguments ..
      COMPLEX*16         A( LDA, * ), TAU( * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  ZUNGR2 generates an m by n complex matrix Q with orthonormal rows,
*  which is defined as the last m rows of a product of k elementary
*  reflectors of order n
*
*        Q  =  H(1)' H(2)' . . . H(k)'
*
*  as returned by ZGERQF.
*
*  Arguments
*  =========
*
*  M       (input) INTEGER
*          The number of rows of the matrix Q. M >= 0.
*
*  N       (input) INTEGER
*          The number of columns of the matrix Q. N >= M.
*
*  K       (input) INTEGER
*          The number of elementary reflectors whose product defines the
*          matrix Q. M >= K >= 0.
*
*  A       (input/output) COMPLEX*16 array, dimension (LDA,N)
*          On entry, the (m-k+i)-th row must contain the vector which
*          defines the elementary reflector H(i), for i = 1,2,...,k, as
*          returned by ZGERQF in the last k rows of its array argument
*          A.
*          On exit, the m-by-n matrix Q.
*
*  LDA     (input) INTEGER
*          The first dimension of the array A. LDA >= max(1,M).
*
*  TAU     (input) COMPLEX*16 array, dimension (K)
*          TAU(i) must contain the scalar factor of the elementary
*          reflector H(i), as returned by ZGERQF.
*
*  WORK    (workspace) COMPLEX*16 array, dimension (M)
*
*  INFO    (output) INTEGER
*          = 0: successful exit
*          < 0: if INFO = -i, the i-th argument has an illegal value
*
*  =====================================================================
*
*     .. Parameters ..
      COMPLEX*16         ONE, ZERO
      PARAMETER          ( ONE = ( 1.0D+0, 0.0D+0 ),
     $                   ZERO = ( 0.0D+0, 0.0D+0 ) )
*     ..
*     .. Local Scalars ..
      INTEGER            I, II, J, L
*     ..
*     .. External Subroutines ..
      EXTERNAL           XERBLA, ZLACGV, ZLARF, ZSCAL
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          DCONJG, MAX
*     ..
*     .. Executable Statements ..
*
*     Test the input arguments
*
      INFO = 0
      IF( M.LT.0 ) THEN
         INFO = -1
      ELSE IF( N.LT.M ) THEN
         INFO = -2
      ELSE IF( K.LT.0 .OR. K.GT.M ) THEN
         INFO = -3
      ELSE IF( LDA.LT.MAX( 1, M ) ) THEN
         INFO = -5
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'ZUNGR2', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( M.LE.0 )
     $   RETURN
*
      IF( K.LT.M ) THEN
*
*        Initialise rows 1:m-k to rows of the unit matrix
*
         DO 20 J = 1, N
            DO 10 L = 1, M - K
               A( L, J ) = ZERO
   10       CONTINUE
            IF( J.GT.N-M .AND. J.LE.N-K )
     $         A( M-N+J, J ) = ONE
   20    CONTINUE
      END IF
*
      DO 40 I = 1, K
         II = M - K + I
*
*        Apply H(i)' to A(1:m-k+i,1:n-k+i) from the right
*
         CALL ZLACGV( N-M+II-1, A( II, 1 ), LDA )
         A( II, N-M+II ) = ONE
         CALL ZLARF( 'Right', II-1, N-M+II, A( II, 1 ), LDA,
     $               DCONJG( TAU( I ) ), A, LDA, WORK )
         CALL ZSCAL( N-M+II-1, -TAU( I ), A( II, 1 ), LDA )
         CALL ZLACGV( N-M+II-1, A( II, 1 ), LDA )
         A( II, N-M+II ) = ONE - DCONJG( TAU( I ) )
*
*        Set A(m-k+i,n-k+i+1:n) to zero
*
         DO 30 L = N - M + II + 1, N
            A( II, L ) = ZERO
   30    CONTINUE
   40 CONTINUE
      RETURN
*
*     End of ZUNGR2
*
      END

      SUBROUTINE ZLAR2V( N, X, Y, Z, INCX, C, S, INCC )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     February 29, 1992
*
*     .. Scalar Arguments ..
      INTEGER            INCC, INCX, N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   C( * )
      COMPLEX*16         S( * ), X( * ), Y( * ), Z( * )
*     ..
*
*  Purpose
*  =======
*
*  ZLAR2V applies a vector of complex plane rotations with real cosines
*  from both sides to a sequence of 2-by-2 complex Hermitian matrices,
*  defined by the elements of the vectors x, y and z. For i = 1,2,...,n
*
*     (       x(i)  z(i) ) :=
*     ( conjg(z(i)) y(i) )
*
*       (  c(i) conjg(s(i)) ) (       x(i)  z(i) ) ( c(i) -conjg(s(i)) )
*       ( -s(i)       c(i)  ) ( conjg(z(i)) y(i) ) ( s(i)        c(i)  )
*
*  Arguments
*  =========
*
*  N       (input) INTEGER
*          The number of plane rotations to be applied.
*
*  X       (input/output) COMPLEX*16 array, dimension (1+(N-1)*INCX)
*          The vector x; the elements of x are assumed to be real.
*
*  Y       (input/output) COMPLEX*16 array, dimension (1+(N-1)*INCX)
*          The vector y; the elements of y are assumed to be real.
*
*  Z       (input/output) COMPLEX*16 array, dimension (1+(N-1)*INCX)
*          The vector z.
*
*  INCX    (input) INTEGER
*          The increment between elements of X, Y and Z. INCX > 0.
*
*  C       (input) DOUBLE PRECISION array, dimension (1+(N-1)*INCC)
*          The cosines of the plane rotations.
*
*  S       (input) COMPLEX*16 array, dimension (1+(N-1)*INCC)
*          The sines of the plane rotations.
*
*  INCC    (input) INTEGER
*          The increment between elements of C and S. INCC > 0.
*
*  =====================================================================
*
*     .. Local Scalars ..
      INTEGER            I, IC, IX
      DOUBLE PRECISION   CI, SII, SIR, T1I, T1R, T5, T6, XI, YI, ZII,
     $                   ZIR
      COMPLEX*16         SI, T2, T3, T4, ZI
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          DBLE, DCMPLX, DCONJG, DIMAG
*     ..
*     .. Executable Statements ..
*
      IX = 1
      IC = 1
      DO 10 I = 1, N
         XI = DBLE( X( IX ) )
         YI = DBLE( Y( IX ) )
         ZI = Z( IX )
         ZIR = DBLE( ZI )
         ZII = DIMAG( ZI )
         CI = C( IC )
         SI = S( IC )
         SIR = DBLE( SI )
         SII = DIMAG( SI )
         T1R = SIR*ZIR - SII*ZII
         T1I = SIR*ZII + SII*ZIR
         T2 = CI*ZI
         T3 = T2 - DCONJG( SI )*XI
         T4 = DCONJG( T2 ) + SI*YI
         T5 = CI*XI + T1R
         T6 = CI*YI - T1R
         X( IX ) = CI*T5 + ( SIR*DBLE( T4 )+SII*DIMAG( T4 ) )
         Y( IX ) = CI*T6 - ( SIR*DBLE( T3 )-SII*DIMAG( T3 ) )
         Z( IX ) = CI*T3 + DCONJG( SI )*DCMPLX( T6, T1I )
         IX = IX + INCX
         IC = IC + INCC
   10 CONTINUE
      RETURN
*
*     End of ZLAR2V
*
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C   FFTPACK 5.0
C   Copyright (C) 1995-2004, Scientific Computing Division,
C   University Corporation for Atmospheric Research
C   Licensed under the GNU General Public License (GPL)
C
C   Authors:  Paul N. Swarztrauber and Richard A. Valent
C
C   $Id: rfft2i.f,v 1.2 2006-11-21 01:10:19 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      SUBROUTINE DRFFT2I(L,M,WSAVE,LENSAV,IER)
      INTEGER L,M,LENSAV,IER
      INTEGER LWSAV,MWSAV
      DOUBLE PRECISION WSAVE(LENSAV)
C
C Initialize IER
C
      IER = 0
C
C Verify LENSAV
C
      LWSAV = L + INT(LOG(DBLE(L))) + 4
      MWSAV = 2*M + INT(LOG(DBLE(M))) + 4
      IF (LENSAV.LT.LWSAV+MWSAV) THEN
          IER = 2
          CALL DXERFFT('RFFT2I',4)
          GO TO 100
      END IF
C
      CALL DRFFTMI(L,WSAVE(1),L+INT(LOG(DBLE(L)))+4,IER1)
      IF (IER1.NE.0) THEN
          IER = 20
          CALL DXERFFT('RFFT2I',-5)
          GO TO 100
      END IF
      CALL DCFFTMI(M,WSAVE(L+INT(LOG(DBLE(L)))+5),
     +            2*M+INT(LOG(DBLE(M)))+4,IER1)
      IF (IER1.NE.0) THEN
          IER = 20
          CALL DXERFFT('RFFT2I',-5)
      END IF
C
  100 CONTINUE
      RETURN
      END

C
C $Id: dpdraw.f,v 1.13 2008-07-27 00:16:58 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE DPDRAW (XCPF,YCPF,IFVL)
C
C DPDRAW is the workhorse routine of DASHPACK.  When IFVL is less than
C or equal to zero, a "first point" call is implied: (XCPF,YCPF) is a
C point in the fractional system at which a curve is to begin.  When
C IFVL is equal to one, a "vector" call is implied: (XCPF,YCPF) is a
C point in the fractional system to which the curve is to be extended.
C When IFVL is greater than or equal to two, a "last point" call is
C implied: the values of XCPF and YCPF are ignored, and all buffered
C information about the curve being drawn is flushed out.
C
C Actually, DPDRAW is more forgiving than that:  If a "first point"
C call is omitted, the first "vector" call will act instead like a
C "first point" call.  If a "last point" call is omitted, the next
C "first point" call will cause buffer-flushing before the new curve
C is started.  (Still, it is best to use a "first point" call, followed
C by a series of "vector" calls, followed by a "last point" call, to
C draw a curve.)
C
C Define the lengths of the arrays that hold the individual elements
C of the dash pattern.  (LDPA should be equal to the length of the
C character variable CHDP, in the common block DPCMCH.)
C
        PARAMETER (LDPA=256)
C
C Define the lengths of the arrays that are used to delay processing of
C contiguous character strings.  (While the gap for a character string
C is being passed over, curve points and character-string descriptors
C are saved; if it turns out that there is enough space to hold the
C character strings, they are drawn; otherwise, the saved curve points
C are used to draw the curve using nothing but gap segments and solid
C segments.  LPSB determines how many curve points can be saved and
C LSSB how many character-string elements can be saved.)
C
        PARAMETER (LPSB=256,LSSB=LDPA)
C
C Declare the character common block.
C
        COMMON /DPCMCH/ CHDP,CHRB,CHRG,CHRS
          CHARACTER*256 CHDP
          CHARACTER*1 CHRB,CHRG,CHRS
        SAVE   /DPCMCH/
C
C Declare the real/integer common block.
C
        COMMON /DPCMRI/ ANGF,DBPI,EPSI,IDPI,IDPS,ILTL,INDP,IPCF,ISBF,
     +                  ISCF,LCDP,RLS1,RLS2,RMFS,TENS,WCHR,WGAP,WSLD
        SAVE   /DPCMRI/
C
C Declare the arrays that are used to hold the descriptors of the
C constituent elements of the dash pattern.  For a value of I between
C 1 and NDPE, IDPE(I) will be -1 for a gap in which no characters will
C be written, 0 for a solid-line chunk, and greater than 0 for a gap
C in which characters will be written (in which case it contains either
C a +1, indicating the little gap that precedes or follows a label, or
C the packed indices of the character substring to be written); RDPE(I)
C is the length of line to be devoted to the element.
C
        DIMENSION IDPE(LDPA),RDPE(LDPA)
C
C Declare arrays that are used to delay processing of character strings
C (which is done to avoid outputting a partial string at the end of a
C curve).  The first two of these are used to save point-coordinate
C information and the remaining four are used to save character-string
C information.
C
        DIMENSION RSPX(LPSB),RSPY(LPSB)
C
        DIMENSION ISSP(LSSB),RSSA(LSSB),RSSX(LSSB),RSSY(LSSB)
C
C Declare a couple of character temporaries to use.
C
        CHARACTER*1 CHRL,CHRN
C
C Declare variables to receive the current window and viewport.
C
        DIMENSION WNDW(4),VPRT(4)
C
C Declare local variables to be saved from one call to the next.  The
C meanings of the mnemonics are as follows: "ICPE" stands for "Index of
C Current Pattern Element", "IDPE" for "Integer parts of Dash Pattern
C Elements", "IDST" for "Integer Drawing STatus",  "IFPF" for "Integer
C Fast-Path Flag", "ISSP" for "Integer Saved-String Pointers", "NBCS"
C for "Number of Break Characters Seen (in a particular dash pattern)",
C "NDPE" for "Number of Dash Pattern Elements", "NPSB" for "Number of
C Points in Save Buffer", "NSSB" for "Number of Strings in Save Buffer",
C "RDPE" for "Real parts of Dash Pattern Elements", "RSPX" for "Real
C Saved Point X's", "RSPY" for "Real Saved Point Y's", "RSSA" for "Real
C Saved String Angles", "RSSX" for "Real Saved String X's", "RSSY" for
C "Real Saved String Y's", "WCPE" for "Width of Current Pattern
C Element", "XCGF" for "X Coordinate at start of Gap, Fractional
C system", "XCLF" for "X Coordinate of Last point, Fractional system",
C "YCGF" for "Y Coordinate at start of Gap, Fractional system", and
C "YCLF" for "Y Coordinate of Last point, Fractional system".
C
        SAVE ICPE,IDPE,IDST,IFPF,ISSP,NBCS,NDPE,NPSB,NSSB,RDPE,
     +       RSPX,RSPY,RSSA,RSSX,RSSY,WCPE,XCGF,XCLF,YCGF,YCLF
C
C Initialize local variables that need it.  IDST is 0 when DPDRAW is
C expecting a first point, 1 when it's expecting the first continuation
C point, and 2 when it's expecting another continuation point or the
C last-point call.  NPSB and NSSB are the number of items in the
C point-save and string-save buffers, respectively.
C
        DATA IDST / 0  /
C
        DATA NPSB / 0  /
C
        DATA NSSB / 0  /
C
C Define a multiplicative constant to get from radians to degrees.
C
        DATA RTOD / 57.2957795130823 /
C
C Do a call forcing a BLOCKDATA to be loaded from a binary library.
C
        CALL DPBLDA
C
C Check for an uncleared prior error.
C
        IF (ICFELL('DPDRAW - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C If the current dash pattern has never been decomposed into its
C constituent elements (or if that has not been done since the last
C time some descriptor of the dash pattern was changed) and this call
C is not just a buffer-dump call, do that now.
C
        IF (IDPI.EQ.0.AND.IFVL.LT.2) THEN
C
C Initialize the number of dash-pattern elements found and the number
C of break characters seen.
C
          NDPE=0
          NBCS=0
C
C If IDPS is less than zero, use the integer dash pattern.
C
          IF (IDPS.LT.0) THEN
C
            NBTS=ABS(IDPS)
            LBIT=1-IAND(ISHIFT(INDP,1-NBTS),1)
C
            DO 101 I=1,NBTS
C
              IBIT=IAND(ISHIFT(INDP,I-NBTS),1)
C
              IF (IBIT.NE.LBIT) THEN
                IF (NDPE.GE.LDPA) GO TO 105
                NDPE=NDPE+1
                IDPE(NDPE)=IBIT-1
                RDPE(NDPE)=0.
              END IF
C
              IF (IBIT.EQ.0) THEN
                RDPE(NDPE)=RDPE(NDPE)+WGAP
              ELSE
                RDPE(NDPE)=RDPE(NDPE)+WSLD
              END IF
C
              LBIT=IBIT
C
  101       CONTINUE
C
C Otherwise, use the character dash pattern.
C
          ELSE
C
            NCHR=IDPS
            IF (NCHR.EQ.0) NCHR=LCDP
C
            CHRN=CHDP(1:1)
C
            CHRL=CHRG
            IF (CHRL.EQ.CHRN) CHRL=CHRS
C
C Initially, generate the descriptors of the dash-pattern elements
C assuming that PLCHMQ or PLCHLQ will be used.
C
            DO 102 I=1,NCHR
C
              IF (CHRN.EQ.CHRG) THEN
C
                IF (CHRL.NE.CHRG) THEN
                  IF (NDPE.GE.LDPA) GO TO 103
                  NDPE=NDPE+1
                  IDPE(NDPE)=-1
                  RDPE(NDPE)=0.
                END IF
C
                RDPE(NDPE)=RDPE(NDPE)+WGAP
C
              ELSE IF (CHRN.EQ.CHRS) THEN
C
                IF (CHRL.NE.CHRS) THEN
                  IF (NDPE.GE.LDPA) GO TO 103
                  NDPE=NDPE+1
                  IDPE(NDPE)=0
                  RDPE(NDPE)=0.
                END IF
C
                RDPE(NDPE)=RDPE(NDPE)+WSLD
C
              ELSE IF (CHRN.NE.CHRB) THEN
C
                IF (CHRL.EQ.CHRB.OR.CHRL.EQ.CHRG.OR.CHRL.EQ.CHRS.OR.
     +              ICHAR(CHRL).GT.127.OR.ICHAR(CHRN).GT.127) THEN
C
                  IF (CHRL.EQ.CHRG.OR.CHRL.EQ.CHRS.OR.
     +                ICHAR(CHRL).GT.127.OR.ICHAR(CHRN).GT.127) THEN
                    IF (RLS1.NE.0..OR.
     +                  ICHAR(CHRL).GT.127.OR.ICHAR(CHRN).GT.127) THEN
                      IF (NDPE.GE.LDPA) GO TO 103
                      NDPE=NDPE+1
                      IDPE(NDPE)=+1
                      RDPE(NDPE)=MAX(.01,RLS1)*WCHR
                    END IF
                  END IF
C
                  IF (NDPE.GE.LDPA) GO TO 103
                  NDPE=NDPE+1
                  IDPE(NDPE)=LDPA*I+I-1
                  RDPE(NDPE)=RLS2*WCHR
C
                END IF
C
                IDPE(NDPE)=IDPE(NDPE)+1
                RDPE(NDPE)=RDPE(NDPE)+WCHR
C
                IF (ISCF.NE.0.AND.ICHAR(CHRN).LT.128) CHRN=CHRB
C
              ELSE
C
                NBCS=NBCS+1
C
              END IF
C
              CHRL=CHRN
C
              IF (I.NE.NCHR) THEN
                CHRN=CHDP(I+1:I+1)
              ELSE
                CHRN=CHRG
              END IF
C
              IF ((CHRN.EQ.CHRG.OR.CHRN.EQ.CHRS).AND.NDPE.NE.0) THEN
C
                IF (IDPE(NDPE).GT.1.AND.RLS1.NE.0.) THEN
                  IF (NDPE.GE.LDPA) GO TO 103
                  NDPE=NDPE+1
                  IDPE(NDPE)=+1
                  RDPE(NDPE)=MAX(.01,RLS1)*WCHR
                END IF
C
              END IF
C
  102       CONTINUE
C
C If there were nothing but break characters in the dash pattern, use a
C solid line.
C
  103       IF (NDPE.EQ.0) THEN
              NDPE=1
              IDPE(1)=0
              RDPE(1)=1.
            END IF
C
C If PLCHHQ is to be used, post-process the list to compute correct gap
C lengths for character-string elements; gap lengths for symbols are not
C recomputed.
C
            IF (IPCF.EQ.0) THEN
C
              CALL PCGETI ('TE - TEXT EXTENT COMPUTATION FLAG',ITEF)
              IF (ICFELL('DPDRAW',2).NE.0) RETURN
C
              CALL PCSETI ('TE - TEXT EXTENT COMPUTATION FLAG',1)
              IF (ICFELL('DPDRAW',3).NE.0) RETURN
C
              DO 104 I=1,NDPE
C
                IF (IDPE(I).GT.1) THEN
C
                  IFCH=IDPE(I)/LDPA
                  ILCH=MOD(IDPE(I),LDPA)
C
                  IF (ICHAR(CHDP(IFCH:IFCH)).LE.127) THEN
C
                    CALL PLCHHQ (CFUX(.5),CFUY(.5),CHDP(IFCH:ILCH),
     +                                                WCHR,360.,0.)
                    IF (ICFELL('DPDRAW',4).NE.0) RETURN
C
                    CALL PCGETR ('XB - X COORDINATE AT BEGINNING',XBEG)
                    IF (ICFELL('DPDRAW',5).NE.0) RETURN
C
                    CALL PCGETR ('XE - X COORDINATE AT END',XEND)
                    IF (ICFELL('DPDRAW',6).NE.0) RETURN
C
                    RDPE(I)=RLS2*WCHR+MAX(0.,XEND-XBEG)
C
                  END IF
C
                END IF
C
  104         CONTINUE
C
              CALL PCSETI ('TE - TEXT EXTENT COMPUTATION FLAG',ITEF)
              IF (ICFELL('DPDRAW',7).NE.0) RETURN
C
            END IF
C
          END IF
C
C Set the fast-path flag to -1 if the pattern is nothing but gap, to
C +1 if the pattern is nothing but solid, and to 0 otherwise.  Also,
C in the final case, remove any "dummy" gap at the end of the list
C that duplicates one at the beginning of the list.
C
  105     IF (NDPE.EQ.1.AND.IDPE(1).LT.0) THEN
            IFPF=-1
          ELSE IF (NDPE.EQ.1.AND.IDPE(1).EQ.0) THEN
            IFPF=+1
          ELSE
            IFPF=0
            IF (IDPE(1).EQ.1.AND.IDPE(NDPE).EQ.1) NDPE=NDPE-1
          END IF
C
C Debug prints ...
C
C         IF (IDPS.GE.0) THEN
C           PRINT '(''IN DPDRAW - XCPF, YCPF, IFVL = '',2E12.4,I4)' ,
C    +            XCPF,YCPF,IFVL
C           PRINT '(I4''-ELEMENT LIST'',4X,I4,2X,A)' ,
C    +            NDPE,NCHR,CHDP(1:NCHR)
C           DO 999 I=1,NDPE
C             IF (IDPE(I).LT.0) THEN
C               PRINT '(I6,E12.4,''  GAP      '')' , I,RDPE(I)
C             ELSE IF (IDPE(I).EQ.0) THEN
C               PRINT '(I6,E12.4,''  SOLID    '')' , I,RDPE(I)
C             ELSE IF (IDPE(I).EQ.1) THEN
C               PRINT '(I6,E12.4,''  DUMMY GAP'')' , I,RDPE(I)
C             ELSE
C               IFCH=IDPE(I)/LDPA
C               ILCH=MOD(IDPE(I),LDPA)
C               LNTH=ILCH-IFCH+1
C               IF (LNTH.NE.1) THEN
C                 PRINT '(I6,E12.4,''  STRING   '',I4,2X,A)' ,
C    +                  I,RDPE(I),LNTH,CHDP(IFCH:ILCH)
C               ELSE IF (ICHAR(CHDP(IFCH:ILCH)).LT.128) THEN
C                 PRINT '(I6,E12.4,''  STRING   '',I4,2X,A)' ,
C    +                  I,RDPE(I),LNTH,CHDP(IFCH:ILCH)
C               ELSE
C                 PRINT '(I6,E12.4,''  SYMBOL   '',6X,A)' ,
C    +                  I,RDPE(I),CHAR(ICHAR(CHDP(IFCH:ILCH))-128)
C               END IF
C             END IF
C 999       CONTINUE
C         END IF
C
C Set the dash-pattern-initialized flag.
C
          IDPI=1
C
        END IF
C
C If the call does not define a continuation point or if DPDRAW is not
C in the proper state to handle such a point, ...
C
        IF (IFVL.NE.1.OR.IDST.EQ.0) THEN
C
C ... first, using only gap and solid elements of the dash pattern,
C draw any portion of a previous curve that was skipped as part of
C the gap for a character string that ended up never being drawn ...
C
          IF (NPSB.GT.1.AND.ILTL.EQ.0) THEN
C
            XCNF=RSPX(1)
            YCNF=RSPY(1)
C
            ISPE=ICPE
            WCPE=0.
C
            DO 108 I=2,NPSB
C
              XCLF=XCNF
              YCLF=YCNF
C
              XCNF=RSPX(I)
              YCNF=RSPY(I)
C
              DIST=SQRT((XCNF-XCLF)**2+(YCNF-YCLF)**2)
C
  106         IF (ICPE.EQ.ISPE.OR.IDPE(ICPE).EQ.0) THEN
                CALL PLOTIF (XCLF,YCLF,0)
                IF (ICFELL('DPDRAW',8).NE.0) RETURN
              END IF
C
              IF (DIST.LE.WCPE) THEN
C
                WCPE=WCPE-DIST
C
                IF (ICPE.EQ.ISPE.OR.IDPE(ICPE).EQ.0) THEN
                  CALL PLOTIF (XCNF,YCNF,1)
                  IF (ICFELL('DPDRAW',9).NE.0) RETURN
                END IF
C
              ELSE
C
                XCLF=XCLF+(WCPE/DIST)*(XCNF-XCLF)
                YCLF=YCLF+(WCPE/DIST)*(YCNF-YCLF)
C
                DIST=DIST-WCPE
C
                IF (ICPE.EQ.ISPE.OR.IDPE(ICPE).EQ.0) THEN
                  CALL PLOTIF (XCLF,YCLF,1)
                  IF (ICFELL('DPDRAW',10).NE.0) RETURN
                END IF
C
                ISPE=ICPE
C
  107           ICPE=MOD(ICPE,NDPE)+1
                IF (ICPE.NE.ISPE.AND.IDPE(ICPE).GT.0) GO TO 107
C
                IF (IDPE(ICPE).LE.0.AND.RDPE(ICPE).GT.0.) THEN
                  ISPE=0
                  WCPE=RDPE(ICPE)
                ELSE
                  ISPE=ICPE
                  WCPE=1.
                END IF
C
                GO TO 106
C
              END IF

  108       CONTINUE
C
          END IF
C
          NPSB=0
          NSSB=0
C
C ... and then, either flush the PLOTIF buffer ...
C
          IF (IFVL.GE.2) THEN
C
            CALL PLOTIF (0.,0.,2)
            IF (ICFELL('DPDRAW',11).NE.0) RETURN
C
            IDST=0
C
C ... or do first-point initialization, whichever is appropriate.
C
          ELSE
C
            XCLF=XCPF
            YCLF=YCPF
C
            ICPE=1
            WCPE=RDPE(1)
C
            IF (IDPE(ICPE).EQ.0) WCPE=RMFS*WCPE
C
            IF (IDPE(ICPE).GT.1) THEN
              XCGF=XCPF
              YCGF=YCPF
            END IF
C
            IF (IDPE(ICPE).GT.0.AND.ISBF.NE.0.AND.NPSB.EQ.0) THEN
              NPSB=1
              RSPX(1)=XCLF
              RSPY(1)=YCLF
            END IF
C
            IDST=1
C
          END IF
C
C Otherwise, the call defines a continuation point and DPDRAW is in the
C correct state to handle such a point, so process it.
C
        ELSE
C
          IF (IFPF.GT.0) THEN
C
            CALL PLOTIF (XCLF,YCLF,0)
            IF (ICFELL('DPDRAW',12).NE.0) RETURN
C
            CALL PLOTIF (XCPF,YCPF,1)
            IF (ICFELL('DPDRAW',13).NE.0) RETURN
C
          ELSE IF (IFPF.EQ.0) THEN
C
            DIST=SQRT((XCPF-XCLF)**2+(YCPF-YCLF)**2)
C
  109       IF (IDPE(ICPE).EQ.0.OR.(ILTL.NE.0.AND.IDPE(ICPE).GT.0)) THEN
              CALL PLOTIF (XCLF,YCLF,0)
              IF (ICFELL('DPDRAW',14).NE.0) RETURN
            END IF
C
            IF (DIST.LE.WCPE) THEN
C
              WCPE=WCPE-DIST
C
              IF (IDPE(ICPE).EQ.0.OR.
     +            (ILTL.NE.0.AND.IDPE(ICPE).GT.0)) THEN
C
                CALL PLOTIF (XCPF,YCPF,1)
                IF (ICFELL('DPDRAW',15).NE.0) RETURN
C
              END IF
C
              IF (IDPE(ICPE).GT.0.AND.ISBF.NE.0) THEN
C
                IF (NPSB.EQ.LPSB) THEN
C
                  IMIN=2
                  DMIN=SQRT((RSPX(3)-RSPX(2))**2+
     +                      (RSPY(3)-RSPY(2))**2)
C
                  DO 110 I=2,NPSB-2
                    DTMP=SQRT((RSPX(I+1)-RSPX(I))**2+
     +                        (RSPY(I+1)-RSPY(I))**2)
                    IF (DTMP.LT.DMIN) THEN
                      IMIN=I
                      DMIN=DTMP
                    END IF
  110             CONTINUE
C
                  RSPX(IMIN)=.5*(RSPX(IMIN)+RSPX(IMIN+1))
                  RSPY(IMIN)=.5*(RSPY(IMIN)+RSPY(IMIN+1))
C
                  DO 111 I=IMIN+1,NPSB-1
                    RSPX(I)=RSPX(I+1)
                    RSPY(I)=RSPY(I+1)
  111             CONTINUE
C
                  NPSB=NPSB-1
C
                END IF
C
                NPSB=NPSB+1
                RSPX(NPSB)=XCPF
                RSPY(NPSB)=YCPF
C
              END IF
C
            ELSE
C
              XCLF=XCLF+(WCPE/DIST)*(XCPF-XCLF)
              YCLF=YCLF+(WCPE/DIST)*(YCPF-YCLF)
C
              DIST=DIST-WCPE
C
              IF (IDPE(ICPE).EQ.0.OR.
     +            (ILTL.NE.0.AND.IDPE(ICPE).GT.0)) THEN
C
                CALL PLOTIF (XCLF,YCLF,1)
                IF (ICFELL('DPDRAW',16).NE.0) RETURN
C
              END IF
C
              IF (IDPE(ICPE).GT.1) THEN
C
                IF (NSSB.GE.LSSB) THEN
                  CALL SETER ('DPDRAW - IMPLEMENTATION ERROR - SEE SPECI
     +ALIST',17,1)
                  RETURN
                END IF
C
                NSSB=NSSB+1
C
                RSSX(NSSB)=.5*(XCGF+XCLF)
                RSSY(NSSB)=.5*(YCGF+YCLF)
C
                IF (XCLF.EQ.XCGF.AND.YCLF.EQ.YCGF) THEN
                  RSSA(NSSB)=0.
                ELSE
                  RSSA(NSSB)=RTOD*ATAN2(YCLF-YCGF,XCLF-XCGF)
                END IF
C
                ISSP(NSSB)=ICPE
C
              END IF
C
              ICPE=MOD(ICPE,NDPE)+1
              WCPE=RDPE(ICPE)
C
              IF (IDPE(ICPE).GT.1) THEN
                XCGF=XCLF
                YCGF=YCLF
              END IF
C
              IF (NSSB.NE.0.AND.(ISBF.EQ.0.OR.ICPE.EQ.1
     +                                    .OR.IDPE(ICPE).LE.1)) THEN
C
                IF (NSSB.GT.1.AND.NPSB.GT.0.AND.ANGF.GT.0.) THEN
C
                  NUDE=0
C
                  DO 112 I=1,NSSB
                    ANGD=MOD(RSSA(I)-ANGF+3780.,360.)-180.
                    IF (ANGD.LT.-90..OR.ANGD.GT.90.) NUDE=NUDE+1
  112             CONTINUE
C
                  IF (NUDE.GT.NSSB/2) THEN
C
                    NTMP=NPSB
C
                    XC1F=XCLF
                    YC1F=YCLF
C
                    XC2F=XCLF
                    YC2F=YCLF
C
                    XC3F=RSPX(NTMP)
                    YC3F=RSPY(NTMP)
C
                    DTMP=SQRT((XC3F-XC2F)**2+(YC3F-YC2F)**2)
C
                    DO 114 I=1,NSSB
C
                      WTMP=RDPE(ISSP(I))
C
  113                 IF (WTMP.GE.DTMP) THEN
C
                        WTMP=WTMP-DTMP
C
                        XC2F=XC3F
                        YC2F=YC3F
C
                        IF (NTMP.GT.1) THEN
                          NTMP=NTMP-1
                          XC3F=RSPX(NTMP)
                          YC3F=RSPY(NTMP)
                        ELSE
                          NTMP=MIN(-2,NTMP-1)
                          IF (-NTMP.LE.NPSB) THEN
                            XC3F=RSPX(1)-(RSPX(-NTMP)-RSPX(1))*1000.
                            YC3F=RSPY(1)-(RSPY(-NTMP)-RSPY(1))*1000.
                          ELSE
                            XC3F=RSPX(1)-(XCLF-RSPX(1))*1000.
                            YC3F=RSPY(1)-(YCLF-RSPY(1))*1000.
                          END IF
                        END IF
C
                        DTMP=SQRT((XC3F-XC2F)**2+(YC3F-YC2F)**2)
C
                        GO TO 113
C
                      END IF
C
                      XC2F=XC2F+(WTMP/DTMP)*(XC3F-XC2F)
                      YC2F=YC2F+(WTMP/DTMP)*(YC3F-YC2F)
C
                      DTMP=DTMP-WTMP
C
                      RSSX(I)=.5*(XC1F+XC2F)
                      RSSY(I)=.5*(YC1F+YC2F)
C
                      IF (XC1F.EQ.XC2F.AND.YC1F.EQ.YC2F) THEN
                        RSSA(I)=0.
                      ELSE
                        RSSA(I)=RTOD*ATAN2(YC2F-YC1F,XC2F-XC1F)
                      END IF
C
                      XC1F=XC2F
                      YC1F=YC2F
C
  114               CONTINUE
C
                  END IF
C
                END IF
C
                CALL PLOTIF (0.,0.,2)
                IF (ICFELL('DPDRAW',18).NE.0) RETURN
C
                DO 115 I=1,NSSB
C
                  XTMP=CFUX(RSSX(I))
                  IF (ICFELL('DPDRAW',19).NE.0) RETURN
C
                  YTMP=CFUY(RSSY(I))
                  IF (ICFELL('DPDRAW',20).NE.0) RETURN
C
                  IFCH=IDPE(ISSP(I))/LDPA
                  ILCH=MOD(IDPE(ISSP(I)),LDPA)
C
                  ANGD=RSSA(I)
C
                  IF (ANGF.NE.0..AND.ISCF.EQ.0.AND.NBCS.EQ.0) THEN
C
                    IF (ANGF.GT.0.) THEN
C
                      ANGD=MOD(ANGD-ANGF+3780.,360.)-180.
C
                      IF (ANGD.LT.-90.) THEN
                        ANGD=ANGD+180.
                      ELSE IF (ANGD.GT.+90.) THEN
                        ANGD=ANGD-180.
                      END IF
C
                      ANGD=MOD(ANGF+ANGD,360.)
C
                    ELSE IF (ILTL.NE.0) THEN
C
                      ANGD=MOD(ABS(ANGF),360.)
C
                    END IF
C
                  END IF
C
                  IF (ICHAR(CHDP(IFCH:IFCH)).GT.127) THEN
C
                    CALL GQCNTN (IERR,NTIU)
C
                    IF (IERR.NE.0) THEN
                      CALL SETER('DPDRAW - ERROR EXIT FROM GQCNTN',21,1)
                      RETURN
                    END IF
C
                    CALL GQNT (NTIU,IERR,WNDW,VPRT)
C
                    IF (IERR.NE.0) THEN
                      CALL SETER ('DPDRAW - ERROR EXIT FROM GQNT',22,1)
                      RETURN
                    END IF
C
                    CALL DPDSYM (WNDW(1)+(RSSX(I)-VPRT(1))/
     +                                   (VPRT(2)-VPRT(1))*
     +                                   (WNDW(2)-WNDW(1)),
     +                           WNDW(3)+(RSSY(I)-VPRT(3))/
     +                                   (VPRT(4)-VPRT(3))*
     +                                   (WNDW(4)-WNDW(3)),
     +                           CHAR(ICHAR(CHDP(IFCH:IFCH))-128),
     +                           WCHR*(WNDW(2)-WNDW(1))/
     +                                (VPRT(2)-VPRT(1)),
     +                           ANGD)
C
                  ELSE IF (IPCF.EQ.0) THEN
C
                    CALL PLCHHQ (XTMP,YTMP,CHDP(IFCH:ILCH),WCHR,ANGD,0.)
                    IF (ICFELL('DPDRAW',23).NE.0) RETURN
C
                  ELSE IF (IPCF.EQ.1) THEN
C
                    CALL PLCHMQ (XTMP,YTMP,CHDP(IFCH:ILCH),WCHR,ANGD,0.)
                    IF (ICFELL('DPDRAW',24).NE.0) RETURN
C
                  ELSE
C
                    CALL PLCHLQ (XTMP,YTMP,CHDP(IFCH:ILCH),WCHR,ANGD,0.)
                    IF (ICFELL('DPDRAW',25).NE.0) RETURN
C
                  END IF
C
  115           CONTINUE
C
                NPSB=0
                NSSB=0
C
              END IF
C
              IF (IDPE(ICPE).GT.0.AND.ISBF.NE.0) THEN
                IF (NPSB.EQ.0) THEN
                  NPSB=1
                  RSPX(1)=XCLF
                  RSPY(1)=YCLF
                END IF
              ELSE
                NPSB=0
              END IF
C
              GO TO 109
C
            END IF
C
          END IF
C
          XCLF=XCPF
          YCLF=YCPF
C
          IDST=2
C
        END IF
C
C Done.
C
        RETURN
C
      END

C
C	$Id: gprec.f,v 1.6 2008-07-27 00:20:58 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GPREC(IL,IA,RL,RA,SL,LSTR,STR,MLDR,ERRIND,LDR,DATREC)
C
C  PACK DATA RECORD
C
      INTEGER EPREC
      PARAMETER (EPREC=107)
      INTEGER IL,IA(*),RL,SL,LSTR(*),MLDR,LDR,ERRIND
      REAL RA(*)
      CHARACTER*(*) STR(*)
      CHARACTER*80  DATREC(LDR)
      DATA NCE/1/
C
C  Determine number of CHARACTER*80 records the packing is going to
C  require:  the integers are packed in I20 format, the reals in
C  E20.13 format, and the characters are packed in packets of
C  N per record, where N is 80 divided by the character string
C  of maximum length.
C
C---------------------------------------------------------------------
C
C  Where:
C    MAXSL = Maximum length of all character strings.
C    NCE   = Number of character entries in each data record.
C    NTL   = Number of data records needed to store the LSTR array.
C    NIL   = Number of data records needed to store INTEGER array.
C    NRL   = Number of data records needed to store the REAL array.
C    NSL   = Number of data records needed to store the CHARACTERs.
C
C  The packed data record structure looks like:
C
C  Data rec number           Stored items
C  ---------------           ------------
C  1                         IL,RL,SL,NTL,NIL,NRL,NSL,MAXSL
C                            (Stored as 8I10)
C  2 TO NTL+1                LSTR array stored as I10 integers
C  NTL+2 TO NTL+NIL+1        INTEGER array stored as I20
C  NTL+NIL+2 TO              REAL array stored as E20.13
C    NTL+NIL+NRL+1
C  NTL+NIL+NRL+2 TO          Characters stored in blocks of NCE
C    NTL+NIL+NRL+NSL+1
C
      NIL = 0
      IF (IL.GT.0) THEN
        NIL = IL/4
        IF (MOD(IL,4).NE.0) THEN
          NIL = NIL+1
        ENDIF
      ENDIF
      NRL = 0
      IF (RL.GT.0) THEN
        NRL = RL/4
        IF (MOD(RL,4).NE.0) THEN
          NRL = NRL+1
        ENDIF
      ENDIF
C
C  Find the maximum length of the character strings.
C
      MAXSL = 0
      IF (SL .GT. 0) THEN
        DO 200 I=1,SL
          MAXSL = MAX(MAXSL,LSTR(I))
  200   CONTINUE
      ENDIF
C
C  Determine the number of character entries to be packed in each
C  data record.
C
      IF (MAXSL.NE.0) THEN
        NCE = 80/MAXSL
        IF (NCE.LE.1) THEN
          NCE = 1
        ENDIF
      ENDIF
C
C  Determine the number of data records needed to store the LSTR
C  array (stored 8I10).
C
      NTL = 0
      IF (SL .GT. 0) THEN
        NPER = 8
        NTL = SL/NPER
        IF (MOD(SL,NPER).NE.0.OR.NTL.EQ.0) THEN
          NTL = NTL+1
        ENDIF
      ENDIF
C
C  Determine the number of records needed to store the characters.
C
      NSL = 0
      IF (SL .GT. 0) THEN
        IF (NCE .GT. 1) THEN
          NSL = SL/NCE
          IF (MOD(SL,NCE).NE.0 .OR. NSL.EQ.0) THEN
            NSL = NSL+1
          ENDIF
        ELSE
          DO 201 I=1,SL
            K = LSTR(I)/80
            IF (MOD(LSTR(I),80).NE.0 .OR. K.EQ.0) THEN
              NSL = NSL+K+1
            ELSE
              NSL = NSL+K
            ENDIF
  201     CONTINUE
        ENDIF
      ENDIF
      LDR = NTL+NIL+NRL+NSL+1
      IF (LDR .GT. MLDR) THEN
        ERRIND = 2001
        RETURN
      ENDIF
C
C  Initialize the data record.
C
      DO 202 I=1,LDR
        DATREC(I) = ' '
  202 CONTINUE
C
C  Pack the data record.
C
      WRITE(DATREC(1),501) IL,RL,SL,NTL,NIL,NRL,NSL,MAXSL
C
C  Write out LSTR array.
C
      NPER = 8
      IF (SL.GT.0) THEN
        INDX1 = SL/NPER
        INDX2 = MOD(SL,NPER)
        IF (INDX1.EQ.0) THEN
          WRITE(DATREC(2),501) (LSTR(LL),LL=1,SL)
        ELSE
          DO 203 I=1,INDX1
            IPNT1 = NPER*(I-1)+1
            IPNT2 = NPER*I
            WRITE(DATREC(I+1),501) (LSTR(LL),LL=IPNT1,IPNT2)
  203     CONTINUE
          IF (INDX2.NE.0) THEN
            NPNT1 = NPER*INDX1+1
            NPNT2 = NPER*INDX1+INDX2
            WRITE(DATREC(INDX1+2),501) (LSTR(LL),LL=NPNT1,NPNT2)
          ENDIF
        ENDIF
      ENDIF
C
C  Write out the integer array.
C
      NPER = 4
      IF (IL.GT.0) THEN
        INDX1 = IL/NPER
        INDX2 = MOD(IL,NPER)
        IF (INDX1.EQ.0) THEN
          WRITE(DATREC(NTL+2),502) (IA(LL),LL=1,IL)
        ELSE
          DO 204 I=1,INDX1
            IPNT1 = NPER*(I-1)+1
            IPNT2 = NPER*I
            WRITE(DATREC(NTL+I+1),502) (IA(LL),LL=IPNT1,IPNT2)
  204     CONTINUE
          IF (INDX2.NE.0) THEN
            NPNT1 = NPER*INDX1+1
            NPNT2 = NPER*INDX1+INDX2
            WRITE(DATREC(NTL+INDX1+2),502) (IA(LL),LL=NPNT1,NPNT2)
          ENDIF
        ENDIF
      ENDIF
C
C  Write out the real array.
C
      NPER = 4
      IF (RL.GT.0) THEN
        INDX1 = RL/NPER
        INDX2 = MOD(RL,NPER)
        IF (INDX1.EQ.0) THEN
          WRITE(DATREC(NTL+NIL+2),503) (RA(LL),LL=1,RL)
        ELSE
          DO 205 I=1,INDX1
            IPNT1 = NPER*(I-1)+1
            IPNT2 = NPER*I
            WRITE(DATREC(NTL+NIL+I+1),503) (RA(LL),LL=IPNT1,IPNT2)
  205     CONTINUE
          IF (INDX2.NE.0) THEN
            NPNT1 = NPER*INDX1+1
            NPNT2 = NPER*INDX1+INDX2
            WRITE(DATREC(NTL+NIL+INDX1+2),503) (RA(LL),LL=NPNT1,NPNT2)
          ENDIF
        ENDIF
      ENDIF
C
C  Write out the character arrays.
C
      NPER = NCE
      IF (SL .GT. 0) THEN
        IF (NPER .GT. 1) THEN
          INDX1 = SL/NPER
          INDX2 = MOD(SL,NPER)
          IF (INDX1 .EQ. 0) THEN
            DO 206 I=1,SL
              IPNT1 = (I-1)*MAXSL+1
              IPNT2 = IPNT1+LSTR(I)-1
              DATREC(NTL+NIL+NRL+2)(IPNT1:IPNT2) = STR(I)
  206       CONTINUE
          ELSE
            DO 207 I=1,INDX1
              DO 208 J=1,NCE
                JPNT1 = (J-1)*MAXSL+1
                JPNT2 = JPNT1+LSTR(NPER*(I-1)+J)-1
                DATREC(NTL+NIL+NRL+I+1)(JPNT1:JPNT2) = 
     +                 STR(NPER*(I-1)+J)       
  208         CONTINUE
  207       CONTINUE
            IF (INDX2 .NE. 0) THEN
              DO 209 J=1,INDX2
                JPNT1 = (J-1)*MAXSL+1
                JPNT2 = JPNT1+LSTR(NPER*INDX1+J)-1
                DATREC(NTL+NIL+NRL+INDX1+2)(JPNT1:JPNT2) = 
     +                 STR(NPER*INDX1+J)     
  209         CONTINUE
            ENDIF
          ENDIF
        ELSE
          JNDX = 0
          DO 210 I=1,SL
            INDX1 = LSTR(I)/80
            INDX2 = MOD(LSTR(I),80)
            IF (INDX1 .EQ. 0) THEN
              JNDX = JNDX+1
              DATREC(NTL+NIL+NRL+JNDX+1) = STR(I)(1:INDX2)
            ELSE
              DO 211 J=1,INDX1
                JNDX = JNDX+1
                DATREC(NTL+NIL+NRL+JNDX+1) = STR(I) (80*(J-1)+1:80*J)
  211         CONTINUE
              IF (INDX2 .NE. 0) THEN
                JNDX = JNDX+1
                DATREC(NTL+NIL+NRL+JNDX+1) = 
     +                 STR(I) (80*INDX1+1:80*INDX1+INDX2)
              ENDIF
            ENDIF
  210     CONTINUE
        ENDIF
      ENDIF
C
  501 FORMAT(8I10)
  502 FORMAT(4I20)
  503 FORMAT(4E20.13)
C
      RETURN
      END

      SUBROUTINE SPBCON( UPLO, N, KD, AB, LDAB, ANORM, RCOND, WORK,
     $                   IWORK, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER          UPLO
      INTEGER            INFO, KD, LDAB, N
      REAL               ANORM, RCOND
*     ..
*     .. Array Arguments ..
      INTEGER            IWORK( * )
      REAL               AB( LDAB, * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  SPBCON estimates the reciprocal of the condition number (in the
*  1-norm) of a real symmetric positive definite band matrix using the
*  Cholesky factorization A = U**T*U or A = L*L**T computed by SPBTRF.
*
*  An estimate is obtained for norm(inv(A)), and the reciprocal of the
*  condition number is computed as RCOND = 1 / (ANORM * norm(inv(A))).
*
*  Arguments
*  =========
*
*  UPLO    (input) CHARACTER*1
*          = 'U':  Upper triangular factor stored in AB;
*          = 'L':  Lower triangular factor stored in AB.
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  KD      (input) INTEGER
*          The number of superdiagonals of the matrix A if UPLO = 'U',
*          or the number of subdiagonals if UPLO = 'L'.  KD >= 0.
*
*  AB      (input) REAL array, dimension (LDAB,N)
*          The triangular factor U or L from the Cholesky factorization
*          A = U**T*U or A = L*L**T of the band matrix A, stored in the
*          first KD+1 rows of the array.  The j-th column of U or L is
*          stored in the j-th column of the array AB as follows:
*          if UPLO ='U', AB(kd+1+i-j,j) = U(i,j) for max(1,j-kd)<=i<=j;
*          if UPLO ='L', AB(1+i-j,j)    = L(i,j) for j<=i<=min(n,j+kd).
*
*  LDAB    (input) INTEGER
*          The leading dimension of the array AB.  LDAB >= KD+1.
*
*  ANORM   (input) REAL
*          The 1-norm (or infinity-norm) of the symmetric band matrix A.
*
*  RCOND   (output) REAL
*          The reciprocal of the condition number of the matrix A,
*          computed as RCOND = 1/(ANORM * AINVNM), where AINVNM is an
*          estimate of the 1-norm of inv(A) computed in this routine.
*
*  WORK    (workspace) REAL array, dimension (3*N)
*
*  IWORK   (workspace) INTEGER array, dimension (N)
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ONE, ZERO
      PARAMETER          ( ONE = 1.0E+0, ZERO = 0.0E+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            UPPER
      CHARACTER          NORMIN
      INTEGER            IX, KASE
      REAL               AINVNM, SCALE, SCALEL, SCALEU, SMLNUM
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            ISAMAX
      REAL               SLAMCH
      EXTERNAL           LSAME, ISAMAX, SLAMCH
*     ..
*     .. External Subroutines ..
      EXTERNAL           SLACON, SLATBS, SRSCL, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      UPPER = LSAME( UPLO, 'U' )
      IF( .NOT.UPPER .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( KD.LT.0 ) THEN
         INFO = -3
      ELSE IF( LDAB.LT.KD+1 ) THEN
         INFO = -5
      ELSE IF( ANORM.LT.ZERO ) THEN
         INFO = -6
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'SPBCON', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      RCOND = ZERO
      IF( N.EQ.0 ) THEN
         RCOND = ONE
         RETURN
      ELSE IF( ANORM.EQ.ZERO ) THEN
         RETURN
      END IF
*
      SMLNUM = SLAMCH( 'Safe minimum' )
*
*     Estimate the 1-norm of the inverse.
*
      KASE = 0
      NORMIN = 'N'
   10 CONTINUE
      CALL SLACON( N, WORK( N+1 ), WORK, IWORK, AINVNM, KASE )
      IF( KASE.NE.0 ) THEN
         IF( UPPER ) THEN
*
*           Multiply by inv(U').
*
            CALL SLATBS( 'Upper', 'Transpose', 'Non-unit', NORMIN, N,
     $                   KD, AB, LDAB, WORK, SCALEL, WORK( 2*N+1 ),
     $                   INFO )
            NORMIN = 'Y'
*
*           Multiply by inv(U).
*
            CALL SLATBS( 'Upper', 'No transpose', 'Non-unit', NORMIN, N,
     $                   KD, AB, LDAB, WORK, SCALEU, WORK( 2*N+1 ),
     $                   INFO )
         ELSE
*
*           Multiply by inv(L).
*
            CALL SLATBS( 'Lower', 'No transpose', 'Non-unit', NORMIN, N,
     $                   KD, AB, LDAB, WORK, SCALEL, WORK( 2*N+1 ),
     $                   INFO )
            NORMIN = 'Y'
*
*           Multiply by inv(L').
*
            CALL SLATBS( 'Lower', 'Transpose', 'Non-unit', NORMIN, N,
     $                   KD, AB, LDAB, WORK, SCALEU, WORK( 2*N+1 ),
     $                   INFO )
         END IF
*
*        Multiply by 1/SCALE if doing so will not cause overflow.
*
         SCALE = SCALEL*SCALEU
         IF( SCALE.NE.ONE ) THEN
            IX = ISAMAX( N, WORK, 1 )
            IF( SCALE.LT.ABS( WORK( IX ) )*SMLNUM .OR. SCALE.EQ.ZERO )
     $         GO TO 20
            CALL SRSCL( N, SCALE, WORK, 1 )
         END IF
         GO TO 10
      END IF
*
*     Compute the estimate of the reciprocal condition number.
*
      IF( AINVNM.NE.ZERO )
     $   RCOND = ( ONE / AINVNM ) / ANORM
*
   20 CONTINUE
*
      RETURN
*
*     End of SPBCON
*
      END

C
C	$Id: gzsrat.f,v 1.6 2008-07-27 00:21:04 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GZSRAT(SRFLG,CICNTX,CFCNTX)
C
C  Save/restore the attribute context.
C
C    If SRFLG = 0, then save the current context
C    If SRFLG = 1, then restore the context.
C    If SRFLG = 3, then return the context in the output arrays
C                  CICNTX and CFCNTX.
C
C  The current integer attribute context returned in CICNTX:
C    CICNTX( 1) = Clip indicator
C    CICNTX( 2) = Polyline index
C    CICNTX( 3) = Line type
C    CICNTX( 4) = Polyline color index
C    CICNTX( 5) = Polymarker index
C    CICNTX( 6) = Marker type
C    CICNTX( 7) = Polymarker color index
C    CICNTX( 8) = Text index
C    CICNTX( 9) = Text font
C    CICNTX(10) = Text precision
C    CICNTX(11) = Text color index
C    CICNTX(12) = Text path
C    CICNTX(13) = Text horizontal alignment
C    CICNTX(14) = Text vertical alignment
C    CICNTX(15) = Fill area index
C    CICNTX(16) = Fill area interior style
C    CICNTX(17) = Fill are style index
C    CICNTX(18) = Fill area color index
C    CICNTX(19) = Linetype ASF
C    CICNTX(20) = Linewidth scale factor ASF
C    CICNTX(21) = Polyline color index ASF
C    CICNTX(22) = Marker type ASF
C    CICNTX(23) = Marker size scale factor ASF
C    CICNTX(24) = Polymarker color index ASF
C    CICNTX(25) = Text font and precision ASF
C    CICNTX(26) = Character expansion factor ASF
C    CICNTX(27) = Character spacing ASF
C    CICNTX(28) = Text color index ASF
C    CICNTX(29) = Fill area interior style ASF
C    CICNTX(30) = Fill area style index ASF
C    CICNTX(31) = Fill area color index ASF
C
C  The current real attribute context returned in CICNTX:
C    CFCNTX( 1) = Linewidth scale factor
C    CFCNTX( 2) = Marker scale factor
C    CFCNTX( 3) = Character expansion factor
C    CFCNTX( 4) = Character spacing
C    CFCNTX( 5) = Character height (world coordinates)
C    CFCNTX( 6) = Character up vector, X component (world coordinates)
C    CFCNTX( 7) = Character up vector, Y component (world coordinates)
C    CFCNTX( 8) = Pattern size, X component (world coordinates)
C    CFCNTX( 9) = Pattern size, Y component (world coordinates)
C    CFCNTX(10) = Pattern reference point, X component (world coordinates)
C    CFCNTX(11) = Pattern reference point, Y component (world coordinates)
C    CFCNTX(12) = Clip rectangle, left X (NDC)
C    CFCNTX(13) = Clip rectangle, right X (NDC)
C    CFCNTX(14) = Clip rectangle, bottom Y (NDC)
C    CFCNTX(15) = Clip rectangle, top Y (NDC)
C    CFCNTX(16) = X component in NDC of a vector parallel to the character
C                 up vector with length of character height.
C    CFCNTX(17) = Y component in NDC of a vector parallel to the character
C                 up vector with length of character height.
C    CFCNTX(18) = X component in NDC of a vector parallel to the character
C                 base vector.
C    CFCNTX(19) = Y component in NDC of a vector parallel to the character
C                 base vector.
C
      include 'gkscom.h'
C
      INTEGER CICNTX(31)
      REAL    CFCNTX(19)
C
      INTEGER SRFLG,LASF(13)
C
      INTEGER   SCLIP , SPLI  , SLN   , SPLCI , SPMI  , SMK   , SPMCI ,       
     +          STXI  , STXFP , STXCI , STXP  , STXAL , SFAI  , SFAIS , 
     +          SFASI , SFACI 
      DIMENSION STXFP(2), STXAL(2)
      REAL      SLWSC , SMKS  , SCHXP , SCHSP , SCHH  , SCHUP , SPA   , 
     +          SPARF
      DIMENSION SCHUP(2), SPA(2), SPARF(2)
      INTEGER   SLNA  , SLWSCA, SPLCIA, SMKA  , SMKSA , SPMCIA, STXFPA,
     +          SCHXPA, SCHSPA, STXCIA, SFAISA, SFASIA, SFACIA
C
      SAVE
C
      IF (SRFLG .EQ. 0) THEN
        SCLIP    = CCLIP
        SPLI     = CPLI
        SLN      = CLN
        SLWSC    = CLWSC
        SPLCI    = CPLCI
        SPMI     = CPMI
        SMK      = CMK
        SMKS     = CMKS
        SPMCI    = CPMCI
        STXI     = CTXI
        STXFP(1) = CTXFP(1)
        STXFP(2) = CTXFP(2)
        SCHXP    = CCHXP
        SCHSP    = CCHSP
        STXCI    = CTXCI
        SCHH     = CCHH
        SCHUP(1) = CCHUP(1)
        SCHUP(2) = CCHUP(2)
        STXP     = CTXP
        STXAL(1) = CTXAL(1)
        STXAL(2) = CTXAL(2)
        SFAI     = CFAI
        SFAIS    = CFAIS
        SFASI    = CFASI
        SFACI    = CFACI
        SPA(1)   = CPA(1)
        SPA(2)   = CPA(2)
        SPARF(1) = CPARF(1)
        SPARF(2) = CPARF(2)
C
        SLNA     = CLNA
        SLWSCA   = CLWSCA
        SPLCIA   = CPLCIA
        SMKA     = CMKA
        SMKSA    = CMKSA
        SPMCIA   = CPMCIA
        STXFPA   = CTXFPA
        SCHXPA   = CCHXPA
        SCHSPA   = CCHSPA
        STXCIA   = CTXCIA
        SFAISA   = CFAISA
        SFASIA   = CFASIA
        SFACIA   = CFACIA
      ELSE IF (SRFLG .EQ. 1) THEN
        CCLIP    = SCLIP
        CALL GSCLIP (CCLIP)
        CPLI     = SPLI
        CALL GSPLI  (CPLI )
        CLN      = SLN
        CALL GSLN   (CLN  )
        CLWSC    = SLWSC
        CALL GSLWSC (CLWSC)
        CPLCI    = SPLCI
        CALL GSPLCI (CPLCI)
        CPMI     = SPMI
        CALL GSPMI  (CPMI )
        CMK      = SMK
        CALL GSMK   (CMK  )
        CMKS     = SMKS
        CALL GSMKSC (CMKS )
        CPMCI    = SPMCI
        CALL GSPMCI (CPMCI)
        CTXI     = STXI
        CALL GSTXI  (CTXI )
        CTXFP(1) = STXFP(1)
        CTXFP(2) = STXFP(2)
        CALL GSTXFP (CTXFP(1),CTXFP(2))
        CCHXP    = SCHXP
        CALL GSCHXP (CCHXP)
        CCHSP    = SCHSP
        CALL GSCHSP (CCHSP)
        CTXCI    = STXCI
        CALL GSTXCI (CTXCI)
        CCHH     = SCHH
        CALL GSCHH  (CCHH )
        CCHUP(1) = SCHUP(1)
        CCHUP(2) = SCHUP(2)
        CALL GSCHUP (CCHUP(1),CCHUP(2))
        CTXP     = STXP
        CALL GSTXP  (CTXP )
        CTXAL(1) = STXAL(1)
        CTXAL(2) = STXAL(2)
        CALL GSTXAL (CTXAL(1),CTXAL(2))
        CFAI     = SFAI
        CALL GSFAI  (CFAI )
        CFAIS    = SFAIS
        CALL GSFAIS (CFAIS)
        CFASI    = SFASI
        CALL GSFASI (CFASI)
        CFACI    = SFACI
        CALL GSFACI (CFACI)
        CPA(1)   = SPA(1)
        CPA(2)   = SPA(2)
        CALL GSPA   (CPA  (1),CPA  (2))
        CPARF(1) = SPARF(1)
        CPARF(2) = SPARF(2)
        CALL GSPARF (CPARF(1),CPARF(2))
C
        CLNA     = SLNA
        CLWSCA   = SLWSCA
        CPLCIA   = SPLCIA
        CMKA     = SMKA
        CMKSA    = SMKSA
        CPMCIA   = SPMCIA
        CTXFPA   = STXFPA
        CCHXPA   = SCHXPA
        CCHSPA   = SCHSPA
        CTXCIA   = STXCIA
        CFAISA   = SFAISA
        CFASIA   = SFASIA
        CFACIA   = SFACIA
        LASF( 1) = CLNA
        LASF( 2) = CLWSCA
        LASF( 3) = CPLCIA
        LASF( 4) = CMKA
        LASF( 5) = CMKSA
        LASF( 6) = CPMCIA
        LASF( 7) = CTXFPA
        LASF( 8) = CCHXPA
        LASF( 9) = CCHSPA
        LASF(10) = CTXCIA
        LASF(11) = CFAISA
        LASF(12) = CFASIA
        LASF(13) = CFACIA
        CALL GSASF (LASF)
      ELSE IF (SRFLG .EQ. 3) THEN
C
C  Return the current context.
C
        CICNTX( 1) = CCLIP
        CICNTX( 2) = CPLI
        CICNTX( 3) = CLN
        CICNTX( 4) = CPLCI
        CICNTX( 5) = CPMI
        CICNTX( 6) = CMK
        CICNTX( 7) = CPMCI
        CICNTX( 8) = CTXI
        CICNTX( 9) = CTXFP(1)
        CICNTX(10) = CTXFP(2)
        CICNTX(11) = CTXCI
        CICNTX(12) = CTXP
        CICNTX(13) = CTXAL(1)
        CICNTX(14) = CTXAL(2)
        CICNTX(15) = CFAI
        CICNTX(16) = CFAIS
        CICNTX(17) = CFASI
        CICNTX(18) = CFACI
        CICNTX(19) = CLNA
        CICNTX(20) = CLWSCA
        CICNTX(21) = CPLCIA
        CICNTX(22) = CMKA
        CICNTX(23) = CMKSA
        CICNTX(24) = CPMCIA
        CICNTX(25) = CTXFPA
        CICNTX(26) = CCHXPA
        CICNTX(27) = CCHSPA
        CICNTX(28) = CTXCIA
        CICNTX(29) = CFAISA
        CICNTX(30) = CFASIA
        CICNTX(31) = CFACIA
C
        CFCNTX( 1) = CLWSC
        CFCNTX( 2) = CMKS
        CFCNTX( 3) = CCHXP
        CFCNTX( 4) = CCHSP
        CFCNTX( 5) = CCHH
        CFCNTX( 6) = CCHUP(1)
        CFCNTX( 7) = CCHUP(2)
        CFCNTX( 8) = CPA(1)
        CFCNTX( 9) = CPA(2)
        CFCNTX(10) = CPARF(1)
        CFCNTX(11) = CPARF(2)
        CALL GQCLIP(IER,ICL,CFCNTX(12))
C
C  Create the normalized orientation vectors for text.
C
        SCL = 1./SQRT(CCHUP(1)*CCHUP(1)+CCHUP(2)*CCHUP(2))
        XP = CCHH*SCL*CCHUP(1)
        YP = CCHH*SCL*CCHUP(2)
        XB =  YP
        YB = -XP
        CALL GZW2NX(1,XP,XTMP)
        CALL GZW2NY(1,YP,YTMP)
        CALL GZW2NX(1,0.,ZXTMP)
        CALL GZW2NY(1,0.,ZYTMP)
        CFCNTX(16) = XTMP-ZXTMP
        CFCNTX(17) = YTMP-ZYTMP
        CALL GZW2NX(1,XB,XTMP)
        CALL GZW2NY(1,YB,YTMP)
        CFCNTX(18) = XTMP-ZXTMP
        CFCNTX(19) = YTMP-ZYTMP
      ENDIF
C
      RETURN
      END 

C
C $Id: intrvl.f,v 1.5 2008-07-27 03:10:11 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
C NOTE: If you make any changes to this software, please remember to
C make the same changes to the corresponding double precision routine.
C
      function intrvl (t,x,n)
c
      integer n
      real t,x(n)
c
c                                 coded by alan kaylor cline
c                           from fitpack -- january 26, 1987
c                        a curve and surface fitting package
c                      a product of pleasant valley software
c                  8603 altus cove, austin, texas 78759, usa
c
c this function determines the index of the interval
c (determined by a given increasing sequence) in which
c a given value lies.
c
c on input--
c
c   t is the given value.
c
c   x is a vector of strictly increasing values.
c
c and
c
c   n is the length of x (n .ge. 2).
c
c on output--
c
c   intrvl returns an integer i such that
c
c          i =  1       if             t .le. x(2)  ,
c          i =  n-1     if x(n-1) .le. t            ,
c          otherwise       x(i)  .le. t .le. x(i+1),
c
c none of the input parameters are altered.
c
c-----------------------------------------------------------
c
      save i
      data i /1/
c
      tt = t
c
c check for illegal i
c
      if (i .ge. n) i = n/2
c
c check old interval and extremes
c
      if (tt .lt. x(i)) then
        if (tt .le. x(2)) then
          i = 1
          intrvl = 1
          return
        else
          il = 2
          ih = i
        end if
      else if (tt .le. x(i+1)) then
        intrvl = i
        return
      else if (tt .ge. x(n-1)) then
        i = n-1
        intrvl = n-1
        return
      else
        il = i+1
        ih = n-1
      end if
c
c binary search loop
c
    1 i = (il+ih)/2
      if (tt .lt. x(i)) then
         ih = i
      else if (tt .gt. x(i+1)) then
         il = i+1
      else
         intrvl = i
         return
      end if
      go to 1
      end

C
C	$Id: shblda.f,v 1.5 2008-07-27 03:10:13 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE SHBLDA
C
C Calling this do-nothing subroutine forces "ld" to load the following
C block data routine (but only if they are in the same ".f" file).
C
        RETURN
C
      END
CNOSPLIT
      BLOCKDATA SHBLDAX
C
C  Initialize data.
C
      COMMON /SHCOMI/ NMLSTQ, NMINFL, NMCELS
C
C  Number of data points used in least squares fit must be initialized
C  at run time - set flag.
C
      DATA NMLSTQ/-1/
C
C  Number of nodes within the radius of influence must be initialized
C  at run time - set flag.
C
      DATA NMINFL/-1/
C
C  Number of rows, columns, planes in the cell grid must be initialized
C  at run time - set flag.
C
      DATA NMCELS/-1/
C
      END

      SUBROUTINE DGTCON( NORM, N, DL, D, DU, DU2, IPIV, ANORM, RCOND,
     $                   WORK, IWORK, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER          NORM
      INTEGER            INFO, N
      DOUBLE PRECISION   ANORM, RCOND
*     ..
*     .. Array Arguments ..
      INTEGER            IPIV( * ), IWORK( * )
      DOUBLE PRECISION   D( * ), DL( * ), DU( * ), DU2( * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  DGTCON estimates the reciprocal of the condition number of a real
*  tridiagonal matrix A using the LU factorization as computed by
*  DGTTRF.
*
*  An estimate is obtained for norm(inv(A)), and the reciprocal of the
*  condition number is computed as RCOND = 1 / (ANORM * norm(inv(A))).
*
*  Arguments
*  =========
*
*  NORM    (input) CHARACTER*1
*          Specifies whether the 1-norm condition number or the
*          infinity-norm condition number is required:
*          = '1' or 'O':  1-norm;
*          = 'I':         Infinity-norm.
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  DL      (input) DOUBLE PRECISION array, dimension (N-1)
*          The (n-1) multipliers that define the matrix L from the
*          LU factorization of A as computed by DGTTRF.
*
*  D       (input) DOUBLE PRECISION array, dimension (N)
*          The n diagonal elements of the upper triangular matrix U from
*          the LU factorization of A.
*
*  DU      (input) DOUBLE PRECISION array, dimension (N-1)
*          The (n-1) elements of the first superdiagonal of U.
*
*  DU2     (input) DOUBLE PRECISION array, dimension (N-2)
*          The (n-2) elements of the second superdiagonal of U.
*
*  IPIV    (input) INTEGER array, dimension (N)
*          The pivot indices; for 1 <= i <= n, row i of the matrix was
*          interchanged with row IPIV(i).  IPIV(i) will always be either
*          i or i+1; IPIV(i) = i indicates a row interchange was not
*          required.
*
*  ANORM   (input) DOUBLE PRECISION
*          If NORM = '1' or 'O', the 1-norm of the original matrix A.
*          If NORM = 'I', the infinity-norm of the original matrix A.
*
*  RCOND   (output) DOUBLE PRECISION
*          The reciprocal of the condition number of the matrix A,
*          computed as RCOND = 1/(ANORM * AINVNM), where AINVNM is an
*          estimate of the 1-norm of inv(A) computed in this routine.
*
*  WORK    (workspace) DOUBLE PRECISION array, dimension (2*N)
*
*  IWORK   (workspace) INTEGER array, dimension (N)
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ONE, ZERO
      PARAMETER          ( ONE = 1.0D+0, ZERO = 0.0D+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            ONENRM
      INTEGER            I, KASE, KASE1
      DOUBLE PRECISION   AINVNM
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           DGTTRS, DLACON, XERBLA
*     ..
*     .. Executable Statements ..
*
*     Test the input arguments.
*
      INFO = 0
      ONENRM = NORM.EQ.'1' .OR. LSAME( NORM, 'O' )
      IF( .NOT.ONENRM .AND. .NOT.LSAME( NORM, 'I' ) ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( ANORM.LT.ZERO ) THEN
         INFO = -8
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DGTCON', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      RCOND = ZERO
      IF( N.EQ.0 ) THEN
         RCOND = ONE
         RETURN
      ELSE IF( ANORM.EQ.ZERO ) THEN
         RETURN
      END IF
*
*     Check that D(1:N) is non-zero.
*
      DO 10 I = 1, N
         IF( D( I ).EQ.ZERO )
     $      RETURN
   10 CONTINUE
*
      AINVNM = ZERO
      IF( ONENRM ) THEN
         KASE1 = 1
      ELSE
         KASE1 = 2
      END IF
      KASE = 0
   20 CONTINUE
      CALL DLACON( N, WORK( N+1 ), WORK, IWORK, AINVNM, KASE )
      IF( KASE.NE.0 ) THEN
         IF( KASE.EQ.KASE1 ) THEN
*
*           Multiply by inv(U)*inv(L).
*
            CALL DGTTRS( 'No transpose', N, 1, DL, D, DU, DU2, IPIV,
     $                   WORK, N, INFO )
         ELSE
*
*           Multiply by inv(L')*inv(U').
*
            CALL DGTTRS( 'Transpose', N, 1, DL, D, DU, DU2, IPIV, WORK,
     $                   N, INFO )
         END IF
         GO TO 20
      END IF
*
*     Compute the estimate of the reciprocal condition number.
*
      IF( AINVNM.NE.ZERO )
     $   RCOND = ( ONE / AINVNM ) / ANORM
*
      RETURN
*
*     End of DGTCON
*
      END

C
C $Id: nasort.f,v 1.4 2008-07-27 03:11:53 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE NASORT(XA,IP,N)                             
C
C  Given an array of REAL numbers of dimension N in XA,
C  this routine returns a permutation vector IP such that
C
C      XA(IP(I)) .LE. XA(IP(J))  
C           for all I,J such that  1. LE. I .LE. J .LE. N .
C
C  This is an implementation of the shellsort (the details of this
C  algorithm can be found in the book "Algorithms" by Robert Sedgewick).
C                                                                       
      INTEGER  H,I,N,IP(N),IP1,IP2,IPH,J,M
      REAL     XA(N)
C                                                                       
C  Check on the input argument N.
C                                                                       
      IF (N .LT. 0) THEN
        CALL SETER(' ASCSRT -- N TOO SMALL',1,1)
      ELSE IF (N .LE. 1) THEN
        IP(1) = 1
        RETURN
      ENDIF
C
C  Calculate the largest H less than N using the recursive definition 
C               H(L+1) = 3*H(L)+1
C
      H = 1
   10 CONTINUE
      H = 3*H+1
      IF (H .LT. N) GO TO 10
      H = (H-1)/3     
C                                                                       
C  Initialize permutation vector.
C                                                                       
      DO 20 I=1,N                                                    
      IP(I) = I                                                     
   20 CONTINUE
C                                                                       
C  Main loop.
C                                                                       
   30 CONTINUE
      M = N-H                                                       
      DO 50 J=1,M
      I = J                                                         
   40 CONTINUE
      IPH = I+H                                                  
      IP1 = IP(I)                                                
      IP2 = IP(IPH)                                              
      IF (XA(IP1) .LE. XA(IP2)) GO TO 50                      
C                                                                       
C  Interchange.
C                                                                       
      IP(I)   = IP2
      IP(IPH) = IP1
C                                                                       
C  Move interchanged elements up the line.
C                                                                       
      I = I-H                                                   
      IF (I .GE. 1) GO TO 40                                     
   50 CONTINUE
C                                                                       
C  Decrease H, continue sort as long as H is greater than 0.
C
      H = (H-1)/3                                               
      IF (H .LT. 1) RETURN                                          
      GO TO 30                                                         
      END                                                               

C
C	$Id: pwrxbd.f,v 1.5 2008-07-27 00:17:21 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
C
      SUBROUTINE PWRXBD
C
C Calling this do-nothing subroutine forces "ld" to load the following
C block data routine (but only if they are in the same ".f" file).
C
        RETURN
C
      END
CNOSPLIT
      BLOCKDATA PWRXBDX
C
C
C  SAVE DATA VALUES FOR LATER PASSES
C
      COMMON/PWRSV1/NNWD,NUMU5,INDLEN,IDDLEN,NUNIT
C
C  INITIALIZATION FOR MASK GENERATION
C
      COMMON/PINIT1/IFRST
      LOGICAL IFRST
C
C  MASKING AND OTHER MACHINE-DEPENDENT CONSTANTS WHICH MUST BE
C  CALCULATED.
C
      COMMON/PINIT/MASK(4),MASK6(64),MASK12(64),LAST6,LAST12,IBIT15,
     +        MASK14,NUM15U,NBWD
C
C INITIALIZATION FOR SUBROUTINES PWRITX AND XTCH.
      COMMON /PWRC2/ INDZER
C
C INITIALIZATION FOR SUBROUTINE PWRITX.
      LOGICAL FINIT
      COMMON /PSAV1/ FINIT,IFNT,IC,IT,ITO,RLX,RLY,RLOX,RLOY
C
C INITIALIZATION FOR SUBROUTINE PWRITX.
      COMMON /PUSER/ MODE
C
C
C  IFRST IS USED BY XTCH TO DECIDE IF MASKS HAVE BEEN GENERATED
C
      DATA IFRST/.FALSE./
C INDZER IS PUT INTO ARRAY LC BY ROUTINE XTCH TO INDICATE TO ROUTINE
C PWRITX THAT AN ALL-0-BITS UNIT WAS ENCOUNTERED.
C
      DATA INDZER /-2048/
C
C FINIT IS USED IN SUBROUTINE PWRITX. IT IS A FLAG TO INDICATE IF SOME
C REQUIRED INITIALIZATION HAS BEEN DONE.
C
      DATA FINIT /.FALSE./
C
C INITIALIZE INDICES TO ROMAN,PRINCIPAL, AND UPPER.
C
      DATA IFNT,IC,IT /0,0,0/
C
C INITIALIZE PREVIOUS CHARACTER SIZE TO PRINCIPAL.
C
      DATA ITO /0/
C
C INITIALIZE CHARACTER SIZE AND PREVIOUS CHARACTER SIZE TO PRINCIPAL.
C
      DATA RLX,RLY,RLOX,RLOY /16.0,32.0,16.0,32.0/
C
C INITIALIZE THE CHARACTER SET TO BE USED TO COMPLEX.
C
      DATA MODE /0/
C
C
      END

C
C	$Id: concom.f,v 1.4 2008-07-27 00:16:54 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      FUNCTION CONCOM (XQ,YQ,XD,YD,ZD,NDP,WK,IWK,LOC)
C
C  INTERPOLATE A GIVEN X,Y PAIR AND RETURN ITS LOCATION
C
C
C
      COMMON /CONRA1/ CL(30)     ,NCL        ,OLDZ       ,PV(210)    ,
     1                FINC       ,HI         ,FLO
      COMMON /CONRA2/ REPEAT     ,EXTRAP     ,PER        ,MESS       ,
     1                ISCALE     ,LOOK       ,PLDVLS     ,GRD        ,
     2                CINC       ,CHILO      ,CON        ,LABON      ,
     3                PMIMX      ,SCALE      ,FRADV      ,EXTRI      ,
     4                BPSIZ      ,LISTOP
      COMMON /CONRA3/ IREC
      COMMON /CONRA4/ NCP        ,NCPSZ
      COMMON /CONRA5/ NIT        ,ITIPV
      COMMON /CONRA6/ XST        ,YST        ,XED        ,YED        ,
     1                STPSZ      ,IGRAD      ,IG         ,XRG        ,
     2                YRG        ,BORD       ,PXST       ,PYST       ,
     3                PXED       ,PYED       ,ITICK
      COMMON /CONR18/ TITLE      ,ICNT   ,ITLSIZ
      COMMON /CONR19/ IHIGH      ,INMAJ      ,INLAB      ,INDAT      ,
     1              LEN      ,IFMT       ,LEND       ,
     2                IFMTD      ,ISIZEP     ,INMIN
      COMMON /CONRA9/ ICOORD(500),  NP       ,MXXY       ,TR         ,
     1                BR         ,TL         ,BL         ,CONV       ,
     2                XN         ,YN         ,ITLL       ,IBLL       ,
     3                ITRL       ,IBRL       ,XC         ,YC         ,
     4                ITLOC(210) ,JX         ,JY         ,ILOC       ,
     5                ISHFCT     ,XO         ,YO         ,IOC        ,NC
      COMMON /CONR10/ NT         ,NL         ,NTNL       ,JWIPT      ,
     1                JWIWL      ,JWIWP      ,JWIPL      ,IPR        ,
     2                ITPV
      COMMON /CONR20/ NREP       ,NCRT       ,ISIZEL     ,
     1                MINGAP     ,ISIZEM         ,
     2                TENS
      COMMON /CONR12/ IXMAX      ,IYMAX      ,XMAX       ,YMAX
      LOGICAL         REPEAT     ,EXTRAP     ,PER        ,MESS       ,
     1                LOOK       ,PLDVLS     ,GRD        ,LABON      ,
     2                PMIMX      ,FRADV      ,EXTRI      ,CINC       ,
     3                TITLE      ,LISTOP     ,CHILO      ,CON
      COMMON /CONR15/ ISTRNG
        CHARACTER*64 ISTRNG
        COMMON /CONR16/ FORM
        CHARACTER*10 FORM
        COMMON /CONR17/ NDASH, IDASH, EDASH
        CHARACTER*10 NDASH, IDASH, EDASH
C
C
      DIMENSION       XD(1)      ,YD(1)      ,ZD(1)      ,WK(1)      ,
     1                IWK(1)
C
        SAVE
C
C LOCATE PROPER TRIANGLE
C
      CALL CONLOC (NDP,XD,YD,NT,IWK(JWIPT),NL,IWK(JWIPL),XQ,YQ,LOC,
     1             IWK(JWIWL),WK)
C
C  INTERPOLATE THE LOCATION
C
      CALL CONCAL (XD,YD,ZD,NT,IWK(JWIPT),NL,IWK(JWIPL),WK(IPR),LOC,XQ,
     1             YQ,TEMP,ITPV)
      CONCOM = TEMP
      RETURN
      END

      SUBROUTINE SSBGV( JOBZ, UPLO, N, KA, KB, AB, LDAB, BB, LDBB, W, Z,
     $                  LDZ, WORK, INFO )
*
*  -- LAPACK driver routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER          JOBZ, UPLO
      INTEGER            INFO, KA, KB, LDAB, LDBB, LDZ, N
*     ..
*     .. Array Arguments ..
      REAL               AB( LDAB, * ), BB( LDBB, * ), W( * ),
     $                   WORK( * ), Z( LDZ, * )
*     ..
*
*  Purpose
*  =======
*
*  SSBGV computes all the eigenvalues, and optionally, the eigenvectors
*  of a real generalized symmetric-definite banded eigenproblem, of
*  the form A*x=(lambda)*B*x. Here A and B are assumed to be symmetric
*  and banded, and B is also positive definite.
*
*  Arguments
*  =========
*
*  JOBZ    (input) CHARACTER*1
*          = 'N':  Compute eigenvalues only;
*          = 'V':  Compute eigenvalues and eigenvectors.
*
*  UPLO    (input) CHARACTER*1
*          = 'U':  Upper triangles of A and B are stored;
*          = 'L':  Lower triangles of A and B are stored.
*
*  N       (input) INTEGER
*          The order of the matrices A and B.  N >= 0.
*
*  KA      (input) INTEGER
*          The number of superdiagonals of the matrix A if UPLO = 'U',
*          or the number of subdiagonals if UPLO = 'L'. KA >= 0.
*
*  KB      (input) INTEGER
*          The number of superdiagonals of the matrix B if UPLO = 'U',
*          or the number of subdiagonals if UPLO = 'L'. KB >= 0.
*
*  AB      (input/output) REAL array, dimension (LDAB, N)
*          On entry, the upper or lower triangle of the symmetric band
*          matrix A, stored in the first ka+1 rows of the array.  The
*          j-th column of A is stored in the j-th column of the array AB
*          as follows:
*          if UPLO = 'U', AB(ka+1+i-j,j) = A(i,j) for max(1,j-ka)<=i<=j;
*          if UPLO = 'L', AB(1+i-j,j)    = A(i,j) for j<=i<=min(n,j+ka).
*
*          On exit, the contents of AB are destroyed.
*
*  LDAB    (input) INTEGER
*          The leading dimension of the array AB.  LDAB >= KA+1.
*
*  BB      (input/output) REAL array, dimension (LDBB, N)
*          On entry, the upper or lower triangle of the symmetric band
*          matrix B, stored in the first kb+1 rows of the array.  The
*          j-th column of B is stored in the j-th column of the array BB
*          as follows:
*          if UPLO = 'U', BB(kb+1+i-j,j) = B(i,j) for max(1,j-kb)<=i<=j;
*          if UPLO = 'L', BB(1+i-j,j)    = B(i,j) for j<=i<=min(n,j+kb).
*
*          On exit, the factor S from the split Cholesky factorization
*          B = S**T*S, as returned by SPBSTF.
*
*  LDBB    (input) INTEGER
*          The leading dimension of the array BB.  LDBB >= KB+1.
*
*  W       (output) REAL array, dimension (N)
*          If INFO = 0, the eigenvalues in ascending order.
*
*  Z       (output) REAL array, dimension (LDZ, N)
*          If JOBZ = 'V', then if INFO = 0, Z contains the matrix Z of
*          eigenvectors, with the i-th column of Z holding the
*          eigenvector associated with W(i). The eigenvectors are
*          normalized so that Z**T*B*Z = I.
*          If JOBZ = 'N', then Z is not referenced.
*
*  LDZ     (input) INTEGER
*          The leading dimension of the array Z.  LDZ >= 1, and if
*          JOBZ = 'V', LDZ >= N.
*
*  WORK    (workspace) REAL array, dimension (3*N)
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*          > 0:  if INFO = i, and i is:
*             <= N:  the algorithm failed to converge:
*                    i off-diagonal elements of an intermediate
*                    tridiagonal form did not converge to zero;
*             > N:   if INFO = N + i, for 1 <= i <= N, then SPBSTF
*                    returned INFO = i: B is not positive definite.
*                    The factorization of B could not be completed and
*                    no eigenvalues or eigenvectors were computed.
*
*  =====================================================================
*
*     .. Local Scalars ..
      LOGICAL            UPPER, WANTZ
      CHARACTER          VECT
      INTEGER            IINFO, INDE, INDWRK
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           SPBSTF, SSBGST, SSBTRD, SSTEQR, SSTERF, XERBLA
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      WANTZ = LSAME( JOBZ, 'V' )
      UPPER = LSAME( UPLO, 'U' )
*
      INFO = 0
      IF( .NOT.( WANTZ .OR. LSAME( JOBZ, 'N' ) ) ) THEN
         INFO = -1
      ELSE IF( .NOT.( UPPER .OR. LSAME( UPLO, 'L' ) ) ) THEN
         INFO = -2
      ELSE IF( N.LT.0 ) THEN
         INFO = -3
      ELSE IF( KA.LT.0 ) THEN
         INFO = -4
      ELSE IF( KB.LT.0 .OR. KB.GT.KA ) THEN
         INFO = -5
      ELSE IF( LDAB.LT.KA+1 ) THEN
         INFO = -7
      ELSE IF( LDBB.LT.KB+1 ) THEN
         INFO = -9
      ELSE IF( LDZ.LT.1 .OR. ( WANTZ .AND. LDZ.LT.N ) ) THEN
         INFO = -12
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'SSBGV ', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
*
*     Form a split Cholesky factorization of B.
*
      CALL SPBSTF( UPLO, N, KB, BB, LDBB, INFO )
      IF( INFO.NE.0 ) THEN
         INFO = N + INFO
         RETURN
      END IF
*
*     Transform problem to standard eigenvalue problem.
*
      INDE = 1
      INDWRK = INDE + N
      CALL SSBGST( JOBZ, UPLO, N, KA, KB, AB, LDAB, BB, LDBB, Z, LDZ,
     $             WORK( INDWRK ), IINFO )
*
*     Reduce to tridiagonal form.
*
      IF( WANTZ ) THEN
         VECT = 'U'
      ELSE
         VECT = 'N'
      END IF
      CALL SSBTRD( VECT, UPLO, N, KA, AB, LDAB, W, WORK( INDE ), Z, LDZ,
     $             WORK( INDWRK ), IINFO )
*
*     For eigenvalues only, call SSTERF.  For eigenvectors, call SSTEQR.
*
      IF( .NOT.WANTZ ) THEN
         CALL SSTERF( N, W, WORK( INDE ), INFO )
      ELSE
         CALL SSTEQR( JOBZ, N, W, WORK( INDE ), Z, LDZ, WORK( INDWRK ),
     $                INFO )
      END IF
      RETURN
*
*     End of SSBGV
*
      END

C
C $Id: pj09sp.f,v 1.5 2008-07-27 00:17:10 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE PJ09SP (COORD,CRDIO,INDIC)
C
C -- T R A N S V E R S E   M E R C A T O R
C
      IMPLICIT REAL (A-Z)
      INTEGER I,IND,NIT
      INTEGER INDIC
      DIMENSION GEOG(2),PROJ(2),COORD(2),CRDIO(2)
C **** PARAMETERS ** A,E,ES,KS0,LON0,LAT0,X0,Y0,E0,E1,E2,E3,ESP,ML0,IND
      COMMON /ERRMZ0/ IERR
        INTEGER IERR
      SAVE   /ERRMZ0/
      COMMON /PRINZ0/ IPEMSG,IPELUN,IPPARM,IPPLUN
        INTEGER IPEMSG,IPELUN,IPPARM,IPPLUN
      SAVE   /PRINZ0/
      COMMON /PC09SP/ A,LON0,X0,Y0,ES,ESP,E0,E1,E2,E3,KS0,LAT0,ML0,IND
      DATA ZERO,HALF,ONE,TWO,THREE /0.0E0,0.5E0,1.0E0,2.0E0,3.0E0/
      DATA FOUR,FIVE,SIX,EIGHT,NINE /4.0E0,5.0E0,6.0E0,8.0E0,9.0E0/
      DATA HALFPI /1.5707963267948966E0/
      DATA TEN /10.0E0/
      DATA EPSLN,NIT /1.0E-10,6/
C
C -- F O R W A R D   . . .
C
      IF (INDIC .EQ. 0) THEN
C
         GEOG(1) = COORD(1)
         GEOG(2) = COORD(2)
         IERR = 0
         DLON = ADJLSP (GEOG(1) - LON0)
         LAT = GEOG(2)
         IF (IND .EQ. 0) GO TO 240
         COSPHI = COS (LAT)
         B = COSPHI * SIN (DLON)
         IF (ABS(ABS(B) - ONE) .GT. EPSLN) GO TO 230
         IF (IPEMSG .EQ. 0) WRITE (IPELUN,2020)
 2020    FORMAT (/' ERROR PJ09SP'/
     .            ' POINT PROJECTS INTO INFINITY')
         IERR = 093
         RETURN
  230    PROJ(1) = HALF * A * KS0 * LOG ((ONE + B) / (ONE - B)) + X0
         CON=ACOS(MAX(-ONE,MIN(ONE,COSPHI*COS(DLON)/
     +                                        SQRT(MAX(ZERO,ONE-B*B)))))
         IF (LAT .LT. ZERO) CON =-CON
         PROJ(2) = A * KS0 * (CON - LAT0) + Y0
         CRDIO(1) = PROJ(1)
         CRDIO(2) = PROJ(2)
         RETURN
C
  240    SINPHI = SIN (LAT)
         COSPHI = COS (LAT)
         AL = COSPHI * DLON
         ALS = AL * AL
         C = ESP * COSPHI * COSPHI
         TQ = TAN (LAT)
         T = TQ * TQ
         N = A / SQRT (ONE - ES * SINPHI * SINPHI)
         ML = A * MLFNSP (E0,E1,E2,E3,LAT)
         PROJ(1) = KS0 * N * AL * (ONE + ALS / SIX * (ONE - T + C +
     .             ALS / 20.0E0 * (FIVE - 18.0E0 * T + T * T + 72.0E0 *
     .             C - 58.0E0 * ESP))) + X0
         PROJ(2) = KS0 *(ML - ML0 + N * TQ *(ALS *(HALF + ALS / 24.0E0 *
     .             (FIVE - T + NINE * C + FOUR * C * C + ALS / 30.0E0 *
     .             (61.0E0 - 58.0E0 * T + T * T + 600.0E0 * C -
     .             330.0E0 * ESP))))) + Y0
         CRDIO(1) = PROJ(1)
         CRDIO(2) = PROJ(2)
         RETURN
      END IF
C
C -- I N V E R S E   . . .
C
      IF (INDIC .EQ. 1) THEN
C
         PROJ(1) = COORD(1)
         PROJ(2) = COORD(2)
         IERR = 0
         X = PROJ(1) - X0
         Y = PROJ(2) - Y0
         IF (IND .EQ. 0) GO TO 340
         F = EXP (X / (A * KS0))
         G = HALF * (F - ONE / F)
         TEMP = LAT0 + Y / (A * KS0)
         H = COS (TEMP)
         CON = SQRT ((ONE - H * H) / (ONE + G * G))
         GEOG(2) = ASINSP (CON)
         IF (TEMP .LT. ZERO) GEOG(2) =-GEOG(2)
         IF (G.NE.ZERO .OR. H.NE.ZERO) GO TO 330
         GEOG(1) = LON0
         CRDIO(1) = GEOG(1)
         CRDIO(2) = GEOG(2)
         RETURN
  330    GEOG(1) = ADJLSP (ATAN2 (G,H) + LON0)
         CRDIO(1) = GEOG(1)
         CRDIO(2) = GEOG(2)
         RETURN
C
  340    CON = (ML0 + Y / KS0) / A
         PHI = CON
         DO 360 I = 1,NIT
         DPHI = ((CON + E1 * SIN (TWO * PHI) - E2 * SIN (FOUR * PHI)
     .          + E3 * SIN (SIX * PHI)) / E0) - PHI
         PHI = PHI + DPHI
         IF (ABS(DPHI) .LE. EPSLN) GO TO 380
  360    CONTINUE
         IF (IPEMSG .EQ. 0) WRITE (IPELUN,2030) NIT
 2030    FORMAT (/' ERROR PJ09SP' /
     .            ' LATITUDE FAILED TO CONVERGE AFTER',I3,' ITERATIONS')
         IERR = 095
         RETURN
  380    IF (ABS(PHI) .LT. HALFPI) GO TO 400
         GEOG(2) = SIGN (HALFPI , Y)
         GEOG(1) = LON0
         CRDIO(1) = GEOG(1)
         CRDIO(2) = GEOG(2)
         RETURN
  400    SINPHI = SIN (PHI)
         COSPHI = COS (PHI)
         TANPHI = TAN (PHI)
         C = ESP * COSPHI * COSPHI
         CS = C * C
         T = TANPHI * TANPHI
         TS = T * T
         CON = ONE - ES * SINPHI * SINPHI
         N = A / SQRT (CON)
         R = N * (ONE - ES) / CON
         D = X / (N * KS0)
         DS = D * D
         GEOG(2) = PHI - (N * TANPHI * DS / R) * (HALF - DS / 24.0E0 *
     .             (FIVE + THREE * T + TEN * C - FOUR * CS - NINE * ESP
     .             - DS / 30.0E0 * (61.0E0 + 90.0E0 * T + 298.0E0 * C +
     .             45.0E0 * TS - 252.0E0 * ESP - THREE * CS)))
         GEOG(1) = ADJLSP (LON0 + (D * (ONE - DS / SIX * (ONE + TWO *
     .             T + C - DS / 20.0E0 * (FIVE - TWO * C + 28.0E0 * T -
     .             THREE * CS + EIGHT * ESP + 24.0E0 * TS))) / COSPHI))
         CRDIO(1) = GEOG(1)
         CRDIO(2) = GEOG(2)
         RETURN
      END IF
C
      END

      PROGRAM CAREDG
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Produce a Mercator projection of the Americas, using simplified 
C continental outlines.  See the routine MAPEOD, below.
C And draw a basic contour plot beside it.
C
      PARAMETER (M=40, N=40)
      REAL Z(M,N), RWRK (2000), PLIM1(2),PLIM2(2),PLIM3(2),PLIM4(2)
      INTEGER IWRK (2000)

      DATA PLIM1 /-60.,0./
      DATA PLIM2 /-170.,0./
      DATA PLIM3 /75.,0./
      DATA PLIM4 /-30.,0./
C
C Get some data
C
      CALL GENDAT(Z,M,M,N,1,25,1.0,25.)
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Turn off the clipping indicator.
C
      CALL GSCLIP (0)
C
C Draw the map.
C
      CALL MAPPOS (0.0,.53,0.53,1.)
      CALL SUPMAP (9,0.,0.,0.,PLIM1,PLIM2,PLIM3,PLIM4,2,0,2,0,IERR)
      CALL GETSET (VPL,VPR,VPB,VPT,WL,WR,WB,WT,LOG)
      CALL GSELNT (0)
      CALL PLCHHQ (.25,.50,'Geographic Map',.013,0.,0.)
C
C Draw contour plot
C
      CALL SET (.53, 1.,VPB,VPT,1.,REAL(M),1.,REAL(N),LOG)
      CALL CPSETR ('SET',0.)
      CALL CPSETR ('LLP',0.)
      CALL CPRECT (Z, M, M, N, RWRK, 2000, IWRK, 2000)
      CALL PERIM (0,0,0,0)
      CALL CPCLDR (Z, RWRK, IWRK)
      CALL GSELNT (0)
      CALL PLCHHQ (.75,.50,'Contour Map',.013,0.,0.)
C
C Draw Vertical Strips
C
      CALL SET(0.,1.,0.,1.,0.,1.,0.,1.,1)
      CALL LINE (.2,.05,.8,.05)
      CALL LINE (.2,.45,.8,.45)
      CALL LINE (.2,.05,.2,.45)
      CALL LINE (.3,.05,.3,.45)
      CALL LINE (.4,.05,.4,.45)
      CALL LINE (.5,.05,.5,.45)
      CALL LINE (.6,.05,.6,.45)
      CALL LINE (.7,.05,.7,.45)
      CALL LINE (.8,.05,.8,.45)
      CALL GSELNT (0)
      CALL PLCHHQ (.50,.01,'Vertical Strips',.013,0.,0.)
      CALL FRAME
C
C Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
C Done.
C
      STOP
C
      END

      SUBROUTINE GENDAT (DATA,IDIM,M,N,MLOW,MHGH,DLOW,DHGH)
C
C This is a routine to generate test data for two-dimensional graphics
C routines.  Given an array "DATA", dimensioned "IDIM x 1", it fills
C the sub-array ((DATA(I,J),I=1,M),J=1,N) with a two-dimensional field
C of data having approximately "MLOW" lows and "MHGH" highs, a minimum
C value of exactly "DLOW" and a maximum value of exactly "DHGH".
C
C "MLOW" and "MHGH" are each forced to be greater than or equal to 1
C and less than or equal to 25.
C
C The function used is a sum of exponentials.
C
        DIMENSION DATA(IDIM,1),CCNT(3,50)
C
        FOVM=9./REAL(M)
        FOVN=9./REAL(N)
C
        NLOW=MAX(1,MIN(25,MLOW))
        NHGH=MAX(1,MIN(25,MHGH))
        NCNT=NLOW+NHGH
C
        DO 101 K=1,NCNT
          CCNT(1,K)=1.+(REAL(M)-1.)*FRAN()
          CCNT(2,K)=1.+(REAL(N)-1.)*FRAN()
          IF (K.LE.NLOW) THEN
            CCNT(3,K)=-1.
          ELSE
            CCNT(3,K)=+1.
          END IF
  101   CONTINUE
C
        DMIN=+1.E36
        DMAX=-1.E36
        DO 104 J=1,N
          DO 103 I=1,M
            DATA(I,J)=.5*(DLOW+DHGH)
            DO 102 K=1,NCNT
              TEMP=-((FOVM*(REAL(I)-CCNT(1,K)))**2+
     +               (FOVN*(REAL(J)-CCNT(2,K)))**2)
              IF (TEMP.GE.-20.) DATA(I,J)=DATA(I,J)+
     +            .5*(DHGH-DLOW)*CCNT(3,K)*EXP(TEMP)
  102       CONTINUE
            DMIN=MIN(DMIN,DATA(I,J))
            DMAX=MAX(DMAX,DATA(I,J))
  103     CONTINUE
  104   CONTINUE
C
        DO 106 J=1,N
          DO 105 I=1,M
            DATA(I,J)=(DATA(I,J)-DMIN)/(DMAX-DMIN)*(DHGH-DLOW)+DLOW
  105     CONTINUE
  106   CONTINUE
C
        RETURN
C
      END
      FUNCTION FRAN ()
        DIMENSION RSEQ (100)
        SAVE ISEQ
        DATA RSEQ / .749,.973,.666,.804,.081,.483,.919,.903,.951,.960 ,
     +              .039,.269,.270,.756,.222,.478,.621,.063,.550,.798 ,
     +              .027,.569,.149,.697,.451,.738,.508,.041,.266,.249 ,
     +              .019,.191,.266,.625,.492,.940,.508,.406,.972,.311 ,
     +              .757,.378,.299,.536,.619,.844,.342,.295,.447,.499 ,
     +              .688,.193,.225,.520,.954,.749,.997,.693,.217,.273 ,
     +              .961,.948,.902,.104,.495,.257,.524,.100,.492,.347 ,
     +              .981,.019,.225,.806,.678,.710,.235,.600,.994,.758 ,
     +              .682,.373,.009,.469,.203,.730,.588,.603,.213,.495 ,
     +              .884,.032,.185,.127,.010,.180,.689,.354,.372,.429 /
        DATA ISEQ / 0 /
        ISEQ=MOD(ISEQ,100)+1
        FRAN=RSEQ(ISEQ)
        RETURN
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C                             Copyright (C)  1996                      C
C               University Corporation for Atmospheric Research        C
C                             All Rights Reserved                      C
C                                                                      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C    
C   File:         basic09f.f
C
C   Author:       Mary Haley
C                 National Center for Atmospheric Research
C                 PO 3000, Boulder, Colorado  80303
C
C   Date:         Wed Jul 10 09:16:08 MDT 1996
C
C   Description: This example displays all the available fonts
C
C
      external NhlFAppClass
      external NhlFNcgmWorkstationClass
      external NhlFCairoWindowWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFTextItemClass
C
C  List of available fonts (by number and name)
C
      character*2 font_nums(31)
      character*18 font_names(31)

      data font_nums/'1','2','3','4','5','6','7','8','9','10','11',
     +     '12','13','14','15','16','17','18','19','20','21','22',
     +     '25','26','29','30','33','34','35','36','37'/

      data font_names/'default','cartographic_roman',
     +     'cartographic_greek','simplex_roman','simplex_greek',
     +     'simplex_script','complex_roman','complex_greek',
     +     'complex_script','complex_italic','complex_cyrillic',
     +     'duplex_roman','triplex_roman','triplex_italic',
     +     'gothic_german','gothic_english','gothic_italian',
     +     'math_symbols','symbol_set1','symbol_set2','helvetica',
     +     'helvetica-bold','times-roman','times-bold','courier',
     +     'courier-bold','greek','math-symbols','text-symbols',
     +     'weather1','weather2'/

      integer appid,wid,txid1,txid2,txid3,txid4,rlist
      integer num_fonts, num_lines
      integer i, j, div1, mod1
      real k
      character*50 string

      character*7  wks_type
C
C Define the workstation type
C
      wks_type = "x11"

      num_fonts = 31
      num_lines = 18
C
C Initialize the high level utility library and create application.
C
      call NhlFInitialize
      call NhlFRLCreate(rlist,'SETRL')

      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'appUsrDir','./',ierr)
      call NhlFRLSetString(rlist,'appDefaultParent','True',ierr)
      call NhlFCreate(appid,'basic09',NhlFAppClass,0,rlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create a metafile workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkMetaName',
     &        './basic09f.ncgm',ierr)
         call NhlFCreate(wid,'wks',
     &        NhlFNcgmWorkstationClass,0,rlist,ierr)
      endif

      if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X workstation.         
C      
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPause','True',ierr)
         call NhlFCreate(wid,'wks',
     +        NhlFCairoWindowWorkstationClass,
     &        0,rlist,ierr)
      endif

      if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PS workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPSFileName',
     &        './basic09f.ps',ierr)
         call NhlFCreate(wid,'wks',NhlFPSWorkstationClass,
     &        0,rlist,ierr)
      endif
      if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPDFFileName',
     &        './basic09f.pdf',ierr)
         call NhlFCreate(wid,'wks',NhlFPDFWorkstationClass,
     &        0,rlist,ierr)
      endif
      if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     &    wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFileName',
     &        './basic09f',ierr)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(wid,'wks',NhlFCairoPSPDFWorkstationClass,
     &        0,rlist,ierr)
      endif
      if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFileName',
     &        './basic09f',ierr)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(wid,'wks',NhlFCairoImageWorkstationClass,
     &        0,rlist,ierr)
      endif
C
C We only want num_lins lines on a page
C
      div1 = num_fonts / num_lines
      mod1 = mod(num_fonts,num_lines)
      if (mod1.ne.0) div1 = div1 + 1
C
C Create header to put on all frames
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'txFuncCode','*',ierr)
      call NhlFRLSetFloat(rlist,'txPosXF',0.32,ierr)
      call NhlFRLSetFloat(rlist,'txPosYF',0.98,ierr)
      call NhlFRLSetFloat(rlist,'txFontHeightF',0.02,ierr)
      call NhlFRLSetInteger(rlist,'txFontColor',3,ierr)
      call NhlFRLSetString(rlist,'txString','font number : font name',
     +     ierr)
      call NhlFCreate(txid1,'TextItem1',NhlFtextItemClass,wid,rlist,
     +     ierr)

      call NhlFRLClear(rlist)
      call NhlFRLSetFloat(rlist,'txPosXF',0.72,ierr)
      call NhlFRLSetFloat(rlist,'txPosYF',0.98,ierr)
      call NhlFRLSetFloat(rlist,'txFontHeightF',0.02,ierr)
      call NhlFRLSetInteger(rlist,'txFontColor',5,ierr)
      call NhlFRLSetString(rlist,'txString','font example',ierr)
      call NhlFCreate(txid2,'TextItem2',NhlFtextItemClass,wid,rlist,
     +     ierr)
      do 40 j = 1,div1
         k = 0.90
         call NhlFDraw(txid1,ierr)
         call NhlFDraw(txid2,ierr)
C
C Loop over each font
C
         do 30 i=(j-1)*num_lines,min(num_fonts-1,j*num_lines-1)
            string = font_nums(i+1) // ' : ' // font_names(i+1)
C
C Font number and name
C
            call NhlFRLClear(rlist)
            call NhlFRLSetInteger(rlist,'txJust',2,ierr)
            call NhlFRLSetString(rlist,'txFuncCode','*',ierr)
            call NhlFRLSetFloat(rlist,'txPosXF',0.1,ierr)
            call NhlFRLSetFloat(rlist,'txPosYF',k,ierr)
            call NhlFRLSetFloat(rlist,'txFontHeightF',0.02,ierr)
            call NhlFRLSetInteger(rlist,'txFontColor',3,ierr)
            call NhlFRLSetString(rlist,'txString',string,ierr)
            call NhlFCreate(txid3,'TextItem3',NhlFtextItemClass,wid,
     +           rlist,ierr)
C
C Actual font drawn using the words 'NCAR Graphics'
C
            call NhlFRLClear(rlist)
            call NhlFRLSetInteger(rlist,'txJust',2,ierr)
            call NhlFRLSetString(rlist,'txFont',font_names(i+1),ierr)
            call NhlFRLSetFloat(rlist,'txPosXF',0.6,ierr)
            call NhlFRLSetFloat(rlist,'txPosYF',k,ierr)
            call NhlFRLSetFloat(rlist,'txFontHeightF',0.02,ierr)
            call NhlFRLSetInteger(rlist,'txFontColor',5,ierr)
            call NhlFRLSetString(rlist,'txString','NCAR Graphics',ierr)
            call NhlFCreate(txid4,'TextItem4',NhlFtextItemClass,wid,
     +           rlist,ierr)
            call NhlFDraw(txid3,ierr)
            call NhlFDraw(txid4,ierr)
            call NhlFDestroy(txid3,ierr)
            call NhlFDestroy(txid4,ierr)
            k = k - 0.05
 30      continue
         call NhlFFrame(wid,ierr)
 40   continue
C
C Clean up.
C
      call NhlFDestroy(wid,ierr)
      call NhlFClose
      stop
      end

C;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
C;                                                                       ;
C;                Copyright (C)  1996                                    ;
C;        University Corporation for Atmospheric Research                ;
C;                All Rights Reserved                                    ;
C;                                                                       ;
C;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
C 
C    File:       pr01f.f
C 
C    Author: Lynn Hermanson
C            National Center for Atmospheric Research
C            PO 3000, Boulder, Colorado
C  
C    Date:       May 6, 1996
C 
C    Description:     Given an array of xaxis values and 
C                     an array of yaxis values, where each 
C                     x,y pair corresponds to one vertex or
C                     the location of one point, draw a
C                     square (a polyline), four points (asterisks)
C                     at the corners of a square (a polymarker), and
C                     a rectangular filled area (a polygon),on to
C                     a blank canvas (an empty default logLinPlot).

C                     Polylines, polymarkers, and polygons, are
C                     refered to as primitives.

C

      external NhlFAppClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFCairoWindowWorkstationClass
      external NhlFMapPlotClass
      external NhlFVectorFieldClass
      external NhlFLogLinPlotClass
      external NhlFGraphicStyleClass

      integer appid,wid,cid,gsid
      integer rlist,ierr
      parameter(N=5)
      parameter(M=4)
      parameter(K=5)
      real X(N),Y(N)
      real U(M),V(M)
      real PX(K),PY(K)
      character*7  wks_type
C
C Define the workstation type
C
      wks_type = "x11"

C
C These are the polyline points /*a square*/
C

      X(1) = .3
      X(2) = .3
      X(3) = .5
      X(4) = .5
      X(5) = .3
      Y(1) = .3
      Y(2) = .5
      Y(3) = .5
      Y(4) = .3
      Y(5) = .3

C
C These are the polymarker points /*four corner points*/
C
      U(1) = .4
      U(2) = .4
      U(3) = .6
      U(4) = .6
      V(1) = .4
      V(2) = .6
      V(3) = .6
      V(4) = .4

C
C These are the polygon points /*a filled rectangle*/ 
C
      PX(1) = .7
      PX(2) = .7
      PX(3) = .8
      PX(4) = .8
      PX(5) = .7
      PY(1) = .2
      PY(2) = .8
      PY(3) = .8
      PY(4) = .2
      PY(5) = .2

C
C  Initialize the high level utility library
C
      call NhlFInitialize()

C Next,
C  create an application context. Set the app dir to the current directory
C  so the application looks for a resource file in the working directory.
C  In the following example default resources are used. 
C
      call NhlFRLCreate(rlist,'SETRL')
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'pr01',NhlFappClass,
     1    NhlFDEFAULT_APP,rlist,ierr)

C  Choose to display output to an X11 workstation.(set above)*/

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C  Create a meta file workstation.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'wkMetaName','./pr01f.ncgm',ierr)
      call NhlFCreate(wid,'pr01Work',NhlFncgmWorkstationClass,
     1     appid,rlist,ierr)
    
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C  Create an X workstation.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetInteger(rlist,'wkPause','true',ierr)
      call NhlFCreate(wid,'pr01Work',
     1            NhlFCairoWindowWorkstationClass,
     1            appid,rlist,ierr)
    

      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C  Create an older-style PS workstation.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'wkPSFileName','./pr01f.ps',ierr)
      call NhlFCreate(wid,'pr01Work',NhlFpsWorkstationClass,
     1    appid,rlist,ierr)

      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C  Create an older-style PDF workstation.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'wkPDFFileName','./pr01f.pdf',ierr)
      call NhlFCreate(wid,'pr01Work',NhlFpdfWorkstationClass,
     1    appid,rlist,ierr)

      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C  Create a cairo PS/PDF workstation.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
      call NhlFRLSetString(rlist,'wkFileName','./pr01f',ierr)
      call NhlFCreate(wid,'pr01Work',
     1    NhlFCairoPSpdfWorkstationClass,appid,rlist,ierr)

      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C  Create a cairo PNG workstation.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
      call NhlFRLSetString(rlist,'wkFileName','./pr01f',ierr)
      call NhlFCreate(wid,'pr01Work',
     1    NhlFCairoImageWorkstationClass,appid,rlist,ierr)

      endif    

C  Create a blank plot object to draw the primitives on.*/

      call NhlFRLClear(rlist)
      call NhlFCreate(cid,'canvas',NhlFlogLinPlotClass,
     1    wid,rlist,ierr)

C  Create a graphicPlot object consisting of, the default styles.*/
C  The graphicStyle object is NOT a stand-alone plot object. There
C    must exist some kind of plot object which has already been drawn
C    to place the primitives on.

      call NhlFRLClear(rlist)
      call NhlFCreate(gsid,'defaultstyle',NhlFgraphicStyleClass,
     1    wid,rlist,ierr)


C  Draw the shapes onto the blank logLinPlot object.
C  Signify end of frame.*/

      call NhlFDraw(cid,ierr)

C The last paramenter is the number of points required*/

      call NhlFNDCPolyline(cid, gsid, X, Y,5,ierr)
      call NhlFNDCPolymarker(cid, gsid, U, V,4,ierr)
      call NhlFNDCPolygon(cid, gsid, PX, PY,5,ierr)
      call NhlFFrame(wid,ierr)

C  Destroy all of the objects created, close the HLU library and exit.*/

      call NhlFDestroy(cid,ierr)
      call NhlFDestroy(wid,ierr)
      call NhlFDestroy(appid,ierr)
      call NhlFClose  

      stop
      end

      PROGRAM CCPCNRC
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER (M=50, N=50)
      REAL ZREG(M,N)
C
C Get some data
C
      CALL MKDAT (3,ZREG, M, N)
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Call CPEZCT
C
      CALL CPCNRC (ZREG,M,M,N,-40.,50.,10.,0,0,-366)
C
C Advance frame
C
      CALL FRAME
C
C Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
C Done.
C
      STOP
      END

      SUBROUTINE MKDAT(NCTFR,ZDAT,M,N)
C
C Create some data to contour
C
      REAL ZDAT(M,N)
C
C NCTFR is used to generate a random number, ZDAT is the data array
C
      CALL GGDINI (0.,1.,NCTFR,.9)
      ZMIN= 1.E36
      ZMAX=-1.E36
      DO 10 I=1,M
         RLON=.017453292519943*(-180.+360.*REAL(I-1)/REAL(M-1))
         DO 20 J=1,N
            RLAT=.017453292519943*(-90.+180.*REAL(J-1)/REAL(N-1))
            ZDAT(I,J)=GGDPNT(RLAT,RLON)+.5*COS(4.*RLAT)
            ZMIN=MIN(ZMIN,ZDAT(I,J))
            ZMAX=MAX(ZMAX,ZDAT(I,J))
 20      CONTINUE
 10   CONTINUE
      DO 30 I=1,M
         DO 40 J=1,N
            ZDAT(I,J)=((ZDAT(I,J)-ZMIN)/(ZMAX-ZMIN))*130.-50.
 40      CONTINUE
 30   CONTINUE
      
      RETURN
      END

C
C $Id: nggcog.f,v 1.4 2008-07-27 00:17:17 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE NGGCOG (CLAT,CLON,CRAD,ALAT,ALON,NPTS)
C
C This routine returns, in the arrays ALAT and ALON, the latitudes and
C longitudes of NPTS points on the surface of the globe, all of them at
C the great-circle distance CRAD from the point (CLAT,CLON), defining a
C circle.  The last point returned is a copy of the first.
C
        DIMENSION ALAT(*),ALON(*)
C
C Define multiplicative constants to convert from degrees to radians
C and from radians to degrees.
C
        DATA DTOR / .017453292519943 /
        DATA RTOD / 57.2957795130823 /
C
C Points on a circle around the North Pole are rotated to lie around
C the point at latitude CLAT and longitude CLON.
C
        RLAT=DTOR*(90.-CRAD)
C
        DO 101 IPNT=1,NPTS
          RLON=DTOR*360.*(REAL(IPNT-1)/REAL(NPTS-1))
          UCRD=COS(RLAT)*COS(RLON)
          VCRD=COS(RLAT)*SIN(RLON)
          WCRD=SIN(RLAT)
          CALL NGRITD (2,90.-CLAT,UCRD,VCRD,WCRD)
          CALL NGRITD (3,    CLON,UCRD,VCRD,WCRD)
          ALAT(IPNT)=RTOD*ASIN(WCRD)
          ALON(IPNT)=RTOD*ATAN2(VCRD,UCRD)
  101   CONTINUE
C
C Done.
C
        RETURN
C
      END

C
C	$Id: g01esc.f,v 1.6 2008-07-27 00:21:05 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE G01ESC
C
C  Process ESCAPE elements.
C
      include 'g01prm.h'
      include 'gksin.h'
      include 'g01ins.h'
C
      INTEGER  KALL, NBYTES, G01PBL
      SAVE KALL
      DATA KALL/0/
      KALL = KALL+1
C
C  Treat the first call -- put out the opcode, FCTID, and first data
C  record if there is one.
C
      IF (KALL .EQ. 1) THEN
        IF (STRL1 .GT. 0) THEN
          NBYTES = G01PBL(STRL1,1+(MINTFW-1)/8)
        ELSE
C
C  Two bytes for the function identifier and one for the string
C  count of the empty string.
C
          NBYTES = 3
        ENDIF
C
C  Put out class, id, length
C
        CALL GPUTNI (6, 1, NBYTES, RERR)
        IF (RERR .NE. 0)  RETURN
C
C  Put out function identifier (2-byte integer).
C
        CALL GPUTPR (ID(1),MINTFW,1,RERR)
        IF (RERR .NE. 0)  RETURN
C
C  Put out first data record if there is one.
C
        IF (STRL2 .EQ. 0) THEN
          CALL GPUTPS (STR, STRL1,  0, 0, RERR)
        ELSE IF (STRL2 .GT. 0) THEN
          CALL GPUTPS (STR, STRL1, 80, 0, RERR)
        ENDIF
        IF (RERR .NE. 0)  RETURN
C
C  If there is to be no continuation, check for consistency, and
C  reset the parameter "KALL".
C
        IF (CONT .EQ. 0) THEN
          IF (MOD(STRL1,80) .EQ. 0) THEN
            KALL = 0
            RETURN
          ELSE
            RERR = 325
            RETURN
          ENDIF
        ENDIF
      ENDIF
C
C  Treat the continuation calls.
C
      IF (KALL .GT. 1) THEN
        IF (CONT .EQ. 0) THEN
          CALL GPUTPS (STR, 80, 80, 1, RERR)
          IF (RERR .NE. 0)  RETURN
          KALL = 0
        ELSE
          CALL GPUTPS (STR, 80, 80, 1, RERR)
          IF (RERR .NE. 0)  RETURN
        ENDIF
      ENDIF
C
      RETURN
      END

C
C	$Id: csaddnod.f,v 1.6 2008-07-27 03:10:05 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CSADDNOD (NST,K,X,Y,Z, LIST,LPTR,LEND,
     .                   LNEW, IER)
      INTEGER NST, K, LIST(*), LPTR(*), LEND(K), LNEW, IER
      DOUBLE PRECISION X(K), Y(K), Z(K)
C
C***********************************************************
C
C                                              From STRIPACK
C                                            Robert J. Renka
C                                  Dept. of Computer Science
C                                       Univ. of North Texas
C                                           renka@cs.unt.edu
C                                                   10/10/99
C
C   This subroutine adds node K to a triangulation of the
C convex hull of nodes 1,...,K-1, producing a triangulation
C of the convex hull of nodes 1,...,K.
C
C   The algorithm consists of the following steps:  node K
C is located relative to the triangulation (CSTRFIND), its
C index is added to the data structure (CSINTADD or CSBDYADD),
C and a sequence of swaps (CSSWPTST and CSSWAP) are applied to
C the arcs opposite K so that all arcs incident on node K
C and opposite node K are locally optimal (satisfy the cir-
C cumcircle test).  Thus, if a Delaunay triangulation is
C input, a Delaunay triangulation will result.
C
C
C On input:
C
C       NST = Index of a node at which CSTRFIND begins its
C             search.  Search time depends on the proximity
C             of this node to K.  If NST < 1, the search is
C             begun at node K-1.
C
C       K = Nodal index (index for X, Y, Z, and LEND) of the
C           new node to be added.  K .GE. 4.
C
C       X,Y,Z = Arrays of length .GE. K containing Car-
C               tesian coordinates of the nodes.
C               (X(I),Y(I),Z(I)) defines node I for
C               I = 1,...,K.
C
C The above parameters are not altered by this routine.
C
C       LIST,LPTR,LEND,LNEW = Data structure associated with
C                             the triangulation of nodes 1
C                             to K-1.  The array lengths are
C                             assumed to be large enough to
C                             add node K.  Refer to Subrou-
C                             tine CSTRMESH.
C
C On output:
C
C       LIST,LPTR,LEND,LNEW = Data structure updated with
C                             the addition of node K as the
C                             last entry unless IER .NE. 0
C                             and IER .NE. -3, in which case
C                             the arrays are not altered.
C
C       IER = Error indicator:
C             IER =  0 if no errors were encountered.
C             IER = -1 if K is outside its valid range
C                      on input.
C             IER = -2 if all nodes (including K) are col-
C                      linear (lie on a common geodesic).
C             IER =  L if nodes L and K coincide for some
C                      L < K.
C
C Modules required by CSADDNOD:  CSBDYADD, CSCOVSPH, CSINSERT,
C                                CSINTADD, CSJRAND, CSLSTPTR,
C                                CSSTORE, CSSWAP, CSSWPTST,
C                                CSTRFIND
C
C Intrinsic function called by CSADDNOD:  ABS
C
C***********************************************************
C
      INTEGER CSLSTPTR
      INTEGER I1, I2, I3, IO1, IO2, IN1, IST, KK, KM1, L,
     .        LP, LPF, LPO1, LPO1S
      LOGICAL CSSWPTST
      DOUBLE PRECISION B1, B2, B3, P(3)
C
C Local parameters:
C
C B1,B2,B3 = Unnormalized barycentric coordinates returned
C              by CSTRFIND.
C I1,I2,I3 = Vertex indexes of a triangle containing K
C IN1 =      Vertex opposite K:  first neighbor of IO2
C              that precedes IO1.  IN1,IO1,IO2 are in
C              counterclockwise order.
C IO1,IO2 =  Adjacent neighbors of K defining an arc to
C              be tested for a swap
C IST =      Index of node at which CSTRFIND begins its search
C KK =       Local copy of K
C KM1 =      K-1
C L =        Vertex index (I1, I2, or I3) returned in IER
C              if node K coincides with a vertex
C LP =       LIST pointer
C LPF =      LIST pointer to the first neighbor of K
C LPO1 =     LIST pointer to IO1
C LPO1S =    Saved value of LPO1
C P =        Cartesian coordinates of node K
C
      KK = K
      IF (KK .LT. 4) GO TO 3
C
C Initialization:
C
      KM1 = KK - 1
      IST = NST
      IF (IST .LT. 1) IST = KM1
      P(1) = X(KK)
      P(2) = Y(KK)
      P(3) = Z(KK)
C
C Find a triangle (I1,I2,I3) containing K or the rightmost
C   (I1) and leftmost (I2) visible boundary nodes as viewed
C   from node K.
C
      CALL CSTRFIND (IST,P,KM1,X,Y,Z,LIST,LPTR,LEND, B1,B2,B3,
     .             I1,I2,I3)
C
C   Test for collinear or duplicate nodes.
C
      IF (I1 .EQ. 0) GO TO 4
      IF (I3 .NE. 0) THEN
        L = I1
        IF (P(1) .EQ. X(L)  .AND.  P(2) .EQ. Y(L)  .AND.
     .      P(3) .EQ. Z(L)) GO TO 5
        L = I2
        IF (P(1) .EQ. X(L)  .AND.  P(2) .EQ. Y(L)  .AND.
     .      P(3) .EQ. Z(L)) GO TO 5
        L = I3
        IF (P(1) .EQ. X(L)  .AND.  P(2) .EQ. Y(L)  .AND.
     .      P(3) .EQ. Z(L)) GO TO 5
        CALL CSINTADD (KK,I1,I2,I3, LIST,LPTR,LEND,LNEW )
      ELSE
        IF (I1 .NE. I2) THEN
          CALL CSBDYADD (KK,I1,I2, LIST,LPTR,LEND,LNEW )
        ELSE
          CALL CSCOVSPH (KK,I1, LIST,LPTR,LEND,LNEW )
        ENDIF
      ENDIF
      IER = 0
C
C Initialize variables for optimization of the
C   triangulation.
C
      LP = LEND(KK)
      LPF = LPTR(LP)
      IO2 = LIST(LPF)
      LPO1 = LPTR(LPF)
      IO1 = ABS(LIST(LPO1))
C
C Begin loop:  find the node opposite K.
C
    1 LP = CSLSTPTR(LEND(IO1),IO2,LIST,LPTR)
        IF (LIST(LP) .LT. 0) GO TO 2
        LP = LPTR(LP)
        IN1 = ABS(LIST(LP))
C
C Swap test:  if a swap occurs, two new arcs are
C             opposite K and must be tested.
C
        LPO1S = LPO1
        IF ( .NOT. CSSWPTST(IN1,KK,IO1,IO2,X,Y,Z) ) GO TO 2
        CALL CSSWAP (IN1,KK,IO1,IO2, LIST,LPTR,LEND, LPO1)
        IF (LPO1 .EQ. 0) THEN
C
C   A swap is not possible because KK and IN1 are already
C     adjacent.  This error in CSSWPTST only occurs in the
C     neutral case and when there are nearly duplicate
C     nodes.
C
          LPO1 = LPO1S
          GO TO 2
        ENDIF
        IO1 = IN1
        GO TO 1
C
C No swap occurred.  Test for termination and reset
C   IO2 and IO1.
C
    2   IF (LPO1 .EQ. LPF  .OR.  LIST(LPO1) .LT. 0) RETURN
        IO2 = IO1
        LPO1 = LPTR(LPO1)
        IO1 = ABS(LIST(LPO1))
        GO TO 1
C
C KK < 4.
C
    3 IER = -1
      RETURN
C
C All nodes are collinear.
C
    4 IER = -2
      RETURN
C
C Nodes L and K coincide.
C
    5 IER = L
      RETURN
      END

C
C $Id: curvidp.f,v 1.3 2008-07-27 03:10:10 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
C NOTE: If you make any changes to this software, please remember to
C make the same changes to the corresponding single precision routine.
C
      FUNCTION CURVIDP(XL,XU,N,X,Y,YP,SIGMA)
      DOUBLE PRECISION CURVIDP
      DOUBLE PRECISION SIGMAP
      DOUBLE PRECISION XXL
      DOUBLE PRECISION XXU
      DOUBLE PRECISION SSIGN
      DOUBLE PRECISION SUM
      DOUBLE PRECISION DEL1
      DOUBLE PRECISION DEL2
      DOUBLE PRECISION DELS
      DOUBLE PRECISION T1
      DOUBLE PRECISION T2
      DOUBLE PRECISION DUMMY
      DOUBLE PRECISION C1
      DOUBLE PRECISION C2
      DOUBLE PRECISION SS
      DOUBLE PRECISION CS
      DOUBLE PRECISION DELU1
      DOUBLE PRECISION DELU2
      DOUBLE PRECISION DELL1
      DOUBLE PRECISION DELL2
      DOUBLE PRECISION DELI
      DOUBLE PRECISION CU1
      DOUBLE PRECISION CU2
      DOUBLE PRECISION CL1
      DOUBLE PRECISION CL2
c
      INTEGER N
      DOUBLE PRECISION XL,XU,X(N),Y(N),YP(N),SIGMA
c
c                                 coded by alan kaylor cline
c                           from fitpack -- january 26, 1987
c                        a curve and surface fitting package
c                      a product of pleasant valley software
c                  8603 altus cove, austin, texas 78759, usa
c
c this function integrates a curve specified by a spline
c under tension between two given limits. the subroutine
c curv1 should be called earlier to determine necessary
c parameters.
c
c on input--
c
c   xl and xu contain the upper and lower limits of inte-
c   gration, respectively. (sl need not be less than or
c   equal to xu, curvidp (xl,xu,...) .eq. -curvidp (xu,xl,...) ).
c
c   n contains the number of points which were specified to
c   determine the curve.
c
c   x and y are arrays containing the abscissae and
c   ordinates, respectively, of the specified points.
c
c   yp is an array from subroutine curv1 containing
c   the values of the second derivatives at the nodes.
c
c and
c
c   sigma contains the tension factor (its sign is ignored).
c
c the parameters n, x, y, yp, and sigma should be input
c unaltered from the output of curv1.
c
c on output--
c
c   curvidp contains the integral value.
c
c none of the input parameters are altered.
c
c this function references package modules intrvldp and
c snhcshdp.
c
c-----------------------------------------------------------
c
c denormalize tension factor
c
      SIGMAP = ABS(SIGMA)*DBLE(N-1)/ (X(N)-X(1))
c
c determine actual upper and lower bounds
c
      XXL = XL
      XXU = XU
      SSIGN = 1.D0
      IF (XL.LT.XU) GO TO 1
      XXL = XU
      XXU = XL
      SSIGN = -1.D0
      IF (XL.GT.XU) GO TO 1
c
c return zero if xl .eq. xu
c
      CURVIDP = 0.D0
      RETURN
c
c search for proper intervals
c
    1 ILM1 = INTRVLDP(XXL,X,N)
      IL = ILM1 + 1
      IUM1 = INTRVLDP(XXU,X,N)
      IU = IUM1 + 1
      IF (IL.EQ.IU) GO TO 8
c
c integrate from xxl to x(il)
c
      SUM = 0.D0
      IF (XXL.EQ.X(IL)) GO TO 3
      DEL1 = XXL - X(ILM1)
      DEL2 = X(IL) - XXL
      DELS = X(IL) - X(ILM1)
      T1 = (DEL1+DELS)*DEL2/ (2.D0*DELS)
      T2 = DEL2*DEL2/ (2.D0*DELS)
      SUM = T1*Y(IL) + T2*Y(ILM1)
      IF (SIGMA.EQ.0.D0) GO TO 2
      CALL SNHCSHDP(DUMMY,C1,SIGMAP*DEL1,2)
      CALL SNHCSHDP(DUMMY,C2,SIGMAP*DEL2,2)
      CALL SNHCSHDP(SS,CS,SIGMAP*DELS,3)
      SUM = SUM + ((DELS*DELS* (CS-SS/2.D0)-DEL1*DEL1* (C1-SS/2.D0))*
     +      YP(IL)+DEL2*DEL2* (C2-SS/2.D0)*YP(ILM1))/
     +      (SIGMAP*SIGMAP*DELS* (1.D0+SS))
      GO TO 3
    2 SUM = SUM - T1*T1*DELS*YP(IL)/6.D0 -
     +      T2* (DEL1* (DEL2+DELS)+DELS*DELS)*YP(ILM1)/12.D0
c
c integrate over interior intervals
c
    3 IF (IU-IL.EQ.1) GO TO 6
      ILP1 = IL + 1
      DO 5 I = ILP1,IUM1
          DELS = X(I) - X(I-1)
          SUM = SUM + (Y(I)+Y(I-1))*DELS/2.D0
          IF (SIGMA.EQ.0.D0) GO TO 4
          CALL SNHCSHDP(SS,CS,SIGMAP*DELS,3)
          SUM = SUM + (YP(I)+YP(I-1))*DELS* (CS-SS/2.D0)/
     +          (SIGMAP*SIGMAP* (1.D0+SS))
          GO TO 5
    4     SUM = SUM - (YP(I)+YP(I-1))*DELS*DELS*DELS/24.D0
    5 CONTINUE
c
c integrate from x(iu-1) to xxu
c
    6 IF (XXU.EQ.X(IUM1)) GO TO 10
      DEL1 = XXU - X(IUM1)
      DEL2 = X(IU) - XXU
      DELS = X(IU) - X(IUM1)
      T1 = DEL1*DEL1/ (2.D0*DELS)
      T2 = (DEL2+DELS)*DEL1/ (2.D0*DELS)
      SUM = SUM + T1*Y(IU) + T2*Y(IUM1)
      IF (SIGMA.EQ.0.D0) GO TO 7
      CALL SNHCSHDP(DUMMY,C1,SIGMAP*DEL1,2)
      CALL SNHCSHDP(DUMMY,C2,SIGMAP*DEL2,2)
      CALL SNHCSHDP(SS,CS,SIGMAP*DELS,3)
      SUM = SUM + (YP(IU)*DEL1*DEL1* (C1-SS/2.D0)+
     +      YP(IUM1)* (DELS*DELS* (CS-SS/2.D0)-DEL2*DEL2* (C2-SS/2.D0)))
     +      / (SIGMAP*SIGMAP*DELS* (1.D0+SS))
      GO TO 10
    7 SUM = SUM - T1* (DEL2* (DEL1+DELS)+DELS*DELS)*YP(IU)/12.D0 -
     +      T2*T2*DELS*YP(IUM1)/6.D0
      GO TO 10
c
c integrate from xxl to xxu
c
    8 DELU1 = XXU - X(IUM1)
      DELU2 = X(IU) - XXU
      DELL1 = XXL - X(IUM1)
      DELL2 = X(IU) - XXL
      DELS = X(IU) - X(IUM1)
      DELI = XXU - XXL
      T1 = (DELU1+DELL1)*DELI/ (2.D0*DELS)
      T2 = (DELU2+DELL2)*DELI/ (2.D0*DELS)
      SUM = T1*Y(IU) + T2*Y(IUM1)
      IF (SIGMA.EQ.0.D0) GO TO 9
      CALL SNHCSHDP(DUMMY,CU1,SIGMAP*DELU1,2)
      CALL SNHCSHDP(DUMMY,CU2,SIGMAP*DELU2,2)
      CALL SNHCSHDP(DUMMY,CL1,SIGMAP*DELL1,2)
      CALL SNHCSHDP(DUMMY,CL2,SIGMAP*DELL2,2)
      CALL SNHCSHDP(SS,DUMMY,SIGMAP*DELS,-1)
      SUM = SUM + (YP(IU)* (DELU1*DELU1* (CU1-SS/2.D0)-
     +      DELL1*DELL1* (CL1-SS/2.D0))+YP(IUM1)*
     +      (DELL2*DELL2* (CL2-SS/2.D0)-DELU2*DELU2* (CU2-SS/2.D0)))/
     +      (SIGMAP*SIGMAP*DELS* (1.D0+SS))
      GO TO 10
    9 SUM = SUM - T1* (DELU2* (DELS+DELU1)+DELL2* (DELS+DELL1))*YP(IU)/
     +      12.D0 - T2* (DELL1* (DELS+DELL2)+DELU1* (DELS+DELU2))*
     +      YP(IUM1)/12.D0
c
c correct sign and return
c
   10 CURVIDP = SSIGN*SUM
      RETURN
      END

      SUBROUTINE SGGGLM( N, M, P, A, LDA, B, LDB, D, X, Y, WORK, LWORK,
     $                   INFO )
*
*  -- LAPACK driver routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      INTEGER            INFO, LDA, LDB, LWORK, M, N, P
*     ..
*     .. Array Arguments ..
      REAL               A( LDA, * ), B( LDB, * ), D( * ), WORK( * ),
     $                   X( * ), Y( * )
*     ..
*
*  Purpose
*  =======
*
*  SGGGLM solves a general Gauss-Markov linear model (GLM) problem:
*
*          minimize || y ||_2   subject to   d = A*x + B*y
*              x
*
*  where A is an N-by-M matrix, B is an N-by-P matrix, and d is a
*  given N-vector. It is assumed that M <= N <= M+P, and
*
*             rank(A) = M    and    rank( A B ) = N.
*
*  Under these assumptions, the constrained equation is always
*  consistent, and there is a unique solution x and a minimal 2-norm
*  solution y, which is obtained using a generalized QR factorization
*  of A and B.
*
*  In particular, if matrix B is square nonsingular, then the problem
*  GLM is equivalent to the following weighted linear least squares
*  problem
*
*               minimize || inv(B)*(d-A*x) ||_2
*                   x
*
*  where inv(B) denotes the inverse of B.
*
*  Arguments
*  =========
*
*  N       (input) INTEGER
*          The number of rows of the matrices A and B.  N >= 0.
*
*  M       (input) INTEGER
*          The number of columns of the matrix A.  0 <= M <= N.
*
*  P       (input) INTEGER
*          The number of columns of the matrix B.  P >= N-M.
*
*  A       (input/output) REAL array, dimension (LDA,M)
*          On entry, the N-by-M matrix A.
*          On exit, A is destroyed.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A. LDA >= max(1,N).
*
*  B       (input/output) REAL array, dimension (LDB,P)
*          On entry, the N-by-P matrix B.
*          On exit, B is destroyed.
*
*  LDB     (input) INTEGER
*          The leading dimension of the array B. LDB >= max(1,N).
*
*  D       (input/output) REAL array, dimension (N)
*          On entry, D is the left hand side of the GLM equation.
*          On exit, D is destroyed.
*
*  X       (output) REAL array, dimension (M)
*  Y       (output) REAL array, dimension (P)
*          On exit, X and Y are the solutions of the GLM problem.
*
*  WORK    (workspace/output) REAL array, dimension (LWORK)
*          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*
*  LWORK   (input) INTEGER
*          The dimension of the array WORK. LWORK >= max(1,N+M+P).
*          For optimum performance, LWORK >= M+min(N,P)+max(N,P)*NB,
*          where NB is an upper bound for the optimal blocksizes for
*          SGEQRF, SGERQF, SORMQR and SORMRQ.
*
*          If LWORK = -1, then a workspace query is assumed; the routine
*          only calculates the optimal size of the WORK array, returns
*          this value as the first entry of the WORK array, and no error
*          message related to LWORK is issued by XERBLA.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit.
*          < 0:  if INFO = -i, the i-th argument had an illegal value.
*
*  ===================================================================
*
*     .. Parameters ..
      REAL               ZERO, ONE
      PARAMETER          ( ZERO = 0.0E+0, ONE = 1.0E+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            LQUERY
      INTEGER            I, LOPT, LWKOPT, NB, NB1, NB2, NB3, NB4, NP
*     ..
*     .. External Subroutines ..
      EXTERNAL           SCOPY, SGEMV, SGGQRF, SORMQR, SORMRQ, STRSV,
     $                   XERBLA
*     ..
*     .. External Functions ..
      INTEGER            ILAENV
      EXTERNAL           ILAENV 
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          INT, MAX, MIN
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters
*
      INFO = 0
      NP = MIN( N, P )
      NB1 = ILAENV( 1, 'SGEQRF', ' ', N, M, -1, -1 )
      NB2 = ILAENV( 1, 'SGERQF', ' ', N, M, -1, -1 )
      NB3 = ILAENV( 1, 'SORMQR', ' ', N, M, P, -1 )
      NB4 = ILAENV( 1, 'SORMRQ', ' ', N, M, P, -1 )
      NB = MAX( NB1, NB2, NB3, NB4 )
      LWKOPT = M + NP + MAX( N, P )*NB
      WORK( 1 ) = LWKOPT
      LQUERY = ( LWORK.EQ.-1 )
      IF( N.LT.0 ) THEN
         INFO = -1
      ELSE IF( M.LT.0 .OR. M.GT.N ) THEN
         INFO = -2
      ELSE IF( P.LT.0 .OR. P.LT.N-M ) THEN
         INFO = -3
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -5
      ELSE IF( LDB.LT.MAX( 1, N ) ) THEN
         INFO = -7
      ELSE IF( LWORK.LT.MAX( 1, N+M+P ) .AND. .NOT.LQUERY ) THEN
         INFO = -12
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'SGGGLM', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
*
*     Compute the GQR factorization of matrices A and B:
*
*            Q'*A = ( R11 ) M,    Q'*B*Z' = ( T11   T12 ) M
*                   (  0  ) N-M             (  0    T22 ) N-M
*                      M                     M+P-N  N-M
*
*     where R11 and T22 are upper triangular, and Q and Z are
*     orthogonal.
*
      CALL SGGQRF( N, M, P, A, LDA, WORK, B, LDB, WORK( M+1 ),
     $             WORK( M+NP+1 ), LWORK-M-NP, INFO )
      LOPT = WORK( M+NP+1 )
*
*     Update left-hand-side vector d = Q'*d = ( d1 ) M
*                                             ( d2 ) N-M
*
      CALL SORMQR( 'Left', 'Transpose', N, 1, M, A, LDA, WORK, D,
     $             MAX( 1, N ), WORK( M+NP+1 ), LWORK-M-NP, INFO )
      LOPT = MAX( LOPT, INT( WORK( M+NP+1 ) ) )
*
*     Solve T22*y2 = d2 for y2
*
      CALL STRSV( 'Upper', 'No transpose', 'Non unit', N-M,
     $            B( M+1, M+P-N+1 ), LDB, D( M+1 ), 1 )
      CALL SCOPY( N-M, D( M+1 ), 1, Y( M+P-N+1 ), 1 )
*
*     Set y1 = 0
*
      DO 10 I = 1, M + P - N
         Y( I ) = ZERO
   10 CONTINUE
*
*     Update d1 = d1 - T12*y2
*
      CALL SGEMV( 'No transpose', M, N-M, -ONE, B( 1, M+P-N+1 ), LDB,
     $            Y( M+P-N+1 ), 1, ONE, D, 1 )
*
*     Solve triangular system: R11*x = d1
*
      CALL STRSV( 'Upper', 'No Transpose', 'Non unit', M, A, LDA, D, 1 )
*
*     Copy D to X
*
      CALL SCOPY( M, D, 1, X, 1 )
*
*     Backward transformation y = Z'*y
*
      CALL SORMRQ( 'Left', 'Transpose', P, 1, NP,
     $             B( MAX( 1, N-P+1 ), 1 ), LDB, WORK( M+1 ), Y,
     $             MAX( 1, P ), WORK( M+NP+1 ), LWORK-M-NP, INFO )
      WORK( 1 ) = M + NP + MAX( LOPT, INT( WORK( M+NP+1 ) ) )
*
      RETURN
*
*     End of SGGGLM
*
      END

C
C	$Id: gray.f,v 1.4 2008-07-27 00:17:14 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GRAY
C
C SUBROUTINE GRAY COLORS HALF-TONE CELL (I,J) WITH INTENSITY INTEN.
C THE ROUTINE ASSUMES 8X8 CELL SIZE ON A VIRTUAL SCREEN 1024X1024.
C
      DIMENSION       IFOT(16)   ,JFOT(16)
      DIMENSION       WIND2(4)   ,VIEW2(4)
CCC      DIMENSION       MX(16)  ,MY(16)
      COMMON /HAFTO1/ I          ,J          ,INTEN
      COMMON /HAFTO4/ NPTMAX     ,NPOINT     ,XPNT(50)  ,YPNT(50)
      SAVE
C
      DATA
     1 IFOT(1),IFOT(2),IFOT(3),IFOT(4),IFOT(5),IFOT(6),IFOT(7),IFOT(8)/
     2   1,      5,      1,      5,      3,      7,      3,      7   /
      DATA
     1 IFOT(9),IFOT(10),IFOT(11),IFOT(12),IFOT(13),IFOT(14),IFOT(15)/
     2   3,      7,       3,       7,       1,       5,       1/,
     3 IFOT(16)/
     4   5    /
C
      DATA
     1 JFOT(1),JFOT(2),JFOT(3),JFOT(4),JFOT(5),JFOT(6),JFOT(7),JFOT(8)/
     2   1,      5,      5,      1,      3,     7,      7,      3   /
      DATA
     1 JFOT(9),JFOT(10),JFOT(11),JFOT(12),JFOT(13),JFOT(14),JFOT(15)/
     2   1,      5,       5,       1,       3,       7,       7/,
     3 JFOT(16)/
     4   3    /
      IF (INTEN) 103,103,101
  101 I1 = I*8
      J1 = J*8
      IF ((NPOINT+INTEN) .LE.NPTMAX)  GO TO 1015
      CALL GETSET (VIEW2(1),VIEW2(2),VIEW2(3),VIEW2(4),
     +             WIND2(1),WIND2(2),WIND2(3),WIND2(4),IOLLS2)
      CALL SET (0.,1.,0.,1.,0.,1023.,0.,1023.,1)
      CALL POINTS (XPNT,YPNT,NPOINT,0,0)
      CALL SET (VIEW2(1),VIEW2(2),VIEW2(3),VIEW2(4),
     +          WIND2(1),WIND2(2),WIND2(3),WIND2(4),IOLLS2)
      NPOINT = 0
 1015 DO 102 I2=1,INTEN
      NPOINT = NPOINT + 1
      XPNT(NPOINT) = I1+IFOT(I2)
      YPNT(NPOINT) = J1+JFOT(I2)
  102 CONTINUE
  103 RETURN
      END

C     
C      $Id: xy04f.f,v 1.18 2010-03-15 22:49:25 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C                Copyright (C)  1995                                   C
C        University Corporation for Atmospheric Research               C
C                All Rights Reserved                                   C
C                                                                      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C  File:       xy04f.f
C
C  Author:     Mary Haley
C          National Center for Atmospheric Research
C          PO 3000, Boulder, Colorado
C
C  Date:       Thu Feb  9 10:00:38 MST 1995
C
C  Description:    This program shows one way on how to create an XyPlot
C                  object with multiple lines in the plot using
C                  the CoordArrays object.  Some of the XyPlot line
C                  resources are tweaked in the resource file to
C                  show how to change the appearance of these multiple
C                  lines.
C
C                  The "CoordArrays" object is used to set up the data,
C                  and the resource file is used to set up attributes
C                  of the data being plotted, like the line color, the
C                  dash patterns, and line label colors.
C
      external NhlFAppClass
      external NhlFCairoWindowWorkstationClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFCoordArraysClass
      external NhlFXyPlotClass
C
C Define the number of curves and points in each curve.
C
      parameter(NPTS=500,NCURVE=4,NCOLORS=6)
      parameter(PI100=.031415926535898)

      integer appid,xworkid,plotid,dataid
      integer rlist, i, j, len(2)
      real ydra(NPTS,NCURVE), theta
C
C Modify the color map using named colors.  Color indices '1' and '2'
C are the background and foreground colors respectively.
C
      character*6 cmap(NCOLORS)
      data cmap/"black","white","red","green","blue","yellow"/

      CHARACTER*7  wks_type
C
C Define the workstation type
C
      wks_type = "x11"
C
C
C Initialize data for the XyPlot object.
C
      do 20 j = 1,NCURVE
         do 10 i = 1,NPTS
            theta = PI100*real(i-1)
            ydra(i,j) = (j-1)*200.+(i-1)*.9*sin(theta)
 10      continue
 20   continue
C
C Initialize the HLU library and set up resource template.
C
      call NhlFInitialize
      call NhlFRLCreate(rlist,'setrl')
C
C Create Application object.  The Application object name is used to
C determine the name of the resource file, which is "xy04.res" in
C this case.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'appDefaultParent','True',ierr)
      call NhlFRLSetString(rlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'xy04',NhlFAppClass,0,rlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkMetaName','./xy04f.ncgm',ierr)
         call NhlFRLSetStringArray(rlist,'wkColorMap',cmap,NCOLORS,ierr)
         call NhlFCreate(xworkid,'xy04Work',
     +        NhlFNcgmWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X11 workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPause','True',ierr)
         call NhlFRLSetStringArray(rlist,'wkColorMap',cmap,NCOLORS,ierr)
         call NhlFCreate(xworkid,'xy04Work',
     +                NhlFCairoWindowWorkstationClass,
     +                0,rlist,ierr)
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PS workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPSFileName','./xy04f.ps',ierr)
         call NhlFRLSetStringArray(rlist,'wkColorMap',cmap,NCOLORS,ierr)
         call NhlFCreate(xworkid,'xy04Work',
     +        NhlFPSWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPDFFileName','./xy04f.pdf',ierr)
         call NhlFRLSetStringArray(rlist,'wkColorMap',cmap,NCOLORS,ierr)
         call NhlFCreate(xworkid,'xy04Work',
     +        NhlFPDFWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFileName','./xy04f',ierr)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetStringArray(rlist,'wkColorMap',cmap,NCOLORS,ierr)
         call NhlFCreate(xworkid,'xy04Work',
     +        NhlFcairoPSPDFWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFileName','./xy04f',ierr)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetStringArray(rlist,'wkColorMap',cmap,NCOLORS,ierr)
         call NhlFCreate(xworkid,'xy04Work',
     +        NhlFcairoImageWorkstationClass,0,rlist,ierr)
      endif
C
C Define the data object.  The id for this object will later be used
C as the value for the XYPlot data resource, 'xyCoordData'.
C Since only the Y values are specified here, each Y value will be
C paired with its integer array index.
C
      len(1) = NPTS
      len(2) = NCURVE
      call NhlFRLClear(rlist)
      call NhlFRLSetMDFloatArray(rlist,'caYArray',ydra,2,len,ierr)
      call NhlFCreate(dataid,'xyData',NhlFCoordArraysClass,
     +                0,rlist,ierr)
C
C This new DataItem object is now the resource value for xyCoordData.
C Tweak some XyPlot resources as well (in the resource file).
C Also tweak some XyDataSpe resources in the resource file.
C When Data is added to an XyPlot object, an XyDataSpec object is
C created internally to the XyPlot.  It has the same name as the Data
C object that is added, and so you can set XyDataSpec (XyPlot Data
C Specific) resources for each piece of data added to the xyCoordData
C resource.
C
C Create the XyPlot object which is created as a child of the
C XWorkstation object.  The resources that are being changed are done
C in the "xy04.res" file.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetInteger(rlist,'xyCoordData',dataid,ierr)
      call NhlFCreate(plotid,'xyPlot',NhlFXyPlotClass,xworkid,
     +                rlist,ierr)
C
C Draw the plot.
C
      call NhlFDraw(plotid,ierr)
      call NhlFFrame(xworkid,ierr)
C
C NhlDestroy destroys the given id and all of its children
C so destroying "xworkid" will also destroy "plotid".
C
      call NhlFRLDestroy(rlist)
      call NhlFDestroy(xworkid,ierr)
      call NhlFDestroy(appid,ierr)
C
C Restores state.
C
      call NhlFClose
      stop
      end

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C   FFTPACK 5.0
C   Copyright (C) 1995-2004, Scientific Computing Division,
C   University Corporation for Atmospheric Research
C   Licensed under the GNU General Public License (GPL)
C
C   Authors:  Paul N. Swarztrauber and Richard A. Valent
C
C   $Id: r1fgkb.f,v 1.2 2006-11-21 01:10:19 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      SUBROUTINE DR1FGKB(IDO,IP,L1,IDL1,CC,C1,C2,IN1,CH,CH2,IN2,WA)
      DOUBLE PRECISION TPI
      DOUBLE PRECISION ARG
      DOUBLE PRECISION DCP
      DOUBLE PRECISION DSP
      DOUBLE PRECISION AR1
      DOUBLE PRECISION AI1
      DOUBLE PRECISION AR1H
      DOUBLE PRECISION DC2
      DOUBLE PRECISION DS2
      DOUBLE PRECISION AR2
      DOUBLE PRECISION AI2
      DOUBLE PRECISION AR2H
      DOUBLE PRECISION CH(IN2,IDO,L1,IP),CC(IN1,IDO,IP,L1),
     +                 C1(IN1,IDO,L1,IP),C2(IN1,IDL1,IP),
     +                 CH2(IN2,IDL1,IP),WA(IDO)
C
      TPI = 2.D0*4.D0*ATAN(1.0D0)
      ARG = TPI/DBLE(IP)
      DCP = COS(ARG)
      DSP = SIN(ARG)
      IDP2 = IDO + 2
      NBD = (IDO-1)/2
      IPP2 = IP + 2
      IPPH = (IP+1)/2
      IF (IDO.LT.L1) GO TO 103
      DO 102 K = 1,L1
          DO 101 I = 1,IDO
              CH(1,I,K,1) = CC(1,I,1,K)
  101     CONTINUE
  102 CONTINUE
      GO TO 106
  103 DO 105 I = 1,IDO
          DO 104 K = 1,L1
              CH(1,I,K,1) = CC(1,I,1,K)
  104     CONTINUE
  105 CONTINUE
  106 DO 108 J = 2,IPPH
          JC = IPP2 - J
          J2 = J + J
          DO 107 K = 1,L1
              CH(1,1,K,J) = CC(1,IDO,J2-2,K) + CC(1,IDO,J2-2,K)
              CH(1,1,K,JC) = CC(1,1,J2-1,K) + CC(1,1,J2-1,K)
 1007         CONTINUE
  107     CONTINUE
  108 CONTINUE
      IF (IDO.EQ.1) GO TO 116
      IF (NBD.LT.L1) GO TO 112
      DO 111 J = 2,IPPH
          JC = IPP2 - J
          DO 110 K = 1,L1
              DO 109 I = 3,IDO,2
                  IC = IDP2 - I
                  CH(1,I-1,K,J) = CC(1,I-1,2*J-1,K) + CC(1,IC-1,2*J-2,K)
                  CH(1,I-1,K,JC) = CC(1,I-1,2*J-1,K) -
     +                             CC(1,IC-1,2*J-2,K)
                  CH(1,I,K,J) = CC(1,I,2*J-1,K) - CC(1,IC,2*J-2,K)
                  CH(1,I,K,JC) = CC(1,I,2*J-1,K) + CC(1,IC,2*J-2,K)
  109         CONTINUE
  110     CONTINUE
  111 CONTINUE
      GO TO 116
  112 DO 115 J = 2,IPPH
          JC = IPP2 - J
          DO 114 I = 3,IDO,2
              IC = IDP2 - I
              DO 113 K = 1,L1
                  CH(1,I-1,K,J) = CC(1,I-1,2*J-1,K) + CC(1,IC-1,2*J-2,K)
                  CH(1,I-1,K,JC) = CC(1,I-1,2*J-1,K) -
     +                             CC(1,IC-1,2*J-2,K)
                  CH(1,I,K,J) = CC(1,I,2*J-1,K) - CC(1,IC,2*J-2,K)
                  CH(1,I,K,JC) = CC(1,I,2*J-1,K) + CC(1,IC,2*J-2,K)
  113         CONTINUE
  114     CONTINUE
  115 CONTINUE
  116 AR1 = 1.D0
      AI1 = 0.D0
      DO 120 L = 2,IPPH
          LC = IPP2 - L
          AR1H = DCP*AR1 - DSP*AI1
          AI1 = DCP*AI1 + DSP*AR1
          AR1 = AR1H
          DO 117 IK = 1,IDL1
              C2(1,IK,L) = CH2(1,IK,1) + AR1*CH2(1,IK,2)
              C2(1,IK,LC) = AI1*CH2(1,IK,IP)
  117     CONTINUE
          DC2 = AR1
          DS2 = AI1
          AR2 = AR1
          AI2 = AI1
          DO 119 J = 3,IPPH
              JC = IPP2 - J
              AR2H = DC2*AR2 - DS2*AI2
              AI2 = DC2*AI2 + DS2*AR2
              AR2 = AR2H
              DO 118 IK = 1,IDL1
                  C2(1,IK,L) = C2(1,IK,L) + AR2*CH2(1,IK,J)
                  C2(1,IK,LC) = C2(1,IK,LC) + AI2*CH2(1,IK,JC)
  118         CONTINUE
  119     CONTINUE
  120 CONTINUE
      DO 122 J = 2,IPPH
          DO 121 IK = 1,IDL1
              CH2(1,IK,1) = CH2(1,IK,1) + CH2(1,IK,J)
  121     CONTINUE
  122 CONTINUE
      DO 124 J = 2,IPPH
          JC = IPP2 - J
          DO 123 K = 1,L1
              CH(1,1,K,J) = C1(1,1,K,J) - C1(1,1,K,JC)
              CH(1,1,K,JC) = C1(1,1,K,J) + C1(1,1,K,JC)
  123     CONTINUE
  124 CONTINUE
      IF (IDO.EQ.1) GO TO 132
      IF (NBD.LT.L1) GO TO 128
      DO 127 J = 2,IPPH
          JC = IPP2 - J
          DO 126 K = 1,L1
              DO 125 I = 3,IDO,2
                  CH(1,I-1,K,J) = C1(1,I-1,K,J) - C1(1,I,K,JC)
                  CH(1,I-1,K,JC) = C1(1,I-1,K,J) + C1(1,I,K,JC)
                  CH(1,I,K,J) = C1(1,I,K,J) + C1(1,I-1,K,JC)
                  CH(1,I,K,JC) = C1(1,I,K,J) - C1(1,I-1,K,JC)
  125         CONTINUE
  126     CONTINUE
  127 CONTINUE
      GO TO 132
  128 DO 131 J = 2,IPPH
          JC = IPP2 - J
          DO 130 I = 3,IDO,2
              DO 129 K = 1,L1
                  CH(1,I-1,K,J) = C1(1,I-1,K,J) - C1(1,I,K,JC)
                  CH(1,I-1,K,JC) = C1(1,I-1,K,J) + C1(1,I,K,JC)
                  CH(1,I,K,J) = C1(1,I,K,J) + C1(1,I-1,K,JC)
                  CH(1,I,K,JC) = C1(1,I,K,J) - C1(1,I-1,K,JC)
  129         CONTINUE
  130     CONTINUE
  131 CONTINUE
  132 CONTINUE
      IF (IDO.EQ.1) RETURN
      DO 133 IK = 1,IDL1
          C2(1,IK,1) = CH2(1,IK,1)
  133 CONTINUE
      DO 135 J = 2,IP
          DO 134 K = 1,L1
              C1(1,1,K,J) = CH(1,1,K,J)
  134     CONTINUE
  135 CONTINUE
      IF (NBD.GT.L1) GO TO 139
      IS = -IDO
      DO 138 J = 2,IP
          IS = IS + IDO
          IDIJ = IS
          DO 137 I = 3,IDO,2
              IDIJ = IDIJ + 2
              DO 136 K = 1,L1
                  C1(1,I-1,K,J) = WA(IDIJ-1)*CH(1,I-1,K,J) -
     +                            WA(IDIJ)*CH(1,I,K,J)
                  C1(1,I,K,J) = WA(IDIJ-1)*CH(1,I,K,J) +
     +                          WA(IDIJ)*CH(1,I-1,K,J)
  136         CONTINUE
  137     CONTINUE
  138 CONTINUE
      GO TO 143
  139 IS = -IDO
      DO 142 J = 2,IP
          IS = IS + IDO
          DO 141 K = 1,L1
              IDIJ = IS
              DO 140 I = 3,IDO,2
                  IDIJ = IDIJ + 2
                  C1(1,I-1,K,J) = WA(IDIJ-1)*CH(1,I-1,K,J) -
     +                            WA(IDIJ)*CH(1,I,K,J)
                  C1(1,I,K,J) = WA(IDIJ-1)*CH(1,I,K,J) +
     +                          WA(IDIJ)*CH(1,I-1,K,J)
  140         CONTINUE
  141     CONTINUE
  142 CONTINUE
  143 RETURN
      END

C
C	$Id: csareas.f,v 1.5 2008-07-27 03:10:05 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      DOUBLE PRECISION FUNCTION CSAREAS (V1,V2,V3)
      DOUBLE PRECISION V1(3), V2(3), V3(3)
C
C***********************************************************
C
C                                              From STRIPACK
C                                            Robert J. Renka
C                                  Dept. of Computer Science
C                                       Univ. of North Texas
C                                           renka@cs.unt.edu
C                                                   06/22/98
C
C   This function returns the area of a spherical triangle
C on the unit sphere.
C
C
C On input:
C
C       V1,V2,V3 = Arrays of length 3 containing the Carte-
C                  sian coordinates of unit vectors (the
C                  three triangle vertices in any order).
C                  These vectors, if nonzero, are implicitly
C                  scaled to have length 1.
C
C Input parameters are not altered by this function.
C
C On output:
C
C       CSAREAS = Area of the spherical triangle defined by
C               V1, V2, and V3 in the range 0 to 2*PI (the
C               area of a hemisphere).  CSAREAS = 0 (or 2*PI)
C               if and only if V1, V2, and V3 lie in (or
C               close to) a plane containing the origin.
C
C Modules required by CSAREAS:  None
C
C Intrinsic functions called by CSAREAS:  ACOS, SQRT
C
C***********************************************************
C
      DOUBLE PRECISION A1, A2, A3, CA1, CA2, CA3, S12, S23,
     .                 S31, U12(3), U23(3), U31(3)
      INTEGER          I
C
C Local parameters:
C
C A1,A2,A3 =    Interior angles of the spherical triangle
C CA1,CA2,CA3 = cos(A1), cos(A2), and cos(A3), respectively
C I =           DO-loop index and index for Uij
C S12,S23,S31 = Sum of squared components of U12, U23, U31
C U12,U23,U31 = Unit normal vectors to the planes defined by
C                 pairs of triangle vertices
C
C
C Compute cross products Uij = Vi X Vj.
C
      U12(1) = V1(2)*V2(3) - V1(3)*V2(2)
      U12(2) = V1(3)*V2(1) - V1(1)*V2(3)
      U12(3) = V1(1)*V2(2) - V1(2)*V2(1)
C
      U23(1) = V2(2)*V3(3) - V2(3)*V3(2)
      U23(2) = V2(3)*V3(1) - V2(1)*V3(3)
      U23(3) = V2(1)*V3(2) - V2(2)*V3(1)
C
      U31(1) = V3(2)*V1(3) - V3(3)*V1(2)
      U31(2) = V3(3)*V1(1) - V3(1)*V1(3)
      U31(3) = V3(1)*V1(2) - V3(2)*V1(1)
C
C Normalize Uij to unit vectors.
C
      S12 = 0.D0
      S23 = 0.D0
      S31 = 0.D0
      DO 2 I = 1,3
        S12 = S12 + U12(I)*U12(I)
        S23 = S23 + U23(I)*U23(I)
        S31 = S31 + U31(I)*U31(I)
    2   CONTINUE
C
C Test for a degenerate triangle associated with collinear
C   vertices.
C
      IF (S12 .EQ. 0.D0  .OR.  S23 .EQ. 0.D0  .OR.
     .    S31 .EQ. 0.D0) THEN
        CSAREAS = 0.D0
        RETURN
      ENDIF
      S12 = SQRT(S12)
      S23 = SQRT(S23)
      S31 = SQRT(S31)
      DO 3 I = 1,3
        U12(I) = U12(I)/S12
        U23(I) = U23(I)/S23
        U31(I) = U31(I)/S31
    3   CONTINUE
C
C Compute interior angles Ai as the dihedral angles between
C   planes:
C           CA1 = cos(A1) = -<U12,U31>
C           CA2 = cos(A2) = -<U23,U12>
C           CA3 = cos(A3) = -<U31,U23>
C
      CA1 = -U12(1)*U31(1)-U12(2)*U31(2)-U12(3)*U31(3)
      CA2 = -U23(1)*U12(1)-U23(2)*U12(2)-U23(3)*U12(3)
      CA3 = -U31(1)*U23(1)-U31(2)*U23(2)-U31(3)*U23(3)
      IF (CA1 .LT. -1.D0) CA1 = -1.D0
      IF (CA1 .GT. 1.D0) CA1 = 1.D0
      IF (CA2 .LT. -1.D0) CA2 = -1.D0
      IF (CA2 .GT. 1.D0) CA2 = 1.D0
      IF (CA3 .LT. -1.D0) CA3 = -1.D0
      IF (CA3 .GT. 1.D0) CA3 = 1.D0
      A1 = ACOS(CA1)
      A2 = ACOS(CA2)
      A3 = ACOS(CA3)
C
C Compute CSAREAS = A1 + A2 + A3 - PI.
C
      CSAREAS = A1 + A2 + A3 - ACOS(-1.D0)
      IF (CSAREAS .LT. 0.D0) CSAREAS = 0.D0
      RETURN
      END

      PROGRAM CLASS3
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER (NPTS=200)
      REAL YDRA(NPTS),XDRA(NPTS)

      DO 10 I=1,NPTS
         XDRA(I)=I*0.1
         YDRA(I)=EXP(XDRA(I)*SIN(XDRA(I)))
 10   CONTINUE

C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)

      CALL DEFCLR(IWKID)

      CALL AGSETI ('Y/LOGARITHMIC.',1)
      CALL AGSETF('DASH/SELECTOR.',-1.0)

      CALL AGSETC('LABEL/NAME.','B')
      CALL AGSETI('LINE/NUMBER.',-100)
      CALL AGSETC('LINE/TEXT.','TIME (SECONDS)$')

      CALL AGSETC('LABEL/NAME.','L')
      CALL AGSETI('LINE/NUMBER.',100)
      CALL AGSETC('LINE/TEXT.','POSITION (METERS)$')

      CALL EZXY (XDRA,YDRA,NPTS,
     +     'Log scaling and publication quality text$')

C
C Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS

      STOP
      END

      SUBROUTINE DEFCLR (IWKID)
      CALL GSCR(IWKID, 0, 0.0, 0.0, 0.0)
      CALL GSCR(IWKID, 1, 1.0, 1.0, 1.0)
      CALL GSCR(IWKID, 2, 1.0, 0.0, 0.0)
      CALL GSCR(IWKID, 3, 0.0, 1.0, 0.0)
      CALL GSCR(IWKID, 4, 0.4, 0.7, 0.9)
      CALL GSCR(IWKID, 5, 0.7, 0.4, 0.7)
      CALL GSCR(IWKID, 6, 0.9, 0.7, 0.4)
      CALL GSCR(IWKID, 7, 0.4, 0.9, 0.7)
      RETURN
      END
        
      SUBROUTINE AGCHAX(IFLG,IAXS,IPRT,VILS)
      CALL PLOTIF (0.,0.,2)
      IF (IFLG .EQ. 0) THEN
        CALL GSPLCI( 2 )
        CALL GSTXCI( 3 )
      ELSE
        CALL GSPLCI(1)
        CALL GSTXCI(1)
      ENDIF
      RETURN
      END

      SUBROUTINE AGCHCU(IFLG,KDSH)
      CALL PLOTIF (0.,0.,2)
      IF (IFLG .EQ. 0) THEN
         CALL GSPLCI( ABS(KDSH)+3 )
         CALL GSTXCI( ABS(KDSH)+3 )
      ELSE
         CALL GSPLCI(1)
         CALL GSTXCI(1)
      ENDIF
      RETURN
      END

      SUBROUTINE AGCHIL(IFLG,LBNM,LNNO)
      CALL PLOTIF (0.,0.,2)
      IF (IFLG .EQ. 0) THEN
         CALL GSTXCI( 4 )
      ELSE
         CALL GSTXCI( 1 )
      ENDIF
      RETURN
      END

      SUBROUTINE AGPWRT (XPOS, YPOS, CHRS, NCHS, ISIZ, IORI, ICEN)
      CHARACTER*(*) CHRS
      CALL PCGETR ('CS - CONSTANT SPACING FLAG', CSFL)
C If the label centering option is on, give wider spacing.
      IF (ICEN.NE.0) THEN
        CALL PCSETR ('CS - CONSTANT SPACING FLAG', 1.25)
      ELSE
        CALL PCSETR ('CS - CONSTANT SPACING FLAG', 0.0 )
      ENDIF
C Set the size of the labels to be the same as Autograph
C would normally use.
      CALL PLCHHQ (XPOS, YPOS, CHRS(1:NCHS),
     +             .8*REAL(ISIZ), REAL(IORI), REAL(ICEN))
C Return spacing to whatever it was before we wrote this label
      CALL PCSETR ('CS - CONSTANT SPACING FLAG', CSFL)
C                                                                       
      RETURN                                                            
      END                                                               

C
C	$Id: gzclwk.f,v 1.4 2008-07-27 00:21:03 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GZCLWK(WKID)
C
C  CLOSE WORKSTATION
C
      INTEGER ECLWK
      PARAMETER (ECLWK=3)
C
      include 'gkscom.h'
C
      INTEGER WKID
C
C  Check that GKS is in the proper state.
C
      CALL GZCKST(7,ECLWK,IER)
      IF (IER .NE. 0) RETURN
C
C  Check if the workstation identifier is valid.
C
      CALL GZCKWK(20,ECLWK,WKID,IDUM,IER)
      IF (IER .NE. 0) RETURN
C
C  Check if the specified workstation is open.
C
      CALL GZCKWK(25,ECLWK,WKID,IDUM,IER)
      IF (IER .NE. 0) RETURN
C
C  Check if the workstation is currently active.
C
      CALL GZCKWK(29,ECLWK,WKID,IDUM,IER)
      IF (IER .NE. 0) RETURN
C
C  Invoke the workstation interface (do this before flagging
C  the workstation as closed).
C
C  Determine the workstation type.
C
      DO 200 I=1,NOPWK
        IF (SOPWK(I) .EQ. WKID) THEN
          NWKTP = SWKTP(I)
          GO TO 10
        ENDIF
  200 CONTINUE
   10 CONTINUE
C
C  Invoke the workstation interface for non-WISS workstations.
C
C  Set the flag CUFLAG to indicate that the interface call should go
C  only to the specifically designated workstation.
C
      IF (NWKTP .NE. GWSS) THEN
        CUFLAG = WKID
        FCODE = 0
        CONT  = 0
        CALL GZROI(0)
        IL1  = 1
        IL2  = 1
        ID(1) = WKID
        CALL GZTOWK
        IF (RERR.NE.0) THEN
          ERS = 1
          CALL GERHND(RERR,ECLWK,ERF)
          ERS = 0
        ENDIF
        CUFLAG = -1
      ELSE
C
C  Delete all segments in WISS, unless requested not to.
C
        IF (SEGDEL .NE. 0) THEN
  210     CONTINUE
          CALL GQSGUS(1,IER,NUMS,ISGNM)
          IF (NUMS .LE. 0) GO TO 215
          CALL GDSG(ISGNM)
          GO TO 210
        ENDIF
  215   CONTINUE
      ENDIF
C
C  Remove the workstation identifier from the set of open 
C  workstations in the GKS state list and delete it from
C  the X workstation list.
C
      IF (NOPWK .EQ. 1) THEN
        SOPWK(1) = -1
        SWKTP(1) = -1
        LXWKID(1) = -1
        NOPWK = 0
      ELSE
        DO 201 I=1,NOPWK
          IF (SOPWK(I) .EQ. WKID) THEN
            IF (I .EQ. NOPWK) THEN
              SOPWK(NOPWK) = -1
              SWKTP(NOPWK) = -1
              LXWKID(I) = -1
              NOPWK = NOPWK-1
            ELSE
              NM1 = NOPWK-1
              DO 202 J=I,NM1
                SOPWK(J) = SOPWK(J+1)
                SWKTP(J) = SWKTP(J+1)
                LXWKID(J) = LXWKID(J+1)
  202         CONTINUE
              SOPWK(NOPWK) = -1
              SWKTP(NOPWK) = -1
              LXWKID(NOPWK) = -1
              NOPWK = NOPWK-1
            ENDIF
          ENDIF
  201   CONTINUE
      ENDIF
C
C  Set GKS to state GKOP if no workstations remain open.
C
      IF (SOPWK(1) .EQ. -1) THEN
        OPS = GGKOP
      ENDIF
C
C  Indicate that the metafile picture is empty.
C
      IF (NWKTP .EQ. GCGM) THEN
        NOPICT = 0
      ENDIF
C
      RETURN
      END

C
C $Id: mdptri.f,v 1.13 2008-09-18 00:42:17 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MDPTRI (UVAL,VVAL,RLAT,RLON)
C
        DOUBLE PRECISION UVAL,VVAL,RLAT,RLON
C
C Declare required common blocks.  See MAPBDX for descriptions of these
C common blocks and the variables in them.
C
        COMMON /MAPCM0/  COS1,DTOR,DTRH,OOPI,PI,PIOF,PIOT,RTDD,RTOD,
     +                   SROT,SIN1,TOPI,TSRT
        DOUBLE PRECISION COS1,DTOR,DTRH,OOPI,PI,PIOF,PIOT,RTDD,RTOD,
     +                   SROT,SIN1,TOPI,TSRT
        SAVE   /MAPCM0/
C
        COMMON /MAPCM1/  COSO,COSR,SINO,SINR,IPRJ,IROD
        DOUBLE PRECISION COSO,COSR,SINO,SINR
        INTEGER          IPRJ,IROD
        SAVE   /MAPCM1/
C
        COMMON /MAPCM2/  BLAM,BLOM,PEPS,SLAM,SLOM,UCEN,UMAX,UMIN,UOFF,
     +                   URNG,VCEN,VMAX,VMIN,VOFF,VRNG,ISSL
        DOUBLE PRECISION BLAM,BLOM,PEPS,SLAM,SLOM,UCEN,UMAX,UMIN,UOFF,
     +                   URNG,VCEN,VMAX,VMIN,VOFF,VRNG
        INTEGER          ISSL
        SAVE   /MAPCM2/
C
        COMMON /MAPCM4/  GRDR,GRID,GRLA,GRLO,GRPO,OTOL,PDRE,PLA1,PLA2,
     +                   PLA3,PLA4,PLB1,PLB2,PLB3,PLB4,PLNO,PLTO,ROTA,
     +                   SRCH,XLOW,XROW,YBOW,YTOW,IDOT,IDSH,IDTL,ILCW,
     +                   ILTS,JPRJ,ELPF,INTF,LBLF,PRMF
        DOUBLE PRECISION GRDR,GRID,GRLA,GRLO,GRPO,OTOL,PDRE,PLA1,PLA2,
     +                   PLA3,PLA4,PLB1,PLB2,PLB3,PLB4,PLNO,PLTO,ROTA,
     +                   SRCH,XLOW,XROW,YBOW,YTOW
        INTEGER          IDOT,IDSH,IDTL,ILCW,ILTS,JPRJ
        LOGICAL          ELPF,INTF,LBLF,PRMF
        SAVE   /MAPCM4/
C
        COMMON /MAPCM6/  UCNM,UMNM,UMXM,URNM,VCNM,VMNM,VMXM,VRNM,ELPM
        DOUBLE PRECISION UCNM,UMNM,UMXM,URNM,VCNM,VMNM,VMXM,VRNM
        LOGICAL ELPM
        SAVE   /MAPCM6/
C
        COMMON /MAPCM8/  P,Q,R
        DOUBLE PRECISION P,Q,R
        SAVE   /MAPCM8/
C
        COMMON /MAPCMW/  CSLS,CSLT,SLTD,ISLT
        DOUBLE PRECISION CSLS,CSLT,SLTD
        INTEGER ISLT
        SAVE   /MAPCMW/
C
        COMMON /MAPSAT/  ALFA,BETA,DCSA,DCSB,DSNA,DSNB,SALT,SSMO,SRSS
        DOUBLE PRECISION ALFA,BETA,DCSA,DCSB,DSNA,DSNB,SALT,SSMO,SRSS
        SAVE   /MAPSAT/
C
C Declare local variables.
C
        DOUBLE PRECISION COSA,COSB,COSL,COSP,RLAP,RLOP,SINA,SINB,SINL,
     +                   SINP,TMP1,TMP2,UTMP,UTM1,UTM2,UTM3,VTMP,VTM1,
     +                   VTM2,VTM3,VVTM,XVAL,YVAL,ZVAL
C
        REAL             SLAT,SLON
C
C Declare function types.
C
        DOUBLE PRECISION RBGLEN,RBIDFE
C
C Check for an uncleared prior error.
C
        IF (ICFELL('MDPTRI - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C If EZMAP needs initialization, do it.
C
        IF (INTF) THEN
          CALL MDPINT
          IF (ICFELL('MDPTRI',2).NE.0) RETURN
        END IF
C
C Check for a point outside the perimeter.  Return 1.D12's for such
C points.
C
        IF (ELPM) THEN
          IF (((UVAL-UCNM)/URNM)**2+
     +        ((VVAL-VCNM)/VRNM)**2.GT.1.000002D0) GO TO 301
        ELSE
          IF (UVAL.LT.UMNM.OR.UVAL.GT.UMXM.OR.
     +        VVAL.LT.VMNM.OR.VVAL.GT.VMXM) GO TO 301
        END IF
C
C The point is inside the perimeter.  Compute its actual coordinates.
C
        UTMP=UVAL+UOFF
        VTMP=VVAL+VOFF
C
C Jump to the proper piece of code, depending on the projection type.
C
C Projection:   US  LC  ST  OR  LE  GN  AE
C                   CE  ME  MT  RO  EA  AI  HA  MO  WT  (arbitrary)
C                   CE  ME  MT  RO  EA  AI  HA  MO  WT  (fast-path)
C                       RM
C
        GO TO (100,101,102,103,104,105,106,
     +             107,108,109,110,111,112,113,114,115,
     +             116,117,118,119,120,121,122,123,124,
     +                 125                            ) , IPRJ+1
C
C USGS transformations.
C
  100   IF (IROD.EQ.0) THEN
          CALL MDUTIS (REAL(UTMP),REAL(VTMP),SLAT,SLON)
          IF (SLAT.NE.1.E12) THEN
            RLAT=DBLE(SLAT)
            RLON=DBLE(SLON)
          ELSE
            RLAT=1.D12
            RLON=1.D12
          END IF
        ELSE
          CALL MDUTID (UTMP,VTMP,RLAT,RLON)
        END IF
        IF (RLAT.NE.1.D12) GO TO 202
        RETURN
C
C Lambert conformal conic.
C
  101   R=SQRT(UTMP*UTMP+VTMP*VTMP)
        IF (R.LT..000001D0) THEN
          RLAT=SINO*90.D0
          TMP1=0.D0
          TMP2=1.D0
        ELSE
          RLAT=SINO*(90.D0-RTDD*ATAN(R**(1.D0/COSO)))
          TMP1=UTMP/R
          TMP2=-SINO*VTMP/R
        END IF
        RLON=PLNO+RTOD*ATAN2(TMP1,TMP2)/COSO
        IF (ABS(RLON-PLNO).GT.180.D0) GO TO 301
        GO TO 202
C
C Stereographic.
C
  102   R=SQRT(UTMP*UTMP+VTMP*VTMP)
        IF (R.LT..000001D0) GO TO 198
        SINB=(UTMP*COSR-VTMP*SINR)/R
        COSB=(UTMP*SINR+VTMP*COSR)/R
        SINA=2.D0*R/(1.D0+R*R)
        COSA=(1.D0-R*R)/(1.D0+R*R)
        GO TO 199
C
C Orthographic or satellite-view (depending on the value of SALT).
C
  103   IF (ABS(SALT).LE.1.D0) THEN
          R=SQRT(UTMP*UTMP+VTMP*VTMP)
          IF (R.LT..000001D0) GO TO 198
          SINB=(UTMP*COSR-VTMP*SINR)/R
          COSB=(UTMP*SINR+VTMP*COSR)/R
          IF (R.LE.1.D0) THEN
            SINA=R
            COSA=SQRT(1.D0-SINA*SINA)
          ELSE
            IF (SALT.GE.0.D0.OR.R.GT.2.D0) GO TO 301
            SINA=2.D0-R
            COSA=-SQRT(1.D0-SINA*SINA)
          END IF
          GO TO 199
        ELSE
          IF (ALFA.EQ.0.D0) THEN
            UTM1=UTMP
            VTM1=VTMP
          ELSE
            UTM3=UTMP*DCSB+VTMP*DSNB
            VTM3=VTMP*DCSB-UTMP*DSNB
            UTM2=SRSS*(SRSS*DSNA+UTM3*DCSA)/(SRSS*DCSA-UTM3*DSNA)
            IF ((SRSS*DCSA+UTM2*DSNA)/SRSS.LT..0001D0) GO TO 301
            VTM2=SRSS*VTM3/(SRSS*DCSA-UTM3*DSNA)
            UTM1=UTM2*DCSB-VTM2*DSNB
            VTM1=UTM2*DSNB+VTM2*DCSB
          END IF
          R=SQRT(UTM1*UTM1+VTM1*VTM1)
          IF (R.LT..000001D0) GO TO 198
          SINB=(UTM1*COSR-VTM1*SINR)/R
          COSB=(UTM1*SINR+VTM1*COSR)/R
          IF (R.LE.1.D0) THEN
            COSA=(R*R*ABS(SALT)+SSMO*SQRT(1.D0-R*R))/(R*R+SSMO)
          ELSE
            IF (SALT.GE.0.D0.OR.R.GT.2.D0) GO TO 301
            R=2.D0-R
            COSA=(R*R*ABS(SALT)-SSMO*SQRT(1.D0-R*R))/(R*R+SSMO)
          END IF
          COSA=MAX(-1.D0,MIN(+1.D0,COSA))
          SINA=SQRT(1.D0-COSA*COSA)
          GO TO 199
        END IF
C
C Lambert equal-area.
C
  104   R=SQRT(UTMP*UTMP+VTMP*VTMP)
        IF (R.LT..000001D0) GO TO 198
        IF (R.GT.2.D0) GO TO 301
        SINB=(UTMP*COSR-VTMP*SINR)/R
        COSB=(UTMP*SINR+VTMP*COSR)/R
        COSA=MAX(-1.D0,MIN(+1.D0,1.D0-R*R/2.D0))
        SINA=SQRT(1.D0-COSA*COSA)
        GO TO 199
C
C Gnomonic.
C
  105   R=SQRT(UTMP*UTMP+VTMP*VTMP)
        IF (R.LT..000001D0) GO TO 198
        SINB=(UTMP*COSR-VTMP*SINR)/R
        COSB=(UTMP*SINR+VTMP*COSR)/R
        COSA=MAX(-1.D0,MIN(+1.D0,1.D0/SQRT(1.D0+R*R)))
        SINA=SQRT(1.D0-COSA*COSA)
        GO TO 199
C
C Azimuthal equidistant.
C
  106   R=SQRT(UTMP*UTMP+VTMP*VTMP)
        IF (R.LT..000001D0) GO TO 198
        IF (R.GT.PI) GO TO 301
        SINB=(UTMP*COSR-VTMP*SINR)/R
        COSB=(UTMP*SINR+VTMP*COSR)/R
        COSA=COS(R)
        SINA=SQRT(1.D0-COSA*COSA)
        GO TO 199
C
C Cylindrical equidistant, arbitrary pole and orientation.
C
  107   IF (ABS(UTMP).GT.180.D0.OR.ABS(VTMP).GT.90.D0/CSLT) GO TO 301
        RLAP=CSLT*VTMP*DTOR
        RLOP=UTMP*DTOR
        GO TO 200
C
C Mercator, arbitrary pole and orientation.
C
  108   IF (ABS(UTMP).GT.PI) GO TO 301
        RLAP=2.D0*ATAN(EXP(VTMP))-PIOT
        RLOP=UTMP
        GO TO 200
C
C Mollweide-type, arbitrary pole and orientation.
C
  109   IF (ABS(VTMP).GT.1.D0) GO TO 301
        RLAP=ASIN(VTMP)
        IF (1.D0-VTMP*VTMP.NE.0.D0) THEN
          RLOP=PIOT*UTMP/SQRT(1.D0-VTMP*VTMP)
          IF (RTOD*ABS(RLOP).GT.180.D0) GO TO 301
        ELSE
          IF (UTMP.NE.0.D0) GO TO 301
          RLOP=0.D0
        END IF
        GO TO 200
C
C Robinson, arbitrary pole and orientation.
C
  110   IF (ABS(VTMP).GT..5072D0) GO TO 301
        VVTM=RBIDFE(VTMP)
        IF (ABS(UTMP).GT.RBGLEN(VVTM)) GO TO 301
        RLAP=DTOR*VVTM
        RLOP=PI*UTMP/RBGLEN(VVTM)
        GO TO 200
C
C Cylindrical equal-area, arbitrary pole and orientation.
C
  111   IF (ABS(UTMP).GT.PI.OR.ABS(VTMP).GT.1.D0/CSLS) GO TO 301
        RLAP=ASIN(VTMP*CSLS)
        RLOP=UTMP
        GO TO 200
C
C Aitoff, arbitrary pole and orientation.
C
  112   CALL AIPRIN (UTMP,VTMP,RLAP,RLOP)
        IF (RLAP.EQ.1.D12) GO TO 301
        GO TO 200
C
C Hammer, arbitrary pole and orientation.
C
  113   CALL HAPRIN (UTMP,VTMP,RLAP,RLOP)
        IF (RLAP.EQ.1.D12) GO TO 301
        GO TO 200
C
C True Mollweide, arbitrary pole and orientation.
C
  114   CALL MOPRIN (UTMP,VTMP,RLAP,RLOP)
        IF (RLAP.EQ.1.D12) GO TO 301
        GO TO 200
C
C Winkel tripel, arbitrary pole and orientation.
C
  115   CALL WTPRIN (UTMP,VTMP,RLAP,RLOP,CSLT)
        IF (RLAP.EQ.1.D12) GO TO 301
        GO TO 200
C
C Cylindrical equidistant, fast-path.
C
  116   IF (ABS(UTMP).GT.180.D0.OR.ABS(VTMP).GT.90.D0/CSLT) GO TO 301
        RLAT=CSLT*VTMP
        RLON=PLNO+UTMP
        GO TO 201
C
C Mercator, fast-path.
C
  117   IF (ABS(UTMP).GT.PI) GO TO 301
        RLAT=RTDD*ATAN(EXP(VTMP))-90.D0
        RLON=PLNO+RTOD*UTMP
        GO TO 201
C
C Mollweide-type, fast-path.
C
  118   IF (ABS(VTMP).GT.1.D0) GO TO 301
        RLAT=ASIN(VTMP)*RTOD
        IF (1.D0-VTMP*VTMP.NE.0.D0) THEN
          RLON=PLNO+90.D0*UTMP/SQRT(1.D0-VTMP*VTMP)
          IF (ABS(RLON-PLNO).GT.180.D0) GO TO 301
        ELSE
          IF (UTMP.NE.0.D0) GO TO 301
          RLON=PLNO
        END IF
        GO TO 201
C
C Robinson, fast-path.
C
  119   IF (ABS(VTMP).GT..5072D0) GO TO 301
        VVTM=RBIDFE(VTMP)
        IF (ABS(UTMP).GT.RBGLEN(VVTM)) GO TO 301
        RLAT=VVTM
        RLON=PLNO+180.D0*UTMP/RBGLEN(VVTM)
        GO TO 201
C
C Cylindrical equal-area, fast-path.
C
  120   IF (ABS(UTMP).GT.PI.OR.ABS(VTMP).GT.1.D0/CSLS) GO TO 301
        RLAT=RTOD*ASIN(VTMP*CSLS)
        RLON=PLNO+RTOD*UTMP
        GO TO 201
C
C Aitoff, fast-path.
C
  121   CALL AIPRIN (UTMP,VTMP,RLAT,RLON)
        IF (RLAT.EQ.1.D12) GO TO 301
        RLAT=RTOD*RLAT
        RLON=PLNO+RTOD*RLON
        GO TO 201
C
C Hammer, fast-path.
C
  122   CALL HAPRIN (UTMP,VTMP,RLAT,RLON)
        IF (RLAT.EQ.1.D12) GO TO 301
        RLAT=RTOD*RLAT
        RLON=PLNO+RTOD*RLON
        GO TO 201
C
C True Mollweide, fast-path.
C
  123   CALL MOPRIN (UTMP,VTMP,RLAT,RLON)
        IF (RLAT.EQ.1.D12) GO TO 301
        RLAT=RTOD*RLAT
        RLON=PLNO+RTOD*RLON
        GO TO 201
C
C Winkel tripel, fast-path.
C
  124   CALL WTPRIN (UTMP,VTMP,RLAT,RLON,CSLT)
        IF (RLAT.EQ.1.D12) GO TO 301
        RLAT=RTOD*RLAT
        RLON=PLNO+RTOD*RLON
        GO TO 201
C
C Rotated Mercator.
C
  125   UTM1=UTMP*COSR-VTMP*SINR
        VTM1=VTMP*COSR+UTMP*SINR
        RLAT=RTDD*ATAN(EXP(VTM1))-90.D0
        RLON=PLNO+RTOD*UTM1
        GO TO 202
C
C The following code is common to all of the azimuthal projections when
C the "radius" R is within epsilon of zero.
C
  198   SINB=0.D0
        COSB=1.D0
        SINA=0.D0
        COSA=1.D0
C
C The following code is common to all of the azimuthal projections.
C
  199   SINL=SINA*SINB
        COSL=COSA*COSO-SINA*SINO*COSB
        COSP=SQRT(SINL*SINL+COSL*COSL)
C
        IF (COSP.NE.0.D0) THEN
          SINL=SINL/COSP
          COSL=COSL/COSP
        END IF
        IF (ABS(SINO).GT..000001D0) THEN
          SINP=(COSA-COSP*COSL*COSO)/SINO
        ELSE
          SINP=SINA*COSB
        END IF
C
        IF (SINP.NE.0.D0.OR.COSP.NE.0.D0) THEN
          RLAT=RTOD*ATAN2(SINP,COSP)
        ELSE
          RLAT=0.D0
        END IF
        IF (SINA*SINB.NE.0.D0.OR.COSA*COSO-SINA*SINO*COSB.NE.0.D0) THEN
          RLON=PLNO+RTOD*ATAN2(SINA*SINB,COSA*COSO-SINA*SINO*COSB)
        ELSE
          RLON=0.D0
        END IF
C
        GO TO 202
C
C The following code is common to all of the cylindrical and mixed
C projections.
C
  200   XVAL=COS(RLOP)*COS(RLAP)*COSO-
     +                    (SIN(RLAP)*COSR+SIN(RLOP)*COS(RLAP)*SINR)*SINO
        YVAL=SIN(RLOP)*COS(RLAP)*COSR-SIN(RLAP)*SINR
        ZVAL=(SIN(RLAP)*COSR+SIN(RLOP)*COS(RLAP)*SINR)*COSO+
     +                                          COS(RLOP)*COS(RLAP)*SINO
        RLAT=RTOD*ASIN(MAX(-1.D0,MIN(+1.D0,ZVAL)))
        RLON=RTOD*ATAN2(YVAL,XVAL)+PLNO
C
        GO TO 202
C
C The following code is common to all the fast-path projections.  If the
C rotation angle is 180, negate the output values of RLAT and RLON.
C
  201   IF (ABS(ROTA).GT.179.999999D0) THEN
          RLAT=-RLAT
          RLON=PLNO-(RLON-PLNO)
        END IF
C
        GO TO 202
C
C Done.
C
  202   IF (ABS(RLON).GT.180.D0) RLON=RLON-SIGN(360.D0,RLON)
C
        GO TO 302
C
C Inverse is not defined; return the values that signal that.
C
  301   RLAT=1.D12
        RLON=1.D12
C
  302   RETURN
C
      END

      PROGRAM FCIRC
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C  Demonstrate different GKS fill types
C
      PARAMETER (NPTS=101,MAPSIZ=5000, NGRPS=3, NC=200)
      INTEGER MAP(MAPSIZ), IAREA(NGRPS), IGRP(NGRPS)
      REAL X1(NPTS),Y1(NPTS),X2(NPTS),Y2(NPTS),X3(NPTS),Y3(NPTS)
      REAL XC(NC), YC(NC)

      EXTERNAL FILL
C
C Convert from degrees to radians.
C
      DATA D2R / .017453292519943 /
C
C Generate three intersecting circles of radius 1.
C
      DO 100 I=1,NPTS
         ANG=D2R*3.6*REAL(I-1)
         X=COS(ANG)
         Y=SIN(ANG)
         X1(I) = X - .5
         X2(I) = X + .5
         X3(I) = X
         Y1(I) = Y + .5
         Y2(I) = Y + .5
         Y3(I) = Y - .5
 100  CONTINUE
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Define the entire viewport and
C a window from -2. to 2 with linear scaling.
C
      CALL SET(0.,1.,0.,1.,-2.,2.,-2.,2.,1)
C
C Initialize the area map
C
      CALL ARINAM(MAP,MAPSIZ)
C
C Add the three objects as 3 edge groups
C
      CALL AREDAM(MAP,X1,Y1,NPTS,1,1,0)
      CALL AREDAM(MAP,X2,Y2,NPTS,2,2,0)
      CALL AREDAM(MAP,X3,Y3,NPTS,3,4,0)
C
C Fill the different regions
C
      CALL ARSCAM(MAP,XC,YC,NC,IAREA,IGRP,NGRPS,FILL)
C
C Close the plot
C
      CALL FRAME
C
C Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS

      WRITE (6,*) 'WARNING:'
      WRITE (6,*) 'fcirc.ncgm generates an error message when viewed.'

      STOP
      END

      SUBROUTINE FILL(XC, YC, NC, IAREA, IGRP, NGRPS)
      INTEGER NC,IAREA(NGRPS), IGRP(NGRPS)
      REAL XC(NC), YC(NC)

      ICOLOR=0
      DO 200 I=1,NGRPS
        ICOLOR = ICOLOR + IAREA(I)
200   CONTINUE
C
C  FILL THE REGION WITH THE APPROPRIATE COLOR
C
      IF (ICOLOR .GT. 0) THEN
        CALL GSFAIS(MOD(ICOLOR,4))
        CALL GFA(NC-1,XC,YC)
      ENDIF

      RETURN
      END

      SUBROUTINE SLAUU2( UPLO, N, A, LDA, INFO )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     February 29, 1992
*
*     .. Scalar Arguments ..
      CHARACTER          UPLO
      INTEGER            INFO, LDA, N
*     ..
*     .. Array Arguments ..
      REAL               A( LDA, * )
*     ..
*
*  Purpose
*  =======
*
*  SLAUU2 computes the product U * U' or L' * L, where the triangular
*  factor U or L is stored in the upper or lower triangular part of
*  the array A.
*
*  If UPLO = 'U' or 'u' then the upper triangle of the result is stored,
*  overwriting the factor U in A.
*  If UPLO = 'L' or 'l' then the lower triangle of the result is stored,
*  overwriting the factor L in A.
*
*  This is the unblocked form of the algorithm, calling Level 2 BLAS.
*
*  Arguments
*  =========
*
*  UPLO    (input) CHARACTER*1
*          Specifies whether the triangular factor stored in the array A
*          is upper or lower triangular:
*          = 'U':  Upper triangular
*          = 'L':  Lower triangular
*
*  N       (input) INTEGER
*          The order of the triangular factor U or L.  N >= 0.
*
*  A       (input/output) REAL array, dimension (LDA,N)
*          On entry, the triangular factor U or L.
*          On exit, if UPLO = 'U', the upper triangle of A is
*          overwritten with the upper triangle of the product U * U';
*          if UPLO = 'L', the lower triangle of A is overwritten with
*          the lower triangle of the product L' * L.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(1,N).
*
*  INFO    (output) INTEGER
*          = 0: successful exit
*          < 0: if INFO = -k, the k-th argument had an illegal value
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ONE
      PARAMETER          ( ONE = 1.0E+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            UPPER
      INTEGER            I
      REAL               AII
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      REAL               SDOT
      EXTERNAL           LSAME, SDOT
*     ..
*     .. External Subroutines ..
      EXTERNAL           SGEMV, SSCAL, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      UPPER = LSAME( UPLO, 'U' )
      IF( .NOT.UPPER .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -4
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'SLAUU2', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
*
      IF( UPPER ) THEN
*
*        Compute the product U * U'.
*
         DO 10 I = 1, N
            AII = A( I, I )
            IF( I.LT.N ) THEN
               A( I, I ) = SDOT( N-I+1, A( I, I ), LDA, A( I, I ), LDA )
               CALL SGEMV( 'No transpose', I-1, N-I, ONE, A( 1, I+1 ),
     $                     LDA, A( I, I+1 ), LDA, AII, A( 1, I ), 1 )
            ELSE
               CALL SSCAL( I, AII, A( 1, I ), 1 )
            END IF
   10    CONTINUE
*
      ELSE
*
*        Compute the product L' * L.
*
         DO 20 I = 1, N
            AII = A( I, I )
            IF( I.LT.N ) THEN
               A( I, I ) = SDOT( N-I+1, A( I, I ), 1, A( I, I ), 1 )
               CALL SGEMV( 'Transpose', N-I, I-1, ONE, A( I+1, 1 ), LDA,
     $                     A( I+1, I ), 1, AII, A( I, 1 ), LDA )
            ELSE
               CALL SSCAL( I, AII, A( I, 1 ), LDA )
            END IF
   20    CONTINUE
      END IF
*
      RETURN
*
*     End of SLAUU2
*
      END

C
C $Id: tdlnpa.f,v 1.4 2008-07-27 00:17:32 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE TDLNPA (XCP1,YCP1,XCP2,YCP2)
C
C This routine draws a line joining the projections of two points in
C 3-space.  The points are defined by their positions within the
C parallelogram defined by the last call to TDPARA.
C
C Project the two points.
C
        CALL TDPRPA (XCP1,YCP1,XPP1,YPP1)
        CALL TDPRPA (XCP2,YCP2,XPP2,YPP2)
C
C Draw the line joining the projected points.
C
        CALL LINE   (XPP1,YPP1,XPP2,YPP2)
C
C Done.
C
        RETURN
C
      END

      SUBROUTINE SLARFT( DIRECT, STOREV, N, K, V, LDV, TAU, T, LDT )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     February 29, 1992
*
*     .. Scalar Arguments ..
      CHARACTER          DIRECT, STOREV
      INTEGER            K, LDT, LDV, N
*     ..
*     .. Array Arguments ..
      REAL               T( LDT, * ), TAU( * ), V( LDV, * )
*     ..
*
*  Purpose
*  =======
*
*  SLARFT forms the triangular factor T of a real block reflector H
*  of order n, which is defined as a product of k elementary reflectors.
*
*  If DIRECT = 'F', H = H(1) H(2) . . . H(k) and T is upper triangular;
*
*  If DIRECT = 'B', H = H(k) . . . H(2) H(1) and T is lower triangular.
*
*  If STOREV = 'C', the vector which defines the elementary reflector
*  H(i) is stored in the i-th column of the array V, and
*
*     H  =  I - V * T * V'
*
*  If STOREV = 'R', the vector which defines the elementary reflector
*  H(i) is stored in the i-th row of the array V, and
*
*     H  =  I - V' * T * V
*
*  Arguments
*  =========
*
*  DIRECT  (input) CHARACTER*1
*          Specifies the order in which the elementary reflectors are
*          multiplied to form the block reflector:
*          = 'F': H = H(1) H(2) . . . H(k) (Forward)
*          = 'B': H = H(k) . . . H(2) H(1) (Backward)
*
*  STOREV  (input) CHARACTER*1
*          Specifies how the vectors which define the elementary
*          reflectors are stored (see also Further Details):
*          = 'C': columnwise
*          = 'R': rowwise
*
*  N       (input) INTEGER
*          The order of the block reflector H. N >= 0.
*
*  K       (input) INTEGER
*          The order of the triangular factor T (= the number of
*          elementary reflectors). K >= 1.
*
*  V       (input/output) REAL array, dimension
*                               (LDV,K) if STOREV = 'C'
*                               (LDV,N) if STOREV = 'R'
*          The matrix V. See further details.
*
*  LDV     (input) INTEGER
*          The leading dimension of the array V.
*          If STOREV = 'C', LDV >= max(1,N); if STOREV = 'R', LDV >= K.
*
*  TAU     (input) REAL array, dimension (K)
*          TAU(i) must contain the scalar factor of the elementary
*          reflector H(i).
*
*  T       (output) REAL array, dimension (LDT,K)
*          The k by k triangular factor T of the block reflector.
*          If DIRECT = 'F', T is upper triangular; if DIRECT = 'B', T is
*          lower triangular. The rest of the array is not used.
*
*  LDT     (input) INTEGER
*          The leading dimension of the array T. LDT >= K.
*
*  Further Details
*  ===============
*
*  The shape of the matrix V and the storage of the vectors which define
*  the H(i) is best illustrated by the following example with n = 5 and
*  k = 3. The elements equal to 1 are not stored; the corresponding
*  array elements are modified but restored on exit. The rest of the
*  array is not used.
*
*  DIRECT = 'F' and STOREV = 'C':         DIRECT = 'F' and STOREV = 'R':
*
*               V = (  1       )                 V = (  1 v1 v1 v1 v1 )
*                   ( v1  1    )                     (     1 v2 v2 v2 )
*                   ( v1 v2  1 )                     (        1 v3 v3 )
*                   ( v1 v2 v3 )
*                   ( v1 v2 v3 )
*
*  DIRECT = 'B' and STOREV = 'C':         DIRECT = 'B' and STOREV = 'R':
*
*               V = ( v1 v2 v3 )                 V = ( v1 v1  1       )
*                   ( v1 v2 v3 )                     ( v2 v2 v2  1    )
*                   (  1 v2 v3 )                     ( v3 v3 v3 v3  1 )
*                   (     1 v3 )
*                   (        1 )
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ONE, ZERO
      PARAMETER          ( ONE = 1.0E+0, ZERO = 0.0E+0 )
*     ..
*     .. Local Scalars ..
      INTEGER            I, J
      REAL               VII
*     ..
*     .. External Subroutines ..
      EXTERNAL           SGEMV, STRMV
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. Executable Statements ..
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
*
      IF( LSAME( DIRECT, 'F' ) ) THEN
         DO 20 I = 1, K
            IF( TAU( I ).EQ.ZERO ) THEN
*
*              H(i)  =  I
*
               DO 10 J = 1, I
                  T( J, I ) = ZERO
   10          CONTINUE
            ELSE
*
*              general case
*
               VII = V( I, I )
               V( I, I ) = ONE
               IF( LSAME( STOREV, 'C' ) ) THEN
*
*                 T(1:i-1,i) := - tau(i) * V(i:n,1:i-1)' * V(i:n,i)
*
                  CALL SGEMV( 'Transpose', N-I+1, I-1, -TAU( I ),
     $                        V( I, 1 ), LDV, V( I, I ), 1, ZERO,
     $                        T( 1, I ), 1 )
               ELSE
*
*                 T(1:i-1,i) := - tau(i) * V(1:i-1,i:n) * V(i,i:n)'
*
                  CALL SGEMV( 'No transpose', I-1, N-I+1, -TAU( I ),
     $                        V( 1, I ), LDV, V( I, I ), LDV, ZERO,
     $                        T( 1, I ), 1 )
               END IF
               V( I, I ) = VII
*
*              T(1:i-1,i) := T(1:i-1,1:i-1) * T(1:i-1,i)
*
               CALL STRMV( 'Upper', 'No transpose', 'Non-unit', I-1, T,
     $                     LDT, T( 1, I ), 1 )
               T( I, I ) = TAU( I )
            END IF
   20    CONTINUE
      ELSE
         DO 40 I = K, 1, -1
            IF( TAU( I ).EQ.ZERO ) THEN
*
*              H(i)  =  I
*
               DO 30 J = I, K
                  T( J, I ) = ZERO
   30          CONTINUE
            ELSE
*
*              general case
*
               IF( I.LT.K ) THEN
                  IF( LSAME( STOREV, 'C' ) ) THEN
                     VII = V( N-K+I, I )
                     V( N-K+I, I ) = ONE
*
*                    T(i+1:k,i) :=
*                            - tau(i) * V(1:n-k+i,i+1:k)' * V(1:n-k+i,i)
*
                     CALL SGEMV( 'Transpose', N-K+I, K-I, -TAU( I ),
     $                           V( 1, I+1 ), LDV, V( 1, I ), 1, ZERO,
     $                           T( I+1, I ), 1 )
                     V( N-K+I, I ) = VII
                  ELSE
                     VII = V( I, N-K+I )
                     V( I, N-K+I ) = ONE
*
*                    T(i+1:k,i) :=
*                            - tau(i) * V(i+1:k,1:n-k+i) * V(i,1:n-k+i)'
*
                     CALL SGEMV( 'No transpose', K-I, N-K+I, -TAU( I ),
     $                           V( I+1, 1 ), LDV, V( I, 1 ), LDV, ZERO,
     $                           T( I+1, I ), 1 )
                     V( I, N-K+I ) = VII
                  END IF
*
*                 T(i+1:k,i) := T(i+1:k,i+1:k) * T(i+1:k,i)
*
                  CALL STRMV( 'Lower', 'No transpose', 'Non-unit', K-I,
     $                        T( I+1, I+1 ), LDT, T( I+1, I ), 1 )
               END IF
               T( I, I ) = TAU( I )
            END IF
   40    CONTINUE
      END IF
      RETURN
*
*     End of SLARFT
*
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C   FFTPACK 5.0
C   Copyright (C) 1995-2004, Scientific Computing Division,
C   University Corporation for Atmospheric Research
C   Licensed under the GNU General Public License (GPL)
C
C   Authors:  Paul N. Swarztrauber and Richard A. Valent
C
C   $Id: c1f2kb.f,v 1.2 2006-11-21 01:10:15 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      SUBROUTINE DC1F2KB(IDO,L1,NA,CC,IN1,CH,IN2,WA)
      DOUBLE PRECISION CHOLD1
      DOUBLE PRECISION CHOLD2
      DOUBLE PRECISION TR2
      DOUBLE PRECISION TI2
      DOUBLE PRECISION CC(IN1,L1,IDO,2),CH(IN2,L1,2,IDO),WA(IDO,1,2)
C
      IF (IDO.GT.1 .OR. NA.EQ.1) GO TO 102
      DO 101 K = 1,L1
          CHOLD1 = CC(1,K,1,1) + CC(1,K,1,2)
          CC(1,K,1,2) = CC(1,K,1,1) - CC(1,K,1,2)
          CC(1,K,1,1) = CHOLD1
          CHOLD2 = CC(2,K,1,1) + CC(2,K,1,2)
          CC(2,K,1,2) = CC(2,K,1,1) - CC(2,K,1,2)
          CC(2,K,1,1) = CHOLD2
  101 CONTINUE
      RETURN
  102 DO 103 K = 1,L1
          CH(1,K,1,1) = CC(1,K,1,1) + CC(1,K,1,2)
          CH(1,K,2,1) = CC(1,K,1,1) - CC(1,K,1,2)
          CH(2,K,1,1) = CC(2,K,1,1) + CC(2,K,1,2)
          CH(2,K,2,1) = CC(2,K,1,1) - CC(2,K,1,2)
  103 CONTINUE
      IF (IDO.EQ.1) RETURN
      DO 105 I = 2,IDO
          DO 104 K = 1,L1
              CH(1,K,1,I) = CC(1,K,I,1) + CC(1,K,I,2)
              TR2 = CC(1,K,I,1) - CC(1,K,I,2)
              CH(2,K,1,I) = CC(2,K,I,1) + CC(2,K,I,2)
              TI2 = CC(2,K,I,1) - CC(2,K,I,2)
              CH(2,K,2,I) = WA(I,1,1)*TI2 + WA(I,1,2)*TR2
              CH(1,K,2,I) = WA(I,1,1)*TR2 - WA(I,1,2)*TI2
  104     CONTINUE
  105 CONTINUE
      RETURN
      END

C
C	$Id: conop2.f,v 1.4 2008-07-27 00:16:57 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CONOP2 (IOPT,ISIZE)
C
C SET THE CONTRAN OPTIONS
C
C INPUT
C     IOPT-CHARACTER STRING OF OPTION VALUE
C     ISIZE-  INTEGER INPUT
C
C  SET COMMON DATA EQUAL TO INPUT DATA
C
C
C
      COMMON /CONRA1/ CL(30)     ,NCL        ,OLDZ       ,PV(210)    ,
     1                FINC       ,HI         ,FLO
      COMMON /CONRA2/ REPEAT     ,EXTRAP     ,PER        ,MESS       ,
     1                ISCALE     ,LOOK       ,PLDVLS     ,GRD        ,
     2                CINC       ,CHILO      ,CON        ,LABON      ,
     3                PMIMX      ,SCALE      ,FRADV      ,EXTRI      ,
     4                BPSIZ      ,LISTOP
      COMMON /CONRA3/ IREC
      COMMON /CONRA4/ NCP        ,NCPSZ
      COMMON /CONRA5/ NIT        ,ITIPV
      COMMON /CONRA6/ XST        ,YST        ,XED        ,YED        ,
     1                STPSZ      ,IGRAD      ,IG         ,XRG        ,
     2                YRG        ,BORD       ,PXST       ,PYST       ,
     3                PXED       ,PYED       ,ITICK
      COMMON /CONR18/ TITLE      ,ICNT   ,ITLSIZ
      COMMON /CONR19/ IHIGH      ,INMAJ      ,INLAB      ,INDAT      ,
     1              LEN      ,IFMT       ,LEND       ,
     2                IFMTD      ,ISIZEP     ,INMIN
      COMMON /CONRA9/ ICOORD(500),NP         ,MXXY       ,TR         ,
     1                BR         ,TL         ,BL         ,CONV       ,
     2                XN         ,YN         ,ITLL       ,IBLL       ,
     3                ITRL       ,IBRL       ,XC         ,YC         ,
     4                ITLOC(210) ,JX         ,JY         ,ILOC       ,
     5                ISHFCT     ,XO         ,YO         ,IOC        ,NC
      COMMON /CONR10/ NT         ,NL         ,NTNL       ,JWIPT      ,
     1                JWIWL      ,JWIWP      ,JWIPL      ,IPR        ,
     2                ITPV
      COMMON /CONR20/ NREP       ,NCRT       ,ISIZEL     ,
     1                MINGAP     ,ISIZEM         ,
     2                TENS
      COMMON /CONR12/ IXMAX      ,IYMAX      ,XMAX       ,YMAX
      LOGICAL         REPEAT     ,EXTRAP     ,PER        ,MESS       ,
     1                LOOK       ,PLDVLS     ,GRD        ,LABON      ,
     2                PMIMX      ,FRADV      ,EXTRI      ,CINC       ,
     3                TITLE      ,LISTOP     ,CHILO      ,CON
      COMMON /CONR13/XVS(50),YVS(50),ICOUNT,SPVAL,SHIELD,
     1               SLDPLT
      LOGICAL SHIELD,SLDPLT
      COMMON /CONR14/LINEAR
      LOGICAL LINEAR
      COMMON /CONR15/ ISTRNG
        CHARACTER*64 ISTRNG
        COMMON /CONR16/ FORM
        CHARACTER*10 FORM
        COMMON /CONR17/ NDASH, IDASH, EDASH
        CHARACTER*10 NDASH, IDASH, EDASH
        COMMON /RANINT/ IRANMJ, IRANMN, IRANTX
        COMMON /RAQINT/ IRAQMJ, IRAQMN, IRAQTX
        COMMON /RASINT/ IRASMJ, IRASMN, IRASTX
C
C
C
C  INTPR IS THE DASH PACKAGE COMMON BLOCK INTERFACE
C  NP11 IS NP IN ALL OTHER INTPR DEFINITIONS; NAME CHANGE BECAUSE OF
C  CONFLICT
C
      COMMON /INTPR/  IPAU       ,FPART      ,TENSN      ,NP11       ,
     1                SMALL      ,L1         ,ADDLR      ,ADDTB      ,
     2                MLLINE     ,ICLOSE
        CHARACTER*7  IOPT
        CHARACTER*2  TAG, OPT
C
        SAVE
C
C  DETERMINE THE OPTION DESIRED
C
      TAG = IOPT(1:2)
        IF (IOPT(3:3) .EQ. '=') THEN
            OPT = IOPT(4:5)
        ELSE
            OPT = IOPT(5:6)
        ENDIF
C
C  SET RESOLUTION OF VIRTUAL GRID
C
      IF (TAG .EQ. 'SS') THEN
C
C  SWITCH = ON SET RESOLUTION OF VIRTUAL GRID
C
            IF (OPT .EQ. 'ON') THEN
              IGRAD = ISIZE
              RETURN
C
C  SWITCH = OFF RESET RESOLUTION TO DEFAULT
C
            ELSEIF (OPT .EQ. 'OF') THEN
              IGRAD = IG
              RETURN
          ELSE
                  GOTO 120
            ENDIF
C
C  NCP OPTION GET VALUE OF SWITCH
C
      ELSEIF (TAG .EQ. 'NC') THEN
C
C  SWITCH ON GET VALUE FOR NUMBER OF SURROUNDING DATA POINTS TO USE
C
            IF (OPT .EQ. 'ON') THEN
              NCP = ISIZE
              RETURN
C
C  SWITCH OFF SET TO DEFAULT VALUE
C
            ELSEIF (OPT .EQ. 'OF') THEN
              NCP = 4
              RETURN
          ELSE
                  GOTO 120
            ENDIF
C
C  INTENSITY OPTION FOUND GET VALUE OF SWITCH
C
      ELSEIF (TAG .EQ. 'IN') THEN
C
C  SWITCH OFF SET DEFAULT VALUES
C
            IF (OPT .EQ. 'OF') THEN
                  IRANMJ = 1
                  IRANMN = 1
                  IRANTX = 1
                  IRASMJ = 1
                  IRASMN = 1
                  IRASTX = 1
                  IRAQMJ = 1
                  IRAQMN = 1
                  IRAQTX = 1
              INMAJ = 1
              INMIN = 1
              INDAT = 1
              INLAB = 1
              RETURN
C
C  SET PLOTTED DATA INTENSITY
C
            ELSEIF (OPT .EQ. 'DA') THEN
              INDAT = ISIZE
              RETURN
C
C SET TITLE AND MESSAGE INTENSITY
C
            ELSEIF (OPT .EQ. 'LA') THEN
              INLAB = ISIZE
                  IRANTX = ISIZE
                  IRASTX = ISIZE
                  IRAQTX = ISIZE
              RETURN
C
C  SET ALL INTENSITIES TO THE SAME VALUE
C
            ELSEIF (OPT .EQ. 'AL') THEN
                  IRANMJ = ISIZE
                  IRANMN = ISIZE
                  IRANTX = ISIZE
                  IRASMJ = ISIZE
                  IRASMN = ISIZE
                  IRASTX = ISIZE
                  IRAQMJ = ISIZE
                  IRAQMN = ISIZE
                  IRAQTX = ISIZE
              INMAJ = ISIZE
                INMIN = ISIZE
              INLAB = ISIZE
              INDAT = ISIZE
              RETURN
C
C  SET MAJOR LINE INTENSITY
C
            ELSEIF (OPT .EQ. 'MA') THEN
                  IRANMJ = ISIZE
                  IRASMJ = ISIZE
                  IRAQMJ = ISIZE
              INMAJ = ISIZE
              RETURN
C
C  SET MINOR LINE INTENSITY
C
            ELSEIF (OPT .EQ. 'MI') THEN
                  IRANMN = ISIZE
                  IRASMN = ISIZE
                  IRAQMN = ISIZE
                INMIN = ISIZE
              RETURN
          ELSE
                  GOTO 120
            ENDIF
C
C  LABEL SIZE OPTION GET VALUE OF SWITCH
C
      ELSEIF (TAG .EQ. 'LS') THEN
C
C  SWITCH ON GET USER LABEL SIZE
C
            IF (OPT .EQ. 'ON') THEN
                ISIZEL = ISIZE
                RETURN
C
C  SWITCH OFF SET LABEL SIZE TO DEFAULT
C
            ELSEIF (OPT .EQ. 'OF') THEN
                ISIZEL = 9
                RETURN
          ELSE
                  GOTO 120
            ENDIF
C
C  SET SIZES OF MINIMUM AND MAXIMUM LABELS
C
      ELSEIF (TAG .EQ. 'SM') THEN
C
C  SWTICH ON GET USERS SIZE
C
            IF (OPT .EQ. 'ON') THEN
                ISIZEM = ISIZE
                RETURN
C
C  SWTICH OFF SET TO DEFAULT VALUE
C
            ELSEIF (OPT .EQ. 'OF') THEN
                ISIZEM = 15
                RETURN
          ELSE
                  GOTO 120
            ENDIF
C
C  SET SIZE OF THE PLOTTED DATA
C
      ELSEIF (TAG .EQ. 'SP') THEN
C
C  SWTICH ON GET USERS SIZE
C
            IF (OPT .EQ. 'ON') THEN
                ISIZEP = ISIZE
                RETURN
C
C  SWTICH OFF SET TO DEFAULT
C
            ELSEIF (OPT .EQ. 'OF') THEN
                ISIZEP = 8
                RETURN
          ELSE
                  GOTO 120
            ENDIF
C
C  TITLE SIZE SWITCH
C
      ELSEIF (TAG .EQ. 'ST') THEN
C
C  SWITCH ON SET THE TITLE SIZE
C
            IF (OPT .EQ. 'ON') THEN
                ITLSIZ = ISIZE
                RETURN
C
C  SWITCH OFF SET TITLE SIZE TO DEFAULT VALUE
C
            ELSEIF (OPT .EQ. 'OF') THEN
                ITLSIZ = 16
                RETURN
          ELSE
                  GOTO 120
            ENDIF
C
C  MINOR LINE COUNT OPTION
C
      ELSEIF (TAG .EQ. 'MI') THEN
C
C  SET MINOR LINE COUNT
C
            IF (OPT .EQ. 'ON') THEN
                MINGAP = ISIZE+1
                RETURN
C
C  SET MINOR LINE COUNT TO DEFAULT
C
            ELSEIF (OPT .EQ. 'OF') THEN
                MINGAP = 3
                RETURN
          ELSE
                  GOTO 120
            ENDIF
        ELSE
            GOTO 120
        ENDIF
C
C  ERROR UNDEFINED OPTION DETECTED
C
  120 CALL SETER (' CONOP2 - UNDEFINED OPTION',1,1)
      RETURN
        END

      SUBROUTINE CGTTRF( N, DL, D, DU, DU2, IPIV, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      INTEGER            INFO, N
*     ..
*     .. Array Arguments ..
      INTEGER            IPIV( * )
      COMPLEX            D( * ), DL( * ), DU( * ), DU2( * )
*     ..
*
*  Purpose
*  =======
*
*  CGTTRF computes an LU factorization of a complex tridiagonal matrix A
*  using elimination with partial pivoting and row interchanges.
*
*  The factorization has the form
*     A = L * U
*  where L is a product of permutation and unit lower bidiagonal
*  matrices and U is upper triangular with nonzeros in only the main
*  diagonal and first two superdiagonals.
*
*  Arguments
*  =========
*
*  N       (input) INTEGER
*          The order of the matrix A.
*
*  DL      (input/output) COMPLEX array, dimension (N-1)
*          On entry, DL must contain the (n-1) sub-diagonal elements of
*          A.
*
*          On exit, DL is overwritten by the (n-1) multipliers that
*          define the matrix L from the LU factorization of A.
*
*  D       (input/output) COMPLEX array, dimension (N)
*          On entry, D must contain the diagonal elements of A.
*
*          On exit, D is overwritten by the n diagonal elements of the
*          upper triangular matrix U from the LU factorization of A.
*
*  DU      (input/output) COMPLEX array, dimension (N-1)
*          On entry, DU must contain the (n-1) super-diagonal elements
*          of A.
*
*          On exit, DU is overwritten by the (n-1) elements of the first
*          super-diagonal of U.
*
*  DU2     (output) COMPLEX array, dimension (N-2)
*          On exit, DU2 is overwritten by the (n-2) elements of the
*          second super-diagonal of U.
*
*  IPIV    (output) INTEGER array, dimension (N)
*          The pivot indices; for 1 <= i <= n, row i of the matrix was
*          interchanged with row IPIV(i).  IPIV(i) will always be either
*          i or i+1; IPIV(i) = i indicates a row interchange was not
*          required.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -k, the k-th argument had an illegal value
*          > 0:  if INFO = k, U(k,k) is exactly zero. The factorization
*                has been completed, but the factor U is exactly
*                singular, and division by zero will occur if it is used
*                to solve a system of equations.
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ZERO
      PARAMETER          ( ZERO = 0.0E+0 )
*     ..
*     .. Local Scalars ..
      INTEGER            I
      COMPLEX            FACT, TEMP, ZDUM
*     ..
*     .. External Subroutines ..
      EXTERNAL           XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, AIMAG, REAL
*     ..
*     .. Statement Functions ..
      REAL               CABS1
*     ..
*     .. Statement Function definitions ..
      CABS1( ZDUM ) = ABS( REAL( ZDUM ) ) + ABS( AIMAG( ZDUM ) )
*     ..
*     .. Executable Statements ..
*
      INFO = 0
      IF( N.LT.0 ) THEN
         INFO = -1
         CALL XERBLA( 'CGTTRF', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
*
*     Initialize IPIV(i) = i and DU2(i) = 0
*
      DO 10 I = 1, N
         IPIV( I ) = I
   10 CONTINUE
      DO 20 I = 1, N - 2
         DU2( I ) = ZERO
   20 CONTINUE
*
      DO 30 I = 1, N - 2
         IF( CABS1( D( I ) ).GE.CABS1( DL( I ) ) ) THEN
*
*           No row interchange required, eliminate DL(I)
*
            IF( CABS1( D( I ) ).NE.ZERO ) THEN
               FACT = DL( I ) / D( I )
               DL( I ) = FACT
               D( I+1 ) = D( I+1 ) - FACT*DU( I )
            END IF
         ELSE
*
*           Interchange rows I and I+1, eliminate DL(I)
*
            FACT = D( I ) / DL( I )
            D( I ) = DL( I )
            DL( I ) = FACT
            TEMP = DU( I )
            DU( I ) = D( I+1 )
            D( I+1 ) = TEMP - FACT*D( I+1 )
            DU2( I ) = DU( I+1 )
            DU( I+1 ) = -FACT*DU( I+1 )
            IPIV( I ) = I + 1
         END IF
   30 CONTINUE
      IF( N.GT.1 ) THEN
         I = N - 1
         IF( CABS1( D( I ) ).GE.CABS1( DL( I ) ) ) THEN
            IF( CABS1( D( I ) ).NE.ZERO ) THEN
               FACT = DL( I ) / D( I )
               DL( I ) = FACT
               D( I+1 ) = D( I+1 ) - FACT*DU( I )
            END IF
         ELSE
            FACT = D( I ) / DL( I )
            D( I ) = DL( I )
            DL( I ) = FACT
            TEMP = DU( I )
            DU( I ) = D( I+1 )
            D( I+1 ) = TEMP - FACT*D( I+1 )
            IPIV( I ) = I + 1
         END IF
      END IF
*
*     Check for a zero on the diagonal of U.
*
      DO 40 I = 1, N
         IF( CABS1( D( I ) ).EQ.ZERO ) THEN
            INFO = I
            GO TO 50
         END IF
   40 CONTINUE
   50 CONTINUE
*
      RETURN
*
*     End of CGTTRF
*
      END

C
C	$Id: wmw2ny.f,v 1.4 2008-07-27 00:17:37 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE WMW2NY(NPT,P,Q)
C
C  This subroutine takes the NPT points in the real array P,
C  which are assumed to be in world coordinates, and, using
C  the current normalization transformation, converts them
C  into NDC coordinates and stores them in Q.  This subroutine
C  operates on Y-coordinates.
C
      INTEGER NPT
      REAL P(NPT),Q(NPT)
      REAL WINDOW(4),VIEWPT(4)
C
      CALL GQCNTN(IER,NTR)
      CALL GQNT(NTR,IER,WINDOW,VIEWPT)
      SCALE = (VIEWPT(4)-VIEWPT(3))/(WINDOW(4)-WINDOW(3))
      DO 20 I=1,NPT
        Q(I) = VIEWPT(3)+(P(I)-WINDOW(3))*SCALE
   20 CONTINUE
C
      RETURN
      END

c orig code [ sp2_util.orig ]: John Adams
c .          check arguments to make sure calls are correct
c
      subroutine geomatv(nlon,nlat,u,v,work)
c
c pay special attention to subscript order
c .   nlon is first   [ u(nlon,nlat),v(nlon,nlat) ]
c
c     when invoked, this subroutine converts the nlon by nlat
c     geophysical vector field (u,v) to nlat by nlon mathematical
c     coordinates.  work is an UNSAVED work space of length at
c     least nlon*nlat
c
      implicit none
      integer nlon,nlat,i,j
      real u(nlon,nlat),v(nlon,nlat),work(*)
c
c     negate v
c
      do j=1,nlon
	do i=1,nlat
	  v(j,i) = -v(j,i)
	end do
      end do
c
c     traspose u,v
c
      call tplatx(nlon,nlat,u,work)
      call tplatx(nlon,nlat,v,work)
c
c     reverse (co)latitude subscript order
c
      call clatx(nlat,nlon,u)
      call clatx(nlat,nlon,v)

      return
      end
c ---------------------------------------------------------
      subroutine matgeov(nlat,nlon,u,v,work)  
c
c pay special attention to subscript order
c .   nlat is first dim  [ u(nlat,nlon), v(nlat,nlon) ]
c
c     when invoked, this subroutine converts the nlat by nlon
c     vector u & v, given in mathematical spherical coordinates, to
c     nlon by nlat vector field given in geophysical spherical
c     coordinates.  work is an UNSAVED work space of length at least
c     nlon*nlat
c
      implicit none
      integer nlon,nlat,i,j
      real u(nlat,nlon),v(nlat,nlon),work(*)
c
c     negate v
c
      do j=1,nlon
	do i=1,nlat
	  v(i,j) = -v(i,j)
	end do
      end do
c
c     reverse (co)latitude subscript order
c
      call clatx(nlat,nlon,u)
      call clatx(nlat,nlon,v)
c
c     transpose array
c
      call tplatx(nlat,nlon,u,work)
      call tplatx(nlat,nlon,v,work)

      return
      end
c -------------------------------------------------------
      subroutine geomat(nlon,nlat,s,work)
c
c pay special attention to subscript order
c .   nlon is first dim  [ s(nlon,nlat) ]
c
c     when invoked, this subroutine converts the nlon by nlat
c     scalar s, given in geophysical spherical coordinates, to
c     a nlat by nlon array given in mathematical spherical
c     coordinates.  work is an UNSAVED work space of length at
c     least nlon*nlat
c
      implicit none
      integer nlon,nlat
      real s(*),work(*)
c
c     traspose array
c
      call tplatx(nlon,nlat,s,work)
c
c     reverse (co)latitude subscript order
c
      call clatx(nlat,nlon,s)
      return
      end
c -------------------------------------------------------------
      subroutine matgeo(nlat,nlon,s,work)
c
c pay special attention to subscript order
c .   nlat is first dim  [ s(nlat,nlon) ]
c
c     when invoked, this subroutine converts the nlat by nlon
c     array s, given in mathematical spherical coordinates, to
c     a nlon by nlat array given in geophysical spherical
c     coordinates.  work is an UNSAVED work space of length at least
c     nlon*nlat
c
      implicit none
      integer nlon,nlat
      real s(*),work(*)
c
c     reverse (co)latitude subscript order
c
      call clatx(nlat,nlon,s)
c
c     transpose array
c
      call tplatx(nlat,nlon,s,work)
      return
      end
c -------------------------------------------------------------
      subroutine tplatx(n,m,data,work)
c
c     transpose the n by m array data to a m by n array data
c     work must be at least n*m words long
c
      implicit none
      integer n,m,i,j,ij,ji
      real data(*),work(*)
 
      do j=1,m
	do i=1,n
	  ij = (j-1)*n+i
	  work(ij) = data(ij)
	end do
      end do
 
      do i=1,n
	do j=1,m
	  ji = (i-1)*m+j
	  ij = (j-1)*n+i
	  data(ji) = work(ij)
	end do
      end do
 
      return
      end
c ----------------------------------------------------
      subroutine clatx(nlat,nlon,data)
c
c     reverse order of latitude (colatitude) grids
c
      implicit none
      integer nlat,nlon,nlat2,i,ib,j
      real data(nlat,nlon),temp
  
      nlat2 = nlat/2
      do i=1,nlat2
	ib = nlat-i+1
	do j=1,nlon
	  temp = data(i,j)
	  data(i,j) = data(ib,j)
	  data(ib,j) = temp
	end do
      end do
 
      return
      end
c ------------------------------------
      subroutine chkerr (string1, string2, ier,jer,ker,mer)
      implicit none

      integer       ier, jer, ker, mer 
      character*(*) string1, string2

      if (ier.ne.0 .or. jer.ne.0 .or. ker.ne.0 .or. mer.ne.0) then 
          write (*,'('' ERROR: '',a,'' : '',a
     *              ,'' : ier,jer,ker,mer='',4i3)')    
     *                  string1, string2, ier,jer,ker,mer
          stop
      endif

      return
      end
c ---------------------------------------------------------
      subroutine trctpr (nlat,mwave,mdab,ndab,nt,a,b,ier)
      implicit   none

c truncate spectral coefficients
c .   (possibly) taper the spectral coef

      integer nlat, mwave, mdab, ndab, nt, ier
      real a(mdab,ndab,nt), b(mdab,ndab,nt)

      real       con
      integer    ntwgt, m, n, iwave, jp, jw, j, k, mw2
      parameter (ntwgt=500)
      real  twgt(ntwgt)

      ier = 0
      if (mwave.eq.0) return 

      mw2 = iabs(mwave)+2
 
      do k=1,nt
       do n=mw2,nlat
        do m=1,n
           a(m,n,k) = 0.0
           b(m,n,k) = 0.0
        enddo
       enddo
      enddo

      if (mwave.gt.0) return
      
      iwave = iabs(mwave)
                                 ! perform exponential tapering 
      jp = max0(iwave/10,1)      ! exponent; determines fall-off rate
      jw = jp*10                 ! coef which has wgt=exp(-1)

      if ((iwave+1).gt.ntwgt) then
         write (*,'(''taprwv: ntwgt exceeded='',2i5)') ntwgt,(iwave+1)  
         return
      endif
          
      con = 1./real(jw*(jw+1))
      do j=0,iwave
         twgt(j+1) = exp(-(real(j*(j+1))*con)**jp)
c c c    write (*,'(''taprwv: j, twgt(j)='',2i5,1x,f15.7)') 
c c c*                        j, (j+1),twgt(j+1)   
      enddo
                                  ! now wgt the coef by the wgts
      do k=1,nt 
       do n=iwave+1,1,-1          ! traverse the diagonal
         do m=1,n
            a(m,n,k) = a(m,n,k)*twgt(n)
            b(m,n,k) = b(m,n,k)*twgt(n)
         enddo
       enddo
      enddo

      return
      end
c ----------------------------------------------------
      subroutine geoscl (mlon,nlat,nt,x,scale,ner)
      implicit none
      integer  mlon, nlat, nt, ner
      real     x(mlon,nlat,nt), scale

      integer  n, ml, nl               

c scale an array

      ner = 0
      if (scale.eq.1.0) return

      do n=1,nt
       do nl=1,nlat
        do ml=1,mlon
           x(ml,nl,n) = x(ml,nl,n)*scale 
        enddo
       enddo
      enddo

      return
      end

      PROGRAM FGKE04
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER (IWKID1=5, IWKID2=7)
C
C  Illustrate workstation control functions by intermixing plotting to
C  a metafile with plotting to X window workstations.
C
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
C
C  Define color index 6 as red on that workstation.
C
      CALL GSCR(IWKID,6,1.,0.,0.)
C
C  Set character height and set the text alignment to (center, half).
C
      CALL GSCHH(.04)
      CALL GSTXAL(2,3)
C
C  Activate the CGM workstation.
C
      CALL GACWK(IWKID)
C
C  Create picture 1 in the metafile and call FRAME to terminate 
C  the first picture.
C
      CALL GSTXCI(6)
      CALL GTX(.5,.5,'Picture 1')
      CALL FRAME
C
C  Put another picture in the metafile.
C
      CALL GTX(.5,.5,'Picture 2')
      CALL FRAME
C
C  Open and activate an X11 workstation and define color index 6
C  to be cyan on that workstation (this workstation will be referred 
C  to as "The first window".
C
      CALL GOPWK(IWKID1,0,8)
      CALL GACWK(IWKID1)
      CALL GSCR(IWKID1,6,0.,1.,1.)
C
C  Create picture 3.  This will be plotted to the CGM workstation as
C  well as to the X11 window since they are both active.
C
      CALL GTX(.5,.5,'Picture 3')
C
C  Terminate the metafile picture.
C
      CALL NGPICT(IWKID,1)
C
C  Pause in the X window with a "<READY>" prompt and wait for a 
C  mouse click.  The window will be cleared after the mouse click.
C
      CALL NGPICT(IWKID1,4)
C
C  Open and activate another X workstation (to be reffered to as "The
C  second window") and define color index 6 to be green on that 
C  workstation.
C
      CALL GOPWK(IWKID2,0,8)
      CALL GACWK(IWKID2)
      CALL GSCR(IWKID2,6,0.,1.,0.)
C
C  Plot picture 4.  This will be sent to the CGM workstation and the
C  two X window workstations since they are all active.
C
      CALL GTX(.5,.5,'Picture 4')
C
C  Terminate picture 4 in the metafile.
C
      CALL NGPICT(IWKID,1)
C
C  Make the second window current.
C
      CALL NGPICT(IWKID2,0)
C
C  Pause in the first window with a "<READY>" prompt and wait for a
C  mouse click.  The window will be cleared after the click.
C
      CALL NGPICT(IWKID1,4)
C
C  Clear the second window.
C
      CALL NGPICT(IWKID2,1)
C
C  Deactivate the metafile (but do not close it) and draw picture 5.
C  This will go to the two active X11 workstations, but not the CGM.
C
      CALL GDAWK(IWKID)
      CALL GTX(.5,.5,'Picture 5')
C
C  Make the second window current
C
      CALL NGPICT(IWKID2,0)
C
C  Pause in the first window waiting or a mouse click
C
      CALL NGPICT(IWKID1,4)
C
C  Re-activate the metafile and deactivate the second window.
C
      CALL GACWK(IWKID)
      CALL GDAWK(IWKID2)
C
C  Plot picture 6.  This will go to the first window and to the
C  metafile.
C
      CALL GTX(.5,.5,'Picture 6')
C
C  Terminate the picture in the CGM.
C
      CALL NGPICT(IWKID,1)
C
C  Pause in the first window waiting for a mouse click.
C
      CALL NGPICT(IWKID1,4)
C
C  Reactivate the second window and clear it.
C
      CALL GACWK(IWKID2)
      CALL NGPICT(IWKID2,1)
C
C  Put out picture 7.  This will go to the all active workstations.
C
      CALL GTX(.5,.5,'Picture 7')
C
C  Terminate the picture in the CGM.
C
      CALL NGPICT(IWKID,1)
C
C  Make the first window current.
C
      CALL NGPICT(IWKID1,0)
C
C  Pause in the second window waiting for a mouse click.
C
      CALL NGPICT(IWKID2,4)
C
C  Deactivate and close the first window; deactivate and close the CGM.
C 
      CALL GDAWK(IWKID1)
      CALL GDAWK(IWKID)
      CALL GCLWK(IWKID1)
      CALL GCLWK(IWKID)
C
C  Put out picture 8.  This will go to the second window, the only 
C  active workstation.
C
      CALL GTX(.5,.5,'Picture 8')
C
C  Pause in the second window with a "<READY>" prompt.
C
      CALL NGPICT(IWKID2,4)
C
C  Deactivate and close the second window.
C
      CALL GDAWK(IWKID2)
      CALL GCLWK(IWKID2)
C
C  Close GKS.
C
      CALL GCLKS
C
      STOP
      END

C
C	$Id: csblda.f,v 1.7 2008-07-27 03:10:06 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CSBLDA
C
C Calling this do-nothing subroutine forces "ld" to load the following
C block data routine (but only if they are in the same ".f" file).
C
        RETURN
C
      END
CNOSPLIT
      BLOCKDATA CSBLDAX
C
C  Initialize data.
C
      include 'cscomn.h'
C
C  Number of nodes to use in least squares fit.
C
      DATA NUMLS/10/
C
C  Value for constant SIGMA.
C
      DATA USSIG/1.0D0/
C
C  Tolerance to use in calculating gradient differences to terminate
C  iteration sequence when computing global gradients.
C
      DATA TOLIC/0.01D0/
C
C  Tolerance to use in determining how close each SIGMA element 
C  should be to its optimum value in GETSIG.
C
      DATA TOLSG/0.01D0/
C
C  Fill value to use with NCL functions that can return a missing
C  value.
C
      DATA RMVAL/-8.D0/
C
C  Maximum number of iterations to use in computing SIGMA array.
C
      DATA NUMIT/10/
C
C  Flag to revert to calculating a SIGMA array rather than
C  use a constant SIGMA.  Using a constant SIGMA is effected
C  by setting a value for SIGME using CSSETR.  If ICSIG is 0,
C  then a SIGMA array is used, otherwise a constant SIGMA is used.
C
      DATA ICSIG/0/
C
C  Flag indicating global/local gradients.
C
      DATA IGFLG/1/
C
      END

      SUBROUTINE CPTCON( N, D, E, ANORM, RCOND, RWORK, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      INTEGER            INFO, N
      REAL               ANORM, RCOND
*     ..
*     .. Array Arguments ..
      REAL               D( * ), RWORK( * )
      COMPLEX            E( * )
*     ..
*
*  Purpose
*  =======
*
*  CPTCON computes the reciprocal of the condition number (in the
*  1-norm) of a complex Hermitian positive definite tridiagonal matrix
*  using the factorization A = L*D*L**H or A = U**H*D*U computed by
*  CPTTRF.
*
*  Norm(inv(A)) is computed by a direct method, and the reciprocal of
*  the condition number is computed as
*                   RCOND = 1 / (ANORM * norm(inv(A))).
*
*  Arguments
*  =========
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  D       (input) REAL array, dimension (N)
*          The n diagonal elements of the diagonal matrix D from the
*          factorization of A, as computed by CPTTRF.
*
*  E       (input) COMPLEX array, dimension (N-1)
*          The (n-1) off-diagonal elements of the unit bidiagonal factor
*          U or L from the factorization of A, as computed by CPTTRF.
*
*  ANORM   (input) REAL
*          The 1-norm of the original matrix A.
*
*  RCOND   (output) REAL
*          The reciprocal of the condition number of the matrix A,
*          computed as RCOND = 1/(ANORM * AINVNM), where AINVNM is the
*          1-norm of inv(A) computed in this routine.
*
*  RWORK   (workspace) REAL array, dimension (N)
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*
*  Further Details
*  ===============
*
*  The method used is described in Nicholas J. Higham, "Efficient
*  Algorithms for Computing the Condition Number of a Tridiagonal
*  Matrix", SIAM J. Sci. Stat. Comput., Vol. 7, No. 1, January 1986.
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ONE, ZERO
      PARAMETER          ( ONE = 1.0E+0, ZERO = 0.0E+0 )
*     ..
*     .. Local Scalars ..
      INTEGER            I, IX
      REAL               AINVNM
*     ..
*     .. External Functions ..
      INTEGER            ISAMAX
      EXTERNAL           ISAMAX
*     ..
*     .. External Subroutines ..
      EXTERNAL           XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS
*     ..
*     .. Executable Statements ..
*
*     Test the input arguments.
*
      INFO = 0
      IF( N.LT.0 ) THEN
         INFO = -1
      ELSE IF( ANORM.LT.ZERO ) THEN
         INFO = -4
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'CPTCON', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      RCOND = ZERO
      IF( N.EQ.0 ) THEN
         RCOND = ONE
         RETURN
      ELSE IF( ANORM.EQ.ZERO ) THEN
         RETURN
      END IF
*
*     Check that D(1:N) is positive.
*
      DO 10 I = 1, N
         IF( D( I ).LE.ZERO )
     $      RETURN
   10 CONTINUE
*
*     Solve M(A) * x = e, where M(A) = (m(i,j)) is given by
*
*        m(i,j) =  abs(A(i,j)), i = j,
*        m(i,j) = -abs(A(i,j)), i .ne. j,
*
*     and e = [ 1, 1, ..., 1 ]'.  Note M(A) = M(L)*D*M(L)'.
*
*     Solve M(L) * x = e.
*
      RWORK( 1 ) = ONE
      DO 20 I = 2, N
         RWORK( I ) = ONE + RWORK( I-1 )*ABS( E( I-1 ) )
   20 CONTINUE
*
*     Solve D * M(L)' * x = b.
*
      RWORK( N ) = RWORK( N ) / D( N )
      DO 30 I = N - 1, 1, -1
         RWORK( I ) = RWORK( I ) / D( I ) + RWORK( I+1 )*ABS( E( I ) )
   30 CONTINUE
*
*     Compute AINVNM = max(x(i)), 1<=i<=n.
*
      IX = ISAMAX( N, RWORK, 1 )
      AINVNM = ABS( RWORK( IX ) )
*
*     Compute the reciprocal condition number.
*
      IF( AINVNM.NE.ZERO )
     $   RCOND = ( ONE / AINVNM ) / ANORM
*
      RETURN
*
*     End of CPTCON
*
      END

C
C $Id: idxchg.f,v 1.6 2008-07-27 00:17:30 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      FUNCTION IDXCHG (X,Y,I1,I2,I3,I4)
C
C This function determines whether or not two adjacent triangles in the
C triangulation should be "exchanged".  By default, it uses a criterion,
C due to C. L. Lawson, that maximizes the minimum angle occurring in the
C triangles, but if ITTY is set non-zero, the function IDXCHN is called
C instead.
C
C The input arguments are as follows:
C
C   X and Y are arrays containing the coordinates of the data points.
C
C   I1, I2, I3, and I4 are point numbers of four points P1, P2, P3,
C   and P4 forming a quadrilateral with P3 and P4 connected diagonally
C   to form two triangles.
C
C The function returns an integer 1 if P1 and P2 should be connected
C instead of P3 and P4 (an "exchange"); otherwise, it returns 0.
C
C Declaration statements.
C
      COMMON /IDCOMN/ INTY,ITTY,ALSP,BLSP,CLSP,XAVG,YAVG
      SAVE   /IDCOMN/
C
      DIMENSION X(*), Y(*)
C
      EQUIVALENCE (C2SQ,C1SQ),(A3SQ,B2SQ),(B3SQ,A1SQ),
     1            (A4SQ,B1SQ),(B4SQ,A2SQ),(C4SQ,C3SQ)
C
      DATA  EPSLN / 1.E-6 /
C
C See if the new triangulation is to be produced and, if so, do it.
C
      IF (ITTY.NE.0) THEN
        IDXCHG=IDXCHN(X,Y,I1,I2,I3,I4)
        RETURN
      END IF
C
C Preliminary processing.
C
      X1=X(I1)
      Y1=Y(I1)
      X2=X(I2)
      Y2=Y(I2)
      X3=X(I3)
      Y3=Y(I3)
      X4=X(I4)
      Y4=Y(I4)
C
C Calculation.
C
      IDX=0
C
      U3=(Y2-Y3)*(X1-X3)-(X2-X3)*(Y1-Y3)
      U4=(Y1-Y4)*(X2-X4)-(X1-X4)*(Y2-Y4)
C
      IF (U3*U4.GT.0.) THEN
        U1=(Y3-Y1)*(X4-X1)-(X3-X1)*(Y4-Y1)
        U2=(Y4-Y2)*(X3-X2)-(X4-X2)*(Y3-Y2)
        A1SQ=(X1-X3)**2+(Y1-Y3)**2
        B1SQ=(X4-X1)**2+(Y4-Y1)**2
        C1SQ=(X3-X4)**2+(Y3-Y4)**2
        A2SQ=(X2-X4)**2+(Y2-Y4)**2
        B2SQ=(X3-X2)**2+(Y3-Y2)**2
        C3SQ=(X2-X1)**2+(Y2-Y1)**2
        S1SQ=U1*U1/(C1SQ*MAX(A1SQ,B1SQ))
        S2SQ=U2*U2/(C2SQ*MAX(A2SQ,B2SQ))
        S3SQ=U3*U3/(C3SQ*MAX(A3SQ,B3SQ))
        S4SQ=U4*U4/(C4SQ*MAX(A4SQ,B4SQ))
        IF ((MIN(S3SQ,S4SQ)-MIN(S1SQ,S2SQ)).GT.EPSLN) IDX=1
      END IF
C
      IDXCHG=IDX
C
C Done.
C
      RETURN
C
      END

      SUBROUTINE CPTTS2( IUPLO, N, NRHS, D, E, B, LDB )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      INTEGER            IUPLO, LDB, N, NRHS
*     ..
*     .. Array Arguments ..
      REAL               D( * )
      COMPLEX            B( LDB, * ), E( * )
*     ..
*
*  Purpose
*  =======
*
*  CPTTS2 solves a tridiagonal system of the form
*     A * X = B
*  using the factorization A = U'*D*U or A = L*D*L' computed by CPTTRF.
*  D is a diagonal matrix specified in the vector D, U (or L) is a unit
*  bidiagonal matrix whose superdiagonal (subdiagonal) is specified in
*  the vector E, and X and B are N by NRHS matrices.
*
*  Arguments
*  =========
*
*  IUPLO   (input) INTEGER
*          Specifies the form of the factorization and whether the
*          vector E is the superdiagonal of the upper bidiagonal factor
*          U or the subdiagonal of the lower bidiagonal factor L.
*          = 1:  A = U'*D*U, E is the superdiagonal of U
*          = 0:  A = L*D*L', E is the subdiagonal of L
*
*  N       (input) INTEGER
*          The order of the tridiagonal matrix A.  N >= 0.
*
*  NRHS    (input) INTEGER
*          The number of right hand sides, i.e., the number of columns
*          of the matrix B.  NRHS >= 0.
*
*  D       (input) REAL array, dimension (N)
*          The n diagonal elements of the diagonal matrix D from the
*          factorization A = U'*D*U or A = L*D*L'.
*
*  E       (input) COMPLEX array, dimension (N-1)
*          If IUPLO = 1, the (n-1) superdiagonal elements of the unit
*          bidiagonal factor U from the factorization A = U'*D*U.
*          If IUPLO = 0, the (n-1) subdiagonal elements of the unit
*          bidiagonal factor L from the factorization A = L*D*L'.
*
*  B       (input/output) REAL array, dimension (LDB,NRHS)
*          On entry, the right hand side vectors B for the system of
*          linear equations.
*          On exit, the solution vectors, X.
*
*  LDB     (input) INTEGER
*          The leading dimension of the array B.  LDB >= max(1,N).
*
*  =====================================================================
*
*     .. Local Scalars ..
      INTEGER            I, J
*     ..
*     .. External Subroutines ..
      EXTERNAL           CSSCAL
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          CONJG
*     ..
*     .. Executable Statements ..
*
*     Quick return if possible
*
      IF( N.LE.1 ) THEN
         IF( N.EQ.1 )
     $      CALL CSSCAL( NRHS, 1. / D( 1 ), B, LDB )
         RETURN
      END IF
*
      IF( IUPLO.EQ.1 ) THEN
*
*        Solve A * X = B using the factorization A = U'*D*U,
*        overwriting each right hand side vector with its solution.
*
         IF( NRHS.LE.2 ) THEN
            J = 1
    5       CONTINUE
*
*           Solve U' * x = b.
*
            DO 10 I = 2, N
               B( I, J ) = B( I, J ) - B( I-1, J )*CONJG( E( I-1 ) )
   10       CONTINUE
*
*           Solve D * U * x = b.
*
            DO 20 I = 1, N
               B( I, J ) = B( I, J ) / D( I )
   20       CONTINUE
            DO 30 I = N - 1, 1, -1
               B( I, J ) = B( I, J ) - B( I+1, J )*E( I )
   30       CONTINUE
            IF( J.LT.NRHS ) THEN
               J = J + 1
               GO TO 5
            END IF
         ELSE
            DO 60 J = 1, NRHS
*
*              Solve U' * x = b.
*
               DO 40 I = 2, N
                  B( I, J ) = B( I, J ) - B( I-1, J )*CONJG( E( I-1 ) )
   40          CONTINUE
*
*              Solve D * U * x = b.
*
               B( N, J ) = B( N, J ) / D( N )
               DO 50 I = N - 1, 1, -1
                  B( I, J ) = B( I, J ) / D( I ) - B( I+1, J )*E( I )
   50          CONTINUE
   60       CONTINUE
         END IF
      ELSE
*
*        Solve A * X = B using the factorization A = L*D*L',
*        overwriting each right hand side vector with its solution.
*
         IF( NRHS.LE.2 ) THEN
            J = 1
   65       CONTINUE
*
*           Solve L * x = b.
*
            DO 70 I = 2, N
               B( I, J ) = B( I, J ) - B( I-1, J )*E( I-1 )
   70       CONTINUE
*
*           Solve D * L' * x = b.
*
            DO 80 I = 1, N
               B( I, J ) = B( I, J ) / D( I )
   80       CONTINUE
            DO 90 I = N - 1, 1, -1
               B( I, J ) = B( I, J ) - B( I+1, J )*CONJG( E( I ) )
   90       CONTINUE
            IF( J.LT.NRHS ) THEN
               J = J + 1
               GO TO 65
            END IF
         ELSE
            DO 120 J = 1, NRHS
*
*              Solve L * x = b.
*
               DO 100 I = 2, N
                  B( I, J ) = B( I, J ) - B( I-1, J )*E( I-1 )
  100          CONTINUE
*
*              Solve D * L' * x = b.
*
               B( N, J ) = B( N, J ) / D( N )
               DO 110 I = N - 1, 1, -1
                  B( I, J ) = B( I, J ) / D( I ) -
     $                        B( I+1, J )*CONJG( E( I ) )
  110          CONTINUE
  120       CONTINUE
         END IF
      END IF
*
      RETURN
*
*     End of CPTTS2
*
      END

      SUBROUTINE CLARZB( SIDE, TRANS, DIRECT, STOREV, M, N, K, L, V,
     $                   LDV, T, LDT, C, LDC, WORK, LDWORK )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     December 1, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          DIRECT, SIDE, STOREV, TRANS
      INTEGER            K, L, LDC, LDT, LDV, LDWORK, M, N
*     ..
*     .. Array Arguments ..
      COMPLEX            C( LDC, * ), T( LDT, * ), V( LDV, * ),
     $                   WORK( LDWORK, * )
*     ..
*
*  Purpose
*  =======
*
*  CLARZB applies a complex block reflector H or its transpose H**H
*  to a complex distributed M-by-N  C from the left or the right.
*
*  Currently, only STOREV = 'R' and DIRECT = 'B' are supported.
*
*  Arguments
*  =========
*
*  SIDE    (input) CHARACTER*1
*          = 'L': apply H or H' from the Left
*          = 'R': apply H or H' from the Right
*
*  TRANS   (input) CHARACTER*1
*          = 'N': apply H (No transpose)
*          = 'C': apply H' (Conjugate transpose)
*
*  DIRECT  (input) CHARACTER*1
*          Indicates how H is formed from a product of elementary
*          reflectors
*          = 'F': H = H(1) H(2) . . . H(k) (Forward, not supported yet)
*          = 'B': H = H(k) . . . H(2) H(1) (Backward)
*
*  STOREV  (input) CHARACTER*1
*          Indicates how the vectors which define the elementary
*          reflectors are stored:
*          = 'C': Columnwise                        (not supported yet)
*          = 'R': Rowwise
*
*  M       (input) INTEGER
*          The number of rows of the matrix C.
*
*  N       (input) INTEGER
*          The number of columns of the matrix C.
*
*  K       (input) INTEGER
*          The order of the matrix T (= the number of elementary
*          reflectors whose product defines the block reflector).
*
*  L       (input) INTEGER
*          The number of columns of the matrix V containing the
*          meaningful part of the Householder reflectors.
*          If SIDE = 'L', M >= L >= 0, if SIDE = 'R', N >= L >= 0.
*
*  V       (input) COMPLEX array, dimension (LDV,NV).
*          If STOREV = 'C', NV = K; if STOREV = 'R', NV = L.
*
*  LDV     (input) INTEGER
*          The leading dimension of the array V.
*          If STOREV = 'C', LDV >= L; if STOREV = 'R', LDV >= K.
*
*  T       (input) COMPLEX array, dimension (LDT,K)
*          The triangular K-by-K matrix T in the representation of the
*          block reflector.
*
*  LDT     (input) INTEGER
*          The leading dimension of the array T. LDT >= K.
*
*  C       (input/output) COMPLEX array, dimension (LDC,N)
*          On entry, the M-by-N matrix C.
*          On exit, C is overwritten by H*C or H'*C or C*H or C*H'.
*
*  LDC     (input) INTEGER
*          The leading dimension of the array C. LDC >= max(1,M).
*
*  WORK    (workspace) COMPLEX array, dimension (LDWORK,K)
*
*  LDWORK  (input) INTEGER
*          The leading dimension of the array WORK.
*          If SIDE = 'L', LDWORK >= max(1,N);
*          if SIDE = 'R', LDWORK >= max(1,M).
*
*  Further Details
*  ===============
*
*  Based on contributions by
*    A. Petitet, Computer Science Dept., Univ. of Tenn., Knoxville, USA
*
*  =====================================================================
*
*     .. Parameters ..
      COMPLEX            ONE
      PARAMETER          ( ONE = ( 1.0E+0, 0.0E+0 ) )
*     ..
*     .. Local Scalars ..
      CHARACTER          TRANST
      INTEGER            I, INFO, J
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           CCOPY, CGEMM, CLACGV, CTRMM, XERBLA
*     ..
*     .. Executable Statements ..
*
*     Quick return if possible
*
      IF( M.LE.0 .OR. N.LE.0 )
     $   RETURN
*
*     Check for currently supported options
*
      INFO = 0
      IF( .NOT.LSAME( DIRECT, 'B' ) ) THEN
         INFO = -3
      ELSE IF( .NOT.LSAME( STOREV, 'R' ) ) THEN
         INFO = -4
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'CLARZB', -INFO )
         RETURN
      END IF
*
      IF( LSAME( TRANS, 'N' ) ) THEN
         TRANST = 'C'
      ELSE
         TRANST = 'N'
      END IF
*
      IF( LSAME( SIDE, 'L' ) ) THEN
*
*        Form  H * C  or  H' * C
*
*        W( 1:n, 1:k ) = conjg( C( 1:k, 1:n )' )
*
         DO 10 J = 1, K
            CALL CCOPY( N, C( J, 1 ), LDC, WORK( 1, J ), 1 )
   10    CONTINUE
*
*        W( 1:n, 1:k ) = W( 1:n, 1:k ) + ...
*                        conjg( C( m-l+1:m, 1:n )' ) * V( 1:k, 1:l )'
*
         IF( L.GT.0 )
     $      CALL CGEMM( 'Transpose', 'Conjugate transpose', N, K, L,
     $                  ONE, C( M-L+1, 1 ), LDC, V, LDV, ONE, WORK,
     $                  LDWORK )
*
*        W( 1:n, 1:k ) = W( 1:n, 1:k ) * T'  or  W( 1:m, 1:k ) * T
*
         CALL CTRMM( 'Right', 'Lower', TRANST, 'Non-unit', N, K, ONE, T,
     $               LDT, WORK, LDWORK )
*
*        C( 1:k, 1:n ) = C( 1:k, 1:n ) - conjg( W( 1:n, 1:k )' )
*
         DO 30 J = 1, N
            DO 20 I = 1, K
               C( I, J ) = C( I, J ) - WORK( J, I )
   20       CONTINUE
   30    CONTINUE
*
*        C( m-l+1:m, 1:n ) = C( m-l+1:m, 1:n ) - ...
*                    conjg( V( 1:k, 1:l )' ) * conjg( W( 1:n, 1:k )' )
*
         IF( L.GT.0 )
     $      CALL CGEMM( 'Transpose', 'Transpose', L, N, K, -ONE, V, LDV,
     $                  WORK, LDWORK, ONE, C( M-L+1, 1 ), LDC )
*
      ELSE IF( LSAME( SIDE, 'R' ) ) THEN
*
*        Form  C * H  or  C * H'
*
*        W( 1:m, 1:k ) = C( 1:m, 1:k )
*
         DO 40 J = 1, K
            CALL CCOPY( M, C( 1, J ), 1, WORK( 1, J ), 1 )
   40    CONTINUE
*
*        W( 1:m, 1:k ) = W( 1:m, 1:k ) + ...
*                        C( 1:m, n-l+1:n ) * conjg( V( 1:k, 1:l )' )
*
         IF( L.GT.0 )
     $      CALL CGEMM( 'No transpose', 'Transpose', M, K, L, ONE,
     $                  C( 1, N-L+1 ), LDC, V, LDV, ONE, WORK, LDWORK )
*
*        W( 1:m, 1:k ) = W( 1:m, 1:k ) * conjg( T )  or
*                        W( 1:m, 1:k ) * conjg( T' )
*
         DO 50 J = 1, K
            CALL CLACGV( K-J+1, T( J, J ), 1 )
   50    CONTINUE
         CALL CTRMM( 'Right', 'Lower', TRANS, 'Non-unit', M, K, ONE, T,
     $               LDT, WORK, LDWORK )
         DO 60 J = 1, K
            CALL CLACGV( K-J+1, T( J, J ), 1 )
   60    CONTINUE
*
*        C( 1:m, 1:k ) = C( 1:m, 1:k ) - W( 1:m, 1:k )
*
         DO 80 J = 1, K
            DO 70 I = 1, M
               C( I, J ) = C( I, J ) - WORK( I, J )
   70       CONTINUE
   80    CONTINUE
*
*        C( 1:m, n-l+1:n ) = C( 1:m, n-l+1:n ) - ...
*                            W( 1:m, 1:k ) * conjg( V( 1:k, 1:l ) )
*
         DO 90 J = 1, L
            CALL CLACGV( K, V( 1, J ), 1 )
   90    CONTINUE
         IF( L.GT.0 )
     $      CALL CGEMM( 'No transpose', 'No transpose', M, L, K, -ONE,
     $                  WORK, LDWORK, V, LDV, ONE, C( 1, N-L+1 ), LDC )
         DO 100 J = 1, L
            CALL CLACGV( K, V( 1, J ), 1 )
  100    CONTINUE
*
      END IF
*
      RETURN
*
*     End of CLARZB
*
      END

      PROGRAM FISISSRF
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C INVOKE DEMO DRIVER
C
      CALL TISOSR(IWKID,IERR)
C
C     DEACTIVATE AND CLOSE WORKSTATION, CLOSE GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      STOP
      END
C
      SUBROUTINE TISOSR (IWKID,IERROR)
C
C PURPOSE                To provide a simple demonstration of ISOSRF.
C
C USAGE                  CALL TISOSR (IWKID,IERROR)
C
C ARGUMENTS
C
C ON OUTPUT              IERROR
C                          An integer variable
C                          = 0, if the test was successful,
C                          = 1, the test was not successful.
C
C ON INPUT               IWKID
C                          A workstation id
C
C I/O                    If the test is successful, the message
C
C               ISOSRF TEST EXECUTED--SEE PLOTS TO CERTIFY
C
C                        is printed on unit 6.  In addition, 2
C                        frames are produced on the machine graphics
C                        device.  In order to determine if the test
C                        was successful, it is necessary to examine
C                        the plots.
C
C PRECISION              Single
C
C LANGUAGE               FORTRAN 77
C
C REQUIRED ROUTINES      ISOSRF
C
C REQUIRED GKS LEVEL     0A
C
C ALGORITHM              Values of a function on a 3-D rectangular grid
C                        are stored in array T.  Entries EZISOS and
C                        ISOSRF are called to draw iso-valued surface
C                        plots of the function.
C
      SAVE
      DIMENSION       T(21,31,19),SLAB(33,33),EYE(3)
C
C Specify coordinates for plot titles.
C
      REAL IX,IY
      DATA IX/.44/, IY/.95/
C
      DATA NU,NV,NW/21,31,19/
      DATA RBIG1,RBIG2,RSML1,RSML2/6.,6.,2.,2./
      DATA TISO/0./
      DATA MUVWP2/33/
      DATA IFLAG/-7/
C
C Initialize the error parameter.
C
      IERROR = 1
C
C Set the background and foreground colors
C
      CALL GSCR (IWKID,0,1.,1.,1.)
      CALL GSCR (IWKID,1,0.,0.,0.)

C
C Fill the 3-D array to be plotted.
C
      JCENT1 = REAL(NV)*.5-RBIG1*.5
      JCENT2 = REAL(NV)*.5+RBIG2*.5
      DO  30 I=1,NU
         FIMID = I-NU/2
         DO  20 J=1,NV
            FJMID1 = J-JCENT1
            FJMID2 = J-JCENT2
            DO  10 K=1,NW
               FKMID = K-NW/2
               F1 = SQRT(RBIG1*RBIG1/(FJMID1*FJMID1+FKMID*FKMID+.1))
               F2 = SQRT(RBIG2*RBIG2/(FIMID*FIMID+FJMID2*FJMID2+.1))
               FIP1 = (1.-F1)*FIMID
               FIP2 = (1.-F2)*FIMID
               FJP1 = (1.-F1)*FJMID1
               FJP2 = (1.-F2)*FJMID2
               FKP1 = (1.-F1)*FKMID
               FKP2 = (1.-F2)*FKMID
               T(I,J,K) = MIN(FIMID*FIMID+FJP1*FJP1+FKP1*FKP1-
     1                    RSML1*RSML1,
     2                      FKMID*FKMID+FIP2*FIP2+FJP2*FJP2-RSML2*RSML2)
   10       CONTINUE
   20    CONTINUE
   30 CONTINUE
C
C Define the eye position.
C
      EYE(1) = 100.
      EYE(2) = 150.
      EYE(3) = 125.
C
C
C     Frame 1 -- The EZISOS entry.
C
C Select normalization transformation 0.
C
      CALL GSELNT(0)
C
C Call PLCHLQ to write the plot title.
C
      CALL PLCHLQ(IX,IY,'DEMONSTRATION PLOT FOR ENTRY EZISOS OF ISOSRF',
     1 16.,0.,0.)
      CALL EZISOS (T,NU,NV,NW,EYE,SLAB,TISO)
C
C
C     Frame 2 -- The ISOSRF entry.
C
C Select normalization transformation 0.
C
      CALL GSELNT(0)
C
C Call PLCHLQ to write the plot title.
C
      CALL PLCHLQ(IX,IY,'DEMONSTRATION PLOT FOR ENTRY ISOSRF OF ISOSRF',
     1 16.,0.,0.)
C
C Test ISOSRF with a subarray of T.
C
      MU=NU/2
      MV=NV/2
      MW=NW/2
      MUVWP2=MAX(MU,MV,MW)+2
      CALL ISOSRF(T(MU,MV,MW),NU,MU,NV,MV,MW,EYE,MUVWP2,SLAB,TISO,IFLAG)
      CALL FRAME
C
      IERROR = 0
      WRITE (6,1001)
      RETURN
C
 1001 FORMAT (' ISOSRF TEST EXECUTED--SEE PLOTS TO CERTIFY')
C
      END

CThe subroutines in this file were taken directly from RIP code written
C by Dr. Mark Stoelinga.  They were modified by Sherrie
C Fredrick(NCAR/MMM) to work with NCL February 2015.
C NCLFORTSTART
      subroutine wrf_monotonic(out,in,lvprs,cor,idir,delta,
     &                         ew,ns,nz,icorsw)
       implicit none
       integer idir,ew,ns,nz,icorsw
       double precision delta
       double precision in(ew,ns,nz),out(ew,ns,nz)
       double precision lvprs(ew,ns,nz),cor(ew,ns)
C NCLEND

       integer i,j,k,ripk,k300

       do j=1,ns
       do i=1,ew
          if (icorsw.eq.1.and.cor(i,j).lt.0.) then
             do k=1,nz
                in(i,j,k)=-in(i,j,k)
              enddo
          endif   


c
c   First find k index that is at or below (height-wise) the 300 hPa
c      level.
c
      do k = 1,nz
         ripk =  nz-k+1
         if (lvprs(i,j,k) .le. 300.d0) then
            k300=k
            goto 40
         endif
      enddo
c
 40   continue

       do k = k300, 1,-1
         if (idir.eq.1) then
            out(i,j,k)=min(in(i,j,k),in(i,j,k+1)+delta)
         elseif (idir.eq.-1) then
            out(i,j,k)=max(in(i,j,k),in(i,j,k+1)-delta)
         endif
       enddo


       do k = k300+1, nz
         if (idir.eq.1) then
            out(i,j,k)=max(in(i,j,k),in(i,j,k-1)-delta)
         elseif (idir.eq.-1) then
            out(i,j,k)=min(in(i,j,k),in(i,j,k-1)+delta)
         endif
       enddo
      
      end do
      end do
      
      return
      end 

c--------------------------------------------------------------------

C NCLFORTSTART
      FUNCTION wrf_intrp_value (wvalp0,wvalp1,vlev,vcp0,vcp1,icase)
      implicit none

      integer icase
      double precision wvalp0,wvalp1,vlev,vcp0,vcp1
C NCLEND
      double precision valp0,valp1,rvalue,rgas,ussalr,sclht

      double precision wrf_intrp_value,chkdiff

      rgas    = 287.04d0     !J/K/kg
      ussalr  = 0.0065d0      ! deg C per m
      sclht   = rgas*256.d0/9.81d0

      valp0 = wvalp0
      valp1 = wvalp1
      if ( icase .eq. 2) then  !GHT
           valp0=exp(-wvalp0/sclht)
           valp1=exp(-wvalp1/sclht)
      end if

      chkdiff = vcp1 - vcp0
      if(chkdiff .eq. 0) then
         print *,"bad difference in vcp's"
         stop
      end if
 
      rvalue = (vlev-vcp0)*(valp1-valp0)/(vcp1-vcp0)+valp0
      if (icase .eq. 2) then  !GHT
          wrf_intrp_value = -sclht*log(rvalue)
      else
          wrf_intrp_value = rvalue
      endif

      return
      end
c------------------------------------------------------------
C NOTES:
c      vcarray is the array holding the values for the vertical 
c      coordinate.
c              It will always come in with the dimensions of 
c              the staggered U and V grid.  
C NCLFORTSTART

      subroutine  wrf_vintrp(datain,dataout,pres,tk,qvp,ght,terrain,
     &                       sfp,smsfp,vcarray,interp_levels,numlevels,
     &                       icase,ew,ns,nz,extrap,vcor,logp,rmsg)


      implicit none
      integer   ew,ns,nz,icase,extrap
      integer   vcor,numlevels,logp
      double precision   datain(ew,ns,nz),pres(ew,ns,nz),tk(ew,ns,nz)
      double precision   ght(ew,ns,nz)
      double precision   terrain(ew,ns),sfp(ew,ns),smsfp(ew,ns)
      double precision   dataout(ew,ns,numlevels),qvp(ew,ns,nz)
      double precision   vcarray(ew,ns,nz)
      double precision   interp_levels(numlevels),rmsg
C NCLEND     
       integer   njx,niy,nreqlvs,ripk
       integer   i,j,k,itriv,kupper
       integer   ifound,miy,mjx,isign
       double precision      rlevel,vlev,diff
       double precision      tempout(ew,ns),tmpvlev
       double precision      vcp1,vcp0,valp0,valp1
       double precision      rgas,rgasmd,sclht,ussalr,cvc,eps
       double precision      qvlhsl,ttlhsl,vclhsl,vctophsl
       double precision      wrf_intrp_value
       double precision      plhsl,zlhsl,ezlhsl,tlhsl,psurf,pratio,tlev
       double precision      ezsurf,psurfsm,zsurf,qvapor,vt
       double precision      rconst,expon,exponi
       double precision      ezlev,plev,zlev,ptarget,dpmin,dp
       double precision      pbot,zbot,tbotextrap,e
       double precision      tlclc1,tlclc2,tlclc3,tlclc4
       double precision      thtecon1,thtecon2,thtecon3
       double precision      tlcl,gamma,cp,cpmd,gammamd,gammam
       character cvcord*1

       rgas    = 287.04d0     !J/K/kg
       rgasmd  = .608d0
       ussalr  = .0065d0      ! deg C per m
       sclht   = rgas*256.d0/9.81d0
       eps     = 0.622d0
       rconst  = -9.81d0/(rgas * ussalr) 
       expon   =  rgas*ussalr/9.81d0
       exponi  =  1./expon
       tlclc1   = 2840.d0
       tlclc2   = 3.5d0
       tlclc3   = 4.805d0
       tlclc4   = 55.d0
       thtecon1 = 3376.d0 ! K
       thtecon2 = 2.54d0
       thtecon3 = 0.81d0
       cp       = 1004.d0
       cpmd     = 0.887d0
       gamma    = rgas/cp
       gammamd  = rgasmd-cpmd

       if(vcor .eq. 1) then
          cvcord = 'p'
       else if((vcor .eq. 2) .or. (vcor .eq. 3)) then
          cvcord = 'z'
       else if((vcor .eq. 4) .or. (vcor .eq. 5)) then
          cvcord = 't'
       end if


       miy = ns 
       mjx = ew
       njx = ew
       niy = ns


       do j = 1,mjx
          do i = 1,miy
               tempout(j,i) = rmsg
          end do
       end do



      do nreqlvs = 1,numlevels
         if(cvcord .eq. 'z') then
!Convert rlevel to meters from km

            rlevel = interp_levels(nreqlvs) * 1000.d0
            vlev = exp(-rlevel/sclht)              
         else if(cvcord .eq. 'p') then             
            vlev = interp_levels(nreqlvs)          
         else if(cvcord .eq. 't') then             
            vlev = interp_levels(nreqlvs)        
         end if                                    
 

         do j=1,mjx
         do i=1,miy
cGet the interpolated value that is within the model domain
            ifound = 0
            do k = 1,nz-1
               ripk  = nz-k+1
               vcp1  = vcarray(j,i,ripk-1)
               vcp0  = vcarray(j,i,ripk)
               valp0 = datain(j,i,ripk)
               valp1 = datain(j,i,ripk-1)
               if ((vlev.ge.vcp0.and.vlev.le.vcp1) .or. 
     &            (vlev.le.vcp0.and.vlev.ge.vcp1)) then
c                  print *,i,j,valp0,valp1
                  if((valp0 .eq. rmsg).or.(valp1 .eq. rmsg)) then
                     tempout(j,i) = rmsg
                     ifound=1
                  else
                     if(logp .eq. 1) then
                       vcp1  = log(vcp1)
                       vcp0  = log(vcp0)
                       if(vlev .eq. 0.0d0) then
                         print *,"Pressure value = 0"
                         print *,"Unable to take log of 0"
                         stop
                       end if
                       tmpvlev  = log(vlev)
                     else 
                       tmpvlev = vlev
                     end if
                     tempout(j,i) = wrf_intrp_value(valp0,valp1,
     &                                  tmpvlev,vcp0,vcp1,icase)
c                     print *,"one ",i,j,tempout(j,i)
                     ifound=1
                  end if
                  goto 115
               end if
             end do !end for the k loop
 115  continue


      if (ifound.eq.1) then !Grid point is in the model domain
          goto 333
      end if

cIf the user has requested no extrapolatin then just assign
call values above or below the model level to rmsg.
      if(extrap .eq. 0) then
         tempout(j,i) = rmsg
         goto 333  
      end if


c The grid point is either above or below the model domain    
c
c First we will check to see if the grid point is above the
c model domain.
      vclhsl   = vcarray(j,i,1) !lowest model level
      vctophsl = vcarray(j,i,nz)!highest model level
      diff     = vctophsl-vclhsl
      isign    = nint(diff/abs(diff))
C
      if(isign*vlev.ge.isign*vctophsl) then
C Assign the highest model level to the out array
         tempout(j,i)=datain(j,i,nz)  
C         print *,"at warn",j,i,tempout(j,i)
         goto 333
      endif
                           

c
c   Only remaining possibility is that the specified level is below
c   lowest model level.  If lowest model level value is missing,
c   set interpolated value to missing.
c
      if (datain(i,j,1) .eq. rmsg) then
          tempout(j,i) = rmsg
          goto 333
      endif

c
c   If the field comming in is not a pressure,temperature or height 
C   field we can set the output array to the value at the lowest 
c   model level.
c
      tempout(j,i) = datain(j,i,1)      
c
c   For the special cases of pressure on height levels or height on
c   pressure levels, or temperature-related variables on pressure or
c   height levels, perform a special extrapolation based on
c   US Standard Atmosphere.  Here we calcualate the surface pressure
c   with the altimeter equation.  This is how RIP calculates the 
c   surface pressure.
c
       if (icase.gt.0) then
           plhsl  = pres(j,i,1) * 0.01d0  !pressure at lowest model level
           zlhsl  = ght(j,i,1)            !grid point height a lowest model level
           ezlhsl = exp(-zlhsl/sclht)
           tlhsl  = tk(j,i,1)             !temperature in K at lowest model level
           zsurf  = terrain(j,i)
           qvapor = max((qvp(j,i,1)*.001d0),1.e-15)  
c virtual temperature
c          vt     = tlhsl * (eps + qvapor)/(eps*(1.0 + qvapor)) 
c           psurf  = plhsl * (vt/(vt+ussalr * (zlhsl-zsurf)))**rconst
           psurf    = sfp(j,i)
           psurfsm  = smsfp(j,i) 
           ezsurf   = exp(-zsurf/sclht)

cThe if for checking above ground
           if ((cvcord.eq.'z'.and.vlev.lt.ezsurf).or.
     &         (cvcord.eq.'p'.and.vlev.lt.psurf)) then
c
c      We are below the lowest data level but above the ground.
c      Use linear interpolation (linear in prs and exp-height).
c
               if (cvcord.eq.'p') then
                   plev=vlev
                   ezlev=((plev-plhsl)*ezsurf+(psurf-plev)*ezlhsl)/
     &                     (psurf-plhsl)
                   zlev=-sclht*log(ezlev)
                   if (icase .eq. 2) then
                       tempout(j,i)=zlev
                       goto 333
                   endif

                elseif (cvcord.eq.'z') then
                   ezlev=vlev
                   zlev=-sclht*log(ezlev)
                   plev=((ezlev-ezlhsl)*psurf+(ezsurf-ezlev)*plhsl)/
     &                    (ezsurf-ezlhsl)
                   if (icase .eq. 1) then
                      tempout(j,i)=plev
                      goto 333
                  endif
                endif

            else   !else for checking above ground
                ptarget=psurfsm-150.d0
                dpmin=1.e4
                do k=1,nz
                   ripk = nz-k+1
                   dp=abs((pres(j,i,ripk) * 0.01d0)-ptarget)
                   if (dp.gt.dpmin) goto 334
                   dpmin=min(dpmin,dp)
                enddo
 334            kupper=k-1

                ripk       = nz - kupper + 1
                pbot       = max(plhsl,psurf)
                zbot       = min(zlhsl,zsurf)
                pratio     = pbot/(pres(j,i,ripk) * 0.01d0)
                tbotextrap = tk(j,i,ripk)*(pratio)**expon
c virtual temperature
                vt = tbotextrap * (eps + qvapor)/(eps*(1.0d0+qvapor)) 
                if (cvcord.eq.'p') then
                   plev=vlev
                   zlev=zbot+vt/ussalr*(1.-(vlev/pbot)**expon)
                   if(icase .eq. 2) then
                      tempout(j,i)=zlev
                      goto 333
                   endif
                elseif (cvcord.eq.'z') then
                        zlev=-sclht*log(vlev)
                        plev=pbot*(1.+ussalr/vt*(zbot-zlev))**exponi
                        if (icase .eq. 1) then
                            tempout(j,i)=plev
                            goto 333
                        endif
                 endif                
            end if !end if for checking above ground
       end if !for icase gt 0
        

       if(icase .gt. 2) then !extrapolation for temperature
           tlev=tlhsl+(zlhsl-zlev)*ussalr
           qvapor = max(qvp(j,i,1),1.e-15)
           gammam = gamma*(1.+gammamd*qvapor)
           if(icase .eq. 3) then
              tempout(j,i) = tlev - 273.16d0
           else if(icase .eq. 4) then
              tempout(j,i) = tlev
C Potential temperature - theta
           else if (icase. eq. 5) then 
               tempout(j,i)=tlev*(1000.d0/plev)**gammam
C extraolation for equivalent potential temperature
           else if (icase .eq. 6) then 
               e    = qvapor*plev/(eps+qvapor)
               tlcl = tlclc1/(log(tlev**tlclc2/e)-tlclc3)+tlclc4
               tempout(j,i)=tlev*(1000.d0/plev)**(gammam)*
     &         exp((thtecon1/tlcl-thtecon2)*qvapor*
     &             (1.+thtecon3*qvapor))   
           end if            
       end if
       
 333  continue          

         end do
         end do
 !        print *,"----done----",interp_levels(nreqlvs)
          do i = 1,njx
             do j = 1,niy
                dataout(i,j,nreqlvs) = tempout(i,j)
           end do
          end do
       end do !end for the nreqlvs
       return
       end  !wrf_vinterp

C
C $Id: mdname.f,v 1.4 2008-07-27 00:17:07 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      CHARACTER*64 FUNCTION MDNAME (IAIN)
C
        INTEGER      IAIN
C
        PARAMETER (MNAI=8000)
C
C The value of MDNAME(IAIN) is the name of the area with the area
C identifier IAIN.
C
        COMMON /MAPCMX/  IATY(MNAI),ISCI(MNAI),IPAR(MNAI)
        INTEGER          IATY,ISCI,IPAR
        SAVE   /MAPCMX/
C
        COMMON /MAPCMY/  NAME(MNAI),FLNS
        CHARACTER*64     NAME
        CHARACTER*512    FLNS
        SAVE   /MAPCMY/
C
        MDNAME=' '
C
        IF (IAIN.GE.1.AND.IAIN.LE.MNAI) THEN
          IF (IATY(IAIN).NE.0) THEN
            MDNAME=NAME(IAIN)
          END IF
        END IF
C
        RETURN
C
      END

c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by UCAR                 .
c  .                                                             .
c  .       University Corporation for Atmospheric Research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                         SPHEREPACK                          .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c
c
c ... file idivgc.f
c
c     this file includes documentation and code for
c     subroutine idivgc          i
c
c ... files which must be loaded with idivec.f
c
c     sphcom.f, hrfft.f, vhsgc.f,shagc.f
c
c     subroutine idivgc(nlat,nlon,isym,nt,v,w,idvw,jdvw,a,b,mdab,ndab,
c    +                  wvhsgc,lvhsgc,work,lwork,pertrb,ierror)
c
C*PL*ERROR* Comment line too long
c     given the scalar spherical harmonic coefficients a and b, precomputed
C*PL*ERROR* Comment line too long
c     by subroutine shagc for a scalar array dv, subroutine idivgc computes
C*PL*ERROR* Comment line too long
c     an irrotational vector field (v,w) whose divergence is dv - pertrb.
C*PL*ERROR* Comment line too long
c     w is the east longitude component and v is the colatitudinal component.
c     pertrb is a constant which must be subtracted from dv for (v,w) to
C*PL*ERROR* Comment line too long
c     exist (see the description of pertrb below).  usually pertrb is zero
C*PL*ERROR* Comment line too long
c     or small relative to dv.  the vorticity of (v,w) is the zero scalar
C*PL*ERROR* Comment line too long
c     field.  v(i,j) and w(i,j) are the velocity components at the gaussian
C*PL*ERROR* Comment line too long
c     colatitude theta(i) (see nlat) and longitude lambda(j)=(j-1)*2*pi/nlon.
c     the
c
c            divergence[v(i,j),w(i,j)]
c
c          = [d(w(i,j)/dlambda + d(sint*v(i,j))/dtheta]/sint
c
c          = dv(i,j) - pertrb
c
c     and
c
c            vorticity(v(i,j),w(i,j))
c
c         =  [dv/dlambda - d(sint*w)/dtheta]/sint
c
c         =  0.0
c
c     where sint = sin(theta(i)).
c
c     input parameters
c
c
c     nlat   the number of points in the gaussian colatitude grid on the
C*PL*ERROR* Comment line too long
c            full sphere. these lie in the interval (0,pi) and are computed
C*PL*ERROR* Comment line too long
c            in radians in theta(1) <...< theta(nlat) by subroutine gaqd.
C*PL*ERROR* Comment line too long
c            if nlat is odd the equator will be included as the grid point
c            theta((nlat+1)/2).  if nlat is even the equator will be
c            excluded as a grid point and will lie half way between
c            theta(nlat/2) and theta(nlat/2+1). nlat must be at least 3.
c            note: on the half sphere, the number of grid points in the
c            colatitudinal direction is nlat/2 if nlat is even or
c            (nlat+1)/2 if nlat is odd.
c
c     nlon   the number of distinct londitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater than
c            3.  the efficiency of the computation is improved when nlon
c            is a product of small prime numbers.
c
c
c     isym   this has the same value as the isym that was input to
c            subroutine shagc to compute the arrays a and b from the
c            scalar field dv.  isym determines whether (v,w) are
c            computed on the full or half sphere as follows:
c
c      = 0
c
c           dv is not symmetric about the equator. in this case
c           the vector field (v,w) is computed on the entire sphere.
c           i.e., in the arrays  v(i,j),w(i,j) for i=1,...,nlat and
c           j=1,...,nlon.
c
c      = 1
c
c           dv is antisymmetric about the equator. in this case w is
c           antisymmetric and v is symmetric about the equator. w
c           and v are computed on the northern hemisphere only.  i.e.,
c           if nlat is odd they are computed for i=1,...,(nlat+1)/2
c           and j=1,...,nlon.  if nlat is even they are computed for
c           i=1,...,nlat/2 and j=1,...,nlon.
c
c      = 2
c
c           dv is symmetric about the equator. in this case w is
c           symmetric and v is antisymmetric about the equator. w
c           and v are computed on the northern hemisphere only.  i.e.,
c           if nlat is odd they are computed for i=1,...,(nlat+1)/2
c           and j=1,...,nlon.  if nlat is even they are computed for
c           i=1,...,nlat/2 and j=1,...,nlon.
c
c
c     nt     nt is the number of divergence and vector fields.  some
c            computational efficiency is obtained for multiple fields.
c            the arrays a,b,v, and w can be three dimensional and pertrb
c            can be one dimensional corresponding to an indexed multiple
c            array dv.  in this case, multiple vector synthesis will be
C*PL*ERROR* Comment line too long
c            performed to compute each vector field.  the third index for
c            a,b,v,w and first for pertrb is the synthesis index which
C*PL*ERROR* Comment line too long
c            assumes the values k = 1,...,nt.  for a single synthesis set
c            nt = 1.  the description of the remaining parameters is
c            simplified by assuming that nt=1 or that a,b,v,w are two
c            dimensional and pertrb is a constant.
c
c     idvw   the first dimension of the arrays v,w as it appears in
c            the program that calls idivgc. if isym = 0 then idvw
c            must be at least nlat.  if isym = 1 or 2 and nlat is
c            even then idvw must be at least nlat/2. if isym = 1 or 2
c            and nlat is odd then idvw must be at least (nlat+1)/2.
c
c     jdvw   the second dimension of the arrays v,w as it appears in
c            the program that calls idivgc. jdvw must be at least nlon.
c
c     a,b    two or three dimensional arrays (see input parameter nt)
c            that contain scalar spherical harmonic coefficients
c            of the divergence array dv as computed by subroutine shagc.
c     ***    a,b must be computed by shagc prior to calling idivgc.
c
c     mdab   the first dimension of the arrays a and b as it appears in
c            the program that calls idivgc (and shagc). mdab must be at
c            least min0(nlat,(nlon+2)/2) if nlon is even or at least
c            min0(nlat,(nlon+1)/2) if nlon is odd.
c
c     ndab   the second dimension of the arrays a and b as it appears in
c            the program that calls idivgc (and shagc). ndab must be at
c            least nlat.
c
c
c  wvhsgc    an array which must be initialized by subroutine vhsgci.
c            once initialized,
c            wvhsgc can be used repeatedly by idivgc as long as nlon
c            and nlat remain unchanged.  wvhsgc must not be altered
c            between calls of idivgc.
c
c
c  lvhsgc    the dimension of the array wvhsgc as it appears in the
c            program that calls idivgc. define
c
c               l1 = min0(nlat,nlon/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            then lvhsgc must be at least
c
c               4*nlat*l2+3*max0(l1-2,0)*(2*nlat-l1-1)+nlon+15
c
c
c     work   a work array that does not have to be saved.
c
c     lwork  the dimension of the array work as it appears in the
c            program that calls idivgc. define
c
c               l1 = min0(nlat,nlon/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2                  if nlat is even or
c               l2 = (nlat+1)/2              if nlat is odd
c
c            if isym = 0 then lwork must be at least
c
c               nlat*(2*nt*nlon+max0(6*l2,nlon) + 2*nt*l1 + 1)
c
c            if isym = 1 or 2 then lwork must be at least
c
c               l2*(2*nt*nlon+max0(6*nlat,nlon)) + nlat*(2*nt*l1+1)
c
c
c     **************************************************************
c
c     output parameters
c
c
C*PL*ERROR* Comment line too long
c     v,w   two or three dimensional arrays (see input parameter nt) that
c           contain an irrotational vector field whose divergence is
c           dv-pertrb at the guassian colatitude point theta(i) and
c           longitude point lambda(j)=(j-1)*2*pi/nlon.  w is the east
C*PL*ERROR* Comment line too long
c           longitude component and v is the colatitudinal component.  the
c           indices for w and v are defined at the input parameter isym.
C*PL*ERROR* Comment line too long
c           the curl or vorticity of (v,w) is the zero vector field.  note
c           that any nonzero vector field on the sphere will be multiple
c           valued at the poles [reference swarztrauber].
c
C*PL*ERROR* Comment line too long
c   pertrb  a nt dimensional array (see input parameter nt and assume nt=1
c           for the description that follows).  dv - pertrb is a scalar
c           field which can be the divergence of a vector field (v,w).
c           pertrb is related to the scalar harmonic coefficients a,b
c           of dv (computed by shagc) by the formula
c
c                pertrb = a(1,1)/(2.*sqrt(2.))
c
c
c
c           the unperturbed scalar field dv can be the divergence of a
c           vector field only if a(1,1) is zero.  if a(1,1) is nonzero
c           (flagged by pertrb nonzero) then subtracting pertrb from
c           dv yields a scalar field for which a(1,1) is zero.
c
c    ierror = 0  no errors
c           = 1  error in the specification of nlat
c           = 2  error in the specification of nlon
c           = 3  error in the specification of isym
c           = 4  error in the specification of nt
c           = 5  error in the specification of idvw
c           = 6  error in the specification of jdvw
c           = 7  error in the specification of mdab
c           = 8  error in the specification of ndab
c           = 9  error in the specification of lvhsgc
c           = 10 error in the specification of lwork
c **********************************************************************
c
c
      SUBROUTINE DIDIVGC(NLAT,NLON,ISYM,NT,V,W,IDVW,JDVW,A,B,MDAB,NDAB,
     +                  WVHSGC,LVHSGC,WORK,LWORK,PERTRB,IERROR)
      DOUBLE PRECISION V
      DOUBLE PRECISION W
      DOUBLE PRECISION A
      DOUBLE PRECISION B
      DOUBLE PRECISION WVHSGC
      DOUBLE PRECISION WORK
      DOUBLE PRECISION PERTRB
      DIMENSION V(IDVW,JDVW,NT),W(IDVW,JDVW,NT),PERTRB(NT)
      DIMENSION A(MDAB,NDAB,NT),B(MDAB,NDAB,NT)
      DIMENSION WVHSGC(LVHSGC),WORK(LWORK)
c
c     check input parameters
c
      IERROR = 1
      IF (NLAT.LT.3) RETURN
      IERROR = 2
      IF (NLON.LT.4) RETURN
      IERROR = 3
      IF (ISYM.LT.0 .OR. ISYM.GT.2) RETURN
      IERROR = 4
      IF (NT.LT.0) RETURN
      IERROR = 5
      IMID = (NLAT+1)/2
      IF ((ISYM.EQ.0.AND.IDVW.LT.NLAT) .OR.
     +    (ISYM.NE.0.AND.IDVW.LT.IMID)) RETURN
      IERROR = 6
      IF (JDVW.LT.NLON) RETURN
      IERROR = 7
      MMAX = MIN0(NLAT, (NLON+1)/2)
      IF (MDAB.LT.MIN0(NLAT, (NLON+2)/2)) RETURN
      IERROR = 8
      IF (NDAB.LT.NLAT) RETURN
      IERROR = 9
      IDZ = (MMAX* (NLAT+NLAT-MMAX+1))/2
      LZIMN = IDZ*IMID
      L1 = MIN0(NLAT, (NLON+1)/2)
      L2 = (NLAT+1)/2
      LWMIN = 4*NLAT*L2 + 3*MAX0(L1-2,0)* (2*NLAT-L1-1) + NLON + 15
      IF (LVHSGC.LT.LWMIN) RETURN
      IERROR = 10
c
c     verify unsaved work space length
c
      MN = MMAX*NLAT*NT
      IF (ISYM.NE.0 .AND. LWORK.LT.NLAT* (2*NT*NLON+MAX0(6*IMID,NLON))+
     +    2*MN+NLAT) RETURN
      IF (ISYM.EQ.0 .AND. LWORK.LT.IMID* (2*NT*NLON+MAX0(6*NLAT,NLON))+
     +    2*MN+NLAT) RETURN
      IERROR = 0
c
c     set work space pointers
c
      IBR = 1
      IBI = IBR + MN
      IS = IBI + MN
      IWK = IS + NLAT
      LIWK = LWORK - 2*MN - NLAT
      CALL DIDVGC1(NLAT,NLON,ISYM,NT,V,W,IDVW,JDVW,WORK(IBR),WORK(IBI),
     +            MMAX,WORK(IS),MDAB,NDAB,A,B,WVHSGC,LVHSGC,WORK(IWK),
     +            LIWK,PERTRB,IERROR)
      RETURN
      END

      SUBROUTINE DIDVGC1(NLAT,NLON,ISYM,NT,V,W,IDVW,JDVW,BR,BI,MMAX,
     +                   SQNN,MDAB,NDAB,A,B,WSAV,LWSAV,WK,LWK,PERTRB,
     +                   IERROR)
      DOUBLE PRECISION V
      DOUBLE PRECISION W
      DOUBLE PRECISION BR
      DOUBLE PRECISION BI
      DOUBLE PRECISION SQNN
      DOUBLE PRECISION A
      DOUBLE PRECISION B
      DOUBLE PRECISION WSAV
      DOUBLE PRECISION WK
      DOUBLE PRECISION PERTRB
      DOUBLE PRECISION FN
      DOUBLE PRECISION CR
      DOUBLE PRECISION CI
      DIMENSION V(IDVW,JDVW,NT),W(IDVW,JDVW,NT),PERTRB(NT)
      DIMENSION BR(MMAX,NLAT,NT),BI(MMAX,NLAT,NT),SQNN(NLAT)
      DIMENSION A(MDAB,NDAB,NT),B(MDAB,NDAB,NT)
      DIMENSION WSAV(LWSAV),WK(LWK)
c
c     preset coefficient multiplyers in vector
c
      DO 1 N = 2,NLAT
          FN = DBLE(N-1)
          SQNN(N) = SQRT(FN* (FN+1.D0))
    1 CONTINUE
c
c     compute multiple vector fields coefficients
c
      DO 2 K = 1,NT
c
c     set divergence field perturbation adjustment
c
          PERTRB(K) = A(1,1,K)/ (2.D0*SQRT(2.D0))
c
c     preset br,bi to 0.0
c
          DO 3 N = 1,NLAT
              DO 4 M = 1,MMAX
                  BR(M,N,K) = 0.0D0
                  BI(M,N,K) = 0.0D0
    4         CONTINUE
    3     CONTINUE
c
c     compute m=0 coefficients
c
          DO 5 N = 2,NLAT
              BR(1,N,K) = -A(1,N,K)/SQNN(N)
              BI(1,N,K) = -B(1,N,K)/SQNN(N)
    5     CONTINUE
c
c     compute m>0 coefficients
c
          DO 6 M = 2,MMAX
              DO 7 N = M,NLAT
                  BR(M,N,K) = -A(M,N,K)/SQNN(N)
                  BI(M,N,K) = -B(M,N,K)/SQNN(N)
    7         CONTINUE
    6     CONTINUE
    2 CONTINUE
c
c     set ityp for vector synthesis with curl=0
c
      IF (ISYM.EQ.0) THEN
          ITYP = 1
      ELSE IF (ISYM.EQ.1) THEN
          ITYP = 4
      ELSE IF (ISYM.EQ.2) THEN
          ITYP = 7
      END IF
c
c     vector sythesize br,bi into irrotational (v,w)
c
      CALL DVHSGC(NLAT,NLON,ITYP,NT,V,W,IDVW,JDVW,BR,BI,CR,CI,MMAX,NLAT,
     +           WSAV,LWSAV,WK,LWK,IERROR)
      RETURN
      END

        PROGRAM MPEX10
C
C Assume you have a FORTRAN function that, given the position of a
C point on the surface of the earth, returns the real value of some
C physical quantity there.  You would like to split the full range of
C values of the quantity into intervals, associate a different color
C with each interval, and then draw a colored map of the resulting
C globe.  One way to do this is to use the contouring package CONPACK;
C another way to do it is given below.
C
C This program constructs a rectangular cell array covering the part
C of the plotter frame occupied by a selected map of the globe.  Each
C element of the cell array occupies a small rectangular portion of
C the plotter frame.  The EZMAP routine MAPTRI, which does the inverse
C transformations, is used to find the values of latitude and longitude
C associated with each cell; these can be used to obtain the value of
C the physical quantity and therefore the color index associated with
C the cell.  When the cell array is complete, it is drawn by a call to
C the GKS routine GCA.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
        PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Define an integer array in which to build the cell array.
C
        DIMENSION ICRA(1000,1000)
C
C Declare some required variables.
C
        CHARACTER*2 PROJ,JLTS
        DIMENSION PLM1(2),PLM2(2),PLM3(2),PLM4(2)
C
C NCLS specifies the number of cells along each edge of the cell array.
C Use a positive value less than or equal to 1000.
C
        DATA NCLS / 300 /
C
C NCLR specifies the number of different colors to be used.
C
        DATA NCLR / 64 /
C
C PROJ is the desired projection type.  Use one of 'LC', 'ST', 'OR',
C 'LE', 'GN', 'AE', 'SV', 'CE', 'ME', or 'MO'.
C
        DATA PROJ / 'OR' /
C
C PLAT and PLON are the desired latitude and longitude of the center of
C the projection, in degrees.
C
        DATA PLAT,PLON / 40. , -105. /
C
C ROTA is the desired final rotation of the map, in degrees.
C
        DATA ROTA / 0. /
C
C SALT, ALFA, and BETA are the desired values of the parameters 'SA',
C 'S1', and 'S2', which are only used with a satellite-view projection.
C SALT is the distance of the satellite from the center of the earth,
C in units of earth radii.  ALFA is the angle, in degrees, between the
C line of sight and the line to the center of the earth.  BETA is used
C only when ALFA is non-zero; it is the angle, in degrees, measured
C counterclockwise, from the plane passing through the satellite, the
C center of the earth, and the point which is due east on the horizon
C to the plane in which the line of sight and the line to the center
C of the earth both lie.
C
        DATA SALT,ALFA,BETA / 1.25 , 15. , 90. /
C
C JLTS, PLM1, PLM2, PLM3, and PLM4 are the required arguments of the
C EZMAP routine MAPSET, which determines the boundaries of the map.
C
        DATA JLTS / 'MA' /
        DATA PLM1(1),PLM2(1),PLM3(1),PLM4(1) / 0. , 0. , 0. , 0. /
        DATA PLM1(2),PLM2(2),PLM3(2),PLM4(2) / 0. , 0. , 0. , 0. /
C
C IGRD is the spacing, in degrees, of the EZMAP grid of latitudes and
C longitudes.
C
        DATA IGRD / 15 /
C
C Define the constant used to convert from degrees to radians.
C
        DATA DTOR / .017453292519943 /
C
C Open GKS.
C
        CALL GOPKS (IERRF, ISZDM)
        CALL GOPWK (IWKID, LUNIT, IWTYPE)
        CALL GACWK (IWKID)
C
C Define the color indices required.  0 and 1 are used for black and
C white (as is customary); the next NCLR values are distributed between
C pure blue (color 2) and pure red (color NCLR+1).
C
        CALL GSCR (IWKID,0,0.,0.,0.)
        CALL GSCR (IWKID,1,1.,1.,1.)
C
        DO 101 ICLR=1,NCLR
          CALL GSCR (IWKID,1+ICLR,REAL(ICLR-1)/REAL(NCLR-1),0.,
     +                        REAL(NCLR-ICLR)/REAL(NCLR-1))
  101   CONTINUE
C
C Set the EZMAP projection parameters.
C
        CALL MAPROJ (PROJ,PLAT,PLON,ROTA)
        IF (PROJ.EQ.'SV') THEN
          CALL MAPSTR ('SA',SALT)
          CALL MAPSTR ('S1',ALFA)
          CALL MAPSTR ('S2',BETA)
        END IF
C
C Set the limits of the map.
C
        CALL MAPSET (JLTS,PLM1,PLM2,PLM3,PLM4)
C
C Set the grid spacing.
C
        CALL MAPSTI ('GR - GRID SPACING',IGRD)
C
C Initialize EZMAP, so that calls to MAPTRI will work properly.
C
        CALL MAPINT
C
C Fill the cell array.  The data generator is rigged to create
C values between 0 and 1, so as to make it easy to interpolate to
C get a color index to be used.  Obviously, the statement setting
C DVAL can be replaced by one that yields a value of some real data
C field of interest (normalized to the range from 0 to 1).
C
        DO 103 I=1,NCLS
          X=CFUX(.05+.90*(REAL(I-1)+.5)/REAL(NCLS))
          DO 102 J=1,NCLS
            Y=CFUY(.05+.90*(REAL(J-1)+.5)/REAL(NCLS))
            CALL MAPTRI (X,Y,RLAT,RLON)
            IF (RLAT.NE.1.E12) THEN
              DVAL=.25*(1.+COS(DTOR*10.*RLAT))+
     +             .25*(1.+SIN(DTOR*10.*RLON))*COS(DTOR*RLAT)
              ICRA(I,J)=MAX(2,MIN(NCLR+1,2+INT(DVAL*REAL(NCLR))))
            ELSE
              ICRA(I,J)=0
            END IF
  102     CONTINUE
  103   CONTINUE
C
C Draw the cell array.
C
        CALL GCA (CFUX(.05),CFUY(.05),CFUX(.95),CFUY(.95),1000,1000,
     +                                           1,1,NCLS,NCLS,ICRA)
C
C Draw a map on top of the cell array.
C
        CALL MAPDRW
C
C Put a label at the top of the plot.
C
        CALL SET   (0.,1.,0.,1.,0.,1.,0.,1.,1)
        CALL WTSTR (.5,.975,'EXAMPLE 10',2,0,0)
C
C Draw a boundary around the edge of the plotter frame.
C
        CALL BNDARY
C
C Advance the frame.
C
        CALL FRAME
C
C Close GKS.
C
        CALL GDAWK (IWKID)
        CALL GCLWK (IWKID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END

      SUBROUTINE SSPGV( ITYPE, JOBZ, UPLO, N, AP, BP, W, Z, LDZ, WORK,
     $                  INFO )
*
*  -- LAPACK driver routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER          JOBZ, UPLO
      INTEGER            INFO, ITYPE, LDZ, N
*     ..
*     .. Array Arguments ..
      REAL               AP( * ), BP( * ), W( * ), WORK( * ),
     $                   Z( LDZ, * )
*     ..
*
*  Purpose
*  =======
*
*  SSPGV computes all the eigenvalues and, optionally, the eigenvectors
*  of a real generalized symmetric-definite eigenproblem, of the form
*  A*x=(lambda)*B*x,  A*Bx=(lambda)*x,  or B*A*x=(lambda)*x.
*  Here A and B are assumed to be symmetric, stored in packed format,
*  and B is also positive definite.
*
*  Arguments
*  =========
*
*  ITYPE   (input) INTEGER
*          Specifies the problem type to be solved:
*          = 1:  A*x = (lambda)*B*x
*          = 2:  A*B*x = (lambda)*x
*          = 3:  B*A*x = (lambda)*x
*
*  JOBZ    (input) CHARACTER*1
*          = 'N':  Compute eigenvalues only;
*          = 'V':  Compute eigenvalues and eigenvectors.
*
*  UPLO    (input) CHARACTER*1
*          = 'U':  Upper triangles of A and B are stored;
*          = 'L':  Lower triangles of A and B are stored.
*
*  N       (input) INTEGER
*          The order of the matrices A and B.  N >= 0.
*
*  AP      (input/output) REAL array, dimension
*                            (N*(N+1)/2)
*          On entry, the upper or lower triangle of the symmetric matrix
*          A, packed columnwise in a linear array.  The j-th column of A
*          is stored in the array AP as follows:
*          if UPLO = 'U', AP(i + (j-1)*j/2) = A(i,j) for 1<=i<=j;
*          if UPLO = 'L', AP(i + (j-1)*(2*n-j)/2) = A(i,j) for j<=i<=n.
*
*          On exit, the contents of AP are destroyed.
*
*  BP      (input/output) REAL array, dimension (N*(N+1)/2)
*          On entry, the upper or lower triangle of the symmetric matrix
*          B, packed columnwise in a linear array.  The j-th column of B
*          is stored in the array BP as follows:
*          if UPLO = 'U', BP(i + (j-1)*j/2) = B(i,j) for 1<=i<=j;
*          if UPLO = 'L', BP(i + (j-1)*(2*n-j)/2) = B(i,j) for j<=i<=n.
*
*          On exit, the triangular factor U or L from the Cholesky
*          factorization B = U**T*U or B = L*L**T, in the same storage
*          format as B.
*
*  W       (output) REAL array, dimension (N)
*          If INFO = 0, the eigenvalues in ascending order.
*
*  Z       (output) REAL array, dimension (LDZ, N)
*          If JOBZ = 'V', then if INFO = 0, Z contains the matrix Z of
*          eigenvectors.  The eigenvectors are normalized as follows:
*          if ITYPE = 1 or 2, Z**T*B*Z = I;
*          if ITYPE = 3, Z**T*inv(B)*Z = I.
*          If JOBZ = 'N', then Z is not referenced.
*
*  LDZ     (input) INTEGER
*          The leading dimension of the array Z.  LDZ >= 1, and if
*          JOBZ = 'V', LDZ >= max(1,N).
*
*  WORK    (workspace) REAL array, dimension (3*N)
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*          > 0:  SPPTRF or SSPEV returned an error code:
*             <= N:  if INFO = i, SSPEV failed to converge;
*                    i off-diagonal elements of an intermediate
*                    tridiagonal form did not converge to zero.
*             > N:   if INFO = n + i, for 1 <= i <= n, then the leading
*                    minor of order i of B is not positive definite.
*                    The factorization of B could not be completed and
*                    no eigenvalues or eigenvectors were computed.
*
*  =====================================================================
*
*     .. Local Scalars ..
      LOGICAL            UPPER, WANTZ
      CHARACTER          TRANS
      INTEGER            J, NEIG
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           SPPTRF, SSPEV, SSPGST, STPMV, STPSV, XERBLA
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      WANTZ = LSAME( JOBZ, 'V' )
      UPPER = LSAME( UPLO, 'U' )
*
      INFO = 0
      IF( ITYPE.LT.0 .OR. ITYPE.GT.3 ) THEN
         INFO = -1
      ELSE IF( .NOT.( WANTZ .OR. LSAME( JOBZ, 'N' ) ) ) THEN
         INFO = -2
      ELSE IF( .NOT.( UPPER .OR. LSAME( UPLO, 'L' ) ) ) THEN
         INFO = -3
      ELSE IF( N.LT.0 ) THEN
         INFO = -4
      ELSE IF( LDZ.LT.1 .OR. ( WANTZ .AND. LDZ.LT.N ) ) THEN
         INFO = -9
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'SSPGV ', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
*
*     Form a Cholesky factorization of B.
*
      CALL SPPTRF( UPLO, N, BP, INFO )
      IF( INFO.NE.0 ) THEN
         INFO = N + INFO
         RETURN
      END IF
*
*     Transform problem to standard eigenvalue problem and solve.
*
      CALL SSPGST( ITYPE, UPLO, N, AP, BP, INFO )
      CALL SSPEV( JOBZ, UPLO, N, AP, W, Z, LDZ, WORK, INFO )
*
      IF( WANTZ ) THEN
*
*        Backtransform eigenvectors to the original problem.
*
         NEIG = N
         IF( INFO.GT.0 )
     $      NEIG = INFO - 1
         IF( ITYPE.EQ.1 .OR. ITYPE.EQ.2 ) THEN
*
*           For A*x=(lambda)*B*x and A*B*x=(lambda)*x;
*           backtransform eigenvectors: x = inv(L)'*y or inv(U)*y
*
            IF( UPPER ) THEN
               TRANS = 'N'
            ELSE
               TRANS = 'T'
            END IF
*
            DO 10 J = 1, NEIG
               CALL STPSV( UPLO, TRANS, 'Non-unit', N, BP, Z( 1, J ),
     $                     1 )
   10       CONTINUE
*
         ELSE IF( ITYPE.EQ.3 ) THEN
*
*           For B*A*x=(lambda)*x;
*           backtransform eigenvectors: x = L*y or U'*y
*
            IF( UPPER ) THEN
               TRANS = 'T'
            ELSE
               TRANS = 'N'
            END IF
*
            DO 20 J = 1, NEIG
               CALL STPMV( UPLO, TRANS, 'Non-unit', N, BP, Z( 1, J ),
     $                     1 )
   20       CONTINUE
         END IF
      END IF
      RETURN
*
*     End of SSPGV
*
      END

C
C	$Id: intcnv.f,v 1.4 2008-07-27 00:59:04 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE INTCNV(CHRSTR,INTVAL,IOS,STATUS)
C
C  DECODE A CHARACTER ARRAY STRING INTO AN INTEGER ARRAY
C
C  INPUT
C       CHRSTR-CHARACTER ARRAY STRING CONTAINING CHARACTERS TO BE CONVERTED
C               INTO INTEGER ARRAY 80
C  OUTPUT
C       INTVAL-INTEGER VALUE GENERATED
C       IOS-THE I/O STATUS OF THE REQUEST ONLY VALID IF STATUS NOT ZERO
C       STATUS-THE ERROR STATUS
C               ZERO ALL OK
C               NOT ZERO THEN ERROR
C
      INTEGER INTVAL,IOS,STATUS,II,ISTRT,KK
      CHARACTER*1 CHRSTR(80)
      CHARACTER*1 NUMS(10)
C
      DATA NUMS/'0','1','2','3','4','5','6','7','8','9'/
C
      INTVAL = 0
C
C  DECODE THE STRING
C
C  FIRST SKIP LEADING BLANKS
C
      DO 10 II = 1,80
        ISTRT = II
        IF (CHRSTR(II) .NE. ' ') GO TO 20
 10   CONTINUE
C
C   NOTHING IN THE STRING SO RETURN
C
      RETURN
C
 20   CONTINUE
C
C  NON BLANK SO START DECODING
C
      DO 30 II = ISTRT,80
        DO 25 KK = 1,10
                IF ( CHRSTR(II) .EQ. NUMS(KK)) THEN
C
C                       INTEGER FOUND SO MODIFY THE INTVAL
C
                        INTVAL = INTVAL * 10 + (KK-1)
                        GO TO 30
                END IF
 25     CONTINUE
C
C       IF YOU REACH HERE THERE WAS A NON INTEGER CHARACTER SO RETURN
C
        RETURN
 30   CONTINUE
C
      RETURN
      END

C
C      $Id: nm06f.f,v 1.8 2010-03-15 22:49:24 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                       C
C                Copyright (C)  1997                                    C
C        University Corporation for Atmospheric Research                C
C                All Rights Reserved                                    C
C                                                                       C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C  File:       nm06f.f
C
C  Author:     Mary Haley (taken from one of Fred Clare's examples)
C              National Center for Atmospheric Research
C              PO 3000, Boulder, Colorado
C
C  Date:       Mon Dec 22 16:36:20 MST 1997
C
C  Description: Smoothing in a simple 2D interpolation.
C
      external NhlFAppClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFCairoWindowWorkstationClass

      parameter(NUM=171,NX=21,NY=21)

      real xi(NUM), yi(NUM), zi(NUM)
      real xo(NX), yo(NY), output(NX,NY),output2(NX,NY)
      data xminin,yminin,xmaxin,ymaxin/ -0.2, -0.2, 1.2, 1.2/
      data xminot,yminot,xmaxot,ymaxot/  0.0,  0.0, 1.0, 1.0/
      data rho, theta, phi/3., -54., 32./
      integer ierr
      integer appid,wid,gkswid
      integer srlist, grlist
      integer i
      character*7  wks_type
C
C Default is to display output to an NCGM workstation.
C
      wks_type = "ncgm"

C
C Initialize the high level utility library
C
      call NhlFInitialize
C
C Create an application context. Set the app dir to the current directory
C so the application looks for a resource file in the working directory.
C In this example the resource file supplies the plot title only.
C
      call NhlFRLCreate(srlist,'setrl')
      call NhlFRLCreate(grlist,'getrl')

      call NhlFRLClear(srlist)
      call NhlFRLSetString(srlist,'appDefaultParent','True',ierr)
      call NhlFRLSetString(srlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'nm06',NhlFAppClass,0,srlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkMetaName','./nm06f.ncgm',ierr)
         call NhlFCreate(wid,'nm06Work',
     +        NhlFNcgmWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X11 workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkPause','True',ierr)
         call NhlFCreate(wid,'nm06Work',
     +        NhlFCairoWindowWorkstationClass,
     +        0,srlist,ierr)
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PostScript workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkPSFileName','./nm06f.ps',ierr)
         call NhlFCreate(wid,'nm06Work',
     +        NhlFPSWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkPDFFileName','./nm06f.pdf',ierr)
         call NhlFCreate(wid,'nm06Work',
     +        NhlFPDFWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkFileName','./nm06f',ierr)
         call NhlFRLSetString(srlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(wid,'nm06Work',
     +        NhlFCairoPSPDFWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkFileName','./nm06f',ierr)
         call NhlFRLSetString(srlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(wid,'nm06Work',
     +        NhlFCairoImageWorkstationClass,0,srlist,ierr)
      endif
C
C  Create random data in two-space and define a function.
C  To get this to work on your system, you may have to insert
C  the correct random number generator for your compiler.
C
      do 10 i=1,num
         xi(i) = xminin+(xmaxin-xminin)*drnm6()
         yi(i) = yminin+(ymaxin-yminin)*drnm6()
         zi(i) = (xi(i)-0.25)**2 + (yi(i)-0.50)**2
 10   continue
C
C  Create the output grid.
C
      do 102 i=1,nx
        xo(i) = xminot+(real(i-1)/real(nx-1))*(xmaxot-xminot)
  102 continue
      do 103 j =1,ny
        yo(j)= yminot+(real(j-1)/real(ny-1))*(ymaxot-yminot)
  103 continue
C
C  Interpolate.
C
      call dsgrid2s(num, xi, yi, zi, nx, ny, xo, yo, output, ierr)
C
C Get Workstation ID.
C
      call NhlFRLClear(grlist)
      call NhlFRLGetInteger(grlist,'wkGksWorkId',gkswid,ierr)
      call NhlFGetValues(wid,grlist,ierr)
C
C  Interpolate using dspnt2s.
C
      do 115 i = 1,NX
         do 110 j = 1,NY
            call dspnt2s(NUM,xi,yi,zi,1,xo(i),yo(j),output2(i,j),ier)
 110     continue
 115  continue
C
C There's no HLU object for surface plots yet, so we need to call the
C LLUs to get a surface plot.
C
      call gacwk (gkswid)
      call tdez2d(nx, ny, xo, yo, output, rho, theta, phi, 6)
      call gdawk (gkswid)
      call NhlFFrame(wid,ier)

      call gacwk (gkswid)
      call tdez2d(nx, ny, xo, yo, output2, rho, theta, phi, 6)
      call gdawk (gkswid)
      call NhlFFrame(wid,ier)
C
C NhlDestroy destroys the given id and all of its children.
C
      call NhlFDestroy(wid,ierr)
C
C Restores state.
C
      call NhlFClose
      stop
      end
      REAL FUNCTION DRNM6()
C
C  Portable random number generator.
C
      PARAMETER (MPLIER=16807,MODLUS=2147483647,MOBYMP=127773,
     +           MOMDMP=2836)
C
      INTEGER HVLUE, LVLUE, TESTV, NEXTN
      SAVE    NEXTN
      DATA JSEED,IFRST/123456789,0/
C
      IF (IFRST .EQ. 0) THEN
        NEXTN = JSEED
        IFRST = 1
      ENDIF
C
      HVLUE = NEXTN / MOBYMP
      LVLUE = MOD(NEXTN, MOBYMP)
      TESTV = MPLIER*LVLUE - MOMDMP*HVLUE
      IF (TESTV .GT. 0) THEN
        NEXTN = TESTV
      ELSE
        NEXTN = TESTV + MODLUS
      ENDIF
      DRNM6 = REAL(NEXTN)/REAL(MODLUS)
C
      RETURN
      END

C
C	$Id: q8qst4.f,v 1.4 2008-07-27 00:17:31 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE Q8QST4(NAME,LBRARY,ENTRY,VRSION)
C
C DIMENSION OF           NAME(1),LBRARY(1),ENTRY(1),VRSION(1)
C ARGUMENTS
C
C LATEST REVISION        MARCH 1984
C
C PURPOSE                MONITORS LIBRARY USE BY WRITING A RECORD WITH
C                        INFORMATION ABOUT THE CIRCUMSTANCES OF A
C                        LIBRARY ROUTINE CALL TO THE SYSTEM ACCOUNTING
C                        TAPE FOR LATER PROCESSING.
C
C NOTE---                THIS VERSION OF Q8QST4 SIMPLY RETURNS TO THE
C                        CALLING ROUTINE.  LOCAL IMPLEMENTORS MAY WISH
C                        TO IMPLEMENT A VERSION OF THIS ROUTINE THAT
C                        MONITORS USE OF NCAR ROUTINES WITH LOCAL
C                        MECHANISMS.  OTHERWISE IT WILL SAVE A SMALL
C                        AMOUNT OF SPACE AND TIME IF CALLS TO Q8QST4 ARE
C                        DELETED FROM ALL NSSL ROUTINES.
C
      CHARACTER*(*) NAME,LBRARY,ENTRY,VRSION
C
      RETURN
      END

C
C $Id: snhcsh.f,v 1.5 2008-07-27 03:10:12 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
C NOTE: If you make any changes to this software, please remember to
C make the same changes to the corresponding double precision routine.
C
      subroutine snhcsh (sinhm,coshm,x,isw)
c
      integer isw
      real sinhm,coshm,x
c
c                                 coded by alan kaylor cline
c                           from fitpack -- january 26, 1987
c                        a curve and surface fitting package
c                      a product of pleasant valley software
c                  8603 altus cove, austin, texas 78759, usa
c
c this subroutine returns approximations to
c       sinhm(x) = sinh(x)/x-1
c       coshm(x) = cosh(x)-1
c and
c       coshmm(x) = (cosh(x)-1-x*x/2)/(x*x)
c with relative error less than 4.0e-14.
c
c on input--
c
c   x contains the value of the independent variable.
c
c   isw indicates the function desired
c           = -1 if only sinhm is desired,
c           =  0 if both sinhm and coshm are desired,
c           =  1 if only coshm is desired,
c           =  2 if only coshmm is desired,
c           =  3 if both sinhm and coshmm are desired.
c
c on output--
c
c   sinhm contains the value of sinhm(x) if isw .le. 0 or
c   isw .eq. 3 (sinhm is unaltered if isw .eq.1 or isw .eq.
c   2).
c
c   coshm contains the value of coshm(x) if isw .eq. 0 or
c   isw .eq. 1 and contains the value of coshmm(x) if isw
c   .ge. 2 (coshm is unaltered if isw .eq. -1).
c
c and
c
c   x and isw are unaltered.
c
c-----------------------------------------------------------
c
      data sp14/.227581660976348e-7/,
     *     sp13/.612189863171694e-5/,
     *     sp12/.715314759211209e-3/,
     *     sp11/.398088289992973e-1/,
     *     sq12/.206382701413725e-3/,
     *     sq11/-.611470260009508e-1/,
     *     sq10/.599999999999986e+1/
      data sp25/.129094158037272e-9/,
     *     sp24/.473731823101666e-7/,
     *     sp23/.849213455598455e-5/,
     *     sp22/.833264803327242e-3/,
     *     sp21/.425024142813226e-1/,
     *     sq22/.106008515744821e-3/,
     *     sq21/-.449855169512505e-1/,
     *     sq20/.600000000268619e+1/
      data sp35/.155193945864942e-9/,
     *     sp34/.511529451668737e-7/,
     *     sp33/.884775635776784e-5/,
     *     sp32/.850447617691392e-3/,
     *     sp31/.428888148791777e-1/,
     *     sq32/.933128831061610e-4/,
     *     sq31/-.426677570538507e-1/,
     *     sq30/.600000145086489e+1/
      data sp45/.188070632058331e-9/,
     *     sp44/.545792817714192e-7/,
     *     sp43/.920119535795222e-5/,
     *     sp42/.866559391672985e-3/,
     *     sp41/.432535234960858e-1/,
     *     sq42/.824891748820670e-4/,
     *     sq41/-.404938841672262e-1/,
     *     sq40/.600005006283834e+1/
      data cp5/.552200614584744e-9/,
     *     cp4/.181666923620944e-6/,
     *     cp3/.270540125846525e-4/,
     *     cp2/.206270719503934e-2/,
     *     cp1/.744437205569040e-1/,
     *     cq2/.514609638642689e-4/,
     *     cq1/-.177792255528382e-1/,
     *     cq0/.200000000000000e+1/
      data zp4/.664418805876835e-8/,
     *     zp3/.218274535686385e-5/,
     *     zp2/.324851059327161e-3/,
     *     zp1/.244515150174258e-1/,
     *     zq2/.616165782306621e-3/,
     *     zq1/-.213163639579425e0/,
     *     zq0/.240000000000000e+2/
c
      ax = abs(x)
      if (isw .ge. 0) go to 5
c
c sinhm approximation
c
      if (ax .gt. 3.9) go to 2
      xs = ax*ax
      if (ax .gt. 2.2) go to 1
c
c sinhm approximation on (0.,2.2)
c
      sinhm = xs*((((sp14*xs+sp13)*xs+sp12)*xs+sp11)*xs+1.)/
     .             ((sq12*xs+sq11)*xs+sq10)
      return
c
c sinhm approximation on (2.2,3.9)
c
    1 sinhm = xs*(((((sp25*xs+sp24)*xs+sp23)*xs+sp22)*xs+sp21)
     .        *xs+1.)/((sq22*xs+sq21)*xs+sq20)
      return
    2 if (ax .gt. 5.1) go to 3
c
c sinhm approximation on (3.9,5.1)
c
      xs = ax*ax
      sinhm = xs*(((((sp35*xs+sp34)*xs+sp33)*xs+sp32)*xs+sp31)
     .        *xs+1.)/((sq32*xs+sq31)*xs+sq30)
      return
    3 if (ax .gt. 6.1) go to 4
c
c sinhm approximation on (5.1,6.1)
c
      xs = ax*ax
      sinhm = xs*(((((sp45*xs+sp44)*xs+sp43)*xs+sp42)*xs+sp41)
     .        *xs+1.)/((sq42*xs+sq41)*xs+sq40)
      return
c
c sinhm approximation above 6.1
c
    4 expx = exp(ax)
      sinhm = (expx-1./expx)/(ax+ax)-1.
      return
c
c coshm and (possibly) sinhm approximation
c
    5 if (isw .ge. 2) go to 7
      if (ax .gt. 2.2) go to 6
      xs = ax*ax
      coshm = xs*(((((cp5*xs+cp4)*xs+cp3)*xs+cp2)*xs+cp1)
     .        *xs+1.)/((cq2*xs+cq1)*xs+cq0)
      if (isw .eq. 0) sinhm = xs*((((sp14*xs+sp13)*xs+sp12)
     .          *xs+sp11)*xs+1.)/((sq12*xs+sq11)*xs+sq10)
      return
    6 expx = exp(ax)
      coshm = (expx+1./expx)/2.-1.
      if (isw .eq. 0) sinhm = (expx-1./expx)/(ax+ax)-1.
      return
c
c coshmm and (possibly) sinhm approximation
c
    7 xs = ax*ax
      if (ax .gt. 2.2) go to 8
      coshm = xs*((((zp4*xs+zp3)*xs+zp2)*xs+zp1)*xs+1.)/
     .             ((zq2*xs+zq1)*xs+zq0)
      if (isw .eq. 3) sinhm = xs*((((sp14*xs+sp13)*xs+sp12)
     .          *xs+sp11)*xs+1.)/((sq12*xs+sq11)*xs+sq10)
      return
    8 expx = exp(ax)
      coshm = ((expx+1./expx-xs)/2.-1.)/xs
      if (isw .eq. 3) sinhm = (expx-1./expx)/(ax+ax)-1.
      return
      end

C
C $Id: issmth.f,v 1.5 2008-07-27 00:17:16 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE ISSMTH (XSVE,YSVE,NSVE,IFSF)
C
      DIMENSION XSVE(*),YSVE(*)
C
C This routine, given the coordinates of points defining a segment of
C a contour line, smooths the line and then passes points defining the
C smoothed line on to the routine ISPLTF for drawing and/or marking of
C the screen models.  (The end points are omitted, because they are
C passed to ISPLTF separately.)
C
      COMMON /ISCOMN/ BIG,BIGD,DBPI,IDONE,IFILL,IFLIP,IONES,IHSS(1000),
     +                IREF,ISCA(16,256),ISCALE,ISCR(16,256),ISLBT,ISDR,
     +                LHSS,LX,NFPW,NINU,NINV,NINW,NX,NY,R0,RNX,RNY,
     +                SMALL,SVAL,TENSN,U,V,W,XMAX,XMIN,YMAX,YMIN,XVPL,
     +                XVPR,YVPB,YVPT
      SAVE   /ISCOMN/
C
C Define arrays needed by the smoothing routines; they must be
C dimensioned the same as XSVE and YSVE, in ISTRCL.
C
        DIMENSION TMP1(100),TMP2(100),TMP3(100),SLEN(100)
C
C Certain quantities must be saved between calls.
C
        SAVE XBFS,YBFS,SBFS,XELS,YELS,SELS
C
C Supply some default values just to keep the code from blowing up the
C first time through.
C
        DATA XBFS,YBFS,XELS,YELS / 0.,0.,0.,0. /
C
C If the line to be smoothed is a closed loop drawn using one segment
C and appropriate conditions are met, let the smoother estimate the
C slope at both ends.
C
        IF (IFSF.NE.0.AND.NSVE.GE.3.AND.
     +      ABS(XSVE(NSVE)-XSVE(1)).LT.SMALL.AND.
     +      ABS(YSVE(NSVE)-YSVE(1)).LT.SMALL) THEN
          ISLP=4
C
C If the line to be smoothed is a continuation of the last one, make the
C slope at its beginning match the slope at the end of the last one ...
C
        ELSE IF (IFSF.EQ.0.AND.
     +           ABS(XSVE(1)-XELS).LT.SMALL.AND.
     +           ABS(YSVE(1)-YELS).LT.SMALL) THEN
          ISLP=1
          SLP1=SELS
C
C ... and if, in addition, this segment closes the loop, supply it
C with a final slope matching the slope at the beginning of the first
C segment.
C
          IF (ABS(XSVE(NSVE)-XBFS).LT.SMALL.AND.
     +        ABS(YSVE(NSVE)-YBFS).LT.SMALL) THEN
            ISLP=0
            SLPN=SBFS
          END IF
C
C If none of the above, let the smoother estimate slopes.
C
        ELSE
          ISLP=3
        END IF
C
C Initialize the smoother.
C
        CALL MSKRV1 (NSVE,XSVE,YSVE,SLP1,SLPN,TMP1,TMP2,TMP3,SLEN,
     +                                                 TENSN,ISLP)
C
C Generate points on the smoothed line and deliver them to ISPLTF.
C
        NINT=MAX(3,INT(SLEN(NSVE)/DBPI)-1)
C
        DO 101 IINT=1,NINT
          CALL MSKRV2 (REAL(IINT)/REAL(NINT+1),XTMP,YTMP,NSVE,
     +                 XSVE,YSVE,TMP1,TMP2,SLEN,TENSN,0,DUMI)
          CALL ISPLTF (XTMP,YTMP,2)
  101   CONTINUE
C
C If this is the first segment, save the position at its beginning
C and the slope there.
C
        IF (IFSF.NE.0) THEN
          XBFS=XSVE(1)
          YBFS=YSVE(1)
          CALL MSKRV2 (0.,XTMP,YTMP,NSVE,XSVE,YSVE,TMP1,TMP2,SLEN,
     +                                               TENSN,1,SBFS)
        END IF
C
C In any case, save the slope at the end of the segment.
C
        XELS=XSVE(NSVE)
        YELS=YSVE(NSVE)
        CALL MSKRV2 (1.,XTMP,YTMP,NSVE,XSVE,YSVE,TMP1,TMP2,SLEN,
     +                                             TENSN,1,SELS)
C
C Done.
C
        RETURN
C
      END

C
C $Id: mdisci.f,v 1.3 2008-07-27 00:17:07 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      INTEGER FUNCTION MDISCI (IAIN)
C
        INTEGER IAIN
C
        PARAMETER (MNAI=8000)
C
C The value of MDISCI(IAIN) is a "suggested color index" for the area
C whose area identifier is IAIN.  The suggested color indices for
C adjacent areas at a given level are guaranteed to be different.
C
        COMMON /MAPCMX/  IATY(MNAI),ISCI(MNAI),IPAR(MNAI)
        INTEGER          IATY,ISCI,IPAR
        SAVE   /MAPCMX/
C
        MDISCI=0
C
        IF (IAIN.GE.1.AND.IAIN.LE.MNAI) THEN
          IF (IATY(IAIN).NE.0) THEN
            MDISCI=ISCI(IAIN)
          END IF
        END IF
C
        RETURN
C
      END

C
C	$Id: xmdef.f,v 1.5 2008-07-27 00:59:05 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE XMDEF(IOS,STATUS)
C
C  SET ALL THE CURRENT VALUES FOR PARSING AND DISPLAYING TO DEFAULT
C
C  DEFINE THE DEFAULT BUNDLE TABLE ENTRIES TO USE
C
      COMMON/CAPBND/PLBTEC, PLIBTB, PLTBTB, PLWBTB, PLCBTB,
     1              PMBTEC, PMIBTB, PMTBTB, PMSBTB, PMCBTB,
     2              TXBTEC, TXIBTB, TXFBTB, TXPBTB, TCXBTB,
     3              TCSBTB, TXCBTB, FABTEC, FAIBTB, FISBTB,
     4              FASBTB, FACBTB
      INTEGER       TBLSIZ
      PARAMETER (TBLSIZ=6)
      INTEGER PLBTEC,PLIBTB(TBLSIZ),PLTBTB(TBLSIZ),PLCBTB(TBLSIZ),
     1        PMBTEC,PMIBTB(TBLSIZ),PMTBTB(TBLSIZ),PMCBTB(TBLSIZ),
     2        TXBTEC,TXIBTB(TBLSIZ),TXFBTB(TBLSIZ),TXPBTB(TBLSIZ),
     3        TXCBTB(TBLSIZ),FACBTB(TBLSIZ),
     4        FABTEC,FAIBTB(TBLSIZ),FISBTB(TBLSIZ),FASBTB(TBLSIZ)
      REAL PLWBTB(TBLSIZ),PMSBTB(TBLSIZ),TCXBTB(TBLSIZ),TCSBTB(TBLSIZ)
      INTEGER LENBND
      PARAMETER (LENBND=4+18*TBLSIZ)
      COMMON /CAPCOL/ COLINT, COLIDX, IDXCUR, VDMINT, DMPAVL, COLFMT
     1               ,COLFIN, IDXMAX, MSTSTR, MSTSIZ, MTRSTR, DMPMDL
     2               ,MTRSIZ, DMPIDV, DMPFIN, DMPFMT
      INTEGER         MAPMAX, COLMAX, MSTMAX, MTRMAX, DMPMAX
      PARAMETER   (MAPMAX=256, COLMAX=15, MSTMAX=50, MTRMAX=20)
      PARAMETER   (DMPMAX=50)
      INTEGER         COLINT(MAPMAX*3)      , COLIDX(MAPMAX), IDXCUR,
     1                VDMINT, COLFMT(COLMAX,4)      , COLFIN(8)     ,
     2                IDXMAX, MSTSTR(MSTMAX), MSTSIZ, MTRSTR(MTRMAX),
     3                DMPMDL, MTRSIZ, DMPFIN(8)     , DMPFMT(DMPMAX,4)
      LOGICAL         DMPAVL, DMPIDV
      REAL            COLRIN(8),DMPRIN(8)
      INTEGER LENCOL
      PARAMETER   (LENCOL=MAPMAX*3+MAPMAX+1+1+1+COLMAX*4+8+1+MSTMAX+
     1                    1+MTRMAX+1+1+1+8+DMPMAX*4)
      EQUIVALENCE (COLFIN,COLRIN),(DMPFIN,DMPRIN)
      COMMON /CAPSPC/ DUMSPC,ENDDSP
      INTEGER     DUMSIZ,DUMSM1
      PARAMETER (DUMSIZ=327, DUMSM1=DUMSIZ-1)
      INTEGER     DUMSPC(DUMSM1),ENDDSP
      COMMON /CAPDEV/ DGISTR, DGISIZ, DGESTR, DGESIZ, DTISTR,
     1                DTISIZ, DCDLLX, DCDLLY, DCDURX, DCDURY,
     3                DCOAVL, CORFMT, CORFIN, BATCH , DHCSIZ,
     4                DHCSTR, CORXOF, CORYOF, DASBIT, CORXSC,
     5                CORYSC, VDWLLX, VDWLLY, VDWURX, VDWURY
      INTEGER         DGIMAX, DGEMAX, DTIMAX, DCFTMX, DHCMAX
      PARAMETER   (DGIMAX=300, DGEMAX=150, DTIMAX=100)
      PARAMETER   (DCFTMX=30 , DHCMAX=50)
      INTEGER         DGISTR(DGIMAX), DGISIZ, DGESTR(DGEMAX),
     1                DGESIZ, DTISTR(DTIMAX), DTISIZ, DCDLLX,
     2                DCDLLY, DCDURX, DCDURY, CORFMT(DCFTMX,4),
     3                CORFIN(8)     , DHCSIZ, DHCSTR(DHCMAX),
     4                CORXOF, CORYOF, DASBIT, VDWLLX, VDWLLY,
     5                VDWURX, VDWURY
      REAL            CORXSC, CORYSC, CORRIN(8)
      LOGICAL         DCOAVL, BATCH
C  Size of the COMMON
      INTEGER         LENDEV
      PARAMETER   (LENDEV=DGIMAX+1+DGEMAX+1+DTIMAX+1+4+1+4*DCFTMX+
     1                  8+2+DHCMAX+9)
      EQUIVALENCE (CORFIN,CORRIN)
      COMMON/TREROR/ ALLOK, MFRCHK, MTOPER, METRDC, REDERR, TYPCHG
     1             ,INVTYP, MINVLD, TYPERR, FRMEND, ENCINT, IVDCDT
     2             ,GCOERR, GCRERR, GCCERR, FCOERR, FCRERR, FCCERR
     3             ,PLIDXG, PMIDXG, TXIDXG, PGIDXG, INVLMT, CELERR
     4             ,COIERR, COLNRM, UNKNOW, UNKOPC, ENDMTF, VNEROR
     5             ,BADRSZ, DEVOUT, NOVERS, BADFNT, PGMERR, FASERR
     6             ,HINERR, VDWERR, RDWERR, RIXLIM
      INTEGER        ALLOK, MFRCHK, MTOPER, METRDC, REDERR, TYPCHG
     1             ,INVTYP, MINVLD, TYPERR, FRMEND, ENCINT, IVDCDT
     2             ,GCOERR, GCRERR, GCCERR, FCOERR, FCRERR, FCCERR
     3             ,PLIDXG, PMIDXG, TXIDXG, PGIDXG, INVLMT, CELERR
     4             ,COIERR, COLNRM, UNKNOW, UNKOPC, ENDMTF, VNEROR
     5             ,BADRSZ, DEVOUT, NOVERS, BADFNT, PGMERR, FASERR
     6             ,HINERR, VDWERR, RDWERR, RIXLIM
      COMMON /PGKSCOM/ CLPDAT, CLPFLG, POLIDX, LINTYP, LINWTH, LINCOL,
     1                LINRGB, MARIDX, MARSIZ, MARCOL, MARRGB, TXTIDX,
     2                INTSTL, PATIDX, FILCOL, FILRGB, MARTYP, HORIZ ,
     3                VERT  , PATH  , CHIGHT, XU    , YU    , XB    ,
     4                YB    , TXTCOL, FINDEX, CEXPN , CSPACE, CURIDX,
     5                CURIMP, CURINT, COLMOD, FILIDX, TXTRGB, PROPN ,
     6                FIRSTX, FIRSTY, LASTX , LASTY , TRATIO, CBV   ,
     7                CUV   , CHP   , CVP   , CCSPAC, CHHORZ, CDV   ,
     8                PMRSIZ, CLPX  , CLPY  , CLPP  , DEFREP, DEFLEN,
     9                VDCECR, TRANVN, TXTPRE, HATIDX, FILRPT, ASFSRF,
     A                ASFSDF, MAPMOD, VERSOK, PCBFST, CPGLEN, CLPNUL,
     B                MTDLEN
      INTEGER         CMPMAX, ASFMAX
      PARAMETER      (CMPMAX=256    , ASFMAX=18)
      LOGICAL         CLPFLG, PROPN , CHHORZ, DEFREP, CLPNUL, MAPMOD,
     1                VERSOK, PCBFST
      REAL            LINWTH, MARSIZ, CEXPN , CSPACE, TRATIO, CBV(2),
     1                CUV(2), CDV(2), CCSPAC
      INTEGER         CLPDAT(4)     , POLIDX, LINTYP, LINCOL, LINRGB(3),
     1                MARIDX, MARCOL, MARRGB(3)     , TXTIDX, INTSTL,
     2                PATIDX, FILCOL, FILRGB(3)     , MARTYP, HORIZ ,
     3                VERT  , PATH  , XU    , YU    , XB    , YB    ,
     4                TXTCOL, FINDEX, CURIMP(CMPMAX), CURINT(CMPMAX*3),
     5                CHIGHT, COLMOD, FILIDX, TXTRGB(3)     , CURIDX,
     6                FIRSTX, FIRSTY, LASTX , LASTY , CHP   , CVP   ,
     7                PMRSIZ, CLPX  , CLPY  , CLPP  , DEFLEN, TRANVN,
     8                TXTPRE, HATIDX, FILRPT(2)     , VDCECR(4)     ,
     9                ASFSRF(ASFMAX), ASFSDF(ASFMAX), CPGLEN, MTDLEN
      COMMON /GKSCHR/ MTDESC
      CHARACTER*80    MTDESC
      COMMON /TRTYPE/ METMIN, METEXT, METPRT, METHED, MIOPCL, MXOPCL,
     1                MIOPID, MXOPID, ASCDEC, ASCHEX, ASCOCT, BINARY,
     2                GAHNOR, GALEFT, GACENT, GARITE, GAVNOR, GATOP ,
     3                GACAP , GAHALF, GABASE, GABOTT, GRIGHT, GLEFT ,
     4                GUP   ,
     5                GDOWN , CINDEX, CDIRCT, PENUP , PENDN , FLAGVL,
     6                SEPRVL, ASCTEK, TYPRGB, TYPBGR,
     7                TYPHLS, TYPMON, SOLID , DASHED, INVSBL, SOLPAT,
     8                ASFIND, ASFBND, ASFLNT, ASFLNW, ASFLNC, ASFMRT,
     9                ASFMRS, ASFMRC, ASFFIS, ASFFHI, ASFFPI, ASFFCO,
     A                ASFFPT, ASFFPW, ASFFPC, ASFTFI, ASFTPR, ASFTCX,
     B                ASFTCS, ASFTCO, ASCFLT, PHOLLO, PSOLID, PPATTR,
     C                PHATCH, PEMPTY, HHORIZ, HVERTI, HPOSLP, HNESLP,
     D                HHOAVE, HPOANE
      INTEGER         METMIN, METEXT, METPRT, METHED, MIOPCL, MXOPCL,
     1                MIOPID, MXOPID, ASCDEC, ASCHEX, ASCOCT, BINARY,
     2                GAHNOR, GALEFT, GACENT, GARITE, GAVNOR, GATOP ,
     3                GACAP , GAHALF, GABASE, GABOTT, GRIGHT, GLEFT ,
     4                GUP   ,
     5                GDOWN , CINDEX, CDIRCT, PENUP , PENDN , FLAGVL,
     6                SEPRVL, ASCTEK, TYPRGB, TYPBGR,
     7                TYPHLS, TYPMON, SOLID , DASHED, INVSBL, SOLPAT,
     8                ASFIND, ASFBND, ASFLNT, ASFLNW, ASFLNC, ASFMRT,
     9                ASFMRS, ASFMRC, ASFFIS, ASFFHI, ASFFPI, ASFFCO,
     A                ASFFPT, ASFFPW, ASFFPC, ASFTFI, ASFTPR, ASFTCX,
     B                ASFTCS, ASFTCO, ASCFLT, PHOLLO, PSOLID, PPATTR,
     C                PHATCH, PEMPTY, HHORIZ, HVERTI, HPOSLP, HNESLP,
     D                HHOAVE, HPOANE
      COMMON /TRDASH/ PATFLG, DASPAT, PATBIT, DEFPAT, DASHX, DASHY,
     1                PATVDC
      INTEGER DPATSZ, PATSIZ, DFPTSZ
      PARAMETER (DPATSZ=16, PATSIZ=320, DFPTSZ=4)
      INTEGER PATFLG, DASPAT, PATBIT, DEFPAT(DFPTSZ), DASHX,
     1        DASHY, PATVDC
      COMMON /PTRDEFL/ POLIDF, LINTDF, LINWDF, TLNCDF, MARIDF, MARTDF,
     1                MARSDF, TMRCDF, PMRSDF, HORIDF, VERTDF, PATHDF,
     2                CHIGDF, XUDF, YUDF, XBDF, YBDF, TXTIDF, TTXCDF,
     3                FINDDF, CEXPDF, CSPADF, FILIDF, INTSDF, PATIDF,
     4                TFLCDF, CLPDDF, VDCEDF, CLPFDF, HATIDF, FILRDF,
     5                TXTPDF
      LOGICAL CLPFDF
      REAL LINWDF, MARSDF, CEXPDF, CSPADF
      INTEGER VDCEDF(4), CLPDDF(4), POLIDF, LINTDF, TLNCDF, MARIDF,
     1        MARTDF, TMRCDF, PMRSDF, HORIDF, VERTDF, PATHDF, CHIGDF,
     2        XUDF, YUDF, XBDF, YBDF, TXTIDF, TTXCDF, FINDDF, FILIDF,
     3        INTSDF, PATIDF, TFLCDF, HATIDF, FILRDF(2), TXTPDF
      COMMON /TRMACH/ BTSWRD
      INTEGER BTSWRD
C
      INTEGER  II, TLNCOL, TMRCOL, TTXCOL, TFLCOL
      INTEGER  IOS, STATUS
C
C  SET THE COLOR SPECIFICATION MODE TO INDEXED
C
      COLMOD = CINDEX
C
C  SET THE DEFAULT POLYLINE INFORMATION
C
      POLIDX = POLIDF
      LINTYP = LINTDF
      LINWTH = LINWDF
      TLNCOL = TLNCDF
C
C  SET THE DEFAULT LINE PATTERN
C
      CALL PATSET(LINTYP)
C
C  SET THE DEFAULT POLYMARKER INFORMATION
C
      MARIDX = MARIDF
      MARTYP = MARTDF
      MARSIZ = MARSDF
      TMRCOL = TMRCDF
      PMRSIZ = PMRSDF
C
C  SET THE DEFAULT TEXT INFORMATION
C
      HORIZ = HORIDF
      VERT = VERTDF
      PATH = PATHDF
      CHIGHT = CHIGDF
      XU = XUDF
      YU = YUDF
      XB = XBDF
      YB = YBDF
      TXTIDX = TXTIDF
      TTXCOL = TTXCDF
      TXTPRE = TXTPDF
      IF (FINDEX .NE. FINDDF) THEN
        FINDEX = FINDDF
      ENDIF
      CEXPN = CEXPDF
      CSPACE = CSPADF
C
C  SET THE DEFAULT POLYGON INFORMATION
C
      FILIDX = FILIDF
      INTSTL = INTSDF
      HATIDX = HATIDF
      PATIDX = PATIDF
      FILRPT(1) = FILRDF(1)
      FILRPT(2) = FILRPT(2)
      TFLCOL = TFLCDF
C
C  SET THE MAX COLOR TABLE SPACE AVAILABLE
C  THIS DEPENDS ON THE COLOR TABLE IN CAPDEV AND ONE IN TRSTAT AND
C  THE MAX ON THE DEVICE
C
      IF (IDXMAX .GT. CMPMAX) IDXMAX = CMPMAX
C
C  IF THERE IS COLOR TABLE CAPABILITY THEN SET THE DEFAULT COLORS
C
      IF (DMPAVL) THEN
      DO 100 II = 1, IDXMAX*3
        CURINT(II) = COLINT(II)
 100    CONTINUE
      DO 110 II = 1, IDXCUR
        CURIMP(II) = COLIDX(II)
 110    CONTINUE
      END IF
      CURIDX = IDXCUR
C
C  Set the map modified flag
C
      MAPMOD = .TRUE.
C
C  MAP USER INDICIES TO REAL MAP INDICIES
C
        MARCOL = TMRCOL
        DO 120 II = 1, IDXCUR
                IF (CURIMP(II) .EQ. TMRCOL) THEN
                        MARCOL = II - 1
                        GO TO 121
                END IF
 120    CONTINUE
 121    CONTINUE
        FILCOL = TFLCOL
        DO 130 II = 1, CURIDX
                IF (CURIMP(II) .EQ. TFLCOL) THEN
                        FILCOL = II - 1
                        GO TO 131
                END IF
 130    CONTINUE
 131    CONTINUE
        TXTCOL = TTXCOL
        DO 140 II = 1, CURIDX
                IF (CURIMP(II) .EQ. TTXCOL) THEN
                        TXTCOL = II - 1
                        GO TO 141
                END IF
 140    CONTINUE
 141    CONTINUE
        LINCOL = TLNCOL
        DO 150 II = 1, CURIDX
                IF (CURIMP(II) .EQ. TLNCOL) THEN
                        LINCOL = II - 1
                        GO TO 151
                END IF
 150    CONTINUE
 151    CONTINUE
C
C  SET THE CLIP RECTANGLE TO DEFAULT VDC EXTENT AND INDICATOR TO ON
C
      CLPFLG = CLPFDF
      CLPDAT(1) = CLPDDF(1)
      CLPDAT(2) = CLPDDF(2)
      CLPDAT(3) = CLPDDF(3)
      CLPDAT(4) = CLPDDF(4)
C
C  INTERSECT CLIP RECTANGLE WITH VIRTUAL DEVICE WINDOW
C
      IF (VDWLLX.LT.CLPDAT(3) .AND. CLPDAT(1).LT.VDWURX .AND.
     -    VDWLLY.LT.CLPDAT(4) .AND. CLPDAT(2).LT.VDWURY) THEN
        CLPDAT(1) = MAX(CLPDAT(1),VDWLLX)
        CLPDAT(2) = MAX(CLPDAT(2),VDWLLY)
        CLPDAT(3) = MIN(CLPDAT(3),VDWURX)
        CLPDAT(4) = MIN(CLPDAT(4),VDWURY)
        CLPNUL = .FALSE.
      ELSE
        CLPNUL = .TRUE.
      ENDIF
C
C  SET THE DEFAULT VDC EXTENT
C
      VDCECR(1) = VDCEDF(1)
      VDCECR(2) = VDCEDF(2)
      VDCECR(3) = VDCEDF(3)
      VDCECR(4) = VDCEDF(4)
C
C  SET THE ASPECT SOURCE FLAGS
C
      DO 160 II=1,ASFMAX
        ASFSRF(II) = ASFSDF(II)
 160  CONTINUE
C
      RETURN
      END

C
C $Id: mdseti.f,v 1.9 2008-09-18 00:42:18 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MDSETI (WHCH,IVAL)
C
        CHARACTER*(*) WHCH
        INTEGER       IVAL
C
C Declare required common blocks.  See MAPBDX for descriptions of these
C common blocks and the variables in them.
C
        COMMON /MAPCM0/  COS1,DTOR,DTRH,OOPI,PI,PIOF,PIOT,RTDD,RTOD,
     +                   SROT,SIN1,TOPI,TSRT
        DOUBLE PRECISION COS1,DTOR,DTRH,OOPI,PI,PIOF,PIOT,RTDD,RTOD,
     +                   SROT,SIN1,TOPI,TSRT
        SAVE   /MAPCM0/
C
        COMMON /MAPCM2/  BLAM,BLOM,PEPS,SLAM,SLOM,UCEN,UMAX,UMIN,UOFF,
     +                   URNG,VCEN,VMAX,VMIN,VOFF,VRNG,ISSL
        DOUBLE PRECISION BLAM,BLOM,PEPS,SLAM,SLOM,UCEN,UMAX,UMIN,UOFF,
     +                   URNG,VCEN,VMAX,VMIN,VOFF,VRNG
        INTEGER          ISSL
        SAVE   /MAPCM2/
C
        COMMON /MAPCM4/  GRDR,GRID,GRLA,GRLO,GRPO,OTOL,PDRE,PLA1,PLA2,
     +                   PLA3,PLA4,PLB1,PLB2,PLB3,PLB4,PLNO,PLTO,ROTA,
     +                   SRCH,XLOW,XROW,YBOW,YTOW,IDOT,IDSH,IDTL,ILCW,
     +                   ILTS,JPRJ,ELPF,INTF,LBLF,PRMF
        DOUBLE PRECISION GRDR,GRID,GRLA,GRLO,GRPO,OTOL,PDRE,PLA1,PLA2,
     +                   PLA3,PLA4,PLB1,PLB2,PLB3,PLB4,PLNO,PLTO,ROTA,
     +                   SRCH,XLOW,XROW,YBOW,YTOW
        INTEGER          IDOT,IDSH,IDTL,ILCW,ILTS,JPRJ
        LOGICAL          ELPF,INTF,LBLF,PRMF
        SAVE   /MAPCM4/
C
        COMMON /MAPCM7/  ULOW,UROW,VBOW,VTOW
        DOUBLE PRECISION ULOW,UROW,VBOW,VTOW
        SAVE   /MAPCM7/
C
        COMMON /MAPCMA/  DATL,DBTD,DDTS,DPLT,DPSQ,DSCA,DSSQ
        DOUBLE PRECISION DATL,DBTD,DDTS,DPLT,DPSQ,DSCA,DSSQ
        SAVE   /MAPCMA/
C
        COMMON /MAPCMC/  IGI1,IGI2,NCRA,NOVS,XCRA(100),YCRA(100)
        INTEGER          IGI1,IGI2,NCRA,NOVS
        REAL             XCRA,YCRA
        SAVE   /MAPCMC/
C
        COMMON /MAPCMQ/  ICIN(8)
        INTEGER          ICIN
        SAVE   /MAPCMQ/
C
        COMMON /MAPRGD/  ICOL(5),ICSF(5),IDPF,LCRA,NILN,NILT,OLAT,OLON
        INTEGER          ICOL,ICSF,IDPF,LCRA,NILN,NILT
        REAL             OLAT,OLON
        SAVE   /MAPRGD/
C
        COMMON /MAPSAT/  ALFA,BETA,DCSA,DCSB,DSNA,DSNB,SALT,SSMO,SRSS
        DOUBLE PRECISION ALFA,BETA,DCSA,DCSB,DSNA,DSNB,SALT,SSMO,SRSS
        SAVE   /MAPSAT/
C
        IF (ICFELL('MDSETI - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
        IF      (WHCH(1:2).EQ.'C1'.OR.WHCH(1:2).EQ.'c1') THEN
          ICIN(1)=IVAL
        ELSE IF (WHCH(1:2).EQ.'C2'.OR.WHCH(1:2).EQ.'c2') THEN
          ICIN(2)=IVAL
        ELSE IF (WHCH(1:2).EQ.'C3'.OR.WHCH(1:2).EQ.'c3') THEN
          ICIN(3)=IVAL
        ELSE IF (WHCH(1:2).EQ.'C4'.OR.WHCH(1:2).EQ.'c4') THEN
          ICIN(4)=IVAL
        ELSE IF (WHCH(1:2).EQ.'C5'.OR.WHCH(1:2).EQ.'c5') THEN
          ICIN(5)=IVAL
        ELSE IF (WHCH(1:2).EQ.'C6'.OR.WHCH(1:2).EQ.'c6') THEN
          ICIN(6)=IVAL
        ELSE IF (WHCH(1:2).EQ.'C7'.OR.WHCH(1:2).EQ.'c7') THEN
          ICIN(7)=IVAL
        ELSE IF (WHCH(1:2).EQ.'C8'.OR.WHCH(1:2).EQ.'c8') THEN
          ICIN(8)=IVAL
        ELSE IF (WHCH(1:2).EQ.'DA'.OR.WHCH(1:2).EQ.'da') THEN
          IDSH=IVAL
        ELSE IF (WHCH(1:2).EQ.'DD'.OR.WHCH(1:2).EQ.'dd') THEN
          DDTS=DBLE(IVAL)
          DBTD=DDTS/DSCA
        ELSE IF (WHCH(1:2).EQ.'DL'.OR.WHCH(1:2).EQ.'dl') THEN
          IDTL=IVAL
        ELSE IF (WHCH(1:2).EQ.'DO'.OR.WHCH(1:2).EQ.'do') THEN
          IDOT=IVAL
        ELSE IF (WHCH(1:2).EQ.'EL'.OR.WHCH(1:2).EQ.'el') THEN
          ELPF=IVAL.NE.0
        ELSE IF (WHCH(1:2).EQ.'GN'.OR.WHCH(1:2).EQ.'gn') THEN
          GRLO=DBLE(IVAL)
        ELSE IF (WHCH(1:2).EQ.'GP'.OR.WHCH(1:2).EQ.'gp') THEN
          GRPO=MAX(0.D0,MIN(90360.D0,DBLE(IVAL)))
        ELSE IF (WHCH(1:2).EQ.'GR'.OR.WHCH(1:2).EQ.'gr') THEN
          GRID=DBLE(IVAL)
        ELSE IF (WHCH(1:2).EQ.'GT'.OR.WHCH(1:2).EQ.'gt') THEN
          GRLA=DBLE(IVAL)
        ELSE IF (WHCH(1:2).EQ.'G1'.OR.WHCH(1:2).EQ.'g1') THEN
          IGI1=IVAL
        ELSE IF (WHCH(1:2).EQ.'G2'.OR.WHCH(1:2).EQ.'g2') THEN
          IGI2=IVAL
        ELSE IF (WHCH(1:2).EQ.'II'.OR.WHCH(1:2).EQ.'ii') THEN
          NILN=MAX(1,MIN(999,MOD(IVAL,1000)))
          NILT=MAX(1,MIN(999,IVAL/1000))
        ELSE IF (WHCH(1:2).EQ.'LA'.OR.WHCH(1:2).EQ.'la') THEN
          LBLF=IVAL.NE.0
        ELSE IF (WHCH(1:2).EQ.'LS'.OR.WHCH(1:2).EQ.'ls') THEN
          ILCW=IVAL
        ELSE IF (WHCH(1:2).EQ.'MV'.OR.WHCH(1:2).EQ.'mv') THEN
          DPLT=DBLE(IVAL)
          DPSQ=DPLT*DPLT
        ELSE IF (WHCH(1:2).EQ.'PE'.OR.WHCH(1:2).EQ.'pe') THEN
          PRMF=IVAL.NE.0
        ELSE IF (WHCH(1:2).EQ.'RE'.OR.WHCH(1:2).EQ.'re') THEN
          PDRE=IVAL
          INTF=.TRUE.
        ELSE IF (WHCH(1:2).EQ.'RP'.OR.WHCH(1:2).EQ.'rp') THEN
          IDPF=MAX(0,MIN(2,IVAL))
        ELSE IF (WHCH(1:2).EQ.'SA'.OR.WHCH(1:2).EQ.'sa') THEN
          SALT=DBLE(IVAL)
          IF (ABS(SALT).GT.1.D0) THEN
            SSMO=SALT*SALT-1.D0
            SRSS=SQRT(SSMO)
          END IF
          INTF=.TRUE.
        ELSE IF (WHCH(1:2).EQ.'S1'.OR.WHCH(1:2).EQ.'s1') THEN
          ALFA=ABS(DBLE(IVAL))
          DSNA=SIN(DTOR*ALFA)
          DCSA=COS(DTOR*ALFA)
          INTF=.TRUE.
        ELSE IF (WHCH(1:2).EQ.'S2'.OR.WHCH(1:2).EQ.'s2') THEN
          BETA=DBLE(IVAL)
          DSNB=SIN(DTOR*BETA)
          DCSB=COS(DTOR*BETA)
          INTF=.TRUE.
        ELSE IF (WHCH(1:2).EQ.'VS'.OR.WHCH(1:2).EQ.'vs') THEN
          NOVS=IVAL
        ELSE
          GO TO 901
        END IF
C
C Done.
C
        RETURN
C
C Error exits.
C
  901   CALL MDPCEM ('MDSETI - UNKNOWN PARAMETER NAME ',WHCH,2,1)
        RETURN
C
      END

C
C	$Id: dashbd.f,v 1.6 2008-07-27 00:16:58 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE DASHBD
C
C Calling this do-nothing subroutine forces "ld" to load the following
C block data routine (but only if they are in the same ".f" file).
C
        RETURN
C
      END
CNOSPLIT
      BLOCKDATA DASHBDX
C
C DASHBDX IS USED TO INITIALIZE VARIABLES IN NAMED COMMON.
C
      COMMON /DASHD1/  ISL,  L,  ISIZE,  IP(100),  NWDSM1,  IPFLAG(100)
     1                 ,MNCSTR, IGP
C
      COMMON /DDFLAG/ IFCFLG
C
      COMMON /DCFLAG/ IFSTFL
C
      COMMON /CFFLAG/ IVCTFG
C
      COMMON /DSAVE3/ IXSTOR,IYSTOR
C
      COMMON/INTPR/IPAU,FPART,TENSN,NP,SMALL,L1,ADDLR,ADDTB,MLLINE,
     1    ICLOSE
C
      COMMON /BLGASO/ IBLK,IGAP,ISOL
      CHARACTER*1     IBLK,IGAP,ISOL
C
      SAVE
C
C IFSTFL CONTROLS THAT FRSTD IS CALLED BEFORE VECTD IS CALLED (IN CFVLD)
C WHENEVER DASHDB OR DASHDC HAVE BEEN CALLED.
C
      DATA IFSTFL /1/
C
C IVCTFG INDICATES IF VECTD IS BEING CALLED OR LASTD (IN CFVLD)
C
      DATA IVCTFG /1/
C
C ISL IS A FLAG FOR AN ALL SOLID PATTERN (+1) OR AN ALL GAP PATTERN (-1)
C
      DATA ISL /1/
C
C IGP IS AN INTERNAL PARAMETER. IT IS DESCRIBED IN THE DOCUMENTATION
C TO THE DASHED LINE PACKAGE.
C
      DATA IGP /9/
C
C MNCSTR IS THE MAXIMUM NUMBER OF CHARACTERS ALLOWED IN A HOLLERITH
C STRING PASSED TO DASHDC.
C
      DATA MNCSTR /15/
C
C
C
C  INTERNAL PARAMETERS
C
      DATA IPAU/3/
      DATA FPART/1./
      DATA TENSN/2.5/
      DATA NP/100/
      DATA SMALL/128./
      DATA L1/70/
      DATA ADDLR/2./
      DATA ADDTB/2./
      DATA MLLINE/384/
      DATA ICLOSE/6/
C
C IFCFLG IS THE FIRST CALL FLAG FOR SUBROUTINE DASHDB OR DASHDC.
C  1 = FIRST CALL TO DASHDB OR DASHDC.
C  2 = DASHDB OR DASHDC HAS BEEN CALLED BEFORE.
C
      DATA IFCFLG /1/
C
C IXSTOR AND IYSTOR CONTAIN THE CURRENT PEN POSITION. THEY ARE
C INITIALIZED TO AN IMPOSSIBLE VALUE.
C
      DATA IXSTOR,IYSTOR /-9999,-9999/
C
C Define characters representing a blank, a gap, and a solid.
C
      DATA IBLK,IGAP,ISOL / ' ' , '''' , '$' /
C
      END

      PROGRAM CTTD02
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.  Use one
C of the following:
C
C       PARAMETER (IERF=6,LUNI=2,IWTY=1 ,IWID=1)  !  NCGM
C       PARAMETER (IERF=6,LUNI=2,IWTY=8 ,IWID=1)  !  X Windows
C       PARAMETER (IERF=6,LUNI=2,IWTY=20,IWID=1)  !  PostScript
C       PARAMETER (IERF=6,LUNI=2,IWTY=11,IWID=1)  !  PDF, Portrait
C       PARAMETER (IERF=6,LUNI=2,IWTY=12,IWID=1)  !  PDF, Landscape
C
        PARAMETER (IERF=6,LUNI=2,IWTYPE=1,IWTY=IWTYPE,IWID=1)
C
C The object of this program is to produce a set of plots illustrating
C the use of a grid wrapped around an arbitrary blob in such a way as
C not to cover it completely; portions of the "inside" of the mesh are
C visible and portions of the outside conceal other portions of the
C outside.  The triangular mesh is created from a rectangular grid by
C calling the CONPACKT routine CTTMRG, which returns a triangular mesh
C on the surface of the unit sphere, and then putting the triangular
C mesh through a couple of steps that deform it.  Dummy data are
C supplied for its vertices, and the data are contoured using a
C mapping supplied by the 3D package TDPACK.
C
C Various frames can be drawn or not drawn:
C
C   1) The triangular mesh on the globe.  This is drawn only if the
C      parameter IMSH is non-zero.
C
C   2) Simple contours on the globe.  This is drawn only if the
C      parameter ICON is non-zero.
C
C   3) Color-filled contour bands on the globe, done using an area
C      map.  This is drawn only if the parameter ICOL is non-zero.
C
C   4) Color-filled contour bands on the globe, done using a cell
C      array.  This is drawn only if the parameter ICAP is non-zero.
C
C Define parameters that say whether or not the triangular mesh is to be
C drawn on the various frames.
C
C       PARAMETER (IMSH=0)  !  frame 1 (mesh only) not drawn
C       PARAMETER (IMSH=1)  !  frame 1 (mesh only) drawn
C
        PARAMETER (IMSH=1)
C
C Define the parameter that says whether or not parts of the triangular
C mesh that were diagonals of the rectangular mesh are to be drawn.
C
C       PARAMETER (IDIA=0)  !  diagonals not drawn
C       PARAMETER (IDIA=1)  !  diagonals drawn
C
        PARAMETER (IDIA=0)
C
C Define the parameter that says whether or not simple contours are to
C be drawn:
C
C       PARAMETER (ICON=0)  !  contours not drawn
C       PARAMETER (ICON=1)  !  contours drawn
C
        PARAMETER (ICON=1)
C
C       PARAMETER (IMSN=0)  !  mesh not drawn on frame
C       PARAMETER (IMSN=1)  !  mesh drawn on frame
C
        PARAMETER (IMSN=1)
C
C Define the parameter that says whether or not color-filled contours
C (drawn using an area map) are to be drawn:
C
C       PARAMETER (ICOL=0)  !  no color fill done
C       PARAMETER (ICOL=1)  !  color fill done
C
        PARAMETER (ICOL=0)
C
C       PARAMETER (IMSL=0)  !  mesh not drawn on frame
C       PARAMETER (IMSL=1)  !  mesh drawn on frame
C
        PARAMETER (IMSL=0)
C
C Define the parameter that says whether or not color-filled contours
C (drawn using a cell array) are to be drawn:
C
C       PARAMETER (ICAP=0)  !  no color fill done
C       PARAMETER (ICAP=1)  !  color fill done
C
        PARAMETER (ICAP=1)
C
C       PARAMETER (IMSP=0)  !  mesh not drawn on frame
C       PARAMETER (IMSP=1)  !  mesh drawn on frame
C
        PARAMETER (IMSP=1)
C
C       PARAMETER (ICOP=0)  !  contours not drawn on frame
C       PARAMETER (ICOP=1)  !  contours drawn on frame
C
        PARAMETER (ICOP=1)
C
C To represent the triangular mesh, we use three singly-dimensioned
C arrays: RPNT holds points, IEDG holds edges, and ITRI holds triangles.
C The elements of each array form "nodes" having lengths as follows:
C
        PARAMETER (LOPN=5)
C
C The five elements of a point node are
C
C   1. the X coordinate of the point;
C   2. the Y coordinate of the point;
C   3. the Z coordinate of the point;
C   4. the field value at the point;
C   5. any additional value desired by the user.
C
        PARAMETER (LOEN=6)
C
C The six elements of an edge node are
C
C   1. the base index, in RPNT, of point 1 of the edge;
C   2. the base index, in RPNT, of point 2 of the edge;
C   3. the index, in ITRI, of the pointer to the edge in the triangle to
C      the left of the edge (-1 if there is no triangle to the left);
C   4. the index, in ITRI, of the pointer to the edge in the triangle to
C      the right of the edge (-1 if there is no triangle to the right);
C   5. a utility flag for use by algorithms that scan the structure.
C   6. a flag used to distinguish certain edges from others (allowing
C      one to suppress the drawing of edges that were diagonals of the
C      rectangular grid).
C
C The "left" and "right" sides of an edge are defined as they would be
C by an observer standing on the globe at point 1 of the edge, looking
C toward point 2 of the edge.  It is possible, if there are "holes" in
C the mesh, that there will be no triangle to the left or to the right
C of an edge, but there must be a triangle on one side or the other.
C
        PARAMETER (LOTN=4)
C
C The four elements of a triangle node are
C
C   1. the base index, in IEDG, of edge 1 of the triangle;
C   2. the base index, in IEDG, of edge 2 of the triangle;
C   3. the base index, in IEDG, of edge 3 of the triangle;
C   4. a flag set non-zero to block use of the triangle, effectively
C      removing it from the mesh.  Different bits of this flag are
C      used for different purposes, as discussed below just prior to
C      the call to the routine CTTDBF.
C
C The "base index" of a point node, an edge node, or a triangle node is
C always a multiple of the length of the node, to which can be added an
C offset to get the index of a particular element of the node.  For
C example, if I is the base index of a triangle of interest, ITRI(I+1)
C is its first element (the base index of its first edge).  Similarly,
C IEDG(ITRI(I+1)+2) is the base index of the second point of the first
C edge of the triangle with base index I, and RPNT(IEDG(ITRI(I+1)+2)+3)
C is the third (Z) coordinate of the second point of the first edge of
C the triangle with base index I.
C
C It is the pointers from the edge nodes back to the triangle nodes that
C allow CONPACKT to navigate the mesh, moving from triangle to triangle
C as it follows a contour line, but these pointers are tricky to define:
C if IPTE is the base index of an edge node and IEDG(IPTE+3) is zero or
C more, saying that there is a triangle to the left of the edge, then
C IEDG(IPTE+3) is the actual index of that element of the triangle node
C that points to the edge node; i.e., ITRI(IEDG(IPTE+3))=IPTE.  The base
C index of the triangle node defining that triangle is IPTT, where
C IPTT=LOTN*((IEDG(IPTE+3)-1)/LOTN), and the index of the pointer to
C the edge within the triangle node is IPTI=IEDG(IPTE+3)-IPTT, so that
C ITRI(IPTT+IPTI)=IPTE.  Similar comments apply to element 4 of an edge
C node, which points into the triangle node defining the triangle to the
C right of the edge.
C
C The maximum numbers of points, edges, and triangles in a triangular
C mesh can be computed in the following manner:  Since the triangular
C mesh is created from a rectangular one by splitting each rectangular
C cell in half, we can declare the largest values we expect to use for
C the dimensions of that mesh:
C
C       PARAMETER (IDIM=361,JDIM=181,IDM1=IDIM-1,JDM1=JDIM-1)
C       PARAMETER (IDIM=181,JDIM= 91,IDM1=IDIM-1,JDM1=JDIM-1)
C       PARAMETER (IDIM=121,JDIM= 61,IDM1=IDIM-1,JDM1=JDIM-1)
        PARAMETER (IDIM= 81,JDIM= 41,IDM1=IDIM-1,JDM1=JDIM-1)
C       PARAMETER (IDIM= 41,JDIM= 21,IDM1=IDIM-1,JDM1=JDIM-1)
C
C and then compute from those values the maximum number of points,
C edges, and triangles that the triangular mesh arrays will need to
C hold.  The computed values will be exactly as required if no points
C or edges of the rectangular grid are repeated in it; if there are
C repeating points or edges, space for slightly fewer points and edges
C will be needed:
C
        PARAMETER (MNOP=IDIM*JDIM)
        PARAMETER (MNOE=3*IDM1*JDM1+IDM1+JDM1)
        PARAMETER (MNOT=2*IDM1*JDM1)
C
C A simple lat/lon grid is a rectangular array, at each point of which
C we have latitude, longitude, and a data value.  From this rectangular
C grid, we construct a triangular mesh to test the contouring algorithm.
C XLAT and XLON are the arrays of latitudes and longitudes and ZDAT is
C the array of field values.
C
        DIMENSION XLAT(IDIM,JDIM),XLON(IDIM,JDIM),ZDAT(IDIM,JDIM)
C
C Each cell of the rectangular grid for which data is available at all
C four corners is split in half along one of its diagonals; resulting
C triangles form the triangular mesh.  As we create the triangular mesh,
C we have to keep track of where the points and edges of the rectangular
C grid were put (so as to avoid the problem of duplicating points and
C edges in the structure).  The array ISCR is used for this.
C
        DIMENSION ISCR(4,IDIM,JDIM)
C
C Once we know how many points, edges, and triangles we're going to use
C (at most), we can set parameters defining the space reserved for the
C triangular mesh:
C
        PARAMETER (MPNT=MNOP*LOPN)
        PARAMETER (MEDG=MNOE*LOEN)
        PARAMETER (MTRI=MNOT*LOTN)
C
C Declare the arrays to hold the point nodes, edge nodes, and triangle
C nodes defining the triangular mesh.
C
        DIMENSION RPNT(MPNT),IEDG(MEDG),ITRI(MTRI)
C
C Declare real and integer workspaces needed by CONPACKT.
C
        PARAMETER (LRWK=10000,LIWK=5000)
C
        DIMENSION RWRK(LRWK),IWRK(LIWK)
C
C Declare the area map array needed to do solid fill.
C
        PARAMETER (LAMA=2000000)
C
        DIMENSION IAMA(LAMA)
C
C Declare workspace arrays to be used in calls to ARSCAM.
C
        PARAMETER (NCRA=LAMA/10,NGPS=2)
C
        DIMENSION XCRA(NCRA),YCRA(NCRA),IAAI(NGPS),IAGI(NGPS)
C
C Declare arrays in which to generate a cell array picture of the
C data on the triangular mesh.
C
        PARAMETER (ICAM= 512,ICAN= 512)
C       PARAMETER (ICAM=1024,ICAN=1024)
C       PARAMETER (ICAM=2048,ICAN=2048)
C
        DIMENSION ICRA(ICAM,ICAN)
C
C Declare external the routine that draws masked contour lines.
C
        EXTERNAL DRWMCL
C
C Declare external the routine that does color fill of contour bands.
C
        EXTERNAL DCFOCB
C
C Define a common block in which to keep track of the maximum space used
C in the arrays XCRA and YCRA.
C
        COMMON /COMONA/ MAXN
C
C DEBUG: CHARACTER TEMPORARY FOR LABELLING PURPOSES.
C
C       CHARACTER*5 CTMP
C
C Set the desired minimum and maximum values of X, Y, and Z.
C
        DATA XMIN,YMIN,ZMIN,XMAX,YMAX,ZMAX / -1.,-1.,-1.,1.,1.,1. /
C
C Set the desired values of parameters determining the eye position.
C ANG1 is a bearing angle, ANG2 is an elevation angle, and RMUL is a
C multiplier of the length of the diagonal of the data box, specifying
C the distance from the center of the box to the eye.
C
        DATA ANG1,ANG2,RMUL / -175., 55.,2.9 /
C
C ISTE is a flag that says whether to do a simple image (ISTE=0),
C a one-frame stereo image (ISTE=-1), or a two-frame stereo image
C (ISTE=+1).
C
C       DATA ISTE /  0 /  !  simple image
C       DATA ISTE / -1 /  !  one-frame stereo image
C       DATA ISTE / +1 /  !  two-frame stereo image
C
        DATA ISTE / -1 /
C
C ASTE is the desired angle (in degrees) between the lines of sight for
C a pair of stereo views.
C
        DATA ASTE / 2. /
C
C WOSW is the width of the stereo windows to be used in one-frame stereo
C images; the width is stated as a fraction of the width of the plotter
C frame.  (The windows are centered vertically; horizontally, they are
C placed as far apart as possible in the plotter frame.)  The value used
C must be positive and non-zero; it may be slightly greater than .5, if
C it is desired that the stereo windows should overlap slightly.
C
        DATA WOSW / .5 /
C
C Define the tension on the splines to be used in smoothing contours.
C
C       DATA T2DS / 0.0 /  !  smoothing off
C       DATA T2DS / 2.5 /  !  smoothing on
C
        DATA T2DS / 0.0 /
C
C Define the distance between points on smoothed contour lines.
C
        DATA RSSL / .002 /
C
C Define the amount of real workspace to be used in drawing contours.
C
        DATA IRWC / 500 /
C
C Define the label-positioning flag.
C
C       DATA ILLP / 0 /  !  no labels
C       DATA ILLP / 1 /  !  dash-package writes labels
C       DATA ILLP / 2 /  !  regular scheme
C       DATA ILLP / 3 /  !  penalty scheme
C
        DATA ILLP / 2 /
C
C Define the high/low search radius.
C
        DATA HLSR / .075 /
C
C Define the high/low label overlap flag.
C
        DATA IHLO / 11 /
C
C Define the hachuring flag, hachure length, and hachure spacing.
C
C       DATA IHCF,HCHL,HCHS /  0 , +.004 , .010 /  !  off
C       DATA IHCF,HCHL,HCHS / +1 , -.004 , .020 /  !  on, all, uphill
C
        DATA IHCF,HCHL,HCHS /  0 , +.004 , .010 /
C
C Define conversion constants to convert from degrees to radians and
C vice-versa.
C
        DATA DTOR / .017453292519943 /
        DATA RTOD / 57.2957795130823 /
C
C Define a constant to be used in the code that blocks triangles too
C nearly parallel to the line of sight.
C
        DATA ATOL / 4. /
C
C Define the three radii of the initial ellipsoid; it cuts the X axis
C at + or - ARAD, the Y axis at + or - BRAD, and the Z axis at + or -
C CRAD.
C
        ARAD=1.0
        BRAD=1.4
        CRAD=1.8
C
C Create data and generate the required triangular mesh.
C
        PRINT * , ' '
        PRINT * , 'CREATING TRIANGULAR MESH:'
C
        CALL GTTD02 (RPNT,MPNT,NPNT,LOPN,
     +               IEDG,MEDG,NEDG,LOEN,
     +               ITRI,MTRI,NTRI,LOTN,
     +               IDIM,JDIM,XLAT,XLON,ZDAT,ISCR)
C
C Print the number of points, edges, and triangles.
C
        PRINT * , '  NUMBER OF POINTS:    ',NPNT/LOPN
        PRINT * , '  NUMBER OF EDGES:     ',NEDG/LOEN
        PRINT * , '  NUMBER OF TRIANGLES: ',NTRI/LOTN
C
C Set the flags in the edge nodes that will allow us to distinguish
C "diagonal" edges from others.
C
        DO 101 IPTE=0,NEDG-LOEN,LOEN
C
          XSP1=RPNT(IEDG(IPTE+1)+1)
          YSP1=RPNT(IEDG(IPTE+1)+2)
          ZSP1=RPNT(IEDG(IPTE+1)+3)
C
          RLT1=ASIN(ZSP1)
C
          IF (XSP1.NE.0..AND.YSP1.NE.0.) THEN
            RLN1=ATAN2(YSP1,XSP1)
          ELSE
            RLN1=0.
          END IF
C
          XSP2=RPNT(IEDG(IPTE+2)+1)
          YSP2=RPNT(IEDG(IPTE+2)+2)
          ZSP2=RPNT(IEDG(IPTE+2)+3)
C
          RLT2=ASIN(ZSP2)
C
          IF (XSP2.NE.0..AND.YSP2.NE.0.) THEN
            RLN2=ATAN2(YSP2,XSP2)
          ELSE
            RLN2=0.
          END IF
C
          IEDG(IPTE+6)=0
C
          IF (ABS(ZSP1).LT..9999.AND.ABS(ZSP2).LT..9999.AND.
     +        ABS(RLT1-RLT2).GT..0001.AND.
     +        ABS(RLN1-RLN2).GT..0001) IEDG(IPTE+6)=1
C
  101   CONTINUE
C
C Deform the triangular mesh to fit on the surface of the ellipsoid,
C further deform it to create a sort of distorted "dumbbell", and
C then supply dummy data values.
C
        CALL TDGDIN (-1.,1.,-1.,1.,-1.,1.,21,21)
C
        DO 102 IPTP=0,NPNT-LOPN,LOPN
          TRAD=1./SQRT(RPNT(IPTP+1)*RPNT(IPTP+1)/(ARAD*ARAD)+
     +                 RPNT(IPTP+2)*RPNT(IPTP+2)/(BRAD*BRAD)+
     +                 RPNT(IPTP+3)*RPNT(IPTP+3)/(CRAD*CRAD))
          RPNT(IPTP+1)=TRAD*RPNT(IPTP+1)
          RPNT(IPTP+2)=TRAD*RPNT(IPTP+2)
          RPNT(IPTP+3)=TRAD*RPNT(IPTP+3)
          RPNT(IPTP+1)=RPNT(IPTP+1)*(.3+.5*RPNT(IPTP+3)**2)
          RPNT(IPTP+2)=RPNT(IPTP+2)*(.3+.5*RPNT(IPTP+3)**2)
          RPNT(IPTP+3)=RPNT(IPTP+3)*(.7+.2*(RPNT(IPTP+1)**3+
     +                                      RPNT(IPTP+2)**3))
          RPNT(IPTP+4)=TDGDVA(RPNT(IPTP+1),RPNT(IPTP+2),RPNT(IPTP+3))
  102   CONTINUE
C
C Write the contents of the point list, the edge list, and the triangle
C list to "fort.11" in a readable form.
C
c       WRITE (11,'(''P'',I8,5F10.4)')
c    +        (I,RPNT(I+1),RPNT(I+2),RPNT(I+3),RPNT(I+4),RPNT(I+5),
c    +                                               I=0,NPNT-LOPN,LOPN)
c       WRITE (11,'(''E'',I8,5I10)')
c    +        (I,IEDG(I+1),IEDG(I+2),IEDG(I+3),IEDG(I+4),IEDG(I+5),
c    +                                               I=0,NEDG-LOEN,LOEN)
c       WRITE (11,'(''T'',I8,4I10)')
c    +        (I,ITRI(I+1),ITRI(I+2),ITRI(I+3),ITRI(I+4),
c    +                                               I=0,NTRI-LOTN,LOTN)
C
C Open GKS.
C
        PRINT * , 'OPENING AND INITIALIZING GKS'
C
        CALL GOPKS (IERF,0)
        CALL GOPWK (IWID,LUNI,IWTY)
        CALL GACWK (IWID)
C
C Turn off the clipping indicator.
C
        CALL GSCLIP (0)
C
C Define a basic set of colors (0 = white, background; 1 = black,
C foreground; 2 = yellow; 3 = light green; 4 = red; 5 = cyan; 6 =
C green; 7 = blue; 8 = darker light gray; 9 = lighter light gray;
C 10 = dark yellow; 11 = dark gray; 12 = medium gray; 13 = light
C red, for geographic lines; 14 = light blue, for lat/lon lines).
C
        CALL GSCR   (IWID, 0,1.,1.,1.)
        CALL GSCR   (IWID, 1,0.,0.,0.)
        CALL GSCR   (IWID, 2,1.,1.,0.)
        CALL GSCR   (IWID, 3,.5,1.,.5)
        CALL GSCR   (IWID, 4,1.,0.,0.)
        CALL GSCR   (IWID, 5,0.,1.,1.)
        CALL GSCR   (IWID, 6,0.,1.,0.)
        CALL GSCR   (IWID, 7,0.,0.,1.)
        CALL GSCR   (IWID, 8,.5,.5,.5)
        CALL GSCR   (IWID, 9,.8,.8,.8)
        CALL GSCR   (IWID,10,.3,.3,0.)
        CALL GSCR   (IWID,11,.3,.3,.3)
        CALL GSCR   (IWID,12,.5,.5,.5)
        CALL GSCR   (IWID,13,.8,.5,.5)
        CALL GSCR   (IWID,14,.5,.5,.8)
C
C Define 100 colors, associated with color indices 151 through 250, to
C be used for color-filled contour bands and in cell arrays, ranging
C from blue to red.
C
C       CALL DFCRGB (IWID,151,250,0.,0.,1.,0.,1.,0.,0.) ! blue to green
C       CALL DFCRGB (IWID,151,250,0.,1.,0.,1.,0.,0.,0.) ! green to red
C       CALL DFCRGB (IWID,151,250,0.,0.,1.,1.,0.,0.,.4) ! blue to red
C       CALL DFCRGB (IWID,151,250,0.,1.,1.,1.,0.,1.,0.) ! cyan to magenta
C       CALL DFCRGB (IWID,151,250,0.,1.,1.,1.,1.,0.,0.) ! cyan to yellow
C
        CALL DFCRGB (IWID,151,250,0.,1.,1.,1.,0.,1.,0.)
C
C       CALL DFCHLS (IWID,151,250,0.,50.,100.,120.,50.,100.)
C
C Set parameters in the utilities.
C
        PRINT * , 'SETTING PARAMETERS IN CONPACKT AND PLOTCHAR'
C
C Set the mapping flag to select the TDPACK mapping (implies use of a
C special version of CTMXYZ).
C
        CALL CTSETI ('MAP - MAPPING FLAG',2)
C
C Set the area identifier for cells associated with triangles that are
C seen from "the back".
C
        CALL CTSETI ('PAI - PARAMETER ARRAY INDEX',-1)
        CALL CTSETI ('AIA - AREA IDENTIFIER FOR AREA',1001)
C
C Set the area identifier for cells associated with no triangles of the
C mesh.
C
        CALL CTSETI ('PAI',-2)
        CALL CTSETI ('AIA - AREA IDENTIFIER FOR AREA',1002)
C
C Set the 2D smoother flag.
C
        CALL CTSETR ('T2D - TENSION ON 2D SPLINES',T2DS)
C
C Set the distance between points on smoothed lines.
C
        CALL CTSETR ('SSL - SMOOTHED SEGMENT LENGTH',RSSL)
C
C Set the amount of real workspace to be used in drawing contours.
C
        CALL CTSETI ('RWC - REAL WORKSPACE FOR CONTOURS',IRWC)
C
C Set the label-positioning flag.
C
        CALL CTSETI ('LLP - LINE LABEL POSITIONING FLAG',ILLP)
C
C Set the high/low search radius.
C
        CALL CTSETR ('HLR - HIGH/LOW SEARCH RADIUS',HLSR)
C
C Set the high/low label overlap flag.
C
        CALL CTSETI ('HLO - HIGH/LOW LABEL OVERLAP FLAG',IHLO)
C
C Set the hachuring flag, hachure length, and hachure spacing.
C
        CALL CTSETI ('HCF - HACHURING FLAG',IHCF)
        CALL CTSETR ('HCL - HACHURE LENGTH',HCHL)
        CALL CTSETR ('HCS - HACHURE SPACING',HCHS)
C
C Set the cell array flag.
C
        CALL CTSETI ('CAF - CELL ARRAY FLAG',-1)
C
C Set the point-interpolation threshold value.
C
        CALL CTSETR ('PIT - POINT INTERPOLATION THRESHOLD VALUE',.001)
C
C Tell CONPACKT not to do its own call to SET, since TDPACK will have
C done it.
C
        CALL CTSETI ('SET - DO-SET-CALL FLAG', 0)
C
C Move the informational label up a little.
C
        CALL CTSETR ('ILY - INFORMATIONAL LABEL Y POSITION',-.005)
C
C Tell CONPACKT to use a little more workspace in CTTDBF.
C
        CALL CTSETI ('IWB - INTEGER WORKSPACE FOR BLOCKING',5000)
C
C Tell PLOTCHAR to use one of the filled fonts and to outline each
C character.
C
        CALL PCSETI ('FN',25)
        CALL PCSETI ('OF',1)
C
C Tell PLOTCHAR to expect a character other than a colon as the
C function-control signal character.
C
        CALL PCSETC ('FC','|')
C
C Find the midpoint of the data box (to be used as the point looked at).
C
        XMID=.5*(XMIN+XMAX)
        YMID=.5*(YMIN+YMAX)
        ZMID=.5*(ZMIN+ZMAX)
C
C Determine the distance (R) from which the data box will be viewed and,
C given that, the eye position.
C
        R=RMUL*SQRT((XMAX-XMIN)**2+(YMAX-YMIN)**2+(ZMAX-ZMIN)**2)
C
        XEYE=XMID+R*COS(DTOR*ANG1)*COS(DTOR*ANG2)
        YEYE=YMID+R*SIN(DTOR*ANG1)*COS(DTOR*ANG2)
        ZEYE=ZMID+R*SIN(DTOR*ANG2)
C
C SET THE TRIANGLE BLOCKING FLAGS FOR THE VIEWS TO BE DRAWN.
C --- --- -------- -------- ----- --- --- ----- -- -- ------
C
        PRINT * , 'SETTING TRIANGLE BLOCKING FLAGS'
C
C Initialize the stereo offset argument to do either a single view or
C a left-eye view (whichever is selected by the value of ISTE).
C
        IF (ISTE.EQ.0) THEN
          OTEP=0.
        ELSE
          OTEP=-R*TAN(DTOR*ASTE/2.)
        END IF
C
C Initialize TDPACK.
C
  103   PRINT * , '  INITIALIZING TDPACK'
C
        CALL TDINIT (XEYE,YEYE,ZEYE,XMID,YMID,ZMID,
     +                              XMID,YMID,ZMID+R,OTEP)
C
C If stereo views are being done, do the requested thing, either by
C redoing the SET call to put them side by side on the same frame,
C or by calling FRAME to put them on separate frames.
C
          IF (OTEP.NE.0.) THEN
            IF (ISTE.LT.0) THEN
              CALL GETSET (XVPL,XVPR,YVPB,YVPT,XWDL,XWDR,YWDB,YWDT,LNLG)
              IF (OTEP.LT.0.) THEN
                CALL SET  (1.-WOSW,1.,.5-.5*WOSW,.5+.5*WOSW,
     +                             XWDL,XWDR,YWDB,YWDT,LNLG)
              ELSE
                CALL SET  (  0., WOSW,.5-.5*WOSW,.5+.5*WOSW,
     +                             XWDL,XWDR,YWDB,YWDT,LNLG)
              END IF
            END IF
          END IF
C
C Initialize CONPACKT.
C
          PRINT * , '  INITIALIZING CONPACKT'
C
          PRINT * , '  CALLING CTMESH'
          CALL CTMESH (RPNT,NPNT,LOPN,
     +                 IEDG,NEDG,LOEN,
     +                 ITRI,NTRI,LOTN,
     +                 RWRK,LRWK,
     +                 IWRK,LIWK)
C
C CTTDBF is called to set blocking flag bits for triangles according to
C various criteria.  Its next-to-last argument may take on the following
C values:
C
C   0 => just clear the blocking flags for all triangles.
C   1 => set blocking flags for triangles that are nearly edge-on to
C        the line of sight or that are seen from the "wrong" side (so
C        that they appear to be defined by points given in clockwise
C        order, rather than in counter-clockwise order).
C   2 => set blocking flags for triangles that are hidden by other
C        triangles of the mesh.
C   3 => do both 1 and 2.
C
C Its final argument is a tolerance value, in degrees, defining what
C it means for a triangle to be nearly edge-on to the line of sight.
C Using the value zero turns off the setting of nearly-edge-on bits.
C
C The bits used in the blocking flags are as follows.  Assume that the
C seven rightmost (lowest-order) bits of the blocking flags are numbered
C as follows:
C
C   . . . B6 B5 B4 B3 B2 B1 B0
C
C Bit B0 of the blocking flag for a triangle is untouched by a call to
C CTTDBF; a user may set it to block the triangle.
C
C Bits B3, B2, and B1 are used for the view from the right eye (when
C stereo views are being drawn) or the only eye (when a simple view is
C being drawn).  If B3 is set, it indicates that the triangle is hidden
C by another triangle of the mesh; if B2 is set, it indicates that the
C triangle is nearly edge-on to the line of sight; if B1 is set, it
C indicates that the triangle is seen from the wrong side.
C
C Bits B6, B5, and B4 are defined similarly, but apply to the view from
C the left eye, rather than the right eye (when stereo views are being
C done).
C
          PRINT * , '  CALLING CTTDBF'
C
          CALL CTTDBF (RPNT,IEDG,ITRI,RWRK,IWRK,3,2.)
C
C If a left-eye view has just been done, loop back for a right-eye view.
C
          IF (OTEP.LT.0.) THEN
            OTEP=-OTEP
            GO TO 103
          END IF
C
C Once bits B6, B5, B4, B3, B2, B1, and B0 are set in all the triangle
C blocking flags, one may use them to determine what is drawn in a
C particular view.  This is done by calling the routine CTTDBM, which
C has eight integer arguments.  The first four arguments are used to
C toggle bit values from the triangle's blocking flag, while the final
C four arguments are used to determine which of those bit values are
C considered to be meaningful.  For example, using the values "0, 0,
C 0, 0, 1, 1, 0, 1" says that none of the four values is to be toggled
C and that all will be allowed to block the triangle except the third;
C the net effect is to block triangles that are hidden, nearly edge-on,
C or blocked by the user, but none that are viewed from the wrong side.
C The four bits used from the blocking flag of each triangle are either
C bits B3, B2, B1, and B0, if the right (or only) eye is in use or bits
C B6, B5, B4, and B0, if the left eye is in use.
C
C Set masks for 3-D| t t t t u u u u | toggle/use
C triangle blocking| h e w u h e w u | hidden/edge-on/wrongside/user
C
C       CALL CTTDBM (0,0,0,0,1,1,0,1)
C
C In this example, there are different calls to CTTDBM, depending on what
C is about to be drawn.  Examine the specific calls to CTTDBM, below.
C
C DRAW THE TRIANGULAR MESH, IF REQUESTED.
C ---- --- ---------- ----- -- ----------
C
        IF (IMSH.NE.0) THEN
C
          PRINT * , 'DRAWING TRIANGULAR MESH'
C
C Initialize the stereo offset argument to do either a single view or
C a left-eye view (whichever is selected by the value of ISTE).
C
          IF (ISTE.EQ.0) THEN
            OTEP=0.
          ELSE
            OTEP=-R*TAN(DTOR*ASTE/2.)
          END IF
C
C Initialize TDPACK.
C
  104     PRINT * , '  INITIALIZING TDPACK'
C
          CALL TDINIT (XEYE,YEYE,ZEYE,XMID,YMID,ZMID,
     +                                XMID,YMID,ZMID+R,OTEP)
C
C If stereo views are being done, do the requested thing, either by
C redoing the SET call to put them side by side on the same frame,
C or by calling FRAME to put them on separate frames.
C
          IF (OTEP.NE.0.) THEN
            IF (ISTE.LT.0) THEN
              CALL GETSET (XVPL,XVPR,YVPB,YVPT,XWDL,XWDR,YWDB,YWDT,LNLG)
              IF (OTEP.LT.0.) THEN
                CALL SET  (1.-WOSW,1.,.5-.5*WOSW,.5+.5*WOSW,
     +                             XWDL,XWDR,YWDB,YWDT,LNLG)
              ELSE
                CALL SET  (  0., WOSW,.5-.5*WOSW,.5+.5*WOSW,
     +                             XWDL,XWDR,YWDB,YWDT,LNLG)
              END IF
            ELSE
              IF (OTEP.GT.0.) CALL FRAME
            END IF
          END IF
C
C Draw the mesh, showing only the edges of unblocked triangles.
C
          CALL PLOTIT (0,0,2)
          CALL GSPLCI (8)
C
C Set masks for 3-D  | t t t t u u u u | toggle/use
C triangle blocking  | h e w u h e w u | hidden/edge-on/wrongside/user
C
          CALL CTTDBM (0,0,0,0,1,1,0,1)
C
C Draw the mesh.
C
          CALL CTTDDM (RPNT,IEDG,ITRI,RWRK,IWRK,(1-IDIA)*6)
C
          CALL PLOTIT (0,0,2)
          CALL GSPLCI (1)
C
C If a left-eye view has just been done, loop back for a right-eye view.
C
          IF (OTEP.LT.0.) THEN
            OTEP=-OTEP
            GO TO 104
          END IF
C
C Advance the frame.
C
          CALL FRAME
C
        END IF
C
C DRAW SIMPLE CONTOURS, IF REQUESTED.
C ---- ------ --------- -- ----------
C
        IF (ICON.NE.0) THEN
C
          PRINT * , 'DRAWING SIMPLE CONTOUR PLOT'
C
C Initialize the stereo offset argument to do either a single view or
C a left-eye view (whichever is selected by the value of ISTE).
C
          IF (ISTE.EQ.0) THEN
            OTEP=0.
          ELSE
            OTEP=-R*TAN(DTOR*ASTE/2.)
          END IF
C
C Initialize TDPACK.
C
  105     PRINT * , '  INITIALIZING TDPACK'
C
          CALL TDINIT (XEYE,YEYE,ZEYE,XMID,YMID,ZMID,
     +                                XMID,YMID,ZMID+R,OTEP)
C
C If stereo views are being done, do the requested thing, either by
C redoing the SET call to put them side by side on the same frame,
C or by calling FRAME to put them on separate frames.
C
          IF (OTEP.NE.0.) THEN
            IF (ISTE.LT.0) THEN
              CALL GETSET (XVPL,XVPR,YVPB,YVPT,XWDL,XWDR,YWDB,YWDT,LNLG)
              IF (OTEP.LT.0.) THEN
                CALL SET  (1.-WOSW,1.,.5-.5*WOSW,.5+.5*WOSW,
     +                             XWDL,XWDR,YWDB,YWDT,LNLG)
              ELSE
                CALL SET  (  0., WOSW,.5-.5*WOSW,.5+.5*WOSW,
     +                             XWDL,XWDR,YWDB,YWDT,LNLG)
              END IF
            ELSE
              IF (OTEP.GT.0.) CALL FRAME
            END IF
          END IF
C
C Initialize CONPACKT.
C
          PRINT * , '  INITIALIZING CONPACKT'
C
          PRINT * , '  CALLING CTMESH'
          CALL CTMESH (RPNT,NPNT,LOPN,
     +                 IEDG,NEDG,LOEN,
     +                 ITRI,NTRI,LOTN,
     +                 RWRK,LRWK,
     +                 IWRK,LIWK)
C
          IF (IMSN.NE.0) THEN
C
            PRINT * , '  DRAWING TRIANGULAR MESH'
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (8)
C
C Set masks for 3-D    | t t t t u u u u | toggle/use
C triangle blocking    | h e w u h e w u | hidden/edge-on/wrongside/user
C
            CALL CTTDBM (0,0,0,0,1,1,0,1)
C
C Draw the mesh.
C
            CALL CTTDDM (RPNT,IEDG,ITRI,RWRK,IWRK,(1-IDIA)*6)
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (1)
C
C Debug code: number the triangles.
C
C           CALL PLOTIT (0,0,2)
C           CALL GSPLCI (4)
C
C           DO 999 IPTT=0,NTRI-LOTN,LOTN
C             WRITE (CTMP,'(I5)') IPTT/LOTN+1
C             XPOS=(RPNT(IEDG(ITRI(IPTT+1)+1)+1)+
C    +              RPNT(IEDG(ITRI(IPTT+1)+2)+1)+
C    +              RPNT(IEDG(ITRI(IPTT+2)+1)+1)+
C    +              RPNT(IEDG(ITRI(IPTT+2)+2)+1)+
C    +              RPNT(IEDG(ITRI(IPTT+3)+1)+1)+
C    +              RPNT(IEDG(ITRI(IPTT+3)+2)+1))/6.
C             YPOS=(RPNT(IEDG(ITRI(IPTT+1)+1)+2)+
C    +              RPNT(IEDG(ITRI(IPTT+1)+2)+2)+
C    +              RPNT(IEDG(ITRI(IPTT+2)+1)+2)+
C    +              RPNT(IEDG(ITRI(IPTT+2)+2)+2)+
C    +              RPNT(IEDG(ITRI(IPTT+3)+1)+2)+
C    +              RPNT(IEDG(ITRI(IPTT+3)+2)+2))/6.
C             ZPOS=(RPNT(IEDG(ITRI(IPTT+1)+1)+3)+
C    +              RPNT(IEDG(ITRI(IPTT+1)+2)+3)+
C    +              RPNT(IEDG(ITRI(IPTT+2)+1)+3)+
C    +              RPNT(IEDG(ITRI(IPTT+2)+2)+3)+
C    +              RPNT(IEDG(ITRI(IPTT+3)+1)+3)+
C    +              RPNT(IEDG(ITRI(IPTT+3)+2)+3))/6.
C             CALL TDPRPT (XPOS,YPOS,ZPOS,XLBL,YLBL)
C             DO 998 I=1,5
C               J=6-I
C               IF (CTMP(I:I).NE.' ') ILNB=I
C               IF (CTMP(J:J).NE.' ') IFNB=J
C 998         CONTINUE
C             CALL PLCHMQ (XLBL,YLBL,CTMP(IFNB:ILNB),.0004,0.,0.)
C 999       CONTINUE
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (1)
C
          END IF
C
C Set masks for 3-D  | t t t t u u u u | toggle/use
C triangle blocking  | h e w u h e w u | hidden/edge-on/wrongside/user
C
          CALL CTTDBM (0,0,0,0,1,1,1,1)
C
C Proceed as implied by the setting of the label-positioning flag.
C
          IF (ABS(ILLP).EQ.1) THEN
C
C Draw the contour lines with labels generated by the dash package.
C
            PRINT * , '  CALLING CTCLDR'
            CALL CTCLDR (RPNT,IEDG,ITRI,RWRK,IWRK)
C
C Add the informational and high/low labels.
C
            PRINT * , '  CALLING CTLBDR'
            CALL CTLBDR (RPNT,IEDG,ITRI,RWRK,IWRK)
C
          ELSE IF (ABS(ILLP).GT.1) THEN
C
C Create an area map for masking of labels.
C
            MAXN=0
C
            PRINT * , '  CALLING ARINAM'
            CALL ARINAM (IAMA,LAMA)
C
            PRINT * , '  CALLING CTLBAM'
            CALL CTLBAM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA)
C
C Draw the contour lines masked by the area map.
C
            PRINT * , '  CALLING CTCLDM'
            CALL CTCLDM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA,DRWMCL)
C
            PRINT * , '  AREA MAP SPACE REQUIRED:         ',
     +                                         IAMA(1)-IAMA(6)+IAMA(5)+1
C
            PRINT * , '  NUMBER OF POINTS IN LONGEST LINE:',MAXN
C
C Draw all the labels.
C
            PRINT * , '  CALLING CTLBDR'
            CALL CTLBDR (RPNT,IEDG,ITRI,RWRK,IWRK)
C
          END IF
C
          CALL CTGETI ('IWU - INTEGER WORKSPACE USED',IIWU)
          PRINT * , '  INTEGER WORKSPACE REQUIRED:      ',IIWU
C
          CALL CTGETI ('RWU -    REAL WORKSPACE USED',IRWU)
          PRINT * , '  REAL WORKSPACE REQUIRED:         ',IRWU
C
C If a left-eye view has just been done, loop back for a right-eye view.
C
          IF (OTEP.LT.0.) THEN
            OTEP=-OTEP
            GO TO 105
          END IF
C
C Advance the frame.
C
          CALL FRAME
C
        END IF
C
C DRAW COLOR-FILLED CONTOUR BANDS (USING AN AREA MAP), IF REQUESTED.
C ---- ------------ ------- ----- ------ -- ---- ----- -- ----------
C
        IF (ICOL.NE.0) THEN
C
          PRINT * , 'DRAWING COLOR-FILLED CONTOUR PLOT (USING AREA MAP)'
C
C Initialize the stereo offset argument to do either a single view or
C a left-eye view (whichever is selected by the value of ISTE).
C
          IF (ISTE.EQ.0) THEN
            OTEP=0.
          ELSE
            OTEP=-R*TAN(DTOR*ASTE/2.)
          END IF
C
C Initialize TDPACK.
C
  106     PRINT * , '  INITIALIZING TDPACK'
C
          CALL TDINIT (XEYE,YEYE,ZEYE,XMID,YMID,ZMID,
     +                                XMID,YMID,ZMID+R,OTEP)
C
C If stereo views are being done, do the requested thing, either by
C redoing the SET call to put them side by side on the same frame,
C or by calling FRAME to put them on separate frames.
C
          IF (OTEP.NE.0.) THEN
            IF (ISTE.LT.0) THEN
              CALL GETSET (XVPL,XVPR,YVPB,YVPT,XWDL,XWDR,YWDB,YWDT,LNLG)
              IF (OTEP.LT.0.) THEN
                CALL SET  (1.-WOSW,1.,.5-.5*WOSW,.5+.5*WOSW,
     +                             XWDL,XWDR,YWDB,YWDT,LNLG)
              ELSE
                CALL SET  (  0., WOSW,.5-.5*WOSW,.5+.5*WOSW,
     +                             XWDL,XWDR,YWDB,YWDT,LNLG)
              END IF
            ELSE
              IF (OTEP.GT.0.) CALL FRAME
            END IF
          END IF
C
C Initialize CONPACKT.
C
          PRINT * , '  INITIALIZING CONPACKT'
C
          PRINT * , '  CALLING CTMESH'
          CALL CTMESH (RPNT,NPNT,LOPN,
     +                 IEDG,NEDG,LOEN,
     +                 ITRI,NTRI,LOTN,
     +                 RWRK,LRWK,
     +                 IWRK,LIWK)
C
          MAXN=0
C
          PRINT * , '  CALLING CTPKCL'
          CALL CTPKCL (RPNT,IEDG,ITRI,RWRK,IWRK)
C
          PRINT * , '  CALLING ARINAM'
          CALL ARINAM (IAMA,LAMA)
C
          PRINT * , '  CALLING CTCLAM'
          CALL CTCLAM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA)
C
C         PRINT * , '  CALLING CTLBAM'
C         CALL CTLBAM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA)
C
          PRINT * , '  CALLING ARSCAM'
          CALL ARSCAM (IAMA,XCRA,YCRA,NCRA,IAAI,IAGI,NGPS,DCFOCB)
C
          PRINT * , '  SPACE REQUIRED IN AREA MAP:      ',
     +                                         IAMA(1)-IAMA(6)+IAMA(5)+1
C
          PRINT * , '  NUMBER OF POINTS IN LARGEST AREA:',MAXN
C
          CALL CTGETI ('IWU - INTEGER WORKSPACE USED',IIWU)
          PRINT * , '  INTEGER WORKSPACE REQUIRED:      ',IIWU
C
          CALL CTGETI ('RWU -    REAL WORKSPACE USED',IRWU)
          PRINT * , '  REAL WORKSPACE REQUIRED:         ',IRWU
C
          IF (IMSL.NE.0) THEN
C
            PRINT * , '  DRAWING TRIANGULAR MESH'
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (8)
C
C Set masks for 3-D    | t t t t u u u u | toggle/use
C triangle blocking    | h e w u h e w u | hidden/edge-on/wrongside/user
C
            CALL CTTDBM (0,0,0,0,1,1,1,1)
C
C Draw the mesh.
C
            CALL CTTDDM (RPNT,IEDG,ITRI,RWRK,IWRK,(1-IDIA)*6)
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (1)
C
          END IF
C
C If a left-eye view has just been done, loop back for a right-eye view.
C
          IF (OTEP.LT.0.) THEN
            OTEP=-OTEP
            GO TO 106
          END IF
C
C Advance the frame.
C
          CALL FRAME
C
        END IF
C
C DRAW COLOR-FILLED CONTOUR BANDS (USING A CELL ARRAY), IF REQUESTED.
C ---- ------------ ------- ----- ------ - ---- ------- -- ----------
C
        IF (ICAP.NE.0) THEN
C
          PRINT * , 'DRAWING COLOR-FILLED CONTOUR PLOT (CELL ARRAY)'
C
C Initialize the stereo offset argument to do either a single view or
C a left-eye view (whichever is selected by the value of ISTE).
C
          IF (ISTE.EQ.0) THEN
            OTEP=0.
          ELSE
            OTEP=-R*TAN(DTOR*ASTE/2.)
          END IF
C
C Initialize TDPACK.
C
  107     PRINT * , '  INITIALIZING TDPACK'
C
          CALL TDINIT (XEYE,YEYE,ZEYE,XMID,YMID,ZMID,
     +                                XMID,YMID,ZMID+R,OTEP)
C
C If stereo views are being done, do the requested thing, either by
C redoing the SET call to put them side by side on the same frame,
C or by calling FRAME to put them on separate frames.
C
          IF (OTEP.NE.0.) THEN
            IF (ISTE.LT.0) THEN
              CALL GETSET (XVPL,XVPR,YVPB,YVPT,XWDL,XWDR,YWDB,YWDT,LNLG)
              IF (OTEP.LT.0.) THEN
                CALL SET  (1.-WOSW,1.,.5-.5*WOSW,.5+.5*WOSW,
     +                             XWDL,XWDR,YWDB,YWDT,LNLG)
              ELSE
                CALL SET  (  0., WOSW,.5-.5*WOSW,.5+.5*WOSW,
     +                             XWDL,XWDR,YWDB,YWDT,LNLG)
              END IF
            ELSE
              IF (OTEP.GT.0.) CALL FRAME
            END IF
          END IF
C
C Initialize CONPACKT.
C
          PRINT * , '  INITIALIZING CONPACKT'
C
          PRINT * , '  CALLING CTMESH'
          CALL CTMESH (RPNT,NPNT,LOPN,
     +                 IEDG,NEDG,LOEN,
     +                 ITRI,NTRI,LOTN,
     +                 RWRK,LRWK,
     +                 IWRK,LIWK)
C
C Retrieve the arguments with which SET was called.
C
          CALL GETSET (XVPL,XVPR,YVPB,YVPT,XWDL,XWDR,YWDB,YWDT,LNLG)
C
          PRINT * , '  CALLING CTTDCA'
          CALL CTTDCA (RPNT,IEDG,ITRI,RWRK,IWRK,ICRA,ICAM,ICAM,ICAN,
     +                                          XVPL,YVPB,XVPR,YVPT)
C
          PRINT * , '  CALLING GCA'
          CALL GCA (XWDL,YWDB,XWDR,YWDT,ICAM,ICAN,1,1,ICAM,ICAN,ICRA)
C
          CALL CTGETI ('IWU - INTEGER WORKSPACE USED',IIWU)
          PRINT * , '  INTEGER WORKSPACE REQUIRED:      ',IIWU
C
          CALL CTGETI ('RWU -    REAL WORKSPACE USED',IRWU)
          PRINT * , '  REAL WORKSPACE REQUIRED:         ',IRWU
C
          IF (IMSP.NE.0) THEN
C
            PRINT * , '  DRAWING TRIANGULAR MESH'
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (8)
C
C Set masks for 3-D    | t t t t u u u u | toggle/use
C triangle blocking    | h e w u h e w u | hidden/edge-on/wrongside/user
C
            CALL CTTDBM (0,0,1,0,1,1,1,1)
C
C Draw the mesh.
C
            CALL CTTDDM (RPNT,IEDG,ITRI,RWRK,IWRK,(1-IDIA)*6)
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (1)
C
          END IF
C
          IF (ICOP.NE.0) THEN
C
C Set masks for 3-D    | t t t t u u u u | toggle/use
C triangle blocking    | h e w u h e w u | hidden/edge-on/wrongside/user
C
            CALL CTTDBM (0,0,0,0,1,1,1,1)
C
            IF (ABS(ILLP).EQ.1) THEN
C
              PRINT * , '  CALLING CTCLDR'
              CALL CTCLDR (RPNT,IEDG,ITRI,RWRK,IWRK)
C
              PRINT * , '  CALLING CTLBDR'
              CALL CTLBDR (RPNT,IEDG,ITRI,RWRK,IWRK)
C
            ELSE IF (ABS(ILLP).GT.1) THEN
C
              MAXN=0
C
              PRINT * , '  CALLING ARINAM'
              CALL ARINAM (IAMA,LAMA)
C
              PRINT * , '  CALLING CTLBAM'
              CALL CTLBAM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA)
C
              PRINT * , '  CALLING CTCLDM'
              CALL CTCLDM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA,DRWMCL)
C
              PRINT * , '  AREA MAP SPACE REQUIRED:         ',
     +                                         IAMA(1)-IAMA(6)+IAMA(5)+1
C
              PRINT * , '  NUMBER OF POINTS IN LONGEST LINE:',MAXN
C
              PRINT * , '  CALLING CTLBDR'
              CALL CTLBDR (RPNT,IEDG,ITRI,RWRK,IWRK)
C
            END IF
C
            CALL CTGETI ('IWU - INTEGER WORKSPACE USED',IIWU)
            PRINT * , '  INTEGER WORKSPACE REQUIRED:      ',IIWU
C
            CALL CTGETI ('RWU -    REAL WORKSPACE USED',IRWU)
            PRINT * , '  REAL WORKSPACE REQUIRED:         ',IRWU
C
          END IF
C
C If a left-eye view has just been done, loop back for a right-eye view.
C
          IF (OTEP.LT.0.) THEN
            OTEP=-OTEP
            GO TO 107
          END IF
C
C Advance the frame.
C
          CALL FRAME
C
        END IF
C
C DONE.
C -----
C
C Close GKS.
C
        CALL GDAWK (IWID)
        CALL GCLWK (IWID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END


      SUBROUTINE DFCRGB (IWID,IOFC,IOLC,BRED,BGRN,BBLU,ERED,EGRN,EBLU,
     +                                                           AMUL)
C
C This routine defines color indices IOFC through IOLC on workstation
C IWID by interpolating values from BRED/BGRN/BBLU to ERED/EGRN/EBLU.
C
C BRED, BGRN, BBLE, ERED, EGRN, and EBLU are all reals between 0 and 1.
C
C AMUL should be a real between zero and one: zero gives interpolated
C values along a straight line in the RGB color cube; larger values
C give interpolated values along a curved line that bends toward the
C black corner of the cube.  On some of the newer color laser jet
C printers, using a non-zero value of AMUL gives colors closer to what
C one sees on one's monitor; for example, if the colors range from pure
C blue to pure red, using AMUL=.6 works pretty well.
C
        DO 101 I=IOFC,IOLC
          P=REAL(IOLC-I)/REAL(IOLC-IOFC)
          Q=REAL(I-IOFC)/REAL(IOLC-IOFC)
          RRED=P*BRED+Q*ERED
          RGRN=P*BGRN+Q*EGRN
          RBLU=P*BBLU+Q*EBLU
          DMIN=SQRT(MIN((RRED-0.)**2+(RGRN-0.)**2+(RBLU-0.)**2,
     +                  (RRED-0.)**2+(RGRN-0.)**2+(RBLU-1.)**2,
     +                  (RRED-0.)**2+(RGRN-1.)**2+(RBLU-0.)**2,
     +                  (RRED-0.)**2+(RGRN-1.)**2+(RBLU-1.)**2,
     +                  (RRED-1.)**2+(RGRN-0.)**2+(RBLU-0.)**2,
     +                  (RRED-1.)**2+(RGRN-0.)**2+(RBLU-1.)**2,
     +                  (RRED-1.)**2+(RGRN-1.)**2+(RBLU-0.)**2,
     +                  (RRED-1.)**2+(RGRN-1.)**2+(RBLU-1.)**2))
          DNOM=1.-(2.*DMIN/SQRT(3.))*MAX(0.,MIN(1.,AMUL))
          RRED=RRED*DNOM
          RGRN=RGRN*DNOM
          RBLU=RBLU*DNOM
          CALL GSCR (IWID,I,RRED,RGRN,RBLU)
  101   CONTINUE
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE DFCHLS (IWID,IOFC,IOLC,BHUE,BLIT,BSAT,EHUE,ELIT,ESAT)
C
C This routine defines color indices IOFC through IOLC on workstation
C IWID by interpolating values from BHUE/BLIT/BSAT to EHUE/ELIT/ESAT.
C
C BHUE and EHUE are expressed as angles between 0 and 720.  Linear
C interpolation will be used to get intermediate values and then the
C result will be reduced modulo 360.
C
C BLIT, BSAT, ELIT, and ESAT are expressed as percentages between 0 and
C 100.
C
        DO 101 I=IOFC,IOLC
          P=REAL(IOLC-I)/REAL(IOLC-IOFC)
          Q=REAL(I-IOFC)/REAL(IOLC-IOFC)
          RHUE=MOD(P*BHUE+Q*EHUE,360.)
          RLIT=MAX(0.,MIN(100.,P*BLIT+Q*ELIT))
          RSAT=MAX(0.,MIN(100.,P*BSAT+Q*ESAT))
          CALL HLSRGB (RHUE,RLIT,RSAT,RRED,RGRN,RBLU)
          CALL GSCR   (IWID,I,RRED,RGRN,RBLU)
  101   CONTINUE
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE DRWMCL (XCRA,YCRA,NCRA,IAAI,IAGI,NGPS)
C
        DIMENSION XCRA(*),YCRA(*),IAAI(*),IAGI(*)
C
C This routine draws the curve defined by the points (XCRA(I),YCRA(I)),
C for I = 1 to NCRA, if and only if none of the area identifiers for the
C area containing the polyline are negative.  It calls either CURVE or
C CURVED to do the drawing, depending on the value of the internal
C parameter 'DPU'.
C
C It keeps track of the maximum value used for NCRA in a common block.
C
        COMMON /COMONA/ MAXN
C
        MAXN=MAX(MAXN,NCRA)
C
C Retrieve the value of the internal parameter 'DPU'.
C
        CALL CTGETI ('DPU - DASH PACKAGE USED',IDUF)
C
C Turn on drawing.
C
        IDRW=1
C
C If any area identifier is negative, turn off drawing.
C
        DO 101 I=1,NGPS
          IF (IAAI(I).LT.0) IDRW=0
  101   CONTINUE
C
C If drawing is turned on, draw the polyline.
C
        IF (IDRW.NE.0) THEN
          IF (IDUF.EQ.0) THEN
            CALL CURVE  (XCRA,YCRA,NCRA)
          ELSE IF (IDUF.LT.0) THEN
            CALL DPCURV (XCRA,YCRA,NCRA)
          ELSE
            CALL CURVED (XCRA,YCRA,NCRA)
          END IF
        END IF
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE DCFOCB (XCRA,YCRA,NCRA,IAAI,IAGI,NGPS)
C
C This routine fills the area defined by the points (XCRA(I),YCRA(I)),
C for I = 1 to NCRA, if and only if none of the area identifiers for
C the area are negative.  The color used is determined from the area
C identifier of the area relative to group 3; it is assumed that 100
C colors are defined having color indices 151 through 250.
C
        DIMENSION XCRA(*),YCRA(*),IAAI(*),IAGI(*)
C
C It keeps track of the maximum value used for NCRA in a common block.
C
        COMMON /COMONA/ MAXN
C
        MAXN=MAX(MAXN,NCRA)
C
C Retrieve the number of contour levels being used.
C
        CALL CTGETI ('NCL - NUMBER OF CONTOUR LEVELS',NOCL)
C
C If the number of contour levels is non-zero and the area has more
C than two points, fill it.
C
        IF (NOCL.NE.0.AND.NCRA.GT.2) THEN
C
          IAI3=-1
C
          DO 101 I=1,NGPS
            IF (IAGI(I).EQ.3) IAI3=IAAI(I)
  101     CONTINUE
C
          IF (IAI3.GE.1.AND.IAI3.LE.NOCL+1) THEN
            CALL GSFACI (151+INT(((REAL(IAI3)-.5)/REAL(NOCL+1))*100.))
            CALL GFA    (NCRA,XCRA,YCRA)
          ELSE IF (IAI3.EQ.1001) THEN
            CALL GSFACI (2)
            CALL GFA    (NCRA,XCRA,YCRA)
          ELSE IF (IAI3.EQ.1002) THEN
            CALL GSFACI (3)
            CALL GFA    (NCRA,XCRA,YCRA)
          END IF
C
        END IF
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE GTTD02 (RPNT,MPNT,NPNT,LOPN,
     +                   IEDG,MEDG,NEDG,LOEN,
     +                   ITRI,MTRI,NTRI,LOTN,
     +                   IDIM,JDIM,XLAT,XLON,ZDAT,ISCR)
C
        DIMENSION RPNT(MPNT),IEDG(MEDG),ITRI(MTRI)
C
C A simple lat/lon grid is a rectangular array, at each point of which
C we have latitude, longitude, and a data value.  From this rectangular
C grid, we construct a triangular mesh to test the contouring algorithm.
C Declare arrays to receive the grid data.  XLAT and XLON are arrays of
C latitudes and longitudes and ZDAT the array of field values.
C
        DIMENSION XLAT(IDIM,JDIM),XLON(IDIM,JDIM),ZDAT(IDIM,JDIM)
C
C Each cell of the rectangular grid for which data is available at all
C four corners is split in half along one of its diagonals; resulting
C triangles form the triangular mesh.  As we create the triangular mesh,
C we have to keep track of where the points and edges of the rectangular
C grid were put (so as to avoid the problem of duplicating points and
C edges in the structure).  The array ISCR is used for this.
C
        DIMENSION ISCR(4,IDIM,JDIM)
C
C Declare external a routine to tell CTTMRG about points of overlap on
C the lat/lon grid.
C
        EXTERNAL MITD02
C
C Define a constant used to convert from degrees to radians.
C
        DATA DTOR / .017453292519943 /
C
C Define latitudes, longitudes, and dummy field values on a rectangular
C mesh to be wrapped around the globe.
C
        DO 102 I=1,IDIM
          DO 101 J=1,JDIM
C           XLAT(I,J)= -90.+(REAL(J-1)/REAL(JDIM-1))*180.
            XLAT(I,J)= -80.+(REAL(J-1)/REAL(JDIM-1))*160.
C           XLON(I,J)=-180.+(REAL(I-1)/REAL(IDIM-1))*360.
            XLON(I,J)=-160.+(REAL(I-1)/REAL(IDIM-1))*320.
            ZDAT(I,J)=COS(3.*DTOR*XLAT(I,J))*COS(3.*DTOR*XLON(I,J))
  101     CONTINUE
  102   CONTINUE
C
C Call a general-purpose subroutine that accepts a rectangular grid
C mapped onto the surface of the globe and returns a triangular mesh
C equivalent to it.
C
        CALL CTTMRG (IDIM,JDIM,XLAT,XLON,ZDAT,ISCR,SVAL,MITD02,
     +               RPNT,MPNT,NPNT,LOPN,
     +               IEDG,MEDG,NEDG,LOEN,
     +               ITRI,MTRI,NTRI,LOTN)
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE MITD02 (IDIM,JDIM,IINI,JINI,IINO,JINO)
C
C Given the dimensions, IDIM and JDIM, of a simple lat/lon grid on the
C globe, and the indices, IINI and JINI, of a point on the grid, this
C routine returns the indices, IINO and JINO, of that coincident point
C on the grid which is to be used to represent it.  This version assumes
C that the first and last rows of the grid each map into a single point
C (perhaps the south pole and the north pole, respectively) and that
C the right and left edges of the grid lie on top of each other.
C
        IINO=IINI
        JINO=JINI
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE TDGDIN (XMIN,XMAX,YMIN,YMAX,ZMIN,ZMAX,MLOW,MHGH)
C
C This is a routine to generate test data for three-dimensional graphics
C routines.  The function used is a sum of exponentials.
C
C "MLOW" and "MHGH" are each forced to be greater than or equal to 1 and
C less than or equal to 25.
C
        COMMON /TDGDCO/ XRNG,YRNG,ZRNG,NCNT,CCNT(4,50)
        SAVE   /TDGDCO/
C
        XRNG=XMAX-XMIN
        YRNG=YMAX-YMIN
        ZRNG=ZMAX-ZMIN
C
        NLOW=MAX(1,MIN(25,MLOW))
        NHGH=MAX(1,MIN(25,MHGH))
        NCNT=NLOW+NHGH
C
        DO 101 ICNT=1,NCNT
          CCNT(1,ICNT)=XMIN+XRNG*FRAN()
          CCNT(2,ICNT)=YMIN+YRNG*FRAN()
          CCNT(3,ICNT)=ZMIN+ZRNG*FRAN()
          IF (ICNT.LE.NLOW) THEN
            CCNT(4,ICNT)=-1.
          ELSE
            CCNT(4,ICNT)=+1.
          END IF
  101   CONTINUE
C
        RETURN
C
      END


      FUNCTION TDGDVA (XPOS,YPOS,ZPOS)
C
        COMMON /TDGDCO/ XRNG,YRNG,ZRNG,NCNT,CCNT(4,50)
        SAVE   /TDGDCO/
C
        TDGDVA=0.
C
        DO 101 ICNT=1,NCNT
          TEMP=-50.*(((XPOS-CCNT(1,ICNT))/XRNG)**2+
     +               ((YPOS-CCNT(2,ICNT))/YRNG)**2+
     +               ((ZPOS-CCNT(3,ICNT))/YRNG)**2)
          IF (TEMP.GE.-20.) TDGDVA=TDGDVA+CCNT(4,ICNT)*EXP(TEMP)
  101   CONTINUE
C
C Done.
C
        RETURN
C
      END


      FUNCTION FRAN ()
C
C Pseudo-random-number generator.
C
        DOUBLE PRECISION X
        SAVE X
C
        DATA X / 2.718281828459045D0 /
C
        X=MOD(9821.D0*X+.211327D0,1.D0)
        FRAN=REAL(X)
C
        RETURN
C
      END


      SUBROUTINE CTSCAE (ICRA,ICA1,ICAM,ICAN,XCPF,YCPF,XCQF,YCQF,
     +                                       IND1,IND2,ICAF,IAID)
        DIMENSION ICRA(ICA1,*)
C
C This routine is called by CTCICA when the internal parameter 'CAF' is
C given a negative value.  Each call is intended to create a particular
C element in the user's cell array.  The arguments are as follows:
C
C ICRA is the user's cell array.
C
C ICA1 is the first dimension of the FORTRAN array ICRA.
C
C ICAM and ICAN are the first and second dimensions of the cell array
C stored in ICRA.
C
C (XCPF,YCPF) is the point at that corner of the rectangular area
C into which the cell array maps that corresponds to the cell (1,1).
C The coordinates are given in the fractional coordinate system (unlike
C what is required in a call to GCA, in which the coordinates of the
C point P are in the world coordinate system).
C
C (XCQF,YCQF) is the point at that corner of the rectangular area into
C which the cell array maps that corresponds to the cell (ICAM,ICAN).
C The coordinates are given in the fractional coordinate system (unlike
C what is required in a call to GCA, in which the coordinates of the
C point Q are in the world coordinate system).
C
C IND1 is the 1st index of the cell that is to be updated.
C
C IND2 is the 2nd index of the cell that is to be updated.
C
C ICAF is the current value of the internal parameter 'CAF'.  This
C value will always be an integer which is less than zero (because
C when 'CAF' is zero or greater, this routine is not called).
C
C IAID is the area identifier associated with the cell.  It will have
C been given one of the values from the internal parameter array 'AIA'
C (the one for 'PAI' = -2 if the cell lies in an out-of-range area, the
C one for 'PAI' = -1 if the cell lies off the data grid, or the one for
C some value of 'PAI' between 1 and 'NCL' if the cell lies on the data
C grid).  The value zero may occur if the cell falls in an out-of-range
C area and the value of 'AIA' for 'PAI' = -2 is 0 or if the cell lies
C off the data grid and the value of 'AIA' for 'PAI' = -1 is 0, or if
C the cell falls on the data grid, but no contour level below the cell
C has a non-zero 'AIA' and no contour level above the cell has a
C non-zero 'AIB'.  Note that, if the values of 'AIA' for 'PAI' = -1
C and -2 are given non-zero values, IAID can only be given a zero
C value in one way.
C
C The default behavior of CTSCAE is as follows:  If the area identifier
C is non-negative, it is treated as a color index, to be stored in the
C appropriate cell in the cell array; but if the area identifier is
C negative, a zero is stored for the color index.  The user may supply
C a version of CTSCAE that does something different; it may simply map
C the area identifiers into color indices or it may somehow modify the
C existing cell array element to incorporate the information provided
C by the area identifier.
C
C       ICRA(IND1,IND2)=MAX(0,IAID)
C
C What follows is not the default behavior; instead, it is the behavior
C expected by many of the example programs for CONPACKT.
C
        CALL CTGETI ('NCL - NUMBER OF CONTOUR LEVELS',NOCL)
C
        IF (IAID.GE.1.AND.IAID.LE.NOCL+1) THEN
          ICRA(IND1,IND2)=151+INT(((REAL(IAID)-.5)/REAL(NOCL+1))*100.)
        ELSE IF (IAID.EQ.1001) THEN
          ICRA(IND1,IND2)=2
        ELSE IF (IAID.EQ.1002) THEN
          ICRA(IND1,IND2)=3
        END IF
C
        RETURN
C
      END

      PROGRAM CCPFIL

      PARAMETER (MREG=50,NREG=50)
C 
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      REAL XREG(MREG),YREG(NREG),ZREG(MREG,NREG)
      
      EXTERNAL COLOR
C      
C Get data array
C
      CALL GETDAT(XREG,YREG,ZREG,MREG,NREG)
C 
C Open GKS, open and activate a workstation.
C 
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C      
C Call Conpack color fill routine
C      
      CALL TCCPFIL(ZREG,MREG,NREG,-15,COLOR,IWKID)
C      
C Close frame
C      
      CALL FRAME
C 
C Deactivate and close workstation, close GKS.
C 
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      
      STOP
      END
      
      SUBROUTINE TCCPFIL(ZREG,MREG,NREG,NCL,COLOR,IWKID)
      
      PARAMETER (LRWK=5000,LIWK=5000,LMAP=50000,NWRK=5000,NOGRPS=5)
      REAL ZREG(MREG,NREG),RWRK(LRWK), XWRK(NWRK), YWRK(NWRK)
      INTEGER MREG,NREG,IWRK(LIWK)
      INTEGER MAP(LMAP),IAREA(NOGRPS),IGRP(NOGRPS)
      
      EXTERNAL FILL
      EXTERNAL COLOR
C      
C Set up color table
C      
      CALL COLOR(IWKID)
C      
C Initialize Areas
C      
      CALL ARINAM(MAP, LMAP)
C      
C Set number of contour levels and initialize Conpack
C      
      CALL CPSETI('CLS - CONTOUR LEVEL SELECTION FLAG',NCL)
      CALL CPRECT(ZREG, MREG, MREG, NREG, RWRK, LRWK, IWRK, LIWK)
C      
C Add contours to area map
C      
      CALL CPCLAM(ZREG, RWRK, IWRK, MAP)
C      
C Set fill style to solid, and fill contours
C      
      CALL GSFAIS(1)
      CALL ARSCAM(MAP, XWRK, YWRK, NWRK, IAREA, IGRP, NOGRPS, FILL)
C      
C Draw Perimeter
C      
      CALL CPBACK(ZREG, RWRK, IWRK)
C      
C Draw Labels
C      
      CALL CPLBDR(ZREG,RWRK,IWRK)
C      
C Draw Contours
C      
      CALL CPCLDR(ZREG,RWRK,IWRK)
      
      RETURN
      END
      
      SUBROUTINE FILL (XWRK,YWRK,NWRK,IAREA,IGRP,NGRPS)
C 
      DIMENSION XWRK(*),YWRK(*),IAREA(*),IGRP(*)
      
      DO 10, I=1,NGRPS
         IF (IGRP(I).EQ.3) IAREA3=IAREA(I)
 10   CONTINUE
      
      IF (IAREA3 .GT. 0) THEN
C      
C If the area is defined by 3 or more points, fill it
C      
         CALL GSFACI(IAREA3+1)
         CALL GFA(NWRK,XWRK,YWRK)
      ENDIF
C      
C Otherwise, do nothing
C      
      RETURN
      END
      
      SUBROUTINE GETDAT(XREG,YREG,ZREG,MREG,NREG)
      
      PARAMETER (NRAN=30,LRWK=5000,LIWK=5000)
      INTEGER MREG, NREG
      REAL XRAN(NRAN), YRAN(NRAN), ZRAN(NRAN)
      REAL XREG(MREG), YREG(NREG), ZREG(MREG,NREG), RWRK(LRWK)
      REAL XDELTA(50)
      INTEGER IWRK(LIWK)
      
      DATA XRAN /12., 60., 14., 33.,  8., 12., 43., 57., 22., 15.,
     1     19., 12., 64., 19., 15., 55., 31., 32., 33., 29.,
     2     18.,  1., 18., 42., 56.,  9.,  6., 12., 44., 19./
      DATA YRAN / 1.,  2.,  3., 53.,  7., 11., 13., 17., 19., 49.,
     1     1., 31., 37.,  5.,  7., 47., 61., 17.,  5., 23.,
     2     29.,  3.,  5., 41., 43.,  9., 13., 59.,  1., 67./
      DATA ZRAN /1.0, 1.5, 1.7, 1.4, 1.9, 1.0, 1.5, 1.2, 1.8, 1.4,
     1     1.8, 1.7, 1.9, 1.5, 1.2, 1.1, 1.3, 1.7, 1.2, 1.6,
     2     1.9, 1.0, 1.6, 1.3, 1.4, 1.8, 1.7, 1.5, 1.1, 1.0/
      DATA XDELTA/.00,.02,.04,.06,.08,.10,.12,.14,.16,.18,.20,
     +            .22,.24,.26,.28,.30,.32,.34,.36,.38,.40,.42,
     +            .44,.46,.48,.50,.52,.54,.56,.58,.60,.62,.64,
     +            .66,.68,.70,.72,.74,.76,.78,.80,.82,.84,.86,
     +            .88,.90,.92,.94,.96,.98/
C 
C Set the min and max data values.
C 
      XMIN = 0.0
      XMAX = 65.0
      YMIN =  0.0
      YMAX = 68.0
C 
C Choose the X and Y coordinates for interpolation points on the 
C regular grid.
C 
      DO 101 I=1,MREG
         XREG(I)=XMIN + (XMAX - XMIN)*XDELTA(I)
 101  CONTINUE

      DO 102 I=1,NREG
         YREG(I)=YMIN + (YMAX - YMIN)*XDELTA(I)
 102  CONTINUE
C      
C Interpolate data onto a regular grid
C      
      CALL IDSFFT (1,NRAN,XRAN,YRAN,ZRAN,
     +     MREG,NREG,MREG,XREG,YREG,ZREG,IWRK,RWRK)
      
      RETURN
      END
      SUBROUTINE COLOR(IWKID)
C 
C BACKGROUND COLOR
C BLACK
C
      CALL GSCR(IWKID,0,0.,0.,0.)
C 
C FORGROUND COLORS
C White
C
      CALL GSCR(IWKID,  1, 1.0, 1.0, 1.0)
C      
C Orchid
C      
      CALL GSCR(IWKID,  2, 0.85, 0.45, 0.8)
C      
C Red
C      
      CALL GSCR(IWKID,  3, 0.9, 0.25, 0.0)
C      
C OrangeRed
C      
      CALL GSCR(IWKID,  4, 1.0, 0.0, 0.2)
C      
C Orange
C      
      CALL GSCR(IWKID,  5, 1.0, 0.65, 0.0)
C      
C Gold
C      
      CALL GSCR(IWKID,  6, 1.0, 0.85, 0.0)
C      
C Yellow
C      
      CALL GSCR(IWKID,  7, 1.0, 1.0, 0.0)
C      
C GreenYellow
C      
      CALL GSCR(IWKID,  8, 0.7, 1.0, 0.2)
C      
C Chartreuse
C      
      CALL GSCR(IWKID,  9, 0.5, 1.0, 0.0)
C      
C Celeste
C      
      CALL GSCR(IWKID, 10, 0.2, 1.0, 0.5)
C      
C Green
C      
      CALL GSCR(IWKID, 11, 0.2, 0.8, 0.2)
C      
C Aqua
C      
      CALL GSCR(IWKID, 12, 0.0, 0.9, 1.0)
C      
C DeepSkyBlue
C      
      CALL GSCR(IWKID, 13, 0.0, 0.75, 1.0)
C      
C RoyalBlue
C      
      CALL GSCR(IWKID, 14, 0.25, 0.45, 0.95)
C      
C SlateBlue
C      
      CALL GSCR(IWKID, 15, 0.4, 0.35, 0.8)
C      
C DarkViolet
C      
      CALL GSCR(IWKID, 16, 0.6, 0.0, 0.8)
C      
C Lavender
C      
      CALL GSCR(IWKID, 17, 0.8, 0.8, 1.0)
C      
C Done.
C 
      RETURN
C 
      END

C
C	$Id: gzopwk.f,v 1.15 2010-02-09 23:19:57 brownrig Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GZOPWK(WKID,CONID,WTYPE)
C
C  OPEN WORKSTATION
C
      INTEGER EOPWK
      PARAMETER (EOPWK=2)
C
      include 'gkscom.h'
C
      INTEGER WKID,CONID,WTYPE
      INTEGER LASF(13)
C
C  Check that GKS is in the proper state.
C
      CALL GZCKST(8,EOPWK,IER)
      IF (IER .NE. 0) RETURN
C
C  Check if the workstation identifier is valid.
C
      CALL GZCKWK(20,EOPWK,WKID,IDUM,IER)
      IF (IER .NE. 0) RETURN
C
C  Check that the connection identifier is valid.
C
      IF (CONID.EQ.5 .OR. CONID.EQ.6) THEN
        ERS = 1
        CALL GERHND(21,EOPWK,ERF)
        ERS = 0
        RETURN
      ENDIF
C
C  Check that the workstation type is valid.
C
      CALL GZCKWK(22,EOPWK,IDUM,WTYPE,IER)
      IF (IER .NE. 0) RETURN
C
C  Check if the workstation is currently open.
C
      CALL GZCKWK(24,EOPWK,WKID,WTYPE,IER)
      IF (IER .NE. 0) RETURN
C
C  Check if there is room for another open workstation.
C
      IF (NOPWK .GE. MOPWK) THEN
        ERS = 1
        CALL GERHND(26,EOPWK,ERF)
        ERS = 0
        RETURN
      ENDIF
C
C  Only one CGM workstation currently allowed.
C
      IF (WTYPE .EQ. GCGM) THEN
        DO 30 I=1,NOPWK
          IF (SWKTP(I) .EQ. GCGM) THEN
            ERS = 1
            CALL GERHND(-112,EOPWK,ERF)
            ERS = 0
            RETURN
          ENDIF
   30   CONTINUE
      ENDIF
C
C  Only one PDF workstation currently allowed.
C
      IF (WTYPE.EQ.GPDFP .OR. WTYPE.EQ.GPDFL) THEN
        DO 50 I=1,NOPWK
          IF (SWKTP(I).EQ.GPDFP .OR. SWKTP(I).EQ.GPDFL) THEN
            ERS = 1
            CALL GERHND(-353,EOPWK,ERF)
            ERS = 0
            RETURN
          ENDIF
   50   CONTINUE
      ENDIF
C
C  Make sure that WISS is not already open if the workstation
C  type is WISS.
C
      IF (WTYPE .EQ. GWSS) THEN
        DO 40 I=1,NOPWK
          IF (SWKTP(I) .EQ. GWSS) THEN
            ERS = 1
            CALL GERHND(28,EOPWK,ERF)
            ERS = 0
            RETURN
          ENDIF
   40   CONTINUE
      WCONID = CONID
      ENDIF
C
C  Set the operating state to WSOP if in state GKOP.
C
      IF (OPS .EQ. GGKOP) THEN
        OPS = GWSOP
      ENDIF
C
C  Pass information across the workstation interface.
C
        FCODE = -3
        CONT  = 0
        CALL GZROI(0)
        IF ((WTYPE.GE.GPSMIN .AND. WTYPE.LE.GPSMAX) .OR.
     +       WTYPE.EQ.GPDFP .OR. WTYPE.EQ.GPDFL) THEN
          IL1   = 15
          IL2   = 15
          ID(1) = WKID
          ID(2) = CONID
          ID(3) = WTYPE
C
C  Positioning coordinates for those workstations that can use them.
C
          ID(4) = CLLX
          ID(5) = CLLY
          ID(6) = CURX
          ID(7) = CURY
C
C  Scale factor for PostScript and PDF workstations.
C
          ID(8) = CPSCL
C
C  Color model for PostScript and PDF workstations.
C
          ID(9) = CCMDL
C
C  Flag for suppressing background color for PS and PDF.
C
          ID(10) = CSUPR
C
C  Flag for portrait/landscape mode (0 or non-zero)
C
          ID(11) = CPTLD
C
C  Specification for page width in PDF files.
C
          ID(12) = PDFWTH
C
C  Specification for page height in PDF files.
C
          ID(13) = PDFHGT
C
C  Specification for page width in PS files.
C
          ID(14) = PSWTH
C
C  Specification for page height in PDF files.
C
          ID(15) = PSHGT

        ELSE IF (WTYPE.GE.GCROMIN .AND. WTYPE.LE.GCROMAX) THEN
          IL1   = 9
          IL2   = 9
          ID(1) = WKID
          ID(2) = CONID
          ID(3) = WTYPE
C
C  Positioning coordinates for those workstations that can use them.
C
          ID(4) = CLLX
          ID(5) = CLLY
          ID(6) = CURX
          ID(7) = CURY
C
C  Specification for page size in document-oriented files.
C
          ID(8) = PDFWTH
          ID(9) = PDFHGT
	ELSE IF (WTYPE.EQ.GXWE .OR. WTYPE.EQ.GXWC .OR.
     +           WTYPE.EQ.GPIX) THEN
	  IL1   = 4
	  IL2   = 4
          ID(1) = WKID
          ID(2) = CONID
          ID(3) = WTYPE
C
C  Color model for X workstations.
C
	  ID(4) = COLMOD
        ELSE
          IL1   = 3
          IL2   = 3
          ID(1) = WKID
          ID(2) = CONID
          ID(3) = WTYPE
        ENDIF
C
        CALL GZTOWK
        IF (RERR.NE.0) THEN
          ERS = 1
          CALL GERHND(RERR,EOPWK,ERF)
          ERS = 0
          RETURN
        ENDIF
C
C  Add the workstation identifier to the set of open workstations.
C
      NOPWK = NOPWK+1
      SOPWK(NOPWK) = WKID
      SWKTP(NOPWK) = WTYPE
C
C  Set the file name for an MO workstation back to default; set the
C  positioning coordinates back to defaults; set the PostScript
C  coordinate scale factor back to the default; set the X color model
C  back to default.
C
        GFNAME = 'DEFAULT'
        CLLX = -9999
        CLLY = -9999
        CURX = -9999
        CURY = -9999
        CPSCL = -1
        COLMOD = -1
C
C  For an X window that does not currently exist, obtain the local
C  window ID for all future calls; for an X window that already exists
C  the connection ID is the window ID.  In the case of an X window
C  that does not exist, the window ID is returned from the interface
C  call in IL2 (non-standard usage of this parameter).  All the
C  other drivers will return a -1 in IL2.
C
        IF (WTYPE.EQ.GXWC  .OR. WTYPE.EQ.GDMP  .OR.
     +      WTYPE.EQ.GXWE  .OR. WTYPE.EQ.GPIX  .OR.
     +     (WTYPE.GE.GPSMIN .AND. WTYPE.LE.GPSMAX) .OR.
     +      WTYPE.EQ.GPDFP .OR. WTYPE.EQ.GPDFL .OR.
     +     (WTYPE.GE.GCROMIN .AND. WTYPE.LE.GCROMAX) ) THEN
          LXWKID(NOPWK) = IL2
        ENDIF
C
C  Establish the current attribute settings (temporerily turn off
C  processing of error -109 [non-implementation of certain functions
C  on output only workstations] by setting CUFLAG non-zero).
C
        CUFLAG = WKID
        CALL GSCLIP (CCLIP)
C       CALL GSPLI  (CPLI )
        CALL GSLN   (CLN  )
        CALL GSLWSC (CLWSC)
        CALL GSPLCI (CPLCI)
C       CALL GSPMI  (CPMI )
        CALL GSMK   (CMK  )
        CALL GSMKSC (CMKS )
        CALL GSPMCI (CPMCI)
C       CALL GSTXI  (CTXI )
        CALL GSTXFP (CTXFP(1),CTXFP(2))
        CALL GSCHXP (CCHXP)
        CALL GSCHSP (CCHSP)
        CALL GSTXCI (CTXCI)
        CALL GSCHH  (CCHH )
        CALL GSCHUP (CCHUP(1),CCHUP(2))
        CALL GSTXP  (CTXP )
        CALL GSTXAL (CTXAL(1),CTXAL(2))
C       CALL GSFAI  (CFAI )
        CALL GSFAIS (CFAIS)
        CALL GSFASI (CFASI)
        CALL GSFACI (CFACI)
C       CALL GSPA   (CPA  (1),CPA  (2))
C       CALL GSPARF (CPARF(1),CPARF(2))
        LASF( 1) = CLNA
        LASF( 2) = CLWSCA
        LASF( 3) = CPLCIA
        LASF( 4) = CMKA
        LASF( 5) = CMKSA
        LASF( 6) = CPMCIA
        LASF( 7) = CTXFPA
        LASF( 8) = CCHXPA
        LASF( 9) = CCHSPA
        LASF(10) = CTXCIA
        LASF(11) = CFAISA
        LASF(12) = CFASIA
        LASF(13) = CFACIA
        CALL GSASF (LASF)
        CUFLAG = -1
C
      RETURN
      END

C
C      $Id: cn17f.f,v 1.5 2010-03-15 22:49:23 haley Exp $
C
C***********************************************************************
C                                                                      *
C                            Copyright (C)  1997                       *
C                 University Corporation for Atmospheric Research      *
C                            All Rights Reserved                       *
C                                                                      *
C***********************************************************************
C
C  File:       cn17f.f
C
C  Author:     Mary Haley
C              (original LLU example by Dave Kennison)
C              National Center for Atmospheric Research
C              PO Box 3000, Boulder, Colorado
C
C  Date:       Wed Apr 23 11:09:03 MST 1997
C
C  Description:  This example is somewhat similar to the LLU example
C                "cpex10", which draws contours bands within a circle
C                on a satellite map projection. It also shows how to
C                use the NhlDataPolyline and NhlDataPolymarker routines
C                to draw lines and markers on a map projection.
C                
C                This example uses the AnnoManager class to label each
C                of the United States with a two-letter mnemonic. The
C                labeling is not done in the map projection, however,
C                so the text is not part of the map.  To show how you
C                *can* get your text to be part of the map, this example
C                has a second frame which mixes the LLUs and the HLUs
C                to achieve this affect (since this *is* doable in the
C                LLUs).
C
      external nhlfappclass
      external nhlfxworkstationclass
      external nhlfncgmworkstationclass
      external nhlfpsworkstationclass
      external nhlfpdfworkstationclass
      external nhlfcairopspdfworkstationclass
      external nhlfcairoimageworkstationclass
      external nhlfcairowindowworkstationclass
      external nhlfscalarfieldclass
      external nhlftextitemclass
      external nhlfcontourplotclass
      external nhlfmapplotclass
      external nhlfannomanagerclass

      parameter(NCLS=100,NCOLORS=23,NDIM=50,NCIRC=100)
C
C Declare the common block in which the angle at which the label of a
C point on the globe is to be written and the latitude and longitude
C of the point being labelled are transmitted to the routine PCMPXY,
C in the package PLOTCHAR (this is for the LLU version of this plot).
C
      common /pcmp04/ pang,plat,plon
      save   /pcmp04/
C
C Define variables for HLU objects and other stuff.
C
      real x, y, zdat(NCLS, NCLS), xlat, xlon
      real xlonrng, xlatrng, xlonstp, xlatstp, dist
      real miss_val
      data miss_val/1.e12/
      integer count(2)
      integer appid, workid, dataid, cnid, mpid, gsid, gkswid
      integer srlist, grlist, i, j, ierr
      real dfce, rtod
      data dfce/1.3/
      data rtod / 57.2957795130823 /
C
C cminlon, cmaxlon, cminlat, and cmaxlat are the four corners where we
C want the contour plot to lie. ctrlat and ctrlon is the center of
C the circular contour plot (and also where we want to put a marker at
C the location of Boulder, CO). clat and clon will hold the lat/lon 
C coordinates for the circle we want to contain the contour plot in.
C
      real cminlon, cmaxlon, cminlat, cmaxlat, ctrlat, ctrlon
      data cminlon,cmaxlon,cminlat,cmaxlat/-115.,-95.,32.,48./
      data ctrlat/40./
      data ctrlon/-105./
      real clat(NCIRC),clon(NCIRC)
C
C Define arrays to hold a list of two-character mnemonics
C for the states, and the latitude and longitude of a point where the
C mnemonic may be placed to label the state.
C
      integer num_am_ids
      data num_am_ids/NDIM/
      integer am_ids(NDIM), text_ids(NDIM)
      data am_ids/50*-1/

      character*2 smne(NDIM)

      real slat(NDIM),slon(NDIM)
C
C Define the state-labelling data.
C
      data smne( 1),slat( 1), slon( 1)
     +                       / 'AL' , 33.0 ,  -86.5 /
      data smne( 2),slat( 2), slon( 2)
     +                       / 'AK' , 65.0 , -152.0 /
        data smne( 3),slat( 3), slon( 3)
     +                       / 'AZ' , 34.7 , -111.5 /
        data smne( 4),slat( 4), slon( 4)
     +                       / 'AR' , 35.0 ,  -92.5 /
        data smne( 5),slat( 5), slon( 5)
     +                       / 'CA' , 37.5 , -120.5 /
        data smne( 6),slat( 6), slon( 6)
     +                       / 'CO' , 39.0 , -105.8 /
        data smne( 7),slat( 7), slon( 7)
     +                       / 'CT' , 41.6 ,  -72.6 /
        data smne( 8),slat( 8), slon( 8)
     +                       / 'DE' , 39.0 ,  -75.5 /
        data smne( 9),slat( 9), slon( 9)
     +                       / 'FL' , 28.5 ,  -82.0 /
        data smne(10),slat(10), slon(10)
     +                       / 'GA' , 32.5 ,  -83.0 /
        data smne(11),slat(11), slon(11)
     +                       / 'HI' , 20.0 , -157.0 /
        data smne(12),slat(12), slon(12)
     +                       / 'ID' , 43.5 , -114.0 /
        data smne(13),slat(13), slon(13)
     +                       / 'IL' , 40.2 ,  -89.2 /
        data smne(14),slat(14), slon(14)
     +                       / 'IN' , 40.0 ,  -86.0 /
        data smne(15),slat(15), slon(15)
     +                       / 'IA' , 42.0 ,  -93.2 /
        data smne(16),slat(16), slon(16)
     +                       / 'KS' , 38.5 ,  -98.2 /
        data smne(17),slat(17), slon(17)
     +                       / 'KY' , 37.4 ,  -84.5 /
        data smne(18),slat(18), slon(18)
     +                       / 'LA' , 31.2 ,  -92.5 /
        data smne(19),slat(19), slon(19)
     +                       / 'ME' , 45.5 ,  -69.0 /
        data smne(20),slat(20), slon(20)
     +                       / 'MD' , 39.2 ,  -76.5 /
        data smne(21),slat(21), slon(21)
     +                       / 'MA' , 42.3 ,  -72.0 /
        data smne(22),slat(22), slon(22)
     +                       / 'MI' , 44.0 ,  -85.0 /
        data smne(23),slat(23), slon(23)
     +                       / 'MN' , 46.0 ,  -94.5 /
        data smne(24),slat(24), slon(24)
     +                       / 'MS' , 32.5 ,  -89.5 /
        data smne(25),slat(25), slon(25)
     +                       / 'MO' , 38.5 ,  -92.5 /
        data smne(26),slat(26), slon(26)
     +                       / 'MT' , 47.0 , -109.5 /
        data smne(27),slat(27), slon(27)
     +                       / 'NE' , 41.5 ,  -99.5 /
        data smne(28),slat(28), slon(28)
     +                       / 'NV' , 39.8 , -117.0 /
        data smne(29),slat(29), slon(29)
     +                       / 'NH' , 43.2 ,  -71.6 /
        data smne(30),slat(30), slon(30)
     +                       / 'NJ' , 39.7 ,  -74.5 /
        data smne(31),slat(31), slon(31)
     +                       / 'NM' , 34.7 , -106.0 /
        data smne(32),slat(32), slon(32)
     +                       / 'NY' , 43.0 ,  -75.0 /
        data smne(33),slat(33), slon(33)
     +                       / 'NC' , 35.5 ,  -79.5 /
        data smne(34),slat(34), slon(34)
     +                       / 'ND' , 47.5 , -100.5 /
        data smne(35),slat(35), slon(35)
     +                       / 'OH' , 40.2 ,  -82.5 /
        data smne(36),slat(36), slon(36)
     +                       / 'OK' , 35.6 ,  -97.5 /
        data smne(37),slat(37), slon(37)
     +                       / 'OR' , 44.0 , -120.2 /
        data smne(38),slat(38), slon(38)
     +                       / 'PA' , 40.8 ,  -77.6 /
        data smne(39),slat(39), slon(39)
     +                       / 'RI' , 41.7 ,  -71.5 /
        data smne(40),slat(40), slon(40)
     +                       / 'SC' , 34.0 ,  -80.5 /
        data smne(41),slat(41), slon(41)
     +                       / 'SD' , 44.5 , -100.5 /
        data smne(42),slat(42), slon(42)
     +                       / 'TN' , 36.0 ,  -86.5 /
        data smne(43),slat(43), slon(43)
     +                       / 'TX' , 32.0 , -100.0 /
        data smne(44),slat(44), slon(44)
     +                       / 'UT' , 39.5 , -111.5 /
        data smne(45),slat(45), slon(45)
     +                       / 'VT' , 44.2 ,  -72.5 /
        data smne(46),slat(46), slon(46)
     +                       / 'VA' , 37.6 ,  -78.6 /
        data smne(47),slat(47), slon(47)
     +                       / 'WA' , 47.5 , -120.5 /
        data smne(48),slat(48), slon(48)
     +                       / 'WV' , 38.5 ,  -80.8 /
        data smne(49),slat(49), slon(49)
     +                       / 'WI' , 44.5 ,  -89.5 /
        data smne(50),slat(50), slon(50)
     +                       / 'WY' , 43.0 , -107.5 /
c
c Declare variables for defining color map.
c
      integer length(2)
      real   cmap(3,NCOLORS)
      character*7  wks_type
c
c Default is to display to an x11 window.
c
      wks_type = "x11"
C     
C Initialize the HLU library and set up resource template.
C
      call NhlFInitialize
      call NhlFRLCreate(srlist,'SETRL')
      call NhlFRLCreate(grlist,'GETRL')
C
C Create an application object.
C
      call NhlFRLClear(srlist)
      call NhlFRLSetstring(srlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'cn17',NhlFAppClass,0,srlist,ierr)
C
C Modify the color map. Colors for contour fill areas varying from
C blue to red.
C
      cmap(1,1) = 0.00
      cmap(2,1) = 0.00
      cmap(3,1) = 0.00
      cmap(1,2) = 1.00
      cmap(2,2) = 1.00
      cmap(3,2) = 1.00
      cmap(1,3) = .6 
      cmap(2,3) = .6 
      cmap(3,3) = .6 
      cmap(1,4) = 0. 
      cmap(2,4) = 0. 
      cmap(3,4) = 0. 
      cmap(1,5) = 1.
      cmap(2,5) = 1.
      cmap(3,5) = 1.
      cmap(1,6) = .4
      cmap(2,6) = .4
      cmap(3,6) = .4
      cmap(1,7) = 1.
      cmap(2,7) = 1.
      cmap(3,7) = 0.
      do i=8,NCOLORS
         cmap(1,i) = real(NCOLORS-i)/15.
         cmap(2,i) = 0.
         cmap(3,i) = real(i-8)/15.
      end do
      length(1) = 3
      length(2) = NCOLORS

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetstring(srlist,'wkMetaName','./cn17f.ncgm',ierr)
         call NhlFRLSetMDFloatArray(srlist,'wkColorMap',cmap,2,length,
     +        ierr)
         call NhlFCreate(workid,'cn17Work',NhlFNcgmWorkstationClass,
     +        0,srlist,ierr) 
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetstring(srlist,'wkPause','True',ierr)
         call NhlFRLSetMDFloatArray(srlist,'wkColorMap',cmap,2,length,
     +        ierr)
         call NhlFCreate(workid,'cn17Work',
     +        NhlFCairoWindowWorkstationClass,
     +        0,srlist,ierr) 
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PostScript workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetstring(srlist,'wkPSFileName','./cn17f.ps',ierr)
         call NhlFRLSetMDFloatArray(srlist,'wkColorMap',cmap,2,length,
     +        ierr)
         call NhlFCreate(workid,'cn17Work',NhlFPSWorkstationClass,
     +        0,srlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetstring(srlist,'wkPDFFileName','./cn17f.pdf',ierr)
         call NhlFRLSetMDFloatArray(srlist,'wkColorMap',cmap,2,length,
     +        ierr)
         call NhlFCreate(workid,'cn17Work',NhlFPDFWorkstationClass,
     +        0,srlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF object.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetstring(srlist,'wkFileName','./cn17f',ierr)
         call NhlFRLSetstring(srlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetMDFloatArray(srlist,'wkColorMap',cmap,2,length,
     +        ierr)
         call NhlFCreate(workid,'cn17Work',
     +        NhlFcairoPSPDFWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG object.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetstring(srlist,'wkFileName','./cn17f',ierr)
         call NhlFRLSetstring(srlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetMDFloatArray(srlist,'wkColorMap',cmap,2,length,
     +        ierr)
         call NhlFCreate(workid,'cn17Work',
     +        NhlFcairoImageWorkstationClass,0,srlist,ierr)
      endif
C
C Create a "great" circle in lat/lon coordinates. We don't want to draw
C any contour lines outside of this circle.
C
      xlonrng = cmaxlon - cminlon
      xlatrng = cmaxlat - cminlat
      do i=1,NCIRC
         clon(i) = ctrlon + 7.*cos(((i-1)*6.28)/real(NCIRC-1))
         clat(i) = ctrlat + 7.*sin(((i-1)*6.28)/real(NCIRC-1))
      end do
C
C Generate some dummy data to contour later.
C
      xlonstp = xlonrng/(NCLS-1)
      xlatstp = xlatrng/(NCLS-1)
      do i=1,NCLS
         xlon = cminlon + (i-1) * xlonstp
         x=real(i-1)/real(NCLS-1)
         do j=1,NCLS
            xlat = cminlat + (j-1) * xlatstp
            dist = sqrt((ctrlat - xlat)**2 + (ctrlon - xlon)**2)
C
C If xlat/xlon falls outside of circle, then we don't
C want to contour this location.
C
            if(dist.le.7.0) then
               y=real(j-1)/real(NCLS-1)
               zdat(i,j) = x**2 + y**2 + x*y + sin(9.*x)*cos(9.*y)
            else
               zdat(i,j)=miss_val
            end if
         end do
      end do
C
C AnnoManager objects allow the PlotManager to manipulate any View
C class object as an annotation a uniform fashion. They allow
C the user to set the View object's size and location relative to
C the viewport of a Plot. They may be located relative to one
C of the viewport sides, or, as in this example, aligned with the 
C plot's data space (amTrackData is set True in the resource file).
C
C Create a TextItem for each place name to be included on the map.
C Collect the object ids into an array.
C
      do i = 1,NDIM
         call NhlFRLClear(srlist)
         call NhlFRLSetstring(srlist,'txString',smne(i),ierr)
         call NhlFCreate(text_ids(i),smne(i),NhlFtextitemClass,workid,
     +        srlist,ierr)
      end do
C
C Create a MapPlot object.
C
      call NhlFRLClear(srlist)
      call NhlFRLSetFloat(srlist,'mpSatelliteAngle1F',
     +     7.*rtod*asin(1./dfce)/8.,ierr)
      call NhlFRLSetIntegerArray(srlist,'pmAnnoViews',text_ids,NDIM,
     +     ierr)
      call NhlFCreate(mpid,'MapPlot',nhlfmapplotclass,workid,srlist,
     +     ierr)
C
C Retrieve the ids of the AnnoManager objects created by the PlotManager
C and then set their location in data coordinate space. The AnnoManager
C objects are arranged in the same order as the TextItems in the
C pmAnnoViews resource.
C
      call NhlFRLClear(grlist)
      call NhlFRLGetintegerarray(grlist,'pmAnnoManagers',am_ids,
     +                           num_am_ids,ierr)
      call NhlFGetValues(mpid,grlist,ierr)

      do i=1,num_am_ids
         call NhlFRLClear(srlist)
         call NhlFRLSetfloat(srlist,'amDataXF',slon(i),ierr)
         call NhlFRLSetfloat(srlist,'amDataYF',slat(i),ierr)
         call NhlFSetValues(am_ids(i),srlist,ierr)
      end do
C
C Create a ScalarField object.
C
      count(1) = NCLS
      count(2) = NCLS
      call NhlFRLClear(srlist)
      call NhlFRLSetMDFloatArray(srlist,'sfDataArray',zdat,2,count,
     +     ierr)
      call NhlFRLSetFloat(srlist,'sfMissingValueV',miss_val,ierr)
      call NhlFRLSetFloat(srlist,'sfXCStartV',cminlon,ierr)
      call NhlFRLSetFloat(srlist,'sfXCEndV',  cmaxlon,ierr)
      call NhlFRLSetFloat(srlist,'sfYCStartV',cminlat,ierr)
      call NhlFRLSetFloat(srlist,'sfYCEndV',  cmaxlat,ierr)
      call NhlFCreate(dataid,'DataItem',nhlfscalarfieldclass,appid,
     +     srlist,ierr)
C
C Create ContourPlot object.
C
      call NhlFRLClear(srlist)
      call NhlFRLSetInteger(srlist,'cnScalarFieldData',dataid,ierr)
      call NhlFRLSetString(srlist,'tiMainString',
     +'Satellite view of contour bands in a limited area (using HLUS)',
     +ierr)
      call NhlFCreate(cnid,'ContourPlot',nhlfcontourplotclass,workid,
     +     srlist,ierr)
C
C Overlay ContourPlot on MapPlot and draw.
C
      call NhlFAddOverlay(mpid,cnid,-1,ierr)
      call NhlFDraw(mpid,ierr)
C
C Retrieve the GraphicStyle object that was created for us when
C we created the Workstation object.  We can then draw polylines
C and polymarkers on our MapPlot on behalf of the GraphicStyle object.
C
      call NhlFRLClear(grlist)
      call NhlFRLGetInteger(grlist,'wkDefGraphicStyleId',gsid,ierr)
      call NhlFGetValues(workid,grlist,ierr)
C
C Draw circle around our contours.
C
      call NhlFDataPolyline(mpid,gsid,clon,clat,NCIRC,ierr)
C
C Draw a polymarker at the position of Boulder, Colorado (where
C NCAR is located).
C
      call NhlFDataPolymarker(mpid,gsid,ctrlon,ctrlat,1,ierr)
C
C Advance the frame.
C
      call NhlFFrame(workid,ierr)
C
C Now, let's show how we can mix LLUs and HLUs so we can use Plotchar
C to draw the text in the map projection (which we can't do in the
C HLUs yet). First we need to get the GKS workstation id so we can
C activate this workstation at the LLU level.
C
      call NhlFRLClear(grlist)
      call NhlFRLGetinteger(grlist,'wkGksWorkId',gkswid,ierr)
      call NhlFGetValues(workid,grlist,ierr)
C     
C Turn off our previous annotations since we are now annotating
C with LLU calls.
C  
      do i=1,NDIM
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'amOn','false',ierr)
         call NhlFSetValues(am_ids(i),srlist,ierr)
      end do
C
C Draw the map, circle, and polymarker.
C     
      call NhlFRLClear(srlist)
      call NhlFRLSetString(srlist,'tiMainString',
     +'Satellite view of contour bands in a limited area (using HLUs/LLU
     +S)',ierr)
      call NhlFSetValues(cnid,srlist,ierr)
      call NhlFDraw(mpid,ierr)
      call NhlFDataPolyline(mpid,gsid,clon,clat,NCIRC,ierr)
      call NhlFDataPolymarker(mpid,gsid,ctrlon,ctrlat,1,ierr)
C
C Here's where the LLU calls come in. We are using Plotchar to
C draw the text in our map projection.  First we need to activate
C the workstation with the GKS id we retrieved earlier.
C
      call gacwk(gkswid)
      call pcseti ('MAP',4)
      call pcsetr ('ORV',1.E12)
      pang=45.
C
      do i=1,NDIM
         plat=slat(i)
         plon=slon(i)
         call plchhq (0.,0.,smne(i),.5,0.,0.)
      end do
      call gdawk(gkswid)
C
C Advance the frame.
C
      call NhlFFrame(workid,ierr)
C
C NhlDestroy destroys the given id and all of its children.
C
      call NhlFDestroy(workid,ierr)
C
C Restores state.
C
      call NhlFClose
      stop
      end

C
C $Id: fence3.f,v 1.6 2008-07-27 00:17:33 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE FENCE3 (U,V,W,N,IOR,BOT)
      SAVE
      REAL            U(N)       ,V(N)       ,W(N)
      DIMENSION       LASF(13)
C
C COMMON BLOCK THRINT IS USED FOR SETTING COLOR INTENSITY
C
      COMMON /THRINT/ ITHRMJ     ,ITHRMN     ,ITHRTX
C
C INQUIRE LINE COLOR INDEX AND SET ASF TO INDIVIDUAL
C
      CALL GQPLCI (IERR, IPLCI)
      CALL GQASF (IERR, LASF)
      LSV3  = LASF(3)
      LASF(3) = 1
      CALL GSASF (LASF)
C
      M = N
      BASE = BOT
      L = MAX(1,MIN(3,IOR))
C
C SET LINE INTENSITY TO LOW
C
      CALL GSPLCI (ITHRMN)
      GO TO ( 10, 40, 70),L
   10 CALL FRST3 (BASE,V(1),W(1))
      DO  20 I=2,M
         VV = V(I)
         WW = W(I)
         CALL VECT3 (BASE,VV,WW)
   20 CONTINUE
      DO  30 I=1,M
         UU = U(I)
         VV = V(I)
         WW = W(I)
         CALL LINE3 (UU,VV,WW,BASE,VV,WW)
   30 CONTINUE
      GO TO 100
   40 CALL FRST3 (U(1),BASE,W(1))
      DO  50 I=2,M
         UU = U(I)
         WW = W(I)
         CALL VECT3 (UU,BASE,WW)
   50 CONTINUE
      DO  60 I=1,M
         UU = U(I)
         VV = V(I)
         WW = W(I)
         CALL LINE3 (UU,VV,WW,UU,BASE,WW)
   60 CONTINUE
      GO TO 100
   70 CALL FRST3 (U(1),V(1),BASE)
      DO  80 I=2,M
         UU = U(I)
         VV = V(I)
         CALL VECT3 (UU,VV,BASE)
   80 CONTINUE
      DO  90 I=1,M
         UU = U(I)
         VV = V(I)
         WW = W(I)
         CALL LINE3 (UU,VV,WW,UU,VV,BASE)
   90 CONTINUE
C
C SET LINE INTENSITY TO HIGH
C
  100 CALL GSPLCI (ITHRMJ)
      CALL CURVE3 (U,V,W,M)
C
C RESTORE ASF AND LINE INTENSITY TO ORIGINAL
C
      LASF(3) = LSV3
      CALL GSASF (LASF)
      CALL GSPLCI (IPLCI)
C
      RETURN
C
C REVISION HISTORY---
C
C JANUARY 1978     DELETED REFERENCES TO THE  *COSY  CARDS AND
C                  ADDED REVISION HISTORY
C FEBURARY 1979    MODIFIED CODE TO CONFORM TO FORTRAN 66 STANDARD
C JUNE 1979        UPDATED FILE TO INCLUDE BLOCK DATA PWRZBD AND
C                  CORRECT A COMMENTED OUT STATEMENT IN CURVE3.
C MARCH 1980       REMOVED THE PWRZ AND PWRITZ ENTRIES.  THESE
C                  CAPABILITIES WERE REPLACED WITH THE NEW ULIB FILE
C                  PWRZT.
C JULY 1984        CONVERTED TO FORTRAN 77 AND GKS
C MARCH 1990       CORRECTED THE SAVING AND RESTORING OF SET CALLS
C JULY 1990        CHANGED THE NAME OF THE COMMON BLOCK TEMPR TO
C                  TEMPRT (TO AVOID CONFLICT WITH ISOSRF).
C
C-----------------------------------------------------------------------
C
      END

      DOUBLE PRECISION FUNCTION DSECND( )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*  Purpose
*  =======
*
*  DSECND returns the user time for a process in seconds.
*  This version gets the time from the system function ETIME.
*
* =====================================================================
*
*     .. Local Scalars ..
      REAL               T1
*     ..
*     .. Local Arrays ..
      REAL               TARRAY( 2 )
*     ..
*     .. External Functions ..
*     NOTE: On IBMs, you may have to change ETIME to ETIME_
*     REAL               ETIME_
*     EXTERNAL           ETIME_
      EXTERNAL  REAL     ETIME
*     ..
*     .. Executable Statements ..
*
      T1 = ETIME( TARRAY )
      DSECND = TARRAY( 1 )
      RETURN
*
*     End of DSECND
*
      END

      SUBROUTINE DSBGST( VECT, UPLO, N, KA, KB, AB, LDAB, BB, LDBB, X,
     $                   LDX, WORK, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          UPLO, VECT
      INTEGER            INFO, KA, KB, LDAB, LDBB, LDX, N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   AB( LDAB, * ), BB( LDBB, * ), WORK( * ),
     $                   X( LDX, * )
*     ..
*
*  Purpose
*  =======
*
*  DSBGST reduces a real symmetric-definite banded generalized
*  eigenproblem  A*x = lambda*B*x  to standard form  C*y = lambda*y,
*  such that C has the same bandwidth as A.
*
*  B must have been previously factorized as S**T*S by DPBSTF, using a
*  split Cholesky factorization. A is overwritten by C = X**T*A*X, where
*  X = S**(-1)*Q and Q is an orthogonal matrix chosen to preserve the
*  bandwidth of A.
*
*  Arguments
*  =========
*
*  VECT    (input) CHARACTER*1
*          = 'N':  do not form the transformation matrix X;
*          = 'V':  form X.
*
*  UPLO    (input) CHARACTER*1
*          = 'U':  Upper triangle of A is stored;
*          = 'L':  Lower triangle of A is stored.
*
*  N       (input) INTEGER
*          The order of the matrices A and B.  N >= 0.
*
*  KA      (input) INTEGER
*          The number of superdiagonals of the matrix A if UPLO = 'U',
*          or the number of subdiagonals if UPLO = 'L'.  KA >= 0.
*
*  KB      (input) INTEGER
*          The number of superdiagonals of the matrix B if UPLO = 'U',
*          or the number of subdiagonals if UPLO = 'L'.  KA >= KB >= 0.
*
*  AB      (input/output) DOUBLE PRECISION array, dimension (LDAB,N)
*          On entry, the upper or lower triangle of the symmetric band
*          matrix A, stored in the first ka+1 rows of the array.  The
*          j-th column of A is stored in the j-th column of the array AB
*          as follows:
*          if UPLO = 'U', AB(ka+1+i-j,j) = A(i,j) for max(1,j-ka)<=i<=j;
*          if UPLO = 'L', AB(1+i-j,j)    = A(i,j) for j<=i<=min(n,j+ka).
*
*          On exit, the transformed matrix X**T*A*X, stored in the same
*          format as A.
*
*  LDAB    (input) INTEGER
*          The leading dimension of the array AB.  LDAB >= KA+1.
*
*  BB      (input) DOUBLE PRECISION array, dimension (LDBB,N)
*          The banded factor S from the split Cholesky factorization of
*          B, as returned by DPBSTF, stored in the first KB+1 rows of
*          the array.
*
*  LDBB    (input) INTEGER
*          The leading dimension of the array BB.  LDBB >= KB+1.
*
*  X       (output) DOUBLE PRECISION array, dimension (LDX,N)
*          If VECT = 'V', the n-by-n matrix X.
*          If VECT = 'N', the array X is not referenced.
*
*  LDX     (input) INTEGER
*          The leading dimension of the array X.
*          LDX >= max(1,N) if VECT = 'V'; LDX >= 1 otherwise.
*
*  WORK    (workspace) DOUBLE PRECISION array, dimension (2*N)
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value.
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO, ONE
      PARAMETER          ( ZERO = 0.0D+0, ONE = 1.0D+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            UPDATE, UPPER, WANTX
      INTEGER            I, I0, I1, I2, INCA, J, J1, J1T, J2, J2T, K,
     $                   KA1, KB1, KBT, L, M, NR, NRT, NX
      DOUBLE PRECISION   BII, RA, RA1, T
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           DGER, DLAR2V, DLARGV, DLARTG, DLARTV, DLASET,
     $                   DROT, DSCAL, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters
*
      WANTX = LSAME( VECT, 'V' )
      UPPER = LSAME( UPLO, 'U' )
      KA1 = KA + 1
      KB1 = KB + 1
      INFO = 0
      IF( .NOT.WANTX .AND. .NOT.LSAME( VECT, 'N' ) ) THEN
         INFO = -1
      ELSE IF( .NOT.UPPER .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = -2
      ELSE IF( N.LT.0 ) THEN
         INFO = -3
      ELSE IF( KA.LT.0 ) THEN
         INFO = -4
      ELSE IF( KB.LT.0 ) THEN
         INFO = -5
      ELSE IF( LDAB.LT.KA+1 ) THEN
         INFO = -7
      ELSE IF( LDBB.LT.KB+1 ) THEN
         INFO = -9
      ELSE IF( LDX.LT.1 .OR. WANTX .AND. LDX.LT.MAX( 1, N ) ) THEN
         INFO = -11
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DSBGST', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
*
      INCA = LDAB*KA1
*
*     Initialize X to the unit matrix, if needed
*
      IF( WANTX )
     $   CALL DLASET( 'Full', N, N, ZERO, ONE, X, LDX )
*
*     Set M to the splitting point m. It must be the same value as is
*     used in DPBSTF. The chosen value allows the arrays WORK and RWORK
*     to be of dimension (N).
*
      M = ( N+KB ) / 2
*
*     The routine works in two phases, corresponding to the two halves
*     of the split Cholesky factorization of B as S**T*S where
*
*     S = ( U    )
*         ( M  L )
*
*     with U upper triangular of order m, and L lower triangular of
*     order n-m. S has the same bandwidth as B.
*
*     S is treated as a product of elementary matrices:
*
*     S = S(m)*S(m-1)*...*S(2)*S(1)*S(m+1)*S(m+2)*...*S(n-1)*S(n)
*
*     where S(i) is determined by the i-th row of S.
*
*     In phase 1, the index i takes the values n, n-1, ... , m+1;
*     in phase 2, it takes the values 1, 2, ... , m.
*
*     For each value of i, the current matrix A is updated by forming
*     inv(S(i))**T*A*inv(S(i)). This creates a triangular bulge outside
*     the band of A. The bulge is then pushed down toward the bottom of
*     A in phase 1, and up toward the top of A in phase 2, by applying
*     plane rotations.
*
*     There are kb*(kb+1)/2 elements in the bulge, but at most 2*kb-1
*     of them are linearly independent, so annihilating a bulge requires
*     only 2*kb-1 plane rotations. The rotations are divided into a 1st
*     set of kb-1 rotations, and a 2nd set of kb rotations.
*
*     Wherever possible, rotations are generated and applied in vector
*     operations of length NR between the indices J1 and J2 (sometimes
*     replaced by modified values NRT, J1T or J2T).
*
*     The cosines and sines of the rotations are stored in the array
*     WORK. The cosines of the 1st set of rotations are stored in
*     elements n+2:n+m-kb-1 and the sines of the 1st set in elements
*     2:m-kb-1; the cosines of the 2nd set are stored in elements
*     n+m-kb+1:2*n and the sines of the second set in elements m-kb+1:n.
*
*     The bulges are not formed explicitly; nonzero elements outside the
*     band are created only when they are required for generating new
*     rotations; they are stored in the array WORK, in positions where
*     they are later overwritten by the sines of the rotations which
*     annihilate them.
*
*     **************************** Phase 1 *****************************
*
*     The logical structure of this phase is:
*
*     UPDATE = .TRUE.
*     DO I = N, M + 1, -1
*        use S(i) to update A and create a new bulge
*        apply rotations to push all bulges KA positions downward
*     END DO
*     UPDATE = .FALSE.
*     DO I = M + KA + 1, N - 1
*        apply rotations to push all bulges KA positions downward
*     END DO
*
*     To avoid duplicating code, the two loops are merged.
*
      UPDATE = .TRUE.
      I = N + 1
   10 CONTINUE
      IF( UPDATE ) THEN
         I = I - 1
         KBT = MIN( KB, I-1 )
         I0 = I - 1
         I1 = MIN( N, I+KA )
         I2 = I - KBT + KA1
         IF( I.LT.M+1 ) THEN
            UPDATE = .FALSE.
            I = I + 1
            I0 = M
            IF( KA.EQ.0 )
     $         GO TO 480
            GO TO 10
         END IF
      ELSE
         I = I + KA
         IF( I.GT.N-1 )
     $      GO TO 480
      END IF
*
      IF( UPPER ) THEN
*
*        Transform A, working with the upper triangle
*
         IF( UPDATE ) THEN
*
*           Form  inv(S(i))**T * A * inv(S(i))
*
            BII = BB( KB1, I )
            DO 20 J = I, I1
               AB( I-J+KA1, J ) = AB( I-J+KA1, J ) / BII
   20       CONTINUE
            DO 30 J = MAX( 1, I-KA ), I
               AB( J-I+KA1, I ) = AB( J-I+KA1, I ) / BII
   30       CONTINUE
            DO 60 K = I - KBT, I - 1
               DO 40 J = I - KBT, K
                  AB( J-K+KA1, K ) = AB( J-K+KA1, K ) -
     $                               BB( J-I+KB1, I )*AB( K-I+KA1, I ) -
     $                               BB( K-I+KB1, I )*AB( J-I+KA1, I ) +
     $                               AB( KA1, I )*BB( J-I+KB1, I )*
     $                               BB( K-I+KB1, I )
   40          CONTINUE
               DO 50 J = MAX( 1, I-KA ), I - KBT - 1
                  AB( J-K+KA1, K ) = AB( J-K+KA1, K ) -
     $                               BB( K-I+KB1, I )*AB( J-I+KA1, I )
   50          CONTINUE
   60       CONTINUE
            DO 80 J = I, I1
               DO 70 K = MAX( J-KA, I-KBT ), I - 1
                  AB( K-J+KA1, J ) = AB( K-J+KA1, J ) -
     $                               BB( K-I+KB1, I )*AB( I-J+KA1, J )
   70          CONTINUE
   80       CONTINUE
*
            IF( WANTX ) THEN
*
*              post-multiply X by inv(S(i))
*
               CALL DSCAL( N-M, ONE / BII, X( M+1, I ), 1 )
               IF( KBT.GT.0 )
     $            CALL DGER( N-M, KBT, -ONE, X( M+1, I ), 1,
     $                       BB( KB1-KBT, I ), 1, X( M+1, I-KBT ), LDX )
            END IF
*
*           store a(i,i1) in RA1 for use in next loop over K
*
            RA1 = AB( I-I1+KA1, I1 )
         END IF
*
*        Generate and apply vectors of rotations to chase all the
*        existing bulges KA positions down toward the bottom of the
*        band
*
         DO 130 K = 1, KB - 1
            IF( UPDATE ) THEN
*
*              Determine the rotations which would annihilate the bulge
*              which has in theory just been created
*
               IF( I-K+KA.LT.N .AND. I-K.GT.1 ) THEN
*
*                 generate rotation to annihilate a(i,i-k+ka+1)
*
                  CALL DLARTG( AB( K+1, I-K+KA ), RA1,
     $                         WORK( N+I-K+KA-M ), WORK( I-K+KA-M ),
     $                         RA )
*
*                 create nonzero element a(i-k,i-k+ka+1) outside the
*                 band and store it in WORK(i-k)
*
                  T = -BB( KB1-K, I )*RA1
                  WORK( I-K ) = WORK( N+I-K+KA-M )*T -
     $                          WORK( I-K+KA-M )*AB( 1, I-K+KA )
                  AB( 1, I-K+KA ) = WORK( I-K+KA-M )*T +
     $                              WORK( N+I-K+KA-M )*AB( 1, I-K+KA )
                  RA1 = RA
               END IF
            END IF
            J2 = I - K - 1 + MAX( 1, K-I0+2 )*KA1
            NR = ( N-J2+KA ) / KA1
            J1 = J2 + ( NR-1 )*KA1
            IF( UPDATE ) THEN
               J2T = MAX( J2, I+2*KA-K+1 )
            ELSE
               J2T = J2
            END IF
            NRT = ( N-J2T+KA ) / KA1
            DO 90 J = J2T, J1, KA1
*
*              create nonzero element a(j-ka,j+1) outside the band
*              and store it in WORK(j-m)
*
               WORK( J-M ) = WORK( J-M )*AB( 1, J+1 )
               AB( 1, J+1 ) = WORK( N+J-M )*AB( 1, J+1 )
   90       CONTINUE
*
*           generate rotations in 1st set to annihilate elements which
*           have been created outside the band
*
            IF( NRT.GT.0 )
     $         CALL DLARGV( NRT, AB( 1, J2T ), INCA, WORK( J2T-M ), KA1,
     $                      WORK( N+J2T-M ), KA1 )
            IF( NR.GT.0 ) THEN
*
*              apply rotations in 1st set from the right
*
               DO 100 L = 1, KA - 1
                  CALL DLARTV( NR, AB( KA1-L, J2 ), INCA,
     $                         AB( KA-L, J2+1 ), INCA, WORK( N+J2-M ),
     $                         WORK( J2-M ), KA1 )
  100          CONTINUE
*
*              apply rotations in 1st set from both sides to diagonal
*              blocks
*
               CALL DLAR2V( NR, AB( KA1, J2 ), AB( KA1, J2+1 ),
     $                      AB( KA, J2+1 ), INCA, WORK( N+J2-M ),
     $                      WORK( J2-M ), KA1 )
*
            END IF
*
*           start applying rotations in 1st set from the left
*
            DO 110 L = KA - 1, KB - K + 1, -1
               NRT = ( N-J2+L ) / KA1
               IF( NRT.GT.0 )
     $            CALL DLARTV( NRT, AB( L, J2+KA1-L ), INCA,
     $                         AB( L+1, J2+KA1-L ), INCA,
     $                         WORK( N+J2-M ), WORK( J2-M ), KA1 )
  110       CONTINUE
*
            IF( WANTX ) THEN
*
*              post-multiply X by product of rotations in 1st set
*
               DO 120 J = J2, J1, KA1
                  CALL DROT( N-M, X( M+1, J ), 1, X( M+1, J+1 ), 1,
     $                       WORK( N+J-M ), WORK( J-M ) )
  120          CONTINUE
            END IF
  130    CONTINUE
*
         IF( UPDATE ) THEN
            IF( I2.LE.N .AND. KBT.GT.0 ) THEN
*
*              create nonzero element a(i-kbt,i-kbt+ka+1) outside the
*              band and store it in WORK(i-kbt)
*
               WORK( I-KBT ) = -BB( KB1-KBT, I )*RA1
            END IF
         END IF
*
         DO 170 K = KB, 1, -1
            IF( UPDATE ) THEN
               J2 = I - K - 1 + MAX( 2, K-I0+1 )*KA1
            ELSE
               J2 = I - K - 1 + MAX( 1, K-I0+1 )*KA1
            END IF
*
*           finish applying rotations in 2nd set from the left
*
            DO 140 L = KB - K, 1, -1
               NRT = ( N-J2+KA+L ) / KA1
               IF( NRT.GT.0 )
     $            CALL DLARTV( NRT, AB( L, J2-L+1 ), INCA,
     $                         AB( L+1, J2-L+1 ), INCA, WORK( N+J2-KA ),
     $                         WORK( J2-KA ), KA1 )
  140       CONTINUE
            NR = ( N-J2+KA ) / KA1
            J1 = J2 + ( NR-1 )*KA1
            DO 150 J = J1, J2, -KA1
               WORK( J ) = WORK( J-KA )
               WORK( N+J ) = WORK( N+J-KA )
  150       CONTINUE
            DO 160 J = J2, J1, KA1
*
*              create nonzero element a(j-ka,j+1) outside the band
*              and store it in WORK(j)
*
               WORK( J ) = WORK( J )*AB( 1, J+1 )
               AB( 1, J+1 ) = WORK( N+J )*AB( 1, J+1 )
  160       CONTINUE
            IF( UPDATE ) THEN
               IF( I-K.LT.N-KA .AND. K.LE.KBT )
     $            WORK( I-K+KA ) = WORK( I-K )
            END IF
  170    CONTINUE
*
         DO 210 K = KB, 1, -1
            J2 = I - K - 1 + MAX( 1, K-I0+1 )*KA1
            NR = ( N-J2+KA ) / KA1
            J1 = J2 + ( NR-1 )*KA1
            IF( NR.GT.0 ) THEN
*
*              generate rotations in 2nd set to annihilate elements
*              which have been created outside the band
*
               CALL DLARGV( NR, AB( 1, J2 ), INCA, WORK( J2 ), KA1,
     $                      WORK( N+J2 ), KA1 )
*
*              apply rotations in 2nd set from the right
*
               DO 180 L = 1, KA - 1
                  CALL DLARTV( NR, AB( KA1-L, J2 ), INCA,
     $                         AB( KA-L, J2+1 ), INCA, WORK( N+J2 ),
     $                         WORK( J2 ), KA1 )
  180          CONTINUE
*
*              apply rotations in 2nd set from both sides to diagonal
*              blocks
*
               CALL DLAR2V( NR, AB( KA1, J2 ), AB( KA1, J2+1 ),
     $                      AB( KA, J2+1 ), INCA, WORK( N+J2 ),
     $                      WORK( J2 ), KA1 )
*
            END IF
*
*           start applying rotations in 2nd set from the left
*
            DO 190 L = KA - 1, KB - K + 1, -1
               NRT = ( N-J2+L ) / KA1
               IF( NRT.GT.0 )
     $            CALL DLARTV( NRT, AB( L, J2+KA1-L ), INCA,
     $                         AB( L+1, J2+KA1-L ), INCA, WORK( N+J2 ),
     $                         WORK( J2 ), KA1 )
  190       CONTINUE
*
            IF( WANTX ) THEN
*
*              post-multiply X by product of rotations in 2nd set
*
               DO 200 J = J2, J1, KA1
                  CALL DROT( N-M, X( M+1, J ), 1, X( M+1, J+1 ), 1,
     $                       WORK( N+J ), WORK( J ) )
  200          CONTINUE
            END IF
  210    CONTINUE
*
         DO 230 K = 1, KB - 1
            J2 = I - K - 1 + MAX( 1, K-I0+2 )*KA1
*
*           finish applying rotations in 1st set from the left
*
            DO 220 L = KB - K, 1, -1
               NRT = ( N-J2+L ) / KA1
               IF( NRT.GT.0 )
     $            CALL DLARTV( NRT, AB( L, J2+KA1-L ), INCA,
     $                         AB( L+1, J2+KA1-L ), INCA,
     $                         WORK( N+J2-M ), WORK( J2-M ), KA1 )
  220       CONTINUE
  230    CONTINUE
*
         IF( KB.GT.1 ) THEN
            DO 240 J = N - 1, I - KB + 2*KA + 1, -1
               WORK( N+J-M ) = WORK( N+J-KA-M )
               WORK( J-M ) = WORK( J-KA-M )
  240       CONTINUE
         END IF
*
      ELSE
*
*        Transform A, working with the lower triangle
*
         IF( UPDATE ) THEN
*
*           Form  inv(S(i))**T * A * inv(S(i))
*
            BII = BB( 1, I )
            DO 250 J = I, I1
               AB( J-I+1, I ) = AB( J-I+1, I ) / BII
  250       CONTINUE
            DO 260 J = MAX( 1, I-KA ), I
               AB( I-J+1, J ) = AB( I-J+1, J ) / BII
  260       CONTINUE
            DO 290 K = I - KBT, I - 1
               DO 270 J = I - KBT, K
                  AB( K-J+1, J ) = AB( K-J+1, J ) -
     $                             BB( I-J+1, J )*AB( I-K+1, K ) -
     $                             BB( I-K+1, K )*AB( I-J+1, J ) +
     $                             AB( 1, I )*BB( I-J+1, J )*
     $                             BB( I-K+1, K )
  270          CONTINUE
               DO 280 J = MAX( 1, I-KA ), I - KBT - 1
                  AB( K-J+1, J ) = AB( K-J+1, J ) -
     $                             BB( I-K+1, K )*AB( I-J+1, J )
  280          CONTINUE
  290       CONTINUE
            DO 310 J = I, I1
               DO 300 K = MAX( J-KA, I-KBT ), I - 1
                  AB( J-K+1, K ) = AB( J-K+1, K ) -
     $                             BB( I-K+1, K )*AB( J-I+1, I )
  300          CONTINUE
  310       CONTINUE
*
            IF( WANTX ) THEN
*
*              post-multiply X by inv(S(i))
*
               CALL DSCAL( N-M, ONE / BII, X( M+1, I ), 1 )
               IF( KBT.GT.0 )
     $            CALL DGER( N-M, KBT, -ONE, X( M+1, I ), 1,
     $                       BB( KBT+1, I-KBT ), LDBB-1,
     $                       X( M+1, I-KBT ), LDX )
            END IF
*
*           store a(i1,i) in RA1 for use in next loop over K
*
            RA1 = AB( I1-I+1, I )
         END IF
*
*        Generate and apply vectors of rotations to chase all the
*        existing bulges KA positions down toward the bottom of the
*        band
*
         DO 360 K = 1, KB - 1
            IF( UPDATE ) THEN
*
*              Determine the rotations which would annihilate the bulge
*              which has in theory just been created
*
               IF( I-K+KA.LT.N .AND. I-K.GT.1 ) THEN
*
*                 generate rotation to annihilate a(i-k+ka+1,i)
*
                  CALL DLARTG( AB( KA1-K, I ), RA1, WORK( N+I-K+KA-M ),
     $                         WORK( I-K+KA-M ), RA )
*
*                 create nonzero element a(i-k+ka+1,i-k) outside the
*                 band and store it in WORK(i-k)
*
                  T = -BB( K+1, I-K )*RA1
                  WORK( I-K ) = WORK( N+I-K+KA-M )*T -
     $                          WORK( I-K+KA-M )*AB( KA1, I-K )
                  AB( KA1, I-K ) = WORK( I-K+KA-M )*T +
     $                             WORK( N+I-K+KA-M )*AB( KA1, I-K )
                  RA1 = RA
               END IF
            END IF
            J2 = I - K - 1 + MAX( 1, K-I0+2 )*KA1
            NR = ( N-J2+KA ) / KA1
            J1 = J2 + ( NR-1 )*KA1
            IF( UPDATE ) THEN
               J2T = MAX( J2, I+2*KA-K+1 )
            ELSE
               J2T = J2
            END IF
            NRT = ( N-J2T+KA ) / KA1
            DO 320 J = J2T, J1, KA1
*
*              create nonzero element a(j+1,j-ka) outside the band
*              and store it in WORK(j-m)
*
               WORK( J-M ) = WORK( J-M )*AB( KA1, J-KA+1 )
               AB( KA1, J-KA+1 ) = WORK( N+J-M )*AB( KA1, J-KA+1 )
  320       CONTINUE
*
*           generate rotations in 1st set to annihilate elements which
*           have been created outside the band
*
            IF( NRT.GT.0 )
     $         CALL DLARGV( NRT, AB( KA1, J2T-KA ), INCA, WORK( J2T-M ),
     $                      KA1, WORK( N+J2T-M ), KA1 )
            IF( NR.GT.0 ) THEN
*
*              apply rotations in 1st set from the left
*
               DO 330 L = 1, KA - 1
                  CALL DLARTV( NR, AB( L+1, J2-L ), INCA,
     $                         AB( L+2, J2-L ), INCA, WORK( N+J2-M ),
     $                         WORK( J2-M ), KA1 )
  330          CONTINUE
*
*              apply rotations in 1st set from both sides to diagonal
*              blocks
*
               CALL DLAR2V( NR, AB( 1, J2 ), AB( 1, J2+1 ), AB( 2, J2 ),
     $                      INCA, WORK( N+J2-M ), WORK( J2-M ), KA1 )
*
            END IF
*
*           start applying rotations in 1st set from the right
*
            DO 340 L = KA - 1, KB - K + 1, -1
               NRT = ( N-J2+L ) / KA1
               IF( NRT.GT.0 )
     $            CALL DLARTV( NRT, AB( KA1-L+1, J2 ), INCA,
     $                         AB( KA1-L, J2+1 ), INCA, WORK( N+J2-M ),
     $                         WORK( J2-M ), KA1 )
  340       CONTINUE
*
            IF( WANTX ) THEN
*
*              post-multiply X by product of rotations in 1st set
*
               DO 350 J = J2, J1, KA1
                  CALL DROT( N-M, X( M+1, J ), 1, X( M+1, J+1 ), 1,
     $                       WORK( N+J-M ), WORK( J-M ) )
  350          CONTINUE
            END IF
  360    CONTINUE
*
         IF( UPDATE ) THEN
            IF( I2.LE.N .AND. KBT.GT.0 ) THEN
*
*              create nonzero element a(i-kbt+ka+1,i-kbt) outside the
*              band and store it in WORK(i-kbt)
*
               WORK( I-KBT ) = -BB( KBT+1, I-KBT )*RA1
            END IF
         END IF
*
         DO 400 K = KB, 1, -1
            IF( UPDATE ) THEN
               J2 = I - K - 1 + MAX( 2, K-I0+1 )*KA1
            ELSE
               J2 = I - K - 1 + MAX( 1, K-I0+1 )*KA1
            END IF
*
*           finish applying rotations in 2nd set from the right
*
            DO 370 L = KB - K, 1, -1
               NRT = ( N-J2+KA+L ) / KA1
               IF( NRT.GT.0 )
     $            CALL DLARTV( NRT, AB( KA1-L+1, J2-KA ), INCA,
     $                         AB( KA1-L, J2-KA+1 ), INCA,
     $                         WORK( N+J2-KA ), WORK( J2-KA ), KA1 )
  370       CONTINUE
            NR = ( N-J2+KA ) / KA1
            J1 = J2 + ( NR-1 )*KA1
            DO 380 J = J1, J2, -KA1
               WORK( J ) = WORK( J-KA )
               WORK( N+J ) = WORK( N+J-KA )
  380       CONTINUE
            DO 390 J = J2, J1, KA1
*
*              create nonzero element a(j+1,j-ka) outside the band
*              and store it in WORK(j)
*
               WORK( J ) = WORK( J )*AB( KA1, J-KA+1 )
               AB( KA1, J-KA+1 ) = WORK( N+J )*AB( KA1, J-KA+1 )
  390       CONTINUE
            IF( UPDATE ) THEN
               IF( I-K.LT.N-KA .AND. K.LE.KBT )
     $            WORK( I-K+KA ) = WORK( I-K )
            END IF
  400    CONTINUE
*
         DO 440 K = KB, 1, -1
            J2 = I - K - 1 + MAX( 1, K-I0+1 )*KA1
            NR = ( N-J2+KA ) / KA1
            J1 = J2 + ( NR-1 )*KA1
            IF( NR.GT.0 ) THEN
*
*              generate rotations in 2nd set to annihilate elements
*              which have been created outside the band
*
               CALL DLARGV( NR, AB( KA1, J2-KA ), INCA, WORK( J2 ), KA1,
     $                      WORK( N+J2 ), KA1 )
*
*              apply rotations in 2nd set from the left
*
               DO 410 L = 1, KA - 1
                  CALL DLARTV( NR, AB( L+1, J2-L ), INCA,
     $                         AB( L+2, J2-L ), INCA, WORK( N+J2 ),
     $                         WORK( J2 ), KA1 )
  410          CONTINUE
*
*              apply rotations in 2nd set from both sides to diagonal
*              blocks
*
               CALL DLAR2V( NR, AB( 1, J2 ), AB( 1, J2+1 ), AB( 2, J2 ),
     $                      INCA, WORK( N+J2 ), WORK( J2 ), KA1 )
*
            END IF
*
*           start applying rotations in 2nd set from the right
*
            DO 420 L = KA - 1, KB - K + 1, -1
               NRT = ( N-J2+L ) / KA1
               IF( NRT.GT.0 )
     $            CALL DLARTV( NRT, AB( KA1-L+1, J2 ), INCA,
     $                         AB( KA1-L, J2+1 ), INCA, WORK( N+J2 ),
     $                         WORK( J2 ), KA1 )
  420       CONTINUE
*
            IF( WANTX ) THEN
*
*              post-multiply X by product of rotations in 2nd set
*
               DO 430 J = J2, J1, KA1
                  CALL DROT( N-M, X( M+1, J ), 1, X( M+1, J+1 ), 1,
     $                       WORK( N+J ), WORK( J ) )
  430          CONTINUE
            END IF
  440    CONTINUE
*
         DO 460 K = 1, KB - 1
            J2 = I - K - 1 + MAX( 1, K-I0+2 )*KA1
*
*           finish applying rotations in 1st set from the right
*
            DO 450 L = KB - K, 1, -1
               NRT = ( N-J2+L ) / KA1
               IF( NRT.GT.0 )
     $            CALL DLARTV( NRT, AB( KA1-L+1, J2 ), INCA,
     $                         AB( KA1-L, J2+1 ), INCA, WORK( N+J2-M ),
     $                         WORK( J2-M ), KA1 )
  450       CONTINUE
  460    CONTINUE
*
         IF( KB.GT.1 ) THEN
            DO 470 J = N - 1, I - KB + 2*KA + 1, -1
               WORK( N+J-M ) = WORK( N+J-KA-M )
               WORK( J-M ) = WORK( J-KA-M )
  470       CONTINUE
         END IF
*
      END IF
*
      GO TO 10
*
  480 CONTINUE
*
*     **************************** Phase 2 *****************************
*
*     The logical structure of this phase is:
*
*     UPDATE = .TRUE.
*     DO I = 1, M
*        use S(i) to update A and create a new bulge
*        apply rotations to push all bulges KA positions upward
*     END DO
*     UPDATE = .FALSE.
*     DO I = M - KA - 1, 2, -1
*        apply rotations to push all bulges KA positions upward
*     END DO
*
*     To avoid duplicating code, the two loops are merged.
*
      UPDATE = .TRUE.
      I = 0
  490 CONTINUE
      IF( UPDATE ) THEN
         I = I + 1
         KBT = MIN( KB, M-I )
         I0 = I + 1
         I1 = MAX( 1, I-KA )
         I2 = I + KBT - KA1
         IF( I.GT.M ) THEN
            UPDATE = .FALSE.
            I = I - 1
            I0 = M + 1
            IF( KA.EQ.0 )
     $         RETURN
            GO TO 490
         END IF
      ELSE
         I = I - KA
         IF( I.LT.2 )
     $      RETURN
      END IF
*
      IF( I.LT.M-KBT ) THEN
         NX = M
      ELSE
         NX = N
      END IF
*
      IF( UPPER ) THEN
*
*        Transform A, working with the upper triangle
*
         IF( UPDATE ) THEN
*
*           Form  inv(S(i))**T * A * inv(S(i))
*
            BII = BB( KB1, I )
            DO 500 J = I1, I
               AB( J-I+KA1, I ) = AB( J-I+KA1, I ) / BII
  500       CONTINUE
            DO 510 J = I, MIN( N, I+KA )
               AB( I-J+KA1, J ) = AB( I-J+KA1, J ) / BII
  510       CONTINUE
            DO 540 K = I + 1, I + KBT
               DO 520 J = K, I + KBT
                  AB( K-J+KA1, J ) = AB( K-J+KA1, J ) -
     $                               BB( I-J+KB1, J )*AB( I-K+KA1, K ) -
     $                               BB( I-K+KB1, K )*AB( I-J+KA1, J ) +
     $                               AB( KA1, I )*BB( I-J+KB1, J )*
     $                               BB( I-K+KB1, K )
  520          CONTINUE
               DO 530 J = I + KBT + 1, MIN( N, I+KA )
                  AB( K-J+KA1, J ) = AB( K-J+KA1, J ) -
     $                               BB( I-K+KB1, K )*AB( I-J+KA1, J )
  530          CONTINUE
  540       CONTINUE
            DO 560 J = I1, I
               DO 550 K = I + 1, MIN( J+KA, I+KBT )
                  AB( J-K+KA1, K ) = AB( J-K+KA1, K ) -
     $                               BB( I-K+KB1, K )*AB( J-I+KA1, I )
  550          CONTINUE
  560       CONTINUE
*
            IF( WANTX ) THEN
*
*              post-multiply X by inv(S(i))
*
               CALL DSCAL( NX, ONE / BII, X( 1, I ), 1 )
               IF( KBT.GT.0 )
     $            CALL DGER( NX, KBT, -ONE, X( 1, I ), 1, BB( KB, I+1 ),
     $                       LDBB-1, X( 1, I+1 ), LDX )
            END IF
*
*           store a(i1,i) in RA1 for use in next loop over K
*
            RA1 = AB( I1-I+KA1, I )
         END IF
*
*        Generate and apply vectors of rotations to chase all the
*        existing bulges KA positions up toward the top of the band
*
         DO 610 K = 1, KB - 1
            IF( UPDATE ) THEN
*
*              Determine the rotations which would annihilate the bulge
*              which has in theory just been created
*
               IF( I+K-KA1.GT.0 .AND. I+K.LT.M ) THEN
*
*                 generate rotation to annihilate a(i+k-ka-1,i)
*
                  CALL DLARTG( AB( K+1, I ), RA1, WORK( N+I+K-KA ),
     $                         WORK( I+K-KA ), RA )
*
*                 create nonzero element a(i+k-ka-1,i+k) outside the
*                 band and store it in WORK(m-kb+i+k)
*
                  T = -BB( KB1-K, I+K )*RA1
                  WORK( M-KB+I+K ) = WORK( N+I+K-KA )*T -
     $                               WORK( I+K-KA )*AB( 1, I+K )
                  AB( 1, I+K ) = WORK( I+K-KA )*T +
     $                           WORK( N+I+K-KA )*AB( 1, I+K )
                  RA1 = RA
               END IF
            END IF
            J2 = I + K + 1 - MAX( 1, K+I0-M+1 )*KA1
            NR = ( J2+KA-1 ) / KA1
            J1 = J2 - ( NR-1 )*KA1
            IF( UPDATE ) THEN
               J2T = MIN( J2, I-2*KA+K-1 )
            ELSE
               J2T = J2
            END IF
            NRT = ( J2T+KA-1 ) / KA1
            DO 570 J = J1, J2T, KA1
*
*              create nonzero element a(j-1,j+ka) outside the band
*              and store it in WORK(j)
*
               WORK( J ) = WORK( J )*AB( 1, J+KA-1 )
               AB( 1, J+KA-1 ) = WORK( N+J )*AB( 1, J+KA-1 )
  570       CONTINUE
*
*           generate rotations in 1st set to annihilate elements which
*           have been created outside the band
*
            IF( NRT.GT.0 )
     $         CALL DLARGV( NRT, AB( 1, J1+KA ), INCA, WORK( J1 ), KA1,
     $                      WORK( N+J1 ), KA1 )
            IF( NR.GT.0 ) THEN
*
*              apply rotations in 1st set from the left
*
               DO 580 L = 1, KA - 1
                  CALL DLARTV( NR, AB( KA1-L, J1+L ), INCA,
     $                         AB( KA-L, J1+L ), INCA, WORK( N+J1 ),
     $                         WORK( J1 ), KA1 )
  580          CONTINUE
*
*              apply rotations in 1st set from both sides to diagonal
*              blocks
*
               CALL DLAR2V( NR, AB( KA1, J1 ), AB( KA1, J1-1 ),
     $                      AB( KA, J1 ), INCA, WORK( N+J1 ),
     $                      WORK( J1 ), KA1 )
*
            END IF
*
*           start applying rotations in 1st set from the right
*
            DO 590 L = KA - 1, KB - K + 1, -1
               NRT = ( J2+L-1 ) / KA1
               J1T = J2 - ( NRT-1 )*KA1
               IF( NRT.GT.0 )
     $            CALL DLARTV( NRT, AB( L, J1T ), INCA,
     $                         AB( L+1, J1T-1 ), INCA, WORK( N+J1T ),
     $                         WORK( J1T ), KA1 )
  590       CONTINUE
*
            IF( WANTX ) THEN
*
*              post-multiply X by product of rotations in 1st set
*
               DO 600 J = J1, J2, KA1
                  CALL DROT( NX, X( 1, J ), 1, X( 1, J-1 ), 1,
     $                       WORK( N+J ), WORK( J ) )
  600          CONTINUE
            END IF
  610    CONTINUE
*
         IF( UPDATE ) THEN
            IF( I2.GT.0 .AND. KBT.GT.0 ) THEN
*
*              create nonzero element a(i+kbt-ka-1,i+kbt) outside the
*              band and store it in WORK(m-kb+i+kbt)
*
               WORK( M-KB+I+KBT ) = -BB( KB1-KBT, I+KBT )*RA1
            END IF
         END IF
*
         DO 650 K = KB, 1, -1
            IF( UPDATE ) THEN
               J2 = I + K + 1 - MAX( 2, K+I0-M )*KA1
            ELSE
               J2 = I + K + 1 - MAX( 1, K+I0-M )*KA1
            END IF
*
*           finish applying rotations in 2nd set from the right
*
            DO 620 L = KB - K, 1, -1
               NRT = ( J2+KA+L-1 ) / KA1
               J1T = J2 - ( NRT-1 )*KA1
               IF( NRT.GT.0 )
     $            CALL DLARTV( NRT, AB( L, J1T+KA ), INCA,
     $                         AB( L+1, J1T+KA-1 ), INCA,
     $                         WORK( N+M-KB+J1T+KA ),
     $                         WORK( M-KB+J1T+KA ), KA1 )
  620       CONTINUE
            NR = ( J2+KA-1 ) / KA1
            J1 = J2 - ( NR-1 )*KA1
            DO 630 J = J1, J2, KA1
               WORK( M-KB+J ) = WORK( M-KB+J+KA )
               WORK( N+M-KB+J ) = WORK( N+M-KB+J+KA )
  630       CONTINUE
            DO 640 J = J1, J2, KA1
*
*              create nonzero element a(j-1,j+ka) outside the band
*              and store it in WORK(m-kb+j)
*
               WORK( M-KB+J ) = WORK( M-KB+J )*AB( 1, J+KA-1 )
               AB( 1, J+KA-1 ) = WORK( N+M-KB+J )*AB( 1, J+KA-1 )
  640       CONTINUE
            IF( UPDATE ) THEN
               IF( I+K.GT.KA1 .AND. K.LE.KBT )
     $            WORK( M-KB+I+K-KA ) = WORK( M-KB+I+K )
            END IF
  650    CONTINUE
*
         DO 690 K = KB, 1, -1
            J2 = I + K + 1 - MAX( 1, K+I0-M )*KA1
            NR = ( J2+KA-1 ) / KA1
            J1 = J2 - ( NR-1 )*KA1
            IF( NR.GT.0 ) THEN
*
*              generate rotations in 2nd set to annihilate elements
*              which have been created outside the band
*
               CALL DLARGV( NR, AB( 1, J1+KA ), INCA, WORK( M-KB+J1 ),
     $                      KA1, WORK( N+M-KB+J1 ), KA1 )
*
*              apply rotations in 2nd set from the left
*
               DO 660 L = 1, KA - 1
                  CALL DLARTV( NR, AB( KA1-L, J1+L ), INCA,
     $                         AB( KA-L, J1+L ), INCA,
     $                         WORK( N+M-KB+J1 ), WORK( M-KB+J1 ), KA1 )
  660          CONTINUE
*
*              apply rotations in 2nd set from both sides to diagonal
*              blocks
*
               CALL DLAR2V( NR, AB( KA1, J1 ), AB( KA1, J1-1 ),
     $                      AB( KA, J1 ), INCA, WORK( N+M-KB+J1 ),
     $                      WORK( M-KB+J1 ), KA1 )
*
            END IF
*
*           start applying rotations in 2nd set from the right
*
            DO 670 L = KA - 1, KB - K + 1, -1
               NRT = ( J2+L-1 ) / KA1
               J1T = J2 - ( NRT-1 )*KA1
               IF( NRT.GT.0 )
     $            CALL DLARTV( NRT, AB( L, J1T ), INCA,
     $                         AB( L+1, J1T-1 ), INCA,
     $                         WORK( N+M-KB+J1T ), WORK( M-KB+J1T ),
     $                         KA1 )
  670       CONTINUE
*
            IF( WANTX ) THEN
*
*              post-multiply X by product of rotations in 2nd set
*
               DO 680 J = J1, J2, KA1
                  CALL DROT( NX, X( 1, J ), 1, X( 1, J-1 ), 1,
     $                       WORK( N+M-KB+J ), WORK( M-KB+J ) )
  680          CONTINUE
            END IF
  690    CONTINUE
*
         DO 710 K = 1, KB - 1
            J2 = I + K + 1 - MAX( 1, K+I0-M+1 )*KA1
*
*           finish applying rotations in 1st set from the right
*
            DO 700 L = KB - K, 1, -1
               NRT = ( J2+L-1 ) / KA1
               J1T = J2 - ( NRT-1 )*KA1
               IF( NRT.GT.0 )
     $            CALL DLARTV( NRT, AB( L, J1T ), INCA,
     $                         AB( L+1, J1T-1 ), INCA, WORK( N+J1T ),
     $                         WORK( J1T ), KA1 )
  700       CONTINUE
  710    CONTINUE
*
         IF( KB.GT.1 ) THEN
            DO 720 J = 2, MIN( I+KB, M ) - 2*KA - 1
               WORK( N+J ) = WORK( N+J+KA )
               WORK( J ) = WORK( J+KA )
  720       CONTINUE
         END IF
*
      ELSE
*
*        Transform A, working with the lower triangle
*
         IF( UPDATE ) THEN
*
*           Form  inv(S(i))**T * A * inv(S(i))
*
            BII = BB( 1, I )
            DO 730 J = I1, I
               AB( I-J+1, J ) = AB( I-J+1, J ) / BII
  730       CONTINUE
            DO 740 J = I, MIN( N, I+KA )
               AB( J-I+1, I ) = AB( J-I+1, I ) / BII
  740       CONTINUE
            DO 770 K = I + 1, I + KBT
               DO 750 J = K, I + KBT
                  AB( J-K+1, K ) = AB( J-K+1, K ) -
     $                             BB( J-I+1, I )*AB( K-I+1, I ) -
     $                             BB( K-I+1, I )*AB( J-I+1, I ) +
     $                             AB( 1, I )*BB( J-I+1, I )*
     $                             BB( K-I+1, I )
  750          CONTINUE
               DO 760 J = I + KBT + 1, MIN( N, I+KA )
                  AB( J-K+1, K ) = AB( J-K+1, K ) -
     $                             BB( K-I+1, I )*AB( J-I+1, I )
  760          CONTINUE
  770       CONTINUE
            DO 790 J = I1, I
               DO 780 K = I + 1, MIN( J+KA, I+KBT )
                  AB( K-J+1, J ) = AB( K-J+1, J ) -
     $                             BB( K-I+1, I )*AB( I-J+1, J )
  780          CONTINUE
  790       CONTINUE
*
            IF( WANTX ) THEN
*
*              post-multiply X by inv(S(i))
*
               CALL DSCAL( NX, ONE / BII, X( 1, I ), 1 )
               IF( KBT.GT.0 )
     $            CALL DGER( NX, KBT, -ONE, X( 1, I ), 1, BB( 2, I ), 1,
     $                       X( 1, I+1 ), LDX )
            END IF
*
*           store a(i,i1) in RA1 for use in next loop over K
*
            RA1 = AB( I-I1+1, I1 )
         END IF
*
*        Generate and apply vectors of rotations to chase all the
*        existing bulges KA positions up toward the top of the band
*
         DO 840 K = 1, KB - 1
            IF( UPDATE ) THEN
*
*              Determine the rotations which would annihilate the bulge
*              which has in theory just been created
*
               IF( I+K-KA1.GT.0 .AND. I+K.LT.M ) THEN
*
*                 generate rotation to annihilate a(i,i+k-ka-1)
*
                  CALL DLARTG( AB( KA1-K, I+K-KA ), RA1,
     $                         WORK( N+I+K-KA ), WORK( I+K-KA ), RA )
*
*                 create nonzero element a(i+k,i+k-ka-1) outside the
*                 band and store it in WORK(m-kb+i+k)
*
                  T = -BB( K+1, I )*RA1
                  WORK( M-KB+I+K ) = WORK( N+I+K-KA )*T -
     $                               WORK( I+K-KA )*AB( KA1, I+K-KA )
                  AB( KA1, I+K-KA ) = WORK( I+K-KA )*T +
     $                                WORK( N+I+K-KA )*AB( KA1, I+K-KA )
                  RA1 = RA
               END IF
            END IF
            J2 = I + K + 1 - MAX( 1, K+I0-M+1 )*KA1
            NR = ( J2+KA-1 ) / KA1
            J1 = J2 - ( NR-1 )*KA1
            IF( UPDATE ) THEN
               J2T = MIN( J2, I-2*KA+K-1 )
            ELSE
               J2T = J2
            END IF
            NRT = ( J2T+KA-1 ) / KA1
            DO 800 J = J1, J2T, KA1
*
*              create nonzero element a(j+ka,j-1) outside the band
*              and store it in WORK(j)
*
               WORK( J ) = WORK( J )*AB( KA1, J-1 )
               AB( KA1, J-1 ) = WORK( N+J )*AB( KA1, J-1 )
  800       CONTINUE
*
*           generate rotations in 1st set to annihilate elements which
*           have been created outside the band
*
            IF( NRT.GT.0 )
     $         CALL DLARGV( NRT, AB( KA1, J1 ), INCA, WORK( J1 ), KA1,
     $                      WORK( N+J1 ), KA1 )
            IF( NR.GT.0 ) THEN
*
*              apply rotations in 1st set from the right
*
               DO 810 L = 1, KA - 1
                  CALL DLARTV( NR, AB( L+1, J1 ), INCA, AB( L+2, J1-1 ),
     $                         INCA, WORK( N+J1 ), WORK( J1 ), KA1 )
  810          CONTINUE
*
*              apply rotations in 1st set from both sides to diagonal
*              blocks
*
               CALL DLAR2V( NR, AB( 1, J1 ), AB( 1, J1-1 ),
     $                      AB( 2, J1-1 ), INCA, WORK( N+J1 ),
     $                      WORK( J1 ), KA1 )
*
            END IF
*
*           start applying rotations in 1st set from the left
*
            DO 820 L = KA - 1, KB - K + 1, -1
               NRT = ( J2+L-1 ) / KA1
               J1T = J2 - ( NRT-1 )*KA1
               IF( NRT.GT.0 )
     $            CALL DLARTV( NRT, AB( KA1-L+1, J1T-KA1+L ), INCA,
     $                         AB( KA1-L, J1T-KA1+L ), INCA,
     $                         WORK( N+J1T ), WORK( J1T ), KA1 )
  820       CONTINUE
*
            IF( WANTX ) THEN
*
*              post-multiply X by product of rotations in 1st set
*
               DO 830 J = J1, J2, KA1
                  CALL DROT( NX, X( 1, J ), 1, X( 1, J-1 ), 1,
     $                       WORK( N+J ), WORK( J ) )
  830          CONTINUE
            END IF
  840    CONTINUE
*
         IF( UPDATE ) THEN
            IF( I2.GT.0 .AND. KBT.GT.0 ) THEN
*
*              create nonzero element a(i+kbt,i+kbt-ka-1) outside the
*              band and store it in WORK(m-kb+i+kbt)
*
               WORK( M-KB+I+KBT ) = -BB( KBT+1, I )*RA1
            END IF
         END IF
*
         DO 880 K = KB, 1, -1
            IF( UPDATE ) THEN
               J2 = I + K + 1 - MAX( 2, K+I0-M )*KA1
            ELSE
               J2 = I + K + 1 - MAX( 1, K+I0-M )*KA1
            END IF
*
*           finish applying rotations in 2nd set from the left
*
            DO 850 L = KB - K, 1, -1
               NRT = ( J2+KA+L-1 ) / KA1
               J1T = J2 - ( NRT-1 )*KA1
               IF( NRT.GT.0 )
     $            CALL DLARTV( NRT, AB( KA1-L+1, J1T+L-1 ), INCA,
     $                         AB( KA1-L, J1T+L-1 ), INCA,
     $                         WORK( N+M-KB+J1T+KA ),
     $                         WORK( M-KB+J1T+KA ), KA1 )
  850       CONTINUE
            NR = ( J2+KA-1 ) / KA1
            J1 = J2 - ( NR-1 )*KA1
            DO 860 J = J1, J2, KA1
               WORK( M-KB+J ) = WORK( M-KB+J+KA )
               WORK( N+M-KB+J ) = WORK( N+M-KB+J+KA )
  860       CONTINUE
            DO 870 J = J1, J2, KA1
*
*              create nonzero element a(j+ka,j-1) outside the band
*              and store it in WORK(m-kb+j)
*
               WORK( M-KB+J ) = WORK( M-KB+J )*AB( KA1, J-1 )
               AB( KA1, J-1 ) = WORK( N+M-KB+J )*AB( KA1, J-1 )
  870       CONTINUE
            IF( UPDATE ) THEN
               IF( I+K.GT.KA1 .AND. K.LE.KBT )
     $            WORK( M-KB+I+K-KA ) = WORK( M-KB+I+K )
            END IF
  880    CONTINUE
*
         DO 920 K = KB, 1, -1
            J2 = I + K + 1 - MAX( 1, K+I0-M )*KA1
            NR = ( J2+KA-1 ) / KA1
            J1 = J2 - ( NR-1 )*KA1
            IF( NR.GT.0 ) THEN
*
*              generate rotations in 2nd set to annihilate elements
*              which have been created outside the band
*
               CALL DLARGV( NR, AB( KA1, J1 ), INCA, WORK( M-KB+J1 ),
     $                      KA1, WORK( N+M-KB+J1 ), KA1 )
*
*              apply rotations in 2nd set from the right
*
               DO 890 L = 1, KA - 1
                  CALL DLARTV( NR, AB( L+1, J1 ), INCA, AB( L+2, J1-1 ),
     $                         INCA, WORK( N+M-KB+J1 ), WORK( M-KB+J1 ),
     $                         KA1 )
  890          CONTINUE
*
*              apply rotations in 2nd set from both sides to diagonal
*              blocks
*
               CALL DLAR2V( NR, AB( 1, J1 ), AB( 1, J1-1 ),
     $                      AB( 2, J1-1 ), INCA, WORK( N+M-KB+J1 ),
     $                      WORK( M-KB+J1 ), KA1 )
*
            END IF
*
*           start applying rotations in 2nd set from the left
*
            DO 900 L = KA - 1, KB - K + 1, -1
               NRT = ( J2+L-1 ) / KA1
               J1T = J2 - ( NRT-1 )*KA1
               IF( NRT.GT.0 )
     $            CALL DLARTV( NRT, AB( KA1-L+1, J1T-KA1+L ), INCA,
     $                         AB( KA1-L, J1T-KA1+L ), INCA,
     $                         WORK( N+M-KB+J1T ), WORK( M-KB+J1T ),
     $                         KA1 )
  900       CONTINUE
*
            IF( WANTX ) THEN
*
*              post-multiply X by product of rotations in 2nd set
*
               DO 910 J = J1, J2, KA1
                  CALL DROT( NX, X( 1, J ), 1, X( 1, J-1 ), 1,
     $                       WORK( N+M-KB+J ), WORK( M-KB+J ) )
  910          CONTINUE
            END IF
  920    CONTINUE
*
         DO 940 K = 1, KB - 1
            J2 = I + K + 1 - MAX( 1, K+I0-M+1 )*KA1
*
*           finish applying rotations in 1st set from the left
*
            DO 930 L = KB - K, 1, -1
               NRT = ( J2+L-1 ) / KA1
               J1T = J2 - ( NRT-1 )*KA1
               IF( NRT.GT.0 )
     $            CALL DLARTV( NRT, AB( KA1-L+1, J1T-KA1+L ), INCA,
     $                         AB( KA1-L, J1T-KA1+L ), INCA,
     $                         WORK( N+J1T ), WORK( J1T ), KA1 )
  930       CONTINUE
  940    CONTINUE
*
         IF( KB.GT.1 ) THEN
            DO 950 J = 2, MIN( I+KB, M ) - 2*KA - 1
               WORK( N+J ) = WORK( N+J+KA )
               WORK( J ) = WORK( J+KA )
  950       CONTINUE
         END IF
*
      END IF
*
      GO TO 490
*
*     End of DSBGST
*
      END

      SUBROUTINE DSPTRD( UPLO, N, AP, D, E, TAU, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     March 31, 1993
*
*     .. Scalar Arguments ..
      CHARACTER          UPLO
      INTEGER            INFO, N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   AP( * ), D( * ), E( * ), TAU( * )
*     ..
*
*  Purpose
*  =======
*
*  DSPTRD reduces a real symmetric matrix A stored in packed form to
*  symmetric tridiagonal form T by an orthogonal similarity
*  transformation: Q**T * A * Q = T.
*
*  Arguments
*  =========
*
*  UPLO    (input) CHARACTER*1
*          = 'U':  Upper triangle of A is stored;
*          = 'L':  Lower triangle of A is stored.
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  AP      (input/output) DOUBLE PRECISION array, dimension (N*(N+1)/2)
*          On entry, the upper or lower triangle of the symmetric matrix
*          A, packed columnwise in a linear array.  The j-th column of A
*          is stored in the array AP as follows:
*          if UPLO = 'U', AP(i + (j-1)*j/2) = A(i,j) for 1<=i<=j;
*          if UPLO = 'L', AP(i + (j-1)*(2*n-j)/2) = A(i,j) for j<=i<=n.
*          On exit, if UPLO = 'U', the diagonal and first superdiagonal
*          of A are overwritten by the corresponding elements of the
*          tridiagonal matrix T, and the elements above the first
*          superdiagonal, with the array TAU, represent the orthogonal
*          matrix Q as a product of elementary reflectors; if UPLO
*          = 'L', the diagonal and first subdiagonal of A are over-
*          written by the corresponding elements of the tridiagonal
*          matrix T, and the elements below the first subdiagonal, with
*          the array TAU, represent the orthogonal matrix Q as a product
*          of elementary reflectors. See Further Details.
*
*  D       (output) DOUBLE PRECISION array, dimension (N)
*          The diagonal elements of the tridiagonal matrix T:
*          D(i) = A(i,i).
*
*  E       (output) DOUBLE PRECISION array, dimension (N-1)
*          The off-diagonal elements of the tridiagonal matrix T:
*          E(i) = A(i,i+1) if UPLO = 'U', E(i) = A(i+1,i) if UPLO = 'L'.
*
*  TAU     (output) DOUBLE PRECISION array, dimension (N-1)
*          The scalar factors of the elementary reflectors (see Further
*          Details).
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*
*  Further Details
*  ===============
*
*  If UPLO = 'U', the matrix Q is represented as a product of elementary
*  reflectors
*
*     Q = H(n-1) . . . H(2) H(1).
*
*  Each H(i) has the form
*
*     H(i) = I - tau * v * v'
*
*  where tau is a real scalar, and v is a real vector with
*  v(i+1:n) = 0 and v(i) = 1; v(1:i-1) is stored on exit in AP,
*  overwriting A(1:i-1,i+1), and tau is stored in TAU(i).
*
*  If UPLO = 'L', the matrix Q is represented as a product of elementary
*  reflectors
*
*     Q = H(1) H(2) . . . H(n-1).
*
*  Each H(i) has the form
*
*     H(i) = I - tau * v * v'
*
*  where tau is a real scalar, and v is a real vector with
*  v(1:i) = 0 and v(i+1) = 1; v(i+2:n) is stored on exit in AP,
*  overwriting A(i+2:n,i), and tau is stored in TAU(i).
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ONE, ZERO, HALF
      PARAMETER          ( ONE = 1.0D0, ZERO = 0.0D0,
     $                   HALF = 1.0D0 / 2.0D0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            UPPER
      INTEGER            I, I1, I1I1, II
      DOUBLE PRECISION   ALPHA, TAUI
*     ..
*     .. External Subroutines ..
      EXTERNAL           DAXPY, DLARFG, DSPMV, DSPR2, XERBLA
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      DOUBLE PRECISION   DDOT
      EXTERNAL           LSAME, DDOT
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters
*
      INFO = 0
      UPPER = LSAME( UPLO, 'U' )
      IF( .NOT.UPPER .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DSPTRD', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.LE.0 )
     $   RETURN
*
      IF( UPPER ) THEN
*
*        Reduce the upper triangle of A.
*        I1 is the index in AP of A(1,I+1).
*
         I1 = N*( N-1 ) / 2 + 1
         DO 10 I = N - 1, 1, -1
*
*           Generate elementary reflector H(i) = I - tau * v * v'
*           to annihilate A(1:i-1,i+1)
*
            CALL DLARFG( I, AP( I1+I-1 ), AP( I1 ), 1, TAUI )
            E( I ) = AP( I1+I-1 )
*
            IF( TAUI.NE.ZERO ) THEN
*
*              Apply H(i) from both sides to A(1:i,1:i)
*
               AP( I1+I-1 ) = ONE
*
*              Compute  y := tau * A * v  storing y in TAU(1:i)
*
               CALL DSPMV( UPLO, I, TAUI, AP, AP( I1 ), 1, ZERO, TAU,
     $                     1 )
*
*              Compute  w := y - 1/2 * tau * (y'*v) * v
*
               ALPHA = -HALF*TAUI*DDOT( I, TAU, 1, AP( I1 ), 1 )
               CALL DAXPY( I, ALPHA, AP( I1 ), 1, TAU, 1 )
*
*              Apply the transformation as a rank-2 update:
*                 A := A - v * w' - w * v'
*
               CALL DSPR2( UPLO, I, -ONE, AP( I1 ), 1, TAU, 1, AP )
*
               AP( I1+I-1 ) = E( I )
            END IF
            D( I+1 ) = AP( I1+I )
            TAU( I ) = TAUI
            I1 = I1 - I
   10    CONTINUE
         D( 1 ) = AP( 1 )
      ELSE
*
*        Reduce the lower triangle of A. II is the index in AP of
*        A(i,i) and I1I1 is the index of A(i+1,i+1).
*
         II = 1
         DO 20 I = 1, N - 1
            I1I1 = II + N - I + 1
*
*           Generate elementary reflector H(i) = I - tau * v * v'
*           to annihilate A(i+2:n,i)
*
            CALL DLARFG( N-I, AP( II+1 ), AP( II+2 ), 1, TAUI )
            E( I ) = AP( II+1 )
*
            IF( TAUI.NE.ZERO ) THEN
*
*              Apply H(i) from both sides to A(i+1:n,i+1:n)
*
               AP( II+1 ) = ONE
*
*              Compute  y := tau * A * v  storing y in TAU(i:n-1)
*
               CALL DSPMV( UPLO, N-I, TAUI, AP( I1I1 ), AP( II+1 ), 1,
     $                     ZERO, TAU( I ), 1 )
*
*              Compute  w := y - 1/2 * tau * (y'*v) * v
*
               ALPHA = -HALF*TAUI*DDOT( N-I, TAU( I ), 1, AP( II+1 ),
     $                 1 )
               CALL DAXPY( N-I, ALPHA, AP( II+1 ), 1, TAU( I ), 1 )
*
*              Apply the transformation as a rank-2 update:
*                 A := A - v * w' - w * v'
*
               CALL DSPR2( UPLO, N-I, -ONE, AP( II+1 ), 1, TAU( I ), 1,
     $                     AP( I1I1 ) )
*
               AP( II+1 ) = E( I )
            END IF
            D( I ) = AP( II )
            TAU( I ) = TAUI
            II = I1I1
   20    CONTINUE
         D( N ) = AP( II )
      END IF
*
      RETURN
*
*     End of DSPTRD
*
      END

      PROGRAM TESTIT
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.  Use one
C of the following:
C
C       PARAMETER (IERF=6,LUNI=2,IWTY=1 ,IWID=1)  !  NCGM
C       PARAMETER (IERF=6,LUNI=2,IWTY=8 ,IWID=1)  !  X Windows
C       PARAMETER (IERF=6,LUNI=2,IWTY=20,IWID=1)  !  PostScript
C       PARAMETER (IERF=6,LUNI=2,IWTY=11,IWID=1)  !  PDF, Portrait
C       PARAMETER (IERF=6,LUNI=2,IWTY=12,IWID=1)  !  PDF, Landscape
C
        PARAMETER (IERF=6,LUNI=2,IWTYPE=1,IWTY=IWTYPE,IWID=1)
C
C This program draws three frames comparing the geodesic grids used in
C the CONPACKT examples "ctgeo2", which was generated mathematically at
C NCAR, and "ctgeo3", which was generated mathematically elsewhere and
C massaged in some fashion to make the triangles all be more nearly the
C same size; the data for "ctgeo3" were downloaded from this Web site:
C
C   http://kiwi.atmos.colostate.edu:16080/BUGS/projects/geodesic/
C
C The first frame shows: in red, the five- or six-sided polygonal
C patches of the "ctgeo3" example; in green, the triangles resulting
C from connecting the center points of adjacent patches; and, in blue,
C the mathematically-generated triangles of the "ctgeo2" example.  Use
C "idt" to zoom in on this frame and compare the triangles in different
C areas
C
C The second frame shows a histogram of the areas of the triangles of
C example "ctgeo2", to be compared to the histogram on the third frame.
C
C The third frame shows a histogram of the areas of the triangles of
C example "ctgeo3".  Note how much more tightly they are grouped.
C
C Define the number of segments into which each edge of the icosahedron
C is to be divided and the number of triangles that result.
C
        PARAMETER (NDIV=16,NTRI=20*NDIV*NDIV+1)
C
C Declare a common block with a variable we can use to make AUTOGRAPH
C use PLCHHQ.
C
        COMMON /PSSFLG/ IFLG
C
C Declare arrays into which to read the geodesic data.
C
        DIMENSION VLAT(2562),VLON(2562)
        DIMENSION XCOV(2562),YCOV(2562),ZCOV(2562)
        DIMENSION CLAT(6,2562),CLON(6,2562)
        DIMENSION IADJ(2562,6)
        DIMENSION IWRK(2562)
C
C Declare an array in which to get the prime factors of an integer.
C
        DIMENSION IFOI(32)
C
C Declare arrays in which to put information about triangles resulting
C from my elaboration of the icosahedron.
C
        DIMENSION XTRI(3,NTRI),YTRI(3,NTRI),ZTRI(3,NTRI)
        DIMENSION TLAT(3,NTRI),TLON(3,NTRI)
        DIMENSION AREA(NTRI),BREA(15372)
C
C Declare arrays needed to create a histogram of the distribution of
C triangle areas.
C
        PARAMETER (NBNS= 120,RBNS=NBNS)
C       PARAMETER (NBNS=1000,RBNS=NBNS)
        DIMENSION XCEN(NBNS),YCEN(NBNS),ZERO(NBNS)
        DIMENSION XCRD(4),YCRD(4)
C
C Declare a variable to hold a label for the histogram plots.
C
        CHARACTER*48 LABL
C
C Declare arrays to hold information describing an icosahedron.
C
        DIMENSION IFCE(3,20),XCVI(12),YCVI(12),ZCVI(12)
C
C Declare a character variable for labelling purposes.
C
        CHARACTER*6 DIGT
C
C Define the 20 faces of an icosahedron (pointers to vertices).
C
        DATA IFCE(1, 1),IFCE(2, 1),IFCE(3, 1) /  1, 3, 5 /
        DATA IFCE(1, 2),IFCE(2, 2),IFCE(3, 2) /  1, 5, 7 /
        DATA IFCE(1, 3),IFCE(2, 3),IFCE(3, 3) /  1, 7, 9 /
        DATA IFCE(1, 4),IFCE(2, 4),IFCE(3, 4) /  1, 9,11 /
        DATA IFCE(1, 5),IFCE(2, 5),IFCE(3, 5) /  1, 3,11 /
        DATA IFCE(1, 6),IFCE(2, 6),IFCE(3, 6) /  3, 8,11 /
        DATA IFCE(1, 7),IFCE(2, 7),IFCE(3, 7) /  3, 8,10 /
        DATA IFCE(1, 8),IFCE(2, 8),IFCE(3, 8) /  3, 5,10 /
        DATA IFCE(1, 9),IFCE(2, 9),IFCE(3, 9) /  5,10,12 /
        DATA IFCE(1,10),IFCE(2,10),IFCE(3,10) /  5, 7,12 /
        DATA IFCE(1,11),IFCE(2,11),IFCE(3,11) /  4, 7,12 /
        DATA IFCE(1,12),IFCE(2,12),IFCE(3,12) /  4, 7, 9 /
        DATA IFCE(1,13),IFCE(2,13),IFCE(3,13) /  4, 6, 9 /
        DATA IFCE(1,14),IFCE(2,14),IFCE(3,14) /  6, 9,11 /
        DATA IFCE(1,15),IFCE(2,15),IFCE(3,15) /  6, 8,11 /
        DATA IFCE(1,16),IFCE(2,16),IFCE(3,16) /  2, 6, 8 /
        DATA IFCE(1,17),IFCE(2,17),IFCE(3,17) /  2, 4, 6 /
        DATA IFCE(1,18),IFCE(2,18),IFCE(3,18) /  2, 4,12 /
        DATA IFCE(1,19),IFCE(2,19),IFCE(3,19) /  2,10,12 /
        DATA IFCE(1,20),IFCE(2,20),IFCE(3,20) /  2, 8,10 /
C
C Define the 12 vertices of an icosahedron (note radius less than one).
C
        DATA XCVI / .0000000000000 ,  .0000000000000 , -.8506508083520 ,
     +              .8506508083520 , -.2628655560596 ,  .2628655560596 ,
     +              .6881909602356 , -.6881909602356 ,  .6881909602356 ,
     +             -.6881909602356 , -.2628655560595 ,  .2628655560596 /
        DATA YCVI / .0000000000000 ,  .0000000000000 ,  .0000000000000 ,
     +              .0000000000000 , -.8090169943749 ,  .8090169943749 ,
     +             -.5000000000000 ,  .5000000000000 ,  .5000000000000 ,
     +             -.5000000000000 ,  .8090169943749 , -.8090169943749 /
        DATA ZCVI / .9510565162952 , -.9510565162951 ,  .4253254041760 ,
     +             -.4253254041760 ,  .4253254041760 , -.4253254041760 ,
     +              .4253254041760 , -.4253254041760 ,  .4253254041760 ,
     +             -.4253254041760 ,  .4253254041760 , -.4253254041760 /
C
C Define a label for the histogram plots.
C
        DATA LABL / 'HISTOGRAM OF TRIANGLE AREAS (ctgeox)   xxxx BINS' /
C
C Conversion factor, radians to degrees.
C
        DATA RTOD / 57.2957795130823D0 /
C
C Value of pi.
C
        DATA PI   / 3.14159265358979 /
C
C Define characters for labeling.
C
        DATA DIGT / '123456' /
C
C Define minimum and maximum values for X and Y on the histograms.
C
        DATA XMIN,XMAX / .85 , 1.25 /
        DATA YMIN,YMAX /  0. ,  .35 /
C
C Read required data from the ASCII file "ctgeo3.dat", which is actually
C associated with the CONPACKT example "ctgeo3".
C
        OPEN (11,FILE='ctgeo3.dat',STATUS='OLD',FORM='FORMATTED')
C
        READ (11,'(5E16.8)') VLAT
        READ (11,'(5E16.8)') VLON
        READ (11,'(5E16.8)') (ZDAT,I=1,2562)
        READ (11,'(5E16.8)') CLAT
        READ (11,'(5E16.8)') CLON
        READ (11,'(  10I8)') (IOLF,I=1,2562)
C
        CLOSE (11)
C
C Convert the latitudes and longitudes of the mesh points to degrees,
C compute equivalent X, Y, and Z coordinates, and eliminate duplicate
C corner points.
C
        DO 104 I=1,2562
          VLAT(I)=RTOD*VLAT(I)
          VLON(I)=RTOD*VLON(I)
          CALL LLPXYZ (VLAT(I),VLON(I),XCOV(I),YCOV(I),ZCOV(I))
          DO 101 J=1,6
            CLAT(J,I)=RTOD*CLAT(J,I)
            CLON(J,I)=RTOD*CLON(J,I)
  101     CONTINUE
          DO 103 J=1,6
            JM1=MOD(J+4,6)+1
            IF (CLAT(J,I).EQ.CLAT(JM1,I).AND.
     +          CLON(J,I).EQ.CLON(JM1,I)) THEN
              DO 102 K=J,5
                CLAT(K,I)=CLAT(K+1,I)
                CLON(K,I)=CLON(K+1,I)
  102         CONTINUE
              CLAT(6,I)=99.
              GO TO 104
            END IF
  103     CONTINUE
  104   CONTINUE
C
C Set up the adjacency index array (time-consuming brute-force method).
C This code is commented out, but I have left it here because it's a bit
C easier to read than the code that replaced it.  The idea is to examine
C each side of each of the 2562 five- or six-sided polygonal patches
C (having a center defined by VLAT(I) and VLON(I) and corners defined
C by the contents of CLAT(J,I) and CLON(J,I) for J from 1 to NOJS) and
C find a matching side in one of the other polygonal patches.  We take
C advantage of the fact that the corners are given in counterclockwise
C order.  We define the contents of an "adjacency array" so that, once
C we are done, we have the indices of the five or six neighbors of each
C of the polygonal patches.  Given this adjacency array, the triangles
C of the triangular mesh can be formed (by just connecting the center
C points of neighboring patches).
C
C       DO 108 I=1,2562
C         IF (CLAT(6,I).EQ.99.) THEN
C           IADJ(I,6)=-1
C           NOJS=5
C         ELSE
C           NOJS=6
C         END IF
C         DO 107 J=1,NOJS
C           JM1=MOD(J+NOJS-2,NOJS)+1
C           DO 106 K=1,2562
C             IF (K.NE.I) THEN
C               IF (CLAT(6,K).EQ.99.) THEN
C                 NOLS=5
C               ELSE
C                 NOLS=6
C               END IF
C               DO 105 L=1,NOLS
C                 LP1=MOD(L,NOLS)+1
C                 IF (CLAT(J  ,I).EQ.CLAT(L  ,K).AND.
C    +                CLON(J  ,I).EQ.CLON(L  ,K).AND.
C    +                CLAT(JM1,I).EQ.CLAT(LP1,K).AND.
C    +                CLON(JM1,I).EQ.CLON(LP1,K)) THEN
C                   IADJ(I,J)=K
C                   GO TO 107
C                 END IF
C 105           CONTINUE
C             END IF
C 106       CONTINUE
C 107     CONTINUE
C 108   CONTINUE
C
C Set up the adjacency index array (better method).  This is just like
C the brute-force method commented out above, but is about an order of
C magnitude faster because we order the vertices of the center points
C of the polygonal patches by latitude, making it possible to look for
C matching edges in nearby polygonal patches first.  (If we're trying
C to find a match for a side of the Ith polygonal patch (sorted order),
C we look at polygonal patches for IC = I+1, I-1, I+2, I-2, and so on,
C until we find the one we want.  If IC becomes less than 1 or greater
C than 2562, we just finish out the rest of the list by stepping through
C the remaining elements on the opposite end of it; IM implements the
C logic to manage this.
C
        CALL CTSORT (VLAT,2562,IWRK)
C
        DO 108 I=1,2562
          IF (CLAT(6,IWRK(I)).EQ.99.) THEN
            IADJ(IWRK(I),6)=-1
            NOJS=5
          ELSE
            NOJS=6
          END IF
          DO 107 J=1,NOJS
            JM1=MOD(J+NOJS-2,NOJS)+1
            IC=I
            IM=0
            DO 106 K=1,2561
              IF (IM.EQ.0) THEN
                IF (MOD(K,2).EQ.0) THEN
                  IC=IC-K
                  IF (IC.LT.1) THEN
                    IC=IC+K+1
                    IM=+1
                  END IF
                ELSE
                  IC=IC+K
                  IF (IC.GT.2562) THEN
                    IC=IC-K-1
                    IM=-1
                  END IF
                END IF
              ELSE
                IC=IC+IM
              END IF
              IF (CLAT(6,IWRK(IC)).EQ.99.) THEN
                NOLS=5
              ELSE
                NOLS=6
              END IF
              DO 105 L=1,NOLS
                LP1=MOD(L,NOLS)+1
                IF (CLAT(J  ,IWRK(I)).EQ.CLAT(L  ,IWRK(IC)).AND.
     +              CLON(J  ,IWRK(I)).EQ.CLON(L  ,IWRK(IC)).AND.
     +              CLAT(JM1,IWRK(I)).EQ.CLAT(LP1,IWRK(IC)).AND.
     +              CLON(JM1,IWRK(I)).EQ.CLON(LP1,IWRK(IC))) THEN
                  IADJ(IWRK(I),J)=IWRK(IC)
                  GO TO 107
                END IF
  105         CONTINUE
  106       CONTINUE
  107     CONTINUE
  108   CONTINUE
C
C Create a mesh using the algorithm of CONPACKT example "ctex02":
C
C First, project the vertices of the icosahedron out onto the surface
C of a sphere of radius 1.
C
        DO 109 I=1,12
          DNOM=SQRT(XCVI(I)*XCVI(I)+YCVI(I)*YCVI(I)+ZCVI(I)*ZCVI(I))
          XCVI(I)=XCVI(I)/DNOM
          YCVI(I)=YCVI(I)/DNOM
          ZCVI(I)=ZCVI(I)/DNOM
  109   CONTINUE
C
C Next, define the twenty initial triangles of the icosahedron to be
C subdivided.
C
        KTRI=0
C
        DO 110 I=1,20
          KTRI=KTRI+1
          XTRI(1,KTRI)=XCVI(IFCE(1,I))
          YTRI(1,KTRI)=YCVI(IFCE(1,I))
          ZTRI(1,KTRI)=ZCVI(IFCE(1,I))
          XTRI(2,KTRI)=XCVI(IFCE(2,I))
          YTRI(2,KTRI)=YCVI(IFCE(2,I))
          ZTRI(2,KTRI)=ZCVI(IFCE(2,I))
          XTRI(3,KTRI)=XCVI(IFCE(3,I))
          YTRI(3,KTRI)=YCVI(IFCE(3,I))
          ZTRI(3,KTRI)=ZCVI(IFCE(3,I))
  110   CONTINUE
C
C Then, get the prime factors of the number NDIV, which says how many
C segments each edge of the icosahedron will be divided into.
C
        CALL FACTOR (NDIV,IFOI,NFOI)
C
C Loop on the array of prime factors, subdividing the triangles as
C dictatate by them.
C
        DO 114 I=1,NFOI
C
          PRINT '(''PRIME FACTOR:'',I4)' , IFOI(I)
C
          DO 113 J=1,KTRI
C
            DO 112 K=0,IFOI(I)-1
C
              DO 111 L=0,2*(IFOI(I)-K-1)
C
                IF (KTRI.GE.NTRI) THEN
                  PRINT * , 'STOP - KTRI.GE.NTRI'
                  STOP
                END IF
C
                KTRI=KTRI+1
C
                IF (MOD(L,2).EQ.0) THEN
C
                  XTRI(1,KTRI)=
     +                     (REAL(IFOI(I)-K-L/2  )/REAL(IFOI(I)-K  ))*
     +                    ((REAL(IFOI(I)-K  )/REAL(IFOI(I)))*XTRI(1,J)+
     +                     (REAL(        K  )/REAL(IFOI(I)))*XTRI(3,J))+
     +                     (REAL(          L/2  )/REAL(IFOI(I)-K  ))*
     +                    ((REAL(IFOI(I)-K  )/REAL(IFOI(I)))*XTRI(2,J)+
     +                     (REAL(        K  )/REAL(IFOI(I)))*XTRI(3,J))
                  YTRI(1,KTRI)=
     +                     (REAL(IFOI(I)-K-L/2  )/REAL(IFOI(I)-K  ))*
     +                    ((REAL(IFOI(I)-K  )/REAL(IFOI(I)))*YTRI(1,J)+
     +                     (REAL(        K  )/REAL(IFOI(I)))*YTRI(3,J))+
     +                     (REAL(          L/2  )/REAL(IFOI(I)-K  ))*
     +                    ((REAL(IFOI(I)-K  )/REAL(IFOI(I)))*YTRI(2,J)+
     +                     (REAL(        K  )/REAL(IFOI(I)))*YTRI(3,J))
                  ZTRI(1,KTRI)=
     +                     (REAL(IFOI(I)-K-L/2  )/REAL(IFOI(I)-K  ))*
     +                    ((REAL(IFOI(I)-K  )/REAL(IFOI(I)))*ZTRI(1,J)+
     +                     (REAL(        K  )/REAL(IFOI(I)))*ZTRI(3,J))+
     +                     (REAL(          L/2  )/REAL(IFOI(I)-K  ))*
     +                    ((REAL(IFOI(I)-K  )/REAL(IFOI(I)))*ZTRI(2,J)+
     +                     (REAL(        K  )/REAL(IFOI(I)))*ZTRI(3,J))
C
                  XTRI(2,KTRI)=
     +                     (REAL(IFOI(I)-K-L/2-1)/REAL(IFOI(I)-K  ))*
     +                    ((REAL(IFOI(I)-K  )/REAL(IFOI(I)))*XTRI(1,J)+
     +                     (REAL(        K  )/REAL(IFOI(I)))*XTRI(3,J))+
     +                     (REAL(          L/2+1)/REAL(IFOI(I)-K  ))*
     +                    ((REAL(IFOI(I)-K  )/REAL(IFOI(I)))*XTRI(2,J)+
     +                     (REAL(        K  )/REAL(IFOI(I)))*XTRI(3,J))
                  YTRI(2,KTRI)=
     +                     (REAL(IFOI(I)-K-L/2-1)/REAL(IFOI(I)-K  ))*
     +                    ((REAL(IFOI(I)-K  )/REAL(IFOI(I)))*YTRI(1,J)+
     +                     (REAL(        K  )/REAL(IFOI(I)))*YTRI(3,J))+
     +                     (REAL(          L/2+1)/REAL(IFOI(I)-K  ))*
     +                    ((REAL(IFOI(I)-K  )/REAL(IFOI(I)))*YTRI(2,J)+
     +                     (REAL(        K  )/REAL(IFOI(I)))*YTRI(3,J))
                  ZTRI(2,KTRI)=
     +                     (REAL(IFOI(I)-K-L/2-1)/REAL(IFOI(I)-K  ))*
     +                    ((REAL(IFOI(I)-K  )/REAL(IFOI(I)))*ZTRI(1,J)+
     +                     (REAL(        K  )/REAL(IFOI(I)))*ZTRI(3,J))+
     +                     (REAL(          L/2+1)/REAL(IFOI(I)-K  ))*
     +                    ((REAL(IFOI(I)-K  )/REAL(IFOI(I)))*ZTRI(2,J)+
     +                     (REAL(        K  )/REAL(IFOI(I)))*ZTRI(3,J))
C
                  IF (IFOI(I)-K-1.NE.0) THEN
C
                    XTRI(3,KTRI)=
     +                     (REAL(IFOI(I)-K-L/2-1)/REAL(IFOI(I)-K-1))*
     +                    ((REAL(IFOI(I)-K-1)/REAL(IFOI(I)))*XTRI(1,J)+
     +                     (REAL(        K+1)/REAL(IFOI(I)))*XTRI(3,J))+
     +                     (REAL(          L/2  )/REAL(IFOI(I)-K-1))*
     +                    ((REAL(IFOI(I)-K-1)/REAL(IFOI(I)))*XTRI(2,J)+
     +                     (REAL(        K+1)/REAL(IFOI(I)))*XTRI(3,J))
                    YTRI(3,KTRI)=
     +                     (REAL(IFOI(I)-K-L/2-1)/REAL(IFOI(I)-K-1))*
     +                    ((REAL(IFOI(I)-K-1)/REAL(IFOI(I)))*YTRI(1,J)+
     +                     (REAL(        K+1)/REAL(IFOI(I)))*YTRI(3,J))+
     +                     (REAL(          L/2  )/REAL(IFOI(I)-K-1))*
     +                    ((REAL(IFOI(I)-K-1)/REAL(IFOI(I)))*YTRI(2,J)+
     +                     (REAL(        K+1)/REAL(IFOI(I)))*YTRI(3,J))
                    ZTRI(3,KTRI)=
     +                     (REAL(IFOI(I)-K-L/2-1)/REAL(IFOI(I)-K-1))*
     +                    ((REAL(IFOI(I)-K-1)/REAL(IFOI(I)))*ZTRI(1,J)+
     +                     (REAL(        K+1)/REAL(IFOI(I)))*ZTRI(3,J))+
     +                     (REAL(          L/2  )/REAL(IFOI(I)-K-1))*
     +                    ((REAL(IFOI(I)-K-1)/REAL(IFOI(I)))*ZTRI(2,J)+
     +                     (REAL(        K+1)/REAL(IFOI(I)))*ZTRI(3,J))
C
                  ELSE
C
                    XTRI(3,KTRI)=XTRI(3,J)
                    YTRI(3,KTRI)=YTRI(3,J)
                    ZTRI(3,KTRI)=ZTRI(3,J)
C
                  END IF
C
                ELSE
C
                  XTRI(1,KTRI)=
     +                     (REAL(IFOI(I)-K-L/2-1)/REAL(IFOI(I)-K-1))*
     +                    ((REAL(IFOI(I)-K-1)/REAL(IFOI(I)))*XTRI(1,J)+
     +                     (REAL(        K+1)/REAL(IFOI(I)))*XTRI(3,J))+
     +                     (REAL(          L/2  )/REAL(IFOI(I)-K-1))*
     +                    ((REAL(IFOI(I)-K-1)/REAL(IFOI(I)))*XTRI(2,J)+
     +                     (REAL(        K+1)/REAL(IFOI(I)))*XTRI(3,J))
                  YTRI(1,KTRI)=
     +                     (REAL(IFOI(I)-K-L/2-1)/REAL(IFOI(I)-K-1))*
     +                    ((REAL(IFOI(I)-K-1)/REAL(IFOI(I)))*YTRI(1,J)+
     +                     (REAL(        K+1)/REAL(IFOI(I)))*YTRI(3,J))+
     +                     (REAL(          L/2  )/REAL(IFOI(I)-K-1))*
     +                    ((REAL(IFOI(I)-K-1)/REAL(IFOI(I)))*YTRI(2,J)+
     +                     (REAL(        K+1)/REAL(IFOI(I)))*YTRI(3,J))
                  ZTRI(1,KTRI)=
     +                     (REAL(IFOI(I)-K-L/2-1)/REAL(IFOI(I)-K-1))*
     +                    ((REAL(IFOI(I)-K-1)/REAL(IFOI(I)))*ZTRI(1,J)+
     +                     (REAL(        K+1)/REAL(IFOI(I)))*ZTRI(3,J))+
     +                     (REAL(          L/2  )/REAL(IFOI(I)-K-1))*
     +                    ((REAL(IFOI(I)-K-1)/REAL(IFOI(I)))*ZTRI(2,J)+
     +                     (REAL(        K+1)/REAL(IFOI(I)))*ZTRI(3,J))
C
                  XTRI(2,KTRI)=
     +                     (REAL(IFOI(I)-K-L/2-2)/REAL(IFOI(I)-K-1))*
     +                    ((REAL(IFOI(I)-K-1)/REAL(IFOI(I)))*XTRI(1,J)+
     +                     (REAL(        K+1)/REAL(IFOI(I)))*XTRI(3,J))+
     +                     (REAL(          L/2+1)/REAL(IFOI(I)-K-1))*
     +                    ((REAL(IFOI(I)-K-1)/REAL(IFOI(I)))*XTRI(2,J)+
     +                     (REAL(        K+1)/REAL(IFOI(I)))*XTRI(3,J))
                  YTRI(2,KTRI)=
     +                     (REAL(IFOI(I)-K-L/2-2)/REAL(IFOI(I)-K-1))*
     +                    ((REAL(IFOI(I)-K-1)/REAL(IFOI(I)))*YTRI(1,J)+
     +                     (REAL(        K+1)/REAL(IFOI(I)))*YTRI(3,J))+
     +                     (REAL(          L/2+1)/REAL(IFOI(I)-K-1))*
     +                    ((REAL(IFOI(I)-K-1)/REAL(IFOI(I)))*YTRI(2,J)+
     +                     (REAL(        K+1)/REAL(IFOI(I)))*YTRI(3,J))
                  ZTRI(2,KTRI)=
     +                     (REAL(IFOI(I)-K-L/2-2)/REAL(IFOI(I)-K-1))*
     +                    ((REAL(IFOI(I)-K-1)/REAL(IFOI(I)))*ZTRI(1,J)+
     +                     (REAL(        K+1)/REAL(IFOI(I)))*ZTRI(3,J))+
     +                     (REAL(          L/2+1)/REAL(IFOI(I)-K-1))*
     +                    ((REAL(IFOI(I)-K-1)/REAL(IFOI(I)))*ZTRI(2,J)+
     +                     (REAL(        K+1)/REAL(IFOI(I)))*ZTRI(3,J))
C
                  XTRI(3,KTRI)=
     +                     (REAL(IFOI(I)-K-L/2-1)/REAL(IFOI(I)-K  ))*
     +                    ((REAL(IFOI(I)-K  )/REAL(IFOI(I)))*XTRI(1,J)+
     +                     (REAL(        K  )/REAL(IFOI(I)))*XTRI(3,J))+
     +                     (REAL(          L/2+1)/REAL(IFOI(I)-K  ))*
     +                    ((REAL(IFOI(I)-K  )/REAL(IFOI(I)))*XTRI(2,J)+
     +                     (REAL(        K  )/REAL(IFOI(I)))*XTRI(3,J))
                  YTRI(3,KTRI)=
     +                     (REAL(IFOI(I)-K-L/2-1)/REAL(IFOI(I)-K  ))*
     +                    ((REAL(IFOI(I)-K  )/REAL(IFOI(I)))*YTRI(1,J)+
     +                     (REAL(        K  )/REAL(IFOI(I)))*YTRI(3,J))+
     +                     (REAL(          L/2+1)/REAL(IFOI(I)-K  ))*
     +                    ((REAL(IFOI(I)-K  )/REAL(IFOI(I)))*YTRI(2,J)+
     +                     (REAL(        K  )/REAL(IFOI(I)))*YTRI(3,J))
                  ZTRI(3,KTRI)=
     +                     (REAL(IFOI(I)-K-L/2-1)/REAL(IFOI(I)-K  ))*
     +                    ((REAL(IFOI(I)-K  )/REAL(IFOI(I)))*ZTRI(1,J)+
     +                     (REAL(        K  )/REAL(IFOI(I)))*ZTRI(3,J))+
     +                     (REAL(          L/2+1)/REAL(IFOI(I)-K  ))*
     +                    ((REAL(IFOI(I)-K  )/REAL(IFOI(I)))*ZTRI(2,J)+
     +                     (REAL(        K  )/REAL(IFOI(I)))*ZTRI(3,J))
C
                END IF
C
                DNOM=SQRT(XTRI(1,KTRI)*XTRI(1,KTRI)+
     +                    YTRI(1,KTRI)*YTRI(1,KTRI)+
     +                    ZTRI(1,KTRI)*ZTRI(1,KTRI))
                XTRI(1,KTRI)=XTRI(1,KTRI)/DNOM
                YTRI(1,KTRI)=YTRI(1,KTRI)/DNOM
                ZTRI(1,KTRI)=ZTRI(1,KTRI)/DNOM
C
                DNOM=SQRT(XTRI(2,KTRI)*XTRI(2,KTRI)+
     +                    YTRI(2,KTRI)*YTRI(2,KTRI)+
     +                    ZTRI(2,KTRI)*ZTRI(2,KTRI))
                XTRI(2,KTRI)=XTRI(2,KTRI)/DNOM
                YTRI(2,KTRI)=YTRI(2,KTRI)/DNOM
                ZTRI(2,KTRI)=ZTRI(2,KTRI)/DNOM
C
                DNOM=SQRT(XTRI(3,KTRI)*XTRI(3,KTRI)+
     +                    YTRI(3,KTRI)*YTRI(3,KTRI)+
     +                    ZTRI(3,KTRI)*ZTRI(3,KTRI))
     +
                XTRI(3,KTRI)=XTRI(3,KTRI)/DNOM
                YTRI(3,KTRI)=YTRI(3,KTRI)/DNOM
                ZTRI(3,KTRI)=ZTRI(3,KTRI)/DNOM
C
  111         CONTINUE
C
  112       CONTINUE
C
            XTRI(1,J)=XTRI(1,KTRI)
            YTRI(1,J)=YTRI(1,KTRI)
            ZTRI(1,J)=ZTRI(1,KTRI)
            XTRI(2,J)=XTRI(2,KTRI)
            YTRI(2,J)=YTRI(2,KTRI)
            ZTRI(2,J)=ZTRI(2,KTRI)
            XTRI(3,J)=XTRI(3,KTRI)
            YTRI(3,J)=YTRI(3,KTRI)
            ZTRI(3,J)=ZTRI(3,KTRI)
            KTRI=KTRI-1
C
  113     CONTINUE
C
  114   CONTINUE
C
C Open GKS.
C
        CALL GOPKS (IERR,0)
        CALL GOPWK (IWID,LUNI,IWTY)
        CALL GACWK (IWID)
C
C Turn off clipping by GKS.
C
        CALL GSCLIP (0)
C
C Define colors (0 = white, background; 1 = black, foreground; 2 =
C yellow; 3 = magenta; 4 = red; 5 = cyan; 6 = green; and 7 = blue).
C
        CALL GSCR   (IWID,0,1.,1.,1.)
        CALL GSCR   (IWID,1,0.,0.,0.)
        CALL GSCR   (IWID,2,1.,1.,0.)
        CALL GSCR   (IWID,3,1.,0.,1.)
        CALL GSCR   (IWID,4,1.,0.,0.)
        CALL GSCR   (IWID,5,0.,1.,1.)
        CALL GSCR   (IWID,6,0.,1.,0.)
        CALL GSCR   (IWID,7,0.,0.,1.)
C
C Tell PLOTCHAR to use one of the filled fonts and to outline each
C character.
C
        CALL PCSETI ('FN',25)
        CALL PCSETI ('OF',1)
C
C Tell PLOTCHAR to expect a character other than a colon as the
C function-control signal character.
C
        CALL PCSETC ('FC','|')
C
C Tell EZMAP not to draw labels or a perimeter.
C
        CALL MPSETI ('LA',0)
        CALL MPSETI ('PE',0)
C
C Do two frames, one showing the entire globe and another showing a
C "zoomed in" view of its center.
C
        DO 121 IFRA=1,2
C
C Initialize EZMAP and draw a background map.
C
          IF (IFRA.EQ.1) THEN
            CALL PLCHHQ (CFUX(.50),CFUY(.96),
     +               'GLOBAL VIEW OF MESHES FROM "ctgeo2" AND "ctgeo3"',
     +                                                       .016,0.,0.)
          ELSE
            CALL PLCHHQ (CFUX(.50),CFUY(.96),
     +               'CLOSER VIEW OF MESHES FROM "ctgeo2" AND "ctgeo3"',
     +                                                       .016,0.,0.)
          END IF
C
C Tell EZMAP where to put the map on the plotter frame.
C
          CALL MAPPOS (.10,.90,.12,.92)
C
C Tell EZMAP what projection to use.
C
          CALL MAPROJ ('OR', 45.,-45.,0.)
C
C Tell EZMAP how much of the map to show (either an entire hemisphere
C or a 40-degree field of view).
C
          IF (IFRA.EQ.1) THEN
            CALL MAPSET ('MA', 0., 0., 0., 0.)
          ELSE
            CALL MAPSET ('AN',20.,20.,20.,20.)
          END IF
C
C Draw the map.
C
          CALL MAPDRW
C
C In red, draw the pentagons and hexagons specified by the user data.
C
          CALL PLOTIT (0,0,2)
          CALL GSPLCI (4)
C
          DO 117 I=1,2562
            IF (CLAT(6,I).EQ.99.) THEN
              NOJS=5
            ELSE
              NOJS=6
            END IF
            CALL MAPIT (CLAT(NOJS,I),CLON(NOJS,I),0)
            DO 115 J=1,NOJS-1
              CALL MAPIT (CLAT(J,I),CLON(J,I),1)
  115       CONTINUE
            CALL MAPIT (CLAT(NOJS,I),CLON(NOJS,I),2)
            CALL MAPIQ
            DO 116 J=1,NOJS
              CALL FPSGCR (VLAT(I),VLON(I),CLAT(J,I),CLON(J,I),.85,
     +                                                   XLAT,XLON)
              CALL MAPTRA (XLAT,XLON,XPOS,YPOS)
              IF (XPOS.NE.1.E12) THEN
                CALL PLCHMQ (XPOS,YPOS,DIGT(J:J),.001,0.,0.)
              END IF
  116       CONTINUE
  117     CONTINUE
C
C In green, draw the triangular mesh developed from the user data.
C
          CALL PLOTIT (0,0,2)
          CALL GSPLCI (6)
C
          DO 119 I=1,2562
            DO 118 J=1,6
              IF (IADJ(I,J).GT.0) THEN
                CALL MAPIT (VLAT(I),VLON(I),0)
                CALL MAPIT (VLAT(IADJ(I,J)),VLON(IADJ(I,J)),2)
              END IF
  118       CONTINUE
  119     CONTINUE
C
C Compute the latitudes and longitudes of all the vertices and draw
C the triangles of the computed mesh of example "ctgeo2"
C
          CALL PLOTIT (0,0,2)
          CALL GSPLCI (7)
C
          AMIN=1.E36
          AMAX=-1.E36
          ASUM=0.
C
          DO 120 I=1,KTRI
            TLAT(1,I)=RTOD*ASIN (ZTRI(1,I))
            TLON(1,I)=RTOD*ATAN2(YTRI(1,I),XTRI(1,I))
            TLAT(2,I)=RTOD*ASIN (ZTRI(2,I))
            TLON(2,I)=RTOD*ATAN2(YTRI(2,I),XTRI(2,I))
            TLAT(3,I)=RTOD*ASIN (ZTRI(3,I))
            TLON(3,I)=RTOD*ATAN2(YTRI(3,I),XTRI(3,I))
            CALL MAPIT (TLAT(1,I),TLON(1,I),0)
            CALL MAPIT (TLAT(2,I),TLON(2,I),2)
            CALL MAPIT (TLAT(3,I),TLON(3,I),2)
            CALL MAPIT (TLAT(1,I),TLON(1,I),2)
  120     CONTINUE
C
          CALL PLCHHQ (CFUX(.50),CFUY(.098),'The computed triangular mes
     +h from example "ctgeo2" is in blue; the polygonal patches and the'
     +,
     +                                                       .012,0.,0.)
C
          CALL PLCHHQ (CFUX(.50),CFUY(.074), 'derived triangular mesh fr
     +om the user-provided data of "ctgeo3" are in red and green, respec
     +tively.',
     +                                                       .012,0.,0.)
C
          IF (IFRA.EQ.1) THEN
            CALL PLCHHQ (CFUX(.50),CFUY(.050),'Zoom (using "idt") to see
     + details of the meshes (also, see the next frame).',.012,0.,0.)
          ELSE
            CALL PLCHHQ (CFUX(.50),CFUY(.050),'Zoom (using "idt") to see
     + details of the meshes.',.012,0.,0.)
          END IF
C
C Label visible points of the icosahedron.
C
          CALL PLOTIT (0,0,2)
          CALL GSPLCI (1)
          CALL LBLPNT (XCVI,YCVI,ZCVI)
C
C Advance the frame.
C
          CALL FRAME
C
  121   CONTINUE
C
C Initialize AUTOGRAPH.
C
          IFLG=1
          CALL AGSETI ('FRAME.',2)
          CALL AGSETR ('GRID/LE.',.1)
          CALL AGSETR ('GRID/RI.',.9)
          CALL AGSETR ('GRID/BO.',.1)
          CALL AGSETR ('GRID/TO.',.9)
          CALL AGSETR ('X/MIN.',XMIN)
          CALL AGSETR ('X/MAX.',XMAX)
          CALL AGSETR ('Y/MIN.',YMIN)
          CALL AGSETR ('Y/MAX.',YMAX)
          CALL AGSETI ('LINE/MAX.',100)
          CALL AGSETR ('LEF/MA/OU.',0.012)
          CALL AGSETR ('LEF/MA/IN.',0.000)
          CALL AGSETR ('LEF/MI/OU.',0.008)
          CALL AGSETR ('LEF/MI/IN.',0.000)
          CALL AGSETR ('RIG/MA/OU.',0.000)
          CALL AGSETR ('RIG/MA/IN.',0.000)
          CALL AGSETR ('RIG/MI/OU.',0.000)
          CALL AGSETR ('RIG/MI/IN.',0.000)
          CALL AGSETR ('BOT/MA/OU.',0.012)
          CALL AGSETR ('BOT/MA/IN.',0.000)
          CALL AGSETR ('BOT/MI/OU.',0.008)
          CALL AGSETR ('BOT/MI/IN.',0.000)
          CALL AGSETR ('TOP/MA/OU.',0.000)
          CALL AGSETR ('TOP/MA/IN.',0.000)
          CALL AGSETR ('TOP/MI/OU.',0.000)
          CALL AGSETR ('TOP/MI/IN.',0.000)
C
          CALL ANOTAT ('AREA OF TRIANGLE (AS A FRACTION OF AVERAGE)',
     +                 'FRACTION OF TRIANGLES HAVING THAT AREA',0,0,0,0)
C
C Compute the areas of all the triangles of the computed grid and find
C the minimum, maximum, and average of the areas.
C
        AMIN=1.E36
        AMAX=-1.E36
        ASUM=0.
C
        DO 122 I=1,KTRI
          A=SQRT((XTRI(1,I)-XTRI(2,I))**2+
     +           (YTRI(1,I)-YTRI(2,I))**2+
     +           (ZTRI(1,I)-ZTRI(2,I))**2)
          B=SQRT((XTRI(2,I)-XTRI(3,I))**2+
     +           (YTRI(2,I)-YTRI(3,I))**2+
     +           (ZTRI(2,I)-ZTRI(3,I))**2)
          C=SQRT((XTRI(3,I)-XTRI(1,I))**2+
     +           (YTRI(3,I)-YTRI(1,I))**2+
     +           (ZTRI(3,I)-ZTRI(1,I))**2)
          S=.5*(A+B+C)
          AREA(I)=SQRT(S*(S-A)*(S-B)*(S-C))
          AMIN=MIN(AMIN,AREA(I))
          AMAX=MAX(AMAX,AREA(I))
          ASUM=ASUM+AREA(I)
  122   CONTINUE
C
        AVRG=ASUM/REAL(KTRI)
C
C Print the minimum, maximum, and average areas.
C
        PRINT * , ' '
        PRINT '(''COMPUTED GRID OF "ctex02"'')'
        PRINT * , ' '
        PRINT '(''TRIANGLES:    '',     I8)' , KTRI
        PRINT '(''MINIMUM AREA: '',1PE16.8)' , AMIN
        PRINT '(''MAXIMUM AREA: '',1PE16.8)' , AMAX
        PRINT '(''AVERAGE AREA: '',1PE16.8)' , AVRG
        PRINT '(''EXPECTED AVG: '',1PE16.8)' , 4.*PI/REAL(KTRI)
C
C Draw a histogram showing the distribution of areas.
C
        DO 123 I=1,NBNS
          XCEN(I)=XMIN+(REAL(I-1)+.5)*(XMAX-XMIN)/RBNS
          YCEN(I)=0.
          ZERO(I)=0.
  123   CONTINUE
C
        DO 124 I=1,KTRI
          K=MAX(1,MIN(NBNS,1+INT(RBNS*(AREA(I)/AVRG-XMIN)/
     +                                                  (XMAX-XMIN))))
          YCEN(K)=YCEN(K)+1.
  124   CONTINUE
C
        DO 125 I=1,NBNS
          YCEN(I)=YCEN(I)/REAL(KTRI)
  125   CONTINUE
C
        LABL(35:35)='2'
        WRITE (LABL(40:43),'(I4)') NBNS
C
        CALL EZXY   (XCEN,ZERO,NBNS,LABL)
C
        DO 126 I=1,NBNS
          XCRD(1)=XMIN+(REAL(I-1)/RBNS)*(XMAX-XMIN)
          YCRD(1)=0.
          XCRD(2)=XMIN+(REAL(I  )/RBNS)*(XMAX-XMIN)
          YCRD(2)=0.
          XCRD(3)=XMIN+(REAL(I  )/RBNS)*(XMAX-XMIN)
          YCRD(3)=YCEN(I)
          XCRD(4)=XMIN+(REAL(I-1)/RBNS)*(XMAX-XMIN)
          YCRD(4)=YCEN(I)
          CALL GFA (4,XCRD,YCRD)
  126   CONTINUE
C
        CALL PLCHHQ (CFUX(.8),CFUY(.75),
     +                                'The triangle sizes vary widely.',
     +                                                       .012,0.,1.)
C
        CALL FRAME
C
C Compute the areas of all the triangles of the derived grid and find
C the minimum, maximum, and average of the areas.  We actually count
C each triangle three times, but that's all right ...
C
        NTDG=0
C
        BMIN=1.E36
        BMAX=-1.E36
        BSUM=0.
C
        DO 128 I=1,2562
          IF (IADJ(I,6).LT.0) THEN
            NOJS=5
          ELSE
            NOJS=6
          END IF
          DO 127 J=1,NOJS
            JM1=MOD(J+NOJS-2,NOJS)+1
            A=SQRT((XCOV(     I     )-XCOV(IADJ(I,JM1)))**2+
     +             (YCOV(     I     )-YCOV(IADJ(I,JM1)))**2+
     +             (ZCOV(     I     )-ZCOV(IADJ(I,JM1)))**2)
            B=SQRT((XCOV(     I     )-XCOV(IADJ(I,J  )))**2+
     +             (YCOV(     I     )-YCOV(IADJ(I,J  )))**2+
     +             (ZCOV(     I     )-ZCOV(IADJ(I,J  )))**2)
            C=SQRT((XCOV(IADJ(I,JM1))-XCOV(IADJ(I,J  )))**2+
     +             (YCOV(IADJ(I,JM1))-YCOV(IADJ(I,J  )))**2+
     +             (ZCOV(IADJ(I,JM1))-ZCOV(IADJ(I,J  )))**2)
            S=.5*(A+B+C)
            NTDG=NTDG+1
            BREA(NTDG)=SQRT(S*(S-A)*(S-B)*(S-C))
            BMIN=MIN(BMIN,BREA(NTDG))
            BMAX=MAX(BMAX,BREA(NTDG))
            BSUM=BSUM+BREA(NTDG)
  127     CONTINUE
  128   CONTINUE
C
        BVRG=BSUM/REAL(NTDG)
C
C Print the minimum, maximum, and average areas.
C
        PRINT * , ' '
        PRINT '(''DERIVED GRID  OF "ctex03" '')'
        PRINT * , ' '
        PRINT '(''TRIANGLES:    '',     I8)' , NTDG/3
        PRINT '(''MINIMUM AREA: '',1PE16.8)' , BMIN
        PRINT '(''MAXIMUM AREA: '',1PE16.8)' , BMAX
        PRINT '(''AVERAGE AREA: '',1PE16.8)' , BVRG
        PRINT '(''EXPECTED AVG: '',1PE16.8)' , 4.*PI/REAL(NTDG/3)
C
C Draw a histogram showing the distribution of areas.
C
        DO 129 I=1,NBNS
          XCEN(I)=XMIN+(REAL(I-1)+.5)*(XMAX-XMIN)/RBNS
          YCEN(I)=0.
          ZERO(I)=0.
  129   CONTINUE
C
        DO 130 I=1,NTDG
          K=MAX(1,MIN(NBNS,1+INT(RBNS*(BREA(I)/BVRG-XMIN)/
     +                                                  (XMAX-XMIN))))
          YCEN(K)=YCEN(K)+1.
  130   CONTINUE
C
        DO 131 I=1,NBNS
          YCEN(I)=YCEN(I)/REAL(NTDG)
  131   CONTINUE
C
        LABL(35:35)='3'
        WRITE (LABL(40:43),'(I4)') NBNS
C
        CALL EZXY   (XCEN,ZERO,NBNS,LABL)
C
        DO 132 I=1,NBNS
          XCRD(1)=XMIN+(REAL(I-1)/RBNS)*(XMAX-XMIN)
          YCRD(1)=0.
          XCRD(2)=XMIN+(REAL(I  )/RBNS)*(XMAX-XMIN)
          YCRD(2)=0.
          XCRD(3)=XMIN+(REAL(I  )/RBNS)*(XMAX-XMIN)
          YCRD(3)=YCEN(I)
          XCRD(4)=XMIN+(REAL(I-1)/RBNS)*(XMAX-XMIN)
          YCRD(4)=YCEN(I)
          CALL GFA (4,XCRD,YCRD)
  132   CONTINUE
C
        CALL PLCHHQ (CFUX(.8),CFUY(.75),
     +                  'The triangle sizes are relatively consistent.',
     +                                                       .012,0.,1.)
C
        CALL FRAME
C
C Close GKS.
C
        CALL GDAWK (IWID)
        CALL GCLWK (IWID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END


      SUBROUTINE FACTOR (ITBF,IFOI,NFOI)
C
        DIMENSION IFOI(32)
C
C Move the absolute value of the number to be factored to a local
C variable we can modify.
C
        NTBF=ABS(ITBF)
C
C Handle the values 1, 2, and 3 specially.
C
        IF (NTBF.LE.3) GO TO 103
C
C Zero the count of factors found.
C
        NFOI=0
C
C Look for prime factors.
C
        ILIM=INT(SQRT(REAL(NTBF)+.5))
C
        DO 102 I=2,ILIM
  101     IF (MOD(NTBF,I).EQ.0) THEN
            IF (NFOI.LT.32) THEN
              NFOI=NFOI+1
              IFOI(NFOI)=I
            END IF
            NTBF=NTBF/I
            IF (NTBF.EQ.1) RETURN
            GO TO 101
          END IF
  102   CONTINUE
C
C Output the remaining factor.
C
  103   IF (NFOI.LT.32) THEN
          NFOI=NFOI+1
          IFOI(NFOI)=NTBF
        END IF
C
        RETURN
C
      END


      SUBROUTINE DRSGCR (ALAT,ALON,BLAT,BLON)
C
C (DRSGCR = DRaw Shortest Great Circle Route)
C
C This routine draws the shortest great circle route joining two points
C on the globe.
C
        PARAMETER (MPTS=181,SIZE=1.)
C
        DIMENSION QLAT(MPTS),QLON(MPTS)
C
        NPTS=MAX(1,MIN(MPTS,INT(ADSGCR(ALAT,ALON,BLAT,BLON)/SIZE)))
C
        CALL MAPGCI (ALAT,ALON,BLAT,BLON,NPTS,QLAT,QLON)
C
        CALL MAPIT (ALAT,ALON,0)
C
        DO 101 I=1,NPTS
          CALL MAPIT (QLAT(I),QLON(I),1)
  101   CONTINUE
C
        CALL MAPIT (BLAT,BLON,2)
C
        CALL MAPIQ
C
        RETURN
C
      END


      FUNCTION ADSGCR (ALAT,ALON,BLAT,BLON)
C
C (ADSGCR = Angle in Degrees along Shortest Great Circle Route)
C
C This function returns the shortest great circle distance, in degrees,
C between two points, A and B, on the surface of the globe.
C
        DATA DTOR / .017453292519943 /
        DATA RTOD / 57.2957795130823 /
C
        XCOA=COS(DTOR*ALAT)*COS(DTOR*ALON)
        YCOA=COS(DTOR*ALAT)*SIN(DTOR*ALON)
        ZCOA=SIN(DTOR*ALAT)
C
        XCOB=COS(DTOR*BLAT)*COS(DTOR*BLON)
        YCOB=COS(DTOR*BLAT)*SIN(DTOR*BLON)
        ZCOB=SIN(DTOR*BLAT)
C
        ADSGCR=2.*RTOD*ASIN(SQRT((XCOA-XCOB)**2+
     +                           (YCOA-YCOB)**2+
     +                           (ZCOA-ZCOB)**2)/2.)
C
        RETURN
C
      END


      SUBROUTINE LBLPNT (XCVI,YCVI,ZCVI)
        DIMENSION XCVI(12),YCVI(12),ZCVI(12)
        CHARACTER*2 CTMP
        DATA RTOD / 57.2957795130823D0 /
        DO 101 I=1,12
          RLAT=RTOD*ASIN (ZCVI(I))
          RLON=RTOD*ATAN2(YCVI(I),XCVI(I))
          CALL MAPTRA (RLAT,RLON,XCOL,YCOL)
          IF (XCOL.NE.1.E12) THEN
            WRITE (CTMP,'(I2)') I
            CALL PLCHHQ (XCOL,YCOL,CTMP(MDIFNB(CTMP):MDILNB(CTMP)),
     +                                                  .018,0.,0.)
          END IF
  101   CONTINUE
        RETURN
      END


      SUBROUTINE AGPWRT (XPOS,YPOS,CHRS,NCHS,ISIZ,IORI,ICEN)
C
        CHARACTER*(*) CHRS
C
C This subroutine replaces the default version in the NCAR Graphics
C libraries (which just calls PWRIT).
C
C If IFLG is zero, labels are drawn using calls to the SPPS routine
C PWRIT (the default behavior of AUTOGRAPH); otherwise, labels are
C drawn using calls to PLCHHQ and, in addition, the constant-spacing
C parameter of PLCHHQ is used to achieve a more consistent appearance
C for numeric labels (which are distinguished from the others by virtue
C of the fact that they are drawn with a non-zero centering flag).
C
        COMMON /PSSFLG/ IFLG
C
C Do it.
C
        IF (IFLG.EQ.0) THEN
          CALL PWRIT (XPOS,YPOS,CHRS,NCHS,ISIZ,IORI,ICEN)
        ELSE
          CALL PCGETR ('CS - CONSTANT SPACING FLAG',CSFL)
          IF (ICEN.NE.0) THEN
            CALL PCSETR ('CS - CONSTANT SPACING FLAG',1.25)
          ELSE
            CALL PCSETR ('CS - CONSTANT SPACING FLAG',0.)
          END IF
          CALL PLCHHQ (XPOS,YPOS,CHRS(1:NCHS),
     +                 .8*REAL(ISIZ),REAL(IORI),REAL(ICEN))
          CALL PCSETR ('CS - CONSTANT SPACING FLAG',CSFL)
        END IF
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE FPSGCR (ALAT,ALON,BLAT,BLON,FRCT,FLAT,FLON)
C
C (FPSGCR = Find Point on Shortest Great Circle Route)
C
        REAL    ALAT,ALON,BLAT,BLON,FRCT,FLAT,FLON
C
C This routine, given the latitudes and longitudes of two points A and
C B on the surface of the globe and a fraction FRCT, between 0. and 1.,
C interpolates a point F along the shortest great circle route joining
C A to B such that the distance from A to F, divided by the distance
C from A to B, is equal to FRCT, and returns its latitude and longitude
C in FLAT and FLON.
C
C Define the constants used to convert from degrees to radians and
C vice-versa.
C
        DATA DTOR / .017453292519943 /
        DATA RTOD / 57.2957795130823 /
C
C Compute the X, Y, and Z coordinates (on a unit sphere) of the point B.
C
        CALL LLPXYZ (BLAT,BLON,XCPB,YCPB,ZCPB)
C
C Rotating about the Z axis by the angle -ALON would carry A into the XZ
C plane.
C
        CALL ROTXYZ (3,-ALON,XCPB,YCPB,ZCPB)
C
C Then, rotating about the Y axis by the angle ALAT would carry A into
C the point on the X axis with coordinates (1,0,0).
C
        CALL ROTXYZ (2,ALAT,XCPB,YCPB,ZCPB)
C
C Then, rotating about the X axis by the angle ALPH = -ATAN(ZCPB/YCPB)
C would leave the position of A unchanged but carry B into a point in
C the XY plane.
C
        IF (ZCPB.NE.0..OR.YCPB.NE.0.) THEN
          ALPH=-RTOD*ATAN2(ZCPB,YCPB)
        ELSE
          ALPH=0.
        END IF
C
        CALL ROTXYZ (1,ALPH,XCPB,YCPB,ZCPB)
C
C The angle BETA from A to B can now be computed easily.
C
        IF (XCPB.NE.0..OR.YCPB.NE.0.) THEN
          BETA=ATAN2(YCPB,XCPB)
        ELSE
          BETA=0.
        END IF
C
C Interpolate a point at the desired position between the points A and
C B, map it back to its original position on the great circle route from
C A to B, and get its latitude and longitude to return to the caller.
C
        GAMA=FRCT*BETA
C
        XCPF=COS(GAMA)
        YCPF=SIN(GAMA)
        ZCPF=0.
C
        CALL ROTXYZ (1,-ALPH,XCPF,YCPF,ZCPF)
        CALL ROTXYZ (2,-ALAT,XCPF,YCPF,ZCPF)
        CALL ROTXYZ (3, ALON,XCPF,YCPF,ZCPF)
C
        CALL XYZLLP (XCPF,YCPF,ZCPF,FLAT,FLON)
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE LLPXYZ (RLAT,RLON,RVOX,RVOY,RVOZ)
C
C (LLPXYZ = Lat/Lon Position to XYZ coordinates)
C
C Given the latitude and longitude of a point on the globe, return its
C X, Y, and Z coordinates.
C
        DATA DTOR / .017453292519943 /
C
        RVOX=COS(DTOR*RLAT)*COS(DTOR*RLON)
        RVOY=COS(DTOR*RLAT)*SIN(DTOR*RLON)
        RVOZ=SIN(DTOR*RLAT)
C
        RETURN
C
      END


      SUBROUTINE XYZLLP (RVOX,RVOY,RVOZ,RLAT,RLON)
C
C (XYZLLP = XYZ coordinates to Lat/Lon Position)
C
C Given the X, Y, and Z coordinates of a point on the globe, return its
C latitude and longitude.
C
        DATA RTOD / 57.2957795130823 /
C
        RLAT=RTOD*ASIN(RVOZ)
C
        IF (RVOX.NE.0.OR.RVOY.NE.0.) THEN
          RLON=RTOD*ATAN2(RVOY,RVOX)
        ELSE
          RLON=0.
        END IF
C
        RETURN
C
      END


      SUBROUTINE ROTXYZ (IAXS,ANGL,XCRD,YCRD,ZCRD)
C
C (ROTXYZ = ROTate a point defined by its X, Y, and Z coordinates)
C
C This is a modified version of a routine in the NCAR Graphics package,
C which is used in some of the examples.  It rotates the point having
C coordinates (XCRD,YCRD,ZCRD) by an angle ANGL about the axis specified
C by IAXS (1 for the X axis, 2 for the Y axis, 3 for the Z axis).
C
C One assumes a right-handed system with X, Y, and Z axes.  Rotating by
C an angle "a" about the X axis maps the point (x,y,z) into the point
C (x',y',z'), where
C
C       x' = x
C       y' = y cos(a) - z sin(a)
C       z' = z cos(a) + y sin(a)
C
C A positive value of "a" represents rotation in the direction from the
C Y axis to the Z axis.
C
C Similarly, rotating by an angle "a" about the Y axis maps the point
C (x,y,z) into the point (x',y',z'), where
C
C       x' = x cos(a) + z sin(a)
C       y' = y
C       z' = z cos(a) - x sin(a)
C
C A positive value of "a" represents rotation in the direction from the
C Z axis to the X axis.
C
C Rotating by an angle "a" about the Z axis maps the point (x,y,z) into
C the point (x',y',z'), where
C
C       x' = x cos(a) - y sin(a)
C       y' = y cos(a) + x sin(a)
C       y' = y
C
C A positive value of "a" represents rotation in the direction from the
C X axis to the Y axis.
C
C Define a multiplicative constant to convert from degrees to radians.
C
        DATA DTOR / .017453292519943 /
C
C Trigonometry.
C
        SINA=SIN(DTOR*ANGL)
        COSA=COS(DTOR*ANGL)
C
        XTMP=XCRD
        YTMP=YCRD
        ZTMP=ZCRD
C
        IF (IAXS.EQ.1) THEN
          YCRD=YTMP*COSA-ZTMP*SINA
          ZCRD=ZTMP*COSA+YTMP*SINA
        ELSE IF (IAXS.EQ.2) THEN
          XCRD=XTMP*COSA+ZTMP*SINA
          ZCRD=ZTMP*COSA-XTMP*SINA
        ELSE
          XCRD=XTMP*COSA-YTMP*SINA
          YCRD=YTMP*COSA+XTMP*SINA
        END IF
C
        RETURN
C
      END

C
C $Id: moprin.f,v 1.4 2008-09-18 00:42:18 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MOPRIN (UVAL,VVAL,DLAT,DLON)
C
        DOUBLE PRECISION UVAL,VVAL,DLAT,DLON
C
C The subroutine MOPRIN implements a closed form of the true Mollweide
C projection, using formulas given on "Wolfram MathWorld".
C
C UVAL and VVAL are input values of U and V, in the projection plane.
C DLAT and DLON are output values of latitude and longitude, in radians.
C
C The common block MAPCM0 contains mathematical constants.
C
        COMMON /MAPCM0/  COS1,DTOR,DTRH,OOPI,PI,PIOF,PIOT,RTDD,RTOD,
     +                   SROT,SIN1,TOPI,TSRT
        DOUBLE PRECISION COS1,DTOR,DTRH,OOPI,PI,PIOF,PIOT,RTDD,RTOD,
     +                   SROT,SIN1,TOPI,TSRT
        SAVE   /MAPCM0/
C
C Local variables.
C
        DOUBLE PRECISION THTA,TVAL
C
C First, we must check the point (UVAL,VVAL) to see if it lies in the
C ellipse occupied by the projection of the globe.  If not, we return
C the value "1.D12" to signal that fact.
C
        IF ((UVAL/TSRT)**2+(VVAL/SROT)**2-1.D0.GT.1.D-12) THEN
          DLAT=1.D12
          DLON=1.D12
          RETURN
        END IF
C
C Do the math.
C
        THTA=ASIN(MAX(-1.D0,MIN(+1.D0,VVAL/SROT)))
C
        DLAT=ASIN(MAX(-1.D0,MIN(+1.D0,(2.D0*THTA+SIN(2.D0*THTA))/PI)))
        DLON=PI*UVAL/(TSRT*COS(THTA))
C
        RETURN
C
      END

      SUBROUTINE DLARZT( DIRECT, STOREV, N, K, V, LDV, TAU, T, LDT )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          DIRECT, STOREV
      INTEGER            K, LDT, LDV, N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   T( LDT, * ), TAU( * ), V( LDV, * )
*     ..
*
*  Purpose
*  =======
*
*  DLARZT forms the triangular factor T of a real block reflector
*  H of order > n, which is defined as a product of k elementary
*  reflectors.
*
*  If DIRECT = 'F', H = H(1) H(2) . . . H(k) and T is upper triangular;
*
*  If DIRECT = 'B', H = H(k) . . . H(2) H(1) and T is lower triangular.
*
*  If STOREV = 'C', the vector which defines the elementary reflector
*  H(i) is stored in the i-th column of the array V, and
*
*     H  =  I - V * T * V'
*
*  If STOREV = 'R', the vector which defines the elementary reflector
*  H(i) is stored in the i-th row of the array V, and
*
*     H  =  I - V' * T * V
*
*  Currently, only STOREV = 'R' and DIRECT = 'B' are supported.
*
*  Arguments
*  =========
*
*  DIRECT  (input) CHARACTER*1
*          Specifies the order in which the elementary reflectors are
*          multiplied to form the block reflector:
*          = 'F': H = H(1) H(2) . . . H(k) (Forward, not supported yet)
*          = 'B': H = H(k) . . . H(2) H(1) (Backward)
*
*  STOREV  (input) CHARACTER*1
*          Specifies how the vectors which define the elementary
*          reflectors are stored (see also Further Details):
*          = 'C': columnwise                        (not supported yet)
*          = 'R': rowwise
*
*  N       (input) INTEGER
*          The order of the block reflector H. N >= 0.
*
*  K       (input) INTEGER
*          The order of the triangular factor T (= the number of
*          elementary reflectors). K >= 1.
*
*  V       (input/output) DOUBLE PRECISION array, dimension
*                               (LDV,K) if STOREV = 'C'
*                               (LDV,N) if STOREV = 'R'
*          The matrix V. See further details.
*
*  LDV     (input) INTEGER
*          The leading dimension of the array V.
*          If STOREV = 'C', LDV >= max(1,N); if STOREV = 'R', LDV >= K.
*
*  TAU     (input) DOUBLE PRECISION array, dimension (K)
*          TAU(i) must contain the scalar factor of the elementary
*          reflector H(i).
*
*  T       (output) DOUBLE PRECISION array, dimension (LDT,K)
*          The k by k triangular factor T of the block reflector.
*          If DIRECT = 'F', T is upper triangular; if DIRECT = 'B', T is
*          lower triangular. The rest of the array is not used.
*
*  LDT     (input) INTEGER
*          The leading dimension of the array T. LDT >= K.
*
*  Further Details
*  ===============
*
*  Based on contributions by
*    A. Petitet, Computer Science Dept., Univ. of Tenn., Knoxville, USA
*
*  The shape of the matrix V and the storage of the vectors which define
*  the H(i) is best illustrated by the following example with n = 5 and
*  k = 3. The elements equal to 1 are not stored; the corresponding
*  array elements are modified but restored on exit. The rest of the
*  array is not used.
*
*  DIRECT = 'F' and STOREV = 'C':         DIRECT = 'F' and STOREV = 'R':
*
*                                              ______V_____
*         ( v1 v2 v3 )                        /            \
*         ( v1 v2 v3 )                      ( v1 v1 v1 v1 v1 . . . . 1 )
*     V = ( v1 v2 v3 )                      ( v2 v2 v2 v2 v2 . . . 1   )
*         ( v1 v2 v3 )                      ( v3 v3 v3 v3 v3 . . 1     )
*         ( v1 v2 v3 )
*            .  .  .
*            .  .  .
*            1  .  .
*               1  .
*                  1
*
*  DIRECT = 'B' and STOREV = 'C':         DIRECT = 'B' and STOREV = 'R':
*
*                                                        ______V_____
*            1                                          /            \
*            .  1                           ( 1 . . . . v1 v1 v1 v1 v1 )
*            .  .  1                        ( . 1 . . . v2 v2 v2 v2 v2 )
*            .  .  .                        ( . . 1 . . v3 v3 v3 v3 v3 )
*            .  .  .
*         ( v1 v2 v3 )
*         ( v1 v2 v3 )
*     V = ( v1 v2 v3 )
*         ( v1 v2 v3 )
*         ( v1 v2 v3 )
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO
      PARAMETER          ( ZERO = 0.0D+0 )
*     ..
*     .. Local Scalars ..
      INTEGER            I, INFO, J
*     ..
*     .. External Subroutines ..
      EXTERNAL           DGEMV, DTRMV, XERBLA
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. Executable Statements ..
*
*     Check for currently supported options
*
      INFO = 0
      IF( .NOT.LSAME( DIRECT, 'B' ) ) THEN
         INFO = -1
      ELSE IF( .NOT.LSAME( STOREV, 'R' ) ) THEN
         INFO = -2
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DLARZT', -INFO )
         RETURN
      END IF
*
      DO 20 I = K, 1, -1
         IF( TAU( I ).EQ.ZERO ) THEN
*
*           H(i)  =  I
*
            DO 10 J = I, K
               T( J, I ) = ZERO
   10       CONTINUE
         ELSE
*
*           general case
*
            IF( I.LT.K ) THEN
*
*              T(i+1:k,i) = - tau(i) * V(i+1:k,1:n) * V(i,1:n)'
*
               CALL DGEMV( 'No transpose', K-I, N, -TAU( I ),
     $                     V( I+1, 1 ), LDV, V( I, 1 ), LDV, ZERO,
     $                     T( I+1, I ), 1 )
*
*              T(i+1:k,i) = T(i+1:k,i+1:k) * T(i+1:k,i)
*
               CALL DTRMV( 'Lower', 'No transpose', 'Non-unit', K-I,
     $                     T( I+1, I+1 ), LDT, T( I+1, I ), 1 )
            END IF
            T( I, I ) = TAU( I )
         END IF
   20 CONTINUE
      RETURN
*
*     End of DLARZT
*
      END

C
C	$Id: condsd.f,v 1.4 2008-07-27 00:16:55 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CONDSD
C
C  DRAW THE OUTLINE OF THE SHIELD ON THE PLOT
C
      COMMON /CONR13/XVS(50),YVS(50),ICOUNT,SPVAL,SHIELD,
     1               SLDPLT
      LOGICAL SHIELD,SLDPLT
C
        SAVE
C
C  GET THE START POINT
C
      XS = XVS(1)
      YS = YVS(1)
C
C  MOVE TO THE START OF THE OUTLINE
C
      CALL FL2INT(XS,YS,IX,IY)
      CALL PLOTIT(IX,IY,0)
C
C  LOOP FOR ALL SHIELD ELEMENTS
C
      DO 100 IC = 2,ICOUNT
C
C       DRAW THE OUTLINE OF THE SHIELD
C
        CALL FL2INT(XVS(IC),YVS(IC),IX,IY)
        CALL PLOTIT(IX,IY,1)
C
 100  CONTINUE
C
C  DRAW TO THE START
C
      CALL FL2INT(XS,YS,IX,IY)
      CALL PLOTIT(IX,IY,1)
C
C  FLUSH PLOTIT BUFFER
C
      CALL PLOTIT(0,0,0)
      RETURN
C
      END

C
C $Id: tdgetr.f,v 1.5 2008-07-27 00:17:32 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE TDGETR (PNAM,RVAL)
C
      CHARACTER*(*) PNAM
C
C The subroutine TDGETR may be used to get TDPACK parameters which have
C values of type REAL.
C
C The variables in the following common block define the mapping from
C 3-space to 2-space.
C
        COMMON /TDCOM1/ IH,IT,XM,YM,ZM,XO,YO,ZO,XT,YT,ZT,OE,XE,YE,ZE
        COMMON /TDCOM1/ A1,B1,C1,D1,E1,A2,B2,C2,D2,E2,A3,B3,C3,D3,E3
        COMMON /TDCOM1/ IS,FV,VL,VR,VB,VT,WL,WR,WB,WT
        SAVE   /TDCOM1/
C
C The variables in the following common block define the parallelogram.
C
        COMMON /TDCOM2/ XACP,YACP,ZACP,XCDX,YCDX,ZCDX,XCDY,YCDY,ZCDY
        SAVE   /TDCOM2/
C
C The variables in the following common block together determine how
C big characters written by TDLBLA will be.
C
        COMMON /TDCOM4/ CSM1,CSM2
        SAVE   /TDCOM4/
C
C The variables in the following common block define the shading type
C and the position of the light source.
C
        COMMON /TDCOM6/ ISHD,XPLS,YPLS,ZPLS
        SAVE   /TDCOM6/
C
C Do a call forcing a BLOCKDATA to be loaded from a binary library.
C
        CALL TDBLDA
C
C Check for an uncleared prior error.
C
        IF (ICFELL('TDGETR - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C Get the selected parameter.
C
        IF      (PNAM(1:3).EQ.'CS1'.OR.PNAM(1:3).EQ.'cs1') THEN
          RVAL=CSM1
        ELSE IF (PNAM(1:3).EQ.'CS2'.OR.PNAM(1:3).EQ.'cs2') THEN
          RVAL=CSM2
        ELSE IF (PNAM(1:3).EQ.'FOV'.OR.PNAM(1:3).EQ.'fov') THEN
          RVAL=FV
        ELSE IF (PNAM(1:3).EQ.'HND'.OR.PNAM(1:3).EQ.'hnd') THEN
          RVAL=REAL(IH)
        ELSE IF (PNAM(1:3).EQ.'LSU'.OR.PNAM(1:3).EQ.'lsu') THEN
          RVAL=XPLS
        ELSE IF (PNAM(1:3).EQ.'LSV'.OR.PNAM(1:3).EQ.'lsv') THEN
          RVAL=YPLS
        ELSE IF (PNAM(1:3).EQ.'LSW'.OR.PNAM(1:3).EQ.'lsw') THEN
          RVAL=ZPLS
        ELSE IF (PNAM(1:3).EQ.'SET'.OR.PNAM(1:3).EQ.'set') THEN
          RVAL=REAL(IS)
        ELSE IF (PNAM(1:3).EQ.'SHD'.OR.PNAM(1:3).EQ.'shd') THEN
          RVAL=REAL(ISHD)
        ELSE IF (PNAM(1:3).EQ.'STE'.OR.PNAM(1:3).EQ.'ste') THEN
          RVAL=REAL(IT)
        ELSE IF (PNAM(1:3).EQ.'VPB'.OR.PNAM(1:3).EQ.'vpb') THEN
          RVAL=VB
        ELSE IF (PNAM(1:3).EQ.'VPL'.OR.PNAM(1:3).EQ.'vpl') THEN
          RVAL=VL
        ELSE IF (PNAM(1:3).EQ.'VPR'.OR.PNAM(1:3).EQ.'vpr') THEN
          RVAL=VR
        ELSE IF (PNAM(1:3).EQ.'VPT'.OR.PNAM(1:3).EQ.'vpt') THEN
          RVAL=VT
        ELSE
          CALL SETER ('TDGETR - UNRECOGNIZED PARAMETER NAME',2,1)
          RETURN
        END IF
C
C Done.
C
        RETURN
C
      END

C
C	$Id: gclsg.f,v 1.5 2008-07-27 00:20:57 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GCLSG
C
C  CLOSE SEGMENT
C
      INTEGER ECLSG
      PARAMETER (ECLSG=57)
C
      include 'gkscom.h'
C
C  This subroutine is here solely as support for the SPPS GFLASn
C  entries.  Full segmentation is not a part of the NCAR GKS
C  package at this time.  The NCAR package is non-standard to the
C  extent that certain segmentation functions are supported, but
C  not all level 1 functions are supported.  This subroutine should
C  be considered a user entry point only by way of the GFLASn
C  calls--it should never be called directly be the user.
C
C
C  Check if GKS is in the proper state.
C
      CALL GZCKST(4,ECLSG,IER)
      IF (IER .NE. 0) RETURN
C
C  Get the workstation ID for WISS.
C
      DO 10 I=1,NACWK
        CALL GQWKC(SACWK(I),IER,ICONID,ITYP)
        IF (ITYP .EQ. GWSS) THEN
          IWKIDX = I
          GO TO 20
        ENDIF
   10 CONTINUE
      ERS = 1
      CALL GERHND(-103,ECLSG,ERF)
      ERS = 0
      RETURN
   20 CONTINUE
C
C  Invoke workstation interface.
C
      CUFLAG = SACWK(IWKIDX)
      FCODE = 81
      CONT  = 0
      CALL GZROI(0)
      CALL GZTOWK
      IF (RERR .NE. 0) THEN
        ERS = 1
        CALL GERHND(RERR,ECLSG,ERF)
        ERS = 0
      ENDIF
C
C  Store the segment length.
C
      DO 30 I=1,NUMSEG
        IF (SEGS(I) .EQ. CURSEG) THEN
          SEGLEN(I) = ID(1)
          GO TO 40
        ENDIF
   30 CONTINUE
   40 CONTINUE
C
C  Set GKS state to workstation active.
C
      OPS = GWSAC
      CURSEG = -1
      CUFLAG = -1
C
      RETURN
      END

C
C       $Id: stdrcv.f,v 1.4 2008-07-27 00:17:28 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE STDRCV  (U,V,UX,VY,P,WRK,IAM,STUMSL)
C
C This routine draws "curly" vectors. It is adapted from STDRAW.
C
      DIMENSION  U(IUD1,*)             ,V(IVD1,*)
      DIMENSION  UX(IXDM,IYDN)         ,VY(IXDM,IYDN)
      DIMENSION  P(IPD1,*)
      DIMENSION  WRK(*)
      DIMENSION  IAM(*)
      EXTERNAL STUMSL
C
C Input parameters:
C
C U,V    - Vector component arrays
C UX,UY  - Work arrays
C P      - Scalar value or magnitude array
C WRK    - work array used for thinning vectors  
C IAM    - Mask array
C STUMSL - User-defined masked streamline drawing routine
C
C The work array has been broken up into two arrays for clarity.  The
C top half of WORK (called UX) will have the normalized (and
C possibly transformed) U components and will be used for book
C keeping.  the lower half of the WORK array (called VY) will
C contain the normalized (and possibly transformed) V components.
C
C ---------------------------------------------------------------------
C
C NOTE:
C Since implicit typing is used for all real and integer variables
C a consistent length convention has been adopted to help clarify the
C significance of the variables encountered in the code for this 
C utility. All local variable and subroutine parameter identifiers 
C are limited to 1,2,or 3 characters. Four character names identify  
C members of common blocks. Five and 6 character variable names 
C denote PARAMETER constants or subroutine or function names.
C
C Declare the ST common blocks.
C
      PARAMETER (IPLVLS = 256)
C
C Integer and real common block variables
C
C
      COMMON / STPAR /
     +                IUD1       ,IVD1       ,IPD1       ,
     +                IXD1       ,IXDM       ,IYD1       ,IYDN       ,
     +                IXM1       ,IYM1       ,IXM2       ,IYM2       ,
     +                IWKD       ,IWKU       ,ISET       ,IERR       ,
     +                IXIN       ,IYIN       ,IMSK       ,ICPM       ,
     +                NLVL       ,IPAI       ,ICTV       ,WDLV       ,
     +                UVMN       ,UVMX       ,PMIN       ,PMAX       ,
     +                IPLR       ,ISST       ,
     +                ICLR(IPLVLS)           ,TVLU(IPLVLS)
C
      COMMON / STTRAN /
     +                UVPS       ,
     +                UVPL       ,UVPR       ,UVPB       ,UVPT       ,
     +                UWDL       ,UWDR       ,UWDB       ,UWDT       ,
     +                UXC1       ,UXCM       ,UYC1       ,UYCN 
C
C Stream algorithm parameters
C
      COMMON / STSTRM /
     +                ISGD       ,IAGD       ,RARL       ,ICKP       ,
     +                ICKX       ,ITRP       ,ICYK       ,RVNL       ,
     +                ISVF       ,RUSV       ,RVSV       ,RNDA       ,
     +                ISPC       ,RPSV       ,RCDS       ,RSSP       ,
     +                RDFM       ,RSMD       ,RAMD       ,IGBS       ,
     +                ISTM       ,RVRL       ,RVFR       ,RVRM       ,
     +                IVPO       ,RAFR       ,RDMX       ,RDMN
C
C Text related parameters
C Note: graphical text output is not yet implemented for the
C       Streamline utility.
C
      COMMON / STTXP /
     +                FCWM    ,ICSZ    ,
     +                FMNS    ,FMNX    ,FMNY    ,IMNP    ,IMNC  ,
     +                FMXS    ,FMXX    ,FMXY    ,IMXP    ,IMXC  ,
     +                FZFS    ,FZFX    ,FZFY    ,IZFP    ,IZFC  ,
     +                FILS    ,FILX    ,FILY    ,IILP    ,IILC 
C
C Character variable declartions
C
      CHARACTER*160 CSTR
      PARAMETER (IPCHSZ=80)
      CHARACTER*(IPCHSZ)  CMNT,CMXT,CZFT,CILT
C
C Text string parameters
C
      COMMON / STCHAR / CSTR,CMNT,CMXT,CZFT,CILT
C
      SAVE /STPAR/, /STTRAN/, /STSTRM/, /STTXP/, /STCHAR/
C
C Internal buffer lengths
C
C IPNPTS - Number of points in the point buffer -- not less than 3
C IPLSTL - Streamline-crossover-check circular list length
C IPGRCT - Number of groups supported for area masking
C
      PARAMETER (IPNPTS = 256, IPLSTL = 750, IPGRCT = 64)
C
C --------------------------------------------------------------------
C
C The mapping common block: made available to user mapping routines
C
      COMMON /STMAP/
     +                IMAP       ,LNLG       ,INVX       ,INVY       ,
     +                XLOV       ,XHIV       ,YLOV       ,YHIV       ,
     +                WXMN       ,WXMX       ,WYMN       ,WYMX       ,
     +                XVPL       ,XVPR       ,YVPB       ,YVPT       ,
     +                XGDS       ,YGDS       ,NXCT       ,NYCT       ,
     +                ITRT       ,FW2W       ,FH2H       ,
     +                DFMG       ,VNML       ,RBIG       ,IBIG
C
      SAVE /STMAP/
C
C Math constants
C
      PARAMETER (PDTOR  = 0.017453292519943,
     +           PRTOD  = 57.2957795130823,
     +           P1XPI  = 3.14159265358979,
     +           P2XPI  = 6.28318530717959,
     +           P1D2PI = 1.57079632679489,
     +           P5D2PI = 7.85398163397448) 
C
C ---------------------------------------------------------------------
C
C Local declarations
C
C Point and list buffers
C
C The XLS and YLS arrays serve as a circular list. they
C are used to prevent lines from crossing one another.
C
      DIMENSION PX(IPNPTS), PY(IPNPTS), SV(IPNPTS)
c      DIMENSION XLS(IPLSTL), YLS(IPLSTL)
C
C Parameters:
C
C IPZERO, IPONE, IPTWO - the numbers 0,1,2
C PRZERO - the number 0.0
C PTHREE - the number 3.0
C PSMALL - a small floating point number, large enough to be 
C          detectable by any standard processor
C PMXITR - maximum iteration count for figuring when determining
C          the streamline edge
C
      PARAMETER (IPZERO=0, IPONE=1, IPTWO=2, PRZERO=0.0, PTHREE=3.0)
      PARAMETER (PSMALL=0.000001, PMXITR=32)
C
C Local variables
C
C VSM      - A small value in comparison to the normalized vector mag.
C ISK      - Number of bits to skip in bit routines
C IS1      - ISK + 1
C SSP      - Stream spacing value in fractional (ND) coordinates
C CDS      - Critical displacement in fractional (ND) coordinates
C LCT      - Count of streamlines drawn
C ITO      - Total number of points used to draw all the streamlines
C LCU      - Amount of list currently in use
C LCK      - Current list index
C IDR      - drawing direction 0 + direction 1 - direction
C SGN      - multiplier to change sign based on drawing direction
C IPC      - number of points currently in the point buffer
C ICT      - count of iterations in current streamline
C I,J      - Grid indices
C UIJ,VIJ  - individual vector components
C CVF      - component-wise vector normalizing factor
C LST      - flag indicating the last point in a streamline
C IUX      - integer storage for retrieved bits
C ISV, JSV - saved grid indices where stream starts in + direction
C NBX      - count of grid boxes for current streamline
C LBC      - box checking variable
C X, Y     - current X,Y coordinates (grid coordinates
C DU, DV   - Current normalized interpolated vector components
C XDA, YDA - Current position in data coordinates
C XUS, YUS - Current position in user coordinates
C XND, YND - Current position in NDC space
C XNS, YNS - value of XND and YND saved at the start of the streamline 
C                           and after each progress check
C XN1, YN1 - Previous position in NDC space
C TA       - The tangent angle in NDC space
C DUV      - The differential normalized interpolated vector magnitude
C CSA,SNA  - Cosine and sine of the tangent angle
C XN2,YN2  - The previous previous position in NDC space
C TMG      - Temporary magnitude 
C XT,YT    - Temporary x and y values
C XU1,YU1  - Previous X and Y user coordinate values
C NCT      - Iteration count for determining the streamline edge
C LI       - Index into circular crossover checking list
C IZO      - Zero field flag
C VMF      - current magnitude / max magnitude
C VRL      - ndc ref length in fractional coordinates
C VFL      - ndc length of the adjusted minimum vector
C CFR      - current size in fractional coordinates (ndc)
C IPD      - is partially drawn - part of the line has been drawn
C ICN      - cancel line flag
C ICA      - cancel arrow flag
C DS       - current interpolated scalar value
C DST      - current length of curly vector segment
C
C --------------------------------------------------------------------
C
C Initialize local variables.
C
C Bit manipulation values
C
      VSM = R1MACH(3)*VNML
      ISK = I1MACH(5) - 2
      IS1 = ISK + 1
C
C Stream spacing (setting depends on whether grid relative sizing is
C in effect) and critical displacement
C
      IF (IGBS.EQ.0) THEN
         SSP=RSSP*FW2W
      ELSE
         SSP=RSSP*FW2W/REAL(IXDM)
      END IF
      CDS=RCDS*DFMG
      AMD=RAMD*FW2W
C
C Stream and arrow counters
C
      LCT=0
      ITO=0
      IAC=0
C
C Crossover list variables
C
c      LCU = 1
c      LCK = 1
c      XLS(1) = 0.0
c      YLS(1) = 0.0
C
C Current streamline variables
C
      IDR = 0
      SGN = 1.0
      IPC = 0
      ICT = 0
      IUC = 0
      JSV = IYD1
      VMF = 1.0
      DST = 0.0
      XUS = 0.0
      YUS = 0.0
      XND = 0.0
      YND = 0.0
      TA = 0.0
      IPD = 0
      ICN = 0
      ICA = 0
      SV0 = 0.0
C
C
C Compute the X and Y normalized (and possibly transformed)
C displacement components (UX and VY).
C
      IZO = 1
      DO  40 J=IYD1,IYDN
         DO  30 I=IXD1,IXDM
C
            IF (ISVF.NE.0) THEN
               IF (U(I,J).EQ.RUSV .OR. V(I,J).EQ.RVSV) THEN
                  UIJ = 0.0
                  VIJ = 0.0
                  GO TO 25
               END IF
            END IF
C
            CALL STMPUV(U(I,J),V(I,J),UIJ,VIJ,IST)
            IF (UIJ.NE.0. .OR. VIJ.NE.0.) THEN
               IZO = 0
               T = SQRT(UIJ*UIJ + VIJ*VIJ)
               CVF = VNML/T
               UIJ = CVF*UIJ
               VIJ = CVF*VIJ
            END IF
 25         CONTINUE
C
C Bookkeeping is done in the least significant bits of the UX array.
C When UIJ is exactly zero this can present some problems.
C To get around this problem, set it to a relatively small number.
C
            IF (UIJ.EQ.0.0) UIJ = VSM
C
C Mask out the least significant two bits as flags for each grid box
C A grid box is any region surrounded by four grid points.
C Flag 1 indicates whether any streamline has previously passed
C through this box.
C Flag 2 indicates whether any directional arrow has already
C appeared in this box.
C Judicious use of these flags prevents overcrowding of
C streamlines and directional arrows.
C If thinning using the SMD parameter ignore SGD
C
            CALL SBYTES(UIJ,IPZERO,ISK,2,0,1)
C
            IF (RSMD.LE.0) THEN
               IF (MOD(I,ISGD).NE.0 .OR. MOD(J,ISGD).NE.0) THEN
                  CALL SBYTES(UIJ,IPONE,IS1,1,0,1)
               END IF
            END IF
C
            UX(I,J) = UIJ
            VY(I,J) = VIJ
C
 30      CONTINUE
 40   CONTINUE
C
C If Zero field bail out
C
      IF (IZO .EQ. 1) THEN
         LCT = 0
         ITO = 0
         GO TO 190
      END IF
      CALL STILNS(VRL,VFL,IAV)
C
C If thinning the vectors based on the NDC distance between grid
C points set up the thinning arrays
C
      IF (RSMD .GT. 0) THEN
         CALL STTHIN(U,V,P,WRK(1),WRK(IXDM*IYDN+1))
      END IF
C
C
C Start a streamline. Experience has shown that a pleasing picture
C will be produced if new streamlines are started only in grid
C boxes that previously have not had other streamlines pass through
C them. As long as a reasonably dense pattern of available boxes
C is initially prescribed, the order of scanning the grid pts. for
C available boxes is immaterial.
C
 50   CONTINUE
C
C First ensure that the point buffer is clear
C
      IF (IPC .LE. 2  .OR. (IPD .EQ. 0 .AND. DST .LE. PSMALL)) ICN = 1
      IF (ICN .EQ. 1) THEN
         IDR = 0
      ELSE
         CALL STLNSG(PX,PY,SV,IPC,IAM,STUMSL)
         IPD = 1
         IF (ICA .EQ. 0) THEN
            IF (IVPO .LT. 0) THEN
               CALL STARDR(XU0,YU0,X0,Y0,TA0,VMF,SV0,IAM,STUMSL,IST)
            ELSE IF (SGN .GT. 0) THEN
               CALL STARDR(XUS,YUS,XND,YND,TA,VMF,SV(IPC),
     +              IAM,STUMSL,IST)
            END IF
         END IF
      END IF
C
      LST=0
C
C Find an available box for starting a streamline.
C First check to see if the box has already been marked as
C ineligible. Then if thinning is in effect check to see
C if the thinning array rules it out (note that special values
C have been marked in the thinning array). If so, mark it ineligible.
C Otherwise check for a special value, and if positive mark it
C ineligible. 
C
      IF (IDR .EQ. 0) THEN
C
         LCT=LCT+1
         ITO = ITO+ICT
         ICT = 0
         DO  70 J=JSV,IYM1
            DO  60 I=IXD1,IXM1
               CALL GBYTES(UX(I,J),IUX,ISK,2,0,1)
               IF (IAND(IUX,IPONE) .EQ. IPZERO) THEN
                  IF (RSMD .GT. 0) THEN
                     CALL STTHND(I,J,WRK(1),IS)
                     IF (IS .EQ. 0) THEN
                        GO TO 80
                     ELSE
                        CALL SBYTES(UX(I,J),IPONE,IS1,1,0,1)
                     END IF
                  ELSE IF (ISVF .NE. 0) THEN
                     CALL STSVCK(U,V,I,J,IST)
                     IF (IST .EQ. 0) THEN
                        GO TO 80
                     ELSE
                        CALL SBYTES(UX(I,J),IPONE,IS1,1,0,1)
                     END IF
                  ELSE
                     GO TO 80
                  END IF
               END IF
 60         CONTINUE
 70      CONTINUE
C
C Must be no available boxes for starting a streamline.
C This is the final exit from the streamline drawing loop
C
         GO TO 190
C
 80      CONTINUE
C
C Initialize parameters for starting a streamline.
C Turn the box off for starting a streamline.
C If the special value parameter is turned on, check to see if 
C this box has missing data. If so, find a new starting box.
C
         CALL SBYTES(UX(I,J),IPONE,IS1,1,0,1)
         ISV = I
         JSV = J
C
C
C Depending on the vector position flag draw in both directions or only
C in one direction
C
         IF (IVPO .EQ. 0) THEN
            IDR = 1
         END IF
         IF (IVPO .LT. 0) THEN
            SGN = -1.0
         ELSE
            SGN = +1.0
         END IF
         IUC = 0
         DST = 0.0
         IPD = 0
         ICN = 0
         ICA = 0
C
      ELSE
C
C Come to here to draw in the opposite direction
C
         IDR = 0
         SGN = -1.
         I = ISV
         J = JSV
         DST = 0.0
         ITO = ITO+ICT
      END IF
C
C Initiate the drawing sequence, resetting counters.
C Start all streamlines in the center of a box.
C Find the initial normalized interpolated vector components.
C
C      NBX = 0
C      IF (IDR.NE.0) LBC = LCK+1
C      IF (LBC.GT.IPLSTL) LBC = 1
      X = REAL(I)
      Y = REAL(J)
      T = SQRT(U(I,J)*U(I,J) + V(I,J)*V(I,J))
C      if (t .eq. uvmx) then
C         write(*,*) i,j,uvmx
C      end if
      
      VMF = T / UVMX
      IF (IAV .EQ. 0) THEN
         CFR = VMF * RDMX
      ELSE
         CFR = VFL + (RDMX - VFL) * (T - UVMN) / (UVMX - UVMN)
      END IF
      IF (IVPO .EQ. 0) THEN
         CFR = CFR / 2.0
      END IF
      CALL  STDUDV(UX,VY,I,J,X,Y,DU,DV)
C
C Get initial point in the various coordinate systems
C and the tangent angle of the stream. 
C
      XDA=XLOV+(X-1.0)*XGDS
      YDA=YLOV+(Y-1.0)*YGDS
      CALL HLUSTMPXY(XDA,YDA,XUS,YUS,IST)
      IF (IST .LT. 0) GO TO 50
      XND=CUFX(XUS)
      YND=CUFY(YUS)
      XU0 = XUS
      YU0 = YUS
      X0 = XND
      Y0 = YND
      XOL = XND
      YOL = YND
      XN1=XND
      YN1=YND
      CALL HLUSTMPTA(XDA,YDA,XUS,YUS,XND,YND,DU,DV,TA,IST)
      IF (IST .LT. 0) GO TO 50
      TA0 = TA
C
      XNS=XND
      YNS=YND
      ICT=1
      IPC=1
      PX(IPC)=XUS
      PY(IPC)=YUS
      IF (ICTV .NE. 0) THEN
         CALL STITSV(P,I,J,X,Y,DS)
         SV(IPC) = DS
         SV0 = DS
      END IF
C
C Loop to this point until streamline ends
C
 110  CONTINUE
C
C Check to see if the streamline has entered a new grid box.
C
      IF (I.EQ.INT(X) .AND. J.EQ.INT(Y)) THEN
C
C Must be in same box --  Clear the point buffer if required
C
         IF (IPC .EQ. IPNPTS) THEN
            CALL STLNSG(PX,PY,SV,IPNPTS,IAM,STUMSL)
            IPD = 1
            PX(1)=PX(IPNPTS)
            PY(1)=PY(IPNPTS)
            IF (ICTV .NE. 0) THEN
               SV(1)=SV(IPNPTS)
            END IF
            IPC=1
         END IF
C
C Determine the interpolated normalized vector at this point
C
         CALL STDUDV (UX,VY,I,J,X,Y,DU,DV)
         IF (DU.EQ.0.0 .AND. DV.EQ.0.0) GO TO 50
C
C Get the tangent angle of the streamline at the current point
C in NDC space
C
         CALL HLUSTMPTA(XDA,YDA,XUS,YUS,XND,YND,DU,DV,TA,IST)
         IF (IST.NE.0) GO TO 50
C
C Count the point and add it to the point buffer
C
         ICT=ICT+1
         IPC=IPC+1
         PX(IPC)=XUS
         PY(IPC)=YUS
         IF (ICTV .NE. 0) THEN
            CALL STITSV(P,I,J,X,Y,DS)
            SV(IPC) = DS
         END IF
C
         IF (LST .EQ. 1) GO TO 50
C
C The increment in NDC space needs to be proportional to the
C magnitude of the interpolated vector, in order to ensure that
C progress checking works at points of convergence or divergence.
C The square enhances the effectiveness of the technique.
C
         DUV=(DU*DU+DV*DV)/(VNML*VNML)
         CSA=COS(TA)*SGN
         SNA=SIN(TA)*SGN
C     
C     The current point is adjusted one third of the distance back to
C     the previous point. Empirically, in most cases, this seems to
C     decrease the inaccuracy resulting from the use of a finite valued
C     differential step.
C     
         XN1=XND-(XND-XOL)/PTHREE
         YN1=YND-(YND-YOL)/PTHREE
         XOL=XND
         YOL=YND
         XND=XN1+CSA*DFMG*DUV
         YND=YN1+SNA*DFMG*DUV
         XD = XND - XOL
         YD = YND - YOL
         DST = DST + SQRT(XD*XD+YD*YD) 
C     
C     If distance is basically 0 at this point we might as well bail out of
C     this line, because we're not going to make any progress.
C     
         IF (DST .LT. 1E-12) THEN
            LST = 1
         END IF
C     
C     If the increment takes the line outside the viewport, find an
C     interpolated point on the grid edge. Set a flag indicating
C     the end of the stream
C     
         IF (XND .LT. XVPL) THEN
            XND = XVPL
            IF (ABS(CSA).GT.0.1) THEN
               TMG = (XND-XN1)/CSA
               YND = YN1+SNA*TMG
            ENDIF
            LST = 1
         ELSE IF (XND .GT. XVPR) THEN
            XND = XVPR
            IF (ABS(CSA).GT.0.1) THEN
               TMG = (XND-XN1)/CSA
               YND = YN1+SNA*TMG
            ENDIF
            LST = 1
         ELSE IF (YND .LT. YVPB) THEN
            YND = YVPB
            IF (ABS(SNA).GT.0.1) THEN
               TMG = (YND-YN1)/SNA
               XND = XN1+CSA*TMG
            END IF
            LST = 1
         ELSE IF (YND .GT. YVPT) THEN
            YND = YVPT
            IF (ABS(SNA).GT.0.1) THEN
               TMG = (YND-YN1)/SNA
               XND = XN1+CSA*TMG
            END IF
            LST = 1
         END IF
         IF (LST .EQ. 1 .AND. DST .LT. CFR .AND. IVPO .GE. 0) THEN
            ICA = 1
         END IF
         IF (DST .GT. CFR) THEN
            LST = 1
         END IF
C     
C     Now that the new point has been found in NDC space, find its
C     coordinates in user, data, and grid space.
C     
         XU1=XUS
         YU1=YUS
         XUS=CFUX(XND)
         YUS=CFUY(YND)
C     
C     Even if the point is within NDC and User boundaries it can still be 
C     outside the data area. In this case we use an iterative technique to
C     determine the end of the streamline.
C     
         CALL HLUSTIMXY(XUS,YUS,XDA,YDA,IST)
         IF (IST.GE.0) THEN
            X=(XDA-XLOV)/XGDS+1.0
            Y=(YDA-YLOV)/YGDS+1.0
         ELSE
            NCT=1
C     
C     Loop to this point dividing the distance in half at each step
C     
 120        CONTINUE
            XT=XU1+(XUS-XU1)/2.0
            YT=YU1+(YUS-YU1)/2.0
            IF (NCT.GE.PMXITR) GO TO 50
            IF (ABS(XUS-XU1).LE.PSMALL .AND. 
     +           ABS(YUS-YU1).LE.PSMALL) THEN
               XUS=XU1
               YUS=YU1
               CALL HLUSTIMXY(XUS,YUS,XDA,YDA,IST)
               IF (IST.LT.0) THEN
                  IF (DST .LT. CFR) THEN
                     ICA = 1
                  END IF
                  GO TO 50
               END IF
            ELSE
               CALL HLUSTIMXY(XT,YT,XDA,YDA,IST)
               NCT=NCT+1
               IF (IST.LT.0) THEN
                  XUS=XT
                  YUS=YT
               ELSE
                  XU1=XT
                  YU1=YT
               END IF
               GO TO 120
            END IF
C     
            XND=CUFX(XUS)
            YND=CUFY(YUS)
            LST=1
            IF (DST .LT. CFR) THEN
               ICA = 1
            END IF
         END IF
C     
C     
C     If on the top or right edge of the grid space, decrease the X and/or
C     Y value by a small amount so the interpolation routine still works.
C     
         IF (INT(X).GE.IXDM) X=REAL(IXDM)-PSMALL
         IF (INT(Y).GE.IYDN) Y=REAL(IYDN)-PSMALL
C
C Check streamline progress every 'ICKP' iterations.
C
         IF (MOD(ICT,ICKP).EQ.0) THEN
            IF (ABS(XND-XNS).LT.CDS 
     +           .AND. ABS(YND-YNS).LT.CDS) THEN
               GO TO 50
            END IF
            XNS=XND
            YNS=YND
         END IF
C
C If the circular list does not need to be checked for
C streamline crossover, return to the top of the main loop.
C
         IF (ICKX.LT.0 .OR. MOD(ICT,ICKX).NE.0) GO TO 110
C
      ELSE
C
C Must have entered a new grid box  check for the following :
C (1) Check for missing data if msg data flag (ISVF) has been set.
C     cancel the line if nothing has been drawn.
C
         I = INT(X)
         J = INT(Y)
C
C Check (1)
C
         IF (ISVF.NE.0) THEN
            CALL STSVCK(U,V,I,J,IST)
            IF (IST .NE. 0) THEN
               IF (IPD .EQ. 0) THEN
                  ICN = 1
               END IF
               GO TO 50
            END IF
         END IF
C
      END IF
C
C Mark the grid box as drawn
C
      CALL SBYTES(UX(I,J),IPONE,IS1,1,0,1)
C
C Return to top of drawing loop
C
      GO TO 110
C
C
C Final exit
C
  190 CONTINUE
C
      IF (IZO .EQ. 1) THEN
         CALL STZERO
      END IF
C
C Plot statistics
C
      IF (ISST.EQ.1) THEN
         LUN=I1MACH(2)
         WRITE(LUN,*) 'STREAM Statistics'
         WRITE(LUN,*) '                Streamlines plotted:',LCT
         WRITE(LUN,*) '      Total differential step count:',ITO
         WRITE(LUN,*) ' '
      END IF
C
C Set the workspace used parameter
C
      IWKU = 2*IXDM*IYDN
C
      RETURN
      END
C
C -------------------------------------------------------------------
C
      SUBROUTINE STILNS(VRL,VFL,IAV)
C
C This subroutine is used only for curly vector mode  
C
C This subroutine initializes a number of variables that control the
C mapping between vector magnitude and the NDC length of the arrow.
C
C Input paramters:
C
C Output parameters:
C
C VRL - length of reference vector in NDC
C IAV - Adjust vector length flag (based on fractional length - VFL)
C VFL - Length in fractional coordinates of the adjusted minimum
C       vector
C
C ---------------------------------------------------------------------
C
C NOTE:
C Since implicit typing is used for all real and integer variables
C a consistent length convention has been adopted to help clarify the
C significance of the variables encountered in the code for this 
C utility. All local variable and subroutine parameter identifiers 
C are limited to 1,2,or 3 characters. Four character names identify  
C members of common blocks. Five and 6 character variable names 
C denote PARAMETER constants or subroutine or function names.
C
C Declare the ST common blocks.
C
      PARAMETER (IPLVLS = 256)
C
C Integer and real common block variables
C
C
      COMMON / STPAR /
     +                IUD1       ,IVD1       ,IPD1       ,
     +                IXD1       ,IXDM       ,IYD1       ,IYDN       ,
     +                IXM1       ,IYM1       ,IXM2       ,IYM2       ,
     +                IWKD       ,IWKU       ,ISET       ,IERR       ,
     +                IXIN       ,IYIN       ,IMSK       ,ICPM       ,
     +                NLVL       ,IPAI       ,ICTV       ,WDLV       ,
     +                UVMN       ,UVMX       ,PMIN       ,PMAX       ,
     +                IPLR       ,ISST       ,
     +                ICLR(IPLVLS)           ,TVLU(IPLVLS)
C
      COMMON / STTRAN /
     +                UVPS       ,
     +                UVPL       ,UVPR       ,UVPB       ,UVPT       ,
     +                UWDL       ,UWDR       ,UWDB       ,UWDT       ,
     +                UXC1       ,UXCM       ,UYC1       ,UYCN 
C
C Stream algorithm parameters
C
      COMMON / STSTRM /
     +                ISGD       ,IAGD       ,RARL       ,ICKP       ,
     +                ICKX       ,ITRP       ,ICYK       ,RVNL       ,
     +                ISVF       ,RUSV       ,RVSV       ,RNDA       ,
     +                ISPC       ,RPSV       ,RCDS       ,RSSP       ,
     +                RDFM       ,RSMD       ,RAMD       ,IGBS       ,
     +                ISTM       ,RVRL       ,RVFR       ,RVRM       ,
     +                IVPO       ,RAFR       ,RDMX       ,RDMN
C
C Text related parameters
C Note: graphical text output is not yet implemented for the
C       Streamline utility.
C
      COMMON / STTXP /
     +                FCWM    ,ICSZ    ,
     +                FMNS    ,FMNX    ,FMNY    ,IMNP    ,IMNC  ,
     +                FMXS    ,FMXX    ,FMXY    ,IMXP    ,IMXC  ,
     +                FZFS    ,FZFX    ,FZFY    ,IZFP    ,IZFC  ,
     +                FILS    ,FILX    ,FILY    ,IILP    ,IILC 
C
C Character variable declartions
C
      CHARACTER*160 CSTR
      PARAMETER (IPCHSZ=80)
      CHARACTER*(IPCHSZ)  CMNT,CMXT,CZFT,CILT
C
C Text string parameters
C
      COMMON / STCHAR / CSTR,CMNT,CMXT,CZFT,CILT
C
      SAVE /STPAR/, /STTRAN/, /STSTRM/, /STTXP/, /STCHAR/
C
C Internal buffer lengths
C
C IPNPTS - Number of points in the point buffer -- not less than 3
C IPLSTL - Streamline-crossover-check circular list length
C IPGRCT - Number of groups supported for area masking
C
      PARAMETER (IPNPTS = 256, IPLSTL = 750, IPGRCT = 64)
C --------------------------------------------------------------------
C
C The mapping common block: made available to user mapping routines
C
      COMMON /STMAP/
     +                IMAP       ,LNLG       ,INVX       ,INVY       ,
     +                XLOV       ,XHIV       ,YLOV       ,YHIV       ,
     +                WXMN       ,WXMX       ,WYMN       ,WYMX       ,
     +                XVPL       ,XVPR       ,YVPB       ,YVPT       ,
     +                XGDS       ,YGDS       ,NXCT       ,NYCT       ,
     +                ITRT       ,FW2W       ,FH2H       ,
     +                DFMG       ,VNML       ,RBIG       ,IBIG
C
      SAVE /STMAP/
C
C Math constants
C
      PARAMETER (PDTOR  = 0.017453292519943,
     +           PRTOD  = 57.2957795130823,
     +           P1XPI  = 3.14159265358979,
     +           P2XPI  = 6.28318530717959,
     +           P1D2PI = 1.57079632679489,
     +           P5D2PI = 7.85398163397448) 
C         
C
      VRL = RDMX
      VFL = RDMN
      IAV = 0
C
C
C Determine the length of the maximum, minimum and reference
C vector magnitudes in NDC. Once these values are calculated
C the maximum vector length only is used for scaling purposes
C in the VVMPXY routine. Its value is also calculated in user
C coordinates. This value may not be useful to VVMPXY if the 
C user coordinate system is not uniform.
C
C There are a number of ways these lengths may be determined,
C depending on whether the user has specified (1) a 
C reference magnitude, (2) a reference length, or (3) a fractional
C size for the minimum magnitude. 
C
C 
      VFR = MIN(1.0, RVFR)
C
C If the field is uniform, special conditions apply
C
      IF (UVMX - UVMN .LE. 0.0) THEN
         IF (RVRL .GT. 0.0 .AND. RVRM .GT. 0.0) THEN
            VRL=RVRL*FW2W
            RDMX=VRL*UVMX/RVRM
         ELSE IF (RVRM .GT. 0.0) THEN
            VRL=RDMX*RVRM/UVMX
         ELSE IF (RVRL .GT. 0.0) THEN
            RDMX=RVRL*FW2W
            VRL=RDMX
         END IF
         VFL=VRL
         RDMN=VFL
C
C If no reference magnitude specified, the maximum magnitude
C is used as the reference magnitude
C
      ELSE IF (RVRM .LE. 0.0) THEN
         IF (RVRL .GT. 0.0) THEN
            RDMX=RVRL*FW2W
         END IF
         VRL=RDMX
         IF (VFR .GT. 0.0) THEN
            IAV=1
            VFL=VFR*RDMX
            RDMN=VFL
         ELSE
            RDMN=RDMX*(UVMN/UVMX)
            VFL=RDMN
         END IF
C
C If the reference magnitude is less than the minimum magnitude,
C the fractional size is ignored if a reference length is also
C specified. Otherwise, the fractional size determines not the
C minimum magnitude length, but the reference magnitude length.
C
      ELSE IF (RVRM .LE. UVMN) THEN
         IAV=1
         IF (RVRL .GT. 0.0) THEN
            VRL=RVRL*FW2W
            RDMX=VRL*UVMX/RVRM
         ELSE IF (VFR .GT. 0.0) THEN
            VRL=RDMX*VFR
         ELSE
            VRL=RDMX*RVRM/UVMX
         END IF
         RDMN=VRL*UVMN/RVRM
         VFL=RDMN
C
C A reference magnitude is specified, as well as a fractional
C magnitude. The min magnitude length is the fractional size 
C times the reference length. If a reference length is specified, 
C it becomes the length of the reference magnitude.  The maximum
C magnitude is determined proportionally. If no reference length
C is specified, the reference length is set proportionally to
C the default size assigned to the maximum magnitude.
C
      ELSE IF (VFR .GT. 0.0) THEN
         IAV=1
         IF (RVRL .GT. 0.0) THEN
            VRL=RVRL*FW2W
            VFL=VFR*VRL
            RDMN=VFL
            RDMX=RDMN+(VRL-RDMN)*(UVMX-UVMN)/(RVRM-UVMN)
         ELSE
            RAT=(RVRM-UVMN)/(UVMX-UVMN)
            VRL=RDMX*RAT/(1.0-VFR+VFR*RAT)
            VFL=VFR*VRL
            RDMN=VFL
         END IF
C
C A reference magnitude is specified. If a reference length is 
C specified, it becomes the length of the reference magnitude.
C Otherwise the reference magnitude's length is proportional
C to the default length assigned to the maximum magnitude.
C The min magnitude length is then determined proportionally
C to both these values.
C
      ELSE
         IF (RVRL .GT. 0.0) THEN
            VRL=RVRL*FW2W
            RDMX=VRL*UVMX/RVRM
            VFL=VRL*UVMN/RVRM
            RDMN=VFL
         ELSE
            VRL=RDMX*RVRM/UVMX
            VFL=RDMX*UVMN/UVMX
            RDMN=VFL
         END IF
      END IF
C
C Done
C
      RETURN
      END

C
C	$Id: genneg.f,v 1.4 2008-07-27 00:20:57 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GENNEG(NUMIN,NUMOUT)
C
C  Where NUMIN has a 2's complement number in the low-order 16 bits,
C  this subroutine returns the equivalent number in the representation
C  of the host machine.
C
      NUMOUT = 0
      ISGN = IAND(ISHIFT(NUMIN,-15),1) 
C
C  If input is a positive number, set output to input.
C
      IF (ISGN .EQ. 0) THEN
        NUMOUT = NUMIN
        RETURN
      ELSE
C
C  Set NUMOUT from 1's complement plus 1.
C
        NUMTMP = IAND(32767,NUMIN)
        NUMTMP = 32767-NUMTMP
        NUMOUT = -(NUMTMP+1)
      ENDIF
      RETURN
C
      END

C
C $Id: pcffhl.f,v 1.6 2008-07-27 00:17:19 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE PCFFHL (NCI,JNDX,XORIG,YORIG,NCO,JNDXO,RDGU)       
C
      include 'pcffdx.h'
      include 'pcffsp.h'
C
C Process holes.
C
      DIMENSION RDGU(*)
C
      JNDXO = JNDX
      NDX = NCI
C
   10 CONTINUE
      NDX = NDX+1
C
      IF (SFLGS(NDX) .EQ. 3) THEN
C
C  End hole, connect the last point back to the initial point if not
C  an outline font.
C
        IF (OUTLIN .EQ. 0) THEN
          JNDXO = JNDXO+1 
          RDGU(JNDXO) = XORIG
          JNDXO = JNDXO+1 
          RDGU(JNDXO) = YORIG
        ENDIF
C
C  Terminate the line if an outline font has been requested and
C  set the next point in the new line back to the original
C  point upon entry to this subroutine.
C
        IF (OUTLIN .EQ. 1) THEN
          JNDXO = JNDXO+1
          RDGU(JNDXO) = -2048.
          JNDXO = JNDXO+1 
          RDGU(JNDXO) = 0.
          JNDXO = JNDXO+1
          RDGU(JNDXO) = XORIG
          JNDXO = JNDXO+1
          RDGU(JNDXO) = YORIG
        ENDIF
        NCO = NDX
        RETURN
      ELSE IF (SFLGS(NDX) .EQ. 0) THEN
C
C  Add coordinate to the current path.
C
        JNDXO = JNDXO+1
        RDGU(JNDXO) = XC(NDX)
        JNDXO = JNDXO+1
        RDGU(JNDXO) = YC(NDX)
        GO TO 10
      ELSE IF (SFLGS(NDX) .EQ. 4) THEN
C
C  Process the Bezier curve.
C
          BCNTLX(1) = RDGU(JNDXO-1)
          BCNTLY(1) = RDGU(JNDXO)
          DO 30 IB=2,4
            BCNTLX(IB) = XC(NDX+IB-2)
            BCNTLY(IB) = YC(NDX+IB-2)
   30     CONTINUE
C
          CALL BCCURV(BCNTLX,BCNTLY,IBZL,BZXC,BZYC,NBP)
          DO 60 K=2,NBP
            JNDXO = JNDXO+1
            RDGU(JNDXO) = BZXC(K)
            JNDXO = JNDXO+1
            RDGU(JNDXO) = BZYC(K)
   60     CONTINUE
          NDX = NDX+2
          GO TO 10
      ELSE
          PRINT * , 'PCFFHL -- Invalid fontcap encoding encountered.'
          STOP
      ENDIF
C
      END

      subroutine  zswap (n,zx,incx,zy,incy)
c
c     interchanges two vectors.
c     jack dongarra, 3/11/78.
c     modified 12/3/93, array(1) declarations changed to array(*)
c
      double complex zx(*),zy(*),ztemp
      integer i,incx,incy,ix,iy,n
c
      if(n.le.0)return
      if(incx.eq.1.and.incy.eq.1)go to 20
c
c       code for unequal increments or equal increments not equal
c         to 1
c
      ix = 1
      iy = 1
      if(incx.lt.0)ix = (-n+1)*incx + 1
      if(incy.lt.0)iy = (-n+1)*incy + 1
      do 10 i = 1,n
        ztemp = zx(ix)
        zx(ix) = zy(iy)
        zy(iy) = ztemp
        ix = ix + incx
        iy = iy + incy
   10 continue
      return
c
c       code for both increments equal to 1
   20 do 30 i = 1,n
        ztemp = zx(i)
        zx(i) = zy(i)
        zy(i) = ztemp
   30 continue
      return
      end

      SUBROUTINE DORMBR( VECT, SIDE, TRANS, M, N, K, A, LDA, TAU, C,
     $                   LDC, WORK, LWORK, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          SIDE, TRANS, VECT
      INTEGER            INFO, K, LDA, LDC, LWORK, M, N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), C( LDC, * ), TAU( * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  If VECT = 'Q', DORMBR overwrites the general real M-by-N matrix C
*  with
*                  SIDE = 'L'     SIDE = 'R'
*  TRANS = 'N':      Q * C          C * Q
*  TRANS = 'T':      Q**T * C       C * Q**T
*
*  If VECT = 'P', DORMBR overwrites the general real M-by-N matrix C
*  with
*                  SIDE = 'L'     SIDE = 'R'
*  TRANS = 'N':      P * C          C * P
*  TRANS = 'T':      P**T * C       C * P**T
*
*  Here Q and P**T are the orthogonal matrices determined by DGEBRD when
*  reducing a real matrix A to bidiagonal form: A = Q * B * P**T. Q and
*  P**T are defined as products of elementary reflectors H(i) and G(i)
*  respectively.
*
*  Let nq = m if SIDE = 'L' and nq = n if SIDE = 'R'. Thus nq is the
*  order of the orthogonal matrix Q or P**T that is applied.
*
*  If VECT = 'Q', A is assumed to have been an NQ-by-K matrix:
*  if nq >= k, Q = H(1) H(2) . . . H(k);
*  if nq < k, Q = H(1) H(2) . . . H(nq-1).
*
*  If VECT = 'P', A is assumed to have been a K-by-NQ matrix:
*  if k < nq, P = G(1) G(2) . . . G(k);
*  if k >= nq, P = G(1) G(2) . . . G(nq-1).
*
*  Arguments
*  =========
*
*  VECT    (input) CHARACTER*1
*          = 'Q': apply Q or Q**T;
*          = 'P': apply P or P**T.
*
*  SIDE    (input) CHARACTER*1
*          = 'L': apply Q, Q**T, P or P**T from the Left;
*          = 'R': apply Q, Q**T, P or P**T from the Right.
*
*  TRANS   (input) CHARACTER*1
*          = 'N':  No transpose, apply Q  or P;
*          = 'T':  Transpose, apply Q**T or P**T.
*
*  M       (input) INTEGER
*          The number of rows of the matrix C. M >= 0.
*
*  N       (input) INTEGER
*          The number of columns of the matrix C. N >= 0.
*
*  K       (input) INTEGER
*          If VECT = 'Q', the number of columns in the original
*          matrix reduced by DGEBRD.
*          If VECT = 'P', the number of rows in the original
*          matrix reduced by DGEBRD.
*          K >= 0.
*
*  A       (input) DOUBLE PRECISION array, dimension
*                                (LDA,min(nq,K)) if VECT = 'Q'
*                                (LDA,nq)        if VECT = 'P'
*          The vectors which define the elementary reflectors H(i) and
*          G(i), whose products determine the matrices Q and P, as
*          returned by DGEBRD.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.
*          If VECT = 'Q', LDA >= max(1,nq);
*          if VECT = 'P', LDA >= max(1,min(nq,K)).
*
*  TAU     (input) DOUBLE PRECISION array, dimension (min(nq,K))
*          TAU(i) must contain the scalar factor of the elementary
*          reflector H(i) or G(i) which determines Q or P, as returned
*          by DGEBRD in the array argument TAUQ or TAUP.
*
*  C       (input/output) DOUBLE PRECISION array, dimension (LDC,N)
*          On entry, the M-by-N matrix C.
*          On exit, C is overwritten by Q*C or Q**T*C or C*Q**T or C*Q
*          or P*C or P**T*C or C*P or C*P**T.
*
*  LDC     (input) INTEGER
*          The leading dimension of the array C. LDC >= max(1,M).
*
*  WORK    (workspace/output) DOUBLE PRECISION array, dimension (LWORK)
*          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*
*  LWORK   (input) INTEGER
*          The dimension of the array WORK.
*          If SIDE = 'L', LWORK >= max(1,N);
*          if SIDE = 'R', LWORK >= max(1,M).
*          For optimum performance LWORK >= N*NB if SIDE = 'L', and
*          LWORK >= M*NB if SIDE = 'R', where NB is the optimal
*          blocksize.
*
*          If LWORK = -1, then a workspace query is assumed; the routine
*          only calculates the optimal size of the WORK array, returns
*          this value as the first entry of the WORK array, and no error
*          message related to LWORK is issued by XERBLA.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*
*  =====================================================================
*
*     .. Local Scalars ..
      LOGICAL            APPLYQ, LEFT, LQUERY, NOTRAN
      CHARACTER          TRANST
      INTEGER            I1, I2, IINFO, LWKOPT, MI, NB, NI, NQ, NW
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            ILAENV
      EXTERNAL           LSAME, ILAENV
*     ..
*     .. External Subroutines ..
      EXTERNAL           DORMLQ, DORMQR, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN
*     ..
*     .. Executable Statements ..
*
*     Test the input arguments
*
      INFO = 0
      APPLYQ = LSAME( VECT, 'Q' )
      LEFT = LSAME( SIDE, 'L' )
      NOTRAN = LSAME( TRANS, 'N' )
      LQUERY = ( LWORK.EQ.-1 )
*
*     NQ is the order of Q or P and NW is the minimum dimension of WORK
*
      IF( LEFT ) THEN
         NQ = M
         NW = N
      ELSE
         NQ = N
         NW = M
      END IF
      IF( .NOT.APPLYQ .AND. .NOT.LSAME( VECT, 'P' ) ) THEN
         INFO = -1
      ELSE IF( .NOT.LEFT .AND. .NOT.LSAME( SIDE, 'R' ) ) THEN
         INFO = -2
      ELSE IF( .NOT.NOTRAN .AND. .NOT.LSAME( TRANS, 'T' ) ) THEN
         INFO = -3
      ELSE IF( M.LT.0 ) THEN
         INFO = -4
      ELSE IF( N.LT.0 ) THEN
         INFO = -5
      ELSE IF( K.LT.0 ) THEN
         INFO = -6
      ELSE IF( ( APPLYQ .AND. LDA.LT.MAX( 1, NQ ) ) .OR.
     $         ( .NOT.APPLYQ .AND. LDA.LT.MAX( 1, MIN( NQ, K ) ) ) )
     $          THEN
         INFO = -8
      ELSE IF( LDC.LT.MAX( 1, M ) ) THEN
         INFO = -11
      ELSE IF( LWORK.LT.MAX( 1, NW ) .AND. .NOT.LQUERY ) THEN
         INFO = -13
      END IF
*
      IF( INFO.EQ.0 ) THEN
         IF( APPLYQ ) THEN
            IF( LEFT ) THEN
               NB = ILAENV( 1, 'DORMQR', SIDE // TRANS, M-1, N, M-1,
     $              -1 )
            ELSE
               NB = ILAENV( 1, 'DORMQR', SIDE // TRANS, M, N-1, N-1,
     $              -1 )
            END IF
         ELSE
            IF( LEFT ) THEN
               NB = ILAENV( 1, 'DORMLQ', SIDE // TRANS, M-1, N, M-1,
     $              -1 )
            ELSE
               NB = ILAENV( 1, 'DORMLQ', SIDE // TRANS, M, N-1, N-1,
     $              -1 )
            END IF
         END IF
         LWKOPT = MAX( 1, NW )*NB
         WORK( 1 ) = LWKOPT
      END IF
*
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DORMBR', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         RETURN
      END IF
*
*     Quick return if possible
*
      WORK( 1 ) = 1
      IF( M.EQ.0 .OR. N.EQ.0 )
     $   RETURN
*
      IF( APPLYQ ) THEN
*
*        Apply Q
*
         IF( NQ.GE.K ) THEN
*
*           Q was determined by a call to DGEBRD with nq >= k
*
            CALL DORMQR( SIDE, TRANS, M, N, K, A, LDA, TAU, C, LDC,
     $                   WORK, LWORK, IINFO )
         ELSE IF( NQ.GT.1 ) THEN
*
*           Q was determined by a call to DGEBRD with nq < k
*
            IF( LEFT ) THEN
               MI = M - 1
               NI = N
               I1 = 2
               I2 = 1
            ELSE
               MI = M
               NI = N - 1
               I1 = 1
               I2 = 2
            END IF
            CALL DORMQR( SIDE, TRANS, MI, NI, NQ-1, A( 2, 1 ), LDA, TAU,
     $                   C( I1, I2 ), LDC, WORK, LWORK, IINFO )
         END IF
      ELSE
*
*        Apply P
*
         IF( NOTRAN ) THEN
            TRANST = 'T'
         ELSE
            TRANST = 'N'
         END IF
         IF( NQ.GT.K ) THEN
*
*           P was determined by a call to DGEBRD with nq > k
*
            CALL DORMLQ( SIDE, TRANST, M, N, K, A, LDA, TAU, C, LDC,
     $                   WORK, LWORK, IINFO )
         ELSE IF( NQ.GT.1 ) THEN
*
*           P was determined by a call to DGEBRD with nq <= k
*
            IF( LEFT ) THEN
               MI = M - 1
               NI = N
               I1 = 2
               I2 = 1
            ELSE
               MI = M
               NI = N - 1
               I1 = 1
               I2 = 2
            END IF
            CALL DORMLQ( SIDE, TRANST, MI, NI, NQ-1, A( 1, 2 ), LDA,
     $                   TAU, C( I1, I2 ), LDC, WORK, LWORK, IINFO )
         END IF
      END IF
      WORK( 1 ) = LWKOPT
      RETURN
*
*     End of DORMBR
*
      END

C
C	$Id: g01seg.f,v 1.9 2008-07-27 00:21:06 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE G01SEG
C
C  This subroutine processes the copy segment function for CGM
C  output.
C
C     For FCODE = 82  --  copy segment to workstation
C
C-------------------------------------------------------------
C
C
C       DEFINITION OF ALL COMMONS.
C
      include 'g01prm.h'
      include 'gksin.h'
      include 'g01io.h'
C
      CHARACTER*1 DNAME
C     CHARACTER CURNAM*7,NLIST(100)*80,FNAME*80,DNAME*1
C     CHARACTER*80 IDR(1),ODR(1)
C     INTEGER SEGID(100),IFLEN(100)
      INTEGER TBUF(720)
C
      SAVE
C
C     DATA LINDX/0/
C
      ICODE = FCODE
      IF (ICODE .NE. 82) THEN
        PRINT * , 'G01SEG -- internal error, see consultant'
        STOP
      ENDIF
C
      IF (IL2 .GT. 0) THEN
        IFUNIT = ID(1)
        INAME  = ID(2)
        MAXREC = ID(3)
      ENDIF
C
C  Flush the output buffer.
C
      IER = 0
      CALL G01FLB(IER)
      IF (IER .NE. 0) THEN
        RERR = 303
        GO TO 110
      ENDIF
C
C  Open the segment for reading.
C
      CALL GTNLEN(STR,ILEN,IER)
      STR(ILEN+1:ILEN+1) = CHAR(0)
      CALL G01MIO(8, IFUNIT, STR(1:ILEN), IDUM1, IDUM2, IER)
      IF (IER .NE. 0) THEN
        RERR = -105
        GO TO 110
      ENDIF
      MRCOLD = MRECNM
      CALL G01MIO(5, IFUNIT, DNAME, IDUM1, IDUM2, IER)
      MRECNM = 1
C
      DO 30 I=1,MAXREC
      MRECNM = I
      CALL G01MIO(4, IFUNIT, DNAME, TBUF, MOBFSZ, IER)
      MRECNM = MRCOLD+I-1
      CALL G01MIO(3,MFGLUN,DNAME,TBUF,MOBFSZ,IER)
      IF (IER .NE. 0) THEN
        RERR = 303
        GO TO 110
      ENDIF
   30 CONTINUE
C
C  Close the segment; flush the output buffer.
C
      CALL G01MIO(2, IFUNIT, DNAME, IDUM1, IDUM2, IER)
      MRECNM = MRCOLD+MAXREC
      CALL G01FLB(IERR)
      IF (IER .NE. 0) THEN
        RERR = 303
        GO TO 110
      ENDIF
C
C  Re-establish original attribute settings.
C
      CALL G01DMP(1)
      RETURN
  110 CONTINUE
      MRECNM = MRCOLD
      RETURN
C
      END

C
C $Id: mdilnb.f,v 1.2 2008-07-27 00:17:06 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      INTEGER FUNCTION MDILNB (CHRS)
C
        CHARACTER*(*) CHRS
C
C The value of MDILNB(CHRS) is the index of the last non-blank in the
C character string CHRS.
C
C Declare local variables.
C
        INTEGER I
C
        DO 101 I=LEN(CHRS),1,-1
          IF (CHRS(I:I).NE.' ') THEN
            MDILNB=I
            RETURN
          END IF
  101   CONTINUE
C
        MDILNB=1
C
        RETURN
C
      END

C
C	$Id: cssig2.f,v 1.5 2008-07-27 03:10:08 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      DOUBLE PRECISION FUNCTION CSSIG2 (N1,N2,N,X,Y,Z,H,LIST,
     .                                LPTR,LEND,GRAD,TOL,
     .                                IFLGS, SIGMA, IER)
      INTEGER N1, N2, N, LIST(*), LPTR(*), LEND(N), IFLGS,
     .        IER
      DOUBLE PRECISION X(N), Y(N), Z(N), H(N), GRAD(3,N),
     .                 TOL, SIGMA(*)
C
C***********************************************************
C
C                                              From SSRFPACK
C                                            Robert J. Renka
C                                  Dept. of Computer Science
C                                       Univ. of North Texas
C                                           renka@cs.unt.edu
C                                                   07/25/96
C
C   Given a triangulation of a set of nodes on the unit
C sphere, along with data values H and gradients GRAD at the
C nodes, this function determines the smallest tension fac-
C tor CSSIG2 such that the Hermite interpolatory tension
C spline H(A), defined by CSSIG2 and the endpoint values and
C directional derivatives associated with an arc N1-N2,
C preserves convexity (or concavity) of the data:
C
C   HP1 .LE. S .LE. HP2 implies HPP(A) .GE. 0, and
C   HP1 .GE. S .GE. HP2 implies HPP(A) .LE. 0
C
C for all A in the open interval (A1,A2) corresponding to
C the arc, where HP1 and HP2 are the derivative values of H
C at the endpoints, S is the slope of the linear interpolant
C of the endpoint data values, HPP denotes the second deriv-
C ative of H, and A is arc-length.  Note, however, that
C infinite tension is required if HP1 = S or HP2 = S (unless
C HP1 = HP2 = S).
C
C On input:
C
C       N1,N2 = Nodal indexes of the endpoints of an arc for
C               which the tension factor is to be computed.
C               The indexes must be distinct and lie in the
C               range 1 to N, and if IFLGS .GE. 1, they must
C               correspond to adjacent nodes in the triangu-
C               lation.
C
C       N = Number of nodes in the triangulation.  N .GE. 3.
C
C       X,Y,Z = Arrays of length N containing coordinates of
C               the nodes.  X(I)**2 + Y(I)**2 + Z(I)**2 = 1.
C
C       H = Array of length N containing data values at the
C           nodes.  H(I) is associated with (X(I),Y(I),Z(I))
C           for I = 1 to N.
C
C       LIST,LPTR,LEND = Data structure defining the trian-
C                        gulation.  Refer to STRIPACK
C                        Subroutine CSTRMESH.
C
C       GRAD = Array dimensioned 3 by N whose columns con-
C              gradients at the nodes.  GRAD( ,J) must be
C              orthogonal to node J:  GRAD(1,J)*X(J) +
C              GRAD(2,J)*Y(J) + GRAD(3,J)*Z(J) = 0.  Refer
C              to Subroutines CSGRADG, CSGRADL, and CSSMSURF.
C
C       TOL = Tolerance whose magnitude determines how close
C             CSSIG2 is to its optimal value when nonzero
C             finite tension is necessary and sufficient to
C             satisfy convexity or concavity.  In the case
C             convexity, CSSIG2 is chosen so that 0 .LE.
C             HPPMIN .LE. abs(TOL), where HPPMIN is the
C             minimum value of HPP on the arc.  In the case
C             of concavity, the maximum value of HPP satis-
C             fies -abs(TOL) .LE. HPPMAX .LE. 0.  Thus, the
C             constraint is satisfied but possibly with more
C             tension than necessary.
C
C       IFLGS = Tension array option indicator:
C               IFLGS .LE. 0 if SIGMA is not to be used.
C               IFLGS .GE. 1 if SIGMA is to be updated by
C                            storing CSSIG2 in the appropriate
C                            locations.
C
C The above parameters are not altered by this function.
C
C       SIGMA = Dummy parameter (IFLGS .LE. 0) or array
C               containing tension factors associated with
C               arcs in one-to-one correspondence with LIST
C               entries (IFLGS .GE. 1).  Refer to Subroutine
C               CSGETSIG.
C
C On output:
C
C       SIGMA = Tension factor array updated with the new
C               value if and only if IFLGS .GE. 1 and IER
C               .GE. 0.
C
C       IER = Error indicator:
C             IER = 0 if no errors were encountered and fin-
C                     ite tension is sufficient to satisfy
C                     convexity (or concavity).
C             IER = 1 if no errors were encountered but in-
C                     finite tension is required to satisfy
C                     convexity.
C             IER = 2 if the data does not satisfy convexity
C                     or concavity.
C             IER = -1 if N1, N2, or N is outside its valid
C                      range.
C             IER = -2 if nodes N1 and N2 coincide or IFLGS
C                      .GE. 1 and the nodes are not adja-
C                      cent.
C
C       CSSIG2 = Minimum tension factor defined above unless
C              IER < 0, in which case CSSIG2 = -1.  If IER
C              = 1, CSSIG2 is set to 85, resulting in an
C              approximation to the linear interpolant of
C              the endpoint values.  If IER = 2, CSSIG2 = 0,
C              resulting in the Hermite cubic interpolant.
C
C STRIPACK module required by CSSIG2:  CSSTORE
C
C SSRFPACK modules required by CSSIG2:  CSARCLEN, CSSNHCSH
C
C Intrinsic functions called by CSSIG2:  ABS, EXP, MAX, MIN,
C                                        SQRT
C
C***********************************************************
C
      DOUBLE PRECISION CSARCLEN, CSSTORE
      INTEGER LP1, LP2, LPL, LUN, NIT
      DOUBLE PRECISION AL, COSHM, D1, D1D2, D2, DSIG, DUMMY,
     .                 EMS, F, FP, FTOL, P1(3), P2(3), RTOL,
     .                 S, SBIG, SIG, SINHM, SSM, T, T1, TP1,
     .                 UN(3), UNORM
C
      DATA SBIG/85./,  LUN/-1/
C
C Print a heading.
C
      IF (LUN .GE. 0) WRITE (LUN,100) N1, N2
  100 FORMAT (//1X,'CSSIG2 -- N1 =',I4,', N2 =',I4)
C
C Test for errors and set local parameters.
C
      IER = -1
      IF (MIN(N1,N2) .LT. 1  .OR.  N1 .EQ. N2  .OR.
     .    MAX(N1,N2,3) .GT. N) GO TO 11
      IER = -2
      IF (IFLGS .GT. 0) THEN
C
C   Set LP1 and LP2 to the pointers to N2 as a neighbor of
C     N1 and N1 as a neighbor of N2, respectively.
C
        LPL = LEND(N1)
        LP1 = LPTR(LPL)
    1   IF (LIST(LP1) .EQ. N2) GO TO 2
          LP1 = LPTR(LP1)
          IF (LP1 .NE. LPL) GO TO 1
        IF (ABS(LIST(LP1)) .NE. N2) GO TO 11
C
    2   LPL = LEND(N2)
        LP2 = LPTR(LPL)
    3   IF (LIST(LP2) .EQ. N1) GO TO 4
          LP2 = LPTR(LP2)
          IF (LP2 .NE. LPL) GO TO 3
        IF (ABS(LIST(LP2)) .NE. N1) GO TO 11
      ENDIF
C
C Store nodal coordinates P1 and P2, compute arc-length AL
C   and unit normal UN = (P1 X P2)/UNORM, and test for
C   coincident nodes.
C
    4 P1(1) = X(N1)
      P1(2) = Y(N1)
      P1(3) = Z(N1)
      P2(1) = X(N2)
      P2(2) = Y(N2)
      P2(3) = Z(N2)
      AL = CSARCLEN(P1,P2)
      UN(1) = P1(2)*P2(3) - P1(3)*P2(2)
      UN(2) = P1(3)*P2(1) - P1(1)*P2(3)
      UN(3) = P1(1)*P2(2) - P1(2)*P2(1)
      UNORM = SQRT(UN(1)*UN(1) + UN(2)*UN(2) + UN(3)*UN(3))
      IF (UNORM .EQ. 0.  .OR.  AL .EQ. 0.) GO TO 11
C
C Compute first and second differences and test for infinite
C   tension required.
C
      S = H(N2) - H(N1)
      D1 = S - AL*(GRAD(1,N1)*P2(1) + GRAD(2,N1)*P2(2) +
     .             GRAD(3,N1)*P2(3))/UNORM
      D2 = -AL*(GRAD(1,N2)*P1(1) + GRAD(2,N2)*P1(2) +
     .          GRAD(3,N2)*P1(3))/UNORM - S
      D1D2 = D1*D2
      IER = 1
      SIG = SBIG
      IF (D1D2 .EQ. 0.  .AND.  D1 .NE. D2) GO TO 10
C
C Test for a valid constraint.
C
      IER = 2
      SIG = 0.
      IF (D1D2 .LT. 0.) GO TO 10
C
C Test for SIG = 0 sufficient.
C
      IER = 0
      IF (D1D2 .EQ. 0.) GO TO 10
      T = MAX(D1/D2,D2/D1)
      IF (T .LE. 2.) GO TO 10
C
C Find a zero of F(SIG) = SIG*COSHM(SIG)/SINHM(SIG) - (T+1).
C   Since the derivative of F vanishes at the origin, a
C   quadratic approximation is used to obtain an initial
C   estimate for the Newton method.
C
      TP1 = T + 1.
      SIG = SQRT(10.*T-20.)
      NIT = 0
C
C   Compute an absolute tolerance FTOL = abs(TOL) and a
C     relative tolerance RTOL = 100*Macheps.
C
      FTOL = ABS(TOL)
      RTOL = 1.
    5 RTOL = RTOL/2.
        IF (CSSTORE(RTOL+1.) .GT. 1.) GO TO 5
      RTOL = RTOL*200.
C
C Top of loop:  evaluate F and its derivative FP.
C
    6 IF (SIG .LE. .5) THEN
C
C   Use approximations designed to avoid cancellation error
C     in the hyperbolic functions.
C
        CALL CSSNHCSH (SIG, SINHM,COSHM,DUMMY)
        T1 = COSHM/SINHM
        FP = T1 + SIG*(SIG/SINHM - T1*T1 + 1.)
      ELSE
C
C   Scale SINHM and COSHM by 2*exp(-SIG) in order to avoid
C     overflow.
C
        EMS = EXP(-SIG)
        SSM = 1. - EMS*(EMS+SIG+SIG)
        T1 = (1.-EMS)*(1.-EMS)/SSM
        FP = T1 + SIG*(2.*SIG*EMS/SSM - T1*T1 + 1.)
      ENDIF
C
      F = SIG*T1 - TP1
C
C   Update the number of iterations NIT.
C
      NIT = NIT + 1
      IF (LUN .GE. 0) WRITE (LUN,110) NIT, SIG, F, FP
  110 FORMAT (1X,3X,I2,' -- SIG = ',E15.8,', F = ',
     .        E15.8/1X,31X,'FP = ',E15.8)
C
C   Test for convergence.
C
      IF (FP .LE. 0.) GO TO 10
      DSIG = -F/FP
      IF (ABS(DSIG) .LE. RTOL*SIG  .OR.  (F .GE. 0.  .AND.
     .    F .LE. FTOL)  .OR.  ABS(F) .LE. RTOL) GO TO 10
C
C   Bottom of loop:  update SIG.
C
      SIG = SIG + DSIG
      GO TO 6
C
C No errors encountered.
C
   10 CSSIG2 = SIG
      IF (IFLGS .LE. 0) RETURN
      SIGMA(LP1) = SIG
      SIGMA(LP2) = SIG
      RETURN
C
C Error termination.
C
   11 CSSIG2 = -1.
      RETURN
      END

C
C $Id: kurvddp.f,v 1.3 2008-07-27 03:10:11 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
C NOTE: If you make any changes to this software, please remember to
C make the same changes to the corresponding single precision routine.
C
      SUBROUTINE KURVDDP(T,XS,YS,XST,YST,XSTT,YSTT,N,X,Y,XP,YP,S,SIGMA)
      DOUBLE PRECISION TN
      DOUBLE PRECISION SIGMAP
      DOUBLE PRECISION DEL1
      DOUBLE PRECISION DEL2
      DOUBLE PRECISION DELS
      DOUBLE PRECISION SUMX
      DOUBLE PRECISION SUMY
      DOUBLE PRECISION SUMXT
      DOUBLE PRECISION SUMYT
      DOUBLE PRECISION DELS6
      DOUBLE PRECISION D
      DOUBLE PRECISION C1
      DOUBLE PRECISION C2
      DOUBLE PRECISION CT1
      DOUBLE PRECISION CT2
      DOUBLE PRECISION CTT1
      DOUBLE PRECISION CTT2
      DOUBLE PRECISION SIGDEL
      DOUBLE PRECISION SS
      DOUBLE PRECISION DUMMY
      DOUBLE PRECISION S1
      DOUBLE PRECISION CO1
      DOUBLE PRECISION S2
      DOUBLE PRECISION CO2
c
      INTEGER N
      DOUBLE PRECISION T,XS,YS,XST,YST,XSTT,YSTT,X(N),Y(N),XP(N),YP(N),
     +                 S(N),SIGMA
c
c                                 coded by alan kaylor cline
c                           from fitpack -- january 26, 1987
c                        a curve and surface fitting package
c                      a product of pleasant valley software
c                  8603 altus cove, austin, texas 78759, usa
c
c this subroutine performs the mapping of points in the
c interval (0.,1.) onto a curve in the plane. it also
c returns the first and second derivatives of the component
c functions. the subroutine kurv1 should be called earlier
c to determine certain necessary parameters. the resulting
c curve has a parametric representation both of whose
c components are splines under tension and functions of the
c polygonal arclength parameter.
c
c on input--
c
c   t contains a real value to be mapped to a point on the
c   curve. the interval (0.,1.) is mapped onto the entire
c   curve, with 0. mapping to (x(1),y(1)) and 1. mapping
c   to (x(n),y(n)). values outside this interval result in
c   extrapolation.
c
c   n contains the number of points which were specified
c   to determine the curve.
c
c   x and y are arrays containing the x- and y-coordinates
c   of the specified points.
c
c   xp and yp are the arrays output from kurv1 containing
c   curvature information.
c
c   s is an array containing the polygonal arclengths of
c   the curve.
c
c and
c
c   sigma contains the tension factor (its sign is ignored).
c
c the parameters n, x, y, xp, yp, s, and sigma should be
c input unaltered from the output of kurv1.
c
c on output--
c
c   xs and ys contain the x- and y-coordinates of the image
c   point on the curve. xst and yst contain the first
c   derivatives of the x- and y-components of the mapping
c   with respect to t. xstt and ystt contain the second
c   derivatives of the x- and y-components of the mapping
c   with respect to t.
c
c none of the input parameters are altered.
c
c this subroutine references package modules intrvldp and
c snhcshdp.
c
c-----------------------------------------------------------
c
c determine interval
c
      TN = S(N)*T
      IM1 = INTRVLDP(TN,S,N)
      I = IM1 + 1
c
c denormalize tension factor
c
      SIGMAP = ABS(SIGMA)*DBLE(N-1)/S(N)
c
c set up and perform interpolation
c
      DEL1 = TN - S(IM1)
      DEL2 = S(I) - TN
      DELS = S(I) - S(IM1)
      SUMX = (X(I)*DEL1+X(IM1)*DEL2)/DELS
      SUMY = (Y(I)*DEL1+Y(IM1)*DEL2)/DELS
      SUMXT = S(N)* (X(I)-X(IM1))/DELS
      SUMYT = S(N)* (Y(I)-Y(IM1))/DELS
      IF (SIGMAP.NE.0.D0) GO TO 1
      DELS6 = 6.D0*DELS
      D = DEL1*DEL2/DELS6
      C1 = - (DEL1+DELS)*D
      C2 = - (DEL2+DELS)*D
      DELS6 = DELS6/S(N)
      CT1 = (2.D0*DEL1*DEL1-DEL2* (DEL1+DELS))/DELS6
      CT2 = - (2.D0*DEL2*DEL2-DEL1* (DEL2+DELS))/DELS6
      DELS = DELS/ (S(N)*S(N))
      CTT1 = DEL1/DELS
      CTT2 = DEL2/DELS
      GO TO 2
    1 SIGDEL = SIGMAP*DELS
      CALL SNHCSHDP(SS,DUMMY,SIGDEL,-1)
      CALL SNHCSHDP(S1,CO1,SIGMAP*DEL1,0)
      CALL SNHCSHDP(S2,CO2,SIGMAP*DEL2,0)
      D = SIGDEL*SIGMAP* (1.D0+SS)
      C1 = DEL1* (S1-SS)/D
      C2 = DEL2* (S2-SS)/D
      CT1 = (CO1-SS)*S(N)/D
      CT2 = - (CO2-SS)*S(N)/D
      CTT1 = DEL1* (1.D0+S1)*S(N)*S(N)/ (DELS* (1.D0+SS))
      CTT2 = DEL2* (1.D0+S2)*S(N)*S(N)/ (DELS* (1.D0+SS))
    2 XS = SUMX + C1*XP(I) + C2*XP(IM1)
      YS = SUMY + C1*YP(I) + C2*YP(IM1)
      XST = SUMXT + CT1*XP(I) + CT2*XP(IM1)
      YST = SUMYT + CT1*YP(I) + CT2*YP(IM1)
      XSTT = CTT1*XP(I) + CTT2*XP(IM1)
      YSTT = CTT1*YP(I) + CTT2*YP(IM1)
      RETURN
      END

C
C	$Id: gsfaci.f,v 1.5 2008-07-27 00:21:01 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GSFACI (COLI)
C
C  SET FILL AREA COLOR INDEX
C
      INTEGER ESFACI
      PARAMETER (ESFACI=38)
C
      include 'gkscom.h'
C
      INTEGER COLI
C
C  Check if GKS is in the proper state.
C
      CALL GZCKST(8,ESFACI,IER)
      IF (IER .NE. 0) RETURN
C
C  Check that the index is valid.
C
      IF (COLI .LT. 0) THEN
        ERS = 1
        CALL GERHND(92,ESFACI,ERF)
        ERS = 0
        RETURN
      ENDIF
C
C  Set the current color index in the GKS state list.
C
      CFACI = COLI
C
C  Invoke the workstation interface.
C
      FCODE = 40
      CONT  = 0
      CALL GZROI(0)
      IC1   = 1
      IC2   = 1
      IC(1) = COLI
      CALL GZTOWK
      IF (RERR .NE. 0) THEN
        ERS = 1
        CALL GERHND(RERR,ESFACI,ERF)
        ERS = 0
      ENDIF
C
      RETURN
      END

C
C $Id: aglbls.f,v 1.8 2008-07-27 00:14:35 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE AGLBLS (ITST,WCWP,HCWP,FLLB,LBIM,FLLN,DBOX,SBOX,RBOX)
C
      DIMENSION FLLB(10,8),FLLN(6,16),DBOX(6,4),SBOX(6,4),RBOX(6)
C
C The routine AGLBLS is used (if ITST .LE. 0) to predict the amount of
C space which will be required for graph labels (excluding the numeric
C labels on the axes, which are handled by AGAXIS) or (if ITST .GT. 0)
C to actually draw the graph labels.
C
C The labels in question are defined by the label list (FLLB array) and
C the line list (FLLN array).  Each label is assumed to lie in one of
C five boxes, as follows:
C
C    Box 1 is to the left of the curve window.
C    Box 2 is to the right of the curve window.
C    Box 3 is below the curve window.
C    Box 4 is above the curve window.
C    Box 5 is the curve window itself.
C    Box 6 is the entire plot (graph) window.
C
C A test run of AGLBLS returns two sets of box dimensions to the caller.
C DBOX contains the dimensions required if all labels are to have their
C desired sizes, SBOX the dimensions required if all labels are to have
C their smallest sizes.  The caller is expected to use this information
C to determine a final set of box dimensions (stored in DBOX), and then
C call AGLBLS again to actually draw the labels in those boxes.
C
C The arguments of AGLBLS are as follows:
C
C -- ITST specifies whether the call is a test call (ITST .LE. 0) or a
C    real call (ITST .GT. 0).  If ABSV(ITST) .GT. 1, AGLBLS is allowed
C    to shrink the labels if they would not otherwise fit in their box.
C    If ABSV(ITST) .EQ. 1, shrinkage of labels is prohibited.  If ITST
C    .EQ. 0, labels are suppressed.
C
C -- WCWP and HCWP are the width and height of the curve window, in
C    plotter-coordinate-system units.  AGLBLS assumes that the last call
C    to the plot package routine "SET" had arguments XLCW, XRCW, YBCW,
C    YTCW, 0., 1., 0., 1., and 1 - defining the most convenient system
C    of coordinates for it.
C
C -- FLLB is the array in which the label list is stored.  The array is
C    doubly-dimensioned.  The first subscript specifies one of ten label
C    attributes, the second a particular label.  The attributes are as
C    follows (the name ILLB(M,N) refers to a label attribute which is
C    intrinsically an integer, despite being stored as a real):
C
C    -- ILLB(1,N) specifies the name of label N.  If ILLB(1,N) is zero,
C       no label is defined.  Otherwise, ILLB(1,N) is an identifier
C       returned by AGSTCH when the name of the label (a character
C       string) was stored away.
C
C    -- ILLB(2,N) may be set non-zero to suppress label N.
C
C    -- FLLB(3,N) and FLLB(4,N) are the x and y coordinates of a base-
C       point relative to which label N is positioned, as fractions of
C       the width and height, respectively, of the curve window.  The
C       position of the base-point determines the box in which label N
C       is considered to lie.
C
C    -- FLLB(5,N) and FLLB(6,N) are small offsets (typically about the
C       size of a character width), stated as fractions of the smaller
C       side of the curve window.  They are used to offset the label
C       base-point (after the box number is determined).  Typically,
C       this provides a minimum spacing between the label and one side
C       of the curve window.
C
C    -- ILLB(7,N) is the orientation angle of the label, in degrees
C       counter-clockwise from horizontal.  The base-line for label N
C       is a vector emanating from the base-point at this angle.  The
C       specified angle must be a multiple of 90 degrees.
C
C    -- ILLB(8,N) is the centering option for the label.  It specifies
C       how each line of the label is to be positioned relative to a
C       line perpendicular to the base-line at the base-point.
C
C       -- If ILLB(8,N) .LT. 0, the left edge of each line lies on
C          the perpendicular.
C
C       -- If ILLB(8,N) .EQ. 0, the center of each line lies on the
C          perpendicular.
C
C       -- If ILLB(8,N) .GT. 0, the right edge of each line lies on
C          the perpendicular.
C
C    -- ILLB(9,N) is the number of lines in label N.
C
C    -- ILLB(10,N) is the second subscript (in the line list) of the
C       first line of label N.
C
C -- LBIM is the maximum number of labels the label list will hold.
C
C -- FLLN is the array in which the line list is stored.  The array is
C    doubly-dimensioned.  The first subscript specifies one of six line
C    attributes, the second a particular line.  The attributes are as
C    follows (the name ILLN(M,N) refers to a line attribute which is
C    intrinsically an integer, despite being stored as a real):
C
C    -- ILLN(1,N) is the position number of line N.  The lines of a
C       label are ordered according to their position numbers, the one
C       having the largest position number being top-most.  Moreover,
C       lines having position numbers .GT. 0 are placed above the label
C       base-line, those having position numbers .EQ. 0 (of which there
C       should be but one) are placed on the label base-line, and those
C       having position numbers .LT. 0 are placed below the label base-
C       line.  The magnitudes of the position numbers have nothing to
C       do with inter-line spacing - that is up to AGLBLS to determine.
C
C    -- ILLN(2,N) may be set non-zero to suppress line N.
C
C    -- FLLN(3,N) is the desired width of characters in the line, as a
C       fraction of the smaller side of the curve window.
C
C    -- ILLN(4,N) is the identifier of the character string comprising
C       the text of the line, as returned by AGSTCH at the time the
C       string was stored.
C
C    -- ILLN(5,N) is the number of characters in the line.
C
C    -- ILLN(6,N) is the index of the next line of the label.  The
C       lines of a label must be ordered by position number (largest
C       to smallest).
C
C -- DBOX and SBOX, dimensioned 6 X 4, contain box dimensions, as dis-
C    cussed above.  D/SBOX(M,N) is the Nth edge-coordinate of box M,
C    where N .EQ. 1 for the left edge, 2 for the right edge, 3 for the
C    bottom edge, and 4 for the top edge, of the box.  The first two are
C    stated as fractions of the width, the second two as fractions of
C    the height, of the curve window.
C
C    RBOX, dimensioned 6, holds reduction factors for the sizes of the
C    characters in labels in each of the six boxes.  Each RBOX(M) is
C
C    -- negative to specify smallest-size characters, or
C
C    -- zero to specify that no reduction factor has been chosen, or
C
C    -- positive, between 0. and 1. (an actual reduction factor).
C
C *-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
C
C The following common block contains other AUTOGRAPH variables, both
C real and integer, which are not control parameters.  The only one of
C interest here is MWCL, which is the minimum usable character width,
C in plotter units.
C
      COMMON /AGORIP/ SMRL , ISLD , MWCL,MWCM,MWCE,MDLA,MWCD,MWDQ ,
     +                INIF
      SAVE /AGORIP/
C
C The following common block contains other AUTOGRAPH variables, of type
C character.
C
      COMMON /AGOCHP/ CHS1,CHS2
      CHARACTER*504 CHS1,CHS2
      SAVE /AGOCHP/
C
C HCFW(WDTH) specifies the height of a character as a function of width.
C
      HCFW(WDTH)=2.*WDTH
C
C *-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
C
C This is the main section of AGLBLS.
C
C Compute the length of the smallest side of the curve window.
C
      SCWP=MIN(WCWP,HCWP)
C
C Preset certain jumps in the internal procedure which follows.
C
      JMP1=2
      JMP2=2
      JMP3=2
C
C Jump if this is a test run.
C
      IF (ITST.LE.0) GO TO 101
C
C This is not a test run.  If the reduction factors for the six boxes
C are already set, jump directly to the plotting section; otherwise, we
C must first compute the coordinates of the six smallest-size boxes.
C
      IF (RBOX(1).NE.0.) GO TO 115
      GO TO 105
C
C This is a test run.  Compute the coordinates of the edges of the six
C desired-size boxes.
C
  101 RWCL=1.
      NBOX=0
      JMP4=1
      GO TO 200
C
  102 DBOX(NBOX,1)=XLBX
      DBOX(NBOX,2)=XRBX
      DBOX(NBOX,3)=YBBX
      DBOX(NBOX,4)=YTBX
C
      IF (NBOX.LT.6) GO TO 200
C
C This is a test run.  Compute the coordinates of the edges of the six
C smallest-size boxes, in one of two ways.
C
      IF (ABS(ITST).GT.1) GO TO 105
C
C This is a test run.  Determine smallest-size boxes (no shrinking).
C
      DO 104 J=1,4
        DO 103 I=1,6
          SBOX(I,J)=DBOX(I,J)
  103   CONTINUE
  104 CONTINUE
      RETURN
C
C Determine smallest-size boxes (shrinking allowed).
C
  105 RWCL=0.
      NBOX=0
      JMP4=2
      GO TO 200
C
  106 SBOX(NBOX,1)=XLBX
      SBOX(NBOX,2)=XRBX
      SBOX(NBOX,3)=YBBX
      SBOX(NBOX,4)=YTBX
C
      IF (NBOX.LT.6) GO TO 200
C
C If this is not a test run, jump to compute reduction factors for each
C of the six boxes and then plot the labels.  Otherwise, return.
C
      IF (ITST.GT.0) GO TO 107
      RETURN
C
C This is not a test run.  Compute reduction factors for each of the
C six boxes.
C
  107 NBOX=1
      JMP4=3
C
C (DBOX(NBOX,I),I=1,4) specifies the box in which the labels are to be
C drawn, (SBOX(NBOX,I),I=1,4) the minimum box in which they can be drawn
C if shrunk.  Check first whether the latter is contained in the former.
C If so, we have a chance.  If not, the best we can do is shrink the
C labels to minimum size and hope for the best.
C
  108 IF (SBOX(NBOX,1).LT.SBOX(NBOX,2).AND.
     +    DBOX(NBOX,1)-SBOX(NBOX,1).LT..0001.AND.
     +    SBOX(NBOX,2)-DBOX(NBOX,2).LT..0001.AND.
     +    DBOX(NBOX,3)-SBOX(NBOX,3).LT..0001.AND.
     +    SBOX(NBOX,4)-DBOX(NBOX,4).LT..0001      ) GO TO 109
C
      RBOX(NBOX)=-1.
      GO TO 114
C
C Mimimum-size labels will fit.  Find the largest value of RBOX(NBOX)
C for which the labels will fit.
C
  109 RWCL=1.
      DWCL=.5
      SWCL=0.
      GO TO 201
C
C See if the last value of RBOX(NBOX) gave us labels which would fit or
C not and adjust the value accordingly.
C
  110 IF (DBOX(NBOX,1)-XLBX.LT..0001.AND.
     +    XRBX-DBOX(NBOX,2).LT..0001.AND.
     +    DBOX(NBOX,3)-YBBX.LT..0001.AND.
     +    YTBX-DBOX(NBOX,4).LT..0001      ) GO TO 111
C
C Labels did not fit.  Adjust RBOX(NBOX) downward.
C
      RWCL=RWCL-DWCL
      DWCL=.5*DWCL
      IF (DWCL.LT..001) RWCL=SWCL
      GO TO 201
C
C Labels did fit.  Adjust RBOX(NBOX) upward, unless it is equal to 1.
C
  111 IF (RWCL.EQ.1.) GO TO 113
      SWCL=RWCL
      RWCL=RWCL+DWCL
      DWCL=.5*DWCL
      IF (DWCL.GT..001) GO TO 201
C
C The current value of RBOX(NBOX) is acceptable.  Do next box, if any.
C
  113 IF (NBOX.GE.5) GO TO 114
C
C Return updated box-edge coordinates for boxes 1 through 4.
C
      DBOX(NBOX,1)=XLBX
      DBOX(NBOX,2)=XRBX
      DBOX(NBOX,3)=YBBX
      DBOX(NBOX,4)=YTBX
C
  114 NBOX=NBOX+1
      IF (NBOX.LE.6) GO TO 108
C
C We have done all we can to make the labels fit.  Plot them now.
C
  115 NBOX=0
      LBIN=0
      JMP3=1
      JMP4=4
C
C Get a label to chew on.
C
  116 JMP1=2
      JMP2=2
      GO TO 202
C
C We have a label.  Initialize the re-loop through the lines in it.
C
  117 XPLN=XPLB-DTLB*YDLB/WCWP
      YPLN=YPLB+DTLB*XDLB/HCWP
      PHCL=0.
      LNIN=LNII
      JMP1=1
      JMP2=1
      GO TO 210
C
C Get ready to plot the label line.
C
  118 XPLN=XPLN+.5*(PHCL+FHCL)*YDLB/WCWP
      YPLN=YPLN-.5*(PHCL+FHCL)*XDLB/HCWP
      PHCL=FHCL
      CALL AGGTCH (INT(FLLN(4,LNIN)),CHS2,LNC2)
C
C Give the user a chance to change the appearance of the label line.
C
      CALL AGCHIL (0,CHS1(1:LNC1),INT(FLLN(1,LNIN)))
C
C Plot the label line.
C
      CALL AGPWRT (XPLN,YPLN,CHS2,LNC2,IWCL,LBOR,LBCN)
C
C Give the user a chance to undo the changes he made above.
C
      CALL AGCHIL (1,CHS1(1:LNC1),INT(FLLN(1,LNIN)))
C
C Go get the next line, if any.
C
      GO TO 215
C
C All labels are drawn.  Return.
C
  120 RETURN
C
C *-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
C
C This internal procedure, which may be entered and exited in a number
C of different ways, is used to scan the label list and the line list
C and to return information about the labels and lines defined there.
C
C Entry occurs here to bump the box number, store away a reduction
C factor for the sizes of labels in that box, and then compute the edge
C coordinates of the box required to hold labels of the size implied by
C that reduction factor.
C
  200 NBOX=NBOX+1
C
C Entry occurs here to do all of the above except the bumping of the box
C number.
C
  201 RBOX(NBOX)=RWCL
C
C Initialize the label-list index and the box-edge parameters.
C
      LBIN=0
      XLBX=+1000.
      XRBX=-1000.
      YBBX=+1000.
      YTBX=-1000.
      IF (ITST.EQ.0) GO TO 222
C
C This is the beginning of the loop through the labels.  Entry occurs
C here to find the next label in the list and return positioning info.
C
C Increment the label index and test for end of label list.
C
  202 LBIN=LBIN+1
      IF (LBIN.GT.LBIM) GO TO 222
C
C Skip this label if it is non-existent, suppressed, or empty.
C
      IF (FLLB(1,LBIN).EQ.0..OR.FLLB(2,LBIN).NE.0.
     +                      .OR.FLLB(9,LBIN).EQ.0.) GO TO 202
C
C Unpack the parameters specifying the label-base-point position.
C
      XBLB=FLLB(3,LBIN)
      YBLB=FLLB(4,LBIN)
      XOLB=FLLB(5,LBIN)
      YOLB=FLLB(6,LBIN)
C
C Determine in which of five boxes the label lies:
C
C in the box to the left of the curve window.
C
      LBBX=1
      IF (XBLB.EQ.0..AND.XOLB.LE.0.) GO TO 203
C
C in the box to the right of the curve window,
C
      LBBX=2
      IF (XBLB.EQ.1..AND.XOLB.GE.0.) GO TO 203
C
C in the box below the curve window,
C
      LBBX=3
      IF (YBLB.EQ.0..AND.YOLB.LE.0.) GO TO 203
C
C in the box above the curve window,
C
      LBBX=4
      IF (YBLB.EQ.1..AND.YOLB.GE.0.) GO TO 203
C
C in the curve window,
C
      LBBX=5
      IF ( (XBLB.EQ.0..AND.XOLB.GT.0.).OR.
     +     (XBLB.EQ.1..AND.XOLB.LT.0.).OR.
     +     (YBLB.EQ.0..AND.YOLB.GT.0.).OR.
     +     (YBLB.EQ.1..AND.YOLB.LT.0.)    ) GO TO 203
C
C or elsewhere.
C
      LBBX=6
C
C If we are interested in a particular box and this label is not in that
C box, skip it.
C
  203 IF (NBOX.NE.0.AND.LBBX.NE.NBOX) GO TO 202
C
C On a non-test run, get the label name and length for call to AGCHIL.
C
      IF (ITST.GT.0) CALL AGGTCH (INT(FLLB(1,LBIN)),CHS1,LNC1)
C
C Unpack the label orientation and compute its direction cosines.
C
      LBOR=INT(FLLB(7,LBIN))
C
      XDLB=COS(.017453292519943*FLLB(7,LBIN))
      YDLB=SIN(.017453292519943*FLLB(7,LBIN))
C
C Unpack the label-centering option.
C
      LBCN=INT(FLLB(8,LBIN))
C
C Unpack the index of the initial line of the label and save it.
C
      LNIN=INT(FLLB(10,LBIN))
      LNII=LNIN
C
C If this is not a test run, modify the label-base-point position as
C needed to move the label into the actual box in which it must fit.
C
      IF (ITST.LE.0) GO TO 209
C
      GO TO (204,205,206,207,208,209) , LBBX
C
  204 XBLB=XBLB+DBOX(1,2)
      GO TO 209
C
  205 XBLB=XBLB+DBOX(2,1)-1.
      GO TO 209
C
  206 YBLB=YBLB+DBOX(3,4)
      GO TO 209
C
  207 YBLB=YBLB+DBOX(4,3)-1.
      GO TO 209
C
  208 IF (XBLB.EQ.0.) XBLB=XBLB+DBOX(5,1)
      IF (XBLB.EQ.1.) XBLB=XBLB+DBOX(5,2)-1.
      IF (YBLB.EQ.0.) YBLB=YBLB+DBOX(5,3)
      IF (YBLB.EQ.1.) YBLB=YBLB+DBOX(5,4)-1.
C
C Compute the final label-base-point position.
C
  209 XPLB=XBLB+XOLB*SCWP/WCWP
      YPLB=YBLB+YOLB*SCWP/HCWP
C
C Before entering the loop through the line list, initialize the label-
C dimension parameters.
C
      DLLB=0.
      DRLB=0.
      DBLB=0.
      DTLB=0.
C
C This is the beginning of the loop through the lines in a given label.
C Entry may occur here to find the next line and return info about it.
C
C If the line is suppressed or of zero length, skip it.
C
  210 IF (FLLN(2,LNIN).NE.0..OR.FLLN(5,LNIN).LE.0.) GO TO 215
C
C Unpack the position-number, character-width, and character-count
C parameters for the line.
C
      LNPN=INT(FLLN(1,LNIN))
      WCLN=FLLN(3,LNIN)
      LNCC=INT(FLLN(5,LNIN))
C
C Compute the integer width (IWCL) and the floating-point width and
C height (FWCL and FHCL) of characters in the label.  All are expressed
C in plotter-coordinate-system units.
C
      IWCL=MAX(MWCL,INT(RBOX(LBBX)*WCLN*SCWP+.5))
      FWCL=REAL(IWCL)
      FHCL=HCFW(FWCL)
C
C Jump back with line information or drop through, as directed.
C
      GO TO (118,211) , JMP1
C
C Update the label-dimension parameters.
C
  211 DRLB=MAX(DRLB,REAL(LNCC)*FWCL)
C
      IF (LNPN) 212,213,214
C
  212 DBLB=DBLB+FHCL
      GO TO 215
C
  213 DBLB=DBLB+.5*FHCL
      DTLB=DTLB+.5*FHCL
      GO TO 215
C
  214 DTLB=DTLB+FHCL
C
C Go to the next line in the label, if there is one.
C
  215 LNIN=INT(FLLN(6,LNIN))
      IF (LNIN.NE.0) GO TO 210
C
C Jump back on end of lines or drop through, as directed.
C
      GO TO (116,216) , JMP2
C
C If all the lines in the label were either suppressed or of zero
C length, skip this label.
C
  216 IF (DRLB.EQ.0.) GO TO 202
C
C Complete the computation of the label dimensions.  The four parameters
C DLLB, DRLB, DBLB, and DTLB represent the distances from the base-point
C to the left edge, right edge, bottom edge, and top edge of the label,
C in plotter-coordinate-system units, where left, right, etc., are as
C viewed by a reader of the label.
C
      IF (LBCN) 217,218,219
C
C Left edges of lines are aligned.
C
  217 GO TO 220
C
C Centers of lines are aligned.
C
  218 DLLB=.5*(DLLB+DRLB)
      DRLB=DLLB
      GO TO 220
C
C Right edges of lines are aligned.
C
  219 SWAP=DLLB
      DLLB=DRLB
      DRLB=SWAP
C
C Jump back with label information or drop through, as directed.
C
  220 GO TO (117,221) , JMP3
C
C Update the x and y coordinates of the label box edges.
C
  221 XLBX=MIN(XLBX,XBLB,
     +     XPLB-MAX(+DLLB*XDLB,-DRLB*XDLB,-DBLB*YDLB,+DTLB*YDLB)/WCWP)
      XRBX=MAX(XRBX,XBLB,
     +     XPLB+MAX(-DLLB*XDLB,+DRLB*XDLB,+DBLB*YDLB,-DTLB*YDLB)/WCWP)
      YBBX=MIN(YBBX,YBLB,
     +     YPLB-MAX(+DLLB*YDLB,-DRLB*YDLB,+DBLB*XDLB,-DTLB*XDLB)/HCWP)
      YTBX=MAX(YTBX,YBLB,
     +     YPLB+MAX(-DLLB*YDLB,+DRLB*YDLB,-DBLB*XDLB,+DTLB*XDLB)/HCWP)
C
C Go back for the next label.
C
      GO TO 202
C
C End of label list.  Jump as directed.
C
  222 GO TO (102,106,110,120) , JMP4
C
C *-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
C
      END

      SUBROUTINE ZPOEQU( N, A, LDA, S, SCOND, AMAX, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     March 31, 1993
*
*     .. Scalar Arguments ..
      INTEGER            INFO, LDA, N
      DOUBLE PRECISION   AMAX, SCOND
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   S( * )
      COMPLEX*16         A( LDA, * )
*     ..
*
*  Purpose
*  =======
*
*  ZPOEQU computes row and column scalings intended to equilibrate a
*  Hermitian positive definite matrix A and reduce its condition number
*  (with respect to the two-norm).  S contains the scale factors,
*  S(i) = 1/sqrt(A(i,i)), chosen so that the scaled matrix B with
*  elements B(i,j) = S(i)*A(i,j)*S(j) has ones on the diagonal.  This
*  choice of S puts the condition number of B within a factor N of the
*  smallest possible condition number over all possible diagonal
*  scalings.
*
*  Arguments
*  =========
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  A       (input) COMPLEX*16 array, dimension (LDA,N)
*          The N-by-N Hermitian positive definite matrix whose scaling
*          factors are to be computed.  Only the diagonal elements of A
*          are referenced.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(1,N).
*
*  S       (output) DOUBLE PRECISION array, dimension (N)
*          If INFO = 0, S contains the scale factors for A.
*
*  SCOND   (output) DOUBLE PRECISION
*          If INFO = 0, S contains the ratio of the smallest S(i) to
*          the largest S(i).  If SCOND >= 0.1 and AMAX is neither too
*          large nor too small, it is not worth scaling by S.
*
*  AMAX    (output) DOUBLE PRECISION
*          Absolute value of largest matrix element.  If AMAX is very
*          close to overflow or very close to underflow, the matrix
*          should be scaled.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*          > 0:  if INFO = i, the i-th diagonal element is nonpositive.
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO, ONE
      PARAMETER          ( ZERO = 0.0D+0, ONE = 1.0D+0 )
*     ..
*     .. Local Scalars ..
      INTEGER            I
      DOUBLE PRECISION   SMIN
*     ..
*     .. External Subroutines ..
      EXTERNAL           XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          DBLE, MAX, MIN, SQRT
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      IF( N.LT.0 ) THEN
         INFO = -1
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -3
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'ZPOEQU', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 ) THEN
         SCOND = ONE
         AMAX = ZERO
         RETURN
      END IF
*
*     Find the minimum and maximum diagonal elements.
*
      S( 1 ) = DBLE( A( 1, 1 ) )
      SMIN = S( 1 )
      AMAX = S( 1 )
      DO 10 I = 2, N
         S( I ) = DBLE( A( I, I ) )
         SMIN = MIN( SMIN, S( I ) )
         AMAX = MAX( AMAX, S( I ) )
   10 CONTINUE
*
      IF( SMIN.LE.ZERO ) THEN
*
*        Find the first non-positive diagonal element and return.
*
         DO 20 I = 1, N
            IF( S( I ).LE.ZERO ) THEN
               INFO = I
               RETURN
            END IF
   20    CONTINUE
      ELSE
*
*        Set the scale factors to the reciprocals
*        of the diagonal elements.
*
         DO 30 I = 1, N
            S( I ) = ONE / SQRT( S( I ) )
   30    CONTINUE
*
*        Compute SCOND = min(S(I)) / max(S(I))
*
         SCOND = SQRT( SMIN ) / SQRT( AMAX )
      END IF
      RETURN
*
*     End of ZPOEQU
*
      END

      SUBROUTINE ZHETRD( UPLO, N, A, LDA, D, E, TAU, WORK, LWORK, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          UPLO
      INTEGER            INFO, LDA, LWORK, N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   D( * ), E( * )
      COMPLEX*16         A( LDA, * ), TAU( * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  ZHETRD reduces a complex Hermitian matrix A to real symmetric
*  tridiagonal form T by a unitary similarity transformation:
*  Q**H * A * Q = T.
*
*  Arguments
*  =========
*
*  UPLO    (input) CHARACTER*1
*          = 'U':  Upper triangle of A is stored;
*          = 'L':  Lower triangle of A is stored.
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  A       (input/output) COMPLEX*16 array, dimension (LDA,N)
*          On entry, the Hermitian matrix A.  If UPLO = 'U', the leading
*          N-by-N upper triangular part of A contains the upper
*          triangular part of the matrix A, and the strictly lower
*          triangular part of A is not referenced.  If UPLO = 'L', the
*          leading N-by-N lower triangular part of A contains the lower
*          triangular part of the matrix A, and the strictly upper
*          triangular part of A is not referenced.
*          On exit, if UPLO = 'U', the diagonal and first superdiagonal
*          of A are overwritten by the corresponding elements of the
*          tridiagonal matrix T, and the elements above the first
*          superdiagonal, with the array TAU, represent the unitary
*          matrix Q as a product of elementary reflectors; if UPLO
*          = 'L', the diagonal and first subdiagonal of A are over-
*          written by the corresponding elements of the tridiagonal
*          matrix T, and the elements below the first subdiagonal, with
*          the array TAU, represent the unitary matrix Q as a product
*          of elementary reflectors. See Further Details.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(1,N).
*
*  D       (output) DOUBLE PRECISION array, dimension (N)
*          The diagonal elements of the tridiagonal matrix T:
*          D(i) = A(i,i).
*
*  E       (output) DOUBLE PRECISION array, dimension (N-1)
*          The off-diagonal elements of the tridiagonal matrix T:
*          E(i) = A(i,i+1) if UPLO = 'U', E(i) = A(i+1,i) if UPLO = 'L'.
*
*  TAU     (output) COMPLEX*16 array, dimension (N-1)
*          The scalar factors of the elementary reflectors (see Further
*          Details).
*
*  WORK    (workspace/output) COMPLEX*16 array, dimension (LWORK)
*          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*
*  LWORK   (input) INTEGER
*          The dimension of the array WORK.  LWORK >= 1.
*          For optimum performance LWORK >= N*NB, where NB is the
*          optimal blocksize.
*
*          If LWORK = -1, then a workspace query is assumed; the routine
*          only calculates the optimal size of the WORK array, returns
*          this value as the first entry of the WORK array, and no error
*          message related to LWORK is issued by XERBLA.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*
*  Further Details
*  ===============
*
*  If UPLO = 'U', the matrix Q is represented as a product of elementary
*  reflectors
*
*     Q = H(n-1) . . . H(2) H(1).
*
*  Each H(i) has the form
*
*     H(i) = I - tau * v * v'
*
*  where tau is a complex scalar, and v is a complex vector with
*  v(i+1:n) = 0 and v(i) = 1; v(1:i-1) is stored on exit in
*  A(1:i-1,i+1), and tau in TAU(i).
*
*  If UPLO = 'L', the matrix Q is represented as a product of elementary
*  reflectors
*
*     Q = H(1) H(2) . . . H(n-1).
*
*  Each H(i) has the form
*
*     H(i) = I - tau * v * v'
*
*  where tau is a complex scalar, and v is a complex vector with
*  v(1:i) = 0 and v(i+1) = 1; v(i+2:n) is stored on exit in A(i+2:n,i),
*  and tau in TAU(i).
*
*  The contents of A on exit are illustrated by the following examples
*  with n = 5:
*
*  if UPLO = 'U':                       if UPLO = 'L':
*
*    (  d   e   v2  v3  v4 )              (  d                  )
*    (      d   e   v3  v4 )              (  e   d              )
*    (          d   e   v4 )              (  v1  e   d          )
*    (              d   e  )              (  v1  v2  e   d      )
*    (                  d  )              (  v1  v2  v3  e   d  )
*
*  where d and e denote diagonal and off-diagonal elements of T, and vi
*  denotes an element of the vector defining H(i).
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ONE
      PARAMETER          ( ONE = 1.0D+0 )
      COMPLEX*16         CONE
      PARAMETER          ( CONE = ( 1.0D+0, 0.0D+0 ) )
*     ..
*     .. Local Scalars ..
      LOGICAL            LQUERY, UPPER
      INTEGER            I, IINFO, IWS, J, KK, LDWORK, LWKOPT, NB,
     $                   NBMIN, NX
*     ..
*     .. External Subroutines ..
      EXTERNAL           XERBLA, ZHER2K, ZHETD2, ZLATRD
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            ILAENV
      EXTERNAL           LSAME, ILAENV
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters
*
      INFO = 0
      UPPER = LSAME( UPLO, 'U' )
      LQUERY = ( LWORK.EQ.-1 )
      IF( .NOT.UPPER .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -4
      ELSE IF( LWORK.LT.1 .AND. .NOT.LQUERY ) THEN
         INFO = -9
      END IF
*
      IF( INFO.EQ.0 ) THEN
*
*        Determine the block size.
*
         NB = ILAENV( 1, 'ZHETRD', UPLO, N, -1, -1, -1 )
         LWKOPT = N*NB
         WORK( 1 ) = LWKOPT
      END IF
*
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'ZHETRD', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 ) THEN
         WORK( 1 ) = 1
         RETURN
      END IF
*
      NX = N
      IWS = 1
      IF( NB.GT.1 .AND. NB.LT.N ) THEN
*
*        Determine when to cross over from blocked to unblocked code
*        (last block is always handled by unblocked code).
*
         NX = MAX( NB, ILAENV( 3, 'ZHETRD', UPLO, N, -1, -1, -1 ) )
         IF( NX.LT.N ) THEN
*
*           Determine if workspace is large enough for blocked code.
*
            LDWORK = N
            IWS = LDWORK*NB
            IF( LWORK.LT.IWS ) THEN
*
*              Not enough workspace to use optimal NB:  determine the
*              minimum value of NB, and reduce NB or force use of
*              unblocked code by setting NX = N.
*
               NB = MAX( LWORK / LDWORK, 1 )
               NBMIN = ILAENV( 2, 'ZHETRD', UPLO, N, -1, -1, -1 )
               IF( NB.LT.NBMIN )
     $            NX = N
            END IF
         ELSE
            NX = N
         END IF
      ELSE
         NB = 1
      END IF
*
      IF( UPPER ) THEN
*
*        Reduce the upper triangle of A.
*        Columns 1:kk are handled by the unblocked method.
*
         KK = N - ( ( N-NX+NB-1 ) / NB )*NB
         DO 20 I = N - NB + 1, KK + 1, -NB
*
*           Reduce columns i:i+nb-1 to tridiagonal form and form the
*           matrix W which is needed to update the unreduced part of
*           the matrix
*
            CALL ZLATRD( UPLO, I+NB-1, NB, A, LDA, E, TAU, WORK,
     $                   LDWORK )
*
*           Update the unreduced submatrix A(1:i-1,1:i-1), using an
*           update of the form:  A := A - V*W' - W*V'
*
            CALL ZHER2K( UPLO, 'No transpose', I-1, NB, -CONE,
     $                   A( 1, I ), LDA, WORK, LDWORK, ONE, A, LDA )
*
*           Copy superdiagonal elements back into A, and diagonal
*           elements into D
*
            DO 10 J = I, I + NB - 1
               A( J-1, J ) = E( J-1 )
               D( J ) = A( J, J )
   10       CONTINUE
   20    CONTINUE
*
*        Use unblocked code to reduce the last or only block
*
         CALL ZHETD2( UPLO, KK, A, LDA, D, E, TAU, IINFO )
      ELSE
*
*        Reduce the lower triangle of A
*
         DO 40 I = 1, N - NX, NB
*
*           Reduce columns i:i+nb-1 to tridiagonal form and form the
*           matrix W which is needed to update the unreduced part of
*           the matrix
*
            CALL ZLATRD( UPLO, N-I+1, NB, A( I, I ), LDA, E( I ),
     $                   TAU( I ), WORK, LDWORK )
*
*           Update the unreduced submatrix A(i+nb:n,i+nb:n), using
*           an update of the form:  A := A - V*W' - W*V'
*
            CALL ZHER2K( UPLO, 'No transpose', N-I-NB+1, NB, -CONE,
     $                   A( I+NB, I ), LDA, WORK( NB+1 ), LDWORK, ONE,
     $                   A( I+NB, I+NB ), LDA )
*
*           Copy subdiagonal elements back into A, and diagonal
*           elements into D
*
            DO 30 J = I, I + NB - 1
               A( J+1, J ) = E( J )
               D( J ) = A( J, J )
   30       CONTINUE
   40    CONTINUE
*
*        Use unblocked code to reduce the last or only block
*
         CALL ZHETD2( UPLO, N-I+1, A( I, I ), LDA, D( I ), E( I ),
     $                TAU( I ), IINFO )
      END IF
*
      WORK( 1 ) = LWKOPT
      RETURN
*
*     End of ZHETRD
*
      END

C
C	$Id: contlk.f,v 1.4 2008-07-27 00:16:57 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CONTLK (XD,YD,NDP,IPT)
C
C  DRAW THE TRIANGLES CREATED BY CONTNG
C
C
C
      COMMON /CONRA1/ CL(30)     ,NCL        ,OLDZ       ,PV(210)    ,
     1                FINC       ,HI         ,FLO
      COMMON /CONRA2/ REPEAT     ,EXTRAP     ,PER        ,MESS       ,
     1                ISCALE     ,LOOK       ,PLDVLS     ,GRD        ,
     2                CINC       ,CHILO      ,CON        ,LABON      ,
     3                PMIMX      ,SCALE      ,FRADV      ,EXTRI      ,
     4                BPSIZ      ,LISTOP
      COMMON /CONRA3/ IREC
      COMMON /CONRA4/ NCP        ,NCPSZ
      COMMON /CONRA5/ NIT        ,ITIPV
      COMMON /CONRA6/ XST        ,YST        ,XED        ,YED        ,
     1                STPSZ      ,IGRAD      ,IG         ,XRG        ,
     2                YRG        ,BORD       ,PXST       ,PYST       ,
     3                PXED       ,PYED       ,ITICK
      COMMON /CONR18/ TITLE      ,ICNT   ,ITLSIZ
      COMMON /CONR19/ IHIGH      ,INMAJ      ,INLAB      ,INDAT      ,
     1              LEN      ,IFMT       ,LEND       ,
     2                IFMTD      ,ISIZEP     ,INMIN
      COMMON /CONRA9/ ICOORD(500),NP         ,MXXY       ,TR         ,
     1                BR         ,TL         ,BL         ,CONV       ,
     2                XN         ,YN         ,ITLL       ,IBLL       ,
     3                ITRL       ,IBRL       ,XC         ,YC         ,
     4                ITLOC(210) ,JX         ,JY         ,ILOC       ,
     5                ISHFCT     ,XO         ,YO         ,IOC        ,NC
      COMMON /CONR10/ NT         ,NL         ,NTNL       ,JWIPT      ,
     1                JWIWL      ,JWIWP      ,JWIPL      ,IPR        ,
     2                ITPV
      COMMON /CONR20/ NREP       ,NCRT       ,ISIZEL     ,
     1                MINGAP     ,ISIZEM         ,
     2                TENS
      COMMON /CONR12/ IXMAX      ,IYMAX      ,XMAX       ,YMAX
      LOGICAL         REPEAT     ,EXTRAP     ,PER        ,MESS       ,
     1                LOOK       ,PLDVLS     ,GRD        ,LABON      ,
     2                PMIMX      ,FRADV      ,EXTRI      ,CINC       ,
     3                TITLE      ,LISTOP     ,CHILO      ,CON
      COMMON /CONR15/ ISTRNG
        CHARACTER*64 ISTRNG
        COMMON /CONR16/ FORM
        CHARACTER*10 FORM
        COMMON /CONR17/ NDASH, IDASH, EDASH
        CHARACTER*10 NDASH, IDASH, EDASH
C
C
      DIMENSION       XD(1)      ,YD(1)      ,IPT(1)
C
        SAVE
C
C  STATEMENT FUNCTIONS TO SCALE DATA FOR OVERLAYS
C
C     FX(XXX,YYY) = XXX
C     FY(XXX,YYY) = YYY
C
C   ADVANCE PICTURE IF DESIRED
C
      IF (FRADV) CALL FRAME
C
C  DRAW TRIANGLES
C
      DO  100 K=1,NT
         I = K*3
         I1 = IPT(I)
         I2 = IPT(I-1)
         I3 = IPT(I-2)
         XX = FX(XD(I1),YD(I1))
         CALL FL2INT (XX,FY(XD(I1),YD(I1)),MX1,MY1)
         CALL PLOTIT (MX1,MY1,0)
         XX = FX(XD(I2),YD(I2))
         CALL FL2INT (XX,FY(XD(I2),YD(I2)),MX,MY)
         CALL PLOTIT (MX,MY,1)
         XX = FX(XD(I3),YD(I3))
         CALL FL2INT (XX,FY(XD(I3),YD(I3)),MX,MY)
         CALL PLOTIT (MX,MY,1)
         CALL PLOTIT (MX1,MY1,1)
  100 CONTINUE
C
C     FLUSH PLOTIT BUFFER
C
      CALL PLOTIT(0,0,0)
      RETURN
      END

c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by UCAR                 .
c  .                                                             .
c  .       University Corporation for Atmospheric Research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                         SPHEREPACK                          .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c
c
c ... file vhsgs.f
c
c     this file contains code and documentation for subroutines
c     vhsgs and vhsgsi
c
c ... files which must be loaded with vhsgs.f
c
c     sphcom.f, hrfft.f, gaqd.f
c
c     subroutine vhsgs(nlat,nlon,ityp,nt,v,w,idvw,jdvw,br,bi,cr,ci,
c    +                 mdab,ndab,wvhsgs,lvhsgs,work,lwork,ierror)
c
c
c     subroutine vhsgs performs the vector spherical harmonic synthesis
c     of the arrays br, bi, cr, and ci and stores the result in the
c     arrays v and w.  the synthesis is performed on an equally spaced
c     longitude grid and a gaussian colatitude grid (measured from
c     the north pole). v(i,j) and w(i,j) are the colatitudinal and
c     east longitudinal components respectively, located at the i(th)
c     colatitude gaussian point (see nlat below) and longitude
c     phi(j) = (j-1)*2*pi/nlon.  the spectral respresentation of (v,w)
c     is given below at output parameters v,w.
c
c     input parameters
c
c     nlat   the number of points in the gaussian colatitude grid on the
C*PL*ERROR* Comment line too long
c            full sphere. these lie in the interval (0,pi) and are computed
C*PL*ERROR* Comment line too long
c            in radians in theta(1) <...< theta(nlat) by subroutine gaqd.
C*PL*ERROR* Comment line too long
c            if nlat is odd the equator will be included as the grid point
c            theta((nlat+1)/2).  if nlat is even the equator will be
c            excluded as a grid point and will lie half way between
c            theta(nlat/2) and theta(nlat/2+1). nlat must be at least 3.
c            note: on the half sphere, the number of grid points in the
c            colatitudinal direction is nlat/2 if nlat is even or
c            (nlat+1)/2 if nlat is odd.
c
c     nlon   the number of distinct londitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater
c            than zero. the axisymmetric case corresponds to nlon=1.
c            the efficiency of the computation is improved when nlon
c            is a product of small prime numbers.
c
c     ityp   = 0  no symmetries exist about the equator. the synthesis
c                 is performed on the entire sphere.  i.e. on the
c                 arrays v(i,j),w(i,j) for i=1,...,nlat and
c                 j=1,...,nlon.
c
c            = 1  no symmetries exist about the equator. the synthesis
c                 is performed on the entire sphere.  i.e. on the
c                 arrays v(i,j),w(i,j) for i=1,...,nlat and
c                 j=1,...,nlon. the curl of (v,w) is zero. that is,
c                 (d/dtheta (sin(theta) w) - dv/dphi)/sin(theta) = 0.
c                 the coefficients cr and ci are zero.
c
c            = 2  no symmetries exist about the equator. the synthesis
c                 is performed on the entire sphere.  i.e. on the
c                 arrays v(i,j),w(i,j) for i=1,...,nlat and
c                 j=1,...,nlon. the divergence of (v,w) is zero. i.e.,
c                 (d/dtheta (sin(theta) v) + dw/dphi)/sin(theta) = 0.
c                 the coefficients br and bi are zero.
c
c            = 3  v is symmetric and w is antisymmetric about the
c                 equator. the synthesis is performed on the northern
c                 hemisphere only.  i.e., if nlat is odd the synthesis
c                 is performed on the arrays v(i,j),w(i,j) for
c                 i=1,...,(nlat+1)/2 and j=1,...,nlon. if nlat is
c                 even the synthesis is performed on the the arrays
c                 v(i,j),w(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
c
c            = 4  v is symmetric and w is antisymmetric about the
c                 equator. the synthesis is performed on the northern
c                 hemisphere only.  i.e., if nlat is odd the synthesis
c                 is performed on the arrays v(i,j),w(i,j) for
c                 i=1,...,(nlat+1)/2 and j=1,...,nlon. if nlat is
c                 even the synthesis is performed on the the arrays
c                 v(i,j),w(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
c                 the curl of (v,w) is zero. that is,
c                 (d/dtheta (sin(theta) w) - dv/dphi)/sin(theta) = 0.
c                 the coefficients cr and ci are zero.
c
c            = 5  v is symmetric and w is antisymmetric about the
c                 equator. the synthesis is performed on the northern
c                 hemisphere only.  i.e., if nlat is odd the synthesis
c                 is performed on the arrays v(i,j),w(i,j) for
c                 i=1,...,(nlat+1)/2 and j=1,...,nlon. if nlat is
c                 even the synthesis is performed on the the arrays
c                 v(i,j),w(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
c                 the divergence of (v,w) is zero. i.e.,
c                 (d/dtheta (sin(theta) v) + dw/dphi)/sin(theta) = 0.
c                 the coefficients br and bi are zero.
c
c            = 6  v is antisymmetric and w is symmetric about the
c                 equator. the synthesis is performed on the northern
c                 hemisphere only.  i.e., if nlat is odd the synthesis
c                 is performed on the arrays v(i,j),w(i,j) for
c                 i=1,...,(nlat+1)/2 and j=1,...,nlon. if nlat is
c                 even the synthesis is performed on the the arrays
c                 v(i,j),w(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
c
c            = 7  v is antisymmetric and w is symmetric about the
c                 equator. the synthesis is performed on the northern
c                 hemisphere only.  i.e., if nlat is odd the synthesis
c                 is performed on the arrays v(i,j),w(i,j) for
c                 i=1,...,(nlat+1)/2 and j=1,...,nlon. if nlat is
c                 even the synthesis is performed on the the arrays
c                 v(i,j),w(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
c                 the curl of (v,w) is zero. that is,
c                 (d/dtheta (sin(theta) w) - dv/dphi)/sin(theta) = 0.
c                 the coefficients cr and ci are zero.
c
c            = 8  v is antisymmetric and w is symmetric about the
c                 equator. the synthesis is performed on the northern
c                 hemisphere only.  i.e., if nlat is odd the synthesis
c                 is performed on the arrays v(i,j),w(i,j) for
c                 i=1,...,(nlat+1)/2 and j=1,...,nlon. if nlat is
c                 even the synthesis is performed on the the arrays
c                 v(i,j),w(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
c                 the divergence of (v,w) is zero. i.e.,
c                 (d/dtheta (sin(theta) v) + dw/dphi)/sin(theta) = 0.
c                 the coefficients br and bi are zero.
c
c
c     nt     the number of syntheses.  in the program that calls vhsgs,
c            the arrays v,w,br,bi,cr, and ci can be three dimensional
c            in which case multiple syntheses will be performed.
c            the third index is the synthesis index which assumes the
c            values k=1,...,nt.  for a single synthesis set nt=1. the
c            discription of the remaining parameters is simplified
c            by assuming that nt=1 or that all the arrays are two
c            dimensional.
c
c     idvw   the first dimension of the arrays v,w as it appears in
c            the program that calls vhags. if ityp .le. 2 then idvw
c            must be at least nlat.  if ityp .gt. 2 and nlat is
c            even then idvw must be at least nlat/2. if ityp .gt. 2
c            and nlat is odd then idvw must be at least (nlat+1)/2.
c
c     jdvw   the second dimension of the arrays v,w as it appears in
c            the program that calls vhsgs. jdvw must be at least nlon.
c
c     br,bi  two or three dimensional arrays (see input parameter nt)
c     cr,ci  that contain the vector spherical harmonic coefficients
c            in the spectral representation of v(i,j) and w(i,j) given
c            below at the discription of output parameters v and w.
c
c     mdab   the first dimension of the arrays br,bi,cr, and ci as it
c            appears in the program that calls vhsgs. mdab must be at
c            least min0(nlat,nlon/2) if nlon is even or at least
c            min0(nlat,(nlon+1)/2) if nlon is odd.
c
c     ndab   the second dimension of the arrays br,bi,cr, and ci as it
c            appears in the program that calls vhsgs. ndab must be at
c            least nlat.
c
c     wvhsgs an array which must be initialized by subroutine vhsgsi.
c            once initialized, wvhsgs can be used repeatedly by vhsgs
c            as long as nlon and nlat remain unchanged.  wvhsgs must
c            not be altered between calls of vhsgs.
c
c     lvhsgs the dimension of the array wvhsgs as it appears in the
c            program that calls vhsgs. define
c
c               l1 = min0(nlat,nlon/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            then lvhsgs must be at least
c
c                 l1*l2*(nlat+nlat-l1+1)+nlon+15+2*nlat
c
c
c     work   a work array that does not have to be saved.
c
c     lwork  the dimension of the array work as it appears in the
c            program that calls vhsgs. define
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            if ityp .le. 2 then lwork must be at least
c
c                       (2*nt+1)*nlat*nlon
c
c            if ityp .gt. 2 then lwork must be at least
c
c                        (2*nt+1)*l2*nlon
c
c     **************************************************************
c
c     output parameters
c
c     v,w    two or three dimensional arrays (see input parameter nt)
c            in which the synthesis is stored. v is the colatitudinal
c            component and w is the east longitudinal component.
C*PL*ERROR* Comment line too long
c            v(i,j),w(i,j) contain the components at the guassian colatitude
c            point theta(i) and longitude phi(j) = (j-1)*2*pi/nlon.
c            the index ranges are defined above at the input parameter
c            ityp. v and w are computed from the formulas given below.
c
c
c     define
c
c     1.  theta is colatitude and phi is east longitude
c
c     2.  the normalized associated legendre funnctions
c
c         pbar(m,n,theta) = sqrt((2*n+1)*factorial(n-m)
c                        /(2*factorial(n+m)))*sin(theta)**m/(2**n*
c                        factorial(n)) times the (n+m)th derivative
c                        of (x**2-1)**n with respect to x=cos(theta)
c
c     3.  vbar(m,n,theta) = the derivative of pbar(m,n,theta) with
c                           respect to theta divided by the square
c                           root of n(n+1).
c
c         vbar(m,n,theta) is more easily computed in the form
c
c         vbar(m,n,theta) = (sqrt((n+m)*(n-m+1))*pbar(m-1,n,theta)
c         -sqrt((n-m)*(n+m+1))*pbar(m+1,n,theta))/(2*sqrt(n*(n+1)))
c
c     4.  wbar(m,n,theta) = m/(sin(theta))*pbar(m,n,theta) divided
c                           by the square root of n(n+1).
c
c         wbar(m,n,theta) is more easily computed in the form
c
c         wbar(m,n,theta) = sqrt((2n+1)/(2n-1))*(sqrt((n+m)*(n+m-1))
c         *pbar(m-1,n-1,theta)+sqrt((n-m)*(n-m-1))*pbar(m+1,n-1,theta))
c         /(2*sqrt(n*(n+1)))
c
c
c    the colatitudnal dependence of the normalized surface vector
c                spherical harmonics are defined by
c
c     5.    bbar(m,n,theta) = (vbar(m,n,theta),i*wbar(m,n,theta))
c
c     6.    cbar(m,n,theta) = (i*wbar(m,n,theta),-vbar(m,n,theta))
c
c
c    the coordinate to index mappings
c
C*PL*ERROR* Comment line too long
c     7.   theta(i) = i(th) gaussian grid point and phi(j) = (j-1)*2*pi/nlon
c
c
c     the maximum (plus one) longitudinal wave number
c
c     8.     mmax = min0(nlat,nlon/2) if nlon is even or
c            mmax = min0(nlat,(nlon+1)/2) if nlon is odd.
c
c    if we further define the output vector as
c
c     9.    h(i,j) = (v(i,j),w(i,j))
c
c    and the complex coefficients
c
c     10.   b(m,n) = cmplx(br(m+1,n+1),bi(m+1,n+1))
c
c     11.   c(m,n) = cmplx(cr(m+1,n+1),ci(m+1,n+1))
c
c
c    then for i=1,...,nlat and  j=1,...,nlon
c
c        the expansion for real h(i,j) takes the form
c
c     h(i,j) = the sum from n=1 to n=nlat-1 of the real part of
c
c         .5*(b(0,n)*bbar(0,n,theta(i))+c(0,n)*cbar(0,n,theta(i)))
c
c     plus the sum from m=1 to m=mmax-1 of the sum from n=m to
c     n=nlat-1 of the real part of
c
c              b(m,n)*bbar(m,n,theta(i))*exp(i*m*phi(j))
c             +c(m,n)*cbar(m,n,theta(i))*exp(i*m*phi(j))
c
c   *************************************************************
c
c   in terms of real variables this expansion takes the form
c
c             for i=1,...,nlat and  j=1,...,nlon
c
c     v(i,j) = the sum from n=1 to n=nlat-1 of
c
c               .5*br(1,n+1)*vbar(0,n,theta(i))
c
c     plus the sum from m=1 to m=mmax-1 of the sum from n=m to
c     n=nlat-1 of the real part of
c
c       (br(m+1,n+1)*vbar(m,n,theta(i))-ci(m+1,n+1)*wbar(m,n,theta(i)))
c                                          *cos(m*phi(j))
c      -(bi(m+1,n+1)*vbar(m,n,theta(i))+cr(m+1,n+1)*wbar(m,n,theta(i)))
c                                          *sin(m*phi(j))
c
c    and for i=1,...,nlat and  j=1,...,nlon
c
c     w(i,j) = the sum from n=1 to n=nlat-1 of
c
c              -.5*cr(1,n+1)*vbar(0,n,theta(i))
c
c     plus the sum from m=1 to m=mmax-1 of the sum from n=m to
c     n=nlat-1 of the real part of
c
c      -(cr(m+1,n+1)*vbar(m,n,theta(i))+bi(m+1,n+1)*wbar(m,n,theta(i)))
c                                          *cos(m*phi(j))
c      +(ci(m+1,n+1)*vbar(m,n,theta(i))-br(m+1,n+1)*wbar(m,n,theta(i)))
c                                          *sin(m*phi(j))
c
c
c      br(m+1,nlat),bi(m+1,nlat),cr(m+1,nlat), and ci(m+1,nlat) are
c      assumed zero for m even.
c
c
c     ierror = 0  no errors
c            = 1  error in the specification of nlat
c            = 2  error in the specification of nlon
c            = 3  error in the specification of ityp
c            = 4  error in the specification of nt
c            = 5  error in the specification of idvw
c            = 6  error in the specification of jdvw
c            = 7  error in the specification of mdab
c            = 8  error in the specification of ndab
c            = 9  error in the specification of lvhsgs
c            = 10 error in the specification of lwork
c
c
c     subroutine vhsgsi(nlat,nlon,wvhsgs,lvhsgs,dwork,ldwork,ierror)
c
c     subroutine vhsgsi initializes the array wvhsgs which can then be
c     used repeatedly by subroutine vhsgs until nlat or nlon is changed.
c
c     input parameters
c
c     nlat   the number of points in the gaussian colatitude grid on the
C*PL*ERROR* Comment line too long
c            full sphere. these lie in the interval (0,pi) and are computed
C*PL*ERROR* Comment line too long
c            in radians in theta(1) <...< theta(nlat) by subroutine gaqd.
C*PL*ERROR* Comment line too long
c            if nlat is odd the equator will be included as the grid point
c            theta((nlat+1)/2).  if nlat is even the equator will be
c            excluded as a grid point and will lie half way between
c            theta(nlat/2) and theta(nlat/2+1). nlat must be at least 3.
c            note: on the half sphere, the number of grid points in the
c            colatitudinal direction is nlat/2 if nlat is even or
c            (nlat+1)/2 if nlat is odd.
c
c     nlon   the number of distinct londitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater
c            than zero. the axisymmetric case corresponds to nlon=1.
c            the efficiency of the computation is improved when nlon
c            is a product of small prime numbers.
c
c     lvhsgs the dimension of the array wvhsgs as it appears in the
c            program that calls vhsgs. define
c
c               l1 = min0(nlat,nlon/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            then lvhsgs must be at least
c
c                 l1*l2*(nlat+nlat-l1+1)+nlon+15+2*nlat
c
c     dwork a double precision work array that does not need to be saved
c
c     ldwork the dimension of the array dwork as it appears in the
c            program that calls vhsgsi. ldwork must be at least
c
c                 (3*nlat*(nlat+3)+2)/2

c
c     **************************************************************
c
c     output parameters
c
c     wvhsgs an array which is initialized for use by subroutine vhsgs.
c            once initialized, wvhsgs can be used repeatedly by vhsgs
c            as long as nlat and nlon remain unchanged.  wvhsgs must not
c            be altered between calls of vhsgs.
c
c
c     ierror = 0  no errors
c            = 1  error in the specification of nlat
c            = 2  error in the specification of nlon
c            = 3  error in the specification of lvhsgs
c            = 4  error in the specification of lwork
c
      SUBROUTINE DVHSGS(NLAT,NLON,ITYP,NT,V,W,IDVW,JDVW,BR,BI,CR,CI,
     +                  MDAB,NDAB,WVHSGS,LVHSGS,WORK,LWORK,IERROR)
      DOUBLE PRECISION V
      DOUBLE PRECISION W
      DOUBLE PRECISION BR
      DOUBLE PRECISION BI
      DOUBLE PRECISION CR
      DOUBLE PRECISION CI
      DOUBLE PRECISION WVHSGS
      DOUBLE PRECISION WORK
      DIMENSION V(IDVW,JDVW,1),W(IDVW,JDVW,1),BR(MDAB,NDAB,1),
     +          BI(MDAB,NDAB,1),CR(MDAB,NDAB,1),CI(MDAB,NDAB,1),WORK(1),
     +          WVHSGS(1)

      IERROR = 1
      IF (NLAT.LT.3) RETURN
      IERROR = 2
      IF (NLON.LT.1) RETURN
      IERROR = 3
      IF (ITYP.LT.0 .OR. ITYP.GT.8) RETURN
      IERROR = 4
      IF (NT.LT.0) RETURN
      IERROR = 5
      IMID = (NLAT+1)/2
      IF ((ITYP.LE.2.AND.IDVW.LT.NLAT) .OR.
     +    (ITYP.GT.2.AND.IDVW.LT.IMID)) RETURN
      IERROR = 6
      IF (JDVW.LT.NLON) RETURN
      IERROR = 7
      MMAX = MIN0(NLAT, (NLON+1)/2)
      IF (MDAB.LT.MMAX) RETURN
      IERROR = 8
      IF (NDAB.LT.NLAT) RETURN
      IERROR = 9
      IDZ = (MMAX* (NLAT+NLAT-MMAX+1))/2
      LZIMN = IDZ*IMID
      IF (LVHSGS.LT.LZIMN+LZIMN+NLON+15) RETURN
      IERROR = 10
      IDV = NLAT
      IF (ITYP.GT.2) IDV = IMID
      LNL = NT*IDV*NLON
      IF (LWORK.LT.LNL+LNL+IDV*NLON) RETURN
      IERROR = 0
      IST = 0
      IF (ITYP.LE.2) IST = IMID
c
c     set wvhsgs pointers
c
      LMN = NLAT* (NLAT+1)/2
      JW1 = 1
      JW2 = JW1 + IMID*LMN
      JW3 = JW2 + IMID*LMN
c
c     set work pointers
c
      IW1 = IST + 1
      IW2 = LNL + 1
      IW3 = IW2 + IST
      IW4 = IW2 + LNL

      CALL DVHSGS1(NLAT,NLON,ITYP,NT,IMID,IDVW,JDVW,V,W,MDAB,NDAB,BR,
     +             BI,CR,CI,IDV,WORK,WORK(IW1),WORK(IW2),WORK(IW3),
     +             WORK(IW4),IDZ,WVHSGS(JW1),WVHSGS(JW2),WVHSGS(JW3))
      RETURN
      END

      SUBROUTINE DVHSGS1(NLAT,NLON,ITYP,NT,IMID,IDVW,JDVW,V,W,MDAB,NDAB,
     +                  BR,BI,CR,CI,IDV,VE,VO,WE,WO,WORK,IDZ,VB,WB,
     +                  WRFFT)
      DOUBLE PRECISION V
      DOUBLE PRECISION W
      DOUBLE PRECISION BR
      DOUBLE PRECISION BI
      DOUBLE PRECISION CR
      DOUBLE PRECISION CI
      DOUBLE PRECISION VE
      DOUBLE PRECISION VO
      DOUBLE PRECISION WE
      DOUBLE PRECISION WO
      DOUBLE PRECISION WORK
      DOUBLE PRECISION VB
      DOUBLE PRECISION WB
      DOUBLE PRECISION WRFFT
      DIMENSION V(IDVW,JDVW,1),W(IDVW,JDVW,1),BR(MDAB,NDAB,1),
     +          BI(MDAB,NDAB,1),CR(MDAB,NDAB,1),CI(MDAB,NDAB,1),
     +          VE(IDV,NLON,1),VO(IDV,NLON,1),WE(IDV,NLON,1),
     +          WO(IDV,NLON,1),WORK(1),WRFFT(1),VB(IMID,1),WB(IMID,1)

      NLP1 = NLAT + 1
      MLAT = MOD(NLAT,2)
      MLON = MOD(NLON,2)
      MMAX = MIN0(NLAT, (NLON+1)/2)
      IMM1 = IMID
      IF (MLAT.NE.0) IMM1 = IMID - 1
      DO 10 K = 1,NT
          DO 10 J = 1,NLON
              DO 10 I = 1,IDV
                  VE(I,J,K) = 0.D0
                  WE(I,J,K) = 0.D0
   10 CONTINUE
      NDO1 = NLAT
      NDO2 = NLAT
      IF (MLAT.NE.0) NDO1 = NLAT - 1
      IF (MLAT.EQ.0) NDO2 = NLAT - 1
   18 ITYPP = ITYP + 1
      GO TO (1,100,200,300,400,500,600,700,800) ITYPP
c
c     case ityp=0   no symmetries
c
c     case m = 0
c
    1 CONTINUE
      DO 15 K = 1,NT
          DO 15 NP1 = 2,NDO2,2
              DO 15 I = 1,IMID
                  VE(I,1,K) = VE(I,1,K) + BR(1,NP1,K)*VB(I,NP1)
                  WE(I,1,K) = WE(I,1,K) - CR(1,NP1,K)*VB(I,NP1)
   15 CONTINUE
      DO 16 K = 1,NT
          DO 16 NP1 = 3,NDO1,2
              DO 16 I = 1,IMM1
                  VO(I,1,K) = VO(I,1,K) + BR(1,NP1,K)*VB(I,NP1)
                  WO(I,1,K) = WO(I,1,K) - CR(1,NP1,K)*VB(I,NP1)
   16 CONTINUE
c
c     case m = 1 through nlat-1
c
      IF (MMAX.LT.2) GO TO 950
      DO 30 MP1 = 2,MMAX
          M = MP1 - 1
c     mb = m*(nlat-1)-(m*(m-1))/2
          MB = M*NLAT - (M* (M+1))/2
          MP2 = MP1 + 1
          IF (MP1.GT.NDO1) GO TO 26
          DO 25 K = 1,NT
              DO 24 NP1 = MP1,NDO1,2
                  MN = MB + NP1
                  DO 23 I = 1,IMM1
                      VO(I,2*MP1-2,K) = VO(I,2*MP1-2,K) +
     +                                  BR(MP1,NP1,K)*VB(I,MN)
                      VE(I,2*MP1-2,K) = VE(I,2*MP1-2,K) -
     +                                  CI(MP1,NP1,K)*WB(I,MN)
                      VO(I,2*MP1-1,K) = VO(I,2*MP1-1,K) +
     +                                  BI(MP1,NP1,K)*VB(I,MN)
                      VE(I,2*MP1-1,K) = VE(I,2*MP1-1,K) +
     +                                  CR(MP1,NP1,K)*WB(I,MN)
                      WO(I,2*MP1-2,K) = WO(I,2*MP1-2,K) -
     +                                  CR(MP1,NP1,K)*VB(I,MN)
                      WE(I,2*MP1-2,K) = WE(I,2*MP1-2,K) -
     +                                  BI(MP1,NP1,K)*WB(I,MN)
                      WO(I,2*MP1-1,K) = WO(I,2*MP1-1,K) -
     +                                  CI(MP1,NP1,K)*VB(I,MN)
                      WE(I,2*MP1-1,K) = WE(I,2*MP1-1,K) +
     +                                  BR(MP1,NP1,K)*WB(I,MN)
   23             CONTINUE
                  IF (MLAT.EQ.0) GO TO 24
                  VE(IMID,2*MP1-2,K) = VE(IMID,2*MP1-2,K) -
     +                                 CI(MP1,NP1,K)*WB(IMID,MN)
                  VE(IMID,2*MP1-1,K) = VE(IMID,2*MP1-1,K) +
     +                                 CR(MP1,NP1,K)*WB(IMID,MN)
                  WE(IMID,2*MP1-2,K) = WE(IMID,2*MP1-2,K) -
     +                                 BI(MP1,NP1,K)*WB(IMID,MN)
                  WE(IMID,2*MP1-1,K) = WE(IMID,2*MP1-1,K) +
     +                                 BR(MP1,NP1,K)*WB(IMID,MN)
   24         CONTINUE
   25     CONTINUE
   26     IF (MP2.GT.NDO2) GO TO 30
          DO 29 K = 1,NT
              DO 28 NP1 = MP2,NDO2,2
                  MN = MB + NP1
                  DO 27 I = 1,IMM1
                      VE(I,2*MP1-2,K) = VE(I,2*MP1-2,K) +
     +                                  BR(MP1,NP1,K)*VB(I,MN)
                      VO(I,2*MP1-2,K) = VO(I,2*MP1-2,K) -
     +                                  CI(MP1,NP1,K)*WB(I,MN)
                      VE(I,2*MP1-1,K) = VE(I,2*MP1-1,K) +
     +                                  BI(MP1,NP1,K)*VB(I,MN)
                      VO(I,2*MP1-1,K) = VO(I,2*MP1-1,K) +
     +                                  CR(MP1,NP1,K)*WB(I,MN)
                      WE(I,2*MP1-2,K) = WE(I,2*MP1-2,K) -
     +                                  CR(MP1,NP1,K)*VB(I,MN)
                      WO(I,2*MP1-2,K) = WO(I,2*MP1-2,K) -
     +                                  BI(MP1,NP1,K)*WB(I,MN)
                      WE(I,2*MP1-1,K) = WE(I,2*MP1-1,K) -
     +                                  CI(MP1,NP1,K)*VB(I,MN)
                      WO(I,2*MP1-1,K) = WO(I,2*MP1-1,K) +
     +                                  BR(MP1,NP1,K)*WB(I,MN)
   27             CONTINUE
                  IF (MLAT.EQ.0) GO TO 28
                  VE(IMID,2*MP1-2,K) = VE(IMID,2*MP1-2,K) +
     +                                 BR(MP1,NP1,K)*VB(IMID,MN)
                  VE(IMID,2*MP1-1,K) = VE(IMID,2*MP1-1,K) +
     +                                 BI(MP1,NP1,K)*VB(IMID,MN)
                  WE(IMID,2*MP1-2,K) = WE(IMID,2*MP1-2,K) -
     +                                 CR(MP1,NP1,K)*VB(IMID,MN)
                  WE(IMID,2*MP1-1,K) = WE(IMID,2*MP1-1,K) -
     +                                 CI(MP1,NP1,K)*VB(IMID,MN)
   28         CONTINUE
   29     CONTINUE
   30 CONTINUE
      GO TO 950
c
c     case ityp=1   no symmetries,  cr and ci equal zero
c
c     case m = 0
c
  100 CONTINUE
      DO 115 K = 1,NT
          DO 115 NP1 = 2,NDO2,2
              DO 115 I = 1,IMID
                  VE(I,1,K) = VE(I,1,K) + BR(1,NP1,K)*VB(I,NP1)
  115 CONTINUE
      DO 116 K = 1,NT
          DO 116 NP1 = 3,NDO1,2
              DO 116 I = 1,IMM1
                  VO(I,1,K) = VO(I,1,K) + BR(1,NP1,K)*VB(I,NP1)
  116 CONTINUE
c
c     case m = 1 through nlat-1
c
      IF (MMAX.LT.2) GO TO 950
      DO 130 MP1 = 2,MMAX
          M = MP1 - 1
c     mb = m*(nlat-1)-(m*(m-1))/2
          MB = M*NLAT - (M* (M+1))/2
          MP2 = MP1 + 1
          IF (MP1.GT.NDO1) GO TO 126
          DO 125 K = 1,NT
              DO 124 NP1 = MP1,NDO1,2
                  MN = MB + NP1
                  DO 123 I = 1,IMM1
                      VO(I,2*MP1-2,K) = VO(I,2*MP1-2,K) +
     +                                  BR(MP1,NP1,K)*VB(I,MN)
                      VO(I,2*MP1-1,K) = VO(I,2*MP1-1,K) +
     +                                  BI(MP1,NP1,K)*VB(I,MN)
                      WE(I,2*MP1-2,K) = WE(I,2*MP1-2,K) -
     +                                  BI(MP1,NP1,K)*WB(I,MN)
                      WE(I,2*MP1-1,K) = WE(I,2*MP1-1,K) +
     +                                  BR(MP1,NP1,K)*WB(I,MN)
  123             CONTINUE
                  IF (MLAT.EQ.0) GO TO 124
                  WE(IMID,2*MP1-2,K) = WE(IMID,2*MP1-2,K) -
     +                                 BI(MP1,NP1,K)*WB(IMID,MN)
                  WE(IMID,2*MP1-1,K) = WE(IMID,2*MP1-1,K) +
     +                                 BR(MP1,NP1,K)*WB(IMID,MN)
  124         CONTINUE
  125     CONTINUE
  126     IF (MP2.GT.NDO2) GO TO 130
          DO 129 K = 1,NT
              DO 128 NP1 = MP2,NDO2,2
                  MN = MB + NP1
                  DO 127 I = 1,IMM1
                      VE(I,2*MP1-2,K) = VE(I,2*MP1-2,K) +
     +                                  BR(MP1,NP1,K)*VB(I,MN)
                      VE(I,2*MP1-1,K) = VE(I,2*MP1-1,K) +
     +                                  BI(MP1,NP1,K)*VB(I,MN)
                      WO(I,2*MP1-2,K) = WO(I,2*MP1-2,K) -
     +                                  BI(MP1,NP1,K)*WB(I,MN)
                      WO(I,2*MP1-1,K) = WO(I,2*MP1-1,K) +
     +                                  BR(MP1,NP1,K)*WB(I,MN)
  127             CONTINUE
                  IF (MLAT.EQ.0) GO TO 128
                  VE(IMID,2*MP1-2,K) = VE(IMID,2*MP1-2,K) +
     +                                 BR(MP1,NP1,K)*VB(IMID,MN)
                  VE(IMID,2*MP1-1,K) = VE(IMID,2*MP1-1,K) +
     +                                 BI(MP1,NP1,K)*VB(IMID,MN)
  128         CONTINUE
  129     CONTINUE
  130 CONTINUE
      GO TO 950
c
c     case ityp=2   no symmetries,  br and bi are equal to zero
c
c     case m = 0
c
  200 DO 215 K = 1,NT
          DO 215 NP1 = 2,NDO2,2
              DO 215 I = 1,IMID
                  WE(I,1,K) = WE(I,1,K) - CR(1,NP1,K)*VB(I,NP1)
  215 CONTINUE
      DO 216 K = 1,NT
          DO 216 NP1 = 3,NDO1,2
              DO 216 I = 1,IMM1
                  WO(I,1,K) = WO(I,1,K) - CR(1,NP1,K)*VB(I,NP1)
  216 CONTINUE
c
c     case m = 1 through nlat-1
c
      IF (MMAX.LT.2) GO TO 950
      DO 230 MP1 = 2,MMAX
          M = MP1 - 1
c     mb = m*(nlat-1)-(m*(m-1))/2
          MB = M*NLAT - (M* (M+1))/2
          MP2 = MP1 + 1
          IF (MP1.GT.NDO1) GO TO 226
          DO 225 K = 1,NT
              DO 224 NP1 = MP1,NDO1,2
                  MN = MB + NP1
                  DO 223 I = 1,IMM1
                      VE(I,2*MP1-2,K) = VE(I,2*MP1-2,K) -
     +                                  CI(MP1,NP1,K)*WB(I,MN)
                      VE(I,2*MP1-1,K) = VE(I,2*MP1-1,K) +
     +                                  CR(MP1,NP1,K)*WB(I,MN)
                      WO(I,2*MP1-2,K) = WO(I,2*MP1-2,K) -
     +                                  CR(MP1,NP1,K)*VB(I,MN)
                      WO(I,2*MP1-1,K) = WO(I,2*MP1-1,K) -
     +                                  CI(MP1,NP1,K)*VB(I,MN)
  223             CONTINUE
                  IF (MLAT.EQ.0) GO TO 224
                  VE(IMID,2*MP1-2,K) = VE(IMID,2*MP1-2,K) -
     +                                 CI(MP1,NP1,K)*WB(IMID,MN)
                  VE(IMID,2*MP1-1,K) = VE(IMID,2*MP1-1,K) +
     +                                 CR(MP1,NP1,K)*WB(IMID,MN)
  224         CONTINUE
  225     CONTINUE
  226     IF (MP2.GT.NDO2) GO TO 230
          DO 229 K = 1,NT
              DO 228 NP1 = MP2,NDO2,2
                  MN = MB + NP1
                  DO 227 I = 1,IMM1
                      VO(I,2*MP1-2,K) = VO(I,2*MP1-2,K) -
     +                                  CI(MP1,NP1,K)*WB(I,MN)
                      VO(I,2*MP1-1,K) = VO(I,2*MP1-1,K) +
     +                                  CR(MP1,NP1,K)*WB(I,MN)
                      WE(I,2*MP1-2,K) = WE(I,2*MP1-2,K) -
     +                                  CR(MP1,NP1,K)*VB(I,MN)
                      WE(I,2*MP1-1,K) = WE(I,2*MP1-1,K) -
     +                                  CI(MP1,NP1,K)*VB(I,MN)
  227             CONTINUE
                  IF (MLAT.EQ.0) GO TO 228
                  WE(IMID,2*MP1-2,K) = WE(IMID,2*MP1-2,K) -
     +                                 CR(MP1,NP1,K)*VB(IMID,MN)
                  WE(IMID,2*MP1-1,K) = WE(IMID,2*MP1-1,K) -
     +                                 CI(MP1,NP1,K)*VB(IMID,MN)
  228         CONTINUE
  229     CONTINUE
  230 CONTINUE
      GO TO 950
c
c     case ityp=3   v even,  w odd
c
c     case m = 0
c
  300 DO 315 K = 1,NT
          DO 315 NP1 = 2,NDO2,2
              DO 315 I = 1,IMID
                  VE(I,1,K) = VE(I,1,K) + BR(1,NP1,K)*VB(I,NP1)
  315 CONTINUE
      DO 316 K = 1,NT
          DO 316 NP1 = 3,NDO1,2
              DO 316 I = 1,IMM1
                  WO(I,1,K) = WO(I,1,K) - CR(1,NP1,K)*VB(I,NP1)
  316 CONTINUE
c
c     case m = 1 through nlat-1
c
      IF (MMAX.LT.2) GO TO 950
      DO 330 MP1 = 2,MMAX
          M = MP1 - 1
c     mb = m*(nlat-1)-(m*(m-1))/2
          MB = M*NLAT - (M* (M+1))/2
          MP2 = MP1 + 1
          IF (MP1.GT.NDO1) GO TO 326
          DO 325 K = 1,NT
              DO 324 NP1 = MP1,NDO1,2
                  MN = MB + NP1
                  DO 323 I = 1,IMM1
                      VE(I,2*MP1-2,K) = VE(I,2*MP1-2,K) -
     +                                  CI(MP1,NP1,K)*WB(I,MN)
                      VE(I,2*MP1-1,K) = VE(I,2*MP1-1,K) +
     +                                  CR(MP1,NP1,K)*WB(I,MN)
                      WO(I,2*MP1-2,K) = WO(I,2*MP1-2,K) -
     +                                  CR(MP1,NP1,K)*VB(I,MN)
                      WO(I,2*MP1-1,K) = WO(I,2*MP1-1,K) -
     +                                  CI(MP1,NP1,K)*VB(I,MN)
  323             CONTINUE
                  IF (MLAT.EQ.0) GO TO 324
                  VE(IMID,2*MP1-2,K) = VE(IMID,2*MP1-2,K) -
     +                                 CI(MP1,NP1,K)*WB(IMID,MN)
                  VE(IMID,2*MP1-1,K) = VE(IMID,2*MP1-1,K) +
     +                                 CR(MP1,NP1,K)*WB(IMID,MN)
  324         CONTINUE
  325     CONTINUE
  326     IF (MP2.GT.NDO2) GO TO 330
          DO 329 K = 1,NT
              DO 328 NP1 = MP2,NDO2,2
                  MN = MB + NP1
                  DO 327 I = 1,IMM1
                      VE(I,2*MP1-2,K) = VE(I,2*MP1-2,K) +
     +                                  BR(MP1,NP1,K)*VB(I,MN)
                      VE(I,2*MP1-1,K) = VE(I,2*MP1-1,K) +
     +                                  BI(MP1,NP1,K)*VB(I,MN)
                      WO(I,2*MP1-2,K) = WO(I,2*MP1-2,K) -
     +                                  BI(MP1,NP1,K)*WB(I,MN)
                      WO(I,2*MP1-1,K) = WO(I,2*MP1-1,K) +
     +                                  BR(MP1,NP1,K)*WB(I,MN)
  327             CONTINUE
                  IF (MLAT.EQ.0) GO TO 328
                  VE(IMID,2*MP1-2,K) = VE(IMID,2*MP1-2,K) +
     +                                 BR(MP1,NP1,K)*VB(IMID,MN)
                  VE(IMID,2*MP1-1,K) = VE(IMID,2*MP1-1,K) +
     +                                 BI(MP1,NP1,K)*VB(IMID,MN)
  328         CONTINUE
  329     CONTINUE
  330 CONTINUE
      GO TO 950
c
c     case ityp=4   v even,  w odd, and both cr and ci equal zero
c
c     case m = 0
c
  400 DO 415 K = 1,NT
          DO 415 NP1 = 2,NDO2,2
              DO 415 I = 1,IMID
                  VE(I,1,K) = VE(I,1,K) + BR(1,NP1,K)*VB(I,NP1)
  415 CONTINUE
c
c     case m = 1 through nlat-1
c
      IF (MMAX.LT.2) GO TO 950
      DO 430 MP1 = 2,MMAX
          M = MP1 - 1
c     mb = m*(nlat-1)-(m*(m-1))/2
          MB = M*NLAT - (M* (M+1))/2
          MP2 = MP1 + 1
          IF (MP2.GT.NDO2) GO TO 430
          DO 429 K = 1,NT
              DO 428 NP1 = MP2,NDO2,2
                  MN = MB + NP1
                  DO 427 I = 1,IMM1
                      VE(I,2*MP1-2,K) = VE(I,2*MP1-2,K) +
     +                                  BR(MP1,NP1,K)*VB(I,MN)
                      VE(I,2*MP1-1,K) = VE(I,2*MP1-1,K) +
     +                                  BI(MP1,NP1,K)*VB(I,MN)
                      WO(I,2*MP1-2,K) = WO(I,2*MP1-2,K) -
     +                                  BI(MP1,NP1,K)*WB(I,MN)
                      WO(I,2*MP1-1,K) = WO(I,2*MP1-1,K) +
     +                                  BR(MP1,NP1,K)*WB(I,MN)
  427             CONTINUE
                  IF (MLAT.EQ.0) GO TO 428
                  VE(IMID,2*MP1-2,K) = VE(IMID,2*MP1-2,K) +
     +                                 BR(MP1,NP1,K)*VB(IMID,MN)
                  VE(IMID,2*MP1-1,K) = VE(IMID,2*MP1-1,K) +
     +                                 BI(MP1,NP1,K)*VB(IMID,MN)
  428         CONTINUE
  429     CONTINUE
  430 CONTINUE
      GO TO 950
c
c     case ityp=5   v even,  w odd,     br and bi equal zero
c
c     case m = 0
c
  500 DO 516 K = 1,NT
          DO 516 NP1 = 3,NDO1,2
              DO 516 I = 1,IMM1
                  WO(I,1,K) = WO(I,1,K) - CR(1,NP1,K)*VB(I,NP1)
  516 CONTINUE
c
c     case m = 1 through nlat-1
c
      IF (MMAX.LT.2) GO TO 950
      DO 530 MP1 = 2,MMAX
          M = MP1 - 1
c     mb = m*(nlat-1)-(m*(m-1))/2
          MB = M*NLAT - (M* (M+1))/2
          MP2 = MP1 + 1
          IF (MP1.GT.NDO1) GO TO 530
          DO 525 K = 1,NT
              DO 524 NP1 = MP1,NDO1,2
                  MN = MB + NP1
                  DO 523 I = 1,IMM1
                      VE(I,2*MP1-2,K) = VE(I,2*MP1-2,K) -
     +                                  CI(MP1,NP1,K)*WB(I,MN)
                      VE(I,2*MP1-1,K) = VE(I,2*MP1-1,K) +
     +                                  CR(MP1,NP1,K)*WB(I,MN)
                      WO(I,2*MP1-2,K) = WO(I,2*MP1-2,K) -
     +                                  CR(MP1,NP1,K)*VB(I,MN)
                      WO(I,2*MP1-1,K) = WO(I,2*MP1-1,K) -
     +                                  CI(MP1,NP1,K)*VB(I,MN)
  523             CONTINUE
                  IF (MLAT.EQ.0) GO TO 524
                  VE(IMID,2*MP1-2,K) = VE(IMID,2*MP1-2,K) -
     +                                 CI(MP1,NP1,K)*WB(IMID,MN)
                  VE(IMID,2*MP1-1,K) = VE(IMID,2*MP1-1,K) +
     +                                 CR(MP1,NP1,K)*WB(IMID,MN)
  524         CONTINUE
  525     CONTINUE
  530 CONTINUE
      GO TO 950
c
c     case ityp=6   v odd  ,  w even
c
c     case m = 0
c
  600 DO 615 K = 1,NT
          DO 615 NP1 = 2,NDO2,2
              DO 615 I = 1,IMID
                  WE(I,1,K) = WE(I,1,K) - CR(1,NP1,K)*VB(I,NP1)
  615 CONTINUE
      DO 616 K = 1,NT
          DO 616 NP1 = 3,NDO1,2
              DO 616 I = 1,IMM1
                  VO(I,1,K) = VO(I,1,K) + BR(1,NP1,K)*VB(I,NP1)
  616 CONTINUE
c
c     case m = 1 through nlat-1
c
      IF (MMAX.LT.2) GO TO 950
      DO 630 MP1 = 2,MMAX
          M = MP1 - 1
c     mb = m*(nlat-1)-(m*(m-1))/2
          MB = M*NLAT - (M* (M+1))/2
          MP2 = MP1 + 1
          IF (MP1.GT.NDO1) GO TO 626
          DO 625 K = 1,NT
              DO 624 NP1 = MP1,NDO1,2
                  MN = MB + NP1
                  DO 623 I = 1,IMM1
                      VO(I,2*MP1-2,K) = VO(I,2*MP1-2,K) +
     +                                  BR(MP1,NP1,K)*VB(I,MN)
                      VO(I,2*MP1-1,K) = VO(I,2*MP1-1,K) +
     +                                  BI(MP1,NP1,K)*VB(I,MN)
                      WE(I,2*MP1-2,K) = WE(I,2*MP1-2,K) -
     +                                  BI(MP1,NP1,K)*WB(I,MN)
                      WE(I,2*MP1-1,K) = WE(I,2*MP1-1,K) +
     +                                  BR(MP1,NP1,K)*WB(I,MN)
  623             CONTINUE
                  IF (MLAT.EQ.0) GO TO 624
                  WE(IMID,2*MP1-2,K) = WE(IMID,2*MP1-2,K) -
     +                                 BI(MP1,NP1,K)*WB(IMID,MN)
                  WE(IMID,2*MP1-1,K) = WE(IMID,2*MP1-1,K) +
     +                                 BR(MP1,NP1,K)*WB(IMID,MN)
  624         CONTINUE
  625     CONTINUE
  626     IF (MP2.GT.NDO2) GO TO 630
          DO 629 K = 1,NT
              DO 628 NP1 = MP2,NDO2,2
                  MN = MB + NP1
                  DO 627 I = 1,IMM1
                      VO(I,2*MP1-2,K) = VO(I,2*MP1-2,K) -
     +                                  CI(MP1,NP1,K)*WB(I,MN)
                      VO(I,2*MP1-1,K) = VO(I,2*MP1-1,K) +
     +                                  CR(MP1,NP1,K)*WB(I,MN)
                      WE(I,2*MP1-2,K) = WE(I,2*MP1-2,K) -
     +                                  CR(MP1,NP1,K)*VB(I,MN)
                      WE(I,2*MP1-1,K) = WE(I,2*MP1-1,K) -
     +                                  CI(MP1,NP1,K)*VB(I,MN)
  627             CONTINUE
                  IF (MLAT.EQ.0) GO TO 628
                  WE(IMID,2*MP1-2,K) = WE(IMID,2*MP1-2,K) -
     +                                 CR(MP1,NP1,K)*VB(IMID,MN)
                  WE(IMID,2*MP1-1,K) = WE(IMID,2*MP1-1,K) -
     +                                 CI(MP1,NP1,K)*VB(IMID,MN)
  628         CONTINUE
  629     CONTINUE
  630 CONTINUE
      GO TO 950
c
c     case ityp=7   v odd, w even   cr and ci equal zero
c
c     case m = 0
c
  700 DO 716 K = 1,NT
          DO 716 NP1 = 3,NDO1,2
              DO 716 I = 1,IMM1
                  VO(I,1,K) = VO(I,1,K) + BR(1,NP1,K)*VB(I,NP1)
  716 CONTINUE
c
c     case m = 1 through nlat-1
c
      IF (MMAX.LT.2) GO TO 950
      DO 730 MP1 = 2,MMAX
          M = MP1 - 1
c     mb = m*(nlat-1)-(m*(m-1))/2
          MB = M*NLAT - (M* (M+1))/2
          MP2 = MP1 + 1
          IF (MP1.GT.NDO1) GO TO 730
          DO 725 K = 1,NT
              DO 724 NP1 = MP1,NDO1,2
                  MN = MB + NP1
                  DO 723 I = 1,IMM1
                      VO(I,2*MP1-2,K) = VO(I,2*MP1-2,K) +
     +                                  BR(MP1,NP1,K)*VB(I,MN)
                      VO(I,2*MP1-1,K) = VO(I,2*MP1-1,K) +
     +                                  BI(MP1,NP1,K)*VB(I,MN)
                      WE(I,2*MP1-2,K) = WE(I,2*MP1-2,K) -
     +                                  BI(MP1,NP1,K)*WB(I,MN)
                      WE(I,2*MP1-1,K) = WE(I,2*MP1-1,K) +
     +                                  BR(MP1,NP1,K)*WB(I,MN)
  723             CONTINUE
                  IF (MLAT.EQ.0) GO TO 724
                  WE(IMID,2*MP1-2,K) = WE(IMID,2*MP1-2,K) -
     +                                 BI(MP1,NP1,K)*WB(IMID,MN)
                  WE(IMID,2*MP1-1,K) = WE(IMID,2*MP1-1,K) +
     +                                 BR(MP1,NP1,K)*WB(IMID,MN)
  724         CONTINUE
  725     CONTINUE
  730 CONTINUE
      GO TO 950
c
c     case ityp=8   v odd,  w even   br and bi equal zero
c
c     case m = 0
c
  800 DO 815 K = 1,NT
          DO 815 NP1 = 2,NDO2,2
              DO 815 I = 1,IMID
                  WE(I,1,K) = WE(I,1,K) - CR(1,NP1,K)*VB(I,NP1)
  815 CONTINUE
c
c     case m = 1 through nlat-1
c
      IF (MMAX.LT.2) GO TO 950
      DO 830 MP1 = 2,MMAX
          M = MP1 - 1
c     mb = m*(nlat-1)-(m*(m-1))/2
          MB = M*NLAT - (M* (M+1))/2
          MP2 = MP1 + 1
          IF (MP2.GT.NDO2) GO TO 830
          DO 829 K = 1,NT
              DO 828 NP1 = MP2,NDO2,2
                  MN = MB + NP1
                  DO 827 I = 1,IMM1
                      VO(I,2*MP1-2,K) = VO(I,2*MP1-2,K) -
     +                                  CI(MP1,NP1,K)*WB(I,MN)
                      VO(I,2*MP1-1,K) = VO(I,2*MP1-1,K) +
     +                                  CR(MP1,NP1,K)*WB(I,MN)
                      WE(I,2*MP1-2,K) = WE(I,2*MP1-2,K) -
     +                                  CR(MP1,NP1,K)*VB(I,MN)
                      WE(I,2*MP1-1,K) = WE(I,2*MP1-1,K) -
     +                                  CI(MP1,NP1,K)*VB(I,MN)
  827             CONTINUE
                  IF (MLAT.EQ.0) GO TO 828
                  WE(IMID,2*MP1-2,K) = WE(IMID,2*MP1-2,K) -
     +                                 CR(MP1,NP1,K)*VB(IMID,MN)
                  WE(IMID,2*MP1-1,K) = WE(IMID,2*MP1-1,K) -
     +                                 CI(MP1,NP1,K)*VB(IMID,MN)
  828         CONTINUE
  829     CONTINUE
  830 CONTINUE
  950 CONTINUE
      DO 14 K = 1,NT
          CALL DHRFFTB(IDV,NLON,VE(1,1,K),IDV,WRFFT,WORK)
          CALL DHRFFTB(IDV,NLON,WE(1,1,K),IDV,WRFFT,WORK)
   14 CONTINUE
      IF (ITYP.GT.2) GO TO 12
      DO 60 K = 1,NT
          DO 60 J = 1,NLON
              DO 60 I = 1,IMM1
                  V(I,J,K) = .5D0* (VE(I,J,K)+VO(I,J,K))
                  W(I,J,K) = .5D0* (WE(I,J,K)+WO(I,J,K))
                  V(NLP1-I,J,K) = .5D0* (VE(I,J,K)-VO(I,J,K))
                  W(NLP1-I,J,K) = .5D0* (WE(I,J,K)-WO(I,J,K))
   60 CONTINUE
      GO TO 13
   12 DO 11 K = 1,NT
          DO 11 J = 1,NLON
              DO 11 I = 1,IMM1
                  V(I,J,K) = .5D0*VE(I,J,K)
                  W(I,J,K) = .5D0*WE(I,J,K)
   11 CONTINUE
   13 IF (MLAT.EQ.0) RETURN
      DO 65 K = 1,NT
          DO 65 J = 1,NLON
              V(IMID,J,K) = .5D0*VE(IMID,J,K)
              W(IMID,J,K) = .5D0*WE(IMID,J,K)
   65 CONTINUE
      RETURN
      END
      SUBROUTINE DVHSGSI(NLAT,NLON,WVHSGS,LVHSGS,DWORK,LDWORK,IERROR)
      DOUBLE PRECISION WVHSGS
c
c     subroutine vhsfsi computes the gaussian points theta, gauss
c     weights wts, and the components vb and wb of the vector
c     harmonics. all quantities are computed internally in double
c     precision but returned in single precision and are therfore
c     accurate to single precision.
c
c     set imid = (nlat+1)/2 and lmn=(nlat*(nlat+1))/2 then
c     wvhsgs must have 2*(imid*lmn+nlat)+nlon+15 locations
c
c     double precision array dwork must have
c       3*nlat*(nlat+1)+5*nlat+1 = nlat*(3*nlat+8)+1
c     locations which is determined by the size of dthet,
c     dwts, dwork, and dpbar in vhsgs1
c
      DIMENSION WVHSGS(*)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION DWORK(*)

      IERROR = 1
      IF (NLAT.LT.3) RETURN
      IERROR = 2
      IF (NLON.LT.1) RETURN
      IERROR = 3
      IMID = (NLAT+1)/2
      LMN = (NLAT* (NLAT+1))/2
      IF (LVHSGS.LT.2* (IMID*LMN)+NLON+15) RETURN
      IERROR = 4
      IF (LDWORK.LT. (NLAT*3* (NLAT+3)+2)/2) RETURN
      IERROR = 0
c
c     set saved work space pointers
c
      JW1 = 1
      JW2 = JW1 + IMID*LMN
      JW3 = JW2 + IMID*LMN
c
c     set unsaved work space pointers
c
      IW1 = 1
      IW2 = IW1 + NLAT
      IW3 = IW2 + NLAT
      IW4 = IW3 + 3*IMID*NLAT
c     iw2 = iw1+nlat+nlat
c     iw3 = iw2+nlat+nlat
c     iw4 = iw3+6*imid*nlat
      CALL DVHGSI1(NLAT,IMID,WVHSGS(JW1),WVHSGS(JW2),DWORK(IW1),
     +             DWORK(IW2),DWORK(IW3),DWORK(IW4))
      CALL DHRFFTI(NLON,WVHSGS(JW3))
      RETURN
      END
      SUBROUTINE DVHGSI1(NLAT,IMID,VB,WB,DTHET,DWTS,DPBAR,WORK)
      DOUBLE PRECISION VB
      DOUBLE PRECISION WB
      DIMENSION VB(IMID,*),WB(IMID,*)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION ABEL,BBEL,CBEL,SSQR2,DCF
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION DTHET(*),DWTS(*),DPBAR(IMID,NLAT,3),WORK(*)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION DN,DM
c
c     compute gauss points and weights
c     use dpbar (length 3*nnlat*(nnlat+1)) as work space for gaqd
c
      LWK = NLAT* (NLAT+2)
      CALL DGAQD(NLAT,DTHET,DWTS,DPBAR,LWK,IERROR)
C*PT*WARNING* Constant already double-precision
c
c     compute associated legendre functions
c
c     compute m=n=0 legendre polynomials for all theta(i)
c
      SSQR2 = 1.D0/DSQRT(2.d0)
      DO 90 I = 1,IMID
          DPBAR(I,1,1) = SSQR2
          VB(I,1) = 0.D0
          WB(I,1) = 0.D0
   90 CONTINUE
c
c     main loop for remaining vb, and wb
c
      DO 100 N = 1,NLAT - 1
C*PT*WARNING* Already double-precision (DBLE)
          DN = DBLE(N)
          NM = MOD(N-2,3) + 1
          NZ = MOD(N-1,3) + 1
          NP = MOD(N,3) + 1
c
c     compute dpbar for m=0
c
          CALL DDNLFK(0,N,WORK)
          MN = INDX(0,N,NLAT)
          DO 105 I = 1,IMID
              CALL DDNLFT(0,N,DTHET(I),WORK,DPBAR(I,1,NP))
c      pbar(i,mn) = dpbar(i,1,np)
  105     CONTINUE
c
c     compute dpbar for m=1
c
          CALL DDNLFK(1,N,WORK)
          MN = INDX(1,N,NLAT)
          DO 106 I = 1,IMID
              CALL DDNLFT(1,N,DTHET(I),WORK,DPBAR(I,2,NP))
c      pbar(i,mn) = dpbar(i,2,np)
  106     CONTINUE
  104     CONTINUE
c
c     compute and store dpbar for m=2,n
c
          IF (N.LT.2) GO TO 108
          DO 107 M = 2,N
C*PT*WARNING* Already double-precision (DBLE)
              DM = DBLE(M)
              ABEL = DSQRT(((2*DN+1)* (DM+DN-2)* (DM+DN-3))/
     +               ((2*DN-3)* (DM+DN-1)* (DM+DN)))
              BBEL = DSQRT(((2*DN+1)* (DN-DM-1)* (DN-DM))/
     +               ((2*DN-3)* (DM+DN-1)* (DM+DN)))
              CBEL = DSQRT(((DN-DM+1)* (DN-DM+2))/ ((DM+DN-1)* (DM+DN)))
              ID = INDX(M,N,NLAT)
              IF (M.GE.N-1) GO TO 102
              DO 103 I = 1,IMID
                  DPBAR(I,M+1,NP) = ABEL*DPBAR(I,M-1,NM) +
     +                              BBEL*DPBAR(I,M+1,NM) -
     +                              CBEL*DPBAR(I,M-1,NP)
c      pbar(i,id) = dpbar(i,m+1,np)
  103         CONTINUE
              GO TO 107
  102         DO 101 I = 1,IMID
                  DPBAR(I,M+1,NP) = ABEL*DPBAR(I,M-1,NM) -
     +                              CBEL*DPBAR(I,M-1,NP)
c      pbar(i,id) = dpbar(i,m+1,np)
  101         CONTINUE
  107     CONTINUE
c
c     compute the derivative of the functions
c
  108     IX = INDX(0,N,NLAT)
          IY = INDX(N,N,NLAT)
          DO 125 I = 1,IMID
              VB(I,IX) = -DPBAR(I,2,NP)
              VB(I,IY) = DPBAR(I,N,NP)/DSQRT(2* (DN+1))
  125     CONTINUE
c
          IF (N.EQ.1) GO TO 131
          DCF = DSQRT(4*DN* (DN+1))
          DO 130 M = 1,N - 1
              DM = DBLE(M)
              IX = INDX(M,N,NLAT)
              ABEL = DSQRT((DN+DM)* (DN-DM+1))/DCF
              BBEL = DSQRT((DN-DM)* (DN+DM+1))/DCF
              DO 130 I = 1,IMID
                  VB(I,IX) = ABEL*DPBAR(I,M,NP) - BBEL*DPBAR(I,M+2,NP)
  130     CONTINUE
c
c     compute the vector harmonic w(theta) = m*pbar/cos(theta)
c
c     set wb=0 for m=0
c
  131     IX = INDX(0,N,NLAT)
          DO 220 I = 1,IMID
C*PT*WARNING* Constant already double-precision
              WB(I,IX) = 0.d0
  220     CONTINUE
c
c     compute wb for m=1,n
c
          DCF = DSQRT((DN+DN+1)/ (4*DN* (DN+1)* (DN+DN-1)))
          DO 230 M = 1,N
              DM = DBLE(M)
              IX = INDX(M,N,NLAT)
              ABEL = DCF*DSQRT((DN+DM)* (DN+DM-1))
              BBEL = DCF*DSQRT((DN-DM)* (DN-DM-1))
              IF (M.GE.N-1) GO TO 231
              DO 229 I = 1,IMID
                  WB(I,IX) = ABEL*DPBAR(I,M,NZ) + BBEL*DPBAR(I,M+2,NZ)
  229         CONTINUE
              GO TO 230
  231         DO 228 I = 1,IMID
                  WB(I,IX) = ABEL*DPBAR(I,M,NZ)
  228         CONTINUE
  230     CONTINUE
  100 CONTINUE
      RETURN
      END

C
C $Id: getsi.f,v 1.8 2008-07-27 00:17:24 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GETSI (IX,IY)
C
C Return to the user the parameters which determine the assumed size of
C the target plotter and therefore determine how user coordinates are
C to be mapped into plotter coordinates.
C
C Declare the common block containing the scaling information.
C
      COMMON /IUTLCM/ LL,MI,MX,MY,IU(96)
      SAVE /IUTLCM/
C
C Check for an uncleared prior error.
C
      IF (ICFELL('GETSI - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C Set the user variables.
C
      IX=MX
      IY=MY
C
      RETURN
C
      END

C
C	$Id: congen.f,v 1.5 2008-07-27 00:16:55 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CONGEN (XI,YI,IPACK,SCRARR,ICA)
C
C  DRAW A CONTOUR AT THE CURRENT LEVEL
C
C  INPUT
C       XI YI LOWER RIGHT CORNER OF CELL
C       IPACK-FLAG TO ALLOW REDUCTION OF COORDINATE PAIR STORAGE
C             IF REQUIRED
C       SCRARR-SCRATCH ARRAY OF CONTOUR VALUES
C       ICA-ENTERING CASE CONDITIONS IF ANY REQUIRED
C
C
C
C
      COMMON /CONRA1/ CL(30)     ,NCL        ,OLDZ       ,PV(210)    ,
     1                FINC       ,HI         ,FLO
      COMMON /CONRA2/ REPEAT     ,EXTRAP     ,PER        ,MESS       ,
     1                ISCALE     ,LOOK       ,PLDVLS     ,GRD        ,
     2                CINC       ,CHILO      ,CON        ,LABON      ,
     3                PMIMX      ,SCALE      ,FRADV      ,EXTRI      ,
     4                BPSIZ      ,LISTOP
      COMMON /CONRA3/ IREC
      COMMON /CONRA4/ NCP        ,NCPSZ
      COMMON /CONRA5/ NIT        ,ITIPV
      COMMON /CONRA6/ XST        ,YST        ,XED        ,YED        ,
     1                STPSZ      ,IGRAD      ,IG         ,XRG        ,
     2                YRG        ,BORD       ,PXST       ,PYST       ,
     3                PXED       ,PYED       ,ITICK
      COMMON /CONR18/ TITLE      ,ICNT   ,ITLSIZ
      COMMON /CONR19/ IHIGH      ,INMAJ      ,INLAB      ,INDAT      ,
     1              LEN      ,IFMT       ,LEND       ,
     2                IFMTD      ,ISIZEP     ,INMIN
      COMMON /CONRA9/ ICOORD(500),NP         ,MXXY       ,TR         ,
     1                BR         ,TL         ,BL         ,CONV       ,
     2                XN         ,YN         ,ITLL       ,IBLL       ,
     3                ITRL       ,IBRL       ,XC         ,YC         ,
     4                ITLOC(210) ,JX         ,JY         ,ILOC       ,
     5                ISHFCT     ,XO         ,YO         ,IOC        ,NC
      COMMON /CONR10/ NT         ,NL         ,NTNL       ,JWIPT      ,
     1                JWIWL      ,JWIWP      ,JWIPL      ,IPR        ,
     2                ITPV
      COMMON /CONR20/ NREP       ,NCRT       ,ISIZEL     ,
     1                MINGAP     ,ISIZEM         ,
     2                TENS
      COMMON /CONR12/ IXMAX      ,IYMAX      ,XMAX       ,YMAX
      LOGICAL         REPEAT     ,EXTRAP     ,PER        ,MESS       ,
     1                LOOK       ,PLDVLS     ,GRD        ,LABON      ,
     2                PMIMX      ,FRADV      ,EXTRI      ,CINC       ,
     3                TITLE      ,LISTOP     ,CHILO      ,CON
      COMMON /CONR15/ ISTRNG
        CHARACTER*64 ISTRNG
        COMMON /CONR16/ FORM
        CHARACTER*10 FORM
        COMMON /CONR17/ NDASH, IDASH, EDASH
        CHARACTER*10 NDASH, IDASH, EDASH
C
C
C
      DIMENSION       SCRARR(1)  ,IXMOV(2)   ,IYMOV(2)
        CHARACTER*64    IHOLD
        CHARACTER*23    IVOUT
      INTEGER         GOOP
C
        SAVE
        DATA NOOP,GOOP/1,0/
C
C  STATEMENT FUNCTIONS FOR MAPPING GRAPHICS OUTPUT
C
C     FX(XXX,YYY) = XXX
C     FY(XXX,YYY) = YYY
C
C  STATEMENT FUNCTION TO MAKE ARRAY ACCESS SEEM LIKE MATRIX ACCESS
C
      SCRTCH(IXX,IYY) = SCRARR(IYY+(IXX-1)*IYMAX)
C
C  DRAW AN ENTIRE CONTOUR LINE WHEN A POTENTIAL START POINT IS
C  PROVIDED
C
C  SAVE STARTING CELL
C
      XCS = XI
      YCS = YI
C
C  TEST IF VALID START POINT
C
      ICASE = ICA
      XC = XI
      YC = YI
      CALL CONCLD (ICASE,NOOP)
C
C  IF NO CONTOUR RETURN
C
      IF (ICASE.EQ.-1) RETURN
      IF (ICASE.EQ.0) RETURN
C
C  IF CONTOUR ALREADY DRAWN RETURN
C
      ILOC = IOR(ISHIFT(JX,ISHFCT),JY)
      IF (NP.EQ.0) GO TO    20
C
C TEST IF CONTOUR FOUND
C
          DO    10 I=1,NP
          IF (ILOC.NE.ICOORD(I)) GO TO    10
          RETURN
   10     CONTINUE
C
C  GET CORRECT OLD CASE
C
   20 IC = IOC
      IF (ICASE.EQ.IOC) IC = NC
C
C  SET UP STRUCTURE TO START IN OTHER DIRECTION FROM HERE IF CONTOUR
C  UNEXPECTLY ENDS IN THIS DIRECTION
C
      IFCASE = IC
      IFOCSE = ICASE
      FXO = XO
      FYO = YO
      LOOP = 1
C
C  SET UP IC TO SIMULATE EXIT FROM A PREVIOUS CELL
C
      IC = MOD(IC+2,4)
C
C  IF EXTRAPOLATING PASS ON
C
      IF (EXTRAP) GO TO    60
C
C  TEST IF CONTOUR EXCEEDED BORDER LIMITS
C  NOTE THAT ICASER CANNOT EQUAL 3 AT THIS POINT
C
      GO TO (   30,   40,   30,   50),ICASE
C
C  EXIT FROM BOTTOM
C
   30 IF (JX.GE.IXMAX) RETURN
      GO TO    60
C
C  EXIT FROM LEFT
C
   40 IF (JY.LE.ITLOC(JX*2 - 1)) RETURN
      GO TO    60
C
C  EXIT FROM RIGHT
C
   50 IF (JY.GE.ITLOC(JX*2 - 1)) RETURN
C
C  SAVE CELL INFO IF COMMING BACK
C
   60 TRT = TR
      BRT = BR
      TLT = TL
      BLT = BL
      IX = JX
      IY = JY
C
C  VALID CONTOUR START FOUND
C
      XX = FX(XO,YO)
      CALL FRSTD (XX,FY(XO,YO))
C
C  DRAW CONTOUR IN THIS CELL
C
   70 XX = FX(XN,YN)
      CALL VECTD (XX,FY(XN,YN))
      XCSTOR = XC
      YCSTOR = YC
      IXSTOR = IX
      IYSTOR = IY
      IOLDC = IC
      IC = ICASE
C
C  ENTER COORDINATE PAIR OF CONTOUR IN LIST
C
      NP = NP+1
      IF (NP.GT.MXXY) GO TO   180
      ICOORD(NP) = ILOC
C
C  BRANCH TO APPROPIATE CODE DEPENDING ON CONTOUR EXIT FROM THE CELL
C
   80 GO TO (   90,  110,  130,  150),IC
C
C  EXIT FORM BOTTOM
C  END CONTOUR IF ON CONVEX HULL
C
   90 IF (EXTRAP) GO TO   100
      IF (IY.LT.ITLOC(IX*2 - 1) .OR. IY-1.GT.ITLOC(IX*2)) GO TO   360
  100 TR = BR
      TL = BL
      XC = XC+STPSZ
C
C  IF ON BORDER END CONTOUR
C
      IX = IX+1
      IF (IX.GT.IXMAX) GO TO   360
      BR = SCRTCH(IX,IY)
      BL = SCRTCH(IX,IY-1)
      ILOC = IOR(ISHIFT(IX,ISHFCT),IY)
C
C  BRANCH IF CONTOUR CLOSED
C
      IF (IX.EQ.JX .AND. IY.EQ.JY) GO TO   170
      CALL CONCLD (ICASE,GOOP)
      IF (ICASE.EQ.-1) GO TO 360
      IF (ICASE.NE.0) GO TO    70
      GO TO   230
C
C  EXIT FROM LEFT SIDE
C  TEST IF IN CONVEX HULL
C
  110 IF (EXTRAP) GO TO   120
      IF (IY-1.LT.ITLOC( (IX-1)*2 - 1 ) .AND. IY-1.LT.ITLOC(IX*2 - 1))
     1    GO TO   360
  120 TR = TL
      BR = BL
      YC = YC-STPSZ
C
C  IF ON BORDER END CONTOUR
C
      IY = IY-1
      IF (IY.LT.2) GO TO   360
      TL = SCRTCH(IX-1,IY-1)
      BL = SCRTCH(IX,IY-1)
C
C  BRANCH IF CONTOUR CLOSED
C
      IF (IX.EQ.JX .AND. IY.EQ.JY) GO TO   170
      ILOC = IOR(ISHIFT(IX,ISHFCT),IY)
      CALL CONCLD (ICASE,GOOP)
      IF (ICASE.EQ.-1) GO TO 360
      IF (ICASE.NE.0) GO TO    70
      GO TO   230
C
C  EXIT FROM TOP
C  END CONTOUR IF OUT OF CONVEX HULL
C
  130 IF (EXTRAP) GO TO   140
      IF (IY.LT.ITLOC( (IX-1)*2 - 1 ) .OR. IY-1.GT.ITLOC( (IX-1)*2 ))
     1    GO TO   360
  140 BR = TR
      BL = TL
      XC = XC-STPSZ
C
C  END CONTOUR IF OUTSIDE OF BORDER
C
      IX = IX-1
      IF (IX.LT.2) GO TO   360
      TR = SCRTCH(IX-1,IY)
      TL = SCRTCH(IX-1,IY-1)
      ILOC = IOR(ISHIFT(IX,ISHFCT),IY)
C
C  BRANCH IF CONTOUR CLOSED
C
      IF (IX.EQ.JX .AND. IY.EQ.JY) GO TO   170
      CALL CONCLD (ICASE,GOOP)
      IF (ICASE.EQ.-1) GO TO 360
      IF (ICASE.NE.0) GO TO    70
      GO TO   230
C
C  EXIT FROM RIGHT SIDE
C  TEST IF ON CONVEX HULL
C
  150 IF (EXTRAP) GO TO   160
      IF (IY.GT.ITLOC( (IX-1)*2 ) .AND. IY.GT.ITLOC(IX*2)) GO TO   360
  160 TL = TR
      BL = BR
      YC = YC+STPSZ
C
C  IF ON BORDER END CONTOUR
C
      IY = IY+1
      IF (IY.GT.IYMAX) GO TO   360
      TR = SCRTCH(IX-1,IY)
      BR = SCRTCH(IX,IY)
      ILOC = IOR(ISHIFT(IX,ISHFCT),IY)
C
C  BRANCH IF CONTOUR CLOSED
C
      IF (IX.EQ.JX .AND. IY.EQ.JY) GO TO   170
      CALL CONCLD (ICASE,GOOP)
      IF (ICASE.EQ.-1) GO TO 360
      IF (ICASE.NE.0) GO TO    70
      GO TO   230
C
C  END THE CONTOUR
C
  170 CALL LASTD
      TR = TRT
      BR = BRT
      TL = TLT
      BL = BLT
      RETURN
C
C  CONTOUR STORAGE EXCEEDED TRY PACKING
C
  180 IF (IPACK.EQ.0) GO TO   200
      NP = 0
      ITEST = IOR(ISHIFT(JX,ISHFCT),JY)
          DO   190 K=1,MXXY
          IF (ICOORD(K).LE.ITEST) GO TO   190
          NP = NP+1
          ICOORD(NP) = ICOORD(K)
  190     CONTINUE
      IF (NP.LT.MXXY) GO TO    80
C
C  FAILURE NO MORE SPACE ABORT THIS CONTOUR LEVEL
C
  200 IHOLD(1:39) = ' CONDRW-CONTOUR STORAGE EXAUSTED LEVEL='
C
C  BLANK FILL THE ENCODE ARRAY
C
        IVOUT = '                       '
      WRITE(IVOUT,'(G13.5)')CONV
        IHOLD(40:62) = IVOUT
      CALL SETER (IHOLD,10,IREC)
      RETURN
C
C  BAD TIME THE CONTOUR EXITED A CORNER OF THE CELL MUST SEARCH FOR
C  NEW CELL
C
  230 IXSTP = IXSTOR
      IYSTP = IYSTOR
      GO TO (  240,  250,  260,  270),IOLDC
C
C PREVIOUS CELL BOTTOM EXIT
C
  240 IXSTP = IXSTP-1
      GO TO   280
C
C  PREVIOUS CELL LEFT EXIT
C
  250 IYSTP = IYSTP+1
      GO TO   280
C
C  PREVIOUS CELL TOP EXIT
C
  260 IXSTP = IXSTP+1
      GO TO   280
C
C  PREVIOUS CELL RIGHT EXIT
C
  270 IYSTP = IYSTP-1
C
C  BRANCH TO CURRENT CELL CASE
C
  280 GO TO (  290,  300,  310,  320),IC
C
C  APPARENT BOTTOM EXIT
C
  290 IXMOV(1) = 0
      IXMOV(2) = 1
      IYMOV(1) = -1
      IYMOV(2) = 1
      GO TO   330
C
C  APPARENT LEFT EXIT
C
  300 IXMOV(1) = 1
      IXMOV(2) = -1
      IYMOV(1) = 0
      IYMOV(2) = -1
      GO TO   330
C
C  APPARENT TOP EXIT
C
  310 IXMOV(1) = 0
      IXMOV(2) = -1
      IYMOV(1) = -1
      IYMOV(2) = 1
      GO TO   330
C
C  APPARENT RIGHT EXIT
C
  320 IXMOV(1) = 1
      IXMOV(2) = -1
      IYMOV(1) = 0
      IYMOV(2) = 1
C
C  SEARCH THE POSSIBLE CELLS
C
  330     DO   350 K=1,2
              DO   340 L=1,2
              XC = XCSTOR + STPSZ*REAL( IXMOV(K) )
              YC = YCSTOR + STPSZ*REAL( IYMOV(L) )
              IX = IXSTOR+IXMOV(K)
              IY = IYSTOR+IYMOV(L)
              ILOC = IOR(ISHIFT(IX,ISHFCT),IY)
C
C  IF BACK TO START END CONTOUR
C
              IF (IX.EQ.JX .AND. IY.EQ.JY) GO TO   170
C
C  IF AT PREVIOUS CELL SKIP PROCESSING
C
              IF (IX.EQ.IXSTP .AND. IY.EQ.IYSTP) GO TO   340
C
C  COMPUTE CELL VALUES
C
              TL = SCRTCH(IX-1,IY-1)
              BL = SCRTCH(IX,IY-1)
              TR = SCRTCH(IX-1,IY)
              BL = SCRTCH(IX,IY)
              ICASE = IC
              CALL CONCLD (ICASE,NOOP)
              IF (ICASE.EQ.-1) GO TO 360
              IF (ICASE.NE.0) GO TO    70
C
C  FAILURE TRY AGAIN
C
  340         CONTINUE
  350     CONTINUE
C
C  NO MORE CONTOUR TRY OTHER END OF LINE
C
  360 IF (LOOP.EQ.0) GO TO   170
      LOOP = 0
      IX = JX
      IY = JY
      TR = TRT
      TL = TLT
      BR = BRT
      BL = BLT
      IC = IFCASE
      ICASE = IC
      IOLDC = IFOCSE
      XC = XI
      YC = YI
      IXSTOR = IX
      IYSTOR = IY
      YCSTOR = YI
      XCSTOR = XI
      XX = FX(FXO,FYO)
      CALL LASTD
      CALL FRSTD (XX,FY(FXO,FYO))
      GO TO (   90,  110,  130,  150),IC
      END

C
C	$Id: csdelnb.f,v 1.5 2008-07-27 03:10:06 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CSDELNB (N0,NB,N, LIST,LPTR,LEND,LNEW, LPH)
      INTEGER N0, NB, N, LIST(*), LPTR(*), LEND(N), LNEW,
     .        LPH
C
C***********************************************************
C
C                                              From STRIPACK
C                                            Robert J. Renka
C                                  Dept. of Computer Science
C                                       Univ. of North Texas
C                                           renka@cs.unt.edu
C                                                   07/29/98
C
C   This subroutine deletes a neighbor NB from the adjacency
C list of node N0 (but N0 is not deleted from the adjacency
C list of NB) and, if NB is a boundary node, makes N0 a
C boundary node.  For pointer (LIST index) LPH to NB as a
C neighbor of N0, the empty LIST,LPTR location LPH is filled
C in with the values at LNEW-1, pointer LNEW-1 (in LPTR and
C possibly in LEND) is changed to LPH, and LNEW is decremen-
C ted.  This requires a search of LEND and LPTR entailing an
C expected operation count of O(N).
C
C   This routine is identical to the similarly named routine
C in TRIPACK.
C
C
C On input:
C
C       N0,NB = Indexes, in the range 1 to N, of a pair of
C               nodes such that NB is a neighbor of N0.
C               (N0 need not be a neighbor of NB.)
C
C       N = Number of nodes in the triangulation.  N .GE. 3.
C
C The above parameters are not altered by this routine.
C
C       LIST,LPTR,LEND,LNEW = Data structure defining the
C                             triangulation.
C
C On output:
C
C       LIST,LPTR,LEND,LNEW = Data structure updated with
C                             the removal of NB from the ad-
C                             jacency list of N0 unless
C                             LPH < 0.
C
C       LPH = List pointer to the hole (NB as a neighbor of
C             N0) filled in by the values at LNEW-1 or error
C             indicator:
C             LPH > 0 if no errors were encountered.
C             LPH = -1 if N0, NB, or N is outside its valid
C                      range.
C             LPH = -2 if NB is not a neighbor of N0.
C
C Modules required by CSDELNB:  None
C
C Intrinsic function called by CSDELNB:  ABS
C
C***********************************************************
C
      INTEGER I, LNW, LP, LPB, LPL, LPP, NN
C
C Local parameters:
C
C I =   DO-loop index
C LNW = LNEW-1 (output value of LNEW)
C LP =  LIST pointer of the last neighbor of NB
C LPB = Pointer to NB as a neighbor of N0
C LPL = Pointer to the last neighbor of N0
C LPP = Pointer to the neighbor of N0 that precedes NB
C NN =  Local copy of N
C
      NN = N
C
C Test for error 1.
C
      IF (N0 .LT. 1  .OR.  N0 .GT. NN  .OR.  NB .LT. 1  .OR.
     .    NB .GT. NN  .OR.  NN .LT. 3) THEN
        LPH = -1
        RETURN
      ENDIF
C
C   Find pointers to neighbors of N0:
C
C     LPL points to the last neighbor,
C     LPP points to the neighbor NP preceding NB, and
C     LPB points to NB.
C
      LPL = LEND(N0)
      LPP = LPL
      LPB = LPTR(LPP)
    1 IF (LIST(LPB) .EQ. NB) GO TO 2
        LPP = LPB
        LPB = LPTR(LPP)
        IF (LPB .NE. LPL) GO TO 1
C
C   Test for error 2 (NB not found).
C
      IF (ABS(LIST(LPB)) .NE. NB) THEN
        LPH = -2
        RETURN
      ENDIF
C
C   NB is the last neighbor of N0.  Make NP the new last
C     neighbor and, if NB is a boundary node, then make N0
C     a boundary node.
C
      LEND(N0) = LPP
      LP = LEND(NB)
      IF (LIST(LP) .LT. 0) LIST(LPP) = -LIST(LPP)
      GO TO 3
C
C   NB is not the last neighbor of N0.  If NB is a boundary
C     node and N0 is not, then make N0 a boundary node with
C     last neighbor NP.
C
    2 LP = LEND(NB)
      IF (LIST(LP) .LT. 0  .AND.  LIST(LPL) .GT. 0) THEN
        LEND(N0) = LPP
        LIST(LPP) = -LIST(LPP)
      ENDIF
C
C   Update LPTR so that the neighbor following NB now fol-
C     lows NP, and fill in the hole at location LPB.
C
    3 LPTR(LPP) = LPTR(LPB)
      LNW = LNEW-1
      LIST(LPB) = LIST(LNW)
      LPTR(LPB) = LPTR(LNW)
      DO 4 I = NN,1,-1
        IF (LEND(I) .EQ. LNW) THEN
          LEND(I) = LPB
          GO TO 5
        ENDIF
    4   CONTINUE
C
    5 DO 6 I = 1,LNW-1
        IF (LPTR(I) .EQ. LNW) THEN
          LPTR(I) = LPB
        ENDIF
    6   CONTINUE
C
C No errors encountered.
C
      LNEW = LNW
      LPH = LPB
      RETURN
      END

C
C	$Id: conlod.f,v 1.4 2008-07-27 00:16:55 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CONLOD (XD,YD,ZD,NDP,WK,IWK,SCRARR)
C
C******************************************************************
C*                                                                *
C*   THIS FILE IS A PACKAGE OF SUPPORT ROUTINES FOR THE ULIB      *
C*   FILES CONRAN AND CONRAS.  SEE THOSE FILES FOR AN             *
C*   EXPLAINATION OF THE ENTRY POINTS.                            *
C*                                                                *
C******************************************************************
C
      COMMON /CONRA1/ CL(30)     ,NCL        ,OLDZ       ,PV(210)    ,
     1                FINC       ,HI         ,FLO
      COMMON /CONRA2/ REPEAT     ,EXTRAP     ,PER        ,MESS       ,
     1                ISCALE     ,LOOK       ,PLDVLS     ,GRD        ,
     2                CINC       ,CHILO      ,CON        ,LABON      ,
     3                PMIMX      ,SCALE      ,FRADV      ,EXTRI      ,
     4                BPSIZ      ,LISTOP
      COMMON /CONRA3/ IREC
      COMMON /CONRA4/ NCP        ,NCPSZ
      COMMON /CONRA5/ NIT        ,ITIPV
      COMMON /CONRA6/ XST        ,YST        ,XED        ,YED        ,
     1                STPSZ      ,IGRAD      ,IG         ,XRG        ,
     2                YRG        ,BORD       ,PXST       ,PYST       ,
     3                PXED       ,PYED       ,ITICK
      COMMON /CONR18/ TITLE      ,ICNT   ,ITLSIZ
      COMMON /CONR19/ IHIGH      ,INMAJ      ,INLAB      ,INDAT      ,
     1              LEN      ,IFMT       ,LEND       ,
     2                IFMTD      ,ISIZEP     ,INMIN
      COMMON /CONRA9/ ICOORD(500),  NP       ,MXXY       ,TR         ,
     1                BR         ,TL         ,BL         ,CONV       ,
     2                XN         ,YN         ,ITLL       ,IBLL       ,
     3                ITRL       ,IBRL       ,XC         ,YC         ,
     4                ITLOC(210) ,JX         ,JY         ,ILOC       ,
     5                ISHFCT     ,XO         ,YO         ,IOC        ,NC
      COMMON /CONR10/ NT         ,NL         ,NTNL       ,JWIPT      ,
     1                JWIWL      ,JWIWP      ,JWIPL      ,IPR        ,
     2                ITPV
      COMMON /CONR20/ NREP       ,NCRT       ,ISIZEL     ,
     1                MINGAP     ,ISIZEM         ,
     2                TENS
      COMMON /CONR12/ IXMAX      ,IYMAX      ,XMAX       ,YMAX
      LOGICAL         REPEAT     ,EXTRAP     ,PER        ,MESS       ,
     1                LOOK       ,PLDVLS     ,GRD        ,LABON      ,
     2                PMIMX      ,FRADV      ,EXTRI      ,CINC       ,
     3                TITLE      ,LISTOP     ,CHILO      ,CON
      COMMON /CONR13/XVS(50),YVS(50),ICOUNT,SPVAL,SHIELD,
     1               SLDPLT
      LOGICAL SHIELD,SLDPLT
      COMMON /CONR14/LINEAR
      LOGICAL LINEAR
      COMMON /CONR15/ ISTRNG
        CHARACTER*64 ISTRNG
        COMMON /CONR16/ FORM
        CHARACTER*10 FORM
        COMMON /CONR17/ NDASH, IDASH, EDASH
        CHARACTER*10 NDASH, IDASH, EDASH
C
C
      DIMENSION       SCRARR(1)
C
        SAVE
C
C  IFR - FLAG TO REGISTER FIRST PASS IN Y DIRECTION
C
C  LOAD THE SCRATCH SPACE AND CONVEX HULL POINTERS
C  ITLOC IS THE LIST OF CONVEX HULL POINTERS RELATIVE TO THE SCARTCH
C  SPACE.
C  PV IS THE LIST OF CONVEX HULL POINTERS RELATIVE TO USER COORDINATES
C
C  INITALIZE THE SPECIAL VALUE FEATURE
C
      X = (XED-XST)/2. + XST
      Y = (YED-YST)/2. + YST
      IF(LINEAR) GO TO 1
      SPVAL = CONCOM(X,Y,XD,YD,ZD,NDP,WK,IWK,IT)
        GO TO 2
 1    SPVAL = CONLCM(X,Y,XD,YD,ZD,NDP,WK,IWK,IT)
 2    CONTINUE
C
C  INITIALIZE THE SEARCH
C
      IYMAX = 0
      IFR = 1
      JX = 1
      X = XST
   10 JY = 1
      Y = YST
C
C  SET HULL POINTERS FOR THIS COLUMN TO NULL
C
      ITLOC(JX*2-1) = 0
      ITLOC(JX*2) = 0
C
C  FLAG START OF COLUMN
C
      LOOP = 1
C
C  GET INTERPOLATED VALUE
C
  20  IF (LINEAR) GO TO 3
      RVAL = CONCOM(X,Y,XD,YD,ZD,NDP,WK,IWK,IT)
      GO TO 4
  3   RVAL = CONLCM(X,Y,XD,YD,ZD,NDP,WK,IWK,IT)
  4   CONTINUE
      SCRARR(JY+(JX-1)*IYMAX) = RVAL
      IF (RVAL.GT.SPVAL) SPVAL = RVAL
C
C  IF OUTSIDE CONVEX HULL BRANCH
C
      IF (IT.GT.NTNL) GO TO    30
C
C  IF OUTSIDE TRIANGLES AND USING LINEAR INTERPLOATION THEN BRANCH
C
      IF(LINEAR.AND.IT.GT.NT) GO TO 30
C
C  IF FIRST OF COLUMN IN HULL CONTINUE THROUGH
C
      IF (LOOP.NE.1) GO TO    40
C
C  SET HULL POINTERS
C
      PV(JX*2-1) = Y
      ITLOC(JX*2-1) = JY
C
C  SET FLAG TO LOOK FOR END OF HULL IN COLUMN
C
      LOOP = 2
C
C  GO FOR NEXT ENTRY
C
      GO TO    40
C
C  TEST FOR END OF CONVEX HULL ON THIS ROW
C
   30 IF (LOOP.NE.2) GO TO    40
C
C  END OF HULL SET POINTERS FOR END OF HULL AND FLAG IT VIA LOOP
C
      LOOP = 0
      ITLOC(JX*2) = JY-1
      PV(JX*2) = Y-STPSZ
C
C  GET NEXT ELEMENT IN ROW IF NOT OUTSIDE ENCLOSING RECTANGULAR
C  BOARDER
C
   40 Y = Y+STPSZ
      JY = JY+1
      IF (Y.LE.YED) GO TO    20
C
C  TEST FOR FIRST COLUMN
C
      IF (IFR.NE.1) GO TO    50
C
C  FIRST COLUMN OVER SET MAX Y VALUES
C
      IYMAX = JY-1
      YMAX = Y-STPSZ
      IFR = 0
C
C  IF HULL WENT TO EDGE OF RECTANGULAR BOARDER SET HULL POINTERS HERE
C
   50 IF (LOOP.NE.2) GO TO    60
      PV(JX*2) = Y-STPSZ
      ITLOC(JX*2) = JY-1
C
C  END OF COLUMN GET NEXT ONE
C
   60 X = X+STPSZ
      JX = JX+1
C
C  IF NOT END OF WORK CONTINUE WITH NEXT COLUMN
C
      IF (X.LE.XED) GO TO    10
C
C  END OF WORK SET MAX X VALUES
C
      IXMAX = JX-1
      XMAX = X-STPSZ
      RETURN
      END

C
C	$Id: trnmch.f,v 1.4 2008-07-27 00:59:05 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE TRNMCH
C
C  SET THE SYSTEM DEPENDENT CONSTANTS
C
      COMMON/TRINOT/ IPTR, MBUFOT, MAXBYT, DEVUNT, METUNT,
     1          METIPT, ERRUNT, FNTUNT
      INTEGER MAXCNT
      PARAMETER (MAXCNT=200)
      INTEGER IPTR, MBUFOT(MAXCNT), MAXBYT, DEVUNT, METUNT, ERRUNT,
     1        FNTUNT
      LOGICAL METIPT
      COMMON /TRMACH/ BTSWRD
      INTEGER BTSWRD
C
      INTEGER I1MACH
C
C  GET THE NUMBER OF BITS PER WORD
C
      BTSWRD = I1MACH(5)
C
C  COMPUTE THE NUMBER OF BYTES IN THE OUTPUT BUFFER
C
      MAXBYT = (BTSWRD/8) * MAXCNT
C
      RETURN
      END

C
C $Id: mdpgci.f,v 1.8 2008-09-18 00:42:17 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MDPGCI (ALAT,ALON,BLAT,BLON,NOPI,RLTI,RLNI)
C
        INTEGER          NOPI
        DOUBLE PRECISION ALAT,ALON,BLAT,BLON,RLTI(*),RLNI(*)
C
C Declare common block containing math constants.
C
        COMMON /MAPCM0/  COS1,DTOR,DTRH,OOPI,PI,PIOF,PIOT,RTDD,RTOD,
     +                   SROT,SIN1,TOPI,TSRT
        DOUBLE PRECISION COS1,DTOR,DTRH,OOPI,PI,PIOF,PIOT,RTDD,RTOD,
     +                   SROT,SIN1,TOPI,TSRT
        SAVE   /MAPCM0/
C
C This routine, given the latitudes and longitudes of two points A and
C B on the surface of the globe, interpolates NOPI points along the
C great circle route joining A to B and returns the latitudes and
C longitudes of the interpolated points in the arrays RLTI and RLNI.
C
C Rotations about a given axis are used extensively below.  Assume a
C right-handed system with U, V, and W axes.  Rotating by an angle "a"
C about the U axis maps the point (u,v,w) into the point (u',v',w'),
C where
C
C       u' = u
C       v' = v cos(a) - w sin(a)
C       w' = w cos(a) + v sin(a)
C
C A positive value of "a" represents rotation in the direction from the
C V axis to the W axis.
C
C Similarly, rotating by an angle "a" about the V axis maps the point
C (u,v,w) into the point (u',v',w'), where
C
C       u' = u cos(a) + w sin(a)
C       v' = v
C       w' = w cos(a) - u sin(a)
C
C A positive value of "a" represents rotation in the direction from the
C W axis to the U axis.
C
C Rotating by an angle "a" about the W axis maps the point (u,v,w) into
C the point (u',v',w'), where
C
C       u' = u cos(a) - v sin(a)
C       v' = v cos(a) + u sin(a)
C       w' = w
C
C A positive value of "a" represents rotation in the direction from the
C U axis to the V axis.
C
C Declare local variables.
C
        INTEGER          IOPI
C
        DOUBLE PRECISION ALPH,BETA,CALN,CALP,CALT,CBLN,CBLT,GAMA,SALN,
     +                   SALP,SALT,SBLN,SBLT,UCPA,UCPB,UCPD,UCPF,UCPG,
     +                   UCPH,UCPO,UCPP,UCPQ,VCPA,VCPB,VCPD,VCPF,VCPG,
     +                   VCPH,VCPO,VCPP,VCPQ,WCPA,WCPB,WCPD,WCPF,WCPG,
     +                   WCPH,WCPO,WCPP,WCPQ
C
C Check for an uncleared prior error.
C
      IF (ICFELL('MDPGCI - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C Compute the U, V, and W coordinates (on a unit sphere) of the points
C A and B.
C
        CALT=COS(ALAT*DTOR)
        SALT=SIN(ALAT*DTOR)
        CALN=COS(ALON*DTOR)
        SALN=SIN(ALON*DTOR)
C
        CBLT=COS(BLAT*DTOR)
        SBLT=SIN(BLAT*DTOR)
        CBLN=COS(BLON*DTOR)
        SBLN=SIN(BLON*DTOR)
C
        UCPA=CALT*CALN
        VCPA=CALT*SALN
        WCPA=SALT
C
        UCPB=CBLT*CBLN
        VCPB=CBLT*SBLN
        WCPB=SBLT
C
C Rotating the points about the W axis by the angle -ALON carries point
C A into point C, in the UW plane.  It carries point B into point D.
C
C       CDLN=COS((BLON-ALON)*DTOR)
C       SDLN=SIN((BLON-ALON)*DTOR)
C
C       UCPC=CALT
C       VCPC=0.D0
C       WCPC=SALT
C
        UCPD=UCPB*CALN+VCPB*SALN
        VCPD=VCPB*CALN-UCPB*SALN
        WCPD=WCPB
C
C       UCPD=CBLT*CDLN
C       VCPD=CBLT*SDLN
C       WCPD=SBLT
C
C Rotating the points about the V axis by the angle ALAT carries point
C C into point E, on the U axis.  It carries point D into point F.
C
C       UCPE=1.D0
C       VCPE=0.D0
C       WCPE=0.D0
C
        UCPF=UCPD*CALT+WCPD*SALT
        VCPF=VCPD
        WCPF=WCPD*CALT-UCPD*SALT
C
C       UCPF=CALT*CBLT*CDLN-SALT*SBLT
C       VCPF=CBLT*SDLN
C       WCPF=CALT*SBLT+SALT*CBLT*CDLN
C
C Rotating the points about the U axis by the angle -ATAN(WCPF/VCPF)
C leaves the position of point E unchanged, but carries point F into
C point G, in the UV plane.
C
        IF (WCPF.NE.0.D0.OR.VCPF.NE.0.D0) THEN
          ALPH=ATAN2(WCPF,VCPF)
        ELSE
          ALPH=0.D0
        END IF
C
        CALP=COS(ALPH)
        SALP=SIN(ALPH)
C
        UCPG=UCPF
        VCPG=VCPF*CALP+WCPF*SALP
        WCPG=WCPF*CALP-VCPF*SALP
C
C       UCPG=CALT*CBLT*CDLN-SALT*SBLT
C       VCPG=CBLT*SDLN*CALP-CALT*SBLT*SALP-SALT*CBLT*CDLN*SALP
C       WCPG=CALT*SBLT*CALP+SALT*CBLT*CDLN*CALP+CBLT*SDLN*SALP
C
C The angle from E to G (which is the same as the angle from A to B)
C may now be computed easily.
C
        IF (VCPG.NE.0.D0.OR.UCPG.NE.0.D0) THEN
          BETA=ATAN2(VCPG,UCPG)
        ELSE
          BETA=0.D0
        END IF
C
C Interpolate points between the points E and G and map them back to
C the great circle route between A and B.
C
        DO 101 IOPI=1,NOPI
          GAMA=(DBLE(IOPI)/DBLE(NOPI+1))*BETA
          UCPH=COS(GAMA)
          VCPH=SIN(GAMA)
          WCPH=0.D0
          UCPO=UCPH
          VCPO=VCPH*CALP-WCPH*SALP
          WCPO=WCPH*CALP+VCPH*SALP
          UCPP=UCPO*CALT-WCPO*SALT
          VCPP=VCPO
          WCPP=WCPO*CALT+UCPO*SALT
          UCPQ=UCPP*CALN-VCPP*SALN
          VCPQ=VCPP*CALN+UCPP*SALN
          WCPQ=WCPP
          RLTI(IOPI)=RTOD*ATAN2(WCPQ,SQRT(UCPQ*UCPQ+VCPQ*VCPQ))
          IF (VCPQ.NE.0.D0.OR.UCPQ.NE.0.D0) THEN
            RLNI(IOPI)=RTOD*ATAN2(VCPQ,UCPQ)
          ELSE
            RLNI(IOPI)=0.D0
          END IF
  101   CONTINUE
C
C Done.
C
        RETURN
C
      END

C
C	$Id: tlocal.f,v 1.4 2008-07-27 00:59:03 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      PROGRAM TLOCAL
C
C     Test program for locally implemented support routines
C     IAND, IOR, ISHIFT, GBYTES, SBYTES
C
      INTEGER BYTLNG,WRDLNG
      DIMENSION MASK0(64)
      DIMENSION MASK1(65)
      DIMENSION ISCR(190)
C
C     This is a test package designed to test the locally
C     implemented routines for the NCAR GKS-based graphics
C     package.   Although the tests are not exhaustive,
C     they give a fairly  good idea whether a routine works
C     or not.
C
C     Appropriate messages are printed when a routine passes or
C     fails a test.  The test package is written in FORTRAN 77
C     with the following machine assumptions:  non-negative
C     integers must be stored in binary format, in one machine word--
C     hence, a word of all 0 bits is zero; a word with only the
C     rightmost bit set is one, etc.
C
C     The test package consists of a main program and various
C     subroutines.  To run the test package, compile it as FORTRAN,
C     and load and execute it with your locally written routines.
C     Certain information must be supplied to the main program
C     before the test.  This is most conveniently supplied by
C     changing certain data statements at the beginning of the main
C     program.  Below are 8 groups of comments.  Each group
C     describes the information required in the data statements
C     which follow it.  Read the directions and modify the data
C     statements as required.
C
C
C 1.  IOUT.  IOUT is an integer variable containing the unit
C     number on which the test package is to output all messages.
C     It is used, for example, in statements like
C
C                  WRITE (IOUT,9999)
C
C     IOUT has been initialized to 6, but you should reset IOUT so
C     that messages come to your line printer.  The test
C     assumes at least 72 columns per line including carriage
C     control.  There are no read statements.
C
      DATA IOUT/6/
C
C
C 2.  WRDLNG.     WRDLNG is an integer variable which contains the
C     number of bits in a machine word in your computer,
C        e.g.   For an ibm 360/370,  wrdlng = 32;
C               for a CRAY-1,  WRDLNG = 64 .
C     WRDLNG must be at least 16 bits and at most 64 bits.
C
      DATA WRDLNG/0/
C
C
C 3.  INLNGA and INLNGC.
C
C     INLNGA is an integer variable specifying the number of
C     contiguous low-order bits transferred from J to I by the
C     FORTRAN assignment statement
C
C         I=J
C
C     INLNGC is an integer variable specifying the number of
C     contiguous low-order bits actually participating in the
C     comparison performed by a FORTRAN statement like
C
C          IF (I.NE.J) GO TO 10
C
C     These parameters are used to determine the highest-order
C     bit that the test package can use in integer operations.
C     If either is less that WRDLNG, the routines IAND, IOR, and
C     ISHIFT are not fully tested.  If either is less than 16,
C     no testing can be done, and the package probably cannot be
C     made to run.
C
C
      DATA INLNGA /0/
      DATA INLNGC /0/
C
C
C 4.  MASK0.  MASK0 is an integer array of WRDLNG elements.
C     Each element contains all zero bits except for 1 one bit.
C     In element I, the one bit is I-1 bits from the right.  Hence,
C     MASK0(1) has the rightmost bit set, MASK0(WRDLNG) has the
C     leftmost bit set.  In terms of integers, MASK0(I) = 2**(I-1).
C     The test program comes with 64 data statements initializing
C     MASK0.  However, on most computers overflow will cause some of
C     our supplied values to be invalid.  You should begin by
C     removing the last 64-WRDLNG data statements, since these are for
C     word sizes larger than yours.  There should be WRDLNG data
C     statements remaining.  You should then change the last few of
C     these data statements to eliminate overflow, and generate the
C     proper values as defined above.  You may want to use octal or
C     hex constants.  The test program cannot check that MASK0 has
C     been initialized properly, but it is crucial that it be set
C     correctly.
C
C
      DATA MASK0( 1) /                    1 / ,
     1     MASK0( 2) /                    2 / ,
     2     MASK0( 3) /                    4 / ,
     3     MASK0( 4) /                    8 / ,
     4     MASK0( 5) /                   16 / ,
     5     MASK0( 6) /                   32 / ,
     6     MASK0( 7) /                   64 / ,
     7     MASK0( 8) /                  128 / ,
     8     MASK0( 9) /                  256 / ,
     9     MASK0(10) /                  512 / ,
     +     MASK0(11) /                 1024 / ,
     1     MASK0(12) /                 2048 / ,
     2     MASK0(13) /                 4096 / ,
     3     MASK0(14) /                 8192 / ,
     4     MASK0(15) /                16384 / ,
     5     MASK0(16) /                32768 /
      DATA MASK0(17) /                65536 / ,
     1     MASK0(18) /               131072 / ,
     2     MASK0(19) /               262144 / ,
     3     MASK0(20) /               524288 / ,
     4     MASK0(21) /              1048576 / ,
     5     MASK0(22) /              2097152 / ,
     6     MASK0(23) /              4194304 / ,
     7     MASK0(24) /              8388608 / ,
     8     MASK0(25) /             16777216 / ,
     9     MASK0(26) /             33554432 / ,
     +     MASK0(27) /             67108864 / ,
     1     MASK0(28) /            134217728 / ,
     2     MASK0(29) /            268435456 / ,
     3     MASK0(30) /            536870912 / ,
     4     MASK0(31) /           1073741824 / ,
     5     MASK0(32) /           2147483648 /
      DATA MASK0(33) /           4294967296 / ,
     1     MASK0(34) /           8589934592 / ,
     2     MASK0(35) /          17179869184 / ,
     3     MASK0(36) /          34359738368 / ,
     4     MASK0(37) /          68719476736 / ,
     5     MASK0(38) /         137438953472 / ,
     6     MASK0(39) /         274877906944 / ,
     7     MASK0(40) /         549755813888 / ,
     8     MASK0(41) /        1099511627776 / ,
     9     MASK0(42) /        2199023255552 / ,
     +     MASK0(43) /        4398046511104 / ,
     1     MASK0(44) /        8796093022208 / ,
     2     MASK0(45) /       17592186044416 / ,
     3     MASK0(46) /       35184372088832 / ,
     4     MASK0(47) /       70368744177664 / ,
     5     MASK0(48) /      140737488355328 /
      DATA MASK0(49) /      281474976710656 / ,
     1     MASK0(50) /      562949953421312 / ,
     2     MASK0(51) /     1125899906842624 / ,
     3     MASK0(52) /     2251799813685248 / ,
     4     MASK0(53) /     4503599627370496 / ,
     5     MASK0(54) /     9007199254740992 / ,
     6     MASK0(55) /    18014398509481984 / ,
     7     MASK0(56) /    36028797018963968 / ,
     8     MASK0(57) /    72057594037927936 / ,
     9     MASK0(58) /   144115188075855872 / ,
     +     MASK0(59) /   288230376151711744 / ,
     1     MASK0(60) /   576460752303423488 / ,
     2     MASK0(61) /  1152921504606846976 / ,
     3     MASK0(62) /  2305843009213693952 / ,
     4     MASK0(63) /  4611686018427387904 / ,
     5     MASK0(64) /  9223372036854775808 /
C
C
C 5.  MSK0DM.  MSK0DM is an integer variable containing the
C     dimension of MASK0.  It must be at least WRDLNG.  The
C     dimension statement for MASK0 is at the beginning of the main
C     program.  You may leave it unchanged, or if you are cramped
C     for space, lower it to WRDLNG.
C
C
      DATA MSK0DM /64/
C
C 6.  MASK1.  MASK1 is an integer array of WRDLNG+1 elements.
C     Element I has the lower I-1 bits set, the other bits are
C     zero, hence, MASK1(1) = 0, MASK1(2) =1,
C                  MASK1(3) = 3, ..., MASK1(WRDLNG+1) is all ones.
C     In terms of integers MASK1(I) = (2**(I-1))-1 .
C     The test program comes with 65 data statements initializing
C     MASK1.  However on most computers overflow will cause some of
C     these to be invalid.  Begin by removing the last 64-WRDLNG
C     data statements.  You should have WRDLNG+1 remaining data
C     statements.  Change the last few of these to eliminate
C     overflow and generate the values as defined above.  You may
C     want to use octal or hex constants.  It is crucial that
C     MASK1 be initialized properly, even though the test program
C     cannot check for this.
C     WARNING.  On one's complement machines, MASK1(WRDLNG+1) = -0.
C
C
C
      DATA MASK1( 1) /                    0 / ,
     1     MASK1( 2) /                    1 / ,
     2     MASK1( 3) /                    3 / ,
     3     MASK1( 4) /                    7 / ,
     4     MASK1( 5) /                   15 / ,
     5     MASK1( 6) /                   31 / ,
     6     MASK1( 7) /                   63 / ,
     7     MASK1( 8) /                  127 / ,
     8     MASK1( 9) /                  255 / ,
     9     MASK1(10) /                  511 / ,
     +     MASK1(11) /                 1023 / ,
     1     MASK1(12) /                 2047 / ,
     2     MASK1(13) /                 4095 / ,
     3     MASK1(14) /                 8191 / ,
     4     MASK1(15) /                16383 / ,
     5     MASK1(16) /                32767 /
      DATA MASK1(17) /                65535 / ,
     1     MASK1(18) /               131071 / ,
     2     MASK1(19) /               262143 / ,
     3     MASK1(20) /               524287 / ,
     4     MASK1(21) /              1048575 / ,
     5     MASK1(22) /              2097151 / ,
     6     MASK1(23) /              4194303 / ,
     7     MASK1(24) /              8388607 / ,
     8     MASK1(25) /             16777215 / ,
     9     MASK1(26) /             33554431 / ,
     +     MASK1(27) /             67108863 / ,
     1     MASK1(28) /            134217727 / ,
     2     MASK1(29) /            268435455 / ,
     3     MASK1(30) /            536870911 / ,
     4     MASK1(31) /           1073741823 / ,
     5     MASK1(32) /           2147483647 /
      DATA MASK1(33) /           4294967295 / ,
     1     MASK1(34) /           8589934591 / ,
     2     MASK1(35) /          17179869183 / ,
     3     MASK1(36) /          34359738367 / ,
     4     MASK1(37) /          68719476735 / ,
     5     MASK1(38) /         137438953471 / ,
     6     MASK1(39) /         274877906943 / ,
     7     MASK1(40) /         549755813887 / ,
     8     MASK1(41) /        1099511627775 / ,
     9     MASK1(42) /        2199023255551 / ,
     +     MASK1(43) /        4398046511103 / ,
     1     MASK1(44) /        8796093022207 / ,
     2     MASK1(45) /       17592186044415 / ,
     3     MASK1(46) /       35184372088831 / ,
     4     MASK1(47) /       70368744177663 / ,
     5     MASK1(48) /      140737488355327 /
      DATA MASK1(49) /      281474976710655 / ,
     1     MASK1(50) /      562949953421311 / ,
     2     MASK1(51) /     1125899906842623 / ,
     3     MASK1(52) /     2251799813685247 / ,
     4     MASK1(53) /     4503599627370495 / ,
     5     MASK1(54) /     9007199254740991 / ,
     6     MASK1(55) /    18014398509481983 / ,
     7     MASK1(56) /    36028797018963967 / ,
     8     MASK1(57) /    72057594037927935 / ,
     9     MASK1(58) /   144115188075855871 / ,
     +     MASK1(59) /   288230376151711743 / ,
     1     MASK1(60) /   576460752303423487 / ,
     2     MASK1(61) /  1152921504606846975 / ,
     3     MASK1(62) /  2305843009213693951 / ,
     4     MASK1(63) /  4611686018427387903 / ,
     5     MASK1(64) /  9223372036854775807 /
      DATA MASK1(65) / 18446744073709551615 /
C
C 7.  MSK1DM.  MSK1DM is an integer variable containing the
C     dimension of MASK1.  It must be at least WRDLNG+1.  The
C     dimension statement for MASK1 is at the beginning of the main
C     program.  You may leave it unchanged, or if you are cramped
C     for space, lower it to WRDLNG+1.
C
      DATA MSK1DM /65/
C
C
C     ISCRDM.  ISCRDM is an integer variable containing the
C     dimension of ISCR.  You may ignore this step unless you are
C     cramped for space.  ISCR is an array used for scratch.  Its
C     length depends on the word length of your machine.  The test
C     package comes with ISCR dimensioned to 190 .  This is large
C     enough for all word sizes of 1-64 bits, but if you want to
C     lower it, the following formula gives the minimum required.
C     Let LCM stand for the least common multiple.  Then the
C     dimension of ISCR must be at least
C          2*( LCM(WRDLNG,16)/16 + 2*LCM(WRDLNG,16)/WRDLNG ) .
C
      DATA ISCRDM /190/
C
C
C
C     End of information that you are required to supply.
C
C
C
      DATA BYTLNG /16/
      WRITE (IOUT,112)
      WRITE (IOUT,113)
      WRITE (IOUT,114) WRDLNG,INLNGA,INLNGC,MSK0DM,MSK1DM,ISCRDM
      IER=0
      INTLNG=MIN0(INLNGC,INLNGA)
      IF (WRDLNG.LT.BYTLNG .OR. WRDLNG.GT.64) GOTO 107
  101 WRDLNG=MAX0(WRDLNG,BYTLNG)
  102 IF (INLNGA.LT.BYTLNG .OR. INLNGA.GT.WRDLNG) GO TO 108
      IF (INLNGC.LT.BYTLNG .OR. INLNGC.GT.WRDLNG) GO TO 108
  103 IF (MSK1DM.LE.WRDLNG) GOTO 109
  104 IF (MSK0DM.LT.WRDLNG) GOTO 110
  105 NMBRB=2*LCM(WRDLNG,BYTLNG)/BYTLNG
      LPAKD=NMBRB*BYTLNG/WRDLNG
      NEEDED=NMBRB+2*LPAKD
      IF (ISCRDM.LT.NEEDED) GOTO 111
  106 IF (IER.NE.0) STOP
      WRITE (IOUT,115)
      CALL TIOR(MASK1,MSK1DM,WRDLNG,INTLNG,IOUT,IER)
      IERIOR=IER
      CALL TIAND(MASK1,MSK1DM,WRDLNG,INTLNG,IOUT,IER)
      IERAND=IER
      CALL TSHIFT (MASK0,MSK0DM,MASK1(2),MSK1DM-1,IERAND,WRDLNG,INTLNG,
     1                                                         IOUT,IER)
      IERSHF=IER
      CALL TGBYTE (MASK0,MSK0DM,MASK1,MSK1DM,ISCR,ISCRDM,WRDLNG,INTLNG,
     1                                           IERAND,IERSHF,IOUT,IER)
      IERGBY=IER
      CALL TSBYTE (MASK0,MSK0DM,MASK1,MSK1DM,ISCR,ISCRDM,WRDLNG,INTLNG,
     1                                   IERAND,IERIOR,IERSHF,IOUT,IER)
      IERSBY=IER
      WRITE (IOUT,116) IERIOR,IERAND,IERSHF,IERGBY,IERSBY
      STOP
  107 WRITE (IOUT,117) BYTLNG
      IER=1
      GOTO 101
  108 WRITE (IOUT,118) BYTLNG
      IER=1
      GOTO 103
  109 WRITE (IOUT,119)
      IER=1
      GOTO 104
  110 WRITE (IOUT,120)
      IER=1
       GOTO 105
  111 WRITE (IOUT,121) NEEDED
      IER=1
       GOTO 106
  112 FORMAT ('1TEST PACKAGE EXECUTING.  THIS LINE SHOULD BE PRINTED.')
  113 FORMAT ('0WE WILL FIRST TEST THE INFORMATION YOU HAVE PROVIDED',
     1        ' IN CERTAIN DATA'/
     2        ' STATEMENTS AT THE BEGINNING OF THIS PROGRAM.  IF ANY',
     3        ' ERROR IS FOUND,'/
     4        ' EXECUTION WILL TERMINATE--NO ROUTINES WILL BE TESTED.')
  114 FORMAT ('0YOU HAVE PROVIDED THE FOLLOWING CONSTANTS.'/' '/
     1        6X,'NUMBER OF BITS IN A WORD                ',I21/
     2        6X,'NUMBER OF BITS IN AN INTEGER ASSIGNMENT ',I21/
     3        6X,'NUMBER OF BITS IN AN INTEGER COMPARISON ',I21/
     4        6X,'THE DIMENSION OF THE ARRAY MASK0        ',I21/
     5        6X,'THE DIMENSION OF THE ARRAY MASK1        ',I21/
     6        6X,'THE DIMENSION OF THE ARRAY ISCR         ',I21)
  115 FORMAT ('0THE ABOVE DATA APPEARS TO BE CORRECT.  WE WILL NOW',
     1        ' BEGIN TESTING THE'/
     2        ' SUPPORT ROUTINES YOU HAVE PROVIDED FOR USE WITH THE',
     3        ' PLOT PACKAGE.'/
     4        '0A MESSAGE WILL BE PRINTED BEFORE EACH TEST BEGINS,',
     5        ' WHENEVER AN ERROR IS'/
     6        ' FOUND, AND AT THE SUCCESSFUL CONCLUSION OF A TEST. ',
     7        ' A SUMMARY OF THE'/
     8        ' TEST RESULTS WILL BE PRINTED AT THE END.  NOTE THAT',
     9        ' AN ERROR FOUND IN'/
     +        ' ONE ROUTINE MAY SUSPEND TESTING OF ONE OR MORE',
     1        ' SUBSEQUENT ROUTINES.')
  116 FORMAT ('1FOLLOWING IS A SUMMARY OF THE TEST RESULTS SO FAR. ',
     1        ' THE INTEGER WHICH'/
     2        ' FOLLOWS THE ROUTINE NAME IS A COUNT OF ERRORS FOUND',
     3        ' WHILE TESTING THE'/
     4        ' ROUTINE.  (-1 INDICATES THAT THE ROUTINE WAS NOT',
     5        ' TESTED AT ALL.)'/' '/
     6        10X,'IOR       ',I2/
     7        10X,'IAND      ',I2/
     8        10X,'ISHIFT    ',I2/
     9        10X,'GBYTES    ',I2/
     +        10X,'SBYTES    ',I2/
     1        '0IN ANY CASE, ALL PRECEDING OUTPUT SHOULD BE CAREFULLY',
     2        ' EXAMINED.')
  117 FORMAT ('0ERROR.  THE SYSTEM PLOT PACKAGE NEEDS AT LEAST ',I2,
     1     ' BITS IN A WORD.'/
     2     ' THE TEST PACKAGE IS DESIGNED FOR A 64 BITS/WORD MAXIMUM.')
  118 FORMAT ('0ERROR.  THE NUMBER OF LOW ORDER BITS TAKING PART IN ',
     1     'INTEGER COMPARISONS'/
     2     ' AND ASSIGNMENTS MUST BE .LE. WORD SIZE AND .GE. ',I2,'.')
  119 FORMAT ('0ERROR.  THE NUMBER OF ONES MASKS MUST BE .GT. ',
     1     'THE WORD LENGTH.  KEEP'/
     2     ' IN MIND THAT THE KTH ELEMENT HAS K-1 CONTIGUOUS ONES IN ',
     3     'THE LOW ORDER'/
     4     ' BITS.  HENCE MASK1(1) SHOULD BE ZERO, MASK1(WRDLNG+1) ',
     5     'SHOULD BE ALL'/
     6     ' ONES.')
  120 FORMAT('0ERROR.  THE NUMBER OF ONE-WITH-ZEROES MASKS MUST ',
     1     'BE .GE. THE WORD'/
     2     ' LENGTH.  KEEP IN MIND THAT THE KTH ELEMENT HAS BIT K-1 ',
     3     'SET (COUNTING'/
     4     ' BIT 0 AS THE RIGHTMOST) WITH THE REST ZEROS.  HENCE ',
     5     'MASK0(1) SHOULD BE'/
     6     ' 1, AND MASK0(WRDLNG) SHOULD HAVE A ONE IN THE LEFTMOST ',
     7     'BIT, AND THE'/
     8     ' REST ZEROS.')
  121 FORMAT ('0ERROR.  WITH THE GIVEN WORD SIZE, THE SCRATCH ARRAY ',
     1     'MUST BE AT LEAST'/
     2     1X,I16,' ELEMENTS LONG.')
      END

C
C $Id: ezmxy.f,v 1.8 2008-07-27 00:14:36 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE EZMXY (XDRA,YDRA,IDXY,MANY,NPTS,LABG)
C
      REAL XDRA(*),YDRA(*)
C
      CHARACTER*(*) LABG
C
C The routine EZMXY draws many curves, each of them defined by points of
C the form (XDRA(I,J),YDRA(I,J)) or (XDRA(J,I),YDRA(J,I)) or, possibly,
C (XDRA(I),YDRA(I,J)) or (XDRA(I),YDRA(J,I)), for I = 1, 2, ... NPTS and
C for J = 1, 2, ... MANY.  (YDRA is actually dimensioned IDXY by * .)
C
      CALL AGGETI ('SET .',ISET)
      CALL AGGETI ('FRAM.',IFRA)
      CALL AGGETI ('DASH/SELE.',IDSH)
C
      CALL AGEZSU (4,XDRA,YDRA,IDXY,MANY,NPTS,LABG,IIVX,IIEX,IIVY,IIEY)
      CALL AGBACK
C
      IF (ISET.LT.0) GO TO 102
C
           DO 101 I=1,MANY
           INXD=1+(I-1)*IIVX
           INYD=1+(I-1)*IIVY
           KDSH=SIGN(I,IDSH)
           CALL AGCURV (XDRA(INXD),IIEX,YDRA(INYD),IIEY,NPTS,KDSH)
  101      CONTINUE
C
  102 IF (IFRA.EQ.1) CALL FRAME
C
      RETURN
C
      END

C
C $Id: curvp2.f,v 1.5 2008-07-27 03:10:10 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
C NOTE: If you make any changes to this software, please remember to
C make the same changes to the corresponding double precision routine.
C
      function curvp2 (t,n,x,y,p,yp,sigma)
c
      integer n
      real t,x(n),y(n),p,yp(n),sigma
c
c                                 coded by alan kaylor cline
c                           from fitpack -- january 26, 1987
c                        a curve and surface fitting package
c                      a product of pleasant valley software
c                  8603 altus cove, austin, texas 78759, usa
c
c this function interpolates a curve at a given point using
c a periodic spline under tension. the subroutine curvp1
c should be called earlier to determine certain necessary
c parameters.
c
c on input--
c
c   t contains a real value to be mapped onto the interpo-
c   lating curve.
c
c   n contains the number of points which were specified to
c   determine the curve.
c
c   x and y are arrays containing the abscissae and
c   ordinates, respectively, of the specified points.
c
c   p contains the period.
c
c   yp is an array of second derivative values of the curve
c   at the nodes.
c
c and
c
c   sigma contains the tension factor (its sign is ignored).
c
c the parameters n, x, y, p, yp, and sigma should be input
c unaltered from the output of curvp1.
c
c on output--
c
c   curvp2 contains the interpolated value.
c
c none of the input parameters are altered.
c
c this function references package modules intrvp and
c snhcsh.
c
c-----------------------------------------------------------
c
c determine interval
c
      im1 = intrvp (t,x,n,p,tp)
      i = im1+1
c
c denormalize tension factor
c
      sigmap = abs(sigma)*float(n)/p
c
c set up and perform interpolation
c
      del1 = tp-x(im1)
      if (im1 .eq. n) go to 1
      del2 = x(i)-tp
      dels = x(i)-x(im1)
      go to 2
    1 i = 1
      del2 = x(1)+p-tp
      dels = p-(x(n)-x(1))
    2 sum = (y(i)*del1+y(im1)*del2)/dels
      if (sigmap .ne. 0.) go to 3
      curvp2 = sum-del1*del2*(yp(i)*(del1+dels)+yp(im1)*
     *        (del2+dels))/(6.*dels)
      return
    3 sigdel = sigmap*dels
      call snhcsh (ss,dummy,sigdel,-1)
      call snhcsh (s1,dummy,sigmap*del1,-1)
      call snhcsh (s2,dummy,sigmap*del2,-1)
      curvp2 = sum+(yp(i)*del1*(s1-ss)+yp(im1)*del2*(s2-ss))/
     *            (sigdel*sigmap*(1.+ss))
      return
      end

      SUBROUTINE SPPTRS( UPLO, N, NRHS, AP, B, LDB, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     March 31, 1993 
*
*     .. Scalar Arguments ..
      CHARACTER          UPLO
      INTEGER            INFO, LDB, N, NRHS
*     ..
*     .. Array Arguments ..
      REAL               AP( * ), B( LDB, * )
*     ..
*
*  Purpose
*  =======
*
*  SPPTRS solves a system of linear equations A*X = B with a symmetric
*  positive definite matrix A in packed storage using the Cholesky
*  factorization A = U**T*U or A = L*L**T computed by SPPTRF.
*
*  Arguments
*  =========
*
*  UPLO    (input) CHARACTER*1
*          = 'U':  Upper triangle of A is stored;
*          = 'L':  Lower triangle of A is stored.
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  NRHS    (input) INTEGER
*          The number of right hand sides, i.e., the number of columns
*          of the matrix B.  NRHS >= 0.
*
*  AP      (input) REAL array, dimension (N*(N+1)/2)
*          The triangular factor U or L from the Cholesky factorization
*          A = U**T*U or A = L*L**T, packed columnwise in a linear
*          array.  The j-th column of U or L is stored in the array AP
*          as follows:
*          if UPLO = 'U', AP(i + (j-1)*j/2) = U(i,j) for 1<=i<=j;
*          if UPLO = 'L', AP(i + (j-1)*(2n-j)/2) = L(i,j) for j<=i<=n.
*
*  B       (input/output) REAL array, dimension (LDB,NRHS)
*          On entry, the right hand side matrix B.
*          On exit, the solution matrix X.
*
*  LDB     (input) INTEGER
*          The leading dimension of the array B.  LDB >= max(1,N).
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*
*  =====================================================================
*
*     .. Local Scalars ..
      LOGICAL            UPPER
      INTEGER            I
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           STPSV, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      UPPER = LSAME( UPLO, 'U' )
      IF( .NOT.UPPER .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( NRHS.LT.0 ) THEN
         INFO = -3
      ELSE IF( LDB.LT.MAX( 1, N ) ) THEN
         INFO = -6
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'SPPTRS', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 .OR. NRHS.EQ.0 )
     $   RETURN
*
      IF( UPPER ) THEN
*
*        Solve A*X = B where A = U'*U.
*
         DO 10 I = 1, NRHS
*
*           Solve U'*X = B, overwriting B with X.
*
            CALL STPSV( 'Upper', 'Transpose', 'Non-unit', N, AP,
     $                  B( 1, I ), 1 )
*
*           Solve U*X = B, overwriting B with X.
*
            CALL STPSV( 'Upper', 'No transpose', 'Non-unit', N, AP,
     $                  B( 1, I ), 1 )
   10    CONTINUE
      ELSE
*
*        Solve A*X = B where A = L*L'.
*
         DO 20 I = 1, NRHS
*
*           Solve L*Y = B, overwriting B with X.
*
            CALL STPSV( 'Lower', 'No transpose', 'Non-unit', N, AP,
     $                  B( 1, I ), 1 )
*
*           Solve L'*X = Y, overwriting B with X.
*
            CALL STPSV( 'Lower', 'Transpose', 'Non-unit', N, AP,
     $                  B( 1, I ), 1 )
   20    CONTINUE
      END IF
*
      RETURN
*
*     End of SPPTRS
*
      END

      SUBROUTINE ZLAQSY( UPLO, N, A, LDA, S, SCOND, AMAX, EQUED )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     February 29, 1992
*
*     .. Scalar Arguments ..
      CHARACTER          EQUED, UPLO
      INTEGER            LDA, N
      DOUBLE PRECISION   AMAX, SCOND
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   S( * )
      COMPLEX*16         A( LDA, * )
*     ..
*
*  Purpose
*  =======
*
*  ZLAQSY equilibrates a symmetric matrix A using the scaling factors
*  in the vector S.
*
*  Arguments
*  =========
*
*  UPLO    (input) CHARACTER*1
*          Specifies whether the upper or lower triangular part of the
*          symmetric matrix A is stored.
*          = 'U':  Upper triangular
*          = 'L':  Lower triangular
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  A       (input/output) COMPLEX*16 array, dimension (LDA,N)
*          On entry, the symmetric matrix A.  If UPLO = 'U', the leading
*          n by n upper triangular part of A contains the upper
*          triangular part of the matrix A, and the strictly lower
*          triangular part of A is not referenced.  If UPLO = 'L', the
*          leading n by n lower triangular part of A contains the lower
*          triangular part of the matrix A, and the strictly upper
*          triangular part of A is not referenced.
*
*          On exit, if EQUED = 'Y', the equilibrated matrix:
*          diag(S) * A * diag(S).
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(N,1).
*
*  S       (input) DOUBLE PRECISION array, dimension (N)
*          The scale factors for A.
*
*  SCOND   (input) DOUBLE PRECISION
*          Ratio of the smallest S(i) to the largest S(i).
*
*  AMAX    (input) DOUBLE PRECISION
*          Absolute value of largest matrix entry.
*
*  EQUED   (output) CHARACTER*1
*          Specifies whether or not equilibration was done.
*          = 'N':  No equilibration.
*          = 'Y':  Equilibration was done, i.e., A has been replaced by
*                  diag(S) * A * diag(S).
*
*  Internal Parameters
*  ===================
*
*  THRESH is a threshold value used to decide if scaling should be done
*  based on the ratio of the scaling factors.  If SCOND < THRESH,
*  scaling is done.
*
*  LARGE and SMALL are threshold values used to decide if scaling should
*  be done based on the absolute size of the largest matrix element.
*  If AMAX > LARGE or AMAX < SMALL, scaling is done.
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ONE, THRESH
      PARAMETER          ( ONE = 1.0D+0, THRESH = 0.1D+0 )
*     ..
*     .. Local Scalars ..
      INTEGER            I, J
      DOUBLE PRECISION   CJ, LARGE, SMALL
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      DOUBLE PRECISION   DLAMCH
      EXTERNAL           LSAME, DLAMCH
*     ..
*     .. Executable Statements ..
*
*     Quick return if possible
*
      IF( N.LE.0 ) THEN
         EQUED = 'N'
         RETURN
      END IF
*
*     Initialize LARGE and SMALL.
*
      SMALL = DLAMCH( 'Safe minimum' ) / DLAMCH( 'Precision' )
      LARGE = ONE / SMALL
*
      IF( SCOND.GE.THRESH .AND. AMAX.GE.SMALL .AND. AMAX.LE.LARGE ) THEN
*
*        No equilibration
*
         EQUED = 'N'
      ELSE
*
*        Replace A by diag(S) * A * diag(S).
*
         IF( LSAME( UPLO, 'U' ) ) THEN
*
*           Upper triangle of A is stored.
*
            DO 20 J = 1, N
               CJ = S( J )
               DO 10 I = 1, J
                  A( I, J ) = CJ*S( I )*A( I, J )
   10          CONTINUE
   20       CONTINUE
         ELSE
*
*           Lower triangle of A is stored.
*
            DO 40 J = 1, N
               CJ = S( J )
               DO 30 I = J, N
                  A( I, J ) = CJ*S( I )*A( I, J )
   30          CONTINUE
   40       CONTINUE
         END IF
         EQUED = 'Y'
      END IF
*
      RETURN
*
*     End of ZLAQSY
*
      END

C
C $Id: mputfd.f,v 1.6 2008-07-27 00:17:09 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MPUTFD (RLAT,RLON,UVAL,VVAL)
        DOUBLE PRECISION RLAT,RLON,UVAL,VVAL
        CALL MDUTFD (RLAT,RLON,UVAL,VVAL)
        RETURN
      END

C NCLFORTSTART
      SUBROUTINE dgeevxint(BALANC,JOBVL,JOBVR,SENSE,N,A,EVLR,WR,WI,
     +                     OPT,WORK,IWORK,SCALEM,RCONDE,RCONDV,VL,VR,
     +                     LWORK,LIWORK)
      IMPLICIT NONE
c                                                      input
      INTEGER           N, OPT
      CHARACTER*(*)     BALANC, JOBVL, JOBVR, SENSE
ccccc CHARACTER*1       BALANC, JOBVL, JOBVR, SENSE
c                                                      input and output
      DOUBLE PRECISION  A(N,N)
c                                                      output
c                                                      (:,:,real/imag,
c                                                           left/right)     
      DOUBLE PRECISION  WR(N), WI(N), EVLR(N,N,2,2)
c
c     These are work arrays originally created by Fortran routine.
c     LWORK should be N*(N+6)
c     LIWORK should be 2*N-1
c
      INTEGER          LWORK,LIWORK
      DOUBLE PRECISION SCALEM(N), RCONDE(N), RCONDV(N)
      DOUBLE PRECISION VL(N,N), VR(N,N)
      DOUBLE PRECISION WORK(LWORK)
      INTEGER          IWORK(LIWORK)
C NCLEND
C --------------------------------------------------------------------------------
C                                                      local dynamically allocated
      INTEGER LDA, ILO, IHI, INFO, I, J
     +      , LDVR, LDVL, K , KP1
C    +      , LDVR, LDVL, LWORK, LIWORK, K , KP1
      DOUBLE PRECISION ABNRM

C just for consistency with LAPACK description   (make large)
      LDA     = N
      LDVR    = N
      LDVL    = N
      INFO    = 0   
C These are passed in above.
C     LWORK   = N*(N+6)
C     LIWORK  = 2*N-1

      CALL DGEEVX( BALANC, JOBVL, JOBVR, SENSE, N, A, LDA, WR, WI,  
     &             VL, LDVL, VR, LDVR, ILO, IHI, SCALEM, ABNRM,
     &             RCONDE, RCONDV, WORK, LWORK, IWORK, INFO )

c
c This is the array returned to NCL | the WR & WI as attributes.
c
      k = 0
      do j=1,N 
         k = k+1
         if (wi(j).eq.0.0d0) then     !   not a complex conjugate
             do i=1,N
                EVLR(i,k,1,1) = VL(i,j) 
                EVLR(i,k,2,1) = 0.0d0   
                EVLR(i,k,1,2) = VR(i,j)
                EVLR(i,k,2,2) = 0.0d0  
             end do
         else if (WR(J).eq.WR(J+1) .and. WI(J).eq.-(WI(J+1))) then  ! conjugate
              kp1 = k+1
              do i=1,N
                 EVLR(i,k  ,1,1) =   VL(i,j)
                 EVLR(i,k  ,2,1) =   VL(i,j+1) 
                 EVLR(i,k  ,1,2) =   VR(i,j)
                 EVLR(i,k  ,2,2) =   VR(i,j+1)

                 EVLR(i,kp1,1,1) =   VL(i,j)
                 EVLR(i,kp1,2,1) = -(VL(i,j+1))
                 EVLR(i,kp1,1,2) =   VR(i,j)
                 EVLR(i,kp1,2,2) = -(VR(i,j+1))
              end do
              k = kp1-1
         end if
      end do

      return
      end

C
C	$Id: drawpv.f,v 1.6 2008-07-27 00:23:04 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE DRAWPV (IX,IY,IND)
C
C DRAWPV INTERCEPTS THE CALL TO PLOTIT.
C FOR IND=1 (PEN DOWN) IT CHECKS IF A LINE (PART OF IT) HAS TO BE DRAWN
C OR REMOVED.
C FOR IND=0 (PEN UP) IT CHECKS IF THE PEN HAS TO BE MOVED OR IF IT IS
C ALREADY CLOSE ENOUGH TO THE WANTED POSITION.
C FOR IND=2 DO NOT MOVE PEN.JUST SET POSITION OF PEN TO (IMPOS,IMPOS).
C
      COMMON/INTPR/IPAU,FPART,TENSN,NP,SMALL,L1,ADDLR,ADDTB,MLLINE,
     1    ICLOSE
C IOFFS IS AN INTERNAL PARAMETER. IT IS REFERENCED IN  DRAWPV AND
C FDVDLD AND INITIALIZED IN DASHBDX.
C
      COMMON /SMFLAG/ IOFFS
C
C IN DSAVE3 THE STARTING POINT OF THE NEXT LINE SEGMENT TO BE DRAWN
C OR REMOVED IS SAVED.
C
      COMMON /DSAVE3/ IXSTOR,IYSTOR
C
C IX1,IY1,IX2 AND IY2 ARE USED TO STORE THE NEXT LINE SEGMENT TO BE
C MARKED, WHICH IS THE SEGMENT THAT WAS DRAWN LAST.
C
      COMMON /DSAVE4/ IX1,IY1,IX2,IY2
C
C ISKIP IS USED TO ADJUST DASHSUPR TO THE SIZE OF THE MODEL PICTURE AS
C DEFINED IN SUBROUTINE REMOVE. ISKIP IS INITIALIZED IN DASHBDX.
C
      COMMON /DSUP1/ ISKIP
C
      LOGICAL LI, LM, HID
      LOGICAL LDUMMY
      SAVE
C
      DATA LDUMMY /.TRUE./
C
C BRANCH DEPENDING ON FUNCTION TO BE PERFORMED.
C
      IIND = IND + 1
      GOTO (2,1,3), IIND
C
    1 CONTINUE
C
C *************************************
C
C INTERCEPT PLOTIT(IX,IY,1) TO CHECK IF THE LINE TO BE DRAWN (PART OF
C IT) HAS TO BE REMOVED. DRAW AND MARK LINE IF FEASIBLE.
C
C
      IF (IOFFS .EQ. 0) GO TO 10
C
C DO NOT MARK LINES IF NOT REQUIRED.
C
      IXSTOR = IX
      IYSTOR = IY
      CALL PLOTIT (IX,IY,1)
      RETURN
C
C LINE HAS TO BE DRAWN AND MARKED.
C
   10 CONTINUE
      MX = IXSTOR
      MY = IYSTOR
      IXSTOR = IX
      IYSTOR = IY
      DX = IXSTOR - MX
      DY = IYSTOR - MY
C
C CHECK BEGINNING AND END POINT OF LINE, IF THEY ARE ALREADY MARKED.
C
      CALL REMOVE (IXSTOR,IYSTOR,LI,3)
      CALL REMOVE (MX,MY,LM,3)
C
C NOTHING TO DO , IF BEGINNING AND END POINT ARE ALREADY MARKED.
C
      IF (LI .AND. LM) RETURN
C
C DRAW A POINT IF LINE IS OF LENGTH 0.
C
      IF (DX .NE. 0. .OR. DY .NE. 0.) GO TO 15
      CALL PLOTIT (IXSTOR,IYSTOR,1)
      RETURN
   15 CONTINUE
C
      IF (LI .OR. LM) GO TO 20
C
C IF NEITHER STARTING NOR END POINT IS MARKED, DRAW LINE AND MARK IT.
C
      CALL PLOTIT (IXSTOR,IYSTOR,1)
      GO TO 80
C
C EITHER BEGINNING OR END POINT OF LINE WERE ALREADY MARKED.
C
   20 D = MAX(ABS(DX),ABS(DY))
      ID = D/REAL(ISKIP)
      DX = (DX/D)*REAL(ISKIP)
      DY = (DY/D)*REAL(ISKIP)
      IF (LM) GO TO 50
C
C STARTING POINT WAS NOT MARKED. FIND THE FIRST MARKED POINT.
C
      X = MX
      Y = MY
      DO 30 I=1,ID
         X = X+DX
         Y = Y+DY
         CALL REMOVE (INT(X+.5),INT(Y+.5),HID,3)
         IF (HID) GO TO 40
   30 CONTINUE
      X = REAL(IXSTOR)+DX
      Y = REAL(IYSTOR)+DY
   40 IXP = X+.5-DX
      IYP = Y+.5-DY
C FIRST MARKED POINT FOUND.
C DRAW LINE, SET PEN, MARK LINE.
      CALL PLOTIT (IXP,IYP,1)
      CALL PLOTIT (IXSTOR,IYSTOR,0)
      GO TO 80
C
C     FIRST PART IS HIDDEN
C       FIND THE FIRST VISIBLE POINT
C
   50 X = MX
      Y = MY
      DO 60 I=1,ID
         X = X+DX
         Y = Y+DY
         CALL REMOVE (INT(X+.5),INT(Y+.5),HID,3)
         IF (.NOT.HID) GO TO 70
   60 CONTINUE
      X = IXSTOR
      Y = IYSTOR
   70 IXP = X+.5
      IYP = Y+.5
C FIRST VISIBLE POINT FOUND.
C SET PEN, DRAW LINE, MARK LINE.
      CALL PLOTIT (IXP,IYP,0)
      CALL PLOTIT (IXSTOR,IYSTOR,1)
C
C
   80 CONTINUE
      CALL MARKL (IX1,IY1,IX2,IY2)
      IX1 = MX
      IY1 = MY
      IX2 = IXSTOR
      IY2 = IYSTOR
      RETURN
C
    2 CONTINUE
C
C *************************************
C
C INTERCEPT PLOTIT(IX,IY,0) TO SET THE STARTING POINT FOR THE NEXT
C LINE TO BE DRAWN OR REMOVED.
C
C CHECK IF PEN IS ALREADY CLOSE ENOUGH TO THE WANTED POSITION.
      DIFF = REAL(ABS(IXSTOR-IX)+ABS(IYSTOR-IY))
      IF (DIFF .LE. REAL(ICLOSE)) GO TO 110
C
      IXSTOR = IX
      IYSTOR = IY
      CALL PLOTIT (IXSTOR,IYSTOR,0)
      RETURN
C
    3 CONTINUE
C
C ****************************
C
C DO NOT MOVE PEN. JUST SET POSITION OF PEN TO (IMPOS,IMPOS).
C
      IXSTOR = IX
      IYSTOR = IY
C
  110 CONTINUE
C
      RETURN
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C   FFTPACK 5.0
C   Copyright (C) 1995-2004, Scientific Computing Division,
C   University Corporation for Atmospheric Research
C   Licensed under the GNU General Public License (GPL)
C
C   Authors:  Paul N. Swarztrauber and Richard A. Valent
C
C   $Id: mrftb1.f,v 1.2 2006-11-21 01:10:18 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      SUBROUTINE DMRFTB1(M,IM,N,IN,C,CH,WA,FAC)
      DOUBLE PRECISION HALF
      DOUBLE PRECISION HALFM
      DOUBLE PRECISION CH(M,*),C(IN,*),WA(N),FAC(15)
C
      NF = FAC(2)
      NA = 0
      DO 10 K1 = 1,NF
          IP = FAC(K1+2)
          NA = 1 - NA
          IF (IP.LE.5) GO TO 10
          IF (K1.EQ.NF) GO TO 10
          NA = 1 - NA
   10 CONTINUE
      HALF = .5D0
      HALFM = -.5D0
      MODN = MOD(N,2)
      NL = N - 2
      IF (MODN.NE.0) NL = N - 1
      IF (NA.EQ.0) GO TO 120
      M2 = 1 - IM
      DO 117 I = 1,M
          M2 = M2 + IM
          CH(I,1) = C(M2,1)
          CH(I,N) = C(M2,N)
  117 CONTINUE
      DO 118 J = 2,NL,2
          M2 = 1 - IM
          DO 118 I = 1,M
              M2 = M2 + IM
              CH(I,J) = HALF*C(M2,J)
              CH(I,J+1) = HALFM*C(M2,J+1)
  118 CONTINUE
      GO TO 124
  120 CONTINUE
      DO 122 J = 2,NL,2
          M2 = 1 - IM
          DO 122 I = 1,M
              M2 = M2 + IM
              C(M2,J) = HALF*C(M2,J)
              C(M2,J+1) = HALFM*C(M2,J+1)
  122 CONTINUE
  124 L1 = 1
      IW = 1
      DO 116 K1 = 1,NF
          IP = FAC(K1+2)
          L2 = IP*L1
          IDO = N/L2
          IDL1 = IDO*L1
          IF (IP.NE.4) GO TO 103
          IX2 = IW + IDO
          IX3 = IX2 + IDO
          IF (NA.NE.0) GO TO 101
          CALL DMRADB4(M,IDO,L1,C,IM,IN,CH,1,M,WA(IW),WA(IX2),WA(IX3))
          GO TO 102
  101     CALL DMRADB4(M,IDO,L1,CH,1,M,C,IM,IN,WA(IW),WA(IX2),WA(IX3))
  102     NA = 1 - NA
          GO TO 115
  103     IF (IP.NE.2) GO TO 106
          IF (NA.NE.0) GO TO 104
          CALL DMRADB2(M,IDO,L1,C,IM,IN,CH,1,M,WA(IW))
          GO TO 105
  104     CALL DMRADB2(M,IDO,L1,CH,1,M,C,IM,IN,WA(IW))
  105     NA = 1 - NA
          GO TO 115
  106     IF (IP.NE.3) GO TO 109
          IX2 = IW + IDO
          IF (NA.NE.0) GO TO 107
          CALL DMRADB3(M,IDO,L1,C,IM,IN,CH,1,M,WA(IW),WA(IX2))
          GO TO 108
  107     CALL DMRADB3(M,IDO,L1,CH,1,M,C,IM,IN,WA(IW),WA(IX2))
  108     NA = 1 - NA
          GO TO 115
  109     IF (IP.NE.5) GO TO 112
          IX2 = IW + IDO
          IX3 = IX2 + IDO
          IX4 = IX3 + IDO
          IF (NA.NE.0) GO TO 110
          CALL DMRADB5(M,IDO,L1,C,IM,IN,CH,1,M,WA(IW),WA(IX2),WA(IX3),
     +                WA(IX4))
          GO TO 111
  110     CALL DMRADB5(M,IDO,L1,CH,1,M,C,IM,IN,WA(IW),WA(IX2),WA(IX3),
     +                WA(IX4))
  111     NA = 1 - NA
          GO TO 115
  112     IF (NA.NE.0) GO TO 113
          CALL DMRADBG(M,IDO,IP,L1,IDL1,C,C,C,IM,IN,CH,CH,1,M,WA(IW))
          GO TO 114
  113     CALL DMRADBG(M,IDO,IP,L1,IDL1,CH,CH,CH,1,M,C,C,IM,IN,WA(IW))
  114     IF (IDO.EQ.1) NA = 1 - NA
  115     L1 = L2
          IW = IW + (IP-1)*IDO
  116 CONTINUE
      RETURN
      END

C
C $Id: curvp2dp.f,v 1.3 2008-07-27 03:10:10 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
C NOTE: If you make any changes to this software, please remember to
C make the same changes to the corresponding single precision routine.
C
      FUNCTION CURVP2DP(T,N,X,Y,P,YP,SIGMA)
      DOUBLE PRECISION CURVP2DP
      DOUBLE PRECISION TP
      DOUBLE PRECISION SIGMAP
      DOUBLE PRECISION DEL1
      DOUBLE PRECISION DEL2
      DOUBLE PRECISION DELS
      DOUBLE PRECISION SUM
      DOUBLE PRECISION SIGDEL
      DOUBLE PRECISION SS
      DOUBLE PRECISION DUMMY
      DOUBLE PRECISION S1
      DOUBLE PRECISION S2
c
      INTEGER N
      DOUBLE PRECISION T,X(N),Y(N),P,YP(N),SIGMA
c
c                                 coded by alan kaylor cline
c                           from fitpack -- january 26, 1987
c                        a curve and surface fitting package
c                      a product of pleasant valley software
c                  8603 altus cove, austin, texas 78759, usa
c
c this function interpolates a curve at a given point using
c a periodic spline under tension. the subroutine curvp1
c should be called earlier to determine certain necessary
c parameters.
c
c on input--
c
c   t contains a real value to be mapped onto the interpo-
c   lating curve.
c
c   n contains the number of points which were specified to
c   determine the curve.
c
c   x and y are arrays containing the abscissae and
c   ordinates, respectively, of the specified points.
c
c   p contains the period.
c
c   yp is an array of second derivative values of the curve
c   at the nodes.
c
c and
c
c   sigma contains the tension factor (its sign is ignored).
c
c the parameters n, x, y, p, yp, and sigma should be input
c unaltered from the output of curvp1.
c
c on output--
c
c   curvp2dp contains the interpolated value.
c
c none of the input parameters are altered.
c
c this function references package modules intrvpdp and
c snhcshdp.
c
c-----------------------------------------------------------
c
c determine interval
c
      IM1 = INTRVPDP(T,X,N,P,TP)
      I = IM1 + 1
c
c denormalize tension factor
c
      SIGMAP = ABS(SIGMA)*DBLE(N)/P
c
c set up and perform interpolation
c
      DEL1 = TP - X(IM1)
      IF (IM1.EQ.N) GO TO 1
      DEL2 = X(I) - TP
      DELS = X(I) - X(IM1)
      GO TO 2
    1 I = 1
      DEL2 = X(1) + P - TP
      DELS = P - (X(N)-X(1))
    2 SUM = (Y(I)*DEL1+Y(IM1)*DEL2)/DELS
      IF (SIGMAP.NE.0.D0) GO TO 3
      CURVP2DP = SUM - DEL1*DEL2* (YP(I)* (DEL1+DELS)+
     +         YP(IM1)* (DEL2+DELS))/ (6.D0*DELS)
      RETURN
    3 SIGDEL = SIGMAP*DELS
      CALL SNHCSHDP(SS,DUMMY,SIGDEL,-1)
      CALL SNHCSHDP(S1,DUMMY,SIGMAP*DEL1,-1)
      CALL SNHCSHDP(S2,DUMMY,SIGMAP*DEL2,-1)
      CURVP2DP = SUM + (YP(I)*DEL1* (S1-SS)+YP(IM1)*DEL2* (S2-SS))/
     +         (SIGDEL*SIGMAP* (1.D0+SS))
      RETURN
      END

C
C $Id: agsetf.f,v 1.6 2008-07-27 00:14:35 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE AGSETF (TPID,FUSR)
C
      CHARACTER*(*) TPID
      DIMENSION FURA(1)
C
C The routine AGSETF may be used to set the real (floating-point) value
C of any single AUTOGRAPH control parameter.
C
      FURA(1)=FUSR
      CALL AGSETP (TPID,FURA,1)
      RETURN
C
      END

C
C $Id: mdloch.f,v 1.10 2008-09-18 00:42:17 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MDLOCH (RLON,CHRS,NCHR)
C
C This routine, given a longitude RLON and a character buffer CHRS,
C returns CHRS and NCHR such that CHRS(1:NCHR), when written by PLCHHQ,
C will yield the nautical representation of RLON, in degrees, minutes,
C and seconds east or west of the prime meridian at Greenwich.
C
        DOUBLE PRECISION RLON
        CHARACTER*(*)    CHRS
        INTEGER          NCHR
C
C Declare local variables.
C
        DOUBLE PRECISION ALON
        INTEGER          IDEG,IMIN,ISEC,NSEC
C
C Compute the equivalent value of the longitude in the range -180 to
C +180 degrees.
C
        ALON=MOD(MOD(RLON,360.D0)+360.D0,360.D0)
        IF (ALON.GE.180.D0) ALON=ALON-360.D0
C
C Compute the absolute value of the longitude in seconds, limiting it to
C the range from 0 to 180 degrees (0 to 648,000 seconds), and rounding
C to the nearest second.
C
        NSEC=MIN(648000,INT(3600.D0*ABS(ALON)+.5D0))
C
C Compute the degree, minute, and second quantities, as integers.
C
        IDEG=NSEC/3600
        IMIN=MOD(NSEC,3600)/60
        ISEC=MOD(NSEC,60)
C
C If the value is zero, return a string that will make PLCHHQ write a
C 0 followed by a degree sign.
C
        IF (IDEG.EQ.0.AND.IMIN.EQ.0.AND.ISEC.EQ.0) THEN
          NCHR=7
          CHRS='0:F34:0'
          RETURN
        END IF
C
C Otherwise, put blanks in the buffer and zero the current character
C count.
C
        CHRS=' '
        NCHR=0
C
C Put the number of degrees in the buffer, followed by the code for a
C degree sign.
C
        CALL MDINCH (IDEG,CHRS,NCHR)
        NCHR=NCHR+9
        CHRS(NCHR-8:NCHR)=':F34:0:F:'
C
C If the number of minutes and seconds are both zero, we're done except
C for, perhaps, a "W" or an "E".
C
        IF (IMIN.EQ.0.AND.ISEC.EQ.0) THEN
          IF (IDEG.EQ.180) RETURN
          GO TO 101
        END IF
C
C Put the number of minutes in the buffer, followed by the code for a
C single quote.
C
        CALL MDINCH (IMIN,CHRS,NCHR)
        NCHR=NCHR+15
        CHRS(NCHR-14:NCHR)=':F29H-5:'':H-4F:'
C
C If the number of seconds is zero, we're done except for, perhaps, a
C "W" or an "E".
C
        IF (ISEC.EQ.0) GO TO 101
C
C Put the number of seconds in the buffer, followed by the code for a
C double quote.
C
        CALL MDINCH (ISEC,CHRS,NCHR)
        NCHR=NCHR+15
        CHRS(NCHR-14:NCHR)=':F29H-5:":FH-4:'
C
C Finally, put either a "W" or an "E" in the buffer.
C
  101   NCHR=NCHR+1
C
        IF (ALON.LT.0.) THEN
          CHRS(NCHR:NCHR)='W'
        ELSE
          CHRS(NCHR:NCHR)='E'
        END IF
C
C Done.
C
        RETURN
C
      END

C
C	$Id: g01msg.f,v 1.4 2008-07-27 00:21:05 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE G01MSG(IACT)
C
C  Put out MESSAGE elements.
C
      include 'g01prm.h'
      include 'gksin.h'
      include 'g01ins.h'
C
C
C  IACT = 0  for no action, or
C       = 1  for action
C       
      INTEGER IACT,G01PBL
C
C  Find the first non-blank, non-null and set the length.
C
      ILEN = 1
      DO 10 I=80,1,-1
        IF (STR(I:I).NE.' ' .AND. STR(I:I).NE.CHAR(0)) THEN
          ILEN = I
          GO TO 20
        ENDIF
   10 CONTINUE
   20 CONTINUE
C
C  Put out opcode (class and id) and length.
C
      NBYTES = G01PBL (ILEN, 1+(MEFW-1)/8 )
      CALL GPUTNI (7, 1, NBYTES, IERR)
C
C  Put out action/no-action flag.
C
      CALL GPUTPR (IACT, MEFW, 1, RERR)
C
C  Put out the message string.
C
      CALL GPUTPS (STR(1:ILEN), ILEN, ILEN, 0, IERR)
C
      RETURN
      END

      DOUBLE COMPLEX   FUNCTION ZLADIV( X, Y )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     October 31, 1992
*
*     .. Scalar Arguments ..
      COMPLEX*16         X, Y
*     ..
*
*  Purpose
*  =======
*
*  ZLADIV := X / Y, where X and Y are complex.  The computation of X / Y
*  will not overflow on an intermediary step unless the results
*  overflows.
*
*  Arguments
*  =========
*
*  X       (input) COMPLEX*16
*  Y       (input) COMPLEX*16
*          The complex scalars X and Y.
*
*  =====================================================================
*
*     .. Local Scalars ..
      DOUBLE PRECISION   ZI, ZR
*     ..
*     .. External Subroutines ..
      EXTERNAL           DLADIV
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          DBLE, DCMPLX, DIMAG
*     ..
*     .. Executable Statements ..
*
      CALL DLADIV( DBLE( X ), DIMAG( X ), DBLE( Y ), DIMAG( Y ), ZR,
     $             ZI )
      ZLADIV = DCMPLX( ZR, ZI )
*
      RETURN
*
*     End of ZLADIV
*
      END

C
C       $Id: stdudv.f,v 1.10 2008-07-27 00:17:28 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE STDUDV (UX,VY,I,J,X,Y,DU,DV)
C
C Input parameters:
C
C UX,VY  - the arrays containing normalized vector field data
C I,J    - the current grid indices
C X,Y    - the X,Y position relative to the grid
C
C Output parameters:
C
C DU,DV  - Interpolated value of the vector field components
C          at the specified point 
C
C Interpolation routine to calculate the displacemant components.
C The philosphy here is to utilize as many points as possible
C (within reason) in order to obtain a pleasing and accurate plot.
C Interpolation schemes desired by other users may easily be
C substituted if desired.
C
      DIMENSION UX(IXDM,*), VY(IXDM,*)
C
C ---------------------------------------------------------------------
C
C NOTE:
C Since implicit typing is used for all real and integer variables
C a consistent length convention has been adopted to help clarify the
C significance of the variables encountered in the code for this 
C utility. All local variable and subroutine parameter identifiers 
C are limited to 1,2,or 3 characters. Four character names identify  
C members of common blocks. Five and 6 character variable names 
C denote PARAMETER constants or subroutine or function names.
C
C Declare the ST common blocks.
C
      PARAMETER (IPLVLS = 256)
C
C Integer and real common block variables
C
C
      COMMON / STPAR /
     +                IUD1       ,IVD1       ,IPD1       ,
     +                IXD1       ,IXDM       ,IYD1       ,IYDN       ,
     +                IXM1       ,IYM1       ,IXM2       ,IYM2       ,
     +                IWKD       ,IWKU       ,ISET       ,IERR       ,
     +                IXIN       ,IYIN       ,IMSK       ,ICPM       ,
     +                NLVL       ,IPAI       ,ICTV       ,WDLV       ,
     +                UVMN       ,UVMX       ,PMIN       ,PMAX       ,
     +                IPLR       ,ISST       ,
     +                ICLR(IPLVLS)           ,TVLU(IPLVLS)
C
      COMMON / STTRAN /
     +                UVPS       ,
     +                UVPL       ,UVPR       ,UVPB       ,UVPT       ,
     +                UWDL       ,UWDR       ,UWDB       ,UWDT       ,
     +                UXC1       ,UXCM       ,UYC1       ,UYCN 
C
C Stream algorithm parameters
C
      COMMON / STSTRM /
     +                ISGD       ,IAGD       ,RARL       ,ICKP       ,
     +                ICKX       ,ITRP       ,ICYK       ,RVNL       ,
     +                ISVF       ,RUSV       ,RVSV       ,RNDA       ,
     +                ISPC       ,RPSV       ,RCDS       ,RSSP       ,
     +                RDFM       ,RSMD       ,RAMD       ,IGBS       ,
     +                ISTM       ,RVRL       ,RVFR       ,RVRM       ,
     +                IVPO       ,RAFR       ,RDMX       ,RDMN
C
C Text related parameters
C Note: graphical text output is not yet implemented for the
C       Streamline utility.
C
      COMMON / STTXP /
     +                FCWM    ,ICSZ    ,
     +                FMNS    ,FMNX    ,FMNY    ,IMNP    ,IMNC  ,
     +                FMXS    ,FMXX    ,FMXY    ,IMXP    ,IMXC  ,
     +                FZFS    ,FZFX    ,FZFY    ,IZFP    ,IZFC  ,
     +                FILS    ,FILX    ,FILY    ,IILP    ,IILC 
C
C Character variable declartions
C
      CHARACTER*160 CSTR
      PARAMETER (IPCHSZ=80)
      CHARACTER*(IPCHSZ)  CMNT,CMXT,CZFT,CILT
C
C Text string parameters
C
      COMMON / STCHAR / CSTR,CMNT,CMXT,CZFT,CILT
C
      SAVE /STPAR/, /STTRAN/, /STSTRM/, /STTXP/, /STCHAR/
C
C Internal buffer lengths
C
C IPNPTS - Number of points in the point buffer -- not less than 3
C IPLSTL - Streamline-crossover-check circular list length
C IPGRCT - Number of groups supported for area masking
C
      PARAMETER (IPNPTS = 256, IPLSTL = 750, IPGRCT = 64)
C
C FDLI  - Double linear interpolation formula
C FBESL - Bessel 16 pt interpolation formula ( most used formula )
C FQUAD - Quadratic interpolation formula
C
      FDLI(Z,Z1,Z2,Z3,DX,DY) = (1.-DX)*((1.-DY)*Z +DY*Z1)
     +                         +     DX *((1.-DY)*Z2+DY*Z3)
      FBESL(Z,ZP1,ZP2,ZM1,DZ)=Z+DZ*(ZP1-Z+0.25*(DZ-1.)*((ZP2-ZP1-Z+ZM1)
     +                        +0.666667*(DZ-0.5)*(ZP2-3.*ZP1+3.*Z-ZM1)))
      FQUAD(Z,ZP1,ZM1,DZ)=Z+0.5*DZ*(ZP1-ZM1+DZ*(ZP1-2.*Z+ZM1))
C
C ---------------------------------------------------------------------
C
      DX = X-AINT(X)
      DY = Y-AINT(Y)
      ITF = 1
      IM1 = I-1
      IP2 = I+2
C
C Determine which interpolation formula to use 
C depending on I,J location or the special flags
C
      IF (I.GE.IXDM .OR. J.GE.IYDN) THEN
C
C This branch should never be taken if STDRAW is correct, but is 
C included for safety
C
         RETURN
C
      ELSE IF(ISVF.NE.0 .OR. ITRP.NE.0) THEN
         ITF = 1
      ELSE IF (J.GT.IYD1 .AND. J.LT.IYM1 
     +        .AND. I.GT.IXD1 .AND. I.LT.IXM1) THEN
         ITF = 2
      ELSE IF (J.EQ.IYM1 .AND. I.GT.IXD1 .AND. I.LT.IXM1) THEN
         ITF = 3
      ELSE IF (J.EQ.IYD1) THEN
         ITF = 1
      ELSE IF (ICYK.NE.1) THEN
         IF (I.EQ.IXD1) THEN
            ITF = 1
         ELSE IF (I.EQ.IXM1) THEN
            ITF = 4
         END IF
      ELSE IF (I.EQ.IXD1 .AND. J.LT.IYM1) THEN 
         IM1 = IXM1
         ITF = 2
      ELSE IF (I.EQ.IXM1 .AND. J.LT.IYM1) THEN
         IP2 = IXD1+1
         ITF = 2
      ELSE IF (J.EQ.IYM1 .AND. I.EQ.IXD1) THEN
         IM1 = IXM1
         ITF = 3
      ELSE IF (J.EQ.IYM1 .AND. I.EQ.IXM1) THEN
         IP2 = IXD1+1
         ITF = 3
      END IF
C
      IF (ITF .EQ. 1) THEN
C
C Double linear interpolation formula. This scheme works at all points
C but the resulting streamlines are not as pleasing as those drawn
C by FBESL or FQUAD. Currently this is utilized
C only at certain boundary points or if ITRP is not equal to zero,
C or if special value processing is turned on.
C
         DU = FDLI(UX(I,J),UX(I,J+1),UX(I+1,J),UX(I+1,J+1),DX,DY)
         DV = FDLI(VY(I,J),VY(I,J+1),VY(I+1,J),VY(I+1,J+1),DX,DY)
C
      ELSE IF (ITF .EQ. 2) THEN
C
C 16 point bessel interpolation scheme.
C
         UJM1 = FBESL(UX(I,J-1),UX(I+1,J-1),UX(IP2,J-1),UX(IM1,J-1),DX)
         UJ   = FBESL(UX(I,J),UX(I+1,J),UX(IP2,J),UX(IM1,J),DX)
         UJP1 = FBESL(UX(I,J+1),UX(I+1,J+1),UX(IP2,J+1),UX(IM1,J+1),DX)
         UJP2 = FBESL(UX(I,J+2),UX(I+1,J+2),UX(IP2,J+2),UX(IM1,J+2),DX)
         DU   = FBESL(UJ,UJP1,UJP2,UJM1,DY)
         VJM1 = FBESL(VY(I,J-1),VY(I+1,J-1),VY(IP2,J-1),VY(IM1,J-1),DX)
         VJ   = FBESL(VY(I,J),VY(I+1,J),VY(IP2,J),VY(IM1,J),DX)
         VJP1 = FBESL(VY(I,J+1),VY(I+1,J+1),VY(IP2,J+1),VY(IM1,J+1),DX)
         VJP2 = FBESL(VY(I,J+2),VY(I+1,J+2),VY(IP2,J+2),VY(IM1,J+2),DX)
         DV   = FBESL(VJ,VJP1,VJP2,VJM1,DY)
C
      ELSE IF (ITF .EQ. 3) THEN
C
C 12 point interpolation scheme applicable to one row from top boundary
C
         UJM1 = FBESL(UX(I,J-1),UX(I+1,J-1),UX(IP2,J-1),UX(IM1,J-1),DX)
         UJ   = FBESL(UX(I,J),UX(I+1,J),UX(IP2,J),UX(IM1,J),DX)
         UJP1 = FBESL(UX(I,J+1),UX(I+1,J+1),UX(IP2,J+1),UX(IM1,J+1),DX)
         DU   = FQUAD(UJ,UJP1,UJM1,DY)
         VJM1 = FBESL(VY(I,J-1),VY(I+1,J-1),VY(IP2,J-1),VY(IM1,J-1),DX)
         VJ   = FBESL(VY(I,J),VY(I+1,J),VY(IP2,J),VY(IM1,J),DX)
         VJP1 = FBESL(VY(I,J+1),VY(I+1,J+1),VY(IP2,J+1),VY(IM1,J+1),DX)
         DV   = FQUAD(VJ,VJP1,VJM1,DY)
C
      ELSE IF (ITF .EQ. 4) THEN
C
C 9 point interpolation scheme for use in the non-cyclic case
C at I=IXM1; J > IYD1 and J <= IYM1
C
         UJP1 = FQUAD(UX(I,J+1),UX(I+1,J+1),UX(IM1,J+1),DX)
         UJ   = FQUAD(UX(I,J),UX(I+1,J),UX(IM1,J),DX)
         UJM1 = FQUAD(UX(I,J-1),UX(I+1,J-1),UX(IM1,J-1),DX)
         DU   = FQUAD(UJ,UJP1,UJM1,DY)
         VJP1 = FQUAD(VY(I,J+1),VY(I+1,J+1),VY(IM1,J+1),DX)
         VJ   = FQUAD(VY(I,J),VY(I+1,J),VY(IM1,J),DX)
         VJM1 = FQUAD(VY(I,J-1),VY(I+1,J-1),VY(IM1,J-1),DX)
         DV   = FQUAD(VJ,VJP1,VJM1,DY)
C
      END IF
C
C Done
C
      RETURN
      END

      SUBROUTINE ZTGEVC( SIDE, HOWMNY, SELECT, N, A, LDA, B, LDB, VL,
     $                   LDVL, VR, LDVR, MM, M, WORK, RWORK, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          HOWMNY, SIDE
      INTEGER            INFO, LDA, LDB, LDVL, LDVR, M, MM, N
*     ..
*     .. Array Arguments ..
      LOGICAL            SELECT( * )
      DOUBLE PRECISION   RWORK( * )
      COMPLEX*16         A( LDA, * ), B( LDB, * ), VL( LDVL, * ),
     $                   VR( LDVR, * ), WORK( * )
*     ..
*
*
*  Purpose
*  =======
*
*  ZTGEVC computes some or all of the right and/or left generalized
*  eigenvectors of a pair of complex upper triangular matrices (A,B).
*
*  The right generalized eigenvector x and the left generalized
*  eigenvector y of (A,B) corresponding to a generalized eigenvalue
*  w are defined by:
*
*          (A - wB) * x = 0  and  y**H * (A - wB) = 0
*
*  where y**H denotes the conjugate tranpose of y.
*
*  If an eigenvalue w is determined by zero diagonal elements of both A
*  and B, a unit vector is returned as the corresponding eigenvector.
*
*  If all eigenvectors are requested, the routine may either return
*  the matrices X and/or Y of right or left eigenvectors of (A,B), or
*  the products Z*X and/or Q*Y, where Z and Q are input unitary
*  matrices.  If (A,B) was obtained from the generalized Schur
*  factorization of an original pair of matrices
*     (A0,B0) = (Q*A*Z**H,Q*B*Z**H),
*  then Z*X and Q*Y are the matrices of right or left eigenvectors of
*  A.
*
*  Arguments
*  =========
*
*  SIDE    (input) CHARACTER*1
*          = 'R': compute right eigenvectors only;
*          = 'L': compute left eigenvectors only;
*          = 'B': compute both right and left eigenvectors.
*
*  HOWMNY  (input) CHARACTER*1
*          = 'A': compute all right and/or left eigenvectors;
*          = 'B': compute all right and/or left eigenvectors, and
*                 backtransform them using the input matrices supplied
*                 in VR and/or VL;
*          = 'S': compute selected right and/or left eigenvectors,
*                 specified by the logical array SELECT.
*
*  SELECT  (input) LOGICAL array, dimension (N)
*          If HOWMNY='S', SELECT specifies the eigenvectors to be
*          computed.
*          If HOWMNY='A' or 'B', SELECT is not referenced.
*          To select the eigenvector corresponding to the j-th
*          eigenvalue, SELECT(j) must be set to .TRUE..
*
*  N       (input) INTEGER
*          The order of the matrices A and B.  N >= 0.
*
*  A       (input) COMPLEX*16 array, dimension (LDA,N)
*          The upper triangular matrix A.
*
*  LDA     (input) INTEGER
*          The leading dimension of array A.  LDA >= max(1,N).
*
*  B       (input) COMPLEX*16 array, dimension (LDB,N)
*          The upper triangular matrix B.  B must have real diagonal
*          elements.
*
*  LDB     (input) INTEGER
*          The leading dimension of array B.  LDB >= max(1,N).
*
*  VL      (input/output) COMPLEX*16 array, dimension (LDVL,MM)
*          On entry, if SIDE = 'L' or 'B' and HOWMNY = 'B', VL must
*          contain an N-by-N matrix Q (usually the unitary matrix Q
*          of left Schur vectors returned by ZHGEQZ).
*          On exit, if SIDE = 'L' or 'B', VL contains:
*          if HOWMNY = 'A', the matrix Y of left eigenvectors of (A,B);
*          if HOWMNY = 'B', the matrix Q*Y;
*          if HOWMNY = 'S', the left eigenvectors of (A,B) specified by
*                      SELECT, stored consecutively in the columns of
*                      VL, in the same order as their eigenvalues.
*          If SIDE = 'R', VL is not referenced.
*
*  LDVL    (input) INTEGER
*          The leading dimension of array VL.
*          LDVL >= max(1,N) if SIDE = 'L' or 'B'; LDVL >= 1 otherwise.
*
*  VR      (input/output) COMPLEX*16 array, dimension (LDVR,MM)
*          On entry, if SIDE = 'R' or 'B' and HOWMNY = 'B', VR must
*          contain an N-by-N matrix Q (usually the unitary matrix Z
*          of right Schur vectors returned by ZHGEQZ).
*          On exit, if SIDE = 'R' or 'B', VR contains:
*          if HOWMNY = 'A', the matrix X of right eigenvectors of (A,B);
*          if HOWMNY = 'B', the matrix Z*X;
*          if HOWMNY = 'S', the right eigenvectors of (A,B) specified by
*                      SELECT, stored consecutively in the columns of
*                      VR, in the same order as their eigenvalues.
*          If SIDE = 'L', VR is not referenced.
*
*  LDVR    (input) INTEGER
*          The leading dimension of the array VR.
*          LDVR >= max(1,N) if SIDE = 'R' or 'B'; LDVR >= 1 otherwise.
*
*  MM      (input) INTEGER
*          The number of columns in the arrays VL and/or VR. MM >= M.
*
*  M       (output) INTEGER
*          The number of columns in the arrays VL and/or VR actually
*          used to store the eigenvectors.  If HOWMNY = 'A' or 'B', M
*          is set to N.  Each selected eigenvector occupies one column.
*
*  WORK    (workspace) COMPLEX*16 array, dimension (2*N)
*
*  RWORK   (workspace) DOUBLE PRECISION array, dimension (2*N)
*
*  INFO    (output) INTEGER
*          = 0:  successful exit.
*          < 0:  if INFO = -i, the i-th argument had an illegal value.
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO, ONE
      PARAMETER          ( ZERO = 0.0D+0, ONE = 1.0D+0 )
      COMPLEX*16         CZERO, CONE
      PARAMETER          ( CZERO = ( 0.0D+0, 0.0D+0 ),
     $                   CONE = ( 1.0D+0, 0.0D+0 ) )
*     ..
*     .. Local Scalars ..
      LOGICAL            COMPL, COMPR, ILALL, ILBACK, ILBBAD, ILCOMP,
     $                   LSA, LSB
      INTEGER            I, IBEG, IEIG, IEND, IHWMNY, IM, ISIDE, ISRC,
     $                   J, JE, JR
      DOUBLE PRECISION   ACOEFA, ACOEFF, ANORM, ASCALE, BCOEFA, BIG,
     $                   BIGNUM, BNORM, BSCALE, DMIN, SAFMIN, SBETA,
     $                   SCALE, SMALL, TEMP, ULP, XMAX
      COMPLEX*16         BCOEFF, CA, CB, D, SALPHA, SUM, SUMA, SUMB, X
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      DOUBLE PRECISION   DLAMCH
      COMPLEX*16         ZLADIV
      EXTERNAL           LSAME, DLAMCH, ZLADIV
*     ..
*     .. External Subroutines ..
      EXTERNAL           DLABAD, XERBLA, ZGEMV
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, DBLE, DCMPLX, DCONJG, DIMAG, MAX, MIN
*     ..
*     .. Statement Functions ..
      DOUBLE PRECISION   ABS1
*     ..
*     .. Statement Function definitions ..
      ABS1( X ) = ABS( DBLE( X ) ) + ABS( DIMAG( X ) )
*     ..
*     .. Executable Statements ..
*
*     Decode and Test the input parameters
*
      IF( LSAME( HOWMNY, 'A' ) ) THEN
         IHWMNY = 1
         ILALL = .TRUE.
         ILBACK = .FALSE.
      ELSE IF( LSAME( HOWMNY, 'S' ) ) THEN
         IHWMNY = 2
         ILALL = .FALSE.
         ILBACK = .FALSE.
      ELSE IF( LSAME( HOWMNY, 'B' ) .OR. LSAME( HOWMNY, 'T' ) ) THEN
         IHWMNY = 3
         ILALL = .TRUE.
         ILBACK = .TRUE.
      ELSE
         IHWMNY = -1
      END IF
*
      IF( LSAME( SIDE, 'R' ) ) THEN
         ISIDE = 1
         COMPL = .FALSE.
         COMPR = .TRUE.
      ELSE IF( LSAME( SIDE, 'L' ) ) THEN
         ISIDE = 2
         COMPL = .TRUE.
         COMPR = .FALSE.
      ELSE IF( LSAME( SIDE, 'B' ) ) THEN
         ISIDE = 3
         COMPL = .TRUE.
         COMPR = .TRUE.
      ELSE
         ISIDE = -1
      END IF
*
      INFO = 0
      IF( ISIDE.LT.0 ) THEN
         INFO = -1
      ELSE IF( IHWMNY.LT.0 ) THEN
         INFO = -2
      ELSE IF( N.LT.0 ) THEN
         INFO = -4
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -6
      ELSE IF( LDB.LT.MAX( 1, N ) ) THEN
         INFO = -8
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'ZTGEVC', -INFO )
         RETURN
      END IF
*
*     Count the number of eigenvectors
*
      IF( .NOT.ILALL ) THEN
         IM = 0
         DO 10 J = 1, N
            IF( SELECT( J ) )
     $         IM = IM + 1
   10    CONTINUE
      ELSE
         IM = N
      END IF
*
*     Check diagonal of B
*
      ILBBAD = .FALSE.
      DO 20 J = 1, N
         IF( DIMAG( B( J, J ) ).NE.ZERO )
     $      ILBBAD = .TRUE.
   20 CONTINUE
*
      IF( ILBBAD ) THEN
         INFO = -7
      ELSE IF( COMPL .AND. LDVL.LT.N .OR. LDVL.LT.1 ) THEN
         INFO = -10
      ELSE IF( COMPR .AND. LDVR.LT.N .OR. LDVR.LT.1 ) THEN
         INFO = -12
      ELSE IF( MM.LT.IM ) THEN
         INFO = -13
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'ZTGEVC', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      M = IM
      IF( N.EQ.0 )
     $   RETURN
*
*     Machine Constants
*
      SAFMIN = DLAMCH( 'Safe minimum' )
      BIG = ONE / SAFMIN
      CALL DLABAD( SAFMIN, BIG )
      ULP = DLAMCH( 'Epsilon' )*DLAMCH( 'Base' )
      SMALL = SAFMIN*N / ULP
      BIG = ONE / SMALL
      BIGNUM = ONE / ( SAFMIN*N )
*
*     Compute the 1-norm of each column of the strictly upper triangular
*     part of A and B to check for possible overflow in the triangular
*     solver.
*
      ANORM = ABS1( A( 1, 1 ) )
      BNORM = ABS1( B( 1, 1 ) )
      RWORK( 1 ) = ZERO
      RWORK( N+1 ) = ZERO
      DO 40 J = 2, N
         RWORK( J ) = ZERO
         RWORK( N+J ) = ZERO
         DO 30 I = 1, J - 1
            RWORK( J ) = RWORK( J ) + ABS1( A( I, J ) )
            RWORK( N+J ) = RWORK( N+J ) + ABS1( B( I, J ) )
   30    CONTINUE
         ANORM = MAX( ANORM, RWORK( J )+ABS1( A( J, J ) ) )
         BNORM = MAX( BNORM, RWORK( N+J )+ABS1( B( J, J ) ) )
   40 CONTINUE
*
      ASCALE = ONE / MAX( ANORM, SAFMIN )
      BSCALE = ONE / MAX( BNORM, SAFMIN )
*
*     Left eigenvectors
*
      IF( COMPL ) THEN
         IEIG = 0
*
*        Main loop over eigenvalues
*
         DO 140 JE = 1, N
            IF( ILALL ) THEN
               ILCOMP = .TRUE.
            ELSE
               ILCOMP = SELECT( JE )
            END IF
            IF( ILCOMP ) THEN
               IEIG = IEIG + 1
*
               IF( ABS1( A( JE, JE ) ).LE.SAFMIN .AND.
     $             ABS( DBLE( B( JE, JE ) ) ).LE.SAFMIN ) THEN
*
*                 Singular matrix pencil -- return unit eigenvector
*
                  DO 50 JR = 1, N
                     VL( JR, IEIG ) = CZERO
   50             CONTINUE
                  VL( IEIG, IEIG ) = CONE
                  GO TO 140
               END IF
*
*              Non-singular eigenvalue:
*              Compute coefficients  a  and  b  in
*                   H
*                 y  ( a A - b B ) = 0
*
               TEMP = ONE / MAX( ABS1( A( JE, JE ) )*ASCALE,
     $                ABS( DBLE( B( JE, JE ) ) )*BSCALE, SAFMIN )
               SALPHA = ( TEMP*A( JE, JE ) )*ASCALE
               SBETA = ( TEMP*DBLE( B( JE, JE ) ) )*BSCALE
               ACOEFF = SBETA*ASCALE
               BCOEFF = SALPHA*BSCALE
*
*              Scale to avoid underflow
*
               LSA = ABS( SBETA ).GE.SAFMIN .AND. ABS( ACOEFF ).LT.SMALL
               LSB = ABS1( SALPHA ).GE.SAFMIN .AND. ABS1( BCOEFF ).LT.
     $               SMALL
*
               SCALE = ONE
               IF( LSA )
     $            SCALE = ( SMALL / ABS( SBETA ) )*MIN( ANORM, BIG )
               IF( LSB )
     $            SCALE = MAX( SCALE, ( SMALL / ABS1( SALPHA ) )*
     $                    MIN( BNORM, BIG ) )
               IF( LSA .OR. LSB ) THEN
                  SCALE = MIN( SCALE, ONE /
     $                    ( SAFMIN*MAX( ONE, ABS( ACOEFF ),
     $                    ABS1( BCOEFF ) ) ) )
                  IF( LSA ) THEN
                     ACOEFF = ASCALE*( SCALE*SBETA )
                  ELSE
                     ACOEFF = SCALE*ACOEFF
                  END IF
                  IF( LSB ) THEN
                     BCOEFF = BSCALE*( SCALE*SALPHA )
                  ELSE
                     BCOEFF = SCALE*BCOEFF
                  END IF
               END IF
*
               ACOEFA = ABS( ACOEFF )
               BCOEFA = ABS1( BCOEFF )
               XMAX = ONE
               DO 60 JR = 1, N
                  WORK( JR ) = CZERO
   60          CONTINUE
               WORK( JE ) = CONE
               DMIN = MAX( ULP*ACOEFA*ANORM, ULP*BCOEFA*BNORM, SAFMIN )
*
*                                              H
*              Triangular solve of  (a A - b B)  y = 0
*
*                                      H
*              (rowwise in  (a A - b B) , or columnwise in a A - b B)
*
               DO 100 J = JE + 1, N
*
*                 Compute
*                       j-1
*                 SUM = sum  conjg( a*A(k,j) - b*B(k,j) )*x(k)
*                       k=je
*                 (Scale if necessary)
*
                  TEMP = ONE / XMAX
                  IF( ACOEFA*RWORK( J )+BCOEFA*RWORK( N+J ).GT.BIGNUM*
     $                TEMP ) THEN
                     DO 70 JR = JE, J - 1
                        WORK( JR ) = TEMP*WORK( JR )
   70                CONTINUE
                     XMAX = ONE
                  END IF
                  SUMA = CZERO
                  SUMB = CZERO
*
                  DO 80 JR = JE, J - 1
                     SUMA = SUMA + DCONJG( A( JR, J ) )*WORK( JR )
                     SUMB = SUMB + DCONJG( B( JR, J ) )*WORK( JR )
   80             CONTINUE
                  SUM = ACOEFF*SUMA - DCONJG( BCOEFF )*SUMB
*
*                 Form x(j) = - SUM / conjg( a*A(j,j) - b*B(j,j) )
*
*                 with scaling and perturbation of the denominator
*
                  D = DCONJG( ACOEFF*A( J, J )-BCOEFF*B( J, J ) )
                  IF( ABS1( D ).LE.DMIN )
     $               D = DCMPLX( DMIN )
*
                  IF( ABS1( D ).LT.ONE ) THEN
                     IF( ABS1( SUM ).GE.BIGNUM*ABS1( D ) ) THEN
                        TEMP = ONE / ABS1( SUM )
                        DO 90 JR = JE, J - 1
                           WORK( JR ) = TEMP*WORK( JR )
   90                   CONTINUE
                        XMAX = TEMP*XMAX
                        SUM = TEMP*SUM
                     END IF
                  END IF
                  WORK( J ) = ZLADIV( -SUM, D )
                  XMAX = MAX( XMAX, ABS1( WORK( J ) ) )
  100          CONTINUE
*
*              Back transform eigenvector if HOWMNY='B'.
*
               IF( ILBACK ) THEN
                  CALL ZGEMV( 'N', N, N+1-JE, CONE, VL( 1, JE ), LDVL,
     $                        WORK( JE ), 1, CZERO, WORK( N+1 ), 1 )
                  ISRC = 2
                  IBEG = 1
               ELSE
                  ISRC = 1
                  IBEG = JE
               END IF
*
*              Copy and scale eigenvector into column of VL
*
               XMAX = ZERO
               DO 110 JR = IBEG, N
                  XMAX = MAX( XMAX, ABS1( WORK( ( ISRC-1 )*N+JR ) ) )
  110          CONTINUE
*
               IF( XMAX.GT.SAFMIN ) THEN
                  TEMP = ONE / XMAX
                  DO 120 JR = IBEG, N
                     VL( JR, IEIG ) = TEMP*WORK( ( ISRC-1 )*N+JR )
  120             CONTINUE
               ELSE
                  IBEG = N + 1
               END IF
*
               DO 130 JR = 1, IBEG - 1
                  VL( JR, IEIG ) = CZERO
  130          CONTINUE
*
            END IF
  140    CONTINUE
      END IF
*
*     Right eigenvectors
*
      IF( COMPR ) THEN
         IEIG = IM + 1
*
*        Main loop over eigenvalues
*
         DO 250 JE = N, 1, -1
            IF( ILALL ) THEN
               ILCOMP = .TRUE.
            ELSE
               ILCOMP = SELECT( JE )
            END IF
            IF( ILCOMP ) THEN
               IEIG = IEIG - 1
*
               IF( ABS1( A( JE, JE ) ).LE.SAFMIN .AND.
     $             ABS( DBLE( B( JE, JE ) ) ).LE.SAFMIN ) THEN
*
*                 Singular matrix pencil -- return unit eigenvector
*
                  DO 150 JR = 1, N
                     VR( JR, IEIG ) = CZERO
  150             CONTINUE
                  VR( IEIG, IEIG ) = CONE
                  GO TO 250
               END IF
*
*              Non-singular eigenvalue:
*              Compute coefficients  a  and  b  in
*
*              ( a A - b B ) x  = 0
*
               TEMP = ONE / MAX( ABS1( A( JE, JE ) )*ASCALE,
     $                ABS( DBLE( B( JE, JE ) ) )*BSCALE, SAFMIN )
               SALPHA = ( TEMP*A( JE, JE ) )*ASCALE
               SBETA = ( TEMP*DBLE( B( JE, JE ) ) )*BSCALE
               ACOEFF = SBETA*ASCALE
               BCOEFF = SALPHA*BSCALE
*
*              Scale to avoid underflow
*
               LSA = ABS( SBETA ).GE.SAFMIN .AND. ABS( ACOEFF ).LT.SMALL
               LSB = ABS1( SALPHA ).GE.SAFMIN .AND. ABS1( BCOEFF ).LT.
     $               SMALL
*
               SCALE = ONE
               IF( LSA )
     $            SCALE = ( SMALL / ABS( SBETA ) )*MIN( ANORM, BIG )
               IF( LSB )
     $            SCALE = MAX( SCALE, ( SMALL / ABS1( SALPHA ) )*
     $                    MIN( BNORM, BIG ) )
               IF( LSA .OR. LSB ) THEN
                  SCALE = MIN( SCALE, ONE /
     $                    ( SAFMIN*MAX( ONE, ABS( ACOEFF ),
     $                    ABS1( BCOEFF ) ) ) )
                  IF( LSA ) THEN
                     ACOEFF = ASCALE*( SCALE*SBETA )
                  ELSE
                     ACOEFF = SCALE*ACOEFF
                  END IF
                  IF( LSB ) THEN
                     BCOEFF = BSCALE*( SCALE*SALPHA )
                  ELSE
                     BCOEFF = SCALE*BCOEFF
                  END IF
               END IF
*
               ACOEFA = ABS( ACOEFF )
               BCOEFA = ABS1( BCOEFF )
               XMAX = ONE
               DO 160 JR = 1, N
                  WORK( JR ) = CZERO
  160          CONTINUE
               WORK( JE ) = CONE
               DMIN = MAX( ULP*ACOEFA*ANORM, ULP*BCOEFA*BNORM, SAFMIN )
*
*              Triangular solve of  (a A - b B) x = 0  (columnwise)
*
*              WORK(1:j-1) contains sums w,
*              WORK(j+1:JE) contains x
*
               DO 170 JR = 1, JE - 1
                  WORK( JR ) = ACOEFF*A( JR, JE ) - BCOEFF*B( JR, JE )
  170          CONTINUE
               WORK( JE ) = CONE
*
               DO 210 J = JE - 1, 1, -1
*
*                 Form x(j) := - w(j) / d
*                 with scaling and perturbation of the denominator
*
                  D = ACOEFF*A( J, J ) - BCOEFF*B( J, J )
                  IF( ABS1( D ).LE.DMIN )
     $               D = DCMPLX( DMIN )
*
                  IF( ABS1( D ).LT.ONE ) THEN
                     IF( ABS1( WORK( J ) ).GE.BIGNUM*ABS1( D ) ) THEN
                        TEMP = ONE / ABS1( WORK( J ) )
                        DO 180 JR = 1, JE
                           WORK( JR ) = TEMP*WORK( JR )
  180                   CONTINUE
                     END IF
                  END IF
*
                  WORK( J ) = ZLADIV( -WORK( J ), D )
*
                  IF( J.GT.1 ) THEN
*
*                    w = w + x(j)*(a A(*,j) - b B(*,j) ) with scaling
*
                     IF( ABS1( WORK( J ) ).GT.ONE ) THEN
                        TEMP = ONE / ABS1( WORK( J ) )
                        IF( ACOEFA*RWORK( J )+BCOEFA*RWORK( N+J ).GE.
     $                      BIGNUM*TEMP ) THEN
                           DO 190 JR = 1, JE
                              WORK( JR ) = TEMP*WORK( JR )
  190                      CONTINUE
                        END IF
                     END IF
*
                     CA = ACOEFF*WORK( J )
                     CB = BCOEFF*WORK( J )
                     DO 200 JR = 1, J - 1
                        WORK( JR ) = WORK( JR ) + CA*A( JR, J ) -
     $                               CB*B( JR, J )
  200                CONTINUE
                  END IF
  210          CONTINUE
*
*              Back transform eigenvector if HOWMNY='B'.
*
               IF( ILBACK ) THEN
                  CALL ZGEMV( 'N', N, JE, CONE, VR, LDVR, WORK, 1,
     $                        CZERO, WORK( N+1 ), 1 )
                  ISRC = 2
                  IEND = N
               ELSE
                  ISRC = 1
                  IEND = JE
               END IF
*
*              Copy and scale eigenvector into column of VR
*
               XMAX = ZERO
               DO 220 JR = 1, IEND
                  XMAX = MAX( XMAX, ABS1( WORK( ( ISRC-1 )*N+JR ) ) )
  220          CONTINUE
*
               IF( XMAX.GT.SAFMIN ) THEN
                  TEMP = ONE / XMAX
                  DO 230 JR = 1, IEND
                     VR( JR, IEIG ) = TEMP*WORK( ( ISRC-1 )*N+JR )
  230             CONTINUE
               ELSE
                  IEND = 0
               END IF
*
               DO 240 JR = IEND + 1, N
                  VR( JR, IEIG ) = CZERO
  240          CONTINUE
*
            END IF
  250    CONTINUE
      END IF
*
      RETURN
*
*     End of ZTGEVC
*
      END

C
C $Id: aiproj.f,v 1.4 2008-09-18 00:42:16 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE AIPROJ (DLAT,DLON,UVAL,VVAL)
C
        DOUBLE PRECISION DLAT,DLON,UVAL,VVAL
C
C The subroutine AIPROJ implements a closed form of the Aitoff
C projection, using formulas identical to those given on various Web
C sites (for example, Wikipedia), using the rather odd function SINC(X),
C the value of which is SIN(X)/X, when X is not zero, and 1, otherwise.
C For efficiency, this function is incorporated into the local code.
C
C DLAT and DLON are input values of latitude and longitude, in radians.
C UVAL and VVAL are output values of U and V, in the projection plane.
C
C Local variable.
C
        DOUBLE PRECISION TVAL
C
        TVAL=ACOS(COS(DLAT)*COS(.5D0*DLON))
C
        IF (ABS(TVAL).GT.1.D-6) THEN
          TVAL=SIN(TVAL)/TVAL
        ELSE
          TVAL=1.D0
        END IF
C
        UVAL=2.D0*COS(DLAT)*SIN(.5D0*DLON)/TVAL
        VVAL=SIN(DLAT)/TVAL
C
        RETURN
C
      END

C
C	$Id: css2c.f,v 1.4 2008-07-27 03:10:07 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CSS2C (N,RLAT,RLON, X,Y,Z)
      INTEGER N
      REAL RLAT(N), RLON(N), X(N), Y(N), Z(N)
C
C   This subroutine transforms spherical coordinates into
C Cartesian coordinates on the unit sphere.
C
C On input:
C
C       N = Number of nodes (points on the unit sphere)
C           whose coordinates are to be transformed.
C
C       RLAT = Array of length N containing latitudinal
C              coordinates of the nodes in degrees.
C
C       RLON = Array of length N containing longitudinal
C              coordinates of the nodes in degrees.
C
C The above parameters are not altered by this routine.
C
C       X,Y,Z = Arrays of length at least N.
C
C On output:
C
C       X,Y,Z = Cartesian coordinates in the range -1 to 1.
C               X(I)**2 + Y(I)**2 + Z(I)**2 = 1 for I = 1
C               to N.
C
C Modules required by CSS2C:  None
C
C Intrinsic functions called by CSS2C:  SIN, COS
C
C***********************************************************
C
      PARAMETER (D2R=0.017453293, R2D=57.295778)
      INTEGER I, NN
      REAL COSPHI, PHI, THETA
C
C Local parameters:
C
C COSPHI = cos(PHI)
C I =      DO-loop index
C NN =     Local copy of N
C PHI =    Latitude
C THETA =  Longitude
C
      NN = N
      DO 1 I = 1,NN
        RLATD = D2R*RLAT(I)
        RLOND = D2R*RLON(I)
        PHI = RLATD
        THETA = RLOND
        COSPHI = COS(PHI)
        X(I) = COSPHI*COS(THETA)
        Y(I) = COSPHI*SIN(THETA)
        Z(I) = SIN(PHI)
    1   CONTINUE
      RETURN
      END

C
C $Id: tdinit.f,v 1.5 2008-07-27 00:17:32 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE TDINIT (XMID,YMID,ZMID,XORI,YORI,ZORI,XTHI,YTHI,ZTHI,
     +                   OTEP)
C
C This routine initializes the projection package.  The arguments are
C as follows:
C
C   (XMID,YMID,ZMID) is a point in three-space that is midway between
C   the eyes of the observer.
C
C   (XORI,YORI,ZORI) is a point in three-space at the origin of a plane
C   called "plane 1", which is the image plane; plane 1 passes through
C   the point (XORI,YORI,ZORI) and is perpendicular to the line joining
C   (XMID,YMID,ZMID) to (XORI,YORI,ZORI).
C
C   (XTHI,YTHI,ZTHI) is the third of three points in three-space [the
C   other two being (XMID,YMID,ZMID) and (XORI,YORI,ZORI)] required to
C   define a plane called "plane 2", which is the plane of bilateral
C   symmetry of the user.  The intersection of planes 1 and 2 is the Y
C   axis of the image plane.  A plane called "plane 3" is defined as
C   passing through the point (XORI,YORI,ZORI) and being perpendicular
C   to each of planes 1 and 2.  The intersection of planes 1 and 3 is
C   the X axis of the image plane.
C
C   OTEP is the desired offset to the position of the eye to be used.
C   If the distance between the eyes is "s", then use OTEP = "-s/2" for
C   a left-eye view and OTEP = "+s/2" for a right-eye view.  OTEP = 0
C   gives a Cyclopean view from the point (XMID,YMID,ZMID).
C
C If the common variable IH has the value zero, the 3D coordinate system
C is right-handed; if it has a non-zero value, the coordinate system is
C left-handed.
C
C If the common variable IS has the value zero, no SET call is done;
C otherwise, a SET call is done, defining a field of view of FV degrees,
C where FV is another common variable.
C
C If one half of a stereo pair is being done and the common variable
C IT is non-zero, planes 1, 2, and 3 are redefined (by rotation about
C the Y axis) so that plane 1 is perpendicular to the line from the
C eye being used to the point (XORI,YORI,ZORI); planes 2 and 3 also
C pass through the eye being used.
C
C The variables in the following common block define the mapping from
C 3-space to 2-space.
C
        COMMON /TDCOM1/ IH,IT,XM,YM,ZM,XO,YO,ZO,XT,YT,ZT,OE,XE,YE,ZE
        COMMON /TDCOM1/ A1,B1,C1,D1,E1,A2,B2,C2,D2,E2,A3,B3,C3,D3,E3
        COMMON /TDCOM1/ IS,FV,VL,VR,VB,VT,WL,WR,WB,WT
        SAVE   /TDCOM1/
C
C Do a call forcing a BLOCKDATA to be loaded from a binary library.
C
        CALL TDBLDA
C
C Check for an uncleared prior error.
C
        IF (ICFELL('TDINIT - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C Copy the coordinates of the midpoint of the line joining the eyes
C into labelled common.
C
        XM=XMID
        YM=YMID
        ZM=ZMID
C
C Copy the coordinates of the origin of the image plane into labelled
C common.
C
        XO=XORI
        YO=YORI
        ZO=ZORI
C
C Copy the coordinates of the third point into labelled common.
C
        XT=XTHI
        YT=YTHI
        ZT=ZTHI
C
C Copy the offset to the eye position into labelled common.
C
        OE=OTEP
C
C Compute the coefficients in the equation defining plane 1.
C
        A1=XO-XM
        B1=YO-YM
        C1=ZO-ZM
        D1=XO*XM+YO*YM+ZO*ZM-XO*XO-YO*YO-ZO*ZO
        T1=SQRT(A1*A1+B1*B1+C1*C1)
        A1=A1/T1
        B1=B1/T1
        C1=C1/T1
        D1=D1/T1
C
C Compute the coefficients in the equation defining plane 2.
C
        A2=YM*(ZO-ZT)+YO*(ZT-ZM)+YT*(ZM-ZO)
        B2=XM*(ZT-ZO)+XO*(ZM-ZT)+XT*(ZO-ZM)
        C2=XM*(YO-YT)+XO*(YT-YM)+XT*(YM-YO)
        D2=XM*YT*ZO+XO*YM*ZT+XT*YO*ZM-XM*YO*ZT-XT*YM*ZO-XO*YT*ZM
        T2=SQRT(A2*A2+B2*B2+C2*C2)
        IF (IH.NE.0) T2=-T2
        A2=A2/T2
        B2=B2/T2
        C2=C2/T2
        D2=D2/T2
C
C Compute the coefficients in the equation defining plane 3.
C
        A3=B2*(ZO-ZM)+C2*(YM-YO)
        B3=A2*(ZM-ZO)+C2*(XO-XM)
        C3=A2*(YO-YM)+B2*(XM-XO)
        D3=A2*(YM*ZO-YO*ZM)+B2*(XO*ZM-XM*ZO)+C2*(XM*YO-XO*YM)
        T3=SQRT(A3*A3+B3*B3+C3*C3)
        IF (IH.NE.0) T3=-T3
        A3=A3/T3
        B3=B3/T3
        C3=C3/T3
        D3=D3/T3
C
C Call SET, if that is to be done.
C
        IF (IS.NE.0) THEN
          IF (VR-VL.GT.VT-VB) THEN
            WL=-ABS(A1*XM+B1*YM+C1*ZM+D1)*TAN(.017453292519943*FV/2.)
            WR=-WL
            WB=((VT-VB)/(VR-VL))*WL
            WT=-WB
          ELSE
            WB=-ABS(A1*XM+B1*YM+C1*ZM+D1)*TAN(.017453292519943*FV/2.)
            WT=-WB
            WL=((VR-VL)/(VT-VB))*WB
            WR=-WL
          END IF
          CALL SET (VL,VR,VB,VT,WL,WR,WB,WT,1)
          IF (ICFELL('TDINIT',2).NE.0) RETURN
        END IF
C
C Compute the coordinates of the eye position.
C
        XE=XM+A2*OE
        YE=YM+B2*OE
        ZE=ZM+C2*OE
C
C If a stereo view is being done and the user has requested that the
C image plane for each view be perpendicular to the line of sight from
C the eye in use, recompute all quantities to make it so.
C
        IF (OE.NE.0..AND.IT.NE.0) THEN
          TT=ABS(A1*XE+B1*YE+C1*ZE+D1)
          XS=XO+TT*A3
          YS=YO+TT*B3
          ZS=ZO+TT*C3
          A1=XO-XE
          B1=YO-YE
          C1=ZO-ZE
          D1=XO*XE+YO*YE+ZO*ZE-XO*XO-YO*YO-ZO*ZO
          T1=SQRT(A1*A1+B1*B1+C1*C1)
          A1=A1/T1
          B1=B1/T1
          C1=C1/T1
          D1=D1/T1
          A2=YE*(ZO-ZS)+YO*(ZS-ZE)+YS*(ZE-ZO)
          B2=XE*(ZS-ZO)+XO*(ZE-ZS)+XS*(ZO-ZE)
          C2=XE*(YO-YS)+XO*(YS-YE)+XS*(YE-YO)
          D2=XE*YS*ZO+XO*YE*ZS+XS*YO*ZE-XE*YO*ZS-XS*YE*ZO-XO*YS*ZE
          T2=SQRT(A2*A2+B2*B2+C2*C2)
          IF (IH.NE.0) T2=-T2
          A2=A2/T2
          B2=B2/T2
          C2=C2/T2
          D2=D2/T2
          A3=B2*(ZO-ZE)+C2*(YE-YO)
          B3=A2*(ZE-ZO)+C2*(XO-XE)
          C3=A2*(YO-YE)+B2*(XE-XO)
          D3=A2*(YE*ZO-YO*ZE)+B2*(XO*ZE-XE*ZO)+C2*(XE*YO-XO*YE)
          T3=SQRT(A3*A3+B3*B3+C3*C3)
          IF (IH.NE.0) T3=-T3
          A3=A3/T3
          B3=B3/T3
          C3=C3/T3
          D3=D3/T3
        END IF
C
C Compute quantities needed by TDPRPT.
C
        E1=A1*XE+B1*YE+C1*ZE+D1
        E2=A2*XE+B2*YE+C2*ZE+D2
        E3=A3*XE+B3*YE+C3*ZE+D3
C
C Done.
C
        RETURN
C
      END

C
C $Id: kfmx.f,v 1.7 2008-07-27 00:17:24 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      FUNCTION KFMX (RX)
C
C Given an X coordinate RX in the fractional system, KFMX(RX) is an X
C coordinate in the metacode system.
C
      KFMX=INT(RX*32767.)
      RETURN
      END

C
C $Id: isblda.f,v 1.6 2008-07-27 00:17:15 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE ISBLDA
C
C Calling this do-nothing subroutine forces "ld" to load the following
C block data routine (but only if they are in the same ".f" file).
C
        RETURN
C
      END
CNOSPLIT
      BLOCKDATA ISBLDAX
C
C Block data routine, in which some default values are set.
C
      COMMON /ISCOMN/ BIG,BIGD,DBPI,IDONE,IFILL,IFLIP,IONES,IHSS(1000),
     +                IREF,ISCA(16,256),ISCALE,ISCR(16,256),ISLBT,ISDR,
     +                LHSS,LX,NFPW,NINU,NINV,NINW,NX,NY,R0,RNX,RNY,
     +                SMALL,SVAL,TENSN,U,V,W,XMAX,XMIN,YMAX,YMIN,XVPL,
     +                XVPR,YVPB,YVPT
      SAVE   /ISCOMN/
C
      COMMON /TEMPRX/ RZERO
      SAVE   /TEMPRX/
C
C DBPI is the desired distance between interpolated points used to
C represent the smooth curves generated by the spline fitter.  It is
C given in the fractional coordinate system.
C
      DATA DBPI / .01 /
C
C IDONE is the "initialization-done" flag.
C
      DATA IDONE / 0 /
C
C SVAL, if non-zero, is the "special value" that signals missing data.
C
      DATA SVAL / 0. /
C
C IREF is a flag controlling the drawing of reference planes and/or
C axes.  By default, these are turned on.
C
      DATA IREF / 1 /
C
C ISDR is set non-zero to suppress drawing of lines by the routine
C ISPLTF.
C
      DATA ISDR / 0 /
C
C LX is the first dimension of the screen model arrays; its value must
C be consistent with the declarations of ISCA and ISCR, above.
C
      DATA LX / 16 /
C
C NX and NY are the dimensions of the screen models.  The two values
C should be set equal to one another, and both values should be either
C 128 or 256.
C
      DATA NX,NY / 128,128 /
C
C LHSS is the length of the array IHSS, in which the contour-tracing
C routine keeps track of horizontal segments already seen.
C
      DATA LHSS / 1000 /
C
C RZERO is set non-zero if the "relative size feature" is to be used.
C
      DATA RZERO / 0. /
C
C SMALL is used by the routines ISTRCL and ISSMTH.  It specifies, in the
C fractional coordinate system, the smallest distance between two points
C in order for the points to be considered distinct.
C
      DATA SMALL / .000001 /
C
C TENSN is the tension on the splines used by the routine ISSMTH.
C
      DATA TENSN / 0. /
C
C XVPL, XVPR, YVPB, YVPT specify the left, right, bottom, and top edges
C of the viewport in which the ISOSRF plot is to be drawn.  Each is a
C real number between 0 and 1.
C
      DATA XVPL,XVPR,YVPB,YVPT / 0.,1.,0.,1. /
C
      END

      PROGRAM WMEX16
C
C  Example of drawing vectors over a map.
C
C
C  Define the error file, the Fortran unit number, the workstation type,
C  and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, 0)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C  Define some colors.
C
      CALL GSCR(IWKID,0,1.,1.,1.)
      CALL GSCR(IWKID,1,0.,0.,0.)
      CALL GSCR(IWKID,2,1.,0.,0.)
      CALL GSCR(IWKID,3,0.,1.,0.)
      CALL GSCR(IWKID,4,0.,0.,1.)
      CALL GSCR(IWKID,5,0.,0.,0.)
      CALL GSCR(IWKID,6,0.,1.,1.)
      CALL GSCR(IWKID,7,1.,0.,1.)
C
C  Tell EZMAP what part of the frame to use.
C
      CALL MAPPOS (.0,1.,0.,1.)
C
C  Draw an orthographic projection with continental outlines plotted.
C
      CALL MAPROJ ('OR',70.,-10.,0.)
      CALL MAPSET ('CO',55.,-50.,85.,-20.)
      CALL MAPSTC ('OU','CO')
C
C  Draw the EZMAP background.
C
      CALL MAPDRW()
C
C  Draw vectors based at the same point on the map.
C  
      CALL WMSETR('VCW - linewidth scale',2.)
      CALL WMSETI('VCC - vector color',2)
      CALL WMVECTMAP(70.,-40.,  0., 80.)
      CALL WMSETI('VCC - vector color',3)
      CALL WMVECTMAP(70.,-40., 80., 80.)
      CALL WMSETI('VCC - vector color',4)
      CALL WMVECTMAP(70.,-40., 80.,  0.)
      CALL WMSETI('VCC - vector color',5)
      CALL WMVECTMAP(70.,-40.,-80.,  0.)
      CALL WMSETI('VCC - vector color',6)
      CALL WMVECTMAP(70.,-40.,  0.,-80.)
      CALL WMSETI('VCC - vector color',7)
      CALL WMVECTMAP(70.,-40.,-80.,-80.)
C
C  Draw label box.
C
      CALL WMVLBL(0.95,0.0015)
C
      CALL FRAME
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      END

C
C $Id: points.f,v 1.7 2008-07-27 00:17:25 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE POINTS (PX,PY,NP,IC,IL)
      DIMENSION PX(NP),PY(NP)
C
C Marks the points at positions in the user coordinate system defined
C by ((PX(I),PY(I)),I=1,NP).  If IC is zero, each point is marked with
C a simple point.  If IC is positive, each point is marked with the
C single character defined by the FORTRAN-77 function CHAR(IC).  If IC
C is negative, each point is marked with a GKS polymarker of type -IC.
C If IL is non-zero, a curve is also drawn, connecting the points.
C
C Define arrays to hold converted point coordinates when it becomes
C necessary to mark the points a few at a time.
C
      DIMENSION QX(10),QY(10)
C
C Define an array to hold the aspect source flags which may need to be
C retrieved from GKS.
C
      DIMENSION LA(13)
      CHARACTER*1 CHRTMP
C
C Check for an uncleared prior error.
C
      IF (ICFELL('POINTS - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C If the number of points is zero or negative, there's nothing to do.
C
      IF (NP.LE.0) RETURN
C
C Otherwise, flush the pen-move buffer.
C
      CALL PLOTIF (0.,0.,2)
      IF (ICFELL('POINTS',2).NE.0) RETURN
C
C Retrieve the parameters from the last SET call.
C
      CALL GETSET (F1,F2,F3,F4,F5,F6,F7,F8,LL)
      IF (ICFELL('POINTS',3).NE.0) RETURN
C
C If a linear-linear, non-mirror-imaged, mapping is being done and the
C GKS polymarkers can be used, all the points can be marked with a
C single polymarker call and joined, if requested, by a single polyline
C call.
C
      IF (F5.LT.F6.AND.F7.LT.F8.AND.LL.EQ.1.AND.IC.LE.0) THEN
        CALL GQASF (IE,LA)
        IF (IE.NE.0) THEN
          CALL SETER ('POINTS - ERROR EXIT FROM GQASF',4,1)
          RETURN
        END IF
        IF (LA(4).EQ.0) THEN
          CALL GQPMI (IE,IN)
          IF (IE.NE.0) THEN
            CALL SETER ('POINTS - ERROR EXIT FROM GQPMI',5,1)
            RETURN
          END IF
          CALL GSPMI (MAX(-IC,1))
          CALL GPM (NP,PX,PY)
          CALL GSPMI (IN)
        ELSE
          CALL GQMK (IE,IN)
          IF (IE.NE.0) THEN
            CALL SETER ('POINTS - ERROR EXIT FROM GQMK',6,1)
            RETURN
          END IF
          CALL GSMK (MAX(-IC,1))
          CALL GPM (NP,PX,PY)
          CALL GSMK (IN)
        END IF
        IF (IL.NE.0.AND.NP.GE.2) CALL GPL (NP,PX,PY)
C
C Otherwise, things get complicated.  We have to do batches of nine
C points at a time.  (Actually, we convert ten coordinates at a time,
C so that the curve joining the points, if any, won't have gaps in it.)
C
      ELSE
C
C Initially, we have to reset either the polymarker index or the text
C alignment, depending on how we're marking the points.
C
        IF (IC.LE.0) THEN
          CALL GQASF (IE,LA)
          IF (IE.NE.0) THEN
            CALL SETER ('POINTS - ERROR EXIT FROM GQASF',7,1)
            RETURN
          END IF
          IF (LA(4).EQ.0) THEN
            CALL GQPMI (IE,IN)
            IF (IE.NE.0) THEN
              CALL SETER ('POINTS - ERROR EXIT FROM GQPMI',8,1)
              RETURN
            END IF
            CALL GSPMI (MAX(-IC,1))
          ELSE
            CALL GQMK (IE,IN)
            IF (IE.NE.0) THEN
              CALL SETER ('POINTS - ERROR EXIT FROM GQMK',9,1)
              RETURN
            END IF
            CALL GSMK (MAX(-IC,1))
          END IF
        ELSE
          CALL GQTXAL (IE,IH,IV)
          IF (IE.NE.0) THEN
            CALL SETER ('POINTS - ERROR EXIT FROM GQTXAL',10,1)
            RETURN
          END IF
          CALL GSTXAL (2,3)
        END IF
C
C Loop through the points by nines.
C
        DO 104 IP=1,NP,9
C
C Fill the little point coordinate arrays with up to ten values,
C converting them from the user system to the fractional system.
C
          NQ=MIN(10,NP-IP+1)
          MQ=MIN(9,NQ)
          DO 102 IQ=1,NQ
            QX(IQ)=CUFX(PX(IP+IQ-1))
            QY(IQ)=CUFY(PY(IP+IQ-1))
  102     CONTINUE
C
C Change the SET call to allow the use of fractional coordinates.
C
          CALL SET (F1,F2,F3,F4,F1,F2,F3,F4,1)
          IF (ICFELL('POINTS',11).NE.0) RETURN
C
C Crank out either a polymarker or a set of characters.
C
          IF (IC.LE.0) THEN
            CALL GPM (MQ,QX,QY)
          ELSE
            DO 103 IQ=1,MQ
              CHRTMP = CHAR(IC)
              CALL GTX (QX(IQ),QY(IQ),CHRTMP)
  103       CONTINUE
          END IF
          IF (IL.NE.0.AND.NQ.GE.2) CALL GPL (NQ,QX,QY)
C
C Put the SET parameters back the way they were.
C
          CALL SET (F1,F2,F3,F4,F5,F6,F7,F8,LL)
          IF (ICFELL('POINTS',12).NE.0) RETURN
C
  104   CONTINUE
C
C Finally, we put either the polymarker index or the text alignment
C back the way it was.
C
        IF (IC.LE.0) THEN
          IF (LA(4).EQ.0) THEN
            CALL GSPMI (IN)
          ELSE
            CALL GSMK (IN)
          END IF
        ELSE
          CALL GSTXAL (IH,IV)
        END IF
C
      END IF
C
C Update the pen position.
C
      CALL FRSTPT (PX(NP),PY(NP))
      IF (ICFELL('POINTS',13).NE.0) RETURN
C
C Done.
C
      RETURN
C
      END

C
C	$Id: garg.f,v 1.4 2008-07-27 00:59:04 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GARG(ANUM,STRING,MAXSTR,STAT)
C
C  GET THE REQUESTED ARGUMENT
C
C  THERE ARE TWO WAYS TO DO THIS
C       1.USE A COMMAND LINE ARGUMENT EXTRACTOR WHICH IS SYSTEM
C         DEPENDENT AND MUST BE IMPLEMENTED AT EACH SITE.
C         IF THIS IS DONE THEN THE VARIABLE METIPT MUST BE SET TO
C         FALSE SO THIS SUBROUTINE WILL USE IT.
C       2.THE FORTRAN 77 READ STATEMENT
C
C  THE ARGUMENTS ARE
C       IN COMMAND LINE MODE THERE CAN BE NONE, ONE, OR TWO
C               0-THE F77 READ IS USED TO GET THE METAFILE NAME
C               1-THE METAFILE IS NAMED ON THE COMMAND LINE
C               2-THE RECORD NUMBER OF A FRAME TO BE PLOTTED IS GIVEN
C                       FOLLOWED BY THE NAME OF THE METAFILE TO USE
C       IN F77 MODE ONLY THE METAFILE NAME GIVEN
C
C  INPUT
C       ANUM-THE ARGUMENT NUMBER REQUESTED
C       MAXSTR-THE MAXIMUM NUMBER OF CHARACTERS TO TRANSFER
C  OUTPUT
C       STRING-CHARACTER STRING CONTAINING THE ARGUMENT
C       STAT-THE STATUS FLAG
C               0-ALL WENT OK
C               1-REQUESTED ARGUMENT DOES NOT EXIST
C               2-F77 READ USED (ONLY FILE NAME CAN BE GIVEN IN THIS MODE)
C
      COMMON/TRINOT/ IPTR, MBUFOT, MAXBYT, DEVUNT, METUNT,
     1          METIPT, ERRUNT, FNTUNT
      INTEGER MAXCNT
      PARAMETER (MAXCNT=200)
      INTEGER IPTR, MBUFOT(MAXCNT), MAXBYT, DEVUNT, METUNT, ERRUNT,
     1        FNTUNT
      LOGICAL METIPT
C
      INTEGER ANUM, MAXSTR, STAT
      CHARACTER*1 STRING(MAXSTR)
      INTEGER II, IARGCT, KK
C
C  INIT STRING TO BLANKS
C
      DO 11 II=1,MAXSTR
 11     STRING(II) = ' '
C
C  TEST IF F77 OR COMMAND LINE MODE
C
      IF (METIPT) THEN
C
C       PORTABLE FLAG ON READ FROM TERMINAL
C
        CALL WRITIT(' ENTER NAME OF METAFILE', 23)
        CALL READIT(STRING,MAXSTR)
        STAT = 2
      ELSE
C
C*******************************************************************
C  IF YOUR INSTALLATION HAS A COMMAND LINE READER THEN THIS IS WHERE
C  THE SUBROUTINE CALLS OCCUR. THE FUNCTION IARGCT RETURNS THE NUMBER
C  OF ARGUMENTS PASSED TO THE TRANSLATOR (1 PATH NAME  2 PATH NAME AND
C  RECORD START POINT).
C******************************************************************
C
C       COMMAND LINE READER TO BE USED IF THERE ARE ARGUMENTS
C
        IF (IARGCT(KK) .EQ. 0) THEN
C
C               NOTHING ON THE COMMAND LINE SO REQUEST THE FILE NAME
C
                CALL WRITIT(' ENTER NAME OF METAFILE', 23)
                CALL READIT(STRING,MAXSTR)
                STAT = 2
        ELSE
C
C               TEST IF THE REQUESTED COMMAND LINE ARG EXISTS
C
                IF (IARGCT(KK).GE.ANUM) THEN
C
C                       ALL OK SO GET IT
C
                        CALL ARGGET(ANUM,STRING)
                        STAT = 0
                ELSE
C
C                       ARG DOES NOT EXIST
C
                        STAT = 1
                END IF
        END IF
      END IF
C
      RETURN
C
      END

      SUBROUTINE CTGSY2( TRANS, IJOB, M, N, A, LDA, B, LDB, C, LDC, D,
     $                   LDD, E, LDE, F, LDF, SCALE, RDSUM, RDSCAL,
     $                   INFO )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          TRANS
      INTEGER            IJOB, INFO, LDA, LDB, LDC, LDD, LDE, LDF, M, N
      REAL               RDSCAL, RDSUM, SCALE
*     ..
*     .. Array Arguments ..
      COMPLEX            A( LDA, * ), B( LDB, * ), C( LDC, * ),
     $                   D( LDD, * ), E( LDE, * ), F( LDF, * )
*     ..
*
*  Purpose
*  =======
*
*  CTGSY2 solves the generalized Sylvester equation
*
*              A * R - L * B = scale *   C               (1)
*              D * R - L * E = scale * F
*
*  using Level 1 and 2 BLAS, where R and L are unknown M-by-N matrices,
*  (A, D), (B, E) and (C, F) are given matrix pairs of size M-by-M,
*  N-by-N and M-by-N, respectively. A, B, D and E are upper triangular
*  (i.e., (A,D) and (B,E) in generalized Schur form).
*
*  The solution (R, L) overwrites (C, F). 0 <= SCALE <= 1 is an output
*  scaling factor chosen to avoid overflow.
*
*  In matrix notation solving equation (1) corresponds to solve
*  Zx = scale * b, where Z is defined as
*
*         Z = [ kron(In, A)  -kron(B', Im) ]             (2)
*             [ kron(In, D)  -kron(E', Im) ],
*
*  Ik is the identity matrix of size k and X' is the transpose of X.
*  kron(X, Y) is the Kronecker product between the matrices X and Y.
*
*  If TRANS = 'C', y in the conjugate transposed system Z'y = scale*b
*  is solved for, which is equivalent to solve for R and L in
*
*              A' * R  + D' * L   = scale *  C           (3)
*              R  * B' + L  * E'  = scale * -F
*
*  This case is used to compute an estimate of Dif[(A, D), (B, E)] =
*  = sigma_min(Z) using reverse communicaton with CLACON.
*
*  CTGSY2 also (IJOB >= 1) contributes to the computation in CTGSYL
*  of an upper bound on the separation between to matrix pairs. Then
*  the input (A, D), (B, E) are sub-pencils of two matrix pairs in
*  CTGSYL.
*
*  Arguments
*  =========
*
*  TRANS   (input) CHARACTER
*          = 'N', solve the generalized Sylvester equation (1).
*          = 'T': solve the 'transposed' system (3).
*
*  IJOB    (input) INTEGER
*          Specifies what kind of functionality to be performed.
*          =0: solve (1) only.
*          =1: A contribution from this subsystem to a Frobenius
*              norm-based estimate of the separation between two matrix
*              pairs is computed. (look ahead strategy is used).
*          =2: A contribution from this subsystem to a Frobenius
*              norm-based estimate of the separation between two matrix
*              pairs is computed. (SGECON on sub-systems is used.)
*          Not referenced if TRANS = 'T'.
*
*  M       (input) INTEGER
*          On entry, M specifies the order of A and D, and the row
*          dimension of C, F, R and L.
*
*  N       (input) INTEGER
*          On entry, N specifies the order of B and E, and the column
*          dimension of C, F, R and L.
*
*  A       (input) COMPLEX array, dimension (LDA, M)
*          On entry, A contains an upper triangular matrix.
*
*  LDA     (input) INTEGER
*          The leading dimension of the matrix A. LDA >= max(1, M).
*
*  B       (input) COMPLEX array, dimension (LDB, N)
*          On entry, B contains an upper triangular matrix.
*
*  LDB     (input) INTEGER
*          The leading dimension of the matrix B. LDB >= max(1, N).
*
*  C       (input/ output) COMPLEX array, dimension (LDC, N)
*          On entry, C contains the right-hand-side of the first matrix
*          equation in (1).
*          On exit, if IJOB = 0, C has been overwritten by the solution
*          R.
*
*  LDC     (input) INTEGER
*          The leading dimension of the matrix C. LDC >= max(1, M).
*
*  D       (input) COMPLEX array, dimension (LDD, M)
*          On entry, D contains an upper triangular matrix.
*
*  LDD     (input) INTEGER
*          The leading dimension of the matrix D. LDD >= max(1, M).
*
*  E       (input) COMPLEX array, dimension (LDE, N)
*          On entry, E contains an upper triangular matrix.
*
*  LDE     (input) INTEGER
*          The leading dimension of the matrix E. LDE >= max(1, N).
*
*  F       (input/ output) COMPLEX array, dimension (LDF, N)
*          On entry, F contains the right-hand-side of the second matrix
*          equation in (1).
*          On exit, if IJOB = 0, F has been overwritten by the solution
*          L.
*
*  LDF     (input) INTEGER
*          The leading dimension of the matrix F. LDF >= max(1, M).
*
*  SCALE   (output) REAL
*          On exit, 0 <= SCALE <= 1. If 0 < SCALE < 1, the solutions
*          R and L (C and F on entry) will hold the solutions to a
*          slightly perturbed system but the input matrices A, B, D and
*          E have not been changed. If SCALE = 0, R and L will hold the
*          solutions to the homogeneous system with C = F = 0.
*          Normally, SCALE = 1.
*
*  RDSUM   (input/output) REAL
*          On entry, the sum of squares of computed contributions to
*          the Dif-estimate under computation by CTGSYL, where the
*          scaling factor RDSCAL (see below) has been factored out.
*          On exit, the corresponding sum of squares updated with the
*          contributions from the current sub-system.
*          If TRANS = 'T' RDSUM is not touched.
*          NOTE: RDSUM only makes sense when CTGSY2 is called by
*          CTGSYL.
*
*  RDSCAL  (input/output) REAL
*          On entry, scaling factor used to prevent overflow in RDSUM.
*          On exit, RDSCAL is updated w.r.t. the current contributions
*          in RDSUM.
*          If TRANS = 'T', RDSCAL is not touched.
*          NOTE: RDSCAL only makes sense when CTGSY2 is called by
*          CTGSYL.
*
*  INFO    (output) INTEGER
*          On exit, if INFO is set to
*            =0: Successful exit
*            <0: If INFO = -i, input argument number i is illegal.
*            >0: The matrix pairs (A, D) and (B, E) have common or very
*                close eigenvalues.
*
*  Further Details
*  ===============
*
*  Based on contributions by
*     Bo Kagstrom and Peter Poromaa, Department of Computing Science,
*     Umea University, S-901 87 Umea, Sweden.
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ZERO, ONE
      INTEGER            LDZ
      PARAMETER          ( ZERO = 0.0E+0, ONE = 1.0E+0, LDZ = 2 )
*     ..
*     .. Local Scalars ..
      LOGICAL            NOTRAN
      INTEGER            I, IERR, J, K
      REAL               SCALOC
      COMPLEX            ALPHA
*     ..
*     .. Local Arrays ..
      INTEGER            IPIV( LDZ ), JPIV( LDZ )
      COMPLEX            RHS( LDZ ), Z( LDZ, LDZ )
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           CAXPY, CGESC2, CGETC2, CSCAL, CLATDF, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          CMPLX, CONJG, MAX
*     ..
*     .. Executable Statements ..
*
*     Decode and test input parameters
*
      INFO = 0
      IERR = 0
      NOTRAN = LSAME( TRANS, 'N' )
      IF( .NOT.NOTRAN .AND. .NOT.LSAME( TRANS, 'C' ) ) THEN
         INFO = -1
      ELSE IF( ( IJOB.LT.0 ) .OR. ( IJOB.GT.2 ) ) THEN
         INFO = -2
      ELSE IF( M.LE.0 ) THEN
         INFO = -3
      ELSE IF( N.LE.0 ) THEN
         INFO = -4
      ELSE IF( LDA.LT.MAX( 1, M ) ) THEN
         INFO = -5
      ELSE IF( LDB.LT.MAX( 1, N ) ) THEN
         INFO = -8
      ELSE IF( LDC.LT.MAX( 1, M ) ) THEN
         INFO = -10
      ELSE IF( LDD.LT.MAX( 1, M ) ) THEN
         INFO = -12
      ELSE IF( LDE.LT.MAX( 1, N ) ) THEN
         INFO = -14
      ELSE IF( LDF.LT.MAX( 1, M ) ) THEN
         INFO = -16
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'CTGSY2', -INFO )
         RETURN
      END IF
*
      IF( NOTRAN ) THEN
*
*        Solve (I, J) - system
*           A(I, I) * R(I, J) - L(I, J) * B(J, J) = C(I, J)
*           D(I, I) * R(I, J) - L(I, J) * E(J, J) = F(I, J)
*        for I = M, M - 1, ..., 1; J = 1, 2, ..., N
*
         SCALE = ONE
         SCALOC = ONE
         DO 30 J = 1, N
            DO 20 I = M, 1, -1
*
*              Build 2 by 2 system
*
               Z( 1, 1 ) = A( I, I )
               Z( 2, 1 ) = D( I, I )
               Z( 1, 2 ) = -B( J, J )
               Z( 2, 2 ) = -E( J, J )
*
*              Set up right hand side(s)
*
               RHS( 1 ) = C( I, J )
               RHS( 2 ) = F( I, J )
*
*              Solve Z * x = RHS
*
               CALL CGETC2( LDZ, Z, LDZ, IPIV, JPIV, IERR )
               IF( IERR.GT.0 )
     $            INFO = IERR
               IF( IJOB.EQ.0 ) THEN
                  CALL CGESC2( LDZ, Z, LDZ, RHS, IPIV, JPIV, SCALOC )
                  IF( SCALOC.NE.ONE ) THEN
                     DO 10 K = 1, N
                        CALL CSCAL( M, CMPLX( SCALOC, ZERO ), C( 1, K ),
     $                              1 )
                        CALL CSCAL( M, CMPLX( SCALOC, ZERO ), F( 1, K ),
     $                              1 )
   10                CONTINUE
                     SCALE = SCALE*SCALOC
                  END IF
               ELSE
                  CALL CLATDF( IJOB, LDZ, Z, LDZ, RHS, RDSUM, RDSCAL,
     $                         IPIV, JPIV )
               END IF
*
*              Unpack solution vector(s)
*
               C( I, J ) = RHS( 1 )
               F( I, J ) = RHS( 2 )
*
*              Substitute R(I, J) and L(I, J) into remaining equation.
*
               IF( I.GT.1 ) THEN
                  ALPHA = -RHS( 1 )
                  CALL CAXPY( I-1, ALPHA, A( 1, I ), 1, C( 1, J ), 1 )
                  CALL CAXPY( I-1, ALPHA, D( 1, I ), 1, F( 1, J ), 1 )
               END IF
               IF( J.LT.N ) THEN
                  CALL CAXPY( N-J, RHS( 2 ), B( J, J+1 ), LDB,
     $                        C( I, J+1 ), LDC )
                  CALL CAXPY( N-J, RHS( 2 ), E( J, J+1 ), LDE,
     $                        F( I, J+1 ), LDF )
               END IF
*
   20       CONTINUE
   30    CONTINUE
      ELSE
*
*        Solve transposed (I, J) - system:
*           A(I, I)' * R(I, J) + D(I, I)' * L(J, J) = C(I, J)
*           R(I, I) * B(J, J) + L(I, J) * E(J, J)   = -F(I, J)
*        for I = 1, 2, ..., M, J = N, N - 1, ..., 1
*
         SCALE = ONE
         SCALOC = ONE
         DO 80 I = 1, M
            DO 70 J = N, 1, -1
*
*              Build 2 by 2 system Z'
*
               Z( 1, 1 ) = CONJG( A( I, I ) )
               Z( 2, 1 ) = -CONJG( B( J, J ) )
               Z( 1, 2 ) = CONJG( D( I, I ) )
               Z( 2, 2 ) = -CONJG( E( J, J ) )
*
*
*              Set up right hand side(s)
*
               RHS( 1 ) = C( I, J )
               RHS( 2 ) = F( I, J )
*
*              Solve Z' * x = RHS
*
               CALL CGETC2( LDZ, Z, LDZ, IPIV, JPIV, IERR )
               IF( IERR.GT.0 )
     $            INFO = IERR
               CALL CGESC2( LDZ, Z, LDZ, RHS, IPIV, JPIV, SCALOC )
               IF( SCALOC.NE.ONE ) THEN
                  DO 40 K = 1, N
                     CALL CSCAL( M, CMPLX( SCALOC, ZERO ), C( 1, K ),
     $                           1 )
                     CALL CSCAL( M, CMPLX( SCALOC, ZERO ), F( 1, K ),
     $                           1 )
   40             CONTINUE
                  SCALE = SCALE*SCALOC
               END IF
*
*              Unpack solution vector(s)
*
               C( I, J ) = RHS( 1 )
               F( I, J ) = RHS( 2 )
*
*              Substitute R(I, J) and L(I, J) into remaining equation.
*
               DO 50 K = 1, J - 1
                  F( I, K ) = F( I, K ) + RHS( 1 )*CONJG( B( K, J ) ) +
     $                        RHS( 2 )*CONJG( E( K, J ) )
   50          CONTINUE
               DO 60 K = I + 1, M
                  C( K, J ) = C( K, J ) - CONJG( A( I, K ) )*RHS( 1 ) -
     $                        CONJG( D( I, K ) )*RHS( 2 )
   60          CONTINUE
*
   70       CONTINUE
   80    CONTINUE
      END IF
      RETURN
*
*     End of CTGSY2
*
      END

C     
C     $Id: mp05f.f,v 1.5 2010-03-15 22:49:24 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C                Copyright (C)  1995                                   C
C        University Corporation for Atmospheric Research               C
C                All Rights Reserved                                   C
C                                                                      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C
C      File:            mp05f.f
C
C      Author:          Mary Haley
C                       National Center for Atmospheric Research
C                       PO 3000, Boulder, Colorado
C
C      Date:            Mon Oct 16 16:15:09 MDT 1995
C
C   Description:  Draws each of the ten map projections, with and 
C                 without fills.
C
      parameter(NMAP=10)
      external NhlFAppClass
      external NhlFCairoWindowWorkstationClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFMapPlotClass
      external NhlFtextItemClass

      integer appid,wid,mapid(NMAP),txid
      integer rlist,i
      character*7  wks_type
      character*20 mapstr
C
C Default is to display output to an X workstation
C
      wks_type = "x11"
C
C Initialize the high level utility library
C
      call NhlFInitialize
C
C Create an application object.
C
      call NhlFRLCreate(rlist,'SETRL')
      call NhlFRLClear(rlist)
      call NhlFRLSetstring(rlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'mp05',NhlFAppClass,0,rlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkMetaName','./mp05f.ncgm',ierr)
         call NhlFCreate(wid,'mp05Work',NhlFNcgmWorkstationClass,0,
     1        rlist,ierr)
      else  if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X workstation
C
         call NhlFRLClear(rlist)
         call NhlFRLSetinteger(rlist,'wkPause',1,ierr)
         call NhlFCreate(wid,'mp05Work',
     1     NhlFCairoWindowWorkstationClass,0,
     1     rlist,ierr)
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PostScript workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPSFileName','./mp05f.ps',ierr)
         call NhlFCreate(wid,'mp05Work',NhlFPSWorkstationClass,0,
     1        rlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPDFFileName','./mp05f.pdf',ierr)
         call NhlFCreate(wid,'mp05Work',NhlFPDFWorkstationClass,0,
     1        rlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF object.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetstring(rlist,'wkFileName','./mp05f',ierr)
         call NhlFCreate(wid,'mp05Work',
     1        NhlFCairoPSPDFWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG object.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetstring(rlist,'wkFileName','./mp05f',ierr)
         call NhlFCreate(wid,'mp05Work',
     1        NhlFCairoImageWorkstationClass,0,rlist,ierr)
      endif
C
C Create a TextItem object.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetFloat(rlist,'vpXF',0.2,ierr)
      call NhlFRLSetFloat(rlist,'vpYF',0.95,ierr)
      call NhlFRLSetInteger(rlist,'txFont',26,ierr)
      call NhlFRLSetString(rlist,'txString',
     +     "Maximal-area projections of all types",ierr)
      call NhlFCreate(txid,'TextItem',NhlFtextItemClass,wid,rlist,ierr)
C
C Draw the default MapPlot object
C
      do 10 i=1,NMAP
         write(mapstr,5)i-1
 5       format('map',i1)
         call NhlFRLClear(rlist)
         call NhlFCreate(mapid(i),mapstr,NhlFMapPlotClass,wid,rlist,
     +        ierr)
         call NhlFDraw(mapid(i),ierr)
 10   continue
      call NhlFDraw(txid,ierr)
      call NhlFFrame(wid,ierr)
C
C Draw each projection individually and fill the countries.
C
      do 20 i=1,NMAP
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'mpEllipticalBoundary','True',ierr)
         call NhlFRLSetString(rlist,'mpFillOn','True',ierr)
         call NhlFRLSetString(rlist,'mpLabelsOn','False',ierr)
         call NhlFRLSetString(rlist,'mpGridMaskMode','MaskNotOcean',
     +        ierr)
         call NhlFRLSetFloat(rlist,'mpGridLineThicknessF',1.1,ierr)
         call NhlFRLSetFloat(rlist,'vpXF',0.1,ierr)
         call NhlFRLSetFloat(rlist,'vpYF',0.9,ierr)
         call NhlFRLSetFloat(rlist,'vpWidthF',0.8,ierr)
         call NhlFRLSetFloat(rlist,'vpHeightF',0.8,ierr)
         call NhlFSetValues(mapid(i),rlist,ierr)
         call NhlFDraw(mapid(i),ierr)
         call NhlFFrame(wid,ierr)
 20   continue
C
C Destroy the objects created, close the HLU library and exit.
C
      call NhlFDestroy(wid,ierr)
      call NhlFClose
      stop
      end

C
C $Id: mdlbln.f,v 1.9 2008-09-18 00:42:17 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MDLBLN (XCOP,YCOP,XCOQ,YCOQ,OFFX,OFFY,SIZE,ANGL,CENT)
C
        REAL XCOP,YCOP,XCOQ,YCOQ,OFFX,OFFY,SIZE,ANGL,CENT
C
        DOUBLE PRECISION PLAT,PLON,QLAT,QLON,DNCE,RLAT,RLON,UCOR,VCOR
C
C This routine attempts to put tick marks and longitude labels along an
C arbitrary line on a map drawn by EZMAP.  XCOP, YCOP, XCOQ, and YCOQ
C are the X and Y coordinates, in the fractional system, of two points,
C P and Q.  The longitude labels will be placed at positions between P
C and Q where the longitude is a multiple of some "nice" value.  OFFX
C and OFFY specify fractional-system X and Y components of an offset
C vector from a point to be labeled to a point relative to which the
C label will be positioned.  SIZE is the desired character width, in
C the fractional system.  ANGL is the angle, in degrees, at which the
C label is to be written.  CENT specifies what part of the label is to
C be placed on the end of the offset vector; CENT = -1. means the center
C of the left end of the label, CENT = 0. means the center of the whole
C label, and CENT = +1. means the center of the right end of the label.
C
C Care should be taken to choose points P and Q such that the value of
C longitude is monotonically increasing or decreasing along the line
C from P to Q.
C
        CHARACTER*128 CHRS
C
C Declare other local variables.
C
        INTEGER       I,IPLN,IQLN,NCHR
C
C Get the latitude and longitude of P.
C
        CALL MDPTRI (DBLE(CFUX(XCOP)),DBLE(CFUY(YCOP)),PLAT,PLON)
        IF (PLAT.EQ.1.D12) RETURN
C
C Get the latitude and longitude of Q.
C
        CALL MDPTRI (DBLE(CFUX(XCOQ)),DBLE(CFUY(YCOQ)),QLAT,QLON)
        IF (QLAT.EQ.1.D12) RETURN
C
C Get the latitude and longitude of a point R that is 1/100th of the
C way along the straight line from P to Q.
C
        CALL MDPTRI (DBLE(CFUX((.99*XCOP+.01*XCOQ))),
     +               DBLE(CFUY((.99*YCOP+.01*YCOQ))),RLAT,RLON)
        IF (RLAT.EQ.1.D12) RETURN
C
C Adjust the longitudes to make sure that the labels go the proper
C way around the earth.
C
        IF (ABS(PLON-RLON).GT.180.) RLON=RLON+SIGN(360.D0,PLON-RLON)
        IF (ABS(PLON-QLON).LT.1D-6.OR.
     +    SIGN(1.D0,PLON-QLON).NE.SIGN(1.D0,PLON-RLON)) QLON=QLON+360.D0
C
C Compute a "nice" longitude interval to use.
C
        CALL MDGNIN (ABS(QLON-PLON)/4.D0,DNCE)
        IF (DNCE.EQ.0.D0) RETURN
C
C Compute limits to be used in the labeling loop.
C
        IPLN=INT((PLON+180.D0)/DNCE)
        IQLN=INT((QLON+180.D0)/DNCE)
C
C Loop to generate the labels.
C
        DO 101 I=MIN(IPLN,IQLN)-1,MAX(IPLN,IQLN)+1
          RLON=DBLE(I)*DNCE-180.D0
          IF (RLON.GT.MIN(PLON,QLON)-DNCE/100.D0.AND.
     +        RLON.LT.MAX(PLON,QLON)+DNCE/100.D0) THEN
            CALL MDILON (PLAT,PLON,DBLE(CFUX(XCOP)),DBLE(CFUY(YCOP)),
     +                   QLAT,QLON,DBLE(CFUX(XCOQ)),DBLE(CFUY(YCOQ)),
     +                   RLON,UCOR,VCOR)
            CALL MDLOCH (RLON,CHRS,NCHR)
            CALL PLCHHQ (CFUX(CUFX(REAL(UCOR))+OFFX),
     +                   CFUY(CUFY(REAL(VCOR))+OFFY),
     +                   CHRS(1:NCHR),SIZE,ANGL,CENT)
          END IF
  101   CONTINUE
C
C Done.
C
        RETURN
C
      END

        PROGRAM CPEX05
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
        PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Declare an array to hold the data to be contoured.
C
        DIMENSION ZDAT(53,37)
C
C Declare the required real and integer workspaces.
C
        DIMENSION RWRK(5000),IWRK(1000)
C
C Declare an array to hold an area map.
C
        DIMENSION IAMA(40000)
C
C Declare the arrays needed by ARSCAM for x/y coordinates.
C
        DIMENSION XCRA(1000),YCRA(1000)
C
C Declare the arrays needed by ARSCAM for area and group identifiers.
C
        DIMENSION IARA(10),IGRA(10)
C
C Declare arrays to hold the list of indices and the list of labels
C required by the label-bar routine.
C
        DIMENSION LIND(20)
        CHARACTER*2 LLBS(21)
C
C Declare an array to hold the GKS "aspect source flags".
C
        DIMENSION IASF(13)
C
C Declare the routine which does the shading of areas from an area map.
C
        EXTERNAL SHADAM
C
C Define the list of indices and the list of labels required by the
C label-bar routine.
C
        DATA LIND / 0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19 /
C
        DATA LLBS / '0',' ','1',' ','2',' ','3',' ','4',' ','5',
     +              ' ','6',' ','7',' ','8',' ','9',' ','10' /
C
C Initialize the values in the aspect-source-flag array.
C
        DATA IASF / 13*1 /
C
C Open GKS.
C
        CALL GOPKS (IERRF, ISZDM)
        CALL GOPWK (IWKID, LUNIT, IWTYPE)
        CALL GACWK (IWKID)
C
C Turn off the clipping indicator.
C
        CALL GSCLIP (0)
C
C Set all the GKS aspect source flags to "individual".
C
        CALL GSASF (IASF)
C
C Generate a relatively smooth array of test data, with values ranging
C from 0 to 10.
C
        CALL GENDAT (ZDAT,53,53,37,10,10,0.,10.)
C
C Initialize the software fill package to do the desired type of fill.
C
        CALL SFSETI ('TYPE OF FILL',-4)
        CALL SFSETI ('ANGLE OF FILL LINES',15)
        CALL SFSETR ('SPACING OF FILL LINES',.000625)
C
C Turn off line labels.
C
        CALL CPSETI ('LLP - LINE LABEL POSITIONING',0)
C
C Turn off the drawing of high and low labels.
C
        CALL CPSETC ('HLT - HIGH/LOW LABEL TEXT',' ')
C
C Turn on the drawing of the grid edge ("contour line number -1") and
C thicken it somewhat.
C
        CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',-1)
        CALL CPSETI ('CLU - CONTOUR LEVEL USE FLAG',1)
        CALL CPSETR ('CLL - CONTOUR LEVEL LINE WIDTH',2.)
C
C Turn off the informational label.
C
        CALL CPSETC ('ILT - INFORMATIONAL LABEL TEXT',' ')
C
C Force the use of contour lines at the values 1, 2, 3, ... 9 and
C values half-way between.  Arrange for the areas between contour lines
C to be shaded.
C
        CALL CPSETI ('CLS - CONTOUR LEVEL SELECTION',0)
C
        CALL CPSETI ('NCL - NUMBER OF CONTOUR LEVELS',19)
C
        DO 101 I=1,19
          CALL CPSETI ('PAI - PARAMETER ARRAY IDENTIFIER',I)
          CALL CPSETR ('CLV - CONTOUR LEVEL VALUE',REAL(I)/2.)
          CALL CPSETI ('CLU - CONTOUR LEVEL USE',1)
          CALL CPSETR ('CLL - CONTOUR LEVEL LINE WIDTH',2.)
          CALL CPSETI ('AIA - AREA IDENTIFIER ABOVE LINE',I+1)
          CALL CPSETI ('AIB - AREA IDENTIFIER BELOW LINE',I)
  101   CONTINUE
C
C Force the plot into the upper portion of the frame.
C
        CALL CPSETR ('VPB - VIEWPORT BOTTOM',.25)
C
C Initialize the drawing of the contour plot.
C
        CALL CPRECT (ZDAT,53,53,37,RWRK,5000,IWRK,1000)
C
C Draw the contour plot.
C
        CALL ARINAM (IAMA,40000)
        CALL CPCLDR (ZDAT,RWRK,IWRK)
        CALL CPCLAM (ZDAT,RWRK,IWRK,IAMA)
        CALL ARSCAM (IAMA,XCRA,YCRA,1000,IARA,IGRA,10,SHADAM)
C
C Put a horizontal label bar at the bottom of the frame.
C
        CALL LBSETR ('WBL - WIDTH OF BOX LINES',2.)
        CALL LBLBAR (0,.05,.95,.15,.25,20,1.,.5,LIND,0,LLBS,21,1)
C
C Compute and print statistics for the plot and label it.
C
        CALL CAPSAP ('EXAMPLE 5',IAMA,40000)
        CALL LABTOP ('EXAMPLE 5',.017)
C
C Put a boundary line at the edge of the plotter frame.
C
        CALL BNDARY
C
C Advance the frame.
C
        CALL FRAME
C
C Close GKS.
C
        CALL GDAWK (IWKID)
        CALL GCLWK (IWKID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END


      SUBROUTINE SHADAM (XCS,YCS,NCS,IAI,IAG,NAI)
C
C This version of SHADAM shades the area-map polygon whose edge is
C defined by the points ((XCS(I),YCS(I)),I=1,NCS) if and only, relative
C to edge group 3, its area identifier is between 1 and 20.  The density
C of the shading increases with the area identifier.
C
        DIMENSION XCS(*),YCS(*),IAI(*),IAG(*)
C
C Declare the workspaces required by SFSGFA.
C
        DIMENSION DST(1100),IND(1200)
C
C Turn off shading.
C
        ISH=0
C
C If the area identifier for group 3 is in the right range, turn on
C shading.
C
        DO 101 I=1,NAI
          IF (IAG(I).EQ.3.AND.IAI(I).GE.1.AND.IAI(I).LE.20) ISH=IAI(I)
  101   CONTINUE
C
C If shading is turned on, shade the area.  The last point of the
C edge is redundant and may be omitted.
C
        IF (ISH.NE.0) CALL SFSGFA (XCS,YCS,NCS,DST,1100,IND,1200,ISH-1)
C
C Done.
C
        RETURN
C
      END

      PROGRAM WMEX04
C
C  Examples of parameter control of fronts.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
      PARAMETER (NS=2)
      DIMENSION XS(NS),YS(NS)
      DATA XS/ 0.10, 0.90/ 
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C  Define a color table.
C
      CALL GSCR(IWKID, 0, 1.0, 1.0, 1.0)
      CALL GSCR(IWKID, 1, 0.0, 0.0, 0.0)
      CALL GSCR(IWKID, 2, 1.0, 0.0, 0.0)
      CALL GSCR(IWKID, 3, 0.0, 0.0, 1.0)
      CALL GSCR(IWKID, 4, 0.4, 0.0, 0.4)
C
C  Plot title.
C
      CALL PLCHHQ(0.50,0.94,
     + ':F26:Parameter control of front attributes', 0.03,0.,0.)
C
C  Various fronts with different attributes.
C
      CALL PCSETI('CC',4)
      FSIZE = .021
      YS(1) = .76
      YS(2) = .76
      CALL PCSETC('FC','%')
      CALL PLCHHQ(XS(1),YS(1)+.06,'%F22%Starting with FRO=''STA'', WFC=2
     + (red), CFC=3 (blue):',FSIZE,0.,-1.)
      CALL WMSETC('FRO','STA')
      CALL WMSETI('WFC',2)
      CALL WMSETI('CFC',3)
      CALL WMDRFT(NS,XS,YS)
C
      YS(1) = .60
      YS(2) = .60
      CALL PLCHHQ(XS(1),YS(1)+.06,'%F22%then setting BEG=0., END=.05, BE
     +T=.03 gives:',FSIZE,0.,-1.)
      CALL WMSETR('BEG',0.00)
      CALL WMSETR('END',0.05)
      CALL WMSETR('BET',0.03)
      CALL WMDRFT(NS,XS,YS)
C
      YS(1) = .44
      YS(2) = .44
      CALL PLCHHQ(XS(1),YS(1)+.06,'%F22%then setting NMS=5 and STY=-1,2,       
     +1,-2,2 gives:',FSIZE,0.,-1.)
      CALL WMSETI('NMS',5)
      CALL WMSETI('PAI',1)
      CALL WMSETI('STY',-1)
      CALL WMSETI('PAI',2)
      CALL WMSETI('STY',2)
      CALL WMSETI('PAI',3)
      CALL WMSETI('STY',1)
      CALL WMSETI('PAI',4)
      CALL WMSETI('STY',-2)
      CALL WMSETI('PAI',5)
      CALL WMSETI('STY',2)
      CALL WMDRFT(NS,XS,YS)
C
      YS(1) = .27
      YS(2) = .27
      CALL PLCHHQ(XS(1),YS(1)+.07,'%F22%then setting SWI=.05 and LIN=12.
     + gives:',FSIZE,0.,-1.)
      CALL WMSETR('SWI',0.05)
      CALL WMSETR('LIN',12.)
      CALL WMDRFT(NS,XS,YS)
C
      YS(1) = .10
      YS(2) = .10
      CALL PLCHHQ(XS(1),YS(1)+.07,'%F22%then setting REV=1 gives:',
     +            .022,0.,-1.)
      CALL WMSETI('REV',1)
      CALL WMDRFT(NS,XS,YS)
      CALL FRAME
C
      CALL GDAWK(IWKID)
      CALL GCLWK(IWKID)
      CALL GCLKS
      STOP
C
      END

C
C	$Id: gswn.f,v 1.9 2008-07-27 00:21:02 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GSWN (TNR,XMIN,XMAX,YMIN,YMAX)
C
C  SET WINDOW
C
      INTEGER ESWN
      PARAMETER (ESWN=49)
C
      include 'gkscom.h'
C
      INTEGER TNR
      REAL XMIN,XMAX,YMIN,YMAX
      DATA IFRST/0/
C
C  Check if GKS is in the proper state.
C
      CALL GZCKST(8,ESWN,IER)
      IF (IER .NE. 0) RETURN
C
C  Check that the normalization transformation number is valid.
C
      IF (TNR.LT.1 .OR. TNR.GT.MNT) THEN
        ERS = 1
        CALL GERHND(50,ESWN,ERF)
        ERS = 0
        RETURN
      ENDIF
C
C  Check that the rectangle definition is valid.
C
      IF (XMAX.LE.XMIN .OR. YMAX.LE.YMIN) THEN
        IF (IFRST .EQ. 0) THEN
          CALL GERHND(-113,ESWN,ERF)
        ENDIF
      ENDIF
C
C  Set the normalization transformation window in the GKS state list.
C
      INR = TNR+1
      NTWN(INR,1) = XMIN
      NTWN(INR,2) = XMAX
      NTWN(INR,3) = YMIN
      NTWN(INR,4) = YMAX
C
C  Re-establish the character height and up vector, and pattern size 
C  and reference point if the normalization transformation number TNR 
C  is the current one.
C
      CALL GQCNTN(IER,ICUR)
      IF (TNR.EQ.ICUR) THEN
        CALL GSCHH(CCHH)
        CALL GSCHUP(CCHUP(1),CCHUP(2))
C
C  Pattern size and pattern reference point currently not implemented.
C
C       CALL GSPA(CPA(1),CPA(2))
C       CALL GSPARF(CPARF(1),CPARF(2))
      ENDIF
C
C  Set flag to indicate that GSWN has been called.
C
      IFRST = 1
C
      RETURN
      END

C
C	$Id: twobyt.f,v 1.6 2008-07-27 00:59:05 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE TWOBYT(IOS,STATUS)
C
C  PERFORM THE OPERATION OF RELATIVE PEN POSITION
C
C  OUTPUT
C       IOS-IO STATUS VALID ONLY IF STATUS DEFINED WITH AN I/O ERROR
C       STATUS-THE STATUS FLAG DEFINED BY COMMON TREROR
C
      COMMON/TREROR/ ALLOK, MFRCHK, MTOPER, METRDC, REDERR, TYPCHG
     1             ,INVTYP, MINVLD, TYPERR, FRMEND, ENCINT, IVDCDT
     2             ,GCOERR, GCRERR, GCCERR, FCOERR, FCRERR, FCCERR
     3             ,PLIDXG, PMIDXG, TXIDXG, PGIDXG, INVLMT, CELERR
     4             ,COIERR, COLNRM, UNKNOW, UNKOPC, ENDMTF, VNEROR
     5             ,BADRSZ, DEVOUT, NOVERS, BADFNT, PGMERR, FASERR
     6             ,HINERR, VDWERR, RDWERR, RIXLIM
      INTEGER        ALLOK, MFRCHK, MTOPER, METRDC, REDERR, TYPCHG
     1             ,INVTYP, MINVLD, TYPERR, FRMEND, ENCINT, IVDCDT
     2             ,GCOERR, GCRERR, GCCERR, FCOERR, FCRERR, FCCERR
     3             ,PLIDXG, PMIDXG, TXIDXG, PGIDXG, INVLMT, CELERR
     4             ,COIERR, COLNRM, UNKNOW, UNKOPC, ENDMTF, VNEROR
     5             ,BADRSZ, DEVOUT, NOVERS, BADFNT, PGMERR, FASERR
     6             ,HINERR, VDWERR, RDWERR, RIXLIM
      COMMON /TRINST/ OPCL, OPID, LEN, CONT
      INTEGER OPCL, OPID, LEN
      LOGICAL CONT
      COMMON /TRTYPE/ METMIN, METEXT, METPRT, METHED, MIOPCL, MXOPCL,
     1                MIOPID, MXOPID, ASCDEC, ASCHEX, ASCOCT, BINARY,
     2                GAHNOR, GALEFT, GACENT, GARITE, GAVNOR, GATOP ,
     3                GACAP , GAHALF, GABASE, GABOTT, GRIGHT, GLEFT ,
     4                GUP   ,
     5                GDOWN , CINDEX, CDIRCT, PENUP , PENDN , FLAGVL,
     6                SEPRVL, ASCTEK, TYPRGB, TYPBGR,
     7                TYPHLS, TYPMON, SOLID , DASHED, INVSBL, SOLPAT,
     8                ASFIND, ASFBND, ASFLNT, ASFLNW, ASFLNC, ASFMRT,
     9                ASFMRS, ASFMRC, ASFFIS, ASFFHI, ASFFPI, ASFFCO,
     A                ASFFPT, ASFFPW, ASFFPC, ASFTFI, ASFTPR, ASFTCX,
     B                ASFTCS, ASFTCO, ASCFLT, PHOLLO, PSOLID, PPATTR,
     C                PHATCH, PEMPTY, HHORIZ, HVERTI, HPOSLP, HNESLP,
     D                HHOAVE, HPOANE
      INTEGER         METMIN, METEXT, METPRT, METHED, MIOPCL, MXOPCL,
     1                MIOPID, MXOPID, ASCDEC, ASCHEX, ASCOCT, BINARY,
     2                GAHNOR, GALEFT, GACENT, GARITE, GAVNOR, GATOP ,
     3                GACAP , GAHALF, GABASE, GABOTT, GRIGHT, GLEFT ,
     4                GUP   ,
     5                GDOWN , CINDEX, CDIRCT, PENUP , PENDN , FLAGVL,
     6                SEPRVL, ASCTEK, TYPRGB, TYPBGR,
     7                TYPHLS, TYPMON, SOLID , DASHED, INVSBL, SOLPAT,
     8                ASFIND, ASFBND, ASFLNT, ASFLNW, ASFLNC, ASFMRT,
     9                ASFMRS, ASFMRC, ASFFIS, ASFFHI, ASFFPI, ASFFCO,
     A                ASFFPT, ASFFPW, ASFFPC, ASFTFI, ASFTPR, ASFTCX,
     B                ASFTCS, ASFTCO, ASCFLT, PHOLLO, PSOLID, PPATTR,
     C                PHATCH, PEMPTY, HHORIZ, HVERTI, HPOSLP, HNESLP,
     D                HHOAVE, HPOANE
      COMMON /TRMTYP/ FOURBT, MULTBT, TWOBT, PTSFLG, CURCOL, IPWRIT,
     1                IFRAME, ISETOP, IRANG, IPTS, ICAS, IINT, IORNT,
     2                ISIZE, IFONT, IPAT, ISSIZ, ICENT, ICOLR,
     3                MCENT, MSIZE, MOR, OLDX, OLDY, MCASE, MINTEN,
     4                MFONT, MDASH, MSPOT, MCOLOR, MLIMIT, PTSYM,
     5                SAVX, SAVY
      INTEGER FOURBT, MULTBT, TWOBT, PTSFLG, CURCOL, IPWRIT,
     1                IFRAME, ISETOP, IRANG, IPTS, ICAS, IINT, IORNT,
     2                ISIZE, IFONT, IPAT, ISSIZ, ICENT, ICOLR,
     3                MCENT, MSIZE, MOR, OLDX, OLDY, MCASE, MINTEN,
     4                MFONT, MDASH, MSPOT, MCOLOR(3), MLIMIT(4), PTSYM,
     5                SAVX, SAVY
      COMMON /PGKSCOM/ CLPDAT, CLPFLG, POLIDX, LINTYP, LINWTH, LINCOL,
     1                LINRGB, MARIDX, MARSIZ, MARCOL, MARRGB, TXTIDX,
     2                INTSTL, PATIDX, FILCOL, FILRGB, MARTYP, HORIZ ,
     3                VERT  , PATH  , CHIGHT, XU    , YU    , XB    ,
     4                YB    , TXTCOL, FINDEX, CEXPN , CSPACE, CURIDX,
     5                CURIMP, CURINT, COLMOD, FILIDX, TXTRGB, PROPN ,
     6                FIRSTX, FIRSTY, LASTX , LASTY , TRATIO, CBV   ,
     7                CUV   , CHP   , CVP   , CCSPAC, CHHORZ, CDV   ,
     8                PMRSIZ, CLPX  , CLPY  , CLPP  , DEFREP, DEFLEN,
     9                VDCECR, TRANVN, TXTPRE, HATIDX, FILRPT, ASFSRF,
     A                ASFSDF, MAPMOD, VERSOK, PCBFST, CPGLEN, CLPNUL,
     B                MTDLEN
      INTEGER         CMPMAX, ASFMAX
      PARAMETER      (CMPMAX=256    , ASFMAX=18)
      LOGICAL         CLPFLG, PROPN , CHHORZ, DEFREP, CLPNUL, MAPMOD,
     1                VERSOK, PCBFST
      REAL            LINWTH, MARSIZ, CEXPN , CSPACE, TRATIO, CBV(2),
     1                CUV(2), CDV(2), CCSPAC
      INTEGER         CLPDAT(4)     , POLIDX, LINTYP, LINCOL, LINRGB(3),
     1                MARIDX, MARCOL, MARRGB(3)     , TXTIDX, INTSTL,
     2                PATIDX, FILCOL, FILRGB(3)     , MARTYP, HORIZ ,
     3                VERT  , PATH  , XU    , YU    , XB    , YB    ,
     4                TXTCOL, FINDEX, CURIMP(CMPMAX), CURINT(CMPMAX*3),
     5                CHIGHT, COLMOD, FILIDX, TXTRGB(3)     , CURIDX,
     6                FIRSTX, FIRSTY, LASTX , LASTY , CHP   , CVP   ,
     7                PMRSIZ, CLPX  , CLPY  , CLPP  , DEFLEN, TRANVN,
     8                TXTPRE, HATIDX, FILRPT(2)     , VDCECR(4)     ,
     9                ASFSRF(ASFMAX), ASFSDF(ASFMAX), CPGLEN, MTDLEN
      COMMON /GKSCHR/ MTDESC
      CHARACTER*80    MTDESC
      COMMON /CAPFNT/ CHRSTR, CHREND, CHRWDT, CHRSCH, FNTRHT,
     1                FNTTOP, FNTCAP, FNTHLF, FNTBAS, FNTBOT,
     2                FNTTYP, FNTSCH, CORXST, CORXLN, CORYST,
     3                CORYLN, CORPST, CORPLN, PBEGST, PBEGLN,
     4                PENDST, PENDLN, CORSCH, NEWCLS, CPNTRS,
     5                CPNLST, CSTRKS
      INTEGER         CHRSM1, CHRSM2
      PARAMETER       (CHRSM1=128, CHRSM2=5121)
      INTEGER         CHRSTR, CHREND, CHRWDT,
     1                CHRSCH(11)    , FNTRHT, FNTTOP,
     2                FNTCAP, FNTHLF, FNTBAS, FNTBOT, FNTTYP,
     3                FNTSCH(9)     , CORXST, CORXLN,
     4                CORYST, CORYLN, CORPST, CORPLN,
     5                PBEGST, PBEGLN, PENDST, PENDLN,
     6                CORSCH(10)    ,
     7                NEWCLS(300)   ,
     8                CPNTRS(CHRSM1), CPNLST        ,
     9                CSTRKS(CHRSM2)
C
C  XLCN   --  Bit offset to extract X coordinates from fontcap.
C  YLCN   --  Bit offset to extract Y coordinates from fontcap.
C  PLCN   --  Bit offset to extract PEN control bit from fontcap.
C  FNTMAX --  Number of fonts obtained from FONT LIST (defaults to 1).
C  FNTS   --  An array of pointers associating indices obtained from
C             FONT INDEX elements with the internally supported fonts.
C             Consult the documentation in BLOCKDATA TRNDATX for a
C             list of supported fonts.
C  FLEFT  --  An array of character left values for proportionally
C             spaced fonts.
C  FRIGHT --  An array of character right values for proportionally
C             spaced fonts.
C  MXFLST --  The maximum number of strings accepted in a FONT LIST
C             element.
C  NSFNTS --  The number of distinct fonts supported internally.
C
      PARAMETER (NSFNTS=20,MXFLST=300)
      COMMON /FNTCOM/ XLCN  , YLCN  , PLCN  , FNTMAX,
     1                FNTS  , FLEFT , FRIGHT, SFLENS
      INTEGER         FLEFT(CHRSM1) , FRIGHT(CHRSM1), FNTS(MXFLST)  ,
     1                XLCN, YLCN    , PLCN  , FNTMAX
      CHARACTER*30 SFONTS(NSFNTS)
      COMMON /SUPFNT/ SFONTS
C
C  Size of common CAPFNT in words.
C
      INTEGER WRLEN
      PARAMETER (WRLEN=5600)
C
      INTEGER IOS, STATUS
      INTEGER BIAS32, CSIZE, PSIZE, XC, PEN, YC
      INTEGER STRX, STRY, METCOR
C
C  SAVE PREVIOUS LINE POINT FOR CONNECTED POINTS,
C  SAVX and SAVY need to be in common with POSIT
C  since there may be a mixture of two byte and
C  four byte instructions.
C
      SAVE    /TRMTYP/
C
C   SIZE OF A CHARACTER MARKER FOR POINTS MODE
C
      INTEGER PTSIZ
      DATA PTSIZ/15/
C
C  THERE IS NO NEED FOR RECORD ERROR CHECKS BECAUSE THE 16 BIT PARCEL
C  IS IN THE METAFILE BUFFER
C
C  THE 32 BIT BIAS FOR THE RELATIVE POSITIONING
C
      DATA BIAS32/32/
      DATA CSIZE,PSIZE/6,1/
C
C  Initialize maximum metacode coordinate.
C
      DATA METCOR/32767/
C
C  SET THE ERROR FLAG TO OK
C
      STATUS = ALLOK
C
C  GET THE X COORDINATE
C
      CALL MNINST(CSIZE,IOS,STATUS)
      XC = OPCL
C
C  GET THE PEN STATUS
C
      CALL MNINST(PSIZE,IOS,STATUS)
      PEN = OPCL
C
C  SKIP THE NULL BIT
C
      CALL MNINST(PSIZE,IOS,STATUS)
C
C  GET THE Y COORDINATE
C
      CALL MNINST(CSIZE,IOS,STATUS)
      YC = OPCL
C
C  BIAS AND SET THE ABSOLUTE PEN POSITION
C
      OLDX = (XC-BIAS32) + OLDX
      OLDY = (YC-BIAS32) + OLDY
C
C  TEST IF IN POINTS MODE OR LINE MODE
C
      IF (PTSFLG.EQ.0) THEN
C
C       LINE MODE PERFORM THE PEN POSITION INSTRUCTION
C
        CALL PATDRW(OLDX, OLDY, PEN, IOS, STATUS)
C
      ELSE
C
C       POINTS MODE
C
        STRX = OLDX
        STRY = OLDY
C
C       CHECK IF POINT OR CHARACTER REQUIRED
C
        IF (PTSYM.EQ.0) THEN
C
C         DRAW A POINT
C
          CALL PLOTIT(0,0,2)
          CALL GSMK(1)
          XCOR = REAL(OLDX)/32767.
          YCOR = REAL(OLDY)/32767.
          CALL GPM(1,XCOR,YCOR)
C
        ELSE
C
C         DRAW A SYMBOL
C
          CALL PLOTIT(0,0,2)
          CHIGHT = PTSIZ
          XCOR = REAL(STRX)/32767.
          YCOR = REAL(STRY)/32767.
          CALL WTSTR(XCOR,YCOR,CHAR(PTSYM),CHIGHT,0,0)
        END IF
C
C               IF PEN DOWN THEN DRAW FROM LAST POINT TO CURRENT POINT
C
        IF (PEN.EQ.PENDN) THEN
                CALL PLTIT(SAVX, SAVY, 0, IOS, STATUS)
                CALL PLTIT(STRX, STRY, 1, IOS, STATUS)
        END IF
C
C  SAVE THE CURRENT POSITION
C
        SAVX = STRX
        SAVY = STRY
       END IF
C
      RETURN
      END

      PROGRAM CCPHLT
C 
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER (M=40,N=40,LRWK=3500,LIWK=4000)
      REAL Z(M,N), RWRK(LRWK)
      INTEGER IWRK(LIWK)
      
      CALL GENDAT(Z,M,M,N,1,25,1.03,24.88)
C 
C Open GKS, open and activate a workstation.
C 
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
      CALL GSCLIP (0)
C
C Set up label options
C
      CALL CPSETC('HLT - HIGH/LOW TEXT',
     1     'Local High ($ZDV$)''Local Low ($ZDV$)')
      CALL CPSETI('HLX - HIGH/LOW SEARCH RADIUS IN X',3)
      CALL CPSETI('HLY - HIGH/LOW SEARCH RADIUS IN Y',2)
      CALL CPSETR('HLL - HIGH/LOW LINE WIDTH',3.0)
C
C Initialize Conpack
C
      CALL CPRECT(Z, M, M, N, RWRK, LRWK, IWRK, LIWK)
C
C Draw Perimeter
C
      CALL CPBACK(Z, RWRK, IWRK)
C
C Draw Contours
C
      CALL CPCLDR(Z,RWRK,IWRK)
      CALL CPLBDR(Z,RWRK,IWRK)
C     
C Close frame and close GKS
C
      CALL FRAME
C 
C Deactivate and close workstation, close GKS.
C 
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      
      STOP
      END
      
      SUBROUTINE GENDAT (DATA,IDIM,M,N,MLOW,MHGH,DLOW,DHGH)
C 
C This is a routine to generate test data for two-dimensional graphics
C routines.  Given an array "DATA", dimensioned "IDIM x 1", it fills
C the sub-array ((DATA(I,J),I=1,M),J=1,N) with a two-dimensional field
C of data having approximately "MLOW" lows and "MHGH" highs, a minimum
C value of exactly "DLOW" and a maximum value of exactly "DHGH".
C 
C "MLOW" and "MHGH" are each forced to be greater than or equal to 1
C and less than or equal to 25.
C 
C The function used is a sum of exponentials.
C 
      DIMENSION DATA(IDIM,1),CCNT(3,50)
C 
      FOVM=9./REAL(M)
      FOVN=9./REAL(N)
C 
      NLOW=MAX(1,MIN(25,MLOW))
      NHGH=MAX(1,MIN(25,MHGH))
      NCNT=NLOW+NHGH
C 
      DO 101 K=1,NCNT
         CCNT(1,K)=1.+(REAL(M)-1.)*FRAN()
         CCNT(2,K)=1.+(REAL(N)-1.)*FRAN()
         IF (K.LE.NLOW) THEN
            CCNT(3,K)=-1.
         ELSE
            CCNT(3,K)=+1.
         END IF
 101  CONTINUE
C 
      DMIN=+1.E36
      DMAX=-1.E36
      DO 104 J=1,N
         DO 103 I=1,M
            DATA(I,J)=.5*(DLOW+DHGH)
            DO 102 K=1,NCNT
               TEMP=-((FOVM*(REAL(I)-CCNT(1,K)))**2+
     1               (FOVN*(REAL(J)-CCNT(2,K)))**2)
               IF (TEMP.GE.-20.) DATA(I,J)=DATA(I,J)+
     1               .5*(DHGH-DLOW)*CCNT(3,K)*EXP(TEMP)
 102        CONTINUE
            DMIN=MIN(DMIN,DATA(I,J))
            DMAX=MAX(DMAX,DATA(I,J))
 103     CONTINUE
 104  CONTINUE
C 
      DO 106 J=1,N
         DO 105 I=1,M
            DATA(I,J)=(DATA(I,J)-DMIN)/(DMAX-DMIN)*(DHGH-DLOW)+DLOW
 105     CONTINUE
 106  CONTINUE
C 
      RETURN
C 
      END
      FUNCTION FRAN ()
      DIMENSION RSEQ (100)
      SAVE ISEQ
      DATA RSEQ / .749,.973,.666,.804,.081,.483,.919,.903,.951,.960 ,
     1      .039,.269,.270,.756,.222,.478,.621,.063,.550,.798 ,
     2      .027,.569,.149,.697,.451,.738,.508,.041,.266,.249 ,
     3      .019,.191,.266,.625,.492,.940,.508,.406,.972,.311 ,
     4      .757,.378,.299,.536,.619,.844,.342,.295,.447,.499 ,
     5      .688,.193,.225,.520,.954,.749,.997,.693,.217,.273 ,
     6      .961,.948,.902,.104,.495,.257,.524,.100,.492,.347 ,
     7      .981,.019,.225,.806,.678,.710,.235,.600,.994,.758 ,
     8      .682,.373,.009,.469,.203,.730,.588,.603,.213,.495 ,
     9      .884,.032,.185,.127,.010,.180,.689,.354,.372,.429 /
      DATA ISEQ / 0 /
      ISEQ=MOD(ISEQ,100)+1
      FRAN=RSEQ(ISEQ)
      RETURN
      END

      PROGRAM PGKEX08
C
C  Demo a plot describing the GKS font coordinate system.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      DIMENSION XB(4),YB(4)
C
C  Open GKS, open and activate a CGM workstation.
C
      CALL GOPKS (IERRF,IDUM)
      CALL GOPWK (IWKID,LUNIT,IWTYPE)
      CALL GACWK (IWKID)
C
C  Get the character body limits.
C
      XCENT = .5
      CAP =  .7
      BASE = .3
      HALF = .5*(CAP+BASE)
      TOP = HALF+.7*(CAP-BASE)
      BOT = HALF-.8*(CAP-BASE)
C
C  Convert the character height to width for Plotchar.
C
      CWIDTH = (6./7.)*(CAP-BASE)
C
C  Turn computation of text extent information on.
C
      CALL PCSETI('TE',1)
C
C  Specify the text font and color.
C
      CALL PCSETI('FN',21)
      CALL PCSETI('CC',1)
C
C  Compute the text extent information.
C
      CALL PLCHHQ(XCENT,HALF,'B',CWIDTH,360.,0.)
C
C  Turn text extent computation off.
C
      CALL PCSETI('TE',0)
      CALL PCGETR('XB',TLEFT)
      CALL PCGETR('XE',TRIGHT)
      EXTL = .15
      EXTR = .05
C
C  Draw a hatch pattern in the character body limits.
C
      XB(1) = TLEFT
      XB(2) = TRIGHT
      XB(3) = TRIGHT
      XB(4) = TLEFT
      YB(1) = BOT
      YB(2) = BOT
      YB(3) = TOP
      YB(4) = TOP
      CALL GSFAIS(3)
      CALL GSFASI(6)
      CALL GFA(4,XB,YB)
      CALL GSFAIS(1)
C
C  Draw the character.
C
      CALL PLCHHQ(XCENT,HALF,'B',CWIDTH,0.,0.)
C
C  Label the plot.
C
      CALL LINE(TLEFT-EXTR,TOP,TRIGHT+EXTR,TOP)
      CALL LINE(TLEFT-EXTL,CAP,TRIGHT+EXTR,CAP)
      CALL LINE(TLEFT,HALF,TRIGHT+EXTR,HALF)
      CALL LINE(TLEFT-EXTL,BASE,TRIGHT+EXTR,BASE)
      CALL LINE(TLEFT-EXTR,BOT,TRIGHT+EXTR,BOT)
C
      CALL LINE(TLEFT,TOP+EXTR,TLEFT,BOT-EXTR)
      CALL LINE(TRIGHT,TOP+EXTR,TRIGHT,BOT-EXTR)
      CALL LINE(XCENT,TOP+EXTR,XCENT,BOT-EXTR)
C
      SZ = .015
      CALL PLCHHQ(TRIGHT+EXTR+.01,TOP,'top',SZ,0.,-1.)
      CALL PLCHHQ(TRIGHT+EXTR+.01,CAP,'cap',SZ,0.,-1.)
      CALL PLCHHQ(TRIGHT+EXTR+.01,HALF,'half',SZ,0.,-1.)
      CALL PLCHHQ(TRIGHT+EXTR+.01,BASE,'base',SZ,0.,-1.)
      CALL PLCHHQ(TRIGHT+EXTR+.01,BOT,'bottom',SZ,0.,-1.)
      CALL PLCHHQ(TLEFT,BOT-EXTR-.025,'left',SZ,0.,0.)
      CALL PLCHHQ(XCENT,BOT-EXTR-.025,'center',SZ,0.,0.)
      CALL PLCHHQ(TRIGHT,BOT-EXTR-.025,'right',SZ,0.,0.)
C
      SZ = .013
      CNTL = TLEFT-.08
      CALL PLCHHQ(CNTL,HALF+.050,'CHARACTER',SZ,0.,0.)
      CALL PLCHHQ(CNTL,HALF+.020,'HEIGHT',SZ,0.,0.)
C
      CALL ARW(CNTL,CAP,0)
      CALL ARW(CNTL,BASE,1)
      CALL LINE(CNTL,HALF+.050+.02,CNTL,CAP)
      CALL LINE(CNTL,HALF,CNTL,BASE)
C
      CALL PLCHHQ(XCENT,.89,
     +            'The hatched area denotes the character body',
     +            .016,0.,0.)
      CALL PCSETI('FN',25)
      CALL PLCHHQ(XCENT,.94,'Font Coordinate System',.024,0.,0.)
      CALL FRAME
C
C  Deactivate and close the workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END
      SUBROUTINE ARW(XP,YP,IP)
C
C  Draws an arrow tip at (X,Y) which is up if IP=0 and down if IP=1
C
      DIMENSION X(3),Y(3)
      DATA DX,DY/.01,.035/
      IYS = 1
      IF (IP .EQ. 0) THEN
        IYS = -1
      ENDIF
      X(1) = XP-DX
      X(2) = XP
      X(3) = XP+DX
      Y(1) = YP+IYS*DY
      Y(2) = YP
      Y(3) = YP+IYS*DY
      CALL GFA(3,X,Y)
      RETURN
      END

      PROGRAM CCPDFLT
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER (K=40,N=40,LRWK=1000,LIWK=1000)
      REAL Z(K,N), RWRK(LRWK)
      INTEGER M, IWRK(LIWK)
      
      CALL GETDAT (Z, K, M, N) 
C 
C Open GKS, open and activate a workstation.
C 
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C     
C Initialize Conpack
C
      CALL CPRECT(Z,K,M,N,RWRK,LRWK,IWRK,LIWK)
C
C Draw perimeter
C
      CALL CPBACK(Z, RWRK, IWRK)
C
C Draw Contours
C
      CALL CPCLDR(Z,RWRK,IWRK)
C
C Close frame
C
      CALL FRAME
C 
C  Deactivate and close workstation, close GKS.
C 
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      
      STOP
      END
      
      SUBROUTINE GETDAT (Z, K, M, N)
      INTEGER I,J,K,M,N
      REAL Z(K,N)
      
      M=K
      DO 10, I=1,M
         DO 20, J=1,N
            Z(I,J)= 10.E-5*(-16.*REAL(I**2*J) +
     1           34*REAL(I*J**2) - REAL(6*I) + 93.)
 20      CONTINUE
 10   CONTINUE
      
      RETURN
      END

C
C $Id: mdchln.f,v 1.2 2008-07-27 00:17:06 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MDCHLN (IFLG,ILTY,IOAL,IOAR,NPTS,PNTS)
C
        INTEGER IFLG,ILTY,IOAL,IOAR,NPTS
        REAL    PNTS(*)
C
C This routine is called by MDLNAM, MDLNDM, and MDLNDR before and after
C processing each line defined by a dataset.  IFLG is positive if a line
C is about to be processed, negative if a line was just processed; its
C absolute value is 1 if the call comes from MDLNAM, 2 if the call comes
C from MDLNDM, and 3 if the call comes from MDLNDR.  ILTY is the type of
C the line, IOAL is the identifier of the area to its left, and IOAR is
C the identifier of the area to its right.  NPTS is the number of points
C defining the line, and the array PNTS contains the lat/lon coordinates
C of the points.  MDCHLN is meant to be replaced by an LLU user; it may
C set line width and color and it may change the values of IOAL and
C IOAR; if it sets NPTS to zero, the line is deleted.
C
        RETURN
C
      END

      SUBROUTINE STPTRS( UPLO, TRANS, DIAG, N, NRHS, AP, B, LDB, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER          DIAG, TRANS, UPLO
      INTEGER            INFO, LDB, N, NRHS
*     ..
*     .. Array Arguments ..
      REAL               AP( * ), B( LDB, * )
*     ..
*
*  Purpose
*  =======
*
*  STPTRS solves a triangular system of the form
*
*     A * X = B  or  A**T * X = B,
*
*  where A is a triangular matrix of order N stored in packed format,
*  and B is an N-by-NRHS matrix.  A check is made to verify that A is
*  nonsingular.
*
*  Arguments
*  =========
*
*  UPLO    (input) CHARACTER*1
*          = 'U':  A is upper triangular;
*          = 'L':  A is lower triangular.
*
*  TRANS   (input) CHARACTER*1
*          Specifies the form of the system of equations:
*          = 'N':  A * X = B  (No transpose)
*          = 'T':  A**T * X = B  (Transpose)
*          = 'C':  A**H * X = B  (Conjugate transpose = Transpose)
*
*  DIAG    (input) CHARACTER*1
*          = 'N':  A is non-unit triangular;
*          = 'U':  A is unit triangular.
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  NRHS    (input) INTEGER
*          The number of right hand sides, i.e., the number of columns
*          of the matrix B.  NRHS >= 0.
*
*  AP      (input) REAL array, dimension (N*(N+1)/2)
*          The upper or lower triangular matrix A, packed columnwise in
*          a linear array.  The j-th column of A is stored in the array
*          AP as follows:
*          if UPLO = 'U', AP(i + (j-1)*j/2) = A(i,j) for 1<=i<=j;
*          if UPLO = 'L', AP(i + (j-1)*(2*n-j)/2) = A(i,j) for j<=i<=n.
*
*  B       (input/output) REAL array, dimension (LDB,NRHS)
*          On entry, the right hand side matrix B.
*          On exit, if INFO = 0, the solution matrix X.
*
*  LDB     (input) INTEGER
*          The leading dimension of the array B.  LDB >= max(1,N).
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*          > 0:  if INFO = i, the i-th diagonal element of A is zero,
*                indicating that the matrix is singular and the
*                solutions X have not been computed.
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ZERO
      PARAMETER          ( ZERO = 0.0E+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            NOUNIT, UPPER
      INTEGER            J, JC
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           STPSV, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      UPPER = LSAME( UPLO, 'U' )
      NOUNIT = LSAME( DIAG, 'N' )
      IF( .NOT.UPPER .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = -1
      ELSE IF( .NOT.LSAME( TRANS, 'N' ) .AND. .NOT.
     $         LSAME( TRANS, 'T' ) .AND. .NOT.LSAME( TRANS, 'C' ) ) THEN
         INFO = -2
      ELSE IF( .NOT.NOUNIT .AND. .NOT.LSAME( DIAG, 'U' ) ) THEN
         INFO = -3
      ELSE IF( N.LT.0 ) THEN
         INFO = -4
      ELSE IF( NRHS.LT.0 ) THEN
         INFO = -5
      ELSE IF( LDB.LT.MAX( 1, N ) ) THEN
         INFO = -8
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'STPTRS', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
*
*     Check for singularity.
*
      IF( NOUNIT ) THEN
         IF( UPPER ) THEN
            JC = 1
            DO 10 INFO = 1, N
               IF( AP( JC+INFO-1 ).EQ.ZERO )
     $            RETURN
               JC = JC + INFO
   10       CONTINUE
         ELSE
            JC = 1
            DO 20 INFO = 1, N
               IF( AP( JC ).EQ.ZERO )
     $            RETURN
               JC = JC + N - INFO + 1
   20       CONTINUE
         END IF
      END IF
      INFO = 0
*
*     Solve A * x = b  or  A' * x = b.
*
      DO 30 J = 1, NRHS
         CALL STPSV( UPLO, TRANS, DIAG, N, AP, B( 1, J ), 1 )
   30 CONTINUE
*
      RETURN
*
*     End of STPTRS
*
      END

      INTEGER FUNCTION I1MACH(I)
      INTEGER I
C
C    I1MACH( 1) = THE STANDARD INPUT UNIT.
C    I1MACH( 2) = THE STANDARD OUTPUT UNIT.
C    I1MACH( 3) = THE STANDARD PUNCH UNIT.
C    I1MACH( 4) = THE STANDARD ERROR MESSAGE UNIT.
C    I1MACH( 5) = THE NUMBER OF BITS PER INTEGER STORAGE UNIT.
C    I1MACH( 6) = THE NUMBER OF CHARACTERS PER CHARACTER STORAGE UNIT.
C    INTEGERS HAVE FORM SIGN ( X(S-1)*A**(S-1) + ... + X(1)*A + X(0) )
C    I1MACH( 7) = A, THE BASE.
C    I1MACH( 8) = S, THE NUMBER OF BASE-A DIGITS.
C    I1MACH( 9) = A**S - 1, THE LARGEST MAGNITUDE.
C    FLOATS HAVE FORM  SIGN (B**E)*( (X(1)/B) + ... + (X(T)/B**T) )
C               WHERE  EMIN .LE. E .LE. EMAX.
C    I1MACH(10) = B, THE BASE.
C  SINGLE-PRECISION
C    I1MACH(11) = T, THE NUMBER OF BASE-B DIGITS.
C    I1MACH(12) = EMIN, THE SMALLEST EXPONENT E.
C    I1MACH(13) = EMAX, THE LARGEST EXPONENT E.
C  DOUBLE-PRECISION
C    I1MACH(14) = T, THE NUMBER OF BASE-B DIGITS.
C    I1MACH(15) = EMIN, THE SMALLEST EXPONENT E.
C    I1MACH(16) = EMAX, THE LARGEST EXPONENT E.
C
      INTEGER IMACH(16), OUTPUT, SC, SMALL(2)
      SAVE IMACH, SC
      REAL RMACH
      EQUIVALENCE (IMACH(4),OUTPUT), (RMACH,SMALL(1))
      INTEGER I3, J, K, T3E(3)
      DATA T3E(1) / 9777664 /
      DATA T3E(2) / 5323660 /
      DATA T3E(3) / 46980 /
C  THIS VERSION ADAPTS AUTOMATICALLY TO MOST CURRENT MACHINES,
C  INCLUDING AUTO-DOUBLE COMPILERS.
C  TO COMPILE ON OLDER MACHINES, ADD A C IN COLUMN 1
C  ON THE NEXT LINE
      DATA SC/0/
C  AND REMOVE THE C FROM COLUMN 1 IN ONE OF THE SECTIONS BELOW.
C  CONSTANTS FOR EVEN OLDER MACHINES CAN BE OBTAINED BY
C          mail netlib@research.bell-labs.com
C          send old1mach from blas
C  PLEASE SEND CORRECTIONS TO dmg OR ehg@bell-labs.com.
C
C     MACHINE CONSTANTS FOR THE HONEYWELL DPS 8/70 SERIES.
C
C      DATA IMACH( 1) /    5 /
C      DATA IMACH( 2) /    6 /
C      DATA IMACH( 3) /   43 /
C      DATA IMACH( 4) /    6 /
C      DATA IMACH( 5) /   36 /
C      DATA IMACH( 6) /    4 /
C      DATA IMACH( 7) /    2 /
C      DATA IMACH( 8) /   35 /
C      DATA IMACH( 9) / O377777777777 /
C      DATA IMACH(10) /    2 /
C      DATA IMACH(11) /   27 /
C      DATA IMACH(12) / -127 /
C      DATA IMACH(13) /  127 /
C      DATA IMACH(14) /   63 /
C      DATA IMACH(15) / -127 /
C      DATA IMACH(16) /  127 /, SC/987/
C
C     MACHINE CONSTANTS FOR PDP-11 FORTRANS SUPPORTING
C     32-BIT INTEGER ARITHMETIC.
C
C      DATA IMACH( 1) /    5 /
C      DATA IMACH( 2) /    6 /
C      DATA IMACH( 3) /    7 /
C      DATA IMACH( 4) /    6 /
C      DATA IMACH( 5) /   32 /
C      DATA IMACH( 6) /    4 /
C      DATA IMACH( 7) /    2 /
C      DATA IMACH( 8) /   31 /
C      DATA IMACH( 9) / 2147483647 /
C      DATA IMACH(10) /    2 /
C      DATA IMACH(11) /   24 /
C      DATA IMACH(12) / -127 /
C      DATA IMACH(13) /  127 /
C      DATA IMACH(14) /   56 /
C      DATA IMACH(15) / -127 /
C      DATA IMACH(16) /  127 /, SC/987/
C
C     MACHINE CONSTANTS FOR THE UNIVAC 1100 SERIES.
C
C     NOTE THAT THE PUNCH UNIT, I1MACH(3), HAS BEEN SET TO 7
C     WHICH IS APPROPRIATE FOR THE UNIVAC-FOR SYSTEM.
C     IF YOU HAVE THE UNIVAC-FTN SYSTEM, SET IT TO 1.
C
C      DATA IMACH( 1) /    5 /
C      DATA IMACH( 2) /    6 /
C      DATA IMACH( 3) /    7 /
C      DATA IMACH( 4) /    6 /
C      DATA IMACH( 5) /   36 /
C      DATA IMACH( 6) /    6 /
C      DATA IMACH( 7) /    2 /
C      DATA IMACH( 8) /   35 /
C      DATA IMACH( 9) / O377777777777 /
C      DATA IMACH(10) /    2 /
C      DATA IMACH(11) /   27 /
C      DATA IMACH(12) / -128 /
C      DATA IMACH(13) /  127 /
C      DATA IMACH(14) /   60 /
C      DATA IMACH(15) /-1024 /
C      DATA IMACH(16) / 1023 /, SC/987/
C
      IF (SC .NE. 987) THEN
*        *** CHECK FOR AUTODOUBLE ***
         SMALL(2) = 0
         RMACH = 1E13
         IF (SMALL(2) .NE. 0) THEN
*           *** AUTODOUBLED ***
            IF (      (SMALL(1) .EQ. 1117925532
     *           .AND. SMALL(2) .EQ. -448790528)
     *       .OR.     (SMALL(2) .EQ. 1117925532
     *           .AND. SMALL(1) .EQ. -448790528)) THEN
*               *** IEEE ***
               IMACH(10) = 2
               IMACH(14) = 53
               IMACH(15) = -1021
               IMACH(16) = 1024
            ELSE IF ( SMALL(1) .EQ. -2065213935
     *          .AND. SMALL(2) .EQ. 10752) THEN
*               *** VAX WITH D_FLOATING ***
               IMACH(10) = 2
               IMACH(14) = 56
               IMACH(15) = -127
               IMACH(16) = 127
            ELSE IF ( SMALL(1) .EQ. 1267827943
     *          .AND. SMALL(2) .EQ. 704643072) THEN
*               *** IBM MAINFRAME ***
               IMACH(10) = 16
               IMACH(14) = 14
               IMACH(15) = -64
               IMACH(16) = 63
            ELSE
               WRITE(*,9010)
               STOP 777
               END IF
            IMACH(11) = IMACH(14)
            IMACH(12) = IMACH(15)
            IMACH(13) = IMACH(16)
         ELSE
            RMACH = 1234567.
            IF (SMALL(1) .EQ. 1234613304) THEN
*               *** IEEE ***
               IMACH(10) = 2
               IMACH(11) = 24
               IMACH(12) = -125
               IMACH(13) = 128
               IMACH(14) = 53
               IMACH(15) = -1021
               IMACH(16) = 1024
               SC = 987
            ELSE IF (SMALL(1) .EQ. -1271379306) THEN
*               *** VAX ***
               IMACH(10) = 2
               IMACH(11) = 24
               IMACH(12) = -127
               IMACH(13) = 127
               IMACH(14) = 56
               IMACH(15) = -127
               IMACH(16) = 127
               SC = 987
            ELSE IF (SMALL(1) .EQ. 1175639687) THEN
*               *** IBM MAINFRAME ***
               IMACH(10) = 16
               IMACH(11) = 6
               IMACH(12) = -64
               IMACH(13) = 63
               IMACH(14) = 14
               IMACH(15) = -64
               IMACH(16) = 63
               SC = 987
            ELSE IF (SMALL(1) .EQ. 1251390520) THEN
*              *** CONVEX C-1 ***
               IMACH(10) = 2
               IMACH(11) = 24
               IMACH(12) = -128
               IMACH(13) = 127
               IMACH(14) = 53
               IMACH(15) = -1024
               IMACH(16) = 1023
            ELSE
               DO 10 I3 = 1, 3
                  J = SMALL(1) / 10000000
                  K = SMALL(1) - 10000000*J
                  IF (K .NE. T3E(I3)) GO TO 20
                  SMALL(1) = J
 10               CONTINUE
*              *** CRAY T3E ***
               IMACH( 1) = 5
               IMACH( 2) = 6
               IMACH( 3) = 0
C
C Note: the original version returns '6' for IMACH(4). But, we've
C been using '0' for years, so we hard-coded it to '0' here.
C
               IMACH( 4) = 0
               IMACH( 5) = 64
               IMACH( 6) = 8
               IMACH( 7) = 2
               IMACH( 8) = 63
               CALL I1MCR1(IMACH(9), K, 32767, 16777215, 16777215)
               IMACH(10) = 2
               IMACH(11) = 53
               IMACH(12) = -1021
               IMACH(13) = 1024
               IMACH(14) = 53
               IMACH(15) = -1021
               IMACH(16) = 1024
               GO TO 35
 20            CALL I1MCR1(J, K, 16405, 9876536, 0)
               IF (SMALL(1) .NE. J) THEN
                  WRITE(*,9020)
                  STOP 777
                  END IF
*              *** CRAY 1, XMP, 2, AND 3 ***
               IMACH(1) = 5
               IMACH(2) = 6
               IMACH(3) = 102
               IMACH(4) = 6
               IMACH(5) = 46
               IMACH(6) = 8
               IMACH(7) = 2
               IMACH(8) = 45
               CALL I1MCR1(IMACH(9), K, 0, 4194303, 16777215)
               IMACH(10) = 2
               IMACH(11) = 47
               IMACH(12) = -8188
               IMACH(13) = 8189
               IMACH(14) = 94
               IMACH(15) = -8141
               IMACH(16) = 8189
               GO TO 35
               END IF
            END IF
         IMACH( 1) = 5
         IMACH( 2) = 6
         IMACH( 3) = 7
         IMACH( 4) = 0
         IMACH( 5) = 32
         IMACH( 6) = 4
         IMACH( 7) = 2
         IMACH( 8) = 31
         IMACH( 9) = 2147483647
 35      SC = 987
         END IF
 9010 FORMAT(/' Adjust autodoubled I1MACH by uncommenting data'/
     * ' statements appropriate for your machine and setting'/
     * ' IMACH(I) = IMACH(I+3) for I = 11, 12, and 13.')
 9020 FORMAT(/' Adjust I1MACH by uncommenting data statements'/
     * ' appropriate for your machine.')
      IF (I .LT. 1  .OR.  I .GT. 16) GO TO 40
      I1MACH = IMACH(I)
      RETURN
 40   WRITE(*,*) 'I1MACH(I): I =',I,' is out of bounds.'
      STOP
* /* C source for I1MACH -- remove the * in column 1 */
* /* Note that some values may need changing. */
*#include <stdio.h>
*#include <float.h>
*#include <limits.h>
*#include <math.h>
*
*long i1mach_(long *i)
*{
*	switch(*i){
*	  case 1:  return 5;	/* standard input */
*	  case 2:  return 6;	/* standard output */
*	  case 3:  return 7;	/* standard punch */
*	  case 4:  return 0;	/* standard error */
*	  case 5:  return 32;	/* bits per integer */
*	  case 6:  return sizeof(int);
*	  case 7:  return 2;	/* base for integers */
*	  case 8:  return 31;	/* digits of integer base */
*	  case 9:  return LONG_MAX;
*	  case 10: return FLT_RADIX;
*	  case 11: return FLT_MANT_DIG;
*	  case 12: return FLT_MIN_EXP;
*	  case 13: return FLT_MAX_EXP;
*	  case 14: return DBL_MANT_DIG;
*	  case 15: return DBL_MIN_EXP;
*	  case 16: return DBL_MAX_EXP;
*	  }
*	fprintf(stderr, "invalid argument: i1mach(%ld)\n", *i);
*	exit(1);return 0; /* some compilers demand return values */
*}
      END
      SUBROUTINE I1MCR1(A, A1, B, C, D)
**** SPECIAL COMPUTATION FOR OLD CRAY MACHINES ****
      INTEGER A, A1, B, C, D
      A1 = 16777216*B + C
      A = 16777216*A1 + D
      END

C
C	$Id: gztowk.f,v 1.20 2010-02-08 06:01:29 fred Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GZTOWK
C
C  This subroutine invokes the workstation drivers depending
C  on the current GKS operating state. 
C
      include 'gkscom.h'
C
      PARAMETER (IADIM=256)
      INTEGER FCODEO,CONTO,XID,ADESTR(IADIM),ICNTX(31)
      REAL    RCNTX(19)
      SAVE
C
      CALL GQOPS(IST)
C
C  Invoke workstation drivers for GKCL functions and OPEN WORKSTATION.
C
      IF (IST .GE. GGKCL) THEN
C
C  Picture name.
C
        IF (FCODE .EQ. 92) THEN
          CALL G01WDR(ID(1),GFNAME)
          RETURN
        ELSE IF (FCODE.EQ.-3 .OR. FCODE.EQ.-4) THEN
          IF (ID(3) .EQ. GCGM) THEN
            CALL G01WDR(ID(1),GFNAME)
            RETURN
          ELSE IF (ID(3).EQ.GXWC   .OR.   ID(3).EQ.GXWE    .OR. 
     +             ID(3).EQ.GDMP   .OR.   ID(3).EQ.GPIX    .OR.
     +            (ID(3).GE.GPSMIN .AND.  ID(3).LE.GPSMAX) .OR.
     +             ID(3).EQ.GPDFP  .OR.   ID(3).EQ.GPDFL   .OR.
     +            (ID(3).GE.GCROMIN .AND.  ID(3).LE.GCROMAX) )THEN
            DO 200 J=1,IADIM
              ADESTR(J) = 0
  200       CONTINUE
            INMLEN = LEN(GFNAME)
            DO 80 J=1,INMLEN
              ADESTR(J) = ICHAR(GFNAME(J:J))
   80       CONTINUE
            STRL1 = INMLEN
            STRL2 = INMLEN
            IID   = ID(1)
            ID(1) = ID(2)
            ID(2) = ID(3)
            ID(3) = ID(4)
            ID(4) = ID(5)
            ID(5) = ID(6)
            ID(6) = ID(7)
            ID(7) = ID(8)
            ID(8) = ID(9)
            ID(9) = ID(10)
            ID(10) = ID(11)
            ID(11) = ID(12)
            ID(12) = ID(13)
            ID(13) = ID(14)
            ID(14) = ID(15)
            NUMP  = 12
            CALL GGKWDR(IID,FCODE,0,NUMP,IL2,ID,IC1,IC2,IC,
     -                  RL1,RL2,RX,RY,STRL1,STRL2,ADESTR,RERR,XERMSG)
            IF (RERR .LE. -100) RETURN
          ELSE IF (ID(3) .EQ. GWSS) THEN
            CALL GZSRAT(3,ICNTX,RCNTX)
            CALL GWIWDR(ICNTX,RCNTX)
            RETURN
          ENDIF
        ENDIF
      ENDIF
C
C  Return if no workstations are open.
C
      IF (IST .EQ. GGKOP) RETURN
C
C  Treat the WSOP functions when there is at least one open workstation.
C
      IF (IST .GE. GWSOP) THEN
        DO 10 I=1,NOPWK
C
C  Put out new picture initialization if metafile and the picture 
C  is empty.
C
          IF (SWKTP(I) .EQ. GCGM) THEN 
C
C  If CUFLAG is set, make the interface call only for the specific
C  workstation.
C
            IF (CUFLAG.GE.0 .AND. SOPWK(I).NE.CUFLAG) GO TO 100
C           IF (IST.GE.2  .AND. NOPICT.LE.0 .AND. 
C    -        (FCODE.EQ.-2 .OR.  FCODE.EQ.56  .OR. FCODE.EQ.61  .OR.
C    -         FCODE.EQ.82 .OR. (FCODE.GE.11 .AND. FCODE.LE.16) .OR.
C    -         (FCODE.GE.21.AND.FCODE.LE.43))) THEN
            IF (IST.GE.2  .AND. NOPICT.LE.0 .AND. 
     -          (FCODE.EQ.82 .OR. (FCODE.GE.11 .AND. FCODE.LE.16))) THEN       
              FCODEO = FCODE
              CONTO  = CONT
              FCODE  = 91
              CONT   =  0
              CALL G01WDR(SOPWK(I),' ')
              FCODE  = FCODEO
              CONT   = CONTO
              NOPICT = 1
            ENDIF
  100       CONTINUE
          ENDIF
C
C  Put functions out to the open workstations.
C
          IF ( 
     +     (FCODE.EQ. -6 .OR. FCODE.EQ. -5 .OR.
     +      FCODE.EQ. -2 .OR. FCODE.EQ.  0 .OR. FCODE.EQ.  1 .OR.
     +      FCODE.EQ.  3 .OR. FCODE.EQ.  6 .OR. FCODE.EQ. 61 .OR.
     +      FCODE.EQ. 56 .OR. FCODE.EQ. 71 .OR. FCODE.EQ. 72 .OR.
     +      FCODE.EQ. 79 .OR. FCODE.EQ. 82 .OR. FCODE.EQ. 84 .OR. 
     +      FCODE.EQ.102 .OR. FCODE.EQ.103 .OR. FCODE.EQ.104 .OR. 
     +      FCODE.EQ. 92 .OR. 
     +     (FCODE.GE. 21.AND. FCODE.LE.43))) THEN
            IF (SWKTP(I) .EQ. GCGM) THEN
C
C  If CUFLAG is set, make the interface call only for the specific
C  workstation.  FCODE of 79 applies only to WISS.
C
              IF (FCODE .EQ. 79) GO TO 10
              IF (CUFLAG.GE.0 .AND. SOPWK(I).NE.CUFLAG) GO TO 50
              CALL G01WDR(SOPWK(I),' ')
   50         CONTINUE
            ELSE IF (SWKTP(I).EQ.GXWC  .OR. SWKTP(I).EQ.GXWE .OR.
     +               SWKTP(I).EQ.GDMP  .OR. SWKTP(I).EQ.GPIX .OR.
     +              (SWKTP(I).GE.GPSMIN .AND. SWKTP(I).LE.GPSMAX) .OR.
     +               SWKTP(I).EQ.GPDFP .OR. SWKTP(I).EQ.GPDFL .OR.
     +         (SWKTP(I).GE.GCROMIN .AND. SWKTP(I).LE.GCROMAX) ) THEN
C
C  If CUFLAG is set, make the interface call only for the specific
C  workstation.
C
              IF (FCODE .EQ. 79) GO TO 10
              IF (CUFLAG.GE.0 .AND. SOPWK(I).NE.CUFLAG) GO TO 10 
C
C  Get the local workstation ID and convert characters to ADE 
C  before invoking the interface.
C
              CALL GZXID(SOPWK(I),XID,RERR)
              IF (RERR .NE. 0) GO TO 55
C
              IF (STRL2 .GT. 0) THEN
                DO 210 J=1,IADIM
                  ADESTR(J) = 0
  210           CONTINUE
                DO 30 J=1,STRL2
                  ADESTR(J) = ICHAR(STR(J:J))
   30           CONTINUE
              ENDIF
C
              CALL GGKWDR(XID,FCODE,CONT,IL1,IL2,ID,IC1,IC2,IC,
     -                    RL1,RL2,RX,RY,STRL1,STRL2,ADESTR,RERR,XERMSG)
            ELSE IF (SWKTP(I) .EQ. GWSS) THEN
              IF (FCODE .EQ. 0) THEN
                IF (CUFLAG.GE.0 .AND. SOPWK(I).NE.CUFLAG) GO TO 10
                CALL GZSRAT(3,ICNTX,RCNTX)
                CALL GWIWDR(ICNTX,RCNTX)
              ELSE IF (FCODE .EQ. 79) THEN
                CALL GWIWDR(ICNTX,RCNTX)
              ENDIF
            ENDIF
   55       CONTINUE
          ENDIF
   10   CONTINUE
      ENDIF
C
C  Put functions out to the active workstations.
C
      IF (IST .GE. GWSAC) THEN
        DO 20 I=1,NACWK
          IF (
     +      FCODE.EQ.-1  .OR. FCODE.EQ.93   .OR. FCODE.EQ.101 .OR.
     +     (FCODE.GE.11 .AND. FCODE.LE.16)) THEN
C
C  Determine the workstation type.
C
            DO 70 J=1,NOPWK
              IF (SACWK(I) .EQ. SOPWK(J)) THEN
                ITYP = SWKTP(J)
                GO TO 90
              ENDIF
   70       CONTINUE
   90       CONTINUE
C
            IF (ITYP .EQ. GCGM) THEN
C
C  If CUFLAG is set, make the interface call only for the specific
C  workstation.
C
              IF (CUFLAG.GE.0 .AND. SACWK(I).NE.CUFLAG) GO TO 60
              CALL G01WDR(SACWK(I),' ')
   60         CONTINUE
            ELSE IF (ITYP.EQ.GXWC  .OR. ITYP.EQ.GXWE .OR.
     +               ITYP.EQ.GDMP  .OR. ITYP.EQ.GPIX .OR.
     +              (ITYP.GE.GPSMIN .AND. ITYP.LE.GPSMAX) .OR.
     +               ITYP.EQ.GPDFP .OR. ITYP.EQ.GPDFL .OR.
     +            (ITYP.GE.GCROMIN .AND. ITYP.LE.GCROMAX) ) THEN
C
C  If CUFLAG is set, make the interface call only for the specific
C  workstation.
C
              IF (CUFLAG.GE.0 .AND. SACWK(I).NE.CUFLAG) GO TO 20
C
C  Get the local workstation ID and convert characters to ADE
C  before invoking the interface.
C
              CALL GZXID(SACWK(I),XID,RERR)
              IF (RERR .NE. 0) GO TO 65
              IF (STRL2 .GT. 0) THEN
                DO 220 J=1,IADIM
                  ADESTR(J) = 0
  220           CONTINUE
                DO 40 J=1,STRL2
                  ADESTR(J) = ICHAR(STR(J:J))
   40           CONTINUE
              ENDIF
              CALL GGKWDR(XID,FCODE,CONT,IL1,IL2,ID,IC1,IC2,IC,
     +                    RL1,RL2,RX,RY,STRL1,STRL2,ADESTR,RERR,XERMSG)
            ENDIF
   65       CONTINUE
          ENDIF
   20   CONTINUE
      ENDIF
C
C  Store segments in WISS.
C
      IF (IST .EQ. GSGOP) THEN
C
C  Open segment name if create segment (GKS was put in state GSGOP
C  by GCRSG before the interface call); flush and close if close segment.      
C
        IF (FCODE.EQ.80 .OR. FCODE.EQ.81) THEN
          CALL GZSRAT(3,ICNTX,RCNTX)
          CALL GWIWDR(ICNTX,RCNTX)
          RETURN
        ENDIF
C
C  Determine if WISS is open, send out appropriate elements if so.
C
        DO 110 I=1,NOPWK
          IF (SWKTP(I) .EQ. GWSS) THEN
            IF (FCODE.EQ. 6 .OR.  FCODE.EQ.61 .OR.
     +         (FCODE.GE.21 .AND. FCODE.LE.43)) THEN          
              CALL GZSRAT(3,ICNTX,RCNTX)
              CALL GWIWDR(ICNTX,RCNTX)
              RETURN
            ENDIF
          ENDIF
  110   CONTINUE
C
C  Determine if WISS is active, send out appropriate elements if so.
C
        DO 130 I=1,NACWK
C
          DO 170 J=1,NOPWK
            IF (SACWK(I) .EQ. SOPWK(J)) THEN
              ITYP = SWKTP(J)
              GO TO 190
            ENDIF
  170     CONTINUE
  190     CONTINUE
C
          IF (ITYP .EQ. GWSS) THEN
            IF (FCODE.GE.11 .AND. FCODE.LE.16) THEN
              CALL GZSRAT(3,ICNTX,RCNTX)
              CALL GWIWDR(ICNTX,RCNTX)
              RETURN
            ENDIF
          ENDIF
  130   CONTINUE
      ENDIF
C
      RETURN
      END

C
C $Id: idgetr.f,v 1.5 2008-07-27 00:17:30 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE IDGETR (PNAM,RVAL)
C
C Get in RVAL the real value of the BIVAR parameter named PNAM.
C
        CHARACTER*(*) PNAM
C
C The common block IDCOMN holds all of the internal parameters of
C the package BIVAR.
C
        COMMON /IDCOMN/ INTY,ITTY,ALSP,BLSP,CLSP,XAVG,YAVG
        SAVE   /IDCOMN/
C
C Define a temporary variable in which to put the first three characters
C of PNAM.
C
        CHARACTER*3 CTMP
C
C Define a character variable in which messages may be formed.
C
        CHARACTER*37 CMSG
C
C Do a call forcing a BLOCKDATA to be loaded from a binary library.
C
        CALL IDBLDA
C
C Check for an uncleared prior error.
C
        IF (ICFELL('IDGETR (BIVAR) - UNCLEARED PRIOR ERROR',1).NE.0)
     +                                                        RETURN
C
C Extract the first three characters of the parameter name.
C
        CTMP=PNAM
C
C If the parameter name has less than three characters, log an error.
C
        IF (LEN(PNAM).LT.3) GO TO 901
C
C See what the parameter name is ...
C
C ... the flag specifying the interpolation type, ...
C
        IF      (CTMP.EQ.'ITY'.OR.CTMP.EQ.'ity') THEN
C
          RVAL=REAL(INTY)
C
C ... or the flag specifying the triangulation type.
C
        ELSE IF (CTMP.EQ.'TTY'.OR.CTMP.EQ.'tty') THEN
C
          RVAL=REAL(ITTY)
C
        ELSE
C
C Otherwise, the parameter name is not recognized.
C
          GO TO 901
C
        END IF
C
        RETURN
C
C Error exit.
C
  901   CMSG(1:37)='IDGETR (BIVAR) - INVALID KEYWORD: '//CTMP
        CALL SETER (CMSG(1:37),2,1)
        RETURN
C
      END

C
C	$Id: gsegdt.f,v 1.6 2008-07-27 00:21:01 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GSEGDT
C
C Calling this do-nothing subroutine forces "ld" to load the following
C block data routine (but only if they are in the same ".f" file).
C
        RETURN
C
      END
CNOSPLIT
      BLOCKDATA GSEGDTX
C
C  Define all constant data for the segment interpreter.
C
      include 'trstat.h'
      include 'trbufr.h'
      include 'trpars.h'
      include 'trinst.h'
      include 'trcode.h'
      include 'trdefl.h'
C
C  Initialize the record pointer.
C
      DATA METREC /1/
C
C  Default polyline info.
C
      DATA POLIDF, LINTDF, LINWDF, TLNCDF /1, 1, 1.0, 1/
C
C  Default marker info.
C
      DATA MARIDF, MARTDF, MARSDF, TMRCDF, PMRSDF /1, 3, 1.0, 1, 320/
C
C  Default text and character info.
C
      DATA HORIDF, VERTDF, PATHDF, CHIGDF, XUDF, YUDF /0,0,0,320,0,1/
      DATA XBDF, YBDF, TXTIDF, TTXCDF, FINDDF, CEXPDF /1,0,1,1,1,1.0/
      DATA CSPADF, TXTPDF /0.0, 0/
C
C  Default fill info.
C
      DATA FILIDF, INTSDF, HATIDF, PATIDF, TFLCDF /1, 0, 1, 1, 1/
      DATA FILRDF /0,0/
C
C  Define the data field default bit sizes.
C
      DATA MOPDLN, MCIDPR, MFLDPR, MWHDPR /16, 8, 16, 16/
      DATA MIXDPR, MENDPR /16,16/
      DATA BYTSIZ, CONFLG /8, 1/
C
C  Define the default aspect source flags.
C
      DATA ASFSDF /ASFMAX*0/
C
C  Control element codes.
C
        DATA CELMVI, CELMCR, CELMCI /1,5,6/
C
C  Flag controlling whether to ignore clipping in segments.
C
        DATA IGSGCP/0/
C
C  Graphical primitive element codes.
C
        DATA GPELPL, GPELPM, GPELTX, GPELPG, GPELCA, GPELGP
     1          /1, 3, 4, 7, 9, 10/
C
C  Define the attribute element codes.
C       
        DATA ATELLI, ATELLT, ATELLW, ATELLC /1, 2, 3, 4/
        DATA ATELMB, ATELMT, ATELMZ, ATELMC /5, 6, 7, 8/
        DATA ATELTI, ATELTF, ATELTP, ATELCE, ATELCS /9, 10, 11, 12, 13/
        DATA ATELTC, ATELCH, ATELCO, ATELTH, ATELTA /14,15,16,17,18/
        DATA ATELFI, ATELIS, ATELFC, ATELHI, ATELPI /21,22,23,24,25/
        DATA ATELFR, ATELPT, ATELPS, ATELCB, ATELAS /31,32,33,34,35/
C
      END

C
C $Id: mdqin2.f,v 1.6 2008-09-18 00:42:18 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MDQIN2 (
     +            ALFAQ,COSOQ,COSRQ,CSLSQ,CSLTQ,DCSAQ,DCSBQ,DSNAQ,DSNBQ,
     +            DTORQ,DTRHQ,OOPIQ,PLNOQ,  PIQ,PIOTQ,ROTAQ,RTDDQ,RTODQ,
     +            SALTQ,SINOQ,SINRQ,SRSSQ,SSMOQ,TOPIQ,UCNMQ,UMNMQ,UMXMQ,
     +            UOFFQ,URNMQ,VCNMQ,VMNMQ,VMXMQ,VOFFQ,VRNMQ,UTPAQ,IPRFQ,
     +            IPRJQ,IRODQ,ELPMQ)
C
      DOUBLE PRECISION
     +            ALFAQ,COSOQ,COSRQ,CSLSQ,CSLTQ,DCSAQ,DCSBQ,DSNAQ,DSNBQ,
     +            DTORQ,DTRHQ,OOPIQ,PLNOQ,  PIQ,PIOTQ,ROTAQ,RTDDQ,RTODQ,
     +            SALTQ,SINOQ,SINRQ,SRSSQ,SSMOQ,TOPIQ,UCNMQ,UMNMQ,UMXMQ,
     +            UOFFQ,URNMQ,VCNMQ,VMNMQ,VMXMQ,VOFFQ,VRNMQ,UTPAQ(15)
C
      INTEGER IPRFQ,IPRJQ,IRODQ
C
      LOGICAL ELPMQ
C
C Declare a special common block, containing only those variables that
C MDQINI needs to set to make MDQTRA, MDQTRI, and MDQTRN carry out the
C transformation in effect at the time MDQINI was called.
C
        COMMON /MAQCMN/  ALFA,COSO,COSR,CSLS,CSLT,DCSA,DCSB,DSNA,DSNB,
     +                   DTOR,DTRH,OOPI,PLNO,  PI,PIOT,ROTA,RTDD,RTOD,
     +                   SALT,SINO,SINR,SRSS,SSMO,TOPI,UCNM,UMNM,UMXM,
     +                   UOFF,URNM,VCNM,VMNM,VMXM,VOFF,VRNM,UTPA,IPRF,
     +                   IPRJ,IROD,ELPM
        DOUBLE PRECISION ALFA,COSO,COSR,CSLS,CSLT,DCSA,DCSB,DSNA,DSNB,
     +                   DTOR,DTRH,OOPI,PLNO,  PI,PIOT,ROTA,RTDD,RTOD,
     +                   SALT,SINO,SINR,SRSS,SSMO,TOPI,UCNM,UMNM,UMXM,
     +                   UOFF,URNM,VCNM,VMNM,VMXM,VOFF,VRNM,UTPA(15)
C
        INTEGER IPRF,IPRJ,IROD
C
        LOGICAL ELPM
C
        SAVE   /MAQCMN/
C
        INTEGER I
C
C Transfer the required variables to the local common block.
C
        ALFA=ALFAQ
        COSO=COSOQ
        COSR=COSRQ
        CSLS=CSLSQ
        CSLT=CSLTQ
        DCSA=DCSAQ
        DCSB=DCSBQ
        DSNA=DSNAQ
        DSNB=DSNBQ
        DTOR=DTORQ
        DTRH=DTRHQ
        ELPM=ELPMQ
        IPRJ=IPRJQ
        IROD=IRODQ
        OOPI=OOPIQ
        PLNO=PLNOQ
          PI=  PIQ
        PIOT=PIOTQ
        ROTA=ROTAQ
        RTDD=RTDDQ
        RTOD=RTODQ
        SALT=SALTQ
        SINO=SINOQ
        SINR=SINRQ
        SRSS=SRSSQ
        SSMO=SSMOQ
        TOPI=TOPIQ
        UCNM=UCNMQ
        UMNM=UMNMQ
        UMXM=UMXMQ
        UOFF=UOFFQ
        URNM=URNMQ
        VCNM=VCNMQ
        VMNM=VMNMQ
        VMXM=VMXMQ
        VOFF=VOFFQ
        VRNM=VRNMQ 
C
        IPRF=IPRFQ
C
        DO 101 I=1,15
          UTPA(I)=UTPAQ(I)
  101   CONTINUE
C
C Done.
C
        RETURN
C
      END

C
C	$Id: lastd.f,v 1.4 2008-07-27 00:23:02 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE LASTD
      SAVE
C USER ENTRY POINT. SEE DOCUMENTATION FOR PURPOSE.
      DATA IDUMMY /0/
      CALL CFVLD (3,IDUMMY,IDUMMY)
      CALL PLOTIT (0,0,0)
      RETURN
      END

      SUBROUTINE DTRSNA( JOB, HOWMNY, SELECT, N, T, LDT, VL, LDVL, VR,
     $                   LDVR, S, SEP, MM, M, WORK, LDWORK, IWORK,
     $                   INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER          HOWMNY, JOB
      INTEGER            INFO, LDT, LDVL, LDVR, LDWORK, M, MM, N
*     ..
*     .. Array Arguments ..
      LOGICAL            SELECT( * )
      INTEGER            IWORK( * )
      DOUBLE PRECISION   S( * ), SEP( * ), T( LDT, * ), VL( LDVL, * ),
     $                   VR( LDVR, * ), WORK( LDWORK, * )
*     ..
*
*  Purpose
*  =======
*
*  DTRSNA estimates reciprocal condition numbers for specified
*  eigenvalues and/or right eigenvectors of a real upper
*  quasi-triangular matrix T (or of any matrix Q*T*Q**T with Q
*  orthogonal).
*
*  T must be in Schur canonical form (as returned by DHSEQR), that is,
*  block upper triangular with 1-by-1 and 2-by-2 diagonal blocks; each
*  2-by-2 diagonal block has its diagonal elements equal and its
*  off-diagonal elements of opposite sign.
*
*  Arguments
*  =========
*
*  JOB     (input) CHARACTER*1
*          Specifies whether condition numbers are required for
*          eigenvalues (S) or eigenvectors (SEP):
*          = 'E': for eigenvalues only (S);
*          = 'V': for eigenvectors only (SEP);
*          = 'B': for both eigenvalues and eigenvectors (S and SEP).
*
*  HOWMNY  (input) CHARACTER*1
*          = 'A': compute condition numbers for all eigenpairs;
*          = 'S': compute condition numbers for selected eigenpairs
*                 specified by the array SELECT.
*
*  SELECT  (input) LOGICAL array, dimension (N)
*          If HOWMNY = 'S', SELECT specifies the eigenpairs for which
*          condition numbers are required. To select condition numbers
*          for the eigenpair corresponding to a real eigenvalue w(j),
*          SELECT(j) must be set to .TRUE.. To select condition numbers
*          corresponding to a complex conjugate pair of eigenvalues w(j)
*          and w(j+1), either SELECT(j) or SELECT(j+1) or both, must be
*          set to .TRUE..
*          If HOWMNY = 'A', SELECT is not referenced.
*
*  N       (input) INTEGER
*          The order of the matrix T. N >= 0.
*
*  T       (input) DOUBLE PRECISION array, dimension (LDT,N)
*          The upper quasi-triangular matrix T, in Schur canonical form.
*
*  LDT     (input) INTEGER
*          The leading dimension of the array T. LDT >= max(1,N).
*
*  VL      (input) DOUBLE PRECISION array, dimension (LDVL,M)
*          If JOB = 'E' or 'B', VL must contain left eigenvectors of T
*          (or of any Q*T*Q**T with Q orthogonal), corresponding to the
*          eigenpairs specified by HOWMNY and SELECT. The eigenvectors
*          must be stored in consecutive columns of VL, as returned by
*          DHSEIN or DTREVC.
*          If JOB = 'V', VL is not referenced.
*
*  LDVL    (input) INTEGER
*          The leading dimension of the array VL.
*          LDVL >= 1; and if JOB = 'E' or 'B', LDVL >= N.
*
*  VR      (input) DOUBLE PRECISION array, dimension (LDVR,M)
*          If JOB = 'E' or 'B', VR must contain right eigenvectors of T
*          (or of any Q*T*Q**T with Q orthogonal), corresponding to the
*          eigenpairs specified by HOWMNY and SELECT. The eigenvectors
*          must be stored in consecutive columns of VR, as returned by
*          DHSEIN or DTREVC.
*          If JOB = 'V', VR is not referenced.
*
*  LDVR    (input) INTEGER
*          The leading dimension of the array VR.
*          LDVR >= 1; and if JOB = 'E' or 'B', LDVR >= N.
*
*  S       (output) DOUBLE PRECISION array, dimension (MM)
*          If JOB = 'E' or 'B', the reciprocal condition numbers of the
*          selected eigenvalues, stored in consecutive elements of the
*          array. For a complex conjugate pair of eigenvalues two
*          consecutive elements of S are set to the same value. Thus
*          S(j), SEP(j), and the j-th columns of VL and VR all
*          correspond to the same eigenpair (but not in general the
*          j-th eigenpair, unless all eigenpairs are selected).
*          If JOB = 'V', S is not referenced.
*
*  SEP     (output) DOUBLE PRECISION array, dimension (MM)
*          If JOB = 'V' or 'B', the estimated reciprocal condition
*          numbers of the selected eigenvectors, stored in consecutive
*          elements of the array. For a complex eigenvector two
*          consecutive elements of SEP are set to the same value. If
*          the eigenvalues cannot be reordered to compute SEP(j), SEP(j)
*          is set to 0; this can only occur when the true value would be
*          very small anyway.
*          If JOB = 'E', SEP is not referenced.
*
*  MM      (input) INTEGER
*          The number of elements in the arrays S (if JOB = 'E' or 'B')
*           and/or SEP (if JOB = 'V' or 'B'). MM >= M.
*
*  M       (output) INTEGER
*          The number of elements of the arrays S and/or SEP actually
*          used to store the estimated condition numbers.
*          If HOWMNY = 'A', M is set to N.
*
*  WORK    (workspace) DOUBLE PRECISION array, dimension (LDWORK,N+1)
*          If JOB = 'E', WORK is not referenced.
*
*  LDWORK  (input) INTEGER
*          The leading dimension of the array WORK.
*          LDWORK >= 1; and if JOB = 'V' or 'B', LDWORK >= N.
*
*  IWORK   (workspace) INTEGER array, dimension (N)
*          If JOB = 'E', IWORK is not referenced.
*
*  INFO    (output) INTEGER
*          = 0: successful exit
*          < 0: if INFO = -i, the i-th argument had an illegal value
*
*  Further Details
*  ===============
*
*  The reciprocal of the condition number of an eigenvalue lambda is
*  defined as
*
*          S(lambda) = |v'*u| / (norm(u)*norm(v))
*
*  where u and v are the right and left eigenvectors of T corresponding
*  to lambda; v' denotes the conjugate-transpose of v, and norm(u)
*  denotes the Euclidean norm. These reciprocal condition numbers always
*  lie between zero (very badly conditioned) and one (very well
*  conditioned). If n = 1, S(lambda) is defined to be 1.
*
*  An approximate error bound for a computed eigenvalue W(i) is given by
*
*                      EPS * norm(T) / S(i)
*
*  where EPS is the machine precision.
*
*  The reciprocal of the condition number of the right eigenvector u
*  corresponding to lambda is defined as follows. Suppose
*
*              T = ( lambda  c  )
*                  (   0    T22 )
*
*  Then the reciprocal condition number is
*
*          SEP( lambda, T22 ) = sigma-min( T22 - lambda*I )
*
*  where sigma-min denotes the smallest singular value. We approximate
*  the smallest singular value by the reciprocal of an estimate of the
*  one-norm of the inverse of T22 - lambda*I. If n = 1, SEP(1) is
*  defined to be abs(T(1,1)).
*
*  An approximate error bound for a computed right eigenvector VR(i)
*  is given by
*
*                      EPS * norm(T) / SEP(i)
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO, ONE, TWO
      PARAMETER          ( ZERO = 0.0D+0, ONE = 1.0D+0, TWO = 2.0D+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            PAIR, SOMCON, WANTBH, WANTS, WANTSP
      INTEGER            I, IERR, IFST, ILST, J, K, KASE, KS, N2, NN
      DOUBLE PRECISION   BIGNUM, COND, CS, DELTA, DUMM, EPS, EST, LNRM,
     $                   MU, PROD, PROD1, PROD2, RNRM, SCALE, SMLNUM, SN
*     ..
*     .. Local Arrays ..
      DOUBLE PRECISION   DUMMY( 1 )
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      DOUBLE PRECISION   DDOT, DLAMCH, DLAPY2, DNRM2
      EXTERNAL           LSAME, DDOT, DLAMCH, DLAPY2, DNRM2
*     ..
*     .. External Subroutines ..
      EXTERNAL           DLACON, DLACPY, DLAQTR, DTREXC, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, MAX, SQRT
*     ..
*     .. Executable Statements ..
*
*     Decode and test the input parameters
*
      WANTBH = LSAME( JOB, 'B' )
      WANTS = LSAME( JOB, 'E' ) .OR. WANTBH
      WANTSP = LSAME( JOB, 'V' ) .OR. WANTBH
*
      SOMCON = LSAME( HOWMNY, 'S' )
*
      INFO = 0
      IF( .NOT.WANTS .AND. .NOT.WANTSP ) THEN
         INFO = -1
      ELSE IF( .NOT.LSAME( HOWMNY, 'A' ) .AND. .NOT.SOMCON ) THEN
         INFO = -2
      ELSE IF( N.LT.0 ) THEN
         INFO = -4
      ELSE IF( LDT.LT.MAX( 1, N ) ) THEN
         INFO = -6
      ELSE IF( LDVL.LT.1 .OR. ( WANTS .AND. LDVL.LT.N ) ) THEN
         INFO = -8
      ELSE IF( LDVR.LT.1 .OR. ( WANTS .AND. LDVR.LT.N ) ) THEN
         INFO = -10
      ELSE
*
*        Set M to the number of eigenpairs for which condition numbers
*        are required, and test MM.
*
         IF( SOMCON ) THEN
            M = 0
            PAIR = .FALSE.
            DO 10 K = 1, N
               IF( PAIR ) THEN
                  PAIR = .FALSE.
               ELSE
                  IF( K.LT.N ) THEN
                     IF( T( K+1, K ).EQ.ZERO ) THEN
                        IF( SELECT( K ) )
     $                     M = M + 1
                     ELSE
                        PAIR = .TRUE.
                        IF( SELECT( K ) .OR. SELECT( K+1 ) )
     $                     M = M + 2
                     END IF
                  ELSE
                     IF( SELECT( N ) )
     $                  M = M + 1
                  END IF
               END IF
   10       CONTINUE
         ELSE
            M = N
         END IF
*
         IF( MM.LT.M ) THEN
            INFO = -13
         ELSE IF( LDWORK.LT.1 .OR. ( WANTSP .AND. LDWORK.LT.N ) ) THEN
            INFO = -16
         END IF
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DTRSNA', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
*
      IF( N.EQ.1 ) THEN
         IF( SOMCON ) THEN
            IF( .NOT.SELECT( 1 ) )
     $         RETURN
         END IF
         IF( WANTS )
     $      S( 1 ) = ONE
         IF( WANTSP )
     $      SEP( 1 ) = ABS( T( 1, 1 ) )
         RETURN
      END IF
*
*     Get machine constants
*
      EPS = DLAMCH( 'P' )
      SMLNUM = DLAMCH( 'S' ) / EPS
      BIGNUM = ONE / SMLNUM
      CALL DLABAD( SMLNUM, BIGNUM )
*
      KS = 0
      PAIR = .FALSE.
      DO 60 K = 1, N
*
*        Determine whether T(k,k) begins a 1-by-1 or 2-by-2 block.
*
         IF( PAIR ) THEN
            PAIR = .FALSE.
            GO TO 60
         ELSE
            IF( K.LT.N )
     $         PAIR = T( K+1, K ).NE.ZERO
         END IF
*
*        Determine whether condition numbers are required for the k-th
*        eigenpair.
*
         IF( SOMCON ) THEN
            IF( PAIR ) THEN
               IF( .NOT.SELECT( K ) .AND. .NOT.SELECT( K+1 ) )
     $            GO TO 60
            ELSE
               IF( .NOT.SELECT( K ) )
     $            GO TO 60
            END IF
         END IF
*
         KS = KS + 1
*
         IF( WANTS ) THEN
*
*           Compute the reciprocal condition number of the k-th
*           eigenvalue.
*
            IF( .NOT.PAIR ) THEN
*
*              Real eigenvalue.
*
               PROD = DDOT( N, VR( 1, KS ), 1, VL( 1, KS ), 1 )
               RNRM = DNRM2( N, VR( 1, KS ), 1 )
               LNRM = DNRM2( N, VL( 1, KS ), 1 )
               S( KS ) = ABS( PROD ) / ( RNRM*LNRM )
            ELSE
*
*              Complex eigenvalue.
*
               PROD1 = DDOT( N, VR( 1, KS ), 1, VL( 1, KS ), 1 )
               PROD1 = PROD1 + DDOT( N, VR( 1, KS+1 ), 1, VL( 1, KS+1 ),
     $                 1 )
               PROD2 = DDOT( N, VL( 1, KS ), 1, VR( 1, KS+1 ), 1 )
               PROD2 = PROD2 - DDOT( N, VL( 1, KS+1 ), 1, VR( 1, KS ),
     $                 1 )
               RNRM = DLAPY2( DNRM2( N, VR( 1, KS ), 1 ),
     $                DNRM2( N, VR( 1, KS+1 ), 1 ) )
               LNRM = DLAPY2( DNRM2( N, VL( 1, KS ), 1 ),
     $                DNRM2( N, VL( 1, KS+1 ), 1 ) )
               COND = DLAPY2( PROD1, PROD2 ) / ( RNRM*LNRM )
               S( KS ) = COND
               S( KS+1 ) = COND
            END IF
         END IF
*
         IF( WANTSP ) THEN
*
*           Estimate the reciprocal condition number of the k-th
*           eigenvector.
*
*           Copy the matrix T to the array WORK and swap the diagonal
*           block beginning at T(k,k) to the (1,1) position.
*
            CALL DLACPY( 'Full', N, N, T, LDT, WORK, LDWORK )
            IFST = K
            ILST = 1
            CALL DTREXC( 'No Q', N, WORK, LDWORK, DUMMY, 1, IFST, ILST,
     $                   WORK( 1, N+1 ), IERR )
*
            IF( IERR.EQ.1 .OR. IERR.EQ.2 ) THEN
*
*              Could not swap because blocks not well separated
*
               SCALE = ONE
               EST = BIGNUM
            ELSE
*
*              Reordering successful
*
               IF( WORK( 2, 1 ).EQ.ZERO ) THEN
*
*                 Form C = T22 - lambda*I in WORK(2:N,2:N).
*
                  DO 20 I = 2, N
                     WORK( I, I ) = WORK( I, I ) - WORK( 1, 1 )
   20             CONTINUE
                  N2 = 1
                  NN = N - 1
               ELSE
*
*                 Triangularize the 2 by 2 block by unitary
*                 transformation U = [  cs   i*ss ]
*                                    [ i*ss   cs  ].
*                 such that the (1,1) position of WORK is complex
*                 eigenvalue lambda with positive imaginary part. (2,2)
*                 position of WORK is the complex eigenvalue lambda
*                 with negative imaginary  part.
*
                  MU = SQRT( ABS( WORK( 1, 2 ) ) )*
     $                 SQRT( ABS( WORK( 2, 1 ) ) )
                  DELTA = DLAPY2( MU, WORK( 2, 1 ) )
                  CS = MU / DELTA
                  SN = -WORK( 2, 1 ) / DELTA
*
*                 Form
*
*                 C' = WORK(2:N,2:N) + i*[rwork(1) ..... rwork(n-1) ]
*                                        [   mu                     ]
*                                        [         ..               ]
*                                        [             ..           ]
*                                        [                  mu      ]
*                 where C' is conjugate transpose of complex matrix C,
*                 and RWORK is stored starting in the N+1-st column of
*                 WORK.
*
                  DO 30 J = 3, N
                     WORK( 2, J ) = CS*WORK( 2, J )
                     WORK( J, J ) = WORK( J, J ) - WORK( 1, 1 )
   30             CONTINUE
                  WORK( 2, 2 ) = ZERO
*
                  WORK( 1, N+1 ) = TWO*MU
                  DO 40 I = 2, N - 1
                     WORK( I, N+1 ) = SN*WORK( 1, I+1 )
   40             CONTINUE
                  N2 = 2
                  NN = 2*( N-1 )
               END IF
*
*              Estimate norm(inv(C'))
*
               EST = ZERO
               KASE = 0
   50          CONTINUE
               CALL DLACON( NN, WORK( 1, N+2 ), WORK( 1, N+4 ), IWORK,
     $                      EST, KASE )
               IF( KASE.NE.0 ) THEN
                  IF( KASE.EQ.1 ) THEN
                     IF( N2.EQ.1 ) THEN
*
*                       Real eigenvalue: solve C'*x = scale*c.
*
                        CALL DLAQTR( .TRUE., .TRUE., N-1, WORK( 2, 2 ),
     $                               LDWORK, DUMMY, DUMM, SCALE,
     $                               WORK( 1, N+4 ), WORK( 1, N+6 ),
     $                               IERR )
                     ELSE
*
*                       Complex eigenvalue: solve
*                       C'*(p+iq) = scale*(c+id) in real arithmetic.
*
                        CALL DLAQTR( .TRUE., .FALSE., N-1, WORK( 2, 2 ),
     $                               LDWORK, WORK( 1, N+1 ), MU, SCALE,
     $                               WORK( 1, N+4 ), WORK( 1, N+6 ),
     $                               IERR )
                     END IF
                  ELSE
                     IF( N2.EQ.1 ) THEN
*
*                       Real eigenvalue: solve C*x = scale*c.
*
                        CALL DLAQTR( .FALSE., .TRUE., N-1, WORK( 2, 2 ),
     $                               LDWORK, DUMMY, DUMM, SCALE,
     $                               WORK( 1, N+4 ), WORK( 1, N+6 ),
     $                               IERR )
                     ELSE
*
*                       Complex eigenvalue: solve
*                       C*(p+iq) = scale*(c+id) in real arithmetic.
*
                        CALL DLAQTR( .FALSE., .FALSE., N-1,
     $                               WORK( 2, 2 ), LDWORK,
     $                               WORK( 1, N+1 ), MU, SCALE,
     $                               WORK( 1, N+4 ), WORK( 1, N+6 ),
     $                               IERR )
*
                     END IF
                  END IF
*
                  GO TO 50
               END IF
            END IF
*
            SEP( KS ) = SCALE / MAX( EST, SMLNUM )
            IF( PAIR )
     $         SEP( KS+1 ) = SEP( KS )
         END IF
*
         IF( PAIR )
     $      KS = KS + 1
*
   60 CONTINUE
      RETURN
*
*     End of DTRSNA
*
      END

        PROGRAM CPEX01
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
        PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Declare an array to hold the data to be contoured.
C
        DIMENSION ZDAT(23,14)
C
C Declare an array to hold dense data (5152=4x4x23x14).
C
        DIMENSION ZDNS(5152)
C
C Declare the required real and integer workspaces.
C
        DIMENSION RWRK(5000),IWRK(1000)
C
C Declare an array to hold an area map.
C
        DIMENSION IAMA(25000)
C
C Declare the arrays needed by ARSCAM for x/y coordinates.
C
        DIMENSION XCRA(1000),YCRA(1000)
C
C Declare the arrays needed by ARSCAM for area and group identifiers.
C
        DIMENSION IARA(10),IGRA(10)
C
C Declare an array to hold the GKS "aspect source flags".
C
        DIMENSION IASF(13)
C
C Declare the routine which will draw contour lines, avoiding labels.
C
        EXTERNAL DRAWCL
C
C Declare the routine which does the shading.
C
        EXTERNAL SHADER
C
C Initialize the values in the aspect-source-flag array.
C
        DATA IASF / 13*1 /
C
C Open GKS.
C
        CALL GOPKS (IERRF, ISZDM)
        CALL GOPWK (IWKID, LUNIT, IWTYPE)
        CALL GACWK (IWKID)
C
C Turn off the clipping indicator.
C
        CALL GSCLIP (0)
C
C Set all the GKS aspect source flags to "individual".
C
        CALL GSASF (IASF)
C
C Generate an array of test data.
C
        CALL GENDAT (ZDAT,23,23,14,20,20,-136.148,451.834)
C
C Example 1-1 ---------------------------------------------------------
C
C Force PLOTCHAR to use characters of the lowest quality.
C
        CALL PCSETI ('QU - QUALITY FLAG',2)
C
C Initialize the drawing of the contour plot.
C
        CALL CPRECT (ZDAT,23,23,14,RWRK,5000,IWRK,1000)
C
C Draw the default background.
C
        CALL CPBACK (ZDAT,RWRK,IWRK)
C
C Draw contour lines and labels.
C
        CALL CPCLDR (ZDAT,RWRK,IWRK)
C
C Add the informational label and the high/low labels.
C
        CALL CPLBDR (ZDAT,RWRK,IWRK)
C
C Compute and print statistics for the plot, label it, and put a
C boundary line around the edge of the plotter frame.
C
        CALL CAPSAP ('EXAMPLE 1-1',IAMA,0)
        CALL LABTOP ('EXAMPLE 1-1',.017)
        CALL BNDARY
C
C Advance the frame.
C
        CALL FRAME
C
C Example 1-2 ---------------------------------------------------------
C
C Make PLOTCHAR use medium-quality characters.
C
        CALL PCSETI ('QU - QUALITY FLAG',1)
C
C Turn on the positioning of labels by the penalty scheme.
C
        CALL CPSETI ('LLP - LINE LABEL POSITIONING',3)
C
C Turn on the drawing of the high and low label boxes.
C
        CALL CPSETI ('HLB - HIGH/LOW LABEL BOX FLAG',1)
C
C Tell CONPACK to delete high/low labels which overlap the informational
C label, another high/low label, or the edge.
C
        CALL CPSETI ('HLO - HIGH/LOW LABEL OVERLAP FLAG',7)
C
C Tell CONPACK not to choose contour levels, so that the ones chosen
C for example 1-1 will be used.
C
        CALL CPSETI ('CLS - CONTOUR LEVEL SELECTION FLAG',0)
C
C Increase the line width for labelled levels.
C
        CALL CPGETI ('NCL - NUMBER OF CONTOUR LEVELS',NCLV)
C
        DO 101 ICLV=1,NCLV
          CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',ICLV)
          CALL CPGETI ('CLU - CONTOUR LEVEL USE FLAG',ICLU)
          IF (ICLU.EQ.3) THEN
            CALL CPSETI ('CLL - CONTOUR-LINE LINE WIDTH',2)
          END IF
  101   CONTINUE
C
C Initialize the drawing of the contour plot.
C
        CALL CPRECT (ZDAT,23,23,14,RWRK,5000,IWRK,1000)
C
C Draw the default background, using a wider line than normal.
C
        CALL GSLWSC (2.)
        CALL CPBACK (ZDAT,RWRK,IWRK)
        CALL GSLWSC (1.)
C
C Initialize the area map.
C
        CALL ARINAM (IAMA,25000)
C
C Put label boxes into the area map.
C
        CALL CPLBAM (ZDAT,RWRK,IWRK,IAMA)
C
C Draw contour lines, avoiding drawing them through the label boxes.
C
        CALL CPCLDM (ZDAT,RWRK,IWRK,IAMA,DRAWCL)
C
C Draw all the labels.
C
        CALL CPLBDR (ZDAT,RWRK,IWRK)
C
C Compute and print statistics for the plot, label it, and put a
C boundary line around the edge of the plotter frame.
C
        CALL CAPSAP ('EXAMPLE 1-2',IAMA,25000)
        CALL LABTOP ('EXAMPLE 1-2',.017)
        CALL BNDARY
C
C Advance the frame.
C
        CALL FRAME
C
C Example 1-3 ---------------------------------------------------------
C
C Make PLOTCHAR use high-quality characters.
C
        CALL PCSETI ('QU - QUALITY FLAG',0)
C
C Tell CONPACK to delete high/low labels which overlap the informational
C label or another high/low label, but to move those which overlap the
C edge inward a little.
C
        CALL CPSETI ('HLO - HIGH/LOW LABEL OVERLAP FLAG',11)
C
C Turn off the area identifiers for all except the zero contour and set
C its identifiers in such a way that we can shade the areas "below" that
C contour.
C
        DO 102 ICLV=1,NCLV
          CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',ICLV)
          CALL CPGETR ('CLV - CONTOUR LEVEL VALUE',CLEV)
          IF (CLEV.NE.0.) THEN
            CALL CPSETI ('AIA - AREA IDENTIFIER ABOVE LINE',0)
            CALL CPSETI ('AIB - AREA IDENTIFIER BELOW LINE',0)
          ELSE
            CALL CPSETI ('AIA - AREA IDENTIFIER ABOVE LINE',2)
            CALL CPSETI ('AIB - AREA IDENTIFIER BELOW LINE',1)
          END IF
  102   CONTINUE
C
C Draw the contour plot, using the same calls as for example 1-2.
C
        CALL CPRECT (ZDAT,23,23,14,RWRK,5000,IWRK,1000)
        CALL GSLWSC (2.)
        CALL CPBACK (ZDAT,RWRK,IWRK)
        CALL GSLWSC (1.)
        CALL ARINAM (IAMA,25000)
        CALL CPLBAM (ZDAT,RWRK,IWRK,IAMA)
        CALL CPCLDM (ZDAT,RWRK,IWRK,IAMA,DRAWCL)
        CALL CPLBDR (ZDAT,RWRK,IWRK)
C
C Now, add the zero contour line to the area map.
C
        CALL CPCLAM (ZDAT,RWRK,IWRK,IAMA)
C
C Scan the area map.  The routine SHADER will be called to shade the
C areas below the zero contour line.
C
        CALL ARSCAM (IAMA,XCRA,YCRA,1000,IARA,IGRA,10,SHADER)
C
C Compute and print statistics for the plot, label it, and put a
C boundary line around the edge of the plotter frame.
C
        CALL CAPSAP ('EXAMPLE 1-3',IAMA,25000)
        CALL LABTOP ('EXAMPLE 1-3',.017)
        CALL BNDARY
C
C Advance the frame.
C
        CALL FRAME
C
C Example 1-4 ---------------------------------------------------------
C
C Turn on the 2D smoother.
C
        CALL CPSETR ('T2D - TENSION ON THE 2D SPLINES',1.)
C
C Draw the contour plot, using the same calls as for example 1-3.
C
        CALL CPRECT (ZDAT,23,23,14,RWRK,5000,IWRK,1000)
        CALL GSLWSC (2.)
        CALL CPBACK (ZDAT,RWRK,IWRK)
        CALL GSLWSC (1.)
        CALL ARINAM (IAMA,25000)
        CALL CPLBAM (ZDAT,RWRK,IWRK,IAMA)
        CALL CPCLDM (ZDAT,RWRK,IWRK,IAMA,DRAWCL)
        CALL CPLBDR (ZDAT,RWRK,IWRK)
        CALL CPCLAM (ZDAT,RWRK,IWRK,IAMA)
        CALL ARSCAM (IAMA,XCRA,YCRA,1000,IARA,IGRA,10,SHADER)
C
C Compute and print statistics for the plot, label it, and put a
C boundary line around the edge of the plotter frame.
C
        CALL CAPSAP ('EXAMPLE 1-4',IAMA,25000)
        CALL LABTOP ('EXAMPLE 1-4',.017)
        CALL BNDARY
C
C Advance the frame.
C
        CALL FRAME
C
C Example 1-5 ---------------------------------------------------------
C
C Make CONPACK set up the contour levels again (the range of the data
C may be increased by 3D interpolation), but force it to use the same
C contour interval and label interval that were used for the first four
C plots.
C
        CALL CPSETI ('CLS - CONTOUR LEVEL SELECTION FLAG',16)
        CALL CPGETR ('CIU - CONTOUR INTERVAL USED',CINU)
        CALL CPSETR ('CIS - CONTOUR INTERVAL SPECIFIER',CINU)
        CALL CPGETI ('LIU - LABEL INTERVAL USED',LINU)
        CALL CPSETI ('LIS - LABEL INTERVAL SPECIFIER',LINU)
C
C Provide more room for storing coordinates used to trace contour
C lines.  The default is slightly too small to hold a complete line,
C and this causes some lines to have a couple of labels right next to
C one another.
C
        CALL CPSETI ('RWC - REAL WORKSPACE FOR CONTOUR TRACING',200)
C
C Turn off the 2D smoother.
C
        CALL CPSETR ('T2D - TENSION ON THE 2D SPLINES',0.)
C
C Initialize the drawing of the contour plot.
C
        CALL CPSPRS (ZDAT,23,23,14,RWRK,5000,IWRK,1000,ZDNS,5152)
C
C Force the selection of contour levels and tweak associated parameters.
C
        CALL CPPKCL (ZDNS,RWRK,IWRK)
C
        CALL CPGETI ('NCL - NUMBER OF CONTOUR LEVELS',NCLV)
C
        DO 103 ICLV=1,NCLV
          CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',ICLV)
          CALL CPGETI ('CLU - CONTOUR LEVEL USE FLAG',ICLU)
          IF (ICLU.EQ.3) THEN
            CALL CPSETI ('CLL - CONTOUR LINE LINE WIDTH',2)
          END IF
          CALL CPGETR ('CLV - CONTOUR LEVEL VALUE',CLEV)
          IF (CLEV.NE.0.) THEN
            CALL CPSETI ('AIA - AREA IDENTIFIER ABOVE LINE',0)
            CALL CPSETI ('AIB - AREA IDENTIFIER BELOW LINE',0)
          ELSE
            CALL CPSETI ('AIA - AREA IDENTIFIER ABOVE LINE',2)
            CALL CPSETI ('AIB - AREA IDENTIFIER BELOW LINE',1)
          END IF
  103   CONTINUE
C
C The rest is pretty much the same as for example 1-4, but the array
C ZDNS is used in place of ZDAT.
C
        CALL GSLWSC (2.)
        CALL PERIM (0,0,0,0)
        CALL GSLWSC (1.)
        CALL ARINAM (IAMA,25000)
        CALL CPLBAM (ZDNS,RWRK,IWRK,IAMA)
        CALL CPCLDM (ZDNS,RWRK,IWRK,IAMA,DRAWCL)
        CALL CPLBDR (ZDNS,RWRK,IWRK)
        CALL CPCLAM (ZDNS,RWRK,IWRK,IAMA)
        CALL ARSCAM (IAMA,XCRA,YCRA,1000,IARA,IGRA,10,SHADER)
C
C Compute and print statistics for the plot, label it, and put a
C boundary line around the edge of the plotter frame.
C
        CALL CAPSAP ('EXAMPLE 1-5',IAMA,25000)
        CALL LABTOP ('EXAMPLE 1-5',.017)
        CALL BNDARY
C
C Advance the frame.
C
        CALL FRAME
C
C Example 1-6 ---------------------------------------------------------
C
C Turn off the selection of contour levels, so that the set picked for
C example 1-5 will be used.
C
        CALL CPSETI ('CLS - CONTOUR LEVEL SELECTION FLAG',0)
C
C Draw an EZMAP background.  The perimeter and the grid are turned off.
C The "political + U.S. states" dataset is used and it is dotted.  We
C use a satellite-view projection, centered over the U.S., showing
C maximal area.
C
        CALL MAPSTI ('PE - PERIMETER',0)
        CALL MAPSTI ('GR - GRID',0)
        CALL MAPSTC ('OU - OUTLINE DATASET','PS')
        CALL MAPSTI ('DO - DOTTING OF OUTLINES',1)
        CALL MAPSTR ('SA - SATELLITE HEIGHT',1.13)
        CALL MAPROJ ('SV - SATELLITE-VIEW',40.,-95.,0.)
        CALL MAPSET ('MA - MAXIMAL AREA',0.,0.,0.,0.)
        CALL MAPDRW
C
C Tell CONPACK that the SET call has been done, force it to generate X
C coordinates that are longitudes and Y coordinates that are latitudes,
C turn on mapping to an EZMAP background, define the out-of-range value
C (returned by MAPTRN for an unprojectable point), and put the
C informational label in a different place.
C
        CALL CPSETI ('SET - DO SET-CALL FLAG',0)
        CALL CPSETR ('XC1 - X COORDINATE AT I = 1',-130.)
        CALL CPSETR ('XCM - X COORDINATE AT I = M',-60.)
        CALL CPSETR ('YC1 - Y COORDINATE AT J = 1',10.)
        CALL CPSETR ('YCN - Y COORDINATE AT J = N',70.)
        CALL CPSETI ('MAP - MAPPING FLAG',1)
        CALL CPSETR ('ORV - OUT-OF-RANGE VALUE',1.E12)
        CALL CPSETI ('ILP - INFORMATIONAL LABEL POSITIONING',3)
        CALL CPSETR ('ILX - INFORMATIONAL LABEL X POSITION',.5)
        CALL CPSETR ('ILY - INFORMATIONAL LABEL Y POSITION',-.02)
C
C The rest of the calls are just as in example 1-5, except that the
C perimeter is not drawn.
C
        CALL CPSPRS (ZDAT,23,23,14,RWRK,5000,IWRK,1000,ZDNS,5152)
        CALL ARINAM (IAMA,25000)
        CALL CPLBAM (ZDNS,RWRK,IWRK,IAMA)
        CALL CPCLDM (ZDNS,RWRK,IWRK,IAMA,DRAWCL)
        CALL CPLBDR (ZDNS,RWRK,IWRK)
        CALL CPCLAM (ZDNS,RWRK,IWRK,IAMA)
        CALL ARSCAM (IAMA,XCRA,YCRA,1000,IARA,IGRA,10,SHADER)
C
C Compute and print statistics for the plot, label it, and put a
C boundary line around the edge of the plotter frame.
C
        CALL CAPSAP ('EXAMPLE 1-6',IAMA,25000)
        CALL LABTOP ('EXAMPLE 1-6',.017)
        CALL BNDARY
C
C Advance the frame.
C
        CALL FRAME
C
C ---------------------------------------------------------------------
C
C Close GKS.
C
        CALL GDAWK (IWKID)
        CALL GCLWK (IWKID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END


      SUBROUTINE DRAWCL (XCS,YCS,NCS,IAI,IAG,NAI)
C
C This version of DRAWCL draws the polyline defined by the points
C ((XCS(I),YCS(I)),I=1,NCS) if and only if none of the area identifiers
C for the area containing the polyline are negative.  The dash package
C routine CURVED is called to do the drawing.
C
        DIMENSION XCS(*),YCS(*),IAI(*),IAG(*)
C
C Turn on drawing.
C
        IDR=1
C
C If any area identifier is negative, turn off drawing.
C
        DO 101 I=1,NAI
          IF (IAI(I).LT.0) IDR=0
  101   CONTINUE
C
C If drawing is turned on, draw the polyline.
C
        IF (IDR.NE.0) CALL CURVED (XCS,YCS,NCS)
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE SHADER (XCS,YCS,NCS,IAI,IAG,NAI)
C
C This version of SHADER shades the polygon whose edge is defined by
C the points ((XCS(I),YCS(I)),I=1,NCS) if and only, relative to edge
C group 3, its area identifier is a 1.  The package SOFTFILL is used
C to do the shading.
C
        DIMENSION XCS(*),YCS(*),IAI(*),IAG(*)
C
C Define workspaces for the shading routine.
C
        DIMENSION DST(1100),IND(1200)
C
C Turn off shading.
C
        ISH=0
C
C If the area identifier for group 3 is a 1, turn on shading.
C
        DO 101 I=1,NAI
          IF (IAG(I).EQ.3.AND.IAI(I).EQ.1) ISH=1
  101   CONTINUE
C
C If shading is turned on, shade the area.  The last point of the
C edge is redundant and may be omitted.
C
        IF (ISH.NE.0) THEN
          CALL SFSETI ('ANGLE',45)
          CALL SFSETR ('SPACING',.006)
          CALL SFWRLD (XCS,YCS,NCS-1,DST,1100,IND,1200)
          CALL SFSETI ('ANGLE',135)
          CALL SFNORM (XCS,YCS,NCS-1,DST,1100,IND,1200)
        END IF
C
C Done.
C
        RETURN
C
      END

C
C	$Id: gschh.f,v 1.6 2008-07-27 00:21:01 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GSCHH (CHH)
C
C  SET CHARACTER HEIGHT
C
      INTEGER ESCHH
      PARAMETER (ESCHH=31)
C
      include 'gkscom.h'
C
      REAL CHH
C
C  Check if GKS is in the proper state.
C
      CALL GZCKST(8,ESCHH,IER)
      IF (IER .NE. 0) RETURN
C
C  Check that the character height is valid.
C
      IF (CHH.LE.0.) THEN
        ERS = 1
        CALL GERHND(78,ESCHH,ERF)
        ERS = 0
        RETURN
      ENDIF
C
C  Set the current character height in the GKS state list.
C  (CHH remains in world coordinates here).
C
      CCHH = CHH
C
C  Invoke the workstation interface.  Two real vectors are
C  passed through the interface.  The first vector is
C  passed via (RX(1),RY(1)) and is a vector parallel to the
C  current character up vector with length equal to the
C  recently defined character height (the character height
C  having been transformed to NDC space).  The second vector
C  is passed via (RX(2),RY(2)) and is a vector parallel to
C  the character base vector scaled in accordance with the
C  appropriate aspect ratio.
C
      FCODE = 34
      CONT  = 0
      CALL GZROI(0)
      RL1   = 2
      RL2   = 2
      SCL = 1./SQRT(CCHUP(1)*CCHUP(1)+CCHUP(2)*CCHUP(2))
C
C  Construct a vector (XP,YP) that is parallel to the up vector
C  and has height equal to the character height.
C
      XP = CCHH*SCL*CCHUP(1)
      YP = CCHH*SCL*CCHUP(2)
C
C  Construct a base vector perpendicular to the height vector.
C
      XB =  YP
      YB = -XP
C
C  Transform the height and base vectors using the current normalization
C  transformation.
C
      CALL GZW2NX(1,XP,XTMP)
      CALL GZW2NY(1,YP,YTMP)
      CALL GZW2NX(1,0.,ZXTMP)
      CALL GZW2NY(1,0.,ZYTMP)
      RX(1) = XTMP-ZXTMP 
      RY(1) = YTMP-ZYTMP 
C
C  If the character height transformed to NDC is large, reduce it
C  to avoid possible overflow.
C
      IF (ABS(RX(1)).GT.1000. .OR. ABS(RY(1)).GT.1000.) THEN
        AMX = MAX(ABS(RX(1)),ABS(RY(1)))
        RX(1) = 1.E5*RX(1)/AMX
        RY(1) = 1.E5*RY(1)/AMX
      ENDIF
      CALL GZW2NX(1,XB,XTMP)
      CALL GZW2NY(1,YB,YTMP)
      RX(2) = XTMP-ZXTMP 
      RY(2) = YTMP-ZYTMP 
      IF (ABS(RX(2)).GT.1000. .OR. ABS(RY(2)).GT.1000.) THEN
        AMX = MAX(ABS(RX(2)),ABS(RY(2)))
        RX(2) = 1.E5*RX(2)/AMX
        RY(2) = 1.E5*RY(2)/AMX
      ENDIF
C
      CALL GZTOWK
      IF (RERR.NE.0) THEN
        ERS = 1
        CALL GERHND(RERR,ESCHH,ERF)
        ERS = 0
      ENDIF
      RETURN
      END

      SUBROUTINE DLATRD( UPLO, N, NB, A, LDA, E, TAU, W, LDW )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     October 31, 1992
*
*     .. Scalar Arguments ..
      CHARACTER          UPLO
      INTEGER            LDA, LDW, N, NB
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), E( * ), TAU( * ), W( LDW, * )
*     ..
*
*  Purpose
*  =======
*
*  DLATRD reduces NB rows and columns of a real symmetric matrix A to
*  symmetric tridiagonal form by an orthogonal similarity
*  transformation Q' * A * Q, and returns the matrices V and W which are
*  needed to apply the transformation to the unreduced part of A.
*
*  If UPLO = 'U', DLATRD reduces the last NB rows and columns of a
*  matrix, of which the upper triangle is supplied;
*  if UPLO = 'L', DLATRD reduces the first NB rows and columns of a
*  matrix, of which the lower triangle is supplied.
*
*  This is an auxiliary routine called by DSYTRD.
*
*  Arguments
*  =========
*
*  UPLO    (input) CHARACTER
*          Specifies whether the upper or lower triangular part of the
*          symmetric matrix A is stored:
*          = 'U': Upper triangular
*          = 'L': Lower triangular
*
*  N       (input) INTEGER
*          The order of the matrix A.
*
*  NB      (input) INTEGER
*          The number of rows and columns to be reduced.
*
*  A       (input/output) DOUBLE PRECISION array, dimension (LDA,N)
*          On entry, the symmetric matrix A.  If UPLO = 'U', the leading
*          n-by-n upper triangular part of A contains the upper
*          triangular part of the matrix A, and the strictly lower
*          triangular part of A is not referenced.  If UPLO = 'L', the
*          leading n-by-n lower triangular part of A contains the lower
*          triangular part of the matrix A, and the strictly upper
*          triangular part of A is not referenced.
*          On exit:
*          if UPLO = 'U', the last NB columns have been reduced to
*            tridiagonal form, with the diagonal elements overwriting
*            the diagonal elements of A; the elements above the diagonal
*            with the array TAU, represent the orthogonal matrix Q as a
*            product of elementary reflectors;
*          if UPLO = 'L', the first NB columns have been reduced to
*            tridiagonal form, with the diagonal elements overwriting
*            the diagonal elements of A; the elements below the diagonal
*            with the array TAU, represent the  orthogonal matrix Q as a
*            product of elementary reflectors.
*          See Further Details.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= (1,N).
*
*  E       (output) DOUBLE PRECISION array, dimension (N-1)
*          If UPLO = 'U', E(n-nb:n-1) contains the superdiagonal
*          elements of the last NB columns of the reduced matrix;
*          if UPLO = 'L', E(1:nb) contains the subdiagonal elements of
*          the first NB columns of the reduced matrix.
*
*  TAU     (output) DOUBLE PRECISION array, dimension (N-1)
*          The scalar factors of the elementary reflectors, stored in
*          TAU(n-nb:n-1) if UPLO = 'U', and in TAU(1:nb) if UPLO = 'L'.
*          See Further Details.
*
*  W       (output) DOUBLE PRECISION array, dimension (LDW,NB)
*          The n-by-nb matrix W required to update the unreduced part
*          of A.
*
*  LDW     (input) INTEGER
*          The leading dimension of the array W. LDW >= max(1,N).
*
*  Further Details
*  ===============
*
*  If UPLO = 'U', the matrix Q is represented as a product of elementary
*  reflectors
*
*     Q = H(n) H(n-1) . . . H(n-nb+1).
*
*  Each H(i) has the form
*
*     H(i) = I - tau * v * v'
*
*  where tau is a real scalar, and v is a real vector with
*  v(i:n) = 0 and v(i-1) = 1; v(1:i-1) is stored on exit in A(1:i-1,i),
*  and tau in TAU(i-1).
*
*  If UPLO = 'L', the matrix Q is represented as a product of elementary
*  reflectors
*
*     Q = H(1) H(2) . . . H(nb).
*
*  Each H(i) has the form
*
*     H(i) = I - tau * v * v'
*
*  where tau is a real scalar, and v is a real vector with
*  v(1:i) = 0 and v(i+1) = 1; v(i+1:n) is stored on exit in A(i+1:n,i),
*  and tau in TAU(i).
*
*  The elements of the vectors v together form the n-by-nb matrix V
*  which is needed, with W, to apply the transformation to the unreduced
*  part of the matrix, using a symmetric rank-2k update of the form:
*  A := A - V*W' - W*V'.
*
*  The contents of A on exit are illustrated by the following examples
*  with n = 5 and nb = 2:
*
*  if UPLO = 'U':                       if UPLO = 'L':
*
*    (  a   a   a   v4  v5 )              (  d                  )
*    (      a   a   v4  v5 )              (  1   d              )
*    (          a   1   v5 )              (  v1  1   a          )
*    (              d   1  )              (  v1  v2  a   a      )
*    (                  d  )              (  v1  v2  a   a   a  )
*
*  where d denotes a diagonal element of the reduced matrix, a denotes
*  an element of the original matrix that is unchanged, and vi denotes
*  an element of the vector defining H(i).
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO, ONE, HALF
      PARAMETER          ( ZERO = 0.0D+0, ONE = 1.0D+0, HALF = 0.5D+0 )
*     ..
*     .. Local Scalars ..
      INTEGER            I, IW
      DOUBLE PRECISION   ALPHA
*     ..
*     .. External Subroutines ..
      EXTERNAL           DAXPY, DGEMV, DLARFG, DSCAL, DSYMV
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      DOUBLE PRECISION   DDOT
      EXTERNAL           LSAME, DDOT
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MIN
*     ..
*     .. Executable Statements ..
*
*     Quick return if possible
*
      IF( N.LE.0 )
     $   RETURN
*
      IF( LSAME( UPLO, 'U' ) ) THEN
*
*        Reduce last NB columns of upper triangle
*
         DO 10 I = N, N - NB + 1, -1
            IW = I - N + NB
            IF( I.LT.N ) THEN
*
*              Update A(1:i,i)
*
               CALL DGEMV( 'No transpose', I, N-I, -ONE, A( 1, I+1 ),
     $                     LDA, W( I, IW+1 ), LDW, ONE, A( 1, I ), 1 )
               CALL DGEMV( 'No transpose', I, N-I, -ONE, W( 1, IW+1 ),
     $                     LDW, A( I, I+1 ), LDA, ONE, A( 1, I ), 1 )
            END IF
            IF( I.GT.1 ) THEN
*
*              Generate elementary reflector H(i) to annihilate
*              A(1:i-2,i)
*
               CALL DLARFG( I-1, A( I-1, I ), A( 1, I ), 1, TAU( I-1 ) )
               E( I-1 ) = A( I-1, I )
               A( I-1, I ) = ONE
*
*              Compute W(1:i-1,i)
*
               CALL DSYMV( 'Upper', I-1, ONE, A, LDA, A( 1, I ), 1,
     $                     ZERO, W( 1, IW ), 1 )
               IF( I.LT.N ) THEN
                  CALL DGEMV( 'Transpose', I-1, N-I, ONE, W( 1, IW+1 ),
     $                        LDW, A( 1, I ), 1, ZERO, W( I+1, IW ), 1 )
                  CALL DGEMV( 'No transpose', I-1, N-I, -ONE,
     $                        A( 1, I+1 ), LDA, W( I+1, IW ), 1, ONE,
     $                        W( 1, IW ), 1 )
                  CALL DGEMV( 'Transpose', I-1, N-I, ONE, A( 1, I+1 ),
     $                        LDA, A( 1, I ), 1, ZERO, W( I+1, IW ), 1 )
                  CALL DGEMV( 'No transpose', I-1, N-I, -ONE,
     $                        W( 1, IW+1 ), LDW, W( I+1, IW ), 1, ONE,
     $                        W( 1, IW ), 1 )
               END IF
               CALL DSCAL( I-1, TAU( I-1 ), W( 1, IW ), 1 )
               ALPHA = -HALF*TAU( I-1 )*DDOT( I-1, W( 1, IW ), 1,
     $                 A( 1, I ), 1 )
               CALL DAXPY( I-1, ALPHA, A( 1, I ), 1, W( 1, IW ), 1 )
            END IF
*
   10    CONTINUE
      ELSE
*
*        Reduce first NB columns of lower triangle
*
         DO 20 I = 1, NB
*
*           Update A(i:n,i)
*
            CALL DGEMV( 'No transpose', N-I+1, I-1, -ONE, A( I, 1 ),
     $                  LDA, W( I, 1 ), LDW, ONE, A( I, I ), 1 )
            CALL DGEMV( 'No transpose', N-I+1, I-1, -ONE, W( I, 1 ),
     $                  LDW, A( I, 1 ), LDA, ONE, A( I, I ), 1 )
            IF( I.LT.N ) THEN
*
*              Generate elementary reflector H(i) to annihilate
*              A(i+2:n,i)
*
               CALL DLARFG( N-I, A( I+1, I ), A( MIN( I+2, N ), I ), 1,
     $                      TAU( I ) )
               E( I ) = A( I+1, I )
               A( I+1, I ) = ONE
*
*              Compute W(i+1:n,i)
*
               CALL DSYMV( 'Lower', N-I, ONE, A( I+1, I+1 ), LDA,
     $                     A( I+1, I ), 1, ZERO, W( I+1, I ), 1 )
               CALL DGEMV( 'Transpose', N-I, I-1, ONE, W( I+1, 1 ), LDW,
     $                     A( I+1, I ), 1, ZERO, W( 1, I ), 1 )
               CALL DGEMV( 'No transpose', N-I, I-1, -ONE, A( I+1, 1 ),
     $                     LDA, W( 1, I ), 1, ONE, W( I+1, I ), 1 )
               CALL DGEMV( 'Transpose', N-I, I-1, ONE, A( I+1, 1 ), LDA,
     $                     A( I+1, I ), 1, ZERO, W( 1, I ), 1 )
               CALL DGEMV( 'No transpose', N-I, I-1, -ONE, W( I+1, 1 ),
     $                     LDW, W( 1, I ), 1, ONE, W( I+1, I ), 1 )
               CALL DSCAL( N-I, TAU( I ), W( I+1, I ), 1 )
               ALPHA = -HALF*TAU( I )*DDOT( N-I, W( I+1, I ), 1,
     $                 A( I+1, I ), 1 )
               CALL DAXPY( N-I, ALPHA, A( I+1, I ), 1, W( I+1, I ), 1 )
            END IF
*
   20    CONTINUE
      END IF
*
      RETURN
*
*     End of DLATRD
*
      END

C
C       $Id: stumsl.f,v 1.5 2008-07-27 00:17:28 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE STUMSL(XCS,YCS,NCS,IAI,IAG,NAI)
C
      DIMENSION XCS(NCS),YCS(NCS),IAI(NAI),IAG(NAI)
C
C
C Example version of user masked drawing program
C
C XCS,YCS    - Arrays of X,Y coordinates
C NCS        - Number of points
C IAI        - Area identifier array
C IAG        - Area group array
C NAI        - number of area/group identifiers
C
C --------------------------------------------------------------------
C
      DO 101 I=1,NAI
         IF (IAI(I).LT.0) RETURN
 101  CONTINUE
C
C If drawing is turned on, draw the polyline.
C
      CALL CURVE(XCS,YCS,NCS)
C
C Done.
C
      RETURN
C
      END

      SUBROUTINE CLARTG( F, G, CS, SN, R )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      REAL               CS
      COMPLEX            F, G, R, SN
*     ..
*
*  Purpose
*  =======
*
*  CLARTG generates a plane rotation so that
*
*     [  CS  SN  ]     [ F ]     [ R ]
*     [  __      ]  .  [   ]  =  [   ]   where CS**2 + |SN|**2 = 1.
*     [ -SN  CS  ]     [ G ]     [ 0 ]
*
*  This is a faster version of the BLAS1 routine CROTG, except for
*  the following differences:
*     F and G are unchanged on return.
*     If G=0, then CS=1 and SN=0.
*     If F=0, then CS=0 and SN is chosen so that R is real.
*
*  Arguments
*  =========
*
*  F       (input) COMPLEX
*          The first component of vector to be rotated.
*
*  G       (input) COMPLEX
*          The second component of vector to be rotated.
*
*  CS      (output) REAL
*          The cosine of the rotation.
*
*  SN      (output) COMPLEX
*          The sine of the rotation.
*
*  R       (output) COMPLEX
*          The nonzero component of the rotated vector.
*
*  Further Details
*  ======= =======
*
*  3-5-96 - Modified with a new algorithm by W. Kahan and J. Demmel
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               TWO, ONE, ZERO
      PARAMETER          ( TWO = 2.0E+0, ONE = 1.0E+0, ZERO = 0.0E+0 )
      COMPLEX            CZERO
      PARAMETER          ( CZERO = ( 0.0E+0, 0.0E+0 ) )
*     ..
*     .. Local Scalars ..
      LOGICAL            FIRST
      INTEGER            COUNT, I
      REAL               D, DI, DR, EPS, F2, F2S, G2, G2S, SAFMIN,
     $                   SAFMN2, SAFMX2, SCALE
      COMPLEX            FF, FS, GS
*     ..
*     .. External Functions ..
      REAL               SLAMCH, SLAPY2
      EXTERNAL           SLAMCH, SLAPY2
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, AIMAG, CMPLX, CONJG, INT, LOG, MAX, REAL,
     $                   SQRT
*     ..
*     .. Statement Functions ..
      REAL               ABS1, ABSSQ
*     ..
*     .. Save statement ..
      SAVE               FIRST, SAFMX2, SAFMIN, SAFMN2
*     ..
*     .. Data statements ..
      DATA               FIRST / .TRUE. /
*     ..
*     .. Statement Function definitions ..
      ABS1( FF ) = MAX( ABS( REAL( FF ) ), ABS( AIMAG( FF ) ) )
      ABSSQ( FF ) = REAL( FF )**2 + AIMAG( FF )**2
*     ..
*     .. Executable Statements ..
*
      IF( FIRST ) THEN
         FIRST = .FALSE.
         SAFMIN = SLAMCH( 'S' )
         EPS = SLAMCH( 'E' )
         SAFMN2 = SLAMCH( 'B' )**INT( LOG( SAFMIN / EPS ) /
     $            LOG( SLAMCH( 'B' ) ) / TWO )
         SAFMX2 = ONE / SAFMN2
      END IF
      SCALE = MAX( ABS1( F ), ABS1( G ) )
      FS = F
      GS = G
      COUNT = 0
      IF( SCALE.GE.SAFMX2 ) THEN
   10    CONTINUE
         COUNT = COUNT + 1
         FS = FS*SAFMN2
         GS = GS*SAFMN2
         SCALE = SCALE*SAFMN2
         IF( SCALE.GE.SAFMX2 )
     $      GO TO 10
      ELSE IF( SCALE.LE.SAFMN2 ) THEN
         IF( G.EQ.CZERO ) THEN
            CS = ONE
            SN = CZERO
            R = F
            RETURN
         END IF
   20    CONTINUE
         COUNT = COUNT - 1
         FS = FS*SAFMX2
         GS = GS*SAFMX2
         SCALE = SCALE*SAFMX2
         IF( SCALE.LE.SAFMN2 )
     $      GO TO 20
      END IF
      F2 = ABSSQ( FS )
      G2 = ABSSQ( GS )
      IF( F2.LE.MAX( G2, ONE )*SAFMIN ) THEN
*
*        This is a rare case: F is very small.
*
         IF( F.EQ.CZERO ) THEN
            CS = ZERO
            R = SLAPY2( REAL( G ), AIMAG( G ) )
*           Do complex/real division explicitly with two real divisions
            D = SLAPY2( REAL( GS ), AIMAG( GS ) )
            SN = CMPLX( REAL( GS ) / D, -AIMAG( GS ) / D )
            RETURN
         END IF
         F2S = SLAPY2( REAL( FS ), AIMAG( FS ) )
*        G2 and G2S are accurate
*        G2 is at least SAFMIN, and G2S is at least SAFMN2
         G2S = SQRT( G2 )
*        Error in CS from underflow in F2S is at most
*        UNFL / SAFMN2 .lt. sqrt(UNFL*EPS) .lt. EPS
*        If MAX(G2,ONE)=G2, then F2 .lt. G2*SAFMIN,
*        and so CS .lt. sqrt(SAFMIN)
*        If MAX(G2,ONE)=ONE, then F2 .lt. SAFMIN
*        and so CS .lt. sqrt(SAFMIN)/SAFMN2 = sqrt(EPS)
*        Therefore, CS = F2S/G2S / sqrt( 1 + (F2S/G2S)**2 ) = F2S/G2S
         CS = F2S / G2S
*        Make sure abs(FF) = 1
*        Do complex/real division explicitly with 2 real divisions
         IF( ABS1( F ).GT.ONE ) THEN
            D = SLAPY2( REAL( F ), AIMAG( F ) )
            FF = CMPLX( REAL( F ) / D, AIMAG( F ) / D )
         ELSE
            DR = SAFMX2*REAL( F )
            DI = SAFMX2*AIMAG( F )
            D = SLAPY2( DR, DI )
            FF = CMPLX( DR / D, DI / D )
         END IF
         SN = FF*CMPLX( REAL( GS ) / G2S, -AIMAG( GS ) / G2S )
         R = CS*F + SN*G
      ELSE
*
*        This is the most common case.
*        Neither F2 nor F2/G2 are less than SAFMIN
*        F2S cannot overflow, and it is accurate
*
         F2S = SQRT( ONE+G2 / F2 )
*        Do the F2S(real)*FS(complex) multiply with two real multiplies
         R = CMPLX( F2S*REAL( FS ), F2S*AIMAG( FS ) )
         CS = ONE / F2S
         D = F2 + G2
*        Do complex/real division explicitly with two real divisions
         SN = CMPLX( REAL( R ) / D, AIMAG( R ) / D )
         SN = SN*CONJG( GS )
         IF( COUNT.NE.0 ) THEN
            IF( COUNT.GT.0 ) THEN
               DO 30 I = 1, COUNT
                  R = R*SAFMX2
   30          CONTINUE
            ELSE
               DO 40 I = 1, -COUNT
                  R = R*SAFMN2
   40          CONTINUE
            END IF
         END IF
      END IF
      RETURN
*
*     End of CLARTG
*
      END

C
C       $Id: vvsetr.f,v 1.18 2008-07-27 00:17:35 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
C
C-----------------------------------------------------------------------
C
      SUBROUTINE VVSETR (CNM,RVL)
C
      CHARACTER*(*) CNM
C
C This subroutine is called to set the real value of a specified
C parameter.
C
C CNM is the name of the parameter whose value is to be set.
C
C RVL is a real variable containing the new value of the parameter.
C
C ---------------------------------------------------------------------
C
C NOTE:
C Since implicit typing is used for all real and integer variables
C a consistent length convention has been adopted to help clarify the
C significance of the variables encountered in the code for this 
C utility. All local variable and subroutine parameter identifiers 
C are limited to 1,2,or 3 characters. Four character names identify  
C members of common blocks. Five and 6 character variable names 
C denote PARAMETER constants or subroutine or function names.
C
C Declare the VV common blocks.
C
C IPLVLS - Maximum number of color threshold level values
C IPAGMX - Maximum number of area groups allowed in the area map
C
      PARAMETER (IPLVLS = 256, IPAGMX = 64)
C
C Integer and real common block variables
C
C
      COMMON /VVCOM/
     +                IUD1       ,IVD1       ,IPD1       ,IXDM       ,
     +                IYDN       ,VLOM       ,VHIM       ,ISET       ,
     +                VRMG       ,VRLN       ,VFRC       ,IXIN       ,
     +                IYIN       ,ISVF       ,UUSV       ,UVSV       ,
     +                UPSV       ,IMSK       ,ICPM       ,UVPS       ,
     +                UVPL       ,UVPR       ,UVPB       ,UVPT       ,
     +                UWDL       ,UWDR       ,UWDB       ,UWDT       ,
     +                UXC1       ,UXCM       ,UYC1       ,UYCN       ,
     +                NLVL       ,IPAI       ,ICTV       ,WDLV       ,
     +                UVMN       ,UVMX       ,PMIN       ,PMAX       ,
     +                RVMN       ,RVMX       ,RDMN       ,RDMX       ,
     +                ISPC       ,RVMD       ,IPLR       ,IVST       ,
     +                IVPO       ,ILBL       ,IDPF       ,IMSG       ,
     +                ICLR(IPLVLS)           ,TVLU(IPLVLS)
C
C Arrow size/shape parameters
C
        COMMON / VVARO /
     +                HDSZ       ,HINF       ,HANG       ,IAST       ,
     +                HSIN       ,HCOS       ,FAMN       ,FAMX       ,
     +                UVMG       ,FAIR       ,FAWR       ,FAWF       ,
     +                FAXR       ,FAXF       ,FAYR       ,FAYF       ,
     +                AROX(8)    ,AROY(8)    ,FXSZ       ,FYSZ       ,
     +                FXRF       ,FXMN       ,FYRF       ,FYMN       ,
     +                FWRF       ,FWMN       ,FIRF       ,FIMN       ,
     +                AXMN       ,AXMX       ,AYMN       ,AYMX       ,
     +                IACM       ,IAFO       ,WBAD       ,WBTF       ,
     +                WBCF       ,WBDF       ,WBSC
C
C
C Text related parameters
C
        COMMON /VVTXP /
     +                FCWM    ,ICSZ    ,
     +                FMNS    ,FMNX    ,FMNY    ,IMNP    ,IMNC  ,
     +                FMXS    ,FMXX    ,FMXY    ,IMXP    ,IMXC  ,
     +                FZFS    ,FZFX    ,FZFY    ,IZFP    ,IZFC  ,
     +                FILS    ,FILX    ,FILY    ,IILP    ,IILC  ,
     +                FLBS    ,ILBC

C
C Character variable declartions
C
      CHARACTER*160 CSTR
      PARAMETER (IPCHSZ=36)
      CHARACTER*(IPCHSZ)  CMNT,CMXT,CZFT,CLBT,CILT
C
C Text string parameters
C
      COMMON /VVCHAR/ CSTR,CMNT,CMXT,CZFT,CLBT,CILT
C
      SAVE /VVCOM/, /VVARO/, /VVTXP/, /VVCHAR/
C
C The mapping common block: made available to user mapping routines
C
      COMMON /VVMAP/
     +                IMAP       ,
     +                XVPL       ,XVPR       ,YVPB       ,YVPT       ,
     +                WXMN       ,WXMX       ,WYMN       ,WYMX       ,
     +                XLOV       ,XHIV       ,YLOV       ,YHIV       ,
     +                SXDC       ,SYDC       ,NXCT       ,NYCT       ,
     +                RLEN       ,LNLG       ,INVX       ,INVY       ,
     +                ITRT       ,IWCT       ,FW2W       ,FH2H       ,
     +                DVMN       ,DVMX       ,RBIG       ,IBIG
C
      SAVE /VVMAP/
C
C Math constants
C
      PARAMETER (PDTOR  = 0.017453292519943,
     +           PRTOD  = 57.2957795130823,
     +           P1XPI  = 3.14159265358979,
     +           P2XPI  = 6.28318530717959,
     +           P1D2PI = 1.57079632679489,
     +           P5D2PI = 7.85398163397448) 
C
C --------------------------------------------------------------------
C
C Check for a parameter name that is too short.
C
      IF (LEN(CNM).LT.3) THEN
        CSTR(1:46)='VVSETI OR VVSETR - PARAMETER NAME TOO SHORT - '
        CSTR(47:46+LEN(CNM))=CNM
        CALL SETER (CSTR(1:46+LEN(CNM)),1,1)
        RETURN
      END IF
C
C Check for incorrect use of the index parameter.
C
      IF (CNM(1:3).EQ.'CLR'.OR.CNM(1:3).EQ.'clr'
     +    .OR.CNM(1:3).EQ.'TVL'.OR.CNM(1:3).EQ.'tvl') THEN
         IF (IPAI.LT.1.OR.IPAI.GT.IPLVLS) THEN
            CSTR(1:46)='VVSETI OR VVSETR - SETTING XXX - PAI INCORRECT'
            CSTR(28:30)=CNM(1:3)
            CALL SETER (CSTR(1:46),2,1)
            RETURN
         END IF
      END IF
C
C Set the appropriate parameter value.
C
C Values in VVCOM
C 
      IF (CNM(1:3).EQ.'UD1'.OR. CNM(1:3).EQ.'ud1') THEN
         IUD1=INT(RVL)
      ELSE IF (CNM(1:3).EQ.'VD1'.OR. CNM(1:3).EQ.'vd1') THEN
         IVD1=INT(RVL)
      ELSE IF (CNM(1:3).EQ.'PD1'.OR. CNM(1:3).EQ.'pd1') THEN
         IPD1=INT(RVL)
      ELSE IF (CNM(1:3).EQ.'XDM'.OR. CNM(1:3).EQ.'xdm') THEN
         IXDM=INT(RVL)
      ELSE IF (CNM(1:3).EQ.'YDN'.OR. CNM(1:3).EQ.'ydn') THEN
         IYDN=INT(RVL)
      ELSE IF (CNM(1:3).EQ.'VLC'.OR.CNM(1:3).EQ.'vlc') THEN
         VLOM=RVL 
      ELSE IF (CNM(1:3).EQ.'VHC'.OR.CNM(1:3).EQ.'vhc') THEN
         VHIM=RVL 
      ELSE IF (CNM(1:3).EQ.'SET'.OR. CNM(1:3).EQ.'set') THEN
         ISET=INT(RVL)
      ELSE IF (CNM(1:3).EQ.'VRM'.OR. CNM(1:3).EQ.'vrm') THEN
         VRMG=RVL
      ELSE IF (CNM(1:3).EQ.'VRL'.OR. CNM(1:3).EQ.'vrl') THEN
         VRLN=RVL
      ELSE IF (CNM(1:3).EQ.'VFR'.OR. CNM(1:3).EQ.'vfr') THEN
         VFRC=RVL
      ELSE IF (CNM(1:3).EQ.'XIN'.OR. CNM(1:3).EQ.'xin') THEN
         IXIN=INT(RVL)
      ELSE IF (CNM(1:3).EQ.'YIN'.OR. CNM(1:3).EQ.'yin') THEN
         IYIN=INT(RVL)
      ELSE IF (CNM(1:3).EQ.'SVF'.OR. CNM(1:3).EQ.'svf') THEN
         ISVF=INT(RVL)
      ELSE IF (CNM(1:3).EQ.'USV'.OR.CNM(1:3).EQ.'usv') THEN
         UUSV=RVL
      ELSE IF (CNM(1:3).EQ.'VSV'.OR.CNM(1:3).EQ.'vsv') THEN
         UVSV=RVL
      ELSE IF (CNM(1:3).EQ.'PSV'.OR.CNM(1:3).EQ.'psv') THEN
         UPSV=RVL
      ELSE IF (CNM(1:3).EQ.'MSK'.OR. CNM(1:3).EQ.'msk') THEN
         IMSK=INT(RVL)
      ELSE IF (CNM(1:3).EQ.'CPM'.OR. CNM(1:3).EQ.'cpm') THEN
         ICPM=INT(RVL)
      ELSE IF (CNM(1:3).EQ.'VPS'.OR. CNM(1:3).EQ.'vps') THEN
         UVPS=RVL
      ELSE IF (CNM(1:3).EQ.'VPL'.OR.CNM(1:3).EQ.'vpl') THEN
         UVPL=MIN(1.0,MAX(0.0,RVL))
      ELSE IF (CNM(1:3).EQ.'VPR'.OR.CNM(1:3).EQ.'vpr') THEN
         UVPR=MIN(1.0,MAX(0.0,RVL))
      ELSE IF (CNM(1:3).EQ.'VPB'.OR.CNM(1:3).EQ.'vpb') THEN
         UVPB=MIN(1.0,MAX(0.0,RVL))
      ELSE IF (CNM(1:3).EQ.'VPT'.OR.CNM(1:3).EQ.'vpt') THEN
         UVPT=MIN(1.0,MAX(0.0,RVL))
      ELSE IF (CNM(1:3).EQ.'WDL'.OR.CNM(1:3).EQ.'wdl') THEN
         UWDL=RVL
      ELSE IF (CNM(1:3).EQ.'WDR'.OR.CNM(1:3).EQ.'wdr') THEN
         UWDR=RVL
      ELSE IF (CNM(1:3).EQ.'WDB'.OR.CNM(1:3).EQ.'wdb') THEN
         UWDB=RVL
      ELSE IF (CNM(1:3).EQ.'WDT'.OR.CNM(1:3).EQ.'wdt') THEN
         UWDT=RVL
      ELSE IF (CNM(1:3).EQ.'XC1'.OR.CNM(1:3).EQ.'xc1') THEN
         UXC1=RVL
      ELSE IF (CNM(1:3).EQ.'XCM'.OR.CNM(1:3).EQ.'xcm') THEN
         UXCM=RVL
      ELSE IF (CNM(1:3).EQ.'YC1'.OR.CNM(1:3).EQ.'yc1') THEN
         UYC1=RVL
      ELSE IF (CNM(1:3).EQ.'YCN'.OR.CNM(1:3).EQ.'ycn') THEN
         UYCN=RVL
      ELSE IF (CNM(1:3).EQ.'NLV'.OR.CNM(1:3).EQ.'nlv') THEN
         NLVL=MIN(IPLVLS,INT(RVL))
      ELSE IF (CNM(1:3).EQ.'PAI'.OR.CNM(1:3).EQ.'pai') THEN
         IF (RVL .LT. 1.0 .OR. RVL .GT. IPLVLS) GO TO 9800
         IPAI=INT(RVL)
      ELSE IF (CNM(1:3).EQ.'CTV'.OR.CNM(1:3).EQ.'ctv') THEN
         ICTV=INT(RVL)
      ELSE IF (CNM(1:3).EQ.'LWD'.OR.CNM(1:3).EQ.'lwd') THEN
         IF (RVL .LE. 0.0) GO TO 9800
         WDLV=RVL
C
C UVMN,UVMX, PMIN, PMAX are read-only
C
      ELSE IF (CNM(1:3).EQ.'SPC'.OR. CNM(1:3).EQ.'spc') THEN
         ISPC=INT(RVL)
      ELSE IF (CNM(1:3).EQ.'VMD'.OR. CNM(1:3).EQ.'vmd') THEN
         RVMD=MAX(0.0,RVL)
      ELSE IF (CNM(1:3).EQ.'MAP'.OR. CNM(1:3).EQ.'map') THEN
         IMAP=INT(RVL)
      ELSE IF (CNM(1:3).EQ.'PLR'.OR. CNM(1:3).EQ.'plr') THEN
         IPLR=INT(RVL)
      ELSE IF (CNM(1:3).EQ.'VST'.OR. CNM(1:3).EQ.'vst') THEN
         IVST=INT(RVL)
      ELSE IF (CNM(1:3).EQ.'VPO'.OR. CNM(1:3).EQ.'vpo') THEN
         IVPO=INT(RVL)
      ELSE IF (CNM(1:3).EQ.'LBL'.OR. CNM(1:3).EQ.'lbl') THEN
         ILBL=INT(RVL)
      ELSE IF (CNM(1:3).EQ.'DPF'.OR. CNM(1:3).EQ.'dpf') THEN
         IDPF=INT(RVL)
C
C arrow parameters
C
      ELSE IF (CNM(1:3).EQ.'AMN'.OR.CNM(1:3).EQ.'amn') THEN
         FAMN=RVL
      ELSE IF (CNM(1:3).EQ.'AMX'.OR.CNM(1:3).EQ.'amx') THEN
         FAMX=RVL
      ELSE IF (CNM(1:3).EQ.'AST'.OR.CNM(1:3).EQ.'ast') THEN
         IAST=INT(RVL)
      ELSE IF (CNM(1:3).EQ.'AIR'.OR.CNM(1:3).EQ.'air') THEN
         FAIR=MIN(1.0,MAX(0.0,RVL))
      ELSE IF (CNM(1:3).EQ.'AWR'.OR.CNM(1:3).EQ.'awr') THEN
         FAWR=MIN(1.0,MAX(0.0,RVL))
      ELSE IF (CNM(1:3).EQ.'AWF'.OR.CNM(1:3).EQ.'awf') THEN
         FAWF=MIN(1.0,MAX(0.0,RVL))
      ELSE IF (CNM(1:3).EQ.'AXR'.OR.CNM(1:3).EQ.'axr') THEN
         FAXR=MIN(2.0,MAX(0.0,RVL))
      ELSE IF (CNM(1:3).EQ.'AXF'.OR.CNM(1:3).EQ.'axf') THEN
         FAXF=MIN(1.0,MAX(0.0,RVL))
      ELSE IF (CNM(1:3).EQ.'AYR'.OR.CNM(1:3).EQ.'ayr') THEN
         FAYR=MIN(1.0,MAX(0.0,RVL))
      ELSE IF (CNM(1:3).EQ.'AYF'.OR.CNM(1:3).EQ.'ayf') THEN
         FAYF=MIN(1.0,MAX(0.0,RVL))
      ELSE IF (CNM(1:3).EQ.'ACM'.OR.CNM(1:3).EQ.'acm') THEN
         IACM=INT(RVL)
      ELSE IF (CNM(1:3).EQ.'AFO'.OR.CNM(1:3).EQ.'afo') THEN
         IAFO=INT(RVL)
C
C wind barb parameters
C
      ELSE IF (CNM(1:3).EQ.'WBA'.OR.CNM(1:3).EQ.'wba') THEN
         WBAD=MIN(80.0,MAX(-80.0,RVL))
      ELSE IF (CNM(1:3).EQ.'WBT'.OR.CNM(1:3).EQ.'wbt') THEN
         WBTF=MIN(1.0,MAX(0.001,RVL))
      ELSE IF (CNM(1:3).EQ.'WBC'.OR.CNM(1:3).EQ.'wbc') THEN
         WBCF=MIN(1.0,MAX(0.001,RVL))
      ELSE IF (CNM(1:3).EQ.'WBD'.OR.CNM(1:3).EQ.'wbd') THEN
         WBDF=MIN(1.0,MAX(0.001,RVL))
      ELSE IF (CNM(1:3).EQ.'WBS'.OR.CNM(1:3).EQ.'wbs') THEN
         WBSC=MAX(0.0,RVL)
C
C character multiplier
C
      ELSE IF (CNM(1:3).EQ.'CWM'.OR.CNM(1:3).EQ.'cwm') THEN
        FCWM=RVL
C
C character attributes
C
      ELSE IF (CNM(1:3).EQ.'MNS'.OR.CNM(1:3).EQ.'mns') THEN
         FMNS=RVL
      ELSE IF (CNM(1:3).EQ.'MNX'.OR.CNM(1:3).EQ.'mnx') THEN
         FMNX=RVL
      ELSE IF (CNM(1:3).EQ.'MNY'.OR.CNM(1:3).EQ.'mny') THEN
         FMNY=RVL
      ELSE IF (CNM(1:3).EQ.'MNP'.OR. CNM(1:3).EQ.'mnp') THEN
         IMNP=INT(RVL)
      ELSE IF (CNM(1:3).EQ.'MNC'.OR. CNM(1:3).EQ.'mnc') THEN
         IMNC=INT(RVL)
C
      ELSE IF (CNM(1:3).EQ.'MXS'.OR.CNM(1:3).EQ.'mxs') THEN
         FMXS=RVL
      ELSE IF (CNM(1:3).EQ.'MXX'.OR.CNM(1:3).EQ.'mxx') THEN
         FMXX=RVL
      ELSE IF (CNM(1:3).EQ.'MXY'.OR.CNM(1:3).EQ.'mxy') THEN
         FMXY=RVL
      ELSE IF (CNM(1:3).EQ.'MXP'.OR. CNM(1:3).EQ.'mxp') THEN
         IMXP=INT(RVL)
      ELSE IF (CNM(1:3).EQ.'MXC'.OR. CNM(1:3).EQ.'mxc') THEN
         IMXC=INT(RVL)
C
      ELSE IF (CNM(1:3).EQ.'ZFS'.OR.CNM(1:3).EQ.'zfs') THEN
         FZFS=RVL
      ELSE IF (CNM(1:3).EQ.'ZFX'.OR.CNM(1:3).EQ.'zfx') THEN
         FZFX=RVL
      ELSE IF (CNM(1:3).EQ.'ZFY'.OR.CNM(1:3).EQ.'zfy') THEN
         FZFY=RVL
      ELSE IF (CNM(1:3).EQ.'ZFP'.OR. CNM(1:3).EQ.'zfp') THEN
         IZFP=INT(RVL)
      ELSE IF (CNM(1:3).EQ.'ZFC'.OR. CNM(1:3).EQ.'zfc') THEN
         IZFC=INT(RVL)
C     
      ELSE IF (CNM(1:3).EQ.'LBS'.OR.CNM(1:3).EQ.'lbs') THEN
         FLBS=RVL
      ELSE IF (CNM(1:3).EQ.'LBC'.OR. CNM(1:3).EQ.'lbc') THEN
         ILBC=INT(RVL)
C
      ELSE IF (CNM(1:3).EQ.'ILS'.OR.CNM(1:3).EQ.'ils') THEN
         FILS=RVL
      ELSE IF (CNM(1:3).EQ.'ILX'.OR.CNM(1:3).EQ.'ilx') THEN
         FILX=RVL
      ELSE IF (CNM(1:3).EQ.'ILY'.OR.CNM(1:3).EQ.'ily') THEN
         FILY=RVL
      ELSE IF (CNM(1:3).EQ.'ILP'.OR. CNM(1:3).EQ.'ilp') THEN
         IILP=INT(RVL)
      ELSE IF (CNM(1:3).EQ.'ILC'.OR. CNM(1:3).EQ.'ilc') THEN
         IILC=INT(RVL)
C     
C     color field parameters
C
      ELSE IF (CNM(1:3).EQ.'CLR'.OR.CNM(1:3).EQ.'clr') THEN
         ICLR(IPAI)=INT(RVL)
      ELSE IF (CNM(1:3).EQ.'TVL'.OR.CNM(1:3).EQ.'tvl') THEN
         TVLU(IPAI)=RVL
      ELSE IF (CNM(1:3).EQ.'TRT'.OR. CNM(1:3).EQ.'trt') THEN
         ITRT=INT(RVL)
      ELSE
        CSTR(1:46)='VVSETI OR VVSETR - PARAMETER NAME NOT KNOWN - '
        CSTR(47:49)=CNM(1:3)
        CALL SETER (CSTR(1:49),3,1)
        RETURN
      END IF
C
      GOTO 9900
C
 9800 CONTINUE
C
      CSTR(1:50)='VVSETI OR VVSETR - PARAMETER VALUE OUT OF RANGE - '
      CSTR(51:53)=CNM(1:3)
      CALL SETER (CSTR(1:53),4,1)
      RETURN
C      
 9900 CONTINUE
C
C Done.
C
      RETURN
C
      END

C
C	$Id: fftkin.f,v 1.4 2008-07-27 12:23:42 haley Exp $
C                                                                      
C			     Copyright (C)  1997
C	     University Corporation for Atmospheric Research
C			     All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C

      SUBROUTINE FFTKIN(INPUT,NUM,IVALS,IER)
C
C  Tokenize the input line INPUT and convert the tokens to
C  integers.  Store the NUM integers in the integer array IVALS.  
C  The tokens are separated by one or more blanks, or by one or more
C  parentheses.
C
      CHARACTER*80 INPUT,CTMP
      INTEGER      IVALS(*)
C
      IP = 1
      NT = 0
C
   10 CONTINUE
      CTMP = ' '
      IF (IP .GT. 80) GO TO 30
      IF (INPUT(IP:IP).NE.' ' .AND. INPUT(IP:IP).NE.'(' .AND.
     +    INPUT(IP:IP).NE.')' ) THEN
        NT = NT+1
        J = 0
        DO 20 K=1,80
          J = J+1 
          CTMP(J:J) = INPUT(IP+K-1:IP+K-1)
          L = IP+K
          IF (L .GT. 80) THEN
            READ(CTMP,500) IVALS(NT)
  500       FORMAT(I6)
            GO TO 30
          ELSE IF (INPUT(L:L).EQ.' ' .OR. INPUT(L:L).EQ.')' .OR.
     +             INPUT(L:L).EQ.')' ) THEN
            READ(CTMP,500) IVALS(NT)
            IP = L
            GO TO 10
          ENDIF 
   20   CONTINUE
      ELSE
        IP = IP+1
        GO TO 10
      ENDIF
   30 CONTINUE
C
      NUM = NT
C
      RETURN
      END

C NCLFORTSTART
      SUBROUTINE TRSSPHX(INTL,IGRIDA,NLONA,NLATA,DA,IGRIDB,NLONB,NLATB,
     +                   DB,WSAVE,LSAVE,LSVMIN,WORK,LWORK,LWKMIN,DWORK,
     +                   LDWORK,IER,JMODE)
      IMPLICIT NONE
      INTEGER INTL,IGRIDA(2),NLONA,NLATA,IGRIDB(2),NLONB,NLATB
      INTEGER LSAVE,LSVMIN,LWORK,LWKMIN,LDWORK,IER,JMODE
      DOUBLE PRECISION DA(*),DB(*),WSAVE(LSAVE),WORK(LWORK)
      DOUBLE PRECISION DWORK(LDWORK)
C NCLEND
      INTEGER IG,IGRDA,IGRDB,LA1,LA2,LB1,LB2,LWA,LWB,IAA,IAB,IBA,IBB
      INTEGER LWK3,LWK4,LW,IW,JB,NT,ISYM,NLAT
      DOUBLE PRECISION RN
c
c     include a save statement to ensure local variables in trssph, set during
c     an intl=0 call, are preserved if trssph is recalled with intl=1
c
      SAVE
c
c     check input arguments
c
      IER = 1
      IF (INTL* (INTL-1).NE.0) RETURN
      IER = 2
      IG = IGRIDA(1)
      IF ((IG-1)* (IG+1)* (IG-2)* (IG+2).NE.0) RETURN
      IER = 3
      IG = IGRIDA(2)
      IF (IG* (IG-1).NE.0) RETURN
      IER = 4
      IF (NLONA.LT.4) RETURN
      IER = 5
      IF (NLATA.LT.3) RETURN
      IER = 6
      IG = IGRIDB(1)
      IF ((IG-1)* (IG+1)* (IG-2)* (IG+2).NE.0) RETURN
      IER = 7
      IG = IGRIDB(2)
      IF (IG* (IG-1).NE.0) RETURN
      IER = 8
      IF (NLONB.LT.4) RETURN
      IER = 9
      IF (NLATB.LT.3) RETURN
      IER = 0

      IGRDA = IABS(IGRIDA(1))
      IGRDB = IABS(IGRIDB(1))
      IF (INTL.EQ.0) THEN
          LA1 = MIN0(NLATA, (NLONA+2)/2)
          LA2 = (NLATA+1)/2
          LB1 = MIN0(NLATB, (NLONB+2)/2)
          LB2 = (NLATB+1)/2
c
c     set saved work space length for analysis
c
          IF (IGRDA.EQ.1) THEN
c
c     saved space for analysis on  equally spaced grid
c
              LWA = 2*NLATA*LA2 + 3* ((LA1-2)* (NLATA+NLATA-LA1-1))/2 +
     +              NLONA + 15
          ELSE
c
c     saved space for analysis on gaussian grid
c
              LWA = NLATA* (2*LA2+3*LA1-2) + 3*LA1* (1-LA1)/2 + NLONA +
     +              15
          END IF
c
c     set wsave pointer
c
          JB = 1 + LWA
c
c     set pointers for spherical harmonic coefs
c
          IAA = 1
          IBA = IAA + LA1*NLATA
          IAB = IBA + LA1*NLATA
          IF (IGRDB.EQ.2) THEN
c
c     set saved work space length for gaussian synthesis
c
              LWB = NLATB* (2*LB2+3*LB1-2) + 3*LB1* (1-LB1)/2 + NLONB +
     +              15
          ELSE
c
c     set saved work space length for equally spaced synthesis
c
              LWB = 2*NLATB*LB2 + 3* ((LB1-2)* (NLATB+NLATB-LB1-1))/2 +
     +              NLONB + 15
          END IF
c
c     set minimum saved work space length
c
          LSVMIN = LWA + LWB
c
c     set remaining harmonic pointer
c
          IBB = IAB + LB1*NLATB
c
c     set pointers for remaining work
c
          IW = IBB + LB1*NLATB
c
c     set remaining work space length in lw
c
          LW = LWORK - IW
          LWK3 = NLATA*NLONA*2
          LWK4 = NLATB*NLONB*2
c
c     set minimum unsaved work space required by trssph
c
          LWKMIN = IW + MAX0(LWK3,LWK4)
c
c     set error flags if saved or unsaved work spaces are insufficient
c
          IER = 10
          IF (LSAVE.LT.LSVMIN) RETURN
          IER = 11
          IF (LWORK.LT.LWKMIN) RETURN
          IER = 13
          NLAT = MAX0(NLATA,NLATB)
          IF (LDWORK.LT.NLAT* (NLAT+4)) RETURN
          IER = 0
          IF (IGRDA.EQ.1) THEN
c
c     initialize wsave for equally spaced analysis
c
              CALL DSHAECI(NLATA,NLONA,WSAVE,LWA,DWORK,LDWORK,IER)
          ELSE
c
c     initialize wsave for gaussian analysis
c
              CALL DSHAGCI(NLATA,NLONA,WSAVE,LWA,DWORK,LDWORK,IER)
              IF (IER.NE.0) THEN
c
c     flag failure in spherepack gaussian software
c
                  IER = 12
                  RETURN
              END IF
          END IF

          IF (IGRDB.EQ.2) THEN
c
c     initialize wsave for gaussian synthesis
c
              CALL DSHSGCI(NLATB,NLONB,WSAVE(JB),LWB,DWORK,LDWORK,IER)
              IF (IER.NE.0) THEN
c
c     flag failure in spherepack gaussian software
c
                  IER = 12
                  RETURN
              END IF
          ELSE
c
c     initialize wsave for equally spaced synthesis
c
              CALL DSHSECI(NLATB,NLONB,WSAVE(JB),LWB,DWORK,LDWORK,IER)
          END IF
c
c     end of initialization (intl=0) call
c
      END IF
c
c     transpose and/or reorder (co)latitude if necessary for da
c     (arrays must have latitude (colatitude) as the first dimension
c     and run north to south for spherepack software)
c
      IF (IGRIDA(2).EQ.0) CALL DTRSPLAT(NLONA,NLATA,DA,WORK)
      IF (IGRIDA(1).GT.0) CALL DCONVLAT(NLATA,NLONA,DA)

      NT = 1
      ISYM = 0
      IF (IGRDA.EQ.2) THEN
c
c     do spherical harmonic analysis of "adjusted" da on gaussian grid
c
          CALL DSHAGC(NLATA,NLONA,ISYM,NT,DA,NLATA,NLONA,WORK(IAA),
     +                WORK(IBA),LA1,NLATA,WSAVE,LWA,WORK(IW),LW,IER)
      ELSE
c
C*PL*ERROR* Comment line too long
c     do spherical harmonic analysis of "adjusted" da on equally spaced grid
c
          CALL DSHAEC(NLATA,NLONA,ISYM,NT,DA,NLATA,NLONA,WORK(IAA),
     +                WORK(IBA),LA1,NLATA,WSAVE,LWA,WORK(IW),LW,IER)
      END IF
c
c     transfer da grid coefficients to db grid coefficients
c     truncating to zero as necessary
c
      CALL DTRAB(LA1,NLATA,WORK(IAA),WORK(IBA),LB1,NLATB,WORK(IAB),
     +           WORK(IBB))
c     --------------------------NEW----------------------------------
c     (possibly) truncate and (possibly) taper the spectral coef
c
      IF (JMODE.NE.0) THEN
          CALL DTRITRUNC(NLATB,ABS(JMODE),NLATB,WORK(IAB),WORK(IBB))
          IF (JMODE.LT.0) THEN
              RN = MAX(ABS(JMODE)/10,1)*10
c c c         RN = RN-1.0
              CALL DEXPTAPERSH(NLATB,NLATB,WORK(IAB),WORK(IBB),RN,4,IER)
          END IF
      END IF
c     --------------------------NEW----------------------------------

      IF (IGRDB.EQ.1) THEN
c
C*PL*ERROR* Comment line too long
c     do spherical harmonic synthesis on nlatb by nlonb equally spaced grid
c
          CALL DSHSEC(NLATB,NLONB,ISYM,NT,DB,NLATB,NLONB,WORK(IAB),
     +                WORK(IBB),LB1,NLATB,WSAVE(JB),LWB,WORK(IW),LW,IER)
      ELSE
c
c     do spherical harmonic synthesis on nlatb by nlonb gaussian grid
c
          CALL DSHSGC(NLATB,NLONB,ISYM,NT,DB,NLATB,NLONB,WORK(IAB),
     +                WORK(IBB),LB1,NLATB,WSAVE(JB),LWB,WORK(IW),LW,IER)
      END IF
c
C*PL*ERROR* Comment line too long
c     both da,db are currently latitude by longitude north to south arrays
c     restore da and set db to agree with flags in igrida and igridb
c
      IF (IGRIDA(1).GT.0) CALL DCONVLAT(NLATA,NLONA,DA)
      IF (IGRIDB(1).GT.0) CALL DCONVLAT(NLATB,NLONB,DB)
      IF (IGRIDA(2).EQ.0) CALL DTRSPLAT(NLATA,NLONA,DA,WORK)
      IF (IGRIDB(2).EQ.0) CALL DTRSPLAT(NLATB,NLONB,DB,WORK)
      RETURN
      END

C
C       $Id: vvmpxy.f,v 1.13 2008-07-27 00:17:35 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
C
C-----------------------------------------------------------------------
C
      SUBROUTINE VVMPXY (X,Y,U,V,UVM,XB,YB,XE,YE,IST)
C
C This routine incorporates the functions previously known as FX, FX, 
C MXF, and MYF into a single subroutine. However, a compatibility
C mode is retained so that old codes that depend on custom versions of
C these functions will still work. The recommended approach for new 
C code that requires a custom transformation routine is to write your
C own version of VVUMXY (Velocity Vector -- User Map X,Y). Whenever 
C IMAP has a value other than 0,1, or 2 VVUMXY will be called.
C
C The most important thing to note is that the input vector position
C (a single point -- input parameters X and Y) is in user coordinate
C space, while the output (two points defining the beginning and
C end of the vector, XB,YB and XE,YE) is in the fractional coordinate
C space. 
C
C Note that each vector consists of three potentially tranformable
C components: position, direction, and magnitude. Depending on the 
C user's requirement, any or all of these components may need to be
C transformed. As an example the map transformations provided by
C VVMPXY transform the position and direction of the vector, but keep
C the vector magnitude based on a uniform coordinate system. This
C is the motivation for having the input vector position in user
C coordinates, but the output in the fractional coordinate system.
C The fractional system is known to be uniform -- a unit in X always
C equals a unit in Y.    
C
C Input parameters:
C
C X,Y   -- vector position in the user coordinate system
C U,V   -- vector components from the U,V arrays for this position
C UVM   -- vector magnitude,  (SQRT(U*U+V*V))
C
C Output parameters:
C
C XB,YB -- starting point of the vector in the fractional 
C          coordinate system
C XE,YE -- ending point of the vector in the fractional
C          coordinate system
C IST   -- status results of the mapping: 0 indicates success
C 
C
C The mapping common block: made available to user mapping routines
C
      COMMON /VVMAP/
     +                IMAP       ,
     +                XVPL       ,XVPR       ,YVPB       ,YVPT       ,
     +                WXMN       ,WXMX       ,WYMN       ,WYMX       ,
     +                XLOV       ,XHIV       ,YLOV       ,YHIV       ,
     +                SXDC       ,SYDC       ,NXCT       ,NYCT       ,
     +                RLEN       ,LNLG       ,INVX       ,INVY       ,
     +                ITRT       ,IWCT       ,FW2W       ,FH2H       ,
     +                DVMN       ,DVMX       ,RBIG       ,IBIG
C
      SAVE /VVMAP/
C
C Math constants
C
      PARAMETER (PDTOR  = 0.017453292519943,
     +           PRTOD  = 57.2957795130823,
     +           P1XPI  = 3.14159265358979,
     +           P2XPI  = 6.28318530717959,
     +           P1D2PI = 1.57079632679489,
     +           P5D2PI = 7.85398163397448) 
C
C --------------------------------------------------------------------
C
C --------------------------------------------------------------------
C
C Local parameters:
C
C PRCFAC - Precision factor used to resolve float equality within
C            the precision of a 4 byte REAL
C PVFRAC - Initial fraction of the vector magnitude used to
C            determine the differential increment
C PFOVFL - Floating point overflow value
C IPMXCT - Number of times to allow the differential to increase
C PDUVML - Multiplier when the differential is increased
C PCSTST - Test value for closeness to 90 degree latitude
C
      PARAMETER (PRCFAC=1E5,
     +           PVFRAC=0.001,
     +           PFOVFL=1E12,
     +           IPMXCT=40,
     +           PDUVML=2.0,
     +           IPCTST=PRCFAC*90)
C
C Local variables:
C
C DUV   - incremental UV magnitude difference
C CLT   - cosine of the latitude
C ICT   - repetition count for the difference loop
C SGN   - sign factor, for switching from pos to neg difference
C XT,YT - temporary projected X,Y position values
C XTF,YTF - temporary X,Y fractional coordinate values
C DV1,DV2 - vector magnitudes
C T     - temporary value
C IZO   - zero magnitude flag
C
C Each end of the vector is calculated in the user coordinate space.
C
C Zero the status flag
C
      IST=0
C
C Check for zero magnitude
C
      IF (INT(UVM*PRCFAC+0.5) .EQ. 0) THEN
         IZO = 1
      ELSE
         IZO = 0
      END IF
C
      If (IMAP .EQ. 0) THEN
C
C Linear transformation
C
         IF (X .LT. WXMN .OR. X .GT. WXMX .OR.
     +        Y .LT. WYMN .OR. Y .GT. WYMX) THEN
            IST=-5
            RETURN
         ENDIF
         XB=CUFX(X)
         YB=CUFY(Y)
C
C Return special status if zero magnitude
C
         IF (IZO .EQ. 1) THEN
            XE = XB
            YE = YB
            IST = -999
            RETURN
         END IF
C
         XE=XB+U*SXDC
         YE=YB+V*SYDC
C
C The following code accounts for non-uniform window coordinate
C systems, such as log scaled coordinates. The technique used
C is similar to the one used in the EZMAP case
C
         IF (ITRT .EQ. 1) THEN
C     
            DV1=SQRT((XE-XB)*(XE-XB)+(YE-YB)*(YE-YB))
C
C Set up an initial increment factor
C
            DUV=0.1/UVM
            ICT=0
            SGN=1.0
C     
 10         CONTINUE
C
C Bail out if it's not working
C     
            IF (ICT .GT. IPMXCT) THEN
               IST = -3
               RETURN
            END IF
C
C Calculate the incremental end points, then check to see if 
C they take us out of the user coordinate boundaries. If they
C do, try incrementing in the other direction
C
            XT=X+SGN*U*DUV
            YT=Y+SGN*V*DUV
            IF (XT .LT. WXMN .OR. XT .GT. WXMX .OR.
     +           YT .LT. WYMN .OR. YT .GT. WYMX) THEN
               IF (SGN .EQ. 1.0) THEN
                  SGN = -1.0
                  GO TO 10
               ELSE
                  IST=-4
                  RETURN
               ENDIF
            END IF
C
C Convert to fractional coordinates and find the incremental
C distance in the fractional system. To ensure that this distance
C is meaningful, we require that it be between 1E3 and 1E4
C times smaller than the maximum vector length.
C 
            XTF=CUFX(XT)
            YTF=CUFY(YT)
            DV2=SQRT((XTF-XB)*(XTF-XB)+(YTF-YB)*(YTF-YB))
            IF (DV2*1E3 .GT. DVMX) THEN
               ICT=ICT+1
               DUV=DUV/2.0
               GO TO 10
            ELSE IF (DV2*1E4 .LT. DVMX) THEN
               ICT=ICT+1
               DUV=DUV*2.0
               GO TO 10
            END IF
C
C The actual endpoints are found using the ratio of the incremental
C distance to the actual distance times the fractional component
C length
            XE=XB+SGN*(XTF-XB)*DV1/DV2
            YE=YB+SGN*(YTF-YB)*DV1/DV2
C
         END IF
C
C EZMAP overlay
C
      ELSE IF (IMAP .EQ. 1) THEN
C
C X is longitude, Y is latitude
C If Y is 90 degrees, a directional vector is meaningless
C Since EZMAP uses uniform user coordinates, don't convert to 
C fractional coordinates until the end
C The tranformation type parameter is not used.
C
         IF (INT(ABS(Y)*PRCFAC+0.5).EQ.IPCTST) THEN
            IST=-1
            RETURN
         END IF
C
C Project the starting value: bail out if outside the window
C
         CALL MAPTRA (Y,X,XB,YB)
         IF (XB .LT. WXMN .OR. XB .GT. WXMX .OR.
     +       YB .LT. WYMN .OR. YB .GT. WYMX) THEN
            IST=-5
            RETURN
         END IF
C
C Return special status if zero magnitude
C
         IF (IZO .EQ. 1) THEN
            XE = XB
            YE = YB
            IST = -999
            RETURN
         END IF
C
C The incremental distance is proportional to a small fraction
C of the vector magnitude
C
         DUV=PVFRAC/UVM
         CLT=COS(Y*PDTOR)
C
C Project the incremental distance. If the positive difference doesn't
C work, try the negative difference. If the difference results in a 
C zero length vector, try a number of progressively larger increments. 
C
         ICT=0
         SGN=1.0
 20      CONTINUE

         CALL MAPTRA(Y+SGN*V*DUV,X+SGN*U*DUV/CLT,XT,YT)

         DV1=SQRT((XT-XB)*(XT-XB)+(YT-YB)*(YT-YB))
         IF (DV1 .GT. RLEN) THEN
            IF (SGN .EQ. -1.0) THEN
               IST=-4
               RETURN
            ELSE
               SGN=-1.0
               GO TO 20
            END IF
         END IF
C
         IF (INT(DV1*PRCFAC) .EQ. 0) THEN
            IF (ICT .LT. IPMXCT) THEN
               ICT = ICT + 1
               DUV=DUV*PDUVML
               GO TO 20
            ELSE
               IST=-3
               RETURN
            END IF
         END IF
C
         IF (ABS(XT) .GE. PFOVFL .OR. ABS(YT) .GE. PFOVFL) THEN
            IST=-6
            RETURN
         END IF
C
         T=SGN*((XT-XB)/DV1)*UVM
         XB=CUFX(XB)
         XE=XB+T*SXDC
         T=SGN*((YT-YB)/DV1)*UVM
         YB=CUFY(YB)
         YE=YB+T*SYDC
C
      ELSE IF (IMAP .EQ. 2) THEN
C
C ... the polar coordinate case ...
C
         TH=PDTOR*Y
         XB=CUFX(X*COS(TH))
         YB=CUFY(X*SIN(TH))
C
C Return special status if zero magnitude
C
         IF (IZO .EQ. 1) THEN
            XE = XB
            YE = YB
            IST = -999
            RETURN
         END IF
C
         XE=XB+U*SXDC
         YE=YB+V*SYDC
C
         IF (ITRT.GE.1) THEN
            DV1=SQRT((XE-XB)*(XE-XB)+(YE-YB)*(YE-YB))
            PHI=ATAN2(V,U)
            ANG=TH+PHI
            XE=XB + DV1*COS(ANG)
            YE=YB + DV1*SIN(ANG)
         END IF
C
C ... and everything else.
C
      ELSE
C
         CALL VVUMXY(X,Y,U,V,UVM,XB,YB,XE,YE,IST)
C
      END IF
C
C Done.
C
      RETURN
C
      END

C
C	$Id: g01mio.f,v 1.12 2008-07-27 00:21:05 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE G01MIO (OP, UNIT, FNAME, BUFFER, LENGTH, ERROR)
C------------------------------------------------------------------------------
C
C	g01mio.f
C
C	The UNIX version of this routine allows the metafile
C	output to be specified using environment variables.
C	It does not actually use FORTRAN I/O.
C
C	Two environment variables play a part in this.
C
C	If NCARG_GKS_OUTPUT is not defined, the default file output
C	is determined by the procedure that calls G01MIO().
C
C	NCARG_GKS_OUTPUT can also be defined in two ways:
C
C	1. As a filename - CGM output will be directed to the
C	   file. (e.g. setenv NCARG_GKS_OUTPUT myfile)
C
C	2. A process, the name of which is preceeded by a pipe
C	   symbol. (e.g. setenv NCARG_GKS_OUTPUT "| translator")
C	   If no name follows the pipe symbol, a default translator
C	   is invoked.
C
C	NOTE: stdout to a translator is not used because of
C	potential conflicts with user code writing to logical unit 6.
C
C------------------------------------------------------------------------------
C
C  Central I/O routine for NCAR GKS.
C
C    INPUT PARAMETERS
C
C      OP     - Operation:
C                 =  1, open workstation for reading and writing on 
C                       ABS(UNIT) - truncates existing files.
C                 =  2, close workstation on ABS(UNIT).
C                 =  3, write buffer to ABS(UNIT).
C                 =  4, read ABS(UNIT) to buffer.
C                 =  5, position the record pointer to the beginning
C                       of the file.
C                 =  6, position the record pointer to the previous 
C                       record.
C                 =  7, flush the I/O buffers for UNIT.
C                 =  8, open workstation for reading only on ABS(UNIT).
C                 =  9, delete the segment whose file name is in FNAME.
C                 = 10, open a segment.
C                 = 11, open an existing CGM for appending.
C      UNIT   - ABS(UNIT) is the Fortran LUN on which OP is to occur.
C      FNAME  - filename used for open.
C      BUFFER - buffer containing data for a read/write operation.
C      LENGTH - length of data in BUFFER.
C
C    OUTPUT PARAMETERS
C
C      ERROR  - error indicator  =    0 if no errors.
C                                =   -1 if EOF.
C                                = -105 if open error.
C                                =  302 if read error.
C                                =  303 if write error.
C
C
      INTEGER  OP, UNIT, LENGTH, BUFFER(LENGTH), ERROR
      CHARACTER*(*) FNAME
C
C  Local variables:  IAUNIT is the Fortran LUN.
C                    IOPENF is a flag for the file open:
C                             = 0  open segment for read only.
C                             = 1  truncate and open for reading and writing.
C                             = 2  open a segment for writing.
C                             = 3  open CGM for appending.
C
      INTEGER IAUNT,IOPENF
C
      ERROR = 0
      IAUNT = ABS(UNIT)

C Open the workstation with filename FNAME

      IF (OP.EQ.1) THEN
        IOPENF = 1
	CALL OPNWKS(IAUNT, IOPENF, FNAME, ERROR)

C Close the workstation attached to IAUNT

      ELSE IF (OP.EQ.2) THEN
	CALL CLSWKS(IAUNT, ERROR)

C Write the BUFFER to the workstation

      ELSE IF (OP.EQ.3) THEN
	CALL WRTWKS(IAUNT, BUFFER, LENGTH, ERROR)

C Read from current location into BUFFER

      ELSE IF (OP.EQ.4) THEN
	CALL RDWKS(IAUNT, BUFFER, LENGTH, ERROR)

C Move file pointer to beginning

      ELSE IF (OP.EQ.5) THEN
	CALL BEGWKS(IAUNT, ERROR)

C Move file pointer back one record

      ELSE IF (OP.EQ.6) THEN
	CALL LSTWKS(IAUNT, ERROR)

C Flush the I/O buffers for a given unit

      ELSE IF (OP.EQ.7) THEN
	CALL FLSWKS(IAUNT, ERROR)

      ELSE IF (OP.EQ.8) THEN
        IOPENF = 0
	CALL OPNWKS(IAUNT, IOPENF, FNAME, ERROR)

      ELSE IF (OP.EQ.9) THEN
	CALL DELFIL(FNAME, ERROR)

      ELSE IF (OP.EQ.10) THEN
        IOPENF = 2
	CALL OPNWKS(IAUNT, IOPENF, FNAME, ERROR)

      ELSE IF (OP.EQ.11) THEN
        IOPENF = 3
	CALL OPNWKS(IAUNT, IOPENF, FNAME, ERROR)

      ENDIF

      END

C
C	$Id: gqdsp.f,v 1.8 2008-07-27 00:20:59 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GQDSP(WTYPE,ERRIND,DCUNIT,RXP,RYP,LX,LY)
C
C  INQUIRE DISPLAY SPACE SIZE
C
      include 'gkscom.h'
C
      INTEGER WTYPE,ERRIND,DCUNIT,LX,LY
      REAL    RXP,RYP
C
C  Check if GKS is in the proper state.
C
      CALL GZCKST(8,-1,ERRIND)
      IF (ERRIND .NE. 0) GO TO 100
C
C  Check that the workstation type is valid.
C
      CALL GZCKWK(22,-1,IDUM,WTYPE,ERRIND)
      IF (ERRIND .NE. 0) GO TO 100
C
C  Check on workstation category.
C
      CALL GQWKCA(WTYPE,IERR,ICAT)
      IF (IERR .NE. 0) THEN
        ERRIND = IERR
        GO TO 100
      ENDIF
C
      IF (ICAT .EQ. GMO) THEN
        ERRIND = 31
        GO TO 100
      ELSE IF (ICAT .EQ. GMI) THEN
        ERRIND = 33
        GO TO 100
      ELSE IF (ICAT .EQ. GWISS) THEN
        ERRIND = 36
        GO TO 100
      ENDIF
C
      IF (WTYPE.EQ.GXWC .OR. WTYPE.EQ.GXWE .OR. WTYPE.EQ.GDMP .OR.
     +    WTYPE.EQ.GPIX) THEN
        DCUNIT = 1
        RXP = 1.
        RYP = 1.
        LX  = 1280
        LY  = 1024
        RETURN
      ENDIF
C
      IF ((WTYPE.GE.GPSMIN .AND. WTYPE.LE.GPSMAX) .OR.
     +     WTYPE.EQ.GPDFP .OR. WTYPE.EQ.GPDFL) THEN
        DCUNIT = 1
        RXP = 1.
        RYP = 1.
        LX  = 13335
        LY  = 13335
        RETURN
      ENDIF
C   
  100 CONTINUE
      DCUNIT  = -1
      RXP     = -1.
      RYP     = -1.
      LX      = -1
      LY      = -1
C
      RETURN
      END

C
C	$Id: csswptst.f,v 1.5 2008-07-27 03:10:08 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      LOGICAL FUNCTION CSSWPTST (N1,N2,N3,N4,X,Y,Z)
      INTEGER N1, N2, N3, N4
      DOUBLE PRECISION X(*), Y(*), Z(*)
C
C***********************************************************
C
C                                              From STRIPACK
C                                            Robert J. Renka
C                                  Dept. of Computer Science
C                                       Univ. of North Texas
C                                           renka@cs.unt.edu
C                                                   03/29/91
C
C   This function decides whether or not to replace a
C diagonal arc in a quadrilateral with the other diagonal.
C The decision will be to swap (CSSWPTST = TRUE) if and only
C if N4 lies above the plane (in the half-space not contain-
C ing the origin) defined by (N1,N2,N3), or equivalently, if
C the projection of N4 onto this plane is interior to the
C circumcircle of (N1,N2,N3).  The decision will be for no
C swap if the quadrilateral is not strictly convex.
C
C
C On input:
C
C       N1,N2,N3,N4 = Indexes of the four nodes defining the
C                     quadrilateral with N1 adjacent to N2,
C                     and (N1,N2,N3) in counterclockwise
C                     order.  The arc connecting N1 to N2
C                     should be replaced by an arc connec-
C                     ting N3 to N4 if CSSWPTST = TRUE.  Refer
C                     to Subroutine CSSWAP.
C
C       X,Y,Z = Arrays of length N containing the Cartesian
C               coordinates of the nodes.  (X(I),Y(I),Z(I))
C               define node I for I = N1, N2, N3, and N4.
C
C Input parameters are not altered by this routine.
C
C On output:
C
C       CSSWPTST = TRUE if and only if the arc connecting N1
C                and N2 should be swapped for an arc con-
C                necting N3 and N4.
C
C Modules required by CSSWPTST:  None
C
C***********************************************************
C
      DOUBLE PRECISION DX1, DX2, DX3, DY1, DY2, DY3, DZ1,
     .                 DZ2, DZ3, X4, Y4, Z4
C
C Local parameters:
C
C DX1,DY1,DZ1 = Coordinates of N4->N1
C DX2,DY2,DZ2 = Coordinates of N4->N2
C DX3,DY3,DZ3 = Coordinates of N4->N3
C X4,Y4,Z4 =    Coordinates of N4
C
      X4 = X(N4)
      Y4 = Y(N4)
      Z4 = Z(N4)
      DX1 = X(N1) - X4
      DX2 = X(N2) - X4
      DX3 = X(N3) - X4
      DY1 = Y(N1) - Y4
      DY2 = Y(N2) - Y4
      DY3 = Y(N3) - Y4
      DZ1 = Z(N1) - Z4
      DZ2 = Z(N2) - Z4
      DZ3 = Z(N3) - Z4
C
C N4 lies above the plane of (N1,N2,N3) iff N3 lies above
C   the plane of (N2,N1,N4) iff Det(N3-N4,N2-N4,N1-N4) =
C   (N3-N4,N2-N4 X N1-N4) > 0.
C
      CSSWPTST = DX3*(DY2*DZ1 - DY1*DZ2)
     .        -DY3*(DX2*DZ1 - DX1*DZ2)
     .        +DZ3*(DX2*DY1 - DX1*DY2) .GT. 0.D0
      RETURN
      END

C
C $Id: hstexp.f,v 1.7 2008-07-27 00:17:15 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
C *************************************************************
C
        SUBROUTINE HSTEXP(HWIND,MAXW)
C
C *************************************************************
C
C  THE WINDOW IS EXPANDED AND THE NEW WORLD COORDINATES ARE
C  CALCULATED TO CORRESPOND TO THE NEW GIVEN VIEWPORT
C  THE ORIGINAL AXPECT RATIO (WORLD COORDS : VIEWPORT COORDS) REMAINS
C
        REAL MAXW(4), VIEW(4), WIND(4), HWIND(4), LEFT
C
C  INQUIRE CURRENT WINDOW AND VIEWPORT LIMITS
C
        CALL GQCNTN(IERR,ICNT)
        CALL GQNT(ICNT,IERR,WIND,VIEW)
C
C  CALCULATE RATIO OF Y WORLD / VIEWPORT COORDINATES
C
        YRATIO = (WIND(4) - WIND(3))/(VIEW(4) - VIEW(3))
C
C  CALCULATE RATIO OF X WORLD / VIEWPORT COORDINATES
C
        XRATIO = (WIND(2) - WIND(1))/(VIEW(2) - VIEW(1))
C
C  GET EXPANDED LOWER LIMIT Y COORDINATE
C
        VBOTTM = VIEW(3) - HWIND(3)
        BOTTOM = YRATIO * VBOTTM
        MAXW(3) = WIND(3) - BOTTOM
C
C  GET EXPANDED UPPER LIMIT Y COORDINATE
C
        VTOP = HWIND(4) - VIEW(4)
        TOP = YRATIO * VTOP
        MAXW(4) = WIND(4) + TOP
C
C  GET EXPANDED LEFT LIMIT X COORDINATE
C
        VLEFT = VIEW(1) - HWIND(1)
        LEFT = XRATIO * VLEFT
        MAXW(1) = WIND(1) - LEFT
C
C  GET EXPANDED RIGHT LIMIT X COORDINATE
C
        VRIGHT = HWIND(2) - VIEW(2)
        RIGHT = XRATIO * VRIGHT
        MAXW(2) = WIND(2) + RIGHT
C
C  SET NEW (EXPANDED) NORMALIZATION TRANSFORMATION
C
        CALL GSWN(1,MAXW(1),MAXW(2),MAXW(3),MAXW(4))
	CALL GSVP(1, HWIND(1), HWIND(2), HWIND(3), HWIND(4))
        CALL GSELNT(1)
C
C
        RETURN
        END

C
C $Id: mdrgdl.f,v 1.9 2008-09-18 00:42:18 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MDRGDL (IRGL)
C
        INTEGER          IRGL
C
C This routine is intended to pick an appropriate data level at which to
C use the RANGS/GSHHS data and return it as the value of IRGL.
C
        DOUBLE PRECISION MDSCAL
C
C Pre-set IRGL in case we take an error exit.
C
        IRGL=0
C
C Check for an uncleared prior error.
C
        IF (ICFELL('MDRGDL - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C If EZMAP needs initialization, do it.
C
        CALL MDGETI ('IN',INTF)
C
        IF (INTF.NE.0) THEN
          CALL MDPINT
          IF (ICFELL('MDRGDL',2).NE.0) RETURN
        END IF
C
C Retrieve the SPPS parameters specifying the mapping of fractional
C coordinates to the U/V plane.
C
        CALL GETSET (XVPL,XVPR,YVPB,YVPT,XWDL,XWDR,YWDB,YWDT,LNLG)
        IF (ICFELL('MDRGDL',3).NE.0) RETURN
C
C Find the angular separation of those points on the globe that project
C into two points near the center of the map and divide by the distance
C between the points on the map to get an estimate of the scale of the
C map in that vicinity.
C
        SCAL=MDSCAL(XVPL+.49*(XVPR-XVPL),.5*(YVPB+YVPT),
     +              XVPL+.51*(XVPR-XVPL),.5*(YVPB+YVPT))
C
C Return a value of the resolution flag based on a somewhat heuristic
C interpretation of the scale estimate.
C
        IF      (SCAL.LT.10.D0) THEN
          IRGL=0
        ELSE IF (SCAL.LT.20.D0) THEN
          IRGL=1
        ELSE IF (SCAL.LE.40.D0) THEN
          IRGL=2
        ELSE IF (SCAL.LE.80.D0) THEN
          IRGL=3
        ELSE
          IRGL=4
        END IF
C
C Done.
C
        RETURN
C
      END

      SUBROUTINE SPTTS2( N, NRHS, D, E, B, LDB )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      INTEGER            LDB, N, NRHS
*     ..
*     .. Array Arguments ..
      REAL               B( LDB, * ), D( * ), E( * )
*     ..
*
*  Purpose
*  =======
*
*  SPTTS2 solves a tridiagonal system of the form
*     A * X = B
*  using the L*D*L' factorization of A computed by SPTTRF.  D is a
*  diagonal matrix specified in the vector D, L is a unit bidiagonal
*  matrix whose subdiagonal is specified in the vector E, and X and B
*  are N by NRHS matrices.
*
*  Arguments
*  =========
*
*  N       (input) INTEGER
*          The order of the tridiagonal matrix A.  N >= 0.
*
*  NRHS    (input) INTEGER
*          The number of right hand sides, i.e., the number of columns
*          of the matrix B.  NRHS >= 0.
*
*  D       (input) REAL array, dimension (N)
*          The n diagonal elements of the diagonal matrix D from the
*          L*D*L' factorization of A.
*
*  E       (input) REAL array, dimension (N-1)
*          The (n-1) subdiagonal elements of the unit bidiagonal factor
*          L from the L*D*L' factorization of A.  E can also be regarded
*          as the superdiagonal of the unit bidiagonal factor U from the
*          factorization A = U'*D*U.
*
*  B       (input/output) REAL array, dimension (LDB,NRHS)
*          On entry, the right hand side vectors B for the system of
*          linear equations.
*          On exit, the solution vectors, X.
*
*  LDB     (input) INTEGER
*          The leading dimension of the array B.  LDB >= max(1,N).
*
*  =====================================================================
*
*     .. Local Scalars ..
      INTEGER            I, J
*     ..
*     .. External Subroutines ..
      EXTERNAL           SSCAL
*     ..
*     .. Executable Statements ..
*
*     Quick return if possible
*
      IF( N.LE.1 ) THEN
         IF( N.EQ.1 )
     $      CALL SSCAL( NRHS, 1. / D( 1 ), B, LDB )
         RETURN
      END IF
*
*     Solve A * X = B using the factorization A = L*D*L',
*     overwriting each right hand side vector with its solution.
*
      DO 30 J = 1, NRHS
*
*           Solve L * x = b.
*
         DO 10 I = 2, N
            B( I, J ) = B( I, J ) - B( I-1, J )*E( I-1 )
   10    CONTINUE
*
*           Solve D * L' * x = b.
*
         B( N, J ) = B( N, J ) / D( N )
         DO 20 I = N - 1, 1, -1
            B( I, J ) = B( I, J ) / D( I ) - B( I+1, J )*E( I )
   20    CONTINUE
   30 CONTINUE
*
      RETURN
*
*     End of SPTTS2
*
      END

C
C	$Id: mapconvrt.f,v 1.4 2008-07-27 01:04:30 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      PROGRAM CONVRT
        DIMENSION FLIM(4),PNTS(200)
        OPEN (UNIT=1,STATUS='OLD',FILE='ezmapdat',ERR=5)
        OPEN (UNIT=2,STATUS='NEW',FORM='UNFORMATTED',FILE='ezmapdata',
     +      ERR=6)
        REWIND 1
        REWIND 2
    1   READ (1,3,END=2) NPTS,IGID,IDLS,IDRS,(FLIM(I),I=1,4)
        IF (NPTS.GT.1) READ (1,4,END=2) (PNTS(I),I=1,NPTS)
        WRITE (2) NPTS,IGID,IDLS,IDRS,(FLIM(I),I=1,4),(PNTS(I),I=1,NPTS)
        GO TO 1
    2   STOP
    3   FORMAT (4I4,4F8.3)
    4   FORMAT (10F8.3)
    5   WRITE (6,*) 'Error in opening the file <ezmapdat>.'
        STOP
    6   WRITE(6,*) 'Error in creating the file <ezmapdata>.'
        STOP
      END

      SUBROUTINE SSBGST( VECT, UPLO, N, KA, KB, AB, LDAB, BB, LDBB, X,
     $                   LDX, WORK, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          UPLO, VECT
      INTEGER            INFO, KA, KB, LDAB, LDBB, LDX, N
*     ..
*     .. Array Arguments ..
      REAL               AB( LDAB, * ), BB( LDBB, * ), WORK( * ),
     $                   X( LDX, * )
*     ..
*
*  Purpose
*  =======
*
*  SSBGST reduces a real symmetric-definite banded generalized
*  eigenproblem  A*x = lambda*B*x  to standard form  C*y = lambda*y,
*  such that C has the same bandwidth as A.
*
*  B must have been previously factorized as S**T*S by SPBSTF, using a
*  split Cholesky factorization. A is overwritten by C = X**T*A*X, where
*  X = S**(-1)*Q and Q is an orthogonal matrix chosen to preserve the
*  bandwidth of A.
*
*  Arguments
*  =========
*
*  VECT    (input) CHARACTER*1
*          = 'N':  do not form the transformation matrix X;
*          = 'V':  form X.
*
*  UPLO    (input) CHARACTER*1
*          = 'U':  Upper triangle of A is stored;
*          = 'L':  Lower triangle of A is stored.
*
*  N       (input) INTEGER
*          The order of the matrices A and B.  N >= 0.
*
*  KA      (input) INTEGER
*          The number of superdiagonals of the matrix A if UPLO = 'U',
*          or the number of subdiagonals if UPLO = 'L'.  KA >= 0.
*
*  KB      (input) INTEGER
*          The number of superdiagonals of the matrix B if UPLO = 'U',
*          or the number of subdiagonals if UPLO = 'L'.  KA >= KB >= 0.
*
*  AB      (input/output) REAL array, dimension (LDAB,N)
*          On entry, the upper or lower triangle of the symmetric band
*          matrix A, stored in the first ka+1 rows of the array.  The
*          j-th column of A is stored in the j-th column of the array AB
*          as follows:
*          if UPLO = 'U', AB(ka+1+i-j,j) = A(i,j) for max(1,j-ka)<=i<=j;
*          if UPLO = 'L', AB(1+i-j,j)    = A(i,j) for j<=i<=min(n,j+ka).
*
*          On exit, the transformed matrix X**T*A*X, stored in the same
*          format as A.
*
*  LDAB    (input) INTEGER
*          The leading dimension of the array AB.  LDAB >= KA+1.
*
*  BB      (input) REAL array, dimension (LDBB,N)
*          The banded factor S from the split Cholesky factorization of
*          B, as returned by SPBSTF, stored in the first KB+1 rows of
*          the array.
*
*  LDBB    (input) INTEGER
*          The leading dimension of the array BB.  LDBB >= KB+1.
*
*  X       (output) REAL array, dimension (LDX,N)
*          If VECT = 'V', the n-by-n matrix X.
*          If VECT = 'N', the array X is not referenced.
*
*  LDX     (input) INTEGER
*          The leading dimension of the array X.
*          LDX >= max(1,N) if VECT = 'V'; LDX >= 1 otherwise.
*
*  WORK    (workspace) REAL array, dimension (2*N)
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value.
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ZERO, ONE
      PARAMETER          ( ZERO = 0.0E+0, ONE = 1.0E+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            UPDATE, UPPER, WANTX
      INTEGER            I, I0, I1, I2, INCA, J, J1, J1T, J2, J2T, K,
     $                   KA1, KB1, KBT, L, M, NR, NRT, NX
      REAL               BII, RA, RA1, T
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           SGER, SLAR2V, SLARGV, SLARTG, SLARTV, SLASET,
     $                   SROT, SSCAL, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters
*
      WANTX = LSAME( VECT, 'V' )
      UPPER = LSAME( UPLO, 'U' )
      KA1 = KA + 1
      KB1 = KB + 1
      INFO = 0
      IF( .NOT.WANTX .AND. .NOT.LSAME( VECT, 'N' ) ) THEN
         INFO = -1
      ELSE IF( .NOT.UPPER .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = -2
      ELSE IF( N.LT.0 ) THEN
         INFO = -3
      ELSE IF( KA.LT.0 ) THEN
         INFO = -4
      ELSE IF( KB.LT.0 ) THEN
         INFO = -5
      ELSE IF( LDAB.LT.KA+1 ) THEN
         INFO = -7
      ELSE IF( LDBB.LT.KB+1 ) THEN
         INFO = -9
      ELSE IF( LDX.LT.1 .OR. WANTX .AND. LDX.LT.MAX( 1, N ) ) THEN
         INFO = -11
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'SSBGST', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
*
      INCA = LDAB*KA1
*
*     Initialize X to the unit matrix, if needed
*
      IF( WANTX )
     $   CALL SLASET( 'Full', N, N, ZERO, ONE, X, LDX )
*
*     Set M to the splitting point m. It must be the same value as is
*     used in SPBSTF. The chosen value allows the arrays WORK and RWORK
*     to be of dimension (N).
*
      M = ( N+KB ) / 2
*
*     The routine works in two phases, corresponding to the two halves
*     of the split Cholesky factorization of B as S**T*S where
*
*     S = ( U    )
*         ( M  L )
*
*     with U upper triangular of order m, and L lower triangular of
*     order n-m. S has the same bandwidth as B.
*
*     S is treated as a product of elementary matrices:
*
*     S = S(m)*S(m-1)*...*S(2)*S(1)*S(m+1)*S(m+2)*...*S(n-1)*S(n)
*
*     where S(i) is determined by the i-th row of S.
*
*     In phase 1, the index i takes the values n, n-1, ... , m+1;
*     in phase 2, it takes the values 1, 2, ... , m.
*
*     For each value of i, the current matrix A is updated by forming
*     inv(S(i))**T*A*inv(S(i)). This creates a triangular bulge outside
*     the band of A. The bulge is then pushed down toward the bottom of
*     A in phase 1, and up toward the top of A in phase 2, by applying
*     plane rotations.
*
*     There are kb*(kb+1)/2 elements in the bulge, but at most 2*kb-1
*     of them are linearly independent, so annihilating a bulge requires
*     only 2*kb-1 plane rotations. The rotations are divided into a 1st
*     set of kb-1 rotations, and a 2nd set of kb rotations.
*
*     Wherever possible, rotations are generated and applied in vector
*     operations of length NR between the indices J1 and J2 (sometimes
*     replaced by modified values NRT, J1T or J2T).
*
*     The cosines and sines of the rotations are stored in the array
*     WORK. The cosines of the 1st set of rotations are stored in
*     elements n+2:n+m-kb-1 and the sines of the 1st set in elements
*     2:m-kb-1; the cosines of the 2nd set are stored in elements
*     n+m-kb+1:2*n and the sines of the second set in elements m-kb+1:n.
*
*     The bulges are not formed explicitly; nonzero elements outside the
*     band are created only when they are required for generating new
*     rotations; they are stored in the array WORK, in positions where
*     they are later overwritten by the sines of the rotations which
*     annihilate them.
*
*     **************************** Phase 1 *****************************
*
*     The logical structure of this phase is:
*
*     UPDATE = .TRUE.
*     DO I = N, M + 1, -1
*        use S(i) to update A and create a new bulge
*        apply rotations to push all bulges KA positions downward
*     END DO
*     UPDATE = .FALSE.
*     DO I = M + KA + 1, N - 1
*        apply rotations to push all bulges KA positions downward
*     END DO
*
*     To avoid duplicating code, the two loops are merged.
*
      UPDATE = .TRUE.
      I = N + 1
   10 CONTINUE
      IF( UPDATE ) THEN
         I = I - 1
         KBT = MIN( KB, I-1 )
         I0 = I - 1
         I1 = MIN( N, I+KA )
         I2 = I - KBT + KA1
         IF( I.LT.M+1 ) THEN
            UPDATE = .FALSE.
            I = I + 1
            I0 = M
            IF( KA.EQ.0 )
     $         GO TO 480
            GO TO 10
         END IF
      ELSE
         I = I + KA
         IF( I.GT.N-1 )
     $      GO TO 480
      END IF
*
      IF( UPPER ) THEN
*
*        Transform A, working with the upper triangle
*
         IF( UPDATE ) THEN
*
*           Form  inv(S(i))**T * A * inv(S(i))
*
            BII = BB( KB1, I )
            DO 20 J = I, I1
               AB( I-J+KA1, J ) = AB( I-J+KA1, J ) / BII
   20       CONTINUE
            DO 30 J = MAX( 1, I-KA ), I
               AB( J-I+KA1, I ) = AB( J-I+KA1, I ) / BII
   30       CONTINUE
            DO 60 K = I - KBT, I - 1
               DO 40 J = I - KBT, K
                  AB( J-K+KA1, K ) = AB( J-K+KA1, K ) -
     $                               BB( J-I+KB1, I )*AB( K-I+KA1, I ) -
     $                               BB( K-I+KB1, I )*AB( J-I+KA1, I ) +
     $                               AB( KA1, I )*BB( J-I+KB1, I )*
     $                               BB( K-I+KB1, I )
   40          CONTINUE
               DO 50 J = MAX( 1, I-KA ), I - KBT - 1
                  AB( J-K+KA1, K ) = AB( J-K+KA1, K ) -
     $                               BB( K-I+KB1, I )*AB( J-I+KA1, I )
   50          CONTINUE
   60       CONTINUE
            DO 80 J = I, I1
               DO 70 K = MAX( J-KA, I-KBT ), I - 1
                  AB( K-J+KA1, J ) = AB( K-J+KA1, J ) -
     $                               BB( K-I+KB1, I )*AB( I-J+KA1, J )
   70          CONTINUE
   80       CONTINUE
*
            IF( WANTX ) THEN
*
*              post-multiply X by inv(S(i))
*
               CALL SSCAL( N-M, ONE / BII, X( M+1, I ), 1 )
               IF( KBT.GT.0 )
     $            CALL SGER( N-M, KBT, -ONE, X( M+1, I ), 1,
     $                       BB( KB1-KBT, I ), 1, X( M+1, I-KBT ), LDX )
            END IF
*
*           store a(i,i1) in RA1 for use in next loop over K
*
            RA1 = AB( I-I1+KA1, I1 )
         END IF
*
*        Generate and apply vectors of rotations to chase all the
*        existing bulges KA positions down toward the bottom of the
*        band
*
         DO 130 K = 1, KB - 1
            IF( UPDATE ) THEN
*
*              Determine the rotations which would annihilate the bulge
*              which has in theory just been created
*
               IF( I-K+KA.LT.N .AND. I-K.GT.1 ) THEN
*
*                 generate rotation to annihilate a(i,i-k+ka+1)
*
                  CALL SLARTG( AB( K+1, I-K+KA ), RA1,
     $                         WORK( N+I-K+KA-M ), WORK( I-K+KA-M ),
     $                         RA )
*
*                 create nonzero element a(i-k,i-k+ka+1) outside the
*                 band and store it in WORK(i-k)
*
                  T = -BB( KB1-K, I )*RA1
                  WORK( I-K ) = WORK( N+I-K+KA-M )*T -
     $                          WORK( I-K+KA-M )*AB( 1, I-K+KA )
                  AB( 1, I-K+KA ) = WORK( I-K+KA-M )*T +
     $                              WORK( N+I-K+KA-M )*AB( 1, I-K+KA )
                  RA1 = RA
               END IF
            END IF
            J2 = I - K - 1 + MAX( 1, K-I0+2 )*KA1
            NR = ( N-J2+KA ) / KA1
            J1 = J2 + ( NR-1 )*KA1
            IF( UPDATE ) THEN
               J2T = MAX( J2, I+2*KA-K+1 )
            ELSE
               J2T = J2
            END IF
            NRT = ( N-J2T+KA ) / KA1
            DO 90 J = J2T, J1, KA1
*
*              create nonzero element a(j-ka,j+1) outside the band
*              and store it in WORK(j-m)
*
               WORK( J-M ) = WORK( J-M )*AB( 1, J+1 )
               AB( 1, J+1 ) = WORK( N+J-M )*AB( 1, J+1 )
   90       CONTINUE
*
*           generate rotations in 1st set to annihilate elements which
*           have been created outside the band
*
            IF( NRT.GT.0 )
     $         CALL SLARGV( NRT, AB( 1, J2T ), INCA, WORK( J2T-M ), KA1,
     $                      WORK( N+J2T-M ), KA1 )
            IF( NR.GT.0 ) THEN
*
*              apply rotations in 1st set from the right
*
               DO 100 L = 1, KA - 1
                  CALL SLARTV( NR, AB( KA1-L, J2 ), INCA,
     $                         AB( KA-L, J2+1 ), INCA, WORK( N+J2-M ),
     $                         WORK( J2-M ), KA1 )
  100          CONTINUE
*
*              apply rotations in 1st set from both sides to diagonal
*              blocks
*
               CALL SLAR2V( NR, AB( KA1, J2 ), AB( KA1, J2+1 ),
     $                      AB( KA, J2+1 ), INCA, WORK( N+J2-M ),
     $                      WORK( J2-M ), KA1 )
*
            END IF
*
*           start applying rotations in 1st set from the left
*
            DO 110 L = KA - 1, KB - K + 1, -1
               NRT = ( N-J2+L ) / KA1
               IF( NRT.GT.0 )
     $            CALL SLARTV( NRT, AB( L, J2+KA1-L ), INCA,
     $                         AB( L+1, J2+KA1-L ), INCA,
     $                         WORK( N+J2-M ), WORK( J2-M ), KA1 )
  110       CONTINUE
*
            IF( WANTX ) THEN
*
*              post-multiply X by product of rotations in 1st set
*
               DO 120 J = J2, J1, KA1
                  CALL SROT( N-M, X( M+1, J ), 1, X( M+1, J+1 ), 1,
     $                       WORK( N+J-M ), WORK( J-M ) )
  120          CONTINUE
            END IF
  130    CONTINUE
*
         IF( UPDATE ) THEN
            IF( I2.LE.N .AND. KBT.GT.0 ) THEN
*
*              create nonzero element a(i-kbt,i-kbt+ka+1) outside the
*              band and store it in WORK(i-kbt)
*
               WORK( I-KBT ) = -BB( KB1-KBT, I )*RA1
            END IF
         END IF
*
         DO 170 K = KB, 1, -1
            IF( UPDATE ) THEN
               J2 = I - K - 1 + MAX( 2, K-I0+1 )*KA1
            ELSE
               J2 = I - K - 1 + MAX( 1, K-I0+1 )*KA1
            END IF
*
*           finish applying rotations in 2nd set from the left
*
            DO 140 L = KB - K, 1, -1
               NRT = ( N-J2+KA+L ) / KA1
               IF( NRT.GT.0 )
     $            CALL SLARTV( NRT, AB( L, J2-L+1 ), INCA,
     $                         AB( L+1, J2-L+1 ), INCA, WORK( N+J2-KA ),
     $                         WORK( J2-KA ), KA1 )
  140       CONTINUE
            NR = ( N-J2+KA ) / KA1
            J1 = J2 + ( NR-1 )*KA1
            DO 150 J = J1, J2, -KA1
               WORK( J ) = WORK( J-KA )
               WORK( N+J ) = WORK( N+J-KA )
  150       CONTINUE
            DO 160 J = J2, J1, KA1
*
*              create nonzero element a(j-ka,j+1) outside the band
*              and store it in WORK(j)
*
               WORK( J ) = WORK( J )*AB( 1, J+1 )
               AB( 1, J+1 ) = WORK( N+J )*AB( 1, J+1 )
  160       CONTINUE
            IF( UPDATE ) THEN
               IF( I-K.LT.N-KA .AND. K.LE.KBT )
     $            WORK( I-K+KA ) = WORK( I-K )
            END IF
  170    CONTINUE
*
         DO 210 K = KB, 1, -1
            J2 = I - K - 1 + MAX( 1, K-I0+1 )*KA1
            NR = ( N-J2+KA ) / KA1
            J1 = J2 + ( NR-1 )*KA1
            IF( NR.GT.0 ) THEN
*
*              generate rotations in 2nd set to annihilate elements
*              which have been created outside the band
*
               CALL SLARGV( NR, AB( 1, J2 ), INCA, WORK( J2 ), KA1,
     $                      WORK( N+J2 ), KA1 )
*
*              apply rotations in 2nd set from the right
*
               DO 180 L = 1, KA - 1
                  CALL SLARTV( NR, AB( KA1-L, J2 ), INCA,
     $                         AB( KA-L, J2+1 ), INCA, WORK( N+J2 ),
     $                         WORK( J2 ), KA1 )
  180          CONTINUE
*
*              apply rotations in 2nd set from both sides to diagonal
*              blocks
*
               CALL SLAR2V( NR, AB( KA1, J2 ), AB( KA1, J2+1 ),
     $                      AB( KA, J2+1 ), INCA, WORK( N+J2 ),
     $                      WORK( J2 ), KA1 )
*
            END IF
*
*           start applying rotations in 2nd set from the left
*
            DO 190 L = KA - 1, KB - K + 1, -1
               NRT = ( N-J2+L ) / KA1
               IF( NRT.GT.0 )
     $            CALL SLARTV( NRT, AB( L, J2+KA1-L ), INCA,
     $                         AB( L+1, J2+KA1-L ), INCA, WORK( N+J2 ),
     $                         WORK( J2 ), KA1 )
  190       CONTINUE
*
            IF( WANTX ) THEN
*
*              post-multiply X by product of rotations in 2nd set
*
               DO 200 J = J2, J1, KA1
                  CALL SROT( N-M, X( M+1, J ), 1, X( M+1, J+1 ), 1,
     $                       WORK( N+J ), WORK( J ) )
  200          CONTINUE
            END IF
  210    CONTINUE
*
         DO 230 K = 1, KB - 1
            J2 = I - K - 1 + MAX( 1, K-I0+2 )*KA1
*
*           finish applying rotations in 1st set from the left
*
            DO 220 L = KB - K, 1, -1
               NRT = ( N-J2+L ) / KA1
               IF( NRT.GT.0 )
     $            CALL SLARTV( NRT, AB( L, J2+KA1-L ), INCA,
     $                         AB( L+1, J2+KA1-L ), INCA,
     $                         WORK( N+J2-M ), WORK( J2-M ), KA1 )
  220       CONTINUE
  230    CONTINUE
*
         IF( KB.GT.1 ) THEN
            DO 240 J = N - 1, I - KB + 2*KA + 1, -1
               WORK( N+J-M ) = WORK( N+J-KA-M )
               WORK( J-M ) = WORK( J-KA-M )
  240       CONTINUE
         END IF
*
      ELSE
*
*        Transform A, working with the lower triangle
*
         IF( UPDATE ) THEN
*
*           Form  inv(S(i))**T * A * inv(S(i))
*
            BII = BB( 1, I )
            DO 250 J = I, I1
               AB( J-I+1, I ) = AB( J-I+1, I ) / BII
  250       CONTINUE
            DO 260 J = MAX( 1, I-KA ), I
               AB( I-J+1, J ) = AB( I-J+1, J ) / BII
  260       CONTINUE
            DO 290 K = I - KBT, I - 1
               DO 270 J = I - KBT, K
                  AB( K-J+1, J ) = AB( K-J+1, J ) -
     $                             BB( I-J+1, J )*AB( I-K+1, K ) -
     $                             BB( I-K+1, K )*AB( I-J+1, J ) +
     $                             AB( 1, I )*BB( I-J+1, J )*
     $                             BB( I-K+1, K )
  270          CONTINUE
               DO 280 J = MAX( 1, I-KA ), I - KBT - 1
                  AB( K-J+1, J ) = AB( K-J+1, J ) -
     $                             BB( I-K+1, K )*AB( I-J+1, J )
  280          CONTINUE
  290       CONTINUE
            DO 310 J = I, I1
               DO 300 K = MAX( J-KA, I-KBT ), I - 1
                  AB( J-K+1, K ) = AB( J-K+1, K ) -
     $                             BB( I-K+1, K )*AB( J-I+1, I )
  300          CONTINUE
  310       CONTINUE
*
            IF( WANTX ) THEN
*
*              post-multiply X by inv(S(i))
*
               CALL SSCAL( N-M, ONE / BII, X( M+1, I ), 1 )
               IF( KBT.GT.0 )
     $            CALL SGER( N-M, KBT, -ONE, X( M+1, I ), 1,
     $                       BB( KBT+1, I-KBT ), LDBB-1,
     $                       X( M+1, I-KBT ), LDX )
            END IF
*
*           store a(i1,i) in RA1 for use in next loop over K
*
            RA1 = AB( I1-I+1, I )
         END IF
*
*        Generate and apply vectors of rotations to chase all the
*        existing bulges KA positions down toward the bottom of the
*        band
*
         DO 360 K = 1, KB - 1
            IF( UPDATE ) THEN
*
*              Determine the rotations which would annihilate the bulge
*              which has in theory just been created
*
               IF( I-K+KA.LT.N .AND. I-K.GT.1 ) THEN
*
*                 generate rotation to annihilate a(i-k+ka+1,i)
*
                  CALL SLARTG( AB( KA1-K, I ), RA1, WORK( N+I-K+KA-M ),
     $                         WORK( I-K+KA-M ), RA )
*
*                 create nonzero element a(i-k+ka+1,i-k) outside the
*                 band and store it in WORK(i-k)
*
                  T = -BB( K+1, I-K )*RA1
                  WORK( I-K ) = WORK( N+I-K+KA-M )*T -
     $                          WORK( I-K+KA-M )*AB( KA1, I-K )
                  AB( KA1, I-K ) = WORK( I-K+KA-M )*T +
     $                             WORK( N+I-K+KA-M )*AB( KA1, I-K )
                  RA1 = RA
               END IF
            END IF
            J2 = I - K - 1 + MAX( 1, K-I0+2 )*KA1
            NR = ( N-J2+KA ) / KA1
            J1 = J2 + ( NR-1 )*KA1
            IF( UPDATE ) THEN
               J2T = MAX( J2, I+2*KA-K+1 )
            ELSE
               J2T = J2
            END IF
            NRT = ( N-J2T+KA ) / KA1
            DO 320 J = J2T, J1, KA1
*
*              create nonzero element a(j+1,j-ka) outside the band
*              and store it in WORK(j-m)
*
               WORK( J-M ) = WORK( J-M )*AB( KA1, J-KA+1 )
               AB( KA1, J-KA+1 ) = WORK( N+J-M )*AB( KA1, J-KA+1 )
  320       CONTINUE
*
*           generate rotations in 1st set to annihilate elements which
*           have been created outside the band
*
            IF( NRT.GT.0 )
     $         CALL SLARGV( NRT, AB( KA1, J2T-KA ), INCA, WORK( J2T-M ),
     $                      KA1, WORK( N+J2T-M ), KA1 )
            IF( NR.GT.0 ) THEN
*
*              apply rotations in 1st set from the left
*
               DO 330 L = 1, KA - 1
                  CALL SLARTV( NR, AB( L+1, J2-L ), INCA,
     $                         AB( L+2, J2-L ), INCA, WORK( N+J2-M ),
     $                         WORK( J2-M ), KA1 )
  330          CONTINUE
*
*              apply rotations in 1st set from both sides to diagonal
*              blocks
*
               CALL SLAR2V( NR, AB( 1, J2 ), AB( 1, J2+1 ), AB( 2, J2 ),
     $                      INCA, WORK( N+J2-M ), WORK( J2-M ), KA1 )
*
            END IF
*
*           start applying rotations in 1st set from the right
*
            DO 340 L = KA - 1, KB - K + 1, -1
               NRT = ( N-J2+L ) / KA1
               IF( NRT.GT.0 )
     $            CALL SLARTV( NRT, AB( KA1-L+1, J2 ), INCA,
     $                         AB( KA1-L, J2+1 ), INCA, WORK( N+J2-M ),
     $                         WORK( J2-M ), KA1 )
  340       CONTINUE
*
            IF( WANTX ) THEN
*
*              post-multiply X by product of rotations in 1st set
*
               DO 350 J = J2, J1, KA1
                  CALL SROT( N-M, X( M+1, J ), 1, X( M+1, J+1 ), 1,
     $                       WORK( N+J-M ), WORK( J-M ) )
  350          CONTINUE
            END IF
  360    CONTINUE
*
         IF( UPDATE ) THEN
            IF( I2.LE.N .AND. KBT.GT.0 ) THEN
*
*              create nonzero element a(i-kbt+ka+1,i-kbt) outside the
*              band and store it in WORK(i-kbt)
*
               WORK( I-KBT ) = -BB( KBT+1, I-KBT )*RA1
            END IF
         END IF
*
         DO 400 K = KB, 1, -1
            IF( UPDATE ) THEN
               J2 = I - K - 1 + MAX( 2, K-I0+1 )*KA1
            ELSE
               J2 = I - K - 1 + MAX( 1, K-I0+1 )*KA1
            END IF
*
*           finish applying rotations in 2nd set from the right
*
            DO 370 L = KB - K, 1, -1
               NRT = ( N-J2+KA+L ) / KA1
               IF( NRT.GT.0 )
     $            CALL SLARTV( NRT, AB( KA1-L+1, J2-KA ), INCA,
     $                         AB( KA1-L, J2-KA+1 ), INCA,
     $                         WORK( N+J2-KA ), WORK( J2-KA ), KA1 )
  370       CONTINUE
            NR = ( N-J2+KA ) / KA1
            J1 = J2 + ( NR-1 )*KA1
            DO 380 J = J1, J2, -KA1
               WORK( J ) = WORK( J-KA )
               WORK( N+J ) = WORK( N+J-KA )
  380       CONTINUE
            DO 390 J = J2, J1, KA1
*
*              create nonzero element a(j+1,j-ka) outside the band
*              and store it in WORK(j)
*
               WORK( J ) = WORK( J )*AB( KA1, J-KA+1 )
               AB( KA1, J-KA+1 ) = WORK( N+J )*AB( KA1, J-KA+1 )
  390       CONTINUE
            IF( UPDATE ) THEN
               IF( I-K.LT.N-KA .AND. K.LE.KBT )
     $            WORK( I-K+KA ) = WORK( I-K )
            END IF
  400    CONTINUE
*
         DO 440 K = KB, 1, -1
            J2 = I - K - 1 + MAX( 1, K-I0+1 )*KA1
            NR = ( N-J2+KA ) / KA1
            J1 = J2 + ( NR-1 )*KA1
            IF( NR.GT.0 ) THEN
*
*              generate rotations in 2nd set to annihilate elements
*              which have been created outside the band
*
               CALL SLARGV( NR, AB( KA1, J2-KA ), INCA, WORK( J2 ), KA1,
     $                      WORK( N+J2 ), KA1 )
*
*              apply rotations in 2nd set from the left
*
               DO 410 L = 1, KA - 1
                  CALL SLARTV( NR, AB( L+1, J2-L ), INCA,
     $                         AB( L+2, J2-L ), INCA, WORK( N+J2 ),
     $                         WORK( J2 ), KA1 )
  410          CONTINUE
*
*              apply rotations in 2nd set from both sides to diagonal
*              blocks
*
               CALL SLAR2V( NR, AB( 1, J2 ), AB( 1, J2+1 ), AB( 2, J2 ),
     $                      INCA, WORK( N+J2 ), WORK( J2 ), KA1 )
*
            END IF
*
*           start applying rotations in 2nd set from the right
*
            DO 420 L = KA - 1, KB - K + 1, -1
               NRT = ( N-J2+L ) / KA1
               IF( NRT.GT.0 )
     $            CALL SLARTV( NRT, AB( KA1-L+1, J2 ), INCA,
     $                         AB( KA1-L, J2+1 ), INCA, WORK( N+J2 ),
     $                         WORK( J2 ), KA1 )
  420       CONTINUE
*
            IF( WANTX ) THEN
*
*              post-multiply X by product of rotations in 2nd set
*
               DO 430 J = J2, J1, KA1
                  CALL SROT( N-M, X( M+1, J ), 1, X( M+1, J+1 ), 1,
     $                       WORK( N+J ), WORK( J ) )
  430          CONTINUE
            END IF
  440    CONTINUE
*
         DO 460 K = 1, KB - 1
            J2 = I - K - 1 + MAX( 1, K-I0+2 )*KA1
*
*           finish applying rotations in 1st set from the right
*
            DO 450 L = KB - K, 1, -1
               NRT = ( N-J2+L ) / KA1
               IF( NRT.GT.0 )
     $            CALL SLARTV( NRT, AB( KA1-L+1, J2 ), INCA,
     $                         AB( KA1-L, J2+1 ), INCA, WORK( N+J2-M ),
     $                         WORK( J2-M ), KA1 )
  450       CONTINUE
  460    CONTINUE
*
         IF( KB.GT.1 ) THEN
            DO 470 J = N - 1, I - KB + 2*KA + 1, -1
               WORK( N+J-M ) = WORK( N+J-KA-M )
               WORK( J-M ) = WORK( J-KA-M )
  470       CONTINUE
         END IF
*
      END IF
*
      GO TO 10
*
  480 CONTINUE
*
*     **************************** Phase 2 *****************************
*
*     The logical structure of this phase is:
*
*     UPDATE = .TRUE.
*     DO I = 1, M
*        use S(i) to update A and create a new bulge
*        apply rotations to push all bulges KA positions upward
*     END DO
*     UPDATE = .FALSE.
*     DO I = M - KA - 1, 2, -1
*        apply rotations to push all bulges KA positions upward
*     END DO
*
*     To avoid duplicating code, the two loops are merged.
*
      UPDATE = .TRUE.
      I = 0
  490 CONTINUE
      IF( UPDATE ) THEN
         I = I + 1
         KBT = MIN( KB, M-I )
         I0 = I + 1
         I1 = MAX( 1, I-KA )
         I2 = I + KBT - KA1
         IF( I.GT.M ) THEN
            UPDATE = .FALSE.
            I = I - 1
            I0 = M + 1
            IF( KA.EQ.0 )
     $         RETURN
            GO TO 490
         END IF
      ELSE
         I = I - KA
         IF( I.LT.2 )
     $      RETURN
      END IF
*
      IF( I.LT.M-KBT ) THEN
         NX = M
      ELSE
         NX = N
      END IF
*
      IF( UPPER ) THEN
*
*        Transform A, working with the upper triangle
*
         IF( UPDATE ) THEN
*
*           Form  inv(S(i))**T * A * inv(S(i))
*
            BII = BB( KB1, I )
            DO 500 J = I1, I
               AB( J-I+KA1, I ) = AB( J-I+KA1, I ) / BII
  500       CONTINUE
            DO 510 J = I, MIN( N, I+KA )
               AB( I-J+KA1, J ) = AB( I-J+KA1, J ) / BII
  510       CONTINUE
            DO 540 K = I + 1, I + KBT
               DO 520 J = K, I + KBT
                  AB( K-J+KA1, J ) = AB( K-J+KA1, J ) -
     $                               BB( I-J+KB1, J )*AB( I-K+KA1, K ) -
     $                               BB( I-K+KB1, K )*AB( I-J+KA1, J ) +
     $                               AB( KA1, I )*BB( I-J+KB1, J )*
     $                               BB( I-K+KB1, K )
  520          CONTINUE
               DO 530 J = I + KBT + 1, MIN( N, I+KA )
                  AB( K-J+KA1, J ) = AB( K-J+KA1, J ) -
     $                               BB( I-K+KB1, K )*AB( I-J+KA1, J )
  530          CONTINUE
  540       CONTINUE
            DO 560 J = I1, I
               DO 550 K = I + 1, MIN( J+KA, I+KBT )
                  AB( J-K+KA1, K ) = AB( J-K+KA1, K ) -
     $                               BB( I-K+KB1, K )*AB( J-I+KA1, I )
  550          CONTINUE
  560       CONTINUE
*
            IF( WANTX ) THEN
*
*              post-multiply X by inv(S(i))
*
               CALL SSCAL( NX, ONE / BII, X( 1, I ), 1 )
               IF( KBT.GT.0 )
     $            CALL SGER( NX, KBT, -ONE, X( 1, I ), 1, BB( KB, I+1 ),
     $                       LDBB-1, X( 1, I+1 ), LDX )
            END IF
*
*           store a(i1,i) in RA1 for use in next loop over K
*
            RA1 = AB( I1-I+KA1, I )
         END IF
*
*        Generate and apply vectors of rotations to chase all the
*        existing bulges KA positions up toward the top of the band
*
         DO 610 K = 1, KB - 1
            IF( UPDATE ) THEN
*
*              Determine the rotations which would annihilate the bulge
*              which has in theory just been created
*
               IF( I+K-KA1.GT.0 .AND. I+K.LT.M ) THEN
*
*                 generate rotation to annihilate a(i+k-ka-1,i)
*
                  CALL SLARTG( AB( K+1, I ), RA1, WORK( N+I+K-KA ),
     $                         WORK( I+K-KA ), RA )
*
*                 create nonzero element a(i+k-ka-1,i+k) outside the
*                 band and store it in WORK(m-kb+i+k)
*
                  T = -BB( KB1-K, I+K )*RA1
                  WORK( M-KB+I+K ) = WORK( N+I+K-KA )*T -
     $                               WORK( I+K-KA )*AB( 1, I+K )
                  AB( 1, I+K ) = WORK( I+K-KA )*T +
     $                           WORK( N+I+K-KA )*AB( 1, I+K )
                  RA1 = RA
               END IF
            END IF
            J2 = I + K + 1 - MAX( 1, K+I0-M+1 )*KA1
            NR = ( J2+KA-1 ) / KA1
            J1 = J2 - ( NR-1 )*KA1
            IF( UPDATE ) THEN
               J2T = MIN( J2, I-2*KA+K-1 )
            ELSE
               J2T = J2
            END IF
            NRT = ( J2T+KA-1 ) / KA1
            DO 570 J = J1, J2T, KA1
*
*              create nonzero element a(j-1,j+ka) outside the band
*              and store it in WORK(j)
*
               WORK( J ) = WORK( J )*AB( 1, J+KA-1 )
               AB( 1, J+KA-1 ) = WORK( N+J )*AB( 1, J+KA-1 )
  570       CONTINUE
*
*           generate rotations in 1st set to annihilate elements which
*           have been created outside the band
*
            IF( NRT.GT.0 )
     $         CALL SLARGV( NRT, AB( 1, J1+KA ), INCA, WORK( J1 ), KA1,
     $                      WORK( N+J1 ), KA1 )
            IF( NR.GT.0 ) THEN
*
*              apply rotations in 1st set from the left
*
               DO 580 L = 1, KA - 1
                  CALL SLARTV( NR, AB( KA1-L, J1+L ), INCA,
     $                         AB( KA-L, J1+L ), INCA, WORK( N+J1 ),
     $                         WORK( J1 ), KA1 )
  580          CONTINUE
*
*              apply rotations in 1st set from both sides to diagonal
*              blocks
*
               CALL SLAR2V( NR, AB( KA1, J1 ), AB( KA1, J1-1 ),
     $                      AB( KA, J1 ), INCA, WORK( N+J1 ),
     $                      WORK( J1 ), KA1 )
*
            END IF
*
*           start applying rotations in 1st set from the right
*
            DO 590 L = KA - 1, KB - K + 1, -1
               NRT = ( J2+L-1 ) / KA1
               J1T = J2 - ( NRT-1 )*KA1
               IF( NRT.GT.0 )
     $            CALL SLARTV( NRT, AB( L, J1T ), INCA,
     $                         AB( L+1, J1T-1 ), INCA, WORK( N+J1T ),
     $                         WORK( J1T ), KA1 )
  590       CONTINUE
*
            IF( WANTX ) THEN
*
*              post-multiply X by product of rotations in 1st set
*
               DO 600 J = J1, J2, KA1
                  CALL SROT( NX, X( 1, J ), 1, X( 1, J-1 ), 1,
     $                       WORK( N+J ), WORK( J ) )
  600          CONTINUE
            END IF
  610    CONTINUE
*
         IF( UPDATE ) THEN
            IF( I2.GT.0 .AND. KBT.GT.0 ) THEN
*
*              create nonzero element a(i+kbt-ka-1,i+kbt) outside the
*              band and store it in WORK(m-kb+i+kbt)
*
               WORK( M-KB+I+KBT ) = -BB( KB1-KBT, I+KBT )*RA1
            END IF
         END IF
*
         DO 650 K = KB, 1, -1
            IF( UPDATE ) THEN
               J2 = I + K + 1 - MAX( 2, K+I0-M )*KA1
            ELSE
               J2 = I + K + 1 - MAX( 1, K+I0-M )*KA1
            END IF
*
*           finish applying rotations in 2nd set from the right
*
            DO 620 L = KB - K, 1, -1
               NRT = ( J2+KA+L-1 ) / KA1
               J1T = J2 - ( NRT-1 )*KA1
               IF( NRT.GT.0 )
     $            CALL SLARTV( NRT, AB( L, J1T+KA ), INCA,
     $                         AB( L+1, J1T+KA-1 ), INCA,
     $                         WORK( N+M-KB+J1T+KA ),
     $                         WORK( M-KB+J1T+KA ), KA1 )
  620       CONTINUE
            NR = ( J2+KA-1 ) / KA1
            J1 = J2 - ( NR-1 )*KA1
            DO 630 J = J1, J2, KA1
               WORK( M-KB+J ) = WORK( M-KB+J+KA )
               WORK( N+M-KB+J ) = WORK( N+M-KB+J+KA )
  630       CONTINUE
            DO 640 J = J1, J2, KA1
*
*              create nonzero element a(j-1,j+ka) outside the band
*              and store it in WORK(m-kb+j)
*
               WORK( M-KB+J ) = WORK( M-KB+J )*AB( 1, J+KA-1 )
               AB( 1, J+KA-1 ) = WORK( N+M-KB+J )*AB( 1, J+KA-1 )
  640       CONTINUE
            IF( UPDATE ) THEN
               IF( I+K.GT.KA1 .AND. K.LE.KBT )
     $            WORK( M-KB+I+K-KA ) = WORK( M-KB+I+K )
            END IF
  650    CONTINUE
*
         DO 690 K = KB, 1, -1
            J2 = I + K + 1 - MAX( 1, K+I0-M )*KA1
            NR = ( J2+KA-1 ) / KA1
            J1 = J2 - ( NR-1 )*KA1
            IF( NR.GT.0 ) THEN
*
*              generate rotations in 2nd set to annihilate elements
*              which have been created outside the band
*
               CALL SLARGV( NR, AB( 1, J1+KA ), INCA, WORK( M-KB+J1 ),
     $                      KA1, WORK( N+M-KB+J1 ), KA1 )
*
*              apply rotations in 2nd set from the left
*
               DO 660 L = 1, KA - 1
                  CALL SLARTV( NR, AB( KA1-L, J1+L ), INCA,
     $                         AB( KA-L, J1+L ), INCA,
     $                         WORK( N+M-KB+J1 ), WORK( M-KB+J1 ), KA1 )
  660          CONTINUE
*
*              apply rotations in 2nd set from both sides to diagonal
*              blocks
*
               CALL SLAR2V( NR, AB( KA1, J1 ), AB( KA1, J1-1 ),
     $                      AB( KA, J1 ), INCA, WORK( N+M-KB+J1 ),
     $                      WORK( M-KB+J1 ), KA1 )
*
            END IF
*
*           start applying rotations in 2nd set from the right
*
            DO 670 L = KA - 1, KB - K + 1, -1
               NRT = ( J2+L-1 ) / KA1
               J1T = J2 - ( NRT-1 )*KA1
               IF( NRT.GT.0 )
     $            CALL SLARTV( NRT, AB( L, J1T ), INCA,
     $                         AB( L+1, J1T-1 ), INCA,
     $                         WORK( N+M-KB+J1T ), WORK( M-KB+J1T ),
     $                         KA1 )
  670       CONTINUE
*
            IF( WANTX ) THEN
*
*              post-multiply X by product of rotations in 2nd set
*
               DO 680 J = J1, J2, KA1
                  CALL SROT( NX, X( 1, J ), 1, X( 1, J-1 ), 1,
     $                       WORK( N+M-KB+J ), WORK( M-KB+J ) )
  680          CONTINUE
            END IF
  690    CONTINUE
*
         DO 710 K = 1, KB - 1
            J2 = I + K + 1 - MAX( 1, K+I0-M+1 )*KA1
*
*           finish applying rotations in 1st set from the right
*
            DO 700 L = KB - K, 1, -1
               NRT = ( J2+L-1 ) / KA1
               J1T = J2 - ( NRT-1 )*KA1
               IF( NRT.GT.0 )
     $            CALL SLARTV( NRT, AB( L, J1T ), INCA,
     $                         AB( L+1, J1T-1 ), INCA, WORK( N+J1T ),
     $                         WORK( J1T ), KA1 )
  700       CONTINUE
  710    CONTINUE
*
         IF( KB.GT.1 ) THEN
            DO 720 J = 2, MIN( I+KB, M ) - 2*KA - 1
               WORK( N+J ) = WORK( N+J+KA )
               WORK( J ) = WORK( J+KA )
  720       CONTINUE
         END IF
*
      ELSE
*
*        Transform A, working with the lower triangle
*
         IF( UPDATE ) THEN
*
*           Form  inv(S(i))**T * A * inv(S(i))
*
            BII = BB( 1, I )
            DO 730 J = I1, I
               AB( I-J+1, J ) = AB( I-J+1, J ) / BII
  730       CONTINUE
            DO 740 J = I, MIN( N, I+KA )
               AB( J-I+1, I ) = AB( J-I+1, I ) / BII
  740       CONTINUE
            DO 770 K = I + 1, I + KBT
               DO 750 J = K, I + KBT
                  AB( J-K+1, K ) = AB( J-K+1, K ) -
     $                             BB( J-I+1, I )*AB( K-I+1, I ) -
     $                             BB( K-I+1, I )*AB( J-I+1, I ) +
     $                             AB( 1, I )*BB( J-I+1, I )*
     $                             BB( K-I+1, I )
  750          CONTINUE
               DO 760 J = I + KBT + 1, MIN( N, I+KA )
                  AB( J-K+1, K ) = AB( J-K+1, K ) -
     $                             BB( K-I+1, I )*AB( J-I+1, I )
  760          CONTINUE
  770       CONTINUE
            DO 790 J = I1, I
               DO 780 K = I + 1, MIN( J+KA, I+KBT )
                  AB( K-J+1, J ) = AB( K-J+1, J ) -
     $                             BB( K-I+1, I )*AB( I-J+1, J )
  780          CONTINUE
  790       CONTINUE
*
            IF( WANTX ) THEN
*
*              post-multiply X by inv(S(i))
*
               CALL SSCAL( NX, ONE / BII, X( 1, I ), 1 )
               IF( KBT.GT.0 )
     $            CALL SGER( NX, KBT, -ONE, X( 1, I ), 1, BB( 2, I ), 1,
     $                       X( 1, I+1 ), LDX )
            END IF
*
*           store a(i,i1) in RA1 for use in next loop over K
*
            RA1 = AB( I-I1+1, I1 )
         END IF
*
*        Generate and apply vectors of rotations to chase all the
*        existing bulges KA positions up toward the top of the band
*
         DO 840 K = 1, KB - 1
            IF( UPDATE ) THEN
*
*              Determine the rotations which would annihilate the bulge
*              which has in theory just been created
*
               IF( I+K-KA1.GT.0 .AND. I+K.LT.M ) THEN
*
*                 generate rotation to annihilate a(i,i+k-ka-1)
*
                  CALL SLARTG( AB( KA1-K, I+K-KA ), RA1,
     $                         WORK( N+I+K-KA ), WORK( I+K-KA ), RA )
*
*                 create nonzero element a(i+k,i+k-ka-1) outside the
*                 band and store it in WORK(m-kb+i+k)
*
                  T = -BB( K+1, I )*RA1
                  WORK( M-KB+I+K ) = WORK( N+I+K-KA )*T -
     $                               WORK( I+K-KA )*AB( KA1, I+K-KA )
                  AB( KA1, I+K-KA ) = WORK( I+K-KA )*T +
     $                                WORK( N+I+K-KA )*AB( KA1, I+K-KA )
                  RA1 = RA
               END IF
            END IF
            J2 = I + K + 1 - MAX( 1, K+I0-M+1 )*KA1
            NR = ( J2+KA-1 ) / KA1
            J1 = J2 - ( NR-1 )*KA1
            IF( UPDATE ) THEN
               J2T = MIN( J2, I-2*KA+K-1 )
            ELSE
               J2T = J2
            END IF
            NRT = ( J2T+KA-1 ) / KA1
            DO 800 J = J1, J2T, KA1
*
*              create nonzero element a(j+ka,j-1) outside the band
*              and store it in WORK(j)
*
               WORK( J ) = WORK( J )*AB( KA1, J-1 )
               AB( KA1, J-1 ) = WORK( N+J )*AB( KA1, J-1 )
  800       CONTINUE
*
*           generate rotations in 1st set to annihilate elements which
*           have been created outside the band
*
            IF( NRT.GT.0 )
     $         CALL SLARGV( NRT, AB( KA1, J1 ), INCA, WORK( J1 ), KA1,
     $                      WORK( N+J1 ), KA1 )
            IF( NR.GT.0 ) THEN
*
*              apply rotations in 1st set from the right
*
               DO 810 L = 1, KA - 1
                  CALL SLARTV( NR, AB( L+1, J1 ), INCA, AB( L+2, J1-1 ),
     $                         INCA, WORK( N+J1 ), WORK( J1 ), KA1 )
  810          CONTINUE
*
*              apply rotations in 1st set from both sides to diagonal
*              blocks
*
               CALL SLAR2V( NR, AB( 1, J1 ), AB( 1, J1-1 ),
     $                      AB( 2, J1-1 ), INCA, WORK( N+J1 ),
     $                      WORK( J1 ), KA1 )
*
            END IF
*
*           start applying rotations in 1st set from the left
*
            DO 820 L = KA - 1, KB - K + 1, -1
               NRT = ( J2+L-1 ) / KA1
               J1T = J2 - ( NRT-1 )*KA1
               IF( NRT.GT.0 )
     $            CALL SLARTV( NRT, AB( KA1-L+1, J1T-KA1+L ), INCA,
     $                         AB( KA1-L, J1T-KA1+L ), INCA,
     $                         WORK( N+J1T ), WORK( J1T ), KA1 )
  820       CONTINUE
*
            IF( WANTX ) THEN
*
*              post-multiply X by product of rotations in 1st set
*
               DO 830 J = J1, J2, KA1
                  CALL SROT( NX, X( 1, J ), 1, X( 1, J-1 ), 1,
     $                       WORK( N+J ), WORK( J ) )
  830          CONTINUE
            END IF
  840    CONTINUE
*
         IF( UPDATE ) THEN
            IF( I2.GT.0 .AND. KBT.GT.0 ) THEN
*
*              create nonzero element a(i+kbt,i+kbt-ka-1) outside the
*              band and store it in WORK(m-kb+i+kbt)
*
               WORK( M-KB+I+KBT ) = -BB( KBT+1, I )*RA1
            END IF
         END IF
*
         DO 880 K = KB, 1, -1
            IF( UPDATE ) THEN
               J2 = I + K + 1 - MAX( 2, K+I0-M )*KA1
            ELSE
               J2 = I + K + 1 - MAX( 1, K+I0-M )*KA1
            END IF
*
*           finish applying rotations in 2nd set from the left
*
            DO 850 L = KB - K, 1, -1
               NRT = ( J2+KA+L-1 ) / KA1
               J1T = J2 - ( NRT-1 )*KA1
               IF( NRT.GT.0 )
     $            CALL SLARTV( NRT, AB( KA1-L+1, J1T+L-1 ), INCA,
     $                         AB( KA1-L, J1T+L-1 ), INCA,
     $                         WORK( N+M-KB+J1T+KA ),
     $                         WORK( M-KB+J1T+KA ), KA1 )
  850       CONTINUE
            NR = ( J2+KA-1 ) / KA1
            J1 = J2 - ( NR-1 )*KA1
            DO 860 J = J1, J2, KA1
               WORK( M-KB+J ) = WORK( M-KB+J+KA )
               WORK( N+M-KB+J ) = WORK( N+M-KB+J+KA )
  860       CONTINUE
            DO 870 J = J1, J2, KA1
*
*              create nonzero element a(j+ka,j-1) outside the band
*              and store it in WORK(m-kb+j)
*
               WORK( M-KB+J ) = WORK( M-KB+J )*AB( KA1, J-1 )
               AB( KA1, J-1 ) = WORK( N+M-KB+J )*AB( KA1, J-1 )
  870       CONTINUE
            IF( UPDATE ) THEN
               IF( I+K.GT.KA1 .AND. K.LE.KBT )
     $            WORK( M-KB+I+K-KA ) = WORK( M-KB+I+K )
            END IF
  880    CONTINUE
*
         DO 920 K = KB, 1, -1
            J2 = I + K + 1 - MAX( 1, K+I0-M )*KA1
            NR = ( J2+KA-1 ) / KA1
            J1 = J2 - ( NR-1 )*KA1
            IF( NR.GT.0 ) THEN
*
*              generate rotations in 2nd set to annihilate elements
*              which have been created outside the band
*
               CALL SLARGV( NR, AB( KA1, J1 ), INCA, WORK( M-KB+J1 ),
     $                      KA1, WORK( N+M-KB+J1 ), KA1 )
*
*              apply rotations in 2nd set from the right
*
               DO 890 L = 1, KA - 1
                  CALL SLARTV( NR, AB( L+1, J1 ), INCA, AB( L+2, J1-1 ),
     $                         INCA, WORK( N+M-KB+J1 ), WORK( M-KB+J1 ),
     $                         KA1 )
  890          CONTINUE
*
*              apply rotations in 2nd set from both sides to diagonal
*              blocks
*
               CALL SLAR2V( NR, AB( 1, J1 ), AB( 1, J1-1 ),
     $                      AB( 2, J1-1 ), INCA, WORK( N+M-KB+J1 ),
     $                      WORK( M-KB+J1 ), KA1 )
*
            END IF
*
*           start applying rotations in 2nd set from the left
*
            DO 900 L = KA - 1, KB - K + 1, -1
               NRT = ( J2+L-1 ) / KA1
               J1T = J2 - ( NRT-1 )*KA1
               IF( NRT.GT.0 )
     $            CALL SLARTV( NRT, AB( KA1-L+1, J1T-KA1+L ), INCA,
     $                         AB( KA1-L, J1T-KA1+L ), INCA,
     $                         WORK( N+M-KB+J1T ), WORK( M-KB+J1T ),
     $                         KA1 )
  900       CONTINUE
*
            IF( WANTX ) THEN
*
*              post-multiply X by product of rotations in 2nd set
*
               DO 910 J = J1, J2, KA1
                  CALL SROT( NX, X( 1, J ), 1, X( 1, J-1 ), 1,
     $                       WORK( N+M-KB+J ), WORK( M-KB+J ) )
  910          CONTINUE
            END IF
  920    CONTINUE
*
         DO 940 K = 1, KB - 1
            J2 = I + K + 1 - MAX( 1, K+I0-M+1 )*KA1
*
*           finish applying rotations in 1st set from the left
*
            DO 930 L = KB - K, 1, -1
               NRT = ( J2+L-1 ) / KA1
               J1T = J2 - ( NRT-1 )*KA1
               IF( NRT.GT.0 )
     $            CALL SLARTV( NRT, AB( KA1-L+1, J1T-KA1+L ), INCA,
     $                         AB( KA1-L, J1T-KA1+L ), INCA,
     $                         WORK( N+J1T ), WORK( J1T ), KA1 )
  930       CONTINUE
  940    CONTINUE
*
         IF( KB.GT.1 ) THEN
            DO 950 J = 2, MIN( I+KB, M ) - 2*KA - 1
               WORK( N+J ) = WORK( N+J+KA )
               WORK( J ) = WORK( J+KA )
  950       CONTINUE
         END IF
*
      END IF
*
      GO TO 490
*
*     End of SSBGST
*
      END

      SUBROUTINE CLACRM( M, N, A, LDA, B, LDB, C, LDC, RWORK )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      INTEGER            LDA, LDB, LDC, M, N
*     ..
*     .. Array Arguments ..
      REAL               B( LDB, * ), RWORK( * )
      COMPLEX            A( LDA, * ), C( LDC, * )
*     ..
*
*  Purpose
*  =======
*
*  CLACRM performs a very simple matrix-matrix multiplication:
*           C := A * B,
*  where A is M by N and complex; B is N by N and real;
*  C is M by N and complex.
*
*  Arguments
*  =========
*
*  M       (input) INTEGER
*          The number of rows of the matrix A and of the matrix C.
*          M >= 0.
*
*  N       (input) INTEGER
*          The number of columns and rows of the matrix B and
*          the number of columns of the matrix C.
*          N >= 0.
*
*  A       (input) COMPLEX array, dimension (LDA, N)
*          A contains the M by N matrix A.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A. LDA >=max(1,M).
*
*  B       (input) REAL array, dimension (LDB, N)
*          B contains the N by N matrix B.
*
*  LDB     (input) INTEGER
*          The leading dimension of the array B. LDB >=max(1,N).
*
*  C       (input) COMPLEX array, dimension (LDC, N)
*          C contains the M by N matrix C.
*
*  LDC     (input) INTEGER
*          The leading dimension of the array C. LDC >=max(1,N).
*
*  RWORK   (workspace) REAL array, dimension (2*M*N)
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ONE, ZERO
      PARAMETER          ( ONE = 1.0E0, ZERO = 0.0E0 )
*     ..
*     .. Local Scalars ..
      INTEGER            I, J, L
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          AIMAG, CMPLX, REAL
*     ..
*     .. External Subroutines ..
      EXTERNAL           SGEMM
*     ..
*     .. Executable Statements ..
*
*     Quick return if possible.
*
      IF( ( M.EQ.0 ) .OR. ( N.EQ.0 ) )
     $   RETURN
*
      DO 20 J = 1, N
         DO 10 I = 1, M
            RWORK( ( J-1 )*M+I ) = REAL( A( I, J ) )
   10    CONTINUE
   20 CONTINUE
*
      L = M*N + 1
      CALL SGEMM( 'N', 'N', M, N, N, ONE, RWORK, M, B, LDB, ZERO,
     $            RWORK( L ), M )
      DO 40 J = 1, N
         DO 30 I = 1, M
            C( I, J ) = RWORK( L+( J-1 )*M+I-1 )
   30    CONTINUE
   40 CONTINUE
*
      DO 60 J = 1, N
         DO 50 I = 1, M
            RWORK( ( J-1 )*M+I ) = AIMAG( A( I, J ) )
   50    CONTINUE
   60 CONTINUE
      CALL SGEMM( 'N', 'N', M, N, N, ONE, RWORK, M, B, LDB, ZERO,
     $            RWORK( L ), M )
      DO 80 J = 1, N
         DO 70 I = 1, M
            C( I, J ) = CMPLX( REAL( C( I, J ) ),
     $                  RWORK( L+( J-1 )*M+I-1 ) )
   70    CONTINUE
   80 CONTINUE
*
      RETURN
*
*     End of CLACRM
*
      END

C
C	$Id: gescfn.f,v 1.4 2008-07-27 00:20:57 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GESCFN (IOS, STATUS)
C
C  ESCAPE elements from segments.
C       
      include 'trinst.h'
      include 'trpars.h'
C
      INTEGER IOS, STATUS
      INTEGER BUFS
      PARAMETER (BUFS=100)
      INTEGER BUFF(BUFS), COUNT, CURR
C
      STATUS = 0
C
C  Get the argument count.
C
    5 CONTINUE
      CALL GOPDEC(COUNT,MWHCPR,1,IOS,STATUS)
      IF (STATUS .NE. 0) RETURN
C
C  Loop until the instruction is processed.
C
   10 CONTINUE
      IF (COUNT .GT. BUFS) THEN
        COUNT = COUNT - BUFS
        CURR = BUFS
      ELSE
        CURR = COUNT
        COUNT = 0
      END IF
C
      CALL GOPDEC(BUFF, BYTSIZ, CURR, IOS, STATUS)
      IF (STATUS .NE. 0) RETURN
C
      IF (COUNT.NE.0) GO TO 10
C
C  Get the next part of the instruction if a continue.
C
      IF (CNTINU) THEN
        CALL GNPART(IOS,STATUS)
        IF (STATUS .NE. 0) RETURN
        GO TO 5
      END IF
C
      RETURN
      END

c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by UCAR                 .
c  .                                                             .
c  .       University Corporation for Atmospheric Research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                         SPHEREPACK                          .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c
c
c ... file shagc.f
c
c     this file contains code and documentation for subroutines
c     shagc and shagci
c
c ... files which must be loaded with shagc.f
c
c     sphcom.f, hrfft.f, gaqd.f
c
c
c     subroutine shagc(nlat,nlon,isym,nt,g,idg,jdg,a,b,mdab,ndab,
c    +                 wshagc,lshagc,work,lwork,ierror)
c
c     subroutine shagc performs the spherical harmonic analysis
c     on the array g and stores the result in the arrays a and b.
c     the analysis is performed on a gaussian grid in colatitude
c     and an equally spaced grid in longitude.  the associated
c     legendre functions are recomputed rather than stored as they
c     are in subroutine shags.  the analysis is described below
c     at output parameters a,b.
c
c     input parameters
c
c     nlat   the number of points in the gaussian colatitude grid on the
c            full sphere. these lie in the interval (0,pi) and are compu
c            in radians in theta(1),...,theta(nlat) by subroutine gaqd.
c            if nlat is odd the equator will be included as the grid poi
c            theta((nlat+1)/2).  if nlat is even the equator will be
c            excluded as a grid point and will lie half way between
c            theta(nlat/2) and theta(nlat/2+1). nlat must be at least 3.
c            note: on the half sphere, the number of grid points in the
c            colatitudinal direction is nlat/2 if nlat is even or
c            (nlat+1)/2 if nlat is odd.
c
c     nlon   the number of distinct londitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater
c            than or equal to 4. the efficiency of the computation is
c            improved when nlon is a product of small prime numbers.
c
c     isym   = 0  no symmetries exist about the equator. the analysis
c                 is performed on the entire sphere.  i.e. on the
c                 array g(i,j) for i=1,...,nlat and j=1,...,nlon.
c                 (see description of g below)
c
c            = 1  g is antisymmetric about the equator. the analysis
c                 is performed on the northern hemisphere only.  i.e.
c                 if nlat is odd the analysis is performed on the
c                 array g(i,j) for i=1,...,(nlat+1)/2 and j=1,...,nlon.
c                 if nlat is even the analysis is performed on the
c                 array g(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
c
c
c            = 2  g is symmetric about the equator. the analysis is
c                 performed on the northern hemisphere only.  i.e.
c                 if nlat is odd the analysis is performed on the
c                 array g(i,j) for i=1,...,(nlat+1)/2 and j=1,...,nlon.
c                 if nlat is even the analysis is performed on the
c                 array g(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
c
c     nt     the number of analyses.  in the program that calls shagc,
c            the arrays g,a and b can be three dimensional in which
c            case multiple analyses will be performed.  the third
c            index is the analysis index which assumes the values
c            k=1,...,nt.  for a single analysis set nt=1. the
c            discription of the remaining parameters is simplified
c            by assuming that nt=1 or that the arrays g,a and b
c            have only two dimensions.
c
c     g      a two or three dimensional array (see input parameter
c            nt) that contains the discrete function to be analyzed.
c            g(i,j) contains the value of the function at the gaussian
c            point theta(i) and longitude point phi(j) = (j-1)*2*pi/nlon
c            the index ranges are defined above at the input parameter
c            isym.
c
c     idg    the first dimension of the array g as it appears in the
c            program that calls shagc. if isym equals zero then idg
c            must be at least nlat.  if isym is nonzero then idg must
c            be at least nlat/2 if nlat is even or at least (nlat+1)/2
c            if nlat is odd.
c
c     jdg    the second dimension of the array g as it appears in the
c            program that calls shagc. jdg must be at least nlon.
c
c     mdab   the first dimension of the arrays a and b as it appears
c            in the program that calls shagc. mdab must be at least
c            min0((nlon+2)/2,nlat) if nlon is even or at least
c            min0((nlon+1)/2,nlat) if nlon is odd
c
c     ndab   the second dimension of the arrays a and b as it appears
c            in the program that calls shaec. ndab must be at least nlat
c
c     wshagc an array which must be initialized by subroutine shagci.
c            once initialized, wshagc can be used repeatedly by shagc.
c            as long as nlat and nlon remain unchanged.  wshagc must
c            not be altered between calls of shagc.
c
c     lshagc the dimension of the array wshagc as it appears in the
c            program that calls shagc. define
c
c               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            then lshagc must be at least
c
c                  nlat*(2*l2+3*l1-2)+3*l1*(1-l1)/2+nlon+15
c
c
c     work   a work array that does not have to be saved.
c
c     lwork  the dimension of the array work as it appears in the
c            program that calls shagc. define
c
c               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            if isym is zero then lwork must be at least
c
c                      nlat*(nlon*nt+max0(3*l2,nlon))
c
c            if isym is not zero then lwork must be at least
c
c                      l2*(nlon*nt+max0(3*nlat,nlon))
c
c     **************************************************************
c
c     output parameters
c
c     a,b    both a,b are two or three dimensional arrays (see input
c            parameter nt) that contain the spherical harmonic
c            coefficients in the representation of g(i,j) given in the
c            discription of subroutine shagc. for isym=0, a(m,n) and
c            b(m,n) are given by the equations listed below. symmetric
c            versions are used when isym is greater than zero.
c
c     definitions
c
c     1. the normalized associated legendre functions
c
c     pbar(m,n,theta) = sqrt((2*n+1)*factorial(n-m)/(2*factorial(n+m)))
c                       *sin(theta)**m/(2**n*factorial(n)) times the
c                       (n+m)th derivative of (x**2-1)**n with respect
c                       to x=cos(theta).
c
c     2. the fourier transform of g(i,j).
c
c     c(m,i)          = 2/nlon times the sum from j=1 to j=nlon of
c                       g(i,j)*cos((m-1)*(j-1)*2*pi/nlon)
c                       (the first and last terms in this sum
c                       are divided by 2)
c
c     s(m,i)          = 2/nlon times the sum from j=2 to j=nlon of
c                       g(i,j)*sin((m-1)*(j-1)*2*pi/nlon)
c
c
c     3. the gaussian points and weights on the sphere
c        (computed by subroutine gaqd).
c
c        theta(1),...,theta(nlat) (gaussian pts in radians)
c        wts(1),...,wts(nlat) (corresponding gaussian weights)
c
c     4. the maximum (plus one) longitudinal wave number
c
c            mmax = min0(nlat,(nlon+2)/2) if nlon is even or
c            mmax = min0(nlat,(nlon+1)/2) if nlon is odd.
c
c
c     then for m=0,...,mmax-1 and n=m,...,nlat-1 the arrays a,b
c     are given by
c
c     a(m+1,n+1)     =  the sum from i=1 to i=nlat of
c                       c(m+1,i)*wts(i)*pbar(m,n,theta(i))
c
c     b(m+1,n+1)      = the sum from i=1 to nlat of
c                       s(m+1,i)*wts(i)*pbar(m,n,theta(i))
c
c     ierror = 0  no errors
c            = 1  error in the specification of nlat
c            = 2  error in the specification of nlon
c            = 3  error in the specification of isym
c            = 4  error in the specification of nt
c            = 5  error in the specification of idg
c            = 6  error in the specification of jdg
c            = 7  error in the specification of mdab
c            = 8  error in the specification of ndab
c            = 9  error in the specification of lshagc
c            = 10 error in the specification of lwork
c
c
c ****************************************************************
c
c     subroutine shagci(nlat,nlon,wshagc,lshagc,dwork,ldwork,ierror)
c
c     subroutine shagci initializes the array wshagc which can then
c     be used repeatedly by subroutines shagc. it precomputes
c     and stores in wshagc quantities such as gaussian weights,
c     legendre polynomial coefficients, and fft trigonometric tables.
c
c     input parameters
c
c     nlat   the number of points in the gaussian colatitude grid on the
c            full sphere. these lie in the interval (0,pi) and are compu
c            in radians in theta(1),...,theta(nlat) by subroutine gaqd.
c            if nlat is odd the equator will be included as the grid poi
c            theta((nlat+1)/2).  if nlat is even the equator will be
c            excluded as a grid point and will lie half way between
c            theta(nlat/2) and theta(nlat/2+1). nlat must be at least 3.
c            note: on the half sphere, the number of grid points in the
c            colatitudinal direction is nlat/2 if nlat is even or
c            (nlat+1)/2 if nlat is odd.
c
c     nlon   the number of distinct londitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater
c            than or equal to 4. the efficiency of the computation is
c            improved when nlon is a product of small prime numbers.
c
c     wshagc an array which must be initialized by subroutine shagci.
c            once initialized, wshagc can be used repeatedly by shagc
c            as long as nlat and nlon remain unchanged.  wshagc must
c            not be altered between calls of shagc.
c
c     lshagc the dimension of the array wshagc as it appears in the
c            program that calls shagc. define
c
c               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            then lshagc must be at least
c
c                  nlat*(2*l2+3*l1-2)+3*l1*(1-l1)/2+nlon+15
c
C*PL*ERROR* Comment line too long
c     dwork   a double precision work array that does not have to be saved.
c
c     ldwork  the dimension of the array dwork as it appears in the
c            program that calls shagci. ldwork must be at least
c
c                nlat*(nlat+4)
c
c     output parameter
c
c     wshagc an array which must be initialized before calling shagc or
c            once initialized, wshagc can be used repeatedly by shagc or
c            as long as nlat and nlon remain unchanged.  wshagc must not
c            altered between calls of shagc.
c
c     ierror = 0  no errors
c            = 1  error in the specification of nlat
c            = 2  error in the specification of nlon
c            = 3  error in the specification of lshagc
c            = 4  error in the specification of ldwork
c            = 5  failure in gaqd to compute gaussian points
c                 (due to failure in eigenvalue routine)
c
c
c ****************************************************************
      SUBROUTINE DSHAGC(NLAT,NLON,ISYM,NT,G,IDG,JDG,A,B,MDAB,NDAB,
     +                  WSHAGC,LSHAGC,WORK,LWORK,IERROR)
      DOUBLE PRECISION G
      DOUBLE PRECISION A
      DOUBLE PRECISION B
      DOUBLE PRECISION WSHAGC
      DOUBLE PRECISION WORK
c     subroutine shagc performs the spherical harmonic analysis on
c     a gaussian grid on the array(s) in g and returns the coefficients
c     in array(s) a,b. the necessary legendre polynomials are computed
c     as needed in this version.
c
      DIMENSION G(IDG,JDG,1),A(MDAB,NDAB,1),B(MDAB,NDAB,1),
     +          WSHAGC(LSHAGC),WORK(LWORK)
c     check input parameters
      IERROR = 1
      IF (NLAT.LT.3) RETURN
      IERROR = 2
      IF (NLON.LT.4) RETURN
      IERROR = 3
      IF (ISYM.LT.0 .OR. ISYM.GT.2) RETURN
      IERROR = 4
      IF (NT.LT.1) RETURN
c     set upper limit on m for spherical harmonic basis
      L = MIN0((NLON+2)/2,NLAT)
c     set gaussian point nearest equator pointer
      LATE = (NLAT+MOD(NLAT,2))/2
c     set number of grid points for analysis/synthesis
      LAT = NLAT
      IF (ISYM.NE.0) LAT = LATE
      IERROR = 5
      IF (IDG.LT.LAT) RETURN
      IERROR = 6
      IF (JDG.LT.NLON) RETURN
      IERROR = 7
      IF (MDAB.LT.L) RETURN
      IERROR = 8
      IF (NDAB.LT.NLAT) RETURN
      L1 = L
      L2 = LATE
      IERROR = 9
c     check permanent work space length
      IF (LSHAGC.LT.NLAT* (2*L2+3*L1-2)+3*L1* (1-L1)/2+NLON+15) RETURN
      IERROR = 10
c     check temporary work space length
      IF (ISYM.EQ.0) THEN
          IF (LWORK.LT.NLAT* (NLON*NT+MAX0(3*L2,NLON))) RETURN
      ELSE
c     isym.ne.0
          IF (LWORK.LT.L2* (NLON*NT+MAX0(3*NLAT,NLON))) RETURN
      END IF
      IERROR = 0
c     starting address for gaussian wts in shigc and fft values
      IWTS = 1
      IFFT = NLAT + 2*NLAT*LATE + 3* (L* (L-1)/2+ (NLAT-L)* (L-1)) + 1
c     set pointers for internal storage of g and legendre polys
      IPMN = LAT*NLON*NT + 1
      CALL DSHAGC1(NLAT,NLON,L,LAT,ISYM,G,IDG,JDG,NT,A,B,MDAB,NDAB,
     +             WSHAGC,WSHAGC(IWTS),WSHAGC(IFFT),LATE,WORK(IPMN),
     +             WORK)
      RETURN
      END
      SUBROUTINE DSHAGC1(NLAT,NLON,L,LAT,MODE,GS,IDG,JDG,NT,A,B,MDAB,
     +                  NDAB,W,WTS,WFFT,LATE,PMN,G)
      DOUBLE PRECISION GS
      DOUBLE PRECISION A
      DOUBLE PRECISION B
      DOUBLE PRECISION W
      DOUBLE PRECISION WTS
      DOUBLE PRECISION WFFT
      DOUBLE PRECISION PMN
      DOUBLE PRECISION G
      DOUBLE PRECISION SFN
      DOUBLE PRECISION T1
      DOUBLE PRECISION T2
      DIMENSION GS(IDG,JDG,NT),A(MDAB,NDAB,NT),B(MDAB,NDAB,NT),
     +          G(LAT,NLON,NT)
      DIMENSION W(1),WTS(NLAT),WFFT(1),PMN(NLAT,LATE,3)
c     set gs array internally in shagc1
      DO 100 K = 1,NT
          DO 100 J = 1,NLON
              DO 100 I = 1,LAT
                  G(I,J,K) = GS(I,J,K)
  100 CONTINUE
c     do fourier transform
      DO 101 K = 1,NT
          CALL DHRFFTF(LAT,NLON,G(1,1,K),LAT,WFFT,PMN)
  101 CONTINUE
c     scale result
      SFN = 2.0D0/DBLE(NLON)
      DO 102 K = 1,NT
          DO 102 J = 1,NLON
              DO 102 I = 1,LAT
                  G(I,J,K) = SFN*G(I,J,K)
  102 CONTINUE
c     compute using gaussian quadrature
c     a(n,m) = s (ga(theta,m)*pnm(theta)*sin(theta)*dtheta)
c     b(n,m) = s (gb(theta,m)*pnm(theta)*sin(theta)*dtheta)
c     here ga,gb are the cos(phi),sin(phi) coefficients of
c     the fourier expansion of g(theta,phi) in phi.  as a result
c     of the above fourier transform they are stored in array
c     g as follows:
c     for each theta(i) and k= l-1
c     ga(0),ga(1),gb(1),ga(2),gb(2),...,ga(k-1),gb(k-1),ga(k)
c     correspond to (in the case nlon=l+l-2)
c     g(i,1),g(i,2),g(i,3),g(i,4),g(i,5),...,g(i,2l-4),g(i,2l-3),g(i,2l-
c     initialize coefficients to zero
      DO 103 K = 1,NT
          DO 103 NP1 = 1,NLAT
              DO 103 MP1 = 1,L
                  A(MP1,NP1,K) = 0.0D0
                  B(MP1,NP1,K) = 0.0D0
  103 CONTINUE
c     set m+1 limit on b(m+1) calculation
      LM1 = L
      IF (NLON.EQ.L+L-2) LM1 = L - 1
      IF (MODE.EQ.0) THEN
c     for full sphere (mode=0) and even/odd reduction:
c     overwrite g(i) with (g(i)+g(nlat-i+1))*wts(i)
c     overwrite g(nlat-i+1) with (g(i)-g(nlat-i+1))*wts(i)
          NL2 = NLAT/2
          DO 104 K = 1,NT
              DO 104 J = 1,NLON
                  DO 105 I = 1,NL2
                      IS = NLAT - I + 1
                      T1 = G(I,J,K)
                      T2 = G(IS,J,K)
                      G(I,J,K) = WTS(I)* (T1+T2)
                      G(IS,J,K) = WTS(I)* (T1-T2)
  105             CONTINUE
c     adjust equator if necessary(nlat odd)
                  IF (MOD(NLAT,2).NE.0) G(LATE,J,K) = WTS(LATE)*
     +                G(LATE,J,K)
  104     CONTINUE
c     set m = 0 coefficients first
          M = 0
          CALL DLEGIN(MODE,L,NLAT,M,W,PMN,KM)
          DO 106 K = 1,NT
              DO 106 I = 1,LATE
                  IS = NLAT - I + 1
                  DO 107 NP1 = 1,NLAT,2
c     n even
                      A(1,NP1,K) = A(1,NP1,K) + G(I,1,K)*PMN(NP1,I,KM)
  107             CONTINUE
                  DO 108 NP1 = 2,NLAT,2
c     n odd
                      A(1,NP1,K) = A(1,NP1,K) + G(IS,1,K)*PMN(NP1,I,KM)
  108             CONTINUE
  106     CONTINUE
c     compute coefficients for which b(m,n) is available
          DO 109 MP1 = 2,LM1
              M = MP1 - 1
              MP2 = M + 2
c     compute pmn for all i and n=m,...,l-1
              CALL DLEGIN(MODE,L,NLAT,M,W,PMN,KM)
              DO 110 K = 1,NT
                  DO 111 I = 1,LATE
                      IS = NLAT - I + 1
c     n-m even
                      DO 112 NP1 = MP1,NLAT,2
                          A(MP1,NP1,K) = A(MP1,NP1,K) +
     +                                   G(I,2*M,K)*PMN(NP1,I,KM)
                          B(MP1,NP1,K) = B(MP1,NP1,K) +
     +                                   G(I,2*M+1,K)*PMN(NP1,I,KM)
  112                 CONTINUE
c     n-m odd
                      DO 113 NP1 = MP2,NLAT,2
                          A(MP1,NP1,K) = A(MP1,NP1,K) +
     +                                   G(IS,2*M,K)*PMN(NP1,I,KM)
                          B(MP1,NP1,K) = B(MP1,NP1,K) +
     +                                   G(IS,2*M+1,K)*PMN(NP1,I,KM)
  113                 CONTINUE
  111             CONTINUE
  110         CONTINUE
  109     CONTINUE
          IF (NLON.EQ.L+L-2) THEN
c     compute a(l,np1) coefficients only
              M = L - 1
              CALL DLEGIN(MODE,L,NLAT,M,W,PMN,KM)
              DO 114 K = 1,NT
                  DO 114 I = 1,LATE
                      IS = NLAT - I + 1
c     n-m even
                      DO 124 NP1 = L,NLAT,2
                          A(L,NP1,K) = A(L,NP1,K) +
     +                                 0.5D0*G(I,NLON,K)*PMN(NP1,I,KM)
  124                 CONTINUE
                      LP1 = L + 1
c     n-m odd
                      DO 125 NP1 = LP1,NLAT,2
                          A(L,NP1,K) = A(L,NP1,K) +
     +                                 0.5D0*G(IS,NLON,K)*PMN(NP1,I,KM)
  125                 CONTINUE
  114         CONTINUE
          END IF
      ELSE
c     half sphere
c     overwrite g(i) with wts(i)*(g(i)+g(i)) for i=1,...,nlate/2
          NL2 = NLAT/2
          DO 116 K = 1,NT
              DO 116 J = 1,NLON
                  DO 115 I = 1,NL2
                      G(I,J,K) = WTS(I)* (G(I,J,K)+G(I,J,K))
  115             CONTINUE
c     adjust equator separately if a grid point
                  IF (NL2.LT.LATE) G(LATE,J,K) = WTS(LATE)*G(LATE,J,K)
  116     CONTINUE
c     set m = 0 coefficients first
          M = 0
          CALL DLEGIN(MODE,L,NLAT,M,W,PMN,KM)
          MS = 1
          IF (MODE.EQ.1) MS = 2
          DO 117 K = 1,NT
              DO 117 I = 1,LATE
                  DO 117 NP1 = MS,NLAT,2
                      A(1,NP1,K) = A(1,NP1,K) + G(I,1,K)*PMN(NP1,I,KM)
  117     CONTINUE
c     compute coefficients for which b(m,n) is available
          DO 118 MP1 = 2,LM1
              M = MP1 - 1
              MS = MP1
              IF (MODE.EQ.1) MS = MP1 + 1
c     compute pmn for all i and n=m,...,nlat-1
              CALL DLEGIN(MODE,L,NLAT,M,W,PMN,KM)
              DO 119 K = 1,NT
                  DO 119 I = 1,LATE
                      DO 119 NP1 = MS,NLAT,2
                          A(MP1,NP1,K) = A(MP1,NP1,K) +
     +                                   G(I,2*M,K)*PMN(NP1,I,KM)
                          B(MP1,NP1,K) = B(MP1,NP1,K) +
     +                                   G(I,2*M+1,K)*PMN(NP1,I,KM)
  119         CONTINUE
  118     CONTINUE
          IF (NLON.EQ.L+L-2) THEN
c     compute coefficient a(l,np1) only
              M = L - 1
              CALL DLEGIN(MODE,L,NLAT,M,W,PMN,KM)
              NS = L
              IF (MODE.EQ.1) NS = L + 1
              DO 120 K = 1,NT
                  DO 120 I = 1,LATE
                      DO 120 NP1 = NS,NLAT,2
                          A(L,NP1,K) = A(L,NP1,K) +
     +                                 0.5D0*G(I,NLON,K)*PMN(NP1,I,KM)
  120         CONTINUE
          END IF
      END IF
      RETURN
      END
      SUBROUTINE DSHAGCI(NLAT,NLON,WSHAGC,LSHAGC,DWORK,LDWORK,IERROR)
      DOUBLE PRECISION WSHAGC
c     this subroutine must be called before calling shagc with
c     fixed nlat,nlon. it precomputes quantites such as the gaussian
c     points and weights, m=0,m=1 legendre polynomials, recursion
c     recursion coefficients.
      DIMENSION WSHAGC(LSHAGC)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION DWORK(LDWORK)

      IERROR = 1
      IF (NLAT.LT.3) RETURN
      IERROR = 2
      IF (NLON.LT.4) RETURN
c     set triangular truncation limit for spherical harmonic basis
      L = MIN0((NLON+2)/2,NLAT)
c     set equator or nearest point (if excluded) pointer
      LATE = (NLAT+MOD(NLAT,2))/2
      L1 = L
      L2 = LATE
      IERROR = 3
c     check permanent work space length
      IF (LSHAGC.LT.NLAT* (2*L2+3*L1-2)+3*L1* (1-L1)/2+NLON+15) RETURN
      IERROR = 4
      IF (LDWORK.LT.NLAT* (NLAT+4)) RETURN
      IERROR = 0
c     set pointers
      I1 = 1
      I2 = I1 + NLAT
      I3 = I2 + NLAT*LATE
      I4 = I3 + NLAT*LATE
      I5 = I4 + L* (L-1)/2 + (NLAT-L)* (L-1)
      I6 = I5 + L* (L-1)/2 + (NLAT-L)* (L-1)
      I7 = I6 + L* (L-1)/2 + (NLAT-L)* (L-1)
c     set indices in temp work for double precision gaussian wts and pts
      IDTH = 1
      IDWTS = IDTH + NLAT
      IW = IDWTS + NLAT
      CALL DSHAGCI1(NLAT,NLON,L,LATE,WSHAGC(I1),WSHAGC(I2),WSHAGC(I3),
     +              WSHAGC(I4),WSHAGC(I5),WSHAGC(I6),WSHAGC(I7),
     +              DWORK(IDTH),DWORK(IDWTS),DWORK(IW),IERROR)
      IF (IERROR.NE.0) IERROR = 5
      RETURN
      END
      SUBROUTINE DSHAGCI1(NLAT,NLON,L,LATE,WTS,P0N,P1N,ABEL,BBEL,CBEL,
     +                    WFFT,DTHETA,DWTS,WORK,IER)
      DOUBLE PRECISION WTS
      DOUBLE PRECISION P0N
      DOUBLE PRECISION P1N
      DOUBLE PRECISION ABEL
      DOUBLE PRECISION BBEL
      DOUBLE PRECISION CBEL
      DOUBLE PRECISION WFFT
      DOUBLE PRECISION FN
      DOUBLE PRECISION FM
      DIMENSION WTS(NLAT),P0N(NLAT,LATE),P1N(NLAT,LATE),ABEL(1),BBEL(1),
     +          CBEL(1),WFFT(1)
C*PT*WARNING* Already double-precision
      DOUBLE PRECISION PB,DTHETA(NLAT),DWTS(NLAT),WORK(*)
c     compute the nlat  gaussian points and weights, the
c     m=0,1 legendre polys for gaussian points and all n,
c     and the legendre recursion coefficients
c     define index function used in storing
c     arrays for recursion coefficients (functions of (m,n))
c     the index function indx(m,n) is defined so that
c     the pairs (m,n) map to [1,2,...,indx(l-1,l-1)] with no
c     "holes" as m varies from 2 to n and n varies from 2 to l-1.
c     (m=0,1 are set from p0n,p1n for all n)
c     define for 2.le.n.le.l-1
      INDX(M,N) = (N-1)* (N-2)/2 + M - 1
c     define index function for l.le.n.le.nlat
      IMNDX(M,N) = L* (L-1)/2 + (N-L-1)* (L-1) + M - 1
c     preset quantites for fourier transform
      CALL DHRFFTI(NLON,WFFT)
c     compute double precision gaussian points and weights
c     lw = 4*nlat*(nlat+1)+2
      LW = NLAT* (NLAT+2)
      CALL DGAQD(NLAT,DTHETA,DWTS,WORK,LW,IER)
      IF (IER.NE.0) RETURN
c     store gaussian weights single precision to save computation
c     in inner loops in analysis
      DO 100 I = 1,NLAT
          WTS(I) = DWTS(I)
  100 CONTINUE
c     initialize p0n,p1n using double precision dnlfk,dnlft
      DO 101 NP1 = 1,NLAT
          DO 101 I = 1,LATE
              P0N(NP1,I) = 0.0D0
              P1N(NP1,I) = 0.0D0
  101 CONTINUE
c     compute m=n=0 legendre polynomials for all theta(i)
      NP1 = 1
      N = 0
      M = 0
      CALL DDNLFK(M,N,WORK)
      DO 103 I = 1,LATE
          CALL DDNLFT(M,N,DTHETA(I),WORK,PB)
          P0N(1,I) = PB
  103 CONTINUE
c     compute p0n,p1n for all theta(i) when n.gt.0
      DO 104 NP1 = 2,NLAT
          N = NP1 - 1
          M = 0
          CALL DDNLFK(M,N,WORK)
          DO 105 I = 1,LATE
              CALL DDNLFT(M,N,DTHETA(I),WORK,PB)
              P0N(NP1,I) = PB
  105     CONTINUE
c     compute m=1 legendre polynomials for all n and theta(i)
          M = 1
          CALL DDNLFK(M,N,WORK)
          DO 106 I = 1,LATE
              CALL DDNLFT(M,N,DTHETA(I),WORK,PB)
              P1N(NP1,I) = PB
  106     CONTINUE
  104 CONTINUE
c     compute and store swarztrauber recursion coefficients
c     for 2.le.m.le.n and 2.le.n.le.nlat in abel,bbel,cbel
      DO 107 N = 2,NLAT
          FN = DBLE(N)
          MLIM = MIN0(N,L)
          DO 107 M = 2,MLIM
              FM = DBLE(M)
              IMN = INDX(M,N)
              IF (N.GE.L) IMN = IMNDX(M,N)
              ABEL(IMN) = DSQRT(((2*FN+1)* (FM+FN-2)* (FM+FN-3))/
     +                    (((2*FN-3)* (FM+FN-1)* (FM+FN))))
              BBEL(IMN) = DSQRT(((2*FN+1)* (FN-FM-1)* (FN-FM))/
     +                    (((2*FN-3)* (FM+FN-1)* (FM+FN))))
              CBEL(IMN) = DSQRT(((FN-FM+1)* (FN-FM+2))/
     +                    (((FN+FM-1)* (FN+FM))))
  107 CONTINUE
      RETURN
      END

C
C	$Id: calcnt.f,v 1.5 2008-07-27 00:23:01 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CALCNT (Z,M,N,A1,A2,A3,I1,I2,I3)
C
C THIS ENTRY POINT IS FOR USERS WHO ARE TOO LAZY TO SWITCH OLD DECKS
C TO THE NEW CALLING SEQUENCE.
C
      SAVE
      DIMENSION       Z(M,N)
C
C THE FOLLOWING CALL IS FOR GATHERING STATISTICS ON LIBRARY USE AT NCAR
      CALL Q8QST4 ('GRAPHX', 'CONRECSUPR', 'CALCNT', 'VERSION 01')
C
      CALL CONREC (Z,M,M,N,A1,A2,A3,I1,I2,-ABS(I3))
      RETURN
      END

C
C $Id: pj19sp.f,v 1.5 2008-07-27 00:17:11 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE PJ19SP (COORD,CRDIO,INDIC)
C
C -- V A N   D E R   G R I N T E N   I
C
      IMPLICIT REAL (A-Z)
      INTEGER INDIC
      DIMENSION GEOG(2),PROJ(2),COORD(2),CRDIO(2)
C **** PARAMETERS **** A,LON0,X0,Y0 ************************************
      COMMON /ERRMZ0/ IERR
        INTEGER IERR
      SAVE   /ERRMZ0/
      COMMON /PRINZ0/ IPEMSG,IPELUN,IPPARM,IPPLUN
        INTEGER IPEMSG,IPELUN,IPPARM,IPPLUN
      SAVE   /PRINZ0/
      COMMON /PC19SP/ A,LON0,X0,Y0
      DATA PI /3.14159265358979323846E0/
      DATA HALFPI /1.5707963267948966E0/
      DATA EPSLN/1.0E-10/
      DATA ZERO,HALF,ONE,TWO,THREE/0.0E0,0.5E0,1.0E0,2.0E0,3.0E0/
C
C -- F O R W A R D   . . .
C
      IF (INDIC .EQ. 0) THEN
C
         GEOG(1) = COORD(1)
         GEOG(2) = COORD(2)
         IERR = 0
         LON = ADJLSP (GEOG(1) - LON0)
         LAT = GEOG(2)
         IF (ABS(LAT) .GT. EPSLN) GO TO 140
         PROJ(1) = X0 + A * LON
         PROJ(2) = Y0
         CRDIO(1) = PROJ(1)
         CRDIO(2) = PROJ(2)
         RETURN
  140    THETA = ASINSP (MIN(ABS (LAT /HALFPI),ONE))
         IF (ABS(LON).GT.EPSLN.AND.ABS(ABS(LAT)-HALFPI).GT.EPSLN)
     .       GO TO 160
         PROJ(1) = X0
         PROJ(2) = Y0 + PI * A * SIGN( TAN (HALF * THETA), LAT)
         CRDIO(1) = PROJ(1)
         CRDIO(2) = PROJ(2)
         RETURN
  160    AL = HALF * ABS (PI / LON - LON / PI)
         ASQ = AL * AL
         SINTHT = SIN (THETA)
         COSTHT = COS (THETA)
         G = COSTHT / (SINTHT + COSTHT - ONE)
         GSQ = G * G
         M = G * (TWO / SINTHT - ONE)
         MSQ = M * M
         CON = PI * A * (AL * (G - MSQ) + SQRT (ASQ * (G - MSQ)**2 -
     .         (MSQ + ASQ) * (GSQ - MSQ))) / (MSQ + ASQ)
         CON = SIGN (CON , LON)
         PROJ(1) = X0 + CON
         CON = ABS (CON / (PI * A))
         PROJ(2)=Y0+SIGN(PI*A*SQRT(MAX(ZERO,ONE-CON*CON
     .                                                -TWO*AL*CON)),LAT)
         CRDIO(1) = PROJ(1)
         CRDIO(2) = PROJ(2)
         RETURN
      END IF
C
C -- I N V E R S E   . . .
C
C ---------------------------------------------------------------------
C     ALGORITHM DEVELOPED BY D.P. RUBINCAM, THE AMERICAN CARTOGRAPHER,
C                1981, V. 8, NO. 2, P. 177-180.
C ---------------------------------------------------------------------
C
      IF (INDIC .EQ. 1) THEN
C
         PROJ(1) = COORD(1)
         PROJ(2) = COORD(2)
         IERR = 0
         X = PROJ(1) - X0
         Y = PROJ(2) - Y0
         CON = PI * A
         XX = X / CON
         YY = Y / CON
         XYS = XX * XX + YY * YY
         C1 = -ABS(YY) * (ONE + XYS)
         C2 = C1 - TWO * YY * YY + XX * XX
         C3 = -TWO * C1 + ONE + TWO * YY * YY + XYS*XYS
         D = YY * YY / C3 + (TWO * C2 * C2 * C2/ C3/ C3/ C3 - 9.0E0 * C1
     .       * C2/ C3/ C3) / 27.0E0
         A1 = (C1 - C2 * C2/ THREE/ C3)/ C3
         M1 = TWO * SQRT(-A1/ THREE)
         CON = ((THREE * D) / A1) / M1
         IF (ABS(CON).GT.ONE) CON = SIGN(ONE,CON)
         TH1 = ACOS(CON)/THREE
         GEOG(2) = (-M1 * COS(TH1 + PI/ THREE) - C2/ THREE/ C3)
     .   * SIGN(PI,Y)
         IF (ABS(XX).GE.EPSLN) GO TO 230
         GEOG(1) = LON0
         CRDIO(1) = GEOG(1)
         CRDIO(2) = GEOG(2)
         RETURN
  230    CONTINUE
         GEOG(1) = LON0 + PI * (XYS - ONE + SQRT(ONE + TWO * (XX * XX
     .      - YY * YY) + XYS * XYS))/ TWO/ XX
         CRDIO(1) = GEOG(1)
         CRDIO(2) = GEOG(2)
         RETURN
      END IF
C
      END

C
C $Id: pj06dp.f,v 1.5 2008-07-27 00:17:10 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE PJ06DP (COORD,CRDIO,INDIC)
C
C -- P O L A R   S T E R E O G R A P H I C
C
      IMPLICIT DOUBLE PRECISION (A-Z)
      INTEGER IND
      INTEGER INDIC
      DIMENSION GEOG(2),PROJ(2),COORD(2),CRDIO(2)
C **** PARAMETERS **** A,E,ES,LON0,LATC,X0,Y0,E4,MCS,TCS,FAC,IND *******
      COMMON /ERRMZ0/ IERR
        INTEGER IERR
      SAVE   /ERRMZ0/
      COMMON /PRINZ0/ IPEMSG,IPELUN,IPPARM,IPPLUN
        INTEGER IPEMSG,IPELUN,IPPARM,IPPLUN
      SAVE   /PRINZ0/
      COMMON /PC06DP/ A,LON0,X0,Y0,E,E4,FAC,MCS,TCS,IND
      DATA ZERO,ONE,TWO /0.0D0,1.0D0,2.0D0/
C
C -- F O R W A R D   . . .
C
      IF (INDIC .EQ. 0) THEN
C
         GEOG(1) = COORD(1)
         GEOG(2) = COORD(2)
         IERR = 0
         CON1 = FAC * ADJLDP (GEOG(1) - LON0)
         CON2 = FAC * GEOG(2)
         SINPHI = SIN (CON2)
         TS = TSFNDP (E,CON2,SINPHI)
         IF (IND .EQ. 0) GO TO 240
         RH = A * MCS * TS / TCS
         GO TO 260
  240    RH = TWO * A * TS / E4
  260    PROJ(1) = X0 + FAC * RH * SIN (CON1)
         PROJ(2) = Y0 - FAC * RH * COS (CON1)
         CRDIO(1) = PROJ(1)
         CRDIO(2) = PROJ(2)
         RETURN
      END IF
C
C -- I N V E R S E   . . .
C
      IF (INDIC .EQ. 1) THEN
C
         PROJ(1) = COORD(1)
         PROJ(2) = COORD(2)
         IERR = 0
         X = FAC * (PROJ(1) - X0)
         Y = FAC * (PROJ(2) - Y0)
         RH = SQRT (X * X + Y * Y)
         IF (IND .EQ. 0) GO TO 340
         TS = RH * TCS / (A * MCS)
         GO TO 360
  340    TS = RH * E4 / (TWO * A)
  360    GEOG(2) = FAC * PHI2DP (E,TS)
         IF (IERR .EQ. 0) GO TO 380
         IERR = 064
         RETURN
  380    IF (RH .NE. ZERO) GO TO 400
         GEOG(1) = FAC * LON0
         CRDIO(1) = GEOG(1)
         CRDIO(2) = GEOG(2)
         RETURN
  400    GEOG(1) = ADJLDP (FAC * ATAN2 (X , -Y) + LON0)
         CRDIO(1) = GEOG(1)
         CRDIO(2) = GEOG(2)
         RETURN
      END IF
C
      END

C
C	$Id: gwidmp.f,v 1.7 2008-07-27 00:21:07 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GWIDMP(ICNTX,RCNTX)
C
C  This subroutine dumps the current state of all attributes as
C  inherited from GKS at the time of the call.  The attributes
C  are stored in the input arrays ICNTX and RCNTX.  See the awi
C  routine GZSRAT for details on the ordering.
C
      include 'gwiwdt.h'
      include 'gwiwsl.h'
      include 'gwiadc.h'
      include 'gwiarq.h'
      include 'gwiast.h'
      include 'gwiadf.h'
      include 'gwiio.h'
      include 'gwiins.h'
      include 'gwiopc.h'
      include 'gwienu.h'
C
      INTEGER NUMO(2),RERR,ICNTX(31)
      REAL    RCNTX(19)
      LOGICAL ASFTMP(13)
C
      SAVE
C
C  Clipping indicator, and clip rectangle.
C
      NBYTES = 1+(MEFW-1)/8
      CALL GWPTNI (CLCLIN, IDCLIN, NBYTES, RERR)
      MRCLIP = ICNTX(1)
      CALL GWPTPR (MRCLIP, MEFW,     1, RERR)
C
      NBYTES = 1 + (4*MVDCFW-1)/8
      CALL GWPTNI (CLCREC, IDCREC, NBYTES, RERR)
      MRCREC(1) = INT(REAL(MXSCAL)*RCNTX(12))
      MRCREC(2) = INT(REAL(MYSCAL)*RCNTX(14))
      MRCREC(3) = INT(REAL(MXSCAL)*RCNTX(13))
      MRCREC(4) = INT(REAL(MYSCAL)*RCNTX(15))
      CALL GWPTPR (MRCREC, MVDCFW,     4, RERR)
C
C  Line bundle index.
C
      NBYTES = 1+(MIXFW-1)/8
      CALL GWPTNI (CLLBIX,  IDLBIX,  NBYTES,  RERR)
      MRPLIX = ICNTX(2)
      CALL GWPTPR (MRPLIX, MIXFW,  1, RERR)
      MSPLIX         = MRPLIX
      VALCHG(IVPLIX) = .FALSE.
C
C  Line type.
C
      NBYTES = 1+(MIXFW-1)/8
      CALL GWPTNI (CLLTYP,  IDLTYP,  NBYTES,  RERR)
      MRLTYP = ICNTX(3)
      CALL GWPTPR (MRLTYP, MIXFW,  1, RERR)
      MSLTYP = MRLTYP
      VALCHG(IVLTYP) = .FALSE.
C
C  Linewidth scale factor.
C
      NBYTES = 1+(2*MCFPP-1)/8
      CALL GWPTNI (CLLWID,  IDLWID,  NBYTES,  RERR)
      ARLWSC = RCNTX(1)
      CALL GFLCNV (ARLWSC,NUMO)
      CALL GWPTPR (NUMO, MCFPP,  2, RERR)
      ASLWSC         = ARLWSC
      VALCHG(IVLWSC) = .FALSE.
C
C  Line color index.
C
      NBYTES = 1+(MCIXFW-1)/8
      CALL GWPTNI (CLLCLR, IDLCLR, NBYTES,  RERR)
      MRPLCI = ICNTX(4)
      CALL GWPTPR (MRPLCI, MCIXFW,  1, RERR)
      MSPLCI         = MRPLCI
      VALCHG(IVPLCI) = .FALSE.
C
C  Marker bundle index.
C
      NBYTES = 1+(MIXFW-1)/8
      CALL GWPTNI (CLMBIX, IDMBIX, NBYTES,  RERR)
      MRPMIX = ICNTX(5)
      CALL GWPTPR (MRPMIX, MIXFW,  1, RERR)
      MSPMIX = MRPMIX
      VALCHG(IVPMIX) = .FALSE.
C
C  Marker type.
C
      NBYTES = 1+(MIXFW-1)/8
      CALL GWPTNI (CLMTYP, IDMTYP,  NBYTES,  RERR)
      MRMTYP = ICNTX(6)
      CALL GWPTPR (MRMTYP, MIXFW,  1, RERR)
      MSMTYP = MRMTYP
      VALCHG(IVMTYP) = .FALSE.
C
C  Marker size.
C
      NBYTES = 1+(2*MCFPP-1)/8
      CALL GWPTNI (CLMSIZ, IDMSIZ, NBYTES,  RERR)
      ARMSZS = RCNTX(2)
      CALL GFLCNV (ARMSZS,NUMO)
      CALL GWPTPR (NUMO, MCFPP,  2, RERR)
      ASMSZS = ARMSZS
      VALCHG(IVMSZS) = .FALSE.
C
C  Marker color.
C
      NBYTES = 1+(MCIXFW-1)/8
      CALL GWPTNI (CLMCLR, IDMCLR, NBYTES,  RERR)
      MRPMCI = ICNTX(7)
      CALL GWPTPR (MRPMCI, MCIXFW,  1, RERR)
      MSPMCI = MRPMCI
      VALCHG(IVPMCI) = .FALSE.
C
C  Text bundle index.
C
      NBYTES = 1+(MIXFW-1)/8
      CALL GWPTNI (CLTBIX, IDTBIX, NBYTES, RERR)
      MRTXIX = ICNTX(8)
      CALL GWPTPR (MRTXIX, MIXFW, 1, RERR)
      MSTXIX         = MRTXIX
      VALCHG(IVTXIX) = .FALSE.
C
C  Text font.
C
      NBYTES = 1+(MEFW-1)/8
      CALL GWPTNI (CLTFON, IDTFON, NBYTES, RERR)
      MRTXFO = ICNTX(9)
      CALL GWPTPR (MRTXFO, MEFW, 1, RERR)
      MSTXFO         = MRTXFO
      VALCHG(IVTXFO) = .FALSE.
C
C  Text precision.
C
      NBYTES         = 1+(MIXFW-1)/8
      CALL GWPTNI (CLTPRE, IDTPRE, NBYTES, RERR)
      MRTXPR = ICNTX(10)
      CALL GWPTPR (MRTXPR, MIXFW, 1, RERR)
      MSTXPR         = MRTXPR
      VALCHG(IVTXPR) = .FALSE.
C
C  Character expansion factor.
C
      NBYTES = 1+(2*MCFPP-1)/8
      CALL GWPTNI (CLCHEX, IDCHEX, NBYTES, RERR)
      ARCHXP = RCNTX(3)
      CALL GFLCNV (ARCHXP, NUMO)
      CALL GWPTPR (NUMO, MCFPP, 2, RERR)
      ASCHXP         = ARCHXP
      VALCHG(IVCHXP) = .FALSE.
C
C  Character spacing.
C
      NBYTES = 1+(2*MCFPP-1)/8
      CALL GWPTNI (CLCHSP, IDCHSP, NBYTES, RERR)
      ARCHSP = RCNTX(4)
      CALL GFLCNV (ARCHSP, NUMO)
      CALL GWPTPR (NUMO, MCFPP, 2, RERR)
      ASCHSP         = ARCHSP
      VALCHG(IVCHSP) = .FALSE.
C
C  Text color index.
C
      NBYTES = 1+(MCIXFW-1)/8
      CALL GWPTNI (CLTCLR, IDTCLR, NBYTES, RERR)
      MRTXCI = ICNTX(11)
      CALL GWPTPR (MRTXCI, MCIXFW, 1, RERR)
      MSTXCI         = MRTXCI
      VALCHG(IVTXCI) = .FALSE.
C
C  Text path.
C
      NBYTES = 1+(MEFW-1)/8
      CALL GWPTNI (CLTXPA, IDTXPA, NBYTES, RERR)
      MRTXP = ICNTX(12)
      CALL GWPTPR (MRTXP , MEFW,  1, RERR)
      MSTXP         = MRTXP
      VALCHG(IVTXP) = .FALSE.
C
C  Text alignment.
C
      NBYTES = 1+(2*MEFW + 4*MCFPP - 1)/8
      CALL GWPTNI (CLTXAL, IDTXAL, NBYTES, RERR)
      MRTXAL(1) = ICNTX(13)
      MRTXAL(2) = ICNTX(14)
      CALL GWPTPR (MRTXAL, MEFW, 2, RERR)
      NUMO(1) = 0
      NUMO(2) = 0
      CALL GWPTPR (NUMO, MCFPP, 2, RERR)
      CALL GWPTPR (NUMO, MCFPP, 2, RERR)
      MSTXAL(1)      = MRTXAL(1)
      MSTXAL(2)      = MRTXAL(2)
      VALCHG(IVTXAL) = .FALSE.
C
C  Character height.
C
      NBYTES = 1+(MVDCFW-1)/8
      CALL GWPTNI (CLCHHT, IDCHHT, NBYTES, RERR)
      UP   = SQRT(RCNTX(16)**2+RCNTX(17)**2)
      BASE = SQRT(RCNTX(18)**2+RCNTX(19)**2)
      DMAX = MAX(UP,BASE)
      IF (DMAX .GT. 1.0)  THEN
C
C  A vector is longer than 1.0 NDC, scale down both vectors equally.
C
        FACTOR = 1.0/DMAX
        RCNTX(16) = FACTOR*RCNTX(16)
        RCNTX(17) = FACTOR*RCNTX(17)
        RCNTX(18) = FACTOR*RCNTX(18)
        RCNTX(19) = FACTOR*RCNTX(19)
      END IF
C
      RTMP = 0.5+UP*REAL(MYSCAL)
      MRCHH = MAXYVD
      IF (RTMP .LT. REAL(MAXYVD)) MRCHH = INT(RTMP)
      CALL GWPTPR (MRCHH, MVDCFW,  1, RERR)
      MSCHH         = MRCHH
      VALCHG(IVCHH) = .FALSE.
C
C  Character up vector.
C
      NBYTES = 1+(4*MVDCFW-1)/8
      CALL GWPTNI (CLCHOR, IDCHOR, NBYTES, RERR)
      MRCHOV(1) = MIN (MAXYVD, INT (0.5 + MXSCAL*RCNTX(16)))
      MRCHOV(2) = MIN (MAXYVD, INT (0.5 + MYSCAL*RCNTX(17)))
      MRCHOV(3) = MIN (MAXYVD, INT (0.5 + MXSCAL*RCNTX(18)))
      MRCHOV(4) = MIN (MAXYVD, INT (0.5 + MYSCAL*RCNTX(19)))
      CALL GWPTPR (MRCHOV(1) , MVDCFW,  4, RERR)
      MSCHOV(1)      = MRCHOV(1)
      MSCHOV(2)      = MRCHOV(2)
      MSCHOV(3)      = MRCHOV(3)
      MSCHOV(4)      = MRCHOV(4)
      VALCHG(IVCHOV) = .FALSE.
C
C  Fill bundle index.
C
       NBYTES = 1+(MIXFW-1)/8
       CALL GWPTNI (CLFBIX, IDFBIX,  NBYTES,  RERR)
       MRFAIX = ICNTX(15)
       CALL GWPTPR (MRFAIX, MIXFW,  1, RERR)
       MSFAIX = MRFAIX
       VALCHG(IVFAIX) = .FALSE.
C
C  Fill area interior style.
C
       NBYTES = 1+(MEFW-1)/8
       CALL GWPTNI (CLINTS, IDINTS, NBYTES,  RERR)
       MRFAIS = ICNTX(16)
       CALL GWPTPR (MRFAIS, MEFW,  1, RERR)
       MSFAIS = MRFAIS
       VALCHG(IVFAIS) = .FALSE.
C
C  Fill area style index--send pattern index and hatch index.
C
       NBYTES = 1+(MIXFW-1)/8
       CALL GWPTNI (CLHAIX, IDHAIX, NBYTES,  RERR)
       MRFASI = ICNTX(17)
       CALL GWPTPR (MRFASI, MIXFW, 1, RERR)
       CALL GWPTNI (CLPTIX, IDPTIX, NBYTES,  RERR)
       CALL GWPTPR (MRFASI, MIXFW, 1, RERR)
       MSFASI = MRFASI
       VALCHG(IVFASI) = .FALSE.
C
C  Fill area color index.
C
       NBYTES = 1+(MCIXFW-1)/8
       CALL GWPTNI (CLFCLR, IDFCLR, NBYTES, RERR)
       MRFACI = ICNTX(18)
       CALL GWPTPR (MRFACI, MCIXFW,  1, RERR)
       MSFACI = MRFACI
       VALCHG(IVFACI) = .FALSE.
C
C  Pattern size (currently not implemented--be sure to transform
C  the sizes as in the GKS GSPA routine if ever implemented).
C
C      NBYTES = 1+(4*MVDCFW-1)/8
C      CALL GWPTNI (CLPTSZ, IDPTSZ, NBYTES, RERR)
C      CALL GWPTPR (MRPASZ(1) , MVDCFW,  4, RERR)
C      MSPASZ(1) = MRPASZ(1)
C      MSPASZ(2) = MRPASZ(2)
C      MSPASZ(3) = MRPASZ(3)
C      MSPASZ(4) = MRPASZ(4)
C      VALCHG(IVPASZ) = .FALSE.
C
C  Pattern reference point (currently not implemented--be sure to
C  transform the reference point as in the GKS routine GSPARF if
C  ever implemented).
C
C      NBYTES = 1+(2*MVDCFW-1)/8
C      CALL GWPTNI (CLFRPT, IDFRPT, NBYTES, RERR)
C      CALL GWPTPR (MRPARF(1), MVDCFW, 2, RERR)
C      MSPARF(1) = MRPARF(1)
C      MSPARF(2) = MRPARF(2)
C      VALCHG(IVPARF) = .FALSE.
C
C  Aspect source flags.
C
      DO 20 I=1,NGKASF
        ASFTMP(I) = ASFCHG(I)
        ASFCHG(I) = .TRUE.
   20 CONTINUE
      DO 40 I=1,NGKASF
        ASFCHG(I) = .TRUE.
C 
C  Convert from GKS ASFs to CGM ASFs.
C
        MRASF(I) =  1-ICNTX(I+18)
   40 CONTINUE
      CALL GWISAS (1, RERR)
      CALL GWISAS (2, RERR)
      CALL GWISAS (3, RERR)
      CALL GWISAS (4, RERR)
C
C  Clear aggregate change variable.
C
      AGPEND(1) = .FALSE.
      AGPEND(2) = .FALSE.
      AGPEND(3) = .FALSE.
      AGPEND(4) = .FALSE.
C
      RETURN
      END

      PROGRAM TCONAQ
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C OPEN GKS, OPEN WORKSTATION OF TYPE 1, ACTIVATE WORKSTATION
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C INVOKE DEMO DRIVER
C
      CALL CONAQ(IERR)
C
C DEACTIVATE AND CLOSE WORKSTATION, CLOSE GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END
C
      SUBROUTINE CONAQ (IERROR)
C
C PURPOSE                To provide a simple demonstration of
C                        the CONRAQ package.
C
C USAGE                  CALL CONAQ (IERROR)
C
C ARGUMENTS
C
C ON OUTPUT              IERROR
C                          An integer variable
C                          = 0, if the test was successful,
C                          > 0, the test was not successful,
C                               and the error number corresponds
C                               to the number in the CONRAQ listing.
C
C I/O                    If the test is successful, the message
C
C              CONRAQ TEST EXECUTED--SEE PLOTS TO CERTIFY
C
C                        is printed on unit 6.  In addition, 2 output
C                        frames are produced on the machine graphics
C                        device.  The first plot is the contour plot.
C                        The second plot shows the triangulation of the
C                        data.  In order to determine if the test
C                        was successful, it is necessary to examine
C                        the plots.
C
C PRECISION              Single
C
C LANGUAGE               FORTRAN 77
C
C REQUIRED ROUTINES      CONRAQ, CONTERP, DASHLINE
C
C REQUIRED GKS LEVEL     0A
C
C ALGORITHM              A sparse dataset is defined in DATA statements.
C                        Options are selected to produce a plot title
C                        and display the triangulation generated by the
C                        interpolation routines.  Default options
C                        include a message at the bottom of the plot
C                        and a plot perimter.
C
C                        This is the quick version of the CONRAN
C                        family of utilities.
C
      COMMON /RAQINT/ IRAQMJ, IRAQMN, IRAQTX
C
C Set up the scratch arrays needed by CONRAQ.
C
      DIMENSION WK(221),IWK(744)
C
C Dimension arrays to hold the sparse dataset.
C
      DIMENSION XD(17),YD(17),ZD(17)
C
C Define the dataset.
C
      DATA XD(1),XD(2),XD(3),XD(4),XD(5),XD(6),XD(7),XD(8),
     1     XD(9),XD(10),XD(11),XD(12),XD(13),XD(14),XD(15),
     2     XD(16),XD(17)
     3     /3.,3.,10.,18.,18.,10.,10.,5.,1.,15.,20.,
     4          5.,15.,10.,7.,13.,16./
C
      DATA YD(1),YD(2),YD(3),YD(4),YD(5),YD(6),YD(7),YD(8),
     1     YD(9),YD(10),YD(11),YD(12),YD(13),YD(14),YD(15),
     2     YD(16),YD(17)
     3    /3.,18.,18.,3.,18.,10.,1.,5.,10.,5.,10.,
     4          15.,15.,15.,20.,20.,8./
C
      DATA ZD(1),ZD(2),ZD(3),ZD(4),ZD(5),ZD(6),ZD(7),ZD(8),
     1     ZD(9),ZD(10),ZD(11),ZD(12),ZD(13),ZD(14),ZD(15),
     2     ZD(16),ZD(17)
     3    /25.,25.,25.,25.,25.,-5.,1.,1.,1.,1.,1.,
     4          1.,1.,1.,1.,1.,25./
C
C Define the number of points in the dataset.
C
      DATA NDP/17/
C
C Set the PORT error handling routine to the recover mode.
C
      CALL ENTSR(IROLD,1)
C
C Define the plot title.
C
      CALL CONOP4('TLE=ON','DEMONSTRATION PLOT FOR CONRAQ',29,0)
C
C Test for an error condition.
C
      IF (NERRO(IERROR).NE.0) GO TO 100
C
C No error encountered.
C
C Set the option to generate the triangulation display.
C
      CALL CONOP1('TRI=ON')
C
C Test for an error condition.
C
      IF (NERRO(IERROR).NE.0) GO TO 100
C
C No error encountered.
C
C Call CONRAQ to contour the data.
C
      CALL CONRAQ(XD,YD,ZD,NDP,WK,IWK)
C
C Test for an error condition.
C
      IF (NERRO(IERROR).NE.0) GO TO 100
C
C No error encountered.
C
C Advance the frame.  CONRAQ does not do this internally.
C
        CALL FRAME
C
C Print the all is well message.
C
      WRITE(6,10)
 10   FORMAT(' CONRAQ TEST EXECUTED--SEE PLOTS TO CERTIFY')
C
      RETURN
C
C If an error was encountered call the PORT error print routine.
C This is only necessary if you are in recover mode, else the message
C is printed automatically.
C
 100  CALL EPRIN
      RETURN
      END

c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by UCAR                 .
c  .                                                             .
c  .       University Corporation for Atmospheric Research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                         SPHEREPACK                          .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c
c ... file vlapgc.f
c
c     this file includes documentation and code for
c     subroutine vlapgc          i
c
c ... files which must be loaded with vlapgc.f
c
c     sphcom.f, hrfft.f, vhagc.f, vhsgc.f, gaqd.f
c
c
C*PL*ERROR* Comment line too long
c     subroutine vlapgc(nlat,nlon,ityp,nt,vlap,wlap,idvw,jdvw,br,bi,cr,ci,
c    +mdbc,ndbc,wvhsgc,lvhsgc,work,lwork,ierror)
c
c     given the vector spherical harmonic coefficients (br,bi,cr,ci)
C*PL*ERROR* Comment line too long
c     precomputed by subroutine vhagc for a vector field (v,w), subroutine
c     vlapgc computes the vector laplacian of the vector field (v,w)
c     in (vlap,wlap) (see the definition of the vector laplacian at
c     the output parameter description of vlap,wlap below).  w and wlap
c     are east longitudinal components of the vectors.  v and vlap are
c     colatitudinal components of the vectors.  the laplacian components
C*PL*ERROR* Comment line too long
c     in (vlap,wlap) have the same symmetry or lack of symmetry about the
C*PL*ERROR* Comment line too long
c     equator as (v,w).  the input parameters ityp,nt,mdbc,nbdc must have
C*PL*ERROR* Comment line too long
c     the same values used by vhagc to compute br,bi,cr, and ci for (v,w).
c     vlap(i,j) and wlap(i,j) are given on the sphere at the gaussian
C*PL*ERROR* Comment line too long
c     colatitude theta(i) (see nlat as input parameter) and east longitude
c     lambda(j) = (j-1)*2*pi/nlon for i=1,...,nlat and j=1,...,nlon.
c
c     input parameters
c
c     nlat   the number of points in the gaussian colatitude grid on the
C*PL*ERROR* Comment line too long
c            full sphere. these lie in the interval (0,pi) and are computed
C*PL*ERROR* Comment line too long
c            in radians in theta(1) <...< theta(nlat) by subroutine gaqd.
C*PL*ERROR* Comment line too long
c            if nlat is odd the equator will be included as the grid point
c            theta((nlat+1)/2).  if nlat is even the equator will be
c            excluded as a grid point and will lie half way between
c            theta(nlat/2) and theta(nlat/2+1). nlat must be at least 3.
c            note: on the half sphere, the number of grid points in the
c            colatitudinal direction is nlat/2 if nlat is even or
c            (nlat+1)/2 if nlat is odd.
c
c     nlon   the number of distinct longitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater
c            than zero. the axisymmetric case corresponds to nlon=1.
c            the efficiency of the computation is improved when nlon
c            is a product of small prime numbers.
c
C*PL*ERROR* Comment line too long
c     ityp   this parameter should have the same value input to subroutine
c            vhagc to compute the coefficients br,bi,cr, and ci for the
c            vector field (v,w).  ityp is set as follows:
c
C*PL*ERROR* Comment line too long
c            = 0  no symmetries exist in (v,w) about the equator. (vlap,wlap)
C*PL*ERROR* Comment line too long
c                 is computed and stored on the entire sphere in the arrays
C*PL*ERROR* Comment line too long
c                 vlap(i,j) and wlap(i,j) for i=1,...,nlat and j=1,...,nlon.
c
c
C*PL*ERROR* Comment line too long
c            = 1  no symmetries exist in (v,w) about the equator. (vlap,wlap)
C*PL*ERROR* Comment line too long
c                 is computed and stored on the entire sphere in the arrays
C*PL*ERROR* Comment line too long
c                 vlap(i,j) and wlap(i,j) for i=1,...,nlat and j=1,...,nlon.
C*PL*ERROR* Comment line too long
c                 the vorticity of (v,w) is zero so the coefficients cr and
C*PL*ERROR* Comment line too long
c                 ci are zero and are not used.  the vorticity of (vlap,wlap)
c                 is also zero.
c
c
C*PL*ERROR* Comment line too long
c            = 2  no symmetries exist in (v,w) about the equator. (vlap,wlap)
C*PL*ERROR* Comment line too long
c                 is computed and stored on the entire sphere in the arrays
C*PL*ERROR* Comment line too long
c                 vlap(i,j) and wlap(i,j) for i=1,...,nlat and j=1,...,nlon.
C*PL*ERROR* Comment line too long
c                 the divergence of (v,w) is zero so the coefficients br and
C*PL*ERROR* Comment line too long
c                 bi are zero and are not used.  the divergence of (vlap,wlap)
c                 is also zero.
c
C*PL*ERROR* Comment line too long
c            = 3  w is antisymmetric and v is symmetric about the equator.
C*PL*ERROR* Comment line too long
c                 consequently wlap is antisymmetric and vlap is symmetric.
c                 (vlap,wlap) is computed and stored on the northern
C*PL*ERROR* Comment line too long
c                 hemisphere only.  if nlat is odd, storage is in the arrays
C*PL*ERROR* Comment line too long
c                 vlap(i,j),wlap(i,j) for i=1,...,(nlat+1)/2 and j=1,...,nlon.
c                 if nlat is even, storage is in the arrays vlap(i,j),
c                 wlap(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
c
C*PL*ERROR* Comment line too long
c            = 4  w is antisymmetric and v is symmetric about the equator.
C*PL*ERROR* Comment line too long
c                 consequently wlap is antisymmetric and vlap is symmetric.
c                 (vlap,wlap) is computed and stored on the northern
C*PL*ERROR* Comment line too long
c                 hemisphere only.  if nlat is odd, storage is in the arrays
C*PL*ERROR* Comment line too long
c                 vlap(i,j),wlap(i,j) for i=1,...,(nlat+1)/2 and j=1,...,nlon.
c                 if nlat is even, storage is in the arrays vlap(i,j),
c                 wlap(i,j) for i=1,...,nlat/2 and j=1,...,nlon.  the
C*PL*ERROR* Comment line too long
c                 vorticity of (v,w) is zero so the coefficients cr,ci are
c                 zero and are not used. the vorticity of (vlap,wlap) is
c                 also zero.
c
C*PL*ERROR* Comment line too long
c            = 5  w is antisymmetric and v is symmetric about the equator.
C*PL*ERROR* Comment line too long
c                 consequently wlap is antisymmetric and vlap is symmetric.
c                 (vlap,wlap) is computed and stored on the northern
C*PL*ERROR* Comment line too long
c                 hemisphere only.  if nlat is odd, storage is in the arrays
C*PL*ERROR* Comment line too long
c                 vlap(i,j),wlap(i,j) for i=1,...,(nlat+1)/2 and j=1,...,nlon.
c                 if nlat is even, storage is in the arrays vlap(i,j),
c                 wlap(i,j) for i=1,...,nlat/2 and j=1,...,nlon.  the
c                 divergence of (v,w) is zero so the coefficients br,bi
C*PL*ERROR* Comment line too long
c                 are zero and are not used. the divergence of (vlap,wlap)
c                 is also zero.
c
c
C*PL*ERROR* Comment line too long
c            = 6  w is symmetric and v is antisymmetric about the equator.
C*PL*ERROR* Comment line too long
c                 consequently wlap is symmetric and vlap is antisymmetric.
c                 (vlap,wlap) is computed and stored on the northern
C*PL*ERROR* Comment line too long
c                 hemisphere only.  if nlat is odd, storage is in the arrays
C*PL*ERROR* Comment line too long
c                 vlap(i,j),wlap(i,j) for i=1,...,(nlat+1)/2 and j=1,...,nlon.
c                 if nlat is even, storage is in the arrays vlap(i,j),
c                 wlap(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
c
C*PL*ERROR* Comment line too long
c            = 7  w is symmetric and v is antisymmetric about the equator.
C*PL*ERROR* Comment line too long
c                 consequently wlap is symmetric and vlap is antisymmetric.
c                 (vlap,wlap) is computed and stored on the northern
C*PL*ERROR* Comment line too long
c                 hemisphere only.  if nlat is odd, storage is in the arrays
C*PL*ERROR* Comment line too long
c                 vlap(i,j),wlap(i,j) for i=1,...,(nlat+1)/2 and j=1,...,nlon.
c                 if nlat is even, storage is in the arrays vlap(i,j),
c                 wlap(i,j) for i=1,...,nlat/2 and j=1,...,nlon.  the
C*PL*ERROR* Comment line too long
c                 vorticity of (v,w) is zero so the coefficients cr,ci are
c                 zero and are not used. the vorticity of (vlap,wlap) is
c                 also zero.
c
C*PL*ERROR* Comment line too long
c            = 8  w is symmetric and v is antisymmetric about the equator.
C*PL*ERROR* Comment line too long
c                 consequently wlap is symmetric and vlap is antisymmetric.
c                 (vlap,wlap) is computed and stored on the northern
C*PL*ERROR* Comment line too long
c                 hemisphere only.  if nlat is odd, storage is in the arrays
C*PL*ERROR* Comment line too long
c                 vlap(i,j),wlap(i,j) for i=1,...,(nlat+1)/2 and j=1,...,nlon.
c                 if nlat is even, storage is in the arrays vlap(i,j),
c                 wlap(i,j) for i=1,...,nlat/2 and j=1,...,nlon.  the
c                 divergence of (v,w) is zero so the coefficients br,bi
C*PL*ERROR* Comment line too long
c                 are zero and are not used. the divergence of (vlap,wlap)
c                 is also zero.
c
c
C*PL*ERROR* Comment line too long
c     nt     nt is the number of vector fields (v,w).  some computational
c            efficiency is obtained for multiple fields.  in the program
c            that calls vlapgc, the arrays vlap,wlap,br,bi,cr and ci
C*PL*ERROR* Comment line too long
c            can be three dimensional corresponding to an indexed multiple
c            vector field.  in this case multiple vector synthesis will
C*PL*ERROR* Comment line too long
c            be performed to compute the vector laplacian for each field.
C*PL*ERROR* Comment line too long
c            the third index is the synthesis index which assumes the values
C*PL*ERROR* Comment line too long
c            k=1,...,nt.  for a single synthesis set nt=1.  the description
C*PL*ERROR* Comment line too long
c            of the remaining parameters is simplified by assuming that nt=1
c            or that all arrays are two dimensional.
c
C*PL*ERROR* Comment line too long
c   idvw     the first dimension of the arrays vlap and wlap as it appears
C*PL*ERROR* Comment line too long
c            in the program that calls vlapgc.  if ityp=0,1, or 2  then idvw
C*PL*ERROR* Comment line too long
c            must be at least nlat.  if ityp > 2 and nlat is even then idvw
C*PL*ERROR* Comment line too long
c            must be at least nlat/2. if ityp > 2 and nlat is odd then idvw
c            must be at least (nlat+1)/2.
c
C*PL*ERROR* Comment line too long
c   jdvw     the second dimension of the arrays vlap and wlap as it appears
C*PL*ERROR* Comment line too long
c            in the program that calls vlapgc. jdvw must be at least nlon.
c
c
c   br,bi    two or three dimensional arrays (see input parameter nt)
c   cr,ci    that contain vector spherical harmonic coefficients
c            of the vector field (v,w) as computed by subroutine vhagc.
c            br,bi,cr and ci must be computed by vhagc prior to calling
c            vlapgc.  if ityp=1,4, or 7 then cr,ci are not used and can
c            be dummy arguments.  if ityp=2,5, or 8 then br,bi are not
c            used and can be dummy arguments.
c
c    mdbc    the first dimension of the arrays br,bi,cr and ci as it
c            appears in the program that calls vlapgc.  mdbc must be
c            at least min0(nlat,nlon/2) if nlon is even or at least
c            min0(nlat,(nlon+1)/2) if nlon is odd.
c
c    ndbc    the second dimension of the arrays br,bi,cr and ci as it
c            appears in the program that calls vlapgc. ndbc must be at
c            least nlat.
c
c    wvhsgc  an array which must be initialized by subroutine vhsgci.
c            once initialized, wvhsgc
c            can be used repeatedly by vlapgc as long as nlat and nlon
c            remain unchanged.  wvhsgc must not be altered between calls
c            of vlapgc.
c
c    lvhsgc  the dimension of the array wvhsgc as it appears in the
c            program that calls vhagc. define
c
c               l1 = min0(nlat,nlon/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            then lvhsgc must be at least
c
c               4*nlat*l2+3*max0(l1-2,0)*(2*nlat-l1-1)+nlon+15
c
c
c     work   a work array that does not have to be saved.
c
c     lwork  the dimension of the array work as it appears in the
c            program that calls vlapgc. define
c
c               l2 = nlat/2                    if nlat is even or
c               l2 = (nlat+1)/2                if nlat is odd
c               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            if ityp .le. 2 then
c
c               nlat*(2*nt*nlon+max0(6*l2,nlon)) + nlat*(4*nt*l1+1)
c
c            or if ityp .gt. 2 let
c
c               l2*(2*nt*nlon+max0(6*nlat,nlon)) + nlat*(4*nt*l1+1)
c
c            will suffice as a minimum length for lwork
c            (see ierror=10 below)
c            (see ierror=10 below)
c
c     **************************************************************
c
c     output parameters
c
c
C*PL*ERROR* Comment line too long
c    vlap,   two or three dimensional arrays (see input parameter nt) that
C*PL*ERROR* Comment line too long
c    wlap    contain the vector laplacian of the field (v,w).  wlap(i,j) is
C*PL*ERROR* Comment line too long
c            the east longitude component and vlap(i,j) is the colatitudinal
c            component of the vector laplacian.  the definition of the
c            vector laplacian follows:
c
C*PL*ERROR* Comment line too long
c            let cost and sint be the cosine and sine at colatitude theta.
C*PL*ERROR* Comment line too long
c            let d( )/dlambda  and d( )/dtheta be the first order partial
C*PL*ERROR* Comment line too long
c            derivatives in longitude and colatitude.  let del2 be the scalar
c            laplacian operator
c
c                 del2(s) = [d(sint*d(s)/dtheta)/dtheta +
c                             2            2
c                            d (s)/dlambda /sint]/sint
c
c            then the vector laplacian opeator
c
c                 dvel2(v,w) = (vlap,wlap)
c
c            is defined by
c
c                 vlap = del2(v) - (2*cost*dw/dlambda + v)/sint**2
c
c                 wlap = del2(w) + (2*cost*dv/dlambda - w)/sint**2
c
C*PL*ERROR* Comment line too long
c  ierror    a parameter which flags errors in input parameters as follows:
c
c            = 0  no errors detected
c
c            = 1  error in the specification of nlat
c
c            = 2  error in the specification of nlon
c
c            = 3  error in the specification of ityp
c
c            = 4  error in the specification of nt
c
c            = 5  error in the specification of idvw
c
c            = 6  error in the specification of jdvw
c
c            = 7  error in the specification of mdbc
c
c            = 8  error in the specification of ndbc
c
c            = 9  error in the specification of lvhsgc
c
c            = 10 error in the specification of lwork
c
c
c **********************************************************************
c
c     end of documentation for vlapgc
c
c **********************************************************************
c
      SUBROUTINE DVLAPGC(NLAT,NLON,ITYP,NT,VLAP,WLAP,IDVW,JDVW,BR,BI,
     +                  CR,CI,MDBC,NDBC,WVHSGC,LVHSGC,WORK,LWORK,
     +                  IERROR)
      DOUBLE PRECISION VLAP
      DOUBLE PRECISION WLAP
      DOUBLE PRECISION BR
      DOUBLE PRECISION BI
      DOUBLE PRECISION CR
      DOUBLE PRECISION CI
      DOUBLE PRECISION WVHSGC
      DOUBLE PRECISION WORK
      DIMENSION VLAP(IDVW,JDVW,NT),WLAP(IDVW,JDVW,NT)
      DIMENSION BR(MDBC,NDBC,NT),BI(MDBC,NDBC,NT)
      DIMENSION CR(MDBC,NDBC,NT),CI(MDBC,NDBC,NT)
      DIMENSION WVHSGC(LVHSGC),WORK(LWORK)

      IERROR = 1
      IF (NLAT.LT.3) RETURN
      IERROR = 2
      IF (NLON.LT.1) RETURN
      IERROR = 3
      IF (ITYP.LT.0 .OR. ITYP.GT.8) RETURN
      IERROR = 4
      IF (NT.LT.0) RETURN
      IERROR = 5
      IMID = (NLAT+1)/2
      IF ((ITYP.LE.2.AND.IDVW.LT.NLAT) .OR.
     +    (ITYP.GT.2.AND.IDVW.LT.IMID)) RETURN
      IERROR = 6
      IF (JDVW.LT.NLON) RETURN
      IERROR = 7
      MMAX = MIN0(NLAT, (NLON+1)/2)
      IF (MDBC.LT.MMAX) RETURN
      IERROR = 8
      IF (NDBC.LT.NLAT) RETURN
      IERROR = 9
      IDZ = (MMAX* (NLAT+NLAT-MMAX+1))/2
      LZIMN = IDZ*IMID
c     lsavmin = lzimn+lzimn+nlon+15
c     if(lsave .lt. lsavmin) return

      L1 = MIN0(NLAT, (NLON+1)/2)
      L2 = (NLAT+1)/2
      LWMIN = 4*NLAT*L2 + 3*MAX0(L1-2,0)* (2*NLAT-L1-1) + NLON + 15
      IF (LVHSGC.LT.LWMIN) RETURN

c
c     verify unsaved work space length
c
      MN = MMAX*NLAT*NT
      IF (ITYP.LT.3) THEN
c       no symmetry
          IF (ITYP.EQ.0) THEN
c       br,bi,cr,ci nonzero
              LWKMIN = NLAT* (2*NT*NLON+MAX0(6*IMID,NLON)+1) + 4*MN
          ELSE
c       br,bi or cr,ci zero
              LWKMIN = NLAT* (2*NT*NLON+MAX0(6*IMID,NLON)+1) + 2*MN
          END IF
      ELSE
c     symmetry about equator
          IF (ITYP.EQ.3 .OR. ITYP.EQ.6) THEN
c       br,bi,cr,ci nonzero
              LWKMIN = IMID* (2*NT*NLON+MAX0(6*NLAT,NLON)) + 4*MN + NLAT
          ELSE
c       br,bi or cr,ci zero
              LWKMIN = IMID* (2*NT*NLON+MAX0(6*NLAT,NLON)) + 2*MN + NLAT
          END IF
      END IF
      IF (LWORK.LT.LWKMIN) RETURN
      IERROR = 0
c
c     set work space pointers for vector laplacian coefficients
c
      IF (ITYP.EQ.0 .OR. ITYP.EQ.3 .OR. ITYP.EQ.6) THEN
          IBR = 1
          IBI = IBR + MN
          ICR = IBI + MN
          ICI = ICR + MN
      ELSE IF (ITYP.EQ.1 .OR. ITYP.EQ.4 .OR. ITYP.EQ.7) THEN
          IBR = 1
          IBI = IBR + MN
          ICR = IBI + MN
          ICI = ICR
      ELSE
          IBR = 1
          IBI = 1
          ICR = IBI + MN
          ICI = ICR + MN
      END IF
      IFN = ICI + MN
      IWK = IFN + NLAT
      LIWK = LWORK - 4*MN - NLAT
      CALL DVLAPGC1(NLAT,NLON,ITYP,NT,VLAP,WLAP,IDVW,JDVW,WORK(IBR),
     +             WORK(IBI),WORK(ICR),WORK(ICI),MMAX,WORK(IFN),MDBC,
     +             NDBC,BR,BI,CR,CI,WVHSGC,LVHSGC,WORK(IWK),LIWK,IERROR)
      RETURN
      END

      SUBROUTINE DVLAPGC1(NLAT,NLON,ITYP,NT,VLAP,WLAP,IDVW,JDVW,BRLAP,
     +                   BILAP,CRLAP,CILAP,MMAX,FNN,MDB,NDB,BR,BI,CR,CI,
     +                   WSAVE,LWSAV,WK,LWK,IERROR)
      DOUBLE PRECISION VLAP
      DOUBLE PRECISION WLAP
      DOUBLE PRECISION BRLAP
      DOUBLE PRECISION BILAP
      DOUBLE PRECISION CRLAP
      DOUBLE PRECISION CILAP
      DOUBLE PRECISION FNN
      DOUBLE PRECISION BR
      DOUBLE PRECISION BI
      DOUBLE PRECISION CR
      DOUBLE PRECISION CI
      DOUBLE PRECISION WSAVE
      DOUBLE PRECISION WK
      DOUBLE PRECISION FN
      DIMENSION VLAP(IDVW,JDVW,NT),WLAP(IDVW,JDVW,NT)
      DIMENSION FNN(NLAT),BRLAP(MMAX,NLAT,NT),BILAP(MMAX,NLAT,NT)
      DIMENSION CRLAP(MMAX,NLAT,NT),CILAP(MMAX,NLAT,NT)
      DIMENSION BR(MDB,NDB,NT),BI(MDB,NDB,NT)
      DIMENSION CR(MDB,NDB,NT),CI(MDB,NDB,NT)
      DIMENSION WSAVE(LWSAV),WK(LWK)
c
c     preset coefficient multiplyers
c
      DO 1 N = 2,NLAT
          FN = DBLE(N-1)
          FNN(N) = -FN* (FN+1.D0)
    1 CONTINUE
c
c     set laplacian coefficients from br,bi,cr,ci
c
      IF (ITYP.EQ.0 .OR. ITYP.EQ.3 .OR. ITYP.EQ.6) THEN
c
c     all coefficients needed
c
          DO 2 K = 1,NT
              DO 3 N = 1,NLAT
                  DO 4 M = 1,MMAX
                      BRLAP(M,N,K) = 0.0D0
                      BILAP(M,N,K) = 0.0D0
                      CRLAP(M,N,K) = 0.0D0
                      CILAP(M,N,K) = 0.0D0
    4             CONTINUE
    3         CONTINUE
              DO 5 N = 2,NLAT
                  BRLAP(1,N,K) = FNN(N)*BR(1,N,K)
                  BILAP(1,N,K) = FNN(N)*BI(1,N,K)
                  CRLAP(1,N,K) = FNN(N)*CR(1,N,K)
                  CILAP(1,N,K) = FNN(N)*CI(1,N,K)
    5         CONTINUE
              DO 6 M = 2,MMAX
                  DO 7 N = M,NLAT
                      BRLAP(M,N,K) = FNN(N)*BR(M,N,K)
                      BILAP(M,N,K) = FNN(N)*BI(M,N,K)
                      CRLAP(M,N,K) = FNN(N)*CR(M,N,K)
                      CILAP(M,N,K) = FNN(N)*CI(M,N,K)
    7             CONTINUE
    6         CONTINUE
    2     CONTINUE
      ELSE IF (ITYP.EQ.1 .OR. ITYP.EQ.4 .OR. ITYP.EQ.7) THEN
c
c     vorticity is zero so cr,ci=0 not used
c
          DO 12 K = 1,NT
              DO 13 N = 1,NLAT
                  DO 14 M = 1,MMAX
                      BRLAP(M,N,K) = 0.0D0
                      BILAP(M,N,K) = 0.0D0
   14             CONTINUE
   13         CONTINUE
              DO 15 N = 2,NLAT
                  BRLAP(1,N,K) = FNN(N)*BR(1,N,K)
                  BILAP(1,N,K) = FNN(N)*BI(1,N,K)
   15         CONTINUE
              DO 16 M = 2,MMAX
                  DO 17 N = M,NLAT
                      BRLAP(M,N,K) = FNN(N)*BR(M,N,K)
                      BILAP(M,N,K) = FNN(N)*BI(M,N,K)
   17             CONTINUE
   16         CONTINUE
   12     CONTINUE
      ELSE
c
c     divergence is zero so br,bi=0 not used
c
          DO 22 K = 1,NT
              DO 23 N = 1,NLAT
                  DO 24 M = 1,MMAX
                      CRLAP(M,N,K) = 0.0D0
                      CILAP(M,N,K) = 0.0D0
   24             CONTINUE
   23         CONTINUE
              DO 25 N = 2,NLAT
                  CRLAP(1,N,K) = FNN(N)*CR(1,N,K)
                  CILAP(1,N,K) = FNN(N)*CI(1,N,K)
   25         CONTINUE
              DO 26 M = 2,MMAX
                  DO 27 N = M,NLAT
                      CRLAP(M,N,K) = FNN(N)*CR(M,N,K)
                      CILAP(M,N,K) = FNN(N)*CI(M,N,K)
   27             CONTINUE
   26         CONTINUE
   22     CONTINUE
      END IF
c
c     sythesize coefs into vector field (vlap,wlap)
c
      CALL DVHSGC(NLAT,NLON,ITYP,NT,VLAP,WLAP,IDVW,JDVW,BRLAP,BILAP,
     +           CRLAP,CILAP,MMAX,NLAT,WSAVE,LWSAV,WK,LWK,IERROR)
      RETURN
      END

C
C	$Id: g01dmp.f,v 1.7 2008-07-27 00:21:05 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE G01DMP(IOPT)
C
C  If IOPT = 0 this subroutine dumps the current state of all 
C  attributes.  If IOPT = 1, additionally it dumps out the clipping 
C  indicator, the clipping rectangle, and the color table.
C
C
      include 'g01prm.h'
      include 'g01wdt.h'
      include 'g01wsl.h'
      include 'g01adc.h'
      include 'g01rqa.h'
      include 'g01ast.h'
      include 'g01dfa.h'
      include 'g01io.h'
      include 'g01ins.h'
      include 'g01opc.h'
      include 'gksenu.h'
C
      INTEGER NUMO(2),RERR
      INTEGER ICTMP(3)
C
      IF (IOPT .EQ. 1) THEN
C
C  Clipping indicator, and clip rectangle.
C
        NBYTES = 1+(MEFW-1)/8
        CALL GPUTNI (CLCLIN, IDCLIN, NBYTES, RERR)
        CALL GPUTPR (MRCLIP, MEFW,     1, RERR)
        NBYTES = 1 + (4*MVDCFW-1)/8
        CALL GPUTNI (CLCREC, IDCREC, NBYTES, RERR)
        CALL GPUTPR (MRCREC, MVDCFW,     4, RERR)
C
C  Color table.
C
        DO 10 I=1,MOL
          ICTMP(1) = REAL(MDCCRG)*SRED(I)
          ICTMP(2) = REAL(MDCCRG)*SGREEN(I)
          ICTMP(3) = REAL(MDCCRG)*SBLUE(I)
          NCIX = MCOLI(I)
C
C  Don't copy over background color.
C
          IF (NCIX .EQ. 0) GO TO 10
          NBYTES = 1 + (3*MDCCFW + MCIXFW - 1)/8
          CALL GPUTNI (CLCTBL, IDCTBL, NBYTES, RERR)
          IF (RERR .NE. 0)  RETURN
          CALL GPUTPR (NCIX, MCIXFW, 1, RERR)
          IF (RERR .NE. 0)  RETURN
          CALL GPUTPR (ICTMP, MDCCFW, 3, RERR)
   10   CONTINUE
      ENDIF
C
C  Line bundle index.
C
C     NBYTES = 1+(MIXFW-1)/8
C     CALL GPUTNI (CLLBIX,  IDLBIX,  NBYTES,  RERR)
C     CALL GPUTPR (MRPLIX, MIXFW,  1, RERR)
C     MSPLIX         = MRPLIX
C     VALCHG(IVPLIX) = .FALSE.
C
C  Line type.
C
      NBYTES = 1+(MIXFW-1)/8
      CALL GPUTNI (CLLTYP,  IDLTYP,  NBYTES,  RERR)
      CALL GPUTPR (MRLTYP, MIXFW,  1, RERR)
      MSLTYP = MRLTYP
      VALCHG(IVLTYP) = .FALSE.
C
C  Linewidth scale factor.
C
      NBYTES = 1+(2*MCFPP-1)/8
      CALL GPUTNI (CLLWID,  IDLWID,  NBYTES,  RERR)
      CALL GFLCNV (ARLWSC,NUMO)
      CALL GPUTPR (NUMO, MCFPP,  2, RERR)
      ASLWSC         = ARLWSC
      VALCHG(IVLWSC) = .FALSE.
C
C  Line color index.
C
      NBYTES = 1+(MCIXFW-1)/8
      CALL GPUTNI (CLLCLR, IDLCLR, NBYTES,  RERR)
      CALL GPUTPR (MRPLCI, MCIXFW,  1, RERR)
      MSPLCI         = MRPLCI
      VALCHG(IVPLCI) = .FALSE.
C
C  Marker bundle index.
C
C     NBYTES = 1+(MIXFW-1)/8
C     CALL GPUTNI (CLMBIX, IDMBIX, NBYTES,  RERR)
C     CALL GPUTPR (MRPMIX, MIXFW,  1, RERR)
C     MSPMIX = MRPMIX
C     VALCHG(IVPMIX) = .FALSE.
C
C  Marker type.
C
      NBYTES = 1+(MIXFW-1)/8
      CALL GPUTNI (CLMTYP, IDMTYP,  NBYTES,  RERR)
      CALL GPUTPR (MRMTYP, MIXFW,  1, RERR)
      MSMTYP = MRMTYP
      VALCHG(IVMTYP) = .FALSE.
C
C  Marker size.
C
      NBYTES = 1+(2*MCFPP-1)/8
      CALL GPUTNI (CLMSIZ, IDMSIZ, NBYTES,  RERR)
      CALL GFLCNV (ARMSZS,NUMO)
      CALL GPUTPR (NUMO, MCFPP,  2, RERR)
      ASMSZS = ARMSZS
      VALCHG(IVMSZS) = .FALSE.
C
C  Marker color.
C
      NBYTES = 1+(MCIXFW-1)/8
      CALL GPUTNI (CLMCLR, IDMCLR, NBYTES,  RERR)
      CALL GPUTPR (MRPMCI, MCIXFW,  1, RERR)
      MSPMCI = MRPMCI
      VALCHG(IVPMCI) = .FALSE.
C
C  Text bundle index.
C
C     NBYTES = 1+(MIXFW-1)/8
C     CALL GPUTNI (CLTBIX, IDTBIX, NBYTES, RERR)
C     CALL GPUTPR (MRTXIX, MIXFW, 1, RERR)
C     MSTXIX         = MRTXIX
C     VALCHG(IVTXIX) = .FALSE.
C
C  Text font.
C
      NBYTES = 1+(MEFW-1)/8
      CALL GPUTNI (CLTFON, IDTFON, NBYTES, RERR)
      CALL GPUTPR (MRTXFO, MEFW, 1, RERR)
      MSTXFO         = MRTXFO
      VALCHG(IVTXFO) = .FALSE.
C
C  Text precision.
C
      NBYTES         = 1+(MIXFW-1)/8
      CALL GPUTNI (CLTPRE, IDTPRE, NBYTES, RERR)
      CALL GPUTPR (MRTXPR, MIXFW, 1, RERR)
      MSTXPR         = MRTXPR
      VALCHG(IVTXPR) = .FALSE.
C
C  Character expansion factor.
C
      NBYTES = 1+(2*MCFPP-1)/8
      CALL GPUTNI (CLCHEX, IDCHEX, NBYTES, RERR)
      CALL GFLCNV (ARCHXP, NUMO)
      CALL GPUTPR (NUMO, MCFPP, 2, RERR)
      ASCHXP         = ARCHXP
      VALCHG(IVCHXP) = .FALSE.
C
C  Character spacing.
C
      NBYTES = 1+(2*MCFPP-1)/8
      CALL GPUTNI (CLCHSP, IDCHSP, NBYTES, RERR)
      CALL GFLCNV (ARCHSP, NUMO)
      CALL GPUTPR (NUMO, MCFPP, 2, RERR)
      ASCHSP         = ARCHSP
      VALCHG(IVCHSP) = .FALSE.
C
C  Text color index.
C
      NBYTES = 1+(MCIXFW-1)/8
      CALL GPUTNI (CLTCLR, IDTCLR, NBYTES, RERR)
      CALL GPUTPR (MRTXCI, MCIXFW, 1, RERR)
      MSTXCI         = MRTXCI
      VALCHG(IVTXCI) = .FALSE.
C
C  Text path.
C
      NBYTES = 1+(MEFW-1)/8
      CALL GPUTNI (CLTXPA, IDTXPA, NBYTES, RERR)
      CALL GPUTPR (MRTXP , MEFW,  1, RERR)
      MSTXP         = MRTXP
      VALCHG(IVTXP) = .FALSE.
C
C  Text alignment.
C
      NBYTES = 1+(2*MEFW + 4*MCFPP - 1)/8
      CALL GPUTNI (CLTXAL, IDTXAL, NBYTES, RERR)
      CALL GPUTPR (MRTXAL, MEFW, 2, RERR)
      NUMO(1) = 0
      NUMO(2) = 0
      CALL GPUTPR (NUMO, MCFPP, 2, RERR)
      CALL GPUTPR (NUMO, MCFPP, 2, RERR)
      MSTXAL(1)      = MRTXAL(1)
      MSTXAL(2)      = MRTXAL(2)
      VALCHG(IVTXAL) = .FALSE.
C
C  Character height.
C
      NBYTES = 1+(MVDCFW-1)/8
      CALL GPUTNI (CLCHHT, IDCHHT, NBYTES, RERR)
      CALL GPUTPR (MRCHH, MVDCFW,  1, RERR)
      MSCHH         = MRCHH
      VALCHG(IVCHH) = .FALSE.
C
C  Character up vector.
C
      NBYTES = 1+(4*MVDCFW-1)/8
      CALL GPUTNI (CLCHOR, IDCHOR, NBYTES, RERR)
      CALL GPUTPR (MRCHOV(1) , MVDCFW,  4, RERR)
      MSCHOV(1)      = MRCHOV(1)
      MSCHOV(2)      = MRCHOV(2)
      MSCHOV(3)      = MRCHOV(3)
      MSCHOV(4)      = MRCHOV(4)
      VALCHG(IVCHOV) = .FALSE.
C
C  Fill bundle index (currently disabled).
C
C      NBYTES = 1+(MIXFW-1)/8
C      CALL GPUTNI (CLFBIX, IDFBIX,  NBYTES,  RERR)
C      CALL GPUTPR (MRFAIX, MIXFW,  1, RERR)
C      MSFAIX = MRFAIX
C      VALCHG(IVFAIX) = .FALSE.
C
C  Fill area interior style.
C
       NBYTES = 1+(MEFW-1)/8
       CALL GPUTNI (CLINTS, IDINTS, NBYTES,  RERR)
       CALL GPUTPR (MRFAIS, MEFW,  1, RERR)
       MSFAIS = MRFAIS
       VALCHG(IVFAIS) = .FALSE.
C
C  Fill area style index--pattern index (currently disabled) 
C                         and hatch index.
C
       NBYTES = 1+(MIXFW-1)/8
       CALL GPUTNI (CLHAIX, IDHAIX, NBYTES,  RERR)
       CALL GPUTPR (MRFASI, MIXFW, 1, RERR)
C      CALL GPUTNI (CLPTIX, IDPTIX, NBYTES,  RERR)
C      CALL GPUTPR (MRFASI, MIXFW, 1, RERR)
       MSFASI = MRFASI
       VALCHG(IVFASI) = .FALSE.
C
C  Fill area color index.
C
       NBYTES = 1+(MCIXFW-1)/8
       CALL GPUTNI (CLFCLR, IDFCLR, NBYTES, RERR)
       CALL GPUTPR (MRFACI, MCIXFW,  1, RERR)
       MSFACI = MRFACI
       VALCHG(IVFACI) = .FALSE.
C
C  Pattern size (currently disabled).
C
C      NBYTES = 1+(4*MVDCFW-1)/8
C      CALL GPUTNI (CLPTSZ, IDPTSZ, NBYTES, RERR)
C      CALL GPUTPR (MRPASZ(1) , MVDCFW,  4, RERR)
C      MSPASZ(1) = MRPASZ(1)
C      MSPASZ(2) = MRPASZ(2)
C      MSPASZ(3) = MRPASZ(3)
C      MSPASZ(4) = MRPASZ(4)
C      VALCHG(IVPASZ) = .FALSE.
C
C  Pattern reference point (currently disabled).
C
C      NBYTES = 1+(2*MVDCFW-1)/8
C      CALL GPUTNI (CLFRPT, IDFRPT, NBYTES, RERR)
C      CALL GPUTPR (MRPARF(1), MVDCFW, 2, RERR)
C      MSPARF(1) = MRPARF(1)
C      MSPARF(2) = MRPARF(2)
C      VALCHG(IVPARF) = .FALSE.
C
C  Aspect source flags.
C
      CALL G01SAS (1, RERR)
      CALL G01SAS (2, RERR)
      CALL G01SAS (3, RERR)
      CALL G01SAS (4, RERR)
C
C  Clear aggregate change variable.
C
      AGPEND(1) = .FALSE.
      AGPEND(2) = .FALSE.
      AGPEND(3) = .FALSE.
      AGPEND(4) = .FALSE.
C
      RETURN
      END

      PROGRAM TSETER
C
C This test program demonstrates minimal functioning of the error-
C handling package used by NCAR Graphics.  It first produces a single
C frame showing what output print lines to expect and then steps
C through a simple set of tests that should produce those print lines.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
        PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Make required character-variable declarations.  ERMSG receives the
C error message returned by the character function SEMESS.
C
        CHARACTER*113 ERMSG,SEMESS
C
C The contents of the array LINE defines the lines of print that this
C program should produce.
C
        CHARACTER*60 LINE(40)
C
        DATA (LINE(I),I=1,10) /
     +  ' ' ,
     +  'PROGRAM TSETER EXECUTING' ,
     +  ' ' ,
     +  'TSETER - CALL ENTSR TO ENTER RECOVERY MODE' ,
     +  ' ' ,
     +  'TSETER - CALL SETER TO REPORT RECOVERABLE ERROR 1' ,
     +  ' ' ,
     +  'TSETER - CALL ERROF TO TURN OFF INTERNAL ERROR FLAG' ,
     +  ' ' ,
     +  'TSETER - CALL SETER TO REPORT RECOVERABLE ERROR 2' /
C
        DATA (LINE(I),I=11,20) /
     +  ' ' ,
     +  'TSETER - EXECUTE STATEMENT ''IERRO=NERRO(JERRO)''' ,
     +  'TSETER - RESULTING IERRO:             2' ,
     +  'TSETER - RESULTING JERRO:             2' ,
     +  ' ' ,
     +  'TSETER - EXECUTE STATEMENT ''ERMSG=SEMESS(0)''' ,
     +  'TSETER - RESULTING ERMSG:  ROUTINE_NAME_2 - ERROR_MESSAGE_2' ,
     +  'TSETER - (PRINTING ABOVE LINE ALSO TESTED ICLOEM)' ,
     +  ' ' ,
     +  'TSETER - CALL EPRIN TO PRINT CURRENT ERROR MESSAGE' /
C
        DATA (LINE(I),I=21,30) /
     +  'ERROR    2 IN ROUTINE_NAME_2 - ERROR_MESSAGE_2' ,
     +  'TSETER - (AN ERROR MESSAGE SHOULD HAVE BEEN PRINTED)' ,
     +  ' ' ,
     +  'TSETER - CALL ERROF TO TURN OFF INTERNAL ERROR FLAG' ,
     +  ' ' ,
     +  'TSETER - CALL EPRIN TO PRINT CURRENT ERROR MESSAGE' ,
     +  'TSETER - (NOTHING SHOULD HAVE BEEN PRINTED)' ,
     +  ' ' ,
     +  'TSETER - CALL SETER TO REPORT RECOVERABLE ERROR 3' ,
     +  ' ' /
C
        DATA (LINE(I),I=31,40) /
     +  'TSETER - TEST THE USE OF ICFELL' ,
     +  ' ' ,
     +  'TSETER - CALL RETSR TO LEAVE RECOVERY MODE - BECAUSE' ,
     +  'TSETER - THE LAST RECOVERABLE ERROR WAS NOT CLEARED,' ,
     +  'TSETER - THIS WILL CAUSE A FATAL-ERROR CALL TO SETER' ,
     +  'ERROR    3 IN SETER - AN UNCLEARED PRIOR ERROR EXISTS' ,
     +  '... MESSAGE FOR UNCLEARED PRIOR ERROR IS AS FOLLOWS:' ,
     +  '... ERROR    6 IN SETER/ROUTINE_NAME_3 - ERROR_MESSAGE_3' ,
     +  '... MESSAGE FOR CURRENT CALL TO SETER IS AS FOLLOWS:' ,
     +  '... ERROR    2 IN RETSR - PRIOR ERROR IS NOW UNRECOVERABLE' /
C
C Open GKS.
C
        CALL GOPKS (IERRF, ISZDM)
        CALL GOPWK (IWKID, LUNIT, IWTYPE)
        CALL GACWK (IWKID)
C
C Produce a single frame of output, detailing what the program ought to
C print.
C
        CALL SET    (0.,1.,0.,1.,0.,1.,0.,1.,1)
C
        CALL PCSETC ('FC - FUNCTION CODE SIGNAL',CHAR(0))
C
        CALL PCSETI ('FN - FONT NUMBER',26)
C
        CALL PLCHHQ (.5,.975,'SETER TEST "tseter"',.025,0.,0.)
C
        CALL PCSETI ('FN - FONT NUMBER',1)
C
        CALL PLCHHQ (.5,.925,'See the print output; it should consist of
     + the following lines:',.011,0.,0.)
C
        DO 101 I=1,40
          CALL PLCHHQ (.15,.9-REAL(I-1)*.022,LINE(I),.011,0.,-1.)
  101   CONTINUE
C
C Advance the frame.
C
        CALL FRAME
C
C Close GKS.
C
        CALL GDAWK (IWKID)
        CALL GCLWK (IWKID)
        CALL GCLKS
C
C Enter recovery mode.
C
        PRINT * , ' '
        PRINT * , 'PROGRAM TSETER EXECUTING'
        PRINT * , ' '
        PRINT * , 'TSETER - CALL ENTSR TO ENTER RECOVERY MODE'
C
        CALL ENTSR (IROLD,1)
C
C Log a recoverable error.  Nothing should be printed, but the internal
C error flag should be set and the message should be remembered.
C
        PRINT * , ' '
        PRINT * , 'TSETER - CALL SETER TO REPORT RECOVERABLE ERROR 1'
C
        CALL SETER ('ROUTINE_NAME_1 - ERROR_MESSAGE_1',1,1)
C
C Clear the internal error flag.
C
        PRINT * , ' '
        PRINT * , 'TSETER - CALL ERROF TO TURN OFF INTERNAL ERROR FLAG'
C
        CALL ERROF
C
C Log another recoverable error.  Again, nothing should be printed, but
C the internal error flag should be set and the message should be
C remembered.
C
        PRINT * , ' '
        PRINT * , 'TSETER - CALL SETER TO REPORT RECOVERABLE ERROR 2'
C
        CALL SETER ('ROUTINE_NAME_2 - ERROR_MESSAGE_2',2,1)
C
C Pick up and print the error flag, as returned in each of two
C ways by the function NERRO.
C
        PRINT * , ' '
        PRINT * , 'TSETER - EXECUTE STATEMENT ''IERRO=NERRO(JERRO)'''
C
        IERRO=NERRO(JERRO)
C
        PRINT * , 'TSETER - RESULTING IERRO:  ',IERRO
        PRINT * , 'TSETER - RESULTING JERRO:  ',JERRO
C
C Pick up and print the error message, as returned by the function
C SEMESS.  This also tests proper functioning of the function ICLOEM.
C
        PRINT * , ' '
        PRINT * , 'TSETER - EXECUTE STATEMENT ''ERMSG=SEMESS(0)'''
C
        ERMSG=SEMESS(0)
C
        PRINT * , 'TSETER - RESULTING ERMSG:  ',ERMSG(1:ICLOEM(ERMSG))
        PRINT * , 'TSETER - (PRINTING ABOVE LINE ALSO TESTED ICLOEM)'
C
C Print the current error message.
C
        PRINT * , ' '
        PRINT * , 'TSETER - CALL EPRIN TO PRINT CURRENT ERROR MESSAGE'
C
        CALL EPRIN
C
        PRINT * , 'TSETER - (AN ERROR MESSAGE SHOULD HAVE BEEN PRINTED)'
C
C Clear the internal error flag again.
C
        PRINT * , ' '
        PRINT * , 'TSETER - CALL ERROF TO TURN OFF INTERNAL ERROR FLAG'
C
        CALL ERROF
C
C Try to print the error message again.  Nothing should be printed.
C
        PRINT * , ' '
        PRINT * , 'TSETER - CALL EPRIN TO PRINT CURRENT ERROR MESSAGE'
C
        CALL EPRIN
C
        PRINT * , 'TSETER - (NOTHING SHOULD HAVE BEEN PRINTED)'
C
C Log another recoverable error.
C
        PRINT * , ' '
        PRINT * , 'TSETER - CALL SETER TO REPORT RECOVERABLE ERROR 3'
C
        CALL SETER ('ROUTINE_NAME_3 - ERROR_MESSAGE_3',5,1)
C
C Test the use of ICFELL.
C
        PRINT * , ' '
        PRINT * , 'TSETER - TEST THE USE OF ICFELL'
C
        IF (ICFELL('TSETER',6).NE.5) THEN
          PRINT * , ' '
          PRINT * , 'TSETER - ICFELL MALFUNCTIONED - SOMETHING''S WRONG'
          STOP
        END IF
C
C Turn recovery mode off without clearing the internal error flag,
C which should be treated as a fatal error.
C
        PRINT * , ' '
        PRINT * , 'TSETER - CALL RETSR TO LEAVE RECOVERY MODE - BECAUSE'
        PRINT * , 'TSETER - THE LAST RECOVERABLE ERROR WAS NOT CLEARED,'
        PRINT * , 'TSETER - THIS WILL CAUSE A FATAL-ERROR CALL TO SETER'
C
        CALL RETSR (IROLD)
C
C Control should never get to the next statement, but just in case ...
C
        PRINT * , ' '
        PRINT * , 'TSETER - GOT CONTROL BACK - SOMETHING''S WRONG'
C
        STOP
C
      END

      SUBROUTINE ZLARGV( N, X, INCX, Y, INCY, C, INCC )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      INTEGER            INCC, INCX, INCY, N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   C( * )
      COMPLEX*16         X( * ), Y( * )
*     ..
*
*  Purpose
*  =======
*
*  ZLARGV generates a vector of complex plane rotations with real
*  cosines, determined by elements of the complex vectors x and y.
*  For i = 1,2,...,n
*
*     (        c(i)   s(i) ) ( x(i) ) = ( r(i) )
*     ( -conjg(s(i))  c(i) ) ( y(i) ) = (   0  )
*
*     where c(i)**2 + ABS(s(i))**2 = 1
*
*  The following conventions are used (these are the same as in ZLARTG,
*  but differ from the BLAS1 routine ZROTG):
*     If y(i)=0, then c(i)=1 and s(i)=0.
*     If x(i)=0, then c(i)=0 and s(i) is chosen so that r(i) is real.
*
*  Arguments
*  =========
*
*  N       (input) INTEGER
*          The number of plane rotations to be generated.
*
*  X       (input/output) COMPLEX*16 array, dimension (1+(N-1)*INCX)
*          On entry, the vector x.
*          On exit, x(i) is overwritten by r(i), for i = 1,...,n.
*
*  INCX    (input) INTEGER
*          The increment between elements of X. INCX > 0.
*
*  Y       (input/output) COMPLEX*16 array, dimension (1+(N-1)*INCY)
*          On entry, the vector y.
*          On exit, the sines of the plane rotations.
*
*  INCY    (input) INTEGER
*          The increment between elements of Y. INCY > 0.
*
*  C       (output) DOUBLE PRECISION array, dimension (1+(N-1)*INCC)
*          The cosines of the plane rotations.
*
*  INCC    (input) INTEGER
*          The increment between elements of C. INCC > 0.
*
*  Further Details
*  ======= =======
*
*  6-6-96 - Modified with a new algorithm by W. Kahan and J. Demmel
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   TWO, ONE, ZERO
      PARAMETER          ( TWO = 2.0D+0, ONE = 1.0D+0, ZERO = 0.0D+0 )
      COMPLEX*16         CZERO
      PARAMETER          ( CZERO = ( 0.0D+0, 0.0D+0 ) )
*     ..
*     .. Local Scalars ..
      LOGICAL            FIRST
      INTEGER            COUNT, I, IC, IX, IY, J
      DOUBLE PRECISION   CS, D, DI, DR, EPS, F2, F2S, G2, G2S, SAFMIN,
     $                   SAFMN2, SAFMX2, SCALE
      COMPLEX*16         F, FF, FS, G, GS, R, SN
*     ..
*     .. External Functions ..
      DOUBLE PRECISION   DLAMCH, DLAPY2
      EXTERNAL           DLAMCH, DLAPY2
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, DBLE, DCMPLX, DCONJG, DIMAG, INT, LOG,
     $                   MAX, SQRT
*     ..
*     .. Statement Functions ..
      DOUBLE PRECISION   ABS1, ABSSQ
*     ..
*     .. Save statement ..
      SAVE               FIRST, SAFMX2, SAFMIN, SAFMN2
*     ..
*     .. Data statements ..
      DATA               FIRST / .TRUE. /
*     ..
*     .. Statement Function definitions ..
      ABS1( FF ) = MAX( ABS( DBLE( FF ) ), ABS( DIMAG( FF ) ) )
      ABSSQ( FF ) = DBLE( FF )**2 + DIMAG( FF )**2
*     ..
*     .. Executable Statements ..
*
      IF( FIRST ) THEN
         FIRST = .FALSE.
         SAFMIN = DLAMCH( 'S' )
         EPS = DLAMCH( 'E' )
         SAFMN2 = DLAMCH( 'B' )**INT( LOG( SAFMIN / EPS ) /
     $            LOG( DLAMCH( 'B' ) ) / TWO )
         SAFMX2 = ONE / SAFMN2
      END IF
      IX = 1
      IY = 1
      IC = 1
      DO 60 I = 1, N
         F = X( IX )
         G = Y( IY )
*
*        Use identical algorithm as in ZLARTG
*
         SCALE = MAX( ABS1( F ), ABS1( G ) )
         FS = F
         GS = G
         COUNT = 0
         IF( SCALE.GE.SAFMX2 ) THEN
   10       CONTINUE
            COUNT = COUNT + 1
            FS = FS*SAFMN2
            GS = GS*SAFMN2
            SCALE = SCALE*SAFMN2
            IF( SCALE.GE.SAFMX2 )
     $         GO TO 10
         ELSE IF( SCALE.LE.SAFMN2 ) THEN
            IF( G.EQ.CZERO ) THEN
               CS = ONE
               SN = CZERO
               R = F
               GO TO 50
            END IF
   20       CONTINUE
            COUNT = COUNT - 1
            FS = FS*SAFMX2
            GS = GS*SAFMX2
            SCALE = SCALE*SAFMX2
            IF( SCALE.LE.SAFMN2 )
     $         GO TO 20
         END IF
         F2 = ABSSQ( FS )
         G2 = ABSSQ( GS )
         IF( F2.LE.MAX( G2, ONE )*SAFMIN ) THEN
*
*           This is a rare case: F is very small.
*
            IF( F.EQ.CZERO ) THEN
               CS = ZERO
               R = DLAPY2( DBLE( G ), DIMAG( G ) )
*              Do complex/real division explicitly with two real
*              divisions
               D = DLAPY2( DBLE( GS ), DIMAG( GS ) )
               SN = DCMPLX( DBLE( GS ) / D, -DIMAG( GS ) / D )
               GO TO 50
            END IF
            F2S = DLAPY2( DBLE( FS ), DIMAG( FS ) )
*           G2 and G2S are accurate
*           G2 is at least SAFMIN, and G2S is at least SAFMN2
            G2S = SQRT( G2 )
*           Error in CS from underflow in F2S is at most
*           UNFL / SAFMN2 .lt. sqrt(UNFL*EPS) .lt. EPS
*           If MAX(G2,ONE)=G2, then F2 .lt. G2*SAFMIN,
*           and so CS .lt. sqrt(SAFMIN)
*           If MAX(G2,ONE)=ONE, then F2 .lt. SAFMIN
*           and so CS .lt. sqrt(SAFMIN)/SAFMN2 = sqrt(EPS)
*           Therefore, CS = F2S/G2S / sqrt( 1 + (F2S/G2S)**2 ) = F2S/G2S
            CS = F2S / G2S
*           Make sure abs(FF) = 1
*           Do complex/real division explicitly with 2 real divisions
            IF( ABS1( F ).GT.ONE ) THEN
               D = DLAPY2( DBLE( F ), DIMAG( F ) )
               FF = DCMPLX( DBLE( F ) / D, DIMAG( F ) / D )
            ELSE
               DR = SAFMX2*DBLE( F )
               DI = SAFMX2*DIMAG( F )
               D = DLAPY2( DR, DI )
               FF = DCMPLX( DR / D, DI / D )
            END IF
            SN = FF*DCMPLX( DBLE( GS ) / G2S, -DIMAG( GS ) / G2S )
            R = CS*F + SN*G
         ELSE
*
*           This is the most common case.
*           Neither F2 nor F2/G2 are less than SAFMIN
*           F2S cannot overflow, and it is accurate
*
            F2S = SQRT( ONE+G2 / F2 )
*           Do the F2S(real)*FS(complex) multiply with two real
*           multiplies
            R = DCMPLX( F2S*DBLE( FS ), F2S*DIMAG( FS ) )
            CS = ONE / F2S
            D = F2 + G2
*           Do complex/real division explicitly with two real divisions
            SN = DCMPLX( DBLE( R ) / D, DIMAG( R ) / D )
            SN = SN*DCONJG( GS )
            IF( COUNT.NE.0 ) THEN
               IF( COUNT.GT.0 ) THEN
                  DO 30 J = 1, COUNT
                     R = R*SAFMX2
   30             CONTINUE
               ELSE
                  DO 40 J = 1, -COUNT
                     R = R*SAFMN2
   40             CONTINUE
               END IF
            END IF
         END IF
   50    CONTINUE
         C( IC ) = CS
         Y( IY ) = SN
         X( IX ) = R
         IC = IC + INCC
         IY = IY + INCY
         IX = IX + INCX
   60 CONTINUE
      RETURN
*
*     End of ZLARGV
*
      END

C
C      $Id: xy02f.f,v 1.16 2010-03-15 22:49:25 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C                Copyright (C)  1995                                   C
C        University Corporation for Atmospheric Research               C
C                All Rights Reserved                                   C
C                                                                      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C  File:       xy02f.f
C
C  Author:     Mary Haley
C          National Center for Atmospheric Research
C          PO 3000, Boulder, Colorado
C
C  Date:       Wed Feb  8 11:44:39 MST 1995
C
C  Description:    This program shows how to create an XyPlot object
C                  and how to tweak some of the XyPlot resources to
C                  change the appearance of the plot.  A resource file
C                  is used to change the resources.
C
C                  The "CoordArrays" object is used to set up the data.
C
      external NhlFAppClass
      external NhlFCairoWindowWorkstationClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFXyPlotClass
      external NhlFCoordArraysClass
C
C Define the number of points in the curve.
C
      parameter(NPTS=500)
      parameter(PI100=.031415926535898)

      integer appid,xworkid,plotid,dataid
      integer rlist, i
      real   ydra(NPTS), theta
      CHARACTER*7  wks_type
C
C Define the workstation type
C
      wks_type = "x11"
C
C
C Initialize some data for the XyPlot object.
C
      do 10 i = 1,NPTS
         theta = PI100*real(i-1)
         ydra(i) = 500.+.9*real(i-1)*sin(theta)
 10   continue
C
C Initialize the HLU library and set up resource template.
C
      call NhlFInitialize
      call NhlFRLCreate(rlist,'setrl')
C
C Create Application object.  The Application object name is used to
C determine the name of the resource file, which is "xy02.res" in
C this case.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'appDefaultParent','True',ierr)
      call NhlFRLSetString(rlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'xy02',NhlFAppClass,0,rlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkMetaName','./xy02f.ncgm',ierr)
         call NhlFCreate(xworkid,'xy02Work',
     +        NhlFNcgmWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X11 workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPause','True',ierr)
         call NhlFCreate(xworkid,'xy02Work',
     +        NhlFCairoWindowWorkstationClass,
     +        0,rlist,ierr)
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PS workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPSFileName','./xy02f.ps',ierr)
         call NhlFCreate(xworkid,'xy02Work',
     +        NhlFPSWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPDFFileName','./xy02f.pdf',ierr)
         call NhlFCreate(xworkid,'xy02Work',
     +        NhlFPDFWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFileName','./xy02f',ierr)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(xworkid,'xy02Work',
     +        NhlFcairoPSPDFWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFileName','./xy02f',ierr)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(xworkid,'xy02Work',
     +        NhlFcairoImageWorkstationClass,0,rlist,ierr)
      endif
C
C Define the data object.  Since only the Y values are specified here,
C each Y value will be paired with its integer array index.  The id
C for this object will later be used as the value for the XyPlot object
C resource, "xyCoordData".
C
      call NhlFRLClear(rlist)
      call NhlFRLSetFloatArray(rlist,'caYArray',ydra,NPTS,ierr)
      call NhlFCreate(dataid,'xyData',NhlFCoordArraysClass,
     +                0,rlist,ierr)
C
C Create the XyPlot object which is created as a child of the
C XWorkstation object.  The resources that are being changed are done
C in the "xy02.res" file.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetInteger(rlist,'xyCoordData',dataid,ierr)
      call NhlFCreate(plotid,'xyPlot',NhlFXyPlotClass,xworkid,
     +                rlist,ierr)
C
C Draw the plot.
C
      call NhlFDraw(plotid,ierr)
      call NhlFFrame(xworkid,ierr)
C
C NhlDestroy destroys the given id and all of its children
C so destroying "xworkid" will also destroy plotid".
C
      call NhlFRLDestroy(rlist)
      call NhlFDestroy(xworkid,ierr)
      call NhlFDestroy(appid,ierr)
C
C Restores state.
C
      call NhlFClose
      stop
      end

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C   FFTPACK 5.0
C   Copyright (C) 1995-2004, Scientific Computing Division,
C   University Corporation for Atmospheric Research
C   Licensed under the GNU General Public License (GPL)
C
C   Authors:  Paul N. Swarztrauber and Richard A. Valent
C
C   $Id: sintmf.f,v 1.2 2006-11-21 01:10:20 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      SUBROUTINE DSINTMF(LOT,JUMP,N,INC,X,LENX,WSAVE,LENSAV,WORK,
     +                  LENWRK,IER)
      INTEGER LOT,JUMP,N,INC,LENX,LENSAV,LENWRK,IER
      DOUBLE PRECISION X(INC,*),WSAVE(LENSAV),WORK(LENWRK)
      LOGICAL DXERCON
C
      IER = 0
C
      IF (LENX.LT. (LOT-1)*JUMP+INC* (N-1)+1) THEN
          IER = 1
          CALL DXERFFT('SINTMF',6)
          GO TO 100
      ELSE IF (LENSAV.LT.N/2+N+INT(LOG(DBLE(N)))+4) THEN
          IER = 2
          CALL DXERFFT('SINTMF',8)
          GO TO 100
      ELSE IF (LENWRK.LT.LOT* (2*N+4)) THEN
          IER = 3
          CALL DXERFFT('SINTMF',10)
          GO TO 100
      ELSE IF (.NOT.DXERCON(INC,JUMP,N,LOT)) THEN
          IER = 4
          CALL DXERFFT('SINTMF',-1)
          GO TO 100
      END IF
C
      IW1 = LOT + LOT + 1
      IW2 = IW1 + LOT* (N+1)
      CALL DMSNTF1(LOT,JUMP,N,INC,X,WSAVE,WORK,WORK(IW1),WORK(IW2),IER1)
      IF (IER1.NE.0) THEN
          IER = 20
          CALL DXERFFT('SINTMF',-5)
      END IF
  100 CONTINUE
      RETURN
      END

C
C	$Id: gwptpr.f,v 1.5 2008-07-27 00:21:08 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GWPTPR (BUFFER,BITS,COUNT,GKSERR)
C
C  Put the operand string into the segment buffer.
C
C  INPUT
C    BUFFER -- List of operands to move.
C    BITS   -- Precision of the operands.
C    COUNT  -- Number of operands in the buffer.
C
C  OUTPUT
C    GKSERR -- Error status.
C
C  All data is type integer unless otherwise indicated.
C
      IMPLICIT INTEGER (A-Z)
      DIMENSION BUFFER(*)
C
C  Operand and instruction communication.
C
      include 'gwiins.h'
C
      SAVE
C
      DATA ALLOK /0/
C
      CTEMP = COUNT
      STRT = 1
C
   10 CONTINUE
C
C  Determine the number of operand words left in the current partition.
C
      WCBYT = (MCCBYT*8)/BITS
C
C  Compute and move the allowed number of operands.
C
      MOVIT = MIN(WCBYT,CTEMP)
      CALL GWILOD(BUFFER(STRT),BITS,MOVIT,GKSERR)
      IF (GKSERR .NE. ALLOK) RETURN
C
C  Check if another partition has to be started.
C
      CTEMP = CTEMP - MOVIT
      MCCBYT = MCCBYT - (MOVIT*BITS)/8
      IF (CTEMP .NE. 0) THEN
C
C  New partition required so set up the instruction.
C
        STRT = STRT + MOVIT
C
C  Take remainder of bytes left in current partition (they must be used).
C
        TCBYT = MCNBYT + MCCBYT
        CALL GWPART(TCBYT,GKSERR)
        IF (GKSERR .NE. ALLOK) RETURN
C
C  Move more operands into new partition.
C
        GO TO 10
      END IF
C
      RETURN
      END

      SUBROUTINE DPPSV( UPLO, N, NRHS, AP, B, LDB, INFO )
*
*  -- LAPACK driver routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     March 31, 1993
*
*     .. Scalar Arguments ..
      CHARACTER          UPLO
      INTEGER            INFO, LDB, N, NRHS
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   AP( * ), B( LDB, * )
*     ..
*
*  Purpose
*  =======
*
*  DPPSV computes the solution to a real system of linear equations
*     A * X = B,
*  where A is an N-by-N symmetric positive definite matrix stored in
*  packed format and X and B are N-by-NRHS matrices.
*
*  The Cholesky decomposition is used to factor A as
*     A = U**T* U,  if UPLO = 'U', or
*     A = L * L**T,  if UPLO = 'L',
*  where U is an upper triangular matrix and L is a lower triangular
*  matrix.  The factored form of A is then used to solve the system of
*  equations A * X = B.
*
*  Arguments
*  =========
*
*  UPLO    (input) CHARACTER*1
*          = 'U':  Upper triangle of A is stored;
*          = 'L':  Lower triangle of A is stored.
*
*  N       (input) INTEGER
*          The number of linear equations, i.e., the order of the
*          matrix A.  N >= 0.
*
*  NRHS    (input) INTEGER
*          The number of right hand sides, i.e., the number of columns
*          of the matrix B.  NRHS >= 0.
*
*  AP      (input/output) DOUBLE PRECISION array, dimension (N*(N+1)/2)
*          On entry, the upper or lower triangle of the symmetric matrix
*          A, packed columnwise in a linear array.  The j-th column of A
*          is stored in the array AP as follows:
*          if UPLO = 'U', AP(i + (j-1)*j/2) = A(i,j) for 1<=i<=j;
*          if UPLO = 'L', AP(i + (j-1)*(2n-j)/2) = A(i,j) for j<=i<=n.
*          See below for further details.
*
*          On exit, if INFO = 0, the factor U or L from the Cholesky
*          factorization A = U**T*U or A = L*L**T, in the same storage
*          format as A.
*
*  B       (input/output) DOUBLE PRECISION array, dimension (LDB,NRHS)
*          On entry, the N-by-NRHS right hand side matrix B.
*          On exit, if INFO = 0, the N-by-NRHS solution matrix X.
*
*  LDB     (input) INTEGER
*          The leading dimension of the array B.  LDB >= max(1,N).
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*          > 0:  if INFO = i, the leading minor of order i of A is not
*                positive definite, so the factorization could not be
*                completed, and the solution has not been computed.
*
*  Further Details
*  ===============
*
*  The packed storage scheme is illustrated by the following example
*  when N = 4, UPLO = 'U':
*
*  Two-dimensional storage of the symmetric matrix A:
*
*     a11 a12 a13 a14
*         a22 a23 a24
*             a33 a34     (aij = conjg(aji))
*                 a44
*
*  Packed storage of the upper triangle of A:
*
*  AP = [ a11, a12, a22, a13, a23, a33, a14, a24, a34, a44 ]
*
*  =====================================================================
*
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           DPPTRF, DPPTRS, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      IF( .NOT.LSAME( UPLO, 'U' ) .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( NRHS.LT.0 ) THEN
         INFO = -3
      ELSE IF( LDB.LT.MAX( 1, N ) ) THEN
         INFO = -6
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DPPSV ', -INFO )
         RETURN
      END IF
*
*     Compute the Cholesky factorization A = U'*U or A = L*L'.
*
      CALL DPPTRF( UPLO, N, AP, INFO )
      IF( INFO.EQ.0 ) THEN
*
*        Solve the system A*X = B, overwriting B with X.
*
         CALL DPPTRS( UPLO, N, NRHS, AP, B, LDB, INFO )
*
      END IF
      RETURN
*
*     End of DPPSV
*
      END

C
C	$Id: pwritx.f,v 1.7 2009-08-06 20:55:14 fred Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE PWRITX(X,Y,IDPC,NCHAR,JSIZE,JOR,JCTR)
C
C SUBROUTINE PWRITX (X,Y,IDPC,NCHAR,JSIZE,JOR,JCTR)
C
C LATEST REVISION        October, 1988
C
C PURPOSE                PWRITX is a character plotting routine.  It
C                        produces high quality characters for annotating
C                        graphs, making movie titles, etc.
C
C USAGE                  CALL PWRITX (X,Y,IDPC,NCHAR,JSIZE,JOR,JCTR)
C
C ARGUMENTS
C
C COMMON BLOCK PUSER     By default PWRITX uses the complex character
C                        set.  A complete list of the characters
C                        contained in this font appears as the
C                        output from the PWRITX demo driver in
C                        the Examples section of the current
C                        graphics manual.  PWRITX can be made to
C                        access one other font, called the duplex
C                        character set.  The characters in the
C                        duplex font are somewhat simpler in
C                        appearance (no serifs, fewer curves, etc.),
C                        but are still of high-quality.  Only the
C                        alphanumeric characters in the duplex
C                        font are different from the alphanumeric
C                        characters in the complex font.  All other
C                        characters remain the same.  To make
C                        PWRITX access the duplex character set, the user
C                        has to define in his main program a common block
C                        PUSER containing 1 integer variable. If this
C                        variable is initialized to 1 before the first
C                        call to PWRITX, the duplex character set is
C                        used by PWRITX.
C
C                        For example:
C
C                               .
C                               .
C                               .
C
C                        COMMON /PUSER/ MODE
C
C                               .
C                               .
C                               .
C
C                        MODE = 1
C
C                               .
C                               .
C                               .
C
C                        CALL PWRITX(.................)
C
C                               .
C                               .
C                               .
C
C                        NOTES
C                          The character set cannot be changed after
C                          the first call to PWRITX.  To produce
C                          examples of the duplex character set,
C                          run the demo driver for pwritx (as supplied)
C                          with MODE set to 1 as described above.
C                          The demo driver for PWRITX also serves
C                          for examples of PWRITX calls (particularly
C                          the final plot.)
C
C ON INPUT               X,Y
C                          Positioning coordinates for the characters to
C                          be drawn.  These are world coordinates.  See
C                          JCTR.
C
C                        IDPC
C                          Characters to be drawn and FUNCTION CODES
C                          (see below.)   IDPC is TYPE CHARACTER.
C
C                        NCHAR
C                          The number of characters in IDPC, including
C                          characters to be drawn and function codes.
C
C                        JSIZE
C                          Size of the character.
C                          . If between 0 and 3, it is 1., 1.5, 2.,
C                            or 3. times digitized character width.
C                            (See  FUNCTION CODES  below for these
C                             sizes.)
C                          . If greater than 3 it is the desired plotter
C                            address units for principal character
C                            height, i.e. principal characters will be
C                            JSIZE plotter address units high, and
C                            indexical and cartographic characters will
C                            be scaled proportionally, such that
C
C                             Indexical = (13/21)*JSIZE  PLA units high
C                          Cartographic = (9/21)*JSIZE  PLA units high
C
C                        JOR
C                          Character string orientation in degrees
C                          counter-clockwise from the positive X axis.
C
C                        JCTR
C                          Centering option.
C                          = 0  (X,Y) is the center of the entire
C                                     string.
C                          = -1 (X,Y) is the center of the left edge of
C                                     the first character.
C                          = 1  (X,Y) is the center of the right edge of
C                                     the last character.
C
C ON OUTPUT              All arguments are unchanged.
C
C FUNCTION CODES         Function codes may be included in the character
C                        string IDPC to change font, case, etc. within a
C                        string of text.  All function instructions must
C                        be enclosed in apostrophes.
C                        No punctuation is needed between functions
C                        except for a comma between adjacent numbers;
C                        however, commas may be used between functions
C                        to improve readability.  The following are the
C                        only legal function codes.  Any other
C                        characters in a function string will be ignored
C                        except that an error message will be printed
C                        and, if more than 10 errors occur within a
C                        string, control will be returned to the main
C                        program. At the first call to PWRITX, size,type
C                        and case are Principal, Roman and Upper.
C
C                        PLA = plotter address  (for resolution 10)
C                        UPA = user plotter address  (resolution as
C                              defined by user )
C
C                        A.  FONT DEFINITIONS
C                            R  Roman type characters
C                            G  Greek type characters
C
C                        B.  SIZE DEFINITIONS
C                            P  Principal size, digitized to be 21 PLA
C                               units high.  The total character
C                               including white space is 32 PLA units
C                               high.  A carriage return or a Y
C                               increment will space down 32 PLA units.
C                               A blank or an X increment will space
C                               across 16 PLA units.  Note:  Characters
C                               vary in width.
C                            I  Indexical size, digitized to be 13 PLA
C                               units high (20 PLA units high
C                               including white space).  A carriage
C                               return or a Y increment is 20 PLA units.
C                               Blanks or X increments are 12 PLA units.
C                            K  Cartographic size, digitized to be 9 PLA
C                               units high (14 PLA units high
C                               including white space).  Carriage return
C                               or Y increments are 14 PLA units. Blanks
C                               or X increments are 8 PLA units.
C
C                        C.  CASE DEFINITIONS
C                            U or Un.  Upper case
C                               If U is followed by a number n (not
C                               separated by a comma) then n characters
C                               will be drawn in upper case, subsequent
C                               characters will be in lower case.  (The
C                               Un option is particularly useful for
C                               capitalizing sentences.)
C                            L or Ln.  Lower case
C                               If L is followed by a number n, then n
C                               characters will be drawn in lower case
C                               and subsequent characters will be in
C                               upper case.
C
C                        D.  LEVEL DEFINITIONS
C                            S or Sn.  Superscript level.
C                            B or Bn.  Subscript level.
C                            N or Nn.  Normal level.
C
C                               When super or subscripting, the
C                               character size will change depending on
C                               the previous character drawn.  Principal
C                               base characters will be subscripted or
C                               superscripted with indexical characters,
C                               with a 10 PLA unit shift (scaled to
C                               JSIZE) up or down.  Indexical and
C                               cartographic base characters will be sub
C                               or superscripted with cartographic
C                               characters with a 7 PLA unit shift.
C
C                               The case of the indexing characters will
C                               generally be the same as that of the bas
C                               character unless otherwise specified.
C                               Exception: a lower case indexical base
C                               will be super or subscripted with upper
C                               case cartographic, as the cartographic
C                               type has no lower case alphabetic or
C                               numeric characters available.
C
C                               If S,B or N is followed by a number n,
C                               then n characters will be drawn as
C                               specified above, after which character
C                               size, case and position will be reset to
C                               that of the base character.
C                               If n is negative, its absolute value
C                               will be used instead (n cannot be 0.)
C                               Do not overlap level definitions given
C                               for a specified number of characters.
C                               The N option returns character case and
C                               size to that of the base but maintains
C                               the current character position.
C
C                               Example:  'U1'T'S1'EST
C                                                          E
C                                         Will be written TST
C                                         'U1'T'S'E'N'ST
C                                                          E
C                                         Will be written T ST
C
C                        E.  COORDINATE DEFINITIONS (descriptions assume
C                                                    normal UPA unit
C                                                    space.)
C                            H,Hn,HnQ.  Increment in the X direction.
C                               If this option appears without a number
C                               n, n will be taken to be 1.  Hn will
C                               shift the present X position n UPA
C                               units.  If n is positive the shift is to
C                               the right, if n is negative the shift is
C                               to the left.  If Hn is followed by a Q,
C                               the X position will be incremented by n
C                               character widths (i.e., n blanks) either
C                               right or left.
C                            V,Vn,VnQ.  Increment in the Y direction.
C                               If this option appears without a number
C                               n, n will be taken to be 1.  Vn will
C                               shift the present Y position n UPA
C                               units.  If n is positive the shift is
C                               up, if n is negative the shift is down.
C                               If Vn is followed by a Q, the Y position
C                               will be incremented by n lines up or
C                               down.
C                            X,Xn.  Set X.
C                               If X appears without a number n, this
C                               will act as a do-nothing statement.
C                               Otherwise, the character position in the
C                               X direction will be set to the UPA
C                               coordinate n, so that the next character
C                               drawn will be centered on n and
C                               subsequent characters will be drawn from
C                               this position.
C                            Y,Yn.  Set Y.
C                               This works the same as set X.
C                            C  Carriage return.
C                               A carriage return will be done before
C                               the next character is plotted.
C
C                        F.  DIRECTION DEFINITIONS
C                            D,Dn.  Write down, rather than across the
C                                   frame.
C                               If D appears without an n or if n=0, all
C                               characters will be written down, until
C                               an 'A' function is encountered.  If D is
C                               followed by a number n, n characters
C                               will be written down and subsequent
C                               characters will be written across the
C                               frame.
C                               If n is negative, the absolute value of
C                               n is used instead.
C                            A  Write across.
C                               Escape from the D option.
C
C                        G.  DIRECT CHARACTER ACCESS
C                               NNN.  Numeric character.
C                               Character number NNN will be drawn.
C                               NNN is base 8.
C
C NOTE                   .  All characters in a given call are drawn in
C                           the same intensity. If JSIZE .LE. 2,
C                           characters are in low intensity, otherwise
C                           they are in high intensity.  Return to the
C                           main program is always in high intensity.
C                        .  On other than the first entry to PWRITX,
C                           font, case, etc. are in the state they
C                           were in when the program exited from the
C                           the last PWRITX call.
C                        .  Font, size, and case are reset to previous
C                           values if they were only set for a specified
C                           number of characters in the previous call.
C                        .  The previous case is always reset to upper
C                           for each new call to PWRITX.
C                        .  The direction is always reset to across
C                           for each new call to PWRITX.
C                        .  Numbers for direct character access must
C                           not be signed. All other numbers can be
C                           signed.
C
C PORTABILITY            FORTRAN 77
C
C REQUIRED RESIDENT      SQRT, SIN, COS.
C ROUTINES
C
C REQUIRED GKS LEVEL     0A
C
C ENTRY POINTS           PWRITX, GTNUM, GTNUMB, XTCH, PWRXBD, GTSIGN,
C                        GTDGTS, HTABLE, GETHOL, CCHECK, DCECK, PWRX
C                        MKMSK, PWRXBDX
C
C COMMON BLOCKS          PWRSV1, PSAV1, PSAV3, PUSER, PINIT, PINIT1,
C                        HOLTAB, PWRC0, PWRC1, PWRC2
C
C REQUIRED LIBRARY       The ERPRT77 package and the SPPS.
C
C I/O                    Plots characters.
C
C PRECISION              Single
C
C LANGUAGE               FORTRAN 77
C
C HISTORY               -Originally implemented to make the Hershey
C                        character sets more accessable.
C                       -Made portable in 1978.
C                        for use on all computer systems which support
C                        plotters with up to 15 bit resolution.
C                       -Made to be FORTRAN 77 and GKS compatible,
C                        August, 1984.
C
C INTERNAL PARAMETERS    NAME   DEFAULT  FUNCTION
C                        ----   -------  --------
C
C                        All values below are for plotter address units.
C
C                        SPRIH  32.      Height of principal characters
C                        SPRIW  16.      Width of principal characters
C                        SINDH  20.      Height of indexical chars.
C                        SINDW  12.      Width of indexical chars.
C                        SCARH  14.      Height of cartographic chars.
C                        SCARW  8.       Width of cartographic chars.
C                        SSPR   10.      Shift in case of super or
C                                        subscripting for principal
C                                        characters.
C                        SSIC   7.       Shift in case of super or
C                                        subscripting for indexical
C                                        characters.
C
C **********************************************************************
C
C IMPLEMENTATION INSTRUCTIONS
C
C 1.  Create the PWRITX binary database from the card-image files
C     PWRITXC1, PWRITXC2, PWRITXD1, PWRITXD2 supplied.  To do this,
C     read the instructions in file PWRITXNT and execute that program.
C 2.  Supply 3 machine dependent subprograms for bit manipulations,
C     namely ISHIFT(I1,I2), IOR(I1,I2), and IAND(I1,I2).
C     These subprograms can be the same routines used to implement the
C     NCAR GKS plot package.
C 3.  Set up a binary input file from which character data may be read
C     (user input) and supply its number below.
C 4.  Set the binary input file where PWRITX may read its data.
C **********************************************************************
C
C
C
C
C
C
C   D E C L A R A T I O N S
C
      CHARACTER       IDPC*(*)
C
C   IDPC contains the characters to be drawn, and the function codes.
C
C   IDPC must be of type character on input.
C
C
C  SAVE DATA VALUES FOR LATER PASSES
C
      COMMON/PWRSV1/NBWD,NUM15,INDLEN,IDDLEN,NUNIT
C
C
C NOTE THE SIZE OF IDD AND IND MAY BE MODIFED TO CONTAIN THE
C  NUMBER OF ELEMENTS EQUAL TO THE VALUE OF IDDLEN AND INDLEN
C  COMPUTED BELOW.
C
      COMMON/PWRC0/IDD(8625),IND(789)
C
C PWRC0 AND PWRC1 ARE FOR COMMUNICATION WITH SUBROUTINE XTCH.
C PWRC0 IS TO PASS VALUES TO XTCH AND PWRC1 IS TO PASS VALUES BACK.
      COMMON /PWRC1/ LC(150)
C PWRC2 IS FOR COMMUNICATION WITH SUBROUTINE XTCH AND BLOCKDATA PWRXBDX.
      COMMON /PWRC2/ INDZER
C VARIABLES WHICH HAVE TO BE SAVED FOR SUBSEQUENT CALLS TO PWRITX AND
C HAVE TO BE INITIALIZED.
C PSAV1 IS ALSO CONTAINED IN PWRXBDX.
      COMMON /PSAV1/ FINIT,IFNT,IC,IT,ITO,RLX,RLY,RLOX,RLOY
C VARIABLES WHICH HAVE TO BE SAVED BUT NOT INITIALIZED.
C PSAV3 IS NOT CONTAINED IN ANY OTHER ROUTINE.
      COMMON /PSAV3/ IAPOST, IQU
C
C COMMUNICATION WITH THE USER.
      COMMON /PUSER/ MODE
C
      LOGICAL NFLAG
      LOGICAL FINIT
C
C  Character constants
C
      CHARACTER*1 IAPOST,IQU
C
C  Storage for current character of string
C
      CHARACTER*1 NC
C
C  Value of the character in the character-to-hollerith table
C
      INTEGER HOLIND
C
C   C O N S T A N T   D E F I N I T I O N S
C
C INFORMATION ABOUT THE SIZE OF THE FILES OF INTEGERS SUPPLIED BY NCAR
C TOGETHER WITH PWRITX.
C THESE CONSTANTS ARE NEVER USED IN THE CODE BUT REFERRED TO IN COMMENTS
C
C NUMBER OF CARD IMAGES NEEDED TO REPRESENT ARRAY IND.
      DATA ICNUM1 /49/
C NUMBER OF CARD IMAGES NEEDED TO REPRESENT ARRAY IDD.
      DATA ICNUM2 /575/
C
C DEFINE INDICES FOR FONT, SIZE, AND CASE DEFINITIONS.
C
C THESE INDICES ARE USED AS DISPLACEMENTS INTO THE ARRAY IND AND THEY
C DEFINE UNIQUELY FOR EACH CHARACTER TOGETHER WITH ITS REPRESENTATION
C IN DPC AN ENTRY IN THE ARRAY IND. THIS ENTRY CONTAINS A POINTER
C WHICH POINTS TO THE DIGITIZATION OF THE SYMBOL AS DEFINED BY FONT,
C SIZE, CASE, AND CHARACTER.
C
C DEFINE INDEX FOR ROMAN AND GREEK FONT.
      DATA INDROM, INDGRE /0,384/
C DEFINE INDEX FOR PRINCIPAL, INDEXICAL, AND CARTOGRAPHIC SIZE.
      DATA INDPRI, INDIND, INDCAR /0,128,256/
C DEFINE INDEX FOR UPPER AND LOWER CASE.
      DATA INDUPP, INDLOW /0,64/
C
C DEFINE CHARACTER SIZES IN PLOTTER ADDRESS UNITS (FOR RESOLUTION 10)
C
C FOR PRINCIPAL CHARACTER SIZE - HEIGHT,WIDTH
      DATA SPRIH, SPRIW /32.,16./
C FOR INDEXICAL SIZE - HEIGTH,WIDTH
      DATA SINDH,SINDW /20.,12./
C FOR CARTOGRAPHIC SIZE - HEIGTH,WIDTH
      DATA SCARH, SCARW /14.,8./
C
C SHIFTING FOR SUPER OR SUBSCRIPTING.
C
C NUMBER OF PLOTTER ADDRESS UNITS SHIFTED FOR PRINCIPAL CHARACTERS.
      DATA SSPR /10./
C NUMBER OF PLOTTER ADDRESS UNITS SHIFTED FOR INDEXICAL OR CARTOGRAPHIC
C CHARACTERS.
      DATA SSIC /7./
C
C CONSTANT USED TO CHANGE DEGREES INTO RADIANS.
C DEGRAD = 2*3.14/360
      DATA DEGRAD /0.01745329/
C T2 = PI/2
      DATA  T2 /1.5707963/
C
C
C **********************************************************************
C
C IMPLEMENTATION-DEPENDENT CONSTANTS
C
C
C THE UNIT NUMBER WHERE THE BINARY FILE SUPPLIED TO PWRITX CAN BE READ.
C
C     DATA INBIN /0/
      DATA INBIN /3/
C
C
C END OF IMPLEMENTATION-DEPENDENT CONSTANTS
C
C
C **********************************************************************
C
C
C
C
C VARIABLES AND CONSTANTS USED IN PWRX:
C
C IND - POINTERS INTO ARRAY IDD
C IDD - DIGITIZED CHARACTERS
C LC - CONTAINS DIGITIZATION OF 1 CHARACTER, 1 DIGITIZATION UNIT PER
C      WORD.
C DISPLACEMENTS INTO THE ARRAY IND
C   INDROM - FOR ROMAN FONT
C   INDGRE - FOR GREEK FONT
C   INDPRI - FOR PRINCIPAL CHARACTER SIZE
C   INDIND - FOR INDEXICAL CHARACTER SIZE
C   INDCAR - FOR CARTOGRAPHIC CHARACTER SIZE
C   INDUPP - FOR UPPER CASE
C   INDLOW - FOR LOWER CASE
C CHARACTER SIZE AS DEFINED BY FUNCTION CODE (PLOTTER ADDRESS UNITS)
C   SPRIH - HEIGHT OF PRINCIPAL CHARACTERS
C   SPRIW - WIDTH OF PRINCIPAL CHARACTERS
C   SINDH - HEIGHT OF INDEXICAL CHARACTERS
C   SINDW - WIDTH OF INDEXICAL CHARACTERS
C   SCARH - HEIGHT OF CARTOGRAPHIC CHARACTERS
C   SCARW - WIDTH OF CARTOGRAPHIC CHARACTERS
C SHIFTING FOR SUPER OR SUBSCRIPTING (PLOTTER ADDRESS UNITS)
C   SSPR - SHIFT FOR PRINCIPAL CHARACTERS
C   SSIC - SHIFT FOR INDEXICAL OR CARTOGRAPHIC CHARACTERS
C II  - THE POSITION OF THE CHARACTER CURRENTLY BEING PROCESSED
C NC  - THE CHARACTER CURRENTLY BEING PROCESSED, RIGHT JUSTIFIED,
C       ZERO FILLED, ASCII REPRESENTATION.
C NCHOL - CHARACTER NC IN HOLLERITH REPRESENTATION.
C INDPOI - THE POSITION OF THE POINTER IN IND WHICH POINTS TO THE
C          DIGITIZATION OF CHARACTER NC IN THE ARRAY IDD.
C NUM - SIGNED INTEGER AS EXTRACTED FROM CHARACTER STRING IDPC
C IPASS = 1 : PASS TO CENTER THE STRING
C       = 2 : PASS TO DRAW OUT THE CHARACTERS
C L1  - DISTANCE FROM THE CENTER OF A CHARACTER TO ITS LEFT END
C       (AS A NEGATIVE NUMBER)
C L2  - DISTANCE FROM THE CENTER OF A CHARACTER TO ITS RIGHT END
C       (AS A POSITIVE NUMBER)
C IERR- ERROR COUNT
C NFLAG = .FALSE.  NORMAL
C       = .TRUE.  DIRECT CHARACTER ACCESS
C IT  - REPRESENTS CHARACTER SIZE
C       0   = PRICIPAL  128 = INDEXICAL   256 = CARTOGRAPHIC
C ITO - REPRESENTS PREVIOUS CHARACTER SIZE
C IC  - REPRESENTS LOWER CASE , UPPER CASE
C       =0 UPPER CASE
C       =64 LOWER CASE
C ICO - REPRESENTS PREVIOUS CASE
C IFNT = 0  ROMAN
C      = 384  GREEK
C IFLG = 0  NORMAL
C      = 1  DISTANCE BETWEEN CHARACTERS IS NOT TAKEN FROM DIGITIZATION
C           POSITION INSTEAD DEFINED BY HIGHER PRIORITY FUNCTION CODE
C           (C,Y,X)
C N   - NUMBER OF CHARACTERS IN INPUT STRING
C IDFLG = 0  WRITE ACROSS THE FRAME
C       = 1  WRITE DOWN THE FRAME
C FINIT = .TRUE. ONE TIME INITIALIZATION HAS BEEN DONE
C       = .FALSE. ONE TIME INITIALIZATION HAS NOT BEEN DONE YET
C RLX - CHARACTER HEIGHT ACCORDING TO FUNCTION CODE AND SIZE PARAMETER
C RLY - CHARACTER WIDTH ACCORDING TO FUNCTION CODE AND SIZE PARAMETER
C RLOX - PREVIOUS CHARACTER HEIGHT
C RLOY - PREVIOUS CHARACTER WIDTH
C N4  = 0  NO CHARACTERS TO BE WRITTEN DOWN
C     OTHERWISE  NUMBER OF CHARACTERS TO BE WRITTEN DOWN
C IN4 - NUMBER OF CHARACTER CURRENTLY BEING WRITTEN DOWN
C N3  - NUMBER AS COMPUTED BY GTNUM FOR COORDINATE DEFINITIONS OR
C       NUMBER AS COMPUTED BY GTNUMB FOR NUMERIC CHARACTER DEFINITIONS.
C N3T1 - TEMPORARY STORAGE FOR VARIABLE N3. ONLY USED IN SECTION FOR
C        FUNCTION CODE H.
C N3T2 - LIKE N3T1, BUT FOR FUNCTION CODE V.
C N2  - NUMBER OF CHARACTERS TO BE WRITTEN AS SUPERSCRIPT OR SUBSCRIPT
C IN2 - NUMBER OF CHARACTER CURRENTLY BEING WRITTEN AS SUPERSCRIPT OR
C       SUBSCRIPT
C N1  - NUMBER OF CHARACTERS TO BE WRITTEN IN LOWER CASE OR UPPER CASE
C IN1 - NUMBER OF CHARACTER CURRENTLY BEING WRITTEN IN LOWER CASE OR
C       UPPER CASE
C NF  =1  NORMAL LEVEL
C     =0  FLAG FOR SUPERSCRIPTING OR SUBSCRIPTING
C NIX,NIY - IN PASS 1 THE PARAMETER COORDINATES X AND Y IN METACODE
C           ADDRESS UNITS. IN PASS 2 THE ACTUAL COORDINATES OF THE FIRST
C           CHARACTER IN THE STRING IN METACODE ADDRESS UNITS.
C IX,IY - SAME AS NIX,NIY AS LONG AS NO CARRIAGE RETURN IS ENCOUNTERED.
C         AFTER EACH CARRIAGE RETURN THEY CONTAIN THE COORDINATES OF
C         THE FIRST CHARACTER IN THE NEW LINE.
C NXX,NYY - THE PARAMETER COORDINATES X AND Y IN METACODE ADDRESS UNITS.
C           NIX AND NIY CAN BE USED INSTEAD.
C XX,YY - THE CENTER OF THE CHARACTER TO BE DRAWN (CONSIDERED) NEXT
C XXO,YYO - THE CENTER OF THE LAST CHARACTER DRAWN (CONSIDERED)
C           BEFORE SUPER OR SUBSCRIPTING STARTED
C MX  - THE DISTANCE BETWEEN THE CHARACTER CURRENTLY BEING PROCESSED AND
C       THE CENTER OF THE NEXT CHARACTER TO BE PROCESSED,
C       IN DIGITIZATION UNITS
C MXO  LAST DISTANCE COMPUTED BEFORE SUPER OR SUBSCRIPTING STARTED
C NN  - INDEX VARIABLE IN THE LOOP FOR STRIKING OUT CHARACTERS
C JX,JY - CONTAIN COORDINATES WHEN CHARACTERS ARE BEING STROKED OUT
C MXEND,MYEND - TEMPORARY STORAGE FOR COORDINATES IN TERMINAL PORTION
C IAPOST - THE CHARACTER APOSTROPHE '
C IQU - THE CHARACTER Q
C NCCG - ONLY USED FOR COMPUTED GO TO IN FUNCTION MODE CONTROL SECTION.
C NUMDUN - THE NUMBER OF DIGITIZATION UNITS CONTAINED IN ARRAY LC
C          =0  NO DIGITIZATION FOUND
C INDZER - AN INDICATION FOR AN ALL-0-BITS DIGITIZATION UNIT. INDICATES
C          THAT NEXT MOVE IS PEN-UP.
C
C
C
C          I N I T I A L I Z A T I O N
C
C
C INITIALIZATION  -  ONCE PER LOADING OF ROUTINE
C
C
C CHECK IF INITIALIZATION IS ALREADY DONE.
      IF (FINIT) GOTO 100
C
C Do a call forcing a BLOCKDATA to be loaded from a binary library.
C
      CALL PWRXBD
C Modification for UNIX Version.
      CALL OPENPW(3)
C End of modification for UNIX Version.
C Modification for UNIX Version.
      CALL OPENPW(3)
C End of modification for UNIX Version.
C Modification for UNIX Version.
      CALL OPENPW(3)
C End of modification for UNIX Version.
C
C  FIND THE NUMBER OF BITS PER WORD
C
      NBWD = I1MACH(5)
C
C  COMPUTE THE NUMBER OF 15-BIT PARCELS PER WORD
C
      NUM15 = NBWD/15
C
C  CALCULATE THE AMOUNT OF ARRAY IND REQUIRED ON THIS MACHINE
C
      INDLEN = (ICNUM1*16-1)/NUM15+1
C
C  CALCULATE THE AMOUNT OF ARRAY IDD REQUIRED ON THIS MACHINE
C
      IDDLEN = (ICNUM2*16*15-1)/NBWD+1
C
C CHARACTERS USED FOR COMPARISONS.
C
      IAPOST = ''''
      IQU    = 'Q'
C
C Define the error file logical unit number
C
      NUNIT = I1MACH(4)
C
C Initialize the hash table for obtaining the hollerith code of a
C character.
C
      CALL HTABLE
C
C READ IN POINTER ARRAY AND CHARACTER DIGITIZATIONS
C
      IF (MODE .EQ. 1) GOTO 98
C
C READ IN COMPLEX SET.
      REWIND INBIN
      READ(INBIN) (IND(I),I=1,INDLEN)
      READ(INBIN) (IDD(I),I=1,IDDLEN)
      REWIND INBIN
      GOTO 97
C
   98 CONTINUE
C
C READ IN DUPLEX SET.
      REWIND INBIN
      READ(INBIN) DUMREA
      READ(INBIN) DUMREA
      READ(INBIN) (IND(I),I=1,INDLEN)
      READ(INBIN) (IDD(I),I=1,IDDLEN)
      REWIND INBIN
   97 CONTINUE
C
C SHORT TEST IF ARRAYS IDD AND IND ARE LOADED CORRECTLY.
      IF (MODE .EQ. 1) CALL DCHECK(LCHERR)
      IF (MODE .NE. 1) CALL CCHECK(LCHERR)
      IF (LCHERR .NE. 0) THEN
           CALL SETER
     +     ('PWRITX - ARRAY IND OR IDD NOT LOADED CORRECTLY',LCHERR,2)
      ENDIF
   99 CONTINUE
C
C SET FLAG THAT INITIALIZATION IS DONE.
      FINIT = .TRUE.
C
  100 CONTINUE
C
C
C INITIALIZATION  -  ONCE PER CALL TO ROUTINE
C
C
C RETRIEVE RESOLUTION.
C
      CALL GETUSV('XF',LXSAVE)
      CALL GETUSV('YF',LYSAVE)
C
C DEFINE FACTOR TO CHANGE PLOTTER ADDRESS UNITS INTO METACODE UNITS.
C
      METPLA = ISHIFT(1,15-10)
C
C DEFINE FACTOR TO CHANGE USER PLOTTER ADDRESS UNITS INTO METACODE UNITS
C
      METUPA = ISHIFT(1,15-LXSAVE)
C
C COPY ARGUMENTS INTO LOCAL VARIABLES
C
      ICTR = JCTR
      IOR = JOR
      ISIZE = JSIZE
      N = NCHAR
C INSIDE PWRITX WE WORK ONLY WITH METACODE ADDRESS UNITS
      CALL FL2INT (X,Y,NIX,NIY)
C
C SAVE THE FOLLOWING CONSTANTS FOR PASS 2
C
      ID1 = IFNT
      ID2 = IC
      ID3 = IT
      ID4 = ITO
      R1 = RLX
      R2 = RLY
      R3 = RLOX
      R4 = RLOY
C
      IPASS = 1
C ONLY 1 PASS REQUIRED IF THE CHARACTER STRING IS CENTERED TO THE LEFT
      IF (ICTR .EQ. -1) IPASS = 2
C
C INITIALIZATION  -  ONCE PER PASS THROUGH ROUTINE
C
  102 CONTINUE
C POSITION PEN
      CALL PLOTIT(NIX,NIY,0)
C STORE CURRENT POSITION OF PEN
C IX AND IY ARE USED FOR CARRIAGE RETURNS. THEY DEFINE THE BEGINNING
C OF THE LINE CURRENTLY BEING WRITTEN.
      IX = NIX
      IY = NIY
      RX = NIX
      RY = NIY
      XXO = NIX
      YYO = NIY
      XX = NIX
      YY = NIY
C  Z  MULTIPLICATION OF DIGITIZED SIZE
      Z = 1. + REAL(ISIZE)/2.
      IF (ISIZE .EQ. 3) Z = 3.
      IF (ISIZE .GT. 3) Z = REAL(ISIZE)/21.
C TRANSLATE SIZE FROM PLOTTER ADDRESS UNITS TO METACODE ADDRESS UNITS.
      Z = Z*REAL(METPLA)
C SET INTENSITY
      INT = 0
      IF (Z .GT. 64.) INT = 1
C  T - ORIENTATION IN RADIANS
      T = REAL(IOR)*DEGRAD
C COMPUTE VALUES USED TO POSITION THE SUBSEQUENT CHARACTER DEPENDING
C ON ANGLE AND FUNCTION CODE.
C NORMAL CASE.
      SIT = SIN(T)
      COT = COS(T)
C USED FOR SUBSCRIPT, CARRIAGE RETURN, Y INCREMENT
      SIM = SIN(T-T2)
      COM = COS(T-T2)
C USED FOR SUPERSCRIPT AND Y INCREMENT
      SIP = SIN(T+T2)
      COP = COS(T+T2)
C MAKE POSITIONING ALSO DEPENDENT ON SIZE PARAMETER
      CT = Z*COT
      ST = Z*SIT
C ADJUST CHARACTER HEIGHT AND WIDTH ACCORDING TO SIZE PARAMETER
      RLX = RLX*Z
      RLY = RLY*Z
C
      MX = 0
C START PROCESSING FROM BEGINNING OF STRING
      II = 0
C FUNCTION CODES DEFINED ONLY FOR A SPECIFIED NUMBER OF CHARACTERS ARE
C NOT VALID ANY MORE. UNRESTRICTED FUNCTION CODES SET IN PREVIOUS CALLS
C TO PWRX ARE STILL VALID.
C CASE.
      N1 = 0
      IN1 = 0
C LEVEL.
      N2 = 0
      IN2 = 0
C DIRECTION.
      N4 = 0
      IN4 = 0
C THE FOLLOWING FUNCTIONS ARE RESET FOR EACH CALL TO PWRX.
C RESET PREVIOUS CASE TO UPPER.
      ICO = 0
C WRITE ACROSS FRAME.
      IDFLG = 0
C THE FOLLOWING INTERNAL FLAGS ARE RESET FOR EACH CALL TO PWRX.
C PROCEED NORMALLY IN X-DIRECTION
      IFLG = 0
C NO DIRECT CHARACTER ACCESS
      NFLAG = .FALSE.
      NF = 0
C
C
C  END INITIALIZATION
C
C-----------------------------------------------------------------------
C
C
C  S T A R T   T O   P R O C E S S   D A T A   S T R I N G
C
C IF IN DIRECT CHARACTER ACCESS MODE, GO TO FUNCTION PROCESSOR SECTION
  104 IF (NFLAG) GO TO 125
C LET II POINT TO THE NEXT CHARACTER IN IDPC
      II = II + 1
C CHECK IF NO CHARACTER LEFT IN STRING.
      IF (II .GT. N) GOTO 120
C RETRIEVE CHARACTER IN NC
      NC = IDPC(II:II)
C IF CHARACTER INDICATES BEGINNING OF FUNCTION CODE, GO TO FUNCTION
C PROCESSOR SECTION.
      IF (NC .EQ. IAPOST) GO TO 125
C FIND ENTRY IN POINTER TABLE POINTING TO DIGITIZATION OF CHARACTER NC
      CALL GETHOL (NC,NCHOL,IER2)
C ERROR IF NC IS NOT A FORTRAN CHARACTER OR AN APOSTROPHE
      IF (IER2 .NE. 0) GOTO 153
      INDPOI = NCHOL + IFNT + IC + IT
C CHECK IF THIS CASE IS ONLY FOR SPECIFIED NUMBER OF CHARACTERS
      IF (N1 .EQ. 0) GO TO 106
C INCREMENT COUNTER FOR CHARACTERS WRITTEN IN THIS CASE
      IN1 = IN1+1
C CHECK IF THIS CHARACTER IS TO BE WRITTEN DOWN
  106 IF (N4 .EQ. 0) GO TO 109
C        ***** PROCESS WRITING DOWN *****
C INCREMENT COUNTER FOR CHARACTERS WRITTEN DOWN
      IN4 = IN4+1
C CHECK IF ALL CHARACTERS SPECIFIED HAVE BEEN WRITTEN DOWN
      IF (IN4 .GT. N4) GO TO 108
C
      RX = XX+RAD*COM
      RY = YY+RAD*SIM
C SET FLAG TO NOT PROCEED IN X DIRECTION
  107 IFLG = 1
C
      MX = 0
      GO TO 109
C SET FLAG THAT ALL CHARACTERS SPECIFIED HAVE BEEN WRITTEN DOWN
  108 N4 = 0
C        ***** END OF WRITING DOWN PROCESSING *****
C
C  PROCESS ONE CHARACTER
C  ---------------------
C
C RETURN DIGITIZATION OF CHARACTER IN ARRAY LC
  109 CONTINUE
      CALL XTCH (INDPOI,IPASS,NUMDUN)
C IF NO DIGITIZATION WAS FOUND, JUST GET NEXT CHARACTER.
      IF (NUMDUN .EQ. 0) GOTO 104
C DEFINE DISTANCE FROM CENTER TO LEFT END OF CHARACTER.
      L1 = LC(1)
C DEFINE DISTANCE FROM CENTER TO RIGHT END OF CHARACTER.
      L2 = LC(2)
C IN THE NORMAL CASE, JUMP
      IF (IFLG .EQ. 0) GO TO 111
C FOR FUNCTION CODES C, Y, AND X NO BLANK SPACE IS LEFT
      L1 = 0
C RESET FLAG TO NORMAL
      IFLG = 0
  111 CONTINUE
C FIND THE CENTER OF THE NEXT CHARACTER TO BE DRAWN.
      MX = MX - L1
      XX = RX+REAL(MX)*CT
      YY = RY+REAL(MX)*ST
C DO NOT STROKE OUT CHARACTERS IN PASS 1.
      IF (IPASS .EQ. 1) GO TO 117
C
C STROKE OUT CHARACTER
C
      NN = 1
      LC(1) = INDZER
      DO 113 NN = 3,NUMDUN,2
C CHECK FOR INDICATION OF PEN-UP MOVE
      IF (LC(NN) .EQ. INDZER) GOTO 113
C FIND COORDINATES FOR NEXT PEN MOVE
      JX = XX + (REAL(LC(NN))*CT - REAL(LC(NN+1))*ST + .5)
      JY = YY + (REAL(LC(NN))*ST + REAL(LC(NN+1))*CT + .5)
C CHECK FOR PEN-UP OR PEN-DOWN
      IF (LC(NN-2) .NE. INDZER) GOTO 116
C PEN-UP MOVE.
      CALL PLOTIT (JX,JY,0)
      GOTO 113
C PEN-DOWN MOVE.
  116 CALL PLOTIT (JX,JY,1)
C
  113 CONTINUE
C
C RESET VARIABLES AFTER ONE CHARACTER HAS BEEN PROCESSED
C
C
  117 CONTINUE
C FIND THE RIGHT END OF THE LAST CHARACTER DRAWN.
      MX = MX + L2
C      ***** FIND CASE DEFINTION OF NEXT CHARACTER *****
C CHECK IF THE CURRENT CASE IS ONLY FOR A SPECIFIED NUMBER.
      IF (N1 .EQ. 0) GO TO 118
C CHECK IF SPECIFIED NUMBER OF CHARACTERS HAS ALREADY BEEN DRAWN.
      IF (IN1 .LT. N1) GO TO 118
C RESET INDICATORS FOR CASE SPECIFICATION.
      N1 = 0
      IN1 = 0
C SET CASE TO PREVIOUS CASE.
      IC = ICO
C CHECK IF THE CURRENT LEVEL IS ONLY FOR SPECIFIED NUMBER OF CHARACTERS.
  118 IF (N2 .EQ. 0) GO TO 104
C CHECK IF SPECIFIED NUMBER OF CHARACTERS HAS ALREADY BEEN DRAWN.
      IN2 = IN2+1
      IF (IN2 .LT. N2) GO TO 104
C SET LEVEL TO PREVIOUS LEVEL.
      IT = ITO
C
      RX = RNX
      RY = RNY
C SET CHARACTER HEIGHT AND WIDTH TO PREVIOUS VALUES
      RLX = RLOX
      RLY = RLOY
C STOP SUPER OR SUBSCRIPTING.
      N2 = 0
C CHECK IF WE WERE IN SUPER OR SUBSCRIPTING MODE BEFORE.
      IF (NF .EQ. 1) GO TO 119
C YES WE WERE. RETURN TO PREVIOUS CASE.
      IC = ICO
C
      XX = XXO
      YY = YYO
C
  119 MX = MXO
C RESET FLAG FOR SUPER OR SUBSCRIPTING TO NORMAL.
      NF = 0
C
      L2 = L2O
C
      GO TO 104
C
C TERMINAL PORTION AFTER WHOLE STRING HAS BEEN PROCESSED
C ------------------------------------------------------
C
  120 CONTINUE
C RESET CHARACTER HEIGHT AND WIDTH
      RLX = RLX/Z
      RLY = RLY/Z
      IF (IPASS .EQ. 2) THEN
          CALL PLOTIT(0,0,0)
          RETURN
      ENDIF
C
C GET READY FOR PASS 2
C
      IPASS = 2
C GET COORDINATES PASSED TO PWRX IN METACODE ADDRESS UNITS
      CALL FL2INT (X,Y,NXX,NYY)
C THE COORDINATES FOR THE END OF THE CHARACTER STRING IF THE FIRST
C CHARACTER HAD BEEN POSITIONED AT THE COORDINATES PASSED TO PWRX.
      MXEND = XX + REAL(L2)*CT
      MYEND = YY + REAL(L2)*ST
C COMPUTE LENGTH OF CHARACTER STRING TO BE DRAWN
      R     = SQRT(REAL(MXEND-NXX)**2 + REAL(MYEND-NYY)**2)
C CONSIDER CENTERING OPTION
      WFAC = -1.
      IF (ICTR .EQ. 0) WFAC = -0.5
C COMPUTE DISPLACEMENT FROM COORDINATES PASSED TO PWRX
      RCT = WFAC*R*COT
      RST = WFAC*R*SIT
C CHECK FOR WRITING DOWN OR ACROSS FRAME
      IF (IDFLG .EQ. 1) GO TO 122
C GET COORDINATES WHERE FIRST CHARACTER IN STRING HAS TO BE CENTERED
      XDIF = MXEND - NXX
      NIX = REAL(NXX) + XDIF*WFAC
      YDIF = MYEND - NYY
      NIY = REAL(NYY) + YDIF*WFAC
      GO TO 123
C GET COORDINATES WHERE FIRST CHARACTER IN STRING HAS TO BE CENTERED
  122 NIX = REAL(NXX) + RST
      NIY = REAL(NYY) - RCT
C
C REINITIALIZE VARIABLES FOR PASS 2
C SET ROMAN,UPPER CASE, PRINCIPAL
C SET PREVIOUS CHARACTER SIZE ALSO TO PRINCIPAL
  123 IFNT = ID1
      IC = ID2
      IT = ID3
      ITO = ID4
      RLX = R1
      RLY = R2
      RLOX = R3
      RLOY = R4
      GO TO 102
C
C-----------------------------------------------------------------------
C
C   F U N C T I O N   P R O C E S S O R   S E C T I O N
C
C
C
C
C
C
C
C
C
C
C  FUNCTION MODE CONTROL SECTION
C  -----------------------------
C
  125 IERR = 0
      NFLAG = .FALSE.
  126 CONTINUE
      II = II + 1
      IF (II .GT. N) GOTO 120
      NC = IDPC(II:II)
C                        Check for an invalid function character, and pr
C                        an error message if one is found.
      CALL GETHOL(NC, HOLIND, NERR)
      IF
     +   (( HOLIND .EQ. 0) .OR. (HOLIND .EQ. 47) .OR.
     +   (( HOLIND .GT. 34 ) .AND. ( HOLIND .LT. 46)) .OR.
     +    ( HOLIND .GT. 52) )
     +THEN
           IERR = IERR + 1
           WRITE( NUNIT, 1001) II, IERR
           IF (IERR .GT. 9) GOTO 120
           GOTO 126
      ENDIF
C                        Check to see if the character is an octal digit
      IF (( NC .GE. '0') .AND. (NC .LE. '7')) THEN
C
C NUMERIC CHARACTER DEFINITION
C ----------------------------
C
C SET FLAG FOR NUMERIC CHARACTER DEFINITION
           NFLAG = .TRUE.
C RETRIEVE OCTAL NUMBER IN N3
           CALL GTNUMB (IDPC,N,II,N3)
C IF END OF CHARACTER STRING REACHED GO TO TERMINAL PORTION
           IF (II .GT. N) GO TO 120
C CHECK IF THIS CASE IS ONLY FOR A SPECIFIED NUMBER OF CHARACTERS.
           IF (N1 .NE. 0) THEN
                IN1 = IN1+1
                IF (IN1 .GT. N1) THEN
                     N1 = 0
C RETURN TO PREVIOUS CASE.
                     IC = ICO
                ENDIF
           ENDIF
C
C SEE IF THE TERMINATING CHARACTER WAS AN APOSTROPHE OR NOT.  IF SO,
C SET 'NFLAG' FALSE TO SUSPEND FUNCTION-CODE SCANNING.
C
           NC = IDPC(II:II)
           IF (NC .EQ. IAPOST) NFLAG = .FALSE.
           INDPOI = N3
           GOTO 106
      ENDIF
C
      IF (NC .EQ. IAPOST) GOTO 104
      IF (NC .EQ. ',') GOTO 126
C
C                           Goto the appropriate section to process the
C                           alphabetic function code characters
C
      GOTO
C        A , B,  C,  D,  E,  F,  G,  H,  I,  J,  K,  L,  M,
     + (145,140,146,144,127,127,129,147,131,127,132,134,127,
C        N,  O,  P,  Q,  R,  S,  T,  U,  V,  W,  X,  Y,  Z
     +  141,127,130,126,128,135,127,133,148,127,149,150,127)
     + HOLIND
C
C                           Error handling section for invalid alphabeti
C                           function code.
C
 127  IERR = IERR + 1
      WRITE( NUNIT, 1001) II, IERR
      IF (IERR .GT. 9) GOTO 120
      GOTO 126
C
C FONT DEFINITION
C ---------------
C
C  ROMAN  R  22B
C
  128 CONTINUE
C DEFINE INDEX INTO POINTER TABLE
      IFNT = INDROM
C GO TO GET NEXT FUNCTION CODE
      GO TO 126
C
C  GREEK  G  07B
C
C EQUIVALENT TO ROMAN
  129 CONTINUE
      IFNT = INDGRE
      GO TO 126
C
C SIZE DEFINITION
C ---------------
C
C  PRINCIPAL SIZE  P  20B
C
  130 CONTINUE
C DEFINE INDEX INTO POINTER TABLE
      IT = INDPRI
C SET CHARACTER WIDTH
      RLX = SPRIW*Z
C SET CHARACTER HEIGHT
      RLY = SPRIH*Z
C GO TO GET NEXT FUNCTION CODE
      GO TO 126
C
C  INDEXICAL SIZE  I  11B
C
C EQUIVALENT TO PRINCIPAL SIZE DEFINITION
  131 CONTINUE
      IT = INDIND
      RLX = SINDW*Z
      RLY = SINDH*Z
      GO TO 126
C
C  CARTOGRAPHIC SIZE  K  13B
C
C EQUIVALENT TO PRINCIPAL SIZE DEFINITION
  132 CONTINUE
      IT = INDCAR
      RLX = SCARW*Z
      RLY = SCARH*Z
      GO TO 126
C
C CASE DEFINITION
C ---------------
C
C  UPPER CASE  U  25B
C
  133 CONTINUE
C Set previous case to lower, current case to
C upper, no characters drawn in this case yet.
      ICO = INDLOW
      IC  = INDUPP
      IN1 = 0
C Set the number of characters to be drawn in upper case.
C If no number is found, then all remaining characters
C should be in upper case.
      CALL GTNUM (IDPC,N,II,N1)
      IF (N1 .EQ. 0) N1 = N + 1 - II
      GO TO 126
C
C  LOWER CASE  L  14B
C
  134 CONTINUE
C Set previous case to upper, current case to
C lower, no characters drawn in this case yet.
      ICO = INDUPP
      IC  = INDLOW
      IN1 = 0
C Set the number of characters to be drawn in upper case.
C If no number is found, then all remaining characters
C should be in lower case.
      CALL GTNUM (IDPC,N,II,N1)
      IF (N1 .EQ. 0) N1 = N + 1 - II
      GO TO 126
C
C LEVEL DEFINITION
C ----------------
C
C  SUPERSCRIPT  S  23B
C
  135 CONTINUE
C DEFINE ANGLE FROM BASE TO FIRST SUPERSCRIPTED CHARACTER.
      TS = SIP
      TC = COP
      GOTO 136
C
C SUBSCRIPT  B  02B
C
  140 CONTINUE
C DEFINE ANGLE FROM BASE TO FIRST SUBSCRIPTED CHARACTER.
      TS = SIM
      TC = COM
C
C FOR SUPERSCRIPT AND SUBSCRIPT.
C
  136 CONTINUE
C DEFINE DISTANCE FROM BASE TO FIRST SUPER OR SUBSCRIPTED CHARACTER.
      RAD = SSPR*Z
      IF (IT .NE. INDPRI) RAD = SSIC*Z
C REMEMBER POSITION OF BASE CHARACTER.
      XXO = XX
      YYO = YY
C
C FOR SUPERSCRIPT, SUBSCRIPT, AND NORMAL.
C
  137 CONTINUE
C REMEMBER POSITION OF LAST CHARACTER BEFORE LEVEL CHANGE.
      RNX = RX
      RNY = RY
C FIND THE POSITION OF THE FIRST CHARACTER AFTER LEVEL CHANGE.
      RX = XX+RAD*TC
      RY = YY+RAD*TS
C RETRIEVE FOR HOW MANY CHARACTERS THE LEVEL HAS TO BE CHANGED.
      IN2 = 0
      CALL GTNUM (IDPC,N,II,N2)
      N2 = ABS(N2)
C REMEMBER SIZE OF CHARACTERS IN PREVIOUS LEVEL.
      RLOX = RLX
      RLOY = RLY
C
      IF (TS .EQ. SIT) GO TO 142
      MXO = MX
C
      MX = L2
      L2O = L2
      NF = 0
C REMEMBER CASE DEFINITION OF BASE CHARACTER.
      ICO = IC
C REMEMBER SIZE DEFINITION OF BASE CHARACTER
      ITO = IT
C ***** FIND CHARACTER SIZE AFTER LEVEL CHANGE *****
C CHECK IF BASE CHARACTER HAS PRINCIPAL SIZE DEFINITION.
      IF (IT .NE. INDPRI) GO TO 139
C BASE CHARACTER HAS PRINCIPAL SIZE. THEN SUPER OR SUBSCRIPT HAS
C INDEXICAL SIZE
  138 CONTINUE
      IT = INDIND
      RLX = SINDW*Z
      RLY = SINDH*Z
      GO TO 126
C BASE CHARACTER HAS INDEXICAL OR CARTOGRAPHIC SIZE. THEN SUPER OR
C SUBSCRIPT HAS CARTOGRAPHIC SIZE.
  139 CONTINUE
      IT = INDCAR
      RLX = SCARW*Z
      RLY = SCARH*Z
C CASE IS SET TO UPPER SINCE CARTOGRAPHIC DOES NOT HAVE LOWER CASE
C CHARACTERS.
      IC = INDUPP
      GO TO 126
C ***** CHARACTER SIZE FOR AFTER LEVEL CHANGE DEFINED *****
C
C  NORMAL  N  16B
C
  141 CONTINUE
C ANGLE BETWEEN LAST SUPER OR SUBSCRIPTED CHARACTER AND FIRST NORMAL
C CHARACTER.
      TS = SIT
      TC = COT
C DISTANCE BETWEEN LAST SUPER OR SUBSCRIPTED CHARACTER AND FIRST
C NORMAL CHARACTER.
      RAD = 0
      IF (IT .EQ. INDIND) RAD = SSPR*Z
      IF (IT .EQ. INDCAR) RAD = SSIC*Z
C GET THE CASE OF THE BASE CHARACTER.
      IC = ICO
C GET THE POSITION OF THE BASE CHARACTER.
      XX = XXO
      YY = YYO
      NF = 1
      GO TO 137
C
  142 CONTINUE
C ***** RESET CHARACTER SIZE WHEN RETURNING TO NORMAL LEVEL *****
      IF (IT .EQ. INDPRI) GO TO 126
C
      IF (IT .EQ. INDCAR .AND. ITO .EQ. INDCAR) GO TO 126
C
      IF (IT .EQ. INDIND) GO TO 143
C
      ITO = IT
      GO TO 138
C
  143 CONTINUE
C RESET CHARACTER SIZE TO PRINCIPAL.
      ITO = IT
      IT = INDPRI
      RLX = SPRIW*Z
      RLY = SPRIH*Z
C *****CHARACTER SIZE IS RESET TO NORMAL *****
      GO TO 126
C
C DIRECTION DEFINITION
C --------------------
C
C    WRITE DOWN  D  04B
C
  144 RAD = RLY
C NO CHARACTER IS CURRENTLY BEING WRITTEN DOWN
      IN4 = 0
C SET FLAG FOR WRITING DOWN
      IDFLG = 1
C GET NUMBER OF CHARACTERS TO BE WRITTEN DOWN
      CALL GTNUM (IDPC,N,II,N4)
C IF N APPEARS WITHOUT AN N OR IF N=0 , WRITE ALL CHARACTERS DOWN
C UNTIL AN 'A' IS ENCOUNTERED OR PWRX RETURNS.
      IF (N4 .EQ. 0) N4 = N
C IF N IS NEGATIVE USE ITS ABSOLUTE VALUE INSTEAD.
      N4 = ABS(N4)
C GO TO INTERPRET CHARACTER NC (ALREADY FETCHED)
      GO TO 126
C
C  ESCAPE FROM DOWN  A  01B
C
  145 CONTINUE
C 0 CHARACTERS TO BE WRITTEN DOWN
      N4 = 0
C *****
C RESET FLAG TO WRITING ACROSS.
      IDFLG = 0
C *****
      GO TO 126
C
C COORDINATE DEFINITION
C ---------------------
C
C  CARRIAGE RETURN  C  03B
C
  146 CONTINUE
C DEFINE DISTANCE TO NEXT LINE.
      RAD = RLY
      MX = 0
C DEFINE POSITION OF FIRST CHARACTER IN NEXT LINE.
      RX = REAL(IX)+RAD*COM
      RY = REAL(IY)+RAD*SIM
      XX = RX
      YY = RY
C DEFINE THE BEGINNING OF THE LINE CURRENTLY BEING WRITTEN.
      IX = RX
      IY = RY
      GO TO 126
C
C  INCREMENT X  H OR H Q  10B
C
  147 CONTINUE
C RETRIEVE NUMBER AFTER H IN N3
      CALL GTNUM (IDPC,N,II,N3)
C IF NO NUMBER IS PROVIDED IT WILL BE TAKEN TO BE 1.
      IF (N3 .EQ. 0) N3 = 1
      N3T1 = N3
C TRANSFORM UPA UNITS INTO METACODE UNITS.
      N3 = N3*METUPA
C IF HN IS FOLLOWED BY A Q THE SHIFT IS N CHARACTER WIDTHS
      NC = IDPC(II:II)
      IF (NC .EQ. IQU) N3 = RLX*REAL(N3T1)
C
      RX = RX + REAL(N3)
C
      XX = RX+REAL(MX)*CT
      YY = RY+REAL(MX)*ST
      GO TO 126
C
C  INCREMENT Y  V OR V Q  26B
C
  148 CONTINUE
C RETRIEVE NUMBER AFTER V IN N3
      CALL GTNUM (IDPC,N,II,N3)
C IF NO NUMBER IS PROVIDED IT WILL BE TAKEN TO BE 1.
      IF (N3 .EQ. 0) N3 = 1
      N3T2 = N3
C TRANSFORM USER PLOTTER ADDRESS UNITS INTO METACODE ADDRESS UNITS.
      N3 = N3*METUPA
C IF VN IS FOLLOWED BY A Q THE SHIFT IS N CHARACTER HEIGHTS
      NC = IDPC(II:II)
      IF (NC .EQ. IQU) N3 = RLY*REAL(N3T2)
C
      RY = RY + REAL(N3)
      XX = RX + REAL(MX)*CT
      YY = RY + REAL(MX)*ST
      GO TO 126
C
C  SET X  (SPECIFY CRT UNIT)  X  30B
C
  149 CONTINUE
C RETRIEVE NUMBER AFTER X IN N3
      CALL GTNUM (IDPC,N,II,N3)
C TRANSLATE USER PLOTTER ADDRESS UNITS INTO METACODE ADDRESS UNITS.
      N3 = N3*METUPA
C
      RX = N3
      XX = RX
      YY = RY + REAL(MX)*ST
C PREPARE TO NOT PROCEED IN X DIRECTION FOR NEXT CHARACTER DRAWN.
      MX = 0
      IFLG = 1
C
      GO TO 126
C
C  SET Y  (SPECIFY CRT UNIT)  Y  31B
C
  150 CONTINUE
C RETRIEVE NUMBER AFTER Y IN N3
      CALL GTNUM (IDPC,N,II,N3)
C TRANSLATE USER PLOTTER ADDRESS UNITS INTO METACODE ADDRESS UNITS.
      N3 = N3*METUPA
      RY = N3
      XX = RX+REAL(MX)*CT
      YY = RY
      GO TO 126
C
C END FUNCTION MODE PROCESSING
C
C-----------------------------------------------------------------------
C
C     ESCAPE CHARACTER ERROR
C
  153 CONTINUE
      WRITE(NUNIT,1002)II
      GO TO 104
C
 1001 FORMAT(' THE ',I5,'TH CHARACTER IN IDPC IS THE ',I3,
     +           'TH ILLEGAL FUNCTION CODE.')
 1002 FORMAT(' THE ',I5,'TH CHARACTER IN IDPC IS ILLEGAL')
C
      END

C
C	$Id: gwpasf.f,v 1.5 2008-07-27 00:21:08 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GWPASF
C
C  Update the aspect source flag context.
C
      include 'gksin.h'
      include 'gwiarq.h'
      include 'gwiast.h'
      include 'gwiadc.h'
C
      INTEGER  I
C
      SAVE
C
C  Compute change flags for each GKS ASF;  compute aggregate.
C  The ASF values in GKS are reversed from those in the segments (which
C  are being stored as CGM), so do that complementation here.
C
      ANYASF = .FALSE.
      DO 435 I=1,NGKASF
        MRASF(I) = 1-ID(I)
        ASFCHG(I) = MRASF(I).NE.MSASF(I)
        ANYASF = ANYASF .OR. ASFCHG(I)
  435 CONTINUE
C
C  Compute polyline aggregrate variable.
C  (Note that the logic relies on ASF pointers being a 
C   contiguous sequence).       
C
      DO 436 I=IALTYP,IAPLCI
        AGPEND(1) = AGPEND(1) .OR. ASFCHG(I)
  436 CONTINUE
C
C  Compute polymarker aggregrate variables.
C  (Note that the logic relies on ASF pointers being a
C   contiguous sequence).
C
      DO 437 I=IAMTYP,IAPMCI
        AGPEND(2) = AGPEND(2) .OR. ASFCHG(I)
  437 CONTINUE
C
C  Compute text aggregrate variables.
C  (Note that the logic relies on ASF pointers being a
C   contiguous sequence).
C
      DO 438 I=IATXFP,IATXCI
        AGPEND(3) = AGPEND(3) .OR. ASFCHG(I)
  438 CONTINUE
C
C  Compute fill area aggregrate variables.
C  (Note that the logic relies on ASF pointers being a
C   contiguous sequence).
C
      DO 439 I=IAFAIS,IAFACI
        AGPEND(4) = AGPEND(4) .OR. ASFCHG(I)
  439 CONTINUE
C
      RETURN
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C                Copyright (C)  1995                                   C
C        University Corporation for Atmospheric Research               C
C                All Rights Reserved                                   C
C                                                                      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C      File:           tx05f.f
C
C      Author:         Fred Clare (converted to Fortran by David
C                      Younghans)
C                      National Center for Atmospheric Research
C                      PO 3000, Boulder, Colorado                      
C                      (translated to Fortran by David Younghans)  
C
C      Date:           Tue Nov 21 15:55 MST 1995
C
C      Description:    Demonstrates the TextItem object with text having
C                      various heights and at various angles.
C

      program tx05f
      implicit none

      external NhlFAppClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFCairoWindowWorkstationClass
      external NhlfTextItemclass

      integer   appid, wid, pid, rlist, ierr
      real height, angle, dtr
      real bkg_color(3)
      real x_coord, y_coord
      character*7  wks_type

      dtr=0.017453292519943
      bkg_color(1)=1.0
      bkg_color(2)=1.0
      bkg_color(3)=1.0
C
C Set the display.  Default is to dispaly output to an X workstation.
C
      wks_type = "x11"
C
C Initialize the high level utility library and create application.
C
      call NhlFInitialize
      call NhlFRLCreate(rlist,'SETRL')
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'appUsrDir','./',ierr)
      call NhlFRLSetString(rlist,'appDefaultParent','True',ierr)
      call NhlFCreate(appid,'tx05f',NhlFAppClass,0,rlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create a meta file workstation.
C
        call NhlFRLClear(rlist)
        call NhlFRLSetString(rlist,'wkMetaName','./tx05f.ncgm',ierr)
        call NhlFRLSetFloatArray(rlist,'wkBackgroundColor',
     &       bkg_color,3,ierr)
        call NhlFCreate(wid,'tx05Work',NhlFNcgmWorkstationClass,
     &       0,rlist,ierr)

      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an XWorkstation object.
C
        call NhlFRLClear(rlist)
        call NhlFRLSetInteger(rlist,'wkPause','True',ierr)
        call NhlFRLSetFloatArray(rlist,'wkBackgroundColor',
     &       bkg_color,3,ierr)
        call NhlFCreate(wid,'t x 0 5 W o r leftk',
     &       NhlFCairoWindowWorkstationClass,0, rlist,ierr)

      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PS workstation.
C
        call NhlFRLClear(rlist)
        call NhlFRLSetString(rlist,'wkPSFileName',
     &       './tx05f.ps',ierr)
        call NhlFRLSetFloatArray(rlist,'wkBackgroundColor',
     &       bkg_color,3,ierr)
        call NhlFCreate(wid,'tx05Work',NhlFpsWorkstationClass,
     &       0,rlist,ierr)

      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
        call NhlFRLClear(rlist)
        call NhlFRLSetString(rlist,'wkPDFFileName',
     &       './tx05f.pdf',ierr)
        call NhlFRLSetFloatArray(rlist,'wkBackgroundColor',
     &       bkg_color,3,ierr)
        call NhlFCreate(wid,'tx05Work',NhlFpdfWorkstationClass,
     &       0,rlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF workstation.
C
        call NhlFRLClear(rlist)
        call NhlFRLSetString(rlist,'wkFileName',
     &       './tx05f',ierr)
        call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
        call NhlFRLSetFloatArray(rlist,'wkBackgroundColor',
     &       bkg_color,3,ierr)
        call NhlFCreate(wid,'tx05Work',
     &       NhlFCairoPSpdfWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG workstation.
C
        call NhlFRLClear(rlist)
        call NhlFRLSetString(rlist,'wkFileName',
     &       './tx05f',ierr)
        call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
        call NhlFRLSetFloatArray(rlist,'wkBackgroundColor',
     &       bkg_color,3,ierr)
        call NhlFCreate(wid,'tx05Work',
     &       NhlFCairoImageWorkstationClass,0,rlist,ierr)
      endif
C
C Create a TextItem object.
C
      call NhlFSetColor(wid,1, 0.0, 0.0, 1.0,ierr)
      call NhlFSetColor(wid,2, 0.4, 0.0, 0.4,ierr)

      call NhlFCreate(pid,'TextItems',NhlFTextItemClass,wid,0,ierr)

C
C  Set text font and string.
C

      call NhlFRLClear(rlist)
      call NhlFRLSetInteger(rlist,'txFont',22,ierr)
      call NhlFRLSetString(rlist,'txString', 'NCAR',ierr)
      call NhlFSetValues(pid,rlist,ierr)

C
C Draw string with various heights and at various angles.
C

      angle = 0.0
 100  if (angle .lt. 136.) then
         x_coord = 0.3 + 0.4*cos(dtr*angle)
         y_coord = 0.2 + 0.4*sin(dtr*angle)
         height  = 0.0005*(136.-angle)

         call NhlFRLClear(rlist)
         call NhlFRLSetFloat(rlist,'txAngleF', angle,ierr)
         call NhlFRLSetFloat(rlist,'txPosXF', x_coord,ierr)
         call NhlFRLSetFloat(rlist,'txPosYF', y_coord,ierr)
         call NhlFRLSetFloat(rlist,'txFontHeightF', height,ierr)
         call NhlFSetValues(pid,rlist,ierr)
         call NhlFDraw(pid,ierr)

         if (210.*height .gt. 1.) then
            angle = angle + 210.*height
         else
            angle = angle + 1.
         endif
         
         goto 100
      endif

C
C Text strings at specific angles.
C

      call NhlFRLClear(rlist)
      call NhlFRLSetFloat(rlist,'txAngleF', 180.0,ierr)
      call NhlFRLSetInteger(rlist,'txFont' ,22,ierr)
      call NhlFRLSetInteger(rlist,'txFontColor' ,1,ierr)
      call NhlFRLSetFloat(rlist,'txFontHeightF', 0.04,ierr)
      call NhlFRLSetFloat(rlist,'txPosXF',  0.25,ierr)
      call NhlFRLSetFloat(rlist,'txPosYF',  0.34,ierr)
      call NhlFRLSetString(rlist,'txString', 'NCAR',ierr)
      call NhlFSetValues(pid,rlist,ierr)
      call NhlFDraw(pid,ierr)

      call NhlFRLSetInteger(rlist,'txFontColor' ,2,ierr)
      call NhlFRLSetFloat(rlist,'txFontHeightF', 0.03,ierr)
      call NhlFRLSetFloat(rlist,'txAngleF', 0.0,ierr)
      call NhlFRLSetFloat(rlist,'txPosYF',  0.4,ierr)
      call NhlFRLSetString(rlist,'txString', '180 degrees',ierr)
      call NhlFSetValues(pid,rlist,ierr)
      call NhlFDraw(pid,ierr)

      call NhlFRLClear(rlist)
      call NhlFRLSetFloat(rlist,'txAngleF', -45.0,ierr)
      call NhlFRLSetInteger(rlist,'txFont' ,22,ierr)
      call NhlFRLSetInteger(rlist,'txFontColor' ,1,ierr)
      call NhlFRLSetFloat(rlist,'txFontHeightF', 0.04,ierr)
      call NhlFRLSetFloat(rlist,'txPosXF',  0.7,ierr)
      call NhlFRLSetFloat(rlist,'txPosYF',  0.6,ierr)
      call NhlFRLSetString(rlist,'txString', 'NCAR',ierr)
      call NhlFSetValues(pid,rlist,ierr)
      call NhlFDraw(pid,ierr)

      call NhlFRLSetInteger(rlist,'txFontColor' ,2,ierr)
      call NhlFRLSetFloat(rlist,'txAngleF', 0.0,ierr)
      call NhlFRLSetFloat(rlist,'txFontHeightF', 0.03,ierr)
      call NhlFRLSetFloat(rlist,'txPosXF',  0.73,ierr)
      call NhlFRLSetFloat(rlist,'txPosYF',  0.65,ierr)
      call NhlFRLSetInteger(rlist,'txJust' ,1,ierr)
      call NhlFRLSetString(rlist,'txString', '-45 degrees',ierr)
      call NhlFSetValues(pid,rlist,ierr)
      call NhlFDraw(pid,ierr)

C
C Label the plot.
C

      call NhlFRLClear(rlist)
      call NhlFRLSetFloat(rlist,'txAngleF', 0.0,ierr)
      call NhlFRLSetInteger(rlist,'txFont' ,25,ierr)
      call NhlFRLSetInteger(rlist,'txJust' ,1,ierr)
      call NhlFRLSetInteger(rlist,'txFontColor' ,2,ierr)
      call NhlFRLSetFloat(rlist,'txFontHeightF', 0.05,ierr)
      call NhlFRLSetFloat(rlist,'txPosXF',  0.2,ierr)
      call NhlFRLSetFloat(rlist,'txPosYF',  0.84,ierr)
      call NhlFRLSetString(rlist,'txString', 'Text heights &',ierr)
      call NhlFSetValues(pid,rlist,ierr)
      call NhlFDraw(pid,ierr)

      call NhlFRLSetFloat(rlist,'txPosYF', 0.76,ierr)
      call NhlFRLSetString(rlist,'txString', 'Text angles',ierr)
      call NhlFSetValues(pid,rlist,ierr)
      call NhlFDraw(pid,ierr)
    
      call NhlFFrame(wid,ierr)

      call NhlFDestroy(pid,ierr)
      call NhlFDestroy(wid,ierr)
      call NhlFClose

      stop
      end

C
C	$Id: zlset.f,v 1.5 2008-07-27 00:17:14 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE ZLSET (Z,MX,NX,NY,ZL,NLEVL)
      SAVE
C
      DIMENSION       Z(MX,NY)   ,ZL(NLEVL)
C
      COMMON /HAFTO2/ GLO        ,HA         ,NOPTN      ,ALPHA      ,
     1                NSPV       ,SP         ,ICNST
C
      BIG = R1MACH(2)
C
C ZLSET PUTS THE INTENSITY LEVEL BREAK POINTS IN ZL.
C ALL ARGUMENTS ARE AS IN HAFTON.
C
      LX = NX
      LY = NY
      NLEV = NLEVL
      NOPT = ABS(NOPTN)
      RALPH = 1./ALPHA
      ICNST = 0
      IF (GLO.NE.0. .OR. HA.NE.0.) GO TO 106
C
C FIND RANGE IF NOT KNOWN.
C
      GLO = BIG
      HA = -GLO
      IF (NSPV .NE. 0) GO TO 103
      DO 102 J=1,LY
         DO 101 I=1,LX
            ZZ = Z(I,J)
            GLO = MIN(ZZ,GLO)
            HA = MAX(ZZ,HA)
  101    CONTINUE
  102 CONTINUE
      GO TO 106
  103 DO 105 J=1,LY
         DO 104 I=1,LX
            ZZ = Z(I,J)
            IF (ZZ .EQ. SP) GO TO 104
            GLO = MIN(ZZ,GLO)
            HA = MAX(ZZ,HA)
  104    CONTINUE
  105 CONTINUE
C
C FILL ZL
C
  106 DELZ = HA-GLO
      IF (DELZ .EQ. 0.) GO TO 115
      DZ = DELZ/REAL(NLEV)
      NLEVM1 = NLEV-1
      DO 114 K=1,NLEVM1
         ZNORM = REAL(K)/REAL(NLEV)
         GO TO (107,108,109,110,111),NOPT
C
C NOPT=1
C
  107    ZL(K) = GLO+REAL(K)*DZ
         GO TO 114
C
C NOPT=2
C
  108    ONORM = (1.-(1.-ZNORM)**ALPHA)**RALPH
         GO TO 113
C
C NOPT=3
C
  109    ONORM = 1.-(1.-ZNORM**ALPHA)**RALPH
         GO TO 113
C
C NOPT=4
C
  110    ONORM = .5*(1.-(ABS(ZNORM+ZNORM-1.))**ALPHA)**RALPH
         GO TO 112
C
C NOPT=5
C
  111    ZNORM2 = ZNORM+ZNORM
         IF (ZNORM .GT. .5) ZNORM2 = 2.-ZNORM2
         ONORM = .5*(1.-(1.-ABS(ZNORM2)**ALPHA)**RALPH)
  112    IF (ZNORM .GT. .5) ONORM = 1.-ONORM
  113    ZL(K) = GLO+DELZ*ONORM
  114 CONTINUE
      ZL(NLEV) = BIG
      RETURN
  115 ICNST = 1
      RETURN
      END

C
C	$Id: gqasf.f,v 1.5 2008-07-27 00:20:58 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GQASF(ERRIND,LASF)
C
C  INQUIRE ASPECT SOURCE FLAGS
C
      include 'gkscom.h'
C
      INTEGER ERRIND,LASF(13)
C
C  Check if GKS is in proper state.
C
      CALL GZCKST(8,-1,ERRIND)
C
      IF (ERRIND.NE.0) THEN
        DO 200 I=1,13
          LASF(I) = -1
  200   CONTINUE
      ELSE
        LASF( 1) = CLNA
        LASF( 2) = CLWSCA
        LASF( 3) = CPLCIA
        LASF( 4) = CMKA
        LASF( 5) = CMKSA
        LASF( 6) = CPMCIA
        LASF( 7) = CTXFPA
        LASF( 8) = CCHXPA
        LASF( 9) = CCHSPA
        LASF(10) = CTXCIA
        LASF(11) = CFAISA
        LASF(12) = CFASIA
        LASF(13) = CFACIA
      ENDIF
C
      RETURN
      END

C
C	$Id: conot2.f,v 1.4 2008-07-27 00:16:57 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CONOT2 (IVER,IUNIT)
C
C  OUTPUT THE OPTION VALUES TO THE LINE PRINTER
C
C  CONTINUE FOR CONRAN AND CONRAS
C
C
C
      COMMON /CONRA1/ CL(30)     ,NCL        ,OLDZ       ,PV(210)    ,
     1                FINC       ,HI         ,FLO
      COMMON /CONRA2/ REPEAT     ,EXTRAP     ,PER        ,MESS       ,
     1                ISCALE     ,LOOK       ,PLDVLS     ,GRD        ,
     2                CINC       ,CHILO      ,CON        ,LABON      ,
     3                PMIMX      ,SCALE      ,FRADV      ,EXTRI      ,
     4                BPSIZ      ,LISTOP
      COMMON /CONRA3/ IREC
      COMMON /CONRA4/ NCP        ,NCPSZ
      COMMON /CONRA5/ NIT        ,ITIPV
      COMMON /CONRA6/ XST        ,YST        ,XED        ,YED        ,
     1                STPSZ      ,IGRAD      ,IG         ,XRG        ,
     2                YRG        ,BORD       ,PXST       ,PYST       ,
     3                PXED       ,PYED       ,ITICK
      COMMON /CONR18/ TITLE      ,ICNT   ,ITLSIZ
      COMMON /CONR19/ IHIGH      ,INMAJ      ,INLAB      ,INDAT      ,
     1              LEN      ,IFMT       ,LEND       ,
     2                IFMTD      ,ISIZEP     ,INMIN
      COMMON /CONRA9/ ICOORD(500),NP         ,MXXY       ,TR         ,
     1                BR         ,TL         ,BL         ,CONV       ,
     2                XN         ,YN         ,ITLL       ,IBLL       ,
     3                ITRL       ,IBRL       ,XC         ,YC         ,
     4                ITLOC(210) ,JX         ,JY         ,ILOC       ,
     5                ISHFCT     ,XO         ,YO         ,IOC        ,NC
      COMMON /CONR10/ NT         ,NL         ,NTNL       ,JWIPT      ,
     1                JWIWL      ,JWIWP      ,JWIPL      ,IPR        ,
     2                ITPV
      COMMON /CONR20/ NREP       ,NCRT       ,ISIZEL     ,
     1                MINGAP     ,ISIZEM         ,
     2                TENS
      COMMON /CONR12/ IXMAX      ,IYMAX      ,XMAX       ,YMAX
      LOGICAL         REPEAT     ,EXTRAP     ,PER        ,MESS       ,
     1                LOOK       ,PLDVLS     ,GRD        ,LABON      ,
     2                PMIMX      ,FRADV      ,EXTRI      ,CINC       ,
     3                TITLE      ,LISTOP     ,CHILO      ,CON
      COMMON /CONR15/ ISTRNG
        CHARACTER*64 ISTRNG
        COMMON /CONR16/ FORM
        CHARACTER*10 FORM
        COMMON /CONR17/ NDASH, IDASH, EDASH
        CHARACTER*10 NDASH, IDASH, EDASH
C
C
      SAVE
C
C  LABEL THE CONTOURS
C
      WRITE (IUNIT,1001)
      IF (LABON) GO TO  100
      WRITE (IUNIT,1002)
      GO TO  110
  100 WRITE (IUNIT,1003)
C
C  LABEL SIZE
C
  110 WRITE (IUNIT,1004) ISIZEL
C
C  SCALE DATA ON CONTOURS
C
      WRITE (IUNIT,1005)
      IF (SCALE .NE. 1.) GO TO  120
      WRITE (IUNIT,1006)
      GO TO  130
  120 WRITE (IUNIT,1007) SCALE
C
C  TENSION FACTOR
C
  130 WRITE (IUNIT,1008) TENS
C
C  PLOT RELATIVE MINS AND MAXS
C
      WRITE (IUNIT,1009)
      IF (PMIMX) GO TO  140
      WRITE (IUNIT,1010)
      GO TO  150
  140 WRITE (IUNIT,1011)
C
C  SIZE OF MINIMUM AND MAXIMUM LABELS
C
  150 WRITE (IUNIT,1012) ISIZEM
C
C  DASH PATTERN
C
      WRITE (IUNIT,1013)
      IF (IDASH(1:1) .EQ. ' ') GO TO  170
      WRITE (IUNIT,1014) IDASH
      GO TO  180
  170 WRITE (IUNIT,1015)
  180 IF (EDASH(1:1) .EQ. ' ') GO TO  200
      WRITE (IUNIT,1016) EDASH
      GO TO  210
  200 WRITE (IUNIT,1017)
  210 IF (NDASH(1:1) .EQ. ' ') GO TO  230
      WRITE (IUNIT,1018) NDASH
      GO TO  240
  230 WRITE (IUNIT,1019)
C
C  DASH PATTERN BREAK POINT
C
  240 WRITE (IUNIT,1020) BPSIZ
C
C  PRINT MINOR LINE GAP
C
      ITT = MINGAP-1
      WRITE (IUNIT,1021) ITT
      RETURN
C
 1001 FORMAT (5X,'LABEL THE CONTOURS, LAB=')
 1002 FORMAT ('+',28X,'OFF')
 1003 FORMAT ('+',28X,'ON')
 1004 FORMAT (5X,'CONTOUR LABEL SIZE IN PWRIT UNITS, LSZ=',I4)
 1005 FORMAT (5X,'SCALE THE DATA ON CONTOUR LINES, SDC=')
 1006 FORMAT ('+',41X,'OFF')
 1007 FORMAT ('+','ON, SCALE FACTOR=',G10.3)
 1008 FORMAT (5X,'TENSION FACTOR (USED FOR SMOOTH AND SUPER), TEN=',
     1        F6.2)
 1009 FORMAT (5X,'PLOT RELATIVE MINIMUMS AND MAXIMUMS, PMM=')
 1010 FORMAT ('+',45X,'OFF')
 1011 FORMAT ('+',45X,'ON')
 1012 FORMAT (5X,'SIZE OF MIN AND MAX LABELS IN PWRIT UNITS SML=',
     1        I4)
 1013 FORMAT (5X,'DASH PATTERN GTR=GREATER, EQU=EQUAL, LSS=LESS')
 1014 FORMAT (10X,'GTR=',A10)
 1015 FORMAT (10X,'GTR=$$$$$$$$$$')
 1016 FORMAT (10X,'EQU=',A10)
 1017 FORMAT (10X,'EQU=$$$$$$$$$$')
 1018 FORMAT (10X,'LSS=',A10)
 1019 FORMAT (10X,'LSS=$$$$$$$$$$')
 1020 FORMAT (5X,'DASH PATTERN BREAK POINT, DBP=',G10.3)
 1021 FORMAT (5X,'MINOR LINE COUNT=',I3)
C
C
C******************************************************************
C*                                                                *
C*                   REVISION HISTORY                             *
C*                                                                *
C*  JUNE 1980   ADDED CONTERP TO ULIB                             *
C*  AUGUST 1980 FIXED THE FOLLOWING PROBLEMS                      *
C*              1.PLOTTING OF INPUT DATA VALUES                   *
C*              2.SETTING OF MINIMUM INTENSITY IN ALL OPTION      *
C*              3.SETTING OF EQU FLAG IN CONTOUR DASH PATTERN     *
C*              4.TURNING OFF OF SIZE OF PLOTTED DATA OPTION      *
C*  DECEMBER 1980 FIXED CONTOUR SELECTION ALGORITHM  AND MOVED IN *
C*                DASH PACKAGE COMMON BLOCK INTPR
C*  MARCH 1981  FIXED NON-PORTABLE STATEMENT ORDERING IN CONSET   *
C*  APRIL 1981  FIXED OPTION LISTING ROUTINE                      *
C*              ADDED MINOR LINE COUNT OPTION                     *
C*  JULY 1983   ADDED LINEAR INTERPOLATION AND SHIELDING          *
C*  JULY 1984     CONVERTED TO STANDARD FORTRAN77 AND GKS         *
C*  AUGUST 1985 DELETED LOC (MACHINE DEPENDENT FUNCTION), CHANGED *
C*              COMMON /CONR13/                                   *
C*  JUNE 1988   CHANGED THREE COMMON BLOCK NAMES TO GET RID OF    *
C*              WARNING MESSAGES FROM SEGLDR ON THE CRAY          *
C*                                                                *
C******************************************************************
C
      END

C
C      $Id: cn15f.f,v 1.12 2010-03-16 21:00:45 haley Exp $
C
C***********************************************************************
C                                                                      *
C                Copyright (C)  1997                                   *
C        University Corporation for Atmospheric Research               *
C     The use of this Software is governed by a License Agreement      *
C                                                                      *
C***********************************************************************
C
C  File:       cn15f.f
C
C   Author:     Bob Lackman
C               National Center for Atmospheric Research
C               PO 3000, Boulder, Colorado
C
C   Date:       Wed Jan 24, 1996
C
C   Description:    Combines a contour plot and an xy plot on a
C                   single frame.  Output goes to an X11 window,
C                   an NCGM, *and* a PostScript file.
C
      external NhlFAppClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFCairoWindowWorkstationClass
      external NhlFScalarFieldClass
      external NhlFTextItemClass
      external NhlFCoordArraysClass
      external NhlFContourPlotClass
      external NhlFMapPlotClass
      external NhlFXyPlotClass
      parameter(NLAT=91, NLON=181, NCOLORS=16)
C
C Declare variables for the HLU routine calls.
C
      integer appid, jan, cn, ice, mp, tx, srlist, zonal, xy_plot
C
C Declare variables for color map
C
      integer length(2)
      real cmap(3,NCOLORS)
C
C Declare variables for contour plot fills.
C
      integer linecolors(15),fillcolors(16)
      data linecolors/12,13,14,7,2,0,8,11,6,9,4,3,5,7,10/
      data fillcolors/0,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2/
C
C Declare variables for Tick Mark values.
C
      real xbvalues1(7),xbvalues2(11),ylvalues(7)
      character*4 xblabels1(7)
      character*2 xblabels2(11)
      character*3 yllabels(7)
      data xbvalues1/0,60,120,180,240,300,360/
      data xblabels1/'0','60E','120E','180','120W','60W','0'/
      data xbvalues2/0,3,6,9,12,15,18,21,24,27,30/
      data ylvalues/-90, -60,-30,0,30,60,90/
      data xblabels2/'0','3','6','9','12','15','18','21','24','27','30'/
      data yllabels/'90S','60S','30S','EQ','30N','60N','90N'/
C
C Declare variables to hold contour and xy plot data.
C
      real sstjan(NLON,NLAT), lat(NLAT), zoneave(NLAT)
      integer ocean1
      data zoneave/NLAT*1.e36/
C
C Declare variables for getting information from netCDF file.
C
      integer  ncid, lon_id, lat_id, stid
      integer start(3), count(3), lonlen, latlen
      character*256 filename
      character*50 recname
C
C Output to several workstations.
C
      integer ncgm1, x1, ps1, pdf1, ps2, pdf2, png1
C
C Generate a color map.
C
      cmap(1,1) = 1.00  ! white
      cmap(2,1) = 1.00
      cmap(3,1) = 1.00
      cmap(1,2) = 0.00  ! black
      cmap(2,2) = 0.00
      cmap(3,2) = 0.00
      cmap(1,3) = 0.00  ! blue
      cmap(2,3) = 0.00
      cmap(3,3) = 1.00
      cmap(1,4) = 0.20  ! sky blue
      cmap(2,4) = 0.56
      cmap(3,4) = 0.80
      cmap(1,5) = 0.00  ! cyan
      cmap(2,5) = 1.00
      cmap(3,5) = 1.00
      cmap(1,6) = 0.50  ! blue magenta
      cmap(2,6) = 0.00
      cmap(3,6) = 1.00
      cmap(1,7) = 0.00  ! green
      cmap(2,7) = 1.00
      cmap(3,7) = 0.00
      cmap(1,8) = 0.14  ! forest green
      cmap(2,8) = 0.56
      cmap(3,8) = 0.14
      cmap(1,9) = 1.00  ! yellow
      cmap(2,9) = 1.00
      cmap(3,9) = 0.00
      cmap(1,10) = 1.00  ! orange
      cmap(2,10) = 0.50
      cmap(3,10) = 0.00
      cmap(1,11) = 1.00 ! magenta
      cmap(2,11) = 0.00
      cmap(3,11) = 1.00
      cmap(1,12) = 1.00 ! red
      cmap(2,12) = 0.00
      cmap(3,12) = 0.00
      cmap(1,13) = 0.65 ! brown
      cmap(2,13) = 0.16
      cmap(3,13) = 0.16
      cmap(1,14) = 0.86 ! tan
      cmap(2,14) = 0.58
      cmap(3,14) = 0.44
      cmap(1,15) = 0.66 ! light gray
      cmap(2,15) = 0.66
      cmap(3,15) = 0.66
      cmap(1,16) = 0.40 ! dark gray
      cmap(2,16) = 0.40
      cmap(3,16) = 0.40
C
C Initialize the HLU library and set up resource template.
C A resource file is not used in this example, but if you did
C want one, it would be called "cn15.res".
C
      call NhlFInitialize
      call NhlFRLCreate(srlist,'setrl')
      call NhlFRLClear(srlist)
      call NhlFRLSetString(srlist,'appDefaultParent','True',ierr)
      call NhlFRLSetString(srlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'cn15',NhlFAppClass,0,srlist,ierr)

C
C Create an NCGM workstation.
C
      length(1) = 3
      length(2) = NCOLORS

      call NhlFRLClear(srlist)
      call NhlFRLSetString(srlist,'wkMetaName','./cn15f.ncgm',ierr)
      call NhlFRLSetMDFloatArray(srlist,'wkColorMap',cmap,2,length,
     +     ierr)
      call NhlFCreate(ncgm1,'cn15Work',
     +     NhlFNcgmWorkstationClass,0,srlist,ierr)
C
C Create an XWorkstation object.
C
      call NhlFRLClear(srlist)
      call NhlFRLSetString(srlist,'wkPause','True',ierr)
      call NhlFRLSetMDFloatArray(srlist,'wkColorMap',cmap,2,length,
     +     ierr)
      call NhlFCreate(x1,'cn15Work',
     +     NhlFCairoWindowWorkstationClass,
     +     0,srlist,ierr)
C
C Create an older-style PostScript workstation.
C
      call NhlFRLClear(srlist)
      call NhlFRLSetString(srlist,'wkPSFileName','./cn15f.ps',ierr)
      call NhlFRLSetString(srlist,'wkVisualType','color',ierr)
C
C Since the plots are beside each other, use landscape mode and the
C PostScript resources for positioning the plot on the paper.
C
      call NhlFRLSetString(srlist,'wkOrientation','landscape',ierr)
      call NhlFRLSetInteger(srlist,'wkDeviceLowerX',0,ierr)
      call NhlFRLSetInteger(srlist,'wkDeviceLowerY',60,ierr)
      call NhlFRLSetInteger(srlist,'wkDeviceUpperX',600,ierr)
      call NhlFRLSetInteger(srlist,'wkDeviceUpperY',700,ierr)
      call NhlFRLSetMDFloatArray(srlist,'wkColorMap',cmap,2,length,
     +     ierr)
      call NhlFCreate(ps1,'cn15Work',
     +     NhlFPSWorkstationClass,0,srlist,ierr)
C
C Create an older-style PDF workstation.
C
      call NhlFRLClear(srlist)
      call NhlFRLSetString(srlist,'wkPDFFileName','./cn15f.pdf',ierr)
      call NhlFRLSetString(srlist,'wkVisualType','color',ierr)
C
C Since the plots are beside each other, use landscape mode and the
C PDF resources for positioning the plot on the paper.
C
      call NhlFRLSetString(srlist,'wkOrientation','landscape',ierr)
      call NhlFRLSetInteger(srlist,'wkDeviceLowerX',0,ierr)
      call NhlFRLSetInteger(srlist,'wkDeviceLowerY',60,ierr)
      call NhlFRLSetInteger(srlist,'wkDeviceUpperX',600,ierr)
      call NhlFRLSetInteger(srlist,'wkDeviceUpperY',700,ierr)
      call NhlFRLSetMDFloatArray(srlist,'wkColorMap',cmap,2,length,
     +     ierr)
      call NhlFCreate(pdf1,'cn15Work',
     +     NhlFPDFWorkstationClass,0,srlist,ierr)
C
C Create a cairo PostScript workstation.
C
      call NhlFRLClear(srlist)
      call NhlFRLSetString(srlist,'wkFileName','./cn15f.cairo',ierr)
      call NhlFRLSetString(srlist,'wkFormat','ps',ierr)
C
C Since the plots are beside each other, use landscape mode and the
C PostScript resources for positioning the plot on the paper.
C
      call NhlFRLSetString(srlist,'wkOrientation','landscape',ierr)
      call NhlFRLSetInteger(srlist,'wkDeviceLowerX',0,ierr)
      call NhlFRLSetInteger(srlist,'wkDeviceLowerY',60,ierr)
      call NhlFRLSetInteger(srlist,'wkDeviceUpperX',600,ierr)
      call NhlFRLSetInteger(srlist,'wkDeviceUpperY',700,ierr)
      call NhlFRLSetMDFloatArray(srlist,'wkColorMap',cmap,2,length,
     +     ierr)
      call NhlFCreate(ps2,'cn15Work',
     +     NhlFCairoPSPDFWorkstationClass,0,srlist,ierr)
C
C Create a cairo PDF workstation.
C
      call NhlFRLClear(srlist)
      call NhlFRLSetString(srlist,'wkFileName','./cn15f.cairo',ierr)
      call NhlFRLSetString(srlist,'wkFormat','pdf',ierr)
C
C Since the plots are beside each other, use landscape mode and the
C PostScript resources for positioning the plot on the paper.
C
      call NhlFRLSetString(srlist,'wkOrientation','landscape',ierr)
      call NhlFRLSetInteger(srlist,'wkDeviceLowerX',0,ierr)
      call NhlFRLSetInteger(srlist,'wkDeviceLowerY',60,ierr)
      call NhlFRLSetInteger(srlist,'wkDeviceUpperX',600,ierr)
      call NhlFRLSetInteger(srlist,'wkDeviceUpperY',700,ierr)
      call NhlFRLSetMDFloatArray(srlist,'wkColorMap',cmap,2,length,
     +     ierr)
      call NhlFCreate(pdf2,'cn15Work',
     +     NhlFCairoPSPDFWorkstationClass,0,srlist,ierr)
C
C Create a cairo PNG workstation.
C
      call NhlFRLClear(srlist)
      call NhlFRLSetString(srlist,'wkFileName','./cn15f.cairo',ierr)
      call NhlFRLSetString(srlist,'wkFormat','png',ierr)
      call NhlFRLSetMDFloatArray(srlist,'wkColorMap',cmap,2,length,
     +     ierr)
      call NhlFCreate(png1,'cn15Work',
     +     NhlFCairoImageWorkstationClass,0,srlist,ierr)
C
C Open and read NetCDF file.
C
      call gngpat(filename,'data',ierr)
      do 10 i=1,256
         if( filename(i:i).eq.char(0) ) then
            filename(i:i+21)='/cdf/sstdata_netcdf.nc'
            goto 15
         endif
 10   continue
C      
C The second argument to 'ncopn' should be NCNOWRIT, but since we
C can't include 'netcdf.inc', we are using the value '0' instead.
C
 15   ncid = ncopn(filename,0,ierr)
C
C Get the lat/lon dimensions.
C
      lat_id = ncdid(ncid,'latitude',ierr)
      lon_id = ncdid(ncid,'longitude',ierr)
      call ncdinq(ncid,lat_id,recname,latlen,ierr)
      call ncdinq(ncid,lon_id,recname,lonlen,ierr)

      start(1) = 1
      lat_id = ncvid(ncid,'lat',ierr)
      count(1) = latlen
      call ncvgt(ncid,lat_id,start,count,lat,ierr)
C
C Read in sstdata netCDF file.
C
      stid = ncvid(ncid,'sst',ierr)
      start(1) = 1
      start(2) = 1
      start(3) = 1
      count(1) = lonlen
      count(2) = latlen
      count(3) = 1
      call ncvgt(ncid,stid,start,count,sstjan,ierr)
C
C Close the netCDF file.
C
      call ncclos(ncid,ierr)
C
C Create an sst data object.
C
      count(1) = NLON
      count(2) = NLAT
      call NhlFRLClear(srlist)
      call NhlFRLSetMDFloatArray(srlist,'sfDataArray',sstjan,2,count,
     +     ierr)
      call NhlFRLSetFloat(srlist,'sfXCStartV',0.,ierr)
      call NhlFRLSetFloat(srlist,'sfXCEndV',360.,ierr)
      call NhlFRLSetFloat(srlist,'sfYCStartV',lat(1),ierr)
      call NhlFRLSetFloat(srlist,'sfYCEndV',lat(latlen),ierr)
      call NhlFCreate(jan,'sf',NhlFscalarFieldClass,appid,srlist,
     +     ierr)
C
C Create a ContourPlot object.
C
      call NhlFRLClear(srlist)
      call NhlFRLSetInteger(srlist,'cnScalarFieldData',jan,ierr)
      call NhlFRLSetFloat(srlist,'vpXF',.06,ierr)
      call NhlFRLSetFloat(srlist,'vpYF',.65,ierr)
      call NhlFRLSetFloat(srlist,'vpWidthF',.60,ierr)
      call NhlFRLSetFloat(srlist,'vpHeightF',.30,ierr)
      call NhlFRLSetString(srlist,'cnInfoLabelOn','False',ierr)
      call NhlFRLSetString(srlist,'cnHighLabelsOn','False',ierr)
      call NhlFRLSetString(srlist,'cnLowLabelsOn','False',ierr)
      call NhlFRLSetString(srlist,'cnMonoLineColor','False',ierr)
      call NhlFRLSetIntegerArray(srlist,'cnLineColors',linecolors,15,
     +     ierr)
      call NhlFRLSetString(srlist,'cnLineDrawOrder','predraw',ierr)
      call NhlFRLSetString(srlist,'cnFillDrawOrder','predraw',ierr)
      call NhlFRLSetString(srlist,'cnLabelDrawOrder','predraw',ierr)
      call NhlFRLSetInteger(srlist,'cnLineLabelInterval',2,ierr)
      call NhlFRLSetString(srlist,'cnLineLabelPlacementMode',
     +     'computed',ierr)
      call NhlFRLSetString(srlist,'tmXBMode','EXPLICIT',ierr)
      call NhlFRLSetFloatArray(srlist,'tmXBValues',xbvalues1,7,ierr)
      call NhlFRLSetStringArray(srlist,'tmXBLabels',xblabels1,7,ierr)
      call NhlFRLSetString(srlist,'tmYLMode','EXPLICIT',ierr)
      call NhlFRLSetFloatArray(srlist,'tmYLValues',ylvalues,7,ierr)
      call NhlFRLSetStringArray(srlist,'tmYLLabels',yllabels,7,ierr)
      call NhlFRLSetString(srlist,'tmXTLabelsOn','False',ierr)
      call NhlFRLSetString(srlist,'tmYRLabelsOn','True',ierr)
      call NhlFRLSetFloat(srlist,'tmXBLabelFontHeightF',.010,ierr)
      call NhlFRLSetFloat(srlist,'tmYLLabelFontHeightF',.010,ierr)
      call NhlFRLSetFloat(srlist,'tmXBMajorOutwardLengthF',.006,ierr)
      call NhlFRLSetFloat(srlist,'tmXBMajorLengthF',.006,ierr)
      call NhlFRLSetFloat(srlist,'tmXTMajorLengthF',0.,ierr)
      call NhlFRLSetFloat(srlist,'tmXTMajorOutwardLengthF',0.,ierr)
      call NhlFRLSetFloat(srlist,'tmYLMajorOutwardLengthF',.006,ierr)
      call NhlFRLSetFloat(srlist,'tmYLMajorLengthF',.006,ierr)
      call NhlFRLSetString(srlist,'tmXBMinorOn','False',ierr)
      call NhlFRLSetString(srlist,'tmXTMinorOn','False',ierr)
      call NhlFRLSetString(srlist,'tmYLMinorOn','False',ierr)
      call NhlFRLSetString(srlist,'tmYRMinorOn','False',ierr)
      call NhlFCreate(cn,'cn',NhlFcontourPlotClass,x1,
     +     srlist,ierr)
C
C Create another ContourPlot object.
C
      cellsize = .8/360.
      call NhlFRLClear(srlist)
      call NhlFRLSetInteger(srlist,'cnScalarFieldData',jan,ierr)
      call NhlFRLSetFloat(srlist,'vpXF',.06,ierr)
      call NhlFRLSetFloat(srlist,'vpYF',.65,ierr)
      call NhlFRLSetFloat(srlist,'vpWidthF',.60,ierr)
      call NhlFRLSetFloat(srlist,'vpHeightF',.30,ierr)
      call NhlFRLSetString(srlist,'tmXBOn','False',ierr)
      call NhlFRLSetString(srlist,'tmYLOn','False',ierr)
      call NhlFRLSetString(srlist,'tmXBMinorOn','False',ierr)
      call NhlFRLSetString(srlist,'tmYLMinorOn','False',ierr)
      call NhlFRLSetString(srlist,'tmXBLabelsOn','False',ierr)
      call NhlFRLSetString(srlist,'tmYLLabelsOn','False',ierr)
      call NhlFRLSetFloat(srlist,'tmXBMajorLengthF',0.,ierr)
      call NhlFRLSetFloat(srlist,'tmYLMajorLengthF',0.,ierr)
      call NhlFRLSetString(srlist,'cnFillOn','True',ierr)
      call NhlFRLSetString(srlist,'cnFillMode','RasterFill',ierr)
      call NhlFRLSetFloat(srlist,'cnRasterCellSizeF',cellsize,ierr)
      call NhlFRLSetFloat(srlist,'cnMinLevelValF',-2.0,ierr)
      call NhlFRLSetIntegerArray(srlist,'cnFillColors',fillcolors,16,
     +     ierr)
      call NhlFRLSetString(srlist,'cnLineLabelsOn','False',ierr)
      call NhlFRLSetString(srlist,'cnLinesOn','False',ierr)
      call NhlFRLSetString(srlist,'cnMonoFillColor','False',ierr)
      call NhlFRLSetString(srlist,'cnInfoLabelOn','False',ierr)
      call NhlFRLSetString(srlist,'cnHighLabelsOn','False',ierr)
      call NhlFCreate(ice,'ice',NhlFcontourPlotClass,x1,
     +     srlist,ierr)
C
C Create a MapPlot object.
C
      call NhlFRLClear(srlist)
      call NhlFRLSetFloat(srlist,'vpXF',.06,ierr)
      call NhlFRLSetFloat(srlist,'vpYF',.65,ierr)
      call NhlFRLSetFloat(srlist,'vpWidthF',.60,ierr)
      call NhlFRLSetFloat(srlist,'vpHeightF',.30,ierr)
      call NhlFRLSetString(srlist,'mpFillOn','True',ierr)
      call NhlFRLSetString(srlist,'mpLabelsOn','False',ierr)
      call NhlFRLSetString(srlist,'mpDefaultFillColor','DarkSalmon',
     +     ierr)
      call NhlFRLSetString(srlist,'mpLandFillColor','DarkSalmon',ierr)
      call NhlFRLSetString(srlist,'mpOutlineOn','False',ierr)
      call NhlFRLSetString(srlist,'mpAreaMaskingOn','True',ierr)
      call NhlFRLSetString(srlist,'mpMaskAreaSpecifiers','Oceans',ierr)
      call NhlFRLSetInteger(srlist,'mpInlandWaterFillColor',2,ierr)
      call NhlFRLSetString(srlist,'mpGridAndLimbOn','False',ierr)
      call NhlFRLSetString(srlist,'mpLimitMode','latlon',ierr)
      call NhlFRLSetFloat(srlist,'mpMinLonF',0.,ierr)
      call NhlFRLSetFloat(srlist,'mpMaxLonF',360.,ierr)
      call NhlFRLSetFloat(srlist,'mpCenterLonF',180.,ierr)
      call NhlFCreate(mp,'mp',nhlfmapplotclass,x1,srlist,
     +     ierr)
C
C Create a TextItem object.
C
      call NhlFRLClear(srlist)
      call NhlFRLSetFloat(srlist,'txPosXF',0.5,ierr)
      call NhlFRLSetFloat(srlist,'txPosYF',0.8,ierr)
      call NhlFRLSetString(srlist,'txJust','CENTERCENTER',ierr)
      call NhlFRLSetString(srlist,'txString',
     +     'January Climatological Surface Temperature',ierr)
      call NhlFRLSetFloat(srlist,'txFontHeightF',.030,ierr)
      call NhlFRLSetInteger(srlist,'txFont',25,ierr)
      call NhlFCreate(tx,'tx',nhlftextitemclass,x1,srlist,ierr)
C
C  Read the ocean(1)/land(2) mask ascii dataset created by Areas/Ezmap.
C
      call gngpat(filename,'data',ierr)
      do 20 i=1,256
         if( filename(i:i).eq.char(0) ) then
            filename(i:i+20)='/asc/oceanland30e.asc'
            goto 25
         endif
 20   continue
 25   open(unit=10,file=filename,status='old',form='formatted')
      do nlt=1,NLAT
         ksst   = 0      ! knt the number of grid pts at ocean locations
         sstzon = 0.0    ! save and plt later as [lat vs zoneave]

         do nln=1,NLON    ! loop over all lon at a particular lat
            read(10,*)ocean1
            if (ocean1.eq.1) then
               ksst = ksst+1
               sstzon = sstzon + sstjan(nln,nlt)
            end if
         end do

         if (ksst.ne.0) then
            zoneave(nlt) = sstzon/ksst
         end if

      end do
C
C Create a coordarrays data object.
C
      call NhlFRLClear(srlist)
      call NhlFRLSetFloatArray(srlist,'caYArray',lat,NLAT,ierr)
      call NhlFRLSetFloatArray(srlist,'caXArray',zoneave,NLAT,ierr)
      call NhlFRLSetFloat(srlist,'caXMissingV',1.e36,ierr)
      call NhlFCreate(zonal,'zonal',nhlfcoordarraysclass,appid,srlist,
     +     ierr)
C
C Create XyPlot object and assign data to it.
C
      call NhlFRLClear(srlist)
      call NhlFRLSetFloat(srlist,'vpXF', .73,ierr)
      call NhlFRLSetFloat(srlist,'vpYF', .65,ierr)
      call NhlFRLSetFloat(srlist,'vpWidthF', .25,ierr)
      call NhlFRLSetFloat(srlist,'vpHeightF',.30,ierr)
      call NhlFRLSetInteger(srlist,'xyCoordData', zonal,ierr)
      call NhlFRLSetFloat(srlist,'trYMaxF',90.,ierr)
      call NhlFRLSetFloat(srlist,'trYMinF',-90.,ierr)
      call NhlFRLSetFloat(srlist,'trXMaxF',30.,ierr)
      call NhlFRLSetFloat(srlist,'trXMinF',0.,ierr)
      call NhlFRLSetString(srlist,'tmXTLabelsOn','False',ierr)
      call NhlFRLSetString(srlist,'tmYRLabelsOn','False',ierr)
      call NhlFRLSetString(srlist,'tmYLLabelsOn','False',ierr)
      call NhlFRLSetFloat(srlist,'tmXBMajorLengthF',.006,ierr)
      call NhlFRLSetFloat(srlist,'tmXBMajorOutwardLengthF',.006,ierr)
      call NhlFRLSetFloat(srlist,'tmXBLabelFontHeightF', .010,ierr)
      call NhlFRLSetFloat(srlist,'tmYLMajorOutwardLengthF',.006,ierr)
      call NhlFRLSetFloat(srlist,'tmYLMajorLengthF',.006,ierr)
      call NhlFRLSetFloat(srlist,'tmXTMajorLengthF',0.,ierr)
      call NhlFRLSetFloat(srlist,'tmXTMajorOutwardLengthF',0.,ierr)
      call NhlFRLSetFloat(srlist,'tmYRMajorLengthF',0.,ierr)
      call NhlFRLSetFloat(srlist,'tmYRMajorOutwardLengthF',0.,ierr)
      call NhlFRLSetString(srlist,'tmXBMinorOn','False',ierr)
      call NhlFRLSetString(srlist,'tmYLMinorOn','False',ierr)
      call NhlFRLSetString(srlist,'tmXBMode','EXPLICIT',ierr)
      call NhlFRLSetFloatArray(srlist,'tmXBValues',xbvalues2,11,ierr)
      call NhlFRLSetStringArray(srlist,'tmXBLabels',xblabels2,11,ierr)
      call NhlFCreate(xy_plot,'xy_plot',nhlfxyplotclass,x1,srlist,
     +     ierr)
C
C Draw all objects to X11 window.
C
      call NhlFDraw(ice,ierr)
      call NhlFDraw(cn,ierr)
      call NhlFDraw(mp,ierr)
      call NhlFDraw(xy_plot,ierr)
      call NhlFDraw(tx,ierr)
      call NhlFFrame(x1,ierr)
C
C Reassign the workstation to save an ncgm.
C
      call NhlFChangeWorkstation (ice,ncgm1,ierr)
      call NhlFChangeWorkstation (cn,ncgm1,ierr)
      call NhlFChangeWorkstation (mp,ncgm1,ierr)
      call NhlFChangeWorkstation (xy_plot,ncgm1,ierr)
      call NhlFChangeWorkstation (tx,ncgm1,ierr)
C
C Draw all objects to the NCGM.
C
      call NhlFDraw(ice,ierr)
      call NhlFDraw(cn,ierr)
      call NhlFDraw(mp,ierr)
      call NhlFDraw(xy_plot,ierr)
      call NhlFDraw(tx,ierr)
      call NhlFFrame(ncgm1,ierr)
C
C Reassign the workstation to save PS.
C
      call NhlFChangeWorkstation (ice,ps1,ierr)
      call NhlFChangeWorkstation (cn,ps1,ierr)
      call NhlFChangeWorkstation (mp,ps1,ierr)
      call NhlFChangeWorkstation (xy_plot,ps1,ierr)
      call NhlFChangeWorkstation (tx,ps1,ierr)
C
C Draw all objects to PostScript.
C
      call NhlFDraw(ice,ierr)
      call NhlFDraw(cn,ierr)
      call NhlFDraw(mp,ierr)
      call NhlFDraw(xy_plot,ierr)
      call NhlFDraw(tx,ierr)
      call NhlFFrame(ps1,ierr)

C
C Reassign the workstation to save PDF.
C
      call NhlFChangeWorkstation (ice,pdf1,ierr)
      call NhlFChangeWorkstation (cn,pdf1,ierr)
      call NhlFChangeWorkstation (mp,pdf1,ierr)
      call NhlFChangeWorkstation (xy_plot,pdf1,ierr)
      call NhlFChangeWorkstation (tx,pdf1,ierr)
C
C Draw all objects to PDF.
C
      call NhlFDraw(ice,ierr)
      call NhlFDraw(cn,ierr)
      call NhlFDraw(mp,ierr)
      call NhlFDraw(xy_plot,ierr)
      call NhlFDraw(tx,ierr)
      call NhlFFrame(pdf1,ierr)

C
C Reassign the workstation to save cairo PS.
C
      call NhlFChangeWorkstation (ice,ps2,ierr)
      call NhlFChangeWorkstation (cn,ps2,ierr)
      call NhlFChangeWorkstation (mp,ps2,ierr)
      call NhlFChangeWorkstation (xy_plot,ps2,ierr)
      call NhlFChangeWorkstation (tx,ps2,ierr)
C
C Draw all objects to cairo PostScript.
C
      call NhlFDraw(ice,ierr)
      call NhlFDraw(cn,ierr)
      call NhlFDraw(mp,ierr)
      call NhlFDraw(xy_plot,ierr)
      call NhlFDraw(tx,ierr)
      call NhlFFrame(ps2,ierr)

C
C Reassign the workstation to save cairo PDF.
C
      call NhlFChangeWorkstation (ice,pdf2,ierr)
      call NhlFChangeWorkstation (cn,pdf2,ierr)
      call NhlFChangeWorkstation (mp,pdf2,ierr)
      call NhlFChangeWorkstation (xy_plot,pdf2,ierr)
      call NhlFChangeWorkstation (tx,pdf2,ierr)
C
C Draw all objects to cairo PDF.
C
      call NhlFDraw(ice,ierr)
      call NhlFDraw(cn,ierr)
      call NhlFDraw(mp,ierr)
      call NhlFDraw(xy_plot,ierr)
      call NhlFDraw(tx,ierr)
      call NhlFFrame(pdf2,ierr)

C
C Reassign the workstation to save cairo PNG.
C
      call NhlFChangeWorkstation (ice,png1,ierr)
      call NhlFChangeWorkstation (cn,png1,ierr)
      call NhlFChangeWorkstation (mp,png1,ierr)
      call NhlFChangeWorkstation (xy_plot,png1,ierr)
      call NhlFChangeWorkstation (tx,png1,ierr)
C
C Draw all objects to cairo PNG.
C
      call NhlFDraw(ice,ierr)
      call NhlFDraw(cn,ierr)
      call NhlFDraw(mp,ierr)
      call NhlFDraw(xy_plot,ierr)
      call NhlFDraw(tx,ierr)
      call NhlFFrame(png1,ierr)

C
C Cleanup
C
      call NhlFDestroy(ncgm1,ierr)
      call NhlFDestroy(x1,ierr)
      call NhlFDestroy(ps1,ierr)
      call NhlFDestroy(ps2,ierr)
      call NhlFDestroy(pdf1,ierr)
      call NhlFDestroy(pdf2,ierr)
      call NhlFDestroy(png1,ierr)
      call NhlFDestroy(appid,ierr)
      stop
      end

      SUBROUTINE SGEHRD( N, ILO, IHI, A, LDA, TAU, WORK, LWORK, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      INTEGER            IHI, ILO, INFO, LDA, LWORK, N
*     ..
*     .. Array Arguments ..
      REAL               A( LDA, * ), TAU( * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  SGEHRD reduces a real general matrix A to upper Hessenberg form H by
*  an orthogonal similarity transformation:  Q' * A * Q = H .
*
*  Arguments
*  =========
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  ILO     (input) INTEGER
*  IHI     (input) INTEGER
*          It is assumed that A is already upper triangular in rows
*          and columns 1:ILO-1 and IHI+1:N. ILO and IHI are normally
*          set by a previous call to SGEBAL; otherwise they should be
*          set to 1 and N respectively. See Further Details.
*          1 <= ILO <= IHI <= N, if N > 0; ILO=1 and IHI=0, if N=0.
*
*  A       (input/output) REAL array, dimension (LDA,N)
*          On entry, the N-by-N general matrix to be reduced.
*          On exit, the upper triangle and the first subdiagonal of A
*          are overwritten with the upper Hessenberg matrix H, and the
*          elements below the first subdiagonal, with the array TAU,
*          represent the orthogonal matrix Q as a product of elementary
*          reflectors. See Further Details.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(1,N).
*
*  TAU     (output) REAL array, dimension (N-1)
*          The scalar factors of the elementary reflectors (see Further
*          Details). Elements 1:ILO-1 and IHI:N-1 of TAU are set to
*          zero.
*
*  WORK    (workspace/output) REAL array, dimension (LWORK)
*          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*
*  LWORK   (input) INTEGER
*          The length of the array WORK.  LWORK >= max(1,N).
*          For optimum performance LWORK >= N*NB, where NB is the
*          optimal blocksize.
*
*          If LWORK = -1, then a workspace query is assumed; the routine
*          only calculates the optimal size of the WORK array, returns
*          this value as the first entry of the WORK array, and no error
*          message related to LWORK is issued by XERBLA.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value.
*
*  Further Details
*  ===============
*
*  The matrix Q is represented as a product of (ihi-ilo) elementary
*  reflectors
*
*     Q = H(ilo) H(ilo+1) . . . H(ihi-1).
*
*  Each H(i) has the form
*
*     H(i) = I - tau * v * v'
*
*  where tau is a real scalar, and v is a real vector with
*  v(1:i) = 0, v(i+1) = 1 and v(ihi+1:n) = 0; v(i+2:ihi) is stored on
*  exit in A(i+2:ihi,i), and tau in TAU(i).
*
*  The contents of A are illustrated by the following example, with
*  n = 7, ilo = 2 and ihi = 6:
*
*  on entry,                        on exit,
*
*  ( a   a   a   a   a   a   a )    (  a   a   h   h   h   h   a )
*  (     a   a   a   a   a   a )    (      a   h   h   h   h   a )
*  (     a   a   a   a   a   a )    (      h   h   h   h   h   h )
*  (     a   a   a   a   a   a )    (      v2  h   h   h   h   h )
*  (     a   a   a   a   a   a )    (      v2  v3  h   h   h   h )
*  (     a   a   a   a   a   a )    (      v2  v3  v4  h   h   h )
*  (                         a )    (                          a )
*
*  where a denotes an element of the original matrix A, h denotes a
*  modified element of the upper Hessenberg matrix H, and vi denotes an
*  element of the vector defining H(i).
*
*  =====================================================================
*
*     .. Parameters ..
      INTEGER            NBMAX, LDT
      PARAMETER          ( NBMAX = 64, LDT = NBMAX+1 )
      REAL               ZERO, ONE
      PARAMETER          ( ZERO = 0.0E+0, ONE = 1.0E+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            LQUERY
      INTEGER            I, IB, IINFO, IWS, LDWORK, LWKOPT, NB, NBMIN,
     $                   NH, NX
      REAL               EI
*     ..
*     .. Local Arrays ..
      REAL               T( LDT, NBMAX )
*     ..
*     .. External Subroutines ..
      EXTERNAL           SGEHD2, SGEMM, SLAHRD, SLARFB, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN
*     ..
*     .. External Functions ..
      INTEGER            ILAENV
      EXTERNAL           ILAENV
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters
*
      INFO = 0
      NB = MIN( NBMAX, ILAENV( 1, 'SGEHRD', ' ', N, ILO, IHI, -1 ) )
      LWKOPT = N*NB
      WORK( 1 ) = LWKOPT
      LQUERY = ( LWORK.EQ.-1 )
      IF( N.LT.0 ) THEN
         INFO = -1
      ELSE IF( ILO.LT.1 .OR. ILO.GT.MAX( 1, N ) ) THEN
         INFO = -2
      ELSE IF( IHI.LT.MIN( ILO, N ) .OR. IHI.GT.N ) THEN
         INFO = -3
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -5
      ELSE IF( LWORK.LT.MAX( 1, N ) .AND. .NOT.LQUERY ) THEN
         INFO = -8
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'SGEHRD', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         RETURN
      END IF
*
*     Set elements 1:ILO-1 and IHI:N-1 of TAU to zero
*
      DO 10 I = 1, ILO - 1
         TAU( I ) = ZERO
   10 CONTINUE
      DO 20 I = MAX( 1, IHI ), N - 1
         TAU( I ) = ZERO
   20 CONTINUE
*
*     Quick return if possible
*
      NH = IHI - ILO + 1
      IF( NH.LE.1 ) THEN
         WORK( 1 ) = 1
         RETURN
      END IF
*
*     Determine the block size.
*
      NB = MIN( NBMAX, ILAENV( 1, 'SGEHRD', ' ', N, ILO, IHI, -1 ) )
      NBMIN = 2
      IWS = 1
      IF( NB.GT.1 .AND. NB.LT.NH ) THEN
*
*        Determine when to cross over from blocked to unblocked code
*        (last block is always handled by unblocked code).
*
         NX = MAX( NB, ILAENV( 3, 'SGEHRD', ' ', N, ILO, IHI, -1 ) )
         IF( NX.LT.NH ) THEN
*
*           Determine if workspace is large enough for blocked code.
*
            IWS = N*NB
            IF( LWORK.LT.IWS ) THEN
*
*              Not enough workspace to use optimal NB:  determine the
*              minimum value of NB, and reduce NB or force use of
*              unblocked code.
*
               NBMIN = MAX( 2, ILAENV( 2, 'SGEHRD', ' ', N, ILO, IHI,
     $                 -1 ) )
               IF( LWORK.GE.N*NBMIN ) THEN
                  NB = LWORK / N
               ELSE
                  NB = 1
               END IF
            END IF
         END IF
      END IF
      LDWORK = N
*
      IF( NB.LT.NBMIN .OR. NB.GE.NH ) THEN
*
*        Use unblocked code below
*
         I = ILO
*
      ELSE
*
*        Use blocked code
*
         DO 30 I = ILO, IHI - 1 - NX, NB
            IB = MIN( NB, IHI-I )
*
*           Reduce columns i:i+ib-1 to Hessenberg form, returning the
*           matrices V and T of the block reflector H = I - V*T*V'
*           which performs the reduction, and also the matrix Y = A*V*T
*
            CALL SLAHRD( IHI, I, IB, A( 1, I ), LDA, TAU( I ), T, LDT,
     $                   WORK, LDWORK )
*
*           Apply the block reflector H to A(1:ihi,i+ib:ihi) from the
*           right, computing  A := A - Y * V'. V(i+ib,ib-1) must be set
*           to 1.
*
            EI = A( I+IB, I+IB-1 )
            A( I+IB, I+IB-1 ) = ONE
            CALL SGEMM( 'No transpose', 'Transpose', IHI, IHI-I-IB+1,
     $                  IB, -ONE, WORK, LDWORK, A( I+IB, I ), LDA, ONE,
     $                  A( 1, I+IB ), LDA )
            A( I+IB, I+IB-1 ) = EI
*
*           Apply the block reflector H to A(i+1:ihi,i+ib:n) from the
*           left
*
            CALL SLARFB( 'Left', 'Transpose', 'Forward', 'Columnwise',
     $                   IHI-I, N-I-IB+1, IB, A( I+1, I ), LDA, T, LDT,
     $                   A( I+1, I+IB ), LDA, WORK, LDWORK )
   30    CONTINUE
      END IF
*
*     Use unblocked code to reduce the rest of the matrix
*
      CALL SGEHD2( N, I, IHI, A, LDA, TAU, WORK, IINFO )
      WORK( 1 ) = IWS
*
      RETURN
*
*     End of SGEHRD
*
      END

C
C $Id: clsgks.f,v 1.7 2008-07-27 00:17:23 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CLSGKS
C
C IU(6), in IUTLCM, is the current metacode unit number, negated if the
C unit is currently in use.
C
      COMMON /IUTLCM/ IU(100)
      SAVE /IUTLCM/
C
C Make sure that, if there is an uncleared prior error, the error
C message gets printed.  Go ahead and close GKS, though.
C
      IERR=ICFELL('CLSGKS - UNCLEARED PRIOR ERROR',1)
C
C Deactivate the metacode workstation, close the workstation, and
C close GKS.
C
      CALL GDAWK (1)
      CALL GCLWK (1)
      CALL GCLKS
C
C Set IU(6) to indicate that the unit is no longer in use.
C
      IU(6)=ABS(IU(6))
C
      RETURN
C
      END

      SUBROUTINE DLARRB( N, D, L, LD, LLD, IFIRST, ILAST, SIGMA, RELTOL,
     $                   W, WGAP, WERR, WORK, IWORK, INFO )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      INTEGER            IFIRST, ILAST, INFO, N
      DOUBLE PRECISION   RELTOL, SIGMA
*     ..
*     .. Array Arguments ..
      INTEGER            IWORK( * )
      DOUBLE PRECISION   D( * ), L( * ), LD( * ), LLD( * ), W( * ),
     $                   WERR( * ), WGAP( * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  Given the relatively robust representation(RRR) L D L^T, DLARRB
*  does ``limited'' bisection to locate the eigenvalues of L D L^T,
*  W( IFIRST ) thru' W( ILAST ), to more accuracy. Intervals
*  [left, right] are maintained by storing their mid-points and
*  semi-widths in the arrays W and WERR respectively.
*
*  Arguments
*  =========
*
*  N       (input) INTEGER
*          The order of the matrix.
*
*  D       (input) DOUBLE PRECISION array, dimension (N)
*          The n diagonal elements of the diagonal matrix D.
*
*  L       (input) DOUBLE PRECISION array, dimension (N-1)
*          The n-1 subdiagonal elements of the unit bidiagonal matrix L.
*
*  LD      (input) DOUBLE PRECISION array, dimension (N-1)
*          The n-1 elements L(i)*D(i).
*
*  LLD     (input) DOUBLE PRECISION array, dimension (N-1)
*          The n-1 elements L(i)*L(i)*D(i).
*
*  IFIRST  (input) INTEGER
*          The index of the first eigenvalue in the cluster.
*
*  ILAST   (input) INTEGER
*          The index of the last eigenvalue in the cluster.
*
*  SIGMA   (input) DOUBLE PRECISION
*          The shift used to form L D L^T (see DLARRF).
*
*  RELTOL  (input) DOUBLE PRECISION
*          The relative tolerance.
*
*  W       (input/output) DOUBLE PRECISION array, dimension (N)
*          On input, W( IFIRST ) thru' W( ILAST ) are estimates of the
*          corresponding eigenvalues of L D L^T.
*          On output, these estimates are ``refined''.
*
*  WGAP    (input/output) DOUBLE PRECISION array, dimension (N)
*          The gaps between the eigenvalues of L D L^T. Very small
*          gaps are changed on output.
*
*  WERR    (input/output) DOUBLE PRECISION array, dimension (N)
*          On input, WERR( IFIRST ) thru' WERR( ILAST ) are the errors
*          in the estimates W( IFIRST ) thru' W( ILAST ).
*          On output, these are the ``refined'' errors.
*
*****Reminder to Inder --- WORK is never used in this subroutine *****
*  WORK    (input) DOUBLE PRECISION array, dimension (???)
*          Workspace.
*
*  IWORK   (input) INTEGER array, dimension (2*N)
*          Workspace.
*
*****Reminder to Inder --- INFO is never set in this subroutine ******
*  INFO    (output) INTEGER
*          Error flag.
*
*  Further Details
*  ===============
*
*  Based on contributions by
*     Inderjit Dhillon, IBM Almaden, USA
*     Osni Marques, LBNL/NERSC, USA
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO, TWO, HALF
      PARAMETER          ( ZERO = 0.0D0, TWO = 2.0D0, HALF = 0.5D0 )
*     ..
*     .. Local Scalars ..
      INTEGER            CNT, I, I1, I2, INITI1, INITI2, J, K, NCNVRG,
     $                   NEIG, NINT, NRIGHT, OLNINT
      DOUBLE PRECISION   DELTA, EPS, GAP, LEFT, MID, PERT, RIGHT, S,
     $                   THRESH, TMP, WIDTH
*     ..
*     .. External Functions ..
      DOUBLE PRECISION   DLAMCH
      EXTERNAL           DLAMCH
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, MAX, MIN
*     ..
*     .. Executable Statements ..
*
      EPS = DLAMCH( 'Precision' )
      I1 = IFIRST
      I2 = IFIRST
      NEIG = ILAST - IFIRST + 1
      NCNVRG = 0
      THRESH = RELTOL
      DO 10 I = IFIRST, ILAST
         IWORK( I ) = 0
         PERT = EPS*( ABS( SIGMA )+ABS( W( I ) ) )
         WERR( I ) = WERR( I ) + PERT
         IF( WGAP( I ).LT.PERT )
     $      WGAP( I ) = PERT
   10 CONTINUE
      DO 20 I = I1, ILAST
         IF( I.EQ.1 ) THEN
            GAP = WGAP( I )
         ELSE IF( I.EQ.N ) THEN
            GAP = WGAP( I-1 )
         ELSE
            GAP = MIN( WGAP( I-1 ), WGAP( I ) )
         END IF
         IF( WERR( I ).LT.THRESH*GAP ) THEN
            NCNVRG = NCNVRG + 1
            IWORK( I ) = 1
            IF( I1.EQ.I )
     $         I1 = I1 + 1
         ELSE
            I2 = I
         END IF
   20 CONTINUE
*
*     Initialize the unconverged intervals.
*
      I = I1
      NINT = 0
      RIGHT = ZERO
   30 CONTINUE
      IF( I.LE.I2 ) THEN
         IF( IWORK( I ).EQ.0 ) THEN
            DELTA = EPS
            LEFT = W( I ) - WERR( I )
*
*           Do while( CNT(LEFT).GT.I-1 )
*
   40       CONTINUE
            IF( I.GT.I1 .AND. LEFT.LE.RIGHT ) THEN
               LEFT = RIGHT
               CNT = I - 1
            ELSE
               S = -LEFT
               CNT = 0
               DO 50 J = 1, N - 1
                  TMP = D( J ) + S
                  S = S*( LD( J ) / TMP )*L( J ) - LEFT
                  IF( TMP.LT.ZERO )
     $               CNT = CNT + 1
   50          CONTINUE
               TMP = D( N ) + S
               IF( TMP.LT.ZERO )
     $            CNT = CNT + 1
               IF( CNT.GT.I-1 ) THEN
                  DELTA = TWO*DELTA
                  LEFT = LEFT - ( ABS( SIGMA )+ABS( LEFT ) )*DELTA
                  GO TO 40
               END IF
            END IF
            DELTA = EPS
            RIGHT = W( I ) + WERR( I )
*
*           Do while( CNT(RIGHT).LT.I )
*
   60       CONTINUE
            S = -RIGHT
            CNT = 0
            DO 70 J = 1, N - 1
               TMP = D( J ) + S
               S = S*( LD( J ) / TMP )*L( J ) - RIGHT
               IF( TMP.LT.ZERO )
     $            CNT = CNT + 1
   70       CONTINUE
            TMP = D( N ) + S
            IF( TMP.LT.ZERO )
     $         CNT = CNT + 1
            IF( CNT.LT.I ) THEN
               DELTA = TWO*DELTA
               RIGHT = RIGHT + ( ABS( SIGMA )+ABS( RIGHT ) )*DELTA
               GO TO 60
            END IF
            WERR( I ) = LEFT
            W( I ) = RIGHT
            IWORK( N+I ) = CNT
            NINT = NINT + 1
            I = CNT + 1
         ELSE
            I = I + 1
         END IF
         GO TO 30
      END IF
*
*     While( NCNVRG.LT.NEIG )
*
      INITI1 = I1
      INITI2 = I2
   80 CONTINUE
      IF( NCNVRG.LT.NEIG ) THEN
         OLNINT = NINT
         I = I1
         DO 100 K = 1, OLNINT
            NRIGHT = IWORK( N+I )
            IF( IWORK( I ).EQ.0 ) THEN
               MID = HALF*( WERR( I )+W( I ) )
               S = -MID
               CNT = 0
               DO 90 J = 1, N - 1
                  TMP = D( J ) + S
                  S = S*( LD( J ) / TMP )*L( J ) - MID
                  IF( TMP.LT.ZERO )
     $               CNT = CNT + 1
   90          CONTINUE
               TMP = D( N ) + S
               IF( TMP.LT.ZERO )
     $            CNT = CNT + 1
               CNT = MAX( I-1, MIN( NRIGHT, CNT ) )
               IF( I.EQ.NRIGHT ) THEN
                  IF( I.EQ.IFIRST ) THEN
                     GAP = WERR( I+1 ) - W( I )
                  ELSE IF( I.EQ.ILAST ) THEN
                     GAP = WERR( I ) - W( I-1 )
                  ELSE
                     GAP = MIN( WERR( I+1 )-W( I ), WERR( I )-W( I-1 ) )
                  END IF
                  WIDTH = W( I ) - MID
                  IF( WIDTH.LT.THRESH*GAP ) THEN
                     NCNVRG = NCNVRG + 1
                     IWORK( I ) = 1
                     IF( I1.EQ.I ) THEN
                        I1 = I1 + 1
                        NINT = NINT - 1
                     END IF
                  END IF
               END IF
               IF( IWORK( I ).EQ.0 )
     $            I2 = K
               IF( CNT.EQ.I-1 ) THEN
                  WERR( I ) = MID
               ELSE IF( CNT.EQ.NRIGHT ) THEN
                  W( I ) = MID
               ELSE
                  IWORK( N+I ) = CNT
                  NINT = NINT + 1
                  WERR( CNT+1 ) = MID
                  W( CNT+1 ) = W( I )
                  W( I ) = MID
                  I = CNT + 1
                  IWORK( N+I ) = NRIGHT
               END IF
            END IF
            I = NRIGHT + 1
  100    CONTINUE
         NINT = NINT - OLNINT + I2
         GO TO 80
      END IF
      DO 110 I = INITI1, INITI2
         W( I ) = HALF*( WERR( I )+W( I ) )
         WERR( I ) = W( I ) - WERR( I )
  110 CONTINUE
*
      RETURN
*
*     End of DLARRB
*
      END

      SUBROUTINE SPTTRS( N, NRHS, D, E, B, LDB, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      INTEGER            INFO, LDB, N, NRHS
*     ..
*     .. Array Arguments ..
      REAL               B( LDB, * ), D( * ), E( * )
*     ..
*
*  Purpose
*  =======
*
*  SPTTRS solves a tridiagonal system of the form
*     A * X = B
*  using the L*D*L' factorization of A computed by SPTTRF.  D is a
*  diagonal matrix specified in the vector D, L is a unit bidiagonal
*  matrix whose subdiagonal is specified in the vector E, and X and B
*  are N by NRHS matrices.
*
*  Arguments
*  =========
*
*  N       (input) INTEGER
*          The order of the tridiagonal matrix A.  N >= 0.
*
*  NRHS    (input) INTEGER
*          The number of right hand sides, i.e., the number of columns
*          of the matrix B.  NRHS >= 0.
*
*  D       (input) REAL array, dimension (N)
*          The n diagonal elements of the diagonal matrix D from the
*          L*D*L' factorization of A.
*
*  E       (input) REAL array, dimension (N-1)
*          The (n-1) subdiagonal elements of the unit bidiagonal factor
*          L from the L*D*L' factorization of A.  E can also be regarded
*          as the superdiagonal of the unit bidiagonal factor U from the
*          factorization A = U'*D*U.
*
*  B       (input/output) REAL array, dimension (LDB,NRHS)
*          On entry, the right hand side vectors B for the system of
*          linear equations.
*          On exit, the solution vectors, X.
*
*  LDB     (input) INTEGER
*          The leading dimension of the array B.  LDB >= max(1,N).
*
*  INFO    (output) INTEGER
*          = 0: successful exit
*          < 0: if INFO = -k, the k-th argument had an illegal value
*
*  =====================================================================
*
*     .. Local Scalars ..
      INTEGER            J, JB, NB
*     ..
*     .. External Functions ..
      INTEGER            ILAENV
      EXTERNAL           ILAENV
*     ..
*     .. External Subroutines ..
      EXTERNAL           SPTTS2, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN
*     ..
*     .. Executable Statements ..
*
*     Test the input arguments.
*
      INFO = 0
      IF( N.LT.0 ) THEN
         INFO = -1
      ELSE IF( NRHS.LT.0 ) THEN
         INFO = -2
      ELSE IF( LDB.LT.MAX( 1, N ) ) THEN
         INFO = -6
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'SPTTRS', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 .OR. NRHS.EQ.0 )
     $   RETURN
*
*     Determine the number of right-hand sides to solve at a time.
*
      IF( NRHS.EQ.1 ) THEN
         NB = 1
      ELSE
         NB = MAX( 1, ILAENV( 1, 'SPTTRS', ' ', N, NRHS, -1, -1 ) )
      END IF
*
      IF( NB.GE.NRHS ) THEN
         CALL SPTTS2( N, NRHS, D, E, B, LDB )
      ELSE
         DO 10 J = 1, NRHS, NB
            JB = MIN( NRHS-J+1, NB )
            CALL SPTTS2( N, JB, D, E, B( 1, J ), LDB )
   10    CONTINUE
      END IF
*
      RETURN
*
*     End of SPTTRS
*
      END

C
C       $Id: stdata.f,v 1.15 2008-07-27 00:17:27 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE STDATA
C
C Calling this do-nothing subroutine forces "ld" to load the following
C block data routine (but only if they are in the same ".f" file).
C
        RETURN
C
      END
CNOSPLIT
      BLOCKDATA STDATAX
C
C This routine defines the default values of the Streamline parameters.
C
C ---------------------------------------------------------------------
C
C NOTE:
C Since implicit typing is used for all real and integer variables
C a consistent length convention has been adopted to help clarify the
C significance of the variables encountered in the code for this 
C utility. All local variable and subroutine parameter identifiers 
C are limited to 1,2,or 3 characters. Four character names identify  
C members of common blocks. Five and 6 character variable names 
C denote PARAMETER constants or subroutine or function names.
C
C Declare the ST common blocks.
C
      PARAMETER (IPLVLS = 256)
C
C Integer and real common block variables
C
C
      COMMON / STPAR /
     +                IUD1       ,IVD1       ,IPD1       ,
     +                IXD1       ,IXDM       ,IYD1       ,IYDN       ,
     +                IXM1       ,IYM1       ,IXM2       ,IYM2       ,
     +                IWKD       ,IWKU       ,ISET       ,IERR       ,
     +                IXIN       ,IYIN       ,IMSK       ,ICPM       ,
     +                NLVL       ,IPAI       ,ICTV       ,WDLV       ,
     +                UVMN       ,UVMX       ,PMIN       ,PMAX       ,
     +                IPLR       ,ISST       ,
     +                ICLR(IPLVLS)           ,TVLU(IPLVLS)
C
      COMMON / STTRAN /
     +                UVPS       ,
     +                UVPL       ,UVPR       ,UVPB       ,UVPT       ,
     +                UWDL       ,UWDR       ,UWDB       ,UWDT       ,
     +                UXC1       ,UXCM       ,UYC1       ,UYCN 
C
C Stream algorithm parameters
C
      COMMON / STSTRM /
     +                ISGD       ,IAGD       ,RARL       ,ICKP       ,
     +                ICKX       ,ITRP       ,ICYK       ,RVNL       ,
     +                ISVF       ,RUSV       ,RVSV       ,RNDA       ,
     +                ISPC       ,RPSV       ,RCDS       ,RSSP       ,
     +                RDFM       ,RSMD       ,RAMD       ,IGBS       ,
     +                ISTM       ,RVRL       ,RVFR       ,RVRM       ,
     +                IVPO       ,RAFR       ,RDMX       ,RDMN
C
C Text related parameters
C Note: graphical text output is not yet implemented for the
C       Streamline utility.
C
      COMMON / STTXP /
     +                FCWM    ,ICSZ    ,
     +                FMNS    ,FMNX    ,FMNY    ,IMNP    ,IMNC  ,
     +                FMXS    ,FMXX    ,FMXY    ,IMXP    ,IMXC  ,
     +                FZFS    ,FZFX    ,FZFY    ,IZFP    ,IZFC  ,
     +                FILS    ,FILX    ,FILY    ,IILP    ,IILC 
C
C Character variable declartions
C
      CHARACTER*160 CSTR
      PARAMETER (IPCHSZ=80)
      CHARACTER*(IPCHSZ)  CMNT,CMXT,CZFT,CILT
C
C Text string parameters
C
      COMMON / STCHAR / CSTR,CMNT,CMXT,CZFT,CILT
C
      SAVE /STPAR/, /STTRAN/, /STSTRM/, /STTXP/, /STCHAR/
C
C Internal buffer lengths
C
C IPNPTS - Number of points in the point buffer -- not less than 3
C IPLSTL - Streamline-crossover-check circular list length
C IPGRCT - Number of groups supported for area masking
C
      PARAMETER (IPNPTS = 256, IPLSTL = 750, IPGRCT = 64)
C
C --------------------------------------------------------------------
C
C The mapping common block: made available to user mapping routines
C
      COMMON /STMAP/
     +                IMAP       ,LNLG       ,INVX       ,INVY       ,
     +                XLOV       ,XHIV       ,YLOV       ,YHIV       ,
     +                WXMN       ,WXMX       ,WYMN       ,WYMX       ,
     +                XVPL       ,XVPR       ,YVPB       ,YVPT       ,
     +                XGDS       ,YGDS       ,NXCT       ,NYCT       ,
     +                ITRT       ,FW2W       ,FH2H       ,
     +                DFMG       ,VNML       ,RBIG       ,IBIG
C
      SAVE /STMAP/
C
C Math constants
C
      PARAMETER (PDTOR  = 0.017453292519943,
     +           PRTOD  = 57.2957795130823,
     +           P1XPI  = 3.14159265358979,
     +           P2XPI  = 6.28318530717959,
     +           P1D2PI = 1.57079632679489,
     +           P5D2PI = 7.85398163397448) 
C
C ---------------------------------------------------------------------
C Old STRMLN interface common blocks
C
      COMMON /STR02/  EXT , SIDE , XLT , YBT
C
      COMMON /STR03/  INITA , INITB , AROWL , ITERP , ITERC , IGFLG
     +             ,  IMSG , UVMSG , ICYC , DISPL , DISPC , CSTOP
C
C ---------------------------------------------------------------------
C
C Initialization of STPAR
C
C IUD1 -- 'UD1' -- First dimension of U
C
      DATA     IUD1 / -1 /
C
C IVD1 -- 'VD1' -- First dimension of V
C
      DATA     IVD1 / -1 /
C
C IPD1 -- 'PD1' -- First dimension of P
C
      DATA     IPD1 / -1 /
C
C IXD1 -- 'XD1' -- Array index for start of data, first dimension
C
      DATA     IXD1 / 1 /
C
C IXDM -- 'XDM' -- Array index for end of data, first dimension
C
      DATA     IXDM / -1 /
C
C IYD1 -- 'YD1' -- Array index for start of data, second dimension
C
      DATA     IYD1 / 1 /
C   
C IYDN -- 'YDN' -- Array index for end of data, second dimension
C
      DATA     IYDN / -1 /
C
C IWKD -- 'WKD' -- Dimension of work array
C
      DATA     IWKD / -1 /
C
C IWKU -- 'WKU' -- Amount of work array actually used (read-only)
C
      DATA     IWKU / 0 /
C
C ISET -- 'SET' -- The Set call flag - Old NSET parameter
C
      DATA     ISET / 1 /
C
C IERR -- 'ERR' -- Error code set by STRMLN (read-only)
C                  -101 - Cyclic flag set for non-cyclic data
C
      DATA     IERR / 0 /
C
C
C IXIN -- 'XIN' -- The X Axis grid increment, must be > 0
C IYIN -- 'YIN' -- The Y Axis grid increment, must be > 0
C
      DATA IXIN / 1 /
      DATA IYIN / 1 /
C
C IXM1 -- (IXDM - 1) (not user accessible)
C IXM2 -- (IXDM - 2) (not user accessible)
C IYM1 -- (IYDN - 1) (not user accessible)
C IYM2 -- (IYDN - 2) (not user accessible)
C
C IMSK -- 'MSK' -- Mask streamlines to an area map: <1 -- no mapping,
C                  >=1 - mapping;
C
      DATA IMSK / 0 /
C
C ICPM -- 'CPM' -- the compatibility mode. If >0 the FX,FY,
C                  functions are used. Additionally, when
C                  used in conjunction with the STRMLN routine, 
C                  has a meaningful range from -4 to +4 inclusive,
C                  where various combinations are allowed to use or
C                  ignore 1) the optional input parameters to
C                  VELVCT, 2) the data in STR01,STR02,STR03,STR04
C                  common, 3) FX, etc routines, as follows:
C
C                  -4: no FX, ignore params, ignore old common data
C                  -3: no FX, ignore params, use old common data
C                  -2: no FX, use params, ignore old common data
C                  -1: no FX, use params, use old common data
C                   0: default, same as -4 if STINIT,STREAM called,
C                      same as +1 if STRMLN or EZSTRM called
C                  +1: FX, use params, use old common data
C                  +2: FX, use params, ignore old common data
C                  +3: FX, ignore params, use old common data
C                  +4: FX, ignore params, ignore old common data
C
C                  FX means using FX,FY
C                  When parameters and common block values are
C                  used they override any values set using the
C                  STSETx routines
C
      DATA ICPM / 0 /
C
C NLVL -- 'NLV' -- number of distinct colors to use for the
C                    independent variable mapping -- cannot exceed
C                    IPLVLS -- default: 16
C                    
      DATA  NLVL /  0 /
C
C IPAI -- 'PAI' -- the current level -- must be set before 
C                   modifying an internal level array value
C
      DATA   IPAI /   1     /
C
C ICTV -- 'CTV' -- compute thresholds flag:
C                  -2: color by scalar value, user sets TVL
C                  -1: color by vector magnitude, user sets TVL
C                   0: no coloring
C                  +1: color by magnitude, STINIT sets TVL
C                  +2: color by scalar array, STINIT sets TVL
C
      DATA  ICTV /   0     /
C
C WDLV -- 'LWD' -- the width of a streamline
C 
      DATA  WDLV /   1.0   /
C
C UVMN -- 'VMN' -- the minimum displayed vector magnitude, read-only
C UVMX -- 'VMX' -- the maximum displayed vector magnitude, read-only
C PMIN -- 'PMN' -- the minimum scalar array value, read-only
C PMAX -- 'PMX' -- the maximum scalar array value, read-only
C
      DATA UVMN / 0.0 /
      DATA UVMX / 0.0 /
      DATA PMIN / 0.0 /
      DATA PMAX / 0.0 /
C
C IPLR -- 'PLR' -- Polar coordinates for UV array flag
C
      DATA IPLR / 0 /
C
C ISST -- 'SST' -- Streamline statistics flag
C
      DATA ISST / 0 /
C
C ICLR -- 'CLR' -- the GKS color index value
C
      DATA  ICLR / IPLVLS * 1 /
C
C TVLU -- 'TVL' -- the list of threshold values
C
      DATA  TVLU / IPLVLS * 0.0 /
C
C End of STPAR intialization
C
C --------------------------------------------------------------------
C
C STTRAN initialization 
C
C User coordinate system to viewport, UV array to user coordinates
C
C UVPS -- 'VPS' -- The viewport mode
C
      DATA UVPS / 0.25 /
C
C UVPL -- 'VPL' -- Viewport left
C
      DATA UVPL / 0.05 /
C
C UVPR -- 'VPR' -- Viewport right
C
      DATA UVPR / 0.95 /
C
C UVPB -- 'VPB' -- Viewport bottom
C
      DATA UVPB / 0.05 /
C
C UVPT -- 'VPT' -- Viewport top
C
      DATA UVPT / 0.95 /
C
C UWDL -- 'WDL' -- Window left
C
      DATA UWDL / 0.0 /
C
C UWDR -- 'WDR' -- Window right
C
      DATA UWDR / 0.0 /
C
C UWDB -- 'WDB' -- Window bottom
C
      DATA UWDB / 0.0 /
C
C UWDT -- 'WDT' -- Window top
C
      DATA UWDT / 0.0 /
C
C UXC1 -- 'XC1' -- minimum X coord
C
      DATA UXC1 / 0.0 /
C
C UXCM -- 'XCM' -- maximum Y coord
C
      DATA UXCM / 0.0 /
C
C UYC1 -- 'YC1' -- minimum Y coord
C
      DATA UYC1 / 0.0 /
C
C UYCN -- 'YCN' -- maximum Y coord
C
      DATA UYCN / 0.0 /
C
C End of STTRAN
C ----------------------------------------------------------------------
C
C STSTRM - Parameters affecting the stream processing algorithm
C
C ISGD -- 'SGD' - Stream starting grid increment (INITA)
C
      DATA ISGD / 2 /
C
C IAGD -- 'AGD' - Arrow placement grid increment (INITB)
C
      DATA IAGD / 2 /
C
C RARL -- 'ARL' - Length of one side of arrow as fraction 
C                 of the viewport width (replaces AROWL)
C
      DATA RARL / 0.012 /
C
C ICKP -- 'CKP' - Check progress after this many iterations (ITERP)
C
      DATA ICKP / 35 /
C
C ICKX -- 'CKX' - Check streamline crossover after this many 
C                 iterations (ITERC). (If negative crossover is 
C                 checked at each entrance to a new grid cell)
C
      DATA ICKX / -99 /
C
C ITRP -- 'TRP' - Interpolaton method (IGFLG)
C                 0 - Use 16 point bessel where possible
C                 non 0 - use bi-linear interpolation everywhere
C
      DATA ITRP / 0 /
C
C ICYK -- 'CYK' - Cyclical data flag (ICYC) If non-zero, instructs
C                 the utility to use cyclic interpolation formulas.
C                 If set and data is non-cyclic the error flag is set.
C
      DATA ICYK / 0 /
C
C RVNL -- 'VNL' - Normalization factor for the differential magnitude.
C                 This controls number of steps in compatibility mode
C                 only when the FX,FY mapping routines are used. See 
C                 parameter 'DFM' for step control when STMPXY and
C                 associated routines are used
C
      DATA RVNL / 0.33 /
C
C ISVF -- 'SVF' - Special value flag  (IMSG)
C                 0 - no special values
C                 non 0 - there may be special values, use only
C                         bi-linear interpolation
      DATA ISVF / 0 /
C
C RUSV -- 'USV' -- The U array special value (UVMSG)
C
      DATA RUSV / 1.0E12 /
C
C RVSV -- 'VSV' -- The V array special value (UVMSG)
C
      DATA RVSV / 1.0E12 /
C
C RNDA -- assigned the NDC value of the arrow size.
C
C ISPC -- 'SPC' -- Special color -- 
C                      < 0: no P special value
C                      >= 0: draw P special values using color SPC
C
      DATA ISPC / -1 /
C
C RPSV -- 'PSV' -- The P array special value
C 
      DATA RPSV / 1.0E12 /
C
C RCDS -- 'CDS' - The critical displacement as a multiple of 'DFM'.
C                 Replaces DISPC. If the streamline has not moved
C                 CDS*DFM units in NDC space after ICKP iterations,
C                 the streamline is terminated
C
      DATA RCDS / 2.0 /
C
C RSSP -- 'SSP' - Stream spacing value as a fraction of the viewport
C                 width; replaces CSTOP. Checked when a new grid box is
C                 entered.
C
      DATA RSSP / 0.015 /
C
C RDFM -- 'DFM' - Differential magnitude as a fraction of the viewport
C                 width. Smaller values result in more steps and a more
C                 accurate approximation of the streamline.
C
      DATA RDFM / 0.02 /
C
C RSMD -- 'SMD' - Streamline minimum starting distance as fraction
C                 of viewport width.
C
      DATA RSMD / 0.0 /
C
C RAMD -- 'AMD' - Arrow minimum distance as a fraction of the 
C                 viewport width.
C
      DATA RAMD / 0.0 /
C
C IGBS -- 'GBS' - Grid based spacing flag
C
      DATA IGBS / 0 /
C
C ISTM -- 'STM' - Streamline mode (0 - normal, 1 - curly vectors)
C
      DATA ISTM / 0 /
C
C RVRL -- 'VRL' - Curly vector mode only: Vector reference length
C                 (if 0.0 streamlines selects the value) -- as
C                 fraction of viewport width.
C
      DATA RVRL / 0.0 /
C
C RVFR -- 'VFR' - Curly vector mode only: Fraction of the maximum 
C                 length used to represent the minimum length vector. 
C                 1.0 causes all vectors to become maximum length. 
C                 0.0 means the minimum length is linearly scaled 
C                 from the maximum length.
C
      DATA RVFR / 0.0 /
C
C RVRM -- 'VRM' - Curly vector mode only: Reference magnitude - 
C                 the magnitude represented by the reference length.
C                 If 0.0, the maximum magnitude is used as the 
C                 reference magnitude.
C
      DATA RVRM / 0.0 /
C
C IVPO -- 'VPO' -- Curly vector mode only: 
C                  vector position flag: < 0 - head at position,
C                                          0 - center at position, 
C                                        > 0 - tail at position
C
      DATA IVPO / 0 /
C
C RAFR -- 'AFR' - Curly vector mode only: fraction of full size
C                 arrow length used for minimum arrow; others are
C                 proportionally scaled. If 0.0 scaling is strictly
C                 proportional
C
      DATA RAFR / 1.0 /
C
C RDMX -- 'DMX' - Curly vector mode only: (read only)
C                 NDC length of maximum vector
C
      DATA RDMX / 0.0 /
C
C RDMN -- 'DMN' - Curly vector mode only: (read only)
C                 NDC length of minimum vector
C
      DATA RDMN / 0.0 /
C
C End of STSTRM
C --------------------------------------------------------------------
C
C STTXP - Text parameters 
C
C ICCM -- internal - maximum length of character strings
C
      DATA ICSZ / IPCHSZ /
C
C FZFS -- 'ZFS' -- size of text for zero field string as FVPW
C FZFX -- 'ZFX' -- X position of zero field string as FVPW
C FZFY -- 'ZFY' -- Y position of zero field string as FVPW
C IZFP -- 'ZFP' -- zero field string position flag
C IZFC -- 'ZFC' -- color of text for zero field label
C 
      DATA FZFS / 0.033 /
      DATA FZFX / 0.5 /
      DATA FZFY / 0.5 /
      DATA IZFP / 0 /
      DATA IZFC / -1 /
C
C ---------------------------------------------------------------------
C
C Beginning of STCHAR initialization
C
      DATA CZFT / 'ZERO FIELD' /
C
C End of STCHAR initialization
C
C
C ---------------------------------------------------------------------
C
C STMAP initialization
C
C IMAP -- 'MAP' -- the mapping transformation to use
C
      DATA  IMAP / 0 /
C
C ITRT -- 'TRT' -- Transform type flag: 
C                      0  - transform position only
C                      1  - transform position and angle
C                     -1  - transform position, angle, and magnitude
C
      DATA ITRT / 1 /
C
C XVPL,XVPT,YVPB,YVPT -- the viewport values (NDC boundaries)
C
C WXMN,WXMX,WYMN,WYMX -- the window minimum and maximum values
C                        (User coordinate space)
C
C XLOV,XHIV,YLOV,YHIV -- the mapped array endpoint values
C                        (Data coordinate space)
C
C XGDS,YGDS -- size in data coordinates of a grid box
C
C NXCT,NYCT -- number of points in X and Y used for the plot
C
C DFMG -- The magnitude of the diffential increment in NDC space
C
C LNLG -- the log scale mapping flag from SET call
C
C INVX,INVY -- inverse flags for the window boundaries
C
C IWCT - unused
C
C FW2W,FH2H -- fraction of viewport to fraction of viewspace
C
C RBIG,IBIG -- maximum expressible real and integer values
C
C ---------------------------------------------------------------------
C
C STRMLN compatibility common blocks
C
C Beginning of STR02 initialization
C
      DATA EXT  / 0.25 /
      DATA SIDE / 0.90  /
      DATA XLT  / 0.05 /
      DATA YBT  / 0.05 /
C
C End of STR02 initialization
C
C Beginning of STR03 initialization
C
      DATA INITA  / 2 /
      DATA INITB  / 2  /
      DATA AROWL  / 0.33 /
      DATA ITERP  / 35 /
      DATA ITERC  / -99 /
      DATA IGFLG  / 0 /
      DATA ICYC   / 0 /
      DATA IMSG   / 0 /
      DATA UVMSG  / 1.E+36 /
      DATA DISPL  / 0.33 /
      DATA DISPC  / 0.67 /
      DATA CSTOP  / 0.50 /
C
C End of STR03 initialization
C
      END

C
C       $Id: strset.f,v 1.11 2008-07-27 00:17:28 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
C
C-----------------------------------------------------------------------
C
      SUBROUTINE STRSET
C
C This subroutine may be called to reset all variables which have
C default values to those values.
C
C ---------------------------------------------------------------------
C
C NOTE:
C Since implicit typing is used for all real and integer variables
C a consistent length convention has been adopted to help clarify the
C significance of the variables encountered in the code for this 
C utility. All local variable and subroutine parameter identifiers 
C are limited to 1,2,or 3 characters. Four character names identify  
C members of common blocks. Five and 6 character variable names 
C denote PARAMETER constants or subroutine or function names.
C
C Declare the ST common blocks.
C
      PARAMETER (IPLVLS = 256)
C
C Integer and real common block variables
C
C
      COMMON / STPAR /
     +                IUD1       ,IVD1       ,IPD1       ,
     +                IXD1       ,IXDM       ,IYD1       ,IYDN       ,
     +                IXM1       ,IYM1       ,IXM2       ,IYM2       ,
     +                IWKD       ,IWKU       ,ISET       ,IERR       ,
     +                IXIN       ,IYIN       ,IMSK       ,ICPM       ,
     +                NLVL       ,IPAI       ,ICTV       ,WDLV       ,
     +                UVMN       ,UVMX       ,PMIN       ,PMAX       ,
     +                IPLR       ,ISST       ,
     +                ICLR(IPLVLS)           ,TVLU(IPLVLS)
C
      COMMON / STTRAN /
     +                UVPS       ,
     +                UVPL       ,UVPR       ,UVPB       ,UVPT       ,
     +                UWDL       ,UWDR       ,UWDB       ,UWDT       ,
     +                UXC1       ,UXCM       ,UYC1       ,UYCN 
C
C Stream algorithm parameters
C
      COMMON / STSTRM /
     +                ISGD       ,IAGD       ,RARL       ,ICKP       ,
     +                ICKX       ,ITRP       ,ICYK       ,RVNL       ,
     +                ISVF       ,RUSV       ,RVSV       ,RNDA       ,
     +                ISPC       ,RPSV       ,RCDS       ,RSSP       ,
     +                RDFM       ,RSMD       ,RAMD       ,IGBS       ,
     +                ISTM       ,RVRL       ,RVFR       ,RVRM       ,
     +                IVPO       ,RAFR       ,RDMX       ,RDMN
C
C Text related parameters
C Note: graphical text output is not yet implemented for the
C       Streamline utility.
C
      COMMON / STTXP /
     +                FCWM    ,ICSZ    ,
     +                FMNS    ,FMNX    ,FMNY    ,IMNP    ,IMNC  ,
     +                FMXS    ,FMXX    ,FMXY    ,IMXP    ,IMXC  ,
     +                FZFS    ,FZFX    ,FZFY    ,IZFP    ,IZFC  ,
     +                FILS    ,FILX    ,FILY    ,IILP    ,IILC 
C
C Character variable declartions
C
      CHARACTER*160 CSTR
      PARAMETER (IPCHSZ=80)
      CHARACTER*(IPCHSZ)  CMNT,CMXT,CZFT,CILT
C
C Text string parameters
C
      COMMON / STCHAR / CSTR,CMNT,CMXT,CZFT,CILT
C
      SAVE /STPAR/, /STTRAN/, /STSTRM/, /STTXP/, /STCHAR/
C
C Internal buffer lengths
C
C IPNPTS - Number of points in the point buffer -- not less than 3
C IPLSTL - Streamline-crossover-check circular list length
C IPGRCT - Number of groups supported for area masking
C
      PARAMETER (IPNPTS = 256, IPLSTL = 750, IPGRCT = 64)
C
C --------------------------------------------------------------------
C
C The mapping common block: made available to user mapping routines
C
      COMMON /STMAP/
     +                IMAP       ,LNLG       ,INVX       ,INVY       ,
     +                XLOV       ,XHIV       ,YLOV       ,YHIV       ,
     +                WXMN       ,WXMX       ,WYMN       ,WYMX       ,
     +                XVPL       ,XVPR       ,YVPB       ,YVPT       ,
     +                XGDS       ,YGDS       ,NXCT       ,NYCT       ,
     +                ITRT       ,FW2W       ,FH2H       ,
     +                DFMG       ,VNML       ,RBIG       ,IBIG
C
      SAVE /STMAP/
C
C Math constants
C
      PARAMETER (PDTOR  = 0.017453292519943,
     +           PRTOD  = 57.2957795130823,
     +           P1XPI  = 3.14159265358979,
     +           P2XPI  = 6.28318530717959,
     +           P1D2PI = 1.57079632679489,
     +           P5D2PI = 7.85398163397448) 
C
C ---------------------------------------------------------------------
C
C Reset individual parameters.
C
C Common block STPAR
C
      IUD1 = -1
      IVD1 = -1
      IPD1 = -1
      IXD1 = 1
      IXDM = -1
      IYD1 = 1
      IYDN = -1
      IWKD = -1
      IWKU = 0
      ISET = 1
      IERR = 0
      IXIN = 1
      IYIN = 1
      IMSK = 0
      ICPM = 0
      NLVL = 0
      IPAI = 1
      ICTV = 0
      WDLV = 1.0
      UVMN = 0.0
      UVMX = 0.0
      PMIN = 0.0
      PMAX = 0.0
      ITHN = 0
      IMAP = 0
      IPLR = 0
      ISST = 0
C
C Parameter arrays
C
      DO 101 I=1,IPLVLS,1
         ICLR(I) = 1
         TVLU(I) = 0.0
 101  CONTINUE
C
C
C ---------------------------------------------------------------------
C
C STTRAN
C
      UVPS = 0.25
      UVPL = 0.05
      UVPR = 0.95
      UVPB = 0.05
      UVPT = 0.95
      UWDL = 0.0
      UWDR = 0.0
      UWDB = 0.0
      UWDT = 0.0
      UXC1 = 0.0
      UXCM = 0.0
      UYC1 = 0.0
      UYCN = 0.0
C
C ---------------------------------------------------------------------
C
C STSTRM
C
      ISGD = 2
      IAGD = 2
      RARL = 0.012
      ICKP = 35
      ICKX = -99
      ITRP = 0
      ICYK = 0
      RVNL = 0.33
      ISVF = 0
      RUSV = 1.0E12
      RVSV = 1.0E12
      RPSV = 1.0E12
      ISPC = -1
      RCDS = 2.0
      RSSP = 0.015
      RDFM = 0.02
      RSMD = 0.0
      RAMD = 0.0
      IGBS = 0
      ISTM = 0
      RVRL = 0.0
      RVFR = 0.0
      RVRM = 0.0
      IVPO = 0
      RAFR = 1.0
      RDMX = 0.0
      RDMN = 0.0
C
C ---------------------------------------------------------------------
C
C
      FZFS = 0.033
      FZFX = 0.5
      FZFY = 0.5
      IZFP = 0
      IZFC = -1
C
C ---------------------------------------------------------------------
C
C STCHAR values
C
      CZFT = 'ZERO FIELD'
C
C ---------------------------------------------------------------------
C
C STMAP values
C
      IMAP = 0
      ITRT = 1
      IBIG = I1MACH(9)
      RBIG = R1MACH(2)
C
C ---------------------------------------------------------------------
C
C Done
C
      RETURN
C
      END

C
C $Id: mdgcog.f,v 1.8 2008-09-18 00:42:17 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MDGCOG (CLAT,CLON,CRAD,ALAT,ALON,NPTS)
C
C This routine returns, in the arrays ALAT and ALON, the latitudes and
C longitudes of NPTS points on the surface of the globe, all of them at
C the great-circle distance CRAD from the point (CLAT,CLON), defining a
C circle.  The last point returned is a copy of the first.
C
        DOUBLE PRECISION CLAT,CLON,CRAD,ALAT(*),ALON(*)
        INTEGER          NPTS
C
C Declare common block containing math constants.
C
        COMMON /MAPCM0/  COS1,DTOR,DTRH,OOPI,PI,PIOF,PIOT,RTDD,RTOD,
     +                   SROT,SIN1,TOPI,TSRT
        DOUBLE PRECISION COS1,DTOR,DTRH,OOPI,PI,PIOF,PIOT,RTDD,RTOD,
     +                   SROT,SIN1,TOPI,TSRT
        SAVE   /MAPCM0/
C
C Declare local variables.
C
        DOUBLE PRECISION RLAT,RLON,UCRD,VCRD,WCRD
        INTEGER          IPNT
C
C Points on a circle around the North Pole are rotated to lie around
C the point at latitude CLAT and longitude CLON.
C
        RLAT=DTOR*(90.-CRAD)
C
        DO 101 IPNT=1,NPTS
          RLON=DTOR*360.D0*(DBLE(IPNT-1)/DBLE(NPTS-1))
          UCRD=COS(RLAT)*COS(RLON)
          VCRD=COS(RLAT)*SIN(RLON)
          WCRD=SIN(RLAT)
          CALL MDRITD (2,90.D0-CLAT,UCRD,VCRD,WCRD)
          CALL MDRITD (3,      CLON,UCRD,VCRD,WCRD)
          ALAT(IPNT)=RTOD*ASIN(MAX(-1.D0,MIN(+1.D0,WCRD)))
          ALON(IPNT)=RTOD*ATAN2(VCRD,UCRD)
  101   CONTINUE
C
C Done.
C
        RETURN
C
      END

C
C	$Id: reset.f,v 1.4 2008-07-27 00:23:04 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE RESET
C
C USER ENTRY POINT.
C RESET INITIALIZES ALL POINTS IN THE MODEL PICTURE TO UNMARKED.
C
      LOGICAL LDUMMY
      SAVE
C
      CALL REMOVE (0,0,LDUMMY,1)
      RETURN
      END

C
C $Id: bcseti.f,v 1.4 2008-07-27 00:17:29 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE BCSETI(PA,IVAL)
C
C Set integer-valued parameters for the Bezier curve package.
C
C Arguments
C     Input   PA       Character string indicating parameter
C                      to be set.
C             IVAL     An integer value for setting PA.
C

      CHARACTER*(*) PA
      CHARACTER*3   CTMP
C
      include 'bccom.h'
C
      CTMP = PA(1:3)
C
      IF (CTMP.EQ.'NPC' .OR. CTMP.EQ.'npc') THEN
C
C  Set flag to indicate number of points on a curve.
C
        NPPC = IVAL
      ELSE
        WRITE(I1MACH(4),500) CTMP
      ENDIF
C
      RETURN
C
  500 FORMAT(' BCSETI -- Invalid keyword = ',A3,', no action taken')
C
      END

      PROGRAM AGEX07
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Define the data arrays and the dash-pattern array.
C
      REAL XDRA(101),YDRA(101,9)
      CHARACTER*28 DSHP(9)
C
C Declare the type of the dash-pattern-name generator.
C
      CHARACTER*16 AGDSHN
C
C Initialize GKS.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Fill the data arrays and the dash pattern array.
C
      DO 101 I=1,101
        XDRA(I)=-90.+1.8*REAL(I-1)
  101 CONTINUE
C
      DO 103 J=1,9
        WRITE (DSHP(J),1001) J
        FJ=J
        DO 102 I=1,101
          YDRA(I,J)=3.*FJ-(FJ/2700.)*XDRA(I)**2
  102   CONTINUE
  103 CONTINUE
C
C Turn on windowing.
C
      CALL AGSETI ('WINDOWING.',1)
C
C Move the edges of the curve window (grid).
C
      CALL AGSETF ('GRID/LEFT.'  ,.10)
      CALL AGSETF ('GRID/RIGHT.' ,.90)
      CALL AGSETF ('GRID/BOTTOM.',.10)
      CALL AGSETF ('GRID/TOP.'   ,.85)
C
C Set the x and y minimum and maximum.
C
      CALL AGSETF ('X/MINIMUM.',-90.)
      CALL AGSETF ('X/MAXIMUM.',+90.)
      CALL AGSETF ('Y/MINIMUM.',  0.)
      CALL AGSETF ('Y/MAXIMUM.', 18.)
C
C Set left axis parameters.
C
      CALL AGSETI ('LEFT/MAJOR/TYPE.',1)
      CALL AGSETF ('LEFT/MAJOR/BASE.',3.)
      CALL AGSETI ('LEFT/MINOR/SPACING.',2)
C
C Set right axis parameters.
C
      CALL AGSETI ('RIGHT/FUNCTION.',1)
      CALL AGSETF ('RIGHT/NUMERIC/TYPE.',1.E36)
C
C Set bottom axis parameters.
C
      CALL AGSETI ('BOTTOM/MAJOR/TYPE.',1)
      CALL AGSETF ('BOTTOM/MAJOR/BASE.',15.)
      CALL AGSETI ('BOTTOM/MINOR/SPACING.',2)
C
C Set top axis parameters.
C
      CALL AGSETI ('TOP/FUNCTION.',2)
      CALL AGSETF ('TOP/NUMERIC/TYPE.',1.E36)
C
C Set up the dash patterns to be used.
C
      CALL AGSETI ('DASH/SELECTOR.',9)
      CALL AGSETI ('DASH/LENGTH.',28)
      DO 104 I=1,9
        CALL AGSETC (AGDSHN(I),DSHP(I))
  104 CONTINUE
C
C Set up the left label.
C
      CALL AGSETC ('LABEL/NAME.','L')
      CALL AGSETI ('LINE/NUMBER.',100)
      CALL AGSETC ('LINE/TEXT.','HEIGHT (KILOMETERS)$')
C
C Set up the right label.
C
      CALL AGSETC ('LABEL/NAME.','R')
      CALL AGSETI ('LINE/NUMBER.',-100)
      CALL AGSETC ('LINE/TEXT.',
     +             'PRESSURE (TONS/SQUARE FURLONG)$')
C
C Set up the bottom labels.
C
      CALL AGSETC ('LABEL/NAME.','B')
      CALL AGSETI ('LINE/NUMBER.',-100)
      CALL AGSETC ('LINE/TEXT.','LATITUDE (DEGREES)$')
C
      CALL AGSETC ('LABEL/NAME.','SP')
      CALL AGSETF ('LABEL/BASEPOINT/X.',.000001)
      CALL AGSETF ('LABEL/BASEPOINT/Y.',0.)
      CALL AGSETF ('LABEL/OFFSET/Y.',-.015)
      CALL AGSETI ('LINE/NUMBER.',-100)
      CALL AGSETC ('LINE/TEXT.','SP$')
C
      CALL AGSETC ('LABEL/NAME.','NP')
      CALL AGSETF ('LABEL/BASEPOINT/X.',.999999)
      CALL AGSETF ('LABEL/BASEPOINT/Y.',0.)
      CALL AGSETF ('LABEL/OFFSET/Y.',-.015)
      CALL AGSETI ('LINE/NUMBER.',-100)
      CALL AGSETC ('LINE/TEXT.','NP$')
C
C Set up the top label.
C
      CALL AGSETC ('LABEL/NAME.','T')
      CALL AGSETI ('LINE/NUMBER.',80)
      CALL AGSETC ('LINE/TEXT.',
     +             'DISTANCE FROM EQUATOR (MILES)$')
      CALL AGSETI ('LINE/NUMBER.',90)
      CALL AGSETC ('LINE/TEXT.',' $')
      CALL AGSETI ('LINE/NUMBER.',100)
      CALL AGSETC ('LINE/TEXT.',
     +             'LINES OF CONSTANT INCRUDESCENCE$')
      CALL AGSETI ('LINE/NUMBER.',110)
      CALL AGSETC ('LINE/TEXT.','EXAMPLE 7 (EZMXY)$')
C
C Set up centered (box 6) label.
C
      CALL AGSETC ('LABEL/NAME.','EQUATOR')
      CALL AGSETI ('LABEL/ANGLE.',90)
      CALL AGSETI ('LINE/NUMBER.',0)
      CALL AGSETC ('LINE/TEXT.','EQUATOR$')
C
C Draw a boundary around the edge of the plotter frame.
C
      CALL BNDARY
C
C Draw the graph, using EZMXY.
C
      CALL EZMXY (XDRA,YDRA,101,9,101,CHAR(0))
C
C Close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
C
C Format for encode above.
C
 1001 FORMAT ('$$$$$$$$$$$$$$$$$$$$$''J''=''',I1,'''')
C
      END
      SUBROUTINE AGUTOL (IAXS,FUNS,IDMA,VINP,VOTP)
C
C Mapping for the right axis.
C
      IF (FUNS.EQ.1.) THEN
        IF (IDMA.GT.0) VOTP=ALOG10(20.-VINP)
        IF (IDMA.LT.0) VOTP=20.-10.**VINP
C
C Mapping for the top axis.
C
      ELSE IF (FUNS.EQ.2.) THEN
        IF (IDMA.GT.0) VOTP=70.136*VINP
        IF (IDMA.LT.0) VOTP=VINP/70.136
C
C Default (identity) mapping.
C
      ELSE
        VOTP=VINP
      END IF
C
C Done.
C
      RETURN
C
      END
      SUBROUTINE BNDARY
C
C Routine to draw the plotter-frame edge.
C
      CALL PLOTIT (    0,    0,0)
      CALL PLOTIT (32767,    0,1)
      CALL PLOTIT (32767,32767,1)
      CALL PLOTIT (    0,32767,1)
      CALL PLOTIT (    0,    0,1)
      RETURN
      END

C
C	$Id: gflas1.f,v 1.7 2008-07-27 00:17:13 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GFLAS1(INAME)
C
C_BEGIN PROLOGUE GFLAS1
C
C_PURPOSE
C    A call to this subroutine flags that all subsequently generated
C    plotting instructions should be saved only in Workstation
C    Independent Segment Storage until a call to GFLAS2 is made.
C
C_DESCRIPTION
C    A call to this subroutine flags that all subsequently generated
C    plotting instructions should be saved only in Workstation
C    Independent Segment Storage (WISS) until a call to GFLAS2 is made.
C    Consult the documentation to GFLAS2 for its usage.
C
C    WISS must be open before calling GFLAS1.  If using NCAR GKS, a
C    call to GOPWK with final argument 3 will suffice for this; if
C    using a non-NCAR GKS, the final argument to GOPWK must be the
C    workstation type of WISS.  Consult GKS documentation for details
C    on the arguments to GOPWK.
C
C_ARGUMENTS
C
C INAME   (INPUT,SINGLE,VARIABLE)  An integer variable in the range
C         [0,99] which is used as a user-defined identifier for the
C         dataset of graphics instructions to be saved between the
C         GFLAS1 call and a subsequent GFLAS2 call.
C
C_I/O
C    GFLAS1 initiates output to WISS.  If using the NCAR GKS
C    package, the output disk file is opened.
C
C_ROUTINES CALLED
C    PLOTIT, SETER
C
C_COMMON BLOCKS
C    GFLASH
C
C_MAXIMUM GKS LEVEL
C    2A
C
C_LANGUAGE
C    FORTRAN
C
C_REVISION DATE
C    890117 (YYMMDD)
C
C_HISTORY
C    This subroutine was coded at NCAR by Fred Clare.  Its purpose
C    is to duplicate the functionality of the previous NCAR System
C    Plot Package entry FLASH1 in a GKS environment.
C
C_REFERENCES
C    "The System Plot Package", NCAR Technical Note number
C    NCAR-TN/162+IA, May, 1983.
C
C    "NCAR Graphics User's Guide", Version 2.00, NCAR Technical Note
C    number NCAR/TN-283+IA, August, 1987.
C
C_LONG DESCRIPTION
C    WISS must be open before calling GFLAS1.  GFLAS1 closes all
C    currently active workstations except WISS, and activates WISS.
C    This results in all subsequent plotting instructions being sent
C    only to WISS.  If one is using the NCAR GKS package, WISS is
C    implemented on the disk of the host machine, and plotting
C    instructions are saved on disk.  By default, the flash buffers
C    (or segments in GKS parlance) are named as "GSEGuuuupppp_nn" 
C    where "uuuu" is the user id, and "pppp" is the process id, 
C    and "nn" is the buffer ID provided in the argument INAME 
C    (described above).  These are put in a temporary directory and
C    automatically deleted when WISS is closed.  There is no way
C    to save these files.  The only way to save flash buffers is
C    to name them, using ESCAPE -1389 to supply a root name.  These
C    files will be written to the local current directory.  All files 
C    with names beginning with "GSEG" will be deleted when WISS is 
C    closed; all other files will not be deleted.  To save just a 
C    single flash buffer, set the root name to something different 
C    than "GSEG" and then write that segment, then change the root 
C    back to "GSEG".
C
C    It is not legal to call FRAME (or clear workstations) between a
C    GFLAS1 call and a GFLAS2 call.
C
C_EXAMPLES
C    Example 1 --  Save a text string in a flash buffer (see GFLAS2
C                  for usage of that subroutine.)
C          SUBROUTINE SVTXT
C          CALL GFLAS1(9)
C          CALL GTX(.5,.5,'STRING')
C          CALL GFLAS2
C          RETURN
C          END
C
C_END PROLOGUE GFLAS1
C
C-------------------------------------------------------------------------
C
C  IOPWKS is an array containing the workstation identifiers for
C  all open workstations; IOACT is an array of flags indicating
C  whether the open workstation is also active.
C
      COMMON /GFLASH/MODEF,IOPWKS(100),IOACT(100),NUMOP,IWISSI
C
C     CHARACTER*80 IDR(1),ODR(1)
C
      SAVE
C
C  Do a call forcing a BLOCKDATA to be loaded from a binary library.
C
      CALL GFLSBD
C
C  Check on proper mode value (MODEF keeps track of where we are
C  in a GFLASH sequence.)
C
      IF (MODEF .EQ. 1) GO TO 101
      MODEF = 1
C
C  Inform NCAR GKS that we are in GFLAS1
C
C     IDR(1) = '1'
C     IFID = -1394
C     CALL PLOTIT(0,0,2)
C     CALL GESC(IFID,1,IDR,1,IDUM,ODR)
C     CALL PLOTIT(0,0,2)
C
C  Check on the range of the input argument.
C
      IBNAME = INAME
      IF (IBNAME.LT.0 .OR. IBNAME.GT.99) GO TO 108
C
C  Check if GKS is open.
C
      CALL GQOPS(IOPSTA)
      IF (IOPSTA .LT. 1) GO TO 109
C
C  Make sure that this GKS implementation has WISS (level 2).
C
      CALL GQEWK(1,IER,NUMB,NTYP)
      DO 10 I=1,NUMB
        CALL GQEWK(I,IER,NUMB,NTYP)
        CALL GQWKCA(NTYP,IER,NCAT)
        IF (NCAT .EQ. 3) GO TO 20
   10 CONTINUE
      GO TO 102
   20 CONTINUE
C
C  Make sure that WISS is open (IWISSI is initialized to an
C  arbitrary illegal value).
C
      IWISSI = -1335
      CALL GQOPWK(1,IER,IOL,IWKID)
      NUMOP = IOL
      IF (NUMOP .LT. 1) GO TO 103
      IF (NUMOP .GT. 100) GO TO 104
      DO 30 I=1,NUMOP
        CALL GQOPWK(I,IER,IOL,IOPWKS(I))
        IOACT(I) = 0
        CALL GQWKS(IOPWKS(I),IER,IOACT(I))
        CALL GQWKC(IOPWKS(I),IER,ICON,ITYPE)
        CALL GQWKCA(ITYPE,IER,ICAT)
        IF (ICAT .EQ. 3) IWISSI = IOPWKS(I)
   30 CONTINUE
      IF (IWISSI .EQ. -1335) GO TO 103
C
C  De-activate all active workstations.
C
      DO 40 I=1,NUMOP
      IF (IOACT(I) .EQ. 1) THEN
        CALL GDAWK(IOPWKS(I))
      ENDIF
   40 CONTINUE
C
C  Activate WISS.
C
      CALL GACWK(IWISSI)
C
C  Flush PLOTIT buffer.
C
      CALL PLOTIT(0,0,2)
C
C  If segment name is currently in use, delete it.
C
      CALL GQSGUS(1,IER,IOL,ISGNA)
      IF (IOL .GT. 0) THEN
        DO 50 I=1,IOL
        CALL GQSGUS(I,IER,IOL,ISGNA)
        IF (ISGNA .EQ. INAME) THEN
          CALL GDSG(INAME)
          GO TO 60
        ENDIF
   50   CONTINUE
      ENDIF
   60 CONTINUE
C
C  Create segment.
C
      CALL GCRSG(INAME)
      RETURN
C
  101 CONTINUE
      CALL GECLKS
      CALL SETER(' GFLAS1 -- GFLAS1 CALLED CONSECUTIVELY WITHOUT AN INTE
     -RVENING GFLSH2 CALL',1,2)
      STOP
  102 CONTINUE
      CALL GECLKS
      CALL SETER(' GFLAS1 -- THE NON NCAR GKS PACKAGE IS NOT LEVEL 2',
     -           2,2)
      STOP
  103 CONTINUE
      CALL GECLKS
      CALL SETER(' GFLAS1 -- WISS MUST BE OPEN BEFORE CALL TO GFLAS1',
     -           3,2)
      STOP
  104 CONTINUE
      CALL GECLKS
      CALL SETER(' GFLAS1 -- MAXIMUM NUMBER OF OPEN WORKSTATIONS ALLOWED
     - IS 100',4,2)
      STOP
  108 CONTINUE
      CALL GECLKS
      CALL SETER(' GFLAS1 -- BUFFER IDENTIFIER .LT. 0, OR .GT. 99',8,2)
      STOP
  109 CONTINUE
      CALL GECLKS
      CALL SETER(' GFLAS1 -- GKS MUST BE OPEN BEFORE A CALL TO GFLAS1',
     -  9,2)
      STOP
C
      END

C
C       $Id: init3d.f,v 1.5 2008-07-27 00:17:16 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE INIT3D (EYE,NU,NV,NW,ST1,LX,NY,IS2,IU,S)
C
C ISO-SURFACE PACKAGE FOR HIGH RESOLUTION 3-DIMENSIONAL ARRAYS
C
C
C DIMENSION OF           EYE(3),ST1(NV,NW,2),IS2(LX,NY),S(4),
C ARGUMENTS              IOBJS(MV,NW)
C
C PURPOSE                This package of three routines produces a
C                        perspective picture of an arbitrary object or
C                        group of objects with the hidden parts not
C                        drawn.  The objects are assumed to be stored
C                        in the format described below, a format which
C                        was chosen to facilitate the display of
C                        functions of three variables  or output from
C                        high resolution three-dimensional computer
C                        simulations.
C
C
C USAGE                  The object is defined by setting elements in a
C                        three-dimensional array to one where the object
C                        is and zero where it is not.  That is, the
C                        position in the array corresponds to a position
C                        in three-space, and the value of the array
C                        tells whether any object is present at that
C                        position or not.  Because a large array is
C                        needed to define objects with good resolution,
C                        only a part of the array is passed to the
C                        package with each call.
C
C                        There are two subroutines in the package.
C                        INIT3D is called at the beginning of a picture.
C                        This call can be skipped sometimes if certain
C                        criteria are met and certain precautions are
C                        taken.  See the 'TIMING' section for details.
C                        DANDR (Draw AND Remember) is called
C                        successively to process different parts of the
C                        three-dimensional array.  For example,
C                        one plane would be processed in the
C                        first call to DANDR, while a different plane
C                        would be processed in a subsequent call.  An
C                        example follows:
C
C                             CALL INIT3D(EYE,NU,NV,NW,ST1,LX,NY,
C                                         IS2,IU,S)
C                             DO 1 IBKWDS = 1,NU
C                             I = NU+1-IBKWDS
C                        C  FORM OR READ SLAB I OF THE 3 DIMENSIONAL
C                        C  ARRAY
C                        C  ONLY 1 OR 0 IN THE SLAB, CALLED IOBJS
C                              . . .
C                           1 CALL DANDR(NV,NW,ST1,LX,NX,NY,IS2,IU,S,
C                                        IOBJS,MV)
C
C ARGUMENTS
C
C ON INPUT               EYE
C                          An array, dimensioned 3, containing the U, V,
C                          and W coordinates of the eye position.  Objects
C                          are considered to be in a box with 2 extreme
C                          corners at (1,1,1) and (NU,NV,NW).  The eye
C                          position must have positive coordinates away
C                          from the coordinate planes U = 0, V = 0, and
C                          W = 0.  While gaining experience with the
C                          package, use EYE(1) = 5*NU, EYE(2) = 4*NV,
C                          EYE(3) = 3*NW.
C
C                        NU
C                          U direction length of the box containing the
C                          objects.
C
C                        NV
C                          V direction length of the box containing the
C                          objects.
C
C                        NW
C                          W direction length of the box containing the
C                          objects.
C
C                        ST1
C                          A scratch array at least NV*NW*2 words long.
C
C                        LX
C                          The number of words needed to hold NX bits.
C                          Also, the first dimension of IS2.  See NX
C                          and IS2.  On a 60 bit machine, LX=(NX-1)/60+1.
C
C                        NY
C                          Number of cells in the Y-direction of the
C                          model of the image plane.  Also the second
C                          dimension of IS2.
C
C                        IS2
C                          An array holding the image plane model.  It
C                          is dimensioned LX by NY.  The model is NX by
C                          NY and packed densely.  If hidden lines are
C                          drawn, decrease NX and NY (and LX if
C                          possible).  If visible lines are left out of
C                          the picture, increase NX and NY (and LX if
C                          need be).  As a guide, some examples showing
C                          successful choices are listed:
C
C                            GIVEN  NU  NV NW           RESULTING NX  NY
C                                                       FROM TESTING
C                            -------------------------------------------
C                                  100 100 60                    200 200
C                                   60  60 60                    110 110
C                                   40  40 40                     75  75
C
C                        IU
C                          Unit number of scratch file for the package.
C                          ST1 will be written NU times on this file.
C
C                        S
C                          A real array, dimensioned 4, which contains the
C                          world coordinates of the area where the picture
C                          is to be drawn.  That is, all plotting
C                          coordinates generated will be bounded as
C                          follows:  X coordinates will be between S(1)
C                          and S(2), Y coordinates will be between S(3)
C                          and S(4).  To prevent distortion, have
C                          S(2)-S(1) = S(4)-S(3).
C                          10.0 .LE. S(I) .LE. 1010.0   for I = 1,2,3,4.
C
C                        IOBJS
C                          A NV by NW array (with actual first dimension
C                          MV in the calling program) describing the
C                          object.  If this is the Ith call to DANDR,
C                          the part of the picture at U = NU+1-I is to
C                          be processed.  IOBJS defines the objects to
C                          be drawn in the following manner:
C                          IOBJS(J,K) = 1 if any object contains the
C                          point (NU+1-I,J,K) and IOBJS(J,K) = 0
C                          otherwise.
C
C                        NX
C                          This variable is an argument to DANDR.  It is
C                          the number of cells in the X-direction of a
C                          model of the image plane.  A silhouette of
C                          the parts of the picture processed so far is
C                          stored in this model.  Lines to be drawn are
C                          tested for visibility by examining the
C                          silhouette.  Lines in the silhouette are
C                          hidden.  Lines out of the silhouette are
C                          visible.  The solution is approximate
C                          because the silhouette is not formed exactly.
C                          See IS2.
C
C                        MV
C                          Actual first dimension of IOBJS in the
C                          calling program.  When plotting all of IOBJS,
C                          NV = MV.
C
C ON OUTPUT              EYE, NU, NV, NW, LX, NX, NY, IU, S, IOBJS, and
C                        MV are unchanged.  ST1 and IS2 have been
C                        written in.
C
C NOTE                   This routine is for large arrays, 40 x 40 x 30
C                        is a practical minimum.
C
C ENTRY POINTS           INIT3D, PERSPC, AND DANDR
C
C COMMON BLOCKS          None
C
C I/O                    Plots visible surfaces, uses scratch file or
C                        tape.
C
C PRECISION              Single
C
C LANGUAGE               FORTRAN 77
C
C HISTORY                Originally developed at NCAR starting in
C                        late 1970.
C
C ALGORITHM              The basic method is to contour cuts through
C                        the array starting with a cut nearest the
C                        observer.  The algorithm leaves out the hidden
C                        parts of the contours by suppressing those lines
C                        enclosed within the lines produced while processing
C                        the preceding cuts.  The technique is described
C                        in detail in the reference cited below.
C
C REQUIRED GKS LEVEL     0A
C
C REFERENCE              Wright, T.:  A One-pass Hidden-line Remover for
C                        Computer Drawn Three-space Objects.  Proc 1972
C                        Summer Computer Simulation Conference, 261-267,
C                        1972.
C
C ACCURACY               The algorithm is not exact.  However,
C                        reasonable pictures are produced.
C
C TIMING                 This routine is very time consuming.  If many
C                        pictures are produced with the same size arrays
C                        and eye position, much time can be saved by
C                        rewinding unit IU, filling IS2 with zeros, and
C                        skipping the call to INIT3D for other than the
C                        first picture.
C
C PORTABILITY            Two machine dependent constants are initialized
C                        in DANDR.  INIT3D has an entry statement for
C                        PERSPC.  In DANDR, .AND. and .OR. are used for
C                        masking operations.
C
C
C
      DIMENSION       EYE(3)     ,ST1(NV,NW,2)           ,IS2(LX,NY) ,
     1                S(4)
C
        SAVE
C
C THE FOLLOWING CALL IS FOR GATHERING STATISTICS ON LIBRARY USE AT NCAR
      CALL Q8QST4('GRAPHX','ISOSRFHR','INIT3D','VERSION  1')
C
C SET UP TRANSFORMATION ROUTINE FOR THIS LINE OF SIGHT.
C
      GO TO 101
C
C     ENTRY PERSPC(X,Y,Z,XT,YT,ZT)
C
      ENTRY PERSPC
      GO TO 122
  101 U = NU
      V = NV
      W = NW
      AX = U*.5
      AY = V*.5
      AZ = W*.5
      EX = EYE(1)
      EY = EYE(2)
      EZ = EYE(3)
      DX = AX-EX
      DY = AY-EY
      DZ = AZ-EZ
      D = SQRT(DX*DX+DY*DY+DZ*DZ)
      COSAL = DX/D
      COSBE = DY/D
      COSGA = DZ/D
      AL = ACOS(COSAL)
      BE = ACOS(COSBE)
      GA = ACOS(COSGA)
      SINGA = SIN(GA)
C
C TEST FOR CLOSE TO VERTICAL
C
      IF (SINGA .LT. 0.0001) GO TO 102
      R = 1./SINGA
      JUMP = 1
      GO TO 103
  102 SINBE = SIN(BE)
      R = 1./SINBE
      JUMP = 2
  103 X = 1.
      Y = 1.
      Z = W
      IBAK = 1
      GO TO 123
  104 YTS = YT
      X = U
      Y = V
      Z = 1.
      IBAK = 2
      GO TO 123
  105 YB = YT
      Y = 1.
      IBAK = 3
      GO TO 123
  106 XL = XT
      X = 1.
      Y = V
      IBAK = 4
      GO TO 123
  107 XR = XT
C
C MAKE SCREEN SQUARE
C
      DIF = (XR-XL-YTS+YB)*.5
      IF (DIF) 108,110,109
  108 XL = XL+DIF
      XR = XR-DIF
      GO TO 110
  109 YB = YB-DIF
      YTS = YTS+DIF
  110 REWIND IU
      C1 = .9*(S(2)-S(1))/(XR-XL)
      C2 = .05*(S(2)-S(1))+S(1)
      C3 = .9*(S(4)-S(3))/(YTS-YB)
      C4 = .05*(S(4)-S(3))+S(3)
      COSALR = COSAL*R*C1
      QF1 = (EX*COSAL+EY*COSBE+EZ*COSGA)/D
      RC3 = R*C3
      COSALD = COSAL/D
      COSBED = COSBE/D
      COSGAD = COSGA/D
C
C TRANSFORM GRID POINTS INTO 2-SPACE
C
      GO TO (111,115),JUMP
  111 COSBER = COSBE*R*C1
      X1F1 = (EX-AX)*COSBER+(AY-EY)*COSALR-C1*XL+C2
      X1F2 = EY*COSALR-EX*COSBER
      Y1F1 = (EZ-AZ)*RC3-C3*YB+C4
      DO 114 I=1,NU
         X = NU+1-I
         QI1 = X*COSALD-QF1
         XF1 = X*COSBER+X1F2
         DO 113 J=1,NV
            Y = J
            QI2 = Y*COSBED+QI1
            YF1 = XF1-Y*COSALR
            DO 112 K=1,NW
               Z = K
               QI3 = Z*COSGAD+QI2
               ST1(J,K,1) = X1F1+YF1/QI3
               ST1(J,K,2) = Y1F1+RC3*(Z-EZ)/QI3
  112       CONTINUE
  113    CONTINUE
         WRITE (IU) ST1
  114 CONTINUE
      GO TO 119
  115 COSGAR = COSGA*R*C1
      X2F1 = (EZ-AZ)*COSALR+(AX-EX)*COSGAR-C1*XL+C2
      X2F2 = EX*COSGAR-EZ*COSALR
      Y2F1 = (EY-AY)*RC3-C3*YB+C4
      DO 118 I=1,NU
         X = NU+1-I
         QI1 = X*COSALD-QF1
         XF1 = X2F2-X*COSGAR
         DO 117 J=1,NV
            Y = J
            QI2 = Y*COSBED+QI1
            YF1 = (Y-EY)*RC3
            DO 116 K=1,NW
               Z = K
               QI3 = Z*COSGAD+QI2
               ST1(J,K,1) = X2F1+(XF1+Z*COSALR)/QI3
               ST1(J,K,2) = Y2F1+YF1/QI3
  116       CONTINUE
  117    CONTINUE
         WRITE (IU) ST1
  118 CONTINUE
  119 REWIND IU
C
C ZERO OUT SCREEN MODEL
C
      DO 121 J=1,NY
         DO 120 I=1,LX
            IS2(I,J) = 0
  120    CONTINUE
  121 CONTINUE
      RETURN
C
C RETAIN OLD CODE FOR TRANSFORMING OUTER POINTS
C
  122 IBAK = 5
  123 Q = D/((X-EX)*COSAL+(Y-EY)*COSBE+(Z-EZ)*COSGA)
      GO TO (124,125),JUMP
  124 XT = ((EX+Q*(X-EX)-AX)*COSBE-(EY+Q*(Y-EY)-AY)*COSAL)*R
      YT = (EZ+Q*(Z-EZ)-AZ)*R
      GO TO 126
  125 XT = ((EZ+Q*(Z-EZ)-AZ)*COSAL-(EX+Q*(X-EX)-AX)*COSGA)*R
      YT = (EY+Q*(Y-EY)-AY)*R
  126 GO TO (104,105,106,107,127) , IBAK
  127 RETURN
      END

c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by UCAR                 .
c  .                                                             .
c  .       University Corporation for Atmospheric Research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                         SPHEREPACK                          .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c
c
c
c ... file slapgs.f
c
c     this file includes documentation and code for
c     subroutine slapgs          i
c
c ... files which must be loaded with slapgs.f
c
c     sphcom.f, hrfft.f, shags.f, shsgs.f
c
c
c
c     subroutine slapgs(nlat,nlon,isym,nt,slap,ids,jds,a,b,
c    +mdab,ndab,wshsgs,lshsgs,work,lwork,ierror)
c
c
C*PL*ERROR* Comment line too long
c     given the scalar spherical harmonic coefficients a and b, precomputed
C*PL*ERROR* Comment line too long
c     by subroutine shags for a scalar field sf, subroutine slapgs computes
c     the laplacian of sf in the scalar array slap.  slap(i,j) is the
c     laplacian of sf at the gaussian colatitude theta(i) (see nlat as
c     an input parameter) and east longitude lambda(j) = (j-1)*2*pi/nlon
c     on the sphere.  i.e.
c
c         slap(i,j) =
c
c                  2                2
C*PL*ERROR* Comment line too long
c         [1/sint*d (sf(i,j)/dlambda + d(sint*d(sf(i,j))/dtheta)/dtheta]/sint
c
c
c     where sint = sin(theta(i)).  the scalar laplacian in slap has the
C*PL*ERROR* Comment line too long
c     same symmetry or absence of symmetry about the equator as the scalar
c     field sf.  the input parameters isym,nt,mdab,ndab must have the
C*PL*ERROR* Comment line too long
c     same values used by shags to compute a and b for sf. the associated
c     legendre functions are stored rather than recomputed as they are
c     in subroutine slapgc.
c
c     input parameters
c
c     nlat   the number of points in the gaussian colatitude grid on the
C*PL*ERROR* Comment line too long
c            full sphere. these lie in the interval (0,pi) and are computed
C*PL*ERROR* Comment line too long
c            in radians in theta(1) <...< theta(nlat) by subroutine gaqd.
C*PL*ERROR* Comment line too long
c            if nlat is odd the equator will be included as the grid point
c            theta((nlat+1)/2).  if nlat is even the equator will be
c            excluded as a grid point and will lie half way between
c            theta(nlat/2) and theta(nlat/2+1). nlat must be at least 3.
c            note: on the half sphere, the number of grid points in the
c            colatitudinal direction is nlat/2 if nlat is even or
c            (nlat+1)/2 if nlat is odd.
c
c     nlon   the number of distinct longitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater
c            than zero. the axisymmetric case corresponds to nlon=1.
c            the efficiency of the computation is improved when nlon
c            is a product of small prime numbers.
c
C*PL*ERROR* Comment line too long
c     isym   this parameter should have the same value input to subroutine
C*PL*ERROR* Comment line too long
c            shags to compute the coefficients a and b for the scalar field
c            sf.  isym is set as follows:
c
c            = 0  no symmetries exist in sf about the equator. scalar
C*PL*ERROR* Comment line too long
c                 synthesis is used to compute slap on the entire sphere.
c                 i.e., in the array slap(i,j) for i=1,...,nlat and
c                 j=1,...,nlon.
c
c           = 1  sf and slap are antisymmetric about the equator. the
c                synthesis used to compute slap is performed on the
c                northern hemisphere only.  if nlat is odd, slap(i,j) is
c                computed for i=1,...,(nlat+1)/2 and j=1,...,nlon.  if
c                nlat is even, slap(i,j) is computed for i=1,...,nlat/2
c                and j=1,...,nlon.
c
c
c           = 2  sf and slap are symmetric about the equator. the
c                synthesis used to compute slap is performed on the
c                northern hemisphere only.  if nlat is odd, slap(i,j) is
c                computed for i=1,...,(nlat+1)/2 and j=1,...,nlon.  if
c                nlat is even, slap(i,j) is computed for i=1,...,nlat/2
c                and j=1,...,nlon.
c
c
c     nt     the number of analyses.  in the program that calls slapgs
c            the arrays slap,a, and b can be three dimensional in which
c            case multiple synthesis will be performed.  the third index
c            is the synthesis index which assumes the values k=1,...,nt.
c            for a single analysis set nt=1. the description of the
c            remaining parameters is simplified by assuming that nt=1
c            or that all the arrays are two dimensional.
c
c   ids      the first dimension of the array slap as it appears in the
c            program that calls slapgs.  if isym = 0 then ids must be at
c            least nlat.  if isym > 0 and nlat is even then ids must be
c            at least nlat/2. if isym > 0 and nlat is odd then ids must
c            be at least (nlat+1)/2.
c
c   jds      the second dimension of the array slap as it appears in the
c            program that calls slapgs. jds must be at least nlon.
c
c
c   a,b      two or three dimensional arrays (see input parameter nt)
c            that contain scalar spherical harmonic coefficients
c            of the scalar field sf as computed by subroutine shags.
c     ***    a,b must be computed by shags prior to calling slapgs.
c
c
c    mdab    the first dimension of the arrays a and b as it appears
c            in the program that calls slapgs.  mdab must be at
c            least min0(nlat,(nlon+2)/2) if nlon is even or at least
c            min0(nlat,(nlon+1)/2) if nlon is odd.
c
c    ndab    the second dimension of the arrays a and b as it appears
c            in the program that calls slapgs. ndbc must be at least
c            least nlat.
c
c            mdab,ndab should have the same values input to shags to
c            compute the coefficients a and b.
c
c
c    wshsgs  an array which must be initialized by subroutine slapgsi
c            (or equivalently by shsgsi).  once initialized, wshsgs
c            can be used repeatedly by slapgs as long as nlat and nlon
c            remain unchanged.  wshsgs must not be altered between calls
c            of slapgs.
c
c    lshsgs  the dimension of the array wshsgs as it appears in the
c            program that calls slapgs.  let
c
c               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            then lshsgs must be at least
c
C*PL*ERROR* Comment line too long
c               nlat*(3*(l1+l2)-2)+(l1-1)*(l2*(2*nlat-l1)-3*l1)/2+nlon+15
c
c
c     work   a work array that does not have to be saved.
c
c     lwork  the dimension of the array work as it appears in the
c            program that calls slapgs. define
c
c               l2 = nlat/2                    if nlat is even or
c               l2 = (nlat+1)/2                if nlat is odd
c               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            if isym is zero then lwork must be at least
c
c               (nt+1)*nlat*nlon + nlat*(2*nt*l1+1)
c
c            if isym is nonzero lwork must be at least
c
c               (nt+1)*l2*nlon + nlat*(2*nt*l1+1)
c
c
c     **************************************************************
c
c     output parameters
c
c
C*PL*ERROR* Comment line too long
c    slap    a two or three dimensional arrays (see input parameter nt) that
C*PL*ERROR* Comment line too long
c            contain the scalar laplacian of the scalar field sf.  slap(i,j)
c            is the scalar laplacian at the gaussian colatitude theta(i)
c            and longitude lambda(j) = (j-1)*2*pi/nlon for i=1,...,nlat
c            and j=1,...,nlon.
c
c
C*PL*ERROR* Comment line too long
c  ierror    a parameter which flags errors in input parameters as follows:
c
c            = 0  no errors detected
c
c            = 1  error in the specification of nlat
c
c            = 2  error in the specification of nlon
c
c            = 3  error in the specification of ityp
c
c            = 4  error in the specification of nt
c
c            = 5  error in the specification of ids
c
c            = 6  error in the specification of jds
c
c            = 7  error in the specification of mdbc
c
c            = 8  error in the specification of ndbc
c
c            = 9  error in the specification of lshsgs
c
c            = 10 error in the specification of lwork
c
c
c **********************************************************************
c
c     end of documentation for slapgs
c
c **********************************************************************
c
c
      SUBROUTINE DSLAPGS(NLAT,NLON,ISYM,NT,SLAP,IDS,JDS,A,B,MDAB,NDAB,
     +                  WSHSGS,LSHSGS,WORK,LWORK,IERROR)
      DOUBLE PRECISION SLAP
      DOUBLE PRECISION A
      DOUBLE PRECISION B
      DOUBLE PRECISION WSHSGS
      DOUBLE PRECISION WORK
      DIMENSION SLAP(IDS,JDS,NT),A(MDAB,NDAB,NT),B(MDAB,NDAB,NT)
      DIMENSION WSHSGS(LSHSGS),WORK(LWORK)
c
c     check input parameters
c
      IERROR = 1
      IF (NLAT.LT.3) RETURN
      IERROR = 2
      IF (NLON.LT.4) RETURN
      IERROR = 3
      IF (ISYM.LT.0 .OR. ISYM.GT.2) RETURN
      IERROR = 4
      IF (NT.LT.0) RETURN
      IERROR = 5
      IMID = (NLAT+1)/2
      IF ((ISYM.EQ.0.AND.IDS.LT.NLAT) .OR.
     +    (ISYM.GT.0.AND.IDS.LT.IMID)) RETURN
      IERROR = 6
      IF (JDS.LT.NLON) RETURN
      IERROR = 7
      MMAX = MIN0(NLAT,NLON/2+1)
      IF (MDAB.LT.MMAX) RETURN
      IERROR = 8
      IF (NDAB.LT.NLAT) RETURN
      IERROR = 9
c
c     set and verify saved work space length
c
      IMID = (NLAT+1)/2
      L2 = (NLAT+MOD(NLAT,2))/2
      L1 = MIN0((NLON+2)/2,NLAT)
      LP = NLAT* (3* (L1+L2)-2) + (L1-1)* (L2* (2*NLAT-L1)-3*L1)/2 +
     +     NLON + 15
      IF (LSHSGS.LT.LP) RETURN
      IERROR = 10
c
c     set and verify unsaved work space length
c
      LS = NLAT
      IF (ISYM.GT.0) LS = IMID
      NLN = NT*LS*NLON
      MN = MMAX*NLAT*NT
c     lwkmin = nln+ls*nlon+2*mn+nlat
c     if (lwork .lt. lwkmin) return
      L2 = (NLAT+1)/2
      L1 = MIN0(NLAT,NLON/2+1)
      IF (ISYM.EQ.0) THEN
          LWKMIN = (NT+1)*NLAT*NLON + NLAT* (2*NT*L1+1)
      ELSE
          LWKMIN = (NT+1)*L2*NLON + NLAT* (2*NT*L1+1)
      END IF
      IF (LWORK.LT.LWKMIN) RETURN
      IERROR = 0
c
c     set work space pointers
c
      IA = 1
      IB = IA + MN
      IFN = IB + MN
      IWK = IFN + NLAT
      LWK = LWORK - 2*MN - NLAT
      CALL DSLAPGS1(NLAT,NLON,ISYM,NT,SLAP,IDS,JDS,A,B,MDAB,NDAB,
     +             WORK(IA),WORK(IB),MMAX,WORK(IFN),WSHSGS,LSHSGS,
     +             WORK(IWK),LWK,IERROR)
      RETURN
      END

      SUBROUTINE DSLAPGS1(NLAT,NLON,ISYM,NT,SLAP,IDS,JDS,A,B,MDAB,NDAB,
     +                   ALAP,BLAP,MMAX,FNN,WSAVE,LSAVE,WK,LWK,IERROR)
      DOUBLE PRECISION SLAP
      DOUBLE PRECISION A
      DOUBLE PRECISION B
      DOUBLE PRECISION ALAP
      DOUBLE PRECISION BLAP
      DOUBLE PRECISION FNN
      DOUBLE PRECISION WSAVE
      DOUBLE PRECISION WK
      DOUBLE PRECISION FN
      DIMENSION SLAP(IDS,JDS,NT),A(MDAB,NDAB,NT),B(MDAB,NDAB,NT)
      DIMENSION ALAP(MMAX,NLAT,NT),BLAP(MMAX,NLAT,NT),FNN(NLAT)
      DIMENSION WSAVE(LSAVE),WK(LWK)
c
c     set coefficient multiplyers
c
      DO 1 N = 2,NLAT
          FN = DBLE(N-1)
          FNN(N) = FN* (FN+1.D0)
    1 CONTINUE
c
c     compute scalar laplacian coefficients for each vector field
c
      DO 2 K = 1,NT
          DO 3 N = 1,NLAT
              DO 4 M = 1,MMAX
                  ALAP(M,N,K) = 0.0D0
                  BLAP(M,N,K) = 0.0D0
    4         CONTINUE
    3     CONTINUE
c
c     compute m=0 coefficients
c
          DO 5 N = 2,NLAT
              ALAP(1,N,K) = -FNN(N)*A(1,N,K)
              BLAP(1,N,K) = -FNN(N)*B(1,N,K)
    5     CONTINUE
c
c     compute m>0 coefficients
c
          DO 6 M = 2,MMAX
              DO 7 N = M,NLAT
                  ALAP(M,N,K) = -FNN(N)*A(M,N,K)
                  BLAP(M,N,K) = -FNN(N)*B(M,N,K)
    7         CONTINUE
    6     CONTINUE
    2 CONTINUE
c
c     synthesize alap,blap into slap
c
      CALL DSHSGS(NLAT,NLON,ISYM,NT,SLAP,IDS,JDS,ALAP,BLAP,MMAX,NLAT,
     +           WSAVE,LSAVE,WK,LWK,IERROR)
      RETURN
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C                Copyright (C)  1995                                   C
C        University Corporation for Atmospheric Research               C
C                all rights reserved                                   C
C                                                                      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C      File:           tx03f.f
C
C      Author:         Bob Lackman (converted by Ed Stautler)
C          National Center for Atmospheric Research
C          PO 3000, Boulder, Colorado
C
C      Date:           Fri Jan 06 18:31:18 mdt 1995
C
C      Description:    Demonstrates the TextItem Object
C                      Writes "NCAR Graphics" in a series of
C                      different colors (using the default colormap.)
C
      external NhlFAppClass
      external NhlFCairoWindowWorkstationClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFTextItemClass

      integer appid, wid, pid
      integer srlist, grlist,ierr
      integer i
      character*7  wks_type
C
C Default is to create a metafile.
C
      wks_type = "x11"
C
C Initialize the high level utility library
C
      call NhlFInitialize
C
C Create an application context. Set the app dir to the current
C directory so the application looks for a resource file in the
C working directory. In this example the resource file supplies the
C plot title only.
C
      call NhlFRLCreate(srlist,'setrl')
      call NhlFRLClear(srlist)
      call NhlFRLSetString(srlist,'appUsrDir','./',ierr)
      call NhlFRLSetString(srlist,'appDefaultParent','True',ierr)
      call NhlFCreate(appid,'tx03',NhlFAppClass,0,srlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkMetaName','./tx03f.ncgm',ierr)
         call NhlFCreate(wid,'tx03Work',NhlFNcgmWorkstationClass,0,
     1        srlist,ierr)
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X Workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkPause','True',ierr)
         call NhlFCreate(wid,'tx03Work',
     $        NhlFCairoWindowWorkstationClass,
     $        0,srlist,ierr)
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PostScript workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkPSFileName','./tx03f.ps',ierr)
         call NhlFCreate(wid,'tx03Work',NhlFPSWorkstationClass,0,
     1        srlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkPDFFileName','./tx03f.pdf',ierr)
         call NhlFCreate(wid,'tx03Work',NhlFPDFWorkstationClass,0,
     1        srlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF object.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetString(srlist,'wkFileName','./tx03f',ierr)
         call NhlFCreate(wid,'tx03Work',
     1        NhlFCairoPSPDFWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG object.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetString(srlist,'wkFileName','./tx03f',ierr)
         call NhlFCreate(wid,'tx03Work',
     1        NhlFCairoImageWorkstationClass,0,srlist,ierr)
      endif
C
C Get the number of colors in the default color table.
C
      call NhlFRLCreate(grlist,'getrl')
      call NhlFRLClear(grlist)
      call NhlFRLGetInteger(grlist,'wkColorMapLen',num_colors,ierr)
      call NhlFGetValues(wid,grlist,ierr)
C
C
C Create a TextItem and then draw multiple frames varying the fill
C color of the text bounding box to all entries of the default
C workstation color map.
C
      call NhlFRLClear(srlist)
      call NhlFCreate(pid,'TextItems',NhlFTextItemClass,
     $        wid,srlist,ierr)
      do 10 i=1,num_colors,10
         call NhlFRLClear(srlist)
         call NhlFRLSetinteger(srlist,'txBackgroundFillColor',
     $        i,ierr)
         call NhlFSetValues(pid,srlist,ierr)
         call NhlFDraw(pid,ierr)
         call NhlFFrame(wid,ierr)
 10   continue
C
      call NhlFDestroy(pid,ierr)
      call NhlFDestroy(wid,ierr)
      call NhlFDestroy(appid,ierr)
      call NhlFClose
C
      stop
      end

C
C $Id: kfmy.f,v 1.7 2008-07-27 00:17:24 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      FUNCTION KFMY (RY)
C
C Given a Y coordinate RY in the fractional system, KFMY(RY) is a Y
C coordinate in the metacode system.
C
      KFMY=INT(RY*32767.)
      RETURN
      END

      SUBROUTINE CGBSV( N, KL, KU, NRHS, AB, LDAB, IPIV, B, LDB, INFO )
*
*  -- LAPACK driver routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     February 29, 1992
*
*     .. Scalar Arguments ..
      INTEGER            INFO, KL, KU, LDAB, LDB, N, NRHS
*     ..
*     .. Array Arguments ..
      INTEGER            IPIV( * )
      COMPLEX            AB( LDAB, * ), B( LDB, * )
*     ..
*
*  Purpose
*  =======
*
*  CGBSV computes the solution to a complex system of linear equations
*  A * X = B, where A is a band matrix of order N with KL subdiagonals
*  and KU superdiagonals, and X and B are N-by-NRHS matrices.
*
*  The LU decomposition with partial pivoting and row interchanges is
*  used to factor A as A = L * U, where L is a product of permutation
*  and unit lower triangular matrices with KL subdiagonals, and U is
*  upper triangular with KL+KU superdiagonals.  The factored form of A
*  is then used to solve the system of equations A * X = B.
*
*  Arguments
*  =========
*
*  N       (input) INTEGER
*          The number of linear equations, i.e., the order of the
*          matrix A.  N >= 0.
*
*  KL      (input) INTEGER
*          The number of subdiagonals within the band of A.  KL >= 0.
*
*  KU      (input) INTEGER
*          The number of superdiagonals within the band of A.  KU >= 0.
*
*  NRHS    (input) INTEGER
*          The number of right hand sides, i.e., the number of columns
*          of the matrix B.  NRHS >= 0.
*
*  AB      (input/output) COMPLEX array, dimension (LDAB,N)
*          On entry, the matrix A in band storage, in rows KL+1 to
*          2*KL+KU+1; rows 1 to KL of the array need not be set.
*          The j-th column of A is stored in the j-th column of the
*          array AB as follows:
*          AB(KL+KU+1+i-j,j) = A(i,j) for max(1,j-KU)<=i<=min(N,j+KL)
*          On exit, details of the factorization: U is stored as an
*          upper triangular band matrix with KL+KU superdiagonals in
*          rows 1 to KL+KU+1, and the multipliers used during the
*          factorization are stored in rows KL+KU+2 to 2*KL+KU+1.
*          See below for further details.
*
*  LDAB    (input) INTEGER
*          The leading dimension of the array AB.  LDAB >= 2*KL+KU+1.
*
*  IPIV    (output) INTEGER array, dimension (N)
*          The pivot indices that define the permutation matrix P;
*          row i of the matrix was interchanged with row IPIV(i).
*
*  B       (input/output) COMPLEX array, dimension (LDB,NRHS)
*          On entry, the N-by-NRHS right hand side matrix B.
*          On exit, if INFO = 0, the N-by-NRHS solution matrix X.
*
*  LDB     (input) INTEGER
*          The leading dimension of the array B.  LDB >= max(1,N).
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*          > 0:  if INFO = i, U(i,i) is exactly zero.  The factorization
*                has been completed, but the factor U is exactly
*                singular, and the solution has not been computed.
*
*  Further Details
*  ===============
*
*  The band storage scheme is illustrated by the following example, when
*  M = N = 6, KL = 2, KU = 1:
*
*  On entry:                       On exit:
*
*      *    *    *    +    +    +       *    *    *   u14  u25  u36
*      *    *    +    +    +    +       *    *   u13  u24  u35  u46
*      *   a12  a23  a34  a45  a56      *   u12  u23  u34  u45  u56
*     a11  a22  a33  a44  a55  a66     u11  u22  u33  u44  u55  u66
*     a21  a32  a43  a54  a65   *      m21  m32  m43  m54  m65   *
*     a31  a42  a53  a64   *    *      m31  m42  m53  m64   *    *
*
*  Array elements marked * are not used by the routine; elements marked
*  + need not be set on entry, but are required by the routine to store
*  elements of U because of fill-in resulting from the row interchanges.
*
*  =====================================================================
*
*     .. External Subroutines ..
      EXTERNAL           CGBTRF, CGBTRS, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      IF( N.LT.0 ) THEN
         INFO = -1
      ELSE IF( KL.LT.0 ) THEN
         INFO = -2
      ELSE IF( KU.LT.0 ) THEN
         INFO = -3
      ELSE IF( NRHS.LT.0 ) THEN
         INFO = -4
      ELSE IF( LDAB.LT.2*KL+KU+1 ) THEN
         INFO = -6
      ELSE IF( LDB.LT.MAX( N, 1 ) ) THEN
         INFO = -9
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'CGBSV ', -INFO )
         RETURN
      END IF
*
*     Compute the LU factorization of the band matrix A.
*
      CALL CGBTRF( N, N, KL, KU, AB, LDAB, IPIV, INFO )
      IF( INFO.EQ.0 ) THEN
*
*        Solve the system A*X = B, overwriting B with X.
*
         CALL CGBTRS( 'No transpose', N, KL, KU, NRHS, AB, LDAB, IPIV,
     $                B, LDB, INFO )
      END IF
      RETURN
*
*     End of CGBSV
*
      END

C
C       $Id: stinit.f,v 1.15 2008-07-27 00:17:28 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
C-----------------------------------------------------------------------
C
      SUBROUTINE STINIT (U,LU,V,LV,P,LP,M,N,WRK,LW)
C
C Argument dimensions.
C
      DIMENSION       U(LU,N)    ,V(LV,N)    ,P(LP,N)
      DIMENSION       WRK(LW)
C
C Input parameters
C
C U,V   - 2-d arrays holding the component values of a vector field
C LU,LV - The first dimensions of the U and V arrays, respectively
C ----------------
C P     - A 2-d array containing a scalar data field. The contents
C         of this array may be used to color the streamlines. 
C LP    - The first dimension of the P array
C NOTE:
C Coloring by means of the P scalar data field is not yet
C implemented
C ----------------
C M     - The first data dimension (must be less than or equal to
C         MIN(LU,LV) (or MIN(LU,LV,LP) if the P array is used
C WRK   - an internally used work array
C LW    - dimension of the work array (must be at least 2*M*N; 3*M*N if
C         coloring by magnitude) 
C
C Output parameters:
C
C None
C
C ---------------------------------------------------------------------
C
C NOTE:
C Since implicit typing is used for all real and integer variables
C a consistent length convention has been adopted to help clarify the
C significance of the variables encountered in the code for this 
C utility. All local variable and subroutine parameter identifiers 
C are limited to 1,2,or 3 characters. Four character names identify  
C members of common blocks. Five and 6 character variable names 
C denote PARAMETER constants or subroutine or function names.
C
C Declare the ST common blocks.
C
      PARAMETER (IPLVLS = 256)
C
C Integer and real common block variables
C
C
      COMMON / STPAR /
     +                IUD1       ,IVD1       ,IPD1       ,
     +                IXD1       ,IXDM       ,IYD1       ,IYDN       ,
     +                IXM1       ,IYM1       ,IXM2       ,IYM2       ,
     +                IWKD       ,IWKU       ,ISET       ,IERR       ,
     +                IXIN       ,IYIN       ,IMSK       ,ICPM       ,
     +                NLVL       ,IPAI       ,ICTV       ,WDLV       ,
     +                UVMN       ,UVMX       ,PMIN       ,PMAX       ,
     +                IPLR       ,ISST       ,
     +                ICLR(IPLVLS)           ,TVLU(IPLVLS)
C
      COMMON / STTRAN /
     +                UVPS       ,
     +                UVPL       ,UVPR       ,UVPB       ,UVPT       ,
     +                UWDL       ,UWDR       ,UWDB       ,UWDT       ,
     +                UXC1       ,UXCM       ,UYC1       ,UYCN 
C
C Stream algorithm parameters
C
      COMMON / STSTRM /
     +                ISGD       ,IAGD       ,RARL       ,ICKP       ,
     +                ICKX       ,ITRP       ,ICYK       ,RVNL       ,
     +                ISVF       ,RUSV       ,RVSV       ,RNDA       ,
     +                ISPC       ,RPSV       ,RCDS       ,RSSP       ,
     +                RDFM       ,RSMD       ,RAMD       ,IGBS       ,
     +                ISTM       ,RVRL       ,RVFR       ,RVRM       ,
     +                IVPO       ,RAFR       ,RDMX       ,RDMN
C
C Text related parameters
C Note: graphical text output is not yet implemented for the
C       Streamline utility.
C
      COMMON / STTXP /
     +                FCWM    ,ICSZ    ,
     +                FMNS    ,FMNX    ,FMNY    ,IMNP    ,IMNC  ,
     +                FMXS    ,FMXX    ,FMXY    ,IMXP    ,IMXC  ,
     +                FZFS    ,FZFX    ,FZFY    ,IZFP    ,IZFC  ,
     +                FILS    ,FILX    ,FILY    ,IILP    ,IILC 
C
C Character variable declartions
C
      CHARACTER*160 CSTR
      PARAMETER (IPCHSZ=80)
      CHARACTER*(IPCHSZ)  CMNT,CMXT,CZFT,CILT
C
C Text string parameters
C
      COMMON / STCHAR / CSTR,CMNT,CMXT,CZFT,CILT
C
      SAVE /STPAR/, /STTRAN/, /STSTRM/, /STTXP/, /STCHAR/
C
C Internal buffer lengths
C
C IPNPTS - Number of points in the point buffer -- not less than 3
C IPLSTL - Streamline-crossover-check circular list length
C IPGRCT - Number of groups supported for area masking
C
      PARAMETER (IPNPTS = 256, IPLSTL = 750, IPGRCT = 64)
C
C --------------------------------------------------------------------
C
C The mapping common block: made available to user mapping routines
C
      COMMON /STMAP/
     +                IMAP       ,LNLG       ,INVX       ,INVY       ,
     +                XLOV       ,XHIV       ,YLOV       ,YHIV       ,
     +                WXMN       ,WXMX       ,WYMN       ,WYMX       ,
     +                XVPL       ,XVPR       ,YVPB       ,YVPT       ,
     +                XGDS       ,YGDS       ,NXCT       ,NYCT       ,
     +                ITRT       ,FW2W       ,FH2H       ,
     +                DFMG       ,VNML       ,RBIG       ,IBIG
C
      SAVE /STMAP/
C
C Math constants
C
      PARAMETER (PDTOR  = 0.017453292519943,
     +           PRTOD  = 57.2957795130823,
     +           P1XPI  = 3.14159265358979,
     +           P2XPI  = 6.28318530717959,
     +           P1D2PI = 1.57079632679489,
     +           P5D2PI = 7.85398163397448) 
C
C ---------------------------------------------------------------------
C
C Do a call forcing a BLOCKDATA to be loaded from a binary library.
C
      CALL STDATA
C
C Write the array sizes into the common block
C 
      IUD1=LU
      IVD1=LV
      IF (ABS(ICTV).EQ.2) THEN
         IPD1=LP
      ELSE 
         IPD1=M
      END IF
      IWKD=LW
C
C Error if M > LU or M > LV?
C
      IF (LU.LT.M .OR. LV.LT.M) THEN
         CSTR(1:45)='STINIT - U AND/OR V ARRAY DIMENSIONS EXCEEDED'
         CALL SETER (CSTR(1:45),1,1)
         RETURN
      END IF
      IXDM=M
      IYDN=N
      IXD1=1
      IYD1=1
      IXM1=IXDM-1
      IXM2=IXDM-2
      IYM1=IYDN-1
      IYM2=IYDN-2
      IF (LW .LT. 2*IXDM*IYDN) THEN
         CSTR(1:37)='STINIT - WRK ARRAY DIMENSION TOO SMALL'
         CALL SETER (CSTR(1:37),2,1)
         RETURN
      END IF
C
C Initialize and transfer some arguments to local variables.
C
      IBIG = I1MACH(9)
      RBIG = R1MACH(2)
C
C Decide what the range of values in X and Y should be.
C
      IF (UXC1.EQ.UXCM) THEN
        XLOV=1.
        XHIV=REAL(IXDM)
      ELSE
        XLOV=UXC1
        XHIV=UXCM
      END IF
C
      IF (UYC1.EQ.UYCN) THEN
        YLOV=1.
        YHIV=REAL(IYDN)
      ELSE
        YLOV=UYC1
        YHIV=UYCN
      END IF
C
      IXIN = MAX(IXIN,1)
      IYIN = MAX(IYIN,1)
C
      NXCT = MAX(IXDM/IXIN,1)
      NYCT = MAX(IYDN/IYIN,1)
C
C If the user has done a SET call, retrieve the arguments; if he hasn't
C done a SET call, do it for him.
C
      IF (ISET .EQ .0) THEN
C
        CALL GETSET (XVPL,XVPR,YVPB,YVPT,WXMN,WXMX,WYMN,WYMX,LNLG)
C
      ELSE
C
        LNLG=1
C
        IF (UWDL.EQ.UWDR) THEN
          WXMN=XLOV
          WXMX=XHIV
        ELSE
          WXMN=UWDL
          WXMX=UWDR
        END IF
C
        IF (UWDB.EQ.UWDT) THEN
          WYMN=YLOV
          WYMX=YHIV
        ELSE
          WYMN=UWDB
          WYMX=UWDT
        END IF
C
C Determine the viewport based on the setting of the viewport
C shape and viewport extent parameters
C
        IF (UVPS.LT.0.) THEN
          AR=ABS(UVPS)
        ELSE IF (UVPS.EQ.0.) THEN
          AR=(UVPR-UVPL)/(UVPT-UVPB)
        ELSE IF (UVPS.LE.1.) THEN
          AR=ABS((WXMX-WXMN)/(WYMX-WYMN))
          IF (MIN(AR,1./AR).LT.UVPS) AR=(UVPR-UVPL)/(UVPT-UVPB)
        ELSE
          AR=ABS((WXMX-WXMN)/(WYMX-WYMN))
          IF (MAX(AR,1./AR).GT.UVPS) AR=1.
        END IF
C
        IF (AR.LT.(UVPR-UVPL)/(UVPT-UVPB)) THEN
          XVPL=.5*(UVPL+UVPR)-.5*(UVPT-UVPB)*AR
          XVPR=.5*(UVPL+UVPR)+.5*(UVPT-UVPB)*AR
          YVPB=UVPB
          YVPT=UVPT
        ELSE
          XVPL=UVPL
          XVPR=UVPR
          YVPB=.5*(UVPB+UVPT)-.5*(UVPR-UVPL)/AR
          YVPT=.5*(UVPB+UVPT)+.5*(UVPR-UVPL)/AR
        END IF
C
        CALL SET (XVPL,XVPR,YVPB,YVPT,WXMN,WXMX,WYMN,WYMX,LNLG)
C
      END IF
C    
C Calculate fraction of VP width to fractional size factor.
C Calculate fraction of VP height to fractional size factor.
C These are for convenience.
C
      FW2W = XVPR - XVPL
      FH2H = YVPT - YVPB
      TX=(XVPR-XVPL)/REAL(NXCT)
      TY=(YVPT-YVPB)/REAL(NYCT)
      RDMX=SQRT((TX*TX+TY*TY))
      RDMN = 0.0
C
C Swap window rectangle if it is inverted, but keep track
C This makes it easier to exclude out-of-bounds points in the
C projection mapping routines
C
      INVX=0
      INVY=0
      IF (WXMN .GT. WXMX) THEN
         T=WXMN
         WXMN=WXMX
         WXMX=T
         INVX=1
      END IF
      IF (WYMN .GT. WYMX) THEN
         T=WYMN
         WYMN=WYMX
         WYMX=T
         INVY=1
      END IF
C
C If cyclic data specified check to ensure the cyclic condition exists.
C The error flag is set if necessary within STCYCL
C
      IF (ICYK.NE.0) CALL STCYCL(U,V)
C
C Calculate the grid size
C
      XGDS=(XHIV-XLOV)/(REAL(NXCT)-1.0)
      YGDS=(YHIV-YLOV)/(REAL(NYCT)-1.0)
C
C If coloring by magnitude a work array containing the vector magnitudes
C needs to be created in the third section of the work array. Do it 
C while calculating the max and min magnitudes.
C
      IF (ABS(ICTV).EQ.1) THEN
         IF (LW .LT. 3*IXDM*IYDN) THEN
            CSTR(1:37)='STINIT - WRK ARRAY DIMENSION TOO SMALL'
            CALL SETER (CSTR(1:37),2,1)
            RETURN
         END IF
         CALL STCMAG(U,V,WRK(2*IXDM*IYDN+1),1)
         PMIN=UVMN
         PMAX=UVMX
         IP=1
      ELSE
         CALL STCMAG(U,V,RDM,0)
      END IF
C
C If using the scalar array...
C
      IF (ABS(ICTV).EQ.2) THEN
C
C Check for error condition
C
         IF (IPD1 .LT. IXDM) THEN
            CSTR(1:31)='STINIT - SCALAR ARRAY TOO SMALL'
            CALL SETER (CSTR(1:31),2,1)
            RETURN
         END IF
C
C Find the max and min scalar values when necessary
C
         IF (ICTV.GE.2 .OR. PMIN.EQ.PMAX) THEN
            PMIN=RBIG
            PMAX=-RBIG
            IP=0
            DO 121 J=1,IYDN,IYIN
               DO 120 I=1,IXDM,IXIN
                  IF (ISPC .GE. 0 .AND. P(I,J) .EQ. RPSV) GO TO 120  
                  IP=1
                  PMIN = MIN(PMIN, P(I,J))
                  PMAX = MAX(PMAX, P(I,J))
 120           CONTINUE
 121        CONTINUE
         END IF
C
      END IF
C
C Determine the threshold values. If there were no non-special
C values in the P array, then set all threshold values to the
C maximum possible.
C
      IF (NLVL.GT.0 .AND. ICTV.GT.0) THEN
C
         IF (IP .NE. 0) THEN
            TV=(PMAX-PMIN)/NLVL
            DO 125 I=1,NLVL,1
               TVLU(I)=PMIN+REAL(I)*TV
 125        CONTINUE
         ELSE
            DO 130 I=1,NLVL,1
               TVLU(I)=RBIG
 130        CONTINUE
         END IF
C
      END IF
C
C Done.
C
      RETURN
C
      END
C ---------------------------------------------------------------------
C
      SUBROUTINE STCMAG(U,V,RM,MFL)
C
C This routine finds the maximum and minimum magnitude vectors.
C If there are no special values use simpler code for efficiency.
C If coloring by magnitude also populates an array with magnitudes
C
C Input parameters:
C
C U,V - 2-d arrays holding the component values of a vector field
C RM  - 2-d array for the magnitude
C MFL - flag for performing magnitude operation
C
C Output parameters:
C

      DIMENSION  U(IUD1,*),V(IVD1,*)
      DIMENSION  RM(IXDM,*)
C
C ---------------------------------------------------------------------
C
C NOTE:
C Since implicit typing is used for all real and integer variables
C a consistent length convention has been adopted to help clarify the
C significance of the variables encountered in the code for this 
C utility. All local variable and subroutine parameter identifiers 
C are limited to 1,2,or 3 characters. Four character names identify  
C members of common blocks. Five and 6 character variable names 
C denote PARAMETER constants or subroutine or function names.
C
C Declare the ST common blocks.
C
      PARAMETER (IPLVLS = 256)
C
C Integer and real common block variables
C
C
      COMMON / STPAR /
     +                IUD1       ,IVD1       ,IPD1       ,
     +                IXD1       ,IXDM       ,IYD1       ,IYDN       ,
     +                IXM1       ,IYM1       ,IXM2       ,IYM2       ,
     +                IWKD       ,IWKU       ,ISET       ,IERR       ,
     +                IXIN       ,IYIN       ,IMSK       ,ICPM       ,
     +                NLVL       ,IPAI       ,ICTV       ,WDLV       ,
     +                UVMN       ,UVMX       ,PMIN       ,PMAX       ,
     +                IPLR       ,ISST       ,
     +                ICLR(IPLVLS)           ,TVLU(IPLVLS)
C
      COMMON / STTRAN /
     +                UVPS       ,
     +                UVPL       ,UVPR       ,UVPB       ,UVPT       ,
     +                UWDL       ,UWDR       ,UWDB       ,UWDT       ,
     +                UXC1       ,UXCM       ,UYC1       ,UYCN 
C
C Stream algorithm parameters
C
      COMMON / STSTRM /
     +                ISGD       ,IAGD       ,RARL       ,ICKP       ,
     +                ICKX       ,ITRP       ,ICYK       ,RVNL       ,
     +                ISVF       ,RUSV       ,RVSV       ,RNDA       ,
     +                ISPC       ,RPSV       ,RCDS       ,RSSP       ,
     +                RDFM       ,RSMD       ,RAMD       ,IGBS       ,
     +                ISTM       ,RVRL       ,RVFR       ,RVRM       ,
     +                IVPO       ,RAFR       ,RDMX       ,RDMN
C
C Text related parameters
C Note: graphical text output is not yet implemented for the
C       Streamline utility.
C
      COMMON / STTXP /
     +                FCWM    ,ICSZ    ,
     +                FMNS    ,FMNX    ,FMNY    ,IMNP    ,IMNC  ,
     +                FMXS    ,FMXX    ,FMXY    ,IMXP    ,IMXC  ,
     +                FZFS    ,FZFX    ,FZFY    ,IZFP    ,IZFC  ,
     +                FILS    ,FILX    ,FILY    ,IILP    ,IILC 
C
C Character variable declartions
C
      CHARACTER*160 CSTR
      PARAMETER (IPCHSZ=80)
      CHARACTER*(IPCHSZ)  CMNT,CMXT,CZFT,CILT
C
C Text string parameters
C
      COMMON / STCHAR / CSTR,CMNT,CMXT,CZFT,CILT
C
      SAVE /STPAR/, /STTRAN/, /STSTRM/, /STTXP/, /STCHAR/
C
C Internal buffer lengths
C
C IPNPTS - Number of points in the point buffer -- not less than 3
C IPLSTL - Streamline-crossover-check circular list length
C IPGRCT - Number of groups supported for area masking
C
      PARAMETER (IPNPTS = 256, IPLSTL = 750, IPGRCT = 64)
C
C --------------------------------------------------------------------
C
C The mapping common block: made available to user mapping routines
C
      COMMON /STMAP/
     +                IMAP       ,LNLG       ,INVX       ,INVY       ,
     +                XLOV       ,XHIV       ,YLOV       ,YHIV       ,
     +                WXMN       ,WXMX       ,WYMN       ,WYMX       ,
     +                XVPL       ,XVPR       ,YVPB       ,YVPT       ,
     +                XGDS       ,YGDS       ,NXCT       ,NYCT       ,
     +                ITRT       ,FW2W       ,FH2H       ,
     +                DFMG       ,VNML       ,RBIG       ,IBIG
C
      SAVE /STMAP/
C
C Math constants
C
      PARAMETER (PDTOR  = 0.017453292519943,
     +           PRTOD  = 57.2957795130823,
     +           P1XPI  = 3.14159265358979,
     +           P2XPI  = 6.28318530717959,
     +           P1D2PI = 1.57079632679489,
     +           P5D2PI = 7.85398163397448) 
C
C ---------------------------------------------------------------------
C
      UVMN=RBIG
      UVMX=0.0
      IF (ISVF .LE. 0) THEN
C
         DO 111 J=1,IYDN,IYIN
            DO 110 I=1,IXDM,IXIN
               TU=U(I,J)
               TV=V(I,J)
               IF (IPLR.NE.0) THEN
                  UVMN = MIN(UVMN, TU)
                  UVMX = MAX(UVMX, TU)
                  IF (MFL .EQ. 1) THEN
                     RM(I,J) = TU
                  END IF
               ELSE
                  TM = TU*TU+TV*TV
                  UVMN = MIN(UVMN, TM)
                  UVMX = MAX(UVMX, TM)
                  IF (MFL .EQ. 1) THEN
                     RM(I,J) = SQRT(TM)
                  END IF
               END IF
 110        CONTINUE
 111     CONTINUE
C
      ELSE
C
         DO 116 J=1,IYDN,IYIN
            DO 115 I=1,IXDM,IXIN
               TU=U(I,J)
               TV=V(I,J)
C
               IF (ISVF .GT. 0) THEN
                  IF (TU .EQ. RUSV .OR. TV .EQ. RVSV) GO TO 115
               END IF
C
               IF (IPLR.NE.0) THEN
                  UVMN = MIN(UVMN, TU)
                  UVMX = MAX(UVMX, TU)
                  IF (MFL .EQ. 1) THEN
                     RM(I,J) = TU
                  END IF
               ELSE
                  TM = TU*TU+TV*TV
                  UVMN = MIN(UVMN,TM)
                  UVMX = MAX(UVMX,TM)
                  IF (MFL .EQ. 1) THEN
                     RM(I,J) = SQRT(TM)
                  END IF
               END IF
C
 115        CONTINUE
 116     CONTINUE
C
      END IF
C
      IF (IPLR .LE. 0) THEN
         UVMX = SQRT(UVMX)
         UVMN = SQRT(UVMN)
      END IF
C
C DONE
C
      RETURN
C
      END

      PROGRAM FPCHIQU
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Set the "fill area interior style" to "solid".
C
      CALL GSFAIS (1)
C
C Do a call to SET which allows us to use fractional coordinates.
C
      CALL SET (0.,1.,0.,1.,0.,1.,0.,1.,1)
C
C Define some colors to use.
C
      CALL GSCR (IWKID,0,1.,1.,1.)
      CALL GSCR (IWKID,1,0.,.0,.0)
      CALL GSCR (IWKID,2,0.,.5,.5)
      CALL GSCR (IWKID,3,.9,.9,0.)
      CALL GSCR (IWKID,4,1.,.3,.3)
      CALL GSCR (IWKID,5,0.,0.,1.)
      CALL GSCR (IWKID,6,.2,.2,.2)
      CALL GSCR (IWKID,7,.8,.8,.8)
C
C Do a single frame showing various capabilities of PLCHHQ.
C
C Put labels at the top of the plot.
C
      CALL PLCHHQ (.5,.98,'PLCHHQ - VARIOUS CAPABILITIES',.02,0.,0.)
C
C First, write characters at various sizes.
C
      CALL PLCHHQ (.225,.900,'SIZE is -1.0',-1.0,0.,0.)
      CALL PLCHHQ (.225,.873,'SIZE is -.75',-.75,0.,0.)
      CALL PLCHHQ (.225,.846,'SIZE is .015',.015,0.,0.)
      CALL PLCHHQ (.225,.811,'SIZE is .020',.020,0.,0.)
      CALL PLCHHQ (.225,.776,'SIZE is 15.0',15.0,0.,0.)
      CALL PLCHHQ (.225,.742,'SIZE is 20.0',20.0,0.,0.)
C
C Next, write characters at various angles.
C
      CALL PLCHHQ (.225,.453,'   ANGD is   0.',.012,  0.,-1.)
      CALL PLCHHQ (.225,.453,'   ANGD is  45.',.012, 45.,-1.)
      CALL PLCHHQ (.225,.453,'   ANGD is  90.',.012, 90.,-1.)
      CALL PLCHHQ (.225,.453,'   ANGD is 135.',.012,135.,-1.)
      CALL PLCHHQ (.225,.453,'   ANGD is 180.',.012,180.,-1.)
      CALL PLCHHQ (.225,.453,'   ANGD is 225.',.012,225.,-1.)
      CALL PLCHHQ (.225,.453,'   ANGD is 270.',.012,270.,-1.)
      CALL PLCHHQ (.225,.453,'   ANGD is 315.',.012,315.,-1.)
C
C Next, use various values of the centering option.
C
      CALL PLCHHQ (.225,.164,'CNTR is -1.5',.012,0.,-1.5)
      CALL PLCHHQ (.225,.140,'CNTR is -1.0',.012,0.,-1.0)
      CALL PLCHHQ (.225,.116,'CNTR is -0.5',.012,0.,-0.5)
      CALL PLCHHQ (.225,.092,'CNTR is  0.0',.012,0., 0.0)
      CALL PLCHHQ (.225,.068,'CNTR is +0.5',.012,0.,+0.5)
      CALL PLCHHQ (.225,.044,'CNTR is +1.0',.012,0.,+1.0)
      CALL PLCHHQ (.225,.020,'CNTR is +1.5',.012,0.,+1.5)
C
C Turn on the computation of text-extent-vector magnitudes and use
C them to draw a box around a label.  (DRAWBX is not part of PLOTCHAR;
C the code for it appears at the end of this example.)
C
      CALL PCSETI ('TE - TEXT EXTENT FLAG',1)
C
      CALL PLCHHQ (.130,.140,'TEXT EXTENT BOX',.012,33.,0.)
      CALL DRAWBX (.130,.140,33.,.01)
C
      CALL PCSETI ('TE - TEXT EXTENT FLAG',0)
C
C On the right side of the frame, create examples of the various kinds
C of function codes.  First, do them using high-quality characters.
C
      CALL PLCHHQ (.715,.900,'HIGH-QUALITY CHARACTERS USED BELOW',
     +                                                       .012,0.,0.)
C
      CALL PCSETC ('FC','$')
      CALL PLCHHQ (.625,.870,'INPUT STRING',.012,0.,0.)
      CALL PLCHHQ (.625,.840,'------------',.012,0.,0.)
      CALL PLCHHQ (.625,.810,':L:A',.012,0.,0.)
      CALL PLCHHQ (.625,.780,':IGL:A',.012,0.,0.)
      CALL PLCHHQ (.625,.750,'A:S:2:N:+B:S:2:N:',.012,0.,0.)
      CALL PLCHHQ (.625,.720,'A:S:B',.012,0.,0.)
      CALL PLCHHQ (.625,.690,'A:SPU:B',.012,0.,0.)
      CALL PLCHHQ (.625,.660,':GIU:+',.012,0.,0.)
      CALL PLCHHQ (.625,.630,':1045:',.012,0.,0.)
      CALL PLCHHQ (.625,.600,'10:S:10:S:100',.012,0.,0.)
      CALL PLCHHQ (.625,.570,'X:B1:2:S1:3',.012,0.,0.)
      CALL PLCHHQ (.625,.540,'X:B1:2:S:3:N:Y:S:2',.012,0.,0.)
      CALL PLCHHQ (.625,.510,'X:S:A:B:1:NN:ABC',.012,0.,0.)
      CALL PLCHHQ (.625,.480,'1.3648:L1:410:S:-13',.012,0.,0.)
C
      CALL PCSETC ('FC',':')
      CALL PLCHHQ (.875,.870,'RESULT',.012,0.,0.)
      CALL PLCHHQ (.875,.840,'------',.012,0.,0.)
      CALL PLCHHQ (.875,.810,':L:A',.012,0.,0.)
      CALL PLCHHQ (.875,.780,':IGL:A',.012,0.,0.)
      CALL PLCHHQ (.875,.750,'A:S:2:N:+B:S:2:N:',.012,0.,0.)
      CALL PLCHHQ (.875,.720,'A:S:B',.012,0.,0.)
      CALL PLCHHQ (.875,.690,'A:SPU:B',.012,0.,0.)
      CALL PLCHHQ (.875,.660,':GIU:+',.012,0.,0.)
      CALL PLCHHQ (.875,.630,':1045:',.012,0.,0.)
      CALL PLCHHQ (.875,.600,'10:S:10:S:100',.012,0.,0.)
      CALL PLCHHQ (.875,.570,'X:B1:2:S1:3',.012,0.,0.)
      CALL PLCHHQ (.875,.540,'X:B1:2:S:3:N:Y:S:2',.012,0.,0.)
      CALL PLCHHQ (.875,.510,'X:S:A:B:1:NN:ABC',.012,0.,0.)
      CALL PLCHHQ (.875,.480,'1.3648:L1:410:S:-13',.012,0.,0.)
C
C Show various other features like lines with several fonts.
C
      CALL PLCHHQ (.715,.440,'OTHER FEATURES',.012,0.,0.)
C

C Show the use of fontcap databases and some of
C the new features added in June of 1990.
      CALL PLOTIF (0.,0.,2)
C
C Temporarily use the slash as a function code character.
C
      CALL PCSETC ('FC - FUNCTION CODE CHARACTER','/')
C
C Combine characters from several different fonts to produce a single
C line.
C
      CALL PLCHHQ (.990,.410,'/F13/A line with characters from several f
     +onts:  /F8/P/BF13/0/N/=/F5/g/SF13/2/N/+/F5/j/SF13/2/N/',
     +                                                       .012,0.,1.)
C
C Reset the internal parameter 'FN' to 4 and write a line illustrating
C the effect of function codes "Fn", "F", and "F0".  Then reset 'FN'
C to 0.
C
      CALL PCSETI ('FN - FONT NUMBER',4)
      CALL PLCHHQ (.990,.380,'Set ''FN'' (Font Number) to 4 and then use
     +"F" function codes:',.012,0.,1.)
      CALL PLCHHQ (.990,.350,'Before F10 - /F10/after F10 - /F/after F
     +- /F0/after F0.',.012,0.,1.)
      CALL PCSETI ('FN - FONT NUMBER',0)
C
C Write lines illustrating various kinds of zooming.
C
      CALL PLCHHQ (.990,.320,'/F13/Unzoomed characters from font 13.',
     +.012,0.,1.)
      CALL PLCHHQ (.990,.290,'/F13X130Q/Characters zoomed in width, usin
     +g X130Q.',.012,0.,1.)
      CALL PLCHHQ (.990,.260,'/F13Y130Q/Characters zoomed in height, usi
     +ng Y130Q.',.012,0.,1.)
      CALL PLCHHQ (.99000,.230,'/F13Z130Q/Characters zoomed both ways, us
     +ing Z130Q.',.012,0.,1.)
C
C Write a line illustrating non-aligned zooming in height.
C
      CALL PLCHHQ (.990,.200,'/F13/Unaligned zoom of characters: /F16Y20
     +0/S/Y/cientific /Y200/V/Y/isualization /Y200/G/Y/roup', .012,0.,
     +1.)
C
C Write lines illustrating the use of 'AS' and 'SS'.
C
      CALL PCSETR ('AS - ADD SPACE BETWEEN CHARACTERS     ',.125)
      CALL PCSETR ('SS - SUBTRACT SPACE BETWEEN CHARACTERS',  0.)
      CALL PLCHHQ (.990,.170,'/F14/Line with ''AS'' = .125 and ''SS = 0.
     +',.012,0.,1.)
      CALL PCSETR ('AS - ADD SPACE BETWEEN CHARACTERS     ',  0.)
      CALL PCSETR ('SS - SUBTRACT SPACE BETWEEN CHARACTERS',  0.)
      CALL PLCHHQ (.990,.140,'/F14/Line with ''AS'' = 0. and ''SS'' = 0.
     +',.012,0.,1.)
      CALL PCSETR ('AS - ADD SPACE BETWEEN CHARACTERS     ',  0.)
      CALL PCSETR ('SS - SUBTRACT SPACE BETWEEN CHARACTERS',.125)
      CALL PLCHHQ (.990,.110, '/F14/Line with ''AS'' = 0. and ''SS'' = .
     +125',.012,0.,1.)
      CALL PCSETR ('AS - ADD SPACE BETWEEN CHARACTERS     ',  0.)
      CALL PCSETR ('SS - SUBTRACT SPACE BETWEEN CHARACTERS',  0.)
C
C Return to a colon as the function code character.
C
      CALL PCSETC ('FC - FUNCTION CODE CHARACTER',':')
C
C Go back to normal line width.
C
      CALL PLOTIF (0.,0.,2)
      CALL GSLWSC (1.)
C
C Draw a bounding box
C
      CALL LINE(0.,0.,1.,0.)
      CALL LINE(1.,0.,1.,1.)
      CALL LINE(1.,1.,0.,1.)
      CALL LINE(0.,1.,0.,0.)


C
C Advance the frame.
C
      CALL FRAME
C
C Do a single frame showing some of the new features added in December
C of 1992.
C
C Put a label at the top of the plot and, below that, an explanatory
C note.
C
      CALL PLCHHQ (.5,.975,':F25:PLCHHQ - FEATURES ADDED 12/92',
     +                                                       .025,0.,0.)
C
      CALL PCSETR ('SS - SUBTRACT SPACE BETWEEN CHARACTERS',.275)
      CALL PLCHHQ (.5,.938,':F13:(Use idt''s ''zoom'' to view some of th
     +is in detail, especially stacking.)',
     +                                                       .017,0.,0.)
      CALL PCSETR ('SS - SUBTRACT SPACE BETWEEN CHARACTERS',0.)
C
C Illustrate the use of filled fonts with shadows and outlines.
C
C Write a line.
C
      CALL PLCHHQ (.5,.900,':F26:By default, the current foreground colo
     +r is used.',.024,0.,0.)
C
C Define the principal color to be used for characters.
C
      CALL PCSETI ('CC - CHARACTER COLOR',4)
C
C Write another line.
C
      CALL PLCHHQ (.5,.850,':F26:A non-negative ''CC'' requests a differ
     +ent color.', .026,0.,0.)
C
C Turn on character shadows and define various characteristics of the
C shadow.
C
      CALL PCSETI ('SF - SHADOW FLAG',1)
      CALL PCSETR ('SX - SHADOW OFFSET IN X',-.15)
      CALL PCSETR ('SY - SHADOW OFFSET IN Y',-.15)
      CALL PCSETI ('SC - SHADOW COLOR',1)
C
C Write another line.
C
      CALL PLCHHQ (.5,.796,':F26:''SF'', ''SC'', ''SX'', and ''SY'' crea
     +te shadows.',
     +                                                       .028,0.,0.)
C
C Turn on character outlines and define the color of the outline.
C
      CALL PCSETI ('SF - SHADOW FLAG',0)
      CALL PCSETI ('OF - OUTLINE FLAG',1)
      CALL PCSETI ('OC - OUTLINE COLOR',1)
      CALL PCSETI ('OL - OUTLINE LINE WIDTH',1)
C
C Write another line.
C
      CALL PLCHHQ (.5,.738,':F26:''OF'', ''OC'', and ''OL'' add outlines
     +.',
     +                                                       .030,0.,0.)
C
C Turn on the drawing of boxes and define characteristics of them.
C
      CALL PCSETI ('BF - BOX FLAG',7)
      CALL PCSETI ('BL - BOX LINE WIDTH',2)
      CALL PCSETR ('BM - BOX MARGIN',.15)
      CALL PCSETR ('BX - BOX SHADOW X OFFSET',-.1)
      CALL PCSETR ('BY - BOX SHADOW Y OFFSET',-.1)
      CALL PCSETI ('BC(1) - BOX COLOR - BOX OUTLINE    ',5)
      CALL PCSETI ('BC(2) - BOX COLOR - BOX FILL       ',7)
      CALL PCSETI ('BC(3) - BOX COLOR - BOX SHADOW FILL',1)
C
C Write another line.
C
      CALL PLCHHQ (.5,.672,':F26:''BF'', ''BC'', ''BL'', ''BM'', ''BX'',
     + and ''BY'' add a box.',
     +                                                       .026,0.,0.)
C
C Get rid of the box shadow, which doesn't add much.
C
      CALL PCSETI ('BF - BOX FLAG',3)
C
C Write another line.
C
      CALL PCSETC ('FC - FUNCTION-CODE CHARACTER','/')
      CALL PLCHHQ (.5,.592,'/F26/''MA'' and ''OR'' are used for mapping:
     +',
     +                                                       .030,0.,0.)
      CALL PCSETC ('FC - FUNCTION CODE CHARACTER',':')
C
C Write a couple of headers for the plots that follow.
C
      CALL PLCHHQ (.28,.528,':F25:(EZMAP)',.024,0.,0.)
      CALL PLCHHQ (.72,.528,':F33:(r:F25: and :F33:q)',.024,0.,0.)
C
C Initialize EZMAP and draw a background.
C
      CALL MAPSTC ('OU','CO')
      CALL MAPSTI ('GR',5)
      CALL MAPPOS (.065,.495,.065,.495)
      CALL MAPSTR ('SA',8.5)
      CALL MAPROJ ('SV',0.,-25.,0.)
      CALL MAPINT
      CALL MAPLOT
      CALL MAPGRD
C
C Tell PLOTCHAR to map characters through EZMAP.
C
      CALL PCSETI ('MA - MAPPING FLAG',1)
      CALL PCSETR ('OR - OUT-OF-RANGE FLAG',1.E12)
C
C Write a line across the surface of the globe.
C
      CALL PLCHHQ (-25.,0.,':F25Y200:NCAR GRAPHICS',8.,30.,0.)
C
C Do an appropriate SET call for a rho-theta mapping.
C
      CALL SET    (.505,.935,.065,.495,-27.5,27.5,-27.5,27.5,1)
C
C Tell PLOTCHAR to use a rho-theta mapping.
C
      CALL PCSETI ('MA - MAPPING FLAG',2)
      CALL PCSETR ('OR - OUT-OF-RANGE FLAG',0.)
C
C Write three lines in rho/theta space, orienting them so they come out
C in a circle after mapping.
C
      CALL PLCHHQ (20., 90.,':F25Y125:NCAR GRAPHICS',8.,-90.,0.)
      CALL PLCHHQ (20.,210.,':F25Y125:NCAR GRAPHICS',8.,-90.,0.)
      CALL PLCHHQ (20.,-30.,':F25Y125:NCAR GRAPHICS',8.,-90.,0.)
C
C Turn off mapping and recall SET to allow fractional coordinates again.
C
      CALL PCSETI ('MA - MAPPING FLAG',0)
C
      CALL SET    (0.,1.,0.,1.,0.,1.,0.,1.,1)
C
C Change the drawing order to allow for "stacking" characters from
C right to left.
C
      CALL PCSETI ('DO - DRAWING ORDER',-2)
C
C Reduce the space between characters so the "stacking" is visible.
C
      CALL PCSETR ('SS - SUBTRACT-SPACE FLAG',.3)
C
C Turn off the box.  Make the shadows black and position them so they
C help make the stacked characters readable.
C
      CALL PCSETI ('BF - BOX FLAG',0)
      CALL PCSETI ('SC - SHADOW COLOR',0)
      CALL PCSETR ('SX - SHADOW OFFSET IN X',.1)
      CALL PCSETR ('SY - SHADOW OFFSET IN Y',0.)
C
C Write a final line demonstrating "stacking".
C
      CALL PLCHHQ (.5,.030,':F26:Use    ''DO''    and    ''SS''    to   +
     + "stack"    characters    in    either    direction.',
     +                                                       .026,0.,0.)
C
C Draw a bounding box
C
      CALL LINE(0.,0.,1.,0.)
      CALL LINE(1.,0.,1.,1.)
      CALL LINE(1.,1.,0.,1.)
      CALL LINE(0.,1.,0.,0.)
C
C Advance the frame.
C
      CALL FRAME
C
C Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
C Done.
C
      STOP
C
      END



      SUBROUTINE DRAWBX (XCEN,YCEN,ANGD,XTRA)
      CALL PCGETR ('DL - DISTANCE LEFT  ',DSTL)
      CALL PCGETR ('DR - DISTANCE RIGHT ',DSTR)
      CALL PCGETR ('DB - DISTANCE BOTTOM',DSTB)
      CALL PCGETR ('DT - DISTANCE TOP   ',DSTT)
      ANGR=.017453292519943*ANGD
      SINA=SIN(ANGR)
      COSA=COS(ANGR)
      XFRA=CUFX(XCEN)
      YFRA=CUFY(YCEN)
      XALB=XFRA-(DSTL+XTRA)*COSA+(DSTB+XTRA)*SINA
      YALB=YFRA-(DSTL+XTRA)*SINA-(DSTB+XTRA)*COSA
      XARB=XFRA+(DSTR+XTRA)*COSA+(DSTB+XTRA)*SINA
      YARB=YFRA+(DSTR+XTRA)*SINA-(DSTB+XTRA)*COSA
      XART=XFRA+(DSTR+XTRA)*COSA-(DSTT+XTRA)*SINA
      YART=YFRA+(DSTR+XTRA)*SINA+(DSTT+XTRA)*COSA
      XALT=XFRA-(DSTL+XTRA)*COSA-(DSTT+XTRA)*SINA
      YALT=YFRA-(DSTL+XTRA)*SINA+(DSTT+XTRA)*COSA
      CALL PLOTIF (XALB,YALB,0)
      CALL PLOTIF (XARB,YARB,1)
      CALL PLOTIF (XART,YART,1)
      CALL PLOTIF (XALT,YALT,1)
      CALL PLOTIF (XALB,YALB,1)
      CALL PLOTIF (0.,0.,2)
      RETURN
      END

C
C	$Id: initzt.f,v 1.6 2008-07-27 00:17:23 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE INITZT (IX,IY,IZ,LIN3,ITOP,IENT)
C
      SAVE
      COMMON /PWRZ1T/ XXMIN      ,XXMAX      ,YYMIN      ,YYMAX      ,
     +                ZZMIN      ,ZZMAX      ,DELCRT     ,EYEX       ,
     +                EYEY       ,EYEZ
C
      COMMON /PWRZ2T/ X          ,Y          ,Z
      FX(R) = R+FACTX*REAL(IX)
      FY(R) = R+FACTY*REAL(IY)
C
C
C  DETERMINE INITZT,VISSET,FRSTZ OR VECTZ CALL
C
      GO TO (1000,2000,3000,4000),IENT
 1000 LIN = MAX(1,MIN(3,ABS(LIN3)))
      ITO = MAX(1,MIN(3,ABS(ITOP)))
C
C SET UP SCALING CONSTANTS
C
      DELMAX = MAX(XXMAX-XXMIN,YYMAX-YYMIN,ZZMAX-ZZMIN)
      FACTOR = DELMAX/DELCRT
      FACTX = SIGN(FACTOR,REAL(LIN3))
      FACTY = SIGN(FACTOR,REAL(ITOP))
C
C SET UP FOR PROPER PLANE
C
      JUMP1 = LIN+(ITO-1)*3
      GO TO (108,101,102,103,108,104,105,106,108),JUMP1
  101 JUMP = 1
      GO TO 107
  102 JUMP = 2
      GO TO 107
  103 JUMP = 3
      GO TO 107
  104 JUMP = 4
      GO TO 107
  105 JUMP = 5
      GO TO 107
  106 JUMP = 6
  107 RETURN
  108 CALL SETER ('INITZT - LINE OR ITOP IMPROPER IN PWRZT CALL' ,1,1)
      LIN3 = 0
      RETURN
C
C **************************** ENTRY VISSET ****************************
C     ENTRY VISSET (IX,IY,IZ)
C
C
C VISSET IS CALLED ONCE FOR EACH END OF THE CHARACTER STRING
C
 2000 IVIS = -1
      ITEMP = 0
      GO TO 110
C
C SEE IF THIS END COULD BE BEHIND THE OBJECT
C
  109 IF (EYEX.GT.XXMAX .AND. XX.GT.XXMAX) ITEMP = ITEMP+1
      IF (EYEY.GT.YYMAX .AND. YY.GT.YYMAX) ITEMP = ITEMP+1
      IF (EYEZ.GT.ZZMAX .AND. ZZ.GT.ZZMAX) ITEMP = ITEMP+1
      IF (EYEX.LT.XXMIN .AND. XX.LT.XXMIN) ITEMP = ITEMP+1
      IF (EYEY.LT.YYMIN .AND. YY.LT.YYMIN) ITEMP = ITEMP+1
      IF (EYEZ.LT.ZZMIN .AND. ZZ.LT.ZZMIN) ITEMP = ITEMP+1
      IF (IZ .EQ. 1) IVISS = ITEMP
C
C IF EITHER END CHARACTER COULD BE HIDDEN, TEST ALL LINE SEGMENTS.
C
      IF (IZ .EQ. 2) IVIS = MIN(IVISS,ITEMP)
      RETURN
C
C **************************** ENTRY FRSTZ *****************************
C     ENTRY FRSTZ (IX,IY)
C
 3000 IFRST = 1
      GO TO 110
C
C **************************** ENTRY VECTZ *****************************
C     ENTRY VECTZ (IX,IY)
C
 4000 IFRST = 0
C
C PICK CORRECT 3-SPACE PLANE TO DRAW IN
C
  110 GO TO (111,112,113,114,115,116), JUMP
  111 XX = FY(X)
      YY = FX(Y)
      ZZ = Z
      GO TO 117
  112 XX = FY(X)
      YY = Y
      ZZ = FX(Z)
      GO TO 117
  113 XX = FX(X)
      YY = FY(Y)
      ZZ = Z
      GO TO 117
  114 XX = X
      YY = FY(Y)
      ZZ = FX(Z)
      GO TO 117
  115 XX = FX(X)
      YY = Y
      ZZ = FY(Z)
      GO TO 117
  116 XX = X
      YY = FX(Y)
      ZZ = FY(Z)
C
C TRANSLATE TO 2-SPACE
C
  117 CALL TRN32T (XX,YY,ZZ,XT,YT,DUMMY,2)
      IF (IVIS) 109,121,118
  118 IF (IFRST) 119,120,119
C
C IF IN FRONT, DRAW IN ANY CASE.
C
  119 CALL PLOTIT (32*INT(XT),32*INT(YT),0)
      RETURN
  120 CALL PLOTIT (32*INT(XT),32*INT(YT),1)
      RETURN
  121 IF (IFRST) 122,123,122
  122 IX1 = XT
      IY1 = YT
      RETURN
  123 IX2 = XT
      IY2 = YT
C
C IF COULD BE HIDDEN, USE HIDDEN LINE PLOTTING ENTRY IN THREED
C
      CALL DRAWT (IX1,IY1,IX2,IY2)
      IX1 = IX2
      IY1 = IY2
      RETURN
      END

      PROGRAM TPWRZI
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C OPEN GKS, OPEN WORKSTATION OF TYPE 1, ACTIVATE WORKSTATION
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C INVOKE DEMO DRIVER
C
      CALL TPWRZI1(IERR)
C
C DEACTIVATE AND CLOSE WORKSTATION, CLOSE GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END
C
      SUBROUTINE TPWRZI1 (IERROR)
C
C PURPOSE                To provide a simple demonstration of
C                        entry PWRZI with the ISOSRF utility.
C
C USAGE                  CALL TPWRZI1 (IERROR)
C
C ARGUMENTS
C
C ON OUTPUT              IERROR
C                          An integer variable
C                          = 0, if the test was successful,
C                          = 1, otherwise
C
C I/O                    If the test is successful, the message
C
C               PWRZI TEST EXECUTED--SEE PLOTS TO CERTIFY
C
C                        is printed on unit 6.  In addition, 1
C                        frame is produced on the machine graphics
C                        device.  In order to determine if the test
C                        was successful, it is necessary to examine
C                        the plot.
C
C PRECISION              Single
C
C REQUIRED ROUTINES      PWRZI, ISOSRF
C
C REQUIRED GKS LEVEL     0A
C
C LANGUAGE               FORTRAN 77
C
C ALGORITHM              A function of 3 variables is defined and the
C                        values of the function on a 3-D rectangular
C                        grid are stored in an array.  This test routine
C                        then calls ISOSRF to draw an iso-valued surface
C                        plot of the function.  PWRZI is then called 3
C                        times to label the front, side, and back of
C                        the picture.
C
      DIMENSION       T(21,31,19),SLAB(33,33),EYE(3)
C
C Define the center of a plot title string on a square grid of size
C 0. to 1.
C
      DATA TX/0.4375/, TY/0.9667/
C
      DATA NU,NV,NW/21,31,19/
      DATA RBIG1,RBIG2,RSML1,RSML2/6.,6.,2.,2./
      DATA TISO/0./
      DATA MUVWP2/33/
      DATA IFLAG/-7/
C
C Initialize the error parameter.
C
      IERROR = 1
C
C Fill the 3-D array to be plotted.
C
      JCENT1 = REAL(NV)*.5-RBIG1*.5
      JCENT2 = REAL(NV)*.5+RBIG2*.5
      DO  30 I=1,NU
         FIMID = I-NU/2
         DO  20 J=1,NV
            FJMID1 = J-JCENT1
            FJMID2 = J-JCENT2
            DO  10 K=1,NW
               FKMID = K-NW/2
               F1 = SQRT(RBIG1*RBIG1/(FJMID1*FJMID1+FKMID*FKMID+.1))
               F2 = SQRT(RBIG2*RBIG2/(FIMID*FIMID+FJMID2*FJMID2+.1))
               FIP1 = (1.-F1)*FIMID
               FIP2 = (1.-F2)*FIMID
               FJP1 = (1.-F1)*FJMID1
               FJP2 = (1.-F2)*FJMID2
               FKP1 = (1.-F1)*FKMID
               FKP2 = (1.-F2)*FKMID
               T(I,J,K) = MIN(FIMID*FIMID+FJP1*FJP1+FKP1*FKP1-
     1                    RSML1*RSML1,
     2                      FKMID*FKMID+FIP2*FIP2+FJP2*FJP2-RSML2*RSML2)
   10       CONTINUE
   20    CONTINUE
   30 CONTINUE
C
C Define the eye position.
C
      EYE(1) = 100.
      EYE(2) = 150.
      EYE(3) = 125.
C
C Select normalization transformation number 0.
C
      CALL GSELNT (0)
C
C Label the plot.
C
      CALL PLCHLQ (TX,TY,'DEMONSTRATION PLOT FOR PWRZI',16.,0.,0.)
C
C Test ISOSRF with subarray T.
C
      MU = NU/2
      MV = NV/2
      MW = NW/2
      MUVWP2 = MAX(MU,MV,MW)+2
      CALL ISOSRF (T(MU,MV,MW),NU,MU,NV,MV,MW,EYE,MUVWP2,SLAB,TISO,
     1             IFLAG)
      ISIZE = 35
      CALL PWRZI (5.,16.,.5,'FRONT',5,ISIZE,-1,3,0)
      CALL PWRZI (11.,7.5,.5,'SIDE',4,ISIZE,2,-1,0)
      CALL PWRZI (5.,1.,5.,' BACK BACK BACK BACK BACK',25,ISIZE,-1,3,0)
      CALL FRAME
      IERROR = 0
C
      WRITE (6,1001)
      RETURN
C
 1001 FORMAT (' PWRZI TEST EXECUTED--SEE PLOT TO CERTIFY')
C
      END

      SUBROUTINE SLACON( N, V, X, ISGN, EST, KASE )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     February 29, 1992
*
*     .. Scalar Arguments ..
      INTEGER            KASE, N
      REAL               EST
*     ..
*     .. Array Arguments ..
      INTEGER            ISGN( * )
      REAL               V( * ), X( * )
*     ..
*
*  Purpose
*  =======
*
*  SLACON estimates the 1-norm of a square, real matrix A.
*  Reverse communication is used for evaluating matrix-vector products.
*
*  Arguments
*  =========
*
*  N      (input) INTEGER
*         The order of the matrix.  N >= 1.
*
*  V      (workspace) REAL array, dimension (N)
*         On the final return, V = A*W,  where  EST = norm(V)/norm(W)
*         (W is not returned).
*
*  X      (input/output) REAL array, dimension (N)
*         On an intermediate return, X should be overwritten by
*               A * X,   if KASE=1,
*               A' * X,  if KASE=2,
*         and SLACON must be re-called with all the other parameters
*         unchanged.
*
*  ISGN   (workspace) INTEGER array, dimension (N)
*
*  EST    (output) REAL
*         An estimate (a lower bound) for norm(A).
*
*  KASE   (input/output) INTEGER
*         On the initial call to SLACON, KASE should be 0.
*         On an intermediate return, KASE will be 1 or 2, indicating
*         whether X should be overwritten by A * X  or A' * X.
*         On the final return from SLACON, KASE will again be 0.
*
*  Further Details
*  ======= =======
*
*  Contributed by Nick Higham, University of Manchester.
*  Originally named SONEST, dated March 16, 1988.
*
*  Reference: N.J. Higham, "FORTRAN codes for estimating the one-norm of
*  a real or complex matrix, with applications to condition estimation",
*  ACM Trans. Math. Soft., vol. 14, no. 4, pp. 381-396, December 1988.
*
*  =====================================================================
*
*     .. Parameters ..
      INTEGER            ITMAX
      PARAMETER          ( ITMAX = 5 )
      REAL               ZERO, ONE, TWO
      PARAMETER          ( ZERO = 0.0E+0, ONE = 1.0E+0, TWO = 2.0E+0 )
*     ..
*     .. Local Scalars ..
      INTEGER            I, ITER, J, JLAST, JUMP
      REAL               ALTSGN, ESTOLD, TEMP
*     ..
*     .. External Functions ..
      INTEGER            ISAMAX
      REAL               SASUM
      EXTERNAL           ISAMAX, SASUM
*     ..
*     .. External Subroutines ..
      EXTERNAL           SCOPY
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, NINT, REAL, SIGN
*     ..
*     .. Save statement ..
      SAVE
*     ..
*     .. Executable Statements ..
*
      IF( KASE.EQ.0 ) THEN
         DO 10 I = 1, N
            X( I ) = ONE / REAL( N )
   10    CONTINUE
         KASE = 1
         JUMP = 1
         RETURN
      END IF
*
      GO TO ( 20, 40, 70, 110, 140 )JUMP
*
*     ................ ENTRY   (JUMP = 1)
*     FIRST ITERATION.  X HAS BEEN OVERWRITTEN BY A*X.
*
   20 CONTINUE
      IF( N.EQ.1 ) THEN
         V( 1 ) = X( 1 )
         EST = ABS( V( 1 ) )
*        ... QUIT
         GO TO 150
      END IF
      EST = SASUM( N, X, 1 )
*
      DO 30 I = 1, N
         X( I ) = SIGN( ONE, X( I ) )
         ISGN( I ) = NINT( X( I ) )
   30 CONTINUE
      KASE = 2
      JUMP = 2
      RETURN
*
*     ................ ENTRY   (JUMP = 2)
*     FIRST ITERATION.  X HAS BEEN OVERWRITTEN BY TRANSPOSE(A)*X.
*
   40 CONTINUE
      J = ISAMAX( N, X, 1 )
      ITER = 2
*
*     MAIN LOOP - ITERATIONS 2,3,...,ITMAX.
*
   50 CONTINUE
      DO 60 I = 1, N
         X( I ) = ZERO
   60 CONTINUE
      X( J ) = ONE
      KASE = 1
      JUMP = 3
      RETURN
*
*     ................ ENTRY   (JUMP = 3)
*     X HAS BEEN OVERWRITTEN BY A*X.
*
   70 CONTINUE
      CALL SCOPY( N, X, 1, V, 1 )
      ESTOLD = EST
      EST = SASUM( N, V, 1 )
      DO 80 I = 1, N
         IF( NINT( SIGN( ONE, X( I ) ) ).NE.ISGN( I ) )
     $      GO TO 90
   80 CONTINUE
*     REPEATED SIGN VECTOR DETECTED, HENCE ALGORITHM HAS CONVERGED.
      GO TO 120
*
   90 CONTINUE
*     TEST FOR CYCLING.
      IF( EST.LE.ESTOLD )
     $   GO TO 120
*
      DO 100 I = 1, N
         X( I ) = SIGN( ONE, X( I ) )
         ISGN( I ) = NINT( X( I ) )
  100 CONTINUE
      KASE = 2
      JUMP = 4
      RETURN
*
*     ................ ENTRY   (JUMP = 4)
*     X HAS BEEN OVERWRITTEN BY TRANSPOSE(A)*X.
*
  110 CONTINUE
      JLAST = J
      J = ISAMAX( N, X, 1 )
      IF( ( X( JLAST ).NE.ABS( X( J ) ) ) .AND. ( ITER.LT.ITMAX ) ) THEN
         ITER = ITER + 1
         GO TO 50
      END IF
*
*     ITERATION COMPLETE.  FINAL STAGE.
*
  120 CONTINUE
      ALTSGN = ONE
      DO 130 I = 1, N
         X( I ) = ALTSGN*( ONE+REAL( I-1 ) / REAL( N-1 ) )
         ALTSGN = -ALTSGN
  130 CONTINUE
      KASE = 1
      JUMP = 5
      RETURN
*
*     ................ ENTRY   (JUMP = 5)
*     X HAS BEEN OVERWRITTEN BY A*X.
*
  140 CONTINUE
      TEMP = TWO*( SASUM( N, X, 1 ) / REAL( 3*N ) )
      IF( TEMP.GT.EST ) THEN
         CALL SCOPY( N, X, 1, V, 1 )
         EST = TEMP
      END IF
*
  150 CONTINUE
      KASE = 0
      RETURN
*
*     End of SLACON
*
      END

C
C $Id: pj04sp.f,v 1.5 2008-07-27 00:17:10 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE PJ04SP (COORD,CRDIO,INDIC)
C
C -- L A M B E R T   C O N F O R M A L   C O N I C
C
      IMPLICIT REAL (A-Z)
      INTEGER INDIC
      DIMENSION GEOG(2),PROJ(2),COORD(2),CRDIO(2)
C **** PARAMETERS **** A,E,ES,LAT1,LAT2,LON0,LAT0,X0,Y0,NS,F,RH0 *******
      COMMON /ERRMZ0/ IERR
        INTEGER IERR
      SAVE   /ERRMZ0/
      COMMON /PRINZ0/ IPEMSG,IPELUN,IPPARM,IPPLUN
        INTEGER IPEMSG,IPELUN,IPPARM,IPPLUN
      SAVE   /PRINZ0/
      COMMON /PC04SP/ A,LON0,X0,Y0,E,F,NS,RH0
      DATA HALFPI /1.5707963267948966E0/
      DATA EPSLN /1.0E-10/
      DATA ZERO,ONE /0.0E0,1.0E0/
C
C -- F O R W A R D   . . .
C
      IF (INDIC .EQ. 0) THEN
C
         GEOG(1) = COORD(1)
         GEOG(2) = COORD(2)
         IERR = 0
         CON = ABS (ABS (GEOG(2)) - HALFPI)
         IF (CON .GT. EPSLN) GO TO 220
         CON = GEOG(2) * NS
         IF (CON .GT. ZERO) GO TO 210
         IF (IPEMSG .EQ. 0) WRITE (IPELUN,2030)
 2030    FORMAT (/' ERROR PJ04SP'/
     .            ' POINT CANNOT BE PROJECTED')
         IERR = 044
         RETURN
  210    RH = ZERO
         GO TO 230
  220    SINPHI = SIN (GEOG(2))
         TS = TSFNSP (E,GEOG(2),SINPHI)
         RH = A * F * TS ** NS
  230    THETA = NS * ADJLSP (GEOG(1) - LON0)
         PROJ(1) = X0 + RH * SIN (THETA)
         PROJ(2) = Y0 + RH0 - RH * COS (THETA)
         CRDIO(1) = PROJ(1)
         CRDIO(2) = PROJ(2)
         RETURN
      END IF
C
C -- I N V E R S E   . . .
C
      IF (INDIC .EQ. 1) THEN
C
         PROJ(1) = COORD(1)
         PROJ(2) = COORD(2)
         IERR = 0
         X = PROJ(1) - X0
         Y = RH0 - PROJ(2) + Y0
         RH = SIGN (SQRT (X*X + Y*Y) , NS)
         THETA = ZERO
         CON = SIGN (ONE , NS)
         IF (RH .NE. ZERO) THETA = ATAN2 (CON * X , CON * Y)
         IF (RH.NE.ZERO .OR. NS.GT.ZERO) GO TO 250
         GEOG(2) = - HALFPI
         GO TO 260
  250    CON = ONE / NS
         TS = (RH / (A * F)) ** CON
         GEOG(2) = PHI2SP (E,TS)
         IF (IERR .EQ. 0) GO TO 260
         IERR = 046
         RETURN
  260    GEOG(1) = ADJLSP (THETA / NS + LON0)
         CRDIO(1) = GEOG(1)
         CRDIO(2) = GEOG(2)
         RETURN
      END IF
C
      END

C
C $Id: pcgtpi.f,v 1.11 2008-07-27 00:17:19 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE PCGTPI (CHRS,NCHR,ICHR,IBSE,NUMV)
C
C The subroutine PCGTPI gets a positive integer from the character
C string CHRS.  Its arguments are as follows:
C
C   CHRS is an input variable.  It contains a character string.
C
C   NCHR is an input variable specifying the number of characters in
C   CHRS.
C
C   ICHR is both an input variable and an output variable.  On entry,
C   it contains the index of the character in CHRS at which a positive
C   integer may start.  On exit, it contains the index of the character
C   following the last character of the integer, if one was found;
C   otherwise, it is unchanged.
C
C   IBSE is an input variable, specifying the base value to be used in
C   computing the value of the integer - either 8 or 10.
C
C   NUMV is an output variable containing the value of the positive
C   integer found.  The value zero indicates that no such integer was
C   found.
C
C COMMON block declarations.
C
      COMMON /PCSVEM/ ICOD,IDDA(8625),IDDL,RDGU(7000),IDPC(256),IERU,
     +                INDA(789),INDL,INIT,IVCO,IVDU,NBPW,NPPW
      SAVE   /PCSVEM/
C
      CHARACTER*(*) CHRS
C
C Initialize the value to be returned.
C
      NUMV=0
C
C Get the DPC value of the character '0' in the collating sequence.
C
      IZRO=IDPC(ICHAR('0'))
C
C Examine each character, updating the value of the number and the
C position of the first possible non-digit, until a non-digit is found.
C
      IMAX=NCHR-ICHR+1
      DO 101 I=1,IMAX
        IDGT=IDPC(ICHAR(CHRS(ICHR:ICHR)))-IZRO
        IF (IDGT.GE.0.AND.IDGT.LT.IBSE) THEN
          NUMV=IBSE*NUMV+IDGT
          ICHR=ICHR+1
        ELSE
          RETURN
        END IF
 101  CONTINUE
C
C Done.
C
      RETURN
C
      END

      SUBROUTINE STBCON( NORM, UPLO, DIAG, N, KD, AB, LDAB, RCOND, WORK,
     $                   IWORK, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     March 31, 1993 
*
*     .. Scalar Arguments ..
      CHARACTER          DIAG, NORM, UPLO
      INTEGER            INFO, KD, LDAB, N
      REAL               RCOND
*     ..
*     .. Array Arguments ..
      INTEGER            IWORK( * )
      REAL               AB( LDAB, * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  STBCON estimates the reciprocal of the condition number of a
*  triangular band matrix A, in either the 1-norm or the infinity-norm.
*
*  The norm of A is computed and an estimate is obtained for
*  norm(inv(A)), then the reciprocal of the condition number is
*  computed as
*     RCOND = 1 / ( norm(A) * norm(inv(A)) ).
*
*  Arguments
*  =========
*
*  NORM    (input) CHARACTER*1
*          Specifies whether the 1-norm condition number or the
*          infinity-norm condition number is required:
*          = '1' or 'O':  1-norm;
*          = 'I':         Infinity-norm.
*
*  UPLO    (input) CHARACTER*1
*          = 'U':  A is upper triangular;
*          = 'L':  A is lower triangular.
*
*  DIAG    (input) CHARACTER*1
*          = 'N':  A is non-unit triangular;
*          = 'U':  A is unit triangular.
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  KD      (input) INTEGER
*          The number of superdiagonals or subdiagonals of the
*          triangular band matrix A.  KD >= 0.
*
*  AB      (input) REAL array, dimension (LDAB,N)
*          The upper or lower triangular band matrix A, stored in the
*          first kd+1 rows of the array. The j-th column of A is stored
*          in the j-th column of the array AB as follows:
*          if UPLO = 'U', AB(kd+1+i-j,j) = A(i,j) for max(1,j-kd)<=i<=j;
*          if UPLO = 'L', AB(1+i-j,j)    = A(i,j) for j<=i<=min(n,j+kd).
*          If DIAG = 'U', the diagonal elements of A are not referenced
*          and are assumed to be 1.
*
*  LDAB    (input) INTEGER
*          The leading dimension of the array AB.  LDAB >= KD+1.
*
*  RCOND   (output) REAL
*          The reciprocal of the condition number of the matrix A,
*          computed as RCOND = 1/(norm(A) * norm(inv(A))).
*
*  WORK    (workspace) REAL array, dimension (3*N)
*
*  IWORK   (workspace) INTEGER array, dimension (N)
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ONE, ZERO
      PARAMETER          ( ONE = 1.0E+0, ZERO = 0.0E+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            NOUNIT, ONENRM, UPPER
      CHARACTER          NORMIN
      INTEGER            IX, KASE, KASE1
      REAL               AINVNM, ANORM, SCALE, SMLNUM, XNORM
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            ISAMAX
      REAL               SLAMCH, SLANTB
      EXTERNAL           LSAME, ISAMAX, SLAMCH, SLANTB
*     ..
*     .. External Subroutines ..
      EXTERNAL           SLACON, SLATBS, SRSCL, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, MAX, REAL
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      UPPER = LSAME( UPLO, 'U' )
      ONENRM = NORM.EQ.'1' .OR. LSAME( NORM, 'O' )
      NOUNIT = LSAME( DIAG, 'N' )
*
      IF( .NOT.ONENRM .AND. .NOT.LSAME( NORM, 'I' ) ) THEN
         INFO = -1
      ELSE IF( .NOT.UPPER .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = -2
      ELSE IF( .NOT.NOUNIT .AND. .NOT.LSAME( DIAG, 'U' ) ) THEN
         INFO = -3
      ELSE IF( N.LT.0 ) THEN
         INFO = -4
      ELSE IF( KD.LT.0 ) THEN
         INFO = -5
      ELSE IF( LDAB.LT.KD+1 ) THEN
         INFO = -7
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'STBCON', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 ) THEN
         RCOND = ONE
         RETURN
      END IF
*
      RCOND = ZERO
      SMLNUM = SLAMCH( 'Safe minimum' )*REAL( MAX( 1, N ) )
*
*     Compute the norm of the triangular matrix A.
*
      ANORM = SLANTB( NORM, UPLO, DIAG, N, KD, AB, LDAB, WORK )
*
*     Continue only if ANORM > 0.
*
      IF( ANORM.GT.ZERO ) THEN
*
*        Estimate the norm of the inverse of A.
*
         AINVNM = ZERO
         NORMIN = 'N'
         IF( ONENRM ) THEN
            KASE1 = 1
         ELSE
            KASE1 = 2
         END IF
         KASE = 0
   10    CONTINUE
         CALL SLACON( N, WORK( N+1 ), WORK, IWORK, AINVNM, KASE )
         IF( KASE.NE.0 ) THEN
            IF( KASE.EQ.KASE1 ) THEN
*
*              Multiply by inv(A).
*
               CALL SLATBS( UPLO, 'No transpose', DIAG, NORMIN, N, KD,
     $                      AB, LDAB, WORK, SCALE, WORK( 2*N+1 ), INFO )
            ELSE
*
*              Multiply by inv(A').
*
               CALL SLATBS( UPLO, 'Transpose', DIAG, NORMIN, N, KD, AB,
     $                      LDAB, WORK, SCALE, WORK( 2*N+1 ), INFO )
            END IF
            NORMIN = 'Y'
*
*           Multiply by 1/SCALE if doing so will not cause overflow.
*
            IF( SCALE.NE.ONE ) THEN
               IX = ISAMAX( N, WORK, 1 )
               XNORM = ABS( WORK( IX ) )
               IF( SCALE.LT.XNORM*SMLNUM .OR. SCALE.EQ.ZERO )
     $            GO TO 20
               CALL SRSCL( N, SCALE, WORK, 1 )
            END IF
            GO TO 10
         END IF
*
*        Compute the estimate of the reciprocal condition number.
*
         IF( AINVNM.NE.ZERO )
     $      RCOND = ( ONE / ANORM ) / AINVNM
      END IF
*
   20 CONTINUE
      RETURN
*
*     End of STBCON
*
      END

C
C	$Id: cssgprnt.f,v 1.5 2008-07-27 03:10:08 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CSSGPRNT (N,LUNIT,LIST,LPTR,LEND,SIGMA)
      INTEGER N, LUNIT, LIST(*), LPTR(*), LEND(N)
      DOUBLE PRECISION SIGMA(*)
C
C***********************************************************
C
C                                              From SSRFPACK
C                                            Robert J. Renka
C                                  Dept. of Computer Science
C                                       Univ. of North Texas
C                                           renka@cs.unt.edu
C                                                   07/21/98
C
C   Given a triangulation of a set of nodes on the unit
C sphere, along with an array of tension factors associated
C with the triangulation arcs, this subroutine prints the
C list of arcs (with tension factors) ordered by endpoint
C nodal indexes.  An arc is identified with its smaller
C endpoint index:  N1-N2, where N1 < N2.
C
C   This routine is identical to the similarly named routine
C in SRFPACK.
C
C
C On input:
C
C       N = Number of nodes in the triangulation.  3 .LE. N
C           .LE. 9999.
C
C       LUNIT = Logical unit for output.  0 .LE. LUNIT .LE.
C               99.  Output is printed on unit 6 if LUNIT is
C               outside its valid range.
C
C       LIST,LPTR,LEND = Data structure defining the trian-
C                        gulation.  Refer to STRIPACK
C                        Subroutine CSTRMESH.
C
C       SIGMA = Array of length 2*NA = 6*(N-1)-2*NB, where
C               NA and NB are the numbers of arcs and boun-
C               dary nodes, respectively, containing tension
C               factors associated with arcs in one-to-one
C               correspondence with LIST entries.  Note that
C               each arc N1-N2 has two LIST entries and
C               thus, SIGMA(I) and SIGMA(J) should be iden-
C               tical, where LIST(I) = N2 (in the adjacency
C               list for N1) and LIST(J) = N1 (in the list
C               associated with N2).  Both SIGMA(I) and
C               SIGMA(J) are printed if they are not iden-
C               tical.
C
C None of the parameters are altered by this routine.
C
C STRIPACK module required by CSSGPRNT:  CSLSTPTR
C
C Intrinsic function called by CSSGPRNT:  ABS
C
C***********************************************************
C
      INTEGER CSLSTPTR
      INTEGER LP1, LP2, LPL, LUN, N1, N2, NA, NAT, NB, NE,
     .        NL, NLMAX, NM1, NMAX
      LOGICAL ERROR
      DOUBLE PRECISION SIG
      DATA NMAX/9999/,  NLMAX/58/
C
      LUN = LUNIT
      IF (LUN .LT. 0  .OR.  LUN .GT. 99) LUN = 6
C
C Print a heading, test for invalid N, and initialize coun-
C   ters:
C
C NL = Number of lines printed on the current page
C NA = Number of arcs encountered
C NE = Number of errors in SIGMA encountered
C NB = Number of boundary nodes encountered
C
      WRITE (LUN,100) N
      IF (N .LT. 3  .OR.  N .GT. NMAX) GO TO 4
      NL = 6
      NA = 0
      NE = 0
      NB = 0
C
C Outer loop on nodes N1.  LPL points to the last neighbor
C   of N1.
C
      NM1 = N - 1
      DO 3 N1 = 1,NM1
        LPL = LEND(N1)
        IF (LIST(LPL) .LT. 0) NB = NB + 1
        LP1 = LPL
C
C Inner loop on neighbors N2 of N1 such that N1 < N2.
C
    1   LP1 = LPTR(LP1)
          N2 = ABS(LIST(LP1))
          IF (N2 .LT. N1) GO TO 2
          NA = NA + 1
          SIG = SIGMA(LP1)
C
C   Test for an invalid SIGMA entry.
C
          LP2 = CSLSTPTR (LEND(N2),N1,LIST,LPTR)
          ERROR = SIGMA(LP2) .NE. SIG
          IF (ERROR) NE = NE + 1
C
C   Print a line and update the counters.
C
          IF (.NOT. ERROR) WRITE (LUN,110) N1, N2, SIG
          IF (ERROR) WRITE (LUN,120) N1, N2, SIG, SIGMA(LP2)
          NL = NL + 1
          IF (NL .GE. NLMAX) THEN
            WRITE (LUN,130)
            NL = 1
          ENDIF
C
C Bottom of loop on neighbors N2 of N1.
C
    2     IF (LP1 .NE. LPL) GO TO 1
    3   CONTINUE
      LPL = LEND(N)
      IF (LIST(LPL) .LT. 0) NB = NB + 1
C
C Test for errors in SIGMA.
C
      IF (NE .GT. 0) WRITE (LUN,200) NE
C
C Print NA and test for an invalid triangulation.
C
      WRITE (LUN,140) NA
      IF (NB .NE. 0) THEN
        NAT = 3*NM1 - NB
      ELSE
        NAT = 3*N - 6
      ENDIF
      IF (NAT .NE. NA) WRITE (LUN,210) NAT
      RETURN
C
C N is outside its valid range.
C
    4 WRITE (LUN,220) NMAX
      RETURN
C
C Print formats:
C
  100 FORMAT ('1',14X,'TENSION FACTORS,  N =',I5,
     .        ' NODES'//1X,18X,'N1',5X,'N2',8X,'TENSION'//)
  110 FORMAT (1X,16X,I4,3X,I4,5X,F12.8)
  120 FORMAT (1X,16X,I4,3X,I4,5X,F12.8,3X,F12.8,' *')
  130 FORMAT ('1')
  140 FORMAT (//1X,10X,'NA =',I5,' ARCS')
C
C Error messages:
C
  200 FORMAT (//1X,10X,'*',I5,' ERRORS IN SIGMA')
  210 FORMAT (/1X,10X,'*** ERROR IN TRIANGULATION -- ',
     .        '3N-NB-3 = ',I5,' ***')
  220 FORMAT (1X,10X,'*** N IS OUT OF RANGE -- NMAX = ',
     .        I4,' ***')
      END

C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CSA1XS (NI,XI,YI,WTS,KNOTS,SSMTH,NDERIV,NO,XO,YO,
     +                   NWRK,WORK,IER)
C
      DIMENSION XI(NI),YI(NI),WTS(*),XO(NO),YO(NO),WORK(NWRK)
C
C  Check on the number of knots.
C
      IF (KNOTS .LT. 4) THEN
        CALL CFAERR (202,' CSA1XS - must have at least four knots',39)       
        IER = 202
        RETURN
      ENDIF
C
C  Check on the size of the workspace.
C
      IF (NWRK .LT. KNOTS*(KNOTS+3)) THEN
        CALL CFAERR (203,' CSA1XS - workspace too small',29)
        IER = 203
        RETURN
      ENDIF
C
C  Calculate the min and max for the knots as the minimum value of
C  the input data and output data and the maximum of the input and
C  output data.
C
      XMN = XI(1)
      XMX = XI(1)
      DO 10 I=2,NI
        XMN = MIN(XMN,XI(I))
        XMX = MAX(XMX,XI(I))
   10 CONTINUE
      XMN = MIN(XMN,XO(1))
      XMX = MAX(XMX,XO(NO))
C
C  Find the coefficients.
C
      CALL SPLCW(1,XI,1,YI,WTS,NI,XMN,XMX,KNOTS,SSMTH,WORK,KNOTS,       
     +           WORK(KNOTS+1),NWRK-KNOTS,IERR)
      IF (IERR .NE. 0) RETURN
C
C  Calculate the approximated values.
C
      DO 20 I=1,NO
        YO(I) = SPLDE(1,XO(I),NDERIV,WORK,XMN,XMX,KNOTS,IER)
        IF (IERR .NE. 0) RETURN
   20 CONTINUE
C
      RETURN
      END

C
C	$Id: csgetnp.f,v 1.5 2008-07-27 03:10:06 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CSGETNP (X,Y,Z,LIST,LPTR,LEND,L, NPTS, DF,
     .                  IER)
      INTEGER LIST(*), LPTR(*), LEND(*), L, NPTS(L), IER
      DOUBLE PRECISION X(*), Y(*), Z(*), DF
C
C***********************************************************
C
C                                              From STRIPACK
C                                            Robert J. Renka
C                                  Dept. of Computer Science
C                                       Univ. of North Texas
C                                           renka@cs.unt.edu
C                                                   07/28/98
C
C   Given a Delaunay triangulation of N nodes on the unit
C sphere and an array NPTS containing the indexes of L-1
C nodes ordered by angular distance from NPTS(1), this sub-
C routine sets NPTS(L) to the index of the next node in the
C sequence -- the node, other than NPTS(1),...,NPTS(L-1),
C that is closest to NPTS(1).  Thus, the ordered sequence
C of K closest nodes to N1 (including N1) may be determined
C by K-1 calls to CSGETNP with NPTS(1) = N1 and L = 2,3,...,K
C for K .GE. 2.
C
C   The algorithm uses the property of a Delaunay triangula-
C tion that the K-th closest node to N1 is a neighbor of one
C of the K-1 closest nodes to N1.
C
C
C On input:
C
C       X,Y,Z = Arrays of length N containing the Cartesian
C               coordinates of the nodes.
C
C       LIST,LPTR,LEND = Triangulation data structure.  Re-
C                        fer to Subroutine CSTRMESH.
C
C       L = Number of nodes in the sequence on output.  2
C           .LE. L .LE. N.
C
C The above parameters are not altered by this routine.
C
C       NPTS = Array of length .GE. L containing the indexes
C              of the L-1 closest nodes to NPTS(1) in the
C              first L-1 locations.
C
C On output:
C
C       NPTS = Array updated with the index of the L-th
C              closest node to NPTS(1) in position L unless
C              IER = 1.
C
C       DF = Value of an increasing function (negative cos-
C            ine) of the angular distance between NPTS(1)
C            and NPTS(L) unless IER = 1.
C
C       IER = Error indicator:
C             IER = 0 if no errors were encountered.
C             IER = 1 if L < 2.
C
C Modules required by CSGETNP:  None
C
C Intrinsic function called by CSGETNP:  ABS
C
C***********************************************************
C
      INTEGER I, LM1, LP, LPL, N1, NB, NI, NP
      DOUBLE PRECISION DNB, DNP, X1, Y1, Z1
C
C Local parameters:
C
C DNB,DNP =  Negative cosines of the angular distances from
C              N1 to NB and to NP, respectively
C I =        NPTS index and DO-loop index
C LM1 =      L-1
C LP =       LIST pointer of a neighbor of NI
C LPL =      Pointer to the last neighbor of NI
C N1 =       NPTS(1)
C NB =       Neighbor of NI and candidate for NP
C NI =       NPTS(I)
C NP =       Candidate for NPTS(L)
C X1,Y1,Z1 = Coordinates of N1
C
      LM1 = L - 1
      IF (LM1 .LT. 1) GO TO 6
      IER = 0
C
C Store N1 = NPTS(1) and mark the elements of NPTS.
C
      N1 = NPTS(1)
      X1 = X(N1)
      Y1 = Y(N1)
      Z1 = Z(N1)
      DO 1 I = 1,LM1
        NI = NPTS(I)
        LEND(NI) = -LEND(NI)
    1   CONTINUE
C
C Candidates for NP = NPTS(L) are the unmarked neighbors
C   of nodes in NPTS.  DNP is initially greater than -cos(PI)
C   (the maximum distance).
C
      DNP = 2.D0
C
C Loop on nodes NI in NPTS.
C
      DO 4 I = 1,LM1
        NI = NPTS(I)
        LPL = -LEND(NI)
        LP = LPL
C
C Loop on neighbors NB of NI.
C
    2   NB = ABS(LIST(LP))
          IF (LEND(NB) .LT. 0) GO TO 3
C
C NB is an unmarked neighbor of NI.  Replace NP if NB is
C   closer to N1.
C
          DNB = -(X(NB)*X1 + Y(NB)*Y1 + Z(NB)*Z1)
          IF (DNB .GE. DNP) GO TO 3
          NP = NB
          DNP = DNB
    3     LP = LPTR(LP)
          IF (LP .NE. LPL) GO TO 2
    4   CONTINUE
      NPTS(L) = NP
      DF = DNP
C
C Unmark the elements of NPTS.
C
      DO 5 I = 1,LM1
        NI = NPTS(I)
        LEND(NI) = -LEND(NI)
    5   CONTINUE
      RETURN
C
C L is outside its valid range.
C
    6 IER = 1
      RETURN
      END

C
C	$Id: tlocalcray.f,v 1.4 2008-07-27 00:59:03 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      PROGRAM TLOCAL
C
C +-----------------------------------------------------------------+
C |                                                                 |
C |                Copyright (C) 1987 by UCAR                       |
C |        University Corporation for Atmospheric Research          |
C |                    All Rights Reserved                          |
C |                                                                 |
C |                 NCARGRAPHICS  Version 2.00                      |
C |                                                                 |
C +-----------------------------------------------------------------+
C
C     Test program for locally implemented support routines
C     IAND, IOR, ISHIFT, GBYTES, SBYTES
C
      INTEGER BYTLNG,WRDLNG
      DIMENSION MASK0(64)
      DIMENSION MASK1(65)
      DIMENSION ISCR(190)
C
C     This is a test package designed to test the locally
C     implemented routines for the NCAR GKS-based graphics
C     package.   Although the tests are not exhaustive,
C     they give a fairly  good idea whether a routine works
C     or not.
C
C     Appropriate messages are printed when a routine passes or
C     fails a test.  The test package is written in FORTRAN 77
C     with the following machine assumptions:  non-negative
C     integers must be stored in binary format, in one machine word--
C     hence, a word of all 0 bits is zero; a word with only the
C     rightmost bit set is one, etc.
C
C     The test package consists of a main program and various
C     subroutines.  To run the test package, compile it as FORTRAN,
C     and load and execute it with your locally written routines.
C     Certain information must be supplied to the main program
C     before the test.  This is most conveniently supplied by
C     changing certain data statements at the beginning of the main
C     program.  Below are 8 groups of comments.  Each group
C     describes the information required in the data statements
C     which follow it.  Read the directions and modify the data
C     statements as required.
C
C
C 1.  IOUT.  IOUT is an integer variable containing the unit
C     number on which the test package is to output all messages.
C     It is used, for example, in statements like
C
C                  WRITE (IOUT,9999)
C
C     IOUT has been initialized to 6, but you should reset IOUT so
C     that messages come to your line printer.  The test
C     assumes at least 72 columns per line including carriage
C     control.  There are no read statements.
C
      DATA IOUT/6/
C
C
C 2.  WRDLNG.     WRDLNG is an integer variable which contains the
C     number of bits in a machine word in your computer,
C        e.g.   For an ibm 360/370,  wrdlng = 32;
C               for a CRAY-1,  WRDLNG = 64 .
C     WRDLNG must be at least 16 bits and at most 64 bits.
C

      DATA WRDLNG/64/

C
C
C 3.  INLNGA and INLNGC.
C
C     INLNGA is an integer variable specifying the number of
C     contiguous low-order bits transferred from J to I by the
C     FORTRAN assignment statement
C
C         I=J
C
C     INLNGC is an integer variable specifying the number of
C     contiguous low-order bits actually participating in the
C     comparison performed by a FORTRAN statement like
C
C          IF (I.NE.J) GO TO 10
C
C     These parameters are used to determine the highest-order
C     bit that the test package can use in integer operations.
C     If either is less that WRDLNG, the routines IAND, IOR, and
C     ISHIFT are not fully tested.  If either is less than 16,
C     no testing can be done, and the package probably cannot be
C     made to run.
C
C

      DATA INLNGA /64/
      DATA INLNGC /64/


C
C
C 4.  MASK0.  MASK0 is an integer array of WRDLNG elements.
C     Each element contains all zero bits except for 1 one bit.
C     In element I, the one bit is I-1 bits from the right.  Hence,
C     MASK0(1) has the rightmost bit set, MASK0(WRDLNG) has the
C     leftmost bit set.  In terms of integers, MASK0(I) = 2**(I-1).
C     The test program comes with 64 data statements initializing
C     MASK0.  However, on most computers overflow will cause some of
C     our supplied values to be invalid.  You should begin by
C     removing the last 64-WRDLNG data statements, since these are for
C     word sizes larger than yours.  There should be WRDLNG data
C     statements remaining.  You should then change the last few of
C     these data statements to eliminate overflow, and generate the
C     proper values as defined above.  You may want to use octal or
C     hex constants.  The test program cannot check that MASK0 has
C     been initialized properly, but it is crucial that it be set
C     correctly.
C
C
	
      DATA MASK0( 1) / x'0000000000000001' /,
     1     MASK0( 2) / x'0000000000000002' /,
     2     MASK0( 3) / x'0000000000000004' /,
     3     MASK0( 4) / x'0000000000000008' /,
     4     MASK0( 5) / x'0000000000000010' /,
     5     MASK0( 6) / x'0000000000000020' /,
     6     MASK0( 7) / x'0000000000000040' /,
     7     MASK0( 8) / x'0000000000000080' /,
     8     MASK0( 9) / x'0000000000000100' /,
     9     MASK0(10) / x'0000000000000200' /,
     +     MASK0(11) / x'0000000000000400' /,
     1     MASK0(12) / x'0000000000000800' /,
     2     MASK0(13) / x'0000000000001000' /,
     3     MASK0(14) / x'0000000000002000' /,
     4     MASK0(15) / x'0000000000004000' /,
     5     MASK0(16) / x'0000000000008000' /
      DATA MASK0(17) / x'0000000000010000' /,
     1     MASK0(18) / x'0000000000020000' /,
     2     MASK0(19) / x'0000000000040000' /,
     3     MASK0(20) / x'0000000000080000' /,
     4     MASK0(21) / x'0000000000100000' /,
     5     MASK0(22) / x'0000000000200000' /,
     6     MASK0(23) / x'0000000000400000' /,
     7     MASK0(24) / x'0000000000800000' /,
     8     MASK0(25) / x'0000000001000000' /,
     9     MASK0(26) / x'0000000002000000' /,
     +     MASK0(27) / x'0000000004000000' /,
     1     MASK0(28) / x'0000000008000000' /,
     2     MASK0(29) / x'0000000010000000' /,
     3     MASK0(30) / x'0000000020000000' /,
     4     MASK0(31) / x'0000000040000000' /
      DATA MASK0(32) / x'0000000080000000' /,
     +     MASK0(33) / x'0000000100000000' /,
     1     MASK0(34) / x'0000000200000000' /,
     2     MASK0(35) / x'0000000400000000' /,
     3     MASK0(36) / x'0000000800000000' /,
     4     MASK0(37) / x'0000001000000000' /,
     5     MASK0(38) / x'0000002000000000' /,
     6     MASK0(39) / x'0000004000000000' /,
     7     MASK0(40) / x'0000008000000000' /,
     8     MASK0(41) / x'0000010000000000' /,
     9     MASK0(42) / x'0000020000000000' /,
     +     MASK0(43) / x'0000040000000000' /,
     1     MASK0(44) / x'0000080000000000' /,
     2     MASK0(45) / x'0000100000000000' /,
     3     MASK0(46) / x'0000200000000000' /,
     4     MASK0(47) / x'0000400000000000' /,
     5     MASK0(48) / x'0000800000000000' /
      DATA MASK0(49) / x'0001000000000000' /,
     1     MASK0(50) / x'0002000000000000' /,
     2     MASK0(51) / x'0004000000000000' /,
     3     MASK0(52) / x'0008000000000000' /,
     4     MASK0(53) / x'0010000000000000' /,
     5     MASK0(54) / x'0020000000000000' /,
     6     MASK0(55) / x'0040000000000000' /,
     7     MASK0(56) / x'0080000000000000' /,
     8     MASK0(57) / x'0100000000000000' /,
     9     MASK0(58) / x'0200000000000000' /,
     +     MASK0(59) / x'0400000000000000' /,
     1     MASK0(60) / x'0800000000000000' /,
     2     MASK0(61) / x'1000000000000000' /,
     3     MASK0(62) / x'2000000000000000' /,
     4     MASK0(63) / x'4000000000000000' /,
     5     MASK0(64) / x'8000000000000000' /

C
C
C 5.  MSK0DM.  MSK0DM is an integer variable containing the
C     dimension of MASK0.  It must be at least WRDLNG.  The
C     dimension statement for MASK0 is at the beginning of the main
C     program.  You may leave it unchanged, or if you are cramped
C     for space, lower it to WRDLNG.
C
C

      DATA MSK0DM /64/

C
C 6.  MASK1.  MASK1 is an integer array of WRDLNG+1 elements.
C     Element I has the lower I-1 bits set, the other bits are
C     zero, hence, MASK1(1) = 0, MASK1(2) =1,
C                  MASK1(3) = 3, ..., MASK1(WRDLNG+1) is all ones.
C     In terms of integers MASK1(I) = (2**(I-1))-1 .
C     The test program comes with 65 data statements initializing
C     MASK1.  However on most computers overflow will cause some of
C     these to be invalid.  Begin by removing the last 64-WRDLNG
C     data statements.  You should have WRDLNG+1 remaining data
C     statements.  Change the last few of these to eliminate
C     overflow and generate the values as defined above.  You may
C     want to use octal or hex constants.  It is crucial that
C     MASK1 be initialized properly, even though the test program
C     cannot check for this.
C     WARNING.  On one's complement machines, MASK1(WRDLNG+1) = -0.
C
C
C
      DATA MASK1( 1) / x'0000000000000000' /,
     1     MASK1( 2) / x'0000000000000001' /,
     2     MASK1( 3) / x'0000000000000003' /,
     3     MASK1( 4) / x'0000000000000007' /,
     4     MASK1( 5) / x'000000000000000f' /,
     5     MASK1( 6) / x'000000000000001f' /,
     6     MASK1( 7) / x'000000000000003f' /,
     7     MASK1( 8) / x'000000000000007f' /,
     8     MASK1( 9) / x'00000000000000ff' /,
     9     MASK1(10) / x'00000000000001ff' /,
     +     MASK1(11) / x'00000000000003ff' /,
     1     MASK1(12) / x'00000000000007ff' /,
     2     MASK1(13) / x'0000000000000fff' /,
     3     MASK1(14) / x'0000000000001fff' /,
     4     MASK1(15) / x'0000000000003fff' /,
     5     MASK1(16) / x'0000000000007fff' /
      DATA MASK1(17) / x'000000000000ffff' /,
     1     MASK1(18) / x'000000000001ffff' /,
     2     MASK1(19) / x'000000000003ffff' /,
     3     MASK1(20) / x'000000000007ffff' /,
     4     MASK1(21) / x'00000000000fffff' /,
     5     MASK1(22) / x'00000000001fffff' /,
     6     MASK1(23) / x'00000000003fffff' /,
     7     MASK1(24) / x'00000000007fffff' /,
     8     MASK1(25) / x'0000000000ffffff' /,
     9     MASK1(26) / x'0000000001ffffff' /,
     +     MASK1(27) / x'0000000003ffffff' /,
     1     MASK1(28) / x'0000000007ffffff' /,
     2     MASK1(29) / x'000000000fffffff' /,
     3     MASK1(30) / x'000000001fffffff' /,
     4     MASK1(31) / x'000000003fffffff' /
      DATA MASK1(32) / x'000000007fffffff' /,
     +     MASK1(33) / x'00000000ffffffff' /,
     1     MASK1(34) / x'00000001ffffffff' /,
     2     MASK1(35) / x'00000003ffffffff' /,
     3     MASK1(36) / x'00000007ffffffff' /,
     4     MASK1(37) / x'0000000fffffffff' /,
     5     MASK1(38) / x'0000001fffffffff' /,
     6     MASK1(39) / x'0000003fffffffff' /,
     7     MASK1(40) / x'0000007fffffffff' /,
     8     MASK1(41) / x'000000ffffffffff' /,
     9     MASK1(42) / x'000001ffffffffff' /,
     +     MASK1(43) / x'000003ffffffffff' /,
     1     MASK1(44) / x'000007ffffffffff' /,
     2     MASK1(45) / x'00000fffffffffff' /,
     3     MASK1(46) / x'00001fffffffffff' /,
     4     MASK1(47) / x'00003fffffffffff' /,
     5     MASK1(48) / x'00007fffffffffff' /
      DATA MASK1(49) / x'0000ffffffffffff' /,
     1     MASK1(50) / x'0001ffffffffffff' /,
     2     MASK1(51) / x'0003ffffffffffff' /,
     3     MASK1(52) / x'0007ffffffffffff' /,
     4     MASK1(53) / x'000fffffffffffff' /,
     5     MASK1(54) / x'001fffffffffffff' /,
     6     MASK1(55) / x'003fffffffffffff' /,
     7     MASK1(56) / x'007fffffffffffff' /,
     8     MASK1(57) / x'00ffffffffffffff' /,
     9     MASK1(58) / x'01ffffffffffffff' /,
     +     MASK1(59) / x'03ffffffffffffff' /,
     1     MASK1(60) / x'07ffffffffffffff' /,
     2     MASK1(61) / x'0fffffffffffffff' /,
     3     MASK1(62) / x'1fffffffffffffff' /,
     4     MASK1(63) / x'3fffffffffffffff' /,
     5     MASK1(64) / x'7fffffffffffffff' /
      DATA MASK1(65) / x'ffffffffffffffff' /
	

C
C 7.  MSK1DM.  MSK1DM is an integer variable containing the
C     dimension of MASK1.  It must be at least WRDLNG+1.  The
C     dimension statement for MASK1 is at the beginning of the main
C     program.  You may leave it unchanged, or if you are cramped
C     for space, lower it to WRDLNG+1.
C

      DATA MSK1DM /65/

C
C
C     ISCRDM.  ISCRDM is an integer variable containing the
C     dimension of ISCR.  You may ignore this step unless you are
C     cramped for space.  ISCR is an array used for scratch.  Its
C     length depends on the word length of your machine.  The test
C     package comes with ISCR dimensioned to 190 .  This is large
C     enough for all word sizes of 1-64 bits, but if you want to
C     lower it, the following formula gives the minimum required.
C     Let LCM stand for the least common multiple.  Then the
C     dimension of ISCR must be at least
C          2*( LCM(WRDLNG,16)/16 + 2*LCM(WRDLNG,16)/WRDLNG ) .
C
      DATA ISCRDM /190/
C
C
C
C     End of information that you are required to supply.
C
C
C
      DATA BYTLNG /16/
      WRITE (IOUT,112)
      WRITE (IOUT,113)
      WRITE (IOUT,114) WRDLNG,INLNGA,INLNGC,MSK0DM,MSK1DM,ISCRDM
      IER=0
      INTLNG=MIN0(INLNGC,INLNGA)
      IF (WRDLNG.LT.BYTLNG .OR. WRDLNG.GT.64) GOTO 107
  101 WRDLNG=MAX0(WRDLNG,BYTLNG)
  102 IF (INLNGA.LT.BYTLNG .OR. INLNGA.GT.WRDLNG) GO TO 108
      IF (INLNGC.LT.BYTLNG .OR. INLNGC.GT.WRDLNG) GO TO 108
  103 IF (MSK1DM.LE.WRDLNG) GOTO 109
  104 IF (MSK0DM.LT.WRDLNG) GOTO 110
  105 NMBRB=2*LCM(WRDLNG,BYTLNG)/BYTLNG
      LPAKD=NMBRB*BYTLNG/WRDLNG
      NEEDED=NMBRB+2*LPAKD
      IF (ISCRDM.LT.NEEDED) GOTO 111
  106 IF (IER.NE.0) STOP
      WRITE (IOUT,115)
      CALL TIOR(MASK1,MSK1DM,WRDLNG,INTLNG,IOUT,IER)
      IERIOR=IER
      CALL TIAND(MASK1,MSK1DM,WRDLNG,INTLNG,IOUT,IER)
      IERAND=IER
      CALL TSHIFT (MASK0,MSK0DM,MASK1(2),MSK1DM-1,IERAND,WRDLNG,INTLNG,
     1                                                         IOUT,IER)
      IERSHF=IER
      CALL TGBYTE (MASK0,MSK0DM,MASK1,MSK1DM,ISCR,ISCRDM,WRDLNG,INTLNG,
     1                                           IERAND,IERSHF,IOUT,IER)
      IERGBY=IER
      CALL TSBYTE (MASK0,MSK0DM,MASK1,MSK1DM,ISCR,ISCRDM,WRDLNG,INTLNG,
     1                                   IERAND,IERIOR,IERSHF,IOUT,IER)
      IERSBY=IER
      WRITE (IOUT,116) IERIOR,IERAND,IERSHF,IERGBY,IERSBY
      STOP
  107 WRITE (IOUT,117) BYTLNG
      IER=1
      GOTO 101
  108 WRITE (IOUT,118) BYTLNG
      IER=1
      GOTO 103
  109 WRITE (IOUT,119)
      IER=1
      GOTO 104
  110 WRITE (IOUT,120)
      IER=1
       GOTO 105
  111 WRITE (IOUT,121) NEEDED
      IER=1
       GOTO 106
  112 FORMAT ('1TEST PACKAGE EXECUTING.  THIS LINE SHOULD BE PRINTED.')
  113 FORMAT ('0WE WILL FIRST TEST THE INFORMATION YOU HAVE PROVIDED',
     1        ' IN CERTAIN DATA'/
     2        ' STATEMENTS AT THE BEGINNING OF THIS PROGRAM.  IF ANY',
     3        ' ERROR IS FOUND,'/
     4        ' EXECUTION WILL TERMINATE--NO ROUTINES WILL BE TESTED.')
  114 FORMAT ('0YOU HAVE PROVIDED THE FOLLOWING CONSTANTS.'/' '/
     1        6X,'NUMBER OF BITS IN A WORD                ',I21/
     2        6X,'NUMBER OF BITS IN AN INTEGER ASSIGNMENT ',I21/
     3        6X,'NUMBER OF BITS IN AN INTEGER COMPARISON ',I21/
     4        6X,'THE DIMENSION OF THE ARRAY MASK0        ',I21/
     5        6X,'THE DIMENSION OF THE ARRAY MASK1        ',I21/
     6        6X,'THE DIMENSION OF THE ARRAY ISCR         ',I21)
  115 FORMAT ('0THE ABOVE DATA APPEARS TO BE CORRECT.  WE WILL NOW',
     1        ' BEGIN TESTING THE'/
     2        ' SUPPORT ROUTINES YOU HAVE PROVIDED FOR USE WITH THE',
     3        ' PLOT PACKAGE.'/
     4        '0A MESSAGE WILL BE PRINTED BEFORE EACH TEST BEGINS,',
     5        ' WHENEVER AN ERROR IS'/
     6        ' FOUND, AND AT THE SUCCESSFUL CONCLUSION OF A TEST. ',
     7        ' A SUMMARY OF THE'/
     8        ' TEST RESULTS WILL BE PRINTED AT THE END.  NOTE THAT',
     9        ' AN ERROR FOUND IN'/
     +        ' ONE ROUTINE MAY SUSPEND TESTING OF ONE OR MORE',
     1        ' SUBSEQUENT ROUTINES.')
  116 FORMAT ('1FOLLOWING IS A SUMMARY OF THE TEST RESULTS SO FAR. ',
     1        ' THE INTEGER WHICH'/
     2        ' FOLLOWS THE ROUTINE NAME IS A COUNT OF ERRORS FOUND',
     3        ' WHILE TESTING THE'/
     4        ' ROUTINE.  (-1 INDICATES THAT THE ROUTINE WAS NOT',
     5        ' TESTED AT ALL.)'/' '/
     6        10X,'IOR       ',I2/
     7        10X,'IAND      ',I2/
     8        10X,'ISHIFT    ',I2/
     9        10X,'GBYTES    ',I2/
     +        10X,'SBYTES    ',I2/
     1        '0IN ANY CASE, ALL PRECEDING OUTPUT SHOULD BE CAREFULLY',
     2        ' EXAMINED.')
  117 FORMAT ('0ERROR.  THE SYSTEM PLOT PACKAGE NEEDS AT LEAST ',I2,
     1     ' BITS IN A WORD.'/
     2     ' THE TEST PACKAGE IS DESIGNED FOR A 64 BITS/WORD MAXIMUM.')
  118 FORMAT ('0ERROR.  THE NUMBER OF LOW ORDER BITS TAKING PART IN ',
     1     'INTEGER COMPARISONS'/
     2     ' AND ASSIGNMENTS MUST BE .LE. WORD SIZE AND .GE. ',I2,'.')
  119 FORMAT ('0ERROR.  THE NUMBER OF ONES MASKS MUST BE .GT. ',
     1     'THE WORD LENGTH.  KEEP'/
     2     ' IN MIND THAT THE KTH ELEMENT HAS K-1 CONTIGUOUS ONES IN ',
     3     'THE LOW ORDER'/
     4     ' BITS.  HENCE MASK1(1) SHOULD BE ZERO, MASK1(WRDLNG+1) ',
     5     'SHOULD BE ALL'/
     6     ' ONES.')
  120 FORMAT('0ERROR.  THE NUMBER OF ONE-WITH-ZEROES MASKS MUST ',
     1     'BE .GE. THE WORD'/
     2     ' LENGTH.  KEEP IN MIND THAT THE KTH ELEMENT HAS BIT K-1 ',
     3     'SET (COUNTING'/
     4     ' BIT 0 AS THE RIGHTMOST) WITH THE REST ZEROS.  HENCE ',
     5     'MASK0(1) SHOULD BE'/
     6     ' 1, AND MASK0(WRDLNG) SHOULD HAVE A ONE IN THE LEFTMOST ',
     7     'BIT, AND THE'/
     8     ' REST ZEROS.')
  121 FORMAT ('0ERROR.  WITH THE GIVEN WORD SIZE, THE SCRATCH ARRAY ',
     1     'MUST BE AT LEAST'/
     2     1X,I16,' ELEMENTS LONG.')
      END

C NCLFORTSTART
      subroutine polft(n,x,y,w,maxdeg,ndeg,eps,r,ierr
     +                ,work,coef,maxdeg1,lwork,cmsg)
      implicit none
c                                                     ; INPUT
      integer n, maxdeg, maxdeg1, lwork
ccccc double precision x(n), y(n),w(n),work(3*n+3*maxdeg+3),eps
      double precision x(n), y(n),w(n),work(lwork),eps,cmsg
c                                                     ; OUTPUT
      integer ndeg, ierr
      double precision r(n), coef(maxdeg1) 
C NCLEND
C                                                     ; LOCAL
      integer i
      double precision c0

      c0 = 0.0
      if (n.gt.maxdeg) then
          call dpolft (n, x,y, w, maxdeg, ndeg, eps, r, ierr
     *                ,work,lwork)
          call dpcoef (maxdeg, c0, coef, work, lwork, maxdeg1)
      else
          do i=1,maxdeg1
             coef(i) = cmsg
          end do
      end if

      return
      end

C NCLFORTSTART
      subroutine polftmsg(n,x,y,w,xmsg,ymsg,maxdeg,ndeg,eps,r,ierr
     +                    ,work,coef,maxdeg1,lwork,cmsg,xx,yy,ww)
      implicit none
c                                                     ; INPUT
      integer n, maxdeg, maxdeg1, lwork
ccccc double precision x(n), y(n),w(n),work(3*n+3*maxdeg+3),eps
      double precision x(n), y(n),w(n),work(lwork),eps
      double precision xmsg,ymsg,cmsg
c                                                     ; temp work
      double precision xx(n), yy(n), ww(n)
c                                                     ; OUTPUT
      integer ndeg, ierr
      double precision r(n), coef(maxdeg1) 
C NCLEND
C                                                     ; LOCAL
      integer i, nn
      double precision c0

c xx, yy, ww will hold non-missing values

      nn = 0
      do i=1,n
         if (x(i).ne.xmsg .and. y(i).ne.ymsg) then
             nn = nn+1
             xx(nn) = x(i)
             yy(nn) = y(i)
             ww(nn) = w(i)
         end if
      end do
 
      c0 = 0.0
      if (nn.gt.maxdeg) then
          call dpolft (nn, xx, yy, ww, maxdeg, ndeg, eps, r, ierr
     *                ,work,lwork)
          call dpcoef (maxdeg, c0, coef, work, lwork, maxdeg1)
      else
          do i=1,maxdeg1
             coef(i) = cmsg
          end do
      end if

      return
      end
c ---------------------- SLATEC ----------------------------------
      SUBROUTINE DPOLFT (N, X, Y, W, MAXDEG, NDEG, EPS, R, IERR, A, LA)
cDJS  SUBROUTINE DPOLFT (N, X, Y, W, MAXDEG, NDEG, EPS, R, IERR, A)
C***BEGIN PROLOGUE  DPOLFT
C***PURPOSE  Fit discrete data in a least squares sense by polynomials
C            in one variable.
C***LIBRARY   SLATEC
C***CATEGORY  K1A1A2
C***TYPE      DOUBLE PRECISION (POLFIT-S, DPOLFT-D)
C***KEYWORDS  CURVE FITTING, DATA FITTING, LEAST SQUARES, POLYNOMIAL FIT
C***AUTHOR  Shampine, L. F., (SNLA)
C           Davenport, S. M., (SNLA)
C           Huddleston, R. E., (SNLL)
C***DESCRIPTION
C
C     Abstract
C
C     Given a collection of points X(I) and a set of values Y(I) which
C     correspond to some function or measurement at each of the X(I),
C     subroutine  DPOLFT  computes the weighted least-squares polynomial
C     fits of all degrees up to some degree either specified by the user
C     or determined by the routine.  The fits thus obtained are in
C     orthogonal polynomial form.  Subroutine  DP1VLU  may then be
C     called to evaluate the fitted polynomials and any of their
C     derivatives at any point.  The subroutine  DPCOEF  may be used to
C     express the polynomial fits as powers of (X-C) for any specified
C     point C.
C
C     The parameters for  DPOLFT  are
C
C     Input -- All TYPE REAL variables are DOUBLE PRECISION
C         N -      the number of data points.  The arrays X, Y and W
C                  must be dimensioned at least  N  (N .GE. 1).
C         X -      array of values of the independent variable.  These
C                  values may appear in any order and need not all be
C                  distinct.
C         Y -      array of corresponding function values.
C         W -      array of positive values to be used as weights.  If
C                  W(1) is negative,  DPOLFT  will set all the weights
C                  to 1.0, which means unweighted least squares error
C                  will be minimized.  To minimize relative error, the
C                  user should set the weights to:  W(I) = 1.0/Y(I)**2,
C                  I = 1,...,N .
C         MAXDEG - maximum degree to be allowed for polynomial fit.
C                  MAXDEG  may be any non-negative integer less than  N.
C                  Note -- MAXDEG  cannot be equal to  N-1  when a
C                  statistical test is to be used for degree selection,
C                  i.e., when input value of  EPS  is negative.
C         EPS -    specifies the criterion to be used in determining
C                  the degree of fit to be computed.
C                  (1)  If  EPS  is input negative,  DPOLFT  chooses the
C                       degree based on a statistical F test of
C                       significance.  One of three possible
C                       significance levels will be used:  .01, .05 or
C                       .10.  If  EPS=-1.0 , the routine will
C                       automatically select one of these levels based
C                       on the number of data points and the maximum
C                       degree to be considered.  If  EPS  is input as
C                       -.01, -.05, or -.10, a significance level of
C                       .01, .05, or .10, respectively, will be used.
C                  (2)  If  EPS  is set to 0.,  DPOLFT  computes the
C                       polynomials of degrees 0 through  MAXDEG .
C                  (3)  If  EPS  is input positive,  EPS  is the RMS
C                       error tolerance which must be satisfied by the
C                       fitted polynomial.  DPOLFT  will increase the
C                       degree of fit until this criterion is met or
C                       until the maximum degree is reached.
C
C     Output -- All TYPE REAL variables are DOUBLE PRECISION
C         NDEG -   degree of the highest degree fit computed.
C         EPS -    RMS error of the polynomial of degree  NDEG .
C         R -      vector of dimension at least NDEG containing values
C                  of the fit of degree  NDEG  at each of the  X(I) .
C                  Except when the statistical test is used, these
C                  values are more accurate than results from subroutine
C                  DP1VLU  normally are.
C         IERR -   error flag with the following possible values.
C             1 -- indicates normal execution, i.e., either
C                  (1)  the input value of  EPS  was negative, and the
C                       computed polynomial fit of degree  NDEG
C                       satisfies the specified F test, or
C                  (2)  the input value of  EPS  was 0., and the fits of
C                       all degrees up to  MAXDEG  are complete, or
C                  (3)  the input value of  EPS  was positive, and the
C                       polynomial of degree  NDEG  satisfies the RMS
C                       error requirement.
C             2 -- invalid input parameter.  At least one of the input
C                  parameters has an illegal value and must be corrected
C                  before  DPOLFT  can proceed.  Valid input results
C                  when the following restrictions are observed
C                       N .GE. 1
C                       0 .LE. MAXDEG .LE. N-1  for  EPS .GE. 0.
C                       0 .LE. MAXDEG .LE. N-2  for  EPS .LT. 0.
C                       W(1)=-1.0  or  W(I) .GT. 0., I=1,...,N .
C             3 -- cannot satisfy the RMS error requirement with a
C                  polynomial of degree no greater than  MAXDEG .  Best
C                  fit found is of degree  MAXDEG .
C             4 -- cannot satisfy the test for significance using
C                  current value of  MAXDEG .  Statistically, the
C                  best fit found is of order  NORD .  (In this case,
C                  NDEG will have one of the values:  MAXDEG-2,
C                  MAXDEG-1, or MAXDEG).  Using a higher value of
C                  MAXDEG  may result in passing the test.
C         A -      work and output array having at least 3N+3MAXDEG+3
C                  locations
C
C     Note - DPOLFT  calculates all fits of degrees up to and including
C            NDEG .  Any or all of these fits can be evaluated or
C            expressed as powers of (X-C) using  DP1VLU  and  DPCOEF
C            after just one call to  DPOLFT .
C
C***REFERENCES  L. F. Shampine, S. M. Davenport and R. E. Huddleston,
C                 Curve fitting by polynomials in one variable, Report
C                 SLA-74-0270, Sandia Laboratories, June 1974.
C***ROUTINES CALLED  DP1VLU, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   740601  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   891006  Cosmetic changes to prologue.  (WRB)
C   891006  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C   900911  Added variable YP to DOUBLE PRECISION declaration.  (WRB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C   920527  Corrected erroneous statements in DESCRIPTION.  (WRB)
C***END PROLOGUE  DPOLFT
      INTEGER I,IDEGF,IERR,J,JP1,JPAS,K1,K1PJ,K2,K2PJ,K3,K3PI,K4,
     * K4PI,K5,K5PI,KSIG,M,MAXDEG,MOP1,NDEG,NDER,NFAIL
      INTEGER LA
      DOUBLE PRECISION TEMD1,TEMD2
      DOUBLE PRECISION A(LA),DEGF,DEN,EPS,ETST,F,FCRIT,R(N),SIG,SIGJ,
     * SIGJM1,SIGPAS,TEMP,X(N),XM,Y(N),YP(1),W(N),W1,W11
cDJS  DOUBLE PRECISION A(*),DEGF,DEN,EPS,ETST,F,FCRIT,R(*),SIG,SIGJ,
cDJS * SIGJM1,SIGPAS,TEMP,X(*),XM,Y(*),YP,W(*),W1,W11
      DOUBLE PRECISION CO(4,3)
      SAVE CO
      DATA  CO(1,1), CO(2,1), CO(3,1), CO(4,1), CO(1,2), CO(2,2),
     1      CO(3,2), CO(4,2), CO(1,3), CO(2,3), CO(3,3),
     2  CO(4,3)/-13.086850D0,-2.4648165D0,-3.3846535D0,-1.2973162D0,
     3          -3.3381146D0,-1.7812271D0,-3.2578406D0,-1.6589279D0,
     4          -1.6282703D0,-1.3152745D0,-3.2640179D0,-1.9829776D0/
C***FIRST EXECUTABLE STATEMENT  DPOLFT
      M = ABS(N)
      IF (M .EQ. 0) GO TO 30
      IF (MAXDEG .LT. 0) GO TO 30
      A(1) = MAXDEG
      MOP1 = MAXDEG + 1
      IF (M .LT. MOP1) GO TO 30
      IF (EPS .LT. 0.0D0 .AND.  M .EQ. MOP1) GO TO 30
      XM = M
      ETST = EPS*EPS*XM
      IF (W(1) .LT. 0.0D0) GO TO 2
      DO 1 I = 1,M
        IF (W(I) .LE. 0.0D0) GO TO 30
 1      CONTINUE
      GO TO 4
 2    DO 3 I = 1,M
 3      W(I) = 1.0D0
 4    IF (EPS .GE. 0.0D0) GO TO 8
C
C DETERMINE SIGNIFICANCE LEVEL INDEX TO BE USED IN STATISTICAL TEST FOR
C CHOOSING DEGREE OF POLYNOMIAL FIT
C
      IF (EPS .GT. (-.55D0)) GO TO 5
      IDEGF = M - MAXDEG - 1
      KSIG = 1
      IF (IDEGF .LT. 10) KSIG = 2
      IF (IDEGF .LT. 5) KSIG = 3
      GO TO 8
 5    KSIG = 1
      IF (EPS .LT. (-.03D0)) KSIG = 2
      IF (EPS .LT. (-.07D0)) KSIG = 3
C
C INITIALIZE INDEXES AND COEFFICIENTS FOR FITTING
C
 8    K1 = MAXDEG + 1
      K2 = K1 + MAXDEG
      K3 = K2 + MAXDEG + 2
      K4 = K3 + M
      K5 = K4 + M
      DO 9 I = 2,K4
 9      A(I) = 0.0D0
      W11 = 0.0D0
      IF (N .LT. 0) GO TO 11
C
C UNCONSTRAINED CASE
C
      DO 10 I = 1,M
        K4PI = K4 + I
        A(K4PI) = 1.0D0
 10     W11 = W11 + W(I)
      GO TO 13
C
C CONSTRAINED CASE
C
 11   DO 12 I = 1,M
        K4PI = K4 + I
 12     W11 = W11 + W(I)*A(K4PI)**2
C
C COMPUTE FIT OF DEGREE ZERO
C
 13   TEMD1 = 0.0D0
      DO 14 I = 1,M
        K4PI = K4 + I
        TEMD1 = TEMD1 + W(I)*Y(I)*A(K4PI)
 14     CONTINUE
      TEMD1 = TEMD1/W11
      A(K2+1) = TEMD1
      SIGJ = 0.0D0
      DO 15 I = 1,M
        K4PI = K4 + I
        K5PI = K5 + I
        TEMD2 = TEMD1*A(K4PI)
        R(I) = TEMD2
        A(K5PI) = TEMD2 - R(I)
 15     SIGJ = SIGJ + W(I)*((Y(I)-R(I)) - A(K5PI))**2
      J = 0
C
C SEE IF POLYNOMIAL OF DEGREE 0 SATISFIES THE DEGREE SELECTION CRITERION
C
      IF (EPS) 24,26,27
C
C INCREMENT DEGREE
C
 16   J = J + 1
      JP1 = J + 1
      K1PJ = K1 + J
      K2PJ = K2 + J
      SIGJM1 = SIGJ
C
C COMPUTE NEW B COEFFICIENT EXCEPT WHEN J = 1
C
      IF (J .GT. 1) A(K1PJ) = W11/W1
C
C COMPUTE NEW A COEFFICIENT
C
      TEMD1 = 0.0D0
      DO 18 I = 1,M
        K4PI = K4 + I
        TEMD2 = A(K4PI)
        TEMD1 = TEMD1 + X(I)*W(I)*TEMD2*TEMD2
 18     CONTINUE
      A(JP1) = TEMD1/W11
C
C EVALUATE ORTHOGONAL POLYNOMIAL AT DATA POINTS
C
      W1 = W11
      W11 = 0.0D0
      DO 19 I = 1,M
        K3PI = K3 + I
        K4PI = K4 + I
        TEMP = A(K3PI)
        A(K3PI) = A(K4PI)
        A(K4PI) = (X(I)-A(JP1))*A(K3PI) - A(K1PJ)*TEMP
 19     W11 = W11 + W(I)*A(K4PI)**2
C
C GET NEW ORTHOGONAL POLYNOMIAL COEFFICIENT USING PARTIAL DOUBLE
C PRECISION
C
      TEMD1 = 0.0D0
      DO 20 I = 1,M
        K4PI = K4 + I
        K5PI = K5 + I
        TEMD2 = W(I)*((Y(I)-R(I))-A(K5PI))*A(K4PI)
 20     TEMD1 = TEMD1 + TEMD2
      TEMD1 = TEMD1/W11
      A(K2PJ+1) = TEMD1
C
C UPDATE POLYNOMIAL EVALUATIONS AT EACH OF THE DATA POINTS, AND
C ACCUMULATE SUM OF SQUARES OF ERRORS.  THE POLYNOMIAL EVALUATIONS ARE
C COMPUTED AND STORED IN EXTENDED PRECISION.  FOR THE I-TH DATA POINT,
C THE MOST SIGNIFICANT BITS ARE STORED IN  R(I) , AND THE LEAST
C SIGNIFICANT BITS ARE IN  A(K5PI) .
C
      SIGJ = 0.0D0
      DO 21 I = 1,M
        K4PI = K4 + I
        K5PI = K5 + I
        TEMD2 = R(I) + A(K5PI) + TEMD1*A(K4PI)
        R(I) = TEMD2
        A(K5PI) = TEMD2 - R(I)
 21     SIGJ = SIGJ + W(I)*((Y(I)-R(I)) - A(K5PI))**2
C
C SEE IF DEGREE SELECTION CRITERION HAS BEEN SATISFIED OR IF DEGREE
C MAXDEG  HAS BEEN REACHED
C
      IF (EPS) 23,26,27
C
C COMPUTE F STATISTICS  (INPUT EPS .LT. 0.)
C
 23   IF (SIGJ .EQ. 0.0D0) GO TO 29
      DEGF = M - J - 1
      DEN = (CO(4,KSIG)*DEGF + 1.0D0)*DEGF
      FCRIT = (((CO(3,KSIG)*DEGF) + CO(2,KSIG))*DEGF + CO(1,KSIG))/DEN
      FCRIT = FCRIT*FCRIT
      F = (SIGJM1 - SIGJ)*DEGF/SIGJ
      IF (F .LT. FCRIT) GO TO 25
C
C POLYNOMIAL OF DEGREE J SATISFIES F TEST
C
 24   SIGPAS = SIGJ
      JPAS = J
      NFAIL = 0
      IF (MAXDEG .EQ. J) GO TO 32
      GO TO 16
C
C POLYNOMIAL OF DEGREE J FAILS F TEST.  IF THERE HAVE BEEN THREE
C SUCCESSIVE FAILURES, A STATISTICALLY BEST DEGREE HAS BEEN FOUND.
C
 25   NFAIL = NFAIL + 1
      IF (NFAIL .GE. 3) GO TO 29
      IF (MAXDEG .EQ. J) GO TO 32
      GO TO 16
C
C RAISE THE DEGREE IF DEGREE  MAXDEG  HAS NOT YET BEEN REACHED  (INPUT
C EPS = 0.)
C
 26   IF (MAXDEG .EQ. J) GO TO 28
      GO TO 16
C
C SEE IF RMS ERROR CRITERION IS SATISFIED  (INPUT EPS .GT. 0.)
C
 27   IF (SIGJ .LE. ETST) GO TO 28
      IF (MAXDEG .EQ. J) GO TO 31
      GO TO 16
C
C RETURNS
C
 28   IERR = 1
      NDEG = J
      SIG = SIGJ
      GO TO 33
 29   IERR = 1
      NDEG = JPAS
      SIG = SIGPAS
      GO TO 33
 30   IERR = 2
c c c CALL XERMSG ('SLATEC', 'DPOLFT', 'INVALID INPUT PARAMETER.', 2,
c c c+   1)
      GO TO 37
 31   IERR = 3
      NDEG = MAXDEG
      SIG = SIGJ
      GO TO 33
 32   IERR = 4
      NDEG = JPAS
      SIG = SIGPAS
C
 33   A(K3) = NDEG
C
C WHEN STATISTICAL TEST HAS BEEN USED, EVALUATE THE BEST POLYNOMIAL AT
C ALL THE DATA POINTS IF  R  DOES NOT ALREADY CONTAIN THESE VALUES
C
      IF(EPS .GE. 0.0  .OR.  NDEG .EQ. MAXDEG) GO TO 36
      NDER = 0
      DO 35 I = 1,M
        CALL DP1VLU (NDEG,NDER,X(I),R(I),YP,A)
 35     CONTINUE
 36   EPS = SQRT(SIG/XM)
 37   RETURN
      END
c--------------------------------------------------------------
      SUBROUTINE DP1VLU (L, NDER, X, YFIT, YP, A)
C***BEGIN PROLOGUE  DP1VLU
C***PURPOSE  Use the coefficients generated by DPOLFT to evaluate the
C            polynomial fit of degree L, along with the first NDER of
C            its derivatives, at a specified point.
C***LIBRARY   SLATEC
C***CATEGORY  K6
C***TYPE      DOUBLE PRECISION (PVALUE-S, DP1VLU-D)
C***KEYWORDS  CURVE FITTING, LEAST SQUARES, POLYNOMIAL APPROXIMATION
C***AUTHOR  Shampine, L. F., (SNLA)
C           Davenport, S. M., (SNLA)
C***DESCRIPTION
C
C     Abstract
C
C     The subroutine  DP1VLU  uses the coefficients generated by  DPOLFT
C     to evaluate the polynomial fit of degree  L , along with the first
C     NDER  of its derivatives, at a specified point.  Computationally
C     stable recurrence relations are used to perform this task.
C
C     The parameters for  DP1VLU  are
C
C     Input -- ALL TYPE REAL variables are DOUBLE PRECISION
C         L -      the degree of polynomial to be evaluated.  L  may be
C                  any non-negative integer which is less than or equal
C                  to  NDEG , the highest degree polynomial provided
C                  by  DPOLFT .
C         NDER -   the number of derivatives to be evaluated.  NDER
C                  may be 0 or any positive value.  If NDER is less
C                  than 0, it will be treated as 0.
C         X -      the argument at which the polynomial and its
C                  derivatives are to be evaluated.
C         A -      work and output array containing values from last
C                  call to  DPOLFT .
C
C     Output -- ALL TYPE REAL variables are DOUBLE PRECISION
C         YFIT -   value of the fitting polynomial of degree  L  at  X
C         YP -     array containing the first through  NDER  derivatives
C                  of the polynomial of degree  L .  YP  must be
C                  dimensioned at least  NDER  in the calling program.
C
C***REFERENCES  L. F. Shampine, S. M. Davenport and R. E. Huddleston,
C                 Curve fitting by polynomials in one variable, Report
C                 SLA-74-0270, Sandia Laboratories, June 1974.
C***ROUTINES CALLED  XERMSG
C***REVISION HISTORY  (YYMMDD)
C   740601  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890911  Removed unnecessary intrinsics.  (WRB)
C   891006  Cosmetic changes to prologue.  (WRB)
C   891006  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C   900510  Convert XERRWV calls to XERMSG calls.  (RWC)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  DP1VLU
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INTEGER I,IC,ILO,IN,INP1,IUP,K1,K1I,K2,K3,K3P1,K3PN,K4,K4P1,K4PN,
     * KC,L,LM1,LP1,MAXORD,N,NDER,NDO,NDP1,NORD
cDJS  DOUBLE PRECISION A(*),CC,DIF,VAL,X,YFIT,YP(*)
      DOUBLE PRECISION A(*),CC,DIF,VAL,X,YFIT,YP(1)
      CHARACTER*8 XERN1, XERN2
C***FIRST EXECUTABLE STATEMENT  DP1VLU
      IF (L .LT. 0) GO TO 12
      NDO = MAX(NDER,0)
      NDO = MIN(NDO,L)
      MAXORD = A(1) + 0.5D0
      K1 = MAXORD + 1
      K2 = K1 + MAXORD
      K3 = K2 + MAXORD + 2
      NORD = A(K3) + 0.5D0
      IF (L .GT. NORD) GO TO 11
      K4 = K3 + L + 1
      IF (NDER .LT. 1) GO TO 2
      DO 1 I = 1,NDER
 1      YP(I) = 0.0D0
 2    IF (L .GE. 2) GO TO 4
      IF (L .EQ. 1) GO TO 3
C
C L IS 0
C
      VAL = A(K2+1)
      GO TO 10
C
C L IS 1
C
 3    CC = A(K2+2)
      VAL = A(K2+1) + (X-A(2))*CC
      IF (NDER .GE. 1) YP(1) = CC
      GO TO 10
C
C L IS GREATER THAN 1
C
 4    NDP1 = NDO + 1
      K3P1 = K3 + 1
      K4P1 = K4 + 1
      LP1 = L + 1
      LM1 = L - 1
      ILO = K3 + 3
      IUP = K4 + NDP1
      DO 5 I = ILO,IUP
 5      A(I) = 0.0D0
      DIF = X - A(LP1)
      KC = K2 + LP1
      A(K4P1) = A(KC)
      A(K3P1) = A(KC-1) + DIF*A(K4P1)
      A(K3+2) = A(K4P1)
C
C EVALUATE RECURRENCE RELATIONS FOR FUNCTION VALUE AND DERIVATIVES
C
      DO 9 I = 1,LM1
        IN = L - I
        INP1 = IN + 1
        K1I = K1 + INP1
        IC = K2 + IN
        DIF = X - A(INP1)
        VAL = A(IC) + DIF*A(K3P1) - A(K1I)*A(K4P1)
        IF (NDO .LE. 0) GO TO 8
        DO 6 N = 1,NDO
          K3PN = K3P1 + N
          K4PN = K4P1 + N
 6        YP(N) = DIF*A(K3PN) + N*A(K3PN-1) - A(K1I)*A(K4PN)
C
C SAVE VALUES NEEDED FOR NEXT EVALUATION OF RECURRENCE RELATIONS
C
        DO 7 N = 1,NDO
          K3PN = K3P1 + N
          K4PN = K4P1 + N
          A(K4PN) = A(K3PN)
 7        A(K3PN) = YP(N)
 8      A(K4P1) = A(K3P1)
 9      A(K3P1) = VAL
C
C NORMAL RETURN OR ABORT DUE TO ERROR
C
 10   YFIT = VAL
      RETURN
C
   11 WRITE (XERN1, '(I8)') L
      WRITE (XERN2, '(I8)') NORD
ccccc CALL XERMSG ('SLATEC', 'DP1VLU',
ccccc*   'THE ORDER OF POLYNOMIAL EVALUATION, L = ' // XERN1 //
ccccc*   ' REQUESTED EXCEEDS THE HIGHEST ORDER FIT, NORD = ' // XERN2 //
ccccc*   ', COMPUTED BY DPOLFT -- EXECUTION TERMINATED.', 8, 2)
      RETURN
C
   12 continue
cc 12 CALL XERMSG ('SLATEC', 'DP1VLU',
cc   +   'INVALID INPUT PARAMETER.  ORDER OF POLYNOMIAL EVALUATION ' //
cc   +   'REQUESTED IS NEGATIVE.', 2, 2)
      RETURN
      END
C--------------------------------------------------------------------------
cDJS  SUBROUTINE DPCOEF (L, C, TC, A)
      SUBROUTINE DPCOEF (L, C, TC, A, LA, LTC)
C***BEGIN PROLOGUE  DPCOEF
C***PURPOSE  Convert the DPOLFT coefficients to Taylor series form.
C***LIBRARY   SLATEC
C***CATEGORY  K1A1A2
C***TYPE      DOUBLE PRECISION (PCOEF-S, DPCOEF-D)
C***KEYWORDS  CURVE FITTING, DATA FITTING, LEAST SQUARES, POLYNOMIAL FIT
C***AUTHOR  Shampine, L. F., (SNLA)
C           Davenport, S. M., (SNLA)
C***DESCRIPTION
C
C     Abstract
C
C     DPOLFT  computes the least squares polynomial fit of degree  L  as
C     a sum of orthogonal polynomials.  DPCOEF  changes this fit to its
C     Taylor expansion about any point  C , i.e. writes the polynomial
C     as a sum of powers of (X-C).  Taking  C=0.  gives the polynomial
C     in powers of X, but a suitable non-zero  C  often leads to
C     polynomials which are better scaled and more accurately evaluated.
C
C     The parameters for  DPCOEF  are
C
C     INPUT -- All TYPE REAL variables are DOUBLE PRECISION
C         L -      Indicates the degree of polynomial to be changed to
C                  its Taylor expansion.  To obtain the Taylor
C                  coefficients in reverse order, input  L  as the
C                  negative of the degree desired.  The absolute value
C                  of L  must be less than or equal to NDEG, the highest
C                  degree polynomial fitted by  DPOLFT .
C         C -      The point about which the Taylor expansion is to be
C                  made.
C         A -      Work and output array containing values from last
C                  call to  DPOLFT .
C
C     OUTPUT -- All TYPE REAL variables are DOUBLE PRECISION
C         TC -     Vector containing the first LL+1 Taylor coefficients
C                  where LL=ABS(L).  If  L.GT.0 , the coefficients are
C                  in the usual Taylor series order, i.e.
C                    P(X) = TC(1) + TC(2)*(X-C) + ... + TC(N+1)*(X-C)**N
C                  If L .LT. 0, the coefficients are in reverse order,
C                  i.e.
C                    P(X) = TC(1)*(X-C)**N + ... + TC(N)*(X-C) + TC(N+1)
C
C***REFERENCES  L. F. Shampine, S. M. Davenport and R. E. Huddleston,
C                 Curve fitting by polynomials in one variable, Report
C                 SLA-74-0270, Sandia Laboratories, June 1974.
C***ROUTINES CALLED  DP1VLU
C***REVISION HISTORY  (YYMMDD)
C   740601  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   891006  Cosmetic changes to prologue.  (WRB)
C   891006  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  DPCOEF
C
      INTEGER I,L,LL,LLP1,LLP2,NEW,NR
cDJS  DOUBLE PRECISION A(*),C,FAC,SAVE,TC(*)
      DOUBLE PRECISION A(LA),C,FAC,SAVE,TC(LTC)

C***FIRST EXECUTABLE STATEMENT  DPCOEF
      LL = ABS(L)
      LLP1 = LL + 1
      CALL DP1VLU (LL,LL,C,TC(1),TC(2),A)
      IF (LL .LT. 2) GO TO 2
      FAC = 1.0D0
      DO 1 I = 3,LLP1
        FAC = FAC*(I-1)
 1      TC(I) = TC(I)/FAC
 2    IF (L .GE. 0) GO TO 4
      NR = LLP1/2
      LLP2 = LL + 2
      DO 3 I = 1,NR
        SAVE = TC(I)
        NEW = LLP2 - I
        TC(I) = TC(NEW)
 3      TC(NEW) = SAVE
 4    RETURN
      END

C
C	$Id: mskout.f,v 1.4 2008-07-27 00:59:03 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MSKOUT(CHARCN,NUM0F,NUM1,NUM0L,IOUT)
      CHARACTER*1 BLANK,ONE,ZERO
      CHARACTER*1 CHARCN
      CHARACTER*6 BINARY
      DATA MAXLEN/72/
      DATA BINARY/'BINARY'/,ONE/'1'/,ZERO/'0'/
      DATA BLANK/' '/
      IF (NUM0F.LT.0 .OR. NUM1.LT.0  .OR. NUM0L.LT.0) GOTO 108
      IF (1+NUM0F+NUM1+NUM0L+7 .GT. MAXLEN) GOTO 108
      LAB0F=0
      IF (NUM0F.NE.0) LAB0F=4
      LAB1=0
      IF (NUM1.NE.0) LAB1=2
      LAB0L=0
      IF (NUM0L.NE.0) LAB0L=1
      LABEL=LAB0F+LAB1+LAB0L
      IF (LABEL.LE.0) GOTO 108
      GOTO (101,102,103,104,105,106,107), LABEL
  101 WRITE (IOUT,109) CHARCN,(ZERO,J=1,NUM0L),BLANK,BINARY
      RETURN
  102 WRITE (IOUT,109) CHARCN,(ONE,J=1,NUM1),BLANK,BINARY
      RETURN
  103 WRITE (IOUT,109) CHARCN,(ONE,J=1,NUM1),(ZERO,J=1,NUM0L),BLANK,
     1    BINARY
      RETURN
  104 WRITE (IOUT,109) CHARCN,(ZERO,J=1,NUM0F),BLANK,BINARY
      RETURN
  105 WRITE (IOUT,109) CHARCN,(ZERO,J=1,NUM0F),(ZERO,J=1,NUM0L),BLANK,
     1    BINARY
      RETURN
  106 WRITE (IOUT,109) CHARCN,(ZERO,J=1,NUM0F),(ONE,J=1,NUM1),BLANK,
     1    BINARY
      RETURN
  107 WRITE (IOUT,109) CHARCN,(ZERO,J=1,NUM0F),(ONE,J=1,NUM1),(ZERO,
     1    J=1,NUM0L),BLANK,BINARY
      RETURN
  108 WRITE (IOUT,110) NUM0F,NUM1,NUM0L
      STOP
  109 FORMAT(72A1)
  110 FORMAT ('0ERROR IN TEST PACKAGE.  MSKOUT CALLED WITH ILLEGAL ',
     1       'NUMBER.  SEND OUTPUT'/
     2       ' TO AUTHOR.  NUM0F=',I16,'.  NUM1=',I16,'.'/
     3      ' NUM0L=',I16,'.')
      END

C
C      $Id: st03f.f,v 1.7 2010-03-15 22:49:24 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C                Copyright (C)  1996                                   C
C        University Corporation for Atmospheric Research               C
C                All Rights Reserved                                   C
C                                                                      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C  File:       st03f.f
C
C  Author:     David Brown (converted by Mary Haley)
C              National Center for Atmospheric Research
C              PO 3000, Boulder, Colorado
C
C  Date:       Thu June 27 9:11:01 MST 1996
C
C  Description: 
C               This plot shows a StreamlinePlot overlaid on a polar
C               stereographic map projection. It illustrates some of
C               the problems with streamlines when the transformation to
C               NDC results in grid cells that vary widely in size.
C               Adjustment of certain parameters may improve the
C               appearance somewhat, but not as much as might be
C               desired. For this and other reasons, StreamlinePlot is
C               still undergoing development and its output may be
C               expected to change in the next release.
C               The data is extracted from an NMC forecast dataset for 
C               11/10/1994.
C
      external NhlFAppClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFCairoWindowWorkstationClass
      external NhlFVectorFieldClass
      external NhlFStreamlinePlotClass
      external NhlFMapPlotClass

      parameter(M=73,N=73)

      character*7  wks_type
      integer appid, wid, dataid, stid, mpid
      integer ncid, uid, vid, latid, lonid
      integer rlist, grlist
      integer len_dims(2)
      real U(M,N),V(M,N)
      real stepsize,spacing
      integer start(2), count(2), lonlen, latlen
      character*256 filename
      character*50 recname
      integer flen

C
C Define the workstation type
C
      wks_type = "x11"
C
C Initialize the high level utility library
C
      call NhlFInitialize
C
C Create an application context. Set the app dir to the current
C directory so the application looks for a resource file in the working
C directory. 
C
      call NhlFRLCreate(rlist,'setrl')
      call NhlFRLCreate(grlist,'getrl')

      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'st03',NhlFappClass,0,rlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkMetaName','./st03f.ncgm',ierr)
         call NhlFCreate(wid,'st03Work',
     +        NhlFNcgmWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X11 workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPause','True',ierr)
         call NhlFCreate(wid,'st03Work',
     +        NhlFCairoWindowWorkstationClass,
     +        0,rlist,ierr)
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PostScript workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPSFileName','./st03f.ps',ierr)
         call NhlFCreate(wid,'st03Work',
     +        NhlFPSWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPDFFileName','./st03f.pdf',ierr)
         call NhlFCreate(wid,'st03Work',
     +        NhlFPDFWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFileName','./st03f',ierr)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(wid,'st03Work',
     +        NhlFCairoPSPDFWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFileName','./st03f',ierr)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(wid,'st03Work',
     +        NhlFCairoImageWorkstationClass,0,rlist,ierr)
      endif
C
C Open the netCDF file.
C
      call gngpat(filename,'data',ierr)
      flen = 17
      do 10 i=1,256
         if( filename(i:i).eq.char(0) ) then
            filename(i:i+flen)='/cdf/941110_UV.cdf'
            goto 15
         endif
 10   continue
C      
C The second argument to 'ncopn' should be NCNOWRIT, but since we
C can't include 'netcdf.inc', we are using the value '0' instead.
C
 15   ncid = ncopn(filename,0,ierr)
C
C Get the data.
C
      latid = ncdid(ncid,'lat',ierr)
      lonid = ncdid(ncid,'lon',ierr)
      uid = ncvid(ncid,'u',ierr)
      vid = ncvid(ncid,'v',ierr)
      call ncdinq(ncid,latid,recname,latlen,ierr)
      call ncdinq(ncid,lonid,recname,lonlen,ierr)
      start(1) = 1
      start(2) = 1
      count(1) = lonlen
      count(2) = latlen
      call ncvgt(ncid,uid,start,count,U,ierr)
      call ncvgt(ncid,vid,start,count,V,ierr)
C
C Create a VectorField data object using the data set defined above.
C By default the array bounds will define the data boundaries (zero-based,
C as in C language conventions)
C
      len_dims(1) = lonlen
      len_dims(2) = latlen
      call NhlFRLClear(rlist)
      call NhlFRLSetMDFloatArray(rlist,'vfUDataArray',U,2,len_dims,ierr)
      call NhlFRLSetMDFloatArray(rlist,'vfVDataArray',V,2,len_dims,ierr)
      call NhlFRLSetFloat(rlist,'vfXCStartV', -180.0,ierr)
      call NhlFRLSetFloat(rlist,'vfXCEndV', 180.0,ierr)
      call NhlFRLSetFloat(rlist,'vfYCStartV', -90.0,ierr)
      call NhlFRLSetFloat(rlist,'vfYCEndV', 90.0,ierr)
      call NhlFRLSetFloat(rlist,'vfYCStartSubsetV', 0.0,ierr)
      call NhlFRLSetFloat(rlist,'vfYCEndSubsetV', 87.5,ierr)
      call NhlFCreate(dataid,'vfield',NhlFvectorFieldClass,appid,rlist,
     +     ierr)
C
C Create a StreamlinePlot object, supplying the VectorField object as data
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'tiMainString',
     +     'StreamlinePlot Overlaying MapPlot',ierr)
      call NhlFRLSetInteger(rlist,'stVectorFieldData',dataid,ierr)
      call NhlFCreate(stid,'streamlineplot',NhlFstreamlinePlotClass,wid,
     +     rlist,ierr)

      call NhlFCreate(mpid,'mapplot',NhlFmapPlotClass,wid,0,ierr)

      call NhlFAddOverlay(mpid,stid,-1,ierr)
      call NhlFDraw(mpid,ierr)
      call NhlFFrame(wid,ierr)
      
      call NhlFRLClear(grlist)
      call NhlFRLGetFloat(grlist,'stStepSizeF',stepsize,ierr)
      call NhlFRLGetFloat(grlist,'stMinLineSpacingF',spacing,ierr)
      call NhlFGetValues(stid,grlist,ierr)
C 
C Set the minimum arrow spacing
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'tiMainString',
     +     'Setting the Minimum Arrow Spacing',ierr)
      call NhlFRLSetFloat(rlist,'stMinArrowSpacingF',0.025,ierr)
      call NhlFSetValues(stid,rlist,ierr)

      call NhlFDraw(mpid,ierr)
      call NhlFFrame(wid,ierr)
C 
C Set the minimum line spacing
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'tiMainString','Smaller Line Spacing',
     +     ierr)
      call NhlFRLSetFloat(rlist,'stMinLineSpacingF',spacing * 0.5,ierr)
      call NhlFSetValues(stid,rlist,ierr)

      call NhlFDraw(mpid,ierr)
      call NhlFFrame(wid,ierr)
C 
C Set the step size
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'tiMainString','Smaller Step Size',
     +     ierr)
      call NhlFRLSetFloat(rlist,'stStepSizeF',stepsize * 0.5,ierr)
      call NhlFSetValues(stid,rlist,ierr)

      call NhlFDraw(mpid,ierr)
      call NhlFFrame(wid,ierr)
C 
C Clean up
C
      call NhlFDestroy(appid,ierr)
      call NhlFClose
      stop
      end

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C   FFTPACK 5.0
C   Copyright (C) 1995-2004, Scientific Computing Division,
C   University Corporation for Atmospheric Research
C   Licensed under the GNU General Public License (GPL)
C
C   Authors:  Paul N. Swarztrauber and Richard A. Valent
C
C   $Id: r1f3kb.f,v 1.2 2006-11-21 01:10:18 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      SUBROUTINE DR1F3KB(IDO,L1,CC,IN1,CH,IN2,WA1,WA2)
      DOUBLE PRECISION ARG
      DOUBLE PRECISION TAUR
      DOUBLE PRECISION TAUI
      DOUBLE PRECISION CC(IN1,IDO,3,L1),CH(IN2,IDO,L1,3),WA1(IDO),
     +                 WA2(IDO)
C
      ARG = 2.D0*4.D0*ATAN(1.0D0)/3.D0
      TAUR = COS(ARG)
      TAUI = SIN(ARG)
      DO 101 K = 1,L1
          CH(1,1,K,1) = CC(1,1,1,K) + 2.D0*CC(1,IDO,2,K)
          CH(1,1,K,2) = CC(1,1,1,K) + (2.D0*TAUR)*CC(1,IDO,2,K) -
     +                  (2.D0*TAUI)*CC(1,1,3,K)
          CH(1,1,K,3) = CC(1,1,1,K) + (2.D0*TAUR)*CC(1,IDO,2,K) +
     +                  2.D0*TAUI*CC(1,1,3,K)
  101 CONTINUE
      IF (IDO.EQ.1) RETURN
      IDP2 = IDO + 2
      DO 103 K = 1,L1
          DO 102 I = 3,IDO,2
              IC = IDP2 - I
              CH(1,I-1,K,1) = CC(1,I-1,1,K) +
     +                        (CC(1,I-1,3,K)+CC(1,IC-1,2,K))
              CH(1,I,K,1) = CC(1,I,1,K) + (CC(1,I,3,K)-CC(1,IC,2,K))
              CH(1,I-1,K,2) = WA1(I-2)* ((CC(1,I-1,1,K)+TAUR* (CC(1,I-1,
     +                        3,K)+CC(1,IC-1,2,K)))-
     +                        (TAUI* (CC(1,I,3,K)+CC(1,IC,2,K)))) -
     +                        WA1(I-1)* ((CC(1,I,1,K)+TAUR* (CC(1,I,3,
     +                        K)-CC(1,IC,2,K)))+ (TAUI* (CC(1,I-1,3,
     +                        K)-CC(1,IC-1,2,K))))
              CH(1,I,K,2) = WA1(I-2)* ((CC(1,I,1,K)+TAUR* (CC(1,I,3,
     +                      K)-CC(1,IC,2,K)))+ (TAUI* (CC(1,I-1,3,
     +                      K)-CC(1,IC-1,2,K)))) +
     +                      WA1(I-1)* ((CC(1,I-1,1,K)+TAUR* (CC(1,I-1,3,
     +                      K)+CC(1,IC-1,2,K)))- (TAUI* (CC(1,I,3,
     +                      K)+CC(1,IC,2,K))))
              CH(1,I-1,K,3) = WA2(I-2)* ((CC(1,I-1,1,K)+TAUR* (CC(1,I-1,
     +                        3,K)+CC(1,IC-1,2,K)))+
     +                        (TAUI* (CC(1,I,3,K)+CC(1,IC,2,K)))) -
     +                        WA2(I-1)* ((CC(1,I,1,K)+TAUR* (CC(1,I,3,
     +                        K)-CC(1,IC,2,K)))- (TAUI* (CC(1,I-1,3,
     +                        K)-CC(1,IC-1,2,K))))
              CH(1,I,K,3) = WA2(I-2)* ((CC(1,I,1,K)+TAUR* (CC(1,I,3,
     +                      K)-CC(1,IC,2,K)))- (TAUI* (CC(1,I-1,3,
     +                      K)-CC(1,IC-1,2,K)))) +
     +                      WA2(I-1)* ((CC(1,I-1,1,K)+TAUR* (CC(1,I-1,3,
     +                      K)+CC(1,IC-1,2,K)))+ (TAUI* (CC(1,I,3,
     +                      K)+CC(1,IC,2,K))))
  102     CONTINUE
  103 CONTINUE
      RETURN
      END

      PROGRAM CCPTITLE
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER (M=40,N=40,LRWK=3500,LIWK=4000)
      REAL Z(M,N), RWRK(LRWK), SIZE, Y
      INTEGER IWRK(LIWK)

      CALL GETDAT (Z, M, M, N)
C
C Open GKS
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
      CALL GSCLIP (0)
C
C Initialize Conpack
C
      CALL CPRECT(Z, M, M, N, RWRK, LRWK, IWRK, LIWK)
C
C Draw Perimeter
C
      CALL CPBACK(Z, RWRK, IWRK)
C
C Draw Contours
C
      CALL CPCLDR(Z,RWRK,IWRK)
C
C Draw a Title
C
      CALL GETSET(VPL,VPR,VPB,VPT,WL,WR,WB,WT,LL)
      SIZE = MIN(.5 * (1.0 - VPT),.017)
      Y = MIN((1.0+VPT)/2.0+.017,.017+VPT)
      CALL SET (0.0, 1.0, 0.0, 1.0, 0.0, 1.0, 0.0, 1.0, 1)
      CALL PLCHHQ (.5, Y, 'An Interesting Data Field',SIZE, 0., 0.)
C
C Close frame and close GKS
C
      CALL FRAME
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS

      STOP
      END

      SUBROUTINE GETDAT (Z, K, M, N)
      INTEGER I,J,K,M,N
      REAL Z(K,N)

      L=K
      DO 10, I=1,L
         READ (*,*) (Z(I,J),J=1,N)
 10   CONTINUE

      RETURN
      END

C
C $Id: idbvip.f,v 1.5 2008-07-27 00:17:30 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE IDBVIP (MD,NDP,XD,YD,ZD,NIP,XI,YI,ZI,IWK,WK)
C
C DIMENSION OF            XD(NDP), YD(NDP), ZD(NDP), XI(NIP), YI(NIP)
C ARGUMENTS               ZI(NIP), IWK(31*NDP+NIP),  WK(8*NDP)
C
C PURPOSE                 To perform bivariate interpolation when the
C                         projections of the data points in the X-Y
C                         plane are irregularly distributed.
C
C USAGE                   CALL IDBVIP (MD,NDP,XD,YD,ZD,NIP,XI,YI,ZI,
C                                      IWK,WK)
C
C ARGUMENTS
C
C ON INPUT                MD
C                           Mode of computation (must be 1, 2, or 3,
C                           else an error return occurs.)
C                           = 1 if this is the first call to this
C                               subroutine, or if the value of NDP
C                               has been changed from the previous
C                               call, or if the contents of the XD
C                               or YD arrays have been changed from
C                               the previous call.
C                           = 2 if the values of NDP and the XD and
C                               YD arrays are unchanged from the
C                               previous call, but new values for
C                               XI and YI are being used.  If MD = 2
C                               and NDP has been changed since the
C                               previous call to IDBVIP, an error
C                               return occurs.
C                           = 3 if the values of NDP, NIP, XD, YD
C                               XI, and YI are unchanged from the
C                               previous call, i.e., if the only
C                               change on input to IDBVIP is in the
C                               ZD array.  If MD=3 and NDP or NIP has
C                               been changed since the previous call
C                               to IDBVIP, an error return occurs.
C
C                           Between the call with MD=2 or MD=3 and
C                           the preceding call, the IWK and WK work
C                           arrays should not be disturbed.
C
C                        NDP
C                          Number of data points (must be 4 or
C                          greater, else an error return occurs).
C
C                        XD
C                          Array of dimension NDP containing the
C                          X coordinates of the data points.
C
C                        YD
C                          Array of dimension NDP containing the
C                          Y coordinates of the data points.
C
C                        ZD
C                          Array of dimension NDP containing the
C                          Z coordinates of the data points.
C
C                        NIP
C                          The number of output points at which
C                          interpolation is to be performed (must be
C                          1 or greater, else an error return occurs).
C
C                        XI
C                          Array of dimension NIP containing the X
C                          coordinates of the output points.
C
C                        YI
C                          Array of dimension NIP containing the Y
C                          coordinates of the output points.
C
C                        IWK
C                          Integer work array of dimension at least
C                          31*NDP + NIP
C
C                        WK
C                          Real work array of dimension at least 8*NDP
C
C ON OUTPUT               ZI
C                           Array of dimension NIP where interpolated
C                           Z values are to be stored.
C
C SPECIAL CONDITIONS     Inadequate work space IWK and WK may cause
C                        incorrect results.
C
C                        The data points must be distinct and their
C                        projections in the X-Y plane must not be
C                        collinear, else an error return occurs.
C
C IDBVIP calls the subroutines IDLCTN, IDPDRV, IDPTIP, and IDTANG.
C
C Declaration statements.
C
      DIMENSION XD(NDP),YD(NDP),ZD(NDP),XI(NIP),YI(NIP),ZI(NIP),
     +          IWK(31*NDP+NIP),WK(8*NDP)
C
      COMMON /IDLC/ ITIPV,DMMY1(13)
      SAVE   /IDLC/
C
      COMMON /IDPT/ ITPV,DMMY(27)
      SAVE   /IDPT/
C
      COMMON /IDCOMN/ INTY,ITTY,ALSP,BLSP,CLSP,XAVG,YAVG
      SAVE   /IDCOMN/
C
C Check for an uncleared prior error.
C
        IF (ICFELL('IDBVIP (BIVAR) - UNCLEARED PRIOR ERROR',1).NE.0)
     +                                                        RETURN
C
C Check for input errors.
C
      IF (MD.LT.1.OR.MD.GT.3) THEN
        CALL SETER ('IDBVIP (BIVAR) - INPUT VARIABLE MD IS OUT OF RANGE'
     +,2,1)
        RETURN
      END IF
C
      IF (NDP.LT.4) THEN
        CALL SETER ('IDBVIP (BIVAR) - INPUT VARIABLE NDP IS OUT OF RANGE
     +',3,1)
        RETURN
      END IF
C
      IF (NIP.LT.1) THEN
        CALL SETER ('IDBVIP (BIVAR) - INPUT VARIABLE NIP IS OUT OF RANGE
     +',4,1)
        RETURN
      END IF
C
      IF (MD.LE.1) THEN
C
        IWK(1)=NDP
C
      ELSE
C
        NDPPV=IWK(1)
C
        IF (NDP.NE.NDPPV) THEN
          CALL SETER  ('IDBVIP (BIVAR) - MD = 2 OR 3 BUT NDP WAS CHANGED
     + SINCE LAST CALL',5,1)
          RETURN
        END IF
C
      END IF
C
      IF (MD.LE.2) THEN
C
        IWK(2)=INTY
        IWK(3)=NIP
C
      ELSE
C
        INTYPV=IWK(2)
C
        IF (INTY.NE.INTYPV) THEN
          CALL SETER ('IDBVIP (BIVAR) - MD = 3 BUT ITY WAS CHANGED SINCE
     + LAST CALL',6,1)
           RETURN
        END IF
C
        NIPPV=IWK(3)
C
        IF (NIP.NE.NIPPV) THEN
          CALL SETER ('IDBVIP (BIVAR) - MD = 3 BUT NIP WAS CHANGED SINCE
     + LAST CALL',7,1)
          RETURN
        END IF
C
      END IF
C
C Allocate storage areas in the array IWK.
C
      JWIPT=16
      JWIWL=6*NDP+1
      JWIWK=JWIWL
      JWIPL=24*NDP+1
      JWIWP=30*NDP+1
      JWIT0=31*NDP
      JWWPD=5*NDP+1
C
C If MD = 1, triangulate the X-Y plane.  (If MD = 2 or 3, this has
C already been done and need not been redone.)
C
      IF (MD.EQ.1) THEN
        CALL IDTANG (NDP,XD,YD,NT,IWK(JWIPT),NL,IWK(JWIPL),IWK(JWIWL),
     +                                                  IWK(JWIWP),WK)
        IF (ICFELL('IDBVIP',8).NE.0) RETURN
        IWK(5)=NT
        IWK(6)=NL
      ELSE
        NT=IWK(5)
        NL=IWK(6)
      END IF
C
      IF (NT.EQ.0) RETURN
C
C If linear interpolation is activated, compute the coefficients of the
C least-squares-fit plane and the mean values of X and Y.
C
      IF (INTY.NE.0) THEN
        CALL IDLSQF (XD,YD,ZD,NDP,ALSP,BLSP,CLSP,XAVG,YAVG)
      END IF
C
C If MD = 1 or 2, locate all points at which interpolation is to be
C performed by getting the number of the containing region (a triangle
C number or a combined pair of border-line-segment numbers).  (If MD
C = 3, this has already been done and need not be redone.)
C
      IF (MD.LE.2) THEN
C
        ITIPV=0
C
        DO 101 IIP=1,NIP
          CALL IDLCTN(NDP,XD,YD,NT,IWK(JWIPT),NL,IWK(JWIPL),XI(IIP),
     +                         YI(IIP),IWK(JWIT0+IIP),IWK(JWIWK),WK)
  101   CONTINUE
C
      END IF
C
C If quintic interpolation is activated, estimate partial derivatives.
C
      IF (INTY.EQ.0) THEN
        CALL IDPDRV (NDP,XD,YD,ZD,NT,IWK(JWIPT),WK,WK(JWWPD))
      END IF
C
C Interpolate to get ZI values.
C
      ITPV=0
C
      DO 102 IIP=1,NIP
        CALL IDPTIP(XD,YD,ZD,NT,IWK(JWIPT),NL,IWK(JWIPL),WK,
     +               IWK(JWIT0+IIP),XI(IIP),YI(IIP),ZI(IIP))
  102 CONTINUE
C
C Done.
C
      RETURN
C
      END

C
C $Id: mdlach.f,v 1.10 2008-09-18 00:42:17 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MDLACH (RLAT,CHRS,NCHR)
C
C This routine, given a latitude RLAT and a character buffer CHRS,
C returns CHRS and NCHR such that CHRS(1:NCHR), when written by PLCHHQ,
C will yield the nautical representation of RLAT, in degrees, minutes,
C and seconds north or south of the equator.
C
        DOUBLE PRECISION RLAT
        CHARACTER*(*)    CHRS
        INTEGER          NCHR
C
C Declare local variables.
C
        INTEGER          IDEG,IMIN,ISEC,NSEC
C
C Compute the absolute value of the latitude in seconds, limiting it to
C the range from 0 to 90 degrees (0 to 324,000 seconds), and rounding to
C the nearest second.
C
        NSEC=MIN(324000,INT(3600.D0*ABS(RLAT)+.5D0))
C
C Compute the degree, minute, and second quantities, as integers.
C
        IDEG=NSEC/3600
        IMIN=MOD(NSEC,3600)/60
        ISEC=MOD(NSEC,60)
C
C If the value is zero, return a string that will make PLCHHQ write a
C 0 followed by a degree sign.
C
        IF (IDEG.EQ.0.AND.IMIN.EQ.0.AND.ISEC.EQ.0) THEN
          NCHR=7
          CHRS='0:F34:0'
          RETURN
        END IF
C
C Otherwise, put blanks in the buffer and zero the current character
C count.
C
        CHRS=' '
        NCHR=0
C
C Put the number of degrees in the buffer, followed by the code for a
C degree sign.
C
        CALL MDINCH (IDEG,CHRS,NCHR)
        NCHR=NCHR+9
        CHRS(NCHR-8:NCHR)=':F34:0:F:'
C
C If the number of minutes and seconds are both zero, we're done except
C for an "S" or an "N".
C
        IF (IMIN.EQ.0.AND.ISEC.EQ.0) GO TO 101
C
C Put the number of minutes in the buffer, followed by the code for a
C single quote.
C
        CALL MDINCH (IMIN,CHRS,NCHR)
        NCHR=NCHR+15
        CHRS(NCHR-14:NCHR)=':F29H-5:'':H-4F:'
C
C If the number of seconds is zero, we're done except for an "S" or an
C "N".
C
        IF (ISEC.EQ.0) GO TO 101
C
C Put the number of seconds in the buffer, followed by the code for a
C double quote.
C
        CALL MDINCH (ISEC,CHRS,NCHR)
        NCHR=NCHR+15
        CHRS(NCHR-14:NCHR)=':F29H-5:":FH-4:'
C
C Finally, put either an "S" or an "N" in the buffer.
C
  101   NCHR=NCHR+1
C
        IF (RLAT.LT.0.) THEN
          CHRS(NCHR:NCHR)='S'
        ELSE
          CHRS(NCHR:NCHR)='N'
        END IF
C
C Done.
C
        RETURN
C
      END

      PROGRAM SLEX02
C
C This program illustrates some features of STITLE that have not been
C covered elsewhere and, in particular, some new features that went
C into the code in July, 1995.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
        PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Declare a common block for communication with the routine SLUBKG.
C
        COMMON /CMUSER/ IBKD
C
C Define an array in which to put "card images".
C
        CHARACTER*80 CRDS(11)
C
C Open GKS.
C
        CALL GOPKS (IERRF,ISZDM)
        CALL GOPWK (IWKID,LUNIT,IWTYPE)
        CALL GACWK (IWKID)
C
C Set the argument that will be used to tell FTITLE and STITLE whether
C a real run (MTST = 0) or a test run (MTST = 1) is being done.  You
C should change this and rerun to see the effect on the output.
C
        MTST=0
C
C Tell STITLE to reset itself.  (At this point, since no internal
C parameters of STITLE have been changed, this call effectively does
C nothing; it's here just to remind the reader that SLRSET exists).
C
        CALL SLRSET
C
C Tell STITLE to output only two frames per second.  (Normally, one
C uses either 24 or 30 frames per second; using 2 in this example is
C just a good way to hold down the length of the metafile produced.)
C
        CALL SLSETI ('NFS - NUMBER OF FRAMES PER SECOND',2)
C
C Turn on fade-in and fade-out by telling STITLE how many seconds of
C each to do.  (By default, fade-in and fade-out are turned off.)
C
        CALL SLSETR ('FIN - FADE-IN TIME',2.)
        CALL SLSETR ('FOU - FADE-OUT TIME',2.)
C
C Set some parameters to their default values.  (These calls are here
C just to remind the reader of the existence of the parameters.)
C
C Tell STITLE not to output alignment frames.  These were mostly for
C use in the old days of real 35-millimeter film and are probably not
C useful now.
C
        CALL SLSETI ('ALN - ALIGNMENT FLAG',0)
C
C Tell STITLE what vertical spacing to use between test frames that
C represent the scrolled portion of output.  The effect of changing
C this will be seen only when MTST = 1.
C
        CALL SLSETI ('INC - INCREMENT BETWEEN TEST FRAMES',300)
C
C Tell STITLE what logical unit to use for WISS (Workstation-Independent
C Segment Storage).
C
        CALL SLSETI ('LOG - LOGICAL UNIT FOR WISS',4)
C
C Tell STITLE what to use for the X coordinates at the start and end of
C the scrolling phase.  It is not clear that these are good for much;
C one possible use might be to set both to a value other than 512 in
C order to get the lines of text centered about a particular vertical
C line.  Values used have to be between 1 and 1024.
C
        CALL SLSETI ('NXS - X COORDINATE AT START OF SCROLL',512)
        CALL SLSETI ('NXE - X COORDINATE AT END OF SCROLL',512)
C
C Tell STITLE what "principal size" to use for characters.  The value
C is given in terms of a 1024x1024 plotter window.  When the input to
C FTITLE or STITLE says to use a "SIZE" of 1., what is meant is a
C height of 'PSZ'/1023. fractional units (NDCs).  Similarly, a "SIZE"
C of 1.25 means a height of 1.25*'PSZ'/1023. fractional units (NDCs).
C
        CALL SLSETI ('PSZ - PRINCIPAL SIZE',21)
C
C Define the STITLE viewport.  Characters are clipped at the edges of
C this viewport and, when 'BGC' is set non-zero, STITLE fills it with
C the background color defined by 'BGC' (instead of depending on GKS
C to supply the background fill).  These parameters should be used in
C lieu of the old ones named 'LX1', 'LX2', 'LY1', and 'LY2'.
C
        CALL SLSETR ('VPL - VIEWPORT LEFT',0.)
        CALL SLSETR ('VPR - VIEWPORT RIGHT',1.)
        CALL SLSETR ('VPB - VIEWPORT BOTTOM',0.)
        CALL SLSETR ('VPT - VIEWPORT TOP',1.)
C
C Turn off the flag that tells the version of SLUBKG included below
C to draw a background.  This flag will be turned on for an STITLE
C example during which the background is appropriate for the title
C being scrolled by.
C
        IBKD=0
C
C BEGIN SIMPLE FTITLE EXAMPLE -----------------------------------------
C
C Tell FTITLE what "gap size" to use for the vertical spacing between
C lines.  The value is given in terms of a 1024x1024 plotter window.
C
        CALL SLSETI ('GSZ - GAP SIZE',40)
C
C Set the centering option for FTITLE.  You can set this to 0 to get
C left-justified titles, to 1 to get centered titles, or to 2 to get
C right-justified titles.
C
        CALL SLSETI ('ICO - INTEGER CENTERING OPTION',1)
C
C Tell FTITLE how many seconds worth of blank frames to put before
C the first title frame ('TM1'), after each title frame except the last
C ('TM2'), and after the last title frame ('TM2'+'TM3').  Note that
C 'TM3' can be negative to make the amount of time after the last
C title frame less than that between title frames.
C
        CALL SLSETR ('TM1 - TIME 1 (BEFORE FIRST TITLE)',1.)
        CALL SLSETR ('TM2 - TIME 2 (BETWEEN PAIRS OF TITLES)',.5)
        CALL SLSETR ('TM3 - TIME 3 (EXTRA TIME AFTER LAST TITLE)',.5)
C
C Call the routine SLWFIF to write an input file for FTITLE.  (One
C would normally just create the input file with an editor.  Writing
C it out in this way is easier logistically for the purposes of an
C example.)
C
        CALL SLWFIF
C
C Tell FTITLE what unit it should read the card input from.
C
        CALL SLSETI ('ICU - INPUT CARD UNIT',12)
C
C Open the file that SLWFIF created and rewind it.
C
        OPEN (UNIT=12,FILE='slex02.input',STATUS='OLD',
     +                                FORM='FORMATTED')
C
        REWIND (12)
C
C Call FTITLE to write out the titles defined by the card input.
C
        CALL FTITLE (MTST)
C
C Close the FTITLE input file.
C
        CLOSE (12)
C
C END OF SIMPLE FTITLE EXAMPLE, BEGIN SIMPLE STITLE EXAMPLE -----------
C
C Set up the CRDS array as expected by STITLE.  Each "card" contains
C an X position on the scroll, a Y position on the scroll, a color
C index, a horizontal centering option, a character size, and text.
C In this example, all the X-coordinates are set to 512, and the
C horizontal centering is always set to 1, so each line of text will
C be centered horizontally.  When the color index is omitted, the
C assumed value is that of the internal parameter 'FGC'.
C
        CRDS( 1)='  512  825  2 1  1.2PLOTCHAR'
        CRDS( 2)='  512  750    1  1.2can be'
        CRDS( 3)='  512  675    1  1.2used to'
        CRDS( 4)='  512  600    1  1.2write'
        CRDS( 5)='  512  525    1  1.2an equation'
        CRDS( 6)='  512  450    1  1.2like'
        CRDS( 7)='  512  375  3 1  2.5C:S:2:N:=A:S:2:N:+B:S:2:N:'
        CRDS( 8)='  512  300    1  1.2in a'
        CRDS( 9)='  512  225    1  1.2movie title'
        CRDS(10)='  512  150    1  1.2created by'
        CRDS(11)='  512   75  2 1  1.2STITLE'
C
        NCDS=11
C
C Define the remaining inputs for STITLE.  (Note that there is no
C reason not to put constant values directly in an STITLE call;
C defining each variable is done for purposes of clarity in the
C example.)
C
C IYST specifies the Y-coordinate that will be at the vertical center
C of the frame when scrolling begins.
C
        IYST=825
C
C IYND specifies the Y-coordinate that will be at the vertical center
C of the frame when scrolling is terminated.
C
        IYND=0
C
C TMST specifies how many seconds the first frame will remain
C stationary before scrolling begins.
C
        TMST=1.
C
C Specify the scroll time.  This is the time in seconds that the
C text will be scrolled from position IYST to IYND.
C
        TMMV=5.
C
C Specify how many seconds the final frame will remain stationary
C after scrolling stops.
C
        TMND=1.
C
C Call STITLE, putting 1-second gaps before and after its output.
C
        CALL SLOGAP (1.,MTST)
        CALL STITLE (CRDS,NCDS,IYST,IYND,TMST,TMMV,TMND,MTST)
        CALL SLOGAP (1.,MTST)
C
C END OF SIMPLE STITLE EXAMPLE, BEGIN FANCIER STITLE EXAMPLE ----------
C
C Tell PLOTCHAR to use font 25 (one of the filled fonts) by default.
C
        CALL PCSETI ('FN',25)
C
C Define the color with index 'BGC' (the default background color).
C
        CALL SLSETR ('BGR - BACKGROUND COLOR, RED COMPONENT'  ,1.)
        CALL SLSETR ('BGG - BACKGROUND COLOR, GREEN COMPONENT',1.)
        CALL SLSETR ('BGB - BACKGROUND COLOR, BLUE COMPONENT' ,1.)
C
C Define the color with index 'FGC' (the default foreground color).
C
        CALL SLSETR ('FGR - FOREGROUND COLOR, RED COMPONENT'  ,0.)
        CALL SLSETR ('FGG - FOREGROUND COLOR, GREEN COMPONENT',.7)
        CALL SLSETR ('FGB - FOREGROUND COLOR, BLUE COMPONENT' ,0.)
C
C Define the color with index 2 (for the words "PLOTCHAR" and "STITLE").
C
        CALL SLSETR ('FGR(2) - FOREGROUND COLOR, RED COMPONENT'  ,1.)
        CALL SLSETR ('FGG(2) - FOREGROUND COLOR, GREEN COMPONENT',0.)
        CALL SLSETR ('FGB(2) - FOREGROUND COLOR, BLUE COMPONENT' ,0.)
C
C Define the color with index 3 (for the equation).
C
        CALL SLSETR ('FGR(3) - FOREGROUND COLOR, RED COMPONENT'  ,0.)
        CALL SLSETR ('FGG(3) - FOREGROUND COLOR, GREEN COMPONENT',0.)
        CALL SLSETR ('FGB(3) - FOREGROUND COLOR, BLUE COMPONENT' ,1.)
C
C Define the color with index 4 (for the background drawing).
C
        CALL SLSETR ('FGR(4) - FOREGROUND COLOR, RED COMPONENT'  ,.9)
        CALL SLSETR ('FGG(4) - FOREGROUND COLOR, GREEN COMPONENT',.9)
        CALL SLSETR ('FGB(4) - FOREGROUND COLOR, BLUE COMPONENT' ,.9)
C
C Tell STITLE what kind of fade-in and fade-out to use.  In both cases,
C you can use -2 for a fade from/to black in the HSV system, -1 for no
C fade at all, and "n" greater than or equal to 0 for a fade-in from
C the color with color index "ni" = n/1000 and a fade-out to the color
C with color index "no" = MOD[n,1000], in the RGB system (in which case,
C "ni" = 999 requests no fade-in and "no" = 999 requests no fade-out.)
C
        CALL SLSETI ('BGF - BACKGROUND FADE-IN/OUT TYPE',0)
        CALL SLSETI ('FGF - FOREGROUND FADE-IN/OUT TYPE',0)
C
C Turn on the flag that tells the version of SLUBKG included below
C to draw a background.
C
        IBKD=1
C
C Call STITLE again, putting 1-second gaps before and after its output.
C
        CALL SLOGAP (1.,MTST)
        CALL STITLE (CRDS,NCDS,IYST,IYND,TMST,TMMV,TMND,MTST)
        CALL SLOGAP (1.,MTST)
C
C END OF FANCIER STITLE EXAMPLE ---------------------------------------
C
C Close GKS.
C
        CALL GDAWK (IWKID)
        CALL GCLWK (IWKID)
        CALL GCLKS
C
      END
      SUBROUTINE SLWFIF
C
C This routine just creates an input file for FTITLE to read.
C
C Declare an array to hold card images and then fill the array.
C
        CHARACTER*63 CRDS(7)
C
        DATA CRDS /
     +'    3   2.  .75                                                ',
     +'Stationary titles can be created by calling FTITLE.            ',
     +'This is the first example of such a title.                     ',
     +'Notice how it fades in and fades out.                          ',
     +'    2   2.  .75                                                ',
     +'This is another stationary title.                              ',
     +'It was created during the same call to FTITLE as the first one.'/
C
C Open the output file in the current directory.
C
        OPEN (UNIT=11,FILE='slex02.input',STATUS='UNKNOWN',
     +                                    FORM='FORMATTED')
C
C Write out the contents of the array CRDS.
C
        WRITE (11,'(A63)') CRDS
C
C Close the output file.
C
        CLOSE (11)
C
C Done.
C
        RETURN
C
      END
      SUBROUTINE SLUBKG (IPOC)
C
C This version of SLUBKG replaces the dummy one in STITLE.  When the
C flag IBKD in the common block CMUSER is turned on, this routine draws
C an appropriate background for the label that is being scrolled by.
C
C IPOC says what is going on in STITLE at the time that SLUBKG is
C called, as follows:
C
C IPOC  Position of call to SLUBKG
C ----  ---------------------------------------------------------------
C  -1   Just before drawing titles on a "fade-in" frame.
C  +1   Just after drawing titles on a "fade-in" frame.
C  -2   Just before drawing titles on a "start" frame.
C  +2   Just after drawing titles on a "start" frame.
C  -3   Just before drawing titles on a "move" frame.
C  +3   Just after drawing titles on a "move" frame.
C  -4   Just before drawing titles on an "end" frame.
C  +4   Just after drawing titles on an "end" frame.
C  -5   Just before drawing titles on a "fade-out" frame.
C  +5   Just after drawing titles on a "fade-out" frame.
C
C Declare a common block for communication with the main program.
C
        COMMON /CMUSER/ IBKD
C
C Define some transformations to put the drawing where it looks best.
C
        TRNX(X)=.4+X/16.
        TRNY(Y)=.4+Y/16.
C
C Draw a background if and only if IPOC is negative and IBKD is not
C zero.  Note that we are careful to save and restore the state of
C anything we change in GKS and in PLOTCHAR.
C
        IF (IPOC.LT.0.AND.IBKD.NE.0) THEN
          CALL PLOTIF (0.,0.,2)
          CALL GQPLCI (IERR,ISPL)
          CALL GSPLCI (4)
          CALL GQLWSC (IERR,WDTH)
          CALL GSLWSC (4.)
          CALL PLOTIF (TRNX( 0.),TRNY( 0.),0)
          CALL PLOTIF (TRNX(-3.),TRNY( 0.),1)
          CALL PLOTIF (TRNX(-3.),TRNY( 3.),1)
          CALL PLOTIF (TRNX( 0.),TRNY( 3.),1)
          CALL PLOTIF (TRNX( 0.),TRNY(-4.),1)
          CALL PLOTIF (TRNX( 4.),TRNY(-4.),1)
          CALL PLOTIF (TRNX( 4.),TRNY( 0.),1)
          CALL PLOTIF (TRNX( 0.),TRNY( 3.),1)
          CALL PLOTIF (TRNX( 3.),TRNY( 7.),1)
          CALL PLOTIF (TRNX( 7.),TRNY( 4.),1)
          CALL PLOTIF (TRNX( 4.),TRNY( 0.),1)
          CALL PLOTIF (TRNX( 0.),TRNY( 0.),1)
          CALL PLOTIF (0.,0.,2)
          CALL GSPLCI (ISPL)
          CALL GSLWSC (WDTH)
          CALL PCGETI ('CC',ISCC)
          CALL PCSETI ('CC',4)
          CALL PLCHHQ (TRNX(-1.5),TRNY( 1.5),'A:S:2',.05,0.,0.)
          CALL PLCHHQ (TRNX( 2.0),TRNY(-2.0),'B:S:2',.05,0.,0.)
          CALL PLCHHQ (TRNX( 3.5),TRNY( 3.5),'C:S:2',.05,0.,0.)
          CALL PCSETI ('CC',ISCC)
        END IF
C
C Done.
C
        RETURN
C
      END

      SUBROUTINE DPPCON( UPLO, N, AP, ANORM, RCOND, WORK, IWORK, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     March 31, 1993
*
*     .. Scalar Arguments ..
      CHARACTER          UPLO
      INTEGER            INFO, N
      DOUBLE PRECISION   ANORM, RCOND
*     ..
*     .. Array Arguments ..
      INTEGER            IWORK( * )
      DOUBLE PRECISION   AP( * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  DPPCON estimates the reciprocal of the condition number (in the
*  1-norm) of a real symmetric positive definite packed matrix using
*  the Cholesky factorization A = U**T*U or A = L*L**T computed by
*  DPPTRF.
*
*  An estimate is obtained for norm(inv(A)), and the reciprocal of the
*  condition number is computed as RCOND = 1 / (ANORM * norm(inv(A))).
*
*  Arguments
*  =========
*
*  UPLO    (input) CHARACTER*1
*          = 'U':  Upper triangle of A is stored;
*          = 'L':  Lower triangle of A is stored.
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  AP      (input) DOUBLE PRECISION array, dimension (N*(N+1)/2)
*          The triangular factor U or L from the Cholesky factorization
*          A = U**T*U or A = L*L**T, packed columnwise in a linear
*          array.  The j-th column of U or L is stored in the array AP
*          as follows:
*          if UPLO = 'U', AP(i + (j-1)*j/2) = U(i,j) for 1<=i<=j;
*          if UPLO = 'L', AP(i + (j-1)*(2n-j)/2) = L(i,j) for j<=i<=n.
*
*  ANORM   (input) DOUBLE PRECISION
*          The 1-norm (or infinity-norm) of the symmetric matrix A.
*
*  RCOND   (output) DOUBLE PRECISION
*          The reciprocal of the condition number of the matrix A,
*          computed as RCOND = 1/(ANORM * AINVNM), where AINVNM is an
*          estimate of the 1-norm of inv(A) computed in this routine.
*
*  WORK    (workspace) DOUBLE PRECISION array, dimension (3*N)
*
*  IWORK   (workspace) INTEGER array, dimension (N)
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ONE, ZERO
      PARAMETER          ( ONE = 1.0D+0, ZERO = 0.0D+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            UPPER
      CHARACTER          NORMIN
      INTEGER            IX, KASE
      DOUBLE PRECISION   AINVNM, SCALE, SCALEL, SCALEU, SMLNUM
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            IDAMAX
      DOUBLE PRECISION   DLAMCH
      EXTERNAL           LSAME, IDAMAX, DLAMCH
*     ..
*     .. External Subroutines ..
      EXTERNAL           DLACON, DLATPS, DRSCL, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      UPPER = LSAME( UPLO, 'U' )
      IF( .NOT.UPPER .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( ANORM.LT.ZERO ) THEN
         INFO = -4
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DPPCON', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      RCOND = ZERO
      IF( N.EQ.0 ) THEN
         RCOND = ONE
         RETURN
      ELSE IF( ANORM.EQ.ZERO ) THEN
         RETURN
      END IF
*
      SMLNUM = DLAMCH( 'Safe minimum' )
*
*     Estimate the 1-norm of the inverse.
*
      KASE = 0
      NORMIN = 'N'
   10 CONTINUE
      CALL DLACON( N, WORK( N+1 ), WORK, IWORK, AINVNM, KASE )
      IF( KASE.NE.0 ) THEN
         IF( UPPER ) THEN
*
*           Multiply by inv(U').
*
            CALL DLATPS( 'Upper', 'Transpose', 'Non-unit', NORMIN, N,
     $                   AP, WORK, SCALEL, WORK( 2*N+1 ), INFO )
            NORMIN = 'Y'
*
*           Multiply by inv(U).
*
            CALL DLATPS( 'Upper', 'No transpose', 'Non-unit', NORMIN, N,
     $                   AP, WORK, SCALEU, WORK( 2*N+1 ), INFO )
         ELSE
*
*           Multiply by inv(L).
*
            CALL DLATPS( 'Lower', 'No transpose', 'Non-unit', NORMIN, N,
     $                   AP, WORK, SCALEL, WORK( 2*N+1 ), INFO )
            NORMIN = 'Y'
*
*           Multiply by inv(L').
*
            CALL DLATPS( 'Lower', 'Transpose', 'Non-unit', NORMIN, N,
     $                   AP, WORK, SCALEU, WORK( 2*N+1 ), INFO )
         END IF
*
*        Multiply by 1/SCALE if doing so will not cause overflow.
*
         SCALE = SCALEL*SCALEU
         IF( SCALE.NE.ONE ) THEN
            IX = IDAMAX( N, WORK, 1 )
            IF( SCALE.LT.ABS( WORK( IX ) )*SMLNUM .OR. SCALE.EQ.ZERO )
     $         GO TO 20
            CALL DRSCL( N, SCALE, WORK, 1 )
         END IF
         GO TO 10
      END IF
*
*     Compute the estimate of the reciprocal condition number.
*
      IF( AINVNM.NE.ZERO )
     $   RCOND = ( ONE / AINVNM ) / ANORM
*
   20 CONTINUE
      RETURN
*
*     End of DPPCON
*
      END

C NCLFORTSTART
      SUBROUTINE DINT2P(PPIN,XXIN,P,X,NPIN,PPOUT,XXOUT,NPOUT,LINLOG,
     +     XMSG,IER)
      IMPLICIT NONE

c routine to interpolate from one set of pressure levels
c .   to another set  using linear or ln(p) interpolation
c
c NCL: xout = int2p (pin,xin,pout,linlog)
c
c This code was originally written for a specific purpose.
c .   Several features were added for incorporation into NCL's
c .   function suite including linear extrapolation.
c
c nomenclature:
c
c .   ppin   - input pressure levels. The pin can be
c .            be in ascending or descending order
c .   xxin   - data at corresponding input pressure levels
c .   npin   - number of input pressure levels >= 2
c .   ppout  - output pressure levels (input by user)
c .            same (ascending or descending) order as pin
c .   xxout  - data at corresponding output pressure levels
c .   npout  - number of output pressure levels
c .   linlog - if abs(linlog)=1 use linear interp in pressure
c .            if abs(linlog) anything but =1 linear interp in
c .                ln(pressure)
c .            If the value is negative then the routine will
c .            extrapolate. Be wary of results in this case.
c .   xmsg   - missing data code. if none, set to some number
c .            which will not be encountered (e.g., 1.e+36)
c .   ier    - error code

c                                                ! input types
      INTEGER NPIN,NPOUT,LINLOG,IER
      DOUBLE PRECISION PPIN(NPIN),XXIN(NPIN),PPOUT(NPOUT),XMSG
C                                                ! output
      DOUBLE PRECISION XXOUT(NPOUT)
C NCLEND

c local
      INTEGER J1,NP,NL,NIN,NLMAX,NPLVL,NLSAVE,NP1,NO1,N1,N2,LOGLIN,
     +        NLSTRT
      DOUBLE PRECISION SLOPE,PA,PB,PC

C automatic arrays
      DOUBLE PRECISION PIN(NPIN),XIN(NPIN),P(NPIN),X(NPIN)
      DOUBLE PRECISION POUT(NPOUT),XOUT(NPOUT)

      LOGLIN = ABS(LINLOG)

c error check: enough points: pressures consistency?

      IER = 0
      IF (NPOUT.GT.0) THEN
          DO NP = 1,NPOUT
              XXOUT(NP) = XMSG
          END DO
      END IF

      IF (NPIN.LT.2 .OR. NPOUT.LT.1) IER = IER + 1

C C C IF (NPOUT.GT.1) THEN
C C C     IF ((PPIN(1).GT.PPIN(2).AND.PPOUT(1).LT.PPOUT(2)) .OR.
C C C+        (PPIN(1).LT.PPIN(2).AND.PPOUT(1).GT.PPOUT(2))) THEN
C C C         IER = IER + 10
C              PRINT *,'INT2P: ppout is in different order than ppin'
C              PRINT *,'       Must both be monotonic {in/de}creasing'
C C C     END IF
C C C END IF

      IF (IER.NE.0) THEN
C          PRINT *,'INT2P: error exit: ier=',IER
          RETURN
      END IF

c should input arrays be reordered: want p(1) > p(2) > p(3) etc
c so that it will match order for which code was originally designed
c copy to local arrays

      NP1 = 0
      NO1 = 0
      IF (PPIN(1).LT.PPIN(2)) THEN
          NP1 = NPIN + 1
          NO1 = NPOUT + 1
      END IF

      DO NP = 1,NPIN
          PIN(NP) = PPIN(ABS(NP1-NP))
          XIN(NP) = XXIN(ABS(NP1-NP))
      END DO

      DO NP = 1,NPOUT
          POUT(NP) = PPOUT(ABS(NO1-NP))
      END DO
c
c eliminate levels with missing data. This can easily
c .   happen with observational data.
c
      NL = 0
      DO NP = 1,NPIN
          IF (XIN(NP).NE.XMSG .AND. PIN(NP).NE.XMSG) THEN
              NL = NL + 1
              P(NL) = PIN(NP)
              X(NL) = XIN(NP)
          END IF
      END DO
      NLMAX = NL
C                                                ! all missing data
      IF (NLMAX.LT.2) THEN
          IER = IER + 1000
C          PRINT *,'INT2P: ier=',IER
          RETURN
      END IF

c ===============> pressure in decreasing order <================
c perform the interpolation  [pin(1)>pin(2)>...>pin(npin)]
c                                                      ( p ,x)
c ------------------------- p(nl+1), x(nl+1)   example (200,5)
c .
c ------------------------- pout(np), xout(np)         (250,?)
c .
c ------------------------- p(nl)  , x(nl)             (300,10)


c exact p-level matches
      NLSTRT = 1
      NLSAVE = 1
      DO NP = 1,NPOUT
          XOUT(NP) = XMSG
          DO NL = NLSTRT,NLMAX
              IF (POUT(NP).EQ.P(NL)) THEN
                  XOUT(NP) = X(NL)
                  NLSAVE = NL + 1
                  GO TO 10
              END IF
          END DO
   10     NLSTRT = NLSAVE
      END DO

      IF (LOGLIN.EQ.1) THEN
          DO NP = 1,NPOUT
              DO NL = 1,NLMAX - 1
                  IF (POUT(NP).LT.P(NL) .AND. POUT(NP).GT.P(NL+1)) THEN
                      SLOPE = (X(NL)-X(NL+1))/ (P(NL)-P(NL+1))
                      XOUT(NP) = X(NL+1) + SLOPE* (POUT(NP)-P(NL+1))
                  END IF
              END DO
          END DO
      ELSE
          DO NP = 1,NPOUT
              DO NL = 1,NLMAX - 1
                  IF (POUT(NP).LT.P(NL) .AND. POUT(NP).GT.P(NL+1)) THEN
                      PA = DLOG(P(NL))
                      PB = DLOG(POUT(NP))
c special case: In case someome inadvertently enter p=0.
                      if (p(nl+1).gt.0.d0) then
                          PC = DLOG(P(NL+1))
                      else
                          PC = DLOG(1.d-4)
                      end if

                      SLOPE = (X(NL)-X(NL+1))/ (PA-PC)
                      XOUT(NP) = X(NL+1) + SLOPE* (PB-PC)
                  END IF
              END DO
          END DO
      END IF

c extrapolate?
c . use the 'last' valid slope for extrapolating

      IF (LINLOG.LT.0) THEN
          DO NP = 1,NPOUT
              DO NL = 1,NLMAX
                  IF (POUT(NP).GT.P(1)) THEN
                      IF (LOGLIN.EQ.1) THEN
                          SLOPE = (X(2)-X(1))/ (P(2)-P(1))
                          XOUT(NP) = X(1) + SLOPE* (POUT(NP)-P(1))
                      ELSE
                          PA = DLOG(P(2))
                          PB = DLOG(POUT(NP))
                          PC = DLOG(P(1))
                          SLOPE = (X(2)-X(1))/ (PA-PC)
                          XOUT(NP) = X(1) + SLOPE* (PB-PC)
                      END IF
                  ELSE IF (POUT(NP).LT.P(NLMAX)) THEN
                      N1 = NLMAX
                      N2 = NLMAX - 1
                      IF (LOGLIN.EQ.1) THEN
                          SLOPE = (X(N1)-X(N2))/ (P(N1)-P(N2))
                          XOUT(NP) = X(N1) + SLOPE* (POUT(NP)-P(N1))
                      ELSE
                          PA = DLOG(P(N1))
                          PB = DLOG(POUT(NP))
                          PC = DLOG(P(N2))
                          SLOPE = (X(N1)-X(N2))/ (PA-PC)
                          XOUT(NP) = X(N1) + SLOPE* (PB-PC)
                      END IF
                  END IF
              END DO
          END DO
      END IF

c place results in the return array;
c .   reverse to original order

      DO NP = 1,NPOUT
          XXOUT(NP) = XOUT(ABS(NO1-NP))
      END DO

      RETURN
      END

C
C $Id: tdmrkb.f,v 1.4 2008-07-27 00:17:32 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE TDMRKB (IMRK,UMRK,VMRK,WMRK,SMRK,RTRI,MTRI,NTRI,IRST,
     +                                  UMIN,VMIN,WMIN,UMAX,VMAX,WMAX)
C
        DIMENSION RTRI(10,MTRI)
C
C This routine is called to put a marker of type IMRK at the point with
C coordinates (UMRK,VMRK,WMRK) and with radius SMRK.  This is done by
C adding triangles to the triangle list in the array RTRI.  MTRI is the
C maximum number of triangles that can be put in the list and NTRI is
C the number of triangles currently in the list.  IRST is the index of
C the rendering style to be used for the marker.
C
C IMRK may have a value from 1 to 5, inclusive, to select a tetrahedron,
C an octahedron, a cube, an icosahedron, or an elaborated icosahedron
C (effectively, a sphere), respectively.
C
C This version of the routine clips triangles that extend outside the
C box defined by the last six arguments.
C
C Declare the labelled common block containing the definitions of the
C triangles making up the various markers.
C
        COMMON /TDCOM5/ TMK1(36),TMK2(72),TMK3(108),TMK4(180),TMK5(720)
        SAVE   /TDCOM5/
C
C Get the real equivalent of the rendering style index.
C
        RRST=REAL(IRST)
C
C Depending on what kind of mark is requested, construct and put into
C the triangle array the proper set of triangles to create that mark.
C
        IF (IMRK.EQ.1) THEN
C
C A tetrahedron.
C
          DO 101 I=1,4
            IF (NTRI.LT.MTRI) THEN
              NTRI=NTRI+1
              RTRI(1,NTRI)=UMRK+SMRK*TMK1(9*I-8)
              RTRI(2,NTRI)=VMRK+SMRK*TMK1(9*I-7)
              RTRI(3,NTRI)=WMRK+SMRK*TMK1(9*I-6)
              RTRI(4,NTRI)=UMRK+SMRK*TMK1(9*I-5)
              RTRI(5,NTRI)=VMRK+SMRK*TMK1(9*I-4)
              RTRI(6,NTRI)=WMRK+SMRK*TMK1(9*I-3)
              RTRI(7,NTRI)=UMRK+SMRK*TMK1(9*I-2)
              RTRI(8,NTRI)=VMRK+SMRK*TMK1(9*I-1)
              RTRI(9,NTRI)=WMRK+SMRK*TMK1(9*I  )
              RTRI(10,NTRI)=RRST
              CALL TDCTAB (RTRI,MTRI,NTRI,UMIN,VMIN,WMIN,UMAX,VMAX,WMAX)
            END IF
  101     CONTINUE
C
        ELSE IF (IMRK.EQ.2) THEN
C
C An octahedron.
C
          DO 102 I=1,8
            IF (NTRI.LT.MTRI) THEN
              NTRI=NTRI+1
              RTRI(1,NTRI)=UMRK+SMRK*TMK2(9*I-8)
              RTRI(2,NTRI)=VMRK+SMRK*TMK2(9*I-7)
              RTRI(3,NTRI)=WMRK+SMRK*TMK2(9*I-6)
              RTRI(4,NTRI)=UMRK+SMRK*TMK2(9*I-5)
              RTRI(5,NTRI)=VMRK+SMRK*TMK2(9*I-4)
              RTRI(6,NTRI)=WMRK+SMRK*TMK2(9*I-3)
              RTRI(7,NTRI)=UMRK+SMRK*TMK2(9*I-2)
              RTRI(8,NTRI)=VMRK+SMRK*TMK2(9*I-1)
              RTRI(9,NTRI)=WMRK+SMRK*TMK2(9*I  )
              RTRI(10,NTRI)=RRST
              CALL TDCTAB (RTRI,MTRI,NTRI,UMIN,VMIN,WMIN,UMAX,VMAX,WMAX)
            END IF
  102     CONTINUE
C
        ELSE IF (IMRK.EQ.3) THEN
C
C A twelve-triangle cube.
C
          DO 103 I=1,12
            IF (NTRI.LT.MTRI) THEN
              NTRI=NTRI+1
              RTRI(1,NTRI)=UMRK+SMRK*TMK3(9*I-8)
              RTRI(2,NTRI)=VMRK+SMRK*TMK3(9*I-7)
              RTRI(3,NTRI)=WMRK+SMRK*TMK3(9*I-6)
              RTRI(4,NTRI)=UMRK+SMRK*TMK3(9*I-5)
              RTRI(5,NTRI)=VMRK+SMRK*TMK3(9*I-4)
              RTRI(6,NTRI)=WMRK+SMRK*TMK3(9*I-3)
              RTRI(7,NTRI)=UMRK+SMRK*TMK3(9*I-2)
              RTRI(8,NTRI)=VMRK+SMRK*TMK3(9*I-1)
              RTRI(9,NTRI)=WMRK+SMRK*TMK3(9*I  )
              RTRI(10,NTRI)=RRST
              CALL TDCTAB (RTRI,MTRI,NTRI,UMIN,VMIN,WMIN,UMAX,VMAX,WMAX)
            END IF
  103     CONTINUE
C
        ELSE IF (IMRK.EQ.4) THEN
C
C An icosahedron.
C
          DO 104 I=1,20
            IF (NTRI.LT.MTRI) THEN
              NTRI=NTRI+1
              RTRI(1,NTRI)=UMRK+SMRK*TMK4(9*I-8)
              RTRI(2,NTRI)=VMRK+SMRK*TMK4(9*I-7)
              RTRI(3,NTRI)=WMRK+SMRK*TMK4(9*I-6)
              RTRI(4,NTRI)=UMRK+SMRK*TMK4(9*I-5)
              RTRI(5,NTRI)=VMRK+SMRK*TMK4(9*I-4)
              RTRI(6,NTRI)=WMRK+SMRK*TMK4(9*I-3)
              RTRI(7,NTRI)=UMRK+SMRK*TMK4(9*I-2)
              RTRI(8,NTRI)=VMRK+SMRK*TMK4(9*I-1)
              RTRI(9,NTRI)=WMRK+SMRK*TMK4(9*I  )
              RTRI(10,NTRI)=RRST
              CALL TDCTAB (RTRI,MTRI,NTRI,UMIN,VMIN,WMIN,UMAX,VMAX,WMAX)
            END IF
  104     CONTINUE
C
        ELSE IF (IMRK.EQ.5) THEN
C
C An elaborated icosahedron.
C
          DO 105 I=1,80
            IF (NTRI.LT.MTRI) THEN
              NTRI=NTRI+1
              RTRI(1,NTRI)=UMRK+SMRK*TMK5(9*I-8)
              RTRI(2,NTRI)=VMRK+SMRK*TMK5(9*I-7)
              RTRI(3,NTRI)=WMRK+SMRK*TMK5(9*I-6)
              RTRI(4,NTRI)=UMRK+SMRK*TMK5(9*I-5)
              RTRI(5,NTRI)=VMRK+SMRK*TMK5(9*I-4)
              RTRI(6,NTRI)=WMRK+SMRK*TMK5(9*I-3)
              RTRI(7,NTRI)=UMRK+SMRK*TMK5(9*I-2)
              RTRI(8,NTRI)=VMRK+SMRK*TMK5(9*I-1)
              RTRI(9,NTRI)=WMRK+SMRK*TMK5(9*I  )
              RTRI(10,NTRI)=RRST
              CALL TDCTAB (RTRI,MTRI,NTRI,UMIN,VMIN,WMIN,UMAX,VMAX,WMAX)
            END IF
  105     CONTINUE
C
        END IF
C
C Done.
C
        RETURN
C
      END

C
C $Id: mputid.f,v 1.6 2008-07-27 00:17:09 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MPUTID (UVAL,VVAL,RLAT,RLON)
        DOUBLE PRECISION UVAL,VVAL,RLAT,RLON
        CALL MDUTID (UVAL,VVAL,RLAT,RLON)
        RETURN
      END

C
C $Id: tdprpt.f,v 1.5 2008-07-27 00:17:33 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE TDPRPT (XI3D,YI3D,ZI3D,XI2D,YI2D)
C
C This routine finds the image of the point (XI3D,YI3D,ZI3D) in the
C image plane and returns in XI2D and YI2D the distances of that point
C from each of two planes perpendicular to the image plane, which are
C the desired X and Y coordinates in the image plane.
C
C The variables in the following common block define the mapping from
C 3-space to 2-space.
C
        COMMON /TDCOM1/ IH,IT,XM,YM,ZM,XO,YO,ZO,XT,YT,ZT,OE,XE,YE,ZE
        COMMON /TDCOM1/ A1,B1,C1,D1,E1,A2,B2,C2,D2,E2,A3,B3,C3,D3,E3
        COMMON /TDCOM1/ IS,FV,VL,VR,VB,VT,WL,WR,WB,WT
        SAVE   /TDCOM1/
C
C Do a call forcing a BLOCKDATA to be loaded from a binary library.
C
        CALL TDBLDA
C
C Check for an uncleared prior error.
C
        IF (ICFELL('TDPRPT - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C What's involved is just algebra.
C
        DX=XI3D-XE
        DY=YI3D-YE
        DZ=ZI3D-ZE
C
        TT=-E1/(A1*DX+B1*DY+C1*DZ)
C
        XP=XE+DX*TT
        YP=YE+DY*TT
        ZP=ZE+DZ*TT
C
        XI2D=A2*XP+B2*YP+C2*ZP+D2
        YI2D=A3*XP+B3*YP+C3*ZP+D3
C
C Done.
C
        RETURN
C
      END

C NCLFORTSTART
      SUBROUTINE DRMSD(X,Y,NPTS,XMSG,YMSG,XYRMSD,NPTUSE,IER)
      IMPLICIT NONE
c
c NCL:    rmsd = dim_rmsd(x,y)
c         interface must chk that the length of x and y are the same
c                                         input
      INTEGER NPTS
      DOUBLE PRECISION X(NPTS),Y(NPTS),XMSG,YMSG
c                                         output
      INTEGER NPTUSE,IER
      DOUBLE PRECISION XYRMSD
C NCLEND

c this routine will calculate estimates of the first two  moments
c .   of the vector x containing missing data.

c input arguments:
c .   x,y      - input vectors
c .   npts     - length of x and y
c .   xmsg,ymsg- missing code: if there are no msg values
c .                            set xmsg to some value which will
c .                            not be encountered.

c output arguments:
c .   xyrmsd   - root-mean-square-difference
c .   nptuse  - no. of points used to calculate the estimates
c .   ier      - if (ier.ne.0) an error has occurred

c note :
c .   uncalculated quantities are set to xmsg (nptuse set to zero)

      INTEGER N
      DOUBLE PRECISION RN

      NPTUSE = 0
      XYRMSD = XMSG

      IF (NPTS.LT.1) THEN
          IER = 1
          RETURN
      END IF

      IER = 0
      XYRMSD = 0.D0
      RN = 0.D0
      DO N = 1,NPTS
          IF (X(N).NE.XMSG .AND. Y(N).NE.YMSG) THEN
              RN = RN + 1.0D0
              XYRMSD = XYRMSD + (X(N)-Y(N))**2
          END IF
      END DO

      NPTUSE = RN

      IF (RN.GT.0.D0) THEN
          XYRMSD = SQRT(XYRMSD/RN)
      ELSE
          XYRMSD = XMSG
C error code for all msg values
          IER = 2
      END IF

      RETURN
      END

C
C	$Id: rgbyiq.f,v 1.7 2008-07-27 00:16:54 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE RGBYIQ ( R, G, B, Y, I, Q )
C
C_BEGIN PROLOGUE RGBYIQ
C
C_PURPOSE
C    This subroutine converts a color specification given as
C    Red, Green, and Blue intensity values to a color specification
C    in the YIQ color space.
C
C_DESCRIPTION
C    This subroutine converts color values given in the
C    Red, Green, Blue (RGB) color space to color values
C    in the YIQ color space.  The input Red, Green,
C    and Blue values are intensities in the range [0.,1.] .
C
C_ARGUMENTS
C
C R       (INPUT,SINGLE,VARIABLE)  A real variable in the range
C         [0.,1.] which represents the red intensity component
C         of the input point in RGB color space.
C
C G       (INPUT,SINGLE,VARIABLE)  A real variable in the range
C         [0.,1.] which represents the green intensity component
C         of the input point in RGB color space.
C
C B       (INPUT,SINGLE,VARIABLE)  A real variable in the range
C         [0.,1.] which represents the blue intensity component
C         of the input point in RGB color space.
C
C Y       (OUTPUT,SINGLE,VARIABLE)  A real variable in the range
C         [0.,1.] .  Y is the color component of a television
C         signal which is shown on black-and-white televisions;
C         Y minimizes the effect of two colors appearing different
C         to the human eye but mapping to similar monochrome
C         intensities.
C
C I       (OUTPUT,SINGLE,VARIABLE)  A real variable in the range
C         [-.6,.6] .  I attains its maximum when the input triple
C         is (1.,0.,0.); I attains its minimum when the input triple
C         is (0.,1.,1.) .
C
C Q       (OUTPUT,SINGLE,VARIABLE)  A real variable in the range
C         [-.52,.52].  Q attains its maximum when the input triple
C         is (1.,0.,1.); Q attains its minimum when the input triple
C         is (0.,1.,0.).
C
C_I/O
C    (NONE)
C
C_ROUTINES CALLED
C    (NONE)
C
C_COMMON BLOCKS
C    (NONE)
C
C_MAXIMUM GKS LEVEL
C    (NONE)
C
C_LANGUAGE
C    FORTRAN
C
C_REVISION DATE
C    880511 (YYMMDD)
C
C_HISTORY
C    This subroutine was originally coded and prepared for the
C    NCAR Graphics package by Fred Clare based on algorithms
C    in Foley and van Dam (see REFERENCES below).
C
C_REFERENCES
C    Foley, James D. and van Dam, Andries,"Fundamentals of Interactive
C    Computer Graphics",Addison-Wesley Publishing Company, 1982.
C
C_EXAMPLES
C    Example 1 --  Full white to YIQ.
C          SUBROUTINE TYIQ1
C          REAL    Y,I,Q,EPS
C          PARAMETER (EPS=0.01)
C          CALL RGBYIQ(1.,1.,1.,Y,I,Q)
C          IF ( (ABS(Y-1.) .GT. EPS) .OR. (ABS(I) .GT. EPS) .OR.
C         *     (ABS(Q) .GT. EPS) ) THEN
C            IUN = I1MACH(4)
C            WRITE(IUN,10)
C          ENDIF
C          RETURN
C       10 FORMAT(' TYIQ1 returned incorrect values')
C          END
C
C_END PROLOGUE RGBYIQ
C
      REAL R,G,B,Y,I,Q
C
C_FIRST EXECUTABLE STATEMENT RGBYIQ
      Y = 0.2988922*R +  0.5870147*G + 0.1140931*B
      I = 0.5960695*R -  0.2743087*G - 0.3217608*B
      Q = 0.2113775*R -  0.5229881*G + 0.3116106*B
C
      RETURN
      END

      PROGRAM TPWRTX
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C OPEN GKS, OPEN WORKSTATION OF TYPE 1, ACTIVATE WORKSTATION
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C INVOKE DEMO DRIVER
C
      CALL TPWRTX1(IERR)
C
C DEACTIVATE AND CLOSE WORKSTATION, CLOSE GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END
C
      SUBROUTINE TPWRTX1(IERROR)
C
C PURPOSE                To provide a demonstration of PWRITX
C                        and to test PWRITX with an example.
C
C USAGE                  CALL TPWRTX1 (IERROR)
C
C ARGUMENTS
C
C ON OUTPUT              IERROR
C                          An integer variable
C                          = 0, if the test is successful,
C                          = 1, otherwise
C
C I/O                    If the test is successful, the message
C
C               PWRITX TEST EXECUTED--SEE PLOTS TO CERTIFY
C
C                        is written on unit 6.
C
C                        In addition, four frames are produced.  The
C                        first three frames contain complete
C                        character plots, and the fourth frame
C                        tests various settings of the function
C                        codes.  To determine if the test is
C                        successful, it is necessary to examine these
C                        plots.
C
C PRECISION              Single
C
C REQUIRED ROUTINES      PWRITX
C
C REQUIRED GKS LEVEL     0A
C
C LANGUAGE               FORTRAN
C
C ALGORITHM              TPWRTX calls the software character drawing
C                        subroutine PWRITX once for twelve different
C                        function codes for 46 separate characters.
C                        This produces a total of 552 characters on
C                        four separate plots.  Each plot contains a
C                        grid of characters with the principle Roman
C                        characters in the first column and their
C                        other representations, produced with different
C                        function codes, across each row.  Each function
C                        code has a mnemonic interpretation (e.g.,
C                        PRU - Principle Roman Upper,  IGL - Indexical
C                        Greek Lower).  In the first four plots, each
C                        column is labelled with its function code.
C                        The fifth plot invokes PWRITX with various
C                        function codes.
C
      CHARACTER*1  DAT(48)
C
C DAT contains the standard character set
C
      DATA  DAT(1),DAT(2),DAT(3),DAT(4),DAT(5),DAT(6),DAT(7),DAT(8),
     1      DAT( 9),DAT(10),DAT(11),DAT(12),DAT(13),DAT(14),DAT(15),
     2      DAT(16),DAT(17),DAT(18),DAT(19),DAT(20),DAT(21),DAT(22),
     3      DAT(23),DAT(24),DAT(25),DAT(26),DAT(27),DAT(28),DAT(29),
     4      DAT(30),DAT(31),DAT(32),DAT(33),DAT(34),DAT(35),DAT(36),
     5      DAT(37),DAT(38),DAT(39),DAT(40),DAT(41),DAT(42),DAT(43),
     6      DAT(44),DAT(45),DAT(46),DAT(47),DAT(48) /
     7       'A',    'B',    'C',    'D',    'E',    'F',    'G',
     8       'H',    'I',    'J',    'K',    'L',    'M',    'N',
     9       'O',    'P',    'Q',    'R',    'S',    'T',    'U',
     +       'V',    'W',    'X',    'Y',    'Z',    '0',    '1',
     1       '2',    '3',    '4',    '5',    '6',    '7',    '8',
     2       '9',    '+',    '-',    '*',    '/',    '(',    ')',
     3       '$',    '=',    ' ',    ',',    '.',    ' '  /
C
C Use normalization transformation 0
C
      CALL GSELNT (0)
C
C A separate frame is produced for each iteration through this loop
C
      DO 160 K=1,4
C
C  Label the column and change the function code
C
         DO 150 J=1,12
            XPOS = REAL(J*80-39) / 1024.
            GO TO ( 10, 20, 30, 40, 50, 60, 70, 80, 90,100,
     1             110,120),J
   10       CALL PWRITX (XPOS,.9375,'PRU',3,16,0,0)
            CALL PWRITX (1./1024.,1./1024.,'''PRU''',5,1,0,0)
            GO TO 130
   20       CALL PWRITX (XPOS,.9375,'PRL',3,16,0,0)
            CALL PWRITX (1./1024.,1./1024.,'''PRL''',5,1,0,0)
            GO TO 130
   30       CALL PWRITX (XPOS,.9375,'IRU',3,16,0,0)
            CALL PWRITX (1./1024.,1./1024.,'''IRU''',5,1,0,0)
            GO TO 130
   40       CALL PWRITX (XPOS,.9375,'IRL',3,16,0,0)
            CALL PWRITX (1./1024.,1./1024.,'''IRL''',5,1,0,0)
            GO TO 130
   50       CALL PWRITX (XPOS,.9375,'KRU',3,16,0,0)
            CALL PWRITX (1./1024.,1./1024.,'''KRU''',5,1,0,0)
            GO TO 130
   60       CALL PWRITX (XPOS,.9375,'KRL',3,16,0,0)
            CALL PWRITX (1./1024.,1./1024.,'''KRL''',5,1,0,0)
            GO TO 130
   70       CALL PWRITX (XPOS,.9375,'PGU',3,16,0,0)
            CALL PWRITX (1./1024.,1./1024.,'''PGU''',5,1,0,0)
            GO TO 130
   80       CALL PWRITX (XPOS,.9375,'PGL',3,16,0,0)
            CALL PWRITX (1./1024.,1./1024.,'''PGL''',5,1,0,0)
            GO TO 130
   90       CALL PWRITX (XPOS,.9375,'IGU',3,16,0,0)
            CALL PWRITX (1./1024.,1./1024.,'''IGU''',5,1,0,0)
            GO TO 130
  100       CALL PWRITX (XPOS,.9375,'IGL',3,16,0,0)
            CALL PWRITX (1./1024.,1./1024.,'''IGL''',5,1,0,0)
            GO TO 130
  110       CALL PWRITX (XPOS,.9375,'KGU',3,16,0,0)
            CALL PWRITX (1./1024.,1./1024.,'''KGU''',5,1,0,0)
            GO TO 130
  120       CALL PWRITX (XPOS,.9375,'KGL',3,16,0,0)
            CALL PWRITX (1./1024.,1./1024.,'''KGL''',5,1,0,0)
C
  130       CONTINUE
C
C           Draw twelve characters with the same function code
C
            DO 140 I=1,12
               YPOS = REAL( 980-I*80 ) / 1024.
               IF = I+(K-1)*12
               CALL PWRITX (XPOS,YPOS,DAT(IF),1,1,0,0)
  140       CONTINUE
C
C           Return function to Principle Roman Upper to label column
C
            CALL PWRITX (1./1024.,1./1024.,'''PRU''',5,1,0,0)
  150    CONTINUE
C
C        Label frame
C
         CALL PWRITX(.5,1000./1024.,
     +               'DEMONSTRATION PLOT FOR PWRITX',29,1,0,0)
         CALL FRAME
  160 CONTINUE
C
C  Test more function codes.
C
C  Tests:
C    Upper and lower case function codes
C    Sub- and Super-scripting and Normal function codes
C    Down and Across function codes
C    Direct Character access
C    X and Y coordinate control, Carriage control function codes
C    Orientation of string (argument to PWRITX)
C
C
C  Test direct character access and string orientation
C
      CALL PWRITX(.5,.5,'''546''',5,3,0,0)
      CALL PWRITX(.5,.5,'''H9L''ANGLE OF ''U''30',19,18,30,-1)
      CALL PWRITX(.5,.5,'''H-9L''ANGLE OF ''U''190',21,18,190,-1)
C
C  Upper and Lower case
C
      CALL PWRITX(.65,.25,'2 ''L2''LOWER, 3 ''U3''UPPER',24,1,0,0)
C
C  Level definitions (sub and superscripting)
C
      CALL PWRITX(.95,.15,'THIS IS ''U1''S''S''UPERSCRIPTING',29,0,0,1)
      CALL PWRITX(.95,.1,'''N''THIS IS ''L1''S''B''UBSCRIPTING',
     -            30,0,0,1)
      CALL PWRITX(.95,.05,'''N''SHOW ''U1''U''S''SE OF''NU''NORMAL',
     -            31,0,0,1)
C
C  Direction definitions
C
      CALL PWRITX(.05,.5,'DO''D''WNA''A''CROSS',16,0,0,-1)
C
C  Coordinate definitions
C
      CALL PWRITX(.3,.85,
     - '''L''U''V7''S''V7''E''V7'' ''V7U1''V''V7'' FOR VERTICAL STEPS',
     -            49,0,0,0)
      CALL PWRITX(.25,.6,
     -            '''U''SHIFT''H11''.''H11''.''H11''.''H11''.RIGHT',
     -            37,14,90,-1)
      CALL PWRITX(.45,.6,
     -            'SHIFT''H-30''.''H-11''.''H-11''.''H-11''.LEFT',
     -            37,14,90,-1)
      CALL PWRITX(.8,.8,'''L3''USE C''CL''FOR''C''CARRIAGE''C''RETURNS',
     -            37,16,0,0)
      CALL PWRITX(.1,.1,'''UX50Y50''( X50, Y50 )''X99Y99''( X99, Y99 )',
     -            41,14,0,-1)
C
C        Label frame
C
         CALL PWRITX(.5,1000./1024.,
     +               'DEMONSTRATION PLOT FOR PWRITX',29,1,0,0)
      CALL FRAME
C
      IERROR = 0
      WRITE (6,1001)
      RETURN
C
 1001 FORMAT (' PWRITX TEST EXECUTED--SEE PLOTS TO CERTIFY')
C
      END

C
C	$Id: devcol.f,v 1.4 2008-07-27 12:23:43 haley Exp $
C                                                                      
C			     Copyright (C)  1997
C	     University Corporation for Atmospheric Research
C			     All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C

      SUBROUTINE DEVCOL(WHICH, IOS, STATUS)
C
C  Process the DEVICE_COLOR keywords.
C
C
C  INPUT
C       WHICH   --  the encoded path flags.
C
C  OUTPUT
C       IOS     --  I/O status flag.  This flag is valid only
C                   if STATUS indicates an error.
C       STATUS  --  The error status as defined in COMMON CAPERR.
C
C
      COMMON /CAPDEV/ DGISTR, DGISIZ, DGESTR, DGESIZ, DTISTR,
     1                DTISIZ, DCDLLX, DCDLLY, DCDURX, DCDURY,
     3                DCOAVL, CORFMT, CORFIN, BATCH , DHCSIZ,
     4                DHCSTR, CORXOF, CORYOF, DASBIT, CORXSC,
     5                CORYSC, VDWLLX, VDWLLY, VDWURX, VDWURY
      INTEGER         DGIMAX, DGEMAX, DTIMAX, DCFTMX, DHCMAX
      PARAMETER   (DGIMAX=300, DGEMAX=150, DTIMAX=100)
      PARAMETER   (DCFTMX=30 , DHCMAX=50)
      INTEGER         DGISTR(DGIMAX), DGISIZ, DGESTR(DGEMAX),
     1                DGESIZ, DTISTR(DTIMAX), DTISIZ, DCDLLX,
     2                DCDLLY, DCDURX, DCDURY, CORFMT(DCFTMX,4),
     3                CORFIN(8)     , DHCSIZ, DHCSTR(DHCMAX),
     4                CORXOF, CORYOF, DASBIT, VDWLLX, VDWLLY,
     5                VDWURX, VDWURY
      REAL            CORXSC, CORYSC, CORRIN(8)
      LOGICAL         DCOAVL, BATCH
C  Size of the COMMON
      INTEGER         LENDEV
      PARAMETER   (LENDEV=DGIMAX+1+DGEMAX+1+DTIMAX+1+4+1+4*DCFTMX+
     1                  8+2+DHCMAX+9)
      EQUIVALENCE (CORFIN,CORRIN)
      COMMON /PARTB1/ PART1, KEYSEP, KEYTER, FRMCOM
      COMMON /PARTB2/ PART2, PART3, PART4, PART5, CTSTR, CTLOC
C
C  THE NUMBER OF WORDS IN THE SEARCH PATH MUST BE BIG ENOUGH TO HOLD
C       THE NUMBER OF BITS PER PATH TIMES THE NUMBER OF LEVELS
C
      INTEGER WHSIZE
      PARAMETER (WHSIZE=20)
C
      INTEGER PARTSZ, OTHSZ, NTABLE
      PARAMETER(PARTSZ=3000, OTHSZ=150, NTABLE=50)
      CHARACTER*1 KEYSEP,KEYTER
      CHARACTER*1 FRMCOM(2)
      INTEGER PART2(OTHSZ), PART3(OTHSZ), PART4(NTABLE), PART5(NTABLE*2)
      CHARACTER*1 PART1(PARTSZ)
      INTEGER CTSTR, CTLOC
      COMMON /CAPERR/ ALLOK, EOFFL, INTERR, MAXINT, PLBERR, PMBERR,
     1                FABERR, TXBERR, FLTERR, MAXFLT, NOTINT, SIZERR,
     2                UNDASC, DEVERR, DOCERR, TBLERR , STSZER, ENTERR,
     3                TABERR, TABSER, PRSFIL
      INTEGER ALLOK, EOFFL, INTERR, MAXINT, PLBERR, PMBERR,
     1        FABERR, TXBERR, FLTERR, MAXFLT, NOTINT, SIZERR, UNDASC,
     2        DEVERR, DOCERR, STSZER, ENTERR, TABERR, TABSER, TBLERR,
     3        PRSFIL
      COMMON /CAPCOL/ COLINT, COLIDX, IDXCUR, VDMINT, DMPAVL, COLFMT
     1               ,COLFIN, IDXMAX, MSTSTR, MSTSIZ, MTRSTR, DMPMDL
     2               ,MTRSIZ, DMPIDV, DMPFIN, DMPFMT
      INTEGER         MAPMAX, COLMAX, MSTMAX, MTRMAX, DMPMAX
      PARAMETER   (MAPMAX=256, COLMAX=15, MSTMAX=50, MTRMAX=20)
      PARAMETER   (DMPMAX=50)
      INTEGER         COLINT(MAPMAX*3)      , COLIDX(MAPMAX), IDXCUR,
     1                VDMINT, COLFMT(COLMAX,4)      , COLFIN(8)     ,
     2                IDXMAX, MSTSTR(MSTMAX), MSTSIZ, MTRSTR(MTRMAX),
     3                DMPMDL, MTRSIZ, DMPFIN(8)     , DMPFMT(DMPMAX,4)
      LOGICAL         DMPAVL, DMPIDV
      REAL            COLRIN(8),DMPRIN(8)
      INTEGER LENCOL
      PARAMETER   (LENCOL=MAPMAX*3+MAPMAX+1+1+1+COLMAX*4+8+1+MSTMAX+
     1                    1+MTRMAX+1+1+1+8+DMPMAX*4)
      EQUIVALENCE (COLFIN,COLRIN),(DMPFIN,DMPRIN)
C
      INTEGER IOS, STATUS, WHICH(WHSIZE)
      INTEGER ROW3, ROW4, DUMMY, II, JJ
      INTEGER HOLDER(COLMAX*4)
C
C  Get levels 3 and 4 of the parse path.
C
      ROW3 = WHICH(3)
      ROW4 = WHICH(4)
C
C  Branch to proper keyword processing.
C
C       ROW3    ROW4    Keyword
C       ----    ----    ------------------------------------
C       1               DEVICE_COLOR_AVAILABLE
C       2       1       DEVICE_COLOR_INDEX_FORMAT
C       2       2       DEVICE_COLOR_INDEX_ENCODING
C       2       3       DEVICE_COLOR_INDEX_FLOATING_INFO
C
      IF (ROW3.EQ.1) THEN
        CALL GTLOG(DCOAVL, 1, DUMMY, IOS, STATUS)
      ELSE IF (ROW3.EQ.2) THEN
        IF (ROW4.EQ.2) THEN
                CALL GTINT(COLFIN(1), 1, DUMMY, IOS, STATUS)
        ELSE IF (ROW4.EQ.3) THEN
                CALL GTFLT(COLRIN(5), 4, DUMMY, IOS, STATUS)
        ELSE IF (ROW4 .EQ. 1) THEN
                CALL GTINT(HOLDER, COLMAX*4, DUMMY, IOS, STATUS)
                        IF (DUMMY .NE. 0) THEN
                        COLFIN(2) = DUMMY/4
                        DO 10 II = 1,COLFIN(2)
                        DO 10 JJ = 1,4
                                COLFMT(II,JJ) = HOLDER((II-1)*4+JJ)
 10                     CONTINUE
                END IF
        END IF
      END IF
C
      RETURN
      END

      SUBROUTINE SGESV( N, NRHS, A, LDA, IPIV, B, LDB, INFO )
*
*  -- LAPACK driver routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     March 31, 1993 
*
*     .. Scalar Arguments ..
      INTEGER            INFO, LDA, LDB, N, NRHS
*     ..
*     .. Array Arguments ..
      INTEGER            IPIV( * )
      REAL               A( LDA, * ), B( LDB, * )
*     ..
*
*  Purpose
*  =======
*
*  SGESV computes the solution to a real system of linear equations
*     A * X = B,
*  where A is an N-by-N matrix and X and B are N-by-NRHS matrices.
*
*  The LU decomposition with partial pivoting and row interchanges is
*  used to factor A as
*     A = P * L * U,
*  where P is a permutation matrix, L is unit lower triangular, and U is
*  upper triangular.  The factored form of A is then used to solve the
*  system of equations A * X = B.
*
*  Arguments
*  =========
*
*  N       (input) INTEGER
*          The number of linear equations, i.e., the order of the
*          matrix A.  N >= 0.
*
*  NRHS    (input) INTEGER
*          The number of right hand sides, i.e., the number of columns
*          of the matrix B.  NRHS >= 0.
*
*  A       (input/output) REAL array, dimension (LDA,N)
*          On entry, the N-by-N coefficient matrix A.
*          On exit, the factors L and U from the factorization
*          A = P*L*U; the unit diagonal elements of L are not stored.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(1,N).
*
*  IPIV    (output) INTEGER array, dimension (N)
*          The pivot indices that define the permutation matrix P;
*          row i of the matrix was interchanged with row IPIV(i).
*
*  B       (input/output) REAL array, dimension (LDB,NRHS)
*          On entry, the N-by-NRHS matrix of right hand side matrix B.
*          On exit, if INFO = 0, the N-by-NRHS solution matrix X.
*
*  LDB     (input) INTEGER
*          The leading dimension of the array B.  LDB >= max(1,N).
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*          > 0:  if INFO = i, U(i,i) is exactly zero.  The factorization
*                has been completed, but the factor U is exactly
*                singular, so the solution could not be computed.
*
*  =====================================================================
*
*     .. External Subroutines ..
      EXTERNAL           SGETRF, SGETRS, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      IF( N.LT.0 ) THEN
         INFO = -1
      ELSE IF( NRHS.LT.0 ) THEN
         INFO = -2
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -4
      ELSE IF( LDB.LT.MAX( 1, N ) ) THEN
         INFO = -7
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'SGESV ', -INFO )
         RETURN
      END IF
*
*     Compute the LU factorization of A.
*
      CALL SGETRF( N, N, A, LDA, IPIV, INFO )
      IF( INFO.EQ.0 ) THEN
*
*        Solve the system A*X = B, overwriting B with X.
*
         CALL SGETRS( 'No transpose', N, NRHS, A, LDA, IPIV, B, LDB,
     $                INFO )
      END IF
      RETURN
*
*     End of SGESV
*
      END

      PROGRAM AREX01
C
C This example code forces ARPRAM to produce, for a simple area map, a
C set of plots showing all the edge segments in the area map at each of
C the steps that are done to preprocess the area map.  The user may wish
C to modify this example to look at what happens to other simple area
C maps.  For a complicated area map, though, the technique will probably
C produce an unreadable set of plots.
C
C The last plot produced by this example shows "contour bands" over a
C simple "map".  The colors used over "water" range from green at one
C end of the contour range to red at the other end.  Over "land", we
C use a color defined by an RGB triple in which the red and green
C components are what they would have been over "water", but we add
C a maximal blue component to wash out the color into a pastel shade.
C A rectangular area (in which, one might imagine, data were missing)
C is masked out so as to be left uncolored.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
        PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Define the size of the area map to be used.
C
        PARAMETER (LAMA=10000)
C
C Define the sizes of the work arrays to be used by ARSCAM.
C
        PARAMETER (NCRA=1000,NGPS=10)
C
C Declare the area map array.
C
        DIMENSION IAMA(LAMA)
C
C Declare the work arrays to be used by ARSCAM.
C
        DIMENSION XCRA(NCRA),YCRA(NCRA),IAAI(NGPS),IAGI(NGPS)
C
C Declare arrays to hold a perimeter, to be used for all three groups
C of edges.
C
        DIMENSION PERIX(5),PERIY(5)
C
C Declare arrays for edge group 1, which may be thought of as defining
C a simple geographic map, showing a single continent, in the middle of
C which is is a lake.
C
        DIMENSION G1E1X(9),G1E1Y(9)
        DIMENSION G1E2X(5),G1E2Y(5)
C
C Declare arrays for edge group 3, which may be thought of as defining
C a contour map.  A "contour line" that lies on top of one of the others
C and has contradictory area identifiers is thrown in to show what AREAS
C does in such cases.
C
        DIMENSION G3E1X(2),G3E1Y(2)
        DIMENSION G3E2X(2),G3E2Y(2)
        DIMENSION G3E3X(2),G3E3Y(2)
        DIMENSION G3E4X(2),G3E4Y(2)
        DIMENSION G3E5X(2),G3E5Y(2)
        DIMENSION G3E6X(2),G3E6Y(2)
        DIMENSION G3E7X(2),G3E7Y(2)
        DIMENSION G3E8X(2),G3E8Y(2)
        DIMENSION G3E9X(2),G3E9Y(2)
C
C Declare arrays for edge group 5, which may be thought of as defining
C a "blocked" region, inside of which we don't want to show anything.
C This edge group is also used to show examples of coincident edge
C segments and "dangling" edge segments.
C
        DIMENSION G5E1X(7),G5E1Y(7)
C
C Declare the routine that will color the areas defined by the area map.
C
        EXTERNAL COLRAM
C
C Define the perimeter for all three groups of edges.
C
        DATA PERIX / .90,.90,.10,.10,.90 /
        DATA PERIY / .10,.90,.90,.10,.10 /
C
C Define the group 1 edges.
C
        DATA G1E1X / .75,.68,.50,.32,.25,.32,.50,.68,.75 /
        DATA G1E1Y / .50,.68,.75,.68,.50,.32,.25,.32,.50 /
C
        DATA G1E2X / .60,.60,.40,.40,.60 /
        DATA G1E2Y / .40,.60,.60,.40,.40 /
C
C Define the group 3 edges.
C
        DATA G3E1X / .10,.20 /
        DATA G3E1Y / .80,.90 /
C
        DATA G3E2X / .10,.40 /
        DATA G3E2Y / .60,.90 /
C
        DATA G3E3X / .10,.60 /
        DATA G3E3Y / .40,.90 /
C
        DATA G3E4X / .10,.80 /
        DATA G3E4Y / .20,.90 /
C
        DATA G3E5X / .20,.90 /
        DATA G3E5Y / .10,.80 /
C
        DATA G3E6X / .40,.90 /
        DATA G3E6Y / .10,.60 /
C
        DATA G3E7X / .60,.90 /
        DATA G3E7Y / .10,.40 /
C
        DATA G3E8X / .80,.90 /
        DATA G3E8Y / .10,.20 /
C
        DATA G3E9X / .40,.20 /
        DATA G3E9Y / .70,.50 /
C
C Define the group 5 edges.
C
        DATA G5E1X / .50,.80,.80,.50,.50,.20,.35 /
        DATA G5E1Y / .50,.50,.80,.80,.50,.20,.35 /
C
C Open GKS.
C
        CALL GOPKS (IERRF, ISZDM)
        CALL GOPWK (IWKID, LUNIT, IWTYPE)
        CALL GACWK (IWKID)
C
C Change the GKS "fill area interior style" to be "solid".
C
        CALL GSFAIS (1)
C
C Define the colors to be used.  Color indices 0 and 1 are the default
C background and foreground colors (black and white, respectively).
C Color indices 11 through 19 are to be used over "ocean" and color
C indices 21 through 29 are to be used over "land".
C
        CALL GSCR (IWKID,0,0.,0.,0.)
        CALL GSCR (IWKID,1,1.,1.,1.)
C
        DO 101 I=1,9
          S=MAX(0.,MIN(1.,REAL(I)/9.))
          T=MAX(0.,MIN(1.,1.-S))
          CALL GSCR (IWKID,10+I,S,T,0.)
          CALL GSCR (IWKID,20+I,S,T,1.)
  101   CONTINUE
C
C Define the mapping from the user system to the plotter frame.
C
        CALL SET (.05,.95,.05,.95,0.,1.,0.,1.,1)
C
C Turn on the AREAS debugging flag.  This will cause the routine
C ARDBPA to be called by ARPRAM.  For the purposes of this example,
C we supply our own version of ARDBPA, which has been hacked to show
C the contents of the area map at each breakpoint position for groups
C 1, 3, and 5, and to make the area identifiers big enough to be read
C without zooming.  It has also been hacked to omit any edge segment
C that has an endpoint outside the viewport defined by the lines
C "X=.05", "X=.95", "Y=.05", and "Y=.95", in the fractional coordinate
C system.
C
        CALL ARSETI ('DB',1)
C
C Initialize the area map.
C
        CALL ARINAM (IAMA,LAMA)
C
C Put group 1 edges into the area map.
C
        CALL AREDAM (IAMA,PERIX,PERIY,5,1, 0,-1)
        CALL AREDAM (IAMA,G1E1X,G1E1Y,9,1, 2, 1)
        CALL AREDAM (IAMA,G1E2X,G1E2Y,5,1, 1, 2)
C
C Put group 3 edges into the area map.
C
        CALL AREDAM (IAMA,PERIX,PERIY,5,3, 0,-1)
        CALL AREDAM (IAMA,G3E1X,G3E1Y,2,3, 1, 2)
        CALL AREDAM (IAMA,G3E2X,G3E2Y,2,3, 2, 3)
        CALL AREDAM (IAMA,G3E3X,G3E3Y,2,3, 3, 4)
        CALL AREDAM (IAMA,G3E4X,G3E4Y,2,3, 4, 5)
        CALL AREDAM (IAMA,G3E5X,G3E5Y,2,3, 5, 6)
        CALL AREDAM (IAMA,G3E6X,G3E6Y,2,3, 6, 7)
        CALL AREDAM (IAMA,G3E7X,G3E7Y,2,3, 7, 8)
        CALL AREDAM (IAMA,G3E8X,G3E8Y,2,3, 8, 9)
        CALL AREDAM (IAMA,G3E9X,G3E9Y,2,3, 9,10)
C
C Put group 5 edges into the area map.
C
        CALL AREDAM (IAMA,PERIX,PERIY,5,5, 0,-1)
        CALL AREDAM (IAMA,G5E1X,G5E1Y,7,5,-1, 0)
C
C Scan the area map.
C
        CALL ARSCAM (IAMA,XCRA,YCRA,NCRA,IAAI,IAGI,NGPS,COLRAM)
C
C Put a label at the top of the final plot.
C
        CALL PLCHLQ (.5,.98,'THE COLORED AREAS',.014,0.,0.)
C
C Advance the frame.
C
        CALL FRAME
C
C Close GKS.
C
        CALL GDAWK (IWKID)
        CALL GCLWK (IWKID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END



      SUBROUTINE ARDBPA (IAMA,IGIP,LABL)
C
        DIMENSION IAMA(*)
C
        CHARACTER*(*) LABL
C
C This is a version of the AREAS routine ARDBPA that has been modified
C to produce plots for each of edge groups 1, 3, and 5.
C
        CHARACTER*80 LABM
C
C Compute the length of the original label.
C
        LENL=LEN(LABL)
C
C Do a plot showing the contents of the area map for group 1.
C
        LABM=LABL // ' - GROUP 1'
        CALL ARDBPB (IAMA,1,LABM(1:LENL+10))
        CALL FRAME
C
C Do a plot showing the contents of the area map for group 3.
C
        LABM=LABL // ' - GROUP 3'
        CALL ARDBPB (IAMA,3,LABM(1:LENL+10))
        CALL FRAME
C
C Do a plot showing the contents of the area map for group 5.
C
        LABM=LABL // ' - GROUP 5'
        CALL ARDBPB (IAMA,5,LABM(1:LENL+10))
        CALL FRAME
C
C Do a plot showing the contents of the area map for all groups.
C
        LABM=LABL // ' - ALL GROUPS'
        CALL ARDBPB (IAMA,1,LABM(1:LENL+13))
        CALL ARDBPB (IAMA,3,LABM(1:LENL+13))
        CALL ARDBPB (IAMA,5,LABM(1:LENL+13))
        CALL FRAME
C
C Done.
C
        RETURN
C
      END



      SUBROUTINE ARDBPB (IAMA,IGIP,LABL)
C
        DIMENSION IAMA(*)
C
        CHARACTER*(*) LABL
C
C This is a version of the AREAS routine ARDBPA that has been modified
C to use larger characters for the area identifiers and to omit edge
C segments that are too close to the edge of the plotter frame.  If
C the common block in AREAS is changed or if the structure of an area
C map is changed, this routine may need to be changed to match.
C
C ARCOMN contains variables which are used by all the AREAS routines.
C
        COMMON /ARCOMN/ IAD,IAU,ILC,RLC,ILM,RLM,ILP,RLP,IBS,RBS,DBS,IDB,
     +                  IDC,IDI,IRC(16),RLA,RWA,RDI,RSI
        SAVE   /ARCOMN/
C
C The common block ARCOM1 is used to communicate with the arrow-drawing
C routine ARDBDA.
C
        COMMON /ARCOM1/ DT
C
C Save the current state of the SET call and switch to the fractional
C coordinate system.
C
        CALL GETSET (XVPL,XVPR,YVPB,YVPT,XWDL,XWDR,YWDB,YWDT,LNLG)
        CALL    SET (  0.,  1.,  0.,  1.,  0.,  1.,  0.,  1.,   1)
C
C Put a label at the top of the plot.
C
        CALL PLCHLQ (.5,.98,LABL,.014,0.,0.)
C
C Trace the edges in the area map, drawing arrows as we go.
C
        DT=0.
        INDX=8
        RXCN=.5
        RYCN=.5
C
  101   RXCO=RXCN
        RYCO=RYCN
        RXCN=REAL(IAMA(INDX+1))/RLC
        RYCN=REAL(IAMA(INDX+2))/RLC
C
        IF (IAMA(INDX+7).NE.0) THEN
          IGID=ABS(IAMA(INDX+7))
          IF (IGID.LT.IAMA(6)) THEN
            IGID=IAMA(IAMA(1)-IGID)/2
          ELSE
            IGID=IAMA(IGID)/2
          END IF
          IF (IGID.EQ.IGIP) THEN
            IAIL=IAMA(INDX+8)
            IF (IAIL.GT.0) IAIL=IAMA(IAIL)/2
            IAIR=IAMA(INDX+9)
            IF (IAIR.GT.0) IAIR=IAMA(IAIR)/2
            CALL ARDBDA (RXCO,RYCO,RXCN,RYCN,IAIL,IAIR)
          END IF
        ELSE
          DT=0.
        END IF
C
        IF (IAMA(INDX+3).NE.0) THEN
          INDX=IAMA(INDX+3)
          GO TO 101
        END IF
C
C Restore the original SET call.
C
        CALL SET (XVPL,XVPR,YVPB,YVPT,XWDL,XWDR,YWDB,YWDT,LNLG)
C
C Done.
C
        RETURN
C
      END



      SUBROUTINE ARDBDA (X1,Y1,X2,Y2,IL,IR)
C
C The routine ARDBDA is called by ARDBPB, above, to draw an arrow from
C the point (X1,Y1) to the point (X2,Y2), in the fractional coordinate
C system.  The left and right area identifiers IL and IR are written
C in the proper positions relative to the arrow.  In order to prevent
C too many arrowheads from appearing, we keep track of the cumulative
C distance along edges being drawn (in DT).
C
        COMMON /ARCOM1/ DT
C
C Define character variables required to write the area identifiers.
C
        CHARACTER*6 CS
        CHARACTER*1 IC
C
C Define some temporary X and Y coordinate arrays, to be used in marking
C the head and tail of the arrow.
C
        DIMENSION TX(8),TY(8)
C
C If either end of the arrow is too close to the edge of the frame,
C don't draw anything.
C
        IF (X1.LT..05.OR.X1.GT..95) RETURN
        IF (Y1.LT..05.OR.Y1.GT..95) RETURN
        IF (X2.LT..05.OR.X2.GT..95) RETURN
        IF (Y2.LT..05.OR.Y2.GT..95) RETURN
C
C Draw the body of the arrow.
C
        CALL PLOTIF(X1,Y1,0)
        CALL PLOTIF(X2,Y2,1)
C
C Compute the length of the arrow.  If it's zero, quit.
C
        DX=X2-X1
        DY=Y2-Y1
        DP=SQRT(DX*DX+DY*DY)
C
        IF (DP.EQ.0.) RETURN
C
C If the area identifiers are in a reasonable range (less than 100,000
C in absolute value), write them on either side of the arrow.
C
        IF (ABS(IL).LT.100000.AND.ABS(IR).LT.100000) THEN
C
          XC=.5*(X1+X2)
          YC=.5*(Y1+Y2)
          XL=XC-.025*DY/DP
          YL=YC+.025*DX/DP
          WRITE (CS,'(I6)') IL
          NC=0
          DO 101 I=1,6
            IC=CS(I:I)
            IF (IC.NE.' ') THEN
              NC=NC+1
              CS(NC:NC)=IC
            END IF
  101     CONTINUE
          CALL PLCHLQ (XL,YL,CS(1:NC),.015,0.,0.)
C
          XR=XC+.025*DY/DP
          YR=YC-.025*DX/DP
          WRITE (CS,'(I6)') IR
          NC=0
          DO 102 I=1,6
            IC=CS(I:I)
            IF (IC.NE.' ') THEN
              NC=NC+1
              CS(NC:NC)=IC
            END IF
  102     CONTINUE
          CALL PLCHLQ (XR,YR,CS(1:NC),.015,0.,0.)
C
        END IF
C
C Put a dot at the tail of the arrow.  This will help identify arrows
C that are drawn tail-to-tail.
C
        TX(1)=X1-.0060
        TY(1)=Y1
        TX(2)=X1-.0042
        TY(2)=Y1+.0042
        TX(3)=X1
        TY(3)=Y1+.0060
        TX(4)=X1+.0042
        TY(4)=Y1+.0042
        TX(5)=X1+.0060
        TY(5)=Y1
        TX(6)=X1+.0042
        TY(6)=Y1-.0042
        TX(7)=X1
        TY(7)=Y1-.0060
        TX(8)=X1-.0042
        TY(8)=Y1-.0042
C
        CALL GSFACI (1)
        CALL GFA    (8,TX,TY)
C
C If the cumulative length of the edge being drawn is too little,
C quit ...
C
        DT=DT+DP
        IF(DT.LE..008) RETURN
C
C ... otherwise, zero the cumulative length ...
C
        DT=0.
C
C and draw an solid-filled arrowhead.
C
        B=(DP-.04)/DP
        A=1.0-B
        XT=A*X1+B*X2
        YT=A*Y1+B*Y2
        B=(DP-.015)/DP
        A=1.0-B
C
        TX(1)=X2
        TY(1)=Y2
        TX(2)=XT-.01*DY/DP
        TY(2)=YT+.01*DX/DP
        TX(3)=A*X1+B*X2
        TY(3)=A*Y1+B*Y2
        TX(4)=XT+.01*DY/DP
        TY(4)=YT-.01*DX/DP
C
        CALL GSFACI (1)
        CALL GFA    (4,TX,TY)
C
C Done.
C
        RETURN
C
      END



      SUBROUTINE COLRAM (XCRA,YCRA,NCRA,IAAI,IAGI,NGPS)
C
C This routine colors the areas defined by the area map.
C
        DIMENSION XCRA(*),YCRA(*),IAAI(*),IAGI(*)
C
C Pick off the individual group identifiers.
C
        IAI1=0
        IAI3=0
        IAI5=0
C
        DO 101 I=1,NGPS
          IF (IAGI(I).EQ.1) IAI1=IAAI(I)
          IF (IAGI(I).EQ.3) IAI3=IAAI(I)
          IF (IAGI(I).EQ.5) IAI5=IAAI(I)
  101   CONTINUE
C
C Skip coloring if either of the first two area identifiers is zero or
C negative or if the final one is negative.
C
        IF (IAI1.LE.0.OR.IAI3.LE.0.OR.IAI5.LT.0) GO TO 102
C
C Otherwise, color the area, using a color index which is obtained by
C combining the area identifiers for groups 1 and 3.
C
        CALL GSFACI (10*IAI1+IAI3)
        CALL GFA    (NCRA-1,XCRA,YCRA)
C
C Done.
C
  102   RETURN
C
      END

      PROGRAM AGEX01
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Define the data array.
C
      REAL YDRA(1001)
C
C Initialize GKS.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Fill the data array.
C
      DO 101 I=1,1001
        X=REAL(I)/20.
        YDRA(I)=10.*(X-1.)*(X-11.)*(X-21.)*(X-31.)*(X-41.)*
     +                             (X-51.)+2.E7*(FRAN()-.5)
  101 CONTINUE
C
C Draw a boundary around the edge of the plotter frame.
C
      CALL BNDARY
C
C Draw the graph, using EZY.
C
      CALL EZY (YDRA,1001,'EXAMPLE 1 (EZY)$')
C
C Close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
C
      END
      FUNCTION FRAN()
C
C Pseudo-random-number generator.
C
        DOUBLE PRECISION X
        SAVE X
        DATA X / 2.718281828459045D0 /
        X=MOD(9821.D0*X+.211327D0,1.D0)
        FRAN=REAL(X)
        RETURN
      END
      SUBROUTINE BNDARY
C
C Routine to draw the plotter-frame edge.
C
      CALL PLOTIT (    0,    0,0)
      CALL PLOTIT (32767,    0,1)
      CALL PLOTIT (32767,32767,1)
      CALL PLOTIT (    0,32767,1)
      CALL PLOTIT (    0,    0,1)
      RETURN
      END

C
C	$Id: pwt.f,v 1.6 2008-07-27 00:59:05 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE PWT(IOS,STATUS)
C
C  START UP THE CHARACTER WRITING SEQUENCE TO THE DEVICE
C
C  OUTPUT
C       IOS-IO STATUS VALID ONLY IF STATUS EQUALS AN I/O ERROR
C       STATUS-THE ERROR STATUS DEFINED BY COMMON TREROR
C
      COMMON/TREROR/ ALLOK, MFRCHK, MTOPER, METRDC, REDERR, TYPCHG
     1             ,INVTYP, MINVLD, TYPERR, FRMEND, ENCINT, IVDCDT
     2             ,GCOERR, GCRERR, GCCERR, FCOERR, FCRERR, FCCERR
     3             ,PLIDXG, PMIDXG, TXIDXG, PGIDXG, INVLMT, CELERR
     4             ,COIERR, COLNRM, UNKNOW, UNKOPC, ENDMTF, VNEROR
     5             ,BADRSZ, DEVOUT, NOVERS, BADFNT, PGMERR, FASERR
     6             ,HINERR, VDWERR, RDWERR, RIXLIM
      INTEGER        ALLOK, MFRCHK, MTOPER, METRDC, REDERR, TYPCHG
     1             ,INVTYP, MINVLD, TYPERR, FRMEND, ENCINT, IVDCDT
     2             ,GCOERR, GCRERR, GCCERR, FCOERR, FCRERR, FCCERR
     3             ,PLIDXG, PMIDXG, TXIDXG, PGIDXG, INVLMT, CELERR
     4             ,COIERR, COLNRM, UNKNOW, UNKOPC, ENDMTF, VNEROR
     5             ,BADRSZ, DEVOUT, NOVERS, BADFNT, PGMERR, FASERR
     6             ,HINERR, VDWERR, RDWERR, RIXLIM
      COMMON /PGKSCOM/ CLPDAT, CLPFLG, POLIDX, LINTYP, LINWTH, LINCOL,
     1                LINRGB, MARIDX, MARSIZ, MARCOL, MARRGB, TXTIDX,
     2                INTSTL, PATIDX, FILCOL, FILRGB, MARTYP, HORIZ ,
     3                VERT  , PATH  , CHIGHT, XU    , YU    , XB    ,
     4                YB    , TXTCOL, FINDEX, CEXPN , CSPACE, CURIDX,
     5                CURIMP, CURINT, COLMOD, FILIDX, TXTRGB, PROPN ,
     6                FIRSTX, FIRSTY, LASTX , LASTY , TRATIO, CBV   ,
     7                CUV   , CHP   , CVP   , CCSPAC, CHHORZ, CDV   ,
     8                PMRSIZ, CLPX  , CLPY  , CLPP  , DEFREP, DEFLEN,
     9                VDCECR, TRANVN, TXTPRE, HATIDX, FILRPT, ASFSRF,
     A                ASFSDF, MAPMOD, VERSOK, PCBFST, CPGLEN, CLPNUL,
     B                MTDLEN
      INTEGER         CMPMAX, ASFMAX
      PARAMETER      (CMPMAX=256    , ASFMAX=18)
      LOGICAL         CLPFLG, PROPN , CHHORZ, DEFREP, CLPNUL, MAPMOD,
     1                VERSOK, PCBFST
      REAL            LINWTH, MARSIZ, CEXPN , CSPACE, TRATIO, CBV(2),
     1                CUV(2), CDV(2), CCSPAC
      INTEGER         CLPDAT(4)     , POLIDX, LINTYP, LINCOL, LINRGB(3),
     1                MARIDX, MARCOL, MARRGB(3)     , TXTIDX, INTSTL,
     2                PATIDX, FILCOL, FILRGB(3)     , MARTYP, HORIZ ,
     3                VERT  , PATH  , XU    , YU    , XB    , YB    ,
     4                TXTCOL, FINDEX, CURIMP(CMPMAX), CURINT(CMPMAX*3),
     5                CHIGHT, COLMOD, FILIDX, TXTRGB(3)     , CURIDX,
     6                FIRSTX, FIRSTY, LASTX , LASTY , CHP   , CVP   ,
     7                PMRSIZ, CLPX  , CLPY  , CLPP  , DEFLEN, TRANVN,
     8                TXTPRE, HATIDX, FILRPT(2)     , VDCECR(4)     ,
     9                ASFSRF(ASFMAX), ASFSDF(ASFMAX), CPGLEN, MTDLEN
      COMMON /GKSCHR/ MTDESC
      CHARACTER*80    MTDESC
      COMMON /TRMTYP/ FOURBT, MULTBT, TWOBT, PTSFLG, CURCOL, IPWRIT,
     1                IFRAME, ISETOP, IRANG, IPTS, ICAS, IINT, IORNT,
     2                ISIZE, IFONT, IPAT, ISSIZ, ICENT, ICOLR,
     3                MCENT, MSIZE, MOR, OLDX, OLDY, MCASE, MINTEN,
     4                MFONT, MDASH, MSPOT, MCOLOR, MLIMIT, PTSYM,
     5                SAVX, SAVY
      INTEGER FOURBT, MULTBT, TWOBT, PTSFLG, CURCOL, IPWRIT,
     1                IFRAME, ISETOP, IRANG, IPTS, ICAS, IINT, IORNT,
     2                ISIZE, IFONT, IPAT, ISSIZ, ICENT, ICOLR,
     3                MCENT, MSIZE, MOR, OLDX, OLDY, MCASE, MINTEN,
     4                MFONT, MDASH, MSPOT, MCOLOR(3), MLIMIT(4), PTSYM,
     5                SAVX, SAVY
      COMMON /TRTYPE/ METMIN, METEXT, METPRT, METHED, MIOPCL, MXOPCL,
     1                MIOPID, MXOPID, ASCDEC, ASCHEX, ASCOCT, BINARY,
     2                GAHNOR, GALEFT, GACENT, GARITE, GAVNOR, GATOP ,
     3                GACAP , GAHALF, GABASE, GABOTT, GRIGHT, GLEFT ,
     4                GUP   ,
     5                GDOWN , CINDEX, CDIRCT, PENUP , PENDN , FLAGVL,
     6                SEPRVL, ASCTEK, TYPRGB, TYPBGR,
     7                TYPHLS, TYPMON, SOLID , DASHED, INVSBL, SOLPAT,
     8                ASFIND, ASFBND, ASFLNT, ASFLNW, ASFLNC, ASFMRT,
     9                ASFMRS, ASFMRC, ASFFIS, ASFFHI, ASFFPI, ASFFCO,
     A                ASFFPT, ASFFPW, ASFFPC, ASFTFI, ASFTPR, ASFTCX,
     B                ASFTCS, ASFTCO, ASCFLT, PHOLLO, PSOLID, PPATTR,
     C                PHATCH, PEMPTY, HHORIZ, HVERTI, HPOSLP, HNESLP,
     D                HHOAVE, HPOANE
      INTEGER         METMIN, METEXT, METPRT, METHED, MIOPCL, MXOPCL,
     1                MIOPID, MXOPID, ASCDEC, ASCHEX, ASCOCT, BINARY,
     2                GAHNOR, GALEFT, GACENT, GARITE, GAVNOR, GATOP ,
     3                GACAP , GAHALF, GABASE, GABOTT, GRIGHT, GLEFT ,
     4                GUP   ,
     5                GDOWN , CINDEX, CDIRCT, PENUP , PENDN , FLAGVL,
     6                SEPRVL, ASCTEK, TYPRGB, TYPBGR,
     7                TYPHLS, TYPMON, SOLID , DASHED, INVSBL, SOLPAT,
     8                ASFIND, ASFBND, ASFLNT, ASFLNW, ASFLNC, ASFMRT,
     9                ASFMRS, ASFMRC, ASFFIS, ASFFHI, ASFFPI, ASFFCO,
     A                ASFFPT, ASFFPW, ASFFPC, ASFTFI, ASFTPR, ASFTCX,
     B                ASFTCS, ASFTCO, ASCFLT, PHOLLO, PSOLID, PPATTR,
     C                PHATCH, PEMPTY, HHORIZ, HVERTI, HPOSLP, HNESLP,
     D                HHOAVE, HPOANE
      COMMON /TRINST/ OPCL, OPID, LEN, CONT
      INTEGER OPCL, OPID, LEN
      LOGICAL CONT
      COMMON /CAPFNT/ CHRSTR, CHREND, CHRWDT, CHRSCH, FNTRHT,
     1                FNTTOP, FNTCAP, FNTHLF, FNTBAS, FNTBOT,
     2                FNTTYP, FNTSCH, CORXST, CORXLN, CORYST,
     3                CORYLN, CORPST, CORPLN, PBEGST, PBEGLN,
     4                PENDST, PENDLN, CORSCH, NEWCLS, CPNTRS,
     5                CPNLST, CSTRKS
      INTEGER         CHRSM1, CHRSM2
      PARAMETER       (CHRSM1=128, CHRSM2=5121)
      INTEGER         CHRSTR, CHREND, CHRWDT,
     1                CHRSCH(11)    , FNTRHT, FNTTOP,
     2                FNTCAP, FNTHLF, FNTBAS, FNTBOT, FNTTYP,
     3                FNTSCH(9)     , CORXST, CORXLN,
     4                CORYST, CORYLN, CORPST, CORPLN,
     5                PBEGST, PBEGLN, PENDST, PENDLN,
     6                CORSCH(10)    ,
     7                NEWCLS(300)   ,
     8                CPNTRS(CHRSM1), CPNLST        ,
     9                CSTRKS(CHRSM2)
C
C  XLCN   --  Bit offset to extract X coordinates from fontcap.
C  YLCN   --  Bit offset to extract Y coordinates from fontcap.
C  PLCN   --  Bit offset to extract PEN control bit from fontcap.
C  FNTMAX --  Number of fonts obtained from FONT LIST (defaults to 1).
C  FNTS   --  An array of pointers associating indices obtained from
C             FONT INDEX elements with the internally supported fonts.
C             Consult the documentation in BLOCKDATA TRNDATX for a
C             list of supported fonts.
C  FLEFT  --  An array of character left values for proportionally
C             spaced fonts.
C  FRIGHT --  An array of character right values for proportionally
C             spaced fonts.
C  MXFLST --  The maximum number of strings accepted in a FONT LIST
C             element.
C  NSFNTS --  The number of distinct fonts supported internally.
C
      PARAMETER (NSFNTS=20,MXFLST=300)
      COMMON /FNTCOM/ XLCN  , YLCN  , PLCN  , FNTMAX,
     1                FNTS  , FLEFT , FRIGHT, SFLENS
      INTEGER         FLEFT(CHRSM1) , FRIGHT(CHRSM1), FNTS(MXFLST)  ,
     1                XLCN, YLCN    , PLCN  , FNTMAX
      CHARACTER*30 SFONTS(NSFNTS)
      COMMON /SUPFNT/ SFONTS
C
C  Size of common CAPFNT in words.
C
      INTEGER WRLEN
      PARAMETER (WRLEN=5600)
      COMMON /CAPLIN/ PLAVBL, LDSSTR, LDSSIZ, LDTSTR, LDTSIZ,
     1                LMSSTR, LMSSIZ, LMTSTR, LMTSIZ, LCSSTR,
     2                LCSSIZ, LCTSTR, LCTSIZ, LINFIN, LINFMT,
     3                LWSSTR, LWSSIZ, LWTSTR, LWTSIZ, LWTFIN,
     4                LWTFMT, LWTRNG, LWTSCF, LBSSTR, LBSSIZ,
     5                LBTSTR, LBTSIZ, LPSSTR, LPSSIZ, LPTSTR,
     6                LPTSIZ
      INTEGER         LDSMAX, LDTMAX, LMSMAX, LMTMAX, LCSMAX,
     1                LCTMAX, LVCFMX, LWSMAX, LWTMAX, LWTFMX,
     2                LBSMAX, LBTMAX, LPSMAX, LPTMAX
      PARAMETER   (LDSMAX=30, LDTMAX=15, LMSMAX=30, LMTMAX=15,
     1             LCSMAX=30, LCTMAX=15, LVCFMX=8,  LWSMAX=30,
     2             LWTMAX=15, LWTFMX=8 , LBSMAX=30, LBTMAX=15,
     3             LPSMAX=20, LPTMAX=20)
      INTEGER         LDSSTR(LDSMAX), LDSSIZ, LDTSTR(LDTMAX),
     1                LDTSIZ, LMSSTR(LMSMAX), LMSSIZ,
     2                LMTSTR(LMTMAX), LMTSIZ, LCSSTR(LCSMAX),
     3                LCSSIZ, LCTSTR(LCTMAX), LCTSIZ, LINFIN(8),
     4                LINFMT(LVCFMX,4)      , LWSSTR(LWSMAX),
     5                LWSSIZ, LWTSTR(LWTMAX), LWTSIZ, LWTFIN(8),
     6                LWTFMT(LWTFMX,4)      , LWTRNG(2)     ,
     7                LBSSTR(LBSMAX), LBSSIZ, LBTSTR(LBTMAX),
     8                LBTSIZ, LPSSTR(LPSMAX), LPSSIZ,
     9                LPTSTR(LPTMAX), LPTSIZ
      LOGICAL         PLAVBL
      REAL            LWTSCF,LINRIN(8),LWTRIN(8)
      INTEGER         LENLIN
      PARAMETER   (LENLIN=1+LDSMAX+1+LDTMAX+1+LMSMAX+1+
     1             LMTMAX+1+LCSMAX+1+LCTMAX+1+8+LVCFMX*4+
     2             LWSMAX+1+LWTMAX+1+8+LWTFMX*4+2+1+LBSMAX+
     3             1+LBTMAX+1+LPSMAX+1+LPTMAX+1)
      EQUIVALENCE (LINFIN,LINRIN), (LWTFIN,LWTRIN)
C
      INTEGER IOS, STATUS
      INTEGER K, CCOUNT, CBYTE, NULL, ICNT, STRX, STRY
      CHARACTER*300 TCHAR
      REAL DEGRAD,METCOR
C
C  256 CHARACTERS MAX ALLOWED
C
      INTEGER MXCH
      PARAMETER (MXCH=300)
      INTEGER ACHAR(MXCH)
      DATA NULL /0/
C
C  DEGREES TO RADIANS CONVERSION AND COORDINATE EXPANDER
C
      DATA DEGRAD,METCOR/.01745329,32767.0/
C
C  DEFINE INSTRUCTION COUNT DATA AND CHARACTER BYTE LENGTH
C
      DATA ICNT,CBYTE/8,8/
C
      STATUS = ALLOK
C
C  GET THE CHARACTER COUNT (NO ERROR CHECKING REQUIRED)
C
      CALL MNINST(ICNT,IOS,STATUS)
      CCOUNT = OPCL
      IF (CCOUNT.GT.MXCH) CCOUNT = MXCH
C
C  GET THE CHARACTER STRING
C
      DO 100 K=1,CCOUNT
        CALL MNINST(CBYTE,IOS,STATUS)
        ACHAR(K) = OPCL
        IF (STATUS.NE.ALLOK) RETURN
C
 100  CONTINUE
C
C  TEST IF ANOTHER READ NEEDED TO GET TO A 16 BIT BOUNDARY
C
      IF (0 .NE. MOD(CCOUNT,2)) CALL MNINST(CBYTE,IOS,STATUS)
C
C  GET THE COORDINATE LOCATION FOR THE STRING
C       DO NOT PASS THE COMMON VALUES BECAUSE THEY ARE RESET BY PLTIT
C
      STRX = OLDX
      STRY = OLDY
C
      CALL GSTXFP(MFONT,2)
      TCHAR = ' '
      DO 130 I=1,CCOUNT
      TCHAR(I:I) = CHAR(ACHAR(I))
  130 CONTINUE
      CALL PLOTIT(0,0,2)
      CALL WTSTR(FLOAT(STRX)/32767.,FLOAT(STRY)/32767.,
     -           TCHAR(1:CCOUNT),MSIZE/32,MOR,MCENT-1)
C
      RETURN
      END

      subroutine  cscal(n,ca,cx,incx)
c
c     scales a vector by a constant.
c     jack dongarra, linpack,  3/11/78.
c     modified 3/93 to return if incx .le. 0.
c     modified 12/3/93, array(1) declarations changed to array(*)
c
      complex ca,cx(*)
      integer i,incx,n,nincx
c
      if( n.le.0 .or. incx.le.0 )return
      if(incx.eq.1)go to 20
c
c        code for increment not equal to 1
c
      nincx = n*incx
      do 10 i = 1,nincx,incx
        cx(i) = ca*cx(i)
   10 continue
      return
c
c        code for increment equal to 1
c
   20 do 30 i = 1,n
        cx(i) = ca*cx(i)
   30 continue
      return
      end

C
C $Id: plchmq.f,v 1.15 2008-07-27 00:17:20 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE PLCHMQ (XPOS,YPOS,CHRS,SIZE,ANGD,CNTR)
C
C This is the medium-quality character-drawing routine.
C
C
C D E C L A R A T I O N S
C
C
      CHARACTER*(*) CHRS
C
C The COMMON block PCPFLQ contains internal parameters that affect the
C behavior of routines besides PLCHHQ.
C
      COMMON /PCPFLQ/ IMAP,OORV,RHTW
      SAVE   /PCPFLQ/
C
C Define an array in which to declare the 94 legal characters.
C
      CHARACTER*1 LCHR(94)
C
C Define arrays in which to declare the pointers into the digitization
C arrays and the digitizations themselves.
C
      DIMENSION INDX(94),KXCO(857),KYCO(857)
C
C Three internal variables are subject to change and need to be saved
C from each call to the next.
C
      SAVE INIT,LCHR,INDX
C
C The following DATA statements associate each character with an index
C in the digitization arrays.  For example, the digitization for the
C character A starts at KXCO(328) and KYCO(328), while that for a B
C starts at KXCO(336) and KYCO(336).
C
      DATA (LCHR(I),I=  1, 94) /
     O                         '!','"','#','$','%','&','''','(',')','*',
     1                         '+',',','-','.','/','0','1','2','3','4',
     2                         '5','6','7','8','9',':',';','<','=','>',
     3                         '?','@','A','B','C','D','E','F','G','H',
     4                         'I','J','K','L','M','N','O','P','Q','R',
     5                         'S','T','U','V','W','X','Y','Z','[','\\',
     6                         ']','^','_','`','a','b','c','d','e','f',
     7                         'g','h','i','j','k','l','m','n','o','p',
     8                         'q','r','s','t','u','v','w','x','y','z',
     9                         '{','|','}','~'                        /
C
      DATA (INDX(I),I=  1, 94) /
     O                           1, 11, 23, 35, 51, 74, 87, 93,100,107,
     1                         116,122,129,132,139,142,155,159,168,183,
     2                         193,203,215,219,238,250,264,278,282,288,
     3                         292,308,328,336,350,359,367,377,386,399,
     4                         408,417,423,432,436,442,447,457,465,478,
     5                         489,502,508,515,519,525,531,538,543,548,
     6                         551,556,560,563,566,581,593,602,614,625,
     7                         634,649,658,669,683,692,697,712,721,731,
     8                         743,755,763,776,785,794,798,804,810,816,
     9                         821,833,839,851                        /
C
C The following DATA statements define the character digitizations.
C Each character is digitized in a box which is basically 60 units
C wide by 70 units tall.  The width includes 20 units of white space
C along the right edge of the character.  A few characters dip below
C the bottom of the box.  Vertical spacing is intended to be 120 units.
C If KXCO(I) = 77, KYCO(I) is a flag:  KYCO(I) = 0 means that the next
C delared move is pen-up (all others are pen-down), and KYCO(I)=77
C signals the end of the digitization for a given character.
C
C Note:  KYCO(151) changed from 0 to 77 to remove slash from zero.  DJK
C (3/11/88).
C
      DATA (KXCO(I),I=  1,100) /
     O                          21, 21, 77, 19, 19, 24, 24, 19, 24, 77,
     1                           9,  9, 77,  9,  9, 77, 31, 31, 77, 31,
     2                          31, 77, 14,  9, 77, 26, 31, 77, 40,  5,
     3                          77,  0, 35, 77, 19, 19, 77,  0,  9, 28,
     4                          38, 38, 28,  9,  0,  0,  9, 28, 38, 77,
     5                          12,  5,  0,  0,  5, 12, 16, 16, 12, 77,
     6                          40,  0, 77, 24, 24, 28, 35, 40, 40, 35,
     7                          28, 24, 77, 40,  5,  5,  9, 16, 21, 21,
     8                           0,  0,  7, 24, 40, 77, 19, 16, 19, 21,
     9                          19, 77, 24, 19, 16, 16, 19, 24, 77, 16/
      DATA (KYCO(I),I=  1,100) /
     O                          70, 21,  0,  3, -3, -3,  3,  3, -3, 77,
     1                          70, 60,  0, 60, 70,  0, 70, 60,  0, 60,
     2                          70, 77, 65, 26,  0, 26, 65,  0, 54, 54,
     3                           0, 36, 36, 77, 70,  0,  0, 16,  5,  5,
     4                          13, 26, 36, 36, 44, 54, 65, 65, 54, 77,
     5                          70, 70, 65, 57, 52, 52, 57, 65, 70,  0,
     6                          70,  0,  0, 13,  5,  0,  0,  5, 13, 18,
     7                          18, 13, 77,  0, 52, 62, 70, 70, 62, 54,
     8                          23, 10,  0,  0, 23, 77, 70, 60, 60, 70,
     9                          70, 77, 70, 60, 47, 23, 10,  0, 77, 70/
      DATA (KXCO(I),I=101,200) /
     O                          21, 24, 24, 21, 16, 77,  0, 38, 77, 19,
     1                          19, 77,  0, 38, 77, 19, 19, 77,  0, 38,
     2                          77, 16, 19, 19, 16, 16, 19, 77,  0, 38,
     3                          77, 19, 19, 24, 24, 19, 24, 77,  0, 40,
     4                          77, 12,  0,  0, 12, 28, 40, 40, 28, 12,
     5                          77, 40,  0, 77,  5, 21, 21, 77,  0,  9,
     6                          31, 40, 40,  0,  0, 40, 77,  0, 12, 28,
     7                          40, 40, 28, 19, 77, 28, 40, 40, 28, 12,
     8                           0, 77, 31, 31, 26,  0,  0, 31, 77, 31,
     9                          40, 77,  2, 28, 40, 40, 28, 12,  0,  0/
      DATA (KYCO(I),I=101,200) /
     O                          60, 47, 23, 10,  0, 77, 54, 16,  0, 62,
     1                           8,  0, 16, 54, 77, 52, 10,  0, 31, 31,
     2                          77,-10, -5,  3,  3,  0,  0, 77, 31, 31,
     3                          77,  3, -3, -3,  3,  3, -3, 77,  0, 70,
     4                          77, 70, 54, 16,  0,  0, 16, 54, 70, 70,
     5                          77, 70,  0, 77, 54, 70,  0, 77, 60, 70,
     6                          70, 60, 39, 10,  0,  0, 77, 60, 70, 70,
     7                          60, 47, 36, 36,  0, 36, 26, 10,  0,  0,
     8                          13, 77,  0, 70, 70, 23, 18, 18,  0, 18,
     9                          18, 77,  0,  0, 13, 31, 44, 44, 34, 70/
      DATA (KXCO(I),I=201,300) /
     O                          40, 77,  0, 12, 28, 40, 40, 28, 12,  0,
     1                           0,  2, 21, 77,  0, 40, 12, 77,  9,  0,
     2                           0,  9,  0,  0,  9, 31, 40, 40, 31,  9,
     3                          77, 31, 40, 40, 31,  9, 77, 21, 38, 40,
     4                          40, 28, 12,  0,  0, 12, 28, 40, 77, 19,
     5                          24, 24, 19, 19, 24, 77, 19, 19, 24, 24,
     6                          19, 24, 77, 19, 24, 24, 19, 19, 24, 77,
     7                          19, 21, 21, 19, 19, 21, 77, 33,  2, 33,
     8                          77, 38,  2, 77,  2, 38, 77,  2, 33,  2,
     9                          77,  5,  5, 12, 24, 33, 33, 16, 16, 77/
      DATA (KYCO(I),I=201,300) /
     O                          70, 77, 29, 41, 41, 29, 13,  0,  0, 13,
     1                          29, 49, 70, 77, 70, 70,  0, 77, 70, 60,
     2                          47, 36, 26, 10,  0,  0, 10, 26, 36, 36,
     3                           0, 36, 47, 60, 70, 70, 77,  0, 21, 41,
     4                          57, 70, 70, 57, 41, 29, 29, 41, 77, 31,
     5                          31, 26, 26, 31, 26,  0, 16, 10, 10, 16,
     6                          16, 10, 77, 31, 31, 26, 26, 31, 26,  0,
     7                           3,  8, 16, 16, 13, 13, 77, 52, 31, 10,
     8                          77, 41, 41,  0, 21, 21, 77, 52, 31, 10,
     9                          77, 54, 62, 70, 67, 60, 47, 29, 18,  0/
      DATA (KXCO(I),I=301,400) /
     O                          16, 16, 21, 21, 16, 21, 77, 31,  9,  0,
     1                           0,  9, 31, 40, 40, 35, 31, 28, 28, 24,
     2                          16, 12, 12, 16, 24, 28, 77,  0, 14, 24,
     3                          38, 77,  5, 33, 77,  0, 31, 40, 40, 31,
     4                           0, 77, 31, 40, 40, 31,  0,  0, 77, 40,
     5                          28, 12,  0,  0, 12, 28, 40, 77,  0, 28,
     6                          40, 40, 28,  0,  0, 77,  0,  0, 40, 77,
     7                           0, 26, 77,  0, 40, 77,  0,  0, 77,  0,
     8                          26, 77,  0, 40, 77, 24, 40, 40, 77, 40,
     9                          28, 12,  0,  0, 12, 28, 40, 77,  0,  0/
      DATA (KYCO(I),I=301,400) /
     O                           3, -3, -3,  3,  3, -3, 77, 10, 10, 21,
     1                          49, 60, 60, 49, 29, 23, 23, 29, 39, 47,
     2                          47, 39, 29, 23, 23, 29, 77,  0, 70, 70,
     3                           0,  0, 26, 26, 77, 70, 70, 60, 47, 36,
     4                          36,  0, 36, 26, 10,  0,  0, 70, 77, 13,
     5                           0,  0, 13, 57, 70, 70, 57, 77, 70, 70,
     6                          57, 13,  0,  0, 70, 77, 70,  0,  0,  0,
     7                          36, 36,  0, 70, 70, 77, 70,  0,  0, 36,
     8                          36,  0, 70, 70, 77, 26, 26,  0,  0, 13,
     9                           0,  0, 13, 57, 70, 70, 57, 77, 70,  0/
      DATA (KXCO(I),I=401,500) /
     O                          77,  0, 40, 77, 40, 40, 77,  7, 31, 77,
     1                          19, 19, 77,  9, 31, 77,  0, 12, 26, 38,
     2                          38, 77,  0,  0, 77, 40, 12, 77,  0, 40,
     3                          77,  0,  0, 40, 77,  0,  0, 19, 38, 38,
     4                          77,  0,  0, 40, 40, 77,  0, 12, 28, 40,
     5                          40, 28, 12,  0,  0, 77,  0,  0, 31, 40,
     6                          40, 31,  0, 77,  0,  0, 12, 28, 40, 40,
     7                          28, 12,  0, 77, 16, 40, 77,  0,  0, 31,
     8                          40, 40, 31,  0, 77, 31, 40, 77,  0,  9,
     9                          31, 40, 40, 31,  9,  0,  0,  9, 31, 40/
      DATA (KYCO(I),I=401,500) /
     O                           0, 34, 34,  0,  0, 70, 77, 70, 70,  0,
     1                          70,  0,  0,  0,  0, 77, 13,  0,  0, 13,
     2                          70, 77, 70,  0,  0,  0, 39,  0, 26, 70,
     3                          77, 70,  0,  0, 77,  0, 70, 34, 70,  0,
     4                          77,  0, 70,  0, 70, 77, 57, 70, 70, 57,
     5                          13,  0,  0, 13, 57, 77,  0, 70, 70, 60,
     6                          41, 31, 31, 77, 57, 13,  0,  0, 13, 57,
     7                          70, 70, 57,  0, 41,-10, 77,  0, 70, 70,
     8                          60, 44, 36, 36,  0, 36,  0, 77, 10,  0,
     9                           0, 10, 23, 34, 36, 47, 60, 70, 70, 60/
      DATA (KXCO(I),I=501,600) /
     O                          77, 21, 21, 77,  0, 42, 77,  0,  0, 12,
     1                          28, 40, 40, 77,  0, 19, 38, 77,  0,  9,
     2                          21, 33, 42, 77,  0, 40, 77,  0, 40, 77,
     3                           0, 19, 19, 77, 19, 38, 77,  0, 40,  0,
     4                          40, 77, 26, 14, 14, 26, 77,  0, 40, 77,
     5                          12, 24, 24, 12, 77,  7, 19, 31, 77, -2,
     6                          42, 77, 16, 21, 77,  9, 24, 31, 31, 21,
     7                           9,  0,  0,  7, 24, 31, 77, 31, 40, 77,
     8                           0,  0, 77,  0,  9, 26, 35, 35, 26,  9,
     9                           0, 77, 33, 26,  9,  0,  0,  9, 26, 33/
      DATA (KYCO(I),I=501,600) /
     O                          77,  0, 70,  0, 70, 70, 77, 70, 13,  0,
     1                           0, 13, 70, 77, 70,  0, 70, 77, 70,  0,
     2                          34,  0, 70, 77, 70,  0,  0,  0, 70, 77,
     3                          70, 39,  0,  0, 39, 70, 77, 70, 70,  0,
     4                           0, 77, 75, 75, -3, -3, 77, 70,  0, 77,
     5                          75, 75, -3, -3, 77, 62, 70, 62, 77,-13,
     6                         -13, 77, 70, 54, 77, 49, 49, 39, 10,  0,
     7                           0, 10, 21, 31, 31, 26,  0, 10,  0, 77,
     8                          70,  0,  0, 10,  0,  0, 10, 29, 39, 39,
     9                          29, 77, 34, 39, 39, 29, 10,  0,  0,  5/
      DATA (KXCO(I),I=601,700) /
     O                          77, 35, 26,  9,  0,  0,  9, 26, 35, 77,
     1                          35, 35, 77,  0, 35, 35, 26,  9,  0,  0,
     2                           9, 26, 35, 77,  5, 31, 77, 14, 14, 21,
     3                          31, 35, 77,  0,  9, 26, 35, 35, 77, 35,
     4                          26,  9,  0,  0,  9, 26, 35, 77,  0,  0,
     5                          77,  0,  9, 26, 35, 35, 77, 16, 16, 21,
     6                          21, 16, 21, 77, 16, 19, 19, 77, 16, 16,
     7                          21, 21, 16, 21, 77, 16, 19, 19, 14,  7,
     8                           2, 77,  0,  0, 77,  0, 28, 77,  9, 35,
     9                          77, 14, 19, 19, 24, 77,  0,  0, 77, 19/
      DATA (KYCO(I),I=601,700) /
     O                          77, 29, 39, 39, 29, 10,  0,  0, 10,  0,
     1                           0, 70, 77, 21, 21, 29, 39, 39, 29, 10,
     2                           0,  0,  8, 77, 41, 41,  0,  0, 57, 65,
     3                          65, 60, 77,-13,-21,-21,-10, 39,  0, 29,
     4                          39, 39, 29, 10,  0,  0, 10, 77, 70,  0,
     5                           0, 29, 39, 39, 29,  0, 77, 54, 49, 49,
     6                          54, 54, 49,  0, 34, 34,  0, 77, 54, 49,
     7                          49, 54, 54, 49,  0, 34, 34,-16,-21,-21,
     8                         -16, 77, 70,  0,  0, 31, 47,  0, 36,  0,
     9                          77, 70, 65,  5,  0, 77, 39,  0,  0,  0/
      DATA (KXCO(I),I=701,800) /
     O                          19, 77,  0,  7, 14, 19, 24, 31, 38, 38,
     1                          77,  0,  0, 77,  0,  9, 26, 35, 35, 77,
     2                           0,  0,  9, 26, 35, 35, 26,  9,  0, 77,
     3                           0,  0, 77,  0,  9, 26, 35, 35, 26,  9,
     4                           0, 77, 35, 35, 77, 35, 26,  9,  0,  0,
     5                           9, 26, 35, 77,  0,  0, 77,  0,  9, 26,
     6                          35, 77,  0,  9, 26, 35, 35, 26,  9,  0,
     7                           0,  9, 26, 33, 77,  7, 31, 77, 33, 28,
     8                          21, 16, 16, 77,  0,  0,  9, 26, 35, 77,
     9                          35, 35, 77,  2, 19, 35, 77,  0,  9, 19/
      DATA (KYCO(I),I=701,800) /
     O                          31,  0, 31, 39, 39, 31, 39, 39, 31,  0,
     1                          77, 39,  0,  0, 29, 39, 39, 29,  0, 77,
     2                          29, 10,  0,  0, 10, 29, 39, 39, 29, 77,
     3                          39,-21,  0, 29, 39, 39, 29, 10,  0,  0,
     4                          10, 77, 39,-21,  0, 10,  0,  0, 10, 29,
     5                          39, 39, 29, 77, 39,  0,  0, 29, 39, 39,
     6                          31, 77,  5,  0,  0,  5, 16, 21, 21, 26,
     7                          34, 39, 39, 34, 77, 39, 39,  0,  5,  0,
     8                           0,  5, 65, 77, 39, 10,  0,  0, 10,  0,
     9                           0, 39, 77, 39,  0, 39, 77, 39,  0, 34/
      DATA (KXCO(I),I=801,857) /
     O                          28, 38, 77,  2, 35, 77,  2, 35, 77,  0,
     1                          19, 77,  9, 38, 77,  2, 35,  2, 35, 77,
     2                          26, 21, 16, 16, 14,  9, 14, 16, 16, 21,
     3                          26, 77, 19, 19, 77, 19, 19, 77, 14, 19,
     4                          24, 24, 26, 31, 26, 24, 24, 19, 14, 77,
     5                           0,  7, 14, 26, 33, 40, 77            /
      DATA (KYCO(I),I=801,857) /
     O                           0, 39, 77, 39,  0,  0,  0, 39, 77, 39,
     1                           0,  0,-21, 39, 77, 39, 39,  0,  0, 77,
     2                          75, 75, 67, 44, 39, 36, 34, 29,  3, -3,
     3                          -3, 77, 70, 44,  0, 26,  0, 77, 75, 75,
     4                          67, 44, 39, 36, 34, 29,  3, -3, -3, 77,
     5                          29, 36, 36, 23, 23, 31, 77            /
C
C INIT is 0 if this is the first call to PLCHMQ, 1 otherwise.
C
      DATA INIT / 0 /
C
C NLCH is the length of LCHR and INDX.
C
      DATA NLCH / 94 /
C
C WIDE and HIGH are the digitized width and height of the characters;
C WIDE includes white space on the right edge, the width of which is
C WHTE.
C
      DATA WIDE,HIGH,WHTE / 60.,70.,20. /
C
C
C I N I T I A L I Z A T I O N
C
C
C Do a call forcing a BLOCKDATA to be loaded from a binary library.
C
      CALL PCBLDA
C
C Check for an uncleared prior error.
C
      IF (ICFELL('PLCHMQ - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C On the first call to PLCHMQ, sort LCHR, maintaining its relationship
C with INDX.  (For example, after sorting, if LCHR(I)='B', INDX(I)=336.)
C The sorting makes it possible to locate characters quickly.
C
      IF (INIT.EQ.0) THEN
        INIT=1
        CALL PCSORT (LCHR,INDX,NLCH)
      END IF
C
C Find the length of the string and, if it's zero, quit.
C
      NCHR=LEN(CHRS)
      IF (NCHR.LE.0) RETURN
C
C Get the fractional coordinates of the reference point.
C
      IF (IMAP.LE.0) THEN
        XFRA=CUFX(XPOS)
        IF (ICFELL('PLCHMQ',2).NE.0) RETURN
        YFRA=CUFY(YPOS)
        IF (ICFELL('PLCHMQ',3).NE.0) RETURN
      ELSE
        XFRA=XPOS
        YFRA=YPOS
      END IF
C
C Determine the resolution of the plotter, as declared by default or
C by the user.
C
      CALL GETUSV ('XF',IRSX)
      IF (ICFELL('PLCHMQ',4).NE.0) RETURN
      RSLN=2.**IRSX-1.
C
C Determine a multiplier for the digitized size which will make the
C characters have the size requested by the user.  First, compute the
C same multiplier we would use for PLCHHQ (except for the adjustment
C factor SIZA) ...
C
      IF (IMAP.LE.0) THEN
        IF (SIZE.LE.0.) THEN
          SIZM=ABS(SIZE)/1023.
        ELSE IF (SIZE.LT.1.) THEN
          SIZM=SIZE/16.
        ELSE
          SIZM=(SIZE/RSLN)/16.
        END IF
      ELSE
        SIZM=SIZE/16.
      END IF
C
C ... and then adjust for the fact that the digitization is different.
C
      SIZM=16.*SIZM/WIDE
C
C Compute the orientation angle, in radians, and the magnitudes of the
C X and Y components of a vector at that angle with magnitude SIZM.
C
      ANGR=.017453292519943*ANGD
C
      XCOV=SIZM*COS(ANGR)
      YCOV=SIZM*SIN(ANGR)
C
C Compute a multiplier for the digitized y coordinates that will make
C the height come out right.
C
      YMLT=ABS(RHTW)/1.75
C
C Find the fractional coordinates for the beginning of the string.  We
C must take into account the fact that each character is digitized with
C (0,0) at the lower left-hand corner of the character.  We must also
C take into account the user's centering option.
C
      XLLC=XFRA+.5*HIGH*YMLT*YCOV
     +                         -.5*(CNTR+1.)*(REAL(NCHR)*WIDE-WHTE)*XCOV
      YLLC=YFRA-.5*HIGH*YMLT*XCOV
     +                         -.5*(CNTR+1.)*(REAL(NCHR)*WIDE-WHTE)*YCOV
C
C
C C H A R A C T E R   L O O P
C
C
C Loop through all the characters in the input string.
C
      DO 107 ICHR=1,NCHR
C
C If the character is not a blank, get a pointer to the beginning of
C its digitization.
C
        IPNT=0
        IF (CHRS(ICHR:ICHR).NE.' ')
     +                 CALL PCGPTR (CHRS(ICHR:ICHR),LCHR,INDX,NLCH,IPNT)
C
C Once we've got a valid pointer, stroke out the character it points to.
C The pen starts out "up".  If mapping is turned on and an out-of-range
C value is defined, initialize a visibility flag and X and Y coordinates
C of a "new" point.
C
        IF (IPNT.GT.0) THEN
C
          IPNT=IPNT-1
          IPEN=0
C
          IF (IMAP.GT.0.AND.OORV.NE.0.) THEN
            IVSN=0
            XNEW=0.
            YNEW=0.
          END IF
C
C Advance to the next digitization pair.
C
  101     IPNT=IPNT+1
C
C Check for an X/Y coordinate pair (as opposed to an op code).
C
          IF (KXCO(IPNT).NE.77) THEN
C
C Process an X/Y coordinate pair.  See if mapping is off or on.
C
            IF (IMAP.LE.0) THEN
C
C Mapping is turned off; just compute the appropriate fractional
C coordinates and use the SPPS routine PLOTIF.
C
              CALL PLOTIF (XLLC+REAL(KXCO(IPNT))*XCOV-
     +                     YMLT*REAL(KYCO(IPNT))*YCOV,
     +                     YLLC+REAL(KXCO(IPNT))*YCOV+
     +                     YMLT*REAL(KYCO(IPNT))*XCOV,IPEN)
              IF (ICFELL('PLCHMQ',5).NE.0) RETURN
C
            ELSE
C
C Mapping is turned on.  If the pen is up, just move to the current
C point.  If the pen is down and the current point is too far from the
C last one, arrange to generate some points in between.
C
              IF (IPEN.EQ.0) THEN
                XTMB=0.
                YTMB=0.
                NINT=1
              ELSE
                XTMB=REAL(KXCO(IPNT-1))
                YTMB=REAL(KYCO(IPNT-1))
                NINT=MAX(1,ABS(KXCO(IPNT)-KXCO(IPNT-1))/7,
     +                     ABS(KYCO(IPNT)-KYCO(IPNT-1))/7)
              END IF
C
              XTME=REAL(KXCO(IPNT))
              YTME=REAL(KYCO(IPNT))
C
C Begin interpolation loop.
C
              DO 106 IINT=1,NINT
C
C Interpolate to get an X/Y position.
C
                P=REAL(NINT-IINT)/REAL(NINT)
C
                XTMI=P*XTMB+(1.-P)*XTME
                YTMI=P*YTMB+(1.-P)*YTME
C
C Check whether an out-of-range value is defined or not.
C
                IF (OORV.EQ.0.) THEN
C
C No out-of-range value is defined; do the mapping, transform to the
C fractional system, and use PLOTIF.
C
                  CALL PCMPXY (IMAP,XLLC+XTMI*XCOV-YMLT*YTMI*YCOV,
     +                              YLLC+XTMI*YCOV+YMLT*YTMI*XCOV,
     +                                                  XTMP,YTMP)
                  IF (ICFELL('PLCHMQ',6).NE.0) RETURN
                  XPEN=CUFX(XTMP)
                  IF (ICFELL('PLCHMQ',7).NE.0) RETURN
                  YPEN=CUFY(YTMP)
                  IF (ICFELL('PLCHMQ',8).NE.0) RETURN
                  CALL PLOTIF (XPEN,YPEN,IPEN)
                  IF (ICFELL('PLCHMQ',9).NE.0) RETURN
C
                ELSE
C
C An out-of-range value is defined; we have to cope with the fact that
C some points may disappear under the given mapping.
C
C The new point becomes the old point.
C
                  IVSO=IVSN
                  XOLD=XNEW
                  YOLD=YNEW
C
C Compute the coordinates and the visibility flag for the new point.
C
                  XNEW=XLLC+XTMI*XCOV-YMLT*YTMI*YCOV
                  YNEW=YLLC+XTMI*YCOV+YMLT*YTMI*XCOV
C
                  CALL PCMPXY (IMAP,XNEW,YNEW,XTMP,YTMP)
                  IF (ICFELL('PLCHMQ',10).NE.0) RETURN
C
                  IF (XTMP.EQ.OORV) THEN
                    IVSN=0
                  ELSE
                    IVSN=1
                  END IF
C
C Process the various combinations of old-point/new-point visibility.
C
                  IF (IVSO.EQ.0.AND.IVSN.NE.0) THEN
C
C The old point was invisible and the new one is visible.  If the line
C segment between them is supposed to be drawn, use a binary-halving
C process to find a point at the edge of the visible area and start
C drawing there.  In any case, leave the pen down at the position of
C the new point.
C
                    IF (IPEN.NE.0) THEN
                      XINV=XOLD
                      YINV=YOLD
                      XVIS=XNEW
                      YVIS=YNEW
                      DO 102 IHLF=1,64
                        XHLF=.5*(XINV+XVIS)
                        YHLF=.5*(YINV+YVIS)
                        CALL PCMPXY (IMAP,XHLF,YHLF,XTMP,YTMP)
                        IF (ICFELL('PLCHMQ',11).NE.0) RETURN
                        IF (XTMP.EQ.OORV) THEN
                          IF (XHLF.EQ.XINV.AND.YHLF.EQ.YINV) GO TO 103
                          XINV=XHLF
                          YINV=YHLF
                        ELSE
                          IF (XHLF.EQ.XVIS.AND.YHLF.EQ.YVIS) GO TO 103
                          XVIS=XHLF
                          YVIS=YHLF
                        END IF
  102                 CONTINUE
  103                 CALL PCMPXY (IMAP,XVIS,YVIS,XTMP,YTMP)
                      IF (ICFELL('PLCHMQ',12).NE.0) RETURN
                      XPEN=CUFX(XTMP)
                      IF (ICFELL('PLCHMQ',13).NE.0) RETURN
                      YPEN=CUFY(YTMP)
                      IF (ICFELL('PLCHMQ',14).NE.0) RETURN
                      CALL PLOTIF (XPEN,YPEN,0)
                    END IF
C
                    CALL PCMPXY (IMAP,XNEW,YNEW,XTMP,YTMP)
                    IF (ICFELL('PLCHMQ',15).NE.0) RETURN
                    XPEN=CUFX(XTMP)
                    IF (ICFELL('PLCHMQ',16).NE.0) RETURN
                    YPEN=CUFY(YTMP)
                    IF (ICFELL('PLCHMQ',17).NE.0) RETURN
                    CALL PLOTIF (XPEN,YPEN,IPEN)
                    IF (ICFELL('PLCHMQ',18).NE.0) RETURN
C
C Check for the next combination.
C
                  ELSE IF (IVSO.NE.0.AND.IVSN.EQ.0) THEN
C
C The old point was visible and the new one is not.  If the line segment
C between them is supposed to be drawn, use a binary-halving process to
C find out where the line segment disappears and extend it to there.
C
                    IF (IPEN.NE.0) THEN
                      XVIS=XOLD
                      YVIS=YOLD
                      XINV=XNEW
                      YINV=YNEW
                      DO 104 IHLF=1,64
                        XHLF=.5*(XINV+XVIS)
                        YHLF=.5*(YINV+YVIS)
                        CALL PCMPXY (IMAP,XHLF,YHLF,XTMP,YTMP)
                        IF (ICFELL('PLCHMQ',19).NE.0) RETURN
                        IF (XTMP.EQ.OORV) THEN
                          IF (XHLF.EQ.XINV.AND.YHLF.EQ.YINV) GO TO 105
                          XINV=XHLF
                          YINV=YHLF
                        ELSE
                          IF (XHLF.EQ.XVIS.AND.YHLF.EQ.YVIS) GO TO 105
                          XVIS=XHLF
                          YVIS=YHLF
                        END IF
  104                 CONTINUE
  105                 CALL PCMPXY (IMAP,XVIS,YVIS,XTMP,YTMP)
                      IF (ICFELL('PLCHMQ',20).NE.0) RETURN
                      XPEN=CUFX(XTMP)
                      IF (ICFELL('PLCHMQ',21).NE.0) RETURN
                      YPEN=CUFY(YTMP)
                      IF (ICFELL('PLCHMQ',22).NE.0) RETURN
                      CALL PLOTIF (XPEN,YPEN,1)
                      IF (ICFELL('PLCHMQ',23).NE.0) RETURN
                    END IF
C
C Check for the next combination.
C
                  ELSE IF (IVSO.NE.0.AND.IVSN.NE.0) THEN
C
C The old and new points are both visible.  An easy case.
C
                    CALL PCMPXY (IMAP,XNEW,YNEW,XTMP,YTMP)
                    IF (ICFELL('PLCHMQ',24).NE.0) RETURN
                    XPEN=CUFX(XTMP)
                    IF (ICFELL('PLCHMQ',25).NE.0) RETURN
                    YPEN=CUFY(YTMP)
                    IF (ICFELL('PLCHMQ',26).NE.0) RETURN
                    CALL PLOTIF (XPEN,YPEN,IPEN)
                    IF (ICFELL('PLCHMQ',27).NE.0) RETURN
C
C End of checks for different combinations.
C
                  END IF
C
C End of check for out-of-range value defined.
C
                END IF
C
C End of interpolation loop.
C
  106         CONTINUE
C
C End of processing of X/Y coordinate pair.
C
            END IF
C
C The pen goes down for the next point.
C
            IPEN=1
C
C Go back for the next digitization pair.
C
            GO TO 101
C
          ELSE
C
C Process an "op-code", which may either force the pen up or stop us.
C
            IF (KYCO(IPNT).NE.77) THEN
              IPEN=0
              GO TO 101
            END IF
C
          END IF
C
        END IF
C
C Move to the lower left-hand corner of the next character.
C
          XLLC=XLLC+60.*XCOV
          YLLC=YLLC+60.*YCOV
C
  107 CONTINUE
C
C Flush the buffer in PLOTIF.
C
      CALL PLOTIF (0.,0.,2)
      IF (ICFELL('PLCHMQ',28).NE.0) RETURN
C
C Done.
C
      RETURN
C
      END

C
C	$Id: lincls.f,v 1.4 2008-07-27 12:23:44 haley Exp $
C                                                                      
C			     Copyright (C)  1997
C	     University Corporation for Atmospheric Research
C			     All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C

      SUBROUTINE LINCLS(WHICH, IOS, STATUS)
C
C  Level two line class keyword parsing.
C
C
C  INPUT
C       WHICH   --  the encoded path flags.
C
C  OUTPUT
C       IOS     --  I/O status flag.  This flag is valid only
C                   if STATUS indicates an error.
C       STATUS  --  The error status as defined in COMMON CAPERR.
C
      COMMON /PARTB1/ PART1, KEYSEP, KEYTER, FRMCOM
      COMMON /PARTB2/ PART2, PART3, PART4, PART5, CTSTR, CTLOC
C
C  THE NUMBER OF WORDS IN THE SEARCH PATH MUST BE BIG ENOUGH TO HOLD
C       THE NUMBER OF BITS PER PATH TIMES THE NUMBER OF LEVELS
C
      INTEGER WHSIZE
      PARAMETER (WHSIZE=20)
C
      INTEGER PARTSZ, OTHSZ, NTABLE
      PARAMETER(PARTSZ=3000, OTHSZ=150, NTABLE=50)
      CHARACTER*1 KEYSEP,KEYTER
      CHARACTER*1 FRMCOM(2)
      INTEGER PART2(OTHSZ), PART3(OTHSZ), PART4(NTABLE), PART5(NTABLE*2)
      CHARACTER*1 PART1(PARTSZ)
      INTEGER CTSTR, CTLOC
      COMMON /CAPERR/ ALLOK, EOFFL, INTERR, MAXINT, PLBERR, PMBERR,
     1                FABERR, TXBERR, FLTERR, MAXFLT, NOTINT, SIZERR,
     2                UNDASC, DEVERR, DOCERR, TBLERR , STSZER, ENTERR,
     3                TABERR, TABSER, PRSFIL
      INTEGER ALLOK, EOFFL, INTERR, MAXINT, PLBERR, PMBERR,
     1        FABERR, TXBERR, FLTERR, MAXFLT, NOTINT, SIZERR, UNDASC,
     2        DEVERR, DOCERR, STSZER, ENTERR, TABERR, TABSER, TBLERR,
     3        PRSFIL
      COMMON /CAPLIN/ PLAVBL, LDSSTR, LDSSIZ, LDTSTR, LDTSIZ,
     1                LMSSTR, LMSSIZ, LMTSTR, LMTSIZ, LCSSTR,
     2                LCSSIZ, LCTSTR, LCTSIZ, LINFIN, LINFMT,
     3                LWSSTR, LWSSIZ, LWTSTR, LWTSIZ, LWTFIN,
     4                LWTFMT, LWTRNG, LWTSCF, LBSSTR, LBSSIZ,
     5                LBTSTR, LBTSIZ, LPSSTR, LPSSIZ, LPTSTR,
     6                LPTSIZ
      INTEGER         LDSMAX, LDTMAX, LMSMAX, LMTMAX, LCSMAX,
     1                LCTMAX, LVCFMX, LWSMAX, LWTMAX, LWTFMX,
     2                LBSMAX, LBTMAX, LPSMAX, LPTMAX
      PARAMETER   (LDSMAX=30, LDTMAX=15, LMSMAX=30, LMTMAX=15,
     1             LCSMAX=30, LCTMAX=15, LVCFMX=8,  LWSMAX=30,
     2             LWTMAX=15, LWTFMX=8 , LBSMAX=30, LBTMAX=15,
     3             LPSMAX=20, LPTMAX=20)
      INTEGER         LDSSTR(LDSMAX), LDSSIZ, LDTSTR(LDTMAX),
     1                LDTSIZ, LMSSTR(LMSMAX), LMSSIZ,
     2                LMTSTR(LMTMAX), LMTSIZ, LCSSTR(LCSMAX),
     3                LCSSIZ, LCTSTR(LCTMAX), LCTSIZ, LINFIN(8),
     4                LINFMT(LVCFMX,4)      , LWSSTR(LWSMAX),
     5                LWSSIZ, LWTSTR(LWTMAX), LWTSIZ, LWTFIN(8),
     6                LWTFMT(LWTFMX,4)      , LWTRNG(2)     ,
     7                LBSSTR(LBSMAX), LBSSIZ, LBTSTR(LBTMAX),
     8                LBTSIZ, LPSSTR(LPSMAX), LPSSIZ,
     9                LPTSTR(LPTMAX), LPTSIZ
      LOGICAL         PLAVBL
      REAL            LWTSCF,LINRIN(8),LWTRIN(8)
      INTEGER         LENLIN
      PARAMETER   (LENLIN=1+LDSMAX+1+LDTMAX+1+LMSMAX+1+
     1             LMTMAX+1+LCSMAX+1+LCTMAX+1+8+LVCFMX*4+
     2             LWSMAX+1+LWTMAX+1+8+LWTFMX*4+2+1+LBSMAX+
     3             1+LBTMAX+1+LPSMAX+1+LPTMAX+1)
      EQUIVALENCE (LINFIN,LINRIN), (LWTFIN,LWTRIN)
C
      INTEGER WHICH(WHSIZE), IOS, STATUS
      INTEGER ROW1, ROW2, ROW3
      INTEGER DUMMY, HOLDER(LVCFMX*4), II, JJ
C
C  Branch to the proper level 2 processing.
C
      ROW1 = WHICH(2)
      ROW2 = WHICH(3)
      ROW3 = WHICH(4)
C
C  POLYLINE processing--
C
C       ROW1   ROW2  ROW3  Keyword
C       ----   ----  ----  -----------------------------------
C       1       1          LINE_DRAW_POLY_FLAG
C       1       2     1    LINE_DRAW_INSTRUCTION_START
C       1       2     2    LINE_DRAW_INSTRUCTION_TERMINATOR
C       2       1     1    LINE_MOVE_INSTRUCTION_START
C       2       1     2    LINE_MOVE_INSTRUCTION_TERMINATOR
C       3       1     1    LINE_COLOR_INSTRUCTION_START
C       3       1     2    LINE_COLOR_INSTRUCTION_TERMINATOR
C       4       1     1    LINE_WIDTH_INSTRUCTION_START
C       4       1     2    LINE_WIDTH_INSTRUCTION_TERMINATOR
C       4       2          LINE_WIDTH_FORMAT
C       4       3          LINE_WIDTH_ENCODING
C       4       4          LINE_WIDTH_RANGE
C       4       5          LINE_WIDTH_SCALE
C       4       6          LINE_WIDTH_FLOATING_INFO
C       5       1     1    LINE_BACKGROUND_COLOR_INSTRUCTION_START
C       5       1     2    LINE_BACKGROUND_COLOR_INSTRUCTION_TERMINATOR
C       6       1          LINE_POINT_START
C       6       2          LINE_POINT_TERMINATOR
C
      IF (ROW1.EQ.1 .AND. ROW2.EQ.1) THEN
        CALL GTLOG(PLAVBL, 1, DUMMY, IOS, STATUS)
      ELSE IF (ROW1.EQ.1 .AND. ROW2.EQ.2) THEN
        IF (ROW3.EQ.1) THEN
                CALL GTSTR(LDSSTR, LDSMAX, LDSSIZ, IOS, STATUS)
        ELSE IF (ROW3.EQ.2) THEN
                CALL GTSTR(LDTSTR, LDTMAX, LDTSIZ, IOS, STATUS)
        END IF
      ELSE IF (ROW1.EQ.2 .AND. ROW2.EQ.1) THEN
        IF (ROW3.EQ.1) THEN
                CALL GTSTR(LMSSTR, LMSMAX, LMSSIZ, IOS, STATUS)
        ELSE IF (ROW3.EQ.2) THEN
                CALL GTSTR(LMTSTR, LMTMAX, LMTSIZ, IOS, STATUS)
        END IF
      ELSE IF (ROW1.EQ.3 .AND. ROW2.EQ.1) THEN
        IF (ROW3.EQ.1) THEN
                CALL GTSTR(LCSSTR, LCSMAX, LCSSIZ, IOS, STATUS)
        ELSE IF (ROW3.EQ.2) THEN
                CALL GTSTR(LCTSTR, LCTMAX, LCTSIZ, IOS, STATUS)
        END IF
C
      ELSE IF (ROW1.EQ.4) THEN
        IF (ROW2.EQ.1) THEN
                IF (ROW3.EQ.1) THEN
                CALL GTSTR(LWSSTR, LWSMAX, LWSSIZ, IOS, STATUS)
                ELSE IF (ROW3.EQ.2) THEN
                CALL GTSTR(LWTSTR, LWTMAX, LWTSIZ, IOS, STATUS)
                END IF
        ELSE IF (ROW2.EQ.2) THEN
                CALL GTINT(HOLDER, LWTFMX*4, DUMMY, IOS, STATUS)
                IF (DUMMY .NE. 0) THEN
                        LWTFIN(2) = DUMMY/4
                        DO 20 II = 1,LWTFIN(2)
                        DO 20 JJ = 1,4
                                LWTFMT(II,JJ) = HOLDER((II-1)*4+JJ)
 20                     CONTINUE
                END IF
        ELSE IF (ROW2.EQ.3) THEN
                CALL GTINT(LWTFIN(1), 1, DUMMY, IOS, STATUS)
        ELSE IF (ROW2.EQ.4) THEN
                CALL GTINT(LWTRNG, 2, DUMMY, IOS, STATUS)
        ELSE IF (ROW2.EQ.5) THEN
                CALL GTFLT(LWTSCF, 1, DUMMY, IOS, STATUS)
        ELSE IF (ROW2.EQ.6) THEN
                CALL GTFLT(LWTRIN(5), 4, DUMMY, IOS, STATUS)
        END IF
      ELSE IF (ROW1.EQ.5 .AND. ROW2.EQ.1) THEN
        IF (ROW3.EQ.1) THEN
                CALL GTSTR(LBSSTR, LBSMAX, LBSSIZ, IOS, STATUS)
        ELSE IF (ROW3.EQ.2) THEN
                CALL GTSTR(LBTSTR, LBTMAX, LBTSIZ, IOS, STATUS)
        END IF
      ELSE IF (ROW1.EQ.6 .AND. ROW2.EQ.1) THEN
        CALL GTSTR(LPSSTR, LPSMAX, LPSSIZ, IOS, STATUS)
      ELSE IF (ROW1.EQ.6 .AND. ROW2.EQ.2) THEN
        CALL GTSTR(LPTSTR, LPTMAX, LPTSIZ, IOS, STATUS)
C
      END IF
      RETURN
      END

      PROGRAM MPEXFI
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Define a data array.
C
      DIMENSION XYCD(224)
C
C Define the centers and the expansion/shrinkage factors for
C various copies of the curve to be drawn.
C
      DIMENSION FLAC(4),FLOC(4),FMUL(4)
C
      DATA FLOC(1),FLAC(1),FMUL(1) / -38.1,32.0,1.7 /
      DATA FLOC(2),FLAC(2),FMUL(2) / -37.9,32.0,1.7 /
      DATA FLOC(3),FLAC(3),FMUL(3) / -38.0,31.9,1.7 /
      DATA FLOC(4),FLAC(4),FMUL(4) / -38.0,32.1,1.7 /
C
C Open GKS.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Fill the data array.
C
      READ 1001 , XYCD
C
C Define the altitude of the satellite.
C
      CALL MAPSTR ('SA',2.)
C
C Draw a map of the North Atlantic, as seen by a satellite.
C
      CALL SUPMAP (7,32.,-38.,20.,0.,0.,0.,0.,1,-1000,5,0,IERR)
C
C Force MAPIT to draw dotted lines.
C
      CALL MAPSTI ('DL',1)
      CALL MAPSTI ('DD',24)
C
C Draw some curves.
C
      DO 102 I=1,4
C
        IFST=0
C
        DO 101 J=1,112
          IF (XYCD(2*J-1).EQ.0.) THEN
            IFST=0
          ELSE
            FLON=FLOC(I)+FMUL(I)*(XYCD(2*J-1)-15.)
            FLAT=FLAC(I)+FMUL(I)*(XYCD(2*J  )-15.)
            CALL MAPIT (FLAT,FLON,IFST)
            IFST=1
          END IF
  101   CONTINUE
C
  102 CONTINUE
C
C Dump MAPIT's buffers.
C
      CALL MAPIQ
C
C Draw a boundary around the edge of the plotter frame.
C
      CALL BNDARY
C
C Advance the frame.
C
      CALL FRAME
C
C Close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
C Done.
C
      STOP
C
C Format.
C
 1001 FORMAT (14E5.0)
C
      END

C
C	$Id: gqops.f,v 1.5 2008-07-27 00:20:59 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GQOPS(OPSTA)
C
C  INQUIRE OPERATING STATE VALUE
C
      include 'gkscom.h'
C
      INTEGER OPSTA
      OPSTA = OPS
C
      RETURN
      END

      SUBROUTINE DLASD3( NL, NR, SQRE, K, D, Q, LDQ, DSIGMA, U, LDU, U2,
     $                   LDU2, VT, LDVT, VT2, LDVT2, IDXC, CTOT, Z,
     $                   INFO )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Oak Ridge National Lab, Argonne National Lab,
*     Courant Institute, NAG Ltd., and Rice University
*     October 31, 1999
*
*     .. Scalar Arguments ..
      INTEGER            INFO, K, LDQ, LDU, LDU2, LDVT, LDVT2, NL, NR,
     $                   SQRE
*     ..
*     .. Array Arguments ..
      INTEGER            CTOT( * ), IDXC( * )
      DOUBLE PRECISION   D( * ), DSIGMA( * ), Q( LDQ, * ), U( LDU, * ),
     $                   U2( LDU2, * ), VT( LDVT, * ), VT2( LDVT2, * ),
     $                   Z( * )
*     ..
*
*  Purpose
*  =======
*
*  DLASD3 finds all the square roots of the roots of the secular
*  equation, as defined by the values in D and Z.  It makes the
*  appropriate calls to DLASD4 and then updates the singular
*  vectors by matrix multiplication.
*
*  This code makes very mild assumptions about floating point
*  arithmetic. It will work on machines with a guard digit in
*  add/subtract, or on those binary machines without guard digits
*  which subtract like the Cray XMP, Cray YMP, Cray C 90, or Cray 2.
*  It could conceivably fail on hexadecimal or decimal machines
*  without guard digits, but we know of none.
*
*  DLASD3 is called from DLASD1.
*
*  Arguments
*  =========
*
*  NL     (input) INTEGER
*         The row dimension of the upper block.  NL >= 1.
*
*  NR     (input) INTEGER
*         The row dimension of the lower block.  NR >= 1.
*
*  SQRE   (input) INTEGER
*         = 0: the lower block is an NR-by-NR square matrix.
*         = 1: the lower block is an NR-by-(NR+1) rectangular matrix.
*
*         The bidiagonal matrix has N = NL + NR + 1 rows and
*         M = N + SQRE >= N columns.
*
*  K      (input) INTEGER
*         The size of the secular equation, 1 =< K = < N.
*
*  D      (output) DOUBLE PRECISION array, dimension(K)
*         On exit the square roots of the roots of the secular equation,
*         in ascending order.
*
*  Q      (workspace) DOUBLE PRECISION array,
*                     dimension at least (LDQ,K).
*
*  LDQ    (input) INTEGER
*         The leading dimension of the array Q.  LDQ >= K.
*
*  DSIGMA (input) DOUBLE PRECISION array, dimension(K)
*         The first K elements of this array contain the old roots
*         of the deflated updating problem.  These are the poles
*         of the secular equation.
*
*  U      (input) DOUBLE PRECISION array, dimension (LDU, N)
*         The last N - K columns of this matrix contain the deflated
*         left singular vectors.
*
*  LDU    (input) INTEGER
*         The leading dimension of the array U.  LDU >= N.
*
*  U2     (input) DOUBLE PRECISION array, dimension (LDU2, N)
*         The first K columns of this matrix contain the non-deflated
*         left singular vectors for the split problem.
*
*  LDU2   (input) INTEGER
*         The leading dimension of the array U2.  LDU2 >= N.
*
*  VT     (input) DOUBLE PRECISION array, dimension (LDVT, M)
*         The last M - K columns of VT' contain the deflated
*         right singular vectors.
*
*  LDVT   (input) INTEGER
*         The leading dimension of the array VT.  LDVT >= N.
*
*  VT2    (input) DOUBLE PRECISION array, dimension (LDVT2, N)
*         The first K columns of VT2' contain the non-deflated
*         right singular vectors for the split problem.
*
*  LDVT2  (input) INTEGER
*         The leading dimension of the array VT2.  LDVT2 >= N.
*
*  IDXC   (input) INTEGER array, dimension ( N )
*         The permutation used to arrange the columns of U (and rows of
*         VT) into three groups:  the first group contains non-zero
*         entries only at and above (or before) NL +1; the second
*         contains non-zero entries only at and below (or after) NL+2;
*         and the third is dense. The first column of U and the row of
*         VT are treated separately, however.
*
*         The rows of the singular vectors found by DLASD4
*         must be likewise permuted before the matrix multiplies can
*         take place.
*
*  CTOT   (input) INTEGER array, dimension ( 4 )
*         A count of the total number of the various types of columns
*         in U (or rows in VT), as described in IDXC. The fourth column
*         type is any column which has been deflated.
*
*  Z      (input) DOUBLE PRECISION array, dimension (K)
*         The first K elements of this array contain the components
*         of the deflation-adjusted updating row vector.
*
*  INFO   (output) INTEGER
*         = 0:  successful exit.
*         < 0:  if INFO = -i, the i-th argument had an illegal value.
*         > 0:  if INFO = 1, an singular value did not converge
*
*  Further Details
*  ===============
*
*  Based on contributions by
*     Ming Gu and Huan Ren, Computer Science Division, University of
*     California at Berkeley, USA
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ONE, ZERO, NEGONE
      PARAMETER          ( ONE = 1.0D+0, ZERO = 0.0D+0,
     $                   NEGONE = -1.0D+0 )
*     ..
*     .. Local Scalars ..
      INTEGER            CTEMP, I, J, JC, KTEMP, M, N, NLP1, NLP2, NRP1
      DOUBLE PRECISION   RHO, TEMP
*     ..
*     .. External Functions ..
      DOUBLE PRECISION   DLAMC3, DNRM2
      EXTERNAL           DLAMC3, DNRM2
*     ..
*     .. External Subroutines ..
      EXTERNAL           DCOPY, DGEMM, DLACPY, DLASCL, DLASD4, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, SIGN, SQRT
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
*
      IF( NL.LT.1 ) THEN
         INFO = -1
      ELSE IF( NR.LT.1 ) THEN
         INFO = -2
      ELSE IF( ( SQRE.NE.1 ) .AND. ( SQRE.NE.0 ) ) THEN
         INFO = -3
      END IF
*
      N = NL + NR + 1
      M = N + SQRE
      NLP1 = NL + 1
      NLP2 = NL + 2
*
      IF( ( K.LT.1 ) .OR. ( K.GT.N ) ) THEN
         INFO = -4
      ELSE IF( LDQ.LT.K ) THEN
         INFO = -7
      ELSE IF( LDU.LT.N ) THEN
         INFO = -10
      ELSE IF( LDU2.LT.N ) THEN
         INFO = -12
      ELSE IF( LDVT.LT.M ) THEN
         INFO = -14
      ELSE IF( LDVT2.LT.M ) THEN
         INFO = -16
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DLASD3', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( K.EQ.1 ) THEN
         D( 1 ) = ABS( Z( 1 ) )
         CALL DCOPY( M, VT2( 1, 1 ), LDVT2, VT( 1, 1 ), LDVT )
         IF( Z( 1 ).GT.ZERO ) THEN
            CALL DCOPY( N, U2( 1, 1 ), 1, U( 1, 1 ), 1 )
         ELSE
            DO 10 I = 1, N
               U( I, 1 ) = -U2( I, 1 )
   10       CONTINUE
         END IF
         RETURN
      END IF
*
*     Modify values DSIGMA(i) to make sure all DSIGMA(i)-DSIGMA(j) can
*     be computed with high relative accuracy (barring over/underflow).
*     This is a problem on machines without a guard digit in
*     add/subtract (Cray XMP, Cray YMP, Cray C 90 and Cray 2).
*     The following code replaces DSIGMA(I) by 2*DSIGMA(I)-DSIGMA(I),
*     which on any of these machines zeros out the bottommost
*     bit of DSIGMA(I) if it is 1; this makes the subsequent
*     subtractions DSIGMA(I)-DSIGMA(J) unproblematic when cancellation
*     occurs. On binary machines with a guard digit (almost all
*     machines) it does not change DSIGMA(I) at all. On hexadecimal
*     and decimal machines with a guard digit, it slightly
*     changes the bottommost bits of DSIGMA(I). It does not account
*     for hexadecimal or decimal machines without guard digits
*     (we know of none). We use a subroutine call to compute
*     2*DLAMBDA(I) to prevent optimizing compilers from eliminating
*     this code.
*
      DO 20 I = 1, K
         DSIGMA( I ) = DLAMC3( DSIGMA( I ), DSIGMA( I ) ) - DSIGMA( I )
   20 CONTINUE
*
*     Keep a copy of Z.
*
      CALL DCOPY( K, Z, 1, Q, 1 )
*
*     Normalize Z.
*
      RHO = DNRM2( K, Z, 1 )
      CALL DLASCL( 'G', 0, 0, RHO, ONE, K, 1, Z, K, INFO )
      RHO = RHO*RHO
*
*     Find the new singular values.
*
      DO 30 J = 1, K
         CALL DLASD4( K, J, DSIGMA, Z, U( 1, J ), RHO, D( J ),
     $                VT( 1, J ), INFO )
*
*        If the zero finder fails, the computation is terminated.
*
         IF( INFO.NE.0 ) THEN
            RETURN
         END IF
   30 CONTINUE
*
*     Compute updated Z.
*
      DO 60 I = 1, K
         Z( I ) = U( I, K )*VT( I, K )
         DO 40 J = 1, I - 1
            Z( I ) = Z( I )*( U( I, J )*VT( I, J ) /
     $               ( DSIGMA( I )-DSIGMA( J ) ) /
     $               ( DSIGMA( I )+DSIGMA( J ) ) )
   40    CONTINUE
         DO 50 J = I, K - 1
            Z( I ) = Z( I )*( U( I, J )*VT( I, J ) /
     $               ( DSIGMA( I )-DSIGMA( J+1 ) ) /
     $               ( DSIGMA( I )+DSIGMA( J+1 ) ) )
   50    CONTINUE
         Z( I ) = SIGN( SQRT( ABS( Z( I ) ) ), Q( I, 1 ) )
   60 CONTINUE
*
*     Compute left singular vectors of the modified diagonal matrix,
*     and store related information for the right singular vectors.
*
      DO 90 I = 1, K
         VT( 1, I ) = Z( 1 ) / U( 1, I ) / VT( 1, I )
         U( 1, I ) = NEGONE
         DO 70 J = 2, K
            VT( J, I ) = Z( J ) / U( J, I ) / VT( J, I )
            U( J, I ) = DSIGMA( J )*VT( J, I )
   70    CONTINUE
         TEMP = DNRM2( K, U( 1, I ), 1 )
         Q( 1, I ) = U( 1, I ) / TEMP
         DO 80 J = 2, K
            JC = IDXC( J )
            Q( J, I ) = U( JC, I ) / TEMP
   80    CONTINUE
   90 CONTINUE
*
*     Update the left singular vector matrix.
*
      IF( K.EQ.2 ) THEN
         CALL DGEMM( 'N', 'N', N, K, K, ONE, U2, LDU2, Q, LDQ, ZERO, U,
     $               LDU )
         GO TO 100
      END IF
      IF( CTOT( 1 ).GT.0 ) THEN
         CALL DGEMM( 'N', 'N', NL, K, CTOT( 1 ), ONE, U2( 1, 2 ), LDU2,
     $               Q( 2, 1 ), LDQ, ZERO, U( 1, 1 ), LDU )
         IF( CTOT( 3 ).GT.0 ) THEN
            KTEMP = 2 + CTOT( 1 ) + CTOT( 2 )
            CALL DGEMM( 'N', 'N', NL, K, CTOT( 3 ), ONE, U2( 1, KTEMP ),
     $                  LDU2, Q( KTEMP, 1 ), LDQ, ONE, U( 1, 1 ), LDU )
         END IF
      ELSE IF( CTOT( 3 ).GT.0 ) THEN
         KTEMP = 2 + CTOT( 1 ) + CTOT( 2 )
         CALL DGEMM( 'N', 'N', NL, K, CTOT( 3 ), ONE, U2( 1, KTEMP ),
     $               LDU2, Q( KTEMP, 1 ), LDQ, ZERO, U( 1, 1 ), LDU )
      ELSE
         CALL DLACPY( 'F', NL, K, U2, LDU2, U, LDU )
      END IF
      CALL DCOPY( K, Q( 1, 1 ), LDQ, U( NLP1, 1 ), LDU )
      KTEMP = 2 + CTOT( 1 )
      CTEMP = CTOT( 2 ) + CTOT( 3 )
      CALL DGEMM( 'N', 'N', NR, K, CTEMP, ONE, U2( NLP2, KTEMP ), LDU2,
     $            Q( KTEMP, 1 ), LDQ, ZERO, U( NLP2, 1 ), LDU )
*
*     Generate the right singular vectors.
*
  100 CONTINUE
      DO 120 I = 1, K
         TEMP = DNRM2( K, VT( 1, I ), 1 )
         Q( I, 1 ) = VT( 1, I ) / TEMP
         DO 110 J = 2, K
            JC = IDXC( J )
            Q( I, J ) = VT( JC, I ) / TEMP
  110    CONTINUE
  120 CONTINUE
*
*     Update the right singular vector matrix.
*
      IF( K.EQ.2 ) THEN
         CALL DGEMM( 'N', 'N', K, M, K, ONE, Q, LDQ, VT2, LDVT2, ZERO,
     $               VT, LDVT )
         RETURN
      END IF
      KTEMP = 1 + CTOT( 1 )
      CALL DGEMM( 'N', 'N', K, NLP1, KTEMP, ONE, Q( 1, 1 ), LDQ,
     $            VT2( 1, 1 ), LDVT2, ZERO, VT( 1, 1 ), LDVT )
      KTEMP = 2 + CTOT( 1 ) + CTOT( 2 )
      IF( KTEMP.LE.LDVT2 )
     $   CALL DGEMM( 'N', 'N', K, NLP1, CTOT( 3 ), ONE, Q( 1, KTEMP ),
     $               LDQ, VT2( KTEMP, 1 ), LDVT2, ONE, VT( 1, 1 ),
     $               LDVT )
*
      KTEMP = CTOT( 1 ) + 1
      NRP1 = NR + SQRE
      IF( KTEMP.GT.1 ) THEN
         DO 130 I = 1, K
            Q( I, KTEMP ) = Q( I, 1 )
  130    CONTINUE
         DO 140 I = NLP2, M
            VT2( KTEMP, I ) = VT2( 1, I )
  140    CONTINUE
      END IF
      CTEMP = 1 + CTOT( 2 ) + CTOT( 3 )
      CALL DGEMM( 'N', 'N', K, NRP1, CTEMP, ONE, Q( 1, KTEMP ), LDQ,
     $            VT2( KTEMP, NLP2 ), LDVT2, ZERO, VT( 1, NLP2 ), LDVT )
*
      RETURN
*
*     End of DLASD3
*
      END

C
C $Id: agstch.f,v 1.6 2008-07-27 00:14:35 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE AGSTCH (CHST,LNCS,IDCS)
C
      CHARACTER*(*) CHST
C
C This routine stores strings of characters for later retrieval and/or
C modification by the routines AGGTCH, AGRPCH, and AGDLCH.  It has the
C following arguments:
C
C -- CHST is the character string to be stored.
C
C -- LNCS is the length of the character string in CHST.  LNCS must be
C    less than or equal to the value of the FORTRAN function LEN(CHST).
C
C -- IDCS is an identifying integer, returned to the caller by AGSTCH
C    for later use in calls to AGGTCH, AGRPCH, and AGDLCH.  If CHST is
C    more than one character long, it is stashed in the array CHRA, and
C    the value returned in IDCS is a negative number between -LNIC and
C    -1, inclusive, the absolute value of which is the index of an entry
C    in the array INCH describing where in the array CHRA the string was
C    stored.  If CHST is only one character long, IDCS is returned as
C    the value of the FORTRAN expression -(LNIC+1+ICHAR(CHST(1:1))).
C
C The following common blocks contain variables which are required for
C the character-storage-and-retrieval scheme of AUTOGRAPH.
C
      COMMON /AGCHR1/ LNIC,INCH(2,50),LNCA,INCA
      SAVE /AGCHR1/
C
      COMMON /AGCHR2/ CHRA(2000)
      CHARACTER*1 CHRA
      SAVE /AGCHR2/
C
C If the string is short enough, just embed it in a negative integer
C and return that value to the caller as the identifier of the string.
C
      IF (LNCS.LE.1) THEN
        IDCS=-(LNIC+1+ICHAR(CHST(1:1)))
        RETURN
      END IF
C
C Otherwise, the string must be stashed in CHRA and the negative of the
C index, in INCH, of its descriptor returned to the caller.  Loop, on I,
C through the index of character strings.
C
      DO 104 I=1,LNIC
C
C If the next entry in the index is zeroed, use it for the new string.
C
        IF (INCH(1,I).EQ.0) THEN
C
C Zeroed entry found.  Return the negative of its index to the user.
C
          IDCS=-I
C
C If there isn't enough room for the character string at the end of the
C character-storage array, do some garbage-collecting, eliminating all
C strings of all-zero characters.
C
          IF (LNCS.GT.LNCA-INCA) THEN
            J=0
            K=0
            DO 102 L=1,INCA
              IF (CHRA(L).EQ.CHAR(0)) THEN
                IF (J.EQ.0) J=L
              ELSE
                IF (J.NE.0) THEN
                  DO 101 M=1,LNIC
                    IF (INCH(1,M).GT.K) INCH(1,M)=INCH(1,M)+J-L
  101             CONTINUE
                  J=0
                END IF
                K=K+1
                CHRA(K)=CHRA(L)
              END IF
  102       CONTINUE
            INCA=K
          END IF
C
C If there still isn't enough room for the character string at the end
C of the character-storage array, take an error exit.  Otherwise, stash
C it and return.  All-zero characters are changed to blanks.
C
          IF (LNCS.GT.LNCA-INCA) GO TO 901
          INCH(1,I)=INCA+1
          INCH(2,I)=LNCS
          DO 103 J=1,LNCS
            INCA=INCA+1
            CHRA(INCA)=CHST(J:J)
            IF (ICHAR(CHRA(INCA)).EQ.0) CHRA(INCA)=' '
  103     CONTINUE
          RETURN
C
        END IF
C
  104 CONTINUE
C
C If no zeroed entry was found in the index of character strings, jump
C to log an error and quit.
C
      GO TO 902
C
C Error exits.
C
  901 CALL SETER ('AGSTCH - CHARACTER-STRING BUFFER OVERFLOW - SEE CONSU
     +LTANT',18,2)
C
  902 CALL SETER ('AGSTCH - CHARACTER-STRING INDEX OVERFLOW - SEE CONSUL
     +TANT',19,2)
C
      END

      SUBROUTINE SLAED5( I, D, Z, DELTA, RHO, DLAM )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Oak Ridge National Lab, Argonne National Lab,
*     Courant Institute, NAG Ltd., and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      INTEGER            I
      REAL               DLAM, RHO
*     ..
*     .. Array Arguments ..
      REAL               D( 2 ), DELTA( 2 ), Z( 2 )
*     ..
*
*  Purpose
*  =======
*
*  This subroutine computes the I-th eigenvalue of a symmetric rank-one
*  modification of a 2-by-2 diagonal matrix
*
*             diag( D )  +  RHO *  Z * transpose(Z) .
*
*  The diagonal elements in the array D are assumed to satisfy
*
*             D(i) < D(j)  for  i < j .
*
*  We also assume RHO > 0 and that the Euclidean norm of the vector
*  Z is one.
*
*  Arguments
*  =========
*
*  I      (input) INTEGER
*         The index of the eigenvalue to be computed.  I = 1 or I = 2.
*
*  D      (input) REAL array, dimension (2)
*         The original eigenvalues.  We assume D(1) < D(2).
*
*  Z      (input) REAL array, dimension (2)
*         The components of the updating vector.
*
*  DELTA  (output) REAL array, dimension (2)
*         The vector DELTA contains the information necessary
*         to construct the eigenvectors.
*
*  RHO    (input) REAL
*         The scalar in the symmetric updating formula.
*
*  DLAM   (output) REAL
*         The computed lambda_I, the I-th updated eigenvalue.
*
*  Further Details
*  ===============
*
*  Based on contributions by
*     Ren-Cang Li, Computer Science Division, University of California
*     at Berkeley, USA
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ZERO, ONE, TWO, FOUR
      PARAMETER          ( ZERO = 0.0E0, ONE = 1.0E0, TWO = 2.0E0,
     $                   FOUR = 4.0E0 )
*     ..
*     .. Local Scalars ..
      REAL               B, C, DEL, TAU, TEMP, W
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, SQRT
*     ..
*     .. Executable Statements ..
*
      DEL = D( 2 ) - D( 1 )
      IF( I.EQ.1 ) THEN
         W = ONE + TWO*RHO*( Z( 2 )*Z( 2 )-Z( 1 )*Z( 1 ) ) / DEL
         IF( W.GT.ZERO ) THEN
            B = DEL + RHO*( Z( 1 )*Z( 1 )+Z( 2 )*Z( 2 ) )
            C = RHO*Z( 1 )*Z( 1 )*DEL
*
*           B > ZERO, always
*
            TAU = TWO*C / ( B+SQRT( ABS( B*B-FOUR*C ) ) )
            DLAM = D( 1 ) + TAU
            DELTA( 1 ) = -Z( 1 ) / TAU
            DELTA( 2 ) = Z( 2 ) / ( DEL-TAU )
         ELSE
            B = -DEL + RHO*( Z( 1 )*Z( 1 )+Z( 2 )*Z( 2 ) )
            C = RHO*Z( 2 )*Z( 2 )*DEL
            IF( B.GT.ZERO ) THEN
               TAU = -TWO*C / ( B+SQRT( B*B+FOUR*C ) )
            ELSE
               TAU = ( B-SQRT( B*B+FOUR*C ) ) / TWO
            END IF
            DLAM = D( 2 ) + TAU
            DELTA( 1 ) = -Z( 1 ) / ( DEL+TAU )
            DELTA( 2 ) = -Z( 2 ) / TAU
         END IF
         TEMP = SQRT( DELTA( 1 )*DELTA( 1 )+DELTA( 2 )*DELTA( 2 ) )
         DELTA( 1 ) = DELTA( 1 ) / TEMP
         DELTA( 2 ) = DELTA( 2 ) / TEMP
      ELSE
*
*     Now I=2
*
         B = -DEL + RHO*( Z( 1 )*Z( 1 )+Z( 2 )*Z( 2 ) )
         C = RHO*Z( 2 )*Z( 2 )*DEL
         IF( B.GT.ZERO ) THEN
            TAU = ( B+SQRT( B*B+FOUR*C ) ) / TWO
         ELSE
            TAU = TWO*C / ( -B+SQRT( B*B+FOUR*C ) )
         END IF
         DLAM = D( 2 ) + TAU
         DELTA( 1 ) = -Z( 1 ) / ( DEL+TAU )
         DELTA( 2 ) = -Z( 2 ) / TAU
         TEMP = SQRT( DELTA( 1 )*DELTA( 1 )+DELTA( 2 )*DELTA( 2 ) )
         DELTA( 1 ) = DELTA( 1 ) / TEMP
         DELTA( 2 ) = DELTA( 2 ) / TEMP
      END IF
      RETURN
*
*     End OF SLAED5
*
      END

C
C $Id: ceez.f,v 1.5 2008-07-27 03:10:10 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
C NOTE: If you make any changes to this software, please remember to
C make the same changes to the corresponding double precision routine.
C
      subroutine ceez (del1,del2,sigma,c1,c2,c3,n)
c
      real del1,del2,sigma,c1,c2,c3
c
c                                 coded by alan kaylor cline
c                           from fitpack -- january 26, 1987
c                        a curve and surface fitting package
c                      a product of pleasant valley software
c                  8603 altus cove, austin, texas 78759, usa
c
c this subroutine determines the coefficients c1, c2, and c3
c used to determine endpoint slopes. specifically, if
c function values y1, y2, and y3 are given at points x1, x2,
c and x3, respectively, the quantity c1*y1 + c2*y2 + c3*y3
c is the value of the derivative at x1 of a spline under
c tension (with tension factor sigma) passing through the
c three points and having third derivative equal to zero at
c x1. optionally, only two values, c1 and c2 are determined.
c
c on input--
c
c   del1 is x2-x1 (.gt. 0.).
c
c   del2 is x3-x1 (.gt. 0.). if n .eq. 2, this parameter is
c   ignored.
c
c   sigma is the tension factor.
c
c and
c
c   n is a switch indicating the number of coefficients to
c   be returned. if n .eq. 2 only two coefficients are
c   returned. otherwise all three are returned.
c
c on output--
c
c   c1, c2, and c3 contain the coefficients.
c
c none of the input parameters are altered.
c
c this subroutine references package module snhcsh.
c
c-----------------------------------------------------------
c
      if (n .eq. 2) go to 2
      if (sigma .ne. 0.) go to 1
      del = del2-del1
c
c tension .eq. 0.
c
      c1 = -(del1+del2)/(del1*del2)
      c2 = del2/(del1*del)
      c3 = -del1/(del2*del)
      return
c
c tension .ne. 0.
c
    1 call snhcsh (dummy,coshm1,sigma*del1,1)
      call snhcsh (dummy,coshm2,sigma*del2,1)
      delp = sigma*(del2+del1)/2.
      delm = sigma*(del2-del1)/2.
      call snhcsh (sinhmp,dummy,delp,-1)
      call snhcsh (sinhmm,dummy,delm,-1)
      denom = coshm1*(del2-del1)-2.*del1*delp*delm*
     *        (1.+sinhmp)*(1.+sinhmm)
      c1 = 2.*delp*delm*(1.+sinhmp)*(1.+sinhmm)/denom
      c2 = -coshm2/denom
      c3 = coshm1/denom
      return
c
c two coefficients
c
    2 c1 = -1./del1
      c2 = -c1
      return
      end

C
C $Id: fcurv2dp.f,v 1.3 2008-07-27 03:10:11 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
C NOTE: If you make any changes to this software, please remember to
C make the same changes to the corresponding single precision routine.
C
      SUBROUTINE FCURV2DP(N,XI,YI,YP,SIGMA,M,XO,YO)
      DOUBLE PRECISION XI
      DOUBLE PRECISION YI
      DOUBLE PRECISION YP
      DOUBLE PRECISION SIGMA
      DOUBLE PRECISION XO
      DOUBLE PRECISION YO
      DOUBLE PRECISION CURV2DP
C
      DIMENSION XI(N),YI(N),YP(N),XO(M),YO(M)
C
      DO 10 I = 1,M
          YO(I) = CURV2DP(XO(I),N,XI,YI,YP,SIGMA)
   10 CONTINUE
C
      RETURN
      END
      SUBROUTINE FCURVDDP(N,XI,YI,YP,SIGMA,M,XO,YO)
      DOUBLE PRECISION XI
      DOUBLE PRECISION YI
      DOUBLE PRECISION YP
      DOUBLE PRECISION SIGMA
      DOUBLE PRECISION XO
      DOUBLE PRECISION YO
      DOUBLE PRECISION CURVDDP
C
      DIMENSION XI(N),YI(N),YP(N),XO(M),YO(M)
C
      DO 10 I = 1,M
          YO(I) = CURVDDP(XO(I),N,XI,YI,YP,SIGMA)
   10 CONTINUE
C
      RETURN
      END
      SUBROUTINE FCURVIDP(XL,XR,N,XI,YI,YP,SIGMA,FINT)
      DOUBLE PRECISION XL
      DOUBLE PRECISION XR
      DOUBLE PRECISION XI
      DOUBLE PRECISION YI
      DOUBLE PRECISION YP
      DOUBLE PRECISION SIGMA
      DOUBLE PRECISION FINT
      DOUBLE PRECISION CURVIDP
C
      DIMENSION XI(N),YI(N),YP(N)
C
      FINT = CURVIDP(XL,XR,N,XI,YI,YP,SIGMA)
C
      RETURN
      END
      SUBROUTINE FCURVP2DP(N,XI,YI,YP,P,SIGMA,M,XO,YO)
      DOUBLE PRECISION XI
      DOUBLE PRECISION YI
      DOUBLE PRECISION YP
      DOUBLE PRECISION P
      DOUBLE PRECISION SIGMA
      DOUBLE PRECISION XO
      DOUBLE PRECISION YO
      DOUBLE PRECISION CURVP2DP
C
      DIMENSION XI(N),YI(N),YP(N),XO(M),YO(M)
C
      DO 10 I = 1,M
          YO(I) = CURVP2DP(XO(I),N,XI,YI,P,YP,SIGMA)
   10 CONTINUE
C
      RETURN
      END
      SUBROUTINE FCURVPIDP(XL,XR,P,N,XI,YI,YP,SIGMA,FINT)
      DOUBLE PRECISION XL
      DOUBLE PRECISION XR
      DOUBLE PRECISION P
      DOUBLE PRECISION XI
      DOUBLE PRECISION YI
      DOUBLE PRECISION YP
      DOUBLE PRECISION SIGMA
      DOUBLE PRECISION FINT
      DOUBLE PRECISION CURVPIDP
C
      DIMENSION XI(N),YI(N),YP(N)
C
      FINT = CURVPIDP(XL,XR,N,XI,YI,P,YP,SIGMA)
C
      RETURN
      END
      SUBROUTINE FKURV2DP(N,XI,YI,M,T,XO,YO,XP,YP,S,SIGMA)
      DOUBLE PRECISION XI
      DOUBLE PRECISION YI
      DOUBLE PRECISION T
      DOUBLE PRECISION XO
      DOUBLE PRECISION YO
      DOUBLE PRECISION XP
      DOUBLE PRECISION YP
      DOUBLE PRECISION S
      DOUBLE PRECISION SIGMA
C
      DIMENSION XI(N),YI(N),YP(N),S(N),T(M),XO(M),YO(M)
C
      DO 10 I = 1,M
          CALL KURV2DP(T(I),XO(I),YO(I),N,XI,YI,XP,YP,S,SIGMA)
   10 CONTINUE
C
      RETURN
      END
      SUBROUTINE FKURVP2DP(N,XI,YI,M,T,XO,YO,XP,YP,S,SIGMA)
      DOUBLE PRECISION XI
      DOUBLE PRECISION YI
      DOUBLE PRECISION T
      DOUBLE PRECISION XO
      DOUBLE PRECISION YO
      DOUBLE PRECISION XP
      DOUBLE PRECISION YP
      DOUBLE PRECISION S
      DOUBLE PRECISION SIGMA
C
      DIMENSION XI(N),YI(N),YP(N),S(N),T(M),XO(M),YO(M)
C
      DO 10 I = 1,M
          CALL KURVP2DP(T(I),XO(I),YO(I),N,XI,YI,XP,YP,S,SIGMA)
   10 CONTINUE
C
      RETURN
      END
      SUBROUTINE FKURVDDP(N,XI,YI,M,T,XO,YO,XD,YD,XDD,YDD,XP,YP,S,SIGMA)
      DOUBLE PRECISION XI
      DOUBLE PRECISION YI
      DOUBLE PRECISION T
      DOUBLE PRECISION XO
      DOUBLE PRECISION YO
      DOUBLE PRECISION XD
      DOUBLE PRECISION YD
      DOUBLE PRECISION XDD
      DOUBLE PRECISION YDD
      DOUBLE PRECISION XP
      DOUBLE PRECISION YP
      DOUBLE PRECISION S
      DOUBLE PRECISION SIGMA
C
      DIMENSION XI(N),YI(N),YP(N),S(N),T(M),XO(M),YO(M),XD(M),YD(M),
     +          XDD(M),YDD(M)
C
      DO 10 I = 1,M
          CALL KURVDDP(T(I),XO(I),YO(I),XD(I),YD(I),XDD(I),YDD(I),N,XI,
     +                 YI,XP,YP,S,SIGMA)
   10 CONTINUE
C
      RETURN
      END
      SUBROUTINE FKURVPDDP(N,XI,YI,M,T,XO,YO,XD,YD,XDD,YDD,XP,YP,S,
     +                     SIGMA)
      DOUBLE PRECISION XI
      DOUBLE PRECISION YI
      DOUBLE PRECISION T
      DOUBLE PRECISION XO
      DOUBLE PRECISION YO
      DOUBLE PRECISION XD
      DOUBLE PRECISION YD
      DOUBLE PRECISION XDD
      DOUBLE PRECISION YDD
      DOUBLE PRECISION XP
      DOUBLE PRECISION YP
      DOUBLE PRECISION S
      DOUBLE PRECISION SIGMA
C
      DIMENSION XI(N),YI(N),YP(N),S(N),T(M),XO(M),YO(M),XD(M),YD(M),
     +          XDD(M),YDD(M)
C
      DO 10 I = 1,M
          CALL KURVPDDP(T(I),XO(I),YO(I),XD(I),YD(I),XDD(I),YDD(I),N,
     +                  XI,YI,XP,YP,S,SIGMA)
   10 CONTINUE
C
      RETURN
      END
      SUBROUTINE FSURF2DP(SVALUE,XO,YO,M,N,XI,YI,ZI,IZ,ZP,SIGMA)
      DOUBLE PRECISION SVALUE
      DOUBLE PRECISION XO
      DOUBLE PRECISION YO
      DOUBLE PRECISION XI
      DOUBLE PRECISION YI
      DOUBLE PRECISION ZI
      DOUBLE PRECISION ZP
      DOUBLE PRECISION SIGMA
      DOUBLE PRECISION SURF2DP
C
      DIMENSION XI(M),YI(N),ZI(IZ,N),ZP(M,N,3)
C
      SVALUE = SURF2DP(XO,YO,M,N,XI,YI,ZI,IZ,ZP,SIGMA)
C
      RETURN
      END
      SUBROUTINE FCURVS2DP(N,PARAM,XI,YI,XS,XSP,YS,YSP,SIGMA,M,XL,XR,XO,
     +                     YO)
      DOUBLE PRECISION PARAM
      DOUBLE PRECISION XI
      DOUBLE PRECISION YI
      DOUBLE PRECISION XS
      DOUBLE PRECISION XSP
      DOUBLE PRECISION YS
      DOUBLE PRECISION YSP
      DOUBLE PRECISION SIGMA
      DOUBLE PRECISION XL
      DOUBLE PRECISION XR
      DOUBLE PRECISION XO
      DOUBLE PRECISION YO
      DOUBLE PRECISION XINC
C
      DIMENSION PARAM(N),XI(N),YI(N),XS(N),XSP(N),YS(N),YSP(N),XO(M),
     +          YO(M)
C
      XINC = (XR-XL)/DBLE(M-1)
      DO 10 I = 1,M
          CALL CURVS2DP(DBLE(I-1)*XINC,N,PARAM,XS,YS,XSP,YSP,SIGMA,
     +                  XO(I),YO(I))
   10 CONTINUE
C
      RETURN
      END

      SUBROUTINE CGGSVP( JOBU, JOBV, JOBQ, M, P, N, A, LDA, B, LDB,
     $                   TOLA, TOLB, K, L, U, LDU, V, LDV, Q, LDQ,
     $                   IWORK, RWORK, TAU, WORK, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER          JOBQ, JOBU, JOBV
      INTEGER            INFO, K, L, LDA, LDB, LDQ, LDU, LDV, M, N, P
      REAL               TOLA, TOLB
*     ..
*     .. Array Arguments ..
      INTEGER            IWORK( * )
      REAL               RWORK( * )
      COMPLEX            A( LDA, * ), B( LDB, * ), Q( LDQ, * ),
     $                   TAU( * ), U( LDU, * ), V( LDV, * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  CGGSVP computes unitary matrices U, V and Q such that
*
*                   N-K-L  K    L
*   U'*A*Q =     K ( 0    A12  A13 )  if M-K-L >= 0;
*                L ( 0     0   A23 )
*            M-K-L ( 0     0    0  )
*
*                   N-K-L  K    L
*          =     K ( 0    A12  A13 )  if M-K-L < 0;
*              M-K ( 0     0   A23 )
*
*                 N-K-L  K    L
*   V'*B*Q =   L ( 0     0   B13 )
*            P-L ( 0     0    0  )
*
*  where the K-by-K matrix A12 and L-by-L matrix B13 are nonsingular
*  upper triangular; A23 is L-by-L upper triangular if M-K-L >= 0,
*  otherwise A23 is (M-K)-by-L upper trapezoidal.  K+L = the effective
*  numerical rank of the (M+P)-by-N matrix (A',B')'.  Z' denotes the
*  conjugate transpose of Z.
*
*  This decomposition is the preprocessing step for computing the
*  Generalized Singular Value Decomposition (GSVD), see subroutine
*  CGGSVD.
*
*  Arguments
*  =========
*
*  JOBU    (input) CHARACTER*1
*          = 'U':  Unitary matrix U is computed;
*          = 'N':  U is not computed.
*
*  JOBV    (input) CHARACTER*1
*          = 'V':  Unitary matrix V is computed;
*          = 'N':  V is not computed.
*
*  JOBQ    (input) CHARACTER*1
*          = 'Q':  Unitary matrix Q is computed;
*          = 'N':  Q is not computed.
*
*  M       (input) INTEGER
*          The number of rows of the matrix A.  M >= 0.
*
*  P       (input) INTEGER
*          The number of rows of the matrix B.  P >= 0.
*
*  N       (input) INTEGER
*          The number of columns of the matrices A and B.  N >= 0.
*
*  A       (input/output) COMPLEX array, dimension (LDA,N)
*          On entry, the M-by-N matrix A.
*          On exit, A contains the triangular (or trapezoidal) matrix
*          described in the Purpose section.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A. LDA >= max(1,M).
*
*  B       (input/output) COMPLEX array, dimension (LDB,N)
*          On entry, the P-by-N matrix B.
*          On exit, B contains the triangular matrix described in
*          the Purpose section.
*
*  LDB     (input) INTEGER
*          The leading dimension of the array B. LDB >= max(1,P).
*
*  TOLA    (input) REAL
*  TOLB    (input) REAL
*          TOLA and TOLB are the thresholds to determine the effective
*          numerical rank of matrix B and a subblock of A. Generally,
*          they are set to
*             TOLA = MAX(M,N)*norm(A)*MACHEPS,
*             TOLB = MAX(P,N)*norm(B)*MACHEPS.
*          The size of TOLA and TOLB may affect the size of backward
*          errors of the decomposition.
*
*  K       (output) INTEGER
*  L       (output) INTEGER
*          On exit, K and L specify the dimension of the subblocks
*          described in Purpose section.
*          K + L = effective numerical rank of (A',B')'.
*
*  U       (output) COMPLEX array, dimension (LDU,M)
*          If JOBU = 'U', U contains the unitary matrix U.
*          If JOBU = 'N', U is not referenced.
*
*  LDU     (input) INTEGER
*          The leading dimension of the array U. LDU >= max(1,M) if
*          JOBU = 'U'; LDU >= 1 otherwise.
*
*  V       (output) COMPLEX array, dimension (LDV,M)
*          If JOBV = 'V', V contains the unitary matrix V.
*          If JOBV = 'N', V is not referenced.
*
*  LDV     (input) INTEGER
*          The leading dimension of the array V. LDV >= max(1,P) if
*          JOBV = 'V'; LDV >= 1 otherwise.
*
*  Q       (output) COMPLEX array, dimension (LDQ,N)
*          If JOBQ = 'Q', Q contains the unitary matrix Q.
*          If JOBQ = 'N', Q is not referenced.
*
*  LDQ     (input) INTEGER
*          The leading dimension of the array Q. LDQ >= max(1,N) if
*          JOBQ = 'Q'; LDQ >= 1 otherwise.
*
*  IWORK   (workspace) INTEGER array, dimension (N)
*
*  RWORK   (workspace) REAL array, dimension (2*N)
*
*  TAU     (workspace) COMPLEX array, dimension (N)
*
*  WORK    (workspace) COMPLEX array, dimension (max(3*N,M,P))
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value.
*
*  Further Details
*  ===============
*
*  The subroutine uses LAPACK subroutine CGEQPF for the QR factorization
*  with column pivoting to detect the effective numerical rank of the
*  a matrix. It may be replaced by a better rank determination strategy.
*
*  =====================================================================
*
*     .. Parameters ..
      COMPLEX            CZERO, CONE
      PARAMETER          ( CZERO = ( 0.0E+0, 0.0E+0 ),
     $                   CONE = ( 1.0E+0, 0.0E+0 ) )
*     ..
*     .. Local Scalars ..
      LOGICAL            FORWRD, WANTQ, WANTU, WANTV
      INTEGER            I, J
      COMPLEX            T
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           CGEQPF, CGEQR2, CGERQ2, CLACPY, CLAPMT, CLASET,
     $                   CUNG2R, CUNM2R, CUNMR2, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, AIMAG, MAX, MIN, REAL
*     ..
*     .. Statement Functions ..
      REAL               CABS1
*     ..
*     .. Statement Function definitions ..
      CABS1( T ) = ABS( REAL( T ) ) + ABS( AIMAG( T ) )
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters
*
      WANTU = LSAME( JOBU, 'U' )
      WANTV = LSAME( JOBV, 'V' )
      WANTQ = LSAME( JOBQ, 'Q' )
      FORWRD = .TRUE.
*
      INFO = 0
      IF( .NOT.( WANTU .OR. LSAME( JOBU, 'N' ) ) ) THEN
         INFO = -1
      ELSE IF( .NOT.( WANTV .OR. LSAME( JOBV, 'N' ) ) ) THEN
         INFO = -2
      ELSE IF( .NOT.( WANTQ .OR. LSAME( JOBQ, 'N' ) ) ) THEN
         INFO = -3
      ELSE IF( M.LT.0 ) THEN
         INFO = -4
      ELSE IF( P.LT.0 ) THEN
         INFO = -5
      ELSE IF( N.LT.0 ) THEN
         INFO = -6
      ELSE IF( LDA.LT.MAX( 1, M ) ) THEN
         INFO = -8
      ELSE IF( LDB.LT.MAX( 1, P ) ) THEN
         INFO = -10
      ELSE IF( LDU.LT.1 .OR. ( WANTU .AND. LDU.LT.M ) ) THEN
         INFO = -16
      ELSE IF( LDV.LT.1 .OR. ( WANTV .AND. LDV.LT.P ) ) THEN
         INFO = -18
      ELSE IF( LDQ.LT.1 .OR. ( WANTQ .AND. LDQ.LT.N ) ) THEN
         INFO = -20
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'CGGSVP', -INFO )
         RETURN
      END IF
*
*     QR with column pivoting of B: B*P = V*( S11 S12 )
*                                           (  0   0  )
*
      DO 10 I = 1, N
         IWORK( I ) = 0
   10 CONTINUE
      CALL CGEQPF( P, N, B, LDB, IWORK, TAU, WORK, RWORK, INFO )
*
*     Update A := A*P
*
      CALL CLAPMT( FORWRD, M, N, A, LDA, IWORK )
*
*     Determine the effective rank of matrix B.
*
      L = 0
      DO 20 I = 1, MIN( P, N )
         IF( CABS1( B( I, I ) ).GT.TOLB )
     $      L = L + 1
   20 CONTINUE
*
      IF( WANTV ) THEN
*
*        Copy the details of V, and form V.
*
         CALL CLASET( 'Full', P, P, CZERO, CZERO, V, LDV )
         IF( P.GT.1 )
     $      CALL CLACPY( 'Lower', P-1, N, B( 2, 1 ), LDB, V( 2, 1 ),
     $                   LDV )
         CALL CUNG2R( P, P, MIN( P, N ), V, LDV, TAU, WORK, INFO )
      END IF
*
*     Clean up B
*
      DO 40 J = 1, L - 1
         DO 30 I = J + 1, L
            B( I, J ) = CZERO
   30    CONTINUE
   40 CONTINUE
      IF( P.GT.L )
     $   CALL CLASET( 'Full', P-L, N, CZERO, CZERO, B( L+1, 1 ), LDB )
*
      IF( WANTQ ) THEN
*
*        Set Q = I and Update Q := Q*P
*
         CALL CLASET( 'Full', N, N, CZERO, CONE, Q, LDQ )
         CALL CLAPMT( FORWRD, N, N, Q, LDQ, IWORK )
      END IF
*
      IF( P.GE.L .AND. N.NE.L ) THEN
*
*        RQ factorization of ( S11 S12 ) = ( 0 S12 )*Z
*
         CALL CGERQ2( L, N, B, LDB, TAU, WORK, INFO )
*
*        Update A := A*Z'
*
         CALL CUNMR2( 'Right', 'Conjugate transpose', M, N, L, B, LDB,
     $                TAU, A, LDA, WORK, INFO )
         IF( WANTQ ) THEN
*
*           Update Q := Q*Z'
*
            CALL CUNMR2( 'Right', 'Conjugate transpose', N, N, L, B,
     $                   LDB, TAU, Q, LDQ, WORK, INFO )
         END IF
*
*        Clean up B
*
         CALL CLASET( 'Full', L, N-L, CZERO, CZERO, B, LDB )
         DO 60 J = N - L + 1, N
            DO 50 I = J - N + L + 1, L
               B( I, J ) = CZERO
   50       CONTINUE
   60    CONTINUE
*
      END IF
*
*     Let              N-L     L
*                A = ( A11    A12 ) M,
*
*     then the following does the complete QR decomposition of A11:
*
*              A11 = U*(  0  T12 )*P1'
*                      (  0   0  )
*
      DO 70 I = 1, N - L
         IWORK( I ) = 0
   70 CONTINUE
      CALL CGEQPF( M, N-L, A, LDA, IWORK, TAU, WORK, RWORK, INFO )
*
*     Determine the effective rank of A11
*
      K = 0
      DO 80 I = 1, MIN( M, N-L )
         IF( CABS1( A( I, I ) ).GT.TOLA )
     $      K = K + 1
   80 CONTINUE
*
*     Update A12 := U'*A12, where A12 = A( 1:M, N-L+1:N )
*
      CALL CUNM2R( 'Left', 'Conjugate transpose', M, L, MIN( M, N-L ),
     $             A, LDA, TAU, A( 1, N-L+1 ), LDA, WORK, INFO )
*
      IF( WANTU ) THEN
*
*        Copy the details of U, and form U
*
         CALL CLASET( 'Full', M, M, CZERO, CZERO, U, LDU )
         IF( M.GT.1 )
     $      CALL CLACPY( 'Lower', M-1, N-L, A( 2, 1 ), LDA, U( 2, 1 ),
     $                   LDU )
         CALL CUNG2R( M, M, MIN( M, N-L ), U, LDU, TAU, WORK, INFO )
      END IF
*
      IF( WANTQ ) THEN
*
*        Update Q( 1:N, 1:N-L )  = Q( 1:N, 1:N-L )*P1
*
         CALL CLAPMT( FORWRD, N, N-L, Q, LDQ, IWORK )
      END IF
*
*     Clean up A: set the strictly lower triangular part of
*     A(1:K, 1:K) = 0, and A( K+1:M, 1:N-L ) = 0.
*
      DO 100 J = 1, K - 1
         DO 90 I = J + 1, K
            A( I, J ) = CZERO
   90    CONTINUE
  100 CONTINUE
      IF( M.GT.K )
     $   CALL CLASET( 'Full', M-K, N-L, CZERO, CZERO, A( K+1, 1 ), LDA )
*
      IF( N-L.GT.K ) THEN
*
*        RQ factorization of ( T11 T12 ) = ( 0 T12 )*Z1
*
         CALL CGERQ2( K, N-L, A, LDA, TAU, WORK, INFO )
*
         IF( WANTQ ) THEN
*
*           Update Q( 1:N,1:N-L ) = Q( 1:N,1:N-L )*Z1'
*
            CALL CUNMR2( 'Right', 'Conjugate transpose', N, N-L, K, A,
     $                   LDA, TAU, Q, LDQ, WORK, INFO )
         END IF
*
*        Clean up A
*
         CALL CLASET( 'Full', K, N-L-K, CZERO, CZERO, A, LDA )
         DO 120 J = N - L - K + 1, N - L
            DO 110 I = J - N + L + K + 1, K
               A( I, J ) = CZERO
  110       CONTINUE
  120    CONTINUE
*
      END IF
*
      IF( M.GT.K ) THEN
*
*        QR factorization of A( K+1:M,N-L+1:N )
*
         CALL CGEQR2( M-K, L, A( K+1, N-L+1 ), LDA, TAU, WORK, INFO )
*
         IF( WANTU ) THEN
*
*           Update U(:,K+1:M) := U(:,K+1:M)*U1
*
            CALL CUNM2R( 'Right', 'No transpose', M, M-K, MIN( M-K, L ),
     $                   A( K+1, N-L+1 ), LDA, TAU, U( 1, K+1 ), LDU,
     $                   WORK, INFO )
         END IF
*
*        Clean up
*
         DO 140 J = N - L + 1, N
            DO 130 I = J - N + K + L + 1, M
               A( I, J ) = CZERO
  130       CONTINUE
  140    CONTINUE
*
      END IF
*
      RETURN
*
*     End of CGGSVP
*
      END

      SUBROUTINE SSYSV( UPLO, N, NRHS, A, LDA, IPIV, B, LDB, WORK,
     $                  LWORK, INFO )
*
*  -- LAPACK driver routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          UPLO
      INTEGER            INFO, LDA, LDB, LWORK, N, NRHS
*     ..
*     .. Array Arguments ..
      INTEGER            IPIV( * )
      REAL               A( LDA, * ), B( LDB, * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  SSYSV computes the solution to a real system of linear equations
*     A * X = B,
*  where A is an N-by-N symmetric matrix and X and B are N-by-NRHS
*  matrices.
*
*  The diagonal pivoting method is used to factor A as
*     A = U * D * U**T,  if UPLO = 'U', or
*     A = L * D * L**T,  if UPLO = 'L',
*  where U (or L) is a product of permutation and unit upper (lower)
*  triangular matrices, and D is symmetric and block diagonal with 
*  1-by-1 and 2-by-2 diagonal blocks.  The factored form of A is then
*  used to solve the system of equations A * X = B.
*
*  Arguments
*  =========
*
*  UPLO    (input) CHARACTER*1
*          = 'U':  Upper triangle of A is stored;
*          = 'L':  Lower triangle of A is stored.
*
*  N       (input) INTEGER
*          The number of linear equations, i.e., the order of the
*          matrix A.  N >= 0.
*
*  NRHS    (input) INTEGER
*          The number of right hand sides, i.e., the number of columns
*          of the matrix B.  NRHS >= 0.
*
*  A       (input/output) REAL array, dimension (LDA,N)
*          On entry, the symmetric matrix A.  If UPLO = 'U', the leading
*          N-by-N upper triangular part of A contains the upper
*          triangular part of the matrix A, and the strictly lower
*          triangular part of A is not referenced.  If UPLO = 'L', the
*          leading N-by-N lower triangular part of A contains the lower
*          triangular part of the matrix A, and the strictly upper
*          triangular part of A is not referenced.
*
*          On exit, if INFO = 0, the block diagonal matrix D and the
*          multipliers used to obtain the factor U or L from the
*          factorization A = U*D*U**T or A = L*D*L**T as computed by
*          SSYTRF.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(1,N).
*
*  IPIV    (output) INTEGER array, dimension (N)
*          Details of the interchanges and the block structure of D, as
*          determined by SSYTRF.  If IPIV(k) > 0, then rows and columns
*          k and IPIV(k) were interchanged, and D(k,k) is a 1-by-1
*          diagonal block.  If UPLO = 'U' and IPIV(k) = IPIV(k-1) < 0,
*          then rows and columns k-1 and -IPIV(k) were interchanged and
*          D(k-1:k,k-1:k) is a 2-by-2 diagonal block.  If UPLO = 'L' and
*          IPIV(k) = IPIV(k+1) < 0, then rows and columns k+1 and
*          -IPIV(k) were interchanged and D(k:k+1,k:k+1) is a 2-by-2
*          diagonal block.
*
*  B       (input/output) REAL array, dimension (LDB,NRHS)
*          On entry, the N-by-NRHS right hand side matrix B.
*          On exit, if INFO = 0, the N-by-NRHS solution matrix X.
*
*  LDB     (input) INTEGER
*          The leading dimension of the array B.  LDB >= max(1,N).
*
*  WORK    (workspace/output) REAL array, dimension (LWORK)
*          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*
*  LWORK   (input) INTEGER
*          The length of WORK.  LWORK >= 1, and for best performance
*          LWORK >= N*NB, where NB is the optimal blocksize for
*          SSYTRF.
*
*          If LWORK = -1, then a workspace query is assumed; the routine
*          only calculates the optimal size of the WORK array, returns
*          this value as the first entry of the WORK array, and no error
*          message related to LWORK is issued by XERBLA.
*
*  INFO    (output) INTEGER
*          = 0: successful exit
*          < 0: if INFO = -i, the i-th argument had an illegal value
*          > 0: if INFO = i, D(i,i) is exactly zero.  The factorization
*               has been completed, but the block diagonal matrix D is
*               exactly singular, so the solution could not be computed.
*
*  =====================================================================
*
*     .. Local Scalars ..
      LOGICAL            LQUERY
      INTEGER            LWKOPT, NB
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            ILAENV
      EXTERNAL           ILAENV, LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           SSYTRF, SSYTRS, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      LQUERY = ( LWORK.EQ.-1 )
      IF( .NOT.LSAME( UPLO, 'U' ) .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( NRHS.LT.0 ) THEN
         INFO = -3
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -5
      ELSE IF( LDB.LT.MAX( 1, N ) ) THEN
         INFO = -8
      ELSE IF( LWORK.LT.1 .AND. .NOT.LQUERY ) THEN
         INFO = -10
      END IF
*
      IF( INFO.EQ.0 ) THEN
         NB = ILAENV( 1, 'SSYTRF', UPLO, N, -1, -1, -1 )
         LWKOPT = N*NB
         WORK( 1 ) = LWKOPT
      END IF
*
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'SSYSV ', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         RETURN
      END IF
*
*     Compute the factorization A = U*D*U' or A = L*D*L'.
*
      CALL SSYTRF( UPLO, N, A, LDA, IPIV, WORK, LWORK, INFO )
      IF( INFO.EQ.0 ) THEN
*
*        Solve the system A*X = B, overwriting B with X.
*
         CALL SSYTRS( UPLO, N, NRHS, A, LDA, IPIV, B, LDB, INFO )
*
      END IF
*
      WORK( 1 ) = LWKOPT
*
      RETURN
*
*     End of SSYSV
*
      END

C
C $Id: mdgetd.f,v 1.10 2008-09-18 12:19:11 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MDGETD (WHCH,DVAL)
C
        CHARACTER*(*)    WHCH
        DOUBLE PRECISION DVAL
C
C Declare required common blocks.  See MAPBDX for descriptions of these
C common blocks and the variables in them.
C
        COMMON /MAPCM0/  COS1,DTOR,DTRH,OOPI,PI,PIOF,PIOT,RTDD,RTOD,
     +                   SROT,SIN1,TOPI,TSRT
        DOUBLE PRECISION COS1,DTOR,DTRH,OOPI,PI,PIOF,PIOT,RTDD,RTOD,
     +                   SROT,SIN1,TOPI,TSRT
        SAVE   /MAPCM0/
C
        COMMON /MAPCM4/  GRDR,GRID,GRLA,GRLO,GRPO,OTOL,PDRE,PLA1,PLA2,
     +                   PLA3,PLA4,PLB1,PLB2,PLB3,PLB4,PLNO,PLTO,ROTA,
     +                   SRCH,XLOW,XROW,YBOW,YTOW,IDOT,IDSH,IDTL,ILCW,
     +                   ILTS,JPRJ,ELPF,INTF,LBLF,PRMF
        DOUBLE PRECISION GRDR,GRID,GRLA,GRLO,GRPO,OTOL,PDRE,PLA1,PLA2,
     +                   PLA3,PLA4,PLB1,PLB2,PLB3,PLB4,PLNO,PLTO,ROTA,
     +                   SRCH,XLOW,XROW,YBOW,YTOW
        INTEGER          IDOT,IDSH,IDTL,ILCW,ILTS,JPRJ
        LOGICAL          ELPF,INTF,LBLF,PRMF
        SAVE   /MAPCM4/
C
        COMMON /MAPCMA/  DATL,DBTD,DDTS,DPLT,DPSQ,DSCA,DSSQ
        DOUBLE PRECISION DATL,DBTD,DDTS,DPLT,DPSQ,DSCA,DSSQ
        SAVE   /MAPCMA/
C
        COMMON /MAPCMW/  CSLS,CSLT,SLTD,ISLT
        DOUBLE PRECISION CSLS,CSLT,SLTD
        INTEGER ISLT
        SAVE   /MAPCMW/
C
        COMMON /MAPSAT/  ALFA,BETA,DCSA,DCSB,DSNA,DSNB,SALT,SSMO,SRSS
        DOUBLE PRECISION ALFA,BETA,DCSA,DCSB,DSNA,DSNB,SALT,SSMO,SRSS
        SAVE   /MAPSAT/
C
        IF (ICFELL('MDGETD - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
        IF      (WHCH(1:2).EQ.'DD'.OR.WHCH(1:2).EQ.'dd') THEN
          DVAL=DDTS
        ELSE IF (WHCH(1:2).EQ.'GD'.OR.WHCH(1:2).EQ.'gd') THEN
          DVAL=GRDR
        ELSE IF (WHCH(1:2).EQ.'GN'.OR.WHCH(1:2).EQ.'gn') THEN
          DVAL=GRLO
        ELSE IF (WHCH(1:2).EQ.'GP'.OR.WHCH(1:2).EQ.'gp') THEN
          DVAL=GRPO
        ELSE IF (WHCH(1:2).EQ.'GR'.OR.WHCH(1:2).EQ.'gr') THEN
          DVAL=GRID
        ELSE IF (WHCH(1:2).EQ.'GT'.OR.WHCH(1:2).EQ.'gt') THEN
          DVAL=GRLA
        ELSE IF (WHCH(1:2).EQ.'MV'.OR.WHCH(1:2).EQ.'mv') THEN
          DVAL=DPLT
        ELSE IF (WHCH(1:2).EQ.'OT'.OR.WHCH(1:2).EQ.'ot') THEN
          DVAL=OTOL
        ELSE IF (WHCH(1:2).EQ.'PN'.OR.WHCH(1:2).EQ.'pn') THEN
          DVAL=PLNO
        ELSE IF (WHCH(1:2).EQ.'PT'.OR.WHCH(1:2).EQ.'pt') THEN
          DVAL=PLTO
        ELSE IF (WHCH(1:2).EQ.'P1'.OR.WHCH(1:2).EQ.'p1') THEN
          DVAL=PLA1
        ELSE IF (WHCH(1:2).EQ.'P2'.OR.WHCH(1:2).EQ.'p2') THEN
          DVAL=PLA2
        ELSE IF (WHCH(1:2).EQ.'P3'.OR.WHCH(1:2).EQ.'p3') THEN
          DVAL=PLA3
        ELSE IF (WHCH(1:2).EQ.'P4'.OR.WHCH(1:2).EQ.'p4') THEN
          DVAL=PLA4
        ELSE IF (WHCH(1:2).EQ.'P5'.OR.WHCH(1:2).EQ.'p5') THEN
          DVAL=PLB1
        ELSE IF (WHCH(1:2).EQ.'P6'.OR.WHCH(1:2).EQ.'p6') THEN
          DVAL=PLB2
        ELSE IF (WHCH(1:2).EQ.'P7'.OR.WHCH(1:2).EQ.'p7') THEN
          DVAL=PLB3
        ELSE IF (WHCH(1:2).EQ.'P8'.OR.WHCH(1:2).EQ.'p8') THEN
          DVAL=PLB4
        ELSE IF (WHCH(1:2).EQ.'RE'.OR.WHCH(1:2).EQ.'re') THEN
          DVAL=PDRE
        ELSE IF (WHCH(1:2).EQ.'RO'.OR.WHCH(1:2).EQ.'ro') THEN
          DVAL=ROTA
        ELSE IF (WHCH(1:2).EQ.'SA'.OR.WHCH(1:2).EQ.'sa') THEN
          DVAL=SALT
        ELSE IF (WHCH(1:2).EQ.'SL'.OR.WHCH(1:2).EQ.'sl') THEN
          DVAL=SLTD
        ELSE IF (WHCH(1:2).EQ.'S1'.OR.WHCH(1:2).EQ.'s1') THEN
          DVAL=ALFA
        ELSE IF (WHCH(1:2).EQ.'S2'.OR.WHCH(1:2).EQ.'s2') THEN
          DVAL=BETA
        ELSE IF (WHCH(1:2).EQ.'SR'.OR.WHCH(1:2).EQ.'sr') THEN
          DVAL=SRCH
        ELSE IF (WHCH(1:2).EQ.'XL'.OR.WHCH(1:2).EQ.'xl') THEN
          DVAL=XLOW
        ELSE IF (WHCH(1:2).EQ.'XR'.OR.WHCH(1:2).EQ.'xr') THEN
          DVAL=XROW
        ELSE IF (WHCH(1:2).EQ.'YB'.OR.WHCH(1:2).EQ.'yb') THEN
          DVAL=YBOW
        ELSE IF (WHCH(1:2).EQ.'YT'.OR.WHCH(1:2).EQ.'yt') THEN
          DVAL=YTOW
        ELSE
          GO TO 901
        END IF
C
C Done.
C
        RETURN
C
C Error exits.
C
  901   CALL MDPCEM ('MDGETD - UNKNOWN PARAMETER NAME ',WHCH,2,1)
        DVAL=0.D0
        RETURN
C
      END

C
C	$Id: gsmksc.f,v 1.5 2008-07-27 00:21:02 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GSMKSC (MSZSF)
C
C  SET MARKER SIZE SCALE FACTOR
C
      INTEGER ESMKSC
      PARAMETER (ESMKSC=24)
C
      include 'gkscom.h'
C
      REAL MSZSF
C
C  Check if GKS is in the proper state.
C
      CALL GZCKST(8,ESMKSC,IER)
      IF (IER .NE. 0) RETURN
C
C  Set the current marker scale factor in the GKS state list.
C
      CMKS = MSZSF
C
C  Invoke the workstation interface.
C
      FCODE = 27
      CONT  = 0
      CALL GZROI(0)
      RL1   = 1
      RL2   = 1
      RX(1) = MSZSF
      CALL GZTOWK
      IF (RERR .NE. 0) THEN
        ERS = 1
        CALL GERHND(RERR,ESMKSC,ERF)
        ERS = 0
      ENDIF
C
      RETURN
      END

      PROGRAM AREX02
C
C This program illustrates the use of the routine ARMVAM, particularly
C as it is used in the process of recovering from area map overflow
C problems.  Because this example is intended to be strictly FORTRAN
C 77, no attempt is made to do real dynamic storage allocation;
C instead, an area map array of a fixed size is used, and the AREAS
C routines are only told about a part of that array.  Still, the idea
C is much the same as one would use in C or, presumably, in FORTRAN
C 90 (if and when compilers become generally available for FORTRAN 90).
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
        PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Define the size of the area map array to be used.  The part of this
C used by the AREAS routines will fluctuate as needed.
C
        PARAMETER (LAMA=6000)
C
C Define the sizes of the work arrays to be used by ARSCAM.
C
        PARAMETER (NCRA=1000,NGPS=10)
C
C Declare the area map array.
C
        DIMENSION IAMA(LAMA)
C
C Declare the work arrays to be used by ARSCAM.
C
        DIMENSION XCRA(NCRA),YCRA(NCRA),IAAI(NGPS),IAGI(NGPS)
C
C Declare arrays to hold a perimeter, to be used for all three groups
C of edges.
C
        DIMENSION PERIX(5),PERIY(5)
C
C Declare arrays for group 1 edges.
C
        DIMENSION G1E1X(9),G1E1Y(9)
        DIMENSION G1E2X(5),G1E2Y(5)
C
C Declare arrays for group 3 edges.
C
        DIMENSION G3E1X(2),G3E1Y(2)
        DIMENSION G3E2X(2),G3E2Y(2)
        DIMENSION G3E3X(2),G3E3Y(2)
        DIMENSION G3E4X(2),G3E4Y(2)
        DIMENSION G3E5X(2),G3E5Y(2)
        DIMENSION G3E6X(2),G3E6Y(2)
        DIMENSION G3E7X(2),G3E7Y(2)
        DIMENSION G3E8X(2),G3E8Y(2)
        DIMENSION G3E9X(2),G3E9Y(2)
C
C Declare arrays for group 5 edges.
C
        DIMENSION G5E1X(7),G5E1Y(7)
C
C Declare the routine that will color the areas defined by the area map.
C
        EXTERNAL COLRAM
C
C Define the perimeter for all three groups of edges.
C
        DATA PERIX / .90,.90,.10,.10,.90 /
        DATA PERIY / .10,.90,.90,.10,.10 /
C
C Define the group 1 edges.
C
        DATA G1E1X / .75,.68,.50,.32,.25,.32,.50,.68,.75 /
        DATA G1E1Y / .50,.68,.75,.68,.50,.32,.25,.32,.50 /
C
        DATA G1E2X / .60,.60,.40,.40,.60 /
        DATA G1E2Y / .40,.60,.60,.40,.40 /
C
C Define the group 3 edges.
C
        DATA G3E1X / .10,.20 /
        DATA G3E1Y / .80,.90 /
C
        DATA G3E2X / .10,.40 /
        DATA G3E2Y / .60,.90 /
C
        DATA G3E3X / .10,.60 /
        DATA G3E3Y / .40,.90 /
C
        DATA G3E4X / .10,.80 /
        DATA G3E4Y / .20,.90 /
C
        DATA G3E5X / .20,.90 /
        DATA G3E5Y / .10,.80 /
C
        DATA G3E6X / .40,.90 /
        DATA G3E6Y / .10,.60 /
C
        DATA G3E7X / .60,.90 /
        DATA G3E7Y / .10,.40 /
C
        DATA G3E8X / .80,.90 /
        DATA G3E8Y / .10,.20 /
C
        DATA G3E9X / .40,.20 /
        DATA G3E9Y / .70,.50 /
C
C Define the group 5 edges.
C
        DATA G5E1X / .50,.80,.80,.50,.50,.20,.35 /
        DATA G5E1Y / .50,.50,.80,.80,.50,.20,.35 /
C
C Open GKS.
C
        CALL GOPKS (IERRF, ISZDM)
        CALL GOPWK (IWKID, LUNIT, IWTYPE)
        CALL GACWK (IWKID)
C
C Change the GKS "fill area interior style" to be "solid".
C
        CALL GSFAIS (1)
C
C Define the colors to be used.
C
        CALL GSCR (IWKID,0,0.,0.,0.)
        CALL GSCR (IWKID,1,1.,1.,1.)
C
        DO 101 I=1,9
          S=MAX(0.,MIN(1.,REAL(I)/9.))
          T=MAX(0.,MIN(1.,1.-S))
          CALL GSCR (IWKID,10+I,S,T,0.)
          CALL GSCR (IWKID,20+I,S,T,1.)
  101   CONTINUE
C
C Define the mapping from the user system to the plotter frame.
C
        CALL SET (.05,.95,.05,.95,0.,1.,0.,1.,1)
C
C Tell AREAS to make identifiers larger and further from the arrows
C and make the arrowheads bigger.
C
        CALL ARSETR ('ID - IDENTIFIER DISTANCE',.02)
        CALL ARSETR ('IS - IDENTIFIER SIZE',.01)
        CALL ARSETR ('AL - ARROWHEAD LENGTH',.04)
        CALL ARSETR ('AW - ARROWHEAD WIDTH',.008)
C
C Initialize the variable that keeps track of how much space is
C currently used in the area map.
C
        NAMA=500
C
C Initialize the area map.
C
        CALL ARINAM (IAMA,NAMA)
C
C Put group 1 edges into the area map.  Instead of calling the AREAS
C routine AREDAM directly, we call an example routine that puts the
C package SETER into recovery mode, checks for overflow of the area
C map array, and uses ARMVAM to recover.
C
        CALL EXEDAM (IAMA,LAMA,NAMA,PERIX,PERIY,5,1, 0,-1)
        CALL EXEDAM (IAMA,LAMA,NAMA,G1E1X,G1E1Y,9,1, 2, 1)
        CALL EXEDAM (IAMA,LAMA,NAMA,G1E2X,G1E2Y,5,1, 1, 2)
C
C Put group 3 edges into the area map.  Again, instead of calling the
C AREAS routine AREDAM directly, we call EXEDAM to allow for error
C recovery.
C
        CALL EXEDAM (IAMA,LAMA,NAMA,PERIX,PERIY,5,3, 0,-1)
        CALL EXEDAM (IAMA,LAMA,NAMA,G3E1X,G3E1Y,2,3, 1, 2)
        CALL EXEDAM (IAMA,LAMA,NAMA,G3E2X,G3E2Y,2,3, 2, 3)
        CALL EXEDAM (IAMA,LAMA,NAMA,G3E3X,G3E3Y,2,3, 3, 4)
        CALL EXEDAM (IAMA,LAMA,NAMA,G3E4X,G3E4Y,2,3, 4, 5)
        CALL EXEDAM (IAMA,LAMA,NAMA,G3E5X,G3E5Y,2,3, 5, 6)
        CALL EXEDAM (IAMA,LAMA,NAMA,G3E6X,G3E6Y,2,3, 6, 7)
        CALL EXEDAM (IAMA,LAMA,NAMA,G3E7X,G3E7Y,2,3, 7, 8)
        CALL EXEDAM (IAMA,LAMA,NAMA,G3E8X,G3E8Y,2,3, 8, 9)
        CALL EXEDAM (IAMA,LAMA,NAMA,G3E9X,G3E9Y,2,3, 9,10)
C
C Put group 5 edges into the area map.  Again, instead of calling the
C AREAS routine AREDAM directly, we call EXEDAM to allow for error
C recovery.
C
        CALL EXEDAM (IAMA,LAMA,NAMA,PERIX,PERIY,5,5, 0,-1)
        CALL EXEDAM (IAMA,LAMA,NAMA,G5E1X,G5E1Y,7,5,-1, 0)
C
C Preprocess the area map.  Again, instead of calling the AREAS
C routine ARPRAM directly, we call EXPRAM to allow for error
C recovery.  Do debug plots to make sure things are working okay.
C
        CALL ARDBPA (IAMA,1,'BEFORE CALLING ARPRAM - GROUP 1')
        CALL ARDBPA (IAMA,3,'BEFORE CALLING ARPRAM - GROUP 3')
        CALL ARDBPA (IAMA,5,'BEFORE CALLING ARPRAM - GROUP 5')
        CALL EXPRAM (IAMA,LAMA,NAMA,0,0,0)
        CALL ARDBPA (IAMA,1,'AFTER CALLING ARPRAM - GROUP 1')
        CALL ARDBPA (IAMA,3,'AFTER CALLING ARPRAM - GROUP 3')
        CALL ARDBPA (IAMA,5,'AFTER CALLING ARPRAM - GROUP 5')
C
C Pack the contents of the area map into the smallest possible space.
C
        CALL ARMVAM (IAMA,IAMA,IAMA(1)-(IAMA(6)-IAMA(5)-1))
C
C Scan the area map.  Again, instead of calling the AREAS routine
C ARSCAM directly, we call EXSCAM to allow for error recovery.
C
        CALL EXSCAM (IAMA,LAMA,NAMA,XCRA,YCRA,NCRA,IAAI,IAGI,NGPS,
     +                                                     COLRAM)
C
C Advance the frame.
C
        CALL FRAME
C
C Close GKS.
C
        CALL GDAWK (IWKID)
        CALL GCLWK (IWKID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END



      SUBROUTINE COLRAM (XCRA,YCRA,NCRA,IAAI,IAGI,NGPS)
C
C This routine colors the areas defined by the area map.
C
        DIMENSION XCRA(*),YCRA(*),IAAI(*),IAGI(*)
C
C Pick off the individual group identifiers.
C
        IAI1=0
        IAI3=0
        IAI5=0
C
        DO 101 I=1,NGPS
          IF (IAGI(I).EQ.1) IAI1=IAAI(I)
          IF (IAGI(I).EQ.3) IAI3=IAAI(I)
          IF (IAGI(I).EQ.5) IAI5=IAAI(I)
  101   CONTINUE
C
C Skip coloring if either of the first two area identifiers is zero or
C negative or if the final one is negative.
C
        IF (IAI1.LE.0.OR.IAI3.LE.0.OR.IAI5.LT.0) GO TO 102
C
C Otherwise, color the area, using a color index which is obtained by
C combining the area identifiers for groups 1 and 3.
C
        CALL GSFACI (10*IAI1+IAI3)
        CALL GFA    (NCRA-1,XCRA,YCRA)
C
C Done.
C
  102   RETURN
C
      END



      SUBROUTINE EXEDAM (IAMA,LAMA,NAMA,XCRA,YCRA,NCRA,IGID,IAIL,IAIR)
C
        DIMENSION IAMA(LAMA),XCRA(NCRA),YCRA(NCRA)
C
C This routine implements an interface to the AREAS routine AREDAM
C that recovers from area map overflow problems.
C
        CHARACTER*113 SEMESS
C
C Put SETER into recovery mode, saving the previous setting of the
C recovery-mode flag in IROLD.
C
        CALL ENTSR (IROLD,1)
C
C Attempt to put the edges in the error map.
C
  101   CALL AREDAM (IAMA,XCRA,YCRA,NCRA,IGID,IAIL,IAIR)
C
C See if a recoverable error occurred during the call to AREDAM.
C
        IF (NERRO(NERR).NE.0) THEN
C
C A recoverable error occurred.  See if it was due to overflowing the
C area map array and if we can do something about it.
C
          IF (SEMESS(2).EQ.'AREA-MAP ARRAY OVERFLOW'.AND.
     +                                          NAMA.LT.LAMA) THEN
C
C Recover from an area map array overflow.  First, log what's happening.
C
            PRINT * , 'EXEDAM - OVERFLOW RECOVERY - NAMA = ', NAMA
C
C Clear the internal error flag in SETER.
C
            CALL ERROF
C
C Move the area map to a slightly larger part of the area map array.
C
            NAMA=MIN(NAMA+100,LAMA)
            CALL ARMVAM (IAMA,IAMA,NAMA)
C
C Go back to try the call to AREDAM again.
C
            GO TO 101
C
          ELSE
C
C Either the error is not an overflow error or we can't do anything
C about it.  Exit with a fatal error message.
C
            CALL SETER ('EXEDAM - CAN''T GET AROUND AREDAM ERROR',1,2)
C
          END IF
C
        ELSE
C
C No recoverable error occurred.  Restore the original value of SETER's
C recovery-mode flag.
C
          CALL RETSR (IROLD)
C
        END IF
C
C Done.
C
        RETURN
C
      END



      SUBROUTINE EXPRAM (IAMA,LAMA,NAMA,IFL1,IFL2,IFL3)
C
        DIMENSION IAMA(LAMA)
C
C This routine implements an interface to the AREAS routine ARPRAM
C that recovers from area-map overflow problems.
C
        CHARACTER*113 SEMESS
C
C Put SETER into recovery mode, saving the previous setting of the
C recovery-mode flag in IROLD.
C
        CALL ENTSR (IROLD,1)
C
C Attempt to pre-process the area map.
C
  101   CALL ARPRAM (IAMA,IFL1,IFL2,IFL3)
C
C See if a recoverable error occurred during the call to ARPRAM.
C
        IF (NERRO(NERR).NE.0) THEN
C
C A recoverable error occurred.  See if it was due to overflowing the
C area map array and if we can do something about it.
C
          IF (SEMESS(2).EQ.'AREA-MAP ARRAY OVERFLOW'.AND.
     +                                                NAMA.LT.LAMA) THEN
C
C Recover from an area map array overflow.  First, log what's happening.
C
            PRINT * , 'EXPRAM - OVERFLOW RECOVERY - NAMA = ', NAMA
C
C Clear the internal error flag in SETER.
C
            CALL ERROF
C
C Move the area map to a slightly larger part of the area map array.
C
            NAMA=MIN(NAMA+100,LAMA)
            CALL ARMVAM (IAMA,IAMA,NAMA)
C
C Go back to try the call to ARPRAM again.
C
            GO TO 101
C
          ELSE
C
C Either the error is not an overflow error or we can't do anything
C about it.  Exit with a fatal error message.
C
            CALL SETER ('EXPRAM - CAN''T GET AROUND ARPRAM ERROR',1,2)
C
          END IF
C
        ELSE
C
C No recoverable error occurred.  Restore the original value of SETER's
C recovery-mode flag.
C
          CALL RETSR (IROLD)
C
        END IF
C
C Done.
C
        RETURN
C
      END



      SUBROUTINE EXSCAM (IAMA,LAMA,NAMA,XCRA,YCRA,NCRA,IAAI,IAGI,NGPS,
     +                                                           URPA)
C
        DIMENSION IAMA(LAMA),XCRA(NCRA),YCRA(NCRA),IAAI(NGPS),IAGI(NGPS)
C
C This routine implements an interface to the AREAS routine ARPRAM
C that recovers from area-map overflow problems.
C
        CHARACTER*113 SEMESS
C
C Put SETER into recovery mode, saving the previous setting of the
C recovery-mode flag in IROLD.
C
        CALL ENTSR (IROLD,1)
C
C Attempt to scan the area map.
C
  101   CALL ARSCAM (IAMA,XCRA,YCRA,NCRA,IAAI,IAGI,NGPS,URPA)
C
C See if a recoverable error occurred during the call to ARSCAM.
C
        IF (NERRO(NERR).NE.0) THEN
C
C A recoverable error occurred.  See if it was due to overflowing the
C area map array and if we can do something about it.
C
          IF (SEMESS(2).EQ.'AREA-MAP ARRAY OVERFLOW'.AND.
     +                                                NAMA.LT.LAMA) THEN
C
C Recover from an area map array overflow.  First, log what's happening.
C
            PRINT * , 'EXSCAM - OVERFLOW RECOVERY - NAMA = ', NAMA
C
C Clear the internal error flag in SETER.
C
            CALL ERROF
C
C Move the area map to a slightly larger part of the area map array.
C
            NAMA=MIN(NAMA+100,LAMA)
            CALL ARMVAM (IAMA,IAMA,NAMA)
C
C Go back to try the call to ARPRAM again.
C
            GO TO 101
C
          ELSE
C
C Either the error is not an overflow error or we can't do anything
C about it.  Exit with a fatal error message.
C
            CALL SETER ('EXSCAM - CAN''T GET AROUND ARSCAM ERROR',1,2)
C
          END IF
C
        ELSE
C
C No recoverable error occurred.  Restore the original value of SETER's
C recovery-mode flag.
C
          CALL RETSR (IROLD)
C
        END IF
C
C Done.
C
        RETURN
C
      END

C
C $Id: gzgte1.f,v 1.6 2008-07-27 00:21:03 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GZGTE1(INDEX,NUM,ERMSG)
C
C  Given an index INDEX into the error table, this subroutine
C  returns the NCAR GKS error number in NUM and the error
C  message string in ERMSG (the length of ERMSG will be a
C  maximum of 210 characters).
C
      CHARACTER*(*) ERMSG
C
      include 'gkscom.h'
C
      IF (INDEX.LE.NUMERS .AND. INDEX.GE.1) THEN
        NUM = IERNMS(INDEX)
        ERMSG = ERMSGS(INDEX)
      ELSE
        NUM = -100
        ERMSG = ERMSGS(79)
      ENDIF
C
      RETURN
      END

      SUBROUTINE DLAED7( ICOMPQ, N, QSIZ, TLVLS, CURLVL, CURPBM, D, Q,
     $                   LDQ, INDXQ, RHO, CUTPNT, QSTORE, QPTR, PRMPTR,
     $                   PERM, GIVPTR, GIVCOL, GIVNUM, WORK, IWORK,
     $                   INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      INTEGER            CURLVL, CURPBM, CUTPNT, ICOMPQ, INFO, LDQ, N,
     $                   QSIZ, TLVLS
      DOUBLE PRECISION   RHO
*     ..
*     .. Array Arguments ..
      INTEGER            GIVCOL( 2, * ), GIVPTR( * ), INDXQ( * ),
     $                   IWORK( * ), PERM( * ), PRMPTR( * ), QPTR( * )
      DOUBLE PRECISION   D( * ), GIVNUM( 2, * ), Q( LDQ, * ),
     $                   QSTORE( * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  DLAED7 computes the updated eigensystem of a diagonal
*  matrix after modification by a rank-one symmetric matrix. This
*  routine is used only for the eigenproblem which requires all
*  eigenvalues and optionally eigenvectors of a dense symmetric matrix
*  that has been reduced to tridiagonal form.  DLAED1 handles
*  the case in which all eigenvalues and eigenvectors of a symmetric
*  tridiagonal matrix are desired.
*
*    T = Q(in) ( D(in) + RHO * Z*Z' ) Q'(in) = Q(out) * D(out) * Q'(out)
*
*     where Z = Q'u, u is a vector of length N with ones in the
*     CUTPNT and CUTPNT + 1 th elements and zeros elsewhere.
*
*     The eigenvectors of the original matrix are stored in Q, and the
*     eigenvalues are in D.  The algorithm consists of three stages:
*
*        The first stage consists of deflating the size of the problem
*        when there are multiple eigenvalues or if there is a zero in
*        the Z vector.  For each such occurence the dimension of the
*        secular equation problem is reduced by one.  This stage is
*        performed by the routine DLAED8.
*
*        The second stage consists of calculating the updated
*        eigenvalues. This is done by finding the roots of the secular
*        equation via the routine DLAED4 (as called by DLAED9).
*        This routine also calculates the eigenvectors of the current
*        problem.
*
*        The final stage consists of computing the updated eigenvectors
*        directly using the updated eigenvalues.  The eigenvectors for
*        the current problem are multiplied with the eigenvectors from
*        the overall problem.
*
*  Arguments
*  =========
*
*  ICOMPQ  (input) INTEGER
*          = 0:  Compute eigenvalues only.
*          = 1:  Compute eigenvectors of original dense symmetric matrix
*                also.  On entry, Q contains the orthogonal matrix used
*                to reduce the original matrix to tridiagonal form.
*
*  N      (input) INTEGER
*         The dimension of the symmetric tridiagonal matrix.  N >= 0.
*
*  QSIZ   (input) INTEGER
*         The dimension of the orthogonal matrix used to reduce
*         the full matrix to tridiagonal form.  QSIZ >= N if ICOMPQ = 1.
*
*  TLVLS  (input) INTEGER
*         The total number of merging levels in the overall divide and
*         conquer tree.
*
*  CURLVL (input) INTEGER
*         The current level in the overall merge routine,
*         0 <= CURLVL <= TLVLS.
*
*  CURPBM (input) INTEGER
*         The current problem in the current level in the overall
*         merge routine (counting from upper left to lower right).
*
*  D      (input/output) DOUBLE PRECISION array, dimension (N)
*         On entry, the eigenvalues of the rank-1-perturbed matrix.
*         On exit, the eigenvalues of the repaired matrix.
*
*  Q      (input/output) DOUBLE PRECISION array, dimension (LDQ, N)
*         On entry, the eigenvectors of the rank-1-perturbed matrix.
*         On exit, the eigenvectors of the repaired tridiagonal matrix.
*
*  LDQ    (input) INTEGER
*         The leading dimension of the array Q.  LDQ >= max(1,N).
*
*  INDXQ  (output) INTEGER array, dimension (N)
*         The permutation which will reintegrate the subproblem just
*         solved back into sorted order, i.e., D( INDXQ( I = 1, N ) )
*         will be in ascending order.
*
*  RHO    (input) DOUBLE PRECISION
*         The subdiagonal element used to create the rank-1
*         modification.
*
*  CUTPNT (input) INTEGER
*         Contains the location of the last eigenvalue in the leading
*         sub-matrix.  min(1,N) <= CUTPNT <= N.
*
*  QSTORE (input/output) DOUBLE PRECISION array, dimension (N**2+1)
*         Stores eigenvectors of submatrices encountered during
*         divide and conquer, packed together. QPTR points to
*         beginning of the submatrices.
*
*  QPTR   (input/output) INTEGER array, dimension (N+2)
*         List of indices pointing to beginning of submatrices stored
*         in QSTORE. The submatrices are numbered starting at the
*         bottom left of the divide and conquer tree, from left to
*         right and bottom to top.
*
*  PRMPTR (input) INTEGER array, dimension (N lg N)
*         Contains a list of pointers which indicate where in PERM a
*         level's permutation is stored.  PRMPTR(i+1) - PRMPTR(i)
*         indicates the size of the permutation and also the size of
*         the full, non-deflated problem.
*
*  PERM   (input) INTEGER array, dimension (N lg N)
*         Contains the permutations (from deflation and sorting) to be
*         applied to each eigenblock.
*
*  GIVPTR (input) INTEGER array, dimension (N lg N)
*         Contains a list of pointers which indicate where in GIVCOL a
*         level's Givens rotations are stored.  GIVPTR(i+1) - GIVPTR(i)
*         indicates the number of Givens rotations.
*
*  GIVCOL (input) INTEGER array, dimension (2, N lg N)
*         Each pair of numbers indicates a pair of columns to take place
*         in a Givens rotation.
*
*  GIVNUM (input) DOUBLE PRECISION array, dimension (2, N lg N)
*         Each number indicates the S value to be used in the
*         corresponding Givens rotation.
*
*  WORK   (workspace) DOUBLE PRECISION array, dimension (3*N+QSIZ*N)
*
*  IWORK  (workspace) INTEGER array, dimension (4*N)
*
*  INFO   (output) INTEGER
*          = 0:  successful exit.
*          < 0:  if INFO = -i, the i-th argument had an illegal value.
*          > 0:  if INFO = 1, an eigenvalue did not converge
*
*  Further Details
*  ===============
*
*  Based on contributions by
*     Jeff Rutter, Computer Science Division, University of California
*     at Berkeley, USA
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ONE, ZERO
      PARAMETER          ( ONE = 1.0D0, ZERO = 0.0D0 )
*     ..
*     .. Local Scalars ..
      INTEGER            COLTYP, CURR, I, IDLMDA, INDX, INDXC, INDXP,
     $                   IQ2, IS, IW, IZ, K, LDQ2, N1, N2, PTR
*     ..
*     .. External Subroutines ..
      EXTERNAL           DGEMM, DLAED8, DLAED9, DLAEDA, DLAMRG, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
*
      IF( ICOMPQ.LT.0 .OR. ICOMPQ.GT.1 ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( ICOMPQ.EQ.1 .AND. QSIZ.LT.N ) THEN
         INFO = -4
      ELSE IF( LDQ.LT.MAX( 1, N ) ) THEN
         INFO = -9
      ELSE IF( MIN( 1, N ).GT.CUTPNT .OR. N.LT.CUTPNT ) THEN
         INFO = -12
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DLAED7', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
*
*     The following values are for bookkeeping purposes only.  They are
*     integer pointers which indicate the portion of the workspace
*     used by a particular array in DLAED8 and DLAED9.
*
      IF( ICOMPQ.EQ.1 ) THEN
         LDQ2 = QSIZ
      ELSE
         LDQ2 = N
      END IF
*
      IZ = 1
      IDLMDA = IZ + N
      IW = IDLMDA + N
      IQ2 = IW + N
      IS = IQ2 + N*LDQ2
*
      INDX = 1
      INDXC = INDX + N
      COLTYP = INDXC + N
      INDXP = COLTYP + N
*
*     Form the z-vector which consists of the last row of Q_1 and the
*     first row of Q_2.
*
      PTR = 1 + 2**TLVLS
      DO 10 I = 1, CURLVL - 1
         PTR = PTR + 2**( TLVLS-I )
   10 CONTINUE
      CURR = PTR + CURPBM
      CALL DLAEDA( N, TLVLS, CURLVL, CURPBM, PRMPTR, PERM, GIVPTR,
     $             GIVCOL, GIVNUM, QSTORE, QPTR, WORK( IZ ),
     $             WORK( IZ+N ), INFO )
*
*     When solving the final problem, we no longer need the stored data,
*     so we will overwrite the data from this level onto the previously
*     used storage space.
*
      IF( CURLVL.EQ.TLVLS ) THEN
         QPTR( CURR ) = 1
         PRMPTR( CURR ) = 1
         GIVPTR( CURR ) = 1
      END IF
*
*     Sort and Deflate eigenvalues.
*
      CALL DLAED8( ICOMPQ, K, N, QSIZ, D, Q, LDQ, INDXQ, RHO, CUTPNT,
     $             WORK( IZ ), WORK( IDLMDA ), WORK( IQ2 ), LDQ2,
     $             WORK( IW ), PERM( PRMPTR( CURR ) ), GIVPTR( CURR+1 ),
     $             GIVCOL( 1, GIVPTR( CURR ) ),
     $             GIVNUM( 1, GIVPTR( CURR ) ), IWORK( INDXP ),
     $             IWORK( INDX ), INFO )
      PRMPTR( CURR+1 ) = PRMPTR( CURR ) + N
      GIVPTR( CURR+1 ) = GIVPTR( CURR+1 ) + GIVPTR( CURR )
*
*     Solve Secular Equation.
*
      IF( K.NE.0 ) THEN
         CALL DLAED9( K, 1, K, N, D, WORK( IS ), K, RHO, WORK( IDLMDA ),
     $                WORK( IW ), QSTORE( QPTR( CURR ) ), K, INFO )
         IF( INFO.NE.0 )
     $      GO TO 30
         IF( ICOMPQ.EQ.1 ) THEN
            CALL DGEMM( 'N', 'N', QSIZ, K, K, ONE, WORK( IQ2 ), LDQ2,
     $                  QSTORE( QPTR( CURR ) ), K, ZERO, Q, LDQ )
         END IF
         QPTR( CURR+1 ) = QPTR( CURR ) + K**2
*
*     Prepare the INDXQ sorting permutation.
*
         N1 = K
         N2 = N - K
         CALL DLAMRG( N1, N2, D, 1, -1, INDXQ )
      ELSE
         QPTR( CURR+1 ) = QPTR( CURR )
         DO 20 I = 1, N
            INDXQ( I ) = I
   20    CONTINUE
      END IF
*
   30 CONTINUE
      RETURN
*
*     End of DLAED7
*
      END

C
C	$Id: gwipl.f,v 1.7 2008-07-27 00:21:08 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GWIPL
C
C  Process POLYLINE elements.
C
      include 'gksin.h'
      include 'gwiio.h'
      include 'gwiins.h'
      include 'gwiwsl.h'
      include 'gwiarq.h'
      include 'gwiast.h'
      include 'gwiadc.h'
      include 'gwiopc.h'
      include 'gwienu.h'
C
      INTEGER  KALL, IPRIM, NBYTES, NUMO, K, INDX1, INDX2
      DIMENSION NUMO(2)
      SAVE
C
      DATA KALL/0/ , IPRIM/1/
C
      KALL = KALL+1
      IF  (KALL .EQ. 1) THEN
C
C  If the picture is empty, send the clip indicator and rectangle;
C  set the WSL entry "DISPLAY SURFACE EMPTY" to "NOT EMPTY".
C
        IF (MDEMPT .EQ. GEMPTY) CALL GWICLP(1)
        MDEMPT = GNEMPT
C
C  Process pending attributes.
C
        IF (AGPEND(IPRIM)) THEN
C
C  Some changes are pending.
C
          IF (VALCHG(IVPLIX)) THEN
C
C  Send bundle index.
C
            NBYTES = 1+(MIXFW-1)/8
            CALL GWPTNI (CLLBIX,  IDLBIX,  NBYTES,  RERR)
            CALL GWPTPR (MRPLIX, MIXFW,  1, RERR)
            IF (RERR .NE. 0) RETURN
C
C  Set sent value to requested, clear change flag.
C
            MSPLIX         = MRPLIX
            VALCHG(IVPLIX) = .FALSE.
          END IF
          IF (VALCHG(IVLTYP)) THEN
C
C  LINETYPE
C
            NBYTES = 1+(MIXFW-1)/8
            CALL GWPTNI (CLLTYP,  IDLTYP,  NBYTES,  RERR)
            CALL GWPTPR (MRLTYP, MIXFW,  1, RERR)
            IF (RERR .NE. 0) RETURN
            MSLTYP = MRLTYP
            VALCHG(IVLTYP) = .FALSE.
          ENDIF
          IF (VALCHG(IVLWSC)) THEN
C
C  LINEWIDTH SCALE FACTOR
C
            NBYTES = 1+(2*MCFPP-1)/8
            CALL GWPTNI (CLLWID,  IDLWID,  NBYTES,  RERR)
            CALL GFLCNV (ARLWSC,NUMO)
            CALL GWPTPR (NUMO, MCFPP,  2, RERR)
            IF (RERR .NE. 0) RETURN
C
C  Set sent value to requested, clear change flag.
C
            ASLWSC         = ARLWSC
            VALCHG(IVLWSC) = .FALSE.
          ENDIF
          IF (VALCHG(IVPLCI)) THEN
C
C  Line color index.
C
            NBYTES = 1+(MCIXFW-1)/8
            CALL GWPTNI (CLLCLR, IDLCLR, NBYTES,  RERR)
            CALL GWPTPR (MRPLCI, MCIXFW,  1, RERR)
            IF (RERR .NE. 0) RETURN
C
C  Set sent value to requested, clear change flag.
C
            MSPLCI         = MRPLCI
            VALCHG(IVPLCI) = .FALSE.
          ENDIF
          IF (ANYASF) THEN
C
C  Some ASF has changed.
C
            CALL GWISAS (IPRIM, RERR)
            IF (RERR.NE.0)  RETURN
          END IF
C
C  Clear aggregate change variable.
C
          AGPEND(IPRIM) = .FALSE.
        ENDIF
C
C  Treat first call, put out opcode, and points
C
C  Put out opcode (class and ID) and total length.
C
        NBYTES = 1+(2*RL1*MVDCFW-1)/8
        CALL GWPTNI (CLPLIN,  IDPLIN,  NBYTES,  RERR)
        IF (RERR .NE. 0) RETURN
C
C  Put out first points array.
C
C  Truncate points to limits of NDC unit square, convert to VDC,
C  and store in WPXPY.
C
        DO 30 K=1,RL2
          INDX1 = 2*K-1
          INDX2 = INDX1+1
          WPXPY(INDX1) = MXOFF + INT(REAL(MXSCAL)*
     +                   (MAX(0.,MIN(1.0,RX(K)))))
          WPXPY(INDX2) = MYOFF + INT(REAL(MYSCAL)*
     +                   (MAX(0.,MIN(1.0,RY(K)))))
   30   CONTINUE
C
C Send out points.
C
        CALL GWPTPR (WPXPY,  MVDCFW,     2*RL2, RERR)
        IF (RERR .NE. 0) RETURN
C
C  If there is to be no continuation, reset the parameter "KALL".
C
        IF (CONT .EQ. 0) THEN
          KALL = 0
          RETURN
        ENDIF
      ENDIF
C
C  Treat the continuation calls.
C
      IF (KALL .GT. 1) THEN
C
C  Truncate points to limits of NDC unit square, convert to VDC,
C  and store in WPXPY.
C
        DO 40 K=1,RL2
          INDX1 = 2*K-1
          INDX2 = INDX1+1
          WPXPY(INDX1) = MXOFF + INT(REAL(MXSCAL)*
     +                   (MAX(0.,MIN(1.0,RX(K)))))
          WPXPY(INDX2) = MYOFF + INT(REAL(MYSCAL)*
     +                 (MAX(0.,MIN(1.0,RY(K)))))
   40   CONTINUE
        IF (CONT .EQ. 0) THEN
          CALL GWPTPR (WPXPY,  MVDCFW,     2*RL2, RERR)
          IF (RERR .NE. 0) RETURN
          KALL = 0
        ELSE
          CALL GWPTPR (WPXPY,  MVDCFW,     2*RL2, RERR)
          IF (RERR .NE. 0) RETURN
        ENDIF
      ENDIF
C
      RETURN
      END

C
C	$Id: gqgdp.f,v 1.5 2008-07-27 00:20:59 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE GQGDP(WTYPE,GDP,ERRIND,NBND,BNDL)
C
C  INQUIRE GENERALIZED DRAWING PRIMITIVE
C
      include 'gkscom.h'
C
      INTEGER WTYPE,GDP,ERRIND,NBND,BNDL(4)
C
C  Check if GKS is in the proper state.
C
      CALL GZCKST(8,-1,ERRIND)
      IF (ERRIND .NE. 0) GOTO 100
C
C  Check that the workstation type is valid.
C
      CALL GZCKWK(22,-1,IDUM,WTYPE,ERRIND)
      IF (ERRIND .NE. 0) GO TO 100
C
C  Check if the workstation category is OUTPUT or OUTIN.
C
      CALL GQWKCA(WTYPE,ERRIND,ICAT)
      IF (ICAT.NE.GOUTPT .AND. ICAT.NE.GOUTIN) THEN
        ERRIND = 39
        GO TO 100
      ENDIF
C
C  Invoke interface.
C
      FCODE = -113
      CONT  = 0
      CALL GZROI(0)
      IL1   = 2
      IL2   = 2
      ID(1) = WTYPE
      ID(2) = GDP
      IWK   = -1
      CALL GZIQWK(WTYPE,IWK)
      IF (RERR.NE.0) THEN
        ERRIND = RERR
        GOTO 100
      ENDIF
      NBND    = ID(3)
      BNDL(1) = ID(4)
      BNDL(2) = ID(5)
      BNDL(3) = ID(6)
      BNDL(4) = ID(7)
      RETURN
C
  100 CONTINUE
      NBND    = -1
      BNDL(1) = -1
      BNDL(2) = -1
      BNDL(3) = -1
      BNDL(4) = -1
      RETURN
      END

C
C $Id: nerro.f,v 1.7 2008-07-27 00:17:31 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      INTEGER FUNCTION NERRO (NERRF)
C
C This function returns the current value of the error flag.
C
C The common blocks SECOMI and SECOMC are used to hold shared variables
C of types INTEGER and CHARACTER, respectively, for the routine SETER
C and associated routines.  For descriptions of these variables and for
C default values of them, see the block data routine SEBLDAX.
C
        COMMON /SECOMI/ IERRU,IERRF,IRECF,LOMSG
        SAVE   /SECOMI/
C
        COMMON /SECOMC/ ERMSG
          CHARACTER*256 ERMSG
        SAVE   /SECOMC/
C
C Return the error flag as the value of both NERRO and NERRF.
C
        NERRO=IERRF
        NERRF=IERRF
C
C Done.
C
        RETURN
C
      END

C   ***************************************************************
C   * Storm Relative Helicity (SRH) is a measure of the           *
C   * streamwise vorticity within the inflow environment of a     *
C   * convective storm. It is calculated by multiplying the       *
C   * storm-relative inflow velocity vector (Vh-C) by the         *
C   * streamwise vorticity (Zh) and integrating this quantity     *
C   * over the inflow depth (lowest 1-3 km layers above ground    *
C   * level). It describes the extent to which corkscrew-like     *
C   * motion occurs (similar to the spiraling motion of an        *
C   * American football). SRH corresponds to the transfer of      *
C   * vorticity from the environment to an air parcel in          *
C   * convective motion and is used to predict the potential      *
C   * for tornadic development (cyclonic updraft rotation) in     *
C   * right-moving supercells.                                    *
C   *                                                             *
C   * There is no clear threshold value for SRH when forecasting  *
C   * supercells, since the formation of supercells appears to be *
C   * related more strongly to the deeper layer vertical shear.   *
C   * Larger values of 0-3-km SRH (greater than 250 m**2/s**2)    *
C   * and 0-1-km SRH (greater than 100 m**2/s**2), suggest an     *
C   * increased threat of tornadoes with supercells. For SRH,     *
C   * larger values are generally better, but there are no clear  *
C   * "boundaries" between non-tornadic and significant tornadic  *
C   * supercells.                                                 *
C   *                                                             *
C   * SRH < 100 (lowest 1 km): cutoff value                       *
C   * SRH = 150-299: supercells possible with weak tornadoes      *
C   * SRH = 300-499: very favorable to supercell development and  *
C   *                strong tornadoes                             *
C   * SRH > 450    : violent tornadoes                            *
C   ***************************************************************
C NCLFORTSTART
      subroutine dcalrelhl(u, v, ght, ter, top, sreh, miy, mjx, mkzh)
      implicit none
      integer miy, mjx, mkzh
      double precision u(miy,mjx,mkzh), v(miy,mjx,mkzh), 
     &                 ght(miy,mjx,mkzh),top,ter(miy,mjx),
     &                 sreh(miy,mjx)
C NCLEND
C
C This helicity code was provided by Dr. Craig Mattocks, and
C verified by Cindy Bruyere to produce results equivalent to
C those generated by RIP4. (The code came from RIP4?)
C
      double precision pi, dtr, dpr
      double precision dh, sdh, su, sv, ua, va, asp, adr, bsp, bdr
      double precision cu, cv, x, sum
      integer i, j, k, k10, k3, ktop
      parameter (pi=3.14159265d0, dtr=pi/180.d0, dpr=180.d0/pi)
     
      do 15 j = 1, mjx
	do 15 i = 1, miy
	  sdh = 0.d0
	  su = 0.d0
	  sv = 0.d0
	  k3 = 0
	  k10 = 0
	  ktop = 0
	  do 6 k = mkzh, 2, -1
	    if (((ght(i,j,k) - ter(i,j)) .gt. 10000.d0) .and.
     &             (k10 .eq. 0)) then
	      k10 = k
	      go to 8
	    endif
	    if (((ght(i,j,k) - ter(i,j)) .gt. top) .and.
     &           (ktop .eq. 0)) ktop = k
	    if (((ght(i,j,k) - ter(i,j)) .gt. 3000.d0) .and.
     &           (k3 .eq. 0)) k3 = k
    6     continue
    8     continue
	  if (k10 .eq. 0) k10=2
	  do k = k3, k10, -1
	    dh = ght(i,j,k-1) - ght(i,j,k)
	    sdh = sdh + dh
	    su = su + 0.5d0*dh*(u(i,j,k-1)+u(i,j,k))
	    sv = sv + 0.5d0*dh*(v(i,j,k-1)+v(i,j,k))
	  enddo
	  ua = su / sdh
	  va = sv / sdh
	  asp = sqrt(ua*ua + va*va)
	  if (ua .eq. 0.d0 .and. va .eq. 0.d0) then
	    adr = 0.d0
	  else
	    adr = dpr * (pi + atan2(ua,va))
	  endif
	  bsp = 0.75d0 * asp
	  bdr = adr + 30.d0
	  if (bdr .gt. 360.d0) bdr = bdr-360.d0
	  cu = -bsp * sin(bdr*dtr)
	  cv = -bsp * cos(bdr*dtr)
          sum = 0.d0
          do 12 k = mkzh-1, ktop, -1
            x = ((u(i,j,k)-cu) * (v(i,j,k)-v(i,j,k+1))) -
     &          ((v(i,j,k)-cv) * (u(i,j,k)-u(i,j,k+1)))
            sum = sum + x
   12     continue
          sreh(i,j) = -sum
   15 continue
      end

      SUBROUTINE SLAEV2( A, B, C, RT1, RT2, CS1, SN1 )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     October 31, 1992
*
*     .. Scalar Arguments ..
      REAL               A, B, C, CS1, RT1, RT2, SN1
*     ..
*
*  Purpose
*  =======
*
*  SLAEV2 computes the eigendecomposition of a 2-by-2 symmetric matrix
*     [  A   B  ]
*     [  B   C  ].
*  On return, RT1 is the eigenvalue of larger absolute value, RT2 is the
*  eigenvalue of smaller absolute value, and (CS1,SN1) is the unit right
*  eigenvector for RT1, giving the decomposition
*
*     [ CS1  SN1 ] [  A   B  ] [ CS1 -SN1 ]  =  [ RT1  0  ]
*     [-SN1  CS1 ] [  B   C  ] [ SN1  CS1 ]     [  0  RT2 ].
*
*  Arguments
*  =========
*
*  A       (input) REAL
*          The (1,1) element of the 2-by-2 matrix.
*
*  B       (input) REAL
*          The (1,2) element and the conjugate of the (2,1) element of
*          the 2-by-2 matrix.
*
*  C       (input) REAL
*          The (2,2) element of the 2-by-2 matrix.
*
*  RT1     (output) REAL
*          The eigenvalue of larger absolute value.
*
*  RT2     (output) REAL
*          The eigenvalue of smaller absolute value.
*
*  CS1     (output) REAL
*  SN1     (output) REAL
*          The vector (CS1, SN1) is a unit right eigenvector for RT1.
*
*  Further Details
*  ===============
*
*  RT1 is accurate to a few ulps barring over/underflow.
*
*  RT2 may be inaccurate if there is massive cancellation in the
*  determinant A*C-B*B; higher precision or correctly rounded or
*  correctly truncated arithmetic would be needed to compute RT2
*  accurately in all cases.
*
*  CS1 and SN1 are accurate to a few ulps barring over/underflow.
*
*  Overflow is possible only if RT1 is within a factor of 5 of overflow.
*  Underflow is harmless if the input data is 0 or exceeds
*     underflow_threshold / macheps.
*
* =====================================================================
*
*     .. Parameters ..
      REAL               ONE
      PARAMETER          ( ONE = 1.0E0 )
      REAL               TWO
      PARAMETER          ( TWO = 2.0E0 )
      REAL               ZERO
      PARAMETER          ( ZERO = 0.0E0 )
      REAL               HALF
      PARAMETER          ( HALF = 0.5E0 )
*     ..
*     .. Local Scalars ..
      INTEGER            SGN1, SGN2
      REAL               AB, ACMN, ACMX, ACS, ADF, CS, CT, DF, RT, SM,
     $                   TB, TN
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, SQRT
*     ..
*     .. Executable Statements ..
*
*     Compute the eigenvalues
*
      SM = A + C
      DF = A - C
      ADF = ABS( DF )
      TB = B + B
      AB = ABS( TB )
      IF( ABS( A ).GT.ABS( C ) ) THEN
         ACMX = A
         ACMN = C
      ELSE
         ACMX = C
         ACMN = A
      END IF
      IF( ADF.GT.AB ) THEN
         RT = ADF*SQRT( ONE+( AB / ADF )**2 )
      ELSE IF( ADF.LT.AB ) THEN
         RT = AB*SQRT( ONE+( ADF / AB )**2 )
      ELSE
*
*        Includes case AB=ADF=0
*
         RT = AB*SQRT( TWO )
      END IF
      IF( SM.LT.ZERO ) THEN
         RT1 = HALF*( SM-RT )
         SGN1 = -1
*
*        Order of execution important.
*        To get fully accurate smaller eigenvalue,
*        next line needs to be executed in higher precision.
*
         RT2 = ( ACMX / RT1 )*ACMN - ( B / RT1 )*B
      ELSE IF( SM.GT.ZERO ) THEN
         RT1 = HALF*( SM+RT )
         SGN1 = 1
*
*        Order of execution important.
*        To get fully accurate smaller eigenvalue,
*        next line needs to be executed in higher precision.
*
         RT2 = ( ACMX / RT1 )*ACMN - ( B / RT1 )*B
      ELSE
*
*        Includes case RT1 = RT2 = 0
*
         RT1 = HALF*RT
         RT2 = -HALF*RT
         SGN1 = 1
      END IF
*
*     Compute the eigenvector
*
      IF( DF.GE.ZERO ) THEN
         CS = DF + RT
         SGN2 = 1
      ELSE
         CS = DF - RT
         SGN2 = -1
      END IF
      ACS = ABS( CS )
      IF( ACS.GT.AB ) THEN
         CT = -TB / CS
         SN1 = ONE / SQRT( ONE+CT*CT )
         CS1 = CT*SN1
      ELSE
         IF( AB.EQ.ZERO ) THEN
            CS1 = ONE
            SN1 = ZERO
         ELSE
            TN = -CS / TB
            CS1 = ONE / SQRT( ONE+TN*TN )
            SN1 = TN*CS1
         END IF
      END IF
      IF( SGN1.EQ.SGN2 ) THEN
         TN = CS1
         CS1 = -SN1
         SN1 = TN
      END IF
      RETURN
*
*     End of SLAEV2
*
      END

C
C	$Id: srfabd.f,v 1.5 2008-07-27 00:17:25 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE SRFABD
C
C Calling this do-nothing subroutine forces "ld" to load the following
C block data routine (but only if they are in the same ".f" file).
C
        RETURN
C
      END
CNOSPLIT
      BLOCKDATA SRFABDX
      COMMON /SRFBLK/ LIMU(1024) ,LIML(1024) ,CL(41)     ,NCL        ,
     1                LL         ,FACT       ,IROT       ,NDRZ       ,
     2                NUPPER     ,NRSWT      ,BIGD       ,UMIN       ,
     3                UMAX       ,VMIN       ,VMAX       ,RZERO      ,
     4                IOFFP      ,NSPVAL     ,SPVAL      ,BIGEST
      COMMON /SRFIP1/ IFR        ,ISTP       ,IROTS      ,IDRX       ,
     1                IDRY       ,IDRZ       ,IUPPER     ,ISKIRT     ,
     2                NCLA       ,THETA      ,HSKIRT     ,CHI        ,
     3                CLO        ,CINC       ,ISPVAL
      COMMON /SRFINT/ ISRFMJ     ,ISRFMN     ,ISRFTX
C
C  INITIALIZATION OF INTERNAL PARAMETERS
C
      DATA ISPVAL/-999/
      DATA IFR,ISTP,IROTS,IDRX,IDRY,IDRZ,IUPPER,ISKIRT,NCLA/
     1       1,   0,    0,   1,   1,   0,     0,     0,   6/
      DATA THETA,HSKIRT,CHI,CLO,CINC/
     1       .02,    0., 0., 0.,  0./
      DATA NRSWT/0/
      DATA IOFFP,SPVAL/0,0.0/
C LINE COLOR INDEX
      DATA ISRFMJ/1/
C
C REVISION HISTORY----------
C FEBURARY 1979    ADDED REVISION HISTORY
C                  MODIFIED CODE TO CONFORM TO FORTRAN 66 STANDARD
C
C DECEMBER 1979    CHANGED LATEST REVISION DATE AND CHANGED LIBRARY
C                  STATISTICS CALL TO NSSL INSTEAD OF CRAYLIB
C
C MAY 1980         INSERTED MODS TO CORRECT THE ERROR THAT ENOUGH
C                  SPACE WAS NOT BEING ALLOWED FOR SKIRTS IN
C                  CERTAIN CASES.
C                  CHANGED THE NAMES OF ENTRY POINTS DRAW AND
C                  TRN32 TO DRAWS AND TRN32S TO BE CONSISTENT
C                  WITH USAGE IN CONJUNCTION WITH PWRZS.
C
C MARCH 1984       CONVERTED CODE TO FORTRAN 77 AND GKS.
C
C MARCH 1986       IMPLEMENTED MODS TO CORRECT VISIBILITY ERRORS
C                  IN CERTAIN OBJECTS HAVING LARGE GRADIENTS.
C
C NOVEMBER 1987    CORRECTED CODE TO GET RID OF SPURIOUS VERTICAL
C                  LINES PROBABLY CAUSED BY THE PREVIOUS MODS.
C
C NOVEMBER 1987    CORRECTED HACK'S PROBLEM BY MARKING THE VISIBILITY
C                  HORIZONS WHILE DRAWING THE SKIRTS.
C
C DECEMBER 1987    FIXED THE TEST IN THE ROUTINE SRFACE DETERMINING
C                  WHETHER THE I LOOP OR THE J LOOP IS OUTERMOST.
C
C MARCH 1990       FIXED THE USE OF SET CALLS.
C
C-----------------------------------------------------------------------
C
      END

      SUBROUTINE DLASD8( ICOMPQ, K, D, Z, VF, VL, DIFL, DIFR, LDDIFR,
     $                   DSIGMA, WORK, INFO )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Oak Ridge National Lab, Argonne National Lab,
*     Courant Institute, NAG Ltd., and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      INTEGER            ICOMPQ, INFO, K, LDDIFR
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   D( * ), DIFL( * ), DIFR( LDDIFR, * ),
     $                   DSIGMA( * ), VF( * ), VL( * ), WORK( * ),
     $                   Z( * )
*     ..
*
*  Purpose
*  =======
*
*  DLASD8 finds the square roots of the roots of the secular equation,
*  as defined by the values in DSIGMA and Z. It makes the appropriate
*  calls to DLASD4, and stores, for each  element in D, the distance
*  to its two nearest poles (elements in DSIGMA). It also updates
*  the arrays VF and VL, the first and last components of all the
*  right singular vectors of the original bidiagonal matrix.
*
*  DLASD8 is called from DLASD6.
*
*  Arguments
*  =========
*
*  ICOMPQ  (input) INTEGER
*          Specifies whether singular vectors are to be computed in
*          factored form in the calling routine:
*          = 0: Compute singular values only.
*          = 1: Compute singular vectors in factored form as well.
*
*  K       (input) INTEGER
*          The number of terms in the rational function to be solved
*          by DLASD4.  K >= 1.
*
*  D       (output) DOUBLE PRECISION array, dimension ( K )
*          On output, D contains the updated singular values.
*
*  Z       (input) DOUBLE PRECISION array, dimension ( K )
*          The first K elements of this array contain the components
*          of the deflation-adjusted updating row vector.
*
*  VF      (input/output) DOUBLE PRECISION array, dimension ( K )
*          On entry, VF contains  information passed through DBEDE8.
*          On exit, VF contains the first K components of the first
*          components of all right singular vectors of the bidiagonal
*          matrix.
*
*  VL      (input/output) DOUBLE PRECISION array, dimension ( K )
*          On entry, VL contains  information passed through DBEDE8.
*          On exit, VL contains the first K components of the last
*          components of all right singular vectors of the bidiagonal
*          matrix.
*
*  DIFL    (output) DOUBLE PRECISION array, dimension ( K )
*          On exit, DIFL(I) = D(I) - DSIGMA(I).
*
*  DIFR    (output) DOUBLE PRECISION array,
*                   dimension ( LDDIFR, 2 ) if ICOMPQ = 1 and
*                   dimension ( K ) if ICOMPQ = 0.
*          On exit, DIFR(I,1) = D(I) - DSIGMA(I+1), DIFR(K,1) is not
*          defined and will not be referenced.
*
*          If ICOMPQ = 1, DIFR(1:K,2) is an array containing the
*          normalizing factors for the right singular vector matrix.
*
*  LDDIFR  (input) INTEGER
*          The leading dimension of DIFR, must be at least K.
*
*  DSIGMA  (input) DOUBLE PRECISION array, dimension ( K )
*          The first K elements of this array contain the old roots
*          of the deflated updating problem.  These are the poles
*          of the secular equation.
*
*  WORK    (workspace) DOUBLE PRECISION array, dimension at least 3 * K
*
*  INFO    (output) INTEGER
*          = 0:  successful exit.
*          < 0:  if INFO = -i, the i-th argument had an illegal value.
*          > 0:  if INFO = 1, an singular value did not converge
*
*  Further Details
*  ===============
*
*  Based on contributions by
*     Ming Gu and Huan Ren, Computer Science Division, University of
*     California at Berkeley, USA
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ONE
      PARAMETER          ( ONE = 1.0D+0 )
*     ..
*     .. Local Scalars ..
      INTEGER            I, IWK1, IWK2, IWK2I, IWK3, IWK3I, J
      DOUBLE PRECISION   DIFLJ, DIFRJ, DJ, DSIGJ, DSIGJP, RHO, TEMP
*     ..
*     .. External Subroutines ..
      EXTERNAL           DCOPY, DLASCL, DLASD4, DLASET, XERBLA
*     ..
*     .. External Functions ..
      DOUBLE PRECISION   DDOT, DLAMC3, DNRM2
      EXTERNAL           DDOT, DLAMC3, DNRM2
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, SIGN, SQRT
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
*
      IF( ( ICOMPQ.LT.0 ) .OR. ( ICOMPQ.GT.1 ) ) THEN
         INFO = -1
      ELSE IF( K.LT.1 ) THEN
         INFO = -2
      ELSE IF( LDDIFR.LT.K ) THEN
         INFO = -9
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DLASD8', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( K.EQ.1 ) THEN
         D( 1 ) = ABS( Z( 1 ) )
         DIFL( 1 ) = D( 1 )
         IF( ICOMPQ.EQ.1 ) THEN
            DIFL( 2 ) = ONE
            DIFR( 1, 2 ) = ONE
         END IF
         RETURN
      END IF
*
*     Modify values DSIGMA(i) to make sure all DSIGMA(i)-DSIGMA(j) can
*     be computed with high relative accuracy (barring over/underflow).
*     This is a problem on machines without a guard digit in
*     add/subtract (Cray XMP, Cray YMP, Cray C 90 and Cray 2).
*     The following code replaces DSIGMA(I) by 2*DSIGMA(I)-DSIGMA(I),
*     which on any of these machines zeros out the bottommost
*     bit of DSIGMA(I) if it is 1; this makes the subsequent
*     subtractions DSIGMA(I)-DSIGMA(J) unproblematic when cancellation
*     occurs. On binary machines with a guard digit (almost all
*     machines) it does not change DSIGMA(I) at all. On hexadecimal
*     and decimal machines with a guard digit, it slightly
*     changes the bottommost bits of DSIGMA(I). It does not account
*     for hexadecimal or decimal machines without guard digits
*     (we know of none). We use a subroutine call to compute
*     2*DLAMBDA(I) to prevent optimizing compilers from eliminating
*     this code.
*
      DO 10 I = 1, K
         DSIGMA( I ) = DLAMC3( DSIGMA( I ), DSIGMA( I ) ) - DSIGMA( I )
   10 CONTINUE
*
*     Book keeping.
*
      IWK1 = 1
      IWK2 = IWK1 + K
      IWK3 = IWK2 + K
      IWK2I = IWK2 - 1
      IWK3I = IWK3 - 1
*
*     Normalize Z.
*
      RHO = DNRM2( K, Z, 1 )
      CALL DLASCL( 'G', 0, 0, RHO, ONE, K, 1, Z, K, INFO )
      RHO = RHO*RHO
*
*     Initialize WORK(IWK3).
*
      CALL DLASET( 'A', K, 1, ONE, ONE, WORK( IWK3 ), K )
*
*     Compute the updated singular values, the arrays DIFL, DIFR,
*     and the updated Z.
*
      DO 40 J = 1, K
         CALL DLASD4( K, J, DSIGMA, Z, WORK( IWK1 ), RHO, D( J ),
     $                WORK( IWK2 ), INFO )
*
*        If the root finder fails, the computation is terminated.
*
         IF( INFO.NE.0 ) THEN
            RETURN
         END IF
         WORK( IWK3I+J ) = WORK( IWK3I+J )*WORK( J )*WORK( IWK2I+J )
         DIFL( J ) = -WORK( J )
         DIFR( J, 1 ) = -WORK( J+1 )
         DO 20 I = 1, J - 1
            WORK( IWK3I+I ) = WORK( IWK3I+I )*WORK( I )*
     $                        WORK( IWK2I+I ) / ( DSIGMA( I )-
     $                        DSIGMA( J ) ) / ( DSIGMA( I )+
     $                        DSIGMA( J ) )
   20    CONTINUE
         DO 30 I = J + 1, K
            WORK( IWK3I+I ) = WORK( IWK3I+I )*WORK( I )*
     $                        WORK( IWK2I+I ) / ( DSIGMA( I )-
     $                        DSIGMA( J ) ) / ( DSIGMA( I )+
     $                        DSIGMA( J ) )
   30    CONTINUE
   40 CONTINUE
*
*     Compute updated Z.
*
      DO 50 I = 1, K
         Z( I ) = SIGN( SQRT( ABS( WORK( IWK3I+I ) ) ), Z( I ) )
   50 CONTINUE
*
*     Update VF and VL.
*
      DO 80 J = 1, K
         DIFLJ = DIFL( J )
         DJ = D( J )
         DSIGJ = -DSIGMA( J )
         IF( J.LT.K ) THEN
            DIFRJ = -DIFR( J, 1 )
            DSIGJP = -DSIGMA( J+1 )
         END IF
         WORK( J ) = -Z( J ) / DIFLJ / ( DSIGMA( J )+DJ )
         DO 60 I = 1, J - 1
            WORK( I ) = Z( I ) / ( DLAMC3( DSIGMA( I ), DSIGJ )-DIFLJ )
     $                   / ( DSIGMA( I )+DJ )
   60    CONTINUE
         DO 70 I = J + 1, K
            WORK( I ) = Z( I ) / ( DLAMC3( DSIGMA( I ), DSIGJP )+DIFRJ )
     $                   / ( DSIGMA( I )+DJ )
   70    CONTINUE
         TEMP = DNRM2( K, WORK, 1 )
         WORK( IWK2I+J ) = DDOT( K, WORK, 1, VF, 1 ) / TEMP
         WORK( IWK3I+J ) = DDOT( K, WORK, 1, VL, 1 ) / TEMP
         IF( ICOMPQ.EQ.1 ) THEN
            DIFR( J, 2 ) = TEMP
         END IF
   80 CONTINUE
*
      CALL DCOPY( K, WORK( IWK2 ), 1, VF, 1 )
      CALL DCOPY( K, WORK( IWK3 ), 1, VL, 1 )
*
      RETURN
*
*     End of DLASD8
*
      END

      PROGRAM FSFWRLD
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER (NPTS=101,LRWK=1000,LIWK=1000)
      INTEGER IWRK(LIWK)
      REAL X1(NPTS),Y1(NPTS),X2(NPTS),Y2(NPTS),X3(NPTS),Y3(NPTS)
      REAL RWRK(LRWK)
C
C Convert from degrees to radians.
C
      DATA D2R / .017453292519943 /
C
C  Demonstrate the use of SFWRLD.
C
C  Generate three intersecting circles of radius 1.
      DO 100 II=1,NPTS
      ANG=D2R*3.6*REAL(II-1)
        X=COS(ANG)
        Y=SIN(ANG)
        X1(II) = X - .5
        X2(II) = X + .5
        X3(II) = X
        Y1(II) = Y + .5
        Y2(II) = Y + .5
        Y3(II) = Y - .5
 100  CONTINUE
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C  Define the entire Viewport and a Window from -2. to 2 with linear scaling.
C
      CALL SET(0.,1.,0.,1.,-2.,2.,-2.,2.,1)
C
C  Process the area definitions (regions) and fill according to instructions
C
      CALL SFSETR ('SP',0.006)
      CALL SFSETR ('AN',0.)
      CALL SFWRLD (X1,Y1,NPTS,RWRK,LRWK,IWRK,LIWK)
      CALL SFSETR ('AN',45.)
      CALL SFWRLD (X2,Y2,NPTS,RWRK,LRWK,IWRK,LIWK)
      CALL SFSETR ('AN',90.)
      CALL SFWRLD (X3,Y3,NPTS,RWRK,LRWK,IWRK,LIWK)
C
C  Do all the rest necesary to display the picture and end the plot
C
      CALL FRAME
C
C Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      STOP
      END

C
C $Id: slblda.f,v 1.6 2008-07-27 00:17:26 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE SLBLDA
C
C Calling this do-nothing subroutine forces "ld" to load the following
C block data routine (but only if they are in the same ".f" file).
C
        RETURN
C
      END
CNOSPLIT
      BLOCKDATA SLBLDAX
C
C This "routine" provides default values for the internal parameters of
C STITLE.
C
C The common block SLCOMN holds all of the internal parameters of
C the package STITLE except for color-table parameters.
C
        COMMON /SLCOMN/ GPSZ,IBGC,IBGF,ICOP,IDOT,IFGC,IFGF,IJMP,IMAP,
     +                  INCU,IWLU,IWRK,IWWI,IXND,IXST,OORV,PCSZ,RNFS,
     +                  RVPB,RVPL,RVPR,RVPT,TFIN,TFOU,TGP1,TGP2,TGP3
        SAVE   /SLCOMN/
C
C The common block SLCLRS holds color-table parameters.
C
        COMMON /SLCLRS/ CRED(256),CGRN(256),CBLU(256),LOCI(256),NOCI
        SAVE   /SLCLRS/
C
C GPSZ is the interline spacing assumed by FTITLE, in the plotter
C coordinate system.
C
        DATA GPSZ / 40. /
C
C IBGC is the default background color index.
C
        DATA IBGC / 0 /
C
C IBGF is the background fade flag (-2 for a fade from/to black in the
C HSV system, -1 for no fade, and "n" greater than or equal to 0 for a
C fade-in from the color with color index n/1000 and a fade-out to the
C color with color index MOD[n,1000], in the RGB system).
C
        DATA IBGF / -2 /
C
C ICOP is the centering option for lines written by FTITLE.
C
        DATA ICOP / 1 /
C
C IDOT is a flag saying whether to draw alignment frames with dots in
C the corners.
C
        DATA IDOT / 0 /
C
C IFGC is the default foreground color index.
C
        DATA IFGC / 1 /
C
C IFGF is the foreground fade flag (-2 for a fade from/to black in the
C HSV system, -1 for no fade, and "n" greater than or equal to 0 for a
C fade-in from the color with color index n/1000 and a fade-out to the
C color with color index MOD[n,1000], in the RGB system).
C
        DATA IFGF / -2 /
C
C IJMP is the distance between centers of practice frames.
C
        DATA IJMP / 300 /
C
C IMAP is the PLOTCHAR mapping flag.
C
        DATA IMAP / 100 /
C
C INCU is the card-input unit for FTITLE.
C
        DATA INCU / 5 /
C
C IWLU and IWWI are the logical unit and the workstation ID for WISS.
C
        DATA IWLU,IWWI / 4 , 9 /
C
C IWRK is the ID of the first active workstation, set to an impossible
C value, so that it will be initialized when it's needed.
C
        DATA IWRK / -1 /
C
C NOCI is the number of color indices currently defined by entries in
C the "list of color indices" array LOCI.
C
        DATA NOCI / 0 /
C
C IXST and IXND are the start and finish coordinates for STITLE in the
C X direction.
C
        DATA IXST,IXND / 512 ,512 /
C
C OORV is the PLOTCHAR out-of-range value.
C
        DATA OORV / 1.E12 /
C
C PCSZ is the nominal character size used by STITLE, in the plotter
C coordinate system.  All user character-size values are given as
C multiples of this.
C
        DATA PCSZ / 21. /
C
C RNFS is the real number of frames per second.  The default, 24, is
C an appropriate value for old-fashioned film, but video tape uses 30
C frames per second.
C
        DATA RNFS / 24. /
C
C RVPL, RVPR, RVPB, and RVPT define the limits of the STITLE viewport.
C
        DATA RVPB,RVPL,RVPR,RVPT / 0. , 0. , 1. , 1. /
C
C TFIN and TFOU are the default fade-in and fade-out times.
C
        DATA TFIN,TFOU / 0. , 0. /
C
C TGP1, TGP2, and TGP3 are the blank-frame gap lengths used by FTITLE.
C
        DATA TGP1,TGP2,TGP3 / 1. , .5 , 0. /
C
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C   FFTPACK 5.0
C   Copyright (C) 1995-2004, Scientific Computing Division,
C   University Corporation for Atmospheric Research
C   Licensed under the GNU General Public License (GPL)
C
C   Authors:  Paul N. Swarztrauber and Richard A. Valent
C
C   $Id: c1f5kb.f,v 1.2 2006-11-21 01:10:15 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      SUBROUTINE DC1F5KB(IDO,L1,NA,CC,IN1,CH,IN2,WA)
      DOUBLE PRECISION TR11
      DOUBLE PRECISION TI11
      DOUBLE PRECISION TR12
      DOUBLE PRECISION TI12
      DOUBLE PRECISION TI5
      DOUBLE PRECISION TI2
      DOUBLE PRECISION TI4
      DOUBLE PRECISION TI3
      DOUBLE PRECISION TR5
      DOUBLE PRECISION TR2
      DOUBLE PRECISION TR4
      DOUBLE PRECISION TR3
      DOUBLE PRECISION CHOLD1
      DOUBLE PRECISION CHOLD2
      DOUBLE PRECISION CR2
      DOUBLE PRECISION CI2
      DOUBLE PRECISION CR3
      DOUBLE PRECISION CI3
      DOUBLE PRECISION CR5
      DOUBLE PRECISION CI5
      DOUBLE PRECISION CR4
      DOUBLE PRECISION CI4
      DOUBLE PRECISION DR3
      DOUBLE PRECISION DR4
      DOUBLE PRECISION DI3
      DOUBLE PRECISION DI4
      DOUBLE PRECISION DR5
      DOUBLE PRECISION DR2
      DOUBLE PRECISION DI5
      DOUBLE PRECISION DI2
      DOUBLE PRECISION CC(IN1,L1,IDO,5),CH(IN2,L1,5,IDO),WA(IDO,4,2)
      DATA TR11,TI11,TR12,TI12/.3090169943749474D0,.9510565162951536D0,
     +     -.8090169943749474D0,.5877852522924731D0/
C
C FFTPACK 5.0 auxiliary routine
C
      IF (IDO.GT.1 .OR. NA.EQ.1) GO TO 102
      DO 101 K = 1,L1
          TI5 = CC(2,K,1,2) - CC(2,K,1,5)
          TI2 = CC(2,K,1,2) + CC(2,K,1,5)
          TI4 = CC(2,K,1,3) - CC(2,K,1,4)
          TI3 = CC(2,K,1,3) + CC(2,K,1,4)
          TR5 = CC(1,K,1,2) - CC(1,K,1,5)
          TR2 = CC(1,K,1,2) + CC(1,K,1,5)
          TR4 = CC(1,K,1,3) - CC(1,K,1,4)
          TR3 = CC(1,K,1,3) + CC(1,K,1,4)
          CHOLD1 = CC(1,K,1,1) + TR2 + TR3
          CHOLD2 = CC(2,K,1,1) + TI2 + TI3
          CR2 = CC(1,K,1,1) + TR11*TR2 + TR12*TR3
          CI2 = CC(2,K,1,1) + TR11*TI2 + TR12*TI3
          CR3 = CC(1,K,1,1) + TR12*TR2 + TR11*TR3
          CI3 = CC(2,K,1,1) + TR12*TI2 + TR11*TI3
          CC(1,K,1,1) = CHOLD1
          CC(2,K,1,1) = CHOLD2
          CR5 = TI11*TR5 + TI12*TR4
          CI5 = TI11*TI5 + TI12*TI4
          CR4 = TI12*TR5 - TI11*TR4
          CI4 = TI12*TI5 - TI11*TI4
          CC(1,K,1,2) = CR2 - CI5
          CC(1,K,1,5) = CR2 + CI5
          CC(2,K,1,2) = CI2 + CR5
          CC(2,K,1,3) = CI3 + CR4
          CC(1,K,1,3) = CR3 - CI4
          CC(1,K,1,4) = CR3 + CI4
          CC(2,K,1,4) = CI3 - CR4
          CC(2,K,1,5) = CI2 - CR5
  101 CONTINUE
      RETURN
  102 DO 103 K = 1,L1
          TI5 = CC(2,K,1,2) - CC(2,K,1,5)
          TI2 = CC(2,K,1,2) + CC(2,K,1,5)
          TI4 = CC(2,K,1,3) - CC(2,K,1,4)
          TI3 = CC(2,K,1,3) + CC(2,K,1,4)
          TR5 = CC(1,K,1,2) - CC(1,K,1,5)
          TR2 = CC(1,K,1,2) + CC(1,K,1,5)
          TR4 = CC(1,K,1,3) - CC(1,K,1,4)
          TR3 = CC(1,K,1,3) + CC(1,K,1,4)
          CH(1,K,1,1) = CC(1,K,1,1) + TR2 + TR3
          CH(2,K,1,1) = CC(2,K,1,1) + TI2 + TI3
          CR2 = CC(1,K,1,1) + TR11*TR2 + TR12*TR3
          CI2 = CC(2,K,1,1) + TR11*TI2 + TR12*TI3
          CR3 = CC(1,K,1,1) + TR12*TR2 + TR11*TR3
          CI3 = CC(2,K,1,1) + TR12*TI2 + TR11*TI3
          CR5 = TI11*TR5 + TI12*TR4
          CI5 = TI11*TI5 + TI12*TI4
          CR4 = TI12*TR5 - TI11*TR4
          CI4 = TI12*TI5 - TI11*TI4
          CH(1,K,2,1) = CR2 - CI5
          CH(1,K,5,1) = CR2 + CI5
          CH(2,K,2,1) = CI2 + CR5
          CH(2,K,3,1) = CI3 + CR4
          CH(1,K,3,1) = CR3 - CI4
          CH(1,K,4,1) = CR3 + CI4
          CH(2,K,4,1) = CI3 - CR4
          CH(2,K,5,1) = CI2 - CR5
  103 CONTINUE
      IF (IDO.EQ.1) RETURN
      DO 105 I = 2,IDO
          DO 104 K = 1,L1
              TI5 = CC(2,K,I,2) - CC(2,K,I,5)
              TI2 = CC(2,K,I,2) + CC(2,K,I,5)
              TI4 = CC(2,K,I,3) - CC(2,K,I,4)
              TI3 = CC(2,K,I,3) + CC(2,K,I,4)
              TR5 = CC(1,K,I,2) - CC(1,K,I,5)
              TR2 = CC(1,K,I,2) + CC(1,K,I,5)
              TR4 = CC(1,K,I,3) - CC(1,K,I,4)
              TR3 = CC(1,K,I,3) + CC(1,K,I,4)
              CH(1,K,1,I) = CC(1,K,I,1) + TR2 + TR3
              CH(2,K,1,I) = CC(2,K,I,1) + TI2 + TI3
              CR2 = CC(1,K,I,1) + TR11*TR2 + TR12*TR3
              CI2 = CC(2,K,I,1) + TR11*TI2 + TR12*TI3
              CR3 = CC(1,K,I,1) + TR12*TR2 + TR11*TR3
              CI3 = CC(2,K,I,1) + TR12*TI2 + TR11*TI3
              CR5 = TI11*TR5 + TI12*TR4
              CI5 = TI11*TI5 + TI12*TI4
              CR4 = TI12*TR5 - TI11*TR4
              CI4 = TI12*TI5 - TI11*TI4
              DR3 = CR3 - CI4
              DR4 = CR3 + CI4
              DI3 = CI3 + CR4
              DI4 = CI3 - CR4
              DR5 = CR2 + CI5
              DR2 = CR2 - CI5
              DI5 = CI2 - CR5
              DI2 = CI2 + CR5
              CH(1,K,2,I) = WA(I,1,1)*DR2 - WA(I,1,2)*DI2
              CH(2,K,2,I) = WA(I,1,1)*DI2 + WA(I,1,2)*DR2
              CH(1,K,3,I) = WA(I,2,1)*DR3 - WA(I,2,2)*DI3
              CH(2,K,3,I) = WA(I,2,1)*DI3 + WA(I,2,2)*DR3
              CH(1,K,4,I) = WA(I,3,1)*DR4 - WA(I,3,2)*DI4
              CH(2,K,4,I) = WA(I,3,1)*DI4 + WA(I,3,2)*DR4
              CH(1,K,5,I) = WA(I,4,1)*DR5 - WA(I,4,2)*DI5
              CH(2,K,5,I) = WA(I,4,1)*DI5 + WA(I,4,2)*DR5
  104     CONTINUE
  105 CONTINUE
      RETURN
      END

C
C $Id: pj06sp.f,v 1.5 2008-07-27 00:17:10 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE PJ06SP (COORD,CRDIO,INDIC)
C
C -- P O L A R   S T E R E O G R A P H I C
C
      IMPLICIT REAL (A-Z)
      INTEGER IND
      INTEGER INDIC
      DIMENSION GEOG(2),PROJ(2),COORD(2),CRDIO(2)
C **** PARAMETERS **** A,E,ES,LON0,LATC,X0,Y0,E4,MCS,TCS,FAC,IND *******
      COMMON /ERRMZ0/ IERR
        INTEGER IERR
      SAVE   /ERRMZ0/
      COMMON /PRINZ0/ IPEMSG,IPELUN,IPPARM,IPPLUN
        INTEGER IPEMSG,IPELUN,IPPARM,IPPLUN
      SAVE   /PRINZ0/
      COMMON /PC06SP/ A,LON0,X0,Y0,E,E4,FAC,MCS,TCS,IND
      DATA ZERO,ONE,TWO /0.0E0,1.0E0,2.0E0/
C
C -- F O R W A R D   . . .
C
      IF (INDIC .EQ. 0) THEN
C
         GEOG(1) = COORD(1)
         GEOG(2) = COORD(2)
         IERR = 0
         CON1 = FAC * ADJLSP (GEOG(1) - LON0)
         CON2 = FAC * GEOG(2)
         SINPHI = SIN (CON2)
         TS = TSFNSP (E,CON2,SINPHI)
         IF (IND .EQ. 0) GO TO 240
         RH = A * MCS * TS / TCS
         GO TO 260
  240    RH = TWO * A * TS / E4
  260    PROJ(1) = X0 + FAC * RH * SIN (CON1)
         PROJ(2) = Y0 - FAC * RH * COS (CON1)
         CRDIO(1) = PROJ(1)
         CRDIO(2) = PROJ(2)
         RETURN
      END IF
C
C -- I N V E R S E   . . .
C
      IF (INDIC .EQ. 1) THEN
C
         PROJ(1) = COORD(1)
         PROJ(2) = COORD(2)
         IERR = 0
         X = FAC * (PROJ(1) - X0)
         Y = FAC * (PROJ(2) - Y0)
         RH = SQRT (X * X + Y * Y)
         IF (IND .EQ. 0) GO TO 340
         TS = RH * TCS / (A * MCS)
         GO TO 360
  340    TS = RH * E4 / (TWO * A)
  360    GEOG(2) = FAC * PHI2SP (E,TS)
         IF (IERR .EQ. 0) GO TO 380
         IERR = 064
         RETURN
  380    IF (RH .NE. ZERO) GO TO 400
         GEOG(1) = FAC * LON0
         CRDIO(1) = GEOG(1)
         CRDIO(2) = GEOG(2)
         RETURN
  400    GEOG(1) = ADJLSP (FAC * ATAN2 (X , -Y) + LON0)
         CRDIO(1) = GEOG(1)
         CRDIO(2) = GEOG(2)
         RETURN
      END IF
C
      END

C
C $Id: isseti.f,v 1.5 2008-07-27 00:17:16 haley Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE ISSETI (IPN,IVL)
C
      CHARACTER*(*) IPN
C
C This subroutine is called to set the integer value of a specified
C parameter.
C
C IPN is the name of the parameter whose value is to be set.
C
C IVL is the desired new integer value.
C
C Pass the real equivalent of the integer value on to ISSETR.
C
      CALL ISSETR (IPN,REAL(IVL))
C
C Done.
C
      RETURN
C
      END

      SUBROUTINE DGEQPF( M, N, A, LDA, JPVT, TAU, WORK, INFO )
*
*  -- LAPACK test routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     March 31, 1993
*
*     .. Scalar Arguments ..
      INTEGER            INFO, LDA, M, N
*     ..
*     .. Array Arguments ..
      INTEGER            JPVT( * )
      DOUBLE PRECISION   A( LDA, * ), TAU( * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  This routine is deprecated and has been replaced by routine DGEQP3.
*
*  DGEQPF computes a QR factorization with column pivoting of a
*  real M-by-N matrix A: A*P = Q*R.
*
*  Arguments
*  =========
*
*  M       (input) INTEGER
*          The number of rows of the matrix A. M >= 0.
*
*  N       (input) INTEGER
*          The number of columns of the matrix A. N >= 0
*
*  A       (input/output) DOUBLE PRECISION array, dimension (LDA,N)
*          On entry, the M-by-N matrix A.
*          On exit, the upper triangle of the array contains the
*          min(M,N)-by-N upper triangular matrix R; the elements
*          below the diagonal, together with the array TAU,
*          represent the orthogonal matrix Q as a product of
*          min(m,n) elementary reflectors.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A. LDA >= max(1,M).
*
*  JPVT    (input/output) INTEGER array, dimension (N)
*          On entry, if JPVT(i) .ne. 0, the i-th column of A is permuted
*          to the front of A*P (a leading column); if JPVT(i) = 0,
*          the i-th column of A is a free column.
*          On exit, if JPVT(i) = k, then the i-th column of A*P
*          was the k-th column of A.
*
*  TAU     (output) DOUBLE PRECISION array, dimension (min(M,N))
*          The scalar factors of the elementary reflectors.
*
*  WORK    (workspace) DOUBLE PRECISION array, dimension (3*N)
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*
*  Further Details
*  ===============
*
*  The matrix Q is represented as a product of elementary reflectors
*
*     Q = H(1) H(2) . . . H(n)
*
*  Each H(i) has the form
*
*     H = I - tau * v * v'
*
*  where tau is a real scalar, and v is a real vector with
*  v(1:i-1) = 0 and v(i) = 1; v(i+1:m) is stored on exit in A(i+1:m,i).
*
*  The matrix P is represented in jpvt as follows: If
*     jpvt(j) = i
*  then the jth column of P is the ith canonical unit vector.
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO, ONE
      PARAMETER          ( ZERO = 0.0D+0, ONE = 1.0D+0 )
*     ..
*     .. Local Scalars ..
      INTEGER            I, ITEMP, J, MA, MN, PVT
      DOUBLE PRECISION   AII, TEMP, TEMP2
*     ..
*     .. External Subroutines ..
      EXTERNAL           DGEQR2, DLARF, DLARFG, DORM2R, DSWAP, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, MAX, MIN, SQRT
*     ..
*     .. External Functions ..
      INTEGER            IDAMAX
      DOUBLE PRECISION   DNRM2
      EXTERNAL           IDAMAX, DNRM2
*     ..
*     .. Executable Statements ..
*
*     Test the input arguments
*
      INFO = 0
      IF( M.LT.0 ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( LDA.LT.MAX( 1, M ) ) THEN
         INFO = -4
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DGEQPF', -INFO )
         RETURN
      END IF
*
      MN = MIN( M, N )
*
*     Move initial columns up front
*
      ITEMP = 1
      DO 10 I = 1, N
         IF( JPVT( I ).NE.0 ) THEN
            IF( I.NE.ITEMP ) THEN
               CALL DSWAP( M, A( 1, I ), 1, A( 1, ITEMP ), 1 )
               JPVT( I ) = JPVT( ITEMP )
               JPVT( ITEMP ) = I
            ELSE
               JPVT( I ) = I
            END IF
            ITEMP = ITEMP + 1
         ELSE
            JPVT( I ) = I
         END IF
   10 CONTINUE
      ITEMP = ITEMP - 1
*
*     Compute the QR factorization and update remaining columns
*
      IF( ITEMP.GT.0 ) THEN
         MA = MIN( ITEMP, M )
         CALL DGEQR2( M, MA, A, LDA, TAU, WORK, INFO )
         IF( MA.LT.N ) THEN
            CALL DORM2R( 'Left', 'Transpose', M, N-MA, MA, A, LDA, TAU,
     $                   A( 1, MA+1 ), LDA, WORK, INFO )
         END IF
      END IF
*
      IF( ITEMP.LT.MN ) THEN
*
*        Initialize partial column norms. The first n elements of
*        work store the exact column norms.
*
         DO 20 I = ITEMP + 1, N
            WORK( I ) = DNRM2( M-ITEMP, A( ITEMP+1, I ), 1 )
            WORK( N+I ) = WORK( I )
   20    CONTINUE
*
*        Compute factorization
*
         DO 40 I = ITEMP + 1, MN
*
*           Determine ith pivot column and swap if necessary
*
            PVT = ( I-1 ) + IDAMAX( N-I+1, WORK( I ), 1 )
*
            IF( PVT.NE.I ) THEN
               CALL DSWAP( M, A( 1, PVT ), 1, A( 1, I ), 1 )
               ITEMP = JPVT( PVT )
               JPVT( PVT ) = JPVT( I )
               JPVT( I ) = ITEMP
               WORK( PVT ) = WORK( I )
               WORK( N+PVT ) = WORK( N+I )
            END IF
*
*           Generate elementary reflector H(i)
*
            IF( I.LT.M ) THEN
               CALL DLARFG( M-I+1, A( I, I ), A( I+1, I ), 1, TAU( I ) )
            ELSE
               CALL DLARFG( 1, A( M, M ), A( M, M ), 1, TAU( M ) )
            END IF
*
            IF( I.LT.N ) THEN
*
*              Apply H(i) to A(i:m,i+1:n) from the left
*
               AII = A( I, I )
               A( I, I ) = ONE
               CALL DLARF( 'LEFT', M-I+1, N-I, A( I, I ), 1, TAU( I ),
     $                     A( I, I+1 ), LDA, WORK( 2*N+1 ) )
               A( I, I ) = AII
            END IF
*
*           Update partial column norms
*
            DO 30 J = I + 1, N
               IF( WORK( J ).NE.ZERO ) THEN
                  TEMP = ONE - ( ABS( A( I, J ) ) / WORK( J ) )**2
                  TEMP = MAX( TEMP, ZERO )
                  TEMP2 = ONE + 0.05D0*TEMP*
     $                    ( WORK( J ) / WORK( N+J ) )**2
                  IF( TEMP2.EQ.ONE ) THEN
                     IF( M-I.GT.0 ) THEN
                        WORK( J ) = DNRM2( M-I, A( I+1, J ), 1 )
                        WORK( N+J ) = WORK( J )
                     ELSE
                        WORK( J ) = ZERO
                        WORK( N+J ) = ZERO
                     END IF
                  ELSE
                     WORK( J ) = WORK( J )*SQRT( TEMP )
                  END IF
               END IF
   30       CONTINUE
*
   40    CONTINUE
      END IF
      RETURN
*
*     End of DGEQPF
*
      END

C
C	$Id: csintrc1.f,v 1.7 2008-07-27 03:10:07 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE CSINTRC1 (N,PLAT,PLON,X,Y,Z,F,LIST,LPTR,LEND,
     .                   IFLGS,SIGMA,IFLGG,GRAD, IST, FP,
     .                   IER)
      INTEGER N, LIST(*), LPTR(*), LEND(N), IFLGS, IFLGG,
     .        IST, IER
      DOUBLE PRECISION PLAT, PLON, X(N), Y(N), Z(N), F(N),
     .                 SIGMA(*), GRAD(3,N), FP
C
C***********************************************************
C
C                                              From SSRFPACK
C                                            Robert J. Renka
C                                  Dept. of Computer Science
C                                       Univ. of North Texas
C                                           renka@cs.unt.edu
C                                                   07/25/96
C
C   Given a triangulation of a set of nodes on the unit
C sphere, along with data values and gradients at the nodes,
C this routine computes a value F(P), where F interpolates
C the nodal data and is once-continuously differentiable
C over the convex hull of the nodes.  Refer to Function CSFVAL
C for further details.  If P is not contained in a triangle,
C an extrapolated value is computed by extending F beyond
C the boundary in a continuous fashion.
C
C On input:
C
C       N = Number of nodes in the triangulation.  N .GE. 3
C           and N .GE. 7 if IFLGG .LE. 0.
C
C       PLAT,PLON = Latitude and longitude in radians of the
C                   point P at which F is to be evaluated.
C
C       X,Y,Z = Arrays of length N containing Cartesian
C               coordinates of the nodes.
C
C       F = Array of length N containing values of F at the
C           nodes:  F(I) = F(X(I),Y(I),Z(I)).
C
C       LIST,LPTR,LEND = Data structure defining the trian-
C                        gulation.  Refer to STRIPACK
C                        Subroutine CSTRMESH.
C
C       IFLGS = Tension factor option:
C               IFLGS .LE. 0 if a single uniform tension
C                            factor is to be used.
C               IFLGS .GE. 1 if variable tension is desired.
C
C       SIGMA = Uniform tension factor (IFLGS .LE. 0), or
C               array containing tension factors associated
C               with arcs in one-to-one correspondence with
C               LIST entries (IFLGS .GE. 1).  Refer to Sub-
C               programs CSFVAL, CSGETSIG, CSSIG0, CSSIG1, and CSSIG2.
C
C       IFLGG = Gradient option:
C               IFLGG .LE. 0 if CSINTRC1 is to provide grad-
C                            ient estimates as needed (from
C                            CSGRADL).
C               IFLGG .GE. 1 if gradients are user-provided
C                            in GRAD.  This is more effici-
C                            ent if CSINTRC1 is to be called
C                            several times.
C
C       GRAD = 3 by N array whose I-th column contains
C              an estimated gradient at node I if IFLGG .GE.
C              1, or unused dummy parameter if IFLGG .LE. 0.
C              Refer to Subroutines CSGRADL and CSGRADG.
C
C       IST = Index of the starting node in the search for a
C             triangle containing P.  The output value of
C             IST from a previous call may be a good choice.
C             1 .LE. IST .LE. N.
C
C Input parameters other than IST are not altered by this
C   routine.
C
C On output:
C
C       IST = Index of one of the vertices of the triangle
C             containing P (or a boundary node if P is not
C             contained in a triangle) unless IER = 4.
C
C       FP = Value of F at P unless IER < 0, in which case
C            FP is not defined.
C
C       IER = Error indicator and information flag:
C               =  0 - no error.
C               =  1 - invalid number of input points (must be
C                      greater than 3).
C               =  4 - first three nodes are collinear.
C               =  7 - vertex of a triangle containing an interpolation
C                      point is outside its valid range.
C               =  8 - the angular distance between an interpolated
C                      point and the nearest point of the
C                      triangulation is at least 90 degrees.
C               =  9 - not enough input points to calculate a gradient.
C
C STRIPACK modules required by CSINTRC1: CSJRAND, CSLSTPTR, CSSTORE,
C                                        CSTRFIND
C                    (and optionally)  CSGETNP if IFLGG .LE. 0
C
C SSRFPACK modules required by CSINTRC1:  CSARCINT, CSARCLEN,
C                                         CSFVAL, CSHVAL, CSSNHCSH
C              (and if IFLGG .LE. 0)  CSAPLYR, CSAPLYRT, CSCONSTR,
C                                       CSGIVENS, CSGRADL,
C                                       CSROTATE, CSSETUP
C
C Intrinsic functions called by CSINTRC1:  COS, SIN, SQRT
C
C***********************************************************
C
      INTEGER CSLSTPTR
      DOUBLE PRECISION CSARCLEN, CSFVAL
      INTEGER I, IERR, I1, I2, I3, LP, N1, N2, NN
      DOUBLE PRECISION A, B1, B2, B3, DUM(3), FQ, GQ(3),
     .                 GQN, G1(3), G2(3), G3(3), P(3),
     .                 P1(3), P2(3), P3(3), PTGQ, PTN1,
     .                 PTN2, Q(3), QNORM, S1, S2, S3, S12,
     .                 SUM
C
C Local parameters:
C
C A =        Angular separation between P and Q
C B1,B2,B3 = Barycentric coordinates of the central projec-
C              tion of P onto the underlying planar triangle,
C              or (B1 and B2) projection of Q onto the
C              underlying line segment N1-N2 when P is
C              exterior.  Unnormalized coordinates are
C              computed by CSTRFIND when P is in a triangle.
C DUM =      Dummy parameter for CSARCINT
C FQ,GQ =    Interpolated value and gradient at Q
C GQN =      Negative of the component of GQ in the direction
C              Q->P
C G1,G2,G3 = Gradients at I1, I2, and I3, or (G1 and G2) at
C              N1 and N2
C I =        DO-loop index
C IERR =     Error flag for calls to CSGRADL
C I1,I2,I3 = Vertex indexes returned by CSTRFIND
C LP =       LIST pointer
C N1,N2 =    Indexes of the endpoints of a boundary arc when
C              P is exterior (not contained in a triangle)
C NN =       Local copy of N
C P =        Cartesian coordinates of P
C P1,P2,P3 = Cartesian coordinates of the vertices I1, I2,
C              and I3, or (P1 and P2) coordinates of N1 and
C              N2 if P is exterior
C PTGQ =     Scalar product (P,GQ) -- factor of the component
C              of GQ in the direction Q->P
C PTN1 =     Scalar product (P,N1) -- factor of B1 and B2
C PTN2 =     Scalar product (P,N2) -- factor of B1 and B2
C Q =        Closest boundary point to P when P is exterior
C QNORM =    Factor used to normalize Q
C S1,S2,S3 = Tension factors associated with the triangle
C              sides opposite I1, I2, and I3, or (S1) the
C              boundary arc N1-N2
C S12 =      Scalar product (N1,N2) -- factor of B1 and B2
C SUM =      Quantity used to normalize the barycentric
C              coordinates
C
      NN = N
      IF (NN .LT. 3) THEN
        GO TO 100
      ELSE IF (IFLGG .LE. 0  .AND.  NN .LT. 7) THEN
        GO TO 110
      ELSE IF (IST .LT. 1  .OR.  IST .GT. NN) THEN
        GO TO 120
      ENDIF
C
C Transform (PLAT,PLON) to Cartesian coordinates.
C
      P(1) = COS(PLAT)*COS(PLON)
      P(2) = COS(PLAT)*SIN(PLON)
      P(3) = SIN(PLAT)
C
C Locate P with respect to the triangulation.
C
      CALL CSTRFIND (IST,P,NN,X,Y,Z,LIST,LPTR,LEND, B1,B2,B3,
     .             I1,I2,I3)
      IF (I1 .EQ. 0) GO TO 130
      IST = I1
      IF (I3 .NE. 0) THEN
C
C P is contained in the triangle (I1,I2,I3).  Store the
C   vertex coordinates, gradients, and tension factors in
C   local variables.
C
        P1(1) = X(I1)
        P1(2) = Y(I1)
        P1(3) = Z(I1)
        P2(1) = X(I2)
        P2(2) = Y(I2)
        P2(3) = Z(I2)
        P3(1) = X(I3)
        P3(2) = Y(I3)
        P3(3) = Z(I3)
        IF (IFLGG .GT. 0) THEN
C
C   Gradients are user-provided.
C
          DO 1 I = 1,3
            G1(I) = GRAD(I,I1)
            G2(I) = GRAD(I,I2)
            G3(I) = GRAD(I,I3)
    1       CONTINUE
        ELSE
C
C   Compute gradient estimates at the vertices.
C
          CALL CSGRADL (NN,I1,X,Y,Z,F,LIST,LPTR,LEND, G1,IERR)
          IF (IERR .LT. 0) GO TO 130
          CALL CSGRADL (NN,I2,X,Y,Z,F,LIST,LPTR,LEND, G2,IERR)
          IF (IERR .LT. 0) GO TO 130
          CALL CSGRADL (NN,I3,X,Y,Z,F,LIST,LPTR,LEND, G3,IERR)
          IF (IERR .LT. 0) GO TO 130
        ENDIF
C
        IF (IFLGS .GT. 0) THEN
C
C   Variable tension:
C
          LP = CSLSTPTR(LEND(I2),I3,LIST,LPTR)
          S1 = SIGMA(LP)
          LP = CSLSTPTR(LEND(I3),I1,LIST,LPTR)
          S2 = SIGMA(LP)
          LP = CSLSTPTR(LEND(I1),I2,LIST,LPTR)
          S3 = SIGMA(LP)
        ELSE
C
C   Uniform tension:
C
          S1 = SIGMA(1)
          S2 = S1
          S3 = S1
        ENDIF
C
C Normalize the coordinates.
C
        SUM = B1 + B2 + B3
        B1 = B1/SUM
        B2 = B2/SUM
        B3 = B3/SUM
        FP = CSFVAL(B1,B2,B3,P1,P2,P3,F(I1),F(I2),F(I3),G1,
     .            G2,G3,S1,S2,S3)
        IER = 0
        RETURN
      ENDIF
C
C P is exterior to the triangulation, and I1 and I2 are
C   boundary nodes which are visible from P.  Extrapolate to
C   P by linear (with respect to arc-length) interpolation
C   of the value and directional derivative (gradient comp-
C   onent in the direction Q->P) of the interpolatory
C   surface at Q where Q is the closest boundary point to P.
C
C Determine Q by traversing the boundary starting from I1.
C
      N1 = I1
      PTN1 = P(1)*X(N1) + P(2)*Y(N1) + P(3)*Z(N1)
      IF (I1 .NE. I2) GO TO 3
C
C All boundary nodes are visible from P.  Find a boundary
C   arc N1->N2 such that P Left (N2 X N1)->N1.
C
C Counterclockwise boundary traversal:
C   Set N2 to the first neighbor of N1.
C
    2 LP = LEND(N1)
        LP = LPTR(LP)
        N2 = LIST(LP)
C
C Compute inner products (N1,N2) and (P,N2), and compute
C   B2 = Det(P,N1,N2 X N1).
C
        S12 = X(N1)*X(N2) + Y(N1)*Y(N2) + Z(N1)*Z(N2)
        PTN2 = P(1)*X(N2) + P(2)*Y(N2) + P(3)*Z(N2)
        B2 = PTN2 - S12*PTN1
        IF (B2 .LE. 0.) GO TO 3
C
C P Right (N2 X N1)->N1:  iterate.
C
        N1 = N2
        I1 = N1
        PTN1 = PTN2
        GO TO 2
C
C P Left (N2 X N1)->N1 where N2 is the first neighbor of N1.
C   Clockwise boundary traversal:
C
    3 N2 = N1
        PTN2 = PTN1
C
C Set N1 to the last neighbor of N2 and test for
C   termination.
C
        LP = LEND(N2)
        N1 = -LIST(LP)
        IF (N1 .EQ. I1) GO TO 140
C
C Compute inner products (N1,N2) and (P,N1).
C
        S12 = X(N1)*X(N2) + Y(N1)*Y(N2) + Z(N1)*Z(N2)
        PTN1 = P(1)*X(N1) + P(2)*Y(N1) + P(3)*Z(N1)
C
C Compute B2 = Det(P,N1,N2 X N1) = Det(Q,N1,N2 X N1)*(P,Q).
C
        B2 = PTN2 - S12*PTN1
        IF (B2 .LE. 0.) GO TO 3
C
C Compute B1 = Det(P,N2 X N1,N2) = Det(Q,N2 X N1,N2)*(P,Q).
C
      B1 = PTN1 - S12*PTN2
      IF (B1 .LE. 0.) THEN
C
C Q = N2.  Store value, coordinates, and gradient at Q.
C
        FQ = F(N2)
        Q(1) = X(N2)
        Q(2) = Y(N2)
        Q(3) = Z(N2)
        IF (IFLGG .GT. 0) THEN
          DO 4 I = 1,3
            GQ(I) = GRAD(I,N2)
    4       CONTINUE
        ELSE
          CALL CSGRADL (NN,N2,X,Y,Z,F,LIST,LPTR,LEND, GQ,IERR)
          IF (IERR .LT. 0) GO TO 130
        ENDIF
C
C Extrapolate to P:  FP = FQ + A*(GQ,Q X (PXQ)/SIN(A)),
C   where A is the angular separation between Q and P,
C   and Sin(A) is the magnitude of P X Q.
C
        A = CSARCLEN(Q,P)
        PTGQ = P(1)*GQ(1) + P(2)*GQ(2) + P(3)*GQ(3)
        FP = FQ
        IF (A .NE. 0.) FP = FP + PTGQ*A/SIN(A)
        IER = 0
        RETURN
      ENDIF
C
C P Strictly Left (N2 X N1)->N2 and P Strictly Left
C   N1->(N2 X N1).  Thus Q lies on the interior of N1->N2.
C   Store coordinates of N1 and N2 in local variables.
C
      P1(1) = X(N1)
      P1(2) = Y(N1)
      P1(3) = Z(N1)
      P2(1) = X(N2)
      P2(2) = Y(N2)
      P2(3) = Z(N2)
C
C Compute the central projection of Q onto P2-P1 and
C   normalize to obtain Q.
C
      QNORM = 0.
      DO 5 I = 1,3
        Q(I) = B1*P1(I) + B2*P2(I)
        QNORM = QNORM + Q(I)*Q(I)
    5   CONTINUE
      QNORM = SQRT(QNORM)
      DO 6 I = 1,3
        Q(I) = Q(I)/QNORM
    6   CONTINUE
C
C Store gradients at N1 and N2 and tension factor S1.
C
      IF (IFLGG .GT. 0) THEN
        DO 7 I = 1,3
          G1(I) = GRAD(I,N1)
          G2(I) = GRAD(I,N2)
    7     CONTINUE
      ELSE
        CALL CSGRADL (NN,N1,X,Y,Z,F,LIST,LPTR,LEND, G1,IERR)
        IF (IERR .LT. 0) GO TO 130
        CALL CSGRADL (NN,N2,X,Y,Z,F,LIST,LPTR,LEND, G2,IERR)
        IF (IERR .LT. 0) GO TO 130
      ENDIF
C
      IF (IFLGS .LE. 0) S1 = SIGMA(1)
      IF (IFLGS .GE. 1) S1 = SIGMA(LP)
C
C Compute an interpolated value and normal gradient
C   component at Q.
C
      CALL CSARCINT (Q,P1,P2,F(N1),F(N2),G1,G2,S1, FQ,DUM,GQN)
C
C Extrapolate to P:  the normal gradient component GQN is
C   the negative of the component in the direction Q->P.
C
      FP = FQ - GQN*CSARCLEN(Q,P)
      IER = 0
      RETURN
C
C  Invalid number of input points (must be greater than 3).
C
  100 CONTINUE
      IER = 1
      RETURN
C
C  Not enough input points to calculate a gradient.
C
  110 CONTINUE
      IER = 9
      RETURN
C
C  Vertex of a triangle containing an interpolation point is outside
C  its valid range.
C
  120 CONTINUE
      IER = 7
      RETURN
C
C  First three nodes are collinear.
C
  130 CONTINUE
      IER = 4
      RETURN
C
  140 CONTINUE
      IER = 8
      RETURN
C
      END

      PROGRAM TDEX02
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
        PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Declare the size of the triangle array.
C
        PARAMETER (MTRI=100000)
C
C Declare an array to hold the list of triangles and a couple of scratch
C arrays to be used in ordering the triangles in the list.
C
        DIMENSION RTRI(10,MTRI),RTWK(MTRI,2),ITWK(MTRI)
C
C Define the positions of the eye, the origin of the X/Y plane, and the
C so-called "third point" (which defines the plane of bilateral symmetry
C of the observer).
C
        DATA UEYE,VEYE,WEYE /  6.0 , 5.0 , 2.5 /
        DATA UORG,VORG,WORG /  0.5 , 0.5 , 0.5 /
        DATA UTHI,VTHI,WTHI /  0.5 , 0.5 , 0.9 /
C
C Set a flag that says whether to do a simple image (ISTE=0) or
C a one-frame stereo image (ISTE=-1) or a two-frame stereo image
C (ISTE=+1).
C
        DATA ISTE / -1 /
C
C WOSW is the width of each stereo window, as a fraction of the width of
C the plotter frame.
C
        DATA WOSW / .55 /
C
C Set a flag that says how to set the position of the light source:
C IPLS=0 implies a light source at the position of the observer; IPLS=1
C implies a light source at the position of the sun; IPLS=2 implies a
C light source 90 degrees of longitude away from the sun and on the
C equator.
C
        DATA IPLS / 2 /
C
C Set the default value of the flag that says whether the basic color
C scheme will be white on black (IBOW=0) or black on white (IBOW=1).
C
        DATA IBOW / 1 /
C
C Set the desired value of the flag that says whether shading of the
C surfaces will be done using gray scales (ICLR=0) or colors (ICLR=1).
C
        DATA ICLR / 1 /
C
C Define default values of the shading parameters.  Use SHDE near 0
C for brighter colors and SHDE near 1 for pastel shades.  Use SHDR
C near 0 for a small range of shades and SHDR near 1 for a full range
C of shades.
C
        DATA SHDE,SHDR / .01 , .99 /
C
C Define the latitude and longitude of the sun.
C
        DATA SLAT,SLON / 25. , 80. /
C
C Define the cone angles (smaller value first).  Uncomment one of these.
C
C       DATA CON1,CON2,CON3,CON4,CON5,CON6 / 15.,23.,28.,34.,0.,.4 /
C       DATA CON1,CON2,CON3,CON4,CON5,CON6 / 15.,23.,15.,23.,0.,.4 /
C       DATA CON1,CON2,CON3,CON4,CON5,CON6 / 65.,73.,15.,23.,0.,.4 /
        DATA CON1,CON2,CON3,CON4,CON5,CON6 / 65.,73.,15.,23.,0.,.4 /
C
C Define the distances from the center of the earth (smaller values to
C larger values, earth radius is .5).
C
        DATA DST1,DST2,DST3,DST4,DST5,DST6 / 0.8,0.9,1.25,1.34,.5,2. /
C
C Define the degrees-to-radians conversion constant.
C
        DATA DTOR / .017453292519943 /
C
C Compute the position on the surface of the globe where the sun is
C directly overhead.  (This seems to be a good position to look at.)
C
        UAIM=.5+.5*COS(.017453292519943*SLAT)*COS(.017453292519943*SLON)
        VAIM=.5+.5*COS(.017453292519943*SLAT)*SIN(.017453292519943*SLON)
        WAIM=.5+.5*SIN(.017453292519943*SLAT)
C
C Determine where the light source is.
C
        IF (IPLS.EQ.0) THEN
          CALL TDSETR ('LSU',0.)
          CALL TDSETR ('LSV',0.)
          CALL TDSETR ('LSW',0.)
        ELSE IF (IPLS.EQ.1) THEN
          CALL TDSETR ('LSU',.5+1000.*COS(DTOR*SLAT)*COS(DTOR*SLON))
          CALL TDSETR ('LSV',.5+1000.*COS(DTOR*SLAT)*SIN(DTOR*SLON))
          CALL TDSETR ('LSW',.5+1000.*SIN(DTOR*SLAT)               )
        ELSE
          QLAT=0.
          QLON=SLON-90.
          CALL TDSETR ('LSU',.5+1000.*COS(DTOR*QLAT)*COS(DTOR*QLON))
          CALL TDSETR ('LSV',.5+1000.*COS(DTOR*QLAT)*SIN(DTOR*QLON))
          CALL TDSETR ('LSW',.5+1000.*SIN(DTOR*QLAT)               )
        END IF
C
C Set the shading flag.
C
        CALL TDSETI ('SHD',1)
C
C Open GKS.
C
        CALL GOPKS (IERRF, ISZDM)
        CALL GOPWK (IWKID, LUNIT, IWTYPE)
        CALL GACWK (IWKID)
C
C Turn clipping off.
C
        CALL GSCLIP (0)
C
C Double the line width.
C
        CALL GSLWSC (2.)
C
C Define colors to use.
C
        CALL TDCLRS (1,IBOW,SHDE,SHDR,11,42,7)
C
C Select font number 25, turn on the outlining of filled fonts, set the
C line width to 1, and turn off the setting of the outline color.
C
        CALL PCSETI ('FN - FONT NUMBER',25)
        CALL PCSETI ('OF - OUTLINE FLAG',1)
        CALL PCSETR ('OL - OUTLINE LINE WIDTH',1.)
        CALL PCSETR ('OC - OUTLINE LINE COLOR',-1.)
C
C Make TDPACK characters a bit bigger.
C
        CALL TDSETR ('CS1',1.25)
C
C Define TDPACK rendering styles 1, 2, and 3, using black-and-white
C shading or colored shading, whichever is selected.
C
        IF (ICLR.EQ.0) THEN
          CALL TDSTRS (1,43,74, 43, 74,-1,-1,1,0.,0.,0.)
          CALL TDSTRS (2,43,74, 43, 74,-1,-1,1,0.,0.,0.)
          CALL TDSTRS (3,43,74, 43, 74,-1,-1,1,0.,0.,0.)
          CALL TDSTRS (4,42,42, 42, 42,-1,-1,1,0.,0.,0.)
        ELSE
          CALL TDSTRS (1,43,74,107,138,-1,-1,1,0.,0.,0.)
          CALL TDSTRS (2,43,74, 75,106,-1,-1,1,0.,0.,0.)
          CALL TDSTRS (3,43,74,139,170,-1,-1,1,0.,0.,0.)
          CALL TDSTRS (4,42,42, 42, 42,-1,-1,1,0.,0.,0.)
        END IF
C
C Initialize the count of triangles in the triangle list.
C
        NTRI=0
C
C Generate a set of triangles representing the earth.  It would probably
C be better to generate these by subdividing the faces of an icosahedron
C and projecting the vertices of the small triangles out to the surface
C of the globe, but that code is somewhat more complicated to write.
C
        DO 103 ILON=0,358,2
          RLN1=.017453292519943*REAL(ILON  )
          RLN2=.017453292519943*REAL(ILON+2)
          DO 102 ILAT=-90,88,2
            RLT1=.017453292519943*REAL(ILAT  )
            RLT2=.017453292519943*REAL(ILAT+5)
            XCSW=.5+.5*COS(RLT1)*COS(RLN1)
            YCSW=.5+.5*COS(RLT1)*SIN(RLN1)
            ZCSW=.5+.5*SIN(RLT1)
            XCSE=.5+.5*COS(RLT1)*COS(RLN2)
            YCSE=.5+.5*COS(RLT1)*SIN(RLN2)
            ZCSE=.5+.5*SIN(RLT1)
            XCNE=.5+.5*COS(RLT2)*COS(RLN2)
            YCNE=.5+.5*COS(RLT2)*SIN(RLN2)
            ZCNE=.5+.5*SIN(RLT2)
            XCNW=.5+.5*COS(RLT2)*COS(RLN1)
            YCNW=.5+.5*COS(RLT2)*SIN(RLN1)
            ZCNW=.5+.5*SIN(RLT2)
            IF (NTRI.LT.MTRI) THEN
              NTRI=NTRI+1
              RTRI( 1,NTRI)=XCSW
              RTRI( 2,NTRI)=YCSW
              RTRI( 3,NTRI)=ZCSW
              RTRI( 4,NTRI)=XCSE
              RTRI( 5,NTRI)=YCSE
              RTRI( 6,NTRI)=ZCSE
              RTRI( 7,NTRI)=XCNW
              RTRI( 8,NTRI)=YCNW
              RTRI( 9,NTRI)=ZCNW
              RTRI(10,NTRI)=1.
            END IF
            IF (NTRI.LT.MTRI) THEN
              NTRI=NTRI+1
              RTRI( 1,NTRI)=XCNW
              RTRI( 2,NTRI)=YCNW
              RTRI( 3,NTRI)=ZCNW
              RTRI( 4,NTRI)=XCSE
              RTRI( 5,NTRI)=YCSE
              RTRI( 6,NTRI)=ZCSE
              RTRI( 7,NTRI)=XCNE
              RTRI( 8,NTRI)=YCNE
              RTRI( 9,NTRI)=ZCNE
              RTRI(10,NTRI)=1.
            END IF
  102     CONTINUE
  103   CONTINUE
C
C Generate a set of triangles representing the inner annulus of the
C inner grid element.
C
        NSTP=MAX(1,INT((CON2-CON1)/2.))
        RSTP=(CON2-CON1)/REAL(NSTP)
C
        DO 105 ISTP=1,NSTP
          RLTI=90.-CON1-REAL(ISTP-1)*RSTP
          RLTO=RLTI-RSTP
          RLTI=.017453292519943*RLTI
          RLTO=.017453292519943*RLTO
          DO 104 ILON=0,358,2
            RLN1=.017453292519943*REAL(ILON  +ISTP-1)
            RLN2=.017453292519943*REAL(ILON+1+ISTP-1)
            RLN3=.017453292519943*REAL(ILON+2+ISTP-1)
            RLN4=.017453292519943*REAL(ILON+3+ISTP-1)
            XCP1=COS(RLTI)*COS(RLN1)
            YCP1=COS(RLTI)*SIN(RLN1)
            ZCP1=SIN(RLTI)
            CALL NGRITD (2,90.-SLAT,XCP1,YCP1,ZCP1)
            CALL NGRITD (3,    SLON,XCP1,YCP1,ZCP1)
            XCP1=.5+DST1*XCP1
            YCP1=.5+DST1*YCP1
            ZCP1=.5+DST1*ZCP1
            XCP2=COS(RLTO)*COS(RLN2)
            YCP2=COS(RLTO)*SIN(RLN2)
            ZCP2=SIN(RLTO)
            CALL NGRITD (2,90.-SLAT,XCP2,YCP2,ZCP2)
            CALL NGRITD (3,    SLON,XCP2,YCP2,ZCP2)
            XCP2=.5+DST1*XCP2
            YCP2=.5+DST1*YCP2
            ZCP2=.5+DST1*ZCP2
            XCP3=COS(RLTI)*COS(RLN3)
            YCP3=COS(RLTI)*SIN(RLN3)
            ZCP3=SIN(RLTI)
            CALL NGRITD (2,90.-SLAT,XCP3,YCP3,ZCP3)
            CALL NGRITD (3,    SLON,XCP3,YCP3,ZCP3)
            XCP3=.5+DST1*XCP3
            YCP3=.5+DST1*YCP3
            ZCP3=.5+DST1*ZCP3
            XCP4=COS(RLTO)*COS(RLN4)
            YCP4=COS(RLTO)*SIN(RLN4)
            ZCP4=SIN(RLTO)
            CALL NGRITD (2,90.-SLAT,XCP4,YCP4,ZCP4)
            CALL NGRITD (3,    SLON,XCP4,YCP4,ZCP4)
            XCP4=.5+DST1*XCP4
            YCP4=.5+DST1*YCP4
            ZCP4=.5+DST1*ZCP4
            IF (NTRI.LT.MTRI) THEN
              NTRI=NTRI+1
              RTRI( 1,NTRI)=XCP1
              RTRI( 2,NTRI)=YCP1
              RTRI( 3,NTRI)=ZCP1
              RTRI( 4,NTRI)=XCP3
              RTRI( 5,NTRI)=YCP3
              RTRI( 6,NTRI)=ZCP3
              RTRI( 7,NTRI)=XCP2
              RTRI( 8,NTRI)=YCP2
              RTRI( 9,NTRI)=ZCP2
              RTRI(10,NTRI)=2.
            END IF
            IF (NTRI.LT.MTRI) THEN
              NTRI=NTRI+1
              RTRI( 1,NTRI)=XCP3
              RTRI( 2,NTRI)=YCP3
              RTRI( 3,NTRI)=ZCP3
              RTRI( 4,NTRI)=XCP4
              RTRI( 5,NTRI)=YCP4
              RTRI( 6,NTRI)=ZCP4
              RTRI( 7,NTRI)=XCP2
              RTRI( 8,NTRI)=YCP2
              RTRI( 9,NTRI)=ZCP2
              RTRI(10,NTRI)=2.
            END IF
  104     CONTINUE
  105   CONTINUE
C
C Generate a set of triangles representing the outer annulus of the
C inner grid element.
C
        NSTP=MAX(1,INT((CON2-CON1)/2.))
        RSTP=(CON2-CON1)/REAL(NSTP)
C
        DO 107 ISTP=1,NSTP
          RLTI=90.-CON1-REAL(ISTP-1)*RSTP
          RLTO=RLTI-RSTP
          RLTI=.017453292519943*RLTI
          RLTO=.017453292519943*RLTO
          DO 106 ILON=0,358,2
            RLN1=.017453292519943*REAL(ILON  +ISTP-1)
            RLN2=.017453292519943*REAL(ILON+1+ISTP-1)
            RLN3=.017453292519943*REAL(ILON+2+ISTP-1)
            RLN4=.017453292519943*REAL(ILON+3+ISTP-1)
            XCP1=COS(RLTI)*COS(RLN1)
            YCP1=COS(RLTI)*SIN(RLN1)
            ZCP1=SIN(RLTI)
            CALL NGRITD (2,90.-SLAT,XCP1,YCP1,ZCP1)
            CALL NGRITD (3,    SLON,XCP1,YCP1,ZCP1)
            XCP1=.5+DST2*XCP1
            YCP1=.5+DST2*YCP1
            ZCP1=.5+DST2*ZCP1
            XCP2=COS(RLTO)*COS(RLN2)
            YCP2=COS(RLTO)*SIN(RLN2)
            ZCP2=SIN(RLTO)
            CALL NGRITD (2,90.-SLAT,XCP2,YCP2,ZCP2)
            CALL NGRITD (3,    SLON,XCP2,YCP2,ZCP2)
            XCP2=.5+DST2*XCP2
            YCP2=.5+DST2*YCP2
            ZCP2=.5+DST2*ZCP2
            XCP3=COS(RLTI)*COS(RLN3)
            YCP3=COS(RLTI)*SIN(RLN3)
            ZCP3=SIN(RLTI)
            CALL NGRITD (2,90.-SLAT,XCP3,YCP3,ZCP3)
            CALL NGRITD (3,    SLON,XCP3,YCP3,ZCP3)
            XCP3=.5+DST2*XCP3
            YCP3=.5+DST2*YCP3
            ZCP3=.5+DST2*ZCP3
            XCP4=COS(RLTO)*COS(RLN4)
            YCP4=COS(RLTO)*SIN(RLN4)
            ZCP4=SIN(RLTO)
            CALL NGRITD (2,90.-SLAT,XCP4,YCP4,ZCP4)
            CALL NGRITD (3,    SLON,XCP4,YCP4,ZCP4)
            XCP4=.5+DST2*XCP4
            YCP4=.5+DST2*YCP4
            ZCP4=.5+DST2*ZCP4
            IF (NTRI.LT.MTRI) THEN
              NTRI=NTRI+1
              RTRI( 1,NTRI)=XCP1
              RTRI( 2,NTRI)=YCP1
              RTRI( 3,NTRI)=ZCP1
              RTRI( 4,NTRI)=XCP2
              RTRI( 5,NTRI)=YCP2
              RTRI( 6,NTRI)=ZCP2
              RTRI( 7,NTRI)=XCP3
              RTRI( 8,NTRI)=YCP3
              RTRI( 9,NTRI)=ZCP3
              RTRI(10,NTRI)=2.
            END IF
            IF (NTRI.LT.MTRI) THEN
              NTRI=NTRI+1
              RTRI( 1,NTRI)=XCP3
              RTRI( 2,NTRI)=YCP3
              RTRI( 3,NTRI)=ZCP3
              RTRI( 4,NTRI)=XCP2
              RTRI( 5,NTRI)=YCP2
              RTRI( 6,NTRI)=ZCP2
              RTRI( 7,NTRI)=XCP4
              RTRI( 8,NTRI)=YCP4
              RTRI( 9,NTRI)=ZCP4
              RTRI(10,NTRI)=2.
            END IF
  106     CONTINUE
  107   CONTINUE
C
C Generate a set of triangles representing the inner cone surface of
C the inner grid element.
C
        RLAT=.017453292519943*(90.-CON1)
C
        NSTP=MAX(1,INT((DST2-DST1)/.02))
        RSTP=(DST2-DST1)/REAL(NSTP)
C
        DO 109 ISTP=1,NSTP
          DMIN=DST1+REAL(ISTP-1)*RSTP
          DMAX=DMIN+RSTP
          DO 108 ILON=0,358,2
            RLN1=.017453292519943*REAL(ILON  +ISTP-1)
            RLN2=.017453292519943*REAL(ILON+1+ISTP-1)
            RLN3=.017453292519943*REAL(ILON+2+ISTP-1)
            RLN4=.017453292519943*REAL(ILON+3+ISTP-1)
            XCP1=COS(RLAT)*COS(RLN1)
            YCP1=COS(RLAT)*SIN(RLN1)
            ZCP1=SIN(RLAT)
            CALL NGRITD (2,90.-SLAT,XCP1,YCP1,ZCP1)
            CALL NGRITD (3,    SLON,XCP1,YCP1,ZCP1)
            XCP1=.5+DMIN*XCP1
            YCP1=.5+DMIN*YCP1
            ZCP1=.5+DMIN*ZCP1
            XCP2=COS(RLAT)*COS(RLN2)
            YCP2=COS(RLAT)*SIN(RLN2)
            ZCP2=SIN(RLAT)
            CALL NGRITD (2,90.-SLAT,XCP2,YCP2,ZCP2)
            CALL NGRITD (3,    SLON,XCP2,YCP2,ZCP2)
            XCP2=.5+DMAX*XCP2
            YCP2=.5+DMAX*YCP2
            ZCP2=.5+DMAX*ZCP2
            XCP3=COS(RLAT)*COS(RLN3)
            YCP3=COS(RLAT)*SIN(RLN3)
            ZCP3=SIN(RLAT)
            CALL NGRITD (2,90.-SLAT,XCP3,YCP3,ZCP3)
            CALL NGRITD (3,    SLON,XCP3,YCP3,ZCP3)
            XCP3=.5+DMIN*XCP3
            YCP3=.5+DMIN*YCP3
            ZCP3=.5+DMIN*ZCP3
            XCP4=COS(RLAT)*COS(RLN4)
            YCP4=COS(RLAT)*SIN(RLN4)
            ZCP4=SIN(RLAT)
            CALL NGRITD (2,90.-SLAT,XCP4,YCP4,ZCP4)
            CALL NGRITD (3,    SLON,XCP4,YCP4,ZCP4)
            XCP4=.5+DMAX*XCP4
            YCP4=.5+DMAX*YCP4
            ZCP4=.5+DMAX*ZCP4
            IF (NTRI.LT.MTRI) THEN
              NTRI=NTRI+1
              RTRI( 1,NTRI)=XCP1
              RTRI( 2,NTRI)=YCP1
              RTRI( 3,NTRI)=ZCP1
              RTRI( 4,NTRI)=XCP2
              RTRI( 5,NTRI)=YCP2
              RTRI( 6,NTRI)=ZCP2
              RTRI( 7,NTRI)=XCP3
              RTRI( 8,NTRI)=YCP3
              RTRI( 9,NTRI)=ZCP3
              RTRI(10,NTRI)=2.
            END IF
            IF (NTRI.LT.MTRI) THEN
              NTRI=NTRI+1
              RTRI( 1,NTRI)=XCP3
              RTRI( 2,NTRI)=YCP3
              RTRI( 3,NTRI)=ZCP3
              RTRI( 4,NTRI)=XCP2
              RTRI( 5,NTRI)=YCP2
              RTRI( 6,NTRI)=ZCP2
              RTRI( 7,NTRI)=XCP4
              RTRI( 8,NTRI)=YCP4
              RTRI( 9,NTRI)=ZCP4
              RTRI(10,NTRI)=2.
            END IF
  108     CONTINUE
  109   CONTINUE
C
C Generate a set of triangles representing the outer cone surface of
C the inner grid element.
C
        RLAT=.017453292519943*(90.-CON2)
C
        NSTP=MAX(1,INT((DST2-DST1)/.02))
        RSTP=(DST2-DST1)/REAL(NSTP)
C
        DO 111 ISTP=1,NSTP
          DMIN=DST1+REAL(ISTP-1)*RSTP
          DMAX=DMIN+RSTP
          DO 110 ILON=0,358,2
            RLN1=.017453292519943*REAL(ILON  +ISTP-1)
            RLN2=.017453292519943*REAL(ILON+1+ISTP-1)
            RLN3=.017453292519943*REAL(ILON+2+ISTP-1)
            RLN4=.017453292519943*REAL(ILON+3+ISTP-1)
            XCP1=COS(RLAT)*COS(RLN1)
            YCP1=COS(RLAT)*SIN(RLN1)
            ZCP1=SIN(RLAT)
            CALL NGRITD (2,90.-SLAT,XCP1,YCP1,ZCP1)
            CALL NGRITD (3,    SLON,XCP1,YCP1,ZCP1)
            XCP1=.5+DMIN*XCP1
            YCP1=.5+DMIN*YCP1
            ZCP1=.5+DMIN*ZCP1
            XCP2=COS(RLAT)*COS(RLN2)
            YCP2=COS(RLAT)*SIN(RLN2)
            ZCP2=SIN(RLAT)
            CALL NGRITD (2,90.-SLAT,XCP2,YCP2,ZCP2)
            CALL NGRITD (3,    SLON,XCP2,YCP2,ZCP2)
            XCP2=.5+DMAX*XCP2
            YCP2=.5+DMAX*YCP2
            ZCP2=.5+DMAX*ZCP2
            XCP3=COS(RLAT)*COS(RLN3)
            YCP3=COS(RLAT)*SIN(RLN3)
            ZCP3=SIN(RLAT)
            CALL NGRITD (2,90.-SLAT,XCP3,YCP3,ZCP3)
            CALL NGRITD (3,    SLON,XCP3,YCP3,ZCP3)
            XCP3=.5+DMIN*XCP3
            YCP3=.5+DMIN*YCP3
            ZCP3=.5+DMIN*ZCP3
            XCP4=COS(RLAT)*COS(RLN4)
            YCP4=COS(RLAT)*SIN(RLN4)
            ZCP4=SIN(RLAT)
            CALL NGRITD (2,90.-SLAT,XCP4,YCP4,ZCP4)
            CALL NGRITD (3,    SLON,XCP4,YCP4,ZCP4)
            XCP4=.5+DMAX*XCP4
            YCP4=.5+DMAX*YCP4
            ZCP4=.5+DMAX*ZCP4
            IF (NTRI.LT.MTRI) THEN
              NTRI=NTRI+1
              RTRI( 1,NTRI)=XCP1
              RTRI( 2,NTRI)=YCP1
              RTRI( 3,NTRI)=ZCP1
              RTRI( 4,NTRI)=XCP3
              RTRI( 5,NTRI)=YCP3
              RTRI( 6,NTRI)=ZCP3
              RTRI( 7,NTRI)=XCP2
              RTRI( 8,NTRI)=YCP2
              RTRI( 9,NTRI)=ZCP2
              RTRI(10,NTRI)=2.
            END IF
            IF (NTRI.LT.MTRI) THEN
              NTRI=NTRI+1
              RTRI( 1,NTRI)=XCP3
              RTRI( 2,NTRI)=YCP3
              RTRI( 3,NTRI)=ZCP3
              RTRI( 4,NTRI)=XCP4
              RTRI( 5,NTRI)=YCP4
              RTRI( 6,NTRI)=ZCP4
              RTRI( 7,NTRI)=XCP2
              RTRI( 8,NTRI)=YCP2
              RTRI( 9,NTRI)=ZCP2
              RTRI(10,NTRI)=2.
            END IF
  110     CONTINUE
  111   CONTINUE
C
C Generate a set of triangles representing the inner annulus of the
C outer grid element.
C
        NSTP=MAX(1,INT((CON4-CON3)/2.))
        RSTP=(CON4-CON3)/REAL(NSTP)
C
        DO 113 ISTP=1,NSTP
          RLTI=90.-CON3-REAL(ISTP-1)*RSTP
          RLTO=RLTI-RSTP
          RLTI=.017453292519943*RLTI
          RLTO=.017453292519943*RLTO
          DO 112 ILON=0,358,2
            RLN1=.017453292519943*REAL(ILON  +ISTP-1)
            RLN2=.017453292519943*REAL(ILON+1+ISTP-1)
            RLN3=.017453292519943*REAL(ILON+2+ISTP-1)
            RLN4=.017453292519943*REAL(ILON+3+ISTP-1)
            XCP1=COS(RLTI)*COS(RLN1)
            YCP1=COS(RLTI)*SIN(RLN1)
            ZCP1=SIN(RLTI)
            CALL NGRITD (2,90.-SLAT,XCP1,YCP1,ZCP1)
            CALL NGRITD (3,    SLON,XCP1,YCP1,ZCP1)
            XCP1=.5+DST3*XCP1
            YCP1=.5+DST3*YCP1
            ZCP1=.5+DST3*ZCP1
            XCP2=COS(RLTO)*COS(RLN2)
            YCP2=COS(RLTO)*SIN(RLN2)
            ZCP2=SIN(RLTO)
            CALL NGRITD (2,90.-SLAT,XCP2,YCP2,ZCP2)
            CALL NGRITD (3,    SLON,XCP2,YCP2,ZCP2)
            XCP2=.5+DST3*XCP2
            YCP2=.5+DST3*YCP2
            ZCP2=.5+DST3*ZCP2
            XCP3=COS(RLTI)*COS(RLN3)
            YCP3=COS(RLTI)*SIN(RLN3)
            ZCP3=SIN(RLTI)
            CALL NGRITD (2,90.-SLAT,XCP3,YCP3,ZCP3)
            CALL NGRITD (3,    SLON,XCP3,YCP3,ZCP3)
            XCP3=.5+DST3*XCP3
            YCP3=.5+DST3*YCP3
            ZCP3=.5+DST3*ZCP3
            XCP4=COS(RLTO)*COS(RLN4)
            YCP4=COS(RLTO)*SIN(RLN4)
            ZCP4=SIN(RLTO)
            CALL NGRITD (2,90.-SLAT,XCP4,YCP4,ZCP4)
            CALL NGRITD (3,    SLON,XCP4,YCP4,ZCP4)
            XCP4=.5+DST3*XCP4
            YCP4=.5+DST3*YCP4
            ZCP4=.5+DST3*ZCP4
            IF (NTRI.LT.MTRI) THEN
              NTRI=NTRI+1
              RTRI( 1,NTRI)=XCP1
              RTRI( 2,NTRI)=YCP1
              RTRI( 3,NTRI)=ZCP1
              RTRI( 4,NTRI)=XCP3
              RTRI( 5,NTRI)=YCP3
              RTRI( 6,NTRI)=ZCP3
              RTRI( 7,NTRI)=XCP2
              RTRI( 8,NTRI)=YCP2
              RTRI( 9,NTRI)=ZCP2
              RTRI(10,NTRI)=3.
            END IF
            IF (NTRI.LT.MTRI) THEN
              NTRI=NTRI+1
              RTRI( 1,NTRI)=XCP3
              RTRI( 2,NTRI)=YCP3
              RTRI( 3,NTRI)=ZCP3
              RTRI( 4,NTRI)=XCP4
              RTRI( 5,NTRI)=YCP4
              RTRI( 6,NTRI)=ZCP4
              RTRI( 7,NTRI)=XCP2
              RTRI( 8,NTRI)=YCP2
              RTRI( 9,NTRI)=ZCP2
              RTRI(10,NTRI)=3.
            END IF
  112     CONTINUE
  113   CONTINUE
C
C Generate a set of triangles representing the outer annulus of the
C outer grid element.
C
        NSTP=MAX(1,INT((CON4-CON3)/2.))
        RSTP=(CON4-CON3)/REAL(NSTP)
C
        DO 115 ISTP=1,NSTP
          RLTI=90.-CON3-REAL(ISTP-1)*RSTP
          RLTO=RLTI-RSTP
          RLTI=.017453292519943*RLTI
          RLTO=.017453292519943*RLTO
          DO 114 ILON=0,358,2
            RLN1=.017453292519943*REAL(ILON  +ISTP-1)
            RLN2=.017453292519943*REAL(ILON+1+ISTP-1)
            RLN3=.017453292519943*REAL(ILON+2+ISTP-1)
            RLN4=.017453292519943*REAL(ILON+3+ISTP-1)
            XCP1=COS(RLTI)*COS(RLN1)
            YCP1=COS(RLTI)*SIN(RLN1)
            ZCP1=SIN(RLTI)
            CALL NGRITD (2,90.-SLAT,XCP1,YCP1,ZCP1)
            CALL NGRITD (3,    SLON,XCP1,YCP1,ZCP1)
            XCP1=.5+DST4*XCP1
            YCP1=.5+DST4*YCP1
            ZCP1=.5+DST4*ZCP1
            XCP2=COS(RLTO)*COS(RLN2)
            YCP2=COS(RLTO)*SIN(RLN2)
            ZCP2=SIN(RLTO)
            CALL NGRITD (2,90.-SLAT,XCP2,YCP2,ZCP2)
            CALL NGRITD (3,    SLON,XCP2,YCP2,ZCP2)
            XCP2=.5+DST4*XCP2
            YCP2=.5+DST4*YCP2
            ZCP2=.5+DST4*ZCP2
            XCP3=COS(RLTI)*COS(RLN3)
            YCP3=COS(RLTI)*SIN(RLN3)
            ZCP3=SIN(RLTI)
            CALL NGRITD (2,90.-SLAT,XCP3,YCP3,ZCP3)
            CALL NGRITD (3,    SLON,XCP3,YCP3,ZCP3)
            XCP3=.5+DST4*XCP3
            YCP3=.5+DST4*YCP3
            ZCP3=.5+DST4*ZCP3
            XCP4=COS(RLTO)*COS(RLN4)
            YCP4=COS(RLTO)*SIN(RLN4)
            ZCP4=SIN(RLTO)
            CALL NGRITD (2,90.-SLAT,XCP4,YCP4,ZCP4)
            CALL NGRITD (3,    SLON,XCP4,YCP4,ZCP4)
            XCP4=.5+DST4*XCP4
            YCP4=.5+DST4*YCP4
            ZCP4=.5+DST4*ZCP4
            IF (NTRI.LT.MTRI) THEN
              NTRI=NTRI+1
              RTRI( 1,NTRI)=XCP1
              RTRI( 2,NTRI)=YCP1
              RTRI( 3,NTRI)=ZCP1
              RTRI( 4,NTRI)=XCP2
              RTRI( 5,NTRI)=YCP2
              RTRI( 6,NTRI)=ZCP2
              RTRI( 7,NTRI)=XCP3
              RTRI( 8,NTRI)=YCP3
              RTRI( 9,NTRI)=ZCP3
              RTRI(10,NTRI)=3.
            END IF
            IF (NTRI.LT.MTRI) THEN
              NTRI=NTRI+1
              RTRI( 1,NTRI)=XCP3
              RTRI( 2,NTRI)=YCP3
              RTRI( 3,NTRI)=ZCP3
              RTRI( 4,NTRI)=XCP2
              RTRI( 5,NTRI)=YCP2
              RTRI( 6,NTRI)=ZCP2
              RTRI( 7,NTRI)=XCP4
              RTRI( 8,NTRI)=YCP4
              RTRI( 9,NTRI)=ZCP4
              RTRI(10,NTRI)=3.
            END IF
  114     CONTINUE
  115   CONTINUE
C
C Generate a set of triangles representing the inner cone surface of
C the outer grid element.
C
        RLAT=.017453292519943*(90.-CON3)
C
        NSTP=MAX(1,INT((DST4-DST3)/.02))
        RSTP=(DST4-DST3)/REAL(NSTP)
C
        DO 117 ISTP=1,NSTP
          DMIN=DST3+REAL(ISTP-1)*RSTP
          DMAX=DMIN+RSTP
          DO 116 ILON=0,358,2
            RLN1=.017453292519943*REAL(ILON  +ISTP-1)
            RLN2=.017453292519943*REAL(ILON+1+ISTP-1)
            RLN3=.017453292519943*REAL(ILON+2+ISTP-1)
            RLN4=.017453292519943*REAL(ILON+3+ISTP-1)
            XCP1=COS(RLAT)*COS(RLN1)
            YCP1=COS(RLAT)*SIN(RLN1)
            ZCP1=SIN(RLAT)
            CALL NGRITD (2,90.-SLAT,XCP1,YCP1,ZCP1)
            CALL NGRITD (3,    SLON,XCP1,YCP1,ZCP1)
            XCP1=.5+DMIN*XCP1
            YCP1=.5+DMIN*YCP1
            ZCP1=.5+DMIN*ZCP1
            XCP2=COS(RLAT)*COS(RLN2)
            YCP2=COS(RLAT)*SIN(RLN2)
            ZCP2=SIN(RLAT)
            CALL NGRITD (2,90.-SLAT,XCP2,YCP2,ZCP2)
            CALL NGRITD (3,    SLON,XCP2,YCP2,ZCP2)
            XCP2=.5+DMAX*XCP2
            YCP2=.5+DMAX*YCP2
            ZCP2=.5+DMAX*ZCP2
            XCP3=COS(RLAT)*COS(RLN3)
            YCP3=COS(RLAT)*SIN(RLN3)
            ZCP3=SIN(RLAT)
            CALL NGRITD (2,90.-SLAT,XCP3,YCP3,ZCP3)
            CALL NGRITD (3,    SLON,XCP3,YCP3,ZCP3)
            XCP3=.5+DMIN*XCP3
            YCP3=.5+DMIN*YCP3
            ZCP3=.5+DMIN*ZCP3
            XCP4=COS(RLAT)*COS(RLN4)
            YCP4=COS(RLAT)*SIN(RLN4)
            ZCP4=SIN(RLAT)
            CALL NGRITD (2,90.-SLAT,XCP4,YCP4,ZCP4)
            CALL NGRITD (3,    SLON,XCP4,YCP4,ZCP4)
            XCP4=.5+DMAX*XCP4
            YCP4=.5+DMAX*YCP4
            ZCP4=.5+DMAX*ZCP4
            IF (NTRI.LT.MTRI) THEN
              NTRI=NTRI+1
              RTRI( 1,NTRI)=XCP1
              RTRI( 2,NTRI)=YCP1
              RTRI( 3,NTRI)=ZCP1
              RTRI( 4,NTRI)=XCP2
              RTRI( 5,NTRI)=YCP2
              RTRI( 6,NTRI)=ZCP2
              RTRI( 7,NTRI)=XCP3
              RTRI( 8,NTRI)=YCP3
              RTRI( 9,NTRI)=ZCP3
              RTRI(10,NTRI)=3.
            END IF
            IF (NTRI.LT.MTRI) THEN
              NTRI=NTRI+1
              RTRI( 1,NTRI)=XCP3
              RTRI( 2,NTRI)=YCP3
              RTRI( 3,NTRI)=ZCP3
              RTRI( 4,NTRI)=XCP2
              RTRI( 5,NTRI)=YCP2
              RTRI( 6,NTRI)=ZCP2
              RTRI( 7,NTRI)=XCP4
              RTRI( 8,NTRI)=YCP4
              RTRI( 9,NTRI)=ZCP4
              RTRI(10,NTRI)=3.
            END IF
  116     CONTINUE
  117   CONTINUE
C
C Generate a set of triangles representing the outer cone surface of
C the outer grid element.
C
        RLAT=.017453292519943*(90.-CON4)
C
        NSTP=MAX(1,INT((DST4-DST3)/.02))
        RSTP=(DST4-DST3)/REAL(NSTP)
C
        DO 119 ISTP=1,NSTP
          DMIN=DST3+REAL(ISTP-1)*RSTP
          DMAX=DMIN+RSTP
          DO 118 ILON=0,358,2
            RLN1=.017453292519943*REAL(ILON  +ISTP-1)
            RLN2=.017453292519943*REAL(ILON+1+ISTP-1)
            RLN3=.017453292519943*REAL(ILON+2+ISTP-1)
            RLN4=.017453292519943*REAL(ILON+3+ISTP-1)
            XCP1=COS(RLAT)*COS(RLN1)
            YCP1=COS(RLAT)*SIN(RLN1)
            ZCP1=SIN(RLAT)
            CALL NGRITD (2,90.-SLAT,XCP1,YCP1,ZCP1)
            CALL NGRITD (3,    SLON,XCP1,YCP1,ZCP1)
            XCP1=.5+DMIN*XCP1
            YCP1=.5+DMIN*YCP1
            ZCP1=.5+DMIN*ZCP1
            XCP2=COS(RLAT)*COS(RLN2)
            YCP2=COS(RLAT)*SIN(RLN2)
            ZCP2=SIN(RLAT)
            CALL NGRITD (2,90.-SLAT,XCP2,YCP2,ZCP2)
            CALL NGRITD (3,    SLON,XCP2,YCP2,ZCP2)
            XCP2=.5+DMAX*XCP2
            YCP2=.5+DMAX*YCP2
            ZCP2=.5+DMAX*ZCP2
            XCP3=COS(RLAT)*COS(RLN3)
            YCP3=COS(RLAT)*SIN(RLN3)
            ZCP3=SIN(RLAT)
            CALL NGRITD (2,90.-SLAT,XCP3,YCP3,ZCP3)
            CALL NGRITD (3,    SLON,XCP3,YCP3,ZCP3)
            XCP3=.5+DMIN*XCP3
            YCP3=.5+DMIN*YCP3
            ZCP3=.5+DMIN*ZCP3
            XCP4=COS(RLAT)*COS(RLN4)
            YCP4=COS(RLAT)*SIN(RLN4)
            ZCP4=SIN(RLAT)
            CALL NGRITD (2,90.-SLAT,XCP4,YCP4,ZCP4)
            CALL NGRITD (3,    SLON,XCP4,YCP4,ZCP4)
            XCP4=.5+DMAX*XCP4
            YCP4=.5+DMAX*YCP4
            ZCP4=.5+DMAX*ZCP4
            IF (NTRI.LT.MTRI) THEN
              NTRI=NTRI+1
              RTRI( 1,NTRI)=XCP1
              RTRI( 2,NTRI)=YCP1
              RTRI( 3,NTRI)=ZCP1
              RTRI( 4,NTRI)=XCP3
              RTRI( 5,NTRI)=YCP3
              RTRI( 6,NTRI)=ZCP3
              RTRI( 7,NTRI)=XCP2
              RTRI( 8,NTRI)=YCP2
              RTRI( 9,NTRI)=ZCP2
              RTRI(10,NTRI)=3.
            END IF
            IF (NTRI.LT.MTRI) THEN
              NTRI=NTRI+1
              RTRI( 1,NTRI)=XCP3
              RTRI( 2,NTRI)=YCP3
              RTRI( 3,NTRI)=ZCP3
              RTRI( 4,NTRI)=XCP4
              RTRI( 5,NTRI)=YCP4
              RTRI( 6,NTRI)=ZCP4
              RTRI( 7,NTRI)=XCP2
              RTRI( 8,NTRI)=YCP2
              RTRI( 9,NTRI)=ZCP2
              RTRI(10,NTRI)=3.
            END IF
  118     CONTINUE
  119   CONTINUE
C
C Generate a set of triangles representing the outer cone surface of
C the outer grid element.
C
        RLAT=.017453292519943*(90.-CON6)
C
        NSTP=MAX(1,INT((DST6-DST5)/.02))
        RSTP=(DST6-DST5)/REAL(NSTP)
C
        DO 121 ISTP=1,NSTP
          DMIN=DST5+REAL(ISTP-1)*RSTP
          DMAX=DMIN+RSTP
          DO 120 ILON=0,358,2
            RLN1=.017453292519943*REAL(ILON  +ISTP-1)
            RLN2=.017453292519943*REAL(ILON+1+ISTP-1)
            RLN3=.017453292519943*REAL(ILON+2+ISTP-1)
            RLN4=.017453292519943*REAL(ILON+3+ISTP-1)
            XCP1=COS(RLAT)*COS(RLN1)
            YCP1=COS(RLAT)*SIN(RLN1)
            ZCP1=SIN(RLAT)
            CALL NGRITD (2,90.-SLAT,XCP1,YCP1,ZCP1)
            CALL NGRITD (3,    SLON,XCP1,YCP1,ZCP1)
            XCP1=.5+DMIN*XCP1
            YCP1=.5+DMIN*YCP1
            ZCP1=.5+DMIN*ZCP1
            XCP2=COS(RLAT)*COS(RLN2)
            YCP2=COS(RLAT)*SIN(RLN2)
            ZCP2=SIN(RLAT)
            CALL NGRITD (2,90.-SLAT,XCP2,YCP2,ZCP2)
            CALL NGRITD (3,    SLON,XCP2,YCP2,ZCP2)
            XCP2=.5+DMAX*XCP2
            YCP2=.5+DMAX*YCP2
            ZCP2=.5+DMAX*ZCP2
            XCP3=COS(RLAT)*COS(RLN3)
            YCP3=COS(RLAT)*SIN(RLN3)
            ZCP3=SIN(RLAT)
            CALL NGRITD (2,90.-SLAT,XCP3,YCP3,ZCP3)
            CALL NGRITD (3,    SLON,XCP3,YCP3,ZCP3)
            XCP3=.5+DMIN*XCP3
            YCP3=.5+DMIN*YCP3
            ZCP3=.5+DMIN*ZCP3
            XCP4=COS(RLAT)*COS(RLN4)
            YCP4=COS(RLAT)*SIN(RLN4)
            ZCP4=SIN(RLAT)
            CALL NGRITD (2,90.-SLAT,XCP4,YCP4,ZCP4)
            CALL NGRITD (3,    SLON,XCP4,YCP4,ZCP4)
            XCP4=.5+DMAX*XCP4
            YCP4=.5+DMAX*YCP4
            ZCP4=.5+DMAX*ZCP4
            IF (NTRI.LT.MTRI) THEN
              NTRI=NTRI+1
              RTRI( 1,NTRI)=XCP1
              RTRI( 2,NTRI)=YCP1
              RTRI( 3,NTRI)=ZCP1
              RTRI( 4,NTRI)=XCP3
              RTRI( 5,NTRI)=YCP3
              RTRI( 6,NTRI)=ZCP3
              RTRI( 7,NTRI)=XCP2
              RTRI( 8,NTRI)=YCP2
              RTRI( 9,NTRI)=ZCP2
              RTRI(10,NTRI)=4.
            END IF
            IF (NTRI.LT.MTRI) THEN
              NTRI=NTRI+1
              RTRI( 1,NTRI)=XCP3
              RTRI( 2,NTRI)=YCP3
              RTRI( 3,NTRI)=ZCP3
              RTRI( 4,NTRI)=XCP4
              RTRI( 5,NTRI)=YCP4
              RTRI( 6,NTRI)=ZCP4
              RTRI( 7,NTRI)=XCP2
              RTRI( 8,NTRI)=YCP2
              RTRI( 9,NTRI)=ZCP2
              RTRI(10,NTRI)=4.
            END IF
  120     CONTINUE
  121   CONTINUE
C
        PRINT * , 'NUMBER OF TRIANGLES USED = ',NTRI
C
C Initialize the eye position to do a left-eye view.
C
        IF (ISTE.EQ.0) THEN
          OTEP=0.
        ELSE
          OTEP=-.4
        END IF
C
C Initialize TDPACK.
C
  199   CALL TDINIT (UEYE,VEYE,WEYE,UAIM,VAIM,WAIM,
     +                              UAIM,VAIM,WAIM+1.,OTEP)
C
C If stereo views are being done, do the requested thing, either by
C redoing the SET call to put them side by side on the same frame,
C or by calling FRAME to put them on separate frames.
C
        IF (OTEP.NE.0.) THEN
          IF (ISTE.LT.0) THEN
            CALL GETSET (XVPL,XVPR,YVPB,YVPT,XWDL,XWDR,YWDB,YWDT,LNLG)
            IF (OTEP.LT.0.) THEN
              CALL SET  (1.-WOSW,1.,.5-.5*WOSW,.5+.5*WOSW,
     +                           XWDL,XWDR,YWDB,YWDT,LNLG)
            ELSE
              CALL SET  (  0., WOSW,.5-.5*WOSW,.5+.5*WOSW,
     +                           XWDL,XWDR,YWDB,YWDT,LNLG)
            END IF
          ELSE
            IF (OTEP.GT.0.) CALL FRAME
          END IF
        END IF
C
C Order the triangles in the triangle list.
C
        CALL TDOTRI (RTRI,MTRI,NTRI,RTWK,ITWK,0)
C
C Render the triangles in the triangle list.
C
        CALL TDDTRI (RTRI,MTRI,NTRI,ITWK)
C
C If a left-eye view has just been done, loop back for a right-eye view.
C
        IF (OTEP.LT.0.) THEN
          OTEP=-OTEP
          GO TO 199
        END IF
C
C Advance the frame.
C
        CALL FRAME
C
C Close GKS.
C
        CALL GDAWK (IWKID)
        CALL GCLWK (IWKID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END

C
C $Id: idictl.f,v 1.17 2008-09-18 00:42:16 kennison Exp $
C
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      INTEGER FUNCTION IDICTL (ISTR,IDCT,NDCT)
C
        CHARACTER*(*) ISTR
        CHARACTER*2   IDCT(NDCT)
        INTEGER       NDCT
C
C The value of this function is the index in the NDCT-element dictionary
C IDCT of the string ISTR.  Only the first two characters of ISTR and
C IDCT(I) are compared.  If ISTR is not found in the dictionary, the
C function value is zero.
C
C Declare local variables.
C
        INTEGER       I
C
        DO 101 I=1,NDCT
          IF (ISTR(1:2).EQ.IDCT(I)) THEN
            IDICTL=I
            RETURN
          END IF
  101   CONTINUE
C
C Not found.  Return a zero.
C
        IDICTL=0
        RETURN
C
      END

# Completion for libncarg-bin executables

complete -W "-ngmath -sungks -ncarbd -ngmathbd -smooth -super -quick -agupwrtx -conransmooth -conranquick -conransuper -conrecsmooth -conrecquick -conrecsuper -dashsmooth -dashquick -dashsuper -dashchar -ictrans -noX11 -nox11" ncargcc
complete -W "-ngmath -sungks -ncarbd -ngmathbd -smooth -super -quick -agupwrtx -conransmooth -conranquick -conransuper -conrecsmooth -conrecquick -conrecsuper -dashsmooth -dashquick -dashsuper -dashchar -ictrans -noX11 -nox11" ncargf77
complete -W "-ngmath -sungks -ncarbd -ngmathbd -smooth -super -quick -agupwrtx -conransmooth -conranquick -conransuper -conrecsmooth -conrecquick -conrecsuper -dashsmooth -dashquick -dashsuper -dashchar -ictrans -noX11 -nox11" ncargf90

# ncargex
# " To invoke various classes of examples:"
#echo "   [-A] [-E] [-F] [-P] [-T] [-U] [-ngmath] [-class] [-ps] [-x11]"
#echo ""
#echo " To invoke various utilities:"
#echo "   [-areas] [-autograph] [-bivar] [-colconv] [-conpack]     "
#echo "   [-conpackt] [-conran_family] [-conrec_family] [-csagrid] "
#echo "   [-cssgrid] [-dashline] [-dashpack] [-dsgrid] [-ezmap]    "
#echo "   [-field_flow] [-fitgrid] [-gflash] [-gks] [-gridall]     "
#echo "   [-halftone] [-histogram] [-isosrfhr] [-isosurface]       "
#echo "   [-labelbar] [-natgrid] [-ngmisc] [-plotchar]             "
#echo "   [-polypack] [-pwrite_family] [-scrolled_title]           "
#echo "   [-seter] [-shgrid] [-softfill] [-spps] [-streamlines]    "
#echo "   [-surface] [-threed] [-vaspackt][-vectors] [-wmap]       "
#echo "   [-misc]                                                  "
#echo ""
#echo " Other options:"
#echo "   [-W workstation_type] [-n] [-clean] [-onebyone] names"
##echo ""

C
C $Id: nadisp.f.sed,v 1.2 2008-07-27 04:11:34 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      PROGRAM NADISP
C
C  Draw natural neighbor circles.
C
      PARAMETER (IPDIM=6001, ISDIM=2*IPDIM, ICDIM=6)
      PARAMETER (NCOLORS=10)
      CHARACTER*80 INFILE,INLINE
      DIMENSION PX(IPDIM),PY(IPDIM),PZ(IPDIM)
      DIMENSION PU(100),PV(100)
      DIMENSION CX(ISDIM),CY(ISDIM),R2(ISDIM)
      DIMENSION COLORS(3,NCOLORS)
      DIMENSION IPTS(ISDIM,3)
      DIMENSION XX(2),YY(2)
      DIMENSION VORX(ISDIM),VORY(ISDIM),IWORK(ISDIM),WORK(ISDIM)
C
C  Read in original points.  Read from the specified file if one is
C  supplied; read from stdin otherwise.
C
      NUMARG = IARGC()
      IF (NUMARG .EQ. 0) THEN
        WRITE(6,510) 
  510   FORMAT(' Usage: nnalg data_file_name')
        STOP
      ELSE
        IUNIT = 2
#ifdef  hpux
        CALL IGETARG(1, INFILE, 80)
#else
        CALL GETARG(1, INFILE)
#endif
        OPEN(IUNIT,FILE=INFILE)
      ENDIF
C
C  Read GKS workstation type.
C
      CALL NASKLN(IUNIT,INLINE)
      READ(INLINE,'(I5)') IWK
C
C  Read in the flag for whether axes should be drawn.
C
      CALL NASKLN(IUNIT,INLINE)
      READ(INLINE,'(I5)') IAXES
C
C  Read in whether to draw axes or a grid.
C
      CALL NASKLN(IUNIT,INLINE)
      READ(INLINE,'(I5)') IGRTYP
C
C  Read in whether to draw the triangulation.
C
      CALL NASKLN(IUNIT,INLINE)
      READ(INLINE,'(I5)') IDRTRI
C
C  Read in whether to draw a blue dot at (0.,0.).
C
      CALL NASKLN(IUNIT,INLINE)
      READ(INLINE,'(I5)') IREF
C
C  Read in whether the pseudo data should be included in the plot.
C
      CALL NASKLN(IUNIT,INLINE)
      READ(INLINE,'(I5)') IPSEUD
C
C  Read in whether the natural neighbor circles should be drawn.
C
      CALL NASKLN(IUNIT,INLINE)
      READ(INLINE,'(I5)') INN
C
C  Read in whether the centers of the natural neighbor circles should be 
C  marked.
C
      CALL NASKLN(IUNIT,INLINE)
      READ(INLINE,'(I5)') INNC
C
C  Read in whether the Voronoi polygons should be drawn.
C
      CALL NASKLN(IUNIT,INLINE)
      READ(INLINE,'(I5)') IVOR
C
C  Read in whether the original points should be marked.
C
      CALL NASKLN(IUNIT,INLINE)
      READ(INLINE,'(I5)') IMKPT
C
C  Read in the colors.
C
      DO 90 I=1,NCOLORS
        CALL NASKLN(IUNIT,INLINE)
        READ(INLINE,'(3F7.3)') COLORS(1,I),COLORS(2,I),COLORS(3,I)
   90 CONTINUE
C
C  Read in scale factor for dots at vertices.
C
      CALL NASKLN(IUNIT,INLINE)
      READ(INLINE,'(F7.3)') DSCALE
C
C  Read in scale factor for circumcircle centers.
C
      CALL NASKLN(IUNIT,INLINE)
      READ(INLINE,'(F7.3)') CSCALE
C
C  Read in scale factor for circle lines
C
      CALL NASKLN(IUNIT,INLINE)
      READ(INLINE,'(F7.3)') CLSCAL
C
C  Read in scale factor for Voronoi polygon lines
C
      CALL NASKLN(IUNIT,INLINE)
      READ(INLINE,'(F7.3)') VSCALE
C
C  Read in scale factor for for tringulation lines
C
      CALL NASKLN(IUNIT,INLINE)
      READ(INLINE,'(F7.3)') TSCALE
C
C  Read in scale factor for axes lines
C
      CALL NASKLN(IUNIT,INLINE)
      READ(INLINE,'(F7.3)') ASCALE
C
C  Read in scale factor for asterisk marking points where neighbors are
C  desired.
C
      CALL NASKLN(IUNIT,INLINE)
      READ(INLINE,'(F7.3)') ASTSCL
C
C  Read in scale factor for dots marking natural neighbors.
C
      CALL NASKLN(IUNIT,INLINE)
      READ(INLINE,'(F7.3)') DNNSCL
C
C  Read in the user coordinates for the SET call.
C
      CALL NASKLN(IUNIT,INLINE)
      READ(INLINE,'(4E15.3)') XL,XR,YB,YT
C
C  Read in number of original data points.
C
      CALL NASKLN(IUNIT,INLINE)
      READ(INLINE,'(I5)') NUMPNT
      IF (NUMPNT+3 .GT. IPDIM) THEN
        IMAX = IPDIM
        WRITE(6,520) NUMPNT,IMAX
  520   FORMAT(' Number of input data points = ',
     +I8/' This exceeds the maximum allowed, which is ',
     +I8)
        STOP
      ENDIF
C
C  Read in original data points.
C
      DO 50 I=1,NUMPNT
        CALL NASKLN(IUNIT,INLINE)
        READ (INLINE,'(I5,3E15.3)') NDUM,PX(I),PY(I),PZ(I)
   50 CONTINUE
C
C  Read in the pseudo point data.
C
      DO 51 I=1,3
        CALL NASKLN(IUNIT,INLINE)
        READ (INLINE,'(I5,3E15.3)') NDUM,PX(NUMPNT+I),PY(NUMPNT+I),
     +                              PZ(NUMPNT+I)       
   51 CONTINUE
C
C  Read in natural neighbor coordinates for center of circumcircles
C  and the radius squared.
C
      CALL NASKLN(IUNIT,INLINE)
      READ(INLINE,'(I5)') NUMSIM
      IF (NUMSIM .GT. ISDIM) THEN
        IMAX = ISDIM
        WRITE(6,530) NUMSIM,IMAX
  530   FORMAT(' Number of circumcircles = ',
     +I8/' This exceeds the maximum allowed, which is ',
     +I8)
        STOP
      ENDIF
      DO 60 I=1,NUMSIM
        CALL NASKLN(IUNIT,INLINE)
        READ (INLINE,'(3I5,3E15.3)') IPTS(I,1),IPTS(I,2),IPTS(I,3),
     +                               CX(I),CY(I),R2(I)
   60 CONTINUE
C
C  Read in the number of data points where natural neighbors are to
C  be displayed, as well as the first-order/second-order flag.
C
      CALL NASKLN(IUNIT,INLINE)
      READ(INLINE,'(2I5)') NUMNND,IFOFLG
C
C  Read in the points.
C
      IF (NUMNND .GT. 0) THEN
        IF (NUMNND .GT. 100) THEN
          WRITE(6,511)
  511     FORMAT(' More than 100 points for natural neighbor draws')
          STOP
        ENDIF
        DO 93 I=1,NUMNND
          CALL NASKLN(IUNIT,INLINE)
          READ(INLINE,'(2E15.3)') PU(I),PV(I)
   93   CONTINUE
      ENDIF
C
C  Open GKS, open and activate a workstation of the appropriate type.
C
      CALL GOPKS(6,0)
      CALL GOPWK(1,2,IWK)
      DO 91 I=1,NCOLORS
        CALL GSCR(1,I-1,COLORS(1,I),COLORS(2,I),COLORS(3,I))
   91 CONTINUE
      CALL GACWK(1)
C
C  Find the limits of the data.
C
      XMAX = -20000.
      XMIN =  20000.
      YMAX = -20000.
      YMIN =  20000.
      IF (IPSEUD .NE. 0) THEN
        LIMIT = NUMPNT+3
      ELSE
        LIMIT = NUMPNT
      ENDIF
      DO 73 I=1,LIMIT
        XMAX = MAX(XMAX,PX(I))
        YMAX = MAX(XMAX,PY(I))
        XMIN = MIN(XMIN,PX(I))
        YMIN = MIN(YMIN,PY(I))
   73 CONTINUE
      XMAXO = XMAX
      YMAXO = YMAX
      XMINO = XMIN
      YMINO = YMIN
C
C  Multiplier for extra space.
C
      ADDMLP = 0.3
      XMAX = XMAX+ADDMLP*(XMAX-XMIN)
      XMIN = XMIN-ADDMLP*(XMAX-XMIN)
      YMAX = YMAX+ADDMLP*(YMAX-YMIN)
      YMIN = YMIN-ADDMLP*(YMAX-YMIN)
      IF (XMAX-XMIN .GT. YMAX-YMIN) THEN
        IF (XL.NE.0. .OR. XR.NE.0. .OR. YB.NE.0. .OR. YT.NE.0.) THEN
          BREDTH = REAL(NINT(XR-XL)+1)
          XLP = XL
          XRP = XR
          YBP = YB
          YTP = YT
          CALL SET(0.0, 1.0, 0.0, 1.0, XLP, XRP, YBP, YTP, 1) 
        ELSE
          BREDTH = REAL(NINT(XMAX-XMIN)+1)
          XLP = XMIN
          XRP = XMAX
          YBP = XMIN
          YTP = XMAX
          CALL SET(0.0, 1.0, 0.0, 1.0, XLP, XRP, YBP, YTP, 1) 
        ENDIF
      ELSE
        IF (XL.NE.0. .OR. XR.NE.0. .OR. YB.NE.0. .OR. YT.NE.0.) THEN
          BREDTH = REAL(NINT(XR-XL)+1)
          XLP = XL
          XRP = XR
          YBP = YB
          YTP = YT
          CALL SET(0.0, 1.0, 0.0, 1.0, XLP, XRP, YBP, YTP, 1) 
        ELSE
          BREDTH = REAL(NINT(YMAX-YMIN)+1)
          XLP = YMIN
          XRP = YMAX
          YBP = YMIN
          YTP = YMAX
          CALL SET(0.0, 1.0, 0.0, 1.0, XLP, XRP, YBP, YTP, 1) 
        ENDIF
      ENDIF
C
C  Sizes
C
      SIZE  = 0.02*BREDTH*DSCALE
      BSIZE = 0.02*BREDTH*DNNSCL
      CSIZE = 0.02*ASTSCL
C
C  Draw axes
C
      IF (IAXES .NE. 0) THEN
        CALL GSLWSC(ASCALE)
        CALL GSPLCI(1)
        DO 72 I=1,10
          IF (I .EQ. 1) THEN
            ITEST = 1
          ELSE
            ITEST = ITEST*10
          ENDIF
          NUMGRD = NINT(BREDTH)/ITEST
          IF (NUMGRD .LE. 40) THEN
            IF (MOD(NUMGRD,2) .NE. 0) NUMGRD = NUMGRD+1
            XINC = (XMAXO-XMINO)/REAL(NUMGRD)
            YINC = (YMAXO-YMINO)/REAL(NUMGRD)
            XX(1) = 0.
            YY(1) = YBP
            XX(2) = 0.
            YY(2) = YTP
            CALL GPL(2,XX,YY)
            XX(1) = XLP
            YY(1) = 0.
            XX(2) = XRP
            YY(2) = 0.
            CALL GPL(2,XX,YY)
            NDG = 6*NUMGRD
            IF (IGRTYP .EQ. 0) THEN
              DO 76 J=1,NDG
                XPOS = REAL(J-1)*XINC
                IF (XPOS .LT. XRP) THEN
                  XX(1) = XPOS
                  YY(1) = 0.
                  XX(2) = XPOS
                  YY(2) = 0.5*SIZE
                  CALL GPL(2,XX,YY)
                ENDIF
                XPOS = -XPOS
                IF (XPOS .GT. XLP) THEN
                  XX(1) = XPOS
                  YY(1) = 0.
                  XX(2) = XPOS
                  YY(2) = 0.5*SIZE
                  CALL GPL(2,XX,YY)
                ENDIF
                YPOS = REAL(J-1)*YINC
                IF (YPOS .LT. YTP) THEN
                  XX(1) = 0.
                  YY(1) = YPOS
                  XX(2) = 0.5*SIZE
                  YY(2) = YPOS
                  CALL GPL(2,XX,YY)
                ENDIF
                YPOS = -YPOS
                IF (YPOS .GT. YBP) THEN
                  XX(1) = 0.
                  YY(1) = YPOS
                  XX(2) = 0.5*SIZE
                  YY(2) = YPOS
                  CALL GPL(2,XX,YY)
                ENDIF
   76         CONTINUE
            ELSE IF (IGRTYP .EQ. 1) THEN
              DO 74 J=1,NDG
                XPOS = REAL(J-1)*XINC
                IF (XPOS .LT. XRP) THEN
                  XX(1) = XPOS
                  YY(1) = YBP
                  XX(2) = XPOS
                  YY(2) = YTP
                  CALL GPL(2,XX,YY)
                ENDIF
                XPOS = -XPOS
                IF (XPOS .GT. XLP) THEN
                  XX(1) = XPOS
                  YY(1) = YBP
                  XX(2) = XPOS
                  YY(2) = YTP
                  CALL GPL(2,XX,YY)
                ENDIF
                YPOS = REAL(J-1)*YINC
                IF (YPOS .LT. YTP) THEN
                  XX(1) = XLP
                  YY(1) = YPOS
                  XX(2) = XRP
                  YY(2) = YPOS
                  CALL GPL(2,XX,YY)
                ENDIF
                YPOS = -YPOS
                IF (YPOS .GT. YBP) THEN
                  XX(1) = XLP
                  YY(1) = YPOS
                  XX(2) = XRP
                  YY(2) = YPOS
                  CALL GPL(2,XX,YY)
                ENDIF
   74         CONTINUE
            ENDIF
            CALL GSLWSC(1.)
            GO TO 77
          ENDIF
   72   CONTINUE
   77   CONTINUE
      ENDIF
C
C  Mark the points where the natural neighbors are to be marked.
C
      IF (NUMNND .GT. 0) THEN
        DO 121 L=1,NUMNND
          CALL PCSETI('CC',9)
          CALL PCSETI('FN',26)
          CALL PLCHHQ(PU(L),PV(L),'*',2.*CSIZE,0.,0.)
  121   CONTINUE
      ENDIF
C
C  Draw the natural neighbor circles.
C
      IF (INN .NE. 0) THEN
        CALL GSLWSC(CLSCAL)
C
C  Draw circumcircles.
C
        CALL NGSETI('CT',1)
        DO 70 I=1,NUMSIM
          IF (IPTS(I,1).LE.NUMPNT .OR. IPSEUD.EQ.1) THEN
            CALL NGDOTS(CX(I),CY(I),1,2.*SQRT(R2(I)),2)
          ENDIF
   70   CONTINUE
        CALL GSLWSC(1.)
      ENDIF
C
C  Draw the triangulation.
C
      IF (IDRTRI .NE. 0) THEN
        CALL GSPLCI(4)
        CALL GSLWSC(TSCALE)
        DO 110 I=1,NUMSIM
          IF (IPTS(I,1).LE.NUMPNT .OR. IPSEUD.EQ.1) THEN
            INDX = IPTS(I,1)
            XX(1) = PX(INDX)
            YY(1) = PY(INDX)
            INDX = IPTS(I,2)
            XX(2) = PX(INDX)
            YY(2) = PY(INDX)
            CALL GPL(2,XX,YY)
C
            INDX = IPTS(I,2)
            XX(1) = PX(INDX)
            YY(1) = PY(INDX)
            INDX = IPTS(I,3)
            XX(2) = PX(INDX)
            YY(2) = PY(INDX)
            CALL GPL(2,XX,YY)
C
            INDX = IPTS(I,3)
            XX(1) = PX(INDX)
            YY(1) = PY(INDX)
            INDX = IPTS(I,1)
            XX(2) = PX(INDX)
            YY(2) = PY(INDX)
            CALL GPL(2,XX,YY)
            CALL SFLUSH()
          ENDIF
  110   CONTINUE
        CALL GSLWSC(1.)
      ENDIF
C
C  Draw the voronoi polygons
C
      IF (IVOR .EQ. 1) THEN
        CALL GSLWSC(VSCALE)
        DO 80 I=1,NUMPNT
          NUMV = 0
C
C  Find the vertices of the Voronoi polygon around the Ith data point.
C
          DO 81 J=1,NUMSIM
            IF (IPTS(J,1).EQ.I .OR. IPTS(J,2).EQ.I .OR.
     +                              IPTS(J,3).EQ.I) THEN
              NUMV = NUMV+1
              VORX(NUMV) = CX(J)
              VORY(NUMV) = CY(J)
            ENDIF
   81     CONTINUE
        IF (NUMV .GT. 0) CALL NADRAW(NUMV,VORX,VORY,IWORK,WORK)
   80   CONTINUE
        CALL GSLWSC(1.)
      ENDIF
C
C  Draw dots at the center of all circles (including the pseudo
C  data if IPSEUD = 1).
C
      IF (INNC .NE. 0) THEN
        CALL NGSETI('CT',0)
        DO 92 I=1,NUMSIM
          IF (IPTS(I,1).LE.NUMPNT .OR. IPSEUD.EQ.1) THEN
            CALL NGDOTS(CX(I),CY(I),1,0.008*BREDTH*CSCALE,3)
          ENDIF
   92   CONTINUE
      ENDIF
C
C  Mark the original points.
C
      IF (IMKPT .NE. 0) THEN
        CALL NGSETI('CT',0)
        IF (IPSEUD .NE. 0) THEN
          LIMIT = NUMPNT+3
        ELSE
          LIMIT = NUMPNT
        ENDIF
        DO 115 I=1,LIMIT
          CALL NGDOTS(PX(I), PY(I), 1, 0.8*SIZE, 6)
          CALL SFLUSH()
  115   CONTINUE
      ENDIF
C
C  Draw a dot at point (0.,0.) if requested.
C
      IF (IREF .NE. 0) THEN
        CALL NGDOTS(0., 0., 1, 0.8*SIZE, 7)
      ENDIF
C
C  Draw the natural neighbors of the specified points.
C
      IF (IFOFLG .GE. 0) THEN
        DO 116 L=1,NUMNND
            CALL NGSETI('CT',0)
            DO 117 I=1,NUMSIM
              DIST = ( (PU(L)-CX(I))**2 + (PV(L)-CY(I))**2)
              IF (DIST .LE. R2(I)) THEN
                DO 118 J=1,3 
                  INDX = IPTS(I,J)
                  IF (IFOFLG .EQ. 0) THEN
                    CALL NGDOTS(PX(INDX),PY(INDX),1,0.8*BSIZE,8)
                  ELSE
                    DO 119 M=1,NUMSIM
                      IF (IPTS(M,1).EQ.INDX .OR. IPTS(M,2).EQ.INDX .OR.
     +                    IPTS(M,3).EQ.INDX) THEN
                        DO 120 N=1,3
                          INDX1 = IPTS(M,N)
                          CALL NGDOTS(PX(INDX1),PY(INDX1),1,0.8*BSIZE,8)
  120                   CONTINUE
                      ENDIF
  119               CONTINUE 
                  ENDIF
  118           CONTINUE
              ENDIF
  117       CONTINUE
  116   CONTINUE        
      ENDIF
C
C  re-mark the points where the natural neighbors are to be marked.
C
      IF (NUMNND .GT. 0) THEN
        DO 122 L=1,NUMNND
          CALL PCSETI('CC',9)
          CALL PCSETI('FN',26)
          CALL PLCHHQ(PU(L),PV(L),'*',2.*CSIZE,0.,0.)
  122   CONTINUE
      ENDIF
C
      CALL FRAME
C
      CALL GDAWK(1)
      CALL GCLWK(1)
      CALL GCLKS
C
      STOP
      END

#!/bin/csh -f
#
#	$Id: gcaps.csh,v 1.10 2008-07-27 03:58:55 haley Exp $
#
#                Copyright (C)  2000
#        University Corporation for Atmospheric Research
#                All Rights Reserved
#
# The use of this Software is governed by a License Agreement.
#
#	Name		gcaps
#
#	Author		John Clyne
#
#	Date		Wed Jun 27 13:23:39 MDT 1990
#
#	Desc.		Report all the graphcaps installed in the graphcap 
#			directory.
# 

set version = "VERSION"
set dir = `ncargpath GRAPHCAPDIR`
if ($status != 0) then
	exit 1
endif

foreach arg ($argv)
	switch ($arg)
	case "-V"
		echo "${0}: Version $version"
		exit 0
	default:
		echo "Usage: $0 [-V]"
		exit 1
	endsw
end

if (! -d "$dir") then
  echo "Graphcap directory <$dir> does not exist."
  exit 1
endif

cd $dir
echo "The following graphcaps are installed in ${dir}:"
foreach gcap ("" *)
	echo "	$gcap"
end

echo ""
echo "The following device specifiers are also valid:"
foreach device ("" DEVICES)
	echo "	$device"
end

/*
 *      $Id$
 */
/************************************************************************
*									*
*			     Copyright (C)  1995			*
*	     University Corporation for Atmospheric Research		*
*			     All Rights Reserved			*
*									*
************************************************************************/
/*
 *	File:		
 *
 *	Author:		Ethan Alpert
 *			National Center for Atmospheric Research
 *			PO 3000, Boulder, Colorado
 *
 *	Date:		Tue Jan 31 15:16:07 MST 1995
 *
 *	Description:	
 */


NhlErrorTypes _NclFUNCNAME
#if	NhlNeedProto
(void)
#else
()
#endif
{
	NclScalar missing,missing2;
	int has_missing,n_dims;
	ng_size_t dimsizes[NCL_MAX_DIMENSIONS];
	void *out_val;
	float *fout_val;
	double *dout_val;
	void *value;
	float *fvalue;
	double *dvalue;
	byte *bvalue;
	char *cvalue;
	short *svalue;
	int  *ivalue;
	long *lvalue;
	long long *llvalue;
	unsigned char *ucvalue;
	unsigned short *usvalue;
	unsigned int  *uivalue;
	unsigned long *ulvalue;
	unsigned long long *ullvalue;
	
	NclBasicDataTypes type;
	ng_size_t total=1;
	ng_size_t i;

	value = (void*)NclGetArgValue(
			0,
			1,
			&n_dims,
			dimsizes,
			&missing,
			&has_missing,
			&type,
			0);
	for(i = 0; i < n_dims; i++) {
		total *= dimsizes[i];
	}
	switch(type) {
	case NCL_float:
		fvalue = (float*)value;
		out_val = (void*)NclMalloc(total*sizeof(float));
		fout_val = (float*)out_val;
		if(has_missing) {
			for( i = 0 ; i < total; i ++ ) {
				if(fvalue[i] != missing.floatval) {
					fout_val[i] = (float)FUNCNAME((CAST)fvalue[i]);
				} else {
					fout_val[i] = (float)missing.floatval;
				}
			}
		} else {
			for( i = 0 ; i < total; i ++ ) {
				fout_val[i] = (float)FUNCNAME((CAST)fvalue[i]);
			}
		}
		return(NclReturnValue(
			out_val,
			n_dims,
			dimsizes,
			(has_missing ? &missing : NULL),
			NCL_float,
			0
		));
	case NCL_double:
		dvalue = (double*)value;
		out_val = (void*)NclMalloc(total*sizeof(double));
		dout_val = (double*)out_val;
		if(has_missing) {
			for( i = 0 ; i < total; i ++ ) {
				if(dvalue[i] != missing.doubleval) {
					dout_val[i] = (double)FUNCNAME((CAST)dvalue[i]);
				} else {
					dout_val[i] = (double)missing.doubleval;
				}
			}
		} else {
			for( i = 0 ; i < total; i ++ ) {
				dout_val[i] = (double)FUNCNAME((CAST)dvalue[i]);
			}
		}
		return(NclReturnValue(
			out_val,
			n_dims,
			dimsizes,
			(has_missing ? &missing : NULL),
			NCL_double,
			0
		));
	case NCL_byte:
		bvalue = (byte*)value;
		out_val = (void*)NclMalloc(total*sizeof(float));
		fout_val = (float*)out_val;
		if(has_missing) {
			missing2.floatval = (float)missing.byteval;
			for( i = 0 ; i < total; i ++ ) {
				if(bvalue[i] != missing.byteval) {
					fout_val[i] = (float)FUNCNAME((CAST)bvalue[i]);
				} else {
					fout_val[i] = missing2.floatval;
				}
			}
		} else {
			for( i = 0 ; i < total; i ++ ) {
				fout_val[i] = (float)FUNCNAME((CAST)bvalue[i]);
			}
		}
		return(NclReturnValue(
			out_val,
			n_dims,
			dimsizes,
			(has_missing ? &missing2 : NULL),
			NCL_float,
			0
		));
	case NCL_short:
		svalue = (short*)value;
		out_val = (void*)NclMalloc(total*sizeof(float));
		fout_val = (float*)out_val;
		if(has_missing) {
			missing2.floatval = (float)missing.shortval;
			for( i = 0 ; i < total; i ++ ) {
				if(svalue[i] != missing.shortval) {
					fout_val[i] = (float)FUNCNAME((CAST)svalue[i]);
				} else {
					fout_val[i] = missing2.floatval;
				}
			}
		} else {
			for( i = 0 ; i < total; i ++ ) {
				fout_val[i] = (float)FUNCNAME((CAST)svalue[i]);
			}
		}
		return(NclReturnValue(
			out_val,
			n_dims,
			dimsizes,
			(has_missing ? &missing2 : NULL),
			NCL_float,
			0
		));
	case NCL_int:
		ivalue = (int*)value;
		out_val = (void*)NclMalloc(total*sizeof(float));
		fout_val = (float*)out_val;
		if(has_missing) {
			missing2.floatval = (float)missing.intval;
			for( i = 0 ; i < total; i ++ ) {
				if(ivalue[i] != missing.intval) {
					fout_val[i] = (float)FUNCNAME((CAST)ivalue[i]);
				} else {
					fout_val[i] = missing2.floatval;
				}
			}
		} else {
			for( i = 0 ; i < total; i ++ ) {
				fout_val[i] = (float)FUNCNAME((CAST)ivalue[i]);
			}
		}
		return(NclReturnValue(
			out_val,
			n_dims,
			dimsizes,
			(has_missing ? &missing2 : NULL),
			NCL_float,
			0
		));
	case NCL_long:
		lvalue = (long*)value;
		out_val = (void*)NclMalloc(total*sizeof(float));
		fout_val = (float*)out_val;
		if(has_missing) {
			missing2.floatval = (float)missing.longval;
			for( i = 0 ; i < total; i ++ ) {
				if(lvalue[i] != missing.longval) {
					fout_val[i] = (float)FUNCNAME((CAST)lvalue[i]);
				} else {
					fout_val[i] = missing2.floatval;
				}
			}
		} else {
			for( i = 0 ; i < total; i ++ ) {
				fout_val[i] = (float)FUNCNAME((CAST)lvalue[i]);
			}
		}
		return(NclReturnValue(
			out_val,
			n_dims,
			dimsizes,
			(has_missing ? &missing2 : NULL),
			NCL_float,
			0
		));
	case NCL_int64:
		llvalue = (long long *)value;
		out_val = (void*)NclMalloc(total*sizeof(float));
		fout_val = (float*)out_val;
		if(has_missing) {
			missing2.floatval = (float)missing.int64val;
			for( i = 0 ; i < total; i ++ ) {
				if(llvalue[i] != missing.int64val) {
					fout_val[i] = (float)FUNCNAME((CAST)llvalue[i]);
				} else {
					fout_val[i] = missing2.floatval;
				}
			}
		} else {
			for( i = 0 ; i < total; i ++ ) {
				fout_val[i] = (float)FUNCNAME((CAST)llvalue[i]);
			}
		}
		return(NclReturnValue(
			out_val,
			n_dims,
			dimsizes,
			(has_missing ? &missing2 : NULL),
			NCL_float,
			0
		));
	case NCL_char:
		ucvalue = (unsigned char*)value;
		out_val = (void*)NclMalloc(total*sizeof(float));
		fout_val = (float*)out_val;
		if(has_missing) {
			missing2.floatval = (float)missing.charval;
			for( i = 0 ; i < total; i ++ ) {
				if(ucvalue[i] != missing.charval) {
					fout_val[i] = (float)FUNCNAME((CAST)ucvalue[i]);
				} else {
					fout_val[i] = missing2.floatval;
				}
			}
		} else {
			for( i = 0 ; i < total; i ++ ) {
				fout_val[i] = (float)FUNCNAME((CAST)ucvalue[i]);
			}
		}
		return(NclReturnValue(
			out_val,
			n_dims,
			dimsizes,
			(has_missing ? &missing2 : NULL),
			NCL_float,
			0
		));
	case NCL_ubyte:
		ucvalue = (unsigned char *)value;
		out_val = (void*)NclMalloc(total*sizeof(float));
		fout_val = (float*)out_val;
		if(has_missing) {
			missing2.floatval = (float)missing.ubyteval;
			for( i = 0 ; i < total; i ++ ) {
				if(ucvalue[i] != missing.ubyteval) {
					fout_val[i] = (float)FUNCNAME((CAST)ucvalue[i]);
				} else {
					fout_val[i] = missing2.floatval;
				}
			}
		} else {
			for( i = 0 ; i < total; i ++ ) {
				fout_val[i] = (float)FUNCNAME((CAST)ucvalue[i]);
			}
		}
		return(NclReturnValue(
			out_val,
			n_dims,
			dimsizes,
			(has_missing ? &missing2 : NULL),
			NCL_float,
			0
		));
	case NCL_ushort:
		usvalue = (unsigned short*)value;
		out_val = (void*)NclMalloc(total*sizeof(float));
		fout_val = (float*)out_val;
		if(has_missing) {
			missing2.floatval = (float)missing.ushortval;
			for( i = 0 ; i < total; i ++ ) {
				if(usvalue[i] != missing.ushortval) {
					fout_val[i] = (float)FUNCNAME((CAST)usvalue[i]);
				} else {
					fout_val[i] = missing2.floatval;
				}
			}
		} else {
			for( i = 0 ; i < total; i ++ ) {
				fout_val[i] = (float)FUNCNAME((CAST)usvalue[i]);
			}
		}
		return(NclReturnValue(
			out_val,
			n_dims,
			dimsizes,
			(has_missing ? &missing2 : NULL),
			NCL_float,
			0
		));
	case NCL_uint:
		uivalue = (unsigned int*)value;
		out_val = (void*)NclMalloc(total*sizeof(float));
		fout_val = (float*)out_val;
		if(has_missing) {
			missing2.floatval = (float)missing.uintval;
			for( i = 0 ; i < total; i ++ ) {
				if(uivalue[i] != missing.uintval) {
					fout_val[i] = (float)FUNCNAME((CAST)uivalue[i]);
				} else {
					fout_val[i] = missing2.floatval;
				}
			}
		} else {
			for( i = 0 ; i < total; i ++ ) {
				fout_val[i] = (float)FUNCNAME((CAST)uivalue[i]);
			}
		}
		return(NclReturnValue(
			out_val,
			n_dims,
			dimsizes,
			(has_missing ? &missing2 : NULL),
			NCL_float,
			0
		));
	case NCL_ulong:
		ulvalue = (unsigned long*)value;
		out_val = (void*)NclMalloc(total*sizeof(float));
		fout_val = (float*)out_val;
		if(has_missing) {
			missing2.floatval = (float)missing.ulongval;
			for( i = 0 ; i < total; i ++ ) {
				if(ulvalue[i] != missing.ulongval) {
					fout_val[i] = (float)FUNCNAME((CAST)ulvalue[i]);
				} else {
					fout_val[i] = missing2.floatval;
				}
			}
		} else {
			for( i = 0 ; i < total; i ++ ) {
				fout_val[i] = (float)FUNCNAME((CAST)ulvalue[i]);
			}
		}
		return(NclReturnValue(
			out_val,
			n_dims,
			dimsizes,
			(has_missing ? &missing2 : NULL),
			NCL_float,
			0
		));
	case NCL_uint64:
		ullvalue = (unsigned long long *)value;
		out_val = (void*)NclMalloc(total*sizeof(float));
		fout_val = (float*)out_val;
		if(has_missing) {
			missing2.floatval = (float)missing.uint64val;
			for( i = 0 ; i < total; i ++ ) {
				if(ullvalue[i] != missing.uint64val) {
					fout_val[i] = (float)FUNCNAME((CAST)ullvalue[i]);
				} else {
					fout_val[i] = missing2.floatval;
				}
			}
		} else {
			for( i = 0 ; i < total; i ++ ) {
				fout_val[i] = (float)FUNCNAME((CAST)ullvalue[i]);
			}
		}
		return(NclReturnValue(
			out_val,
			n_dims,
			dimsizes,
			(has_missing ? &missing2 : NULL),
			NCL_float,
			0
		));
	default:
		NhlPError(NhlFATAL,NhlEUNKNOWN,"FUNCNAME: a non-numeric type was passed to this function, can not continue");
	}
	return NhlFATAL;
}

/*
 *      $Id: TypeAndOpTemplate.c.sed 12092 2011-02-09 22:36:30Z haley $
 */
/************************************************************************
*									*
*			     Copyright (C)  1995			*
*	     University Corporation for Atmospheric Research		*
*			     All Rights Reserved			*
*									*
************************************************************************/
/*
 *	File:		
 *
 *	Author:		Dave Brown
 *			National Center for Atmospheric Research
 *			PO 3000, Boulder, Colorado
 *
 *	Date:		Wed Jun 17 15:36:20 MDT 2009
 *
 *	Description:	
 */
NhlErrorTypes Ncl_Type_DATATYPE_FUNCNAME
#if	NhlNeedProto
(void *result,void *lhs, void* rhs, NclScalar* lhs_m, NclScalar* rhs_m, ng_size_t nlhs, ng_size_t nrhs)
#else
(result,lhs,rhs,lhs_m,rhs_m,nlhs,nrhs)
void *result;
void *lhs;
void* rhs;
NclScalar* lhs_m;
NclScalar* rhs_m;
ng_size_t nlhs;
ng_size_t nrhs;
#endif
{
        LOCALTYPE *ls,*rs;
	OUTDATATYPE *res;
	ng_size_t stopi = 1;
	ng_size_t linc = 0;
	ng_size_t rinc = 0;
	ng_size_t i;

	ls = (LOCALTYPE*)lhs;
	rs = (LOCALTYPE*)rhs;
	res = (OUTDATATYPE*)result;

	if(nlhs > nrhs) 
		stopi = nlhs;
	else
		stopi = nrhs;
	if(nlhs > 1) {
		linc = 1;
	}
	if(nrhs > 1) {
		rinc = 1;
	}
	

	if((lhs_m == NULL)&&(rhs_m == NULL)) {
		for(i = 0; i < stopi; i++, res++, ls += linc, rs += rinc) {
			*res = (OUTDATATYPE)(*ls THEOP *rs);
		}
	} else if(rhs_m == NULL) {
		for(i = 0 ; i < stopi; i++, res++, ls += linc, rs += rinc) {
			*res = (OUTDATATYPE)(( lhs_m->DATATYPEval == *ls) ? ( LEFTMISSING ) : (*ls THEOP *rs));
		}
	} else if(lhs_m == NULL ) {
		for(i = 0; i < stopi; i++, res++, ls += linc, rs += rinc) {
                        if (!(OUTDATATYPE) *ls) {
                        	*res = (OUTDATATYPE) (*ls && 0);
			}
			else {
				*res = (OUTDATATYPE)(( rhs_m->DATATYPEval == *rs) ? ( RIGHTMISSING ) : (*ls && *rs));
			}
		}
	} else {
		for(i = 0; i < stopi; i++, res++, ls += linc, rs += rinc) {
			if (lhs_m->DATATYPEval == *ls) {
				*res = (OUTDATATYPE) ( LEFTMISSING );
			}
			else if (! (OUTDATATYPE) *ls) {
                        	*res = (OUTDATATYPE) (*ls && 0);
			}
			else {
				*res = (OUTDATATYPE)(( rhs_m->DATATYPEval == *rs) ? ( LEFTMISSING ) : (*ls && *rs));
			}
		}
	}
	return(NhlNOERROR);
}

NclTypeClass Ncl_Type_DATATYPE_FUNCNAME_type
#if	NhlNeedProto
(void)
#else
()
#endif
{
	return((NclTypeClass)nclTypeOUTDATATYPEClass);
}

#!/usr/bin/ksh
#---------------------------------------------------------
#  NCL Doc Examples: NCL_cdo_remap_bilinear_CMIP5_grid_to_1x1deg_grid.ksh
#  Regrid CMIP5 grid to world grid 1x1 degrees - bilinear
#
#  weights_bilinear.nc:  weights file generated by 'cdo genbil'
#
#  KMF 30.10.14
#---------------------------------------------------------
t1=$(date +%s)

dir="./"
fin="$dir/thetao_ocean_rectilinear_grid_2D.nc"
fout="remap_bilinear_CMIP5_thetao.nc"
wgts="weights_bilinear.nc"

#-- generate bilinear interpolation weights
cdo genbil,r360x180 ${fin} ${wgts}

#-- remap to 1x1 degree grid using the weights file
cdo remap,r360x180,${wgts} ${fin} ${fout}

#-- following call will give the same result and elapsed time
#-- as 'cdo genbil' and 'cdo remap', but won't save the weights file
#cdo remapbil,r360x180 ${fin} ${fout}

t2=$(date +%s)
td=$(expr $t2 - $t1)
echo "Elapsed time:  ${td}s"

exit

#!/bin/csh -f
#
#	$Id: version.sed,v 1.26 2010-03-14 16:33:22 haley Exp $
#                                                                      
#                Copyright (C)  2000
#        University Corporation for Atmospheric Research
#                All Rights Reserved
#
# The use of this Software is governed by a License Agreement.
#
echo ""
cat <<EOF
NCAR View - UNIX Version VERSION
Copyright (C) 1987-2018
University Corporation for Atmospheric Research

The use of this Software is governed by a License Agreement.

EOF

#!/bin/sh

sh op_funcs.sh ulong NhlTUlong NhlTUlongGenArray 4294967295U > .tmp.$$

if [ ! $? ]
then
	exit $?
fi

sed \
-e 's/PRINTFORMAT/\%lu\\n/' \
-e 's/DATATYPE/ulong/g' \
-e 's/LOCALTYPE/unsigned long/g' \
-e 's/HLUTYPEREP/NhlTUlong/g' \
-e 's/HLUGENTYPEREP/NhlTUlongGenArray/g' \
-e 's/DEFAULT_MISS/4294967295U/g' \
-e 's/DEFAULT_FORMAT/%lu/g' \
-e "/REPLACE/r .tmp.$$" \
-e '/REPLACE/d' \
-e '/DSPECIFIC/r NclTypeulong.c.specific' \
-e '/DSPECIFIC/d' \
NclType.c.sed > NclTypeulong.c

rm .tmp.$$

echo "created NclTypeulong.c"

exit 0

#!/bin/sh

sh op_funcs.sh double NhlTDouble NhlTDoubleGenArray 9.9692099683868690e+36 > .tmp.$$ 

if [ ! $? ]
then
	exit $?
fi

sed \
-e 's/DATATYPE/double/g' \
-e 's/LOCALTYPE/double/g' \
-e 's/HLUTYPEREP/NhlTDouble/g' \
-e 's/HLUGENTYPEREP/NhlTDoubleGenArray/g' \
-e 's/DEFAULT_MISS/9.9692099683868690e+36/g' \
-e 's/DEFAULT_FORMAT/%lf/g' \
-e "/REPLACE/r .tmp.$$" \
-e '/REPLACE/d' \
-e '/DSPECIFIC/r NclTypedouble.c.specific' \
-e '/DSPECIFIC/d' \
-e 's/Ncl_Type_double_mod_type/NULL/' \
-e 's/Ncl_Type_double_mod/NULL/' \
NclType.c.sed > NclTypedouble.c

rm .tmp.$$

echo "created NclTypedouble.c"

exit 0

#!/bin/csh -f
#
#	$Id: ctlib.csh,v 1.9 2008-07-27 03:58:55 haley Exp $
#
#                Copyright (C)  2000
#        University Corporation for Atmospheric Research
#                All Rights Reserved
#
# The use of this Software is governed by a License Agreement.
#
#	This script simply reports the libraries required by ctrans.
#	The library list will vary depending on machine configuration
#

set libdir = `ncargpath LIBDIR`
if ($status != 0) then
	exit 1
endif
if (! -d "$libdir") then
  echo "Library directory <$libdir> does not exist."
  exit 1
endif

set robjdir = $libdir/NCARGDIR/ROBJDIR

set locals = ""

foreach file (CTRANS_ROBJS)
  set locals = "$locals $robjdir/$file"
end

foreach file (CTRANS_LIBS_A)
  set locals = "$locals $libdir/$file"
end

echo $locals CTRANS_LIBS_B

#!/bin/sh

sh op_funcs.sh nclfile NULL NULL > .tmp.$$

if [ ! $? ]
then
	exit $?
fi

sed \
-e 's/PRINTFORMAT/\%d\\n/' \
-e '/PRINTFORMAT/d' \
-e 's/DATATYPE/nclfile/g' \
-e 's/HLUTYPEREP/NULL/g' \
-e 's/HLUGENTYPEREP/NULL/g' \
-e 's/DEFAULT_FORMAT/%d/g' \
-e "/REPLACE/r .tmp.$$" \
-e '/REPLACE/d' \
-e '/DSPECIFIC/r NclMultiDValnclfileData.c.specific' \
-e '/DSPECIFIC/d' \
-e 's/MultiDVal_nclfile_InitClass/NULL/' \
-e 's/MultiDVal_nclfile_md_Not/NULL/' \
-e 's/MultiDVal_nclfile_s_Not/NULL/' \
-e 's/MultiDVal_nclfile_mdmd_And/NULL/' \
-e 's/MultiDVal_nclfile_smd_And/NULL/' \
-e 's/MultiDVal_nclfile_mds_And/NULL/' \
-e 's/MultiDVal_nclfile_ss_And/NULL/' \
-e 's/MultiDVal_nclfile_mdmd_Or/NULL/' \
-e 's/MultiDVal_nclfile_smd_Or/NULL/' \
-e 's/MultiDVal_nclfile_mds_Or/NULL/' \
-e 's/MultiDVal_nclfile_ss_Or/NULL/' \
-e 's/MultiDVal_nclfile_mdmd_Xor/NULL/' \
-e 's/MultiDVal_nclfile_smd_Xor/NULL/' \
-e 's/MultiDVal_nclfile_mds_Xor/NULL/' \
-e 's/MultiDVal_nclfile_ss_Xor/NULL/' \
-e 's/MultiDVal_nclfile_mdmd_Mod/NULL/' \
-e 's/MultiDVal_nclfile_smd_Mod/NULL/' \
-e 's/MultiDVal_nclfile_mds_Mod/NULL/' \
-e 's/MultiDVal_nclfile_ss_Mod/NULL/' \
-e 's/MultiDVal_nclfile_mdmd_Div/NULL/' \
-e 's/MultiDVal_nclfile_smd_Div/NULL/' \
-e 's/MultiDVal_nclfile_mds_Div/NULL/' \
-e 's/MultiDVal_nclfile_ss_Div/NULL/' \
-e 's/MultiDVal_nclfile_mdmd_Mul/NULL/' \
-e 's/MultiDVal_nclfile_smd_Mul/NULL/' \
-e 's/MultiDVal_nclfile_mds_Mul/NULL/' \
-e 's/MultiDVal_nclfile_ss_Mul/NULL/' \
-e 's/MultiDVal_nclfile_mdmd_Plus/NULL/' \
-e 's/MultiDVal_nclfile_smd_Plus/NULL/' \
-e 's/MultiDVal_nclfile_mds_Plus/NULL/' \
-e 's/MultiDVal_nclfile_ss_Plus/NULL/' \
-e 's/MultiDVal_nclfile_mdmd_Minus/NULL/' \
-e 's/MultiDVal_nclfile_smd_Minus/NULL/' \
-e 's/MultiDVal_nclfile_mds_Minus/NULL/' \
-e 's/MultiDVal_nclfile_ss_Minus/NULL/' \
-e 's/MultiDVal_nclfile_mdmd_Exp/NULL/' \
-e 's/MultiDVal_nclfile_smd_Exp/NULL/' \
-e 's/MultiDVal_nclfile_mds_Exp/NULL/' \
-e 's/MultiDVal_nclfile_ss_Exp/NULL/' \
-e 's/MultiDVal_nclfile_mdmd_SelLt/NULL/' \
-e 's/MultiDVal_nclfile_smd_SelLt/NULL/' \
-e 's/MultiDVal_nclfile_mds_SelLt/NULL/' \
-e 's/MultiDVal_nclfile_ss_SelLt/NULL/' \
-e 's/MultiDVal_nclfile_mdmd_SelGt/NULL/' \
-e 's/MultiDVal_nclfile_smd_SelGt/NULL/' \
-e 's/MultiDVal_nclfile_mds_SelGt/NULL/' \
-e 's/MultiDVal_nclfile_ss_SelGt/NULL/' \
-e 's/MultiDVal_nclfile_md_Neg/NULL/' \
-e 's/MultiDVal_nclfile_s_Neg/NULL/' \
-e 's/MultiDVal_nclfile_mdmd_Gt/NULL/' \
-e 's/MultiDVal_nclfile_smd_Gt/NULL/' \
-e 's/MultiDVal_nclfile_mds_Gt/NULL/' \
-e 's/MultiDVal_nclfile_ss_Gt/NULL/' \
-e 's/MultiDVal_nclfile_mdmd_Lt/NULL/' \
-e 's/MultiDVal_nclfile_smd_Lt/NULL/' \
-e 's/MultiDVal_nclfile_mds_Lt/NULL/' \
-e 's/MultiDVal_nclfile_ss_Lt/NULL/' \
-e 's/MultiDVal_nclfile_mdmd_Ge/NULL/' \
-e 's/MultiDVal_nclfile_smd_Ge/NULL/' \
-e 's/MultiDVal_nclfile_mds_Ge/NULL/' \
-e 's/MultiDVal_nclfile_ss_Ge/NULL/' \
-e 's/MultiDVal_nclfile_mdmd_Le/NULL/' \
-e 's/MultiDVal_nclfile_smd_Le/NULL/' \
-e 's/MultiDVal_nclfile_mds_Le/NULL/' \
-e 's/MultiDVal_nclfile_ss_Le/NULL/' \
-e 's/MultiDVal_nclfile_mdmd_Ne/NULL/' \
-e 's/MultiDVal_nclfile_smd_Ne/NULL/' \
-e 's/MultiDVal_nclfile_mds_Ne/NULL/' \
-e 's/MultiDVal_nclfile_ss_Ne/NULL/' \
NclMultiDValData.c.sed > NclMultiDValnclfileData.c

rm .tmp.$$

echo "created NclMultiDValnclfileData.c"

exit 0

/*
 *      $Id: MathTemplate2.c.sed,v 1.5 2009-02-10 18:48:09 haley Exp $
 */
/************************************************************************
*									*
*			     Copyright (C)  1995			*
*	     University Corporation for Atmospheric Research		*
*			     All Rights Reserved			*
*									*
************************************************************************/
/*
 *	File:		
 *
 *	Author:		Ethan Alpert
 *			National Center for Atmospheric Research
 *			PO 3000, Boulder, Colorado
 *
 *	Date:		Tue Jan 31 15:16:07 MST 1995
 *
 *	Description:	
 */


NhlErrorTypes _NclFUNCNAME
#if	NhlNeedProto
(void)
#else
()
#endif
{
	NclScalar missing0,missing1,dm0,dm1;
	int has_missing0,n_dims0;
	ng_size_t dimsizes0[NCL_MAX_DIMENSIONS];
	int has_missing1,n_dims1;
	ng_size_t dimsizes1[NCL_MAX_DIMENSIONS];
	double *dout_val;
	float *fout_val;
	void *value0;
	void *value1;
	double *dval0;
	double *dval1;
	float *fval0;
	float *fval1;
	NclBasicDataTypes type0,out_type;
	NclBasicDataTypes type1;
	ng_size_t total1=1;
	ng_size_t total0=1;
	ng_size_t i;

	value0 = (void*)NclGetArgValue(
			0,
			2,
			&n_dims0,
			dimsizes0,
			&missing0,
			&has_missing0,
			&type0,
			0);
	for(i = 0; i < n_dims0; i++) {
		total0 *= dimsizes0[i];
	}

	value1 = (void*)NclGetArgValue(
			1,
			2,
			&n_dims1,
			dimsizes1,
			&missing1,
			&has_missing1,
			&type1,
			0);
	for(i = 0; i < n_dims1; i++) {
		total1 *= dimsizes1[i];
	}
	if((type1 == NCL_double)||(type0==NCL_double)) {
		out_type = NCL_double;
	} else {
		out_type = NCL_float;
	}
	if(total0 == total1) {
		switch(out_type) {
		case NCL_double:
			if(type0 == NCL_double) {
				dval0 = (double*)value0;
				if(has_missing0) {
					dm0.doubleval = missing0.doubleval;
				}
			} else {
				dval0 = (double*)NclMalloc(sizeof(double)*total0);
				_Nclcoerce((NclTypeClass)nclTypedoubleClass,
						dval0,
						value0,
						total0,
						&missing0,
						NULL,
						(NclTypeClass)_NclNameToTypeClass(NrmStringToQuark(_NclBasicDataTypeToName(type0))));

				dm0.doubleval = ((NclTypeClass)nclTypedoubleClass)->type_class.default_mis.floatval;
			}
			if(type1 == NCL_double) {
				dval1 = (double*)value1;
				if(has_missing1) {
					dm1.doubleval = missing1.doubleval;
				}
			} else {
				dval1 = (double*)NclMalloc(sizeof(double)*total1);
				_Nclcoerce((NclTypeClass)nclTypedoubleClass,
						dval1,
						value1,
						total1,
						&missing1,
						NULL,
						(NclTypeClass)_NclNameToTypeClass(NrmStringToQuark(_NclBasicDataTypeToName(type1))));
				dm1.doubleval = ((NclTypeClass)nclTypedoubleClass)->type_class.default_mis.doubleval;
			}
		
			dout_val = (double*)NclMalloc(total0*sizeof(double));

			if(has_missing0&&!has_missing1) {
				for( i = 0 ; i < total0; i ++ ) {
					if(dval0[i] != dm0.doubleval) {
						dout_val[i] = FUNCNAME((CAST)dval0[i],(CAST)dval1[i]);
					} else {
						dout_val[i] = dm0.doubleval;
					}
				}
			} else if(has_missing1&&!has_missing0) {
				for( i = 0 ; i < total1; i ++ ) {
					if(dval1[i] != dm1.doubleval) {
						dout_val[i] = FUNCNAME((CAST)dval0[i],(CAST)dval1[i]);
					} else {
						dout_val[i] = dm1.doubleval;
					}
				}
			} else if(has_missing1&&has_missing0) {
				for( i = 0 ; i < total0; i ++ ) {
					if((dval0[i] != dm0.doubleval)&&(dval1[i] != dm1.doubleval)) {
						dout_val[i] = FUNCNAME((CAST)dval0[i],(CAST)dval1[i]);
					} else {
						dout_val[i] = dm1.doubleval;
					}
				}
			} else {
				for( i = 0 ; i < total0; i ++ ) {
					dout_val[i] = FUNCNAME((CAST)dval0[i],(CAST)dval1[i]);
				}
			}
			if((void*)dval0 != value0) {
				NclFree(dval0);
			}
			if((void*)dval1 != value1) {
				NclFree(dval1);
			}
			return(NclReturnValue(
				dout_val,
				n_dims0,
				dimsizes0,
				(has_missing0 ? &dm0 : has_missing1 ? &dm1 : NULL),
				NCL_double,
				0
			));
		case NCL_float:
			if(type0 == NCL_float) {
				fval0 = (float*)value0;
				if(has_missing0) {
					dm0.floatval = missing0.floatval;
				}
			} else {
				fval0 = (float*)NclMalloc(sizeof(float)*total0);
				_Nclcoerce((NclTypeClass)nclTypefloatClass,
						fval0,
						value0,
						total0,
						&missing0,
						NULL,
						(NclTypeClass)_NclNameToTypeClass(NrmStringToQuark(_NclBasicDataTypeToName(type0))));
				dm0.floatval = ((NclTypeClass)nclTypefloatClass)->type_class.default_mis.floatval;
			}
			if(type1 == NCL_float) {
				fval1 = (float*)value1;
				if(has_missing1) {
					dm1.floatval = missing1.floatval;
				}
			} else {
				fval1 = (float*)NclMalloc(sizeof(float)*total1);
				_Nclcoerce((NclTypeClass)nclTypefloatClass,
						fval1,
						value1,
						total1,
						&missing1,
						NULL,
						(NclTypeClass)_NclNameToTypeClass(NrmStringToQuark(_NclBasicDataTypeToName(type1))));
				dm1.floatval = ((NclTypeClass)nclTypefloatClass)->type_class.default_mis.floatval;
			}
		
			fout_val = (float*)NclMalloc(total0*sizeof(float));

			if(has_missing0&&!has_missing1) {
				for( i = 0 ; i < total0; i ++ ) {
					if(fval0[i] != dm0.floatval) {
						fout_val[i] = FUNCNAME((CAST)fval0[i],(CAST)fval1[i]);
					} else {
						fout_val[i] = dm0.floatval;
					}
				}
			} else if(has_missing1&&!has_missing0) {
				for( i = 0 ; i < total1; i ++ ) {
					if(fval1[i] != dm1.floatval) {
						fout_val[i] = FUNCNAME((CAST)fval0[i],(CAST)fval1[i]);
					} else {
						fout_val[i] = dm1.floatval;
					}
				}
			} else if(has_missing1&&has_missing0) {
				for( i = 0 ; i < total0; i ++ ) {
					if((fval0[i] != dm0.floatval)&&(fval1[i] != dm1.floatval)) {
						fout_val[i] = FUNCNAME((CAST)fval0[i],(CAST)fval1[i]);
					} else {
						fout_val[i] = dm1.floatval;
					}
				}
			} else {
				for( i = 0 ; i < total0; i ++ ) {
					fout_val[i] = FUNCNAME((CAST)fval0[i],(CAST)fval1[i]);
				}
			}
			if((void*)fval0 != value0) {
				NclFree(fval0);
			}
			if((void*)fval1 != value1) {
				NclFree(fval1);
			}
			return(NclReturnValue(
				fout_val,
				n_dims0,
				dimsizes0,
				(has_missing0 ? &dm0 : has_missing1 ? &dm1 : NULL),
				NCL_float,
				0
			));
		default:
			NhlPError(NhlFATAL,NhlEUNKNOWN,"FUNCNAME: internal error: can not continue");
			return NhlFATAL;
		}

	} else {
		NhlPError(NhlFATAL,NhlEUNKNOWN,"FUNCNAME parameter 0 and parameter 1 are not the same size");
		return(NhlFATAL);
	}
}

C
C	$Id: trlate.f.sed,v 1.2 2008-07-27 00:59:05 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE TRLATE(IOS,STATUS)
C
C  PROCESS OLD METACODE INSTRUCTIONS
C
C  OUTPUT
C       IOS-READ STATUS ONLY VALID IF STATUS SET TO AN I/O ERROR
C       STATUS-THE STATUS FLAG DEFINED BY COMMON TREROR
C
      COMMON/TREROR/ ALLOK, MFRCHK, MTOPER, METRDC, REDERR, TYPCHG
     1             ,INVTYP, MINVLD, TYPERR, FRMEND, ENCINT, IVDCDT
     2             ,GCOERR, GCRERR, GCCERR, FCOERR, FCRERR, FCCERR
     3             ,PLIDXG, PMIDXG, TXIDXG, PGIDXG, INVLMT, CELERR
     4             ,COIERR, COLNRM, UNKNOW, UNKOPC, ENDMTF, VNEROR
     5             ,BADRSZ, DEVOUT, NOVERS, BADFNT, PGMERR, FASERR
     6             ,HINERR, VDWERR, RDWERR, RIXLIM
      INTEGER        ALLOK, MFRCHK, MTOPER, METRDC, REDERR, TYPCHG
     1             ,INVTYP, MINVLD, TYPERR, FRMEND, ENCINT, IVDCDT
     2             ,GCOERR, GCRERR, GCCERR, FCOERR, FCRERR, FCCERR
     3             ,PLIDXG, PMIDXG, TXIDXG, PGIDXG, INVLMT, CELERR
     4             ,COIERR, COLNRM, UNKNOW, UNKOPC, ENDMTF, VNEROR
     5             ,BADRSZ, DEVOUT, NOVERS, BADFNT, PGMERR, FASERR
     6             ,HINERR, VDWERR, RDWERR, RIXLIM
      COMMON /TRFRAM/ METALL, FRINIT, FRCNT
      LOGICAL METALL, FRINIT
      INTEGER  FRCNT
      COMMON /TRINST/ OPCL, OPID, LEN, CONT
      INTEGER OPCL, OPID, LEN
      LOGICAL CONT
      COMMON /TRMTYP/ FOURBT, MULTBT, TWOBT, PTSFLG, CURCOL, IPWRIT,
     1                IFRAME, ISETOP, IRANG, IPTS, ICAS, IINT, IORNT,
     2                ISIZE, IFONT, IPAT, ISSIZ, ICENT, ICOLR,
     3                MCENT, MSIZE, MOR, OLDX, OLDY, MCASE, MINTEN,
     4                MFONT, MDASH, MSPOT, MCOLOR, MLIMIT, PTSYM,
     5                SAVX, SAVY
      INTEGER FOURBT, MULTBT, TWOBT, PTSFLG, CURCOL, IPWRIT,
     1                IFRAME, ISETOP, IRANG, IPTS, ICAS, IINT, IORNT,
     2                ISIZE, IFONT, IPAT, ISSIZ, ICENT, ICOLR,
     3                MCENT, MSIZE, MOR, OLDX, OLDY, MCASE, MINTEN,
     4                MFONT, MDASH, MSPOT, MCOLOR(3), MLIMIT(4), PTSYM,
     5                SAVX, SAVY
      COMMON /TRCNTL/ INPICT, INMETA, RECINT
      LOGICAL INPICT, INMETA
      INTEGER RECINT
      COMMON /PTRBUFR/ METBIT, MBUFER, MDTYPE, METREC, MRECLN,
     1                MCONTF, MOPRST, LNGFLG, MERGFL
      INTEGER MNWRDS, RECLOC, RECSIZ, DTLOC, DTSIZ, MBITST, MBUFOF,
     1        MINSBD, MERLOC, MERSIZ
#if defined(cray)
      PARAMETER (MNWRDS=180, RECLOC=0, RECSIZ=16, DTLOC=16, DTSIZ=4
#else
      PARAMETER (MNWRDS=360, RECLOC=0, RECSIZ=16, DTLOC=16, DTSIZ=4
#endif
     1          ,MBITST=32, MBUFOF=32, MINSBD=16, MERLOC=23, MERSIZ=1)
      INTEGER METBIT, MBUFER(MNWRDS), MDTYPE, METREC, MRECLN, MOPRST
      LOGICAL MCONTF, LNGFLG, MERGFL
      COMMON /CAPDEV/ DGISTR, DGISIZ, DGESTR, DGESIZ, DTISTR,
     1                DTISIZ, DCDLLX, DCDLLY, DCDURX, DCDURY,
     3                DCOAVL, CORFMT, CORFIN, BATCH , DHCSIZ,
     4                DHCSTR, CORXOF, CORYOF, DASBIT, CORXSC,
     5                CORYSC, VDWLLX, VDWLLY, VDWURX, VDWURY
      INTEGER         DGIMAX, DGEMAX, DTIMAX, DCFTMX, DHCMAX
      PARAMETER   (DGIMAX=300, DGEMAX=150, DTIMAX=100)
      PARAMETER   (DCFTMX=30 , DHCMAX=50)
      INTEGER         DGISTR(DGIMAX), DGISIZ, DGESTR(DGEMAX),
     1                DGESIZ, DTISTR(DTIMAX), DTISIZ, DCDLLX,
     2                DCDLLY, DCDURX, DCDURY, CORFMT(DCFTMX,4),
     3                CORFIN(8)     , DHCSIZ, DHCSTR(DHCMAX),
     4                CORXOF, CORYOF, DASBIT, VDWLLX, VDWLLY,
     5                VDWURX, VDWURY
      REAL            CORXSC, CORYSC, CORRIN(8)
      LOGICAL         DCOAVL, BATCH
C  Size of the COMMON
      INTEGER         LENDEV
      PARAMETER   (LENDEV=DGIMAX+1+DGEMAX+1+DTIMAX+1+4+1+4*DCFTMX+
     1                  8+2+DHCMAX+9)
      EQUIVALENCE (CORFIN,CORRIN)
C
      INTEGER IOS, STATUS
      INTEGER ONE
C
C  LOCAL DATA DEFS
C
      DATA ONE/1/
C
C  INITIALIZE THE DATA STRUCTURES
C
      CALL XMDEF(IOS, STATUS)
      IF (STATUS .NE. ALLOK) RETURN
      CALL MMDEF
C
C  TEST IF INITIAL FRAME AND TAKE APPROPRIATE ACTION
C   ACTIVATE GRAPHICS MODE, ERASE THE SCREEN AND LOAD THE COLOR TABLE
C
      IF (FRINIT) THEN
        CALL LODCTB(IOS,STATUS)
        IF (STATUS.NE.ALLOK) RETURN
        FRINIT = .FALSE.
      END IF
C
C  IF ONLY ONE FRAME REQUESTED THEN SET THE RECORD POINTER TO IT
C
      IF (.NOT. METALL) THEN
        METREC = RECINT
        CALL METRED(IOS, STATUS)
        IF (STATUS.NE.ALLOK) RETURN
      END IF
C
C LOOP THROUGH THE INSTRUCTIONS.  ONE METACODE INSTRUCTION IS PROCESSED
C FOR EACH PASS THROUGH THIS LOOP.
C
  100 CONTINUE
C
      CALL MNINST(ONE,IOS,STATUS)
      IF (STATUS .NE. ALLOK) RETURN
C
C  TEST FOR 4 BYTE INSTRUCTION (POSITION INSTRUCTION)
C
      IF (OPCL.EQ.FOURBT) THEN
C
C       POSITION INSTRUCTION
C
        CALL POSIT(IOS,STATUS)
        IF (STATUS.NE.ALLOK) RETURN
C
      ELSE
C
C       TEST FOR THE MULTIBYTE OR TWOBYTE INSTRUCTION
C
        CALL MNINST(ONE,IOS,STATUS)
        IF (STATUS .NE. ALLOK) RETURN
C
        IF (OPCL .EQ. MULTBT) THEN
C
C               MULTIBYTE INSTRUCTION
C
                CALL MULTI(IOS,STATUS)
                IF (STATUS .NE. ALLOK) RETURN
C
        ELSE
C
C               2 BYTE INSTRUCTION
C
                CALL TWOBYT(IOS,STATUS)
                IF (STATUS .NE. ALLOK) RETURN
        END IF
      END IF
C
C  GET THE NEXT INSTRUCTION
C
      GO TO 100
C
      END

#!/bin/sh
#
#      $Id: syms_lex.sh,v 1.1 1994-07-21 23:16:35 boote Exp $
#
#########################################################################
#									#
#			   Copyright (C)  1994				#
#	     University Corporation for Atmospheric Research		#
#			   All Rights Reserved				#
#									#
#########################################################################
#
#	File:		syms_lex.sh
#
#	Author:		Jeff W. Boote
#			National Center for Atmospheric Research
#			PO 3000, Boulder, Colorado
#
#	Date:		Mon Jul 18 11:32:03 MDT 1994
#
#	Description:	This script is used to create scanner.c from lex.yy.c.
#			It changes all the "yy" symbols it needs to change
#			to avoid conflicts with system libraries on brain
#			dead suns.
#
#	Usage:
#
#	Environment:
#
#	Files:
#
#
#	Options:

sed \
-e "s/yyback/nclback/g" \
-e "s/yybgin/nclbgin/g" \
-e "s/yych/nclch/g" \
-e "s/yycrank/nclcrank/g" \
-e "s/yyestate/nclestate/g" \
-e "s/yyextra/nclextra/g" \
-e "s/yyfirst/nclfirst/g" \
-e "s/yyfnd/nclfnd/g" \
-e "s/yyfussy/nclfussy/g" \
-e "s/yyin/nclin/g" \
-e "s/yyinput/nclinput/g" \
-e "s/yylastch/ncllastch/g" \
-e "s/yylex/ncllex/g" \
-e "s/yylineno/ncllineno/g" \
-e "s/yylook/ncllook/g" \
-e "s/yylsp/ncllsp/g" \
-e "s/yylstate/ncllstate/g" \
-e "s/yylval/ncllval/g" \
-e "s/yymatch/nclmatch/g" \
-e "s/yymore/nclmore/g" \
-e "s/yymorfg/nclmorfg/g" \
-e "s/yyolsp/nclolsp/g" \
-e "s/yyother/nclother/g" \
-e "s/yyout/nclout/g" \
-e "s/yyoutput/ncloutput/g" \
-e "s/yyr/nclr/g" \
-e "s/yyreject/nclreject/g" \
-e "s/yysbuf/nclsbuf/g" \
-e "s/yysptr/nclsptr/g" \
-e "s/yystate/nclstate/g" \
-e "s/yystoff/nclstoff/g" \
-e "s/yystops/nclstops/g" \
-e "s/yysvec/nclsvec/g" \
-e "s/yysvf/nclsvf/g" \
-e "s/yytchar/ncltchar/g" \
-e "s/yytop/ncltop/g" \
-e "s/yyvstop/nclvstop/g" \
-e "s/yywork/nclwork/g" \
-e "s/yywrap/nclwrap/g" \
-e "s/yyz/nclz/g" \
lex.yy.c > scanner.c

exit 0

#!/bin/sh
#
#      $Id: syms_tab_c.sh,v 1.1 1994-07-21 23:16:37 boote Exp $
#
#########################################################################
#									#
#			   Copyright (C)  1994				#
#	     University Corporation for Atmospheric Research		#
#			   All Rights Reserved				#
#									#
#########################################################################
#
#	File:		syms_tab_c.sh
#
#	Author:		Jeff W. Boote
#			National Center for Atmospheric Research
#			PO 3000, Boulder, Colorado
#
#	Date:		Mon Jul 18 11:40:47 MDT 1994
#
#	Description:	Creates parser.c from y.tab.c changing symbols so
#			conflicts with other libraries go away.
#
#	Usage:
#
#	Environment:
#
#	Files:
#
#
#	Options:
sed \
-e "s/yy_i/ncl_i/g" \
-e "s/yy_len/ncl_len/g" \
-e "s/yy_n/ncl_n/g" \
-e "s/yy_newstate/ncl_newstate/g" \
-e "s/yy_ps/ncl_ps/g" \
-e "s/yy_pv/ncl_pv/g" \
-e "s/yy_stack/ncl_stack/g" \
-e "s/yy_state/ncl_state/g" \
-e "s/yyact/nclact/g" \
-e "s/yychar/nclchar/g" \
-e "s/yychk/nclchk/g" \
-e "s/yyclearin/nclclearin/g" \
-e "s/yydebug/ncldebug/g" \
-e "s/yydef/ncldef/g" \
-e "s/yydefault/ncldefault/g" \
-e "s/yyerrflag/nclerrflag/g" \
-e "s/yyerrlab/nclerrlab/g" \
-e "s/yyerrok/nclerrok/g" \
-e "s/yyerror/nclerror/g" \
-e "s/yyexca/nclexca/g" \
-e "s/yyin/nclin/g" \
-e "s/yylex/ncllex/g" \
-e "s/yylineno/ncllineno/g" \
-e "s/yylval/ncllval/g" \
-e "s/yymaxdepth/nclmaxdepth/g" \
-e "s/yynerrs/nclnerrs/g" \
-e "s/yynewstate/nclnewstate/g" \
-e "s/yypact/nclpact/g" \
-e "s/yyparse/nclparse/g" \
-e "s/yypgo/nclpgo/g" \
-e "s/yyps/nclps/g" \
-e "s/yyps_index/nclps_index/g" \
-e "s/yypv/nclpv/g" \
-e "s/yypv_index/nclpv_index/g" \
-e "s/yypvt_index/nclpvt_index/g" \
-e "s/yypvt/nclpvt/g" \
-e "s/yyr/nclr/g" \
-e "s/yyreds/nclreds/g" \
-e "s/yys/ncls/g" \
-e "s/yystack/nclstack/g" \
-e "s/yystate/nclstate/g" \
-e "s/yytmp/ncltmp/g" \
-e "s/yytoks/ncltoks/g" \
-e "s/yytoktype/ncltoktype/g" \
-e "s/yyv/nclv/g" \
-e "s/yyval/nclval/g" \
-e "s/yyxi/nclxi/g" \
y.tab.c > parser.c

exit 0

#!/bin/csh -f -b
#
#	$Id: ncargsrcy.csh,v 1.6 2008-07-27 00:59:06 haley Exp $
#                                                                      
#                Copyright (C)  2000
#        University Corporation for Atmospheric Research
#                All Rights Reserved
#
# The use of this Software is governed by a License Agreement.
#

set path = (/bin /usr/bin)

set bnpath = $0
set bindir = $bnpath:h
set l = `$bindir/ncargpath SED_LIBDIR`

if ($status != 0) then
        exit 1
endif

set nlibs = "$l/srcncarg.a $l/srcncarg_gks.a"
set alibs = ""
set blibs = ""

echo ""
echo "Remember that NCAR Graphics source code is copyrighted."
echo ""

echo "`who am i` `date` $*" >>! $l/ncargsrc.stats

if ($#argv == 1 && "$1" == "-index") then

  cat << END > INDEX
Contents of the library srcncarg.a:

`ar t $l/srcncarg.a | sort | pr -t -5 -l1`

Contents of the library srcncarg_gks.a:

`ar t $l/srcncarg_gks.a | sort | pr -t -5 -l1`

Contents of the library srcagupwrtx.a:

`ar t $l/srcagupwrtx.a | sort | pr -t -5 -l1`

Contents of the library srcconraq.a:

`ar t $l/srcconraq.a | sort | pr -t -5 -l1`

Contents of the library srcconras.a:

`ar t $l/srcconras.a | sort | pr -t -5 -l1`

Contents of the library srcconrcqck.a:

`ar t $l/srcconrcqck.a | sort | pr -t -5 -l1`

Contents of the library srcconrcspr.a:

`ar t $l/srcconrcspr.a | sort | pr -t -5 -l1`

Contents of the library srcdashline.a:

`ar t $l/srcdashline.a | sort | pr -t -5 -l1`

Contents of the library srcdashsmth.a:

`ar t $l/srcdashsmth.a | sort | pr -t -5 -l1`

Contents of the library srcdashsupr.a:

`ar t $l/srcdashsupr.a | sort | pr -t -5 -l1`
END

  chmod 644 INDEX

  exit 0

endif

foreach arg ($argv)

  switch ($arg)

  case "-agupwrtx":

    set alibs = "$alibs $l/srcagupwrtx.a"
    set blibs = "$l/srcagupwrtx.a $blibs"
    breaksw

  case "-quick":

    set alibs = "$alibs $l/srcconrcqck.a $l/srcconraq.a $l/srcdashline.a"
    set blibs = "$l/srcdashline.a $l/srcconraq.a $l/srcconrcqck.a $blibs"
    breaksw

  case "-smooth":

    set alibs = "$alibs $l/srcdashsmth.a"
    set blibs = "$l/srcdashsmth.a $blibs"
    breaksw

  case "-super":

    set alibs = "$alibs $l/srcconrcspr.a $l/srcconras.a $l/srcdashsupr.a"
    set blibs = "$l/srcdashsupr.a $l/srcconras.a $l/srcconrcspr.a $blibs"
    breaksw

  case "-conrecquick":

    set alibs = "$alibs $l/srcconrcqck.a"
    set blibs = "$l/srcconrcqck.a $blibs"
    breaksw

  case "-conrecsmooth":

    set alibs = "$alibs $l/srcdashsmth.a"
    set blibs = "$l/srcdashsmth.a $blibs"
    breaksw

  case "-conrecsuper":

    set alibs = "$alibs $l/srcconrcspr.a $l/srcdashsupr.a"
    set blibs = "$l/srcdashsupr.a $l/srcconrcspr.a $blibs"
    breaksw

  case "-conranquick":

    set alibs = "$alibs $l/srcconraq.a"
    set blibs = "$l/srcconraq.a $blibs"
    breaksw

  case "-conransmooth":

    set alibs = "$alibs $l/srcdashsmth.a"
    set blibs = "$l/srcdashsmth.a $blibs"
    breaksw

  case "-conransuper":

    set alibs = "$alibs $l/srcconras.a $l/srcdashsupr.a"
    set blibs = "$l/srcdashsupr.a $l/srcconras.a $blibs"
    breaksw

  case "-dashline":
  case "-dashquick":

    set alibs = "$alibs $l/srcdashline.a"
    set blibs = "$l/srcdashline.a $blibs"
    breaksw

  case "-dashsmooth":

    set alibs = "$alibs $l/srcdashsmth.a"
    set blibs = "$l/srcdashsmth.a $blibs"
    breaksw

  case "-dashsuper":

    set alibs = "$alibs $l/srcdashsupr.a"
    set blibs = "$l/srcdashsupr.a $blibs"
    breaksw

  case "-index":

    set index
    breaksw

  case "-*":

    echo "Unknown option <$arg>."
    exit 1

  default:

    set arg = `echo $arg | tr '[A-Z]' '[a-z]'`

    unset fileinormalibrary

    set errorflag = "notfoundyet"

    foreach lib ($alibs)
      set errorflag = `ar x $lib $arg |& cat`
      if (".$errorflag" == ".") then
	break
      endif
    end

    if (".$errorflag" != ".") then
      foreach lib ($nlibs)
	set errorflag = `ar x $lib $arg |& cat`
	if (".$errorflag" == ".") then
	  set fileinormalibrary
	  break
	endif
      end
    endif

    if (".$errorflag" != ".") then
      set clibs = ""
      foreach lib ($l/srcagupwrtx.a $l/srcconraq.a   $l/srcconras.a \
		   $l/srcconrcqck.a $l/srcconrcspr.a $l/srcdashline.a \
		   $l/srcdashsmth.a $l/srcdashsupr.a)
	unset found
	foreach alib ($alibs)
	  if ("$lib" == "$alib") then
	    set found
	    break
	  endif
	end
	if (! $?found) set clibs = "$clibs $lib"
      end
      foreach lib ($clibs)
	set errorflag = `ar x $lib $arg |& cat`
	if (".$errorflag" == ".") then
	  break
	endif
      end
    endif

    if (".$errorflag" == ".") then
      chmod 644 $arg
      if ("$arg:r" == "$arg") then
	if ($?index) then
	  mv $arg $arg.index
	else
	  set filelist = `cat $arg`
	  ar x $lib $filelist
	  if ($?fileinormalibrary) then
	    foreach lib ($blibs)
	      set bfiles = `ar t $lib`
	      set gfiles = ""
	      foreach file ($bfiles)
		if ("$file:r" != "$file") then
		  set gfiles = "$gfiles $file"
		  if (! -e $file) then
		    set filelist = "$filelist $file"
		  endif
		endif
	      end
	      ar x $lib $gfiles
	    end
	  endif
	  cat $filelist >! $arg
	  rm -f $filelist
	endif
      endif
    else
      echo "Cannot find file <$arg>."
    endif
    breaksw

  endsw

end

exit 0

# sh script to switch between versions of NCL
#
# To use: . /contrib/bin/testncl.sh
# To switch back to original version: . /contrib/bin/origncl.sh

export NCARG_ROOT=/contrib/ncl-5.1.1-beta
export PATH=$NCARG_ROOT/bin:$PATH

version=`ncl -V`
echo "You are now using the test version of NCL: $version"

C
C	$Id: trassn.f.sed,v 1.2 2008-07-27 00:59:05 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE TRASSN(IOS,STATUS)
C
C  THIS ROUTINE ASSIGNS THE PROPER TRANSLATOR BASED ON THE DATA TYPE
C  FIELD FOUND IN THE CURRENT METAFILE RECORD.
C
C  OUTPUT
C     IOS    --  The I/O status which is valid only if STATUS
C                is set to an I/O error.
C     STATUS --  The error status defined in COMMON TREROR.
C
      COMMON /TRTYPE/ METMIN, METEXT, METPRT, METHED, MIOPCL, MXOPCL,
     1                MIOPID, MXOPID, ASCDEC, ASCHEX, ASCOCT, BINARY,
     2                GAHNOR, GALEFT, GACENT, GARITE, GAVNOR, GATOP ,
     3                GACAP , GAHALF, GABASE, GABOTT, GRIGHT, GLEFT ,
     4                GUP   ,
     5                GDOWN , CINDEX, CDIRCT, PENUP , PENDN , FLAGVL,
     6                SEPRVL, ASCTEK, TYPRGB, TYPBGR,
     7                TYPHLS, TYPMON, SOLID , DASHED, INVSBL, SOLPAT,
     8                ASFIND, ASFBND, ASFLNT, ASFLNW, ASFLNC, ASFMRT,
     9                ASFMRS, ASFMRC, ASFFIS, ASFFHI, ASFFPI, ASFFCO,
     A                ASFFPT, ASFFPW, ASFFPC, ASFTFI, ASFTPR, ASFTCX,
     B                ASFTCS, ASFTCO, ASCFLT, PHOLLO, PSOLID, PPATTR,
     C                PHATCH, PEMPTY, HHORIZ, HVERTI, HPOSLP, HNESLP,
     D                HHOAVE, HPOANE
      INTEGER         METMIN, METEXT, METPRT, METHED, MIOPCL, MXOPCL,
     1                MIOPID, MXOPID, ASCDEC, ASCHEX, ASCOCT, BINARY,
     2                GAHNOR, GALEFT, GACENT, GARITE, GAVNOR, GATOP ,
     3                GACAP , GAHALF, GABASE, GABOTT, GRIGHT, GLEFT ,
     4                GUP   ,
     5                GDOWN , CINDEX, CDIRCT, PENUP , PENDN , FLAGVL,
     6                SEPRVL, ASCTEK, TYPRGB, TYPBGR,
     7                TYPHLS, TYPMON, SOLID , DASHED, INVSBL, SOLPAT,
     8                ASFIND, ASFBND, ASFLNT, ASFLNW, ASFLNC, ASFMRT,
     9                ASFMRS, ASFMRC, ASFFIS, ASFFHI, ASFFPI, ASFFCO,
     A                ASFFPT, ASFFPW, ASFFPC, ASFTFI, ASFTPR, ASFTCX,
     B                ASFTCS, ASFTCO, ASCFLT, PHOLLO, PSOLID, PPATTR,
     C                PHATCH, PEMPTY, HHORIZ, HVERTI, HPOSLP, HNESLP,
     D                HHOAVE, HPOANE
      COMMON /PTRBUFR/ METBIT, MBUFER, MDTYPE, METREC, MRECLN,
     1                MCONTF, MOPRST, LNGFLG, MERGFL
      INTEGER MNWRDS, RECLOC, RECSIZ, DTLOC, DTSIZ, MBITST, MBUFOF,
     1        MINSBD, MERLOC, MERSIZ
#if defined(cray)
      PARAMETER (MNWRDS=180, RECLOC=0, RECSIZ=16, DTLOC=16, DTSIZ=4
#else
      PARAMETER (MNWRDS=360, RECLOC=0, RECSIZ=16, DTLOC=16, DTSIZ=4
#endif
     1          ,MBITST=32, MBUFOF=32, MINSBD=16, MERLOC=23, MERSIZ=1)
      INTEGER METBIT, MBUFER(MNWRDS), MDTYPE, METREC, MRECLN, MOPRST
      LOGICAL MCONTF, LNGFLG, MERGFL
      COMMON/TREROR/ ALLOK, MFRCHK, MTOPER, METRDC, REDERR, TYPCHG
     1             ,INVTYP, MINVLD, TYPERR, FRMEND, ENCINT, IVDCDT
     2             ,GCOERR, GCRERR, GCCERR, FCOERR, FCRERR, FCCERR
     3             ,PLIDXG, PMIDXG, TXIDXG, PGIDXG, INVLMT, CELERR
     4             ,COIERR, COLNRM, UNKNOW, UNKOPC, ENDMTF, VNEROR
     5             ,BADRSZ, DEVOUT, NOVERS, BADFNT, PGMERR, FASERR
     6             ,HINERR, VDWERR, RDWERR, RIXLIM
      INTEGER        ALLOK, MFRCHK, MTOPER, METRDC, REDERR, TYPCHG
     1             ,INVTYP, MINVLD, TYPERR, FRMEND, ENCINT, IVDCDT
     2             ,GCOERR, GCRERR, GCCERR, FCOERR, FCRERR, FCCERR
     3             ,PLIDXG, PMIDXG, TXIDXG, PGIDXG, INVLMT, CELERR
     4             ,COIERR, COLNRM, UNKNOW, UNKOPC, ENDMTF, VNEROR
     5             ,BADRSZ, DEVOUT, NOVERS, BADFNT, PGMERR, FASERR
     6             ,HINERR, VDWERR, RDWERR, RIXLIM
      COMMON/TRINOT/ IPTR, MBUFOT, MAXBYT, DEVUNT, METUNT,
     1          METIPT, ERRUNT, FNTUNT
      INTEGER MAXCNT
      PARAMETER (MAXCNT=200)
      INTEGER IPTR, MBUFOT(MAXCNT), MAXBYT, DEVUNT, METUNT, ERRUNT,
     1        FNTUNT
      LOGICAL METIPT
C
      INTEGER IOS, STATUS
C
C  SET THE DEFAULT OPERAND LENGTHS BEFORE READING ANY INSTRUCTIONS
C
      CALL XMOPDF
C
C  BRANCH TO THE PROPER TRANSLATOR
C
 10   CONTINUE
      STATUS = 0
      IF (MDTYPE .EQ. METEXT) THEN
C
C       THE EXTENDED METACODE TRANSLATOR
C
        STATUS = TYPCHG
      ELSE IF (MDTYPE .EQ. METMIN) THEN
C
C       THE MINIMAL METACODE TRANSLATOR
C
        CALL TRLATE(IOS,STATUS)
      ELSE IF ((MDTYPE.EQ.METPRT) .OR. (MDTYPE.EQ.METHED)) THEN
C
C       THE PRINTER TRANSLATOR
C       GET ANOTHER RECORD
C
        CALL METRED(IOS,STATUS)
        IF (STATUS .EQ. ALLOK) STATUS = TYPCHG
      ELSE
C
C       NOT MINIMAL METACODE
C
C       GET ANOTHER RECORD
C
        CALL METRED(IOS,STATUS)
        IF (STATUS.EQ.ALLOK) STATUS = TYPCHG
      END IF
C
C  CHECK IF STATUS REQUESTING A NEW TRANSLATOR
C
      IF (STATUS .EQ. TYPCHG) GO TO 10
C
      RETURN
      END

C
C	$Id: fndarg.f.sed,v 1.2 2008-07-27 00:59:04 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE FNDARG(IOS,STATUS)
C
C  OUTPUT
C       IOS-SYSTEM DEPENDENT IO STATUS FLAG USEFUL IF STATUS
C               SET TO OPNERR
C       STATUS-STATUS FLAG
C               ALLOK-ALL WENT OK
C               NE ALLOK SOME ERROR EXISTS DEFINED BY COMMON TREROR
C
      COMMON /TRFRAM/ METALL, FRINIT, FRCNT
      LOGICAL METALL, FRINIT
      INTEGER  FRCNT
      COMMON/TREROR/ ALLOK, MFRCHK, MTOPER, METRDC, REDERR, TYPCHG
     1             ,INVTYP, MINVLD, TYPERR, FRMEND, ENCINT, IVDCDT
     2             ,GCOERR, GCRERR, GCCERR, FCOERR, FCRERR, FCCERR
     3             ,PLIDXG, PMIDXG, TXIDXG, PGIDXG, INVLMT, CELERR
     4             ,COIERR, COLNRM, UNKNOW, UNKOPC, ENDMTF, VNEROR
     5             ,BADRSZ, DEVOUT, NOVERS, BADFNT, PGMERR, FASERR
     6             ,HINERR, VDWERR, RDWERR, RIXLIM
      INTEGER        ALLOK, MFRCHK, MTOPER, METRDC, REDERR, TYPCHG
     1             ,INVTYP, MINVLD, TYPERR, FRMEND, ENCINT, IVDCDT
     2             ,GCOERR, GCRERR, GCCERR, FCOERR, FCRERR, FCCERR
     3             ,PLIDXG, PMIDXG, TXIDXG, PGIDXG, INVLMT, CELERR
     4             ,COIERR, COLNRM, UNKNOW, UNKOPC, ENDMTF, VNEROR
     5             ,BADRSZ, DEVOUT, NOVERS, BADFNT, PGMERR, FASERR
     6             ,HINERR, VDWERR, RDWERR, RIXLIM
      COMMON/TRINOT/ IPTR, MBUFOT, MAXBYT, DEVUNT, METUNT,
     1          METIPT, ERRUNT, FNTUNT
      INTEGER MAXCNT
      PARAMETER (MAXCNT=200)
      INTEGER IPTR, MBUFOT(MAXCNT), MAXBYT, DEVUNT, METUNT, ERRUNT,
     1        FNTUNT
      LOGICAL METIPT
      COMMON /PTRBUFR/ METBIT, MBUFER, MDTYPE, METREC, MRECLN,
     1                MCONTF, MOPRST, LNGFLG, MERGFL
      INTEGER MNWRDS, RECLOC, RECSIZ, DTLOC, DTSIZ, MBITST, MBUFOF,
     1        MINSBD, MERLOC, MERSIZ
#if defined(cray)
      PARAMETER (MNWRDS=180, RECLOC=0, RECSIZ=16, DTLOC=16, DTSIZ=4
#else
      PARAMETER (MNWRDS=360, RECLOC=0, RECSIZ=16, DTLOC=16, DTSIZ=4
#endif
     1          ,MBITST=32, MBUFOF=32, MINSBD=16, MERLOC=23, MERSIZ=1)
      INTEGER METBIT, MBUFER(MNWRDS), MDTYPE, METREC, MRECLN, MOPRST
      LOGICAL MCONTF, LNGFLG, MERGFL
      COMMON /TRCNTL/ INPICT, INMETA, RECINT
      LOGICAL INPICT, INMETA
      INTEGER RECINT
      COMMON /PGKSCOM/ CLPDAT, CLPFLG, POLIDX, LINTYP, LINWTH, LINCOL,
     1                LINRGB, MARIDX, MARSIZ, MARCOL, MARRGB, TXTIDX,
     2                INTSTL, PATIDX, FILCOL, FILRGB, MARTYP, HORIZ ,
     3                VERT  , PATH  , CHIGHT, XU    , YU    , XB    ,
     4                YB    , TXTCOL, FINDEX, CEXPN , CSPACE, CURIDX,
     5                CURIMP, CURINT, COLMOD, FILIDX, TXTRGB, PROPN ,
     6                FIRSTX, FIRSTY, LASTX , LASTY , TRATIO, CBV   ,
     7                CUV   , CHP   , CVP   , CCSPAC, CHHORZ, CDV   ,
     8                PMRSIZ, CLPX  , CLPY  , CLPP  , DEFREP, DEFLEN,
     9                VDCECR, TRANVN, TXTPRE, HATIDX, FILRPT, ASFSRF,
     A                ASFSDF, MAPMOD, VERSOK, PCBFST, CPGLEN, CLPNUL,
     B                MTDLEN
      INTEGER         CMPMAX, ASFMAX
      PARAMETER      (CMPMAX=256    , ASFMAX=18)
      LOGICAL         CLPFLG, PROPN , CHHORZ, DEFREP, CLPNUL, MAPMOD,
     1                VERSOK, PCBFST
      REAL            LINWTH, MARSIZ, CEXPN , CSPACE, TRATIO, CBV(2),
     1                CUV(2), CDV(2), CCSPAC
      INTEGER         CLPDAT(4)     , POLIDX, LINTYP, LINCOL, LINRGB(3),
     1                MARIDX, MARCOL, MARRGB(3)     , TXTIDX, INTSTL,
     2                PATIDX, FILCOL, FILRGB(3)     , MARTYP, HORIZ ,
     3                VERT  , PATH  , XU    , YU    , XB    , YB    ,
     4                TXTCOL, FINDEX, CURIMP(CMPMAX), CURINT(CMPMAX*3),
     5                CHIGHT, COLMOD, FILIDX, TXTRGB(3)     , CURIDX,
     6                FIRSTX, FIRSTY, LASTX , LASTY , CHP   , CVP   ,
     7                PMRSIZ, CLPX  , CLPY  , CLPP  , DEFLEN, TRANVN,
     8                TXTPRE, HATIDX, FILRPT(2)     , VDCECR(4)     ,
     9                ASFSRF(ASFMAX), ASFSDF(ASFMAX), CPGLEN, MTDLEN
      COMMON /GKSCHR/ MTDESC
      CHARACTER*80    MTDESC
C
      INTEGER IOS, STATUS
C
C  SET THE STATUS FLAG TO OK
C
      STATUS = ALLOK
C
C  SET FLAGS TO PLOT ALL FRAMES
C
      METALL = .TRUE.
      METREC = 1
      RETURN
C
      END

/*
 *      $Id: MathTemplate.h.sed,v 1.1 1995-01-31 22:25:56 ethan Exp $
 */
/************************************************************************
*									*
*			     Copyright (C)  1995			*
*	     University Corporation for Atmospheric Research		*
*			     All Rights Reserved			*
*									*
************************************************************************/
/*
 *	File:		
 *
 *	Author:		Ethan Alpert
 *			National Center for Atmospheric Research
 *			PO 3000, Boulder, Colorado
 *
 *	Date:		Tue Jan 31 15:17:01 MST 1995
 *
 *	Description:	
 */
extern NhlErrorTypes _NclFUNCNAME(
#if     NhlNeedProto
void
#endif
);

#!/bin/sh

sh op_funcs.sh ushort NhlTUshort NhlTUshortGenArray 65535U > .tmp.$$

if [ ! $? ]
then
	exit $?
fi

sed \
-e 's/PRINTFORMAT/\%d\\n/' \
-e 's/DATATYPE/ushort/g' \
-e 's/LOCALTYPE/unsigned short/g' \
-e 's/HLUTYPEREP/NhlTUshort/g' \
-e 's/HLUGENTYPEREP/NhlTUshortGenArray/g' \
-e 's/DEFAULT_MISS/65535U/g' \
-e 's/DEFAULT_FORMAT/%hu/g' \
-e "/REPLACE/r .tmp.$$" \
-e '/REPLACE/d' \
-e '/DSPECIFIC/r NclTypeushort.c.specific' \
-e '/DSPECIFIC/d' \
NclType.c.sed > NclTypeushort.c

rm .tmp.$$

echo "created NclTypeushort.c"

exit 0

/*
 *      $Id$
 */
/************************************************************************
*									*
*			     Copyright (C)  1993			*
*	     University Corporation for Atmospheric Research		*
*			     All Rights Reserved			*
*									*
************************************************************************/
/*
 *	File:		
 *
 *	Author:		Ethan Alpert
 *			National Center for Atmospheric Research
 *			PO 3000, Boulder, Colorado
 *
 *	Date:		Fri Oct 29 11:36:10 MDT 1993
 *
 *	Description:	
 */

#include <stdio.h>
#ifdef NIO_LIB_ONLY
#include "niohluP.h"
#include "nioConvert.h"
#include "nioNresDB.h"
#else
#include <ncarg/hlu/hluP.h>
#include <ncarg/hlu/Convert.h>
#include <ncarg/hlu/NresDB.h>
#endif
#include "defs.h"
#include "Symbol.h"
#include <errno.h>
#include <math.h>
#include "NclTypeint.h"
#include "NclTypelogical.h"
#include "NclTypestring.h"
#include "NclMultiDValData.h"


static NhlErrorTypes CvtNhlTStringGenArrayToNclData
#if	NhlNeedProto
(NrmValue *from, NrmValue *to, NhlConvertArgList args, int nargs)
#else
(from, to, args, nargs)
NrmValue *from;
NrmValue *to;
NhlConvertArgList args;
int nargs;
#endif
{
        NhlGenArray gen;
        char func[] = "CvtNhlTStringGenArrayToNclData";
        NclQuark *val;
        NclMultiDValData tmp_md;
        ng_size_t len_dimensions = 1;
	char **strar;
	int i;
 
 
        if(nargs != 0) {
                NhlPError(NhlFATAL,NhlEUNKNOWN,"%s: called with wrong number of args",func);
                to->size =0;
                return(NhlFATAL);
        }
        gen = (NhlGenArray)from->data.ptrval;
        if(gen != NULL) {
                if(!_NhlIsSubtypeQ(NrmStringToQuark(NhlTStringGenArray),from->typeQ)) {
                        NhlPError(NhlFATAL,NhlEUNKNOWN,"%s: called with wrong input type",func);
                        to->size =0;
                        return(NhlFATAL);
                }
		val = NclMalloc(sizeof(NclQuark)* gen->num_elements);
	        strar = (char**)gen->data;
        	for(i = 0; i < gen->num_elements; i++) {
                	val[i] = NrmStringToQuark(strar[i]);
        	}

                tmp_md = _NclCreateMultiDVal(
                        NULL,NULL, Ncl_MultiDValData,
                        0,val,NULL,gen->num_dimensions,
                        gen->len_dimensions,TEMPORARY,NULL,(NclTypeClass)nclTypestringClass);
                if(to->size < sizeof(NclMultiDValData)) {
                        return(NhlFATAL);
                } else {
                        *((NclMultiDValData*)(to->data.ptrval)) = (void*)tmp_md;
                        return(NhlNOERROR);
                }
        } else {
                val = NclMalloc((unsigned)nclTypestringClassRec.type_class.size);
                *(NclQuark *)(val) = nclTypestringClassRec.type_class.default_mis.stringval;
                tmp_md = _NclCreateMultiDVal(
                        NULL,NULL, Ncl_MultiDValData,
                        0,val,&nclTypestringClassRec.type_class.default_mis,1,
                        &len_dimensions,TEMPORARY,NULL,(NclTypeClass)nclTypestringClass);
                if(to->size < sizeof(NclMultiDValData)) {
                        return(NhlFATAL);
                } else {
                       *((NclMultiDValData*)(to->data.ptrval)) = (void*)tmp_md;
                       return(NhlNOERROR);
                }
        }
}

/*ARGSUSED*/
static NhlErrorTypes CvtNhlTStringToNclData
#if	NhlNeedProto
(NrmValue *from, NrmValue *to, NhlConvertArgList args, int nargs)
#else
(from, to, args, nargs)
NrmValue *from;
NrmValue *to;
NhlConvertArgList args;
int nargs;
#endif
{
	NclQuark *tmp;
	NclMultiDValData tmp_md;
	int n_dims = 1;
	ng_size_t len_dims = 1;

	tmp = NclMalloc((unsigned)sizeof(NclQuark));
	*tmp = NrmStringToQuark((char*)(from->data.ptrval));
	tmp_md = _NclCreateMultiDVal(
		NULL,NULL, Ncl_MultiDValData,
		0,(void*)tmp,NULL,n_dims,
		&len_dims,TEMPORARY,NULL,(NclTypeClass)nclTypestringClass);
	if(to->size < sizeof(NclMultiDValData)) {
		return(NhlFATAL);
	} else {
		*((NclMultiDValData*)(to->data.ptrval)) = (void*)tmp_md;
        	return(NhlNOERROR);
	}
}

static NhlErrorTypes Ncl_Type_string_InitClass
#if	NhlNeedProto
(void)
#else
()
#endif
{
        NhlRegisterConverter(NhlbaseClass,NhlTStringGenArray,NhlTNclData,
		CvtNhlTStringGenArrayToNclData,NULL,0,False,NULL);
        NhlRegisterConverter(NhlbaseClass,NhlTString,NhlTNclData,
		CvtNhlTStringToNclData,NULL,0,False,NULL);
	nclTypestringClassRec.type_class.default_mis.stringval = NrmStringToQuark("missing");
	return(NhlNOERROR);
}


/* 0 on match, non zero on non-match just like real strcmp */
/*
static int my_strcmp
#if	NhlNeedProto
(NclQuark s1,NclQuark s2)
#else 
(s1,s2)
NclQuark s1;
NclQuark s2;
#endif
{
	if((s1 < 1)&&(s2 < 1)) {
		return(0);
	} else if((s1 < 1)||(s2 < 1)) {
		return(1);
	} else {
		return(strcmp(NrmQuarkToString(s1),NrmQuarkToString(s2)));
	}
}
*/

static NclQuark combine_strings
#if	NhlNeedProto
(NclQuark ls,NclQuark rs,NclQuark mis_ls, NclQuark mis_rs,NclQuark mis)
#else
(ls,rs,mis_ls,mis_rs,mis)
NclQuark ls;
NclQuark rs;
NclQuark mis_ls;
NclQuark mis_rs;
NclQuark mis;
#endif
{
	char *tmp;
	char * ls_ptr;
	char * rs_ptr;
	NclQuark ret_val;

#if 0
	if(mis_ls == ls) {
		return(mis);
	} else if(mis_rs == rs) {
		return(mis);
	}
#endif
	if (mis_ls == ls && mis_rs == rs) {
		return (mis);
	}
	else {
		ls_ptr = NrmQuarkToString(ls);
		rs_ptr = NrmQuarkToString(rs);
		tmp = (char*)NclMalloc(strlen(ls_ptr)+strlen(rs_ptr)+1);
		strcpy(tmp,ls_ptr);
		strcat(tmp,rs_ptr);
		ret_val = NrmStringToQuark(tmp);
		NclFree(tmp);
		return(ret_val);
	}
}

static NclQuark select_string_lt
#if	NhlNeedProto
(NclQuark ls,NclQuark rs,NclQuark mis_ls, NclQuark mis_rs,NclQuark mis)
#else
(ls,rs,mis_ls,mis_rs,mis)
NclQuark ls;
NclQuark rs;
NclQuark mis_ls;
NclQuark mis_rs;
NclQuark mis;
#endif
{
	int len;
	int i;
	char *lptr;
	char *rptr;
	char *save_l;
	char *save_r;

	if(ls == mis_ls) {
		return(mis);
	} else if(rs == mis_rs) {
		return(mis);
	}


		
	save_l = lptr = NrmQuarkToString(ls);
	save_r = rptr = NrmQuarkToString(rs);
	len = MIN(strlen(lptr),strlen(rptr));	

	for(i = 0; i<len; i++) {
		if((int)(*lptr) < (int)(*rptr)) {
			return(ls);
		} else if((int)(*lptr) > (int)(*rptr)){
			return(rs);
		}
		lptr++;
		rptr++;
	}
	if(strlen(save_l) < strlen(save_r)) {
		return(ls);
	} else {
		return(rs);
	}
}
static NclQuark select_string_gt
#if	NhlNeedProto
(NclQuark ls,NclQuark rs,NclQuark mis_ls, NclQuark mis_rs,NclQuark mis)
#else
(ls,rs,mis_ls,mis_rs,mis)
NclQuark ls;
NclQuark rs;
NclQuark mis_ls;
NclQuark mis_rs;
NclQuark mis;
#endif
{
	int len;
	int i;
	char *lptr;
	char *rptr;
	char *save_l;
	char *save_r;
	
	if(ls == mis_ls) {
		return(mis);
	} else if(rs == mis_rs) {
		return(mis);
	}

	save_l = lptr = NrmQuarkToString(ls);
	save_r = rptr = NrmQuarkToString(rs);
	len = MIN(strlen(lptr),strlen(rptr));	

	for(i = 0; i<len; i++) {
		if((int)(*lptr) > (int)(*rptr)) {
			return(ls);
		} else if((int)(*lptr) < (int)(*rptr)){
			return(rs);
		}
		lptr++;
		rptr++;
	}
	if(strlen(save_l) > strlen(save_r)) {
		return(ls);
	} else {
		return(rs);
	}
}
static int cmp_string_lt
#if	NhlNeedProto
(NclQuark ls,NclQuark rs)
#else
(ls,rs)
NclQuark ls;
NclQuark rs;
#endif
{
	int len;
	int i;
	char *lptr;
	char *rptr;
	char *save_l;
	char *save_r;
	
	if(rs <1 ) {
		return(0);
	} else if(ls <1) {
		return(1);
	}
	
	save_l = lptr = NrmQuarkToString(ls);
	save_r = rptr = NrmQuarkToString(rs);
	len = MIN(strlen(lptr),strlen(rptr));	

	for(i = 0; i<len; i++) {
		if((int)(*lptr) < (int)(*rptr)) {
			return(1);
		} else if((int)(*lptr) > (int)(*rptr)) {
			return(0);
		}
		lptr++;	
		rptr++;
	}
	if(strlen(save_l) < strlen(save_r)) {
		return(1);
	} else {
		return(0);
	}
}

static int cmp_string_gt
#if	NhlNeedProto
(NclQuark ls,NclQuark rs)
#else
(ls,rs)
NclQuark ls;
NclQuark rs;
#endif
{
	int len;
	int i;
	char *lptr;
	char *rptr;
	char *save_l;
	char *save_r;

	if(ls <1) {
		return(0);
	} else if(rs <1) {
		return(1);
	}
	
	save_l = lptr = NrmQuarkToString(ls);
	save_r = rptr = NrmQuarkToString(rs);
	len = MIN(strlen(lptr),strlen(rptr));	

	for(i = 0; i<len; i++) {
		if((int)(*lptr) > (int)(*rptr)) {
			return(1);
		} else if((int)(*lptr) < (int)(*rptr)) {
			return(0);
		}
		lptr++;	
		rptr++;
	}
	if(strlen(save_l) > strlen(save_r)) {
		return(1);
	} else {
		return(0);
	}
}

static int cmp_string_le
#if	NhlNeedProto
(NclQuark ls,NclQuark rs)
#else
(ls,rs)
NclQuark ls;
NclQuark rs;
#endif
{
	int len;
	int i;
	char *lptr;
	char *rptr;
	char *save_l;
	char *save_r;

	if(ls <1) {
		return(1);
	} else if(rs <1) {
		return(0);
	}
	
	save_l = lptr = NrmQuarkToString(ls);
	save_r = rptr = NrmQuarkToString(rs);
	len = MIN(strlen(lptr),strlen(rptr));	

	for(i = 0; i<len; i++) {
		if((int)(*lptr) < (int)(*rptr)) {
			return(1);
		} else if((int)(*lptr) > (int)(*rptr)) {
			return(0);
		}
		lptr++;	
		rptr++;
	}
	if(strlen(save_l) <= strlen(save_r)) {
		return(1);
	} else {
		return(0);
	}
}
static int cmp_string_ge
#if	NhlNeedProto
(NclQuark ls,NclQuark rs)
#else
(ls,rs)
NclQuark ls;
NclQuark rs;
#endif
{
	int len;
	int i;
	char *lptr;
	char *rptr;
	char *save_l;
	char *save_r;

	if(rs <1) {
		return(1);
	} else if(ls <1) {
		return(0);
	}

	save_l = lptr = NrmQuarkToString(ls);
	save_r = rptr = NrmQuarkToString(rs);
	len = MIN(strlen(lptr),strlen(rptr));	

	for(i = 0; i<len; i++) {
		if((int)(*lptr) > (int)(*rptr)) {
			return(1);
		} else if((int)(*lptr) < (int)(*rptr)) {
			return(0);
		}
		lptr++;	
		rptr++;
	}
	if(strlen(save_l) >= strlen(save_r)) {
		return(1);
	} else {
		return(0);
	}
}

static NclMonoTypes Ncl_Type_string_is_mono
#if	NhlNeedProto
(void *val,NclScalar* val_m,ng_size_t nval)
#else
(val, val_m, nval)
void *val;
NclScalar* val_m;
ng_size_t nval;
#endif
{
	NclQuark *value = (NclQuark*)val;
	ng_size_t i = 0,j = 1;

	if(nval == 1) 
		return(1);
	if(val_m != NULL) {
		i = 0;
		j = 0;
		while((i<nval)&&(value[i] == val_m->stringval))i++;
		if(i >= nval-1) return(NclNONMONO);
		j = i + 1;
		while((j<nval)&&(value[j] == val_m->stringval)) j++;
		if(j == nval) return(NclNONMONO);
/*
* i is first non-missing value and j is second guarenteed
*/
		if(cmp_string_gt(value[i],value[j])) {
			while(cmp_string_gt(value[i],value[j])) {
				i = j;
				j++;
				while((j<nval)&&(value[j] == val_m->stringval)) {
					j++;
				}
				if(j >= nval)
					break;
			}
			if(j >= nval) {
				return(NclDECREASING);
			} else {
				return(NclNONMONO);
			}
		} else if(cmp_string_lt(value[i], value[j])) {
			while(cmp_string_lt(value[i],value[j])) {
				i = j;
				j++;
				while((j<nval)&&(value[j] == val_m->stringval)) {
					j++;
				}
				if(j >= nval)
					break;
			}
			if(j >= nval) {
				return(NclINCREASING);
			} else {
				return(NclNONMONO);
			}
		}
	} else {
		i = 0;
		if(cmp_string_gt(value[0], value[1])) {
			while((i<nval-1)&&(cmp_string_gt(value[i],value[i+1]))) i++;
			if(i == nval-1) {
				return(NclDECREASING);
			} else {
				return(NclNONMONO);
			}
		} else if(cmp_string_lt(value[0],value[1])) {
			while((i<nval-1)&&(cmp_string_lt(value[i],value[i+1]))) i++;
			if(i == nval-1) {
				return(NclINCREASING);
			} else {
				return(NclNONMONO);
			}
		} 
	}
	return(NclNONMONO);
}

static NhlErrorTypes Ncl_Type_string_cmpf
#if NhlNeedProto
(void *lhs, void* rhs, NclScalar* lhs_m, NclScalar *rhs_m,int digits, double* result)
#else
(lhs, rhs, lhs_m, rhs_m, digits, result)
void *lhs;
void* rhs;
NclScalar* lhs_m;
NclScalar *rhs_m;
int digits;
double * result;
#endif
{
        if((lhs_m != NULL)&&(lhs_m->intval == *(int*)lhs)) {
                return(NhlFATAL);
        } else if((rhs_m != NULL)&&(rhs_m->intval == *(int*)rhs)) {
                return(NhlFATAL);
        } else {
		if(cmp_string_gt(*(NclQuark*)lhs,*(NclQuark*)rhs)) {
			*result = 1;
		} else if(cmp_string_lt(*(NclQuark*)lhs,*(NclQuark*)rhs)) {
			*result = -1;
		} else {
			*result = 0;
		}
                return(NhlNOERROR);
        }
}



INSERTTMPSTRING


NhlErrorTypes Ncl_Type_string_plus
#if	NhlNeedProto
(void *result,void *lhs, void* rhs, NclScalar* lhs_m, NclScalar* rhs_m, ng_size_t nlhs, ng_size_t nrhs)
#else
(result,lhs,rhs,lhs_m,rhs_m,nlhs,nrhs)
void *result;
void *lhs;
void* rhs;
NclScalar* lhs_m;
NclScalar* rhs_m;
ng_size_t nlhs;
ng_size_t nrhs;
#endif
{
        NclQuark *ls,*rs;
	NclQuark *res;
	ng_size_t stopi = 1;
	ng_size_t linc = 0;
	ng_size_t rinc = 0;
	ng_size_t i;

	ls = (NclQuark*)lhs;
	rs = (NclQuark*)rhs;
	res = (NclQuark*)result;

	if(nlhs > nrhs) 
		stopi = nlhs;
	else
		stopi = nrhs;
	if(nlhs > 1) {
		linc = 1;
	}
	if(nrhs > 1) {
		rinc = 1;
	}
	

	if((lhs_m == NULL)&&(rhs_m == NULL)) {
		for(i = 0; i < stopi; i++, res++, ls += linc, rs += rinc) {
			*res = combine_strings(*ls,*rs,-1,-1,-1);
		}
	} else if(rhs_m == NULL) {
		for(i = 0 ; i < stopi; i++, res++, ls += linc, rs += rinc) {
			*res = combine_strings(*ls,*rs, lhs_m->stringval, -1,lhs_m->stringval);
		}
	} else if(lhs_m == NULL ) {
		for(i = 0 ; i < stopi; i++, res++, ls += linc, rs += rinc) {
			*res = combine_strings(*ls,*rs,-1, rhs_m->stringval, rhs_m->stringval);
		}
	} else {
		for(i = 0 ; i < stopi; i++, res++, ls += linc, rs += rinc) {
			*res = combine_strings(*ls,*rs, lhs_m->stringval, rhs_m->stringval, lhs_m->stringval);
		}
	}
	return(NhlNOERROR);
}

NclTypeClass Ncl_Type_string_plus_type
#if	NhlNeedProto
(void)
#else
()
#endif
{
	return((NclTypeClass)nclTypestringClass);
}

NhlErrorTypes Ncl_Type_string_eq
#if	NhlNeedProto
(void *result,void *lhs, void* rhs, NclScalar* lhs_m, NclScalar* rhs_m, ng_size_t nlhs, ng_size_t nrhs)
#else
(result,lhs,rhs,lhs_m,rhs_m,nlhs,nrhs)
void *result;
void *lhs;
void* rhs;
NclScalar* lhs_m;
NclScalar* rhs_m;
ng_size_t nlhs;
ng_size_t nrhs;
#endif
{
        NclQuark *ls,*rs;
	logical *res;
	ng_size_t stopi = 1;
	ng_size_t linc = 0;
	ng_size_t rinc = 0;
	ng_size_t i;

	ls = (NclQuark*)lhs;
	rs = (NclQuark*)rhs;
	res = (logical*)result;

	if(nlhs > nrhs) 
		stopi = nlhs;
	else
		stopi = nrhs;
	if(nlhs > 1) {
		linc = 1;
	}
	if(nrhs > 1) {
		rinc = 1;
	}
	

	if((lhs_m == NULL)&&(rhs_m == NULL)) {
		for(i = 0 ; i < stopi; i++, res++, ls += linc, rs += rinc) {
			*res = *ls == *rs;
		}
	} else if(rhs_m == NULL) {
		for(i = 0 ; i < stopi; i++, res++, ls += linc, rs += rinc) {
			*res = (logical)((lhs_m->stringval == *ls) ? ((logical)((NclTypeClass)nclTypelogicalClass)->type_class.default_mis.logicalval) : *ls == *rs);
		}
	} else if(lhs_m == NULL ) {
		for(i = 0 ; i < stopi; i++, res++, ls += linc, rs += rinc) {
			*res = (logical)((rhs_m->stringval == *rs) ? ( (logical)((logical)((NclTypeClass)nclTypelogicalClass)->type_class.default_mis.logicalval)) : *ls == *rs);
		}
	} else {
		for(i = 0 ; i < stopi; i++, res++, ls += linc, rs += rinc) {
			*res = (logical)(((lhs_m->stringval == *ls)||( rhs_m->stringval==*rs)) ? ((logical)((logical)((NclTypeClass)nclTypelogicalClass)->type_class.default_mis.logicalval)) : *ls == *rs);
		}
	}
	return(NhlNOERROR);
}

NclTypeClass Ncl_Type_string_eq_type
#if	NhlNeedProto
(void)
#else
()
#endif
{
	return((NclTypeClass)nclTypelogicalClass);
}
NhlErrorTypes Ncl_Type_string_ne
#if	NhlNeedProto
(void *result,void *lhs, void* rhs, NclScalar* lhs_m, NclScalar* rhs_m, ng_size_t nlhs, ng_size_t nrhs)
#else
(result,lhs,rhs,lhs_m,rhs_m,nlhs,nrhs)
void *result;
void *lhs;
void* rhs;
NclScalar* lhs_m;
NclScalar* rhs_m;
ng_size_t nlhs;
ng_size_t nrhs;
#endif
{
        NclQuark *ls,*rs;
	logical *res;
	ng_size_t stopi = 1;
	ng_size_t linc = 0;
	ng_size_t rinc = 0;
	ng_size_t i;

	ls = (NclQuark*)lhs;
	rs = (NclQuark*)rhs;
	res = (logical*)result;

	if(nlhs > nrhs) 
		stopi = nlhs;
	else
		stopi = nrhs;
	if(nlhs > 1) {
		linc = 1;
	}
	if(nrhs > 1) {
		rinc = 1;
	}


	if((lhs_m == NULL)&&(rhs_m == NULL)) {
		for(i = 0 ; i < stopi; i++, res++, ls += linc, rs += rinc) {
			*res = !((*ls==*rs));
		}
	} else if(rhs_m == NULL) {
		for(i = 0 ; i < stopi; i++, res++, ls += linc, rs += rinc) {
			*res = (logical)(( lhs_m->stringval == *ls) ? ( (logical)((logical)((NclTypeClass)nclTypelogicalClass)->type_class.default_mis.logicalval)) : !((*ls==*rs)));
		}
	} else if(lhs_m == NULL ) {
		for(i = 0 ; i < stopi; i++, res++, ls += linc, rs += rinc) {
			*res = (logical)((rhs_m->stringval == *rs)?((logical)((logical)((NclTypeClass)nclTypelogicalClass)->type_class.default_mis.logicalval)):!(*ls==*rs));
		}
	} else {
		for(i = 0 ; i < stopi; i++, res++, ls += linc, rs += rinc) {
			*res = (logical)((( lhs_m->stringval == *ls) ||( rhs_m->stringval==*rs)) ? ( (logical)((logical)((NclTypeClass)nclTypelogicalClass)->type_class.default_mis.logicalval)) : !((*ls==*rs)));
		}
	}
	return(NhlNOERROR);
}

NclTypeClass Ncl_Type_string_ne_type
#if	NhlNeedProto
(void)
#else
()
#endif
{
	return((NclTypeClass)nclTypelogicalClass);
}

NclTypestringClassRec nclTypestringClassRec = {
	{
		"NclTypeClass",
		sizeof(NclTypeRec),
		(NclObjClass)&nclTypeClassRec,
		0,
		NULL,
		NULL,
		NULL,
		Ncl_Type_string_InitClass,
		NULL,
		NULL,
		NULL,
/* NclCallBackList* create_callback*/   NULL,
/* NclCallBackList* delete_callback*/   NULL,
/* NclCallBackList* modify_callback*/   NULL
	},
	{
/* NclObjTypes type 			*/ Ncl_Typestring,
/* NclBasicDataTypes data_type		*/ NCL_string,
/* int size 				*/ sizeof(NclQuark),
/* char *hlu_rep_type			*/ {NhlTQuark,NhlTQuarkGenArray},
/* NclScalar 				*/ {(NclQuark)-1},
/* char *format ; 			*/ "%s",
/* NclTypePrint print ; 		*/ Ncl_Type_string_print,
/* NclTypeResetMissing reset_mis; 	*/ Ncl_Type_string_reset_mis,
/* NclTypeCoerceFunction coerce; 	*/ Ncl_Type_string_coerce,
/* NclTypeOp multiply; 			*/ NULL,
/* NclTypeOutSize multiply_type;        */ NULL,
/* NclTypeOp plus; 			*/ Ncl_Type_string_plus,
/* NclTypeOutSize plus_type;            */ Ncl_Type_string_plus_type,
/* NclTypeOp minus; 			*/ NULL,
/* NclTypeOutSize minus_type;           */ NULL,
/* NclTypeOp divide; 			*/ NULL,
/* NclTypeOutSize divide_type;          */ NULL,
/* NclTypeOp exponent; 			*/ NULL,
/* NclTypeOutSize exponent_type;        */ NULL,
/* NclTypeOp mod; 			*/ NULL,
/* NclTypeOutSize mod_type;             */ NULL,
/* NclTypeOp mat; 			*/ NULL,
/* NclTypeOutSize mat_type;             */ NULL,
/* NclTypeOp sel_lt; 			*/ Ncl_Type_string_sel_lt,
/* NclTypeOutSize sel_lt_type;          */ Ncl_Type_string_sel_lt_type,
/* NclTypeOp sel_gt; 			*/ Ncl_Type_string_sel_gt,
/* NclTypeOutSize sel_gt_type;          */ Ncl_Type_string_sel_gt_type,
/* NclTypeOp not; 			*/ NULL,
/* NclTypeOutSize not_type;             */ NULL,
/* NclTypeOp neg; 			*/ NULL,
/* NclTypeOutSize neg_type;             */ NULL,
/* NclTypeOp gt; 			*/ Ncl_Type_string_gt,
/* NclTypeOutSize gt_type;              */ Ncl_Type_string_gt_type,
/* NclTypeOp lt; 			*/ Ncl_Type_string_lt,
/* NclTypeOutSize lt_type;              */ Ncl_Type_string_lt_type,
/* NclTypeOp ge; 			*/ Ncl_Type_string_ge,
/* NclTypeOutSize ge_type;              */ Ncl_Type_string_ge_type,
/* NclTypeOp le; 			*/ Ncl_Type_string_le,
/* NclTypeOutSize le_type;              */ Ncl_Type_string_le_type,
/* NclTypeOp ne; 			*/ Ncl_Type_string_ne,
/* NclTypeOutSize ne_type;              */ Ncl_Type_string_ne_type,
/* NclTypeOp eq; 			*/ Ncl_Type_string_eq,
/* NclTypeOutSize eq_type;              */ Ncl_Type_string_eq_type,
/* NclTypeOp and; 			*/ NULL,
/* NclTypeOutSize and_type;             */ NULL,
/* NclTypeOp or; 			*/ NULL,
/* NclTypeOutSize or_type;              */ NULL,
/* NclTypeOp xor; 			*/ NULL,
/* NclTypeOp xor;                       */ NULL,
/* NclNumScalarCompareFunc cmpf; 	*/ Ncl_Type_string_cmpf,
/* NclMonotonicTestFunction is_mono; 	*/ Ncl_Type_string_is_mono
	},
	{
		NULL
	}
};

NclObjClass nclTypestringClass = (NclObjClass)&nclTypestringClassRec;

NclType _NclTypestringCreate
#if	NhlNeedProto
(NclObj inst , NclObjClass theclass , NclObjTypes obj_type , unsigned int obj_type_mask, NclStatus status)
#else
(inst , theclass , obj_type ,obj_type_mask, status)
NclObj inst ;
NclObjClass theclass ;
NclObjTypes obj_type ;
unsigned int obj_type_mask;
NclStatus status;
#endif
{
	return((NclType)_NclTypeCreate(inst,theclass,obj_type,(obj_type_mask | Ncl_Typestring), status));
}

#!/bin/csh -f
#
#	$Id: ncargcc.csh,v 1.54 2010-04-02 17:49:55 haley Exp $
#                                                                      
#                Copyright (C)  2000
#        University Corporation for Atmospheric Research
#                All Rights Reserved
#
# The use of this Software is governed by a License Agreement.
#

#*********************************************#
#                                             #
# Make sure NCARG_ROOT is set for this script #
#                                             #
#*********************************************#
setenv NCARG_ROOT  `ncargpath root`

if ($status != 0) then
	exit 1
endif

set syslibdir = "SED_LIBSEARCHUSER"
set xlib     = "SED_XLIB"
set cairolib = "SED_CAIROLIBUSER"
set cc       = "SED_CC"
set defines  = "SED_STDDEF SED_PROJDEF"
set loadflags = "SED_LDCFLAGS"
set libdir   = `ncargpath SED_LIBDIR`
set incdir   = `ncargpath SED_INCDIR`
set ro       = "$libdir/SED_NCARGDIR/SED_ROBJDIR"
set f77libs  = "SED_CTOFLIBSUSER"
set libpath = "-L$libdir $syslibdir"
set incpath = "-I$incdir"

set libextra = ""

set newargv = "$cc $defines $loadflags"

set ctrans_libs = ""
set stub_file   = ""

set ncarbd   = "$ro/libncarbd.o"
set ngmathbd = "$ro/libngmathbd.o"
set smooth   = "$ro/libdashsmth.o"
set quick    = "$ro/libdashline.o $ro/libconrcqck.o $ro/libconraq.o"
set super    = "$ro/libdashsupr.o $ro/libconrcspr.o $ro/libconras.o"

#
# set up default libraries
#
set libncarg    = "-lncarg"
set libgks     = "-lSED_LIBNCARG_GKS"
set libmath     = ""
set libncarg_c  = "-lncarg_c"

set robjs
unset NGMATH_LD
unset NGMATH_BLOCKD_LD

foreach arg ($argv)

	switch ($arg)

	case "-ngmath":
		set libmath     = "-lngmath"
		set NGMATH_LD
	breaksw

	case "-sungks":
		echo "Using Sun GKS"
		set libgks="-lgks77 -lgks -lsuntool -lsunwindow -lpixrect -lm"
		breaksw

	case "-ncarbd":
		set robjs = "$robjs $ncarbd"
		set NGMATH_BLOCKD_LD
        breaksw

	case "-ngmathbd":
		set robjs = "$robjs $ngmathbd"
# Make sure the ngmath blockdata routine doesn't get loaded twice.
		unset NGMATH_BLOCKD_LD
        breaksw

	case "-smooth":
		echo "Smooth f77 of NCAR Graphics"
		set robjs = "$robjs $smooth"
		breaksw

	case "-super":
		echo "Super f77 of NCAR Graphics"
		set robjs = "$robjs $super"
		breaksw

	case "-quick":
		echo "Quick f77 of NCAR Graphics"
		set robjs = "$robjs $quick"
		breaksw

	case "-agupwrtx":
		echo "Autograph with PWRITX"
        set robjs = "$robjs $ro/libagupwrtx.o"
		breaksw

	case "-conransmooth":
		echo "Smooth Conran"
		set robjs = "$robjs $smooth"
		breaksw

	case "-conranquick":
		echo "Quick Conran"
        set robjs = "$robjs $ro/libconraq.o"
		breaksw

	case "-conransuper":
		echo "Super Conran"
        set robjs = "$robjs $ro/libconras.o $ro/libdashsupr.o"
		breaksw

	case "-conrecsmooth":
		echo "Smooth Conrec"
        set robjs = "$robjs $ro/libdashsmth.o"
		breaksw

	case "-conrecquick":
		echo "Quick Conrec"
        set robjs = "$robjs $ro/libconrcqck.o"
		breaksw

	case "-conrecsuper":
		echo "Super Conrec"
        set robjs = "$robjs $ro/libconrcspr.o $ro/libdashsupr.o"
		breaksw

	case "-dashsmooth":
		echo "Smooth Dash"
        set robjs = "$robjs $ro/libdashsmth.o"
		breaksw

	case "-dashquick":
	case "-dashline":
		echo "Quick Dash"	
        set robjs = "$robjs $ro/libdashline.o"
		breaksw

	case "-dashsuper":
		echo "Super Dash"
        set robjs = "$robjs $ro/libdashsupr.o"
        breaksw

    case "-dashchar":
        echo "Normal Dash"
        breaksw

	case "-ictrans"
		echo "Output to ictrans"
		set ctrans_libs = `ctlib`
		breaksw

    case "-noX11"
    case "-nox11"
        set stub_file = $ro/ggkwdr_stub.o
        set xlib = ""
        breaksw

	default:
		set newargv = "$newargv $arg"

	endsw

end

#
# If -ncarbd was set, *and* the ngmath library was loaded,
# then automatically take care of loading libngmathbd.o.
#
if ($?NGMATH_LD && $?NGMATH_BLOCKD_LD) then
  set robjs = "$robjs $ngmathbd"
endif

set ncarg_libs  = "$libncarg $libgks $libncarg_c $libmath"
set newargv = "$newargv $stub_file $libpath $incpath $ctrans_libs $robjs $ncarg_libs $f77libs $xlib $cairolib $libextra"


echo $newargv
eval $newargv

# csh script to switch between versions of NCL
#
# To use: source /contrib/bin/testncl.csh
# To switch back to the original version: source /contrib/bin/origncl.csh

setenv NCARG_ROOT /contrib/ncl-5.1.1-beta
setenv PATH $NCARG_ROOT/bin:$PATH

set version=`ncl -V`
echo "You are now using the test version of NCL: $version"

#!/bin/sh
#
#      $Id: char_data_c.sh,v 1.7 2009-07-10 19:54:06 huangwei Exp $
#
#########################################################################
#									#
#			   Copyright (C)  1994				#
#	     University Corporation for Atmospheric Research		#
#			   All Rights Reserved				#
#									#
#########################################################################
#
#	File:		int_data_c.sh
#
#	Author:		Jeff W. Boote
#			National Center for Atmospheric Research
#			PO 3000, Boulder, Colorado
#
#	Date:		Wed Jul 20 17:21:13 MDT 1994
#
#	Description:	
#
#	Usage:
#
#	Environment:
#
#	Files:
#
#
#	Options:

sh op_funcs.sh  char NhlTCharacter NhlTCharacterGenArray \(char\)0 > .tmp.$$

if [ ! $? ]
then
	exit $?
fi

sed \
-e 's/PRINTFORMAT/\%c\\n/' \
-e 's/DATATYPE/char/g' \
-e 's/LOCALTYPE/char/g' \
-e 's/HLUTYPEREP/NhlTCharacter/g' \
-e 's/HLUGENTYPEREP/NhlTCharacterGenArray/g' \
-e 's/DEFAULT_MISS/'\0'/g' \
-e 's/DEFAULT_FORMAT/%c/g' \
-e "/REPLACE/r .tmp.$$" \
-e '/REPLACE/d' \
-e '/DSPECIFIC/r NclTypechar.c.specific' \
-e '/DSPECIFIC/d' \
-e 's/Ncl_Type_char_mat_type/NULL/' \
-e 's/Ncl_Type_char_mat/NULL/' \
-e 's/Ncl_Type_char_mod_type/NULL/' \
-e 's/Ncl_Type_char_mod/NULL/' \
-e 's/Ncl_Type_char_divide_type/NULL/' \
-e 's/Ncl_Type_char_divide/NULL/' \
-e 's/Ncl_Type_char_multiply_type/NULL/' \
-e 's/Ncl_Type_char_multiply/NULL/' \
-e 's/Ncl_Type_char_minus_type/NULL/' \
-e 's/Ncl_Type_char_minus/NULL/' \
-e 's/Ncl_Type_char_exponent_type/NULL/' \
-e 's/Ncl_Type_char_exponent/NULL/' \
-e 's/Ncl_Type_char_neg_type/NULL/' \
-e 's/Ncl_Type_char_neg/NULL/' \
-e 's/Ncl_Type_char_not_type/NULL/' \
-e 's/Ncl_Type_char_not/NULL/' \
-e 's/Ncl_Type_char_and_type/NULL/' \
-e 's/Ncl_Type_char_and/NULL/' \
-e 's/Ncl_Type_char_or_type/NULL/' \
-e 's/Ncl_Type_char_or/NULL/' \
-e 's/Ncl_Type_char_xor_type/NULL/' \
-e 's/Ncl_Type_char_xor/NULL/' \
NclType.c.sed > NclTypechar.c

rm .tmp.$$

echo "created NclTypechar.c"

C
C $Id: mpdbdi.f.sed,v 1.4 2008-07-27 01:15:50 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MPDBDI (FLNM,ISTA)
        CHARACTER*(*) FLNM
        FLNM=' '
	CALL GNGPAT (FLNM,'SED_DBDIR',ISTA)
	RETURN
      END

/*
 *      $Id: MathFuncs.c.sed,v 1.3 1997-04-14 23:57:14 ethan Exp $
 */
/************************************************************************
*									*
*			     Copyright (C)  1995			*
*	     University Corporation for Atmospheric Research		*
*			     All Rights Reserved			*
*									*
************************************************************************/
/*
 *	File:		
 *
 *	Author:		Ethan Alpert
 *			National Center for Atmospheric Research
 *			PO 3000, Boulder, Colorado
 *
 *	Date:		Tue Jan 31 15:16:30 MST 1995
 *
 *	Description:	
 */

#include <math.h>
#include <ncarg/hlu/hlu.h>
#include <ncarg/hlu/NresDB.h>
#include "defs.h"
#include "NclDataDefs.h"
#include "NclBuiltInSupport.h"
#include "NclMdInc.h"
#include "TypeSupport.h"



REPLACE

/*
 *      $Id: NclType.c.sed,v 1.10 2009-07-10 19:54:05 huangwei Exp $
 */
/************************************************************************
*									*
*			     Copyright (C)  1995			*
*	     University Corporation for Atmospheric Research		*
*			     All Rights Reserved			*
*									*
************************************************************************/
/*
 *	File:		
 *
 *	Author:		Ethan Alpert
 *			National Center for Atmospheric Research
 *			PO 3000, Boulder, Colorado
 *
 *	Date:		Fri Jan 27 18:23:52 MST 1995
 *
 *	Description:	
 */

#include "NclTypeDATATYPE.h"
DSPECIFIC
REPLACE

NclTypeDATATYPEClassRec nclTypeDATATYPEClassRec = {
	{
		"NclTypeClass",
		sizeof(NclTypeRec),
		(NclObjClass)&nclTypeClassRec,
		0,
		NULL,
		NULL,
		NULL,
		Ncl_Type_DATATYPE_InitClass,
		NULL,
		NULL,
		NULL,
/* NclCallBackList* create_callback*/   NULL,
/* NclCallBackList* delete_callback*/   NULL,
/* NclCallBackList* modify_callback*/   NULL,
/* NclObtainCall obtain_calldata*/   NULL
	},
	{
/* NclObjTypes type 			*/ Ncl_TypeDATATYPE,
/* NclBasicDataTypes 			*/ NCL_DATATYPE,
/* int size 				*/ sizeof(LOCALTYPE),
/* char * hlu_rep_type			*/ {HLUTYPEREP,HLUGENTYPEREP},
/* NclScalar	default_mis		*/ {DEFAULT_MISS},
/* NclTypePrint print			*/ "DEFAULT_FORMAT",
/* NclTypePrint print			*/ Ncl_Type_DATATYPE_print,
/* NclTypeResetMissing reset_mis; 	*/ Ncl_Type_DATATYPE_reset_mis,
/* NclTypeCoerceFunction coerce; 	*/ Ncl_Type_DATATYPE_coerce,
/* NclTypeOp multiply; 			*/ Ncl_Type_DATATYPE_multiply,
/* NclTypeOutType multiply_type;        */ Ncl_Type_DATATYPE_multiply_type,
/* NclTypeOp plus; 			*/ Ncl_Type_DATATYPE_plus,
/* NclTypeOutType plus_type;            */ Ncl_Type_DATATYPE_plus_type,
/* NclTypeOp minus; 			*/ Ncl_Type_DATATYPE_minus,
/* NclTypeOutType minus_type;           */ Ncl_Type_DATATYPE_minus_type,
/* NclTypeOp divide; 			*/ Ncl_Type_DATATYPE_divide,
/* NclTypeOutType divide_type;          */ Ncl_Type_DATATYPE_divide_type,
/* NclTypeOp exponent; 			*/ Ncl_Type_DATATYPE_exponent,
/* NclTypeOutType exponent_type;        */ Ncl_Type_DATATYPE_exponent_type,
/* NclTypeOp mod; 			*/ Ncl_Type_DATATYPE_mod,
/* NclTypeOutType mod_type;             */ Ncl_Type_DATATYPE_mod_type,
/* NclTypeOp mat; 			*/ Ncl_Type_DATATYPE_mat,
/* NclTypeOutType mat_type;             */ Ncl_Type_DATATYPE_mat_type,
/* NclTypeOp sel_lt; 			*/ Ncl_Type_DATATYPE_sel_lt,
/* NclTypeOutType sel_lt_type;          */ Ncl_Type_DATATYPE_sel_lt_type,
/* NclTypeOp sel_gt; 			*/ Ncl_Type_DATATYPE_sel_gt,
/* NclTypeOutType sel_gt_type;          */ Ncl_Type_DATATYPE_sel_gt_type,
/* NclTypeOp not; 			*/ Ncl_Type_DATATYPE_not,
/* NclTypeOutType not_type;             */ Ncl_Type_DATATYPE_not_type,
/* NclTypeOp neg; 			*/ Ncl_Type_DATATYPE_neg,
/* NclTypeOutType neg_type;             */ Ncl_Type_DATATYPE_neg_type,
/* NclTypeOp gt; 			*/ Ncl_Type_DATATYPE_gt,
/* NclTypeOutType gt_type;              */ Ncl_Type_DATATYPE_gt_type,
/* NclTypeOp lt; 			*/ Ncl_Type_DATATYPE_lt,
/* NclTypeOutType lt_type;              */ Ncl_Type_DATATYPE_lt_type,
/* NclTypeOp ge; 			*/ Ncl_Type_DATATYPE_ge,
/* NclTypeOutType ge_type;              */ Ncl_Type_DATATYPE_ge_type,
/* NclTypeOp le; 			*/ Ncl_Type_DATATYPE_le,
/* NclTypeOutType le_type;              */ Ncl_Type_DATATYPE_le_type,
/* NclTypeOp ne; 			*/ Ncl_Type_DATATYPE_ne,
/* NclTypeOutType ne_type;              */ Ncl_Type_DATATYPE_ne_type,
/* NclTypeOp eq; 			*/ Ncl_Type_DATATYPE_eq,
/* NclTypeOutType eq_type;              */ Ncl_Type_DATATYPE_eq_type,
/* NclTypeOp and; 			*/ Ncl_Type_DATATYPE_and,
/* NclTypeOutType and_type;             */ Ncl_Type_DATATYPE_and_type,
/* NclTypeOp or; 			*/ Ncl_Type_DATATYPE_or,
/* NclTypeOutType or_type;              */ Ncl_Type_DATATYPE_or_type,
/* NclTypeOp xor; 			*/ Ncl_Type_DATATYPE_xor,
/* NclTypeOp xor;                       */ Ncl_Type_DATATYPE_xor_type,
/* NclNumScalarCompareFunc cmpf; 	*/ Ncl_Type_DATATYPE_cmpf,
/* NclMonotonicTestFunction is_mono; 	*/ Ncl_Type_DATATYPE_is_mono
	},
	{
		NULL
	}
};

NclObjClass nclTypeDATATYPEClass = (NclObjClass)&nclTypeDATATYPEClassRec;

NclType _NclTypeDATATYPECreate
#if	NhlNeedProto
(NclObj inst , NclObjClass theclass , NclObjTypes obj_type , unsigned int obj_type_mask, NclStatus status)
#else
(inst , theclass , obj_type ,obj_type_mask, status)
NclObj inst ;
NclObjClass theclass ;
NclObjTypes obj_type ;
unsigned int obj_type_mask;
NclStatus status;
#endif
{
	return((NclType)_NclTypeCreate(inst,theclass,obj_type,(obj_type_mask | Ncl_TypeDATATYPE), status));
}

#!/bin/csh -f
#
#   $Id: ncargf77.csh,v 1.41 2010-04-02 17:49:55 haley Exp $
#                                                                      
#                Copyright (C)  2000
#        University Corporation for Atmospheric Research
#                All Rights Reserved
#
# The use of this Software is governed by a License Agreement.
#

#*********************************************#
#                                             #
# Make sure NCARG_ROOT is set for this script #
#                                             #
#*********************************************#
setenv NCARG_ROOT  `ncargpath root`

if ($status != 0) then
	exit 1
endif

set syslibdir = "SED_LIBSEARCHUSER"
set xlib     = "SED_XLIB"
set cairolib = "SED_CAIROLIBUSER"
set fortran  = "SED_FC"
set loadflags  = "SED_LDFLAGS"
set libdir   = `ncargpath SED_LIBDIR`
set ro       = "$libdir/SED_NCARGDIR/SED_ROBJDIR"
set libpath = "-L$libdir $syslibdir"

set libextra = "SED_LIBEXTRA"

if (! -d "$libdir") then
  echo "Library directory <$libdir> does not exist."
  exit 1
endif

set newargv = "$fortran $loadflags"

set ctrans_libs = ""
set stub_file   = ""

#
# set up default libraries
#
set libncarg  =  "-lncarg"
set libgks     = "-lSED_LIBNCARG_GKS"
set libncarg_c = "-lncarg_c"
set libmath  = ""

set ncarbd   = "$ro/libncarbd.o"
set ngmathbd = "$ro/libngmathbd.o"
set smooth   = "$ro/libdashsmth.o"
set quick    = "$ro/libdashline.o $ro/libconrcqck.o $ro/libconraq.o"
set super    = "$ro/libdashsupr.o $ro/libconrcspr.o $ro/libconras.o"

set robjs
unset NGMATH_LD
unset NGMATH_BLOCKD_LD

foreach arg ($argv)

    switch ($arg)

    case "-ngmath":
      set libmath     = "-lngmath"
      set NGMATH_LD
      breaksw

    case "-sungks":
        echo "Using Sun GKS"
        set libgks="-lgks77 -lgks -lsuntool -lsunwindow -lpixrect -lm"
        breaksw

    case "-ncarbd":
        set robjs = "$robjs $ncarbd"
        set NGMATH_BLOCKD_LD
        breaksw

    case "-ngmathbd":
        set robjs = "$robjs $ngmathbd"
# Make sure the ngmath blockdata routine doesn't get loaded twice.
        unset NGMATH_BLOCKD_LD
        breaksw

    case "-smooth":
        echo "Smooth SED_FC of NCAR Graphics"
        set robjs = "$robjs $smooth"
        breaksw

    case "-super":
        echo "Super SED_FC of NCAR Graphics"
        set robjs = "$robjs $super"
        breaksw

    case "-quick":
        echo "Quick SED_FC of NCAR Graphics"
        set robjs = "$robjs $quick"
        breaksw

    case "-agupwrtx":
        echo "Autograph with PWRITX"
        set robjs = "$robjs $ro/libagupwrtx.o"
        breaksw

    case "-conransmooth":
        echo "Smooth Conran"
        set robjs = "$robjs $smooth"
        breaksw

    case "-conranquick":
        echo "Quick Conran"
        set robjs = "$robjs $ro/libconraq.o"
        breaksw

    case "-conransuper":
        echo "Super Conran"
        set robjs = "$robjs $ro/libconras.o $ro/libdashsupr.o"
        breaksw

    case "-conrecsmooth":
        echo "Smooth Conrec"
        set robjs = "$robjs $ro/libdashsmth.o"
        breaksw

    case "-conrecquick":
        echo "Quick Conrec"
        set robjs = "$robjs $ro/libconrcqck.o"
        breaksw

    case "-conrecsuper":
        echo "Super Conrec"
        set robjs = "$robjs $ro/libconrcspr.o $ro/libdashsupr.o"
        breaksw

    case "-dashsmooth":
        echo "Smooth Dash"
        set robjs = "$robjs $ro/libdashsmth.o"
        breaksw

    case "-dashquick":
    case "-dashline":
        echo "Quick Dash"
        set robjs = "$robjs $ro/libdashline.o"
        breaksw

    case "-dashsuper":
        echo "Super Dash"
        set robjs = "$robjs $ro/libdashsupr.o"
        breaksw

    case "-dashchar":
        echo "Normal Dash"
        breaksw

    case "-ictrans":
        echo "Output to ictrans"
        set ctrans_libs = `ctlib`
        set xlib   = ""
        set libmath  = ""
        set stub_file = $ro/ggkwdr_stub.o
        breaksw

    case "-noX11"
    case "-nox11"
        set stub_file = $ro/ggkwdr_stub.o
        set xlib = ""
        breaksw

    case "-*":
        set newargv = "$newargv $arg"
        breaksw

    default:
        set newargv = "$newargv $arg"
        breaksw

    endsw
end
 
#
# If -ncarbd was set, *and* the ngmath library was loaded,
# then automatically take care of loading libngmathbd.o.
#
if ($?NGMATH_LD && $?NGMATH_BLOCKD_LD) then
  set robjs = "$robjs $ngmathbd"
endif

set ncarg_libs  = "$libncarg $libgks $libncarg_c $libmath"
set newargv = "$newargv $stub_file $libpath $ctrans_libs $robjs $ncarg_libs $xlib $cairolib $libextra"



echo $newargv
eval $newargv

C
C	$Id: metred.f.sed,v 1.2 2008-07-27 00:59:04 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE METRED(IOS,STATUS)
C
C  READ IN A METAFILE RECORD
C
C  INPUT-NONE
C
C  OUTPUT
C       IOS-METAFILE READ STATUS VALID WHEN STATUS SET TO AN I/O ERROR
C       STATUS-THE ERROR STATUS FLAG
C                       ALLOK EVERYTHING WENT WELL
C                       NE ALLOK ERROR DEFINED IN COMMON TREROR
C
      COMMON/TREROR/ ALLOK, MFRCHK, MTOPER, METRDC, REDERR, TYPCHG
     1             ,INVTYP, MINVLD, TYPERR, FRMEND, ENCINT, IVDCDT
     2             ,GCOERR, GCRERR, GCCERR, FCOERR, FCRERR, FCCERR
     3             ,PLIDXG, PMIDXG, TXIDXG, PGIDXG, INVLMT, CELERR
     4             ,COIERR, COLNRM, UNKNOW, UNKOPC, ENDMTF, VNEROR
     5             ,BADRSZ, DEVOUT, NOVERS, BADFNT, PGMERR, FASERR
     6             ,HINERR, VDWERR, RDWERR, RIXLIM
      INTEGER        ALLOK, MFRCHK, MTOPER, METRDC, REDERR, TYPCHG
     1             ,INVTYP, MINVLD, TYPERR, FRMEND, ENCINT, IVDCDT
     2             ,GCOERR, GCRERR, GCCERR, FCOERR, FCRERR, FCCERR
     3             ,PLIDXG, PMIDXG, TXIDXG, PGIDXG, INVLMT, CELERR
     4             ,COIERR, COLNRM, UNKNOW, UNKOPC, ENDMTF, VNEROR
     5             ,BADRSZ, DEVOUT, NOVERS, BADFNT, PGMERR, FASERR
     6             ,HINERR, VDWERR, RDWERR, RIXLIM
      COMMON/TRINOT/ IPTR, MBUFOT, MAXBYT, DEVUNT, METUNT,
     1          METIPT, ERRUNT, FNTUNT
      INTEGER MAXCNT
      PARAMETER (MAXCNT=200)
      INTEGER IPTR, MBUFOT(MAXCNT), MAXBYT, DEVUNT, METUNT, ERRUNT,
     1        FNTUNT
      LOGICAL METIPT
      COMMON /PTRBUFR/ METBIT, MBUFER, MDTYPE, METREC, MRECLN,
     1                MCONTF, MOPRST, LNGFLG, MERGFL
      INTEGER MNWRDS, RECLOC, RECSIZ, DTLOC, DTSIZ, MBITST, MBUFOF,
     1        MINSBD, MERLOC, MERSIZ
#if defined(cray)
      PARAMETER (MNWRDS=180, RECLOC=0, RECSIZ=16, DTLOC=16, DTSIZ=4
#else
      PARAMETER (MNWRDS=360, RECLOC=0, RECSIZ=16, DTLOC=16, DTSIZ=4
#endif
     1          ,MBITST=32, MBUFOF=32, MINSBD=16, MERLOC=23, MERSIZ=1)
      INTEGER METBIT, MBUFER(MNWRDS), MDTYPE, METREC, MRECLN, MOPRST
      LOGICAL MCONTF, LNGFLG, MERGFL
      COMMON /TRTYPE/ METMIN, METEXT, METPRT, METHED, MIOPCL, MXOPCL,
     1                MIOPID, MXOPID, ASCDEC, ASCHEX, ASCOCT, BINARY,
     2                GAHNOR, GALEFT, GACENT, GARITE, GAVNOR, GATOP ,
     3                GACAP , GAHALF, GABASE, GABOTT, GRIGHT, GLEFT ,
     4                GUP   ,
     5                GDOWN , CINDEX, CDIRCT, PENUP , PENDN , FLAGVL,
     6                SEPRVL, ASCTEK, TYPRGB, TYPBGR,
     7                TYPHLS, TYPMON, SOLID , DASHED, INVSBL, SOLPAT,
     8                ASFIND, ASFBND, ASFLNT, ASFLNW, ASFLNC, ASFMRT,
     9                ASFMRS, ASFMRC, ASFFIS, ASFFHI, ASFFPI, ASFFCO,
     A                ASFFPT, ASFFPW, ASFFPC, ASFTFI, ASFTPR, ASFTCX,
     B                ASFTCS, ASFTCO, ASCFLT, PHOLLO, PSOLID, PPATTR,
     C                PHATCH, PEMPTY, HHORIZ, HVERTI, HPOSLP, HNESLP,
     D                HHOAVE, HPOANE
      INTEGER         METMIN, METEXT, METPRT, METHED, MIOPCL, MXOPCL,
     1                MIOPID, MXOPID, ASCDEC, ASCHEX, ASCOCT, BINARY,
     2                GAHNOR, GALEFT, GACENT, GARITE, GAVNOR, GATOP ,
     3                GACAP , GAHALF, GABASE, GABOTT, GRIGHT, GLEFT ,
     4                GUP   ,
     5                GDOWN , CINDEX, CDIRCT, PENUP , PENDN , FLAGVL,
     6                SEPRVL, ASCTEK, TYPRGB, TYPBGR,
     7                TYPHLS, TYPMON, SOLID , DASHED, INVSBL, SOLPAT,
     8                ASFIND, ASFBND, ASFLNT, ASFLNW, ASFLNC, ASFMRT,
     9                ASFMRS, ASFMRC, ASFFIS, ASFFHI, ASFFPI, ASFFCO,
     A                ASFFPT, ASFFPW, ASFFPC, ASFTFI, ASFTPR, ASFTCX,
     B                ASFTCS, ASFTCO, ASCFLT, PHOLLO, PSOLID, PPATTR,
     C                PHATCH, PEMPTY, HHORIZ, HVERTI, HPOSLP, HNESLP,
     D                HHOAVE, HPOANE
      COMMON /THFLG/NSFLG
C
C  The following COMMON is from the NCAR GKS package.  It is used
C  in order to bump MRECNM when writing a HEADER or TEXT record
C  to the output file.  *** This COMMON must be kept compatible
C  with the NCAR GKS package ***
C
      COMMON  /G01IO/   MIOFLG  ,MRECNM ,ITMP(985)
      INTEGER           MIOFLG  ,MRECNM ,ITMP
C
      INTEGER IOS, STATUS
      INTEGER TEMP, IER
      CHARACTER*1 CTMP
C
C  SET THE FLAG TO OK
C
      STATUS = ALLOK
   20 CONTINUE
C
C  READ IN A METAFILE RECORD
C
      CALL BINRED(0,MNWRDS,MBUFER,IOS,IER)
#if (defined(ultrix) && defined(mips)) || (defined(__alpha) && defined(__osf__))
      DO 220 J=1,360
        IB1 = IAND(ISHIFT(MBUFER(J),-24),255)
        IB2 = IAND(ISHIFT(MBUFER(J),-16),255)
        IB3 = IAND(ISHIFT(MBUFER(J),-08),255)
        IB4 = IAND(ISHIFT(MBUFER(J),-00),255)
        IRV = IOR(IB1,ISHIFT(IB2,08))
        IRV = IOR(IRV,ISHIFT(IB3,16))
        IRV = IOR(IRV,ISHIFT(IB4,24))
        MBUFER(J) = IRV
  220 CONTINUE
#endif
      IF (IER .NE. 0) GO TO 1000
C
C  GET THE DATA TYPE ID AND PASS ANY TEXT AND HEADER RECORDS
C  ON TO THE OUTPUT FILE.
C
      MDTYPE = 0
      CALL GBYTES(MBUFER,MDTYPE,DTLOC,DTSIZ,0,1)
      METREC = METREC + 1
      IF (MDTYPE .NE. METMIN) THEN
        IF (MDTYPE.EQ.METPRT .OR. MDTYPE.EQ.METHED) THEN
C
C  Write to output file.
C
          IF (NSFLG .NE. 1) THEN
            CALL G01FLB
            CALL G01MIO(3,METUNT,CTMP,MBUFER,MNWRDS,ier)
            MRECNM = MRECNM+1
          ENDIF
          GO TO 20
        ELSE IF(MDTYPE .EQ. METEXT) THEN
          WRITE(6,'('' Input metafile already in NCAR CGM format, no act
     -ion taken.'')')
          WRITE(6,'('' Output file may be corrupt.'')')
          STOP
        ELSE
          WRITE(6,'('' Unknown record type in input metafile'')')
          STOP
        ENDIF
      ELSE
C
C  RESET THE BIT POINTER
C
        METBIT = MBITST
C
C  GET THE USEFUL DATA COUNT AND CONVERT FROM 8 BIT BYTES TO BITS
C
        CALL GBYTES(MBUFER,TEMP,RECLOC,RECSIZ,0,1)
        MRECLN = TEMP * 8 + MBUFOF
C
C  IF BIT COUNT OUT OF RANGE THEN SET END OF METAFILE AND RETURN
C       THIS FIX IS FOR MINIMAL METACODE PROBLEMS
C
        IF (MRECLN .LE. MBUFOF .OR. MRECLN .GT. 1440*8) THEN
          STATUS = ENDMTF
          RETURN
        END IF
C
C  GET THE MERGE FRAMES FLAG
C
        CALL GBYTES(MBUFER,TEMP, MERLOC, MERSIZ, 0, 1)
        MERGFL = .FALSE.
        IF (TEMP .EQ. 1) MERGFL = .TRUE.
C
C  NORMAL EXIT
C
        RETURN
      ENDIF
C
C  ERROR EXIT
C
 1000 CONTINUE
      STATUS = REDERR
      RETURN
C
      END

#!/bin/csh -f
#
#   $Id: ncargex.csh,v 1.175 2010-05-07 16:15:39 haley Exp $
#                                                                      
#                Copyright (C)  2000
#        University Corporation for Atmospheric Research
#                All Rights Reserved
#
# The use of this Software is governed by a License Agreement.
#

if ($#argv < 1) goto usage

#*********************************************#
#                                             #
# Make sure NCARG_ROOT is set for this script #
#                                             #
#*********************************************#
setenv NCARG_ROOT  `ncargpath root`
if ($status != 0) then
  exit 1
endif

#****************************#
#                            #
# Check for directories that #
# contain the examples       #
#                            #
#****************************#
set example_dir=`ncargpath SED_EXAMPLESDIR`
if ($status != 0) then
  exit 1
endif

if (! -d "$example_dir") then
  echo "Example directory <$example_dir> does not exist."
  exit 1
endif
set fund_dir = $example_dir
set pdoc_dir = $example_dir

set test_dir=`ncargpath SED_TESTSDIR`
if ($status != 0) then
  exit 1
endif

if (! -d "$test_dir") then
  echo "Test directory <$test_dir> does not exist."
  exit 2
endif

set tutor_dir=`ncargpath SED_TUTORIALDIR`
if ($status != 0) then
  exit 1
endif

if (! -d "$tutor_dir") then
  echo "Test directory <$tutor_dir> does not exist."
  exit 2
endif

#*************************************************#
#                                                 #
# Initialize file types, orientation types, color #
# types, names of default output files, output    #
# messages, etc.                                  #
#                                                 #
# If new workstation types are added, this is     #
# where you specify the name for it.  The         #
# position (index, starting at "1") of the        # 
# workstation description in the following        #
# lists corresponds to its associated integer     #
# value.                                          #
#                                                 #
#*************************************************#
set file_types     = (ncgm x11 text oldps eps epsi oldpdf ps png pdf)
set orient_types = (port land)
set color_types  = (color mono)
set ws_types = (                                                   \
                "ncgm.port.color"                                  \
                "" "" "" "" "" ""                                  \
                "x11.port.color" "" "text.port.color"              \
                "oldpdf.port.color" "oldpdf.land.color"            \
                "" "" "" "" "" "" ""                               \
                "oldps.port.color" "eps.port.color" "epsi.port.color" \
                "oldps.port.mono"  "eps.port.mono"  "epsi.port.mono"  \
                "oldps.land.color" "eps.land.color" "epsi.land.color" \
                "oldps.land.mono"  "eps.land.mono"  "epsi.land.mono"  \
                "" "" "" "" "" "" "" ""                            \
                "ps.port.color" "png.port.color" "pdf.port.color" \
               )
set suffix_names = (                                               \
                "ncgm"                                             \
                "" "" "" "" "" ""                                  \
                "" "" "txt"                                        \
                "pdf" "pdf"                                        \
                "" "" "" "" "" "" ""                               \
                "ps" "eps" "epsi"                                  \
                "ps" "eps" "epsi"                                  \
                "ps" "eps" "epsi"                                  \
                "ps" "eps" "epsi"                                  \
                "" "" "" "" "" "" "" ""                            \
                "ps" "png" "pdf"                                   \
                    )
set default_msgs = (                                                       \
  "Metafile file is named"                                                 \
  "" "" "" "" "" ""                                                        \
  "" "" "Text dump file is named"                                          \
  "Older-style color portrait PDF file is named"                                       \
  "Older-style Color landscape PDF file is named"                                      \
  "" "" "" "" "" "" ""                                                     \
  "Older-style color portrait PostScript file is named"                                \
  "Color portrait encapsulated PostScript file is named"                   \
  "Color portrait interchange encapsulated PostScript file is named"       \
  "Older-style monochrome portrait PostScript file is named"                           \
  "Monochrome portrait encapsulated PostScript file is named"              \
  "Monochrome portrait interchange encapsulated PostScript file is named"  \
  "Older-style color landscape PostScript file is named"                               \
  "Color landscape encapsulated PostScript file is named"                  \
  "Color landscape interchange encapsulated PostScript file is named"      \
  "Older-style monochrome landscape PostScript file is named"                          \
  "Monochrome landscape encapsulated PostScript file is named"             \
  "Monochrome landscape interchange encapsulated PostScript file is named" \
  "" "" "" "" "" "" "" ""                                                  \
  "cairo Postscript file is named"                                         \
  ""                                                                       \
  "cairo PDF file is named"                                                \
)

set f_list
set c_list
#**********************#
#                      #
#  Set areas examples  #
#                      #
#**********************#
set areas_fex   = (arex01 arex02 arex03)
set areas_ftst  = (tareas)
set areas_fttr  = (cardb1 caredg carline cardb2 carfill carmap)
set areas_flist = ($areas_fex $areas_ftst $areas_fttr)

set areas_ctst  = (c_tareas)
set areas_clist = ($areas_ctst)
set f_list = ($f_list $areas_flist)
set c_list = ($c_list $areas_clist)

#**************************#
#                          #
#  Set autograph examples  #
#                          #
#**************************#
set autograph_fex   = (agex01 agex02 agex03 agex04 agex05 agex06 agex07 \
		      agex08 agex09 agex10 agex11 agex12 agex13 agdp01)
set autograph_ftst  = (tautog tagupw)
set autograph_ffnd  = (fagaxclr fagaxlbl fagaxmax fagcuclr fagcudsh fagezmxy \
                      fagezmy fagezxy fagezy fagilclr fagovrvw)
set autograph_flist = ($autograph_fex $autograph_ftst $autograph_ffnd)

set autograph_cex   = (c_agex07)
set autograph_clist = ($autograph_cex)

set f_list = ($f_list $autograph_flist)
set c_list = ($c_list $autograph_clist)

#**********************#
#                      #
#  Set bivar examples  #
#                      #
#**********************#
set cbivar_fex   = (cbex01)
set cbivar_fttr  = (cidsfft)
set cbivar_flist = ($cbivar_fex $cbivar_fttr)

set cbivar_cex   = (c_cbex01)
set cbivar_clist = ($cbivar_cex)

set f_list = ($f_list $cbivar_flist)
set c_list = ($c_list $cbivar_clist)

#************************#
#                        #
#  Set colconv examples  #
#                        #
#************************#
set colconv_fex   = (coex01 coex02 coex03)
set colconv_ftst  = (tcolcv)
set colconv_ffnd  = (fcce01 fcce02)
set colconv_flist = ($colconv_fex $colconv_ftst $colconv_ffnd)

set colconv_cex   = (c_coex02)
set colconv_clist = ($colconv_cex)

set f_list = ($f_list $colconv_flist)
set c_list = ($c_list $colconv_clist)

#************************#
#                        #
#  Set conpack examples  #
#                        #
#************************#
set conpack_fex  = (cpex01 cpex02 cpex03 cpex04 cpex05 cpex06 cpex07 \
                    cpex08 cpex09 cpex10 cpex11 cpex12 cpex13 cpex14 \
                    cpex15 cpex16 ${cbivar_fex})
set conpack_ftst = (tconpa)
set conpack_fttr = (ccpback ccpcff ccpcfx ccpcica ccpcir ccpcis ccpcit ccpclc \
                    ccpcld ccpcldm ccpcldr ccpcll ccpclu ccpcnrc ccpdflt \
                    ccpezct ccpfil ccpga ccphand ccphcf ccphl ccphlt ccpila \
                    ccpils ccpilt ccpklb ccplbam ccplbdr ccpline ccpllb \
                    ccpllc ccplll ccpllo ccpllp ccpllt ccpllw ccpmap \
                    ccpmovi ccpmpxy ccpncls ccpnet ccpnof ccpnsd ccppc ccppc1 \
                    ccppc2 ccppc3 ccppc4 ccppkcl ccppole ccpt2d ccprc ccprect \
                    ccprwc ccprwu ccpscam ccpset ccpsps1 ccpsps2 ccpspv \
                    ccptitle ccpvp ccpvs colcon ${cbivar_fttr})
set conpack_flist = ($conpack_fex $conpack_ftst $conpack_fttr)

set conpack_cttr  = (c_colcon)
set conpack_cex   = (${cbivar_cex})
set conpack_clist = ($conpack_cex $conpack_cttr)

set f_list = ($f_list $conpack_flist)
set c_list = ($c_list $conpack_clist)

#*************************#
#                         #
#  Set conpackt examples  #
#                         #
#*************************#
set conpackt_fex   = (ctcbay ctex01 ctex02 ctfite ctgaus ctgc23 ctgeo1 ctgeo2 \
		      ctgeo3 ctiscp ctisc2 ctllg1 ctllg2 ctllg3 ctnccl ctorca \
		      ctpopg ctswth ctwng1 ctwng2 cttd01 cttd02 ctterr)
set conpackt_flist = ($conpackt_fex)

set conpackt_cex   = (c_ctllg3)
set conpackt_clist = ($conpackt_cex)

set f_list = ($f_list $conpackt_flist)
set c_list = ($c_list $conpackt_clist)

#******************************#
#                              #
#  Set conran_family examples  #
#                              #
#******************************#
set cnrn_family_ftst  = (tconan tconaq tconas)
set cnrn_family_flist = (${cnrn_family_ftst})

set f_list = ($f_list ${cnrn_family_flist})

#******************************#
#                              #
#  Set conrec_family examples  #
#                              #
#******************************#
set cnrc_family_ftst  = (tconre tcnqck tcnsmt tcnsup)
set cnrc_family_flist = (${cnrc_family_ftst})

set f_list = ($f_list ${cnrc_family_flist})

#*************************#
#                         #
#  Set dashline examples  #
#                         #
#*************************#
set dashline_ftst  = (tdashc tdashl tdashp tdashs)
set dashline_ffnd  = (fdlcurvd fdldashc fdldashd fdlsmth)
set dashline_flist = ($dashline_ftst $dashline_ffnd)

set dashline_cfnd  = (c_fdldashc)
set dashline_clist = ($dashline_cfnd)

set f_list = ($f_list $dashline_flist)
set c_list = ($c_list $dashline_clist)

#***********************#
#                       #
# set dashpack examples #
#                       #
#***********************#
set dashpack_ftst  = (tdshpk)
set dashpack_flist = ($dashpack_ftst)

set dashpack_ctst  = (c_tdshpk)
set dashpack_clist = ($dashpack_ctst)

set f_list = ($f_list $dashpack_flist)
set c_list = ($c_list $dashpack_clist)

#**********************#
#                      #
#  Set ezmap examples  #
#                      #
#**********************#
set ezmap_fex   = (mpex01 mpex02 mpex03 mpex04 mpex05 mpex06 mpex07 mpex08 \
		  mpex09 mpex10 mpex11 mpex12 mpex13 mpex14 mpex15 mpexfi \
		  eezmpa)
set ezmap_ftst  = (tezmap tezmpa tezmpb)
set ezmap_fttr  = (cezmap1 cezmap2 cezmap3 cmpclr cmpdd cmpdrw cmpel \
                  cmpfil cmpgci cmpgrd cmpgrp cmpita cmpitm cmplab cmplbl \
                  cmplot cmpmsk cmpou cmppos cmpsat cmpsup cmptit cmptra \
                  cmpusr)
set ezmap_flist = ($ezmap_fex $ezmap_ftst $ezmap_fttr)

set ezmap_cex   = (c_mpex05 c_eezmpa c_eezmpb)
set ezmap_clist = ($ezmap_cex)

set f_list = ($f_list $ezmap_flist)
set c_list = ($c_list $ezmap_clist)

#***********************#
#                       #
#  Set gflash examples  #
#                       #
#***********************#
set gflash_ftst  = (tgflas)
set gflash_flist = ($gflash_ftst)

set gflash_ctst  = (c_tgflas)
set gflash_clist = ($gflash_ctst)

set f_list = ($f_list $gflash_flist)
set c_list = ($c_list $gflash_clist)

#******************#
#                  #
# set gks examples #
#                  #
#******************#
set gks_ffnd    = (fgke02 fgke03 fcell fcell0 fgpm01 fgkgpl fgkgpm fgkgtx \
                  fgklnclr fgklnwth fcirc)
set gks_fpdc    = (pgkex01 pgkex02 pgkex03 pgkex04 pgkex05 pgkex06 pgkex07 \
                  pgkex08 pgkex09 pgkex10 pgkex11 pgkex12 pgkex13 pgkex14 \
                  pgkex15 pgkex16 pgkex17 pgkex18 pgkex19 pgkex20 pgkex21 \
                  pgkex22 pgkex23 pgkex24 pgkex25 pgkex26 pgkex27)
set gks_flist   = ($gks_ffnd $gks_fpdc)

set gks_cex     = (c_gtxpac c_gcell)
set gks_cpdc    = (c_pgkex21)
set gks_clist   = ($gks_cex $gks_cpdc)

set f_list = ($f_list $gks_flist)
set c_list = ($c_list $gks_clist)

#************************#
#                        #
#  Set gridall examples  #
#                        #
#************************#
set gridall_ftst  = (tgrida)
set gridall_ffnd  = (ccpga)
set gridall_flist = ($gridall_ffnd $gridall_ftst)

set gridall_ctst  = (c_tgrida)
set gridall_clist = ($gridall_ctst)

set f_list = ($f_list $gridall_flist)
set c_list = ($c_list $gridall_clist)

#*************************#
#                         #
#  Set halftone examples  #
#                         #
#*************************#
set halftone_ftst  = (thafto)
set halftone_flist = ($halftone_ftst)

set f_list = ($f_list $halftone_flist)

#**************************#
#                          #
#  Set histogram examples  #
#                          #
#**************************#
set histogram_ftst  = (thstgr thstmv)
set histogram_flist = ($histogram_ftst)

set histogram_ctst  = (c_thstmv)
set histogram_clist = ($histogram_ctst)

set f_list = ($f_list $histogram_flist)
set c_list = ($c_list $histogram_clist)

#***********************#
#                       #
# set isosrfhr examples #
#                       #
#***********************#
set isosrfhr_ftst  = (tisohr)
set isosrfhr_flist = ($isosrfhr_ftst)

set f_list = ($f_list $isosrfhr_flist)

#*************************#
#                         #
# set isosurface examples #
#                         #
#*************************#
set isosurface_ftst  = (tisosr tpwrzi)
set isosurface_ffnd  = (fisissrf fispwrzi)
set isosurface_flist = ($isosurface_ftst $isosurface_ffnd)

set isosurface_ctst  = (c_tisosr)
set isosurface_clist = ($isosurface_ctst)

set f_list = ($f_list $isosurface_flist)
set c_list = ($c_list $isosurface_clist)

#***********************#
#                       #
# set labelbar examples #
#                       #
#***********************#
set labelbar_fex   = (elblba)
set labelbar_ftst  = (tlblba)
set labelbar_ffnd  = (clbfil clbbar clblbr)
set labelbar_flist = ($labelbar_fex $labelbar_ftst $labelbar_ffnd)

set labelbar_cex   = (c_elblba)
set labelbar_clist = ($labelbar_cex)

set f_list = ($f_list $labelbar_flist)
set c_list = ($c_list $labelbar_clist)

#*********************#
#                     #
# set ngmath examples #
#                     #
#*********************#
set csagrid_flist = (csex01 csex02 csex03 csex04 csex05 csex06 csex07)
set cssgrid_flist = (cssex01 cssex02 cssex03)
set dsgrid_flist  = (dsex01 dsex01d dsex02 dsex03 dsex04 dsex05 dsex06)
set fitgrid_flist = (ftex01  ftex02  ftex03  ftex04  ftex05  ftex06  ftex07 \
                     ftex01d ftex02d ftex03d ftex04d ftex05d ftex06d ftex07d)
set natgrid_flist = (nnex01 nnex01d nnex02 nnex03 nnex04 nnex05 nnex06 \
                     nnex07 nnex08 nnex09 nnex10)
set shgrid_flist  = (shex01 shex02 shex03)

set ngmath_flist  = ($csagrid_flist $cssgrid_flist $dsgrid_flist \
                     $fitgrid_flist $natgrid_flist $shgrid_flist)
                   
set csagrid_clist = (c_csex01 c_csex02 c_csex03 c_csex04 c_csex05 \
                     c_csex06 c_csex07)
set cssgrid_clist = (c_cssex01 c_cssex02 c_cssex03)
set dsgrid_clist  = (c_dsex01 c_dsex01d c_dsex02 c_dsex03 c_dsex04 \
                     c_dsex05 c_dsex06)
set fitgrid_clist = (c_ftex01  c_ftex02  c_ftex03  c_ftex04  c_ftex05 \
                     c_ftex06  c_ftex07 \
                     c_ftex01d c_ftex02d c_ftex03d c_ftex04d c_ftex05d \
                     c_ftex06d c_ftex07d)
set natgrid_clist = (c_nnex01 c_nnex01d c_nnex02 c_nnex03 c_nnex04 c_nnex06)
set shgrid_clist  = (c_shex01 c_shex02 c_shex03)

set ngmath_clist  = ($csagrid_clist $cssgrid_clist $dsgrid_clist \
                     $fitgrid_clist $natgrid_clist $shgrid_clist)
                      
set ngmath_fex    = ($ngmath_flist)
set ngmath_cex    = ($ngmath_clist)
set f_list = ($f_list $ngmath_flist)
set c_list = ($c_list $ngmath_clist)

#*********************#
#                     #
# set ngmisc examples #
#                     #
#*********************#
set ngmisc_ffnd  = (fngngdts fngwsym miex01)
set ngmisc_flist = ($ngmisc_ffnd)

set ngmisc_cfnd  = (c_fngwsym)
set ngmisc_clist = ($ngmisc_cfnd)

set f_list = ($f_list $ngmisc_flist)
set c_list = ($c_list $ngmisc_clist)

#***********************#
#                       #
# set plotchar examples #
#                       #
#***********************#
set plotchar_fex   = (epltch)
set plotchar_ftst  = (tpltch)
set plotchar_ffnd  = (fpchiqu fpcloqu fpcfonts)
set plotchar_flist = ($plotchar_fex $plotchar_ftst $plotchar_ffnd)

set plotchar_cex   = (c_epltch)
set plotchar_clist = ($plotchar_cex)

set f_list = ($f_list $plotchar_flist)
set c_list = ($c_list $plotchar_clist)

#***********************#
#                       #
# set polypack examples #
#                       #
#***********************#
set polypack_fex   = (ppex01)
set polypack_ftst  = (tppack)
set polypack_flist = ($polypack_fex $polypack_ftst)

set polypack_cex   = (c_ppex01)
set polypack_clist = ($polypack_cex)

set f_list = ($f_list $polypack_flist)
set c_list = ($c_list $polypack_clist)

#****************************#
#                            #
# set pwrite_family examples #
#                            #
#****************************#
set pwrite_ftst  = (tpwrtx tpwry)
set pwrite_flist = ($pwrite_ftst)

set f_list = ($f_list $pwrite_flist)

#*****************************#
#                             #
# set scrolled title examples #
#                             #
#*****************************#
set scrlld_title_fex   = (slex01 slex02)
set scrlld_title_ftst  = (tstitl)
set scrlld_title_ffnd  = (fslfont)
set scrlld_title_flist = (${scrlld_title_fex} ${scrlld_title_ftst} \
                         ${scrlld_title_ffnd})

set scrlld_title_cex   = (c_slex01)
set scrlld_title_clist = (${scrlld_title_cex})

set f_list = ($f_list ${scrlld_title_flist})
set c_list = ($c_list ${scrlld_title_clist})

#********************#
#                    #
# set seter examples #
#                    #
#********************#
set seter_ftst  = (tseter)
set seter_flist = ($seter_ftst)

set f_list = ($f_list $seter_flist)

#***********************#
#                       #
# set softfill examples #
#                       #
#***********************#
set softfill_fex   = (sfex01 sfex02)
set softfill_ftst  = (tsoftf)
set softfill_ffnd  = (fsfwrld fsfsgfa)
set softfill_flist = ($softfill_fex $softfill_ftst $softfill_ffnd)

set softfill_cex   = (c_sfex02)
set softfill_clist = ($softfill_cex)

set f_list = ($f_list $softfill_flist)
set c_list = ($c_list $softfill_clist)

#*******************#
#                   #
# set spps examples #
#                   #
#*******************#
set spps_fex   = (splogy sprevx)
set spps_ffnd  = (fspcurve fspline fsppoint fspponts fcoord fcoord1 fcoord2)
set spps_flist = ($spps_fex $spps_ffnd)

set spps_cfnd  = (c_fcoord2)
set spps_clist = ($spps_cfnd)

set f_list = ($f_list $spps_flist)
set c_list = ($c_list $spps_clist)

#**************************#
#                          #
# set streamlines examples #
#                          #
#**************************#
set streamlines_fex   = (stex01 stex02 stex03)
set streamlines_ftst  = (tstrml)
set streamlines_ffnd  = (fstream ffex00 ffex01 ffex03 ffex04)
set streamlines_flist = ($streamlines_fex $streamlines_ftst $streamlines_ffnd)

set streamlines_cfnd  = (c_ffex03)
set streamlines_clist = ($streamlines_cfnd)

set f_list = ($f_list $streamlines_flist)
set c_list = ($c_list $streamlines_clist)

#**********************#
#                      #
# set surface examples #
#                      #
#**********************#
set surface_fex   = (srex01)
set surface_ftst  = (tsrfac tpwrzs)
set surface_ffnd  = (fsrezsrf fsrpwrzs fsrsrfac)
set surface_flist = ($surface_fex $surface_ftst $surface_ffnd)

set surface_cex   = (c_srex01)
set surface_clist = ($surface_cex)

set f_list = ($f_list $surface_flist)
set c_list = ($c_list $surface_clist)

#*********************#
#                     #
# set tdpack examples #
#                     #
#*********************#
set tdpack_fex   = (tdex01 tdex02 tdex03 tdex04 tdex05 tdex06 tdex07 tdex08)
set tdpack_ftst  = ()
set tdpack_flist = ($tdpack_fex $tdpack_ftst)

set tdpack_cex   = (c_tdex01 c_tdex03)
set tdpack_clist = ($tdpack_cex)

set f_list = ($f_list $tdpack_flist)
set c_list = ($c_list $tdpack_clist)

#*********************#
#                     #
# set threed examples #
#                     #
#*********************#
set threed_ftst  = (tthree tpwrzt)
set threed_ffnd  = (fthex01 fthex02 fthex03 fthex04 fthex05)
set threed_flist = ($threed_ftst $threed_ffnd)

set threed_cfnd  = (c_fthex01)
set threed_clist = ($threed_cfnd)

set f_list = ($f_list $threed_flist)
set c_list = ($c_list $threed_clist)

#*************************#
#                         #
#  Set vaspackt examples  #
#                         #
#*************************#
set vaspackt_fex   = (vtex01 vtex02 vtex03)
set vaspackt_flist = ($vaspackt_fex)

set vaspackt_cex   = ()
set vaspackt_clist = ($vaspackt_cex)

set f_list = ($f_list $vaspackt_flist)
set c_list = ($c_list $vaspackt_clist)

#**********************#
#                      #
# set vectors examples #
#                      #
#**********************#
set vectors_fex   = (vvex01 vvex02 vvex03)
set vectors_ftst  = (tvelvc)
set vectors_ffnd  = (ffex00 ffex01 ffex02 ffex05 fcover)
set vectors_flist = ($vectors_fex $vectors_ftst $vectors_ffnd)

set vectors_cex   = (c_vvex03)
set vectors_clist = ($vectors_cex)

set f_list = ($f_list $vectors_flist)
set c_list = ($c_list $vectors_clist)

#*******************#
#                   #
# set wmap examples #
#                   #
#*******************#
set wmap_fex   = (wmex01 wmex02 wmex03 wmex04 wmex05 wmex06 wmex07 wmex08\
                 wmex09 wmex10 wmex11 wmex12 wmex13 wmex14 wmex15 wmex16 \
                 wmex17)
set wmap_flist = ($wmap_fex)

set wmap_cex   = (c_wmex09)
set wmap_clist = ($wmap_cex)

set f_list = ($f_list $wmap_flist)
set c_list = ($c_list $wmap_clist)

#****************************************#
#                                        #
#  Set field flow examples - consists of #
#  all streamlines and vectors examples  #
#                                        #
#****************************************#
set field_fex   = (stex01 stex02 stex03 vvex01 vvex02 vvex03)
set field_ftst  = (tstrml tvelvc)
set field_ffnd  = (fstream ffex00 ffex01 ffex02 ffex03 ffex04 ffex05 fcover)
set field_flist = ($field_fex $field_ftst $field_ffnd)

set field_cex   = (c_vvex03)
set field_cfnd  = (c_ffex03)
set field_clist = ($field_cex $field_cfnd)

#****************************#
#                            #
# set miscellaneous examples #
#                            #
#****************************#
set misc_fex   = (example bnchmk ncargworld)
set misc_flist = ($misc_fex)

set f_list = ($f_list $misc_flist)

#********************#
#                    #
# set class examples #
#                    #
#*******************#
set class_fttr   = (class1 class2 class3)
set class_flist  = ($class_fttr)

set f_list = ($f_list $class_flist)

#*************************************************************#
#                                                             #
# Some of the other examples are considered tutorial examples #
#                                                             #
#*************************************************************#
set overlap_fttr = (mpex03 mpex05 arex01 sfex01 tsoftf)

#****************************************#
#                                        #
# Set lists of various types of examples #
#                                        #
#****************************************#
set list_fx11 = (fgke01 fgke04)
set list_cx11 = (c_xwndws)
set list_fex = ($areas_fex $autograph_fex $colconv_fex $conpack_fex \
		$conpackt_fex $ezmap_fex $field_fex $labelbar_fex $ngmath_fex \
		$plotchar_fex $polypack_fex ${scrlld_title_fex} $softfill_fex \
		$spps_fex $surface_fex $tdpack_fex $wmap_fex $misc_fex \
		$vaspackt_fex)

set list_cex  = ($autograph_cex $colconv_cex $conpack_cex $conpackt_cex \
		$ezmap_cex $field_cex $gks_cex $labelbar_cex $ngmath_cex \
		$plotchar_cex $polypack_cex ${scrlld_title_cex} $softfill_cex \
		$surface_cex $tdpack_cex $wmap_cex $vaspackt_cex)

set list_ftst = ($areas_ftst $autograph_ftst $colconv_ftst $conpack_ftst \
                ${cnrn_family_ftst} ${cnrc_family_ftst} $dashline_ftst \
                $dashpack_ftst $ezmap_ftst $field_ftst $gflash_ftst \
                $gridall_ftst $halftone_ftst $histogram_ftst $isosrfhr_ftst \
                $isosurface_ftst $labelbar_ftst $plotchar_ftst $polypack_ftst \
                $pwrite_ftst ${scrlld_title_ftst} $seter_ftst $softfill_ftst \
                $surface_ftst $tdpack_ftst $threed_ftst)

set list_ctst = ($areas_ctst $dashpack_ctst $gflash_ctst $gridall_ctst \
                $histogram_ctst $isosurface_ctst)

set list_fttr = ($areas_fttr $conpack_fttr $ezmap_fttr $class_fttr)

set list_cttr = ($conpack_cttr)

set list_ffnd = ($autograph_ffnd $colconv_ffnd $dashline_ffnd $field_ffnd \
                $gks_ffnd $gridall_ffnd $isosurface_ffnd $labelbar_ffnd \
                $ngmisc_ffnd $plotchar_ffnd ${scrlld_title_ffnd} \
                $softfill_ffnd $spps_ffnd $surface_ffnd $threed_ffnd)

set list_cfnd = ($dashline_cfnd $field_cfnd $ngmisc_cfnd $spps_cfnd \
                 $threed_cfnd)

set list_fpdc = ($gks_fpdc)
set list_cpdc = ($gks_cpdc)

set list_fps = (pgkex19 pgkex20 pgkex21 pgkex22 pgkex23 wmex12 wmex13 wmex14)
set list_cps = (c_pgkex21)

#****************************************************#
#                                                    #
# Default is to load in the X11 library. If the      #
# user specifies "-noX11" or "-NCGMonly on the       #
# command line, then a stub will be linked instead   #
# of the X11 library                                 #
#                                                    #
#****************************************************#
set X11_option
set ncarbd_flag
set ngmathbd_flag

#*******************************#
#                               #
# Parse options on command line #
#                               #
#*******************************#
set names

#*******************************#
#                               #
# change_ws_type is used to keep#
# track of whether the user     #
# explicitly changed the ws type#
#                               #
#*******************************#
unset change_ws_type
set ws_type      = 1

while ($#argv > 0)

  switch ($1)
    case "-all":
    case "-A":
      shift
      set names=($names $list_fex $list_ftst $list_fttr $list_ffnd $list_fpdc \
                 $list_cex $list_ctst $list_cttr $list_cfnd $list_cpdc)
      breaksw

    case "-c":
    case "-C":
      shift
      set names=($names $c_list)
      breaksw

    case "-fortran":
    case "-Fortran":
      shift
      set names=($names $f_list)
      breaksw

    case "-allexamples":
    case "-E":
      shift
      set names=($names $list_fex $list_cex)
      breaksw

    case "-alltests":
    case "-T":
      shift
      set names=($names $list_ftst $list_ctst)
      breaksw
        
    case "-alltutorial":
    case "-U":
      shift
      set names=($names $list_fttr $overlap_fttr $list_cttr)
      breaksw
        
    case "-allfundamental":
    case "-F":
      shift
      set names=($names $list_ffnd $list_cfnd)
      breaksw
        
    case "-allpdocs":
    case "-P":
      shift
      set names=($names $list_fpdc $list_cpdc)
      breaksw
        
    case "-areas":
      shift
      set names=($names $areas_flist $areas_clist)
      breaksw
        
    case "-autograph":
      shift
      set names=($names $autograph_flist $autograph_clist)
      breaksw

    case "-bivar":
      shift
      set names=($names $cbivar_flist $cbivar_clist)
      breaksw

    case "-colconv":
      shift
      set names=($names $colconv_flist $colconv_clist)
      breaksw

    case "-conpack":
      shift
      set names=($names $conpack_flist $conpack_clist)
      breaksw

    case "-conpackt":
      shift
      set names=($names $conpackt_flist $conpackt_clist)
      breaksw

    case "-conran_family":
      shift
      set names=($names ${cnrn_family_flist})
      breaksw

    case "-conrec_family":
      shift
      set names=($names ${cnrc_family_flist})
      breaksw

    case "-csagrid":
      shift
      set names=($names $csagrid_flist $csagrid_clist)
      breaksw

    case "-cssgrid":
      shift
      set names=($names $cssgrid_flist $cssgrid_clist)
      breaksw

    case "-dashline":
      shift
      set names=($names $dashline_flist $dashline_clist)
      breaksw

    case "-dashpack":
      shift
      set names=($names $dashpack_flist $dashpack_clist)
      breaksw

    case "-dsgrid":
      shift
      set names=($names $dsgrid_flist $dsgrid_clist)
      breaksw

    case "-ezmap":
      shift
      set names=($names $ezmap_flist $ezmap_clist)
      breaksw

    case "-field_flow":
      shift
      set names=($names $field_flist $field_clist)
      breaksw

    case "-fitgrid":
      shift
      set names=($names $fitgrid_flist $fitgrid_clist)
      breaksw

    case "-gflash":
      shift
      set names=($names $gflash_flist $gflash_clist)
      breaksw

    case "-gks":
      shift
      set names=($names $gks_flist $gks_clist)
      breaksw

    case "-gridall":
      shift
      set names=($names $gridall_flist $gridall_clist)
      breaksw

    case "-halftone":
      shift
      set names=($names $halftone_flist)
      breaksw

    case "-histogram":
      shift
      set names=($names $histogram_flist $histogram_clist)
      breaksw

    case "-isosrfhr":
      shift
      set names=($names $isosrfhr_flist)
      breaksw

    case "-isosurface":
      shift
      set names=($names $isosurface_flist $isosurface_clist)
      breaksw

    case "-labelbar":
      shift
      set names=($names $labelbar_flist $labelbar_clist)
      breaksw

    case "-natgrid":
      shift
      set names=($names $natgrid_flist $natgrid_clist)
      breaksw

    case "-ngmath":
      shift
      set names=($names $ngmath_flist $ngmath_clist)
      breaksw

    case "-ngmisc":
      shift
      set names=($names $ngmisc_flist $ngmisc_clist)
      breaksw

    case "-plotchar":
      shift
      set names=($names $plotchar_flist $plotchar_clist)
      breaksw

    case "-polypack":
      shift
      set names=($names $polypack_flist $polypack_clist)
      breaksw

    case "-pwrite_family":
      shift
      set names=($names $pwrite_flist)
      breaksw

    case "-scrolled_title":
      shift
      set names=($names ${scrlld_title_flist} ${scrlld_title_clist})
      breaksw

    case "-seter":
      shift
      set names=($names $seter_flist)
      breaksw

    case "-shgrid":
      shift
      set names=($names $shgrid_flist $shgrid_clist)
      breaksw

    case "-softfill":
      shift
      set names=($names $softfill_flist $softfill_clist)
      breaksw

    case "-spps":
      shift
      set names=($names $spps_flist $spps_clist)
      breaksw

    case "-streamlines":
      shift
      set names=($names $streamlines_flist $streamlines_clist)
      breaksw

    case "-surface":
      shift
      set names=($names $surface_flist $surface_clist)
      breaksw

    case "-tdpack":
      shift
      set names=($names $tdpack_flist $tdpack_clist)
      breaksw

    case "-threed":
      shift
      set names=($names $threed_flist $threed_clist)
      breaksw

    case "-vaspackt":
      shift
      set names=($names $vaspackt_flist $vaspackt_clist)
      breaksw

    case "-vectors":
      shift
      set names=($names $vectors_flist $vectors_clist)
      breaksw

    case "-wmap":
      shift
      set names=($names $wmap_flist $wmap_clist)
      breaksw

    case "-misc":
      shift
      set names=($names $misc_flist)
      breaksw

    case "-class":
      shift
      set names=($names $class_flist)
      breaksw

    case "-ps":
      shift
      set names=($names $list_fps $list_cps)
      breaksw

    case "-x11":
      shift
      set names=($names $list_fx11 $list_cx11)
      breaksw

    case "-clean":
      shift
      set CleanOption
      breaksw

    case "-n":
      shift
      set NoRunOption
      breaksw
        
    case "-onebyone":
      shift
      set OneByOneOption
      breaksw

    case "-unique":
      shift
      set Unique
      breaksw

    case "-W":
    case "-w":
      shift
      set new_ws_type = $1
      if ( !(`expr "$new_ws_type" : '[0-9]'`)) then
#***********************************************#
#                                               #
# The workstation type has been specified as a  #
# string and not a number, so we have to get    #
# the number by parsing the string.             #
#                                               #
# If the workstation is a PostScript file, then #
# it can have three different attributes:  file #
# type, orientation type, and color type.       #
#                                               #
#***********************************************#
        set file_type
        set orient_type
        set color_type
        set str = ("$new_ws_type" "" "")
        set num = 1
#************************#
#                        #
# Parse the string.      #
#                        #
# String can be of form  #
# "xxx", "xxx.yyy", or   #
# "xxx.yyy.zzz"          #
#                        #
#************************#
        if ( `expr "$new_ws_type" : '.*\..*\..*'` ) then
#***********************#
#                       #
# String is xxx.yyy.zzz #
#                       #
#***********************#
          set str[1] = `expr "$new_ws_type" : '\(.*\)\..*\..*'`
          set str[2] = `expr "$new_ws_type" : '.*\.\(.*\)\..*'`
          set str[3] = `expr "$new_ws_type" : '.*\..*\.\(.*\)'`
          set num = 3
        else
          if ( `expr "$new_ws_type" : '.*\..*'` ) then
#*******************#
#                   #
# String is xxx.yyy #
#                   #
#*******************#
            set str[1] = `expr "$new_ws_type" : '\(.*\)\..*'`
            set str[2] = `expr "$new_ws_type" : '.*\.\(.*\)'`
            set num = 2
          endif
        endif
        set i = 1
        while ($i <= $num)
          foreach ftype($file_types)
            if ("$str[$i]" == "$ftype") then
              set file_type = "$str[$i]"
              break
            endif
          end
          foreach otype($orient_types)
            if ("$str[$i]" == "$otype") then
              set orient_type = "$str[$i]"
              break
            endif
          end
          foreach ctype($color_types)
            if ("$str[$i]" == "$ctype") then
              set color_type = "$str[$i]"
              break
            endif
          end
          @ i++
        end
#*********************************************#
#                                             #
# If the workstation type was not specified,  #
# or one of the attributes was not recognized #
# then this is an error.                      #
#                                             #
#*********************************************#
        if ("$file_type" == "" || \
           ($num == 2 && ("$orient_type" == "" && "$color_type" == "")) || \
           ($num == 3 && ("$orient_type" == "" || "$color_type" == ""))) then
          set not_valid
          goto invalid
        endif
        if ("$orient_type" == "") set orient_type = "port"
        if ("$color_type" == "") set color_type = "color"
        set str = "$file_type.$orient_type.$color_type"
#**************************************#
#                                      #
# Find the workstation type associated #
# with the string and assign the       #
# correct workstation number.          #
#                                      #
#**************************************#
        @ i = 1
        unset found
        while ($i <= $#ws_types)
          if ("$str" == "$ws_types[$i]" ) then
            set new_ws_type = "$i"
            set found
            break
          endif
          @ i++
        end
        if (! $?found) then
          set not_valid
          goto invalid
        endif        
      else
        if ("$new_ws_type" < 1 || "$new_ws_type" > $#ws_types ) then
          set not_valid
          goto invalid
        else
          if ("$ws_types[$new_ws_type]" == "" ) then
            set not_valid
            goto invalid
          endif
        endif
      endif
invalid:
      if ($?not_valid) then
          echo ""
          echo "    '$1' is not a valid workstation type."
          echo ""
          exit 1
      endif
      set change_ws_type
      shift
      breaksw

    case "-ncarbd":
      shift
      set ncarbd_flag = "-ncarbd"
      breaksw

    case "-ngmathbd":
      shift
      set ngmathbd_flag = "-ngmathbd"
      breaksw

    case "-noX11":
    case "-nox11":
    case "-NCGMonly":
    case "-ncgmonly":
      shift
      set X11_option = "-noX11"
      breaksw

    case "-list":
      shift
      set List
      breaksw

    case "-*":
      echo "$0 : Unknown option <$1>"
      exit 1
      breaksw

    default:
      set names=($names $1)
      shift
      breaksw
    endsw
end

#***********************************************#
#                                               #
# If you just want to see what list of examples #
# you have asked for, list them and exit.       #
#                                               #
#***********************************************#
if ($?List) then
   echo $names
   exit
endif

#***************************#
#                           #
# Loop through each example #
#                           #
#***************************#
foreach name ($names)

unset tmp_msg
set input
set output

#*************************************#
#                                     #
# Find out what type of example it is #
#                                     #
#*************************************#
set ex_type = "Unknown"

foreach known ($list_fex $list_cex $list_cx11)
  if ("$name" == "$known") then
    set ex_type
    set temp_dir = "$example_dir"
    break
  endif
end

if ( "$ex_type" == "Unknown" ) then
  foreach known ($list_ftst $list_ctst)
    if ("$name" == "$known") then
      set ex_type = "Test"
      set temp_dir = "$test_dir"
      break
    endif
  end
endif

if ( "$ex_type" == "Unknown" ) then
  foreach known ($list_fttr $list_cttr)
    if ("$name" == "$known") then
      set ex_type = "Tutorial"
      set temp_dir = "$tutor_dir"
      break
    endif
  end
endif

if ( "$ex_type" == "Unknown" ) then
  foreach known ($list_ffnd $list_cfnd $list_fx11)
    if ("$name" == "$known") then
      set ex_type = "Fundamentals"
      set temp_dir = "$fund_dir"
      break
    endif
  end
endif

if ( "$ex_type" == "Unknown" ) then
  foreach known ($list_fpdc $list_cpdc)
    if ("$name" == "$known") then
      set ex_type = "Programmer"
      set temp_dir = "$pdoc_dir"
      break
    endif
  end
endif

# 
# There are four types of examples:
# 
#   1. One that creates an NCGM by default, but can be changed
#      via the "-W" option. This is how most examples are currently.
#      They must have an IWTYPE parameter in order for this to work.
# 
#   2. One that creates something other than an NCGM, but can
#      be changed via the "-W" option. Again, IWTYPE must be present.
# 
# Set the "modifiable" for types of both #1 and #2.
#
#   3. One that creates an output file that cannot be changed
#      via the "-W" option.
# 
# Set std_file for types of #1-#3. This just means a "standard"
# file of the form "example_name.xxxx" is created.
#
#   4. One that doesn't create a file of the form example_name.xxx,
#      or creates no file at all.
# 
# Unset "modifiable" for types of both #3 and #4.
# Unset std_file for types of #4.
#
# The variable "orig_ws_type" represents the workstation type.  In most
# cases, this value will be equal to 1 (case #1). If a Fortran example
# has the IWTYPE parameter, and it is set to 1, then leave orig_ws_type
# alone. Otherwise, if IWTYPE exists and is set to something other than
# 1, then set orig_ws_type to this value.
# 
# If the example does not have an IWTYPE parameter, but it supposed to
# create a file of the style example_name.xxx, then unset modifiable,
# but leave std_file set.
# 
# If the example is either not meant to create an output file, or else
# it doesn't create one of the form example_ncgm.xxxx, then unset 
# modifiable AND std_file.
# 

set orig_ws_type = "1"
set modifiable
set std_file

switch($name)
    case pgkex19:
    case pgkex20:
    case pgkex21:
    case pgkex22:
    case pgkex23:
    case c_pgkex21:
      unset modifiable
      set orig_ws_type = "20"
      if ("$name" == "pgkex20") then
        set orig_ws_type = "26"
      endif
      echo ""
      echo "  This example was set up to demonstrate how to use"
      echo "  the Ngmisc routines to define the Postscript output."
      echo ""
    breaksw

    case wmex12:
    case wmex13:
    case wmex14:
      set orig_ws_type = "26"
      if (! $?change_ws_type) then
        echo ""
        echo "  This example was set up to use the entire"
        echo "  page when going to PostScript, so workstation"
        echo "  type 26 is being used."
        echo ""
      endif
    breaksw

    case pgkex26:
    case fgke03:
      unset modifiable
      unset std_file
      echo ""
      echo "  This example was set up to demonstrate how to change"
      echo "  the name of the metafile from within the program."
      echo ""
      set tmp_msg = "Metafiles META01 and META02 produced."
    breaksw

    case pgkex27:
      unset modifiable
      unset std_file
      echo ""
      echo "  This example was set up to demonstrate how to write"
      echo "  to more than one metafile at a time."
      echo ""
      set tmp_msg = "Metafiles gmeta1 and gmeta2 produced."
    breaksw

    case fgke01:
    case fgke04:
      set orig_ws_type = 8
      unset modifiable
      unset std_file
      echo ""
      echo "  This example was set up to demonstrate the X11"
      echo "  driver.  It also generates a graphic file."
      echo ""
      set tmp_msg = "   "
    breaksw

    case nnex08:
    case nnex09:
    case nnex10:
    case mpex12:
      unset modifiable
      unset std_file
      set tmp_msg = "   "
      echo ""
      echo "  This example does not produce a metafile."
      echo ""
    breaksw

    case ccpcff:
    case tcolcv:
    case fcce02:
    case ftex01d:
    case ftex02d:
    case ftex03d:
    case ftex04d:
    case ftex05d:
    case ftex06d:
    case ftex07d:
    case c_ftex01d:
    case c_ftex02d:
    case c_ftex03d:
    case c_ftex04d:
    case c_ftex05d:
    case c_ftex06d:
    case c_ftex07d:
      unset modifiable
      unset std_file
      set tmp_msg = "   "
      echo ""
      echo "  No graphics file will be produced by this example."
      echo ""
    breaksw
endsw

#
# If the user changed the workstation type with the -W option,
# then only use it if this particular example is a modifiable one.
#
if ($?change_ws_type && $?modifiable) then
  set ws_type = $new_ws_type
else
  set ws_type = $orig_ws_type
endif

#******************************************#
#                                          #
# Determine if it's a C or Fortran example #
#                                          #
#******************************************#
unset fprog
unset cprog
if ( `expr "$name" : "c_.*"`) then 
  set cprog
  set prog_type = "C"
  set comp_script = "ncargcc"
else
  set fprog
  set prog_type = "Fortran"
  set comp_script = "ncargf77"
endif

#***************#
#               #
# Echo the type #
#               #
#***************#

if ( "$ex_type" == "Unknown" ) then
  echo ""
  echo "ncargex: <$name> is not a known example"
  echo ""
  goto theend
else
  echo ""
  echo "NCAR Graphics $prog_type $ex_type Example <$name>"
  echo ""
endif

#********************************************#
#                                            #
# "-noX11" only works if going to an NCGM    #
# file.                                      #
#                                            #
#********************************************#
if ("$X11_option" == "-noX11" && "$ws_type" != "1") then
    echo ""
    echo "Warning:  You can only use the '-noX11' option if you are"
    echo "          sending your output to an NCGM file. The '-noX11'"
    echo "          option will be turned off for this example."
    echo ""
    set xoption = ""
else
    set xoption = $X11_option
endif


#***************************************#
#                                       #
# If the workstation type is "8" (X11)  #
# or "10" (text dump) then no file is   #
# created when the example is executed. #
#                                       #
#***************************************#
if ("$ws_type" == "8" || "$ws_type" == "10" ) unset std_file

#**************************************#
#                                      #
# Initialize the name of the default   #
# output file and the name of the file #
# it is going to be renamed to.        #
#                                      #
#**************************************#
set suffix = "$suffix_names[$ws_type]"
set graphic_file = "$name.$suffix"

if ($ws_type == 41) then
  set msg = "cairo PNG files are named $name.xxxxxx.png (xxxxxx is the frame #)"
else
  set msg = "$default_msgs[$ws_type] $graphic_file."
endif
if ($?fprog) then
  set main = "$name.f"
else
  set main = "$name.c"
endif

if ($?tmp_msg) then
  set msg = "$tmp_msg"
endif

if ("$ws_type" == "8") then
  echo ""
  echo "NOTE: This example is being run interactively and can only"
  echo "      be executed if you have X running and have your     "
  echo "      DISPLAY environment variable set properly.  It will "
  echo "      create an X11 window that you must click on with your"
  echo "      mouse to advance the frame(s)."
  echo ""
  set xoption = ""
endif

#**********************************#
#                                  #
# For workstation "10" (text dump) #
# the output goes to stdout        #
#                                  #
#**********************************#
if ("$ws_type" == "10") then
  set output = "$graphic_file"
endif

#***********************************************#
#                                               #
# If the "-unique" option was selected and the  #
# NCGM already exists, don't generate it again. #
#                                               #
#***********************************************#
if ($?Unique && -f $graphic_file) goto theend

#****************************#
#                            #
# Set initial compiler flags #
#                            #
#****************************#
set comp_flags = ($ncarbd_flag $ngmathbd_flag $xoption)

#**********************************#
#                                  #
# Some examples need extra Fortran #
# files, data files, or special    #
# compiler options                 #
#                                  #
#**********************************#
set extra_src_files
set stdin_data_file
set other_data_files

switch ($name)
    case agex13:
	set stdin_data_file = (agda13.dat)
    breaksw

    case ccpcica:
    case ccpcir:
    case ccpcnrc:
    case ccpezct:
    case ccphl:
    case ccpmap:
    case ccpmovi:
    case ccpvp:
        set extra_src_files = (ggdini.f)
    breaksw

    case ccpila:
    case ccpt2d:
	set stdin_data_file = (ccpila.dat)
    breaksw

    case ccpils:
    case ccpilt:
    case ccplbdr:
    case ccptitle:
	set stdin_data_file = (ccpex.dat)
    breaksw

    case ccpmpxy:
	set stdin_data_file = (cpmpxy1.dat)
    breaksw

    case class1:
	set stdin_data_file = (class1.dat)
    breaksw

    case cpex01:
    case cpex02:
    case cpex03:
    case cpex04:
    case cpex05:
    case cpex06:
    case cpex07:
    case cpex08:
    case cpex09:
        set extra_src_files = (cpexcc.f)
    breaksw

    case cpex14:
	set other_data_files = (cpex14.dat)
    breaksw

    case cpex16:
	set other_data_files = (cpex16.dat)
    breaksw

    case ctcbay:
	set other_data_files = (ctcbay.dat)
    breaksw

    case ctfite:
	set other_data_files = (ctfite.dat)
    breaksw

    case ctgaus:
	set other_data_files = (ctgaus.dat)
    breaksw

    case ctgeo3:
    case ctgc23:
	set other_data_files = (ctgeo3.dat)
    breaksw

    case ctiscp:
    case ctisc2:
	set other_data_files = (ctiscp.dat)
    breaksw

    case ctnccl:
	set other_data_files = (ctnccl.dat)
    breaksw

    case ctorca:
	set other_data_files = (ctorca.dat)
    breaksw

    case ctpopg:
	set other_data_files = (ctpopg.dat)
    breaksw

    case ctswth:
	set other_data_files = (ctswth.dat)
    breaksw

    case ctterr:
	set other_data_files = (ctterr.dat)
    breaksw

    case ctwng1:
	set other_data_files = (ctwng1.dat)
    breaksw

    case ctwng2:
	set other_data_files = (ctwng2.dat)
    breaksw

    case fcover:
	set stdin_data_file = (fcover.dat)
    breaksw

    case ffex02:
    case ffex03:
    case c_ffex03:
	set stdin_data_file = (ffex02.dat)
    breaksw

    case ffex05:
	set stdin_data_file = (ffex05.dat)
    breaksw

    case mpex01:
    case mpex02:
    case mpex03:
    case mpex04:
    case mpex05:
    case mpex06:
    case mpex07:
    case mpex08:
    case mpex09:
    case mpex10:
        set extra_src_files = (mpexcc.f)
    breaksw

    case mpex15:
	set other_data_files = (Europe.png Europe.pngi)
        set comp_flags = ($comp_flags "-lpng -lz")
    breaksw

    case mpexfi:
	set stdin_data_file = (mpexfi.dat)
        set extra_src_files = (mpexcc.f)
    breaksw

    case srex01:
    case c_srex01:
	set stdin_data_file = (srex01.dat)
    breaksw

    case csex01:
    case csex02:
    case csex03:
    case csex04:
    case csex05:
    case csex06:
    case csex07:
    case cssex01:
    case cssex02:
    case cssex03:
    case dsex01:
    case dsex01d:
    case dsex02:
    case dsex03:
    case dsex04:
    case dsex05:
    case dsex06:
    case ftex01:
    case ftex02:
    case ftex03:
    case ftex04:
    case ftex05:
    case ftex06:
    case ftex07:
    case ftex01d:
    case ftex02d:
    case ftex03d:
    case ftex04d:
    case ftex05d:
    case ftex06d:
    case ftex07d:
    case shex01:
    case shex02:
    case shex03:
    case wmex01:
    case wmex02:
    case wmex03:
    case wmex04:
    case wmex13:
    case wmex14:
    case c_csex01:
    case c_csex02:
    case c_csex03:
    case c_csex04:
    case c_csex05:
    case c_csex06:
    case c_csex07:
    case c_cssex01:
    case c_cssex02:
    case c_cssex03:
    case c_dsex01:
    case c_dsex01d:
    case c_dsex02:
    case c_dsex03:
    case c_dsex04:
    case c_dsex05:
    case c_dsex06:
    case c_ftex01:
    case c_ftex02:
    case c_ftex03:
    case c_ftex04:
    case c_ftex05:
    case c_ftex06:
    case c_ftex07:
    case c_ftex01d:
    case c_ftex02d:
    case c_ftex03d:
    case c_ftex04d:
    case c_ftex05d:
    case c_ftex06d:
    case c_ftex07d:
    case c_shex01:
    case c_shex02:
    case c_shex03
       set comp_flags = ($comp_flags "-ngmath")
    breaksw

    case nnex01:
    case nnex02:
    case nnex03:
    case nnex04:
    case nnex05:
    case nnex06:
    case nnex07:
    case nnex08:
    case nnex09:
    case nnex10:
    case nnex01d:
        set extra_src_files = (nnplotf.f)
        set comp_flags = ($comp_flags "-ngmath")
    breaksw

    case c_nnex01:
    case c_nnex02:
    case c_nnex03:
    case c_nnex04:
    case c_nnex06:
    case c_nnex01d:
        set extra_src_files = (nnplotc.c)
        set comp_flags = ($comp_flags "-ngmath")
    breaksw

#************************************************#           
#                                                #
# autograph with pwritx for character generation #
#                                                #
#************************************************#           
    case tagupw:
        set comp_flags = ($comp_flags "-agupwrtx")
    breaksw

#***************************#           
#                           #
# smooth routines (default) #
#                           #
#***************************#           
    case tdashs:
    case tcnsmt:
    case tconan:
        set comp_flags = ($comp_flags "-smooth")
    breaksw
#****************#           
#                #
# quick routines #
#                #
#****************#           
    case tdashl:
    case tcnqck:
    case tconaq:
        set comp_flags = ($comp_flags "-quick")
    breaksw
#****************#
#                #
# super routines #
#                #
#****************#
    case tdashp:
    case tcnsup:
    case tconas:
    case fdlsmth:
        set comp_flags = ($comp_flags "-super")
    breaksw

    case vvex01:
    case vvex02:
        set extra_src_files = (vvexcc.f)
    breaksw
endsw

#**********************************#
#                                  #
# Check if this particular example #
# needs a data file on "stdin"     #
#                                  #
#**********************************#
if ("$stdin_data_file" != "") then
  set input = "$stdin_data_file"
endif

#******************************#
#                              #
# Modify the main program to   #
# give it the workstation type #
#                              #
#******************************#

echo "  Copying $main"
echo ""
cp $temp_dir/$main ./$main
if ($?fprog && $?change_ws_type && $?modifiable) then
if($orig_ws_type != $ws_type) then
ed << EOF - ./$main >& /dev/null
g/^ *PARAMETER/s/IWTYPE=[0-9][0-9]*/IWTYPE=$ws_type/g
.
w
q
endif
endif

if ($?cprog && $?change_ws_type && $?modifiable) then
if($orig_ws_type != $ws_type) then
ed << EOF - ./$main >& /dev/null
/define IWTYPE
c
#define IWTYPE $ws_type
.
w
q
EOF
endif
endif

set src_files = ($extra_src_files $main)

#***********************#
#                       #
# Copy the needed files #
#                       #
#***********************#
   
set copy_files = ($extra_src_files $stdin_data_file $other_data_files)

foreach file($copy_files)
    echo "  Copying $file"
    echo ""
    cp $temp_dir/$file .
end

#******************************#
#                              #
# Compile and link the example #
#                              #
#******************************#
   
if (! $?NoRunOption) then
    echo "Compiling and linking..."
    $comp_script $comp_flags -o $name $src_files
    if ($status != 0) then
        echo ""
        echo "The compile and link failed."
        echo ""
        exit
    endif
#*****************#
#                 #
# Run the example #
#                 #
#*****************#
    set rename_option = "-o $graphic_file"
    if (! $?std_file) set rename_option
    echo ""
    echo "Executing <$name>..."

    if ("$input" != "" ) then
      if ("$output" != "") then
        ncargrun $rename_option ./$name < $input > $output
      else 
        ncargrun $rename_option ./$name < $input
      endif
    else
      if ("$output" != "") then
        ncargrun $rename_option ./$name > $output
      else 
        ncargrun $rename_option ./$name
      endif
    endif
    if ($status != 0) then
        echo ""
        echo "The execution of ./$name failed"
        echo ""
        exit
    endif
    echo ""
    echo "$msg"
    echo ""
endif

#*******************************************#
#                                           #
# Remove files created after the execution. #
#                                           #
#*******************************************#
switch ($name)
    case slex02:
	set other_data_files = ($other_data_files slex02.input)
    breaksw
endsw


#***********************#
#                       #
# Remove unwanted files #
#                       #
#***********************#
set rmfiles = ($stdin_data_file $other_data_files $src_files $nameSED_EXE_SUFFIX)
foreach file($src_files)
  set obj_file = {$file:r}.o
  set rmfiles = ($rmfiles $obj_file)
end

if ($?CleanOption) /bin/rm $rmfiles >& /dev/null

#************************#
#                        #
# Display NCGM on screen #
# as it is generated     #
#                        #
#************************#
if ($?OneByOneOption) then
  if ( -f $graphic_file) then
    if ("$suffix" == "ncgm") then
      ctrans -d X11 -geometry 1142x865+10+0 $graphic_file
    else if ("$suffix" == "ps" || "$suffix" == "eps" || \
             "$suffix" == "epsi" ) then
      gs $graphic_file
    endif
    /bin/rm -f $graphic_file $rmfiles >& /dev/null
  endif
endif

theend:

end

exit

usage:
#*************************#
#                         #
# ncargex usage statement #
#                         #
#*************************#
echo "usage: ncargex [options] [example names]"
echo ""
echo " Options:"
echo ""
echo " To invoke various classes of examples:"
echo "   [-A] [-E] [-F] [-P] [-T] [-U] [-ngmath] [-class] [-ps] [-x11]"
echo ""
echo " To invoke various utilities:"
echo "   [-areas] [-autograph] [-bivar] [-colconv] [-conpack]     "
echo "   [-conpackt] [-conran_family] [-conrec_family] [-csagrid] "
echo "   [-cssgrid] [-dashline] [-dashpack] [-dsgrid] [-ezmap]    "
echo "   [-field_flow] [-fitgrid] [-gflash] [-gks] [-gridall]     "
echo "   [-halftone] [-histogram] [-isosrfhr] [-isosurface]       "
echo "   [-labelbar] [-natgrid] [-ngmisc] [-plotchar]             "
echo "   [-polypack] [-pwrite_family] [-scrolled_title]           "
echo "   [-seter] [-shgrid] [-softfill] [-spps] [-streamlines]    "
echo "   [-surface] [-threed] [-vaspackt][-vectors] [-wmap]       "
echo "   [-misc]                                                  "
echo ""
echo " Other options:"
echo "   [-W workstation_type] [-n] [-clean] [-onebyone] names"
echo ""
echo "See <man ncargex> for explanation of options." 
echo ""
exit

#!/bin/csh -f
#
#   $Id: ng4ex.csh,v 1.15 2010-04-02 17:29:43 haley Exp $
#
#######################################################################
#                                                                     #
#              Copyright (C)  1995                                    #
#        University Corporation for Atmospheric Research              #
#              All Rights Reserved                                    #
#                                                                     #
#######################################################################
#
#   File:       Jeff Boote (and modified by Mary Haley)
#
#   Author:     
#           National Center for Atmospheric Research
#           PO 3000, Boulder, Colorado
#
#   Date:       Sun Jan 29 19:31:56 MST 1995
#
#   Description:    "ng4ex" provides the user with access to several
#                   C, Fortran, and NCL examples illustrating the use
#                   of the NCAR Graphics HLUs (High Level Utilities)
#                   and NCL.
# 
# The current "objects" that "ng4ex" demonstrates include the following:
# 
#     object name           abbrev. name
#     -----------           ------------
#     app                       ap
#     basic                     basic
#     contourplot               cn
#     labelbar                  lb
#     legend                    lg
#     primitives                pr
#     mapplot                   mp
#     ngmath                    nm
#     textitem                  tx
#     tickmark                  tm
#     title                     ti
#     streamlineplot            st
#     vectorplot                vc
#     xyplot                    xy
#
#     GSUN examples             gsun
#
#     NCL User Guide examples   nug   ( added in NCL V6.4.0 )
#
# How to add an example to this script:
#
#   First add it to appropriate variable below (c_xyplot, f_vector,
#   n_textitem, etc.).
#
#   If it is one of the "special" examples, then you'll also need to
#   add it to one or more of the following variables:
#
#    anno_list:  Annotation example
#    gui_list:   GUI example
#    cdf_list:   Reads or writes a netCDF file
#    x_list:     An example that always creates an X window (this
#                list was created so that if a user runs "ng4ex -W ncgm"
#                it won't try to generate examples that will always 
#                produce an X11 window).  GUI examples should be included
#                in this list.
#

#***********************#
#                       #
# ng4ex usage statement #
#                       #
#***********************#
if ($#argv < 1) then
  echo "usage: ng4ex [options] [example names]"
  echo ""
  echo " Options:"
  echo ""
  echo "   [-list] [-n] [-clean]"
  echo ""
  echo "   To invoke various types of examples:"
  echo "   [-A] [-C] [-Fortran] [-NCL] [-cdf] [-gui] [-app] [-basic] [-nug] [-gsun]"
  echo ""
  echo "   To invoke various types of objects:"
  echo "   [-contourplot] [-labelbar] [-legend] [-mapplot] [-ngmath]"
  echo "   [-primitives] [-streamlineplot] [-textitem] [-tickmark]"
  echo "   [-title] [-vectorplot] [-xyplot]"
  echo ""
  echo "See <man ng4ex> for explanation of options." 
  echo ""
  exit
endif

#*********************************************#
#                                             #
# Make sure NCARG_ROOT is set for this script #
#                                             #
#*********************************************#
setenv NCARG_ROOT  `ncargpath root`
if ($status != 0) then
  exit 1
endif

#*********************************#
#                                 #
# Get directory names for various #
# examples and files.             #
#                                 #
#*********************************#

set hluex_dir = "`ncargpath SED_HLUEXDIR`"
set nclex_dir = "`ncargpath SED_NCLEXDIR`"
set res_dir   = "`ncargpath SED_RESDIR`"

if (! -d "$res_dir") then
  echo "Resource directory <$res_dir> does not exist."
  exit 1
endif

set data_dir="`ncargpath SED_DATADIR`"
if (! -d "$data_dir") then
  echo "Data directory <$data_dir> does not exist."
  exit 1
endif

#**********************#
#                      #
# Initialize directory #
# names for objects    #
#                      #
#**********************#
set dir_ap = "app"
set dir_basic = "basic"
set dir_cn = "contourplot"
set dir_lb = "labelbar"
set dir_lg = "legend"
set dir_pr = "primitives"
set dir_mp = "mapplot"
set dir_nm = "ngmath"
set dir_st = "streamlineplot"
set dir_tx = "textitem"
set dir_tm = "tickmark"
set dir_ti = "title"
set dir_vc = "vectorplot"
set dir_xy = "xyplot"
set dir_nug = "nug"
set dir_gsun = "gsun"

#******************#
#                  #
# Initialize lists #
#                  #
#******************#
set c_list
set f_list
set n_list

#***************************************#
#                                       #
# Will hold list of Annotation examples #
#                                       #
#***************************************#
set anno_list

#********************************#
#                                #
# Will hold list of GUI examples #
#                                #
#********************************#
set gui_list

#***********************************#
#                                   #
# Will hold list of netCDF examples #
#                                   #
#***********************************#
set cdf_list

#********************************************************#
#                                                        #
# Keep track of examples that will *always* produce an X #
# window, (these examples we don't want to generate if   #
# the "-W ncgm" option is specified.                     #
#                                                        #
#********************************************************#
set x_list

#********************#
#                    #
#  Set App examples  #
#                    #
#********************#
set f_app   = (ap01f)
set c_app   = (ap01c)
set n_app   = (ap01n)
set app_list = ($c_app $f_app $n_app)
set c_list = ($c_list $c_app)
set f_list = ($f_list $f_app)
set n_list = ($n_list $n_app)

#**********************#
#                      #
#  Set Basic examples  #
#                      #
#**********************#
set c_basic   = (basic01c basic02c basic03c basic04c basic05c basic06c \
                 basic07c basic08c basic09c)
set f_basic   = (basic01f basic02f basic03f basic04f basic05f basic06f \
                 basic07f basic08f basic09f)
set n_basic   = (basic01n basic02n basic03n basic04n basic05n basic06n \
                 basic07n basic08n basic09n)
set basic_list = ($c_basic $f_basic $n_basic)
set c_list = ($c_list $c_basic)
set f_list = ($f_list $f_basic)
set n_list = ($n_list $n_basic)
set x_list = ($x_list basic03c basic03f basic03n basic04c basic04f basic04n \
              basic07c basic07f basic07n)


#*************************#
#                         #
#  Set Contour examples   #
#                         #
#*************************#
set c_contour  = (cn01c cn02c cn03c cn04c cn05c cn06c cn07c cn08c cn09c cn10c \
                  cn11c cn12c cn13c cn14c cn15c cn16c cn17c)
set f_contour  = (cn01f cn02f cn03f cn04f cn05f cn06f cn07f cn08f cn09f cn10f \
                  cn11f cn12f cn13f cn14f cn15f cn16f cn17f)
set n_contour  = (cn01n cn02n cn03n cn04n cn05n cn06n cn07n cn08n cn09n cn10n \
                  cn12n cn13n cn14n cn15n cn16n cn17n)
set contour_list = ($c_contour $f_contour $n_contour)
set c_list = ($c_list $c_contour)
set f_list = ($f_list $f_contour)
set n_list = ($n_list $n_contour)
set anno_list = ($anno_list cn17c cn17f cn17n)
set cdf_list = ($cdf_list cn05c cn06c cn07c cn08c cn09c cn10c cn14c cn15c cn16c cn05f cn06f cn07f cn08f cn09f cn10f cn14f cn15f cn16f cn05n cn06n cn07n cn08n cn09n cn10n cn14n cn15n cn16n cn17n)

#*************************#
#                         #
#  Set LabelBar examples  #
#                         #
#*************************#
set c_labelbar = (lb01c lb02c)
set f_labelbar = (lb01f lb02f)
set n_labelbar = (lb01n lb02n)
set labelbar_list = ($c_labelbar $f_labelbar $n_labelbar)
set c_list = ($c_list $c_labelbar)
set f_list = ($f_list $f_labelbar)
set n_list = ($n_list $n_labelbar)

#***********************#
#                       #
#  Set Legend examples  #
#                       #
#***********************#
set c_legend = (lg01c lg02c lg03c)
set f_legend = (lg01f lg02f lg03f)
set n_legend = (lg01n lg02n lg03n)
set legend_list = ($c_legend $f_legend $n_legend)
set c_list = ($c_list $c_legend)
set f_list = ($f_list $f_legend)
set n_list = ($n_list $n_legend)

#*************************#
#                         #
#  Set Primitive examples #
#                         #
#*************************#
set c_prim   = (pr01c pr02c pr03c pr04c pr05c)
set f_prim   = (pr01f pr02f pr03f pr04f pr05f)
set n_prim   = (pr01n pr02n pr03n pr04n pr05n)
set prim_list = ($c_prim $f_prim $n_prim)
set c_list = ($c_list $c_prim)
set f_list = ($f_list $f_prim)
set n_list = ($n_list $n_prim)

#************************#
#                        #
#  Set MapPlot examples  #
#                        #
#************************#
set c_mapplot   = (mp01c mp02c mp03c mp04c mp05c mp06c mp07c)
set f_mapplot   = (mp01f mp02f mp03f mp04f mp05f mp06f mp07f)
set n_mapplot   = (mp01n mp02n mp03n mp04n mp05n mp06n mp07n)
set mapplot_list = ($c_mapplot $f_mapplot $n_mapplot)
set c_list = ($c_list $c_mapplot)
set f_list = ($f_list $f_mapplot)
set n_list = ($n_list $n_mapplot)
set anno_list = ($anno_list mp04c mp04f mp04n)

#***********************#
#                       #
#  Set Ngmath examples  #
#                       #
#***********************#

set c_natgrid = (nm01c nm02c nm03c)
set c_dsgrid  = (nm04c nm05c nm06c)

set f_natgrid = (nm01f nm02f nm03f)
set f_dsgrid  = (nm04f nm05f nm06f)

set n_csagrid = (nm13n nm14n nm15n nm16n nm17n nm18n nm19n)
set n_cssgrid = (nm20n nm21n)
set n_dsgrid  = (nm04n nm05n nm06n)
set n_fitgrid = (nm07n nm08n nm09n nm10n nm11n nm12n)
set n_natgrid = (nm01n nm02n nm03n)
set n_shgrid  = (nm22n)

set c_ngmath = ($c_natgrid $c_dsgrid)
set f_ngmath = ($f_natgrid $f_dsgrid)
set n_ngmath = ($n_natgrid $n_dsgrid $n_fitgrid $n_csagrid $n_cssgrid \
                $n_shgrid)

set csagrid_list = ($n_csagrid)
set cssgrid_list = ($n_cssgrid)
set dsgrid_list  = ($c_dsgrid $f_dsgrid $n_dsgrid)
set fitgrid_list = ($n_fitgrid)
set natgrid_list = ($c_natgrid $f_natgrid $n_natgrid)
set shgrid_list  = ($n_shgrid)

set ngmath_list  = ($c_ngmath $f_ngmath $n_ngmath)
set c_list = ($c_list $c_ngmath)
set f_list = ($f_list $f_ngmath)
set n_list = ($n_list $n_ngmath)

#*******************************#
#                               #
#  Set Streamlineplot examples  #
#                               #
#*******************************#
set c_stream  = (st01c st02c st03c st04c)
set f_stream  = (st01f st02f st03f st04f)
set n_stream  = (st01n st02n st03n st04n)
set stream_list = ($c_stream $f_stream $n_stream)
set c_list = ($c_list $c_stream)
set n_list = ($n_list $n_stream)
set f_list = ($f_list $f_stream)
set cdf_list = ($cdf_list st03c st03f st03n st04c st04f st04n)

#*************************#
#                         #
#  Set TextItem examples  #
#                         #
#*************************#
set c_textitem = (tx01c tx02c tx03c tx04c tx05c tx06c tx07c tx08c)
set f_textitem = (tx01f tx02f tx03f tx04f tx05f tx06f tx07f tx08f)
set n_textitem = (tx01n tx02n tx03n tx04n tx05n tx06n tx07n tx08n)
set textitem_list  = ($c_textitem $f_textitem $n_textitem)
set c_list = ($c_list $c_textitem)
set f_list = ($f_list $f_textitem)
set n_list = ($n_list $n_textitem)

#***********************#
#                       #
# set TickMark examples #
#                       #
#***********************#
set c_tickmark = (tm01c tm02c tm03c)
set f_tickmark = (tm01f tm02f tm03f)
set n_tickmark = (tm01n tm02n tm03n tm04n)
set tickmark_list  = ($c_tickmark $f_tickmark $n_tickmark)
set c_list = ($c_list $c_tickmark)
set f_list = ($f_list $f_tickmark)
set n_list = ($n_list $n_tickmark)

#**********************#
#                      #
#  Set Title examples  #
#                      #
#**********************#
set c_title = (ti01c ti02c ti03c)
set f_title = (ti01f ti02f ti03f)
set n_title = (ti01n ti02n ti03n)
set title_list  = ($c_title $f_title $n_title)
set c_list = ($c_list $c_title)
set f_list = ($f_list $f_title)
set n_list = ($n_list $n_title)

#***************************#
#                           #
#  Set Vectorplot examples  #
#                           #
#***************************#
set c_vector  = (vc01c vc02c vc03c vc04c vc05c vc06c vc07c vc08c vc09c)
set f_vector  = (vc01f vc02f vc03f vc04f vc05f vc06f vc07f vc08f vc09f)
set n_vector  = (vc01n vc02n vc03n vc04n vc05n vc06n vc07n vc08n vc09n)
set vector_list = ($c_vector $f_vector $n_vector)
set c_list = ($c_list $c_vector)
set f_list = ($f_list $f_vector)
set n_list = ($n_list $n_vector)
set cdf_list = ($cdf_list vc06c vc06f vc06n vc08c vc08f vc08n vc09c vc09f vc09n)

#***********************#
#                       #
#  Set XYPlot examples  #
#                       #
#***********************#
set c_xyplot  = (xy01c xy02c xy03c xy04c xy05c xy06c xy07c xy08c xy09c \
                 xy10c xy11c xy12c xy13c xy14c xy15c xy16c xy17c)
set f_xyplot  = (xy01f xy02f xy03f xy04f xy05f xy06f xy07f xy08f xy09f xy10f \
                 xy11f xy14f xy15f xy16f xy17f)
set n_xyplot  = (xy01n xy02n xy03n xy04n xy05n xy06n xy07n xy08n xy09n xy10n \
                 xy11n xy14n xy15n xy16n xy17n)
set xyplot_list = ($c_xyplot $f_xyplot $n_xyplot)
set c_list = ($c_list $c_xyplot)
set f_list = ($f_list $f_xyplot)
set n_list = ($n_list $n_xyplot)
set gui_list = ($gui_list xy12c xy13c)
set cdf_list = ($cdf_list xy06c xy10c xy06f xy10f xy06n xy10n)
set x_list = ($x_list xy11c xy11f xy11n xy12c xy13c)


#*********************#
#                     #
#  Set NUG examples   #
#                     #
#*********************#
set n_nug  = (NUG_GrADS_binary_data NUG_ICON_triangles_colored \
              NUG_axis_annotations NUG_bar_chart \
              NUG_bar_chart_col_above_below NUG_bar_chart_multi \
              NUG_bipolar_grid_MPI-ESM \
              NUG_bipolar_grid_MPI-ESM_subregion \
              NUG_color_Land_Ocean NUG_color_country_user \
              NUG_colormaps NUG_contour_dashpattern \
              NUG_contour_filled_map NUG_contour_fillpattern \
              NUG_contour_labels NUG_contour_map \
              NUG_contour_map_add_zonal_average \
              NUG_curvilinear_basic NUG_curvilinear_grid \
              NUG_date_format NUG_function_procedure \
              NUG_globe_orography_grid_resolution \
              NUG_grid_resolution_comparison \
              NUG_histograms-transparent NUG_histograms \
              NUG_insert_logo NUG_labelbar_title \
              NUG_labelbars NUG_legends NUG_map_countries \
              NUG_map_default NUG_map_grid_and_tickmark_settings \
              NUG_map_land_ocean_settings NUG_map_resolutions \
              NUG_map_selected_countries NUG_map_settings \
              NUG_masking NUG_multi_timeseries \
              NUG_multiple_plots_along_y NUG_panel_plot_3x2 \
              NUG_panel_control NUG_panel_plot NUG_panel_vp \
              NUG_plot_in_5_steps NUG_plot_rotated_grid \
              NUG_polar_NH NUG_polyline_polygon_polymarker \
              NUG_primitives \
              NUG_projections NUG_projections_mollweide \
              NUG_projections_robinson NUG_read_ASCII_1 \
              NUG_read_ASCII_2 NUG_read_ASCII_3 \
              NUG_read_Binary_1 NUG_read_Binary_GrADS \
              NUG_read_CSV_1 NUG_read_CSV_2 \
              NUG_regrid_bilinear_CMIP5_grid_to_1x1deg_grid \
              NUG_regrid_curvilinear_to_rectilinear_bilinear_weights_ESMF \
              NUG_regrid_curvilinear_to_rectilinear_bilinear_wgts_destgrid_ESMF \
              NUG_regrid_rectilinear_to_curvilinear_bilinear_wgts_destgrid_ESMF \
              NUG_regrid_unstructured_to_rectilinear_bilinear_wgts_ESMF \
              NUG_regrid_unstructured_to_rectilinear_bilinear_wgts_destgrid_ESMF \
              NUG_shapefile_plot NUG_shapefile_plot_data \
              NUG_slice_plot NUG_statistics_linear_regression \
              NUG_statistics_running_mean NUG_strings \
              NUG_system_calls NUG_template_script \
              NUG_text_settings NUG_title_strings \
              NUG_transparent_filled_contour \
              NUG_transparent_land_sea_mask_Africa \
              NUG_triangular_grid_ICON NUG_triangular_grid_ICON_640 \
              NUG_tripolar_grid_STORM \
              NUG_unstructured_grid NUG_unstructured_grid_640 \
              NUG_unstructured_grid_ICON \
              NUG_use_Fortran_subroutines NUG_vector_curly \
              NUG_vector_default NUG_vector_plot_colorized \
              NUG_vector_plot_overlay NUG_wind_mag \
              NUG_write_ASCII_1 NUG_write_ASCII_2 \
              NUG_write_ASCII_3 NUG_write_ASCII_4 \
              NUG_write_ASCII_5 NUG_write_Binary_1 \
              NUG_write_Binary_2 NUG_write_netCDF_1 \
              NUG_write_netCDF_2 NUG_xy_plot NUG_xy_plot_res \
              NUG_xy_plot_timeseries NUG_xy_plot_timeseries_2 \
              )
set nug_list = ($n_nug)

#*********************#
#                     #
#  Set GSUN examples  #
#                     #
#*********************#
set n_gsun  = (gsun01n gsun02n gsun03n gsun04n gsun05n gsun06n gsun07n \
               gsun08n gsun09n gsun10n gsun11n)
set gsun_list = ($n_gsun)
set n_list = ($n_list $n_gsun)
set cdf_list = ($cdf_list gsun02n gsun03n gsun04n gsun05n gsun06n gsun09n)
set x_list = ($x_list gsun01n gsun02n gsun03n gsun04n gsun05n gsun06n gsun07n \
              gsun08n gsun10n gsun11n)

#*******************************#
#                               #
# Parse options on command line #
#                               #
#*******************************#
set names
unset NCGM
unset X11
unset PS
unset PDF
unset OLDPS
unset PNG
unset OLDPDF

set ncarbd_flag
set ngmathbd_flag
set num_set = 0

set ws_type = "x11"

while ($#argv > 0)

  switch ($1)
    case "-all":
    case "-A":
      shift
      set names=($names $c_list $f_list $n_list)
      breaksw

    case "-fortran":
    case "-Fortran":
      shift
      set names=($names $f_list)
      breaksw
        
    case "-C":
    case "-c":
      shift
      set names=($names $c_list)
      breaksw
        
    case "-NCL":
    case "-ncl":
      shift
      set names=($names $n_list)
      breaksw
        
    case "-GUI":
    case "-gui":
      shift
      set names=($names $gui_list)
      breaksw
        
    case "-anno":
    case "-annotation":
    case "-ANNOTATION":
      shift
      set names=($names $anno_list)
      breaksw
        
    case "-CDF":
    case "-cdf":
      shift
      set names=($names $cdf_list)
      breaksw
        
    case "-unique":
      shift
      set Unique
      breaksw

    case "-W":
      shift
      set change_ws_type
      set ws_type = $1
      if ("$ws_type" == "NCGM" || "$ws_type" == "ncgm") then
        set NCGM
        @ num_set += 1
      else if ("$ws_type" == "X11" || "$ws_type" == "x11") then
        set X11
        @ num_set += 1
      else if ("$ws_type" == "OLDPS" || "$ws_type" == "oldps") then
        set OLDPS
        @ num_set += 1
      else if ("$ws_type" == "oldpdf" || "$ws_type" == "OLDPDF") then
        set OLDPDF
        @ num_set += 1
      else if ("$ws_type" == "ps" || "$ws_type" == "PS") then
        set PS
        @ num_set += 1
      else if ("$ws_type" == "png"    || "$ws_type" == "PNG") then
        set PNG
        @ num_set += 1
      else if ("$ws_type" == "pdf" || "$ws_type" == "PDF") then
        set PDF
        @ num_set += 1
      else
        echo ""
        echo "    '$ws_type' is not a valid workstation type."
        echo ""
        exit 1
      endif
      if ($num_set > 1) then
        echo ""
        echo "    Cannot specify more than one workstation type."
        echo ""
        exit 1
      endif
      shift
      breaksw
        
    case "-ncarbd":
      shift
      set ncarbd_flag = "-ncarbd"
      breaksw

    case "-ngmathbd":
      shift
      set ngmathbd_flag = "-ngmathbd"
      breaksw

    case "-app":
      shift
      set names=($names $app_list)
      breaksw
        
    case "-basic":
      shift
      set names=($names $basic_list)
      breaksw
        
    case "-contourplot":
    case "-ContourPlot":
      shift
      set names=($names $contour_list)
      breaksw
        
    case "-csagrid":
    case "-Csagrid":
      shift
      set names=($names $csagrid_list)
      breaksw

    case "-cssgrid":
    case "-Cssgrid":
      shift
      set names=($names $cssgrid_list)
      breaksw

    case "-dsgrid":
    case "-Dsgrid":
      shift
      set names=($names $dsgrid_list)
      breaksw

    case "-fitgrid":
    case "-Fitgrid":
      shift
      set names=($names $fitgrid_list)
      breaksw

    case "-labelbar":
    case "-LabelBar":
      shift
      set names=($names $labelbar_list)
      breaksw

    case "-Legend":
    case "-legend":
      shift
      set names=($names $legend_list)
      breaksw

    case "-natgrid":
    case "-Natgrid":
      shift
      set names=($names $natgrid_list)
      breaksw

    case "-primitives":
    case "-Primitives":
      shift
      set names=($names $prim_list)
      breaksw

    case "-mapplot":
    case "-MapPlot":
      shift
      set names=($names $mapplot_list)
      breaksw

    case "-ngmath":
    case "-NgMath":
    case "-Ngmath":
      shift
      set names=($names $ngmath_list)
      breaksw

    case "-shgrid":
    case "-Shgrid":
      shift
      set names=($names $shgrid_list)
      breaksw

    case "-streamlineplot":
    case "-StreamlinePlot":
      shift
      set names=($names $stream_list)
      breaksw

    case "-textitem":
    case "-TextItem":
      shift
      set names=($names $textitem_list)
      breaksw

    case "-tickmark":
    case "-TickMark":
      shift
      set names=($names $tickmark_list)
      breaksw

    case "-title":
    case "-Title":
      shift
      set names=($names $title_list)
      breaksw

    case "-vectorplot":
    case "-VectorPlot":
      shift
      set names=($names $vector_list)
      breaksw

    case "-xyplot":
    case "-XyPlot":
      shift
      set names=($names $xyplot_list)
      breaksw

    case "-gsun":
    case "-GSUN":
      shift
      set names=($names $gsun_list)
      breaksw

    case "-nug":
    case "-NUG":
      shift
      set names=($names $nug_list)
      breaksw

    case "-clean":
      shift
      set CleanOption
      breaksw

    case "-n":
      shift
      set NoRunOption
      breaksw
        
    case "-list":
      shift
      set List
      breaksw

    case "-*":
      echo "$0 : Unknown option <$1>"
      exit 1
      breaksw

    default:
      set ex_name = $1:r
      set names=($names $ex_name)
      shift
      breaksw
    endsw
end

#***********************************************#
#                                               #
# If you just want to see what list of examples #
# you have asked for, list them and exit.       #
#                                               #
#***********************************************#
if ($?List) then
   echo $names
   exit
endif

#***************************#
#                           #
# Loop through each example #
#                           #
#***************************#
foreach name ($names)

#**************************************************#
#                                                  #
# If the "-unique" option was selected and the     #
# NCGM/PS/PDF already exists, don't generate       #
# it again.                                        #
#**************************************************#
if ($?NCGM && $?Unique && -f $name.ncgm) goto theend
if ($?OLDPS && $?Unique && -f $name.ps) goto theend
if ($?OLDPDF && $?Unique && -f $name.pdf) goto theend
if ($?PS && $?Unique && -f $name.ps) goto theend
if ($?PDF && $?Unique && -f $name.pdf) goto theend
if ($?PNG && $?Unique && (-f $name.000001.png || -f $name.png)) goto theend

#*********************************************#
#                                             #
# If we've specified "-W ncgm", then we don't #
# want to generate any of the "X11" examples. #
#                                             #
#*********************************************#
if ($?NCGM) then
  set found = 0
  foreach file($x_list)
    if ("$file" == "$name") then
      set found = 1
      break
    endif
  end
endif

#*************************************#
#                                     #
# Find out what type of example it is #
#                                     #
#*************************************#
set ex_type="Unknown"

foreach known ($c_list)
  if ("$name" == "$known") then
    set ex_type = "C"
    break
  endif
end

foreach known ($f_list)
  if ("$name" == "$known") then
    set ex_type = "Fortran"
    break
  endif
end

foreach known ($n_list)
  if ("$name" == "$known") then
    set ex_type = "NCL"
    break
  endif
end

foreach known ($nug_list)
  if ("$name" == "$known") then
    set ex_type = "NUG"
    break
  endif
end

#***************#
#               #
# Echo the type #
#               #
#***************#

switch($ex_type)
    case Unknown:
    echo ""
    echo "ng4ex: <$name> is not a known example"
    echo ""
    goto theend
    breaksw

    case NCL:
    echo ""
    echo "NCAR Graphics NCL Example <$name>"
    echo ""
    breaksw 
 
    case NUG:
    echo ""
    echo "NCL User Guide Example <$name.ncl>"
    echo ""
    breaksw 
 
    default:
    echo ""
    echo "NCAR Graphics High Level Utility $ex_type Example <$name>"
    echo ""
    breaksw
endsw

#******************************#
#                              #
# Determine the directory that #
# the example resides in.      #
#                              #
#******************************#
if($ex_type != "NUG") then
  set obj = `expr $name : '\(.*\)[0-9][0-9].*'`
  set obj_dir = `eval echo \$dir_$obj`
else
  set obj = `expr $name : '\(.*\)[0-9][0-9].*'`
  set obj_dir = $dir_nug
endif

#************************************************#
#                                                #
# Determine if it's a C, Fortran, or NCL example #
#                                                #
#************************************************#
unset fprog
unset cprog
unset nprog
set res_file
set inc_file
set ascdata_file
set bindata_file
set ncl_file
set comp_flags = ($ncarbd_flag $ngmathbd_flag)
set generic_name = `expr $name : '\(.*[0-9][0-9]\).*'`

if($ex_type != "NUG") then
  set prog_type = `expr $name : '.*[0-9][0-9]\(.\)'`
else
  set prog_type = "nug"
endif
set resfile_dir = "$res_dir/$obj_dir"

if ("$prog_type" == "c") then
  if (! -d "$hluex_dir") then
    echo "Warning: HLU directory <$hluex_dir> doesn't exist."
    echo "         Won't generate $name example."
    continue
  endif
  set cprog
  set example_dir = "$hluex_dir/$obj_dir"
  set src_file = "$name.c"
else if ("$prog_type" == "f") then
  set fprog
  set example_dir = "$hluex_dir/$obj_dir"
  set src_file = "$name.f"
else if ("$prog_type" == "n" || "$prog_type" == "nug") then
  if (! -d "$nclex_dir") then
    echo "Warning: NCL directory <$nclex_dir> doesn't exist."
    echo "         Won't generate $name example."
    continue
  endif
  if ("$prog_type" == "n") then
    set example_dir = "$nclex_dir/$obj_dir"
  else
    set example_dir = "$nclex_dir/$dir_nug"
  endif
  set nprog
  set src_file = "$name.ncl"
else
  echo ""
  echo "Cannot determine what type of example $name is."
  echo ""
  exit 1
endif

#***********************************#
#                                   #
# Get the names of needed resource, #
# include, and/or data files        #
#                                   #
#***********************************#

if ( -e "$resfile_dir/$name.res") then
    set res_file = $name.res
else if ( -e "$resfile_dir/$generic_name.res") then
    set res_file = $generic_name.res
endif

if ( -e "$example_dir/$name.h") then
    set inc_file = $name.h
endif

#*******************************#
#                               #
# Some examples need data files #
# or extra compiler stuff or    #
# some special message.         #
#                               #
#*******************************#
switch($name)
    case xy06c:
    case xy06f:
    case xy10c:
    case xy10f:
    case cn05c:
    case cn05f:
    case cn06c:
    case cn06f:
    case cn07c:
    case cn07f:
    case cn08c:
    case cn08f:
    case cn09c:
    case cn09f:
    case cn10c:
    case cn10f:
    case cn14c:
    case cn14f:
    case cn15c:
    case cn15f:
    case cn16c:
    case cn16f:
    case st03c:
    case st03f:
    case st04c:
    case st04f:
    case vc06c:
    case vc06f:
    case vc08c:
    case vc08f:
    case vc09c:
    case vc09f:
        echo ""
        echo "You must have the netCDF library installed on your system"
        echo "in order to compile this example."
        echo ""
        set comp_flags = ($comp_flags "-netcdf")
    breaksw

    case xy12c:
    case xy13c:
        echo ""
        echo "This example is a GUI example, and requires the X"
        echo "libraries Xm and Xt to be loaded during the link phase."
        echo ""
        echo "The output will be displayed to an X11 window, and an"
        echo "NCGM/PS/PDF/PNG file may or may not be produced."
        echo ""
        set comp_flags = ($comp_flags "-XmXt")
        if ("$name" == "xy12c") set ascdata_file = "xy12c.asc"
    breaksw

    case cn03f:
    case cn04n:
    case cn11f:
    case cn12n:
    case mp03n:
        set ascdata_file = "$name.asc"
    breaksw

    case xy16c:
    case xy16f:
    case xy16n:
        set ascdata_file = "xy.asc"
    breaksw

    case gsun11n:
        set ascdata_file = "u.cocos"
    breaksw

    case xy17c:
    case xy17f:
    case xy17n:
        set ascdata_file = "xy.asc"
    breaksw

    case nm01c:
    case nm02c:
    case nm03c:
    case nm04c:
    case nm05c:
    case nm06c:
    case nm01f:
    case nm02f:
    case nm03f:
    case nm04f:
    case nm05f:
    case nm06f:
        echo ""
        echo "This example requires the math library, -lngmath, to be"
        echo "loaded during the link phase."
        echo ""
        set comp_flags = ($comp_flags "-ngmath")
    breaksw
endsw

switch($generic_name)
    case gsun01:
    case gsun02:
    case gsun03:
    case gsun04:
    case gsun05:
    case gsun06:
    case gsun07:
    case gsun10:
    case gsun11:
    case basic03:
        echo ""
        echo "This example was set up to display the output to an"
        echo "X11 window."
        echo ""
    breaksw

    case gsun09:
        echo ""
        echo "This example was set up to display the output to an"
        echo "NCGM file only."
        echo ""
    breaksw

    case basic04:
	case xy11:
	case xy12:
        echo ""
        echo "This example was set up to display the output to an"
        echo "X11 window and an NCGM."
        echo ""
    breaksw

	case cn15:
	case gsun08:
    case basic07:
        echo ""
        echo "This example was set up to display the output to an"
        echo "X11 window, an NCGM, a PDF, and a PostScript workstation."
        echo ""
    breaksw

    case cn13:
        echo ""
        echo "This example may take awhile, so please be patient."
        echo ""
    breaksw

    case xy08:
        set ascdata_file = "$generic_name.asc"
    breaksw
endsw

#************#
#            #
# Copy files #
#            #
#************#
foreach file($src_file)
    echo "  Copying $file"
    cp $example_dir/$file .
end

#*****************************************#
#                                         #
# Modify example if we explicity want to  #
# output to an NCGM file, an XWorkstation,#
# a PS file, a PDF file, or PNG file.     #
# If a type is explicitly requested, then #
# turn the other types off.               #
#                                         #
#*****************************************#
if ($?cprog && $?change_ws_type) then
ed << EOF - ./$src_file >& /dev/null
/wks_type =/d
i
  char const *wks_type = "$ws_type";
.
w
q
EOF
endif

if ($?fprog && $?change_ws_type) then
ed << EOF - ./$src_file >& /dev/null
/wks_type =/d
i
      wks_type = "$ws_type"
.
w
q
EOF
endif

if ($?nprog && $?change_ws_type) then
ed << EOF - ./$src_file >& /dev/null
/wks_type = "
c
wks_type = "$ws_type"
.
w
q
EOF
endif

foreach file($res_file)
    echo "  Copying $file"
    cp $resfile_dir/$file .
end

foreach file($inc_file)
    echo "  Copying $file"
    cp $example_dir/$file .
end

foreach file($ascdata_file)
    echo "  Copying $file"
    cp $data_dir/asc/$file .
end

foreach file($bindata_file)
    echo "  Copying $file"
    cp $data_dir/bin/$file .
end

#********************************#
#                                #
# Create list of files to remove #
#                                #
#********************************#
set rmfiles = ($src_file $res_file $inc_file $ascdata_file $bindata_file)
if (! $?nprog) then
  set rmfiles = ($name.o ${name}SED_EXE_SUFFIX $rmfiles)
endif

#******************************#
#                              #
# Compile and link the example #
#                              #
#******************************#
   
if (! $?NoRunOption) then
    echo ""
    if ($?fprog || $?cprog) then   
      echo "Compiling and linking..."
      if ($?cprog) then
        nhlcc -o $name $src_file $comp_flags
      else
        nhlf77 -o $name $src_file $comp_flags
      endif
      if ($status != 0) then
          echo ""
          echo "The compile and link failed."
          echo ""
          exit
      endif
      echo "Executing <$name>..."
      echo ""

      ./$name

      echo ""
      echo "Finished executing <$name>..."
      echo ""
    else 
      echo "Running NCL..."
      ncl < $src_file
      if ($status != 0) then
          echo ""
          echo "ncl failed."
          echo ""
          exit
      endif
      echo ""
      echo "Finished running 'ncl < $src_file'..."
      echo ""
    endif
    if( -e $name.ncgm ) then
      echo ""
      echo "    Example $name produced a metafile."
      echo "    Metafile is named $name.ncgm."
      echo ""
    endif
    if( -e $name.ps  && ("$ws_type" == "oldps" || "$ws_type" == "OLDPS")) then
      echo ""
      echo "    Example $name produced an older version PostScript file."
      echo "    PS file is named $name.ps."
      echo ""
    endif
    if( -e $name.ps  && ("$ws_type" == "ps" || "$ws_type" == "PS")) then
      echo ""
      echo "    Example $name produced a cairo PostScript file."
      echo "    PS file is named $name.ps."
      echo ""
    endif
    if( -e $name.pdf  && ("$ws_type" == "oldpdf" || "$ws_type" == "OLDPDF")) then
      echo ""
      echo "    Example $name produced an older version PDF file."
      echo "    PDF file is named $name.pdf."
      echo ""
    endif
    if( -e $name.pdf  && ("$ws_type" == "pdf" || "$ws_type" == "PDF")) then
      echo ""
      echo "    Example $name produced a cairo PDF file."
      echo "    PDF file is named $name.pdf."
      echo ""
    endif

    if($ex_type == "NUG") then
      echo ""
      echo "    Example $src_file produced PNG file."
      echo ""
    endif

    if( (-e $name.png || -e $name.000001.png)  && ("$ws_type" == "png" || "$ws_type" == "PNG")) then
      echo ""
      echo "    Example $name produced one or more cairo PNG files."
      echo "    If single PNG file, it is named $name.png"
      echo "    If multiple PNG files, first PNG file is named $name.000001.png, and so on."
      echo ""
    endif
endif

#***********************#
#                       #
# Remove unwanted files #
#                       #
#***********************#
if ($?CleanOption) then
    /bin/rm $rmfiles >>& /dev/null
endif

theend:

end

#!/bin/csh -f
#
#   $Id: MakeNcl.csh,v 1.5 2008-07-27 04:12:48 haley Exp $
#                                                                      
#                Copyright (C)  2004
#        University Corporation for Atmospheric Research
#                All Rights Reserved
#
# The use of this Software is governed by a License Agreement.
#
# Use this script to make an ncl executable from installed libraries.
#

set cc_ld         = "SED_CC_LD"
set cc_opts       = "SED_CC_OPT"
set ld_libs       = "SED_LDLIBS"
set extra_ld_libs = "SED_EXTRA_LDLIBS"
set libpath       = "SED_LIBPATH"
set incpath       = "SED_INCPATH"
set libdir        = "-L$libpath"
set incdir        = "-I$incpath"
set libncl        = "-lncl"
set libnfp        = "-lnfp -lnfpfort"
set libhlu        = "-lhlu"
set libncarg      = "-lncarg"
set libgks        = "-lncarg_gks"
set libncarg_c    = "-lncarg_c"
set libmath       = "-lngmath"
set ncarg_libs    = "$libncl $libnfp $libhlu $libncarg $libgks $libncarg_c $libmath"

if (! -d "$libpath") then
  echo "Library directory <$libpath> does not exist."
  exit 1
endif

set files      = ""
set extra_opts = ""

foreach arg ($argv)

    switch ($arg)

    case "-*":
        set extra_opts = "$extra_opts $arg"
        breaksw

    default:
        set files = "$files $arg"
        breaksw
    endsw
end

if ("$files" == "") then
  echo "MakeNcl error: You must input one or more *.o files"
  exit 1
endif

set newargv = "$cc_ld $cc_opts $extra_opts -o ncl $files $incdir $libdir $ncarg_libs $ld_libs $extra_ld_libs"

echo $newargv
eval $newargv

/*
 *      $Id: TypeSupport.c.sed,v 1.7 2010-04-14 21:29:48 huangwei Exp $
 */
/************************************************************************
*									*
*			     Copyright (C)  1995			*
*	     University Corporation for Atmospheric Research		*
*			     All Rights Reserved			*
*									*
************************************************************************/
/*
 *	File:		
 *
 *	Author:		Ethan Alpert
 *			National Center for Atmospheric Research
 *			PO 3000, Boulder, Colorado
 *
 *	Date:		Fri Jan 27 18:29:40 MST 1995
 *
 *	Description:	
 */
#ifdef NIO_LIB_ONLY
#include "niohlu.h"
#include "nioNresDB.h"
#else
#include <ncarg/hlu/hlu.h>
#include <ncarg/hlu/NresDB.h>
#endif
#include "defs.h"
#include "NclType.h"
#include "TypeSupport.h"
#include "NclMdInc.h"
#include "NclTypelist.h"
#include <ctype.h>

INSERTHERE

NhlErrorTypes _NclInitTypeClasses
#if	NhlNeedProto
(void)
#else
()
#endif
{
	_NclInitClass(nclTypedoubleClass);
	_NclInitClass(nclTypefloatClass);
	_NclInitClass(nclTypelongClass);
	_NclInitClass(nclTypeintClass);
	_NclInitClass(nclTypeshortClass);
	_NclInitClass(nclTypelogicalClass);
	_NclInitClass(nclTypebyteClass);
	_NclInitClass(nclTypecharClass);
	_NclInitClass(nclTypestringClass);
	_NclInitClass(nclTypeobjClass);
	_NclInitClass(nclTypeint64Class);
	_NclInitClass(nclTypeushortClass);
	_NclInitClass(nclTypeuintClass);
	_NclInitClass(nclTypeulongClass);
	_NclInitClass(nclTypeuint64Class);
	_NclInitClass(nclTypeubyteClass);
	_NclInitClass(nclTypelistClass);
	return(NhlNOERROR);
}

NhlErrorTypes _Nclcmpf
#if	NhlNeedProto
(NclTypeClass the_type, void *lhs, void* rhs, NclScalar* lhs_m, NclScalar* rhs_m,int digits,double *result)
#else
(the_type,lhs,rhs,lhs_m,rhs_m,digits,result)
NclTypeClass the_type;
void *lhs;
void* rhs;
NclScalar* lhs_m;
NclScalar* rhs_m;
int digits;
double *result;
#endif
{
	NclTypeClass tmp;

	if(the_type->type_class.cmpf!= NULL) {
		return((*(the_type->type_class.cmpf))(lhs,rhs,lhs_m,rhs_m,digits,result));
	} else {
		tmp = (NclTypeClass)the_type->obj_class.super_class;
		while(tmp != (NclTypeClass)nclTypeClass) {
			if(tmp->type_class.cmpf != NULL) {
				return((*(tmp->type_class.cmpf))(lhs,rhs,lhs_m,rhs_m,digits,result));
			} else {
				tmp = (NclTypeClass)tmp->obj_class.super_class;
			}
		}
	}
	return NhlFATAL;
}

NclTypeClass _NclTypeEnumToTypeClass
#if	NhlNeedProto
(NclObjTypes obj_type_enum)
#else
(obj_type_enum)
NclObjTypes obj_type_enum;
#endif
{
	switch(obj_type_enum) {
	case Ncl_Typedouble:
		return((NclTypeClass)nclTypedoubleClass);
	case Ncl_Typefloat:
		return((NclTypeClass)nclTypefloatClass);
	case Ncl_Typelong:
		return((NclTypeClass)nclTypelongClass);
	case Ncl_Typeint:
		return((NclTypeClass)nclTypeintClass);
	case Ncl_Typeshort:
		return((NclTypeClass)nclTypeshortClass);
	case Ncl_Typebyte:
		return((NclTypeClass)nclTypebyteClass);
	case Ncl_Typestring:
		return((NclTypeClass)nclTypestringClass);
	case Ncl_Typechar:
		return((NclTypeClass)nclTypecharClass);
	case Ncl_Typelogical:
		return((NclTypeClass)nclTypelogicalClass);
	case Ncl_Typeint64:
		return((NclTypeClass)nclTypeint64Class);
	case Ncl_Typeushort:
		return((NclTypeClass)nclTypeushortClass);
	case Ncl_Typeuint:
		return((NclTypeClass)nclTypeuintClass);
	case Ncl_Typeulong:
		return((NclTypeClass)nclTypeulongClass);
	case Ncl_Typeuint64:
		return((NclTypeClass)nclTypeuint64Class);
	case Ncl_Typeubyte:
		return((NclTypeClass)nclTypeubyteClass);
	case Ncl_Typeobj:
		return((NclTypeClass)nclTypeobjClass);
	case Ncl_Typelist:
		return((NclTypeClass)nclTypelistClass);
	default:
		return((NclTypeClass)nclTypeClass);
	}
}

NhlErrorTypes _Nclprint
#if	NhlNeedProto
(NclTypeClass the_type,FILE *fp,void* val)
#else
(the_type,fp,val)
NclTypeClass the_type;
FILE *fp;
void* val;
#endif
{
	NclTypeClass tmp;

	if(the_type->type_class.print != NULL) {
		return((*(the_type->type_class.print))(fp,val));
	} else {
		tmp = (NclTypeClass)the_type->obj_class.super_class;
		while(tmp != (NclTypeClass)nclTypeClass) {
			if(tmp->type_class.print!= NULL) {
				return((*(tmp->type_class.print))(fp,val));
			} else {
				tmp = (NclTypeClass)tmp->obj_class.super_class;
			}
		}
	}
	return NhlFATAL;

}

NhlErrorTypes _Nclcoerce
#if	NhlNeedProto
(NclTypeClass to_type, void * result, void* from, ng_size_t n, NclScalar* from_m, NclScalar* to_m, NclTypeClass from_type)
#else
(t0_type, result, from, n, from_m, to_m, from_type)
NclTypeClass to_type;
void * result;
void* from;
ng_size_t n;
NclScalar* from_m;
NclScalar* to_m;
NclTypeClass from_type;
#endif
{
	NclTypeClass tmp;

	if(to_type->type_class.coerce != NULL) {
		return((*(to_type->type_class.coerce))(result,from,n,from_m,to_m,from_type));
	} else {
		tmp = (NclTypeClass)to_type->obj_class.super_class;
		while(tmp != (NclTypeClass)nclTypeClass) {
			if(tmp->type_class.coerce != NULL) {
				return((*(tmp->type_class.coerce))(result,from,n,from_m,to_m,from_type));
			} else {
				tmp =(NclTypeClass) tmp->obj_class.super_class;
			}
		}
		return(NhlFATAL);
	}
}

NhlErrorTypes _Nclreset_mis
#if	NhlNeedProto
(NclTypeClass the_type,void *val, NclScalar* old_m, NclScalar * new_m,ng_size_t nval)
#else
(the_type,val, old_m, new_m,nval)
NclTypeClass the_type;
void *val;
NclScalar* old_m;
NclScalar* new_m;
ng_size_t nval;
#endif
{
	NclTypeClass tmp;
	if(the_type->type_class.reset_mis != NULL) {
		return((*(the_type->type_class.reset_mis))(val,old_m,new_m,nval));
	} else {
		tmp = (NclTypeClass)the_type->obj_class.super_class;
		while(tmp != (NclTypeClass)nclTypeClass) {
			if(tmp->type_class.reset_mis != NULL) {
				return((*(tmp->type_class.reset_mis))(val,old_m,new_m,nval));
			} else {
				tmp = (NclTypeClass)tmp->obj_class.super_class;
			}
		}
		return(NhlFATAL);
	}
}

NclMonoTypes _Nclis_mono
#if	NhlNeedProto
(NclTypeClass the_type, void *val, NclScalar* val_m, ng_size_t nval)
#else
(the_type, val, val_m, nval)
NclTypeClass the_type;
void *val;
NclScalar* val_m;
ng_size_t nval;
#endif
{
	NclTypeClass tmp;
	if(the_type->type_class.is_mono != NULL) {
		return((*(the_type->type_class.is_mono))(val, val_m, nval));
	} else {
		tmp = (NclTypeClass)the_type->obj_class.super_class;
		while(tmp != (NclTypeClass)nclTypeClass) {
			if(tmp->type_class.is_mono != NULL) {
				return((*(tmp->type_class.is_mono))(val, val_m, nval));
			} else {
				tmp = (NclTypeClass)tmp->obj_class.super_class;
			}
		}
		return(NhlFATAL);
	}

}

NclQuark _NclGetLower
(
	NclQuark qstr
	)
{
	char *buf;
	char buffer[256];
	char *cp;
	char *instr = NrmQuarkToString(qstr);
	int size;
	NrmQuark outq;
	
	if (! instr) {
	        return NrmNULLQUARK;
        }
        size  = strlen(instr);
	if (size < 256) {
		buf = buffer;
	}
	else {
		buf = NclMalloc(size + 1);
	}
	strncpy(buf,instr,size);
	buf[size] = '\0';
	for (cp = buf; *cp != '\0'; cp++) {
		*cp = tolower(*cp);
	}
	outq = NrmStringToQuark(buffer);

	if (buf != buffer)
		NclFree(buf);

	return outq;
}

NhlErrorTypes _NclSetDefaultFillValues
(
	int default_type
)
{
	if (default_type == NCL_5_DEFAULT_FILLVALUES) {
		((NclTypeClass)nclTypeshortClass)->type_class.default_mis.shortval = -99;
		((NclTypeClass)nclTypeintClass)->type_class.default_mis.intval = -999;
		((NclTypeClass)nclTypelongClass)->type_class.default_mis.longval = -9999;
		((NclTypeClass)nclTypeint64Class)->type_class.default_mis.int64val = -99999999;
		((NclTypeClass)nclTypeushortClass)->type_class.default_mis.ushortval = 0;
		((NclTypeClass)nclTypeuintClass)->type_class.default_mis.uintval = 0;
		((NclTypeClass)nclTypeulongClass)->type_class.default_mis.ulongval = 0;
		((NclTypeClass)nclTypeuint64Class)->type_class.default_mis.uint64val = 0;
		((NclTypeClass)nclTypeubyteClass)->type_class.default_mis.ubyteval = 0;
		((NclTypeClass)nclTypefloatClass)->type_class.default_mis.floatval = -999.0;
		((NclTypeClass)nclTypedoubleClass)->type_class.default_mis.doubleval = -9999.0;
		((NclTypeClass)nclTypecharClass)->type_class.default_mis.charval = 0;
		((NclTypeClass)nclTypebyteClass)->type_class.default_mis.byteval = (char) 0xff;
		((NclTypeClass)nclTypestringClass)->type_class.default_mis.stringval = NrmStringToQuark("missing");
		((NclTypeClass)nclTypelogicalClass)->type_class.default_mis.logicalval = -1;
	}
	else if (default_type == NCL_6_DEFAULT_FILLVALUES) {
		((NclTypeClass)nclTypeshortClass)->type_class.default_mis.shortval = -32767;
		((NclTypeClass)nclTypeintClass)->type_class.default_mis.intval = -2147483647;
		((NclTypeClass)nclTypelongClass)->type_class.default_mis.longval = -2147483647;
		((NclTypeClass)nclTypeint64Class)->type_class.default_mis.int64val = (long long)-9223372036854775806LL;
		((NclTypeClass)nclTypeushortClass)->type_class.default_mis.ushortval = 65535;
		((NclTypeClass)nclTypeuintClass)->type_class.default_mis.uintval = 4294967295U;
		((NclTypeClass)nclTypeulongClass)->type_class.default_mis.ulongval = 4294967295U;
		((NclTypeClass)nclTypeuint64Class)->type_class.default_mis.uint64val = (unsigned long long)18446744073709551614ULL;
		((NclTypeClass)nclTypeubyteClass)->type_class.default_mis.ubyteval = 255;
		((NclTypeClass)nclTypefloatClass)->type_class.default_mis.floatval = 9.9692099683868690e+36f;
		((NclTypeClass)nclTypedoubleClass)->type_class.default_mis.doubleval = 9.9692099683868690e+36;
		((NclTypeClass)nclTypecharClass)->type_class.default_mis.charval = 0;
		((NclTypeClass)nclTypebyteClass)->type_class.default_mis.byteval = -127;
		((NclTypeClass)nclTypestringClass)->type_class.default_mis.stringval = NrmStringToQuark("missing");
		((NclTypeClass)nclTypelogicalClass)->type_class.default_mis.logicalval = -1;
	}
	return NhlNOERROR;
}

NhlErrorTypes _NclGetDefaultFillValue
(NclBasicDataTypes type,
 NclScalar *def_val)
{
	char *ctype = NULL;
	NclTypeClass class = NULL;

	ctype = _NclBasicDataTypeToName(type);
	if (ctype) {
		class = _NclNameToTypeClass(NrmStringToQuark(ctype));
		if (class) {
				*def_val = class->type_class.default_mis;
				return NhlNOERROR;
                }
        }
	return NhlFATAL;
}

/*
 *      $Id: TypeInitClassTemplate.c.sed,v 1.6 2009-07-10 19:54:06 huangwei Exp $
 */
/************************************************************************
*									*
*			     Copyright (C)  1995			*
*	     University Corporation for Atmospheric Research		*
*			     All Rights Reserved			*
*									*
************************************************************************/
/*
 *	File:		
 *
 *	Author:		Ethan Alpert
 *			National Center for Atmospheric Research
 *			PO 3000, Boulder, Colorado
 *
 *	Date:		Fri Jan 27 18:35:14 MST 1995
 *
 *	Description:	
 */

/*ARGSUSED*/
static NhlErrorTypes CvtHLUGENTYPEREPToNclData
#if	NhlNeedProto
(NrmValue *from, NrmValue *to, NhlConvertArgList args, int nargs)
#else
(from, to, args, nargs)
NrmValue *from;
NrmValue *to;
NhlConvertArgList args;
int nargs;
#endif
{
	NhlGenArray gen;
	char func[] = "CvtHLUGENTYPEREPToNclData";
	void *val;
	NclMultiDValData tmp_md;
	ng_size_t len_dimensions = 1;

	if(nargs != 0) {
		NhlPError(NhlFATAL,NhlEUNKNOWN,"%s: called with wrong number of args",func);
		to->size =0;
		return(NhlFATAL);
	}
	gen = (NhlGenArray)from->data.ptrval;
	if(gen != NULL) {
		if(!_NhlIsSubtypeQ(NrmStringToQuark(((NclTypeDATATYPEClass)nclTypeDATATYPEClass)->type_class.hlu_type_rep[1]),from->typeQ)) {
			NhlPError(NhlFATAL,NhlEUNKNOWN,"%s: called with wrong input type",func);
			to->size =0;
			return(NhlFATAL);
		}
		if(gen->my_data) {
			val = gen->data;
			gen->my_data = False;
		} else {
			val = NclMalloc((unsigned)gen->size * gen->num_elements);
			memcpy(val,gen->data,(unsigned)gen->size * gen->num_elements);
		}
		tmp_md = _NclCreateMultiDVal(
			NULL,NULL, Ncl_MultiDValData,
			0,val,NULL,gen->num_dimensions,
			gen->len_dimensions,TEMPORARY,NULL,(NclTypeClass)nclTypeDATATYPEClass);
		if(to->size < sizeof(NclMultiDValData)) {
			return(NhlFATAL);
		} else {
			*((NclMultiDValData*)(to->data.ptrval)) = (void*)tmp_md;
			return(NhlNOERROR);
		}
	} else {
                val = NclMalloc((unsigned)nclTypeDATATYPEClassRec.type_class.size);
                *(LOCALTYPE*)(val) = nclTypeDATATYPEClassRec.type_class.default_mis.DATATYPEval;
                tmp_md = _NclCreateMultiDVal(
                        NULL,NULL, Ncl_MultiDValData,
                        0,val,&nclTypeDATATYPEClassRec.type_class.default_mis,1,
                        &len_dimensions,TEMPORARY,NULL,(NclTypeClass)nclTypeDATATYPEClass);
                if(to->size < sizeof(NclMultiDValData)) {
                        return(NhlFATAL);
                } else {
                        *((NclMultiDValData*)(to->data.ptrval)) = (void*)tmp_md;
                        return(NhlNOERROR);
                }
	}
}
/*ARGSUSED*/
static NhlErrorTypes CvtHLUTYPEREPToNclData
#if	NhlNeedProto
(NrmValue *from, NrmValue *to, NhlConvertArgList args, int nargs)
#else
(from, to, args, nargs)
NrmValue *from;
NrmValue *to;
NhlConvertArgList args;
int nargs;
#endif
{
	NhlArgVal * tmp;
	NclMultiDValData tmp_md;
	int n_dims = 1;
	ng_size_t len_dims = 1;

	tmp = NclMalloc((unsigned)sizeof(NhlArgVal));
	memcpy((void*)tmp,(void*)&from->data,sizeof(NhlArgVal));
	tmp_md = _NclCreateMultiDVal(
		NULL,NULL, Ncl_MultiDValData,
		0,(void*)tmp,NULL,n_dims,
		&len_dims,TEMPORARY,NULL,(NclTypeClass)nclTypeDATATYPEClass);
	if(to->size < sizeof(NclMultiDValData)) {
		return(NhlFATAL);
	} else {
		*((NclMultiDValData*)(to->data.ptrval)) = (void*)tmp_md;
        	return(NhlNOERROR);
	}
}

static NhlErrorTypes Ncl_Type_DATATYPE_InitClass
#if	NhlNeedProto
(void)
#else
()
#endif
{
        NhlRegisterConverter(NhlbaseClass,HLUGENTYPEREP,NhlTNclData,
		CvtHLUGENTYPEREPToNclData,NULL,0,False,NULL);
        NhlRegisterConverter(NhlbaseClass,HLUTYPEREP,NhlTNclData,
		CvtHLUTYPEREPToNclData,NULL,0,False,NULL);
	nclTypeDATATYPEClassRec.type_class.default_mis.DATATYPEval = DEFAULT_MISS;
	return(NhlNOERROR);
}

/*
 *      $Id: MatMulDValOp.c.sed,v 1.1.4.1 2008-03-28 20:37:48 grubin Exp $
 */
/************************************************************************
*									*
*			     Copyright (C)  1995			*
*	     University Corporation for Atmospheric Research		*
*			     All Rights Reserved			*
*									*
************************************************************************/
/*
 *	File:		
 *
 *	Author:		Ethan Alpert
 *			National Center for Atmospheric Research
 *			PO 3000, Boulder, Colorado
 *
 *	Date:		Fri Jan 27 18:22:08 MST 1995
 *
 *	Description:	
 */

static NclData MultiDVal_mdmd_Mat
#if	NhlNeedProto
(NclData self, NclData other, NclData result)
#else
(self,other,result)
NclData	self;
NclData other;
NclData result;
#endif
{
	NclMultiDValData self_md = (NclMultiDValData)self;
	NclMultiDValData other_md = (NclMultiDValData)other;
	NclMultiDValData result_md = (NclMultiDValData)result;
	NclMultiDValData output_md = NULL;
	NclTypeClass the_type = NULL;
	NclTypeClass operand_type = NULL;
	NclMissingRec themissing;
	void *result_val;
	int n_dims =0;
	ng_size_t dims[2];
	ng_size_t total;
	

	if((other_md == NULL)||(self_md == NULL))
		return(NULL);

        if((other_md->multidval.n_dims > 2)||(self_md->multidval.n_dims > 2)){
		NhlPError(NhlFATAL,NhlEUNKNOWN,"Mat: One of the operands exceeds the rank of 2, can't continue");
		return(NULL);
        }
	if((other_md->multidval.n_dims == 2)&&(self_md->multidval.n_dims == 2)) {
		if(self_md->multidval.dim_sizes[1] != other_md->multidval.dim_sizes[0]) {
			NhlPError(NhlFATAL,NhlEUNKNOWN,"Mat: Dimension size mismatch");
			return(NULL);
		}
		n_dims = 2;
		dims[0] = self_md->multidval.dim_sizes[0];
		dims[1] = other_md->multidval.dim_sizes[1];
		total = dims[0]*dims[1];
	} else if(self_md->multidval.n_dims == 2) {
		if(self_md->multidval.dim_sizes[1] != other_md->multidval.dim_sizes[0]) {
			NhlPError(NhlFATAL,NhlEUNKNOWN,"Mat: Dimension size mismatch");
			return(NULL);
		}
		n_dims = 1;
		dims[0] = self_md->multidval.dim_sizes[0];
		total = dims[0];
	} else if(other_md->multidval.n_dims == 2) {
		if(self_md->multidval.dim_sizes[0] != other_md->multidval.dim_sizes[0]) {
			NhlPError(NhlFATAL,NhlEUNKNOWN,"Mat: Dimension size mismatch");
			return(NULL);
		}
		n_dims = 1;
		dims[0] = other_md->multidval.dim_sizes[1];
		total = dims[0];
	} else {
		if(self_md->multidval.dim_sizes[0] != other_md->multidval.dim_sizes[0]) {
			NhlPError(NhlFATAL,NhlEUNKNOWN,"Mat: Dimension size mismatch");
			return(NULL);
		}
		n_dims = 1;
		dims[0] = 1;
		total = 1;
	}



	operand_type = self_md->multidval.type;
        if(self_md->multidval.missing_value.has_missing) {
                themissing.value = self_md->multidval.missing_value.value;
                themissing.has_missing = 1;
        } else if(other_md->multidval.missing_value.has_missing) {
                themissing.value = other_md->multidval.missing_value.value;
                themissing.has_missing = 1;
        } else {
                themissing.has_missing = 0;
        }

	if((self_md->multidval.type != NULL)&&(((NclTypeClass)self_md->multidval.type)->type_class.mat != NULL)) {

/*
* the_type is not null since requirement if mat != NULL mat_type != NULL
*/

		the_type = _Nclmat_type(self_md->multidval.type);
		if((result_md != NULL)&&(result_md!=self_md)&&(result_md!=other_md)&&(result_md->multidval.data_type== the_type->type_class.data_type)&&(total*result_md->multidval.type->type_class.size <= result_md->multidval.totalsize)) {
			result_val = result_md->multidval.val;
			result_md->multidval.totalsize = total*result_md->multidval.type->type_class.size;
			result_md->multidval.n_dims = n_dims;
			if(n_dims == 2 ) {
				result_md->multidval.dim_sizes[0] = dims[0];
				result_md->multidval.dim_sizes[1] = dims[1];
			} else {
				result_md->multidval.dim_sizes[0] = dims[0];
			}
		} else if((result_md != NULL)&&(result_md!=self_md)&&(result_md!=other_md)&&(result_md->multidval.type->type_class.size >= the_type->type_class.size)&&(total*result_md->multidval.type->type_class.size <= result_md->multidval.totalsize)) {
			result_val = result_md->multidval.val;
			result_md->multidval.type = the_type;
			result_md->multidval.data_type = the_type->type_class.data_type;
			result_md->multidval.hlu_type_rep[0] = the_type->type_class.hlu_type_rep[0];
			result_md->multidval.hlu_type_rep[1] = the_type->type_class.hlu_type_rep[1];
			result_md->multidval.n_dims = n_dims;
			result_md->multidval.totalsize = total* the_type->type_class.size;
			if(n_dims == 2 ) {
				result_md->multidval.dim_sizes[0] = dims[0];
				result_md->multidval.dim_sizes[1] = dims[1];
			} else {
				result_md->multidval.dim_sizes[0] = dims[0];
			}
		} else {
			if((result_md != NULL)&&(result_md!=self_md)&&(result_md!=other_md))  {
				_NclDestroyObj((NclObj)result_md);
				result_md = NULL;
			} else {
				result_md = NULL;
			}
			result_val = (void*)NclMalloc(total * the_type->type_class.size);
			if(result_val == NULL) {
				NhlPError(NhlFATAL,NhlEUNKNOWN,"FUNCNAME: Could not allocate memory for result type, can't continue\n");
				return(NULL);
			}
		}
		if(_Nclmat(
			operand_type,
			result_val,
			self_md->multidval.val,
			other_md->multidval.val,
			(self_md->multidval.missing_value.has_missing?(void*)&self_md->multidval.missing_value.value:NULL),
			(other_md->multidval.missing_value.has_missing?(void*)&other_md->multidval.missing_value.value:NULL),
			self_md->multidval.n_dims,
			self_md->multidval.dim_sizes,
			other_md->multidval.n_dims,
			other_md->multidval.dim_sizes) != NhlFATAL) {

			if((the_type != operand_type)&&(themissing.has_missing)) {
				if(!_NclScalarCoerce(&themissing.value,operand_type->type_class.data_type,&themissing.value,the_type->type_class.data_type) ) {

					themissing.value = the_type->type_class.default_mis;
				}
			}
			if(result_md == NULL) {
				output_md = _NclCreateMultiDVal(
					(NclObj)result_md,
					NULL,
					Ncl_MultiDValData,
					0,
					result_val,
					(themissing.has_missing? &(themissing.value):NULL),
					n_dims,
					dims,
					TEMPORARY,
					NULL,
					the_type
				);
				return((NclData)output_md);
			} else {
				if(themissing.has_missing)
					result_md->multidval.missing_value = themissing;
				return((NclData)result_md);
			}
		} else {
			if(result_md == NULL) {
				NclFree(result_val);
			}
			return(NULL);
		}
			
			
		
	} else {
		NhlPError(NhlFATAL,NhlEUNKNOWN,"Mat: operation not supported on type (%s)",_NclBasicDataTypeToName(self_md->multidval.data_type));
		return(NULL);
	}
}

/*
 *      $Id: TypeSupportMatTemplate.c.sed,v 1.1.4.1 2008-03-28 20:37:53 grubin Exp $
 */
/************************************************************************
*									*
*			     Copyright (C)  1995			*
*	     University Corporation for Atmospheric Research		*
*			     All Rights Reserved			*
*									*
************************************************************************/
/*
 *	File:		
 *
 *	Author:		Ethan Alpert
 *			National Center for Atmospheric Research
 *			PO 3000, Boulder, Colorado
 *
 *	Date:		Fri Jan 27 18:30:15 MST 1995
 *
 *	Description:	
 */





NhlErrorTypes _NclTFUNC
#if	NhlNeedProto
(NclTypeClass the_type, void * result, void* lhs, void* rhs, NclScalar* lhs_m, NclScalar* rhs_m, int nlhs_dims,ng_size_t* lhs_dimsizes, int nrhs_dims, ng_size_t* rhs_dimsizes)
#else
(the_type, result, lhs, rhs, lhs_m, rhs_m, nlhs_dims,lhs_dimsizes, nrhs_dims,rhs_dimsizes)
NclTypeClass the_type;
void * result;
void* lhs;
void* rhs;
NclScalar* lhs_m;
NclScalar* rhs_m;
int nlhs_dims;
ng_size_t *lhs_dimsizes;
int nrhs_dims;
ng_size_t *rhs_dimsizes;
#endif
{
	NclTypeClass tmp;

	if(the_type->type_class.TFUNC!= NULL) {
		return((*(the_type->type_class.TFUNC))(result, lhs, rhs, lhs_m, rhs_m, nlhs_dims,lhs_dimsizes, nrhs_dims,rhs_dimsizes));
	} else {
		tmp = (NclTypeClass)the_type->obj_class.super_class;
		while(tmp != (NclTypeClass)nclTypeClass) {
			if(tmp->type_class.TFUNC != NULL) {
				return((*(the_type->type_class.TFUNC))(result, lhs, rhs, lhs_m, rhs_m, nlhs_dims,lhs_dimsizes, nrhs_dims,rhs_dimsizes));
			} else {
				tmp = (NclTypeClass)tmp->obj_class.super_class;
			}
		}
		return(NhlFATAL);
	}
}


NclTypeClass _NclTFUNC_type
#if	NhlNeedProto
(NclTypeClass the_type)
#else
(the_type)
NclTypeClass the_type;
#endif
{
	NclTypeClass tmp;

	if(the_type->type_class.TFUNC_type!= NULL) {
		return((*(the_type->type_class.TFUNC_type))());
	} else {
		tmp = (NclTypeClass)the_type->obj_class.super_class;
		while(tmp != (NclTypeClass)nclTypeClass) {
			if(tmp->type_class.TFUNC_type != NULL) {
				return((*(tmp->type_class.TFUNC_type))());
			} else {
				tmp = (NclTypeClass)tmp->obj_class.super_class;
			}
		}
		return(NULL);
	}
}

/*
 *	$Id: c.h.sed,v 1.3 2008-07-27 12:23:45 haley Exp $
 */
/************************************************************************
*                                                                       *
*                          Copyright (C)  2000                          *
*            University Corporation for Atmospheric Research            *
*                          All Rights Reserved                          *
*                                                                       *
*                          NCAR View V3.00alpha                         *
*                                                                       *
*    The use of this Software is governed by a License Agreement.       *
*                                                                       *
************************************************************************/


#ifndef	_ncarg_c_
#define	_ncarg_c_

#include <stdio.h>
#include <sys/types.h>

/*
 * Fortran function macro.  This macro needs to surround any "C" reference
 * to a function that is written in fortran or is written in "C" to be
 * Fortran callable.
 */

#ifndef	NGCALLF

#define NGCALLF(reg,caps)   SED_NGCALLF

#endif	/* NGCALLF */

/*
 * The Absoft ProFortran compiler munges common block names
 * differently than the way it handles Fortran subroutine names,
 * so here is where we deal with this.
 */
#ifndef NGCALLC
#if defined(AbsoftProFortran)
#define	NGCALLC(reg,caps)	_C##caps
#else
#define NGCALLC NGCALLF
#endif /* AbsoftProFortran else ... */
#endif /* NGCALLC */

typedef char    *NcargString;

#ifdef  UNICOS
#include <fortran.h>
#define NGstring            _fcd
#define NGCstrToFstr(cstr,len) ((cstr)?_cptofcd((char *)cstr,len):_cptofcd("",0))
#define NGFstrToCstr(fstr) (_fcdtocp(fstr))
#define NGFlgclToClgcl(flog)  (_ltob(&flog))
#define NGClgclToFlgcl(clog)  (_btol(clog))
#else
#define NGstring            char *
#define NGCstrToFstr(cstr,len) (char *)cstr
#define NGFstrToCstr(fstr) fstr
#define NGFlgclToClgcl(flog)  flog
#define NGClgclToFlgcl(clog)  clog
#endif

#define NGSTRLEN(cstr)      ((cstr)?strlen(cstr):0)

#ifdef	__STDC__
#include <stdarg.h>
#else
#include <varargs.h>
#endif	/*	__STDC__	*/


#ifdef	__STDC__

typedef	void *	Voidptr;

#define	LABS(X)	labs(X)
#else

/*
 *	K&R C
 */
typedef	caddr_t	Voidptr;
#define	const		/* K&R C has no 'const'	*/

#define	LABS(X)	(long) (abs((int) (X)))

#endif	/*	__STDC__	*/

/*
 * C++ prototype protector
 */
#ifdef	__cplusplus
#define	NCARG_PROTO_BEGIN	extern "C" {
#define	NCARG_PROTO_END		}
#else
#define	NCARG_PROTO_BEGIN
#define	NCARG_PROTO_END	
#endif

typedef	unsigned int	boolean;

#ifndef	TRUE
#define FALSE	0
#define TRUE	!FALSE
#endif	/* TRUE */

NCARG_PROTO_BEGIN
/*
**
**	A R G U M E N T   V E C T O R S
**
*/

extern	char	**AToArgv(
#ifdef	NeedFuncProto
	const char      *str,
	const char      *prog_name,
	int     *argc
#endif
);

extern	void	FreeArgv(
#ifdef	NeedFuncProto
	char	**argv
#endif
);

/*
**
**	E R R O R   R E P O R T I N G
**
*/
#define	E_UNKNOWN	1000

#define	ESPRINTF(A,B)	ESprintfFirstPart(A, __FILE__, __LINE__), \
				ESprintfSecondPart B

/*
 * maintain backwords compatibility
 */
#define	ErrorGetMessage	ErrGetMsg
#define	ErrorGetNumber	ErrGetNum

/*ARGSUSED2*/
extern	const char	*ESprintf(
#ifdef	NeedFuncProto
	unsigned        err_code,
	const   char    *format,
	...
#endif
);

extern	const char	*LFESprintf(
#ifdef	NeedFuncProto
	unsigned	err_code,
	const char	*file,
	int		line,
	const char	*format,
	...
#endif
);

extern	void	ESprintfFirstPart(
#ifdef	NeedFuncProto
	int		err_code,
	const char	*file,
	int		line
#endif
);

extern const char    *ESprintfSecondPart(
#ifdef	NeedFuncProto
	const char	*format,
	...
#endif
);

extern	int	ErrorList(
#ifdef	NeedFuncProto
	unsigned start,
	unsigned num,
	const char **err_list
#endif
);

extern	const char	*ErrGetMsg();
extern	int	ErrGetNum();



/*
**
**	M I S C E L L A N Y
**
*/
extern	boolean	IsAsciiInt(
#ifdef	NeedFuncProto
	const char *s
#endif
);

extern	void USleep(
#ifdef	NeedFuncProto
	unsigned usec
#endif
);

/*
**
**	O P T I O N   P A R S I N G
**
*/

/*
 *	structure for describing a valid option to buildOptionTable
 */
typedef	struct	_OptDescRec {
	const char	*option;/* name of option without preceeding '-' */
	int	arg_count;	/* num args expected by option		*/
	char	*value;		/* default value for the argument	*/
	const char	*help;	/* help string for option		*/
	} OptDescRec;

/*
 *	structure for returning the value of an option
 */
typedef	struct	_Option {
	char		*option_name;	/* the options name		*/

			/* 
			 * option type converter	
			 */
	int		(*type_conv)(
#ifdef	NeedFuncProto
			const char *from, Voidptr to
#endif
			);

	Voidptr		offset;		/* offset of return address	*/ 
	int		size;		/* size of option in bytes	*/
	} Option;

typedef	struct	_EnvOpt {
	char	*option;		/* option name			*/
	char	*env_var;		/* coresponding enviroment var	*/
	} EnvOpt;

typedef	struct	Dimension2D_ {
	int	nx, ny;
	} Dimension2D;

extern	int	NCARGCvtToInt(
#ifdef	NeedFuncProto
	const char	*from,
	Voidptr		to
#endif
);

extern	int	NCARGCvtToFloat(
#ifdef	NeedFuncProto
	const char	*from,
	Voidptr		to
#endif
);

extern	int	NCARGCvtToChar(
#ifdef	NeedFuncProto
	const char	*from,
	Voidptr		to
#endif
);

extern	int	NCARGCvtToBoolean(
#ifdef	NeedFuncProto
	const char	*from,
	Voidptr		to
#endif
);

extern	int	NCARGCvtToString(
#ifdef	NeedFuncProto
	const char	*from,
	Voidptr		to
#endif
);

extern	int	NCARGCvtToDimension2D(
#ifdef	NeedFuncProto
	const char	*from,
	Voidptr		to
#endif
);

extern	int	OpenOptionTable();

extern	int	CloseOptionTable(
#ifdef	NeedFuncProto
	int	od
#endif
);

extern	int	GetOptions(
#ifdef	NeedFuncProto
	int	od,
	const Option	*options
#endif
);

extern	int	LoadOptionTable(
#ifdef	NeedFuncProto
	int	od,
	const OptDescRec	*optd
#endif
);

extern	void	RemoveOptions(
#ifdef	NeedFuncProto
	int	od,
	const OptDescRec	*optd
#endif
);

extern	int	ParseOptionTable(
#ifdef	NeedFuncProto
	int		od,
	int		*argc,
	char		**argv,
	const OptDescRec	*optds
#endif
);

extern	int	ParseEnvOptions(
#ifdef	NeedFuncProto
	int		od,
	const EnvOpt	*envv,
	const OptDescRec	*optds
#endif
);

extern	void	PrintOptionHelp(
#ifdef	NeedFuncProto
	int	od,
	FILE	*fp
#endif
);


/*
**
**	V E R S I O N
**
*/
extern	void	PrintVersion(
#ifdef	NeedFuncProto
	const char	*header
#endif
);

extern	const char *GetNCARGVersion(
#ifdef	NeedFuncProto
	void				 
#endif
);

extern	const char *GetNCLVersion(
#ifdef	NeedFuncProto
	void				 
#endif
);
/*
**
**	B I T   M A N I P U L A T I O N
**
*/


#ifndef	BITSPERBYTE
#define BITSPERBYTE     8
#endif

#ifndef	BITS
#define BITS(type)      (BITSPERBYTE * (int)sizeof(type))
#endif



#define	BYTESIZE	8
#define	POWER16		65536.0		/*two to the power 16	*/
#define	POWER32		4294967300.0	/*two to the power 32	*/
#define	POWER15		32768.0
#define	POWER31		2147483650.0	/*two to the power 32	*/


	/*
	 *	Macro for extracting N bits from TARG stating at position
	 *	POSS counting from the left. E.g GETBITS(I, 4, 3) will
	 *	extract bits at bit position 4, 3, 2 right adjusted. 
	 *	This macro contains a conditional for number of bits greater
	 *	then 32 because some architechures such as Sun 4 with a sparc
	 *	cpu or pyramids cannot shift 32.
	 */

#define GETBITS(TARG,POSS,N) \
	((N)<32 ? (((TARG) >> ((POSS)+1-(N))) & ~(~0 << (N))) : \
	((TARG) >> ((POSS)+1-(N))) )

	/*
	 *	Inverse of the GETBITS macro. Place N bits from SRC into
	 *	TARG at position POSS. 
	 */
#define	PUTBITS(TARG, POSS, N, SRC) \
		(TARG) &= ~(~((~0) << (N)) << (((POSS)+1) - (N))); \
		(TARG) |= (((SRC) & ~((~0) << (N))) << (((POSS)+1) - (N))) 

#define ZERO_INDEX(X)   (X < 0 ? 0 : X)	


/*
**
**	N C A R  G   E N V I R O N M E N T
**
*/

extern	const char	*GetNCARGPath(
#ifdef	NeedFuncProto
	const char	*dir
#endif
);

extern	const char	*_NGGetNCARGEnv(
#ifdef	NeedFuncProto
	const char	*name
#endif
);

extern	const char	*_NGResolvePath(
#ifdef	NeedFuncProto
	const char	*rawfname
#endif
);

extern	char *getFcapname(
#ifdef	NeedFuncProto
	const char	*device
#endif
);

extern	char *getGcapname(
#ifdef	NeedFuncProto
	const char	*device
#endif
);

/*
**	R G B Database Support
**
*/

typedef struct _NGRGB{
	unsigned short red,green,blue;
} NGRGB;

/*
 * sdbm - ndbm work-alike hashed database library
 * based on Per-Aake Larson's Dynamic Hashing algorithms.
 * BIT 18 (1978).
 *
 * Copyright (c) 1991 by Ozan S. Yigit (oz@nexus.yorku.ca)
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose and without fee is hereby granted,
 * provided that the above copyright notice appear in all copies and that
 * both that copyright notice and this permission notice appear in
 * supporting documentation.
 *
 * This file is provided AS IS with no warranties of any kind.  The author
 * shall have no liability with respect to the infringement of copyrights,
 * trade secrets or any patents by this file or any part thereof.  In no
 * event will the author be liable for any lost revenue or profits or
 * other special, indirect and consequential damages.
 */

#define NGDBLKSIZ 4096
#define NGPBLKSIZ 1024
#define NGPAIRMAX 1008			/* arbitrary on PBLKSIZ-N */
#define NGSPLTMAX	10			/* maximum allowed splits */
					/* for a single insertion */
#define NGDIRFEXT	".dir"
#define NGPAGFEXT	".pag"

typedef struct {
	int dirf;		       /* directory file descriptor */
	int pagf;		       /* page file descriptor */
	int flags;		       /* status/error flags, see below */
	long maxbno;		       /* size of dirfile in bits */
	long curbit;		       /* current bit number */
	long hmask;		       /* current hash mask */
	long blkptr;		       /* current block for nextkey */
	int keyptr;		       /* current key for nextkey */
	long blkno;		       /* current page to read/write */
	long pagbno;		       /* current page in pagbuf */
	char pagbuf[NGPBLKSIZ];	       /* page file block buffer */
	long dirbno;		       /* current block in dirbuf */
	char dirbuf[NGDBLKSIZ];	       /* directory file block buffer */
} NGDBM;

#define NGDBM_RDONLY	0x1	       /* data base open read-only */
#define NGDBM_IOERR	0x2	       /* data base I/O error */

/*
 * utility macros
 */
#define NGdbm_rdonly(db)		((db)->flags & NGDBM_RDONLY)
#define NGdbm_error(db)		((db)->flags & NGDBM_IOERR)

#define NGdbm_clearerr(db)	((db)->flags &= ~NGDBM_IOERR)  /* ouch */

#define NGdbm_dirfno(db)	((db)->dirf)
#define NGdbm_pagfno(db)	((db)->pagf)

typedef struct {
	char *dptr;
	int dsize;
} NGdatum;

extern NGdatum nullitem;

#ifdef __STDC__
#define proto(p) p
#else
#define proto(p) ()
#endif

/*
 * flags to dbm_store
 */
#define NGDBM_INSERT	0
#define NGDBM_REPLACE	1

/*
 * ndbm interface
 */
extern NGDBM *NGdbm_open proto((char *, int, int));
extern void NGdbm_close proto((NGDBM *));
extern NGdatum NGdbm_fetch proto((NGDBM *, NGdatum));
extern int NGdbm_delete proto((NGDBM *, NGdatum));
extern int NGdbm_store proto((NGDBM *, NGdatum, NGdatum, int));
extern NGdatum NGdbm_firstkey proto((NGDBM *));
extern NGdatum NGdbm_nextkey proto((NGDBM *));

/*
 * other
 */
extern NGDBM *NGdbm_prep proto((char *, char *, int, int));
extern long NGdbm_hash proto((char *, int));

#ifdef SVID
#include <unistd.h>
#endif

/*
 * important tuning parms (hah)
 */

#define NGBYTESIZ	(8)
#define NGSEEDUPS			/* always detect duplicates */
#define NGBADMESS			/* generate a message for worst case:
				   cannot make room after SPLTMAX splits */
/*
 * misc
 */
#define debug(x)

/*
**
**	M I S C E L L A N E O U S
**
*/

extern char	*NmuStrdup(
#ifdef NeedFuncProto
	const char	*str
#endif
);


NCARG_PROTO_END

#endif	/* _ncarg_c_	*/

#!/bin/sh

sh op_funcs.sh int64 NhlTInt64 NhlTInt64GenArray '\(long long\)-9223372036854775806LL' > .tmp.$$

if [ ! $? ]
then
	exit $?
fi

sed \
-e 's/PRINTFORMAT/\%lld\\n/' \
-e 's/DATATYPE/int64/g' \
-e 's/LOCALTYPE/long long/g' \
-e 's/HLUTYPEREP/NhlTInt64/g' \
-e 's/HLUGENTYPEREP/NhlTInt64GenArray/g' \
-e 's/DEFAULT_MISS/(long long)-9223372036854775806LL/g' \
-e 's/DEFAULT_FORMAT/%lld/g' \
-e "/REPLACE/r .tmp.$$" \
-e '/REPLACE/d' \
-e '/DSPECIFIC/r NclTypeint64.c.specific' \
-e '/DSPECIFIC/d' \
NclType.c.sed > NclTypeint64.c

rm .tmp.$$

echo "created NclTypeint64.c"

exit 0

C
C   $Id: openpw.f.2.sed,v 1.2 2008-07-27 03:53:06 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE OPENPW (IUNIT)
      CHARACTER*128 FILENM
          DATA FILENM / ' ' /
      SAVE IOPEN
      DATA IOPEN / 0 /
      IF (IOPEN.EQ.0) THEN
      CALL GNGPAT (FILENM,'SED_DBDIR',ISTAT)
      IF (ISTAT .NE. -1) THEN
          DO 101 I=1,119
              IF (FILENM(I:I).EQ.CHAR(0)) THEN
                  FILENM(I:I+9)='/pwritdata'
                  GO TO 104
              END IF
 101      CONTINUE
          GO TO 105
      ELSE
          DO 102 I=2,128
              LENEM=I
              IF (FILENM(I:I).EQ.CHAR(0)) GO TO 103
 102     CONTINUE
 103     PRINT * , 'OPENPW - ',FILENM(1:LENEM-1)
         STOP
      ENDIF
#if defined(ultrix) && defined(mips)
 104  OPEN (UNIT=IUNIT,FILE=FILENM,STATUS='OLD',FORM='UNFORMATTED',
     +    READONLY,ERR=105)
#else
 104  OPEN (UNIT=IUNIT,FILE=FILENM,STATUS='OLD',FORM='UNFORMATTED',
     +    ERR=105)
#endif
      IOPEN=1
      END IF
      RETURN
 105  WRITE (6,*) 'ERROR IN OPENING ',FILENM
      STOP
      END

/*
 *      $Id$
 */
/************************************************************************
*									*
*			     Copyright (C)  1995			*
*	     University Corporation for Atmospheric Research		*
*			     All Rights Reserved			*
*									*
************************************************************************/
/*
 *	File:		
 *
 *	Author:		Ethan Alpert
 *			National Center for Atmospheric Research
 *			PO 3000, Boulder, Colorado
 *
 *	Date:		Fri Jan 27 18:28:50 MST 1995
 *
 *	Description:	
 */
static NclMonoTypes Ncl_Type_DATATYPE_is_mono
#if	NhlNeedProto
(void *val,NclScalar* val_m,ng_size_t nval)
#else
(val, val_m, nval)
void *val;
NclScalar* val_m;
ng_size_t nval;
#endif
{
	LOCALTYPE *value = (LOCALTYPE*)val;
	ng_size_t i = 0,j = 1;

	if(nval == 1) 
		return(NclINCREASING);
	if(val_m != NULL) {
		i = 0;
		j = 0;
		while((i<nval)&&(value[i] == val_m->DATATYPEval))i++;
		if(i >= nval-1) return(NclNONMONO);
		j = i + 1;
		while((j<nval)&&(value[j] == val_m->DATATYPEval)) j++;
		if(j == nval) return(NclNONMONO);
/*
* i is first non-missing value and j is second guarenteed
*/
		if(value[i] > value[j]) {
			while(value[i] > value[j]) {
				i = j;
				j++;
				while((j<nval)&&(value[j] == val_m->DATATYPEval)) {
					j++;
				}
				if(j >= nval)
					break;
			}
			if(j >= nval) {
				return(NclDECREASING);
			} else {
				return(NclNONMONO);
			}
		} else if(value[i] < value[j]) {
			while(value[i] < value[j]) {
				i = j;
				j++;
				while((j<nval)&&(value[j] == val_m->DATATYPEval)) {
					j++;
				}
				if(j >= nval)
					break;
			}
			if(j >= nval) {
				return(NclINCREASING);
			} else {
				return(NclNONMONO);
			}
		}
	} else {
		i = 0;
		if(value[0] > value[1]) {
			while((i<nval-1)&&(value[i] > value[i+1])) i++;
			if(i == nval-1) {
				return(NclDECREASING);
			} else {
				return(NclNONMONO);
			}
		} else if(value[0] < value[1]) {
			while((i<nval-1)&&(value[i] < value[i+1])) i++;
			if(i == nval-1) {
				return(NclINCREASING);
			} else {
				return(NclNONMONO);
			}
		} 
	}
	return(NclNONMONO);
}

#!/bin/sh

sh op_funcs.sh byte NhlTByte NhlTByteGenArray \(char\)-127 > .tmp.$$

if [ ! $? ]
then
	exit $?
fi

sed \
-e 's/PRINTFORMAT/\%c\\n/' \
-e 's/DATATYPE/byte/g' \
-e 's/LOCALTYPE/byte/g' \
-e 's/HLUTYPEREP/NhlTByte/g' \
-e 's/HLUGENTYPEREP/NhlTByteGenArray/g' \
-e "s/DEFAULT_MISS/-127/g" \
-e "s/DEFAULT_FORMAT/%hhd/g" \
-e "/REPLACE/r .tmp.$$" \
-e '/REPLACE/d' \
-e '/DSPECIFIC/r NclTypebyte.c.specific' \
-e '/DSPECIFIC/d' \
-e 's/Ncl_Type_byte_mod_type/NULL/' \
-e 's/Ncl_Type_byte_mod/NULL/' \
NclType.c.sed > NclTypebyte.c

rm .tmp.$$

echo "created NclTypebyte.c"

#!/bin/sh

rm -f NclTypestring.c

sh op_funcs.sh string NhlTString NhlTStringGenArray -1 > .tmp.$$

if [ ! $? ]
then
	exit $?
fi

cat NclTypestring.c.specific >> .tmp.$$

if [ ! $? ]
then
	exit $?
fi

sed \
-e "/INSERTTMPSTRING/r .tmp.$$" \
-e '/INSERTTMPSTRING/d' \
-e 's/HLUTYPEREP/NhlTQuark/g' \
-e 's/HLUGENTYPEREP/NhlTQuarkGenArray/g' \
NclTypestring.c.sed > NclTypestring.c

if [ ! $? ]
then
	exit $?
fi

cp NclTypestring.c .tmp.$$
sed \
-e 's/(string)/(NclQuark)/g' \
-e 's/string\*/NclQuark \*/g' \
-e 's/string \*/NclQuark \*/g' \
.tmp.$$ > NclTypestring.c

rm .tmp.$$
rm -f NclTypestring.c.tmp

echo "created NclTypestring.c"

exit 0

#!/bin/sh

sh op_funcs.sh short NhlTShort NhlTShortGenArray \(short\)-32767 > .tmp.$$

if [ ! $? ]
then
	exit $?
fi

sed \
-e 's/PRINTFORMAT/\%d\\n/' \
-e 's/DATATYPE/short/g' \
-e 's/LOCALTYPE/short/g' \
-e 's/HLUTYPEREP/NhlTShort/g' \
-e 's/HLUGENTYPEREP/NhlTShortGenArray/g' \
-e 's/DEFAULT_MISS/-32767/g' \
-e 's/DEFAULT_FORMAT/%hd/g' \
-e "/REPLACE/r .tmp.$$" \
-e '/REPLACE/d' \
-e '/DSPECIFIC/r NclTypeshort.c.specific' \
-e '/DSPECIFIC/d' \
NclType.c.sed > NclTypeshort.c

rm .tmp.$$

echo "created NclTypeshort.c"

exit 0

#!/bin/sh
# This script was provided by Carter Borst, who got it to work
# with V5.1.0.
# 
#  NAME: 	Build-NCARG_NCL5.0.sh
#  PURPOSE:	Install NCARG, NCL, and dependent software packages
#  DEPENDS:	zlib, jpeg-6b, libpng, netcdf, udunits, jasper, flex
#		    Additional dependent software is included in this build 
#			Including: gctp, g2clib, HDF4.2r3, HDF-EOS2.14v1.00, ncl_ncarg-5.0.0
#  CLI ARGS:	1-software version, 2-software prefix, 3-netcdf version 4-default install-yes/no 
#  example line:  sh Build-NCL.sh -v 5.0.0 -p /opt -c pgi -n netcdf-3.6.3-pgi -d 
#
message_hdr() { echo "--------------------" ; echo "$@" ; echo "--------------------" ;}
debug() { [ -n "$SNAT_DEBUG" ] && echo "SNAT_DEBUG: " "$@" 1>&2 ; }
repo=${repo_root_dir:-/opt/repo}
scripts=${scripts_root_dir:-${repo}/app_support/build_inst_scripts}
srcdir=${source_root_dir:-${repo}/app_support/src}
config_data=${config_data_dir:-${repo}/projects/config_data}
func_file=${func_file_loc:-${scripts}/FUNCTIONS.sh}
source ${func_file}
parse_cmd_args "$@" 
software=ncl_ncarg
sw_link=ncl
sw_link2=ncarg
build_sum=${sw_root}/build_summary
base_lib=/usr/lib64
base_inc=/usr/include
instdir=${sw_root}/${software}-${version}-${compiler}

echo Building pre-ncl software in a dev directory ${srcdir}/ncl_dev
## !!! ### Clean up past installs and prep for new install
export ncl_dev=${srcdir}/ncl_dev
export ncl_dev_lib=${ncl_dev}/lib
export ncl_dev_inc=${ncl_dev}/include
export ncl_src=${srcdir}/ncl_src
export ncl_inst=${srcdir}/ncl_inst
rm -rf $ncl_dev $ncl_src $ncl_inst
mkdir -p $ncl_dev $ncl_src $ncl_inst
cd $ncl_dev
mkdir -p bin lib include rangs man
cd $ncl_inst
mkdir -p bin lib include rangs man

# Know the ncl_ncarg src software dependencies::
# OS: flex, libpng, zlib, jpeg-6b
# opt: udunits, netcdf, jasper
# Packages to build: HDF4.2f3, g2clib-1.0.04-NCAR, HDF-EOS2.14v1.00, gctp
# Actual software package: ncl_ncar-${version}
szip_src_file=szip-2.1.tar.gz
hdf4_src_file=HDF4.2r3.tar.gz
hdf_eos_src_file=HDF-EOS2.14v1.00.tar.gz
gctp_src_file=gctp.tar.gz
g2clib_src_file=g2clib-1.0.4-NCAR.tar.gz
sw_src_file=${software}_src-${version}.tar.gz

## Setting Environment
## From Mary Haley, 15-16 Sept 2008
if [ $compiler == "pgi" ]; then
	echo Building NCL with PGI . . .
	export NCARG_ROOT=${ncl_dev}
	export NCARG=${ncl_src}/${software}-${version}
	export YMAKE_DEV_FILE=${NCARG}/ymakedevfile
	export PGI=/opt/pgi
	export PATH=${ncl_dev}/bin:${PATH}:${PGI}/bin
	export CC=pgcc
	export F90=pgf90
	export F77=pgf90
	export FC=pgf90
	export CFLAGS="-fPIC -DpgiFortran"
	export CPPFLAGS="-fPIC"
	export CXXFLAGS="-fPIC"
	export FFLAGS="-fPIC"
	export F90FLAGS="-fPIC"
elif [ $compiler == "gcc" ]; then
	echo Building NETCDF with GCC . . .
	export CC=/usr/bin/gcc
	export F90=/usr/bin/gfortran
	export FC=/usr/bin/gfortran
	export CXX=/usr/bin/g++
else
	message_hdr Unknown compiler, exiting
	exit 0
fi

## Pre install
cd ${ncl_src}
tar zxf ${srcdir}/${sw_src_file}
tar zxf ${srcdir}/${hdf4_src_file}
tar zxf ${srcdir}/${hdf_eos_src_file}
tar zxf ${srcdir}/${g2clib_src_file}
tar zxf ${srcdir}/${gctp_src_file}
tar zxf ${srcdir}/${szip_src_file}
chown -Rh root:root ${ncl_src}

##  Copy in pre-built, non-OS software include / lib files into *dev/ directories
cp -r ${netcdf_version}/lib/* ${ncl_dev_lib}
cp -r ${udunits_version}/lib/* ${ncl_dev_lib} 
cp -r /opt/jasper/lib/* ${ncl_dev_lib}
cp -r ${netcdf_version}/include/* ${ncl_dev_inc}
cp -r ${udunits_version}/include/* ${ncl_dev_inc}
cp -r /opt/jasper/include/jasper ${ncl_dev_inc}

export MAKEFLAGS="-l 6"

export CPPFLAGS="-I${base_inc} -fPIC -I${ncl_dev}/include -DBIG_LONGS -DSWAP "
export LDFLAGS=-L/opt/repo/app_support/src/ncl_dev/lib

###  Start building packages from source and copying files to the *dev* structure
###
### Build szip for HDF4 ?
cd ${ncl_src}/szip-2.1
./configure --prefix=${ncl_dev} --disable-shared  2>&1 | tee ${build_sum}/szip-2.1-config.`date +%Y%m%d`.out
make all install 2>&1 | tee ${build_sum}/szip-2.1-makeinstall.`date +%Y%m%d`.out
##  How is this implemented in the build for HDF4 via Haley's build?

###
### Build HDF4.2r3 with these options !! important !!
cd ${ncl_src}/HDF4.2r3
./configure --prefix=${ncl_dev} --with-zlib=${base_lib} --with-jpeg=${base_lib} --includedir=${ncl_dev_inc}/hdf --disable-netcdf  2>&1 | tee ${build_sum}/HDF4.2r3-config.`date +%Y%m%d`.out
make all install 2>&1 | tee ${build_sum}/HDF4.2r3-makeinstall.`date +%Y%m%d`.out
cd ${ncl_dev_inc}/hdf
cp -v *.h ../

###
###  Build g2clib-1.0.4-NCAR
cd ${ncl_src}/g2clib-1.0.4-NCAR
cp Makefile Makefile.orig
ed -s Makefile <<"EOF"
H
g/^DEFS/d
g/^CFLAGS/d
g/^CC/d
i
DEFS   = -DUSE_JPEG2000 -DUSE_PNG
CFLAGS = -fPIC $(INC) $(DEFS)
CC     = pgcc
.
wq
EOF
ed -s Makefile <<EOF
H
g/^INC/d
i
INC    = -I${base_inc} -I${ncl_dev_inc}
.
wq
EOF
make all 2>&1 | tee ${build_sum}/g2clib-makeoutput.`date +%Y%m%d`.out
cp -v libgrib2c.a ${ncl_dev_lib}
cp -v grib2.h ${ncl_dev_inc}

###
### Building HDF-EOS2.14v1.00:
cd ${ncl_src}/HDF-EOS2.14v1.00
cp -v bin/INSTALL-HDFEOS bin/INSTALL-HDFEOS.orig
ed -s bin/INSTALL-HDFEOS <<"EOF"
H
/linux)
/CC=gcc/d
i
	PGI=/opt/pgi
	PATH=${PGI}/bin:${PATH}
        CC=pgcc
.
/CFLAGS=/d
i
        CFLAGS="$opt_flag -fPIC"
.
/F77=g77*/d
i
       F77=pgf90
.
/F77FLAGS="$opt_flag"/d
i
        F77FLAGS="$opt_flag -fPIC"
.
wq
EOF
echo HDFINC=${ncl_dev_inc} HDFLIB=${ncl_dev_lib} bin/INSTALL-HDFEOS
HDFINC=${ncl_dev_inc} HDFLIB=${ncl_dev_lib} bin/INSTALL-HDFEOS
cp -v lib/linux/libhdfeos.a ${ncl_dev_lib}
cp -v include/*.h ${ncl_dev_inc}

###
### Building gctp
cd ${ncl_src}/gctp/src
cp -v Makefile Makefile.orig
cp -v makelinux.pgi Makefile
#  Edit Makefile -  change gcc to "pgcc" and add "-fPIC" on the compile line.
ed -s Makefile <<EOF
H
g/CC/d
i
CC  =  pgcc -fPIC -DLINUX -Dunix
.
wq
EOF
make 2>&1 | tee ${build_sum}/gctp-makeoutput.`date +%Y%m%d`.out
cp -v ../lib/linux/libGctp.a  ${ncl_dev_lib}
cp -v ../include/*.h  ${ncl_dev_inc}


###
### Start configuration & build of NCL 
cd $NCARG
cat >> ${ncl_src}/${software}-${version}/ymakedevfile <<EOF
#undef YmakeRoot
#define YmakeRoot ${ncl_inst}
EOF

cp -v config/LINUX LINUX.orig
cp -v config/Project Project.orig
cp -v Makefile Makefile.orig
cp -v ni/src/ncl/NclHDF.c NclHDF.c.orig
cp -v ni/src/ncl/NclHDFEOS.c NclHDFEOS.c.orig
cp -v ${config_data}/NclHDFEOS.c.NCL ni/src/ncl/NclHDFEOS.c 
cp -v ${config_data}/NclHDF.c.NCL ni/src/ncl/NclHDF.c 
cp -v ${config_data}/LINUX.NCL config/LINUX
cp -v ${config_data}/Project.NCL config/Project
cp -v ${config_data}/triangle.* ${ncl_src}/${software}-${version}/ni/src/lib/hlu/
# cp -v ${config_data}/Makefile.NCL Makefile

message_hdr Building NCL with user input
echo Almost ready to start the NCL install, but please take notes here:
echo answer YES for the following:
# echo          Build NCL,  HDF support,  Triangle support,  Udunits support,  HDF-EOS support,  GRIB2 support
echo          Build NCL,  Triangle support,  Udunits support,  HDF-EOS support,  GRIB2 support
echo answer NO for the following:
echo          HDF4 w/szip support, NetCDF-4 support,  Vis5D+ support, OPeNDAP support
# echo          NetCDF-4 support,  Vis5D+ support, OPeNDAP support
echo  For local library search path, enter:
echo    /opt/repo/app_support/src/ncl_dev/lib /usr/lib64 ${netcdf_version}/lib
echo  For local include search path, enter:
echo    /opt/repo/app_support/src/ncl_dev/include /usr/include ${netcdf_version}/include 
message_hdr
read -p "Please hit a key when you are ready to continue:" yes_no

./Configure -v 2>&1 | tee ${build_sum}/ncl_configure.out.`date +%Y%m%d`.out

make Everything 2>&1 | tee ${build_sum}/ncl_makeoutput.`date +%Y%m%d`.out

rm -rf ${sw_root}/${software} ${sw_root}/${sw_link} ${sw_root}/${sw_link2} 
ln -s ${instdir} ${sw_root}/${sw_link}
ln -s ${instdir} ${sw_root}/${software}
ln -s ${instdir} ${sw_root}/${sw_link2}

rsync -avx ${ncl_inst}/ ${instdir}/
for i in ${srcdir}/rangs*zip ${srcdir}/gshh*zip ; do unzip -od ${instdir}/rangs/ $i ; done

chown -Rh root:root $instdir
cd ${repo}

# exby temporary need for ATEC range application
# borst temp fix for above
/bin/ed -s /etc/ld.so.conf <<EOF
H
g/ncl/d
g/ncarg/d
a
/opt/ncarg/lib
/opt/ncl/lib
.
wq
EOF
/sbin/ldconfig

readme_log
exit 0
##================================
##================================
Installing RPM or std OPT packages
#  Installed from source in /opt/udunits-1.12.9
#  Installed from source in /opt/netcdf-3.6.3-pgi
#  tar zxvf jpeg-6b.tgz
#  rpms installed by default in both 32 and 64bit
#  libjpeg-6b-37  &  libjpeg-devel-6b-37
#  README in source tree and in /usr/share/doc/libjpeg-6b are the same
#  tar zxvf jasper-1.900.1.zip
#  Installed from source in /opt/jasper-1.900.1 with NCAR patches
#  libraries and includes installed under /opt/jasper/ 
#  No alterations from std install for ATEC stuff noted
#  tar zxvf zlib-1.2.3.tgz
#  rpms installed by default in both 32 and 64bit
#  zlib-1.2.3-3  &   zlib-devel-1.2.3-3
#  README in source tree and in /usr/share/doc/zlib-1.2.3 are the same
#  tar zxvf flex-2.5.3.tar.gz
#  rpm installed by default in 64bit
#  flex 2.5.4a
#  README in source tree and in /usr/share/doc/flex-2.5.4a are the same
#  tar zxvf libpng-1.2.29.tar.gz
#  rpm installed by default in 32 and 64bit
#  libpng-devel-1.2.10-7.1.el5_0.1 & libpng-1.2.10-7.1.el5_0.1
#  README in source tree and in /usr/share/doc/libpng-1.2.[10 29] are different
#  source version is much newer than rpm install 1.2.10 vs 1.2.29
#cp -r /usr/lib64/libz* /usr/lib64/libjpeg* /usr/lib64/libpng* /usr/lib64/pkgconfig/libpng.pc /usr/lib64/pkgconfig/libpng12.pc ${ncl_dev_lib}
# cp -r /usr/include/zconf.h /usr/include/zlib.h /usr/include/zutil.h /usr/include/jconfig.h /usr/include/jerror.h /usr/include/jmorecfg.h /usr/include/jpeglib.h /usr/include/libpng12 /usr/include/libpng12/png.h /usr/include/libpng12/pngconf.h /usr/include/png.h /usr/include/pngconf.h ${ncl_dev_inc}

Installing RPM or std OPT packages
[root@rap-server build_inst_scripts]# cd ../src/ncl_src/
[root@rap-server ncl_src]# ls -al
total 32
drwxr-xr-x  8 root  root  4096 Dec 18 22:47 .
drwxrwxrwx 16 root  root  4096 Dec 18 22:46 ..
drwxrwxr-x  2 haley games 4096 Aug 22 21:35 g2clib-1.0.4-NCAR
drwxr-xr-x  7 haley games 4096 Dec 11  2002 gctp
drwxr-xr-x  7 haley games 4096 Dec 11  2002 Gctp
drwxr-xr-x  9 haley games 4096 Jul 23 21:06 HDF4.2r3
drwxrwxr-x 11 haley games 4096 Jul 20  2005 HDF-EOS2.14v1.00
drwxrwxr-x  9 haley games 4096 Oct 30  2007 ncl_ncarg-5.0.0

# Steps done Pre-install time::
  4b. Netcdf pre-built for Mary, no steps noted.
  5. I built jpeg-6b with:
       cd /home/haley/src/jpeg-6b
       ./configure --prefix=/home/haley/dev
       make all install install-lib install-headers >&! make-output.091508
     (I didn't worry that it couldn't install man pages.)
  6. I built zlib-1.2.3 with:
       cd /home/haley/src/zlib-1.2.3
        ./configure --prefix=/home/haley/dev
       make all install >&! make-output.091508
  8. I built jasper-1.900.1 with:
       cd /home/haley/src/jasper-1.900.1
       ./configure --prefix=/home/haley/dev
       make all install >&! make-output.091508
  9. I built libpng-1.2.29 with:
        cd /home/haley/src/libpng-1.2.29
        ./configure --prefix=/home/haley/dev --with-pic --disable-shared
        make all install >&! make-output.091508
 13. To install udunits-1.12.4:
       cd /home/haley/src/udunits-1.12.4/src
       ./configure --prefix=/home/haley/dev
       make all install >&! make-output.091508
       You will probably see some errors here regarding "perl". Don't
       worry about these. Type:
       make install
       and make sure libudunits.a and libudport.a get installed to
       /home/haley/dev/lib, and udunits.h to /home/haley/dev/include.
 14. To install flex-2.5.3:
       cd /home/haley/src/flex-2.5.3
       ./configure --prefix=/home/haley/dev
       make all install >&! make-output.091508

###
### Non-automated ncl configuration steps
###
# cd $NCARG
#cp -v config/LINUX.64.PGI config/LINUX
#ed -s config/Project <<EOF
#H
#g/lgrib2c/d
#i
##define GRIB2lib   -lgrib2c -ljasper -lpng -lz
#.
#wq
#EOF
#
#ed -s config/LINUX <<EOF
#H
#g/k8-64/d
#i
##define CCompiler     pgcc 
##define Ccoptions     -fPIC -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE
##define FCompiler     pgf90 
##define Fcoptions     -fPIC -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE
#.
#g/ArchRecLibSearch/d
#g/ArchRecIncSearch/d
#.
#wq
#EOF
#ed -s ni/src/ncl/NclHDF.c <<EOF
#H
#g/netcdf.h/d
#.
#/ctype.h
#a
##define MAX_VAR_DIMS H4_MAX_VAR_DIMS
##define MAX_NC_NAME H4_MAX_NC_NAME
##define MAX_NC_DIMS H4_MAX_NC_DIMS
#.
#wq
#EOF
#ed -s ni/src/ncl/NclHDFEOS.c <<EOF
#H
#g/netcdf.h/d
#.
#/HdfEosDef.h
#a
##define MAX_VAR_DIMS H4_MAX_VAR_DIMS
##define MAX_NC_NAME H4_MAX_NC_NAME
##define MAX_NC_DIMS H4_MAX_NC_DIMS
#.
#wq
#EOF

#   message_hdr Building NCL with user input
#   echo Almost ready to start the NCL install, but please take notes here:
#   echo answer YES for the following:
#   # echo          Build NCL,  HDF support,  Triangle support,  Udunits support,  HDF-EOS support,  GRIB2 support
#   echo          Build NCL,  Triangle support,  Udunits support,  HDF-EOS support,  GRIB2 support
#   echo answer NO for the following:
#   echo          HDF4 w/szip support, NetCDF-4 support,  Vis5D+ support, OPeNDAP support
#   # echo          NetCDF-4 support,  Vis5D+ support, OPeNDAP support
#   echo  For local library search path, enter:
#   echo    /opt/repo/app_support/src/ncl_dev/lib
#   echo  For local include search path, enter:
#   echo    /opt/repo/app_support/src/ncl_dev/include 
#   message_hdr
#   read -p "Please hit a key when you are ready to continue:" yes_no

# message_hdr  To finalize the install, when not installing from a Control script, run this command:
# rm -rf /tmp/graph_font-cap.fix
# cat >> /tmp/graph_font-cap.fix <<EOF
# #!/bin/sh
# export PGI=/opt/pgi
# export PATH=${PATH}:${PGI}/bin 
# cd $NCARG
# make install
# cd /opt/repo/app_support/src/ncl_dev
# rsync -avx . /opt/ncl/
# rm -rf /tmp/graph_font-cap.fix
# EOF
# chmod 700 /tmp/graph_font-cap.fix
# message_hdr  sh /tmp/graph_font-cap.fix 2>&1 | tee /opt/build_summary/ncl_graphc_fix.`date +%Y%m%d`.out

ed -s Makefile <<EOF
H
g/LIBSEARCH/d
i
LIBSEARCH               = -L${ncl_dev_lib} -L/usr/lib64 -L/opt/netcdf-3.6.3-pgi/lib
.
g/INCSEARCH/d
i
INCSEARCH               = -I${ncl_dev_inc} -I/usr/include -I/opt/netcdf-3.6.3-pgi/include
.
g/LIB_SEARCH/d
i
LIB_SEARCH              = -L${ncl_dev_lib} -L/usr/lib64 -L/opt/netcdf-3.6.3-pgi/lib
.
g/INC_SEARCH/d
i
INC_SEARCH              = -I${ncl_dev_inc} -I/usr/include -I/opt/netcdf-3.6.3-pgi/include
.
wq
EOF

C
C	$Id: trans.f.sed,v 1.3 2008-07-27 00:59:05 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      PROGRAM TRANS
C
C  Main program for the NCAR Fortran CGM translator.  This translator
C  will also accept NCAR pre-CGM metafiles.
C
      COMMON/TREROR/ ALLOK, MFRCHK, MTOPER, METRDC, REDERR, TYPCHG
     1             ,INVTYP, MINVLD, TYPERR, FRMEND, ENCINT, IVDCDT
     2             ,GCOERR, GCRERR, GCCERR, FCOERR, FCRERR, FCCERR
     3             ,PLIDXG, PMIDXG, TXIDXG, PGIDXG, INVLMT, CELERR
     4             ,COIERR, COLNRM, UNKNOW, UNKOPC, ENDMTF, VNEROR
     5             ,BADRSZ, DEVOUT, NOVERS, BADFNT, PGMERR, FASERR
     6             ,HINERR, VDWERR, RDWERR, RIXLIM
      INTEGER        ALLOK, MFRCHK, MTOPER, METRDC, REDERR, TYPCHG
     1             ,INVTYP, MINVLD, TYPERR, FRMEND, ENCINT, IVDCDT
     2             ,GCOERR, GCRERR, GCCERR, FCOERR, FCRERR, FCCERR
     3             ,PLIDXG, PMIDXG, TXIDXG, PGIDXG, INVLMT, CELERR
     4             ,COIERR, COLNRM, UNKNOW, UNKOPC, ENDMTF, VNEROR
     5             ,BADRSZ, DEVOUT, NOVERS, BADFNT, PGMERR, FASERR
     6             ,HINERR, VDWERR, RDWERR, RIXLIM
      COMMON /TRFRAM/ METALL, FRINIT, FRCNT
      LOGICAL METALL, FRINIT
      INTEGER  FRCNT
      COMMON /PTRBUFR/ METBIT, MBUFER, MDTYPE, METREC, MRECLN,
     1                MCONTF, MOPRST, LNGFLG, MERGFL
      INTEGER MNWRDS, RECLOC, RECSIZ, DTLOC, DTSIZ, MBITST, MBUFOF,
     1        MINSBD, MERLOC, MERSIZ
#if defined(cray)
      PARAMETER (MNWRDS=180, RECLOC=0, RECSIZ=16, DTLOC=16, DTSIZ=4
#else
      PARAMETER (MNWRDS=360, RECLOC=0, RECSIZ=16, DTLOC=16, DTSIZ=4
#endif
     1          ,MBITST=32, MBUFOF=32, MINSBD=16, MERLOC=23, MERSIZ=1)
      INTEGER METBIT, MBUFER(MNWRDS), MDTYPE, METREC, MRECLN, MOPRST
      LOGICAL MCONTF, LNGFLG, MERGFL
      COMMON/TRINOT/ IPTR, MBUFOT, MAXBYT, DEVUNT, METUNT,
     1          METIPT, ERRUNT, FNTUNT
      INTEGER MAXCNT
      PARAMETER (MAXCNT=200)
      INTEGER IPTR, MBUFOT(MAXCNT), MAXBYT, DEVUNT, METUNT, ERRUNT,
     1        FNTUNT
      LOGICAL METIPT
      COMMON /TRTYPE/ METMIN, METEXT, METPRT, METHED, MIOPCL, MXOPCL,
     1                MIOPID, MXOPID, ASCDEC, ASCHEX, ASCOCT, BINARY,
     2                GAHNOR, GALEFT, GACENT, GARITE, GAVNOR, GATOP ,
     3                GACAP , GAHALF, GABASE, GABOTT, GRIGHT, GLEFT ,
     4                GUP   ,
     5                GDOWN , CINDEX, CDIRCT, PENUP , PENDN , FLAGVL,
     6                SEPRVL, ASCTEK, TYPRGB, TYPBGR,
     7                TYPHLS, TYPMON, SOLID , DASHED, INVSBL, SOLPAT,
     8                ASFIND, ASFBND, ASFLNT, ASFLNW, ASFLNC, ASFMRT,
     9                ASFMRS, ASFMRC, ASFFIS, ASFFHI, ASFFPI, ASFFCO,
     A                ASFFPT, ASFFPW, ASFFPC, ASFTFI, ASFTPR, ASFTCX,
     B                ASFTCS, ASFTCO, ASCFLT, PHOLLO, PSOLID, PPATTR,
     C                PHATCH, PEMPTY, HHORIZ, HVERTI, HPOSLP, HNESLP,
     D                HHOAVE, HPOANE
      INTEGER         METMIN, METEXT, METPRT, METHED, MIOPCL, MXOPCL,
     1                MIOPID, MXOPID, ASCDEC, ASCHEX, ASCOCT, BINARY,
     2                GAHNOR, GALEFT, GACENT, GARITE, GAVNOR, GATOP ,
     3                GACAP , GAHALF, GABASE, GABOTT, GRIGHT, GLEFT ,
     4                GUP   ,
     5                GDOWN , CINDEX, CDIRCT, PENUP , PENDN , FLAGVL,
     6                SEPRVL, ASCTEK, TYPRGB, TYPBGR,
     7                TYPHLS, TYPMON, SOLID , DASHED, INVSBL, SOLPAT,
     8                ASFIND, ASFBND, ASFLNT, ASFLNW, ASFLNC, ASFMRT,
     9                ASFMRS, ASFMRC, ASFFIS, ASFFHI, ASFFPI, ASFFCO,
     A                ASFFPT, ASFFPW, ASFFPC, ASFTFI, ASFTPR, ASFTCX,
     B                ASFTCS, ASFTCO, ASCFLT, PHOLLO, PSOLID, PPATTR,
     C                PHATCH, PEMPTY, HHORIZ, HVERTI, HPOSLP, HNESLP,
     D                HHOAVE, HPOANE
      COMMON /THFLG/NSFLG
C
      INTEGER IOS, STATUS
      CHARACTER*1 STRING(80)
C
C Do calls forcing BLOCKDATAs to be loaded from a binary library.
C
      CALL TRNDAT
      CALL TRNDT2
C
C  Set the machine dependent constants.
C
      CALL TRNMCH
C
      STATUS = ALLOK
C
C  Determine if text and header recors should be suppressed from
C  being written to the output file.
C
      DO 10 I=1,80
        STRING(I) = ' '
   10 CONTINUE
      NSFLG = 0
      IF (IARGCT(IDUM) .GE. 0) THEN
        CALL ARGGET(1,STRING)
        IF (STRING(1).EQ.'-' .AND. (STRING(2).EQ.'n' .OR.
     -                            STRING(2).EQ.'N')) THEN
          NSFLG = 1
        ELSE
          NSFLG = 0
        ENDIF
      ENDIF
C
C  Attempt to open the metafile.
C
      CALL FNDARG(IOS,STATUS)
      IF (STATUS.NE.ALLOK) CALL ALOVER(IOS,STATUS)
C
C  Open the GKS package.
C
      CALL GOPKS(1,IDUM)
      CALL GOPWK(1,METUNT,1)
      CALL GACWK(1)
C
C  Use normalization 0.
C
      CALL GSELNT(0)
C
C  Set clipping off.
C
      CALL GSCLIP(0)
C
C  Read in the first metafile record.
C
      METREC = 1
      CALL METRED(IOS,STATUS)
      IF (STATUS.NE.ALLOK) CALL ALOVER(IOS,STATUS)
C
      FRINIT = .TRUE.
      FRCNT = 0
C
C  Loop until we run out of data, or error.
C
      CALL TRASSN(IOS,STATUS)
      IF (STATUS.NE.ALLOK .AND. STATUS.NE.ENDMTF)
     -                         CALL ALOVER(IOS,STATUS)
C
C  End the plotting and set the default color table.
C
      CALL XMDEF(IOS,STATUS)
      CALL LODCTB(IOS,STATUS)
C
C  Flush the buffer.
C
      CALL PLOTIT(0,0,2)
C
C  Close the GKS package.
C
      CALL GDAWK(1)
      CALL GCLWK(1)
      CALL GCLKS
C
      STOP
      END

#!/bin/sh

sh op_funcs.sh logical NhlTBoolean NhlTBooleanGenArray -1 > .tmp.$$

if [ ! $? ]
then
	exit $?
fi

sed \
-e 's/PRINTFORMAT/\%d\\n/' \
-e '/PRINTFORMAT/d' \
-e 's/DATATYPE/logical/g' \
-e 's/LOCALTYPE/logical/g' \
-e 's/HLUTYPEREP/NhlTBoolean/g' \
-e 's/HLUGENTYPEREP/NhlTBooleanGenArray/g' \
-e 's/DEFAULT_MISS/-1/g' \
-e 's/DEFAULT_MISS/%d/g' \
-e "/REPLACE/r .tmp.$$" \
-e '/REPLACE/d' \
-e '/DSPECIFIC/r NclTypelogical.c.specific' \
-e '/DSPECIFIC/d' \
-e 's/Ncl_Type_logical_mat_type/NULL/' \
-e 's/Ncl_Type_logical_mat/NULL/' \
-e 's/Ncl_Type_logical_mod_type/NULL/' \
-e 's/Ncl_Type_logical_mod/NULL/' \
-e 's/Ncl_Type_logical_divide_type/NULL/' \
-e 's/Ncl_Type_logical_divide/NULL/' \
-e 's/Ncl_Type_logical_multiply_type/NULL/' \
-e 's/Ncl_Type_logical_multiply/NULL/' \
-e 's/Ncl_Type_logical_plus_type/NULL/' \
-e 's/Ncl_Type_logical_plus/NULL/' \
-e 's/Ncl_Type_logical_minus_type/NULL/' \
-e 's/Ncl_Type_logical_minus/NULL/' \
-e 's/Ncl_Type_logical_exponent_type/NULL/' \
-e 's/Ncl_Type_logical_exponent/NULL/' \
-e 's/Ncl_Type_logical_sel_lt_type/NULL/' \
-e 's/Ncl_Type_logical_sel_lt/NULL/' \
-e 's/Ncl_Type_logical_sel_gt_type/NULL/' \
-e 's/Ncl_Type_logical_sel_gt/NULL/' \
-e 's/Ncl_Type_logical_neg_type/NULL/' \
-e 's/Ncl_Type_logical_neg/NULL/' \
-e 's/Ncl_Type_logical_gt_type/NULL/' \
-e 's/Ncl_Type_logical_gt/NULL/' \
-e 's/Ncl_Type_logical_lt_type/NULL/' \
-e 's/Ncl_Type_logical_lt/NULL/' \
-e 's/Ncl_Type_logical_ge_type/NULL/' \
-e 's/Ncl_Type_logical_ge/NULL/' \
-e 's/Ncl_Type_logical_le_type/NULL/' \
-e 's/Ncl_Type_logical_le/NULL/' \
-e 's/Ncl_Type_logical_is_mono/NULL/' \
-e 's/Ncl_Type_logical_cmpf/NULL/' \
NclType.c.sed > NclTypelogical.c

rm .tmp.$$

echo "created NclTypelogical.c"

exit 0

#!/bin/sh
#
#      $Id: data_h.sh,v 1.3 2009-07-10 19:54:06 huangwei Exp $
#
#########################################################################
#									#
#			   Copyright (C)  1994				#
#	     University Corporation for Atmospheric Research		#
#			   All Rights Reserved				#
#									#
#########################################################################
#
#	File:		data_h.sh
#
#	Author:		Jeff W. Boote
#			National Center for Atmospheric Research
#			PO 3000, Boulder, Colorado
#
#	Date:		Wed Jul 20 16:22:39 MDT 1994
#
#	Description:	
#
#	Usage:
#
#	Environment:
#
#	Files:
#
#
#	Options:

sed \
-e "s/FIELDNAME/${1}val/" \
-e "s/DATATYPE/$1/g" \
-e "s/LOCALTYPE/$1/g" \
-e "/DSPECIFIC/d" \
NclType.h.sed > NclType${1}.h

echo "created NclType${1}.h"

exit 0

/*
 *      $Id: NclMultiDValData.h.sed,v 1.4 1994-12-23 01:18:33 ethan Exp $
 */
/************************************************************************
*									*
*			     Copyright (C)  1994			*
*	     University Corporation for Atmospheric Research		*
*			     All Rights Reserved			*
*									*
************************************************************************/
/*
 *	File:		
 *
 *	Author:		Ethan Alpert
 *			National Center for Atmospheric Research
 *			PO 3000, Boulder, Colorado
 *
 *	Date:		Thu Jan 13 14:55:57 MST 1994
 *
 *	Description:	
 */
#ifndef NclMultiDValDATATYPEData_h
#define NclMultiDValDATATYPEData_h
#include "NclMultiDValData.h"
#include "DataSupport.h"


typedef struct _NclMultiDValDATATYPEDataPart {
	char *foo;
}NclMultiDValDATATYPEDataPart;

typedef struct _NclMultiDValDATATYPEDataRec {
	NclObjPart	obj;
	NclDataPart	data;
	NclMultiDValDataPart multidval;
	NclMultiDValDATATYPEDataPart FIELDNAME;
}NclMultiDValDATATYPEDataRec;

typedef struct _NclMultiDValDATATYPEDataClassPart {
	char *foo;
}NclMultiDValDATATYPEDataClassPart;

typedef struct _NclMultiDValDATATYPEDataClassRec {
	NclObjClassPart	obj_class;
	NclDataClassPart data_class;
	NclMultiDValDataClassPart multid_class;
	NclMultiDValDATATYPEDataClassPart FIELDNAME_class;
}NclMultiDValDATATYPEDataClassRec;

typedef struct _NclMultiDValDATATYPEDataRec* NclMultiDValDATATYPEData;
typedef struct _NclMultiDValDATATYPEDataClassRec* NclMultiDValDATATYPEDataClass;


extern NclObjClass nclMultiDValDATATYPEDataClass;

NclMultiDValData _NclMultiDValDATATYPECreate(
#if	NhlNeedProto
NclObj 		/* inst */,
NclObjClass     /* theclass */,
NclObjTypes     /* obj_type */,
unsigned int    /* obj_type_mask */,
void *          /* val */,
NclScalar *     /*missing_value*/,
int             /*n_dims*/,
int *           /*dim_sizes*/,
NclStatus       /*status*/,
NclSelectionRecord * /*sel_rec*/
#endif
);


DSPECIFIC

#endif /*NclMultiDValDATATYPEData_h */

#!/bin/csh -f
#
#	$Id: fcaps.csh,v 1.7 2008-07-27 03:58:55 haley Exp $
#
#                Copyright (C)  2000
#        University Corporation for Atmospheric Research
#                All Rights Reserved
#
# The use of this Software is governed by a License Agreement.
#
#	Name		fcaps
#
#	Author		John Clyne
#
#	Date		Wed Jun 27 13:23:39 MDT 1990
#
#	Desc.		Report all the fontcaps installed in the fontcap 
#			directory.
# 

set version = "VERSION"
set dir = `ncargpath FONTCAPDIR`
if ($status != 0) then
	exit 1
endif

foreach arg ($argv)
	switch ($arg)
	case "-V"
		echo "${0}: Version $version"
		exit 0
	default:
		echo "Usage: $0 [-V]"
		exit 1
	endsw
end


if (! -d "$dir") then
  echo "Fontcap directory <$dir> does not exist."
  exit 1
endif

cd $dir
echo "The following fontcaps are installed to ${dir}:"
foreach fcap ("" *)
	echo "	$fcap"
end

/*
 *      $Id: ncarg_path.c.sed,v 1.2 2008-07-27 12:23:45 haley Exp $
 */
/************************************************************************
*                                                                       *
*			     Copyright (C)  2000	                        		*
*	     University Corporation for Atmospheric Research		        *
*			     All Rights Reserved			                        *
*                                                                       *
*    The use of this Software is governed by a License Agreement.       *
*                                                                       *
************************************************************************/

/*
 *	File:		ncarg_path.c
 *
 *	Author:		John Clyne
 *			National Center for Atmospheric Research
 *			PO 3000, Boulder, Colorado
 *
 *	Date:		Tue Jul 30 13:48:29 MDT 1991
 *
 *	Description:	The function GetNCARGPath returns a fully-qualified
 *			path name for a particulary directory.
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <pwd.h>
#include <errno.h>
#include <ncarg/c.h>
#include "ncarg_path.h"

#ifdef	cray
#include <fortran.h>
#endif

/*
 *	Create a string by concatenating the names $PREFIX and $postfix
 *	$postfix is converted to caps if necessary.
 */
static	char	*create_env_name(postfix)
	char	*postfix;
{
	char	*env;
	char	*s;

	env = malloc(strlen(PREFIX) + strlen(postfix) + 1);
	if (! env) {
		ESprintf(errno, "malloc(%s)",strlen(PREFIX)+ strlen(postfix)+1);
		return(NULL);
	}

	(void) strcpy(env, PREFIX);
	s = env + strlen(env);
	(void) strcat(env, postfix);

	while (*s) {
		if (islower(*s)) {
			*s = toupper(*s);
		}
		s++;
	}

	return(env);
}

/*
 * Function:	_NGResolvePath
 *
 * Description:	This function takes a pathname and returns a pathname with
 *		all "~"'s and environment "$var"'s resolved.
 *
 * In Args:	char 	*rawfname	fname as provided
 *
 * Out Args:	
 *
 * Scope:	Global Private
 * Returns:	char *
 * Side Effect:	
 */
const char
*_NGResolvePath
#if	NeedFuncProto
(
	const char	*rawfname	/* fname as provided	*/
)
#else
(rawfname)
	const char	*rawfname;	/* fname as provided	*/
#endif
{
	static char	fname[PATH_MAX];
	char		tmpfname[PATH_MAX];
	char		buffer[PATH_MAX];
	char		*piece = NULL;
	const char	*cs;
	struct passwd	*pw = NULL;
	int		first = 1;

	if(rawfname == NULL){
		return(NULL);
	}

	fname[0] = '\0';

	strcpy(tmpfname,rawfname);
	strcpy(buffer,_NGPATHDELIMITER);
	if(tmpfname[0] == buffer[0])
		strcpy(fname,_NGPATHDELIMITER);
	piece = strtok(tmpfname,_NGPATHDELIMITER);

	while(piece != NULL){

		if(first)
			first = 0;
		else
			strcat(fname,_NGPATHDELIMITER);

		switch(*piece){

			case '~':

				if(*(piece+1) != '\0')	/* different username */
					pw = getpwnam((piece+1));
				else			/* this username      */
					pw = getpwuid(getuid());

				if(pw == NULL){
					endpwent();
					ESprintf(E_UNKNOWN,
						"Unable to Resolve \'~\' in %s",
								rawfname);
					return(NULL);
				}
				strcat(fname,pw->pw_dir);
				endpwent();

				break;

			case '$':

				if(!strncmp(piece+1,PREFIX,strlen(PREFIX)))
					cs = _NGGetNCARGEnv(piece+ 1+
								strlen(PREFIX));
				else
					cs = getenv(piece + 1);

				if(cs == NULL){
					ESprintf(E_UNKNOWN,
						"Unable to Resolve %s in %s",
								piece,rawfname);
					return(NULL);
				}
				strcat(fname,cs);

				break;

			default:

				strcat(fname,piece);
		}

		piece = strtok(NULL,_NGPATHDELIMITER);
	}

	return(fname);
}

/*
 * Function:	GetNCARGEnv
 *
 * Description:		
 *			To get GetNCARGEnv to know about additional vars
 *			simply add them to the directvars,ngdirectdirs,
 *			ngrootdirs, or nglibdirs lists.
 *			These lists are NULL terminated.
 *
 *			The directvars is a list of env vars that ncarg uses
 *			but that don't necessarily fit in the ncarg root
 *			tree and the env name doesn't start with "NCARG_".
 *
 *			The ngdirectdirs are ncarg env vars that must be
 *			specified directly to override the default values.
 *			They can not be determined from other variables.
 *
 *			The ngrootdirs are ncarg env vars that specify
 *			filenames/dirnames that are exactly under $NCARG_ROOT if
 *			they are not specified directly.
 *
 *			The nglibdirs are ncarg env vars that specify
 *			filenames/dirnames that are exactly under
 *			$NCARG_ROOT/lib/ncarg if they are not specified
 *			directly.
 *
 *			The URL var is a special case, where instead of returning
 *			the path to a directory or a filename, it actually opens
 *			the file, reads the first line, and returns this (which 
 *			should be the URL for the NG documentation).
 *
 *			This function memorizes the return values that it
 *			reports so that if they are requested again it can
 *			just return the value instead of having to recalc.
 * In Args:	
 *	name
 *
 * Out Args:
 *
 * Return Values:
 *	NULL		=> Error, ESprintf() invoked.
 *	path		Else, the env var value is returned.
 *
 * Side Effects:
 */
const	char	*_NGGetNCARGEnv(name)
	const char	*name;
{
	static char	*env_vars[] = SED_ENV_DEFS;
	static char	*env_vals[(sizeof(env_vars)/sizeof(env_vars[0]))] =
					{ NULL };

	int		i=0;
	char		**current;

	static	char	buf[PATH_MAX];
	int		found = 0;
	int     slen;
	char		*env_name=NULL;
	char		*direct_val=NULL;
	char		localname[PATH_MAX];
	char		*s = localname;
	char		stmp[PATH_MAX];
	const char	*cs = NULL;
	FILE *fp;

	strcpy(localname,name);
	while (*s) {
		if (isupper(*s)) {
			*s = tolower(*s);
		}
		s++;
	}

	/*
	 * directvars section.
	 */
	current = env_vars;
	while(*current != NULL){
		if(!strcmp(*current,localname)){
			found = 1;
			break;
		}
		current+=5; i++;
	}
	if(!found){
		ESprintf(E_UNKNOWN, "Unknown environment specifier (%s)", name);
		return(NULL);
	}

	/*
	 * if it was previously calculated just return it...
	 */
	if(env_vals[i])
		return env_vals[i];

	/*
	 * get the actual Environment vars name...
	 */
	if(*(current+1))
		env_name = *(current+1);
	else
		env_name = create_env_name(localname);

	if(!env_name){
		ESprintf(E_UNKNOWN,"Unable to create Env Name?? for (%s)",name);
		return NULL;
	}

	/*
	 * See if the user set the env var directly...
	 */
	direct_val = getenv(env_name);
	if(env_name != *(current+1))
		free(env_name);

	/*
	 * if not, look for a default or calculate...
	 */
	if(!direct_val){
		/*
		 * Is there a parent directory specified?
		 */
		if(*(current+2)){
			cs = _NGGetNCARGEnv(*(current+2));
			if(!cs)
				return NULL;
			strcpy(buf,cs);
			strcat(buf,_NGPATHDELIMITER);
			strcat(buf,localname);
			direct_val = buf;
		}
		/*
		 * Is there a backup default specified?
		 */
		else if(*(current+3)){
			direct_val = *(current+3);

			/*
			 * See if there is a check file for this default.
			 */
			if(*(current+4)){
				struct stat	sbuf;

				strcpy(buf,direct_val);
				strcat(buf,*(current+4));

				if(stat(buf, &sbuf) < 0){
					ESprintf(E_UNKNOWN,
					"%s environment variable not set",
								env_name);
					return NULL;
				}
/*
#define	EMSGSTR "\n\nWarning: %s environment variable not set.\n\tAssuming %s as the value for\n\t%s.\n\tPlease see the 'ncargintro' man page for\n\tinformation on the %s environment variable.\n\n"
				fprintf(stderr,EMSGSTR,env_name,direct_val,
							env_name,env_name);
*/
			}
		}
		/*
		 * it's default value is NULL.
		 */
		else
			return NULL;
	} else {
		if(*(current+2)){
			 (void*)_NGGetNCARGEnv(*(current+2));
		}
	}

	cs = _NGResolvePath(direct_val);

	if(cs == NULL)
		return NULL;
/*
 * Check to see if we are prompting for URL path.  If so, then
 * later we will need to open a file to get the URL.
 */
	if( strcmp(localname,NCARGURL) ) {
		env_vals[i] = malloc(strlen(cs)+1);
		if(!env_vals[i]) {
			ESprintf(errno, "malloc(%s)",strlen(cs)+1);
			return NULL;
		}
		strcpy(env_vals[i],cs);
	}
/*
 * If the user wants the URL, then we need to open the file
 * to get it.
 */
	else {
		stmp[0] = '\0';
		fp = fopen(cs,"r");
		if( fp == (FILE *) NULL) {
			(void) ESprintf(errno, "fopen(%s)", cs);
			  return NULL;
		}
		(void)fgets(stmp,PATH_MAX-1,fp);
		if( !(slen = strlen(stmp)) ) {
			ESprintf(errno, "No URL found in file (%s)",cs);
			return NULL;
		}
		if( stmp[slen-1] == '\n' ) 
		  stmp[slen-1] = '\0';
		env_vals[i] = malloc(strlen(stmp)+1);
		if(!env_vals[i]) {
			ESprintf(errno, "malloc(%s)",strlen(stmp)+1);
			return NULL;
		}
		strcpy(env_vals[i],stmp);
	}
	return env_vals[i];
}

/*
 * Function:	GetNCARGPath
 *
 * Description:	This function just calls GetNCARGEnv.  The only reason I
 *		made a new name for it is that GetNCARGEnv returns all
 *		kinds of env var's, not just path names.
 *						jeff
 *
 * In Args:	
 *
 * Out Args:	
 *
 * Scope:	
 * Returns:	
 * Side Effect:	
 */
const	char	*GetNCARGPath(path)
	const char	*path;
{
	return _NGGetNCARGEnv(path);
}

static	char	ErrMsgBuf[256];

/*
 *	return an error message when get_ncarg_path fails
 */
const	char	*get_ncarg_path_err()
{
	return(ErrMsgBuf);
}

/*
 * Function:	gngpat	- Get NCAR G Path
 *
 * Description:		This function provides a entry point for Fortran
 *			to the function _NGGetNCARGEnv(). The parameters
 *			pathlen and dirlen are provided by the fortran compiler.
 *			The fortran calling syntax should be:
 *
 *				call gngpat(path, dir, status)
 *
 * In Args:		
 *	*dir 		: The directory 
 *
 * Out Args:
 *	*path		: if status == 1 $path contains the path to $dir.
 *			  If status == -1 $path contains an error message.
 *	*status		: -1 on failure, else ok
 *
 * Return Values:
 *
 * Side Effects:
 */
void
NGCALLF(gngpat,GNGPAT)
#ifdef	cray
(path_, dir_, status)
	_fcd	path_;
	_fcd	dir_;
	int	*status;
#else
(path, dir, status, pathlen, dirlen)
	char	path[];
	char	dir[];
	int	*status;
	int	pathlen;
	int	dirlen;
#endif
{

#ifdef	cray
	int	pathlen = _fcdlen(path_);
	int	dirlen = _fcdlen(dir_);
	char	*path = path_;
	char	*dir = dir_;
#endif

	const char	*s;
	char	*dir_C = malloc(dirlen + 1);


	if (! dir_C) {
		*status = -1;
		strcpy(path, "Malloc failed");
		return;
	}

	strncpy(dir_C, dir, dirlen);
	dir_C[dirlen] = '\0';	/* strncpy does not null terminate	*/


	memset(path, 0, pathlen);
	if ((s = _NGGetNCARGEnv(dir_C)) == NULL) {
		*status = -1;
		strncpy(path, ErrMsgBuf, pathlen-1);
		return;
	}

	if ((int) strlen(s) >= pathlen) {
		*status = -1;
		strncpy(path, "Directory path too long", pathlen-1);
		return;
	}

	free((char *) dir_C);
	*status = 1;
	strcpy(path, s);
}

#!/bin/sh

sh op_funcs.sh uint NhlTUint NhlTUintGenArray 4294967295U > .tmp.$$

if [ ! $? ]
then
	exit $?
fi

sed \
-e 's/PRINTFORMAT/\%d\\n/' \
-e 's/DATATYPE/uint/g' \
-e 's/LOCALTYPE/unsigned int/g' \
-e 's/HLUTYPEREP/NhlTUint/g' \
-e 's/HLUGENTYPEREP/NhlTUintGenArray/g' \
-e 's/DEFAULT_MISS/4294967295U/g' \
-e 's/DEFAULT_FORMAT/%u/g' \
-e "/REPLACE/r .tmp.$$" \
-e '/REPLACE/d' \
-e '/DSPECIFIC/r NclTypeuint.c.specific' \
-e '/DSPECIFIC/d' \
NclType.c.sed > NclTypeuint.c

rm .tmp.$$

echo "created NclTypeuint.c"

#
#      $Id: type_support_c.sh,v 1.2 1997-09-02 20:27:38 ethan Exp $
#
#########################################################################
#									#
#			   Copyright (C)  1995				#
#	     University Corporation for Atmospheric Research		#
#			   All Rights Reserved				#
#									#
#########################################################################
#
#	File:		
#
#	Author:		Ethan Alpert
#			National Center for Atmospheric Research
#			PO 3000, Boulder, Colorado
#
#	Date:		Fri Jan 27 18:33:47 MST 1995
#
#	Description:	
#
#	Usage:
#
#	Environment:
#
#	Files:
#
#
#	Options:
#!/bin/sh


sed \
-e 's/TFUNC/multiply/g' \
TypeSupportOpTemplate.c.sed > .tmp.$$

sed \
-e 's/TFUNC/divide/g' \
TypeSupportOpTemplate.c.sed >> .tmp.$$

sed \
-e 's/TFUNC/plus/g' \
TypeSupportOpTemplate.c.sed >> .tmp.$$

sed \
-e 's/TFUNC/minus/g' \
TypeSupportOpTemplate.c.sed >> .tmp.$$

sed \
-e 's/TFUNC/exponent/g' \
TypeSupportOpTemplate.c.sed >> .tmp.$$

sed \
-e 's/TFUNC/mod/g' \
TypeSupportOpTemplate.c.sed >> .tmp.$$

sed \
-e 's/TFUNC/sel_lt/g' \
TypeSupportOpTemplate.c.sed >> .tmp.$$

sed \
-e 's/TFUNC/sel_gt/g' \
TypeSupportOpTemplate.c.sed >> .tmp.$$

sed \
-e 's/TFUNC/gt/g' \
TypeSupportOpTemplate.c.sed >> .tmp.$$

sed \
-e 's/TFUNC/lt/g' \
TypeSupportOpTemplate.c.sed >> .tmp.$$

sed \
-e 's/TFUNC/ge/g' \
TypeSupportOpTemplate.c.sed >> .tmp.$$

sed \
-e 's/TFUNC/le/g' \
TypeSupportOpTemplate.c.sed >> .tmp.$$

sed \
-e 's/TFUNC/ne/g' \
TypeSupportOpTemplate.c.sed >> .tmp.$$

sed \
-e 's/TFUNC/eq/g' \
TypeSupportOpTemplate.c.sed >> .tmp.$$

sed \
-e 's/TFUNC/ncl_and/g' \
TypeSupportOpTemplate.c.sed >> .tmp.$$

sed \
-e 's/TFUNC/ncl_or/g' \
TypeSupportOpTemplate.c.sed >> .tmp.$$

sed \
-e 's/TFUNC/ncl_xor/g' \
TypeSupportOpTemplate.c.sed >> .tmp.$$

sed \
-e 's/TFUNC/ncl_not/g' \
TypeSupportMonoOpTemplate.c.sed >> .tmp.$$

sed \
-e 's/TFUNC/neg/g' \
TypeSupportMonoOpTemplate.c.sed >> .tmp.$$

sed \
-e 's/TFUNC/mat/g' \
TypeSupportMatTemplate.c.sed >> .tmp.$$


if [ ! $? ]
then
	exit $?
fi

sed \
-e "/INSERTHERE/r .tmp.$$" \
-e '/INSERTHERE/d' \
TypeSupport.c.sed > .tmp2.$$

sed \
-e 's/ncl_and_type/and_type/g' \
-e 's/ncl_not_type/not_type/g' \
-e 's/ncl_xor_type/xor_type/g' \
-e 's/ncl_or_type/or_type/g' \
.tmp2.$$ > TypeSupport.c

rm .tmp.$$ .tmp2.$$

echo "created TypeSupport.c"

exit 0

/*
 *      $Id: NclMultiDValData.c.sed,v 1.46 2009-07-02 23:17:36 dbrown Exp $
 */
/************************************************************************
*									*
*			     Copyright (C)  1993			*
*	     University Corporation for Atmospheric Research		*
*			     All Rights Reserved			*
*									*
************************************************************************/
/*
 *	File:		
 *
 *	Author:		Ethan Alpert
 *			National Center for Atmospheric Research
 *			PO 3000, Boulder, Colorado
 *
 *	Date:		Fri Oct 29 11:36:10 MDT 1993
 *
 *	Description:	
 */

#include <stdio.h>
#ifdef NIO_LIB_ONLY
#include "niohlu.h"
#include "nioNresDB.h"
short    NCLnoPrintElem;  
#else
#include <ncarg/hlu/hlu.h>
#include <ncarg/hlu/NresDB.h>
extern short    NCLnoPrintElem;     /* for multiple element print() stmts */
#endif
#include "defs.h"
#include <errno.h>
#include "NclMultiDValData.h"
#include "TypeSupport.h"
#include "DataSupport.h"
#include <math.h>
#include <stdlib.h>
#include "NclTypestring.h"
#include "NclTypechar.h"


INSERTHERE



static struct _NclDataRec *MultiDValReadSection
#if	NhlNeedProto
(NclData self, NclSelectionRecord * sel,NclScalar *missing)
#else
(self,sel,missing)
	NclData self;
	NclSelectionRecord *sel;
	NclScalar *missing;
#endif
{
	NclMultiDValData self_md = (NclMultiDValData)self;
	NclData output_md;
	NclSelection *sel_ptr;
	void *val;
	ng_size_t i,k,from,to;

	ng_size_t current_index[NCL_MAX_DIMENSIONS];
	ng_size_t multiplier[NCL_MAX_DIMENSIONS];
	ng_size_t compare_sel[NCL_MAX_DIMENSIONS];
	ng_size_t strider[NCL_MAX_DIMENSIONS];
	ng_size_t keeper[NCL_MAX_DIMENSIONS];
	ng_size_t output_dim_sizes[NCL_MAX_DIMENSIONS];

	ng_size_t total_elements = 1;
	int n_dims_input = self_md->multidval.n_dims;
	ng_size_t n_elem=0;
	int done = 0;
	int inc_done = 0;
	ng_size_t el_size = 0;
	ng_size_t rem_count;
	ng_size_t cpy_count = 1;
	int last = 0;

/*
* Pre Conditions: 	number entries in selection record == n_dims
*			object is not scalar
* 			if it is a reorder only one reference to a values 
*				dimension is allowed (no duplicates!!)
*			if a missing value is passed in it is the same
* 			type as the value being selected
*
* First check dimension ranges.
*
* Check to see if vector subscripting is used.
*
* Compute total number of elements in output array.
* 
* Allocate array and perform selection, three types 
* (only normal subs,contains vector subs,reordering selection)
* 
* if no vector subscripting is used then add selection record to
* output object.
*/
	if(sel!= NULL){
		sel_ptr	= sel->selection;
	}
	for(i = 0 ; i < n_dims_input; i++) {
		switch(sel_ptr->sel_type) {
		case Ncl_SUB_ALL:                             
			sel_ptr->u.sub.start = 0;
		case Ncl_SUB_VAL_DEF:
			sel_ptr->u.sub.finish = (long)self_md->multidval.dim_sizes[sel_ptr->dim_num] - 1;
		case Ncl_SUB_DEF_VAL:
			if(sel_ptr->sel_type != Ncl_SUB_VAL_DEF)
				sel_ptr->u.sub.start = 0;
/*
* The above cases make sure the defaults ranges are set. This cannot happen
* until here because dim sizes are not known out side of the object
* Note all cases fall through to here (no break statement)
*/
			sel_ptr->sel_type = Ncl_SUBSCR;
		case Ncl_SUBSCR:
			if(sel_ptr->u.sub.is_single) {
				keeper[i] = 0;
			} else {
				keeper[i] = 1;
			}
			if(sel_ptr->u.sub.finish < sel_ptr->u.sub.start) {
				

				if(sel_ptr->u.sub.stride == 0 ) {
					NhlPError(NhlWARNING,NhlEUNKNOWN,"Invalid stride: stride must be positive non-zero integer");
					sel_ptr->u.sub.stride = 1;
				}

				n_elem = (ng_size_t) labs((sel_ptr->u.sub.start - sel_ptr->u.sub.finish)
					 	          / sel_ptr->u.sub.stride) + 1L;

/*
* Need to be able to determine which type of comparision < or > is needed to
* determine whether the finish has been passed up
*/
				if(sel_ptr->u.sub.stride < 0){
					current_index[i] = sel_ptr->u.sub.finish + (sel_ptr->u.sub.start - sel_ptr->u.sub.finish) % abs(sel_ptr->u.sub.stride);
					sel_ptr->u.sub.finish = sel_ptr->u.sub.start;
					sel_ptr->u.sub.start = current_index[i];
					compare_sel[i] = -2;
					strider[i] = -(sel_ptr->u.sub.stride);
					sel_ptr->u.sub.stride = strider[i];

				} else {
					compare_sel[i] = -1;
					current_index[i] = sel_ptr->u.sub.start;
					strider[i] = -(sel_ptr->u.sub.stride);
				}
			} else {
				if(sel_ptr->u.sub.stride == 0 ) {
					NhlPError(NhlWARNING,NhlEUNKNOWN,"Invalid stride: stride must be positive non-zero integer");
					sel_ptr->u.sub.stride = 1;

				}

				n_elem = (ng_size_t) labs((sel_ptr->u.sub.start - sel_ptr->u.sub.finish)
					 	          / sel_ptr->u.sub.stride) + 1L;
				
				if(sel_ptr->u.sub.stride < 0){
					compare_sel[i] = -1;
					current_index[i] = sel_ptr->u.sub.finish - (sel_ptr->u.sub.finish - sel_ptr->u.sub.start) % abs(sel_ptr->u.sub.stride);
					sel_ptr->u.sub.finish = sel_ptr->u.sub.start;
					sel_ptr->u.sub.start = current_index[i];
					strider[i] = sel_ptr->u.sub.stride;
					sel_ptr->u.sub.stride = -strider[i];

				} else {
					compare_sel[i] = -2;
					current_index[i] = sel_ptr->u.sub.start;
					strider[i] = sel_ptr->u.sub.stride;
				}
			}
			if((sel_ptr->u.sub.start > self_md->multidval.dim_sizes[sel_ptr->dim_num] - 1)||(sel_ptr->u.sub.start < 0)) {
				NhlPError(NhlFATAL,NhlEUNKNOWN,"Subscript out of range, error in subscript #%d",i);
				return(NULL);
			}

			if((sel_ptr->u.sub.finish > self_md->multidval.dim_sizes[sel_ptr->dim_num] - 1)||(sel_ptr->u.sub.finish < 0)) {
				NhlPError(NhlFATAL,NhlEUNKNOWN,"Subscript out of range, error in subscript #%d",i);
				return(NULL);
			}
			break;
		case Ncl_VECSUBSCR:
/*
* to qualify as a vector subscript must have one dimension, be integer and have
* a dim_size > 1
*/
			keeper[i] = 1;
			if((sel_ptr->u.vec.min < 0)|| (sel_ptr->u.vec.min > self_md->multidval.dim_sizes[sel_ptr->dim_num]-1)) {
				NhlPError(NhlFATAL,NhlEUNKNOWN,"Subscript out of range, error in subscript #%d",i);
				return(NULL);
			}
			if((sel_ptr->u.vec.max < 0)|| (sel_ptr->u.vec.max > self_md->multidval.dim_sizes[sel_ptr->dim_num]-1)) {
				NhlPError(NhlFATAL,NhlEUNKNOWN,"Subscript out of range, error in subscript #%d",i);
				return(NULL);
			}
			n_elem = sel_ptr->u.vec.n_ind;
			strider[i] = 0;
			current_index[i] = sel_ptr->u.vec.ind[0]; 
			compare_sel[i] = 0;
		} 
		if(sel_ptr->dim_num != n_dims_input -1) {
			multiplier[i] = 1;

			for(k = sel_ptr->dim_num + 1; k < n_dims_input ;k++) {
				multiplier[i] *= (long)self_md->multidval.dim_sizes[k];
			}
		} else {
			multiplier[i] = 1;
		}
		output_dim_sizes[i] = n_elem;
		total_elements = total_elements * n_elem;
		sel_ptr++;
	}
	sel_ptr = sel->selection;
/*
* All subscript ranges are valid. whether or not it is a reorder, and
* whether or not a vector subscript is present are known.
* also multiplier contains the appropriate multiplier by which to multiply
* an index to get the actual index in the value vector.
* the output arrays dimension sizes are known and the total number of 
* elements is known 
* the current_index array is inialized to the starting location
*
* compare_sel contains either -2 or -1 for normal subscripts or the
* index >= 0 into the integer vector array.
*/

/*
 * Now determine the amount of continguous data that may be copied in a single 
 * call to memcpy. Conditions are as follows:
 * Testing proceeds from right to left (fastest dimension to slowest);
 * If a dimension is a proper subset, dimensions to the left must be handled individually ('last' test)
 * For each dimension, its elements must not be reversed (positive stride + compare_sel[i] == -2 ensures this)
 * For each dimension stride must be 1 (strider[i] == 1)
 * The dimension cannot be reordered (its dim_num should equal its position)
 * The dimension cannot be a vector subscript (compare_sel[i] should not be positive)
 * Any dimension that does not meet these requirements ensures that dimensions to the left cannot be contiguous either. 
 */
	for (i = n_dims_input - 1; i >= 0; i--) {
		if (last || compare_sel[i] != -2 || strider[i] != 1 || (i != sel_ptr[i].dim_num))
			break;
		if (output_dim_sizes[i] < self_md->multidval.dim_sizes[sel_ptr[i].dim_num])
			last = 1;
		cpy_count *= output_dim_sizes[i];
	}
	
	el_size = self_md->multidval.type->type_class.size;
	val = (void*)NclMalloc(total_elements * el_size);
	to = 0;
	while(!done) {
		rem_count = cpy_count;
		from = 0;
		for(i = 0; i < n_dims_input;i++) {
			from = from + (current_index[i] * multiplier[i]);
		}
		memcpy((void*)((char*)val + to * el_size),(void*)((char*)self_md->multidval.val + from * el_size),el_size * cpy_count);

		if (rem_count > 1) {
			current_index[n_dims_input -1 ] += output_dim_sizes[n_dims_input -1];
			rem_count /= output_dim_sizes[n_dims_input -1];
		}
		else if (compare_sel[n_dims_input-1] <0) {
			current_index[n_dims_input -1 ] += strider[n_dims_input-1];
		} 
		else {
			compare_sel[n_dims_input-1]++;
		}
		
		for(k = n_dims_input-1; k >0; k--) {
			switch(compare_sel[k]) {
			case -2: 
				if(current_index[k] > sel_ptr[k].u.sub.finish) {
					current_index[k] = sel_ptr[k].u.sub.start;
					if (rem_count > 1) {
						current_index[k -1 ] += output_dim_sizes[k -1];
						rem_count /= output_dim_sizes[k -1];
					}
					else if(compare_sel[k-1] < 0) {
						current_index[k-1] += strider[k-1];
					} else {
						compare_sel[k-1]++;
					}
				} else {
					inc_done = 1;
				}
				break;
			case -1:
				if(current_index[k] < sel_ptr[k].u.sub.finish) {
					current_index[k] = sel_ptr[k].u.sub.start;
					if(compare_sel[k-1] < 0) {
						current_index[k-1] += strider[k-1];
					} else {
						compare_sel[k-1]++;
					}
				} else {
					inc_done = 1;
				}
				break;
			default:
/*
* Only falls through to here when vector is present because compare_sel
* is only positive when a vector is present
*/
				if(compare_sel[k] >= sel_ptr[k].u.vec.n_ind) {
					compare_sel[k] = 0;
					current_index[k] = sel_ptr[k].u.vec.ind[compare_sel[k]];
					if(compare_sel[k-1] < 0) {
						current_index[k-1] += strider[k-1];
					} else {
						compare_sel[k-1]++;
					}

				} else {
					current_index[k] = sel_ptr[k].u.vec.ind[compare_sel[k]];
					inc_done = 1;
				}
				break;
			}

			if(inc_done) {
				inc_done = 0;
				break;
			}
		}
		switch(compare_sel[0]) {
		case -2:
			if(current_index[0] > sel_ptr[0].u.sub.finish)
					done = 1;
			break;
		case -1:
			if(current_index[0] < sel_ptr[0].u.sub.finish)
					done = 1;
			break;
		default:
			if(compare_sel[0] >= sel_ptr[0].u.vec.n_ind) {
					done = 1;
			} else {
				current_index[0] = sel_ptr[0].u.vec.ind[compare_sel[0]];
			}
			break;
		}
		to +=cpy_count;
	}
	i =0;
	while(i < n_dims_input) {
		if((output_dim_sizes[i] < 2)&&(!keeper[i])) {
			for(k=i; k< n_dims_input-1;k++){
				output_dim_sizes[k] = output_dim_sizes[k+1];
				keeper[k] = keeper[k+1];
			}
			n_dims_input--;
		} else {
			i++;
		}
	}
	if(n_dims_input == 0) {
/*
* This means every one of the output_dim_sizes was one hence SCALAR 
* subsection
*/
		n_dims_input = 1;
	}
	if((self_md->multidval.missing_value.has_missing)&&
		(missing != NULL)) {
		_Nclreset_mis(self_md->multidval.type,self_md->multidval.val,&(self_md->multidval.missing_value.value),missing,total_elements);
		output_md = (NclData)_NclCreateVal(NULL,
			NULL,
			self_md->obj.obj_type,
			0,(void*)val,	
			missing,
			n_dims_input,output_dim_sizes,
			TEMPORARY,sel,(NclObjClass)self_md->multidval.type);
	} else if(self_md->multidval.missing_value.has_missing) {
		output_md = (NclData)_NclCreateVal(NULL,
			NULL,
			self_md->obj.obj_type,
			0,(void*)val,	
			&self_md->multidval.missing_value.value,
			n_dims_input,output_dim_sizes,
			TEMPORARY,sel,(NclObjClass)self_md->multidval.type);
	} else {
		output_md = (NclData)_NclCreateVal(NULL,
			NULL,
			self_md->obj.obj_type,
			0,(void*)val,	
			NULL,
			n_dims_input,output_dim_sizes,
			TEMPORARY,sel,(NclObjClass)self_md->multidval.type);
	}

	return(output_md);		
}


static NhlErrorTypes MultiDVal_md_WriteSection
#if	NhlNeedProto
(NclData target, NclSelectionRecord * sel, struct _NclDataRec* value)
#else
(target,sel,value)
	NclData target;
	NclSelectionRecord *sel;
	NclData value;
#endif
{
	NclMultiDValData target_md = (NclMultiDValData)target;
	NclMultiDValData value_md = (NclMultiDValData)value;
/*
* This selection record applys to the target record and it represents a 
* mapping from the value object into target. 
*/
	NclSelection *sel_ptr = NULL;
	void *val;
	ng_size_t i,k;
	ng_size_t from,to;

	ng_size_t current_index[NCL_MAX_DIMENSIONS];
	ng_size_t multiplier[NCL_MAX_DIMENSIONS];
	ng_size_t compare_sel[NCL_MAX_DIMENSIONS];
	ng_size_t strider[NCL_MAX_DIMENSIONS];
	ng_size_t output_dim_sizes[NCL_MAX_DIMENSIONS];

	ng_size_t dim_sizes_value [NCL_MAX_DIMENSIONS];
	int n_dims_value = 0;
	int n_dims_sel = 0;
	ng_size_t total_elements = 1;
	int n_dims_target = target_md->multidval.n_dims;
	ng_size_t n_elem=0;
	int done = 0;
	int inc_done = 0;
	int chckmiss = 0;
	logical tmpe;
	ng_size_t el_size;
	ng_size_t rem_count;
	ng_size_t cpy_count = 1;
	int last = 0;

/*
* preconditions:
*	target and value are same type of object
*	sel is a valid selection record with no duplicate indices and
* 	contains a selection entry for each dimension in target or it
* 	is null implying a direct copy.
*
* 	*****Value is a multidimensional array***** 
*	number of dimensions >= 1 && size > 1
*/

	if((target_md->multidval.missing_value.has_missing)&&
		(value_md->multidval.missing_value.has_missing)) {
		_Ncleq(target_md->multidval.type,(void*)&tmpe,(void*)&(target_md->multidval.missing_value.value),(void*)&(value_md->multidval.missing_value.value),NULL,NULL,1,1);
		if(tmpe) {
/*
* No need to check when missing values are equal
*/
			chckmiss = 0;
		} else {
			chckmiss = 1;
		}
	} else {
		chckmiss = 0;
	}
	el_size = target_md->multidval.type->type_class.size;
	
	if(sel != NULL) {
		sel_ptr = sel->selection;
	} else {
		if(target_md->multidval.totalsize == value_md->multidval.totalsize) {
			memcpy(target_md->multidval.val,value_md->multidval.val,value_md->multidval.totalsize);
			if(chckmiss) {
				_Nclreset_mis(target_md->multidval.type,target_md->multidval.val,&value_md->multidval.missing_value.value,&target_md->multidval.missing_value.value,target_md->multidval.totalelements);
			} 
			return(NhlNOERROR);
		} else {
			return(NhlFATAL);
		}
	}
        for(i = 0; i < value_md->multidval.n_dims; i++) {
                if(value_md->multidval.dim_sizes[i] > 1) {
                        dim_sizes_value[n_dims_value] = value_md->multidval.dim_sizes[i];
                        n_dims_value++;
                }
        }

	for(i = 0 ; i < n_dims_target; i++) {
		switch(sel_ptr->sel_type) {
		case Ncl_SUB_ALL:
			sel_ptr->u.sub.start = 0;
		case Ncl_SUB_VAL_DEF:
			sel_ptr->u.sub.finish = (long)target_md->multidval.dim_sizes[sel_ptr->dim_num] - 1;
		case Ncl_SUB_DEF_VAL:
			if(sel_ptr->sel_type != Ncl_SUB_VAL_DEF)
				sel_ptr->u.sub.start = 0;
/*
* The above cases make sure the defaults ranges are set. This cannot happen
* until here because dim sizes are not known out side of the object
* Note all cases fall through to here (no break statement)
*/
			sel_ptr->sel_type = Ncl_SUBSCR;
		case Ncl_SUBSCR:
			if(sel_ptr->u.sub.finish < sel_ptr->u.sub.start) {

				if(sel_ptr->u.sub.stride == 0 ) {
					NhlPError(NhlWARNING,NhlEUNKNOWN,"Invalid stride: stride must be a positive non-zero integer ");
					sel_ptr->u.sub.stride = 1;

				}

				n_elem = (ng_size_t) labs((sel_ptr->u.sub.start - sel_ptr->u.sub.finish)
					 	          / sel_ptr->u.sub.stride) + 1L;
				

				 if(sel_ptr->u.sub.stride < 0){
                                        current_index[i] = sel_ptr->u.sub.finish + (sel_ptr->u.sub.start - sel_ptr->u.sub.finish) % abs(sel_ptr->u.sub.stride);
                                        sel_ptr->u.sub.finish = sel_ptr->u.sub.start;
                                        sel_ptr->u.sub.start = current_index[i];
                                        compare_sel[i] = -2;
                                        strider[i] = -(sel_ptr->u.sub.stride);
					sel_ptr->u.sub.stride = strider[i];
                                } else {
                                        compare_sel[i] = -1;
                                        current_index[i] = sel_ptr->u.sub.start;
                                        strider[i] = -(sel_ptr->u.sub.stride);
                                }


/*
* Need to be able to determine which type of comparision < or > is needed to
* determine whether the finish has been passed up
*/

			} else {
				if(sel_ptr->u.sub.stride == 0 ) {
					NhlPError(NhlWARNING,NhlEUNKNOWN,"Invalid stride: stride must be a positive non-zero integer ");
					sel_ptr->u.sub.stride = 1;

				}

				n_elem = (ng_size_t) labs((sel_ptr->u.sub.start - sel_ptr->u.sub.finish)
					 	          / sel_ptr->u.sub.stride) + 1L;

				if(sel_ptr->u.sub.stride < 0){
                                        compare_sel[i] = -1;
                                        current_index[i] = sel_ptr->u.sub.finish - (sel_ptr->u.sub.finish - sel_ptr->u.sub.start) % abs(sel_ptr->u.sub.stride);
                                        sel_ptr->u.sub.finish = sel_ptr->u.sub.start;
                                        sel_ptr->u.sub.start = current_index[i];
                                        strider[i] = sel_ptr->u.sub.stride;
					sel_ptr->u.sub.stride = -strider[i];

                                } else {
                                        compare_sel[i] = -2;
                                        current_index[i] = sel_ptr->u.sub.start;
                                        strider[i] = sel_ptr->u.sub.stride;
                                }


			}
			if((sel_ptr->u.sub.start > target_md->multidval.dim_sizes[sel_ptr->dim_num] - 1)||(sel_ptr->u.sub.start < 0)) {
				NhlPError(NhlFATAL,NhlEUNKNOWN,"Subscript out of range, error in subscript #%d",i);
				return(NhlFATAL);
			}

			if((sel_ptr->u.sub.finish > target_md->multidval.dim_sizes[sel_ptr->dim_num] - 1)||(sel_ptr->u.sub.finish < 0)) {
				NhlPError(NhlFATAL,NhlEUNKNOWN,"Subscript out of range, error in subscript #%d",i);
				return(NhlFATAL);
			}
			break;
		case Ncl_VECSUBSCR:
/*
* to qualify as a vector subscript must have one dimension, be integer and have
* a dim_size > 1
*/
			if((sel_ptr->u.vec.min < 0)|| (sel_ptr->u.vec.min > target_md->multidval.dim_sizes[sel_ptr->dim_num]-1)) {
				NhlPError(NhlFATAL,NhlEUNKNOWN,"Subscript out of range, error in subscript #%d",i);
				return(NhlFATAL);
			}
			if((sel_ptr->u.vec.max < 0)|| (sel_ptr->u.vec.max > target_md->multidval.dim_sizes[sel_ptr->dim_num]-1)) {
				NhlPError(NhlFATAL,NhlEUNKNOWN,"Subscript out of range, error in subscript #%d",i);
				return(NhlFATAL);
			}
			n_elem = sel_ptr->u.vec.n_ind;
			strider[i] = 0;
			current_index[i] = sel_ptr->u.vec.ind[0]; 
			compare_sel[i] = 0;
		} 
/*
* This check should really be done from above before calling this function
* But I put it here just in case.
*/
		if(sel_ptr->dim_num != n_dims_target -1) {
			multiplier[i] = 1;

			for(k = sel_ptr->dim_num + 1; k < n_dims_target;k++) {
				multiplier[i] *= (long)target_md->multidval.dim_sizes[k];
			}
		} else {
			multiplier[i] = 1;
		}
		output_dim_sizes[i] = n_elem;
		total_elements = total_elements * n_elem;
		sel_ptr++;
		if(n_elem != 1) {
			if(n_elem != dim_sizes_value[n_dims_sel]) {
				NhlPError(NhlFATAL,NhlEUNKNOWN,"Dimension size mismatch on subscript #%d, left-hand and right-hand side dimensions do not match",i);
				return(NhlFATAL);
			}
			n_dims_sel++;
		}
	}
	if(total_elements != value_md->multidval.totalelements) {
		NhlPError(NhlFATAL,NhlEUNKNOWN,"Dimension sizes on right hand side of assignment do not match dimension sizes of left hand side");
		return(NhlFATAL);
	}
	if(n_dims_sel != n_dims_value) {
		NhlPError(NhlFATAL,NhlEUNKNOWN,"Left-hand side and right-hand side of assignment do not have the same number of dimensions");
		return(NhlFATAL);
		
	}
	sel_ptr = sel->selection;
/*
* all dimsizes between value and selection target match. 
* all dimsizes are in valid ranges of target dimensions.
* All subscript ranges are valid.vector subscript is present is known.
* also multiplier contains the appropriate multiplier by which to multiply
* an index to get the actual index in the target vector.
* the output arrays dimension sizes are known and the total number of 
* elements is known 
* the current_index array is inialized to the starting location
*
* compare_sel contains either -2 or -1 for normal subscripts or the
* index >= 0 into the integer vector array.
*/

/*
 * Now determine the amount of continguous data that may be copied in a single 
 * call to memcpy
 */
	for (i = n_dims_target - 1; i >= 0; i--) {
		if (last || compare_sel[i] != -2 || strider[i] != 1 || (i != sel_ptr[i].dim_num))
			break;
		if (output_dim_sizes[i] < target_md->multidval.dim_sizes[sel_ptr[i].dim_num])
			last = 1;
		cpy_count *= output_dim_sizes[i];
	}

	val = value_md->multidval.val;
	from = 0;
	while(!done) {
		rem_count = cpy_count;
		to = 0;
		for(i = 0; i < n_dims_target;i++) {
			to = to + (current_index[i] * multiplier[i]);
		}
		memcpy((void*)((char*)target_md->multidval.val + (to * el_size)),
		       (void*)((char*)val + (from * el_size)),el_size * cpy_count);
		if (rem_count > 1) {
			current_index[n_dims_target -1 ] += output_dim_sizes[n_dims_target -1];
			rem_count /= output_dim_sizes[n_dims_target -1];
		}
		else if(compare_sel[n_dims_target-1] <0) {
			current_index[n_dims_target -1 ] += strider[n_dims_target-1];
		} 
		else {
			compare_sel[n_dims_target-1]++;
		}
		for(k = n_dims_target-1; k >0; k--) {
			switch(compare_sel[k]) {
			case -2: 
				if(current_index[k] > sel_ptr[k].u.sub.finish) {
					current_index[k] = sel_ptr[k].u.sub.start;
					if (rem_count > 1) {
						current_index[k -1 ] += output_dim_sizes[k -1];
						rem_count /= output_dim_sizes[k -1];
					}
					else if(compare_sel[k-1] < 0) {
						current_index[k-1] += strider[k-1];
					} 
					else {
						compare_sel[k-1]++;
					}
				} else {
					inc_done = 1;
				}
				break;
			case -1:
				if(current_index[k] < sel_ptr[k].u.sub.finish) {
					current_index[k] = sel_ptr[k].u.sub.start;
					if(compare_sel[k-1] < 0) {
						current_index[k-1] += strider[k-1];
					} else {
						compare_sel[k-1]++;
					}
				} else {
					inc_done = 1;
				}
				break;
			default:
/*
* Only falls through to here when vector is present because compare_sel
* is only positive when a vector is present
*/
				if(compare_sel[k] >= sel_ptr[k].u.vec.n_ind) {
					compare_sel[k] = 0;
					current_index[k] = sel_ptr[k].u.vec.ind[compare_sel[k]];
					if(compare_sel[k-1] < 0) {
						current_index[k-1] += strider[k-1];
					} else {
						compare_sel[k-1]++;
					}

				} else {
					current_index[k] = sel_ptr[k].u.vec.ind[compare_sel[k]];
					inc_done = 1;
				}
				break;
			}

			if(inc_done) {
				inc_done = 0;
				break;
			}
		}
		switch(compare_sel[0]) {
		case -2:
			if(current_index[0] > sel_ptr[0].u.sub.finish)
					done = 1;
			break;
		case -1:
			if(current_index[0] < sel_ptr[0].u.sub.finish)
					done = 1;
			break;
		default:
			if(compare_sel[0] >= sel_ptr[0].u.vec.n_ind) {
					done = 1;
			} else {
				current_index[0] = sel_ptr[0].u.vec.ind[compare_sel[0]];
			}
			break;
		}
		from += cpy_count;
	}

	if(chckmiss) {
		_Nclreset_mis(target_md->multidval.type,target_md->multidval.val,&value_md->multidval.missing_value.value,&target_md->multidval.missing_value.value,target_md->multidval.totalelements);
	} else if(value_md->multidval.missing_value.has_missing && !chckmiss) {
		target_md->multidval.missing_value = value_md->multidval.missing_value;
	}
	return(NhlNOERROR);
}
static NhlErrorTypes MultiDVal_s_WriteSection
#if	NhlNeedProto
(NclData target, NclSelectionRecord * sel, struct _NclDataRec* value)
#else
(target,sel,value)
	NclData target;
	NclSelectionRecord *sel;
	NclData value;
#endif
{
	NclMultiDValData target_md = (NclMultiDValData)target;
	NclMultiDValData value_md = (NclMultiDValData)value;
/*
* This selection record applys to the target record and it represents a 
* mapping from the value object into target. 
*/
	NclSelection *sel_ptr = NULL;
	void *val;
	ng_size_t i,k,to;

	ng_size_t current_index[NCL_MAX_DIMENSIONS];
	ng_size_t multiplier[NCL_MAX_DIMENSIONS];
	ng_size_t compare_sel[NCL_MAX_DIMENSIONS];
	ng_size_t strider[NCL_MAX_DIMENSIONS];
	ng_size_t output_dim_sizes[NCL_MAX_DIMENSIONS];

	ng_size_t total_elements = 1;
	int n_dims_target = target_md->multidval.n_dims;
	long long n_elem=0;
	int done = 0;
	int inc_done = 0;
	int chckmiss = 0;
	ng_size_t el_size;
	logical tmpe;
	ng_size_t rem_count;
	ng_size_t cpy_count = 1;
	int last = 0;
	int first = 1;
	char *savep;

/*
* preconditions:
*	target and value are same type of object
*	sel is a valid selection record with no duplicate indices and
* 	contains a selection entry for each dimension in target.
*
* 	*****Value is a SCALAR array***** 
*	number of dimensions == 1 && size == 1
*/
	if((target_md->multidval.missing_value.has_missing)&&
		(value_md->multidval.missing_value.has_missing)) {
		_Ncleq(target_md->multidval.type,(void*)&tmpe,(void*)&(target_md->multidval.missing_value.value),(void*)&(value_md->multidval.missing_value.value),NULL,NULL,1,1);
		if(tmpe) {
/*
* No need to check when missing values are equal
*/
			chckmiss = 0;
		} else {
			chckmiss = 1;
		}
	} else {
		chckmiss = 0;
	}
	el_size = target_md->multidval.type->type_class.size;
	if(sel != NULL) {
		sel_ptr = sel->selection;
	} else {
		/*
		 * DIB -- this seems wrong: if the value_md has only one element it can't possible work.
		 * The totalsizes will not in general be equal, so it will return a FATAL.
		 * I suppose this branch never gets taken.
		 */
		if(target_md->multidval.totalsize == value_md->multidval.totalsize) {
			memcpy(target_md->multidval.val,value_md->multidval.val,value_md->multidval.totalsize);
                        if(chckmiss) {
                                _Nclreset_mis(target_md->multidval.type,target_md->multidval.val,&value_md->multidval.missing_value.value,&target_md->multidval.missing_value.value,target_md->multidval.totalelements);
                        }
                        return(NhlNOERROR);
                } else {
			return(NhlFATAL);
                }
        }


	for(i = 0 ; i < n_dims_target; i++) {
		switch(sel_ptr->sel_type) {
		case Ncl_SUB_ALL:
			sel_ptr->u.sub.start = 0;
		case Ncl_SUB_VAL_DEF:
			sel_ptr->u.sub.finish = target_md->multidval.dim_sizes[sel_ptr->dim_num] - 1;
		case Ncl_SUB_DEF_VAL:
			if(sel_ptr->sel_type != Ncl_SUB_VAL_DEF)
				sel_ptr->u.sub.start = 0;
/*
* The above cases make sure the defaults ranges are set. This cannot happen
* until here because dim sizes are not known out side of the object
* Note all cases fall through to here (no break statement)
*/
			sel_ptr->sel_type = Ncl_SUBSCR;
		case Ncl_SUBSCR:
			if(sel_ptr->u.sub.finish < sel_ptr->u.sub.start) {

				if(sel_ptr->u.sub.stride == 0 ) {
					NhlPError(NhlWARNING,NhlEUNKNOWN,"Invalid stride: stride must be positive non-zero integer");
					sel_ptr->u.sub.stride = 1;
				}

				n_elem = (ng_size_t) labs((sel_ptr->u.sub.start - sel_ptr->u.sub.finish)
					 	          / sel_ptr->u.sub.stride) + 1L;

/*
* Need to be able to determine which type of comparision < or > is needed to
* determine whether the finish has been passed up
*/
				if(sel_ptr->u.sub.stride < 0){
                                        current_index[i] = sel_ptr->u.sub.finish + (sel_ptr->u.sub.start - sel_ptr->u.sub.finish) % abs(sel_ptr->u.sub.stride);
                                        sel_ptr->u.sub.finish = sel_ptr->u.sub.start;
                                        sel_ptr->u.sub.start = current_index[i];
                                        compare_sel[i] = -2;
                                        strider[i] = -(sel_ptr->u.sub.stride);
					sel_ptr->u.sub.stride = strider[i];
                                } else {
                                        compare_sel[i] = -1;
                                        current_index[i] = sel_ptr->u.sub.start;
                                        strider[i] = -(sel_ptr->u.sub.stride);
                                }
			} else {
				if(sel_ptr->u.sub.stride == 0 ) {
					NhlPError(NhlWARNING,NhlEUNKNOWN,"Invalid stride: stride must be positive non-zero integer");
					sel_ptr->u.sub.stride = 1;
				}

				n_elem = (ng_size_t) labs((sel_ptr->u.sub.start - sel_ptr->u.sub.finish)
					 	          / sel_ptr->u.sub.stride) + 1L;

				if(sel_ptr->u.sub.stride < 0){
                                        compare_sel[i] = -1;
                                        current_index[i] = sel_ptr->u.sub.finish - (sel_ptr->u.sub.finish - sel_ptr->u.sub.start) % abs(sel_ptr->u.sub.stride);
                                        sel_ptr->u.sub.finish = sel_ptr->u.sub.start;
                                        sel_ptr->u.sub.start = current_index[i];
                                        strider[i] = sel_ptr->u.sub.stride;
					sel_ptr->u.sub.stride = -strider[i];

                                } else {
                                        compare_sel[i] = -2;
                                        current_index[i] = sel_ptr->u.sub.start;
                                        strider[i] = sel_ptr->u.sub.stride;
                                }


			}
			if((sel_ptr->u.sub.start > target_md->multidval.dim_sizes[sel_ptr->dim_num] - 1)||(sel_ptr->u.sub.start < 0)) {
				NhlPError(NhlFATAL,NhlEUNKNOWN,"Subscript out of range, error in subscript #%d",i);
				return(NhlFATAL);
			}

			if((sel_ptr->u.sub.finish > target_md->multidval.dim_sizes[sel_ptr->dim_num] - 1)||(sel_ptr->u.sub.finish < 0)) {
				NhlPError(NhlFATAL,NhlEUNKNOWN,"Subscript out of range, error in subscript #%d",i);
				return(NhlFATAL);
			}
			break;
		case Ncl_VECSUBSCR:
/*
* to qualify as a vector subscript must have one dimension, be integer and have
* a dim_size > 1
*/
			if((sel_ptr->u.vec.min < 0)|| (sel_ptr->u.vec.min > target_md->multidval.dim_sizes[sel_ptr->dim_num]-1)) {
				NhlPError(NhlFATAL,NhlEUNKNOWN,"Subscript out of range, error in subscript #%d",i);
				return(NhlFATAL);
			}
			if((sel_ptr->u.vec.max < 0)|| (sel_ptr->u.vec.max > target_md->multidval.dim_sizes[sel_ptr->dim_num]-1)) {
				NhlPError(NhlFATAL,NhlEUNKNOWN,"Subscript out of range, error in subscript #%d",i);
				return(NhlFATAL);
			}
			n_elem = sel_ptr->u.vec.n_ind;
			strider[i] = 0;
			current_index[i] = sel_ptr->u.vec.ind[0]; 
			compare_sel[i] = 0;
		} 
/*
* This check should really be done from above before calling this function
* But I put it here just in case.
*/
		if(sel_ptr->dim_num != n_dims_target -1) {
			multiplier[i] = 1;

			for(k = sel_ptr->dim_num + 1; k < n_dims_target;k++) {
				multiplier[i] *= target_md->multidval.dim_sizes[k];
			}
		} else {
			multiplier[i] = 1;
		}
		output_dim_sizes[i] = n_elem;
		total_elements = total_elements * n_elem;
		sel_ptr++;
	}
	sel_ptr = sel->selection;
/*
* all dimsizes are in valid ranges of target dimensions.
* All subscript ranges are valid. if vector subscript is present is known.
* also multiplier contains the appropriate multiplier by which to multiply
* an index to get the actual index in the target vector.
* the output arrays dimension sizes are known and the total number of 
* elements is known 
* the current_index array is inialized to the starting location
*
* compare_sel contains either -2 or -1 for normal subscripts or the
* index >= 0 into the integer vector array.
*/

	val = value_md->multidval.val;
	tmpe = 0;
	if(value_md->multidval.missing_value.has_missing)
		_Ncleq(value_md->multidval.type,(void*)&tmpe,(void*)&(value_md->multidval.missing_value.value),val,NULL,NULL,1,1);
/*
* chckmis is true only if *both* md's contain missing values
*/
	if((tmpe) &&(chckmiss)) {
/*
* case where val is missing value and target has missing values also
*/
		val = (void*)&(target_md->multidval.missing_value.value);
	} else if(tmpe){
/*
* case where val is missing value and target has none val is already 
* equal to missing value but target needs to be changed
*/
		target_md->multidval.missing_value.has_missing = 1;
		target_md->multidval.missing_value.value = value_md->multidval.missing_value.value;
		
	}
	for (i = n_dims_target - 1; i >= 0; i--) {
		if (last || compare_sel[i] != -2 || strider[i] != 1 || (i != sel_ptr[i].dim_num))
			break;
		if (output_dim_sizes[i] < target_md->multidval.dim_sizes[sel_ptr[i].dim_num])
			last = 1;
		cpy_count *= output_dim_sizes[i];
	}
	while(!done) {
		char *tp;
		rem_count = cpy_count;
		to = 0;
		for(i = 0; i < n_dims_target;i++) {
			to = to + (current_index[i] * multiplier[i]);
		}
		tp = ((char*)target_md->multidval.val + (to * el_size));
		/*
		 * Propagate the scalar value to contiguous elements of the array
		 */
		if (first) {
			i = 1;
			memcpy(tp,val,el_size);
			while (i <= cpy_count / 2) {
				memcpy(tp+i*el_size,tp,el_size * i);
				i *= 2;
			}
			if (cpy_count - i > 0) {
				memcpy(tp+i*el_size,tp,el_size * (cpy_count - i));
			}
			savep = tp;
			first = 0;
		}
		else {
			memcpy(tp,savep,el_size * cpy_count);
		}

		if (rem_count > 1) {
			current_index[n_dims_target -1 ] += output_dim_sizes[n_dims_target -1];
			rem_count /= output_dim_sizes[n_dims_target -1];
		}
		else if (compare_sel[n_dims_target-1] <0) {
			current_index[n_dims_target -1 ] += strider[n_dims_target-1];
		} 
		else {
			compare_sel[n_dims_target-1]++;
		}
		for(k = n_dims_target-1; k >0; k--) {
			switch(compare_sel[k]) {
			case -2: 
				if(current_index[k] > sel_ptr[k].u.sub.finish) {
					current_index[k] = sel_ptr[k].u.sub.start;
					if (rem_count > 1) {
						current_index[k -1 ] += output_dim_sizes[k -1];
						rem_count /= output_dim_sizes[k -1];
					}
					else if(compare_sel[k-1] < 0) {
						current_index[k-1] += strider[k-1];
					} else {
						compare_sel[k-1]++;
					}
				} else {
					inc_done = 1;
				}
				break;
			case -1:
				if(current_index[k] < sel_ptr[k].u.sub.finish) {
					current_index[k] = sel_ptr[k].u.sub.start;
					if(compare_sel[k-1] < 0) {
						current_index[k-1] += strider[k-1];
					} else {
						compare_sel[k-1]++;
					}
				} else {
					inc_done = 1;
				}
				break;
			default:
/*
* Only falls through to here when vector is present because compare_sel
* is only positive when a vector is present
*/
				if(compare_sel[k] >= sel_ptr[k].u.vec.n_ind) {
					compare_sel[k] = 0;
					current_index[k] = sel_ptr[k].u.vec.ind[compare_sel[k]];
					if(compare_sel[k-1] < 0) {
						current_index[k-1] += strider[k-1];
					} else {
						compare_sel[k-1]++;
					}

				} else {
					current_index[k] = sel_ptr[k].u.vec.ind[compare_sel[k]];
					inc_done = 1;
				}
				break;
			}

			if(inc_done) {
				inc_done = 0;
				break;
			}
		}
		switch(compare_sel[0]) {
		case -2:
			if(current_index[0] > sel_ptr[0].u.sub.finish)
					done = 1;
			break;
		case -1:
			if(current_index[0] < sel_ptr[0].u.sub.finish)
					done = 1;
			break;
		default:
			if(compare_sel[0] >= sel_ptr[0].u.vec.n_ind) {
					done = 1;
			} else {
				current_index[0] = sel_ptr[0].u.vec.ind[compare_sel[0]];
			}
			break;
		}
	}
	return(NhlNOERROR);
}




static NhlErrorTypes MultiDVal_ReadWriteSection
#if	NhlNeedProto
(NclData to_data, NclSelectionRecord * to_selection, NclData from_data, NclSelectionRecord *from_selection)
#else
(to_data,to_selection,from_data,from_selection)
NclData to_data;
NclSelectionRecord * to_selection;
NclData from_data;
NclSelectionRecord *from_selection;
#endif
{
	NclMultiDValData target_md = (NclMultiDValData)to_data;
	NclMultiDValData value_md = (NclMultiDValData)from_data;
/*
* This selection record applys to the target record and it represents a 
* mapping from the value object into target. 
*/

	ng_size_t i,j,k;
	ng_size_t from,to;
	NclSelection *to_sel_ptr = NULL;
	void *to_val;
	NclSelection *from_sel_ptr = NULL;
	void *from_val;

	ng_size_t to_current_index[NCL_MAX_DIMENSIONS];
	ng_size_t to_multiplier[NCL_MAX_DIMENSIONS];
	ng_size_t to_compare_sel[NCL_MAX_DIMENSIONS];
	ng_size_t to_strider[NCL_MAX_DIMENSIONS];
	ng_size_t to_output_dim_sizes[NCL_MAX_DIMENSIONS];
	ng_size_t from_current_index[NCL_MAX_DIMENSIONS];
	ng_size_t from_multiplier[NCL_MAX_DIMENSIONS];
	ng_size_t from_compare_sel[NCL_MAX_DIMENSIONS];
	ng_size_t from_strider[NCL_MAX_DIMENSIONS];
	ng_size_t from_output_dim_sizes[NCL_MAX_DIMENSIONS];

	int n_dims_value = 0;
	ng_size_t total_elements_value = 1;
	ng_size_t total_elements_target = 1;
	int n_dims_target = 0;
	int n_elem_target=0;
	int n_elem_value=0;

	int done = 0;
	int inc_done = 0;
	int chckmiss = 0;
	ng_size_t el_size;
	logical tmpe =0 ;
	ng_size_t to_rem_count,from_rem_count;
	ng_size_t from_cpy_count = 1,cpy_count = 1;
	int last = 0;
	ng_size_t from_dim_count, to_dim_count;
	ng_size_t from_left_dim, to_left_dim, jstart;
	int scalar;
	
	for(i = 0; i < NCL_MAX_DIMENSIONS; i++) {
		to_current_index[i] = 0;
		to_multiplier[i] = 0;
		to_compare_sel[i] = 0;
		to_strider[i]=0;
		to_output_dim_sizes[i]=0;
		from_current_index[i]=0;
		from_multiplier[i]=0;
		from_compare_sel[i]=0;
		from_strider[i]=0;
		from_output_dim_sizes[i]=0;
	}

	if((target_md == NULL)||(value_md == NULL) ) {
		return(NhlFATAL);
	}

	n_dims_value = value_md->multidval.n_dims;
	n_dims_target = target_md->multidval.n_dims;
	
	

/*
* preconditions:
*	target and value are same type of object
*	sel is a valid selection record with no duplicate indices and
* 	contains a selection entry for each dimension in target or it
* 	is null implying a direct copy.
*
* 	*****Value is a multidimensional array***** 
*	number of dimensions >= 1 && size > 1
*/
	if((target_md->multidval.missing_value.has_missing)&&
		(value_md->multidval.missing_value.has_missing)) {
		_Ncleq(target_md->multidval.type,(void*)&tmpe,(void*)&(target_md->multidval.missing_value.value),(void*)&(value_md->multidval.missing_value.value),NULL,NULL,1,1);
		if(tmpe) {
/*
* No need to check when missing values are equal
*/
			chckmiss = 0;
		} else {
			chckmiss = 1;
		}
	} else {
		chckmiss = 0;
	}
	el_size = target_md->multidval.type->type_class.size;

	
	if(to_selection != NULL) {
		to_sel_ptr = to_selection->selection;
	} 
	if(from_selection != NULL) {
		from_sel_ptr = from_selection->selection;
	} 
	for(i = 0 ; i < n_dims_target; i++) {
		switch(to_sel_ptr->sel_type) {
		case Ncl_SUB_ALL:
			to_sel_ptr->u.sub.start = 0;
		case Ncl_SUB_VAL_DEF:
			to_sel_ptr->u.sub.finish = (long)target_md->multidval.dim_sizes[to_sel_ptr->dim_num] - 1;
		case Ncl_SUB_DEF_VAL:
			if(to_sel_ptr->sel_type != Ncl_SUB_VAL_DEF)
				to_sel_ptr->u.sub.start = 0;
/*
* The above cases make sure the defaults ranges are set. This cannot happen
* until here because dim sizes are not known out side of the object
* Note all cases fall through to here (no break statement)
*/
			to_sel_ptr->sel_type = Ncl_SUBSCR;
		case Ncl_SUBSCR:
			if(to_sel_ptr->u.sub.finish < to_sel_ptr->u.sub.start) {

				if(to_sel_ptr->u.sub.stride == 0 ) {
					NhlPError(NhlWARNING,NhlEUNKNOWN,"Invalid stride: stride must be a positive non-zero integer");
					to_sel_ptr->u.sub.stride = 1;
				}

				n_elem_target = (ng_size_t) labs((to_sel_ptr->u.sub.start - to_sel_ptr->u.sub.finish)
					 	          / to_sel_ptr->u.sub.stride) + 1L;

/*
* Need to be able to determine which type of comparision < or > is needed to
* determine whether the finish has been passed up
*/
				if(to_sel_ptr->u.sub.stride < 0){
                                        to_current_index[i] = to_sel_ptr->u.sub.finish + (to_sel_ptr->u.sub.start - to_sel_ptr->u.sub.finish) % abs(to_sel_ptr->u.sub.stride);
                                        to_sel_ptr->u.sub.finish = to_sel_ptr->u.sub.start;
                                        to_sel_ptr->u.sub.start = to_current_index[i];
                                        to_compare_sel[i] = -2;
                                        to_strider[i] = -(to_sel_ptr->u.sub.stride);
					to_sel_ptr->u.sub.stride = to_strider[i];
                                } else {
                                        to_compare_sel[i] = -1;
                                        to_current_index[i] = to_sel_ptr->u.sub.start;
                                        to_strider[i] = -(to_sel_ptr->u.sub.stride);
                                }


			} else {
				if(to_sel_ptr->u.sub.stride == 0 ) {
					NhlPError(NhlWARNING,NhlEUNKNOWN,"Invalid stride: stride must be a positive non-zero integer");
					to_sel_ptr->u.sub.stride = 1;

				}

				n_elem_target = (ng_size_t) labs((to_sel_ptr->u.sub.start - to_sel_ptr->u.sub.finish)
					 	          / to_sel_ptr->u.sub.stride) + 1L;

				if(to_sel_ptr->u.sub.stride < 0){
                                        to_compare_sel[i] = -1;
                                        to_current_index[i] = to_sel_ptr->u.sub.finish - (to_sel_ptr->u.sub.finish - to_sel_ptr->u.sub.start) % abs(to_sel_ptr->u.sub.stride);
                                        to_sel_ptr->u.sub.finish = to_sel_ptr->u.sub.start;
                                        to_sel_ptr->u.sub.start = to_current_index[i];
                                        to_strider[i] = to_sel_ptr->u.sub.stride;
					to_sel_ptr->u.sub.stride = -to_strider[i];

                                } else {
                                        to_compare_sel[i] = -2;
                                        to_current_index[i] = to_sel_ptr->u.sub.start;
                                        to_strider[i] = to_sel_ptr->u.sub.stride;
                                }

				
			}
			if((to_sel_ptr->u.sub.start > target_md->multidval.dim_sizes[to_sel_ptr->dim_num] - 1)||(to_sel_ptr->u.sub.start < 0)) {
				NhlPError(NhlFATAL,NhlEUNKNOWN,"Subscript out of range, error in subscript #%d",i);
				return(NhlFATAL);
			}

			if((to_sel_ptr->u.sub.finish > target_md->multidval.dim_sizes[to_sel_ptr->dim_num] - 1)||(to_sel_ptr->u.sub.finish < 0)) {
				NhlPError(NhlFATAL,NhlEUNKNOWN,"Subscript out of range, error in subscript #%d",i);
				return(NhlFATAL);
			}
			break;
		case Ncl_VECSUBSCR:
/*
* to qualify as a vector subscript must have one dimension, be integer and have
* a dim_size > 1
*/
			if((to_sel_ptr->u.vec.min < 0)|| (to_sel_ptr->u.vec.min > target_md->multidval.dim_sizes[to_sel_ptr->dim_num]-1)) {
				NhlPError(NhlFATAL,NhlEUNKNOWN,"Subscript out of range, error in subscript #%d",i);
				return(NhlFATAL);
			}
			if((to_sel_ptr->u.vec.max < 0)|| (to_sel_ptr->u.vec.max > target_md->multidval.dim_sizes[to_sel_ptr->dim_num]-1)) {
				NhlPError(NhlFATAL,NhlEUNKNOWN,"Subscript out of range, error in subscript #%d",i);
				return(NhlFATAL);
			}
			n_elem_target = to_sel_ptr->u.vec.n_ind;
			to_strider[i] = 0;
			to_current_index[i] = to_sel_ptr->u.vec.ind[0]; 
			to_compare_sel[i] = 0;
		} 
/*
* This check should really be done from above before calling this function
* But I put it here just in case.
*/
		if(to_sel_ptr->dim_num != n_dims_target -1) {
			to_multiplier[i] = 1;

			for(k = to_sel_ptr->dim_num + 1; k < n_dims_target;k++) {
				to_multiplier[i] *= (long)target_md->multidval.dim_sizes[k];
			}
		} else {
			to_multiplier[i] = 1;
		}
		to_output_dim_sizes[i] = n_elem_target < 1 ? 1 : n_elem_target;
		total_elements_target = total_elements_target * n_elem_target;
		to_sel_ptr++;
	}

	for(i = 0 ; i < n_dims_value; i++) {
		switch(from_sel_ptr->sel_type) {
		case Ncl_SUB_ALL:
			from_sel_ptr->u.sub.start = 0;
		case Ncl_SUB_VAL_DEF:
			from_sel_ptr->u.sub.finish = (long)value_md->multidval.dim_sizes[from_sel_ptr->dim_num] - 1;
		case Ncl_SUB_DEF_VAL:
			if(from_sel_ptr->sel_type != Ncl_SUB_VAL_DEF)
				from_sel_ptr->u.sub.start = 0;
/*
* The above cases make sure the defaults ranges are set. This cannot happen
* until here because dim sizes are not known out side of the object
* Note all cases fall through to here (no break statement)
*/
			from_sel_ptr->sel_type = Ncl_SUBSCR;
		case Ncl_SUBSCR:
			if(from_sel_ptr->u.sub.finish < from_sel_ptr->u.sub.start) {

				if(from_sel_ptr->u.sub.stride == 0 ) {
					NhlPError(NhlWARNING,NhlEUNKNOWN,"Invalid stride: stride must be a positive non-zero integer");
					from_sel_ptr->u.sub.stride = 1;

				}

				n_elem_value = (ng_size_t) labs((from_sel_ptr->u.sub.start - from_sel_ptr->u.sub.finish)
					 	          / from_sel_ptr->u.sub.stride) + 1L;

/*
* Need from be able from determine which type of comparision < or > is needed from
* determine whether the finish has been passed up
*/
				if(from_sel_ptr->u.sub.stride < 0){
                                        from_current_index[i] = from_sel_ptr->u.sub.finish + (from_sel_ptr->u.sub.start - from_sel_ptr->u.sub.finish) % abs(from_sel_ptr->u.sub.stride);
                                        from_sel_ptr->u.sub.finish = from_sel_ptr->u.sub.start;
                                        from_sel_ptr->u.sub.start = from_current_index[i];
                                        from_compare_sel[i] = -2;
                                        from_strider[i] = -(from_sel_ptr->u.sub.stride);
					from_sel_ptr->u.sub.stride = from_strider[i];
                                } else {
                                        from_compare_sel[i] = -1;
                                        from_current_index[i] = from_sel_ptr->u.sub.start;
                                        from_strider[i] = -(from_sel_ptr->u.sub.stride);
                                }


			} else {
				if(from_sel_ptr->u.sub.stride == 0 ) {
					NhlPError(NhlWARNING,NhlEUNKNOWN,"Invalid stride: stride must be a positive non-zero integer");
					from_sel_ptr->u.sub.stride = 1;
				}

				n_elem_value = (ng_size_t) labs((from_sel_ptr->u.sub.start - from_sel_ptr->u.sub.finish)
					 	          / from_sel_ptr->u.sub.stride) + 1L;
				
				if(from_sel_ptr->u.sub.stride < 0){
                                        from_compare_sel[i] = -1;
                                        from_current_index[i] = from_sel_ptr->u.sub.finish - (from_sel_ptr->u.sub.finish - from_sel_ptr->u.sub.start) % abs(from_sel_ptr->u.sub.stride);
                                        from_sel_ptr->u.sub.finish = from_sel_ptr->u.sub.start;
                                        from_sel_ptr->u.sub.start = from_current_index[i];
                                        from_strider[i] = from_sel_ptr->u.sub.stride;
					from_sel_ptr->u.sub.stride = -from_strider[i];
                                } else {
                                        from_compare_sel[i] = -2;
                                        from_current_index[i] = from_sel_ptr->u.sub.start;
                                        from_strider[i] = from_sel_ptr->u.sub.stride;
                                }

			}
			if((from_sel_ptr->u.sub.start > value_md->multidval.dim_sizes[from_sel_ptr->dim_num] - 1)||(from_sel_ptr->u.sub.start < 0)) {
				NhlPError(NhlFATAL,NhlEUNKNOWN,"Subscript out of range, error in subscript #%d",i);
				return(NhlFATAL);
			}

			if((from_sel_ptr->u.sub.finish > value_md->multidval.dim_sizes[from_sel_ptr->dim_num] - 1)||(from_sel_ptr->u.sub.finish < 0)) {
				NhlPError(NhlFATAL,NhlEUNKNOWN,"Subscript out of range, error in subscript #%d",i);
				return(NhlFATAL);
			}
			break;
		case Ncl_VECSUBSCR:
/*
* to qualify as a vector subscript must have one dimension, be integer and have
* a dim_size > 1
*/
			if((from_sel_ptr->u.vec.min < 0)|| (from_sel_ptr->u.vec.min > value_md->multidval.dim_sizes[from_sel_ptr->dim_num]-1)) {
				NhlPError(NhlFATAL,NhlEUNKNOWN,"Subscript out of range, error in subscript #%d",i);
				return(NhlFATAL);
			}
			if((from_sel_ptr->u.vec.max < 0)|| (from_sel_ptr->u.vec.max > value_md->multidval.dim_sizes[from_sel_ptr->dim_num]-1)) {
				NhlPError(NhlFATAL,NhlEUNKNOWN,"Subscript out of range, error in subscript #%d",i);
				return(NhlFATAL);
			}
			n_elem_value = from_sel_ptr->u.vec.n_ind;
			from_strider[i] = 0;
			from_current_index[i] = from_sel_ptr->u.vec.ind[0]; 
			from_compare_sel[i] = 0;
		} 
/*
* This check should really be done from above before calling this function
* But I put it here just in case.
*/
		if(from_sel_ptr->dim_num != n_dims_value -1) {
			from_multiplier[i] = 1;

			for(k = from_sel_ptr->dim_num + 1; k < n_dims_value;k++) {
				from_multiplier[i] *= (long)value_md->multidval.dim_sizes[k];
			}
		} else {
			from_multiplier[i] = 1;
		}
		from_output_dim_sizes[i] = n_elem_value < 1 ? 1 : n_elem_value;
		total_elements_value =total_elements_value * n_elem_value;
		from_sel_ptr++;
	}

	to_sel_ptr = to_selection->selection;
	from_sel_ptr = from_selection->selection;
	to_val = target_md->multidval.val;
	from_val = value_md->multidval.val;

/*
 * find the dim count after subscripting and the left most non-unitary dimension
 */


	from_dim_count = 0;
	from_left_dim = -1;
	for (i = 0; i < n_dims_value; i++) {
		if (from_output_dim_sizes[i] > 1) {
			if (from_left_dim == -1) {
				from_left_dim = i;
			}
			from_dim_count++;
		}
	}
	if (from_dim_count == 0) {
		from_dim_count = 1;
		from_left_dim = 0;
	}

	to_dim_count = 0;
	to_left_dim = -1;
	for (i = 0; i < n_dims_target; i++) {
		if (to_output_dim_sizes[i] > 1) {
			if (to_left_dim == -1) {
				to_left_dim = i;
			}
			to_dim_count++;
		}
	}
	if (to_dim_count == 0) {
		to_dim_count = 1;
		to_left_dim = 0;
	}
/*
 * if from_dim_count == 1 and 	from_output_dim_sizes[from_left_dim] == 1, it turns into a 
 * scalar assignment
 */
	scalar = from_dim_count == 1 && from_output_dim_sizes[from_left_dim] == 1;

/*
 * if not scalar then check that the number of dimensions after subscripting is equal,
 * and that the non-unitary dimensions match in number of elements proceeding left to right.
 */   

	if (! scalar) {	
		if(to_dim_count != from_dim_count) {
			NhlPError(NhlFATAL,NhlEUNKNOWN,"Right hand side of assignment has (%d) dimensions and left hand side has (%d), dimension mismatch",from_dim_count,to_dim_count);
			return(NhlFATAL);
		}

		k = 0; /* counts dims after subscripting */
		jstart = from_left_dim;
		for (i = to_left_dim; i <  n_dims_target; i++) {
			if (to_output_dim_sizes[i] <= 1) /* should never be less than 1 */
				continue;
			for (j = jstart; j < n_dims_value; j++) {
				if (from_output_dim_sizes[j] <= 1)
					continue;
				if (to_output_dim_sizes[i] == from_output_dim_sizes[j]) {
					jstart = j+1;
					k++;
					break;
				}
				NhlPError(NhlFATAL,NhlEUNKNOWN,"Dimension size mismatch, dimension (%d) of left hand side reference does not have the same size as the right hand side reference after subscripting.",k);
				return(NhlFATAL);
			}
		}
	}

/*
 * Now determine the amount of continguous data that may be copied in a single 
 * call to memcpy
 */
	if (! chckmiss) {
		last = 0;
		for (i = n_dims_value - 1; i >= 0; i--) {
			if (last || from_compare_sel[i] != -2 || from_strider[i] != 1 || (i != from_sel_ptr[i].dim_num))
				break;
			if (from_output_dim_sizes[i] < value_md->multidval.dim_sizes[from_sel_ptr[i].dim_num])
				last = 1;
			from_cpy_count *= from_output_dim_sizes[i];
		}
		last = 0;
		for (i = n_dims_target - 1; i >= 0; i--) {
			if (last || to_compare_sel[i] != -2 || to_strider[i] != 1 || (i != to_sel_ptr[i].dim_num))
				break;
			if (to_output_dim_sizes[i] < target_md->multidval.dim_sizes[to_sel_ptr[i].dim_num])
				last = 1;
			cpy_count *= to_output_dim_sizes[i];
		}
		cpy_count = cpy_count > from_cpy_count ? from_cpy_count : cpy_count;
	}
/*
 * copy the data
 */

	while(!done) {
		to_rem_count = from_rem_count = cpy_count;
		to = 0;
		from = 0;
		for(i = 0; i < n_dims_target;i++) {
			to = to + (to_current_index[i] * to_multiplier[i]);
		}
		for(i = 0; i < n_dims_value;i++) {
			from = from + (from_current_index[i] * from_multiplier[i]);
		}
		if(chckmiss) {
			tmpe = 0;
			_Ncleq(target_md->multidval.type,(void*)&tmpe,(void*)((char*)from_val + (from * el_size)),(void*)&(value_md->multidval.missing_value.value),NULL,NULL,1,1);	
			if(tmpe) {
				memcpy((void*)((char*)to_val + (to*el_size)),(void*)&(target_md->multidval.missing_value.value),el_size);
			} else {
				memcpy((void*)((char*)to_val + (to*el_size)),(void*)((char*)from_val + (from * el_size)),el_size);
			}
		} else {
			memcpy((void*)((char*)to_val + (to*el_size)),(void*)((char*)from_val + (from * el_size)),el_size * cpy_count);
		}
		if (to_rem_count > 1) {
			to_current_index[n_dims_target -1 ] += to_output_dim_sizes[n_dims_target -1];
			to_rem_count /= to_output_dim_sizes[n_dims_target -1];
		}
		else if (to_compare_sel[n_dims_target-1] <0) {
			to_current_index[n_dims_target -1 ] += to_strider[n_dims_target-1];
		} else {
			to_compare_sel[n_dims_target-1]++;
		}
		if (! scalar) {
			if (from_rem_count > 1) {
				from_current_index[n_dims_value -1 ] += from_output_dim_sizes[n_dims_value -1];
				from_rem_count /= from_output_dim_sizes[n_dims_value -1];
			}
			else if (from_compare_sel[n_dims_value -1] <0) {
				from_current_index[n_dims_value -1 ] += from_strider[n_dims_value-1];
			} else {
				from_compare_sel[n_dims_value-1]++;
			}
		}
		for(k = n_dims_target-1; k >0; k--) {
			switch(to_compare_sel[k]) {
			case -2: 
				if(to_current_index[k] > to_sel_ptr[k].u.sub.finish) {
					to_current_index[k] = to_sel_ptr[k].u.sub.start;
					if (to_rem_count > 1) {
						to_current_index[k -1 ] += to_output_dim_sizes[k -1];
						to_rem_count /= to_output_dim_sizes[k -1];
					}
					else if(to_compare_sel[k-1] < 0) {
						to_current_index[k-1] += to_strider[k-1];
					} else {
						to_compare_sel[k-1]++;
					}
				} else {
					inc_done = 1;
				}
				break;
			case -1:
				if(to_current_index[k] < to_sel_ptr[k].u.sub.finish) {
					to_current_index[k] = to_sel_ptr[k].u.sub.start;
					if(to_compare_sel[k-1] < 0) {
						to_current_index[k-1] += to_strider[k-1];
					} else {
						to_compare_sel[k-1]++;
					}
				} else {
					inc_done = 1;
				}
				break;
			default:
				if(to_compare_sel[k] >= to_sel_ptr[k].u.vec.n_ind) {
					to_compare_sel[k] = 0;
					to_current_index[k] = to_sel_ptr[k].u.vec.ind[to_compare_sel[k]];
					if(to_compare_sel[k-1] < 0) {
						to_current_index[k-1] += to_strider[k-1];
					} else {
						to_compare_sel[k-1]++;
					}

				} else {
					to_current_index[k] = to_sel_ptr[k].u.vec.ind[to_compare_sel[k]];
					inc_done = 1;
				}
				break;
			}

			if(inc_done) {
				inc_done = 0;
				break;
			}
		}
		switch(to_compare_sel[0]) {
		case -2:
			if(to_current_index[0] > to_sel_ptr[0].u.sub.finish)
					done = 1;
			break;
		case -1:
			if(to_current_index[0] < to_sel_ptr[0].u.sub.finish)
					done = 1;
			break;
		default:
			if(to_compare_sel[0] >= to_sel_ptr[0].u.vec.n_ind) {
					done = 1;
			} else {
				to_current_index[0] = to_sel_ptr[0].u.vec.ind[to_compare_sel[0]];
			}
			break;
		}
		if (! scalar) {
			for(k = n_dims_value -1; k >0; k--) {
				switch(from_compare_sel[k]) {
				case -2: 
					if(from_current_index[k] > from_sel_ptr[k].u.sub.finish) {
						from_current_index[k] = from_sel_ptr[k].u.sub.start;
						if (from_rem_count > 1) {
							from_current_index[k -1 ] += from_output_dim_sizes[k -1];
							from_rem_count /= from_output_dim_sizes[k -1];
						}
						else if(from_compare_sel[k-1] < 0) {
							from_current_index[k-1] += from_strider[k-1];
						} else {
							from_compare_sel[k-1]++;
						}
					} else {
						inc_done = 1;
					}
					break;
				case -1:
					if(from_current_index[k] < from_sel_ptr[k].u.sub.finish) {
						from_current_index[k] = from_sel_ptr[k].u.sub.start;
						if(from_compare_sel[k-1] < 0) {
							from_current_index[k-1] += from_strider[k-1];
						} else {
							from_compare_sel[k-1]++;
						}
					} else {
						inc_done = 1;
					}
					break;
				default:
					if(from_compare_sel[k] >= from_sel_ptr[k].u.vec.n_ind) {
						from_compare_sel[k] = 0;
						from_current_index[k] = from_sel_ptr[k].u.vec.ind[from_compare_sel[k]];
						if(from_compare_sel[k-1] < 0) {
							from_current_index[k-1] += from_strider[k-1];
						} else {
							from_compare_sel[k-1]++;
						}
	
					} else {
						from_current_index[k] = from_sel_ptr[k].u.vec.ind[from_compare_sel[k]];
						inc_done = 1;
					}
					break;
				}
	
				if(inc_done) {
					inc_done = 0;
					break;
				}
			}
			switch(from_compare_sel[0]) {
			case -2:
				if(from_current_index[0] > from_sel_ptr[0].u.sub.finish)
						done = 1;
				break;
			case -1:
				if(from_current_index[0] < from_sel_ptr[0].u.sub.finish)
						done = 1;
				break;
			default:
				if(from_compare_sel[0] >= from_sel_ptr[0].u.vec.n_ind) {
						done = 1;
				} else {
					from_current_index[0] = from_sel_ptr[0].u.vec.ind[from_compare_sel[0]];
				}
				break;
			}
		}
	}
	if(value_md->multidval.missing_value.has_missing&&!chckmiss) {
/*
* This condition is when value has missing value that could've been
* assigned and target doesn't have a missing_value record.
*/
		target_md->multidval.missing_value.has_missing = 1;
		target_md->multidval.missing_value.value = value_md->multidval.missing_value.value;
	}
	return(NhlNOERROR);
}

static NhlErrorTypes MultiDValAddParent
#if	NhlNeedProto
(NclObj theobj, NclObj parent)
#else 
(theobj, parent)
NclObj theobj;
NclObj parent;
#endif
{
	NclRefList * tmp = NULL;

	tmp = theobj->obj.parents;
	theobj->obj.parents = NclMalloc((unsigned)sizeof(NclRefList));
	theobj->obj.parents->next = tmp;
	theobj->obj.parents->pid= parent->obj.id;
	theobj->obj.ref_count++;
	return(NhlNOERROR);
}

static NhlErrorTypes MultiDValDelParent
#if	NhlNeedProto
(NclObj theobj, NclObj parent)
#else 
(theobj, parent)
NclObj theobj;
NclObj parent;
#endif
{
	NclRefList *tmp,*tmp1;
	int found = 0;

	if(theobj->obj.parents == NULL) {
		if(0 == strcmp("MultiDVallistData", parent->obj.class_ptr->obj_class.class_name))
		{
			return(NhlNOERROR);
		}
		else
		{
			NHLPERROR((NhlFATAL,NhlEUNKNOWN,"MultiDValDelParent: Attempt to delete parent from empty list"));
			return(NhlFATAL);
		}
	} 

	tmp = theobj->obj.parents;	
	while((tmp!=NULL)&&(tmp->pid == parent->obj.id)) {
		theobj->obj.parents = theobj->obj.parents->next;
		NclFree(tmp);
		tmp = theobj->obj.parents;
		found = 1;
		theobj->obj.ref_count--;
	}
	if((tmp == NULL)&&(found)) {
		_NclDestroyObj(theobj);
		return(NhlNOERROR);
	}
	while(tmp->next != NULL) {
		if(tmp->next->pid == parent->obj.id) {
			found = 1;
			tmp1 = tmp->next;
			tmp->next = tmp->next->next;
			NclFree(tmp1);
			theobj->obj.ref_count--;
		} else {
			tmp = tmp->next;
		}
	}
	if(found) {
		if(theobj->obj.ref_count <= 0) 
			_NclDestroyObj(theobj);
		return(NhlNOERROR);
	} else {
		return(NhlWARNING);
	}
}

static NclData MultiDValDup
#if	NhlNeedProto
(NclData self,NclScalar *new_missing)
#else
(self,new_missing)
NclData self;
NclScalar *new_missing;
#endif
{
	void *new_val;
	NclMultiDValData self_md = (NclMultiDValData)self;
	NclMultiDValData output_md = NULL;

	new_val = (void*)NclMalloc(self_md->multidval.totalsize);
	memcpy(new_val,self_md->multidval.val,self_md->multidval.totalsize);

	output_md = _NclCreateVal(
		NULL,
		NULL,
		self_md->obj.obj_type,
		self_md->obj.obj_type_mask,
		new_val,
		((self_md->multidval.missing_value.has_missing)? ((new_missing != NULL) ? new_missing : &(self_md->multidval.missing_value.value)) : NULL),
		self_md->multidval.n_dims,
		self_md->multidval.dim_sizes,
		TEMPORARY,
		NULL,
		(NclObjClass)self_md->multidval.type
	);	
	if(output_md != NULL) {
		if((new_missing != NULL)&&(self_md->multidval.missing_value.has_missing)) {
			_Nclreset_mis(output_md->multidval.type,output_md->multidval.val,&(self_md->multidval.missing_value.value),new_missing,self_md->multidval.totalelements);
			output_md->multidval.missing_value.has_missing = 1;
			output_md->multidval.missing_value.value = *new_missing;
		} 	
	}
	return((NclData)output_md);
}

NclData MultiDVal_md_Not
#if	NhlNeedProto
(NclData self,NclData result)
#else
(self,result)
NclData self;
NclData result;
#endif
{
	NclMultiDValData self_md = (NclMultiDValData)self;
	NclMultiDValData result_md = (NclMultiDValData)result;
	NclMissingRec themissing;
	NclMultiDValData output_md = NULL;
	NclTypeClass the_type;
	void *result_val;

	if(self_md == NULL) return(NULL);

	if(self_md->multidval.missing_value.has_missing) {
                themissing.value = self_md->multidval.missing_value.value;
                themissing.has_missing = 1;
        } else {
                themissing.has_missing = 0;
        }	
	if((self_md->multidval.type != NULL)&&(((NclTypeClass)self_md->multidval.type)->type_class.ncl_not != NULL)) {

/*
* the_type is not null since requirement if not != NULL not_type != NULL
*/

                the_type = _Nclnot_type(self_md->multidval.type);
		if((the_type->type_class.data_type == NCL_logical)&&(themissing.has_missing)) {
			themissing.value = the_type->type_class.default_mis;
		}
                result_val = (void*)NclMalloc(self_md->multidval.totalelements * the_type->type_class.size);
                if(result_val == NULL) {
                        NhlPError(NhlFATAL,NhlEUNKNOWN,"Not: Could not allocate memory for result type, can't continue\n");
                        return(NULL);
                }
                if(_Nclncl_not(
                        self_md->multidval.type,
                        result_val,
                        self_md->multidval.val,
                        (self_md->multidval.missing_value.has_missing?(void*)&self_md->multidval.missing_value.value:NULL),
                        self_md->multidval.totalelements) != NhlFATAL) {

                        output_md = _NclCreateMultiDVal(
                                (NclObj)result_md,
                                NULL,
                                Ncl_MultiDValData,
                                0,
                                result_val,
                                (themissing.has_missing? &(themissing.value):NULL),
                                self_md->multidval.n_dims,
                                self_md->multidval.dim_sizes,
                                TEMPORARY,
                                NULL,
                                the_type
                        );
                        return((NclData)output_md);
                } else {
                        NclFree(result_val);
                        return(NULL);
                }
	} else {
		NhlPError(NhlFATAL,NhlEUNKNOWN,"Not: operation not supported on type (%s)",_NclBasicDataTypeToName(self_md->multidval.data_type));
		return(NULL);
	}
}
static NclData MultiDVal_md_Neg
#if	NhlNeedProto
(NclData self,NclData result)
#else
(self,result)
NclData self;
NclData result;
#endif
{
	NclMultiDValData self_md = (NclMultiDValData)self;
	NclMultiDValData result_md = (NclMultiDValData)result;
	NclMissingRec themissing;
	NclMultiDValData output_md = NULL;
	NclTypeClass the_type;
	void *result_val;

	if(self_md == NULL) return(NULL);

	if(self_md->multidval.missing_value.has_missing) {
                themissing.value = self_md->multidval.missing_value.value;
                themissing.has_missing = 1;
        } else {
                themissing.has_missing = 0;
        }	

	if((self_md->multidval.type != NULL)&&(((NclTypeClass)self_md->multidval.type)->type_class.neg != NULL)) {

/*
* the_type is not null since requirement if neg != NULL neg_type != NULL
*/

                the_type = _Nclneg_type(self_md->multidval.type);
                result_val = (void*)NclMalloc(self_md->multidval.totalelements * the_type->type_class.size);
                if(result_val == NULL) {
                        NhlPError(NhlFATAL,NhlEUNKNOWN,"Neg: Could not allocate memory for result type, can't continue\n");
                        return(NULL);
                }
                if(_Nclneg(
                        self_md->multidval.type,
                        result_val,
                        self_md->multidval.val,
                        (self_md->multidval.missing_value.has_missing?(void*)&self_md->multidval.missing_value.value:NULL),
                        self_md->multidval.totalelements) != NhlFATAL) {

                        output_md = _NclCreateMultiDVal(
                                (NclObj)result_md,
                                NULL,
                                Ncl_MultiDValData,
                                0,
                                result_val,
                                (themissing.has_missing? &(themissing.value):NULL),
                                self_md->multidval.n_dims,
                                self_md->multidval.dim_sizes,
                                TEMPORARY,
                                NULL,
                                the_type
                        );
                        return((NclData)output_md);
                } else {
                        NclFree(result_val);
                        return(NULL);
                }
	} else {
		NhlPError(NhlFATAL,NhlEUNKNOWN,"Neg: operation not supported on type (%s)",_NclBasicDataTypeToName(self_md->multidval.data_type));
		return(NULL);
	}
}

static int MultiDVal_IsMis
#if	NhlNeedProto
(NclData self, void* v_one)
#else
(self,v_one)
NclData self_md;
void *v_one;
#endif
{
	NclMultiDValData self_md = (NclMultiDValData)self;
	logical res;

	if((self_md != NULL)&&(self_md->multidval.type != NULL)&&(self_md->multidval.missing_value.has_missing)) {
		if(_Ncleq(self_md->multidval.type,(void*)&res,(void*)&self_md->multidval.missing_value.value,v_one,NULL,NULL,1,1) != NhlFATAL) {
			return((int)res);
		}
	}
	return(0);
}

static NclData MultiDVal_md_Coerce
#if	NhlNeedProto
(NclData self, NclObjTypes coerce_to_obj, NclScalar *new_missing)
#else
(self,coerce_to_obj,new_missing)
NclData self;
NclObjTypes coerce_to_obj;
NclScalar *new_missing;
#endif
{
	NclTypeClass to_type;
	NclTypeClass from_type;
	NclMultiDValData self_md = (NclMultiDValData)self;
	NclMultiDValData output_md = NULL;
	void *result_val = NULL;
	int limit = 1,from = 0;
	int n_dims = 0;
	int step = 0;
	ng_size_t i;
	ng_size_t dimsizes[NCL_MAX_DIMENSIONS];
	NclScalar tmp_missing;

	if((self_md != NULL)&&(self_md->multidval.type != NULL)) {
		from_type = self_md->multidval.type;
		to_type = _NclTypeEnumToTypeClass(coerce_to_obj);
		if(self_md->multidval.type == to_type) {
			if((self_md->multidval.missing_value.has_missing)&&(new_missing != NULL)) 
				_NclResetMissingValue(self_md,new_missing);
			return(self);
		} else {
			if(to_type != (NclTypeClass)nclTypeClass) {
				if((from_type == (NclTypeClass)nclTypecharClass)&&(to_type == (NclTypeClass)nclTypestringClass)){
					for(i = 0; i < self_md->multidval.n_dims - 1; i++) {
						limit *= self_md->multidval.dim_sizes[i];
						dimsizes[i] = self_md->multidval.dim_sizes[i];
					}
					n_dims = self_md->multidval.n_dims - 1;
					if(n_dims == 0) {
						n_dims = 1;
						dimsizes[i] = 1;
					}
					step = self_md->multidval.dim_sizes[self_md->multidval.n_dims - 1];
					result_val = (void*)NclMalloc(to_type->type_class.size*limit);
					if(result_val != NULL) {
						for(i = 0; i < limit; i++) {
							if(_Nclcoerce(
								to_type,
								(void*)&((NclQuark*)result_val)[i],
								(void*)&((char*)self_md->multidval.val)[from],
								self_md->multidval.totalelements/limit,
								(self_md->multidval.missing_value.has_missing?&self_md->multidval.missing_value.value:NULL),
								new_missing,
								from_type) == NhlFATAL) {
								
								NclFree(result_val);
							}
							from += step;
						}
						output_md = _NclCreateVal(
							NULL,
							NULL,
							self_md->obj.obj_type,
							self_md->obj.obj_type_mask,
							result_val,
							new_missing,
							n_dims,
							(ng_size_t*)dimsizes,
							TEMPORARY,
							NULL,
							(NclObjClass)to_type
							);
						return((NclData)output_md);
					}
				} else {
					result_val = (void*)NclMalloc(to_type->type_class.size*self_md->multidval.totalelements);
					if(result_val != NULL) {
						if(_Nclcoerce(
							to_type,
							result_val,
							self_md->multidval.val,
							self_md->multidval.totalelements,
							(self_md->multidval.missing_value.has_missing?&self_md->multidval.missing_value.value:NULL),
							new_missing,
							from_type) != NhlFATAL) {
							if((self_md->multidval.missing_value.has_missing)&&(new_missing == NULL)) {
								/* dont try to convert other type missing values to logical */
					                        if((to_type->type_class.data_type == NCL_logical)||
								   (!_NclScalarCoerce(&(self_md->multidval.missing_value.value),self_md->multidval.data_type,&tmp_missing, to_type->type_class.data_type))) {
					                                tmp_missing = to_type->type_class.default_mis;
					                        }
								output_md = _NclCreateVal(
									NULL,
									NULL,
									self_md->obj.obj_type,
									self_md->obj.obj_type_mask,
									result_val,
									&tmp_missing,
									self_md->multidval.n_dims,
									self_md->multidval.dim_sizes,
									TEMPORARY,
									NULL,
									(NclObjClass)to_type
									);
							}  else {
								output_md = _NclCreateVal(
									NULL,
									NULL,
									self_md->obj.obj_type,
									self_md->obj.obj_type_mask,
									result_val,
									new_missing,
									self_md->multidval.n_dims,
									self_md->multidval.dim_sizes,
									TEMPORARY,
									NULL,
									(NclObjClass)to_type
									);
							}
							return((NclData)output_md);
						} else {
							NclFree(result_val);
						}
					}
				}
			}
		} 
	}
	return(NULL);
}

static void MultiDValResetMissing
#if	NhlNeedProto
(NclData self, NclScalar * missing)
#else
(self, missing)
NclData self;
NclScalar * missing;
#endif
{
	NclMultiDValData self_md = (NclMultiDValData)self;
	
	if(self_md == NULL) return;

	if(missing == NULL) {
		self_md->multidval.missing_value.has_missing = 0;
		return;
	}

	if(!self_md->multidval.missing_value.has_missing) {
		if (self_md->multidval.data_type == NCL_logical) {
			self_md->multidval.missing_value.has_missing = 1;
			self_md->multidval.missing_value.value.logicalval = -1;
                }
		else {
			self_md->multidval.missing_value.has_missing = 1;
			self_md->multidval.missing_value.value = *missing;
			return;
               }
	}

	if(self_md->multidval.type == NULL) return;

	if(_Nclreset_mis(self_md->multidval.type,self_md->multidval.val,&(self_md->multidval.missing_value.value),missing,self_md->multidval.totalelements) != NhlFATAL) {
		self_md->multidval.missing_value.value = *missing;
	}
	return;
}

static NhlErrorTypes MultiDValPrint
#if     NhlNeedProto
(NclObj self, FILE *fp)
#else
(self,fp)
NclObj self;
FILE *fp;
#endif
{
    NclMultiDValData self_md = (NclMultiDValData)self;
    ng_size_t i[NCL_MAX_DIMENSIONS];
    ng_size_t j[NCL_MAX_DIMENSIONS];
    ng_size_t where;
    int done = 0;
    ng_size_t k;
    ng_size_t ndims = self_md->multidval.n_dims;
    ng_size_t el_size;
    int ret = 0;
    NhlErrorTypes ret0 = NhlNOERROR;

    if (self_md->multidval.totalelements == 0) {
        ret = nclfprintf(fp,"(0) no elements\n");
        if(ret < 0) {
            return(NhlWARNING);
        }
	return NhlNOERROR;
    }	

    el_size = self_md->multidval.type->type_class.size;
    for(k = 0; k < self_md->multidval.n_dims; k++) {
        i[k] = 0;
        j[k] = self_md->multidval.dim_sizes[k];
    }

    while(!done) {
        where = 0;
        if (!NCLnoPrintElem) {
            ret = nclfprintf(fp,"(");
            if(ret < 0) {
                return(NhlWARNING);
            }
            for(k = 0; k < ndims - 1; k++) {
                ret = nclfprintf(fp,"%zd,",i[k]);
                if(ret < 0) {
                    return(NhlWARNING);
                }
                where = (where + i[k]) * j[k+1];
            }
            ret = nclfprintf(fp,"%zd)\t",i[ndims-1]);
            if(ret < 0) {
                return(NhlWARNING);
            }
        }
	else {
 	    for(k = 0; k < ndims - 1; k++) {
	       where = (where + i[k]) * j[k+1];
	    }
	}	

        where = where + i[ndims - 1];

        ret0 = _Nclprint(self_md->multidval.type,fp,(void*)((char*)self_md->multidval.val + (where * el_size)));
        if(ret0 < NhlINFO) {
            return(NhlWARNING);
        }
        ret = nclfprintf(fp,"\n");
        if(ret < 0) {
            return(NhlWARNING);
        }
        i[ndims - 1]++;
        if(i[ndims - 1] == j[ndims - 1]) {
            for(k=ndims - 1;k >0;k--) {
                if(i[k] == j[k]) {
                    i[k] = 0;
                    i[k-1]++;
                }
            }
            if(i[0] == j[0]) done = 1;
        }
    }
    return(NhlNOERROR);
}

static void MultiDValDestroy
#if     NhlNeedProto
(NclObj self)
#else
(self)
        NclObj  self;
#endif
{
        NclMultiDValData self_md = (NclMultiDValData)self;
	NhlArgVal selector;
	NhlArgVal cbdata;
	ng_size_t i;

	cbdata.intval = self->obj.id;
	selector.lngval = DESTROYED;

	if(self->obj.cblist != NULL) {
		_NhlCBCallCallbacks(self->obj.cblist,selector,cbdata);
	}
        _NclUnRegisterObj(self);

        if(self_md->multidval.sel_rec != NULL) {
		for(i = 0; i <  self_md->multidval.sel_rec->n_entries; i++) {
			if(self_md->multidval.sel_rec->selection[i].sel_type == Ncl_VECSUBSCR){
				NclFree(self_md->multidval.sel_rec->selection[i].u.vec.ind);
			}
		}
		NclFree(self_md->multidval.sel_rec);
        }

        if((self_md->obj.status != STATIC)&&(self_md->multidval.val != NULL)) {
                NclFree(self_md->multidval.val);
        }
	if(self->obj.cblist != NULL) {
		_NhlCBDestroy(self->obj.cblist);
	}
        NclFree(self);
        return;
}

static NhlErrorTypes MultiDValClassInitialize(
#if NhlNeedProto
void
#endif
);

NclMultiDValDataClassRec nclMultiDValDataClassRec = {
	{
/* char *class_name; 		*/	"MultiDValData",
/* unsigned int obj_size;	*/	sizeof(NclMultiDValDataRec),
/* NclObjClass 			*/	(NclObjClass)&nclDataClassRec,
/* int inited			*/	0,
/* NclGenericFunction destroy; 	*/	MultiDValDestroy,
/* NclSetStatusFunction set_status; 	*/	NULL,
/* NclInitPartFunction initialize_part; 	*/	NULL,
/* NclInitClassFunction initialize_class; 	*/	MultiDValClassInitialize,
		(NclAddParentFunction)MultiDValAddParent,
                (NclDelParentFunction)MultiDValDelParent,
/* NclPrintSummaryFunction print_summary; */    NULL,
/* NclPrintFunction print; 	*/	MultiDValPrint	,
/* NclCallBackList* create_callback*/   NULL,
/* NclCallBackList* delete_callback*/   NULL,
/* NclCallBackList* modify_callback*/   NULL,
/* NclObtainCallData  obtain_calldata*/   NULL
	},
	{
/* NclGenericFunction dup; 	*/	MultiDValDup,
/* NclResetMissingValueFuction dup;	*/	MultiDValResetMissing,
/* NclReadSubSecFunction r_subsection */ 	MultiDValReadSection,
/* NclReadSubSecFunction w_subsection */ {	
						MultiDVal_md_WriteSection,
						MultiDVal_s_WriteSection
					},
/* NclReadThenWriteSubFunc w_subsection */ MultiDVal_ReadWriteSection,
/* NclDataFunction coerce; 	*/	{
						MultiDVal_md_Coerce,
						MultiDVal_md_Coerce
					},
/* NclDataFunction multiply; 	*/	{
						MultiDVal_mdmd_Mul,
						MultiDVal_ss_Mul,
						MultiDVal_ss_Mul,
						MultiDVal_ss_Mul
					},
/* NclDataFunction plus; 	*/	{
						MultiDVal_mdmd_Plus,
						MultiDVal_ss_Plus,
						MultiDVal_ss_Plus,
						MultiDVal_ss_Plus
					},
/* NclDataFunction minus; 	*/	{	
						MultiDVal_mdmd_Minus,	
						MultiDVal_ss_Minus,	
						MultiDVal_ss_Minus,	
						MultiDVal_ss_Minus
					},
/* NclDataFunction divide; 	*/	{
						MultiDVal_mdmd_Div,
						MultiDVal_ss_Div,
						MultiDVal_ss_Div,
						MultiDVal_ss_Div
					},
/* NclDataFunction exponent; 	*/	{
                                                MultiDVal_mdmd_Exp,
                                                MultiDVal_ss_Exp,
                                                MultiDVal_ss_Exp,
                                                MultiDVal_ss_Exp
					},
/* NclDataFunction mod; 	*/	{
                                                MultiDVal_mdmd_Mod,
                                                MultiDVal_ss_Mod,
                                                MultiDVal_ss_Mod,
                                                MultiDVal_ss_Mod
					},
/* NclDataFunction mat; 	*/	{
                                                MultiDVal_mdmd_Mat,
                                                MultiDVal_ss_Mul,
                                                MultiDVal_ss_Mul,
                                                MultiDVal_ss_Mul 
					},
/* NclDataFunction sel_lt; 	*/	{
                                                MultiDVal_mdmd_SelLt,
                                                MultiDVal_ss_SelLt,
                                                MultiDVal_ss_SelLt,
                                                MultiDVal_ss_SelLt
					},
/* NclDataFunction sel_gt; 	*/	{
                                                MultiDVal_mdmd_SelGt,
                                                MultiDVal_ss_SelGt,
                                                MultiDVal_ss_SelGt,
                                                MultiDVal_ss_SelGt
					},
/* NclDataFunction not; 	*/	{
						MultiDVal_md_Not,
						MultiDVal_md_Not
					},
/* NclDataFunction neg; 	*/	{	
						MultiDVal_md_Neg,
						MultiDVal_md_Neg
					},
/* NclDataFunction gt; 		*/	{
                                                MultiDVal_mdmd_Gt,
                                                MultiDVal_ss_Gt,
                                                MultiDVal_ss_Gt,
                                                MultiDVal_ss_Gt
					},
/* NclDataFunction lt; 		*/	{
                                                MultiDVal_mdmd_Lt,
                                                MultiDVal_ss_Lt,
                                                MultiDVal_ss_Lt,
                                                MultiDVal_ss_Lt
					},
/* NclDataFunction ge; 		*/	{
                                                MultiDVal_mdmd_Ge,
                                                MultiDVal_ss_Ge,
                                                MultiDVal_ss_Ge,
                                                MultiDVal_ss_Ge
					},
/* NclDataFunction le; 		*/	{
                                                MultiDVal_mdmd_Le,
                                                MultiDVal_ss_Le,
                                                MultiDVal_ss_Le,
                                                MultiDVal_ss_Le
					},
/* NclDataFunction ne; 		*/	{
                                                MultiDVal_mdmd_Ne,
                                                MultiDVal_ss_Ne,
                                                MultiDVal_ss_Ne,
                                                MultiDVal_ss_Ne
					},
/* NclDataFunction eq; 		*/	{
                                                MultiDVal_mdmd_Eq,
                                                MultiDVal_ss_Eq,
                                                MultiDVal_ss_Eq,
                                                MultiDVal_ss_Eq
					},
/* NclDataFunction and;	 	*/	{
                                                MultiDVal_mdmd_And,
                                                MultiDVal_ss_And,
                                                MultiDVal_ss_And,
                                                MultiDVal_ss_And
					},
/* NclDataFunction or; 		*/	{
                                                MultiDVal_mdmd_Or,
                                                MultiDVal_ss_Or,
                                                MultiDVal_ss_Or,
                                                MultiDVal_ss_Or
					},
/* NclDataFunction xor;		*/	{
                                                MultiDVal_mdmd_Xor,
                                                MultiDVal_ss_Xor,
                                                MultiDVal_ss_Xor,
                                                MultiDVal_ss_Xor
					},
/* NclIsMissingFuncion is_mis   */	MultiDVal_IsMis
	},
	{
		NULL
	}
};

NclObjClass nclMultiDValDataClass = (NclObjClass)&nclMultiDValDataClassRec;

static NhlErrorTypes MultiDValClassInitialize
#if NhlNeedProto
(void)
#else
()
#endif
{
	_NclRegisterClassPointer(
		Ncl_MultiDValData,
		(NclObjClass)&nclMultiDValDataClassRec
	);
	return(NhlNOERROR);
}




struct _NclMultiDValDataRec * _NclCreateMultiDVal
#if     NhlNeedProto
(NclObj inst, NclObjClass theclass, NclObjTypes obj_type, unsigned int obj_type_mask, void *val, NclScalar *missing_value, int n_dims, ng_size_t *dim_sizes, NclStatus status, NclSelectionRecord *sel_rec, NclTypeClass type)
#else
(inst, theclass, obj_type, obj_type_mask, val, missing_value, n_dims, dim_sizes, status, sel_rec, type)
NclObj inst;
NclObjClass theclass;
NclObjTypes obj_type;
unsigned int obj_type_mask;
void *val;
NclScalar *missing_value;
int n_dims;
ng_size_t *dim_sizes;
NclStatus status;
NclSelectionRecord *sel_rec;
NclTypeClass type;
#endif
{

	NclMultiDValData thevalobj;
	NclObjClass class_ptr= nclMultiDValDataClass;
	ng_size_t i;
	NhlErrorTypes ret1= NhlNOERROR;
	ng_size_t nelem;

	ret1 = _NclInitClass(nclMultiDValDataClass);
	if(ret1 < NhlWARNING) {
		return(NULL);
	}
	if(inst == NULL ) {
		thevalobj = (NclMultiDValData)NclMalloc(
				(unsigned)nclMultiDValDataClassRec.obj_class.obj_size);
	} else {
		thevalobj = (NclMultiDValData)inst;
	}
	if(theclass != NULL) {
		class_ptr = theclass;
	}
/*
* Since no initialize functions exist for Obj and Data (meaningless because
* data has not instance record) fields must be assign manually here
*/
	_NclDataCreate((NclObj)thevalobj,class_ptr,obj_type,(obj_type_mask | Ncl_MultiDValData),status);


	thevalobj->multidval.data_type = type->type_class.data_type;
	thevalobj->multidval.val = val;
	thevalobj->multidval.type= type;
	thevalobj->multidval.hlu_type_rep[0] = type->type_class.hlu_type_rep[0];
	thevalobj->multidval.hlu_type_rep[1] = type->type_class.hlu_type_rep[1];

	if(missing_value != NULL ) {
		thevalobj->multidval.missing_value.has_missing = 1;
			thevalobj->multidval.missing_value.value = *missing_value;
	} else {
		thevalobj->multidval.missing_value.has_missing = 0;
	}



	thevalobj->multidval.n_dims = n_dims;
	nelem = 1;
	if((n_dims == 1) &&(dim_sizes[0]== 1)) {
		thevalobj->multidval.kind = SCALAR;
		thevalobj->multidval.dim_sizes[0] = 1;
	} else {
		thevalobj->multidval.kind = MULTID;
		for(i = 0; i<n_dims; i++) {
			thevalobj->multidval.dim_sizes[i] = dim_sizes[i];
			nelem *= dim_sizes[i];
		}
	}
	thevalobj->multidval.totalelements = nelem;
	thevalobj->multidval.totalsize = nelem * type->type_class.size;
	if(sel_rec != NULL) {
		thevalobj->multidval.sel_rec = (NclSelectionRecord*)NclMalloc((unsigned)sizeof(NclSelectionRecord));
		memcpy((char*)thevalobj->multidval.sel_rec,(char*)sel_rec,sizeof(NclSelectionRecord));
		for(i = 0; i <  sel_rec->n_entries; i++) {
                 	if(sel_rec->selection[i].sel_type == Ncl_VECSUBSCR){
                        	thevalobj->multidval.sel_rec->selection[i].u.vec.ind = (long*) NclMalloc(sizeof(long)*(sel_rec->selection[i].u.vec.n_ind));
				memcpy(thevalobj->multidval.sel_rec->selection[i].u.vec.ind,sel_rec->selection[i].u.vec.ind,sizeof(long)*(sel_rec->selection[i].u.vec.n_ind));
        	        }
		}
	} else {
		thevalobj->multidval.sel_rec = NULL;
	}
	return((NclMultiDValData)thevalobj);
}

# csh script to switch between versions of NCL
#
# To use: source /contrib/bin/origncl.csh
# To switch back to the test version: source /contrib/bin/testncl.csh

set ngroot=/contrib/ncl-5.1.1-beta

set sub=s:$ngroot/bin\\:::g
set newpath=`echo $PATH | sed -e $sub`

# Remove extra colons
# set sub=s/:://
# set newpath=`echo $PATH | sed -e $sub`

setenv PATH $newpath

setenv NCARG_ROOT /contrib

set version=`ncl -V`
echo "You are now using the current version of NCL: $version"

unset ngroot
unset newpath

/*
 *      $Id: MultiDValOp.c.sed,v 1.13.4.1 2008-03-28 20:37:49 grubin Exp $
 */
/************************************************************************
*									*
*			     Copyright (C)  1995			*
*	     University Corporation for Atmospheric Research		*
*			     All Rights Reserved			*
*									*
************************************************************************/
/*
 *	File:		
 *
 *	Author:		Ethan Alpert
 *			National Center for Atmospheric Research
 *			PO 3000, Boulder, Colorado
 *
 *	Date:		Fri Jan 27 18:22:08 MST 1995
 *
 *	Description:	
 */

static NclData MultiDVal_mdmd_FUNCNAME
#if	NhlNeedProto
(NclData self, NclData other, NclData result)
#else
(self,other,result)
NclData	self;
NclData other;
NclData result;
#endif
{
	NclMultiDValData self_md = (NclMultiDValData)self;
	NclMultiDValData other_md = (NclMultiDValData)other;
	NclMultiDValData result_md = (NclMultiDValData)result;
	NclMultiDValData output_md = NULL;
	NclTypeClass the_type = NULL;
	NclTypeClass operand_type = NULL;
	NclMissingRec themissing;
	void *result_val;
	ng_size_t i;
	

	if((other_md == NULL)||(self_md == NULL))
		return(NULL);

        if((other_md->multidval.n_dims != self_md->multidval.n_dims)){
		NhlPError(NhlFATAL,NhlEUNKNOWN,"FUNCNAME: Number of dimensions do not match, can't continue");
                return(NULL);
        }
	operand_type = self_md->multidval.type;
	for(i = 0; i< self_md->multidval.n_dims; i++) {
                if(self_md->multidval.dim_sizes[i]
                        != other_md->multidval.dim_sizes[i]) {
                        NhlPError(NhlFATAL,NhlEUNKNOWN,"FUNCNAME: Dimension size, for dimension number %d, of operands does not match, can't continue\n",i);
                        return(NULL);
                }
        }
        if(self_md->multidval.missing_value.has_missing) {
                themissing.value = self_md->multidval.missing_value.value;
                themissing.has_missing = 1;
        } else if(other_md->multidval.missing_value.has_missing) {
                themissing.value = other_md->multidval.missing_value.value;
                themissing.has_missing = 1;
        } else {
                themissing.has_missing = 0;
        }

	if((self_md->multidval.type != NULL)&&(((NclTypeClass)self_md->multidval.type)->type_class.TFUNC != NULL)) {

/*
* the_type is not null since requirement if TFUNC != NULL TFUNC_type != NULL
*/

		the_type = _NclTFUNC_type(self_md->multidval.type);
		if((result_md != NULL)&&(result_md->multidval.data_type== the_type->type_class.data_type)) {
			result_val = result_md->multidval.val;
		} else if((result_md != NULL)&&(result_md->multidval.type->type_class.size >= the_type->type_class.size)) {
			result_val = result_md->multidval.val;
			result_md->multidval.type = the_type;
			result_md->multidval.data_type = the_type->type_class.data_type;
			result_md->multidval.hlu_type_rep[0] = the_type->type_class.hlu_type_rep[0];
			result_md->multidval.hlu_type_rep[1] = the_type->type_class.hlu_type_rep[1];
			result_md->multidval.totalsize = result_md->multidval.totalelements * the_type->type_class.size;
		} else {
			if((result_md != NULL) &&((result_md != self_md)&&(result_md != other_md))) {
				_NclDestroyObj((NclObj)result_md);
			}
			result_md = NULL;
			result_val = (void*)NclMalloc(self_md->multidval.totalelements * the_type->type_class.size);
			if(result_val == NULL) {
				NhlPError(NhlFATAL,NhlEUNKNOWN,"FUNCNAME: Could not allocate memory for result type, can't continue\n");
				return(NULL);
			}
		}
		if(_NclTFUNC(
			operand_type,
			result_val,
			self_md->multidval.val,
			other_md->multidval.val,
			(self_md->multidval.missing_value.has_missing?(void*)&self_md->multidval.missing_value.value:NULL),
			(other_md->multidval.missing_value.has_missing?(void*)&other_md->multidval.missing_value.value:NULL),
			self_md->multidval.totalelements,
			other_md->multidval.totalelements) != NhlFATAL) {

			if((the_type != operand_type)&&(themissing.has_missing)) {
				if((the_type->type_class.data_type == NCL_logical)||(!_NclScalarCoerce(&themissing.value,operand_type->type_class.data_type,&themissing.value,the_type->type_class.data_type) )) {

					themissing.value = the_type->type_class.default_mis;
				}
			}
			if(result_md == NULL) {
				output_md = _NclCreateMultiDVal(
					(NclObj)result_md,
					NULL,
					Ncl_MultiDValData,
					0,
					result_val,
					(themissing.has_missing? &(themissing.value):NULL),
					self_md->multidval.n_dims,
					self_md->multidval.dim_sizes,
					TEMPORARY,
					NULL,
					the_type
				);
				return((NclData)output_md);
			} else {
				if(themissing.has_missing)
					result_md->multidval.missing_value = themissing;
				return((NclData)result_md);
			}
		} else {
			if(result_md == NULL) {
				NclFree(result_val);
			}
			NhlPError(NhlFATAL,NhlEUNKNOWN,"FUNCNAME: operator failed, can't continue");
			return(NULL);
		}
			
			
		
	} else {
		NhlPError(NhlFATAL,NhlEUNKNOWN,"FUNCNAME: operation not supported on type (%s)",_NclBasicDataTypeToName(self_md->multidval.data_type));
		return(NULL);
	}
}

static NclData MultiDVal_ss_FUNCNAME
#if	NhlNeedProto
(NclData self, NclData other, NclData result)
#else
(self,other,result)
NclData	self;
NclData other;
NclData result;
#endif
{
	NclMultiDValData self_md = (NclMultiDValData)self;
	NclMultiDValData other_md = (NclMultiDValData)other;
	NclMultiDValData result_md = (NclMultiDValData)result;
	NclMultiDValData output_md;
	NclTypeClass the_type = NULL;
	NclTypeClass operand_type = NULL;
	NclMissingRec themissing;
	void *result_val;
	ng_size_t total;
	ng_size_t *dim_sizes = NULL;
	int n_dims = 1;
	

	if((other_md == NULL)||(self_md == NULL))
		return(NULL);

	operand_type = self_md->multidval.type;
        if(self_md->multidval.missing_value.has_missing) {
                themissing.value = self_md->multidval.missing_value.value;
                themissing.has_missing = 1;
        } else if(other_md->multidval.missing_value.has_missing) {
                themissing.value = other_md->multidval.missing_value.value;
                themissing.has_missing = 1;
        } else {
                themissing.has_missing = 0;
        }
	if(!((self_md->multidval.kind == SCALAR)||(other_md->multidval.kind == SCALAR))) {
		NhlPError(NhlFATAL,NhlEUNKNOWN,"TFUNC for scalar values was called with non scalar value, this should not happen");
		return(NULL);
	}

	total = self_md->multidval.totalelements;
	n_dims = self_md->multidval.n_dims;
	dim_sizes = self_md->multidval.dim_sizes;
	if(total < other_md->multidval.totalelements) {
		total = other_md->multidval.totalelements;
		n_dims = other_md->multidval.n_dims;
		dim_sizes = other_md->multidval.dim_sizes;
	}

	if((self_md->multidval.type != NULL)&&(((NclTypeClass)self_md->multidval.type)->type_class.TFUNC != NULL)) {

/*
* the_type is not null since requirement if TFUNC != NULL TFUNC_type != NULL
*/

		the_type = _NclTFUNC_type(self_md->multidval.type);

                if((result_md != NULL)&&(result_md->multidval.data_type== the_type->type_class.data_type)) {
                        result_val = result_md->multidval.val;
                } else if((result_md != NULL)&&(result_md->multidval.type->type_class.size >= the_type->type_class.size)) {
                        result_val = result_md->multidval.val;
                        result_md->multidval.type = the_type;
                        result_md->multidval.data_type = the_type->type_class.data_type;
                        result_md->multidval.hlu_type_rep[0] = the_type->type_class.hlu_type_rep[0];
                        result_md->multidval.hlu_type_rep[1] = the_type->type_class.hlu_type_rep[1];
                        result_md->multidval.totalsize = result_md->multidval.totalelements * the_type->type_class.size;
                } else {
			if((result_md != NULL) &&((result_md != self_md)&&(result_md != other_md))) {
                                _NclDestroyObj((NclObj)result_md);
                        }
                        result_md = NULL;
                        result_val = (void*)NclMalloc(total * the_type->type_class.size);
                        if(result_val == NULL) {
                                NhlPError(NhlFATAL,NhlEUNKNOWN,"FUNCNAME: Could not allocate memory for result type, can't continue\n");
                                return(NULL);
                        }
                }
		if((the_type != operand_type)&&(themissing.has_missing)) {
			if((the_type->type_class.data_type == NCL_logical)||(!_NclScalarCoerce(&themissing.value,operand_type->type_class.data_type,&themissing.value,the_type->type_class.data_type) )) {
				themissing.value = the_type->type_class.default_mis;
			}
		}

		if(_NclTFUNC(
			operand_type,
			result_val,
			self_md->multidval.val,
			other_md->multidval.val,
			(self_md->multidval.missing_value.has_missing?(void*)&self_md->multidval.missing_value.value:NULL),
			(other_md->multidval.missing_value.has_missing?(void*)&other_md->multidval.missing_value.value:NULL),
			self_md->multidval.totalelements,
			other_md->multidval.totalelements) != NhlFATAL) {

			if(result_md == NULL) {
				output_md = _NclCreateMultiDVal(
					(NclObj)result_md,
					NULL,
					Ncl_MultiDValData,
					0,
					result_val,
					(themissing.has_missing? &(themissing.value):NULL),
					n_dims,
					dim_sizes,
					TEMPORARY,
					NULL,
					the_type
				);
				return((NclData)output_md);
			} else {
				if(themissing.has_missing)
					result_md->multidval.missing_value = themissing;
				return((NclData)result_md);
			}
		} else {
			if(result_md == NULL) {
				NclFree(result_val);
			}
			NhlPError(NhlFATAL,NhlEUNKNOWN,"FUNCNAME: operator failed, can't continue");
			return(NULL);
		}
	} else {
		NhlPError(NhlFATAL,NhlEUNKNOWN,"FUNCNAME: operation not supported on type (%s)",_NclBasicDataTypeToName(self_md->multidval.data_type));
		return(NULL);
	}
}

#!/bin/sh

sh op_funcs.sh int NhlTInteger NhlTIntegerGenArray -2147483647 > .tmp.$$

if [ ! $? ]
then
	exit $?
fi

sed \
-e 's/PRINTFORMAT/\%d\\n/' \
-e 's/DATATYPE/int/g' \
-e 's/LOCALTYPE/int/g' \
-e 's/HLUTYPEREP/NhlTInteger/g' \
-e 's/HLUGENTYPEREP/NhlTIntegerGenArray/g' \
-e 's/DEFAULT_MISS/-2147483647/g' \
-e 's/DEFAULT_FORMAT/%d/g' \
-e "/REPLACE/r .tmp.$$" \
-e '/REPLACE/d' \
-e '/DSPECIFIC/r NclTypeint.c.specific' \
-e '/DSPECIFIC/d' \
NclType.c.sed > NclTypeint.c

rm .tmp.$$

echo "created NclTypeint.c"

#!/bin/sh


if [ $1 = "ushort" ]; then
    def_type="unsigned short"
elif [ $1 = "uint" ]; then
    def_type="unsigned int"
elif [ $1 = "ulong" ]; then
    def_type="unsigned long"
elif [ $1 = "int64" ]; then
    def_type="long long"
elif [ $1 = "uint64" ]; then
    def_type="unsigned long long"
elif [ $1 = "ubyte" ]; then
    def_type="unsigned char"
else
    def_type=$1
fi

export def_type

sed \
-e "s/DATATYPE/$1/g" \
-e "s/LOCALTYPE/$def_type/g" \
TypeResetMissing.c.sed

#
# Begin "logical" section
#

if [ $1 = "logical" ]
then

sed \
-e "s/HLUGENTYPEREP/$3/g" \
-e "s/HLUTYPEREP/$2/g" \
-e "s/DATATYPE/logical/g" \
-e "s/LOCALTYPE/$def_type/g" \
-e "s/DEFAULT_MISS/$4/g" \
TypeInitClassTemplate.c.sed


sed \
-e "s/OUTDATATYPE/logical/g" \
-e "s/DATATYPE/logical/g" \
-e "s/LOCALTYPE/$def_type/g" \
-e "s/LOCALOUTTYPE/logical/g" \
-e "s/LEFTMISSING/lhs_m->logicalval/g" \
-e "s/RIGHTMISSING/rhs_m->logicalval/g" \
-e "s/THEOP/\&\&/g" \
-e "s/OPER/\.ncl_and\./g" \
-e "s/FUNCNAME/and/g" \
TypeAndOpTemplate.c.sed

sed \
-e "s/OUTDATATYPE/logical/g" \
-e "s/DATATYPE/logical/g" \
-e "s/LOCALTYPE/$def_type/g" \
-e "s/LOCALOUTTYPE/logical/g" \
-e "s/OUTMISSING/lhs_m->logicalval/g" \
-e "s/THEOP/\!/g" \
-e "s/OPER/\.ncl_not\./g" \
-e "s/FUNCNAME/not/g" \
TypeMonoOpTemplate.c.sed

sed \
-e "s/OUTDATATYPE/logical/g" \
-e "s/DATATYPE/logical/g" \
-e "s/LOCALTYPE/$def_type/g" \
-e "s/LOCALOUTTYPE/logical/g" \
-e "s/LEFTMISSING/lhs_m->logicalval/g" \
-e "s/RIGHTMISSING/rhs_m->logicalval/g" \
-e "s/THEOP/||/g" \
-e "s/OPER/\.ncl_or\./g" \
-e "s/FUNCNAME/or/g" \
TypeOrOpTemplate.c.sed

sed \
-e "s/OUTDATATYPE/logical/g" \
-e "s/DATATYPE/logical/g" \
-e "s/LOCALTYPE/$def_type/g" \
-e "s/LOCALOUTTYPE/logical/g" \
-e "s/LEFTMISSING/lhs_m->logicalval/g" \
-e "s/RIGHTMISSING/rhs_m->logicalval/g" \
-e "s/OPER/\.ncl_xor\./g" \
-e "s/FUNCNAME/xor/g" \
TypeXorOpTemplate.c.sed

sed \
-e "s/OUTDATATYPE/logical/g" \
-e "s/DATATYPE/logical/g" \
-e "s/LOCALTYPE/$def_type/g" \
-e "s/LOCALOUTTYPE/logical/g" \
-e "s/LEFTMISSING/lhs_m->logicalval/g" \
-e "s/RIGHTMISSING/rhs_m->logicalval/g" \
-e "s/THEOP/==/g" \
-e "s/OPER/\.eq\./g" \
-e "s/FUNCNAME/eq/g" \
TypeSimpleOpTemplate.c.sed

sed \
-e "s/OUTDATATYPE/logical/g" \
-e "s/DATATYPE/logical/g" \
-e "s/LOCALTYPE/logical/g" \
-e "s/LOCALOUTTYPE/logical/g" \
-e "s/LEFTMISSING/lhs_m->logicalval/g" \
-e "s/RIGHTMISSING/rhs_m->logicalval/g" \
-e "s/THEOP/!=/g" \
-e "s/OPER/\.ne\./g" \
-e "s/FUNCNAME/ne/g" \
TypeSimpleOpTemplate.c.sed
exit 0

fi

#
# Begin "string" section
#
if [ $1 = "string" ]
then


sed \
-e 's/SELFUNC/select_string_gt/g' \
-e 's/FUNCNAME/sel_gt/' \
TypestringSelectOpTemplate.c.sed

sed \
-e 's/SELFUNC/select_string_lt/g' \
-e 's/FUNCNAME/sel_lt/' \
TypestringSelectOpTemplate.c.sed

sed \
-e 's/CMPFUNC/cmp_string_lt/g' \
-e 's/FUNCNAME/lt/' \
TypestringCompareOpTemplate.c.sed

sed \
-e 's/CMPFUNC/cmp_string_gt/g' \
-e 's/FUNCNAME/gt/' \
TypestringCompareOpTemplate.c.sed

sed \
-e 's/CMPFUNC/cmp_string_ge/g' \
-e 's/FUNCNAME/ge/' \
TypestringCompareOpTemplate.c.sed

sed \
-e 's/CMPFUNC/cmp_string_le/g' \
-e 's/FUNCNAME/le/' \
TypestringCompareOpTemplate.c.sed

exit 0

fi

#
# Begin "obj" section
#
if [ $1 = "obj" ]
then

sed \
-e "s/OUTDATATYPE/logical/g" \
-e "s/DATATYPE/obj/g" \
-e "s/LOCALTYPE/obj/g" \
-e "s/LOCALOUTTYPE/logical/g" \
-e "s/LEFTMISSING/((NclTypeClass)nclTypelogicalClass)->type_class.default_mis.logicalval/g" \
-e "s/RIGHTMISSING/((NclTypeClass)nclTypelogicalClass)->type_class.default_mis.logicalval/g" \
-e "s/THEOP/==/g" \
-e "s/OPER/\.eq\./g" \
-e "s/FUNCNAME/eq/g" \
TypeSimpleOpTemplate.c.sed

sed \
-e "s/OUTDATATYPE/logical/g" \
-e "s/DATATYPE/obj/g" \
-e "s/LOCALTYPE/obj/g" \
-e "s/LOCALOUTTYPE/logical/g" \
-e "s/LEFTMISSING/((NclTypeClass)nclTypelogicalClass)->type_class.default_mis.logicalval/g" \
-e "s/RIGHTMISSING/((NclTypeClass)nclTypelogicalClass)->type_class.default_mis.logicalval/g" \
-e "s/THEOP/!=/g" \
-e "s/OPER/\.ne\./g" \
-e "s/FUNCNAME/ne/g" \
TypeSimpleOpTemplate.c.sed

exit 0

fi

if [ $1 = "char" ]
then
sed \
-e "s/HLUGENTYPEREP/$3/g" \
-e "s/HLUTYPEREP/$2/g" \
-e "s/DATATYPE/char/g" \
-e "s/LOCALTYPE/$def_type/g" \
-e "s/DEFAULT_MISS/$4/g" \
TypeInitClassTemplate.c.sed

sed  \
-e "s/OUTDATATYPE/$1/g" \
-e "s/DATATYPE/$1/g" \
-e "s/LOCALTYPE/$1/g" \
-e "s/LOCALOUTTYPE/$def_type/g" \
-e "s/LEFTMISSING/lhs_m->$1val/g" \
-e "s/RIGHTMISSING/rhs_m->$1val/g" \
-e 's/THEOP/+/' \
-e 's/OPER/\+/' \
-e 's/FUNCNAME/plus/' \
TypeSimpleOpTemplate.c.sed

sed \
-e "s/OUTDATATYPE/logical/g" \
-e "s/DATATYPE/$1/g" \
-e "s/LOCALTYPE/$1/g" \
-e "s/LOCALOUTTYPE/logical/g" \
-e "s/LEFTMISSING/((NclTypeClass)nclTypelogicalClass)->type_class.default_mis.logicalval/g" \
-e "s/RIGHTMISSING/((NclTypeClass)nclTypelogicalClass)->type_class.default_mis.logicalval/g" \
-e 's/THEOP/</' \
-e 's/OPER/\.lt\./' \
-e 's/FUNCNAME/lt/' \
TypeSimpleOpTemplate.c.sed

sed \
-e "s/OUTDATATYPE/logical/g" \
-e "s/DATATYPE/$1/g" \
-e "s/LOCALTYPE/$1/g" \
-e "s/LOCALOUTTYPE/logical/g" \
-e "s/LEFTMISSING/((NclTypeClass)nclTypelogicalClass)->type_class.default_mis.logicalval/g" \
-e "s/RIGHTMISSING/((NclTypeClass)nclTypelogicalClass)->type_class.default_mis.logicalval/g" \
-e 's/THEOP/>/' \
-e 's/OPER/\.gt\./' \
-e 's/FUNCNAME/gt/' \
TypeSimpleOpTemplate.c.sed

sed \
-e "s/OUTDATATYPE/logical/g" \
-e "s/DATATYPE/$1/g" \
-e "s/LOCALTYPE/$1/g" \
-e "s/LOCALOUTTYPE/logical/g" \
-e "s/LEFTMISSING/((NclTypeClass)nclTypelogicalClass)->type_class.default_mis.logicalval/g" \
-e "s/RIGHTMISSING/((NclTypeClass)nclTypelogicalClass)->type_class.default_mis.logicalval/g" \
-e 's/THEOP/<=/' \
-e 's/OPER/\.le\./' \
-e 's/FUNCNAME/le/' \
TypeSimpleOpTemplate.c.sed

sed \
-e "s/OUTDATATYPE/logical/g" \
-e "s/DATATYPE/$1/g" \
-e "s/LOCALTYPE/$1/g" \
-e "s/LOCALOUTTYPE/logical/g" \
-e "s/LEFTMISSING/((NclTypeClass)nclTypelogicalClass)->type_class.default_mis.logicalval/g" \
-e "s/RIGHTMISSING/((NclTypeClass)nclTypelogicalClass)->type_class.default_mis.logicalval/g" \
-e 's/THEOP/>=/' \
-e 's/OPER/\.ge\./' \
-e 's/FUNCNAME/ge/' \
TypeSimpleOpTemplate.c.sed

sed \
-e "s/OUTDATATYPE/logical/g" \
-e "s/DATATYPE/$1/g" \
-e "s/LOCALTYPE/$1/g" \
-e "s/LOCALOUTTYPE/logical/g" \
-e "s/LEFTMISSING/((NclTypeClass)nclTypelogicalClass)->type_class.default_mis.logicalval/g" \
-e "s/RIGHTMISSING/((NclTypeClass)nclTypelogicalClass)->type_class.default_mis.logicalval/g" \
-e 's/THEOP/==/' \
-e 's/OPER/\.eq\./' \
-e 's/FUNCNAME/eq/' \
TypeSimpleOpTemplate.c.sed

sed \
-e "s/OUTDATATYPE/logical/g" \
-e "s/DATATYPE/$1/g" \
-e "s/LOCALTYPE/$1/g" \
-e "s/LOCALOUTTYPE/logical/g" \
-e "s/LEFTMISSING/((NclTypeClass)nclTypelogicalClass)->type_class.default_mis.logicalval/g" \
-e "s/RIGHTMISSING/((NclTypeClass)nclTypelogicalClass)->type_class.default_mis.logicalval/g" \
-e 's/THEOP/!=/' \
-e 's/OPER/\.ne\./' \
-e 's/FUNCNAME/ne/' \
TypeSimpleOpTemplate.c.sed

sed \
-e "s/OUTDATATYPE/$1/g" \
-e "s/DATATYPE/$1/g" \
-e "s/LOCALTYPE/$def_type/g" \
-e "s/LOCALOUTTYPE/$def_type/g" \
-e 's/THEOP/\</' \
-e 's/OPER/\</' \
-e 's/FUNCNAME/sel_lt/' \
TypeSelectOpTemplate.c.sed

sed \
-e "s/OUTDATATYPE/$1/g" \
-e "s/DATATYPE/$1/g" \
-e "s/LOCALTYPE/$def_type/g" \
-e "s/LOCALOUTTYPE/$def_type/g" \
-e 's/THEOP/\>/' \
-e 's/OPER/\>/' \
-e 's/FUNCNAME/sel_gt/' \
TypeSelectOpTemplate.c.sed

sed \
-e "s/DATATYPE/$1/g" \
-e "s/LOCALTYPE/$def_type/g" \
TypeIsMonoFunc.c.sed


exit 0
fi

#
# Begin "numeric" section
#

sed \
-e "s/HLUGENTYPEREP/$3/g" \
-e "s/HLUTYPEREP/$2/g" \
-e "s/DATATYPE/$1/g" \
-e "s/LOCALTYPE/$def_type/g" \
-e "s/DEFAULT_MISS/$4/g" \
TypeInitClassTemplate.c.sed

sed  \
-e "s/OUTDATATYPE/$1/g" \
-e "s/DATATYPE/$1/g" \
-e "s/LOCALTYPE/$def_type/g" \
-e "s/LOCALOUTTYPE/$def_type/g" \
-e "s/LEFTMISSING/lhs_m->$1val/g" \
-e "s/RIGHTMISSING/rhs_m->$1val/g" \
TypeMatMulOpTemplate.c.sed

sed  \
-e "s/OUTDATATYPE/$1/g" \
-e "s/DATATYPE/$1/g" \
-e "s/LOCALTYPE/$def_type/g" \
-e "s/LOCALOUTTYPE/$def_type/g" \
-e "s/LEFTMISSING/lhs_m->$1val/g" \
-e "s/RIGHTMISSING/rhs_m->$1val/g" \
-e 's/THEOP/+/' \
-e 's/OPER/\+/' \
-e 's/FUNCNAME/plus/' \
TypeSimpleOpTemplate.c.sed

sed \
-e "s/OUTDATATYPE/$1/g" \
-e "s/DATATYPE/$1/g" \
-e "s/LOCALTYPE/$def_type/g" \
-e "s/LOCALOUTTYPE/$def_type/g" \
-e "s/LEFTMISSING/lhs_m->$1val/g" \
-e "s/RIGHTMISSING/rhs_m->$1val/g" \
-e 's/THEOP/-/' \
-e 's/OPER/\-/' \
-e 's/FUNCNAME/minus/' \
TypeSimpleOpTemplate.c.sed

sed \
-e "s/OUTDATATYPE/$1/g" \
-e "s/DATATYPE/$1/g" \
-e "s/LOCALTYPE/$def_type/g" \
-e "s/LOCALOUTTYPE/$def_type/g" \
-e "s/LEFTMISSING/lhs_m->$1val/g" \
-e "s/RIGHTMISSING/rhs_m->$1val/g" \
-e 's/THEOP/*/' \
-e 's/OPER/\*/' \
-e 's/FUNCNAME/multiply/' \
TypeSimpleOpTemplate.c.sed

sed \
-e "s/OUTDATATYPE/logical/g" \
-e "s/DATATYPE/$1/g" \
-e "s/LOCALTYPE/$def_type/g" \
-e "s/LOCALOUTTYPE/logical/g" \
-e "s/LEFTMISSING/((NclTypeClass)nclTypelogicalClass)->type_class.default_mis.logicalval/g" \
-e "s/RIGHTMISSING/((NclTypeClass)nclTypelogicalClass)->type_class.default_mis.logicalval/g" \
-e 's/THEOP/</' \
-e 's/OPER/\.lt\./' \
-e 's/FUNCNAME/lt/' \
TypeSimpleOpTemplate.c.sed

sed \
-e "s/OUTDATATYPE/logical/g" \
-e "s/DATATYPE/$1/g" \
-e "s/LOCALTYPE/$def_type/g" \
-e "s/LOCALOUTTYPE/logical/g" \
-e "s/LEFTMISSING/((NclTypeClass)nclTypelogicalClass)->type_class.default_mis.logicalval/g" \
-e "s/RIGHTMISSING/((NclTypeClass)nclTypelogicalClass)->type_class.default_mis.logicalval/g" \
-e 's/THEOP/>/' \
-e 's/OPER/\.gt\./' \
-e 's/FUNCNAME/gt/' \
TypeSimpleOpTemplate.c.sed

sed \
-e "s/OUTDATATYPE/logical/g" \
-e "s/DATATYPE/$1/g" \
-e "s/LOCALTYPE/$def_type/g" \
-e "s/LOCALOUTTYPE/logical/g" \
-e "s/LEFTMISSING/((NclTypeClass)nclTypelogicalClass)->type_class.default_mis.logicalval/g" \
-e "s/RIGHTMISSING/((NclTypeClass)nclTypelogicalClass)->type_class.default_mis.logicalval/g" \
-e 's/THEOP/<=/' \
-e 's/OPER/\.le\./' \
-e 's/FUNCNAME/le/' \
TypeSimpleOpTemplate.c.sed

sed \
-e "s/OUTDATATYPE/logical/g" \
-e "s/DATATYPE/$1/g" \
-e "s/LOCALTYPE/$def_type/g" \
-e "s/LOCALOUTTYPE/logical/g" \
-e "s/LEFTMISSING/((NclTypeClass)nclTypelogicalClass)->type_class.default_mis.logicalval/g" \
-e "s/RIGHTMISSING/((NclTypeClass)nclTypelogicalClass)->type_class.default_mis.logicalval/g" \
-e 's/THEOP/>=/' \
-e 's/OPER/\.ge\./' \
-e 's/FUNCNAME/ge/' \
TypeSimpleOpTemplate.c.sed

sed \
-e "s/OUTDATATYPE/logical/g" \
-e "s/DATATYPE/$1/g" \
-e "s/LOCALTYPE/$def_type/g" \
-e "s/LOCALOUTTYPE/logical/g" \
-e "s/LEFTMISSING/((NclTypeClass)nclTypelogicalClass)->type_class.default_mis.logicalval/g" \
-e "s/RIGHTMISSING/((NclTypeClass)nclTypelogicalClass)->type_class.default_mis.logicalval/g" \
-e 's/THEOP/==/' \
-e 's/OPER/\.eq\./' \
-e 's/FUNCNAME/eq/' \
TypeSimpleOpTemplate.c.sed

sed \
-e "s/OUTDATATYPE/logical/g" \
-e "s/DATATYPE/$1/g" \
-e "s/LOCALTYPE/$def_type/g" \
-e "s/LOCALOUTTYPE/logical/g" \
-e "s/LEFTMISSING/((NclTypeClass)nclTypelogicalClass)->type_class.default_mis.logicalval/g" \
-e "s/RIGHTMISSING/((NclTypeClass)nclTypelogicalClass)->type_class.default_mis.logicalval/g" \
-e 's/THEOP/!=/' \
-e 's/OPER/\.ne\./' \
-e 's/FUNCNAME/ne/' \
TypeSimpleOpTemplate.c.sed

sed \
-e "s/OUTDATATYPE/logical/g" \
-e "s/DATATYPE/$1/g" \
-e "s/LOCALTYPE/$def_type/g" \
-e "s/LOCALOUTTYPE/logical/g" \
-e "s/LEFTMISSING/((NclTypeClass)nclTypelogicalClass)->type_class.default_mis.logicalval/g" \
-e "s/RIGHTMISSING/((NclTypeClass)nclTypelogicalClass)->type_class.default_mis.logicalval/g" \
-e 's/THEOP/\&\&/' \
-e 's/OPER/\.ncl_and\./' \
-e 's/FUNCNAME/and/' \
TypeAndOpTemplate.c.sed

sed \
-e "s/OUTDATATYPE/logical/g" \
-e "s/DATATYPE/$1/g" \
-e "s/LOCALTYPE/$def_type/g" \
-e "s/LOCALOUTTYPE/logical/g" \
-e "s/LEFTMISSING/((NclTypeClass)nclTypelogicalClass)->type_class.default_mis.logicalval/g" \
-e "s/RIGHTMISSING/((NclTypeClass)nclTypelogicalClass)->type_class.default_mis.logicalval/g" \
-e 's/THEOP/||/' \
-e 's/OPER/\.ncl_or\./' \
-e 's/FUNCNAME/or/' \
TypeOrOpTemplate.c.sed

sed \
-e "s/DATATYPE/$1/g" \
-e "s/LOCALTYPE/$def_type/g" \
TypeIsMonoFunc.c.sed

if [ \( $1 = "int" \) -o \( $1 = "long" \) -o \( $1 = "short" \) -o \( $1 = "uint" \) -o \( $1 = "ulong" \) -o \( $1 = "ushort" \) -o \( $1 = "ubyte" \) ]
then
sed \
-e "s/OUTDATATYPE/float/g" \
-e "s/DATATYPE/$1/g" \
-e "s/LOCALTYPE/$def_type/g" \
-e "s/LEFTMISSING/lhs_m->$1val/g" \
-e "s/RIGHTMISSING/rhs_m->$1val/g" \
-e 's/FNAME/pow/' \
-e 's/OPER/\^/' \
-e 's/FUNCNAME/exponent/' \
-e 's/CAST/double/g' \
-e 's/INCLUDE/math/' \
TypeFunctionOpTemplate.c.sed
else
if [ \( $1 = "int64" \) -o \( $1 = "uint64" \) ]
then

sed \
-e "s/OUTDATATYPE/double/g" \
-e "s/DATATYPE/$1/g" \
-e "s/LOCALTYPE/$def_type/g" \
-e "s/LEFTMISSING/lhs_m->$1val/g" \
-e "s/RIGHTMISSING/rhs_m->$1val/g" \
-e 's/FNAME/pow/' \
-e 's/OPER/\^/' \
-e 's/FUNCNAME/exponent/' \
-e 's/CAST/double/g' \
-e 's/INCLUDE/math/' \
TypeFunctionOpTemplate.c.sed
else

sed \
-e "s/OUTDATATYPE/$1/g" \
-e "s/DATATYPE/$1/g" \
-e "s/LOCALTYPE/$def_type/g" \
-e "s/LEFTMISSING/lhs_m->$1val/g" \
-e "s/RIGHTMISSING/rhs_m->$1val/g" \
-e 's/FNAME/pow/' \
-e 's/OPER/\^/' \
-e 's/FUNCNAME/exponent/' \
-e 's/CAST/double/g' \
-e 's/INCLUDE/math/' \
TypeFunctionOpTemplate.c.sed
fi
fi


sed \
-e "s/OUTDATATYPE/logical/g" \
-e "s/DATATYPE/$1/g" \
-e "s/LOCALTYPE/$def_type/g" \
-e "s/LOCALOUTTYPE/logical/g" \
-e "s/OUTMISSING/((NclTypeClass)nclTypelogicalClass)->type_class.default_mis.logicalval/g" \
-e 's/THEOP/\!/' \
-e 's/OPER/\.ncl_not\./' \
-e 's/FUNCNAME/not/' \
TypeMonoOpTemplate.c.sed

sed \
-e "s/OUTDATATYPE/$1/g" \
-e "s/DATATYPE/$1/g" \
-e "s/LOCALTYPE/$def_type/g" \
-e "s/LOCALOUTTYPE/$def_type/g" \
-e "s/OUTMISSING/lhs_m->$1val/g" \
-e 's/THEOP/\-/' \
-e 's/OPER/neg/' \
-e 's/FUNCNAME/neg/' \
TypeMonoOpTemplate.c.sed

sed \
-e "s/OUTDATATYPE/$1/g" \
-e "s/DATATYPE/$1/g" \
-e "s/LOCALTYPE/$def_type/g" \
-e "s/LOCALOUTTYPE/$def_type/g" \
-e 's/THEOP/\</' \
-e 's/OPER/\</' \
-e 's/FUNCNAME/sel_lt/' \
TypeSelectOpTemplate.c.sed

sed \
-e "s/OUTDATATYPE/$1/g" \
-e "s/DATATYPE/$1/g" \
-e "s/LOCALTYPE/$def_type/g" \
-e "s/LOCALOUTTYPE/$def_type/g" \
-e 's/THEOP/\>/' \
-e 's/OPER/\>/' \
-e 's/FUNCNAME/sel_gt/' \
TypeSelectOpTemplate.c.sed

sed \
-e "s/OUTDATATYPE/logical/g" \
-e "s/DATATYPE/$1/g" \
-e "s/LOCALTYPE/$def_type/g" \
-e "s/LOCALOUTTYPE/logical/g" \
-e "s/LEFTMISSING/((NclTypeClass)nclTypelogicalClass)->type_class.default_mis.logicalval/g" \
-e "s/RIGHTMISSING/((NclTypeClass)nclTypelogicalClass)->type_class.default_mis.logicalval/g" \
-e 's/OPER/\.ncl_xor\./' \
-e 's/FUNCNAME/xor/' \
TypeXorOpTemplate.c.sed

sed \
-e "s/OUTDATATYPE/$1/g" \
-e "s/DATATYPE/$1/g" \
-e "s/LOCALTYPE/$def_type/g" \
-e "s/LOCALOUTTYPE/$def_type/g" \
-e "s/LEFTMISSING/lhs_m->$1val/g" \
-e "s/RIGHTMISSING/rhs_m->$1val/g" \
-e 's/THEOP/\//' \
-e 's/FUNCNAME/divide/' \
TypeDivOpTemplate.c.sed

if [ \( $1 = "int" \) -o \( $1 = "long" \) -o \( $1 = "short" \) -o \( $1 = "int64" \) -o \( $1 = "uint" \) -o \( $1 = "ulong" \) -o \( $1 = "ushort" \) -o \( $1 = "uint64" \) -o \( $1 = "ubyte" \) ]
then
sed \
-e "s/OUTDATATYPE/$1/g" \
-e "s/DATATYPE/$1/g" \
-e "s/LOCALTYPE/$def_type/g" \
-e "s/LOCALOUTTYPE/$def_type/g" \
-e "s/LEFTMISSING/lhs_m->$1val/g" \
-e "s/RIGHTMISSING/rhs_m->$1val/g" \
-e 's/THEOP/\%/' \
-e 's/OPER/mod/' \
-e 's/FUNCNAME/mod/' \
TypeDivOpTemplate.c.sed
fi

exit 0

#!/bin/sh

#
#      $Id: obj_data_c.sh,v 1.6 2009-07-10 19:54:06 huangwei Exp $
#
#########################################################################
#									#
#			   Copyright (C)  1995				#
#	     University Corporation for Atmospheric Research		#
#			   All Rights Reserved				#
#									#
#########################################################################
#
#	File:		
#
#	Author:		Ethan Alpert
#			National Center for Atmospheric Research
#			PO 3000, Boulder, Colorado
#
#	Date:		Fri Jan 27 18:34:11 MST 1995
#
#	Description:	
#
#	Usage:
#
#	Environment:
#
#	Files:
#
#
#	Options:
sh op_funcs.sh obj NULL NULL -1 > .tmp.$$

if [ ! $? ]
then
	exit $?
fi

sed \
-e 's/PRINTFORMAT/\%d\\n/' \
-e '/PRINTFORMAT/d' \
-e 's/DATATYPE/obj/g' \
-e 's/LOCALTYPE/obj/g' \
-e 's/HLUTYPEREP/NULL/g' \
-e 's/HLUGENTYPEREP/NULL/g' \
-e 's/DEFAULT_MISS/-1/g' \
-e 's/DEFAULT_FORMAT/%d/g' \
-e "/REPLACE/r .tmp.$$" \
-e '/REPLACE/d' \
-e '/DSPECIFIC/r NclTypeobj.c.specific' \
-e '/DSPECIFIC/d' \
-e 's/Ncl_Type_obj_not_type/NULL/' \
-e 's/Ncl_Type_obj_not/NULL/' \
-e 's/Ncl_Type_obj_xor_type/NULL/' \
-e 's/Ncl_Type_obj_xor/NULL/' \
-e 's/Ncl_Type_obj_or_type/NULL/' \
-e 's/Ncl_Type_obj_or/NULL/' \
-e 's/Ncl_Type_obj_and_type/NULL/' \
-e 's/Ncl_Type_obj_and/NULL/' \
-e 's/Ncl_Type_obj_mat_type/NULL/' \
-e 's/Ncl_Type_obj_mat/NULL/' \
-e 's/Ncl_Type_obj_mod_type/NULL/' \
-e 's/Ncl_Type_obj_mod/NULL/' \
-e 's/Ncl_Type_obj_divide_type/NULL/' \
-e 's/Ncl_Type_obj_divide/NULL/' \
-e 's/Ncl_Type_obj_multiply_type/NULL/' \
-e 's/Ncl_Type_obj_multiply/NULL/' \
-e 's/Ncl_Type_obj_plus_type/NULL/' \
-e 's/Ncl_Type_obj_plus/NULL/' \
-e 's/Ncl_Type_obj_minus_type/NULL/' \
-e 's/Ncl_Type_obj_minus/NULL/' \
-e 's/Ncl_Type_obj_exponent_type/NULL/' \
-e 's/Ncl_Type_obj_exponent/NULL/' \
-e 's/Ncl_Type_obj_sel_lt_type/NULL/' \
-e 's/Ncl_Type_obj_sel_lt/NULL/' \
-e 's/Ncl_Type_obj_sel_gt_type/NULL/' \
-e 's/Ncl_Type_obj_sel_gt/NULL/' \
-e 's/Ncl_Type_obj_neg_type/NULL/' \
-e 's/Ncl_Type_obj_neg/NULL/' \
-e 's/Ncl_Type_obj_gt_type/NULL/' \
-e 's/Ncl_Type_obj_gt/NULL/' \
-e 's/Ncl_Type_obj_lt_type/NULL/' \
-e 's/Ncl_Type_obj_lt/NULL/' \
-e 's/Ncl_Type_obj_ge_type/NULL/' \
-e 's/Ncl_Type_obj_ge/NULL/' \
-e 's/Ncl_Type_obj_le_type/NULL/' \
-e 's/Ncl_Type_obj_le/NULL/' \
-e 's/Ncl_Type_obj_is_mono/NULL/' \
-e 's/Ncl_Type_obj_coerce/NULL/' \
-e 's/Ncl_Type_obj_cmpf/NULL/' \
NclType.c.sed > NclTypeobj.c

rm .tmp.$$

echo "created NclTypeobj.c"

exit 0

C
C	$Id: argget.f.sed,v 1.2 2008-07-27 12:23:44 haley Exp $
C                                                                      
C			     Copyright (C)  2000
C	     University Corporation for Atmospheric Research
C			     All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C

      SUBROUTINE ARGGET(NUMBER,STRING)
C***********************************************************************
C	
C	Procedure: ARGGET()
C
C	Purpose: To determine the "NUMBER"th argument and
C		copy it into a CHARACTER*1 array "STRING".
C
C	Input Variables:
C		NUMBER:	The index of the desired argument.
C
C	Output Variables:
C		STRING:	A CHARACTER*1 array which is filled
C			with the appropriate argument.
C
C
C***********************************************************************
      INTEGER NUMBER
      CHARACTER*1 STRING(80)
      INTEGER I
      CHARACTER*80 ARG
C
      DO 10 I = 1,80
          ARG(I:I) = ' '
 10   CONTINUE

#ifdef	hpux
      CALL IGETARG(NUMBER,ARG, 80)
#else
      CALL GETARG(NUMBER,ARG)
#endif

      DO 20 I = 1,80
          STRING(I) = ARG(I:I)
 20   CONTINUE
C
      RETURN
      END

C
C	$Id: mninst.f.sed,v 1.2 2008-07-27 00:59:04 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE MNINST(SIZE,IOS,STATUS)
C
C  RETURN A BIT PACKET FROM A METAFILE RECORD CONTAINING MINIMAL METACODE
C
C  INPUT
C       SIZE-NUMBER OF BITS TO TRANSFER
C  OUTPUT
C       IOS-METAFILE READ STATUS VALID ONLY IF STATUS SET TO I/O ERROR
C       STATUS-THE STATUS FLAG DEFINED BY TREROR
C
      COMMON/TREROR/ ALLOK, MFRCHK, MTOPER, METRDC, REDERR, TYPCHG
     1             ,INVTYP, MINVLD, TYPERR, FRMEND, ENCINT, IVDCDT
     2             ,GCOERR, GCRERR, GCCERR, FCOERR, FCRERR, FCCERR
     3             ,PLIDXG, PMIDXG, TXIDXG, PGIDXG, INVLMT, CELERR
     4             ,COIERR, COLNRM, UNKNOW, UNKOPC, ENDMTF, VNEROR
     5             ,BADRSZ, DEVOUT, NOVERS, BADFNT, PGMERR, FASERR
     6             ,HINERR, VDWERR, RDWERR, RIXLIM
      INTEGER        ALLOK, MFRCHK, MTOPER, METRDC, REDERR, TYPCHG
     1             ,INVTYP, MINVLD, TYPERR, FRMEND, ENCINT, IVDCDT
     2             ,GCOERR, GCRERR, GCCERR, FCOERR, FCRERR, FCCERR
     3             ,PLIDXG, PMIDXG, TXIDXG, PGIDXG, INVLMT, CELERR
     4             ,COIERR, COLNRM, UNKNOW, UNKOPC, ENDMTF, VNEROR
     5             ,BADRSZ, DEVOUT, NOVERS, BADFNT, PGMERR, FASERR
     6             ,HINERR, VDWERR, RDWERR, RIXLIM
      COMMON /TRTYPE/ METMIN, METEXT, METPRT, METHED, MIOPCL, MXOPCL,
     1                MIOPID, MXOPID, ASCDEC, ASCHEX, ASCOCT, BINARY,
     2                GAHNOR, GALEFT, GACENT, GARITE, GAVNOR, GATOP ,
     3                GACAP , GAHALF, GABASE, GABOTT, GRIGHT, GLEFT ,
     4                GUP   ,
     5                GDOWN , CINDEX, CDIRCT, PENUP , PENDN , FLAGVL,
     6                SEPRVL, ASCTEK, TYPRGB, TYPBGR,
     7                TYPHLS, TYPMON, SOLID , DASHED, INVSBL, SOLPAT,
     8                ASFIND, ASFBND, ASFLNT, ASFLNW, ASFLNC, ASFMRT,
     9                ASFMRS, ASFMRC, ASFFIS, ASFFHI, ASFFPI, ASFFCO,
     A                ASFFPT, ASFFPW, ASFFPC, ASFTFI, ASFTPR, ASFTCX,
     B                ASFTCS, ASFTCO, ASCFLT, PHOLLO, PSOLID, PPATTR,
     C                PHATCH, PEMPTY, HHORIZ, HVERTI, HPOSLP, HNESLP,
     D                HHOAVE, HPOANE
      INTEGER         METMIN, METEXT, METPRT, METHED, MIOPCL, MXOPCL,
     1                MIOPID, MXOPID, ASCDEC, ASCHEX, ASCOCT, BINARY,
     2                GAHNOR, GALEFT, GACENT, GARITE, GAVNOR, GATOP ,
     3                GACAP , GAHALF, GABASE, GABOTT, GRIGHT, GLEFT ,
     4                GUP   ,
     5                GDOWN , CINDEX, CDIRCT, PENUP , PENDN , FLAGVL,
     6                SEPRVL, ASCTEK, TYPRGB, TYPBGR,
     7                TYPHLS, TYPMON, SOLID , DASHED, INVSBL, SOLPAT,
     8                ASFIND, ASFBND, ASFLNT, ASFLNW, ASFLNC, ASFMRT,
     9                ASFMRS, ASFMRC, ASFFIS, ASFFHI, ASFFPI, ASFFCO,
     A                ASFFPT, ASFFPW, ASFFPC, ASFTFI, ASFTPR, ASFTCX,
     B                ASFTCS, ASFTCO, ASCFLT, PHOLLO, PSOLID, PPATTR,
     C                PHATCH, PEMPTY, HHORIZ, HVERTI, HPOSLP, HNESLP,
     D                HHOAVE, HPOANE
      COMMON /PTRBUFR/ METBIT, MBUFER, MDTYPE, METREC, MRECLN,
     1                MCONTF, MOPRST, LNGFLG, MERGFL
      INTEGER MNWRDS, RECLOC, RECSIZ, DTLOC, DTSIZ, MBITST, MBUFOF,
     1        MINSBD, MERLOC, MERSIZ
#if defined(cray)
      PARAMETER (MNWRDS=180, RECLOC=0, RECSIZ=16, DTLOC=16, DTSIZ=4
#else
      PARAMETER (MNWRDS=360, RECLOC=0, RECSIZ=16, DTLOC=16, DTSIZ=4
#endif
     1          ,MBITST=32, MBUFOF=32, MINSBD=16, MERLOC=23, MERSIZ=1)
      INTEGER METBIT, MBUFER(MNWRDS), MDTYPE, METREC, MRECLN, MOPRST
      LOGICAL MCONTF, LNGFLG, MERGFL
      COMMON /TRINST/ OPCL, OPID, LEN, CONT
      INTEGER OPCL, OPID, LEN
      LOGICAL CONT
C
      INTEGER SIZE, IOS, STATUS
C
C  INITIALIZE THE ERROR STATUS FLAG
C
      STATUS = ALLOK
C
C  CHECK IF ENOUGH ROOM LEFT FOR THE REQUESTED INSTRUCTION PART
C
      IF (MRECLN .LT. (METBIT+SIZE)) THEN
C
C       READ IN A NEW METAFILE RECORD
C
        CALL METRED (IOS,STATUS)
        IF (STATUS.NE.ALLOK) RETURN
C
C  TEST FOR PROPER DATA TYPE (IGNORE ALL BUT METMIN)
C
        IF (MDTYPE.NE.METMIN) THEN
C
C               NOT SAME DATA TYPE--IGNORE
C
                STATUS = TYPCHG
                RETURN
        END IF
      END IF
C
C  EXTRACT THE REQUESTED BITS FROM THE RECORD
C
      CALL GBYTES(MBUFER,OPCL,METBIT,SIZE,0,1)
      METBIT = METBIT + SIZE
C
      RETURN
      END

#!/bin/sh

sh op_funcs.sh uint64 NhlTUint64 NhlTUint64GenArray 18446744073709551614ULL > .tmp.$$

if [ ! $? ]
then
	exit $?
fi

sed \
-e 's/PRINTFORMAT/\%llu\\n/' \
-e 's/DATATYPE/uint64/g' \
-e 's/LOCALTYPE/unsigned long long/g' \
-e 's/HLUTYPEREP/NhlTUint64/g' \
-e 's/HLUGENTYPEREP/NhlTUint64GenArray/g' \
-e 's/DEFAULT_MISS/18446744073709551614ULL/g' \
-e 's/DEFAULT_FORMAT/%llu/g' \
-e "/REPLACE/r .tmp.$$" \
-e '/REPLACE/d' \
-e '/DSPECIFIC/r NclTypeuint64.c.specific' \
-e '/DSPECIFIC/d' \
NclType.c.sed > NclTypeuint64.c

rm .tmp.$$

echo "created NclTypeuint64.c"

exit 0

#!/bin/csh -f
#
#	$Id: ncargsrc.csh,v 1.7 2008-07-27 00:59:06 haley Exp $
#                                                                      
#                Copyright (C)  2000
#        University Corporation for Atmospheric Research
#                All Rights Reserved
#
# The use of this Software is governed by a License Agreement.
#

# If no arguments, tell user how "ncargsrc" works.

if ($#argv == 0) then

  more << "END"
The command "ncargsrc" may be used to acquire copies of NCAR Graphics source
files.  This material is copyrighted; redistribution is not permitted except
with written permission from UCAR (the University Corporation for Atmospheric
Research).

Note:  For various reasons, files retrieved by "ncargsrc" are temporarily put
in a subdirectory called "NCARGSOURCE" and then moved to another subdirectory
called "ncargsource".  Among other things, this prevents overwriting user
files accidentally.

The argument list is processed from left to right.  Arguments which do not
begin with a dash are the names of source files to be retrieved; those with
a suffixed ".f", ".c", or ".h" are names of specific routines, while those
which have no such suffix refer to collections of routines comprising a
complete utility.  For example, the command

    ncargsrc areas

will retrieve, in a file called "areas", the entire collection of routines
comprising the utility called AREAS, while the command

    ncargsrc argeti.f

will retrieve, in a file called "argeti.f", one member of that collection,
called ARGETI.

Arguments which begin with a dash select options to be applied from then on.

The argument "-index" directs that what should be retrieved for an argument
like "areas" is not the code for the utility called "AREAS", but a file
called "areas.index" containing the names of the routines which make up that
utility.  You can execute a command like

    ncargsrc -index areas

and then, after examining the contents of the file "areas.index", execute
a command like

    ncargsrc arscam.f

to retrieve a specific selected routine from "areas".

The command

    ncargsrc -index

(in which the sole argument is "-index") produces a file called "INDEX" that
contains a listing of the contents of all the source libraries.

The following two source libraries are normally searched first:

    srcncarg.a      -  NCAR Graphics utilities (including the default members
		       of the CONRAN, CONREC, and DASH families).
    srcncarg_gks.a  -  NCAR Graphics GKS package.

The following eight source libraries are normally searched after the first
two:

    srcagupwrtx.a   -  a version of the AUTOGRAPH routine AGPWRT that
		       uses PWRITX.
    srcconraq.a     -  the "quick" member of the CONRAN family.
    srcconras.a     -  the "super" member of the CONRAN family.
    srcconrcqck.a   -  the "quick" member of the CONREC family.
    srcconrcspr.a   -  the "super" member of the CONREC family.
    srcdashline.a   -  the "quick" member of the DASH family.
    srcdashsmth.a   -  the "smooth" member of the DASH family.
    srcdashsupr.a   -  the "super" member of the DASH family.

The following command-line arguments may be used to move libraries to the
beginning of the search list:

    Argument                    Libraries moved to beginning of list
    -------------------------   -----------------------------------------
    -agupwrtx                   srcagupwrtx.a
    -quick                      srcconrcqck.a, srcconraq.a, srcdashline.a
    -smooth                     srcdashsmth.a
    -super                      srcconrcspr.a, srcconras.a, srcdashsupr.a
    -conrecquick                srcconrcqck.a
    -conrecsmooth               srcdashsmth.a
    -conrecsuper                srcconrcspr.a, srcdashsupr.a
    -conranquick                srcconraq.a
    -conransmooth               srcdashsmth
    -conransuper                srcconras.a, srcdashsupr.a
    -dashquick (or -dashline)   srcdashline.a
    -dashsmooth                 srcdashsmth.a
    -dashsuper                  srcdashsupr.a

Moving a library to the beginning of the search list has a simple effect on
the retrieval of a specific file.  The command

     ncargsrc conrec.f

retrieves the default version of "conrec.f", while the command

     ncargsrc -quick conrec.f

retrieves the "quick" version.

The effect (of moving a library to the beginning of the search list) on the
retrieval of an entire utility is not quite so simple.  The command

     ncargsrc conrec

retrieves, in a single file called "conrec", all the routines of the default
version of the utility CONREC, while the command

     ncargsrc -quick conrec

retrieves, in a single file called "conrec", all the routines of the default
version of the utility CONREC, replaces those routines for which there are
"quick" versions with those versions, and then appends all other routines
from the "-quick" libraries to the end of the file "conrec".  The intent of
this is to provide the user with all of the source code required by the
version of the utility implied by the argument list, but it does not always
work quite as one might like.  Some recommendations:

    To get             Use the following command
    ---------------    ---------------------------------------
    "normal" CONRAN    ncargsrc conran conterp concom
    "quick" CONRAN     ncargsrc conraq conterp concom
    "smooth" CONRAN    ncargsrc conran conterp concom dashsmth
    "super" CONRAN     ncargsrc conras conterp concom dashsupr
    "quick" CONREC     ncargsrc -conrecquick conrec
    "smooth" CONREC    ncargsrc -conrecsmooth conrec
    "super" CONREC     ncargsrc -conrecsuper conrec
    "normal" DASH      ncargsrc dashchar
    "quick" DASH       ncargsrc dashline
    "smooth" DASH      ncargsrc dashsmth
    "super" DASH       ncargsrc dashsupr

The following table lists all of the named collections of routines in the
source libraries:

    srcncarg.a      -  areas autogrph colconv common concom conpack conran
		       conrec conterp dashchar dashpack ezmap ezmapa gflash gridal
		       hafton histgr isosrf isosrfhr labelbar plotchar polypack
		       pwritx pwrity pwrzi pwrzs pwrzt softfill spps srface
		       stitle strmln support threed velvct wmap
    srcncarg_gks.a  -  awi bwi
    srcagupwrtx.a   -  agupwrtx
    srcconraq.a     -  conraq
    srcconras.a     -  conras
    srcconrcqck.a   -  conrcqck
    srcconrcspr.a   -  conrcspr
    srcdashline.a   -  dashline
    srcdashsmth.a   -  dashsmth
    srcdashsupr.a   -  dashsupr

"END"

  exit 0

endif

# Make sure "ncargpath" works by getting a path to the binary directory.

set b = `ncargpath SED_BINDIR`
if ($status != 0) then
        exit 1
endif

if (! -d "$b") then
  echo "Binary directory <$b> does not exist."
  exit 1
endif

# Create directories into which to copy the desired source files.

if (! -e NCARGSOURCE) then
  /bin/mkdir NCARGSOURCE
  /bin/chmod 777 NCARGSOURCE
endif

if (! -e ncargsource) then
  /bin/mkdir ncargsource
  /bin/chmod 700 ncargsource
endif

# Get the desired source files in "NCARGSOURCE".  Because the "set-uid" bit
# of "ncargsrcx" is on, the files will be owned by whoever owns "ncargsrcx".

cd NCARGSOURCE

$b/ncargsrcx $argv

# Copy the source files to "ncargsource" so they will have the right owner
# and set the permissions to read/write for the user only.

cd .. >& /dev/null

/bin/cp NCARGSOURCE/* ncargsource
/bin/rm -rf NCARGSOURCE
/bin/chmod 600 ncargsource/*

# Done.

exit 0

/*
 *      $Id: TypeMatMulOpTemplate.c.sed,v 1.3 2009-07-10 19:54:06 huangwei Exp $
 */
/************************************************************************
*									*
*			     Copyright (C)  1995			*
*	     University Corporation for Atmospheric Research		*
*			     All Rights Reserved			*
*									*
************************************************************************/
/*
 *	File:		
 *
 *	Author:		Ethan Alpert
 *			National Center for Atmospheric Research
 *			PO 3000, Boulder, Colorado
 *
 *	Date:		Fri Jan 27 18:29:35 MST 1995
 *
 *	Description:	
 */
NhlErrorTypes Ncl_Type_DATATYPE_mat
#if	NhlNeedProto
(void *result,void *lhs, void* rhs, NclScalar* lhs_m, NclScalar* rhs_m, int nlhs_dims,ng_size_t* lhs_dimsizes, int nrhs_dims,ng_size_t*rhs_dimsizes)
#else
(result,lhs,rhs,lhs_m,rhs_m,nlhs,lhs_dimsizes,nrhs,rhs_dimsizes)
void *result;
void *lhs;
void* rhs;
NclScalar* lhs_m;
NclScalar* rhs_m;
int nlhs;
ng_size_t* lhs_dimsizes;
int nrhs;
ng_size_t*rhs_dimsizes;
#endif
{
        LOCALTYPE *ls,*rs;
	LOCALOUTTYPE *res;
	ng_size_t stopi = 1;
	ng_size_t stopk = 1;
	ng_size_t stopj = 1;
	ng_size_t i,j,k;

	ls = (LOCALTYPE*)lhs;
	rs = (LOCALTYPE*)rhs;
	res = (LOCALOUTTYPE*)result;

	if((nrhs_dims == 2)&&(nlhs_dims ==2))  {
		stopi = lhs_dimsizes[0];
		stopj = rhs_dimsizes[1];
		stopk = rhs_dimsizes[0];
	} else if(nrhs_dims ==2) {
		stopi = 1;
		stopj = rhs_dimsizes[1];
		stopk = rhs_dimsizes[0];
	} else if(nlhs_dims ==2) {
		stopi = lhs_dimsizes[0];
		stopj = 1;
		stopk = rhs_dimsizes[0];
	} else {
		stopi = 1;
		stopj = 1;
		stopk = rhs_dimsizes[0];
	}
	

	if((lhs_m == NULL)&&(rhs_m == NULL)) {
		for(i = 0; i < stopi; i++) {
			for(j = 0; j < stopj; j++){
				rs = (LOCALTYPE*)rhs + j;
				ls = &(((LOCALTYPE*)lhs)[i * stopk]);
				*res = (LOCALOUTTYPE)(*ls++ * *rs);
				rs += stopj;
				for(k = 1; k < stopk; k++,ls++,rs+=stopj) {
					*res = *res + (LOCALOUTTYPE)(*ls * *rs);
				}
				res++;
			}
		}
	} else if(rhs_m == NULL) {
		for(i = 0; i < stopi; i++) {
			for(j = 0; j < stopj; j++){
				rs = (LOCALTYPE*)rhs + j;
				ls = &(((LOCALTYPE*)lhs)[i * stopk]);
				if( lhs_m->DATATYPEval == *ls) {
					*res = LEFTMISSING;
					res++;
					continue;
				} else {
					*res = (LOCALOUTTYPE)(*ls++ * *rs);
					rs += stopj;
				}
				for(k = 1; k < stopk; k++,ls++,rs+=stopj) {
					if( lhs_m->DATATYPEval == *ls) {
						*res = LEFTMISSING;
						break;
					} else 	{
						*res = *res + (LOCALOUTTYPE)(*ls * *rs);
					}
				}
				res++;
			}
		}
	} else if(lhs_m == NULL ) {
		for(i = 0; i < stopi; i++) {
			for(j = 0; j < stopj; j++){
				rs = (LOCALTYPE*)rhs + j;
				ls = &(((LOCALTYPE*)lhs)[i * stopk]);
				if( rhs_m->DATATYPEval == *rs) {
					*res = RIGHTMISSING;
					res++;
					continue;
				} else {
					*res = (LOCALOUTTYPE)(*ls++ * *rs);
					rs += stopj;
				}
				for(k = 1; k < stopk; k++,ls++,rs+=stopj) {
					if( rhs_m->DATATYPEval == *rs) {
						*res = RIGHTMISSING;
						break;
					} else 	{
						*res = *res + (LOCALOUTTYPE)(*ls * *rs);
					}
				}
				res++;
			}
		}
	} else {
		for(i = 0; i < stopi; i++) {
			for(j = 0; j < stopj; j++){
				rs = (LOCALTYPE*)rhs + j;
				ls = &(((LOCALTYPE*)lhs)[i * stopk]);
				if((rhs_m->DATATYPEval == *rs)||( lhs_m->DATATYPEval == *ls)) {
					*res = LEFTMISSING;
					res++;
					continue;
				} else {
					*res = (LOCALOUTTYPE)(*ls++ * *rs);
					rs += stopj;
				}
				for(k = 1; k < stopk; k++,ls++,rs+=stopj) {
					if(( rhs_m->DATATYPEval == *rs)||( lhs_m->DATATYPEval == *ls)) {
						*res = LEFTMISSING;
						break;
					} else 	{
						*res = *res + (LOCALOUTTYPE)(*ls * *rs);
					}
				}
				res++;
			}
		}
	}
	return(NhlNOERROR);
}

NclTypeClass Ncl_Type_DATATYPE_mat_type
#if	NhlNeedProto
(void)
#else
()
#endif
{
	return((NclTypeClass)nclTypeOUTDATATYPEClass);
}

#!/bin/sh

sh op_funcs.sh long NhlTLong NhlTLongGenArray -2147483647 > .tmp.$$

if [ ! $? ]
then
	exit $?
fi

sed \
-e 's/PRINTFORMAT/\%ld\\n/' \
-e 's/DATATYPE/long/g' \
-e 's/LOCALTYPE/long/g' \
-e 's/HLUTYPEREP/NhlTLong/g' \
-e 's/HLUGENTYPEREP/NhlTLongGenArray/g' \
-e 's/DEFAULT_MISS/-2147483647/g' \
-e 's/DEFAULT_FORMAT/%ld/g' \
-e "/REPLACE/r .tmp.$$" \
-e '/REPLACE/d' \
-e '/DSPECIFIC/r NclTypelong.c.specific' \
-e '/DSPECIFIC/d' \
NclType.c.sed > NclTypelong.c

rm .tmp.$$

echo "created NclTypelong.c"

exit 0

/*
 *      $Id: TypeMonoOpTemplate.c.sed 12092 2011-02-09 22:36:30Z haley $
 */
/************************************************************************
*									*
*			     Copyright (C)  1995			*
*	     University Corporation for Atmospheric Research		*
*			     All Rights Reserved			*
*									*
************************************************************************/
/*
 *	File:		
 *
 *	Author:		Ethan Alpert
 *			National Center for Atmospheric Research
 *			PO 3000, Boulder, Colorado
 *
 *	Date:		Fri Jan 27 18:28:58 MST 1995
 *
 *	Description:	
 */
/*ARGSUSED*/
NhlErrorTypes Ncl_Type_DATATYPE_FUNCNAME
#if	NhlNeedProto
(void *result,void *lhs, void* rhs, NclScalar* lhs_m, NclScalar* rhs_m, ng_size_t nlhs, ng_size_t nrhs)
#else
(result,lhs,rhs,lhs_m,rhs_m,nlhs,nrhs)
void *result;
void *lhs;
void* rhs;
NclScalar* lhs_m;
NclScalar* rhs_m;
ng_size_t nlhs;
ng_size_t nrhs;
#endif
{
        LOCALTYPE *ls,*rs;
	LOCALOUTTYPE *res;
	ng_size_t stopi = 1;
	ng_size_t linc = 0;
	ng_size_t rinc = 0;
	ng_size_t i;
	
	rs = NULL;
	ls = (LOCALTYPE*)lhs;
	res = (LOCALOUTTYPE*)result;	

	if(nlhs > nrhs) 
		stopi = nlhs;
	else
		stopi = nrhs;
	if(nlhs > 1) {
		linc = 1;
	}
	if(nrhs > 1) {
		rinc = 1;
	}
	

	if((lhs_m == NULL)&&(rhs_m == NULL)) {
		for(i = 0 ; i < stopi; i++, res++, ls += linc, rs += rinc) {
			*res = (LOCALOUTTYPE)(THEOP *ls);
		}
	} else {
		for(i = 0; i < stopi; i++, res++, ls += linc, rs += rinc) {
			*res = (LOCALOUTTYPE)(( lhs_m->DATATYPEval == *ls) ? ( OUTMISSING ) : (THEOP *ls));
		}
	} 
	return(NhlNOERROR);
}

NclTypeClass Ncl_Type_DATATYPE_FUNCNAME_type
#if	NhlNeedProto
(void)
#else
()
#endif
{
	return((NclTypeClass)nclTypeOUTDATATYPEClass);
}

#!/bin/sh
#
#      $Id: type_support_h.sh,v 1.2 1997-09-02 20:27:41 ethan Exp $
#
#########################################################################
#									#
#			   Copyright (C)  1995				#
#	     University Corporation for Atmospheric Research		#
#			   All Rights Reserved				#
#									#
#########################################################################
#
#	File:		
#
#	Author:		Ethan Alpert
#			National Center for Atmospheric Research
#			PO 3000, Boulder, Colorado
#
#	Date:		Fri Jan 27 18:33:52 MST 1995
#
#	Description:	
#
#	Usage:
#
#	Environment:
#
#	Files:
#
#
#	Options:



sed \
-e 's/TFUNC/multiply/g' \
TypeSupportOpTemplate.h.sed > .tmp.$$

sed \
-e 's/TFUNC/divide/g' \
TypeSupportOpTemplate.h.sed >> .tmp.$$

sed \
-e 's/TFUNC/plus/g' \
TypeSupportOpTemplate.h.sed >> .tmp.$$

sed \
-e 's/TFUNC/minus/g' \
TypeSupportOpTemplate.h.sed >> .tmp.$$

sed \
-e 's/TFUNC/exponent/g' \
TypeSupportOpTemplate.h.sed >> .tmp.$$

sed \
-e 's/TFUNC/mod/g' \
TypeSupportOpTemplate.h.sed >> .tmp.$$

sed \
-e 's/TFUNC/sel_lt/g' \
TypeSupportOpTemplate.h.sed >> .tmp.$$

sed \
-e 's/TFUNC/sel_gt/g' \
TypeSupportOpTemplate.h.sed >> .tmp.$$

sed \
-e 's/TFUNC/gt/g' \
TypeSupportOpTemplate.h.sed >> .tmp.$$

sed \
-e 's/TFUNC/lt/g' \
TypeSupportOpTemplate.h.sed >> .tmp.$$

sed \
-e 's/TFUNC/ge/g' \
TypeSupportOpTemplate.h.sed >> .tmp.$$

sed \
-e 's/TFUNC/le/g' \
TypeSupportOpTemplate.h.sed >> .tmp.$$

sed \
-e 's/TFUNC/ne/g' \
TypeSupportOpTemplate.h.sed >> .tmp.$$

sed \
-e 's/TFUNC/eq/g' \
TypeSupportOpTemplate.h.sed >> .tmp.$$

sed \
-e 's/TFUNC/ncl_and/g' \
TypeSupportOpTemplate.h.sed >> .tmp.$$

sed \
-e 's/TFUNC/ncl_or/g' \
TypeSupportOpTemplate.h.sed >> .tmp.$$

sed \
-e 's/TFUNC/ncl_xor/g' \
TypeSupportOpTemplate.h.sed >> .tmp.$$

sed \
-e 's/TFUNC/ncl_not/g' \
TypeSupportMonoOpTemplate.h.sed >> .tmp.$$

sed \
-e 's/TFUNC/neg/g' \
TypeSupportMonoOpTemplate.h.sed >> .tmp.$$

sed \
-e 's/TFUNC/mat/g' \
TypeSupportMatTemplate.h.sed >> .tmp.$$



if [ ! $? ]
then
	exit $?
fi

sed \
-e "/INSERTHERE/r .tmp.$$" \
-e '/INSERTHERE/d' \
TypeSupport.h.sed > .tmp2.$$

sed \
-e 's/ncl_and_type/and_type/g' \
-e 's/ncl_not_type/not_type/g' \
-e 's/ncl_xor_type/xor_type/g' \
-e 's/ncl_or_type/or_type/g' \
.tmp2.$$ > TypeSupport.h

rm .tmp.$$ .tmp2.$$

echo "created TypeSupport.h"

exit 0

#!/bin/ksh
#-----------------------------------------------------------------------
#-- KSH  -  NCL Doc Example script:
#--
#-- convert GrADS color tables to NCL color tables
#-- used by   gsn_define_colormap(wks,"NCL_BYR-03")
#--
#-- Example GrADS colo table file:    BYR-03
#--
#-- usage:  grads2ncl_coltab.ksh BYR-03
#--         ---> creates new file NCL_BYR-03.rgb
#--
#-- KMF 03.05.13
#-----------------------------------------------------------------------
in=$1

grads_coltab=${in##*/}
coltab=NCL_${grads_coltab%.*}.rgb

#-- count the number of colors plus foreground and background color.
ncols=$(cat ${in} | grep -v "\*" | grep -v "\#" | wc -l)
ncols=$(expr ${ncols} + 2)

#-- insert background (1) and foreground (0) colors
#-- NCL starts with color index 2
cat << EOF > ${coltab}
ncolors=${ncols}
# r   g   b
0 0 0
1 1 1
EOF

#-- read and write the color values
cat ${in} | grep -v "\*" | grep -v "\#" | sed -e "s/'//g" | awk '{print $4" "$5" "$6}' >> ${coltab}

exit

C
C	$Id: capchg.f.sed,v 1.3 2008-07-27 12:23:43 haley Exp $
C                                                                      
C			     Copyright (C)  1997
C	     University Corporation for Atmospheric Research
C			     All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C

      PROGRAM CAPCHG
C
C  This program converts the ASCII graphcap files into binary
C  graphcap files which are readable by the CGM translator.
C  Execution of this program will create a request for the
C  name of the ASCII graphcap file and a request for the name
C  of the binary output file.  If the program is executed in
C  a batch environment, appropriate changes must be made to
C  ensure the proper file names are supplied and OPENed.
C
C  This program contains the following labeled common blocks:
C
C    CAPASC
C    CAPASI
C    CAPBND
C    CAPCOL
C    CAPDEV
C    CAPERR
C    CAPIO2
C    CAPIOB
C    CAPLIN
C    CAPMAR
C    CAPPLG
C    CAPSCN
C    CAPSKP
C    CAPSPC
C    CAPTXT
C    CAPUSR
C    PARTB1
C    PARTB2
C
C  We now describe the variables in each of these commons.
C  After each variable name there is a pair of values in
C  brackets; the first value indicates the type of the
C  common variable, and the second value indicates its
C  default initial value.  The possibilities for the first
C  entry in the bracketed pair are:
C
C      I -- Integer
C     IA -- Integer array
C      R -- Real
C     RA -- Real array
C      C -- Character
C     CA -- Character array
C      L -- Logical
C
C    CAPASC
C    ------
C      ASCTB1 [CA, - ]  Table containing all 3-character sequences
C                       which have special meaning to the translator.
C                       This includes the special ASCII characters
C                       with ADE values between 0 and 31 (decimal).
C      ASCTB2 [CA, - ]  Table of all ASCII characters with ADE values
C                       between 33 and 126 (decimal).
C
C    CAPASI
C    ------
C      ASCVL1 [IA, - ]  A table containing decimal equivalents to the
C                       characters in ASCTB1.  Special negative values
C                       are assigned to the strings which are significant
C                       to the translator, but are not part of the ASCII
C                       character set.
C      ASCVL2 [IA, - ]  A table containing decimal equivalents for the
C                       ASCII characters in table ASCTB2.
C
C
C
C    CAPBND (Common for the bundle tables.)
C    ------
C      PLBTEC [ I, -1]  Number of POLYLINE bundle tables.
C      PLIBTB [IA, - ]  Array of indices for POLYLINE bundle tables.
C      PLTBTB [IA, - ]  Array of POLYLINE LINETYPE bundle table entries.
C      PLWBTB [RA, - ]  Array of POLYLINE LINEWIDTH bundle table entries.
C      PLCBTB [IA, - ]  Array of POLYLINE COLOR INDEX bundle table entries.
C      PMBTEC [ I, -1]  Number of POLYMARKER bundle tables.
C      PMIBTB [IA, - ]  Array of indices for POLYMARKER bundle tables.
C      PMTBTB [IA, - ]  Array of POLYMARKER MARKERTYPE bundle table entries.
C      PMSBTB [RA, - ]  Array of POLYMARKER MARKERSIZE bundle table entries.
C      PMCBTB [IA, - ]  Array of POLYMARKER COLOR INDEX bundle tbl. entries.
C      TXBTEC [ I, -1]  Number of TEXT bundle tables.
C      TXIBTB [IA, - ]  Array of indices for TEXT bundle tables.
C      TXFBTB [IA, - ]  Array of TEXT FONT bundle table entries.
C      TXPBTB [IA, - ]  Array of TEXT PRECISION bundle table entries.
C      TCXBTB [RA, - ]  Array of CHARACTER EXPANSION FACTOR table entries.
C      TCSBTB [RA, - ]  Array of CHARACTER SPACING bundle table entries.
C      TXCBTB [IA, - ]  Array of TEXT COLOR INDEX bundle table entries.
C      FABTEC [ I, -1]  Number of FILL AREA bundle tables.
C      FAIBTB [IA, - ]  Array of indices for FILL AREA bundle tables.
C      FISBTB [IA, - ]  Array of FILL AREA INTERIOR STYLE bundle table entries.
C      FASBTB [IA, - ]  Array of FILL AREA STYLE INDEX bundle table entries.
C      FACBTB [IA, - ]  Array of FILL AREA COLOR INDEX bundle table entries.
C
C
C    CAPCOL (Contains device color information.)
C    ------
C      COLINT [IA,  0]  Contains the DEVICE_MAP_INIT table of color intensities
C                       (COLINT is dimensioned for 3*(max number of colors)).
C      COLIDX [IA, - ]  Array of indices associated with the table of color
C                       intensities defined in COLINT above.
C      IDXCUR [ I,  0]  DEVICE_MAP_INDEX_RANGE_DEFINED
C      VDMINT [ -, - ]  Unused.
C      DMPAVL [ L,.FALSE.] DEVICE_MAP_AVAILABLE
C      COLFMT [IA,  0]  A two-dimensional array (dimensioned for
C                       COLMAX x 4) containing the DEVICE_COLOR_INDEX_FORMAT
C      COLFIN [IA,  0]  Array dimensioned for 8 describing the
C                       color indices as follows:
C                       COLFIN(1) -- DEVICE_COLOR_INDEX_ENCODING
C                       COLFIN(2) -- Number of 4-entry lines defined
C                                    in COLFMT.
C                       COLFIN(3) -- Maximum number of lines allowed
C                                    in COLFMT.
C                       COLFIN(4) -- Number of entries in each
C                                    line of COLFMT.
C
C                       If COLFIN(1) is not equal to 5, then
C                       COLFIN(5) is IFIX(ALOG10(FLOAT(IDXMAX+1))+1).
C
C                       The INTEGER array COLFIN is equivalenced to
C                       the REAL array COLRIN, and
C                       if COLFIN(1) equals 5, then
C                       COLRIN(5) -- Minimum data value input to encoder
C                       COLRIN(6) -- Maximum data value input to encoder
C                       COLRIN(7) -- Minimum data value output from
C                                    encoder.
C                       COLRIN(8) -- Maximum data value output from
C                                    encoder.
C                       obtained from DEVICE_COLOR_INDEX_FLOATING_INFO
C      IDXMAX [ I, -1]  DEVICE_MAP_INDEX_RANGE_MAX
C      MSTSTR [IA,  0]  Contains the string DEVICE_MAP_INSTRUCTION_START
C      MSTSIZ [ I,  0]  Number of characters in MSTSTR.
C      MTRSTR [IA,  0]  Contains the string DEVICE_MAP_INSTRUCTION_TERMINATOR
C      DMPMDL [ I,  1]  DEVICE_MAP_MODEL
C      MTRSIZ [ I,  0]  Number of characters in MTRSTR.
C      DMPIDV [ L,.FALSE.]  DEVICE_MAP_INDIVIDUAL
C      DMPFIN [IA,  0]  Array dimensioned for 8 describing the
C                       device map intensities as follows:
C                       DMPFIN(1) -- DEVICE_MAP_INTENSITY_ENCODING
C                       DMPFIN(2) -- Number of 4-entry lines defined
C                                    in DMPFMT.
C                       DMPFIN(3) -- Maximum number of lines allowed
C                                    in DMPFMT.
C                       DMPFIN(4) -- Number of entries in each
C                                    line of DMPFMT.
C
C                       If DMPFIN(1) equals 5, then
C                       DMPFIN(5) is IFIX(ALOG10(FLOAT(INTMAX+1))+1),
C                       where INTMAX is the maximum value in the
C                       COLINT array.
C
C                       The INTEGER array DMPFIN is equivalenced to
C                       the REAL array DMPRIN, and
C                       if DMPFIN(1) equals 5, then
C                       DMPRIN(5) -- Minimum data value input to encoder
C                       DMPRIN(6) -- Maximum data value input to encoder
C                       DMPRIN(7) -- Minimum data value output from
C                                    encoder.
C                       DMPRIN(8) -- Maximum data value output from
C                                    encoder.
C                       as obtained from
C                       DEVICE_MAP_INTENSITY_FLOATING_INFO
C      DMPFMT [IA,  0]  A two-dimensional array (dimensioned for
C                       DMPMAX x 4) containing the DEVICE_MAP_INTENSITY_FORMAT
C
C
C    CAPDEV (Contains all device class data.)
C    ------
C      DGISTR [IA, - ]  Array containing the DEVICE_GRAPHIC_INIT string.
C      DGISIZ [ I, - ]  Number of defined elements in DGISTR.
C      DGESTR [IA, - ]  Array containing the DEVICE_ERASE string.
C      DGESIZ [ I, - ]  Number of defined elements in DGESIZ.
C      DTISTR [IA, - ]  Array containing the DEVICE_TEXT_INIT string.
C      DTISIZ [ I, - ]  Number of defined elements in DTISTR.
C      DCDLLX [ I,  0]  DEVICE_COORD_LOWER_LEFT_X
C      DCDLLY [ I,  0]  DEVICE_COORD_LOWER_LEFT_Y
C      DCDURX [ I,  0]  DEVICE_COORD_UPPER_RIGHT_X
C      DCDURY [ I,  0]  DEVICE_COORD_UPPER_RIGHT_Y
C      DCOAVL [ L,.FALSE.]  DEVICE_COLOR_AVAILABLE
C      CORFMT [IA,  0]  A two-dimensional array (dimensioned for
C                       DCFTMX x 4) containing the DEVICE_COORD_FORMAT.
C      CORFIN [IA,  0]  Array dimensioned for 8 describing the
C                       device coordinates as follows:
C                       CORFIN(1) -- DEVICE_COORD_ENCODING
C                       CORFIN(2) -- Number of lines defined
C                                    in CORFMT.
C                       CORFIN(3) -- Maximum number of lines allowed
C                                    in CORFMT.
C                       CORFIN(4) -- Number of entries in each
C                                    line of CORFMT.
C
C                       The INTEGER array CORFIN is equivalenced to
C                       the REAL array CORRIN, and
C                       if encoding is ASCII real, then
C                       CORRIN(5) -- Minimum data value input to encoder
C                       CORRIN(6) -- Maximum data value input to encoder
C                       CORRIN(7) -- Minimum data value output from
C                                    encoder.
C                       CORRIN(8) -- Maximum data value output from
C                                    encoder.
C                       as obtained from DEVICE_COORD_FLOATING_INFO
C      BATCH  [ L,.FALSE.] DEVICE_BATCH
C      DHCSIZ [ I, - ]  Number of defined characters in DEVICE_CURSOR_HOME.
C      DHCSTR [ I, - ]  Array containing the DEVICE_CURSOR_HOME string.
C      CORXOF [ I,  0]  DEVICE_COORD_XOFFSET
C      CORYOF [ I,  0]  DEVICE_COORD_YOFFSET
C      DASBIT [ I,100]  DASH_BIT_LENGTH
C      CORXSC [ R,1.0]  DEVICE_COORD_XSCALE
C      CORYSC [ R,1.0]  DEVICE_COORD_YSCALE
C      VDWLLX [ I,  0]  DEVICE_WINDOW_LOWER_LEFT_X
C      VDWLLY [ I,  0]  DEVICE_WINDOW_LOWER_LEFT_Y
C      VDWURX [ I,32767]  DEVICE_WINDOW_UPPER_RIGHT_X
C      VDWURY [ I,32767]  DEVICE_WINDOW_UPPER_RIGHT_X
C
C
C    CAPERR  (Error flags)
C    ------
C      ALLOK  [ I, 0]  No error condition obtains.
C      EOFFL  [ I, 1]  End-of-file encountered.
C      INTERR [ I, 2]  Error decoding an integer value.
C      MAXINT [ I, 3]  Integer exceeds the maximum number of digits
C                      allowed.
C      PLBERR [ I, 4]  Error in defining the polyline bundle tables
C                      indicating that not all of the tables in the
C                      class are of the same length.
C      PMBERR [ I, 5]  Error in defining the polymarker bundle tables
C                      indicating that not all of the tables in the
C                      class are of the same length.
C      FABERR [ I, 6]  Error in defining the fill area bundle tables
C                      indicating that not all of the tables in the
C                      class are of the same length.
C      TXBERR [ I, 7]  Error in defining the text bundle tables
C                      indicating that not all of the tables in the
C                      class are of the same length.
C      FLTERR [ I, 8]  Error in decoding a floating point value.
C      MAXFLT [ I, 9]  Floating point value exceeds the maximum
C                      number of digits allowed.
C      NOTINT [ I,10]  An integer field is being decoded, but the
C                      value in the input graphcap file is not integer.
C      SIZERR [ I,11]  The string buffer is not big enough to hold
C                      the input string.
C      UNDASC [ I,12]  A value was encountered which is not in the
C                      local ASCII tables.
C      DEVERR [ I,13]  The device coordinate space is null.
C      DOCERR [ I,14]  Not used.
C      TBLERR [ I,15]  Not used.
C      STSZER [ I,16]  Not used.
C      ENTERR [ I,17]  Not used.
C      TABERR [ I,18]  Not used.
C      TABSER [ I,19]  Not used.
C      PRSFIL [ I,20]  Not used.
C
C
C    CAPIO2
C    ------
C      LINE  [CA, - ]  Array containing the current line buffer.
C
C
C    CAPIOB
C    ------
C      UNIT  [ I, - ]  Used for the unit number for reading the
C                      input file, and for writing the output file.
C      IPTR  [ I, - ]  Points to the current position in the LINE buffer.
C      LSIZE [ I, - ]  The number of useable characters in LINE.
C
C    CAPLIN  (Contains the POLYLINE information.)
C    ------
C      PLAVBL  [ L,.FALSE.]  LINE_DRAW_POLY_FLAG
C      LDSSTR  [IA, - ]  LINE_DRAW_INSTRUCTION_START
C      LDSSIZ  [ I, - ]  Number of characters in  LDSSTR.
C      LDTSTR  [IA, - ]  LINE_DRAW_INSTRUCTION_TERMINATOR
C      LDTSIZ  [ I, - ]  Number of characters in  LDTSTR.
C      LMSSTR  [IA, - ]  LINE_MOVE_INSTRUCTION_START
C      LMSSIZ  [ I, - ]  Number of characters in LMSSTR.
C      LMTSTR  [IA, - ]  LINE_MOVE_INSTRUCTION_TERMINATOR
C      LMTSIZ  [ I, - ]  Number of characters in  LMTSTR.
C      LCSSTR  [IA, - ]  LINE_COLOR_INSTRUCTION_START
C      LCSSIZ  [ I, - ]  Number of characters in  LCSSTR.
C      LCTSTR  [IA, - ]  LINE_COLOR_INSTRUCTION_TERMINATOR
C      LCTSIZ  [ I, - ]  Number of characters in  LCTSTR.
C      LINFIN [IA,  0]  Array dimensioned for 8 describing the
C                       device vector counts as follows:
C                       LINFIN(1) -- DEVICE_VECTOR_COUNT_ENCODING
C                       LINFIN(2) -- Number of lines defined
C                                    in LINFMT.
C                       LINFIN(3) -- Maximum number of lines allowed
C                                    in LINFMT.
C                       LINFIN(4) -- Number of entries in each
C                                    line of LINFMT.
C
C                       The INTEGER array LINFIN is equivalenced to
C                       the REAL array LINRIN, and
C                       if encoding is ASCII real, then
C                       LINRIN(5) -- Minimum data value input to encoder
C                       LINRIN(6) -- Maximum data value input to encoder
C                       LINRIN(7) -- Minimum data value output from
C                                    encoder.
C                       LINRIN(8) -- Maximum data value output from
C                                    encoder.
C                       obtained from DEVICE_VECTOR_COUNT_FLOATING_INFO
C
C                       if encoding is not ASCII real, then
C                       LINFIN(5) equals 5 .
C      LINFMT [IA,  0]  A two-dimensional array (dimensioned for
C                       LVCFMX x 4) containing the
C                       DEVICE_VECTOR_COUNT_FORMAT
C      LWSSTR [IA, - ]  LINE_WIDTH_INSTRUCTION_START
C      LWSSIZ [ I, - ]  Number of characters in LWSSTR.
C      LWTSTR [IA, - ]  LINE_WIDTH_INSTRUCTION_TERMINATOR
C      LWTSIZ [ I, - ]  Number of characters in LWTSTR.
C      LWTFIN [IA,  0]  Array dimensioned for 8 describing the
C                       line widths as follows:
C                       LWTFIN(1) -- LINE_WIDTH_ENCODING
C                       LWTFIN(2) -- Number of lines defined
C                                    in LWTFMT.
C                       LWTFIN(3) -- Maximum number of lines allowed
C                                    in LWTFMT.
C                       LWTFIN(4) -- Number of entries in each
C                                    line of LWTFMT.
C
C                       The INTEGER array LWTFIN is equivalenced to
C                       the REAL array LWTRIN, and
C                       if encoding is ASCII real, then
C                       LWTRIN(5) -- Minimum data value input to encoder
C                       LWTRIN(6) -- Maximum data value input to encoder
C                       LWTRIN(7) -- Minimum data value output from
C                                    encoder.
C                       LWTRIN(8) -- Maximum data value output from
C                                    encoder.
C                       obtained from LINE_WIDTH_FLOATING_INFO
C
C                       if encoding is not ASCII real, then
C                       LWTFIN(5) equals 5 .
C      LWTFMT [IA,  0]  A two-dimensional array (dimensioned for
C                       LWTFMX x 4) containing the
C                       LINE_WIDTH_FORMAT
C      LWTRNG [IA, - ]  Two values specifying the LINE_WIDTH_RANGE.
C      LWTSCF [ R,1.0]  LINE_WIDTH_SCALE
C      LBSSTR [IA, - ]  LINE_BACKGROUND_COLOR_INSTRUCTION_START
C      LBSSIZ [ I, - ]  Number of characters in LBSSTR.
C      LBTSTR [IA, - ]  LINE_BACKGROUND_COLOR_INSTRUCTION_TERMINATOR
C      LBTSIZ [ I, - ]  Number of characters in LBTSTR.
C      LPSSTR [IA, - ]  LINE_POINT_START
C      LPSSIZ [ I, - ]  Number of characters in LPSSTR.
C      LPTSTR [IA, - ]  LINE_POINT_TERMINATOR
C      LPTSIZ [ I, - ]  Number of characters in LPTSTR.
C
C
C    CAPMAR  (Contains POLYMARKER information.)
C    ------
C      MCSSTR [IA, - ]  MARKER_COLOR_INSTRUCTION_START
C      MCSSIZ [ I, - ]  Number of characters in  MCSSTR.
C      MCTSTR [IA, - ]  MARKER_COLOR_INSTRUCTION_TERMINATOR
C      MCTSIZ [ I, - ]  Number of characters in MCTSTR.
C      MARFIN [IA,  0]  Array dimensioned for 5 describing the
C                       marker vector counts as follows:
C                       MARFIN(1) -- MARKER_VECTOR_COUNT_ENCODING
C                       MARFIN(2) -- Number of lines defined
C                                    in MARFMT.
C                       MARFIN(3) -- Currently undefined.
C                       MARFIN(4) -- Currently undefined.
C                       MARFIN(5) -- Currently undefined.
C      MARFMT [IA,  0]  A two-dimensional array (dimensioned for
C                       MVCFMX x 4) containing the
C                       MARKER_VECTOR_COUNT_FORMAT
C      MRSSTR [IA, - ]  MARKER_INSTRUCTION_START
C      MRSSIZ [ I, - ]  Number of characters in MRSSTR.
C      MRTSTR [IA, - ]  MARKER_INSTRUCTION_TERMINATOR
C      MRTSIZ [ I, - ]  Number of charactgers in MRTSTR.
C      MDOTSZ [ I, 0 ]  MARKER_DOT_SIZE
C
C
C    CAPPLG  (Polygon class information.)
C    ------
C      PCSSTR [IA, - ]  POLYGON_COLOR_INSTRUCTION_START
C      PCSSIZ [ I, - ]  Number of characters in PCSSTR.
C      PCTSTR [IA, - ]  POLYGON_COLOR_INSTRUCTION_TERMINATOR
C      PCTSIZ [ I, - ]  Number of characters in PCTSTR.
C      PLSSTR [IA, - ]  POLYGON_INSTRUCTION_START
C      PLSSIZ [ I, - ]  Number of characters in PLSSTR.
C      PLTSTR [IA, - ]  POLYGON_INSTRUCTION_TERMINATOR
C      PLTSIZ [ I, - ]  Number of characters in PLTSTR.
C      PBSSTR [IA, - ]  POLYGON_BACKGROUND_COLOR_INSTRUCTION_START
C      PBSSIZ [ I, - ]  Number of characters in PBSSIZ.
C      PBTSTR [IA, - ]  POLYGON_BACKGROUND_COLOR_INSTRUCTION_TERMINATOR
C      PBTSIZ [ I, - ]  Number of characters in PBTSIZ.
C      PHATSP [ I,300]  POLYGON_HATCH_SPACING
C      PMAXPT [I,32767] POLYGON_MAXIMUM_POINTS
C      PPSSTR [IA, - ]  POLYGON_POINT_START
C      PPSSIZ [ I, - ]  Number of characters in PPSSIZ.
C      PPTSTR [IA, - ]  POLYGON_POINT_TERMINATOR
C      PPTSIZ [ I, - ]  Number of characters in PPTSIZ.
C      PLGSIM [ L,.TRUE.] POLYGON_SIMULATE
C      PSIMSP [ I, * ]  POLYGON_SIMULATION_SPACING --
C                         default depends on device coordinate space.
C      PSIMTR [ I, 0 ]  POLYGON_SIMULATION_TRUNCATION
C
C
C    CAPSCN  (RASTER class information.)
C    ------
C      SCSSTR [IA, - ]  RASTER_HORIZONTAL_INSTRUCTION_START
C      SCSSIZ [ I, - ]  Number of characters in SCSSTR.
C      SCTSTR [IA, - ]  RASTER_HORIZONTAL_INSTRUCTION_TERMINATOR
C      SCTSIZ [ I, - ]  Number of characters in SCTSTR.
C      SCNLLX [ I, - ]  RASTER_COORD_LOWER_LEFT_X
C      SCNLLY [ I, - ]  RASTER_COORD_LOWER_LEFT_Y
C      SCNURX [ I, - ]  RASTER_COORD_UPPER_RIGHT_X
C      SCNURY [ I, - ]  RASTER_COORD_UPPER_RIGHT_Y
C      SCNXOF [ I, - ]  RASTER_COORD_XOFF
C      SCNYOF [ I, - ]  RASTER_COORD_YOFF
C      SCNXSC [ R, - ]  RASTER_COORD_XSCALE
C      SCNYSC [ R, - ]  RASTER_COORD_YSCALE
C      SCNFMT [IA,  0]  A two-dimensional array (dimensioned for
C                       SFMFMX x 4) containing the
C                       RASTER_DATA_FORMAT
C      SCNFIN [IA,  0]  Array dimensioned for 8 describing the
C                       raster data format as follows:
C                       SCNFIN(1) -- RASTER_DATA_ENCODING
C                       SCNFIN(2) -- Number of lines defined
C                                    in SCNFMT.
C                       SCNFIN(3) -- Maximum number of lines allowed
C                                    in SCNFMT.
C                       SCNFIN(4) -- Number of entries in each
C                                    line of SCNFMT.
C
C                       The INTEGER array SCNFIN is equivalenced to
C                       the REAL array SCNRIN, and
C                       if encoding is ASCII real, then
C                       SCNRIN(5) -- Minimum data value input to encoder
C                       SCNRIN(6) -- Maximum data value input to encoder
C                       SCNRIN(7) -- Minimum data value output from
C                                    encoder.
C                       SCNRIN(8) -- Maximum data value output from
C                                    encoder.
C                       obtained from RASTER_DATA_FLOATING_INFO
C      SCVFMT [IA,  0]  A two-dimensional array (dimensioned for
C                       SCVFMX x 4) containing the
C                       RASTER_VECTOR_COUNT_FORMAT
C      SCVFIN [IA,  0]  Array dimensioned for 8 describing the
C                       raster vector count format as follows:
C                       SCVFIN(1) -- RASTER_VECTOR_COUNT_ENCODING
C                       SCVFIN(2) -- Number of lines defined
C                                    in SCVFMT.
C                       SCVFIN(3) -- Maximum number of lines allowed
C                                    in SCVFMT.
C                       SCVFIN(4) -- Number of entries in each
C                                    line of SCVFMT.
C
C                       The INTEGER array SCVFIN is equivalenced to
C                       the REAL array SCVRIN, and
C                       if encoding is ASCII real, then
C                       SCVRIN(5) -- Minimum data value input to encoder
C                       SCVRIN(6) -- Maximum data value input to encoder
C                       SCVRIN(7) -- Minimum data value output from
C                                    encoder.
C                       SCVRIN(8) -- Maximum data value output from
C                                    encoder.
C                       obtained from RASTER_VECTOR_COUNT_FLOATING_INFO
C      SCNSIM [ L,.FALSE.]  RASTER_SIMULATE
C
C
C    CAPSKP (Controls printing of the input lines.)
C    ------
C      SKIPIT [ L,.TRUE.]  Controls printing of the input lines, if
C                          SKIPIT is .TRUE., then the input lines are
C                          not printed; if SKIPIT is .FALSE., then
C                          the input lines are printed.
C
C
C    CAPSPC (Dummy graphcap space for future temporary expansions)
C    ------
C      DUMSPC  [ I, - ]     SCRATCH SPACE (DIMENSIONED FOR DUMSIZ)
C      ENDDSP  [ I, - ]     Dummy variable to flag the end of graphcap
C                           variables in the binary graphcap.
C
C
C    CAPTXT (TEXT class information.)
C    ------
C      TCSSTR [IA, - ]  TEXT_COLOR_INSTRUCTION_START
C      TCSSIZ [ I, - ]  Number of characters in TCSSTR.
C      TCTSTR [IA, - ]  TEXT_COLOR_INSTRUCTION_TERMINATOR
C      TCTSIZ [ I, - ]  Number of characters in TCTSTR.
C      TXTFMT [IA,  0]  A two-dimensional array (dimensioned for
C                       TVCFMX x 4) containing the
C                       TEXT_VECTOR_COUNT_FORMAT
C      TXTFIN [IA,  0]  Array dimensioned for 5 describing the
C                       text vector count format as follows:
C                       TXTFIN(1) -- TEXT_VECTOR_COUNT_ENCODING
C                       TXTFIN(2) -- Number of lines defined
C                                    in TXTFMT.
C                       TXTFIN(3) -- Currently not used.
C                       TXTFIN(4) -- Currently not used.
C      TXSSTR [IA, - ]  TEXT_INSTRUCTION_START
C      TXSSIZ [ I, - ]  Number of characters in TXSSTR.
C      TXTSTR [IA, - ]  TEXT_INSTRUCTION_TERMINATOR
C      TXTSIZ [ I, - ]  Number of characters in TXTSIZ.
C
C
C    CAPUSR
C    ------
C      UPRSTR [IA, - ]  USER_PROMPT
C      UPRSIZ [ I, - ]  Number of characters in UPRSTR.
C
C
C    PARTB1
C    ------
C      PART1  [CA, - ]  Contains all character sequences
C                       which are pertinent to parsing then
C                       input graphcap file.  PART1 is
C                       initialized in the BLOCKDATA.
C      KEYSEP [ C,'_']  A CHARACTER*1 variable containing
C                       the keyword separator.
C      KEYTER [ C,' ']  A CHARACTER*1 variable containing the
C                       keyword terminator.
C      FRCOM  [CA,'/','*']  A CHARACTER*1 array of dimension 2
C                       containing the two initial characters
C                       which will cause a line in the input
C                       grpaphcap to be regarded as a comment line.
C
C    PARTB2
C    ------
C      PART2 [IA, - ]  An array of pointers indicating the
C                      the next jump in the parse tree.  See
C                      the example after the description of
C                      PART5 to see how the parse tables
C                      interact.For
C
C                      we should go to the 24th section of
C                      keywords in PART1 to find our next
C                      keyword.
C                      PART4(24) = 786 indicating we should
C
C                      indicates we should go to PART2(88)
C                      to see where the next row of keywords
C                      is.  PART2(88) = 24, and PART3(24) =
C                      5
C      PART3 [IA, - ]  Contains pointers into PART4.
C      PART4 [IA, - ]  Contains pointers into PART1.  These pointers
C                      indicate where the first character
C                      of sections of keywords are located in PART1.
C      PART5 [IA, - ]  Pairs of integers indicating how many keywords
C                      are in a given section in PART1, and how
C                      many characters in length each keyword
C                      in that section is.  Currently there are
C                      24 different keyword sections in PART1, i.e.
C                      PART1 is segmented into 24 different sections.
C
C                      DISCUSSION of the parse tables:
C                       The keywords necessary to the parsing are
C                       stored in PART1 in groups.  Within each
C                       group, all keywords have the same length
C                       (some may have to be blank padded to satisfy
C                       this.)  The values in PART4 indicate where
C                       in PART1 groups of keywords begin.  The
C                       values in PART5 indicate, for each group of
C                       keywords in PART1, how many keywords are
C                       in that group, and the length of each word
C                       in the group.  The values in PART3 are pointers
C                       to the various keyword groups.
C
C                      EXAMPLE:  Let us consider an example of how
C                       the various parse tables interact.  Suppose
C                       the input keyword string being parsed is
C                       RASTER_HORIZONTAL_INSTRUCTION_TERMINATOR.
C                       The keyword RASTER is the 9th entry
C                       in the initial group of  keywords in PART1
C                       (the 9 entries being: DEVICE, LINE, USER,
C                       BUNDLE, TEXT, MARKER, POLYGON, DASH,
C                       and RASTER.)  PART2 is used to determine
C                       which group of keywords to search next after
C                       RASTER has been found.  If PART2(9) = N,
C                       and PART3(N) = M, then the next group of
C                       keywords to be searched is the Mth group
C                       which starts at PART4(M).  If the keyword
C                       matched within the current keyword group is
C                       number L, then PART2(N+L-1) provides the
C                       pointer into PART3 which will produce the
C                       number of the next keyword group to be
C                       searched.  This procedure is continued
C                       until the entry in PART2 is 0, indicating
C                       the final keyword has been found.
C      CTSTR [ I, - ]  Currently unused.
C      CTLOC [ I, - ]  Currently unused.
C
C
C
C
      COMMON /CAPERR/ ALLOK, EOFFL, INTERR, MAXINT, PLBERR, PMBERR,
     1                FABERR, TXBERR, FLTERR, MAXFLT, NOTINT, SIZERR,
     2                UNDASC, DEVERR, DOCERR, TBLERR , STSZER, ENTERR,
     3                TABERR, TABSER, PRSFIL
      INTEGER ALLOK, EOFFL, INTERR, MAXINT, PLBERR, PMBERR,
     1        FABERR, TXBERR, FLTERR, MAXFLT, NOTINT, SIZERR, UNDASC,
     2        DEVERR, DOCERR, STSZER, ENTERR, TABERR, TABSER, TBLERR,
     3        PRSFIL
      COMMON /CAPIOB/ UNIT, IPTR, LSIZE, NFST, NFLG
      COMMON /CAPIO2/ LINE, GRNM
      INTEGER LNMAX
      PARAMETER (LNMAX=80)
      CHARACTER*80 LINE
      CHARACTER*80 GRNM
      INTEGER UNIT, IPTR, LSIZE, NFST, NFLG
C
C  CONTROL THE PRINTING OF INPUT LINES
C
      COMMON /CAPSKP/ SKIPIT
      LOGICAL SKIPIT
      COMMON /CAPPLG/ PCSSTR, PCSSIZ, PCTSTR, PCTSIZ, PLSSTR,
     1                PLSSIZ, PLTSTR, PLTSIZ, PBSSTR, PBSSIZ,
     2                PBTSTR, PBTSIZ, PHATSP, PMAXPT, PPSSTR,
     3                PPSSIZ, PPTSTR, PPTSIZ, PLGSIM, PSIMSP,
     4                PSIMTR
      INTEGER         PCSMAX, PCTMAX, PLSMAX, PLTMAX, PBSMAX,
     1                PBTMAX, PPSMAX, PPTMAX
      PARAMETER   (PCSMAX=20, PCTMAX=15, PLSMAX=40, PLTMAX=20)
      PARAMETER   (PBSMAX=30, PBTMAX=15, PPSMAX=20, PPTMAX=20)
      INTEGER         PCSSTR(PCSMAX), PCSSIZ, PCTSTR(PCTMAX), PCTSIZ,
     1                PLSSTR(PLSMAX), PLSSIZ, PLTSTR(PLTMAX), PLTSIZ,
     2                PBSSTR(PBSMAX), PBSSIZ, PBTSTR(PBTMAX), PBTSIZ,
     3                PHATSP, PMAXPT, PPSSTR(PPSMAX), PPSSIZ,
     4                PPTSTR(PPTMAX), PPTSIZ, PSIMSP, PSIMTR
      LOGICAL         PLGSIM
      INTEGER         LENPLG
      PARAMETER   (LENPLG=PCSMAX+1+PCTMAX+1+PLSMAX+1+PLTMAX+1+
     1                    PBSMAX+1+PBTMAX+1+1+1+PPSMAX+1+PPTMAX+
     2                    1+1+1+1)
      COMMON /CAPDEV/ DGISTR, DGISIZ, DGESTR, DGESIZ, DTISTR,
     1                DTISIZ, DCDLLX, DCDLLY, DCDURX, DCDURY,
     3                DCOAVL, CORFMT, CORFIN, BATCH , DHCSIZ,
     4                DHCSTR, CORXOF, CORYOF, DASBIT, CORXSC,
     5                CORYSC, VDWLLX, VDWLLY, VDWURX, VDWURY
      INTEGER         DGIMAX, DGEMAX, DTIMAX, DCFTMX, DHCMAX
      PARAMETER   (DGIMAX=300, DGEMAX=150, DTIMAX=100)
      PARAMETER   (DCFTMX=30 , DHCMAX=50)
      INTEGER         DGISTR(DGIMAX), DGISIZ, DGESTR(DGEMAX),
     1                DGESIZ, DTISTR(DTIMAX), DTISIZ, DCDLLX,
     2                DCDLLY, DCDURX, DCDURY, CORFMT(DCFTMX,4),
     3                CORFIN(8)     , DHCSIZ, DHCSTR(DHCMAX),
     4                CORXOF, CORYOF, DASBIT, VDWLLX, VDWLLY,
     5                VDWURX, VDWURY
      REAL            CORXSC, CORYSC, CORRIN(8)
      LOGICAL         DCOAVL, BATCH
C  Size of the COMMON
      INTEGER         LENDEV
      PARAMETER   (LENDEV=DGIMAX+1+DGEMAX+1+DTIMAX+1+4+1+4*DCFTMX+
     1                  8+2+DHCMAX+9)
      EQUIVALENCE (CORFIN,CORRIN)
C
      INTEGER  IOS, STATUS, II
      CHARACTER*80 DFLNAM
C
C Modification for UNIX Version
C
      CHARACTER*80 ARG1, ARG2
C
C End of modification for UNIX Version
C
C Do calls forcing BLOCKDATAs to be loaded from a binary library.
C
      CALL CAPAST
      CALL CAPDAT
C
C  Initialize STATUS to ALLOK.
C
 110  CONTINUE
      STATUS = ALLOK
C
C  Get the file name of the ASCII input graphcap.
C
      DO 10 II = 1,80
  10  DFLNAM(II:II) = ' '
C Modification for UNIX Version

#ifdef	hpux
      CALL IGETARG(1, ARG1, 80)
#else
      CALL GETARG(1, ARG1)
#endif
      DO 15 II = 1,80
	DFLNAM(II:II) = ARG1(II:II)
   15 CONTINUE

C End of modification for UNIX Version
      UNIT = 1
C
C  Open the input graphcap for reading.
C
      CALL CHROPN(UNIT,DFLNAM,IOS,STATUS)
      IF (STATUS .NE. ALLOK ) THEN
C
C  Error opening the input file.
C
        WRITE(6,40)IOS
 40     FORMAT(' ERROR OPENING THE CHARACTER GRAPHCAP FILE, IOS='
     1          ,I7)
        STOP
      END IF
C
C  Parse the character graphcap file after initializing COMMON
C  variables.
C
      CALL GRINIT
      CALL CAPPAR(IOS,STATUS)
      IF (STATUS .NE. ALLOK .AND. STATUS .NE. EOFFL) THEN
C
C  Error reading the file.
C
        WRITE(6,50)STATUS,IOS
 50     FORMAT(' ERROR READING THE CHARACTER GRAPHCAP FILE',
     1          ', STATUS=',I7,' IOS=',I7)
        CALL CHRCLS(UNIT,IOS,STATUS)
        STOP
      END IF
C
C  Default the fill line spacing if it has not been defined.
C
      IF (DCDURY .EQ. DCDLLY) THEN
        WRITE(6,100)
  100   FORMAT(' Device coordinate space is null')
        STOP
      ENDIF
      IF (PSIMSP .EQ. 0) THEN
        ITMP   = INT(0.9*32767./REAL((IABS(DCDURY-DCDLLY))))
        PSIMSP = MAX0(1,ITMP)
      ENDIF
C
C  Close the input graphcap file.
C
      CALL CHRCLS(UNIT,IOS,STATUS)
C
C  Get the file name for the binary output file.
C
      DO 60 II = 1,80
 60   DFLNAM(II:II) = ' '
C Modification for UNIX Version

#ifdef	hpux
      CALL IGETARG(2, ARG2, 80)
#else
      CALL GETARG(2, ARG2)
#endif
      DO 65 II = 1,80
	DFLNAM(II:II) = ARG2(II:II)
   65 CONTINUE

C End of modification for UNIX Version
      UNIT = 1
C
C  Open the binary graphcap output file.
C
      CALL BINOPN(UNIT,DFLNAM,IOS,STATUS)
      IF (STATUS.NE.0) GO TO 1000
C
C  Write the output file.
C
      CALL BINPUT(IOS,STATUS)
      IF (STATUS .NE. 0) THEN
C
C  Error writing the file.
C
        WRITE(6,80)STATUS,IOS
 80     FORMAT(' ERROR WRITING THE BINARY GRAPHCAP FILE',
     1          ', STATUS=',I7,' IOS=',I7)
        CALL BINCLS(UNIT,IOS,STATUS)
        STOP
      END IF
C
C  Close the output file.
C
      CALL BINCLS(UNIT,IOS,STATUS)
C
C  More graphcaps?
C
C Modification for UNIX Version

C Removed prompt for more graphcaps

C End of modification for UNIX Version
C
      STOP
 1000 CONTINUE
      WRITE(6,1010)
 1010 FORMAT(' CANNOT OPEN THE BINARY OUTPUT FILE')
      END

#!/bin/csh -f
#
#	$Id: version.sed,v 1.27 2010-03-14 16:32:51 haley Exp $
#

set year = "2017"
set sitefile = `ncargpath NCARGDIR`/NCARGSITEFILE
if (-f $sitefile) then
  set sitenum = `head -1 $sitefile`
else
  set sitenum = "Site ID Number undefined for support."
endif  

if ($#argv > 0) then
  if ("$1" == "-v") echo VERSION
else

echo ""
cat <<EOF
NCAR Graphics Software Version VERSION
Copyright (C) 1987-$year, University Corporation for Atmospheric Research

NCAR Graphics is a registered trademark of the University Corporation
for Atmospheric Research.

The use of this Software is governed by a License Agreement.
EOF
echo ""
endif

/*
 *      $Id: TypeSupportOpTemplate.h.sed,v 1.1 1995-01-28 01:53:15 ethan Exp $
 */
/************************************************************************
*									*
*			     Copyright (C)  1995			*
*	     University Corporation for Atmospheric Research		*
*			     All Rights Reserved			*
*									*
************************************************************************/
/*
 *	File:		
 *
 *	Author:		Ethan Alpert
 *			National Center for Atmospheric Research
 *			PO 3000, Boulder, Colorado
 *
 *	Date:		Fri Jan 27 18:30:21 MST 1995
 *
 *	Description:	
 */
extern NhlErrorTypes _NclTFUNC(
#if	NhlNeedProto
NclTypeClass /* the_type */,
void * /* result */,
void* /* lhs */,
void* /* rhs */,
NclScalar* /* lhs_m */,
NclScalar* /* rhs_m */,
ng_size_t /* nlhs */,
ng_size_t /* nrhs */
#endif
);

NclTypeClass _NclTFUNC_type(
#if	NhlNeedProto
NclTypeClass /*the_type*/
#endif
);

#!/bin/csh -f
#
#	$Id: nhlcc.csh,v 1.6 2010-04-02 17:52:38 haley Exp $
#

#*********************************************#
#                                             #
# Make sure NCARG_ROOT is set for this script #
#                                             #
#*********************************************#
setenv NCARG_ROOT  `ncargpath root`

if ($status != 0) then
	exit 1
endif

set xlibs = "SED_XLIB"
set cairolib = "SED_CAIROLIBUSER"
set system   = "SED_SYSTEM_INCLUDE"
set cc       = "SED_CC"
set defines  = "SED_STDDEF SED_PROJDEF"
set loadflags  = "SED_LDCFLAGS"
set libdir   = `ncargpath SED_LIBDIR`
set incdir   = `ncargpath SED_INCDIR`
set syslibdir = "SED_LIBSEARCHUSER"
set sysincdir = "SED_INCSEARCHUSER"
set ro       = "$libdir/SED_NCARGDIR/SED_ROBJDIR"
set f77libs  = "SED_CTOFLIBSUSER"
set newargv = "$cc $defines $loadflags"
set libpath = "-L$libdir $syslibdir"
set incpath = "-I$incdir $sysincdir"

#
# set up default libraries
#
set libncarg    = "-lncarg"
set libgks      = "-lSED_LIBNCARG_GKS"
set libmath     = ""
set libncarg_c  = "-lncarg_c"
set libhlu      = "-lSED_LIBHLU"
set ncarbd      = "$ro/libncarbd.o"
set ngmathbd    = "$ro/libngmathbd.o"
set extra_libs

set robjs
unset NGMATH_LD
unset NGMATH_BLOCKD_LD

foreach arg ($argv)
  switch ($arg)

  case "-XmXt":
  case "-xmxt":
    set extra_libs = "$extra_libs SED_XMOTIFLIB SED_XTOOLLIB"
    breaksw

  case "-ngmath":
    set libmath     = "-lngmath"
    breaksw

  case "-ncarbd":
    set robjs = "$robjs $ncarbd"
    set NGMATH_BLOCKD_LD
    breaksw

  case "-ngmathbd":
    set robjs = "$robjs $ngmathbd"
# Make sure the ngmath blockdata routine doesn't get loaded twice.
    unset NGMATH_BLOCKD_LD
    breaksw

  case "-netcdf":
  case "-cdf":
    set extra_libs = "$extra_libs SED_NCDFLIBS"
    breaksw

  case "-hdf":
    set extra_libs = "$extra_libs SED_HDFLIB"
    breaksw

  default:
    set newargv = "$newargv $arg"
  endsw
end


#
# If -ncarbd was set, *and* the ngmath library was loaded,
# then automatically take care of loading libngmathbd.o.
#
if ($?NGMATH_LD && $?NGMATH_BLOCKD_LD) then
  set robjs = "$robjs $ngmathbd"
endif

set ncarg_libs = "$libhlu $libncarg $libgks $libncarg_c $libmath"
set newargv = "$newargv $libpath $incpath $extra_libs $robjs $ncarg_libs $xlibs $cairolib $f77libs"

echo $newargv
eval $newargv

/*
 *      $Id: NclType.h.sed,v 1.2 2008-12-10 20:12:17 dbrown Exp $
 */
/************************************************************************
*									*
*			     Copyright (C)  1995			*
*	     University Corporation for Atmospheric Research		*
*			     All Rights Reserved			*
*									*
************************************************************************/
/*
 *	File:		
 *
 *	Author:		Ethan Alpert
 *			National Center for Atmospheric Research
 *			PO 3000, Boulder, Colorado
 *
 *	Date:		Fri Jan 27 18:25:39 MST 1995
 *
 *	Description:	
 */
#ifndef NclTypeDATATYPE_h
#define NclTypeDATATYPE_h
#ifdef NIO_LIB_ONLY
#include "nioConvertP.h"
#else
#include <ncarg/hlu/ConvertP.h>
#endif
#include "defs.h"
#include "NclType.h"
#include "NclTypedouble.h"
#include <math.h>
#include "NclMultiDValData.h"
#include "DataSupport.h"


typedef struct _NclTypeDATATYPEClassPart {
	char * foo;
} NclTypeDATATYPEClassPart;

typedef struct _NclTypeDATATYPEPart {
	char * foo;
} NclTypeDATATYPEPart;

typedef struct _NclTypeDATATYPEClassRec {
	NclObjClassPart	obj_class;
	NclTypeClassPart type_class;
	NclTypeDATATYPEClassPart FIELDNAME_class;
}NclTypeDATATYPEClassRec;

typedef struct _NclTypeDATATYPERec {
	NclObjPart	obj;
	NclTypePart	type;
	NclTypeDATATYPEPart	FIELDNAME;
}NclTypeDATATYPERec;

typedef NclTypeDATATYPERec *NclTypeDATATYPE;
typedef NclTypeDATATYPEClassRec *NclTypeDATATYPEClass;

extern NclObjClass nclTypeDATATYPEClass;
extern NclTypeDATATYPEClassRec nclTypeDATATYPEClassRec;

NclType _NclTypeDATATYPECreate(
#if	NhlNeedProto
NclObj /* inst */, 
NclObjClass /* theclass */,
NclObjTypes /* obj_type */, 
unsigned int /* obj_type_mask */, 
NclStatus /* status*/
#endif
);

#endif /* NclTypeDATATYPE_h*/

# sh script to switch between versions of NCL
#
# To use: . /contrib/bin/origncl.sh
# To switch back to test version: . /contrib/bin/testncl.sh

ngroot=/contrib/ncl-5.1.1-beta

sub=s:$ngroot/bin\\:::g
newpath=`echo $PATH | sed -e $sub`
export PATH=$newpath

export NCARG_ROOT=/contrib

version=`ncl -V`
echo "You are now using the current version of NCL: $version"

unset ngroot
unset newpath

#!/usr/bin/ksh
#-----------------------------------------------------------------------
#-- KSH  - NCL Doc Example script:
#--
#-- convert GMT color tables to NCL color tables
#-- used by   gsn_define_colormap(wks,"NCL_GMT-BYR-03")
#--
#-- Example GMT color table file:   GMT-BYR-03.cpt
#--
#-- usage:  gmt2coltab.ksh GMT-BYR-03.cpt
#--         ---> creates new file NCL_GMT-BYR-03.rgb
#--
#-- KMF 03.05.13
#-----------------------------------------------------------------------
in=$1

gmt_coltab=${in##*/}
coltab=NCL_${gmt_coltab%.*}.rgb

#-- count number of colors plus foreground and background color.
#-- BUT, delete the last 3 color entries from the GMT color table
#-- they're not needed --> number of colors + 2 - 3  =  number of colors -1

ncols=$(cat ${in} | grep -v "\#" | wc -l)
ncols=$(expr ${ncols} - 1)

#-- insert background (1) and foreground (0) colors
#-- NCL starts with color index 2
cat << EOF > tmp_col.rgb
ncolors=${ncols}
# r   g   b
0 0 0
1 1 1
EOF

#-- read and write the color values
cat ${in} | grep -v "\#" | sed -e "s/'//g" | awk '{print $2" "$3" "$4}' >> tmp_col.rgb
head -n -3 tmp_col.rgb > ${coltab}

\rm -rf tmp_col.rgb

exit

/*
 *      $Id: TypeResetMissing.c.sed,v 1.3 2009-07-10 19:54:06 huangwei Exp $
 */
/************************************************************************
*									*
*			     Copyright (C)  1995			*
*	     University Corporation for Atmospheric Research		*
*			     All Rights Reserved			*
*									*
************************************************************************/
/*
 *	File:		
 *
 *	Author:		Ethan Alpert
 *			National Center for Atmospheric Research
 *			PO 3000, Boulder, Colorado
 *
 *	Date:		Fri Jan 27 18:29:04 MST 1995
 *
 *	Description:	
 */


static NhlErrorTypes Ncl_Type_DATATYPE_reset_mis
#if	NhlNeedProto
(void	*val,NclScalar * old_m,NclScalar * new_m, ng_size_t nval)
#else
(val,old_m,new_m,nval)
void *val;
NclScalar * old_m;
NclScalar * new_m;
ng_size_t nval;
#endif
{
	LOCALTYPE *value = (LOCALTYPE*)val;
	ng_size_t i;

	if((old_m == NULL)||(new_m == NULL))
		return(NhlFATAL);

	if (old_m->DATATYPEval == new_m->DATATYPEval) {
		/* nothing to do */
		return NhlNOERROR;	
	}

	for(i = 0; i < nval; i++,value++ ) {
		if(*value == old_m->DATATYPEval) {
			*value = new_m->DATATYPEval;
		}	
	}
	return(NhlNOERROR);
}

C
C	$Id: trndat.f.sed,v 1.3 2008-07-27 00:59:05 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      SUBROUTINE TRNDAT
C
C Calling this do-nothing subroutine forces "ld" to load the following
C block data routine (but only if they are in the same ".f" file).
C
        RETURN
C
      END
CNOSPLIT
      BLOCKDATA TRNDATX
C
C  DEFINE ALL CONSTANT DATA FOR THE METAFILE TRANSLATOR
C
      COMMON/TREROR/ ALLOK, MFRCHK, MTOPER, METRDC, REDERR, TYPCHG
     1             ,INVTYP, MINVLD, TYPERR, FRMEND, ENCINT, IVDCDT
     2             ,GCOERR, GCRERR, GCCERR, FCOERR, FCRERR, FCCERR
     3             ,PLIDXG, PMIDXG, TXIDXG, PGIDXG, INVLMT, CELERR
     4             ,COIERR, COLNRM, UNKNOW, UNKOPC, ENDMTF, VNEROR
     5             ,BADRSZ, DEVOUT, NOVERS, BADFNT, PGMERR, FASERR
     6             ,HINERR, VDWERR, RDWERR, RIXLIM
      INTEGER        ALLOK, MFRCHK, MTOPER, METRDC, REDERR, TYPCHG
     1             ,INVTYP, MINVLD, TYPERR, FRMEND, ENCINT, IVDCDT
     2             ,GCOERR, GCRERR, GCCERR, FCOERR, FCRERR, FCCERR
     3             ,PLIDXG, PMIDXG, TXIDXG, PGIDXG, INVLMT, CELERR
     4             ,COIERR, COLNRM, UNKNOW, UNKOPC, ENDMTF, VNEROR
     5             ,BADRSZ, DEVOUT, NOVERS, BADFNT, PGMERR, FASERR
     6             ,HINERR, VDWERR, RDWERR, RIXLIM
      COMMON /PGKSCOM/ CLPDAT, CLPFLG, POLIDX, LINTYP, LINWTH, LINCOL,
     1                LINRGB, MARIDX, MARSIZ, MARCOL, MARRGB, TXTIDX,
     2                INTSTL, PATIDX, FILCOL, FILRGB, MARTYP, HORIZ ,
     3                VERT  , PATH  , CHIGHT, XU    , YU    , XB    ,
     4                YB    , TXTCOL, FINDEX, CEXPN , CSPACE, CURIDX,
     5                CURIMP, CURINT, COLMOD, FILIDX, TXTRGB, PROPN ,
     6                FIRSTX, FIRSTY, LASTX , LASTY , TRATIO, CBV   ,
     7                CUV   , CHP   , CVP   , CCSPAC, CHHORZ, CDV   ,
     8                PMRSIZ, CLPX  , CLPY  , CLPP  , DEFREP, DEFLEN,
     9                VDCECR, TRANVN, TXTPRE, HATIDX, FILRPT, ASFSRF,
     A                ASFSDF, MAPMOD, VERSOK, PCBFST, CPGLEN, CLPNUL,
     B                MTDLEN
      INTEGER         CMPMAX, ASFMAX
      PARAMETER      (CMPMAX=256    , ASFMAX=18)
      LOGICAL         CLPFLG, PROPN , CHHORZ, DEFREP, CLPNUL, MAPMOD,
     1                VERSOK, PCBFST
      REAL            LINWTH, MARSIZ, CEXPN , CSPACE, TRATIO, CBV(2),
     1                CUV(2), CDV(2), CCSPAC
      INTEGER         CLPDAT(4)     , POLIDX, LINTYP, LINCOL, LINRGB(3),
     1                MARIDX, MARCOL, MARRGB(3)     , TXTIDX, INTSTL,
     2                PATIDX, FILCOL, FILRGB(3)     , MARTYP, HORIZ ,
     3                VERT  , PATH  , XU    , YU    , XB    , YB    ,
     4                TXTCOL, FINDEX, CURIMP(CMPMAX), CURINT(CMPMAX*3),
     5                CHIGHT, COLMOD, FILIDX, TXTRGB(3)     , CURIDX,
     6                FIRSTX, FIRSTY, LASTX , LASTY , CHP   , CVP   ,
     7                PMRSIZ, CLPX  , CLPY  , CLPP  , DEFLEN, TRANVN,
     8                TXTPRE, HATIDX, FILRPT(2)     , VDCECR(4)     ,
     9                ASFSRF(ASFMAX), ASFSDF(ASFMAX), CPGLEN, MTDLEN
      COMMON /GKSCHR/ MTDESC
      CHARACTER*80    MTDESC
      COMMON/TRINOT/ IPTR, MBUFOT, MAXBYT, DEVUNT, METUNT,
     1          METIPT, ERRUNT, FNTUNT
      INTEGER MAXCNT
      PARAMETER (MAXCNT=200)
      INTEGER IPTR, MBUFOT(MAXCNT), MAXBYT, DEVUNT, METUNT, ERRUNT,
     1        FNTUNT
      LOGICAL METIPT
      COMMON /TRFRAM/ METALL, FRINIT, FRCNT
      LOGICAL METALL, FRINIT
      INTEGER  FRCNT
      COMMON/TRCHAR/ GRCAPN, FNCAPN
      CHARACTER*1 GRCAPN(80), FNCAPN(80)
      COMMON /PTRBUFR/ METBIT, MBUFER, MDTYPE, METREC, MRECLN,
     1                MCONTF, MOPRST, LNGFLG, MERGFL
      INTEGER MNWRDS, RECLOC, RECSIZ, DTLOC, DTSIZ, MBITST, MBUFOF,
     1        MINSBD, MERLOC, MERSIZ
#if defined(cray)
      PARAMETER (MNWRDS=180, RECLOC=0, RECSIZ=16, DTLOC=16, DTSIZ=4
#else
      PARAMETER (MNWRDS=360, RECLOC=0, RECSIZ=16, DTLOC=16, DTSIZ=4
#endif
     1          ,MBITST=32, MBUFOF=32, MINSBD=16, MERLOC=23, MERSIZ=1)
      INTEGER METBIT, MBUFER(MNWRDS), MDTYPE, METREC, MRECLN, MOPRST
      LOGICAL MCONTF, LNGFLG, MERGFL
      COMMON /TRTYPE/ METMIN, METEXT, METPRT, METHED, MIOPCL, MXOPCL,
     1                MIOPID, MXOPID, ASCDEC, ASCHEX, ASCOCT, BINARY,
     2                GAHNOR, GALEFT, GACENT, GARITE, GAVNOR, GATOP ,
     3                GACAP , GAHALF, GABASE, GABOTT, GRIGHT, GLEFT ,
     4                GUP   ,
     5                GDOWN , CINDEX, CDIRCT, PENUP , PENDN , FLAGVL,
     6                SEPRVL, ASCTEK, TYPRGB, TYPBGR,
     7                TYPHLS, TYPMON, SOLID , DASHED, INVSBL, SOLPAT,
     8                ASFIND, ASFBND, ASFLNT, ASFLNW, ASFLNC, ASFMRT,
     9                ASFMRS, ASFMRC, ASFFIS, ASFFHI, ASFFPI, ASFFCO,
     A                ASFFPT, ASFFPW, ASFFPC, ASFTFI, ASFTPR, ASFTCX,
     B                ASFTCS, ASFTCO, ASCFLT, PHOLLO, PSOLID, PPATTR,
     C                PHATCH, PEMPTY, HHORIZ, HVERTI, HPOSLP, HNESLP,
     D                HHOAVE, HPOANE
      INTEGER         METMIN, METEXT, METPRT, METHED, MIOPCL, MXOPCL,
     1                MIOPID, MXOPID, ASCDEC, ASCHEX, ASCOCT, BINARY,
     2                GAHNOR, GALEFT, GACENT, GARITE, GAVNOR, GATOP ,
     3                GACAP , GAHALF, GABASE, GABOTT, GRIGHT, GLEFT ,
     4                GUP   ,
     5                GDOWN , CINDEX, CDIRCT, PENUP , PENDN , FLAGVL,
     6                SEPRVL, ASCTEK, TYPRGB, TYPBGR,
     7                TYPHLS, TYPMON, SOLID , DASHED, INVSBL, SOLPAT,
     8                ASFIND, ASFBND, ASFLNT, ASFLNW, ASFLNC, ASFMRT,
     9                ASFMRS, ASFMRC, ASFFIS, ASFFHI, ASFFPI, ASFFCO,
     A                ASFFPT, ASFFPW, ASFFPC, ASFTFI, ASFTPR, ASFTCX,
     B                ASFTCS, ASFTCO, ASCFLT, PHOLLO, PSOLID, PPATTR,
     C                PHATCH, PEMPTY, HHORIZ, HVERTI, HPOSLP, HNESLP,
     D                HHOAVE, HPOANE
      COMMON /PTRPARS/  MOPLEN, MCICPR, MCDCPR, MFLCPR, MIXCPR, MWHCPR,
     1                 MOPDLN, MCIDPR, MCDDPR, MFLDPR, MIXDPR, MWHDPR,
     2                 BYTSIZ, CONFLG, MENDPR, MENCPR
      INTEGER MOPCLL, MOPIDL, MSCLEN, MLGFLG, MCOLEN, MLOLEN
      PARAMETER (MOPCLL=4, MOPIDL=7, MCOLEN=1, MSCLEN=5, MLOLEN=15,
     1           MLGFLG=31)
       INTEGER         MOPLEN, MCICPR, MCDCPR, MFLCPR, MIXCPR, MWHCPR,
     1                 MOPDLN, MCIDPR, MCDDPR, MFLDPR, MIXDPR, MWHDPR,
     2                 BYTSIZ, CONFLG, MENDPR, MENCPR
      COMMON /TRINST/ OPCL, OPID, LEN, CONT
      INTEGER OPCL, OPID, LEN
      LOGICAL CONT
      COMMON /TRBNDL/ PMRTYP
      INTEGER PTSIZE
      PARAMETER (PTSIZE=6)
      INTEGER PMRTYP(PTSIZE)
      COMMON /TRMTYP/ FOURBT, MULTBT, TWOBT, PTSFLG, CURCOL, IPWRIT,
     1                IFRAME, ISETOP, IRANG, IPTS, ICAS, IINT, IORNT,
     2                ISIZE, IFONT, IPAT, ISSIZ, ICENT, ICOLR,
     3                MCENT, MSIZE, MOR, OLDX, OLDY, MCASE, MINTEN,
     4                MFONT, MDASH, MSPOT, MCOLOR, MLIMIT, PTSYM,
     5                SAVX, SAVY
      INTEGER FOURBT, MULTBT, TWOBT, PTSFLG, CURCOL, IPWRIT,
     1                IFRAME, ISETOP, IRANG, IPTS, ICAS, IINT, IORNT,
     2                ISIZE, IFONT, IPAT, ISSIZ, ICENT, ICOLR,
     3                MCENT, MSIZE, MOR, OLDX, OLDY, MCASE, MINTEN,
     4                MFONT, MDASH, MSPOT, MCOLOR(3), MLIMIT(4), PTSYM,
     5                SAVX, SAVY
      COMMON /TRDASH/ PATFLG, DASPAT, PATBIT, DEFPAT, DASHX, DASHY,
     1                PATVDC
      INTEGER DPATSZ, PATSIZ, DFPTSZ
      PARAMETER (DPATSZ=16, PATSIZ=320, DFPTSZ=4)
      INTEGER PATFLG, DASPAT, PATBIT, DEFPAT(DFPTSZ), DASHX,
     1        DASHY, PATVDC
      COMMON /TRBFRS/ PLBUFR, PLBFPT, PLPRVX, PLPRVY
      INTEGER PLBFMX
      PARAMETER (PLBFMX=500)
      INTEGER PLBUFR(PLBFMX*2), PLBFPT, PLPRVX, PLPRVY
      COMMON /TPGSPC/ PGVTXS,  PGSPCR, PGSPCI
      INTEGER MAXPTS
      PARAMETER (MAXPTS=12000)
      REAL    PGVTXS(MAXPTS*2), PGSPCR(MAXPTS*2)
      INTEGER PGSPCI(MAXPTS*3)
      COMMON /TMPSPC/ TEMPSP
      INTEGER MAXTMP
      PARAMETER (MAXTMP=300)
      INTEGER TEMPSP(MAXTMP)
      COMMON/TRNMAR/MARSCL, MARX, MARY, MARP, MARPR
      INTEGER MARXYS, MARNUM
      PARAMETER (MARXYS=32, MARNUM=6)
      INTEGER MARX(MARXYS), MARY(MARXYS), MARP(MARXYS), MARPR(MARNUM+1)
      REAL MARSCL
C
C  COMMON TRCODE NOTES
C
C  ALL ELEMENT CODES BELONGING TO THE SAME ID MUST BE CONTIGUOUS
C  STORAGE
C
C  WHEN ADDING TO AN EXISTING ELEMENT CLASS INSERT AT THE END OF
C  THE ELEMENT CODE LIST FOR THE CLASS, CHANGE THE COUNT ON THE
C  ELEMENT CODE COUNT, AND ADD TO TRNDATX BLOCKDATA FOR DEFINITION
C
C  WHEN CREATING A NEW ELEMENT CODE YOU NEED TO:
C       1.  CREATE AN ELEMENT CODE VARIABLE
C       2.  CREATE THE LIST OF ELEMENT CODES
C       3.  CREATE AN ELEMENT CLASS PARAMETER VARIABLE WITH THE COUNT
C           OF ELEMENT CODES
C       4.  EQUIVALENCE A POINTER TO THE BEGINNING OF THE ELEMENT CLASS LIST
C       5.  GENERATE CODE IN SUBROUTINE MELCMP SIMILAR TO THAT WHICH EXISTS
C           FOR THE OTHER ELEMENT CODES
C       6.  ADD TO TRNDATX BLOCKDATA FOR DEFINITION
C
C       LIST OF VALID ELEMENT CODES AND CLASS VARIABLES
C
C       ECDELM - DELIMITER ELEMENTS
C               CLASS CODES DELMxx, FIRST DELMBM
C       ECMDES - METAFILE DESCRIPTOR ELEMENTS
C               CLASS CODES MDESxx, FIRST MDESMV
C       ECPDEL - PICTURE DESCRIPTOR ELEMENTS
C               CLASS CODES PDELxx  FIRST PDELCS
C       ECCELM - CONTROL ELEMENTS
C               CLASS CODES CELMxx  FIRST CELMVI
C       ECGPEL - GRAPHICAL PRIMITIVE ELEMENTS
C               CLASS CODES GPELxx  FIRST GPELPL
C       ECATEL - ATTRIBUTE ELEMENTS
C               CLASS CODES ATELxx  FIRST ATELLI
C
      COMMON /PTRCODE/ ECDELM, ECMDES, ECCELM, ECPDEL, ECGPEL,
     A                ECATEL, ECESEL, ECEXEL,
     O                DELMNO, DELMBM, DELMEM, DELMBP, DELMEP, DELMBB,
     1                MDESMV, MDESMD, MDESEL, MDESDR, MDESFL,
     2                PDELCS, PDELVE, PDELBC,
     3                CELMVI, CELMCR, CELMCI,
     4                GPELPL, GPELPM, GPELTX, GPELPG, GPELCA, GPELGP,
     5                ATELLI, ATELLT, ATELLW, ATELLC, ATELMB, ATELMT,
     5                ATELMZ, ATELMC, ATELTI, ATELTF, ATELTP, ATELCE,
     5                ATELCS, ATELTC, ATELCH, ATELCO, ATELTH, ATELTA,
     5                ATELFI, ATELIS, ATELHI, ATELPI, ATELFC, ATELFR,
     5                ATELPT, ATELPS, ATELCB, ATELAS
C
C  LIST OF ELEMENT CLASS COUNTS
C
      INTEGER DELMCT, MDESCT, PDELCT, CELMCT, GPELCT, ATELCT
      PARAMETER (DELMCT=6, MDESCT=5, PDELCT=3, CELMCT=3, GPELCT=6,
     1           ATELCT=28)
C
C  DEFINE THE TYPES OF THE COMMON DATA
C
      INTEGER ECDELM, ECMDES, ECCELM, ECPDEL, ECGPEL, ECATEL, ECESEL,
     A        ECEXEL,
     O        DELMNO, DELMBM, DELMEM, DELMBP, DELMEP, DELMBB,
     1        MDESMV, MDESMD, MDESEL, MDESDR, MDESFL,
     2        PDELCS, PDELVE, PDELBC,
     3        CELMVI, CELMCR, CELMCI,
     4        GPELPL, GPELPM, GPELTX, GPELPG, GPELCA, GPELGP,
     5        ATELLI, ATELLT, ATELLW, ATELLC, ATELMB, ATELMT, ATELMZ,
     5        ATELMC, ATELTI, ATELTF, ATELTP, ATELCE, ATELCS, ATELTC,
     5        ATELCH, ATELCO, ATELTH, ATELTA, ATELFI, ATELIS, ATELHI,
     5        ATELPI, ATELFC, ATELFR, ATELPT, ATELPS, ATELCB, ATELAS
C
C  DEFINE THE CLASS CODE LIST POINTERS
C
      INTEGER DELMST(DELMCT), MDESST(MDESCT), PDELST(PDELCT),
     1        CELMST(CELMCT), GPELST(GPELCT), ATELST(ATELCT)
      EQUIVALENCE (DELMST(1), DELMNO), (MDESST(1), MDESMV),
     1            (PDELST(1), PDELCS), (CELMST(1), CELMVI),
     2            (GPELST(1), GPELPL), (ATELST(1), ATELLI)
      COMMON /TRCNTL/ INPICT, INMETA, RECINT
      LOGICAL INPICT, INMETA
      INTEGER RECINT
      COMMON /PTRDEFL/ POLIDF, LINTDF, LINWDF, TLNCDF, MARIDF, MARTDF,
     1                MARSDF, TMRCDF, PMRSDF, HORIDF, VERTDF, PATHDF,
     2                CHIGDF, XUDF, YUDF, XBDF, YBDF, TXTIDF, TTXCDF,
     3                FINDDF, CEXPDF, CSPADF, FILIDF, INTSDF, PATIDF,
     4                TFLCDF, CLPDDF, VDCEDF, CLPFDF, HATIDF, FILRDF,
     5                TXTPDF
      LOGICAL CLPFDF
      REAL LINWDF, MARSDF, CEXPDF, CSPADF
      INTEGER VDCEDF(4), CLPDDF(4), POLIDF, LINTDF, TLNCDF, MARIDF,
     1        MARTDF, TMRCDF, PMRSDF, HORIDF, VERTDF, PATHDF, CHIGDF,
     2        XUDF, YUDF, XBDF, YBDF, TXTIDF, TTXCDF, FINDDF, FILIDF,
     3        INTSDF, PATIDF, TFLCDF, HATIDF, FILRDF(2), TXTPDF
      COMMON /CAPSPC/ DUMSPC,ENDDSP
      INTEGER     DUMSIZ,DUMSM1
      PARAMETER (DUMSIZ=327, DUMSM1=DUMSIZ-1)
      INTEGER     DUMSPC(DUMSM1),ENDDSP
      COMMON /CAPDEV/ DGISTR, DGISIZ, DGESTR, DGESIZ, DTISTR,
     1                DTISIZ, DCDLLX, DCDLLY, DCDURX, DCDURY,
     3                DCOAVL, CORFMT, CORFIN, BATCH , DHCSIZ,
     4                DHCSTR, CORXOF, CORYOF, DASBIT, CORXSC,
     5                CORYSC, VDWLLX, VDWLLY, VDWURX, VDWURY
      INTEGER         DGIMAX, DGEMAX, DTIMAX, DCFTMX, DHCMAX
      PARAMETER   (DGIMAX=300, DGEMAX=150, DTIMAX=100)
      PARAMETER   (DCFTMX=30 , DHCMAX=50)
      INTEGER         DGISTR(DGIMAX), DGISIZ, DGESTR(DGEMAX),
     1                DGESIZ, DTISTR(DTIMAX), DTISIZ, DCDLLX,
     2                DCDLLY, DCDURX, DCDURY, CORFMT(DCFTMX,4),
     3                CORFIN(8)     , DHCSIZ, DHCSTR(DHCMAX),
     4                CORXOF, CORYOF, DASBIT, VDWLLX, VDWLLY,
     5                VDWURX, VDWURY
      REAL            CORXSC, CORYSC, CORRIN(8)
      LOGICAL         DCOAVL, BATCH
C  Size of the COMMON
      INTEGER         LENDEV
      PARAMETER   (LENDEV=DGIMAX+1+DGEMAX+1+DTIMAX+1+4+1+4*DCFTMX+
     1                  8+2+DHCMAX+9)
      EQUIVALENCE (CORFIN,CORRIN)
      COMMON /CAPFNT/ CHRSTR, CHREND, CHRWDT, CHRSCH, FNTRHT,
     1                FNTTOP, FNTCAP, FNTHLF, FNTBAS, FNTBOT,
     2                FNTTYP, FNTSCH, CORXST, CORXLN, CORYST,
     3                CORYLN, CORPST, CORPLN, PBEGST, PBEGLN,
     4                PENDST, PENDLN, CORSCH, NEWCLS, CPNTRS,
     5                CPNLST, CSTRKS
      INTEGER         CHRSM1, CHRSM2
      PARAMETER       (CHRSM1=128, CHRSM2=5121)
      INTEGER         CHRSTR, CHREND, CHRWDT,
     1                CHRSCH(11)    , FNTRHT, FNTTOP,
     2                FNTCAP, FNTHLF, FNTBAS, FNTBOT, FNTTYP,
     3                FNTSCH(9)     , CORXST, CORXLN,
     4                CORYST, CORYLN, CORPST, CORPLN,
     5                PBEGST, PBEGLN, PENDST, PENDLN,
     6                CORSCH(10)    ,
     7                NEWCLS(300)   ,
     8                CPNTRS(CHRSM1), CPNLST        ,
     9                CSTRKS(CHRSM2)
C
C  XLCN   --  Bit offset to extract X coordinates from fontcap.
C  YLCN   --  Bit offset to extract Y coordinates from fontcap.
C  PLCN   --  Bit offset to extract PEN control bit from fontcap.
C  FNTMAX --  Number of fonts obtained from FONT LIST (defaults to 1).
C  FNTS   --  An array of pointers associating indices obtained from
C             FONT INDEX elements with the internally supported fonts.
C             Consult the documentation in BLOCKDATA TRNDATX for a
C             list of supported fonts.
C  FLEFT  --  An array of character left values for proportionally
C             spaced fonts.
C  FRIGHT --  An array of character right values for proportionally
C             spaced fonts.
C  MXFLST --  The maximum number of strings accepted in a FONT LIST
C             element.
C  NSFNTS --  The number of distinct fonts supported internally.
C
      PARAMETER (NSFNTS=20,MXFLST=300)
      COMMON /FNTCOM/ XLCN  , YLCN  , PLCN  , FNTMAX,
     1                FNTS  , FLEFT , FRIGHT, SFLENS
      INTEGER         FLEFT(CHRSM1) , FRIGHT(CHRSM1), FNTS(MXFLST)  ,
     1                XLCN, YLCN    , PLCN  , FNTMAX
      CHARACTER*30 SFONTS(NSFNTS)
      COMMON /SUPFNT/ SFONTS
C
C  Size of common CAPFNT in words.
C
      INTEGER WRLEN
      PARAMETER (WRLEN=5600)
      COMMON /CINFO/COLVLS,INTS,NUMI
      DIMENSION COLVLS(3,256),INTS(256)
C
C  INITIALIZE COLOR MAP DATA.
C
      DATA NUMI/1/
      DATA COLVLS(1,1),COLVLS(2,1),COLVLS(3,1)/ 0.8, 0.8, 0.8/
      DATA (COLVLS(1,II),II=2,256)/255*-1.0/
      DATA (COLVLS(2,II),II=2,256)/255*-1.0/
      DATA (COLVLS(3,II),II=2,256)/255*-1.0/
C
C  INITIALIZE BUFFER POINTER
C
      DATA IPTR /0/
C
C  DEFINE THE TRANSLATOR VERSION FOR COMPARISON WITH THE METAFILE VERSION
C
      DATA TRANVN, VERSOK /-32767, .FALSE./
C
C  DEFINE THE ERROR FLAGS
C
      DATA  ALLOK, MFRCHK, MTOPER, METRDC, REDERR / 0,  1,  2,  3,  4/
      DATA TYPCHG, INVTYP, MINVLD, TYPERR, FRMEND / 5,  6,  7,  8,  9/
      DATA ENCINT, IVDCDT                         /10, 11            /
      DATA GCOERR, GCRERR, GCCERR, FCOERR, FCRERR /12, 13, 14, 15, 16/
      DATA FCCERR, PLIDXG, PMIDXG, TXIDXG, PGIDXG /17, 18, 19, 20, 21/
      DATA INVLMT, CELERR, COIERR, COLNRM, UNKNOW /22, 23, 24, 25, 26/
      DATA UNKOPC, ENDMTF, VNEROR, BADRSZ, DEVOUT /27, 28, 29, 30, 31/
      DATA NOVERS, BADFNT, PGMERR, FASERR, HINERR /32, 33, 34, 35, 36/
      DATA VDWERR, RDWERR, RIXLIM                 /37, 38, 39        /
C
C  SET THE STATE OF POLYLINE START AND END VDC
C
      DATA FIRSTX, FIRSTY, LASTX, LASTY /0, 0, 0, 0/
C
C  DEFINE THE I/O GLOBAL DATA
C
      DATA DEVUNT, METUNT, ERRUNT, FNTUNT /1, 3, 2, 4/
C
C   PORTABLE FLAG  TRUE NO COMMAND LINE AVAILABLE
C
      DATA METIPT /.FALSE./
C
C  DEFINE THE FRAME INFORMATION
C
      DATA METALL, FRINIT, FRCNT /.TRUE., .TRUE., 0/
C
C  DEFINE THE GRAPHCAP AND FONTCAP NAMES
C
      DATA (GRCAPN(II),II=1,9) /'G','R','A','P','H','C','A','P',' '/
      DATA (FNCAPN(II),II=1,6) /'F','O','N','T','0',' '/
C
C  INITIALIZE THE RECORD POINTER
C
      DATA METREC /1/
C
C  DEFINE THE TRANSLATOR TYPE FLAGS
C
      DATA METMIN, METEXT, METPRT, METHED /2, 3, 8, 4/
      DATA MIOPCL, MXOPCL, MIOPID, MXOPID /0, 7, 0, 127/
      DATA BINARY, ASCDEC, ASCHEX, ASCOCT, ASCTEK /0, 1, 2, 3, 4/
      DATA ASCFLT /5/
      DATA GAHNOR, GALEFT, GACENT, GARITE /0, 1, 2, 3/
      DATA GAVNOR, GATOP, GACAP, GAHALF, GABASE, GABOTT
     1     /0, 1, 2, 3, 4, 5/
      DATA GRIGHT, GLEFT, GUP, GDOWN /0, 1, 2, 3/
      DATA SEPRVL, FLAGVL /-1, 0/
      DATA PENUP, PENDN /0, 1/
      DATA CINDEX, CDIRCT /0, 1/
      DATA TYPMON, TYPRGB, TYPBGR, TYPHLS /0, 1, 2, 3/
      DATA INVSBL, SOLID, DASHED, SOLPAT /0, 1, 2, 65535/
      DATA PHOLLO, PSOLID, PPATTR, PHATCH, PEMPTY /0, 1, 2, 3, 4/
      DATA HHORIZ, HVERTI, HPOSLP, HNESLP         /1, 2, 3, 4   /
      DATA HHOAVE, HPOANE                         /5, 6         /
      DATA ASFIND, ASFBND /0,1/
      DATA ASFLNT, ASFLNW, ASFLNC, ASFMRT, ASFMRS /0, 1, 2, 3, 4/
      DATA ASFMRC, ASFFIS, ASFFHI, ASFFPI, ASFFCO /5, 6, 7, 8, 9/
      DATA ASFFPT, ASFFPW, ASFFPC, ASFTFI, ASFTPR /10,11,12,13,14/
      DATA ASFTCX, ASFTCS, ASFTCO /15,16,17/
C
C  SET THE DEFAULTS REPLACMENT FLAG TO NO REPLACMENT AND LENGTH TO 0
C
      DATA DEFLEN /0/
      DATA DEFREP /.FALSE./
C
C  DEFINE THE DEFAULT VDC EXTENT
C
      DATA VDCEDF /0,0,32767,32767/
C
C  SET THE DEFAULT CLIPPING TO OFF AND DEFAULT CLIP RECTANGLE.
C  SET FLAG TO INDICATE A NULL CLIPPING RECTANGLE.
C
      DATA CLPFDF /.TRUE./
      DATA CLPDDF /0,0,32767,32767/
      DATA CLPNUL /.FALSE./
C
C  DEFAULT POLYLINE INFO
C
      DATA POLIDF, LINTDF, LINWDF, TLNCDF /1, 1, 1.0, 1/
C
C  DEFAULT MARKER INFO
C
      DATA MARIDF, MARTDF, MARSDF, TMRCDF, PMRSDF /1, 3, 1.0, 1, 320/
C
C  DEFAULT TEXT AND CHARACTER INFO
C
      DATA HORIDF, VERTDF, PATHDF, CHIGDF, XUDF, YUDF /0,0,0,320,0,1/
      DATA XBDF, YBDF, TXTIDF, TTXCDF, FINDDF, CEXPDF /1,0,1,1,1,1.0/
      DATA CSPADF, TXTPDF /0.0, 0/
C
C  DEFAULT FILL INFO
C
      DATA FILIDF, INTSDF, HATIDF, PATIDF, TFLCDF /1, 0, 1, 1, 1/
      DATA FILRDF /0,0/
C
C  DEFINE THE METACODE DATA FIELD DEFAULT BIT SIZES
C
      DATA MOPDLN, MCIDPR, MCDDPR, MFLDPR, MWHDPR /16, 8, 8, 16, 16/
      DATA MIXDPR, MENDPR /16,16/
      DATA BYTSIZ, CONFLG /8, 1/
C
C  SET THE CONTINUE INSTRUCTION PACKET TO FALSE
C
      DATA MCONTF /.FALSE./
C
C  SET THE COLOR SPECIFICATION MODE TO INDEXED
C
      DATA COLMOD /0/
C
C  SET THE POLYLINE OPEN STATE TO CLOSED
C
      DATA PROPN /.FALSE./
C
C  DEFINE THE DEFAULT MARKER CHARACTERS
C
      DATA (PMRTYP(II),II=1,5) /1, 2, 3, 4, 5/
C
C  DEFINE THE DEFAULT ASPECT SOURCE FLAGS
C
      DATA ASFSDF /ASFMAX*0/
C
C   DEFINE MINIMAL METACODE DATA
C
      DATA FOURBT, MULTBT, TWOBT /0, 1, 0/
      DATA IPWRIT, IFRAME, ISETOP, IRANG, IPTS /33, 34, 35, 39, 40/
      DATA ICAS, IINT, IORNT, ISIZE, IFONT, IPAT, ISSIZ, ICENT, ICOLR
     1     /1, 2, 3, 4, 5, 6, 7, 8, 9/
C
C  SET THE DEFAULT DASH PATTERNS
C  1 SOLID, 2 DASHED, 3 DOTTED, 4 DASH-DOTTED
C    HEX solid, fofo, aaaa, f838
      DATA DEFPAT / 1, 61680, 43690, 64824/
C
C  SET THE POLYLINE BUFFERS TO EMPTY, POLYGON LENGTH TO 0.
C
      DATA PLBFPT, CPGLEN /0,0/
C
C  Define the markers.  The MARX and MARY arrays define the stroke
C  coordinates for the markers.  The MARP array defines the PEN UP/DOWN
C  flag for the coordinate strokes.  The MARPR array defines where in
C  the MARK and MARY arrays the various markers start.  The final entry
C  in MARPR should be the dimension of MARX plus 1.
C
      DATA MARX /
     1           1, -1, -1, 1, 1,
     2           0, 0, -20, 20,
     3           0, 0, 17, -17, 17, -17,
     4           0, 12, 19, 19, 12, 0, -12, -19, -19, -12, 0,
     5           14, -14, -14, 14,
     6           0, 0
     Z          /
      DATA MARY /
     1           1,  1, -1,-1, 1,
     2           20, -20, 0, 0,
     3           20, -20, 10, -10, -10, 10,
     4           20, 16, 6, -6, -16, -20, -16, -6, 6, 16, 20,
     5           14, -14, 14, -14,
     6           0, 0
     Z          /
      DATA MARP /
     1           0, 1, 1, 1, 1,
     2           0, 1, 0, 1,
     3           0, 1, 0, 1, 0, 1,
     4           0, 10*1,
     5           0, 1, 0, 1,
     6           0, 1
     Z          /
      DATA MARPR /
     1          1,
     2          6,
     3          10,
     4          16,
     5          27,
     6          31,
     7          33
     Z          /
C
C  SET THE MARKERS MAPPING SCALE FACTOR (GET MARKER SCALE 1.0 TO BE THE RIGHT
C   SIZE)
C
      DATA MARSCL /6.4/
C
C  DEFINE THE ELEMENT CLASS CODES
C
      DATA ECDELM, ECMDES, ECPDEL, ECCELM, ECGPEL, ECATEL, ECESEL,
     1     ECEXEL /
     2          0, 1, 2, 3, 4, 5, 6, 7/
C
C       DELIMITER ELEMENT CODES
C
        DATA DELMNO, DELMBM, DELMEM, DELMBP, DELMBB, DELMEP
     1          / 0, 1, 2, 3, 4, 5/
C
C       DESCRIPTOR ELEMENT CODES
C
        DATA MDESMV, MDESMD, MDESEL, MDESDR, MDESFL /1, 2, 11, 12, 13/
C
C       PICTURE DESCRIPTOR ELEMENT CODES
C
        DATA PDELCS, PDELVE, PDELBC /2, 6, 7/
C
C       CONTROL ELEMENT CODES
C
        DATA CELMVI, CELMCR, CELMCI /1,5,6/
C
C       GRAPHICAL PRIMITIVE ELEMENT CODES
C
        DATA GPELPL, GPELPM, GPELTX, GPELPG, GPELCA, GPELGP
     1          /1, 3, 4, 7, 9, 10/
C
C       DEFINE THE ATTRIBUTE ELEMENT CODES
C
        DATA ATELLI, ATELLT, ATELLW, ATELLC /1, 2, 3, 4/
        DATA ATELMB, ATELMT, ATELMZ, ATELMC /5, 6, 7, 8/
        DATA ATELTI, ATELTF, ATELTP, ATELCE, ATELCS /9, 10, 11, 12, 13/
        DATA ATELTC, ATELCH, ATELCO, ATELTH, ATELTA /14,15,16,17,18/
        DATA ATELFI, ATELIS, ATELFC, ATELHI, ATELPI /21,22,23,24,25/
        DATA ATELFR, ATELPT, ATELPS, ATELCB, ATELAS /31,32,33,34,35/
C
C  SET THE BEGIN METAFILE TO FALSE, AND IN PICTURE TO FALSE
C
      DATA INMETA, INPICT /.FALSE. , .FALSE./
C
C  SET NOT IN POLY FUNCTION
C
      DATA PCBFST /.TRUE./
C
C  PRE-CGM DATA
C
      DATA MCENT,MSIZE,MOR,MCASE,MINTEN,MFONT/ 0, 128, 0, 0, 204, 1/
      DATA DASBIT/ 100/
C
C  VIRTUAL DEVICE WINDOW
C
      DATA VDWLLX,VDWLLY,VDWURX,VDWURY/0,0,32767,32767/
C
C  INITIALIZE POINTERS INTO THE FONT LIST.
C
      DATA FNTS/MXFLST*1/
C
C  MAXIMUM NUMBER OF FONTS (THIS IS RESET FROM PARSING THE FONT LIST
C  ELEMENT IF ONE IS IN THE METAFILE DESCRIPTOR).
C
      DATA FNTMAX/1/
C
C  SUPPORTED FONT NAMES
C
      DATA SFONTS( 1)/'DEFAULT                       '/
      DATA SFONTS( 2)/'HERSHEY:CARTOGRAPHIC_ROMAN    '/
      DATA SFONTS( 3)/'HERSHEY:CARTOGRAPHIC_GREEK    '/
      DATA SFONTS( 4)/'HERSHEY:SIMPLEX_ROMAN         '/
      DATA SFONTS( 5)/'HERSHEY:SIMPLEX_GREEK         '/
      DATA SFONTS( 6)/'HERSHEY:SIMPLEX_SCRIPT        '/
      DATA SFONTS( 7)/'HERSHEY:COMPLEX_ROMAN         '/
      DATA SFONTS( 8)/'HERSHEY:COMPLEX_GREEK         '/
      DATA SFONTS( 9)/'HERSHEY:COMPLEX_SCRIPT        '/
      DATA SFONTS(10)/'HERSHEY:COMPLEX_ITALIC        '/
      DATA SFONTS(11)/'HERSHEY:COMPLEX_CYRILLIC      '/
      DATA SFONTS(12)/'HERSHEY:DUPLEX_ROMAN          '/
      DATA SFONTS(13)/'HERSHEY:TRIPLEX_ROMAN         '/
      DATA SFONTS(14)/'HERSHEY:TRIPLEX_ITALIC        '/
      DATA SFONTS(15)/'HERSHEY:GOTHIC_GERMAN         '/
      DATA SFONTS(16)/'HERSHEY:GOTHIC_ENGLISH        '/
      DATA SFONTS(17)/'HERSHEY:GOTHIC_ITALIAN        '/
      DATA SFONTS(18)/'HERSHEY:MATH_SYMBOLS          '/
      DATA SFONTS(19)/'HERSHEY:SYMBOL_SET1           '/
      DATA SFONTS(20)/'HERSHEY:SYMBOL_SET2           '/
C
      END

/*
 *      $Id: TypeSupportMatTemplate.h.sed,v 1.1.4.1 2008-03-28 20:37:53 grubin Exp $
 */
/************************************************************************
*									*
*			     Copyright (C)  1995			*
*	     University Corporation for Atmospheric Research		*
*			     All Rights Reserved			*
*									*
************************************************************************/
/*
 *	File:		
 *
 *	Author:		Ethan Alpert
 *			National Center for Atmospheric Research
 *			PO 3000, Boulder, Colorado
 *
 *	Date:		Fri Jan 27 18:30:21 MST 1995
 *
 *	Description:	
 */
extern NhlErrorTypes _NclTFUNC(
#if	NhlNeedProto
NclTypeClass /* the_type */,
void * /* result */,
void* /* lhs */,
void* /* rhs */,
NclScalar* /* lhs_m */,
NclScalar* /* rhs_m */,
int       /* nlhs_dims */,
ng_size_t* /* lhs_dimsizes */,
int       /* nrhs_dims */,
ng_size_t* /* rhs_dimsizes */
#endif
);

NclTypeClass _NclTFUNC_type(
#if	NhlNeedProto
NclTypeClass /*the_type*/
#endif
);

#!/bin/sh
#
#      $Id: syms_tab_h.sh,v 1.1 1994-07-21 23:16:38 boote Exp $
#
#########################################################################
#									#
#			   Copyright (C)  1994				#
#	     University Corporation for Atmospheric Research		#
#			   All Rights Reserved				#
#									#
#########################################################################
#
#	File:		syms_tab_h.sh
#
#	Author:		Jeff W. Boote
#			National Center for Atmospheric Research
#			PO 3000, Boulder, Colorado
#
#	Date:		Mon Jul 18 11:37:49 MDT 1994
#
#	Description:	This file creates parser.h from y.tab.h, changing
#			symbols to minimize conflicts with other libs.
#
#	Usage:
#
#	Environment:
#
#	Files:
#
#
#	Options:

sed \
-e "s/yylval/ncllval/g" \
y.tab.h > parser.h

exit 0

/*
 *      $Id$
 */
/************************************************************************
*									*
*			     Copyright (C)  1995			*
*	     University Corporation for Atmospheric Research		*
*			     All Rights Reserved			*
*									*
************************************************************************/
/*
 *	File:		
 *
 *	Author:		Ethan Alpert
 *			National Center for Atmospheric Research
 *			PO 3000, Boulder, Colorado
 *
 *	Date:		Fri Jan 27 18:29:35 MST 1995
 *
 *	Description:	
 */
NhlErrorTypes Ncl_Type_DATATYPE_FUNCNAME
#if	NhlNeedProto
(void *result,void *lhs, void* rhs, NclScalar* lhs_m, NclScalar* rhs_m, ng_size_t nlhs, ng_size_t nrhs)
#else
(result,lhs,rhs,lhs_m,rhs_m,nlhs,nrhs)
void *result;
void *lhs;
void* rhs;
NclScalar* lhs_m;
NclScalar* rhs_m;
ng_size_t nlhs;
ng_size_t nrhs;
#endif
{
        LOCALTYPE *ls,*rs;
	LOCALOUTTYPE *res;
	ng_size_t stopi = 1;
	ng_size_t linc = 0;
	ng_size_t rinc = 0;
	ng_size_t i;

	ls = (LOCALTYPE*)lhs;
	rs = (LOCALTYPE*)rhs;
	res = (LOCALOUTTYPE*)result;

	if(nlhs > nrhs) 
		stopi = nlhs;
	else
		stopi = nrhs;
	if(nlhs > 1) {
		linc = 1;
	}
	if(nrhs > 1) {
		rinc = 1;
	}
	

	if((lhs_m == NULL)&&(rhs_m == NULL)) {
		for(i = 0; i < stopi; i++, res++, ls += linc, rs += rinc) {
			*res = (LOCALOUTTYPE)(*ls THEOP *rs);
		}
	} else if(rhs_m == NULL) {
		for(i = 0 ; i < stopi; i++, res++, ls += linc, rs += rinc) {
			*res = (LOCALOUTTYPE)(( lhs_m->DATATYPEval == *ls) ? ( LEFTMISSING ) : (*ls THEOP *rs));
		}
	} else if(lhs_m == NULL ) {
		for(i = 0; i < stopi; i++, res++, ls += linc, rs += rinc) {
			*res = (LOCALOUTTYPE)(( rhs_m->DATATYPEval == *rs) ? ( RIGHTMISSING ) : (*ls THEOP *rs));
		}
	} else {
		for(i = 0; i < stopi; i++, res++, ls += linc, rs += rinc) {
			*res = (LOCALOUTTYPE)((( lhs_m->DATATYPEval == *ls)|| ( rhs_m->DATATYPEval == *rs)) ? ( LEFTMISSING ) : (*ls THEOP *rs));
		}
	}
	return(NhlNOERROR);
}

NclTypeClass Ncl_Type_DATATYPE_FUNCNAME_type
#if	NhlNeedProto
(void)
#else
()
#endif
{
	return((NclTypeClass)nclTypeOUTDATATYPEClass);
}

/*
 *      $Id: TypeSupportOpTemplate.c.sed,v 1.1 1995-01-28 01:53:13 ethan Exp $
 */
/************************************************************************
*									*
*			     Copyright (C)  1995			*
*	     University Corporation for Atmospheric Research		*
*			     All Rights Reserved			*
*									*
************************************************************************/
/*
 *	File:		
 *
 *	Author:		Ethan Alpert
 *			National Center for Atmospheric Research
 *			PO 3000, Boulder, Colorado
 *
 *	Date:		Fri Jan 27 18:30:15 MST 1995
 *
 *	Description:	
 */





NhlErrorTypes _NclTFUNC
#if	NhlNeedProto
(NclTypeClass the_type, void * result, void* lhs, void* rhs, NclScalar* lhs_m, NclScalar* rhs_m, ng_size_t nlhs, ng_size_t nrhs)
#else
(the_type, result, lhs, rhs, lhs_m, rhs_m, nlhs, nrhs)
NclTypeClass the_type;
void * result;
void* lhs;
void* rhs;
NclScalar* lhs_m;
NclScalar* rhs_m;
ng_size_t nlhs;
ng_size_t nrhs;
#endif
{
	NclTypeClass tmp;

	if(the_type->type_class.TFUNC!= NULL) {
		return((*(the_type->type_class.TFUNC))(result, lhs, rhs, lhs_m, rhs_m, nlhs, nrhs));
	} else {
		tmp = (NclTypeClass)the_type->obj_class.super_class;
		while(tmp != (NclTypeClass)nclTypeClass) {
			if(tmp->type_class.TFUNC != NULL) {
				return((*(tmp->type_class.TFUNC))(result, lhs, rhs, lhs_m, rhs_m, nlhs, nrhs));
			} else {
				tmp = (NclTypeClass)tmp->obj_class.super_class;
			}
		}
		return(NhlFATAL);
	}
}


NclTypeClass _NclTFUNC_type
#if	NhlNeedProto
(NclTypeClass the_type)
#else
(the_type)
NclTypeClass the_type;
#endif
{
	NclTypeClass tmp;

	if(the_type->type_class.TFUNC_type!= NULL) {
		return((*(the_type->type_class.TFUNC_type))());
	} else {
		tmp = (NclTypeClass)the_type->obj_class.super_class;
		while(tmp != (NclTypeClass)nclTypeClass) {
			if(tmp->type_class.TFUNC_type != NULL) {
				return((*(tmp->type_class.TFUNC_type))());
			} else {
				tmp = (NclTypeClass)tmp->obj_class.super_class;
			}
		}
		return(NULL);
	}
}

C
C	$Id: cfaamn.f.sed,v 1.4 2008-07-27 12:23:41 haley Exp $
C                                                                      
C			     Copyright (C)  1997
C	     University Corporation for Atmospheric Research
C			     All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      PROGRAM CFAAMN
C
C  This program converts the tabular form of a fontcap, as described
C  in "NCAR Graphics Installer's GUIDE," or a fontcap describing an
C  NCAR filled font into a compact binary representation that is read 
C  directly by ctrans or PLOTCHAR.  
C
C  This program was created by merging two independent processors
C  (one for the stroked fonts and the other for the filled fonts).
C  The forms of the fontcaps are quite different in the case of 
C  stroked or filled fonts and the logic in this code that handles 
C  the two cases is different.  Subroutines in this code that are
C  common to the processing of both forms of the fontcap begin with
C  the letters "CF"; subroutines that apply to the processing of
C  the stroked fonts begin with "SF"; subroutines that apply to the
C  processing of the filled fonts begin with "FF".
C
C  Exclusive of the character stroke tables, all fontcap entries
C  are written to the output file as integers.  The character
C  stroke tables are packed into integer words in accordance 
C  with the COORD field descriptors.  Each line of a stroke
C  table entry for each character is packed into one integer.
C
C  Upon abnormal termination, a status number will be printed.  The 
C  meaning of these numbers is:
C
C       STATUS  --  Integer-valued error status:
C                              =  0 -- No errors
C                              =  1 -- EOF encountered.
C                              =  2 -- Error decoding an integer value.
C                              =  3 -- Integer exceeds max. number of
C                                      digits allowed.
C                              =  8 -- Error decoding floating-point value.
C                              =  9 -- Floating value exceeds maximum
C                                      number of digits allowed.
C                              = 10 -- Not an integer field.
C                              = 11 -- String buffer not big enough
C                                      to hold the input string.
C                              = 12 -- Non-ASCII value encountered.
C                              = 13 -- The keyword FONT_TYPE has not
C                                      been defined.
C
C  This code contains common blocks CAPFNT, FNTTB1, FNTTB2,
C  FNTERR, FNTIOB, FNTIO2.  The contents of these common
C  blocks are described below.
C
C
C  CAPFNT
C  ------
C
C  The binary output file for stroked fonts is stored in common CAPFNT.  
C  (The binary output for the filled fonts is stored in BUFFER, see
C  the comments in fntcom.h for details on that encoding.)
C  There are two important arrays in common CAPFNT:  CPNTRS dimensioned
C  for CHRSM1 (set in a data statement), and  CSTRKS dimensioned
C  for CHRSM2 (set in a data statement.)  
C
C  The binary output file contains:
C
C   Word #   Variable  Description
C   ------   --------  -----------
C
C        1   CHSTRT    CHARACTER_START
C        2   CHSEND    CHARACTER_END
C        3   CHRWDT    CHARACTER_WIDTH
C   4-  14   CHRSCH    Scratch array for possible future expansion of
C                      the CHARACTER class.
C       15   FNTRHT    FONT_RIGHT
C       16   FNTTOP    FONT_TOP
C       17   FNTCAP    FONT_CAP
C       18   FNTHLF    FONT_HALF
C       19   FNTBAS    FONT_BASE
C       20   FNTBOT    FONT_BOTTOM
C       21   FNTTYP    FONT_TYPE
C  22-  30   FNTSCH    Scratch array for possible future expansion of
C                      the FONT class.
C       31   CORXST    COORD_X_START
C       32   CORXLN    COORD_X_LEN
C       33   CORYST    COORD_Y_START
C       34   CORYLN    COORD_Y_LEN
C       35   CORPST    COORD_PEN_START
C       36   CORPLN    COORD_PEN_LEN
C       37   PBEGST    PAINT_BEGIN_START
C       38   PBEGLN    PAINT_BEGIN_LEN
C       39   PENDST    PAINT_END_START
C       40   PENDLN    PAINT_END_LEN
C  41-  50   CORSCH    Scratch array for possible future expansion of
C                      the COORDINATE or PAINT classes.
C  51- 350   NEWCLS    Scratch array for the possible future addition
C                      of new classes.
C 351- 478   CPNTRS    One integer for each defined character
C                      which points into the stroke sequence
C                      in array CSTRKS, defined below, indicating where
C                      the stroke sequence for the defined
C                      character begins.  CPNTRS is dimensioned
C                      for CHRSM1.
C      479   CPNLST    Pointer to the final stroke of the final character.
C 480-5600   CSTRKS    Packed stroke sequences for the characters;
C                      each integer contains one line packed from 
C                      the stroke tables in the fontcap table.
C                      CSTRKS is dimensioned for CHRSM2.
C
C
C  FNTTB1
C  ------
C 
C        PART1  -- Parser Table 1 is a CHARACTER*1 array
C                  which contains all character sequences
C                  pertinent to parsing the fontcap form.
C                  First to appear in PART1 is a list of
C                  all the major classes (CHARACTER, COORD,
C                  PAINT, CHAR, FONT), and then comes a list
C                  of the keywords pertinent to each class.
C                  PART1 is completely specified in the BLOCKDATA.
C        KEYSEP -- Is a CHARACTER*1 variable containing
C                  the keyword separator.
C        KEYTER -- Is a CHARACTER*1 variable containing the
C                  keyword terminator.
C        FRMCOM -- Is a CHARACTER*1 array of dimension 2
C                  containing the two initial characters
C                  which will cause a line in the fontcap
C                  form to be regarded as a comment line.
C
C  FNTTB2
C  ------
C
C         PART2 -- The fontcap entries are processed in
C                  the order: CHARACTER, COORD, PAINT, CHAR,
C                  FONT.  The elements of PART2 point to
C                  the virtual words in PART1 containing
C                  the keywords for the individual classes.
C                  For example, PART2(2) points to word 10
C                  which is X_START, the first keyword 
C                  appropriate to the COORD class.  PART2(4)
C                  is 0 since there are no keywords appropriate
C                  to the class CHAR.
C         PART3 -- Contains pointers into the table descriptors
C                  defined in PART4 and PART5.
C         PART4 -- Contains pointers into PART1 indicating
C                  at which character the keywords pertinent
C                  to a given class begin.
C         PART5 -- An array of pointers into PART1.  For each
C                  table, there are two entries in PART5,
C                  the first specifying how many keywords
C                  there are in a given class, and the second
C                  specifying how many characters long each
C                  keyword in that class is.
C         PTHBTS - Number of bits to hold internal flags to
C                  indicate what keywords are being processed.
C
C
C  FNTERR
C  ------
C         
C         ALLOK  --  Error number 0 to indicate everything is OK.
C         EOFFL  --  Set to 1, indicates EOF encountered.
C         INTERR --  Error number 2 indicating an error in trying
C                    to convert an integer fontcap entry to character.
C         MAXINT --  Error number 3 indicating the maximum number
C                    of characters per line has been exceeded.
C
C
C  FNTIOB
C  ------
C
C         UNIT   --  FORTRAN logical unit used for the input 
C                    fontacp file.
C         IPTR   --  Pointer to the column number of the current
C                    character being processed.
C         LSIZE  --  Size (in characters) of the current input line.
C                    
C
C  FNTIO2
C  ------
C
C         LINE  --  Current line being processed.
C
C  Other internal variables of interest:
C
C         PD011 -- Number of keywords in the highest class.
C         PD012 -- Number of characters per keyword in highest class.
C         PD021 -- Number of keywords in the CHARACTER class.
C         PD022 -- Number of characters per keyword in the CHARACTER class.
C         PD031 -- Number of keywords in the COORD class.
C         PD032 -- Number of characters per keyword in the COORD class.
C         PD041 -- Number of keywords in the PAINT class.
C         PD042 -- Number of characters per keyword in the PAINT class.
C         PD051 -- Number of keywords in the FONT class.
C         PD052 -- Number of characters per keyword in the FONT class.
C
      include 'fnttab.h'
      include 'fnterr.h'
      include 'fntcom.h'
C
      INTEGER  IOS, STATUS, II
      CHARACTER*80  DFLNAM
      CHARACTER*80 ARG1, ARG2, ARG3
C
C Do calls forcing BLOCKDATAs to be loaded from a binary library.
C
      CALL FFTBKD
      CALL SFTBKD
C
C  Set the status field to ALLOK and inititalize the array to 
C  receive the name of the character fontcap file.
C
      STATUS = ALLOK
      DO 10 II = 1,80
  10  DFLNAM(II:II) = ' '
C
C  Check if the verbose mode flag is there.
C
#ifdef  hpux
      CALL IGETARG(3, ARG3, 80)
#else
      CALL GETARG(3, ARG3)
#endif
      VERBOS = 0
      IF (ARG3(1:2) .EQ. '-v') VERBOS =1
C
C
C  Get file name of the input fontcap file, and OPEN the file.
C
#ifdef  hpux
      CALL IGETARG(1, ARG1, 80)
#else
      CALL GETARG(1, ARG1)
#endif
C
      DO 15 II = 1,80
        DFLNAM(II:II) = ARG1(II:II)
   15 CONTINUE
C
      UNIT = 1
      CALL CHROPN(UNIT,DFLNAM,IOS,STATUS)
      IF (STATUS .NE. ALLOK ) THEN
C
C       Error opening the file.
C
        WRITE(6,40)IOS
 40     FORMAT(' ERROR OPENING THE CHARACTER FONTCAP FILE, IOS='
     1          ,I7)
        STOP
      END IF
C
C  Parse the character fontcap file.
C
      CALL SFPRCF(ITYP,IOS,STATUS)
      IF (STATUS.NE.ALLOK .AND. STATUS.NE.EOFFL) THEN
C
C       Error reading the file.
C
        WRITE(6,50)STATUS,IOS
 50     FORMAT(' ERROR READING THE CHARACTER FONTCAP FILE',
     1          ', STATUS=',I7,' IOS=',I7)
        CALL CHRCLS(UNIT,IOS,STATUS)
        STOP
      END IF
C
C  Close the fontcap file.
C
      CALL CHRCLS(UNIT,IOS,STATUS)
C
C  Open the fontcap binary file for writing.
C
      DO 60 II = 1,80
 60   DFLNAM(II:II) = ' '
C
#ifdef  hpux
      CALL IGETARG(2, ARG2, 80)
#else
      CALL GETARG(2, ARG2)
#endif
      DO 65 II = 1,80
        DFLNAM(II:II) = ARG2(II:II)
   65 CONTINUE
C
      UNIT = 1
      CALL BINOPN(UNIT,DFLNAM,IOS,STATUS)
      IF (STATUS.NE.0) GO TO 1000
C
      CALL CFWRIT(UNIT,ITYP,IOS,STATUS)
      IF (STATUS .NE. 0) THEN
C
C  Error writing the file.
C
        WRITE(6,80)STATUS,IOS
 80     FORMAT(' ERROR WRITING THE BINARY FONTCAP FILE',
     +       ', STATUS=',I7,' IOS=',I7)
        CALL BINCLS(UNIT,IOS,STATUS)
        STOP
      END IF
C
C  Close the binary fontcap file.
C
      CALL BINCLS(UNIT,IOS,STATUS)
C
      STOP
 1000 CONTINUE
      WRITE(6,1010)
 1010 FORMAT(' CANNOT OPEN THE BINARY FILE')
      END

# Contributor Code of Conduct

## Related Code of Conduct 

Participant Code of Conduct
[https://www2.fin.ucar.edu/ethics/participant-code-conduct](https://www2.fin.ucar.edu/ethics/participant-code-conduct)

## Our Pledge

We, as contributors and maintainers (participants), of the NCAR Command Language (NCL) pledge to make participation in our software project and community a safe, productive, welcoming and inclusive experience for everyone. All participants are required to abide by this Code of Conduct. This includes respectful treatment of everyone regardless of age, body size, disability, ethnicity, gender identity or expression, level of experience, nationality, political affiliation, veteran status, pregnancy, genetic information, physical appearance, race, religion, or sexual orientation, as well as any other characteristic protected under applicable US federal or state law.

## Our Standards

Examples of behaviors that contribute to a positive environment include:

* Using welcoming and inclusive language
* Respectful when offering and gracefully accepting constructive criticism
* Acknowledging the contributions of others
* Focusing on what is best for the community
* Showing empathy towards other community members
* Treating everyone with respect and consideration, valuing a diversity of views and opinions
* Communicating openly with respect for others, critiquing ideas rather than individuals

Examples of unacceptable behavior include, but are not limited to:

* Harassment, intimidation, or discrimination in any form
* Personal attacks directed toward other participants
* Unwelcome sexual attention or advances
* Inappropriate, negative, derogatory comments and/or attacks on personal beliefs
* Publishing others' private information, such as a physical or electronic address, without explicit permission
* Refusing to use the pronouns that someone requests
* Alarming, intimidating, threatening, or hostile comments or conduct
* Physical or verbal abuse by anyone to anyone, including but not limited to a participant, member of the public, guest, member of any institution or sponsor
* Comments related to characteristics given in the pledge at the top
* Inappropriate use of nudity and/or sexual images
* Threatening or stalking other participants
* Other conduct which could reasonably be considered inappropriate in a professional setting

## Scope

This Code of Conduct applies to all spaces managed by the Project whether it be online or face-to-face. This includes project code, code repository, associated web pages, documentation, mailing lists, project websites and wiki pages, issue tracker, meetings, telecons, events, project social media accounts, and any other forums created by the project team which the community uses for communication. In addition, violations of this Code of Conduct outside these spaces may affect a person's ability to participate within them. Representation of a project may be further defined and clarified by project maintainers.

## Community Responsibilities

Everyone in the community is empowered to respond to people who are showing unacceptable behavior. They can talk to them privately or publicly. Anyone requested to stop unacceptable behavior is expected to comply immediately. If the behavior continues concerns may be brought to the project administrators or to any other party listed in the Reporting section below.

## Project Administrator Responsibilities

Project Administrators are responsible for clarifying the standards of acceptable behavior and are encouraged to model appropriate behavior and provide support when people in the community point out inappropriate behavior. Project administrator(s) are normally the ones that would be tasked to carry out the actions in the Consequences section below.

Project Administrators are also expected to keep this Code of Conduct updated with the main one housed at UCAR as listed below in the Attribution section.

## Reporting

Instances of unacceptable behavior can be brought to the attention of the project administrator(s) who may take any action as outlined in the Consequences section below. However, making a report to a project administrator is not considered an 'official report' to UCAR.

Instances of unacceptable behavior may also be reported directly to UCAR via UCAR's Harassment Reporting and Complaint Procedure at [https://www2.fin.ucar.edu/procedures/hr/harassment-reporting-and-complaint-procedure](https://www2.fin.ucar.edu/procedures/hr/harassment-reporting-and-complaint-procedure), or anonymously through UCAR's EthicsPoint Hotline at [https://www2.fin.ucar.edu/ethics/anonymous-reporting](https://www2.fin.ucar.edu/ethics/anonymous-reporting).

Complaints received by UCAR will be handled pursuant to the procedures outlined in UCAR's Harassment Reporting and Complaint Procedure. Complaints to UCAR will be held as confidential as practicable under the circumstances, and retaliation against a person who initiates a complaint or an inquiry about inappropriate behavior will not be tolerated.

Any Contributor can use these reporting methods even if they are not directly affiliated with UCAR. The Frequently Asked Questions (FAQ) page for reporting is here: [https://www2.fin.ucar.edu/procedures/hr/reporting-faqs](https://www2.fin.ucar.edu/procedures/hr/reporting-faqs).

## Consequences

Upon receipt of a complaint, the project administrator(s) may take any action deemed necessary and appropriate under the circumstances. Such action can include things such as: removing, editing, or rejecting comments, commits, code, wiki edits, email, issues, and other contributions that are not aligned to this Code of Conduct, or banning temporarily or permanently any contributor for other behaviors that are deemed inappropriate, threatening, offensive, or harmful. Project Administrators also have the right to report violations to UCAR HR and/or UCAR's Office of Diversity, Equity and Inclusion (ODEI) as well as a participant's home institution and/or law enforcement. In the event an incident is reported to UCAR, UCAR will follow its Harassment Reporting and Complaint Procedure.

## Process for Changes

All UCAR managed projects are required to adopt this Contributor Code of Conduct. Adoption is assumed even if not expressly stated in the repository. Projects should fill in sections where prompted with project-specific information, including, project name, email addresses, adoption date, etc. There is one section below marked "optional" that may not apply to a given project.

Projects that adopt this Code of Conduct need to stay up to date with UCAR's Contributor Code of Conduct, linked with a DOI in the "Attribution" section below. Projects can make limited substantive changes to the Code of Conduct, however, the changes must be limited in scope and may not contradict the UCAR Contributor Code of Conduct.

## Attribution

This Code of Conduct was originally adapted from the Contributor Covenant, version 1.4, available at [Contributor-Covenant](http://contributor-covenant.org/version/1/4). We then aligned it with the UCAR Participant Code of Conduct, which also borrows from the American Geophysical Union (AGU) Code of Conduct. The UCAR Participant Code of Conduct applies to both UCAR employees as well as participants in activities run by UCAR. We modified the "scope" section with the django project description, and we added "Publication Ethics" from the NGEET/FATES project. The original version of this for all software projects that have strong management from UCAR or UCAR staff is available on the UCAR website at [*Enter DOI link name*] (the date that it was adopted by this project was [*Enter date adopted*]). When responding to complaints UCAR HR and ODEI will do so based on the latest published version. Therefore, any project-specific changes should follow the Process for Changes section above.

## Publication Ethics (optional)

We aim to create an open development environment where developers can be confident that all members of the community are publishing any research on the project in an ethical manner. In particular, writing code is a form of intellectual contribution, and one should expect that all such intellectual contributions are respected and given credit in any resulting published work. To support the community and avoid issues of misconduct related to the above principle, please respect the following rules:

* Document the version of the code used in any publication, preferably by either using a release tag (existing or newly created) if possible, or a commit hash if not.

* Do not use code from anywhere other than the central project's development repository main development branch without discussing with the author(s) of the modified code your intentions for using the code and receiving their permission to do so.

* When using project features that have recently been integrated into the central Project development repository, be mindful of the contributions of others and, where the novel features qualitatively affect the results, involve the author(s) of these features in any resulting manuscripts. Be particularly aware of the concerns of early career researchers, and ensure they have sufficient time to lead publications using their developments.

* When discussing results arising from older project features that have been described in the literature or releases, accurately cite the publications describing those features or releases.

# Contributing to NCL

Thank you for your interest in NCL. We welcome contributions from everyone. There are many ways to contribute, such as, but not limited to:

- New features
- Bug reports, bug fixes
- Corrections/clarifications to documentation
- NCL scripts (utilities, computational routines, etc.)
- Examples (techniques, novel graphics, etc.)
- Suggestions for new features
- Commentary on the Roadmap

## How to Contribute

- Contributions to the NCL source code (new features, bug fixes, etc.) should be submitted as [pull-requests](https://help.github.com/articles/about-pull-requests/). We broadly follow the [GitFlow](https://datasift.github.io/gitflow/IntroducingGitFlow.html) work flow.
- Bug reports should be filed as an [issue](https://github.com/NCAR/ncl/issues) on GitHub.
- Examples, scripts, documentation fixes may be submitted via the **ncl-talk@ucar.edu** email group. ([Registration](http://mailman.ucar.edu/mailman/listinfo/ncl-talk) is required).
- Suggestions, commentary may be submitted ( to-be-filled-in)

## Code of Conduct

In contributing to NCL, you agree to follow our [Code of Conduct](CODE_OF_CONDUCT.md).

## License

[NCL's license](LICENSE) is based on the <a href="http://www.apache.org/licenses/LICENSE-2.0">Apache License, Version 2.0</a>.

## Additional Resources

- The [NCL website](http://ncl.ucar.edu/) is a source for comprehensive documentation and extensive examples.
- [Installing](http://ncl.ucar.edu/Download/) NCL from prebuilt binaries or via conda.
